#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9997
#define LARGE_STATE_COUNT 4455
#define SYMBOL_COUNT 498
#define ALIAS_COUNT 2
#define TOKEN_COUNT 216
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 26
#define MAX_ALIAS_SEQUENCE_LENGTH 15
#define PRODUCTION_ID_COUNT 226

enum ts_symbol_identifiers {
  sym__identifier_token = 1,
  anon_sym_extern = 2,
  anon_sym_alias = 3,
  anon_sym_SEMI = 4,
  anon_sym_global = 5,
  anon_sym_using = 6,
  anon_sym_unsafe = 7,
  anon_sym_EQ = 8,
  anon_sym_static = 9,
  anon_sym_LBRACK = 10,
  anon_sym_assembly = 11,
  anon_sym_module = 12,
  anon_sym_COLON = 13,
  anon_sym_COMMA = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LPAREN = 16,
  anon_sym_RPAREN = 17,
  anon_sym_field = 18,
  anon_sym_event = 19,
  anon_sym_method = 20,
  anon_sym_param = 21,
  anon_sym_property = 22,
  anon_sym_return = 23,
  anon_sym_type = 24,
  anon_sym_namespace = 25,
  anon_sym_class = 26,
  anon_sym_ref = 27,
  anon_sym_struct = 28,
  anon_sym_enum = 29,
  anon_sym_LBRACE = 30,
  anon_sym_RBRACE = 31,
  anon_sym_interface = 32,
  anon_sym_delegate = 33,
  anon_sym_record = 34,
  anon_sym_abstract = 35,
  anon_sym_async = 36,
  anon_sym_const = 37,
  anon_sym_file = 38,
  anon_sym_fixed = 39,
  anon_sym_internal = 40,
  anon_sym_new = 41,
  anon_sym_override = 42,
  anon_sym_partial = 43,
  anon_sym_private = 44,
  anon_sym_protected = 45,
  anon_sym_public = 46,
  anon_sym_readonly = 47,
  anon_sym_required = 48,
  anon_sym_sealed = 49,
  anon_sym_virtual = 50,
  anon_sym_volatile = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_in = 54,
  anon_sym_out = 55,
  anon_sym_where = 56,
  anon_sym_QMARK = 57,
  anon_sym_notnull = 58,
  anon_sym_unmanaged = 59,
  anon_sym_operator = 60,
  anon_sym_checked = 61,
  anon_sym_BANG = 62,
  anon_sym_TILDE = 63,
  anon_sym_PLUS_PLUS = 64,
  anon_sym_DASH_DASH = 65,
  anon_sym_true = 66,
  anon_sym_false = 67,
  anon_sym_PLUS = 68,
  anon_sym_DASH = 69,
  anon_sym_STAR = 70,
  anon_sym_SLASH = 71,
  anon_sym_PERCENT = 72,
  anon_sym_CARET = 73,
  anon_sym_PIPE = 74,
  anon_sym_AMP = 75,
  anon_sym_LT_LT = 76,
  anon_sym_GT_GT = 77,
  anon_sym_GT_GT_GT = 78,
  anon_sym_EQ_EQ = 79,
  anon_sym_BANG_EQ = 80,
  anon_sym_GT_EQ = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_implicit = 83,
  anon_sym_explicit = 84,
  anon_sym_get = 85,
  anon_sym_set = 86,
  anon_sym_add = 87,
  anon_sym_remove = 88,
  anon_sym_init = 89,
  anon_sym_this = 90,
  anon_sym_DOT = 91,
  anon_sym_scoped = 92,
  anon_sym_params = 93,
  anon_sym_base = 94,
  anon_sym_EQ_GT = 95,
  anon_sym_COLON_COLON = 96,
  anon_sym_var = 97,
  anon_sym_managed = 98,
  anon_sym_Cdecl = 99,
  anon_sym_Stdcall = 100,
  anon_sym_Thiscall = 101,
  anon_sym_Fastcall = 102,
  sym_predefined_type = 103,
  anon_sym_break = 104,
  anon_sym_unchecked = 105,
  anon_sym_continue = 106,
  anon_sym_do = 107,
  anon_sym_while = 108,
  anon_sym_for = 109,
  anon_sym_lock = 110,
  anon_sym_yield = 111,
  anon_sym_switch = 112,
  anon_sym_case = 113,
  anon_sym_default = 114,
  anon_sym_throw = 115,
  anon_sym_try = 116,
  anon_sym_catch = 117,
  anon_sym_when = 118,
  anon_sym_finally = 119,
  anon_sym_await = 120,
  anon_sym_foreach = 121,
  anon_sym_goto = 122,
  anon_sym_if = 123,
  anon_sym_else = 124,
  sym_discard = 125,
  anon_sym_DOT_DOT = 126,
  anon_sym_not = 127,
  anon_sym_and = 128,
  anon_sym_or = 129,
  anon_sym_PLUS_EQ = 130,
  anon_sym_DASH_EQ = 131,
  anon_sym_STAR_EQ = 132,
  anon_sym_SLASH_EQ = 133,
  anon_sym_PERCENT_EQ = 134,
  anon_sym_AMP_EQ = 135,
  anon_sym_CARET_EQ = 136,
  anon_sym_PIPE_EQ = 137,
  anon_sym_LT_LT_EQ = 138,
  anon_sym_GT_GT_EQ = 139,
  anon_sym_GT_GT_GT_EQ = 140,
  anon_sym_QMARK_QMARK_EQ = 141,
  anon_sym_AMP_AMP = 142,
  anon_sym_PIPE_PIPE = 143,
  anon_sym_QMARK_QMARK = 144,
  anon_sym_from = 145,
  anon_sym_into = 146,
  anon_sym_join = 147,
  anon_sym_on = 148,
  anon_sym_equals = 149,
  anon_sym_let = 150,
  anon_sym_orderby = 151,
  anon_sym_ascending = 152,
  anon_sym_descending = 153,
  anon_sym_group = 154,
  anon_sym_by = 155,
  anon_sym_select = 156,
  anon_sym_as = 157,
  anon_sym_is = 158,
  anon_sym_DQUOTE = 159,
  aux_sym_interpolation_format_clause_token1 = 160,
  anon_sym_DASH_GT = 161,
  anon_sym_stackalloc = 162,
  anon_sym_with = 163,
  anon_sym_sizeof = 164,
  anon_sym_typeof = 165,
  anon_sym___makeref = 166,
  anon_sym___reftype = 167,
  anon_sym___refvalue = 168,
  sym_null_literal = 169,
  anon_sym_SQUOTE = 170,
  sym_character_literal_content = 171,
  sym_integer_literal = 172,
  sym_real_literal = 173,
  aux_sym_string_literal_content_token1 = 174,
  aux_sym_string_literal_content_token2 = 175,
  sym_escape_sequence = 176,
  sym_string_literal_encoding = 177,
  sym_verbatim_string_literal = 178,
  aux_sym_raw_string_literal_token1 = 179,
  aux_sym_preproc_if_token1 = 180,
  aux_sym_preproc_if_token2 = 181,
  aux_sym_preproc_if_token3 = 182,
  aux_sym_preproc_else_token1 = 183,
  aux_sym_preproc_elif_token1 = 184,
  sym_preproc_arg = 185,
  aux_sym_preproc_region_token1 = 186,
  aux_sym_preproc_endregion_token1 = 187,
  aux_sym_preproc_line_token1 = 188,
  anon_sym_hidden = 189,
  aux_sym_preproc_pragma_token1 = 190,
  anon_sym_warning = 191,
  anon_sym_disable = 192,
  anon_sym_restore = 193,
  anon_sym_checksum = 194,
  aux_sym_preproc_nullable_token1 = 195,
  anon_sym_enable = 196,
  anon_sym_annotations = 197,
  anon_sym_warnings = 198,
  aux_sym_preproc_error_token1 = 199,
  aux_sym_preproc_define_token1 = 200,
  aux_sym_preproc_undef_token1 = 201,
  sym_shebang_directive = 202,
  sym_comment = 203,
  sym__optional_semi = 204,
  sym_interpolation_regular_start = 205,
  sym_interpolation_verbatim_start = 206,
  sym_interpolation_raw_start = 207,
  sym_interpolation_start_quote = 208,
  sym_interpolation_end_quote = 209,
  sym_interpolation_open_brace = 210,
  sym_interpolation_close_brace = 211,
  sym_interpolation_string_content = 212,
  sym_raw_string_start = 213,
  sym_raw_string_end = 214,
  sym_raw_string_content = 215,
  sym_compilation_unit = 216,
  sym__top_level_item = 217,
  sym_global_statement = 218,
  sym_extern_alias_directive = 219,
  sym_using_directive = 220,
  sym_global_attribute = 221,
  sym_attribute = 222,
  sym_attribute_argument_list = 223,
  sym_attribute_argument = 224,
  sym_attribute_list = 225,
  sym_attribute_target_specifier = 226,
  sym_namespace_declaration = 227,
  sym_file_scoped_namespace_declaration = 228,
  sym_type_declaration = 229,
  sym_class_declaration = 230,
  sym_struct_declaration = 231,
  sym_enum_declaration = 232,
  sym_enum_member_declaration_list = 233,
  sym_enum_member_declaration = 234,
  sym_interface_declaration = 235,
  sym_delegate_declaration = 236,
  sym_record_declaration = 237,
  sym_record_base = 238,
  sym_primary_constructor_base_type = 239,
  sym_modifier = 240,
  sym_type_parameter_list = 241,
  sym_type_parameter = 242,
  sym_base_list = 243,
  sym_type_parameter_constraints_clause = 244,
  sym_type_parameter_constraint = 245,
  sym_constructor_constraint = 246,
  sym_operator_declaration = 247,
  sym_conversion_operator_declaration = 248,
  sym_declaration_list = 249,
  sym_declaration = 250,
  sym_field_declaration = 251,
  sym_constructor_declaration = 252,
  sym_destructor_declaration = 253,
  sym_method_declaration = 254,
  sym_event_declaration = 255,
  sym_event_field_declaration = 256,
  sym_accessor_list = 257,
  sym_accessor_declaration = 258,
  sym_indexer_declaration = 259,
  sym_bracketed_parameter_list = 260,
  sym_property_declaration = 261,
  sym_explicit_interface_specifier = 262,
  sym_parameter_list = 263,
  sym_parameter = 264,
  sym__parameter_array = 265,
  sym_constructor_initializer = 266,
  sym_argument_list = 267,
  sym_tuple_pattern = 268,
  sym_argument = 269,
  sym_block = 270,
  sym_arrow_expression_clause = 271,
  sym__function_body = 272,
  sym_variable_declaration = 273,
  sym_using_variable_declaration = 274,
  sym_variable_declarator = 275,
  sym_using_variable_declarator = 276,
  sym_bracketed_argument_list = 277,
  sym__name = 278,
  sym_alias_qualified_name = 279,
  sym__simple_name = 280,
  sym_qualified_name = 281,
  sym_generic_name = 282,
  sym_type_argument_list = 283,
  sym_type = 284,
  sym_implicit_type = 285,
  sym_array_type = 286,
  sym__array_base_type = 287,
  sym_array_rank_specifier = 288,
  sym_nullable_type = 289,
  sym_pointer_type = 290,
  sym__pointer_base_type = 291,
  sym_function_pointer_type = 292,
  sym_calling_convention = 293,
  sym_function_pointer_parameter = 294,
  sym_ref_type = 295,
  sym__ref_base_type = 296,
  sym_scoped_type = 297,
  sym__scoped_base_type = 298,
  sym_tuple_type = 299,
  sym_tuple_element = 300,
  sym_statement = 301,
  sym_break_statement = 302,
  sym_checked_statement = 303,
  sym_continue_statement = 304,
  sym_do_statement = 305,
  sym_empty_statement = 306,
  sym_expression_statement = 307,
  sym_fixed_statement = 308,
  sym_for_statement = 309,
  sym_return_statement = 310,
  sym_lock_statement = 311,
  sym_yield_statement = 312,
  sym_switch_statement = 313,
  sym_switch_body = 314,
  sym_switch_section = 315,
  sym_throw_statement = 316,
  sym_try_statement = 317,
  sym_catch_clause = 318,
  sym_catch_declaration = 319,
  sym_catch_filter_clause = 320,
  sym_finally_clause = 321,
  sym_unsafe_statement = 322,
  sym_using_statement = 323,
  sym_foreach_statement = 324,
  sym_goto_statement = 325,
  sym_labeled_statement = 326,
  sym_if_statement = 327,
  sym_while_statement = 328,
  sym_local_declaration_statement = 329,
  sym_local_function_statement = 330,
  sym_pattern = 331,
  sym_constant_pattern = 332,
  sym_parenthesized_pattern = 333,
  sym_var_pattern = 334,
  sym_type_pattern = 335,
  sym_list_pattern = 336,
  sym_recursive_pattern = 337,
  sym_positional_pattern_clause = 338,
  sym_property_pattern_clause = 339,
  sym_subpattern = 340,
  sym_relational_pattern = 341,
  sym_negated_pattern = 342,
  sym_and_pattern = 343,
  sym_or_pattern = 344,
  sym_declaration_pattern = 345,
  sym__variable_designation = 346,
  sym_parenthesized_variable_designation = 347,
  sym_expression = 348,
  sym_non_lvalue_expression = 349,
  sym_lvalue_expression = 350,
  sym__expression_statement_expression = 351,
  sym_assignment_expression = 352,
  sym_binary_expression = 353,
  sym_postfix_unary_expression = 354,
  sym_prefix_unary_expression = 355,
  sym__pointer_indirection_expression = 356,
  sym_query_expression = 357,
  sym_from_clause = 358,
  sym__query_body = 359,
  sym__query_clause = 360,
  sym_join_clause = 361,
  sym__join_header = 362,
  sym__join_body = 363,
  sym_join_into_clause = 364,
  sym_let_clause = 365,
  sym_order_by_clause = 366,
  sym__ordering = 367,
  sym_where_clause = 368,
  sym__select_or_group_clause = 369,
  sym_group_clause = 370,
  sym_select_clause = 371,
  sym_conditional_expression = 372,
  sym_conditional_access_expression = 373,
  sym_as_expression = 374,
  sym_is_expression = 375,
  sym_is_pattern_expression = 376,
  sym_cast_expression = 377,
  sym_checked_expression = 378,
  sym_invocation_expression = 379,
  sym_switch_expression = 380,
  sym_switch_expression_arm = 381,
  sym_when_clause = 382,
  sym_await_expression = 383,
  sym_throw_expression = 384,
  sym_element_access_expression = 385,
  sym_interpolated_string_expression = 386,
  sym__interpolated_string_content = 387,
  sym__interpolated_verbatim_string_content = 388,
  sym__interpolated_raw_string_content = 389,
  sym_interpolation = 390,
  sym_interpolation_alignment_clause = 391,
  sym_interpolation_format_clause = 392,
  sym_member_access_expression = 393,
  sym_member_binding_expression = 394,
  sym_object_creation_expression = 395,
  sym_parenthesized_expression = 396,
  sym__parenthesized_lvalue_expression = 397,
  sym_lambda_expression = 398,
  sym__lambda_parameters = 399,
  sym_array_creation_expression = 400,
  sym_anonymous_method_expression = 401,
  sym_anonymous_object_creation_expression = 402,
  sym__anonymous_object_member_declarator = 403,
  sym_implicit_array_creation_expression = 404,
  sym_implicit_object_creation_expression = 405,
  sym_implicit_stackalloc_expression = 406,
  sym_initializer_expression = 407,
  sym_declaration_expression = 408,
  sym_default_expression = 409,
  sym_with_expression = 410,
  sym_with_initializer = 411,
  sym_sizeof_expression = 412,
  sym_typeof_expression = 413,
  sym_makeref_expression = 414,
  sym_ref_expression = 415,
  sym_reftype_expression = 416,
  sym_refvalue_expression = 417,
  sym_stackalloc_expression = 418,
  sym_range_expression = 419,
  sym_tuple_expression = 420,
  sym_literal = 421,
  sym_character_literal = 422,
  sym_string_literal = 423,
  sym_string_literal_content = 424,
  sym_raw_string_literal = 425,
  sym_boolean_literal = 426,
  sym_identifier = 427,
  sym__reserved_identifier = 428,
  sym_preproc_if = 429,
  sym_preproc_else = 430,
  sym_preproc_elif = 431,
  sym_preproc_if_in_top_level = 432,
  sym_preproc_else_in_top_level = 433,
  sym_preproc_elif_in_top_level = 434,
  sym_preproc_if_in_expression = 435,
  sym_preproc_else_in_expression = 436,
  sym_preproc_elif_in_expression = 437,
  sym_preproc_if_in_enum_member_declaration = 438,
  sym_preproc_else_in_enum_member_declaration = 439,
  sym_preproc_elif_in_enum_member_declaration = 440,
  sym__preproc_expression = 441,
  sym_preproc_parenthesized_expression = 442,
  sym_preproc_unary_expression = 443,
  sym_preproc_binary_expression = 444,
  sym_preproc_region = 445,
  sym_preproc_endregion = 446,
  sym_preproc_line = 447,
  sym_preproc_pragma = 448,
  sym_preproc_nullable = 449,
  sym_preproc_error = 450,
  sym_preproc_define = 451,
  sym_preproc_undef = 452,
  aux_sym_compilation_unit_repeat1 = 453,
  aux_sym_global_attribute_repeat1 = 454,
  aux_sym_attribute_argument_list_repeat1 = 455,
  aux_sym_class_declaration_repeat1 = 456,
  aux_sym_class_declaration_repeat2 = 457,
  aux_sym_class_declaration_repeat3 = 458,
  aux_sym_enum_member_declaration_list_repeat1 = 459,
  aux_sym_record_base_repeat1 = 460,
  aux_sym_type_parameter_list_repeat1 = 461,
  aux_sym_base_list_repeat1 = 462,
  aux_sym_type_parameter_constraints_clause_repeat1 = 463,
  aux_sym_declaration_list_repeat1 = 464,
  aux_sym_accessor_list_repeat1 = 465,
  aux_sym_bracketed_parameter_list_repeat1 = 466,
  aux_sym__parameter_type_with_modifiers_repeat1 = 467,
  aux_sym_argument_list_repeat1 = 468,
  aux_sym_tuple_pattern_repeat1 = 469,
  aux_sym_block_repeat1 = 470,
  aux_sym_variable_declaration_repeat1 = 471,
  aux_sym_using_variable_declaration_repeat1 = 472,
  aux_sym_type_argument_list_repeat1 = 473,
  aux_sym_type_argument_list_repeat2 = 474,
  aux_sym_array_rank_specifier_repeat1 = 475,
  aux_sym_function_pointer_type_repeat1 = 476,
  aux_sym_calling_convention_repeat1 = 477,
  aux_sym_tuple_type_repeat1 = 478,
  aux_sym_for_statement_repeat1 = 479,
  aux_sym_switch_body_repeat1 = 480,
  aux_sym_try_statement_repeat1 = 481,
  aux_sym_list_pattern_repeat1 = 482,
  aux_sym_positional_pattern_clause_repeat1 = 483,
  aux_sym_parenthesized_variable_designation_repeat1 = 484,
  aux_sym__query_body_repeat1 = 485,
  aux_sym__query_body_repeat2 = 486,
  aux_sym_order_by_clause_repeat1 = 487,
  aux_sym_switch_expression_repeat1 = 488,
  aux_sym_interpolated_string_expression_repeat1 = 489,
  aux_sym_interpolated_string_expression_repeat2 = 490,
  aux_sym_interpolated_string_expression_repeat3 = 491,
  aux_sym_lambda_expression_repeat1 = 492,
  aux_sym_anonymous_object_creation_expression_repeat1 = 493,
  aux_sym_with_expression_repeat1 = 494,
  aux_sym_string_literal_repeat1 = 495,
  aux_sym_preproc_if_in_top_level_repeat1 = 496,
  aux_sym_preproc_pragma_repeat1 = 497,
  alias_sym_element_binding_expression = 498,
  alias_sym_implicit_parameter = 499,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier_token] = "_identifier_token",
  [anon_sym_extern] = "extern",
  [anon_sym_alias] = "alias",
  [anon_sym_SEMI] = ";",
  [anon_sym_global] = "global",
  [anon_sym_using] = "using",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_EQ] = "=",
  [anon_sym_static] = "static",
  [anon_sym_LBRACK] = "[",
  [anon_sym_assembly] = "assembly",
  [anon_sym_module] = "module",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_field] = "field",
  [anon_sym_event] = "event",
  [anon_sym_method] = "method",
  [anon_sym_param] = "param",
  [anon_sym_property] = "property",
  [anon_sym_return] = "return",
  [anon_sym_type] = "type",
  [anon_sym_namespace] = "namespace",
  [anon_sym_class] = "class",
  [anon_sym_ref] = "ref",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_delegate] = "delegate",
  [anon_sym_record] = "record",
  [anon_sym_abstract] = "abstract",
  [anon_sym_async] = "async",
  [anon_sym_const] = "const",
  [anon_sym_file] = "file",
  [anon_sym_fixed] = "fixed",
  [anon_sym_internal] = "internal",
  [anon_sym_new] = "new",
  [anon_sym_override] = "override",
  [anon_sym_partial] = "partial",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_public] = "public",
  [anon_sym_readonly] = "readonly",
  [anon_sym_required] = "required",
  [anon_sym_sealed] = "sealed",
  [anon_sym_virtual] = "virtual",
  [anon_sym_volatile] = "volatile",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_where] = "where",
  [anon_sym_QMARK] = "\?",
  [anon_sym_notnull] = "notnull",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_operator] = "operator",
  [anon_sym_checked] = "checked",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_implicit] = "implicit",
  [anon_sym_explicit] = "explicit",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_add] = "add",
  [anon_sym_remove] = "remove",
  [anon_sym_init] = "init",
  [anon_sym_this] = "this",
  [anon_sym_DOT] = ".",
  [anon_sym_scoped] = "scoped",
  [anon_sym_params] = "params",
  [anon_sym_base] = "base",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_var] = "var",
  [anon_sym_managed] = "managed",
  [anon_sym_Cdecl] = "Cdecl",
  [anon_sym_Stdcall] = "Stdcall",
  [anon_sym_Thiscall] = "Thiscall",
  [anon_sym_Fastcall] = "Fastcall",
  [sym_predefined_type] = "predefined_type",
  [anon_sym_break] = "break",
  [anon_sym_unchecked] = "unchecked",
  [anon_sym_continue] = "continue",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_lock] = "lock",
  [anon_sym_yield] = "yield",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_when] = "when",
  [anon_sym_finally] = "finally",
  [anon_sym_await] = "await",
  [anon_sym_foreach] = "foreach",
  [anon_sym_goto] = "goto",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [sym_discard] = "discard",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_from] = "from",
  [anon_sym_into] = "into",
  [anon_sym_join] = "join",
  [anon_sym_on] = "on",
  [anon_sym_equals] = "equals",
  [anon_sym_let] = "let",
  [anon_sym_orderby] = "orderby",
  [anon_sym_ascending] = "ascending",
  [anon_sym_descending] = "descending",
  [anon_sym_group] = "group",
  [anon_sym_by] = "by",
  [anon_sym_select] = "select",
  [anon_sym_as] = "as",
  [anon_sym_is] = "is",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_interpolation_format_clause_token1] = "interpolation_format_clause_token1",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stackalloc] = "stackalloc",
  [anon_sym_with] = "with",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_typeof] = "typeof",
  [anon_sym___makeref] = "__makeref",
  [anon_sym___reftype] = "__reftype",
  [anon_sym___refvalue] = "__refvalue",
  [sym_null_literal] = "null_literal",
  [anon_sym_SQUOTE] = "'",
  [sym_character_literal_content] = "character_literal_content",
  [sym_integer_literal] = "integer_literal",
  [sym_real_literal] = "real_literal",
  [aux_sym_string_literal_content_token1] = "string_literal_content_token1",
  [aux_sym_string_literal_content_token2] = "string_literal_content_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_string_literal_encoding] = "string_literal_encoding",
  [sym_verbatim_string_literal] = "verbatim_string_literal",
  [aux_sym_raw_string_literal_token1] = "raw_string_literal_token1",
  [aux_sym_preproc_if_token1] = "#if",
  [aux_sym_preproc_if_token2] = "preproc_if_token2",
  [aux_sym_preproc_if_token3] = "#endif",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [sym_preproc_arg] = "preproc_arg",
  [aux_sym_preproc_region_token1] = "#region",
  [aux_sym_preproc_endregion_token1] = "#endregion",
  [aux_sym_preproc_line_token1] = "#line",
  [anon_sym_hidden] = "hidden",
  [aux_sym_preproc_pragma_token1] = "#pragma",
  [anon_sym_warning] = "warning",
  [anon_sym_disable] = "disable",
  [anon_sym_restore] = "restore",
  [anon_sym_checksum] = "checksum",
  [aux_sym_preproc_nullable_token1] = "#nullable",
  [anon_sym_enable] = "enable",
  [anon_sym_annotations] = "annotations",
  [anon_sym_warnings] = "warnings",
  [aux_sym_preproc_error_token1] = "#error",
  [aux_sym_preproc_define_token1] = "#define",
  [aux_sym_preproc_undef_token1] = "#undef",
  [sym_shebang_directive] = "shebang_directive",
  [sym_comment] = "comment",
  [sym__optional_semi] = "_optional_semi",
  [sym_interpolation_regular_start] = "interpolation_start",
  [sym_interpolation_verbatim_start] = "interpolation_start",
  [sym_interpolation_raw_start] = "interpolation_start",
  [sym_interpolation_start_quote] = "interpolation_quote",
  [sym_interpolation_end_quote] = "interpolation_quote",
  [sym_interpolation_open_brace] = "interpolation_brace",
  [sym_interpolation_close_brace] = "interpolation_brace",
  [sym_interpolation_string_content] = "string_content",
  [sym_raw_string_start] = "raw_string_start",
  [sym_raw_string_end] = "raw_string_end",
  [sym_raw_string_content] = "raw_string_content",
  [sym_compilation_unit] = "compilation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym_global_statement] = "global_statement",
  [sym_extern_alias_directive] = "extern_alias_directive",
  [sym_using_directive] = "using_directive",
  [sym_global_attribute] = "global_attribute",
  [sym_attribute] = "attribute",
  [sym_attribute_argument_list] = "attribute_argument_list",
  [sym_attribute_argument] = "attribute_argument",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute_target_specifier] = "attribute_target_specifier",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_file_scoped_namespace_declaration] = "file_scoped_namespace_declaration",
  [sym_type_declaration] = "type_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_member_declaration_list] = "enum_member_declaration_list",
  [sym_enum_member_declaration] = "enum_member_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_delegate_declaration] = "delegate_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_record_base] = "base_list",
  [sym_primary_constructor_base_type] = "primary_constructor_base_type",
  [sym_modifier] = "modifier",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter] = "type_parameter",
  [sym_base_list] = "base_list",
  [sym_type_parameter_constraints_clause] = "type_parameter_constraints_clause",
  [sym_type_parameter_constraint] = "type_parameter_constraint",
  [sym_constructor_constraint] = "constructor_constraint",
  [sym_operator_declaration] = "operator_declaration",
  [sym_conversion_operator_declaration] = "conversion_operator_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_declaration] = "declaration",
  [sym_field_declaration] = "field_declaration",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym_destructor_declaration] = "destructor_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_event_declaration] = "event_declaration",
  [sym_event_field_declaration] = "event_field_declaration",
  [sym_accessor_list] = "accessor_list",
  [sym_accessor_declaration] = "accessor_declaration",
  [sym_indexer_declaration] = "indexer_declaration",
  [sym_bracketed_parameter_list] = "bracketed_parameter_list",
  [sym_property_declaration] = "property_declaration",
  [sym_explicit_interface_specifier] = "explicit_interface_specifier",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter] = "parameter",
  [sym__parameter_array] = "_parameter_array",
  [sym_constructor_initializer] = "constructor_initializer",
  [sym_argument_list] = "argument_list",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_argument] = "argument",
  [sym_block] = "block",
  [sym_arrow_expression_clause] = "arrow_expression_clause",
  [sym__function_body] = "_function_body",
  [sym_variable_declaration] = "variable_declaration",
  [sym_using_variable_declaration] = "variable_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_using_variable_declarator] = "variable_declarator",
  [sym_bracketed_argument_list] = "bracketed_argument_list",
  [sym__name] = "_name",
  [sym_alias_qualified_name] = "alias_qualified_name",
  [sym__simple_name] = "_simple_name",
  [sym_qualified_name] = "qualified_name",
  [sym_generic_name] = "generic_name",
  [sym_type_argument_list] = "type_argument_list",
  [sym_type] = "type",
  [sym_implicit_type] = "implicit_type",
  [sym_array_type] = "array_type",
  [sym__array_base_type] = "_array_base_type",
  [sym_array_rank_specifier] = "array_rank_specifier",
  [sym_nullable_type] = "nullable_type",
  [sym_pointer_type] = "pointer_type",
  [sym__pointer_base_type] = "_pointer_base_type",
  [sym_function_pointer_type] = "function_pointer_type",
  [sym_calling_convention] = "calling_convention",
  [sym_function_pointer_parameter] = "function_pointer_parameter",
  [sym_ref_type] = "ref_type",
  [sym__ref_base_type] = "_ref_base_type",
  [sym_scoped_type] = "scoped_type",
  [sym__scoped_base_type] = "_scoped_base_type",
  [sym_tuple_type] = "tuple_type",
  [sym_tuple_element] = "tuple_element",
  [sym_statement] = "statement",
  [sym_break_statement] = "break_statement",
  [sym_checked_statement] = "checked_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_do_statement] = "do_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_fixed_statement] = "fixed_statement",
  [sym_for_statement] = "for_statement",
  [sym_return_statement] = "return_statement",
  [sym_lock_statement] = "lock_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_section] = "switch_section",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_declaration] = "catch_declaration",
  [sym_catch_filter_clause] = "catch_filter_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_unsafe_statement] = "unsafe_statement",
  [sym_using_statement] = "using_statement",
  [sym_foreach_statement] = "foreach_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_local_declaration_statement] = "local_declaration_statement",
  [sym_local_function_statement] = "local_function_statement",
  [sym_pattern] = "pattern",
  [sym_constant_pattern] = "constant_pattern",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym_var_pattern] = "var_pattern",
  [sym_type_pattern] = "type_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_recursive_pattern] = "recursive_pattern",
  [sym_positional_pattern_clause] = "positional_pattern_clause",
  [sym_property_pattern_clause] = "property_pattern_clause",
  [sym_subpattern] = "subpattern",
  [sym_relational_pattern] = "relational_pattern",
  [sym_negated_pattern] = "negated_pattern",
  [sym_and_pattern] = "and_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym_declaration_pattern] = "declaration_pattern",
  [sym__variable_designation] = "_variable_designation",
  [sym_parenthesized_variable_designation] = "parenthesized_variable_designation",
  [sym_expression] = "expression",
  [sym_non_lvalue_expression] = "non_lvalue_expression",
  [sym_lvalue_expression] = "lvalue_expression",
  [sym__expression_statement_expression] = "_expression_statement_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_postfix_unary_expression] = "postfix_unary_expression",
  [sym_prefix_unary_expression] = "prefix_unary_expression",
  [sym__pointer_indirection_expression] = "prefix_unary_expression",
  [sym_query_expression] = "query_expression",
  [sym_from_clause] = "from_clause",
  [sym__query_body] = "_query_body",
  [sym__query_clause] = "_query_clause",
  [sym_join_clause] = "join_clause",
  [sym__join_header] = "_join_header",
  [sym__join_body] = "_join_body",
  [sym_join_into_clause] = "join_into_clause",
  [sym_let_clause] = "let_clause",
  [sym_order_by_clause] = "order_by_clause",
  [sym__ordering] = "_ordering",
  [sym_where_clause] = "where_clause",
  [sym__select_or_group_clause] = "_select_or_group_clause",
  [sym_group_clause] = "group_clause",
  [sym_select_clause] = "select_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_conditional_access_expression] = "conditional_access_expression",
  [sym_as_expression] = "as_expression",
  [sym_is_expression] = "is_expression",
  [sym_is_pattern_expression] = "is_pattern_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_checked_expression] = "checked_expression",
  [sym_invocation_expression] = "invocation_expression",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_expression_arm] = "switch_expression_arm",
  [sym_when_clause] = "when_clause",
  [sym_await_expression] = "await_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_element_access_expression] = "element_access_expression",
  [sym_interpolated_string_expression] = "interpolated_string_expression",
  [sym__interpolated_string_content] = "_interpolated_string_content",
  [sym__interpolated_verbatim_string_content] = "_interpolated_verbatim_string_content",
  [sym__interpolated_raw_string_content] = "_interpolated_raw_string_content",
  [sym_interpolation] = "interpolation",
  [sym_interpolation_alignment_clause] = "interpolation_alignment_clause",
  [sym_interpolation_format_clause] = "interpolation_format_clause",
  [sym_member_access_expression] = "member_access_expression",
  [sym_member_binding_expression] = "member_binding_expression",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__parenthesized_lvalue_expression] = "parenthesized_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym__lambda_parameters] = "_lambda_parameters",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_anonymous_method_expression] = "anonymous_method_expression",
  [sym_anonymous_object_creation_expression] = "anonymous_object_creation_expression",
  [sym__anonymous_object_member_declarator] = "_anonymous_object_member_declarator",
  [sym_implicit_array_creation_expression] = "implicit_array_creation_expression",
  [sym_implicit_object_creation_expression] = "implicit_object_creation_expression",
  [sym_implicit_stackalloc_expression] = "implicit_stackalloc_expression",
  [sym_initializer_expression] = "initializer_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_default_expression] = "default_expression",
  [sym_with_expression] = "with_expression",
  [sym_with_initializer] = "with_initializer",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_typeof_expression] = "typeof_expression",
  [sym_makeref_expression] = "makeref_expression",
  [sym_ref_expression] = "ref_expression",
  [sym_reftype_expression] = "reftype_expression",
  [sym_refvalue_expression] = "refvalue_expression",
  [sym_stackalloc_expression] = "stackalloc_expression",
  [sym_range_expression] = "range_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_literal] = "literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_string_literal_content] = "string_literal_content",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_identifier] = "identifier",
  [sym__reserved_identifier] = "_reserved_identifier",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_if_in_top_level] = "preproc_if",
  [sym_preproc_else_in_top_level] = "preproc_else",
  [sym_preproc_elif_in_top_level] = "preproc_elif",
  [sym_preproc_if_in_expression] = "preproc_if",
  [sym_preproc_else_in_expression] = "preproc_else",
  [sym_preproc_elif_in_expression] = "preproc_elif",
  [sym_preproc_if_in_enum_member_declaration] = "preproc_if",
  [sym_preproc_else_in_enum_member_declaration] = "preproc_else",
  [sym_preproc_elif_in_enum_member_declaration] = "preproc_elif",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_preproc_region] = "preproc_region",
  [sym_preproc_endregion] = "preproc_endregion",
  [sym_preproc_line] = "preproc_line",
  [sym_preproc_pragma] = "preproc_pragma",
  [sym_preproc_nullable] = "preproc_nullable",
  [sym_preproc_error] = "preproc_error",
  [sym_preproc_define] = "preproc_define",
  [sym_preproc_undef] = "preproc_undef",
  [aux_sym_compilation_unit_repeat1] = "compilation_unit_repeat1",
  [aux_sym_global_attribute_repeat1] = "global_attribute_repeat1",
  [aux_sym_attribute_argument_list_repeat1] = "attribute_argument_list_repeat1",
  [aux_sym_class_declaration_repeat1] = "class_declaration_repeat1",
  [aux_sym_class_declaration_repeat2] = "class_declaration_repeat2",
  [aux_sym_class_declaration_repeat3] = "class_declaration_repeat3",
  [aux_sym_enum_member_declaration_list_repeat1] = "enum_member_declaration_list_repeat1",
  [aux_sym_record_base_repeat1] = "record_base_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_base_list_repeat1] = "base_list_repeat1",
  [aux_sym_type_parameter_constraints_clause_repeat1] = "type_parameter_constraints_clause_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_accessor_list_repeat1] = "accessor_list_repeat1",
  [aux_sym_bracketed_parameter_list_repeat1] = "bracketed_parameter_list_repeat1",
  [aux_sym__parameter_type_with_modifiers_repeat1] = "_parameter_type_with_modifiers_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_using_variable_declaration_repeat1] = "using_variable_declaration_repeat1",
  [aux_sym_type_argument_list_repeat1] = "type_argument_list_repeat1",
  [aux_sym_type_argument_list_repeat2] = "type_argument_list_repeat2",
  [aux_sym_array_rank_specifier_repeat1] = "array_rank_specifier_repeat1",
  [aux_sym_function_pointer_type_repeat1] = "function_pointer_type_repeat1",
  [aux_sym_calling_convention_repeat1] = "calling_convention_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_list_pattern_repeat1] = "list_pattern_repeat1",
  [aux_sym_positional_pattern_clause_repeat1] = "positional_pattern_clause_repeat1",
  [aux_sym_parenthesized_variable_designation_repeat1] = "parenthesized_variable_designation_repeat1",
  [aux_sym__query_body_repeat1] = "_query_body_repeat1",
  [aux_sym__query_body_repeat2] = "_query_body_repeat2",
  [aux_sym_order_by_clause_repeat1] = "order_by_clause_repeat1",
  [aux_sym_switch_expression_repeat1] = "switch_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat1] = "interpolated_string_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat2] = "interpolated_string_expression_repeat2",
  [aux_sym_interpolated_string_expression_repeat3] = "interpolated_string_expression_repeat3",
  [aux_sym_lambda_expression_repeat1] = "lambda_expression_repeat1",
  [aux_sym_anonymous_object_creation_expression_repeat1] = "anonymous_object_creation_expression_repeat1",
  [aux_sym_with_expression_repeat1] = "with_expression_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_preproc_if_in_top_level_repeat1] = "preproc_if_in_top_level_repeat1",
  [aux_sym_preproc_pragma_repeat1] = "preproc_pragma_repeat1",
  [alias_sym_element_binding_expression] = "element_binding_expression",
  [alias_sym_implicit_parameter] = "implicit_parameter",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier_token] = sym__identifier_token,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_file] = anon_sym_file,
  [anon_sym_fixed] = anon_sym_fixed,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_partial] = anon_sym_partial,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_notnull] = anon_sym_notnull,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_checked] = anon_sym_checked,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_implicit] = anon_sym_implicit,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_init] = anon_sym_init,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_scoped] = anon_sym_scoped,
  [anon_sym_params] = anon_sym_params,
  [anon_sym_base] = anon_sym_base,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_managed] = anon_sym_managed,
  [anon_sym_Cdecl] = anon_sym_Cdecl,
  [anon_sym_Stdcall] = anon_sym_Stdcall,
  [anon_sym_Thiscall] = anon_sym_Thiscall,
  [anon_sym_Fastcall] = anon_sym_Fastcall,
  [sym_predefined_type] = sym_predefined_type,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_unchecked] = anon_sym_unchecked,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [sym_discard] = sym_discard,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_into] = anon_sym_into,
  [anon_sym_join] = anon_sym_join,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_equals] = anon_sym_equals,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_orderby] = anon_sym_orderby,
  [anon_sym_ascending] = anon_sym_ascending,
  [anon_sym_descending] = anon_sym_descending,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_interpolation_format_clause_token1] = aux_sym_interpolation_format_clause_token1,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stackalloc] = anon_sym_stackalloc,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym___makeref] = anon_sym___makeref,
  [anon_sym___reftype] = anon_sym___reftype,
  [anon_sym___refvalue] = anon_sym___refvalue,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_character_literal_content] = sym_character_literal_content,
  [sym_integer_literal] = sym_integer_literal,
  [sym_real_literal] = sym_real_literal,
  [aux_sym_string_literal_content_token1] = aux_sym_string_literal_content_token1,
  [aux_sym_string_literal_content_token2] = aux_sym_string_literal_content_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_string_literal_encoding] = sym_string_literal_encoding,
  [sym_verbatim_string_literal] = sym_verbatim_string_literal,
  [aux_sym_raw_string_literal_token1] = aux_sym_raw_string_literal_token1,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_if_token3] = aux_sym_preproc_if_token3,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [sym_preproc_arg] = sym_preproc_arg,
  [aux_sym_preproc_region_token1] = aux_sym_preproc_region_token1,
  [aux_sym_preproc_endregion_token1] = aux_sym_preproc_endregion_token1,
  [aux_sym_preproc_line_token1] = aux_sym_preproc_line_token1,
  [anon_sym_hidden] = anon_sym_hidden,
  [aux_sym_preproc_pragma_token1] = aux_sym_preproc_pragma_token1,
  [anon_sym_warning] = anon_sym_warning,
  [anon_sym_disable] = anon_sym_disable,
  [anon_sym_restore] = anon_sym_restore,
  [anon_sym_checksum] = anon_sym_checksum,
  [aux_sym_preproc_nullable_token1] = aux_sym_preproc_nullable_token1,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_annotations] = anon_sym_annotations,
  [anon_sym_warnings] = anon_sym_warnings,
  [aux_sym_preproc_error_token1] = aux_sym_preproc_error_token1,
  [aux_sym_preproc_define_token1] = aux_sym_preproc_define_token1,
  [aux_sym_preproc_undef_token1] = aux_sym_preproc_undef_token1,
  [sym_shebang_directive] = sym_shebang_directive,
  [sym_comment] = sym_comment,
  [sym__optional_semi] = sym__optional_semi,
  [sym_interpolation_regular_start] = sym_interpolation_regular_start,
  [sym_interpolation_verbatim_start] = sym_interpolation_regular_start,
  [sym_interpolation_raw_start] = sym_interpolation_regular_start,
  [sym_interpolation_start_quote] = sym_interpolation_start_quote,
  [sym_interpolation_end_quote] = sym_interpolation_start_quote,
  [sym_interpolation_open_brace] = sym_interpolation_open_brace,
  [sym_interpolation_close_brace] = sym_interpolation_open_brace,
  [sym_interpolation_string_content] = sym_interpolation_string_content,
  [sym_raw_string_start] = sym_raw_string_start,
  [sym_raw_string_end] = sym_raw_string_end,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_compilation_unit] = sym_compilation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym_global_statement] = sym_global_statement,
  [sym_extern_alias_directive] = sym_extern_alias_directive,
  [sym_using_directive] = sym_using_directive,
  [sym_global_attribute] = sym_global_attribute,
  [sym_attribute] = sym_attribute,
  [sym_attribute_argument_list] = sym_attribute_argument_list,
  [sym_attribute_argument] = sym_attribute_argument,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute_target_specifier] = sym_attribute_target_specifier,
  [sym_namespace_declaration] = sym_namespace_declaration,
  [sym_file_scoped_namespace_declaration] = sym_file_scoped_namespace_declaration,
  [sym_type_declaration] = sym_type_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_member_declaration_list] = sym_enum_member_declaration_list,
  [sym_enum_member_declaration] = sym_enum_member_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_delegate_declaration] = sym_delegate_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_record_base] = sym_base_list,
  [sym_primary_constructor_base_type] = sym_primary_constructor_base_type,
  [sym_modifier] = sym_modifier,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter] = sym_type_parameter,
  [sym_base_list] = sym_base_list,
  [sym_type_parameter_constraints_clause] = sym_type_parameter_constraints_clause,
  [sym_type_parameter_constraint] = sym_type_parameter_constraint,
  [sym_constructor_constraint] = sym_constructor_constraint,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym_conversion_operator_declaration] = sym_conversion_operator_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_declaration] = sym_declaration,
  [sym_field_declaration] = sym_field_declaration,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym_destructor_declaration] = sym_destructor_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_event_declaration] = sym_event_declaration,
  [sym_event_field_declaration] = sym_event_field_declaration,
  [sym_accessor_list] = sym_accessor_list,
  [sym_accessor_declaration] = sym_accessor_declaration,
  [sym_indexer_declaration] = sym_indexer_declaration,
  [sym_bracketed_parameter_list] = sym_bracketed_parameter_list,
  [sym_property_declaration] = sym_property_declaration,
  [sym_explicit_interface_specifier] = sym_explicit_interface_specifier,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym__parameter_array] = sym__parameter_array,
  [sym_constructor_initializer] = sym_constructor_initializer,
  [sym_argument_list] = sym_argument_list,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_argument] = sym_argument,
  [sym_block] = sym_block,
  [sym_arrow_expression_clause] = sym_arrow_expression_clause,
  [sym__function_body] = sym__function_body,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_using_variable_declaration] = sym_variable_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_using_variable_declarator] = sym_variable_declarator,
  [sym_bracketed_argument_list] = sym_bracketed_argument_list,
  [sym__name] = sym__name,
  [sym_alias_qualified_name] = sym_alias_qualified_name,
  [sym__simple_name] = sym__simple_name,
  [sym_qualified_name] = sym_qualified_name,
  [sym_generic_name] = sym_generic_name,
  [sym_type_argument_list] = sym_type_argument_list,
  [sym_type] = sym_type,
  [sym_implicit_type] = sym_implicit_type,
  [sym_array_type] = sym_array_type,
  [sym__array_base_type] = sym__array_base_type,
  [sym_array_rank_specifier] = sym_array_rank_specifier,
  [sym_nullable_type] = sym_nullable_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym__pointer_base_type] = sym__pointer_base_type,
  [sym_function_pointer_type] = sym_function_pointer_type,
  [sym_calling_convention] = sym_calling_convention,
  [sym_function_pointer_parameter] = sym_function_pointer_parameter,
  [sym_ref_type] = sym_ref_type,
  [sym__ref_base_type] = sym__ref_base_type,
  [sym_scoped_type] = sym_scoped_type,
  [sym__scoped_base_type] = sym__scoped_base_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_tuple_element] = sym_tuple_element,
  [sym_statement] = sym_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_checked_statement] = sym_checked_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_fixed_statement] = sym_fixed_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_lock_statement] = sym_lock_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_section] = sym_switch_section,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_declaration] = sym_catch_declaration,
  [sym_catch_filter_clause] = sym_catch_filter_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_unsafe_statement] = sym_unsafe_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_local_declaration_statement] = sym_local_declaration_statement,
  [sym_local_function_statement] = sym_local_function_statement,
  [sym_pattern] = sym_pattern,
  [sym_constant_pattern] = sym_constant_pattern,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym_var_pattern] = sym_var_pattern,
  [sym_type_pattern] = sym_type_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_recursive_pattern] = sym_recursive_pattern,
  [sym_positional_pattern_clause] = sym_positional_pattern_clause,
  [sym_property_pattern_clause] = sym_property_pattern_clause,
  [sym_subpattern] = sym_subpattern,
  [sym_relational_pattern] = sym_relational_pattern,
  [sym_negated_pattern] = sym_negated_pattern,
  [sym_and_pattern] = sym_and_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym_declaration_pattern] = sym_declaration_pattern,
  [sym__variable_designation] = sym__variable_designation,
  [sym_parenthesized_variable_designation] = sym_parenthesized_variable_designation,
  [sym_expression] = sym_expression,
  [sym_non_lvalue_expression] = sym_non_lvalue_expression,
  [sym_lvalue_expression] = sym_lvalue_expression,
  [sym__expression_statement_expression] = sym__expression_statement_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_postfix_unary_expression] = sym_postfix_unary_expression,
  [sym_prefix_unary_expression] = sym_prefix_unary_expression,
  [sym__pointer_indirection_expression] = sym_prefix_unary_expression,
  [sym_query_expression] = sym_query_expression,
  [sym_from_clause] = sym_from_clause,
  [sym__query_body] = sym__query_body,
  [sym__query_clause] = sym__query_clause,
  [sym_join_clause] = sym_join_clause,
  [sym__join_header] = sym__join_header,
  [sym__join_body] = sym__join_body,
  [sym_join_into_clause] = sym_join_into_clause,
  [sym_let_clause] = sym_let_clause,
  [sym_order_by_clause] = sym_order_by_clause,
  [sym__ordering] = sym__ordering,
  [sym_where_clause] = sym_where_clause,
  [sym__select_or_group_clause] = sym__select_or_group_clause,
  [sym_group_clause] = sym_group_clause,
  [sym_select_clause] = sym_select_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_conditional_access_expression] = sym_conditional_access_expression,
  [sym_as_expression] = sym_as_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_is_pattern_expression] = sym_is_pattern_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_checked_expression] = sym_checked_expression,
  [sym_invocation_expression] = sym_invocation_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_expression_arm] = sym_switch_expression_arm,
  [sym_when_clause] = sym_when_clause,
  [sym_await_expression] = sym_await_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_element_access_expression] = sym_element_access_expression,
  [sym_interpolated_string_expression] = sym_interpolated_string_expression,
  [sym__interpolated_string_content] = sym__interpolated_string_content,
  [sym__interpolated_verbatim_string_content] = sym__interpolated_verbatim_string_content,
  [sym__interpolated_raw_string_content] = sym__interpolated_raw_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym_interpolation_alignment_clause] = sym_interpolation_alignment_clause,
  [sym_interpolation_format_clause] = sym_interpolation_format_clause,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_member_binding_expression] = sym_member_binding_expression,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__parenthesized_lvalue_expression] = sym_parenthesized_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym__lambda_parameters] = sym__lambda_parameters,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_anonymous_method_expression] = sym_anonymous_method_expression,
  [sym_anonymous_object_creation_expression] = sym_anonymous_object_creation_expression,
  [sym__anonymous_object_member_declarator] = sym__anonymous_object_member_declarator,
  [sym_implicit_array_creation_expression] = sym_implicit_array_creation_expression,
  [sym_implicit_object_creation_expression] = sym_implicit_object_creation_expression,
  [sym_implicit_stackalloc_expression] = sym_implicit_stackalloc_expression,
  [sym_initializer_expression] = sym_initializer_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_default_expression] = sym_default_expression,
  [sym_with_expression] = sym_with_expression,
  [sym_with_initializer] = sym_with_initializer,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_typeof_expression] = sym_typeof_expression,
  [sym_makeref_expression] = sym_makeref_expression,
  [sym_ref_expression] = sym_ref_expression,
  [sym_reftype_expression] = sym_reftype_expression,
  [sym_refvalue_expression] = sym_refvalue_expression,
  [sym_stackalloc_expression] = sym_stackalloc_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_literal] = sym_literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_string_literal_content] = sym_string_literal_content,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_identifier] = sym_identifier,
  [sym__reserved_identifier] = sym__reserved_identifier,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_if_in_top_level] = sym_preproc_if,
  [sym_preproc_else_in_top_level] = sym_preproc_else,
  [sym_preproc_elif_in_top_level] = sym_preproc_elif,
  [sym_preproc_if_in_expression] = sym_preproc_if,
  [sym_preproc_else_in_expression] = sym_preproc_else,
  [sym_preproc_elif_in_expression] = sym_preproc_elif,
  [sym_preproc_if_in_enum_member_declaration] = sym_preproc_if,
  [sym_preproc_else_in_enum_member_declaration] = sym_preproc_else,
  [sym_preproc_elif_in_enum_member_declaration] = sym_preproc_elif,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_unary_expression] = sym_preproc_unary_expression,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_preproc_region] = sym_preproc_region,
  [sym_preproc_endregion] = sym_preproc_endregion,
  [sym_preproc_line] = sym_preproc_line,
  [sym_preproc_pragma] = sym_preproc_pragma,
  [sym_preproc_nullable] = sym_preproc_nullable,
  [sym_preproc_error] = sym_preproc_error,
  [sym_preproc_define] = sym_preproc_define,
  [sym_preproc_undef] = sym_preproc_undef,
  [aux_sym_compilation_unit_repeat1] = aux_sym_compilation_unit_repeat1,
  [aux_sym_global_attribute_repeat1] = aux_sym_global_attribute_repeat1,
  [aux_sym_attribute_argument_list_repeat1] = aux_sym_attribute_argument_list_repeat1,
  [aux_sym_class_declaration_repeat1] = aux_sym_class_declaration_repeat1,
  [aux_sym_class_declaration_repeat2] = aux_sym_class_declaration_repeat2,
  [aux_sym_class_declaration_repeat3] = aux_sym_class_declaration_repeat3,
  [aux_sym_enum_member_declaration_list_repeat1] = aux_sym_enum_member_declaration_list_repeat1,
  [aux_sym_record_base_repeat1] = aux_sym_record_base_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_base_list_repeat1] = aux_sym_base_list_repeat1,
  [aux_sym_type_parameter_constraints_clause_repeat1] = aux_sym_type_parameter_constraints_clause_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_accessor_list_repeat1] = aux_sym_accessor_list_repeat1,
  [aux_sym_bracketed_parameter_list_repeat1] = aux_sym_bracketed_parameter_list_repeat1,
  [aux_sym__parameter_type_with_modifiers_repeat1] = aux_sym__parameter_type_with_modifiers_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_using_variable_declaration_repeat1] = aux_sym_using_variable_declaration_repeat1,
  [aux_sym_type_argument_list_repeat1] = aux_sym_type_argument_list_repeat1,
  [aux_sym_type_argument_list_repeat2] = aux_sym_type_argument_list_repeat2,
  [aux_sym_array_rank_specifier_repeat1] = aux_sym_array_rank_specifier_repeat1,
  [aux_sym_function_pointer_type_repeat1] = aux_sym_function_pointer_type_repeat1,
  [aux_sym_calling_convention_repeat1] = aux_sym_calling_convention_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_list_pattern_repeat1] = aux_sym_list_pattern_repeat1,
  [aux_sym_positional_pattern_clause_repeat1] = aux_sym_positional_pattern_clause_repeat1,
  [aux_sym_parenthesized_variable_designation_repeat1] = aux_sym_parenthesized_variable_designation_repeat1,
  [aux_sym__query_body_repeat1] = aux_sym__query_body_repeat1,
  [aux_sym__query_body_repeat2] = aux_sym__query_body_repeat2,
  [aux_sym_order_by_clause_repeat1] = aux_sym_order_by_clause_repeat1,
  [aux_sym_switch_expression_repeat1] = aux_sym_switch_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat1] = aux_sym_interpolated_string_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat2] = aux_sym_interpolated_string_expression_repeat2,
  [aux_sym_interpolated_string_expression_repeat3] = aux_sym_interpolated_string_expression_repeat3,
  [aux_sym_lambda_expression_repeat1] = aux_sym_lambda_expression_repeat1,
  [aux_sym_anonymous_object_creation_expression_repeat1] = aux_sym_anonymous_object_creation_expression_repeat1,
  [aux_sym_with_expression_repeat1] = aux_sym_with_expression_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_preproc_if_in_top_level_repeat1] = aux_sym_preproc_if_in_top_level_repeat1,
  [aux_sym_preproc_pragma_repeat1] = aux_sym_preproc_pragma_repeat1,
  [alias_sym_element_binding_expression] = alias_sym_element_binding_expression,
  [alias_sym_implicit_parameter] = alias_sym_implicit_parameter,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_token] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_file] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_scoped] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_managed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Fastcall] = {
    .visible = true,
    .named = false,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unchecked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_into] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_join] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equals] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orderby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ascending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_descending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpolation_format_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stackalloc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___makeref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___reftype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___refvalue] = {
    .visible = true,
    .named = false,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_character_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_content_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_encoding] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_raw_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_region_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_endregion_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_line_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_pragma_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warning] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checksum] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_nullable_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_annotations] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warnings] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_error_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_define_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_undef_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_shebang_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__optional_semi] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation_regular_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_verbatim_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_raw_start] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_start_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_end_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_open_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_close_brace] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_compilation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_alias_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_global_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_target_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_file_scoped_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_base] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_constructor_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_base_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_conversion_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_event_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_list] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_array] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_expression_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_using_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_alias_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_name] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_implicit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym__array_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_array_rank_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_function_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym__ref_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_type] = {
    .visible = true,
    .named = true,
  },
  [sym__scoped_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_element] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_section] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_filter_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_constant_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_var_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_type_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_recursive_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_property_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_subpattern] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_and_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_designation] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_variable_designation] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_non_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_lvalue_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_statement_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_indirection_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_query_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__query_body] = {
    .visible = false,
    .named = true,
  },
  [sym__query_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_join_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__join_header] = {
    .visible = false,
    .named = true,
  },
  [sym__join_body] = {
    .visible = false,
    .named = true,
  },
  [sym_join_into_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_order_by_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__ordering] = {
    .visible = false,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__select_or_group_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_select_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_pattern_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_string_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_verbatim_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_raw_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_alignment_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_format_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_lvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__anonymous_object_member_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_implicit_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_makeref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reftype_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_refvalue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_stackalloc_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal_content] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_top_level] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_region] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_endregion] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_line] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_nullable] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_error] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_define] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_undef] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_compilation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_declaration_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_member_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_constraints_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_accessor_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bracketed_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_type_with_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_using_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_rank_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_pointer_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_calling_convention_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_pattern_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_variable_designation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_by_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_object_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_top_level_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_pragma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_element_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_implicit_parameter] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_accessors = 1,
  field_alias = 2,
  field_alternative = 3,
  field_argument = 4,
  field_arguments = 5,
  field_body = 6,
  field_condition = 7,
  field_consequence = 8,
  field_content = 9,
  field_expression = 10,
  field_function = 11,
  field_initializer = 12,
  field_left = 13,
  field_name = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_qualifier = 18,
  field_rank = 19,
  field_returns = 20,
  field_right = 21,
  field_subscript = 22,
  field_type = 23,
  field_type_parameters = 24,
  field_update = 25,
  field_value = 26,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_accessors] = "accessors",
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_expression] = "expression",
  [field_function] = "function",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_qualifier] = "qualifier",
  [field_rank] = "rank",
  [field_returns] = "returns",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 1},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 13, .length = 2},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 2},
  [19] = {.index = 22, .length = 2},
  [20] = {.index = 24, .length = 2},
  [21] = {.index = 26, .length = 2},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 3},
  [24] = {.index = 33, .length = 1},
  [25] = {.index = 33, .length = 1},
  [26] = {.index = 34, .length = 2},
  [27] = {.index = 36, .length = 2},
  [28] = {.index = 38, .length = 2},
  [29] = {.index = 40, .length = 1},
  [30] = {.index = 41, .length = 2},
  [31] = {.index = 43, .length = 2},
  [32] = {.index = 45, .length = 4},
  [33] = {.index = 49, .length = 4},
  [34] = {.index = 53, .length = 2},
  [35] = {.index = 55, .length = 2},
  [36] = {.index = 57, .length = 3},
  [37] = {.index = 60, .length = 1},
  [38] = {.index = 61, .length = 3},
  [39] = {.index = 64, .length = 1},
  [40] = {.index = 65, .length = 4},
  [41] = {.index = 69, .length = 1},
  [42] = {.index = 70, .length = 2},
  [43] = {.index = 72, .length = 1},
  [44] = {.index = 73, .length = 2},
  [45] = {.index = 75, .length = 1},
  [46] = {.index = 76, .length = 1},
  [47] = {.index = 77, .length = 2},
  [48] = {.index = 79, .length = 2},
  [49] = {.index = 81, .length = 2},
  [50] = {.index = 83, .length = 3},
  [51] = {.index = 86, .length = 1},
  [52] = {.index = 87, .length = 3},
  [53] = {.index = 90, .length = 2},
  [54] = {.index = 92, .length = 2},
  [55] = {.index = 94, .length = 1},
  [56] = {.index = 95, .length = 2},
  [57] = {.index = 97, .length = 2},
  [58] = {.index = 99, .length = 1},
  [59] = {.index = 100, .length = 2},
  [60] = {.index = 102, .length = 2},
  [61] = {.index = 104, .length = 5},
  [62] = {.index = 109, .length = 4},
  [63] = {.index = 113, .length = 3},
  [64] = {.index = 116, .length = 2},
  [65] = {.index = 118, .length = 3},
  [66] = {.index = 121, .length = 4},
  [67] = {.index = 125, .length = 2},
  [68] = {.index = 127, .length = 3},
  [69] = {.index = 130, .length = 3},
  [70] = {.index = 133, .length = 2},
  [71] = {.index = 135, .length = 2},
  [72] = {.index = 137, .length = 2},
  [73] = {.index = 139, .length = 3},
  [74] = {.index = 142, .length = 1},
  [75] = {.index = 143, .length = 4},
  [76] = {.index = 147, .length = 1},
  [77] = {.index = 148, .length = 1},
  [78] = {.index = 149, .length = 2},
  [79] = {.index = 151, .length = 2},
  [80] = {.index = 153, .length = 5},
  [81] = {.index = 158, .length = 2},
  [82] = {.index = 160, .length = 2},
  [83] = {.index = 162, .length = 3},
  [84] = {.index = 165, .length = 3},
  [85] = {.index = 168, .length = 1},
  [86] = {.index = 169, .length = 5},
  [87] = {.index = 174, .length = 4},
  [88] = {.index = 178, .length = 4},
  [89] = {.index = 182, .length = 3},
  [90] = {.index = 185, .length = 3},
  [91] = {.index = 188, .length = 3},
  [92] = {.index = 191, .length = 3},
  [93] = {.index = 194, .length = 3},
  [94] = {.index = 197, .length = 4},
  [95] = {.index = 201, .length = 3},
  [96] = {.index = 204, .length = 3},
  [97] = {.index = 207, .length = 2},
  [98] = {.index = 209, .length = 2},
  [99] = {.index = 211, .length = 2},
  [100] = {.index = 213, .length = 3},
  [101] = {.index = 216, .length = 1},
  [102] = {.index = 217, .length = 2},
  [103] = {.index = 219, .length = 2},
  [104] = {.index = 221, .length = 2},
  [105] = {.index = 223, .length = 2},
  [106] = {.index = 225, .length = 3},
  [107] = {.index = 228, .length = 3},
  [108] = {.index = 231, .length = 2},
  [109] = {.index = 233, .length = 2},
  [110] = {.index = 235, .length = 3},
  [111] = {.index = 238, .length = 4},
  [112] = {.index = 242, .length = 5},
  [113] = {.index = 247, .length = 2},
  [114] = {.index = 249, .length = 3},
  [115] = {.index = 252, .length = 3},
  [116] = {.index = 255, .length = 1},
  [117] = {.index = 256, .length = 5},
  [118] = {.index = 261, .length = 4},
  [119] = {.index = 265, .length = 3},
  [120] = {.index = 268, .length = 2},
  [121] = {.index = 270, .length = 3},
  [122] = {.index = 273, .length = 3},
  [123] = {.index = 276, .length = 4},
  [124] = {.index = 280, .length = 3},
  [125] = {.index = 283, .length = 3},
  [126] = {.index = 286, .length = 4},
  [127] = {.index = 290, .length = 3},
  [128] = {.index = 293, .length = 2},
  [129] = {.index = 295, .length = 5},
  [130] = {.index = 300, .length = 4},
  [131] = {.index = 304, .length = 3},
  [132] = {.index = 307, .length = 3},
  [133] = {.index = 310, .length = 4},
  [134] = {.index = 314, .length = 3},
  [135] = {.index = 317, .length = 3},
  [136] = {.index = 320, .length = 2},
  [137] = {.index = 322, .length = 2},
  [138] = {.index = 324, .length = 3},
  [139] = {.index = 327, .length = 3},
  [140] = {.index = 330, .length = 3},
  [141] = {.index = 333, .length = 3},
  [142] = {.index = 336, .length = 3},
  [143] = {.index = 339, .length = 3},
  [144] = {.index = 342, .length = 4},
  [145] = {.index = 346, .length = 2},
  [146] = {.index = 348, .length = 3},
  [147] = {.index = 351, .length = 2},
  [148] = {.index = 353, .length = 3},
  [149] = {.index = 356, .length = 4},
  [150] = {.index = 360, .length = 5},
  [151] = {.index = 365, .length = 3},
  [152] = {.index = 368, .length = 4},
  [153] = {.index = 372, .length = 3},
  [154] = {.index = 375, .length = 5},
  [155] = {.index = 380, .length = 4},
  [156] = {.index = 384, .length = 2},
  [157] = {.index = 386, .length = 5},
  [158] = {.index = 391, .length = 4},
  [159] = {.index = 395, .length = 3},
  [160] = {.index = 398, .length = 2},
  [161] = {.index = 400, .length = 3},
  [162] = {.index = 403, .length = 4},
  [163] = {.index = 407, .length = 3},
  [164] = {.index = 410, .length = 3},
  [165] = {.index = 413, .length = 4},
  [166] = {.index = 417, .length = 3},
  [167] = {.index = 420, .length = 5},
  [168] = {.index = 425, .length = 4},
  [169] = {.index = 429, .length = 2},
  [170] = {.index = 431, .length = 3},
  [171] = {.index = 434, .length = 3},
  [172] = {.index = 437, .length = 4},
  [173] = {.index = 441, .length = 3},
  [174] = {.index = 444, .length = 3},
  [175] = {.index = 447, .length = 2},
  [176] = {.index = 449, .length = 4},
  [177] = {.index = 453, .length = 4},
  [178] = {.index = 457, .length = 4},
  [179] = {.index = 461, .length = 4},
  [180] = {.index = 465, .length = 4},
  [181] = {.index = 469, .length = 4},
  [182] = {.index = 473, .length = 2},
  [183] = {.index = 475, .length = 2},
  [184] = {.index = 477, .length = 3},
  [185] = {.index = 480, .length = 3},
  [186] = {.index = 483, .length = 4},
  [187] = {.index = 487, .length = 5},
  [188] = {.index = 492, .length = 4},
  [189] = {.index = 496, .length = 2},
  [190] = {.index = 498, .length = 4},
  [191] = {.index = 502, .length = 3},
  [192] = {.index = 505, .length = 5},
  [193] = {.index = 510, .length = 4},
  [194] = {.index = 514, .length = 5},
  [195] = {.index = 519, .length = 4},
  [196] = {.index = 523, .length = 2},
  [197] = {.index = 525, .length = 3},
  [198] = {.index = 528, .length = 4},
  [199] = {.index = 532, .length = 3},
  [200] = {.index = 535, .length = 3},
  [201] = {.index = 538, .length = 4},
  [202] = {.index = 542, .length = 3},
  [203] = {.index = 545, .length = 5},
  [204] = {.index = 550, .length = 4},
  [205] = {.index = 554, .length = 5},
  [206] = {.index = 559, .length = 5},
  [207] = {.index = 564, .length = 5},
  [208] = {.index = 569, .length = 2},
  [209] = {.index = 571, .length = 2},
  [210] = {.index = 573, .length = 3},
  [211] = {.index = 576, .length = 4},
  [212] = {.index = 580, .length = 5},
  [213] = {.index = 585, .length = 4},
  [214] = {.index = 589, .length = 4},
  [215] = {.index = 593, .length = 3},
  [216] = {.index = 596, .length = 5},
  [217] = {.index = 601, .length = 4},
  [218] = {.index = 605, .length = 5},
  [219] = {.index = 610, .length = 4},
  [220] = {.index = 614, .length = 6},
  [221] = {.index = 620, .length = 2},
  [222] = {.index = 622, .length = 3},
  [223] = {.index = 625, .length = 4},
  [224] = {.index = 629, .length = 5},
  [225] = {.index = 634, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_type, 0},
  [2] =
    {field_type, 1},
  [3] =
    {field_body, 1},
  [4] =
    {field_rank, 1},
    {field_type, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_expression, 0},
    {field_subscript, 1},
  [10] =
    {field_content, 1},
  [11] =
    {field_name, 1},
    {field_type, 0},
  [13] =
    {field_name, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [15] =
    {field_name, 1},
  [16] =
    {field_type, 2},
  [17] =
    {field_parameters, 1},
  [18] =
    {field_arguments, 2},
    {field_type, 1},
  [20] =
    {field_initializer, 2},
    {field_type, 1},
  [22] =
    {field_expression, 0},
    {field_name, 2},
  [24] =
    {field_body, 2},
    {field_value, 1},
  [26] =
    {field_argument, 1},
    {field_operator, 0},
  [28] =
    {field_name, 2},
    {field_qualifier, 0},
  [30] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [33] =
    {field_condition, 0},
  [34] =
    {field_expression, 0},
    {field_pattern, 2},
  [36] =
    {field_body, 2},
    {field_parameters, 0},
  [38] =
    {field_alias, 0},
    {field_name, 2},
  [40] =
    {field_name, 2},
  [41] =
    {field_name, 2},
    {field_type, 1},
  [43] =
    {field_name, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [45] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [49] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [53] =
    {field_type, 1},
    {field_value, 3},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_arguments, 2},
    {field_initializer, 3},
    {field_type, 1},
  [60] =
    {field_condition, 1},
  [61] =
    {field_body, 3},
    {field_parameters, 1},
    {field_type, 0},
  [64] =
    {field_body, 0},
  [65] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [69] =
    {field_name, 1, .inherited = true},
  [70] =
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [72] =
    {field_type, 1, .inherited = true},
  [73] =
    {field_body, 3},
    {field_parameters, 1},
  [75] =
    {field_parameters, 2},
  [76] =
    {field_body, 4},
  [77] =
    {field_name, 3},
    {field_type, 2},
  [79] =
    {field_body, 3},
    {field_name, 1},
  [81] =
    {field_body, 3},
    {field_name, 2},
  [83] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [86] =
    {field_returns, 3},
  [87] =
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [90] =
    {field_body, 4},
    {field_condition, 2},
  [92] =
    {field_body, 4},
    {field_value, 2},
  [94] =
    {field_body, 2},
  [95] =
    {field_condition, 2},
    {field_consequence, 4},
  [97] =
    {field_alternative, 3},
    {field_condition, 1},
  [99] =
    {field_name, 2, .inherited = true},
  [100] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [102] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [104] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [109] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [113] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [116] =
    {field_name, 2, .inherited = true},
    {field_type, 0},
  [118] =
    {field_body, 4},
    {field_parameters, 2},
    {field_type, 1},
  [121] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [125] =
    {field_body, 4},
    {field_parameters, 2},
  [127] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
  [130] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [133] =
    {field_body, 4},
    {field_name, 1},
  [135] =
    {field_body, 4},
    {field_name, 2},
  [137] =
    {field_name, 0},
    {field_value, 2},
  [139] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [142] =
    {field_returns, 4},
  [143] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [147] =
    {field_body, 5},
  [148] =
    {field_body, 3},
  [149] =
    {field_type, 4},
    {field_value, 2},
  [151] =
    {field_alternative, 4},
    {field_condition, 1},
  [153] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [158] =
    {field_name, 3, .inherited = true},
    {field_type, 0},
  [160] =
    {field_body, 4},
    {field_name, 3},
  [162] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [165] =
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [168] =
    {field_name, 3},
  [169] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [174] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [178] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [182] =
    {field_body, 5},
    {field_parameters, 3},
    {field_type, 2},
  [185] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
  [188] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [191] =
    {field_accessors, 3},
    {field_parameters, 2},
    {field_type, 0},
  [194] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
  [197] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [201] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 2},
  [204] =
    {field_body, 3, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [207] =
    {field_body, 5},
    {field_name, 1},
  [209] =
    {field_body, 5},
    {field_name, 2},
  [211] =
    {field_name, 1},
    {field_value, 3},
  [213] =
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [216] =
    {field_returns, 5},
  [217] =
    {field_body, 1},
    {field_condition, 4},
  [219] =
    {field_body, 6},
    {field_update, 4},
  [221] =
    {field_body, 6},
    {field_condition, 3},
  [223] =
    {field_body, 6},
    {field_initializer, 2},
  [225] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [228] =
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [231] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
  [233] =
    {field_body, 5},
    {field_name, 3},
  [235] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [238] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [242] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [247] =
    {field_body, 5},
    {field_name, 4},
  [249] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [252] =
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 3},
  [255] =
    {field_name, 4},
  [256] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [261] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [265] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [268] =
    {field_name, 3},
    {field_type, 1},
  [270] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
  [273] =
    {field_body, 4, .inherited = true},
    {field_parameters, 3},
    {field_type, 2},
  [276] =
    {field_body, 4, .inherited = true},
    {field_operator, 2},
    {field_parameters, 3},
    {field_type, 0},
  [280] =
    {field_parameters, 2},
    {field_type, 0},
    {field_value, 3},
  [283] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 0},
  [286] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [290] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 3},
  [293] =
    {field_body, 1, .inherited = true},
    {field_name, 0},
  [295] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [300] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_returns, 0},
  [304] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
  [307] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 1},
  [310] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [314] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 3},
  [317] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [320] =
    {field_body, 6},
    {field_name, 1},
  [322] =
    {field_body, 6},
    {field_name, 2},
  [324] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5},
  [327] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [330] =
    {field_body, 7},
    {field_initializer, 2},
    {field_update, 5},
  [333] =
    {field_body, 7},
    {field_condition, 4},
    {field_initializer, 2},
  [336] =
    {field_body, 7},
    {field_initializer, 2},
    {field_initializer, 3},
  [339] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
  [342] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
    {field_type, 2},
  [346] =
    {field_body, 6},
    {field_name, 3},
  [348] =
    {field_body, 6},
    {field_name, 2},
    {field_type_parameters, 3},
  [351] =
    {field_body, 6},
    {field_name, 4},
  [353] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [356] =
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 3},
    {field_type_parameters, 5},
  [360] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [365] =
    {field_body, 5, .inherited = true},
    {field_parameters, 4},
    {field_type, 3},
  [368] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 0},
  [372] =
    {field_parameters, 3},
    {field_type, 0},
    {field_value, 4},
  [375] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [380] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 0},
  [384] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
  [386] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_returns, 0},
    {field_type_parameters, 2},
  [391] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
    {field_value, 4},
  [395] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
  [398] =
    {field_name, 4},
    {field_type, 2},
  [400] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
  [403] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 1},
  [407] =
    {field_parameters, 3},
    {field_type, 1},
    {field_value, 4},
  [410] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 1},
  [413] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [417] =
    {field_name, 3},
    {field_type, 1},
    {field_value, 4},
  [420] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [425] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_returns, 1},
  [429] =
    {field_name, 4},
    {field_type, 3},
  [431] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 3},
  [434] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 2},
  [437] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [441] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 4},
  [444] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [447] =
    {field_body, 7},
    {field_name, 2},
  [449] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6},
  [453] =
    {field_body, 8},
    {field_initializer, 2},
    {field_update, 5},
    {field_update, 6},
  [457] =
    {field_body, 8},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
  [461] =
    {field_body, 8},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
  [465] =
    {field_body, 8},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
  [469] =
    {field_body, 8},
    {field_left, 4},
    {field_right, 6},
    {field_type, 3},
  [473] =
    {field_body, 7},
    {field_name, 3},
  [475] =
    {field_body, 7},
    {field_name, 4},
  [477] =
    {field_body, 7},
    {field_name, 3},
    {field_type_parameters, 4},
  [480] =
    {field_body, 6, .inherited = true},
    {field_parameters, 5},
    {field_type, 4},
  [483] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 0},
  [487] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 0},
    {field_type_parameters, 3},
  [492] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
    {field_value, 5},
  [496] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
  [498] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 1},
  [502] =
    {field_parameters, 4},
    {field_type, 1},
    {field_value, 5},
  [505] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [510] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 1},
  [514] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_returns, 1},
    {field_type_parameters, 3},
  [519] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
    {field_value, 5},
  [523] =
    {field_name, 5},
    {field_type, 3},
  [525] =
    {field_accessors, 6},
    {field_name, 5},
    {field_type, 3},
  [528] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 2},
  [532] =
    {field_parameters, 4},
    {field_type, 2},
    {field_value, 5},
  [535] =
    {field_accessors, 6},
    {field_parameters, 5},
    {field_type, 2},
  [538] =
    {field_body, 6, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [542] =
    {field_name, 4},
    {field_type, 2},
    {field_value, 5},
  [545] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [550] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_returns, 2},
  [554] =
    {field_body, 9},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
    {field_update, 7},
  [559] =
    {field_body, 9},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
    {field_update, 7},
  [564] =
    {field_body, 9},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
  [569] =
    {field_body, 8},
    {field_name, 3},
  [571] =
    {field_body, 8},
    {field_name, 4},
  [573] =
    {field_body, 7, .inherited = true},
    {field_parameters, 6},
    {field_type, 5},
  [576] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 1},
  [580] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 1},
    {field_type_parameters, 4},
  [585] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
    {field_value, 6},
  [589] =
    {field_body, 7, .inherited = true},
    {field_operator, 5},
    {field_parameters, 6},
    {field_type, 2},
  [593] =
    {field_parameters, 5},
    {field_type, 2},
    {field_value, 6},
  [596] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [601] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_returns, 2},
  [605] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_returns, 2},
    {field_type_parameters, 4},
  [610] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
    {field_value, 6},
  [614] =
    {field_body, 10},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
    {field_update, 8},
  [620] =
    {field_body, 9},
    {field_name, 4},
  [622] =
    {field_body, 8, .inherited = true},
    {field_parameters, 7},
    {field_type, 6},
  [625] =
    {field_body, 8, .inherited = true},
    {field_operator, 6},
    {field_parameters, 7},
    {field_type, 2},
  [629] =
    {field_body, 8, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_returns, 2},
    {field_type_parameters, 5},
  [634] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
    {field_value, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_modifier,
  },
  [2] = {
    [0] = alias_sym_element_binding_expression,
  },
  [3] = {
    [0] = alias_sym_implicit_parameter,
  },
  [24] = {
    [2] = alias_sym_element_binding_expression,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_bracketed_argument_list, 2,
    sym_bracketed_argument_list,
    alias_sym_element_binding_expression,
  sym_identifier, 2,
    sym_identifier,
    alias_sym_implicit_parameter,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 8,
  [11] = 8,
  [12] = 8,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 21,
  [24] = 24,
  [25] = 21,
  [26] = 26,
  [27] = 21,
  [28] = 21,
  [29] = 21,
  [30] = 30,
  [31] = 21,
  [32] = 21,
  [33] = 21,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 21,
  [38] = 38,
  [39] = 39,
  [40] = 38,
  [41] = 39,
  [42] = 39,
  [43] = 39,
  [44] = 38,
  [45] = 38,
  [46] = 38,
  [47] = 38,
  [48] = 38,
  [49] = 39,
  [50] = 39,
  [51] = 39,
  [52] = 39,
  [53] = 38,
  [54] = 38,
  [55] = 38,
  [56] = 38,
  [57] = 39,
  [58] = 39,
  [59] = 39,
  [60] = 60,
  [61] = 61,
  [62] = 60,
  [63] = 63,
  [64] = 64,
  [65] = 60,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 64,
  [75] = 75,
  [76] = 67,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 85,
  [87] = 84,
  [88] = 83,
  [89] = 82,
  [90] = 81,
  [91] = 80,
  [92] = 75,
  [93] = 73,
  [94] = 72,
  [95] = 70,
  [96] = 69,
  [97] = 60,
  [98] = 85,
  [99] = 68,
  [100] = 66,
  [101] = 101,
  [102] = 71,
  [103] = 79,
  [104] = 78,
  [105] = 67,
  [106] = 77,
  [107] = 107,
  [108] = 84,
  [109] = 64,
  [110] = 71,
  [111] = 77,
  [112] = 112,
  [113] = 113,
  [114] = 112,
  [115] = 113,
  [116] = 116,
  [117] = 116,
  [118] = 83,
  [119] = 119,
  [120] = 112,
  [121] = 119,
  [122] = 113,
  [123] = 82,
  [124] = 119,
  [125] = 125,
  [126] = 78,
  [127] = 81,
  [128] = 128,
  [129] = 129,
  [130] = 80,
  [131] = 116,
  [132] = 70,
  [133] = 129,
  [134] = 107,
  [135] = 101,
  [136] = 69,
  [137] = 79,
  [138] = 128,
  [139] = 68,
  [140] = 125,
  [141] = 61,
  [142] = 61,
  [143] = 129,
  [144] = 125,
  [145] = 63,
  [146] = 66,
  [147] = 107,
  [148] = 80,
  [149] = 79,
  [150] = 63,
  [151] = 128,
  [152] = 101,
  [153] = 78,
  [154] = 101,
  [155] = 67,
  [156] = 72,
  [157] = 107,
  [158] = 61,
  [159] = 125,
  [160] = 129,
  [161] = 128,
  [162] = 64,
  [163] = 63,
  [164] = 116,
  [165] = 75,
  [166] = 113,
  [167] = 112,
  [168] = 77,
  [169] = 71,
  [170] = 73,
  [171] = 66,
  [172] = 68,
  [173] = 69,
  [174] = 70,
  [175] = 81,
  [176] = 72,
  [177] = 73,
  [178] = 75,
  [179] = 119,
  [180] = 82,
  [181] = 85,
  [182] = 84,
  [183] = 83,
  [184] = 184,
  [185] = 185,
  [186] = 184,
  [187] = 184,
  [188] = 184,
  [189] = 184,
  [190] = 185,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 193,
  [195] = 193,
  [196] = 193,
  [197] = 193,
  [198] = 193,
  [199] = 193,
  [200] = 193,
  [201] = 193,
  [202] = 193,
  [203] = 193,
  [204] = 193,
  [205] = 193,
  [206] = 193,
  [207] = 193,
  [208] = 193,
  [209] = 193,
  [210] = 193,
  [211] = 193,
  [212] = 193,
  [213] = 193,
  [214] = 193,
  [215] = 193,
  [216] = 193,
  [217] = 193,
  [218] = 193,
  [219] = 193,
  [220] = 193,
  [221] = 193,
  [222] = 191,
  [223] = 223,
  [224] = 192,
  [225] = 223,
  [226] = 192,
  [227] = 191,
  [228] = 192,
  [229] = 191,
  [230] = 192,
  [231] = 191,
  [232] = 192,
  [233] = 191,
  [234] = 192,
  [235] = 191,
  [236] = 191,
  [237] = 192,
  [238] = 192,
  [239] = 191,
  [240] = 191,
  [241] = 191,
  [242] = 192,
  [243] = 191,
  [244] = 192,
  [245] = 192,
  [246] = 192,
  [247] = 191,
  [248] = 192,
  [249] = 249,
  [250] = 192,
  [251] = 191,
  [252] = 192,
  [253] = 249,
  [254] = 249,
  [255] = 191,
  [256] = 192,
  [257] = 191,
  [258] = 192,
  [259] = 192,
  [260] = 191,
  [261] = 192,
  [262] = 191,
  [263] = 192,
  [264] = 191,
  [265] = 191,
  [266] = 191,
  [267] = 191,
  [268] = 192,
  [269] = 191,
  [270] = 192,
  [271] = 191,
  [272] = 191,
  [273] = 191,
  [274] = 192,
  [275] = 249,
  [276] = 249,
  [277] = 192,
  [278] = 192,
  [279] = 191,
  [280] = 192,
  [281] = 192,
  [282] = 191,
  [283] = 191,
  [284] = 191,
  [285] = 192,
  [286] = 286,
  [287] = 192,
  [288] = 191,
  [289] = 191,
  [290] = 191,
  [291] = 192,
  [292] = 191,
  [293] = 192,
  [294] = 192,
  [295] = 192,
  [296] = 191,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 297,
  [301] = 297,
  [302] = 192,
  [303] = 298,
  [304] = 304,
  [305] = 192,
  [306] = 304,
  [307] = 298,
  [308] = 191,
  [309] = 191,
  [310] = 297,
  [311] = 192,
  [312] = 191,
  [313] = 192,
  [314] = 304,
  [315] = 298,
  [316] = 304,
  [317] = 192,
  [318] = 304,
  [319] = 192,
  [320] = 320,
  [321] = 191,
  [322] = 320,
  [323] = 191,
  [324] = 304,
  [325] = 192,
  [326] = 192,
  [327] = 327,
  [328] = 328,
  [329] = 191,
  [330] = 191,
  [331] = 192,
  [332] = 192,
  [333] = 328,
  [334] = 328,
  [335] = 192,
  [336] = 192,
  [337] = 337,
  [338] = 191,
  [339] = 191,
  [340] = 328,
  [341] = 191,
  [342] = 191,
  [343] = 343,
  [344] = 343,
  [345] = 328,
  [346] = 343,
  [347] = 343,
  [348] = 343,
  [349] = 327,
  [350] = 192,
  [351] = 191,
  [352] = 337,
  [353] = 343,
  [354] = 192,
  [355] = 191,
  [356] = 328,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 359,
  [362] = 359,
  [363] = 360,
  [364] = 358,
  [365] = 357,
  [366] = 359,
  [367] = 357,
  [368] = 359,
  [369] = 357,
  [370] = 360,
  [371] = 357,
  [372] = 360,
  [373] = 373,
  [374] = 360,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 375,
  [379] = 376,
  [380] = 380,
  [381] = 376,
  [382] = 382,
  [383] = 382,
  [384] = 384,
  [385] = 375,
  [386] = 380,
  [387] = 376,
  [388] = 382,
  [389] = 375,
  [390] = 375,
  [391] = 375,
  [392] = 375,
  [393] = 382,
  [394] = 380,
  [395] = 376,
  [396] = 376,
  [397] = 380,
  [398] = 382,
  [399] = 375,
  [400] = 375,
  [401] = 375,
  [402] = 384,
  [403] = 375,
  [404] = 382,
  [405] = 376,
  [406] = 375,
  [407] = 382,
  [408] = 382,
  [409] = 380,
  [410] = 376,
  [411] = 382,
  [412] = 376,
  [413] = 380,
  [414] = 382,
  [415] = 376,
  [416] = 376,
  [417] = 376,
  [418] = 382,
  [419] = 380,
  [420] = 376,
  [421] = 382,
  [422] = 382,
  [423] = 380,
  [424] = 380,
  [425] = 382,
  [426] = 376,
  [427] = 380,
  [428] = 375,
  [429] = 375,
  [430] = 375,
  [431] = 375,
  [432] = 375,
  [433] = 380,
  [434] = 380,
  [435] = 375,
  [436] = 382,
  [437] = 375,
  [438] = 375,
  [439] = 376,
  [440] = 380,
  [441] = 382,
  [442] = 376,
  [443] = 375,
  [444] = 380,
  [445] = 376,
  [446] = 382,
  [447] = 380,
  [448] = 376,
  [449] = 375,
  [450] = 375,
  [451] = 375,
  [452] = 375,
  [453] = 375,
  [454] = 375,
  [455] = 375,
  [456] = 382,
  [457] = 380,
  [458] = 375,
  [459] = 380,
  [460] = 376,
  [461] = 382,
  [462] = 375,
  [463] = 375,
  [464] = 375,
  [465] = 382,
  [466] = 375,
  [467] = 375,
  [468] = 376,
  [469] = 380,
  [470] = 376,
  [471] = 375,
  [472] = 382,
  [473] = 375,
  [474] = 380,
  [475] = 380,
  [476] = 376,
  [477] = 380,
  [478] = 382,
  [479] = 375,
  [480] = 375,
  [481] = 382,
  [482] = 375,
  [483] = 375,
  [484] = 380,
  [485] = 382,
  [486] = 375,
  [487] = 380,
  [488] = 376,
  [489] = 382,
  [490] = 382,
  [491] = 380,
  [492] = 375,
  [493] = 382,
  [494] = 375,
  [495] = 380,
  [496] = 375,
  [497] = 376,
  [498] = 375,
  [499] = 376,
  [500] = 380,
  [501] = 376,
  [502] = 382,
  [503] = 503,
  [504] = 375,
  [505] = 382,
  [506] = 380,
  [507] = 376,
  [508] = 380,
  [509] = 376,
  [510] = 380,
  [511] = 376,
  [512] = 512,
  [513] = 512,
  [514] = 514,
  [515] = 514,
  [516] = 514,
  [517] = 514,
  [518] = 514,
  [519] = 514,
  [520] = 514,
  [521] = 521,
  [522] = 521,
  [523] = 521,
  [524] = 521,
  [525] = 521,
  [526] = 521,
  [527] = 521,
  [528] = 521,
  [529] = 521,
  [530] = 521,
  [531] = 531,
  [532] = 521,
  [533] = 521,
  [534] = 521,
  [535] = 521,
  [536] = 521,
  [537] = 521,
  [538] = 521,
  [539] = 521,
  [540] = 521,
  [541] = 521,
  [542] = 521,
  [543] = 521,
  [544] = 521,
  [545] = 521,
  [546] = 521,
  [547] = 521,
  [548] = 521,
  [549] = 521,
  [550] = 521,
  [551] = 521,
  [552] = 521,
  [553] = 521,
  [554] = 521,
  [555] = 521,
  [556] = 521,
  [557] = 521,
  [558] = 521,
  [559] = 521,
  [560] = 521,
  [561] = 521,
  [562] = 521,
  [563] = 521,
  [564] = 521,
  [565] = 521,
  [566] = 521,
  [567] = 521,
  [568] = 521,
  [569] = 521,
  [570] = 521,
  [571] = 521,
  [572] = 521,
  [573] = 521,
  [574] = 521,
  [575] = 521,
  [576] = 521,
  [577] = 521,
  [578] = 578,
  [579] = 578,
  [580] = 578,
  [581] = 578,
  [582] = 578,
  [583] = 578,
  [584] = 578,
  [585] = 585,
  [586] = 586,
  [587] = 586,
  [588] = 588,
  [589] = 585,
  [590] = 590,
  [591] = 586,
  [592] = 585,
  [593] = 590,
  [594] = 594,
  [595] = 594,
  [596] = 586,
  [597] = 586,
  [598] = 585,
  [599] = 594,
  [600] = 586,
  [601] = 590,
  [602] = 590,
  [603] = 585,
  [604] = 594,
  [605] = 590,
  [606] = 594,
  [607] = 590,
  [608] = 594,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 610,
  [613] = 609,
  [614] = 614,
  [615] = 610,
  [616] = 610,
  [617] = 617,
  [618] = 609,
  [619] = 609,
  [620] = 610,
  [621] = 614,
  [622] = 610,
  [623] = 611,
  [624] = 624,
  [625] = 625,
  [626] = 625,
  [627] = 624,
  [628] = 624,
  [629] = 625,
  [630] = 625,
  [631] = 624,
  [632] = 625,
  [633] = 633,
  [634] = 625,
  [635] = 624,
  [636] = 625,
  [637] = 637,
  [638] = 625,
  [639] = 624,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 640,
  [644] = 640,
  [645] = 645,
  [646] = 646,
  [647] = 640,
  [648] = 640,
  [649] = 649,
  [650] = 646,
  [651] = 640,
  [652] = 652,
  [653] = 640,
  [654] = 640,
  [655] = 642,
  [656] = 640,
  [657] = 657,
  [658] = 658,
  [659] = 657,
  [660] = 640,
  [661] = 640,
  [662] = 640,
  [663] = 663,
  [664] = 640,
  [665] = 663,
  [666] = 640,
  [667] = 657,
  [668] = 649,
  [669] = 657,
  [670] = 649,
  [671] = 640,
  [672] = 640,
  [673] = 645,
  [674] = 640,
  [675] = 649,
  [676] = 640,
  [677] = 663,
  [678] = 652,
  [679] = 640,
  [680] = 640,
  [681] = 640,
  [682] = 640,
  [683] = 640,
  [684] = 640,
  [685] = 685,
  [686] = 640,
  [687] = 640,
  [688] = 640,
  [689] = 652,
  [690] = 663,
  [691] = 658,
  [692] = 652,
  [693] = 640,
  [694] = 640,
  [695] = 646,
  [696] = 640,
  [697] = 640,
  [698] = 658,
  [699] = 640,
  [700] = 663,
  [701] = 652,
  [702] = 642,
  [703] = 640,
  [704] = 640,
  [705] = 640,
  [706] = 640,
  [707] = 640,
  [708] = 685,
  [709] = 640,
  [710] = 646,
  [711] = 640,
  [712] = 640,
  [713] = 640,
  [714] = 652,
  [715] = 640,
  [716] = 716,
  [717] = 685,
  [718] = 658,
  [719] = 642,
  [720] = 657,
  [721] = 663,
  [722] = 640,
  [723] = 640,
  [724] = 640,
  [725] = 640,
  [726] = 640,
  [727] = 640,
  [728] = 728,
  [729] = 685,
  [730] = 657,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 731,
  [737] = 735,
  [738] = 738,
  [739] = 734,
  [740] = 740,
  [741] = 732,
  [742] = 742,
  [743] = 731,
  [744] = 744,
  [745] = 738,
  [746] = 744,
  [747] = 734,
  [748] = 740,
  [749] = 731,
  [750] = 744,
  [751] = 732,
  [752] = 740,
  [753] = 738,
  [754] = 732,
  [755] = 731,
  [756] = 735,
  [757] = 734,
  [758] = 735,
  [759] = 744,
  [760] = 744,
  [761] = 735,
  [762] = 733,
  [763] = 734,
  [764] = 735,
  [765] = 734,
  [766] = 734,
  [767] = 731,
  [768] = 735,
  [769] = 769,
  [770] = 731,
  [771] = 731,
  [772] = 744,
  [773] = 740,
  [774] = 731,
  [775] = 775,
  [776] = 734,
  [777] = 735,
  [778] = 738,
  [779] = 731,
  [780] = 740,
  [781] = 738,
  [782] = 740,
  [783] = 732,
  [784] = 732,
  [785] = 738,
  [786] = 740,
  [787] = 732,
  [788] = 744,
  [789] = 744,
  [790] = 744,
  [791] = 791,
  [792] = 738,
  [793] = 744,
  [794] = 734,
  [795] = 744,
  [796] = 796,
  [797] = 732,
  [798] = 735,
  [799] = 735,
  [800] = 740,
  [801] = 801,
  [802] = 735,
  [803] = 738,
  [804] = 738,
  [805] = 805,
  [806] = 731,
  [807] = 740,
  [808] = 731,
  [809] = 732,
  [810] = 735,
  [811] = 738,
  [812] = 738,
  [813] = 734,
  [814] = 801,
  [815] = 738,
  [816] = 796,
  [817] = 740,
  [818] = 734,
  [819] = 805,
  [820] = 732,
  [821] = 735,
  [822] = 734,
  [823] = 740,
  [824] = 824,
  [825] = 825,
  [826] = 732,
  [827] = 744,
  [828] = 731,
  [829] = 738,
  [830] = 740,
  [831] = 744,
  [832] = 744,
  [833] = 732,
  [834] = 744,
  [835] = 735,
  [836] = 744,
  [837] = 734,
  [838] = 734,
  [839] = 735,
  [840] = 731,
  [841] = 734,
  [842] = 734,
  [843] = 738,
  [844] = 740,
  [845] = 735,
  [846] = 732,
  [847] = 744,
  [848] = 744,
  [849] = 735,
  [850] = 732,
  [851] = 731,
  [852] = 734,
  [853] = 738,
  [854] = 740,
  [855] = 732,
  [856] = 801,
  [857] = 735,
  [858] = 732,
  [859] = 731,
  [860] = 744,
  [861] = 738,
  [862] = 733,
  [863] = 731,
  [864] = 734,
  [865] = 740,
  [866] = 866,
  [867] = 867,
  [868] = 735,
  [869] = 732,
  [870] = 731,
  [871] = 744,
  [872] = 732,
  [873] = 740,
  [874] = 874,
  [875] = 744,
  [876] = 731,
  [877] = 738,
  [878] = 738,
  [879] = 740,
  [880] = 732,
  [881] = 744,
  [882] = 731,
  [883] = 740,
  [884] = 738,
  [885] = 740,
  [886] = 732,
  [887] = 732,
  [888] = 744,
  [889] = 731,
  [890] = 744,
  [891] = 734,
  [892] = 735,
  [893] = 744,
  [894] = 744,
  [895] = 731,
  [896] = 738,
  [897] = 744,
  [898] = 740,
  [899] = 899,
  [900] = 900,
  [901] = 732,
  [902] = 732,
  [903] = 732,
  [904] = 769,
  [905] = 734,
  [906] = 744,
  [907] = 735,
  [908] = 735,
  [909] = 731,
  [910] = 738,
  [911] = 911,
  [912] = 740,
  [913] = 744,
  [914] = 734,
  [915] = 735,
  [916] = 791,
  [917] = 731,
  [918] = 738,
  [919] = 740,
  [920] = 732,
  [921] = 744,
  [922] = 744,
  [923] = 735,
  [924] = 866,
  [925] = 866,
  [926] = 744,
  [927] = 734,
  [928] = 911,
  [929] = 911,
  [930] = 738,
  [931] = 744,
  [932] = 740,
  [933] = 732,
  [934] = 740,
  [935] = 740,
  [936] = 738,
  [937] = 738,
  [938] = 744,
  [939] = 734,
  [940] = 738,
  [941] = 744,
  [942] = 734,
  [943] = 943,
  [944] = 796,
  [945] = 740,
  [946] = 744,
  [947] = 734,
  [948] = 734,
  [949] = 735,
  [950] = 738,
  [951] = 735,
  [952] = 911,
  [953] = 900,
  [954] = 731,
  [955] = 899,
  [956] = 731,
  [957] = 738,
  [958] = 805,
  [959] = 740,
  [960] = 732,
  [961] = 744,
  [962] = 775,
  [963] = 744,
  [964] = 744,
  [965] = 733,
  [966] = 738,
  [967] = 731,
  [968] = 735,
  [969] = 744,
  [970] = 731,
  [971] = 971,
  [972] = 735,
  [973] = 866,
  [974] = 738,
  [975] = 744,
  [976] = 734,
  [977] = 734,
  [978] = 740,
  [979] = 740,
  [980] = 734,
  [981] = 769,
  [982] = 732,
  [983] = 911,
  [984] = 744,
  [985] = 734,
  [986] = 775,
  [987] = 744,
  [988] = 732,
  [989] = 735,
  [990] = 731,
  [991] = 734,
  [992] = 744,
  [993] = 744,
  [994] = 734,
  [995] = 805,
  [996] = 735,
  [997] = 732,
  [998] = 735,
  [999] = 775,
  [1000] = 731,
  [1001] = 744,
  [1002] = 769,
  [1003] = 740,
  [1004] = 1004,
  [1005] = 731,
  [1006] = 738,
  [1007] = 738,
  [1008] = 824,
  [1009] = 744,
  [1010] = 1010,
  [1011] = 740,
  [1012] = 734,
  [1013] = 796,
  [1014] = 825,
  [1015] = 731,
  [1016] = 732,
  [1017] = 744,
  [1018] = 744,
  [1019] = 735,
  [1020] = 734,
  [1021] = 744,
  [1022] = 732,
  [1023] = 740,
  [1024] = 744,
  [1025] = 791,
  [1026] = 824,
  [1027] = 801,
  [1028] = 899,
  [1029] = 744,
  [1030] = 825,
  [1031] = 866,
  [1032] = 735,
  [1033] = 732,
  [1034] = 744,
  [1035] = 1035,
  [1036] = 738,
  [1037] = 738,
  [1038] = 740,
  [1039] = 731,
  [1040] = 733,
  [1041] = 825,
  [1042] = 740,
  [1043] = 733,
  [1044] = 738,
  [1045] = 731,
  [1046] = 744,
  [1047] = 867,
  [1048] = 867,
  [1049] = 732,
  [1050] = 731,
  [1051] = 735,
  [1052] = 738,
  [1053] = 740,
  [1054] = 731,
  [1055] = 734,
  [1056] = 731,
  [1057] = 732,
  [1058] = 734,
  [1059] = 824,
  [1060] = 735,
  [1061] = 732,
  [1062] = 740,
  [1063] = 744,
  [1064] = 732,
  [1065] = 738,
  [1066] = 731,
  [1067] = 738,
  [1068] = 744,
  [1069] = 740,
  [1070] = 731,
  [1071] = 732,
  [1072] = 867,
  [1073] = 734,
  [1074] = 734,
  [1075] = 735,
  [1076] = 735,
  [1077] = 735,
  [1078] = 734,
  [1079] = 734,
  [1080] = 731,
  [1081] = 735,
  [1082] = 900,
  [1083] = 738,
  [1084] = 740,
  [1085] = 732,
  [1086] = 744,
  [1087] = 732,
  [1088] = 740,
  [1089] = 738,
  [1090] = 732,
  [1091] = 740,
  [1092] = 731,
  [1093] = 731,
  [1094] = 732,
  [1095] = 734,
  [1096] = 735,
  [1097] = 740,
  [1098] = 734,
  [1099] = 738,
  [1100] = 744,
  [1101] = 731,
  [1102] = 744,
  [1103] = 734,
  [1104] = 735,
  [1105] = 735,
  [1106] = 734,
  [1107] = 731,
  [1108] = 866,
  [1109] = 738,
  [1110] = 740,
  [1111] = 732,
  [1112] = 744,
  [1113] = 744,
  [1114] = 734,
  [1115] = 735,
  [1116] = 732,
  [1117] = 744,
  [1118] = 740,
  [1119] = 731,
  [1120] = 735,
  [1121] = 738,
  [1122] = 738,
  [1123] = 740,
  [1124] = 738,
  [1125] = 740,
  [1126] = 731,
  [1127] = 732,
  [1128] = 900,
  [1129] = 899,
  [1130] = 732,
  [1131] = 791,
  [1132] = 740,
  [1133] = 735,
  [1134] = 744,
  [1135] = 738,
  [1136] = 732,
  [1137] = 735,
  [1138] = 744,
  [1139] = 734,
  [1140] = 731,
  [1141] = 735,
  [1142] = 732,
  [1143] = 734,
  [1144] = 734,
  [1145] = 740,
  [1146] = 738,
  [1147] = 735,
  [1148] = 740,
  [1149] = 731,
  [1150] = 738,
  [1151] = 1151,
  [1152] = 1152,
  [1153] = 1153,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 1159,
  [1160] = 1159,
  [1161] = 1157,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1165,
  [1167] = 1162,
  [1168] = 1168,
  [1169] = 1164,
  [1170] = 1162,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1153,
  [1174] = 1162,
  [1175] = 1154,
  [1176] = 1162,
  [1177] = 1165,
  [1178] = 1178,
  [1179] = 1163,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1151,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1155,
  [1187] = 1187,
  [1188] = 1172,
  [1189] = 1165,
  [1190] = 1190,
  [1191] = 1178,
  [1192] = 1151,
  [1193] = 1185,
  [1194] = 1153,
  [1195] = 1152,
  [1196] = 1187,
  [1197] = 1168,
  [1198] = 1198,
  [1199] = 1155,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1200,
  [1203] = 1187,
  [1204] = 1155,
  [1205] = 1151,
  [1206] = 1200,
  [1207] = 1201,
  [1208] = 1201,
  [1209] = 1190,
  [1210] = 1178,
  [1211] = 1153,
  [1212] = 1168,
  [1213] = 1201,
  [1214] = 1200,
  [1215] = 1187,
  [1216] = 1151,
  [1217] = 1154,
  [1218] = 1155,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1164,
  [1222] = 1154,
  [1223] = 1163,
  [1224] = 1159,
  [1225] = 1157,
  [1226] = 1157,
  [1227] = 1154,
  [1228] = 1159,
  [1229] = 1164,
  [1230] = 1157,
  [1231] = 1151,
  [1232] = 1155,
  [1233] = 1187,
  [1234] = 1200,
  [1235] = 1201,
  [1236] = 1168,
  [1237] = 1153,
  [1238] = 1171,
  [1239] = 1178,
  [1240] = 1190,
  [1241] = 1241,
  [1242] = 1162,
  [1243] = 1165,
  [1244] = 1163,
  [1245] = 1159,
  [1246] = 1165,
  [1247] = 1162,
  [1248] = 1190,
  [1249] = 1164,
  [1250] = 1163,
  [1251] = 1168,
  [1252] = 1164,
  [1253] = 1163,
  [1254] = 1159,
  [1255] = 1159,
  [1256] = 1155,
  [1257] = 1157,
  [1258] = 1152,
  [1259] = 1155,
  [1260] = 1157,
  [1261] = 1162,
  [1262] = 1163,
  [1263] = 1154,
  [1264] = 1151,
  [1265] = 1165,
  [1266] = 1200,
  [1267] = 1165,
  [1268] = 1162,
  [1269] = 1155,
  [1270] = 1163,
  [1271] = 1271,
  [1272] = 1164,
  [1273] = 1171,
  [1274] = 1162,
  [1275] = 1154,
  [1276] = 1168,
  [1277] = 1155,
  [1278] = 1162,
  [1279] = 1164,
  [1280] = 1159,
  [1281] = 1168,
  [1282] = 1165,
  [1283] = 1157,
  [1284] = 1154,
  [1285] = 1151,
  [1286] = 1187,
  [1287] = 1200,
  [1288] = 1201,
  [1289] = 1168,
  [1290] = 1153,
  [1291] = 1178,
  [1292] = 1190,
  [1293] = 1165,
  [1294] = 1190,
  [1295] = 1190,
  [1296] = 1178,
  [1297] = 1178,
  [1298] = 1153,
  [1299] = 1178,
  [1300] = 1168,
  [1301] = 1201,
  [1302] = 1200,
  [1303] = 1190,
  [1304] = 1187,
  [1305] = 1178,
  [1306] = 1153,
  [1307] = 1168,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1151,
  [1311] = 1153,
  [1312] = 1155,
  [1313] = 1168,
  [1314] = 1154,
  [1315] = 1157,
  [1316] = 1159,
  [1317] = 1163,
  [1318] = 1201,
  [1319] = 1319,
  [1320] = 1201,
  [1321] = 1164,
  [1322] = 1200,
  [1323] = 1190,
  [1324] = 1309,
  [1325] = 1163,
  [1326] = 1200,
  [1327] = 1159,
  [1328] = 1187,
  [1329] = 1157,
  [1330] = 1164,
  [1331] = 1331,
  [1332] = 1163,
  [1333] = 1159,
  [1334] = 1154,
  [1335] = 1157,
  [1336] = 1154,
  [1337] = 1151,
  [1338] = 1151,
  [1339] = 1154,
  [1340] = 1187,
  [1341] = 1200,
  [1342] = 1201,
  [1343] = 1168,
  [1344] = 1153,
  [1345] = 1151,
  [1346] = 1178,
  [1347] = 1190,
  [1348] = 1187,
  [1349] = 1200,
  [1350] = 1201,
  [1351] = 1165,
  [1352] = 1162,
  [1353] = 1168,
  [1354] = 1153,
  [1355] = 1178,
  [1356] = 1157,
  [1357] = 1159,
  [1358] = 1164,
  [1359] = 1359,
  [1360] = 1190,
  [1361] = 1155,
  [1362] = 1151,
  [1363] = 1187,
  [1364] = 1151,
  [1365] = 1187,
  [1366] = 1162,
  [1367] = 1165,
  [1368] = 1154,
  [1369] = 1164,
  [1370] = 1187,
  [1371] = 1157,
  [1372] = 1163,
  [1373] = 1159,
  [1374] = 1157,
  [1375] = 1154,
  [1376] = 1163,
  [1377] = 1151,
  [1378] = 1187,
  [1379] = 1379,
  [1380] = 1159,
  [1381] = 1200,
  [1382] = 1153,
  [1383] = 1200,
  [1384] = 1201,
  [1385] = 1168,
  [1386] = 1153,
  [1387] = 1178,
  [1388] = 1152,
  [1389] = 1190,
  [1390] = 1163,
  [1391] = 1164,
  [1392] = 1200,
  [1393] = 1319,
  [1394] = 1164,
  [1395] = 1178,
  [1396] = 1155,
  [1397] = 1165,
  [1398] = 1162,
  [1399] = 1201,
  [1400] = 1190,
  [1401] = 1201,
  [1402] = 1155,
  [1403] = 1187,
  [1404] = 1404,
  [1405] = 1155,
  [1406] = 1152,
  [1407] = 1164,
  [1408] = 1168,
  [1409] = 1409,
  [1410] = 1241,
  [1411] = 1411,
  [1412] = 1151,
  [1413] = 1309,
  [1414] = 1156,
  [1415] = 1201,
  [1416] = 1164,
  [1417] = 1158,
  [1418] = 1319,
  [1419] = 1419,
  [1420] = 1162,
  [1421] = 1241,
  [1422] = 1309,
  [1423] = 1165,
  [1424] = 1153,
  [1425] = 1178,
  [1426] = 1404,
  [1427] = 1154,
  [1428] = 1163,
  [1429] = 1157,
  [1430] = 1153,
  [1431] = 1431,
  [1432] = 1319,
  [1433] = 1241,
  [1434] = 1241,
  [1435] = 1190,
  [1436] = 1165,
  [1437] = 1437,
  [1438] = 1241,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1155,
  [1443] = 1309,
  [1444] = 1163,
  [1445] = 1165,
  [1446] = 1241,
  [1447] = 1162,
  [1448] = 1165,
  [1449] = 1162,
  [1450] = 1178,
  [1451] = 1152,
  [1452] = 1159,
  [1453] = 1155,
  [1454] = 1241,
  [1455] = 1162,
  [1456] = 1456,
  [1457] = 1155,
  [1458] = 1153,
  [1459] = 1159,
  [1460] = 1162,
  [1461] = 1165,
  [1462] = 1152,
  [1463] = 1190,
  [1464] = 1411,
  [1465] = 1190,
  [1466] = 1466,
  [1467] = 1198,
  [1468] = 1157,
  [1469] = 1178,
  [1470] = 1152,
  [1471] = 1152,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1154,
  [1475] = 1190,
  [1476] = 1476,
  [1477] = 1164,
  [1478] = 1163,
  [1479] = 1479,
  [1480] = 1178,
  [1481] = 1163,
  [1482] = 1178,
  [1483] = 1153,
  [1484] = 1484,
  [1485] = 1165,
  [1486] = 1486,
  [1487] = 1162,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1168,
  [1491] = 1201,
  [1492] = 1200,
  [1493] = 1159,
  [1494] = 1164,
  [1495] = 1187,
  [1496] = 1271,
  [1497] = 1497,
  [1498] = 1159,
  [1499] = 1157,
  [1500] = 1153,
  [1501] = 1190,
  [1502] = 1168,
  [1503] = 1151,
  [1504] = 1154,
  [1505] = 1157,
  [1506] = 1190,
  [1507] = 1151,
  [1508] = 1154,
  [1509] = 1157,
  [1510] = 1441,
  [1511] = 1241,
  [1512] = 1201,
  [1513] = 1200,
  [1514] = 1241,
  [1515] = 1159,
  [1516] = 1187,
  [1517] = 1441,
  [1518] = 1241,
  [1519] = 1200,
  [1520] = 1187,
  [1521] = 1241,
  [1522] = 1441,
  [1523] = 1241,
  [1524] = 1441,
  [1525] = 1441,
  [1526] = 1151,
  [1527] = 1241,
  [1528] = 1441,
  [1529] = 1241,
  [1530] = 1168,
  [1531] = 1201,
  [1532] = 1187,
  [1533] = 1441,
  [1534] = 1241,
  [1535] = 1441,
  [1536] = 1201,
  [1537] = 1168,
  [1538] = 1162,
  [1539] = 1241,
  [1540] = 1441,
  [1541] = 1165,
  [1542] = 1154,
  [1543] = 1153,
  [1544] = 1241,
  [1545] = 1441,
  [1546] = 1151,
  [1547] = 1241,
  [1548] = 1441,
  [1549] = 1241,
  [1550] = 1441,
  [1551] = 1241,
  [1552] = 1187,
  [1553] = 1165,
  [1554] = 1441,
  [1555] = 1241,
  [1556] = 1472,
  [1557] = 1190,
  [1558] = 1441,
  [1559] = 1241,
  [1560] = 1163,
  [1561] = 1201,
  [1562] = 1178,
  [1563] = 1153,
  [1564] = 1164,
  [1565] = 1168,
  [1566] = 1201,
  [1567] = 1441,
  [1568] = 1568,
  [1569] = 1200,
  [1570] = 1241,
  [1571] = 1309,
  [1572] = 1200,
  [1573] = 1151,
  [1574] = 1178,
  [1575] = 1178,
  [1576] = 1441,
  [1577] = 1241,
  [1578] = 1153,
  [1579] = 1154,
  [1580] = 1489,
  [1581] = 1441,
  [1582] = 1241,
  [1583] = 1168,
  [1584] = 1488,
  [1585] = 1441,
  [1586] = 1200,
  [1587] = 1241,
  [1588] = 1486,
  [1589] = 1164,
  [1590] = 1484,
  [1591] = 1441,
  [1592] = 1241,
  [1593] = 1155,
  [1594] = 1157,
  [1595] = 1309,
  [1596] = 1441,
  [1597] = 1241,
  [1598] = 1198,
  [1599] = 1201,
  [1600] = 1441,
  [1601] = 1241,
  [1602] = 1159,
  [1603] = 1152,
  [1604] = 1187,
  [1605] = 1151,
  [1606] = 1201,
  [1607] = 1154,
  [1608] = 1441,
  [1609] = 1241,
  [1610] = 1163,
  [1611] = 1479,
  [1612] = 1200,
  [1613] = 1319,
  [1614] = 1614,
  [1615] = 1309,
  [1616] = 1190,
  [1617] = 1168,
  [1618] = 1153,
  [1619] = 1441,
  [1620] = 1157,
  [1621] = 1241,
  [1622] = 1178,
  [1623] = 1473,
  [1624] = 1155,
  [1625] = 1187,
  [1626] = 1159,
  [1627] = 1157,
  [1628] = 1163,
  [1629] = 1319,
  [1630] = 1187,
  [1631] = 1309,
  [1632] = 1154,
  [1633] = 1151,
  [1634] = 1151,
  [1635] = 1164,
  [1636] = 1151,
  [1637] = 1187,
  [1638] = 1159,
  [1639] = 1200,
  [1640] = 1157,
  [1641] = 1201,
  [1642] = 1168,
  [1643] = 1154,
  [1644] = 1441,
  [1645] = 1154,
  [1646] = 1241,
  [1647] = 1151,
  [1648] = 1187,
  [1649] = 1309,
  [1650] = 1200,
  [1651] = 1201,
  [1652] = 1153,
  [1653] = 1168,
  [1654] = 1319,
  [1655] = 1153,
  [1656] = 1178,
  [1657] = 1178,
  [1658] = 1159,
  [1659] = 1319,
  [1660] = 1157,
  [1661] = 1190,
  [1662] = 1190,
  [1663] = 1163,
  [1664] = 1309,
  [1665] = 1241,
  [1666] = 1159,
  [1667] = 1152,
  [1668] = 1190,
  [1669] = 1319,
  [1670] = 1163,
  [1671] = 1319,
  [1672] = 1359,
  [1673] = 1309,
  [1674] = 1241,
  [1675] = 1154,
  [1676] = 1441,
  [1677] = 1241,
  [1678] = 1437,
  [1679] = 1168,
  [1680] = 1680,
  [1681] = 1153,
  [1682] = 1682,
  [1683] = 1441,
  [1684] = 1163,
  [1685] = 1319,
  [1686] = 1157,
  [1687] = 1309,
  [1688] = 1178,
  [1689] = 1165,
  [1690] = 1690,
  [1691] = 1309,
  [1692] = 1162,
  [1693] = 1164,
  [1694] = 1190,
  [1695] = 1164,
  [1696] = 1165,
  [1697] = 1441,
  [1698] = 1241,
  [1699] = 1319,
  [1700] = 1159,
  [1701] = 1241,
  [1702] = 1155,
  [1703] = 1190,
  [1704] = 1441,
  [1705] = 1319,
  [1706] = 1162,
  [1707] = 1164,
  [1708] = 1198,
  [1709] = 1155,
  [1710] = 1152,
  [1711] = 1309,
  [1712] = 1178,
  [1713] = 1241,
  [1714] = 1441,
  [1715] = 1155,
  [1716] = 1441,
  [1717] = 1241,
  [1718] = 1165,
  [1719] = 1162,
  [1720] = 1171,
  [1721] = 1155,
  [1722] = 1152,
  [1723] = 1241,
  [1724] = 1153,
  [1725] = 1164,
  [1726] = 1472,
  [1727] = 1158,
  [1728] = 1156,
  [1729] = 1152,
  [1730] = 1319,
  [1731] = 1163,
  [1732] = 1159,
  [1733] = 1473,
  [1734] = 1157,
  [1735] = 1154,
  [1736] = 1309,
  [1737] = 1331,
  [1738] = 1164,
  [1739] = 1441,
  [1740] = 1151,
  [1741] = 1187,
  [1742] = 1200,
  [1743] = 1404,
  [1744] = 1441,
  [1745] = 1745,
  [1746] = 1201,
  [1747] = 1241,
  [1748] = 1168,
  [1749] = 1153,
  [1750] = 1155,
  [1751] = 1178,
  [1752] = 1190,
  [1753] = 1164,
  [1754] = 1754,
  [1755] = 1163,
  [1756] = 1159,
  [1757] = 1157,
  [1758] = 1155,
  [1759] = 1155,
  [1760] = 1154,
  [1761] = 1163,
  [1762] = 1151,
  [1763] = 1165,
  [1764] = 1187,
  [1765] = 1200,
  [1766] = 1162,
  [1767] = 1163,
  [1768] = 1409,
  [1769] = 1165,
  [1770] = 1162,
  [1771] = 1164,
  [1772] = 1182,
  [1773] = 1168,
  [1774] = 1319,
  [1775] = 1775,
  [1776] = 1159,
  [1777] = 1164,
  [1778] = 1778,
  [1779] = 1157,
  [1780] = 1164,
  [1781] = 1201,
  [1782] = 1159,
  [1783] = 1479,
  [1784] = 1157,
  [1785] = 1154,
  [1786] = 1151,
  [1787] = 1187,
  [1788] = 1200,
  [1789] = 1201,
  [1790] = 1168,
  [1791] = 1155,
  [1792] = 1153,
  [1793] = 1178,
  [1794] = 1190,
  [1795] = 1484,
  [1796] = 1168,
  [1797] = 1153,
  [1798] = 1154,
  [1799] = 1201,
  [1800] = 1309,
  [1801] = 1178,
  [1802] = 1163,
  [1803] = 1319,
  [1804] = 1155,
  [1805] = 1497,
  [1806] = 1152,
  [1807] = 1198,
  [1808] = 1271,
  [1809] = 1162,
  [1810] = 1190,
  [1811] = 1164,
  [1812] = 1165,
  [1813] = 1171,
  [1814] = 1359,
  [1815] = 1163,
  [1816] = 1241,
  [1817] = 1200,
  [1818] = 1171,
  [1819] = 1159,
  [1820] = 1359,
  [1821] = 1157,
  [1822] = 1154,
  [1823] = 1155,
  [1824] = 1198,
  [1825] = 1200,
  [1826] = 1309,
  [1827] = 1151,
  [1828] = 1187,
  [1829] = 1200,
  [1830] = 1187,
  [1831] = 1163,
  [1832] = 1198,
  [1833] = 1198,
  [1834] = 1200,
  [1835] = 1201,
  [1836] = 1159,
  [1837] = 1157,
  [1838] = 1168,
  [1839] = 1198,
  [1840] = 1190,
  [1841] = 1153,
  [1842] = 1154,
  [1843] = 1201,
  [1844] = 1151,
  [1845] = 1178,
  [1846] = 1187,
  [1847] = 1200,
  [1848] = 1201,
  [1849] = 1168,
  [1850] = 1168,
  [1851] = 1153,
  [1852] = 1198,
  [1853] = 1178,
  [1854] = 1152,
  [1855] = 1190,
  [1856] = 1165,
  [1857] = 1153,
  [1858] = 1198,
  [1859] = 1319,
  [1860] = 1190,
  [1861] = 1162,
  [1862] = 1155,
  [1863] = 1165,
  [1864] = 1198,
  [1865] = 1162,
  [1866] = 1152,
  [1867] = 1190,
  [1868] = 1178,
  [1869] = 1178,
  [1870] = 1153,
  [1871] = 1484,
  [1872] = 1441,
  [1873] = 1241,
  [1874] = 1168,
  [1875] = 1201,
  [1876] = 1486,
  [1877] = 1877,
  [1878] = 1200,
  [1879] = 1187,
  [1880] = 1379,
  [1881] = 1151,
  [1882] = 1154,
  [1883] = 1157,
  [1884] = 1159,
  [1885] = 1155,
  [1886] = 1319,
  [1887] = 1198,
  [1888] = 1155,
  [1889] = 1437,
  [1890] = 1155,
  [1891] = 1164,
  [1892] = 1190,
  [1893] = 1163,
  [1894] = 1894,
  [1895] = 1165,
  [1896] = 1489,
  [1897] = 1488,
  [1898] = 1163,
  [1899] = 1163,
  [1900] = 1488,
  [1901] = 1159,
  [1902] = 1165,
  [1903] = 1157,
  [1904] = 1154,
  [1905] = 1486,
  [1906] = 1162,
  [1907] = 1165,
  [1908] = 1151,
  [1909] = 1187,
  [1910] = 1200,
  [1911] = 1164,
  [1912] = 1162,
  [1913] = 1201,
  [1914] = 1159,
  [1915] = 1157,
  [1916] = 1154,
  [1917] = 1917,
  [1918] = 1168,
  [1919] = 1151,
  [1920] = 1153,
  [1921] = 1178,
  [1922] = 1178,
  [1923] = 1187,
  [1924] = 1200,
  [1925] = 1162,
  [1926] = 1153,
  [1927] = 1168,
  [1928] = 1155,
  [1929] = 1201,
  [1930] = 1201,
  [1931] = 1151,
  [1932] = 1201,
  [1933] = 1441,
  [1934] = 1164,
  [1935] = 1201,
  [1936] = 1190,
  [1937] = 1178,
  [1938] = 1198,
  [1939] = 1168,
  [1940] = 1153,
  [1941] = 1168,
  [1942] = 1153,
  [1943] = 1178,
  [1944] = 1241,
  [1945] = 1190,
  [1946] = 1201,
  [1947] = 1200,
  [1948] = 1155,
  [1949] = 1162,
  [1950] = 1165,
  [1951] = 1200,
  [1952] = 1187,
  [1953] = 1151,
  [1954] = 1954,
  [1955] = 1319,
  [1956] = 1155,
  [1957] = 1190,
  [1958] = 1479,
  [1959] = 1154,
  [1960] = 1164,
  [1961] = 1165,
  [1962] = 1165,
  [1963] = 1162,
  [1964] = 1152,
  [1965] = 1157,
  [1966] = 1162,
  [1967] = 1163,
  [1968] = 1159,
  [1969] = 1190,
  [1970] = 1164,
  [1971] = 1198,
  [1972] = 1159,
  [1973] = 1162,
  [1974] = 1165,
  [1975] = 1473,
  [1976] = 1157,
  [1977] = 1163,
  [1978] = 1178,
  [1979] = 1472,
  [1980] = 1309,
  [1981] = 1419,
  [1982] = 1163,
  [1983] = 1153,
  [1984] = 1984,
  [1985] = 1168,
  [1986] = 1489,
  [1987] = 1154,
  [1988] = 1155,
  [1989] = 1159,
  [1990] = 1157,
  [1991] = 1184,
  [1992] = 1154,
  [1993] = 1151,
  [1994] = 1201,
  [1995] = 1164,
  [1996] = 1200,
  [1997] = 1187,
  [1998] = 1151,
  [1999] = 1151,
  [2000] = 1154,
  [2001] = 1157,
  [2002] = 1159,
  [2003] = 1151,
  [2004] = 1187,
  [2005] = 1163,
  [2006] = 1187,
  [2007] = 1200,
  [2008] = 1201,
  [2009] = 1168,
  [2010] = 2010,
  [2011] = 1152,
  [2012] = 1164,
  [2013] = 1155,
  [2014] = 1153,
  [2015] = 1159,
  [2016] = 1178,
  [2017] = 1163,
  [2018] = 1157,
  [2019] = 1154,
  [2020] = 1190,
  [2021] = 1151,
  [2022] = 1152,
  [2023] = 1151,
  [2024] = 1187,
  [2025] = 1154,
  [2026] = 2026,
  [2027] = 1152,
  [2028] = 1164,
  [2029] = 1155,
  [2030] = 1154,
  [2031] = 1164,
  [2032] = 1190,
  [2033] = 1178,
  [2034] = 1200,
  [2035] = 1165,
  [2036] = 1162,
  [2037] = 1437,
  [2038] = 1187,
  [2039] = 1163,
  [2040] = 1157,
  [2041] = 1184,
  [2042] = 1159,
  [2043] = 1157,
  [2044] = 1154,
  [2045] = 1200,
  [2046] = 1151,
  [2047] = 1187,
  [2048] = 1241,
  [2049] = 1441,
  [2050] = 1441,
  [2051] = 1200,
  [2052] = 1201,
  [2053] = 1168,
  [2054] = 1153,
  [2055] = 1178,
  [2056] = 1190,
  [2057] = 1198,
  [2058] = 2058,
  [2059] = 1153,
  [2060] = 1168,
  [2061] = 1241,
  [2062] = 1157,
  [2063] = 1201,
  [2064] = 1187,
  [2065] = 1200,
  [2066] = 1187,
  [2067] = 1151,
  [2068] = 1152,
  [2069] = 1473,
  [2070] = 1165,
  [2071] = 1162,
  [2072] = 1154,
  [2073] = 1165,
  [2074] = 1157,
  [2075] = 1168,
  [2076] = 1162,
  [2077] = 1159,
  [2078] = 1159,
  [2079] = 1198,
  [2080] = 1162,
  [2081] = 1165,
  [2082] = 1153,
  [2083] = 1159,
  [2084] = 1164,
  [2085] = 1168,
  [2086] = 1162,
  [2087] = 1178,
  [2088] = 1163,
  [2089] = 1155,
  [2090] = 1159,
  [2091] = 1165,
  [2092] = 1157,
  [2093] = 1190,
  [2094] = 1164,
  [2095] = 1165,
  [2096] = 1154,
  [2097] = 1319,
  [2098] = 1162,
  [2099] = 1163,
  [2100] = 1198,
  [2101] = 1198,
  [2102] = 1187,
  [2103] = 1200,
  [2104] = 1158,
  [2105] = 1201,
  [2106] = 1168,
  [2107] = 1155,
  [2108] = 1155,
  [2109] = 1155,
  [2110] = 1153,
  [2111] = 1164,
  [2112] = 1156,
  [2113] = 1178,
  [2114] = 1404,
  [2115] = 1153,
  [2116] = 1472,
  [2117] = 1155,
  [2118] = 1178,
  [2119] = 1473,
  [2120] = 1190,
  [2121] = 1190,
  [2122] = 1178,
  [2123] = 1153,
  [2124] = 1168,
  [2125] = 1201,
  [2126] = 1200,
  [2127] = 1187,
  [2128] = 1151,
  [2129] = 1155,
  [2130] = 1154,
  [2131] = 1157,
  [2132] = 1159,
  [2133] = 1155,
  [2134] = 1162,
  [2135] = 1152,
  [2136] = 1163,
  [2137] = 1163,
  [2138] = 1309,
  [2139] = 1159,
  [2140] = 1163,
  [2141] = 1157,
  [2142] = 1190,
  [2143] = 1165,
  [2144] = 1489,
  [2145] = 1165,
  [2146] = 1162,
  [2147] = 1164,
  [2148] = 1154,
  [2149] = 1164,
  [2150] = 1165,
  [2151] = 1198,
  [2152] = 1441,
  [2153] = 1241,
  [2154] = 1162,
  [2155] = 1162,
  [2156] = 1163,
  [2157] = 1190,
  [2158] = 1187,
  [2159] = 1159,
  [2160] = 1489,
  [2161] = 1164,
  [2162] = 1271,
  [2163] = 1164,
  [2164] = 1162,
  [2165] = 1165,
  [2166] = 1190,
  [2167] = 1200,
  [2168] = 1178,
  [2169] = 1157,
  [2170] = 1201,
  [2171] = 1152,
  [2172] = 1168,
  [2173] = 1159,
  [2174] = 1153,
  [2175] = 1178,
  [2176] = 1165,
  [2177] = 1190,
  [2178] = 1165,
  [2179] = 1162,
  [2180] = 1153,
  [2181] = 1168,
  [2182] = 1201,
  [2183] = 1178,
  [2184] = 1153,
  [2185] = 1164,
  [2186] = 1154,
  [2187] = 1151,
  [2188] = 1155,
  [2189] = 1151,
  [2190] = 1187,
  [2191] = 1200,
  [2192] = 1201,
  [2193] = 1168,
  [2194] = 1200,
  [2195] = 1472,
  [2196] = 1187,
  [2197] = 1152,
  [2198] = 1151,
  [2199] = 1163,
  [2200] = 1157,
  [2201] = 1154,
  [2202] = 1163,
  [2203] = 1184,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 2204,
  [2207] = 2205,
  [2208] = 2204,
  [2209] = 2205,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2212,
  [2213] = 2210,
  [2214] = 2211,
  [2215] = 2215,
  [2216] = 2216,
  [2217] = 2217,
  [2218] = 2218,
  [2219] = 2219,
  [2220] = 2220,
  [2221] = 2212,
  [2222] = 2222,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2226,
  [2227] = 2227,
  [2228] = 2220,
  [2229] = 2229,
  [2230] = 2230,
  [2231] = 2231,
  [2232] = 2232,
  [2233] = 2233,
  [2234] = 2234,
  [2235] = 2235,
  [2236] = 2236,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2217,
  [2240] = 2240,
  [2241] = 2241,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2245,
  [2246] = 2246,
  [2247] = 2247,
  [2248] = 2248,
  [2249] = 2249,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2254,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2263,
  [2264] = 2264,
  [2265] = 2216,
  [2266] = 2266,
  [2267] = 2267,
  [2268] = 2268,
  [2269] = 2269,
  [2270] = 2270,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2274,
  [2275] = 2275,
  [2276] = 2276,
  [2277] = 2215,
  [2278] = 2278,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 2219,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 2287,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 2290,
  [2291] = 2291,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2297,
  [2298] = 2298,
  [2299] = 2218,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2306,
  [2307] = 2307,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 2326,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 2334,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2337,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2390,
  [2391] = 2391,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 2394,
  [2395] = 2395,
  [2396] = 2396,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 2399,
  [2400] = 2400,
  [2401] = 2401,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2420,
  [2421] = 2421,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2426,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2430,
  [2431] = 2431,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2229,
  [2437] = 2269,
  [2438] = 2282,
  [2439] = 2279,
  [2440] = 2288,
  [2441] = 2278,
  [2442] = 2251,
  [2443] = 2276,
  [2444] = 2248,
  [2445] = 2275,
  [2446] = 2249,
  [2447] = 2232,
  [2448] = 2301,
  [2449] = 2304,
  [2450] = 2307,
  [2451] = 2297,
  [2452] = 2306,
  [2453] = 2263,
  [2454] = 2250,
  [2455] = 2271,
  [2456] = 2456,
  [2457] = 2246,
  [2458] = 2238,
  [2459] = 2274,
  [2460] = 2243,
  [2461] = 2236,
  [2462] = 2252,
  [2463] = 2272,
  [2464] = 2291,
  [2465] = 2222,
  [2466] = 2253,
  [2467] = 2280,
  [2468] = 2285,
  [2469] = 2235,
  [2470] = 2264,
  [2471] = 2283,
  [2472] = 2300,
  [2473] = 2256,
  [2474] = 2287,
  [2475] = 2284,
  [2476] = 2290,
  [2477] = 2292,
  [2478] = 2303,
  [2479] = 2245,
  [2480] = 2293,
  [2481] = 2266,
  [2482] = 2296,
  [2483] = 2298,
  [2484] = 2295,
  [2485] = 2286,
  [2486] = 2273,
  [2487] = 2294,
  [2488] = 2240,
  [2489] = 2223,
  [2490] = 2262,
  [2491] = 2225,
  [2492] = 2257,
  [2493] = 2260,
  [2494] = 2267,
  [2495] = 2255,
  [2496] = 2254,
  [2497] = 2227,
  [2498] = 2244,
  [2499] = 2210,
  [2500] = 2234,
  [2501] = 2233,
  [2502] = 2237,
  [2503] = 2231,
  [2504] = 2261,
  [2505] = 2230,
  [2506] = 2302,
  [2507] = 2258,
  [2508] = 2226,
  [2509] = 2247,
  [2510] = 2211,
  [2511] = 2242,
  [2512] = 2259,
  [2513] = 2224,
  [2514] = 2289,
  [2515] = 2311,
  [2516] = 2320,
  [2517] = 2354,
  [2518] = 2353,
  [2519] = 2347,
  [2520] = 2346,
  [2521] = 2334,
  [2522] = 2357,
  [2523] = 2332,
  [2524] = 2390,
  [2525] = 2337,
  [2526] = 2359,
  [2527] = 2363,
  [2528] = 2365,
  [2529] = 2366,
  [2530] = 2342,
  [2531] = 2367,
  [2532] = 2341,
  [2533] = 2372,
  [2534] = 2373,
  [2535] = 2340,
  [2536] = 2383,
  [2537] = 2384,
  [2538] = 2338,
  [2539] = 2336,
  [2540] = 2356,
  [2541] = 2362,
  [2542] = 2386,
  [2543] = 2389,
  [2544] = 2544,
  [2545] = 2333,
  [2546] = 2368,
  [2547] = 2399,
  [2548] = 2548,
  [2549] = 2361,
  [2550] = 2550,
  [2551] = 2352,
  [2552] = 2407,
  [2553] = 2396,
  [2554] = 2329,
  [2555] = 2394,
  [2556] = 2309,
  [2557] = 2557,
  [2558] = 2398,
  [2559] = 2364,
  [2560] = 2317,
  [2561] = 2313,
  [2562] = 2409,
  [2563] = 2360,
  [2564] = 2411,
  [2565] = 2412,
  [2566] = 2416,
  [2567] = 2312,
  [2568] = 2421,
  [2569] = 2422,
  [2570] = 2319,
  [2571] = 2318,
  [2572] = 2315,
  [2573] = 2314,
  [2574] = 2425,
  [2575] = 2428,
  [2576] = 2323,
  [2577] = 2324,
  [2578] = 2434,
  [2579] = 2435,
  [2580] = 2325,
  [2581] = 2358,
  [2582] = 2351,
  [2583] = 2377,
  [2584] = 2350,
  [2585] = 2355,
  [2586] = 2385,
  [2587] = 2433,
  [2588] = 2432,
  [2589] = 2431,
  [2590] = 2430,
  [2591] = 2427,
  [2592] = 2426,
  [2593] = 2417,
  [2594] = 2393,
  [2595] = 2404,
  [2596] = 2415,
  [2597] = 2414,
  [2598] = 2413,
  [2599] = 2322,
  [2600] = 2369,
  [2601] = 2392,
  [2602] = 2344,
  [2603] = 2391,
  [2604] = 2339,
  [2605] = 2310,
  [2606] = 2327,
  [2607] = 2371,
  [2608] = 2397,
  [2609] = 2212,
  [2610] = 2321,
  [2611] = 2328,
  [2612] = 2330,
  [2613] = 2331,
  [2614] = 2349,
  [2615] = 2418,
  [2616] = 2419,
  [2617] = 2374,
  [2618] = 2378,
  [2619] = 2379,
  [2620] = 2370,
  [2621] = 2308,
  [2622] = 2420,
  [2623] = 2380,
  [2624] = 2381,
  [2625] = 2400,
  [2626] = 2405,
  [2627] = 2406,
  [2628] = 2408,
  [2629] = 2410,
  [2630] = 2429,
  [2631] = 2345,
  [2632] = 2343,
  [2633] = 2375,
  [2634] = 2348,
  [2635] = 2316,
  [2636] = 2335,
  [2637] = 2402,
  [2638] = 2403,
  [2639] = 2401,
  [2640] = 2395,
  [2641] = 2388,
  [2642] = 2387,
  [2643] = 2376,
  [2644] = 2424,
  [2645] = 2645,
  [2646] = 2646,
  [2647] = 2647,
  [2648] = 2648,
  [2649] = 2217,
  [2650] = 2215,
  [2651] = 2219,
  [2652] = 2216,
  [2653] = 2220,
  [2654] = 2218,
  [2655] = 2655,
  [2656] = 2256,
  [2657] = 2232,
  [2658] = 2273,
  [2659] = 2269,
  [2660] = 2267,
  [2661] = 2266,
  [2662] = 2224,
  [2663] = 2264,
  [2664] = 2283,
  [2665] = 2298,
  [2666] = 2261,
  [2667] = 2259,
  [2668] = 2285,
  [2669] = 2280,
  [2670] = 2274,
  [2671] = 2304,
  [2672] = 2300,
  [2673] = 2258,
  [2674] = 2257,
  [2675] = 2282,
  [2676] = 2296,
  [2677] = 2291,
  [2678] = 2295,
  [2679] = 2294,
  [2680] = 2301,
  [2681] = 2251,
  [2682] = 2272,
  [2683] = 2244,
  [2684] = 2286,
  [2685] = 2243,
  [2686] = 2293,
  [2687] = 2297,
  [2688] = 2292,
  [2689] = 2238,
  [2690] = 2235,
  [2691] = 2222,
  [2692] = 2229,
  [2693] = 2288,
  [2694] = 2287,
  [2695] = 2227,
  [2696] = 2263,
  [2697] = 2289,
  [2698] = 2226,
  [2699] = 2230,
  [2700] = 2284,
  [2701] = 2236,
  [2702] = 2307,
  [2703] = 2253,
  [2704] = 2231,
  [2705] = 2306,
  [2706] = 2303,
  [2707] = 2302,
  [2708] = 2252,
  [2709] = 2290,
  [2710] = 2225,
  [2711] = 2279,
  [2712] = 2278,
  [2713] = 2276,
  [2714] = 2250,
  [2715] = 2249,
  [2716] = 2275,
  [2717] = 2271,
  [2718] = 2223,
  [2719] = 2262,
  [2720] = 2248,
  [2721] = 2247,
  [2722] = 2260,
  [2723] = 2255,
  [2724] = 2254,
  [2725] = 2234,
  [2726] = 2246,
  [2727] = 2245,
  [2728] = 2242,
  [2729] = 2240,
  [2730] = 2237,
  [2731] = 2233,
  [2732] = 2655,
  [2733] = 2733,
  [2734] = 2456,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2736,
  [2738] = 2736,
  [2739] = 2739,
  [2740] = 2736,
  [2741] = 2736,
  [2742] = 2736,
  [2743] = 2739,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2736,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2736,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2753,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2758,
  [2760] = 2758,
  [2761] = 2758,
  [2762] = 2762,
  [2763] = 2762,
  [2764] = 2739,
  [2765] = 2754,
  [2766] = 2757,
  [2767] = 2739,
  [2768] = 2758,
  [2769] = 2758,
  [2770] = 2739,
  [2771] = 2736,
  [2772] = 2757,
  [2773] = 2736,
  [2774] = 2739,
  [2775] = 2754,
  [2776] = 2739,
  [2777] = 2739,
  [2778] = 2753,
  [2779] = 2736,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2736,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2739,
  [2786] = 2754,
  [2787] = 2787,
  [2788] = 2753,
  [2789] = 2757,
  [2790] = 2739,
  [2791] = 2791,
  [2792] = 2758,
  [2793] = 2739,
  [2794] = 2739,
  [2795] = 2739,
  [2796] = 2762,
  [2797] = 2744,
  [2798] = 2758,
  [2799] = 2745,
  [2800] = 2800,
  [2801] = 2754,
  [2802] = 2802,
  [2803] = 2800,
  [2804] = 2757,
  [2805] = 2736,
  [2806] = 2762,
  [2807] = 2800,
  [2808] = 2800,
  [2809] = 2802,
  [2810] = 2755,
  [2811] = 2753,
  [2812] = 2812,
  [2813] = 2757,
  [2814] = 2814,
  [2815] = 2753,
  [2816] = 2812,
  [2817] = 2745,
  [2818] = 2744,
  [2819] = 2762,
  [2820] = 2814,
  [2821] = 2757,
  [2822] = 2758,
  [2823] = 2754,
  [2824] = 2747,
  [2825] = 2744,
  [2826] = 2762,
  [2827] = 2827,
  [2828] = 2758,
  [2829] = 2745,
  [2830] = 2752,
  [2831] = 2748,
  [2832] = 2832,
  [2833] = 2749,
  [2834] = 2834,
  [2835] = 2757,
  [2836] = 2753,
  [2837] = 2753,
  [2838] = 2758,
  [2839] = 2757,
  [2840] = 2758,
  [2841] = 2758,
  [2842] = 2842,
  [2843] = 2751,
  [2844] = 2762,
  [2845] = 2754,
  [2846] = 2754,
  [2847] = 2832,
  [2848] = 2736,
  [2849] = 2758,
  [2850] = 2758,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2842,
  [2854] = 2854,
  [2855] = 2758,
  [2856] = 2827,
  [2857] = 2857,
  [2858] = 2762,
  [2859] = 2762,
  [2860] = 2758,
  [2861] = 2757,
  [2862] = 2754,
  [2863] = 2736,
  [2864] = 2758,
  [2865] = 2762,
  [2866] = 2758,
  [2867] = 2757,
  [2868] = 2868,
  [2869] = 2762,
  [2870] = 2757,
  [2871] = 2814,
  [2872] = 2758,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2762,
  [2876] = 2876,
  [2877] = 2757,
  [2878] = 2814,
  [2879] = 2758,
  [2880] = 2758,
  [2881] = 2881,
  [2882] = 2876,
  [2883] = 2883,
  [2884] = 2884,
  [2885] = 2758,
  [2886] = 2762,
  [2887] = 2757,
  [2888] = 2736,
  [2889] = 2889,
  [2890] = 2758,
  [2891] = 2758,
  [2892] = 2832,
  [2893] = 2758,
  [2894] = 2758,
  [2895] = 2895,
  [2896] = 2762,
  [2897] = 2881,
  [2898] = 2874,
  [2899] = 2868,
  [2900] = 2736,
  [2901] = 2758,
  [2902] = 2757,
  [2903] = 2762,
  [2904] = 2758,
  [2905] = 2758,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2762,
  [2909] = 2909,
  [2910] = 2762,
  [2911] = 2762,
  [2912] = 2758,
  [2913] = 2832,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2762,
  [2917] = 2834,
  [2918] = 2762,
  [2919] = 2758,
  [2920] = 2755,
  [2921] = 2736,
  [2922] = 2922,
  [2923] = 2923,
  [2924] = 2922,
  [2925] = 2744,
  [2926] = 2754,
  [2927] = 2745,
  [2928] = 2928,
  [2929] = 2922,
  [2930] = 2757,
  [2931] = 2758,
  [2932] = 2922,
  [2933] = 2758,
  [2934] = 2736,
  [2935] = 2922,
  [2936] = 2923,
  [2937] = 2736,
  [2938] = 2938,
  [2939] = 2757,
  [2940] = 2758,
  [2941] = 2758,
  [2942] = 2942,
  [2943] = 2757,
  [2944] = 2944,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2757,
  [2948] = 2948,
  [2949] = 2758,
  [2950] = 2950,
  [2951] = 2800,
  [2952] = 2757,
  [2953] = 2758,
  [2954] = 2758,
  [2955] = 2757,
  [2956] = 2956,
  [2957] = 2752,
  [2958] = 2958,
  [2959] = 2959,
  [2960] = 2960,
  [2961] = 2751,
  [2962] = 2800,
  [2963] = 2755,
  [2964] = 2757,
  [2965] = 2758,
  [2966] = 2802,
  [2967] = 2958,
  [2968] = 2749,
  [2969] = 2800,
  [2970] = 2757,
  [2971] = 2971,
  [2972] = 2748,
  [2973] = 2758,
  [2974] = 2974,
  [2975] = 2747,
  [2976] = 2976,
  [2977] = 2757,
  [2978] = 2736,
  [2979] = 2758,
  [2980] = 2980,
  [2981] = 2736,
  [2982] = 2982,
  [2983] = 2802,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2800,
  [2987] = 2960,
  [2988] = 2736,
  [2989] = 2757,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2992,
  [2993] = 2993,
  [2994] = 2994,
  [2995] = 2995,
  [2996] = 2751,
  [2997] = 2736,
  [2998] = 2736,
  [2999] = 2749,
  [3000] = 2993,
  [3001] = 3001,
  [3002] = 2747,
  [3003] = 2748,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 3006,
  [3007] = 2736,
  [3008] = 3008,
  [3009] = 2736,
  [3010] = 2736,
  [3011] = 3011,
  [3012] = 3012,
  [3013] = 2736,
  [3014] = 2736,
  [3015] = 3015,
  [3016] = 3016,
  [3017] = 2993,
  [3018] = 3018,
  [3019] = 2744,
  [3020] = 3020,
  [3021] = 2736,
  [3022] = 2745,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 2752,
  [3026] = 3026,
  [3027] = 2800,
  [3028] = 2800,
  [3029] = 2802,
  [3030] = 2800,
  [3031] = 2800,
  [3032] = 2800,
  [3033] = 2800,
  [3034] = 2802,
  [3035] = 3024,
  [3036] = 2802,
  [3037] = 2800,
  [3038] = 3016,
  [3039] = 2990,
  [3040] = 2802,
  [3041] = 2802,
  [3042] = 2994,
  [3043] = 2800,
  [3044] = 2802,
  [3045] = 2992,
  [3046] = 2802,
  [3047] = 2800,
  [3048] = 2800,
  [3049] = 3015,
  [3050] = 3011,
  [3051] = 2800,
  [3052] = 2802,
  [3053] = 2802,
  [3054] = 2800,
  [3055] = 2800,
  [3056] = 2995,
  [3057] = 2800,
  [3058] = 3020,
  [3059] = 2802,
  [3060] = 2800,
  [3061] = 2800,
  [3062] = 2736,
  [3063] = 2736,
  [3064] = 2842,
  [3065] = 2800,
  [3066] = 2800,
  [3067] = 2802,
  [3068] = 2736,
  [3069] = 2800,
  [3070] = 2736,
  [3071] = 2800,
  [3072] = 2827,
  [3073] = 2800,
  [3074] = 2802,
  [3075] = 2802,
  [3076] = 2802,
  [3077] = 2800,
  [3078] = 2800,
  [3079] = 2802,
  [3080] = 2800,
  [3081] = 2736,
  [3082] = 2800,
  [3083] = 2800,
  [3084] = 2800,
  [3085] = 2802,
  [3086] = 2800,
  [3087] = 2802,
  [3088] = 2827,
  [3089] = 2800,
  [3090] = 2842,
  [3091] = 2736,
  [3092] = 2800,
  [3093] = 2854,
  [3094] = 3094,
  [3095] = 3095,
  [3096] = 3096,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3096,
  [3100] = 2928,
  [3101] = 3101,
  [3102] = 2827,
  [3103] = 3095,
  [3104] = 3097,
  [3105] = 3095,
  [3106] = 3097,
  [3107] = 3094,
  [3108] = 3096,
  [3109] = 3101,
  [3110] = 3097,
  [3111] = 3094,
  [3112] = 3098,
  [3113] = 3101,
  [3114] = 3095,
  [3115] = 3096,
  [3116] = 3101,
  [3117] = 3094,
  [3118] = 2928,
  [3119] = 2842,
  [3120] = 2827,
  [3121] = 2842,
  [3122] = 3122,
  [3123] = 2842,
  [3124] = 3122,
  [3125] = 3122,
  [3126] = 2881,
  [3127] = 2938,
  [3128] = 3122,
  [3129] = 2827,
  [3130] = 2876,
  [3131] = 2868,
  [3132] = 2874,
  [3133] = 2881,
  [3134] = 2876,
  [3135] = 2874,
  [3136] = 2827,
  [3137] = 2827,
  [3138] = 2868,
  [3139] = 2842,
  [3140] = 2842,
  [3141] = 2827,
  [3142] = 2295,
  [3143] = 2827,
  [3144] = 2755,
  [3145] = 2296,
  [3146] = 2842,
  [3147] = 2842,
  [3148] = 2842,
  [3149] = 2842,
  [3150] = 2744,
  [3151] = 2827,
  [3152] = 2938,
  [3153] = 2876,
  [3154] = 3001,
  [3155] = 3006,
  [3156] = 2842,
  [3157] = 2827,
  [3158] = 2842,
  [3159] = 2827,
  [3160] = 2842,
  [3161] = 2842,
  [3162] = 2827,
  [3163] = 2827,
  [3164] = 2868,
  [3165] = 2745,
  [3166] = 2868,
  [3167] = 2874,
  [3168] = 2881,
  [3169] = 2874,
  [3170] = 2237,
  [3171] = 2876,
  [3172] = 2881,
  [3173] = 2827,
  [3174] = 2991,
  [3175] = 2868,
  [3176] = 3026,
  [3177] = 3024,
  [3178] = 2744,
  [3179] = 3012,
  [3180] = 2876,
  [3181] = 3181,
  [3182] = 2993,
  [3183] = 2745,
  [3184] = 2992,
  [3185] = 2971,
  [3186] = 3008,
  [3187] = 2881,
  [3188] = 2874,
  [3189] = 2868,
  [3190] = 2868,
  [3191] = 3191,
  [3192] = 3192,
  [3193] = 2751,
  [3194] = 2876,
  [3195] = 2752,
  [3196] = 3196,
  [3197] = 2994,
  [3198] = 3198,
  [3199] = 3016,
  [3200] = 3015,
  [3201] = 3011,
  [3202] = 2874,
  [3203] = 3203,
  [3204] = 2881,
  [3205] = 2995,
  [3206] = 3206,
  [3207] = 2744,
  [3208] = 2874,
  [3209] = 2881,
  [3210] = 2754,
  [3211] = 3020,
  [3212] = 3212,
  [3213] = 2745,
  [3214] = 3214,
  [3215] = 2747,
  [3216] = 2748,
  [3217] = 2990,
  [3218] = 2745,
  [3219] = 2993,
  [3220] = 2956,
  [3221] = 2749,
  [3222] = 2744,
  [3223] = 2876,
  [3224] = 2991,
  [3225] = 2755,
  [3226] = 2993,
  [3227] = 2755,
  [3228] = 2328,
  [3229] = 2323,
  [3230] = 2984,
  [3231] = 2749,
  [3232] = 2343,
  [3233] = 2876,
  [3234] = 3234,
  [3235] = 2876,
  [3236] = 2345,
  [3237] = 2396,
  [3238] = 2982,
  [3239] = 2407,
  [3240] = 2868,
  [3241] = 2370,
  [3242] = 2874,
  [3243] = 2881,
  [3244] = 2316,
  [3245] = 2393,
  [3246] = 2335,
  [3247] = 2995,
  [3248] = 3248,
  [3249] = 2358,
  [3250] = 2360,
  [3251] = 2361,
  [3252] = 2363,
  [3253] = 2364,
  [3254] = 2976,
  [3255] = 2914,
  [3256] = 2876,
  [3257] = 2950,
  [3258] = 2881,
  [3259] = 2874,
  [3260] = 2752,
  [3261] = 2868,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 2993,
  [3265] = 2744,
  [3266] = 2876,
  [3267] = 2881,
  [3268] = 2745,
  [3269] = 2874,
  [3270] = 2868,
  [3271] = 2868,
  [3272] = 2874,
  [3273] = 2320,
  [3274] = 3274,
  [3275] = 2881,
  [3276] = 2884,
  [3277] = 2974,
  [3278] = 2322,
  [3279] = 3279,
  [3280] = 2321,
  [3281] = 2876,
  [3282] = 3282,
  [3283] = 3283,
  [3284] = 3284,
  [3285] = 3285,
  [3286] = 2909,
  [3287] = 2907,
  [3288] = 2906,
  [3289] = 2881,
  [3290] = 3026,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3293,
  [3294] = 2874,
  [3295] = 3295,
  [3296] = 3296,
  [3297] = 2868,
  [3298] = 2874,
  [3299] = 3299,
  [3300] = 2748,
  [3301] = 2881,
  [3302] = 2424,
  [3303] = 2420,
  [3304] = 2419,
  [3305] = 2418,
  [3306] = 2876,
  [3307] = 2404,
  [3308] = 3308,
  [3309] = 3309,
  [3310] = 2883,
  [3311] = 3311,
  [3312] = 2915,
  [3313] = 2344,
  [3314] = 2751,
  [3315] = 3315,
  [3316] = 3020,
  [3317] = 2348,
  [3318] = 2349,
  [3319] = 2960,
  [3320] = 2351,
  [3321] = 2352,
  [3322] = 2355,
  [3323] = 2356,
  [3324] = 2868,
  [3325] = 2385,
  [3326] = 2874,
  [3327] = 3327,
  [3328] = 2881,
  [3329] = 3329,
  [3330] = 2309,
  [3331] = 2392,
  [3332] = 2377,
  [3333] = 3008,
  [3334] = 2655,
  [3335] = 2876,
  [3336] = 2311,
  [3337] = 2312,
  [3338] = 2313,
  [3339] = 3339,
  [3340] = 2317,
  [3341] = 2985,
  [3342] = 2868,
  [3343] = 2959,
  [3344] = 2391,
  [3345] = 2333,
  [3346] = 2336,
  [3347] = 2338,
  [3348] = 2340,
  [3349] = 3349,
  [3350] = 2747,
  [3351] = 2747,
  [3352] = 2341,
  [3353] = 2342,
  [3354] = 3354,
  [3355] = 2350,
  [3356] = 2748,
  [3357] = 2353,
  [3358] = 2357,
  [3359] = 2359,
  [3360] = 2362,
  [3361] = 2368,
  [3362] = 2895,
  [3363] = 2749,
  [3364] = 2369,
  [3365] = 2371,
  [3366] = 2375,
  [3367] = 2376,
  [3368] = 3368,
  [3369] = 2387,
  [3370] = 2752,
  [3371] = 2751,
  [3372] = 2388,
  [3373] = 2395,
  [3374] = 2401,
  [3375] = 2403,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 2429,
  [3379] = 2410,
  [3380] = 2408,
  [3381] = 2406,
  [3382] = 3382,
  [3383] = 3383,
  [3384] = 2405,
  [3385] = 2400,
  [3386] = 2381,
  [3387] = 3387,
  [3388] = 2380,
  [3389] = 2308,
  [3390] = 2889,
  [3391] = 2379,
  [3392] = 3392,
  [3393] = 2378,
  [3394] = 3394,
  [3395] = 2993,
  [3396] = 2374,
  [3397] = 3397,
  [3398] = 2331,
  [3399] = 2330,
  [3400] = 3400,
  [3401] = 3401,
  [3402] = 3402,
  [3403] = 2327,
  [3404] = 2325,
  [3405] = 2324,
  [3406] = 3406,
  [3407] = 2310,
  [3408] = 2339,
  [3409] = 2314,
  [3410] = 2315,
  [3411] = 2318,
  [3412] = 2960,
  [3413] = 2319,
  [3414] = 3414,
  [3415] = 2332,
  [3416] = 2942,
  [3417] = 3417,
  [3418] = 2334,
  [3419] = 3419,
  [3420] = 2219,
  [3421] = 3421,
  [3422] = 2220,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3425,
  [3426] = 2346,
  [3427] = 3427,
  [3428] = 3428,
  [3429] = 3429,
  [3430] = 3430,
  [3431] = 3431,
  [3432] = 2347,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 2354,
  [3436] = 2365,
  [3437] = 3437,
  [3438] = 3438,
  [3439] = 2366,
  [3440] = 2367,
  [3441] = 2372,
  [3442] = 2992,
  [3443] = 2373,
  [3444] = 3444,
  [3445] = 2383,
  [3446] = 2384,
  [3447] = 2386,
  [3448] = 3448,
  [3449] = 2389,
  [3450] = 2868,
  [3451] = 3024,
  [3452] = 2993,
  [3453] = 2948,
  [3454] = 2394,
  [3455] = 2413,
  [3456] = 3456,
  [3457] = 2946,
  [3458] = 2945,
  [3459] = 2944,
  [3460] = 3460,
  [3461] = 2398,
  [3462] = 2874,
  [3463] = 2409,
  [3464] = 2881,
  [3465] = 2411,
  [3466] = 2412,
  [3467] = 2416,
  [3468] = 3203,
  [3469] = 3469,
  [3470] = 2421,
  [3471] = 3471,
  [3472] = 3012,
  [3473] = 2422,
  [3474] = 2425,
  [3475] = 2434,
  [3476] = 2876,
  [3477] = 2994,
  [3478] = 2435,
  [3479] = 2428,
  [3480] = 2433,
  [3481] = 2432,
  [3482] = 2431,
  [3483] = 3483,
  [3484] = 3484,
  [3485] = 3485,
  [3486] = 2980,
  [3487] = 3487,
  [3488] = 3488,
  [3489] = 3489,
  [3490] = 3490,
  [3491] = 2430,
  [3492] = 3492,
  [3493] = 3493,
  [3494] = 3494,
  [3495] = 3495,
  [3496] = 2427,
  [3497] = 2990,
  [3498] = 3498,
  [3499] = 3499,
  [3500] = 3500,
  [3501] = 2426,
  [3502] = 3502,
  [3503] = 3016,
  [3504] = 2417,
  [3505] = 3505,
  [3506] = 2415,
  [3507] = 2414,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 3510,
  [3511] = 3511,
  [3512] = 3512,
  [3513] = 3513,
  [3514] = 3514,
  [3515] = 3515,
  [3516] = 3015,
  [3517] = 3517,
  [3518] = 3518,
  [3519] = 3011,
  [3520] = 3520,
  [3521] = 3521,
  [3522] = 3522,
  [3523] = 3523,
  [3524] = 3524,
  [3525] = 3525,
  [3526] = 3526,
  [3527] = 3527,
  [3528] = 3528,
  [3529] = 3023,
  [3530] = 3006,
  [3531] = 3004,
  [3532] = 3005,
  [3533] = 3001,
  [3534] = 3018,
  [3535] = 2956,
  [3536] = 2960,
  [3537] = 2993,
  [3538] = 2993,
  [3539] = 2993,
  [3540] = 2971,
  [3541] = 2993,
  [3542] = 2993,
  [3543] = 2993,
  [3544] = 2993,
  [3545] = 3015,
  [3546] = 3020,
  [3547] = 2993,
  [3548] = 2993,
  [3549] = 2220,
  [3550] = 2993,
  [3551] = 2960,
  [3552] = 2993,
  [3553] = 2993,
  [3554] = 2993,
  [3555] = 3001,
  [3556] = 2995,
  [3557] = 2219,
  [3558] = 2990,
  [3559] = 2993,
  [3560] = 3006,
  [3561] = 3561,
  [3562] = 2744,
  [3563] = 2755,
  [3564] = 3564,
  [3565] = 3011,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3568,
  [3569] = 3569,
  [3570] = 3024,
  [3571] = 2745,
  [3572] = 3568,
  [3573] = 3573,
  [3574] = 2991,
  [3575] = 2992,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 2754,
  [3579] = 3016,
  [3580] = 2994,
  [3581] = 3203,
  [3582] = 3008,
  [3583] = 3568,
  [3584] = 3584,
  [3585] = 2748,
  [3586] = 3586,
  [3587] = 2915,
  [3588] = 2751,
  [3589] = 3577,
  [3590] = 2744,
  [3591] = 2752,
  [3592] = 2984,
  [3593] = 2959,
  [3594] = 2745,
  [3595] = 2982,
  [3596] = 2749,
  [3597] = 2976,
  [3598] = 2974,
  [3599] = 2895,
  [3600] = 3600,
  [3601] = 2889,
  [3602] = 2754,
  [3603] = 2938,
  [3604] = 3604,
  [3605] = 3569,
  [3606] = 3606,
  [3607] = 2942,
  [3608] = 2747,
  [3609] = 3609,
  [3610] = 3610,
  [3611] = 2914,
  [3612] = 2755,
  [3613] = 3567,
  [3614] = 2950,
  [3615] = 2884,
  [3616] = 2980,
  [3617] = 3617,
  [3618] = 2909,
  [3619] = 2907,
  [3620] = 2906,
  [3621] = 3621,
  [3622] = 2883,
  [3623] = 3576,
  [3624] = 2946,
  [3625] = 2945,
  [3626] = 2944,
  [3627] = 3627,
  [3628] = 3567,
  [3629] = 2948,
  [3630] = 3630,
  [3631] = 3631,
  [3632] = 3632,
  [3633] = 3633,
  [3634] = 2895,
  [3635] = 3635,
  [3636] = 3636,
  [3637] = 2219,
  [3638] = 2749,
  [3639] = 2974,
  [3640] = 3640,
  [3641] = 2220,
  [3642] = 3642,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 2945,
  [3648] = 2944,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 3651,
  [3652] = 2946,
  [3653] = 2984,
  [3654] = 3654,
  [3655] = 2883,
  [3656] = 3656,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3659,
  [3660] = 2889,
  [3661] = 2976,
  [3662] = 3662,
  [3663] = 3663,
  [3664] = 3664,
  [3665] = 2942,
  [3666] = 3666,
  [3667] = 3667,
  [3668] = 3668,
  [3669] = 3669,
  [3670] = 2948,
  [3671] = 2655,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3675,
  [3676] = 2751,
  [3677] = 3677,
  [3678] = 2747,
  [3679] = 3679,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3684,
  [3685] = 3685,
  [3686] = 2204,
  [3687] = 3687,
  [3688] = 3688,
  [3689] = 3689,
  [3690] = 3690,
  [3691] = 2982,
  [3692] = 3692,
  [3693] = 3693,
  [3694] = 3694,
  [3695] = 2914,
  [3696] = 3567,
  [3697] = 2906,
  [3698] = 3698,
  [3699] = 3699,
  [3700] = 2907,
  [3701] = 2909,
  [3702] = 3702,
  [3703] = 3703,
  [3704] = 2980,
  [3705] = 2884,
  [3706] = 2748,
  [3707] = 3707,
  [3708] = 3708,
  [3709] = 3709,
  [3710] = 2959,
  [3711] = 3711,
  [3712] = 3712,
  [3713] = 3713,
  [3714] = 3714,
  [3715] = 3715,
  [3716] = 3716,
  [3717] = 3717,
  [3718] = 3718,
  [3719] = 2950,
  [3720] = 3720,
  [3721] = 3721,
  [3722] = 3722,
  [3723] = 3723,
  [3724] = 3724,
  [3725] = 2915,
  [3726] = 3726,
  [3727] = 3727,
  [3728] = 2752,
  [3729] = 3729,
  [3730] = 3730,
  [3731] = 3731,
  [3732] = 3721,
  [3733] = 3720,
  [3734] = 3643,
  [3735] = 3708,
  [3736] = 3698,
  [3737] = 3654,
  [3738] = 3722,
  [3739] = 3729,
  [3740] = 3740,
  [3741] = 3699,
  [3742] = 3726,
  [3743] = 3693,
  [3744] = 3687,
  [3745] = 3642,
  [3746] = 3650,
  [3747] = 3635,
  [3748] = 3666,
  [3749] = 3730,
  [3750] = 3649,
  [3751] = 3685,
  [3752] = 3203,
  [3753] = 3658,
  [3754] = 3716,
  [3755] = 3681,
  [3756] = 3631,
  [3757] = 3640,
  [3758] = 3026,
  [3759] = 3672,
  [3760] = 3712,
  [3761] = 3674,
  [3762] = 3762,
  [3763] = 3727,
  [3764] = 3707,
  [3765] = 3669,
  [3766] = 3690,
  [3767] = 3012,
  [3768] = 3673,
  [3769] = 3651,
  [3770] = 3714,
  [3771] = 3662,
  [3772] = 3711,
  [3773] = 3663,
  [3774] = 3633,
  [3775] = 3731,
  [3776] = 3713,
  [3777] = 3567,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3659,
  [3781] = 2204,
  [3782] = 3657,
  [3783] = 3656,
  [3784] = 3784,
  [3785] = 3632,
  [3786] = 3718,
  [3787] = 3567,
  [3788] = 3567,
  [3789] = 3789,
  [3790] = 3679,
  [3791] = 3717,
  [3792] = 3792,
  [3793] = 3675,
  [3794] = 3794,
  [3795] = 3203,
  [3796] = 3567,
  [3797] = 2655,
  [3798] = 3798,
  [3799] = 2990,
  [3800] = 3800,
  [3801] = 3567,
  [3802] = 3802,
  [3803] = 3803,
  [3804] = 2938,
  [3805] = 3561,
  [3806] = 3806,
  [3807] = 3807,
  [3808] = 3569,
  [3809] = 3809,
  [3810] = 3809,
  [3811] = 3809,
  [3812] = 3812,
  [3813] = 3809,
  [3814] = 3809,
  [3815] = 3577,
  [3816] = 3809,
  [3817] = 3809,
  [3818] = 3809,
  [3819] = 3809,
  [3820] = 3584,
  [3821] = 3809,
  [3822] = 3809,
  [3823] = 3809,
  [3824] = 3809,
  [3825] = 3566,
  [3826] = 3809,
  [3827] = 3809,
  [3828] = 3809,
  [3829] = 3809,
  [3830] = 3809,
  [3831] = 2744,
  [3832] = 3809,
  [3833] = 3203,
  [3834] = 3809,
  [3835] = 3809,
  [3836] = 2745,
  [3837] = 3586,
  [3838] = 3567,
  [3839] = 3809,
  [3840] = 3840,
  [3841] = 3809,
  [3842] = 2755,
  [3843] = 3809,
  [3844] = 3844,
  [3845] = 3809,
  [3846] = 3840,
  [3847] = 3809,
  [3848] = 3576,
  [3849] = 3561,
  [3850] = 3809,
  [3851] = 3809,
  [3852] = 3809,
  [3853] = 2755,
  [3854] = 3809,
  [3855] = 3809,
  [3856] = 3809,
  [3857] = 3573,
  [3858] = 3809,
  [3859] = 3809,
  [3860] = 3809,
  [3861] = 3809,
  [3862] = 3809,
  [3863] = 3844,
  [3864] = 3809,
  [3865] = 3809,
  [3866] = 3812,
  [3867] = 3809,
  [3868] = 3809,
  [3869] = 3809,
  [3870] = 3809,
  [3871] = 2754,
  [3872] = 3567,
  [3873] = 3809,
  [3874] = 3567,
  [3875] = 3809,
  [3876] = 3809,
  [3877] = 3809,
  [3878] = 3809,
  [3879] = 2907,
  [3880] = 3577,
  [3881] = 2994,
  [3882] = 2749,
  [3883] = 2974,
  [3884] = 3024,
  [3885] = 3566,
  [3886] = 2745,
  [3887] = 2744,
  [3888] = 2992,
  [3889] = 2976,
  [3890] = 2982,
  [3891] = 3016,
  [3892] = 2751,
  [3893] = 2752,
  [3894] = 2655,
  [3895] = 3567,
  [3896] = 2984,
  [3897] = 2942,
  [3898] = 2749,
  [3899] = 2748,
  [3900] = 3621,
  [3901] = 2755,
  [3902] = 2914,
  [3903] = 3604,
  [3904] = 2915,
  [3905] = 2959,
  [3906] = 2895,
  [3907] = 2950,
  [3908] = 3610,
  [3909] = 2752,
  [3910] = 2754,
  [3911] = 2884,
  [3912] = 2980,
  [3913] = 2747,
  [3914] = 2909,
  [3915] = 3567,
  [3916] = 3569,
  [3917] = 2748,
  [3918] = 2906,
  [3919] = 2889,
  [3920] = 2745,
  [3921] = 2744,
  [3922] = 3026,
  [3923] = 3012,
  [3924] = 3609,
  [3925] = 3610,
  [3926] = 2990,
  [3927] = 3567,
  [3928] = 3015,
  [3929] = 3617,
  [3930] = 2747,
  [3931] = 2944,
  [3932] = 2945,
  [3933] = 2938,
  [3934] = 2946,
  [3935] = 3008,
  [3936] = 2744,
  [3937] = 3203,
  [3938] = 3011,
  [3939] = 3627,
  [3940] = 2883,
  [3941] = 2745,
  [3942] = 3576,
  [3943] = 2751,
  [3944] = 2995,
  [3945] = 3604,
  [3946] = 2991,
  [3947] = 2948,
  [3948] = 3621,
  [3949] = 3573,
  [3950] = 3617,
  [3951] = 3020,
  [3952] = 3627,
  [3953] = 3584,
  [3954] = 2959,
  [3955] = 3693,
  [3956] = 3956,
  [3957] = 2895,
  [3958] = 3669,
  [3959] = 2889,
  [3960] = 2938,
  [3961] = 3961,
  [3962] = 3684,
  [3963] = 3663,
  [3964] = 3721,
  [3965] = 2915,
  [3966] = 3966,
  [3967] = 3687,
  [3968] = 2984,
  [3969] = 2982,
  [3970] = 2976,
  [3971] = 3636,
  [3972] = 3715,
  [3973] = 3658,
  [3974] = 2974,
  [3975] = 3690,
  [3976] = 3702,
  [3977] = 3708,
  [3978] = 3689,
  [3979] = 3716,
  [3980] = 3717,
  [3981] = 3731,
  [3982] = 3730,
  [3983] = 3729,
  [3984] = 3727,
  [3985] = 3609,
  [3986] = 2942,
  [3987] = 3630,
  [3988] = 3726,
  [3989] = 3692,
  [3990] = 2914,
  [3991] = 3667,
  [3992] = 3567,
  [3993] = 3688,
  [3994] = 2950,
  [3995] = 3995,
  [3996] = 3567,
  [3997] = 3997,
  [3998] = 3722,
  [3999] = 3999,
  [4000] = 3682,
  [4001] = 4001,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 2884,
  [4005] = 3567,
  [4006] = 2980,
  [4007] = 2909,
  [4008] = 4008,
  [4009] = 2907,
  [4010] = 2906,
  [4011] = 3720,
  [4012] = 2944,
  [4013] = 2945,
  [4014] = 2946,
  [4015] = 2883,
  [4016] = 3723,
  [4017] = 4017,
  [4018] = 4018,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4021,
  [4022] = 2948,
  [4023] = 3646,
  [4024] = 3644,
  [4025] = 3718,
  [4026] = 3712,
  [4027] = 3672,
  [4028] = 3654,
  [4029] = 2747,
  [4030] = 3707,
  [4031] = 3650,
  [4032] = 3649,
  [4033] = 3681,
  [4034] = 3711,
  [4035] = 3675,
  [4036] = 2748,
  [4037] = 3699,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 3698,
  [4041] = 4041,
  [4042] = 3567,
  [4043] = 3659,
  [4044] = 3640,
  [4045] = 4045,
  [4046] = 3642,
  [4047] = 3666,
  [4048] = 2749,
  [4049] = 3966,
  [4050] = 3679,
  [4051] = 4051,
  [4052] = 3714,
  [4053] = 3713,
  [4054] = 3632,
  [4055] = 4055,
  [4056] = 3586,
  [4057] = 3633,
  [4058] = 4058,
  [4059] = 3630,
  [4060] = 2219,
  [4061] = 3709,
  [4062] = 2220,
  [4063] = 2752,
  [4064] = 2751,
  [4065] = 3703,
  [4066] = 3635,
  [4067] = 3643,
  [4068] = 4068,
  [4069] = 3651,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4072,
  [4073] = 4073,
  [4074] = 3656,
  [4075] = 4075,
  [4076] = 3657,
  [4077] = 3662,
  [4078] = 3673,
  [4079] = 3674,
  [4080] = 3645,
  [4081] = 4081,
  [4082] = 3631,
  [4083] = 2204,
  [4084] = 3956,
  [4085] = 3677,
  [4086] = 3680,
  [4087] = 3636,
  [4088] = 3685,
  [4089] = 3203,
  [4090] = 3646,
  [4091] = 3631,
  [4092] = 4092,
  [4093] = 4093,
  [4094] = 2220,
  [4095] = 2219,
  [4096] = 4092,
  [4097] = 3674,
  [4098] = 4093,
  [4099] = 4092,
  [4100] = 4092,
  [4101] = 4092,
  [4102] = 4001,
  [4103] = 3673,
  [4104] = 4093,
  [4105] = 3662,
  [4106] = 4093,
  [4107] = 3999,
  [4108] = 4093,
  [4109] = 4109,
  [4110] = 3693,
  [4111] = 3657,
  [4112] = 4112,
  [4113] = 3656,
  [4114] = 4092,
  [4115] = 4093,
  [4116] = 4092,
  [4117] = 4117,
  [4118] = 3698,
  [4119] = 4119,
  [4120] = 3687,
  [4121] = 4093,
  [4122] = 4092,
  [4123] = 4093,
  [4124] = 4109,
  [4125] = 3699,
  [4126] = 4126,
  [4127] = 4127,
  [4128] = 4093,
  [4129] = 4093,
  [4130] = 4119,
  [4131] = 3708,
  [4132] = 3651,
  [4133] = 3567,
  [4134] = 3711,
  [4135] = 4092,
  [4136] = 4092,
  [4137] = 2204,
  [4138] = 4093,
  [4139] = 3712,
  [4140] = 4093,
  [4141] = 3567,
  [4142] = 4093,
  [4143] = 3643,
  [4144] = 4092,
  [4145] = 3692,
  [4146] = 4109,
  [4147] = 4093,
  [4148] = 4092,
  [4149] = 4092,
  [4150] = 4092,
  [4151] = 4093,
  [4152] = 4093,
  [4153] = 3635,
  [4154] = 4092,
  [4155] = 3997,
  [4156] = 4092,
  [4157] = 3633,
  [4158] = 4093,
  [4159] = 4092,
  [4160] = 3203,
  [4161] = 4051,
  [4162] = 3995,
  [4163] = 3026,
  [4164] = 4092,
  [4165] = 4041,
  [4166] = 3586,
  [4167] = 4093,
  [4168] = 4092,
  [4169] = 4109,
  [4170] = 4093,
  [4171] = 4109,
  [4172] = 4126,
  [4173] = 4092,
  [4174] = 4127,
  [4175] = 3012,
  [4176] = 4093,
  [4177] = 4093,
  [4178] = 4092,
  [4179] = 4093,
  [4180] = 4119,
  [4181] = 4093,
  [4182] = 3567,
  [4183] = 3632,
  [4184] = 4039,
  [4185] = 4092,
  [4186] = 4093,
  [4187] = 3713,
  [4188] = 3667,
  [4189] = 4038,
  [4190] = 3714,
  [4191] = 3679,
  [4192] = 4093,
  [4193] = 3666,
  [4194] = 4127,
  [4195] = 4019,
  [4196] = 3567,
  [4197] = 4018,
  [4198] = 4017,
  [4199] = 4126,
  [4200] = 4092,
  [4201] = 4008,
  [4202] = 3606,
  [4203] = 4127,
  [4204] = 4092,
  [4205] = 4092,
  [4206] = 4126,
  [4207] = 3720,
  [4208] = 4092,
  [4209] = 4209,
  [4210] = 3690,
  [4211] = 4119,
  [4212] = 3715,
  [4213] = 4055,
  [4214] = 4058,
  [4215] = 4093,
  [4216] = 3642,
  [4217] = 4093,
  [4218] = 4070,
  [4219] = 4068,
  [4220] = 3640,
  [4221] = 4092,
  [4222] = 4093,
  [4223] = 4071,
  [4224] = 4127,
  [4225] = 4109,
  [4226] = 4072,
  [4227] = 4073,
  [4228] = 4092,
  [4229] = 4126,
  [4230] = 4093,
  [4231] = 4119,
  [4232] = 3659,
  [4233] = 3675,
  [4234] = 4127,
  [4235] = 4075,
  [4236] = 4119,
  [4237] = 3644,
  [4238] = 3681,
  [4239] = 3649,
  [4240] = 3650,
  [4241] = 3707,
  [4242] = 3654,
  [4243] = 3672,
  [4244] = 3709,
  [4245] = 3567,
  [4246] = 3567,
  [4247] = 3718,
  [4248] = 3567,
  [4249] = 4093,
  [4250] = 4092,
  [4251] = 4093,
  [4252] = 3702,
  [4253] = 4127,
  [4254] = 3685,
  [4255] = 4092,
  [4256] = 4092,
  [4257] = 4093,
  [4258] = 4126,
  [4259] = 4092,
  [4260] = 3722,
  [4261] = 4092,
  [4262] = 4093,
  [4263] = 3689,
  [4264] = 4092,
  [4265] = 3682,
  [4266] = 4119,
  [4267] = 3677,
  [4268] = 3680,
  [4269] = 3726,
  [4270] = 3567,
  [4271] = 4092,
  [4272] = 4045,
  [4273] = 4092,
  [4274] = 3727,
  [4275] = 2735,
  [4276] = 4092,
  [4277] = 4093,
  [4278] = 3567,
  [4279] = 4093,
  [4280] = 3658,
  [4281] = 4093,
  [4282] = 4092,
  [4283] = 2655,
  [4284] = 4092,
  [4285] = 3730,
  [4286] = 4092,
  [4287] = 4020,
  [4288] = 4093,
  [4289] = 4093,
  [4290] = 3721,
  [4291] = 4109,
  [4292] = 4092,
  [4293] = 3663,
  [4294] = 4093,
  [4295] = 4021,
  [4296] = 4092,
  [4297] = 4126,
  [4298] = 3561,
  [4299] = 3567,
  [4300] = 4093,
  [4301] = 4092,
  [4302] = 4092,
  [4303] = 3703,
  [4304] = 3669,
  [4305] = 4092,
  [4306] = 3729,
  [4307] = 3684,
  [4308] = 4093,
  [4309] = 4093,
  [4310] = 4310,
  [4311] = 4003,
  [4312] = 4092,
  [4313] = 4093,
  [4314] = 4093,
  [4315] = 4093,
  [4316] = 3731,
  [4317] = 4126,
  [4318] = 4093,
  [4319] = 2735,
  [4320] = 4109,
  [4321] = 3717,
  [4322] = 3716,
  [4323] = 4119,
  [4324] = 4092,
  [4325] = 4093,
  [4326] = 4127,
  [4327] = 4092,
  [4328] = 4093,
  [4329] = 4329,
  [4330] = 4330,
  [4331] = 3026,
  [4332] = 3567,
  [4333] = 4333,
  [4334] = 3012,
  [4335] = 3573,
  [4336] = 3566,
  [4337] = 3567,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 3561,
  [4341] = 3567,
  [4342] = 3567,
  [4343] = 3567,
  [4344] = 3567,
  [4345] = 3606,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 3762,
  [4349] = 3567,
  [4350] = 3584,
  [4351] = 2237,
  [4352] = 3567,
  [4353] = 2220,
  [4354] = 2219,
  [4355] = 2736,
  [4356] = 4329,
  [4357] = 2295,
  [4358] = 2296,
  [4359] = 3567,
  [4360] = 4360,
  [4361] = 4361,
  [4362] = 3567,
  [4363] = 4363,
  [4364] = 4346,
  [4365] = 4365,
  [4366] = 4360,
  [4367] = 4367,
  [4368] = 4360,
  [4369] = 4369,
  [4370] = 4360,
  [4371] = 4371,
  [4372] = 3740,
  [4373] = 4360,
  [4374] = 4374,
  [4375] = 3573,
  [4376] = 3812,
  [4377] = 4377,
  [4378] = 3812,
  [4379] = 4379,
  [4380] = 4379,
  [4381] = 4379,
  [4382] = 4346,
  [4383] = 4360,
  [4384] = 4360,
  [4385] = 4385,
  [4386] = 4360,
  [4387] = 3586,
  [4388] = 4360,
  [4389] = 4346,
  [4390] = 4360,
  [4391] = 4391,
  [4392] = 4360,
  [4393] = 4379,
  [4394] = 4394,
  [4395] = 4395,
  [4396] = 4360,
  [4397] = 4397,
  [4398] = 4398,
  [4399] = 4360,
  [4400] = 4360,
  [4401] = 3812,
  [4402] = 4379,
  [4403] = 3778,
  [4404] = 3567,
  [4405] = 4379,
  [4406] = 4360,
  [4407] = 4407,
  [4408] = 4360,
  [4409] = 3577,
  [4410] = 4379,
  [4411] = 4411,
  [4412] = 4360,
  [4413] = 4413,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4416,
  [4417] = 4379,
  [4418] = 4418,
  [4419] = 4346,
  [4420] = 3566,
  [4421] = 4421,
  [4422] = 3569,
  [4423] = 4360,
  [4424] = 4360,
  [4425] = 3567,
  [4426] = 3792,
  [4427] = 4427,
  [4428] = 4360,
  [4429] = 3812,
  [4430] = 3584,
  [4431] = 4379,
  [4432] = 4360,
  [4433] = 3779,
  [4434] = 4434,
  [4435] = 4379,
  [4436] = 3784,
  [4437] = 4360,
  [4438] = 3576,
  [4439] = 4360,
  [4440] = 3567,
  [4441] = 4441,
  [4442] = 4379,
  [4443] = 4360,
  [4444] = 4379,
  [4445] = 4346,
  [4446] = 4360,
  [4447] = 4379,
  [4448] = 4360,
  [4449] = 4379,
  [4450] = 4360,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 3762,
  [4454] = 4346,
  [4455] = 4414,
  [4456] = 4413,
  [4457] = 4369,
  [4458] = 4374,
  [4459] = 4441,
  [4460] = 3617,
  [4461] = 4415,
  [4462] = 4421,
  [4463] = 4451,
  [4464] = 4367,
  [4465] = 4385,
  [4466] = 4398,
  [4467] = 3567,
  [4468] = 4394,
  [4469] = 4394,
  [4470] = 4371,
  [4471] = 4471,
  [4472] = 4385,
  [4473] = 4391,
  [4474] = 4427,
  [4475] = 3609,
  [4476] = 4418,
  [4477] = 4395,
  [4478] = 4416,
  [4479] = 4397,
  [4480] = 3567,
  [4481] = 4363,
  [4482] = 4451,
  [4483] = 4398,
  [4484] = 4411,
  [4485] = 4371,
  [4486] = 4391,
  [4487] = 4487,
  [4488] = 4395,
  [4489] = 4397,
  [4490] = 4490,
  [4491] = 4491,
  [4492] = 4365,
  [4493] = 3610,
  [4494] = 4427,
  [4495] = 4413,
  [4496] = 4496,
  [4497] = 3567,
  [4498] = 4434,
  [4499] = 4363,
  [4500] = 3567,
  [4501] = 4452,
  [4502] = 4070,
  [4503] = 4377,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 3567,
  [4507] = 4407,
  [4508] = 4508,
  [4509] = 4414,
  [4510] = 4415,
  [4511] = 4421,
  [4512] = 3627,
  [4513] = 4471,
  [4514] = 4411,
  [4515] = 3621,
  [4516] = 4516,
  [4517] = 3792,
  [4518] = 4487,
  [4519] = 4487,
  [4520] = 4471,
  [4521] = 4407,
  [4522] = 4522,
  [4523] = 3784,
  [4524] = 4377,
  [4525] = 4434,
  [4526] = 3779,
  [4527] = 4452,
  [4528] = 3806,
  [4529] = 4365,
  [4530] = 3778,
  [4531] = 3802,
  [4532] = 4367,
  [4533] = 4441,
  [4534] = 4369,
  [4535] = 2744,
  [4536] = 4374,
  [4537] = 3604,
  [4538] = 3567,
  [4539] = 3740,
  [4540] = 2745,
  [4541] = 4541,
  [4542] = 3645,
  [4543] = 4068,
  [4544] = 4544,
  [4545] = 4071,
  [4546] = 4544,
  [4547] = 4072,
  [4548] = 2736,
  [4549] = 4073,
  [4550] = 4075,
  [4551] = 4551,
  [4552] = 4552,
  [4553] = 3636,
  [4554] = 4554,
  [4555] = 4045,
  [4556] = 4544,
  [4557] = 4544,
  [4558] = 4552,
  [4559] = 4041,
  [4560] = 4039,
  [4561] = 4038,
  [4562] = 4562,
  [4563] = 4544,
  [4564] = 4554,
  [4565] = 4019,
  [4566] = 4018,
  [4567] = 4017,
  [4568] = 4008,
  [4569] = 4407,
  [4570] = 4377,
  [4571] = 4434,
  [4572] = 4365,
  [4573] = 4367,
  [4574] = 4369,
  [4575] = 4374,
  [4576] = 3692,
  [4577] = 3630,
  [4578] = 4544,
  [4579] = 4544,
  [4580] = 4003,
  [4581] = 4001,
  [4582] = 3999,
  [4583] = 4583,
  [4584] = 4058,
  [4585] = 4544,
  [4586] = 4586,
  [4587] = 4544,
  [4588] = 3667,
  [4589] = 3723,
  [4590] = 3997,
  [4591] = 3995,
  [4592] = 3718,
  [4593] = 4544,
  [4594] = 3966,
  [4595] = 3672,
  [4596] = 4583,
  [4597] = 4544,
  [4598] = 3654,
  [4599] = 3707,
  [4600] = 3650,
  [4601] = 3649,
  [4602] = 3681,
  [4603] = 4544,
  [4604] = 4586,
  [4605] = 3633,
  [4606] = 3675,
  [4607] = 4544,
  [4608] = 3659,
  [4609] = 4418,
  [4610] = 4610,
  [4611] = 3640,
  [4612] = 4554,
  [4613] = 4544,
  [4614] = 4544,
  [4615] = 4491,
  [4616] = 4544,
  [4617] = 3642,
  [4618] = 2938,
  [4619] = 2220,
  [4620] = 3666,
  [4621] = 3679,
  [4622] = 3714,
  [4623] = 3713,
  [4624] = 4544,
  [4625] = 3966,
  [4626] = 4626,
  [4627] = 4544,
  [4628] = 3632,
  [4629] = 4020,
  [4630] = 4021,
  [4631] = 4496,
  [4632] = 4504,
  [4633] = 3635,
  [4634] = 3643,
  [4635] = 4635,
  [4636] = 3651,
  [4637] = 3656,
  [4638] = 4638,
  [4639] = 4051,
  [4640] = 3657,
  [4641] = 3662,
  [4642] = 3673,
  [4643] = 3674,
  [4644] = 3677,
  [4645] = 3680,
  [4646] = 3631,
  [4647] = 3684,
  [4648] = 4505,
  [4649] = 4508,
  [4650] = 3685,
  [4651] = 3687,
  [4652] = 4652,
  [4653] = 3693,
  [4654] = 3698,
  [4655] = 3699,
  [4656] = 3703,
  [4657] = 3709,
  [4658] = 3711,
  [4659] = 3712,
  [4660] = 4416,
  [4661] = 3726,
  [4662] = 3720,
  [4663] = 3722,
  [4664] = 3644,
  [4665] = 3729,
  [4666] = 4666,
  [4667] = 3730,
  [4668] = 3731,
  [4669] = 3717,
  [4670] = 3716,
  [4671] = 4441,
  [4672] = 3715,
  [4673] = 3708,
  [4674] = 4363,
  [4675] = 3702,
  [4676] = 3688,
  [4677] = 3690,
  [4678] = 3689,
  [4679] = 3682,
  [4680] = 3669,
  [4681] = 4544,
  [4682] = 3663,
  [4683] = 3721,
  [4684] = 3727,
  [4685] = 3802,
  [4686] = 3658,
  [4687] = 3646,
  [4688] = 2736,
  [4689] = 3966,
  [4690] = 3966,
  [4691] = 4583,
  [4692] = 3806,
  [4693] = 4081,
  [4694] = 4544,
  [4695] = 2219,
  [4696] = 4544,
  [4697] = 4552,
  [4698] = 4544,
  [4699] = 4586,
  [4700] = 4544,
  [4701] = 4544,
  [4702] = 2204,
  [4703] = 4413,
  [4704] = 4544,
  [4705] = 4414,
  [4706] = 4415,
  [4707] = 4421,
  [4708] = 4586,
  [4709] = 4709,
  [4710] = 4544,
  [4711] = 4544,
  [4712] = 4544,
  [4713] = 4051,
  [4714] = 4397,
  [4715] = 4395,
  [4716] = 4391,
  [4717] = 4544,
  [4718] = 4371,
  [4719] = 4451,
  [4720] = 4586,
  [4721] = 4544,
  [4722] = 4385,
  [4723] = 4544,
  [4724] = 4394,
  [4725] = 4398,
  [4726] = 4427,
  [4727] = 4411,
  [4728] = 4586,
  [4729] = 4729,
  [4730] = 4544,
  [4731] = 4583,
  [4732] = 4544,
  [4733] = 4733,
  [4734] = 4544,
  [4735] = 4586,
  [4736] = 4544,
  [4737] = 4544,
  [4738] = 4544,
  [4739] = 4544,
  [4740] = 4586,
  [4741] = 4055,
  [4742] = 4544,
  [4743] = 4743,
  [4744] = 4744,
  [4745] = 4745,
  [4746] = 4745,
  [4747] = 4434,
  [4748] = 4748,
  [4749] = 4745,
  [4750] = 4748,
  [4751] = 4748,
  [4752] = 4748,
  [4753] = 4748,
  [4754] = 4748,
  [4755] = 4744,
  [4756] = 4391,
  [4757] = 4451,
  [4758] = 4635,
  [4759] = 4395,
  [4760] = 4397,
  [4761] = 4407,
  [4762] = 4377,
  [4763] = 4385,
  [4764] = 4434,
  [4765] = 4365,
  [4766] = 4748,
  [4767] = 4767,
  [4768] = 4768,
  [4769] = 4394,
  [4770] = 4398,
  [4771] = 4051,
  [4772] = 4748,
  [4773] = 4745,
  [4774] = 4774,
  [4775] = 4775,
  [4776] = 4451,
  [4777] = 4748,
  [4778] = 4745,
  [4779] = 4745,
  [4780] = 4051,
  [4781] = 4367,
  [4782] = 4369,
  [4783] = 4745,
  [4784] = 4745,
  [4785] = 4427,
  [4786] = 4374,
  [4787] = 4787,
  [4788] = 4371,
  [4789] = 4745,
  [4790] = 4745,
  [4791] = 4441,
  [4792] = 4745,
  [4793] = 4745,
  [4794] = 4748,
  [4795] = 4377,
  [4796] = 4427,
  [4797] = 4748,
  [4798] = 4745,
  [4799] = 4748,
  [4800] = 4411,
  [4801] = 4801,
  [4802] = 4774,
  [4803] = 4504,
  [4804] = 4496,
  [4805] = 4407,
  [4806] = 4745,
  [4807] = 4391,
  [4808] = 4391,
  [4809] = 4398,
  [4810] = 4395,
  [4811] = 4394,
  [4812] = 4397,
  [4813] = 4371,
  [4814] = 2755,
  [4815] = 4395,
  [4816] = 4363,
  [4817] = 4745,
  [4818] = 4414,
  [4819] = 4421,
  [4820] = 4743,
  [4821] = 4821,
  [4822] = 4745,
  [4823] = 4745,
  [4824] = 4745,
  [4825] = 4801,
  [4826] = 4826,
  [4827] = 4411,
  [4828] = 4745,
  [4829] = 4829,
  [4830] = 3561,
  [4831] = 2754,
  [4832] = 4411,
  [4833] = 4774,
  [4834] = 4748,
  [4835] = 4745,
  [4836] = 4385,
  [4837] = 4666,
  [4838] = 4748,
  [4839] = 4774,
  [4840] = 4767,
  [4841] = 4416,
  [4842] = 4385,
  [4843] = 4748,
  [4844] = 4744,
  [4845] = 4745,
  [4846] = 4846,
  [4847] = 4775,
  [4848] = 2736,
  [4849] = 4421,
  [4850] = 4415,
  [4851] = 4745,
  [4852] = 4748,
  [4853] = 4821,
  [4854] = 4854,
  [4855] = 4413,
  [4856] = 4508,
  [4857] = 4748,
  [4858] = 4394,
  [4859] = 4398,
  [4860] = 4748,
  [4861] = 4505,
  [4862] = 4748,
  [4863] = 4801,
  [4864] = 4451,
  [4865] = 4768,
  [4866] = 4774,
  [4867] = 4427,
  [4868] = 4416,
  [4869] = 4745,
  [4870] = 4745,
  [4871] = 4371,
  [4872] = 4745,
  [4873] = 4745,
  [4874] = 4745,
  [4875] = 4748,
  [4876] = 4748,
  [4877] = 4418,
  [4878] = 4744,
  [4879] = 4363,
  [4880] = 4880,
  [4881] = 4745,
  [4882] = 4745,
  [4883] = 4745,
  [4884] = 4767,
  [4885] = 4748,
  [4886] = 4775,
  [4887] = 4745,
  [4888] = 4666,
  [4889] = 4821,
  [4890] = 4369,
  [4891] = 4367,
  [4892] = 4418,
  [4893] = 4745,
  [4894] = 4415,
  [4895] = 4374,
  [4896] = 4775,
  [4897] = 4452,
  [4898] = 4898,
  [4899] = 4745,
  [4900] = 4491,
  [4901] = 4365,
  [4902] = 4768,
  [4903] = 4748,
  [4904] = 4748,
  [4905] = 4905,
  [4906] = 4744,
  [4907] = 4397,
  [4908] = 4826,
  [4909] = 4745,
  [4910] = 4745,
  [4911] = 4911,
  [4912] = 4363,
  [4913] = 4745,
  [4914] = 4441,
  [4915] = 4748,
  [4916] = 4414,
  [4917] = 4407,
  [4918] = 4377,
  [4919] = 3586,
  [4920] = 4767,
  [4921] = 4775,
  [4922] = 4774,
  [4923] = 4413,
  [4924] = 4767,
  [4925] = 4745,
  [4926] = 4745,
  [4927] = 4441,
  [4928] = 4414,
  [4929] = 4415,
  [4930] = 4635,
  [4931] = 4748,
  [4932] = 4374,
  [4933] = 4369,
  [4934] = 4367,
  [4935] = 4421,
  [4936] = 4745,
  [4937] = 4365,
  [4938] = 4413,
  [4939] = 4434,
  [4940] = 4452,
  [4941] = 3566,
  [4942] = 2736,
  [4943] = 4505,
  [4944] = 4508,
  [4945] = 4413,
  [4946] = 4491,
  [4947] = 4441,
  [4948] = 3573,
  [4949] = 2938,
  [4950] = 4374,
  [4951] = 4369,
  [4952] = 4367,
  [4953] = 4365,
  [4954] = 4434,
  [4955] = 4377,
  [4956] = 4407,
  [4957] = 3026,
  [4958] = 4504,
  [4959] = 4496,
  [4960] = 4504,
  [4961] = 4496,
  [4962] = 4508,
  [4963] = 4491,
  [4964] = 3012,
  [4965] = 4397,
  [4966] = 4395,
  [4967] = 4391,
  [4968] = 4363,
  [4969] = 4371,
  [4970] = 4451,
  [4971] = 4385,
  [4972] = 4414,
  [4973] = 4505,
  [4974] = 4394,
  [4975] = 4398,
  [4976] = 4415,
  [4977] = 4421,
  [4978] = 4411,
  [4979] = 4427,
  [4980] = 3584,
  [4981] = 4070,
  [4982] = 4395,
  [4983] = 4041,
  [4984] = 4018,
  [4985] = 2747,
  [4986] = 4019,
  [4987] = 4039,
  [4988] = 2751,
  [4989] = 4008,
  [4990] = 2974,
  [4991] = 4038,
  [4992] = 4017,
  [4993] = 3995,
  [4994] = 4051,
  [4995] = 4003,
  [4996] = 4001,
  [4997] = 2752,
  [4998] = 3999,
  [4999] = 4416,
  [5000] = 3997,
  [5001] = 4666,
  [5002] = 4374,
  [5003] = 4369,
  [5004] = 4418,
  [5005] = 4367,
  [5006] = 2736,
  [5007] = 4365,
  [5008] = 4058,
  [5009] = 2748,
  [5010] = 4413,
  [5011] = 4434,
  [5012] = 4377,
  [5013] = 4055,
  [5014] = 4068,
  [5015] = 4071,
  [5016] = 4072,
  [5017] = 4073,
  [5018] = 4407,
  [5019] = 4414,
  [5020] = 4415,
  [5021] = 4075,
  [5022] = 4421,
  [5023] = 4635,
  [5024] = 4397,
  [5025] = 4051,
  [5026] = 4391,
  [5027] = 4045,
  [5028] = 4371,
  [5029] = 4451,
  [5030] = 4385,
  [5031] = 4394,
  [5032] = 4398,
  [5033] = 2749,
  [5034] = 4427,
  [5035] = 2948,
  [5036] = 4411,
  [5037] = 5037,
  [5038] = 4020,
  [5039] = 4021,
  [5040] = 4441,
  [5041] = 4363,
  [5042] = 4391,
  [5043] = 4416,
  [5044] = 4411,
  [5045] = 5045,
  [5046] = 4374,
  [5047] = 4421,
  [5048] = 4415,
  [5049] = 4414,
  [5050] = 4407,
  [5051] = 4377,
  [5052] = 4434,
  [5053] = 4413,
  [5054] = 4365,
  [5055] = 4369,
  [5056] = 4367,
  [5057] = 4369,
  [5058] = 4374,
  [5059] = 4051,
  [5060] = 4020,
  [5061] = 4398,
  [5062] = 4394,
  [5063] = 4021,
  [5064] = 4385,
  [5065] = 4363,
  [5066] = 4398,
  [5067] = 4367,
  [5068] = 4365,
  [5069] = 4413,
  [5070] = 4434,
  [5071] = 4451,
  [5072] = 4394,
  [5073] = 4371,
  [5074] = 4377,
  [5075] = 4407,
  [5076] = 4414,
  [5077] = 4395,
  [5078] = 4397,
  [5079] = 4414,
  [5080] = 4363,
  [5081] = 4421,
  [5082] = 4415,
  [5083] = 4421,
  [5084] = 4415,
  [5085] = 4407,
  [5086] = 4377,
  [5087] = 4434,
  [5088] = 4413,
  [5089] = 4441,
  [5090] = 4427,
  [5091] = 4365,
  [5092] = 4367,
  [5093] = 4369,
  [5094] = 4374,
  [5095] = 4363,
  [5096] = 3561,
  [5097] = 4452,
  [5098] = 5098,
  [5099] = 2976,
  [5100] = 4397,
  [5101] = 4397,
  [5102] = 4385,
  [5103] = 4496,
  [5104] = 4395,
  [5105] = 4504,
  [5106] = 4491,
  [5107] = 4427,
  [5108] = 4391,
  [5109] = 4371,
  [5110] = 2938,
  [5111] = 4451,
  [5112] = 4395,
  [5113] = 4635,
  [5114] = 4391,
  [5115] = 4666,
  [5116] = 4505,
  [5117] = 4385,
  [5118] = 4441,
  [5119] = 4394,
  [5120] = 5120,
  [5121] = 4451,
  [5122] = 4508,
  [5123] = 4427,
  [5124] = 4418,
  [5125] = 4371,
  [5126] = 4398,
  [5127] = 4441,
  [5128] = 4411,
  [5129] = 4411,
  [5130] = 5130,
  [5131] = 2754,
  [5132] = 5132,
  [5133] = 4452,
  [5134] = 4452,
  [5135] = 4391,
  [5136] = 2745,
  [5137] = 4374,
  [5138] = 4369,
  [5139] = 5139,
  [5140] = 4367,
  [5141] = 4365,
  [5142] = 4413,
  [5143] = 4434,
  [5144] = 4377,
  [5145] = 4452,
  [5146] = 4385,
  [5147] = 4407,
  [5148] = 4427,
  [5149] = 4421,
  [5150] = 4415,
  [5151] = 4394,
  [5152] = 4398,
  [5153] = 4374,
  [5154] = 4369,
  [5155] = 3586,
  [5156] = 4367,
  [5157] = 4421,
  [5158] = 4363,
  [5159] = 4421,
  [5160] = 4365,
  [5161] = 4434,
  [5162] = 4363,
  [5163] = 4377,
  [5164] = 4415,
  [5165] = 4407,
  [5166] = 4415,
  [5167] = 5139,
  [5168] = 4441,
  [5169] = 2736,
  [5170] = 4441,
  [5171] = 4414,
  [5172] = 4411,
  [5173] = 4452,
  [5174] = 4414,
  [5175] = 5139,
  [5176] = 4407,
  [5177] = 4413,
  [5178] = 4427,
  [5179] = 4377,
  [5180] = 2755,
  [5181] = 4397,
  [5182] = 4397,
  [5183] = 4434,
  [5184] = 4413,
  [5185] = 4365,
  [5186] = 4441,
  [5187] = 4367,
  [5188] = 4369,
  [5189] = 4418,
  [5190] = 5139,
  [5191] = 2744,
  [5192] = 2754,
  [5193] = 4395,
  [5194] = 3576,
  [5195] = 2745,
  [5196] = 3569,
  [5197] = 4391,
  [5198] = 3566,
  [5199] = 2982,
  [5200] = 4363,
  [5201] = 4414,
  [5202] = 3584,
  [5203] = 5139,
  [5204] = 4451,
  [5205] = 5139,
  [5206] = 2736,
  [5207] = 4371,
  [5208] = 4451,
  [5209] = 4374,
  [5210] = 2744,
  [5211] = 3573,
  [5212] = 4411,
  [5213] = 3577,
  [5214] = 4395,
  [5215] = 4391,
  [5216] = 4398,
  [5217] = 3586,
  [5218] = 4508,
  [5219] = 4371,
  [5220] = 4505,
  [5221] = 4491,
  [5222] = 4394,
  [5223] = 4504,
  [5224] = 4385,
  [5225] = 4397,
  [5226] = 4371,
  [5227] = 4496,
  [5228] = 4416,
  [5229] = 4394,
  [5230] = 4451,
  [5231] = 4385,
  [5232] = 4395,
  [5233] = 4427,
  [5234] = 4411,
  [5235] = 4398,
  [5236] = 5236,
  [5237] = 2980,
  [5238] = 4371,
  [5239] = 4451,
  [5240] = 4451,
  [5241] = 4385,
  [5242] = 2944,
  [5243] = 2945,
  [5244] = 4385,
  [5245] = 2946,
  [5246] = 4394,
  [5247] = 4398,
  [5248] = 2736,
  [5249] = 4413,
  [5250] = 4414,
  [5251] = 4415,
  [5252] = 4421,
  [5253] = 4394,
  [5254] = 4398,
  [5255] = 4411,
  [5256] = 4414,
  [5257] = 4413,
  [5258] = 4427,
  [5259] = 2984,
  [5260] = 2959,
  [5261] = 3012,
  [5262] = 4051,
  [5263] = 4635,
  [5264] = 4395,
  [5265] = 4371,
  [5266] = 3012,
  [5267] = 4411,
  [5268] = 5268,
  [5269] = 2736,
  [5270] = 4395,
  [5271] = 2938,
  [5272] = 4397,
  [5273] = 4391,
  [5274] = 2889,
  [5275] = 4363,
  [5276] = 2883,
  [5277] = 4434,
  [5278] = 4452,
  [5279] = 5279,
  [5280] = 2751,
  [5281] = 4421,
  [5282] = 4427,
  [5283] = 4413,
  [5284] = 4397,
  [5285] = 2752,
  [5286] = 4395,
  [5287] = 4391,
  [5288] = 4371,
  [5289] = 4451,
  [5290] = 4385,
  [5291] = 4397,
  [5292] = 4394,
  [5293] = 4398,
  [5294] = 3026,
  [5295] = 4020,
  [5296] = 4415,
  [5297] = 4021,
  [5298] = 4416,
  [5299] = 2906,
  [5300] = 4051,
  [5301] = 2749,
  [5302] = 4452,
  [5303] = 4421,
  [5304] = 4418,
  [5305] = 2942,
  [5306] = 2755,
  [5307] = 2907,
  [5308] = 4411,
  [5309] = 2909,
  [5310] = 4070,
  [5311] = 3604,
  [5312] = 2748,
  [5313] = 2747,
  [5314] = 2884,
  [5315] = 3609,
  [5316] = 2950,
  [5317] = 2980,
  [5318] = 4452,
  [5319] = 2895,
  [5320] = 5268,
  [5321] = 2914,
  [5322] = 3610,
  [5323] = 4391,
  [5324] = 4416,
  [5325] = 4421,
  [5326] = 4415,
  [5327] = 2984,
  [5328] = 4414,
  [5329] = 4416,
  [5330] = 4418,
  [5331] = 4407,
  [5332] = 2982,
  [5333] = 5236,
  [5334] = 2802,
  [5335] = 5268,
  [5336] = 4377,
  [5337] = 4414,
  [5338] = 4434,
  [5339] = 2959,
  [5340] = 2944,
  [5341] = 4413,
  [5342] = 2945,
  [5343] = 4365,
  [5344] = 4407,
  [5345] = 5268,
  [5346] = 4367,
  [5347] = 4377,
  [5348] = 4434,
  [5349] = 4365,
  [5350] = 4441,
  [5351] = 4367,
  [5352] = 4369,
  [5353] = 4374,
  [5354] = 4369,
  [5355] = 4374,
  [5356] = 4441,
  [5357] = 4374,
  [5358] = 4418,
  [5359] = 4441,
  [5360] = 4369,
  [5361] = 4367,
  [5362] = 4363,
  [5363] = 2938,
  [5364] = 4666,
  [5365] = 4434,
  [5366] = 4377,
  [5367] = 4407,
  [5368] = 4666,
  [5369] = 4635,
  [5370] = 4398,
  [5371] = 4394,
  [5372] = 4427,
  [5373] = 4385,
  [5374] = 4451,
  [5375] = 4415,
  [5376] = 4363,
  [5377] = 4491,
  [5378] = 4427,
  [5379] = 4496,
  [5380] = 4371,
  [5381] = 4504,
  [5382] = 4391,
  [5383] = 4505,
  [5384] = 4508,
  [5385] = 4395,
  [5386] = 4397,
  [5387] = 5387,
  [5388] = 4441,
  [5389] = 5268,
  [5390] = 3621,
  [5391] = 3617,
  [5392] = 3627,
  [5393] = 2915,
  [5394] = 4411,
  [5395] = 2942,
  [5396] = 2948,
  [5397] = 4407,
  [5398] = 4377,
  [5399] = 5399,
  [5400] = 4365,
  [5401] = 4367,
  [5402] = 5268,
  [5403] = 4369,
  [5404] = 4363,
  [5405] = 4365,
  [5406] = 4374,
  [5407] = 2974,
  [5408] = 2976,
  [5409] = 4415,
  [5410] = 4385,
  [5411] = 4395,
  [5412] = 4374,
  [5413] = 4369,
  [5414] = 4367,
  [5415] = 4394,
  [5416] = 4427,
  [5417] = 4365,
  [5418] = 4413,
  [5419] = 4434,
  [5420] = 4377,
  [5421] = 4421,
  [5422] = 4415,
  [5423] = 4051,
  [5424] = 4407,
  [5425] = 4377,
  [5426] = 2960,
  [5427] = 4434,
  [5428] = 4413,
  [5429] = 4365,
  [5430] = 4367,
  [5431] = 4369,
  [5432] = 4374,
  [5433] = 4635,
  [5434] = 4407,
  [5435] = 4414,
  [5436] = 4415,
  [5437] = 4421,
  [5438] = 4416,
  [5439] = 4418,
  [5440] = 2946,
  [5441] = 4441,
  [5442] = 4414,
  [5443] = 4414,
  [5444] = 4441,
  [5445] = 4363,
  [5446] = 4441,
  [5447] = 4441,
  [5448] = 4418,
  [5449] = 4452,
  [5450] = 4416,
  [5451] = 4397,
  [5452] = 4414,
  [5453] = 4411,
  [5454] = 4427,
  [5455] = 4398,
  [5456] = 4394,
  [5457] = 4385,
  [5458] = 4441,
  [5459] = 4451,
  [5460] = 4371,
  [5461] = 4391,
  [5462] = 4395,
  [5463] = 4363,
  [5464] = 4441,
  [5465] = 4397,
  [5466] = 4363,
  [5467] = 5467,
  [5468] = 4427,
  [5469] = 4363,
  [5470] = 4397,
  [5471] = 4395,
  [5472] = 4391,
  [5473] = 4441,
  [5474] = 4371,
  [5475] = 4451,
  [5476] = 5467,
  [5477] = 4385,
  [5478] = 4394,
  [5479] = 4398,
  [5480] = 4374,
  [5481] = 4369,
  [5482] = 4367,
  [5483] = 4365,
  [5484] = 4434,
  [5485] = 4377,
  [5486] = 4385,
  [5487] = 4407,
  [5488] = 4411,
  [5489] = 4411,
  [5490] = 4414,
  [5491] = 4418,
  [5492] = 4452,
  [5493] = 4416,
  [5494] = 4452,
  [5495] = 4051,
  [5496] = 2938,
  [5497] = 2204,
  [5498] = 2219,
  [5499] = 4413,
  [5500] = 4415,
  [5501] = 4421,
  [5502] = 4371,
  [5503] = 4398,
  [5504] = 4391,
  [5505] = 4363,
  [5506] = 4397,
  [5507] = 4395,
  [5508] = 4395,
  [5509] = 4398,
  [5510] = 4496,
  [5511] = 4051,
  [5512] = 4504,
  [5513] = 4021,
  [5514] = 4020,
  [5515] = 4421,
  [5516] = 4415,
  [5517] = 4407,
  [5518] = 4377,
  [5519] = 4434,
  [5520] = 4413,
  [5521] = 4365,
  [5522] = 4367,
  [5523] = 4369,
  [5524] = 4374,
  [5525] = 4451,
  [5526] = 4391,
  [5527] = 2220,
  [5528] = 4371,
  [5529] = 4508,
  [5530] = 4371,
  [5531] = 4505,
  [5532] = 4504,
  [5533] = 4496,
  [5534] = 4505,
  [5535] = 4491,
  [5536] = 4397,
  [5537] = 4508,
  [5538] = 4451,
  [5539] = 4385,
  [5540] = 4394,
  [5541] = 4398,
  [5542] = 4374,
  [5543] = 4369,
  [5544] = 4367,
  [5545] = 4365,
  [5546] = 4434,
  [5547] = 3995,
  [5548] = 3997,
  [5549] = 4377,
  [5550] = 4407,
  [5551] = 4411,
  [5552] = 3999,
  [5553] = 4001,
  [5554] = 4451,
  [5555] = 4003,
  [5556] = 4008,
  [5557] = 4017,
  [5558] = 4018,
  [5559] = 4019,
  [5560] = 4038,
  [5561] = 4427,
  [5562] = 4363,
  [5563] = 4398,
  [5564] = 4441,
  [5565] = 4427,
  [5566] = 4416,
  [5567] = 4413,
  [5568] = 4415,
  [5569] = 4421,
  [5570] = 4394,
  [5571] = 4039,
  [5572] = 4041,
  [5573] = 4385,
  [5574] = 4045,
  [5575] = 4441,
  [5576] = 4385,
  [5577] = 4055,
  [5578] = 4058,
  [5579] = 4451,
  [5580] = 4068,
  [5581] = 4371,
  [5582] = 4418,
  [5583] = 4071,
  [5584] = 4072,
  [5585] = 4073,
  [5586] = 4391,
  [5587] = 4421,
  [5588] = 4415,
  [5589] = 4413,
  [5590] = 4427,
  [5591] = 4075,
  [5592] = 4395,
  [5593] = 4452,
  [5594] = 4397,
  [5595] = 4051,
  [5596] = 4635,
  [5597] = 3636,
  [5598] = 3667,
  [5599] = 3692,
  [5600] = 4411,
  [5601] = 4414,
  [5602] = 4421,
  [5603] = 3630,
  [5604] = 4452,
  [5605] = 4411,
  [5606] = 4414,
  [5607] = 4407,
  [5608] = 5608,
  [5609] = 4377,
  [5610] = 4394,
  [5611] = 4434,
  [5612] = 4363,
  [5613] = 4411,
  [5614] = 4374,
  [5615] = 4407,
  [5616] = 4377,
  [5617] = 4434,
  [5618] = 4365,
  [5619] = 4427,
  [5620] = 4367,
  [5621] = 4369,
  [5622] = 4374,
  [5623] = 4398,
  [5624] = 4394,
  [5625] = 4369,
  [5626] = 4385,
  [5627] = 4367,
  [5628] = 4427,
  [5629] = 4451,
  [5630] = 4365,
  [5631] = 4371,
  [5632] = 4391,
  [5633] = 4413,
  [5634] = 4395,
  [5635] = 4397,
  [5636] = 4434,
  [5637] = 4377,
  [5638] = 4407,
  [5639] = 4363,
  [5640] = 4414,
  [5641] = 4415,
  [5642] = 4635,
  [5643] = 4452,
  [5644] = 4421,
  [5645] = 4666,
  [5646] = 4365,
  [5647] = 3718,
  [5648] = 3658,
  [5649] = 4441,
  [5650] = 3646,
  [5651] = 4367,
  [5652] = 3672,
  [5653] = 3644,
  [5654] = 4369,
  [5655] = 4363,
  [5656] = 4421,
  [5657] = 4415,
  [5658] = 3721,
  [5659] = 3663,
  [5660] = 4407,
  [5661] = 4377,
  [5662] = 4434,
  [5663] = 4414,
  [5664] = 4365,
  [5665] = 4407,
  [5666] = 4367,
  [5667] = 4369,
  [5668] = 4374,
  [5669] = 4377,
  [5670] = 4434,
  [5671] = 4374,
  [5672] = 4413,
  [5673] = 4398,
  [5674] = 4365,
  [5675] = 4427,
  [5676] = 4367,
  [5677] = 3669,
  [5678] = 4394,
  [5679] = 4391,
  [5680] = 4369,
  [5681] = 4374,
  [5682] = 4451,
  [5683] = 3649,
  [5684] = 3682,
  [5685] = 5467,
  [5686] = 3689,
  [5687] = 3690,
  [5688] = 4394,
  [5689] = 4371,
  [5690] = 3688,
  [5691] = 3702,
  [5692] = 3708,
  [5693] = 3715,
  [5694] = 4385,
  [5695] = 3716,
  [5696] = 3717,
  [5697] = 3731,
  [5698] = 3723,
  [5699] = 3729,
  [5700] = 3727,
  [5701] = 4414,
  [5702] = 3654,
  [5703] = 4508,
  [5704] = 4505,
  [5705] = 3730,
  [5706] = 4504,
  [5707] = 4496,
  [5708] = 4411,
  [5709] = 3707,
  [5710] = 3726,
  [5711] = 4491,
  [5712] = 3722,
  [5713] = 3720,
  [5714] = 2802,
  [5715] = 4666,
  [5716] = 4391,
  [5717] = 4416,
  [5718] = 4395,
  [5719] = 4397,
  [5720] = 5467,
  [5721] = 4451,
  [5722] = 3712,
  [5723] = 4398,
  [5724] = 4427,
  [5725] = 4413,
  [5726] = 4415,
  [5727] = 4421,
  [5728] = 3711,
  [5729] = 3709,
  [5730] = 3703,
  [5731] = 3699,
  [5732] = 3698,
  [5733] = 3693,
  [5734] = 3687,
  [5735] = 3650,
  [5736] = 3685,
  [5737] = 3684,
  [5738] = 4411,
  [5739] = 4371,
  [5740] = 4391,
  [5741] = 3651,
  [5742] = 3631,
  [5743] = 5743,
  [5744] = 4395,
  [5745] = 3680,
  [5746] = 4413,
  [5747] = 4397,
  [5748] = 3677,
  [5749] = 3681,
  [5750] = 3675,
  [5751] = 3674,
  [5752] = 3659,
  [5753] = 3645,
  [5754] = 3673,
  [5755] = 4418,
  [5756] = 3662,
  [5757] = 3640,
  [5758] = 3642,
  [5759] = 4411,
  [5760] = 4666,
  [5761] = 3666,
  [5762] = 4398,
  [5763] = 3657,
  [5764] = 3656,
  [5765] = 3679,
  [5766] = 4394,
  [5767] = 4491,
  [5768] = 4363,
  [5769] = 4397,
  [5770] = 4395,
  [5771] = 4391,
  [5772] = 3714,
  [5773] = 4385,
  [5774] = 3643,
  [5775] = 5467,
  [5776] = 3713,
  [5777] = 3635,
  [5778] = 4451,
  [5779] = 3633,
  [5780] = 3632,
  [5781] = 4371,
  [5782] = 5782,
  [5783] = 4414,
  [5784] = 4505,
  [5785] = 4398,
  [5786] = 5782,
  [5787] = 5782,
  [5788] = 5788,
  [5789] = 5789,
  [5790] = 5782,
  [5791] = 4411,
  [5792] = 5792,
  [5793] = 4427,
  [5794] = 4398,
  [5795] = 4374,
  [5796] = 4369,
  [5797] = 4367,
  [5798] = 4365,
  [5799] = 4413,
  [5800] = 4434,
  [5801] = 4377,
  [5802] = 4407,
  [5803] = 4415,
  [5804] = 4421,
  [5805] = 5805,
  [5806] = 4394,
  [5807] = 4385,
  [5808] = 5782,
  [5809] = 4451,
  [5810] = 5810,
  [5811] = 5811,
  [5812] = 4371,
  [5813] = 4391,
  [5814] = 5814,
  [5815] = 4395,
  [5816] = 5782,
  [5817] = 4397,
  [5818] = 5818,
  [5819] = 5819,
  [5820] = 5782,
  [5821] = 4421,
  [5822] = 4363,
  [5823] = 5823,
  [5824] = 4415,
  [5825] = 4414,
  [5826] = 4407,
  [5827] = 4377,
  [5828] = 4434,
  [5829] = 4413,
  [5830] = 4365,
  [5831] = 5810,
  [5832] = 4427,
  [5833] = 4367,
  [5834] = 4369,
  [5835] = 4374,
  [5836] = 4363,
  [5837] = 4504,
  [5838] = 2950,
  [5839] = 4496,
  [5840] = 4414,
  [5841] = 4397,
  [5842] = 4395,
  [5843] = 4391,
  [5844] = 4394,
  [5845] = 4441,
  [5846] = 5782,
  [5847] = 4371,
  [5848] = 5848,
  [5849] = 4451,
  [5850] = 5850,
  [5851] = 4491,
  [5852] = 4441,
  [5853] = 5853,
  [5854] = 5782,
  [5855] = 4385,
  [5856] = 4452,
  [5857] = 5819,
  [5858] = 4394,
  [5859] = 4398,
  [5860] = 4427,
  [5861] = 4363,
  [5862] = 4371,
  [5863] = 4363,
  [5864] = 4397,
  [5865] = 4395,
  [5866] = 5782,
  [5867] = 4391,
  [5868] = 4371,
  [5869] = 4451,
  [5870] = 4414,
  [5871] = 4385,
  [5872] = 5819,
  [5873] = 4411,
  [5874] = 4394,
  [5875] = 4385,
  [5876] = 4398,
  [5877] = 4451,
  [5878] = 4427,
  [5879] = 5819,
  [5880] = 4411,
  [5881] = 4374,
  [5882] = 4398,
  [5883] = 5782,
  [5884] = 5819,
  [5885] = 5782,
  [5886] = 4411,
  [5887] = 4391,
  [5888] = 4421,
  [5889] = 4415,
  [5890] = 4407,
  [5891] = 4377,
  [5892] = 5782,
  [5893] = 4434,
  [5894] = 4413,
  [5895] = 5895,
  [5896] = 4451,
  [5897] = 4441,
  [5898] = 5782,
  [5899] = 4635,
  [5900] = 4365,
  [5901] = 4369,
  [5902] = 4441,
  [5903] = 5848,
  [5904] = 4367,
  [5905] = 5905,
  [5906] = 4666,
  [5907] = 4367,
  [5908] = 4369,
  [5909] = 4051,
  [5910] = 4374,
  [5911] = 4371,
  [5912] = 5912,
  [5913] = 4365,
  [5914] = 4413,
  [5915] = 4411,
  [5916] = 5912,
  [5917] = 4070,
  [5918] = 4427,
  [5919] = 4398,
  [5920] = 4391,
  [5921] = 4394,
  [5922] = 4385,
  [5923] = 4395,
  [5924] = 4434,
  [5925] = 5925,
  [5926] = 2802,
  [5927] = 5850,
  [5928] = 5853,
  [5929] = 5912,
  [5930] = 4451,
  [5931] = 4635,
  [5932] = 4371,
  [5933] = 4391,
  [5934] = 4635,
  [5935] = 4377,
  [5936] = 4397,
  [5937] = 4395,
  [5938] = 4397,
  [5939] = 5789,
  [5940] = 5788,
  [5941] = 4363,
  [5942] = 4407,
  [5943] = 5782,
  [5944] = 4452,
  [5945] = 5945,
  [5946] = 5946,
  [5947] = 4414,
  [5948] = 5948,
  [5949] = 4508,
  [5950] = 4413,
  [5951] = 4374,
  [5952] = 4369,
  [5953] = 4367,
  [5954] = 4363,
  [5955] = 4365,
  [5956] = 4421,
  [5957] = 5782,
  [5958] = 4397,
  [5959] = 4395,
  [5960] = 4508,
  [5961] = 4391,
  [5962] = 4371,
  [5963] = 4385,
  [5964] = 4451,
  [5965] = 4505,
  [5966] = 4385,
  [5967] = 4413,
  [5968] = 4394,
  [5969] = 4398,
  [5970] = 4427,
  [5971] = 4363,
  [5972] = 4411,
  [5973] = 4504,
  [5974] = 4434,
  [5975] = 5945,
  [5976] = 4377,
  [5977] = 4496,
  [5978] = 4407,
  [5979] = 4415,
  [5980] = 4452,
  [5981] = 4421,
  [5982] = 4491,
  [5983] = 4441,
  [5984] = 5819,
  [5985] = 5945,
  [5986] = 5782,
  [5987] = 5810,
  [5988] = 4397,
  [5989] = 5789,
  [5990] = 5788,
  [5991] = 4508,
  [5992] = 4411,
  [5993] = 5823,
  [5994] = 5994,
  [5995] = 3026,
  [5996] = 4505,
  [5997] = 5788,
  [5998] = 5789,
  [5999] = 5819,
  [6000] = 3012,
  [6001] = 4395,
  [6002] = 4504,
  [6003] = 5850,
  [6004] = 5912,
  [6005] = 4421,
  [6006] = 6006,
  [6007] = 5743,
  [6008] = 4496,
  [6009] = 5853,
  [6010] = 5782,
  [6011] = 5810,
  [6012] = 4491,
  [6013] = 4363,
  [6014] = 5848,
  [6015] = 4397,
  [6016] = 4415,
  [6017] = 5782,
  [6018] = 4441,
  [6019] = 4395,
  [6020] = 4391,
  [6021] = 4415,
  [6022] = 4411,
  [6023] = 5782,
  [6024] = 4414,
  [6025] = 4407,
  [6026] = 4371,
  [6027] = 4377,
  [6028] = 4451,
  [6029] = 4385,
  [6030] = 4427,
  [6031] = 4434,
  [6032] = 4394,
  [6033] = 4398,
  [6034] = 4508,
  [6035] = 4505,
  [6036] = 5945,
  [6037] = 4504,
  [6038] = 4496,
  [6039] = 4491,
  [6040] = 4427,
  [6041] = 4411,
  [6042] = 5782,
  [6043] = 4452,
  [6044] = 4414,
  [6045] = 4413,
  [6046] = 4365,
  [6047] = 5782,
  [6048] = 4441,
  [6049] = 5853,
  [6050] = 5850,
  [6051] = 4398,
  [6052] = 4427,
  [6053] = 4394,
  [6054] = 4367,
  [6055] = 3586,
  [6056] = 6056,
  [6057] = 4369,
  [6058] = 4374,
  [6059] = 4451,
  [6060] = 6060,
  [6061] = 4371,
  [6062] = 4391,
  [6063] = 4421,
  [6064] = 4395,
  [6065] = 4415,
  [6066] = 4397,
  [6067] = 4407,
  [6068] = 4377,
  [6069] = 4434,
  [6070] = 4374,
  [6071] = 4369,
  [6072] = 4367,
  [6073] = 4365,
  [6074] = 4413,
  [6075] = 4434,
  [6076] = 4377,
  [6077] = 4407,
  [6078] = 4415,
  [6079] = 4421,
  [6080] = 4385,
  [6081] = 4421,
  [6082] = 4415,
  [6083] = 5810,
  [6084] = 4414,
  [6085] = 4407,
  [6086] = 4377,
  [6087] = 4434,
  [6088] = 4413,
  [6089] = 5848,
  [6090] = 4394,
  [6091] = 4365,
  [6092] = 4367,
  [6093] = 4365,
  [6094] = 4491,
  [6095] = 4496,
  [6096] = 4369,
  [6097] = 4374,
  [6098] = 4504,
  [6099] = 4505,
  [6100] = 4508,
  [6101] = 4666,
  [6102] = 5782,
  [6103] = 4363,
  [6104] = 4367,
  [6105] = 4441,
  [6106] = 4452,
  [6107] = 5819,
  [6108] = 4441,
  [6109] = 4414,
  [6110] = 4452,
  [6111] = 5782,
  [6112] = 4666,
  [6113] = 5810,
  [6114] = 5782,
  [6115] = 4369,
  [6116] = 4374,
  [6117] = 6117,
  [6118] = 4411,
  [6119] = 4407,
  [6120] = 4377,
  [6121] = 4398,
  [6122] = 4434,
  [6123] = 4418,
  [6124] = 4365,
  [6125] = 4363,
  [6126] = 4385,
  [6127] = 5994,
  [6128] = 4369,
  [6129] = 4374,
  [6130] = 4020,
  [6131] = 4021,
  [6132] = 6132,
  [6133] = 4398,
  [6134] = 4394,
  [6135] = 4385,
  [6136] = 4451,
  [6137] = 4371,
  [6138] = 6138,
  [6139] = 4666,
  [6140] = 4416,
  [6141] = 4411,
  [6142] = 4391,
  [6143] = 3012,
  [6144] = 4395,
  [6145] = 4397,
  [6146] = 3026,
  [6147] = 4427,
  [6148] = 4367,
  [6149] = 6149,
  [6150] = 4666,
  [6151] = 4020,
  [6152] = 4051,
  [6153] = 6138,
  [6154] = 4418,
  [6155] = 4363,
  [6156] = 4441,
  [6157] = 6138,
  [6158] = 4021,
  [6159] = 4051,
  [6160] = 4635,
  [6161] = 6132,
  [6162] = 4394,
  [6163] = 4367,
  [6164] = 4451,
  [6165] = 6165,
  [6166] = 4635,
  [6167] = 2802,
  [6168] = 4371,
  [6169] = 4374,
  [6170] = 4369,
  [6171] = 4414,
  [6172] = 4365,
  [6173] = 4413,
  [6174] = 4434,
  [6175] = 4377,
  [6176] = 4407,
  [6177] = 6177,
  [6178] = 4415,
  [6179] = 4421,
  [6180] = 6180,
  [6181] = 6060,
  [6182] = 4391,
  [6183] = 6183,
  [6184] = 4395,
  [6185] = 4397,
  [6186] = 6186,
  [6187] = 4397,
  [6188] = 4395,
  [6189] = 4391,
  [6190] = 4371,
  [6191] = 4451,
  [6192] = 6192,
  [6193] = 4051,
  [6194] = 6194,
  [6195] = 4385,
  [6196] = 4666,
  [6197] = 4394,
  [6198] = 4398,
  [6199] = 4427,
  [6200] = 4411,
  [6201] = 4421,
  [6202] = 4415,
  [6203] = 4414,
  [6204] = 4416,
  [6205] = 6205,
  [6206] = 4407,
  [6207] = 4377,
  [6208] = 4434,
  [6209] = 4413,
  [6210] = 6210,
  [6211] = 4365,
  [6212] = 4367,
  [6213] = 4369,
  [6214] = 4374,
  [6215] = 6215,
  [6216] = 6056,
  [6217] = 6217,
  [6218] = 6218,
  [6219] = 6138,
  [6220] = 6183,
  [6221] = 4418,
  [6222] = 6222,
  [6223] = 4363,
  [6224] = 4441,
  [6225] = 4441,
  [6226] = 6186,
  [6227] = 6227,
  [6228] = 4635,
  [6229] = 4374,
  [6230] = 6230,
  [6231] = 6231,
  [6232] = 3606,
  [6233] = 4369,
  [6234] = 5823,
  [6235] = 4367,
  [6236] = 4365,
  [6237] = 4413,
  [6238] = 6218,
  [6239] = 4434,
  [6240] = 4377,
  [6241] = 4407,
  [6242] = 4414,
  [6243] = 4415,
  [6244] = 4421,
  [6245] = 6217,
  [6246] = 6215,
  [6247] = 6132,
  [6248] = 4635,
  [6249] = 3026,
  [6250] = 6250,
  [6251] = 4421,
  [6252] = 4397,
  [6253] = 4395,
  [6254] = 4391,
  [6255] = 4371,
  [6256] = 4451,
  [6257] = 4385,
  [6258] = 4394,
  [6259] = 4635,
  [6260] = 6138,
  [6261] = 4398,
  [6262] = 6262,
  [6263] = 6227,
  [6264] = 6264,
  [6265] = 4427,
  [6266] = 4635,
  [6267] = 4411,
  [6268] = 2802,
  [6269] = 6269,
  [6270] = 2993,
  [6271] = 4441,
  [6272] = 4363,
  [6273] = 6227,
  [6274] = 6132,
  [6275] = 4666,
  [6276] = 6276,
  [6277] = 6194,
  [6278] = 4418,
  [6279] = 6279,
  [6280] = 6205,
  [6281] = 6231,
  [6282] = 6192,
  [6283] = 2802,
  [6284] = 6284,
  [6285] = 4666,
  [6286] = 2993,
  [6287] = 4051,
  [6288] = 6288,
  [6289] = 4416,
  [6290] = 6290,
  [6291] = 6291,
  [6292] = 2827,
  [6293] = 4666,
  [6294] = 6294,
  [6295] = 6006,
  [6296] = 6227,
  [6297] = 6138,
  [6298] = 6298,
  [6299] = 2842,
  [6300] = 4427,
  [6301] = 4413,
  [6302] = 4414,
  [6303] = 4416,
  [6304] = 4415,
  [6305] = 6305,
  [6306] = 4365,
  [6307] = 4051,
  [6308] = 6308,
  [6309] = 6309,
  [6310] = 5743,
  [6311] = 6311,
  [6312] = 4441,
  [6313] = 4397,
  [6314] = 4411,
  [6315] = 6308,
  [6316] = 6316,
  [6317] = 6308,
  [6318] = 4395,
  [6319] = 4391,
  [6320] = 6309,
  [6321] = 4666,
  [6322] = 4398,
  [6323] = 6308,
  [6324] = 6316,
  [6325] = 6325,
  [6326] = 4371,
  [6327] = 6327,
  [6328] = 6328,
  [6329] = 6308,
  [6330] = 4411,
  [6331] = 4451,
  [6332] = 4363,
  [6333] = 6333,
  [6334] = 6334,
  [6335] = 6335,
  [6336] = 6336,
  [6337] = 6309,
  [6338] = 6338,
  [6339] = 4421,
  [6340] = 6340,
  [6341] = 6341,
  [6342] = 6342,
  [6343] = 6343,
  [6344] = 6308,
  [6345] = 6308,
  [6346] = 4385,
  [6347] = 6308,
  [6348] = 6348,
  [6349] = 6335,
  [6350] = 6308,
  [6351] = 6351,
  [6352] = 6352,
  [6353] = 6353,
  [6354] = 6343,
  [6355] = 4415,
  [6356] = 4414,
  [6357] = 6357,
  [6358] = 6358,
  [6359] = 6359,
  [6360] = 6338,
  [6361] = 4407,
  [6362] = 4377,
  [6363] = 4434,
  [6364] = 6308,
  [6365] = 6308,
  [6366] = 4051,
  [6367] = 6309,
  [6368] = 6368,
  [6369] = 6308,
  [6370] = 4394,
  [6371] = 4398,
  [6372] = 4413,
  [6373] = 4635,
  [6374] = 4374,
  [6375] = 4369,
  [6376] = 4367,
  [6377] = 4427,
  [6378] = 4365,
  [6379] = 4413,
  [6380] = 4434,
  [6381] = 4377,
  [6382] = 4635,
  [6383] = 4407,
  [6384] = 4414,
  [6385] = 4415,
  [6386] = 6308,
  [6387] = 6387,
  [6388] = 4421,
  [6389] = 6340,
  [6390] = 6342,
  [6391] = 4496,
  [6392] = 6392,
  [6393] = 4504,
  [6394] = 6308,
  [6395] = 4365,
  [6396] = 2938,
  [6397] = 6338,
  [6398] = 6309,
  [6399] = 4051,
  [6400] = 4505,
  [6401] = 4427,
  [6402] = 4367,
  [6403] = 4363,
  [6404] = 6308,
  [6405] = 6308,
  [6406] = 6335,
  [6407] = 4508,
  [6408] = 6308,
  [6409] = 6305,
  [6410] = 4441,
  [6411] = 4441,
  [6412] = 4363,
  [6413] = 6308,
  [6414] = 6414,
  [6415] = 6392,
  [6416] = 4369,
  [6417] = 6308,
  [6418] = 5743,
  [6419] = 6419,
  [6420] = 6308,
  [6421] = 4051,
  [6422] = 6308,
  [6423] = 6309,
  [6424] = 4051,
  [6425] = 4374,
  [6426] = 6368,
  [6427] = 4491,
  [6428] = 6309,
  [6429] = 4397,
  [6430] = 6348,
  [6431] = 6431,
  [6432] = 6308,
  [6433] = 4635,
  [6434] = 6434,
  [6435] = 6392,
  [6436] = 6368,
  [6437] = 4411,
  [6438] = 6305,
  [6439] = 4394,
  [6440] = 6440,
  [6441] = 6308,
  [6442] = 4395,
  [6443] = 6443,
  [6444] = 6309,
  [6445] = 6308,
  [6446] = 4385,
  [6447] = 6447,
  [6448] = 6448,
  [6449] = 4363,
  [6450] = 4441,
  [6451] = 4496,
  [6452] = 6343,
  [6453] = 6392,
  [6454] = 4635,
  [6455] = 6308,
  [6456] = 6309,
  [6457] = 4441,
  [6458] = 6368,
  [6459] = 4504,
  [6460] = 6359,
  [6461] = 6358,
  [6462] = 4391,
  [6463] = 6336,
  [6464] = 6357,
  [6465] = 4427,
  [6466] = 6308,
  [6467] = 6334,
  [6468] = 6290,
  [6469] = 6434,
  [6470] = 2754,
  [6471] = 4363,
  [6472] = 6434,
  [6473] = 4441,
  [6474] = 2993,
  [6475] = 6334,
  [6476] = 6336,
  [6477] = 4508,
  [6478] = 4505,
  [6479] = 4635,
  [6480] = 4413,
  [6481] = 6481,
  [6482] = 4371,
  [6483] = 6341,
  [6484] = 6434,
  [6485] = 6308,
  [6486] = 6309,
  [6487] = 4414,
  [6488] = 6308,
  [6489] = 6440,
  [6490] = 6334,
  [6491] = 4415,
  [6492] = 4411,
  [6493] = 6308,
  [6494] = 6494,
  [6495] = 6368,
  [6496] = 4504,
  [6497] = 4421,
  [6498] = 4496,
  [6499] = 6338,
  [6500] = 6308,
  [6501] = 6309,
  [6502] = 6338,
  [6503] = 4051,
  [6504] = 6342,
  [6505] = 6340,
  [6506] = 4397,
  [6507] = 4505,
  [6508] = 6308,
  [6509] = 4421,
  [6510] = 4395,
  [6511] = 6308,
  [6512] = 4415,
  [6513] = 4414,
  [6514] = 4407,
  [6515] = 4377,
  [6516] = 4434,
  [6517] = 4413,
  [6518] = 4365,
  [6519] = 6327,
  [6520] = 4427,
  [6521] = 4367,
  [6522] = 4369,
  [6523] = 4374,
  [6524] = 4391,
  [6525] = 4371,
  [6526] = 6308,
  [6527] = 4451,
  [6528] = 6308,
  [6529] = 4398,
  [6530] = 4394,
  [6531] = 4415,
  [6532] = 6440,
  [6533] = 4414,
  [6534] = 6309,
  [6535] = 6308,
  [6536] = 4385,
  [6537] = 4407,
  [6538] = 4421,
  [6539] = 6308,
  [6540] = 4377,
  [6541] = 6343,
  [6542] = 6341,
  [6543] = 6316,
  [6544] = 4508,
  [6545] = 6348,
  [6546] = 4385,
  [6547] = 6359,
  [6548] = 4394,
  [6549] = 4451,
  [6550] = 4374,
  [6551] = 4369,
  [6552] = 4635,
  [6553] = 4666,
  [6554] = 4367,
  [6555] = 6352,
  [6556] = 6481,
  [6557] = 4371,
  [6558] = 6335,
  [6559] = 4427,
  [6560] = 4451,
  [6561] = 4365,
  [6562] = 6309,
  [6563] = 4434,
  [6564] = 4413,
  [6565] = 4434,
  [6566] = 6351,
  [6567] = 4371,
  [6568] = 4391,
  [6569] = 4411,
  [6570] = 4666,
  [6571] = 4377,
  [6572] = 4413,
  [6573] = 4391,
  [6574] = 4407,
  [6575] = 4395,
  [6576] = 4414,
  [6577] = 4415,
  [6578] = 4397,
  [6579] = 6308,
  [6580] = 4421,
  [6581] = 6308,
  [6582] = 6309,
  [6583] = 6358,
  [6584] = 4395,
  [6585] = 4397,
  [6586] = 6308,
  [6587] = 6308,
  [6588] = 6327,
  [6589] = 6342,
  [6590] = 6308,
  [6591] = 6333,
  [6592] = 6309,
  [6593] = 4365,
  [6594] = 6594,
  [6595] = 6309,
  [6596] = 6357,
  [6597] = 6443,
  [6598] = 6448,
  [6599] = 4427,
  [6600] = 6340,
  [6601] = 6309,
  [6602] = 4363,
  [6603] = 6338,
  [6604] = 6359,
  [6605] = 6358,
  [6606] = 6357,
  [6607] = 6448,
  [6608] = 4367,
  [6609] = 6609,
  [6610] = 6309,
  [6611] = 6611,
  [6612] = 6308,
  [6613] = 6613,
  [6614] = 6352,
  [6615] = 4491,
  [6616] = 6616,
  [6617] = 6351,
  [6618] = 6309,
  [6619] = 6333,
  [6620] = 4411,
  [6621] = 6308,
  [6622] = 6443,
  [6623] = 6448,
  [6624] = 6624,
  [6625] = 4398,
  [6626] = 4398,
  [6627] = 6342,
  [6628] = 6341,
  [6629] = 6308,
  [6630] = 6340,
  [6631] = 4491,
  [6632] = 6632,
  [6633] = 6308,
  [6634] = 6308,
  [6635] = 6305,
  [6636] = 4407,
  [6637] = 4377,
  [6638] = 4666,
  [6639] = 6341,
  [6640] = 4666,
  [6641] = 6308,
  [6642] = 4491,
  [6643] = 2854,
  [6644] = 4434,
  [6645] = 4369,
  [6646] = 4367,
  [6647] = 4369,
  [6648] = 4374,
  [6649] = 4374,
  [6650] = 6336,
  [6651] = 6309,
  [6652] = 6652,
  [6653] = 6308,
  [6654] = 4398,
  [6655] = 4394,
  [6656] = 4397,
  [6657] = 4395,
  [6658] = 4391,
  [6659] = 6341,
  [6660] = 6333,
  [6661] = 4371,
  [6662] = 6340,
  [6663] = 6342,
  [6664] = 4508,
  [6665] = 6440,
  [6666] = 4451,
  [6667] = 6624,
  [6668] = 4505,
  [6669] = 4666,
  [6670] = 4385,
  [6671] = 4504,
  [6672] = 4496,
  [6673] = 4385,
  [6674] = 6351,
  [6675] = 6352,
  [6676] = 6316,
  [6677] = 6327,
  [6678] = 6443,
  [6679] = 6348,
  [6680] = 4451,
  [6681] = 5743,
  [6682] = 4394,
  [6683] = 6683,
  [6684] = 6683,
  [6685] = 3779,
  [6686] = 6683,
  [6687] = 2842,
  [6688] = 2854,
  [6689] = 6683,
  [6690] = 3784,
  [6691] = 6683,
  [6692] = 6683,
  [6693] = 2868,
  [6694] = 6694,
  [6695] = 2993,
  [6696] = 6683,
  [6697] = 2993,
  [6698] = 2993,
  [6699] = 6683,
  [6700] = 6683,
  [6701] = 6683,
  [6702] = 6683,
  [6703] = 6683,
  [6704] = 6683,
  [6705] = 6683,
  [6706] = 6683,
  [6707] = 2874,
  [6708] = 2881,
  [6709] = 6683,
  [6710] = 6683,
  [6711] = 2745,
  [6712] = 2744,
  [6713] = 2993,
  [6714] = 3792,
  [6715] = 6683,
  [6716] = 6683,
  [6717] = 6683,
  [6718] = 6683,
  [6719] = 2827,
  [6720] = 2205,
  [6721] = 2854,
  [6722] = 3778,
  [6723] = 6683,
  [6724] = 6683,
  [6725] = 2204,
  [6726] = 6683,
  [6727] = 3740,
  [6728] = 2876,
  [6729] = 6683,
  [6730] = 2993,
  [6731] = 6683,
  [6732] = 6683,
  [6733] = 6683,
  [6734] = 6734,
  [6735] = 6683,
  [6736] = 6683,
  [6737] = 2993,
  [6738] = 6683,
  [6739] = 6683,
  [6740] = 2993,
  [6741] = 6741,
  [6742] = 6742,
  [6743] = 6743,
  [6744] = 6744,
  [6745] = 6745,
  [6746] = 2993,
  [6747] = 2993,
  [6748] = 6748,
  [6749] = 2993,
  [6750] = 6750,
  [6751] = 6290,
  [6752] = 6752,
  [6753] = 6753,
  [6754] = 6290,
  [6755] = 6755,
  [6756] = 6734,
  [6757] = 6757,
  [6758] = 6758,
  [6759] = 2881,
  [6760] = 6760,
  [6761] = 6761,
  [6762] = 6761,
  [6763] = 3012,
  [6764] = 2874,
  [6765] = 2868,
  [6766] = 2938,
  [6767] = 2834,
  [6768] = 6748,
  [6769] = 2876,
  [6770] = 6770,
  [6771] = 6771,
  [6772] = 6772,
  [6773] = 6773,
  [6774] = 6774,
  [6775] = 6771,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6776,
  [6779] = 6771,
  [6780] = 6780,
  [6781] = 6774,
  [6782] = 6776,
  [6783] = 6777,
  [6784] = 6774,
  [6785] = 6785,
  [6786] = 6776,
  [6787] = 6787,
  [6788] = 6788,
  [6789] = 6771,
  [6790] = 6788,
  [6791] = 6777,
  [6792] = 2753,
  [6793] = 6777,
  [6794] = 6777,
  [6795] = 6770,
  [6796] = 6796,
  [6797] = 6797,
  [6798] = 6771,
  [6799] = 6387,
  [6800] = 6776,
  [6801] = 6801,
  [6802] = 6802,
  [6803] = 6803,
  [6804] = 2971,
  [6805] = 6805,
  [6806] = 6803,
  [6807] = 6807,
  [6808] = 6808,
  [6809] = 6809,
  [6810] = 6803,
  [6811] = 6811,
  [6812] = 6812,
  [6813] = 6813,
  [6814] = 6814,
  [6815] = 6813,
  [6816] = 6803,
  [6817] = 6808,
  [6818] = 6818,
  [6819] = 6803,
  [6820] = 6813,
  [6821] = 6821,
  [6822] = 6822,
  [6823] = 6823,
  [6824] = 6824,
  [6825] = 6825,
  [6826] = 6824,
  [6827] = 6827,
  [6828] = 6825,
  [6829] = 6824,
  [6830] = 6830,
  [6831] = 6831,
  [6832] = 6832,
  [6833] = 6831,
  [6834] = 6824,
  [6835] = 6824,
  [6836] = 6825,
  [6837] = 6824,
  [6838] = 6838,
  [6839] = 6839,
  [6840] = 6823,
  [6841] = 6824,
  [6842] = 6842,
  [6843] = 6832,
  [6844] = 6844,
  [6845] = 6842,
  [6846] = 6824,
  [6847] = 6847,
  [6848] = 6824,
  [6849] = 6824,
  [6850] = 6850,
  [6851] = 6824,
  [6852] = 6830,
  [6853] = 6824,
  [6854] = 6824,
  [6855] = 6832,
  [6856] = 6824,
  [6857] = 6824,
  [6858] = 6824,
  [6859] = 6824,
  [6860] = 6831,
  [6861] = 6824,
  [6862] = 6824,
  [6863] = 6824,
  [6864] = 6830,
  [6865] = 6824,
  [6866] = 6824,
  [6867] = 6824,
  [6868] = 6824,
  [6869] = 6824,
  [6870] = 6824,
  [6871] = 6825,
  [6872] = 6832,
  [6873] = 6824,
  [6874] = 6824,
  [6875] = 6824,
  [6876] = 6824,
  [6877] = 6824,
  [6878] = 6824,
  [6879] = 6824,
  [6880] = 6824,
  [6881] = 6824,
  [6882] = 6824,
  [6883] = 6824,
  [6884] = 6824,
  [6885] = 6885,
  [6886] = 6824,
  [6887] = 6824,
  [6888] = 6825,
  [6889] = 6889,
  [6890] = 3026,
  [6891] = 6824,
  [6892] = 6889,
  [6893] = 6824,
  [6894] = 6824,
  [6895] = 6889,
  [6896] = 6824,
  [6897] = 6824,
  [6898] = 6824,
  [6899] = 6824,
  [6900] = 6824,
  [6901] = 6832,
  [6902] = 6902,
  [6903] = 2993,
  [6904] = 2993,
  [6905] = 6902,
  [6906] = 2993,
  [6907] = 2993,
  [6908] = 6908,
  [6909] = 6909,
  [6910] = 6908,
  [6911] = 2993,
  [6912] = 6912,
  [6913] = 6913,
  [6914] = 2960,
  [6915] = 2993,
  [6916] = 2993,
  [6917] = 2993,
  [6918] = 6918,
  [6919] = 2993,
  [6920] = 2993,
  [6921] = 2993,
  [6922] = 6922,
  [6923] = 6902,
  [6924] = 2993,
  [6925] = 2960,
  [6926] = 2993,
  [6927] = 2993,
  [6928] = 2993,
  [6929] = 2960,
  [6930] = 6930,
  [6931] = 2993,
  [6932] = 6908,
  [6933] = 2993,
  [6934] = 2960,
  [6935] = 2993,
  [6936] = 2993,
  [6937] = 6937,
  [6938] = 6908,
  [6939] = 2993,
  [6940] = 2993,
  [6941] = 6902,
  [6942] = 2993,
  [6943] = 6909,
  [6944] = 2993,
  [6945] = 6945,
  [6946] = 2993,
  [6947] = 2993,
  [6948] = 2854,
  [6949] = 6949,
  [6950] = 6950,
  [6951] = 6950,
  [6952] = 6950,
  [6953] = 6953,
  [6954] = 2854,
  [6955] = 2854,
  [6956] = 6949,
  [6957] = 6949,
  [6958] = 2854,
  [6959] = 6950,
  [6960] = 6953,
  [6961] = 6953,
  [6962] = 6962,
  [6963] = 6949,
  [6964] = 2854,
  [6965] = 6950,
  [6966] = 6966,
  [6967] = 6962,
  [6968] = 2854,
  [6969] = 6949,
  [6970] = 6949,
  [6971] = 6953,
  [6972] = 6949,
  [6973] = 6973,
  [6974] = 6974,
  [6975] = 6950,
  [6976] = 2854,
  [6977] = 6950,
  [6978] = 6953,
  [6979] = 6949,
  [6980] = 2854,
  [6981] = 6953,
  [6982] = 6950,
  [6983] = 6953,
  [6984] = 6950,
  [6985] = 6966,
  [6986] = 2854,
  [6987] = 6953,
  [6988] = 6949,
  [6989] = 6953,
  [6990] = 6950,
  [6991] = 6953,
  [6992] = 6953,
  [6993] = 6949,
  [6994] = 6950,
  [6995] = 2854,
  [6996] = 6950,
  [6997] = 6950,
  [6998] = 6974,
  [6999] = 6949,
  [7000] = 6949,
  [7001] = 6962,
  [7002] = 2854,
  [7003] = 7003,
  [7004] = 6950,
  [7005] = 6953,
  [7006] = 2854,
  [7007] = 6950,
  [7008] = 6949,
  [7009] = 6953,
  [7010] = 6949,
  [7011] = 2854,
  [7012] = 6950,
  [7013] = 6953,
  [7014] = 6953,
  [7015] = 7003,
  [7016] = 7016,
  [7017] = 6949,
  [7018] = 2854,
  [7019] = 6950,
  [7020] = 6953,
  [7021] = 6953,
  [7022] = 6949,
  [7023] = 6950,
  [7024] = 6950,
  [7025] = 2854,
  [7026] = 2854,
  [7027] = 2854,
  [7028] = 6953,
  [7029] = 6949,
  [7030] = 6949,
  [7031] = 2854,
  [7032] = 6950,
  [7033] = 6953,
  [7034] = 6949,
  [7035] = 7035,
  [7036] = 2854,
  [7037] = 6949,
  [7038] = 6949,
  [7039] = 2854,
  [7040] = 6949,
  [7041] = 6953,
  [7042] = 6950,
  [7043] = 6962,
  [7044] = 6974,
  [7045] = 6953,
  [7046] = 6950,
  [7047] = 6949,
  [7048] = 6953,
  [7049] = 6950,
  [7050] = 2854,
  [7051] = 6950,
  [7052] = 6950,
  [7053] = 6953,
  [7054] = 6949,
  [7055] = 6949,
  [7056] = 7003,
  [7057] = 2854,
  [7058] = 6949,
  [7059] = 7035,
  [7060] = 6937,
  [7061] = 6950,
  [7062] = 6953,
  [7063] = 6953,
  [7064] = 6949,
  [7065] = 2854,
  [7066] = 6949,
  [7067] = 6949,
  [7068] = 2854,
  [7069] = 6953,
  [7070] = 6950,
  [7071] = 6950,
  [7072] = 6950,
  [7073] = 6953,
  [7074] = 2854,
  [7075] = 7075,
  [7076] = 6949,
  [7077] = 2854,
  [7078] = 6949,
  [7079] = 6953,
  [7080] = 2854,
  [7081] = 6949,
  [7082] = 6950,
  [7083] = 6953,
  [7084] = 6953,
  [7085] = 6950,
  [7086] = 6953,
  [7087] = 6950,
  [7088] = 2854,
  [7089] = 6949,
  [7090] = 2854,
  [7091] = 7091,
  [7092] = 6949,
  [7093] = 6950,
  [7094] = 6953,
  [7095] = 6953,
  [7096] = 6950,
  [7097] = 7075,
  [7098] = 6949,
  [7099] = 2854,
  [7100] = 6953,
  [7101] = 2854,
  [7102] = 6953,
  [7103] = 6950,
  [7104] = 2854,
  [7105] = 2854,
  [7106] = 6949,
  [7107] = 6953,
  [7108] = 2854,
  [7109] = 6949,
  [7110] = 6949,
  [7111] = 6962,
  [7112] = 2854,
  [7113] = 6974,
  [7114] = 6950,
  [7115] = 6950,
  [7116] = 2854,
  [7117] = 6949,
  [7118] = 6949,
  [7119] = 6953,
  [7120] = 6953,
  [7121] = 6950,
  [7122] = 6953,
  [7123] = 6950,
  [7124] = 6950,
  [7125] = 2854,
  [7126] = 6949,
  [7127] = 6950,
  [7128] = 2854,
  [7129] = 6953,
  [7130] = 6949,
  [7131] = 6950,
  [7132] = 6949,
  [7133] = 2854,
  [7134] = 6953,
  [7135] = 6949,
  [7136] = 6950,
  [7137] = 3606,
  [7138] = 6953,
  [7139] = 2854,
  [7140] = 6953,
  [7141] = 6950,
  [7142] = 2854,
  [7143] = 6949,
  [7144] = 6949,
  [7145] = 6953,
  [7146] = 6950,
  [7147] = 6950,
  [7148] = 6953,
  [7149] = 6950,
  [7150] = 2854,
  [7151] = 2854,
  [7152] = 6949,
  [7153] = 6953,
  [7154] = 6949,
  [7155] = 6953,
  [7156] = 6953,
  [7157] = 6950,
  [7158] = 2854,
  [7159] = 7159,
  [7160] = 7160,
  [7161] = 7161,
  [7162] = 7159,
  [7163] = 7163,
  [7164] = 7161,
  [7165] = 7159,
  [7166] = 7161,
  [7167] = 7161,
  [7168] = 7159,
  [7169] = 7163,
  [7170] = 7160,
  [7171] = 7161,
  [7172] = 7161,
  [7173] = 7173,
  [7174] = 7161,
  [7175] = 7159,
  [7176] = 7176,
  [7177] = 7163,
  [7178] = 7160,
  [7179] = 7159,
  [7180] = 7161,
  [7181] = 7161,
  [7182] = 7159,
  [7183] = 7163,
  [7184] = 7160,
  [7185] = 7161,
  [7186] = 7161,
  [7187] = 7187,
  [7188] = 7161,
  [7189] = 7189,
  [7190] = 7160,
  [7191] = 7191,
  [7192] = 7192,
  [7193] = 7161,
  [7194] = 7163,
  [7195] = 7161,
  [7196] = 7159,
  [7197] = 7161,
  [7198] = 7159,
  [7199] = 7189,
  [7200] = 7163,
  [7201] = 7163,
  [7202] = 7161,
  [7203] = 7160,
  [7204] = 7161,
  [7205] = 7205,
  [7206] = 7159,
  [7207] = 7161,
  [7208] = 7163,
  [7209] = 7173,
  [7210] = 7160,
  [7211] = 7161,
  [7212] = 7161,
  [7213] = 7161,
  [7214] = 7176,
  [7215] = 7161,
  [7216] = 7216,
  [7217] = 7161,
  [7218] = 7218,
  [7219] = 7176,
  [7220] = 7163,
  [7221] = 7161,
  [7222] = 7161,
  [7223] = 7161,
  [7224] = 7191,
  [7225] = 7225,
  [7226] = 7161,
  [7227] = 7163,
  [7228] = 7159,
  [7229] = 7161,
  [7230] = 7173,
  [7231] = 7161,
  [7232] = 7163,
  [7233] = 7161,
  [7234] = 7173,
  [7235] = 7159,
  [7236] = 7160,
  [7237] = 7161,
  [7238] = 7238,
  [7239] = 7161,
  [7240] = 7161,
  [7241] = 7161,
  [7242] = 7238,
  [7243] = 7161,
  [7244] = 7191,
  [7245] = 7161,
  [7246] = 7159,
  [7247] = 7238,
  [7248] = 7161,
  [7249] = 7161,
  [7250] = 7161,
  [7251] = 7159,
  [7252] = 7161,
  [7253] = 7173,
  [7254] = 7161,
  [7255] = 7160,
  [7256] = 7161,
  [7257] = 7161,
  [7258] = 7173,
  [7259] = 7161,
  [7260] = 7161,
  [7261] = 7261,
  [7262] = 7159,
  [7263] = 7161,
  [7264] = 7163,
  [7265] = 7161,
  [7266] = 7161,
  [7267] = 7191,
  [7268] = 7161,
  [7269] = 7191,
  [7270] = 7161,
  [7271] = 7161,
  [7272] = 7189,
  [7273] = 7161,
  [7274] = 7161,
  [7275] = 7161,
  [7276] = 7163,
  [7277] = 7277,
  [7278] = 7278,
  [7279] = 7163,
  [7280] = 7161,
  [7281] = 7161,
  [7282] = 7163,
  [7283] = 7283,
  [7284] = 7284,
  [7285] = 7285,
  [7286] = 7286,
  [7287] = 3784,
  [7288] = 3779,
  [7289] = 3792,
  [7290] = 3740,
  [7291] = 3778,
  [7292] = 7292,
  [7293] = 7293,
  [7294] = 7294,
  [7295] = 7295,
  [7296] = 7296,
  [7297] = 7297,
  [7298] = 7298,
  [7299] = 7299,
  [7300] = 7298,
  [7301] = 7301,
  [7302] = 7302,
  [7303] = 7299,
  [7304] = 7304,
  [7305] = 7301,
  [7306] = 7297,
  [7307] = 7307,
  [7308] = 7299,
  [7309] = 7307,
  [7310] = 7310,
  [7311] = 7311,
  [7312] = 7311,
  [7313] = 7307,
  [7314] = 7314,
  [7315] = 7299,
  [7316] = 7316,
  [7317] = 7304,
  [7318] = 7318,
  [7319] = 7302,
  [7320] = 7320,
  [7321] = 7299,
  [7322] = 7296,
  [7323] = 7307,
  [7324] = 7299,
  [7325] = 7325,
  [7326] = 7299,
  [7327] = 7299,
  [7328] = 7328,
  [7329] = 7329,
  [7330] = 7330,
  [7331] = 7331,
  [7332] = 7299,
  [7333] = 7302,
  [7334] = 7299,
  [7335] = 7335,
  [7336] = 7299,
  [7337] = 7337,
  [7338] = 7338,
  [7339] = 7314,
  [7340] = 7335,
  [7341] = 7299,
  [7342] = 7342,
  [7343] = 7343,
  [7344] = 7342,
  [7345] = 7345,
  [7346] = 7299,
  [7347] = 7299,
  [7348] = 7348,
  [7349] = 7349,
  [7350] = 7350,
  [7351] = 7351,
  [7352] = 7352,
  [7353] = 7353,
  [7354] = 7354,
  [7355] = 7299,
  [7356] = 7353,
  [7357] = 7343,
  [7358] = 7343,
  [7359] = 7335,
  [7360] = 7294,
  [7361] = 7299,
  [7362] = 7350,
  [7363] = 7363,
  [7364] = 7353,
  [7365] = 7295,
  [7366] = 7310,
  [7367] = 7354,
  [7368] = 7314,
  [7369] = 7338,
  [7370] = 7352,
  [7371] = 7293,
  [7372] = 7299,
  [7373] = 7293,
  [7374] = 7352,
  [7375] = 7342,
  [7376] = 7295,
  [7377] = 7350,
  [7378] = 7338,
  [7379] = 7301,
  [7380] = 7311,
  [7381] = 7354,
  [7382] = 7304,
  [7383] = 7298,
  [7384] = 7299,
  [7385] = 7385,
  [7386] = 7299,
  [7387] = 7296,
  [7388] = 7310,
  [7389] = 7299,
  [7390] = 7297,
  [7391] = 7391,
  [7392] = 7392,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7395,
  [7396] = 7396,
  [7397] = 7397,
  [7398] = 7398,
  [7399] = 7399,
  [7400] = 7400,
  [7401] = 7401,
  [7402] = 7402,
  [7403] = 7403,
  [7404] = 7404,
  [7405] = 7405,
  [7406] = 7405,
  [7407] = 7405,
  [7408] = 7405,
  [7409] = 7405,
  [7410] = 7405,
  [7411] = 7405,
  [7412] = 7405,
  [7413] = 7405,
  [7414] = 7405,
  [7415] = 7405,
  [7416] = 7405,
  [7417] = 7405,
  [7418] = 7405,
  [7419] = 7405,
  [7420] = 7405,
  [7421] = 7405,
  [7422] = 7405,
  [7423] = 7405,
  [7424] = 7405,
  [7425] = 7405,
  [7426] = 7405,
  [7427] = 7405,
  [7428] = 7405,
  [7429] = 7405,
  [7430] = 7405,
  [7431] = 7405,
  [7432] = 7405,
  [7433] = 7405,
  [7434] = 7405,
  [7435] = 7405,
  [7436] = 7405,
  [7437] = 7405,
  [7438] = 7405,
  [7439] = 7405,
  [7440] = 7405,
  [7441] = 7441,
  [7442] = 7442,
  [7443] = 7441,
  [7444] = 7444,
  [7445] = 7442,
  [7446] = 7441,
  [7447] = 7441,
  [7448] = 7441,
  [7449] = 7441,
  [7450] = 7444,
  [7451] = 7444,
  [7452] = 7441,
  [7453] = 7441,
  [7454] = 7441,
  [7455] = 7442,
  [7456] = 7441,
  [7457] = 7444,
  [7458] = 7444,
  [7459] = 7442,
  [7460] = 7444,
  [7461] = 7441,
  [7462] = 7444,
  [7463] = 7444,
  [7464] = 7444,
  [7465] = 7442,
  [7466] = 7444,
  [7467] = 7442,
  [7468] = 7442,
  [7469] = 7442,
  [7470] = 7444,
  [7471] = 7441,
  [7472] = 7442,
  [7473] = 7442,
  [7474] = 7442,
  [7475] = 7442,
  [7476] = 7442,
  [7477] = 7444,
  [7478] = 7442,
  [7479] = 7441,
  [7480] = 7444,
  [7481] = 7441,
  [7482] = 7444,
  [7483] = 7444,
  [7484] = 7442,
  [7485] = 7441,
  [7486] = 7441,
  [7487] = 7444,
  [7488] = 7441,
  [7489] = 7444,
  [7490] = 7442,
  [7491] = 7444,
  [7492] = 7442,
  [7493] = 7442,
  [7494] = 7441,
  [7495] = 7444,
  [7496] = 7441,
  [7497] = 7442,
  [7498] = 7444,
  [7499] = 7441,
  [7500] = 7442,
  [7501] = 7501,
  [7502] = 7502,
  [7503] = 7503,
  [7504] = 7504,
  [7505] = 7505,
  [7506] = 7506,
  [7507] = 7507,
  [7508] = 7505,
  [7509] = 7509,
  [7510] = 7509,
  [7511] = 7506,
  [7512] = 7505,
  [7513] = 7507,
  [7514] = 7509,
  [7515] = 7507,
  [7516] = 7506,
  [7517] = 7517,
  [7518] = 7518,
  [7519] = 7519,
  [7520] = 7519,
  [7521] = 7521,
  [7522] = 7522,
  [7523] = 7523,
  [7524] = 7524,
  [7525] = 7519,
  [7526] = 7526,
  [7527] = 7521,
  [7528] = 7528,
  [7529] = 7523,
  [7530] = 7530,
  [7531] = 7531,
  [7532] = 7521,
  [7533] = 7522,
  [7534] = 7528,
  [7535] = 7523,
  [7536] = 7518,
  [7537] = 7522,
  [7538] = 7528,
  [7539] = 7517,
  [7540] = 7517,
  [7541] = 7518,
  [7542] = 7542,
  [7543] = 7542,
  [7544] = 7544,
  [7545] = 7545,
  [7546] = 7546,
  [7547] = 7546,
  [7548] = 7546,
  [7549] = 7545,
  [7550] = 7544,
  [7551] = 7544,
  [7552] = 7552,
  [7553] = 7545,
  [7554] = 7552,
  [7555] = 7552,
  [7556] = 7546,
  [7557] = 7542,
  [7558] = 7558,
  [7559] = 7559,
  [7560] = 7560,
  [7561] = 7561,
  [7562] = 7562,
  [7563] = 7563,
  [7564] = 7564,
  [7565] = 7565,
  [7566] = 7566,
  [7567] = 7567,
  [7568] = 7568,
  [7569] = 7568,
  [7570] = 7570,
  [7571] = 7571,
  [7572] = 7558,
  [7573] = 7560,
  [7574] = 7574,
  [7575] = 7575,
  [7576] = 7576,
  [7577] = 7577,
  [7578] = 7578,
  [7579] = 7567,
  [7580] = 7577,
  [7581] = 7581,
  [7582] = 7561,
  [7583] = 7583,
  [7584] = 7584,
  [7585] = 7585,
  [7586] = 7586,
  [7587] = 7587,
  [7588] = 7566,
  [7589] = 7576,
  [7590] = 7565,
  [7591] = 7591,
  [7592] = 7592,
  [7593] = 7574,
  [7594] = 7559,
  [7595] = 7568,
  [7596] = 7560,
  [7597] = 7571,
  [7598] = 7570,
  [7599] = 7599,
  [7600] = 7571,
  [7601] = 7601,
  [7602] = 7602,
  [7603] = 7583,
  [7604] = 7604,
  [7605] = 7605,
  [7606] = 7561,
  [7607] = 7558,
  [7608] = 7576,
  [7609] = 7609,
  [7610] = 7602,
  [7611] = 7611,
  [7612] = 7612,
  [7613] = 7560,
  [7614] = 7559,
  [7615] = 7591,
  [7616] = 7616,
  [7617] = 7591,
  [7618] = 7618,
  [7619] = 7570,
  [7620] = 7565,
  [7621] = 7583,
  [7622] = 7577,
  [7623] = 7561,
  [7624] = 7559,
  [7625] = 7564,
  [7626] = 7563,
  [7627] = 7627,
  [7628] = 7591,
  [7629] = 7563,
  [7630] = 7568,
  [7631] = 7563,
  [7632] = 7564,
  [7633] = 7633,
  [7634] = 7584,
  [7635] = 7635,
  [7636] = 7633,
  [7637] = 7583,
  [7638] = 7577,
  [7639] = 7576,
  [7640] = 7565,
  [7641] = 7571,
  [7642] = 7633,
  [7643] = 7635,
  [7644] = 7644,
  [7645] = 7645,
  [7646] = 7635,
  [7647] = 7584,
  [7648] = 7574,
  [7649] = 7566,
  [7650] = 7581,
  [7651] = 7651,
  [7652] = 7652,
  [7653] = 7581,
  [7654] = 7570,
  [7655] = 7655,
  [7656] = 7656,
  [7657] = 7567,
  [7658] = 7658,
  [7659] = 7659,
  [7660] = 7660,
  [7661] = 7602,
  [7662] = 7662,
  [7663] = 7663,
  [7664] = 7575,
  [7665] = 7665,
  [7666] = 7666,
  [7667] = 7575,
  [7668] = 7564,
  [7669] = 7669,
  [7670] = 7670,
  [7671] = 7671,
  [7672] = 7672,
  [7673] = 7673,
  [7674] = 7672,
  [7675] = 7675,
  [7676] = 7669,
  [7677] = 7669,
  [7678] = 7678,
  [7679] = 7678,
  [7680] = 7670,
  [7681] = 7681,
  [7682] = 7682,
  [7683] = 7675,
  [7684] = 7670,
  [7685] = 7673,
  [7686] = 7675,
  [7687] = 7687,
  [7688] = 7688,
  [7689] = 7689,
  [7690] = 7690,
  [7691] = 7691,
  [7692] = 7692,
  [7693] = 7693,
  [7694] = 7673,
  [7695] = 7688,
  [7696] = 7678,
  [7697] = 7690,
  [7698] = 7688,
  [7699] = 7699,
  [7700] = 7672,
  [7701] = 7690,
  [7702] = 7702,
  [7703] = 2211,
  [7704] = 7704,
  [7705] = 7705,
  [7706] = 7706,
  [7707] = 7707,
  [7708] = 7702,
  [7709] = 7709,
  [7710] = 7707,
  [7711] = 7709,
  [7712] = 7709,
  [7713] = 7713,
  [7714] = 7705,
  [7715] = 7715,
  [7716] = 7713,
  [7717] = 7706,
  [7718] = 7718,
  [7719] = 7702,
  [7720] = 7707,
  [7721] = 7721,
  [7722] = 7722,
  [7723] = 7723,
  [7724] = 7724,
  [7725] = 7725,
  [7726] = 7726,
  [7727] = 7724,
  [7728] = 7728,
  [7729] = 7728,
  [7730] = 7723,
  [7731] = 7704,
  [7732] = 7732,
  [7733] = 7733,
  [7734] = 7732,
  [7735] = 7733,
  [7736] = 7736,
  [7737] = 7736,
  [7738] = 7738,
  [7739] = 7704,
  [7740] = 7738,
  [7741] = 7741,
  [7742] = 7723,
  [7743] = 7741,
  [7744] = 7721,
  [7745] = 7722,
  [7746] = 7726,
  [7747] = 7725,
  [7748] = 7726,
  [7749] = 7725,
  [7750] = 7722,
  [7751] = 7721,
  [7752] = 2210,
  [7753] = 7753,
  [7754] = 7704,
  [7755] = 7736,
  [7756] = 7756,
  [7757] = 7723,
  [7758] = 7713,
  [7759] = 7741,
  [7760] = 7723,
  [7761] = 7761,
  [7762] = 7732,
  [7763] = 7704,
  [7764] = 7733,
  [7765] = 7738,
  [7766] = 7724,
  [7767] = 7705,
  [7768] = 7728,
  [7769] = 7706,
  [7770] = 7770,
  [7771] = 7771,
  [7772] = 7772,
  [7773] = 7773,
  [7774] = 7774,
  [7775] = 7775,
  [7776] = 7776,
  [7777] = 7777,
  [7778] = 7778,
  [7779] = 7779,
  [7780] = 2745,
  [7781] = 2744,
  [7782] = 7782,
  [7783] = 7783,
  [7784] = 7784,
  [7785] = 7785,
  [7786] = 7786,
  [7787] = 7787,
  [7788] = 7788,
  [7789] = 7789,
  [7790] = 7774,
  [7791] = 7791,
  [7792] = 7789,
  [7793] = 7793,
  [7794] = 7794,
  [7795] = 7795,
  [7796] = 7796,
  [7797] = 7797,
  [7798] = 6761,
  [7799] = 7799,
  [7800] = 3012,
  [7801] = 7801,
  [7802] = 7802,
  [7803] = 7803,
  [7804] = 7795,
  [7805] = 7805,
  [7806] = 7806,
  [7807] = 7771,
  [7808] = 7808,
  [7809] = 7809,
  [7810] = 7810,
  [7811] = 7811,
  [7812] = 7812,
  [7813] = 7813,
  [7814] = 7789,
  [7815] = 7806,
  [7816] = 7816,
  [7817] = 7817,
  [7818] = 7818,
  [7819] = 7805,
  [7820] = 7820,
  [7821] = 7821,
  [7822] = 7794,
  [7823] = 7823,
  [7824] = 7824,
  [7825] = 7825,
  [7826] = 7795,
  [7827] = 7797,
  [7828] = 7828,
  [7829] = 7808,
  [7830] = 7796,
  [7831] = 2212,
  [7832] = 7789,
  [7833] = 7833,
  [7834] = 7834,
  [7835] = 7835,
  [7836] = 7836,
  [7837] = 7837,
  [7838] = 7838,
  [7839] = 7839,
  [7840] = 7840,
  [7841] = 7841,
  [7842] = 7842,
  [7843] = 7843,
  [7844] = 7844,
  [7845] = 7845,
  [7846] = 7846,
  [7847] = 7847,
  [7848] = 7824,
  [7849] = 7849,
  [7850] = 7808,
  [7851] = 7771,
  [7852] = 7773,
  [7853] = 7853,
  [7854] = 7854,
  [7855] = 7855,
  [7856] = 7773,
  [7857] = 7833,
  [7858] = 7833,
  [7859] = 7836,
  [7860] = 7860,
  [7861] = 7836,
  [7862] = 7862,
  [7863] = 7863,
  [7864] = 7862,
  [7865] = 7863,
  [7866] = 7860,
  [7867] = 7860,
  [7868] = 7776,
  [7869] = 7846,
  [7870] = 7789,
  [7871] = 7806,
  [7872] = 7854,
  [7873] = 7873,
  [7874] = 7805,
  [7875] = 7853,
  [7876] = 7784,
  [7877] = 7776,
  [7878] = 7784,
  [7879] = 7879,
  [7880] = 7880,
  [7881] = 7817,
  [7882] = 7796,
  [7883] = 7817,
  [7884] = 7818,
  [7885] = 7818,
  [7886] = 7886,
  [7887] = 7842,
  [7888] = 7841,
  [7889] = 7797,
  [7890] = 7809,
  [7891] = 7795,
  [7892] = 7886,
  [7893] = 7795,
  [7894] = 7797,
  [7895] = 7873,
  [7896] = 7842,
  [7897] = 7897,
  [7898] = 7796,
  [7899] = 7841,
  [7900] = 7802,
  [7901] = 7806,
  [7902] = 7902,
  [7903] = 7799,
  [7904] = 7805,
  [7905] = 7802,
  [7906] = 7805,
  [7907] = 7799,
  [7908] = 7779,
  [7909] = 7886,
  [7910] = 7789,
  [7911] = 7778,
  [7912] = 7912,
  [7913] = 7806,
  [7914] = 7914,
  [7915] = 7772,
  [7916] = 7779,
  [7917] = 7917,
  [7918] = 7778,
  [7919] = 7855,
  [7920] = 7854,
  [7921] = 7772,
  [7922] = 7922,
  [7923] = 7855,
  [7924] = 7853,
  [7925] = 7795,
  [7926] = 7926,
  [7927] = 7846,
  [7928] = 7873,
  [7929] = 7846,
  [7930] = 7809,
  [7931] = 7793,
  [7932] = 7796,
  [7933] = 7794,
  [7934] = 7797,
  [7935] = 7791,
  [7936] = 7793,
  [7937] = 7791,
  [7938] = 7774,
  [7939] = 7863,
  [7940] = 7824,
  [7941] = 7862,
  [7942] = 7942,
  [7943] = 7943,
  [7944] = 7944,
  [7945] = 7945,
  [7946] = 7946,
  [7947] = 7947,
  [7948] = 7948,
  [7949] = 7949,
  [7950] = 7950,
  [7951] = 7951,
  [7952] = 7952,
  [7953] = 7953,
  [7954] = 7954,
  [7955] = 7955,
  [7956] = 7956,
  [7957] = 7957,
  [7958] = 7958,
  [7959] = 7959,
  [7960] = 7960,
  [7961] = 7961,
  [7962] = 7962,
  [7963] = 7963,
  [7964] = 7964,
  [7965] = 7965,
  [7966] = 7959,
  [7967] = 7943,
  [7968] = 7947,
  [7969] = 7969,
  [7970] = 7970,
  [7971] = 7969,
  [7972] = 7972,
  [7973] = 7973,
  [7974] = 7974,
  [7975] = 7947,
  [7976] = 7976,
  [7977] = 7977,
  [7978] = 7978,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7981,
  [7982] = 7982,
  [7983] = 7957,
  [7984] = 7954,
  [7985] = 7953,
  [7986] = 7951,
  [7987] = 7946,
  [7988] = 7945,
  [7989] = 7943,
  [7990] = 7990,
  [7991] = 2944,
  [7992] = 7965,
  [7993] = 7812,
  [7994] = 7994,
  [7995] = 7995,
  [7996] = 7972,
  [7997] = 7970,
  [7998] = 7973,
  [7999] = 7999,
  [8000] = 8000,
  [8001] = 8001,
  [8002] = 7974,
  [8003] = 8003,
  [8004] = 7959,
  [8005] = 8005,
  [8006] = 8006,
  [8007] = 8007,
  [8008] = 8008,
  [8009] = 8009,
  [8010] = 7976,
  [8011] = 7970,
  [8012] = 7977,
  [8013] = 8013,
  [8014] = 7970,
  [8015] = 7970,
  [8016] = 8016,
  [8017] = 7978,
  [8018] = 8018,
  [8019] = 7942,
  [8020] = 8020,
  [8021] = 7980,
  [8022] = 8022,
  [8023] = 8023,
  [8024] = 8024,
  [8025] = 7952,
  [8026] = 8026,
  [8027] = 8027,
  [8028] = 8028,
  [8029] = 8029,
  [8030] = 8030,
  [8031] = 8031,
  [8032] = 8032,
  [8033] = 8033,
  [8034] = 8034,
  [8035] = 7947,
  [8036] = 8036,
  [8037] = 8037,
  [8038] = 8038,
  [8039] = 8039,
  [8040] = 7959,
  [8041] = 8041,
  [8042] = 8042,
  [8043] = 8043,
  [8044] = 7947,
  [8045] = 8045,
  [8046] = 8046,
  [8047] = 8047,
  [8048] = 8048,
  [8049] = 8045,
  [8050] = 8050,
  [8051] = 7981,
  [8052] = 8052,
  [8053] = 8053,
  [8054] = 8054,
  [8055] = 8055,
  [8056] = 7947,
  [8057] = 4666,
  [8058] = 8058,
  [8059] = 8059,
  [8060] = 8060,
  [8061] = 8061,
  [8062] = 8062,
  [8063] = 8063,
  [8064] = 8064,
  [8065] = 7961,
  [8066] = 8066,
  [8067] = 8067,
  [8068] = 8068,
  [8069] = 8069,
  [8070] = 8070,
  [8071] = 8031,
  [8072] = 8072,
  [8073] = 7942,
  [8074] = 7990,
  [8075] = 8075,
  [8076] = 8033,
  [8077] = 8032,
  [8078] = 7982,
  [8079] = 7959,
  [8080] = 8080,
  [8081] = 8081,
  [8082] = 8082,
  [8083] = 8075,
  [8084] = 7964,
  [8085] = 8000,
  [8086] = 8072,
  [8087] = 7970,
  [8088] = 7960,
  [8089] = 7960,
  [8090] = 8090,
  [8091] = 8091,
  [8092] = 8062,
  [8093] = 8047,
  [8094] = 8067,
  [8095] = 8063,
  [8096] = 8096,
  [8097] = 8097,
  [8098] = 7963,
  [8099] = 8045,
  [8100] = 7962,
  [8101] = 7959,
  [8102] = 7970,
  [8103] = 8032,
  [8104] = 8070,
  [8105] = 8105,
  [8106] = 8013,
  [8107] = 8033,
  [8108] = 8075,
  [8109] = 8047,
  [8110] = 8072,
  [8111] = 8030,
  [8112] = 8080,
  [8113] = 8029,
  [8114] = 8037,
  [8115] = 8115,
  [8116] = 8028,
  [8117] = 8117,
  [8118] = 8067,
  [8119] = 8119,
  [8120] = 7981,
  [8121] = 8063,
  [8122] = 8122,
  [8123] = 8000,
  [8124] = 7981,
  [8125] = 3667,
  [8126] = 8027,
  [8127] = 8082,
  [8128] = 8128,
  [8129] = 8081,
  [8130] = 8038,
  [8131] = 8080,
  [8132] = 8132,
  [8133] = 7982,
  [8134] = 7958,
  [8135] = 7990,
  [8136] = 8136,
  [8137] = 8031,
  [8138] = 8064,
  [8139] = 7956,
  [8140] = 8140,
  [8141] = 8070,
  [8142] = 8069,
  [8143] = 8143,
  [8144] = 8115,
  [8145] = 7945,
  [8146] = 7946,
  [8147] = 8047,
  [8148] = 8066,
  [8149] = 8039,
  [8150] = 7961,
  [8151] = 3692,
  [8152] = 7951,
  [8153] = 8153,
  [8154] = 8064,
  [8155] = 7952,
  [8156] = 7953,
  [8157] = 8062,
  [8158] = 7954,
  [8159] = 8041,
  [8160] = 8160,
  [8161] = 8055,
  [8162] = 8054,
  [8163] = 8058,
  [8164] = 7957,
  [8165] = 8060,
  [8166] = 8053,
  [8167] = 8061,
  [8168] = 8052,
  [8169] = 7969,
  [8170] = 8050,
  [8171] = 8068,
  [8172] = 8172,
  [8173] = 8042,
  [8174] = 8048,
  [8175] = 7965,
  [8176] = 8046,
  [8177] = 8177,
  [8178] = 8042,
  [8179] = 8179,
  [8180] = 8041,
  [8181] = 7956,
  [8182] = 8039,
  [8183] = 8038,
  [8184] = 8037,
  [8185] = 7958,
  [8186] = 7952,
  [8187] = 7962,
  [8188] = 8030,
  [8189] = 4635,
  [8190] = 8029,
  [8191] = 8028,
  [8192] = 8027,
  [8193] = 7963,
  [8194] = 8055,
  [8195] = 8023,
  [8196] = 8022,
  [8197] = 7972,
  [8198] = 7960,
  [8199] = 8023,
  [8200] = 8018,
  [8201] = 7973,
  [8202] = 8022,
  [8203] = 7981,
  [8204] = 8016,
  [8205] = 7974,
  [8206] = 8069,
  [8207] = 8046,
  [8208] = 8018,
  [8209] = 8081,
  [8210] = 7976,
  [8211] = 7977,
  [8212] = 8016,
  [8213] = 7978,
  [8214] = 8048,
  [8215] = 8153,
  [8216] = 8008,
  [8217] = 8007,
  [8218] = 8082,
  [8219] = 8045,
  [8220] = 8050,
  [8221] = 8006,
  [8222] = 8005,
  [8223] = 7980,
  [8224] = 7944,
  [8225] = 8008,
  [8226] = 8003,
  [8227] = 8007,
  [8228] = 8228,
  [8229] = 8006,
  [8230] = 8066,
  [8231] = 8005,
  [8232] = 8052,
  [8233] = 8001,
  [8234] = 8003,
  [8235] = 8054,
  [8236] = 8001,
  [8237] = 8053,
  [8238] = 7999,
  [8239] = 7999,
  [8240] = 8240,
  [8241] = 8241,
  [8242] = 8241,
  [8243] = 8243,
  [8244] = 8244,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 8247,
  [8248] = 8248,
  [8249] = 8249,
  [8250] = 8250,
  [8251] = 8251,
  [8252] = 4666,
  [8253] = 8253,
  [8254] = 8254,
  [8255] = 8248,
  [8256] = 8256,
  [8257] = 8254,
  [8258] = 8258,
  [8259] = 8243,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8251,
  [8263] = 8263,
  [8264] = 8264,
  [8265] = 8265,
  [8266] = 8266,
  [8267] = 4666,
  [8268] = 8268,
  [8269] = 8266,
  [8270] = 8270,
  [8271] = 8264,
  [8272] = 8272,
  [8273] = 8243,
  [8274] = 8274,
  [8275] = 8275,
  [8276] = 8276,
  [8277] = 8277,
  [8278] = 8278,
  [8279] = 8250,
  [8280] = 8280,
  [8281] = 8281,
  [8282] = 4635,
  [8283] = 8283,
  [8284] = 8268,
  [8285] = 8246,
  [8286] = 8253,
  [8287] = 8287,
  [8288] = 8249,
  [8289] = 8289,
  [8290] = 8290,
  [8291] = 8253,
  [8292] = 8292,
  [8293] = 8293,
  [8294] = 8243,
  [8295] = 8246,
  [8296] = 4666,
  [8297] = 8278,
  [8298] = 8290,
  [8299] = 8277,
  [8300] = 8281,
  [8301] = 8247,
  [8302] = 2909,
  [8303] = 8277,
  [8304] = 2884,
  [8305] = 8243,
  [8306] = 2915,
  [8307] = 8241,
  [8308] = 8272,
  [8309] = 2895,
  [8310] = 2889,
  [8311] = 8258,
  [8312] = 8243,
  [8313] = 8249,
  [8314] = 8248,
  [8315] = 8315,
  [8316] = 8243,
  [8317] = 8256,
  [8318] = 8266,
  [8319] = 8266,
  [8320] = 8250,
  [8321] = 4635,
  [8322] = 8322,
  [8323] = 8290,
  [8324] = 8324,
  [8325] = 8253,
  [8326] = 8251,
  [8327] = 8247,
  [8328] = 8328,
  [8329] = 8329,
  [8330] = 8330,
  [8331] = 8331,
  [8332] = 8278,
  [8333] = 8333,
  [8334] = 2946,
  [8335] = 8335,
  [8336] = 8245,
  [8337] = 8243,
  [8338] = 8263,
  [8339] = 8339,
  [8340] = 8254,
  [8341] = 8341,
  [8342] = 8342,
  [8343] = 8343,
  [8344] = 8344,
  [8345] = 8345,
  [8346] = 8346,
  [8347] = 2215,
  [8348] = 8240,
  [8349] = 8245,
  [8350] = 8350,
  [8351] = 8247,
  [8352] = 8268,
  [8353] = 8276,
  [8354] = 8281,
  [8355] = 8263,
  [8356] = 2218,
  [8357] = 2217,
  [8358] = 8344,
  [8359] = 8359,
  [8360] = 8264,
  [8361] = 8361,
  [8362] = 2216,
  [8363] = 8363,
  [8364] = 8364,
  [8365] = 8365,
  [8366] = 8366,
  [8367] = 8367,
  [8368] = 8368,
  [8369] = 8253,
  [8370] = 8370,
  [8371] = 4635,
  [8372] = 8256,
  [8373] = 8258,
  [8374] = 8374,
  [8375] = 8272,
  [8376] = 8376,
  [8377] = 8377,
  [8378] = 8378,
  [8379] = 8379,
  [8380] = 8368,
  [8381] = 8381,
  [8382] = 8382,
  [8383] = 8383,
  [8384] = 8384,
  [8385] = 8385,
  [8386] = 8377,
  [8387] = 8382,
  [8388] = 8388,
  [8389] = 8389,
  [8390] = 8377,
  [8391] = 8391,
  [8392] = 8392,
  [8393] = 8393,
  [8394] = 8394,
  [8395] = 8395,
  [8396] = 8396,
  [8397] = 8397,
  [8398] = 8398,
  [8399] = 8399,
  [8400] = 8400,
  [8401] = 8401,
  [8402] = 8402,
  [8403] = 8382,
  [8404] = 8378,
  [8405] = 8382,
  [8406] = 8406,
  [8407] = 8407,
  [8408] = 8408,
  [8409] = 8377,
  [8410] = 8410,
  [8411] = 8411,
  [8412] = 8412,
  [8413] = 8413,
  [8414] = 8414,
  [8415] = 8415,
  [8416] = 8416,
  [8417] = 8417,
  [8418] = 8378,
  [8419] = 8367,
  [8420] = 8420,
  [8421] = 8421,
  [8422] = 8377,
  [8423] = 8423,
  [8424] = 8424,
  [8425] = 8425,
  [8426] = 8426,
  [8427] = 8427,
  [8428] = 8383,
  [8429] = 8429,
  [8430] = 8377,
  [8431] = 8370,
  [8432] = 8432,
  [8433] = 8401,
  [8434] = 8398,
  [8435] = 8385,
  [8436] = 8436,
  [8437] = 8391,
  [8438] = 8415,
  [8439] = 8414,
  [8440] = 8440,
  [8441] = 8441,
  [8442] = 8442,
  [8443] = 8413,
  [8444] = 8415,
  [8445] = 8445,
  [8446] = 8382,
  [8447] = 8447,
  [8448] = 8414,
  [8449] = 8449,
  [8450] = 8413,
  [8451] = 8451,
  [8452] = 8452,
  [8453] = 8453,
  [8454] = 8454,
  [8455] = 8451,
  [8456] = 8456,
  [8457] = 8406,
  [8458] = 8383,
  [8459] = 8406,
  [8460] = 8460,
  [8461] = 8396,
  [8462] = 8462,
  [8463] = 8463,
  [8464] = 8464,
  [8465] = 8402,
  [8466] = 8394,
  [8467] = 8383,
  [8468] = 8468,
  [8469] = 8393,
  [8470] = 8427,
  [8471] = 8471,
  [8472] = 8472,
  [8473] = 8447,
  [8474] = 8474,
  [8475] = 8451,
  [8476] = 8382,
  [8477] = 8477,
  [8478] = 8393,
  [8479] = 8401,
  [8480] = 8398,
  [8481] = 8481,
  [8482] = 8482,
  [8483] = 8483,
  [8484] = 8484,
  [8485] = 8485,
  [8486] = 8401,
  [8487] = 8487,
  [8488] = 8382,
  [8489] = 8489,
  [8490] = 8383,
  [8491] = 8491,
  [8492] = 8383,
  [8493] = 8410,
  [8494] = 8494,
  [8495] = 8420,
  [8496] = 8496,
  [8497] = 8383,
  [8498] = 8410,
  [8499] = 8382,
  [8500] = 8500,
  [8501] = 8383,
  [8502] = 8385,
  [8503] = 8420,
  [8504] = 8415,
  [8505] = 8505,
  [8506] = 8406,
  [8507] = 8414,
  [8508] = 8508,
  [8509] = 8509,
  [8510] = 8510,
  [8511] = 8511,
  [8512] = 8396,
  [8513] = 8513,
  [8514] = 8442,
  [8515] = 8410,
  [8516] = 8427,
  [8517] = 8427,
  [8518] = 8518,
  [8519] = 8393,
  [8520] = 8413,
  [8521] = 8394,
  [8522] = 8522,
  [8523] = 8464,
  [8524] = 8460,
  [8525] = 8423,
  [8526] = 8526,
  [8527] = 8396,
  [8528] = 8464,
  [8529] = 8420,
  [8530] = 8406,
  [8531] = 8460,
  [8532] = 8451,
  [8533] = 8533,
  [8534] = 8451,
  [8535] = 8494,
  [8536] = 8536,
  [8537] = 8406,
  [8538] = 8463,
  [8539] = 8413,
  [8540] = 8396,
  [8541] = 8413,
  [8542] = 8406,
  [8543] = 8396,
  [8544] = 8414,
  [8545] = 8383,
  [8546] = 8546,
  [8547] = 8393,
  [8548] = 8548,
  [8549] = 8410,
  [8550] = 8382,
  [8551] = 8383,
  [8552] = 8447,
  [8553] = 8464,
  [8554] = 8432,
  [8555] = 8378,
  [8556] = 8556,
  [8557] = 8382,
  [8558] = 8460,
  [8559] = 8559,
  [8560] = 8415,
  [8561] = 8406,
  [8562] = 8562,
  [8563] = 8429,
  [8564] = 8564,
  [8565] = 8565,
  [8566] = 8566,
  [8567] = 8567,
  [8568] = 8568,
  [8569] = 8569,
  [8570] = 8410,
  [8571] = 8424,
  [8572] = 8378,
  [8573] = 8447,
  [8574] = 8574,
  [8575] = 8394,
  [8576] = 8377,
  [8577] = 8402,
  [8578] = 8383,
  [8579] = 8432,
  [8580] = 8382,
  [8581] = 8378,
  [8582] = 8394,
  [8583] = 8460,
  [8584] = 8432,
  [8585] = 8421,
  [8586] = 8586,
  [8587] = 8417,
  [8588] = 8447,
  [8589] = 8383,
  [8590] = 8590,
  [8591] = 8447,
  [8592] = 8377,
  [8593] = 8385,
  [8594] = 8594,
  [8595] = 8424,
  [8596] = 8393,
  [8597] = 8432,
  [8598] = 8421,
  [8599] = 8417,
  [8600] = 8377,
  [8601] = 8424,
  [8602] = 8416,
  [8603] = 8412,
  [8604] = 8604,
  [8605] = 8377,
  [8606] = 8377,
  [8607] = 8607,
  [8608] = 8441,
  [8609] = 8401,
  [8610] = 8391,
  [8611] = 8402,
  [8612] = 8398,
  [8613] = 8441,
  [8614] = 8421,
  [8615] = 8377,
  [8616] = 8412,
  [8617] = 8436,
  [8618] = 8416,
  [8619] = 8482,
  [8620] = 8383,
  [8621] = 8511,
  [8622] = 8500,
  [8623] = 8383,
  [8624] = 8472,
  [8625] = 8625,
  [8626] = 8424,
  [8627] = 8382,
  [8628] = 8511,
  [8629] = 8382,
  [8630] = 8472,
  [8631] = 8359,
  [8632] = 8412,
  [8633] = 8391,
  [8634] = 8261,
  [8635] = 8500,
  [8636] = 8636,
  [8637] = 8637,
  [8638] = 8472,
  [8639] = 8427,
  [8640] = 8500,
  [8641] = 8398,
  [8642] = 8642,
  [8643] = 3026,
  [8644] = 8468,
  [8645] = 8594,
  [8646] = 8346,
  [8647] = 8647,
  [8648] = 8511,
  [8649] = 8345,
  [8650] = 8401,
  [8651] = 8464,
  [8652] = 8385,
  [8653] = 8382,
  [8654] = 8460,
  [8655] = 8655,
  [8656] = 8412,
  [8657] = 8657,
  [8658] = 8389,
  [8659] = 8659,
  [8660] = 8447,
  [8661] = 8429,
  [8662] = 8662,
  [8663] = 8663,
  [8664] = 8569,
  [8665] = 8385,
  [8666] = 8421,
  [8667] = 8421,
  [8668] = 8564,
  [8669] = 8417,
  [8670] = 8590,
  [8671] = 8671,
  [8672] = 8447,
  [8673] = 8673,
  [8674] = 8674,
  [8675] = 8377,
  [8676] = 8676,
  [8677] = 8432,
  [8678] = 8330,
  [8679] = 8436,
  [8680] = 8496,
  [8681] = 8562,
  [8682] = 8424,
  [8683] = 8416,
  [8684] = 8684,
  [8685] = 8436,
  [8686] = 8686,
  [8687] = 8377,
  [8688] = 8417,
  [8689] = 8416,
  [8690] = 8441,
  [8691] = 8410,
  [8692] = 8410,
  [8693] = 8693,
  [8694] = 8412,
  [8695] = 8429,
  [8696] = 8696,
  [8697] = 8280,
  [8698] = 8698,
  [8699] = 8283,
  [8700] = 8402,
  [8701] = 8701,
  [8702] = 8702,
  [8703] = 8703,
  [8704] = 8704,
  [8705] = 8705,
  [8706] = 8706,
  [8707] = 8707,
  [8708] = 8708,
  [8709] = 8709,
  [8710] = 8710,
  [8711] = 8711,
  [8712] = 8712,
  [8713] = 3604,
  [8714] = 8714,
  [8715] = 8715,
  [8716] = 8716,
  [8717] = 8717,
  [8718] = 8718,
  [8719] = 8719,
  [8720] = 8720,
  [8721] = 8721,
  [8722] = 8722,
  [8723] = 8723,
  [8724] = 8724,
  [8725] = 8725,
  [8726] = 8726,
  [8727] = 8727,
  [8728] = 8728,
  [8729] = 8729,
  [8730] = 8730,
  [8731] = 8731,
  [8732] = 8732,
  [8733] = 8733,
  [8734] = 2244,
  [8735] = 2292,
  [8736] = 8736,
  [8737] = 8737,
  [8738] = 8738,
  [8739] = 8739,
  [8740] = 2293,
  [8741] = 8741,
  [8742] = 8742,
  [8743] = 8743,
  [8744] = 2286,
  [8745] = 8745,
  [8746] = 8719,
  [8747] = 8726,
  [8748] = 8742,
  [8749] = 8725,
  [8750] = 8750,
  [8751] = 8709,
  [8752] = 8727,
  [8753] = 8753,
  [8754] = 8754,
  [8755] = 8714,
  [8756] = 8756,
  [8757] = 8757,
  [8758] = 8754,
  [8759] = 8759,
  [8760] = 8760,
  [8761] = 8761,
  [8762] = 8762,
  [8763] = 2883,
  [8764] = 2291,
  [8765] = 2288,
  [8766] = 2906,
  [8767] = 2907,
  [8768] = 2287,
  [8769] = 2284,
  [8770] = 2914,
  [8771] = 8771,
  [8772] = 8772,
  [8773] = 8701,
  [8774] = 2232,
  [8775] = 8775,
  [8776] = 8776,
  [8777] = 8777,
  [8778] = 8706,
  [8779] = 8737,
  [8780] = 8780,
  [8781] = 8701,
  [8782] = 8782,
  [8783] = 2226,
  [8784] = 8784,
  [8785] = 8785,
  [8786] = 3621,
  [8787] = 8787,
  [8788] = 8788,
  [8789] = 8789,
  [8790] = 8728,
  [8791] = 8776,
  [8792] = 8775,
  [8793] = 8793,
  [8794] = 2258,
  [8795] = 8701,
  [8796] = 8702,
  [8797] = 2307,
  [8798] = 2306,
  [8799] = 8799,
  [8800] = 8719,
  [8801] = 8801,
  [8802] = 8714,
  [8803] = 8745,
  [8804] = 8709,
  [8805] = 2303,
  [8806] = 8725,
  [8807] = 2227,
  [8808] = 8727,
  [8809] = 2222,
  [8810] = 8810,
  [8811] = 2302,
  [8812] = 8777,
  [8813] = 8775,
  [8814] = 8814,
  [8815] = 8815,
  [8816] = 8753,
  [8817] = 8817,
  [8818] = 8759,
  [8819] = 8787,
  [8820] = 8728,
  [8821] = 2235,
  [8822] = 2279,
  [8823] = 2278,
  [8824] = 8757,
  [8825] = 8825,
  [8826] = 2276,
  [8827] = 8753,
  [8828] = 8787,
  [8829] = 2238,
  [8830] = 8830,
  [8831] = 2275,
  [8832] = 2271,
  [8833] = 8738,
  [8834] = 8772,
  [8835] = 2223,
  [8836] = 8738,
  [8837] = 2243,
  [8838] = 8838,
  [8839] = 2262,
  [8840] = 8785,
  [8841] = 8841,
  [8842] = 8738,
  [8843] = 8843,
  [8844] = 8825,
  [8845] = 8845,
  [8846] = 8789,
  [8847] = 8847,
  [8848] = 8825,
  [8849] = 8849,
  [8850] = 8757,
  [8851] = 8851,
  [8852] = 8852,
  [8853] = 8753,
  [8854] = 8726,
  [8855] = 8759,
  [8856] = 8856,
  [8857] = 2260,
  [8858] = 8858,
  [8859] = 8859,
  [8860] = 8727,
  [8861] = 2255,
  [8862] = 2254,
  [8863] = 2234,
  [8864] = 2233,
  [8865] = 2231,
  [8866] = 2251,
  [8867] = 8825,
  [8868] = 8868,
  [8869] = 8757,
  [8870] = 2257,
  [8871] = 8871,
  [8872] = 8759,
  [8873] = 2259,
  [8874] = 8874,
  [8875] = 8875,
  [8876] = 8709,
  [8877] = 8701,
  [8878] = 8878,
  [8879] = 2261,
  [8880] = 8880,
  [8881] = 8737,
  [8882] = 2225,
  [8883] = 8759,
  [8884] = 8728,
  [8885] = 8775,
  [8886] = 8810,
  [8887] = 8887,
  [8888] = 2230,
  [8889] = 8702,
  [8890] = 8890,
  [8891] = 8745,
  [8892] = 8742,
  [8893] = 2229,
  [8894] = 2264,
  [8895] = 2272,
  [8896] = 8709,
  [8897] = 8714,
  [8898] = 8898,
  [8899] = 8899,
  [8900] = 8900,
  [8901] = 2289,
  [8902] = 8777,
  [8903] = 2266,
  [8904] = 8706,
  [8905] = 8775,
  [8906] = 8737,
  [8907] = 8776,
  [8908] = 8789,
  [8909] = 8737,
  [8910] = 8754,
  [8911] = 8745,
  [8912] = 8912,
  [8913] = 2263,
  [8914] = 8776,
  [8915] = 8825,
  [8916] = 8759,
  [8917] = 8709,
  [8918] = 8868,
  [8919] = 8919,
  [8920] = 8776,
  [8921] = 8921,
  [8922] = 8922,
  [8923] = 8761,
  [8924] = 8868,
  [8925] = 2297,
  [8926] = 2290,
  [8927] = 8927,
  [8928] = 8928,
  [8929] = 8714,
  [8930] = 2301,
  [8931] = 8709,
  [8932] = 8932,
  [8933] = 2282,
  [8934] = 8737,
  [8935] = 2224,
  [8936] = 8936,
  [8937] = 8868,
  [8938] = 8745,
  [8939] = 8939,
  [8940] = 8789,
  [8941] = 2236,
  [8942] = 8725,
  [8943] = 2240,
  [8944] = 2242,
  [8945] = 8761,
  [8946] = 2245,
  [8947] = 8772,
  [8948] = 8775,
  [8949] = 2246,
  [8950] = 8777,
  [8951] = 8922,
  [8952] = 2247,
  [8953] = 8953,
  [8954] = 2248,
  [8955] = 2249,
  [8956] = 2250,
  [8957] = 2252,
  [8958] = 2253,
  [8959] = 2256,
  [8960] = 8761,
  [8961] = 8745,
  [8962] = 2294,
  [8963] = 2300,
  [8964] = 8964,
  [8965] = 8726,
  [8966] = 2304,
  [8967] = 8785,
  [8968] = 8968,
  [8969] = 2274,
  [8970] = 2280,
  [8971] = 2285,
  [8972] = 8972,
  [8973] = 8973,
  [8974] = 2298,
  [8975] = 8825,
  [8976] = 8810,
  [8977] = 2283,
  [8978] = 8719,
  [8979] = 8979,
  [8980] = 2273,
  [8981] = 8737,
  [8982] = 8732,
  [8983] = 8776,
  [8984] = 8984,
  [8985] = 8922,
  [8986] = 8701,
  [8987] = 8737,
  [8988] = 8709,
  [8989] = 8989,
  [8990] = 2269,
  [8991] = 2267,
  [8992] = 8992,
  [8993] = 8993,
  [8994] = 8994,
  [8995] = 8995,
  [8996] = 8996,
  [8997] = 8997,
  [8998] = 8998,
  [8999] = 8999,
  [9000] = 9000,
  [9001] = 9001,
  [9002] = 9002,
  [9003] = 9003,
  [9004] = 9004,
  [9005] = 9005,
  [9006] = 9006,
  [9007] = 9007,
  [9008] = 9008,
  [9009] = 9009,
  [9010] = 9010,
  [9011] = 9011,
  [9012] = 9012,
  [9013] = 9013,
  [9014] = 8992,
  [9015] = 9015,
  [9016] = 9016,
  [9017] = 9010,
  [9018] = 9018,
  [9019] = 9019,
  [9020] = 9020,
  [9021] = 8998,
  [9022] = 9022,
  [9023] = 9001,
  [9024] = 9024,
  [9025] = 9025,
  [9026] = 9026,
  [9027] = 9009,
  [9028] = 9001,
  [9029] = 9001,
  [9030] = 9009,
  [9031] = 9031,
  [9032] = 9032,
  [9033] = 9033,
  [9034] = 9034,
  [9035] = 9018,
  [9036] = 9036,
  [9037] = 9018,
  [9038] = 9038,
  [9039] = 9010,
  [9040] = 9040,
  [9041] = 9009,
  [9042] = 9018,
  [9043] = 9043,
  [9044] = 9016,
  [9045] = 8998,
  [9046] = 9046,
  [9047] = 9015,
  [9048] = 8992,
  [9049] = 9049,
  [9050] = 9018,
  [9051] = 9011,
  [9052] = 9052,
  [9053] = 9053,
  [9054] = 9001,
  [9055] = 9055,
  [9056] = 9010,
  [9057] = 8992,
  [9058] = 9058,
  [9059] = 9059,
  [9060] = 9000,
  [9061] = 9019,
  [9062] = 8998,
  [9063] = 9003,
  [9064] = 8998,
  [9065] = 8998,
  [9066] = 9066,
  [9067] = 9067,
  [9068] = 9068,
  [9069] = 9069,
  [9070] = 8997,
  [9071] = 9049,
  [9072] = 9072,
  [9073] = 8992,
  [9074] = 9010,
  [9075] = 9075,
  [9076] = 8992,
  [9077] = 9069,
  [9078] = 9052,
  [9079] = 9079,
  [9080] = 9009,
  [9081] = 9081,
  [9082] = 9055,
  [9083] = 9001,
  [9084] = 9001,
  [9085] = 9009,
  [9086] = 8998,
  [9087] = 9087,
  [9088] = 9088,
  [9089] = 8992,
  [9090] = 9069,
  [9091] = 9018,
  [9092] = 9079,
  [9093] = 9010,
  [9094] = 9094,
  [9095] = 9095,
  [9096] = 9096,
  [9097] = 9097,
  [9098] = 9098,
  [9099] = 9099,
  [9100] = 9001,
  [9101] = 8994,
  [9102] = 8992,
  [9103] = 9103,
  [9104] = 8998,
  [9105] = 9004,
  [9106] = 9081,
  [9107] = 8998,
  [9108] = 9002,
  [9109] = 9094,
  [9110] = 9009,
  [9111] = 9018,
  [9112] = 9005,
  [9113] = 9095,
  [9114] = 8994,
  [9115] = 9115,
  [9116] = 9116,
  [9117] = 8992,
  [9118] = 9010,
  [9119] = 9043,
  [9120] = 8992,
  [9121] = 9097,
  [9122] = 9018,
  [9123] = 9123,
  [9124] = 9124,
  [9125] = 8998,
  [9126] = 9001,
  [9127] = 9010,
  [9128] = 9009,
  [9129] = 9099,
  [9130] = 9130,
  [9131] = 9131,
  [9132] = 9009,
  [9133] = 9001,
  [9134] = 9018,
  [9135] = 9018,
  [9136] = 9010,
  [9137] = 9001,
  [9138] = 9009,
  [9139] = 9001,
  [9140] = 9009,
  [9141] = 9010,
  [9142] = 9142,
  [9143] = 8992,
  [9144] = 8992,
  [9145] = 8998,
  [9146] = 9010,
  [9147] = 9010,
  [9148] = 9069,
  [9149] = 9149,
  [9150] = 9150,
  [9151] = 9151,
  [9152] = 9016,
  [9153] = 9015,
  [9154] = 8992,
  [9155] = 9010,
  [9156] = 9010,
  [9157] = 9157,
  [9158] = 9158,
  [9159] = 9159,
  [9160] = 9059,
  [9161] = 9001,
  [9162] = 9162,
  [9163] = 9009,
  [9164] = 9058,
  [9165] = 8992,
  [9166] = 9053,
  [9167] = 9018,
  [9168] = 9168,
  [9169] = 9009,
  [9170] = 9011,
  [9171] = 9171,
  [9172] = 9172,
  [9173] = 9157,
  [9174] = 8998,
  [9175] = 9158,
  [9176] = 9009,
  [9177] = 9177,
  [9178] = 9059,
  [9179] = 9009,
  [9180] = 8992,
  [9181] = 9019,
  [9182] = 8992,
  [9183] = 9010,
  [9184] = 9010,
  [9185] = 9185,
  [9186] = 9186,
  [9187] = 9053,
  [9188] = 9188,
  [9189] = 9001,
  [9190] = 9079,
  [9191] = 9009,
  [9192] = 9192,
  [9193] = 9193,
  [9194] = 9018,
  [9195] = 9195,
  [9196] = 9018,
  [9197] = 8998,
  [9198] = 9040,
  [9199] = 9036,
  [9200] = 9159,
  [9201] = 9059,
  [9202] = 9018,
  [9203] = 9010,
  [9204] = 9204,
  [9205] = 9067,
  [9206] = 9088,
  [9207] = 9068,
  [9208] = 9208,
  [9209] = 9072,
  [9210] = 8998,
  [9211] = 9001,
  [9212] = 9081,
  [9213] = 9075,
  [9214] = 9024,
  [9215] = 8998,
  [9216] = 9009,
  [9217] = 9018,
  [9218] = 9018,
  [9219] = 9219,
  [9220] = 8998,
  [9221] = 9221,
  [9222] = 8998,
  [9223] = 9223,
  [9224] = 9224,
  [9225] = 9009,
  [9226] = 9226,
  [9227] = 9227,
  [9228] = 8992,
  [9229] = 9229,
  [9230] = 9040,
  [9231] = 9018,
  [9232] = 9001,
  [9233] = 9233,
  [9234] = 9234,
  [9235] = 9235,
  [9236] = 9001,
  [9237] = 9237,
  [9238] = 9009,
  [9239] = 9038,
  [9240] = 9036,
  [9241] = 9241,
  [9242] = 9018,
  [9243] = 9038,
  [9244] = 9058,
  [9245] = 8998,
  [9246] = 9081,
  [9247] = 9247,
  [9248] = 9053,
  [9249] = 9249,
  [9250] = 8992,
  [9251] = 9251,
  [9252] = 9252,
  [9253] = 9253,
  [9254] = 9254,
  [9255] = 8992,
  [9256] = 9256,
  [9257] = 9010,
  [9258] = 9258,
  [9259] = 9188,
  [9260] = 9260,
  [9261] = 9261,
  [9262] = 9262,
  [9263] = 9001,
  [9264] = 9264,
  [9265] = 9265,
  [9266] = 9009,
  [9267] = 8998,
  [9268] = 9268,
  [9269] = 9269,
  [9270] = 9270,
  [9271] = 9271,
  [9272] = 9024,
  [9273] = 9273,
  [9274] = 9274,
  [9275] = 9275,
  [9276] = 9276,
  [9277] = 9277,
  [9278] = 9278,
  [9279] = 9279,
  [9280] = 8998,
  [9281] = 9281,
  [9282] = 9282,
  [9283] = 9283,
  [9284] = 9284,
  [9285] = 8992,
  [9286] = 9286,
  [9287] = 9287,
  [9288] = 9288,
  [9289] = 9289,
  [9290] = 9290,
  [9291] = 9291,
  [9292] = 9292,
  [9293] = 9010,
  [9294] = 9294,
  [9295] = 9295,
  [9296] = 9142,
  [9297] = 9162,
  [9298] = 9208,
  [9299] = 9299,
  [9300] = 9300,
  [9301] = 9001,
  [9302] = 9302,
  [9303] = 9303,
  [9304] = 9009,
  [9305] = 9018,
  [9306] = 8998,
  [9307] = 9299,
  [9308] = 9177,
  [9309] = 9309,
  [9310] = 8992,
  [9311] = 9311,
  [9312] = 9312,
  [9313] = 9010,
  [9314] = 9001,
  [9315] = 9009,
  [9316] = 9316,
  [9317] = 9317,
  [9318] = 9318,
  [9319] = 9319,
  [9320] = 9320,
  [9321] = 9321,
  [9322] = 9018,
  [9323] = 9323,
  [9324] = 8998,
  [9325] = 9325,
  [9326] = 9326,
  [9327] = 9327,
  [9328] = 9328,
  [9329] = 9329,
  [9330] = 9330,
  [9331] = 9001,
  [9332] = 9010,
  [9333] = 9001,
  [9334] = 9334,
  [9335] = 9335,
  [9336] = 9336,
  [9337] = 9337,
  [9338] = 9338,
  [9339] = 9004,
  [9340] = 9340,
  [9341] = 9341,
  [9342] = 9002,
  [9343] = 9009,
  [9344] = 9024,
  [9345] = 9018,
  [9346] = 9346,
  [9347] = 9347,
  [9348] = 9348,
  [9349] = 9349,
  [9350] = 9350,
  [9351] = 9351,
  [9352] = 9352,
  [9353] = 9353,
  [9354] = 9354,
  [9355] = 9355,
  [9356] = 9356,
  [9357] = 8993,
  [9358] = 9005,
  [9359] = 9359,
  [9360] = 9360,
  [9361] = 9361,
  [9362] = 9018,
  [9363] = 8992,
  [9364] = 9018,
  [9365] = 9327,
  [9366] = 9022,
  [9367] = 8992,
  [9368] = 9010,
  [9369] = 9018,
  [9370] = 9001,
  [9371] = 9009,
  [9372] = 9018,
  [9373] = 9278,
  [9374] = 9374,
  [9375] = 9375,
  [9376] = 9326,
  [9377] = 8992,
  [9378] = 9378,
  [9379] = 9379,
  [9380] = 8998,
  [9381] = 8992,
  [9382] = 9382,
  [9383] = 9241,
  [9384] = 9036,
  [9385] = 9038,
  [9386] = 9010,
  [9387] = 9001,
  [9388] = 9040,
  [9389] = 9018,
  [9390] = 8994,
  [9391] = 9009,
  [9392] = 9068,
  [9393] = 8998,
  [9394] = 8998,
  [9395] = 9009,
  [9396] = 9325,
  [9397] = 9001,
  [9398] = 9009,
  [9399] = 9399,
  [9400] = 9177,
  [9401] = 9192,
  [9402] = 8996,
  [9403] = 8998,
  [9404] = 8992,
  [9405] = 9010,
  [9406] = 9001,
  [9407] = 9193,
  [9408] = 9053,
  [9409] = 8995,
  [9410] = 9010,
  [9411] = 9001,
  [9412] = 9009,
  [9413] = 9058,
  [9414] = 9414,
  [9415] = 9059,
  [9416] = 9159,
  [9417] = 9417,
  [9418] = 9018,
  [9419] = 8998,
  [9420] = 9158,
  [9421] = 9157,
  [9422] = 9422,
  [9423] = 8992,
  [9424] = 9010,
  [9425] = 9425,
  [9426] = 9328,
  [9427] = 8992,
  [9428] = 9195,
  [9429] = 9010,
  [9430] = 9009,
  [9431] = 9016,
  [9432] = 9069,
  [9433] = 9015,
  [9434] = 9007,
  [9435] = 9018,
  [9436] = 8992,
  [9437] = 9437,
  [9438] = 9018,
  [9439] = 9300,
  [9440] = 9009,
  [9441] = 9329,
  [9442] = 9011,
  [9443] = 9013,
  [9444] = 9010,
  [9445] = 8998,
  [9446] = 9010,
  [9447] = 9012,
  [9448] = 9018,
  [9449] = 9001,
  [9450] = 9450,
  [9451] = 8992,
  [9452] = 9452,
  [9453] = 9010,
  [9454] = 9018,
  [9455] = 9455,
  [9456] = 9456,
  [9457] = 9457,
  [9458] = 9001,
  [9459] = 9459,
  [9460] = 9460,
  [9461] = 9461,
  [9462] = 9462,
  [9463] = 9009,
  [9464] = 9123,
  [9465] = 9009,
  [9466] = 9001,
  [9467] = 9004,
  [9468] = 9002,
  [9469] = 9469,
  [9470] = 9020,
  [9471] = 9471,
  [9472] = 8996,
  [9473] = 9473,
  [9474] = 9001,
  [9475] = 9475,
  [9476] = 9204,
  [9477] = 9005,
  [9478] = 8998,
  [9479] = 9009,
  [9480] = 9069,
  [9481] = 9149,
  [9482] = 8994,
  [9483] = 9018,
  [9484] = 9067,
  [9485] = 9031,
  [9486] = 9010,
  [9487] = 9072,
  [9488] = 9488,
  [9489] = 9075,
  [9490] = 9018,
  [9491] = 9009,
  [9492] = 9010,
  [9493] = 9001,
  [9494] = 9337,
  [9495] = 9417,
  [9496] = 9018,
  [9497] = 8998,
  [9498] = 9018,
  [9499] = 9009,
  [9500] = 9001,
  [9501] = 9010,
  [9502] = 8992,
  [9503] = 9115,
  [9504] = 8998,
  [9505] = 8998,
  [9506] = 9024,
  [9507] = 9031,
  [9508] = 9032,
  [9509] = 9018,
  [9510] = 9009,
  [9511] = 9302,
  [9512] = 9303,
  [9513] = 9001,
  [9514] = 9010,
  [9515] = 8992,
  [9516] = 8992,
  [9517] = 9422,
  [9518] = 9378,
  [9519] = 9519,
  [9520] = 9010,
  [9521] = 9124,
  [9522] = 8998,
  [9523] = 9001,
  [9524] = 9081,
  [9525] = 8998,
  [9526] = 9009,
  [9527] = 9527,
  [9528] = 9018,
  [9529] = 8998,
  [9530] = 9088,
  [9531] = 9087,
  [9532] = 9009,
  [9533] = 9001,
  [9534] = 8992,
  [9535] = 9079,
  [9536] = 9040,
  [9537] = 8992,
  [9538] = 9321,
  [9539] = 9019,
  [9540] = 9010,
  [9541] = 8992,
  [9542] = 9066,
  [9543] = 9185,
  [9544] = 9010,
  [9545] = 8998,
  [9546] = 9334,
  [9547] = 9001,
  [9548] = 9066,
  [9549] = 9009,
  [9550] = 9018,
  [9551] = 9079,
  [9552] = 9001,
  [9553] = 9553,
  [9554] = 9554,
  [9555] = 9019,
  [9556] = 9219,
  [9557] = 9336,
  [9558] = 9558,
  [9559] = 9559,
  [9560] = 8992,
  [9561] = 9223,
  [9562] = 9018,
  [9563] = 9010,
  [9564] = 9087,
  [9565] = 9565,
  [9566] = 9009,
  [9567] = 9032,
  [9568] = 9088,
  [9569] = 9001,
  [9570] = 9018,
  [9571] = 9081,
  [9572] = 9010,
  [9573] = 9573,
  [9574] = 9320,
  [9575] = 9009,
  [9576] = 9034,
  [9577] = 9001,
  [9578] = 8992,
  [9579] = 8998,
  [9580] = 8998,
  [9581] = 9081,
  [9582] = 9224,
  [9583] = 9115,
  [9584] = 8998,
  [9585] = 9585,
  [9586] = 9586,
  [9587] = 9226,
  [9588] = 9588,
  [9589] = 9227,
  [9590] = 9010,
  [9591] = 9319,
  [9592] = 9229,
  [9593] = 9593,
  [9594] = 9594,
  [9595] = 9452,
  [9596] = 9596,
  [9597] = 9597,
  [9598] = 9040,
  [9599] = 9599,
  [9600] = 9600,
  [9601] = 9233,
  [9602] = 9452,
  [9603] = 9234,
  [9604] = 9072,
  [9605] = 9605,
  [9606] = 9606,
  [9607] = 9607,
  [9608] = 9596,
  [9609] = 9597,
  [9610] = 9032,
  [9611] = 9123,
  [9612] = 9075,
  [9613] = 9262,
  [9614] = 9010,
  [9615] = 9124,
  [9616] = 9235,
  [9617] = 9031,
  [9618] = 9237,
  [9619] = 9068,
  [9620] = 9067,
  [9621] = 8992,
  [9622] = 9309,
  [9623] = 8992,
  [9624] = 8998,
  [9625] = 9553,
  [9626] = 9016,
  [9627] = 9015,
  [9628] = 9295,
  [9629] = 8992,
  [9630] = 9038,
  [9631] = 9022,
  [9632] = 9036,
  [9633] = 9020,
  [9634] = 8998,
  [9635] = 9012,
  [9636] = 8992,
  [9637] = 9010,
  [9638] = 9013,
  [9639] = 9001,
  [9640] = 9009,
  [9641] = 9018,
  [9642] = 9338,
  [9643] = 9241,
  [9644] = 9294,
  [9645] = 9007,
  [9646] = 9417,
  [9647] = 8995,
  [9648] = 8996,
  [9649] = 9018,
  [9650] = 9019,
  [9651] = 9009,
  [9652] = 9001,
  [9653] = 9010,
  [9654] = 9011,
  [9655] = 9010,
  [9656] = 8992,
  [9657] = 8994,
  [9658] = 8998,
  [9659] = 9001,
  [9660] = 8998,
  [9661] = 9009,
  [9662] = 9005,
  [9663] = 8992,
  [9664] = 9069,
  [9665] = 9665,
  [9666] = 9335,
  [9667] = 9002,
  [9668] = 9004,
  [9669] = 9311,
  [9670] = 9018,
  [9671] = 9040,
  [9672] = 9001,
  [9673] = 9024,
  [9674] = 9455,
  [9675] = 9456,
  [9676] = 9457,
  [9677] = 9459,
  [9678] = 9460,
  [9679] = 9461,
  [9680] = 9462,
  [9681] = 9009,
  [9682] = 9340,
  [9683] = 9683,
  [9684] = 9471,
  [9685] = 9292,
  [9686] = 9043,
  [9687] = 8998,
  [9688] = 9000,
  [9689] = 9003,
  [9690] = 8997,
  [9691] = 9596,
  [9692] = 9291,
  [9693] = 9049,
  [9694] = 9052,
  [9695] = 9055,
  [9696] = 9341,
  [9697] = 9066,
  [9698] = 9597,
  [9699] = 9069,
  [9700] = 9251,
  [9701] = 9094,
  [9702] = 9095,
  [9703] = 9097,
  [9704] = 9099,
  [9705] = 9290,
  [9706] = 9252,
  [9707] = 9253,
  [9708] = 9254,
  [9709] = 9422,
  [9710] = 9378,
  [9711] = 9256,
  [9712] = 9258,
  [9713] = 9289,
  [9714] = 9312,
  [9715] = 9188,
  [9716] = 9279,
  [9717] = 9157,
  [9718] = 9158,
  [9719] = 9159,
  [9720] = 9059,
  [9721] = 9348,
  [9722] = 9058,
  [9723] = 9018,
  [9724] = 8992,
  [9725] = 9288,
  [9726] = 9053,
  [9727] = 9185,
  [9728] = 9260,
  [9729] = 9233,
  [9730] = 9261,
  [9731] = 9683,
  [9732] = 9553,
  [9733] = 9264,
  [9734] = 9177,
  [9735] = 9287,
  [9736] = 9286,
  [9737] = 9737,
  [9738] = 9452,
  [9739] = 9079,
  [9740] = 9740,
  [9741] = 9010,
  [9742] = 9316,
  [9743] = 9265,
  [9744] = 9192,
  [9745] = 9745,
  [9746] = 9455,
  [9747] = 9456,
  [9748] = 9457,
  [9749] = 9459,
  [9750] = 9460,
  [9751] = 9461,
  [9752] = 9462,
  [9753] = 9193,
  [9754] = 9195,
  [9755] = 9284,
  [9756] = 9471,
  [9757] = 3630,
  [9758] = 9018,
  [9759] = 9283,
  [9760] = 9149,
  [9761] = 9009,
  [9762] = 9762,
  [9763] = 9282,
  [9764] = 9223,
  [9765] = 9224,
  [9766] = 9226,
  [9767] = 9227,
  [9768] = 3636,
  [9769] = 9229,
  [9770] = 9040,
  [9771] = 9422,
  [9772] = 9378,
  [9773] = 9773,
  [9774] = 9774,
  [9775] = 9011,
  [9776] = 9776,
  [9777] = 9234,
  [9778] = 9350,
  [9779] = 8998,
  [9780] = 9235,
  [9781] = 9185,
  [9782] = 8992,
  [9783] = 9553,
  [9784] = 9784,
  [9785] = 9237,
  [9786] = 9015,
  [9787] = 9038,
  [9788] = 9036,
  [9789] = 9241,
  [9790] = 9268,
  [9791] = 9606,
  [9792] = 9261,
  [9793] = 9269,
  [9794] = 9794,
  [9795] = 9459,
  [9796] = 9460,
  [9797] = 9461,
  [9798] = 9462,
  [9799] = 9001,
  [9800] = 9251,
  [9801] = 9471,
  [9802] = 9252,
  [9803] = 9803,
  [9804] = 9253,
  [9805] = 9254,
  [9806] = 8992,
  [9807] = 9807,
  [9808] = 9256,
  [9809] = 9270,
  [9810] = 9258,
  [9811] = 9016,
  [9812] = 9360,
  [9813] = 9422,
  [9814] = 9359,
  [9815] = 9815,
  [9816] = 8993,
  [9817] = 9356,
  [9818] = 9355,
  [9819] = 9354,
  [9820] = 9353,
  [9821] = 9352,
  [9822] = 9351,
  [9823] = 9461,
  [9824] = 9462,
  [9825] = 9281,
  [9826] = 9471,
  [9827] = 9350,
  [9828] = 9828,
  [9829] = 9348,
  [9830] = 9279,
  [9831] = 9271,
  [9832] = 9471,
  [9833] = 9833,
  [9834] = 9834,
  [9835] = 9835,
  [9836] = 9341,
  [9837] = 9422,
  [9838] = 9340,
  [9839] = 9469,
  [9840] = 9338,
  [9841] = 9337,
  [9842] = 9336,
  [9843] = 9335,
  [9844] = 9334,
  [9845] = 9024,
  [9846] = 9274,
  [9847] = 9329,
  [9848] = 9328,
  [9849] = 9327,
  [9850] = 9326,
  [9851] = 9275,
  [9852] = 9325,
  [9853] = 9087,
  [9854] = 9360,
  [9855] = 9318,
  [9856] = 9260,
  [9857] = 9422,
  [9858] = 9321,
  [9859] = 9320,
  [9860] = 9319,
  [9861] = 9318,
  [9862] = 9317,
  [9863] = 9316,
  [9864] = 9359,
  [9865] = 9312,
  [9866] = 9088,
  [9867] = 8998,
  [9868] = 9311,
  [9869] = 9309,
  [9870] = 9870,
  [9871] = 9276,
  [9872] = 9317,
  [9873] = 9873,
  [9874] = 9874,
  [9875] = 9277,
  [9876] = 9422,
  [9877] = 9877,
  [9878] = 9018,
  [9879] = 9303,
  [9880] = 9302,
  [9881] = 9300,
  [9882] = 9299,
  [9883] = 9208,
  [9884] = 9884,
  [9885] = 9356,
  [9886] = 9278,
  [9887] = 9162,
  [9888] = 9142,
  [9889] = 9889,
  [9890] = 9890,
  [9891] = 9295,
  [9892] = 9294,
  [9893] = 9893,
  [9894] = 9894,
  [9895] = 9262,
  [9896] = 9896,
  [9897] = 9292,
  [9898] = 9898,
  [9899] = 9001,
  [9900] = 9291,
  [9901] = 9290,
  [9902] = 8998,
  [9903] = 9289,
  [9904] = 9288,
  [9905] = 9287,
  [9906] = 9081,
  [9907] = 9352,
  [9908] = 9286,
  [9909] = 9353,
  [9910] = 9001,
  [9911] = 9115,
  [9912] = 9912,
  [9913] = 9913,
  [9914] = 9284,
  [9915] = 9354,
  [9916] = 9916,
  [9917] = 8998,
  [9918] = 9745,
  [9919] = 9009,
  [9920] = 9283,
  [9921] = 9452,
  [9922] = 9282,
  [9923] = 9462,
  [9924] = 8992,
  [9925] = 9461,
  [9926] = 9460,
  [9927] = 9010,
  [9928] = 9382,
  [9929] = 9459,
  [9930] = 9281,
  [9931] = 9355,
  [9932] = 9010,
  [9933] = 9001,
  [9934] = 9457,
  [9935] = 9606,
  [9936] = 9009,
  [9937] = 9937,
  [9938] = 9018,
  [9939] = 9010,
  [9940] = 9940,
  [9941] = 9456,
  [9942] = 9916,
  [9943] = 9455,
  [9944] = 9123,
  [9945] = 9278,
  [9946] = 9124,
  [9947] = 9916,
  [9948] = 9745,
  [9949] = 9277,
  [9950] = 9950,
  [9951] = 9276,
  [9952] = 9275,
  [9953] = 9382,
  [9954] = 9274,
  [9955] = 9018,
  [9956] = 9024,
  [9957] = 9271,
  [9958] = 9270,
  [9959] = 9916,
  [9960] = 9745,
  [9961] = 9269,
  [9962] = 9067,
  [9963] = 9382,
  [9964] = 9068,
  [9965] = 9268,
  [9966] = 9265,
  [9967] = 9745,
  [9968] = 9072,
  [9969] = 9745,
  [9970] = 9075,
  [9971] = 9745,
  [9972] = 9745,
  [9973] = 9973,
  [9974] = 9606,
  [9975] = 9452,
  [9976] = 9976,
  [9977] = 9351,
  [9978] = 9597,
  [9979] = 9596,
  [9980] = 9980,
  [9981] = 9981,
  [9982] = 9982,
  [9983] = 9983,
  [9984] = 9984,
  [9985] = 9985,
  [9986] = 9986,
  [9987] = 9987,
  [9988] = 9988,
  [9989] = 9989,
  [9990] = 9990,
  [9991] = 9991,
  [9992] = 9992,
  [9993] = 9993,
  [9994] = 9994,
  [9995] = 9995,
  [9996] = 9996,
};

static TSCharacterRange sym__identifier_token_character_set_2[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37a, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe33},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb3},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x1884}, {0x1887, 0x18a8},
  {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16},
  {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23},
  {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6},
  {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c},
  {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128},
  {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2e2f, 0x2e2f},
  {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff},
  {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf}, {0x4e00, 0x4e00}, {0x9fff, 0xa48c},
  {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a},
  {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946},
  {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42},
  {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0},
  {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb},
  {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdfb},
  {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x1092b},
};

static TSCharacterRange sym__identifier_token_character_set_3[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xad, 0xad}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37a, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf},
  {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x600, 0x605}, {0x610, 0x61a}, {0x61c, 0x61c},
  {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dd}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x70f, 0x74a}, {0x74d, 0x7b1},
  {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e},
  {0x890, 0x891}, {0x898, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3},
  {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30},
  {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51},
  {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0},
  {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef},
  {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71},
  {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4},
  {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef},
  {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56},
  {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8},
  {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3},
  {0xce6, 0xcef}, {0xcf1, 0xcf2}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57},
  {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd},
  {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a},
  {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd},
  {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xecd}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29},
  {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc},
  {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b},
  {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19d9}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e},
  {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59},
  {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf},
  {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59},
  {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc},
  {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200b, 0x200f}, {0x202a, 0x202e}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2060, 0x2064}, {0x2066, 0x206f}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1},
  {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2119, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x212d}, {0x212f, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4},
  {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff},
  {0x2e2f, 0x2e2f}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f},
  {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x3400}, {0x4dbf, 0x4dbf},
  {0x4e00, 0x4e00}, {0x9fff, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1},
  {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c},
  {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c},
  {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2},
  {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e},
  {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xac00}, {0xd7a3, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdfb},
  {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe70, 0xfe74}, {0xfe76, 0xfefc}, {0xfeff, 0xfeff}, {0xff10, 0xff19},
  {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff66, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc},
  {0xfff9, 0xfffb}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a},
  {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x1092b},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(106);
      ADVANCE_MAP(
        '!', 131,
        '"', 187,
        '#', 9,
        '%', 146,
        '&', 154,
        '\'', 227,
        '(', 115,
        ')', 116,
        '*', 142,
        '+', 136,
        ',', 113,
        '-', 138,
        '.', 167,
        '/', 144,
        '0', 232,
        ':', 112,
        ';', 107,
        '<', 120,
        '=', 108,
        '>', 125,
        '?', 128,
        '@', 12,
        '[', 110,
        '\\', 29,
        ']', 114,
        '^', 148,
        '{', 117,
        '|', 150,
        '}', 118,
        '~', 132,
        'U', 291,
        'u', 291,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(103);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(233);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 294,
        '!', 24,
        '"', 187,
        '#', 42,
        '&', 18,
        ',', 113,
        '/', 19,
        '0', 236,
        '=', 25,
        '@', 101,
        '|', 87,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(237);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(11);
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(252);
      if (lookahead == '/') ADVANCE(245);
      if (lookahead == '\\') ADVANCE(29);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(244);
      if (lookahead != 0) ADVANCE(280);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(295);
      if (lookahead == '#') ADVANCE(312);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(301);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 131,
        '"', 187,
        '#', 41,
        '%', 146,
        '&', 154,
        '(', 115,
        ')', 116,
        '*', 142,
        '+', 136,
        ',', 113,
        '-', 138,
        '.', 166,
        '/', 144,
        '0', 236,
        ':', 112,
        ';', 107,
        '<', 120,
        '=', 108,
        '>', 125,
        '?', 128,
        '@', 101,
        '[', 110,
        ']', 114,
        '^', 148,
        '{', 117,
        '|', 150,
        '}', 118,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(237);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 131,
        '#', 41,
        '%', 146,
        '&', 154,
        '(', 115,
        ')', 116,
        '*', 142,
        '+', 136,
        ',', 113,
        '-', 138,
        '.', 166,
        '/', 144,
        ':', 111,
        ';', 107,
        '<', 120,
        '=', 108,
        '>', 125,
        '?', 128,
        '@', 101,
        '[', 110,
        ']', 114,
        '^', 148,
        '{', 117,
        '|', 150,
        '}', 118,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(5);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 131,
        '#', 41,
        '%', 145,
        '&', 153,
        '(', 115,
        ')', 116,
        '*', 141,
        '+', 135,
        ',', 113,
        '-', 139,
        '.', 166,
        '/', 143,
        ':', 112,
        ';', 107,
        '<', 121,
        '=', 26,
        '>', 126,
        '?', 129,
        '@', 101,
        '[', 110,
        ']', 114,
        '^', 147,
        '{', 117,
        '|', 151,
        '}', 118,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(6);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 131,
        '#', 41,
        '%', 145,
        '&', 153,
        '(', 115,
        ')', 116,
        '*', 141,
        '+', 135,
        ',', 113,
        '-', 139,
        '.', 166,
        '/', 143,
        ':', 111,
        ';', 107,
        '<', 121,
        '=', 26,
        '>', 126,
        '?', 129,
        '@', 101,
        '[', 110,
        ']', 114,
        '^', 147,
        '|', 151,
        '}', 118,
        'U', 291,
        'u', 291,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(7);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 131,
        '#', 42,
        '%', 145,
        '&', 152,
        '*', 141,
        '+', 135,
        '-', 137,
        '/', 143,
        '<', 121,
        '=', 25,
        '>', 126,
        '@', 101,
        '^', 147,
        '|', 149,
        '~', 132,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(8);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 359,
        'd', 51,
        'e', 68,
        'i', 54,
        'l', 62,
        'n', 86,
        'p', 82,
        'r', 46,
        'u', 75,
        '\t', 40,
        ' ', 40,
      );
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 130,
        '#', 42,
        '\'', 227,
        '(', 115,
        ')', 116,
        '*', 141,
        ',', 113,
        '-', 140,
        '.', 165,
        '/', 19,
        '0', 236,
        ':', 112,
        ';', 107,
        '<', 119,
        '=', 109,
        '>', 123,
        '?', 127,
        '@', 101,
        '[', 110,
        ']', 114,
        '{', 117,
        '}', 118,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(237);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead == '#') ADVANCE(42);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(30);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(11);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(13);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(289);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '#') ADVANCE(230);
      if (lookahead == '/') ADVANCE(229);
      if (lookahead == '\\') ADVANCE(30);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(228);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(312);
      if (lookahead == '/') ADVANCE(305);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(302);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(196);
      if (lookahead == '/') ADVANCE(189);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '#', 42,
        '(', 115,
        ')', 116,
        '*', 141,
        ',', 113,
        '-', 27,
        '.', 165,
        '/', 19,
        ':', 111,
        ';', 107,
        '<', 119,
        '=', 28,
        '>', 123,
        '?', 127,
        '@', 101,
        '[', 110,
        ']', 114,
        '{', 117,
        '}', 118,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(17);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 18:
      if (lookahead == '&') ADVANCE(183);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(364);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(360);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead != 0) ADVANCE(300);
      END_STATE();
    case 23:
      if (lookahead == '8') ADVANCE(288);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(161);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(161);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 27:
      if (lookahead == '>') ADVANCE(226);
      END_STATE();
    case 28:
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'U', 282,
        'u', 284,
        'x', 283,
        '"', 285,
        '\'', 285,
        '0', 285,
        '?', 285,
        '\\', 285,
        'a', 285,
        'b', 285,
        'e', 285,
        'f', 285,
        'n', 285,
        'r', 285,
        't', 285,
        'v', 285,
      );
      if (lookahead != 0) ADVANCE(281);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        'U', 92,
        'u', 97,
        'x', 94,
        '"', 285,
        '\'', 285,
        '0', 285,
        '?', 285,
        '\\', 285,
        'a', 285,
        'b', 285,
        'e', 285,
        'f', 285,
        'n', 285,
        'r', 285,
        't', 285,
        'v', 285,
      );
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 32:
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(234);
      END_STATE();
    case 33:
      if (lookahead == '_') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(235);
      END_STATE();
    case 34:
      if (lookahead == '_') ADVANCE(34);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 35:
      if (lookahead == '_') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 36:
      if (lookahead == 'a') ADVANCE(39);
      END_STATE();
    case 37:
      if (lookahead == 'a') ADVANCE(354);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(59);
      END_STATE();
    case 39:
      if (lookahead == 'b') ADVANCE(71);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        'd', 51,
        'e', 68,
        'i', 54,
        'l', 62,
        'n', 86,
        'p', 82,
        'r', 46,
        'u', 75,
        '\t', 40,
        ' ', 40,
      );
      END_STATE();
    case 41:
      ADVANCE_MAP(
        'd', 51,
        'e', 68,
        'l', 62,
        'n', 86,
        'p', 82,
        'r', 46,
        'u', 75,
        '\t', 41,
        ' ', 41,
      );
      END_STATE();
    case 42:
      ADVANCE_MAP(
        'd', 51,
        'e', 76,
        'l', 62,
        'n', 86,
        'p', 82,
        'r', 46,
        'u', 75,
        '\t', 42,
        ' ', 42,
      );
      END_STATE();
    case 43:
      if (lookahead == 'd') ADVANCE(65);
      END_STATE();
    case 44:
      if (lookahead == 'd') ADVANCE(85);
      END_STATE();
    case 45:
      if (lookahead == 'd') ADVANCE(52);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(353);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(357);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 54:
      if (lookahead == 'f') ADVANCE(293);
      END_STATE();
    case 55:
      if (lookahead == 'f') ADVANCE(298);
      END_STATE();
    case 56:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 57:
      if (lookahead == 'f') ADVANCE(358);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(66);
      END_STATE();
    case 59:
      if (lookahead == 'g') ADVANCE(72);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(63);
      END_STATE();
    case 61:
      if (lookahead == 'g') ADVANCE(67);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(77);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(80);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(56);
      if (lookahead == 'r') ADVANCE(53);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(78);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(64);
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == 'l') ADVANCE(36);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(50);
      END_STATE();
    case 72:
      if (lookahead == 'm') ADVANCE(37);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(352);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(48);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(79);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(356);
      END_STATE();
    case 85:
      if (lookahead == 'r') ADVANCE(53);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(69);
      END_STATE();
    case 87:
      if (lookahead == '|') ADVANCE(184);
      END_STATE();
    case 88:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(242);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(242);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(285);
      END_STATE();
    case 92:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(100);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(287);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(95);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(97);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(98);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(99);
      END_STATE();
    case 101:
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 102:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(349);
      END_STATE();
    case 103:
      if (eof) ADVANCE(106);
      ADVANCE_MAP(
        '!', 131,
        '"', 187,
        '#', 9,
        '%', 146,
        '&', 154,
        '\'', 227,
        '(', 115,
        ')', 116,
        '*', 142,
        '+', 136,
        ',', 113,
        '-', 138,
        '.', 167,
        '/', 144,
        '0', 232,
        ':', 112,
        ';', 107,
        '<', 120,
        '=', 108,
        '>', 125,
        '?', 128,
        '@', 12,
        '[', 110,
        '\\', 30,
        ']', 114,
        '^', 148,
        '{', 117,
        '|', 150,
        '}', 118,
        '~', 132,
        'U', 291,
        'u', 291,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(103);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(233);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 104:
      if (eof) ADVANCE(106);
      ADVANCE_MAP(
        '!', 131,
        '"', 187,
        '#', 40,
        '%', 145,
        '&', 153,
        '\'', 227,
        '(', 115,
        ')', 116,
        '*', 141,
        '+', 135,
        ',', 113,
        '-', 139,
        '.', 167,
        '/', 143,
        '0', 232,
        ':', 111,
        ';', 107,
        '<', 121,
        '=', 26,
        '>', 126,
        '?', 129,
        '@', 12,
        '[', 110,
        ']', 114,
        '^', 147,
        '{', 117,
        '|', 151,
        '}', 118,
        '~', 132,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(104);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(233);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 105:
      if (eof) ADVANCE(106);
      ADVANCE_MAP(
        '!', 130,
        '"', 187,
        '#', 9,
        '&', 152,
        '\'', 227,
        '(', 115,
        ')', 116,
        '*', 141,
        '+', 135,
        ',', 113,
        '-', 139,
        '.', 167,
        '/', 19,
        '0', 232,
        ':', 112,
        ';', 107,
        '<', 122,
        '=', 109,
        '>', 124,
        '?', 127,
        '@', 12,
        '[', 110,
        ']', 114,
        '^', 147,
        '{', 117,
        '}', 118,
        '~', 132,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(233);
      if (set_contains(sym__identifier_token_character_set_2, 433, lookahead)) ADVANCE(292);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(161);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(168);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(169);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(155);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(164);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(163);
      if (lookahead == '>') ADVANCE(157);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(163);
      if (lookahead == '>') ADVANCE(158);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(186);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(185);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(162);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(133);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(133);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(134);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(134);
      if (lookahead == '=') ADVANCE(172);
      if (lookahead == '>') ADVANCE(226);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(134);
      if (lookahead == '>') ADVANCE(226);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(226);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(173);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(364);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(364);
      if (lookahead == '=') ADVANCE(174);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(175);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(177);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(178);
      if (lookahead == '|') ADVANCE(184);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(184);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(183);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(183);
      if (lookahead == '=') ADVANCE(176);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(179);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(180);
      if (lookahead == '>') ADVANCE(160);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(181);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(182);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '#') ADVANCE(196);
      if (lookahead == '/') ADVANCE(189);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '/') ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '/') ADVANCE(225);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(21);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(21);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'a') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'b') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      ADVANCE_MAP(
        'd', 200,
        'e', 214,
        'l', 207,
        'n', 223,
        'p', 220,
        'r', 201,
        'u', 215,
        '\t', 196,
        ' ', 196,
      );
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'd') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(204);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'e') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'f') ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'g') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'i') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'l') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'm') ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(197);
      if (lookahead == 'r') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'n') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'o') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(194);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'r') ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == 'u') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(225);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(364);
      if (lookahead != 0) ADVANCE(224);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_character_literal_content);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_character_literal_content);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(364);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_character_literal_content);
      ADVANCE_MAP(
        'd', 51,
        'e', 76,
        'l', 62,
        'n', 86,
        'p', 82,
        'r', 46,
        'u', 75,
        '\t', 42,
        ' ', 42,
      );
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 89,
        '_', 31,
        'B', 32,
        'b', 32,
        'E', 88,
        'e', 88,
        'L', 239,
        'l', 239,
        'U', 238,
        'u', 238,
        'X', 33,
        'x', 33,
        'D', 240,
        'F', 240,
        'M', 240,
        'd', 240,
        'f', 240,
        'm', 240,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '.', 89,
        '_', 31,
        'E', 88,
        'e', 88,
        'L', 239,
        'l', 239,
        'U', 238,
        'u', 238,
        'D', 240,
        'F', 240,
        'M', 240,
        'd', 240,
        'f', 240,
        'm', 240,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(239);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(33);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(239);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(235);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_integer_literal);
      ADVANCE_MAP(
        '_', 35,
        'B', 32,
        'b', 32,
        'L', 239,
        'l', 239,
        'U', 238,
        'u', 238,
        'X', 33,
        'x', 33,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(239);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(231);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_real_literal);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_real_literal);
      ADVANCE_MAP(
        '_', 34,
        'E', 88,
        'e', 88,
        'D', 240,
        'F', 240,
        'M', 240,
        'd', 240,
        'f', 240,
        'm', 240,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'M' ||
          lookahead == 'd' ||
          lookahead == 'f' ||
          lookahead == 'm') ADVANCE(240);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(242);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '\r') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(243);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '#') ADVANCE(252);
      if (lookahead == '/') ADVANCE(245);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(244);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '#' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(247);
      if (lookahead == '/') ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(246);
      if (lookahead == '/') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(247);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == '*') ADVANCE(246);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(247);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(251);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'a') ADVANCE(261);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'b') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      ADVANCE_MAP(
        'd', 256,
        'e', 270,
        'l', 263,
        'n', 279,
        'p', 276,
        'r', 257,
        'u', 271,
        '\t', 252,
        ' ', 252,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(278);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'd') ADVANCE(258);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(260);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(262);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'e') ADVANCE(259);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'f') ADVANCE(263);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(268);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'g') ADVANCE(264);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'i') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(249);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'l') ADVANCE(255);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'm') ADVANCE(248);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(253);
      if (lookahead == 'r') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(269);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'o') ADVANCE(275);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(250);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(274);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'r') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead == 'u') ADVANCE(265);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(280);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(100);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(93);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_string_literal_content_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(96);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(285);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(286);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      if (lookahead == '"') ADVANCE(13);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(23);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_raw_string_literal_token1);
      if (set_contains(sym__identifier_token_character_set_3, 492, lookahead)) ADVANCE(292);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym__identifier_token);
      if (lookahead == '8') ADVANCE(290);
      if (set_contains(sym__identifier_token_character_set_3, 492, lookahead)) ADVANCE(292);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym__identifier_token);
      if (set_contains(sym__identifier_token_character_set_3, 492, lookahead)) ADVANCE(292);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(294);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (lookahead == '\n') ADVANCE(295);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(301);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_preproc_if_token3);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(21);
      if (lookahead == '*') ADVANCE(299);
      if (lookahead == '/') ADVANCE(360);
      if (lookahead == '\\') ADVANCE(304);
      if (lookahead != 0) ADVANCE(300);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(21);
      if (lookahead == '*') ADVANCE(299);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(304);
      if (lookahead != 0) ADVANCE(300);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(295);
      if (lookahead == '#') ADVANCE(312);
      if (lookahead == '/') ADVANCE(306);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(301);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(301);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(15);
      if (lookahead == '#') ADVANCE(312);
      if (lookahead == '/') ADVANCE(306);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) ADVANCE(302);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(302);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(350);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(307);
      if (lookahead == '*') ADVANCE(299);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(304);
      if (lookahead != 0) ADVANCE(300);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(300);
      if (lookahead == '/') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(300);
      if (lookahead == '/') ADVANCE(363);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(299);
      if (lookahead == '/') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(304);
      if (lookahead != 0) ADVANCE(300);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'a') ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'a') ADVANCE(311);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'a') ADVANCE(324);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'b') ADVANCE(333);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_preproc_arg);
      ADVANCE_MAP(
        '/', 102,
        '\\', 303,
        'd', 318,
        'e', 337,
        'l', 327,
        'n', 348,
        'p', 345,
        'r', 319,
        'u', 338,
        '\t', 312,
        ' ', 312,
      );
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'd') ADVANCE(347);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'd') ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(353);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(357);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(355);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(323);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(325);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(322);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(326);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'f') ADVANCE(358);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'f') ADVANCE(329);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'g') ADVANCE(334);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'g') ADVANCE(328);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'g') ADVANCE(330);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'i') ADVANCE(339);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'i') ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'i') ADVANCE(340);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'i') ADVANCE(343);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'l') ADVANCE(332);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'l') ADVANCE(309);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'l') ADVANCE(317);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'm') ADVANCE(308);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(351);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(352);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(313);
      if (lookahead == 'r') ADVANCE(346);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(315);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'n') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'o') ADVANCE(335);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'o') ADVANCE(344);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'o') ADVANCE(336);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'r') ADVANCE(356);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'r') ADVANCE(310);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'r') ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'r') ADVANCE(321);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead == 'u') ADVANCE(331);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(349);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(303);
      if (lookahead != 0) ADVANCE(349);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_preproc_region_token1);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_preproc_endregion_token1);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_line_token1);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_pragma_token1);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_nullable_token1);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_preproc_error_token1);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_preproc_define_token1);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_preproc_undef_token1);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_shebang_directive);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(359);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(362);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(362);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(363);
      if (lookahead == '\\') ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(362);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(364);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        'U', 5,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 25,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 3:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(33);
      END_STATE();
    case 5:
      if (lookahead == '8') ADVANCE(34);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(sym_discard);
      if (lookahead == '_') ADVANCE(35);
      END_STATE();
    case 7:
      if (lookahead == 'b') ADVANCE(36);
      if (lookahead == 'd') ADVANCE(37);
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(39);
      if (lookahead == 's') ADVANCE(40);
      if (lookahead == 'w') ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(44);
      if (lookahead == 'y') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(46);
      if (lookahead == 'h') ADVANCE(47);
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'i') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(53);
      if (lookahead == 'n') ADVANCE(54);
      if (lookahead == 'q') ADVANCE(55);
      if (lookahead == 'v') ADVANCE(56);
      if (lookahead == 'x') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'i') ADVANCE(59);
      if (lookahead == 'l') ADVANCE(60);
      if (lookahead == 'o') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(63);
      if (lookahead == 'l') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 14:
      if (lookahead == 'i') ADVANCE(67);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(68);
      if (lookahead == 'm') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(70);
      if (lookahead == 's') ADVANCE(71);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(73);
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(78);
      if (lookahead == 'e') ADVANCE(79);
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 20:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 'r') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'v') ADVANCE(88);
      END_STATE();
    case 21:
      if (lookahead == 'a') ADVANCE(89);
      if (lookahead == 'r') ADVANCE(90);
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 23:
      if (lookahead == 'b') ADVANCE(93);
      if (lookahead == 'c') ADVANCE(94);
      if (lookahead == 'e') ADVANCE(95);
      if (lookahead == 'h') ADVANCE(96);
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      if (lookahead == 'w') ADVANCE(99);
      END_STATE();
    case 24:
      if (lookahead == 'h') ADVANCE(100);
      if (lookahead == 'r') ADVANCE(101);
      if (lookahead == 'y') ADVANCE(102);
      END_STATE();
    case 25:
      if (lookahead == '8') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(108);
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'h') ADVANCE(111);
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 28:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'C', 1,
        'F', 2,
        'S', 3,
        'T', 4,
        '_', 6,
        'a', 7,
        'b', 8,
        'c', 9,
        'd', 10,
        'e', 11,
        'f', 12,
        'g', 13,
        'h', 14,
        'i', 15,
        'j', 16,
        'l', 17,
        'm', 18,
        'n', 19,
        'o', 20,
        'p', 21,
        'r', 22,
        's', 23,
        't', 24,
        'u', 114,
        'v', 26,
        'w', 27,
        'y', 28,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x3000 ||
          lookahead == 0xfeff) SKIP(29);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(117);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(sym_string_literal_encoding);
      END_STATE();
    case 35:
      if (lookahead == 'm') ADVANCE(119);
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 36:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 37:
      if (lookahead == 'd') ADVANCE(122);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(123);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(124);
      if (lookahead == 'n') ADVANCE(125);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'c') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 'y') ADVANCE(128);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 42:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_by);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(136);
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(140);
      if (lookahead == 'f') ADVANCE(141);
      if (lookahead == 'l') ADVANCE(142);
      if (lookahead == 's') ADVANCE(143);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(144);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(150);
      END_STATE();
    case 57:
      if (lookahead == 'p') ADVANCE(151);
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 58:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(154);
      if (lookahead == 'l') ADVANCE(155);
      if (lookahead == 'n') ADVANCE(156);
      if (lookahead == 'x') ADVANCE(157);
      END_STATE();
    case 60:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 61:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(160);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 67:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 69:
      if (lookahead == 'p') ADVANCE(166);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'i') ADVANCE(167);
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(169);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(171);
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(173);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(175);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(176);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(177);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(180);
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 83:
      if (lookahead == 'j') ADVANCE(182);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(184);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(185);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(187);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(188);
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 91:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(191);
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'f') ADVANCE(193);
      if (lookahead == 'm') ADVANCE(194);
      if (lookahead == 'q') ADVANCE(195);
      if (lookahead == 's') ADVANCE(196);
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 93:
      if (lookahead == 'y') ADVANCE(198);
      END_STATE();
    case 94:
      if (lookahead == 'o') ADVANCE(199);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(200);
      if (lookahead == 'l') ADVANCE(201);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 97:
      if (lookahead == 'z') ADVANCE(204);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(205);
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(208);
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(210);
      if (lookahead == 'y') ADVANCE(211);
      END_STATE();
    case 102:
      if (lookahead == 'p') ADVANCE(212);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(213);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 105:
      if (lookahead == 'c') ADVANCE(215);
      if (lookahead == 'm') ADVANCE(216);
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 108:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 109:
      if (lookahead == 'i') ADVANCE(222);
      if (lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(225);
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(228);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(103);
      if (lookahead == 'l') ADVANCE(104);
      if (lookahead == 'n') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(229);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(232);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 125:
      if (lookahead == 'o') ADVANCE(237);
      END_STATE();
    case 126:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 136:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 137:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(248);
      END_STATE();
    case 139:
      if (lookahead == 's') ADVANCE(249);
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(251);
      END_STATE();
    case 141:
      if (lookahead == 'a') ADVANCE(252);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 143:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 145:
      if (lookahead == 'b') ADVANCE(256);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 147:
      if (lookahead == 'b') ADVANCE(258);
      END_STATE();
    case 148:
      if (lookahead == 'm') ADVANCE(259);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(260);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 153:
      if (lookahead == 's') ADVANCE(264);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(265);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(266);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 157:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 158:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(270);
      END_STATE();
    case 160:
      if (lookahead == 'm') ADVANCE(271);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 162:
      if (lookahead == 'b') ADVANCE(272);
      END_STATE();
    case 163:
      if (lookahead == 'o') ADVANCE(273);
      END_STATE();
    case 164:
      if (lookahead == 'u') ADVANCE(274);
      END_STATE();
    case 165:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(276);
      END_STATE();
    case 167:
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_predefined_type);
      if (lookahead == 'e') ADVANCE(278);
      if (lookahead == 'o') ADVANCE(279);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 171:
      if (lookahead == 'k') ADVANCE(281);
      END_STATE();
    case 172:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 173:
      if (lookahead == 'a') ADVANCE(282);
      END_STATE();
    case 174:
      if (lookahead == 'h') ADVANCE(283);
      END_STATE();
    case 175:
      if (lookahead == 'u') ADVANCE(284);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 178:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == 'n') ADVANCE(286);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 181:
      if (lookahead == 'l') ADVANCE(288);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(292);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 188:
      if (lookahead == 'v') ADVANCE(295);
      END_STATE();
    case 189:
      if (lookahead == 'p') ADVANCE(296);
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 190:
      if (lookahead == 'l') ADVANCE(298);
      END_STATE();
    case 191:
      if (lookahead == 'd') ADVANCE(299);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 194:
      if (lookahead == 'o') ADVANCE(301);
      END_STATE();
    case 195:
      if (lookahead == 'u') ADVANCE(302);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(303);
      END_STATE();
    case 197:
      if (lookahead == 'u') ADVANCE(304);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(305);
      END_STATE();
    case 199:
      if (lookahead == 'p') ADVANCE(306);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(307);
      END_STATE();
    case 201:
      if (lookahead == 'e') ADVANCE(308);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(309);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 205:
      if (lookahead == 'c') ADVANCE(311);
      if (lookahead == 't') ADVANCE(312);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(313);
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(316);
      END_STATE();
    case 209:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 213:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(320);
      END_STATE();
    case 215:
      if (lookahead == 'h') ADVANCE(321);
      END_STATE();
    case 216:
      if (lookahead == 'a') ADVANCE(322);
      END_STATE();
    case 217:
      if (lookahead == 'a') ADVANCE(323);
      END_STATE();
    case 218:
      if (lookahead == 'o') ADVANCE(324);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 222:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 223:
      if (lookahead == 'a') ADVANCE(327);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(328);
      END_STATE();
    case 225:
      if (lookahead == 'n') ADVANCE(329);
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 227:
      if (lookahead == 'h') ADVANCE(332);
      END_STATE();
    case 228:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 231:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 232:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 233:
      if (lookahead == 'k') ADVANCE(338);
      END_STATE();
    case 234:
      if (lookahead == 'f') ADVANCE(339);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(340);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(341);
      END_STATE();
    case 237:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 238:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 239:
      if (lookahead == 'm') ADVANCE(344);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(346);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_base);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_predefined_type);
      END_STATE();
    case 244:
      if (lookahead == 'k') ADVANCE(347);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 246:
      if (lookahead == 'h') ADVANCE(348);
      END_STATE();
    case 247:
      if (lookahead == 'k') ADVANCE(349);
      END_STATE();
    case 248:
      if (lookahead == 's') ADVANCE(350);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(351);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 251:
      if (lookahead == 'm') ADVANCE(353);
      END_STATE();
    case 252:
      if (lookahead == 'u') ADVANCE(354);
      END_STATE();
    case 253:
      if (lookahead == 'g') ADVANCE(355);
      END_STATE();
    case 254:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 255:
      if (lookahead == 'b') ADVANCE(357);
      END_STATE();
    case 256:
      if (lookahead == 'l') ADVANCE(358);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 258:
      if (lookahead == 'l') ADVANCE(359);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 260:
      if (lookahead == 'l') ADVANCE(360);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 262:
      if (lookahead == 'i') ADVANCE(362);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(363);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 265:
      if (lookahead == 'd') ADVANCE(365);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_file);
      END_STATE();
    case 267:
      if (lookahead == 'l') ADVANCE(366);
      END_STATE();
    case 268:
      if (lookahead == 'd') ADVANCE(367);
      END_STATE();
    case 269:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 272:
      if (lookahead == 'a') ADVANCE(369);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 274:
      if (lookahead == 'p') ADVANCE(370);
      END_STATE();
    case 275:
      if (lookahead == 'e') ADVANCE(371);
      END_STATE();
    case 276:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_init);
      END_STATE();
    case 278:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_into);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_join);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 282:
      if (lookahead == 'g') ADVANCE(374);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(375);
      END_STATE();
    case 284:
      if (lookahead == 'l') ADVANCE(376);
      END_STATE();
    case 285:
      if (lookahead == 's') ADVANCE(377);
      END_STATE();
    case 286:
      if (lookahead == 'u') ADVANCE(378);
      END_STATE();
    case 287:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 289:
      if (lookahead == 'c') ADVANCE(379);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(380);
      END_STATE();
    case 291:
      if (lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 292:
      if (lookahead == 'r') ADVANCE(382);
      END_STATE();
    case 293:
      if (lookahead == 'm') ADVANCE(383);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(384);
      END_STATE();
    case 295:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 296:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 298:
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 299:
      if (lookahead == 'o') ADVANCE(389);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 301:
      if (lookahead == 'v') ADVANCE(391);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(392);
      END_STATE();
    case 303:
      if (lookahead == 'o') ADVANCE(393);
      END_STATE();
    case 304:
      if (lookahead == 'r') ADVANCE(394);
      END_STATE();
    case 305:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(397);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 310:
      if (lookahead == 'o') ADVANCE(398);
      END_STATE();
    case 311:
      if (lookahead == 'k') ADVANCE(399);
      END_STATE();
    case 312:
      if (lookahead == 'i') ADVANCE(400);
      END_STATE();
    case 313:
      if (lookahead == 'n') ADVANCE(401);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(402);
      END_STATE();
    case 315:
      if (lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 317:
      if (lookahead == 'w') ADVANCE(404);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(405);
      END_STATE();
    case 320:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 321:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 322:
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 323:
      if (lookahead == 'f') ADVANCE(408);
      END_STATE();
    case 324:
      if (lookahead == 'r') ADVANCE(409);
      END_STATE();
    case 325:
      if (lookahead == 'g') ADVANCE(410);
      END_STATE();
    case 326:
      if (lookahead == 'u') ADVANCE(411);
      END_STATE();
    case 327:
      if (lookahead == 't') ADVANCE(412);
      END_STATE();
    case 328:
      if (lookahead == 'i') ADVANCE(413);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(414);
      END_STATE();
    case 331:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 333:
      if (lookahead == 'd') ADVANCE(416);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_Cdecl);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(417);
      END_STATE();
    case 336:
      if (lookahead == 'l') ADVANCE(418);
      END_STATE();
    case 337:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 338:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 339:
      if (lookahead == 't') ADVANCE(421);
      if (lookahead == 'v') ADVANCE(422);
      END_STATE();
    case 340:
      if (lookahead == 'a') ADVANCE(423);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 342:
      if (lookahead == 'a') ADVANCE(424);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(425);
      END_STATE();
    case 344:
      if (lookahead == 'b') ADVANCE(426);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(427);
      if (lookahead == 's') ADVANCE(428);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 352:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 354:
      if (lookahead == 'l') ADVANCE(431);
      END_STATE();
    case 355:
      if (lookahead == 'a') ADVANCE(432);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(433);
      END_STATE();
    case 357:
      if (lookahead == 'l') ADVANCE(434);
      END_STATE();
    case 358:
      if (lookahead == 'e') ADVANCE(243);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 360:
      if (lookahead == 's') ADVANCE(436);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 362:
      if (lookahead == 'c') ADVANCE(437);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 366:
      if (lookahead == 'l') ADVANCE(439);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_fixed);
      END_STATE();
    case 368:
      if (lookahead == 'c') ADVANCE(440);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(441);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 371:
      if (lookahead == 'n') ADVANCE(442);
      END_STATE();
    case 372:
      if (lookahead == 'c') ADVANCE(443);
      END_STATE();
    case 373:
      if (lookahead == 'f') ADVANCE(444);
      if (lookahead == 'n') ADVANCE(445);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(446);
      END_STATE();
    case 375:
      if (lookahead == 'd') ADVANCE(447);
      END_STATE();
    case 376:
      if (lookahead == 'e') ADVANCE(448);
      END_STATE();
    case 377:
      if (lookahead == 'p') ADVANCE(449);
      END_STATE();
    case 378:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 379:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 380:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 381:
      if (lookahead == 'b') ADVANCE(452);
      END_STATE();
    case 382:
      if (lookahead == 'i') ADVANCE(453);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_param);
      if (lookahead == 's') ADVANCE(454);
      END_STATE();
    case 384:
      if (lookahead == 'a') ADVANCE(455);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(456);
      END_STATE();
    case 386:
      if (lookahead == 'r') ADVANCE(457);
      END_STATE();
    case 387:
      if (lookahead == 'c') ADVANCE(458);
      END_STATE();
    case 388:
      if (lookahead == 'c') ADVANCE(459);
      END_STATE();
    case 389:
      if (lookahead == 'n') ADVANCE(460);
      END_STATE();
    case 390:
      if (lookahead == 'd') ADVANCE(461);
      END_STATE();
    case 391:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 392:
      if (lookahead == 'r') ADVANCE(463);
      END_STATE();
    case 393:
      if (lookahead == 'r') ADVANCE(464);
      END_STATE();
    case 394:
      if (lookahead == 'n') ADVANCE(465);
      END_STATE();
    case 395:
      if (lookahead == 'd') ADVANCE(466);
      END_STATE();
    case 396:
      if (lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(468);
      END_STATE();
    case 398:
      if (lookahead == 'f') ADVANCE(469);
      END_STATE();
    case 399:
      if (lookahead == 'a') ADVANCE(470);
      END_STATE();
    case 400:
      if (lookahead == 'c') ADVANCE(471);
      END_STATE();
    case 401:
      if (lookahead == 'g') ADVANCE(243);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(472);
      END_STATE();
    case 403:
      if (lookahead == 'h') ADVANCE(473);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 405:
      if (lookahead == 'f') ADVANCE(474);
      END_STATE();
    case 406:
      if (lookahead == 'c') ADVANCE(475);
      END_STATE();
    case 407:
      if (lookahead == 'a') ADVANCE(476);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 409:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 411:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 412:
      if (lookahead == 'i') ADVANCE(479);
      END_STATE();
    case 413:
      if (lookahead == 'n') ADVANCE(480);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 417:
      if (lookahead == 'l') ADVANCE(481);
      END_STATE();
    case 418:
      if (lookahead == 'l') ADVANCE(482);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 420:
      if (lookahead == 'r') ADVANCE(484);
      END_STATE();
    case 421:
      if (lookahead == 'y') ADVANCE(485);
      END_STATE();
    case 422:
      if (lookahead == 'a') ADVANCE(486);
      END_STATE();
    case 423:
      if (lookahead == 'c') ADVANCE(487);
      END_STATE();
    case 424:
      if (lookahead == 't') ADVANCE(488);
      END_STATE();
    case 425:
      if (lookahead == 'i') ADVANCE(489);
      END_STATE();
    case 426:
      if (lookahead == 'l') ADVANCE(490);
      END_STATE();
    case 427:
      if (lookahead == 'd') ADVANCE(491);
      END_STATE();
    case 428:
      if (lookahead == 'u') ADVANCE(492);
      END_STATE();
    case 429:
      if (lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 430:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 431:
      if (lookahead == 't') ADVANCE(494);
      END_STATE();
    case 432:
      if (lookahead == 't') ADVANCE(495);
      END_STATE();
    case 433:
      if (lookahead == 'd') ADVANCE(496);
      END_STATE();
    case 434:
      if (lookahead == 'e') ADVANCE(497);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_equals);
      END_STATE();
    case 437:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 439:
      if (lookahead == 'y') ADVANCE(499);
      END_STATE();
    case 440:
      if (lookahead == 'h') ADVANCE(500);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(501);
      END_STATE();
    case 444:
      if (lookahead == 'a') ADVANCE(502);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 446:
      if (lookahead == 'd') ADVANCE(504);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(505);
      END_STATE();
    case 450:
      if (lookahead == 'l') ADVANCE(506);
      END_STATE();
    case 451:
      if (lookahead == 'o') ADVANCE(507);
      END_STATE();
    case 452:
      if (lookahead == 'y') ADVANCE(508);
      END_STATE();
    case 453:
      if (lookahead == 'd') ADVANCE(509);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 455:
      if (lookahead == 'l') ADVANCE(510);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(511);
      END_STATE();
    case 457:
      if (lookahead == 't') ADVANCE(512);
      END_STATE();
    case 458:
      if (lookahead == 't') ADVANCE(513);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 460:
      if (lookahead == 'l') ADVANCE(514);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 463:
      if (lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_scoped);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 470:
      if (lookahead == 'l') ADVANCE(517);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 475:
      if (lookahead == 'k') ADVANCE(518);
      END_STATE();
    case 476:
      if (lookahead == 'g') ADVANCE(519);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 478:
      if (lookahead == 'l') ADVANCE(520);
      END_STATE();
    case 479:
      if (lookahead == 'l') ADVANCE(521);
      END_STATE();
    case 480:
      if (lookahead == 'g') ADVANCE(522);
      END_STATE();
    case 481:
      if (lookahead == 'l') ADVANCE(523);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_Stdcall);
      END_STATE();
    case 483:
      if (lookahead == 'l') ADVANCE(524);
      END_STATE();
    case 484:
      if (lookahead == 'e') ADVANCE(525);
      END_STATE();
    case 485:
      if (lookahead == 'p') ADVANCE(526);
      END_STATE();
    case 486:
      if (lookahead == 'l') ADVANCE(527);
      END_STATE();
    case 487:
      if (lookahead == 't') ADVANCE(528);
      END_STATE();
    case 488:
      if (lookahead == 'i') ADVANCE(529);
      END_STATE();
    case 489:
      if (lookahead == 'n') ADVANCE(530);
      END_STATE();
    case 490:
      if (lookahead == 'y') ADVANCE(531);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_checked);
      END_STATE();
    case 492:
      if (lookahead == 'm') ADVANCE(532);
      END_STATE();
    case 493:
      if (lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 495:
      if (lookahead == 'e') ADVANCE(534);
      END_STATE();
    case 496:
      if (lookahead == 'i') ADVANCE(535);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_disable);
      END_STATE();
    case 498:
      if (lookahead == 't') ADVANCE(536);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 501:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 502:
      if (lookahead == 'c') ADVANCE(538);
      END_STATE();
    case 503:
      if (lookahead == 'l') ADVANCE(539);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_managed);
      END_STATE();
    case 505:
      if (lookahead == 'c') ADVANCE(540);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_notnull);
      END_STATE();
    case 507:
      if (lookahead == 'r') ADVANCE(541);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(anon_sym_orderby);
      END_STATE();
    case 509:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_partial);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 512:
      if (lookahead == 'y') ADVANCE(543);
      END_STATE();
    case 513:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 514:
      if (lookahead == 'y') ADVANCE(545);
      END_STATE();
    case 515:
      if (lookahead == 'd') ADVANCE(546);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_restore);
      END_STATE();
    case 517:
      if (lookahead == 'l') ADVANCE(547);
      END_STATE();
    case 518:
      if (lookahead == 'e') ADVANCE(548);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(549);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 521:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_warning);
      if (lookahead == 's') ADVANCE(551);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_Fastcall);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_Thiscall);
      END_STATE();
    case 525:
      if (lookahead == 'f') ADVANCE(552);
      END_STATE();
    case 526:
      if (lookahead == 'e') ADVANCE(553);
      END_STATE();
    case 527:
      if (lookahead == 'u') ADVANCE(554);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 529:
      if (lookahead == 'o') ADVANCE(555);
      END_STATE();
    case 530:
      if (lookahead == 'g') ADVANCE(556);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_checksum);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 535:
      if (lookahead == 'n') ADVANCE(557);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_implicit);
      END_STATE();
    case 538:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 540:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 544:
      if (lookahead == 'd') ADVANCE(560);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 547:
      if (lookahead == 'o') ADVANCE(561);
      END_STATE();
    case 548:
      if (lookahead == 'd') ADVANCE(562);
      END_STATE();
    case 549:
      if (lookahead == 'd') ADVANCE(563);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_warnings);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym___makeref);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym___reftype);
      END_STATE();
    case 554:
      if (lookahead == 'e') ADVANCE(564);
      END_STATE();
    case 555:
      if (lookahead == 'n') ADVANCE(565);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_ascending);
      END_STATE();
    case 557:
      if (lookahead == 'g') ADVANCE(566);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 561:
      if (lookahead == 'c') ADVANCE(567);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_unchecked);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym___refvalue);
      END_STATE();
    case 565:
      if (lookahead == 's') ADVANCE(568);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_descending);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_stackalloc);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_annotations);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 105, .external_lex_state = 2},
  [2] = {.lex_state = 105, .external_lex_state = 2},
  [3] = {.lex_state = 105, .external_lex_state = 2},
  [4] = {.lex_state = 105, .external_lex_state = 2},
  [5] = {.lex_state = 105, .external_lex_state = 2},
  [6] = {.lex_state = 105, .external_lex_state = 2},
  [7] = {.lex_state = 105, .external_lex_state = 2},
  [8] = {.lex_state = 105, .external_lex_state = 2},
  [9] = {.lex_state = 105, .external_lex_state = 2},
  [10] = {.lex_state = 105, .external_lex_state = 2},
  [11] = {.lex_state = 105, .external_lex_state = 2},
  [12] = {.lex_state = 105, .external_lex_state = 2},
  [13] = {.lex_state = 105, .external_lex_state = 2},
  [14] = {.lex_state = 105, .external_lex_state = 2},
  [15] = {.lex_state = 105, .external_lex_state = 2},
  [16] = {.lex_state = 105, .external_lex_state = 2},
  [17] = {.lex_state = 105, .external_lex_state = 2},
  [18] = {.lex_state = 105, .external_lex_state = 2},
  [19] = {.lex_state = 105, .external_lex_state = 2},
  [20] = {.lex_state = 105, .external_lex_state = 2},
  [21] = {.lex_state = 105, .external_lex_state = 2},
  [22] = {.lex_state = 105, .external_lex_state = 2},
  [23] = {.lex_state = 105, .external_lex_state = 2},
  [24] = {.lex_state = 105, .external_lex_state = 2},
  [25] = {.lex_state = 105, .external_lex_state = 2},
  [26] = {.lex_state = 105, .external_lex_state = 2},
  [27] = {.lex_state = 105, .external_lex_state = 2},
  [28] = {.lex_state = 105, .external_lex_state = 2},
  [29] = {.lex_state = 105, .external_lex_state = 2},
  [30] = {.lex_state = 105, .external_lex_state = 2},
  [31] = {.lex_state = 105, .external_lex_state = 2},
  [32] = {.lex_state = 105, .external_lex_state = 2},
  [33] = {.lex_state = 105, .external_lex_state = 2},
  [34] = {.lex_state = 105, .external_lex_state = 2},
  [35] = {.lex_state = 105, .external_lex_state = 2},
  [36] = {.lex_state = 105, .external_lex_state = 2},
  [37] = {.lex_state = 105, .external_lex_state = 2},
  [38] = {.lex_state = 105, .external_lex_state = 2},
  [39] = {.lex_state = 105, .external_lex_state = 2},
  [40] = {.lex_state = 105, .external_lex_state = 2},
  [41] = {.lex_state = 105, .external_lex_state = 2},
  [42] = {.lex_state = 105, .external_lex_state = 2},
  [43] = {.lex_state = 105, .external_lex_state = 2},
  [44] = {.lex_state = 105, .external_lex_state = 2},
  [45] = {.lex_state = 105, .external_lex_state = 2},
  [46] = {.lex_state = 105, .external_lex_state = 2},
  [47] = {.lex_state = 105, .external_lex_state = 2},
  [48] = {.lex_state = 105, .external_lex_state = 2},
  [49] = {.lex_state = 105, .external_lex_state = 2},
  [50] = {.lex_state = 105, .external_lex_state = 2},
  [51] = {.lex_state = 105, .external_lex_state = 2},
  [52] = {.lex_state = 105, .external_lex_state = 2},
  [53] = {.lex_state = 105, .external_lex_state = 2},
  [54] = {.lex_state = 105, .external_lex_state = 2},
  [55] = {.lex_state = 105, .external_lex_state = 2},
  [56] = {.lex_state = 105, .external_lex_state = 2},
  [57] = {.lex_state = 105, .external_lex_state = 2},
  [58] = {.lex_state = 105, .external_lex_state = 2},
  [59] = {.lex_state = 105, .external_lex_state = 2},
  [60] = {.lex_state = 105, .external_lex_state = 2},
  [61] = {.lex_state = 105, .external_lex_state = 2},
  [62] = {.lex_state = 105, .external_lex_state = 2},
  [63] = {.lex_state = 105, .external_lex_state = 2},
  [64] = {.lex_state = 105, .external_lex_state = 2},
  [65] = {.lex_state = 105, .external_lex_state = 2},
  [66] = {.lex_state = 105, .external_lex_state = 2},
  [67] = {.lex_state = 105, .external_lex_state = 2},
  [68] = {.lex_state = 105, .external_lex_state = 2},
  [69] = {.lex_state = 105, .external_lex_state = 2},
  [70] = {.lex_state = 105, .external_lex_state = 2},
  [71] = {.lex_state = 105, .external_lex_state = 2},
  [72] = {.lex_state = 105, .external_lex_state = 2},
  [73] = {.lex_state = 105, .external_lex_state = 2},
  [74] = {.lex_state = 105, .external_lex_state = 2},
  [75] = {.lex_state = 105, .external_lex_state = 2},
  [76] = {.lex_state = 105, .external_lex_state = 2},
  [77] = {.lex_state = 105, .external_lex_state = 2},
  [78] = {.lex_state = 105, .external_lex_state = 2},
  [79] = {.lex_state = 105, .external_lex_state = 2},
  [80] = {.lex_state = 105, .external_lex_state = 2},
  [81] = {.lex_state = 105, .external_lex_state = 2},
  [82] = {.lex_state = 105, .external_lex_state = 2},
  [83] = {.lex_state = 105, .external_lex_state = 2},
  [84] = {.lex_state = 105, .external_lex_state = 2},
  [85] = {.lex_state = 105, .external_lex_state = 2},
  [86] = {.lex_state = 105, .external_lex_state = 2},
  [87] = {.lex_state = 105, .external_lex_state = 2},
  [88] = {.lex_state = 105, .external_lex_state = 2},
  [89] = {.lex_state = 105, .external_lex_state = 2},
  [90] = {.lex_state = 105, .external_lex_state = 2},
  [91] = {.lex_state = 105, .external_lex_state = 2},
  [92] = {.lex_state = 105, .external_lex_state = 2},
  [93] = {.lex_state = 105, .external_lex_state = 2},
  [94] = {.lex_state = 105, .external_lex_state = 2},
  [95] = {.lex_state = 105, .external_lex_state = 2},
  [96] = {.lex_state = 105, .external_lex_state = 2},
  [97] = {.lex_state = 105, .external_lex_state = 2},
  [98] = {.lex_state = 105, .external_lex_state = 2},
  [99] = {.lex_state = 105, .external_lex_state = 2},
  [100] = {.lex_state = 105, .external_lex_state = 2},
  [101] = {.lex_state = 105, .external_lex_state = 2},
  [102] = {.lex_state = 105, .external_lex_state = 2},
  [103] = {.lex_state = 105, .external_lex_state = 2},
  [104] = {.lex_state = 105, .external_lex_state = 2},
  [105] = {.lex_state = 105, .external_lex_state = 2},
  [106] = {.lex_state = 105, .external_lex_state = 2},
  [107] = {.lex_state = 105, .external_lex_state = 2},
  [108] = {.lex_state = 105, .external_lex_state = 2},
  [109] = {.lex_state = 105, .external_lex_state = 2},
  [110] = {.lex_state = 105, .external_lex_state = 2},
  [111] = {.lex_state = 105, .external_lex_state = 2},
  [112] = {.lex_state = 105, .external_lex_state = 2},
  [113] = {.lex_state = 105, .external_lex_state = 2},
  [114] = {.lex_state = 105, .external_lex_state = 2},
  [115] = {.lex_state = 105, .external_lex_state = 2},
  [116] = {.lex_state = 105, .external_lex_state = 2},
  [117] = {.lex_state = 105, .external_lex_state = 2},
  [118] = {.lex_state = 105, .external_lex_state = 2},
  [119] = {.lex_state = 105, .external_lex_state = 2},
  [120] = {.lex_state = 105, .external_lex_state = 2},
  [121] = {.lex_state = 105, .external_lex_state = 2},
  [122] = {.lex_state = 105, .external_lex_state = 2},
  [123] = {.lex_state = 105, .external_lex_state = 2},
  [124] = {.lex_state = 105, .external_lex_state = 2},
  [125] = {.lex_state = 105, .external_lex_state = 2},
  [126] = {.lex_state = 105, .external_lex_state = 2},
  [127] = {.lex_state = 105, .external_lex_state = 2},
  [128] = {.lex_state = 105, .external_lex_state = 2},
  [129] = {.lex_state = 105, .external_lex_state = 2},
  [130] = {.lex_state = 105, .external_lex_state = 2},
  [131] = {.lex_state = 105, .external_lex_state = 2},
  [132] = {.lex_state = 105, .external_lex_state = 2},
  [133] = {.lex_state = 105, .external_lex_state = 2},
  [134] = {.lex_state = 105, .external_lex_state = 2},
  [135] = {.lex_state = 105, .external_lex_state = 2},
  [136] = {.lex_state = 105, .external_lex_state = 2},
  [137] = {.lex_state = 105, .external_lex_state = 2},
  [138] = {.lex_state = 105, .external_lex_state = 2},
  [139] = {.lex_state = 105, .external_lex_state = 2},
  [140] = {.lex_state = 105, .external_lex_state = 2},
  [141] = {.lex_state = 105, .external_lex_state = 2},
  [142] = {.lex_state = 105, .external_lex_state = 2},
  [143] = {.lex_state = 105, .external_lex_state = 2},
  [144] = {.lex_state = 105, .external_lex_state = 2},
  [145] = {.lex_state = 105, .external_lex_state = 2},
  [146] = {.lex_state = 105, .external_lex_state = 2},
  [147] = {.lex_state = 105, .external_lex_state = 2},
  [148] = {.lex_state = 105, .external_lex_state = 2},
  [149] = {.lex_state = 105, .external_lex_state = 2},
  [150] = {.lex_state = 105, .external_lex_state = 2},
  [151] = {.lex_state = 105, .external_lex_state = 2},
  [152] = {.lex_state = 105, .external_lex_state = 2},
  [153] = {.lex_state = 105, .external_lex_state = 2},
  [154] = {.lex_state = 105, .external_lex_state = 2},
  [155] = {.lex_state = 105, .external_lex_state = 2},
  [156] = {.lex_state = 105, .external_lex_state = 2},
  [157] = {.lex_state = 105, .external_lex_state = 2},
  [158] = {.lex_state = 105, .external_lex_state = 2},
  [159] = {.lex_state = 105, .external_lex_state = 2},
  [160] = {.lex_state = 105, .external_lex_state = 2},
  [161] = {.lex_state = 105, .external_lex_state = 2},
  [162] = {.lex_state = 105, .external_lex_state = 2},
  [163] = {.lex_state = 105, .external_lex_state = 2},
  [164] = {.lex_state = 105, .external_lex_state = 2},
  [165] = {.lex_state = 105, .external_lex_state = 2},
  [166] = {.lex_state = 105, .external_lex_state = 2},
  [167] = {.lex_state = 105, .external_lex_state = 2},
  [168] = {.lex_state = 105, .external_lex_state = 2},
  [169] = {.lex_state = 105, .external_lex_state = 2},
  [170] = {.lex_state = 105, .external_lex_state = 2},
  [171] = {.lex_state = 105, .external_lex_state = 2},
  [172] = {.lex_state = 105, .external_lex_state = 2},
  [173] = {.lex_state = 105, .external_lex_state = 2},
  [174] = {.lex_state = 105, .external_lex_state = 2},
  [175] = {.lex_state = 105, .external_lex_state = 2},
  [176] = {.lex_state = 105, .external_lex_state = 2},
  [177] = {.lex_state = 105, .external_lex_state = 2},
  [178] = {.lex_state = 105, .external_lex_state = 2},
  [179] = {.lex_state = 105, .external_lex_state = 2},
  [180] = {.lex_state = 105, .external_lex_state = 2},
  [181] = {.lex_state = 105, .external_lex_state = 2},
  [182] = {.lex_state = 105, .external_lex_state = 2},
  [183] = {.lex_state = 105, .external_lex_state = 2},
  [184] = {.lex_state = 105, .external_lex_state = 2},
  [185] = {.lex_state = 105, .external_lex_state = 2},
  [186] = {.lex_state = 105, .external_lex_state = 2},
  [187] = {.lex_state = 105, .external_lex_state = 2},
  [188] = {.lex_state = 105, .external_lex_state = 2},
  [189] = {.lex_state = 105, .external_lex_state = 2},
  [190] = {.lex_state = 105, .external_lex_state = 2},
  [191] = {.lex_state = 104, .external_lex_state = 2},
  [192] = {.lex_state = 104, .external_lex_state = 2},
  [193] = {.lex_state = 105, .external_lex_state = 2},
  [194] = {.lex_state = 105, .external_lex_state = 2},
  [195] = {.lex_state = 105, .external_lex_state = 2},
  [196] = {.lex_state = 105, .external_lex_state = 2},
  [197] = {.lex_state = 105, .external_lex_state = 2},
  [198] = {.lex_state = 105, .external_lex_state = 2},
  [199] = {.lex_state = 105, .external_lex_state = 2},
  [200] = {.lex_state = 105, .external_lex_state = 2},
  [201] = {.lex_state = 105, .external_lex_state = 2},
  [202] = {.lex_state = 105, .external_lex_state = 2},
  [203] = {.lex_state = 105, .external_lex_state = 2},
  [204] = {.lex_state = 105, .external_lex_state = 2},
  [205] = {.lex_state = 105, .external_lex_state = 2},
  [206] = {.lex_state = 105, .external_lex_state = 2},
  [207] = {.lex_state = 105, .external_lex_state = 2},
  [208] = {.lex_state = 105, .external_lex_state = 2},
  [209] = {.lex_state = 105, .external_lex_state = 2},
  [210] = {.lex_state = 105, .external_lex_state = 2},
  [211] = {.lex_state = 105, .external_lex_state = 2},
  [212] = {.lex_state = 105, .external_lex_state = 2},
  [213] = {.lex_state = 105, .external_lex_state = 2},
  [214] = {.lex_state = 105, .external_lex_state = 2},
  [215] = {.lex_state = 105, .external_lex_state = 2},
  [216] = {.lex_state = 105, .external_lex_state = 2},
  [217] = {.lex_state = 105, .external_lex_state = 2},
  [218] = {.lex_state = 105, .external_lex_state = 2},
  [219] = {.lex_state = 105, .external_lex_state = 2},
  [220] = {.lex_state = 105, .external_lex_state = 2},
  [221] = {.lex_state = 105, .external_lex_state = 2},
  [222] = {.lex_state = 104, .external_lex_state = 2},
  [223] = {.lex_state = 105, .external_lex_state = 2},
  [224] = {.lex_state = 104, .external_lex_state = 2},
  [225] = {.lex_state = 105, .external_lex_state = 2},
  [226] = {.lex_state = 104, .external_lex_state = 2},
  [227] = {.lex_state = 104, .external_lex_state = 2},
  [228] = {.lex_state = 104, .external_lex_state = 2},
  [229] = {.lex_state = 104, .external_lex_state = 2},
  [230] = {.lex_state = 104, .external_lex_state = 2},
  [231] = {.lex_state = 104, .external_lex_state = 2},
  [232] = {.lex_state = 104, .external_lex_state = 2},
  [233] = {.lex_state = 104, .external_lex_state = 2},
  [234] = {.lex_state = 104, .external_lex_state = 3},
  [235] = {.lex_state = 104, .external_lex_state = 3},
  [236] = {.lex_state = 104, .external_lex_state = 3},
  [237] = {.lex_state = 104, .external_lex_state = 3},
  [238] = {.lex_state = 104, .external_lex_state = 2},
  [239] = {.lex_state = 104, .external_lex_state = 2},
  [240] = {.lex_state = 104, .external_lex_state = 2},
  [241] = {.lex_state = 104, .external_lex_state = 2},
  [242] = {.lex_state = 104, .external_lex_state = 2},
  [243] = {.lex_state = 104, .external_lex_state = 2},
  [244] = {.lex_state = 104, .external_lex_state = 2},
  [245] = {.lex_state = 104, .external_lex_state = 2},
  [246] = {.lex_state = 104, .external_lex_state = 2},
  [247] = {.lex_state = 104, .external_lex_state = 2},
  [248] = {.lex_state = 104, .external_lex_state = 2},
  [249] = {.lex_state = 104, .external_lex_state = 2},
  [250] = {.lex_state = 104, .external_lex_state = 2},
  [251] = {.lex_state = 104, .external_lex_state = 2},
  [252] = {.lex_state = 104, .external_lex_state = 2},
  [253] = {.lex_state = 104, .external_lex_state = 2},
  [254] = {.lex_state = 104, .external_lex_state = 2},
  [255] = {.lex_state = 104, .external_lex_state = 2},
  [256] = {.lex_state = 104, .external_lex_state = 2},
  [257] = {.lex_state = 104, .external_lex_state = 2},
  [258] = {.lex_state = 104, .external_lex_state = 2},
  [259] = {.lex_state = 104, .external_lex_state = 2},
  [260] = {.lex_state = 104, .external_lex_state = 2},
  [261] = {.lex_state = 104, .external_lex_state = 2},
  [262] = {.lex_state = 104, .external_lex_state = 2},
  [263] = {.lex_state = 104, .external_lex_state = 3},
  [264] = {.lex_state = 104, .external_lex_state = 2},
  [265] = {.lex_state = 104, .external_lex_state = 2},
  [266] = {.lex_state = 104, .external_lex_state = 2},
  [267] = {.lex_state = 104, .external_lex_state = 2},
  [268] = {.lex_state = 104, .external_lex_state = 2},
  [269] = {.lex_state = 104, .external_lex_state = 2},
  [270] = {.lex_state = 104, .external_lex_state = 3},
  [271] = {.lex_state = 104, .external_lex_state = 2},
  [272] = {.lex_state = 104, .external_lex_state = 3},
  [273] = {.lex_state = 104, .external_lex_state = 3},
  [274] = {.lex_state = 104, .external_lex_state = 2},
  [275] = {.lex_state = 104, .external_lex_state = 2},
  [276] = {.lex_state = 104, .external_lex_state = 2},
  [277] = {.lex_state = 104, .external_lex_state = 2},
  [278] = {.lex_state = 104, .external_lex_state = 2},
  [279] = {.lex_state = 104, .external_lex_state = 2},
  [280] = {.lex_state = 104, .external_lex_state = 2},
  [281] = {.lex_state = 104, .external_lex_state = 2},
  [282] = {.lex_state = 104, .external_lex_state = 2},
  [283] = {.lex_state = 104, .external_lex_state = 2},
  [284] = {.lex_state = 104, .external_lex_state = 2},
  [285] = {.lex_state = 104, .external_lex_state = 2},
  [286] = {.lex_state = 104, .external_lex_state = 2},
  [287] = {.lex_state = 104, .external_lex_state = 2},
  [288] = {.lex_state = 104, .external_lex_state = 2},
  [289] = {.lex_state = 104, .external_lex_state = 2},
  [290] = {.lex_state = 104, .external_lex_state = 2},
  [291] = {.lex_state = 104, .external_lex_state = 2},
  [292] = {.lex_state = 104, .external_lex_state = 2},
  [293] = {.lex_state = 104, .external_lex_state = 2},
  [294] = {.lex_state = 104, .external_lex_state = 2},
  [295] = {.lex_state = 104, .external_lex_state = 2},
  [296] = {.lex_state = 104, .external_lex_state = 2},
  [297] = {.lex_state = 105, .external_lex_state = 2},
  [298] = {.lex_state = 104, .external_lex_state = 2},
  [299] = {.lex_state = 104, .external_lex_state = 2},
  [300] = {.lex_state = 105, .external_lex_state = 2},
  [301] = {.lex_state = 105, .external_lex_state = 2},
  [302] = {.lex_state = 104, .external_lex_state = 2},
  [303] = {.lex_state = 104, .external_lex_state = 2},
  [304] = {.lex_state = 105, .external_lex_state = 2},
  [305] = {.lex_state = 104, .external_lex_state = 2},
  [306] = {.lex_state = 105, .external_lex_state = 2},
  [307] = {.lex_state = 104, .external_lex_state = 2},
  [308] = {.lex_state = 104, .external_lex_state = 2},
  [309] = {.lex_state = 104, .external_lex_state = 2},
  [310] = {.lex_state = 105, .external_lex_state = 2},
  [311] = {.lex_state = 104, .external_lex_state = 2},
  [312] = {.lex_state = 104, .external_lex_state = 2},
  [313] = {.lex_state = 104, .external_lex_state = 2},
  [314] = {.lex_state = 105, .external_lex_state = 2},
  [315] = {.lex_state = 104, .external_lex_state = 2},
  [316] = {.lex_state = 105, .external_lex_state = 2},
  [317] = {.lex_state = 104, .external_lex_state = 2},
  [318] = {.lex_state = 105, .external_lex_state = 2},
  [319] = {.lex_state = 104, .external_lex_state = 2},
  [320] = {.lex_state = 105, .external_lex_state = 2},
  [321] = {.lex_state = 104, .external_lex_state = 2},
  [322] = {.lex_state = 105, .external_lex_state = 2},
  [323] = {.lex_state = 104, .external_lex_state = 2},
  [324] = {.lex_state = 105, .external_lex_state = 2},
  [325] = {.lex_state = 104, .external_lex_state = 2},
  [326] = {.lex_state = 104, .external_lex_state = 2},
  [327] = {.lex_state = 105, .external_lex_state = 2},
  [328] = {.lex_state = 105, .external_lex_state = 2},
  [329] = {.lex_state = 104, .external_lex_state = 2},
  [330] = {.lex_state = 104, .external_lex_state = 2},
  [331] = {.lex_state = 104, .external_lex_state = 2},
  [332] = {.lex_state = 104, .external_lex_state = 2},
  [333] = {.lex_state = 105, .external_lex_state = 2},
  [334] = {.lex_state = 105, .external_lex_state = 2},
  [335] = {.lex_state = 104, .external_lex_state = 2},
  [336] = {.lex_state = 104, .external_lex_state = 2},
  [337] = {.lex_state = 105, .external_lex_state = 2},
  [338] = {.lex_state = 104, .external_lex_state = 2},
  [339] = {.lex_state = 104, .external_lex_state = 2},
  [340] = {.lex_state = 105, .external_lex_state = 2},
  [341] = {.lex_state = 104, .external_lex_state = 2},
  [342] = {.lex_state = 104, .external_lex_state = 2},
  [343] = {.lex_state = 105, .external_lex_state = 2},
  [344] = {.lex_state = 105, .external_lex_state = 2},
  [345] = {.lex_state = 105, .external_lex_state = 2},
  [346] = {.lex_state = 105, .external_lex_state = 2},
  [347] = {.lex_state = 105, .external_lex_state = 2},
  [348] = {.lex_state = 105, .external_lex_state = 2},
  [349] = {.lex_state = 105, .external_lex_state = 2},
  [350] = {.lex_state = 104, .external_lex_state = 2},
  [351] = {.lex_state = 104, .external_lex_state = 2},
  [352] = {.lex_state = 105, .external_lex_state = 2},
  [353] = {.lex_state = 105, .external_lex_state = 2},
  [354] = {.lex_state = 104, .external_lex_state = 2},
  [355] = {.lex_state = 104, .external_lex_state = 2},
  [356] = {.lex_state = 105, .external_lex_state = 2},
  [357] = {.lex_state = 105, .external_lex_state = 2},
  [358] = {.lex_state = 105, .external_lex_state = 2},
  [359] = {.lex_state = 105, .external_lex_state = 2},
  [360] = {.lex_state = 105, .external_lex_state = 2},
  [361] = {.lex_state = 105, .external_lex_state = 2},
  [362] = {.lex_state = 105, .external_lex_state = 2},
  [363] = {.lex_state = 105, .external_lex_state = 2},
  [364] = {.lex_state = 105, .external_lex_state = 2},
  [365] = {.lex_state = 105, .external_lex_state = 2},
  [366] = {.lex_state = 105, .external_lex_state = 2},
  [367] = {.lex_state = 105, .external_lex_state = 2},
  [368] = {.lex_state = 105, .external_lex_state = 2},
  [369] = {.lex_state = 105, .external_lex_state = 2},
  [370] = {.lex_state = 105, .external_lex_state = 2},
  [371] = {.lex_state = 105, .external_lex_state = 2},
  [372] = {.lex_state = 105, .external_lex_state = 2},
  [373] = {.lex_state = 105, .external_lex_state = 2},
  [374] = {.lex_state = 105, .external_lex_state = 2},
  [375] = {.lex_state = 105, .external_lex_state = 2},
  [376] = {.lex_state = 105, .external_lex_state = 2},
  [377] = {.lex_state = 105, .external_lex_state = 2},
  [378] = {.lex_state = 105, .external_lex_state = 2},
  [379] = {.lex_state = 105, .external_lex_state = 2},
  [380] = {.lex_state = 105, .external_lex_state = 2},
  [381] = {.lex_state = 105, .external_lex_state = 2},
  [382] = {.lex_state = 105, .external_lex_state = 2},
  [383] = {.lex_state = 105, .external_lex_state = 2},
  [384] = {.lex_state = 105, .external_lex_state = 2},
  [385] = {.lex_state = 105, .external_lex_state = 2},
  [386] = {.lex_state = 105, .external_lex_state = 2},
  [387] = {.lex_state = 105, .external_lex_state = 2},
  [388] = {.lex_state = 105, .external_lex_state = 2},
  [389] = {.lex_state = 105, .external_lex_state = 2},
  [390] = {.lex_state = 105, .external_lex_state = 2},
  [391] = {.lex_state = 105, .external_lex_state = 2},
  [392] = {.lex_state = 105, .external_lex_state = 2},
  [393] = {.lex_state = 105, .external_lex_state = 2},
  [394] = {.lex_state = 105, .external_lex_state = 2},
  [395] = {.lex_state = 105, .external_lex_state = 2},
  [396] = {.lex_state = 105, .external_lex_state = 2},
  [397] = {.lex_state = 105, .external_lex_state = 2},
  [398] = {.lex_state = 105, .external_lex_state = 2},
  [399] = {.lex_state = 105, .external_lex_state = 2},
  [400] = {.lex_state = 105, .external_lex_state = 2},
  [401] = {.lex_state = 105, .external_lex_state = 2},
  [402] = {.lex_state = 105, .external_lex_state = 2},
  [403] = {.lex_state = 105, .external_lex_state = 2},
  [404] = {.lex_state = 105, .external_lex_state = 2},
  [405] = {.lex_state = 105, .external_lex_state = 2},
  [406] = {.lex_state = 105, .external_lex_state = 2},
  [407] = {.lex_state = 105, .external_lex_state = 2},
  [408] = {.lex_state = 105, .external_lex_state = 2},
  [409] = {.lex_state = 105, .external_lex_state = 2},
  [410] = {.lex_state = 105, .external_lex_state = 2},
  [411] = {.lex_state = 105, .external_lex_state = 2},
  [412] = {.lex_state = 105, .external_lex_state = 2},
  [413] = {.lex_state = 105, .external_lex_state = 2},
  [414] = {.lex_state = 105, .external_lex_state = 2},
  [415] = {.lex_state = 105, .external_lex_state = 2},
  [416] = {.lex_state = 105, .external_lex_state = 2},
  [417] = {.lex_state = 105, .external_lex_state = 2},
  [418] = {.lex_state = 105, .external_lex_state = 2},
  [419] = {.lex_state = 105, .external_lex_state = 2},
  [420] = {.lex_state = 105, .external_lex_state = 2},
  [421] = {.lex_state = 105, .external_lex_state = 2},
  [422] = {.lex_state = 105, .external_lex_state = 2},
  [423] = {.lex_state = 105, .external_lex_state = 2},
  [424] = {.lex_state = 105, .external_lex_state = 2},
  [425] = {.lex_state = 105, .external_lex_state = 2},
  [426] = {.lex_state = 105, .external_lex_state = 2},
  [427] = {.lex_state = 105, .external_lex_state = 2},
  [428] = {.lex_state = 105, .external_lex_state = 2},
  [429] = {.lex_state = 105, .external_lex_state = 2},
  [430] = {.lex_state = 105, .external_lex_state = 2},
  [431] = {.lex_state = 105, .external_lex_state = 2},
  [432] = {.lex_state = 105, .external_lex_state = 2},
  [433] = {.lex_state = 105, .external_lex_state = 2},
  [434] = {.lex_state = 105, .external_lex_state = 2},
  [435] = {.lex_state = 105, .external_lex_state = 2},
  [436] = {.lex_state = 105, .external_lex_state = 2},
  [437] = {.lex_state = 105, .external_lex_state = 2},
  [438] = {.lex_state = 105, .external_lex_state = 2},
  [439] = {.lex_state = 105, .external_lex_state = 2},
  [440] = {.lex_state = 105, .external_lex_state = 2},
  [441] = {.lex_state = 105, .external_lex_state = 2},
  [442] = {.lex_state = 105, .external_lex_state = 2},
  [443] = {.lex_state = 105, .external_lex_state = 2},
  [444] = {.lex_state = 105, .external_lex_state = 2},
  [445] = {.lex_state = 105, .external_lex_state = 2},
  [446] = {.lex_state = 105, .external_lex_state = 2},
  [447] = {.lex_state = 105, .external_lex_state = 2},
  [448] = {.lex_state = 105, .external_lex_state = 2},
  [449] = {.lex_state = 105, .external_lex_state = 2},
  [450] = {.lex_state = 105, .external_lex_state = 2},
  [451] = {.lex_state = 105, .external_lex_state = 2},
  [452] = {.lex_state = 105, .external_lex_state = 2},
  [453] = {.lex_state = 105, .external_lex_state = 2},
  [454] = {.lex_state = 105, .external_lex_state = 2},
  [455] = {.lex_state = 105, .external_lex_state = 2},
  [456] = {.lex_state = 105, .external_lex_state = 2},
  [457] = {.lex_state = 105, .external_lex_state = 2},
  [458] = {.lex_state = 105, .external_lex_state = 2},
  [459] = {.lex_state = 105, .external_lex_state = 2},
  [460] = {.lex_state = 105, .external_lex_state = 2},
  [461] = {.lex_state = 105, .external_lex_state = 2},
  [462] = {.lex_state = 105, .external_lex_state = 2},
  [463] = {.lex_state = 105, .external_lex_state = 2},
  [464] = {.lex_state = 105, .external_lex_state = 2},
  [465] = {.lex_state = 105, .external_lex_state = 2},
  [466] = {.lex_state = 105, .external_lex_state = 2},
  [467] = {.lex_state = 105, .external_lex_state = 2},
  [468] = {.lex_state = 105, .external_lex_state = 2},
  [469] = {.lex_state = 105, .external_lex_state = 2},
  [470] = {.lex_state = 105, .external_lex_state = 2},
  [471] = {.lex_state = 105, .external_lex_state = 2},
  [472] = {.lex_state = 105, .external_lex_state = 2},
  [473] = {.lex_state = 105, .external_lex_state = 2},
  [474] = {.lex_state = 105, .external_lex_state = 2},
  [475] = {.lex_state = 105, .external_lex_state = 2},
  [476] = {.lex_state = 105, .external_lex_state = 2},
  [477] = {.lex_state = 105, .external_lex_state = 2},
  [478] = {.lex_state = 105, .external_lex_state = 2},
  [479] = {.lex_state = 105, .external_lex_state = 2},
  [480] = {.lex_state = 105, .external_lex_state = 2},
  [481] = {.lex_state = 105, .external_lex_state = 2},
  [482] = {.lex_state = 105, .external_lex_state = 2},
  [483] = {.lex_state = 105, .external_lex_state = 2},
  [484] = {.lex_state = 105, .external_lex_state = 2},
  [485] = {.lex_state = 105, .external_lex_state = 2},
  [486] = {.lex_state = 105, .external_lex_state = 2},
  [487] = {.lex_state = 105, .external_lex_state = 2},
  [488] = {.lex_state = 105, .external_lex_state = 2},
  [489] = {.lex_state = 105, .external_lex_state = 2},
  [490] = {.lex_state = 105, .external_lex_state = 2},
  [491] = {.lex_state = 105, .external_lex_state = 2},
  [492] = {.lex_state = 105, .external_lex_state = 2},
  [493] = {.lex_state = 105, .external_lex_state = 2},
  [494] = {.lex_state = 105, .external_lex_state = 2},
  [495] = {.lex_state = 105, .external_lex_state = 2},
  [496] = {.lex_state = 105, .external_lex_state = 2},
  [497] = {.lex_state = 105, .external_lex_state = 2},
  [498] = {.lex_state = 105, .external_lex_state = 2},
  [499] = {.lex_state = 105, .external_lex_state = 2},
  [500] = {.lex_state = 105, .external_lex_state = 2},
  [501] = {.lex_state = 105, .external_lex_state = 2},
  [502] = {.lex_state = 105, .external_lex_state = 2},
  [503] = {.lex_state = 105, .external_lex_state = 2},
  [504] = {.lex_state = 105, .external_lex_state = 2},
  [505] = {.lex_state = 105, .external_lex_state = 2},
  [506] = {.lex_state = 105, .external_lex_state = 2},
  [507] = {.lex_state = 105, .external_lex_state = 2},
  [508] = {.lex_state = 105, .external_lex_state = 2},
  [509] = {.lex_state = 105, .external_lex_state = 2},
  [510] = {.lex_state = 105, .external_lex_state = 2},
  [511] = {.lex_state = 105, .external_lex_state = 2},
  [512] = {.lex_state = 105, .external_lex_state = 2},
  [513] = {.lex_state = 105, .external_lex_state = 2},
  [514] = {.lex_state = 105, .external_lex_state = 2},
  [515] = {.lex_state = 105, .external_lex_state = 2},
  [516] = {.lex_state = 105, .external_lex_state = 2},
  [517] = {.lex_state = 105, .external_lex_state = 2},
  [518] = {.lex_state = 105, .external_lex_state = 2},
  [519] = {.lex_state = 105, .external_lex_state = 2},
  [520] = {.lex_state = 105, .external_lex_state = 2},
  [521] = {.lex_state = 105, .external_lex_state = 2},
  [522] = {.lex_state = 105, .external_lex_state = 2},
  [523] = {.lex_state = 105, .external_lex_state = 2},
  [524] = {.lex_state = 105, .external_lex_state = 2},
  [525] = {.lex_state = 105, .external_lex_state = 2},
  [526] = {.lex_state = 105, .external_lex_state = 2},
  [527] = {.lex_state = 105, .external_lex_state = 2},
  [528] = {.lex_state = 105, .external_lex_state = 2},
  [529] = {.lex_state = 105, .external_lex_state = 2},
  [530] = {.lex_state = 105, .external_lex_state = 2},
  [531] = {.lex_state = 105, .external_lex_state = 2},
  [532] = {.lex_state = 105, .external_lex_state = 2},
  [533] = {.lex_state = 105, .external_lex_state = 2},
  [534] = {.lex_state = 105, .external_lex_state = 2},
  [535] = {.lex_state = 105, .external_lex_state = 2},
  [536] = {.lex_state = 105, .external_lex_state = 2},
  [537] = {.lex_state = 105, .external_lex_state = 2},
  [538] = {.lex_state = 105, .external_lex_state = 2},
  [539] = {.lex_state = 105, .external_lex_state = 2},
  [540] = {.lex_state = 105, .external_lex_state = 2},
  [541] = {.lex_state = 105, .external_lex_state = 2},
  [542] = {.lex_state = 105, .external_lex_state = 2},
  [543] = {.lex_state = 105, .external_lex_state = 2},
  [544] = {.lex_state = 105, .external_lex_state = 2},
  [545] = {.lex_state = 105, .external_lex_state = 2},
  [546] = {.lex_state = 105, .external_lex_state = 2},
  [547] = {.lex_state = 105, .external_lex_state = 2},
  [548] = {.lex_state = 105, .external_lex_state = 2},
  [549] = {.lex_state = 105, .external_lex_state = 2},
  [550] = {.lex_state = 105, .external_lex_state = 2},
  [551] = {.lex_state = 105, .external_lex_state = 2},
  [552] = {.lex_state = 105, .external_lex_state = 2},
  [553] = {.lex_state = 105, .external_lex_state = 2},
  [554] = {.lex_state = 105, .external_lex_state = 2},
  [555] = {.lex_state = 105, .external_lex_state = 2},
  [556] = {.lex_state = 105, .external_lex_state = 2},
  [557] = {.lex_state = 105, .external_lex_state = 2},
  [558] = {.lex_state = 105, .external_lex_state = 2},
  [559] = {.lex_state = 105, .external_lex_state = 2},
  [560] = {.lex_state = 105, .external_lex_state = 2},
  [561] = {.lex_state = 105, .external_lex_state = 2},
  [562] = {.lex_state = 105, .external_lex_state = 2},
  [563] = {.lex_state = 105, .external_lex_state = 2},
  [564] = {.lex_state = 105, .external_lex_state = 2},
  [565] = {.lex_state = 105, .external_lex_state = 2},
  [566] = {.lex_state = 105, .external_lex_state = 2},
  [567] = {.lex_state = 105, .external_lex_state = 2},
  [568] = {.lex_state = 105, .external_lex_state = 2},
  [569] = {.lex_state = 105, .external_lex_state = 2},
  [570] = {.lex_state = 105, .external_lex_state = 2},
  [571] = {.lex_state = 105, .external_lex_state = 2},
  [572] = {.lex_state = 105, .external_lex_state = 2},
  [573] = {.lex_state = 105, .external_lex_state = 2},
  [574] = {.lex_state = 105, .external_lex_state = 2},
  [575] = {.lex_state = 105, .external_lex_state = 2},
  [576] = {.lex_state = 105, .external_lex_state = 2},
  [577] = {.lex_state = 105, .external_lex_state = 2},
  [578] = {.lex_state = 105, .external_lex_state = 2},
  [579] = {.lex_state = 105, .external_lex_state = 2},
  [580] = {.lex_state = 105, .external_lex_state = 2},
  [581] = {.lex_state = 105, .external_lex_state = 2},
  [582] = {.lex_state = 105, .external_lex_state = 2},
  [583] = {.lex_state = 105, .external_lex_state = 2},
  [584] = {.lex_state = 105, .external_lex_state = 2},
  [585] = {.lex_state = 105, .external_lex_state = 2},
  [586] = {.lex_state = 105, .external_lex_state = 2},
  [587] = {.lex_state = 105, .external_lex_state = 2},
  [588] = {.lex_state = 105, .external_lex_state = 2},
  [589] = {.lex_state = 105, .external_lex_state = 2},
  [590] = {.lex_state = 105, .external_lex_state = 2},
  [591] = {.lex_state = 105, .external_lex_state = 2},
  [592] = {.lex_state = 105, .external_lex_state = 2},
  [593] = {.lex_state = 105, .external_lex_state = 2},
  [594] = {.lex_state = 105, .external_lex_state = 2},
  [595] = {.lex_state = 105, .external_lex_state = 2},
  [596] = {.lex_state = 105, .external_lex_state = 2},
  [597] = {.lex_state = 105, .external_lex_state = 2},
  [598] = {.lex_state = 105, .external_lex_state = 2},
  [599] = {.lex_state = 105, .external_lex_state = 2},
  [600] = {.lex_state = 105, .external_lex_state = 2},
  [601] = {.lex_state = 105, .external_lex_state = 2},
  [602] = {.lex_state = 105, .external_lex_state = 2},
  [603] = {.lex_state = 105, .external_lex_state = 2},
  [604] = {.lex_state = 105, .external_lex_state = 2},
  [605] = {.lex_state = 105, .external_lex_state = 2},
  [606] = {.lex_state = 105, .external_lex_state = 2},
  [607] = {.lex_state = 105, .external_lex_state = 2},
  [608] = {.lex_state = 105, .external_lex_state = 2},
  [609] = {.lex_state = 105, .external_lex_state = 2},
  [610] = {.lex_state = 105, .external_lex_state = 2},
  [611] = {.lex_state = 105, .external_lex_state = 2},
  [612] = {.lex_state = 105, .external_lex_state = 2},
  [613] = {.lex_state = 105, .external_lex_state = 2},
  [614] = {.lex_state = 105, .external_lex_state = 2},
  [615] = {.lex_state = 105, .external_lex_state = 2},
  [616] = {.lex_state = 105, .external_lex_state = 2},
  [617] = {.lex_state = 105, .external_lex_state = 2},
  [618] = {.lex_state = 105, .external_lex_state = 2},
  [619] = {.lex_state = 105, .external_lex_state = 2},
  [620] = {.lex_state = 105, .external_lex_state = 2},
  [621] = {.lex_state = 105, .external_lex_state = 2},
  [622] = {.lex_state = 105, .external_lex_state = 2},
  [623] = {.lex_state = 105, .external_lex_state = 2},
  [624] = {.lex_state = 105, .external_lex_state = 2},
  [625] = {.lex_state = 105, .external_lex_state = 2},
  [626] = {.lex_state = 105, .external_lex_state = 2},
  [627] = {.lex_state = 105, .external_lex_state = 2},
  [628] = {.lex_state = 105, .external_lex_state = 2},
  [629] = {.lex_state = 105, .external_lex_state = 2},
  [630] = {.lex_state = 105, .external_lex_state = 2},
  [631] = {.lex_state = 105, .external_lex_state = 2},
  [632] = {.lex_state = 105, .external_lex_state = 2},
  [633] = {.lex_state = 105, .external_lex_state = 2},
  [634] = {.lex_state = 105, .external_lex_state = 2},
  [635] = {.lex_state = 105, .external_lex_state = 2},
  [636] = {.lex_state = 105, .external_lex_state = 2},
  [637] = {.lex_state = 105, .external_lex_state = 2},
  [638] = {.lex_state = 105, .external_lex_state = 2},
  [639] = {.lex_state = 105, .external_lex_state = 2},
  [640] = {.lex_state = 105, .external_lex_state = 2},
  [641] = {.lex_state = 105, .external_lex_state = 2},
  [642] = {.lex_state = 105, .external_lex_state = 2},
  [643] = {.lex_state = 105, .external_lex_state = 2},
  [644] = {.lex_state = 105, .external_lex_state = 2},
  [645] = {.lex_state = 105, .external_lex_state = 2},
  [646] = {.lex_state = 105, .external_lex_state = 2},
  [647] = {.lex_state = 105, .external_lex_state = 2},
  [648] = {.lex_state = 105, .external_lex_state = 2},
  [649] = {.lex_state = 105, .external_lex_state = 2},
  [650] = {.lex_state = 105, .external_lex_state = 2},
  [651] = {.lex_state = 105, .external_lex_state = 2},
  [652] = {.lex_state = 105, .external_lex_state = 2},
  [653] = {.lex_state = 105, .external_lex_state = 2},
  [654] = {.lex_state = 105, .external_lex_state = 2},
  [655] = {.lex_state = 105, .external_lex_state = 2},
  [656] = {.lex_state = 105, .external_lex_state = 2},
  [657] = {.lex_state = 105, .external_lex_state = 2},
  [658] = {.lex_state = 105, .external_lex_state = 2},
  [659] = {.lex_state = 105, .external_lex_state = 2},
  [660] = {.lex_state = 105, .external_lex_state = 2},
  [661] = {.lex_state = 105, .external_lex_state = 2},
  [662] = {.lex_state = 105, .external_lex_state = 2},
  [663] = {.lex_state = 105, .external_lex_state = 2},
  [664] = {.lex_state = 105, .external_lex_state = 2},
  [665] = {.lex_state = 105, .external_lex_state = 2},
  [666] = {.lex_state = 105, .external_lex_state = 2},
  [667] = {.lex_state = 105, .external_lex_state = 2},
  [668] = {.lex_state = 105, .external_lex_state = 2},
  [669] = {.lex_state = 105, .external_lex_state = 2},
  [670] = {.lex_state = 105, .external_lex_state = 2},
  [671] = {.lex_state = 105, .external_lex_state = 2},
  [672] = {.lex_state = 105, .external_lex_state = 2},
  [673] = {.lex_state = 105, .external_lex_state = 2},
  [674] = {.lex_state = 105, .external_lex_state = 2},
  [675] = {.lex_state = 105, .external_lex_state = 2},
  [676] = {.lex_state = 105, .external_lex_state = 2},
  [677] = {.lex_state = 105, .external_lex_state = 2},
  [678] = {.lex_state = 105, .external_lex_state = 2},
  [679] = {.lex_state = 105, .external_lex_state = 2},
  [680] = {.lex_state = 105, .external_lex_state = 2},
  [681] = {.lex_state = 105, .external_lex_state = 2},
  [682] = {.lex_state = 105, .external_lex_state = 2},
  [683] = {.lex_state = 105, .external_lex_state = 2},
  [684] = {.lex_state = 105, .external_lex_state = 2},
  [685] = {.lex_state = 105, .external_lex_state = 2},
  [686] = {.lex_state = 105, .external_lex_state = 2},
  [687] = {.lex_state = 105, .external_lex_state = 2},
  [688] = {.lex_state = 105, .external_lex_state = 2},
  [689] = {.lex_state = 105, .external_lex_state = 2},
  [690] = {.lex_state = 105, .external_lex_state = 2},
  [691] = {.lex_state = 105, .external_lex_state = 2},
  [692] = {.lex_state = 105, .external_lex_state = 2},
  [693] = {.lex_state = 105, .external_lex_state = 2},
  [694] = {.lex_state = 105, .external_lex_state = 2},
  [695] = {.lex_state = 105, .external_lex_state = 2},
  [696] = {.lex_state = 105, .external_lex_state = 2},
  [697] = {.lex_state = 105, .external_lex_state = 2},
  [698] = {.lex_state = 105, .external_lex_state = 2},
  [699] = {.lex_state = 105, .external_lex_state = 2},
  [700] = {.lex_state = 105, .external_lex_state = 2},
  [701] = {.lex_state = 105, .external_lex_state = 2},
  [702] = {.lex_state = 105, .external_lex_state = 2},
  [703] = {.lex_state = 105, .external_lex_state = 2},
  [704] = {.lex_state = 105, .external_lex_state = 2},
  [705] = {.lex_state = 105, .external_lex_state = 2},
  [706] = {.lex_state = 105, .external_lex_state = 2},
  [707] = {.lex_state = 105, .external_lex_state = 2},
  [708] = {.lex_state = 105, .external_lex_state = 2},
  [709] = {.lex_state = 105, .external_lex_state = 2},
  [710] = {.lex_state = 105, .external_lex_state = 2},
  [711] = {.lex_state = 105, .external_lex_state = 2},
  [712] = {.lex_state = 105, .external_lex_state = 2},
  [713] = {.lex_state = 105, .external_lex_state = 2},
  [714] = {.lex_state = 105, .external_lex_state = 2},
  [715] = {.lex_state = 105, .external_lex_state = 2},
  [716] = {.lex_state = 105, .external_lex_state = 2},
  [717] = {.lex_state = 105, .external_lex_state = 2},
  [718] = {.lex_state = 105, .external_lex_state = 2},
  [719] = {.lex_state = 105, .external_lex_state = 2},
  [720] = {.lex_state = 105, .external_lex_state = 2},
  [721] = {.lex_state = 105, .external_lex_state = 2},
  [722] = {.lex_state = 105, .external_lex_state = 2},
  [723] = {.lex_state = 105, .external_lex_state = 2},
  [724] = {.lex_state = 105, .external_lex_state = 2},
  [725] = {.lex_state = 105, .external_lex_state = 2},
  [726] = {.lex_state = 105, .external_lex_state = 2},
  [727] = {.lex_state = 105, .external_lex_state = 2},
  [728] = {.lex_state = 105, .external_lex_state = 2},
  [729] = {.lex_state = 105, .external_lex_state = 2},
  [730] = {.lex_state = 105, .external_lex_state = 2},
  [731] = {.lex_state = 105, .external_lex_state = 2},
  [732] = {.lex_state = 105, .external_lex_state = 2},
  [733] = {.lex_state = 105, .external_lex_state = 2},
  [734] = {.lex_state = 105, .external_lex_state = 2},
  [735] = {.lex_state = 105, .external_lex_state = 2},
  [736] = {.lex_state = 105, .external_lex_state = 2},
  [737] = {.lex_state = 105, .external_lex_state = 2},
  [738] = {.lex_state = 105, .external_lex_state = 2},
  [739] = {.lex_state = 105, .external_lex_state = 2},
  [740] = {.lex_state = 105, .external_lex_state = 2},
  [741] = {.lex_state = 105, .external_lex_state = 2},
  [742] = {.lex_state = 105, .external_lex_state = 2},
  [743] = {.lex_state = 105, .external_lex_state = 2},
  [744] = {.lex_state = 105, .external_lex_state = 2},
  [745] = {.lex_state = 105, .external_lex_state = 2},
  [746] = {.lex_state = 105, .external_lex_state = 2},
  [747] = {.lex_state = 105, .external_lex_state = 2},
  [748] = {.lex_state = 105, .external_lex_state = 2},
  [749] = {.lex_state = 105, .external_lex_state = 2},
  [750] = {.lex_state = 105, .external_lex_state = 2},
  [751] = {.lex_state = 105, .external_lex_state = 2},
  [752] = {.lex_state = 105, .external_lex_state = 2},
  [753] = {.lex_state = 105, .external_lex_state = 2},
  [754] = {.lex_state = 105, .external_lex_state = 2},
  [755] = {.lex_state = 105, .external_lex_state = 2},
  [756] = {.lex_state = 105, .external_lex_state = 2},
  [757] = {.lex_state = 105, .external_lex_state = 2},
  [758] = {.lex_state = 105, .external_lex_state = 2},
  [759] = {.lex_state = 105, .external_lex_state = 2},
  [760] = {.lex_state = 105, .external_lex_state = 2},
  [761] = {.lex_state = 105, .external_lex_state = 2},
  [762] = {.lex_state = 105, .external_lex_state = 2},
  [763] = {.lex_state = 105, .external_lex_state = 2},
  [764] = {.lex_state = 105, .external_lex_state = 2},
  [765] = {.lex_state = 105, .external_lex_state = 2},
  [766] = {.lex_state = 105, .external_lex_state = 2},
  [767] = {.lex_state = 105, .external_lex_state = 2},
  [768] = {.lex_state = 105, .external_lex_state = 2},
  [769] = {.lex_state = 105, .external_lex_state = 2},
  [770] = {.lex_state = 105, .external_lex_state = 2},
  [771] = {.lex_state = 105, .external_lex_state = 2},
  [772] = {.lex_state = 105, .external_lex_state = 2},
  [773] = {.lex_state = 105, .external_lex_state = 2},
  [774] = {.lex_state = 105, .external_lex_state = 2},
  [775] = {.lex_state = 105, .external_lex_state = 2},
  [776] = {.lex_state = 105, .external_lex_state = 2},
  [777] = {.lex_state = 105, .external_lex_state = 2},
  [778] = {.lex_state = 105, .external_lex_state = 2},
  [779] = {.lex_state = 105, .external_lex_state = 2},
  [780] = {.lex_state = 105, .external_lex_state = 2},
  [781] = {.lex_state = 105, .external_lex_state = 2},
  [782] = {.lex_state = 105, .external_lex_state = 2},
  [783] = {.lex_state = 105, .external_lex_state = 2},
  [784] = {.lex_state = 105, .external_lex_state = 2},
  [785] = {.lex_state = 105, .external_lex_state = 2},
  [786] = {.lex_state = 105, .external_lex_state = 2},
  [787] = {.lex_state = 105, .external_lex_state = 2},
  [788] = {.lex_state = 105, .external_lex_state = 2},
  [789] = {.lex_state = 105, .external_lex_state = 2},
  [790] = {.lex_state = 105, .external_lex_state = 2},
  [791] = {.lex_state = 105, .external_lex_state = 2},
  [792] = {.lex_state = 105, .external_lex_state = 2},
  [793] = {.lex_state = 105, .external_lex_state = 2},
  [794] = {.lex_state = 105, .external_lex_state = 2},
  [795] = {.lex_state = 105, .external_lex_state = 2},
  [796] = {.lex_state = 105, .external_lex_state = 2},
  [797] = {.lex_state = 105, .external_lex_state = 2},
  [798] = {.lex_state = 105, .external_lex_state = 2},
  [799] = {.lex_state = 105, .external_lex_state = 2},
  [800] = {.lex_state = 105, .external_lex_state = 2},
  [801] = {.lex_state = 105, .external_lex_state = 2},
  [802] = {.lex_state = 105, .external_lex_state = 2},
  [803] = {.lex_state = 105, .external_lex_state = 2},
  [804] = {.lex_state = 105, .external_lex_state = 2},
  [805] = {.lex_state = 105, .external_lex_state = 2},
  [806] = {.lex_state = 105, .external_lex_state = 2},
  [807] = {.lex_state = 105, .external_lex_state = 2},
  [808] = {.lex_state = 105, .external_lex_state = 2},
  [809] = {.lex_state = 105, .external_lex_state = 2},
  [810] = {.lex_state = 105, .external_lex_state = 2},
  [811] = {.lex_state = 105, .external_lex_state = 2},
  [812] = {.lex_state = 105, .external_lex_state = 2},
  [813] = {.lex_state = 105, .external_lex_state = 2},
  [814] = {.lex_state = 105, .external_lex_state = 2},
  [815] = {.lex_state = 105, .external_lex_state = 2},
  [816] = {.lex_state = 105, .external_lex_state = 2},
  [817] = {.lex_state = 105, .external_lex_state = 2},
  [818] = {.lex_state = 105, .external_lex_state = 2},
  [819] = {.lex_state = 105, .external_lex_state = 2},
  [820] = {.lex_state = 105, .external_lex_state = 2},
  [821] = {.lex_state = 105, .external_lex_state = 2},
  [822] = {.lex_state = 105, .external_lex_state = 2},
  [823] = {.lex_state = 105, .external_lex_state = 2},
  [824] = {.lex_state = 105, .external_lex_state = 2},
  [825] = {.lex_state = 105, .external_lex_state = 2},
  [826] = {.lex_state = 105, .external_lex_state = 2},
  [827] = {.lex_state = 105, .external_lex_state = 2},
  [828] = {.lex_state = 105, .external_lex_state = 2},
  [829] = {.lex_state = 105, .external_lex_state = 2},
  [830] = {.lex_state = 105, .external_lex_state = 2},
  [831] = {.lex_state = 105, .external_lex_state = 2},
  [832] = {.lex_state = 105, .external_lex_state = 2},
  [833] = {.lex_state = 105, .external_lex_state = 2},
  [834] = {.lex_state = 105, .external_lex_state = 2},
  [835] = {.lex_state = 105, .external_lex_state = 2},
  [836] = {.lex_state = 105, .external_lex_state = 2},
  [837] = {.lex_state = 105, .external_lex_state = 2},
  [838] = {.lex_state = 105, .external_lex_state = 2},
  [839] = {.lex_state = 105, .external_lex_state = 2},
  [840] = {.lex_state = 105, .external_lex_state = 2},
  [841] = {.lex_state = 105, .external_lex_state = 2},
  [842] = {.lex_state = 105, .external_lex_state = 2},
  [843] = {.lex_state = 105, .external_lex_state = 2},
  [844] = {.lex_state = 105, .external_lex_state = 2},
  [845] = {.lex_state = 105, .external_lex_state = 2},
  [846] = {.lex_state = 105, .external_lex_state = 2},
  [847] = {.lex_state = 105, .external_lex_state = 2},
  [848] = {.lex_state = 105, .external_lex_state = 2},
  [849] = {.lex_state = 105, .external_lex_state = 2},
  [850] = {.lex_state = 105, .external_lex_state = 2},
  [851] = {.lex_state = 105, .external_lex_state = 2},
  [852] = {.lex_state = 105, .external_lex_state = 2},
  [853] = {.lex_state = 105, .external_lex_state = 2},
  [854] = {.lex_state = 105, .external_lex_state = 2},
  [855] = {.lex_state = 105, .external_lex_state = 2},
  [856] = {.lex_state = 105, .external_lex_state = 2},
  [857] = {.lex_state = 105, .external_lex_state = 2},
  [858] = {.lex_state = 105, .external_lex_state = 2},
  [859] = {.lex_state = 105, .external_lex_state = 2},
  [860] = {.lex_state = 105, .external_lex_state = 2},
  [861] = {.lex_state = 105, .external_lex_state = 2},
  [862] = {.lex_state = 105, .external_lex_state = 2},
  [863] = {.lex_state = 105, .external_lex_state = 2},
  [864] = {.lex_state = 105, .external_lex_state = 2},
  [865] = {.lex_state = 105, .external_lex_state = 2},
  [866] = {.lex_state = 105, .external_lex_state = 2},
  [867] = {.lex_state = 105, .external_lex_state = 2},
  [868] = {.lex_state = 105, .external_lex_state = 2},
  [869] = {.lex_state = 105, .external_lex_state = 2},
  [870] = {.lex_state = 105, .external_lex_state = 2},
  [871] = {.lex_state = 105, .external_lex_state = 2},
  [872] = {.lex_state = 105, .external_lex_state = 2},
  [873] = {.lex_state = 105, .external_lex_state = 2},
  [874] = {.lex_state = 105, .external_lex_state = 2},
  [875] = {.lex_state = 105, .external_lex_state = 2},
  [876] = {.lex_state = 105, .external_lex_state = 2},
  [877] = {.lex_state = 105, .external_lex_state = 2},
  [878] = {.lex_state = 105, .external_lex_state = 2},
  [879] = {.lex_state = 105, .external_lex_state = 2},
  [880] = {.lex_state = 105, .external_lex_state = 2},
  [881] = {.lex_state = 105, .external_lex_state = 2},
  [882] = {.lex_state = 105, .external_lex_state = 2},
  [883] = {.lex_state = 105, .external_lex_state = 2},
  [884] = {.lex_state = 105, .external_lex_state = 2},
  [885] = {.lex_state = 105, .external_lex_state = 2},
  [886] = {.lex_state = 105, .external_lex_state = 2},
  [887] = {.lex_state = 105, .external_lex_state = 2},
  [888] = {.lex_state = 105, .external_lex_state = 2},
  [889] = {.lex_state = 105, .external_lex_state = 2},
  [890] = {.lex_state = 105, .external_lex_state = 2},
  [891] = {.lex_state = 105, .external_lex_state = 2},
  [892] = {.lex_state = 105, .external_lex_state = 2},
  [893] = {.lex_state = 105, .external_lex_state = 2},
  [894] = {.lex_state = 105, .external_lex_state = 2},
  [895] = {.lex_state = 105, .external_lex_state = 2},
  [896] = {.lex_state = 105, .external_lex_state = 2},
  [897] = {.lex_state = 105, .external_lex_state = 2},
  [898] = {.lex_state = 105, .external_lex_state = 2},
  [899] = {.lex_state = 105, .external_lex_state = 2},
  [900] = {.lex_state = 105, .external_lex_state = 2},
  [901] = {.lex_state = 105, .external_lex_state = 2},
  [902] = {.lex_state = 105, .external_lex_state = 2},
  [903] = {.lex_state = 105, .external_lex_state = 2},
  [904] = {.lex_state = 105, .external_lex_state = 2},
  [905] = {.lex_state = 105, .external_lex_state = 2},
  [906] = {.lex_state = 105, .external_lex_state = 2},
  [907] = {.lex_state = 105, .external_lex_state = 2},
  [908] = {.lex_state = 105, .external_lex_state = 2},
  [909] = {.lex_state = 105, .external_lex_state = 2},
  [910] = {.lex_state = 105, .external_lex_state = 2},
  [911] = {.lex_state = 105, .external_lex_state = 2},
  [912] = {.lex_state = 105, .external_lex_state = 2},
  [913] = {.lex_state = 105, .external_lex_state = 2},
  [914] = {.lex_state = 105, .external_lex_state = 2},
  [915] = {.lex_state = 105, .external_lex_state = 2},
  [916] = {.lex_state = 105, .external_lex_state = 2},
  [917] = {.lex_state = 105, .external_lex_state = 2},
  [918] = {.lex_state = 105, .external_lex_state = 2},
  [919] = {.lex_state = 105, .external_lex_state = 2},
  [920] = {.lex_state = 105, .external_lex_state = 2},
  [921] = {.lex_state = 105, .external_lex_state = 2},
  [922] = {.lex_state = 105, .external_lex_state = 2},
  [923] = {.lex_state = 105, .external_lex_state = 2},
  [924] = {.lex_state = 105, .external_lex_state = 2},
  [925] = {.lex_state = 105, .external_lex_state = 2},
  [926] = {.lex_state = 105, .external_lex_state = 2},
  [927] = {.lex_state = 105, .external_lex_state = 2},
  [928] = {.lex_state = 105, .external_lex_state = 2},
  [929] = {.lex_state = 105, .external_lex_state = 2},
  [930] = {.lex_state = 105, .external_lex_state = 2},
  [931] = {.lex_state = 105, .external_lex_state = 2},
  [932] = {.lex_state = 105, .external_lex_state = 2},
  [933] = {.lex_state = 105, .external_lex_state = 2},
  [934] = {.lex_state = 105, .external_lex_state = 2},
  [935] = {.lex_state = 105, .external_lex_state = 2},
  [936] = {.lex_state = 105, .external_lex_state = 2},
  [937] = {.lex_state = 105, .external_lex_state = 2},
  [938] = {.lex_state = 105, .external_lex_state = 2},
  [939] = {.lex_state = 105, .external_lex_state = 2},
  [940] = {.lex_state = 105, .external_lex_state = 2},
  [941] = {.lex_state = 105, .external_lex_state = 2},
  [942] = {.lex_state = 105, .external_lex_state = 2},
  [943] = {.lex_state = 105, .external_lex_state = 2},
  [944] = {.lex_state = 105, .external_lex_state = 2},
  [945] = {.lex_state = 105, .external_lex_state = 2},
  [946] = {.lex_state = 105, .external_lex_state = 2},
  [947] = {.lex_state = 105, .external_lex_state = 2},
  [948] = {.lex_state = 105, .external_lex_state = 2},
  [949] = {.lex_state = 105, .external_lex_state = 2},
  [950] = {.lex_state = 105, .external_lex_state = 2},
  [951] = {.lex_state = 105, .external_lex_state = 2},
  [952] = {.lex_state = 105, .external_lex_state = 2},
  [953] = {.lex_state = 105, .external_lex_state = 2},
  [954] = {.lex_state = 105, .external_lex_state = 2},
  [955] = {.lex_state = 105, .external_lex_state = 2},
  [956] = {.lex_state = 105, .external_lex_state = 2},
  [957] = {.lex_state = 105, .external_lex_state = 2},
  [958] = {.lex_state = 105, .external_lex_state = 2},
  [959] = {.lex_state = 105, .external_lex_state = 2},
  [960] = {.lex_state = 105, .external_lex_state = 2},
  [961] = {.lex_state = 105, .external_lex_state = 2},
  [962] = {.lex_state = 105, .external_lex_state = 2},
  [963] = {.lex_state = 105, .external_lex_state = 2},
  [964] = {.lex_state = 105, .external_lex_state = 2},
  [965] = {.lex_state = 105, .external_lex_state = 2},
  [966] = {.lex_state = 105, .external_lex_state = 2},
  [967] = {.lex_state = 105, .external_lex_state = 2},
  [968] = {.lex_state = 105, .external_lex_state = 2},
  [969] = {.lex_state = 105, .external_lex_state = 2},
  [970] = {.lex_state = 105, .external_lex_state = 2},
  [971] = {.lex_state = 105, .external_lex_state = 2},
  [972] = {.lex_state = 105, .external_lex_state = 2},
  [973] = {.lex_state = 105, .external_lex_state = 2},
  [974] = {.lex_state = 105, .external_lex_state = 2},
  [975] = {.lex_state = 105, .external_lex_state = 2},
  [976] = {.lex_state = 105, .external_lex_state = 2},
  [977] = {.lex_state = 105, .external_lex_state = 2},
  [978] = {.lex_state = 105, .external_lex_state = 2},
  [979] = {.lex_state = 105, .external_lex_state = 2},
  [980] = {.lex_state = 105, .external_lex_state = 2},
  [981] = {.lex_state = 105, .external_lex_state = 2},
  [982] = {.lex_state = 105, .external_lex_state = 2},
  [983] = {.lex_state = 105, .external_lex_state = 2},
  [984] = {.lex_state = 105, .external_lex_state = 2},
  [985] = {.lex_state = 105, .external_lex_state = 2},
  [986] = {.lex_state = 105, .external_lex_state = 2},
  [987] = {.lex_state = 105, .external_lex_state = 2},
  [988] = {.lex_state = 105, .external_lex_state = 2},
  [989] = {.lex_state = 105, .external_lex_state = 2},
  [990] = {.lex_state = 105, .external_lex_state = 2},
  [991] = {.lex_state = 105, .external_lex_state = 2},
  [992] = {.lex_state = 105, .external_lex_state = 2},
  [993] = {.lex_state = 105, .external_lex_state = 2},
  [994] = {.lex_state = 105, .external_lex_state = 2},
  [995] = {.lex_state = 105, .external_lex_state = 2},
  [996] = {.lex_state = 105, .external_lex_state = 2},
  [997] = {.lex_state = 105, .external_lex_state = 2},
  [998] = {.lex_state = 105, .external_lex_state = 2},
  [999] = {.lex_state = 105, .external_lex_state = 2},
  [1000] = {.lex_state = 105, .external_lex_state = 2},
  [1001] = {.lex_state = 105, .external_lex_state = 2},
  [1002] = {.lex_state = 105, .external_lex_state = 2},
  [1003] = {.lex_state = 105, .external_lex_state = 2},
  [1004] = {.lex_state = 105, .external_lex_state = 2},
  [1005] = {.lex_state = 105, .external_lex_state = 2},
  [1006] = {.lex_state = 105, .external_lex_state = 2},
  [1007] = {.lex_state = 105, .external_lex_state = 2},
  [1008] = {.lex_state = 105, .external_lex_state = 2},
  [1009] = {.lex_state = 105, .external_lex_state = 2},
  [1010] = {.lex_state = 105, .external_lex_state = 2},
  [1011] = {.lex_state = 105, .external_lex_state = 2},
  [1012] = {.lex_state = 105, .external_lex_state = 2},
  [1013] = {.lex_state = 105, .external_lex_state = 2},
  [1014] = {.lex_state = 105, .external_lex_state = 2},
  [1015] = {.lex_state = 105, .external_lex_state = 2},
  [1016] = {.lex_state = 105, .external_lex_state = 2},
  [1017] = {.lex_state = 105, .external_lex_state = 2},
  [1018] = {.lex_state = 105, .external_lex_state = 2},
  [1019] = {.lex_state = 105, .external_lex_state = 2},
  [1020] = {.lex_state = 105, .external_lex_state = 2},
  [1021] = {.lex_state = 105, .external_lex_state = 2},
  [1022] = {.lex_state = 105, .external_lex_state = 2},
  [1023] = {.lex_state = 105, .external_lex_state = 2},
  [1024] = {.lex_state = 105, .external_lex_state = 2},
  [1025] = {.lex_state = 105, .external_lex_state = 2},
  [1026] = {.lex_state = 105, .external_lex_state = 2},
  [1027] = {.lex_state = 105, .external_lex_state = 2},
  [1028] = {.lex_state = 105, .external_lex_state = 2},
  [1029] = {.lex_state = 105, .external_lex_state = 2},
  [1030] = {.lex_state = 105, .external_lex_state = 2},
  [1031] = {.lex_state = 105, .external_lex_state = 2},
  [1032] = {.lex_state = 105, .external_lex_state = 2},
  [1033] = {.lex_state = 105, .external_lex_state = 2},
  [1034] = {.lex_state = 105, .external_lex_state = 2},
  [1035] = {.lex_state = 105, .external_lex_state = 2},
  [1036] = {.lex_state = 105, .external_lex_state = 2},
  [1037] = {.lex_state = 105, .external_lex_state = 2},
  [1038] = {.lex_state = 105, .external_lex_state = 2},
  [1039] = {.lex_state = 105, .external_lex_state = 2},
  [1040] = {.lex_state = 105, .external_lex_state = 2},
  [1041] = {.lex_state = 105, .external_lex_state = 2},
  [1042] = {.lex_state = 105, .external_lex_state = 2},
  [1043] = {.lex_state = 105, .external_lex_state = 2},
  [1044] = {.lex_state = 105, .external_lex_state = 2},
  [1045] = {.lex_state = 105, .external_lex_state = 2},
  [1046] = {.lex_state = 105, .external_lex_state = 2},
  [1047] = {.lex_state = 105, .external_lex_state = 2},
  [1048] = {.lex_state = 105, .external_lex_state = 2},
  [1049] = {.lex_state = 105, .external_lex_state = 2},
  [1050] = {.lex_state = 105, .external_lex_state = 2},
  [1051] = {.lex_state = 105, .external_lex_state = 2},
  [1052] = {.lex_state = 105, .external_lex_state = 2},
  [1053] = {.lex_state = 105, .external_lex_state = 2},
  [1054] = {.lex_state = 105, .external_lex_state = 2},
  [1055] = {.lex_state = 105, .external_lex_state = 2},
  [1056] = {.lex_state = 105, .external_lex_state = 2},
  [1057] = {.lex_state = 105, .external_lex_state = 2},
  [1058] = {.lex_state = 105, .external_lex_state = 2},
  [1059] = {.lex_state = 105, .external_lex_state = 2},
  [1060] = {.lex_state = 105, .external_lex_state = 2},
  [1061] = {.lex_state = 105, .external_lex_state = 2},
  [1062] = {.lex_state = 105, .external_lex_state = 2},
  [1063] = {.lex_state = 105, .external_lex_state = 2},
  [1064] = {.lex_state = 105, .external_lex_state = 2},
  [1065] = {.lex_state = 105, .external_lex_state = 2},
  [1066] = {.lex_state = 105, .external_lex_state = 2},
  [1067] = {.lex_state = 105, .external_lex_state = 2},
  [1068] = {.lex_state = 105, .external_lex_state = 2},
  [1069] = {.lex_state = 105, .external_lex_state = 2},
  [1070] = {.lex_state = 105, .external_lex_state = 2},
  [1071] = {.lex_state = 105, .external_lex_state = 2},
  [1072] = {.lex_state = 105, .external_lex_state = 2},
  [1073] = {.lex_state = 105, .external_lex_state = 2},
  [1074] = {.lex_state = 105, .external_lex_state = 2},
  [1075] = {.lex_state = 105, .external_lex_state = 2},
  [1076] = {.lex_state = 105, .external_lex_state = 2},
  [1077] = {.lex_state = 105, .external_lex_state = 2},
  [1078] = {.lex_state = 105, .external_lex_state = 2},
  [1079] = {.lex_state = 105, .external_lex_state = 2},
  [1080] = {.lex_state = 105, .external_lex_state = 2},
  [1081] = {.lex_state = 105, .external_lex_state = 2},
  [1082] = {.lex_state = 105, .external_lex_state = 2},
  [1083] = {.lex_state = 105, .external_lex_state = 2},
  [1084] = {.lex_state = 105, .external_lex_state = 2},
  [1085] = {.lex_state = 105, .external_lex_state = 2},
  [1086] = {.lex_state = 105, .external_lex_state = 2},
  [1087] = {.lex_state = 105, .external_lex_state = 2},
  [1088] = {.lex_state = 105, .external_lex_state = 2},
  [1089] = {.lex_state = 105, .external_lex_state = 2},
  [1090] = {.lex_state = 105, .external_lex_state = 2},
  [1091] = {.lex_state = 105, .external_lex_state = 2},
  [1092] = {.lex_state = 105, .external_lex_state = 2},
  [1093] = {.lex_state = 105, .external_lex_state = 2},
  [1094] = {.lex_state = 105, .external_lex_state = 2},
  [1095] = {.lex_state = 105, .external_lex_state = 2},
  [1096] = {.lex_state = 105, .external_lex_state = 2},
  [1097] = {.lex_state = 105, .external_lex_state = 2},
  [1098] = {.lex_state = 105, .external_lex_state = 2},
  [1099] = {.lex_state = 105, .external_lex_state = 2},
  [1100] = {.lex_state = 105, .external_lex_state = 2},
  [1101] = {.lex_state = 105, .external_lex_state = 2},
  [1102] = {.lex_state = 105, .external_lex_state = 2},
  [1103] = {.lex_state = 105, .external_lex_state = 2},
  [1104] = {.lex_state = 105, .external_lex_state = 2},
  [1105] = {.lex_state = 105, .external_lex_state = 2},
  [1106] = {.lex_state = 105, .external_lex_state = 2},
  [1107] = {.lex_state = 105, .external_lex_state = 2},
  [1108] = {.lex_state = 105, .external_lex_state = 2},
  [1109] = {.lex_state = 105, .external_lex_state = 2},
  [1110] = {.lex_state = 105, .external_lex_state = 2},
  [1111] = {.lex_state = 105, .external_lex_state = 2},
  [1112] = {.lex_state = 105, .external_lex_state = 2},
  [1113] = {.lex_state = 105, .external_lex_state = 2},
  [1114] = {.lex_state = 105, .external_lex_state = 2},
  [1115] = {.lex_state = 105, .external_lex_state = 2},
  [1116] = {.lex_state = 105, .external_lex_state = 2},
  [1117] = {.lex_state = 105, .external_lex_state = 2},
  [1118] = {.lex_state = 105, .external_lex_state = 2},
  [1119] = {.lex_state = 105, .external_lex_state = 2},
  [1120] = {.lex_state = 105, .external_lex_state = 2},
  [1121] = {.lex_state = 105, .external_lex_state = 2},
  [1122] = {.lex_state = 105, .external_lex_state = 2},
  [1123] = {.lex_state = 105, .external_lex_state = 2},
  [1124] = {.lex_state = 105, .external_lex_state = 2},
  [1125] = {.lex_state = 105, .external_lex_state = 2},
  [1126] = {.lex_state = 105, .external_lex_state = 2},
  [1127] = {.lex_state = 105, .external_lex_state = 2},
  [1128] = {.lex_state = 105, .external_lex_state = 2},
  [1129] = {.lex_state = 105, .external_lex_state = 2},
  [1130] = {.lex_state = 105, .external_lex_state = 2},
  [1131] = {.lex_state = 105, .external_lex_state = 2},
  [1132] = {.lex_state = 105, .external_lex_state = 2},
  [1133] = {.lex_state = 105, .external_lex_state = 2},
  [1134] = {.lex_state = 105, .external_lex_state = 2},
  [1135] = {.lex_state = 105, .external_lex_state = 2},
  [1136] = {.lex_state = 105, .external_lex_state = 2},
  [1137] = {.lex_state = 105, .external_lex_state = 2},
  [1138] = {.lex_state = 105, .external_lex_state = 2},
  [1139] = {.lex_state = 105, .external_lex_state = 2},
  [1140] = {.lex_state = 105, .external_lex_state = 2},
  [1141] = {.lex_state = 105, .external_lex_state = 2},
  [1142] = {.lex_state = 105, .external_lex_state = 2},
  [1143] = {.lex_state = 105, .external_lex_state = 2},
  [1144] = {.lex_state = 105, .external_lex_state = 2},
  [1145] = {.lex_state = 105, .external_lex_state = 2},
  [1146] = {.lex_state = 105, .external_lex_state = 2},
  [1147] = {.lex_state = 105, .external_lex_state = 2},
  [1148] = {.lex_state = 105, .external_lex_state = 2},
  [1149] = {.lex_state = 105, .external_lex_state = 2},
  [1150] = {.lex_state = 105, .external_lex_state = 2},
  [1151] = {.lex_state = 105, .external_lex_state = 2},
  [1152] = {.lex_state = 105, .external_lex_state = 2},
  [1153] = {.lex_state = 105, .external_lex_state = 2},
  [1154] = {.lex_state = 105, .external_lex_state = 2},
  [1155] = {.lex_state = 105, .external_lex_state = 2},
  [1156] = {.lex_state = 105, .external_lex_state = 2},
  [1157] = {.lex_state = 105, .external_lex_state = 2},
  [1158] = {.lex_state = 105, .external_lex_state = 2},
  [1159] = {.lex_state = 105, .external_lex_state = 2},
  [1160] = {.lex_state = 105, .external_lex_state = 2},
  [1161] = {.lex_state = 105, .external_lex_state = 2},
  [1162] = {.lex_state = 105, .external_lex_state = 2},
  [1163] = {.lex_state = 105, .external_lex_state = 2},
  [1164] = {.lex_state = 105, .external_lex_state = 2},
  [1165] = {.lex_state = 105, .external_lex_state = 2},
  [1166] = {.lex_state = 105, .external_lex_state = 2},
  [1167] = {.lex_state = 105, .external_lex_state = 2},
  [1168] = {.lex_state = 105, .external_lex_state = 2},
  [1169] = {.lex_state = 105, .external_lex_state = 2},
  [1170] = {.lex_state = 105, .external_lex_state = 2},
  [1171] = {.lex_state = 105, .external_lex_state = 2},
  [1172] = {.lex_state = 105, .external_lex_state = 2},
  [1173] = {.lex_state = 105, .external_lex_state = 2},
  [1174] = {.lex_state = 105, .external_lex_state = 2},
  [1175] = {.lex_state = 105, .external_lex_state = 2},
  [1176] = {.lex_state = 105, .external_lex_state = 2},
  [1177] = {.lex_state = 105, .external_lex_state = 2},
  [1178] = {.lex_state = 105, .external_lex_state = 2},
  [1179] = {.lex_state = 105, .external_lex_state = 2},
  [1180] = {.lex_state = 105, .external_lex_state = 2},
  [1181] = {.lex_state = 105, .external_lex_state = 2},
  [1182] = {.lex_state = 105, .external_lex_state = 2},
  [1183] = {.lex_state = 105, .external_lex_state = 2},
  [1184] = {.lex_state = 105, .external_lex_state = 2},
  [1185] = {.lex_state = 105, .external_lex_state = 2},
  [1186] = {.lex_state = 105, .external_lex_state = 2},
  [1187] = {.lex_state = 105, .external_lex_state = 2},
  [1188] = {.lex_state = 105, .external_lex_state = 2},
  [1189] = {.lex_state = 105, .external_lex_state = 2},
  [1190] = {.lex_state = 105, .external_lex_state = 2},
  [1191] = {.lex_state = 105, .external_lex_state = 2},
  [1192] = {.lex_state = 105, .external_lex_state = 2},
  [1193] = {.lex_state = 105, .external_lex_state = 2},
  [1194] = {.lex_state = 105, .external_lex_state = 2},
  [1195] = {.lex_state = 105, .external_lex_state = 2},
  [1196] = {.lex_state = 105, .external_lex_state = 2},
  [1197] = {.lex_state = 105, .external_lex_state = 2},
  [1198] = {.lex_state = 105, .external_lex_state = 2},
  [1199] = {.lex_state = 105, .external_lex_state = 2},
  [1200] = {.lex_state = 105, .external_lex_state = 2},
  [1201] = {.lex_state = 105, .external_lex_state = 2},
  [1202] = {.lex_state = 105, .external_lex_state = 2},
  [1203] = {.lex_state = 105, .external_lex_state = 2},
  [1204] = {.lex_state = 105, .external_lex_state = 2},
  [1205] = {.lex_state = 105, .external_lex_state = 2},
  [1206] = {.lex_state = 105, .external_lex_state = 2},
  [1207] = {.lex_state = 105, .external_lex_state = 2},
  [1208] = {.lex_state = 105, .external_lex_state = 2},
  [1209] = {.lex_state = 105, .external_lex_state = 2},
  [1210] = {.lex_state = 105, .external_lex_state = 2},
  [1211] = {.lex_state = 105, .external_lex_state = 2},
  [1212] = {.lex_state = 105, .external_lex_state = 2},
  [1213] = {.lex_state = 105, .external_lex_state = 2},
  [1214] = {.lex_state = 105, .external_lex_state = 2},
  [1215] = {.lex_state = 105, .external_lex_state = 2},
  [1216] = {.lex_state = 105, .external_lex_state = 2},
  [1217] = {.lex_state = 105, .external_lex_state = 2},
  [1218] = {.lex_state = 105, .external_lex_state = 2},
  [1219] = {.lex_state = 105, .external_lex_state = 2},
  [1220] = {.lex_state = 105, .external_lex_state = 2},
  [1221] = {.lex_state = 105, .external_lex_state = 2},
  [1222] = {.lex_state = 105, .external_lex_state = 2},
  [1223] = {.lex_state = 105, .external_lex_state = 2},
  [1224] = {.lex_state = 105, .external_lex_state = 2},
  [1225] = {.lex_state = 105, .external_lex_state = 2},
  [1226] = {.lex_state = 105, .external_lex_state = 2},
  [1227] = {.lex_state = 105, .external_lex_state = 2},
  [1228] = {.lex_state = 105, .external_lex_state = 2},
  [1229] = {.lex_state = 105, .external_lex_state = 2},
  [1230] = {.lex_state = 105, .external_lex_state = 2},
  [1231] = {.lex_state = 105, .external_lex_state = 2},
  [1232] = {.lex_state = 105, .external_lex_state = 2},
  [1233] = {.lex_state = 105, .external_lex_state = 2},
  [1234] = {.lex_state = 105, .external_lex_state = 2},
  [1235] = {.lex_state = 105, .external_lex_state = 2},
  [1236] = {.lex_state = 105, .external_lex_state = 2},
  [1237] = {.lex_state = 105, .external_lex_state = 2},
  [1238] = {.lex_state = 105, .external_lex_state = 2},
  [1239] = {.lex_state = 105, .external_lex_state = 2},
  [1240] = {.lex_state = 105, .external_lex_state = 2},
  [1241] = {.lex_state = 105, .external_lex_state = 2},
  [1242] = {.lex_state = 105, .external_lex_state = 2},
  [1243] = {.lex_state = 105, .external_lex_state = 2},
  [1244] = {.lex_state = 105, .external_lex_state = 2},
  [1245] = {.lex_state = 105, .external_lex_state = 2},
  [1246] = {.lex_state = 105, .external_lex_state = 2},
  [1247] = {.lex_state = 105, .external_lex_state = 2},
  [1248] = {.lex_state = 105, .external_lex_state = 2},
  [1249] = {.lex_state = 105, .external_lex_state = 2},
  [1250] = {.lex_state = 105, .external_lex_state = 2},
  [1251] = {.lex_state = 105, .external_lex_state = 2},
  [1252] = {.lex_state = 105, .external_lex_state = 2},
  [1253] = {.lex_state = 105, .external_lex_state = 2},
  [1254] = {.lex_state = 105, .external_lex_state = 2},
  [1255] = {.lex_state = 105, .external_lex_state = 2},
  [1256] = {.lex_state = 105, .external_lex_state = 2},
  [1257] = {.lex_state = 105, .external_lex_state = 2},
  [1258] = {.lex_state = 105, .external_lex_state = 2},
  [1259] = {.lex_state = 105, .external_lex_state = 2},
  [1260] = {.lex_state = 105, .external_lex_state = 2},
  [1261] = {.lex_state = 105, .external_lex_state = 2},
  [1262] = {.lex_state = 105, .external_lex_state = 2},
  [1263] = {.lex_state = 105, .external_lex_state = 2},
  [1264] = {.lex_state = 105, .external_lex_state = 2},
  [1265] = {.lex_state = 105, .external_lex_state = 2},
  [1266] = {.lex_state = 105, .external_lex_state = 2},
  [1267] = {.lex_state = 105, .external_lex_state = 2},
  [1268] = {.lex_state = 105, .external_lex_state = 2},
  [1269] = {.lex_state = 105, .external_lex_state = 2},
  [1270] = {.lex_state = 105, .external_lex_state = 2},
  [1271] = {.lex_state = 105, .external_lex_state = 2},
  [1272] = {.lex_state = 105, .external_lex_state = 2},
  [1273] = {.lex_state = 105, .external_lex_state = 2},
  [1274] = {.lex_state = 105, .external_lex_state = 2},
  [1275] = {.lex_state = 105, .external_lex_state = 2},
  [1276] = {.lex_state = 105, .external_lex_state = 2},
  [1277] = {.lex_state = 105, .external_lex_state = 2},
  [1278] = {.lex_state = 105, .external_lex_state = 2},
  [1279] = {.lex_state = 105, .external_lex_state = 2},
  [1280] = {.lex_state = 105, .external_lex_state = 2},
  [1281] = {.lex_state = 105, .external_lex_state = 2},
  [1282] = {.lex_state = 105, .external_lex_state = 2},
  [1283] = {.lex_state = 105, .external_lex_state = 2},
  [1284] = {.lex_state = 105, .external_lex_state = 2},
  [1285] = {.lex_state = 105, .external_lex_state = 2},
  [1286] = {.lex_state = 105, .external_lex_state = 2},
  [1287] = {.lex_state = 105, .external_lex_state = 2},
  [1288] = {.lex_state = 105, .external_lex_state = 2},
  [1289] = {.lex_state = 105, .external_lex_state = 2},
  [1290] = {.lex_state = 105, .external_lex_state = 2},
  [1291] = {.lex_state = 105, .external_lex_state = 2},
  [1292] = {.lex_state = 105, .external_lex_state = 2},
  [1293] = {.lex_state = 105, .external_lex_state = 2},
  [1294] = {.lex_state = 105, .external_lex_state = 2},
  [1295] = {.lex_state = 105, .external_lex_state = 2},
  [1296] = {.lex_state = 105, .external_lex_state = 2},
  [1297] = {.lex_state = 105, .external_lex_state = 2},
  [1298] = {.lex_state = 105, .external_lex_state = 2},
  [1299] = {.lex_state = 105, .external_lex_state = 2},
  [1300] = {.lex_state = 105, .external_lex_state = 2},
  [1301] = {.lex_state = 105, .external_lex_state = 2},
  [1302] = {.lex_state = 105, .external_lex_state = 2},
  [1303] = {.lex_state = 105, .external_lex_state = 2},
  [1304] = {.lex_state = 105, .external_lex_state = 2},
  [1305] = {.lex_state = 105, .external_lex_state = 2},
  [1306] = {.lex_state = 105, .external_lex_state = 2},
  [1307] = {.lex_state = 105, .external_lex_state = 2},
  [1308] = {.lex_state = 105, .external_lex_state = 2},
  [1309] = {.lex_state = 105, .external_lex_state = 2},
  [1310] = {.lex_state = 105, .external_lex_state = 2},
  [1311] = {.lex_state = 105, .external_lex_state = 2},
  [1312] = {.lex_state = 105, .external_lex_state = 2},
  [1313] = {.lex_state = 105, .external_lex_state = 2},
  [1314] = {.lex_state = 105, .external_lex_state = 2},
  [1315] = {.lex_state = 105, .external_lex_state = 2},
  [1316] = {.lex_state = 105, .external_lex_state = 2},
  [1317] = {.lex_state = 105, .external_lex_state = 2},
  [1318] = {.lex_state = 105, .external_lex_state = 2},
  [1319] = {.lex_state = 105, .external_lex_state = 2},
  [1320] = {.lex_state = 105, .external_lex_state = 2},
  [1321] = {.lex_state = 105, .external_lex_state = 2},
  [1322] = {.lex_state = 105, .external_lex_state = 2},
  [1323] = {.lex_state = 105, .external_lex_state = 2},
  [1324] = {.lex_state = 105, .external_lex_state = 2},
  [1325] = {.lex_state = 105, .external_lex_state = 2},
  [1326] = {.lex_state = 105, .external_lex_state = 2},
  [1327] = {.lex_state = 105, .external_lex_state = 2},
  [1328] = {.lex_state = 105, .external_lex_state = 2},
  [1329] = {.lex_state = 105, .external_lex_state = 2},
  [1330] = {.lex_state = 105, .external_lex_state = 2},
  [1331] = {.lex_state = 105, .external_lex_state = 2},
  [1332] = {.lex_state = 105, .external_lex_state = 2},
  [1333] = {.lex_state = 105, .external_lex_state = 2},
  [1334] = {.lex_state = 105, .external_lex_state = 2},
  [1335] = {.lex_state = 105, .external_lex_state = 2},
  [1336] = {.lex_state = 105, .external_lex_state = 2},
  [1337] = {.lex_state = 105, .external_lex_state = 2},
  [1338] = {.lex_state = 105, .external_lex_state = 2},
  [1339] = {.lex_state = 105, .external_lex_state = 2},
  [1340] = {.lex_state = 105, .external_lex_state = 2},
  [1341] = {.lex_state = 105, .external_lex_state = 2},
  [1342] = {.lex_state = 105, .external_lex_state = 2},
  [1343] = {.lex_state = 105, .external_lex_state = 2},
  [1344] = {.lex_state = 105, .external_lex_state = 2},
  [1345] = {.lex_state = 105, .external_lex_state = 2},
  [1346] = {.lex_state = 105, .external_lex_state = 2},
  [1347] = {.lex_state = 105, .external_lex_state = 2},
  [1348] = {.lex_state = 105, .external_lex_state = 2},
  [1349] = {.lex_state = 105, .external_lex_state = 2},
  [1350] = {.lex_state = 105, .external_lex_state = 2},
  [1351] = {.lex_state = 105, .external_lex_state = 2},
  [1352] = {.lex_state = 105, .external_lex_state = 2},
  [1353] = {.lex_state = 105, .external_lex_state = 2},
  [1354] = {.lex_state = 105, .external_lex_state = 2},
  [1355] = {.lex_state = 105, .external_lex_state = 2},
  [1356] = {.lex_state = 105, .external_lex_state = 2},
  [1357] = {.lex_state = 105, .external_lex_state = 2},
  [1358] = {.lex_state = 105, .external_lex_state = 2},
  [1359] = {.lex_state = 105, .external_lex_state = 2},
  [1360] = {.lex_state = 105, .external_lex_state = 2},
  [1361] = {.lex_state = 105, .external_lex_state = 2},
  [1362] = {.lex_state = 105, .external_lex_state = 2},
  [1363] = {.lex_state = 105, .external_lex_state = 2},
  [1364] = {.lex_state = 105, .external_lex_state = 2},
  [1365] = {.lex_state = 105, .external_lex_state = 2},
  [1366] = {.lex_state = 105, .external_lex_state = 2},
  [1367] = {.lex_state = 105, .external_lex_state = 2},
  [1368] = {.lex_state = 105, .external_lex_state = 2},
  [1369] = {.lex_state = 105, .external_lex_state = 2},
  [1370] = {.lex_state = 105, .external_lex_state = 2},
  [1371] = {.lex_state = 105, .external_lex_state = 2},
  [1372] = {.lex_state = 105, .external_lex_state = 2},
  [1373] = {.lex_state = 105, .external_lex_state = 2},
  [1374] = {.lex_state = 105, .external_lex_state = 2},
  [1375] = {.lex_state = 105, .external_lex_state = 2},
  [1376] = {.lex_state = 105, .external_lex_state = 2},
  [1377] = {.lex_state = 105, .external_lex_state = 2},
  [1378] = {.lex_state = 105, .external_lex_state = 2},
  [1379] = {.lex_state = 105, .external_lex_state = 2},
  [1380] = {.lex_state = 105, .external_lex_state = 2},
  [1381] = {.lex_state = 105, .external_lex_state = 2},
  [1382] = {.lex_state = 105, .external_lex_state = 2},
  [1383] = {.lex_state = 105, .external_lex_state = 2},
  [1384] = {.lex_state = 105, .external_lex_state = 2},
  [1385] = {.lex_state = 105, .external_lex_state = 2},
  [1386] = {.lex_state = 105, .external_lex_state = 2},
  [1387] = {.lex_state = 105, .external_lex_state = 2},
  [1388] = {.lex_state = 105, .external_lex_state = 2},
  [1389] = {.lex_state = 105, .external_lex_state = 2},
  [1390] = {.lex_state = 105, .external_lex_state = 2},
  [1391] = {.lex_state = 105, .external_lex_state = 2},
  [1392] = {.lex_state = 105, .external_lex_state = 2},
  [1393] = {.lex_state = 105, .external_lex_state = 2},
  [1394] = {.lex_state = 105, .external_lex_state = 2},
  [1395] = {.lex_state = 105, .external_lex_state = 2},
  [1396] = {.lex_state = 105, .external_lex_state = 2},
  [1397] = {.lex_state = 105, .external_lex_state = 2},
  [1398] = {.lex_state = 105, .external_lex_state = 2},
  [1399] = {.lex_state = 105, .external_lex_state = 2},
  [1400] = {.lex_state = 105, .external_lex_state = 2},
  [1401] = {.lex_state = 105, .external_lex_state = 2},
  [1402] = {.lex_state = 105, .external_lex_state = 2},
  [1403] = {.lex_state = 105, .external_lex_state = 2},
  [1404] = {.lex_state = 105, .external_lex_state = 2},
  [1405] = {.lex_state = 105, .external_lex_state = 2},
  [1406] = {.lex_state = 105, .external_lex_state = 2},
  [1407] = {.lex_state = 105, .external_lex_state = 2},
  [1408] = {.lex_state = 105, .external_lex_state = 2},
  [1409] = {.lex_state = 105, .external_lex_state = 2},
  [1410] = {.lex_state = 105, .external_lex_state = 2},
  [1411] = {.lex_state = 105, .external_lex_state = 2},
  [1412] = {.lex_state = 105, .external_lex_state = 2},
  [1413] = {.lex_state = 105, .external_lex_state = 2},
  [1414] = {.lex_state = 105, .external_lex_state = 2},
  [1415] = {.lex_state = 105, .external_lex_state = 2},
  [1416] = {.lex_state = 105, .external_lex_state = 2},
  [1417] = {.lex_state = 105, .external_lex_state = 2},
  [1418] = {.lex_state = 105, .external_lex_state = 2},
  [1419] = {.lex_state = 105, .external_lex_state = 2},
  [1420] = {.lex_state = 105, .external_lex_state = 2},
  [1421] = {.lex_state = 105, .external_lex_state = 2},
  [1422] = {.lex_state = 105, .external_lex_state = 2},
  [1423] = {.lex_state = 105, .external_lex_state = 2},
  [1424] = {.lex_state = 105, .external_lex_state = 2},
  [1425] = {.lex_state = 105, .external_lex_state = 2},
  [1426] = {.lex_state = 105, .external_lex_state = 2},
  [1427] = {.lex_state = 105, .external_lex_state = 2},
  [1428] = {.lex_state = 105, .external_lex_state = 2},
  [1429] = {.lex_state = 105, .external_lex_state = 2},
  [1430] = {.lex_state = 105, .external_lex_state = 2},
  [1431] = {.lex_state = 105, .external_lex_state = 2},
  [1432] = {.lex_state = 105, .external_lex_state = 2},
  [1433] = {.lex_state = 105, .external_lex_state = 2},
  [1434] = {.lex_state = 105, .external_lex_state = 2},
  [1435] = {.lex_state = 105, .external_lex_state = 2},
  [1436] = {.lex_state = 105, .external_lex_state = 2},
  [1437] = {.lex_state = 105, .external_lex_state = 2},
  [1438] = {.lex_state = 105, .external_lex_state = 2},
  [1439] = {.lex_state = 105, .external_lex_state = 2},
  [1440] = {.lex_state = 105, .external_lex_state = 2},
  [1441] = {.lex_state = 105, .external_lex_state = 2},
  [1442] = {.lex_state = 105, .external_lex_state = 2},
  [1443] = {.lex_state = 105, .external_lex_state = 2},
  [1444] = {.lex_state = 105, .external_lex_state = 2},
  [1445] = {.lex_state = 105, .external_lex_state = 2},
  [1446] = {.lex_state = 105, .external_lex_state = 2},
  [1447] = {.lex_state = 105, .external_lex_state = 2},
  [1448] = {.lex_state = 105, .external_lex_state = 2},
  [1449] = {.lex_state = 105, .external_lex_state = 2},
  [1450] = {.lex_state = 105, .external_lex_state = 2},
  [1451] = {.lex_state = 105, .external_lex_state = 2},
  [1452] = {.lex_state = 105, .external_lex_state = 2},
  [1453] = {.lex_state = 105, .external_lex_state = 2},
  [1454] = {.lex_state = 105, .external_lex_state = 2},
  [1455] = {.lex_state = 105, .external_lex_state = 2},
  [1456] = {.lex_state = 105, .external_lex_state = 2},
  [1457] = {.lex_state = 105, .external_lex_state = 2},
  [1458] = {.lex_state = 105, .external_lex_state = 2},
  [1459] = {.lex_state = 105, .external_lex_state = 2},
  [1460] = {.lex_state = 105, .external_lex_state = 2},
  [1461] = {.lex_state = 105, .external_lex_state = 2},
  [1462] = {.lex_state = 105, .external_lex_state = 2},
  [1463] = {.lex_state = 105, .external_lex_state = 2},
  [1464] = {.lex_state = 105, .external_lex_state = 2},
  [1465] = {.lex_state = 105, .external_lex_state = 2},
  [1466] = {.lex_state = 105, .external_lex_state = 2},
  [1467] = {.lex_state = 105, .external_lex_state = 2},
  [1468] = {.lex_state = 105, .external_lex_state = 2},
  [1469] = {.lex_state = 105, .external_lex_state = 2},
  [1470] = {.lex_state = 105, .external_lex_state = 2},
  [1471] = {.lex_state = 105, .external_lex_state = 2},
  [1472] = {.lex_state = 105, .external_lex_state = 2},
  [1473] = {.lex_state = 105, .external_lex_state = 2},
  [1474] = {.lex_state = 105, .external_lex_state = 2},
  [1475] = {.lex_state = 105, .external_lex_state = 2},
  [1476] = {.lex_state = 105, .external_lex_state = 2},
  [1477] = {.lex_state = 105, .external_lex_state = 2},
  [1478] = {.lex_state = 105, .external_lex_state = 2},
  [1479] = {.lex_state = 105, .external_lex_state = 2},
  [1480] = {.lex_state = 105, .external_lex_state = 2},
  [1481] = {.lex_state = 105, .external_lex_state = 2},
  [1482] = {.lex_state = 105, .external_lex_state = 2},
  [1483] = {.lex_state = 105, .external_lex_state = 2},
  [1484] = {.lex_state = 105, .external_lex_state = 2},
  [1485] = {.lex_state = 105, .external_lex_state = 2},
  [1486] = {.lex_state = 105, .external_lex_state = 2},
  [1487] = {.lex_state = 105, .external_lex_state = 2},
  [1488] = {.lex_state = 105, .external_lex_state = 2},
  [1489] = {.lex_state = 105, .external_lex_state = 2},
  [1490] = {.lex_state = 105, .external_lex_state = 2},
  [1491] = {.lex_state = 105, .external_lex_state = 2},
  [1492] = {.lex_state = 105, .external_lex_state = 2},
  [1493] = {.lex_state = 105, .external_lex_state = 2},
  [1494] = {.lex_state = 105, .external_lex_state = 2},
  [1495] = {.lex_state = 105, .external_lex_state = 2},
  [1496] = {.lex_state = 105, .external_lex_state = 2},
  [1497] = {.lex_state = 105, .external_lex_state = 2},
  [1498] = {.lex_state = 105, .external_lex_state = 2},
  [1499] = {.lex_state = 105, .external_lex_state = 2},
  [1500] = {.lex_state = 105, .external_lex_state = 2},
  [1501] = {.lex_state = 105, .external_lex_state = 2},
  [1502] = {.lex_state = 105, .external_lex_state = 2},
  [1503] = {.lex_state = 105, .external_lex_state = 2},
  [1504] = {.lex_state = 105, .external_lex_state = 2},
  [1505] = {.lex_state = 105, .external_lex_state = 2},
  [1506] = {.lex_state = 105, .external_lex_state = 2},
  [1507] = {.lex_state = 105, .external_lex_state = 2},
  [1508] = {.lex_state = 105, .external_lex_state = 2},
  [1509] = {.lex_state = 105, .external_lex_state = 2},
  [1510] = {.lex_state = 105, .external_lex_state = 2},
  [1511] = {.lex_state = 105, .external_lex_state = 2},
  [1512] = {.lex_state = 105, .external_lex_state = 2},
  [1513] = {.lex_state = 105, .external_lex_state = 2},
  [1514] = {.lex_state = 105, .external_lex_state = 2},
  [1515] = {.lex_state = 105, .external_lex_state = 2},
  [1516] = {.lex_state = 105, .external_lex_state = 2},
  [1517] = {.lex_state = 105, .external_lex_state = 2},
  [1518] = {.lex_state = 105, .external_lex_state = 2},
  [1519] = {.lex_state = 105, .external_lex_state = 2},
  [1520] = {.lex_state = 105, .external_lex_state = 2},
  [1521] = {.lex_state = 105, .external_lex_state = 2},
  [1522] = {.lex_state = 105, .external_lex_state = 2},
  [1523] = {.lex_state = 105, .external_lex_state = 2},
  [1524] = {.lex_state = 105, .external_lex_state = 2},
  [1525] = {.lex_state = 105, .external_lex_state = 2},
  [1526] = {.lex_state = 105, .external_lex_state = 2},
  [1527] = {.lex_state = 105, .external_lex_state = 2},
  [1528] = {.lex_state = 105, .external_lex_state = 2},
  [1529] = {.lex_state = 105, .external_lex_state = 2},
  [1530] = {.lex_state = 105, .external_lex_state = 2},
  [1531] = {.lex_state = 105, .external_lex_state = 2},
  [1532] = {.lex_state = 105, .external_lex_state = 2},
  [1533] = {.lex_state = 105, .external_lex_state = 2},
  [1534] = {.lex_state = 105, .external_lex_state = 2},
  [1535] = {.lex_state = 105, .external_lex_state = 2},
  [1536] = {.lex_state = 105, .external_lex_state = 2},
  [1537] = {.lex_state = 105, .external_lex_state = 2},
  [1538] = {.lex_state = 105, .external_lex_state = 2},
  [1539] = {.lex_state = 105, .external_lex_state = 2},
  [1540] = {.lex_state = 105, .external_lex_state = 2},
  [1541] = {.lex_state = 105, .external_lex_state = 2},
  [1542] = {.lex_state = 105, .external_lex_state = 2},
  [1543] = {.lex_state = 105, .external_lex_state = 2},
  [1544] = {.lex_state = 105, .external_lex_state = 2},
  [1545] = {.lex_state = 105, .external_lex_state = 2},
  [1546] = {.lex_state = 105, .external_lex_state = 2},
  [1547] = {.lex_state = 105, .external_lex_state = 2},
  [1548] = {.lex_state = 105, .external_lex_state = 2},
  [1549] = {.lex_state = 105, .external_lex_state = 2},
  [1550] = {.lex_state = 105, .external_lex_state = 2},
  [1551] = {.lex_state = 105, .external_lex_state = 2},
  [1552] = {.lex_state = 105, .external_lex_state = 2},
  [1553] = {.lex_state = 105, .external_lex_state = 2},
  [1554] = {.lex_state = 105, .external_lex_state = 2},
  [1555] = {.lex_state = 105, .external_lex_state = 2},
  [1556] = {.lex_state = 105, .external_lex_state = 2},
  [1557] = {.lex_state = 105, .external_lex_state = 2},
  [1558] = {.lex_state = 105, .external_lex_state = 2},
  [1559] = {.lex_state = 105, .external_lex_state = 2},
  [1560] = {.lex_state = 105, .external_lex_state = 2},
  [1561] = {.lex_state = 105, .external_lex_state = 2},
  [1562] = {.lex_state = 105, .external_lex_state = 2},
  [1563] = {.lex_state = 105, .external_lex_state = 2},
  [1564] = {.lex_state = 105, .external_lex_state = 2},
  [1565] = {.lex_state = 105, .external_lex_state = 2},
  [1566] = {.lex_state = 105, .external_lex_state = 2},
  [1567] = {.lex_state = 105, .external_lex_state = 2},
  [1568] = {.lex_state = 105, .external_lex_state = 2},
  [1569] = {.lex_state = 105, .external_lex_state = 2},
  [1570] = {.lex_state = 105, .external_lex_state = 2},
  [1571] = {.lex_state = 105, .external_lex_state = 2},
  [1572] = {.lex_state = 105, .external_lex_state = 2},
  [1573] = {.lex_state = 105, .external_lex_state = 2},
  [1574] = {.lex_state = 105, .external_lex_state = 2},
  [1575] = {.lex_state = 105, .external_lex_state = 2},
  [1576] = {.lex_state = 105, .external_lex_state = 2},
  [1577] = {.lex_state = 105, .external_lex_state = 2},
  [1578] = {.lex_state = 105, .external_lex_state = 2},
  [1579] = {.lex_state = 105, .external_lex_state = 2},
  [1580] = {.lex_state = 105, .external_lex_state = 2},
  [1581] = {.lex_state = 105, .external_lex_state = 2},
  [1582] = {.lex_state = 105, .external_lex_state = 2},
  [1583] = {.lex_state = 105, .external_lex_state = 2},
  [1584] = {.lex_state = 105, .external_lex_state = 2},
  [1585] = {.lex_state = 105, .external_lex_state = 2},
  [1586] = {.lex_state = 105, .external_lex_state = 2},
  [1587] = {.lex_state = 105, .external_lex_state = 2},
  [1588] = {.lex_state = 105, .external_lex_state = 2},
  [1589] = {.lex_state = 105, .external_lex_state = 2},
  [1590] = {.lex_state = 105, .external_lex_state = 2},
  [1591] = {.lex_state = 105, .external_lex_state = 2},
  [1592] = {.lex_state = 105, .external_lex_state = 2},
  [1593] = {.lex_state = 105, .external_lex_state = 2},
  [1594] = {.lex_state = 105, .external_lex_state = 2},
  [1595] = {.lex_state = 105, .external_lex_state = 2},
  [1596] = {.lex_state = 105, .external_lex_state = 2},
  [1597] = {.lex_state = 105, .external_lex_state = 2},
  [1598] = {.lex_state = 105, .external_lex_state = 2},
  [1599] = {.lex_state = 105, .external_lex_state = 2},
  [1600] = {.lex_state = 105, .external_lex_state = 2},
  [1601] = {.lex_state = 105, .external_lex_state = 2},
  [1602] = {.lex_state = 105, .external_lex_state = 2},
  [1603] = {.lex_state = 105, .external_lex_state = 2},
  [1604] = {.lex_state = 105, .external_lex_state = 2},
  [1605] = {.lex_state = 105, .external_lex_state = 2},
  [1606] = {.lex_state = 105, .external_lex_state = 2},
  [1607] = {.lex_state = 105, .external_lex_state = 2},
  [1608] = {.lex_state = 105, .external_lex_state = 2},
  [1609] = {.lex_state = 105, .external_lex_state = 2},
  [1610] = {.lex_state = 105, .external_lex_state = 2},
  [1611] = {.lex_state = 105, .external_lex_state = 2},
  [1612] = {.lex_state = 105, .external_lex_state = 2},
  [1613] = {.lex_state = 105, .external_lex_state = 2},
  [1614] = {.lex_state = 105, .external_lex_state = 2},
  [1615] = {.lex_state = 105, .external_lex_state = 2},
  [1616] = {.lex_state = 105, .external_lex_state = 2},
  [1617] = {.lex_state = 105, .external_lex_state = 2},
  [1618] = {.lex_state = 105, .external_lex_state = 2},
  [1619] = {.lex_state = 105, .external_lex_state = 2},
  [1620] = {.lex_state = 105, .external_lex_state = 2},
  [1621] = {.lex_state = 105, .external_lex_state = 2},
  [1622] = {.lex_state = 105, .external_lex_state = 2},
  [1623] = {.lex_state = 105, .external_lex_state = 2},
  [1624] = {.lex_state = 105, .external_lex_state = 2},
  [1625] = {.lex_state = 105, .external_lex_state = 2},
  [1626] = {.lex_state = 105, .external_lex_state = 2},
  [1627] = {.lex_state = 105, .external_lex_state = 2},
  [1628] = {.lex_state = 105, .external_lex_state = 2},
  [1629] = {.lex_state = 105, .external_lex_state = 2},
  [1630] = {.lex_state = 105, .external_lex_state = 2},
  [1631] = {.lex_state = 105, .external_lex_state = 2},
  [1632] = {.lex_state = 105, .external_lex_state = 2},
  [1633] = {.lex_state = 105, .external_lex_state = 2},
  [1634] = {.lex_state = 105, .external_lex_state = 2},
  [1635] = {.lex_state = 105, .external_lex_state = 2},
  [1636] = {.lex_state = 105, .external_lex_state = 2},
  [1637] = {.lex_state = 105, .external_lex_state = 2},
  [1638] = {.lex_state = 105, .external_lex_state = 2},
  [1639] = {.lex_state = 105, .external_lex_state = 2},
  [1640] = {.lex_state = 105, .external_lex_state = 2},
  [1641] = {.lex_state = 105, .external_lex_state = 2},
  [1642] = {.lex_state = 105, .external_lex_state = 2},
  [1643] = {.lex_state = 105, .external_lex_state = 2},
  [1644] = {.lex_state = 105, .external_lex_state = 2},
  [1645] = {.lex_state = 105, .external_lex_state = 2},
  [1646] = {.lex_state = 105, .external_lex_state = 2},
  [1647] = {.lex_state = 105, .external_lex_state = 2},
  [1648] = {.lex_state = 105, .external_lex_state = 2},
  [1649] = {.lex_state = 105, .external_lex_state = 2},
  [1650] = {.lex_state = 105, .external_lex_state = 2},
  [1651] = {.lex_state = 105, .external_lex_state = 2},
  [1652] = {.lex_state = 105, .external_lex_state = 2},
  [1653] = {.lex_state = 105, .external_lex_state = 2},
  [1654] = {.lex_state = 105, .external_lex_state = 2},
  [1655] = {.lex_state = 105, .external_lex_state = 2},
  [1656] = {.lex_state = 105, .external_lex_state = 2},
  [1657] = {.lex_state = 105, .external_lex_state = 2},
  [1658] = {.lex_state = 105, .external_lex_state = 2},
  [1659] = {.lex_state = 105, .external_lex_state = 2},
  [1660] = {.lex_state = 105, .external_lex_state = 2},
  [1661] = {.lex_state = 105, .external_lex_state = 2},
  [1662] = {.lex_state = 105, .external_lex_state = 2},
  [1663] = {.lex_state = 105, .external_lex_state = 2},
  [1664] = {.lex_state = 105, .external_lex_state = 2},
  [1665] = {.lex_state = 105, .external_lex_state = 2},
  [1666] = {.lex_state = 105, .external_lex_state = 2},
  [1667] = {.lex_state = 105, .external_lex_state = 2},
  [1668] = {.lex_state = 105, .external_lex_state = 2},
  [1669] = {.lex_state = 105, .external_lex_state = 2},
  [1670] = {.lex_state = 105, .external_lex_state = 2},
  [1671] = {.lex_state = 105, .external_lex_state = 2},
  [1672] = {.lex_state = 105, .external_lex_state = 2},
  [1673] = {.lex_state = 105, .external_lex_state = 2},
  [1674] = {.lex_state = 105, .external_lex_state = 2},
  [1675] = {.lex_state = 105, .external_lex_state = 2},
  [1676] = {.lex_state = 105, .external_lex_state = 2},
  [1677] = {.lex_state = 105, .external_lex_state = 2},
  [1678] = {.lex_state = 105, .external_lex_state = 2},
  [1679] = {.lex_state = 105, .external_lex_state = 2},
  [1680] = {.lex_state = 105, .external_lex_state = 2},
  [1681] = {.lex_state = 105, .external_lex_state = 2},
  [1682] = {.lex_state = 105, .external_lex_state = 2},
  [1683] = {.lex_state = 105, .external_lex_state = 2},
  [1684] = {.lex_state = 105, .external_lex_state = 2},
  [1685] = {.lex_state = 105, .external_lex_state = 2},
  [1686] = {.lex_state = 105, .external_lex_state = 2},
  [1687] = {.lex_state = 105, .external_lex_state = 2},
  [1688] = {.lex_state = 105, .external_lex_state = 2},
  [1689] = {.lex_state = 105, .external_lex_state = 2},
  [1690] = {.lex_state = 105, .external_lex_state = 2},
  [1691] = {.lex_state = 105, .external_lex_state = 2},
  [1692] = {.lex_state = 105, .external_lex_state = 2},
  [1693] = {.lex_state = 105, .external_lex_state = 2},
  [1694] = {.lex_state = 105, .external_lex_state = 2},
  [1695] = {.lex_state = 105, .external_lex_state = 2},
  [1696] = {.lex_state = 105, .external_lex_state = 2},
  [1697] = {.lex_state = 105, .external_lex_state = 2},
  [1698] = {.lex_state = 105, .external_lex_state = 2},
  [1699] = {.lex_state = 105, .external_lex_state = 2},
  [1700] = {.lex_state = 105, .external_lex_state = 2},
  [1701] = {.lex_state = 105, .external_lex_state = 2},
  [1702] = {.lex_state = 105, .external_lex_state = 2},
  [1703] = {.lex_state = 105, .external_lex_state = 2},
  [1704] = {.lex_state = 105, .external_lex_state = 2},
  [1705] = {.lex_state = 105, .external_lex_state = 2},
  [1706] = {.lex_state = 105, .external_lex_state = 2},
  [1707] = {.lex_state = 105, .external_lex_state = 2},
  [1708] = {.lex_state = 105, .external_lex_state = 2},
  [1709] = {.lex_state = 105, .external_lex_state = 2},
  [1710] = {.lex_state = 105, .external_lex_state = 2},
  [1711] = {.lex_state = 105, .external_lex_state = 2},
  [1712] = {.lex_state = 105, .external_lex_state = 2},
  [1713] = {.lex_state = 105, .external_lex_state = 2},
  [1714] = {.lex_state = 105, .external_lex_state = 2},
  [1715] = {.lex_state = 105, .external_lex_state = 2},
  [1716] = {.lex_state = 105, .external_lex_state = 2},
  [1717] = {.lex_state = 105, .external_lex_state = 2},
  [1718] = {.lex_state = 105, .external_lex_state = 2},
  [1719] = {.lex_state = 105, .external_lex_state = 2},
  [1720] = {.lex_state = 105, .external_lex_state = 2},
  [1721] = {.lex_state = 105, .external_lex_state = 2},
  [1722] = {.lex_state = 105, .external_lex_state = 2},
  [1723] = {.lex_state = 105, .external_lex_state = 2},
  [1724] = {.lex_state = 105, .external_lex_state = 2},
  [1725] = {.lex_state = 105, .external_lex_state = 2},
  [1726] = {.lex_state = 105, .external_lex_state = 2},
  [1727] = {.lex_state = 105, .external_lex_state = 2},
  [1728] = {.lex_state = 105, .external_lex_state = 2},
  [1729] = {.lex_state = 105, .external_lex_state = 2},
  [1730] = {.lex_state = 105, .external_lex_state = 2},
  [1731] = {.lex_state = 105, .external_lex_state = 2},
  [1732] = {.lex_state = 105, .external_lex_state = 2},
  [1733] = {.lex_state = 105, .external_lex_state = 2},
  [1734] = {.lex_state = 105, .external_lex_state = 2},
  [1735] = {.lex_state = 105, .external_lex_state = 2},
  [1736] = {.lex_state = 105, .external_lex_state = 2},
  [1737] = {.lex_state = 105, .external_lex_state = 2},
  [1738] = {.lex_state = 105, .external_lex_state = 2},
  [1739] = {.lex_state = 105, .external_lex_state = 2},
  [1740] = {.lex_state = 105, .external_lex_state = 2},
  [1741] = {.lex_state = 105, .external_lex_state = 2},
  [1742] = {.lex_state = 105, .external_lex_state = 2},
  [1743] = {.lex_state = 105, .external_lex_state = 2},
  [1744] = {.lex_state = 105, .external_lex_state = 2},
  [1745] = {.lex_state = 105, .external_lex_state = 2},
  [1746] = {.lex_state = 105, .external_lex_state = 2},
  [1747] = {.lex_state = 105, .external_lex_state = 2},
  [1748] = {.lex_state = 105, .external_lex_state = 2},
  [1749] = {.lex_state = 105, .external_lex_state = 2},
  [1750] = {.lex_state = 105, .external_lex_state = 2},
  [1751] = {.lex_state = 105, .external_lex_state = 2},
  [1752] = {.lex_state = 105, .external_lex_state = 2},
  [1753] = {.lex_state = 105, .external_lex_state = 2},
  [1754] = {.lex_state = 105, .external_lex_state = 2},
  [1755] = {.lex_state = 105, .external_lex_state = 2},
  [1756] = {.lex_state = 105, .external_lex_state = 2},
  [1757] = {.lex_state = 105, .external_lex_state = 2},
  [1758] = {.lex_state = 105, .external_lex_state = 2},
  [1759] = {.lex_state = 105, .external_lex_state = 2},
  [1760] = {.lex_state = 105, .external_lex_state = 2},
  [1761] = {.lex_state = 105, .external_lex_state = 2},
  [1762] = {.lex_state = 105, .external_lex_state = 2},
  [1763] = {.lex_state = 105, .external_lex_state = 2},
  [1764] = {.lex_state = 105, .external_lex_state = 2},
  [1765] = {.lex_state = 105, .external_lex_state = 2},
  [1766] = {.lex_state = 105, .external_lex_state = 2},
  [1767] = {.lex_state = 105, .external_lex_state = 2},
  [1768] = {.lex_state = 105, .external_lex_state = 2},
  [1769] = {.lex_state = 105, .external_lex_state = 2},
  [1770] = {.lex_state = 105, .external_lex_state = 2},
  [1771] = {.lex_state = 105, .external_lex_state = 2},
  [1772] = {.lex_state = 105, .external_lex_state = 2},
  [1773] = {.lex_state = 105, .external_lex_state = 2},
  [1774] = {.lex_state = 105, .external_lex_state = 2},
  [1775] = {.lex_state = 105, .external_lex_state = 2},
  [1776] = {.lex_state = 105, .external_lex_state = 2},
  [1777] = {.lex_state = 105, .external_lex_state = 2},
  [1778] = {.lex_state = 105, .external_lex_state = 2},
  [1779] = {.lex_state = 105, .external_lex_state = 2},
  [1780] = {.lex_state = 105, .external_lex_state = 2},
  [1781] = {.lex_state = 105, .external_lex_state = 2},
  [1782] = {.lex_state = 105, .external_lex_state = 2},
  [1783] = {.lex_state = 105, .external_lex_state = 2},
  [1784] = {.lex_state = 105, .external_lex_state = 2},
  [1785] = {.lex_state = 105, .external_lex_state = 2},
  [1786] = {.lex_state = 105, .external_lex_state = 2},
  [1787] = {.lex_state = 105, .external_lex_state = 2},
  [1788] = {.lex_state = 105, .external_lex_state = 2},
  [1789] = {.lex_state = 105, .external_lex_state = 2},
  [1790] = {.lex_state = 105, .external_lex_state = 2},
  [1791] = {.lex_state = 105, .external_lex_state = 2},
  [1792] = {.lex_state = 105, .external_lex_state = 2},
  [1793] = {.lex_state = 105, .external_lex_state = 2},
  [1794] = {.lex_state = 105, .external_lex_state = 2},
  [1795] = {.lex_state = 105, .external_lex_state = 2},
  [1796] = {.lex_state = 105, .external_lex_state = 2},
  [1797] = {.lex_state = 105, .external_lex_state = 2},
  [1798] = {.lex_state = 105, .external_lex_state = 2},
  [1799] = {.lex_state = 105, .external_lex_state = 2},
  [1800] = {.lex_state = 105, .external_lex_state = 2},
  [1801] = {.lex_state = 105, .external_lex_state = 2},
  [1802] = {.lex_state = 105, .external_lex_state = 2},
  [1803] = {.lex_state = 105, .external_lex_state = 2},
  [1804] = {.lex_state = 105, .external_lex_state = 2},
  [1805] = {.lex_state = 105, .external_lex_state = 2},
  [1806] = {.lex_state = 105, .external_lex_state = 2},
  [1807] = {.lex_state = 105, .external_lex_state = 2},
  [1808] = {.lex_state = 105, .external_lex_state = 2},
  [1809] = {.lex_state = 105, .external_lex_state = 2},
  [1810] = {.lex_state = 105, .external_lex_state = 2},
  [1811] = {.lex_state = 105, .external_lex_state = 2},
  [1812] = {.lex_state = 105, .external_lex_state = 2},
  [1813] = {.lex_state = 105, .external_lex_state = 2},
  [1814] = {.lex_state = 105, .external_lex_state = 2},
  [1815] = {.lex_state = 105, .external_lex_state = 2},
  [1816] = {.lex_state = 105, .external_lex_state = 2},
  [1817] = {.lex_state = 105, .external_lex_state = 2},
  [1818] = {.lex_state = 105, .external_lex_state = 2},
  [1819] = {.lex_state = 105, .external_lex_state = 2},
  [1820] = {.lex_state = 105, .external_lex_state = 2},
  [1821] = {.lex_state = 105, .external_lex_state = 2},
  [1822] = {.lex_state = 105, .external_lex_state = 2},
  [1823] = {.lex_state = 105, .external_lex_state = 2},
  [1824] = {.lex_state = 105, .external_lex_state = 2},
  [1825] = {.lex_state = 105, .external_lex_state = 2},
  [1826] = {.lex_state = 105, .external_lex_state = 2},
  [1827] = {.lex_state = 105, .external_lex_state = 2},
  [1828] = {.lex_state = 105, .external_lex_state = 2},
  [1829] = {.lex_state = 105, .external_lex_state = 2},
  [1830] = {.lex_state = 105, .external_lex_state = 2},
  [1831] = {.lex_state = 105, .external_lex_state = 2},
  [1832] = {.lex_state = 105, .external_lex_state = 2},
  [1833] = {.lex_state = 105, .external_lex_state = 2},
  [1834] = {.lex_state = 105, .external_lex_state = 2},
  [1835] = {.lex_state = 105, .external_lex_state = 2},
  [1836] = {.lex_state = 105, .external_lex_state = 2},
  [1837] = {.lex_state = 105, .external_lex_state = 2},
  [1838] = {.lex_state = 105, .external_lex_state = 2},
  [1839] = {.lex_state = 105, .external_lex_state = 2},
  [1840] = {.lex_state = 105, .external_lex_state = 2},
  [1841] = {.lex_state = 105, .external_lex_state = 2},
  [1842] = {.lex_state = 105, .external_lex_state = 2},
  [1843] = {.lex_state = 105, .external_lex_state = 2},
  [1844] = {.lex_state = 105, .external_lex_state = 2},
  [1845] = {.lex_state = 105, .external_lex_state = 2},
  [1846] = {.lex_state = 105, .external_lex_state = 2},
  [1847] = {.lex_state = 105, .external_lex_state = 2},
  [1848] = {.lex_state = 105, .external_lex_state = 2},
  [1849] = {.lex_state = 105, .external_lex_state = 2},
  [1850] = {.lex_state = 105, .external_lex_state = 2},
  [1851] = {.lex_state = 105, .external_lex_state = 2},
  [1852] = {.lex_state = 105, .external_lex_state = 2},
  [1853] = {.lex_state = 105, .external_lex_state = 2},
  [1854] = {.lex_state = 105, .external_lex_state = 2},
  [1855] = {.lex_state = 105, .external_lex_state = 2},
  [1856] = {.lex_state = 105, .external_lex_state = 2},
  [1857] = {.lex_state = 105, .external_lex_state = 2},
  [1858] = {.lex_state = 105, .external_lex_state = 2},
  [1859] = {.lex_state = 105, .external_lex_state = 2},
  [1860] = {.lex_state = 105, .external_lex_state = 2},
  [1861] = {.lex_state = 105, .external_lex_state = 2},
  [1862] = {.lex_state = 105, .external_lex_state = 2},
  [1863] = {.lex_state = 105, .external_lex_state = 2},
  [1864] = {.lex_state = 105, .external_lex_state = 2},
  [1865] = {.lex_state = 105, .external_lex_state = 2},
  [1866] = {.lex_state = 105, .external_lex_state = 2},
  [1867] = {.lex_state = 105, .external_lex_state = 2},
  [1868] = {.lex_state = 105, .external_lex_state = 2},
  [1869] = {.lex_state = 105, .external_lex_state = 2},
  [1870] = {.lex_state = 105, .external_lex_state = 2},
  [1871] = {.lex_state = 105, .external_lex_state = 2},
  [1872] = {.lex_state = 105, .external_lex_state = 2},
  [1873] = {.lex_state = 105, .external_lex_state = 2},
  [1874] = {.lex_state = 105, .external_lex_state = 2},
  [1875] = {.lex_state = 105, .external_lex_state = 2},
  [1876] = {.lex_state = 105, .external_lex_state = 2},
  [1877] = {.lex_state = 105, .external_lex_state = 2},
  [1878] = {.lex_state = 105, .external_lex_state = 2},
  [1879] = {.lex_state = 105, .external_lex_state = 2},
  [1880] = {.lex_state = 105, .external_lex_state = 2},
  [1881] = {.lex_state = 105, .external_lex_state = 2},
  [1882] = {.lex_state = 105, .external_lex_state = 2},
  [1883] = {.lex_state = 105, .external_lex_state = 2},
  [1884] = {.lex_state = 105, .external_lex_state = 2},
  [1885] = {.lex_state = 105, .external_lex_state = 2},
  [1886] = {.lex_state = 105, .external_lex_state = 2},
  [1887] = {.lex_state = 105, .external_lex_state = 2},
  [1888] = {.lex_state = 105, .external_lex_state = 2},
  [1889] = {.lex_state = 105, .external_lex_state = 2},
  [1890] = {.lex_state = 105, .external_lex_state = 2},
  [1891] = {.lex_state = 105, .external_lex_state = 2},
  [1892] = {.lex_state = 105, .external_lex_state = 2},
  [1893] = {.lex_state = 105, .external_lex_state = 2},
  [1894] = {.lex_state = 105, .external_lex_state = 2},
  [1895] = {.lex_state = 105, .external_lex_state = 2},
  [1896] = {.lex_state = 105, .external_lex_state = 2},
  [1897] = {.lex_state = 105, .external_lex_state = 2},
  [1898] = {.lex_state = 105, .external_lex_state = 2},
  [1899] = {.lex_state = 105, .external_lex_state = 2},
  [1900] = {.lex_state = 105, .external_lex_state = 2},
  [1901] = {.lex_state = 105, .external_lex_state = 2},
  [1902] = {.lex_state = 105, .external_lex_state = 2},
  [1903] = {.lex_state = 105, .external_lex_state = 2},
  [1904] = {.lex_state = 105, .external_lex_state = 2},
  [1905] = {.lex_state = 105, .external_lex_state = 2},
  [1906] = {.lex_state = 105, .external_lex_state = 2},
  [1907] = {.lex_state = 105, .external_lex_state = 2},
  [1908] = {.lex_state = 105, .external_lex_state = 2},
  [1909] = {.lex_state = 105, .external_lex_state = 2},
  [1910] = {.lex_state = 105, .external_lex_state = 2},
  [1911] = {.lex_state = 105, .external_lex_state = 2},
  [1912] = {.lex_state = 105, .external_lex_state = 2},
  [1913] = {.lex_state = 105, .external_lex_state = 2},
  [1914] = {.lex_state = 105, .external_lex_state = 2},
  [1915] = {.lex_state = 105, .external_lex_state = 2},
  [1916] = {.lex_state = 105, .external_lex_state = 2},
  [1917] = {.lex_state = 105, .external_lex_state = 2},
  [1918] = {.lex_state = 105, .external_lex_state = 2},
  [1919] = {.lex_state = 105, .external_lex_state = 2},
  [1920] = {.lex_state = 105, .external_lex_state = 2},
  [1921] = {.lex_state = 105, .external_lex_state = 2},
  [1922] = {.lex_state = 105, .external_lex_state = 2},
  [1923] = {.lex_state = 105, .external_lex_state = 2},
  [1924] = {.lex_state = 105, .external_lex_state = 2},
  [1925] = {.lex_state = 105, .external_lex_state = 2},
  [1926] = {.lex_state = 105, .external_lex_state = 2},
  [1927] = {.lex_state = 105, .external_lex_state = 2},
  [1928] = {.lex_state = 105, .external_lex_state = 2},
  [1929] = {.lex_state = 105, .external_lex_state = 2},
  [1930] = {.lex_state = 105, .external_lex_state = 2},
  [1931] = {.lex_state = 105, .external_lex_state = 2},
  [1932] = {.lex_state = 105, .external_lex_state = 2},
  [1933] = {.lex_state = 105, .external_lex_state = 2},
  [1934] = {.lex_state = 105, .external_lex_state = 2},
  [1935] = {.lex_state = 105, .external_lex_state = 2},
  [1936] = {.lex_state = 105, .external_lex_state = 2},
  [1937] = {.lex_state = 105, .external_lex_state = 2},
  [1938] = {.lex_state = 105, .external_lex_state = 2},
  [1939] = {.lex_state = 105, .external_lex_state = 2},
  [1940] = {.lex_state = 105, .external_lex_state = 2},
  [1941] = {.lex_state = 105, .external_lex_state = 2},
  [1942] = {.lex_state = 105, .external_lex_state = 2},
  [1943] = {.lex_state = 105, .external_lex_state = 2},
  [1944] = {.lex_state = 105, .external_lex_state = 2},
  [1945] = {.lex_state = 105, .external_lex_state = 2},
  [1946] = {.lex_state = 105, .external_lex_state = 2},
  [1947] = {.lex_state = 105, .external_lex_state = 2},
  [1948] = {.lex_state = 105, .external_lex_state = 2},
  [1949] = {.lex_state = 105, .external_lex_state = 2},
  [1950] = {.lex_state = 105, .external_lex_state = 2},
  [1951] = {.lex_state = 105, .external_lex_state = 2},
  [1952] = {.lex_state = 105, .external_lex_state = 2},
  [1953] = {.lex_state = 105, .external_lex_state = 2},
  [1954] = {.lex_state = 105, .external_lex_state = 2},
  [1955] = {.lex_state = 105, .external_lex_state = 2},
  [1956] = {.lex_state = 105, .external_lex_state = 2},
  [1957] = {.lex_state = 105, .external_lex_state = 2},
  [1958] = {.lex_state = 105, .external_lex_state = 2},
  [1959] = {.lex_state = 105, .external_lex_state = 2},
  [1960] = {.lex_state = 105, .external_lex_state = 2},
  [1961] = {.lex_state = 105, .external_lex_state = 2},
  [1962] = {.lex_state = 105, .external_lex_state = 2},
  [1963] = {.lex_state = 105, .external_lex_state = 2},
  [1964] = {.lex_state = 105, .external_lex_state = 2},
  [1965] = {.lex_state = 105, .external_lex_state = 2},
  [1966] = {.lex_state = 105, .external_lex_state = 2},
  [1967] = {.lex_state = 105, .external_lex_state = 2},
  [1968] = {.lex_state = 105, .external_lex_state = 2},
  [1969] = {.lex_state = 105, .external_lex_state = 2},
  [1970] = {.lex_state = 105, .external_lex_state = 2},
  [1971] = {.lex_state = 105, .external_lex_state = 2},
  [1972] = {.lex_state = 105, .external_lex_state = 2},
  [1973] = {.lex_state = 105, .external_lex_state = 2},
  [1974] = {.lex_state = 105, .external_lex_state = 2},
  [1975] = {.lex_state = 105, .external_lex_state = 2},
  [1976] = {.lex_state = 105, .external_lex_state = 2},
  [1977] = {.lex_state = 105, .external_lex_state = 2},
  [1978] = {.lex_state = 105, .external_lex_state = 2},
  [1979] = {.lex_state = 105, .external_lex_state = 2},
  [1980] = {.lex_state = 105, .external_lex_state = 2},
  [1981] = {.lex_state = 105, .external_lex_state = 2},
  [1982] = {.lex_state = 105, .external_lex_state = 2},
  [1983] = {.lex_state = 105, .external_lex_state = 2},
  [1984] = {.lex_state = 105, .external_lex_state = 2},
  [1985] = {.lex_state = 105, .external_lex_state = 2},
  [1986] = {.lex_state = 105, .external_lex_state = 2},
  [1987] = {.lex_state = 105, .external_lex_state = 2},
  [1988] = {.lex_state = 105, .external_lex_state = 2},
  [1989] = {.lex_state = 105, .external_lex_state = 2},
  [1990] = {.lex_state = 105, .external_lex_state = 2},
  [1991] = {.lex_state = 105, .external_lex_state = 2},
  [1992] = {.lex_state = 105, .external_lex_state = 2},
  [1993] = {.lex_state = 105, .external_lex_state = 2},
  [1994] = {.lex_state = 105, .external_lex_state = 2},
  [1995] = {.lex_state = 105, .external_lex_state = 2},
  [1996] = {.lex_state = 105, .external_lex_state = 2},
  [1997] = {.lex_state = 105, .external_lex_state = 2},
  [1998] = {.lex_state = 105, .external_lex_state = 2},
  [1999] = {.lex_state = 105, .external_lex_state = 2},
  [2000] = {.lex_state = 105, .external_lex_state = 2},
  [2001] = {.lex_state = 105, .external_lex_state = 2},
  [2002] = {.lex_state = 105, .external_lex_state = 2},
  [2003] = {.lex_state = 105, .external_lex_state = 2},
  [2004] = {.lex_state = 105, .external_lex_state = 2},
  [2005] = {.lex_state = 105, .external_lex_state = 2},
  [2006] = {.lex_state = 105, .external_lex_state = 2},
  [2007] = {.lex_state = 105, .external_lex_state = 2},
  [2008] = {.lex_state = 105, .external_lex_state = 2},
  [2009] = {.lex_state = 105, .external_lex_state = 2},
  [2010] = {.lex_state = 105, .external_lex_state = 2},
  [2011] = {.lex_state = 105, .external_lex_state = 2},
  [2012] = {.lex_state = 105, .external_lex_state = 2},
  [2013] = {.lex_state = 105, .external_lex_state = 2},
  [2014] = {.lex_state = 105, .external_lex_state = 2},
  [2015] = {.lex_state = 105, .external_lex_state = 2},
  [2016] = {.lex_state = 105, .external_lex_state = 2},
  [2017] = {.lex_state = 105, .external_lex_state = 2},
  [2018] = {.lex_state = 105, .external_lex_state = 2},
  [2019] = {.lex_state = 105, .external_lex_state = 2},
  [2020] = {.lex_state = 105, .external_lex_state = 2},
  [2021] = {.lex_state = 105, .external_lex_state = 2},
  [2022] = {.lex_state = 105, .external_lex_state = 2},
  [2023] = {.lex_state = 105, .external_lex_state = 2},
  [2024] = {.lex_state = 105, .external_lex_state = 2},
  [2025] = {.lex_state = 105, .external_lex_state = 2},
  [2026] = {.lex_state = 105, .external_lex_state = 2},
  [2027] = {.lex_state = 105, .external_lex_state = 2},
  [2028] = {.lex_state = 105, .external_lex_state = 2},
  [2029] = {.lex_state = 105, .external_lex_state = 2},
  [2030] = {.lex_state = 105, .external_lex_state = 2},
  [2031] = {.lex_state = 105, .external_lex_state = 2},
  [2032] = {.lex_state = 105, .external_lex_state = 2},
  [2033] = {.lex_state = 105, .external_lex_state = 2},
  [2034] = {.lex_state = 105, .external_lex_state = 2},
  [2035] = {.lex_state = 105, .external_lex_state = 2},
  [2036] = {.lex_state = 105, .external_lex_state = 2},
  [2037] = {.lex_state = 105, .external_lex_state = 2},
  [2038] = {.lex_state = 105, .external_lex_state = 2},
  [2039] = {.lex_state = 105, .external_lex_state = 2},
  [2040] = {.lex_state = 105, .external_lex_state = 2},
  [2041] = {.lex_state = 105, .external_lex_state = 2},
  [2042] = {.lex_state = 105, .external_lex_state = 2},
  [2043] = {.lex_state = 105, .external_lex_state = 2},
  [2044] = {.lex_state = 105, .external_lex_state = 2},
  [2045] = {.lex_state = 105, .external_lex_state = 2},
  [2046] = {.lex_state = 105, .external_lex_state = 2},
  [2047] = {.lex_state = 105, .external_lex_state = 2},
  [2048] = {.lex_state = 105, .external_lex_state = 2},
  [2049] = {.lex_state = 105, .external_lex_state = 2},
  [2050] = {.lex_state = 105, .external_lex_state = 2},
  [2051] = {.lex_state = 105, .external_lex_state = 2},
  [2052] = {.lex_state = 105, .external_lex_state = 2},
  [2053] = {.lex_state = 105, .external_lex_state = 2},
  [2054] = {.lex_state = 105, .external_lex_state = 2},
  [2055] = {.lex_state = 105, .external_lex_state = 2},
  [2056] = {.lex_state = 105, .external_lex_state = 2},
  [2057] = {.lex_state = 105, .external_lex_state = 2},
  [2058] = {.lex_state = 105, .external_lex_state = 2},
  [2059] = {.lex_state = 105, .external_lex_state = 2},
  [2060] = {.lex_state = 105, .external_lex_state = 2},
  [2061] = {.lex_state = 105, .external_lex_state = 2},
  [2062] = {.lex_state = 105, .external_lex_state = 2},
  [2063] = {.lex_state = 105, .external_lex_state = 2},
  [2064] = {.lex_state = 105, .external_lex_state = 2},
  [2065] = {.lex_state = 105, .external_lex_state = 2},
  [2066] = {.lex_state = 105, .external_lex_state = 2},
  [2067] = {.lex_state = 105, .external_lex_state = 2},
  [2068] = {.lex_state = 105, .external_lex_state = 2},
  [2069] = {.lex_state = 105, .external_lex_state = 2},
  [2070] = {.lex_state = 105, .external_lex_state = 2},
  [2071] = {.lex_state = 105, .external_lex_state = 2},
  [2072] = {.lex_state = 105, .external_lex_state = 2},
  [2073] = {.lex_state = 105, .external_lex_state = 2},
  [2074] = {.lex_state = 105, .external_lex_state = 2},
  [2075] = {.lex_state = 105, .external_lex_state = 2},
  [2076] = {.lex_state = 105, .external_lex_state = 2},
  [2077] = {.lex_state = 105, .external_lex_state = 2},
  [2078] = {.lex_state = 105, .external_lex_state = 2},
  [2079] = {.lex_state = 105, .external_lex_state = 2},
  [2080] = {.lex_state = 105, .external_lex_state = 2},
  [2081] = {.lex_state = 105, .external_lex_state = 2},
  [2082] = {.lex_state = 105, .external_lex_state = 2},
  [2083] = {.lex_state = 105, .external_lex_state = 2},
  [2084] = {.lex_state = 105, .external_lex_state = 2},
  [2085] = {.lex_state = 105, .external_lex_state = 2},
  [2086] = {.lex_state = 105, .external_lex_state = 2},
  [2087] = {.lex_state = 105, .external_lex_state = 2},
  [2088] = {.lex_state = 105, .external_lex_state = 2},
  [2089] = {.lex_state = 105, .external_lex_state = 2},
  [2090] = {.lex_state = 105, .external_lex_state = 2},
  [2091] = {.lex_state = 105, .external_lex_state = 2},
  [2092] = {.lex_state = 105, .external_lex_state = 2},
  [2093] = {.lex_state = 105, .external_lex_state = 2},
  [2094] = {.lex_state = 105, .external_lex_state = 2},
  [2095] = {.lex_state = 105, .external_lex_state = 2},
  [2096] = {.lex_state = 105, .external_lex_state = 2},
  [2097] = {.lex_state = 105, .external_lex_state = 2},
  [2098] = {.lex_state = 105, .external_lex_state = 2},
  [2099] = {.lex_state = 105, .external_lex_state = 2},
  [2100] = {.lex_state = 105, .external_lex_state = 2},
  [2101] = {.lex_state = 105, .external_lex_state = 2},
  [2102] = {.lex_state = 105, .external_lex_state = 2},
  [2103] = {.lex_state = 105, .external_lex_state = 2},
  [2104] = {.lex_state = 105, .external_lex_state = 2},
  [2105] = {.lex_state = 105, .external_lex_state = 2},
  [2106] = {.lex_state = 105, .external_lex_state = 2},
  [2107] = {.lex_state = 105, .external_lex_state = 2},
  [2108] = {.lex_state = 105, .external_lex_state = 2},
  [2109] = {.lex_state = 105, .external_lex_state = 2},
  [2110] = {.lex_state = 105, .external_lex_state = 2},
  [2111] = {.lex_state = 105, .external_lex_state = 2},
  [2112] = {.lex_state = 105, .external_lex_state = 2},
  [2113] = {.lex_state = 105, .external_lex_state = 2},
  [2114] = {.lex_state = 105, .external_lex_state = 2},
  [2115] = {.lex_state = 105, .external_lex_state = 2},
  [2116] = {.lex_state = 105, .external_lex_state = 2},
  [2117] = {.lex_state = 105, .external_lex_state = 2},
  [2118] = {.lex_state = 105, .external_lex_state = 2},
  [2119] = {.lex_state = 105, .external_lex_state = 2},
  [2120] = {.lex_state = 105, .external_lex_state = 2},
  [2121] = {.lex_state = 105, .external_lex_state = 2},
  [2122] = {.lex_state = 105, .external_lex_state = 2},
  [2123] = {.lex_state = 105, .external_lex_state = 2},
  [2124] = {.lex_state = 105, .external_lex_state = 2},
  [2125] = {.lex_state = 105, .external_lex_state = 2},
  [2126] = {.lex_state = 105, .external_lex_state = 2},
  [2127] = {.lex_state = 105, .external_lex_state = 2},
  [2128] = {.lex_state = 105, .external_lex_state = 2},
  [2129] = {.lex_state = 105, .external_lex_state = 2},
  [2130] = {.lex_state = 105, .external_lex_state = 2},
  [2131] = {.lex_state = 105, .external_lex_state = 2},
  [2132] = {.lex_state = 105, .external_lex_state = 2},
  [2133] = {.lex_state = 105, .external_lex_state = 2},
  [2134] = {.lex_state = 105, .external_lex_state = 2},
  [2135] = {.lex_state = 105, .external_lex_state = 2},
  [2136] = {.lex_state = 105, .external_lex_state = 2},
  [2137] = {.lex_state = 105, .external_lex_state = 2},
  [2138] = {.lex_state = 105, .external_lex_state = 2},
  [2139] = {.lex_state = 105, .external_lex_state = 2},
  [2140] = {.lex_state = 105, .external_lex_state = 2},
  [2141] = {.lex_state = 105, .external_lex_state = 2},
  [2142] = {.lex_state = 105, .external_lex_state = 2},
  [2143] = {.lex_state = 105, .external_lex_state = 2},
  [2144] = {.lex_state = 105, .external_lex_state = 2},
  [2145] = {.lex_state = 105, .external_lex_state = 2},
  [2146] = {.lex_state = 105, .external_lex_state = 2},
  [2147] = {.lex_state = 105, .external_lex_state = 2},
  [2148] = {.lex_state = 105, .external_lex_state = 2},
  [2149] = {.lex_state = 105, .external_lex_state = 2},
  [2150] = {.lex_state = 105, .external_lex_state = 2},
  [2151] = {.lex_state = 105, .external_lex_state = 2},
  [2152] = {.lex_state = 105, .external_lex_state = 2},
  [2153] = {.lex_state = 105, .external_lex_state = 2},
  [2154] = {.lex_state = 105, .external_lex_state = 2},
  [2155] = {.lex_state = 105, .external_lex_state = 2},
  [2156] = {.lex_state = 105, .external_lex_state = 2},
  [2157] = {.lex_state = 105, .external_lex_state = 2},
  [2158] = {.lex_state = 105, .external_lex_state = 2},
  [2159] = {.lex_state = 105, .external_lex_state = 2},
  [2160] = {.lex_state = 105, .external_lex_state = 2},
  [2161] = {.lex_state = 105, .external_lex_state = 2},
  [2162] = {.lex_state = 105, .external_lex_state = 2},
  [2163] = {.lex_state = 105, .external_lex_state = 2},
  [2164] = {.lex_state = 105, .external_lex_state = 2},
  [2165] = {.lex_state = 105, .external_lex_state = 2},
  [2166] = {.lex_state = 105, .external_lex_state = 2},
  [2167] = {.lex_state = 105, .external_lex_state = 2},
  [2168] = {.lex_state = 105, .external_lex_state = 2},
  [2169] = {.lex_state = 105, .external_lex_state = 2},
  [2170] = {.lex_state = 105, .external_lex_state = 2},
  [2171] = {.lex_state = 105, .external_lex_state = 2},
  [2172] = {.lex_state = 105, .external_lex_state = 2},
  [2173] = {.lex_state = 105, .external_lex_state = 2},
  [2174] = {.lex_state = 105, .external_lex_state = 2},
  [2175] = {.lex_state = 105, .external_lex_state = 2},
  [2176] = {.lex_state = 105, .external_lex_state = 2},
  [2177] = {.lex_state = 105, .external_lex_state = 2},
  [2178] = {.lex_state = 105, .external_lex_state = 2},
  [2179] = {.lex_state = 105, .external_lex_state = 2},
  [2180] = {.lex_state = 105, .external_lex_state = 2},
  [2181] = {.lex_state = 105, .external_lex_state = 2},
  [2182] = {.lex_state = 105, .external_lex_state = 2},
  [2183] = {.lex_state = 105, .external_lex_state = 2},
  [2184] = {.lex_state = 105, .external_lex_state = 2},
  [2185] = {.lex_state = 105, .external_lex_state = 2},
  [2186] = {.lex_state = 105, .external_lex_state = 2},
  [2187] = {.lex_state = 105, .external_lex_state = 2},
  [2188] = {.lex_state = 105, .external_lex_state = 2},
  [2189] = {.lex_state = 105, .external_lex_state = 2},
  [2190] = {.lex_state = 105, .external_lex_state = 2},
  [2191] = {.lex_state = 105, .external_lex_state = 2},
  [2192] = {.lex_state = 105, .external_lex_state = 2},
  [2193] = {.lex_state = 105, .external_lex_state = 2},
  [2194] = {.lex_state = 105, .external_lex_state = 2},
  [2195] = {.lex_state = 105, .external_lex_state = 2},
  [2196] = {.lex_state = 105, .external_lex_state = 2},
  [2197] = {.lex_state = 105, .external_lex_state = 2},
  [2198] = {.lex_state = 105, .external_lex_state = 2},
  [2199] = {.lex_state = 105, .external_lex_state = 2},
  [2200] = {.lex_state = 105, .external_lex_state = 2},
  [2201] = {.lex_state = 105, .external_lex_state = 2},
  [2202] = {.lex_state = 105, .external_lex_state = 2},
  [2203] = {.lex_state = 105, .external_lex_state = 2},
  [2204] = {.lex_state = 104, .external_lex_state = 2},
  [2205] = {.lex_state = 104, .external_lex_state = 2},
  [2206] = {.lex_state = 104, .external_lex_state = 2},
  [2207] = {.lex_state = 104, .external_lex_state = 2},
  [2208] = {.lex_state = 104, .external_lex_state = 2},
  [2209] = {.lex_state = 104, .external_lex_state = 2},
  [2210] = {.lex_state = 105, .external_lex_state = 2},
  [2211] = {.lex_state = 105, .external_lex_state = 2},
  [2212] = {.lex_state = 105, .external_lex_state = 2},
  [2213] = {.lex_state = 105, .external_lex_state = 2},
  [2214] = {.lex_state = 105, .external_lex_state = 2},
  [2215] = {.lex_state = 105, .external_lex_state = 2},
  [2216] = {.lex_state = 105, .external_lex_state = 2},
  [2217] = {.lex_state = 105, .external_lex_state = 2},
  [2218] = {.lex_state = 105, .external_lex_state = 2},
  [2219] = {.lex_state = 105, .external_lex_state = 2},
  [2220] = {.lex_state = 105, .external_lex_state = 2},
  [2221] = {.lex_state = 105, .external_lex_state = 2},
  [2222] = {.lex_state = 105, .external_lex_state = 2},
  [2223] = {.lex_state = 105, .external_lex_state = 2},
  [2224] = {.lex_state = 105, .external_lex_state = 2},
  [2225] = {.lex_state = 105, .external_lex_state = 2},
  [2226] = {.lex_state = 105, .external_lex_state = 2},
  [2227] = {.lex_state = 105, .external_lex_state = 2},
  [2228] = {.lex_state = 105, .external_lex_state = 2},
  [2229] = {.lex_state = 105, .external_lex_state = 2},
  [2230] = {.lex_state = 105, .external_lex_state = 2},
  [2231] = {.lex_state = 105, .external_lex_state = 2},
  [2232] = {.lex_state = 105, .external_lex_state = 2},
  [2233] = {.lex_state = 105, .external_lex_state = 2},
  [2234] = {.lex_state = 105, .external_lex_state = 2},
  [2235] = {.lex_state = 105, .external_lex_state = 2},
  [2236] = {.lex_state = 105, .external_lex_state = 2},
  [2237] = {.lex_state = 105, .external_lex_state = 2},
  [2238] = {.lex_state = 105, .external_lex_state = 2},
  [2239] = {.lex_state = 105, .external_lex_state = 2},
  [2240] = {.lex_state = 105, .external_lex_state = 2},
  [2241] = {.lex_state = 105},
  [2242] = {.lex_state = 105, .external_lex_state = 2},
  [2243] = {.lex_state = 105, .external_lex_state = 2},
  [2244] = {.lex_state = 105, .external_lex_state = 2},
  [2245] = {.lex_state = 105, .external_lex_state = 2},
  [2246] = {.lex_state = 105, .external_lex_state = 2},
  [2247] = {.lex_state = 105, .external_lex_state = 2},
  [2248] = {.lex_state = 105, .external_lex_state = 2},
  [2249] = {.lex_state = 105, .external_lex_state = 2},
  [2250] = {.lex_state = 105, .external_lex_state = 2},
  [2251] = {.lex_state = 105, .external_lex_state = 2},
  [2252] = {.lex_state = 105, .external_lex_state = 2},
  [2253] = {.lex_state = 105, .external_lex_state = 2},
  [2254] = {.lex_state = 105, .external_lex_state = 2},
  [2255] = {.lex_state = 105, .external_lex_state = 2},
  [2256] = {.lex_state = 105, .external_lex_state = 2},
  [2257] = {.lex_state = 105, .external_lex_state = 2},
  [2258] = {.lex_state = 105, .external_lex_state = 2},
  [2259] = {.lex_state = 105, .external_lex_state = 2},
  [2260] = {.lex_state = 105, .external_lex_state = 2},
  [2261] = {.lex_state = 105, .external_lex_state = 2},
  [2262] = {.lex_state = 105, .external_lex_state = 2},
  [2263] = {.lex_state = 105, .external_lex_state = 2},
  [2264] = {.lex_state = 105, .external_lex_state = 2},
  [2265] = {.lex_state = 105, .external_lex_state = 2},
  [2266] = {.lex_state = 105, .external_lex_state = 2},
  [2267] = {.lex_state = 105, .external_lex_state = 2},
  [2268] = {.lex_state = 105},
  [2269] = {.lex_state = 105, .external_lex_state = 2},
  [2270] = {.lex_state = 105},
  [2271] = {.lex_state = 105, .external_lex_state = 2},
  [2272] = {.lex_state = 105, .external_lex_state = 2},
  [2273] = {.lex_state = 105, .external_lex_state = 2},
  [2274] = {.lex_state = 105, .external_lex_state = 2},
  [2275] = {.lex_state = 105, .external_lex_state = 2},
  [2276] = {.lex_state = 105, .external_lex_state = 2},
  [2277] = {.lex_state = 105, .external_lex_state = 2},
  [2278] = {.lex_state = 105, .external_lex_state = 2},
  [2279] = {.lex_state = 105, .external_lex_state = 2},
  [2280] = {.lex_state = 105, .external_lex_state = 2},
  [2281] = {.lex_state = 105, .external_lex_state = 2},
  [2282] = {.lex_state = 105, .external_lex_state = 2},
  [2283] = {.lex_state = 105, .external_lex_state = 2},
  [2284] = {.lex_state = 105, .external_lex_state = 2},
  [2285] = {.lex_state = 105, .external_lex_state = 2},
  [2286] = {.lex_state = 105, .external_lex_state = 2},
  [2287] = {.lex_state = 105, .external_lex_state = 2},
  [2288] = {.lex_state = 105, .external_lex_state = 2},
  [2289] = {.lex_state = 105, .external_lex_state = 2},
  [2290] = {.lex_state = 105, .external_lex_state = 2},
  [2291] = {.lex_state = 105, .external_lex_state = 2},
  [2292] = {.lex_state = 105, .external_lex_state = 2},
  [2293] = {.lex_state = 105, .external_lex_state = 2},
  [2294] = {.lex_state = 105, .external_lex_state = 2},
  [2295] = {.lex_state = 105, .external_lex_state = 2},
  [2296] = {.lex_state = 105, .external_lex_state = 2},
  [2297] = {.lex_state = 105, .external_lex_state = 2},
  [2298] = {.lex_state = 105, .external_lex_state = 2},
  [2299] = {.lex_state = 105, .external_lex_state = 2},
  [2300] = {.lex_state = 105, .external_lex_state = 2},
  [2301] = {.lex_state = 105, .external_lex_state = 2},
  [2302] = {.lex_state = 105, .external_lex_state = 2},
  [2303] = {.lex_state = 105, .external_lex_state = 2},
  [2304] = {.lex_state = 105, .external_lex_state = 2},
  [2305] = {.lex_state = 105},
  [2306] = {.lex_state = 105, .external_lex_state = 2},
  [2307] = {.lex_state = 105, .external_lex_state = 2},
  [2308] = {.lex_state = 105, .external_lex_state = 2},
  [2309] = {.lex_state = 105, .external_lex_state = 2},
  [2310] = {.lex_state = 105, .external_lex_state = 2},
  [2311] = {.lex_state = 105, .external_lex_state = 2},
  [2312] = {.lex_state = 105, .external_lex_state = 2},
  [2313] = {.lex_state = 105, .external_lex_state = 2},
  [2314] = {.lex_state = 105, .external_lex_state = 2},
  [2315] = {.lex_state = 105, .external_lex_state = 2},
  [2316] = {.lex_state = 105, .external_lex_state = 2},
  [2317] = {.lex_state = 105, .external_lex_state = 2},
  [2318] = {.lex_state = 105, .external_lex_state = 2},
  [2319] = {.lex_state = 105, .external_lex_state = 2},
  [2320] = {.lex_state = 105, .external_lex_state = 2},
  [2321] = {.lex_state = 105, .external_lex_state = 2},
  [2322] = {.lex_state = 105, .external_lex_state = 2},
  [2323] = {.lex_state = 105, .external_lex_state = 2},
  [2324] = {.lex_state = 105, .external_lex_state = 2},
  [2325] = {.lex_state = 105, .external_lex_state = 2},
  [2326] = {.lex_state = 105, .external_lex_state = 2},
  [2327] = {.lex_state = 105, .external_lex_state = 2},
  [2328] = {.lex_state = 105, .external_lex_state = 2},
  [2329] = {.lex_state = 105, .external_lex_state = 2},
  [2330] = {.lex_state = 105, .external_lex_state = 2},
  [2331] = {.lex_state = 105, .external_lex_state = 2},
  [2332] = {.lex_state = 105, .external_lex_state = 2},
  [2333] = {.lex_state = 105, .external_lex_state = 2},
  [2334] = {.lex_state = 105, .external_lex_state = 2},
  [2335] = {.lex_state = 105, .external_lex_state = 2},
  [2336] = {.lex_state = 105, .external_lex_state = 2},
  [2337] = {.lex_state = 105, .external_lex_state = 2},
  [2338] = {.lex_state = 105, .external_lex_state = 2},
  [2339] = {.lex_state = 105, .external_lex_state = 2},
  [2340] = {.lex_state = 105, .external_lex_state = 2},
  [2341] = {.lex_state = 105, .external_lex_state = 2},
  [2342] = {.lex_state = 105, .external_lex_state = 2},
  [2343] = {.lex_state = 105, .external_lex_state = 2},
  [2344] = {.lex_state = 105, .external_lex_state = 2},
  [2345] = {.lex_state = 105, .external_lex_state = 2},
  [2346] = {.lex_state = 105, .external_lex_state = 2},
  [2347] = {.lex_state = 105, .external_lex_state = 2},
  [2348] = {.lex_state = 105, .external_lex_state = 2},
  [2349] = {.lex_state = 105, .external_lex_state = 2},
  [2350] = {.lex_state = 105, .external_lex_state = 2},
  [2351] = {.lex_state = 105, .external_lex_state = 2},
  [2352] = {.lex_state = 105, .external_lex_state = 2},
  [2353] = {.lex_state = 105, .external_lex_state = 2},
  [2354] = {.lex_state = 105, .external_lex_state = 2},
  [2355] = {.lex_state = 105, .external_lex_state = 2},
  [2356] = {.lex_state = 105, .external_lex_state = 2},
  [2357] = {.lex_state = 105, .external_lex_state = 2},
  [2358] = {.lex_state = 105, .external_lex_state = 2},
  [2359] = {.lex_state = 105, .external_lex_state = 2},
  [2360] = {.lex_state = 105, .external_lex_state = 2},
  [2361] = {.lex_state = 105, .external_lex_state = 2},
  [2362] = {.lex_state = 105, .external_lex_state = 2},
  [2363] = {.lex_state = 105, .external_lex_state = 2},
  [2364] = {.lex_state = 105, .external_lex_state = 2},
  [2365] = {.lex_state = 105, .external_lex_state = 2},
  [2366] = {.lex_state = 105, .external_lex_state = 2},
  [2367] = {.lex_state = 105, .external_lex_state = 2},
  [2368] = {.lex_state = 105, .external_lex_state = 2},
  [2369] = {.lex_state = 105, .external_lex_state = 2},
  [2370] = {.lex_state = 105, .external_lex_state = 2},
  [2371] = {.lex_state = 105, .external_lex_state = 2},
  [2372] = {.lex_state = 105, .external_lex_state = 2},
  [2373] = {.lex_state = 105, .external_lex_state = 2},
  [2374] = {.lex_state = 105, .external_lex_state = 2},
  [2375] = {.lex_state = 105, .external_lex_state = 2},
  [2376] = {.lex_state = 105, .external_lex_state = 2},
  [2377] = {.lex_state = 105, .external_lex_state = 2},
  [2378] = {.lex_state = 105, .external_lex_state = 2},
  [2379] = {.lex_state = 105, .external_lex_state = 2},
  [2380] = {.lex_state = 105, .external_lex_state = 2},
  [2381] = {.lex_state = 105, .external_lex_state = 2},
  [2382] = {.lex_state = 105, .external_lex_state = 2},
  [2383] = {.lex_state = 105, .external_lex_state = 2},
  [2384] = {.lex_state = 105, .external_lex_state = 2},
  [2385] = {.lex_state = 105, .external_lex_state = 2},
  [2386] = {.lex_state = 105, .external_lex_state = 2},
  [2387] = {.lex_state = 105, .external_lex_state = 2},
  [2388] = {.lex_state = 105, .external_lex_state = 2},
  [2389] = {.lex_state = 105, .external_lex_state = 2},
  [2390] = {.lex_state = 105, .external_lex_state = 2},
  [2391] = {.lex_state = 105, .external_lex_state = 2},
  [2392] = {.lex_state = 105, .external_lex_state = 2},
  [2393] = {.lex_state = 105, .external_lex_state = 2},
  [2394] = {.lex_state = 105, .external_lex_state = 2},
  [2395] = {.lex_state = 105, .external_lex_state = 2},
  [2396] = {.lex_state = 105, .external_lex_state = 2},
  [2397] = {.lex_state = 105, .external_lex_state = 2},
  [2398] = {.lex_state = 105, .external_lex_state = 2},
  [2399] = {.lex_state = 105, .external_lex_state = 2},
  [2400] = {.lex_state = 105, .external_lex_state = 2},
  [2401] = {.lex_state = 105, .external_lex_state = 2},
  [2402] = {.lex_state = 105, .external_lex_state = 2},
  [2403] = {.lex_state = 105, .external_lex_state = 2},
  [2404] = {.lex_state = 105, .external_lex_state = 2},
  [2405] = {.lex_state = 105, .external_lex_state = 2},
  [2406] = {.lex_state = 105, .external_lex_state = 2},
  [2407] = {.lex_state = 105, .external_lex_state = 2},
  [2408] = {.lex_state = 105, .external_lex_state = 2},
  [2409] = {.lex_state = 105, .external_lex_state = 2},
  [2410] = {.lex_state = 105, .external_lex_state = 2},
  [2411] = {.lex_state = 105, .external_lex_state = 2},
  [2412] = {.lex_state = 105, .external_lex_state = 2},
  [2413] = {.lex_state = 105, .external_lex_state = 2},
  [2414] = {.lex_state = 105, .external_lex_state = 2},
  [2415] = {.lex_state = 105, .external_lex_state = 2},
  [2416] = {.lex_state = 105, .external_lex_state = 2},
  [2417] = {.lex_state = 105, .external_lex_state = 2},
  [2418] = {.lex_state = 105, .external_lex_state = 2},
  [2419] = {.lex_state = 105, .external_lex_state = 2},
  [2420] = {.lex_state = 105, .external_lex_state = 2},
  [2421] = {.lex_state = 105, .external_lex_state = 2},
  [2422] = {.lex_state = 105, .external_lex_state = 2},
  [2423] = {.lex_state = 105},
  [2424] = {.lex_state = 105, .external_lex_state = 2},
  [2425] = {.lex_state = 105, .external_lex_state = 2},
  [2426] = {.lex_state = 105, .external_lex_state = 2},
  [2427] = {.lex_state = 105, .external_lex_state = 2},
  [2428] = {.lex_state = 105, .external_lex_state = 2},
  [2429] = {.lex_state = 105, .external_lex_state = 2},
  [2430] = {.lex_state = 105, .external_lex_state = 2},
  [2431] = {.lex_state = 105, .external_lex_state = 2},
  [2432] = {.lex_state = 105, .external_lex_state = 2},
  [2433] = {.lex_state = 105, .external_lex_state = 2},
  [2434] = {.lex_state = 105, .external_lex_state = 2},
  [2435] = {.lex_state = 105, .external_lex_state = 2},
  [2436] = {.lex_state = 105, .external_lex_state = 2},
  [2437] = {.lex_state = 105, .external_lex_state = 2},
  [2438] = {.lex_state = 105, .external_lex_state = 2},
  [2439] = {.lex_state = 105, .external_lex_state = 2},
  [2440] = {.lex_state = 105, .external_lex_state = 2},
  [2441] = {.lex_state = 105, .external_lex_state = 2},
  [2442] = {.lex_state = 105, .external_lex_state = 2},
  [2443] = {.lex_state = 105, .external_lex_state = 2},
  [2444] = {.lex_state = 105, .external_lex_state = 2},
  [2445] = {.lex_state = 105, .external_lex_state = 2},
  [2446] = {.lex_state = 105, .external_lex_state = 2},
  [2447] = {.lex_state = 105, .external_lex_state = 2},
  [2448] = {.lex_state = 105, .external_lex_state = 2},
  [2449] = {.lex_state = 105, .external_lex_state = 2},
  [2450] = {.lex_state = 105, .external_lex_state = 2},
  [2451] = {.lex_state = 105, .external_lex_state = 2},
  [2452] = {.lex_state = 105, .external_lex_state = 2},
  [2453] = {.lex_state = 105, .external_lex_state = 2},
  [2454] = {.lex_state = 105, .external_lex_state = 2},
  [2455] = {.lex_state = 105, .external_lex_state = 2},
  [2456] = {.lex_state = 4},
  [2457] = {.lex_state = 105, .external_lex_state = 2},
  [2458] = {.lex_state = 105, .external_lex_state = 2},
  [2459] = {.lex_state = 105, .external_lex_state = 2},
  [2460] = {.lex_state = 105, .external_lex_state = 2},
  [2461] = {.lex_state = 105, .external_lex_state = 2},
  [2462] = {.lex_state = 105, .external_lex_state = 2},
  [2463] = {.lex_state = 105, .external_lex_state = 2},
  [2464] = {.lex_state = 105, .external_lex_state = 2},
  [2465] = {.lex_state = 105, .external_lex_state = 2},
  [2466] = {.lex_state = 105, .external_lex_state = 2},
  [2467] = {.lex_state = 105, .external_lex_state = 2},
  [2468] = {.lex_state = 105, .external_lex_state = 2},
  [2469] = {.lex_state = 105, .external_lex_state = 2},
  [2470] = {.lex_state = 105, .external_lex_state = 2},
  [2471] = {.lex_state = 105, .external_lex_state = 2},
  [2472] = {.lex_state = 105, .external_lex_state = 2},
  [2473] = {.lex_state = 105, .external_lex_state = 2},
  [2474] = {.lex_state = 105, .external_lex_state = 2},
  [2475] = {.lex_state = 105, .external_lex_state = 2},
  [2476] = {.lex_state = 105, .external_lex_state = 2},
  [2477] = {.lex_state = 105, .external_lex_state = 2},
  [2478] = {.lex_state = 105, .external_lex_state = 2},
  [2479] = {.lex_state = 105, .external_lex_state = 2},
  [2480] = {.lex_state = 105, .external_lex_state = 2},
  [2481] = {.lex_state = 105, .external_lex_state = 2},
  [2482] = {.lex_state = 105, .external_lex_state = 2},
  [2483] = {.lex_state = 105, .external_lex_state = 2},
  [2484] = {.lex_state = 105, .external_lex_state = 2},
  [2485] = {.lex_state = 105, .external_lex_state = 2},
  [2486] = {.lex_state = 105, .external_lex_state = 2},
  [2487] = {.lex_state = 105, .external_lex_state = 2},
  [2488] = {.lex_state = 105, .external_lex_state = 2},
  [2489] = {.lex_state = 105, .external_lex_state = 2},
  [2490] = {.lex_state = 105, .external_lex_state = 2},
  [2491] = {.lex_state = 105, .external_lex_state = 2},
  [2492] = {.lex_state = 105, .external_lex_state = 2},
  [2493] = {.lex_state = 105, .external_lex_state = 2},
  [2494] = {.lex_state = 105, .external_lex_state = 2},
  [2495] = {.lex_state = 105, .external_lex_state = 2},
  [2496] = {.lex_state = 105, .external_lex_state = 2},
  [2497] = {.lex_state = 105, .external_lex_state = 2},
  [2498] = {.lex_state = 105, .external_lex_state = 2},
  [2499] = {.lex_state = 105, .external_lex_state = 2},
  [2500] = {.lex_state = 105, .external_lex_state = 2},
  [2501] = {.lex_state = 105, .external_lex_state = 2},
  [2502] = {.lex_state = 105, .external_lex_state = 2},
  [2503] = {.lex_state = 105, .external_lex_state = 2},
  [2504] = {.lex_state = 105, .external_lex_state = 2},
  [2505] = {.lex_state = 105, .external_lex_state = 2},
  [2506] = {.lex_state = 105, .external_lex_state = 2},
  [2507] = {.lex_state = 105, .external_lex_state = 2},
  [2508] = {.lex_state = 105, .external_lex_state = 2},
  [2509] = {.lex_state = 105, .external_lex_state = 2},
  [2510] = {.lex_state = 105, .external_lex_state = 2},
  [2511] = {.lex_state = 105, .external_lex_state = 2},
  [2512] = {.lex_state = 105, .external_lex_state = 2},
  [2513] = {.lex_state = 105, .external_lex_state = 2},
  [2514] = {.lex_state = 105, .external_lex_state = 2},
  [2515] = {.lex_state = 105, .external_lex_state = 2},
  [2516] = {.lex_state = 105, .external_lex_state = 2},
  [2517] = {.lex_state = 105, .external_lex_state = 2},
  [2518] = {.lex_state = 105, .external_lex_state = 2},
  [2519] = {.lex_state = 105, .external_lex_state = 2},
  [2520] = {.lex_state = 105, .external_lex_state = 2},
  [2521] = {.lex_state = 105, .external_lex_state = 2},
  [2522] = {.lex_state = 105, .external_lex_state = 2},
  [2523] = {.lex_state = 105, .external_lex_state = 2},
  [2524] = {.lex_state = 105, .external_lex_state = 2},
  [2525] = {.lex_state = 105, .external_lex_state = 2},
  [2526] = {.lex_state = 105, .external_lex_state = 2},
  [2527] = {.lex_state = 105, .external_lex_state = 2},
  [2528] = {.lex_state = 105, .external_lex_state = 2},
  [2529] = {.lex_state = 105, .external_lex_state = 2},
  [2530] = {.lex_state = 105, .external_lex_state = 2},
  [2531] = {.lex_state = 105, .external_lex_state = 2},
  [2532] = {.lex_state = 105, .external_lex_state = 2},
  [2533] = {.lex_state = 105, .external_lex_state = 2},
  [2534] = {.lex_state = 105, .external_lex_state = 2},
  [2535] = {.lex_state = 105, .external_lex_state = 2},
  [2536] = {.lex_state = 105, .external_lex_state = 2},
  [2537] = {.lex_state = 105, .external_lex_state = 2},
  [2538] = {.lex_state = 105, .external_lex_state = 2},
  [2539] = {.lex_state = 105, .external_lex_state = 2},
  [2540] = {.lex_state = 105, .external_lex_state = 2},
  [2541] = {.lex_state = 105, .external_lex_state = 2},
  [2542] = {.lex_state = 105, .external_lex_state = 2},
  [2543] = {.lex_state = 105, .external_lex_state = 2},
  [2544] = {.lex_state = 105, .external_lex_state = 2},
  [2545] = {.lex_state = 105, .external_lex_state = 2},
  [2546] = {.lex_state = 105, .external_lex_state = 2},
  [2547] = {.lex_state = 105, .external_lex_state = 2},
  [2548] = {.lex_state = 105, .external_lex_state = 2},
  [2549] = {.lex_state = 105, .external_lex_state = 2},
  [2550] = {.lex_state = 105, .external_lex_state = 2},
  [2551] = {.lex_state = 105, .external_lex_state = 2},
  [2552] = {.lex_state = 105, .external_lex_state = 2},
  [2553] = {.lex_state = 105, .external_lex_state = 2},
  [2554] = {.lex_state = 105, .external_lex_state = 2},
  [2555] = {.lex_state = 105, .external_lex_state = 2},
  [2556] = {.lex_state = 105, .external_lex_state = 2},
  [2557] = {.lex_state = 105, .external_lex_state = 2},
  [2558] = {.lex_state = 105, .external_lex_state = 2},
  [2559] = {.lex_state = 105, .external_lex_state = 2},
  [2560] = {.lex_state = 105, .external_lex_state = 2},
  [2561] = {.lex_state = 105, .external_lex_state = 2},
  [2562] = {.lex_state = 105, .external_lex_state = 2},
  [2563] = {.lex_state = 105, .external_lex_state = 2},
  [2564] = {.lex_state = 105, .external_lex_state = 2},
  [2565] = {.lex_state = 105, .external_lex_state = 2},
  [2566] = {.lex_state = 105, .external_lex_state = 2},
  [2567] = {.lex_state = 105, .external_lex_state = 2},
  [2568] = {.lex_state = 105, .external_lex_state = 2},
  [2569] = {.lex_state = 105, .external_lex_state = 2},
  [2570] = {.lex_state = 105, .external_lex_state = 2},
  [2571] = {.lex_state = 105, .external_lex_state = 2},
  [2572] = {.lex_state = 105, .external_lex_state = 2},
  [2573] = {.lex_state = 105, .external_lex_state = 2},
  [2574] = {.lex_state = 105, .external_lex_state = 2},
  [2575] = {.lex_state = 105, .external_lex_state = 2},
  [2576] = {.lex_state = 105, .external_lex_state = 2},
  [2577] = {.lex_state = 105, .external_lex_state = 2},
  [2578] = {.lex_state = 105, .external_lex_state = 2},
  [2579] = {.lex_state = 105, .external_lex_state = 2},
  [2580] = {.lex_state = 105, .external_lex_state = 2},
  [2581] = {.lex_state = 105, .external_lex_state = 2},
  [2582] = {.lex_state = 105, .external_lex_state = 2},
  [2583] = {.lex_state = 105, .external_lex_state = 2},
  [2584] = {.lex_state = 105, .external_lex_state = 2},
  [2585] = {.lex_state = 105, .external_lex_state = 2},
  [2586] = {.lex_state = 105, .external_lex_state = 2},
  [2587] = {.lex_state = 105, .external_lex_state = 2},
  [2588] = {.lex_state = 105, .external_lex_state = 2},
  [2589] = {.lex_state = 105, .external_lex_state = 2},
  [2590] = {.lex_state = 105, .external_lex_state = 2},
  [2591] = {.lex_state = 105, .external_lex_state = 2},
  [2592] = {.lex_state = 105, .external_lex_state = 2},
  [2593] = {.lex_state = 105, .external_lex_state = 2},
  [2594] = {.lex_state = 105, .external_lex_state = 2},
  [2595] = {.lex_state = 105, .external_lex_state = 2},
  [2596] = {.lex_state = 105, .external_lex_state = 2},
  [2597] = {.lex_state = 105, .external_lex_state = 2},
  [2598] = {.lex_state = 105, .external_lex_state = 2},
  [2599] = {.lex_state = 105, .external_lex_state = 2},
  [2600] = {.lex_state = 105, .external_lex_state = 2},
  [2601] = {.lex_state = 105, .external_lex_state = 2},
  [2602] = {.lex_state = 105, .external_lex_state = 2},
  [2603] = {.lex_state = 105, .external_lex_state = 2},
  [2604] = {.lex_state = 105, .external_lex_state = 2},
  [2605] = {.lex_state = 105, .external_lex_state = 2},
  [2606] = {.lex_state = 105, .external_lex_state = 2},
  [2607] = {.lex_state = 105, .external_lex_state = 2},
  [2608] = {.lex_state = 105, .external_lex_state = 2},
  [2609] = {.lex_state = 105, .external_lex_state = 2},
  [2610] = {.lex_state = 105, .external_lex_state = 2},
  [2611] = {.lex_state = 105, .external_lex_state = 2},
  [2612] = {.lex_state = 105, .external_lex_state = 2},
  [2613] = {.lex_state = 105, .external_lex_state = 2},
  [2614] = {.lex_state = 105, .external_lex_state = 2},
  [2615] = {.lex_state = 105, .external_lex_state = 2},
  [2616] = {.lex_state = 105, .external_lex_state = 2},
  [2617] = {.lex_state = 105, .external_lex_state = 2},
  [2618] = {.lex_state = 105, .external_lex_state = 2},
  [2619] = {.lex_state = 105, .external_lex_state = 2},
  [2620] = {.lex_state = 105, .external_lex_state = 2},
  [2621] = {.lex_state = 105, .external_lex_state = 2},
  [2622] = {.lex_state = 105, .external_lex_state = 2},
  [2623] = {.lex_state = 105, .external_lex_state = 2},
  [2624] = {.lex_state = 105, .external_lex_state = 2},
  [2625] = {.lex_state = 105, .external_lex_state = 2},
  [2626] = {.lex_state = 105, .external_lex_state = 2},
  [2627] = {.lex_state = 105, .external_lex_state = 2},
  [2628] = {.lex_state = 105, .external_lex_state = 2},
  [2629] = {.lex_state = 105, .external_lex_state = 2},
  [2630] = {.lex_state = 105, .external_lex_state = 2},
  [2631] = {.lex_state = 105, .external_lex_state = 2},
  [2632] = {.lex_state = 105, .external_lex_state = 2},
  [2633] = {.lex_state = 105, .external_lex_state = 2},
  [2634] = {.lex_state = 105, .external_lex_state = 2},
  [2635] = {.lex_state = 105, .external_lex_state = 2},
  [2636] = {.lex_state = 105, .external_lex_state = 2},
  [2637] = {.lex_state = 105, .external_lex_state = 2},
  [2638] = {.lex_state = 105, .external_lex_state = 2},
  [2639] = {.lex_state = 105, .external_lex_state = 2},
  [2640] = {.lex_state = 105, .external_lex_state = 2},
  [2641] = {.lex_state = 105, .external_lex_state = 2},
  [2642] = {.lex_state = 105, .external_lex_state = 2},
  [2643] = {.lex_state = 105, .external_lex_state = 2},
  [2644] = {.lex_state = 105, .external_lex_state = 2},
  [2645] = {.lex_state = 105},
  [2646] = {.lex_state = 105},
  [2647] = {.lex_state = 105},
  [2648] = {.lex_state = 105},
  [2649] = {.lex_state = 105, .external_lex_state = 2},
  [2650] = {.lex_state = 105, .external_lex_state = 2},
  [2651] = {.lex_state = 105, .external_lex_state = 2},
  [2652] = {.lex_state = 105, .external_lex_state = 2},
  [2653] = {.lex_state = 105, .external_lex_state = 2},
  [2654] = {.lex_state = 105, .external_lex_state = 2},
  [2655] = {.lex_state = 4},
  [2656] = {.lex_state = 105, .external_lex_state = 2},
  [2657] = {.lex_state = 105, .external_lex_state = 2},
  [2658] = {.lex_state = 105, .external_lex_state = 2},
  [2659] = {.lex_state = 105, .external_lex_state = 2},
  [2660] = {.lex_state = 105, .external_lex_state = 2},
  [2661] = {.lex_state = 105, .external_lex_state = 2},
  [2662] = {.lex_state = 105, .external_lex_state = 2},
  [2663] = {.lex_state = 105, .external_lex_state = 2},
  [2664] = {.lex_state = 105, .external_lex_state = 2},
  [2665] = {.lex_state = 105, .external_lex_state = 2},
  [2666] = {.lex_state = 105, .external_lex_state = 2},
  [2667] = {.lex_state = 105, .external_lex_state = 2},
  [2668] = {.lex_state = 105, .external_lex_state = 2},
  [2669] = {.lex_state = 105, .external_lex_state = 2},
  [2670] = {.lex_state = 105, .external_lex_state = 2},
  [2671] = {.lex_state = 105, .external_lex_state = 2},
  [2672] = {.lex_state = 105, .external_lex_state = 2},
  [2673] = {.lex_state = 105, .external_lex_state = 2},
  [2674] = {.lex_state = 105, .external_lex_state = 2},
  [2675] = {.lex_state = 105, .external_lex_state = 2},
  [2676] = {.lex_state = 105, .external_lex_state = 2},
  [2677] = {.lex_state = 105, .external_lex_state = 2},
  [2678] = {.lex_state = 105, .external_lex_state = 2},
  [2679] = {.lex_state = 105, .external_lex_state = 2},
  [2680] = {.lex_state = 105, .external_lex_state = 2},
  [2681] = {.lex_state = 105, .external_lex_state = 2},
  [2682] = {.lex_state = 105, .external_lex_state = 2},
  [2683] = {.lex_state = 105, .external_lex_state = 2},
  [2684] = {.lex_state = 105, .external_lex_state = 2},
  [2685] = {.lex_state = 105, .external_lex_state = 2},
  [2686] = {.lex_state = 105, .external_lex_state = 2},
  [2687] = {.lex_state = 105, .external_lex_state = 2},
  [2688] = {.lex_state = 105, .external_lex_state = 2},
  [2689] = {.lex_state = 105, .external_lex_state = 2},
  [2690] = {.lex_state = 105, .external_lex_state = 2},
  [2691] = {.lex_state = 105, .external_lex_state = 2},
  [2692] = {.lex_state = 105, .external_lex_state = 2},
  [2693] = {.lex_state = 105, .external_lex_state = 2},
  [2694] = {.lex_state = 105, .external_lex_state = 2},
  [2695] = {.lex_state = 105, .external_lex_state = 2},
  [2696] = {.lex_state = 105, .external_lex_state = 2},
  [2697] = {.lex_state = 105, .external_lex_state = 2},
  [2698] = {.lex_state = 105, .external_lex_state = 2},
  [2699] = {.lex_state = 105, .external_lex_state = 2},
  [2700] = {.lex_state = 105, .external_lex_state = 2},
  [2701] = {.lex_state = 105, .external_lex_state = 2},
  [2702] = {.lex_state = 105, .external_lex_state = 2},
  [2703] = {.lex_state = 105, .external_lex_state = 2},
  [2704] = {.lex_state = 105, .external_lex_state = 2},
  [2705] = {.lex_state = 105, .external_lex_state = 2},
  [2706] = {.lex_state = 105, .external_lex_state = 2},
  [2707] = {.lex_state = 105, .external_lex_state = 2},
  [2708] = {.lex_state = 105, .external_lex_state = 2},
  [2709] = {.lex_state = 105, .external_lex_state = 2},
  [2710] = {.lex_state = 105, .external_lex_state = 2},
  [2711] = {.lex_state = 105, .external_lex_state = 2},
  [2712] = {.lex_state = 105, .external_lex_state = 2},
  [2713] = {.lex_state = 105, .external_lex_state = 2},
  [2714] = {.lex_state = 105, .external_lex_state = 2},
  [2715] = {.lex_state = 105, .external_lex_state = 2},
  [2716] = {.lex_state = 105, .external_lex_state = 2},
  [2717] = {.lex_state = 105, .external_lex_state = 2},
  [2718] = {.lex_state = 105, .external_lex_state = 2},
  [2719] = {.lex_state = 105, .external_lex_state = 2},
  [2720] = {.lex_state = 105, .external_lex_state = 2},
  [2721] = {.lex_state = 105, .external_lex_state = 2},
  [2722] = {.lex_state = 105, .external_lex_state = 2},
  [2723] = {.lex_state = 105, .external_lex_state = 2},
  [2724] = {.lex_state = 105, .external_lex_state = 2},
  [2725] = {.lex_state = 105, .external_lex_state = 2},
  [2726] = {.lex_state = 105, .external_lex_state = 2},
  [2727] = {.lex_state = 105, .external_lex_state = 2},
  [2728] = {.lex_state = 105, .external_lex_state = 2},
  [2729] = {.lex_state = 105, .external_lex_state = 2},
  [2730] = {.lex_state = 105, .external_lex_state = 2},
  [2731] = {.lex_state = 105, .external_lex_state = 2},
  [2732] = {.lex_state = 4},
  [2733] = {.lex_state = 105, .external_lex_state = 2},
  [2734] = {.lex_state = 4, .external_lex_state = 4},
  [2735] = {.lex_state = 4},
  [2736] = {.lex_state = 4},
  [2737] = {.lex_state = 4},
  [2738] = {.lex_state = 4},
  [2739] = {.lex_state = 4},
  [2740] = {.lex_state = 4},
  [2741] = {.lex_state = 4},
  [2742] = {.lex_state = 4, .external_lex_state = 4},
  [2743] = {.lex_state = 4},
  [2744] = {.lex_state = 4},
  [2745] = {.lex_state = 4},
  [2746] = {.lex_state = 4},
  [2747] = {.lex_state = 5},
  [2748] = {.lex_state = 5},
  [2749] = {.lex_state = 5},
  [2750] = {.lex_state = 4, .external_lex_state = 4},
  [2751] = {.lex_state = 5},
  [2752] = {.lex_state = 5},
  [2753] = {.lex_state = 4},
  [2754] = {.lex_state = 4},
  [2755] = {.lex_state = 5},
  [2756] = {.lex_state = 4},
  [2757] = {.lex_state = 5},
  [2758] = {.lex_state = 5},
  [2759] = {.lex_state = 5},
  [2760] = {.lex_state = 5},
  [2761] = {.lex_state = 5},
  [2762] = {.lex_state = 5},
  [2763] = {.lex_state = 5},
  [2764] = {.lex_state = 4},
  [2765] = {.lex_state = 4},
  [2766] = {.lex_state = 5},
  [2767] = {.lex_state = 4, .external_lex_state = 4},
  [2768] = {.lex_state = 5},
  [2769] = {.lex_state = 5},
  [2770] = {.lex_state = 4},
  [2771] = {.lex_state = 6},
  [2772] = {.lex_state = 5},
  [2773] = {.lex_state = 6},
  [2774] = {.lex_state = 4},
  [2775] = {.lex_state = 4},
  [2776] = {.lex_state = 4},
  [2777] = {.lex_state = 4},
  [2778] = {.lex_state = 4},
  [2779] = {.lex_state = 6},
  [2780] = {.lex_state = 4},
  [2781] = {.lex_state = 105},
  [2782] = {.lex_state = 6},
  [2783] = {.lex_state = 4},
  [2784] = {.lex_state = 5},
  [2785] = {.lex_state = 4},
  [2786] = {.lex_state = 4},
  [2787] = {.lex_state = 4},
  [2788] = {.lex_state = 4, .external_lex_state = 4},
  [2789] = {.lex_state = 5},
  [2790] = {.lex_state = 4},
  [2791] = {.lex_state = 4},
  [2792] = {.lex_state = 5},
  [2793] = {.lex_state = 4},
  [2794] = {.lex_state = 4},
  [2795] = {.lex_state = 4},
  [2796] = {.lex_state = 5},
  [2797] = {.lex_state = 4, .external_lex_state = 4},
  [2798] = {.lex_state = 5},
  [2799] = {.lex_state = 4, .external_lex_state = 4},
  [2800] = {.lex_state = 104},
  [2801] = {.lex_state = 4, .external_lex_state = 4},
  [2802] = {.lex_state = 104},
  [2803] = {.lex_state = 104},
  [2804] = {.lex_state = 5},
  [2805] = {.lex_state = 6},
  [2806] = {.lex_state = 5},
  [2807] = {.lex_state = 104},
  [2808] = {.lex_state = 104},
  [2809] = {.lex_state = 104},
  [2810] = {.lex_state = 5, .external_lex_state = 4},
  [2811] = {.lex_state = 4, .external_lex_state = 4},
  [2812] = {.lex_state = 105},
  [2813] = {.lex_state = 5},
  [2814] = {.lex_state = 4},
  [2815] = {.lex_state = 4},
  [2816] = {.lex_state = 105},
  [2817] = {.lex_state = 5},
  [2818] = {.lex_state = 5},
  [2819] = {.lex_state = 5, .external_lex_state = 4},
  [2820] = {.lex_state = 4},
  [2821] = {.lex_state = 5},
  [2822] = {.lex_state = 5},
  [2823] = {.lex_state = 4, .external_lex_state = 4},
  [2824] = {.lex_state = 5, .external_lex_state = 4},
  [2825] = {.lex_state = 5, .external_lex_state = 4},
  [2826] = {.lex_state = 5, .external_lex_state = 4},
  [2827] = {.lex_state = 104},
  [2828] = {.lex_state = 5},
  [2829] = {.lex_state = 5, .external_lex_state = 4},
  [2830] = {.lex_state = 5, .external_lex_state = 4},
  [2831] = {.lex_state = 5, .external_lex_state = 4},
  [2832] = {.lex_state = 4},
  [2833] = {.lex_state = 5, .external_lex_state = 4},
  [2834] = {.lex_state = 4},
  [2835] = {.lex_state = 5},
  [2836] = {.lex_state = 4},
  [2837] = {.lex_state = 4},
  [2838] = {.lex_state = 5, .external_lex_state = 4},
  [2839] = {.lex_state = 5, .external_lex_state = 4},
  [2840] = {.lex_state = 5, .external_lex_state = 4},
  [2841] = {.lex_state = 5, .external_lex_state = 4},
  [2842] = {.lex_state = 104},
  [2843] = {.lex_state = 5, .external_lex_state = 4},
  [2844] = {.lex_state = 5},
  [2845] = {.lex_state = 4},
  [2846] = {.lex_state = 4},
  [2847] = {.lex_state = 4},
  [2848] = {.lex_state = 6},
  [2849] = {.lex_state = 5},
  [2850] = {.lex_state = 5},
  [2851] = {.lex_state = 105},
  [2852] = {.lex_state = 4},
  [2853] = {.lex_state = 104},
  [2854] = {.lex_state = 104},
  [2855] = {.lex_state = 5},
  [2856] = {.lex_state = 104},
  [2857] = {.lex_state = 105},
  [2858] = {.lex_state = 5},
  [2859] = {.lex_state = 5},
  [2860] = {.lex_state = 5, .external_lex_state = 4},
  [2861] = {.lex_state = 5, .external_lex_state = 4},
  [2862] = {.lex_state = 4},
  [2863] = {.lex_state = 6, .external_lex_state = 4},
  [2864] = {.lex_state = 4},
  [2865] = {.lex_state = 4},
  [2866] = {.lex_state = 5},
  [2867] = {.lex_state = 5, .external_lex_state = 4},
  [2868] = {.lex_state = 104},
  [2869] = {.lex_state = 4},
  [2870] = {.lex_state = 5},
  [2871] = {.lex_state = 4},
  [2872] = {.lex_state = 5},
  [2873] = {.lex_state = 4},
  [2874] = {.lex_state = 104},
  [2875] = {.lex_state = 5},
  [2876] = {.lex_state = 104},
  [2877] = {.lex_state = 5},
  [2878] = {.lex_state = 4},
  [2879] = {.lex_state = 5, .external_lex_state = 4},
  [2880] = {.lex_state = 4},
  [2881] = {.lex_state = 104},
  [2882] = {.lex_state = 104},
  [2883] = {.lex_state = 104},
  [2884] = {.lex_state = 104},
  [2885] = {.lex_state = 4},
  [2886] = {.lex_state = 4},
  [2887] = {.lex_state = 5},
  [2888] = {.lex_state = 6, .external_lex_state = 4},
  [2889] = {.lex_state = 104},
  [2890] = {.lex_state = 5},
  [2891] = {.lex_state = 4},
  [2892] = {.lex_state = 4},
  [2893] = {.lex_state = 4},
  [2894] = {.lex_state = 4},
  [2895] = {.lex_state = 104},
  [2896] = {.lex_state = 4},
  [2897] = {.lex_state = 104},
  [2898] = {.lex_state = 104},
  [2899] = {.lex_state = 104},
  [2900] = {.lex_state = 6, .external_lex_state = 4},
  [2901] = {.lex_state = 5},
  [2902] = {.lex_state = 5},
  [2903] = {.lex_state = 4},
  [2904] = {.lex_state = 4},
  [2905] = {.lex_state = 4},
  [2906] = {.lex_state = 104},
  [2907] = {.lex_state = 104},
  [2908] = {.lex_state = 4},
  [2909] = {.lex_state = 104},
  [2910] = {.lex_state = 4},
  [2911] = {.lex_state = 4},
  [2912] = {.lex_state = 4},
  [2913] = {.lex_state = 4},
  [2914] = {.lex_state = 104},
  [2915] = {.lex_state = 104},
  [2916] = {.lex_state = 4},
  [2917] = {.lex_state = 4},
  [2918] = {.lex_state = 4},
  [2919] = {.lex_state = 4},
  [2920] = {.lex_state = 104},
  [2921] = {.lex_state = 6},
  [2922] = {.lex_state = 105},
  [2923] = {.lex_state = 105},
  [2924] = {.lex_state = 105},
  [2925] = {.lex_state = 6},
  [2926] = {.lex_state = 6},
  [2927] = {.lex_state = 6},
  [2928] = {.lex_state = 105},
  [2929] = {.lex_state = 105},
  [2930] = {.lex_state = 4},
  [2931] = {.lex_state = 4},
  [2932] = {.lex_state = 105},
  [2933] = {.lex_state = 4},
  [2934] = {.lex_state = 6},
  [2935] = {.lex_state = 105},
  [2936] = {.lex_state = 105},
  [2937] = {.lex_state = 6},
  [2938] = {.lex_state = 6},
  [2939] = {.lex_state = 4},
  [2940] = {.lex_state = 4},
  [2941] = {.lex_state = 4},
  [2942] = {.lex_state = 104},
  [2943] = {.lex_state = 4},
  [2944] = {.lex_state = 104},
  [2945] = {.lex_state = 104},
  [2946] = {.lex_state = 104},
  [2947] = {.lex_state = 4},
  [2948] = {.lex_state = 104},
  [2949] = {.lex_state = 4},
  [2950] = {.lex_state = 104},
  [2951] = {.lex_state = 104, .external_lex_state = 4},
  [2952] = {.lex_state = 4},
  [2953] = {.lex_state = 4},
  [2954] = {.lex_state = 4},
  [2955] = {.lex_state = 4},
  [2956] = {.lex_state = 104},
  [2957] = {.lex_state = 104},
  [2958] = {.lex_state = 105},
  [2959] = {.lex_state = 104},
  [2960] = {.lex_state = 104},
  [2961] = {.lex_state = 104},
  [2962] = {.lex_state = 104, .external_lex_state = 4},
  [2963] = {.lex_state = 5},
  [2964] = {.lex_state = 4},
  [2965] = {.lex_state = 4},
  [2966] = {.lex_state = 104, .external_lex_state = 4},
  [2967] = {.lex_state = 105},
  [2968] = {.lex_state = 104},
  [2969] = {.lex_state = 104, .external_lex_state = 4},
  [2970] = {.lex_state = 4},
  [2971] = {.lex_state = 104},
  [2972] = {.lex_state = 104},
  [2973] = {.lex_state = 4},
  [2974] = {.lex_state = 104},
  [2975] = {.lex_state = 104},
  [2976] = {.lex_state = 104},
  [2977] = {.lex_state = 4},
  [2978] = {.lex_state = 6},
  [2979] = {.lex_state = 4},
  [2980] = {.lex_state = 104},
  [2981] = {.lex_state = 6},
  [2982] = {.lex_state = 104},
  [2983] = {.lex_state = 104, .external_lex_state = 4},
  [2984] = {.lex_state = 104},
  [2985] = {.lex_state = 104},
  [2986] = {.lex_state = 104, .external_lex_state = 4},
  [2987] = {.lex_state = 104},
  [2988] = {.lex_state = 6},
  [2989] = {.lex_state = 4},
  [2990] = {.lex_state = 5},
  [2991] = {.lex_state = 5},
  [2992] = {.lex_state = 5},
  [2993] = {.lex_state = 104},
  [2994] = {.lex_state = 5},
  [2995] = {.lex_state = 5},
  [2996] = {.lex_state = 5},
  [2997] = {.lex_state = 6},
  [2998] = {.lex_state = 6},
  [2999] = {.lex_state = 5},
  [3000] = {.lex_state = 104},
  [3001] = {.lex_state = 104},
  [3002] = {.lex_state = 5},
  [3003] = {.lex_state = 5},
  [3004] = {.lex_state = 104},
  [3005] = {.lex_state = 104},
  [3006] = {.lex_state = 104},
  [3007] = {.lex_state = 6},
  [3008] = {.lex_state = 5},
  [3009] = {.lex_state = 6},
  [3010] = {.lex_state = 6},
  [3011] = {.lex_state = 5},
  [3012] = {.lex_state = 104},
  [3013] = {.lex_state = 6},
  [3014] = {.lex_state = 6},
  [3015] = {.lex_state = 5},
  [3016] = {.lex_state = 5},
  [3017] = {.lex_state = 104},
  [3018] = {.lex_state = 104},
  [3019] = {.lex_state = 5},
  [3020] = {.lex_state = 5},
  [3021] = {.lex_state = 6},
  [3022] = {.lex_state = 5},
  [3023] = {.lex_state = 104},
  [3024] = {.lex_state = 5},
  [3025] = {.lex_state = 5},
  [3026] = {.lex_state = 104},
  [3027] = {.lex_state = 104},
  [3028] = {.lex_state = 104},
  [3029] = {.lex_state = 104},
  [3030] = {.lex_state = 104},
  [3031] = {.lex_state = 104},
  [3032] = {.lex_state = 104},
  [3033] = {.lex_state = 104},
  [3034] = {.lex_state = 104},
  [3035] = {.lex_state = 5},
  [3036] = {.lex_state = 104},
  [3037] = {.lex_state = 104},
  [3038] = {.lex_state = 5},
  [3039] = {.lex_state = 5},
  [3040] = {.lex_state = 104},
  [3041] = {.lex_state = 104},
  [3042] = {.lex_state = 5},
  [3043] = {.lex_state = 104},
  [3044] = {.lex_state = 104},
  [3045] = {.lex_state = 5},
  [3046] = {.lex_state = 104},
  [3047] = {.lex_state = 104},
  [3048] = {.lex_state = 104},
  [3049] = {.lex_state = 5},
  [3050] = {.lex_state = 5},
  [3051] = {.lex_state = 104},
  [3052] = {.lex_state = 104},
  [3053] = {.lex_state = 104},
  [3054] = {.lex_state = 104},
  [3055] = {.lex_state = 104},
  [3056] = {.lex_state = 5},
  [3057] = {.lex_state = 104},
  [3058] = {.lex_state = 5},
  [3059] = {.lex_state = 104},
  [3060] = {.lex_state = 104},
  [3061] = {.lex_state = 104},
  [3062] = {.lex_state = 6},
  [3063] = {.lex_state = 6},
  [3064] = {.lex_state = 104, .external_lex_state = 4},
  [3065] = {.lex_state = 104},
  [3066] = {.lex_state = 104},
  [3067] = {.lex_state = 104},
  [3068] = {.lex_state = 6},
  [3069] = {.lex_state = 104},
  [3070] = {.lex_state = 6},
  [3071] = {.lex_state = 104},
  [3072] = {.lex_state = 104, .external_lex_state = 4},
  [3073] = {.lex_state = 104},
  [3074] = {.lex_state = 104},
  [3075] = {.lex_state = 104},
  [3076] = {.lex_state = 104},
  [3077] = {.lex_state = 104},
  [3078] = {.lex_state = 104},
  [3079] = {.lex_state = 104},
  [3080] = {.lex_state = 104},
  [3081] = {.lex_state = 6},
  [3082] = {.lex_state = 104},
  [3083] = {.lex_state = 104},
  [3084] = {.lex_state = 104},
  [3085] = {.lex_state = 104},
  [3086] = {.lex_state = 104},
  [3087] = {.lex_state = 104},
  [3088] = {.lex_state = 104, .external_lex_state = 4},
  [3089] = {.lex_state = 104},
  [3090] = {.lex_state = 104, .external_lex_state = 4},
  [3091] = {.lex_state = 6},
  [3092] = {.lex_state = 104},
  [3093] = {.lex_state = 104, .external_lex_state = 4},
  [3094] = {.lex_state = 105},
  [3095] = {.lex_state = 105},
  [3096] = {.lex_state = 105},
  [3097] = {.lex_state = 105},
  [3098] = {.lex_state = 105},
  [3099] = {.lex_state = 105},
  [3100] = {.lex_state = 105},
  [3101] = {.lex_state = 105},
  [3102] = {.lex_state = 104},
  [3103] = {.lex_state = 105},
  [3104] = {.lex_state = 105},
  [3105] = {.lex_state = 105},
  [3106] = {.lex_state = 105},
  [3107] = {.lex_state = 105},
  [3108] = {.lex_state = 105},
  [3109] = {.lex_state = 105},
  [3110] = {.lex_state = 105},
  [3111] = {.lex_state = 105},
  [3112] = {.lex_state = 105},
  [3113] = {.lex_state = 105},
  [3114] = {.lex_state = 105},
  [3115] = {.lex_state = 105},
  [3116] = {.lex_state = 105},
  [3117] = {.lex_state = 105},
  [3118] = {.lex_state = 105},
  [3119] = {.lex_state = 104},
  [3120] = {.lex_state = 104},
  [3121] = {.lex_state = 104},
  [3122] = {.lex_state = 105},
  [3123] = {.lex_state = 104},
  [3124] = {.lex_state = 105},
  [3125] = {.lex_state = 105},
  [3126] = {.lex_state = 104, .external_lex_state = 4},
  [3127] = {.lex_state = 6},
  [3128] = {.lex_state = 105},
  [3129] = {.lex_state = 104},
  [3130] = {.lex_state = 104, .external_lex_state = 4},
  [3131] = {.lex_state = 104, .external_lex_state = 4},
  [3132] = {.lex_state = 104, .external_lex_state = 4},
  [3133] = {.lex_state = 104, .external_lex_state = 4},
  [3134] = {.lex_state = 104, .external_lex_state = 4},
  [3135] = {.lex_state = 104, .external_lex_state = 4},
  [3136] = {.lex_state = 104},
  [3137] = {.lex_state = 104},
  [3138] = {.lex_state = 104, .external_lex_state = 4},
  [3139] = {.lex_state = 104},
  [3140] = {.lex_state = 104},
  [3141] = {.lex_state = 104},
  [3142] = {.lex_state = 105},
  [3143] = {.lex_state = 104},
  [3144] = {.lex_state = 5},
  [3145] = {.lex_state = 105},
  [3146] = {.lex_state = 104},
  [3147] = {.lex_state = 104},
  [3148] = {.lex_state = 104},
  [3149] = {.lex_state = 104},
  [3150] = {.lex_state = 5},
  [3151] = {.lex_state = 104},
  [3152] = {.lex_state = 6, .external_lex_state = 4},
  [3153] = {.lex_state = 104},
  [3154] = {.lex_state = 104},
  [3155] = {.lex_state = 104},
  [3156] = {.lex_state = 104},
  [3157] = {.lex_state = 104},
  [3158] = {.lex_state = 104},
  [3159] = {.lex_state = 104},
  [3160] = {.lex_state = 104},
  [3161] = {.lex_state = 104},
  [3162] = {.lex_state = 104},
  [3163] = {.lex_state = 104},
  [3164] = {.lex_state = 104},
  [3165] = {.lex_state = 5},
  [3166] = {.lex_state = 104},
  [3167] = {.lex_state = 104},
  [3168] = {.lex_state = 104},
  [3169] = {.lex_state = 104},
  [3170] = {.lex_state = 105},
  [3171] = {.lex_state = 104},
  [3172] = {.lex_state = 104},
  [3173] = {.lex_state = 104},
  [3174] = {.lex_state = 5},
  [3175] = {.lex_state = 104},
  [3176] = {.lex_state = 104},
  [3177] = {.lex_state = 5},
  [3178] = {.lex_state = 104},
  [3179] = {.lex_state = 104},
  [3180] = {.lex_state = 104},
  [3181] = {.lex_state = 105},
  [3182] = {.lex_state = 104},
  [3183] = {.lex_state = 104},
  [3184] = {.lex_state = 5},
  [3185] = {.lex_state = 104, .external_lex_state = 4},
  [3186] = {.lex_state = 5},
  [3187] = {.lex_state = 104},
  [3188] = {.lex_state = 104},
  [3189] = {.lex_state = 104},
  [3190] = {.lex_state = 104},
  [3191] = {.lex_state = 105},
  [3192] = {.lex_state = 105},
  [3193] = {.lex_state = 5},
  [3194] = {.lex_state = 104},
  [3195] = {.lex_state = 5},
  [3196] = {.lex_state = 105},
  [3197] = {.lex_state = 5},
  [3198] = {.lex_state = 105},
  [3199] = {.lex_state = 5},
  [3200] = {.lex_state = 5},
  [3201] = {.lex_state = 5},
  [3202] = {.lex_state = 104},
  [3203] = {.lex_state = 5},
  [3204] = {.lex_state = 104},
  [3205] = {.lex_state = 5},
  [3206] = {.lex_state = 105},
  [3207] = {.lex_state = 6, .external_lex_state = 4},
  [3208] = {.lex_state = 104},
  [3209] = {.lex_state = 104},
  [3210] = {.lex_state = 6, .external_lex_state = 4},
  [3211] = {.lex_state = 5},
  [3212] = {.lex_state = 105},
  [3213] = {.lex_state = 5},
  [3214] = {.lex_state = 105},
  [3215] = {.lex_state = 5},
  [3216] = {.lex_state = 5},
  [3217] = {.lex_state = 5},
  [3218] = {.lex_state = 6, .external_lex_state = 4},
  [3219] = {.lex_state = 104},
  [3220] = {.lex_state = 104, .external_lex_state = 4},
  [3221] = {.lex_state = 5},
  [3222] = {.lex_state = 5},
  [3223] = {.lex_state = 104},
  [3224] = {.lex_state = 5},
  [3225] = {.lex_state = 104, .external_lex_state = 4},
  [3226] = {.lex_state = 104},
  [3227] = {.lex_state = 5},
  [3228] = {.lex_state = 105},
  [3229] = {.lex_state = 105},
  [3230] = {.lex_state = 104, .external_lex_state = 4},
  [3231] = {.lex_state = 5},
  [3232] = {.lex_state = 105},
  [3233] = {.lex_state = 104},
  [3234] = {.lex_state = 105},
  [3235] = {.lex_state = 104},
  [3236] = {.lex_state = 105},
  [3237] = {.lex_state = 105},
  [3238] = {.lex_state = 104, .external_lex_state = 4},
  [3239] = {.lex_state = 105},
  [3240] = {.lex_state = 104},
  [3241] = {.lex_state = 105},
  [3242] = {.lex_state = 104},
  [3243] = {.lex_state = 104},
  [3244] = {.lex_state = 105},
  [3245] = {.lex_state = 105},
  [3246] = {.lex_state = 105},
  [3247] = {.lex_state = 5},
  [3248] = {.lex_state = 105},
  [3249] = {.lex_state = 105},
  [3250] = {.lex_state = 105},
  [3251] = {.lex_state = 105},
  [3252] = {.lex_state = 105},
  [3253] = {.lex_state = 105},
  [3254] = {.lex_state = 104, .external_lex_state = 4},
  [3255] = {.lex_state = 104, .external_lex_state = 4},
  [3256] = {.lex_state = 104},
  [3257] = {.lex_state = 104, .external_lex_state = 4},
  [3258] = {.lex_state = 104},
  [3259] = {.lex_state = 104},
  [3260] = {.lex_state = 5},
  [3261] = {.lex_state = 104},
  [3262] = {.lex_state = 105},
  [3263] = {.lex_state = 105},
  [3264] = {.lex_state = 104, .external_lex_state = 4},
  [3265] = {.lex_state = 104, .external_lex_state = 4},
  [3266] = {.lex_state = 104},
  [3267] = {.lex_state = 104},
  [3268] = {.lex_state = 104, .external_lex_state = 4},
  [3269] = {.lex_state = 104},
  [3270] = {.lex_state = 104},
  [3271] = {.lex_state = 104},
  [3272] = {.lex_state = 104},
  [3273] = {.lex_state = 105},
  [3274] = {.lex_state = 105},
  [3275] = {.lex_state = 104},
  [3276] = {.lex_state = 104, .external_lex_state = 4},
  [3277] = {.lex_state = 104, .external_lex_state = 4},
  [3278] = {.lex_state = 105},
  [3279] = {.lex_state = 105},
  [3280] = {.lex_state = 105},
  [3281] = {.lex_state = 104},
  [3282] = {.lex_state = 105},
  [3283] = {.lex_state = 105},
  [3284] = {.lex_state = 105},
  [3285] = {.lex_state = 105},
  [3286] = {.lex_state = 104, .external_lex_state = 4},
  [3287] = {.lex_state = 104, .external_lex_state = 4},
  [3288] = {.lex_state = 104, .external_lex_state = 4},
  [3289] = {.lex_state = 104},
  [3290] = {.lex_state = 104, .external_lex_state = 4},
  [3291] = {.lex_state = 105},
  [3292] = {.lex_state = 105},
  [3293] = {.lex_state = 105},
  [3294] = {.lex_state = 104},
  [3295] = {.lex_state = 105},
  [3296] = {.lex_state = 105},
  [3297] = {.lex_state = 104},
  [3298] = {.lex_state = 104},
  [3299] = {.lex_state = 105},
  [3300] = {.lex_state = 5},
  [3301] = {.lex_state = 104},
  [3302] = {.lex_state = 105},
  [3303] = {.lex_state = 105},
  [3304] = {.lex_state = 105},
  [3305] = {.lex_state = 105},
  [3306] = {.lex_state = 104},
  [3307] = {.lex_state = 105},
  [3308] = {.lex_state = 105},
  [3309] = {.lex_state = 105},
  [3310] = {.lex_state = 104, .external_lex_state = 4},
  [3311] = {.lex_state = 105},
  [3312] = {.lex_state = 104, .external_lex_state = 4},
  [3313] = {.lex_state = 105},
  [3314] = {.lex_state = 5},
  [3315] = {.lex_state = 105},
  [3316] = {.lex_state = 5},
  [3317] = {.lex_state = 105},
  [3318] = {.lex_state = 105},
  [3319] = {.lex_state = 104, .external_lex_state = 4},
  [3320] = {.lex_state = 105},
  [3321] = {.lex_state = 105},
  [3322] = {.lex_state = 105},
  [3323] = {.lex_state = 105},
  [3324] = {.lex_state = 104},
  [3325] = {.lex_state = 105},
  [3326] = {.lex_state = 104},
  [3327] = {.lex_state = 105},
  [3328] = {.lex_state = 104},
  [3329] = {.lex_state = 105},
  [3330] = {.lex_state = 105},
  [3331] = {.lex_state = 105},
  [3332] = {.lex_state = 105},
  [3333] = {.lex_state = 5},
  [3334] = {.lex_state = 105},
  [3335] = {.lex_state = 104},
  [3336] = {.lex_state = 105},
  [3337] = {.lex_state = 105},
  [3338] = {.lex_state = 105},
  [3339] = {.lex_state = 105},
  [3340] = {.lex_state = 105},
  [3341] = {.lex_state = 104, .external_lex_state = 4},
  [3342] = {.lex_state = 104},
  [3343] = {.lex_state = 104, .external_lex_state = 4},
  [3344] = {.lex_state = 105},
  [3345] = {.lex_state = 105},
  [3346] = {.lex_state = 105},
  [3347] = {.lex_state = 105},
  [3348] = {.lex_state = 105},
  [3349] = {.lex_state = 105},
  [3350] = {.lex_state = 104, .external_lex_state = 4},
  [3351] = {.lex_state = 5},
  [3352] = {.lex_state = 105},
  [3353] = {.lex_state = 105},
  [3354] = {.lex_state = 105},
  [3355] = {.lex_state = 105},
  [3356] = {.lex_state = 104, .external_lex_state = 4},
  [3357] = {.lex_state = 105},
  [3358] = {.lex_state = 105},
  [3359] = {.lex_state = 105},
  [3360] = {.lex_state = 105},
  [3361] = {.lex_state = 105},
  [3362] = {.lex_state = 104, .external_lex_state = 4},
  [3363] = {.lex_state = 104, .external_lex_state = 4},
  [3364] = {.lex_state = 105},
  [3365] = {.lex_state = 105},
  [3366] = {.lex_state = 105},
  [3367] = {.lex_state = 105},
  [3368] = {.lex_state = 105},
  [3369] = {.lex_state = 105},
  [3370] = {.lex_state = 104, .external_lex_state = 4},
  [3371] = {.lex_state = 104, .external_lex_state = 4},
  [3372] = {.lex_state = 105},
  [3373] = {.lex_state = 105},
  [3374] = {.lex_state = 105},
  [3375] = {.lex_state = 105},
  [3376] = {.lex_state = 105},
  [3377] = {.lex_state = 105},
  [3378] = {.lex_state = 105},
  [3379] = {.lex_state = 105},
  [3380] = {.lex_state = 105},
  [3381] = {.lex_state = 105},
  [3382] = {.lex_state = 105},
  [3383] = {.lex_state = 105},
  [3384] = {.lex_state = 105},
  [3385] = {.lex_state = 105},
  [3386] = {.lex_state = 105},
  [3387] = {.lex_state = 105},
  [3388] = {.lex_state = 105},
  [3389] = {.lex_state = 105},
  [3390] = {.lex_state = 104, .external_lex_state = 4},
  [3391] = {.lex_state = 105},
  [3392] = {.lex_state = 105},
  [3393] = {.lex_state = 105},
  [3394] = {.lex_state = 105},
  [3395] = {.lex_state = 104, .external_lex_state = 4},
  [3396] = {.lex_state = 105},
  [3397] = {.lex_state = 105},
  [3398] = {.lex_state = 105},
  [3399] = {.lex_state = 105},
  [3400] = {.lex_state = 105},
  [3401] = {.lex_state = 105},
  [3402] = {.lex_state = 105},
  [3403] = {.lex_state = 105},
  [3404] = {.lex_state = 105},
  [3405] = {.lex_state = 105},
  [3406] = {.lex_state = 105},
  [3407] = {.lex_state = 105},
  [3408] = {.lex_state = 105},
  [3409] = {.lex_state = 105},
  [3410] = {.lex_state = 105},
  [3411] = {.lex_state = 105},
  [3412] = {.lex_state = 104, .external_lex_state = 4},
  [3413] = {.lex_state = 105},
  [3414] = {.lex_state = 105},
  [3415] = {.lex_state = 105},
  [3416] = {.lex_state = 104, .external_lex_state = 4},
  [3417] = {.lex_state = 105},
  [3418] = {.lex_state = 105},
  [3419] = {.lex_state = 105},
  [3420] = {.lex_state = 105},
  [3421] = {.lex_state = 105},
  [3422] = {.lex_state = 105},
  [3423] = {.lex_state = 105},
  [3424] = {.lex_state = 105},
  [3425] = {.lex_state = 105},
  [3426] = {.lex_state = 105},
  [3427] = {.lex_state = 105},
  [3428] = {.lex_state = 105},
  [3429] = {.lex_state = 105},
  [3430] = {.lex_state = 105},
  [3431] = {.lex_state = 105},
  [3432] = {.lex_state = 105},
  [3433] = {.lex_state = 105},
  [3434] = {.lex_state = 105},
  [3435] = {.lex_state = 105},
  [3436] = {.lex_state = 105},
  [3437] = {.lex_state = 105},
  [3438] = {.lex_state = 105},
  [3439] = {.lex_state = 105},
  [3440] = {.lex_state = 105},
  [3441] = {.lex_state = 105},
  [3442] = {.lex_state = 5},
  [3443] = {.lex_state = 105},
  [3444] = {.lex_state = 105},
  [3445] = {.lex_state = 105},
  [3446] = {.lex_state = 105},
  [3447] = {.lex_state = 105},
  [3448] = {.lex_state = 105},
  [3449] = {.lex_state = 105},
  [3450] = {.lex_state = 104},
  [3451] = {.lex_state = 5},
  [3452] = {.lex_state = 104, .external_lex_state = 4},
  [3453] = {.lex_state = 104, .external_lex_state = 4},
  [3454] = {.lex_state = 105},
  [3455] = {.lex_state = 105},
  [3456] = {.lex_state = 105},
  [3457] = {.lex_state = 104, .external_lex_state = 4},
  [3458] = {.lex_state = 104, .external_lex_state = 4},
  [3459] = {.lex_state = 104, .external_lex_state = 4},
  [3460] = {.lex_state = 105},
  [3461] = {.lex_state = 105},
  [3462] = {.lex_state = 104},
  [3463] = {.lex_state = 105},
  [3464] = {.lex_state = 104},
  [3465] = {.lex_state = 105},
  [3466] = {.lex_state = 105},
  [3467] = {.lex_state = 105},
  [3468] = {.lex_state = 5},
  [3469] = {.lex_state = 105},
  [3470] = {.lex_state = 105},
  [3471] = {.lex_state = 105},
  [3472] = {.lex_state = 104, .external_lex_state = 4},
  [3473] = {.lex_state = 105},
  [3474] = {.lex_state = 105},
  [3475] = {.lex_state = 105},
  [3476] = {.lex_state = 104},
  [3477] = {.lex_state = 5},
  [3478] = {.lex_state = 105},
  [3479] = {.lex_state = 105},
  [3480] = {.lex_state = 105},
  [3481] = {.lex_state = 105},
  [3482] = {.lex_state = 105},
  [3483] = {.lex_state = 105},
  [3484] = {.lex_state = 105},
  [3485] = {.lex_state = 105},
  [3486] = {.lex_state = 104, .external_lex_state = 4},
  [3487] = {.lex_state = 105},
  [3488] = {.lex_state = 105},
  [3489] = {.lex_state = 105},
  [3490] = {.lex_state = 105},
  [3491] = {.lex_state = 105},
  [3492] = {.lex_state = 105},
  [3493] = {.lex_state = 105},
  [3494] = {.lex_state = 105},
  [3495] = {.lex_state = 105},
  [3496] = {.lex_state = 105},
  [3497] = {.lex_state = 5},
  [3498] = {.lex_state = 105},
  [3499] = {.lex_state = 105},
  [3500] = {.lex_state = 105},
  [3501] = {.lex_state = 105},
  [3502] = {.lex_state = 105},
  [3503] = {.lex_state = 5},
  [3504] = {.lex_state = 105},
  [3505] = {.lex_state = 105},
  [3506] = {.lex_state = 105},
  [3507] = {.lex_state = 105},
  [3508] = {.lex_state = 105},
  [3509] = {.lex_state = 105},
  [3510] = {.lex_state = 105},
  [3511] = {.lex_state = 105},
  [3512] = {.lex_state = 105},
  [3513] = {.lex_state = 105},
  [3514] = {.lex_state = 105},
  [3515] = {.lex_state = 105},
  [3516] = {.lex_state = 5},
  [3517] = {.lex_state = 105},
  [3518] = {.lex_state = 105},
  [3519] = {.lex_state = 5},
  [3520] = {.lex_state = 105},
  [3521] = {.lex_state = 105},
  [3522] = {.lex_state = 105},
  [3523] = {.lex_state = 105},
  [3524] = {.lex_state = 105},
  [3525] = {.lex_state = 105},
  [3526] = {.lex_state = 105},
  [3527] = {.lex_state = 105},
  [3528] = {.lex_state = 105},
  [3529] = {.lex_state = 104, .external_lex_state = 4},
  [3530] = {.lex_state = 104, .external_lex_state = 4},
  [3531] = {.lex_state = 104, .external_lex_state = 4},
  [3532] = {.lex_state = 104, .external_lex_state = 4},
  [3533] = {.lex_state = 104, .external_lex_state = 4},
  [3534] = {.lex_state = 104, .external_lex_state = 4},
  [3535] = {.lex_state = 104},
  [3536] = {.lex_state = 104},
  [3537] = {.lex_state = 104},
  [3538] = {.lex_state = 104},
  [3539] = {.lex_state = 104},
  [3540] = {.lex_state = 104},
  [3541] = {.lex_state = 104},
  [3542] = {.lex_state = 104},
  [3543] = {.lex_state = 104},
  [3544] = {.lex_state = 104},
  [3545] = {.lex_state = 5},
  [3546] = {.lex_state = 5},
  [3547] = {.lex_state = 104},
  [3548] = {.lex_state = 104},
  [3549] = {.lex_state = 104},
  [3550] = {.lex_state = 104},
  [3551] = {.lex_state = 104},
  [3552] = {.lex_state = 104},
  [3553] = {.lex_state = 104},
  [3554] = {.lex_state = 104},
  [3555] = {.lex_state = 104},
  [3556] = {.lex_state = 5},
  [3557] = {.lex_state = 104},
  [3558] = {.lex_state = 5},
  [3559] = {.lex_state = 104},
  [3560] = {.lex_state = 104},
  [3561] = {.lex_state = 104},
  [3562] = {.lex_state = 6},
  [3563] = {.lex_state = 104},
  [3564] = {.lex_state = 105},
  [3565] = {.lex_state = 4},
  [3566] = {.lex_state = 104},
  [3567] = {.lex_state = 4},
  [3568] = {.lex_state = 105},
  [3569] = {.lex_state = 104},
  [3570] = {.lex_state = 4},
  [3571] = {.lex_state = 6},
  [3572] = {.lex_state = 105},
  [3573] = {.lex_state = 104},
  [3574] = {.lex_state = 4},
  [3575] = {.lex_state = 4},
  [3576] = {.lex_state = 104},
  [3577] = {.lex_state = 104},
  [3578] = {.lex_state = 6},
  [3579] = {.lex_state = 4},
  [3580] = {.lex_state = 4},
  [3581] = {.lex_state = 4},
  [3582] = {.lex_state = 4},
  [3583] = {.lex_state = 105},
  [3584] = {.lex_state = 104},
  [3585] = {.lex_state = 104},
  [3586] = {.lex_state = 104},
  [3587] = {.lex_state = 104},
  [3588] = {.lex_state = 104},
  [3589] = {.lex_state = 104},
  [3590] = {.lex_state = 6},
  [3591] = {.lex_state = 104},
  [3592] = {.lex_state = 104},
  [3593] = {.lex_state = 104},
  [3594] = {.lex_state = 6},
  [3595] = {.lex_state = 104},
  [3596] = {.lex_state = 104},
  [3597] = {.lex_state = 104},
  [3598] = {.lex_state = 104},
  [3599] = {.lex_state = 104},
  [3600] = {.lex_state = 105},
  [3601] = {.lex_state = 104},
  [3602] = {.lex_state = 6},
  [3603] = {.lex_state = 6},
  [3604] = {.lex_state = 104},
  [3605] = {.lex_state = 104},
  [3606] = {.lex_state = 105},
  [3607] = {.lex_state = 104},
  [3608] = {.lex_state = 104},
  [3609] = {.lex_state = 7},
  [3610] = {.lex_state = 104},
  [3611] = {.lex_state = 104},
  [3612] = {.lex_state = 104},
  [3613] = {.lex_state = 4},
  [3614] = {.lex_state = 104},
  [3615] = {.lex_state = 104},
  [3616] = {.lex_state = 104},
  [3617] = {.lex_state = 104},
  [3618] = {.lex_state = 104},
  [3619] = {.lex_state = 104},
  [3620] = {.lex_state = 104},
  [3621] = {.lex_state = 104},
  [3622] = {.lex_state = 104},
  [3623] = {.lex_state = 104},
  [3624] = {.lex_state = 104},
  [3625] = {.lex_state = 104},
  [3626] = {.lex_state = 104},
  [3627] = {.lex_state = 104},
  [3628] = {.lex_state = 4},
  [3629] = {.lex_state = 104},
  [3630] = {.lex_state = 104},
  [3631] = {.lex_state = 104},
  [3632] = {.lex_state = 104},
  [3633] = {.lex_state = 104},
  [3634] = {.lex_state = 104},
  [3635] = {.lex_state = 104},
  [3636] = {.lex_state = 104},
  [3637] = {.lex_state = 104},
  [3638] = {.lex_state = 104},
  [3639] = {.lex_state = 104},
  [3640] = {.lex_state = 104},
  [3641] = {.lex_state = 104},
  [3642] = {.lex_state = 104},
  [3643] = {.lex_state = 104},
  [3644] = {.lex_state = 104},
  [3645] = {.lex_state = 104},
  [3646] = {.lex_state = 104},
  [3647] = {.lex_state = 104},
  [3648] = {.lex_state = 104},
  [3649] = {.lex_state = 104},
  [3650] = {.lex_state = 104},
  [3651] = {.lex_state = 104},
  [3652] = {.lex_state = 104},
  [3653] = {.lex_state = 104},
  [3654] = {.lex_state = 104},
  [3655] = {.lex_state = 104},
  [3656] = {.lex_state = 104},
  [3657] = {.lex_state = 104},
  [3658] = {.lex_state = 104},
  [3659] = {.lex_state = 104},
  [3660] = {.lex_state = 104},
  [3661] = {.lex_state = 104},
  [3662] = {.lex_state = 104},
  [3663] = {.lex_state = 104},
  [3664] = {.lex_state = 105},
  [3665] = {.lex_state = 104},
  [3666] = {.lex_state = 104},
  [3667] = {.lex_state = 104},
  [3668] = {.lex_state = 105},
  [3669] = {.lex_state = 104},
  [3670] = {.lex_state = 104},
  [3671] = {.lex_state = 105},
  [3672] = {.lex_state = 104},
  [3673] = {.lex_state = 104},
  [3674] = {.lex_state = 104},
  [3675] = {.lex_state = 104},
  [3676] = {.lex_state = 104},
  [3677] = {.lex_state = 104},
  [3678] = {.lex_state = 104},
  [3679] = {.lex_state = 104},
  [3680] = {.lex_state = 104},
  [3681] = {.lex_state = 104},
  [3682] = {.lex_state = 104},
  [3683] = {.lex_state = 105},
  [3684] = {.lex_state = 104},
  [3685] = {.lex_state = 104},
  [3686] = {.lex_state = 104},
  [3687] = {.lex_state = 104},
  [3688] = {.lex_state = 104},
  [3689] = {.lex_state = 104},
  [3690] = {.lex_state = 104},
  [3691] = {.lex_state = 104},
  [3692] = {.lex_state = 104},
  [3693] = {.lex_state = 104},
  [3694] = {.lex_state = 105},
  [3695] = {.lex_state = 104},
  [3696] = {.lex_state = 4},
  [3697] = {.lex_state = 104},
  [3698] = {.lex_state = 104},
  [3699] = {.lex_state = 104},
  [3700] = {.lex_state = 104},
  [3701] = {.lex_state = 104},
  [3702] = {.lex_state = 104},
  [3703] = {.lex_state = 104},
  [3704] = {.lex_state = 104},
  [3705] = {.lex_state = 104},
  [3706] = {.lex_state = 104},
  [3707] = {.lex_state = 104},
  [3708] = {.lex_state = 104},
  [3709] = {.lex_state = 104},
  [3710] = {.lex_state = 104},
  [3711] = {.lex_state = 104},
  [3712] = {.lex_state = 104},
  [3713] = {.lex_state = 104},
  [3714] = {.lex_state = 104},
  [3715] = {.lex_state = 104},
  [3716] = {.lex_state = 104},
  [3717] = {.lex_state = 104},
  [3718] = {.lex_state = 104},
  [3719] = {.lex_state = 104},
  [3720] = {.lex_state = 104},
  [3721] = {.lex_state = 104},
  [3722] = {.lex_state = 104},
  [3723] = {.lex_state = 104},
  [3724] = {.lex_state = 105},
  [3725] = {.lex_state = 104},
  [3726] = {.lex_state = 104},
  [3727] = {.lex_state = 104},
  [3728] = {.lex_state = 104},
  [3729] = {.lex_state = 104},
  [3730] = {.lex_state = 104},
  [3731] = {.lex_state = 104},
  [3732] = {.lex_state = 104},
  [3733] = {.lex_state = 104},
  [3734] = {.lex_state = 104},
  [3735] = {.lex_state = 104},
  [3736] = {.lex_state = 104},
  [3737] = {.lex_state = 104},
  [3738] = {.lex_state = 104},
  [3739] = {.lex_state = 104},
  [3740] = {.lex_state = 105},
  [3741] = {.lex_state = 104},
  [3742] = {.lex_state = 104},
  [3743] = {.lex_state = 104},
  [3744] = {.lex_state = 104},
  [3745] = {.lex_state = 104},
  [3746] = {.lex_state = 104},
  [3747] = {.lex_state = 104},
  [3748] = {.lex_state = 104},
  [3749] = {.lex_state = 104},
  [3750] = {.lex_state = 104},
  [3751] = {.lex_state = 104},
  [3752] = {.lex_state = 4},
  [3753] = {.lex_state = 104},
  [3754] = {.lex_state = 104},
  [3755] = {.lex_state = 104},
  [3756] = {.lex_state = 104},
  [3757] = {.lex_state = 104},
  [3758] = {.lex_state = 104},
  [3759] = {.lex_state = 104},
  [3760] = {.lex_state = 104},
  [3761] = {.lex_state = 104},
  [3762] = {.lex_state = 105},
  [3763] = {.lex_state = 104},
  [3764] = {.lex_state = 104},
  [3765] = {.lex_state = 104},
  [3766] = {.lex_state = 104},
  [3767] = {.lex_state = 104},
  [3768] = {.lex_state = 104},
  [3769] = {.lex_state = 104},
  [3770] = {.lex_state = 104},
  [3771] = {.lex_state = 104},
  [3772] = {.lex_state = 104},
  [3773] = {.lex_state = 104},
  [3774] = {.lex_state = 104},
  [3775] = {.lex_state = 104},
  [3776] = {.lex_state = 104},
  [3777] = {.lex_state = 4},
  [3778] = {.lex_state = 105},
  [3779] = {.lex_state = 105},
  [3780] = {.lex_state = 104},
  [3781] = {.lex_state = 104},
  [3782] = {.lex_state = 104},
  [3783] = {.lex_state = 104},
  [3784] = {.lex_state = 105},
  [3785] = {.lex_state = 104},
  [3786] = {.lex_state = 104},
  [3787] = {.lex_state = 4},
  [3788] = {.lex_state = 4},
  [3789] = {.lex_state = 105},
  [3790] = {.lex_state = 104},
  [3791] = {.lex_state = 104},
  [3792] = {.lex_state = 105},
  [3793] = {.lex_state = 104},
  [3794] = {.lex_state = 105},
  [3795] = {.lex_state = 5},
  [3796] = {.lex_state = 4},
  [3797] = {.lex_state = 105},
  [3798] = {.lex_state = 105},
  [3799] = {.lex_state = 5},
  [3800] = {.lex_state = 10},
  [3801] = {.lex_state = 4},
  [3802] = {.lex_state = 105},
  [3803] = {.lex_state = 105},
  [3804] = {.lex_state = 6},
  [3805] = {.lex_state = 104},
  [3806] = {.lex_state = 105},
  [3807] = {.lex_state = 105},
  [3808] = {.lex_state = 104},
  [3809] = {.lex_state = 105},
  [3810] = {.lex_state = 105},
  [3811] = {.lex_state = 105},
  [3812] = {.lex_state = 105},
  [3813] = {.lex_state = 105},
  [3814] = {.lex_state = 105},
  [3815] = {.lex_state = 104},
  [3816] = {.lex_state = 105},
  [3817] = {.lex_state = 105},
  [3818] = {.lex_state = 105},
  [3819] = {.lex_state = 105},
  [3820] = {.lex_state = 104},
  [3821] = {.lex_state = 105},
  [3822] = {.lex_state = 105},
  [3823] = {.lex_state = 105},
  [3824] = {.lex_state = 105},
  [3825] = {.lex_state = 104},
  [3826] = {.lex_state = 105},
  [3827] = {.lex_state = 105},
  [3828] = {.lex_state = 105},
  [3829] = {.lex_state = 105},
  [3830] = {.lex_state = 105},
  [3831] = {.lex_state = 6},
  [3832] = {.lex_state = 105},
  [3833] = {.lex_state = 5},
  [3834] = {.lex_state = 105},
  [3835] = {.lex_state = 105},
  [3836] = {.lex_state = 6},
  [3837] = {.lex_state = 104},
  [3838] = {.lex_state = 4},
  [3839] = {.lex_state = 105},
  [3840] = {.lex_state = 105},
  [3841] = {.lex_state = 105},
  [3842] = {.lex_state = 104},
  [3843] = {.lex_state = 105},
  [3844] = {.lex_state = 105},
  [3845] = {.lex_state = 105},
  [3846] = {.lex_state = 105},
  [3847] = {.lex_state = 105},
  [3848] = {.lex_state = 104},
  [3849] = {.lex_state = 104},
  [3850] = {.lex_state = 105},
  [3851] = {.lex_state = 105},
  [3852] = {.lex_state = 105},
  [3853] = {.lex_state = 5, .external_lex_state = 4},
  [3854] = {.lex_state = 105},
  [3855] = {.lex_state = 105},
  [3856] = {.lex_state = 105},
  [3857] = {.lex_state = 104},
  [3858] = {.lex_state = 105},
  [3859] = {.lex_state = 105},
  [3860] = {.lex_state = 105},
  [3861] = {.lex_state = 105},
  [3862] = {.lex_state = 105},
  [3863] = {.lex_state = 105},
  [3864] = {.lex_state = 105},
  [3865] = {.lex_state = 105},
  [3866] = {.lex_state = 105},
  [3867] = {.lex_state = 105},
  [3868] = {.lex_state = 105},
  [3869] = {.lex_state = 105},
  [3870] = {.lex_state = 105},
  [3871] = {.lex_state = 6},
  [3872] = {.lex_state = 5},
  [3873] = {.lex_state = 105},
  [3874] = {.lex_state = 4},
  [3875] = {.lex_state = 105},
  [3876] = {.lex_state = 105},
  [3877] = {.lex_state = 105},
  [3878] = {.lex_state = 105},
  [3879] = {.lex_state = 104},
  [3880] = {.lex_state = 104},
  [3881] = {.lex_state = 5, .external_lex_state = 4},
  [3882] = {.lex_state = 5, .external_lex_state = 4},
  [3883] = {.lex_state = 104},
  [3884] = {.lex_state = 5, .external_lex_state = 4},
  [3885] = {.lex_state = 104},
  [3886] = {.lex_state = 6},
  [3887] = {.lex_state = 6},
  [3888] = {.lex_state = 5, .external_lex_state = 4},
  [3889] = {.lex_state = 104},
  [3890] = {.lex_state = 104},
  [3891] = {.lex_state = 5, .external_lex_state = 4},
  [3892] = {.lex_state = 104},
  [3893] = {.lex_state = 104},
  [3894] = {.lex_state = 105},
  [3895] = {.lex_state = 4},
  [3896] = {.lex_state = 104},
  [3897] = {.lex_state = 104},
  [3898] = {.lex_state = 104},
  [3899] = {.lex_state = 5, .external_lex_state = 4},
  [3900] = {.lex_state = 104},
  [3901] = {.lex_state = 104},
  [3902] = {.lex_state = 104},
  [3903] = {.lex_state = 104},
  [3904] = {.lex_state = 104},
  [3905] = {.lex_state = 104},
  [3906] = {.lex_state = 104},
  [3907] = {.lex_state = 104},
  [3908] = {.lex_state = 104},
  [3909] = {.lex_state = 5, .external_lex_state = 4},
  [3910] = {.lex_state = 6},
  [3911] = {.lex_state = 104},
  [3912] = {.lex_state = 104},
  [3913] = {.lex_state = 5, .external_lex_state = 4},
  [3914] = {.lex_state = 104},
  [3915] = {.lex_state = 5, .external_lex_state = 4},
  [3916] = {.lex_state = 104},
  [3917] = {.lex_state = 104},
  [3918] = {.lex_state = 104},
  [3919] = {.lex_state = 104},
  [3920] = {.lex_state = 5, .external_lex_state = 4},
  [3921] = {.lex_state = 5, .external_lex_state = 4},
  [3922] = {.lex_state = 104},
  [3923] = {.lex_state = 104},
  [3924] = {.lex_state = 7},
  [3925] = {.lex_state = 104},
  [3926] = {.lex_state = 5, .external_lex_state = 4},
  [3927] = {.lex_state = 5},
  [3928] = {.lex_state = 5, .external_lex_state = 4},
  [3929] = {.lex_state = 104},
  [3930] = {.lex_state = 104},
  [3931] = {.lex_state = 104},
  [3932] = {.lex_state = 104},
  [3933] = {.lex_state = 6},
  [3934] = {.lex_state = 104},
  [3935] = {.lex_state = 5, .external_lex_state = 4},
  [3936] = {.lex_state = 104},
  [3937] = {.lex_state = 5, .external_lex_state = 4},
  [3938] = {.lex_state = 5, .external_lex_state = 4},
  [3939] = {.lex_state = 104},
  [3940] = {.lex_state = 104},
  [3941] = {.lex_state = 104},
  [3942] = {.lex_state = 104},
  [3943] = {.lex_state = 5, .external_lex_state = 4},
  [3944] = {.lex_state = 5, .external_lex_state = 4},
  [3945] = {.lex_state = 104},
  [3946] = {.lex_state = 5, .external_lex_state = 4},
  [3947] = {.lex_state = 104},
  [3948] = {.lex_state = 104},
  [3949] = {.lex_state = 104},
  [3950] = {.lex_state = 104},
  [3951] = {.lex_state = 5, .external_lex_state = 4},
  [3952] = {.lex_state = 104},
  [3953] = {.lex_state = 104},
  [3954] = {.lex_state = 104},
  [3955] = {.lex_state = 104},
  [3956] = {.lex_state = 105},
  [3957] = {.lex_state = 104},
  [3958] = {.lex_state = 104},
  [3959] = {.lex_state = 104},
  [3960] = {.lex_state = 6},
  [3961] = {.lex_state = 105},
  [3962] = {.lex_state = 104},
  [3963] = {.lex_state = 104},
  [3964] = {.lex_state = 104},
  [3965] = {.lex_state = 104},
  [3966] = {.lex_state = 105},
  [3967] = {.lex_state = 104},
  [3968] = {.lex_state = 104},
  [3969] = {.lex_state = 104},
  [3970] = {.lex_state = 104},
  [3971] = {.lex_state = 104},
  [3972] = {.lex_state = 104},
  [3973] = {.lex_state = 104},
  [3974] = {.lex_state = 104},
  [3975] = {.lex_state = 104},
  [3976] = {.lex_state = 104},
  [3977] = {.lex_state = 104},
  [3978] = {.lex_state = 104},
  [3979] = {.lex_state = 104},
  [3980] = {.lex_state = 104},
  [3981] = {.lex_state = 104},
  [3982] = {.lex_state = 104},
  [3983] = {.lex_state = 104},
  [3984] = {.lex_state = 104},
  [3985] = {.lex_state = 7},
  [3986] = {.lex_state = 104},
  [3987] = {.lex_state = 104},
  [3988] = {.lex_state = 104},
  [3989] = {.lex_state = 104},
  [3990] = {.lex_state = 104},
  [3991] = {.lex_state = 104},
  [3992] = {.lex_state = 5, .external_lex_state = 4},
  [3993] = {.lex_state = 104},
  [3994] = {.lex_state = 104},
  [3995] = {.lex_state = 104},
  [3996] = {.lex_state = 5},
  [3997] = {.lex_state = 104},
  [3998] = {.lex_state = 104},
  [3999] = {.lex_state = 104},
  [4000] = {.lex_state = 104},
  [4001] = {.lex_state = 104},
  [4002] = {.lex_state = 105},
  [4003] = {.lex_state = 104},
  [4004] = {.lex_state = 104},
  [4005] = {.lex_state = 5},
  [4006] = {.lex_state = 104},
  [4007] = {.lex_state = 104},
  [4008] = {.lex_state = 104},
  [4009] = {.lex_state = 104},
  [4010] = {.lex_state = 104},
  [4011] = {.lex_state = 104},
  [4012] = {.lex_state = 104},
  [4013] = {.lex_state = 104},
  [4014] = {.lex_state = 104},
  [4015] = {.lex_state = 104},
  [4016] = {.lex_state = 104},
  [4017] = {.lex_state = 104},
  [4018] = {.lex_state = 104},
  [4019] = {.lex_state = 104},
  [4020] = {.lex_state = 104},
  [4021] = {.lex_state = 104},
  [4022] = {.lex_state = 104},
  [4023] = {.lex_state = 104},
  [4024] = {.lex_state = 104},
  [4025] = {.lex_state = 104},
  [4026] = {.lex_state = 104},
  [4027] = {.lex_state = 104},
  [4028] = {.lex_state = 104},
  [4029] = {.lex_state = 104},
  [4030] = {.lex_state = 104},
  [4031] = {.lex_state = 104},
  [4032] = {.lex_state = 104},
  [4033] = {.lex_state = 104},
  [4034] = {.lex_state = 104},
  [4035] = {.lex_state = 104},
  [4036] = {.lex_state = 104},
  [4037] = {.lex_state = 104},
  [4038] = {.lex_state = 104},
  [4039] = {.lex_state = 104},
  [4040] = {.lex_state = 104},
  [4041] = {.lex_state = 104},
  [4042] = {.lex_state = 4},
  [4043] = {.lex_state = 104},
  [4044] = {.lex_state = 104},
  [4045] = {.lex_state = 104},
  [4046] = {.lex_state = 104},
  [4047] = {.lex_state = 104},
  [4048] = {.lex_state = 104},
  [4049] = {.lex_state = 105},
  [4050] = {.lex_state = 104},
  [4051] = {.lex_state = 104},
  [4052] = {.lex_state = 104},
  [4053] = {.lex_state = 104},
  [4054] = {.lex_state = 104},
  [4055] = {.lex_state = 104},
  [4056] = {.lex_state = 104},
  [4057] = {.lex_state = 104},
  [4058] = {.lex_state = 104},
  [4059] = {.lex_state = 104},
  [4060] = {.lex_state = 104},
  [4061] = {.lex_state = 104},
  [4062] = {.lex_state = 104},
  [4063] = {.lex_state = 104},
  [4064] = {.lex_state = 104},
  [4065] = {.lex_state = 104},
  [4066] = {.lex_state = 104},
  [4067] = {.lex_state = 104},
  [4068] = {.lex_state = 104},
  [4069] = {.lex_state = 104},
  [4070] = {.lex_state = 104},
  [4071] = {.lex_state = 104},
  [4072] = {.lex_state = 104},
  [4073] = {.lex_state = 104},
  [4074] = {.lex_state = 104},
  [4075] = {.lex_state = 104},
  [4076] = {.lex_state = 104},
  [4077] = {.lex_state = 104},
  [4078] = {.lex_state = 104},
  [4079] = {.lex_state = 104},
  [4080] = {.lex_state = 104},
  [4081] = {.lex_state = 105},
  [4082] = {.lex_state = 104},
  [4083] = {.lex_state = 104},
  [4084] = {.lex_state = 105},
  [4085] = {.lex_state = 104},
  [4086] = {.lex_state = 104},
  [4087] = {.lex_state = 104},
  [4088] = {.lex_state = 104},
  [4089] = {.lex_state = 5},
  [4090] = {.lex_state = 104},
  [4091] = {.lex_state = 104},
  [4092] = {.lex_state = 105},
  [4093] = {.lex_state = 105},
  [4094] = {.lex_state = 104},
  [4095] = {.lex_state = 104},
  [4096] = {.lex_state = 105},
  [4097] = {.lex_state = 104},
  [4098] = {.lex_state = 105},
  [4099] = {.lex_state = 105},
  [4100] = {.lex_state = 105},
  [4101] = {.lex_state = 105},
  [4102] = {.lex_state = 104},
  [4103] = {.lex_state = 104},
  [4104] = {.lex_state = 105},
  [4105] = {.lex_state = 104},
  [4106] = {.lex_state = 105},
  [4107] = {.lex_state = 104},
  [4108] = {.lex_state = 105},
  [4109] = {.lex_state = 105},
  [4110] = {.lex_state = 104},
  [4111] = {.lex_state = 104},
  [4112] = {.lex_state = 105},
  [4113] = {.lex_state = 104},
  [4114] = {.lex_state = 105},
  [4115] = {.lex_state = 105},
  [4116] = {.lex_state = 105},
  [4117] = {.lex_state = 105},
  [4118] = {.lex_state = 104},
  [4119] = {.lex_state = 105},
  [4120] = {.lex_state = 104},
  [4121] = {.lex_state = 105},
  [4122] = {.lex_state = 105},
  [4123] = {.lex_state = 105},
  [4124] = {.lex_state = 105},
  [4125] = {.lex_state = 104},
  [4126] = {.lex_state = 105},
  [4127] = {.lex_state = 105},
  [4128] = {.lex_state = 105},
  [4129] = {.lex_state = 105},
  [4130] = {.lex_state = 105},
  [4131] = {.lex_state = 104},
  [4132] = {.lex_state = 104},
  [4133] = {.lex_state = 5},
  [4134] = {.lex_state = 104},
  [4135] = {.lex_state = 105},
  [4136] = {.lex_state = 105},
  [4137] = {.lex_state = 104},
  [4138] = {.lex_state = 105},
  [4139] = {.lex_state = 104},
  [4140] = {.lex_state = 105},
  [4141] = {.lex_state = 4},
  [4142] = {.lex_state = 105},
  [4143] = {.lex_state = 104},
  [4144] = {.lex_state = 105},
  [4145] = {.lex_state = 104},
  [4146] = {.lex_state = 105},
  [4147] = {.lex_state = 105},
  [4148] = {.lex_state = 105},
  [4149] = {.lex_state = 105},
  [4150] = {.lex_state = 105},
  [4151] = {.lex_state = 105},
  [4152] = {.lex_state = 105},
  [4153] = {.lex_state = 104},
  [4154] = {.lex_state = 105},
  [4155] = {.lex_state = 104},
  [4156] = {.lex_state = 105},
  [4157] = {.lex_state = 104},
  [4158] = {.lex_state = 105},
  [4159] = {.lex_state = 105},
  [4160] = {.lex_state = 5},
  [4161] = {.lex_state = 104},
  [4162] = {.lex_state = 104},
  [4163] = {.lex_state = 104},
  [4164] = {.lex_state = 105},
  [4165] = {.lex_state = 104},
  [4166] = {.lex_state = 104},
  [4167] = {.lex_state = 105},
  [4168] = {.lex_state = 105},
  [4169] = {.lex_state = 105},
  [4170] = {.lex_state = 105},
  [4171] = {.lex_state = 105},
  [4172] = {.lex_state = 105},
  [4173] = {.lex_state = 105},
  [4174] = {.lex_state = 105},
  [4175] = {.lex_state = 104},
  [4176] = {.lex_state = 105},
  [4177] = {.lex_state = 105},
  [4178] = {.lex_state = 105},
  [4179] = {.lex_state = 105},
  [4180] = {.lex_state = 105},
  [4181] = {.lex_state = 105},
  [4182] = {.lex_state = 5},
  [4183] = {.lex_state = 104},
  [4184] = {.lex_state = 104},
  [4185] = {.lex_state = 105},
  [4186] = {.lex_state = 105},
  [4187] = {.lex_state = 104},
  [4188] = {.lex_state = 104},
  [4189] = {.lex_state = 104},
  [4190] = {.lex_state = 104},
  [4191] = {.lex_state = 104},
  [4192] = {.lex_state = 105},
  [4193] = {.lex_state = 104},
  [4194] = {.lex_state = 105},
  [4195] = {.lex_state = 104},
  [4196] = {.lex_state = 4},
  [4197] = {.lex_state = 104},
  [4198] = {.lex_state = 104},
  [4199] = {.lex_state = 105},
  [4200] = {.lex_state = 105},
  [4201] = {.lex_state = 104},
  [4202] = {.lex_state = 105},
  [4203] = {.lex_state = 105},
  [4204] = {.lex_state = 105},
  [4205] = {.lex_state = 105},
  [4206] = {.lex_state = 105},
  [4207] = {.lex_state = 104},
  [4208] = {.lex_state = 105},
  [4209] = {.lex_state = 105},
  [4210] = {.lex_state = 104},
  [4211] = {.lex_state = 105},
  [4212] = {.lex_state = 104},
  [4213] = {.lex_state = 104},
  [4214] = {.lex_state = 104},
  [4215] = {.lex_state = 105},
  [4216] = {.lex_state = 104},
  [4217] = {.lex_state = 105},
  [4218] = {.lex_state = 104},
  [4219] = {.lex_state = 104},
  [4220] = {.lex_state = 104},
  [4221] = {.lex_state = 105},
  [4222] = {.lex_state = 105},
  [4223] = {.lex_state = 104},
  [4224] = {.lex_state = 105},
  [4225] = {.lex_state = 105},
  [4226] = {.lex_state = 104},
  [4227] = {.lex_state = 104},
  [4228] = {.lex_state = 105},
  [4229] = {.lex_state = 105},
  [4230] = {.lex_state = 105},
  [4231] = {.lex_state = 105},
  [4232] = {.lex_state = 104},
  [4233] = {.lex_state = 104},
  [4234] = {.lex_state = 105},
  [4235] = {.lex_state = 104},
  [4236] = {.lex_state = 105},
  [4237] = {.lex_state = 104},
  [4238] = {.lex_state = 104},
  [4239] = {.lex_state = 104},
  [4240] = {.lex_state = 104},
  [4241] = {.lex_state = 104},
  [4242] = {.lex_state = 104},
  [4243] = {.lex_state = 104},
  [4244] = {.lex_state = 104},
  [4245] = {.lex_state = 4},
  [4246] = {.lex_state = 4},
  [4247] = {.lex_state = 104},
  [4248] = {.lex_state = 5, .external_lex_state = 4},
  [4249] = {.lex_state = 105},
  [4250] = {.lex_state = 105},
  [4251] = {.lex_state = 105},
  [4252] = {.lex_state = 104},
  [4253] = {.lex_state = 105},
  [4254] = {.lex_state = 104},
  [4255] = {.lex_state = 105},
  [4256] = {.lex_state = 105},
  [4257] = {.lex_state = 105},
  [4258] = {.lex_state = 105},
  [4259] = {.lex_state = 105},
  [4260] = {.lex_state = 104},
  [4261] = {.lex_state = 105},
  [4262] = {.lex_state = 105},
  [4263] = {.lex_state = 104},
  [4264] = {.lex_state = 105},
  [4265] = {.lex_state = 104},
  [4266] = {.lex_state = 105},
  [4267] = {.lex_state = 104},
  [4268] = {.lex_state = 104},
  [4269] = {.lex_state = 104},
  [4270] = {.lex_state = 4},
  [4271] = {.lex_state = 105},
  [4272] = {.lex_state = 104},
  [4273] = {.lex_state = 105},
  [4274] = {.lex_state = 104},
  [4275] = {.lex_state = 105},
  [4276] = {.lex_state = 105},
  [4277] = {.lex_state = 105},
  [4278] = {.lex_state = 4},
  [4279] = {.lex_state = 105},
  [4280] = {.lex_state = 104},
  [4281] = {.lex_state = 105},
  [4282] = {.lex_state = 105},
  [4283] = {.lex_state = 105},
  [4284] = {.lex_state = 105},
  [4285] = {.lex_state = 104},
  [4286] = {.lex_state = 105},
  [4287] = {.lex_state = 104},
  [4288] = {.lex_state = 105},
  [4289] = {.lex_state = 105},
  [4290] = {.lex_state = 104},
  [4291] = {.lex_state = 105},
  [4292] = {.lex_state = 105},
  [4293] = {.lex_state = 104},
  [4294] = {.lex_state = 105},
  [4295] = {.lex_state = 104},
  [4296] = {.lex_state = 105},
  [4297] = {.lex_state = 105},
  [4298] = {.lex_state = 104},
  [4299] = {.lex_state = 4},
  [4300] = {.lex_state = 105},
  [4301] = {.lex_state = 105},
  [4302] = {.lex_state = 105},
  [4303] = {.lex_state = 104},
  [4304] = {.lex_state = 104},
  [4305] = {.lex_state = 105},
  [4306] = {.lex_state = 104},
  [4307] = {.lex_state = 104},
  [4308] = {.lex_state = 105},
  [4309] = {.lex_state = 105},
  [4310] = {.lex_state = 105},
  [4311] = {.lex_state = 104},
  [4312] = {.lex_state = 105},
  [4313] = {.lex_state = 105},
  [4314] = {.lex_state = 105},
  [4315] = {.lex_state = 105},
  [4316] = {.lex_state = 104},
  [4317] = {.lex_state = 105},
  [4318] = {.lex_state = 105},
  [4319] = {.lex_state = 105},
  [4320] = {.lex_state = 105},
  [4321] = {.lex_state = 104},
  [4322] = {.lex_state = 104},
  [4323] = {.lex_state = 105},
  [4324] = {.lex_state = 105},
  [4325] = {.lex_state = 105},
  [4326] = {.lex_state = 105},
  [4327] = {.lex_state = 105},
  [4328] = {.lex_state = 105},
  [4329] = {.lex_state = 105},
  [4330] = {.lex_state = 105},
  [4331] = {.lex_state = 104},
  [4332] = {.lex_state = 4},
  [4333] = {.lex_state = 105},
  [4334] = {.lex_state = 104},
  [4335] = {.lex_state = 104},
  [4336] = {.lex_state = 104},
  [4337] = {.lex_state = 4},
  [4338] = {.lex_state = 105},
  [4339] = {.lex_state = 105},
  [4340] = {.lex_state = 104},
  [4341] = {.lex_state = 4},
  [4342] = {.lex_state = 4},
  [4343] = {.lex_state = 4},
  [4344] = {.lex_state = 5, .external_lex_state = 4},
  [4345] = {.lex_state = 105},
  [4346] = {.lex_state = 5},
  [4347] = {.lex_state = 105},
  [4348] = {.lex_state = 105},
  [4349] = {.lex_state = 4},
  [4350] = {.lex_state = 104},
  [4351] = {.lex_state = 105},
  [4352] = {.lex_state = 5},
  [4353] = {.lex_state = 105},
  [4354] = {.lex_state = 105},
  [4355] = {.lex_state = 105},
  [4356] = {.lex_state = 105},
  [4357] = {.lex_state = 105},
  [4358] = {.lex_state = 105},
  [4359] = {.lex_state = 4},
  [4360] = {.lex_state = 105},
  [4361] = {.lex_state = 105},
  [4362] = {.lex_state = 4},
  [4363] = {.lex_state = 104},
  [4364] = {.lex_state = 4},
  [4365] = {.lex_state = 104},
  [4366] = {.lex_state = 105},
  [4367] = {.lex_state = 104},
  [4368] = {.lex_state = 105},
  [4369] = {.lex_state = 104},
  [4370] = {.lex_state = 105},
  [4371] = {.lex_state = 104},
  [4372] = {.lex_state = 105},
  [4373] = {.lex_state = 105},
  [4374] = {.lex_state = 104},
  [4375] = {.lex_state = 104},
  [4376] = {.lex_state = 105},
  [4377] = {.lex_state = 104},
  [4378] = {.lex_state = 105},
  [4379] = {.lex_state = 10},
  [4380] = {.lex_state = 10},
  [4381] = {.lex_state = 10},
  [4382] = {.lex_state = 4},
  [4383] = {.lex_state = 105},
  [4384] = {.lex_state = 105},
  [4385] = {.lex_state = 104},
  [4386] = {.lex_state = 105},
  [4387] = {.lex_state = 104},
  [4388] = {.lex_state = 105},
  [4389] = {.lex_state = 4},
  [4390] = {.lex_state = 105},
  [4391] = {.lex_state = 104},
  [4392] = {.lex_state = 105},
  [4393] = {.lex_state = 10},
  [4394] = {.lex_state = 104},
  [4395] = {.lex_state = 104},
  [4396] = {.lex_state = 105},
  [4397] = {.lex_state = 104},
  [4398] = {.lex_state = 104},
  [4399] = {.lex_state = 105},
  [4400] = {.lex_state = 105},
  [4401] = {.lex_state = 105},
  [4402] = {.lex_state = 10},
  [4403] = {.lex_state = 105},
  [4404] = {.lex_state = 4},
  [4405] = {.lex_state = 10},
  [4406] = {.lex_state = 105},
  [4407] = {.lex_state = 104},
  [4408] = {.lex_state = 105},
  [4409] = {.lex_state = 104},
  [4410] = {.lex_state = 10},
  [4411] = {.lex_state = 104},
  [4412] = {.lex_state = 105},
  [4413] = {.lex_state = 104},
  [4414] = {.lex_state = 104},
  [4415] = {.lex_state = 104},
  [4416] = {.lex_state = 104},
  [4417] = {.lex_state = 10},
  [4418] = {.lex_state = 104},
  [4419] = {.lex_state = 4},
  [4420] = {.lex_state = 104},
  [4421] = {.lex_state = 104},
  [4422] = {.lex_state = 104},
  [4423] = {.lex_state = 105},
  [4424] = {.lex_state = 105},
  [4425] = {.lex_state = 4},
  [4426] = {.lex_state = 105},
  [4427] = {.lex_state = 104},
  [4428] = {.lex_state = 105},
  [4429] = {.lex_state = 105},
  [4430] = {.lex_state = 104},
  [4431] = {.lex_state = 10},
  [4432] = {.lex_state = 105},
  [4433] = {.lex_state = 105},
  [4434] = {.lex_state = 104},
  [4435] = {.lex_state = 10},
  [4436] = {.lex_state = 105},
  [4437] = {.lex_state = 105},
  [4438] = {.lex_state = 104},
  [4439] = {.lex_state = 105},
  [4440] = {.lex_state = 4},
  [4441] = {.lex_state = 104},
  [4442] = {.lex_state = 10},
  [4443] = {.lex_state = 105},
  [4444] = {.lex_state = 10},
  [4445] = {.lex_state = 4},
  [4446] = {.lex_state = 105},
  [4447] = {.lex_state = 10},
  [4448] = {.lex_state = 105},
  [4449] = {.lex_state = 10},
  [4450] = {.lex_state = 105},
  [4451] = {.lex_state = 104},
  [4452] = {.lex_state = 104},
  [4453] = {.lex_state = 105},
  [4454] = {.lex_state = 4},
  [4455] = {.lex_state = 104},
  [4456] = {.lex_state = 104},
  [4457] = {.lex_state = 104},
  [4458] = {.lex_state = 104},
  [4459] = {.lex_state = 104},
  [4460] = {.lex_state = 104},
  [4461] = {.lex_state = 104},
  [4462] = {.lex_state = 104},
  [4463] = {.lex_state = 104},
  [4464] = {.lex_state = 104},
  [4465] = {.lex_state = 104},
  [4466] = {.lex_state = 104},
  [4467] = {.lex_state = 4},
  [4468] = {.lex_state = 104},
  [4469] = {.lex_state = 104},
  [4470] = {.lex_state = 104},
  [4471] = {.lex_state = 105},
  [4472] = {.lex_state = 104},
  [4473] = {.lex_state = 104},
  [4474] = {.lex_state = 104},
  [4475] = {.lex_state = 7},
  [4476] = {.lex_state = 104},
  [4477] = {.lex_state = 104},
  [4478] = {.lex_state = 104},
  [4479] = {.lex_state = 104},
  [4480] = {.lex_state = 4},
  [4481] = {.lex_state = 104},
  [4482] = {.lex_state = 104},
  [4483] = {.lex_state = 104},
  [4484] = {.lex_state = 104},
  [4485] = {.lex_state = 104},
  [4486] = {.lex_state = 104},
  [4487] = {.lex_state = 105},
  [4488] = {.lex_state = 104},
  [4489] = {.lex_state = 104},
  [4490] = {.lex_state = 105},
  [4491] = {.lex_state = 104},
  [4492] = {.lex_state = 104},
  [4493] = {.lex_state = 104},
  [4494] = {.lex_state = 104},
  [4495] = {.lex_state = 104},
  [4496] = {.lex_state = 104},
  [4497] = {.lex_state = 4},
  [4498] = {.lex_state = 104},
  [4499] = {.lex_state = 104},
  [4500] = {.lex_state = 4},
  [4501] = {.lex_state = 104},
  [4502] = {.lex_state = 104},
  [4503] = {.lex_state = 104},
  [4504] = {.lex_state = 104},
  [4505] = {.lex_state = 104},
  [4506] = {.lex_state = 4},
  [4507] = {.lex_state = 104},
  [4508] = {.lex_state = 104},
  [4509] = {.lex_state = 104},
  [4510] = {.lex_state = 104},
  [4511] = {.lex_state = 104},
  [4512] = {.lex_state = 104},
  [4513] = {.lex_state = 105},
  [4514] = {.lex_state = 104},
  [4515] = {.lex_state = 104},
  [4516] = {.lex_state = 105},
  [4517] = {.lex_state = 105},
  [4518] = {.lex_state = 105},
  [4519] = {.lex_state = 105},
  [4520] = {.lex_state = 105},
  [4521] = {.lex_state = 104},
  [4522] = {.lex_state = 105},
  [4523] = {.lex_state = 105},
  [4524] = {.lex_state = 104},
  [4525] = {.lex_state = 104},
  [4526] = {.lex_state = 105},
  [4527] = {.lex_state = 104},
  [4528] = {.lex_state = 105},
  [4529] = {.lex_state = 104},
  [4530] = {.lex_state = 105},
  [4531] = {.lex_state = 105},
  [4532] = {.lex_state = 104},
  [4533] = {.lex_state = 104},
  [4534] = {.lex_state = 104},
  [4535] = {.lex_state = 10},
  [4536] = {.lex_state = 104},
  [4537] = {.lex_state = 104},
  [4538] = {.lex_state = 5},
  [4539] = {.lex_state = 105},
  [4540] = {.lex_state = 10},
  [4541] = {.lex_state = 105},
  [4542] = {.lex_state = 104},
  [4543] = {.lex_state = 104},
  [4544] = {.lex_state = 105},
  [4545] = {.lex_state = 104},
  [4546] = {.lex_state = 105},
  [4547] = {.lex_state = 104},
  [4548] = {.lex_state = 105},
  [4549] = {.lex_state = 104},
  [4550] = {.lex_state = 104},
  [4551] = {.lex_state = 105},
  [4552] = {.lex_state = 105},
  [4553] = {.lex_state = 104},
  [4554] = {.lex_state = 105},
  [4555] = {.lex_state = 104},
  [4556] = {.lex_state = 105},
  [4557] = {.lex_state = 105},
  [4558] = {.lex_state = 105},
  [4559] = {.lex_state = 104},
  [4560] = {.lex_state = 104},
  [4561] = {.lex_state = 104},
  [4562] = {.lex_state = 105},
  [4563] = {.lex_state = 105},
  [4564] = {.lex_state = 105},
  [4565] = {.lex_state = 104},
  [4566] = {.lex_state = 104},
  [4567] = {.lex_state = 104},
  [4568] = {.lex_state = 104},
  [4569] = {.lex_state = 104},
  [4570] = {.lex_state = 104},
  [4571] = {.lex_state = 104},
  [4572] = {.lex_state = 104},
  [4573] = {.lex_state = 104},
  [4574] = {.lex_state = 104},
  [4575] = {.lex_state = 104},
  [4576] = {.lex_state = 104},
  [4577] = {.lex_state = 104},
  [4578] = {.lex_state = 105},
  [4579] = {.lex_state = 105},
  [4580] = {.lex_state = 104},
  [4581] = {.lex_state = 104},
  [4582] = {.lex_state = 104},
  [4583] = {.lex_state = 105},
  [4584] = {.lex_state = 104},
  [4585] = {.lex_state = 105},
  [4586] = {.lex_state = 105},
  [4587] = {.lex_state = 105},
  [4588] = {.lex_state = 104},
  [4589] = {.lex_state = 104},
  [4590] = {.lex_state = 104},
  [4591] = {.lex_state = 104},
  [4592] = {.lex_state = 104},
  [4593] = {.lex_state = 105},
  [4594] = {.lex_state = 105},
  [4595] = {.lex_state = 104},
  [4596] = {.lex_state = 105},
  [4597] = {.lex_state = 105},
  [4598] = {.lex_state = 104},
  [4599] = {.lex_state = 104},
  [4600] = {.lex_state = 104},
  [4601] = {.lex_state = 104},
  [4602] = {.lex_state = 104},
  [4603] = {.lex_state = 105},
  [4604] = {.lex_state = 105},
  [4605] = {.lex_state = 104},
  [4606] = {.lex_state = 104},
  [4607] = {.lex_state = 105},
  [4608] = {.lex_state = 104},
  [4609] = {.lex_state = 104},
  [4610] = {.lex_state = 105},
  [4611] = {.lex_state = 104},
  [4612] = {.lex_state = 105},
  [4613] = {.lex_state = 105},
  [4614] = {.lex_state = 105},
  [4615] = {.lex_state = 104},
  [4616] = {.lex_state = 105},
  [4617] = {.lex_state = 104},
  [4618] = {.lex_state = 6},
  [4619] = {.lex_state = 104},
  [4620] = {.lex_state = 104},
  [4621] = {.lex_state = 104},
  [4622] = {.lex_state = 104},
  [4623] = {.lex_state = 104},
  [4624] = {.lex_state = 105},
  [4625] = {.lex_state = 105},
  [4626] = {.lex_state = 105},
  [4627] = {.lex_state = 105},
  [4628] = {.lex_state = 104},
  [4629] = {.lex_state = 104},
  [4630] = {.lex_state = 104},
  [4631] = {.lex_state = 104},
  [4632] = {.lex_state = 104},
  [4633] = {.lex_state = 104},
  [4634] = {.lex_state = 104},
  [4635] = {.lex_state = 104},
  [4636] = {.lex_state = 104},
  [4637] = {.lex_state = 104},
  [4638] = {.lex_state = 105},
  [4639] = {.lex_state = 104},
  [4640] = {.lex_state = 104},
  [4641] = {.lex_state = 104},
  [4642] = {.lex_state = 104},
  [4643] = {.lex_state = 104},
  [4644] = {.lex_state = 104},
  [4645] = {.lex_state = 104},
  [4646] = {.lex_state = 104},
  [4647] = {.lex_state = 104},
  [4648] = {.lex_state = 104},
  [4649] = {.lex_state = 104},
  [4650] = {.lex_state = 104},
  [4651] = {.lex_state = 104},
  [4652] = {.lex_state = 105},
  [4653] = {.lex_state = 104},
  [4654] = {.lex_state = 104},
  [4655] = {.lex_state = 104},
  [4656] = {.lex_state = 104},
  [4657] = {.lex_state = 104},
  [4658] = {.lex_state = 104},
  [4659] = {.lex_state = 104},
  [4660] = {.lex_state = 104},
  [4661] = {.lex_state = 104},
  [4662] = {.lex_state = 104},
  [4663] = {.lex_state = 104},
  [4664] = {.lex_state = 104},
  [4665] = {.lex_state = 104},
  [4666] = {.lex_state = 104},
  [4667] = {.lex_state = 104},
  [4668] = {.lex_state = 104},
  [4669] = {.lex_state = 104},
  [4670] = {.lex_state = 104},
  [4671] = {.lex_state = 104},
  [4672] = {.lex_state = 104},
  [4673] = {.lex_state = 104},
  [4674] = {.lex_state = 104},
  [4675] = {.lex_state = 104},
  [4676] = {.lex_state = 104},
  [4677] = {.lex_state = 104},
  [4678] = {.lex_state = 104},
  [4679] = {.lex_state = 104},
  [4680] = {.lex_state = 104},
  [4681] = {.lex_state = 105},
  [4682] = {.lex_state = 104},
  [4683] = {.lex_state = 104},
  [4684] = {.lex_state = 104},
  [4685] = {.lex_state = 105},
  [4686] = {.lex_state = 104},
  [4687] = {.lex_state = 104},
  [4688] = {.lex_state = 105},
  [4689] = {.lex_state = 105},
  [4690] = {.lex_state = 105},
  [4691] = {.lex_state = 105},
  [4692] = {.lex_state = 105},
  [4693] = {.lex_state = 105},
  [4694] = {.lex_state = 105},
  [4695] = {.lex_state = 104},
  [4696] = {.lex_state = 105},
  [4697] = {.lex_state = 105},
  [4698] = {.lex_state = 105},
  [4699] = {.lex_state = 105},
  [4700] = {.lex_state = 105},
  [4701] = {.lex_state = 105},
  [4702] = {.lex_state = 104},
  [4703] = {.lex_state = 104},
  [4704] = {.lex_state = 105},
  [4705] = {.lex_state = 104},
  [4706] = {.lex_state = 104},
  [4707] = {.lex_state = 104},
  [4708] = {.lex_state = 105},
  [4709] = {.lex_state = 105},
  [4710] = {.lex_state = 105},
  [4711] = {.lex_state = 105},
  [4712] = {.lex_state = 105},
  [4713] = {.lex_state = 104},
  [4714] = {.lex_state = 104},
  [4715] = {.lex_state = 104},
  [4716] = {.lex_state = 104},
  [4717] = {.lex_state = 105},
  [4718] = {.lex_state = 104},
  [4719] = {.lex_state = 104},
  [4720] = {.lex_state = 105},
  [4721] = {.lex_state = 105},
  [4722] = {.lex_state = 104},
  [4723] = {.lex_state = 105},
  [4724] = {.lex_state = 104},
  [4725] = {.lex_state = 104},
  [4726] = {.lex_state = 104},
  [4727] = {.lex_state = 104},
  [4728] = {.lex_state = 105},
  [4729] = {.lex_state = 105},
  [4730] = {.lex_state = 105},
  [4731] = {.lex_state = 105},
  [4732] = {.lex_state = 105},
  [4733] = {.lex_state = 105},
  [4734] = {.lex_state = 105},
  [4735] = {.lex_state = 105},
  [4736] = {.lex_state = 105},
  [4737] = {.lex_state = 105},
  [4738] = {.lex_state = 105},
  [4739] = {.lex_state = 105},
  [4740] = {.lex_state = 105},
  [4741] = {.lex_state = 104},
  [4742] = {.lex_state = 105},
  [4743] = {.lex_state = 105},
  [4744] = {.lex_state = 105},
  [4745] = {.lex_state = 105},
  [4746] = {.lex_state = 105},
  [4747] = {.lex_state = 104},
  [4748] = {.lex_state = 105},
  [4749] = {.lex_state = 105},
  [4750] = {.lex_state = 105},
  [4751] = {.lex_state = 105},
  [4752] = {.lex_state = 105},
  [4753] = {.lex_state = 105},
  [4754] = {.lex_state = 105},
  [4755] = {.lex_state = 105},
  [4756] = {.lex_state = 104},
  [4757] = {.lex_state = 104},
  [4758] = {.lex_state = 104},
  [4759] = {.lex_state = 104},
  [4760] = {.lex_state = 104},
  [4761] = {.lex_state = 104},
  [4762] = {.lex_state = 104},
  [4763] = {.lex_state = 104},
  [4764] = {.lex_state = 104},
  [4765] = {.lex_state = 104},
  [4766] = {.lex_state = 105},
  [4767] = {.lex_state = 105},
  [4768] = {.lex_state = 105},
  [4769] = {.lex_state = 104},
  [4770] = {.lex_state = 104},
  [4771] = {.lex_state = 104},
  [4772] = {.lex_state = 105},
  [4773] = {.lex_state = 105},
  [4774] = {.lex_state = 105},
  [4775] = {.lex_state = 105},
  [4776] = {.lex_state = 104},
  [4777] = {.lex_state = 105},
  [4778] = {.lex_state = 105},
  [4779] = {.lex_state = 105},
  [4780] = {.lex_state = 104},
  [4781] = {.lex_state = 104},
  [4782] = {.lex_state = 104},
  [4783] = {.lex_state = 105},
  [4784] = {.lex_state = 105},
  [4785] = {.lex_state = 104},
  [4786] = {.lex_state = 104},
  [4787] = {.lex_state = 105},
  [4788] = {.lex_state = 104},
  [4789] = {.lex_state = 105},
  [4790] = {.lex_state = 105},
  [4791] = {.lex_state = 104},
  [4792] = {.lex_state = 105},
  [4793] = {.lex_state = 105},
  [4794] = {.lex_state = 105},
  [4795] = {.lex_state = 104},
  [4796] = {.lex_state = 104},
  [4797] = {.lex_state = 105},
  [4798] = {.lex_state = 105},
  [4799] = {.lex_state = 105},
  [4800] = {.lex_state = 104},
  [4801] = {.lex_state = 105},
  [4802] = {.lex_state = 105},
  [4803] = {.lex_state = 104},
  [4804] = {.lex_state = 104},
  [4805] = {.lex_state = 104},
  [4806] = {.lex_state = 105},
  [4807] = {.lex_state = 104},
  [4808] = {.lex_state = 104},
  [4809] = {.lex_state = 104},
  [4810] = {.lex_state = 104},
  [4811] = {.lex_state = 104},
  [4812] = {.lex_state = 104},
  [4813] = {.lex_state = 104},
  [4814] = {.lex_state = 17},
  [4815] = {.lex_state = 104},
  [4816] = {.lex_state = 104},
  [4817] = {.lex_state = 105},
  [4818] = {.lex_state = 104},
  [4819] = {.lex_state = 104},
  [4820] = {.lex_state = 105},
  [4821] = {.lex_state = 105},
  [4822] = {.lex_state = 105},
  [4823] = {.lex_state = 105},
  [4824] = {.lex_state = 105},
  [4825] = {.lex_state = 105},
  [4826] = {.lex_state = 105},
  [4827] = {.lex_state = 104},
  [4828] = {.lex_state = 105},
  [4829] = {.lex_state = 104},
  [4830] = {.lex_state = 104},
  [4831] = {.lex_state = 10},
  [4832] = {.lex_state = 104},
  [4833] = {.lex_state = 105},
  [4834] = {.lex_state = 105},
  [4835] = {.lex_state = 105},
  [4836] = {.lex_state = 104},
  [4837] = {.lex_state = 104},
  [4838] = {.lex_state = 105},
  [4839] = {.lex_state = 105},
  [4840] = {.lex_state = 105},
  [4841] = {.lex_state = 104},
  [4842] = {.lex_state = 104},
  [4843] = {.lex_state = 105},
  [4844] = {.lex_state = 105},
  [4845] = {.lex_state = 105},
  [4846] = {.lex_state = 105},
  [4847] = {.lex_state = 105},
  [4848] = {.lex_state = 105},
  [4849] = {.lex_state = 104},
  [4850] = {.lex_state = 104},
  [4851] = {.lex_state = 105},
  [4852] = {.lex_state = 105},
  [4853] = {.lex_state = 105},
  [4854] = {.lex_state = 105},
  [4855] = {.lex_state = 104},
  [4856] = {.lex_state = 104},
  [4857] = {.lex_state = 105},
  [4858] = {.lex_state = 104},
  [4859] = {.lex_state = 104},
  [4860] = {.lex_state = 105},
  [4861] = {.lex_state = 104},
  [4862] = {.lex_state = 105},
  [4863] = {.lex_state = 105},
  [4864] = {.lex_state = 104},
  [4865] = {.lex_state = 105},
  [4866] = {.lex_state = 105},
  [4867] = {.lex_state = 104},
  [4868] = {.lex_state = 104},
  [4869] = {.lex_state = 105},
  [4870] = {.lex_state = 105},
  [4871] = {.lex_state = 104},
  [4872] = {.lex_state = 105},
  [4873] = {.lex_state = 105},
  [4874] = {.lex_state = 105},
  [4875] = {.lex_state = 105},
  [4876] = {.lex_state = 105},
  [4877] = {.lex_state = 104},
  [4878] = {.lex_state = 105},
  [4879] = {.lex_state = 104},
  [4880] = {.lex_state = 105},
  [4881] = {.lex_state = 105},
  [4882] = {.lex_state = 105},
  [4883] = {.lex_state = 105},
  [4884] = {.lex_state = 105},
  [4885] = {.lex_state = 105},
  [4886] = {.lex_state = 105},
  [4887] = {.lex_state = 105},
  [4888] = {.lex_state = 104},
  [4889] = {.lex_state = 105},
  [4890] = {.lex_state = 104},
  [4891] = {.lex_state = 104},
  [4892] = {.lex_state = 104},
  [4893] = {.lex_state = 105},
  [4894] = {.lex_state = 104},
  [4895] = {.lex_state = 104},
  [4896] = {.lex_state = 105},
  [4897] = {.lex_state = 104},
  [4898] = {.lex_state = 105},
  [4899] = {.lex_state = 105},
  [4900] = {.lex_state = 104},
  [4901] = {.lex_state = 104},
  [4902] = {.lex_state = 105},
  [4903] = {.lex_state = 105},
  [4904] = {.lex_state = 105},
  [4905] = {.lex_state = 105},
  [4906] = {.lex_state = 105},
  [4907] = {.lex_state = 104},
  [4908] = {.lex_state = 105},
  [4909] = {.lex_state = 105},
  [4910] = {.lex_state = 105},
  [4911] = {.lex_state = 105},
  [4912] = {.lex_state = 104},
  [4913] = {.lex_state = 105},
  [4914] = {.lex_state = 104},
  [4915] = {.lex_state = 105},
  [4916] = {.lex_state = 104},
  [4917] = {.lex_state = 104},
  [4918] = {.lex_state = 104},
  [4919] = {.lex_state = 104},
  [4920] = {.lex_state = 105},
  [4921] = {.lex_state = 105},
  [4922] = {.lex_state = 105},
  [4923] = {.lex_state = 104},
  [4924] = {.lex_state = 105},
  [4925] = {.lex_state = 105},
  [4926] = {.lex_state = 105},
  [4927] = {.lex_state = 104},
  [4928] = {.lex_state = 104},
  [4929] = {.lex_state = 104},
  [4930] = {.lex_state = 104},
  [4931] = {.lex_state = 105},
  [4932] = {.lex_state = 104},
  [4933] = {.lex_state = 104},
  [4934] = {.lex_state = 104},
  [4935] = {.lex_state = 104},
  [4936] = {.lex_state = 105},
  [4937] = {.lex_state = 104},
  [4938] = {.lex_state = 104},
  [4939] = {.lex_state = 104},
  [4940] = {.lex_state = 104},
  [4941] = {.lex_state = 104},
  [4942] = {.lex_state = 105},
  [4943] = {.lex_state = 104},
  [4944] = {.lex_state = 104},
  [4945] = {.lex_state = 104},
  [4946] = {.lex_state = 104},
  [4947] = {.lex_state = 104},
  [4948] = {.lex_state = 104},
  [4949] = {.lex_state = 10},
  [4950] = {.lex_state = 104},
  [4951] = {.lex_state = 104},
  [4952] = {.lex_state = 104},
  [4953] = {.lex_state = 104},
  [4954] = {.lex_state = 104},
  [4955] = {.lex_state = 104},
  [4956] = {.lex_state = 104},
  [4957] = {.lex_state = 104},
  [4958] = {.lex_state = 104},
  [4959] = {.lex_state = 104},
  [4960] = {.lex_state = 104},
  [4961] = {.lex_state = 104},
  [4962] = {.lex_state = 104},
  [4963] = {.lex_state = 104},
  [4964] = {.lex_state = 104},
  [4965] = {.lex_state = 104},
  [4966] = {.lex_state = 104},
  [4967] = {.lex_state = 104},
  [4968] = {.lex_state = 104},
  [4969] = {.lex_state = 104},
  [4970] = {.lex_state = 104},
  [4971] = {.lex_state = 104},
  [4972] = {.lex_state = 104},
  [4973] = {.lex_state = 104},
  [4974] = {.lex_state = 104},
  [4975] = {.lex_state = 104},
  [4976] = {.lex_state = 104},
  [4977] = {.lex_state = 104},
  [4978] = {.lex_state = 104},
  [4979] = {.lex_state = 104},
  [4980] = {.lex_state = 104},
  [4981] = {.lex_state = 104},
  [4982] = {.lex_state = 104},
  [4983] = {.lex_state = 104},
  [4984] = {.lex_state = 104},
  [4985] = {.lex_state = 17},
  [4986] = {.lex_state = 104},
  [4987] = {.lex_state = 104},
  [4988] = {.lex_state = 17},
  [4989] = {.lex_state = 104},
  [4990] = {.lex_state = 17},
  [4991] = {.lex_state = 104},
  [4992] = {.lex_state = 104},
  [4993] = {.lex_state = 104},
  [4994] = {.lex_state = 104},
  [4995] = {.lex_state = 104},
  [4996] = {.lex_state = 104},
  [4997] = {.lex_state = 17},
  [4998] = {.lex_state = 104},
  [4999] = {.lex_state = 104},
  [5000] = {.lex_state = 104},
  [5001] = {.lex_state = 104},
  [5002] = {.lex_state = 104},
  [5003] = {.lex_state = 104},
  [5004] = {.lex_state = 104},
  [5005] = {.lex_state = 104},
  [5006] = {.lex_state = 105},
  [5007] = {.lex_state = 104},
  [5008] = {.lex_state = 104},
  [5009] = {.lex_state = 17},
  [5010] = {.lex_state = 104},
  [5011] = {.lex_state = 104},
  [5012] = {.lex_state = 104},
  [5013] = {.lex_state = 104},
  [5014] = {.lex_state = 104},
  [5015] = {.lex_state = 104},
  [5016] = {.lex_state = 104},
  [5017] = {.lex_state = 104},
  [5018] = {.lex_state = 104},
  [5019] = {.lex_state = 104},
  [5020] = {.lex_state = 104},
  [5021] = {.lex_state = 104},
  [5022] = {.lex_state = 104},
  [5023] = {.lex_state = 104},
  [5024] = {.lex_state = 104},
  [5025] = {.lex_state = 104},
  [5026] = {.lex_state = 104},
  [5027] = {.lex_state = 104},
  [5028] = {.lex_state = 104},
  [5029] = {.lex_state = 104},
  [5030] = {.lex_state = 104},
  [5031] = {.lex_state = 104},
  [5032] = {.lex_state = 104},
  [5033] = {.lex_state = 17},
  [5034] = {.lex_state = 104},
  [5035] = {.lex_state = 17},
  [5036] = {.lex_state = 104},
  [5037] = {.lex_state = 104},
  [5038] = {.lex_state = 104},
  [5039] = {.lex_state = 104},
  [5040] = {.lex_state = 104},
  [5041] = {.lex_state = 104},
  [5042] = {.lex_state = 104},
  [5043] = {.lex_state = 104},
  [5044] = {.lex_state = 104},
  [5045] = {.lex_state = 105},
  [5046] = {.lex_state = 104},
  [5047] = {.lex_state = 104},
  [5048] = {.lex_state = 104},
  [5049] = {.lex_state = 104},
  [5050] = {.lex_state = 104},
  [5051] = {.lex_state = 104},
  [5052] = {.lex_state = 104},
  [5053] = {.lex_state = 104},
  [5054] = {.lex_state = 104},
  [5055] = {.lex_state = 104},
  [5056] = {.lex_state = 104},
  [5057] = {.lex_state = 104},
  [5058] = {.lex_state = 104},
  [5059] = {.lex_state = 104},
  [5060] = {.lex_state = 104},
  [5061] = {.lex_state = 104},
  [5062] = {.lex_state = 104},
  [5063] = {.lex_state = 104},
  [5064] = {.lex_state = 104},
  [5065] = {.lex_state = 104},
  [5066] = {.lex_state = 104},
  [5067] = {.lex_state = 104},
  [5068] = {.lex_state = 104},
  [5069] = {.lex_state = 104},
  [5070] = {.lex_state = 104},
  [5071] = {.lex_state = 104},
  [5072] = {.lex_state = 104},
  [5073] = {.lex_state = 104},
  [5074] = {.lex_state = 104},
  [5075] = {.lex_state = 104},
  [5076] = {.lex_state = 104},
  [5077] = {.lex_state = 104},
  [5078] = {.lex_state = 104},
  [5079] = {.lex_state = 104},
  [5080] = {.lex_state = 104},
  [5081] = {.lex_state = 104},
  [5082] = {.lex_state = 104},
  [5083] = {.lex_state = 104},
  [5084] = {.lex_state = 104},
  [5085] = {.lex_state = 104},
  [5086] = {.lex_state = 104},
  [5087] = {.lex_state = 104},
  [5088] = {.lex_state = 104},
  [5089] = {.lex_state = 104},
  [5090] = {.lex_state = 104},
  [5091] = {.lex_state = 104},
  [5092] = {.lex_state = 104},
  [5093] = {.lex_state = 104},
  [5094] = {.lex_state = 104},
  [5095] = {.lex_state = 104},
  [5096] = {.lex_state = 104, .external_lex_state = 4},
  [5097] = {.lex_state = 104},
  [5098] = {.lex_state = 104},
  [5099] = {.lex_state = 17},
  [5100] = {.lex_state = 104},
  [5101] = {.lex_state = 104},
  [5102] = {.lex_state = 104},
  [5103] = {.lex_state = 104},
  [5104] = {.lex_state = 104},
  [5105] = {.lex_state = 104},
  [5106] = {.lex_state = 104},
  [5107] = {.lex_state = 104},
  [5108] = {.lex_state = 104},
  [5109] = {.lex_state = 104},
  [5110] = {.lex_state = 6, .external_lex_state = 4},
  [5111] = {.lex_state = 104},
  [5112] = {.lex_state = 104},
  [5113] = {.lex_state = 104},
  [5114] = {.lex_state = 104},
  [5115] = {.lex_state = 104},
  [5116] = {.lex_state = 104},
  [5117] = {.lex_state = 104},
  [5118] = {.lex_state = 104},
  [5119] = {.lex_state = 104},
  [5120] = {.lex_state = 104},
  [5121] = {.lex_state = 104},
  [5122] = {.lex_state = 104},
  [5123] = {.lex_state = 104},
  [5124] = {.lex_state = 104},
  [5125] = {.lex_state = 104},
  [5126] = {.lex_state = 104},
  [5127] = {.lex_state = 104},
  [5128] = {.lex_state = 104},
  [5129] = {.lex_state = 104},
  [5130] = {.lex_state = 104},
  [5131] = {.lex_state = 10},
  [5132] = {.lex_state = 104},
  [5133] = {.lex_state = 104},
  [5134] = {.lex_state = 104},
  [5135] = {.lex_state = 104},
  [5136] = {.lex_state = 104, .external_lex_state = 4},
  [5137] = {.lex_state = 104},
  [5138] = {.lex_state = 104},
  [5139] = {.lex_state = 105},
  [5140] = {.lex_state = 104},
  [5141] = {.lex_state = 104},
  [5142] = {.lex_state = 104},
  [5143] = {.lex_state = 104},
  [5144] = {.lex_state = 104},
  [5145] = {.lex_state = 104},
  [5146] = {.lex_state = 104},
  [5147] = {.lex_state = 104},
  [5148] = {.lex_state = 104},
  [5149] = {.lex_state = 104, .external_lex_state = 4},
  [5150] = {.lex_state = 104},
  [5151] = {.lex_state = 104},
  [5152] = {.lex_state = 104},
  [5153] = {.lex_state = 104, .external_lex_state = 4},
  [5154] = {.lex_state = 104, .external_lex_state = 4},
  [5155] = {.lex_state = 104},
  [5156] = {.lex_state = 104, .external_lex_state = 4},
  [5157] = {.lex_state = 104},
  [5158] = {.lex_state = 104},
  [5159] = {.lex_state = 104},
  [5160] = {.lex_state = 104, .external_lex_state = 4},
  [5161] = {.lex_state = 104, .external_lex_state = 4},
  [5162] = {.lex_state = 104},
  [5163] = {.lex_state = 104, .external_lex_state = 4},
  [5164] = {.lex_state = 104},
  [5165] = {.lex_state = 104, .external_lex_state = 4},
  [5166] = {.lex_state = 104, .external_lex_state = 4},
  [5167] = {.lex_state = 105},
  [5168] = {.lex_state = 104},
  [5169] = {.lex_state = 10},
  [5170] = {.lex_state = 104},
  [5171] = {.lex_state = 104, .external_lex_state = 4},
  [5172] = {.lex_state = 104},
  [5173] = {.lex_state = 104, .external_lex_state = 4},
  [5174] = {.lex_state = 104},
  [5175] = {.lex_state = 105},
  [5176] = {.lex_state = 104},
  [5177] = {.lex_state = 104, .external_lex_state = 4},
  [5178] = {.lex_state = 104, .external_lex_state = 4},
  [5179] = {.lex_state = 104},
  [5180] = {.lex_state = 104, .external_lex_state = 4},
  [5181] = {.lex_state = 104, .external_lex_state = 4},
  [5182] = {.lex_state = 104},
  [5183] = {.lex_state = 104},
  [5184] = {.lex_state = 104},
  [5185] = {.lex_state = 104},
  [5186] = {.lex_state = 104, .external_lex_state = 4},
  [5187] = {.lex_state = 104},
  [5188] = {.lex_state = 104},
  [5189] = {.lex_state = 104, .external_lex_state = 4},
  [5190] = {.lex_state = 105},
  [5191] = {.lex_state = 6, .external_lex_state = 4},
  [5192] = {.lex_state = 6, .external_lex_state = 4},
  [5193] = {.lex_state = 104, .external_lex_state = 4},
  [5194] = {.lex_state = 104, .external_lex_state = 4},
  [5195] = {.lex_state = 6, .external_lex_state = 4},
  [5196] = {.lex_state = 104, .external_lex_state = 4},
  [5197] = {.lex_state = 104, .external_lex_state = 4},
  [5198] = {.lex_state = 104, .external_lex_state = 4},
  [5199] = {.lex_state = 17},
  [5200] = {.lex_state = 104, .external_lex_state = 4},
  [5201] = {.lex_state = 104},
  [5202] = {.lex_state = 104, .external_lex_state = 4},
  [5203] = {.lex_state = 105},
  [5204] = {.lex_state = 104},
  [5205] = {.lex_state = 105},
  [5206] = {.lex_state = 10},
  [5207] = {.lex_state = 104, .external_lex_state = 4},
  [5208] = {.lex_state = 104, .external_lex_state = 4},
  [5209] = {.lex_state = 104},
  [5210] = {.lex_state = 104, .external_lex_state = 4},
  [5211] = {.lex_state = 104, .external_lex_state = 4},
  [5212] = {.lex_state = 104, .external_lex_state = 4},
  [5213] = {.lex_state = 104, .external_lex_state = 4},
  [5214] = {.lex_state = 104},
  [5215] = {.lex_state = 104},
  [5216] = {.lex_state = 104, .external_lex_state = 4},
  [5217] = {.lex_state = 104, .external_lex_state = 4},
  [5218] = {.lex_state = 104},
  [5219] = {.lex_state = 104},
  [5220] = {.lex_state = 104},
  [5221] = {.lex_state = 104},
  [5222] = {.lex_state = 104},
  [5223] = {.lex_state = 104},
  [5224] = {.lex_state = 104, .external_lex_state = 4},
  [5225] = {.lex_state = 104},
  [5226] = {.lex_state = 104},
  [5227] = {.lex_state = 104},
  [5228] = {.lex_state = 104, .external_lex_state = 4},
  [5229] = {.lex_state = 104, .external_lex_state = 4},
  [5230] = {.lex_state = 104},
  [5231] = {.lex_state = 104},
  [5232] = {.lex_state = 104},
  [5233] = {.lex_state = 104},
  [5234] = {.lex_state = 104},
  [5235] = {.lex_state = 104},
  [5236] = {.lex_state = 104, .external_lex_state = 4},
  [5237] = {.lex_state = 104, .external_lex_state = 4},
  [5238] = {.lex_state = 104},
  [5239] = {.lex_state = 104},
  [5240] = {.lex_state = 104},
  [5241] = {.lex_state = 104},
  [5242] = {.lex_state = 104, .external_lex_state = 4},
  [5243] = {.lex_state = 104, .external_lex_state = 4},
  [5244] = {.lex_state = 104},
  [5245] = {.lex_state = 104, .external_lex_state = 4},
  [5246] = {.lex_state = 104},
  [5247] = {.lex_state = 104},
  [5248] = {.lex_state = 105},
  [5249] = {.lex_state = 104},
  [5250] = {.lex_state = 104},
  [5251] = {.lex_state = 104},
  [5252] = {.lex_state = 104},
  [5253] = {.lex_state = 104},
  [5254] = {.lex_state = 104},
  [5255] = {.lex_state = 104},
  [5256] = {.lex_state = 104, .external_lex_state = 4},
  [5257] = {.lex_state = 104, .external_lex_state = 4},
  [5258] = {.lex_state = 104},
  [5259] = {.lex_state = 104, .external_lex_state = 4},
  [5260] = {.lex_state = 17},
  [5261] = {.lex_state = 105},
  [5262] = {.lex_state = 104},
  [5263] = {.lex_state = 104},
  [5264] = {.lex_state = 104},
  [5265] = {.lex_state = 104},
  [5266] = {.lex_state = 104, .external_lex_state = 4},
  [5267] = {.lex_state = 104},
  [5268] = {.lex_state = 104},
  [5269] = {.lex_state = 105},
  [5270] = {.lex_state = 104},
  [5271] = {.lex_state = 105},
  [5272] = {.lex_state = 104},
  [5273] = {.lex_state = 104},
  [5274] = {.lex_state = 104, .external_lex_state = 4},
  [5275] = {.lex_state = 104},
  [5276] = {.lex_state = 104, .external_lex_state = 4},
  [5277] = {.lex_state = 104, .external_lex_state = 4},
  [5278] = {.lex_state = 104, .external_lex_state = 4},
  [5279] = {.lex_state = 105},
  [5280] = {.lex_state = 104, .external_lex_state = 4},
  [5281] = {.lex_state = 104},
  [5282] = {.lex_state = 104},
  [5283] = {.lex_state = 104},
  [5284] = {.lex_state = 104, .external_lex_state = 4},
  [5285] = {.lex_state = 104, .external_lex_state = 4},
  [5286] = {.lex_state = 104, .external_lex_state = 4},
  [5287] = {.lex_state = 104, .external_lex_state = 4},
  [5288] = {.lex_state = 104, .external_lex_state = 4},
  [5289] = {.lex_state = 104, .external_lex_state = 4},
  [5290] = {.lex_state = 104, .external_lex_state = 4},
  [5291] = {.lex_state = 104},
  [5292] = {.lex_state = 104, .external_lex_state = 4},
  [5293] = {.lex_state = 104, .external_lex_state = 4},
  [5294] = {.lex_state = 104, .external_lex_state = 4},
  [5295] = {.lex_state = 104},
  [5296] = {.lex_state = 104, .external_lex_state = 4},
  [5297] = {.lex_state = 104},
  [5298] = {.lex_state = 104},
  [5299] = {.lex_state = 104, .external_lex_state = 4},
  [5300] = {.lex_state = 104},
  [5301] = {.lex_state = 104, .external_lex_state = 4},
  [5302] = {.lex_state = 104},
  [5303] = {.lex_state = 104, .external_lex_state = 4},
  [5304] = {.lex_state = 104},
  [5305] = {.lex_state = 17},
  [5306] = {.lex_state = 104},
  [5307] = {.lex_state = 104, .external_lex_state = 4},
  [5308] = {.lex_state = 104, .external_lex_state = 4},
  [5309] = {.lex_state = 104, .external_lex_state = 4},
  [5310] = {.lex_state = 104, .external_lex_state = 4},
  [5311] = {.lex_state = 104, .external_lex_state = 4},
  [5312] = {.lex_state = 104, .external_lex_state = 4},
  [5313] = {.lex_state = 104, .external_lex_state = 4},
  [5314] = {.lex_state = 104, .external_lex_state = 4},
  [5315] = {.lex_state = 7, .external_lex_state = 4},
  [5316] = {.lex_state = 104, .external_lex_state = 4},
  [5317] = {.lex_state = 17},
  [5318] = {.lex_state = 104},
  [5319] = {.lex_state = 104, .external_lex_state = 4},
  [5320] = {.lex_state = 104},
  [5321] = {.lex_state = 104, .external_lex_state = 4},
  [5322] = {.lex_state = 104, .external_lex_state = 4},
  [5323] = {.lex_state = 104},
  [5324] = {.lex_state = 104},
  [5325] = {.lex_state = 104},
  [5326] = {.lex_state = 104},
  [5327] = {.lex_state = 17},
  [5328] = {.lex_state = 104},
  [5329] = {.lex_state = 104},
  [5330] = {.lex_state = 104},
  [5331] = {.lex_state = 104},
  [5332] = {.lex_state = 104, .external_lex_state = 4},
  [5333] = {.lex_state = 104, .external_lex_state = 4},
  [5334] = {.lex_state = 105},
  [5335] = {.lex_state = 104},
  [5336] = {.lex_state = 104},
  [5337] = {.lex_state = 104},
  [5338] = {.lex_state = 104},
  [5339] = {.lex_state = 104, .external_lex_state = 4},
  [5340] = {.lex_state = 17},
  [5341] = {.lex_state = 104},
  [5342] = {.lex_state = 17},
  [5343] = {.lex_state = 104},
  [5344] = {.lex_state = 104},
  [5345] = {.lex_state = 104},
  [5346] = {.lex_state = 104},
  [5347] = {.lex_state = 104},
  [5348] = {.lex_state = 104},
  [5349] = {.lex_state = 104},
  [5350] = {.lex_state = 104},
  [5351] = {.lex_state = 104},
  [5352] = {.lex_state = 104},
  [5353] = {.lex_state = 104},
  [5354] = {.lex_state = 104},
  [5355] = {.lex_state = 104},
  [5356] = {.lex_state = 104},
  [5357] = {.lex_state = 104},
  [5358] = {.lex_state = 104},
  [5359] = {.lex_state = 104, .external_lex_state = 4},
  [5360] = {.lex_state = 104},
  [5361] = {.lex_state = 104},
  [5362] = {.lex_state = 104, .external_lex_state = 4},
  [5363] = {.lex_state = 6},
  [5364] = {.lex_state = 104},
  [5365] = {.lex_state = 104},
  [5366] = {.lex_state = 104},
  [5367] = {.lex_state = 104},
  [5368] = {.lex_state = 104},
  [5369] = {.lex_state = 104},
  [5370] = {.lex_state = 104},
  [5371] = {.lex_state = 104},
  [5372] = {.lex_state = 104, .external_lex_state = 4},
  [5373] = {.lex_state = 104},
  [5374] = {.lex_state = 104},
  [5375] = {.lex_state = 104},
  [5376] = {.lex_state = 104},
  [5377] = {.lex_state = 104, .external_lex_state = 4},
  [5378] = {.lex_state = 104},
  [5379] = {.lex_state = 104, .external_lex_state = 4},
  [5380] = {.lex_state = 104},
  [5381] = {.lex_state = 104, .external_lex_state = 4},
  [5382] = {.lex_state = 104},
  [5383] = {.lex_state = 104, .external_lex_state = 4},
  [5384] = {.lex_state = 104, .external_lex_state = 4},
  [5385] = {.lex_state = 104},
  [5386] = {.lex_state = 104},
  [5387] = {.lex_state = 104},
  [5388] = {.lex_state = 104},
  [5389] = {.lex_state = 104},
  [5390] = {.lex_state = 104, .external_lex_state = 4},
  [5391] = {.lex_state = 104, .external_lex_state = 4},
  [5392] = {.lex_state = 104, .external_lex_state = 4},
  [5393] = {.lex_state = 104, .external_lex_state = 4},
  [5394] = {.lex_state = 104},
  [5395] = {.lex_state = 104, .external_lex_state = 4},
  [5396] = {.lex_state = 104, .external_lex_state = 4},
  [5397] = {.lex_state = 104, .external_lex_state = 4},
  [5398] = {.lex_state = 104, .external_lex_state = 4},
  [5399] = {.lex_state = 105},
  [5400] = {.lex_state = 104, .external_lex_state = 4},
  [5401] = {.lex_state = 104, .external_lex_state = 4},
  [5402] = {.lex_state = 104},
  [5403] = {.lex_state = 104, .external_lex_state = 4},
  [5404] = {.lex_state = 104},
  [5405] = {.lex_state = 104},
  [5406] = {.lex_state = 104, .external_lex_state = 4},
  [5407] = {.lex_state = 104, .external_lex_state = 4},
  [5408] = {.lex_state = 104, .external_lex_state = 4},
  [5409] = {.lex_state = 104, .external_lex_state = 4},
  [5410] = {.lex_state = 104},
  [5411] = {.lex_state = 104},
  [5412] = {.lex_state = 104},
  [5413] = {.lex_state = 104},
  [5414] = {.lex_state = 104},
  [5415] = {.lex_state = 104},
  [5416] = {.lex_state = 104},
  [5417] = {.lex_state = 104},
  [5418] = {.lex_state = 104},
  [5419] = {.lex_state = 104},
  [5420] = {.lex_state = 104},
  [5421] = {.lex_state = 104},
  [5422] = {.lex_state = 104},
  [5423] = {.lex_state = 104},
  [5424] = {.lex_state = 104},
  [5425] = {.lex_state = 104},
  [5426] = {.lex_state = 17},
  [5427] = {.lex_state = 104},
  [5428] = {.lex_state = 104},
  [5429] = {.lex_state = 104},
  [5430] = {.lex_state = 104},
  [5431] = {.lex_state = 104},
  [5432] = {.lex_state = 104},
  [5433] = {.lex_state = 104},
  [5434] = {.lex_state = 104},
  [5435] = {.lex_state = 104},
  [5436] = {.lex_state = 104},
  [5437] = {.lex_state = 104},
  [5438] = {.lex_state = 104},
  [5439] = {.lex_state = 104},
  [5440] = {.lex_state = 17},
  [5441] = {.lex_state = 104},
  [5442] = {.lex_state = 104},
  [5443] = {.lex_state = 104},
  [5444] = {.lex_state = 104},
  [5445] = {.lex_state = 104},
  [5446] = {.lex_state = 104},
  [5447] = {.lex_state = 104},
  [5448] = {.lex_state = 104},
  [5449] = {.lex_state = 104},
  [5450] = {.lex_state = 104},
  [5451] = {.lex_state = 104},
  [5452] = {.lex_state = 104},
  [5453] = {.lex_state = 104},
  [5454] = {.lex_state = 104},
  [5455] = {.lex_state = 104},
  [5456] = {.lex_state = 104},
  [5457] = {.lex_state = 104},
  [5458] = {.lex_state = 104},
  [5459] = {.lex_state = 104},
  [5460] = {.lex_state = 104},
  [5461] = {.lex_state = 104},
  [5462] = {.lex_state = 104},
  [5463] = {.lex_state = 104},
  [5464] = {.lex_state = 104},
  [5465] = {.lex_state = 104},
  [5466] = {.lex_state = 104},
  [5467] = {.lex_state = 105},
  [5468] = {.lex_state = 104},
  [5469] = {.lex_state = 104},
  [5470] = {.lex_state = 104},
  [5471] = {.lex_state = 104},
  [5472] = {.lex_state = 104},
  [5473] = {.lex_state = 104},
  [5474] = {.lex_state = 104},
  [5475] = {.lex_state = 104},
  [5476] = {.lex_state = 105},
  [5477] = {.lex_state = 104},
  [5478] = {.lex_state = 104},
  [5479] = {.lex_state = 104},
  [5480] = {.lex_state = 104},
  [5481] = {.lex_state = 104},
  [5482] = {.lex_state = 104},
  [5483] = {.lex_state = 104},
  [5484] = {.lex_state = 104},
  [5485] = {.lex_state = 104},
  [5486] = {.lex_state = 104},
  [5487] = {.lex_state = 104},
  [5488] = {.lex_state = 104},
  [5489] = {.lex_state = 104},
  [5490] = {.lex_state = 104},
  [5491] = {.lex_state = 104},
  [5492] = {.lex_state = 104},
  [5493] = {.lex_state = 104},
  [5494] = {.lex_state = 104},
  [5495] = {.lex_state = 104, .external_lex_state = 4},
  [5496] = {.lex_state = 6},
  [5497] = {.lex_state = 104, .external_lex_state = 4},
  [5498] = {.lex_state = 104, .external_lex_state = 4},
  [5499] = {.lex_state = 104},
  [5500] = {.lex_state = 104},
  [5501] = {.lex_state = 104},
  [5502] = {.lex_state = 104},
  [5503] = {.lex_state = 104},
  [5504] = {.lex_state = 104},
  [5505] = {.lex_state = 104},
  [5506] = {.lex_state = 104},
  [5507] = {.lex_state = 104},
  [5508] = {.lex_state = 104},
  [5509] = {.lex_state = 104},
  [5510] = {.lex_state = 104},
  [5511] = {.lex_state = 104},
  [5512] = {.lex_state = 104},
  [5513] = {.lex_state = 104, .external_lex_state = 4},
  [5514] = {.lex_state = 104, .external_lex_state = 4},
  [5515] = {.lex_state = 104},
  [5516] = {.lex_state = 104},
  [5517] = {.lex_state = 104},
  [5518] = {.lex_state = 104},
  [5519] = {.lex_state = 104},
  [5520] = {.lex_state = 104},
  [5521] = {.lex_state = 104},
  [5522] = {.lex_state = 104},
  [5523] = {.lex_state = 104},
  [5524] = {.lex_state = 104},
  [5525] = {.lex_state = 104},
  [5526] = {.lex_state = 104},
  [5527] = {.lex_state = 104, .external_lex_state = 4},
  [5528] = {.lex_state = 104},
  [5529] = {.lex_state = 104},
  [5530] = {.lex_state = 104},
  [5531] = {.lex_state = 104},
  [5532] = {.lex_state = 104},
  [5533] = {.lex_state = 104},
  [5534] = {.lex_state = 104},
  [5535] = {.lex_state = 104},
  [5536] = {.lex_state = 104},
  [5537] = {.lex_state = 104},
  [5538] = {.lex_state = 104},
  [5539] = {.lex_state = 104},
  [5540] = {.lex_state = 104},
  [5541] = {.lex_state = 104},
  [5542] = {.lex_state = 104},
  [5543] = {.lex_state = 104},
  [5544] = {.lex_state = 104},
  [5545] = {.lex_state = 104},
  [5546] = {.lex_state = 104},
  [5547] = {.lex_state = 104, .external_lex_state = 4},
  [5548] = {.lex_state = 104, .external_lex_state = 4},
  [5549] = {.lex_state = 104},
  [5550] = {.lex_state = 104},
  [5551] = {.lex_state = 104},
  [5552] = {.lex_state = 104, .external_lex_state = 4},
  [5553] = {.lex_state = 104, .external_lex_state = 4},
  [5554] = {.lex_state = 104},
  [5555] = {.lex_state = 104, .external_lex_state = 4},
  [5556] = {.lex_state = 104, .external_lex_state = 4},
  [5557] = {.lex_state = 104, .external_lex_state = 4},
  [5558] = {.lex_state = 104, .external_lex_state = 4},
  [5559] = {.lex_state = 104, .external_lex_state = 4},
  [5560] = {.lex_state = 104, .external_lex_state = 4},
  [5561] = {.lex_state = 104, .external_lex_state = 4},
  [5562] = {.lex_state = 104, .external_lex_state = 4},
  [5563] = {.lex_state = 104, .external_lex_state = 4},
  [5564] = {.lex_state = 104, .external_lex_state = 4},
  [5565] = {.lex_state = 104},
  [5566] = {.lex_state = 104},
  [5567] = {.lex_state = 104},
  [5568] = {.lex_state = 104},
  [5569] = {.lex_state = 104},
  [5570] = {.lex_state = 104, .external_lex_state = 4},
  [5571] = {.lex_state = 104, .external_lex_state = 4},
  [5572] = {.lex_state = 104, .external_lex_state = 4},
  [5573] = {.lex_state = 104},
  [5574] = {.lex_state = 104, .external_lex_state = 4},
  [5575] = {.lex_state = 104},
  [5576] = {.lex_state = 104, .external_lex_state = 4},
  [5577] = {.lex_state = 104, .external_lex_state = 4},
  [5578] = {.lex_state = 104, .external_lex_state = 4},
  [5579] = {.lex_state = 104, .external_lex_state = 4},
  [5580] = {.lex_state = 104, .external_lex_state = 4},
  [5581] = {.lex_state = 104, .external_lex_state = 4},
  [5582] = {.lex_state = 104},
  [5583] = {.lex_state = 104, .external_lex_state = 4},
  [5584] = {.lex_state = 104, .external_lex_state = 4},
  [5585] = {.lex_state = 104, .external_lex_state = 4},
  [5586] = {.lex_state = 104, .external_lex_state = 4},
  [5587] = {.lex_state = 104},
  [5588] = {.lex_state = 104},
  [5589] = {.lex_state = 104},
  [5590] = {.lex_state = 104},
  [5591] = {.lex_state = 104, .external_lex_state = 4},
  [5592] = {.lex_state = 104, .external_lex_state = 4},
  [5593] = {.lex_state = 104},
  [5594] = {.lex_state = 104, .external_lex_state = 4},
  [5595] = {.lex_state = 104, .external_lex_state = 4},
  [5596] = {.lex_state = 104, .external_lex_state = 4},
  [5597] = {.lex_state = 104, .external_lex_state = 4},
  [5598] = {.lex_state = 104, .external_lex_state = 4},
  [5599] = {.lex_state = 104, .external_lex_state = 4},
  [5600] = {.lex_state = 104, .external_lex_state = 4},
  [5601] = {.lex_state = 104, .external_lex_state = 4},
  [5602] = {.lex_state = 104, .external_lex_state = 4},
  [5603] = {.lex_state = 104, .external_lex_state = 4},
  [5604] = {.lex_state = 104},
  [5605] = {.lex_state = 104},
  [5606] = {.lex_state = 104},
  [5607] = {.lex_state = 104},
  [5608] = {.lex_state = 104},
  [5609] = {.lex_state = 104},
  [5610] = {.lex_state = 104},
  [5611] = {.lex_state = 104},
  [5612] = {.lex_state = 104},
  [5613] = {.lex_state = 104},
  [5614] = {.lex_state = 104},
  [5615] = {.lex_state = 104, .external_lex_state = 4},
  [5616] = {.lex_state = 104, .external_lex_state = 4},
  [5617] = {.lex_state = 104, .external_lex_state = 4},
  [5618] = {.lex_state = 104, .external_lex_state = 4},
  [5619] = {.lex_state = 104},
  [5620] = {.lex_state = 104, .external_lex_state = 4},
  [5621] = {.lex_state = 104, .external_lex_state = 4},
  [5622] = {.lex_state = 104, .external_lex_state = 4},
  [5623] = {.lex_state = 104},
  [5624] = {.lex_state = 104},
  [5625] = {.lex_state = 104},
  [5626] = {.lex_state = 104},
  [5627] = {.lex_state = 104},
  [5628] = {.lex_state = 104},
  [5629] = {.lex_state = 104},
  [5630] = {.lex_state = 104},
  [5631] = {.lex_state = 104},
  [5632] = {.lex_state = 104},
  [5633] = {.lex_state = 104},
  [5634] = {.lex_state = 104},
  [5635] = {.lex_state = 104},
  [5636] = {.lex_state = 104},
  [5637] = {.lex_state = 104},
  [5638] = {.lex_state = 104},
  [5639] = {.lex_state = 104},
  [5640] = {.lex_state = 104},
  [5641] = {.lex_state = 104},
  [5642] = {.lex_state = 104},
  [5643] = {.lex_state = 104},
  [5644] = {.lex_state = 104},
  [5645] = {.lex_state = 104},
  [5646] = {.lex_state = 104},
  [5647] = {.lex_state = 104, .external_lex_state = 4},
  [5648] = {.lex_state = 104, .external_lex_state = 4},
  [5649] = {.lex_state = 104},
  [5650] = {.lex_state = 104, .external_lex_state = 4},
  [5651] = {.lex_state = 104},
  [5652] = {.lex_state = 104, .external_lex_state = 4},
  [5653] = {.lex_state = 104, .external_lex_state = 4},
  [5654] = {.lex_state = 104},
  [5655] = {.lex_state = 104},
  [5656] = {.lex_state = 104},
  [5657] = {.lex_state = 104},
  [5658] = {.lex_state = 104, .external_lex_state = 4},
  [5659] = {.lex_state = 104, .external_lex_state = 4},
  [5660] = {.lex_state = 104},
  [5661] = {.lex_state = 104},
  [5662] = {.lex_state = 104},
  [5663] = {.lex_state = 104},
  [5664] = {.lex_state = 104},
  [5665] = {.lex_state = 104},
  [5666] = {.lex_state = 104},
  [5667] = {.lex_state = 104},
  [5668] = {.lex_state = 104},
  [5669] = {.lex_state = 104},
  [5670] = {.lex_state = 104},
  [5671] = {.lex_state = 104},
  [5672] = {.lex_state = 104},
  [5673] = {.lex_state = 104},
  [5674] = {.lex_state = 104},
  [5675] = {.lex_state = 104},
  [5676] = {.lex_state = 104},
  [5677] = {.lex_state = 104, .external_lex_state = 4},
  [5678] = {.lex_state = 104},
  [5679] = {.lex_state = 104},
  [5680] = {.lex_state = 104},
  [5681] = {.lex_state = 104},
  [5682] = {.lex_state = 104},
  [5683] = {.lex_state = 104, .external_lex_state = 4},
  [5684] = {.lex_state = 104, .external_lex_state = 4},
  [5685] = {.lex_state = 105},
  [5686] = {.lex_state = 104, .external_lex_state = 4},
  [5687] = {.lex_state = 104, .external_lex_state = 4},
  [5688] = {.lex_state = 104},
  [5689] = {.lex_state = 104},
  [5690] = {.lex_state = 104, .external_lex_state = 4},
  [5691] = {.lex_state = 104, .external_lex_state = 4},
  [5692] = {.lex_state = 104, .external_lex_state = 4},
  [5693] = {.lex_state = 104, .external_lex_state = 4},
  [5694] = {.lex_state = 104},
  [5695] = {.lex_state = 104, .external_lex_state = 4},
  [5696] = {.lex_state = 104, .external_lex_state = 4},
  [5697] = {.lex_state = 104, .external_lex_state = 4},
  [5698] = {.lex_state = 104, .external_lex_state = 4},
  [5699] = {.lex_state = 104, .external_lex_state = 4},
  [5700] = {.lex_state = 104, .external_lex_state = 4},
  [5701] = {.lex_state = 104},
  [5702] = {.lex_state = 104, .external_lex_state = 4},
  [5703] = {.lex_state = 104},
  [5704] = {.lex_state = 104},
  [5705] = {.lex_state = 104, .external_lex_state = 4},
  [5706] = {.lex_state = 104},
  [5707] = {.lex_state = 104},
  [5708] = {.lex_state = 104},
  [5709] = {.lex_state = 104, .external_lex_state = 4},
  [5710] = {.lex_state = 104, .external_lex_state = 4},
  [5711] = {.lex_state = 104},
  [5712] = {.lex_state = 104, .external_lex_state = 4},
  [5713] = {.lex_state = 104, .external_lex_state = 4},
  [5714] = {.lex_state = 105},
  [5715] = {.lex_state = 104, .external_lex_state = 4},
  [5716] = {.lex_state = 104},
  [5717] = {.lex_state = 104, .external_lex_state = 4},
  [5718] = {.lex_state = 104},
  [5719] = {.lex_state = 104},
  [5720] = {.lex_state = 105},
  [5721] = {.lex_state = 104},
  [5722] = {.lex_state = 104, .external_lex_state = 4},
  [5723] = {.lex_state = 104},
  [5724] = {.lex_state = 104},
  [5725] = {.lex_state = 104},
  [5726] = {.lex_state = 104},
  [5727] = {.lex_state = 104},
  [5728] = {.lex_state = 104, .external_lex_state = 4},
  [5729] = {.lex_state = 104, .external_lex_state = 4},
  [5730] = {.lex_state = 104, .external_lex_state = 4},
  [5731] = {.lex_state = 104, .external_lex_state = 4},
  [5732] = {.lex_state = 104, .external_lex_state = 4},
  [5733] = {.lex_state = 104, .external_lex_state = 4},
  [5734] = {.lex_state = 104, .external_lex_state = 4},
  [5735] = {.lex_state = 104, .external_lex_state = 4},
  [5736] = {.lex_state = 104, .external_lex_state = 4},
  [5737] = {.lex_state = 104, .external_lex_state = 4},
  [5738] = {.lex_state = 104},
  [5739] = {.lex_state = 104},
  [5740] = {.lex_state = 104},
  [5741] = {.lex_state = 104, .external_lex_state = 4},
  [5742] = {.lex_state = 104, .external_lex_state = 4},
  [5743] = {.lex_state = 104},
  [5744] = {.lex_state = 104},
  [5745] = {.lex_state = 104, .external_lex_state = 4},
  [5746] = {.lex_state = 104, .external_lex_state = 4},
  [5747] = {.lex_state = 104},
  [5748] = {.lex_state = 104, .external_lex_state = 4},
  [5749] = {.lex_state = 104, .external_lex_state = 4},
  [5750] = {.lex_state = 104, .external_lex_state = 4},
  [5751] = {.lex_state = 104, .external_lex_state = 4},
  [5752] = {.lex_state = 104, .external_lex_state = 4},
  [5753] = {.lex_state = 104, .external_lex_state = 4},
  [5754] = {.lex_state = 104, .external_lex_state = 4},
  [5755] = {.lex_state = 104, .external_lex_state = 4},
  [5756] = {.lex_state = 104, .external_lex_state = 4},
  [5757] = {.lex_state = 104, .external_lex_state = 4},
  [5758] = {.lex_state = 104, .external_lex_state = 4},
  [5759] = {.lex_state = 104},
  [5760] = {.lex_state = 104},
  [5761] = {.lex_state = 104, .external_lex_state = 4},
  [5762] = {.lex_state = 104},
  [5763] = {.lex_state = 104, .external_lex_state = 4},
  [5764] = {.lex_state = 104, .external_lex_state = 4},
  [5765] = {.lex_state = 104, .external_lex_state = 4},
  [5766] = {.lex_state = 104},
  [5767] = {.lex_state = 104},
  [5768] = {.lex_state = 104},
  [5769] = {.lex_state = 104},
  [5770] = {.lex_state = 104},
  [5771] = {.lex_state = 104},
  [5772] = {.lex_state = 104, .external_lex_state = 4},
  [5773] = {.lex_state = 104},
  [5774] = {.lex_state = 104, .external_lex_state = 4},
  [5775] = {.lex_state = 105},
  [5776] = {.lex_state = 104, .external_lex_state = 4},
  [5777] = {.lex_state = 104, .external_lex_state = 4},
  [5778] = {.lex_state = 104},
  [5779] = {.lex_state = 104, .external_lex_state = 4},
  [5780] = {.lex_state = 104, .external_lex_state = 4},
  [5781] = {.lex_state = 104},
  [5782] = {.lex_state = 105},
  [5783] = {.lex_state = 104},
  [5784] = {.lex_state = 104, .external_lex_state = 4},
  [5785] = {.lex_state = 104},
  [5786] = {.lex_state = 105},
  [5787] = {.lex_state = 105},
  [5788] = {.lex_state = 104},
  [5789] = {.lex_state = 104},
  [5790] = {.lex_state = 105},
  [5791] = {.lex_state = 104},
  [5792] = {.lex_state = 104},
  [5793] = {.lex_state = 104},
  [5794] = {.lex_state = 104},
  [5795] = {.lex_state = 104},
  [5796] = {.lex_state = 104},
  [5797] = {.lex_state = 104},
  [5798] = {.lex_state = 104},
  [5799] = {.lex_state = 104},
  [5800] = {.lex_state = 104},
  [5801] = {.lex_state = 104},
  [5802] = {.lex_state = 104},
  [5803] = {.lex_state = 104},
  [5804] = {.lex_state = 104},
  [5805] = {.lex_state = 104},
  [5806] = {.lex_state = 104},
  [5807] = {.lex_state = 104},
  [5808] = {.lex_state = 105},
  [5809] = {.lex_state = 104},
  [5810] = {.lex_state = 104},
  [5811] = {.lex_state = 104},
  [5812] = {.lex_state = 104},
  [5813] = {.lex_state = 104},
  [5814] = {.lex_state = 104},
  [5815] = {.lex_state = 104},
  [5816] = {.lex_state = 105},
  [5817] = {.lex_state = 104},
  [5818] = {.lex_state = 104},
  [5819] = {.lex_state = 104},
  [5820] = {.lex_state = 105},
  [5821] = {.lex_state = 104},
  [5822] = {.lex_state = 104},
  [5823] = {.lex_state = 104},
  [5824] = {.lex_state = 104},
  [5825] = {.lex_state = 104},
  [5826] = {.lex_state = 104},
  [5827] = {.lex_state = 104},
  [5828] = {.lex_state = 104},
  [5829] = {.lex_state = 104},
  [5830] = {.lex_state = 104},
  [5831] = {.lex_state = 104},
  [5832] = {.lex_state = 104},
  [5833] = {.lex_state = 104},
  [5834] = {.lex_state = 104},
  [5835] = {.lex_state = 104},
  [5836] = {.lex_state = 104},
  [5837] = {.lex_state = 104, .external_lex_state = 4},
  [5838] = {.lex_state = 17},
  [5839] = {.lex_state = 104, .external_lex_state = 4},
  [5840] = {.lex_state = 104},
  [5841] = {.lex_state = 104},
  [5842] = {.lex_state = 104},
  [5843] = {.lex_state = 104},
  [5844] = {.lex_state = 104},
  [5845] = {.lex_state = 104},
  [5846] = {.lex_state = 105},
  [5847] = {.lex_state = 104},
  [5848] = {.lex_state = 104},
  [5849] = {.lex_state = 104},
  [5850] = {.lex_state = 104},
  [5851] = {.lex_state = 104, .external_lex_state = 4},
  [5852] = {.lex_state = 104, .external_lex_state = 4},
  [5853] = {.lex_state = 104},
  [5854] = {.lex_state = 105},
  [5855] = {.lex_state = 104},
  [5856] = {.lex_state = 104},
  [5857] = {.lex_state = 104},
  [5858] = {.lex_state = 104},
  [5859] = {.lex_state = 104},
  [5860] = {.lex_state = 104},
  [5861] = {.lex_state = 104, .external_lex_state = 4},
  [5862] = {.lex_state = 104},
  [5863] = {.lex_state = 104},
  [5864] = {.lex_state = 104},
  [5865] = {.lex_state = 104},
  [5866] = {.lex_state = 105},
  [5867] = {.lex_state = 104},
  [5868] = {.lex_state = 104},
  [5869] = {.lex_state = 104},
  [5870] = {.lex_state = 104},
  [5871] = {.lex_state = 104},
  [5872] = {.lex_state = 104},
  [5873] = {.lex_state = 104},
  [5874] = {.lex_state = 104},
  [5875] = {.lex_state = 104},
  [5876] = {.lex_state = 104},
  [5877] = {.lex_state = 104},
  [5878] = {.lex_state = 104},
  [5879] = {.lex_state = 104},
  [5880] = {.lex_state = 104},
  [5881] = {.lex_state = 104},
  [5882] = {.lex_state = 104},
  [5883] = {.lex_state = 105},
  [5884] = {.lex_state = 104},
  [5885] = {.lex_state = 105},
  [5886] = {.lex_state = 104},
  [5887] = {.lex_state = 104},
  [5888] = {.lex_state = 104},
  [5889] = {.lex_state = 104},
  [5890] = {.lex_state = 104},
  [5891] = {.lex_state = 104},
  [5892] = {.lex_state = 105},
  [5893] = {.lex_state = 104},
  [5894] = {.lex_state = 104},
  [5895] = {.lex_state = 105},
  [5896] = {.lex_state = 104},
  [5897] = {.lex_state = 104},
  [5898] = {.lex_state = 105},
  [5899] = {.lex_state = 104},
  [5900] = {.lex_state = 104},
  [5901] = {.lex_state = 104},
  [5902] = {.lex_state = 104},
  [5903] = {.lex_state = 104},
  [5904] = {.lex_state = 104},
  [5905] = {.lex_state = 104},
  [5906] = {.lex_state = 104},
  [5907] = {.lex_state = 104},
  [5908] = {.lex_state = 104},
  [5909] = {.lex_state = 104, .external_lex_state = 4},
  [5910] = {.lex_state = 104},
  [5911] = {.lex_state = 104},
  [5912] = {.lex_state = 104},
  [5913] = {.lex_state = 104},
  [5914] = {.lex_state = 104},
  [5915] = {.lex_state = 104},
  [5916] = {.lex_state = 104},
  [5917] = {.lex_state = 104},
  [5918] = {.lex_state = 104},
  [5919] = {.lex_state = 104},
  [5920] = {.lex_state = 104},
  [5921] = {.lex_state = 104},
  [5922] = {.lex_state = 104},
  [5923] = {.lex_state = 104},
  [5924] = {.lex_state = 104},
  [5925] = {.lex_state = 104},
  [5926] = {.lex_state = 105},
  [5927] = {.lex_state = 104},
  [5928] = {.lex_state = 104},
  [5929] = {.lex_state = 104},
  [5930] = {.lex_state = 104},
  [5931] = {.lex_state = 104, .external_lex_state = 4},
  [5932] = {.lex_state = 104},
  [5933] = {.lex_state = 104},
  [5934] = {.lex_state = 104},
  [5935] = {.lex_state = 104},
  [5936] = {.lex_state = 104},
  [5937] = {.lex_state = 104},
  [5938] = {.lex_state = 104},
  [5939] = {.lex_state = 104},
  [5940] = {.lex_state = 104},
  [5941] = {.lex_state = 104},
  [5942] = {.lex_state = 104},
  [5943] = {.lex_state = 105},
  [5944] = {.lex_state = 104},
  [5945] = {.lex_state = 104},
  [5946] = {.lex_state = 104},
  [5947] = {.lex_state = 104},
  [5948] = {.lex_state = 104},
  [5949] = {.lex_state = 104, .external_lex_state = 4},
  [5950] = {.lex_state = 104},
  [5951] = {.lex_state = 104},
  [5952] = {.lex_state = 104},
  [5953] = {.lex_state = 104},
  [5954] = {.lex_state = 104},
  [5955] = {.lex_state = 104},
  [5956] = {.lex_state = 104},
  [5957] = {.lex_state = 105},
  [5958] = {.lex_state = 104},
  [5959] = {.lex_state = 104},
  [5960] = {.lex_state = 104},
  [5961] = {.lex_state = 104},
  [5962] = {.lex_state = 104},
  [5963] = {.lex_state = 104},
  [5964] = {.lex_state = 104},
  [5965] = {.lex_state = 104},
  [5966] = {.lex_state = 104},
  [5967] = {.lex_state = 104},
  [5968] = {.lex_state = 104},
  [5969] = {.lex_state = 104},
  [5970] = {.lex_state = 104},
  [5971] = {.lex_state = 104},
  [5972] = {.lex_state = 104},
  [5973] = {.lex_state = 104},
  [5974] = {.lex_state = 104},
  [5975] = {.lex_state = 104},
  [5976] = {.lex_state = 104},
  [5977] = {.lex_state = 104},
  [5978] = {.lex_state = 104},
  [5979] = {.lex_state = 104},
  [5980] = {.lex_state = 104},
  [5981] = {.lex_state = 104},
  [5982] = {.lex_state = 104},
  [5983] = {.lex_state = 104},
  [5984] = {.lex_state = 104},
  [5985] = {.lex_state = 104},
  [5986] = {.lex_state = 105},
  [5987] = {.lex_state = 104},
  [5988] = {.lex_state = 104},
  [5989] = {.lex_state = 104},
  [5990] = {.lex_state = 104},
  [5991] = {.lex_state = 104},
  [5992] = {.lex_state = 104},
  [5993] = {.lex_state = 104},
  [5994] = {.lex_state = 104},
  [5995] = {.lex_state = 104},
  [5996] = {.lex_state = 104},
  [5997] = {.lex_state = 104},
  [5998] = {.lex_state = 104},
  [5999] = {.lex_state = 104},
  [6000] = {.lex_state = 104},
  [6001] = {.lex_state = 104},
  [6002] = {.lex_state = 104},
  [6003] = {.lex_state = 104},
  [6004] = {.lex_state = 104},
  [6005] = {.lex_state = 104},
  [6006] = {.lex_state = 104},
  [6007] = {.lex_state = 104},
  [6008] = {.lex_state = 104},
  [6009] = {.lex_state = 104},
  [6010] = {.lex_state = 105},
  [6011] = {.lex_state = 104},
  [6012] = {.lex_state = 104},
  [6013] = {.lex_state = 104},
  [6014] = {.lex_state = 104},
  [6015] = {.lex_state = 104},
  [6016] = {.lex_state = 104},
  [6017] = {.lex_state = 105},
  [6018] = {.lex_state = 104},
  [6019] = {.lex_state = 104},
  [6020] = {.lex_state = 104},
  [6021] = {.lex_state = 104},
  [6022] = {.lex_state = 104, .external_lex_state = 4},
  [6023] = {.lex_state = 105},
  [6024] = {.lex_state = 104},
  [6025] = {.lex_state = 104},
  [6026] = {.lex_state = 104},
  [6027] = {.lex_state = 104},
  [6028] = {.lex_state = 104},
  [6029] = {.lex_state = 104},
  [6030] = {.lex_state = 104, .external_lex_state = 4},
  [6031] = {.lex_state = 104},
  [6032] = {.lex_state = 104},
  [6033] = {.lex_state = 104},
  [6034] = {.lex_state = 104},
  [6035] = {.lex_state = 104},
  [6036] = {.lex_state = 104},
  [6037] = {.lex_state = 104},
  [6038] = {.lex_state = 104},
  [6039] = {.lex_state = 104},
  [6040] = {.lex_state = 104},
  [6041] = {.lex_state = 104},
  [6042] = {.lex_state = 105},
  [6043] = {.lex_state = 104},
  [6044] = {.lex_state = 104},
  [6045] = {.lex_state = 104},
  [6046] = {.lex_state = 104},
  [6047] = {.lex_state = 105},
  [6048] = {.lex_state = 104},
  [6049] = {.lex_state = 104},
  [6050] = {.lex_state = 104},
  [6051] = {.lex_state = 104, .external_lex_state = 4},
  [6052] = {.lex_state = 104},
  [6053] = {.lex_state = 104, .external_lex_state = 4},
  [6054] = {.lex_state = 104},
  [6055] = {.lex_state = 104},
  [6056] = {.lex_state = 104},
  [6057] = {.lex_state = 104},
  [6058] = {.lex_state = 104},
  [6059] = {.lex_state = 104, .external_lex_state = 4},
  [6060] = {.lex_state = 104},
  [6061] = {.lex_state = 104, .external_lex_state = 4},
  [6062] = {.lex_state = 104, .external_lex_state = 4},
  [6063] = {.lex_state = 104},
  [6064] = {.lex_state = 104, .external_lex_state = 4},
  [6065] = {.lex_state = 104},
  [6066] = {.lex_state = 104, .external_lex_state = 4},
  [6067] = {.lex_state = 104},
  [6068] = {.lex_state = 104},
  [6069] = {.lex_state = 104},
  [6070] = {.lex_state = 104},
  [6071] = {.lex_state = 104},
  [6072] = {.lex_state = 104},
  [6073] = {.lex_state = 104},
  [6074] = {.lex_state = 104},
  [6075] = {.lex_state = 104},
  [6076] = {.lex_state = 104},
  [6077] = {.lex_state = 104},
  [6078] = {.lex_state = 104},
  [6079] = {.lex_state = 104},
  [6080] = {.lex_state = 104, .external_lex_state = 4},
  [6081] = {.lex_state = 104, .external_lex_state = 4},
  [6082] = {.lex_state = 104, .external_lex_state = 4},
  [6083] = {.lex_state = 104},
  [6084] = {.lex_state = 104, .external_lex_state = 4},
  [6085] = {.lex_state = 104, .external_lex_state = 4},
  [6086] = {.lex_state = 104, .external_lex_state = 4},
  [6087] = {.lex_state = 104, .external_lex_state = 4},
  [6088] = {.lex_state = 104, .external_lex_state = 4},
  [6089] = {.lex_state = 104},
  [6090] = {.lex_state = 104},
  [6091] = {.lex_state = 104, .external_lex_state = 4},
  [6092] = {.lex_state = 104, .external_lex_state = 4},
  [6093] = {.lex_state = 104},
  [6094] = {.lex_state = 104},
  [6095] = {.lex_state = 104},
  [6096] = {.lex_state = 104, .external_lex_state = 4},
  [6097] = {.lex_state = 104, .external_lex_state = 4},
  [6098] = {.lex_state = 104},
  [6099] = {.lex_state = 104},
  [6100] = {.lex_state = 104},
  [6101] = {.lex_state = 104, .external_lex_state = 4},
  [6102] = {.lex_state = 105},
  [6103] = {.lex_state = 104},
  [6104] = {.lex_state = 104},
  [6105] = {.lex_state = 104},
  [6106] = {.lex_state = 104},
  [6107] = {.lex_state = 104},
  [6108] = {.lex_state = 104},
  [6109] = {.lex_state = 104},
  [6110] = {.lex_state = 104},
  [6111] = {.lex_state = 105},
  [6112] = {.lex_state = 104},
  [6113] = {.lex_state = 104},
  [6114] = {.lex_state = 105},
  [6115] = {.lex_state = 104},
  [6116] = {.lex_state = 104},
  [6117] = {.lex_state = 104, .external_lex_state = 4},
  [6118] = {.lex_state = 104},
  [6119] = {.lex_state = 104},
  [6120] = {.lex_state = 104},
  [6121] = {.lex_state = 104},
  [6122] = {.lex_state = 104},
  [6123] = {.lex_state = 104},
  [6124] = {.lex_state = 104},
  [6125] = {.lex_state = 104},
  [6126] = {.lex_state = 104},
  [6127] = {.lex_state = 104},
  [6128] = {.lex_state = 104},
  [6129] = {.lex_state = 104},
  [6130] = {.lex_state = 104},
  [6131] = {.lex_state = 104},
  [6132] = {.lex_state = 104},
  [6133] = {.lex_state = 104},
  [6134] = {.lex_state = 104},
  [6135] = {.lex_state = 104},
  [6136] = {.lex_state = 104},
  [6137] = {.lex_state = 104},
  [6138] = {.lex_state = 10},
  [6139] = {.lex_state = 104},
  [6140] = {.lex_state = 104},
  [6141] = {.lex_state = 104},
  [6142] = {.lex_state = 104},
  [6143] = {.lex_state = 104},
  [6144] = {.lex_state = 104},
  [6145] = {.lex_state = 104},
  [6146] = {.lex_state = 104},
  [6147] = {.lex_state = 104},
  [6148] = {.lex_state = 104},
  [6149] = {.lex_state = 10},
  [6150] = {.lex_state = 104},
  [6151] = {.lex_state = 104},
  [6152] = {.lex_state = 104},
  [6153] = {.lex_state = 10},
  [6154] = {.lex_state = 104},
  [6155] = {.lex_state = 104},
  [6156] = {.lex_state = 104},
  [6157] = {.lex_state = 10},
  [6158] = {.lex_state = 104},
  [6159] = {.lex_state = 104},
  [6160] = {.lex_state = 104},
  [6161] = {.lex_state = 104},
  [6162] = {.lex_state = 104},
  [6163] = {.lex_state = 104},
  [6164] = {.lex_state = 104},
  [6165] = {.lex_state = 104},
  [6166] = {.lex_state = 104},
  [6167] = {.lex_state = 104},
  [6168] = {.lex_state = 104},
  [6169] = {.lex_state = 104},
  [6170] = {.lex_state = 104},
  [6171] = {.lex_state = 104},
  [6172] = {.lex_state = 104},
  [6173] = {.lex_state = 104},
  [6174] = {.lex_state = 104},
  [6175] = {.lex_state = 104},
  [6176] = {.lex_state = 104},
  [6177] = {.lex_state = 104},
  [6178] = {.lex_state = 104},
  [6179] = {.lex_state = 104},
  [6180] = {.lex_state = 104},
  [6181] = {.lex_state = 104},
  [6182] = {.lex_state = 104},
  [6183] = {.lex_state = 104},
  [6184] = {.lex_state = 104},
  [6185] = {.lex_state = 104},
  [6186] = {.lex_state = 104},
  [6187] = {.lex_state = 104},
  [6188] = {.lex_state = 104},
  [6189] = {.lex_state = 104},
  [6190] = {.lex_state = 104},
  [6191] = {.lex_state = 104},
  [6192] = {.lex_state = 104},
  [6193] = {.lex_state = 104},
  [6194] = {.lex_state = 104},
  [6195] = {.lex_state = 104},
  [6196] = {.lex_state = 104},
  [6197] = {.lex_state = 104},
  [6198] = {.lex_state = 104},
  [6199] = {.lex_state = 104},
  [6200] = {.lex_state = 104},
  [6201] = {.lex_state = 104},
  [6202] = {.lex_state = 104},
  [6203] = {.lex_state = 104},
  [6204] = {.lex_state = 104},
  [6205] = {.lex_state = 10},
  [6206] = {.lex_state = 104},
  [6207] = {.lex_state = 104},
  [6208] = {.lex_state = 104},
  [6209] = {.lex_state = 104},
  [6210] = {.lex_state = 10},
  [6211] = {.lex_state = 104},
  [6212] = {.lex_state = 104},
  [6213] = {.lex_state = 104},
  [6214] = {.lex_state = 104},
  [6215] = {.lex_state = 10},
  [6216] = {.lex_state = 104},
  [6217] = {.lex_state = 10},
  [6218] = {.lex_state = 10},
  [6219] = {.lex_state = 10},
  [6220] = {.lex_state = 104},
  [6221] = {.lex_state = 104},
  [6222] = {.lex_state = 10},
  [6223] = {.lex_state = 104},
  [6224] = {.lex_state = 104},
  [6225] = {.lex_state = 104},
  [6226] = {.lex_state = 104},
  [6227] = {.lex_state = 10},
  [6228] = {.lex_state = 104},
  [6229] = {.lex_state = 104},
  [6230] = {.lex_state = 104},
  [6231] = {.lex_state = 10},
  [6232] = {.lex_state = 105},
  [6233] = {.lex_state = 104},
  [6234] = {.lex_state = 104},
  [6235] = {.lex_state = 104},
  [6236] = {.lex_state = 104},
  [6237] = {.lex_state = 104},
  [6238] = {.lex_state = 10},
  [6239] = {.lex_state = 104},
  [6240] = {.lex_state = 104},
  [6241] = {.lex_state = 104},
  [6242] = {.lex_state = 104},
  [6243] = {.lex_state = 104},
  [6244] = {.lex_state = 104},
  [6245] = {.lex_state = 10},
  [6246] = {.lex_state = 10},
  [6247] = {.lex_state = 104},
  [6248] = {.lex_state = 104},
  [6249] = {.lex_state = 105},
  [6250] = {.lex_state = 104},
  [6251] = {.lex_state = 104},
  [6252] = {.lex_state = 104},
  [6253] = {.lex_state = 104},
  [6254] = {.lex_state = 104},
  [6255] = {.lex_state = 104},
  [6256] = {.lex_state = 104},
  [6257] = {.lex_state = 104},
  [6258] = {.lex_state = 104},
  [6259] = {.lex_state = 104},
  [6260] = {.lex_state = 10},
  [6261] = {.lex_state = 104},
  [6262] = {.lex_state = 104},
  [6263] = {.lex_state = 10},
  [6264] = {.lex_state = 104},
  [6265] = {.lex_state = 104},
  [6266] = {.lex_state = 104},
  [6267] = {.lex_state = 104},
  [6268] = {.lex_state = 105},
  [6269] = {.lex_state = 104},
  [6270] = {.lex_state = 105},
  [6271] = {.lex_state = 104},
  [6272] = {.lex_state = 104},
  [6273] = {.lex_state = 10},
  [6274] = {.lex_state = 104},
  [6275] = {.lex_state = 104},
  [6276] = {.lex_state = 105},
  [6277] = {.lex_state = 104},
  [6278] = {.lex_state = 104},
  [6279] = {.lex_state = 10},
  [6280] = {.lex_state = 10},
  [6281] = {.lex_state = 10},
  [6282] = {.lex_state = 104},
  [6283] = {.lex_state = 104},
  [6284] = {.lex_state = 10},
  [6285] = {.lex_state = 104},
  [6286] = {.lex_state = 105},
  [6287] = {.lex_state = 104},
  [6288] = {.lex_state = 104},
  [6289] = {.lex_state = 104},
  [6290] = {.lex_state = 104},
  [6291] = {.lex_state = 10},
  [6292] = {.lex_state = 105},
  [6293] = {.lex_state = 104},
  [6294] = {.lex_state = 10},
  [6295] = {.lex_state = 104},
  [6296] = {.lex_state = 10},
  [6297] = {.lex_state = 10},
  [6298] = {.lex_state = 104},
  [6299] = {.lex_state = 105},
  [6300] = {.lex_state = 104},
  [6301] = {.lex_state = 104},
  [6302] = {.lex_state = 104},
  [6303] = {.lex_state = 104},
  [6304] = {.lex_state = 104},
  [6305] = {.lex_state = 104},
  [6306] = {.lex_state = 104},
  [6307] = {.lex_state = 104},
  [6308] = {.lex_state = 104},
  [6309] = {.lex_state = 104},
  [6310] = {.lex_state = 104},
  [6311] = {.lex_state = 104},
  [6312] = {.lex_state = 104},
  [6313] = {.lex_state = 104},
  [6314] = {.lex_state = 104},
  [6315] = {.lex_state = 104},
  [6316] = {.lex_state = 104},
  [6317] = {.lex_state = 104},
  [6318] = {.lex_state = 104},
  [6319] = {.lex_state = 104},
  [6320] = {.lex_state = 104},
  [6321] = {.lex_state = 104},
  [6322] = {.lex_state = 104},
  [6323] = {.lex_state = 104},
  [6324] = {.lex_state = 104},
  [6325] = {.lex_state = 105},
  [6326] = {.lex_state = 104},
  [6327] = {.lex_state = 104},
  [6328] = {.lex_state = 104},
  [6329] = {.lex_state = 104},
  [6330] = {.lex_state = 104},
  [6331] = {.lex_state = 104},
  [6332] = {.lex_state = 104},
  [6333] = {.lex_state = 104},
  [6334] = {.lex_state = 104},
  [6335] = {.lex_state = 104},
  [6336] = {.lex_state = 104},
  [6337] = {.lex_state = 104},
  [6338] = {.lex_state = 104},
  [6339] = {.lex_state = 104},
  [6340] = {.lex_state = 104},
  [6341] = {.lex_state = 104},
  [6342] = {.lex_state = 104},
  [6343] = {.lex_state = 104},
  [6344] = {.lex_state = 104},
  [6345] = {.lex_state = 104},
  [6346] = {.lex_state = 104},
  [6347] = {.lex_state = 104},
  [6348] = {.lex_state = 104},
  [6349] = {.lex_state = 104},
  [6350] = {.lex_state = 104},
  [6351] = {.lex_state = 104},
  [6352] = {.lex_state = 104},
  [6353] = {.lex_state = 105},
  [6354] = {.lex_state = 104},
  [6355] = {.lex_state = 104},
  [6356] = {.lex_state = 104},
  [6357] = {.lex_state = 104},
  [6358] = {.lex_state = 104},
  [6359] = {.lex_state = 104},
  [6360] = {.lex_state = 104},
  [6361] = {.lex_state = 104},
  [6362] = {.lex_state = 104},
  [6363] = {.lex_state = 104},
  [6364] = {.lex_state = 104},
  [6365] = {.lex_state = 104},
  [6366] = {.lex_state = 104},
  [6367] = {.lex_state = 104},
  [6368] = {.lex_state = 104},
  [6369] = {.lex_state = 104},
  [6370] = {.lex_state = 104},
  [6371] = {.lex_state = 104},
  [6372] = {.lex_state = 104},
  [6373] = {.lex_state = 104},
  [6374] = {.lex_state = 104},
  [6375] = {.lex_state = 104},
  [6376] = {.lex_state = 104},
  [6377] = {.lex_state = 104},
  [6378] = {.lex_state = 104},
  [6379] = {.lex_state = 104},
  [6380] = {.lex_state = 104},
  [6381] = {.lex_state = 104},
  [6382] = {.lex_state = 104},
  [6383] = {.lex_state = 104},
  [6384] = {.lex_state = 104},
  [6385] = {.lex_state = 104},
  [6386] = {.lex_state = 104},
  [6387] = {.lex_state = 105},
  [6388] = {.lex_state = 104},
  [6389] = {.lex_state = 104},
  [6390] = {.lex_state = 104},
  [6391] = {.lex_state = 104},
  [6392] = {.lex_state = 104},
  [6393] = {.lex_state = 104},
  [6394] = {.lex_state = 104},
  [6395] = {.lex_state = 104},
  [6396] = {.lex_state = 105},
  [6397] = {.lex_state = 104},
  [6398] = {.lex_state = 104},
  [6399] = {.lex_state = 104},
  [6400] = {.lex_state = 104},
  [6401] = {.lex_state = 104},
  [6402] = {.lex_state = 104},
  [6403] = {.lex_state = 104},
  [6404] = {.lex_state = 104},
  [6405] = {.lex_state = 104},
  [6406] = {.lex_state = 104},
  [6407] = {.lex_state = 104},
  [6408] = {.lex_state = 104},
  [6409] = {.lex_state = 104},
  [6410] = {.lex_state = 104},
  [6411] = {.lex_state = 104},
  [6412] = {.lex_state = 104},
  [6413] = {.lex_state = 104},
  [6414] = {.lex_state = 104},
  [6415] = {.lex_state = 104},
  [6416] = {.lex_state = 104},
  [6417] = {.lex_state = 104},
  [6418] = {.lex_state = 104},
  [6419] = {.lex_state = 105},
  [6420] = {.lex_state = 104},
  [6421] = {.lex_state = 104},
  [6422] = {.lex_state = 104},
  [6423] = {.lex_state = 104},
  [6424] = {.lex_state = 104},
  [6425] = {.lex_state = 104},
  [6426] = {.lex_state = 104},
  [6427] = {.lex_state = 104},
  [6428] = {.lex_state = 104},
  [6429] = {.lex_state = 104},
  [6430] = {.lex_state = 104},
  [6431] = {.lex_state = 104},
  [6432] = {.lex_state = 104},
  [6433] = {.lex_state = 104},
  [6434] = {.lex_state = 104},
  [6435] = {.lex_state = 104},
  [6436] = {.lex_state = 104},
  [6437] = {.lex_state = 104},
  [6438] = {.lex_state = 104},
  [6439] = {.lex_state = 104},
  [6440] = {.lex_state = 104},
  [6441] = {.lex_state = 104},
  [6442] = {.lex_state = 104},
  [6443] = {.lex_state = 104},
  [6444] = {.lex_state = 104},
  [6445] = {.lex_state = 104},
  [6446] = {.lex_state = 104},
  [6447] = {.lex_state = 104},
  [6448] = {.lex_state = 104},
  [6449] = {.lex_state = 104},
  [6450] = {.lex_state = 104},
  [6451] = {.lex_state = 104},
  [6452] = {.lex_state = 104},
  [6453] = {.lex_state = 104},
  [6454] = {.lex_state = 104},
  [6455] = {.lex_state = 104},
  [6456] = {.lex_state = 104},
  [6457] = {.lex_state = 104},
  [6458] = {.lex_state = 104},
  [6459] = {.lex_state = 104},
  [6460] = {.lex_state = 104},
  [6461] = {.lex_state = 104},
  [6462] = {.lex_state = 104},
  [6463] = {.lex_state = 104},
  [6464] = {.lex_state = 104},
  [6465] = {.lex_state = 104},
  [6466] = {.lex_state = 104},
  [6467] = {.lex_state = 104},
  [6468] = {.lex_state = 104},
  [6469] = {.lex_state = 104},
  [6470] = {.lex_state = 105},
  [6471] = {.lex_state = 104},
  [6472] = {.lex_state = 104},
  [6473] = {.lex_state = 104},
  [6474] = {.lex_state = 105},
  [6475] = {.lex_state = 104},
  [6476] = {.lex_state = 104},
  [6477] = {.lex_state = 104},
  [6478] = {.lex_state = 104},
  [6479] = {.lex_state = 104},
  [6480] = {.lex_state = 104},
  [6481] = {.lex_state = 104},
  [6482] = {.lex_state = 104},
  [6483] = {.lex_state = 104},
  [6484] = {.lex_state = 104},
  [6485] = {.lex_state = 104},
  [6486] = {.lex_state = 104},
  [6487] = {.lex_state = 104},
  [6488] = {.lex_state = 104},
  [6489] = {.lex_state = 104},
  [6490] = {.lex_state = 104},
  [6491] = {.lex_state = 104},
  [6492] = {.lex_state = 104},
  [6493] = {.lex_state = 104},
  [6494] = {.lex_state = 104},
  [6495] = {.lex_state = 104},
  [6496] = {.lex_state = 104},
  [6497] = {.lex_state = 104},
  [6498] = {.lex_state = 104},
  [6499] = {.lex_state = 104},
  [6500] = {.lex_state = 104},
  [6501] = {.lex_state = 104},
  [6502] = {.lex_state = 104},
  [6503] = {.lex_state = 104},
  [6504] = {.lex_state = 104},
  [6505] = {.lex_state = 104},
  [6506] = {.lex_state = 104},
  [6507] = {.lex_state = 104},
  [6508] = {.lex_state = 104},
  [6509] = {.lex_state = 104},
  [6510] = {.lex_state = 104},
  [6511] = {.lex_state = 104},
  [6512] = {.lex_state = 104},
  [6513] = {.lex_state = 104},
  [6514] = {.lex_state = 104},
  [6515] = {.lex_state = 104},
  [6516] = {.lex_state = 104},
  [6517] = {.lex_state = 104},
  [6518] = {.lex_state = 104},
  [6519] = {.lex_state = 104},
  [6520] = {.lex_state = 104},
  [6521] = {.lex_state = 104},
  [6522] = {.lex_state = 104},
  [6523] = {.lex_state = 104},
  [6524] = {.lex_state = 104},
  [6525] = {.lex_state = 104},
  [6526] = {.lex_state = 104},
  [6527] = {.lex_state = 104},
  [6528] = {.lex_state = 104},
  [6529] = {.lex_state = 104},
  [6530] = {.lex_state = 104},
  [6531] = {.lex_state = 104},
  [6532] = {.lex_state = 104},
  [6533] = {.lex_state = 104},
  [6534] = {.lex_state = 104},
  [6535] = {.lex_state = 104},
  [6536] = {.lex_state = 104},
  [6537] = {.lex_state = 104},
  [6538] = {.lex_state = 104},
  [6539] = {.lex_state = 104},
  [6540] = {.lex_state = 104},
  [6541] = {.lex_state = 104},
  [6542] = {.lex_state = 104},
  [6543] = {.lex_state = 104},
  [6544] = {.lex_state = 104},
  [6545] = {.lex_state = 104},
  [6546] = {.lex_state = 104},
  [6547] = {.lex_state = 104},
  [6548] = {.lex_state = 104},
  [6549] = {.lex_state = 104},
  [6550] = {.lex_state = 104},
  [6551] = {.lex_state = 104},
  [6552] = {.lex_state = 104},
  [6553] = {.lex_state = 104},
  [6554] = {.lex_state = 104},
  [6555] = {.lex_state = 104},
  [6556] = {.lex_state = 104},
  [6557] = {.lex_state = 104},
  [6558] = {.lex_state = 104},
  [6559] = {.lex_state = 104},
  [6560] = {.lex_state = 104},
  [6561] = {.lex_state = 104},
  [6562] = {.lex_state = 104},
  [6563] = {.lex_state = 104},
  [6564] = {.lex_state = 104},
  [6565] = {.lex_state = 104},
  [6566] = {.lex_state = 104},
  [6567] = {.lex_state = 104},
  [6568] = {.lex_state = 104},
  [6569] = {.lex_state = 104},
  [6570] = {.lex_state = 104},
  [6571] = {.lex_state = 104},
  [6572] = {.lex_state = 104},
  [6573] = {.lex_state = 104},
  [6574] = {.lex_state = 104},
  [6575] = {.lex_state = 104},
  [6576] = {.lex_state = 104},
  [6577] = {.lex_state = 104},
  [6578] = {.lex_state = 104},
  [6579] = {.lex_state = 104},
  [6580] = {.lex_state = 104},
  [6581] = {.lex_state = 104},
  [6582] = {.lex_state = 104},
  [6583] = {.lex_state = 104},
  [6584] = {.lex_state = 104},
  [6585] = {.lex_state = 104},
  [6586] = {.lex_state = 104},
  [6587] = {.lex_state = 104},
  [6588] = {.lex_state = 104},
  [6589] = {.lex_state = 104},
  [6590] = {.lex_state = 104},
  [6591] = {.lex_state = 104},
  [6592] = {.lex_state = 104},
  [6593] = {.lex_state = 104},
  [6594] = {.lex_state = 104},
  [6595] = {.lex_state = 104},
  [6596] = {.lex_state = 104},
  [6597] = {.lex_state = 104},
  [6598] = {.lex_state = 104},
  [6599] = {.lex_state = 104},
  [6600] = {.lex_state = 104},
  [6601] = {.lex_state = 104},
  [6602] = {.lex_state = 104},
  [6603] = {.lex_state = 104},
  [6604] = {.lex_state = 104},
  [6605] = {.lex_state = 104},
  [6606] = {.lex_state = 104},
  [6607] = {.lex_state = 104},
  [6608] = {.lex_state = 104},
  [6609] = {.lex_state = 104},
  [6610] = {.lex_state = 104},
  [6611] = {.lex_state = 104},
  [6612] = {.lex_state = 104},
  [6613] = {.lex_state = 104},
  [6614] = {.lex_state = 104},
  [6615] = {.lex_state = 104},
  [6616] = {.lex_state = 104},
  [6617] = {.lex_state = 104},
  [6618] = {.lex_state = 104},
  [6619] = {.lex_state = 104},
  [6620] = {.lex_state = 104},
  [6621] = {.lex_state = 104},
  [6622] = {.lex_state = 104},
  [6623] = {.lex_state = 104},
  [6624] = {.lex_state = 104},
  [6625] = {.lex_state = 104},
  [6626] = {.lex_state = 104},
  [6627] = {.lex_state = 104},
  [6628] = {.lex_state = 104},
  [6629] = {.lex_state = 104},
  [6630] = {.lex_state = 104},
  [6631] = {.lex_state = 104},
  [6632] = {.lex_state = 104},
  [6633] = {.lex_state = 104},
  [6634] = {.lex_state = 104},
  [6635] = {.lex_state = 104},
  [6636] = {.lex_state = 104},
  [6637] = {.lex_state = 104},
  [6638] = {.lex_state = 104},
  [6639] = {.lex_state = 104},
  [6640] = {.lex_state = 104},
  [6641] = {.lex_state = 104},
  [6642] = {.lex_state = 104},
  [6643] = {.lex_state = 104},
  [6644] = {.lex_state = 104},
  [6645] = {.lex_state = 104},
  [6646] = {.lex_state = 104},
  [6647] = {.lex_state = 104},
  [6648] = {.lex_state = 104},
  [6649] = {.lex_state = 104},
  [6650] = {.lex_state = 104},
  [6651] = {.lex_state = 104},
  [6652] = {.lex_state = 104},
  [6653] = {.lex_state = 104},
  [6654] = {.lex_state = 104},
  [6655] = {.lex_state = 104},
  [6656] = {.lex_state = 104},
  [6657] = {.lex_state = 104},
  [6658] = {.lex_state = 104},
  [6659] = {.lex_state = 104},
  [6660] = {.lex_state = 104},
  [6661] = {.lex_state = 104},
  [6662] = {.lex_state = 104},
  [6663] = {.lex_state = 104},
  [6664] = {.lex_state = 104},
  [6665] = {.lex_state = 104},
  [6666] = {.lex_state = 104},
  [6667] = {.lex_state = 104},
  [6668] = {.lex_state = 104},
  [6669] = {.lex_state = 104},
  [6670] = {.lex_state = 104},
  [6671] = {.lex_state = 104},
  [6672] = {.lex_state = 104},
  [6673] = {.lex_state = 104},
  [6674] = {.lex_state = 104},
  [6675] = {.lex_state = 104},
  [6676] = {.lex_state = 104},
  [6677] = {.lex_state = 104},
  [6678] = {.lex_state = 104},
  [6679] = {.lex_state = 104},
  [6680] = {.lex_state = 104},
  [6681] = {.lex_state = 104},
  [6682] = {.lex_state = 104},
  [6683] = {.lex_state = 104},
  [6684] = {.lex_state = 104},
  [6685] = {.lex_state = 105},
  [6686] = {.lex_state = 104},
  [6687] = {.lex_state = 104},
  [6688] = {.lex_state = 105},
  [6689] = {.lex_state = 104},
  [6690] = {.lex_state = 105},
  [6691] = {.lex_state = 104},
  [6692] = {.lex_state = 104},
  [6693] = {.lex_state = 105},
  [6694] = {.lex_state = 105},
  [6695] = {.lex_state = 105},
  [6696] = {.lex_state = 104},
  [6697] = {.lex_state = 105},
  [6698] = {.lex_state = 105},
  [6699] = {.lex_state = 104},
  [6700] = {.lex_state = 104},
  [6701] = {.lex_state = 104},
  [6702] = {.lex_state = 104},
  [6703] = {.lex_state = 104},
  [6704] = {.lex_state = 104},
  [6705] = {.lex_state = 104},
  [6706] = {.lex_state = 104},
  [6707] = {.lex_state = 105},
  [6708] = {.lex_state = 105},
  [6709] = {.lex_state = 104},
  [6710] = {.lex_state = 104},
  [6711] = {.lex_state = 17},
  [6712] = {.lex_state = 17},
  [6713] = {.lex_state = 105},
  [6714] = {.lex_state = 105},
  [6715] = {.lex_state = 104},
  [6716] = {.lex_state = 104},
  [6717] = {.lex_state = 104},
  [6718] = {.lex_state = 104},
  [6719] = {.lex_state = 104},
  [6720] = {.lex_state = 104},
  [6721] = {.lex_state = 105},
  [6722] = {.lex_state = 105},
  [6723] = {.lex_state = 104},
  [6724] = {.lex_state = 104},
  [6725] = {.lex_state = 104},
  [6726] = {.lex_state = 104},
  [6727] = {.lex_state = 105},
  [6728] = {.lex_state = 105},
  [6729] = {.lex_state = 104},
  [6730] = {.lex_state = 105},
  [6731] = {.lex_state = 104},
  [6732] = {.lex_state = 104},
  [6733] = {.lex_state = 104},
  [6734] = {.lex_state = 105},
  [6735] = {.lex_state = 104},
  [6736] = {.lex_state = 104},
  [6737] = {.lex_state = 105},
  [6738] = {.lex_state = 104},
  [6739] = {.lex_state = 104},
  [6740] = {.lex_state = 105},
  [6741] = {.lex_state = 105},
  [6742] = {.lex_state = 105},
  [6743] = {.lex_state = 105},
  [6744] = {.lex_state = 105},
  [6745] = {.lex_state = 105},
  [6746] = {.lex_state = 17},
  [6747] = {.lex_state = 17},
  [6748] = {.lex_state = 105},
  [6749] = {.lex_state = 17},
  [6750] = {.lex_state = 105},
  [6751] = {.lex_state = 104},
  [6752] = {.lex_state = 105},
  [6753] = {.lex_state = 105},
  [6754] = {.lex_state = 104},
  [6755] = {.lex_state = 105},
  [6756] = {.lex_state = 105},
  [6757] = {.lex_state = 105},
  [6758] = {.lex_state = 105},
  [6759] = {.lex_state = 104},
  [6760] = {.lex_state = 105},
  [6761] = {.lex_state = 105},
  [6762] = {.lex_state = 105},
  [6763] = {.lex_state = 17},
  [6764] = {.lex_state = 104},
  [6765] = {.lex_state = 104},
  [6766] = {.lex_state = 105},
  [6767] = {.lex_state = 105},
  [6768] = {.lex_state = 105},
  [6769] = {.lex_state = 104},
  [6770] = {.lex_state = 105},
  [6771] = {.lex_state = 105},
  [6772] = {.lex_state = 105},
  [6773] = {.lex_state = 105},
  [6774] = {.lex_state = 105},
  [6775] = {.lex_state = 105},
  [6776] = {.lex_state = 105},
  [6777] = {.lex_state = 105},
  [6778] = {.lex_state = 105},
  [6779] = {.lex_state = 105},
  [6780] = {.lex_state = 105},
  [6781] = {.lex_state = 105},
  [6782] = {.lex_state = 105},
  [6783] = {.lex_state = 105},
  [6784] = {.lex_state = 105},
  [6785] = {.lex_state = 105},
  [6786] = {.lex_state = 105},
  [6787] = {.lex_state = 105},
  [6788] = {.lex_state = 105},
  [6789] = {.lex_state = 105},
  [6790] = {.lex_state = 105},
  [6791] = {.lex_state = 105},
  [6792] = {.lex_state = 105},
  [6793] = {.lex_state = 105},
  [6794] = {.lex_state = 105},
  [6795] = {.lex_state = 105},
  [6796] = {.lex_state = 105},
  [6797] = {.lex_state = 105},
  [6798] = {.lex_state = 105},
  [6799] = {.lex_state = 105},
  [6800] = {.lex_state = 105},
  [6801] = {.lex_state = 105},
  [6802] = {.lex_state = 105},
  [6803] = {.lex_state = 105},
  [6804] = {.lex_state = 105},
  [6805] = {.lex_state = 105},
  [6806] = {.lex_state = 105},
  [6807] = {.lex_state = 105},
  [6808] = {.lex_state = 105},
  [6809] = {.lex_state = 105},
  [6810] = {.lex_state = 105},
  [6811] = {.lex_state = 105},
  [6812] = {.lex_state = 105},
  [6813] = {.lex_state = 105},
  [6814] = {.lex_state = 105},
  [6815] = {.lex_state = 105},
  [6816] = {.lex_state = 105},
  [6817] = {.lex_state = 105},
  [6818] = {.lex_state = 105},
  [6819] = {.lex_state = 105},
  [6820] = {.lex_state = 105},
  [6821] = {.lex_state = 105},
  [6822] = {.lex_state = 105},
  [6823] = {.lex_state = 105},
  [6824] = {.lex_state = 105},
  [6825] = {.lex_state = 105},
  [6826] = {.lex_state = 105},
  [6827] = {.lex_state = 105},
  [6828] = {.lex_state = 105},
  [6829] = {.lex_state = 105},
  [6830] = {.lex_state = 105},
  [6831] = {.lex_state = 105},
  [6832] = {.lex_state = 105},
  [6833] = {.lex_state = 105},
  [6834] = {.lex_state = 105},
  [6835] = {.lex_state = 105},
  [6836] = {.lex_state = 105},
  [6837] = {.lex_state = 105},
  [6838] = {.lex_state = 105},
  [6839] = {.lex_state = 105},
  [6840] = {.lex_state = 105},
  [6841] = {.lex_state = 105},
  [6842] = {.lex_state = 105},
  [6843] = {.lex_state = 105},
  [6844] = {.lex_state = 105},
  [6845] = {.lex_state = 105},
  [6846] = {.lex_state = 105},
  [6847] = {.lex_state = 105},
  [6848] = {.lex_state = 105},
  [6849] = {.lex_state = 105},
  [6850] = {.lex_state = 105},
  [6851] = {.lex_state = 105},
  [6852] = {.lex_state = 105},
  [6853] = {.lex_state = 105},
  [6854] = {.lex_state = 105},
  [6855] = {.lex_state = 105},
  [6856] = {.lex_state = 105},
  [6857] = {.lex_state = 105},
  [6858] = {.lex_state = 105},
  [6859] = {.lex_state = 105},
  [6860] = {.lex_state = 105},
  [6861] = {.lex_state = 105},
  [6862] = {.lex_state = 105},
  [6863] = {.lex_state = 105},
  [6864] = {.lex_state = 105},
  [6865] = {.lex_state = 105},
  [6866] = {.lex_state = 105},
  [6867] = {.lex_state = 105},
  [6868] = {.lex_state = 105},
  [6869] = {.lex_state = 105},
  [6870] = {.lex_state = 105},
  [6871] = {.lex_state = 105},
  [6872] = {.lex_state = 105},
  [6873] = {.lex_state = 105},
  [6874] = {.lex_state = 105},
  [6875] = {.lex_state = 105},
  [6876] = {.lex_state = 105},
  [6877] = {.lex_state = 105},
  [6878] = {.lex_state = 105},
  [6879] = {.lex_state = 105},
  [6880] = {.lex_state = 105},
  [6881] = {.lex_state = 105},
  [6882] = {.lex_state = 105},
  [6883] = {.lex_state = 105},
  [6884] = {.lex_state = 105},
  [6885] = {.lex_state = 105},
  [6886] = {.lex_state = 105},
  [6887] = {.lex_state = 105},
  [6888] = {.lex_state = 105},
  [6889] = {.lex_state = 105},
  [6890] = {.lex_state = 104},
  [6891] = {.lex_state = 105},
  [6892] = {.lex_state = 105},
  [6893] = {.lex_state = 105},
  [6894] = {.lex_state = 105},
  [6895] = {.lex_state = 105},
  [6896] = {.lex_state = 105},
  [6897] = {.lex_state = 105},
  [6898] = {.lex_state = 105},
  [6899] = {.lex_state = 105},
  [6900] = {.lex_state = 105},
  [6901] = {.lex_state = 105},
  [6902] = {.lex_state = 105},
  [6903] = {.lex_state = 105},
  [6904] = {.lex_state = 105},
  [6905] = {.lex_state = 105},
  [6906] = {.lex_state = 105},
  [6907] = {.lex_state = 105},
  [6908] = {.lex_state = 105},
  [6909] = {.lex_state = 105},
  [6910] = {.lex_state = 105},
  [6911] = {.lex_state = 105},
  [6912] = {.lex_state = 105},
  [6913] = {.lex_state = 105},
  [6914] = {.lex_state = 105},
  [6915] = {.lex_state = 105},
  [6916] = {.lex_state = 105},
  [6917] = {.lex_state = 105},
  [6918] = {.lex_state = 105},
  [6919] = {.lex_state = 105},
  [6920] = {.lex_state = 105},
  [6921] = {.lex_state = 105},
  [6922] = {.lex_state = 105},
  [6923] = {.lex_state = 105},
  [6924] = {.lex_state = 105},
  [6925] = {.lex_state = 105},
  [6926] = {.lex_state = 105},
  [6927] = {.lex_state = 105},
  [6928] = {.lex_state = 105},
  [6929] = {.lex_state = 105},
  [6930] = {.lex_state = 105},
  [6931] = {.lex_state = 105},
  [6932] = {.lex_state = 105},
  [6933] = {.lex_state = 105},
  [6934] = {.lex_state = 105},
  [6935] = {.lex_state = 105},
  [6936] = {.lex_state = 105},
  [6937] = {.lex_state = 105},
  [6938] = {.lex_state = 105},
  [6939] = {.lex_state = 105},
  [6940] = {.lex_state = 105},
  [6941] = {.lex_state = 105},
  [6942] = {.lex_state = 105},
  [6943] = {.lex_state = 105},
  [6944] = {.lex_state = 105},
  [6945] = {.lex_state = 105},
  [6946] = {.lex_state = 105},
  [6947] = {.lex_state = 105},
  [6948] = {.lex_state = 105},
  [6949] = {.lex_state = 105},
  [6950] = {.lex_state = 105},
  [6951] = {.lex_state = 105},
  [6952] = {.lex_state = 105},
  [6953] = {.lex_state = 105},
  [6954] = {.lex_state = 105},
  [6955] = {.lex_state = 105},
  [6956] = {.lex_state = 105},
  [6957] = {.lex_state = 105},
  [6958] = {.lex_state = 105},
  [6959] = {.lex_state = 105},
  [6960] = {.lex_state = 105},
  [6961] = {.lex_state = 105},
  [6962] = {.lex_state = 105},
  [6963] = {.lex_state = 105},
  [6964] = {.lex_state = 105},
  [6965] = {.lex_state = 105},
  [6966] = {.lex_state = 105},
  [6967] = {.lex_state = 105},
  [6968] = {.lex_state = 105},
  [6969] = {.lex_state = 105},
  [6970] = {.lex_state = 105},
  [6971] = {.lex_state = 105},
  [6972] = {.lex_state = 105},
  [6973] = {.lex_state = 105},
  [6974] = {.lex_state = 105},
  [6975] = {.lex_state = 105},
  [6976] = {.lex_state = 105},
  [6977] = {.lex_state = 105},
  [6978] = {.lex_state = 105},
  [6979] = {.lex_state = 105},
  [6980] = {.lex_state = 105},
  [6981] = {.lex_state = 105},
  [6982] = {.lex_state = 105},
  [6983] = {.lex_state = 105},
  [6984] = {.lex_state = 105},
  [6985] = {.lex_state = 105},
  [6986] = {.lex_state = 105},
  [6987] = {.lex_state = 105},
  [6988] = {.lex_state = 105},
  [6989] = {.lex_state = 105},
  [6990] = {.lex_state = 105},
  [6991] = {.lex_state = 105},
  [6992] = {.lex_state = 105},
  [6993] = {.lex_state = 105},
  [6994] = {.lex_state = 105},
  [6995] = {.lex_state = 105},
  [6996] = {.lex_state = 105},
  [6997] = {.lex_state = 105},
  [6998] = {.lex_state = 105},
  [6999] = {.lex_state = 105},
  [7000] = {.lex_state = 105},
  [7001] = {.lex_state = 105},
  [7002] = {.lex_state = 105},
  [7003] = {.lex_state = 105},
  [7004] = {.lex_state = 105},
  [7005] = {.lex_state = 105},
  [7006] = {.lex_state = 105},
  [7007] = {.lex_state = 105},
  [7008] = {.lex_state = 105},
  [7009] = {.lex_state = 105},
  [7010] = {.lex_state = 105},
  [7011] = {.lex_state = 105},
  [7012] = {.lex_state = 105},
  [7013] = {.lex_state = 105},
  [7014] = {.lex_state = 105},
  [7015] = {.lex_state = 105},
  [7016] = {.lex_state = 105},
  [7017] = {.lex_state = 105},
  [7018] = {.lex_state = 105},
  [7019] = {.lex_state = 105},
  [7020] = {.lex_state = 105},
  [7021] = {.lex_state = 105},
  [7022] = {.lex_state = 105},
  [7023] = {.lex_state = 105},
  [7024] = {.lex_state = 105},
  [7025] = {.lex_state = 105},
  [7026] = {.lex_state = 105},
  [7027] = {.lex_state = 105},
  [7028] = {.lex_state = 105},
  [7029] = {.lex_state = 105},
  [7030] = {.lex_state = 105},
  [7031] = {.lex_state = 105},
  [7032] = {.lex_state = 105},
  [7033] = {.lex_state = 105},
  [7034] = {.lex_state = 105},
  [7035] = {.lex_state = 105},
  [7036] = {.lex_state = 105},
  [7037] = {.lex_state = 105},
  [7038] = {.lex_state = 105},
  [7039] = {.lex_state = 105},
  [7040] = {.lex_state = 105},
  [7041] = {.lex_state = 105},
  [7042] = {.lex_state = 105},
  [7043] = {.lex_state = 105},
  [7044] = {.lex_state = 105},
  [7045] = {.lex_state = 105},
  [7046] = {.lex_state = 105},
  [7047] = {.lex_state = 105},
  [7048] = {.lex_state = 105},
  [7049] = {.lex_state = 105},
  [7050] = {.lex_state = 105},
  [7051] = {.lex_state = 105},
  [7052] = {.lex_state = 105},
  [7053] = {.lex_state = 105},
  [7054] = {.lex_state = 105},
  [7055] = {.lex_state = 105},
  [7056] = {.lex_state = 105},
  [7057] = {.lex_state = 105},
  [7058] = {.lex_state = 105},
  [7059] = {.lex_state = 105},
  [7060] = {.lex_state = 105},
  [7061] = {.lex_state = 105},
  [7062] = {.lex_state = 105},
  [7063] = {.lex_state = 105},
  [7064] = {.lex_state = 105},
  [7065] = {.lex_state = 105},
  [7066] = {.lex_state = 105},
  [7067] = {.lex_state = 105},
  [7068] = {.lex_state = 105},
  [7069] = {.lex_state = 105},
  [7070] = {.lex_state = 105},
  [7071] = {.lex_state = 105},
  [7072] = {.lex_state = 105},
  [7073] = {.lex_state = 105},
  [7074] = {.lex_state = 105},
  [7075] = {.lex_state = 105},
  [7076] = {.lex_state = 105},
  [7077] = {.lex_state = 105},
  [7078] = {.lex_state = 105},
  [7079] = {.lex_state = 105},
  [7080] = {.lex_state = 105},
  [7081] = {.lex_state = 105},
  [7082] = {.lex_state = 105},
  [7083] = {.lex_state = 105},
  [7084] = {.lex_state = 105},
  [7085] = {.lex_state = 105},
  [7086] = {.lex_state = 105},
  [7087] = {.lex_state = 105},
  [7088] = {.lex_state = 105},
  [7089] = {.lex_state = 105},
  [7090] = {.lex_state = 105},
  [7091] = {.lex_state = 105},
  [7092] = {.lex_state = 105},
  [7093] = {.lex_state = 105},
  [7094] = {.lex_state = 105},
  [7095] = {.lex_state = 105},
  [7096] = {.lex_state = 105},
  [7097] = {.lex_state = 105},
  [7098] = {.lex_state = 105},
  [7099] = {.lex_state = 105},
  [7100] = {.lex_state = 105},
  [7101] = {.lex_state = 105},
  [7102] = {.lex_state = 105},
  [7103] = {.lex_state = 105},
  [7104] = {.lex_state = 105},
  [7105] = {.lex_state = 105},
  [7106] = {.lex_state = 105},
  [7107] = {.lex_state = 105},
  [7108] = {.lex_state = 105},
  [7109] = {.lex_state = 105},
  [7110] = {.lex_state = 105},
  [7111] = {.lex_state = 105},
  [7112] = {.lex_state = 105},
  [7113] = {.lex_state = 105},
  [7114] = {.lex_state = 105},
  [7115] = {.lex_state = 105},
  [7116] = {.lex_state = 105},
  [7117] = {.lex_state = 105},
  [7118] = {.lex_state = 105},
  [7119] = {.lex_state = 105},
  [7120] = {.lex_state = 105},
  [7121] = {.lex_state = 105},
  [7122] = {.lex_state = 105},
  [7123] = {.lex_state = 105},
  [7124] = {.lex_state = 105},
  [7125] = {.lex_state = 105},
  [7126] = {.lex_state = 105},
  [7127] = {.lex_state = 105},
  [7128] = {.lex_state = 105},
  [7129] = {.lex_state = 105},
  [7130] = {.lex_state = 105},
  [7131] = {.lex_state = 105},
  [7132] = {.lex_state = 105},
  [7133] = {.lex_state = 105},
  [7134] = {.lex_state = 105},
  [7135] = {.lex_state = 105},
  [7136] = {.lex_state = 105},
  [7137] = {.lex_state = 105},
  [7138] = {.lex_state = 105},
  [7139] = {.lex_state = 105},
  [7140] = {.lex_state = 105},
  [7141] = {.lex_state = 105},
  [7142] = {.lex_state = 105},
  [7143] = {.lex_state = 105},
  [7144] = {.lex_state = 105},
  [7145] = {.lex_state = 105},
  [7146] = {.lex_state = 105},
  [7147] = {.lex_state = 105},
  [7148] = {.lex_state = 105},
  [7149] = {.lex_state = 105},
  [7150] = {.lex_state = 105},
  [7151] = {.lex_state = 105},
  [7152] = {.lex_state = 105},
  [7153] = {.lex_state = 105},
  [7154] = {.lex_state = 105},
  [7155] = {.lex_state = 105},
  [7156] = {.lex_state = 105},
  [7157] = {.lex_state = 105},
  [7158] = {.lex_state = 105},
  [7159] = {.lex_state = 105},
  [7160] = {.lex_state = 105},
  [7161] = {.lex_state = 105},
  [7162] = {.lex_state = 105},
  [7163] = {.lex_state = 105},
  [7164] = {.lex_state = 105},
  [7165] = {.lex_state = 105},
  [7166] = {.lex_state = 105},
  [7167] = {.lex_state = 105},
  [7168] = {.lex_state = 105},
  [7169] = {.lex_state = 105},
  [7170] = {.lex_state = 105},
  [7171] = {.lex_state = 105},
  [7172] = {.lex_state = 105},
  [7173] = {.lex_state = 105},
  [7174] = {.lex_state = 105},
  [7175] = {.lex_state = 105},
  [7176] = {.lex_state = 105},
  [7177] = {.lex_state = 105},
  [7178] = {.lex_state = 105},
  [7179] = {.lex_state = 105},
  [7180] = {.lex_state = 105},
  [7181] = {.lex_state = 105},
  [7182] = {.lex_state = 105},
  [7183] = {.lex_state = 105},
  [7184] = {.lex_state = 105},
  [7185] = {.lex_state = 105},
  [7186] = {.lex_state = 105},
  [7187] = {.lex_state = 105},
  [7188] = {.lex_state = 105},
  [7189] = {.lex_state = 105},
  [7190] = {.lex_state = 105},
  [7191] = {.lex_state = 105},
  [7192] = {.lex_state = 105},
  [7193] = {.lex_state = 105},
  [7194] = {.lex_state = 105},
  [7195] = {.lex_state = 105},
  [7196] = {.lex_state = 105},
  [7197] = {.lex_state = 105},
  [7198] = {.lex_state = 105},
  [7199] = {.lex_state = 105},
  [7200] = {.lex_state = 105},
  [7201] = {.lex_state = 105},
  [7202] = {.lex_state = 105},
  [7203] = {.lex_state = 105},
  [7204] = {.lex_state = 105},
  [7205] = {.lex_state = 105},
  [7206] = {.lex_state = 105},
  [7207] = {.lex_state = 105},
  [7208] = {.lex_state = 105},
  [7209] = {.lex_state = 105},
  [7210] = {.lex_state = 105},
  [7211] = {.lex_state = 105},
  [7212] = {.lex_state = 105},
  [7213] = {.lex_state = 105},
  [7214] = {.lex_state = 105},
  [7215] = {.lex_state = 105},
  [7216] = {.lex_state = 1},
  [7217] = {.lex_state = 105},
  [7218] = {.lex_state = 105},
  [7219] = {.lex_state = 105},
  [7220] = {.lex_state = 105},
  [7221] = {.lex_state = 105},
  [7222] = {.lex_state = 105},
  [7223] = {.lex_state = 105},
  [7224] = {.lex_state = 105},
  [7225] = {.lex_state = 105},
  [7226] = {.lex_state = 105},
  [7227] = {.lex_state = 105},
  [7228] = {.lex_state = 105},
  [7229] = {.lex_state = 105},
  [7230] = {.lex_state = 105},
  [7231] = {.lex_state = 105},
  [7232] = {.lex_state = 105},
  [7233] = {.lex_state = 105},
  [7234] = {.lex_state = 105},
  [7235] = {.lex_state = 105},
  [7236] = {.lex_state = 105},
  [7237] = {.lex_state = 105},
  [7238] = {.lex_state = 105},
  [7239] = {.lex_state = 105},
  [7240] = {.lex_state = 105},
  [7241] = {.lex_state = 105},
  [7242] = {.lex_state = 105},
  [7243] = {.lex_state = 105},
  [7244] = {.lex_state = 105},
  [7245] = {.lex_state = 105},
  [7246] = {.lex_state = 105},
  [7247] = {.lex_state = 105},
  [7248] = {.lex_state = 105},
  [7249] = {.lex_state = 105},
  [7250] = {.lex_state = 105},
  [7251] = {.lex_state = 105},
  [7252] = {.lex_state = 105},
  [7253] = {.lex_state = 105},
  [7254] = {.lex_state = 105},
  [7255] = {.lex_state = 105},
  [7256] = {.lex_state = 105},
  [7257] = {.lex_state = 105},
  [7258] = {.lex_state = 105},
  [7259] = {.lex_state = 105},
  [7260] = {.lex_state = 105},
  [7261] = {.lex_state = 105},
  [7262] = {.lex_state = 105},
  [7263] = {.lex_state = 105},
  [7264] = {.lex_state = 105},
  [7265] = {.lex_state = 105},
  [7266] = {.lex_state = 105},
  [7267] = {.lex_state = 105},
  [7268] = {.lex_state = 105},
  [7269] = {.lex_state = 105},
  [7270] = {.lex_state = 105},
  [7271] = {.lex_state = 105},
  [7272] = {.lex_state = 105},
  [7273] = {.lex_state = 105},
  [7274] = {.lex_state = 105},
  [7275] = {.lex_state = 105},
  [7276] = {.lex_state = 105},
  [7277] = {.lex_state = 105},
  [7278] = {.lex_state = 105},
  [7279] = {.lex_state = 105},
  [7280] = {.lex_state = 105},
  [7281] = {.lex_state = 105},
  [7282] = {.lex_state = 105},
  [7283] = {.lex_state = 105},
  [7284] = {.lex_state = 105},
  [7285] = {.lex_state = 105},
  [7286] = {.lex_state = 4},
  [7287] = {.lex_state = 105},
  [7288] = {.lex_state = 105},
  [7289] = {.lex_state = 105},
  [7290] = {.lex_state = 105},
  [7291] = {.lex_state = 105},
  [7292] = {.lex_state = 105},
  [7293] = {.lex_state = 105},
  [7294] = {.lex_state = 105},
  [7295] = {.lex_state = 105},
  [7296] = {.lex_state = 105},
  [7297] = {.lex_state = 105},
  [7298] = {.lex_state = 105},
  [7299] = {.lex_state = 105},
  [7300] = {.lex_state = 105},
  [7301] = {.lex_state = 105},
  [7302] = {.lex_state = 105},
  [7303] = {.lex_state = 105},
  [7304] = {.lex_state = 105},
  [7305] = {.lex_state = 105},
  [7306] = {.lex_state = 105},
  [7307] = {.lex_state = 105},
  [7308] = {.lex_state = 105},
  [7309] = {.lex_state = 105},
  [7310] = {.lex_state = 105},
  [7311] = {.lex_state = 105},
  [7312] = {.lex_state = 105},
  [7313] = {.lex_state = 105},
  [7314] = {.lex_state = 105},
  [7315] = {.lex_state = 105},
  [7316] = {.lex_state = 105},
  [7317] = {.lex_state = 105},
  [7318] = {.lex_state = 105},
  [7319] = {.lex_state = 105},
  [7320] = {.lex_state = 105},
  [7321] = {.lex_state = 105},
  [7322] = {.lex_state = 105},
  [7323] = {.lex_state = 105},
  [7324] = {.lex_state = 105},
  [7325] = {.lex_state = 105},
  [7326] = {.lex_state = 105},
  [7327] = {.lex_state = 105},
  [7328] = {.lex_state = 105},
  [7329] = {.lex_state = 105},
  [7330] = {.lex_state = 105},
  [7331] = {.lex_state = 105},
  [7332] = {.lex_state = 105},
  [7333] = {.lex_state = 105},
  [7334] = {.lex_state = 105},
  [7335] = {.lex_state = 105},
  [7336] = {.lex_state = 105},
  [7337] = {.lex_state = 105},
  [7338] = {.lex_state = 105},
  [7339] = {.lex_state = 105},
  [7340] = {.lex_state = 105},
  [7341] = {.lex_state = 105},
  [7342] = {.lex_state = 105},
  [7343] = {.lex_state = 105},
  [7344] = {.lex_state = 105},
  [7345] = {.lex_state = 105},
  [7346] = {.lex_state = 105},
  [7347] = {.lex_state = 105},
  [7348] = {.lex_state = 105},
  [7349] = {.lex_state = 105},
  [7350] = {.lex_state = 105},
  [7351] = {.lex_state = 105},
  [7352] = {.lex_state = 105},
  [7353] = {.lex_state = 105},
  [7354] = {.lex_state = 105},
  [7355] = {.lex_state = 105},
  [7356] = {.lex_state = 105},
  [7357] = {.lex_state = 105},
  [7358] = {.lex_state = 105},
  [7359] = {.lex_state = 105},
  [7360] = {.lex_state = 105},
  [7361] = {.lex_state = 105},
  [7362] = {.lex_state = 105},
  [7363] = {.lex_state = 105},
  [7364] = {.lex_state = 105},
  [7365] = {.lex_state = 105},
  [7366] = {.lex_state = 105},
  [7367] = {.lex_state = 105},
  [7368] = {.lex_state = 105},
  [7369] = {.lex_state = 105},
  [7370] = {.lex_state = 105},
  [7371] = {.lex_state = 105},
  [7372] = {.lex_state = 105},
  [7373] = {.lex_state = 105},
  [7374] = {.lex_state = 105},
  [7375] = {.lex_state = 105},
  [7376] = {.lex_state = 105},
  [7377] = {.lex_state = 105},
  [7378] = {.lex_state = 105},
  [7379] = {.lex_state = 105},
  [7380] = {.lex_state = 105},
  [7381] = {.lex_state = 105},
  [7382] = {.lex_state = 105},
  [7383] = {.lex_state = 105},
  [7384] = {.lex_state = 105},
  [7385] = {.lex_state = 105},
  [7386] = {.lex_state = 105},
  [7387] = {.lex_state = 105},
  [7388] = {.lex_state = 105},
  [7389] = {.lex_state = 105},
  [7390] = {.lex_state = 105},
  [7391] = {.lex_state = 105},
  [7392] = {.lex_state = 8},
  [7393] = {.lex_state = 8},
  [7394] = {.lex_state = 8},
  [7395] = {.lex_state = 8},
  [7396] = {.lex_state = 8},
  [7397] = {.lex_state = 8},
  [7398] = {.lex_state = 8},
  [7399] = {.lex_state = 8},
  [7400] = {.lex_state = 8},
  [7401] = {.lex_state = 8},
  [7402] = {.lex_state = 8},
  [7403] = {.lex_state = 8},
  [7404] = {.lex_state = 105},
  [7405] = {.lex_state = 105},
  [7406] = {.lex_state = 105},
  [7407] = {.lex_state = 105},
  [7408] = {.lex_state = 105},
  [7409] = {.lex_state = 105},
  [7410] = {.lex_state = 105},
  [7411] = {.lex_state = 105},
  [7412] = {.lex_state = 105},
  [7413] = {.lex_state = 105},
  [7414] = {.lex_state = 105},
  [7415] = {.lex_state = 105},
  [7416] = {.lex_state = 105},
  [7417] = {.lex_state = 105},
  [7418] = {.lex_state = 105},
  [7419] = {.lex_state = 105},
  [7420] = {.lex_state = 105},
  [7421] = {.lex_state = 105},
  [7422] = {.lex_state = 105},
  [7423] = {.lex_state = 105},
  [7424] = {.lex_state = 105},
  [7425] = {.lex_state = 105},
  [7426] = {.lex_state = 105},
  [7427] = {.lex_state = 105},
  [7428] = {.lex_state = 105},
  [7429] = {.lex_state = 105},
  [7430] = {.lex_state = 105},
  [7431] = {.lex_state = 105},
  [7432] = {.lex_state = 105},
  [7433] = {.lex_state = 105},
  [7434] = {.lex_state = 105},
  [7435] = {.lex_state = 105},
  [7436] = {.lex_state = 105},
  [7437] = {.lex_state = 105},
  [7438] = {.lex_state = 105},
  [7439] = {.lex_state = 105},
  [7440] = {.lex_state = 105},
  [7441] = {.lex_state = 105},
  [7442] = {.lex_state = 105},
  [7443] = {.lex_state = 105},
  [7444] = {.lex_state = 105},
  [7445] = {.lex_state = 105},
  [7446] = {.lex_state = 105},
  [7447] = {.lex_state = 105},
  [7448] = {.lex_state = 105},
  [7449] = {.lex_state = 105},
  [7450] = {.lex_state = 105},
  [7451] = {.lex_state = 105},
  [7452] = {.lex_state = 105},
  [7453] = {.lex_state = 105},
  [7454] = {.lex_state = 105},
  [7455] = {.lex_state = 105},
  [7456] = {.lex_state = 105},
  [7457] = {.lex_state = 105},
  [7458] = {.lex_state = 105},
  [7459] = {.lex_state = 105},
  [7460] = {.lex_state = 105},
  [7461] = {.lex_state = 105},
  [7462] = {.lex_state = 105},
  [7463] = {.lex_state = 105},
  [7464] = {.lex_state = 105},
  [7465] = {.lex_state = 105},
  [7466] = {.lex_state = 105},
  [7467] = {.lex_state = 105},
  [7468] = {.lex_state = 105},
  [7469] = {.lex_state = 105},
  [7470] = {.lex_state = 105},
  [7471] = {.lex_state = 105},
  [7472] = {.lex_state = 105},
  [7473] = {.lex_state = 105},
  [7474] = {.lex_state = 105},
  [7475] = {.lex_state = 105},
  [7476] = {.lex_state = 105},
  [7477] = {.lex_state = 105},
  [7478] = {.lex_state = 105},
  [7479] = {.lex_state = 105},
  [7480] = {.lex_state = 105},
  [7481] = {.lex_state = 105},
  [7482] = {.lex_state = 105},
  [7483] = {.lex_state = 105},
  [7484] = {.lex_state = 105},
  [7485] = {.lex_state = 105},
  [7486] = {.lex_state = 105},
  [7487] = {.lex_state = 105},
  [7488] = {.lex_state = 105},
  [7489] = {.lex_state = 105},
  [7490] = {.lex_state = 105},
  [7491] = {.lex_state = 105},
  [7492] = {.lex_state = 105},
  [7493] = {.lex_state = 105},
  [7494] = {.lex_state = 105},
  [7495] = {.lex_state = 105},
  [7496] = {.lex_state = 105},
  [7497] = {.lex_state = 105},
  [7498] = {.lex_state = 105},
  [7499] = {.lex_state = 105},
  [7500] = {.lex_state = 105},
  [7501] = {.lex_state = 0},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 0},
  [7504] = {.lex_state = 105},
  [7505] = {.lex_state = 104},
  [7506] = {.lex_state = 104},
  [7507] = {.lex_state = 104},
  [7508] = {.lex_state = 104},
  [7509] = {.lex_state = 104},
  [7510] = {.lex_state = 104},
  [7511] = {.lex_state = 104},
  [7512] = {.lex_state = 104},
  [7513] = {.lex_state = 104},
  [7514] = {.lex_state = 104},
  [7515] = {.lex_state = 104},
  [7516] = {.lex_state = 104},
  [7517] = {.lex_state = 104},
  [7518] = {.lex_state = 104},
  [7519] = {.lex_state = 104},
  [7520] = {.lex_state = 104},
  [7521] = {.lex_state = 104},
  [7522] = {.lex_state = 104},
  [7523] = {.lex_state = 104},
  [7524] = {.lex_state = 0},
  [7525] = {.lex_state = 104},
  [7526] = {.lex_state = 0},
  [7527] = {.lex_state = 104},
  [7528] = {.lex_state = 104},
  [7529] = {.lex_state = 104},
  [7530] = {.lex_state = 105},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 104},
  [7533] = {.lex_state = 104},
  [7534] = {.lex_state = 104},
  [7535] = {.lex_state = 104},
  [7536] = {.lex_state = 104},
  [7537] = {.lex_state = 104},
  [7538] = {.lex_state = 104},
  [7539] = {.lex_state = 104},
  [7540] = {.lex_state = 104},
  [7541] = {.lex_state = 104},
  [7542] = {.lex_state = 104},
  [7543] = {.lex_state = 104},
  [7544] = {.lex_state = 104},
  [7545] = {.lex_state = 104},
  [7546] = {.lex_state = 0},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 104},
  [7550] = {.lex_state = 104},
  [7551] = {.lex_state = 104},
  [7552] = {.lex_state = 104},
  [7553] = {.lex_state = 104},
  [7554] = {.lex_state = 104},
  [7555] = {.lex_state = 104},
  [7556] = {.lex_state = 0},
  [7557] = {.lex_state = 104},
  [7558] = {.lex_state = 104},
  [7559] = {.lex_state = 105},
  [7560] = {.lex_state = 105},
  [7561] = {.lex_state = 105},
  [7562] = {.lex_state = 105},
  [7563] = {.lex_state = 105},
  [7564] = {.lex_state = 105},
  [7565] = {.lex_state = 105},
  [7566] = {.lex_state = 104},
  [7567] = {.lex_state = 104},
  [7568] = {.lex_state = 0},
  [7569] = {.lex_state = 0},
  [7570] = {.lex_state = 105},
  [7571] = {.lex_state = 105},
  [7572] = {.lex_state = 104},
  [7573] = {.lex_state = 105},
  [7574] = {.lex_state = 104},
  [7575] = {.lex_state = 104},
  [7576] = {.lex_state = 105},
  [7577] = {.lex_state = 105},
  [7578] = {.lex_state = 105},
  [7579] = {.lex_state = 104},
  [7580] = {.lex_state = 105},
  [7581] = {.lex_state = 104},
  [7582] = {.lex_state = 105},
  [7583] = {.lex_state = 105},
  [7584] = {.lex_state = 104},
  [7585] = {.lex_state = 105},
  [7586] = {.lex_state = 105},
  [7587] = {.lex_state = 105},
  [7588] = {.lex_state = 104},
  [7589] = {.lex_state = 105},
  [7590] = {.lex_state = 105},
  [7591] = {.lex_state = 105},
  [7592] = {.lex_state = 105},
  [7593] = {.lex_state = 104},
  [7594] = {.lex_state = 105},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 105},
  [7597] = {.lex_state = 105},
  [7598] = {.lex_state = 105},
  [7599] = {.lex_state = 105},
  [7600] = {.lex_state = 105},
  [7601] = {.lex_state = 105},
  [7602] = {.lex_state = 104},
  [7603] = {.lex_state = 105},
  [7604] = {.lex_state = 105},
  [7605] = {.lex_state = 105},
  [7606] = {.lex_state = 105},
  [7607] = {.lex_state = 104},
  [7608] = {.lex_state = 105},
  [7609] = {.lex_state = 105},
  [7610] = {.lex_state = 104},
  [7611] = {.lex_state = 105},
  [7612] = {.lex_state = 105},
  [7613] = {.lex_state = 105},
  [7614] = {.lex_state = 105},
  [7615] = {.lex_state = 105},
  [7616] = {.lex_state = 105},
  [7617] = {.lex_state = 105},
  [7618] = {.lex_state = 105},
  [7619] = {.lex_state = 105},
  [7620] = {.lex_state = 105},
  [7621] = {.lex_state = 105},
  [7622] = {.lex_state = 105},
  [7623] = {.lex_state = 105},
  [7624] = {.lex_state = 105},
  [7625] = {.lex_state = 105},
  [7626] = {.lex_state = 105},
  [7627] = {.lex_state = 105},
  [7628] = {.lex_state = 105},
  [7629] = {.lex_state = 105},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 105},
  [7632] = {.lex_state = 105},
  [7633] = {.lex_state = 104},
  [7634] = {.lex_state = 104},
  [7635] = {.lex_state = 104},
  [7636] = {.lex_state = 104},
  [7637] = {.lex_state = 105},
  [7638] = {.lex_state = 105},
  [7639] = {.lex_state = 105},
  [7640] = {.lex_state = 105},
  [7641] = {.lex_state = 105},
  [7642] = {.lex_state = 104},
  [7643] = {.lex_state = 104},
  [7644] = {.lex_state = 105},
  [7645] = {.lex_state = 105},
  [7646] = {.lex_state = 104},
  [7647] = {.lex_state = 104},
  [7648] = {.lex_state = 104},
  [7649] = {.lex_state = 104},
  [7650] = {.lex_state = 104},
  [7651] = {.lex_state = 105},
  [7652] = {.lex_state = 105},
  [7653] = {.lex_state = 104},
  [7654] = {.lex_state = 105},
  [7655] = {.lex_state = 105},
  [7656] = {.lex_state = 105},
  [7657] = {.lex_state = 104},
  [7658] = {.lex_state = 105},
  [7659] = {.lex_state = 105},
  [7660] = {.lex_state = 105},
  [7661] = {.lex_state = 104},
  [7662] = {.lex_state = 10},
  [7663] = {.lex_state = 105},
  [7664] = {.lex_state = 104},
  [7665] = {.lex_state = 105},
  [7666] = {.lex_state = 105},
  [7667] = {.lex_state = 104},
  [7668] = {.lex_state = 105},
  [7669] = {.lex_state = 104},
  [7670] = {.lex_state = 104},
  [7671] = {.lex_state = 0},
  [7672] = {.lex_state = 104},
  [7673] = {.lex_state = 104},
  [7674] = {.lex_state = 104},
  [7675] = {.lex_state = 104},
  [7676] = {.lex_state = 104},
  [7677] = {.lex_state = 104},
  [7678] = {.lex_state = 104},
  [7679] = {.lex_state = 104},
  [7680] = {.lex_state = 104},
  [7681] = {.lex_state = 104},
  [7682] = {.lex_state = 0},
  [7683] = {.lex_state = 104},
  [7684] = {.lex_state = 104},
  [7685] = {.lex_state = 104},
  [7686] = {.lex_state = 104},
  [7687] = {.lex_state = 0},
  [7688] = {.lex_state = 104},
  [7689] = {.lex_state = 105},
  [7690] = {.lex_state = 104},
  [7691] = {.lex_state = 105},
  [7692] = {.lex_state = 105},
  [7693] = {.lex_state = 104},
  [7694] = {.lex_state = 104},
  [7695] = {.lex_state = 104},
  [7696] = {.lex_state = 104},
  [7697] = {.lex_state = 104},
  [7698] = {.lex_state = 104},
  [7699] = {.lex_state = 104},
  [7700] = {.lex_state = 104},
  [7701] = {.lex_state = 104},
  [7702] = {.lex_state = 104},
  [7703] = {.lex_state = 105},
  [7704] = {.lex_state = 0, .external_lex_state = 5},
  [7705] = {.lex_state = 104},
  [7706] = {.lex_state = 104},
  [7707] = {.lex_state = 104},
  [7708] = {.lex_state = 104},
  [7709] = {.lex_state = 104},
  [7710] = {.lex_state = 104},
  [7711] = {.lex_state = 104},
  [7712] = {.lex_state = 104},
  [7713] = {.lex_state = 104},
  [7714] = {.lex_state = 104},
  [7715] = {.lex_state = 105},
  [7716] = {.lex_state = 104},
  [7717] = {.lex_state = 104},
  [7718] = {.lex_state = 105},
  [7719] = {.lex_state = 104},
  [7720] = {.lex_state = 104},
  [7721] = {.lex_state = 104},
  [7722] = {.lex_state = 104},
  [7723] = {.lex_state = 0, .external_lex_state = 5},
  [7724] = {.lex_state = 104},
  [7725] = {.lex_state = 104},
  [7726] = {.lex_state = 104},
  [7727] = {.lex_state = 104},
  [7728] = {.lex_state = 104},
  [7729] = {.lex_state = 104},
  [7730] = {.lex_state = 0, .external_lex_state = 5},
  [7731] = {.lex_state = 0, .external_lex_state = 5},
  [7732] = {.lex_state = 104},
  [7733] = {.lex_state = 104},
  [7734] = {.lex_state = 104},
  [7735] = {.lex_state = 104},
  [7736] = {.lex_state = 104},
  [7737] = {.lex_state = 104},
  [7738] = {.lex_state = 104},
  [7739] = {.lex_state = 0, .external_lex_state = 5},
  [7740] = {.lex_state = 104},
  [7741] = {.lex_state = 104},
  [7742] = {.lex_state = 0, .external_lex_state = 5},
  [7743] = {.lex_state = 104},
  [7744] = {.lex_state = 104},
  [7745] = {.lex_state = 104},
  [7746] = {.lex_state = 104},
  [7747] = {.lex_state = 104},
  [7748] = {.lex_state = 104},
  [7749] = {.lex_state = 104},
  [7750] = {.lex_state = 104},
  [7751] = {.lex_state = 104},
  [7752] = {.lex_state = 105},
  [7753] = {.lex_state = 105},
  [7754] = {.lex_state = 0, .external_lex_state = 5},
  [7755] = {.lex_state = 104},
  [7756] = {.lex_state = 0, .external_lex_state = 5},
  [7757] = {.lex_state = 0, .external_lex_state = 5},
  [7758] = {.lex_state = 104},
  [7759] = {.lex_state = 104},
  [7760] = {.lex_state = 0, .external_lex_state = 5},
  [7761] = {.lex_state = 105},
  [7762] = {.lex_state = 104},
  [7763] = {.lex_state = 0, .external_lex_state = 5},
  [7764] = {.lex_state = 104},
  [7765] = {.lex_state = 104},
  [7766] = {.lex_state = 104},
  [7767] = {.lex_state = 104},
  [7768] = {.lex_state = 104},
  [7769] = {.lex_state = 104},
  [7770] = {.lex_state = 0},
  [7771] = {.lex_state = 105},
  [7772] = {.lex_state = 105},
  [7773] = {.lex_state = 105},
  [7774] = {.lex_state = 105},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 105},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 105},
  [7779] = {.lex_state = 105},
  [7780] = {.lex_state = 1},
  [7781] = {.lex_state = 1},
  [7782] = {.lex_state = 105},
  [7783] = {.lex_state = 105},
  [7784] = {.lex_state = 105},
  [7785] = {.lex_state = 105},
  [7786] = {.lex_state = 105},
  [7787] = {.lex_state = 105},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 2},
  [7790] = {.lex_state = 105},
  [7791] = {.lex_state = 105},
  [7792] = {.lex_state = 2},
  [7793] = {.lex_state = 105},
  [7794] = {.lex_state = 105},
  [7795] = {.lex_state = 2},
  [7796] = {.lex_state = 0, .external_lex_state = 5},
  [7797] = {.lex_state = 0, .external_lex_state = 6},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 105},
  [7800] = {.lex_state = 10},
  [7801] = {.lex_state = 10},
  [7802] = {.lex_state = 105},
  [7803] = {.lex_state = 0},
  [7804] = {.lex_state = 2},
  [7805] = {.lex_state = 0, .external_lex_state = 5},
  [7806] = {.lex_state = 0, .external_lex_state = 6},
  [7807] = {.lex_state = 105},
  [7808] = {.lex_state = 105},
  [7809] = {.lex_state = 0},
  [7810] = {.lex_state = 105},
  [7811] = {.lex_state = 0},
  [7812] = {.lex_state = 105},
  [7813] = {.lex_state = 0},
  [7814] = {.lex_state = 2},
  [7815] = {.lex_state = 0, .external_lex_state = 6},
  [7816] = {.lex_state = 0, .external_lex_state = 6},
  [7817] = {.lex_state = 105},
  [7818] = {.lex_state = 105},
  [7819] = {.lex_state = 0, .external_lex_state = 5},
  [7820] = {.lex_state = 105},
  [7821] = {.lex_state = 0},
  [7822] = {.lex_state = 105},
  [7823] = {.lex_state = 0, .external_lex_state = 5},
  [7824] = {.lex_state = 105},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 2},
  [7827] = {.lex_state = 0, .external_lex_state = 6},
  [7828] = {.lex_state = 0},
  [7829] = {.lex_state = 105},
  [7830] = {.lex_state = 0, .external_lex_state = 5},
  [7831] = {.lex_state = 105},
  [7832] = {.lex_state = 2},
  [7833] = {.lex_state = 105},
  [7834] = {.lex_state = 105},
  [7835] = {.lex_state = 2},
  [7836] = {.lex_state = 105},
  [7837] = {.lex_state = 105},
  [7838] = {.lex_state = 0},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 0},
  [7841] = {.lex_state = 105},
  [7842] = {.lex_state = 105},
  [7843] = {.lex_state = 105},
  [7844] = {.lex_state = 0},
  [7845] = {.lex_state = 0},
  [7846] = {.lex_state = 105},
  [7847] = {.lex_state = 0},
  [7848] = {.lex_state = 105},
  [7849] = {.lex_state = 0},
  [7850] = {.lex_state = 105},
  [7851] = {.lex_state = 105},
  [7852] = {.lex_state = 105},
  [7853] = {.lex_state = 105},
  [7854] = {.lex_state = 105},
  [7855] = {.lex_state = 105},
  [7856] = {.lex_state = 105},
  [7857] = {.lex_state = 105},
  [7858] = {.lex_state = 105},
  [7859] = {.lex_state = 105},
  [7860] = {.lex_state = 105},
  [7861] = {.lex_state = 105},
  [7862] = {.lex_state = 105},
  [7863] = {.lex_state = 105},
  [7864] = {.lex_state = 105},
  [7865] = {.lex_state = 105},
  [7866] = {.lex_state = 105},
  [7867] = {.lex_state = 105},
  [7868] = {.lex_state = 105},
  [7869] = {.lex_state = 105},
  [7870] = {.lex_state = 2},
  [7871] = {.lex_state = 0, .external_lex_state = 6},
  [7872] = {.lex_state = 105},
  [7873] = {.lex_state = 0},
  [7874] = {.lex_state = 0, .external_lex_state = 5},
  [7875] = {.lex_state = 105},
  [7876] = {.lex_state = 105},
  [7877] = {.lex_state = 105},
  [7878] = {.lex_state = 105},
  [7879] = {.lex_state = 105},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 105},
  [7882] = {.lex_state = 0, .external_lex_state = 5},
  [7883] = {.lex_state = 105},
  [7884] = {.lex_state = 105},
  [7885] = {.lex_state = 105},
  [7886] = {.lex_state = 105},
  [7887] = {.lex_state = 105},
  [7888] = {.lex_state = 105},
  [7889] = {.lex_state = 0, .external_lex_state = 6},
  [7890] = {.lex_state = 0},
  [7891] = {.lex_state = 2},
  [7892] = {.lex_state = 105},
  [7893] = {.lex_state = 2},
  [7894] = {.lex_state = 0, .external_lex_state = 6},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 105},
  [7897] = {.lex_state = 0},
  [7898] = {.lex_state = 0, .external_lex_state = 5},
  [7899] = {.lex_state = 105},
  [7900] = {.lex_state = 105},
  [7901] = {.lex_state = 0, .external_lex_state = 6},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 105},
  [7904] = {.lex_state = 0, .external_lex_state = 5},
  [7905] = {.lex_state = 105},
  [7906] = {.lex_state = 0, .external_lex_state = 5},
  [7907] = {.lex_state = 105},
  [7908] = {.lex_state = 105},
  [7909] = {.lex_state = 105},
  [7910] = {.lex_state = 2},
  [7911] = {.lex_state = 105},
  [7912] = {.lex_state = 0},
  [7913] = {.lex_state = 0, .external_lex_state = 6},
  [7914] = {.lex_state = 0},
  [7915] = {.lex_state = 105},
  [7916] = {.lex_state = 105},
  [7917] = {.lex_state = 0},
  [7918] = {.lex_state = 105},
  [7919] = {.lex_state = 105},
  [7920] = {.lex_state = 105},
  [7921] = {.lex_state = 105},
  [7922] = {.lex_state = 105},
  [7923] = {.lex_state = 105},
  [7924] = {.lex_state = 105},
  [7925] = {.lex_state = 2},
  [7926] = {.lex_state = 0},
  [7927] = {.lex_state = 105},
  [7928] = {.lex_state = 0},
  [7929] = {.lex_state = 105},
  [7930] = {.lex_state = 0},
  [7931] = {.lex_state = 105},
  [7932] = {.lex_state = 0, .external_lex_state = 5},
  [7933] = {.lex_state = 105},
  [7934] = {.lex_state = 0, .external_lex_state = 6},
  [7935] = {.lex_state = 105},
  [7936] = {.lex_state = 105},
  [7937] = {.lex_state = 105},
  [7938] = {.lex_state = 105},
  [7939] = {.lex_state = 105},
  [7940] = {.lex_state = 105},
  [7941] = {.lex_state = 105},
  [7942] = {.lex_state = 105},
  [7943] = {.lex_state = 105},
  [7944] = {.lex_state = 0},
  [7945] = {.lex_state = 105},
  [7946] = {.lex_state = 105},
  [7947] = {.lex_state = 105},
  [7948] = {.lex_state = 104},
  [7949] = {.lex_state = 1},
  [7950] = {.lex_state = 105},
  [7951] = {.lex_state = 105},
  [7952] = {.lex_state = 105},
  [7953] = {.lex_state = 105},
  [7954] = {.lex_state = 105},
  [7955] = {.lex_state = 0},
  [7956] = {.lex_state = 105},
  [7957] = {.lex_state = 105},
  [7958] = {.lex_state = 105},
  [7959] = {.lex_state = 1},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 105},
  [7962] = {.lex_state = 105},
  [7963] = {.lex_state = 105},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 105},
  [7966] = {.lex_state = 1},
  [7967] = {.lex_state = 105},
  [7968] = {.lex_state = 105},
  [7969] = {.lex_state = 105},
  [7970] = {.lex_state = 105},
  [7971] = {.lex_state = 105},
  [7972] = {.lex_state = 105},
  [7973] = {.lex_state = 105},
  [7974] = {.lex_state = 105},
  [7975] = {.lex_state = 105},
  [7976] = {.lex_state = 105},
  [7977] = {.lex_state = 105},
  [7978] = {.lex_state = 105},
  [7979] = {.lex_state = 1},
  [7980] = {.lex_state = 105},
  [7981] = {.lex_state = 105},
  [7982] = {.lex_state = 105},
  [7983] = {.lex_state = 105},
  [7984] = {.lex_state = 105},
  [7985] = {.lex_state = 105},
  [7986] = {.lex_state = 105},
  [7987] = {.lex_state = 105},
  [7988] = {.lex_state = 105},
  [7989] = {.lex_state = 105},
  [7990] = {.lex_state = 105},
  [7991] = {.lex_state = 10},
  [7992] = {.lex_state = 105},
  [7993] = {.lex_state = 0},
  [7994] = {.lex_state = 104},
  [7995] = {.lex_state = 104},
  [7996] = {.lex_state = 105},
  [7997] = {.lex_state = 105},
  [7998] = {.lex_state = 105},
  [7999] = {.lex_state = 105},
  [8000] = {.lex_state = 105},
  [8001] = {.lex_state = 105},
  [8002] = {.lex_state = 105},
  [8003] = {.lex_state = 105},
  [8004] = {.lex_state = 1},
  [8005] = {.lex_state = 105},
  [8006] = {.lex_state = 105},
  [8007] = {.lex_state = 105},
  [8008] = {.lex_state = 105},
  [8009] = {.lex_state = 104},
  [8010] = {.lex_state = 105},
  [8011] = {.lex_state = 105},
  [8012] = {.lex_state = 105},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 105},
  [8015] = {.lex_state = 105},
  [8016] = {.lex_state = 105},
  [8017] = {.lex_state = 105},
  [8018] = {.lex_state = 105},
  [8019] = {.lex_state = 105},
  [8020] = {.lex_state = 1},
  [8021] = {.lex_state = 105},
  [8022] = {.lex_state = 105},
  [8023] = {.lex_state = 105},
  [8024] = {.lex_state = 105},
  [8025] = {.lex_state = 105},
  [8026] = {.lex_state = 105},
  [8027] = {.lex_state = 105},
  [8028] = {.lex_state = 105},
  [8029] = {.lex_state = 105},
  [8030] = {.lex_state = 105},
  [8031] = {.lex_state = 105},
  [8032] = {.lex_state = 105},
  [8033] = {.lex_state = 105},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 105},
  [8036] = {.lex_state = 10},
  [8037] = {.lex_state = 105},
  [8038] = {.lex_state = 105},
  [8039] = {.lex_state = 105},
  [8040] = {.lex_state = 1},
  [8041] = {.lex_state = 105},
  [8042] = {.lex_state = 105},
  [8043] = {.lex_state = 1},
  [8044] = {.lex_state = 105},
  [8045] = {.lex_state = 105},
  [8046] = {.lex_state = 105},
  [8047] = {.lex_state = 1},
  [8048] = {.lex_state = 105},
  [8049] = {.lex_state = 105},
  [8050] = {.lex_state = 105},
  [8051] = {.lex_state = 105},
  [8052] = {.lex_state = 105},
  [8053] = {.lex_state = 105},
  [8054] = {.lex_state = 105},
  [8055] = {.lex_state = 105},
  [8056] = {.lex_state = 105},
  [8057] = {.lex_state = 105},
  [8058] = {.lex_state = 1},
  [8059] = {.lex_state = 105},
  [8060] = {.lex_state = 1},
  [8061] = {.lex_state = 1},
  [8062] = {.lex_state = 105},
  [8063] = {.lex_state = 105},
  [8064] = {.lex_state = 105},
  [8065] = {.lex_state = 105},
  [8066] = {.lex_state = 105},
  [8067] = {.lex_state = 105},
  [8068] = {.lex_state = 1},
  [8069] = {.lex_state = 105},
  [8070] = {.lex_state = 105},
  [8071] = {.lex_state = 105},
  [8072] = {.lex_state = 105},
  [8073] = {.lex_state = 105},
  [8074] = {.lex_state = 105},
  [8075] = {.lex_state = 105},
  [8076] = {.lex_state = 105},
  [8077] = {.lex_state = 105},
  [8078] = {.lex_state = 105},
  [8079] = {.lex_state = 1},
  [8080] = {.lex_state = 105},
  [8081] = {.lex_state = 105},
  [8082] = {.lex_state = 105},
  [8083] = {.lex_state = 105},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 105},
  [8086] = {.lex_state = 105},
  [8087] = {.lex_state = 105},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 105},
  [8091] = {.lex_state = 105},
  [8092] = {.lex_state = 105},
  [8093] = {.lex_state = 1},
  [8094] = {.lex_state = 105},
  [8095] = {.lex_state = 105},
  [8096] = {.lex_state = 104},
  [8097] = {.lex_state = 105},
  [8098] = {.lex_state = 105},
  [8099] = {.lex_state = 105},
  [8100] = {.lex_state = 105},
  [8101] = {.lex_state = 1},
  [8102] = {.lex_state = 105},
  [8103] = {.lex_state = 105},
  [8104] = {.lex_state = 105},
  [8105] = {.lex_state = 1},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 105},
  [8108] = {.lex_state = 105},
  [8109] = {.lex_state = 1},
  [8110] = {.lex_state = 105},
  [8111] = {.lex_state = 105},
  [8112] = {.lex_state = 105},
  [8113] = {.lex_state = 105},
  [8114] = {.lex_state = 105},
  [8115] = {.lex_state = 1},
  [8116] = {.lex_state = 105},
  [8117] = {.lex_state = 104},
  [8118] = {.lex_state = 105},
  [8119] = {.lex_state = 105},
  [8120] = {.lex_state = 105},
  [8121] = {.lex_state = 105},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 105},
  [8124] = {.lex_state = 105},
  [8125] = {.lex_state = 1},
  [8126] = {.lex_state = 105},
  [8127] = {.lex_state = 105},
  [8128] = {.lex_state = 105},
  [8129] = {.lex_state = 105},
  [8130] = {.lex_state = 105},
  [8131] = {.lex_state = 105},
  [8132] = {.lex_state = 105},
  [8133] = {.lex_state = 105},
  [8134] = {.lex_state = 105},
  [8135] = {.lex_state = 105},
  [8136] = {.lex_state = 104},
  [8137] = {.lex_state = 105},
  [8138] = {.lex_state = 105},
  [8139] = {.lex_state = 105},
  [8140] = {.lex_state = 105},
  [8141] = {.lex_state = 105},
  [8142] = {.lex_state = 105},
  [8143] = {.lex_state = 105},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 105},
  [8146] = {.lex_state = 105},
  [8147] = {.lex_state = 1},
  [8148] = {.lex_state = 105},
  [8149] = {.lex_state = 105},
  [8150] = {.lex_state = 105},
  [8151] = {.lex_state = 1},
  [8152] = {.lex_state = 105},
  [8153] = {.lex_state = 0},
  [8154] = {.lex_state = 105},
  [8155] = {.lex_state = 105},
  [8156] = {.lex_state = 105},
  [8157] = {.lex_state = 105},
  [8158] = {.lex_state = 105},
  [8159] = {.lex_state = 105},
  [8160] = {.lex_state = 105},
  [8161] = {.lex_state = 105},
  [8162] = {.lex_state = 105},
  [8163] = {.lex_state = 0},
  [8164] = {.lex_state = 105},
  [8165] = {.lex_state = 0},
  [8166] = {.lex_state = 105},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 105},
  [8169] = {.lex_state = 105},
  [8170] = {.lex_state = 105},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 104},
  [8173] = {.lex_state = 105},
  [8174] = {.lex_state = 105},
  [8175] = {.lex_state = 105},
  [8176] = {.lex_state = 105},
  [8177] = {.lex_state = 1},
  [8178] = {.lex_state = 105},
  [8179] = {.lex_state = 1},
  [8180] = {.lex_state = 105},
  [8181] = {.lex_state = 105},
  [8182] = {.lex_state = 105},
  [8183] = {.lex_state = 105},
  [8184] = {.lex_state = 105},
  [8185] = {.lex_state = 105},
  [8186] = {.lex_state = 105},
  [8187] = {.lex_state = 105},
  [8188] = {.lex_state = 105},
  [8189] = {.lex_state = 105},
  [8190] = {.lex_state = 105},
  [8191] = {.lex_state = 105},
  [8192] = {.lex_state = 105},
  [8193] = {.lex_state = 105},
  [8194] = {.lex_state = 105},
  [8195] = {.lex_state = 105},
  [8196] = {.lex_state = 105},
  [8197] = {.lex_state = 105},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 105},
  [8200] = {.lex_state = 105},
  [8201] = {.lex_state = 105},
  [8202] = {.lex_state = 105},
  [8203] = {.lex_state = 105},
  [8204] = {.lex_state = 105},
  [8205] = {.lex_state = 105},
  [8206] = {.lex_state = 105},
  [8207] = {.lex_state = 105},
  [8208] = {.lex_state = 105},
  [8209] = {.lex_state = 105},
  [8210] = {.lex_state = 105},
  [8211] = {.lex_state = 105},
  [8212] = {.lex_state = 105},
  [8213] = {.lex_state = 105},
  [8214] = {.lex_state = 105},
  [8215] = {.lex_state = 1},
  [8216] = {.lex_state = 105},
  [8217] = {.lex_state = 105},
  [8218] = {.lex_state = 105},
  [8219] = {.lex_state = 105},
  [8220] = {.lex_state = 105},
  [8221] = {.lex_state = 105},
  [8222] = {.lex_state = 105},
  [8223] = {.lex_state = 105},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 105},
  [8226] = {.lex_state = 105},
  [8227] = {.lex_state = 105},
  [8228] = {.lex_state = 105},
  [8229] = {.lex_state = 105},
  [8230] = {.lex_state = 105},
  [8231] = {.lex_state = 105},
  [8232] = {.lex_state = 105},
  [8233] = {.lex_state = 105},
  [8234] = {.lex_state = 105},
  [8235] = {.lex_state = 105},
  [8236] = {.lex_state = 105},
  [8237] = {.lex_state = 105},
  [8238] = {.lex_state = 105},
  [8239] = {.lex_state = 105},
  [8240] = {.lex_state = 105},
  [8241] = {.lex_state = 105},
  [8242] = {.lex_state = 105},
  [8243] = {.lex_state = 105},
  [8244] = {.lex_state = 0},
  [8245] = {.lex_state = 105},
  [8246] = {.lex_state = 105},
  [8247] = {.lex_state = 105},
  [8248] = {.lex_state = 105},
  [8249] = {.lex_state = 105},
  [8250] = {.lex_state = 105},
  [8251] = {.lex_state = 104},
  [8252] = {.lex_state = 105},
  [8253] = {.lex_state = 105},
  [8254] = {.lex_state = 0},
  [8255] = {.lex_state = 105},
  [8256] = {.lex_state = 104},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 105},
  [8260] = {.lex_state = 105},
  [8261] = {.lex_state = 0, .external_lex_state = 5},
  [8262] = {.lex_state = 104},
  [8263] = {.lex_state = 105},
  [8264] = {.lex_state = 105},
  [8265] = {.lex_state = 0},
  [8266] = {.lex_state = 0},
  [8267] = {.lex_state = 105},
  [8268] = {.lex_state = 105},
  [8269] = {.lex_state = 0},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 105},
  [8272] = {.lex_state = 105},
  [8273] = {.lex_state = 105},
  [8274] = {.lex_state = 2},
  [8275] = {.lex_state = 2},
  [8276] = {.lex_state = 0},
  [8277] = {.lex_state = 105},
  [8278] = {.lex_state = 105},
  [8279] = {.lex_state = 105},
  [8280] = {.lex_state = 105},
  [8281] = {.lex_state = 104},
  [8282] = {.lex_state = 104},
  [8283] = {.lex_state = 105},
  [8284] = {.lex_state = 105},
  [8285] = {.lex_state = 105},
  [8286] = {.lex_state = 105},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 105},
  [8289] = {.lex_state = 105},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 105},
  [8292] = {.lex_state = 10},
  [8293] = {.lex_state = 0},
  [8294] = {.lex_state = 105},
  [8295] = {.lex_state = 105},
  [8296] = {.lex_state = 104},
  [8297] = {.lex_state = 105},
  [8298] = {.lex_state = 0},
  [8299] = {.lex_state = 105},
  [8300] = {.lex_state = 104},
  [8301] = {.lex_state = 105},
  [8302] = {.lex_state = 10},
  [8303] = {.lex_state = 105},
  [8304] = {.lex_state = 10},
  [8305] = {.lex_state = 105},
  [8306] = {.lex_state = 10},
  [8307] = {.lex_state = 105},
  [8308] = {.lex_state = 105},
  [8309] = {.lex_state = 10},
  [8310] = {.lex_state = 10},
  [8311] = {.lex_state = 0},
  [8312] = {.lex_state = 105},
  [8313] = {.lex_state = 105},
  [8314] = {.lex_state = 105},
  [8315] = {.lex_state = 0},
  [8316] = {.lex_state = 105},
  [8317] = {.lex_state = 104},
  [8318] = {.lex_state = 0},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 105},
  [8321] = {.lex_state = 105},
  [8322] = {.lex_state = 2},
  [8323] = {.lex_state = 0},
  [8324] = {.lex_state = 105},
  [8325] = {.lex_state = 105},
  [8326] = {.lex_state = 104},
  [8327] = {.lex_state = 105},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 105},
  [8330] = {.lex_state = 0, .external_lex_state = 5},
  [8331] = {.lex_state = 105},
  [8332] = {.lex_state = 105},
  [8333] = {.lex_state = 0},
  [8334] = {.lex_state = 10},
  [8335] = {.lex_state = 0, .external_lex_state = 5},
  [8336] = {.lex_state = 105},
  [8337] = {.lex_state = 105},
  [8338] = {.lex_state = 105},
  [8339] = {.lex_state = 0, .external_lex_state = 5},
  [8340] = {.lex_state = 0},
  [8341] = {.lex_state = 105},
  [8342] = {.lex_state = 0},
  [8343] = {.lex_state = 0},
  [8344] = {.lex_state = 105},
  [8345] = {.lex_state = 105},
  [8346] = {.lex_state = 105},
  [8347] = {.lex_state = 105},
  [8348] = {.lex_state = 105},
  [8349] = {.lex_state = 105},
  [8350] = {.lex_state = 10},
  [8351] = {.lex_state = 105},
  [8352] = {.lex_state = 105},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 104},
  [8355] = {.lex_state = 105},
  [8356] = {.lex_state = 105},
  [8357] = {.lex_state = 105},
  [8358] = {.lex_state = 105},
  [8359] = {.lex_state = 0, .external_lex_state = 5},
  [8360] = {.lex_state = 105},
  [8361] = {.lex_state = 0},
  [8362] = {.lex_state = 105},
  [8363] = {.lex_state = 10},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 0},
  [8366] = {.lex_state = 0},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 0},
  [8369] = {.lex_state = 105},
  [8370] = {.lex_state = 0},
  [8371] = {.lex_state = 105},
  [8372] = {.lex_state = 104},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 105},
  [8375] = {.lex_state = 105},
  [8376] = {.lex_state = 4},
  [8377] = {.lex_state = 10},
  [8378] = {.lex_state = 0},
  [8379] = {.lex_state = 0, .external_lex_state = 5},
  [8380] = {.lex_state = 0},
  [8381] = {.lex_state = 0},
  [8382] = {.lex_state = 10},
  [8383] = {.lex_state = 10},
  [8384] = {.lex_state = 0, .external_lex_state = 6},
  [8385] = {.lex_state = 0},
  [8386] = {.lex_state = 10},
  [8387] = {.lex_state = 10},
  [8388] = {.lex_state = 0, .external_lex_state = 6},
  [8389] = {.lex_state = 0},
  [8390] = {.lex_state = 10},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 105},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 0},
  [8395] = {.lex_state = 10},
  [8396] = {.lex_state = 0},
  [8397] = {.lex_state = 0},
  [8398] = {.lex_state = 0},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 10},
  [8401] = {.lex_state = 0},
  [8402] = {.lex_state = 0},
  [8403] = {.lex_state = 10},
  [8404] = {.lex_state = 0},
  [8405] = {.lex_state = 10},
  [8406] = {.lex_state = 0},
  [8407] = {.lex_state = 0},
  [8408] = {.lex_state = 0},
  [8409] = {.lex_state = 10},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 0},
  [8412] = {.lex_state = 0},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 0},
  [8415] = {.lex_state = 0},
  [8416] = {.lex_state = 0},
  [8417] = {.lex_state = 0},
  [8418] = {.lex_state = 0},
  [8419] = {.lex_state = 0},
  [8420] = {.lex_state = 0},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 10},
  [8423] = {.lex_state = 0},
  [8424] = {.lex_state = 0},
  [8425] = {.lex_state = 0},
  [8426] = {.lex_state = 0},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 10},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 10},
  [8431] = {.lex_state = 0},
  [8432] = {.lex_state = 0},
  [8433] = {.lex_state = 0},
  [8434] = {.lex_state = 0},
  [8435] = {.lex_state = 0},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 0},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 0},
  [8441] = {.lex_state = 0},
  [8442] = {.lex_state = 0},
  [8443] = {.lex_state = 0},
  [8444] = {.lex_state = 0},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 10},
  [8447] = {.lex_state = 0},
  [8448] = {.lex_state = 0},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 0},
  [8452] = {.lex_state = 0},
  [8453] = {.lex_state = 0},
  [8454] = {.lex_state = 0},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 105},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 10},
  [8459] = {.lex_state = 0},
  [8460] = {.lex_state = 0},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 0},
  [8463] = {.lex_state = 0},
  [8464] = {.lex_state = 0},
  [8465] = {.lex_state = 0},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 10},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 0},
  [8470] = {.lex_state = 0},
  [8471] = {.lex_state = 0},
  [8472] = {.lex_state = 0},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 105},
  [8475] = {.lex_state = 0},
  [8476] = {.lex_state = 10},
  [8477] = {.lex_state = 0},
  [8478] = {.lex_state = 0},
  [8479] = {.lex_state = 0},
  [8480] = {.lex_state = 0},
  [8481] = {.lex_state = 0},
  [8482] = {.lex_state = 104, .external_lex_state = 4},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 105},
  [8485] = {.lex_state = 0},
  [8486] = {.lex_state = 0},
  [8487] = {.lex_state = 0},
  [8488] = {.lex_state = 10},
  [8489] = {.lex_state = 0},
  [8490] = {.lex_state = 10},
  [8491] = {.lex_state = 1},
  [8492] = {.lex_state = 10},
  [8493] = {.lex_state = 0},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 0},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 10},
  [8498] = {.lex_state = 0},
  [8499] = {.lex_state = 10},
  [8500] = {.lex_state = 0},
  [8501] = {.lex_state = 10},
  [8502] = {.lex_state = 0},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 0},
  [8505] = {.lex_state = 0},
  [8506] = {.lex_state = 0},
  [8507] = {.lex_state = 0},
  [8508] = {.lex_state = 1},
  [8509] = {.lex_state = 0},
  [8510] = {.lex_state = 0},
  [8511] = {.lex_state = 0},
  [8512] = {.lex_state = 0},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 0},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 0},
  [8520] = {.lex_state = 0},
  [8521] = {.lex_state = 0},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 0},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 0},
  [8526] = {.lex_state = 0},
  [8527] = {.lex_state = 0},
  [8528] = {.lex_state = 0},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 0},
  [8532] = {.lex_state = 0},
  [8533] = {.lex_state = 0},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 1},
  [8537] = {.lex_state = 0},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 0},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 0},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 10},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 0},
  [8548] = {.lex_state = 0},
  [8549] = {.lex_state = 0},
  [8550] = {.lex_state = 10},
  [8551] = {.lex_state = 10},
  [8552] = {.lex_state = 0},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 0},
  [8555] = {.lex_state = 0},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 10},
  [8558] = {.lex_state = 0},
  [8559] = {.lex_state = 0, .external_lex_state = 5},
  [8560] = {.lex_state = 0},
  [8561] = {.lex_state = 0},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 0},
  [8564] = {.lex_state = 0},
  [8565] = {.lex_state = 0},
  [8566] = {.lex_state = 1},
  [8567] = {.lex_state = 10},
  [8568] = {.lex_state = 105},
  [8569] = {.lex_state = 0},
  [8570] = {.lex_state = 0},
  [8571] = {.lex_state = 0},
  [8572] = {.lex_state = 0},
  [8573] = {.lex_state = 0},
  [8574] = {.lex_state = 105},
  [8575] = {.lex_state = 0},
  [8576] = {.lex_state = 10},
  [8577] = {.lex_state = 0},
  [8578] = {.lex_state = 10},
  [8579] = {.lex_state = 0},
  [8580] = {.lex_state = 10},
  [8581] = {.lex_state = 0},
  [8582] = {.lex_state = 0},
  [8583] = {.lex_state = 0},
  [8584] = {.lex_state = 0},
  [8585] = {.lex_state = 0},
  [8586] = {.lex_state = 0},
  [8587] = {.lex_state = 0},
  [8588] = {.lex_state = 0},
  [8589] = {.lex_state = 10},
  [8590] = {.lex_state = 0},
  [8591] = {.lex_state = 0},
  [8592] = {.lex_state = 10},
  [8593] = {.lex_state = 0},
  [8594] = {.lex_state = 0},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0},
  [8597] = {.lex_state = 0},
  [8598] = {.lex_state = 0},
  [8599] = {.lex_state = 0},
  [8600] = {.lex_state = 10},
  [8601] = {.lex_state = 0},
  [8602] = {.lex_state = 0},
  [8603] = {.lex_state = 0},
  [8604] = {.lex_state = 0},
  [8605] = {.lex_state = 10},
  [8606] = {.lex_state = 10},
  [8607] = {.lex_state = 0},
  [8608] = {.lex_state = 0},
  [8609] = {.lex_state = 0},
  [8610] = {.lex_state = 0},
  [8611] = {.lex_state = 0},
  [8612] = {.lex_state = 0},
  [8613] = {.lex_state = 0},
  [8614] = {.lex_state = 0},
  [8615] = {.lex_state = 10},
  [8616] = {.lex_state = 0},
  [8617] = {.lex_state = 0},
  [8618] = {.lex_state = 0},
  [8619] = {.lex_state = 104, .external_lex_state = 4},
  [8620] = {.lex_state = 10},
  [8621] = {.lex_state = 0},
  [8622] = {.lex_state = 0},
  [8623] = {.lex_state = 10},
  [8624] = {.lex_state = 0},
  [8625] = {.lex_state = 0},
  [8626] = {.lex_state = 0},
  [8627] = {.lex_state = 10},
  [8628] = {.lex_state = 0},
  [8629] = {.lex_state = 10},
  [8630] = {.lex_state = 0},
  [8631] = {.lex_state = 0, .external_lex_state = 6},
  [8632] = {.lex_state = 0},
  [8633] = {.lex_state = 0},
  [8634] = {.lex_state = 0, .external_lex_state = 6},
  [8635] = {.lex_state = 0},
  [8636] = {.lex_state = 0},
  [8637] = {.lex_state = 0},
  [8638] = {.lex_state = 0},
  [8639] = {.lex_state = 0},
  [8640] = {.lex_state = 0},
  [8641] = {.lex_state = 0},
  [8642] = {.lex_state = 0},
  [8643] = {.lex_state = 10},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0},
  [8646] = {.lex_state = 0},
  [8647] = {.lex_state = 10},
  [8648] = {.lex_state = 0},
  [8649] = {.lex_state = 0},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 0},
  [8652] = {.lex_state = 0},
  [8653] = {.lex_state = 10},
  [8654] = {.lex_state = 0},
  [8655] = {.lex_state = 0},
  [8656] = {.lex_state = 0},
  [8657] = {.lex_state = 0},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 0},
  [8660] = {.lex_state = 0},
  [8661] = {.lex_state = 0},
  [8662] = {.lex_state = 0},
  [8663] = {.lex_state = 0},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 0},
  [8666] = {.lex_state = 0},
  [8667] = {.lex_state = 0},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 0},
  [8671] = {.lex_state = 4},
  [8672] = {.lex_state = 0},
  [8673] = {.lex_state = 0},
  [8674] = {.lex_state = 0},
  [8675] = {.lex_state = 10},
  [8676] = {.lex_state = 1},
  [8677] = {.lex_state = 0},
  [8678] = {.lex_state = 0, .external_lex_state = 6},
  [8679] = {.lex_state = 0},
  [8680] = {.lex_state = 0},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 0},
  [8683] = {.lex_state = 0},
  [8684] = {.lex_state = 0},
  [8685] = {.lex_state = 0},
  [8686] = {.lex_state = 0},
  [8687] = {.lex_state = 10},
  [8688] = {.lex_state = 0},
  [8689] = {.lex_state = 0},
  [8690] = {.lex_state = 0},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 0},
  [8693] = {.lex_state = 0},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 0},
  [8696] = {.lex_state = 10},
  [8697] = {.lex_state = 0},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 0},
  [8700] = {.lex_state = 0},
  [8701] = {.lex_state = 0},
  [8702] = {.lex_state = 0},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 0},
  [8705] = {.lex_state = 0},
  [8706] = {.lex_state = 0},
  [8707] = {.lex_state = 0},
  [8708] = {.lex_state = 105},
  [8709] = {.lex_state = 0},
  [8710] = {.lex_state = 0},
  [8711] = {.lex_state = 0},
  [8712] = {.lex_state = 0},
  [8713] = {.lex_state = 1},
  [8714] = {.lex_state = 0},
  [8715] = {.lex_state = 0},
  [8716] = {.lex_state = 0},
  [8717] = {.lex_state = 0},
  [8718] = {.lex_state = 10},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 0},
  [8721] = {.lex_state = 0},
  [8722] = {.lex_state = 10},
  [8723] = {.lex_state = 105},
  [8724] = {.lex_state = 0},
  [8725] = {.lex_state = 105},
  [8726] = {.lex_state = 105},
  [8727] = {.lex_state = 0},
  [8728] = {.lex_state = 0},
  [8729] = {.lex_state = 0},
  [8730] = {.lex_state = 0},
  [8731] = {.lex_state = 0},
  [8732] = {.lex_state = 0},
  [8733] = {.lex_state = 0},
  [8734] = {.lex_state = 105},
  [8735] = {.lex_state = 105},
  [8736] = {.lex_state = 0},
  [8737] = {.lex_state = 0},
  [8738] = {.lex_state = 0},
  [8739] = {.lex_state = 1},
  [8740] = {.lex_state = 105},
  [8741] = {.lex_state = 0},
  [8742] = {.lex_state = 0},
  [8743] = {.lex_state = 0},
  [8744] = {.lex_state = 105},
  [8745] = {.lex_state = 0},
  [8746] = {.lex_state = 0},
  [8747] = {.lex_state = 105},
  [8748] = {.lex_state = 0},
  [8749] = {.lex_state = 105},
  [8750] = {.lex_state = 0},
  [8751] = {.lex_state = 0},
  [8752] = {.lex_state = 0},
  [8753] = {.lex_state = 0},
  [8754] = {.lex_state = 0},
  [8755] = {.lex_state = 0},
  [8756] = {.lex_state = 0},
  [8757] = {.lex_state = 0},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 0},
  [8760] = {.lex_state = 0},
  [8761] = {.lex_state = 0},
  [8762] = {.lex_state = 10},
  [8763] = {.lex_state = 10},
  [8764] = {.lex_state = 105},
  [8765] = {.lex_state = 105},
  [8766] = {.lex_state = 10},
  [8767] = {.lex_state = 10},
  [8768] = {.lex_state = 105},
  [8769] = {.lex_state = 105},
  [8770] = {.lex_state = 10},
  [8771] = {.lex_state = 0},
  [8772] = {.lex_state = 0},
  [8773] = {.lex_state = 0},
  [8774] = {.lex_state = 105},
  [8775] = {.lex_state = 0},
  [8776] = {.lex_state = 14},
  [8777] = {.lex_state = 0},
  [8778] = {.lex_state = 0},
  [8779] = {.lex_state = 0},
  [8780] = {.lex_state = 0},
  [8781] = {.lex_state = 0},
  [8782] = {.lex_state = 0},
  [8783] = {.lex_state = 105},
  [8784] = {.lex_state = 3},
  [8785] = {.lex_state = 0},
  [8786] = {.lex_state = 1},
  [8787] = {.lex_state = 0},
  [8788] = {.lex_state = 0},
  [8789] = {.lex_state = 0},
  [8790] = {.lex_state = 0},
  [8791] = {.lex_state = 14},
  [8792] = {.lex_state = 0},
  [8793] = {.lex_state = 0},
  [8794] = {.lex_state = 105},
  [8795] = {.lex_state = 0},
  [8796] = {.lex_state = 0},
  [8797] = {.lex_state = 105},
  [8798] = {.lex_state = 105},
  [8799] = {.lex_state = 0},
  [8800] = {.lex_state = 0},
  [8801] = {.lex_state = 0},
  [8802] = {.lex_state = 0},
  [8803] = {.lex_state = 0},
  [8804] = {.lex_state = 0},
  [8805] = {.lex_state = 105},
  [8806] = {.lex_state = 105},
  [8807] = {.lex_state = 105},
  [8808] = {.lex_state = 0},
  [8809] = {.lex_state = 105},
  [8810] = {.lex_state = 0},
  [8811] = {.lex_state = 105},
  [8812] = {.lex_state = 0},
  [8813] = {.lex_state = 0},
  [8814] = {.lex_state = 0},
  [8815] = {.lex_state = 0},
  [8816] = {.lex_state = 0},
  [8817] = {.lex_state = 0},
  [8818] = {.lex_state = 0},
  [8819] = {.lex_state = 0},
  [8820] = {.lex_state = 0},
  [8821] = {.lex_state = 105},
  [8822] = {.lex_state = 105},
  [8823] = {.lex_state = 105},
  [8824] = {.lex_state = 0},
  [8825] = {.lex_state = 0},
  [8826] = {.lex_state = 105},
  [8827] = {.lex_state = 0},
  [8828] = {.lex_state = 0},
  [8829] = {.lex_state = 105},
  [8830] = {.lex_state = 0},
  [8831] = {.lex_state = 105},
  [8832] = {.lex_state = 105},
  [8833] = {.lex_state = 0},
  [8834] = {.lex_state = 0},
  [8835] = {.lex_state = 105},
  [8836] = {.lex_state = 0},
  [8837] = {.lex_state = 105},
  [8838] = {.lex_state = 105},
  [8839] = {.lex_state = 105},
  [8840] = {.lex_state = 0},
  [8841] = {.lex_state = 0},
  [8842] = {.lex_state = 0},
  [8843] = {.lex_state = 0},
  [8844] = {.lex_state = 0},
  [8845] = {.lex_state = 0},
  [8846] = {.lex_state = 0},
  [8847] = {.lex_state = 0},
  [8848] = {.lex_state = 0},
  [8849] = {.lex_state = 0},
  [8850] = {.lex_state = 0},
  [8851] = {.lex_state = 0},
  [8852] = {.lex_state = 0},
  [8853] = {.lex_state = 0},
  [8854] = {.lex_state = 105},
  [8855] = {.lex_state = 0},
  [8856] = {.lex_state = 0},
  [8857] = {.lex_state = 105},
  [8858] = {.lex_state = 0},
  [8859] = {.lex_state = 0},
  [8860] = {.lex_state = 0},
  [8861] = {.lex_state = 105},
  [8862] = {.lex_state = 105},
  [8863] = {.lex_state = 105},
  [8864] = {.lex_state = 105},
  [8865] = {.lex_state = 105},
  [8866] = {.lex_state = 105},
  [8867] = {.lex_state = 0},
  [8868] = {.lex_state = 0},
  [8869] = {.lex_state = 0},
  [8870] = {.lex_state = 105},
  [8871] = {.lex_state = 0},
  [8872] = {.lex_state = 0},
  [8873] = {.lex_state = 105},
  [8874] = {.lex_state = 105},
  [8875] = {.lex_state = 0},
  [8876] = {.lex_state = 0},
  [8877] = {.lex_state = 0},
  [8878] = {.lex_state = 0},
  [8879] = {.lex_state = 105},
  [8880] = {.lex_state = 0},
  [8881] = {.lex_state = 0},
  [8882] = {.lex_state = 105},
  [8883] = {.lex_state = 0},
  [8884] = {.lex_state = 0},
  [8885] = {.lex_state = 0},
  [8886] = {.lex_state = 0},
  [8887] = {.lex_state = 0},
  [8888] = {.lex_state = 105},
  [8889] = {.lex_state = 0},
  [8890] = {.lex_state = 0},
  [8891] = {.lex_state = 0},
  [8892] = {.lex_state = 0},
  [8893] = {.lex_state = 105},
  [8894] = {.lex_state = 105},
  [8895] = {.lex_state = 105},
  [8896] = {.lex_state = 0},
  [8897] = {.lex_state = 0},
  [8898] = {.lex_state = 0},
  [8899] = {.lex_state = 0},
  [8900] = {.lex_state = 0},
  [8901] = {.lex_state = 105},
  [8902] = {.lex_state = 0},
  [8903] = {.lex_state = 105},
  [8904] = {.lex_state = 0},
  [8905] = {.lex_state = 0},
  [8906] = {.lex_state = 0},
  [8907] = {.lex_state = 14},
  [8908] = {.lex_state = 0},
  [8909] = {.lex_state = 0},
  [8910] = {.lex_state = 0},
  [8911] = {.lex_state = 0},
  [8912] = {.lex_state = 10},
  [8913] = {.lex_state = 105},
  [8914] = {.lex_state = 14},
  [8915] = {.lex_state = 0},
  [8916] = {.lex_state = 0},
  [8917] = {.lex_state = 0},
  [8918] = {.lex_state = 0},
  [8919] = {.lex_state = 0},
  [8920] = {.lex_state = 14},
  [8921] = {.lex_state = 0},
  [8922] = {.lex_state = 0},
  [8923] = {.lex_state = 0},
  [8924] = {.lex_state = 0},
  [8925] = {.lex_state = 105},
  [8926] = {.lex_state = 105},
  [8927] = {.lex_state = 0},
  [8928] = {.lex_state = 0},
  [8929] = {.lex_state = 0},
  [8930] = {.lex_state = 105},
  [8931] = {.lex_state = 0},
  [8932] = {.lex_state = 0},
  [8933] = {.lex_state = 105},
  [8934] = {.lex_state = 0},
  [8935] = {.lex_state = 105},
  [8936] = {.lex_state = 0},
  [8937] = {.lex_state = 0},
  [8938] = {.lex_state = 0},
  [8939] = {.lex_state = 105},
  [8940] = {.lex_state = 0},
  [8941] = {.lex_state = 105},
  [8942] = {.lex_state = 105},
  [8943] = {.lex_state = 105},
  [8944] = {.lex_state = 105},
  [8945] = {.lex_state = 0},
  [8946] = {.lex_state = 105},
  [8947] = {.lex_state = 0},
  [8948] = {.lex_state = 0},
  [8949] = {.lex_state = 105},
  [8950] = {.lex_state = 0},
  [8951] = {.lex_state = 0},
  [8952] = {.lex_state = 105},
  [8953] = {.lex_state = 0},
  [8954] = {.lex_state = 105},
  [8955] = {.lex_state = 105},
  [8956] = {.lex_state = 105},
  [8957] = {.lex_state = 105},
  [8958] = {.lex_state = 105},
  [8959] = {.lex_state = 105},
  [8960] = {.lex_state = 0},
  [8961] = {.lex_state = 0},
  [8962] = {.lex_state = 105},
  [8963] = {.lex_state = 105},
  [8964] = {.lex_state = 0},
  [8965] = {.lex_state = 105},
  [8966] = {.lex_state = 105},
  [8967] = {.lex_state = 0},
  [8968] = {.lex_state = 0},
  [8969] = {.lex_state = 105},
  [8970] = {.lex_state = 105},
  [8971] = {.lex_state = 105},
  [8972] = {.lex_state = 10},
  [8973] = {.lex_state = 10},
  [8974] = {.lex_state = 105},
  [8975] = {.lex_state = 0},
  [8976] = {.lex_state = 0},
  [8977] = {.lex_state = 105},
  [8978] = {.lex_state = 0},
  [8979] = {.lex_state = 105},
  [8980] = {.lex_state = 105},
  [8981] = {.lex_state = 0},
  [8982] = {.lex_state = 0},
  [8983] = {.lex_state = 14},
  [8984] = {.lex_state = 105},
  [8985] = {.lex_state = 0},
  [8986] = {.lex_state = 0},
  [8987] = {.lex_state = 0},
  [8988] = {.lex_state = 0},
  [8989] = {.lex_state = 3},
  [8990] = {.lex_state = 105},
  [8991] = {.lex_state = 105},
  [8992] = {.lex_state = 0},
  [8993] = {.lex_state = 0, .external_lex_state = 7},
  [8994] = {.lex_state = 0},
  [8995] = {.lex_state = 0, .external_lex_state = 7},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 0, .external_lex_state = 7},
  [8998] = {.lex_state = 0},
  [8999] = {.lex_state = 0},
  [9000] = {.lex_state = 0, .external_lex_state = 7},
  [9001] = {.lex_state = 0},
  [9002] = {.lex_state = 0},
  [9003] = {.lex_state = 0, .external_lex_state = 7},
  [9004] = {.lex_state = 0},
  [9005] = {.lex_state = 0},
  [9006] = {.lex_state = 0},
  [9007] = {.lex_state = 0, .external_lex_state = 7},
  [9008] = {.lex_state = 104},
  [9009] = {.lex_state = 0},
  [9010] = {.lex_state = 0},
  [9011] = {.lex_state = 0},
  [9012] = {.lex_state = 0, .external_lex_state = 7},
  [9013] = {.lex_state = 0, .external_lex_state = 7},
  [9014] = {.lex_state = 0},
  [9015] = {.lex_state = 0},
  [9016] = {.lex_state = 0},
  [9017] = {.lex_state = 0},
  [9018] = {.lex_state = 0},
  [9019] = {.lex_state = 0},
  [9020] = {.lex_state = 0, .external_lex_state = 7},
  [9021] = {.lex_state = 0},
  [9022] = {.lex_state = 0, .external_lex_state = 7},
  [9023] = {.lex_state = 0},
  [9024] = {.lex_state = 10},
  [9025] = {.lex_state = 0},
  [9026] = {.lex_state = 0, .external_lex_state = 7},
  [9027] = {.lex_state = 0},
  [9028] = {.lex_state = 0},
  [9029] = {.lex_state = 0},
  [9030] = {.lex_state = 0},
  [9031] = {.lex_state = 0},
  [9032] = {.lex_state = 0},
  [9033] = {.lex_state = 0},
  [9034] = {.lex_state = 0},
  [9035] = {.lex_state = 0},
  [9036] = {.lex_state = 0},
  [9037] = {.lex_state = 0},
  [9038] = {.lex_state = 0},
  [9039] = {.lex_state = 0},
  [9040] = {.lex_state = 10},
  [9041] = {.lex_state = 0},
  [9042] = {.lex_state = 0},
  [9043] = {.lex_state = 0},
  [9044] = {.lex_state = 0},
  [9045] = {.lex_state = 0},
  [9046] = {.lex_state = 0, .external_lex_state = 7},
  [9047] = {.lex_state = 0},
  [9048] = {.lex_state = 0},
  [9049] = {.lex_state = 0, .external_lex_state = 7},
  [9050] = {.lex_state = 0},
  [9051] = {.lex_state = 0},
  [9052] = {.lex_state = 0, .external_lex_state = 7},
  [9053] = {.lex_state = 0},
  [9054] = {.lex_state = 0},
  [9055] = {.lex_state = 0, .external_lex_state = 7},
  [9056] = {.lex_state = 0},
  [9057] = {.lex_state = 0},
  [9058] = {.lex_state = 0},
  [9059] = {.lex_state = 0},
  [9060] = {.lex_state = 0, .external_lex_state = 7},
  [9061] = {.lex_state = 0},
  [9062] = {.lex_state = 0},
  [9063] = {.lex_state = 0, .external_lex_state = 7},
  [9064] = {.lex_state = 0},
  [9065] = {.lex_state = 0},
  [9066] = {.lex_state = 0},
  [9067] = {.lex_state = 0, .external_lex_state = 8},
  [9068] = {.lex_state = 0, .external_lex_state = 9},
  [9069] = {.lex_state = 10},
  [9070] = {.lex_state = 0, .external_lex_state = 7},
  [9071] = {.lex_state = 0, .external_lex_state = 7},
  [9072] = {.lex_state = 0},
  [9073] = {.lex_state = 0},
  [9074] = {.lex_state = 0},
  [9075] = {.lex_state = 0},
  [9076] = {.lex_state = 0},
  [9077] = {.lex_state = 10},
  [9078] = {.lex_state = 0, .external_lex_state = 7},
  [9079] = {.lex_state = 0},
  [9080] = {.lex_state = 0},
  [9081] = {.lex_state = 105},
  [9082] = {.lex_state = 0, .external_lex_state = 7},
  [9083] = {.lex_state = 0},
  [9084] = {.lex_state = 0},
  [9085] = {.lex_state = 0},
  [9086] = {.lex_state = 0},
  [9087] = {.lex_state = 0},
  [9088] = {.lex_state = 0, .external_lex_state = 10},
  [9089] = {.lex_state = 0},
  [9090] = {.lex_state = 10},
  [9091] = {.lex_state = 0},
  [9092] = {.lex_state = 0},
  [9093] = {.lex_state = 0},
  [9094] = {.lex_state = 0, .external_lex_state = 7},
  [9095] = {.lex_state = 0, .external_lex_state = 7},
  [9096] = {.lex_state = 0},
  [9097] = {.lex_state = 0, .external_lex_state = 7},
  [9098] = {.lex_state = 0},
  [9099] = {.lex_state = 0, .external_lex_state = 7},
  [9100] = {.lex_state = 0},
  [9101] = {.lex_state = 0},
  [9102] = {.lex_state = 0},
  [9103] = {.lex_state = 0},
  [9104] = {.lex_state = 0},
  [9105] = {.lex_state = 0},
  [9106] = {.lex_state = 105},
  [9107] = {.lex_state = 0},
  [9108] = {.lex_state = 0},
  [9109] = {.lex_state = 0, .external_lex_state = 7},
  [9110] = {.lex_state = 0},
  [9111] = {.lex_state = 0},
  [9112] = {.lex_state = 0},
  [9113] = {.lex_state = 0, .external_lex_state = 7},
  [9114] = {.lex_state = 0},
  [9115] = {.lex_state = 0},
  [9116] = {.lex_state = 105},
  [9117] = {.lex_state = 0},
  [9118] = {.lex_state = 0},
  [9119] = {.lex_state = 0},
  [9120] = {.lex_state = 0},
  [9121] = {.lex_state = 0, .external_lex_state = 7},
  [9122] = {.lex_state = 0},
  [9123] = {.lex_state = 0},
  [9124] = {.lex_state = 0},
  [9125] = {.lex_state = 0},
  [9126] = {.lex_state = 0},
  [9127] = {.lex_state = 0},
  [9128] = {.lex_state = 0},
  [9129] = {.lex_state = 0, .external_lex_state = 7},
  [9130] = {.lex_state = 0},
  [9131] = {.lex_state = 0},
  [9132] = {.lex_state = 0},
  [9133] = {.lex_state = 0},
  [9134] = {.lex_state = 0},
  [9135] = {.lex_state = 0},
  [9136] = {.lex_state = 0},
  [9137] = {.lex_state = 0},
  [9138] = {.lex_state = 0},
  [9139] = {.lex_state = 0},
  [9140] = {.lex_state = 0},
  [9141] = {.lex_state = 0},
  [9142] = {.lex_state = 0, .external_lex_state = 7},
  [9143] = {.lex_state = 0},
  [9144] = {.lex_state = 0},
  [9145] = {.lex_state = 0},
  [9146] = {.lex_state = 0},
  [9147] = {.lex_state = 0},
  [9148] = {.lex_state = 10},
  [9149] = {.lex_state = 0},
  [9150] = {.lex_state = 4},
  [9151] = {.lex_state = 0},
  [9152] = {.lex_state = 0},
  [9153] = {.lex_state = 0},
  [9154] = {.lex_state = 0},
  [9155] = {.lex_state = 0},
  [9156] = {.lex_state = 0},
  [9157] = {.lex_state = 0},
  [9158] = {.lex_state = 0},
  [9159] = {.lex_state = 0},
  [9160] = {.lex_state = 0},
  [9161] = {.lex_state = 0},
  [9162] = {.lex_state = 0, .external_lex_state = 7},
  [9163] = {.lex_state = 0},
  [9164] = {.lex_state = 0},
  [9165] = {.lex_state = 0},
  [9166] = {.lex_state = 0},
  [9167] = {.lex_state = 0},
  [9168] = {.lex_state = 104},
  [9169] = {.lex_state = 0},
  [9170] = {.lex_state = 0},
  [9171] = {.lex_state = 4},
  [9172] = {.lex_state = 0},
  [9173] = {.lex_state = 0},
  [9174] = {.lex_state = 0},
  [9175] = {.lex_state = 0},
  [9176] = {.lex_state = 0},
  [9177] = {.lex_state = 0},
  [9178] = {.lex_state = 0},
  [9179] = {.lex_state = 0},
  [9180] = {.lex_state = 0},
  [9181] = {.lex_state = 0},
  [9182] = {.lex_state = 0},
  [9183] = {.lex_state = 0},
  [9184] = {.lex_state = 0},
  [9185] = {.lex_state = 105},
  [9186] = {.lex_state = 4},
  [9187] = {.lex_state = 0},
  [9188] = {.lex_state = 0, .external_lex_state = 7},
  [9189] = {.lex_state = 0},
  [9190] = {.lex_state = 0},
  [9191] = {.lex_state = 0},
  [9192] = {.lex_state = 0, .external_lex_state = 7},
  [9193] = {.lex_state = 0, .external_lex_state = 7},
  [9194] = {.lex_state = 0},
  [9195] = {.lex_state = 0, .external_lex_state = 7},
  [9196] = {.lex_state = 0},
  [9197] = {.lex_state = 0},
  [9198] = {.lex_state = 10},
  [9199] = {.lex_state = 0},
  [9200] = {.lex_state = 0},
  [9201] = {.lex_state = 0},
  [9202] = {.lex_state = 0},
  [9203] = {.lex_state = 0},
  [9204] = {.lex_state = 0, .external_lex_state = 4},
  [9205] = {.lex_state = 0, .external_lex_state = 8},
  [9206] = {.lex_state = 0, .external_lex_state = 10},
  [9207] = {.lex_state = 0, .external_lex_state = 9},
  [9208] = {.lex_state = 0, .external_lex_state = 7},
  [9209] = {.lex_state = 0},
  [9210] = {.lex_state = 0},
  [9211] = {.lex_state = 0},
  [9212] = {.lex_state = 105},
  [9213] = {.lex_state = 0},
  [9214] = {.lex_state = 10},
  [9215] = {.lex_state = 0},
  [9216] = {.lex_state = 0},
  [9217] = {.lex_state = 0},
  [9218] = {.lex_state = 0},
  [9219] = {.lex_state = 0},
  [9220] = {.lex_state = 0},
  [9221] = {.lex_state = 0},
  [9222] = {.lex_state = 0},
  [9223] = {.lex_state = 0, .external_lex_state = 7},
  [9224] = {.lex_state = 0, .external_lex_state = 7},
  [9225] = {.lex_state = 0},
  [9226] = {.lex_state = 0, .external_lex_state = 7},
  [9227] = {.lex_state = 0, .external_lex_state = 7},
  [9228] = {.lex_state = 0},
  [9229] = {.lex_state = 0, .external_lex_state = 7},
  [9230] = {.lex_state = 10},
  [9231] = {.lex_state = 0},
  [9232] = {.lex_state = 0},
  [9233] = {.lex_state = 0, .external_lex_state = 7},
  [9234] = {.lex_state = 0, .external_lex_state = 7},
  [9235] = {.lex_state = 0, .external_lex_state = 7},
  [9236] = {.lex_state = 0},
  [9237] = {.lex_state = 0, .external_lex_state = 7},
  [9238] = {.lex_state = 0},
  [9239] = {.lex_state = 0},
  [9240] = {.lex_state = 0},
  [9241] = {.lex_state = 0},
  [9242] = {.lex_state = 0},
  [9243] = {.lex_state = 0},
  [9244] = {.lex_state = 0},
  [9245] = {.lex_state = 0},
  [9246] = {.lex_state = 105},
  [9247] = {.lex_state = 0},
  [9248] = {.lex_state = 0},
  [9249] = {.lex_state = 0},
  [9250] = {.lex_state = 0},
  [9251] = {.lex_state = 0, .external_lex_state = 7},
  [9252] = {.lex_state = 0, .external_lex_state = 7},
  [9253] = {.lex_state = 0, .external_lex_state = 7},
  [9254] = {.lex_state = 0, .external_lex_state = 7},
  [9255] = {.lex_state = 0},
  [9256] = {.lex_state = 0, .external_lex_state = 7},
  [9257] = {.lex_state = 0},
  [9258] = {.lex_state = 0, .external_lex_state = 7},
  [9259] = {.lex_state = 0, .external_lex_state = 7},
  [9260] = {.lex_state = 0, .external_lex_state = 7},
  [9261] = {.lex_state = 0, .external_lex_state = 7},
  [9262] = {.lex_state = 0, .external_lex_state = 7},
  [9263] = {.lex_state = 0},
  [9264] = {.lex_state = 0, .external_lex_state = 4},
  [9265] = {.lex_state = 0},
  [9266] = {.lex_state = 0},
  [9267] = {.lex_state = 0},
  [9268] = {.lex_state = 0, .external_lex_state = 7},
  [9269] = {.lex_state = 0, .external_lex_state = 7},
  [9270] = {.lex_state = 0, .external_lex_state = 7},
  [9271] = {.lex_state = 0, .external_lex_state = 7},
  [9272] = {.lex_state = 10},
  [9273] = {.lex_state = 0},
  [9274] = {.lex_state = 0, .external_lex_state = 7},
  [9275] = {.lex_state = 0, .external_lex_state = 7},
  [9276] = {.lex_state = 0, .external_lex_state = 7},
  [9277] = {.lex_state = 0, .external_lex_state = 7},
  [9278] = {.lex_state = 0},
  [9279] = {.lex_state = 0, .external_lex_state = 7},
  [9280] = {.lex_state = 0},
  [9281] = {.lex_state = 0, .external_lex_state = 7},
  [9282] = {.lex_state = 0, .external_lex_state = 7},
  [9283] = {.lex_state = 0, .external_lex_state = 7},
  [9284] = {.lex_state = 0, .external_lex_state = 7},
  [9285] = {.lex_state = 0},
  [9286] = {.lex_state = 0, .external_lex_state = 7},
  [9287] = {.lex_state = 0, .external_lex_state = 7},
  [9288] = {.lex_state = 0, .external_lex_state = 7},
  [9289] = {.lex_state = 0, .external_lex_state = 7},
  [9290] = {.lex_state = 0, .external_lex_state = 7},
  [9291] = {.lex_state = 0, .external_lex_state = 7},
  [9292] = {.lex_state = 0, .external_lex_state = 7},
  [9293] = {.lex_state = 0},
  [9294] = {.lex_state = 0, .external_lex_state = 7},
  [9295] = {.lex_state = 0, .external_lex_state = 7},
  [9296] = {.lex_state = 0, .external_lex_state = 7},
  [9297] = {.lex_state = 0, .external_lex_state = 7},
  [9298] = {.lex_state = 0, .external_lex_state = 7},
  [9299] = {.lex_state = 0, .external_lex_state = 7},
  [9300] = {.lex_state = 0, .external_lex_state = 7},
  [9301] = {.lex_state = 0},
  [9302] = {.lex_state = 0, .external_lex_state = 7},
  [9303] = {.lex_state = 0, .external_lex_state = 7},
  [9304] = {.lex_state = 0},
  [9305] = {.lex_state = 0},
  [9306] = {.lex_state = 0},
  [9307] = {.lex_state = 0, .external_lex_state = 7},
  [9308] = {.lex_state = 0},
  [9309] = {.lex_state = 0, .external_lex_state = 7},
  [9310] = {.lex_state = 0},
  [9311] = {.lex_state = 0, .external_lex_state = 7},
  [9312] = {.lex_state = 0, .external_lex_state = 7},
  [9313] = {.lex_state = 0},
  [9314] = {.lex_state = 0},
  [9315] = {.lex_state = 0},
  [9316] = {.lex_state = 0, .external_lex_state = 7},
  [9317] = {.lex_state = 0, .external_lex_state = 7},
  [9318] = {.lex_state = 0, .external_lex_state = 7},
  [9319] = {.lex_state = 0, .external_lex_state = 7},
  [9320] = {.lex_state = 0, .external_lex_state = 7},
  [9321] = {.lex_state = 0, .external_lex_state = 7},
  [9322] = {.lex_state = 0},
  [9323] = {.lex_state = 0},
  [9324] = {.lex_state = 0},
  [9325] = {.lex_state = 0, .external_lex_state = 7},
  [9326] = {.lex_state = 0, .external_lex_state = 7},
  [9327] = {.lex_state = 0, .external_lex_state = 7},
  [9328] = {.lex_state = 0, .external_lex_state = 7},
  [9329] = {.lex_state = 0, .external_lex_state = 7},
  [9330] = {.lex_state = 0},
  [9331] = {.lex_state = 0},
  [9332] = {.lex_state = 0},
  [9333] = {.lex_state = 0},
  [9334] = {.lex_state = 0, .external_lex_state = 7},
  [9335] = {.lex_state = 0, .external_lex_state = 7},
  [9336] = {.lex_state = 0, .external_lex_state = 7},
  [9337] = {.lex_state = 0, .external_lex_state = 7},
  [9338] = {.lex_state = 0, .external_lex_state = 7},
  [9339] = {.lex_state = 0},
  [9340] = {.lex_state = 0, .external_lex_state = 7},
  [9341] = {.lex_state = 0, .external_lex_state = 7},
  [9342] = {.lex_state = 0},
  [9343] = {.lex_state = 0},
  [9344] = {.lex_state = 10},
  [9345] = {.lex_state = 0},
  [9346] = {.lex_state = 0},
  [9347] = {.lex_state = 105},
  [9348] = {.lex_state = 0, .external_lex_state = 7},
  [9349] = {.lex_state = 0},
  [9350] = {.lex_state = 0, .external_lex_state = 7},
  [9351] = {.lex_state = 0, .external_lex_state = 7},
  [9352] = {.lex_state = 0, .external_lex_state = 7},
  [9353] = {.lex_state = 0, .external_lex_state = 7},
  [9354] = {.lex_state = 0, .external_lex_state = 7},
  [9355] = {.lex_state = 0, .external_lex_state = 7},
  [9356] = {.lex_state = 0, .external_lex_state = 7},
  [9357] = {.lex_state = 0, .external_lex_state = 7},
  [9358] = {.lex_state = 0},
  [9359] = {.lex_state = 0, .external_lex_state = 7},
  [9360] = {.lex_state = 0, .external_lex_state = 7},
  [9361] = {.lex_state = 0, .external_lex_state = 7},
  [9362] = {.lex_state = 0},
  [9363] = {.lex_state = 0},
  [9364] = {.lex_state = 0},
  [9365] = {.lex_state = 0, .external_lex_state = 7},
  [9366] = {.lex_state = 0, .external_lex_state = 7},
  [9367] = {.lex_state = 0},
  [9368] = {.lex_state = 0},
  [9369] = {.lex_state = 0},
  [9370] = {.lex_state = 0},
  [9371] = {.lex_state = 0},
  [9372] = {.lex_state = 0},
  [9373] = {.lex_state = 0},
  [9374] = {.lex_state = 0},
  [9375] = {.lex_state = 105},
  [9376] = {.lex_state = 0, .external_lex_state = 7},
  [9377] = {.lex_state = 0},
  [9378] = {.lex_state = 0},
  [9379] = {.lex_state = 0},
  [9380] = {.lex_state = 0},
  [9381] = {.lex_state = 0},
  [9382] = {.lex_state = 0},
  [9383] = {.lex_state = 0},
  [9384] = {.lex_state = 0},
  [9385] = {.lex_state = 0},
  [9386] = {.lex_state = 0},
  [9387] = {.lex_state = 0},
  [9388] = {.lex_state = 10},
  [9389] = {.lex_state = 0},
  [9390] = {.lex_state = 0},
  [9391] = {.lex_state = 0},
  [9392] = {.lex_state = 0, .external_lex_state = 9},
  [9393] = {.lex_state = 0},
  [9394] = {.lex_state = 0},
  [9395] = {.lex_state = 0},
  [9396] = {.lex_state = 0, .external_lex_state = 7},
  [9397] = {.lex_state = 0},
  [9398] = {.lex_state = 0},
  [9399] = {.lex_state = 0},
  [9400] = {.lex_state = 0},
  [9401] = {.lex_state = 0, .external_lex_state = 7},
  [9402] = {.lex_state = 0},
  [9403] = {.lex_state = 0},
  [9404] = {.lex_state = 0},
  [9405] = {.lex_state = 0},
  [9406] = {.lex_state = 0},
  [9407] = {.lex_state = 0, .external_lex_state = 7},
  [9408] = {.lex_state = 0},
  [9409] = {.lex_state = 0, .external_lex_state = 7},
  [9410] = {.lex_state = 0},
  [9411] = {.lex_state = 0},
  [9412] = {.lex_state = 0},
  [9413] = {.lex_state = 0},
  [9414] = {.lex_state = 0},
  [9415] = {.lex_state = 0},
  [9416] = {.lex_state = 0},
  [9417] = {.lex_state = 0, .external_lex_state = 7},
  [9418] = {.lex_state = 0},
  [9419] = {.lex_state = 0},
  [9420] = {.lex_state = 0},
  [9421] = {.lex_state = 0},
  [9422] = {.lex_state = 0},
  [9423] = {.lex_state = 0},
  [9424] = {.lex_state = 0},
  [9425] = {.lex_state = 0},
  [9426] = {.lex_state = 0, .external_lex_state = 7},
  [9427] = {.lex_state = 0},
  [9428] = {.lex_state = 0, .external_lex_state = 7},
  [9429] = {.lex_state = 0},
  [9430] = {.lex_state = 0},
  [9431] = {.lex_state = 0},
  [9432] = {.lex_state = 10},
  [9433] = {.lex_state = 0},
  [9434] = {.lex_state = 0, .external_lex_state = 7},
  [9435] = {.lex_state = 0},
  [9436] = {.lex_state = 0},
  [9437] = {.lex_state = 0},
  [9438] = {.lex_state = 0},
  [9439] = {.lex_state = 0, .external_lex_state = 7},
  [9440] = {.lex_state = 0},
  [9441] = {.lex_state = 0, .external_lex_state = 7},
  [9442] = {.lex_state = 0},
  [9443] = {.lex_state = 0, .external_lex_state = 7},
  [9444] = {.lex_state = 0},
  [9445] = {.lex_state = 0},
  [9446] = {.lex_state = 0},
  [9447] = {.lex_state = 0, .external_lex_state = 7},
  [9448] = {.lex_state = 0},
  [9449] = {.lex_state = 0},
  [9450] = {.lex_state = 0},
  [9451] = {.lex_state = 0},
  [9452] = {.lex_state = 0},
  [9453] = {.lex_state = 0},
  [9454] = {.lex_state = 0},
  [9455] = {.lex_state = 0},
  [9456] = {.lex_state = 0},
  [9457] = {.lex_state = 0},
  [9458] = {.lex_state = 0},
  [9459] = {.lex_state = 0},
  [9460] = {.lex_state = 0},
  [9461] = {.lex_state = 0},
  [9462] = {.lex_state = 0},
  [9463] = {.lex_state = 0},
  [9464] = {.lex_state = 0},
  [9465] = {.lex_state = 0},
  [9466] = {.lex_state = 0},
  [9467] = {.lex_state = 0},
  [9468] = {.lex_state = 0},
  [9469] = {.lex_state = 104},
  [9470] = {.lex_state = 0, .external_lex_state = 7},
  [9471] = {.lex_state = 0},
  [9472] = {.lex_state = 0},
  [9473] = {.lex_state = 1},
  [9474] = {.lex_state = 0},
  [9475] = {.lex_state = 16},
  [9476] = {.lex_state = 0, .external_lex_state = 4},
  [9477] = {.lex_state = 0},
  [9478] = {.lex_state = 0},
  [9479] = {.lex_state = 0},
  [9480] = {.lex_state = 10},
  [9481] = {.lex_state = 0},
  [9482] = {.lex_state = 0},
  [9483] = {.lex_state = 0},
  [9484] = {.lex_state = 0, .external_lex_state = 8},
  [9485] = {.lex_state = 0},
  [9486] = {.lex_state = 0},
  [9487] = {.lex_state = 0},
  [9488] = {.lex_state = 0},
  [9489] = {.lex_state = 0},
  [9490] = {.lex_state = 0},
  [9491] = {.lex_state = 0},
  [9492] = {.lex_state = 0},
  [9493] = {.lex_state = 0},
  [9494] = {.lex_state = 0, .external_lex_state = 7},
  [9495] = {.lex_state = 0, .external_lex_state = 7},
  [9496] = {.lex_state = 0},
  [9497] = {.lex_state = 0},
  [9498] = {.lex_state = 0},
  [9499] = {.lex_state = 0},
  [9500] = {.lex_state = 0},
  [9501] = {.lex_state = 0},
  [9502] = {.lex_state = 0},
  [9503] = {.lex_state = 0},
  [9504] = {.lex_state = 0},
  [9505] = {.lex_state = 0},
  [9506] = {.lex_state = 10},
  [9507] = {.lex_state = 0},
  [9508] = {.lex_state = 0},
  [9509] = {.lex_state = 0},
  [9510] = {.lex_state = 0},
  [9511] = {.lex_state = 0, .external_lex_state = 7},
  [9512] = {.lex_state = 0, .external_lex_state = 7},
  [9513] = {.lex_state = 0},
  [9514] = {.lex_state = 0},
  [9515] = {.lex_state = 0},
  [9516] = {.lex_state = 0},
  [9517] = {.lex_state = 0},
  [9518] = {.lex_state = 0},
  [9519] = {.lex_state = 0},
  [9520] = {.lex_state = 0},
  [9521] = {.lex_state = 0},
  [9522] = {.lex_state = 0},
  [9523] = {.lex_state = 0},
  [9524] = {.lex_state = 105},
  [9525] = {.lex_state = 0},
  [9526] = {.lex_state = 0},
  [9527] = {.lex_state = 0},
  [9528] = {.lex_state = 0},
  [9529] = {.lex_state = 0},
  [9530] = {.lex_state = 0, .external_lex_state = 10},
  [9531] = {.lex_state = 0},
  [9532] = {.lex_state = 0},
  [9533] = {.lex_state = 0},
  [9534] = {.lex_state = 0},
  [9535] = {.lex_state = 0},
  [9536] = {.lex_state = 10},
  [9537] = {.lex_state = 0},
  [9538] = {.lex_state = 0, .external_lex_state = 7},
  [9539] = {.lex_state = 0},
  [9540] = {.lex_state = 0},
  [9541] = {.lex_state = 0},
  [9542] = {.lex_state = 0},
  [9543] = {.lex_state = 105},
  [9544] = {.lex_state = 0},
  [9545] = {.lex_state = 0},
  [9546] = {.lex_state = 0, .external_lex_state = 7},
  [9547] = {.lex_state = 0},
  [9548] = {.lex_state = 0},
  [9549] = {.lex_state = 0},
  [9550] = {.lex_state = 0},
  [9551] = {.lex_state = 0},
  [9552] = {.lex_state = 0},
  [9553] = {.lex_state = 105},
  [9554] = {.lex_state = 105},
  [9555] = {.lex_state = 0},
  [9556] = {.lex_state = 0},
  [9557] = {.lex_state = 0, .external_lex_state = 7},
  [9558] = {.lex_state = 0},
  [9559] = {.lex_state = 0, .external_lex_state = 7},
  [9560] = {.lex_state = 0},
  [9561] = {.lex_state = 0, .external_lex_state = 7},
  [9562] = {.lex_state = 0},
  [9563] = {.lex_state = 0},
  [9564] = {.lex_state = 0},
  [9565] = {.lex_state = 0},
  [9566] = {.lex_state = 0},
  [9567] = {.lex_state = 0},
  [9568] = {.lex_state = 0, .external_lex_state = 10},
  [9569] = {.lex_state = 0},
  [9570] = {.lex_state = 0},
  [9571] = {.lex_state = 105},
  [9572] = {.lex_state = 0},
  [9573] = {.lex_state = 0},
  [9574] = {.lex_state = 0, .external_lex_state = 7},
  [9575] = {.lex_state = 0},
  [9576] = {.lex_state = 0},
  [9577] = {.lex_state = 0},
  [9578] = {.lex_state = 0},
  [9579] = {.lex_state = 0},
  [9580] = {.lex_state = 0},
  [9581] = {.lex_state = 105},
  [9582] = {.lex_state = 0, .external_lex_state = 7},
  [9583] = {.lex_state = 0},
  [9584] = {.lex_state = 0},
  [9585] = {.lex_state = 0},
  [9586] = {.lex_state = 0},
  [9587] = {.lex_state = 0, .external_lex_state = 7},
  [9588] = {.lex_state = 0, .external_lex_state = 7},
  [9589] = {.lex_state = 0, .external_lex_state = 7},
  [9590] = {.lex_state = 0},
  [9591] = {.lex_state = 0, .external_lex_state = 7},
  [9592] = {.lex_state = 0, .external_lex_state = 7},
  [9593] = {.lex_state = 0},
  [9594] = {.lex_state = 0},
  [9595] = {.lex_state = 0},
  [9596] = {.lex_state = 0},
  [9597] = {.lex_state = 105},
  [9598] = {.lex_state = 10},
  [9599] = {.lex_state = 1},
  [9600] = {.lex_state = 0},
  [9601] = {.lex_state = 0, .external_lex_state = 7},
  [9602] = {.lex_state = 0},
  [9603] = {.lex_state = 0, .external_lex_state = 7},
  [9604] = {.lex_state = 0},
  [9605] = {.lex_state = 1},
  [9606] = {.lex_state = 0},
  [9607] = {.lex_state = 0},
  [9608] = {.lex_state = 0},
  [9609] = {.lex_state = 105},
  [9610] = {.lex_state = 0},
  [9611] = {.lex_state = 0},
  [9612] = {.lex_state = 0},
  [9613] = {.lex_state = 0, .external_lex_state = 7},
  [9614] = {.lex_state = 0},
  [9615] = {.lex_state = 0},
  [9616] = {.lex_state = 0, .external_lex_state = 7},
  [9617] = {.lex_state = 0},
  [9618] = {.lex_state = 0, .external_lex_state = 7},
  [9619] = {.lex_state = 0, .external_lex_state = 9},
  [9620] = {.lex_state = 0, .external_lex_state = 8},
  [9621] = {.lex_state = 0},
  [9622] = {.lex_state = 0, .external_lex_state = 7},
  [9623] = {.lex_state = 0},
  [9624] = {.lex_state = 0},
  [9625] = {.lex_state = 105},
  [9626] = {.lex_state = 0},
  [9627] = {.lex_state = 0},
  [9628] = {.lex_state = 0, .external_lex_state = 7},
  [9629] = {.lex_state = 0},
  [9630] = {.lex_state = 0},
  [9631] = {.lex_state = 0, .external_lex_state = 7},
  [9632] = {.lex_state = 0},
  [9633] = {.lex_state = 0, .external_lex_state = 7},
  [9634] = {.lex_state = 0},
  [9635] = {.lex_state = 0, .external_lex_state = 7},
  [9636] = {.lex_state = 0},
  [9637] = {.lex_state = 0},
  [9638] = {.lex_state = 0, .external_lex_state = 7},
  [9639] = {.lex_state = 0},
  [9640] = {.lex_state = 0},
  [9641] = {.lex_state = 0},
  [9642] = {.lex_state = 0, .external_lex_state = 7},
  [9643] = {.lex_state = 0},
  [9644] = {.lex_state = 0, .external_lex_state = 7},
  [9645] = {.lex_state = 0, .external_lex_state = 7},
  [9646] = {.lex_state = 0, .external_lex_state = 7},
  [9647] = {.lex_state = 0, .external_lex_state = 7},
  [9648] = {.lex_state = 0},
  [9649] = {.lex_state = 0},
  [9650] = {.lex_state = 0},
  [9651] = {.lex_state = 0},
  [9652] = {.lex_state = 0},
  [9653] = {.lex_state = 0},
  [9654] = {.lex_state = 0},
  [9655] = {.lex_state = 0},
  [9656] = {.lex_state = 0},
  [9657] = {.lex_state = 0},
  [9658] = {.lex_state = 0},
  [9659] = {.lex_state = 0},
  [9660] = {.lex_state = 0},
  [9661] = {.lex_state = 0},
  [9662] = {.lex_state = 0},
  [9663] = {.lex_state = 0},
  [9664] = {.lex_state = 10},
  [9665] = {.lex_state = 0},
  [9666] = {.lex_state = 0, .external_lex_state = 7},
  [9667] = {.lex_state = 0},
  [9668] = {.lex_state = 0},
  [9669] = {.lex_state = 0, .external_lex_state = 7},
  [9670] = {.lex_state = 0},
  [9671] = {.lex_state = 10},
  [9672] = {.lex_state = 0},
  [9673] = {.lex_state = 10},
  [9674] = {.lex_state = 0},
  [9675] = {.lex_state = 0},
  [9676] = {.lex_state = 0},
  [9677] = {.lex_state = 0},
  [9678] = {.lex_state = 0},
  [9679] = {.lex_state = 0},
  [9680] = {.lex_state = 0},
  [9681] = {.lex_state = 0},
  [9682] = {.lex_state = 0, .external_lex_state = 7},
  [9683] = {.lex_state = 0},
  [9684] = {.lex_state = 0},
  [9685] = {.lex_state = 0, .external_lex_state = 7},
  [9686] = {.lex_state = 0},
  [9687] = {.lex_state = 0},
  [9688] = {.lex_state = 0, .external_lex_state = 7},
  [9689] = {.lex_state = 0, .external_lex_state = 7},
  [9690] = {.lex_state = 0, .external_lex_state = 7},
  [9691] = {.lex_state = 0},
  [9692] = {.lex_state = 0, .external_lex_state = 7},
  [9693] = {.lex_state = 0, .external_lex_state = 7},
  [9694] = {.lex_state = 0, .external_lex_state = 7},
  [9695] = {.lex_state = 0, .external_lex_state = 7},
  [9696] = {.lex_state = 0, .external_lex_state = 7},
  [9697] = {.lex_state = 0},
  [9698] = {.lex_state = 105},
  [9699] = {.lex_state = 10},
  [9700] = {.lex_state = 0, .external_lex_state = 7},
  [9701] = {.lex_state = 0, .external_lex_state = 7},
  [9702] = {.lex_state = 0, .external_lex_state = 7},
  [9703] = {.lex_state = 0, .external_lex_state = 7},
  [9704] = {.lex_state = 0, .external_lex_state = 7},
  [9705] = {.lex_state = 0, .external_lex_state = 7},
  [9706] = {.lex_state = 0, .external_lex_state = 7},
  [9707] = {.lex_state = 0, .external_lex_state = 7},
  [9708] = {.lex_state = 0, .external_lex_state = 7},
  [9709] = {.lex_state = 0},
  [9710] = {.lex_state = 0},
  [9711] = {.lex_state = 0, .external_lex_state = 7},
  [9712] = {.lex_state = 0, .external_lex_state = 7},
  [9713] = {.lex_state = 0, .external_lex_state = 7},
  [9714] = {.lex_state = 0, .external_lex_state = 7},
  [9715] = {.lex_state = 0, .external_lex_state = 7},
  [9716] = {.lex_state = 0, .external_lex_state = 7},
  [9717] = {.lex_state = 0},
  [9718] = {.lex_state = 0},
  [9719] = {.lex_state = 0},
  [9720] = {.lex_state = 0},
  [9721] = {.lex_state = 0, .external_lex_state = 7},
  [9722] = {.lex_state = 0},
  [9723] = {.lex_state = 0},
  [9724] = {.lex_state = 0},
  [9725] = {.lex_state = 0, .external_lex_state = 7},
  [9726] = {.lex_state = 0},
  [9727] = {.lex_state = 105},
  [9728] = {.lex_state = 0, .external_lex_state = 7},
  [9729] = {.lex_state = 0, .external_lex_state = 7},
  [9730] = {.lex_state = 0, .external_lex_state = 7},
  [9731] = {.lex_state = 0},
  [9732] = {.lex_state = 105},
  [9733] = {.lex_state = 0, .external_lex_state = 4},
  [9734] = {.lex_state = 0},
  [9735] = {.lex_state = 0, .external_lex_state = 7},
  [9736] = {.lex_state = 0, .external_lex_state = 7},
  [9737] = {.lex_state = 10},
  [9738] = {.lex_state = 0},
  [9739] = {.lex_state = 0},
  [9740] = {.lex_state = 0, .external_lex_state = 4},
  [9741] = {.lex_state = 0},
  [9742] = {.lex_state = 0, .external_lex_state = 7},
  [9743] = {.lex_state = 0},
  [9744] = {.lex_state = 0, .external_lex_state = 7},
  [9745] = {.lex_state = 105},
  [9746] = {.lex_state = 0},
  [9747] = {.lex_state = 0},
  [9748] = {.lex_state = 0},
  [9749] = {.lex_state = 0},
  [9750] = {.lex_state = 0},
  [9751] = {.lex_state = 0},
  [9752] = {.lex_state = 0},
  [9753] = {.lex_state = 0, .external_lex_state = 7},
  [9754] = {.lex_state = 0, .external_lex_state = 7},
  [9755] = {.lex_state = 0, .external_lex_state = 7},
  [9756] = {.lex_state = 0},
  [9757] = {.lex_state = 1},
  [9758] = {.lex_state = 0},
  [9759] = {.lex_state = 0, .external_lex_state = 7},
  [9760] = {.lex_state = 0},
  [9761] = {.lex_state = 0},
  [9762] = {.lex_state = 0},
  [9763] = {.lex_state = 0, .external_lex_state = 7},
  [9764] = {.lex_state = 0, .external_lex_state = 7},
  [9765] = {.lex_state = 0, .external_lex_state = 7},
  [9766] = {.lex_state = 0, .external_lex_state = 7},
  [9767] = {.lex_state = 0, .external_lex_state = 7},
  [9768] = {.lex_state = 1},
  [9769] = {.lex_state = 0, .external_lex_state = 7},
  [9770] = {.lex_state = 10},
  [9771] = {.lex_state = 0},
  [9772] = {.lex_state = 0},
  [9773] = {.lex_state = 0},
  [9774] = {.lex_state = 105},
  [9775] = {.lex_state = 0},
  [9776] = {.lex_state = 0},
  [9777] = {.lex_state = 0, .external_lex_state = 7},
  [9778] = {.lex_state = 0, .external_lex_state = 7},
  [9779] = {.lex_state = 0},
  [9780] = {.lex_state = 0, .external_lex_state = 7},
  [9781] = {.lex_state = 105},
  [9782] = {.lex_state = 0},
  [9783] = {.lex_state = 105},
  [9784] = {.lex_state = 0},
  [9785] = {.lex_state = 0, .external_lex_state = 7},
  [9786] = {.lex_state = 0},
  [9787] = {.lex_state = 0},
  [9788] = {.lex_state = 0},
  [9789] = {.lex_state = 0},
  [9790] = {.lex_state = 0, .external_lex_state = 7},
  [9791] = {.lex_state = 0},
  [9792] = {.lex_state = 0, .external_lex_state = 7},
  [9793] = {.lex_state = 0, .external_lex_state = 7},
  [9794] = {.lex_state = 1},
  [9795] = {.lex_state = 0},
  [9796] = {.lex_state = 0},
  [9797] = {.lex_state = 0},
  [9798] = {.lex_state = 0},
  [9799] = {.lex_state = 0},
  [9800] = {.lex_state = 0, .external_lex_state = 7},
  [9801] = {.lex_state = 0},
  [9802] = {.lex_state = 0, .external_lex_state = 7},
  [9803] = {.lex_state = 1},
  [9804] = {.lex_state = 0, .external_lex_state = 7},
  [9805] = {.lex_state = 0, .external_lex_state = 7},
  [9806] = {.lex_state = 0},
  [9807] = {.lex_state = 0},
  [9808] = {.lex_state = 0, .external_lex_state = 7},
  [9809] = {.lex_state = 0, .external_lex_state = 7},
  [9810] = {.lex_state = 0, .external_lex_state = 7},
  [9811] = {.lex_state = 0},
  [9812] = {.lex_state = 0, .external_lex_state = 7},
  [9813] = {.lex_state = 0},
  [9814] = {.lex_state = 0, .external_lex_state = 7},
  [9815] = {.lex_state = 0, .external_lex_state = 7},
  [9816] = {.lex_state = 0, .external_lex_state = 7},
  [9817] = {.lex_state = 0, .external_lex_state = 7},
  [9818] = {.lex_state = 0, .external_lex_state = 7},
  [9819] = {.lex_state = 0, .external_lex_state = 7},
  [9820] = {.lex_state = 0, .external_lex_state = 7},
  [9821] = {.lex_state = 0, .external_lex_state = 7},
  [9822] = {.lex_state = 0, .external_lex_state = 7},
  [9823] = {.lex_state = 0},
  [9824] = {.lex_state = 0},
  [9825] = {.lex_state = 0, .external_lex_state = 7},
  [9826] = {.lex_state = 0},
  [9827] = {.lex_state = 0, .external_lex_state = 7},
  [9828] = {.lex_state = 0},
  [9829] = {.lex_state = 0, .external_lex_state = 7},
  [9830] = {.lex_state = 0, .external_lex_state = 7},
  [9831] = {.lex_state = 0, .external_lex_state = 7},
  [9832] = {.lex_state = 0},
  [9833] = {.lex_state = 0},
  [9834] = {.lex_state = 0},
  [9835] = {.lex_state = 104},
  [9836] = {.lex_state = 0, .external_lex_state = 7},
  [9837] = {.lex_state = 0},
  [9838] = {.lex_state = 0, .external_lex_state = 7},
  [9839] = {.lex_state = 104},
  [9840] = {.lex_state = 0, .external_lex_state = 7},
  [9841] = {.lex_state = 0, .external_lex_state = 7},
  [9842] = {.lex_state = 0, .external_lex_state = 7},
  [9843] = {.lex_state = 0, .external_lex_state = 7},
  [9844] = {.lex_state = 0, .external_lex_state = 7},
  [9845] = {.lex_state = 10},
  [9846] = {.lex_state = 0, .external_lex_state = 7},
  [9847] = {.lex_state = 0, .external_lex_state = 7},
  [9848] = {.lex_state = 0, .external_lex_state = 7},
  [9849] = {.lex_state = 0, .external_lex_state = 7},
  [9850] = {.lex_state = 0, .external_lex_state = 7},
  [9851] = {.lex_state = 0, .external_lex_state = 7},
  [9852] = {.lex_state = 0, .external_lex_state = 7},
  [9853] = {.lex_state = 0},
  [9854] = {.lex_state = 0, .external_lex_state = 7},
  [9855] = {.lex_state = 0, .external_lex_state = 7},
  [9856] = {.lex_state = 0, .external_lex_state = 7},
  [9857] = {.lex_state = 0},
  [9858] = {.lex_state = 0, .external_lex_state = 7},
  [9859] = {.lex_state = 0, .external_lex_state = 7},
  [9860] = {.lex_state = 0, .external_lex_state = 7},
  [9861] = {.lex_state = 0, .external_lex_state = 7},
  [9862] = {.lex_state = 0, .external_lex_state = 7},
  [9863] = {.lex_state = 0, .external_lex_state = 7},
  [9864] = {.lex_state = 0, .external_lex_state = 7},
  [9865] = {.lex_state = 0, .external_lex_state = 7},
  [9866] = {.lex_state = 0, .external_lex_state = 10},
  [9867] = {.lex_state = 0},
  [9868] = {.lex_state = 0, .external_lex_state = 7},
  [9869] = {.lex_state = 0, .external_lex_state = 7},
  [9870] = {.lex_state = 0},
  [9871] = {.lex_state = 0, .external_lex_state = 7},
  [9872] = {.lex_state = 0, .external_lex_state = 7},
  [9873] = {.lex_state = 1},
  [9874] = {.lex_state = 1},
  [9875] = {.lex_state = 0, .external_lex_state = 7},
  [9876] = {.lex_state = 0},
  [9877] = {.lex_state = 1},
  [9878] = {.lex_state = 0},
  [9879] = {.lex_state = 0, .external_lex_state = 7},
  [9880] = {.lex_state = 0, .external_lex_state = 7},
  [9881] = {.lex_state = 0, .external_lex_state = 7},
  [9882] = {.lex_state = 0, .external_lex_state = 7},
  [9883] = {.lex_state = 0, .external_lex_state = 7},
  [9884] = {.lex_state = 0},
  [9885] = {.lex_state = 0, .external_lex_state = 7},
  [9886] = {.lex_state = 0},
  [9887] = {.lex_state = 0, .external_lex_state = 7},
  [9888] = {.lex_state = 0, .external_lex_state = 7},
  [9889] = {.lex_state = 0},
  [9890] = {.lex_state = 1},
  [9891] = {.lex_state = 0, .external_lex_state = 7},
  [9892] = {.lex_state = 0, .external_lex_state = 7},
  [9893] = {.lex_state = 4},
  [9894] = {.lex_state = 1},
  [9895] = {.lex_state = 0, .external_lex_state = 7},
  [9896] = {.lex_state = 0},
  [9897] = {.lex_state = 0, .external_lex_state = 7},
  [9898] = {.lex_state = 1},
  [9899] = {.lex_state = 0},
  [9900] = {.lex_state = 0, .external_lex_state = 7},
  [9901] = {.lex_state = 0, .external_lex_state = 7},
  [9902] = {.lex_state = 0},
  [9903] = {.lex_state = 0, .external_lex_state = 7},
  [9904] = {.lex_state = 0, .external_lex_state = 7},
  [9905] = {.lex_state = 0, .external_lex_state = 7},
  [9906] = {.lex_state = 105},
  [9907] = {.lex_state = 0, .external_lex_state = 7},
  [9908] = {.lex_state = 0, .external_lex_state = 7},
  [9909] = {.lex_state = 0, .external_lex_state = 7},
  [9910] = {.lex_state = 0},
  [9911] = {.lex_state = 0},
  [9912] = {.lex_state = 0},
  [9913] = {.lex_state = 0},
  [9914] = {.lex_state = 0, .external_lex_state = 7},
  [9915] = {.lex_state = 0, .external_lex_state = 7},
  [9916] = {.lex_state = 0},
  [9917] = {.lex_state = 0},
  [9918] = {.lex_state = 105},
  [9919] = {.lex_state = 0},
  [9920] = {.lex_state = 0, .external_lex_state = 7},
  [9921] = {.lex_state = 0},
  [9922] = {.lex_state = 0, .external_lex_state = 7},
  [9923] = {.lex_state = 0},
  [9924] = {.lex_state = 0},
  [9925] = {.lex_state = 0},
  [9926] = {.lex_state = 0},
  [9927] = {.lex_state = 0},
  [9928] = {.lex_state = 0},
  [9929] = {.lex_state = 0},
  [9930] = {.lex_state = 0, .external_lex_state = 7},
  [9931] = {.lex_state = 0, .external_lex_state = 7},
  [9932] = {.lex_state = 0},
  [9933] = {.lex_state = 0},
  [9934] = {.lex_state = 0},
  [9935] = {.lex_state = 0},
  [9936] = {.lex_state = 0},
  [9937] = {.lex_state = 0},
  [9938] = {.lex_state = 0},
  [9939] = {.lex_state = 0},
  [9940] = {.lex_state = 104},
  [9941] = {.lex_state = 0},
  [9942] = {.lex_state = 0},
  [9943] = {.lex_state = 0},
  [9944] = {.lex_state = 0},
  [9945] = {.lex_state = 0},
  [9946] = {.lex_state = 0},
  [9947] = {.lex_state = 0},
  [9948] = {.lex_state = 105},
  [9949] = {.lex_state = 0, .external_lex_state = 7},
  [9950] = {.lex_state = 0},
  [9951] = {.lex_state = 0, .external_lex_state = 7},
  [9952] = {.lex_state = 0, .external_lex_state = 7},
  [9953] = {.lex_state = 0},
  [9954] = {.lex_state = 0, .external_lex_state = 7},
  [9955] = {.lex_state = 0},
  [9956] = {.lex_state = 10},
  [9957] = {.lex_state = 0, .external_lex_state = 7},
  [9958] = {.lex_state = 0, .external_lex_state = 7},
  [9959] = {.lex_state = 0},
  [9960] = {.lex_state = 105},
  [9961] = {.lex_state = 0, .external_lex_state = 7},
  [9962] = {.lex_state = 0, .external_lex_state = 8},
  [9963] = {.lex_state = 0},
  [9964] = {.lex_state = 0, .external_lex_state = 9},
  [9965] = {.lex_state = 0, .external_lex_state = 7},
  [9966] = {.lex_state = 0},
  [9967] = {.lex_state = 105},
  [9968] = {.lex_state = 0},
  [9969] = {.lex_state = 105},
  [9970] = {.lex_state = 0},
  [9971] = {.lex_state = 105},
  [9972] = {.lex_state = 105},
  [9973] = {.lex_state = 15},
  [9974] = {.lex_state = 0},
  [9975] = {.lex_state = 0},
  [9976] = {.lex_state = 15},
  [9977] = {.lex_state = 0, .external_lex_state = 7},
  [9978] = {.lex_state = 105},
  [9979] = {.lex_state = 0},
  [9980] = {.lex_state = 15},
  [9981] = {(TSStateId)(-1)},
  [9982] = {(TSStateId)(-1)},
  [9983] = {(TSStateId)(-1)},
  [9984] = {(TSStateId)(-1)},
  [9985] = {(TSStateId)(-1)},
  [9986] = {(TSStateId)(-1)},
  [9987] = {(TSStateId)(-1)},
  [9988] = {(TSStateId)(-1)},
  [9989] = {(TSStateId)(-1)},
  [9990] = {(TSStateId)(-1)},
  [9991] = {(TSStateId)(-1)},
  [9992] = {(TSStateId)(-1)},
  [9993] = {(TSStateId)(-1)},
  [9994] = {(TSStateId)(-1)},
  [9995] = {(TSStateId)(-1)},
  [9996] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_preproc_region] = STATE(0),
    [sym_preproc_endregion] = STATE(0),
    [sym_preproc_line] = STATE(0),
    [sym_preproc_pragma] = STATE(0),
    [sym_preproc_nullable] = STATE(0),
    [sym_preproc_error] = STATE(0),
    [sym_preproc_define] = STATE(0),
    [sym_preproc_undef] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier_token] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_file] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_partial] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_notnull] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_checked] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_implicit] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_init] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_scoped] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_base] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_managed] = ACTIONS(1),
    [anon_sym_Cdecl] = ACTIONS(1),
    [anon_sym_Stdcall] = ACTIONS(1),
    [anon_sym_Thiscall] = ACTIONS(1),
    [anon_sym_Fastcall] = ACTIONS(1),
    [sym_predefined_type] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_unchecked] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [sym_discard] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_into] = ACTIONS(1),
    [anon_sym_join] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_equals] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_orderby] = ACTIONS(1),
    [anon_sym_ascending] = ACTIONS(1),
    [anon_sym_descending] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_stackalloc] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym___makeref] = ACTIONS(1),
    [anon_sym___reftype] = ACTIONS(1),
    [anon_sym___refvalue] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_real_literal] = ACTIONS(1),
    [aux_sym_string_literal_content_token2] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_string_literal_encoding] = ACTIONS(1),
    [sym_verbatim_string_literal] = ACTIONS(1),
    [aux_sym_raw_string_literal_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token3] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [anon_sym_hidden] = ACTIONS(1),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [anon_sym_warning] = ACTIONS(1),
    [anon_sym_disable] = ACTIONS(1),
    [anon_sym_restore] = ACTIONS(1),
    [anon_sym_checksum] = ACTIONS(1),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_annotations] = ACTIONS(1),
    [anon_sym_warnings] = ACTIONS(1),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_shebang_directive] = ACTIONS(1),
    [sym_comment] = ACTIONS(19),
    [sym__optional_semi] = ACTIONS(1),
    [sym_interpolation_regular_start] = ACTIONS(1),
    [sym_interpolation_verbatim_start] = ACTIONS(1),
    [sym_interpolation_raw_start] = ACTIONS(1),
    [sym_interpolation_start_quote] = ACTIONS(1),
    [sym_interpolation_end_quote] = ACTIONS(1),
    [sym_interpolation_open_brace] = ACTIONS(1),
    [sym_interpolation_close_brace] = ACTIONS(1),
    [sym_interpolation_string_content] = ACTIONS(1),
    [sym_raw_string_start] = ACTIONS(1),
    [sym_raw_string_end] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_compilation_unit] = STATE(9913),
    [sym__top_level_item] = STATE(2550),
    [sym_global_statement] = STATE(2548),
    [sym_extern_alias_directive] = STATE(2548),
    [sym_using_directive] = STATE(2548),
    [sym_global_attribute] = STATE(2548),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2548),
    [sym_file_scoped_namespace_declaration] = STATE(2548),
    [sym_type_declaration] = STATE(2548),
    [sym_class_declaration] = STATE(2525),
    [sym_struct_declaration] = STATE(2525),
    [sym_enum_declaration] = STATE(2525),
    [sym_interface_declaration] = STATE(2525),
    [sym_delegate_declaration] = STATE(2525),
    [sym_record_declaration] = STATE(2525),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2544),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2557),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1),
    [sym_preproc_endregion] = STATE(1),
    [sym_preproc_line] = STATE(1),
    [sym_preproc_pragma] = STATE(1),
    [sym_preproc_nullable] = STATE(1),
    [sym_preproc_error] = STATE(1),
    [sym_preproc_define] = STATE(1),
    [sym_preproc_undef] = STATE(1),
    [aux_sym_compilation_unit_repeat1] = STATE(17),
    [aux_sym_class_declaration_repeat1] = STATE(2816),
    [aux_sym_class_declaration_repeat2] = STATE(2936),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [ts_builtin_sym_end] = ACTIONS(21),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_shebang_directive] = ACTIONS(147),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9719),
    [sym_preproc_elif_in_top_level] = STATE(9719),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9201),
    [sym_preproc_elif_in_expression] = STATE(9201),
    [sym_preproc_region] = STATE(2),
    [sym_preproc_endregion] = STATE(2),
    [sym_preproc_line] = STATE(2),
    [sym_preproc_pragma] = STATE(2),
    [sym_preproc_nullable] = STATE(2),
    [sym_preproc_error] = STATE(2),
    [sym_preproc_define] = STATE(2),
    [sym_preproc_undef] = STATE(2),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(11),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(223),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [3] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9200),
    [sym_preproc_elif_in_top_level] = STATE(9200),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9201),
    [sym_preproc_elif_in_expression] = STATE(9201),
    [sym_preproc_region] = STATE(3),
    [sym_preproc_endregion] = STATE(3),
    [sym_preproc_line] = STATE(3),
    [sym_preproc_pragma] = STATE(3),
    [sym_preproc_nullable] = STATE(3),
    [sym_preproc_error] = STATE(3),
    [sym_preproc_define] = STATE(3),
    [sym_preproc_undef] = STATE(3),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(12),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(229),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [4] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9416),
    [sym_preproc_elif_in_top_level] = STATE(9416),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9201),
    [sym_preproc_elif_in_expression] = STATE(9201),
    [sym_preproc_region] = STATE(4),
    [sym_preproc_endregion] = STATE(4),
    [sym_preproc_line] = STATE(4),
    [sym_preproc_pragma] = STATE(4),
    [sym_preproc_nullable] = STATE(4),
    [sym_preproc_error] = STATE(4),
    [sym_preproc_define] = STATE(4),
    [sym_preproc_undef] = STATE(4),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(8),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(231),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [5] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9159),
    [sym_preproc_elif_in_top_level] = STATE(9159),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9201),
    [sym_preproc_elif_in_expression] = STATE(9201),
    [sym_preproc_region] = STATE(5),
    [sym_preproc_endregion] = STATE(5),
    [sym_preproc_line] = STATE(5),
    [sym_preproc_pragma] = STATE(5),
    [sym_preproc_nullable] = STATE(5),
    [sym_preproc_error] = STATE(5),
    [sym_preproc_define] = STATE(5),
    [sym_preproc_undef] = STATE(5),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(10),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(233),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [6] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(5387),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9573),
    [sym_preproc_elif_in_top_level] = STATE(9573),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9586),
    [sym_preproc_elif_in_expression] = STATE(9586),
    [sym_preproc_region] = STATE(6),
    [sym_preproc_endregion] = STATE(6),
    [sym_preproc_line] = STATE(6),
    [sym_preproc_pragma] = STATE(6),
    [sym_preproc_nullable] = STATE(6),
    [sym_preproc_error] = STATE(6),
    [sym_preproc_define] = STATE(6),
    [sym_preproc_undef] = STATE(6),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(7),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(235),
    [aux_sym_preproc_else_token1] = ACTIONS(225),
    [aux_sym_preproc_elif_token1] = ACTIONS(227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [7] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9527),
    [sym_preproc_elif_in_top_level] = STATE(9527),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(7),
    [sym_preproc_endregion] = STATE(7),
    [sym_preproc_line] = STATE(7),
    [sym_preproc_pragma] = STATE(7),
    [sym_preproc_nullable] = STATE(7),
    [sym_preproc_error] = STATE(7),
    [sym_preproc_define] = STATE(7),
    [sym_preproc_undef] = STATE(7),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(237),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [8] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9383),
    [sym_preproc_elif_in_top_level] = STATE(9383),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(8),
    [sym_preproc_endregion] = STATE(8),
    [sym_preproc_line] = STATE(8),
    [sym_preproc_pragma] = STATE(8),
    [sym_preproc_nullable] = STATE(8),
    [sym_preproc_error] = STATE(8),
    [sym_preproc_define] = STATE(8),
    [sym_preproc_undef] = STATE(8),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(243),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [9] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9573),
    [sym_preproc_elif_in_top_level] = STATE(9573),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(9),
    [sym_preproc_endregion] = STATE(9),
    [sym_preproc_line] = STATE(9),
    [sym_preproc_pragma] = STATE(9),
    [sym_preproc_nullable] = STATE(9),
    [sym_preproc_error] = STATE(9),
    [sym_preproc_define] = STATE(9),
    [sym_preproc_undef] = STATE(9),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(7),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(235),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [10] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9241),
    [sym_preproc_elif_in_top_level] = STATE(9241),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(10),
    [sym_preproc_endregion] = STATE(10),
    [sym_preproc_line] = STATE(10),
    [sym_preproc_pragma] = STATE(10),
    [sym_preproc_nullable] = STATE(10),
    [sym_preproc_error] = STATE(10),
    [sym_preproc_define] = STATE(10),
    [sym_preproc_undef] = STATE(10),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(245),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [11] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9789),
    [sym_preproc_elif_in_top_level] = STATE(9789),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(11),
    [sym_preproc_endregion] = STATE(11),
    [sym_preproc_line] = STATE(11),
    [sym_preproc_pragma] = STATE(11),
    [sym_preproc_nullable] = STATE(11),
    [sym_preproc_error] = STATE(11),
    [sym_preproc_define] = STATE(11),
    [sym_preproc_undef] = STATE(11),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(247),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [12] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_else_in_top_level] = STATE(9643),
    [sym_preproc_elif_in_top_level] = STATE(9643),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(12),
    [sym_preproc_endregion] = STATE(12),
    [sym_preproc_line] = STATE(12),
    [sym_preproc_pragma] = STATE(12),
    [sym_preproc_nullable] = STATE(12),
    [sym_preproc_error] = STATE(12),
    [sym_preproc_define] = STATE(12),
    [sym_preproc_undef] = STATE(12),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(249),
    [aux_sym_preproc_else_token1] = ACTIONS(239),
    [aux_sym_preproc_elif_token1] = ACTIONS(241),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [13] = {
    [sym__top_level_item] = STATE(2550),
    [sym_global_statement] = STATE(2548),
    [sym_extern_alias_directive] = STATE(2548),
    [sym_using_directive] = STATE(2548),
    [sym_global_attribute] = STATE(2548),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2548),
    [sym_file_scoped_namespace_declaration] = STATE(2548),
    [sym_type_declaration] = STATE(2548),
    [sym_class_declaration] = STATE(2525),
    [sym_struct_declaration] = STATE(2525),
    [sym_enum_declaration] = STATE(2525),
    [sym_interface_declaration] = STATE(2525),
    [sym_delegate_declaration] = STATE(2525),
    [sym_record_declaration] = STATE(2525),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2544),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2557),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(13),
    [sym_preproc_endregion] = STATE(13),
    [sym_preproc_line] = STATE(13),
    [sym_preproc_pragma] = STATE(13),
    [sym_preproc_nullable] = STATE(13),
    [sym_preproc_error] = STATE(13),
    [sym_preproc_define] = STATE(13),
    [sym_preproc_undef] = STATE(13),
    [aux_sym_compilation_unit_repeat1] = STATE(14),
    [aux_sym_class_declaration_repeat1] = STATE(2816),
    [aux_sym_class_declaration_repeat2] = STATE(2936),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [ts_builtin_sym_end] = ACTIONS(251),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [14] = {
    [sym__top_level_item] = STATE(2550),
    [sym_global_statement] = STATE(2548),
    [sym_extern_alias_directive] = STATE(2548),
    [sym_using_directive] = STATE(2548),
    [sym_global_attribute] = STATE(2548),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2548),
    [sym_file_scoped_namespace_declaration] = STATE(2548),
    [sym_type_declaration] = STATE(2548),
    [sym_class_declaration] = STATE(2525),
    [sym_struct_declaration] = STATE(2525),
    [sym_enum_declaration] = STATE(2525),
    [sym_interface_declaration] = STATE(2525),
    [sym_delegate_declaration] = STATE(2525),
    [sym_record_declaration] = STATE(2525),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2544),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2557),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(14),
    [sym_preproc_endregion] = STATE(14),
    [sym_preproc_line] = STATE(14),
    [sym_preproc_pragma] = STATE(14),
    [sym_preproc_nullable] = STATE(14),
    [sym_preproc_error] = STATE(14),
    [sym_preproc_define] = STATE(14),
    [sym_preproc_undef] = STATE(14),
    [aux_sym_compilation_unit_repeat1] = STATE(14),
    [aux_sym_class_declaration_repeat1] = STATE(2816),
    [aux_sym_class_declaration_repeat2] = STATE(2936),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [ts_builtin_sym_end] = ACTIONS(253),
    [sym__identifier_token] = ACTIONS(255),
    [anon_sym_extern] = ACTIONS(258),
    [anon_sym_alias] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(264),
    [anon_sym_global] = ACTIONS(267),
    [anon_sym_using] = ACTIONS(270),
    [anon_sym_unsafe] = ACTIONS(273),
    [anon_sym_static] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(282),
    [anon_sym_return] = ACTIONS(285),
    [anon_sym_namespace] = ACTIONS(288),
    [anon_sym_class] = ACTIONS(291),
    [anon_sym_ref] = ACTIONS(294),
    [anon_sym_struct] = ACTIONS(297),
    [anon_sym_enum] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_delegate] = ACTIONS(309),
    [anon_sym_record] = ACTIONS(312),
    [anon_sym_abstract] = ACTIONS(315),
    [anon_sym_async] = ACTIONS(276),
    [anon_sym_const] = ACTIONS(315),
    [anon_sym_file] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(321),
    [anon_sym_internal] = ACTIONS(315),
    [anon_sym_new] = ACTIONS(324),
    [anon_sym_override] = ACTIONS(315),
    [anon_sym_partial] = ACTIONS(315),
    [anon_sym_private] = ACTIONS(315),
    [anon_sym_protected] = ACTIONS(315),
    [anon_sym_public] = ACTIONS(315),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_required] = ACTIONS(315),
    [anon_sym_sealed] = ACTIONS(315),
    [anon_sym_virtual] = ACTIONS(315),
    [anon_sym_volatile] = ACTIONS(315),
    [anon_sym_where] = ACTIONS(261),
    [anon_sym_notnull] = ACTIONS(261),
    [anon_sym_unmanaged] = ACTIONS(261),
    [anon_sym_checked] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(330),
    [anon_sym_TILDE] = ACTIONS(330),
    [anon_sym_PLUS_PLUS] = ACTIONS(330),
    [anon_sym_DASH_DASH] = ACTIONS(330),
    [anon_sym_true] = ACTIONS(333),
    [anon_sym_false] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(336),
    [anon_sym_DASH] = ACTIONS(336),
    [anon_sym_STAR] = ACTIONS(339),
    [anon_sym_CARET] = ACTIONS(330),
    [anon_sym_AMP] = ACTIONS(330),
    [anon_sym_this] = ACTIONS(342),
    [anon_sym_scoped] = ACTIONS(345),
    [anon_sym_base] = ACTIONS(348),
    [anon_sym_var] = ACTIONS(351),
    [sym_predefined_type] = ACTIONS(354),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_unchecked] = ACTIONS(327),
    [anon_sym_continue] = ACTIONS(360),
    [anon_sym_do] = ACTIONS(363),
    [anon_sym_while] = ACTIONS(366),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_lock] = ACTIONS(372),
    [anon_sym_yield] = ACTIONS(375),
    [anon_sym_switch] = ACTIONS(378),
    [anon_sym_default] = ACTIONS(381),
    [anon_sym_throw] = ACTIONS(384),
    [anon_sym_try] = ACTIONS(387),
    [anon_sym_when] = ACTIONS(261),
    [anon_sym_await] = ACTIONS(390),
    [anon_sym_foreach] = ACTIONS(393),
    [anon_sym_goto] = ACTIONS(396),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_DOT_DOT] = ACTIONS(402),
    [anon_sym_from] = ACTIONS(405),
    [anon_sym_into] = ACTIONS(261),
    [anon_sym_join] = ACTIONS(261),
    [anon_sym_on] = ACTIONS(261),
    [anon_sym_equals] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(261),
    [anon_sym_orderby] = ACTIONS(261),
    [anon_sym_ascending] = ACTIONS(261),
    [anon_sym_descending] = ACTIONS(261),
    [anon_sym_group] = ACTIONS(261),
    [anon_sym_by] = ACTIONS(261),
    [anon_sym_select] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(408),
    [anon_sym_stackalloc] = ACTIONS(411),
    [anon_sym_sizeof] = ACTIONS(414),
    [anon_sym_typeof] = ACTIONS(417),
    [anon_sym___makeref] = ACTIONS(420),
    [anon_sym___reftype] = ACTIONS(423),
    [anon_sym___refvalue] = ACTIONS(426),
    [sym_null_literal] = ACTIONS(429),
    [anon_sym_SQUOTE] = ACTIONS(432),
    [sym_integer_literal] = ACTIONS(429),
    [sym_real_literal] = ACTIONS(435),
    [sym_verbatim_string_literal] = ACTIONS(435),
    [aux_sym_preproc_if_token1] = ACTIONS(438),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(441),
    [sym_interpolation_verbatim_start] = ACTIONS(444),
    [sym_interpolation_raw_start] = ACTIONS(447),
    [sym_raw_string_start] = ACTIONS(450),
  },
  [15] = {
    [sym__top_level_item] = STATE(2550),
    [sym_global_statement] = STATE(2548),
    [sym_extern_alias_directive] = STATE(2548),
    [sym_using_directive] = STATE(2548),
    [sym_global_attribute] = STATE(2548),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2548),
    [sym_file_scoped_namespace_declaration] = STATE(2548),
    [sym_type_declaration] = STATE(2548),
    [sym_class_declaration] = STATE(2525),
    [sym_struct_declaration] = STATE(2525),
    [sym_enum_declaration] = STATE(2525),
    [sym_interface_declaration] = STATE(2525),
    [sym_delegate_declaration] = STATE(2525),
    [sym_record_declaration] = STATE(2525),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2544),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2557),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(15),
    [sym_preproc_endregion] = STATE(15),
    [sym_preproc_line] = STATE(15),
    [sym_preproc_pragma] = STATE(15),
    [sym_preproc_nullable] = STATE(15),
    [sym_preproc_error] = STATE(15),
    [sym_preproc_define] = STATE(15),
    [sym_preproc_undef] = STATE(15),
    [aux_sym_compilation_unit_repeat1] = STATE(13),
    [aux_sym_class_declaration_repeat1] = STATE(2816),
    [aux_sym_class_declaration_repeat2] = STATE(2936),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [16] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(16),
    [sym_preproc_endregion] = STATE(16),
    [sym_preproc_line] = STATE(16),
    [sym_preproc_pragma] = STATE(16),
    [sym_preproc_nullable] = STATE(16),
    [sym_preproc_error] = STATE(16),
    [sym_preproc_define] = STATE(16),
    [sym_preproc_undef] = STATE(16),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(455),
    [anon_sym_extern] = ACTIONS(458),
    [anon_sym_alias] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(464),
    [anon_sym_global] = ACTIONS(467),
    [anon_sym_using] = ACTIONS(470),
    [anon_sym_unsafe] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(482),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_namespace] = ACTIONS(488),
    [anon_sym_class] = ACTIONS(491),
    [anon_sym_ref] = ACTIONS(494),
    [anon_sym_struct] = ACTIONS(497),
    [anon_sym_enum] = ACTIONS(500),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_interface] = ACTIONS(506),
    [anon_sym_delegate] = ACTIONS(509),
    [anon_sym_record] = ACTIONS(512),
    [anon_sym_abstract] = ACTIONS(515),
    [anon_sym_async] = ACTIONS(476),
    [anon_sym_const] = ACTIONS(515),
    [anon_sym_file] = ACTIONS(518),
    [anon_sym_fixed] = ACTIONS(521),
    [anon_sym_internal] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(524),
    [anon_sym_override] = ACTIONS(515),
    [anon_sym_partial] = ACTIONS(515),
    [anon_sym_private] = ACTIONS(515),
    [anon_sym_protected] = ACTIONS(515),
    [anon_sym_public] = ACTIONS(515),
    [anon_sym_readonly] = ACTIONS(515),
    [anon_sym_required] = ACTIONS(515),
    [anon_sym_sealed] = ACTIONS(515),
    [anon_sym_virtual] = ACTIONS(515),
    [anon_sym_volatile] = ACTIONS(515),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_notnull] = ACTIONS(461),
    [anon_sym_unmanaged] = ACTIONS(461),
    [anon_sym_checked] = ACTIONS(527),
    [anon_sym_BANG] = ACTIONS(530),
    [anon_sym_TILDE] = ACTIONS(530),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_DASH_DASH] = ACTIONS(530),
    [anon_sym_true] = ACTIONS(533),
    [anon_sym_false] = ACTIONS(533),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(539),
    [anon_sym_CARET] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_this] = ACTIONS(542),
    [anon_sym_scoped] = ACTIONS(545),
    [anon_sym_base] = ACTIONS(548),
    [anon_sym_var] = ACTIONS(551),
    [sym_predefined_type] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(557),
    [anon_sym_unchecked] = ACTIONS(527),
    [anon_sym_continue] = ACTIONS(560),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(569),
    [anon_sym_lock] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_default] = ACTIONS(581),
    [anon_sym_throw] = ACTIONS(584),
    [anon_sym_try] = ACTIONS(587),
    [anon_sym_when] = ACTIONS(461),
    [anon_sym_await] = ACTIONS(590),
    [anon_sym_foreach] = ACTIONS(593),
    [anon_sym_goto] = ACTIONS(596),
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_DOT_DOT] = ACTIONS(602),
    [anon_sym_from] = ACTIONS(605),
    [anon_sym_into] = ACTIONS(461),
    [anon_sym_join] = ACTIONS(461),
    [anon_sym_on] = ACTIONS(461),
    [anon_sym_equals] = ACTIONS(461),
    [anon_sym_let] = ACTIONS(461),
    [anon_sym_orderby] = ACTIONS(461),
    [anon_sym_ascending] = ACTIONS(461),
    [anon_sym_descending] = ACTIONS(461),
    [anon_sym_group] = ACTIONS(461),
    [anon_sym_by] = ACTIONS(461),
    [anon_sym_select] = ACTIONS(461),
    [anon_sym_DQUOTE] = ACTIONS(608),
    [anon_sym_stackalloc] = ACTIONS(611),
    [anon_sym_sizeof] = ACTIONS(614),
    [anon_sym_typeof] = ACTIONS(617),
    [anon_sym___makeref] = ACTIONS(620),
    [anon_sym___reftype] = ACTIONS(623),
    [anon_sym___refvalue] = ACTIONS(626),
    [sym_null_literal] = ACTIONS(629),
    [anon_sym_SQUOTE] = ACTIONS(632),
    [sym_integer_literal] = ACTIONS(629),
    [sym_real_literal] = ACTIONS(635),
    [sym_verbatim_string_literal] = ACTIONS(635),
    [aux_sym_preproc_if_token1] = ACTIONS(638),
    [aux_sym_preproc_if_token3] = ACTIONS(641),
    [aux_sym_preproc_else_token1] = ACTIONS(641),
    [aux_sym_preproc_elif_token1] = ACTIONS(641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(643),
    [sym_interpolation_verbatim_start] = ACTIONS(646),
    [sym_interpolation_raw_start] = ACTIONS(649),
    [sym_raw_string_start] = ACTIONS(652),
  },
  [17] = {
    [sym__top_level_item] = STATE(2550),
    [sym_global_statement] = STATE(2548),
    [sym_extern_alias_directive] = STATE(2548),
    [sym_using_directive] = STATE(2548),
    [sym_global_attribute] = STATE(2548),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2548),
    [sym_file_scoped_namespace_declaration] = STATE(2548),
    [sym_type_declaration] = STATE(2548),
    [sym_class_declaration] = STATE(2525),
    [sym_struct_declaration] = STATE(2525),
    [sym_enum_declaration] = STATE(2525),
    [sym_interface_declaration] = STATE(2525),
    [sym_delegate_declaration] = STATE(2525),
    [sym_record_declaration] = STATE(2525),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2544),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2557),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(17),
    [sym_preproc_endregion] = STATE(17),
    [sym_preproc_line] = STATE(17),
    [sym_preproc_pragma] = STATE(17),
    [sym_preproc_nullable] = STATE(17),
    [sym_preproc_error] = STATE(17),
    [sym_preproc_define] = STATE(17),
    [sym_preproc_undef] = STATE(17),
    [aux_sym_compilation_unit_repeat1] = STATE(14),
    [aux_sym_class_declaration_repeat1] = STATE(2816),
    [aux_sym_class_declaration_repeat2] = STATE(2936),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(25),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(31),
    [anon_sym_using] = ACTIONS(33),
    [anon_sym_unsafe] = ACTIONS(35),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(39),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_namespace] = ACTIONS(45),
    [anon_sym_class] = ACTIONS(47),
    [anon_sym_ref] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_enum] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_interface] = ACTIONS(57),
    [anon_sym_delegate] = ACTIONS(59),
    [anon_sym_record] = ACTIONS(61),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(67),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [18] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(18),
    [sym_preproc_endregion] = STATE(18),
    [sym_preproc_line] = STATE(18),
    [sym_preproc_pragma] = STATE(18),
    [sym_preproc_nullable] = STATE(18),
    [sym_preproc_error] = STATE(18),
    [sym_preproc_define] = STATE(18),
    [sym_preproc_undef] = STATE(18),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(655),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [19] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(19),
    [sym_preproc_endregion] = STATE(19),
    [sym_preproc_line] = STATE(19),
    [sym_preproc_pragma] = STATE(19),
    [sym_preproc_nullable] = STATE(19),
    [sym_preproc_error] = STATE(19),
    [sym_preproc_define] = STATE(19),
    [sym_preproc_undef] = STATE(19),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(16),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(657),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [20] = {
    [sym_extern_alias_directive] = STATE(2326),
    [sym_using_directive] = STATE(2326),
    [sym_global_attribute] = STATE(2326),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(2326),
    [sym_file_scoped_namespace_declaration] = STATE(2326),
    [sym_type_declaration] = STATE(2326),
    [sym_class_declaration] = STATE(2337),
    [sym_struct_declaration] = STATE(2337),
    [sym_enum_declaration] = STATE(2337),
    [sym_interface_declaration] = STATE(2337),
    [sym_delegate_declaration] = STATE(2337),
    [sym_record_declaration] = STATE(2337),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2326),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6613),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2382),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(20),
    [sym_preproc_endregion] = STATE(20),
    [sym_preproc_line] = STATE(20),
    [sym_preproc_pragma] = STATE(20),
    [sym_preproc_nullable] = STATE(20),
    [sym_preproc_error] = STATE(20),
    [sym_preproc_define] = STATE(20),
    [sym_preproc_undef] = STATE(20),
    [aux_sym_class_declaration_repeat1] = STATE(2812),
    [aux_sym_class_declaration_repeat2] = STATE(2923),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [aux_sym_preproc_if_in_top_level_repeat1] = STATE(19),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(161),
    [anon_sym_using] = ACTIONS(163),
    [anon_sym_unsafe] = ACTIONS(165),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_namespace] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_ref] = ACTIONS(175),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_enum] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_interface] = ACTIONS(183),
    [anon_sym_delegate] = ACTIONS(185),
    [anon_sym_record] = ACTIONS(187),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(65),
    [anon_sym_fixed] = ACTIONS(189),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(69),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_if_token3] = ACTIONS(655),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [21] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(5987),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(21),
    [sym_preproc_endregion] = STATE(21),
    [sym_preproc_line] = STATE(21),
    [sym_preproc_pragma] = STATE(21),
    [sym_preproc_nullable] = STATE(21),
    [sym_preproc_error] = STATE(21),
    [sym_preproc_define] = STATE(21),
    [sym_preproc_undef] = STATE(21),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [22] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(22),
    [sym_preproc_endregion] = STATE(22),
    [sym_preproc_line] = STATE(22),
    [sym_preproc_pragma] = STATE(22),
    [sym_preproc_nullable] = STATE(22),
    [sym_preproc_error] = STATE(22),
    [sym_preproc_define] = STATE(22),
    [sym_preproc_undef] = STATE(22),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(731),
    [anon_sym_extern] = ACTIONS(734),
    [anon_sym_alias] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(740),
    [anon_sym_global] = ACTIONS(737),
    [anon_sym_using] = ACTIONS(743),
    [anon_sym_unsafe] = ACTIONS(746),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(752),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_return] = ACTIONS(758),
    [anon_sym_ref] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_delegate] = ACTIONS(769),
    [anon_sym_abstract] = ACTIONS(734),
    [anon_sym_async] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(734),
    [anon_sym_file] = ACTIONS(772),
    [anon_sym_fixed] = ACTIONS(775),
    [anon_sym_internal] = ACTIONS(734),
    [anon_sym_new] = ACTIONS(778),
    [anon_sym_override] = ACTIONS(734),
    [anon_sym_partial] = ACTIONS(734),
    [anon_sym_private] = ACTIONS(734),
    [anon_sym_protected] = ACTIONS(734),
    [anon_sym_public] = ACTIONS(734),
    [anon_sym_readonly] = ACTIONS(734),
    [anon_sym_required] = ACTIONS(734),
    [anon_sym_sealed] = ACTIONS(734),
    [anon_sym_virtual] = ACTIONS(734),
    [anon_sym_volatile] = ACTIONS(734),
    [anon_sym_where] = ACTIONS(737),
    [anon_sym_notnull] = ACTIONS(737),
    [anon_sym_unmanaged] = ACTIONS(737),
    [anon_sym_checked] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_true] = ACTIONS(787),
    [anon_sym_false] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(790),
    [anon_sym_DASH] = ACTIONS(790),
    [anon_sym_STAR] = ACTIONS(793),
    [anon_sym_CARET] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_this] = ACTIONS(796),
    [anon_sym_scoped] = ACTIONS(799),
    [anon_sym_base] = ACTIONS(802),
    [anon_sym_var] = ACTIONS(805),
    [sym_predefined_type] = ACTIONS(808),
    [anon_sym_break] = ACTIONS(811),
    [anon_sym_unchecked] = ACTIONS(781),
    [anon_sym_continue] = ACTIONS(814),
    [anon_sym_do] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(820),
    [anon_sym_for] = ACTIONS(823),
    [anon_sym_lock] = ACTIONS(826),
    [anon_sym_yield] = ACTIONS(829),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(837),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_await] = ACTIONS(846),
    [anon_sym_foreach] = ACTIONS(849),
    [anon_sym_goto] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_DOT_DOT] = ACTIONS(858),
    [anon_sym_from] = ACTIONS(861),
    [anon_sym_into] = ACTIONS(737),
    [anon_sym_join] = ACTIONS(737),
    [anon_sym_on] = ACTIONS(737),
    [anon_sym_equals] = ACTIONS(737),
    [anon_sym_let] = ACTIONS(737),
    [anon_sym_orderby] = ACTIONS(737),
    [anon_sym_ascending] = ACTIONS(737),
    [anon_sym_descending] = ACTIONS(737),
    [anon_sym_group] = ACTIONS(737),
    [anon_sym_by] = ACTIONS(737),
    [anon_sym_select] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(864),
    [anon_sym_stackalloc] = ACTIONS(867),
    [anon_sym_sizeof] = ACTIONS(870),
    [anon_sym_typeof] = ACTIONS(873),
    [anon_sym___makeref] = ACTIONS(876),
    [anon_sym___reftype] = ACTIONS(879),
    [anon_sym___refvalue] = ACTIONS(882),
    [sym_null_literal] = ACTIONS(885),
    [anon_sym_SQUOTE] = ACTIONS(888),
    [sym_integer_literal] = ACTIONS(885),
    [sym_real_literal] = ACTIONS(891),
    [sym_verbatim_string_literal] = ACTIONS(891),
    [aux_sym_preproc_if_token1] = ACTIONS(894),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(897),
    [sym_interpolation_verbatim_start] = ACTIONS(900),
    [sym_interpolation_raw_start] = ACTIONS(903),
    [sym_raw_string_start] = ACTIONS(906),
  },
  [23] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6113),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(23),
    [sym_preproc_endregion] = STATE(23),
    [sym_preproc_line] = STATE(23),
    [sym_preproc_pragma] = STATE(23),
    [sym_preproc_nullable] = STATE(23),
    [sym_preproc_error] = STATE(23),
    [sym_preproc_define] = STATE(23),
    [sym_preproc_undef] = STATE(23),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(43),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [24] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(24),
    [sym_preproc_endregion] = STATE(24),
    [sym_preproc_line] = STATE(24),
    [sym_preproc_pragma] = STATE(24),
    [sym_preproc_nullable] = STATE(24),
    [sym_preproc_error] = STATE(24),
    [sym_preproc_define] = STATE(24),
    [sym_preproc_undef] = STATE(24),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(917),
    [anon_sym_default] = ACTIONS(917),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [25] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(25),
    [sym_preproc_endregion] = STATE(25),
    [sym_preproc_line] = STATE(25),
    [sym_preproc_pragma] = STATE(25),
    [sym_preproc_nullable] = STATE(25),
    [sym_preproc_error] = STATE(25),
    [sym_preproc_define] = STATE(25),
    [sym_preproc_undef] = STATE(25),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(58),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [26] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(26),
    [sym_preproc_endregion] = STATE(26),
    [sym_preproc_line] = STATE(26),
    [sym_preproc_pragma] = STATE(26),
    [sym_preproc_nullable] = STATE(26),
    [sym_preproc_error] = STATE(26),
    [sym_preproc_define] = STATE(26),
    [sym_preproc_undef] = STATE(26),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(35),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(929),
    [anon_sym_default] = ACTIONS(929),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [27] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(5831),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(27),
    [sym_preproc_endregion] = STATE(27),
    [sym_preproc_line] = STATE(27),
    [sym_preproc_pragma] = STATE(27),
    [sym_preproc_nullable] = STATE(27),
    [sym_preproc_error] = STATE(27),
    [sym_preproc_define] = STATE(27),
    [sym_preproc_undef] = STATE(27),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(41),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [28] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(28),
    [sym_preproc_endregion] = STATE(28),
    [sym_preproc_line] = STATE(28),
    [sym_preproc_pragma] = STATE(28),
    [sym_preproc_nullable] = STATE(28),
    [sym_preproc_error] = STATE(28),
    [sym_preproc_define] = STATE(28),
    [sym_preproc_undef] = STATE(28),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(50),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [29] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(29),
    [sym_preproc_endregion] = STATE(29),
    [sym_preproc_line] = STATE(29),
    [sym_preproc_pragma] = STATE(29),
    [sym_preproc_nullable] = STATE(29),
    [sym_preproc_error] = STATE(29),
    [sym_preproc_define] = STATE(29),
    [sym_preproc_undef] = STATE(29),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(49),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [30] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(30),
    [sym_preproc_endregion] = STATE(30),
    [sym_preproc_line] = STATE(30),
    [sym_preproc_pragma] = STATE(30),
    [sym_preproc_nullable] = STATE(30),
    [sym_preproc_error] = STATE(30),
    [sym_preproc_define] = STATE(30),
    [sym_preproc_undef] = STATE(30),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(36),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(941),
    [anon_sym_default] = ACTIONS(941),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [31] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(5810),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(31),
    [sym_preproc_endregion] = STATE(31),
    [sym_preproc_line] = STATE(31),
    [sym_preproc_pragma] = STATE(31),
    [sym_preproc_nullable] = STATE(31),
    [sym_preproc_error] = STATE(31),
    [sym_preproc_define] = STATE(31),
    [sym_preproc_undef] = STATE(31),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(39),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [32] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(32),
    [sym_preproc_endregion] = STATE(32),
    [sym_preproc_line] = STATE(32),
    [sym_preproc_pragma] = STATE(32),
    [sym_preproc_nullable] = STATE(32),
    [sym_preproc_error] = STATE(32),
    [sym_preproc_define] = STATE(32),
    [sym_preproc_undef] = STATE(32),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(58),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [33] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6011),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(33),
    [sym_preproc_endregion] = STATE(33),
    [sym_preproc_line] = STATE(33),
    [sym_preproc_pragma] = STATE(33),
    [sym_preproc_nullable] = STATE(33),
    [sym_preproc_error] = STATE(33),
    [sym_preproc_define] = STATE(33),
    [sym_preproc_undef] = STATE(33),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(42),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [34] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(34),
    [sym_preproc_endregion] = STATE(34),
    [sym_preproc_line] = STATE(34),
    [sym_preproc_pragma] = STATE(34),
    [sym_preproc_nullable] = STATE(34),
    [sym_preproc_error] = STATE(34),
    [sym_preproc_define] = STATE(34),
    [sym_preproc_undef] = STATE(34),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(24),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_default] = ACTIONS(955),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [35] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(35),
    [sym_preproc_endregion] = STATE(35),
    [sym_preproc_line] = STATE(35),
    [sym_preproc_pragma] = STATE(35),
    [sym_preproc_nullable] = STATE(35),
    [sym_preproc_error] = STATE(35),
    [sym_preproc_define] = STATE(35),
    [sym_preproc_undef] = STATE(35),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_default] = ACTIONS(955),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [36] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(36),
    [sym_preproc_endregion] = STATE(36),
    [sym_preproc_line] = STATE(36),
    [sym_preproc_pragma] = STATE(36),
    [sym_preproc_nullable] = STATE(36),
    [sym_preproc_error] = STATE(36),
    [sym_preproc_define] = STATE(36),
    [sym_preproc_undef] = STATE(36),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_case] = ACTIONS(929),
    [anon_sym_default] = ACTIONS(929),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [37] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6828),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(37),
    [sym_preproc_endregion] = STATE(37),
    [sym_preproc_line] = STATE(37),
    [sym_preproc_pragma] = STATE(37),
    [sym_preproc_nullable] = STATE(37),
    [sym_preproc_error] = STATE(37),
    [sym_preproc_define] = STATE(37),
    [sym_preproc_undef] = STATE(37),
    [aux_sym_class_declaration_repeat1] = STATE(2932),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(57),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(715),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(719),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [38] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(38),
    [sym_preproc_endregion] = STATE(38),
    [sym_preproc_line] = STATE(38),
    [sym_preproc_pragma] = STATE(38),
    [sym_preproc_nullable] = STATE(38),
    [sym_preproc_error] = STATE(38),
    [sym_preproc_define] = STATE(38),
    [sym_preproc_undef] = STATE(38),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(43),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [39] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(39),
    [sym_preproc_endregion] = STATE(39),
    [sym_preproc_line] = STATE(39),
    [sym_preproc_pragma] = STATE(39),
    [sym_preproc_nullable] = STATE(39),
    [sym_preproc_error] = STATE(39),
    [sym_preproc_define] = STATE(39),
    [sym_preproc_undef] = STATE(39),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [40] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(40),
    [sym_preproc_endregion] = STATE(40),
    [sym_preproc_line] = STATE(40),
    [sym_preproc_pragma] = STATE(40),
    [sym_preproc_nullable] = STATE(40),
    [sym_preproc_error] = STATE(40),
    [sym_preproc_define] = STATE(40),
    [sym_preproc_undef] = STATE(40),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(39),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [41] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(41),
    [sym_preproc_endregion] = STATE(41),
    [sym_preproc_line] = STATE(41),
    [sym_preproc_pragma] = STATE(41),
    [sym_preproc_nullable] = STATE(41),
    [sym_preproc_error] = STATE(41),
    [sym_preproc_define] = STATE(41),
    [sym_preproc_undef] = STATE(41),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [42] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(42),
    [sym_preproc_endregion] = STATE(42),
    [sym_preproc_line] = STATE(42),
    [sym_preproc_pragma] = STATE(42),
    [sym_preproc_nullable] = STATE(42),
    [sym_preproc_error] = STATE(42),
    [sym_preproc_define] = STATE(42),
    [sym_preproc_undef] = STATE(42),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(967),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [43] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(43),
    [sym_preproc_endregion] = STATE(43),
    [sym_preproc_line] = STATE(43),
    [sym_preproc_pragma] = STATE(43),
    [sym_preproc_nullable] = STATE(43),
    [sym_preproc_error] = STATE(43),
    [sym_preproc_define] = STATE(43),
    [sym_preproc_undef] = STATE(43),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [44] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(44),
    [sym_preproc_endregion] = STATE(44),
    [sym_preproc_line] = STATE(44),
    [sym_preproc_pragma] = STATE(44),
    [sym_preproc_nullable] = STATE(44),
    [sym_preproc_error] = STATE(44),
    [sym_preproc_define] = STATE(44),
    [sym_preproc_undef] = STATE(44),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(58),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [45] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(45),
    [sym_preproc_endregion] = STATE(45),
    [sym_preproc_line] = STATE(45),
    [sym_preproc_pragma] = STATE(45),
    [sym_preproc_nullable] = STATE(45),
    [sym_preproc_error] = STATE(45),
    [sym_preproc_define] = STATE(45),
    [sym_preproc_undef] = STATE(45),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(42),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [46] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(46),
    [sym_preproc_endregion] = STATE(46),
    [sym_preproc_line] = STATE(46),
    [sym_preproc_pragma] = STATE(46),
    [sym_preproc_nullable] = STATE(46),
    [sym_preproc_error] = STATE(46),
    [sym_preproc_define] = STATE(46),
    [sym_preproc_undef] = STATE(46),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(41),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [47] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(47),
    [sym_preproc_endregion] = STATE(47),
    [sym_preproc_line] = STATE(47),
    [sym_preproc_pragma] = STATE(47),
    [sym_preproc_nullable] = STATE(47),
    [sym_preproc_error] = STATE(47),
    [sym_preproc_define] = STATE(47),
    [sym_preproc_undef] = STATE(47),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(57),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [48] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(48),
    [sym_preproc_endregion] = STATE(48),
    [sym_preproc_line] = STATE(48),
    [sym_preproc_pragma] = STATE(48),
    [sym_preproc_nullable] = STATE(48),
    [sym_preproc_error] = STATE(48),
    [sym_preproc_define] = STATE(48),
    [sym_preproc_undef] = STATE(48),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(59),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [49] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(49),
    [sym_preproc_endregion] = STATE(49),
    [sym_preproc_line] = STATE(49),
    [sym_preproc_pragma] = STATE(49),
    [sym_preproc_nullable] = STATE(49),
    [sym_preproc_error] = STATE(49),
    [sym_preproc_define] = STATE(49),
    [sym_preproc_undef] = STATE(49),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [50] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(50),
    [sym_preproc_endregion] = STATE(50),
    [sym_preproc_line] = STATE(50),
    [sym_preproc_pragma] = STATE(50),
    [sym_preproc_nullable] = STATE(50),
    [sym_preproc_error] = STATE(50),
    [sym_preproc_define] = STATE(50),
    [sym_preproc_undef] = STATE(50),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [51] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(51),
    [sym_preproc_endregion] = STATE(51),
    [sym_preproc_line] = STATE(51),
    [sym_preproc_pragma] = STATE(51),
    [sym_preproc_nullable] = STATE(51),
    [sym_preproc_error] = STATE(51),
    [sym_preproc_define] = STATE(51),
    [sym_preproc_undef] = STATE(51),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [52] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(52),
    [sym_preproc_endregion] = STATE(52),
    [sym_preproc_line] = STATE(52),
    [sym_preproc_pragma] = STATE(52),
    [sym_preproc_nullable] = STATE(52),
    [sym_preproc_error] = STATE(52),
    [sym_preproc_define] = STATE(52),
    [sym_preproc_undef] = STATE(52),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [53] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(53),
    [sym_preproc_endregion] = STATE(53),
    [sym_preproc_line] = STATE(53),
    [sym_preproc_pragma] = STATE(53),
    [sym_preproc_nullable] = STATE(53),
    [sym_preproc_error] = STATE(53),
    [sym_preproc_define] = STATE(53),
    [sym_preproc_undef] = STATE(53),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(50),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [54] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(54),
    [sym_preproc_endregion] = STATE(54),
    [sym_preproc_line] = STATE(54),
    [sym_preproc_pragma] = STATE(54),
    [sym_preproc_nullable] = STATE(54),
    [sym_preproc_error] = STATE(54),
    [sym_preproc_define] = STATE(54),
    [sym_preproc_undef] = STATE(54),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(49),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [55] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(55),
    [sym_preproc_endregion] = STATE(55),
    [sym_preproc_line] = STATE(55),
    [sym_preproc_pragma] = STATE(55),
    [sym_preproc_nullable] = STATE(55),
    [sym_preproc_error] = STATE(55),
    [sym_preproc_define] = STATE(55),
    [sym_preproc_undef] = STATE(55),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(52),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [56] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(56),
    [sym_preproc_endregion] = STATE(56),
    [sym_preproc_line] = STATE(56),
    [sym_preproc_pragma] = STATE(56),
    [sym_preproc_nullable] = STATE(56),
    [sym_preproc_error] = STATE(56),
    [sym_preproc_define] = STATE(56),
    [sym_preproc_undef] = STATE(56),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(51),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [57] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(57),
    [sym_preproc_endregion] = STATE(57),
    [sym_preproc_line] = STATE(57),
    [sym_preproc_pragma] = STATE(57),
    [sym_preproc_nullable] = STATE(57),
    [sym_preproc_error] = STATE(57),
    [sym_preproc_define] = STATE(57),
    [sym_preproc_undef] = STATE(57),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [58] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(58),
    [sym_preproc_endregion] = STATE(58),
    [sym_preproc_line] = STATE(58),
    [sym_preproc_pragma] = STATE(58),
    [sym_preproc_nullable] = STATE(58),
    [sym_preproc_error] = STATE(58),
    [sym_preproc_define] = STATE(58),
    [sym_preproc_undef] = STATE(58),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [59] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2733),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(59),
    [sym_preproc_endregion] = STATE(59),
    [sym_preproc_line] = STATE(59),
    [sym_preproc_pragma] = STATE(59),
    [sym_preproc_nullable] = STATE(59),
    [sym_preproc_error] = STATE(59),
    [sym_preproc_define] = STATE(59),
    [sym_preproc_undef] = STATE(59),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_block_repeat1] = STATE(22),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [60] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(9698),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(60),
    [sym_preproc_endregion] = STATE(60),
    [sym_preproc_line] = STATE(60),
    [sym_preproc_pragma] = STATE(60),
    [sym_preproc_nullable] = STATE(60),
    [sym_preproc_error] = STATE(60),
    [sym_preproc_define] = STATE(60),
    [sym_preproc_undef] = STATE(60),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [61] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2675),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(61),
    [sym_preproc_endregion] = STATE(61),
    [sym_preproc_line] = STATE(61),
    [sym_preproc_pragma] = STATE(61),
    [sym_preproc_nullable] = STATE(61),
    [sym_preproc_error] = STATE(61),
    [sym_preproc_define] = STATE(61),
    [sym_preproc_undef] = STATE(61),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [62] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(9609),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(62),
    [sym_preproc_endregion] = STATE(62),
    [sym_preproc_line] = STATE(62),
    [sym_preproc_pragma] = STATE(62),
    [sym_preproc_nullable] = STATE(62),
    [sym_preproc_error] = STATE(62),
    [sym_preproc_define] = STATE(62),
    [sym_preproc_undef] = STATE(62),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [63] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2457),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(63),
    [sym_preproc_endregion] = STATE(63),
    [sym_preproc_line] = STATE(63),
    [sym_preproc_pragma] = STATE(63),
    [sym_preproc_nullable] = STATE(63),
    [sym_preproc_error] = STATE(63),
    [sym_preproc_define] = STATE(63),
    [sym_preproc_undef] = STATE(63),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [64] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2286),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(64),
    [sym_preproc_endregion] = STATE(64),
    [sym_preproc_line] = STATE(64),
    [sym_preproc_pragma] = STATE(64),
    [sym_preproc_nullable] = STATE(64),
    [sym_preproc_error] = STATE(64),
    [sym_preproc_define] = STATE(64),
    [sym_preproc_undef] = STATE(64),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [65] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(9978),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(65),
    [sym_preproc_endregion] = STATE(65),
    [sym_preproc_line] = STATE(65),
    [sym_preproc_pragma] = STATE(65),
    [sym_preproc_nullable] = STATE(65),
    [sym_preproc_error] = STATE(65),
    [sym_preproc_define] = STATE(65),
    [sym_preproc_undef] = STATE(65),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [66] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8832),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(66),
    [sym_preproc_endregion] = STATE(66),
    [sym_preproc_line] = STATE(66),
    [sym_preproc_pragma] = STATE(66),
    [sym_preproc_nullable] = STATE(66),
    [sym_preproc_error] = STATE(66),
    [sym_preproc_define] = STATE(66),
    [sym_preproc_undef] = STATE(66),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [67] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2293),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(67),
    [sym_preproc_endregion] = STATE(67),
    [sym_preproc_line] = STATE(67),
    [sym_preproc_pragma] = STATE(67),
    [sym_preproc_nullable] = STATE(67),
    [sym_preproc_error] = STATE(67),
    [sym_preproc_define] = STATE(67),
    [sym_preproc_undef] = STATE(67),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [68] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8831),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(68),
    [sym_preproc_endregion] = STATE(68),
    [sym_preproc_line] = STATE(68),
    [sym_preproc_pragma] = STATE(68),
    [sym_preproc_nullable] = STATE(68),
    [sym_preproc_error] = STATE(68),
    [sym_preproc_define] = STATE(68),
    [sym_preproc_undef] = STATE(68),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [69] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8826),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(69),
    [sym_preproc_endregion] = STATE(69),
    [sym_preproc_line] = STATE(69),
    [sym_preproc_pragma] = STATE(69),
    [sym_preproc_nullable] = STATE(69),
    [sym_preproc_error] = STATE(69),
    [sym_preproc_define] = STATE(69),
    [sym_preproc_undef] = STATE(69),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [70] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8823),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(70),
    [sym_preproc_endregion] = STATE(70),
    [sym_preproc_line] = STATE(70),
    [sym_preproc_pragma] = STATE(70),
    [sym_preproc_nullable] = STATE(70),
    [sym_preproc_error] = STATE(70),
    [sym_preproc_define] = STATE(70),
    [sym_preproc_undef] = STATE(70),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [71] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2495),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(71),
    [sym_preproc_endregion] = STATE(71),
    [sym_preproc_line] = STATE(71),
    [sym_preproc_pragma] = STATE(71),
    [sym_preproc_nullable] = STATE(71),
    [sym_preproc_error] = STATE(71),
    [sym_preproc_define] = STATE(71),
    [sym_preproc_undef] = STATE(71),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [72] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8822),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(72),
    [sym_preproc_endregion] = STATE(72),
    [sym_preproc_line] = STATE(72),
    [sym_preproc_pragma] = STATE(72),
    [sym_preproc_nullable] = STATE(72),
    [sym_preproc_error] = STATE(72),
    [sym_preproc_define] = STATE(72),
    [sym_preproc_undef] = STATE(72),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [73] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8926),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(73),
    [sym_preproc_endregion] = STATE(73),
    [sym_preproc_line] = STATE(73),
    [sym_preproc_pragma] = STATE(73),
    [sym_preproc_nullable] = STATE(73),
    [sym_preproc_error] = STATE(73),
    [sym_preproc_define] = STATE(73),
    [sym_preproc_undef] = STATE(73),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [74] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2684),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(74),
    [sym_preproc_endregion] = STATE(74),
    [sym_preproc_line] = STATE(74),
    [sym_preproc_pragma] = STATE(74),
    [sym_preproc_nullable] = STATE(74),
    [sym_preproc_error] = STATE(74),
    [sym_preproc_define] = STATE(74),
    [sym_preproc_undef] = STATE(74),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [75] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8811),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(75),
    [sym_preproc_endregion] = STATE(75),
    [sym_preproc_line] = STATE(75),
    [sym_preproc_pragma] = STATE(75),
    [sym_preproc_nullable] = STATE(75),
    [sym_preproc_error] = STATE(75),
    [sym_preproc_define] = STATE(75),
    [sym_preproc_undef] = STATE(75),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [76] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2686),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(76),
    [sym_preproc_endregion] = STATE(76),
    [sym_preproc_line] = STATE(76),
    [sym_preproc_pragma] = STATE(76),
    [sym_preproc_nullable] = STATE(76),
    [sym_preproc_error] = STATE(76),
    [sym_preproc_define] = STATE(76),
    [sym_preproc_undef] = STATE(76),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [77] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2496),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(77),
    [sym_preproc_endregion] = STATE(77),
    [sym_preproc_line] = STATE(77),
    [sym_preproc_pragma] = STATE(77),
    [sym_preproc_nullable] = STATE(77),
    [sym_preproc_error] = STATE(77),
    [sym_preproc_define] = STATE(77),
    [sym_preproc_undef] = STATE(77),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [78] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2688),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(78),
    [sym_preproc_endregion] = STATE(78),
    [sym_preproc_line] = STATE(78),
    [sym_preproc_pragma] = STATE(78),
    [sym_preproc_nullable] = STATE(78),
    [sym_preproc_error] = STATE(78),
    [sym_preproc_define] = STATE(78),
    [sym_preproc_undef] = STATE(78),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [79] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2677),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(79),
    [sym_preproc_endregion] = STATE(79),
    [sym_preproc_line] = STATE(79),
    [sym_preproc_pragma] = STATE(79),
    [sym_preproc_nullable] = STATE(79),
    [sym_preproc_error] = STATE(79),
    [sym_preproc_define] = STATE(79),
    [sym_preproc_undef] = STATE(79),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [80] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2693),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(80),
    [sym_preproc_endregion] = STATE(80),
    [sym_preproc_line] = STATE(80),
    [sym_preproc_pragma] = STATE(80),
    [sym_preproc_nullable] = STATE(80),
    [sym_preproc_error] = STATE(80),
    [sym_preproc_define] = STATE(80),
    [sym_preproc_undef] = STATE(80),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [81] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2694),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(81),
    [sym_preproc_endregion] = STATE(81),
    [sym_preproc_line] = STATE(81),
    [sym_preproc_pragma] = STATE(81),
    [sym_preproc_nullable] = STATE(81),
    [sym_preproc_error] = STATE(81),
    [sym_preproc_define] = STATE(81),
    [sym_preproc_undef] = STATE(81),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [82] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2700),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(82),
    [sym_preproc_endregion] = STATE(82),
    [sym_preproc_line] = STATE(82),
    [sym_preproc_pragma] = STATE(82),
    [sym_preproc_nullable] = STATE(82),
    [sym_preproc_error] = STATE(82),
    [sym_preproc_define] = STATE(82),
    [sym_preproc_undef] = STATE(82),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [83] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2657),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(83),
    [sym_preproc_endregion] = STATE(83),
    [sym_preproc_line] = STATE(83),
    [sym_preproc_pragma] = STATE(83),
    [sym_preproc_nullable] = STATE(83),
    [sym_preproc_error] = STATE(83),
    [sym_preproc_define] = STATE(83),
    [sym_preproc_undef] = STATE(83),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [84] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2702),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(84),
    [sym_preproc_endregion] = STATE(84),
    [sym_preproc_line] = STATE(84),
    [sym_preproc_pragma] = STATE(84),
    [sym_preproc_nullable] = STATE(84),
    [sym_preproc_error] = STATE(84),
    [sym_preproc_define] = STATE(84),
    [sym_preproc_undef] = STATE(84),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [85] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2705),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(85),
    [sym_preproc_endregion] = STATE(85),
    [sym_preproc_line] = STATE(85),
    [sym_preproc_pragma] = STATE(85),
    [sym_preproc_nullable] = STATE(85),
    [sym_preproc_error] = STATE(85),
    [sym_preproc_define] = STATE(85),
    [sym_preproc_undef] = STATE(85),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [86] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8798),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(86),
    [sym_preproc_endregion] = STATE(86),
    [sym_preproc_line] = STATE(86),
    [sym_preproc_pragma] = STATE(86),
    [sym_preproc_nullable] = STATE(86),
    [sym_preproc_error] = STATE(86),
    [sym_preproc_define] = STATE(86),
    [sym_preproc_undef] = STATE(86),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [87] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8797),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(87),
    [sym_preproc_endregion] = STATE(87),
    [sym_preproc_line] = STATE(87),
    [sym_preproc_pragma] = STATE(87),
    [sym_preproc_nullable] = STATE(87),
    [sym_preproc_error] = STATE(87),
    [sym_preproc_define] = STATE(87),
    [sym_preproc_undef] = STATE(87),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [88] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8774),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(88),
    [sym_preproc_endregion] = STATE(88),
    [sym_preproc_line] = STATE(88),
    [sym_preproc_pragma] = STATE(88),
    [sym_preproc_nullable] = STATE(88),
    [sym_preproc_error] = STATE(88),
    [sym_preproc_define] = STATE(88),
    [sym_preproc_undef] = STATE(88),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [89] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8769),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(89),
    [sym_preproc_endregion] = STATE(89),
    [sym_preproc_line] = STATE(89),
    [sym_preproc_pragma] = STATE(89),
    [sym_preproc_nullable] = STATE(89),
    [sym_preproc_error] = STATE(89),
    [sym_preproc_define] = STATE(89),
    [sym_preproc_undef] = STATE(89),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [90] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8768),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(90),
    [sym_preproc_endregion] = STATE(90),
    [sym_preproc_line] = STATE(90),
    [sym_preproc_pragma] = STATE(90),
    [sym_preproc_nullable] = STATE(90),
    [sym_preproc_error] = STATE(90),
    [sym_preproc_define] = STATE(90),
    [sym_preproc_undef] = STATE(90),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [91] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8765),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(91),
    [sym_preproc_endregion] = STATE(91),
    [sym_preproc_line] = STATE(91),
    [sym_preproc_pragma] = STATE(91),
    [sym_preproc_nullable] = STATE(91),
    [sym_preproc_error] = STATE(91),
    [sym_preproc_define] = STATE(91),
    [sym_preproc_undef] = STATE(91),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [92] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2707),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(92),
    [sym_preproc_endregion] = STATE(92),
    [sym_preproc_line] = STATE(92),
    [sym_preproc_pragma] = STATE(92),
    [sym_preproc_nullable] = STATE(92),
    [sym_preproc_error] = STATE(92),
    [sym_preproc_define] = STATE(92),
    [sym_preproc_undef] = STATE(92),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [93] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2709),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(93),
    [sym_preproc_endregion] = STATE(93),
    [sym_preproc_line] = STATE(93),
    [sym_preproc_pragma] = STATE(93),
    [sym_preproc_nullable] = STATE(93),
    [sym_preproc_error] = STATE(93),
    [sym_preproc_define] = STATE(93),
    [sym_preproc_undef] = STATE(93),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [94] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2711),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(94),
    [sym_preproc_endregion] = STATE(94),
    [sym_preproc_line] = STATE(94),
    [sym_preproc_pragma] = STATE(94),
    [sym_preproc_nullable] = STATE(94),
    [sym_preproc_error] = STATE(94),
    [sym_preproc_define] = STATE(94),
    [sym_preproc_undef] = STATE(94),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [95] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2712),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(95),
    [sym_preproc_endregion] = STATE(95),
    [sym_preproc_line] = STATE(95),
    [sym_preproc_pragma] = STATE(95),
    [sym_preproc_nullable] = STATE(95),
    [sym_preproc_error] = STATE(95),
    [sym_preproc_define] = STATE(95),
    [sym_preproc_undef] = STATE(95),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [96] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2713),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(96),
    [sym_preproc_endregion] = STATE(96),
    [sym_preproc_line] = STATE(96),
    [sym_preproc_pragma] = STATE(96),
    [sym_preproc_nullable] = STATE(96),
    [sym_preproc_error] = STATE(96),
    [sym_preproc_define] = STATE(96),
    [sym_preproc_undef] = STATE(96),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [97] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(9597),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(97),
    [sym_preproc_endregion] = STATE(97),
    [sym_preproc_line] = STATE(97),
    [sym_preproc_pragma] = STATE(97),
    [sym_preproc_nullable] = STATE(97),
    [sym_preproc_error] = STATE(97),
    [sym_preproc_define] = STATE(97),
    [sym_preproc_undef] = STATE(97),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [98] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2452),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(98),
    [sym_preproc_endregion] = STATE(98),
    [sym_preproc_line] = STATE(98),
    [sym_preproc_pragma] = STATE(98),
    [sym_preproc_nullable] = STATE(98),
    [sym_preproc_error] = STATE(98),
    [sym_preproc_define] = STATE(98),
    [sym_preproc_undef] = STATE(98),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [99] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2716),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(99),
    [sym_preproc_endregion] = STATE(99),
    [sym_preproc_line] = STATE(99),
    [sym_preproc_pragma] = STATE(99),
    [sym_preproc_nullable] = STATE(99),
    [sym_preproc_error] = STATE(99),
    [sym_preproc_define] = STATE(99),
    [sym_preproc_undef] = STATE(99),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [100] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2717),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(100),
    [sym_preproc_endregion] = STATE(100),
    [sym_preproc_line] = STATE(100),
    [sym_preproc_pragma] = STATE(100),
    [sym_preproc_nullable] = STATE(100),
    [sym_preproc_error] = STATE(100),
    [sym_preproc_define] = STATE(100),
    [sym_preproc_undef] = STATE(100),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [101] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2462),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(101),
    [sym_preproc_endregion] = STATE(101),
    [sym_preproc_line] = STATE(101),
    [sym_preproc_pragma] = STATE(101),
    [sym_preproc_nullable] = STATE(101),
    [sym_preproc_error] = STATE(101),
    [sym_preproc_define] = STATE(101),
    [sym_preproc_undef] = STATE(101),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [102] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8861),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(102),
    [sym_preproc_endregion] = STATE(102),
    [sym_preproc_line] = STATE(102),
    [sym_preproc_pragma] = STATE(102),
    [sym_preproc_nullable] = STATE(102),
    [sym_preproc_error] = STATE(102),
    [sym_preproc_define] = STATE(102),
    [sym_preproc_undef] = STATE(102),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [103] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8764),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(103),
    [sym_preproc_endregion] = STATE(103),
    [sym_preproc_line] = STATE(103),
    [sym_preproc_pragma] = STATE(103),
    [sym_preproc_nullable] = STATE(103),
    [sym_preproc_error] = STATE(103),
    [sym_preproc_define] = STATE(103),
    [sym_preproc_undef] = STATE(103),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [104] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8735),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(104),
    [sym_preproc_endregion] = STATE(104),
    [sym_preproc_line] = STATE(104),
    [sym_preproc_pragma] = STATE(104),
    [sym_preproc_nullable] = STATE(104),
    [sym_preproc_error] = STATE(104),
    [sym_preproc_define] = STATE(104),
    [sym_preproc_undef] = STATE(104),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [105] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8740),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(105),
    [sym_preproc_endregion] = STATE(105),
    [sym_preproc_line] = STATE(105),
    [sym_preproc_pragma] = STATE(105),
    [sym_preproc_nullable] = STATE(105),
    [sym_preproc_error] = STATE(105),
    [sym_preproc_define] = STATE(105),
    [sym_preproc_undef] = STATE(105),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [106] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8862),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(106),
    [sym_preproc_endregion] = STATE(106),
    [sym_preproc_line] = STATE(106),
    [sym_preproc_pragma] = STATE(106),
    [sym_preproc_nullable] = STATE(106),
    [sym_preproc_error] = STATE(106),
    [sym_preproc_define] = STATE(106),
    [sym_preproc_undef] = STATE(106),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [107] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2466),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(107),
    [sym_preproc_endregion] = STATE(107),
    [sym_preproc_line] = STATE(107),
    [sym_preproc_pragma] = STATE(107),
    [sym_preproc_nullable] = STATE(107),
    [sym_preproc_error] = STATE(107),
    [sym_preproc_define] = STATE(107),
    [sym_preproc_undef] = STATE(107),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [108] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2450),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(108),
    [sym_preproc_endregion] = STATE(108),
    [sym_preproc_line] = STATE(108),
    [sym_preproc_pragma] = STATE(108),
    [sym_preproc_nullable] = STATE(108),
    [sym_preproc_error] = STATE(108),
    [sym_preproc_define] = STATE(108),
    [sym_preproc_undef] = STATE(108),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [109] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8744),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(109),
    [sym_preproc_endregion] = STATE(109),
    [sym_preproc_line] = STATE(109),
    [sym_preproc_pragma] = STATE(109),
    [sym_preproc_nullable] = STATE(109),
    [sym_preproc_error] = STATE(109),
    [sym_preproc_define] = STATE(109),
    [sym_preproc_undef] = STATE(109),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [110] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2723),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(110),
    [sym_preproc_endregion] = STATE(110),
    [sym_preproc_line] = STATE(110),
    [sym_preproc_pragma] = STATE(110),
    [sym_preproc_nullable] = STATE(110),
    [sym_preproc_error] = STATE(110),
    [sym_preproc_define] = STATE(110),
    [sym_preproc_undef] = STATE(110),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [111] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2724),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(111),
    [sym_preproc_endregion] = STATE(111),
    [sym_preproc_line] = STATE(111),
    [sym_preproc_pragma] = STATE(111),
    [sym_preproc_nullable] = STATE(111),
    [sym_preproc_error] = STATE(111),
    [sym_preproc_define] = STATE(111),
    [sym_preproc_undef] = STATE(111),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [112] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8863),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(112),
    [sym_preproc_endregion] = STATE(112),
    [sym_preproc_line] = STATE(112),
    [sym_preproc_pragma] = STATE(112),
    [sym_preproc_nullable] = STATE(112),
    [sym_preproc_error] = STATE(112),
    [sym_preproc_define] = STATE(112),
    [sym_preproc_undef] = STATE(112),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [113] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8864),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(113),
    [sym_preproc_endregion] = STATE(113),
    [sym_preproc_line] = STATE(113),
    [sym_preproc_pragma] = STATE(113),
    [sym_preproc_nullable] = STATE(113),
    [sym_preproc_error] = STATE(113),
    [sym_preproc_define] = STATE(113),
    [sym_preproc_undef] = STATE(113),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [114] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2725),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(114),
    [sym_preproc_endregion] = STATE(114),
    [sym_preproc_line] = STATE(114),
    [sym_preproc_pragma] = STATE(114),
    [sym_preproc_nullable] = STATE(114),
    [sym_preproc_error] = STATE(114),
    [sym_preproc_define] = STATE(114),
    [sym_preproc_undef] = STATE(114),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [115] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2731),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(115),
    [sym_preproc_endregion] = STATE(115),
    [sym_preproc_line] = STATE(115),
    [sym_preproc_pragma] = STATE(115),
    [sym_preproc_nullable] = STATE(115),
    [sym_preproc_error] = STATE(115),
    [sym_preproc_define] = STATE(115),
    [sym_preproc_undef] = STATE(115),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [116] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2704),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(116),
    [sym_preproc_endregion] = STATE(116),
    [sym_preproc_line] = STATE(116),
    [sym_preproc_pragma] = STATE(116),
    [sym_preproc_nullable] = STATE(116),
    [sym_preproc_error] = STATE(116),
    [sym_preproc_define] = STATE(116),
    [sym_preproc_undef] = STATE(116),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [117] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8865),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(117),
    [sym_preproc_endregion] = STATE(117),
    [sym_preproc_line] = STATE(117),
    [sym_preproc_pragma] = STATE(117),
    [sym_preproc_nullable] = STATE(117),
    [sym_preproc_error] = STATE(117),
    [sym_preproc_define] = STATE(117),
    [sym_preproc_undef] = STATE(117),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [118] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2447),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(118),
    [sym_preproc_endregion] = STATE(118),
    [sym_preproc_line] = STATE(118),
    [sym_preproc_pragma] = STATE(118),
    [sym_preproc_nullable] = STATE(118),
    [sym_preproc_error] = STATE(118),
    [sym_preproc_define] = STATE(118),
    [sym_preproc_undef] = STATE(118),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [119] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8977),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(119),
    [sym_preproc_endregion] = STATE(119),
    [sym_preproc_line] = STATE(119),
    [sym_preproc_pragma] = STATE(119),
    [sym_preproc_nullable] = STATE(119),
    [sym_preproc_error] = STATE(119),
    [sym_preproc_define] = STATE(119),
    [sym_preproc_undef] = STATE(119),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [120] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2500),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(120),
    [sym_preproc_endregion] = STATE(120),
    [sym_preproc_line] = STATE(120),
    [sym_preproc_pragma] = STATE(120),
    [sym_preproc_nullable] = STATE(120),
    [sym_preproc_error] = STATE(120),
    [sym_preproc_define] = STATE(120),
    [sym_preproc_undef] = STATE(120),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [121] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2471),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(121),
    [sym_preproc_endregion] = STATE(121),
    [sym_preproc_line] = STATE(121),
    [sym_preproc_pragma] = STATE(121),
    [sym_preproc_nullable] = STATE(121),
    [sym_preproc_error] = STATE(121),
    [sym_preproc_define] = STATE(121),
    [sym_preproc_undef] = STATE(121),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [122] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2501),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(122),
    [sym_preproc_endregion] = STATE(122),
    [sym_preproc_line] = STATE(122),
    [sym_preproc_pragma] = STATE(122),
    [sym_preproc_nullable] = STATE(122),
    [sym_preproc_error] = STATE(122),
    [sym_preproc_define] = STATE(122),
    [sym_preproc_undef] = STATE(122),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [123] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2475),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(123),
    [sym_preproc_endregion] = STATE(123),
    [sym_preproc_line] = STATE(123),
    [sym_preproc_pragma] = STATE(123),
    [sym_preproc_nullable] = STATE(123),
    [sym_preproc_error] = STATE(123),
    [sym_preproc_define] = STATE(123),
    [sym_preproc_undef] = STATE(123),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [124] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2283),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(124),
    [sym_preproc_endregion] = STATE(124),
    [sym_preproc_line] = STATE(124),
    [sym_preproc_pragma] = STATE(124),
    [sym_preproc_nullable] = STATE(124),
    [sym_preproc_error] = STATE(124),
    [sym_preproc_define] = STATE(124),
    [sym_preproc_undef] = STATE(124),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [125] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2680),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(125),
    [sym_preproc_endregion] = STATE(125),
    [sym_preproc_line] = STATE(125),
    [sym_preproc_pragma] = STATE(125),
    [sym_preproc_nullable] = STATE(125),
    [sym_preproc_error] = STATE(125),
    [sym_preproc_define] = STATE(125),
    [sym_preproc_undef] = STATE(125),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [126] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2292),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(126),
    [sym_preproc_endregion] = STATE(126),
    [sym_preproc_line] = STATE(126),
    [sym_preproc_pragma] = STATE(126),
    [sym_preproc_nullable] = STATE(126),
    [sym_preproc_error] = STATE(126),
    [sym_preproc_define] = STATE(126),
    [sym_preproc_undef] = STATE(126),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [127] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2474),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(127),
    [sym_preproc_endregion] = STATE(127),
    [sym_preproc_line] = STATE(127),
    [sym_preproc_pragma] = STATE(127),
    [sym_preproc_nullable] = STATE(127),
    [sym_preproc_error] = STATE(127),
    [sym_preproc_define] = STATE(127),
    [sym_preproc_undef] = STATE(127),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [128] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2454),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(128),
    [sym_preproc_endregion] = STATE(128),
    [sym_preproc_line] = STATE(128),
    [sym_preproc_pragma] = STATE(128),
    [sym_preproc_nullable] = STATE(128),
    [sym_preproc_error] = STATE(128),
    [sym_preproc_define] = STATE(128),
    [sym_preproc_undef] = STATE(128),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [129] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2473),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(129),
    [sym_preproc_endregion] = STATE(129),
    [sym_preproc_line] = STATE(129),
    [sym_preproc_pragma] = STATE(129),
    [sym_preproc_nullable] = STATE(129),
    [sym_preproc_error] = STATE(129),
    [sym_preproc_define] = STATE(129),
    [sym_preproc_undef] = STATE(129),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [130] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2440),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(130),
    [sym_preproc_endregion] = STATE(130),
    [sym_preproc_line] = STATE(130),
    [sym_preproc_pragma] = STATE(130),
    [sym_preproc_nullable] = STATE(130),
    [sym_preproc_error] = STATE(130),
    [sym_preproc_define] = STATE(130),
    [sym_preproc_undef] = STATE(130),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [131] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2503),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(131),
    [sym_preproc_endregion] = STATE(131),
    [sym_preproc_line] = STATE(131),
    [sym_preproc_pragma] = STATE(131),
    [sym_preproc_nullable] = STATE(131),
    [sym_preproc_error] = STATE(131),
    [sym_preproc_define] = STATE(131),
    [sym_preproc_undef] = STATE(131),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [132] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2441),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(132),
    [sym_preproc_endregion] = STATE(132),
    [sym_preproc_line] = STATE(132),
    [sym_preproc_pragma] = STATE(132),
    [sym_preproc_nullable] = STATE(132),
    [sym_preproc_error] = STATE(132),
    [sym_preproc_define] = STATE(132),
    [sym_preproc_undef] = STATE(132),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [133] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2256),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(133),
    [sym_preproc_endregion] = STATE(133),
    [sym_preproc_line] = STATE(133),
    [sym_preproc_pragma] = STATE(133),
    [sym_preproc_nullable] = STATE(133),
    [sym_preproc_error] = STATE(133),
    [sym_preproc_define] = STATE(133),
    [sym_preproc_undef] = STATE(133),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [134] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2253),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(134),
    [sym_preproc_endregion] = STATE(134),
    [sym_preproc_line] = STATE(134),
    [sym_preproc_pragma] = STATE(134),
    [sym_preproc_nullable] = STATE(134),
    [sym_preproc_error] = STATE(134),
    [sym_preproc_define] = STATE(134),
    [sym_preproc_undef] = STATE(134),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [135] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2252),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(135),
    [sym_preproc_endregion] = STATE(135),
    [sym_preproc_line] = STATE(135),
    [sym_preproc_pragma] = STATE(135),
    [sym_preproc_nullable] = STATE(135),
    [sym_preproc_error] = STATE(135),
    [sym_preproc_define] = STATE(135),
    [sym_preproc_undef] = STATE(135),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [136] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2443),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(136),
    [sym_preproc_endregion] = STATE(136),
    [sym_preproc_line] = STATE(136),
    [sym_preproc_pragma] = STATE(136),
    [sym_preproc_nullable] = STATE(136),
    [sym_preproc_error] = STATE(136),
    [sym_preproc_define] = STATE(136),
    [sym_preproc_undef] = STATE(136),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [137] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2291),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(137),
    [sym_preproc_endregion] = STATE(137),
    [sym_preproc_line] = STATE(137),
    [sym_preproc_pragma] = STATE(137),
    [sym_preproc_nullable] = STATE(137),
    [sym_preproc_error] = STATE(137),
    [sym_preproc_define] = STATE(137),
    [sym_preproc_undef] = STATE(137),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [138] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2250),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(138),
    [sym_preproc_endregion] = STATE(138),
    [sym_preproc_line] = STATE(138),
    [sym_preproc_pragma] = STATE(138),
    [sym_preproc_nullable] = STATE(138),
    [sym_preproc_error] = STATE(138),
    [sym_preproc_define] = STATE(138),
    [sym_preproc_undef] = STATE(138),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [139] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2445),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(139),
    [sym_preproc_endregion] = STATE(139),
    [sym_preproc_line] = STATE(139),
    [sym_preproc_pragma] = STATE(139),
    [sym_preproc_nullable] = STATE(139),
    [sym_preproc_error] = STATE(139),
    [sym_preproc_define] = STATE(139),
    [sym_preproc_undef] = STATE(139),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [140] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8930),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(140),
    [sym_preproc_endregion] = STATE(140),
    [sym_preproc_line] = STATE(140),
    [sym_preproc_pragma] = STATE(140),
    [sym_preproc_nullable] = STATE(140),
    [sym_preproc_error] = STATE(140),
    [sym_preproc_define] = STATE(140),
    [sym_preproc_undef] = STATE(140),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [141] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8933),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(141),
    [sym_preproc_endregion] = STATE(141),
    [sym_preproc_line] = STATE(141),
    [sym_preproc_pragma] = STATE(141),
    [sym_preproc_nullable] = STATE(141),
    [sym_preproc_error] = STATE(141),
    [sym_preproc_define] = STATE(141),
    [sym_preproc_undef] = STATE(141),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [142] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2438),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(142),
    [sym_preproc_endregion] = STATE(142),
    [sym_preproc_line] = STATE(142),
    [sym_preproc_pragma] = STATE(142),
    [sym_preproc_nullable] = STATE(142),
    [sym_preproc_error] = STATE(142),
    [sym_preproc_define] = STATE(142),
    [sym_preproc_undef] = STATE(142),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [143] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8959),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(143),
    [sym_preproc_endregion] = STATE(143),
    [sym_preproc_line] = STATE(143),
    [sym_preproc_pragma] = STATE(143),
    [sym_preproc_nullable] = STATE(143),
    [sym_preproc_error] = STATE(143),
    [sym_preproc_define] = STATE(143),
    [sym_preproc_undef] = STATE(143),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [144] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2448),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(144),
    [sym_preproc_endregion] = STATE(144),
    [sym_preproc_line] = STATE(144),
    [sym_preproc_pragma] = STATE(144),
    [sym_preproc_nullable] = STATE(144),
    [sym_preproc_error] = STATE(144),
    [sym_preproc_define] = STATE(144),
    [sym_preproc_undef] = STATE(144),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [145] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2246),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(145),
    [sym_preproc_endregion] = STATE(145),
    [sym_preproc_line] = STATE(145),
    [sym_preproc_pragma] = STATE(145),
    [sym_preproc_nullable] = STATE(145),
    [sym_preproc_error] = STATE(145),
    [sym_preproc_define] = STATE(145),
    [sym_preproc_undef] = STATE(145),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [146] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2455),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(146),
    [sym_preproc_endregion] = STATE(146),
    [sym_preproc_line] = STATE(146),
    [sym_preproc_pragma] = STATE(146),
    [sym_preproc_nullable] = STATE(146),
    [sym_preproc_error] = STATE(146),
    [sym_preproc_define] = STATE(146),
    [sym_preproc_undef] = STATE(146),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [147] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8958),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(147),
    [sym_preproc_endregion] = STATE(147),
    [sym_preproc_line] = STATE(147),
    [sym_preproc_pragma] = STATE(147),
    [sym_preproc_nullable] = STATE(147),
    [sym_preproc_error] = STATE(147),
    [sym_preproc_define] = STATE(147),
    [sym_preproc_undef] = STATE(147),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [148] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2288),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(148),
    [sym_preproc_endregion] = STATE(148),
    [sym_preproc_line] = STATE(148),
    [sym_preproc_pragma] = STATE(148),
    [sym_preproc_nullable] = STATE(148),
    [sym_preproc_error] = STATE(148),
    [sym_preproc_define] = STATE(148),
    [sym_preproc_undef] = STATE(148),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [149] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2464),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(149),
    [sym_preproc_endregion] = STATE(149),
    [sym_preproc_line] = STATE(149),
    [sym_preproc_pragma] = STATE(149),
    [sym_preproc_nullable] = STATE(149),
    [sym_preproc_error] = STATE(149),
    [sym_preproc_define] = STATE(149),
    [sym_preproc_undef] = STATE(149),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [150] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2726),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(150),
    [sym_preproc_endregion] = STATE(150),
    [sym_preproc_line] = STATE(150),
    [sym_preproc_pragma] = STATE(150),
    [sym_preproc_nullable] = STATE(150),
    [sym_preproc_error] = STATE(150),
    [sym_preproc_define] = STATE(150),
    [sym_preproc_undef] = STATE(150),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [151] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2714),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(151),
    [sym_preproc_endregion] = STATE(151),
    [sym_preproc_line] = STATE(151),
    [sym_preproc_pragma] = STATE(151),
    [sym_preproc_nullable] = STATE(151),
    [sym_preproc_error] = STATE(151),
    [sym_preproc_define] = STATE(151),
    [sym_preproc_undef] = STATE(151),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [152] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2708),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(152),
    [sym_preproc_endregion] = STATE(152),
    [sym_preproc_line] = STATE(152),
    [sym_preproc_pragma] = STATE(152),
    [sym_preproc_nullable] = STATE(152),
    [sym_preproc_error] = STATE(152),
    [sym_preproc_define] = STATE(152),
    [sym_preproc_undef] = STATE(152),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [153] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2477),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(153),
    [sym_preproc_endregion] = STATE(153),
    [sym_preproc_line] = STATE(153),
    [sym_preproc_pragma] = STATE(153),
    [sym_preproc_nullable] = STATE(153),
    [sym_preproc_error] = STATE(153),
    [sym_preproc_define] = STATE(153),
    [sym_preproc_undef] = STATE(153),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [154] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8957),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(154),
    [sym_preproc_endregion] = STATE(154),
    [sym_preproc_line] = STATE(154),
    [sym_preproc_pragma] = STATE(154),
    [sym_preproc_nullable] = STATE(154),
    [sym_preproc_error] = STATE(154),
    [sym_preproc_define] = STATE(154),
    [sym_preproc_undef] = STATE(154),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [155] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2480),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(155),
    [sym_preproc_endregion] = STATE(155),
    [sym_preproc_line] = STATE(155),
    [sym_preproc_pragma] = STATE(155),
    [sym_preproc_nullable] = STATE(155),
    [sym_preproc_error] = STATE(155),
    [sym_preproc_define] = STATE(155),
    [sym_preproc_undef] = STATE(155),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [156] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2439),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(156),
    [sym_preproc_endregion] = STATE(156),
    [sym_preproc_line] = STATE(156),
    [sym_preproc_pragma] = STATE(156),
    [sym_preproc_nullable] = STATE(156),
    [sym_preproc_error] = STATE(156),
    [sym_preproc_define] = STATE(156),
    [sym_preproc_undef] = STATE(156),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [157] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2703),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(157),
    [sym_preproc_endregion] = STATE(157),
    [sym_preproc_line] = STATE(157),
    [sym_preproc_pragma] = STATE(157),
    [sym_preproc_nullable] = STATE(157),
    [sym_preproc_error] = STATE(157),
    [sym_preproc_define] = STATE(157),
    [sym_preproc_undef] = STATE(157),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [158] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2282),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(158),
    [sym_preproc_endregion] = STATE(158),
    [sym_preproc_line] = STATE(158),
    [sym_preproc_pragma] = STATE(158),
    [sym_preproc_nullable] = STATE(158),
    [sym_preproc_error] = STATE(158),
    [sym_preproc_define] = STATE(158),
    [sym_preproc_undef] = STATE(158),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [159] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2301),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(159),
    [sym_preproc_endregion] = STATE(159),
    [sym_preproc_line] = STATE(159),
    [sym_preproc_pragma] = STATE(159),
    [sym_preproc_nullable] = STATE(159),
    [sym_preproc_error] = STATE(159),
    [sym_preproc_define] = STATE(159),
    [sym_preproc_undef] = STATE(159),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [160] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2656),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(160),
    [sym_preproc_endregion] = STATE(160),
    [sym_preproc_line] = STATE(160),
    [sym_preproc_pragma] = STATE(160),
    [sym_preproc_nullable] = STATE(160),
    [sym_preproc_error] = STATE(160),
    [sym_preproc_define] = STATE(160),
    [sym_preproc_undef] = STATE(160),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [161] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8956),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(161),
    [sym_preproc_endregion] = STATE(161),
    [sym_preproc_line] = STATE(161),
    [sym_preproc_pragma] = STATE(161),
    [sym_preproc_nullable] = STATE(161),
    [sym_preproc_error] = STATE(161),
    [sym_preproc_define] = STATE(161),
    [sym_preproc_undef] = STATE(161),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [162] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2485),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(162),
    [sym_preproc_endregion] = STATE(162),
    [sym_preproc_line] = STATE(162),
    [sym_preproc_pragma] = STATE(162),
    [sym_preproc_nullable] = STATE(162),
    [sym_preproc_error] = STATE(162),
    [sym_preproc_define] = STATE(162),
    [sym_preproc_undef] = STATE(162),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [163] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(8783),
    [sym_variable_declaration] = STATE(9503),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6825),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(8949),
    [sym_break_statement] = STATE(8783),
    [sym_checked_statement] = STATE(8783),
    [sym_continue_statement] = STATE(8783),
    [sym_do_statement] = STATE(8783),
    [sym_empty_statement] = STATE(8783),
    [sym_expression_statement] = STATE(8783),
    [sym_fixed_statement] = STATE(8783),
    [sym_for_statement] = STATE(8783),
    [sym_return_statement] = STATE(8783),
    [sym_lock_statement] = STATE(8783),
    [sym_yield_statement] = STATE(8783),
    [sym_switch_statement] = STATE(8783),
    [sym_throw_statement] = STATE(8783),
    [sym_try_statement] = STATE(8783),
    [sym_unsafe_statement] = STATE(8783),
    [sym_using_statement] = STATE(8783),
    [sym_foreach_statement] = STATE(8783),
    [sym_goto_statement] = STATE(8783),
    [sym_labeled_statement] = STATE(8783),
    [sym_if_statement] = STATE(8783),
    [sym_while_statement] = STATE(8783),
    [sym_local_declaration_statement] = STATE(8783),
    [sym_local_function_statement] = STATE(8783),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6754),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2913),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(8783),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(163),
    [sym_preproc_endregion] = STATE(163),
    [sym_preproc_line] = STATE(163),
    [sym_preproc_pragma] = STATE(163),
    [sym_preproc_nullable] = STATE(163),
    [sym_preproc_error] = STATE(163),
    [sym_preproc_define] = STATE(163),
    [sym_preproc_undef] = STATE(163),
    [aux_sym_class_declaration_repeat1] = STATE(2922),
    [aux_sym_class_declaration_repeat2] = STATE(3095),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1005),
    [anon_sym_unsafe] = ACTIONS(1007),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1013),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_unchecked] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_lock] = ACTIONS(1027),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1045),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [164] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2231),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(164),
    [sym_preproc_endregion] = STATE(164),
    [sym_preproc_line] = STATE(164),
    [sym_preproc_pragma] = STATE(164),
    [sym_preproc_nullable] = STATE(164),
    [sym_preproc_error] = STATE(164),
    [sym_preproc_define] = STATE(164),
    [sym_preproc_undef] = STATE(164),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [165] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2506),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(165),
    [sym_preproc_endregion] = STATE(165),
    [sym_preproc_line] = STATE(165),
    [sym_preproc_pragma] = STATE(165),
    [sym_preproc_nullable] = STATE(165),
    [sym_preproc_error] = STATE(165),
    [sym_preproc_define] = STATE(165),
    [sym_preproc_undef] = STATE(165),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [166] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2233),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(166),
    [sym_preproc_endregion] = STATE(166),
    [sym_preproc_line] = STATE(166),
    [sym_preproc_pragma] = STATE(166),
    [sym_preproc_nullable] = STATE(166),
    [sym_preproc_error] = STATE(166),
    [sym_preproc_define] = STATE(166),
    [sym_preproc_undef] = STATE(166),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [167] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2234),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(167),
    [sym_preproc_endregion] = STATE(167),
    [sym_preproc_line] = STATE(167),
    [sym_preproc_pragma] = STATE(167),
    [sym_preproc_nullable] = STATE(167),
    [sym_preproc_error] = STATE(167),
    [sym_preproc_define] = STATE(167),
    [sym_preproc_undef] = STATE(167),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [168] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2254),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(168),
    [sym_preproc_endregion] = STATE(168),
    [sym_preproc_line] = STATE(168),
    [sym_preproc_pragma] = STATE(168),
    [sym_preproc_nullable] = STATE(168),
    [sym_preproc_error] = STATE(168),
    [sym_preproc_define] = STATE(168),
    [sym_preproc_undef] = STATE(168),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [169] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2255),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(169),
    [sym_preproc_endregion] = STATE(169),
    [sym_preproc_line] = STATE(169),
    [sym_preproc_pragma] = STATE(169),
    [sym_preproc_nullable] = STATE(169),
    [sym_preproc_error] = STATE(169),
    [sym_preproc_define] = STATE(169),
    [sym_preproc_undef] = STATE(169),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [170] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2508),
    [sym_variable_declaration] = STATE(9911),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6871),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2476),
    [sym_break_statement] = STATE(2508),
    [sym_checked_statement] = STATE(2508),
    [sym_continue_statement] = STATE(2508),
    [sym_do_statement] = STATE(2508),
    [sym_empty_statement] = STATE(2508),
    [sym_expression_statement] = STATE(2508),
    [sym_fixed_statement] = STATE(2508),
    [sym_for_statement] = STATE(2508),
    [sym_return_statement] = STATE(2508),
    [sym_lock_statement] = STATE(2508),
    [sym_yield_statement] = STATE(2508),
    [sym_switch_statement] = STATE(2508),
    [sym_throw_statement] = STATE(2508),
    [sym_try_statement] = STATE(2508),
    [sym_unsafe_statement] = STATE(2508),
    [sym_using_statement] = STATE(2508),
    [sym_foreach_statement] = STATE(2508),
    [sym_goto_statement] = STATE(2508),
    [sym_labeled_statement] = STATE(2508),
    [sym_if_statement] = STATE(2508),
    [sym_while_statement] = STATE(2508),
    [sym_local_declaration_statement] = STATE(2508),
    [sym_local_function_statement] = STATE(2508),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6751),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2892),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2508),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(170),
    [sym_preproc_endregion] = STATE(170),
    [sym_preproc_line] = STATE(170),
    [sym_preproc_pragma] = STATE(170),
    [sym_preproc_nullable] = STATE(170),
    [sym_preproc_error] = STATE(170),
    [sym_preproc_define] = STATE(170),
    [sym_preproc_undef] = STATE(170),
    [aux_sym_class_declaration_repeat1] = STATE(2935),
    [aux_sym_class_declaration_repeat2] = STATE(3114),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1047),
    [anon_sym_unsafe] = ACTIONS(1049),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1051),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(91),
    [anon_sym_unchecked] = ACTIONS(71),
    [anon_sym_continue] = ACTIONS(93),
    [anon_sym_do] = ACTIONS(95),
    [anon_sym_while] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_lock] = ACTIONS(101),
    [anon_sym_yield] = ACTIONS(103),
    [anon_sym_switch] = ACTIONS(105),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(111),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(113),
    [anon_sym_foreach] = ACTIONS(115),
    [anon_sym_goto] = ACTIONS(117),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [171] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2271),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(171),
    [sym_preproc_endregion] = STATE(171),
    [sym_preproc_line] = STATE(171),
    [sym_preproc_pragma] = STATE(171),
    [sym_preproc_nullable] = STATE(171),
    [sym_preproc_error] = STATE(171),
    [sym_preproc_define] = STATE(171),
    [sym_preproc_undef] = STATE(171),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [172] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2275),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(172),
    [sym_preproc_endregion] = STATE(172),
    [sym_preproc_line] = STATE(172),
    [sym_preproc_pragma] = STATE(172),
    [sym_preproc_nullable] = STATE(172),
    [sym_preproc_error] = STATE(172),
    [sym_preproc_define] = STATE(172),
    [sym_preproc_undef] = STATE(172),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [173] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2276),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(173),
    [sym_preproc_endregion] = STATE(173),
    [sym_preproc_line] = STATE(173),
    [sym_preproc_pragma] = STATE(173),
    [sym_preproc_nullable] = STATE(173),
    [sym_preproc_error] = STATE(173),
    [sym_preproc_define] = STATE(173),
    [sym_preproc_undef] = STATE(173),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [174] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2278),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(174),
    [sym_preproc_endregion] = STATE(174),
    [sym_preproc_line] = STATE(174),
    [sym_preproc_pragma] = STATE(174),
    [sym_preproc_nullable] = STATE(174),
    [sym_preproc_error] = STATE(174),
    [sym_preproc_define] = STATE(174),
    [sym_preproc_undef] = STATE(174),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [175] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2287),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(175),
    [sym_preproc_endregion] = STATE(175),
    [sym_preproc_line] = STATE(175),
    [sym_preproc_pragma] = STATE(175),
    [sym_preproc_nullable] = STATE(175),
    [sym_preproc_error] = STATE(175),
    [sym_preproc_define] = STATE(175),
    [sym_preproc_undef] = STATE(175),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [176] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2279),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(176),
    [sym_preproc_endregion] = STATE(176),
    [sym_preproc_line] = STATE(176),
    [sym_preproc_pragma] = STATE(176),
    [sym_preproc_nullable] = STATE(176),
    [sym_preproc_error] = STATE(176),
    [sym_preproc_define] = STATE(176),
    [sym_preproc_undef] = STATE(176),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [177] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2290),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(177),
    [sym_preproc_endregion] = STATE(177),
    [sym_preproc_line] = STATE(177),
    [sym_preproc_pragma] = STATE(177),
    [sym_preproc_nullable] = STATE(177),
    [sym_preproc_error] = STATE(177),
    [sym_preproc_define] = STATE(177),
    [sym_preproc_undef] = STATE(177),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [178] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2302),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(178),
    [sym_preproc_endregion] = STATE(178),
    [sym_preproc_line] = STATE(178),
    [sym_preproc_pragma] = STATE(178),
    [sym_preproc_nullable] = STATE(178),
    [sym_preproc_error] = STATE(178),
    [sym_preproc_define] = STATE(178),
    [sym_preproc_undef] = STATE(178),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [179] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2698),
    [sym_variable_declaration] = STATE(9115),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6836),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2664),
    [sym_break_statement] = STATE(2698),
    [sym_checked_statement] = STATE(2698),
    [sym_continue_statement] = STATE(2698),
    [sym_do_statement] = STATE(2698),
    [sym_empty_statement] = STATE(2698),
    [sym_expression_statement] = STATE(2698),
    [sym_fixed_statement] = STATE(2698),
    [sym_for_statement] = STATE(2698),
    [sym_return_statement] = STATE(2698),
    [sym_lock_statement] = STATE(2698),
    [sym_yield_statement] = STATE(2698),
    [sym_switch_statement] = STATE(2698),
    [sym_throw_statement] = STATE(2698),
    [sym_try_statement] = STATE(2698),
    [sym_unsafe_statement] = STATE(2698),
    [sym_using_statement] = STATE(2698),
    [sym_foreach_statement] = STATE(2698),
    [sym_goto_statement] = STATE(2698),
    [sym_labeled_statement] = STATE(2698),
    [sym_if_statement] = STATE(2698),
    [sym_while_statement] = STATE(2698),
    [sym_local_declaration_statement] = STATE(2698),
    [sym_local_function_statement] = STATE(2698),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6468),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2698),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(179),
    [sym_preproc_endregion] = STATE(179),
    [sym_preproc_line] = STATE(179),
    [sym_preproc_pragma] = STATE(179),
    [sym_preproc_nullable] = STATE(179),
    [sym_preproc_error] = STATE(179),
    [sym_preproc_define] = STATE(179),
    [sym_preproc_undef] = STATE(179),
    [aux_sym_class_declaration_repeat1] = STATE(2924),
    [aux_sym_class_declaration_repeat2] = STATE(3103),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_unsafe] = ACTIONS(665),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(679),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(687),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(699),
    [anon_sym_unchecked] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(701),
    [anon_sym_do] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(707),
    [anon_sym_lock] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(921),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [180] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2284),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(180),
    [sym_preproc_endregion] = STATE(180),
    [sym_preproc_line] = STATE(180),
    [sym_preproc_pragma] = STATE(180),
    [sym_preproc_nullable] = STATE(180),
    [sym_preproc_error] = STATE(180),
    [sym_preproc_define] = STATE(180),
    [sym_preproc_undef] = STATE(180),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [181] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2306),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(181),
    [sym_preproc_endregion] = STATE(181),
    [sym_preproc_line] = STATE(181),
    [sym_preproc_pragma] = STATE(181),
    [sym_preproc_nullable] = STATE(181),
    [sym_preproc_error] = STATE(181),
    [sym_preproc_define] = STATE(181),
    [sym_preproc_undef] = STATE(181),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [182] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2307),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(182),
    [sym_preproc_endregion] = STATE(182),
    [sym_preproc_line] = STATE(182),
    [sym_preproc_pragma] = STATE(182),
    [sym_preproc_nullable] = STATE(182),
    [sym_preproc_error] = STATE(182),
    [sym_preproc_define] = STATE(182),
    [sym_preproc_undef] = STATE(182),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [183] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(2226),
    [sym_variable_declaration] = STATE(9583),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6888),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_statement] = STATE(2232),
    [sym_break_statement] = STATE(2226),
    [sym_checked_statement] = STATE(2226),
    [sym_continue_statement] = STATE(2226),
    [sym_do_statement] = STATE(2226),
    [sym_empty_statement] = STATE(2226),
    [sym_expression_statement] = STATE(2226),
    [sym_fixed_statement] = STATE(2226),
    [sym_for_statement] = STATE(2226),
    [sym_return_statement] = STATE(2226),
    [sym_lock_statement] = STATE(2226),
    [sym_yield_statement] = STATE(2226),
    [sym_switch_statement] = STATE(2226),
    [sym_throw_statement] = STATE(2226),
    [sym_try_statement] = STATE(2226),
    [sym_unsafe_statement] = STATE(2226),
    [sym_using_statement] = STATE(2226),
    [sym_foreach_statement] = STATE(2226),
    [sym_goto_statement] = STATE(2226),
    [sym_labeled_statement] = STATE(2226),
    [sym_if_statement] = STATE(2226),
    [sym_while_statement] = STATE(2226),
    [sym_local_declaration_statement] = STATE(2226),
    [sym_local_function_statement] = STATE(2226),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(6290),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2832),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_top_level] = STATE(2226),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(183),
    [sym_preproc_endregion] = STATE(183),
    [sym_preproc_line] = STATE(183),
    [sym_preproc_pragma] = STATE(183),
    [sym_preproc_nullable] = STATE(183),
    [sym_preproc_error] = STATE(183),
    [sym_preproc_define] = STATE(183),
    [sym_preproc_undef] = STATE(183),
    [aux_sym_class_declaration_repeat1] = STATE(2929),
    [aux_sym_class_declaration_repeat2] = STATE(3105),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(1053),
    [anon_sym_unsafe] = ACTIONS(1055),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(1057),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_break] = ACTIONS(193),
    [anon_sym_unchecked] = ACTIONS(191),
    [anon_sym_continue] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_for] = ACTIONS(201),
    [anon_sym_lock] = ACTIONS(203),
    [anon_sym_yield] = ACTIONS(205),
    [anon_sym_switch] = ACTIONS(207),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(209),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(213),
    [anon_sym_foreach] = ACTIONS(215),
    [anon_sym_goto] = ACTIONS(217),
    [anon_sym_if] = ACTIONS(219),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [184] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6387),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8203),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(184),
    [sym_preproc_endregion] = STATE(184),
    [sym_preproc_line] = STATE(184),
    [sym_preproc_pragma] = STATE(184),
    [sym_preproc_nullable] = STATE(184),
    [sym_preproc_error] = STATE(184),
    [sym_preproc_define] = STATE(184),
    [sym_preproc_undef] = STATE(184),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1063),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [185] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym__variable_designation] = STATE(8618),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2787),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(185),
    [sym_preproc_endregion] = STATE(185),
    [sym_preproc_line] = STATE(185),
    [sym_preproc_pragma] = STATE(185),
    [sym_preproc_nullable] = STATE(185),
    [sym_preproc_error] = STATE(185),
    [sym_preproc_define] = STATE(185),
    [sym_preproc_undef] = STATE(185),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1131),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [186] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6387),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8120),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(186),
    [sym_preproc_endregion] = STATE(186),
    [sym_preproc_line] = STATE(186),
    [sym_preproc_pragma] = STATE(186),
    [sym_preproc_nullable] = STATE(186),
    [sym_preproc_error] = STATE(186),
    [sym_preproc_define] = STATE(186),
    [sym_preproc_undef] = STATE(186),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1139),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [187] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6387),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8051),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(187),
    [sym_preproc_endregion] = STATE(187),
    [sym_preproc_line] = STATE(187),
    [sym_preproc_pragma] = STATE(187),
    [sym_preproc_nullable] = STATE(187),
    [sym_preproc_error] = STATE(187),
    [sym_preproc_define] = STATE(187),
    [sym_preproc_undef] = STATE(187),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1143),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [188] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6387),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(7981),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(188),
    [sym_preproc_endregion] = STATE(188),
    [sym_preproc_line] = STATE(188),
    [sym_preproc_pragma] = STATE(188),
    [sym_preproc_nullable] = STATE(188),
    [sym_preproc_error] = STATE(188),
    [sym_preproc_define] = STATE(188),
    [sym_preproc_undef] = STATE(188),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [189] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6387),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5895),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8124),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6181),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(189),
    [sym_preproc_endregion] = STATE(189),
    [sym_preproc_line] = STATE(189),
    [sym_preproc_pragma] = STATE(189),
    [sym_preproc_nullable] = STATE(189),
    [sym_preproc_error] = STATE(189),
    [sym_preproc_define] = STATE(189),
    [sym_preproc_undef] = STATE(189),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [190] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym__variable_designation] = STATE(8618),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2787),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(190),
    [sym_preproc_endregion] = STATE(190),
    [sym_preproc_line] = STATE(190),
    [sym_preproc_pragma] = STATE(190),
    [sym_preproc_nullable] = STATE(190),
    [sym_preproc_error] = STATE(190),
    [sym_preproc_define] = STATE(190),
    [sym_preproc_undef] = STATE(190),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1131),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [191] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4533),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(191),
    [sym_preproc_endregion] = STATE(191),
    [sym_preproc_line] = STATE(191),
    [sym_preproc_pragma] = STATE(191),
    [sym_preproc_nullable] = STATE(191),
    [sym_preproc_error] = STATE(191),
    [sym_preproc_define] = STATE(191),
    [sym_preproc_undef] = STATE(191),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_if_token3] = ACTIONS(1155),
    [aux_sym_preproc_else_token1] = ACTIONS(1155),
    [aux_sym_preproc_elif_token1] = ACTIONS(1155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [192] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4474),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(192),
    [sym_preproc_endregion] = STATE(192),
    [sym_preproc_line] = STATE(192),
    [sym_preproc_pragma] = STATE(192),
    [sym_preproc_nullable] = STATE(192),
    [sym_preproc_error] = STATE(192),
    [sym_preproc_define] = STATE(192),
    [sym_preproc_undef] = STATE(192),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_if_token3] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [193] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5866),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(193),
    [sym_preproc_endregion] = STATE(193),
    [sym_preproc_line] = STATE(193),
    [sym_preproc_pragma] = STATE(193),
    [sym_preproc_nullable] = STATE(193),
    [sym_preproc_error] = STATE(193),
    [sym_preproc_define] = STATE(193),
    [sym_preproc_undef] = STATE(193),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [194] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6042),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(194),
    [sym_preproc_endregion] = STATE(194),
    [sym_preproc_line] = STATE(194),
    [sym_preproc_pragma] = STATE(194),
    [sym_preproc_nullable] = STATE(194),
    [sym_preproc_error] = STATE(194),
    [sym_preproc_define] = STATE(194),
    [sym_preproc_undef] = STATE(194),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [195] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5898),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8917),
    [sym_pattern] = STATE(8369),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8982),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(195),
    [sym_preproc_endregion] = STATE(195),
    [sym_preproc_line] = STATE(195),
    [sym_preproc_pragma] = STATE(195),
    [sym_preproc_nullable] = STATE(195),
    [sym_preproc_error] = STATE(195),
    [sym_preproc_define] = STATE(195),
    [sym_preproc_undef] = STATE(195),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [196] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5943),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(196),
    [sym_preproc_endregion] = STATE(196),
    [sym_preproc_line] = STATE(196),
    [sym_preproc_pragma] = STATE(196),
    [sym_preproc_nullable] = STATE(196),
    [sym_preproc_error] = STATE(196),
    [sym_preproc_define] = STATE(196),
    [sym_preproc_undef] = STATE(196),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [197] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5892),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(197),
    [sym_preproc_endregion] = STATE(197),
    [sym_preproc_line] = STATE(197),
    [sym_preproc_pragma] = STATE(197),
    [sym_preproc_nullable] = STATE(197),
    [sym_preproc_error] = STATE(197),
    [sym_preproc_define] = STATE(197),
    [sym_preproc_undef] = STATE(197),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [198] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5808),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(198),
    [sym_preproc_endregion] = STATE(198),
    [sym_preproc_line] = STATE(198),
    [sym_preproc_pragma] = STATE(198),
    [sym_preproc_nullable] = STATE(198),
    [sym_preproc_error] = STATE(198),
    [sym_preproc_define] = STATE(198),
    [sym_preproc_undef] = STATE(198),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [199] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5786),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(199),
    [sym_preproc_endregion] = STATE(199),
    [sym_preproc_line] = STATE(199),
    [sym_preproc_pragma] = STATE(199),
    [sym_preproc_nullable] = STATE(199),
    [sym_preproc_error] = STATE(199),
    [sym_preproc_define] = STATE(199),
    [sym_preproc_undef] = STATE(199),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [200] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5787),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(200),
    [sym_preproc_endregion] = STATE(200),
    [sym_preproc_line] = STATE(200),
    [sym_preproc_pragma] = STATE(200),
    [sym_preproc_nullable] = STATE(200),
    [sym_preproc_error] = STATE(200),
    [sym_preproc_define] = STATE(200),
    [sym_preproc_undef] = STATE(200),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [201] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5790),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(201),
    [sym_preproc_endregion] = STATE(201),
    [sym_preproc_line] = STATE(201),
    [sym_preproc_pragma] = STATE(201),
    [sym_preproc_nullable] = STATE(201),
    [sym_preproc_error] = STATE(201),
    [sym_preproc_define] = STATE(201),
    [sym_preproc_undef] = STATE(201),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [202] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(202),
    [sym_preproc_endregion] = STATE(202),
    [sym_preproc_line] = STATE(202),
    [sym_preproc_pragma] = STATE(202),
    [sym_preproc_nullable] = STATE(202),
    [sym_preproc_error] = STATE(202),
    [sym_preproc_define] = STATE(202),
    [sym_preproc_undef] = STATE(202),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [203] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5986),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(203),
    [sym_preproc_endregion] = STATE(203),
    [sym_preproc_line] = STATE(203),
    [sym_preproc_pragma] = STATE(203),
    [sym_preproc_nullable] = STATE(203),
    [sym_preproc_error] = STATE(203),
    [sym_preproc_define] = STATE(203),
    [sym_preproc_undef] = STATE(203),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [204] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6111),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(204),
    [sym_preproc_endregion] = STATE(204),
    [sym_preproc_line] = STATE(204),
    [sym_preproc_pragma] = STATE(204),
    [sym_preproc_nullable] = STATE(204),
    [sym_preproc_error] = STATE(204),
    [sym_preproc_define] = STATE(204),
    [sym_preproc_undef] = STATE(204),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [205] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5816),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(205),
    [sym_preproc_endregion] = STATE(205),
    [sym_preproc_line] = STATE(205),
    [sym_preproc_pragma] = STATE(205),
    [sym_preproc_nullable] = STATE(205),
    [sym_preproc_error] = STATE(205),
    [sym_preproc_define] = STATE(205),
    [sym_preproc_undef] = STATE(205),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [206] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5846),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8325),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(206),
    [sym_preproc_endregion] = STATE(206),
    [sym_preproc_line] = STATE(206),
    [sym_preproc_pragma] = STATE(206),
    [sym_preproc_nullable] = STATE(206),
    [sym_preproc_error] = STATE(206),
    [sym_preproc_define] = STATE(206),
    [sym_preproc_undef] = STATE(206),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [207] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(207),
    [sym_preproc_endregion] = STATE(207),
    [sym_preproc_line] = STATE(207),
    [sym_preproc_pragma] = STATE(207),
    [sym_preproc_nullable] = STATE(207),
    [sym_preproc_error] = STATE(207),
    [sym_preproc_define] = STATE(207),
    [sym_preproc_undef] = STATE(207),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [208] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8917),
    [sym_pattern] = STATE(8369),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8982),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(208),
    [sym_preproc_endregion] = STATE(208),
    [sym_preproc_line] = STATE(208),
    [sym_preproc_pragma] = STATE(208),
    [sym_preproc_nullable] = STATE(208),
    [sym_preproc_error] = STATE(208),
    [sym_preproc_define] = STATE(208),
    [sym_preproc_undef] = STATE(208),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [209] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(209),
    [sym_preproc_endregion] = STATE(209),
    [sym_preproc_line] = STATE(209),
    [sym_preproc_pragma] = STATE(209),
    [sym_preproc_nullable] = STATE(209),
    [sym_preproc_error] = STATE(209),
    [sym_preproc_define] = STATE(209),
    [sym_preproc_undef] = STATE(209),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [210] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6102),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(210),
    [sym_preproc_endregion] = STATE(210),
    [sym_preproc_line] = STATE(210),
    [sym_preproc_pragma] = STATE(210),
    [sym_preproc_nullable] = STATE(210),
    [sym_preproc_error] = STATE(210),
    [sym_preproc_define] = STATE(210),
    [sym_preproc_undef] = STATE(210),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [211] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5782),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8253),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(211),
    [sym_preproc_endregion] = STATE(211),
    [sym_preproc_line] = STATE(211),
    [sym_preproc_pragma] = STATE(211),
    [sym_preproc_nullable] = STATE(211),
    [sym_preproc_error] = STATE(211),
    [sym_preproc_define] = STATE(211),
    [sym_preproc_undef] = STATE(211),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [212] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5885),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(212),
    [sym_preproc_endregion] = STATE(212),
    [sym_preproc_line] = STATE(212),
    [sym_preproc_pragma] = STATE(212),
    [sym_preproc_nullable] = STATE(212),
    [sym_preproc_error] = STATE(212),
    [sym_preproc_define] = STATE(212),
    [sym_preproc_undef] = STATE(212),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [213] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5820),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(213),
    [sym_preproc_endregion] = STATE(213),
    [sym_preproc_line] = STATE(213),
    [sym_preproc_pragma] = STATE(213),
    [sym_preproc_nullable] = STATE(213),
    [sym_preproc_error] = STATE(213),
    [sym_preproc_define] = STATE(213),
    [sym_preproc_undef] = STATE(213),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [214] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(214),
    [sym_preproc_endregion] = STATE(214),
    [sym_preproc_line] = STATE(214),
    [sym_preproc_pragma] = STATE(214),
    [sym_preproc_nullable] = STATE(214),
    [sym_preproc_error] = STATE(214),
    [sym_preproc_define] = STATE(214),
    [sym_preproc_undef] = STATE(214),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [215] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6023),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(215),
    [sym_preproc_endregion] = STATE(215),
    [sym_preproc_line] = STATE(215),
    [sym_preproc_pragma] = STATE(215),
    [sym_preproc_nullable] = STATE(215),
    [sym_preproc_error] = STATE(215),
    [sym_preproc_define] = STATE(215),
    [sym_preproc_undef] = STATE(215),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [216] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5885),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(216),
    [sym_preproc_endregion] = STATE(216),
    [sym_preproc_line] = STATE(216),
    [sym_preproc_pragma] = STATE(216),
    [sym_preproc_nullable] = STATE(216),
    [sym_preproc_error] = STATE(216),
    [sym_preproc_define] = STATE(216),
    [sym_preproc_undef] = STATE(216),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [217] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(217),
    [sym_preproc_endregion] = STATE(217),
    [sym_preproc_line] = STATE(217),
    [sym_preproc_pragma] = STATE(217),
    [sym_preproc_nullable] = STATE(217),
    [sym_preproc_error] = STATE(217),
    [sym_preproc_define] = STATE(217),
    [sym_preproc_undef] = STATE(217),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [218] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8325),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(218),
    [sym_preproc_endregion] = STATE(218),
    [sym_preproc_line] = STATE(218),
    [sym_preproc_pragma] = STATE(218),
    [sym_preproc_nullable] = STATE(218),
    [sym_preproc_error] = STATE(218),
    [sym_preproc_define] = STATE(218),
    [sym_preproc_undef] = STATE(218),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [219] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(219),
    [sym_preproc_endregion] = STATE(219),
    [sym_preproc_line] = STATE(219),
    [sym_preproc_pragma] = STATE(219),
    [sym_preproc_nullable] = STATE(219),
    [sym_preproc_error] = STATE(219),
    [sym_preproc_define] = STATE(219),
    [sym_preproc_undef] = STATE(219),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [220] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5986),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8291),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(220),
    [sym_preproc_endregion] = STATE(220),
    [sym_preproc_line] = STATE(220),
    [sym_preproc_pragma] = STATE(220),
    [sym_preproc_nullable] = STATE(220),
    [sym_preproc_error] = STATE(220),
    [sym_preproc_define] = STATE(220),
    [sym_preproc_undef] = STATE(220),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [221] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5883),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_pattern] = STATE(8286),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6269),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4346),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(221),
    [sym_preproc_endregion] = STATE(221),
    [sym_preproc_line] = STATE(221),
    [sym_preproc_pragma] = STATE(221),
    [sym_preproc_nullable] = STATE(221),
    [sym_preproc_error] = STATE(221),
    [sym_preproc_define] = STATE(221),
    [sym_preproc_undef] = STATE(221),
    [aux_sym_class_declaration_repeat1] = STATE(3583),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_ref] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [222] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4927),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(222),
    [sym_preproc_endregion] = STATE(222),
    [sym_preproc_line] = STATE(222),
    [sym_preproc_pragma] = STATE(222),
    [sym_preproc_nullable] = STATE(222),
    [sym_preproc_error] = STATE(222),
    [sym_preproc_define] = STATE(222),
    [sym_preproc_undef] = STATE(222),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token3] = ACTIONS(1155),
    [aux_sym_preproc_else_token1] = ACTIONS(1155),
    [aux_sym_preproc_elif_token1] = ACTIONS(1155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [223] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6276),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym__variable_designation] = STATE(8618),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2791),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(223),
    [sym_preproc_endregion] = STATE(223),
    [sym_preproc_line] = STATE(223),
    [sym_preproc_pragma] = STATE(223),
    [sym_preproc_nullable] = STATE(223),
    [sym_preproc_error] = STATE(223),
    [sym_preproc_define] = STATE(223),
    [sym_preproc_undef] = STATE(223),
    [aux_sym_class_declaration_repeat1] = STATE(3568),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_ref] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1311),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1131),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [224] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4796),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(224),
    [sym_preproc_endregion] = STATE(224),
    [sym_preproc_line] = STATE(224),
    [sym_preproc_pragma] = STATE(224),
    [sym_preproc_nullable] = STATE(224),
    [sym_preproc_error] = STATE(224),
    [sym_preproc_define] = STATE(224),
    [sym_preproc_undef] = STATE(224),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_if_token3] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [225] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6276),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8732),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym__variable_designation] = STATE(8618),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2791),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(225),
    [sym_preproc_endregion] = STATE(225),
    [sym_preproc_line] = STATE(225),
    [sym_preproc_pragma] = STATE(225),
    [sym_preproc_nullable] = STATE(225),
    [sym_preproc_error] = STATE(225),
    [sym_preproc_define] = STATE(225),
    [sym_preproc_undef] = STATE(225),
    [aux_sym_class_declaration_repeat1] = STATE(3568),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_ref] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1311),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1131),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [226] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5123),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(226),
    [sym_preproc_endregion] = STATE(226),
    [sym_preproc_line] = STATE(226),
    [sym_preproc_pragma] = STATE(226),
    [sym_preproc_nullable] = STATE(226),
    [sym_preproc_error] = STATE(226),
    [sym_preproc_define] = STATE(226),
    [sym_preproc_undef] = STATE(226),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [227] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5127),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(227),
    [sym_preproc_endregion] = STATE(227),
    [sym_preproc_line] = STATE(227),
    [sym_preproc_pragma] = STATE(227),
    [sym_preproc_nullable] = STATE(227),
    [sym_preproc_error] = STATE(227),
    [sym_preproc_define] = STATE(227),
    [sym_preproc_undef] = STATE(227),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [228] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5148),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(228),
    [sym_preproc_endregion] = STATE(228),
    [sym_preproc_line] = STATE(228),
    [sym_preproc_pragma] = STATE(228),
    [sym_preproc_nullable] = STATE(228),
    [sym_preproc_error] = STATE(228),
    [sym_preproc_define] = STATE(228),
    [sym_preproc_undef] = STATE(228),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [229] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5168),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(229),
    [sym_preproc_endregion] = STATE(229),
    [sym_preproc_line] = STATE(229),
    [sym_preproc_pragma] = STATE(229),
    [sym_preproc_nullable] = STATE(229),
    [sym_preproc_error] = STATE(229),
    [sym_preproc_define] = STATE(229),
    [sym_preproc_undef] = STATE(229),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token3] = ACTIONS(1155),
    [aux_sym_preproc_else_token1] = ACTIONS(1155),
    [aux_sym_preproc_elif_token1] = ACTIONS(1155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [230] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5233),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(230),
    [sym_preproc_endregion] = STATE(230),
    [sym_preproc_line] = STATE(230),
    [sym_preproc_pragma] = STATE(230),
    [sym_preproc_nullable] = STATE(230),
    [sym_preproc_error] = STATE(230),
    [sym_preproc_define] = STATE(230),
    [sym_preproc_undef] = STATE(230),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_if_token3] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [231] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5170),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(231),
    [sym_preproc_endregion] = STATE(231),
    [sym_preproc_line] = STATE(231),
    [sym_preproc_pragma] = STATE(231),
    [sym_preproc_nullable] = STATE(231),
    [sym_preproc_error] = STATE(231),
    [sym_preproc_define] = STATE(231),
    [sym_preproc_undef] = STATE(231),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [232] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5107),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(232),
    [sym_preproc_endregion] = STATE(232),
    [sym_preproc_line] = STATE(232),
    [sym_preproc_pragma] = STATE(232),
    [sym_preproc_nullable] = STATE(232),
    [sym_preproc_error] = STATE(232),
    [sym_preproc_define] = STATE(232),
    [sym_preproc_undef] = STATE(232),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [233] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5089),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(233),
    [sym_preproc_endregion] = STATE(233),
    [sym_preproc_line] = STATE(233),
    [sym_preproc_pragma] = STATE(233),
    [sym_preproc_nullable] = STATE(233),
    [sym_preproc_error] = STATE(233),
    [sym_preproc_define] = STATE(233),
    [sym_preproc_undef] = STATE(233),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [234] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5372),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(234),
    [sym_preproc_endregion] = STATE(234),
    [sym_preproc_line] = STATE(234),
    [sym_preproc_pragma] = STATE(234),
    [sym_preproc_nullable] = STATE(234),
    [sym_preproc_error] = STATE(234),
    [sym_preproc_define] = STATE(234),
    [sym_preproc_undef] = STATE(234),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1417),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [235] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5359),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(235),
    [sym_preproc_endregion] = STATE(235),
    [sym_preproc_line] = STATE(235),
    [sym_preproc_pragma] = STATE(235),
    [sym_preproc_nullable] = STATE(235),
    [sym_preproc_error] = STATE(235),
    [sym_preproc_define] = STATE(235),
    [sym_preproc_undef] = STATE(235),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1417),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1155),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [236] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5186),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(236),
    [sym_preproc_endregion] = STATE(236),
    [sym_preproc_line] = STATE(236),
    [sym_preproc_pragma] = STATE(236),
    [sym_preproc_nullable] = STATE(236),
    [sym_preproc_error] = STATE(236),
    [sym_preproc_define] = STATE(236),
    [sym_preproc_undef] = STATE(236),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1155),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [237] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5178),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(237),
    [sym_preproc_endregion] = STATE(237),
    [sym_preproc_line] = STATE(237),
    [sym_preproc_pragma] = STATE(237),
    [sym_preproc_nullable] = STATE(237),
    [sym_preproc_error] = STATE(237),
    [sym_preproc_define] = STATE(237),
    [sym_preproc_undef] = STATE(237),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [238] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5258),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(238),
    [sym_preproc_endregion] = STATE(238),
    [sym_preproc_line] = STATE(238),
    [sym_preproc_pragma] = STATE(238),
    [sym_preproc_nullable] = STATE(238),
    [sym_preproc_error] = STATE(238),
    [sym_preproc_define] = STATE(238),
    [sym_preproc_undef] = STATE(238),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1497),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [239] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5356),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(239),
    [sym_preproc_endregion] = STATE(239),
    [sym_preproc_line] = STATE(239),
    [sym_preproc_pragma] = STATE(239),
    [sym_preproc_nullable] = STATE(239),
    [sym_preproc_error] = STATE(239),
    [sym_preproc_define] = STATE(239),
    [sym_preproc_undef] = STATE(239),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1497),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [240] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5649),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(240),
    [sym_preproc_endregion] = STATE(240),
    [sym_preproc_line] = STATE(240),
    [sym_preproc_pragma] = STATE(240),
    [sym_preproc_nullable] = STATE(240),
    [sym_preproc_error] = STATE(240),
    [sym_preproc_define] = STATE(240),
    [sym_preproc_undef] = STATE(240),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(1155),
    [aux_sym_preproc_else_token1] = ACTIONS(1155),
    [aux_sym_preproc_elif_token1] = ACTIONS(1155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [241] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(241),
    [sym_preproc_endregion] = STATE(241),
    [sym_preproc_line] = STATE(241),
    [sym_preproc_pragma] = STATE(241),
    [sym_preproc_nullable] = STATE(241),
    [sym_preproc_error] = STATE(241),
    [sym_preproc_define] = STATE(241),
    [sym_preproc_undef] = STATE(241),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [242] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5675),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(242),
    [sym_preproc_endregion] = STATE(242),
    [sym_preproc_line] = STATE(242),
    [sym_preproc_pragma] = STATE(242),
    [sym_preproc_nullable] = STATE(242),
    [sym_preproc_error] = STATE(242),
    [sym_preproc_define] = STATE(242),
    [sym_preproc_undef] = STATE(242),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [243] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5446),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(243),
    [sym_preproc_endregion] = STATE(243),
    [sym_preproc_line] = STATE(243),
    [sym_preproc_pragma] = STATE(243),
    [sym_preproc_nullable] = STATE(243),
    [sym_preproc_error] = STATE(243),
    [sym_preproc_define] = STATE(243),
    [sym_preproc_undef] = STATE(243),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1155),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [244] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5628),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(244),
    [sym_preproc_endregion] = STATE(244),
    [sym_preproc_line] = STATE(244),
    [sym_preproc_pragma] = STATE(244),
    [sym_preproc_nullable] = STATE(244),
    [sym_preproc_error] = STATE(244),
    [sym_preproc_define] = STATE(244),
    [sym_preproc_undef] = STATE(244),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [245] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5416),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(245),
    [sym_preproc_endregion] = STATE(245),
    [sym_preproc_line] = STATE(245),
    [sym_preproc_pragma] = STATE(245),
    [sym_preproc_nullable] = STATE(245),
    [sym_preproc_error] = STATE(245),
    [sym_preproc_define] = STATE(245),
    [sym_preproc_undef] = STATE(245),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [246] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5619),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(246),
    [sym_preproc_endregion] = STATE(246),
    [sym_preproc_line] = STATE(246),
    [sym_preproc_pragma] = STATE(246),
    [sym_preproc_nullable] = STATE(246),
    [sym_preproc_error] = STATE(246),
    [sym_preproc_define] = STATE(246),
    [sym_preproc_undef] = STATE(246),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [247] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5845),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(247),
    [sym_preproc_endregion] = STATE(247),
    [sym_preproc_line] = STATE(247),
    [sym_preproc_pragma] = STATE(247),
    [sym_preproc_nullable] = STATE(247),
    [sym_preproc_error] = STATE(247),
    [sym_preproc_define] = STATE(247),
    [sym_preproc_undef] = STATE(247),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1561),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [248] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5832),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(248),
    [sym_preproc_endregion] = STATE(248),
    [sym_preproc_line] = STATE(248),
    [sym_preproc_pragma] = STATE(248),
    [sym_preproc_nullable] = STATE(248),
    [sym_preproc_error] = STATE(248),
    [sym_preproc_define] = STATE(248),
    [sym_preproc_undef] = STATE(248),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [249] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(249),
    [sym_preproc_endregion] = STATE(249),
    [sym_preproc_line] = STATE(249),
    [sym_preproc_pragma] = STATE(249),
    [sym_preproc_nullable] = STATE(249),
    [sym_preproc_error] = STATE(249),
    [sym_preproc_define] = STATE(249),
    [sym_preproc_undef] = STATE(249),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_list_pattern_repeat1] = STATE(8688),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [250] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5565),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(250),
    [sym_preproc_endregion] = STATE(250),
    [sym_preproc_line] = STATE(250),
    [sym_preproc_pragma] = STATE(250),
    [sym_preproc_nullable] = STATE(250),
    [sym_preproc_error] = STATE(250),
    [sym_preproc_define] = STATE(250),
    [sym_preproc_undef] = STATE(250),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [251] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6105),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(251),
    [sym_preproc_endregion] = STATE(251),
    [sym_preproc_line] = STATE(251),
    [sym_preproc_pragma] = STATE(251),
    [sym_preproc_nullable] = STATE(251),
    [sym_preproc_error] = STATE(251),
    [sym_preproc_define] = STATE(251),
    [sym_preproc_undef] = STATE(251),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1155),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(695),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [252] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5970),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(252),
    [sym_preproc_endregion] = STATE(252),
    [sym_preproc_line] = STATE(252),
    [sym_preproc_pragma] = STATE(252),
    [sym_preproc_nullable] = STATE(252),
    [sym_preproc_error] = STATE(252),
    [sym_preproc_define] = STATE(252),
    [sym_preproc_undef] = STATE(252),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [253] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(253),
    [sym_preproc_endregion] = STATE(253),
    [sym_preproc_line] = STATE(253),
    [sym_preproc_pragma] = STATE(253),
    [sym_preproc_nullable] = STATE(253),
    [sym_preproc_error] = STATE(253),
    [sym_preproc_define] = STATE(253),
    [sym_preproc_undef] = STATE(253),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_list_pattern_repeat1] = STATE(8669),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [254] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(254),
    [sym_preproc_endregion] = STATE(254),
    [sym_preproc_line] = STATE(254),
    [sym_preproc_pragma] = STATE(254),
    [sym_preproc_nullable] = STATE(254),
    [sym_preproc_error] = STATE(254),
    [sym_preproc_define] = STATE(254),
    [sym_preproc_undef] = STATE(254),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_list_pattern_repeat1] = STATE(8587),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [255] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6108),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(255),
    [sym_preproc_endregion] = STATE(255),
    [sym_preproc_line] = STATE(255),
    [sym_preproc_pragma] = STATE(255),
    [sym_preproc_nullable] = STATE(255),
    [sym_preproc_error] = STATE(255),
    [sym_preproc_define] = STATE(255),
    [sym_preproc_undef] = STATE(255),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [256] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5860),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(256),
    [sym_preproc_endregion] = STATE(256),
    [sym_preproc_line] = STATE(256),
    [sym_preproc_pragma] = STATE(256),
    [sym_preproc_nullable] = STATE(256),
    [sym_preproc_error] = STATE(256),
    [sym_preproc_define] = STATE(256),
    [sym_preproc_undef] = STATE(256),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [257] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5902),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(257),
    [sym_preproc_endregion] = STATE(257),
    [sym_preproc_line] = STATE(257),
    [sym_preproc_pragma] = STATE(257),
    [sym_preproc_nullable] = STATE(257),
    [sym_preproc_error] = STATE(257),
    [sym_preproc_define] = STATE(257),
    [sym_preproc_undef] = STATE(257),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(1155),
    [aux_sym_preproc_else_token1] = ACTIONS(1155),
    [aux_sym_preproc_elif_token1] = ACTIONS(1155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [258] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4494),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(258),
    [sym_preproc_endregion] = STATE(258),
    [sym_preproc_line] = STATE(258),
    [sym_preproc_pragma] = STATE(258),
    [sym_preproc_nullable] = STATE(258),
    [sym_preproc_error] = STATE(258),
    [sym_preproc_define] = STATE(258),
    [sym_preproc_undef] = STATE(258),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1651),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1651),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [259] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5282),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(259),
    [sym_preproc_endregion] = STATE(259),
    [sym_preproc_line] = STATE(259),
    [sym_preproc_pragma] = STATE(259),
    [sym_preproc_nullable] = STATE(259),
    [sym_preproc_error] = STATE(259),
    [sym_preproc_define] = STATE(259),
    [sym_preproc_undef] = STATE(259),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [260] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4459),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(260),
    [sym_preproc_endregion] = STATE(260),
    [sym_preproc_line] = STATE(260),
    [sym_preproc_pragma] = STATE(260),
    [sym_preproc_nullable] = STATE(260),
    [sym_preproc_error] = STATE(260),
    [sym_preproc_define] = STATE(260),
    [sym_preproc_undef] = STATE(260),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1651),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1651),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [261] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5878),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(261),
    [sym_preproc_endregion] = STATE(261),
    [sym_preproc_line] = STATE(261),
    [sym_preproc_pragma] = STATE(261),
    [sym_preproc_nullable] = STATE(261),
    [sym_preproc_error] = STATE(261),
    [sym_preproc_define] = STATE(261),
    [sym_preproc_undef] = STATE(261),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1561),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [262] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5388),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(262),
    [sym_preproc_endregion] = STATE(262),
    [sym_preproc_line] = STATE(262),
    [sym_preproc_pragma] = STATE(262),
    [sym_preproc_nullable] = STATE(262),
    [sym_preproc_error] = STATE(262),
    [sym_preproc_define] = STATE(262),
    [sym_preproc_undef] = STATE(262),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [263] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5561),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(263),
    [sym_preproc_endregion] = STATE(263),
    [sym_preproc_line] = STATE(263),
    [sym_preproc_pragma] = STATE(263),
    [sym_preproc_nullable] = STATE(263),
    [sym_preproc_error] = STATE(263),
    [sym_preproc_define] = STATE(263),
    [sym_preproc_undef] = STATE(263),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [264] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5447),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(264),
    [sym_preproc_endregion] = STATE(264),
    [sym_preproc_line] = STATE(264),
    [sym_preproc_pragma] = STATE(264),
    [sym_preproc_nullable] = STATE(264),
    [sym_preproc_error] = STATE(264),
    [sym_preproc_define] = STATE(264),
    [sym_preproc_undef] = STATE(264),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [265] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5575),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(265),
    [sym_preproc_endregion] = STATE(265),
    [sym_preproc_line] = STATE(265),
    [sym_preproc_pragma] = STATE(265),
    [sym_preproc_nullable] = STATE(265),
    [sym_preproc_error] = STATE(265),
    [sym_preproc_define] = STATE(265),
    [sym_preproc_undef] = STATE(265),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1543),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [266] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5350),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(266),
    [sym_preproc_endregion] = STATE(266),
    [sym_preproc_line] = STATE(266),
    [sym_preproc_pragma] = STATE(266),
    [sym_preproc_nullable] = STATE(266),
    [sym_preproc_error] = STATE(266),
    [sym_preproc_define] = STATE(266),
    [sym_preproc_undef] = STATE(266),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [267] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5897),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(267),
    [sym_preproc_endregion] = STATE(267),
    [sym_preproc_line] = STATE(267),
    [sym_preproc_pragma] = STATE(267),
    [sym_preproc_nullable] = STATE(267),
    [sym_preproc_error] = STATE(267),
    [sym_preproc_define] = STATE(267),
    [sym_preproc_undef] = STATE(267),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [268] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6052),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(268),
    [sym_preproc_endregion] = STATE(268),
    [sym_preproc_line] = STATE(268),
    [sym_preproc_pragma] = STATE(268),
    [sym_preproc_nullable] = STATE(268),
    [sym_preproc_error] = STATE(268),
    [sym_preproc_define] = STATE(268),
    [sym_preproc_undef] = STATE(268),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(1225),
    [aux_sym_preproc_else_token1] = ACTIONS(1225),
    [aux_sym_preproc_elif_token1] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [269] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5473),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(269),
    [sym_preproc_endregion] = STATE(269),
    [sym_preproc_line] = STATE(269),
    [sym_preproc_pragma] = STATE(269),
    [sym_preproc_nullable] = STATE(269),
    [sym_preproc_error] = STATE(269),
    [sym_preproc_define] = STATE(269),
    [sym_preproc_undef] = STATE(269),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [270] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6030),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(270),
    [sym_preproc_endregion] = STATE(270),
    [sym_preproc_line] = STATE(270),
    [sym_preproc_pragma] = STATE(270),
    [sym_preproc_nullable] = STATE(270),
    [sym_preproc_error] = STATE(270),
    [sym_preproc_define] = STATE(270),
    [sym_preproc_undef] = STATE(270),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1771),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1225),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [271] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4441),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(271),
    [sym_preproc_endregion] = STATE(271),
    [sym_preproc_line] = STATE(271),
    [sym_preproc_pragma] = STATE(271),
    [sym_preproc_nullable] = STATE(271),
    [sym_preproc_error] = STATE(271),
    [sym_preproc_define] = STATE(271),
    [sym_preproc_undef] = STATE(271),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1787),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [272] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5852),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(272),
    [sym_preproc_endregion] = STATE(272),
    [sym_preproc_line] = STATE(272),
    [sym_preproc_pragma] = STATE(272),
    [sym_preproc_nullable] = STATE(272),
    [sym_preproc_error] = STATE(272),
    [sym_preproc_define] = STATE(272),
    [sym_preproc_undef] = STATE(272),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1771),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1155),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [273] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5564),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(273),
    [sym_preproc_endregion] = STATE(273),
    [sym_preproc_line] = STATE(273),
    [sym_preproc_pragma] = STATE(273),
    [sym_preproc_nullable] = STATE(273),
    [sym_preproc_error] = STATE(273),
    [sym_preproc_define] = STATE(273),
    [sym_preproc_undef] = STATE(273),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_interpolation_close_brace] = ACTIONS(1155),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [274] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4427),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(274),
    [sym_preproc_endregion] = STATE(274),
    [sym_preproc_line] = STATE(274),
    [sym_preproc_pragma] = STATE(274),
    [sym_preproc_nullable] = STATE(274),
    [sym_preproc_error] = STATE(274),
    [sym_preproc_define] = STATE(274),
    [sym_preproc_undef] = STATE(274),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1787),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [275] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(275),
    [sym_preproc_endregion] = STATE(275),
    [sym_preproc_line] = STATE(275),
    [sym_preproc_pragma] = STATE(275),
    [sym_preproc_nullable] = STATE(275),
    [sym_preproc_error] = STATE(275),
    [sym_preproc_define] = STATE(275),
    [sym_preproc_undef] = STATE(275),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_list_pattern_repeat1] = STATE(8599),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [276] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(276),
    [sym_preproc_endregion] = STATE(276),
    [sym_preproc_line] = STATE(276),
    [sym_preproc_pragma] = STATE(276),
    [sym_preproc_nullable] = STATE(276),
    [sym_preproc_error] = STATE(276),
    [sym_preproc_define] = STATE(276),
    [sym_preproc_undef] = STATE(276),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_list_pattern_repeat1] = STATE(8417),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_RBRACK] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [277] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5378),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(277),
    [sym_preproc_endregion] = STATE(277),
    [sym_preproc_line] = STATE(277),
    [sym_preproc_pragma] = STATE(277),
    [sym_preproc_nullable] = STATE(277),
    [sym_preproc_error] = STATE(277),
    [sym_preproc_define] = STATE(277),
    [sym_preproc_undef] = STATE(277),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [278] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5454),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(278),
    [sym_preproc_endregion] = STATE(278),
    [sym_preproc_line] = STATE(278),
    [sym_preproc_pragma] = STATE(278),
    [sym_preproc_nullable] = STATE(278),
    [sym_preproc_error] = STATE(278),
    [sym_preproc_define] = STATE(278),
    [sym_preproc_undef] = STATE(278),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [279] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6048),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(279),
    [sym_preproc_endregion] = STATE(279),
    [sym_preproc_line] = STATE(279),
    [sym_preproc_pragma] = STATE(279),
    [sym_preproc_nullable] = STATE(279),
    [sym_preproc_error] = STATE(279),
    [sym_preproc_define] = STATE(279),
    [sym_preproc_undef] = STATE(279),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [280] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5590),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(280),
    [sym_preproc_endregion] = STATE(280),
    [sym_preproc_line] = STATE(280),
    [sym_preproc_pragma] = STATE(280),
    [sym_preproc_nullable] = STATE(280),
    [sym_preproc_error] = STATE(280),
    [sym_preproc_define] = STATE(280),
    [sym_preproc_undef] = STATE(280),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [281] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6040),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(281),
    [sym_preproc_endregion] = STATE(281),
    [sym_preproc_line] = STATE(281),
    [sym_preproc_pragma] = STATE(281),
    [sym_preproc_nullable] = STATE(281),
    [sym_preproc_error] = STATE(281),
    [sym_preproc_define] = STATE(281),
    [sym_preproc_undef] = STATE(281),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1805),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1805),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [282] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5983),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(282),
    [sym_preproc_endregion] = STATE(282),
    [sym_preproc_line] = STATE(282),
    [sym_preproc_pragma] = STATE(282),
    [sym_preproc_nullable] = STATE(282),
    [sym_preproc_error] = STATE(282),
    [sym_preproc_define] = STATE(282),
    [sym_preproc_undef] = STATE(282),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1841),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [283] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4914),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(283),
    [sym_preproc_endregion] = STATE(283),
    [sym_preproc_line] = STATE(283),
    [sym_preproc_pragma] = STATE(283),
    [sym_preproc_nullable] = STATE(283),
    [sym_preproc_error] = STATE(283),
    [sym_preproc_define] = STATE(283),
    [sym_preproc_undef] = STATE(283),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [284] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6018),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(284),
    [sym_preproc_endregion] = STATE(284),
    [sym_preproc_line] = STATE(284),
    [sym_preproc_pragma] = STATE(284),
    [sym_preproc_nullable] = STATE(284),
    [sym_preproc_error] = STATE(284),
    [sym_preproc_define] = STATE(284),
    [sym_preproc_undef] = STATE(284),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [285] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5918),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(285),
    [sym_preproc_endregion] = STATE(285),
    [sym_preproc_line] = STATE(285),
    [sym_preproc_pragma] = STATE(285),
    [sym_preproc_nullable] = STATE(285),
    [sym_preproc_error] = STATE(285),
    [sym_preproc_define] = STATE(285),
    [sym_preproc_undef] = STATE(285),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1877),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [286] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5902),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(286),
    [sym_preproc_endregion] = STATE(286),
    [sym_preproc_line] = STATE(286),
    [sym_preproc_pragma] = STATE(286),
    [sym_preproc_nullable] = STATE(286),
    [sym_preproc_error] = STATE(286),
    [sym_preproc_define] = STATE(286),
    [sym_preproc_undef] = STATE(286),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1889),
    [anon_sym_RBRACK] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [287] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5724),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(287),
    [sym_preproc_endregion] = STATE(287),
    [sym_preproc_line] = STATE(287),
    [sym_preproc_pragma] = STATE(287),
    [sym_preproc_nullable] = STATE(287),
    [sym_preproc_error] = STATE(287),
    [sym_preproc_define] = STATE(287),
    [sym_preproc_undef] = STATE(287),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1897),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [288] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5441),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(288),
    [sym_preproc_endregion] = STATE(288),
    [sym_preproc_line] = STATE(288),
    [sym_preproc_pragma] = STATE(288),
    [sym_preproc_nullable] = STATE(288),
    [sym_preproc_error] = STATE(288),
    [sym_preproc_define] = STATE(288),
    [sym_preproc_undef] = STATE(288),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [289] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4947),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(289),
    [sym_preproc_endregion] = STATE(289),
    [sym_preproc_line] = STATE(289),
    [sym_preproc_pragma] = STATE(289),
    [sym_preproc_nullable] = STATE(289),
    [sym_preproc_error] = STATE(289),
    [sym_preproc_define] = STATE(289),
    [sym_preproc_undef] = STATE(289),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [290] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5458),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(290),
    [sym_preproc_endregion] = STATE(290),
    [sym_preproc_line] = STATE(290),
    [sym_preproc_pragma] = STATE(290),
    [sym_preproc_nullable] = STATE(290),
    [sym_preproc_error] = STATE(290),
    [sym_preproc_define] = STATE(290),
    [sym_preproc_undef] = STATE(290),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1897),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [291] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5793),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(291),
    [sym_preproc_endregion] = STATE(291),
    [sym_preproc_line] = STATE(291),
    [sym_preproc_pragma] = STATE(291),
    [sym_preproc_nullable] = STATE(291),
    [sym_preproc_error] = STATE(291),
    [sym_preproc_define] = STATE(291),
    [sym_preproc_undef] = STATE(291),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1841),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [292] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5444),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(292),
    [sym_preproc_endregion] = STATE(292),
    [sym_preproc_line] = STATE(292),
    [sym_preproc_pragma] = STATE(292),
    [sym_preproc_nullable] = STATE(292),
    [sym_preproc_error] = STATE(292),
    [sym_preproc_define] = STATE(292),
    [sym_preproc_undef] = STATE(292),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1933),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [293] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4979),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(293),
    [sym_preproc_endregion] = STATE(293),
    [sym_preproc_line] = STATE(293),
    [sym_preproc_pragma] = STATE(293),
    [sym_preproc_nullable] = STATE(293),
    [sym_preproc_error] = STATE(293),
    [sym_preproc_define] = STATE(293),
    [sym_preproc_undef] = STATE(293),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1915),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [294] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5468),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(294),
    [sym_preproc_endregion] = STATE(294),
    [sym_preproc_line] = STATE(294),
    [sym_preproc_pragma] = STATE(294),
    [sym_preproc_nullable] = STATE(294),
    [sym_preproc_error] = STATE(294),
    [sym_preproc_define] = STATE(294),
    [sym_preproc_undef] = STATE(294),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1933),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [295] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4867),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(295),
    [sym_preproc_endregion] = STATE(295),
    [sym_preproc_line] = STATE(295),
    [sym_preproc_pragma] = STATE(295),
    [sym_preproc_nullable] = STATE(295),
    [sym_preproc_error] = STATE(295),
    [sym_preproc_define] = STATE(295),
    [sym_preproc_undef] = STATE(295),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [296] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6411),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(296),
    [sym_preproc_endregion] = STATE(296),
    [sym_preproc_line] = STATE(296),
    [sym_preproc_pragma] = STATE(296),
    [sym_preproc_nullable] = STATE(296),
    [sym_preproc_error] = STATE(296),
    [sym_preproc_define] = STATE(296),
    [sym_preproc_undef] = STATE(296),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COLON] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [297] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5926),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8594),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(5608),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(297),
    [sym_preproc_endregion] = STATE(297),
    [sym_preproc_line] = STATE(297),
    [sym_preproc_pragma] = STATE(297),
    [sym_preproc_nullable] = STATE(297),
    [sym_preproc_error] = STATE(297),
    [sym_preproc_define] = STATE(297),
    [sym_preproc_undef] = STATE(297),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [298] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6614),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(298),
    [sym_preproc_endregion] = STATE(298),
    [sym_preproc_line] = STATE(298),
    [sym_preproc_pragma] = STATE(298),
    [sym_preproc_nullable] = STATE(298),
    [sym_preproc_error] = STATE(298),
    [sym_preproc_define] = STATE(298),
    [sym_preproc_undef] = STATE(298),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [299] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(299),
    [sym_preproc_endregion] = STATE(299),
    [sym_preproc_line] = STATE(299),
    [sym_preproc_pragma] = STATE(299),
    [sym_preproc_nullable] = STATE(299),
    [sym_preproc_error] = STATE(299),
    [sym_preproc_define] = STATE(299),
    [sym_preproc_undef] = STATE(299),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1967),
    [anon_sym_BANG_EQ] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1969),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_QMARK_QMARK] = ACTIONS(1967),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1969),
    [anon_sym_is] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1967),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [300] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5926),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8645),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(5608),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(300),
    [sym_preproc_endregion] = STATE(300),
    [sym_preproc_line] = STATE(300),
    [sym_preproc_pragma] = STATE(300),
    [sym_preproc_nullable] = STATE(300),
    [sym_preproc_error] = STATE(300),
    [sym_preproc_define] = STATE(300),
    [sym_preproc_undef] = STATE(300),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1971),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [301] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5926),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8645),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(5608),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(301),
    [sym_preproc_endregion] = STATE(301),
    [sym_preproc_line] = STATE(301),
    [sym_preproc_pragma] = STATE(301),
    [sym_preproc_nullable] = STATE(301),
    [sym_preproc_error] = STATE(301),
    [sym_preproc_define] = STATE(301),
    [sym_preproc_undef] = STATE(301),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [302] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6559),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(302),
    [sym_preproc_endregion] = STATE(302),
    [sym_preproc_line] = STATE(302),
    [sym_preproc_pragma] = STATE(302),
    [sym_preproc_nullable] = STATE(302),
    [sym_preproc_error] = STATE(302),
    [sym_preproc_define] = STATE(302),
    [sym_preproc_undef] = STATE(302),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [303] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6352),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(303),
    [sym_preproc_endregion] = STATE(303),
    [sym_preproc_line] = STATE(303),
    [sym_preproc_pragma] = STATE(303),
    [sym_preproc_nullable] = STATE(303),
    [sym_preproc_error] = STATE(303),
    [sym_preproc_define] = STATE(303),
    [sym_preproc_undef] = STATE(303),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [304] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8579),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(304),
    [sym_preproc_endregion] = STATE(304),
    [sym_preproc_line] = STATE(304),
    [sym_preproc_pragma] = STATE(304),
    [sym_preproc_nullable] = STATE(304),
    [sym_preproc_error] = STATE(304),
    [sym_preproc_define] = STATE(304),
    [sym_preproc_undef] = STATE(304),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2003),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [305] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6300),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(305),
    [sym_preproc_endregion] = STATE(305),
    [sym_preproc_line] = STATE(305),
    [sym_preproc_pragma] = STATE(305),
    [sym_preproc_nullable] = STATE(305),
    [sym_preproc_error] = STATE(305),
    [sym_preproc_define] = STATE(305),
    [sym_preproc_undef] = STATE(305),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [306] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8677),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(306),
    [sym_preproc_endregion] = STATE(306),
    [sym_preproc_line] = STATE(306),
    [sym_preproc_pragma] = STATE(306),
    [sym_preproc_nullable] = STATE(306),
    [sym_preproc_error] = STATE(306),
    [sym_preproc_define] = STATE(306),
    [sym_preproc_undef] = STATE(306),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2031),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [307] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6555),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(307),
    [sym_preproc_endregion] = STATE(307),
    [sym_preproc_line] = STATE(307),
    [sym_preproc_pragma] = STATE(307),
    [sym_preproc_nullable] = STATE(307),
    [sym_preproc_error] = STATE(307),
    [sym_preproc_define] = STATE(307),
    [sym_preproc_undef] = STATE(307),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [308] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6225),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(308),
    [sym_preproc_endregion] = STATE(308),
    [sym_preproc_line] = STATE(308),
    [sym_preproc_pragma] = STATE(308),
    [sym_preproc_nullable] = STATE(308),
    [sym_preproc_error] = STATE(308),
    [sym_preproc_define] = STATE(308),
    [sym_preproc_undef] = STATE(308),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2017),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [309] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6473),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(309),
    [sym_preproc_endregion] = STATE(309),
    [sym_preproc_line] = STATE(309),
    [sym_preproc_pragma] = STATE(309),
    [sym_preproc_nullable] = STATE(309),
    [sym_preproc_error] = STATE(309),
    [sym_preproc_define] = STATE(309),
    [sym_preproc_undef] = STATE(309),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1983),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [310] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2806),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5926),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8645),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(5608),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(310),
    [sym_preproc_endregion] = STATE(310),
    [sym_preproc_line] = STATE(310),
    [sym_preproc_pragma] = STATE(310),
    [sym_preproc_nullable] = STATE(310),
    [sym_preproc_error] = STATE(310),
    [sym_preproc_define] = STATE(310),
    [sym_preproc_undef] = STATE(310),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2035),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2037),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [311] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4726),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(311),
    [sym_preproc_endregion] = STATE(311),
    [sym_preproc_line] = STATE(311),
    [sym_preproc_pragma] = STATE(311),
    [sym_preproc_nullable] = STATE(311),
    [sym_preproc_error] = STATE(311),
    [sym_preproc_define] = STATE(311),
    [sym_preproc_undef] = STATE(311),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [312] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4671),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(312),
    [sym_preproc_endregion] = STATE(312),
    [sym_preproc_line] = STATE(312),
    [sym_preproc_pragma] = STATE(312),
    [sym_preproc_nullable] = STATE(312),
    [sym_preproc_error] = STATE(312),
    [sym_preproc_define] = STATE(312),
    [sym_preproc_undef] = STATE(312),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2043),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2043),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [313] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4785),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(313),
    [sym_preproc_endregion] = STATE(313),
    [sym_preproc_line] = STATE(313),
    [sym_preproc_pragma] = STATE(313),
    [sym_preproc_nullable] = STATE(313),
    [sym_preproc_error] = STATE(313),
    [sym_preproc_define] = STATE(313),
    [sym_preproc_undef] = STATE(313),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [314] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8584),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(314),
    [sym_preproc_endregion] = STATE(314),
    [sym_preproc_line] = STATE(314),
    [sym_preproc_pragma] = STATE(314),
    [sym_preproc_nullable] = STATE(314),
    [sym_preproc_error] = STATE(314),
    [sym_preproc_define] = STATE(314),
    [sym_preproc_undef] = STATE(314),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2067),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [315] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(315),
    [sym_preproc_endregion] = STATE(315),
    [sym_preproc_line] = STATE(315),
    [sym_preproc_pragma] = STATE(315),
    [sym_preproc_nullable] = STATE(315),
    [sym_preproc_error] = STATE(315),
    [sym_preproc_define] = STATE(315),
    [sym_preproc_undef] = STATE(315),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(77),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1963),
    [anon_sym_is] = ACTIONS(1963),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1963),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [316] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8597),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(316),
    [sym_preproc_endregion] = STATE(316),
    [sym_preproc_line] = STATE(316),
    [sym_preproc_pragma] = STATE(316),
    [sym_preproc_nullable] = STATE(316),
    [sym_preproc_error] = STATE(316),
    [sym_preproc_define] = STATE(316),
    [sym_preproc_undef] = STATE(316),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2073),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [317] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6465),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(317),
    [sym_preproc_endregion] = STATE(317),
    [sym_preproc_line] = STATE(317),
    [sym_preproc_pragma] = STATE(317),
    [sym_preproc_nullable] = STATE(317),
    [sym_preproc_error] = STATE(317),
    [sym_preproc_define] = STATE(317),
    [sym_preproc_undef] = STATE(317),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2081),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [318] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8432),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(318),
    [sym_preproc_endregion] = STATE(318),
    [sym_preproc_line] = STATE(318),
    [sym_preproc_pragma] = STATE(318),
    [sym_preproc_nullable] = STATE(318),
    [sym_preproc_error] = STATE(318),
    [sym_preproc_define] = STATE(318),
    [sym_preproc_undef] = STATE(318),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2091),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [319] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6377),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(319),
    [sym_preproc_endregion] = STATE(319),
    [sym_preproc_line] = STATE(319),
    [sym_preproc_pragma] = STATE(319),
    [sym_preproc_nullable] = STATE(319),
    [sym_preproc_error] = STATE(319),
    [sym_preproc_define] = STATE(319),
    [sym_preproc_undef] = STATE(319),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [320] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8594),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(320),
    [sym_preproc_endregion] = STATE(320),
    [sym_preproc_line] = STATE(320),
    [sym_preproc_pragma] = STATE(320),
    [sym_preproc_nullable] = STATE(320),
    [sym_preproc_error] = STATE(320),
    [sym_preproc_define] = STATE(320),
    [sym_preproc_undef] = STATE(320),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2099),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [321] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6457),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(321),
    [sym_preproc_endregion] = STATE(321),
    [sym_preproc_line] = STATE(321),
    [sym_preproc_pragma] = STATE(321),
    [sym_preproc_nullable] = STATE(321),
    [sym_preproc_error] = STATE(321),
    [sym_preproc_define] = STATE(321),
    [sym_preproc_undef] = STATE(321),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2081),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [322] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8645),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(322),
    [sym_preproc_endregion] = STATE(322),
    [sym_preproc_line] = STATE(322),
    [sym_preproc_pragma] = STATE(322),
    [sym_preproc_nullable] = STATE(322),
    [sym_preproc_error] = STATE(322),
    [sym_preproc_define] = STATE(322),
    [sym_preproc_undef] = STATE(322),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2101),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2103),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [323] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4791),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(323),
    [sym_preproc_endregion] = STATE(323),
    [sym_preproc_line] = STATE(323),
    [sym_preproc_pragma] = STATE(323),
    [sym_preproc_nullable] = STATE(323),
    [sym_preproc_error] = STATE(323),
    [sym_preproc_define] = STATE(323),
    [sym_preproc_undef] = STATE(323),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2057),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [324] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8554),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(324),
    [sym_preproc_endregion] = STATE(324),
    [sym_preproc_line] = STATE(324),
    [sym_preproc_pragma] = STATE(324),
    [sym_preproc_nullable] = STATE(324),
    [sym_preproc_error] = STATE(324),
    [sym_preproc_define] = STATE(324),
    [sym_preproc_undef] = STATE(324),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [325] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6199),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(325),
    [sym_preproc_endregion] = STATE(325),
    [sym_preproc_line] = STATE(325),
    [sym_preproc_pragma] = STATE(325),
    [sym_preproc_nullable] = STATE(325),
    [sym_preproc_error] = STATE(325),
    [sym_preproc_define] = STATE(325),
    [sym_preproc_undef] = STATE(325),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [326] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6599),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(326),
    [sym_preproc_endregion] = STATE(326),
    [sym_preproc_line] = STATE(326),
    [sym_preproc_pragma] = STATE(326),
    [sym_preproc_nullable] = STATE(326),
    [sym_preproc_error] = STATE(326),
    [sym_preproc_define] = STATE(326),
    [sym_preproc_undef] = STATE(326),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [327] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(327),
    [sym_preproc_endregion] = STATE(327),
    [sym_preproc_line] = STATE(327),
    [sym_preproc_pragma] = STATE(327),
    [sym_preproc_nullable] = STATE(327),
    [sym_preproc_error] = STATE(327),
    [sym_preproc_define] = STATE(327),
    [sym_preproc_undef] = STATE(327),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [328] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(328),
    [sym_preproc_endregion] = STATE(328),
    [sym_preproc_line] = STATE(328),
    [sym_preproc_pragma] = STATE(328),
    [sym_preproc_nullable] = STATE(328),
    [sym_preproc_error] = STATE(328),
    [sym_preproc_define] = STATE(328),
    [sym_preproc_undef] = STATE(328),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [329] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6224),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(329),
    [sym_preproc_endregion] = STATE(329),
    [sym_preproc_line] = STATE(329),
    [sym_preproc_pragma] = STATE(329),
    [sym_preproc_nullable] = STATE(329),
    [sym_preproc_error] = STATE(329),
    [sym_preproc_define] = STATE(329),
    [sym_preproc_undef] = STATE(329),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [330] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5040),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(330),
    [sym_preproc_endregion] = STATE(330),
    [sym_preproc_line] = STATE(330),
    [sym_preproc_pragma] = STATE(330),
    [sym_preproc_nullable] = STATE(330),
    [sym_preproc_error] = STATE(330),
    [sym_preproc_define] = STATE(330),
    [sym_preproc_undef] = STATE(330),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2171),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [331] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6265),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(331),
    [sym_preproc_endregion] = STATE(331),
    [sym_preproc_line] = STATE(331),
    [sym_preproc_pragma] = STATE(331),
    [sym_preproc_nullable] = STATE(331),
    [sym_preproc_error] = STATE(331),
    [sym_preproc_define] = STATE(331),
    [sym_preproc_undef] = STATE(331),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [332] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6520),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(332),
    [sym_preproc_endregion] = STATE(332),
    [sym_preproc_line] = STATE(332),
    [sym_preproc_pragma] = STATE(332),
    [sym_preproc_nullable] = STATE(332),
    [sym_preproc_error] = STATE(332),
    [sym_preproc_define] = STATE(332),
    [sym_preproc_undef] = STATE(332),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [333] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(333),
    [sym_preproc_endregion] = STATE(333),
    [sym_preproc_line] = STATE(333),
    [sym_preproc_pragma] = STATE(333),
    [sym_preproc_nullable] = STATE(333),
    [sym_preproc_error] = STATE(333),
    [sym_preproc_define] = STATE(333),
    [sym_preproc_undef] = STATE(333),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [334] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(334),
    [sym_preproc_endregion] = STATE(334),
    [sym_preproc_line] = STATE(334),
    [sym_preproc_pragma] = STATE(334),
    [sym_preproc_nullable] = STATE(334),
    [sym_preproc_error] = STATE(334),
    [sym_preproc_define] = STATE(334),
    [sym_preproc_undef] = STATE(334),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2201),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [335] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5034),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(335),
    [sym_preproc_endregion] = STATE(335),
    [sym_preproc_line] = STATE(335),
    [sym_preproc_pragma] = STATE(335),
    [sym_preproc_nullable] = STATE(335),
    [sym_preproc_error] = STATE(335),
    [sym_preproc_define] = STATE(335),
    [sym_preproc_undef] = STATE(335),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2171),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [336] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6147),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(336),
    [sym_preproc_endregion] = STATE(336),
    [sym_preproc_line] = STATE(336),
    [sym_preproc_pragma] = STATE(336),
    [sym_preproc_nullable] = STATE(336),
    [sym_preproc_error] = STATE(336),
    [sym_preproc_define] = STATE(336),
    [sym_preproc_undef] = STATE(336),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [337] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(337),
    [sym_preproc_endregion] = STATE(337),
    [sym_preproc_line] = STATE(337),
    [sym_preproc_pragma] = STATE(337),
    [sym_preproc_nullable] = STATE(337),
    [sym_preproc_error] = STATE(337),
    [sym_preproc_define] = STATE(337),
    [sym_preproc_undef] = STATE(337),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2221),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [338] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6450),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(338),
    [sym_preproc_endregion] = STATE(338),
    [sym_preproc_line] = STATE(338),
    [sym_preproc_pragma] = STATE(338),
    [sym_preproc_nullable] = STATE(338),
    [sym_preproc_error] = STATE(338),
    [sym_preproc_define] = STATE(338),
    [sym_preproc_undef] = STATE(338),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2133),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [339] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6271),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(339),
    [sym_preproc_endregion] = STATE(339),
    [sym_preproc_line] = STATE(339),
    [sym_preproc_pragma] = STATE(339),
    [sym_preproc_nullable] = STATE(339),
    [sym_preproc_error] = STATE(339),
    [sym_preproc_define] = STATE(339),
    [sym_preproc_undef] = STATE(339),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2209),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2209),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [340] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(340),
    [sym_preproc_endregion] = STATE(340),
    [sym_preproc_line] = STATE(340),
    [sym_preproc_pragma] = STATE(340),
    [sym_preproc_nullable] = STATE(340),
    [sym_preproc_error] = STATE(340),
    [sym_preproc_define] = STATE(340),
    [sym_preproc_undef] = STATE(340),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [341] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6312),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(341),
    [sym_preproc_endregion] = STATE(341),
    [sym_preproc_line] = STATE(341),
    [sym_preproc_pragma] = STATE(341),
    [sym_preproc_nullable] = STATE(341),
    [sym_preproc_error] = STATE(341),
    [sym_preproc_define] = STATE(341),
    [sym_preproc_undef] = STATE(341),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [342] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6410),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(342),
    [sym_preproc_endregion] = STATE(342),
    [sym_preproc_line] = STATE(342),
    [sym_preproc_pragma] = STATE(342),
    [sym_preproc_nullable] = STATE(342),
    [sym_preproc_error] = STATE(342),
    [sym_preproc_define] = STATE(342),
    [sym_preproc_undef] = STATE(342),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2231),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [343] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(343),
    [sym_preproc_endregion] = STATE(343),
    [sym_preproc_line] = STATE(343),
    [sym_preproc_pragma] = STATE(343),
    [sym_preproc_nullable] = STATE(343),
    [sym_preproc_error] = STATE(343),
    [sym_preproc_define] = STATE(343),
    [sym_preproc_undef] = STATE(343),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2243),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [344] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(344),
    [sym_preproc_endregion] = STATE(344),
    [sym_preproc_line] = STATE(344),
    [sym_preproc_pragma] = STATE(344),
    [sym_preproc_nullable] = STATE(344),
    [sym_preproc_error] = STATE(344),
    [sym_preproc_define] = STATE(344),
    [sym_preproc_undef] = STATE(344),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [345] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(345),
    [sym_preproc_endregion] = STATE(345),
    [sym_preproc_line] = STATE(345),
    [sym_preproc_pragma] = STATE(345),
    [sym_preproc_nullable] = STATE(345),
    [sym_preproc_error] = STATE(345),
    [sym_preproc_define] = STATE(345),
    [sym_preproc_undef] = STATE(345),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2247),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [346] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(346),
    [sym_preproc_endregion] = STATE(346),
    [sym_preproc_line] = STATE(346),
    [sym_preproc_pragma] = STATE(346),
    [sym_preproc_nullable] = STATE(346),
    [sym_preproc_error] = STATE(346),
    [sym_preproc_define] = STATE(346),
    [sym_preproc_undef] = STATE(346),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2249),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [347] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(347),
    [sym_preproc_endregion] = STATE(347),
    [sym_preproc_line] = STATE(347),
    [sym_preproc_pragma] = STATE(347),
    [sym_preproc_nullable] = STATE(347),
    [sym_preproc_error] = STATE(347),
    [sym_preproc_define] = STATE(347),
    [sym_preproc_undef] = STATE(347),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2251),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [348] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(348),
    [sym_preproc_endregion] = STATE(348),
    [sym_preproc_line] = STATE(348),
    [sym_preproc_pragma] = STATE(348),
    [sym_preproc_nullable] = STATE(348),
    [sym_preproc_error] = STATE(348),
    [sym_preproc_define] = STATE(348),
    [sym_preproc_undef] = STATE(348),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2253),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [349] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(349),
    [sym_preproc_endregion] = STATE(349),
    [sym_preproc_line] = STATE(349),
    [sym_preproc_pragma] = STATE(349),
    [sym_preproc_nullable] = STATE(349),
    [sym_preproc_error] = STATE(349),
    [sym_preproc_define] = STATE(349),
    [sym_preproc_undef] = STATE(349),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2255),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [350] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6401),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(350),
    [sym_preproc_endregion] = STATE(350),
    [sym_preproc_line] = STATE(350),
    [sym_preproc_pragma] = STATE(350),
    [sym_preproc_nullable] = STATE(350),
    [sym_preproc_error] = STATE(350),
    [sym_preproc_define] = STATE(350),
    [sym_preproc_undef] = STATE(350),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2231),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [351] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6156),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(351),
    [sym_preproc_endregion] = STATE(351),
    [sym_preproc_line] = STATE(351),
    [sym_preproc_pragma] = STATE(351),
    [sym_preproc_nullable] = STATE(351),
    [sym_preproc_error] = STATE(351),
    [sym_preproc_define] = STATE(351),
    [sym_preproc_undef] = STATE(351),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [352] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(352),
    [sym_preproc_endregion] = STATE(352),
    [sym_preproc_line] = STATE(352),
    [sym_preproc_pragma] = STATE(352),
    [sym_preproc_nullable] = STATE(352),
    [sym_preproc_error] = STATE(352),
    [sym_preproc_define] = STATE(352),
    [sym_preproc_undef] = STATE(352),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2257),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [353] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(353),
    [sym_preproc_endregion] = STATE(353),
    [sym_preproc_line] = STATE(353),
    [sym_preproc_pragma] = STATE(353),
    [sym_preproc_nullable] = STATE(353),
    [sym_preproc_error] = STATE(353),
    [sym_preproc_define] = STATE(353),
    [sym_preproc_undef] = STATE(353),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2259),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [354] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5090),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(354),
    [sym_preproc_endregion] = STATE(354),
    [sym_preproc_line] = STATE(354),
    [sym_preproc_pragma] = STATE(354),
    [sym_preproc_nullable] = STATE(354),
    [sym_preproc_error] = STATE(354),
    [sym_preproc_define] = STATE(354),
    [sym_preproc_undef] = STATE(354),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(2265),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1225),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [355] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5118),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(355),
    [sym_preproc_endregion] = STATE(355),
    [sym_preproc_line] = STATE(355),
    [sym_preproc_pragma] = STATE(355),
    [sym_preproc_nullable] = STATE(355),
    [sym_preproc_error] = STATE(355),
    [sym_preproc_define] = STATE(355),
    [sym_preproc_undef] = STATE(355),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2265),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(2265),
    [anon_sym_LT_LT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1155),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_GT_EQ] = ACTIONS(1155),
    [anon_sym_LT_EQ] = ACTIONS(1155),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_AMP_AMP] = ACTIONS(1155),
    [anon_sym_PIPE_PIPE] = ACTIONS(1155),
    [anon_sym_QMARK_QMARK] = ACTIONS(1155),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_is] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_DASH_GT] = ACTIONS(1155),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [356] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(356),
    [sym_preproc_endregion] = STATE(356),
    [sym_preproc_line] = STATE(356),
    [sym_preproc_pragma] = STATE(356),
    [sym_preproc_nullable] = STATE(356),
    [sym_preproc_error] = STATE(356),
    [sym_preproc_define] = STATE(356),
    [sym_preproc_undef] = STATE(356),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_RBRACE] = ACTIONS(2275),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [357] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(357),
    [sym_preproc_endregion] = STATE(357),
    [sym_preproc_line] = STATE(357),
    [sym_preproc_pragma] = STATE(357),
    [sym_preproc_nullable] = STATE(357),
    [sym_preproc_error] = STATE(357),
    [sym_preproc_define] = STATE(357),
    [sym_preproc_undef] = STATE(357),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2277),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [358] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8240),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6556),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(358),
    [sym_preproc_endregion] = STATE(358),
    [sym_preproc_line] = STATE(358),
    [sym_preproc_pragma] = STATE(358),
    [sym_preproc_nullable] = STATE(358),
    [sym_preproc_error] = STATE(358),
    [sym_preproc_define] = STATE(358),
    [sym_preproc_undef] = STATE(358),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [359] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(359),
    [sym_preproc_endregion] = STATE(359),
    [sym_preproc_line] = STATE(359),
    [sym_preproc_pragma] = STATE(359),
    [sym_preproc_nullable] = STATE(359),
    [sym_preproc_error] = STATE(359),
    [sym_preproc_define] = STATE(359),
    [sym_preproc_undef] = STATE(359),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2283),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [360] = {
    [sym_attribute_list] = STATE(6722),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9564),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6823),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(360),
    [sym_preproc_endregion] = STATE(360),
    [sym_preproc_line] = STATE(360),
    [sym_preproc_pragma] = STATE(360),
    [sym_preproc_nullable] = STATE(360),
    [sym_preproc_error] = STATE(360),
    [sym_preproc_define] = STATE(360),
    [sym_preproc_undef] = STATE(360),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_class_declaration_repeat2] = STATE(3116),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2285),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(2287),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_foreach] = ACTIONS(2289),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [361] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(361),
    [sym_preproc_endregion] = STATE(361),
    [sym_preproc_line] = STATE(361),
    [sym_preproc_pragma] = STATE(361),
    [sym_preproc_nullable] = STATE(361),
    [sym_preproc_error] = STATE(361),
    [sym_preproc_define] = STATE(361),
    [sym_preproc_undef] = STATE(361),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [362] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(362),
    [sym_preproc_endregion] = STATE(362),
    [sym_preproc_line] = STATE(362),
    [sym_preproc_pragma] = STATE(362),
    [sym_preproc_nullable] = STATE(362),
    [sym_preproc_error] = STATE(362),
    [sym_preproc_define] = STATE(362),
    [sym_preproc_undef] = STATE(362),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [363] = {
    [sym_attribute_list] = STATE(6722),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9087),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6823),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(363),
    [sym_preproc_endregion] = STATE(363),
    [sym_preproc_line] = STATE(363),
    [sym_preproc_pragma] = STATE(363),
    [sym_preproc_nullable] = STATE(363),
    [sym_preproc_error] = STATE(363),
    [sym_preproc_define] = STATE(363),
    [sym_preproc_undef] = STATE(363),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_class_declaration_repeat2] = STATE(3109),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2295),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(2287),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_foreach] = ACTIONS(2297),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [364] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5714),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8348),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_subpattern] = STATE(8481),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6481),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(364),
    [sym_preproc_endregion] = STATE(364),
    [sym_preproc_line] = STATE(364),
    [sym_preproc_pragma] = STATE(364),
    [sym_preproc_nullable] = STATE(364),
    [sym_preproc_error] = STATE(364),
    [sym_preproc_define] = STATE(364),
    [sym_preproc_undef] = STATE(364),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_ref] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [365] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(365),
    [sym_preproc_endregion] = STATE(365),
    [sym_preproc_line] = STATE(365),
    [sym_preproc_pragma] = STATE(365),
    [sym_preproc_nullable] = STATE(365),
    [sym_preproc_error] = STATE(365),
    [sym_preproc_define] = STATE(365),
    [sym_preproc_undef] = STATE(365),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [366] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(366),
    [sym_preproc_endregion] = STATE(366),
    [sym_preproc_line] = STATE(366),
    [sym_preproc_pragma] = STATE(366),
    [sym_preproc_nullable] = STATE(366),
    [sym_preproc_error] = STATE(366),
    [sym_preproc_define] = STATE(366),
    [sym_preproc_undef] = STATE(366),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [367] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(367),
    [sym_preproc_endregion] = STATE(367),
    [sym_preproc_line] = STATE(367),
    [sym_preproc_pragma] = STATE(367),
    [sym_preproc_nullable] = STATE(367),
    [sym_preproc_error] = STATE(367),
    [sym_preproc_define] = STATE(367),
    [sym_preproc_undef] = STATE(367),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [368] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(368),
    [sym_preproc_endregion] = STATE(368),
    [sym_preproc_line] = STATE(368),
    [sym_preproc_pragma] = STATE(368),
    [sym_preproc_nullable] = STATE(368),
    [sym_preproc_error] = STATE(368),
    [sym_preproc_define] = STATE(368),
    [sym_preproc_undef] = STATE(368),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2309),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [369] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(369),
    [sym_preproc_endregion] = STATE(369),
    [sym_preproc_line] = STATE(369),
    [sym_preproc_pragma] = STATE(369),
    [sym_preproc_nullable] = STATE(369),
    [sym_preproc_error] = STATE(369),
    [sym_preproc_define] = STATE(369),
    [sym_preproc_undef] = STATE(369),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [370] = {
    [sym_attribute_list] = STATE(6722),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9087),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(370),
    [sym_preproc_endregion] = STATE(370),
    [sym_preproc_line] = STATE(370),
    [sym_preproc_pragma] = STATE(370),
    [sym_preproc_nullable] = STATE(370),
    [sym_preproc_error] = STATE(370),
    [sym_preproc_define] = STATE(370),
    [sym_preproc_undef] = STATE(370),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_class_declaration_repeat2] = STATE(3109),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2295),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(2287),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_foreach] = ACTIONS(2297),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [371] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(371),
    [sym_preproc_endregion] = STATE(371),
    [sym_preproc_line] = STATE(371),
    [sym_preproc_pragma] = STATE(371),
    [sym_preproc_nullable] = STATE(371),
    [sym_preproc_error] = STATE(371),
    [sym_preproc_define] = STATE(371),
    [sym_preproc_undef] = STATE(371),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(2313),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [372] = {
    [sym_attribute_list] = STATE(6722),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9531),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6823),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(372),
    [sym_preproc_endregion] = STATE(372),
    [sym_preproc_line] = STATE(372),
    [sym_preproc_pragma] = STATE(372),
    [sym_preproc_nullable] = STATE(372),
    [sym_preproc_error] = STATE(372),
    [sym_preproc_define] = STATE(372),
    [sym_preproc_undef] = STATE(372),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_class_declaration_repeat2] = STATE(3113),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2315),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(2287),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_foreach] = ACTIONS(2317),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [373] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8119),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_switch_expression_arm] = STATE(8871),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(373),
    [sym_preproc_endregion] = STATE(373),
    [sym_preproc_line] = STATE(373),
    [sym_preproc_pragma] = STATE(373),
    [sym_preproc_nullable] = STATE(373),
    [sym_preproc_error] = STATE(373),
    [sym_preproc_define] = STATE(373),
    [sym_preproc_undef] = STATE(373),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [374] = {
    [sym_attribute_list] = STATE(6722),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9853),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6823),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(374),
    [sym_preproc_endregion] = STATE(374),
    [sym_preproc_line] = STATE(374),
    [sym_preproc_pragma] = STATE(374),
    [sym_preproc_nullable] = STATE(374),
    [sym_preproc_error] = STATE(374),
    [sym_preproc_define] = STATE(374),
    [sym_preproc_undef] = STATE(374),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_using] = ACTIONS(2319),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(685),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(2287),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_foreach] = ACTIONS(2321),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [375] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3226),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6738),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(375),
    [sym_preproc_endregion] = STATE(375),
    [sym_preproc_line] = STATE(375),
    [sym_preproc_pragma] = STATE(375),
    [sym_preproc_nullable] = STATE(375),
    [sym_preproc_error] = STATE(375),
    [sym_preproc_define] = STATE(375),
    [sym_preproc_undef] = STATE(375),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2325),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [376] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(376),
    [sym_preproc_endregion] = STATE(376),
    [sym_preproc_line] = STATE(376),
    [sym_preproc_pragma] = STATE(376),
    [sym_preproc_nullable] = STATE(376),
    [sym_preproc_error] = STATE(376),
    [sym_preproc_define] = STATE(376),
    [sym_preproc_undef] = STATE(376),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [377] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8374),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(377),
    [sym_preproc_endregion] = STATE(377),
    [sym_preproc_line] = STATE(377),
    [sym_preproc_pragma] = STATE(377),
    [sym_preproc_nullable] = STATE(377),
    [sym_preproc_error] = STATE(377),
    [sym_preproc_define] = STATE(377),
    [sym_preproc_undef] = STATE(377),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(2281),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [378] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3552),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2896),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3083),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6193),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3266),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6702),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(378),
    [sym_preproc_endregion] = STATE(378),
    [sym_preproc_line] = STATE(378),
    [sym_preproc_pragma] = STATE(378),
    [sym_preproc_nullable] = STATE(378),
    [sym_preproc_error] = STATE(378),
    [sym_preproc_define] = STATE(378),
    [sym_preproc_undef] = STATE(378),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2369),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [379] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3543),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2865),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3052),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4567),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3137),
    [sym_property_pattern_clause] = STATE(3194),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6729),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(379),
    [sym_preproc_endregion] = STATE(379),
    [sym_preproc_line] = STATE(379),
    [sym_preproc_pragma] = STATE(379),
    [sym_preproc_nullable] = STATE(379),
    [sym_preproc_error] = STATE(379),
    [sym_preproc_define] = STATE(379),
    [sym_preproc_undef] = STATE(379),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2375),
    [anon_sym_GT] = ACTIONS(2375),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2385),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [380] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3547),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3085),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6285),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3235),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6718),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(380),
    [sym_preproc_endregion] = STATE(380),
    [sym_preproc_line] = STATE(380),
    [sym_preproc_pragma] = STATE(380),
    [sym_preproc_nullable] = STATE(380),
    [sym_preproc_error] = STATE(380),
    [sym_preproc_define] = STATE(380),
    [sym_preproc_undef] = STATE(380),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2393),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [381] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3547),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3085),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3235),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6718),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(381),
    [sym_preproc_endregion] = STATE(381),
    [sym_preproc_line] = STATE(381),
    [sym_preproc_pragma] = STATE(381),
    [sym_preproc_nullable] = STATE(381),
    [sym_preproc_error] = STATE(381),
    [sym_preproc_define] = STATE(381),
    [sym_preproc_undef] = STATE(381),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2393),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [382] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3543),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2865),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3052),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4758),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3137),
    [sym_property_pattern_clause] = STATE(3194),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6729),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(382),
    [sym_preproc_endregion] = STATE(382),
    [sym_preproc_line] = STATE(382),
    [sym_preproc_pragma] = STATE(382),
    [sym_preproc_nullable] = STATE(382),
    [sym_preproc_error] = STATE(382),
    [sym_preproc_define] = STATE(382),
    [sym_preproc_undef] = STATE(382),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2375),
    [anon_sym_GT] = ACTIONS(2375),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2385),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [383] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3547),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3085),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6228),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3235),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6718),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(383),
    [sym_preproc_endregion] = STATE(383),
    [sym_preproc_line] = STATE(383),
    [sym_preproc_pragma] = STATE(383),
    [sym_preproc_nullable] = STATE(383),
    [sym_preproc_error] = STATE(383),
    [sym_preproc_define] = STATE(383),
    [sym_preproc_undef] = STATE(383),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2393),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [384] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8358),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(384),
    [sym_preproc_endregion] = STATE(384),
    [sym_preproc_line] = STATE(384),
    [sym_preproc_pragma] = STATE(384),
    [sym_preproc_nullable] = STATE(384),
    [sym_preproc_error] = STATE(384),
    [sym_preproc_define] = STATE(384),
    [sym_preproc_undef] = STATE(384),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [385] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3542),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(385),
    [sym_preproc_endregion] = STATE(385),
    [sym_preproc_line] = STATE(385),
    [sym_preproc_pragma] = STATE(385),
    [sym_preproc_nullable] = STATE(385),
    [sym_preproc_error] = STATE(385),
    [sym_preproc_define] = STATE(385),
    [sym_preproc_undef] = STATE(385),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2405),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [386] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3552),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2896),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3074),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6196),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3266),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6702),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(386),
    [sym_preproc_endregion] = STATE(386),
    [sym_preproc_line] = STATE(386),
    [sym_preproc_pragma] = STATE(386),
    [sym_preproc_nullable] = STATE(386),
    [sym_preproc_error] = STATE(386),
    [sym_preproc_define] = STATE(386),
    [sym_preproc_undef] = STATE(386),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2369),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [387] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3552),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2896),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3074),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3266),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6702),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(387),
    [sym_preproc_endregion] = STATE(387),
    [sym_preproc_line] = STATE(387),
    [sym_preproc_pragma] = STATE(387),
    [sym_preproc_nullable] = STATE(387),
    [sym_preproc_error] = STATE(387),
    [sym_preproc_define] = STATE(387),
    [sym_preproc_undef] = STATE(387),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2369),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [388] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3552),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2896),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3074),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6248),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3266),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6702),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(388),
    [sym_preproc_endregion] = STATE(388),
    [sym_preproc_line] = STATE(388),
    [sym_preproc_pragma] = STATE(388),
    [sym_preproc_nullable] = STATE(388),
    [sym_preproc_error] = STATE(388),
    [sym_preproc_define] = STATE(388),
    [sym_preproc_undef] = STATE(388),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2369),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [389] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2803),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(389),
    [sym_preproc_endregion] = STATE(389),
    [sym_preproc_line] = STATE(389),
    [sym_preproc_pragma] = STATE(389),
    [sym_preproc_nullable] = STATE(389),
    [sym_preproc_error] = STATE(389),
    [sym_preproc_define] = STATE(389),
    [sym_preproc_undef] = STATE(389),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2409),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2413),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [390] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3553),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2918),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6159),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3162),
    [sym_property_pattern_clause] = STATE(3256),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(390),
    [sym_preproc_endregion] = STATE(390),
    [sym_preproc_line] = STATE(390),
    [sym_preproc_pragma] = STATE(390),
    [sym_preproc_nullable] = STATE(390),
    [sym_preproc_error] = STATE(390),
    [sym_preproc_define] = STATE(390),
    [sym_preproc_undef] = STATE(390),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2419),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2421),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [391] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3548),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2910),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6424),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3173),
    [sym_property_pattern_clause] = STATE(3281),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6726),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(391),
    [sym_preproc_endregion] = STATE(391),
    [sym_preproc_line] = STATE(391),
    [sym_preproc_pragma] = STATE(391),
    [sym_preproc_nullable] = STATE(391),
    [sym_preproc_error] = STATE(391),
    [sym_preproc_define] = STATE(391),
    [sym_preproc_undef] = STATE(391),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [392] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2808),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6503),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(392),
    [sym_preproc_endregion] = STATE(392),
    [sym_preproc_line] = STATE(392),
    [sym_preproc_pragma] = STATE(392),
    [sym_preproc_nullable] = STATE(392),
    [sym_preproc_error] = STATE(392),
    [sym_preproc_define] = STATE(392),
    [sym_preproc_undef] = STATE(392),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [393] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8371),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(393),
    [sym_preproc_endregion] = STATE(393),
    [sym_preproc_line] = STATE(393),
    [sym_preproc_pragma] = STATE(393),
    [sym_preproc_nullable] = STATE(393),
    [sym_preproc_error] = STATE(393),
    [sym_preproc_define] = STATE(393),
    [sym_preproc_undef] = STATE(393),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [394] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3550),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2886),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5115),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3143),
    [sym_property_pattern_clause] = STATE(3233),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(394),
    [sym_preproc_endregion] = STATE(394),
    [sym_preproc_line] = STATE(394),
    [sym_preproc_pragma] = STATE(394),
    [sym_preproc_nullable] = STATE(394),
    [sym_preproc_error] = STATE(394),
    [sym_preproc_define] = STATE(394),
    [sym_preproc_undef] = STATE(394),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2447),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [395] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3550),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2886),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4992),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3143),
    [sym_property_pattern_clause] = STATE(3233),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(395),
    [sym_preproc_endregion] = STATE(395),
    [sym_preproc_line] = STATE(395),
    [sym_preproc_pragma] = STATE(395),
    [sym_preproc_nullable] = STATE(395),
    [sym_preproc_error] = STATE(395),
    [sym_preproc_define] = STATE(395),
    [sym_preproc_undef] = STATE(395),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2447),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [396] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(396),
    [sym_preproc_endregion] = STATE(396),
    [sym_preproc_line] = STATE(396),
    [sym_preproc_pragma] = STATE(396),
    [sym_preproc_nullable] = STATE(396),
    [sym_preproc_error] = STATE(396),
    [sym_preproc_define] = STATE(396),
    [sym_preproc_undef] = STATE(396),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [397] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8267),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(397),
    [sym_preproc_endregion] = STATE(397),
    [sym_preproc_line] = STATE(397),
    [sym_preproc_pragma] = STATE(397),
    [sym_preproc_nullable] = STATE(397),
    [sym_preproc_error] = STATE(397),
    [sym_preproc_define] = STATE(397),
    [sym_preproc_undef] = STATE(397),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1135),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [398] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3550),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2886),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5113),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3143),
    [sym_property_pattern_clause] = STATE(3233),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(398),
    [sym_preproc_endregion] = STATE(398),
    [sym_preproc_line] = STATE(398),
    [sym_preproc_pragma] = STATE(398),
    [sym_preproc_nullable] = STATE(398),
    [sym_preproc_error] = STATE(398),
    [sym_preproc_define] = STATE(398),
    [sym_preproc_undef] = STATE(398),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2447),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [399] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3537),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(399),
    [sym_preproc_endregion] = STATE(399),
    [sym_preproc_line] = STATE(399),
    [sym_preproc_pragma] = STATE(399),
    [sym_preproc_nullable] = STATE(399),
    [sym_preproc_error] = STATE(399),
    [sym_preproc_define] = STATE(399),
    [sym_preproc_undef] = STATE(399),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2463),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [400] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3559),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2916),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3060),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6399),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3159),
    [sym_property_pattern_clause] = STATE(3476),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6733),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(400),
    [sym_preproc_endregion] = STATE(400),
    [sym_preproc_line] = STATE(400),
    [sym_preproc_pragma] = STATE(400),
    [sym_preproc_nullable] = STATE(400),
    [sym_preproc_error] = STATE(400),
    [sym_preproc_define] = STATE(400),
    [sym_preproc_undef] = STATE(400),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2471),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [401] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3550),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2886),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3065),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5059),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3143),
    [sym_property_pattern_clause] = STATE(3233),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(401),
    [sym_preproc_endregion] = STATE(401),
    [sym_preproc_line] = STATE(401),
    [sym_preproc_pragma] = STATE(401),
    [sym_preproc_nullable] = STATE(401),
    [sym_preproc_error] = STATE(401),
    [sym_preproc_define] = STATE(401),
    [sym_preproc_undef] = STATE(401),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2447),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [402] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8344),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(402),
    [sym_preproc_endregion] = STATE(402),
    [sym_preproc_line] = STATE(402),
    [sym_preproc_pragma] = STATE(402),
    [sym_preproc_nullable] = STATE(402),
    [sym_preproc_error] = STATE(402),
    [sym_preproc_define] = STATE(402),
    [sym_preproc_undef] = STATE(402),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [403] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2808),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5423),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6731),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(403),
    [sym_preproc_endregion] = STATE(403),
    [sym_preproc_line] = STATE(403),
    [sym_preproc_pragma] = STATE(403),
    [sym_preproc_nullable] = STATE(403),
    [sym_preproc_error] = STATE(403),
    [sym_preproc_define] = STATE(403),
    [sym_preproc_undef] = STATE(403),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2477),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [404] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3046),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6454),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3223),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6724),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(404),
    [sym_preproc_endregion] = STATE(404),
    [sym_preproc_line] = STATE(404),
    [sym_preproc_pragma] = STATE(404),
    [sym_preproc_nullable] = STATE(404),
    [sym_preproc_error] = STATE(404),
    [sym_preproc_define] = STATE(404),
    [sym_preproc_undef] = STATE(404),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2487),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2489),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [405] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(405),
    [sym_preproc_endregion] = STATE(405),
    [sym_preproc_line] = STATE(405),
    [sym_preproc_pragma] = STATE(405),
    [sym_preproc_nullable] = STATE(405),
    [sym_preproc_error] = STATE(405),
    [sym_preproc_define] = STATE(405),
    [sym_preproc_undef] = STATE(405),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [406] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3547),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3086),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6287),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3235),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6718),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(406),
    [sym_preproc_endregion] = STATE(406),
    [sym_preproc_line] = STATE(406),
    [sym_preproc_pragma] = STATE(406),
    [sym_preproc_nullable] = STATE(406),
    [sym_preproc_error] = STATE(406),
    [sym_preproc_define] = STATE(406),
    [sym_preproc_undef] = STATE(406),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2393),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [407] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8321),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(407),
    [sym_preproc_endregion] = STATE(407),
    [sym_preproc_line] = STATE(407),
    [sym_preproc_pragma] = STATE(407),
    [sym_preproc_nullable] = STATE(407),
    [sym_preproc_error] = STATE(407),
    [sym_preproc_define] = STATE(407),
    [sym_preproc_undef] = STATE(407),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [408] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5642),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6717),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(408),
    [sym_preproc_endregion] = STATE(408),
    [sym_preproc_line] = STATE(408),
    [sym_preproc_pragma] = STATE(408),
    [sym_preproc_nullable] = STATE(408),
    [sym_preproc_error] = STATE(408),
    [sym_preproc_define] = STATE(408),
    [sym_preproc_undef] = STATE(408),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2497),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [409] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6749),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2875),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6283),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8296),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(6130),
    [sym_postfix_unary_expression] = STATE(6131),
    [sym_prefix_unary_expression] = STATE(6131),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(6130),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(6131),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(6130),
    [sym_member_access_expression] = STATE(4089),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(6131),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(6130),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(6130),
    [sym_typeof_expression] = STATE(6130),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(4089),
    [sym_literal] = STATE(6130),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(409),
    [sym_preproc_endregion] = STATE(409),
    [sym_preproc_line] = STATE(409),
    [sym_preproc_pragma] = STATE(409),
    [sym_preproc_nullable] = STATE(409),
    [sym_preproc_error] = STATE(409),
    [sym_preproc_define] = STATE(409),
    [sym_preproc_undef] = STATE(409),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_ref] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2507),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [410] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6749),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2875),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6283),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(6130),
    [sym_postfix_unary_expression] = STATE(6131),
    [sym_prefix_unary_expression] = STATE(6131),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(6130),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(6131),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(6130),
    [sym_member_access_expression] = STATE(4089),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(6131),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(6130),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(6130),
    [sym_typeof_expression] = STATE(6130),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(4089),
    [sym_literal] = STATE(6130),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(410),
    [sym_preproc_endregion] = STATE(410),
    [sym_preproc_line] = STATE(410),
    [sym_preproc_pragma] = STATE(410),
    [sym_preproc_nullable] = STATE(410),
    [sym_preproc_error] = STATE(410),
    [sym_preproc_define] = STATE(410),
    [sym_preproc_undef] = STATE(410),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_ref] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2507),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [411] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3539),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5899),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6700),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(411),
    [sym_preproc_endregion] = STATE(411),
    [sym_preproc_line] = STATE(411),
    [sym_preproc_pragma] = STATE(411),
    [sym_preproc_nullable] = STATE(411),
    [sym_preproc_error] = STATE(411),
    [sym_preproc_define] = STATE(411),
    [sym_preproc_undef] = STATE(411),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [412] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(412),
    [sym_preproc_endregion] = STATE(412),
    [sym_preproc_line] = STATE(412),
    [sym_preproc_pragma] = STATE(412),
    [sym_preproc_nullable] = STATE(412),
    [sym_preproc_error] = STATE(412),
    [sym_preproc_define] = STATE(412),
    [sym_preproc_undef] = STATE(412),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [413] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6740),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6268),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8252),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5060),
    [sym_postfix_unary_expression] = STATE(5063),
    [sym_prefix_unary_expression] = STATE(5063),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5060),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5063),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5060),
    [sym_member_access_expression] = STATE(3795),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5063),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5060),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5060),
    [sym_typeof_expression] = STATE(5060),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3795),
    [sym_literal] = STATE(5060),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(413),
    [sym_preproc_endregion] = STATE(413),
    [sym_preproc_line] = STATE(413),
    [sym_preproc_pragma] = STATE(413),
    [sym_preproc_nullable] = STATE(413),
    [sym_preproc_error] = STATE(413),
    [sym_preproc_define] = STATE(413),
    [sym_preproc_undef] = STATE(413),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2009),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [414] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2869),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4635),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3129),
    [sym_property_pattern_clause] = STATE(3180),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(414),
    [sym_preproc_endregion] = STATE(414),
    [sym_preproc_line] = STATE(414),
    [sym_preproc_pragma] = STATE(414),
    [sym_preproc_nullable] = STATE(414),
    [sym_preproc_error] = STATE(414),
    [sym_preproc_define] = STATE(414),
    [sym_preproc_undef] = STATE(414),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2525),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [415] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3452),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2819),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2983),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5557),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3088),
    [sym_property_pattern_clause] = STATE(3134),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(415),
    [sym_preproc_endregion] = STATE(415),
    [sym_preproc_line] = STATE(415),
    [sym_preproc_pragma] = STATE(415),
    [sym_preproc_nullable] = STATE(415),
    [sym_preproc_error] = STATE(415),
    [sym_preproc_define] = STATE(415),
    [sym_preproc_undef] = STATE(415),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2549),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [416] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2869),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4567),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3129),
    [sym_property_pattern_clause] = STATE(3180),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(416),
    [sym_preproc_endregion] = STATE(416),
    [sym_preproc_line] = STATE(416),
    [sym_preproc_pragma] = STATE(416),
    [sym_preproc_nullable] = STATE(416),
    [sym_preproc_error] = STATE(416),
    [sym_preproc_define] = STATE(416),
    [sym_preproc_undef] = STATE(416),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2525),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [417] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3539),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6700),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(417),
    [sym_preproc_endregion] = STATE(417),
    [sym_preproc_line] = STATE(417),
    [sym_preproc_pragma] = STATE(417),
    [sym_preproc_nullable] = STATE(417),
    [sym_preproc_error] = STATE(417),
    [sym_preproc_define] = STATE(417),
    [sym_preproc_undef] = STATE(417),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [418] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5263),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(418),
    [sym_preproc_endregion] = STATE(418),
    [sym_preproc_line] = STATE(418),
    [sym_preproc_pragma] = STATE(418),
    [sym_preproc_nullable] = STATE(418),
    [sym_preproc_error] = STATE(418),
    [sym_preproc_define] = STATE(418),
    [sym_preproc_undef] = STATE(418),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [419] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3559),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2916),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6321),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3159),
    [sym_property_pattern_clause] = STATE(3476),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6733),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(419),
    [sym_preproc_endregion] = STATE(419),
    [sym_preproc_line] = STATE(419),
    [sym_preproc_pragma] = STATE(419),
    [sym_preproc_nullable] = STATE(419),
    [sym_preproc_error] = STATE(419),
    [sym_preproc_define] = STATE(419),
    [sym_preproc_undef] = STATE(419),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2471),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [420] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3559),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2916),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3159),
    [sym_property_pattern_clause] = STATE(3476),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6733),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(420),
    [sym_preproc_endregion] = STATE(420),
    [sym_preproc_line] = STATE(420),
    [sym_preproc_pragma] = STATE(420),
    [sym_preproc_nullable] = STATE(420),
    [sym_preproc_error] = STATE(420),
    [sym_preproc_define] = STATE(420),
    [sym_preproc_undef] = STATE(420),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2471),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [421] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3559),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2916),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6382),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3159),
    [sym_property_pattern_clause] = STATE(3476),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6733),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(421),
    [sym_preproc_endregion] = STATE(421),
    [sym_preproc_line] = STATE(421),
    [sym_preproc_pragma] = STATE(421),
    [sym_preproc_nullable] = STATE(421),
    [sym_preproc_error] = STATE(421),
    [sym_preproc_define] = STATE(421),
    [sym_preproc_undef] = STATE(421),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2471),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [422] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6749),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2875),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6283),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8282),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(6130),
    [sym_postfix_unary_expression] = STATE(6131),
    [sym_prefix_unary_expression] = STATE(6131),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(6130),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(6131),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(6130),
    [sym_member_access_expression] = STATE(4089),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(6131),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(6130),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(6130),
    [sym_typeof_expression] = STATE(6130),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(4089),
    [sym_literal] = STATE(6130),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(422),
    [sym_preproc_endregion] = STATE(422),
    [sym_preproc_line] = STATE(422),
    [sym_preproc_pragma] = STATE(422),
    [sym_preproc_nullable] = STATE(422),
    [sym_preproc_error] = STATE(422),
    [sym_preproc_define] = STATE(422),
    [sym_preproc_undef] = STATE(422),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_ref] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2507),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [423] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3539),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5906),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6700),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(423),
    [sym_preproc_endregion] = STATE(423),
    [sym_preproc_line] = STATE(423),
    [sym_preproc_pragma] = STATE(423),
    [sym_preproc_nullable] = STATE(423),
    [sym_preproc_error] = STATE(423),
    [sym_preproc_define] = STATE(423),
    [sym_preproc_undef] = STATE(423),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [424] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3452),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2819),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2983),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(6101),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3088),
    [sym_property_pattern_clause] = STATE(3134),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(424),
    [sym_preproc_endregion] = STATE(424),
    [sym_preproc_line] = STATE(424),
    [sym_preproc_pragma] = STATE(424),
    [sym_preproc_nullable] = STATE(424),
    [sym_preproc_error] = STATE(424),
    [sym_preproc_define] = STATE(424),
    [sym_preproc_undef] = STATE(424),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2549),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [425] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5433),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6731),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(425),
    [sym_preproc_endregion] = STATE(425),
    [sym_preproc_line] = STATE(425),
    [sym_preproc_pragma] = STATE(425),
    [sym_preproc_nullable] = STATE(425),
    [sym_preproc_error] = STATE(425),
    [sym_preproc_define] = STATE(425),
    [sym_preproc_undef] = STATE(425),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2477),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [426] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6731),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(426),
    [sym_preproc_endregion] = STATE(426),
    [sym_preproc_line] = STATE(426),
    [sym_preproc_pragma] = STATE(426),
    [sym_preproc_nullable] = STATE(426),
    [sym_preproc_error] = STATE(426),
    [sym_preproc_define] = STATE(426),
    [sym_preproc_undef] = STATE(426),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2477),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [427] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5760),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6731),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(427),
    [sym_preproc_endregion] = STATE(427),
    [sym_preproc_line] = STATE(427),
    [sym_preproc_pragma] = STATE(427),
    [sym_preproc_nullable] = STATE(427),
    [sym_preproc_error] = STATE(427),
    [sym_preproc_define] = STATE(427),
    [sym_preproc_undef] = STATE(427),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2477),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [428] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2807),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(428),
    [sym_preproc_endregion] = STATE(428),
    [sym_preproc_line] = STATE(428),
    [sym_preproc_pragma] = STATE(428),
    [sym_preproc_nullable] = STATE(428),
    [sym_preproc_error] = STATE(428),
    [sym_preproc_define] = STATE(428),
    [sym_preproc_undef] = STATE(428),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [429] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3553),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2918),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3077),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3162),
    [sym_property_pattern_clause] = STATE(3256),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(429),
    [sym_preproc_endregion] = STATE(429),
    [sym_preproc_line] = STATE(429),
    [sym_preproc_pragma] = STATE(429),
    [sym_preproc_nullable] = STATE(429),
    [sym_preproc_error] = STATE(429),
    [sym_preproc_define] = STATE(429),
    [sym_preproc_undef] = STATE(429),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2419),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2421),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [430] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2807),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(430),
    [sym_preproc_endregion] = STATE(430),
    [sym_preproc_line] = STATE(430),
    [sym_preproc_pragma] = STATE(430),
    [sym_preproc_nullable] = STATE(430),
    [sym_preproc_error] = STATE(430),
    [sym_preproc_define] = STATE(430),
    [sym_preproc_undef] = STATE(430),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [431] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3033),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6152),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6696),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(431),
    [sym_preproc_endregion] = STATE(431),
    [sym_preproc_line] = STATE(431),
    [sym_preproc_pragma] = STATE(431),
    [sym_preproc_nullable] = STATE(431),
    [sym_preproc_error] = STATE(431),
    [sym_preproc_define] = STATE(431),
    [sym_preproc_undef] = STATE(431),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [432] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3452),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2819),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2962),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5909),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3088),
    [sym_property_pattern_clause] = STATE(3134),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(432),
    [sym_preproc_endregion] = STATE(432),
    [sym_preproc_line] = STATE(432),
    [sym_preproc_pragma] = STATE(432),
    [sym_preproc_nullable] = STATE(432),
    [sym_preproc_error] = STATE(432),
    [sym_preproc_define] = STATE(432),
    [sym_preproc_undef] = STATE(432),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2549),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [433] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2869),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4666),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3129),
    [sym_property_pattern_clause] = STATE(3180),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(433),
    [sym_preproc_endregion] = STATE(433),
    [sym_preproc_line] = STATE(433),
    [sym_preproc_pragma] = STATE(433),
    [sym_preproc_nullable] = STATE(433),
    [sym_preproc_error] = STATE(433),
    [sym_preproc_define] = STATE(433),
    [sym_preproc_undef] = STATE(433),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2525),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [434] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3554),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2903),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3087),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6570),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3306),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6732),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(434),
    [sym_preproc_endregion] = STATE(434),
    [sym_preproc_line] = STATE(434),
    [sym_preproc_pragma] = STATE(434),
    [sym_preproc_nullable] = STATE(434),
    [sym_preproc_error] = STATE(434),
    [sym_preproc_define] = STATE(434),
    [sym_preproc_undef] = STATE(434),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(2567),
    [anon_sym_LT_EQ] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [435] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3051),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6421),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3223),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6724),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(435),
    [sym_preproc_endregion] = STATE(435),
    [sym_preproc_line] = STATE(435),
    [sym_preproc_pragma] = STATE(435),
    [sym_preproc_nullable] = STATE(435),
    [sym_preproc_error] = STATE(435),
    [sym_preproc_define] = STATE(435),
    [sym_preproc_undef] = STATE(435),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2487),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2489),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [436] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3452),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2819),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2983),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5931),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3088),
    [sym_property_pattern_clause] = STATE(3134),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(436),
    [sym_preproc_endregion] = STATE(436),
    [sym_preproc_line] = STATE(436),
    [sym_preproc_pragma] = STATE(436),
    [sym_preproc_nullable] = STATE(436),
    [sym_preproc_error] = STATE(436),
    [sym_preproc_define] = STATE(436),
    [sym_preproc_undef] = STATE(436),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2549),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [437] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3027),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6696),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(437),
    [sym_preproc_endregion] = STATE(437),
    [sym_preproc_line] = STATE(437),
    [sym_preproc_pragma] = STATE(437),
    [sym_preproc_nullable] = STATE(437),
    [sym_preproc_error] = STATE(437),
    [sym_preproc_define] = STATE(437),
    [sym_preproc_undef] = STATE(437),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [438] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2807),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6717),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(438),
    [sym_preproc_endregion] = STATE(438),
    [sym_preproc_line] = STATE(438),
    [sym_preproc_pragma] = STATE(438),
    [sym_preproc_nullable] = STATE(438),
    [sym_preproc_error] = STATE(438),
    [sym_preproc_define] = STATE(438),
    [sym_preproc_undef] = STATE(438),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2497),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [439] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(439),
    [sym_preproc_endregion] = STATE(439),
    [sym_preproc_line] = STATE(439),
    [sym_preproc_pragma] = STATE(439),
    [sym_preproc_nullable] = STATE(439),
    [sym_preproc_error] = STATE(439),
    [sym_preproc_define] = STATE(439),
    [sym_preproc_undef] = STATE(439),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [440] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5368),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(440),
    [sym_preproc_endregion] = STATE(440),
    [sym_preproc_line] = STATE(440),
    [sym_preproc_pragma] = STATE(440),
    [sym_preproc_nullable] = STATE(440),
    [sym_preproc_error] = STATE(440),
    [sym_preproc_define] = STATE(440),
    [sym_preproc_undef] = STATE(440),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [441] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8189),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(441),
    [sym_preproc_endregion] = STATE(441),
    [sym_preproc_line] = STATE(441),
    [sym_preproc_pragma] = STATE(441),
    [sym_preproc_nullable] = STATE(441),
    [sym_preproc_error] = STATE(441),
    [sym_preproc_define] = STATE(441),
    [sym_preproc_undef] = STATE(441),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [442] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3554),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2903),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3087),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3306),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6732),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(442),
    [sym_preproc_endregion] = STATE(442),
    [sym_preproc_line] = STATE(442),
    [sym_preproc_pragma] = STATE(442),
    [sym_preproc_nullable] = STATE(442),
    [sym_preproc_error] = STATE(442),
    [sym_preproc_define] = STATE(442),
    [sym_preproc_undef] = STATE(442),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(2567),
    [anon_sym_LT_EQ] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [443] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3539),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6700),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(443),
    [sym_preproc_endregion] = STATE(443),
    [sym_preproc_line] = STATE(443),
    [sym_preproc_pragma] = STATE(443),
    [sym_preproc_nullable] = STATE(443),
    [sym_preproc_error] = STATE(443),
    [sym_preproc_define] = STATE(443),
    [sym_preproc_undef] = STATE(443),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2511),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2513),
    [anon_sym_GT] = ACTIONS(2513),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2517),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [444] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2796),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(5334),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8057),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6292),
    [sym_property_pattern_clause] = STATE(6728),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5295),
    [sym_postfix_unary_expression] = STATE(5297),
    [sym_prefix_unary_expression] = STATE(5297),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5295),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5297),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5295),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5297),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5295),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5295),
    [sym_typeof_expression] = STATE(5295),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3833),
    [sym_literal] = STATE(5295),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(444),
    [sym_preproc_endregion] = STATE(444),
    [sym_preproc_line] = STATE(444),
    [sym_preproc_pragma] = STATE(444),
    [sym_preproc_nullable] = STATE(444),
    [sym_preproc_error] = STATE(444),
    [sym_preproc_define] = STATE(444),
    [sym_preproc_undef] = STATE(444),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1089),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [445] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3046),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3223),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6724),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(445),
    [sym_preproc_endregion] = STATE(445),
    [sym_preproc_line] = STATE(445),
    [sym_preproc_pragma] = STATE(445),
    [sym_preproc_nullable] = STATE(445),
    [sym_preproc_error] = STATE(445),
    [sym_preproc_define] = STATE(445),
    [sym_preproc_undef] = STATE(445),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2487),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2489),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [446] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4930),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(446),
    [sym_preproc_endregion] = STATE(446),
    [sym_preproc_line] = STATE(446),
    [sym_preproc_pragma] = STATE(446),
    [sym_preproc_nullable] = STATE(446),
    [sym_preproc_error] = STATE(446),
    [sym_preproc_define] = STATE(446),
    [sym_preproc_undef] = STATE(446),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2409),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2413),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [447] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5645),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6717),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(447),
    [sym_preproc_endregion] = STATE(447),
    [sym_preproc_line] = STATE(447),
    [sym_preproc_pragma] = STATE(447),
    [sym_preproc_nullable] = STATE(447),
    [sym_preproc_error] = STATE(447),
    [sym_preproc_define] = STATE(447),
    [sym_preproc_undef] = STATE(447),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2497),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [448] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6717),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(448),
    [sym_preproc_endregion] = STATE(448),
    [sym_preproc_line] = STATE(448),
    [sym_preproc_pragma] = STATE(448),
    [sym_preproc_nullable] = STATE(448),
    [sym_preproc_error] = STATE(448),
    [sym_preproc_define] = STATE(448),
    [sym_preproc_undef] = STATE(448),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2497),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [449] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2808),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5511),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6717),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(449),
    [sym_preproc_endregion] = STATE(449),
    [sym_preproc_line] = STATE(449),
    [sym_preproc_pragma] = STATE(449),
    [sym_preproc_nullable] = STATE(449),
    [sym_preproc_error] = STATE(449),
    [sym_preproc_define] = STATE(449),
    [sym_preproc_undef] = STATE(449),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2491),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2497),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [450] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3554),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2903),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3069),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3306),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6732),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(450),
    [sym_preproc_endregion] = STATE(450),
    [sym_preproc_line] = STATE(450),
    [sym_preproc_pragma] = STATE(450),
    [sym_preproc_nullable] = STATE(450),
    [sym_preproc_error] = STATE(450),
    [sym_preproc_define] = STATE(450),
    [sym_preproc_undef] = STATE(450),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(2567),
    [anon_sym_LT_EQ] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [451] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3559),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2916),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3084),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3159),
    [sym_property_pattern_clause] = STATE(3476),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6733),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(451),
    [sym_preproc_endregion] = STATE(451),
    [sym_preproc_line] = STATE(451),
    [sym_preproc_pragma] = STATE(451),
    [sym_preproc_nullable] = STATE(451),
    [sym_preproc_error] = STATE(451),
    [sym_preproc_define] = STATE(451),
    [sym_preproc_undef] = STATE(451),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2465),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2467),
    [anon_sym_GT] = ACTIONS(2467),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2471),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [452] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3552),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2896),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3082),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3141),
    [sym_property_pattern_clause] = STATE(3266),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6702),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(452),
    [sym_preproc_endregion] = STATE(452),
    [sym_preproc_line] = STATE(452),
    [sym_preproc_pragma] = STATE(452),
    [sym_preproc_nullable] = STATE(452),
    [sym_preproc_error] = STATE(452),
    [sym_preproc_define] = STATE(452),
    [sym_preproc_undef] = STATE(452),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2365),
    [anon_sym_GT] = ACTIONS(2365),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2369),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [453] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3550),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2886),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3061),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4994),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3143),
    [sym_property_pattern_clause] = STATE(3233),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6689),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(453),
    [sym_preproc_endregion] = STATE(453),
    [sym_preproc_line] = STATE(453),
    [sym_preproc_pragma] = STATE(453),
    [sym_preproc_nullable] = STATE(453),
    [sym_preproc_error] = STATE(453),
    [sym_preproc_define] = STATE(453),
    [sym_preproc_undef] = STATE(453),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2443),
    [anon_sym_GT] = ACTIONS(2443),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(2445),
    [anon_sym_LT_EQ] = ACTIONS(2445),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2447),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [454] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3264),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2826),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2986),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5595),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3072),
    [sym_property_pattern_clause] = STATE(3130),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6684),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(454),
    [sym_preproc_endregion] = STATE(454),
    [sym_preproc_line] = STATE(454),
    [sym_preproc_pragma] = STATE(454),
    [sym_preproc_nullable] = STATE(454),
    [sym_preproc_error] = STATE(454),
    [sym_preproc_define] = STATE(454),
    [sym_preproc_undef] = STATE(454),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [455] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3548),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2910),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3080),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3173),
    [sym_property_pattern_clause] = STATE(3281),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6726),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(455),
    [sym_preproc_endregion] = STATE(455),
    [sym_preproc_line] = STATE(455),
    [sym_preproc_pragma] = STATE(455),
    [sym_preproc_nullable] = STATE(455),
    [sym_preproc_error] = STATE(455),
    [sym_preproc_define] = STATE(455),
    [sym_preproc_undef] = STATE(455),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [456] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6266),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(456),
    [sym_preproc_endregion] = STATE(456),
    [sym_preproc_line] = STATE(456),
    [sym_preproc_pragma] = STATE(456),
    [sym_preproc_nullable] = STATE(456),
    [sym_preproc_error] = STATE(456),
    [sym_preproc_define] = STATE(456),
    [sym_preproc_undef] = STATE(456),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [457] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3046),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6669),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3223),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6724),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(457),
    [sym_preproc_endregion] = STATE(457),
    [sym_preproc_line] = STATE(457),
    [sym_preproc_pragma] = STATE(457),
    [sym_preproc_nullable] = STATE(457),
    [sym_preproc_error] = STATE(457),
    [sym_preproc_define] = STATE(457),
    [sym_preproc_undef] = STATE(457),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2487),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2489),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [458] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3543),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2865),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3043),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4780),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3137),
    [sym_property_pattern_clause] = STATE(3194),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6729),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(458),
    [sym_preproc_endregion] = STATE(458),
    [sym_preproc_line] = STATE(458),
    [sym_preproc_pragma] = STATE(458),
    [sym_preproc_nullable] = STATE(458),
    [sym_preproc_error] = STATE(458),
    [sym_preproc_define] = STATE(458),
    [sym_preproc_undef] = STATE(458),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2375),
    [anon_sym_GT] = ACTIONS(2375),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2385),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [459] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3553),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2918),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6150),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3162),
    [sym_property_pattern_clause] = STATE(3256),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(459),
    [sym_preproc_endregion] = STATE(459),
    [sym_preproc_line] = STATE(459),
    [sym_preproc_pragma] = STATE(459),
    [sym_preproc_nullable] = STATE(459),
    [sym_preproc_error] = STATE(459),
    [sym_preproc_define] = STATE(459),
    [sym_preproc_undef] = STATE(459),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2419),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2421),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [460] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3553),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2918),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3162),
    [sym_property_pattern_clause] = STATE(3256),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(460),
    [sym_preproc_endregion] = STATE(460),
    [sym_preproc_line] = STATE(460),
    [sym_preproc_pragma] = STATE(460),
    [sym_preproc_nullable] = STATE(460),
    [sym_preproc_error] = STATE(460),
    [sym_preproc_define] = STATE(460),
    [sym_preproc_undef] = STATE(460),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2419),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2421),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [461] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3553),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2918),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6160),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3162),
    [sym_property_pattern_clause] = STATE(3256),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6704),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(461),
    [sym_preproc_endregion] = STATE(461),
    [sym_preproc_line] = STATE(461),
    [sym_preproc_pragma] = STATE(461),
    [sym_preproc_nullable] = STATE(461),
    [sym_preproc_error] = STATE(461),
    [sym_preproc_define] = STATE(461),
    [sym_preproc_undef] = STATE(461),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2415),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2417),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2419),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2421),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [462] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2869),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4639),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3129),
    [sym_property_pattern_clause] = STATE(3180),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(462),
    [sym_preproc_endregion] = STATE(462),
    [sym_preproc_line] = STATE(462),
    [sym_preproc_pragma] = STATE(462),
    [sym_preproc_nullable] = STATE(462),
    [sym_preproc_error] = STATE(462),
    [sym_preproc_define] = STATE(462),
    [sym_preproc_undef] = STATE(462),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2525),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [463] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3452),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2819),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2969),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5495),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3088),
    [sym_property_pattern_clause] = STATE(3134),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6686),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(463),
    [sym_preproc_endregion] = STATE(463),
    [sym_preproc_line] = STATE(463),
    [sym_preproc_pragma] = STATE(463),
    [sym_preproc_nullable] = STATE(463),
    [sym_preproc_error] = STATE(463),
    [sym_preproc_define] = STATE(463),
    [sym_preproc_undef] = STATE(463),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2537),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_GT_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2549),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [464] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3544),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3073),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4994),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3163),
    [sym_property_pattern_clause] = STATE(3335),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6735),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(464),
    [sym_preproc_endregion] = STATE(464),
    [sym_preproc_line] = STATE(464),
    [sym_preproc_pragma] = STATE(464),
    [sym_preproc_nullable] = STATE(464),
    [sym_preproc_error] = STATE(464),
    [sym_preproc_define] = STATE(464),
    [sym_preproc_undef] = STATE(464),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2585),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [465] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3554),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2903),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3087),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6373),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3306),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6732),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(465),
    [sym_preproc_endregion] = STATE(465),
    [sym_preproc_line] = STATE(465),
    [sym_preproc_pragma] = STATE(465),
    [sym_preproc_nullable] = STATE(465),
    [sym_preproc_error] = STATE(465),
    [sym_preproc_define] = STATE(465),
    [sym_preproc_undef] = STATE(465),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(2567),
    [anon_sym_LT_EQ] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [466] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2807),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6731),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(466),
    [sym_preproc_endregion] = STATE(466),
    [sym_preproc_line] = STATE(466),
    [sym_preproc_pragma] = STATE(466),
    [sym_preproc_nullable] = STATE(466),
    [sym_preproc_error] = STATE(466),
    [sym_preproc_define] = STATE(466),
    [sym_preproc_undef] = STATE(466),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2473),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_GT_EQ] = ACTIONS(2477),
    [anon_sym_LT_EQ] = ACTIONS(2477),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2479),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [467] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2808),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5300),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6703),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(467),
    [sym_preproc_endregion] = STATE(467),
    [sym_preproc_line] = STATE(467),
    [sym_preproc_pragma] = STATE(467),
    [sym_preproc_nullable] = STATE(467),
    [sym_preproc_error] = STATE(467),
    [sym_preproc_define] = STATE(467),
    [sym_preproc_undef] = STATE(467),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1085),
    [anon_sym_LT_EQ] = ACTIONS(1085),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [468] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(468),
    [sym_preproc_endregion] = STATE(468),
    [sym_preproc_line] = STATE(468),
    [sym_preproc_pragma] = STATE(468),
    [sym_preproc_nullable] = STATE(468),
    [sym_preproc_error] = STATE(468),
    [sym_preproc_define] = STATE(468),
    [sym_preproc_undef] = STATE(468),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2409),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2413),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [469] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3053),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6293),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6696),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(469),
    [sym_preproc_endregion] = STATE(469),
    [sym_preproc_line] = STATE(469),
    [sym_preproc_pragma] = STATE(469),
    [sym_preproc_nullable] = STATE(469),
    [sym_preproc_error] = STATE(469),
    [sym_preproc_define] = STATE(469),
    [sym_preproc_undef] = STATE(469),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [470] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3053),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6696),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(470),
    [sym_preproc_endregion] = STATE(470),
    [sym_preproc_line] = STATE(470),
    [sym_preproc_pragma] = STATE(470),
    [sym_preproc_nullable] = STATE(470),
    [sym_preproc_error] = STATE(470),
    [sym_preproc_define] = STATE(470),
    [sym_preproc_undef] = STATE(470),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [471] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3057),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(471),
    [sym_preproc_endregion] = STATE(471),
    [sym_preproc_line] = STATE(471),
    [sym_preproc_pragma] = STATE(471),
    [sym_preproc_nullable] = STATE(471),
    [sym_preproc_error] = STATE(471),
    [sym_preproc_define] = STATE(471),
    [sym_preproc_undef] = STATE(471),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [472] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3053),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6259),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6696),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(472),
    [sym_preproc_endregion] = STATE(472),
    [sym_preproc_line] = STATE(472),
    [sym_preproc_pragma] = STATE(472),
    [sym_preproc_nullable] = STATE(472),
    [sym_preproc_error] = STATE(472),
    [sym_preproc_define] = STATE(472),
    [sym_preproc_undef] = STATE(472),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2555),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2557),
    [anon_sym_GT] = ACTIONS(2557),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2561),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [473] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2800),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4771),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(473),
    [sym_preproc_endregion] = STATE(473),
    [sym_preproc_line] = STATE(473),
    [sym_preproc_pragma] = STATE(473),
    [sym_preproc_nullable] = STATE(473),
    [sym_preproc_error] = STATE(473),
    [sym_preproc_define] = STATE(473),
    [sym_preproc_undef] = STATE(473),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2409),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2413),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [474] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(2993),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4837),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6699),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(474),
    [sym_preproc_endregion] = STATE(474),
    [sym_preproc_line] = STATE(474),
    [sym_preproc_pragma] = STATE(474),
    [sym_preproc_nullable] = STATE(474),
    [sym_preproc_error] = STATE(474),
    [sym_preproc_define] = STATE(474),
    [sym_preproc_undef] = STATE(474),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2407),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2409),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(2411),
    [anon_sym_LT_EQ] = ACTIONS(2411),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2413),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [475] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6640),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(475),
    [sym_preproc_endregion] = STATE(475),
    [sym_preproc_line] = STATE(475),
    [sym_preproc_pragma] = STATE(475),
    [sym_preproc_nullable] = STATE(475),
    [sym_preproc_error] = STATE(475),
    [sym_preproc_define] = STATE(475),
    [sym_preproc_undef] = STATE(475),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [476] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(476),
    [sym_preproc_endregion] = STATE(476),
    [sym_preproc_line] = STATE(476),
    [sym_preproc_pragma] = STATE(476),
    [sym_preproc_nullable] = STATE(476),
    [sym_preproc_error] = STATE(476),
    [sym_preproc_define] = STATE(476),
    [sym_preproc_undef] = STATE(476),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [477] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3543),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2865),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3052),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4888),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3137),
    [sym_property_pattern_clause] = STATE(3194),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6729),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(477),
    [sym_preproc_endregion] = STATE(477),
    [sym_preproc_line] = STATE(477),
    [sym_preproc_pragma] = STATE(477),
    [sym_preproc_nullable] = STATE(477),
    [sym_preproc_error] = STATE(477),
    [sym_preproc_define] = STATE(477),
    [sym_preproc_undef] = STATE(477),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2375),
    [anon_sym_GT] = ACTIONS(2375),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2385),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [478] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3041),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6552),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(478),
    [sym_preproc_endregion] = STATE(478),
    [sym_preproc_line] = STATE(478),
    [sym_preproc_pragma] = STATE(478),
    [sym_preproc_nullable] = STATE(478),
    [sym_preproc_error] = STATE(478),
    [sym_preproc_define] = STATE(478),
    [sym_preproc_undef] = STATE(478),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [479] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6307),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6709),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(479),
    [sym_preproc_endregion] = STATE(479),
    [sym_preproc_line] = STATE(479),
    [sym_preproc_pragma] = STATE(479),
    [sym_preproc_nullable] = STATE(479),
    [sym_preproc_error] = STATE(479),
    [sym_preproc_define] = STATE(479),
    [sym_preproc_undef] = STATE(479),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2345),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2359),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [480] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3544),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5025),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3163),
    [sym_property_pattern_clause] = STATE(3335),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6735),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(480),
    [sym_preproc_endregion] = STATE(480),
    [sym_preproc_line] = STATE(480),
    [sym_preproc_pragma] = STATE(480),
    [sym_preproc_nullable] = STATE(480),
    [sym_preproc_error] = STATE(480),
    [sym_preproc_define] = STATE(480),
    [sym_preproc_undef] = STATE(480),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2585),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [481] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3226),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5369),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6738),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(481),
    [sym_preproc_endregion] = STATE(481),
    [sym_preproc_line] = STATE(481),
    [sym_preproc_pragma] = STATE(481),
    [sym_preproc_nullable] = STATE(481),
    [sym_preproc_error] = STATE(481),
    [sym_preproc_define] = STATE(481),
    [sym_preproc_undef] = STATE(481),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2325),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [482] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3547),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2911),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4051),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3157),
    [sym_property_pattern_clause] = STATE(3235),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6718),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(482),
    [sym_preproc_endregion] = STATE(482),
    [sym_preproc_line] = STATE(482),
    [sym_preproc_pragma] = STATE(482),
    [sym_preproc_nullable] = STATE(482),
    [sym_preproc_error] = STATE(482),
    [sym_preproc_define] = STATE(482),
    [sym_preproc_undef] = STATE(482),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2387),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2389),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2391),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2393),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [483] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3541),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2869),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3031),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4713),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3129),
    [sym_property_pattern_clause] = STATE(3180),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6683),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(483),
    [sym_preproc_endregion] = STATE(483),
    [sym_preproc_line] = STATE(483),
    [sym_preproc_pragma] = STATE(483),
    [sym_preproc_nullable] = STATE(483),
    [sym_preproc_error] = STATE(483),
    [sym_preproc_define] = STATE(483),
    [sym_preproc_undef] = STATE(483),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2519),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2521),
    [anon_sym_GT] = ACTIONS(2521),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(2523),
    [anon_sym_LT_EQ] = ACTIONS(2523),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2525),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [484] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6139),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(484),
    [sym_preproc_endregion] = STATE(484),
    [sym_preproc_line] = STATE(484),
    [sym_preproc_pragma] = STATE(484),
    [sym_preproc_nullable] = STATE(484),
    [sym_preproc_error] = STATE(484),
    [sym_preproc_define] = STATE(484),
    [sym_preproc_undef] = STATE(484),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [485] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6479),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(485),
    [sym_preproc_endregion] = STATE(485),
    [sym_preproc_line] = STATE(485),
    [sym_preproc_pragma] = STATE(485),
    [sym_preproc_nullable] = STATE(485),
    [sym_preproc_error] = STATE(485),
    [sym_preproc_define] = STATE(485),
    [sym_preproc_undef] = STATE(485),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [486] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3000),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3048),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3136),
    [sym_property_pattern_clause] = STATE(3223),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6724),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(486),
    [sym_preproc_endregion] = STATE(486),
    [sym_preproc_line] = STATE(486),
    [sym_preproc_pragma] = STATE(486),
    [sym_preproc_nullable] = STATE(486),
    [sym_preproc_error] = STATE(486),
    [sym_preproc_define] = STATE(486),
    [sym_preproc_undef] = STATE(486),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2483),
    [anon_sym_GT] = ACTIONS(2483),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(2485),
    [anon_sym_LT_EQ] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2487),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2489),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [487] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3264),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2826),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2966),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5715),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3072),
    [sym_property_pattern_clause] = STATE(3130),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6684),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(487),
    [sym_preproc_endregion] = STATE(487),
    [sym_preproc_line] = STATE(487),
    [sym_preproc_pragma] = STATE(487),
    [sym_preproc_nullable] = STATE(487),
    [sym_preproc_error] = STATE(487),
    [sym_preproc_define] = STATE(487),
    [sym_preproc_undef] = STATE(487),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [488] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3264),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2826),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2966),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5557),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3072),
    [sym_property_pattern_clause] = STATE(3130),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6684),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(488),
    [sym_preproc_endregion] = STATE(488),
    [sym_preproc_line] = STATE(488),
    [sym_preproc_pragma] = STATE(488),
    [sym_preproc_nullable] = STATE(488),
    [sym_preproc_error] = STATE(488),
    [sym_preproc_define] = STATE(488),
    [sym_preproc_undef] = STATE(488),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [489] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3544),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3075),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5023),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3163),
    [sym_property_pattern_clause] = STATE(3335),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6735),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(489),
    [sym_preproc_endregion] = STATE(489),
    [sym_preproc_line] = STATE(489),
    [sym_preproc_pragma] = STATE(489),
    [sym_preproc_nullable] = STATE(489),
    [sym_preproc_error] = STATE(489),
    [sym_preproc_define] = STATE(489),
    [sym_preproc_undef] = STATE(489),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2585),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [490] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3548),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2910),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3079),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6433),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3173),
    [sym_property_pattern_clause] = STATE(3281),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6726),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(490),
    [sym_preproc_endregion] = STATE(490),
    [sym_preproc_line] = STATE(490),
    [sym_preproc_pragma] = STATE(490),
    [sym_preproc_nullable] = STATE(490),
    [sym_preproc_error] = STATE(490),
    [sym_preproc_define] = STATE(490),
    [sym_preproc_undef] = STATE(490),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [491] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3542),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6275),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(491),
    [sym_preproc_endregion] = STATE(491),
    [sym_preproc_line] = STATE(491),
    [sym_preproc_pragma] = STATE(491),
    [sym_preproc_nullable] = STATE(491),
    [sym_preproc_error] = STATE(491),
    [sym_preproc_define] = STATE(491),
    [sym_preproc_undef] = STATE(491),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2405),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [492] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3538),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3032),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4161),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6692),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(492),
    [sym_preproc_endregion] = STATE(492),
    [sym_preproc_line] = STATE(492),
    [sym_preproc_pragma] = STATE(492),
    [sym_preproc_nullable] = STATE(492),
    [sym_preproc_error] = STATE(492),
    [sym_preproc_define] = STATE(492),
    [sym_preproc_undef] = STATE(492),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2355),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [493] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3264),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2826),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2966),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5596),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3072),
    [sym_property_pattern_clause] = STATE(3130),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6684),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(493),
    [sym_preproc_endregion] = STATE(493),
    [sym_preproc_line] = STATE(493),
    [sym_preproc_pragma] = STATE(493),
    [sym_preproc_nullable] = STATE(493),
    [sym_preproc_error] = STATE(493),
    [sym_preproc_define] = STATE(493),
    [sym_preproc_undef] = STATE(493),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [494] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3264),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2826),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(2951),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_pattern] = STATE(5495),
    [sym_constant_pattern] = STATE(5574),
    [sym_parenthesized_pattern] = STATE(5574),
    [sym_var_pattern] = STATE(5574),
    [sym_type_pattern] = STATE(5574),
    [sym_list_pattern] = STATE(5574),
    [sym_recursive_pattern] = STATE(5574),
    [sym_positional_pattern_clause] = STATE(3072),
    [sym_property_pattern_clause] = STATE(3130),
    [sym_relational_pattern] = STATE(5574),
    [sym_negated_pattern] = STATE(5574),
    [sym_and_pattern] = STATE(5574),
    [sym_or_pattern] = STATE(5574),
    [sym_declaration_pattern] = STATE(5574),
    [sym_expression] = STATE(6684),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5514),
    [sym_postfix_unary_expression] = STATE(5513),
    [sym_prefix_unary_expression] = STATE(5513),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5514),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5513),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5514),
    [sym_member_access_expression] = STATE(3937),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5513),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5514),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5514),
    [sym_typeof_expression] = STATE(5514),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3937),
    [sym_literal] = STATE(5514),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(494),
    [sym_preproc_endregion] = STATE(494),
    [sym_preproc_line] = STATE(494),
    [sym_preproc_pragma] = STATE(494),
    [sym_preproc_nullable] = STATE(494),
    [sym_preproc_error] = STATE(494),
    [sym_preproc_define] = STATE(494),
    [sym_preproc_undef] = STATE(494),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2527),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_GT] = ACTIONS(2573),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2575),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2543),
    [sym_predefined_type] = ACTIONS(2545),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2547),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [495] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3537),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6112),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(495),
    [sym_preproc_endregion] = STATE(495),
    [sym_preproc_line] = STATE(495),
    [sym_preproc_pragma] = STATE(495),
    [sym_preproc_nullable] = STATE(495),
    [sym_preproc_error] = STATE(495),
    [sym_preproc_define] = STATE(495),
    [sym_preproc_undef] = STATE(495),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2463),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [496] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3543),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2865),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3028),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4713),
    [sym_constant_pattern] = STATE(4555),
    [sym_parenthesized_pattern] = STATE(4555),
    [sym_var_pattern] = STATE(4555),
    [sym_type_pattern] = STATE(4555),
    [sym_list_pattern] = STATE(4555),
    [sym_recursive_pattern] = STATE(4555),
    [sym_positional_pattern_clause] = STATE(3137),
    [sym_property_pattern_clause] = STATE(3194),
    [sym_relational_pattern] = STATE(4555),
    [sym_negated_pattern] = STATE(4555),
    [sym_and_pattern] = STATE(4555),
    [sym_or_pattern] = STATE(4555),
    [sym_declaration_pattern] = STATE(4555),
    [sym_expression] = STATE(6729),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4629),
    [sym_postfix_unary_expression] = STATE(4630),
    [sym_prefix_unary_expression] = STATE(4630),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4629),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4630),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4629),
    [sym_member_access_expression] = STATE(3581),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4630),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4629),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4629),
    [sym_typeof_expression] = STATE(4629),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3581),
    [sym_literal] = STATE(4629),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(496),
    [sym_preproc_endregion] = STATE(496),
    [sym_preproc_line] = STATE(496),
    [sym_preproc_pragma] = STATE(496),
    [sym_preproc_nullable] = STATE(496),
    [sym_preproc_error] = STATE(496),
    [sym_preproc_define] = STATE(496),
    [sym_preproc_undef] = STATE(496),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2371),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2375),
    [anon_sym_GT] = ACTIONS(2375),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2379),
    [sym_predefined_type] = ACTIONS(2381),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2383),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2385),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [497] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3537),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(497),
    [sym_preproc_endregion] = STATE(497),
    [sym_preproc_line] = STATE(497),
    [sym_preproc_pragma] = STATE(497),
    [sym_preproc_nullable] = STATE(497),
    [sym_preproc_error] = STATE(497),
    [sym_preproc_define] = STATE(497),
    [sym_preproc_undef] = STATE(497),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2463),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [498] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3554),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2903),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3071),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6366),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3151),
    [sym_property_pattern_clause] = STATE(3306),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6732),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(498),
    [sym_preproc_endregion] = STATE(498),
    [sym_preproc_line] = STATE(498),
    [sym_preproc_pragma] = STATE(498),
    [sym_preproc_nullable] = STATE(498),
    [sym_preproc_error] = STATE(498),
    [sym_preproc_define] = STATE(498),
    [sym_preproc_undef] = STATE(498),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2563),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2565),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(2567),
    [anon_sym_LT_EQ] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [499] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(499),
    [sym_preproc_endregion] = STATE(499),
    [sym_preproc_line] = STATE(499),
    [sym_preproc_pragma] = STATE(499),
    [sym_preproc_nullable] = STATE(499),
    [sym_preproc_error] = STATE(499),
    [sym_preproc_define] = STATE(499),
    [sym_preproc_undef] = STATE(499),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [500] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3219),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2763),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2809),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6553),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(2856),
    [sym_property_pattern_clause] = STATE(2882),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6710),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(500),
    [sym_preproc_endregion] = STATE(500),
    [sym_preproc_line] = STATE(500),
    [sym_preproc_pragma] = STATE(500),
    [sym_preproc_nullable] = STATE(500),
    [sym_preproc_error] = STATE(500),
    [sym_preproc_define] = STATE(500),
    [sym_preproc_undef] = STATE(500),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2433),
    [anon_sym_GT] = ACTIONS(2433),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_GT_EQ] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2435),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [501] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3542),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(501),
    [sym_preproc_endregion] = STATE(501),
    [sym_preproc_line] = STATE(501),
    [sym_preproc_pragma] = STATE(501),
    [sym_preproc_nullable] = STATE(501),
    [sym_preproc_error] = STATE(501),
    [sym_preproc_define] = STATE(501),
    [sym_preproc_undef] = STATE(501),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2405),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [502] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3542),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2859),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3044),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6166),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3102),
    [sym_property_pattern_clause] = STATE(3153),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6705),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(502),
    [sym_preproc_endregion] = STATE(502),
    [sym_preproc_line] = STATE(502),
    [sym_preproc_pragma] = STATE(502),
    [sym_preproc_nullable] = STATE(502),
    [sym_preproc_error] = STATE(502),
    [sym_preproc_define] = STATE(502),
    [sym_preproc_undef] = STATE(502),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2397),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2405),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [503] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6749),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2844),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6167),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_pattern] = STATE(8096),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(6719),
    [sym_property_pattern_clause] = STATE(6769),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6328),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(6151),
    [sym_postfix_unary_expression] = STATE(6158),
    [sym_prefix_unary_expression] = STATE(6158),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(6151),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(6158),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(6151),
    [sym_member_access_expression] = STATE(4160),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(6158),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(6151),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(6151),
    [sym_typeof_expression] = STATE(6151),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(4160),
    [sym_literal] = STATE(6151),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(503),
    [sym_preproc_endregion] = STATE(503),
    [sym_preproc_line] = STATE(503),
    [sym_preproc_pragma] = STATE(503),
    [sym_preproc_nullable] = STATE(503),
    [sym_preproc_error] = STATE(503),
    [sym_preproc_define] = STATE(503),
    [sym_preproc_undef] = STATE(503),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_ref] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(2401),
    [anon_sym_LT_EQ] = ACTIONS(2401),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2507),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_not] = ACTIONS(2509),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [504] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3226),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2800),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5262),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6738),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(504),
    [sym_preproc_endregion] = STATE(504),
    [sym_preproc_line] = STATE(504),
    [sym_preproc_pragma] = STATE(504),
    [sym_preproc_nullable] = STATE(504),
    [sym_preproc_error] = STATE(504),
    [sym_preproc_define] = STATE(504),
    [sym_preproc_undef] = STATE(504),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2325),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [505] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3537),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2858),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3036),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5934),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(3120),
    [sym_property_pattern_clause] = STATE(3171),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6706),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(505),
    [sym_preproc_endregion] = STATE(505),
    [sym_preproc_line] = STATE(505),
    [sym_preproc_pragma] = STATE(505),
    [sym_preproc_nullable] = STATE(505),
    [sym_preproc_error] = STATE(505),
    [sym_preproc_define] = STATE(505),
    [sym_preproc_undef] = STATE(505),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2457),
    [anon_sym_GT] = ACTIONS(2457),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_GT_EQ] = ACTIONS(2459),
    [anon_sym_LT_EQ] = ACTIONS(2459),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2461),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2463),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [506] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3548),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2910),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3079),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(6638),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3173),
    [sym_property_pattern_clause] = STATE(3281),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6726),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(506),
    [sym_preproc_endregion] = STATE(506),
    [sym_preproc_line] = STATE(506),
    [sym_preproc_pragma] = STATE(506),
    [sym_preproc_nullable] = STATE(506),
    [sym_preproc_error] = STATE(506),
    [sym_preproc_define] = STATE(506),
    [sym_preproc_undef] = STATE(506),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [507] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3548),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2910),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3079),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4198),
    [sym_constant_pattern] = STATE(4272),
    [sym_parenthesized_pattern] = STATE(4272),
    [sym_var_pattern] = STATE(4272),
    [sym_type_pattern] = STATE(4272),
    [sym_list_pattern] = STATE(4272),
    [sym_recursive_pattern] = STATE(4272),
    [sym_positional_pattern_clause] = STATE(3173),
    [sym_property_pattern_clause] = STATE(3281),
    [sym_relational_pattern] = STATE(4272),
    [sym_negated_pattern] = STATE(4272),
    [sym_and_pattern] = STATE(4272),
    [sym_or_pattern] = STATE(4272),
    [sym_declaration_pattern] = STATE(4272),
    [sym_expression] = STATE(6726),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4287),
    [sym_postfix_unary_expression] = STATE(4295),
    [sym_prefix_unary_expression] = STATE(4295),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4287),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4295),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4287),
    [sym_member_access_expression] = STATE(3468),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4295),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4287),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4287),
    [sym_typeof_expression] = STATE(4287),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3468),
    [sym_literal] = STATE(4287),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(507),
    [sym_preproc_endregion] = STATE(507),
    [sym_preproc_line] = STATE(507),
    [sym_preproc_pragma] = STATE(507),
    [sym_preproc_nullable] = STATE(507),
    [sym_preproc_error] = STATE(507),
    [sym_preproc_define] = STATE(507),
    [sym_preproc_undef] = STATE(507),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2427),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2403),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [508] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3226),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5364),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6738),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(508),
    [sym_preproc_endregion] = STATE(508),
    [sym_preproc_line] = STATE(508),
    [sym_preproc_pragma] = STATE(508),
    [sym_preproc_nullable] = STATE(508),
    [sym_preproc_error] = STATE(508),
    [sym_preproc_define] = STATE(508),
    [sym_preproc_undef] = STATE(508),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2325),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [509] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3226),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2762),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2802),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4017),
    [sym_constant_pattern] = STATE(4045),
    [sym_parenthesized_pattern] = STATE(4045),
    [sym_var_pattern] = STATE(4045),
    [sym_type_pattern] = STATE(4045),
    [sym_list_pattern] = STATE(4045),
    [sym_recursive_pattern] = STATE(4045),
    [sym_positional_pattern_clause] = STATE(2827),
    [sym_property_pattern_clause] = STATE(2876),
    [sym_relational_pattern] = STATE(4045),
    [sym_negated_pattern] = STATE(4045),
    [sym_and_pattern] = STATE(4045),
    [sym_or_pattern] = STATE(4045),
    [sym_declaration_pattern] = STATE(4045),
    [sym_expression] = STATE(6738),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(4020),
    [sym_postfix_unary_expression] = STATE(4021),
    [sym_prefix_unary_expression] = STATE(4021),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(4020),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(4021),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(4020),
    [sym_member_access_expression] = STATE(3203),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(4021),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(4020),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(4020),
    [sym_typeof_expression] = STATE(4020),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3203),
    [sym_literal] = STATE(4020),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(509),
    [sym_preproc_endregion] = STATE(509),
    [sym_preproc_line] = STATE(509),
    [sym_preproc_pragma] = STATE(509),
    [sym_preproc_nullable] = STATE(509),
    [sym_preproc_error] = STATE(509),
    [sym_preproc_define] = STATE(509),
    [sym_preproc_undef] = STATE(509),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2323),
    [anon_sym_LPAREN] = ACTIONS(2325),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2331),
    [anon_sym_GT] = ACTIONS(2331),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(2333),
    [anon_sym_LT_EQ] = ACTIONS(2333),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2337),
    [sym_predefined_type] = ACTIONS(2339),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2341),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [510] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3544),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3075),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(5001),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3163),
    [sym_property_pattern_clause] = STATE(3335),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6735),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(510),
    [sym_preproc_endregion] = STATE(510),
    [sym_preproc_line] = STATE(510),
    [sym_preproc_pragma] = STATE(510),
    [sym_preproc_nullable] = STATE(510),
    [sym_preproc_error] = STATE(510),
    [sym_preproc_define] = STATE(510),
    [sym_preproc_undef] = STATE(510),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2585),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [511] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3544),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2908),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(3075),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_pattern] = STATE(4992),
    [sym_constant_pattern] = STATE(5027),
    [sym_parenthesized_pattern] = STATE(5027),
    [sym_var_pattern] = STATE(5027),
    [sym_type_pattern] = STATE(5027),
    [sym_list_pattern] = STATE(5027),
    [sym_recursive_pattern] = STATE(5027),
    [sym_positional_pattern_clause] = STATE(3163),
    [sym_property_pattern_clause] = STATE(3335),
    [sym_relational_pattern] = STATE(5027),
    [sym_negated_pattern] = STATE(5027),
    [sym_and_pattern] = STATE(5027),
    [sym_or_pattern] = STATE(5027),
    [sym_declaration_pattern] = STATE(5027),
    [sym_expression] = STATE(6735),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(5038),
    [sym_postfix_unary_expression] = STATE(5039),
    [sym_prefix_unary_expression] = STATE(5039),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(5038),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(5039),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(5038),
    [sym_member_access_expression] = STATE(3752),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(5039),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(5038),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(5038),
    [sym_typeof_expression] = STATE(5038),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3752),
    [sym_literal] = STATE(5038),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(511),
    [sym_preproc_endregion] = STATE(511),
    [sym_preproc_line] = STATE(511),
    [sym_preproc_pragma] = STATE(511),
    [sym_preproc_nullable] = STATE(511),
    [sym_preproc_error] = STATE(511),
    [sym_preproc_define] = STATE(511),
    [sym_preproc_undef] = STATE(511),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(2585),
    [anon_sym_GT] = ACTIONS(2585),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(2587),
    [anon_sym_LT_EQ] = ACTIONS(2587),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2449),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [sym_discard] = ACTIONS(2451),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_not] = ACTIONS(2591),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [512] = {
    [sym_attribute] = STATE(8641),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6803),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(512),
    [sym_preproc_endregion] = STATE(512),
    [sym_preproc_line] = STATE(512),
    [sym_preproc_pragma] = STATE(512),
    [sym_preproc_nullable] = STATE(512),
    [sym_preproc_error] = STATE(512),
    [sym_preproc_define] = STATE(512),
    [sym_preproc_undef] = STATE(512),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_assembly] = ACTIONS(2595),
    [anon_sym_module] = ACTIONS(2595),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [513] = {
    [sym_attribute] = STATE(8641),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6803),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(513),
    [sym_preproc_endregion] = STATE(513),
    [sym_preproc_line] = STATE(513),
    [sym_preproc_pragma] = STATE(513),
    [sym_preproc_nullable] = STATE(513),
    [sym_preproc_error] = STATE(513),
    [sym_preproc_define] = STATE(513),
    [sym_preproc_undef] = STATE(513),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_assembly] = ACTIONS(2599),
    [anon_sym_module] = ACTIONS(2599),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [514] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(514),
    [sym_preproc_endregion] = STATE(514),
    [sym_preproc_line] = STATE(514),
    [sym_preproc_pragma] = STATE(514),
    [sym_preproc_nullable] = STATE(514),
    [sym_preproc_error] = STATE(514),
    [sym_preproc_define] = STATE(514),
    [sym_preproc_undef] = STATE(514),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [515] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8433),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(515),
    [sym_preproc_endregion] = STATE(515),
    [sym_preproc_line] = STATE(515),
    [sym_preproc_pragma] = STATE(515),
    [sym_preproc_nullable] = STATE(515),
    [sym_preproc_error] = STATE(515),
    [sym_preproc_define] = STATE(515),
    [sym_preproc_undef] = STATE(515),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [516] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8479),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(516),
    [sym_preproc_endregion] = STATE(516),
    [sym_preproc_line] = STATE(516),
    [sym_preproc_pragma] = STATE(516),
    [sym_preproc_nullable] = STATE(516),
    [sym_preproc_error] = STATE(516),
    [sym_preproc_define] = STATE(516),
    [sym_preproc_undef] = STATE(516),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [517] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8609),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(517),
    [sym_preproc_endregion] = STATE(517),
    [sym_preproc_line] = STATE(517),
    [sym_preproc_pragma] = STATE(517),
    [sym_preproc_nullable] = STATE(517),
    [sym_preproc_error] = STATE(517),
    [sym_preproc_define] = STATE(517),
    [sym_preproc_undef] = STATE(517),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [518] = {
    [sym_attribute] = STATE(8434),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6816),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(518),
    [sym_preproc_endregion] = STATE(518),
    [sym_preproc_line] = STATE(518),
    [sym_preproc_pragma] = STATE(518),
    [sym_preproc_nullable] = STATE(518),
    [sym_preproc_error] = STATE(518),
    [sym_preproc_define] = STATE(518),
    [sym_preproc_undef] = STATE(518),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [519] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8401),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(519),
    [sym_preproc_endregion] = STATE(519),
    [sym_preproc_line] = STATE(519),
    [sym_preproc_pragma] = STATE(519),
    [sym_preproc_nullable] = STATE(519),
    [sym_preproc_error] = STATE(519),
    [sym_preproc_define] = STATE(519),
    [sym_preproc_undef] = STATE(519),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [520] = {
    [sym_attribute] = STATE(8480),
    [sym_attribute_list] = STATE(6722),
    [sym_attribute_target_specifier] = STATE(6810),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8486),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6799),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(520),
    [sym_preproc_endregion] = STATE(520),
    [sym_preproc_line] = STATE(520),
    [sym_preproc_pragma] = STATE(520),
    [sym_preproc_nullable] = STATE(520),
    [sym_preproc_error] = STATE(520),
    [sym_preproc_define] = STATE(520),
    [sym_preproc_undef] = STATE(520),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_field] = ACTIONS(1067),
    [anon_sym_event] = ACTIONS(1067),
    [anon_sym_method] = ACTIONS(1067),
    [anon_sym_param] = ACTIONS(1067),
    [anon_sym_property] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1067),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [521] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4419),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(521),
    [sym_preproc_endregion] = STATE(521),
    [sym_preproc_line] = STATE(521),
    [sym_preproc_pragma] = STATE(521),
    [sym_preproc_nullable] = STATE(521),
    [sym_preproc_error] = STATE(521),
    [sym_preproc_define] = STATE(521),
    [sym_preproc_undef] = STATE(521),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [522] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6896),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(522),
    [sym_preproc_endregion] = STATE(522),
    [sym_preproc_line] = STATE(522),
    [sym_preproc_pragma] = STATE(522),
    [sym_preproc_nullable] = STATE(522),
    [sym_preproc_error] = STATE(522),
    [sym_preproc_define] = STATE(522),
    [sym_preproc_undef] = STATE(522),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [523] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6868),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(523),
    [sym_preproc_endregion] = STATE(523),
    [sym_preproc_line] = STATE(523),
    [sym_preproc_pragma] = STATE(523),
    [sym_preproc_nullable] = STATE(523),
    [sym_preproc_error] = STATE(523),
    [sym_preproc_define] = STATE(523),
    [sym_preproc_undef] = STATE(523),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [524] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6867),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(524),
    [sym_preproc_endregion] = STATE(524),
    [sym_preproc_line] = STATE(524),
    [sym_preproc_pragma] = STATE(524),
    [sym_preproc_nullable] = STATE(524),
    [sym_preproc_error] = STATE(524),
    [sym_preproc_define] = STATE(524),
    [sym_preproc_undef] = STATE(524),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [525] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6883),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(525),
    [sym_preproc_endregion] = STATE(525),
    [sym_preproc_line] = STATE(525),
    [sym_preproc_pragma] = STATE(525),
    [sym_preproc_nullable] = STATE(525),
    [sym_preproc_error] = STATE(525),
    [sym_preproc_define] = STATE(525),
    [sym_preproc_undef] = STATE(525),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [526] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6887),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(526),
    [sym_preproc_endregion] = STATE(526),
    [sym_preproc_line] = STATE(526),
    [sym_preproc_pragma] = STATE(526),
    [sym_preproc_nullable] = STATE(526),
    [sym_preproc_error] = STATE(526),
    [sym_preproc_define] = STATE(526),
    [sym_preproc_undef] = STATE(526),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [527] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6865),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(527),
    [sym_preproc_endregion] = STATE(527),
    [sym_preproc_line] = STATE(527),
    [sym_preproc_pragma] = STATE(527),
    [sym_preproc_nullable] = STATE(527),
    [sym_preproc_error] = STATE(527),
    [sym_preproc_define] = STATE(527),
    [sym_preproc_undef] = STATE(527),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [528] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6863),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(528),
    [sym_preproc_endregion] = STATE(528),
    [sym_preproc_line] = STATE(528),
    [sym_preproc_pragma] = STATE(528),
    [sym_preproc_nullable] = STATE(528),
    [sym_preproc_error] = STATE(528),
    [sym_preproc_define] = STATE(528),
    [sym_preproc_undef] = STATE(528),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [529] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6880),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(529),
    [sym_preproc_endregion] = STATE(529),
    [sym_preproc_line] = STATE(529),
    [sym_preproc_pragma] = STATE(529),
    [sym_preproc_nullable] = STATE(529),
    [sym_preproc_error] = STATE(529),
    [sym_preproc_define] = STATE(529),
    [sym_preproc_undef] = STATE(529),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [530] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6899),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(530),
    [sym_preproc_endregion] = STATE(530),
    [sym_preproc_line] = STATE(530),
    [sym_preproc_pragma] = STATE(530),
    [sym_preproc_nullable] = STATE(530),
    [sym_preproc_error] = STATE(530),
    [sym_preproc_define] = STATE(530),
    [sym_preproc_undef] = STATE(530),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [531] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6821),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(531),
    [sym_preproc_endregion] = STATE(531),
    [sym_preproc_line] = STATE(531),
    [sym_preproc_pragma] = STATE(531),
    [sym_preproc_nullable] = STATE(531),
    [sym_preproc_error] = STATE(531),
    [sym_preproc_define] = STATE(531),
    [sym_preproc_undef] = STATE(531),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [532] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6853),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4382),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(532),
    [sym_preproc_endregion] = STATE(532),
    [sym_preproc_line] = STATE(532),
    [sym_preproc_pragma] = STATE(532),
    [sym_preproc_nullable] = STATE(532),
    [sym_preproc_error] = STATE(532),
    [sym_preproc_define] = STATE(532),
    [sym_preproc_undef] = STATE(532),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [533] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6862),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(533),
    [sym_preproc_endregion] = STATE(533),
    [sym_preproc_line] = STATE(533),
    [sym_preproc_pragma] = STATE(533),
    [sym_preproc_nullable] = STATE(533),
    [sym_preproc_error] = STATE(533),
    [sym_preproc_define] = STATE(533),
    [sym_preproc_undef] = STATE(533),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [534] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4382),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(534),
    [sym_preproc_endregion] = STATE(534),
    [sym_preproc_line] = STATE(534),
    [sym_preproc_pragma] = STATE(534),
    [sym_preproc_nullable] = STATE(534),
    [sym_preproc_error] = STATE(534),
    [sym_preproc_define] = STATE(534),
    [sym_preproc_undef] = STATE(534),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [535] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8917),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(535),
    [sym_preproc_endregion] = STATE(535),
    [sym_preproc_line] = STATE(535),
    [sym_preproc_pragma] = STATE(535),
    [sym_preproc_nullable] = STATE(535),
    [sym_preproc_error] = STATE(535),
    [sym_preproc_define] = STATE(535),
    [sym_preproc_undef] = STATE(535),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [536] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6841),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4419),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(536),
    [sym_preproc_endregion] = STATE(536),
    [sym_preproc_line] = STATE(536),
    [sym_preproc_pragma] = STATE(536),
    [sym_preproc_nullable] = STATE(536),
    [sym_preproc_error] = STATE(536),
    [sym_preproc_define] = STATE(536),
    [sym_preproc_undef] = STATE(536),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [537] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6879),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4419),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(537),
    [sym_preproc_endregion] = STATE(537),
    [sym_preproc_line] = STATE(537),
    [sym_preproc_pragma] = STATE(537),
    [sym_preproc_nullable] = STATE(537),
    [sym_preproc_error] = STATE(537),
    [sym_preproc_define] = STATE(537),
    [sym_preproc_undef] = STATE(537),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [538] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(538),
    [sym_preproc_endregion] = STATE(538),
    [sym_preproc_line] = STATE(538),
    [sym_preproc_pragma] = STATE(538),
    [sym_preproc_nullable] = STATE(538),
    [sym_preproc_error] = STATE(538),
    [sym_preproc_define] = STATE(538),
    [sym_preproc_undef] = STATE(538),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [539] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6861),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(539),
    [sym_preproc_endregion] = STATE(539),
    [sym_preproc_line] = STATE(539),
    [sym_preproc_pragma] = STATE(539),
    [sym_preproc_nullable] = STATE(539),
    [sym_preproc_error] = STATE(539),
    [sym_preproc_define] = STATE(539),
    [sym_preproc_undef] = STATE(539),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [540] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6856),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(540),
    [sym_preproc_endregion] = STATE(540),
    [sym_preproc_line] = STATE(540),
    [sym_preproc_pragma] = STATE(540),
    [sym_preproc_nullable] = STATE(540),
    [sym_preproc_error] = STATE(540),
    [sym_preproc_define] = STATE(540),
    [sym_preproc_undef] = STATE(540),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [541] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6900),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(541),
    [sym_preproc_endregion] = STATE(541),
    [sym_preproc_line] = STATE(541),
    [sym_preproc_pragma] = STATE(541),
    [sym_preproc_nullable] = STATE(541),
    [sym_preproc_error] = STATE(541),
    [sym_preproc_define] = STATE(541),
    [sym_preproc_undef] = STATE(541),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [542] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6849),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(542),
    [sym_preproc_endregion] = STATE(542),
    [sym_preproc_line] = STATE(542),
    [sym_preproc_pragma] = STATE(542),
    [sym_preproc_nullable] = STATE(542),
    [sym_preproc_error] = STATE(542),
    [sym_preproc_define] = STATE(542),
    [sym_preproc_undef] = STATE(542),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [543] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6846),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(543),
    [sym_preproc_endregion] = STATE(543),
    [sym_preproc_line] = STATE(543),
    [sym_preproc_pragma] = STATE(543),
    [sym_preproc_nullable] = STATE(543),
    [sym_preproc_error] = STATE(543),
    [sym_preproc_define] = STATE(543),
    [sym_preproc_undef] = STATE(543),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [544] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(544),
    [sym_preproc_endregion] = STATE(544),
    [sym_preproc_line] = STATE(544),
    [sym_preproc_pragma] = STATE(544),
    [sym_preproc_nullable] = STATE(544),
    [sym_preproc_error] = STATE(544),
    [sym_preproc_define] = STATE(544),
    [sym_preproc_undef] = STATE(544),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [545] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6881),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(545),
    [sym_preproc_endregion] = STATE(545),
    [sym_preproc_line] = STATE(545),
    [sym_preproc_pragma] = STATE(545),
    [sym_preproc_nullable] = STATE(545),
    [sym_preproc_error] = STATE(545),
    [sym_preproc_define] = STATE(545),
    [sym_preproc_undef] = STATE(545),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [546] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6858),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4382),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(546),
    [sym_preproc_endregion] = STATE(546),
    [sym_preproc_line] = STATE(546),
    [sym_preproc_pragma] = STATE(546),
    [sym_preproc_nullable] = STATE(546),
    [sym_preproc_error] = STATE(546),
    [sym_preproc_define] = STATE(546),
    [sym_preproc_undef] = STATE(546),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [547] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6874),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(547),
    [sym_preproc_endregion] = STATE(547),
    [sym_preproc_line] = STATE(547),
    [sym_preproc_pragma] = STATE(547),
    [sym_preproc_nullable] = STATE(547),
    [sym_preproc_error] = STATE(547),
    [sym_preproc_define] = STATE(547),
    [sym_preproc_undef] = STATE(547),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [548] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6829),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4419),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(548),
    [sym_preproc_endregion] = STATE(548),
    [sym_preproc_line] = STATE(548),
    [sym_preproc_pragma] = STATE(548),
    [sym_preproc_nullable] = STATE(548),
    [sym_preproc_error] = STATE(548),
    [sym_preproc_define] = STATE(548),
    [sym_preproc_undef] = STATE(548),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [549] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6837),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(549),
    [sym_preproc_endregion] = STATE(549),
    [sym_preproc_line] = STATE(549),
    [sym_preproc_pragma] = STATE(549),
    [sym_preproc_nullable] = STATE(549),
    [sym_preproc_error] = STATE(549),
    [sym_preproc_define] = STATE(549),
    [sym_preproc_undef] = STATE(549),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [550] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6894),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(550),
    [sym_preproc_endregion] = STATE(550),
    [sym_preproc_line] = STATE(550),
    [sym_preproc_pragma] = STATE(550),
    [sym_preproc_nullable] = STATE(550),
    [sym_preproc_error] = STATE(550),
    [sym_preproc_define] = STATE(550),
    [sym_preproc_undef] = STATE(550),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [551] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6848),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(551),
    [sym_preproc_endregion] = STATE(551),
    [sym_preproc_line] = STATE(551),
    [sym_preproc_pragma] = STATE(551),
    [sym_preproc_nullable] = STATE(551),
    [sym_preproc_error] = STATE(551),
    [sym_preproc_define] = STATE(551),
    [sym_preproc_undef] = STATE(551),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [552] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6873),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(552),
    [sym_preproc_endregion] = STATE(552),
    [sym_preproc_line] = STATE(552),
    [sym_preproc_pragma] = STATE(552),
    [sym_preproc_nullable] = STATE(552),
    [sym_preproc_error] = STATE(552),
    [sym_preproc_define] = STATE(552),
    [sym_preproc_undef] = STATE(552),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [553] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6884),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(553),
    [sym_preproc_endregion] = STATE(553),
    [sym_preproc_line] = STATE(553),
    [sym_preproc_pragma] = STATE(553),
    [sym_preproc_nullable] = STATE(553),
    [sym_preproc_error] = STATE(553),
    [sym_preproc_define] = STATE(553),
    [sym_preproc_undef] = STATE(553),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [554] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(554),
    [sym_preproc_endregion] = STATE(554),
    [sym_preproc_line] = STATE(554),
    [sym_preproc_pragma] = STATE(554),
    [sym_preproc_nullable] = STATE(554),
    [sym_preproc_error] = STATE(554),
    [sym_preproc_define] = STATE(554),
    [sym_preproc_undef] = STATE(554),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [555] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6891),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(555),
    [sym_preproc_endregion] = STATE(555),
    [sym_preproc_line] = STATE(555),
    [sym_preproc_pragma] = STATE(555),
    [sym_preproc_nullable] = STATE(555),
    [sym_preproc_error] = STATE(555),
    [sym_preproc_define] = STATE(555),
    [sym_preproc_undef] = STATE(555),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [556] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6886),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(556),
    [sym_preproc_endregion] = STATE(556),
    [sym_preproc_line] = STATE(556),
    [sym_preproc_pragma] = STATE(556),
    [sym_preproc_nullable] = STATE(556),
    [sym_preproc_error] = STATE(556),
    [sym_preproc_define] = STATE(556),
    [sym_preproc_undef] = STATE(556),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [557] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6824),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(557),
    [sym_preproc_endregion] = STATE(557),
    [sym_preproc_line] = STATE(557),
    [sym_preproc_pragma] = STATE(557),
    [sym_preproc_nullable] = STATE(557),
    [sym_preproc_error] = STATE(557),
    [sym_preproc_define] = STATE(557),
    [sym_preproc_undef] = STATE(557),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [558] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8929),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6893),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6495),
    [sym_lvalue_expression] = STATE(4364),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(558),
    [sym_preproc_endregion] = STATE(558),
    [sym_preproc_line] = STATE(558),
    [sym_preproc_pragma] = STATE(558),
    [sym_preproc_nullable] = STATE(558),
    [sym_preproc_error] = STATE(558),
    [sym_preproc_define] = STATE(558),
    [sym_preproc_undef] = STATE(558),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [559] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6870),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(559),
    [sym_preproc_endregion] = STATE(559),
    [sym_preproc_line] = STATE(559),
    [sym_preproc_pragma] = STATE(559),
    [sym_preproc_nullable] = STATE(559),
    [sym_preproc_error] = STATE(559),
    [sym_preproc_define] = STATE(559),
    [sym_preproc_undef] = STATE(559),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [560] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6875),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4382),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(560),
    [sym_preproc_endregion] = STATE(560),
    [sym_preproc_line] = STATE(560),
    [sym_preproc_pragma] = STATE(560),
    [sym_preproc_nullable] = STATE(560),
    [sym_preproc_error] = STATE(560),
    [sym_preproc_define] = STATE(560),
    [sym_preproc_undef] = STATE(560),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [561] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(561),
    [sym_preproc_endregion] = STATE(561),
    [sym_preproc_line] = STATE(561),
    [sym_preproc_pragma] = STATE(561),
    [sym_preproc_nullable] = STATE(561),
    [sym_preproc_error] = STATE(561),
    [sym_preproc_define] = STATE(561),
    [sym_preproc_undef] = STATE(561),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [562] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6882),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(562),
    [sym_preproc_endregion] = STATE(562),
    [sym_preproc_line] = STATE(562),
    [sym_preproc_pragma] = STATE(562),
    [sym_preproc_nullable] = STATE(562),
    [sym_preproc_error] = STATE(562),
    [sym_preproc_define] = STATE(562),
    [sym_preproc_undef] = STATE(562),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [563] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(563),
    [sym_preproc_endregion] = STATE(563),
    [sym_preproc_line] = STATE(563),
    [sym_preproc_pragma] = STATE(563),
    [sym_preproc_nullable] = STATE(563),
    [sym_preproc_error] = STATE(563),
    [sym_preproc_define] = STATE(563),
    [sym_preproc_undef] = STATE(563),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [564] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6869),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(564),
    [sym_preproc_endregion] = STATE(564),
    [sym_preproc_line] = STATE(564),
    [sym_preproc_pragma] = STATE(564),
    [sym_preproc_nullable] = STATE(564),
    [sym_preproc_error] = STATE(564),
    [sym_preproc_define] = STATE(564),
    [sym_preproc_undef] = STATE(564),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [565] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6877),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(565),
    [sym_preproc_endregion] = STATE(565),
    [sym_preproc_line] = STATE(565),
    [sym_preproc_pragma] = STATE(565),
    [sym_preproc_nullable] = STATE(565),
    [sym_preproc_error] = STATE(565),
    [sym_preproc_define] = STATE(565),
    [sym_preproc_undef] = STATE(565),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [566] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8897),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6876),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6458),
    [sym_lvalue_expression] = STATE(4382),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(566),
    [sym_preproc_endregion] = STATE(566),
    [sym_preproc_line] = STATE(566),
    [sym_preproc_pragma] = STATE(566),
    [sym_preproc_nullable] = STATE(566),
    [sym_preproc_error] = STATE(566),
    [sym_preproc_define] = STATE(566),
    [sym_preproc_undef] = STATE(566),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [567] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8802),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6866),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6368),
    [sym_lvalue_expression] = STATE(4419),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(567),
    [sym_preproc_endregion] = STATE(567),
    [sym_preproc_line] = STATE(567),
    [sym_preproc_pragma] = STATE(567),
    [sym_preproc_nullable] = STATE(567),
    [sym_preproc_error] = STATE(567),
    [sym_preproc_define] = STATE(567),
    [sym_preproc_undef] = STATE(567),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [568] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6851),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(568),
    [sym_preproc_endregion] = STATE(568),
    [sym_preproc_line] = STATE(568),
    [sym_preproc_pragma] = STATE(568),
    [sym_preproc_nullable] = STATE(568),
    [sym_preproc_error] = STATE(568),
    [sym_preproc_define] = STATE(568),
    [sym_preproc_undef] = STATE(568),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [569] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6857),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(569),
    [sym_preproc_endregion] = STATE(569),
    [sym_preproc_line] = STATE(569),
    [sym_preproc_pragma] = STATE(569),
    [sym_preproc_nullable] = STATE(569),
    [sym_preproc_error] = STATE(569),
    [sym_preproc_define] = STATE(569),
    [sym_preproc_undef] = STATE(569),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [570] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6826),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(570),
    [sym_preproc_endregion] = STATE(570),
    [sym_preproc_line] = STATE(570),
    [sym_preproc_pragma] = STATE(570),
    [sym_preproc_nullable] = STATE(570),
    [sym_preproc_error] = STATE(570),
    [sym_preproc_define] = STATE(570),
    [sym_preproc_undef] = STATE(570),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [571] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6897),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(571),
    [sym_preproc_endregion] = STATE(571),
    [sym_preproc_line] = STATE(571),
    [sym_preproc_pragma] = STATE(571),
    [sym_preproc_nullable] = STATE(571),
    [sym_preproc_error] = STATE(571),
    [sym_preproc_define] = STATE(571),
    [sym_preproc_undef] = STATE(571),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [572] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(572),
    [sym_preproc_endregion] = STATE(572),
    [sym_preproc_line] = STATE(572),
    [sym_preproc_pragma] = STATE(572),
    [sym_preproc_nullable] = STATE(572),
    [sym_preproc_error] = STATE(572),
    [sym_preproc_define] = STATE(572),
    [sym_preproc_undef] = STATE(572),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [573] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6834),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(573),
    [sym_preproc_endregion] = STATE(573),
    [sym_preproc_line] = STATE(573),
    [sym_preproc_pragma] = STATE(573),
    [sym_preproc_nullable] = STATE(573),
    [sym_preproc_error] = STATE(573),
    [sym_preproc_define] = STATE(573),
    [sym_preproc_undef] = STATE(573),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [574] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6878),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4389),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(574),
    [sym_preproc_endregion] = STATE(574),
    [sym_preproc_line] = STATE(574),
    [sym_preproc_pragma] = STATE(574),
    [sym_preproc_nullable] = STATE(574),
    [sym_preproc_error] = STATE(574),
    [sym_preproc_define] = STATE(574),
    [sym_preproc_undef] = STATE(574),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [575] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8755),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6898),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6436),
    [sym_lvalue_expression] = STATE(4454),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(575),
    [sym_preproc_endregion] = STATE(575),
    [sym_preproc_line] = STATE(575),
    [sym_preproc_pragma] = STATE(575),
    [sym_preproc_nullable] = STATE(575),
    [sym_preproc_error] = STATE(575),
    [sym_preproc_define] = STATE(575),
    [sym_preproc_undef] = STATE(575),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [576] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6859),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(576),
    [sym_preproc_endregion] = STATE(576),
    [sym_preproc_line] = STATE(576),
    [sym_preproc_pragma] = STATE(576),
    [sym_preproc_nullable] = STATE(576),
    [sym_preproc_error] = STATE(576),
    [sym_preproc_define] = STATE(576),
    [sym_preproc_undef] = STATE(576),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [577] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6835),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(6426),
    [sym_lvalue_expression] = STATE(4445),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2783),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(577),
    [sym_preproc_endregion] = STATE(577),
    [sym_preproc_line] = STATE(577),
    [sym_preproc_pragma] = STATE(577),
    [sym_preproc_nullable] = STATE(577),
    [sym_preproc_error] = STATE(577),
    [sym_preproc_define] = STATE(577),
    [sym_preproc_undef] = STATE(577),
    [aux_sym_class_declaration_repeat1] = STATE(3572),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(2603),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1113),
    [anon_sym_out] = ACTIONS(1113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(1121),
    [anon_sym_scoped] = ACTIONS(1123),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [578] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8394),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8751),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(578),
    [sym_preproc_endregion] = STATE(578),
    [sym_preproc_line] = STATE(578),
    [sym_preproc_pragma] = STATE(578),
    [sym_preproc_nullable] = STATE(578),
    [sym_preproc_error] = STATE(578),
    [sym_preproc_define] = STATE(578),
    [sym_preproc_undef] = STATE(578),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [579] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8575),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8988),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(579),
    [sym_preproc_endregion] = STATE(579),
    [sym_preproc_line] = STATE(579),
    [sym_preproc_pragma] = STATE(579),
    [sym_preproc_nullable] = STATE(579),
    [sym_preproc_error] = STATE(579),
    [sym_preproc_define] = STATE(579),
    [sym_preproc_undef] = STATE(579),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [580] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8466),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8931),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(580),
    [sym_preproc_endregion] = STATE(580),
    [sym_preproc_line] = STATE(580),
    [sym_preproc_pragma] = STATE(580),
    [sym_preproc_nullable] = STATE(580),
    [sym_preproc_error] = STATE(580),
    [sym_preproc_define] = STATE(580),
    [sym_preproc_undef] = STATE(580),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [581] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8394),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8804),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(581),
    [sym_preproc_endregion] = STATE(581),
    [sym_preproc_line] = STATE(581),
    [sym_preproc_pragma] = STATE(581),
    [sym_preproc_nullable] = STATE(581),
    [sym_preproc_error] = STATE(581),
    [sym_preproc_define] = STATE(581),
    [sym_preproc_undef] = STATE(581),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [582] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8582),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8896),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(582),
    [sym_preproc_endregion] = STATE(582),
    [sym_preproc_line] = STATE(582),
    [sym_preproc_pragma] = STATE(582),
    [sym_preproc_nullable] = STATE(582),
    [sym_preproc_error] = STATE(582),
    [sym_preproc_define] = STATE(582),
    [sym_preproc_undef] = STATE(582),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2617),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [583] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8521),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8876),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(583),
    [sym_preproc_endregion] = STATE(583),
    [sym_preproc_line] = STATE(583),
    [sym_preproc_pragma] = STATE(583),
    [sym_preproc_nullable] = STATE(583),
    [sym_preproc_error] = STATE(583),
    [sym_preproc_define] = STATE(583),
    [sym_preproc_undef] = STATE(583),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2619),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [584] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8575),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6912),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8751),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(584),
    [sym_preproc_endregion] = STATE(584),
    [sym_preproc_line] = STATE(584),
    [sym_preproc_pragma] = STATE(584),
    [sym_preproc_nullable] = STATE(584),
    [sym_preproc_error] = STATE(584),
    [sym_preproc_define] = STATE(584),
    [sym_preproc_undef] = STATE(584),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_ref] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2611),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [585] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8575),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(585),
    [sym_preproc_endregion] = STATE(585),
    [sym_preproc_line] = STATE(585),
    [sym_preproc_pragma] = STATE(585),
    [sym_preproc_nullable] = STATE(585),
    [sym_preproc_error] = STATE(585),
    [sym_preproc_define] = STATE(585),
    [sym_preproc_undef] = STATE(585),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [586] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(586),
    [sym_preproc_endregion] = STATE(586),
    [sym_preproc_line] = STATE(586),
    [sym_preproc_pragma] = STATE(586),
    [sym_preproc_nullable] = STATE(586),
    [sym_preproc_error] = STATE(586),
    [sym_preproc_define] = STATE(586),
    [sym_preproc_undef] = STATE(586),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [587] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(587),
    [sym_preproc_endregion] = STATE(587),
    [sym_preproc_line] = STATE(587),
    [sym_preproc_pragma] = STATE(587),
    [sym_preproc_nullable] = STATE(587),
    [sym_preproc_error] = STATE(587),
    [sym_preproc_define] = STATE(587),
    [sym_preproc_undef] = STATE(587),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2625),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [588] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5387),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9586),
    [sym_preproc_elif_in_expression] = STATE(9586),
    [sym_preproc_region] = STATE(588),
    [sym_preproc_endregion] = STATE(588),
    [sym_preproc_line] = STATE(588),
    [sym_preproc_pragma] = STATE(588),
    [sym_preproc_nullable] = STATE(588),
    [sym_preproc_error] = STATE(588),
    [sym_preproc_define] = STATE(588),
    [sym_preproc_undef] = STATE(588),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2627),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [589] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8521),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(589),
    [sym_preproc_endregion] = STATE(589),
    [sym_preproc_line] = STATE(589),
    [sym_preproc_pragma] = STATE(589),
    [sym_preproc_nullable] = STATE(589),
    [sym_preproc_error] = STATE(589),
    [sym_preproc_define] = STATE(589),
    [sym_preproc_undef] = STATE(589),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2619),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [590] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(590),
    [sym_preproc_endregion] = STATE(590),
    [sym_preproc_line] = STATE(590),
    [sym_preproc_pragma] = STATE(590),
    [sym_preproc_nullable] = STATE(590),
    [sym_preproc_error] = STATE(590),
    [sym_preproc_define] = STATE(590),
    [sym_preproc_undef] = STATE(590),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2633),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [591] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(591),
    [sym_preproc_endregion] = STATE(591),
    [sym_preproc_line] = STATE(591),
    [sym_preproc_pragma] = STATE(591),
    [sym_preproc_nullable] = STATE(591),
    [sym_preproc_error] = STATE(591),
    [sym_preproc_define] = STATE(591),
    [sym_preproc_undef] = STATE(591),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [592] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8466),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(592),
    [sym_preproc_endregion] = STATE(592),
    [sym_preproc_line] = STATE(592),
    [sym_preproc_pragma] = STATE(592),
    [sym_preproc_nullable] = STATE(592),
    [sym_preproc_error] = STATE(592),
    [sym_preproc_define] = STATE(592),
    [sym_preproc_undef] = STATE(592),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2615),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [593] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(593),
    [sym_preproc_endregion] = STATE(593),
    [sym_preproc_line] = STATE(593),
    [sym_preproc_pragma] = STATE(593),
    [sym_preproc_nullable] = STATE(593),
    [sym_preproc_error] = STATE(593),
    [sym_preproc_define] = STATE(593),
    [sym_preproc_undef] = STATE(593),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2637),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [594] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5320),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9720),
    [sym_preproc_elif_in_expression] = STATE(9720),
    [sym_preproc_region] = STATE(594),
    [sym_preproc_endregion] = STATE(594),
    [sym_preproc_line] = STATE(594),
    [sym_preproc_pragma] = STATE(594),
    [sym_preproc_nullable] = STATE(594),
    [sym_preproc_error] = STATE(594),
    [sym_preproc_define] = STATE(594),
    [sym_preproc_undef] = STATE(594),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2639),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [595] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5389),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9178),
    [sym_preproc_elif_in_expression] = STATE(9178),
    [sym_preproc_region] = STATE(595),
    [sym_preproc_endregion] = STATE(595),
    [sym_preproc_line] = STATE(595),
    [sym_preproc_pragma] = STATE(595),
    [sym_preproc_nullable] = STATE(595),
    [sym_preproc_error] = STATE(595),
    [sym_preproc_define] = STATE(595),
    [sym_preproc_undef] = STATE(595),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2641),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [596] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(596),
    [sym_preproc_endregion] = STATE(596),
    [sym_preproc_line] = STATE(596),
    [sym_preproc_pragma] = STATE(596),
    [sym_preproc_nullable] = STATE(596),
    [sym_preproc_error] = STATE(596),
    [sym_preproc_define] = STATE(596),
    [sym_preproc_undef] = STATE(596),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2643),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [597] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(597),
    [sym_preproc_endregion] = STATE(597),
    [sym_preproc_line] = STATE(597),
    [sym_preproc_pragma] = STATE(597),
    [sym_preproc_nullable] = STATE(597),
    [sym_preproc_error] = STATE(597),
    [sym_preproc_define] = STATE(597),
    [sym_preproc_undef] = STATE(597),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2645),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [598] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8394),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(598),
    [sym_preproc_endregion] = STATE(598),
    [sym_preproc_line] = STATE(598),
    [sym_preproc_pragma] = STATE(598),
    [sym_preproc_nullable] = STATE(598),
    [sym_preproc_error] = STATE(598),
    [sym_preproc_define] = STATE(598),
    [sym_preproc_undef] = STATE(598),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2607),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [599] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5268),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9201),
    [sym_preproc_elif_in_expression] = STATE(9201),
    [sym_preproc_region] = STATE(599),
    [sym_preproc_endregion] = STATE(599),
    [sym_preproc_line] = STATE(599),
    [sym_preproc_pragma] = STATE(599),
    [sym_preproc_nullable] = STATE(599),
    [sym_preproc_error] = STATE(599),
    [sym_preproc_define] = STATE(599),
    [sym_preproc_undef] = STATE(599),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2647),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [600] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(600),
    [sym_preproc_endregion] = STATE(600),
    [sym_preproc_line] = STATE(600),
    [sym_preproc_pragma] = STATE(600),
    [sym_preproc_nullable] = STATE(600),
    [sym_preproc_error] = STATE(600),
    [sym_preproc_define] = STATE(600),
    [sym_preproc_undef] = STATE(600),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2649),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [601] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(601),
    [sym_preproc_endregion] = STATE(601),
    [sym_preproc_line] = STATE(601),
    [sym_preproc_pragma] = STATE(601),
    [sym_preproc_nullable] = STATE(601),
    [sym_preproc_error] = STATE(601),
    [sym_preproc_define] = STATE(601),
    [sym_preproc_undef] = STATE(601),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2651),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [602] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(602),
    [sym_preproc_endregion] = STATE(602),
    [sym_preproc_line] = STATE(602),
    [sym_preproc_pragma] = STATE(602),
    [sym_preproc_nullable] = STATE(602),
    [sym_preproc_error] = STATE(602),
    [sym_preproc_define] = STATE(602),
    [sym_preproc_undef] = STATE(602),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2653),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [603] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8582),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(603),
    [sym_preproc_endregion] = STATE(603),
    [sym_preproc_line] = STATE(603),
    [sym_preproc_pragma] = STATE(603),
    [sym_preproc_nullable] = STATE(603),
    [sym_preproc_error] = STATE(603),
    [sym_preproc_define] = STATE(603),
    [sym_preproc_undef] = STATE(603),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2617),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [604] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9415),
    [sym_preproc_elif_in_expression] = STATE(9415),
    [sym_preproc_region] = STATE(604),
    [sym_preproc_endregion] = STATE(604),
    [sym_preproc_line] = STATE(604),
    [sym_preproc_pragma] = STATE(604),
    [sym_preproc_nullable] = STATE(604),
    [sym_preproc_error] = STATE(604),
    [sym_preproc_define] = STATE(604),
    [sym_preproc_undef] = STATE(604),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2655),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [605] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(605),
    [sym_preproc_endregion] = STATE(605),
    [sym_preproc_line] = STATE(605),
    [sym_preproc_pragma] = STATE(605),
    [sym_preproc_nullable] = STATE(605),
    [sym_preproc_error] = STATE(605),
    [sym_preproc_define] = STATE(605),
    [sym_preproc_undef] = STATE(605),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [606] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5345),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9160),
    [sym_preproc_elif_in_expression] = STATE(9160),
    [sym_preproc_region] = STATE(606),
    [sym_preproc_endregion] = STATE(606),
    [sym_preproc_line] = STATE(606),
    [sym_preproc_pragma] = STATE(606),
    [sym_preproc_nullable] = STATE(606),
    [sym_preproc_error] = STATE(606),
    [sym_preproc_define] = STATE(606),
    [sym_preproc_undef] = STATE(606),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2659),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [607] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(607),
    [sym_preproc_endregion] = STATE(607),
    [sym_preproc_line] = STATE(607),
    [sym_preproc_pragma] = STATE(607),
    [sym_preproc_nullable] = STATE(607),
    [sym_preproc_error] = STATE(607),
    [sym_preproc_define] = STATE(607),
    [sym_preproc_undef] = STATE(607),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_RBRACK] = ACTIONS(2661),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [608] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5402),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_else_in_expression] = STATE(9059),
    [sym_preproc_elif_in_expression] = STATE(9059),
    [sym_preproc_region] = STATE(608),
    [sym_preproc_endregion] = STATE(608),
    [sym_preproc_line] = STATE(608),
    [sym_preproc_pragma] = STATE(608),
    [sym_preproc_nullable] = STATE(608),
    [sym_preproc_error] = STATE(608),
    [sym_preproc_define] = STATE(608),
    [sym_preproc_undef] = STATE(608),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2663),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2631),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [609] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6274),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(609),
    [sym_preproc_endregion] = STATE(609),
    [sym_preproc_line] = STATE(609),
    [sym_preproc_pragma] = STATE(609),
    [sym_preproc_nullable] = STATE(609),
    [sym_preproc_error] = STATE(609),
    [sym_preproc_define] = STATE(609),
    [sym_preproc_undef] = STATE(609),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [610] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8433),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(610),
    [sym_preproc_endregion] = STATE(610),
    [sym_preproc_line] = STATE(610),
    [sym_preproc_pragma] = STATE(610),
    [sym_preproc_nullable] = STATE(610),
    [sym_preproc_error] = STATE(610),
    [sym_preproc_define] = STATE(610),
    [sym_preproc_undef] = STATE(610),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [611] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5823),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(611),
    [sym_preproc_endregion] = STATE(611),
    [sym_preproc_line] = STATE(611),
    [sym_preproc_pragma] = STATE(611),
    [sym_preproc_nullable] = STATE(611),
    [sym_preproc_error] = STATE(611),
    [sym_preproc_define] = STATE(611),
    [sym_preproc_undef] = STATE(611),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [612] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8401),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(612),
    [sym_preproc_endregion] = STATE(612),
    [sym_preproc_line] = STATE(612),
    [sym_preproc_pragma] = STATE(612),
    [sym_preproc_nullable] = STATE(612),
    [sym_preproc_error] = STATE(612),
    [sym_preproc_define] = STATE(612),
    [sym_preproc_undef] = STATE(612),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [613] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6132),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(613),
    [sym_preproc_endregion] = STATE(613),
    [sym_preproc_line] = STATE(613),
    [sym_preproc_pragma] = STATE(613),
    [sym_preproc_nullable] = STATE(613),
    [sym_preproc_error] = STATE(613),
    [sym_preproc_define] = STATE(613),
    [sym_preproc_undef] = STATE(613),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [614] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(614),
    [sym_preproc_endregion] = STATE(614),
    [sym_preproc_line] = STATE(614),
    [sym_preproc_pragma] = STATE(614),
    [sym_preproc_nullable] = STATE(614),
    [sym_preproc_error] = STATE(614),
    [sym_preproc_define] = STATE(614),
    [sym_preproc_undef] = STATE(614),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [615] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8486),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(615),
    [sym_preproc_endregion] = STATE(615),
    [sym_preproc_line] = STATE(615),
    [sym_preproc_pragma] = STATE(615),
    [sym_preproc_nullable] = STATE(615),
    [sym_preproc_error] = STATE(615),
    [sym_preproc_define] = STATE(615),
    [sym_preproc_undef] = STATE(615),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [616] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8479),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(616),
    [sym_preproc_endregion] = STATE(616),
    [sym_preproc_line] = STATE(616),
    [sym_preproc_pragma] = STATE(616),
    [sym_preproc_nullable] = STATE(616),
    [sym_preproc_error] = STATE(616),
    [sym_preproc_define] = STATE(616),
    [sym_preproc_undef] = STATE(616),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [617] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5818),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(617),
    [sym_preproc_endregion] = STATE(617),
    [sym_preproc_line] = STATE(617),
    [sym_preproc_pragma] = STATE(617),
    [sym_preproc_nullable] = STATE(617),
    [sym_preproc_error] = STATE(617),
    [sym_preproc_define] = STATE(617),
    [sym_preproc_undef] = STATE(617),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [618] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6247),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(618),
    [sym_preproc_endregion] = STATE(618),
    [sym_preproc_line] = STATE(618),
    [sym_preproc_pragma] = STATE(618),
    [sym_preproc_nullable] = STATE(618),
    [sym_preproc_error] = STATE(618),
    [sym_preproc_define] = STATE(618),
    [sym_preproc_undef] = STATE(618),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [619] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8714),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6161),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(619),
    [sym_preproc_endregion] = STATE(619),
    [sym_preproc_line] = STATE(619),
    [sym_preproc_pragma] = STATE(619),
    [sym_preproc_nullable] = STATE(619),
    [sym_preproc_error] = STATE(619),
    [sym_preproc_define] = STATE(619),
    [sym_preproc_undef] = STATE(619),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [620] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8650),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(620),
    [sym_preproc_endregion] = STATE(620),
    [sym_preproc_line] = STATE(620),
    [sym_preproc_pragma] = STATE(620),
    [sym_preproc_nullable] = STATE(620),
    [sym_preproc_error] = STATE(620),
    [sym_preproc_define] = STATE(620),
    [sym_preproc_undef] = STATE(620),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [621] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8397),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(621),
    [sym_preproc_endregion] = STATE(621),
    [sym_preproc_line] = STATE(621),
    [sym_preproc_pragma] = STATE(621),
    [sym_preproc_nullable] = STATE(621),
    [sym_preproc_error] = STATE(621),
    [sym_preproc_define] = STATE(621),
    [sym_preproc_undef] = STATE(621),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [622] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_argument] = STATE(8609),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6060),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8659),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2780),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(622),
    [sym_preproc_endregion] = STATE(622),
    [sym_preproc_line] = STATE(622),
    [sym_preproc_pragma] = STATE(622),
    [sym_preproc_nullable] = STATE(622),
    [sym_preproc_error] = STATE(622),
    [sym_preproc_define] = STATE(622),
    [sym_preproc_undef] = STATE(622),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_out] = ACTIONS(1077),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [623] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6713),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2821),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6756),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5993),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(623),
    [sym_preproc_endregion] = STATE(623),
    [sym_preproc_line] = STATE(623),
    [sym_preproc_pragma] = STATE(623),
    [sym_preproc_nullable] = STATE(623),
    [sym_preproc_error] = STATE(623),
    [sym_preproc_define] = STATE(623),
    [sym_preproc_undef] = STATE(623),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [624] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8519),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(624),
    [sym_preproc_endregion] = STATE(624),
    [sym_preproc_line] = STATE(624),
    [sym_preproc_pragma] = STATE(624),
    [sym_preproc_nullable] = STATE(624),
    [sym_preproc_error] = STATE(624),
    [sym_preproc_define] = STATE(624),
    [sym_preproc_undef] = STATE(624),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2671),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2673),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [625] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5879),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(625),
    [sym_preproc_endregion] = STATE(625),
    [sym_preproc_line] = STATE(625),
    [sym_preproc_pragma] = STATE(625),
    [sym_preproc_nullable] = STATE(625),
    [sym_preproc_error] = STATE(625),
    [sym_preproc_define] = STATE(625),
    [sym_preproc_undef] = STATE(625),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8691),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2677),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [626] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5984),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(626),
    [sym_preproc_endregion] = STATE(626),
    [sym_preproc_line] = STATE(626),
    [sym_preproc_pragma] = STATE(626),
    [sym_preproc_nullable] = STATE(626),
    [sym_preproc_error] = STATE(626),
    [sym_preproc_define] = STATE(626),
    [sym_preproc_undef] = STATE(626),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8515),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2679),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [627] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8393),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(627),
    [sym_preproc_endregion] = STATE(627),
    [sym_preproc_line] = STATE(627),
    [sym_preproc_pragma] = STATE(627),
    [sym_preproc_nullable] = STATE(627),
    [sym_preproc_error] = STATE(627),
    [sym_preproc_define] = STATE(627),
    [sym_preproc_undef] = STATE(627),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2681),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [628] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8596),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(628),
    [sym_preproc_endregion] = STATE(628),
    [sym_preproc_line] = STATE(628),
    [sym_preproc_pragma] = STATE(628),
    [sym_preproc_nullable] = STATE(628),
    [sym_preproc_error] = STATE(628),
    [sym_preproc_define] = STATE(628),
    [sym_preproc_undef] = STATE(628),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [629] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5872),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(629),
    [sym_preproc_endregion] = STATE(629),
    [sym_preproc_line] = STATE(629),
    [sym_preproc_pragma] = STATE(629),
    [sym_preproc_nullable] = STATE(629),
    [sym_preproc_error] = STATE(629),
    [sym_preproc_define] = STATE(629),
    [sym_preproc_undef] = STATE(629),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8498),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2689),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [630] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5857),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(630),
    [sym_preproc_endregion] = STATE(630),
    [sym_preproc_line] = STATE(630),
    [sym_preproc_pragma] = STATE(630),
    [sym_preproc_nullable] = STATE(630),
    [sym_preproc_error] = STATE(630),
    [sym_preproc_define] = STATE(630),
    [sym_preproc_undef] = STATE(630),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8570),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2691),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [631] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8547),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(631),
    [sym_preproc_endregion] = STATE(631),
    [sym_preproc_line] = STATE(631),
    [sym_preproc_pragma] = STATE(631),
    [sym_preproc_nullable] = STATE(631),
    [sym_preproc_error] = STATE(631),
    [sym_preproc_define] = STATE(631),
    [sym_preproc_undef] = STATE(631),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2693),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [632] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6107),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(632),
    [sym_preproc_endregion] = STATE(632),
    [sym_preproc_line] = STATE(632),
    [sym_preproc_pragma] = STATE(632),
    [sym_preproc_nullable] = STATE(632),
    [sym_preproc_error] = STATE(632),
    [sym_preproc_define] = STATE(632),
    [sym_preproc_undef] = STATE(632),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8549),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2697),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [633] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5946),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8505),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(633),
    [sym_preproc_endregion] = STATE(633),
    [sym_preproc_line] = STATE(633),
    [sym_preproc_pragma] = STATE(633),
    [sym_preproc_nullable] = STATE(633),
    [sym_preproc_error] = STATE(633),
    [sym_preproc_define] = STATE(633),
    [sym_preproc_undef] = STATE(633),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2699),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(2701),
    [anon_sym_out] = ACTIONS(2701),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [634] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5819),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(634),
    [sym_preproc_endregion] = STATE(634),
    [sym_preproc_line] = STATE(634),
    [sym_preproc_pragma] = STATE(634),
    [sym_preproc_nullable] = STATE(634),
    [sym_preproc_error] = STATE(634),
    [sym_preproc_define] = STATE(634),
    [sym_preproc_undef] = STATE(634),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8493),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2703),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [635] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8478),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(635),
    [sym_preproc_endregion] = STATE(635),
    [sym_preproc_line] = STATE(635),
    [sym_preproc_pragma] = STATE(635),
    [sym_preproc_nullable] = STATE(635),
    [sym_preproc_error] = STATE(635),
    [sym_preproc_define] = STATE(635),
    [sym_preproc_undef] = STATE(635),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [636] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5999),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(636),
    [sym_preproc_endregion] = STATE(636),
    [sym_preproc_line] = STATE(636),
    [sym_preproc_pragma] = STATE(636),
    [sym_preproc_nullable] = STATE(636),
    [sym_preproc_error] = STATE(636),
    [sym_preproc_define] = STATE(636),
    [sym_preproc_undef] = STATE(636),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8692),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2709),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [637] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6697),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6643),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(637),
    [sym_preproc_endregion] = STATE(637),
    [sym_preproc_line] = STATE(637),
    [sym_preproc_pragma] = STATE(637),
    [sym_preproc_nullable] = STATE(637),
    [sym_preproc_error] = STATE(637),
    [sym_preproc_define] = STATE(637),
    [sym_preproc_undef] = STATE(637),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(2667),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2667),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(2667),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_scoped] = ACTIONS(2667),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2667),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [638] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5884),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(638),
    [sym_preproc_endregion] = STATE(638),
    [sym_preproc_line] = STATE(638),
    [sym_preproc_pragma] = STATE(638),
    [sym_preproc_nullable] = STATE(638),
    [sym_preproc_error] = STATE(638),
    [sym_preproc_define] = STATE(638),
    [sym_preproc_undef] = STATE(638),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_array_rank_specifier_repeat1] = STATE(8410),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_RBRACK] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [639] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8469),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(639),
    [sym_preproc_endregion] = STATE(639),
    [sym_preproc_line] = STATE(639),
    [sym_preproc_pragma] = STATE(639),
    [sym_preproc_nullable] = STATE(639),
    [sym_preproc_error] = STATE(639),
    [sym_preproc_define] = STATE(639),
    [sym_preproc_undef] = STATE(639),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [640] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6408),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(640),
    [sym_preproc_endregion] = STATE(640),
    [sym_preproc_line] = STATE(640),
    [sym_preproc_pragma] = STATE(640),
    [sym_preproc_nullable] = STATE(640),
    [sym_preproc_error] = STATE(640),
    [sym_preproc_define] = STATE(640),
    [sym_preproc_undef] = STATE(640),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2719),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [641] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5814),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8440),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(641),
    [sym_preproc_endregion] = STATE(641),
    [sym_preproc_line] = STATE(641),
    [sym_preproc_pragma] = STATE(641),
    [sym_preproc_nullable] = STATE(641),
    [sym_preproc_error] = STATE(641),
    [sym_preproc_define] = STATE(641),
    [sym_preproc_undef] = STATE(641),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [642] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9157),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6452),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(642),
    [sym_preproc_endregion] = STATE(642),
    [sym_preproc_line] = STATE(642),
    [sym_preproc_pragma] = STATE(642),
    [sym_preproc_nullable] = STATE(642),
    [sym_preproc_error] = STATE(642),
    [sym_preproc_define] = STATE(642),
    [sym_preproc_undef] = STATE(642),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [643] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6633),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(643),
    [sym_preproc_endregion] = STATE(643),
    [sym_preproc_line] = STATE(643),
    [sym_preproc_pragma] = STATE(643),
    [sym_preproc_nullable] = STATE(643),
    [sym_preproc_error] = STATE(643),
    [sym_preproc_define] = STATE(643),
    [sym_preproc_undef] = STATE(643),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [644] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6329),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(644),
    [sym_preproc_endregion] = STATE(644),
    [sym_preproc_line] = STATE(644),
    [sym_preproc_pragma] = STATE(644),
    [sym_preproc_nullable] = STATE(644),
    [sym_preproc_error] = STATE(644),
    [sym_preproc_define] = STATE(644),
    [sym_preproc_undef] = STATE(644),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [645] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(645),
    [sym_preproc_endregion] = STATE(645),
    [sym_preproc_line] = STATE(645),
    [sym_preproc_pragma] = STATE(645),
    [sym_preproc_nullable] = STATE(645),
    [sym_preproc_error] = STATE(645),
    [sym_preproc_define] = STATE(645),
    [sym_preproc_undef] = STATE(645),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [646] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9610),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(646),
    [sym_preproc_endregion] = STATE(646),
    [sym_preproc_line] = STATE(646),
    [sym_preproc_pragma] = STATE(646),
    [sym_preproc_nullable] = STATE(646),
    [sym_preproc_error] = STATE(646),
    [sym_preproc_define] = STATE(646),
    [sym_preproc_undef] = STATE(646),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [647] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6511),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(647),
    [sym_preproc_endregion] = STATE(647),
    [sym_preproc_line] = STATE(647),
    [sym_preproc_pragma] = STATE(647),
    [sym_preproc_nullable] = STATE(647),
    [sym_preproc_error] = STATE(647),
    [sym_preproc_define] = STATE(647),
    [sym_preproc_undef] = STATE(647),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [648] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6579),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(648),
    [sym_preproc_endregion] = STATE(648),
    [sym_preproc_line] = STATE(648),
    [sym_preproc_pragma] = STATE(648),
    [sym_preproc_nullable] = STATE(648),
    [sym_preproc_error] = STATE(648),
    [sym_preproc_define] = STATE(648),
    [sym_preproc_undef] = STATE(648),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [649] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6305),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(649),
    [sym_preproc_endregion] = STATE(649),
    [sym_preproc_line] = STATE(649),
    [sym_preproc_pragma] = STATE(649),
    [sym_preproc_nullable] = STATE(649),
    [sym_preproc_error] = STATE(649),
    [sym_preproc_define] = STATE(649),
    [sym_preproc_undef] = STATE(649),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2737),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [650] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9032),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6406),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(650),
    [sym_preproc_endregion] = STATE(650),
    [sym_preproc_line] = STATE(650),
    [sym_preproc_pragma] = STATE(650),
    [sym_preproc_nullable] = STATE(650),
    [sym_preproc_error] = STATE(650),
    [sym_preproc_define] = STATE(650),
    [sym_preproc_undef] = STATE(650),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [651] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3926),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6386),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(5712),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(651),
    [sym_preproc_endregion] = STATE(651),
    [sym_preproc_line] = STATE(651),
    [sym_preproc_pragma] = STATE(651),
    [sym_preproc_nullable] = STATE(651),
    [sym_preproc_error] = STATE(651),
    [sym_preproc_define] = STATE(651),
    [sym_preproc_undef] = STATE(651),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2739),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [652] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(652),
    [sym_preproc_endregion] = STATE(652),
    [sym_preproc_line] = STATE(652),
    [sym_preproc_pragma] = STATE(652),
    [sym_preproc_nullable] = STATE(652),
    [sym_preproc_error] = STATE(652),
    [sym_preproc_define] = STATE(652),
    [sym_preproc_undef] = STATE(652),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [653] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6315),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(653),
    [sym_preproc_endregion] = STATE(653),
    [sym_preproc_line] = STATE(653),
    [sym_preproc_pragma] = STATE(653),
    [sym_preproc_nullable] = STATE(653),
    [sym_preproc_error] = STATE(653),
    [sym_preproc_define] = STATE(653),
    [sym_preproc_undef] = STATE(653),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [654] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6539),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(654),
    [sym_preproc_endregion] = STATE(654),
    [sym_preproc_line] = STATE(654),
    [sym_preproc_pragma] = STATE(654),
    [sym_preproc_nullable] = STATE(654),
    [sym_preproc_error] = STATE(654),
    [sym_preproc_define] = STATE(654),
    [sym_preproc_undef] = STATE(654),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [655] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9717),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6343),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(655),
    [sym_preproc_endregion] = STATE(655),
    [sym_preproc_line] = STATE(655),
    [sym_preproc_pragma] = STATE(655),
    [sym_preproc_nullable] = STATE(655),
    [sym_preproc_error] = STATE(655),
    [sym_preproc_define] = STATE(655),
    [sym_preproc_undef] = STATE(655),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [656] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6441),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(656),
    [sym_preproc_endregion] = STATE(656),
    [sym_preproc_line] = STATE(656),
    [sym_preproc_pragma] = STATE(656),
    [sym_preproc_nullable] = STATE(656),
    [sym_preproc_error] = STATE(656),
    [sym_preproc_define] = STATE(656),
    [sym_preproc_undef] = STATE(656),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [657] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6011),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(657),
    [sym_preproc_endregion] = STATE(657),
    [sym_preproc_line] = STATE(657),
    [sym_preproc_pragma] = STATE(657),
    [sym_preproc_nullable] = STATE(657),
    [sym_preproc_error] = STATE(657),
    [sym_preproc_define] = STATE(657),
    [sym_preproc_undef] = STATE(657),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(949),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [658] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9518),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5912),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(658),
    [sym_preproc_endregion] = STATE(658),
    [sym_preproc_line] = STATE(658),
    [sym_preproc_pragma] = STATE(658),
    [sym_preproc_nullable] = STATE(658),
    [sym_preproc_error] = STATE(658),
    [sym_preproc_define] = STATE(658),
    [sym_preproc_undef] = STATE(658),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [659] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5987),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(659),
    [sym_preproc_endregion] = STATE(659),
    [sym_preproc_line] = STATE(659),
    [sym_preproc_pragma] = STATE(659),
    [sym_preproc_nullable] = STATE(659),
    [sym_preproc_error] = STATE(659),
    [sym_preproc_define] = STATE(659),
    [sym_preproc_undef] = STATE(659),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2747),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [660] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6634),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(660),
    [sym_preproc_endregion] = STATE(660),
    [sym_preproc_line] = STATE(660),
    [sym_preproc_pragma] = STATE(660),
    [sym_preproc_nullable] = STATE(660),
    [sym_preproc_error] = STATE(660),
    [sym_preproc_define] = STATE(660),
    [sym_preproc_undef] = STATE(660),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [661] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6488),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(661),
    [sym_preproc_endregion] = STATE(661),
    [sym_preproc_line] = STATE(661),
    [sym_preproc_pragma] = STATE(661),
    [sym_preproc_nullable] = STATE(661),
    [sym_preproc_error] = STATE(661),
    [sym_preproc_define] = STATE(661),
    [sym_preproc_undef] = STATE(661),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [662] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6413),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(662),
    [sym_preproc_endregion] = STATE(662),
    [sym_preproc_line] = STATE(662),
    [sym_preproc_pragma] = STATE(662),
    [sym_preproc_nullable] = STATE(662),
    [sym_preproc_error] = STATE(662),
    [sym_preproc_define] = STATE(662),
    [sym_preproc_undef] = STATE(662),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [663] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(663),
    [sym_preproc_endregion] = STATE(663),
    [sym_preproc_line] = STATE(663),
    [sym_preproc_pragma] = STATE(663),
    [sym_preproc_nullable] = STATE(663),
    [sym_preproc_error] = STATE(663),
    [sym_preproc_define] = STATE(663),
    [sym_preproc_undef] = STATE(663),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2751),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [664] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6347),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(664),
    [sym_preproc_endregion] = STATE(664),
    [sym_preproc_line] = STATE(664),
    [sym_preproc_pragma] = STATE(664),
    [sym_preproc_nullable] = STATE(664),
    [sym_preproc_error] = STATE(664),
    [sym_preproc_define] = STATE(664),
    [sym_preproc_undef] = STATE(664),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [665] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(665),
    [sym_preproc_endregion] = STATE(665),
    [sym_preproc_line] = STATE(665),
    [sym_preproc_pragma] = STATE(665),
    [sym_preproc_nullable] = STATE(665),
    [sym_preproc_error] = STATE(665),
    [sym_preproc_define] = STATE(665),
    [sym_preproc_undef] = STATE(665),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [666] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6369),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(666),
    [sym_preproc_endregion] = STATE(666),
    [sym_preproc_line] = STATE(666),
    [sym_preproc_pragma] = STATE(666),
    [sym_preproc_nullable] = STATE(666),
    [sym_preproc_error] = STATE(666),
    [sym_preproc_define] = STATE(666),
    [sym_preproc_undef] = STATE(666),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [667] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6113),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(667),
    [sym_preproc_endregion] = STATE(667),
    [sym_preproc_line] = STATE(667),
    [sym_preproc_pragma] = STATE(667),
    [sym_preproc_nullable] = STATE(667),
    [sym_preproc_error] = STATE(667),
    [sym_preproc_define] = STATE(667),
    [sym_preproc_undef] = STATE(667),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2755),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [668] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6635),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(668),
    [sym_preproc_endregion] = STATE(668),
    [sym_preproc_line] = STATE(668),
    [sym_preproc_pragma] = STATE(668),
    [sym_preproc_nullable] = STATE(668),
    [sym_preproc_error] = STATE(668),
    [sym_preproc_define] = STATE(668),
    [sym_preproc_undef] = STATE(668),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [669] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5831),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(669),
    [sym_preproc_endregion] = STATE(669),
    [sym_preproc_line] = STATE(669),
    [sym_preproc_pragma] = STATE(669),
    [sym_preproc_nullable] = STATE(669),
    [sym_preproc_error] = STATE(669),
    [sym_preproc_define] = STATE(669),
    [sym_preproc_undef] = STATE(669),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2763),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [670] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6409),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(670),
    [sym_preproc_endregion] = STATE(670),
    [sym_preproc_line] = STATE(670),
    [sym_preproc_pragma] = STATE(670),
    [sym_preproc_nullable] = STATE(670),
    [sym_preproc_error] = STATE(670),
    [sym_preproc_define] = STATE(670),
    [sym_preproc_undef] = STATE(670),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2769),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [671] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3926),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6323),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(5712),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(671),
    [sym_preproc_endregion] = STATE(671),
    [sym_preproc_line] = STATE(671),
    [sym_preproc_pragma] = STATE(671),
    [sym_preproc_nullable] = STATE(671),
    [sym_preproc_error] = STATE(671),
    [sym_preproc_define] = STATE(671),
    [sym_preproc_undef] = STATE(671),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2739),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [672] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3926),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6621),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(5712),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(672),
    [sym_preproc_endregion] = STATE(672),
    [sym_preproc_line] = STATE(672),
    [sym_preproc_pragma] = STATE(672),
    [sym_preproc_nullable] = STATE(672),
    [sym_preproc_error] = STATE(672),
    [sym_preproc_define] = STATE(672),
    [sym_preproc_undef] = STATE(672),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2739),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [673] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(673),
    [sym_preproc_endregion] = STATE(673),
    [sym_preproc_line] = STATE(673),
    [sym_preproc_pragma] = STATE(673),
    [sym_preproc_nullable] = STATE(673),
    [sym_preproc_error] = STATE(673),
    [sym_preproc_define] = STATE(673),
    [sym_preproc_undef] = STATE(673),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [674] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6432),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(674),
    [sym_preproc_endregion] = STATE(674),
    [sym_preproc_line] = STATE(674),
    [sym_preproc_pragma] = STATE(674),
    [sym_preproc_nullable] = STATE(674),
    [sym_preproc_error] = STATE(674),
    [sym_preproc_define] = STATE(674),
    [sym_preproc_undef] = STATE(674),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2719),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [675] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6438),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(675),
    [sym_preproc_endregion] = STATE(675),
    [sym_preproc_line] = STATE(675),
    [sym_preproc_pragma] = STATE(675),
    [sym_preproc_nullable] = STATE(675),
    [sym_preproc_error] = STATE(675),
    [sym_preproc_define] = STATE(675),
    [sym_preproc_undef] = STATE(675),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(2775),
    [anon_sym_default] = ACTIONS(2777),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [676] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6528),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(676),
    [sym_preproc_endregion] = STATE(676),
    [sym_preproc_line] = STATE(676),
    [sym_preproc_pragma] = STATE(676),
    [sym_preproc_nullable] = STATE(676),
    [sym_preproc_error] = STATE(676),
    [sym_preproc_define] = STATE(676),
    [sym_preproc_undef] = STATE(676),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [677] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(677),
    [sym_preproc_endregion] = STATE(677),
    [sym_preproc_line] = STATE(677),
    [sym_preproc_pragma] = STATE(677),
    [sym_preproc_nullable] = STATE(677),
    [sym_preproc_error] = STATE(677),
    [sym_preproc_define] = STATE(677),
    [sym_preproc_undef] = STATE(677),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [678] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(678),
    [sym_preproc_endregion] = STATE(678),
    [sym_preproc_line] = STATE(678),
    [sym_preproc_pragma] = STATE(678),
    [sym_preproc_nullable] = STATE(678),
    [sym_preproc_error] = STATE(678),
    [sym_preproc_define] = STATE(678),
    [sym_preproc_undef] = STATE(678),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [679] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3558),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6345),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4663),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(679),
    [sym_preproc_endregion] = STATE(679),
    [sym_preproc_line] = STATE(679),
    [sym_preproc_pragma] = STATE(679),
    [sym_preproc_nullable] = STATE(679),
    [sym_preproc_error] = STATE(679),
    [sym_preproc_define] = STATE(679),
    [sym_preproc_undef] = STATE(679),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [680] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6344),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(680),
    [sym_preproc_endregion] = STATE(680),
    [sym_preproc_line] = STATE(680),
    [sym_preproc_pragma] = STATE(680),
    [sym_preproc_nullable] = STATE(680),
    [sym_preproc_error] = STATE(680),
    [sym_preproc_define] = STATE(680),
    [sym_preproc_undef] = STATE(680),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [681] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3558),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6612),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4663),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(681),
    [sym_preproc_endregion] = STATE(681),
    [sym_preproc_line] = STATE(681),
    [sym_preproc_pragma] = STATE(681),
    [sym_preproc_nullable] = STATE(681),
    [sym_preproc_error] = STATE(681),
    [sym_preproc_define] = STATE(681),
    [sym_preproc_undef] = STATE(681),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [682] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3558),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6641),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4663),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(682),
    [sym_preproc_endregion] = STATE(682),
    [sym_preproc_line] = STATE(682),
    [sym_preproc_pragma] = STATE(682),
    [sym_preproc_nullable] = STATE(682),
    [sym_preproc_error] = STATE(682),
    [sym_preproc_define] = STATE(682),
    [sym_preproc_undef] = STATE(682),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [683] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6308),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(683),
    [sym_preproc_endregion] = STATE(683),
    [sym_preproc_line] = STATE(683),
    [sym_preproc_pragma] = STATE(683),
    [sym_preproc_nullable] = STATE(683),
    [sym_preproc_error] = STATE(683),
    [sym_preproc_define] = STATE(683),
    [sym_preproc_undef] = STATE(683),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [684] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3926),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6653),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(5712),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(684),
    [sym_preproc_endregion] = STATE(684),
    [sym_preproc_line] = STATE(684),
    [sym_preproc_pragma] = STATE(684),
    [sym_preproc_nullable] = STATE(684),
    [sym_preproc_error] = STATE(684),
    [sym_preproc_define] = STATE(684),
    [sym_preproc_undef] = STATE(684),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2739),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [685] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6234),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(685),
    [sym_preproc_endregion] = STATE(685),
    [sym_preproc_line] = STATE(685),
    [sym_preproc_pragma] = STATE(685),
    [sym_preproc_nullable] = STATE(685),
    [sym_preproc_error] = STATE(685),
    [sym_preproc_define] = STATE(685),
    [sym_preproc_undef] = STATE(685),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [686] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6526),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(686),
    [sym_preproc_endregion] = STATE(686),
    [sym_preproc_line] = STATE(686),
    [sym_preproc_pragma] = STATE(686),
    [sym_preproc_nullable] = STATE(686),
    [sym_preproc_error] = STATE(686),
    [sym_preproc_define] = STATE(686),
    [sym_preproc_undef] = STATE(686),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [687] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6364),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(687),
    [sym_preproc_endregion] = STATE(687),
    [sym_preproc_line] = STATE(687),
    [sym_preproc_pragma] = STATE(687),
    [sym_preproc_nullable] = STATE(687),
    [sym_preproc_error] = STATE(687),
    [sym_preproc_define] = STATE(687),
    [sym_preproc_undef] = STATE(687),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [688] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6535),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(688),
    [sym_preproc_endregion] = STATE(688),
    [sym_preproc_line] = STATE(688),
    [sym_preproc_pragma] = STATE(688),
    [sym_preproc_nullable] = STATE(688),
    [sym_preproc_error] = STATE(688),
    [sym_preproc_define] = STATE(688),
    [sym_preproc_undef] = STATE(688),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [689] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(689),
    [sym_preproc_endregion] = STATE(689),
    [sym_preproc_line] = STATE(689),
    [sym_preproc_pragma] = STATE(689),
    [sym_preproc_nullable] = STATE(689),
    [sym_preproc_error] = STATE(689),
    [sym_preproc_define] = STATE(689),
    [sym_preproc_undef] = STATE(689),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2787),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [690] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(690),
    [sym_preproc_endregion] = STATE(690),
    [sym_preproc_line] = STATE(690),
    [sym_preproc_pragma] = STATE(690),
    [sym_preproc_nullable] = STATE(690),
    [sym_preproc_error] = STATE(690),
    [sym_preproc_define] = STATE(690),
    [sym_preproc_undef] = STATE(690),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [691] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9710),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5929),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(691),
    [sym_preproc_endregion] = STATE(691),
    [sym_preproc_line] = STATE(691),
    [sym_preproc_pragma] = STATE(691),
    [sym_preproc_nullable] = STATE(691),
    [sym_preproc_error] = STATE(691),
    [sym_preproc_define] = STATE(691),
    [sym_preproc_undef] = STATE(691),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [692] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(692),
    [sym_preproc_endregion] = STATE(692),
    [sym_preproc_line] = STATE(692),
    [sym_preproc_pragma] = STATE(692),
    [sym_preproc_nullable] = STATE(692),
    [sym_preproc_error] = STATE(692),
    [sym_preproc_define] = STATE(692),
    [sym_preproc_undef] = STATE(692),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [693] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3558),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4663),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(693),
    [sym_preproc_endregion] = STATE(693),
    [sym_preproc_line] = STATE(693),
    [sym_preproc_pragma] = STATE(693),
    [sym_preproc_nullable] = STATE(693),
    [sym_preproc_error] = STATE(693),
    [sym_preproc_define] = STATE(693),
    [sym_preproc_undef] = STATE(693),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2783),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [694] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6422),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(694),
    [sym_preproc_endregion] = STATE(694),
    [sym_preproc_line] = STATE(694),
    [sym_preproc_pragma] = STATE(694),
    [sym_preproc_nullable] = STATE(694),
    [sym_preproc_error] = STATE(694),
    [sym_preproc_define] = STATE(694),
    [sym_preproc_undef] = STATE(694),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [695] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9508),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6558),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(695),
    [sym_preproc_endregion] = STATE(695),
    [sym_preproc_line] = STATE(695),
    [sym_preproc_pragma] = STATE(695),
    [sym_preproc_nullable] = STATE(695),
    [sym_preproc_error] = STATE(695),
    [sym_preproc_define] = STATE(695),
    [sym_preproc_undef] = STATE(695),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [696] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6404),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(696),
    [sym_preproc_endregion] = STATE(696),
    [sym_preproc_line] = STATE(696),
    [sym_preproc_pragma] = STATE(696),
    [sym_preproc_nullable] = STATE(696),
    [sym_preproc_error] = STATE(696),
    [sym_preproc_define] = STATE(696),
    [sym_preproc_undef] = STATE(696),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [697] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6485),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(697),
    [sym_preproc_endregion] = STATE(697),
    [sym_preproc_line] = STATE(697),
    [sym_preproc_pragma] = STATE(697),
    [sym_preproc_nullable] = STATE(697),
    [sym_preproc_error] = STATE(697),
    [sym_preproc_define] = STATE(697),
    [sym_preproc_undef] = STATE(697),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [698] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9378),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5916),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(698),
    [sym_preproc_endregion] = STATE(698),
    [sym_preproc_line] = STATE(698),
    [sym_preproc_pragma] = STATE(698),
    [sym_preproc_nullable] = STATE(698),
    [sym_preproc_error] = STATE(698),
    [sym_preproc_define] = STATE(698),
    [sym_preproc_undef] = STATE(698),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2797),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [699] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6417),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(699),
    [sym_preproc_endregion] = STATE(699),
    [sym_preproc_line] = STATE(699),
    [sym_preproc_pragma] = STATE(699),
    [sym_preproc_nullable] = STATE(699),
    [sym_preproc_error] = STATE(699),
    [sym_preproc_define] = STATE(699),
    [sym_preproc_undef] = STATE(699),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [700] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(700),
    [sym_preproc_endregion] = STATE(700),
    [sym_preproc_line] = STATE(700),
    [sym_preproc_pragma] = STATE(700),
    [sym_preproc_nullable] = STATE(700),
    [sym_preproc_error] = STATE(700),
    [sym_preproc_define] = STATE(700),
    [sym_preproc_undef] = STATE(700),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [701] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(701),
    [sym_preproc_endregion] = STATE(701),
    [sym_preproc_line] = STATE(701),
    [sym_preproc_pragma] = STATE(701),
    [sym_preproc_nullable] = STATE(701),
    [sym_preproc_error] = STATE(701),
    [sym_preproc_define] = STATE(701),
    [sym_preproc_undef] = STATE(701),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [702] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9421),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6354),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(702),
    [sym_preproc_endregion] = STATE(702),
    [sym_preproc_line] = STATE(702),
    [sym_preproc_pragma] = STATE(702),
    [sym_preproc_nullable] = STATE(702),
    [sym_preproc_error] = STATE(702),
    [sym_preproc_define] = STATE(702),
    [sym_preproc_undef] = STATE(702),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [703] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6590),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(703),
    [sym_preproc_endregion] = STATE(703),
    [sym_preproc_line] = STATE(703),
    [sym_preproc_pragma] = STATE(703),
    [sym_preproc_nullable] = STATE(703),
    [sym_preproc_error] = STATE(703),
    [sym_preproc_define] = STATE(703),
    [sym_preproc_undef] = STATE(703),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [704] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6500),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(704),
    [sym_preproc_endregion] = STATE(704),
    [sym_preproc_line] = STATE(704),
    [sym_preproc_pragma] = STATE(704),
    [sym_preproc_nullable] = STATE(704),
    [sym_preproc_error] = STATE(704),
    [sym_preproc_define] = STATE(704),
    [sym_preproc_undef] = STATE(704),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [705] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3799),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6365),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(705),
    [sym_preproc_endregion] = STATE(705),
    [sym_preproc_line] = STATE(705),
    [sym_preproc_pragma] = STATE(705),
    [sym_preproc_nullable] = STATE(705),
    [sym_preproc_error] = STATE(705),
    [sym_preproc_define] = STATE(705),
    [sym_preproc_undef] = STATE(705),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2795),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [706] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6493),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(706),
    [sym_preproc_endregion] = STATE(706),
    [sym_preproc_line] = STATE(706),
    [sym_preproc_pragma] = STATE(706),
    [sym_preproc_nullable] = STATE(706),
    [sym_preproc_error] = STATE(706),
    [sym_preproc_define] = STATE(706),
    [sym_preproc_undef] = STATE(706),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [707] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6394),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(707),
    [sym_preproc_endregion] = STATE(707),
    [sym_preproc_line] = STATE(707),
    [sym_preproc_pragma] = STATE(707),
    [sym_preproc_nullable] = STATE(707),
    [sym_preproc_error] = STATE(707),
    [sym_preproc_define] = STATE(707),
    [sym_preproc_undef] = STATE(707),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [708] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6234),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(708),
    [sym_preproc_endregion] = STATE(708),
    [sym_preproc_line] = STATE(708),
    [sym_preproc_pragma] = STATE(708),
    [sym_preproc_nullable] = STATE(708),
    [sym_preproc_error] = STATE(708),
    [sym_preproc_define] = STATE(708),
    [sym_preproc_undef] = STATE(708),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [709] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6445),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(709),
    [sym_preproc_endregion] = STATE(709),
    [sym_preproc_line] = STATE(709),
    [sym_preproc_pragma] = STATE(709),
    [sym_preproc_nullable] = STATE(709),
    [sym_preproc_error] = STATE(709),
    [sym_preproc_define] = STATE(709),
    [sym_preproc_undef] = STATE(709),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [710] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9567),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6349),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(710),
    [sym_preproc_endregion] = STATE(710),
    [sym_preproc_line] = STATE(710),
    [sym_preproc_pragma] = STATE(710),
    [sym_preproc_nullable] = STATE(710),
    [sym_preproc_error] = STATE(710),
    [sym_preproc_define] = STATE(710),
    [sym_preproc_undef] = STATE(710),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [711] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6629),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(711),
    [sym_preproc_endregion] = STATE(711),
    [sym_preproc_line] = STATE(711),
    [sym_preproc_pragma] = STATE(711),
    [sym_preproc_nullable] = STATE(711),
    [sym_preproc_error] = STATE(711),
    [sym_preproc_define] = STATE(711),
    [sym_preproc_undef] = STATE(711),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [712] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6455),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(712),
    [sym_preproc_endregion] = STATE(712),
    [sym_preproc_line] = STATE(712),
    [sym_preproc_pragma] = STATE(712),
    [sym_preproc_nullable] = STATE(712),
    [sym_preproc_error] = STATE(712),
    [sym_preproc_define] = STATE(712),
    [sym_preproc_undef] = STATE(712),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [713] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6581),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(713),
    [sym_preproc_endregion] = STATE(713),
    [sym_preproc_line] = STATE(713),
    [sym_preproc_pragma] = STATE(713),
    [sym_preproc_nullable] = STATE(713),
    [sym_preproc_error] = STATE(713),
    [sym_preproc_define] = STATE(713),
    [sym_preproc_undef] = STATE(713),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [714] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(714),
    [sym_preproc_endregion] = STATE(714),
    [sym_preproc_line] = STATE(714),
    [sym_preproc_pragma] = STATE(714),
    [sym_preproc_nullable] = STATE(714),
    [sym_preproc_error] = STATE(714),
    [sym_preproc_define] = STATE(714),
    [sym_preproc_undef] = STATE(714),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [715] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6508),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(715),
    [sym_preproc_endregion] = STATE(715),
    [sym_preproc_line] = STATE(715),
    [sym_preproc_pragma] = STATE(715),
    [sym_preproc_nullable] = STATE(715),
    [sym_preproc_error] = STATE(715),
    [sym_preproc_define] = STATE(715),
    [sym_preproc_undef] = STATE(715),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [716] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6264),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(716),
    [sym_preproc_endregion] = STATE(716),
    [sym_preproc_line] = STATE(716),
    [sym_preproc_pragma] = STATE(716),
    [sym_preproc_nullable] = STATE(716),
    [sym_preproc_error] = STATE(716),
    [sym_preproc_define] = STATE(716),
    [sym_preproc_undef] = STATE(716),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [717] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5823),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(717),
    [sym_preproc_endregion] = STATE(717),
    [sym_preproc_line] = STATE(717),
    [sym_preproc_pragma] = STATE(717),
    [sym_preproc_nullable] = STATE(717),
    [sym_preproc_error] = STATE(717),
    [sym_preproc_define] = STATE(717),
    [sym_preproc_undef] = STATE(717),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [718] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_variable_declaration] = STATE(9772),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6840),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6004),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(718),
    [sym_preproc_endregion] = STATE(718),
    [sym_preproc_line] = STATE(718),
    [sym_preproc_pragma] = STATE(718),
    [sym_preproc_nullable] = STATE(718),
    [sym_preproc_error] = STATE(718),
    [sym_preproc_define] = STATE(718),
    [sym_preproc_undef] = STATE(718),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2813),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [719] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_using_variable_declaration] = STATE(9173),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6822),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_expression] = STATE(6541),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(719),
    [sym_preproc_endregion] = STATE(719),
    [sym_preproc_line] = STATE(719),
    [sym_preproc_pragma] = STATE(719),
    [sym_preproc_nullable] = STATE(719),
    [sym_preproc_error] = STATE(719),
    [sym_preproc_define] = STATE(719),
    [sym_preproc_undef] = STATE(719),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [720] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(720),
    [sym_preproc_endregion] = STATE(720),
    [sym_preproc_line] = STATE(720),
    [sym_preproc_pragma] = STATE(720),
    [sym_preproc_nullable] = STATE(720),
    [sym_preproc_error] = STATE(720),
    [sym_preproc_define] = STATE(720),
    [sym_preproc_undef] = STATE(720),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [721] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(721),
    [sym_preproc_endregion] = STATE(721),
    [sym_preproc_line] = STATE(721),
    [sym_preproc_pragma] = STATE(721),
    [sym_preproc_nullable] = STATE(721),
    [sym_preproc_error] = STATE(721),
    [sym_preproc_define] = STATE(721),
    [sym_preproc_undef] = STATE(721),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [722] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6420),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(722),
    [sym_preproc_endregion] = STATE(722),
    [sym_preproc_line] = STATE(722),
    [sym_preproc_pragma] = STATE(722),
    [sym_preproc_nullable] = STATE(722),
    [sym_preproc_error] = STATE(722),
    [sym_preproc_define] = STATE(722),
    [sym_preproc_undef] = STATE(722),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [723] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6586),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(723),
    [sym_preproc_endregion] = STATE(723),
    [sym_preproc_line] = STATE(723),
    [sym_preproc_pragma] = STATE(723),
    [sym_preproc_nullable] = STATE(723),
    [sym_preproc_error] = STATE(723),
    [sym_preproc_define] = STATE(723),
    [sym_preproc_undef] = STATE(723),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [724] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3217),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6587),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3998),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(724),
    [sym_preproc_endregion] = STATE(724),
    [sym_preproc_line] = STATE(724),
    [sym_preproc_pragma] = STATE(724),
    [sym_preproc_nullable] = STATE(724),
    [sym_preproc_error] = STATE(724),
    [sym_preproc_define] = STATE(724),
    [sym_preproc_undef] = STATE(724),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2749),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [725] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3497),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6405),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(4260),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(725),
    [sym_preproc_endregion] = STATE(725),
    [sym_preproc_line] = STATE(725),
    [sym_preproc_pragma] = STATE(725),
    [sym_preproc_nullable] = STATE(725),
    [sym_preproc_error] = STATE(725),
    [sym_preproc_define] = STATE(725),
    [sym_preproc_undef] = STATE(725),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2731),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [726] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(2990),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6466),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3722),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(726),
    [sym_preproc_endregion] = STATE(726),
    [sym_preproc_line] = STATE(726),
    [sym_preproc_pragma] = STATE(726),
    [sym_preproc_nullable] = STATE(726),
    [sym_preproc_error] = STATE(726),
    [sym_preproc_define] = STATE(726),
    [sym_preproc_undef] = STATE(726),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2785),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [727] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3039),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6317),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_member_binding_expression] = STATE(3738),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(727),
    [sym_preproc_endregion] = STATE(727),
    [sym_preproc_line] = STATE(727),
    [sym_preproc_pragma] = STATE(727),
    [sym_preproc_nullable] = STATE(727),
    [sym_preproc_error] = STATE(727),
    [sym_preproc_define] = STATE(727),
    [sym_preproc_undef] = STATE(727),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_DOT] = ACTIONS(2727),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [728] = {
    [sym_attribute_argument] = STATE(8510),
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6230),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2852),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(728),
    [sym_preproc_endregion] = STATE(728),
    [sym_preproc_line] = STATE(728),
    [sym_preproc_pragma] = STATE(728),
    [sym_preproc_nullable] = STATE(728),
    [sym_preproc_error] = STATE(728),
    [sym_preproc_define] = STATE(728),
    [sym_preproc_undef] = STATE(728),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2819),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [729] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6734),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5823),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(729),
    [sym_preproc_endregion] = STATE(729),
    [sym_preproc_line] = STATE(729),
    [sym_preproc_pragma] = STATE(729),
    [sym_preproc_nullable] = STATE(729),
    [sym_preproc_error] = STATE(729),
    [sym_preproc_define] = STATE(729),
    [sym_preproc_undef] = STATE(729),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [730] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5810),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(730),
    [sym_preproc_endregion] = STATE(730),
    [sym_preproc_line] = STATE(730),
    [sym_preproc_pragma] = STATE(730),
    [sym_preproc_nullable] = STATE(730),
    [sym_preproc_error] = STATE(730),
    [sym_preproc_define] = STATE(730),
    [sym_preproc_undef] = STATE(730),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [731] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5538),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(731),
    [sym_preproc_endregion] = STATE(731),
    [sym_preproc_line] = STATE(731),
    [sym_preproc_pragma] = STATE(731),
    [sym_preproc_nullable] = STATE(731),
    [sym_preproc_error] = STATE(731),
    [sym_preproc_define] = STATE(731),
    [sym_preproc_undef] = STATE(731),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [732] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4489),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(732),
    [sym_preproc_endregion] = STATE(732),
    [sym_preproc_line] = STATE(732),
    [sym_preproc_pragma] = STATE(732),
    [sym_preproc_nullable] = STATE(732),
    [sym_preproc_error] = STATE(732),
    [sym_preproc_define] = STATE(732),
    [sym_preproc_undef] = STATE(732),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [733] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(733),
    [sym_preproc_endregion] = STATE(733),
    [sym_preproc_line] = STATE(733),
    [sym_preproc_pragma] = STATE(733),
    [sym_preproc_nullable] = STATE(733),
    [sym_preproc_error] = STATE(733),
    [sym_preproc_define] = STATE(733),
    [sym_preproc_undef] = STATE(733),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2825),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [734] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5921),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(734),
    [sym_preproc_endregion] = STATE(734),
    [sym_preproc_line] = STATE(734),
    [sym_preproc_pragma] = STATE(734),
    [sym_preproc_nullable] = STATE(734),
    [sym_preproc_error] = STATE(734),
    [sym_preproc_define] = STATE(734),
    [sym_preproc_undef] = STATE(734),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [735] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5922),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(735),
    [sym_preproc_endregion] = STATE(735),
    [sym_preproc_line] = STATE(735),
    [sym_preproc_pragma] = STATE(735),
    [sym_preproc_nullable] = STATE(735),
    [sym_preproc_error] = STATE(735),
    [sym_preproc_define] = STATE(735),
    [sym_preproc_undef] = STATE(735),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [736] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5930),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(736),
    [sym_preproc_endregion] = STATE(736),
    [sym_preproc_line] = STATE(736),
    [sym_preproc_pragma] = STATE(736),
    [sym_preproc_nullable] = STATE(736),
    [sym_preproc_error] = STATE(736),
    [sym_preproc_define] = STATE(736),
    [sym_preproc_undef] = STATE(736),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [737] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5539),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(737),
    [sym_preproc_endregion] = STATE(737),
    [sym_preproc_line] = STATE(737),
    [sym_preproc_pragma] = STATE(737),
    [sym_preproc_nullable] = STATE(737),
    [sym_preproc_error] = STATE(737),
    [sym_preproc_define] = STATE(737),
    [sym_preproc_undef] = STATE(737),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [738] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5933),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(738),
    [sym_preproc_endregion] = STATE(738),
    [sym_preproc_line] = STATE(738),
    [sym_preproc_pragma] = STATE(738),
    [sym_preproc_nullable] = STATE(738),
    [sym_preproc_error] = STATE(738),
    [sym_preproc_define] = STATE(738),
    [sym_preproc_undef] = STATE(738),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [739] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5540),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(739),
    [sym_preproc_endregion] = STATE(739),
    [sym_preproc_line] = STATE(739),
    [sym_preproc_pragma] = STATE(739),
    [sym_preproc_nullable] = STATE(739),
    [sym_preproc_error] = STATE(739),
    [sym_preproc_define] = STATE(739),
    [sym_preproc_undef] = STATE(739),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [740] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5937),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(740),
    [sym_preproc_endregion] = STATE(740),
    [sym_preproc_line] = STATE(740),
    [sym_preproc_pragma] = STATE(740),
    [sym_preproc_nullable] = STATE(740),
    [sym_preproc_error] = STATE(740),
    [sym_preproc_define] = STATE(740),
    [sym_preproc_undef] = STATE(740),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [741] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5938),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(741),
    [sym_preproc_endregion] = STATE(741),
    [sym_preproc_line] = STATE(741),
    [sym_preproc_pragma] = STATE(741),
    [sym_preproc_nullable] = STATE(741),
    [sym_preproc_error] = STATE(741),
    [sym_preproc_define] = STATE(741),
    [sym_preproc_undef] = STATE(741),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [742] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5818),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8425),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(742),
    [sym_preproc_endregion] = STATE(742),
    [sym_preproc_line] = STATE(742),
    [sym_preproc_pragma] = STATE(742),
    [sym_preproc_nullable] = STATE(742),
    [sym_preproc_error] = STATE(742),
    [sym_preproc_define] = STATE(742),
    [sym_preproc_undef] = STATE(742),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [743] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5554),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(743),
    [sym_preproc_endregion] = STATE(743),
    [sym_preproc_line] = STATE(743),
    [sym_preproc_pragma] = STATE(743),
    [sym_preproc_nullable] = STATE(743),
    [sym_preproc_error] = STATE(743),
    [sym_preproc_define] = STATE(743),
    [sym_preproc_undef] = STATE(743),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [744] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6721),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5655),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(744),
    [sym_preproc_endregion] = STATE(744),
    [sym_preproc_line] = STATE(744),
    [sym_preproc_pragma] = STATE(744),
    [sym_preproc_nullable] = STATE(744),
    [sym_preproc_error] = STATE(744),
    [sym_preproc_define] = STATE(744),
    [sym_preproc_undef] = STATE(744),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2831),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [745] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4808),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(745),
    [sym_preproc_endregion] = STATE(745),
    [sym_preproc_line] = STATE(745),
    [sym_preproc_pragma] = STATE(745),
    [sym_preproc_nullable] = STATE(745),
    [sym_preproc_error] = STATE(745),
    [sym_preproc_define] = STATE(745),
    [sym_preproc_undef] = STATE(745),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [746] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6948),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5562),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(746),
    [sym_preproc_endregion] = STATE(746),
    [sym_preproc_line] = STATE(746),
    [sym_preproc_pragma] = STATE(746),
    [sym_preproc_nullable] = STATE(746),
    [sym_preproc_error] = STATE(746),
    [sym_preproc_define] = STATE(746),
    [sym_preproc_undef] = STATE(746),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [747] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5371),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(747),
    [sym_preproc_endregion] = STATE(747),
    [sym_preproc_line] = STATE(747),
    [sym_preproc_pragma] = STATE(747),
    [sym_preproc_nullable] = STATE(747),
    [sym_preproc_error] = STATE(747),
    [sym_preproc_define] = STATE(747),
    [sym_preproc_undef] = STATE(747),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [748] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4810),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(748),
    [sym_preproc_endregion] = STATE(748),
    [sym_preproc_line] = STATE(748),
    [sym_preproc_pragma] = STATE(748),
    [sym_preproc_nullable] = STATE(748),
    [sym_preproc_error] = STATE(748),
    [sym_preproc_define] = STATE(748),
    [sym_preproc_undef] = STATE(748),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [749] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5121),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(749),
    [sym_preproc_endregion] = STATE(749),
    [sym_preproc_line] = STATE(749),
    [sym_preproc_pragma] = STATE(749),
    [sym_preproc_nullable] = STATE(749),
    [sym_preproc_error] = STATE(749),
    [sym_preproc_define] = STATE(749),
    [sym_preproc_undef] = STATE(749),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [750] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6995),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5041),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(750),
    [sym_preproc_endregion] = STATE(750),
    [sym_preproc_line] = STATE(750),
    [sym_preproc_pragma] = STATE(750),
    [sym_preproc_nullable] = STATE(750),
    [sym_preproc_error] = STATE(750),
    [sym_preproc_define] = STATE(750),
    [sym_preproc_undef] = STATE(750),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [751] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5958),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(751),
    [sym_preproc_endregion] = STATE(751),
    [sym_preproc_line] = STATE(751),
    [sym_preproc_pragma] = STATE(751),
    [sym_preproc_nullable] = STATE(751),
    [sym_preproc_error] = STATE(751),
    [sym_preproc_define] = STATE(751),
    [sym_preproc_undef] = STATE(751),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [752] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5959),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(752),
    [sym_preproc_endregion] = STATE(752),
    [sym_preproc_line] = STATE(752),
    [sym_preproc_pragma] = STATE(752),
    [sym_preproc_nullable] = STATE(752),
    [sym_preproc_error] = STATE(752),
    [sym_preproc_define] = STATE(752),
    [sym_preproc_undef] = STATE(752),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [753] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5961),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(753),
    [sym_preproc_endregion] = STATE(753),
    [sym_preproc_line] = STATE(753),
    [sym_preproc_pragma] = STATE(753),
    [sym_preproc_nullable] = STATE(753),
    [sym_preproc_error] = STATE(753),
    [sym_preproc_define] = STATE(753),
    [sym_preproc_undef] = STATE(753),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [754] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4812),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(754),
    [sym_preproc_endregion] = STATE(754),
    [sym_preproc_line] = STATE(754),
    [sym_preproc_pragma] = STATE(754),
    [sym_preproc_nullable] = STATE(754),
    [sym_preproc_error] = STATE(754),
    [sym_preproc_define] = STATE(754),
    [sym_preproc_undef] = STATE(754),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [755] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5964),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(755),
    [sym_preproc_endregion] = STATE(755),
    [sym_preproc_line] = STATE(755),
    [sym_preproc_pragma] = STATE(755),
    [sym_preproc_nullable] = STATE(755),
    [sym_preproc_error] = STATE(755),
    [sym_preproc_define] = STATE(755),
    [sym_preproc_undef] = STATE(755),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [756] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5966),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(756),
    [sym_preproc_endregion] = STATE(756),
    [sym_preproc_line] = STATE(756),
    [sym_preproc_pragma] = STATE(756),
    [sym_preproc_nullable] = STATE(756),
    [sym_preproc_error] = STATE(756),
    [sym_preproc_define] = STATE(756),
    [sym_preproc_undef] = STATE(756),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [757] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5968),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(757),
    [sym_preproc_endregion] = STATE(757),
    [sym_preproc_line] = STATE(757),
    [sym_preproc_pragma] = STATE(757),
    [sym_preproc_nullable] = STATE(757),
    [sym_preproc_error] = STATE(757),
    [sym_preproc_define] = STATE(757),
    [sym_preproc_undef] = STATE(757),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [758] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5102),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(758),
    [sym_preproc_endregion] = STATE(758),
    [sym_preproc_line] = STATE(758),
    [sym_preproc_pragma] = STATE(758),
    [sym_preproc_nullable] = STATE(758),
    [sym_preproc_error] = STATE(758),
    [sym_preproc_define] = STATE(758),
    [sym_preproc_undef] = STATE(758),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [759] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7108),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6272),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(759),
    [sym_preproc_endregion] = STATE(759),
    [sym_preproc_line] = STATE(759),
    [sym_preproc_pragma] = STATE(759),
    [sym_preproc_nullable] = STATE(759),
    [sym_preproc_error] = STATE(759),
    [sym_preproc_define] = STATE(759),
    [sym_preproc_undef] = STATE(759),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [760] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7026),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5463),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(760),
    [sym_preproc_endregion] = STATE(760),
    [sym_preproc_line] = STATE(760),
    [sym_preproc_pragma] = STATE(760),
    [sym_preproc_nullable] = STATE(760),
    [sym_preproc_error] = STATE(760),
    [sym_preproc_define] = STATE(760),
    [sym_preproc_undef] = STATE(760),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [761] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5373),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(761),
    [sym_preproc_endregion] = STATE(761),
    [sym_preproc_line] = STATE(761),
    [sym_preproc_pragma] = STATE(761),
    [sym_preproc_nullable] = STATE(761),
    [sym_preproc_error] = STATE(761),
    [sym_preproc_define] = STATE(761),
    [sym_preproc_undef] = STATE(761),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [762] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(762),
    [sym_preproc_endregion] = STATE(762),
    [sym_preproc_line] = STATE(762),
    [sym_preproc_pragma] = STATE(762),
    [sym_preproc_nullable] = STATE(762),
    [sym_preproc_error] = STATE(762),
    [sym_preproc_define] = STATE(762),
    [sym_preproc_undef] = STATE(762),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [763] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5678),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(763),
    [sym_preproc_endregion] = STATE(763),
    [sym_preproc_line] = STATE(763),
    [sym_preproc_pragma] = STATE(763),
    [sym_preproc_nullable] = STATE(763),
    [sym_preproc_error] = STATE(763),
    [sym_preproc_define] = STATE(763),
    [sym_preproc_undef] = STATE(763),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [764] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5410),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(764),
    [sym_preproc_endregion] = STATE(764),
    [sym_preproc_line] = STATE(764),
    [sym_preproc_pragma] = STATE(764),
    [sym_preproc_nullable] = STATE(764),
    [sym_preproc_error] = STATE(764),
    [sym_preproc_define] = STATE(764),
    [sym_preproc_undef] = STATE(764),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [765] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5624),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(765),
    [sym_preproc_endregion] = STATE(765),
    [sym_preproc_line] = STATE(765),
    [sym_preproc_pragma] = STATE(765),
    [sym_preproc_nullable] = STATE(765),
    [sym_preproc_error] = STATE(765),
    [sym_preproc_define] = STATE(765),
    [sym_preproc_undef] = STATE(765),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [766] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5072),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(766),
    [sym_preproc_endregion] = STATE(766),
    [sym_preproc_line] = STATE(766),
    [sym_preproc_pragma] = STATE(766),
    [sym_preproc_nullable] = STATE(766),
    [sym_preproc_error] = STATE(766),
    [sym_preproc_define] = STATE(766),
    [sym_preproc_undef] = STATE(766),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [767] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5682),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(767),
    [sym_preproc_endregion] = STATE(767),
    [sym_preproc_line] = STATE(767),
    [sym_preproc_pragma] = STATE(767),
    [sym_preproc_nullable] = STATE(767),
    [sym_preproc_error] = STATE(767),
    [sym_preproc_define] = STATE(767),
    [sym_preproc_undef] = STATE(767),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [768] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5626),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(768),
    [sym_preproc_endregion] = STATE(768),
    [sym_preproc_line] = STATE(768),
    [sym_preproc_pragma] = STATE(768),
    [sym_preproc_nullable] = STATE(768),
    [sym_preproc_error] = STATE(768),
    [sym_preproc_define] = STATE(768),
    [sym_preproc_undef] = STATE(768),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [769] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6453),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(769),
    [sym_preproc_endregion] = STATE(769),
    [sym_preproc_line] = STATE(769),
    [sym_preproc_pragma] = STATE(769),
    [sym_preproc_nullable] = STATE(769),
    [sym_preproc_error] = STATE(769),
    [sym_preproc_define] = STATE(769),
    [sym_preproc_undef] = STATE(769),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [770] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5629),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(770),
    [sym_preproc_endregion] = STATE(770),
    [sym_preproc_line] = STATE(770),
    [sym_preproc_pragma] = STATE(770),
    [sym_preproc_nullable] = STATE(770),
    [sym_preproc_error] = STATE(770),
    [sym_preproc_define] = STATE(770),
    [sym_preproc_undef] = STATE(770),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [771] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5374),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(771),
    [sym_preproc_endregion] = STATE(771),
    [sym_preproc_line] = STATE(771),
    [sym_preproc_pragma] = STATE(771),
    [sym_preproc_nullable] = STATE(771),
    [sym_preproc_error] = STATE(771),
    [sym_preproc_define] = STATE(771),
    [sym_preproc_undef] = STATE(771),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [772] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3182),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2757),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2778),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(772),
    [sym_preproc_endregion] = STATE(772),
    [sym_preproc_line] = STATE(772),
    [sym_preproc_pragma] = STATE(772),
    [sym_preproc_nullable] = STATE(772),
    [sym_preproc_error] = STATE(772),
    [sym_preproc_define] = STATE(772),
    [sym_preproc_undef] = STATE(772),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_ref] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2841),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2335),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2843),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [773] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5112),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(773),
    [sym_preproc_endregion] = STATE(773),
    [sym_preproc_line] = STATE(773),
    [sym_preproc_pragma] = STATE(773),
    [sym_preproc_nullable] = STATE(773),
    [sym_preproc_error] = STATE(773),
    [sym_preproc_define] = STATE(773),
    [sym_preproc_undef] = STATE(773),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [774] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4776),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(774),
    [sym_preproc_endregion] = STATE(774),
    [sym_preproc_line] = STATE(774),
    [sym_preproc_pragma] = STATE(774),
    [sym_preproc_nullable] = STATE(774),
    [sym_preproc_error] = STATE(774),
    [sym_preproc_define] = STATE(774),
    [sym_preproc_undef] = STATE(774),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [775] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5975),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(775),
    [sym_preproc_endregion] = STATE(775),
    [sym_preproc_line] = STATE(775),
    [sym_preproc_pragma] = STATE(775),
    [sym_preproc_nullable] = STATE(775),
    [sym_preproc_error] = STATE(775),
    [sym_preproc_define] = STATE(775),
    [sym_preproc_undef] = STATE(775),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [776] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6197),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(776),
    [sym_preproc_endregion] = STATE(776),
    [sym_preproc_line] = STATE(776),
    [sym_preproc_pragma] = STATE(776),
    [sym_preproc_nullable] = STATE(776),
    [sym_preproc_error] = STATE(776),
    [sym_preproc_define] = STATE(776),
    [sym_preproc_undef] = STATE(776),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [777] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6195),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(777),
    [sym_preproc_endregion] = STATE(777),
    [sym_preproc_line] = STATE(777),
    [sym_preproc_pragma] = STATE(777),
    [sym_preproc_nullable] = STATE(777),
    [sym_preproc_error] = STATE(777),
    [sym_preproc_define] = STATE(777),
    [sym_preproc_undef] = STATE(777),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [778] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5632),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(778),
    [sym_preproc_endregion] = STATE(778),
    [sym_preproc_line] = STATE(778),
    [sym_preproc_pragma] = STATE(778),
    [sym_preproc_nullable] = STATE(778),
    [sym_preproc_error] = STATE(778),
    [sym_preproc_define] = STATE(778),
    [sym_preproc_undef] = STATE(778),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [779] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6191),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(779),
    [sym_preproc_endregion] = STATE(779),
    [sym_preproc_line] = STATE(779),
    [sym_preproc_pragma] = STATE(779),
    [sym_preproc_nullable] = STATE(779),
    [sym_preproc_error] = STATE(779),
    [sym_preproc_define] = STATE(779),
    [sym_preproc_undef] = STATE(779),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [780] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5634),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(780),
    [sym_preproc_endregion] = STATE(780),
    [sym_preproc_line] = STATE(780),
    [sym_preproc_pragma] = STATE(780),
    [sym_preproc_nullable] = STATE(780),
    [sym_preproc_error] = STATE(780),
    [sym_preproc_define] = STATE(780),
    [sym_preproc_undef] = STATE(780),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [781] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6189),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(781),
    [sym_preproc_endregion] = STATE(781),
    [sym_preproc_line] = STATE(781),
    [sym_preproc_pragma] = STATE(781),
    [sym_preproc_nullable] = STATE(781),
    [sym_preproc_error] = STATE(781),
    [sym_preproc_define] = STATE(781),
    [sym_preproc_undef] = STATE(781),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [782] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6188),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(782),
    [sym_preproc_endregion] = STATE(782),
    [sym_preproc_line] = STATE(782),
    [sym_preproc_pragma] = STATE(782),
    [sym_preproc_nullable] = STATE(782),
    [sym_preproc_error] = STATE(782),
    [sym_preproc_define] = STATE(782),
    [sym_preproc_undef] = STATE(782),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [783] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6187),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(783),
    [sym_preproc_endregion] = STATE(783),
    [sym_preproc_line] = STATE(783),
    [sym_preproc_pragma] = STATE(783),
    [sym_preproc_nullable] = STATE(783),
    [sym_preproc_error] = STATE(783),
    [sym_preproc_define] = STATE(783),
    [sym_preproc_undef] = STATE(783),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [784] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5635),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(784),
    [sym_preproc_endregion] = STATE(784),
    [sym_preproc_line] = STATE(784),
    [sym_preproc_pragma] = STATE(784),
    [sym_preproc_nullable] = STATE(784),
    [sym_preproc_error] = STATE(784),
    [sym_preproc_define] = STATE(784),
    [sym_preproc_undef] = STATE(784),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [785] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5716),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(785),
    [sym_preproc_endregion] = STATE(785),
    [sym_preproc_line] = STATE(785),
    [sym_preproc_pragma] = STATE(785),
    [sym_preproc_nullable] = STATE(785),
    [sym_preproc_error] = STATE(785),
    [sym_preproc_define] = STATE(785),
    [sym_preproc_undef] = STATE(785),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [786] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5718),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(786),
    [sym_preproc_endregion] = STATE(786),
    [sym_preproc_line] = STATE(786),
    [sym_preproc_pragma] = STATE(786),
    [sym_preproc_nullable] = STATE(786),
    [sym_preproc_error] = STATE(786),
    [sym_preproc_define] = STATE(786),
    [sym_preproc_undef] = STATE(786),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [787] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5719),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(787),
    [sym_preproc_endregion] = STATE(787),
    [sym_preproc_line] = STATE(787),
    [sym_preproc_pragma] = STATE(787),
    [sym_preproc_nullable] = STATE(787),
    [sym_preproc_error] = STATE(787),
    [sym_preproc_define] = STATE(787),
    [sym_preproc_undef] = STATE(787),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [788] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7104),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5941),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(788),
    [sym_preproc_endregion] = STATE(788),
    [sym_preproc_line] = STATE(788),
    [sym_preproc_pragma] = STATE(788),
    [sym_preproc_nullable] = STATE(788),
    [sym_preproc_error] = STATE(788),
    [sym_preproc_define] = STATE(788),
    [sym_preproc_undef] = STATE(788),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [789] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7027),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5612),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(789),
    [sym_preproc_endregion] = STATE(789),
    [sym_preproc_line] = STATE(789),
    [sym_preproc_pragma] = STATE(789),
    [sym_preproc_nullable] = STATE(789),
    [sym_preproc_error] = STATE(789),
    [sym_preproc_define] = STATE(789),
    [sym_preproc_undef] = STATE(789),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [790] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6721),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5655),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(790),
    [sym_preproc_endregion] = STATE(790),
    [sym_preproc_line] = STATE(790),
    [sym_preproc_pragma] = STATE(790),
    [sym_preproc_nullable] = STATE(790),
    [sym_preproc_error] = STATE(790),
    [sym_preproc_define] = STATE(790),
    [sym_preproc_undef] = STATE(790),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [791] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6472),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(791),
    [sym_preproc_endregion] = STATE(791),
    [sym_preproc_line] = STATE(791),
    [sym_preproc_pragma] = STATE(791),
    [sym_preproc_nullable] = STATE(791),
    [sym_preproc_error] = STATE(791),
    [sym_preproc_define] = STATE(791),
    [sym_preproc_undef] = STATE(791),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [792] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5679),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(792),
    [sym_preproc_endregion] = STATE(792),
    [sym_preproc_line] = STATE(792),
    [sym_preproc_pragma] = STATE(792),
    [sym_preproc_nullable] = STATE(792),
    [sym_preproc_error] = STATE(792),
    [sym_preproc_define] = STATE(792),
    [sym_preproc_undef] = STATE(792),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [793] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7068),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4816),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(793),
    [sym_preproc_endregion] = STATE(793),
    [sym_preproc_line] = STATE(793),
    [sym_preproc_pragma] = STATE(793),
    [sym_preproc_nullable] = STATE(793),
    [sym_preproc_error] = STATE(793),
    [sym_preproc_define] = STATE(793),
    [sym_preproc_undef] = STATE(793),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [794] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5722),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6053),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(794),
    [sym_preproc_endregion] = STATE(794),
    [sym_preproc_line] = STATE(794),
    [sym_preproc_pragma] = STATE(794),
    [sym_preproc_nullable] = STATE(794),
    [sym_preproc_error] = STATE(794),
    [sym_preproc_define] = STATE(794),
    [sym_preproc_undef] = STATE(794),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [795] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7101),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6449),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(795),
    [sym_preproc_endregion] = STATE(795),
    [sym_preproc_line] = STATE(795),
    [sym_preproc_pragma] = STATE(795),
    [sym_preproc_nullable] = STATE(795),
    [sym_preproc_error] = STATE(795),
    [sym_preproc_define] = STATE(795),
    [sym_preproc_undef] = STATE(795),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [796] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6475),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(796),
    [sym_preproc_endregion] = STATE(796),
    [sym_preproc_line] = STATE(796),
    [sym_preproc_pragma] = STATE(796),
    [sym_preproc_nullable] = STATE(796),
    [sym_preproc_error] = STATE(796),
    [sym_preproc_define] = STATE(796),
    [sym_preproc_undef] = STATE(796),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [797] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6185),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(797),
    [sym_preproc_endregion] = STATE(797),
    [sym_preproc_line] = STATE(797),
    [sym_preproc_pragma] = STATE(797),
    [sym_preproc_nullable] = STATE(797),
    [sym_preproc_error] = STATE(797),
    [sym_preproc_define] = STATE(797),
    [sym_preproc_undef] = STATE(797),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [798] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5756),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6080),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(798),
    [sym_preproc_endregion] = STATE(798),
    [sym_preproc_line] = STATE(798),
    [sym_preproc_pragma] = STATE(798),
    [sym_preproc_nullable] = STATE(798),
    [sym_preproc_error] = STATE(798),
    [sym_preproc_define] = STATE(798),
    [sym_preproc_undef] = STATE(798),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [799] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5573),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(799),
    [sym_preproc_endregion] = STATE(799),
    [sym_preproc_line] = STATE(799),
    [sym_preproc_pragma] = STATE(799),
    [sym_preproc_nullable] = STATE(799),
    [sym_preproc_error] = STATE(799),
    [sym_preproc_define] = STATE(799),
    [sym_preproc_undef] = STATE(799),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [800] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6184),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(800),
    [sym_preproc_endregion] = STATE(800),
    [sym_preproc_line] = STATE(800),
    [sym_preproc_pragma] = STATE(800),
    [sym_preproc_nullable] = STATE(800),
    [sym_preproc_error] = STATE(800),
    [sym_preproc_define] = STATE(800),
    [sym_preproc_undef] = STATE(800),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [801] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6014),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(801),
    [sym_preproc_endregion] = STATE(801),
    [sym_preproc_line] = STATE(801),
    [sym_preproc_pragma] = STATE(801),
    [sym_preproc_nullable] = STATE(801),
    [sym_preproc_error] = STATE(801),
    [sym_preproc_define] = STATE(801),
    [sym_preproc_undef] = STATE(801),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [802] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4842),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(802),
    [sym_preproc_endregion] = STATE(802),
    [sym_preproc_line] = STATE(802),
    [sym_preproc_pragma] = STATE(802),
    [sym_preproc_nullable] = STATE(802),
    [sym_preproc_error] = STATE(802),
    [sym_preproc_define] = STATE(802),
    [sym_preproc_undef] = STATE(802),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [803] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6182),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(803),
    [sym_preproc_endregion] = STATE(803),
    [sym_preproc_line] = STATE(803),
    [sym_preproc_pragma] = STATE(803),
    [sym_preproc_nullable] = STATE(803),
    [sym_preproc_error] = STATE(803),
    [sym_preproc_define] = STATE(803),
    [sym_preproc_undef] = STATE(803),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [804] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5526),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(804),
    [sym_preproc_endregion] = STATE(804),
    [sym_preproc_line] = STATE(804),
    [sym_preproc_pragma] = STATE(804),
    [sym_preproc_nullable] = STATE(804),
    [sym_preproc_error] = STATE(804),
    [sym_preproc_define] = STATE(804),
    [sym_preproc_undef] = STATE(804),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [805] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6489),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(805),
    [sym_preproc_endregion] = STATE(805),
    [sym_preproc_line] = STATE(805),
    [sym_preproc_pragma] = STATE(805),
    [sym_preproc_nullable] = STATE(805),
    [sym_preproc_error] = STATE(805),
    [sym_preproc_define] = STATE(805),
    [sym_preproc_undef] = STATE(805),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [806] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6164),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(806),
    [sym_preproc_endregion] = STATE(806),
    [sym_preproc_line] = STATE(806),
    [sym_preproc_pragma] = STATE(806),
    [sym_preproc_nullable] = STATE(806),
    [sym_preproc_error] = STATE(806),
    [sym_preproc_define] = STATE(806),
    [sym_preproc_undef] = STATE(806),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [807] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5508),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(807),
    [sym_preproc_endregion] = STATE(807),
    [sym_preproc_line] = STATE(807),
    [sym_preproc_pragma] = STATE(807),
    [sym_preproc_nullable] = STATE(807),
    [sym_preproc_error] = STATE(807),
    [sym_preproc_define] = STATE(807),
    [sym_preproc_undef] = STATE(807),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [808] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5774),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6059),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(808),
    [sym_preproc_endregion] = STATE(808),
    [sym_preproc_line] = STATE(808),
    [sym_preproc_pragma] = STATE(808),
    [sym_preproc_nullable] = STATE(808),
    [sym_preproc_error] = STATE(808),
    [sym_preproc_define] = STATE(808),
    [sym_preproc_undef] = STATE(808),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [809] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5506),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(809),
    [sym_preproc_endregion] = STATE(809),
    [sym_preproc_line] = STATE(809),
    [sym_preproc_pragma] = STATE(809),
    [sym_preproc_nullable] = STATE(809),
    [sym_preproc_error] = STATE(809),
    [sym_preproc_define] = STATE(809),
    [sym_preproc_undef] = STATE(809),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [810] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6126),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(810),
    [sym_preproc_endregion] = STATE(810),
    [sym_preproc_line] = STATE(810),
    [sym_preproc_pragma] = STATE(810),
    [sym_preproc_nullable] = STATE(810),
    [sym_preproc_error] = STATE(810),
    [sym_preproc_define] = STATE(810),
    [sym_preproc_undef] = STATE(810),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [811] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5920),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(811),
    [sym_preproc_endregion] = STATE(811),
    [sym_preproc_line] = STATE(811),
    [sym_preproc_pragma] = STATE(811),
    [sym_preproc_nullable] = STATE(811),
    [sym_preproc_error] = STATE(811),
    [sym_preproc_define] = STATE(811),
    [sym_preproc_undef] = STATE(811),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [812] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5752),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6062),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(812),
    [sym_preproc_endregion] = STATE(812),
    [sym_preproc_line] = STATE(812),
    [sym_preproc_pragma] = STATE(812),
    [sym_preproc_nullable] = STATE(812),
    [sym_preproc_error] = STATE(812),
    [sym_preproc_define] = STATE(812),
    [sym_preproc_undef] = STATE(812),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [813] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6162),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(813),
    [sym_preproc_endregion] = STATE(813),
    [sym_preproc_line] = STATE(813),
    [sym_preproc_pragma] = STATE(813),
    [sym_preproc_nullable] = STATE(813),
    [sym_preproc_error] = STATE(813),
    [sym_preproc_define] = STATE(813),
    [sym_preproc_undef] = STATE(813),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [814] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5848),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(814),
    [sym_preproc_endregion] = STATE(814),
    [sym_preproc_line] = STATE(814),
    [sym_preproc_pragma] = STATE(814),
    [sym_preproc_nullable] = STATE(814),
    [sym_preproc_error] = STATE(814),
    [sym_preproc_define] = STATE(814),
    [sym_preproc_undef] = STATE(814),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2857),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [815] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5382),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(815),
    [sym_preproc_endregion] = STATE(815),
    [sym_preproc_line] = STATE(815),
    [sym_preproc_pragma] = STATE(815),
    [sym_preproc_nullable] = STATE(815),
    [sym_preproc_error] = STATE(815),
    [sym_preproc_define] = STATE(815),
    [sym_preproc_undef] = STATE(815),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [816] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6334),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(816),
    [sym_preproc_endregion] = STATE(816),
    [sym_preproc_line] = STATE(816),
    [sym_preproc_pragma] = STATE(816),
    [sym_preproc_nullable] = STATE(816),
    [sym_preproc_error] = STATE(816),
    [sym_preproc_define] = STATE(816),
    [sym_preproc_undef] = STATE(816),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [817] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5750),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6064),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(817),
    [sym_preproc_endregion] = STATE(817),
    [sym_preproc_line] = STATE(817),
    [sym_preproc_pragma] = STATE(817),
    [sym_preproc_nullable] = STATE(817),
    [sym_preproc_error] = STATE(817),
    [sym_preproc_define] = STATE(817),
    [sym_preproc_undef] = STATE(817),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [818] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6682),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(818),
    [sym_preproc_endregion] = STATE(818),
    [sym_preproc_line] = STATE(818),
    [sym_preproc_pragma] = STATE(818),
    [sym_preproc_nullable] = STATE(818),
    [sym_preproc_error] = STATE(818),
    [sym_preproc_define] = STATE(818),
    [sym_preproc_undef] = STATE(818),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [819] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6532),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(819),
    [sym_preproc_endregion] = STATE(819),
    [sym_preproc_line] = STATE(819),
    [sym_preproc_pragma] = STATE(819),
    [sym_preproc_nullable] = STATE(819),
    [sym_preproc_error] = STATE(819),
    [sym_preproc_define] = STATE(819),
    [sym_preproc_undef] = STATE(819),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [820] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5652),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6066),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(820),
    [sym_preproc_endregion] = STATE(820),
    [sym_preproc_line] = STATE(820),
    [sym_preproc_pragma] = STATE(820),
    [sym_preproc_nullable] = STATE(820),
    [sym_preproc_error] = STATE(820),
    [sym_preproc_define] = STATE(820),
    [sym_preproc_undef] = STATE(820),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [821] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6673),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(821),
    [sym_preproc_endregion] = STATE(821),
    [sym_preproc_line] = STATE(821),
    [sym_preproc_pragma] = STATE(821),
    [sym_preproc_nullable] = STATE(821),
    [sym_preproc_error] = STATE(821),
    [sym_preproc_define] = STATE(821),
    [sym_preproc_undef] = STATE(821),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [822] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5062),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(822),
    [sym_preproc_endregion] = STATE(822),
    [sym_preproc_line] = STATE(822),
    [sym_preproc_pragma] = STATE(822),
    [sym_preproc_nullable] = STATE(822),
    [sym_preproc_error] = STATE(822),
    [sym_preproc_define] = STATE(822),
    [sym_preproc_undef] = STATE(822),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [823] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5385),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(823),
    [sym_preproc_endregion] = STATE(823),
    [sym_preproc_line] = STATE(823),
    [sym_preproc_pragma] = STATE(823),
    [sym_preproc_nullable] = STATE(823),
    [sym_preproc_error] = STATE(823),
    [sym_preproc_define] = STATE(823),
    [sym_preproc_undef] = STATE(823),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [824] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5997),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(824),
    [sym_preproc_endregion] = STATE(824),
    [sym_preproc_line] = STATE(824),
    [sym_preproc_pragma] = STATE(824),
    [sym_preproc_nullable] = STATE(824),
    [sym_preproc_error] = STATE(824),
    [sym_preproc_define] = STATE(824),
    [sym_preproc_undef] = STATE(824),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [825] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5998),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(825),
    [sym_preproc_endregion] = STATE(825),
    [sym_preproc_line] = STATE(825),
    [sym_preproc_pragma] = STATE(825),
    [sym_preproc_nullable] = STATE(825),
    [sym_preproc_error] = STATE(825),
    [sym_preproc_define] = STATE(825),
    [sym_preproc_undef] = STATE(825),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2865),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [826] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5386),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(826),
    [sym_preproc_endregion] = STATE(826),
    [sym_preproc_line] = STATE(826),
    [sym_preproc_pragma] = STATE(826),
    [sym_preproc_nullable] = STATE(826),
    [sym_preproc_error] = STATE(826),
    [sym_preproc_define] = STATE(826),
    [sym_preproc_undef] = STATE(826),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [827] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7006),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4912),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(827),
    [sym_preproc_endregion] = STATE(827),
    [sym_preproc_line] = STATE(827),
    [sym_preproc_pragma] = STATE(827),
    [sym_preproc_nullable] = STATE(827),
    [sym_preproc_error] = STATE(827),
    [sym_preproc_define] = STATE(827),
    [sym_preproc_undef] = STATE(827),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [828] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6666),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(828),
    [sym_preproc_endregion] = STATE(828),
    [sym_preproc_line] = STATE(828),
    [sym_preproc_pragma] = STATE(828),
    [sym_preproc_nullable] = STATE(828),
    [sym_preproc_error] = STATE(828),
    [sym_preproc_define] = STATE(828),
    [sym_preproc_undef] = STATE(828),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [829] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6658),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(829),
    [sym_preproc_endregion] = STATE(829),
    [sym_preproc_line] = STATE(829),
    [sym_preproc_pragma] = STATE(829),
    [sym_preproc_nullable] = STATE(829),
    [sym_preproc_error] = STATE(829),
    [sym_preproc_define] = STATE(829),
    [sym_preproc_undef] = STATE(829),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [830] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6657),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(830),
    [sym_preproc_endregion] = STATE(830),
    [sym_preproc_line] = STATE(830),
    [sym_preproc_pragma] = STATE(830),
    [sym_preproc_nullable] = STATE(830),
    [sym_preproc_error] = STATE(830),
    [sym_preproc_define] = STATE(830),
    [sym_preproc_undef] = STATE(830),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [831] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7018),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6155),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(831),
    [sym_preproc_endregion] = STATE(831),
    [sym_preproc_line] = STATE(831),
    [sym_preproc_pragma] = STATE(831),
    [sym_preproc_nullable] = STATE(831),
    [sym_preproc_error] = STATE(831),
    [sym_preproc_define] = STATE(831),
    [sym_preproc_undef] = STATE(831),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [832] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6958),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5065),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(832),
    [sym_preproc_endregion] = STATE(832),
    [sym_preproc_line] = STATE(832),
    [sym_preproc_pragma] = STATE(832),
    [sym_preproc_nullable] = STATE(832),
    [sym_preproc_error] = STATE(832),
    [sym_preproc_define] = STATE(832),
    [sym_preproc_undef] = STATE(832),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [833] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6656),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(833),
    [sym_preproc_endregion] = STATE(833),
    [sym_preproc_line] = STATE(833),
    [sym_preproc_pragma] = STATE(833),
    [sym_preproc_nullable] = STATE(833),
    [sym_preproc_error] = STATE(833),
    [sym_preproc_define] = STATE(833),
    [sym_preproc_undef] = STATE(833),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [834] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6695),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2835),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(834),
    [sym_preproc_endregion] = STATE(834),
    [sym_preproc_line] = STATE(834),
    [sym_preproc_pragma] = STATE(834),
    [sym_preproc_nullable] = STATE(834),
    [sym_preproc_error] = STATE(834),
    [sym_preproc_define] = STATE(834),
    [sym_preproc_undef] = STATE(834),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2395),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2831),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [835] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5064),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(835),
    [sym_preproc_endregion] = STATE(835),
    [sym_preproc_line] = STATE(835),
    [sym_preproc_pragma] = STATE(835),
    [sym_preproc_nullable] = STATE(835),
    [sym_preproc_error] = STATE(835),
    [sym_preproc_define] = STATE(835),
    [sym_preproc_undef] = STATE(835),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [836] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7050),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5954),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(836),
    [sym_preproc_endregion] = STATE(836),
    [sym_preproc_line] = STATE(836),
    [sym_preproc_pragma] = STATE(836),
    [sym_preproc_nullable] = STATE(836),
    [sym_preproc_error] = STATE(836),
    [sym_preproc_define] = STATE(836),
    [sym_preproc_undef] = STATE(836),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [837] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5222),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(837),
    [sym_preproc_endregion] = STATE(837),
    [sym_preproc_line] = STATE(837),
    [sym_preproc_pragma] = STATE(837),
    [sym_preproc_nullable] = STATE(837),
    [sym_preproc_error] = STATE(837),
    [sym_preproc_define] = STATE(837),
    [sym_preproc_undef] = STATE(837),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [838] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6032),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(838),
    [sym_preproc_endregion] = STATE(838),
    [sym_preproc_line] = STATE(838),
    [sym_preproc_pragma] = STATE(838),
    [sym_preproc_nullable] = STATE(838),
    [sym_preproc_error] = STATE(838),
    [sym_preproc_define] = STATE(838),
    [sym_preproc_undef] = STATE(838),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [839] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6029),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(839),
    [sym_preproc_endregion] = STATE(839),
    [sym_preproc_line] = STATE(839),
    [sym_preproc_pragma] = STATE(839),
    [sym_preproc_nullable] = STATE(839),
    [sym_preproc_error] = STATE(839),
    [sym_preproc_define] = STATE(839),
    [sym_preproc_undef] = STATE(839),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [840] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6028),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(840),
    [sym_preproc_endregion] = STATE(840),
    [sym_preproc_line] = STATE(840),
    [sym_preproc_pragma] = STATE(840),
    [sym_preproc_nullable] = STATE(840),
    [sym_preproc_error] = STATE(840),
    [sym_preproc_define] = STATE(840),
    [sym_preproc_undef] = STATE(840),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [841] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4724),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(841),
    [sym_preproc_endregion] = STATE(841),
    [sym_preproc_line] = STATE(841),
    [sym_preproc_pragma] = STATE(841),
    [sym_preproc_nullable] = STATE(841),
    [sym_preproc_error] = STATE(841),
    [sym_preproc_define] = STATE(841),
    [sym_preproc_undef] = STATE(841),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [842] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5151),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(842),
    [sym_preproc_endregion] = STATE(842),
    [sym_preproc_line] = STATE(842),
    [sym_preproc_pragma] = STATE(842),
    [sym_preproc_nullable] = STATE(842),
    [sym_preproc_error] = STATE(842),
    [sym_preproc_define] = STATE(842),
    [sym_preproc_undef] = STATE(842),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [843] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6020),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(843),
    [sym_preproc_endregion] = STATE(843),
    [sym_preproc_line] = STATE(843),
    [sym_preproc_pragma] = STATE(843),
    [sym_preproc_nullable] = STATE(843),
    [sym_preproc_error] = STATE(843),
    [sym_preproc_define] = STATE(843),
    [sym_preproc_undef] = STATE(843),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [844] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6019),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(844),
    [sym_preproc_endregion] = STATE(844),
    [sym_preproc_line] = STATE(844),
    [sym_preproc_pragma] = STATE(844),
    [sym_preproc_nullable] = STATE(844),
    [sym_preproc_error] = STATE(844),
    [sym_preproc_define] = STATE(844),
    [sym_preproc_undef] = STATE(844),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [845] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5231),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(845),
    [sym_preproc_endregion] = STATE(845),
    [sym_preproc_line] = STATE(845),
    [sym_preproc_pragma] = STATE(845),
    [sym_preproc_nullable] = STATE(845),
    [sym_preproc_error] = STATE(845),
    [sym_preproc_define] = STATE(845),
    [sym_preproc_undef] = STATE(845),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [846] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6015),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(846),
    [sym_preproc_endregion] = STATE(846),
    [sym_preproc_line] = STATE(846),
    [sym_preproc_pragma] = STATE(846),
    [sym_preproc_nullable] = STATE(846),
    [sym_preproc_error] = STATE(846),
    [sym_preproc_define] = STATE(846),
    [sym_preproc_undef] = STATE(846),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [847] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7142),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6013),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(847),
    [sym_preproc_endregion] = STATE(847),
    [sym_preproc_line] = STATE(847),
    [sym_preproc_pragma] = STATE(847),
    [sym_preproc_nullable] = STATE(847),
    [sym_preproc_error] = STATE(847),
    [sym_preproc_define] = STATE(847),
    [sym_preproc_undef] = STATE(847),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [848] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6986),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6471),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(848),
    [sym_preproc_endregion] = STATE(848),
    [sym_preproc_line] = STATE(848),
    [sym_preproc_pragma] = STATE(848),
    [sym_preproc_nullable] = STATE(848),
    [sym_preproc_error] = STATE(848),
    [sym_preproc_define] = STATE(848),
    [sym_preproc_undef] = STATE(848),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [849] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5146),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(849),
    [sym_preproc_endregion] = STATE(849),
    [sym_preproc_line] = STATE(849),
    [sym_preproc_pragma] = STATE(849),
    [sym_preproc_nullable] = STATE(849),
    [sym_preproc_error] = STATE(849),
    [sym_preproc_define] = STATE(849),
    [sym_preproc_undef] = STATE(849),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [850] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5536),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(850),
    [sym_preproc_endregion] = STATE(850),
    [sym_preproc_line] = STATE(850),
    [sym_preproc_pragma] = STATE(850),
    [sym_preproc_nullable] = STATE(850),
    [sym_preproc_error] = STATE(850),
    [sym_preproc_define] = STATE(850),
    [sym_preproc_undef] = STATE(850),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [851] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5204),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(851),
    [sym_preproc_endregion] = STATE(851),
    [sym_preproc_line] = STATE(851),
    [sym_preproc_pragma] = STATE(851),
    [sym_preproc_nullable] = STATE(851),
    [sym_preproc_error] = STATE(851),
    [sym_preproc_define] = STATE(851),
    [sym_preproc_undef] = STATE(851),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [852] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4858),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(852),
    [sym_preproc_endregion] = STATE(852),
    [sym_preproc_line] = STATE(852),
    [sym_preproc_pragma] = STATE(852),
    [sym_preproc_nullable] = STATE(852),
    [sym_preproc_error] = STATE(852),
    [sym_preproc_define] = STATE(852),
    [sym_preproc_undef] = STATE(852),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [853] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5135),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(853),
    [sym_preproc_endregion] = STATE(853),
    [sym_preproc_line] = STATE(853),
    [sym_preproc_pragma] = STATE(853),
    [sym_preproc_nullable] = STATE(853),
    [sym_preproc_error] = STATE(853),
    [sym_preproc_define] = STATE(853),
    [sym_preproc_undef] = STATE(853),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [854] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5232),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(854),
    [sym_preproc_endregion] = STATE(854),
    [sym_preproc_line] = STATE(854),
    [sym_preproc_pragma] = STATE(854),
    [sym_preproc_nullable] = STATE(854),
    [sym_preproc_error] = STATE(854),
    [sym_preproc_define] = STATE(854),
    [sym_preproc_undef] = STATE(854),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [855] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5225),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(855),
    [sym_preproc_endregion] = STATE(855),
    [sym_preproc_line] = STATE(855),
    [sym_preproc_pragma] = STATE(855),
    [sym_preproc_nullable] = STATE(855),
    [sym_preproc_error] = STATE(855),
    [sym_preproc_define] = STATE(855),
    [sym_preproc_undef] = STATE(855),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [856] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5903),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(856),
    [sym_preproc_endregion] = STATE(856),
    [sym_preproc_line] = STATE(856),
    [sym_preproc_pragma] = STATE(856),
    [sym_preproc_nullable] = STATE(856),
    [sym_preproc_error] = STATE(856),
    [sym_preproc_define] = STATE(856),
    [sym_preproc_undef] = STATE(856),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2869),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [857] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4722),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(857),
    [sym_preproc_endregion] = STATE(857),
    [sym_preproc_line] = STATE(857),
    [sym_preproc_pragma] = STATE(857),
    [sym_preproc_nullable] = STATE(857),
    [sym_preproc_error] = STATE(857),
    [sym_preproc_define] = STATE(857),
    [sym_preproc_undef] = STATE(857),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [858] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5101),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(858),
    [sym_preproc_endregion] = STATE(858),
    [sym_preproc_line] = STATE(858),
    [sym_preproc_pragma] = STATE(858),
    [sym_preproc_nullable] = STATE(858),
    [sym_preproc_error] = STATE(858),
    [sym_preproc_define] = STATE(858),
    [sym_preproc_undef] = STATE(858),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [859] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4634),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4719),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(859),
    [sym_preproc_endregion] = STATE(859),
    [sym_preproc_line] = STATE(859),
    [sym_preproc_pragma] = STATE(859),
    [sym_preproc_nullable] = STATE(859),
    [sym_preproc_error] = STATE(859),
    [sym_preproc_define] = STATE(859),
    [sym_preproc_undef] = STATE(859),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [860] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7036),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5095),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(860),
    [sym_preproc_endregion] = STATE(860),
    [sym_preproc_line] = STATE(860),
    [sym_preproc_pragma] = STATE(860),
    [sym_preproc_nullable] = STATE(860),
    [sym_preproc_error] = STATE(860),
    [sym_preproc_define] = STATE(860),
    [sym_preproc_undef] = STATE(860),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [861] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4608),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4716),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(861),
    [sym_preproc_endregion] = STATE(861),
    [sym_preproc_line] = STATE(861),
    [sym_preproc_pragma] = STATE(861),
    [sym_preproc_nullable] = STATE(861),
    [sym_preproc_error] = STATE(861),
    [sym_preproc_define] = STATE(861),
    [sym_preproc_undef] = STATE(861),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [862] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(862),
    [sym_preproc_endregion] = STATE(862),
    [sym_preproc_line] = STATE(862),
    [sym_preproc_pragma] = STATE(862),
    [sym_preproc_nullable] = STATE(862),
    [sym_preproc_error] = STATE(862),
    [sym_preproc_define] = STATE(862),
    [sym_preproc_undef] = STATE(862),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [863] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5071),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(863),
    [sym_preproc_endregion] = STATE(863),
    [sym_preproc_line] = STATE(863),
    [sym_preproc_pragma] = STATE(863),
    [sym_preproc_nullable] = STATE(863),
    [sym_preproc_error] = STATE(863),
    [sym_preproc_define] = STATE(863),
    [sym_preproc_undef] = STATE(863),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [864] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6548),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(864),
    [sym_preproc_endregion] = STATE(864),
    [sym_preproc_line] = STATE(864),
    [sym_preproc_pragma] = STATE(864),
    [sym_preproc_nullable] = STATE(864),
    [sym_preproc_error] = STATE(864),
    [sym_preproc_define] = STATE(864),
    [sym_preproc_undef] = STATE(864),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [865] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4606),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4715),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(865),
    [sym_preproc_endregion] = STATE(865),
    [sym_preproc_line] = STATE(865),
    [sym_preproc_pragma] = STATE(865),
    [sym_preproc_nullable] = STATE(865),
    [sym_preproc_error] = STATE(865),
    [sym_preproc_define] = STATE(865),
    [sym_preproc_undef] = STATE(865),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [866] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(866),
    [sym_preproc_endregion] = STATE(866),
    [sym_preproc_line] = STATE(866),
    [sym_preproc_pragma] = STATE(866),
    [sym_preproc_nullable] = STATE(866),
    [sym_preproc_error] = STATE(866),
    [sym_preproc_define] = STATE(866),
    [sym_preproc_undef] = STATE(866),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [867] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6675),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(867),
    [sym_preproc_endregion] = STATE(867),
    [sym_preproc_line] = STATE(867),
    [sym_preproc_pragma] = STATE(867),
    [sym_preproc_nullable] = STATE(867),
    [sym_preproc_error] = STATE(867),
    [sym_preproc_define] = STATE(867),
    [sym_preproc_undef] = STATE(867),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [868] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6536),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(868),
    [sym_preproc_endregion] = STATE(868),
    [sym_preproc_line] = STATE(868),
    [sym_preproc_pragma] = STATE(868),
    [sym_preproc_nullable] = STATE(868),
    [sym_preproc_error] = STATE(868),
    [sym_preproc_define] = STATE(868),
    [sym_preproc_undef] = STATE(868),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [869] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4595),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4714),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(869),
    [sym_preproc_endregion] = STATE(869),
    [sym_preproc_line] = STATE(869),
    [sym_preproc_pragma] = STATE(869),
    [sym_preproc_nullable] = STATE(869),
    [sym_preproc_error] = STATE(869),
    [sym_preproc_define] = STATE(869),
    [sym_preproc_undef] = STATE(869),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [870] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5896),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(870),
    [sym_preproc_endregion] = STATE(870),
    [sym_preproc_line] = STATE(870),
    [sym_preproc_pragma] = STATE(870),
    [sym_preproc_nullable] = STATE(870),
    [sym_preproc_error] = STATE(870),
    [sym_preproc_define] = STATE(870),
    [sym_preproc_undef] = STATE(870),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [871] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7088),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5505),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(871),
    [sym_preproc_endregion] = STATE(871),
    [sym_preproc_line] = STATE(871),
    [sym_preproc_pragma] = STATE(871),
    [sym_preproc_nullable] = STATE(871),
    [sym_preproc_error] = STATE(871),
    [sym_preproc_define] = STATE(871),
    [sym_preproc_undef] = STATE(871),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [872] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5024),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(872),
    [sym_preproc_endregion] = STATE(872),
    [sym_preproc_line] = STATE(872),
    [sym_preproc_pragma] = STATE(872),
    [sym_preproc_nullable] = STATE(872),
    [sym_preproc_error] = STATE(872),
    [sym_preproc_define] = STATE(872),
    [sym_preproc_undef] = STATE(872),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [873] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4982),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(873),
    [sym_preproc_endregion] = STATE(873),
    [sym_preproc_line] = STATE(873),
    [sym_preproc_pragma] = STATE(873),
    [sym_preproc_nullable] = STATE(873),
    [sym_preproc_error] = STATE(873),
    [sym_preproc_define] = STATE(873),
    [sym_preproc_undef] = STATE(873),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [874] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7091),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5811),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_declaration_expression] = STATE(8440),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(874),
    [sym_preproc_endregion] = STATE(874),
    [sym_preproc_line] = STATE(874),
    [sym_preproc_pragma] = STATE(874),
    [sym_preproc_nullable] = STATE(874),
    [sym_preproc_error] = STATE(874),
    [sym_preproc_define] = STATE(874),
    [sym_preproc_undef] = STATE(874),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [875] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6688),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5445),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(875),
    [sym_preproc_endregion] = STATE(875),
    [sym_preproc_line] = STATE(875),
    [sym_preproc_pragma] = STATE(875),
    [sym_preproc_nullable] = STATE(875),
    [sym_preproc_error] = STATE(875),
    [sym_preproc_define] = STATE(875),
    [sym_preproc_undef] = STATE(875),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [876] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6527),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(876),
    [sym_preproc_endregion] = STATE(876),
    [sym_preproc_line] = STATE(876),
    [sym_preproc_pragma] = STATE(876),
    [sym_preproc_nullable] = STATE(876),
    [sym_preproc_error] = STATE(876),
    [sym_preproc_define] = STATE(876),
    [sym_preproc_undef] = STATE(876),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [877] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5026),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(877),
    [sym_preproc_endregion] = STATE(877),
    [sym_preproc_line] = STATE(877),
    [sym_preproc_pragma] = STATE(877),
    [sym_preproc_nullable] = STATE(877),
    [sym_preproc_error] = STATE(877),
    [sym_preproc_define] = STATE(877),
    [sym_preproc_undef] = STATE(877),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [878] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6524),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(878),
    [sym_preproc_endregion] = STATE(878),
    [sym_preproc_line] = STATE(878),
    [sym_preproc_pragma] = STATE(878),
    [sym_preproc_nullable] = STATE(878),
    [sym_preproc_error] = STATE(878),
    [sym_preproc_define] = STATE(878),
    [sym_preproc_undef] = STATE(878),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [879] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6510),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(879),
    [sym_preproc_endregion] = STATE(879),
    [sym_preproc_line] = STATE(879),
    [sym_preproc_pragma] = STATE(879),
    [sym_preproc_nullable] = STATE(879),
    [sym_preproc_error] = STATE(879),
    [sym_preproc_define] = STATE(879),
    [sym_preproc_undef] = STATE(879),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [880] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6506),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(880),
    [sym_preproc_endregion] = STATE(880),
    [sym_preproc_line] = STATE(880),
    [sym_preproc_pragma] = STATE(880),
    [sym_preproc_nullable] = STATE(880),
    [sym_preproc_error] = STATE(880),
    [sym_preproc_define] = STATE(880),
    [sym_preproc_undef] = STATE(880),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [881] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6697),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6643),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(881),
    [sym_preproc_endregion] = STATE(881),
    [sym_preproc_line] = STATE(881),
    [sym_preproc_pragma] = STATE(881),
    [sym_preproc_nullable] = STATE(881),
    [sym_preproc_error] = STATE(881),
    [sym_preproc_define] = STATE(881),
    [sym_preproc_undef] = STATE(881),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(2097),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [882] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5230),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(882),
    [sym_preproc_endregion] = STATE(882),
    [sym_preproc_line] = STATE(882),
    [sym_preproc_pragma] = STATE(882),
    [sym_preproc_nullable] = STATE(882),
    [sym_preproc_error] = STATE(882),
    [sym_preproc_define] = STATE(882),
    [sym_preproc_undef] = STATE(882),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [883] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5077),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(883),
    [sym_preproc_endregion] = STATE(883),
    [sym_preproc_line] = STATE(883),
    [sym_preproc_pragma] = STATE(883),
    [sym_preproc_nullable] = STATE(883),
    [sym_preproc_error] = STATE(883),
    [sym_preproc_define] = STATE(883),
    [sym_preproc_undef] = STATE(883),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [884] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5215),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(884),
    [sym_preproc_endregion] = STATE(884),
    [sym_preproc_line] = STATE(884),
    [sym_preproc_pragma] = STATE(884),
    [sym_preproc_nullable] = STATE(884),
    [sym_preproc_error] = STATE(884),
    [sym_preproc_define] = STATE(884),
    [sym_preproc_undef] = STATE(884),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [885] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5214),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(885),
    [sym_preproc_endregion] = STATE(885),
    [sym_preproc_line] = STATE(885),
    [sym_preproc_pragma] = STATE(885),
    [sym_preproc_nullable] = STATE(885),
    [sym_preproc_error] = STATE(885),
    [sym_preproc_define] = STATE(885),
    [sym_preproc_undef] = STATE(885),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [886] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5182),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(886),
    [sym_preproc_endregion] = STATE(886),
    [sym_preproc_line] = STATE(886),
    [sym_preproc_pragma] = STATE(886),
    [sym_preproc_nullable] = STATE(886),
    [sym_preproc_error] = STATE(886),
    [sym_preproc_define] = STATE(886),
    [sym_preproc_undef] = STATE(886),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [887] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5078),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(887),
    [sym_preproc_endregion] = STATE(887),
    [sym_preproc_line] = STATE(887),
    [sym_preproc_pragma] = STATE(887),
    [sym_preproc_nullable] = STATE(887),
    [sym_preproc_error] = STATE(887),
    [sym_preproc_define] = STATE(887),
    [sym_preproc_undef] = STATE(887),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [888] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7151),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5376),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(888),
    [sym_preproc_endregion] = STATE(888),
    [sym_preproc_line] = STATE(888),
    [sym_preproc_pragma] = STATE(888),
    [sym_preproc_nullable] = STATE(888),
    [sym_preproc_error] = STATE(888),
    [sym_preproc_define] = STATE(888),
    [sym_preproc_undef] = STATE(888),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [889] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5029),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(889),
    [sym_preproc_endregion] = STATE(889),
    [sym_preproc_line] = STATE(889),
    [sym_preproc_pragma] = STATE(889),
    [sym_preproc_nullable] = STATE(889),
    [sym_preproc_error] = STATE(889),
    [sym_preproc_define] = STATE(889),
    [sym_preproc_undef] = STATE(889),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [890] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6976),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5639),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(890),
    [sym_preproc_endregion] = STATE(890),
    [sym_preproc_line] = STATE(890),
    [sym_preproc_pragma] = STATE(890),
    [sym_preproc_nullable] = STATE(890),
    [sym_preproc_error] = STATE(890),
    [sym_preproc_define] = STATE(890),
    [sym_preproc_undef] = STATE(890),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [891] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5858),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(891),
    [sym_preproc_endregion] = STATE(891),
    [sym_preproc_line] = STATE(891),
    [sym_preproc_pragma] = STATE(891),
    [sym_preproc_nullable] = STATE(891),
    [sym_preproc_error] = STATE(891),
    [sym_preproc_define] = STATE(891),
    [sym_preproc_undef] = STATE(891),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [892] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5855),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(892),
    [sym_preproc_endregion] = STATE(892),
    [sym_preproc_line] = STATE(892),
    [sym_preproc_pragma] = STATE(892),
    [sym_preproc_nullable] = STATE(892),
    [sym_preproc_error] = STATE(892),
    [sym_preproc_define] = STATE(892),
    [sym_preproc_undef] = STATE(892),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [893] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6968),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5861),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(893),
    [sym_preproc_endregion] = STATE(893),
    [sym_preproc_line] = STATE(893),
    [sym_preproc_pragma] = STATE(893),
    [sym_preproc_nullable] = STATE(893),
    [sym_preproc_error] = STATE(893),
    [sym_preproc_define] = STATE(893),
    [sym_preproc_undef] = STATE(893),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [894] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6747),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2877),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6643),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(894),
    [sym_preproc_endregion] = STATE(894),
    [sym_preproc_line] = STATE(894),
    [sym_preproc_pragma] = STATE(894),
    [sym_preproc_nullable] = STATE(894),
    [sym_preproc_error] = STATE(894),
    [sym_preproc_define] = STATE(894),
    [sym_preproc_undef] = STATE(894),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [895] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5849),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(895),
    [sym_preproc_endregion] = STATE(895),
    [sym_preproc_line] = STATE(895),
    [sym_preproc_pragma] = STATE(895),
    [sym_preproc_nullable] = STATE(895),
    [sym_preproc_error] = STATE(895),
    [sym_preproc_define] = STATE(895),
    [sym_preproc_undef] = STATE(895),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [896] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5843),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(896),
    [sym_preproc_endregion] = STATE(896),
    [sym_preproc_line] = STATE(896),
    [sym_preproc_pragma] = STATE(896),
    [sym_preproc_nullable] = STATE(896),
    [sym_preproc_error] = STATE(896),
    [sym_preproc_define] = STATE(896),
    [sym_preproc_undef] = STATE(896),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [897] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7139),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5080),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(897),
    [sym_preproc_endregion] = STATE(897),
    [sym_preproc_line] = STATE(897),
    [sym_preproc_pragma] = STATE(897),
    [sym_preproc_nullable] = STATE(897),
    [sym_preproc_error] = STATE(897),
    [sym_preproc_define] = STATE(897),
    [sym_preproc_undef] = STATE(897),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [898] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5842),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(898),
    [sym_preproc_endregion] = STATE(898),
    [sym_preproc_line] = STATE(898),
    [sym_preproc_pragma] = STATE(898),
    [sym_preproc_nullable] = STATE(898),
    [sym_preproc_error] = STATE(898),
    [sym_preproc_define] = STATE(898),
    [sym_preproc_undef] = STATE(898),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [899] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6049),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(899),
    [sym_preproc_endregion] = STATE(899),
    [sym_preproc_line] = STATE(899),
    [sym_preproc_pragma] = STATE(899),
    [sym_preproc_nullable] = STATE(899),
    [sym_preproc_error] = STATE(899),
    [sym_preproc_define] = STATE(899),
    [sym_preproc_undef] = STATE(899),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [900] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6050),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(900),
    [sym_preproc_endregion] = STATE(900),
    [sym_preproc_line] = STATE(900),
    [sym_preproc_pragma] = STATE(900),
    [sym_preproc_nullable] = STATE(900),
    [sym_preproc_error] = STATE(900),
    [sym_preproc_define] = STATE(900),
    [sym_preproc_undef] = STATE(900),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [901] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5841),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(901),
    [sym_preproc_endregion] = STATE(901),
    [sym_preproc_line] = STATE(901),
    [sym_preproc_pragma] = STATE(901),
    [sym_preproc_nullable] = STATE(901),
    [sym_preproc_error] = STATE(901),
    [sym_preproc_define] = STATE(901),
    [sym_preproc_undef] = STATE(901),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [902] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5652),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5594),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(902),
    [sym_preproc_endregion] = STATE(902),
    [sym_preproc_line] = STATE(902),
    [sym_preproc_pragma] = STATE(902),
    [sym_preproc_nullable] = STATE(902),
    [sym_preproc_error] = STATE(902),
    [sym_preproc_define] = STATE(902),
    [sym_preproc_undef] = STATE(902),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [903] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6578),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(903),
    [sym_preproc_endregion] = STATE(903),
    [sym_preproc_line] = STATE(903),
    [sym_preproc_pragma] = STATE(903),
    [sym_preproc_nullable] = STATE(903),
    [sym_preproc_error] = STATE(903),
    [sym_preproc_define] = STATE(903),
    [sym_preproc_undef] = STATE(903),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [904] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6392),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(904),
    [sym_preproc_endregion] = STATE(904),
    [sym_preproc_line] = STATE(904),
    [sym_preproc_pragma] = STATE(904),
    [sym_preproc_nullable] = STATE(904),
    [sym_preproc_error] = STATE(904),
    [sym_preproc_define] = STATE(904),
    [sym_preproc_undef] = STATE(904),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [905] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5246),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(905),
    [sym_preproc_endregion] = STATE(905),
    [sym_preproc_line] = STATE(905),
    [sym_preproc_pragma] = STATE(905),
    [sym_preproc_nullable] = STATE(905),
    [sym_preproc_error] = STATE(905),
    [sym_preproc_define] = STATE(905),
    [sym_preproc_undef] = STATE(905),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [906] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7105),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5836),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(906),
    [sym_preproc_endregion] = STATE(906),
    [sym_preproc_line] = STATE(906),
    [sym_preproc_pragma] = STATE(906),
    [sym_preproc_nullable] = STATE(906),
    [sym_preproc_error] = STATE(906),
    [sym_preproc_define] = STATE(906),
    [sym_preproc_undef] = STATE(906),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [907] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5244),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(907),
    [sym_preproc_endregion] = STATE(907),
    [sym_preproc_line] = STATE(907),
    [sym_preproc_pragma] = STATE(907),
    [sym_preproc_nullable] = STATE(907),
    [sym_preproc_error] = STATE(907),
    [sym_preproc_define] = STATE(907),
    [sym_preproc_undef] = STATE(907),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [908] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5875),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(908),
    [sym_preproc_endregion] = STATE(908),
    [sym_preproc_line] = STATE(908),
    [sym_preproc_pragma] = STATE(908),
    [sym_preproc_nullable] = STATE(908),
    [sym_preproc_error] = STATE(908),
    [sym_preproc_define] = STATE(908),
    [sym_preproc_undef] = STATE(908),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [909] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5240),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(909),
    [sym_preproc_endregion] = STATE(909),
    [sym_preproc_line] = STATE(909),
    [sym_preproc_pragma] = STATE(909),
    [sym_preproc_nullable] = STATE(909),
    [sym_preproc_error] = STATE(909),
    [sym_preproc_define] = STATE(909),
    [sym_preproc_undef] = STATE(909),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [910] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5042),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(910),
    [sym_preproc_endregion] = STATE(910),
    [sym_preproc_line] = STATE(910),
    [sym_preproc_pragma] = STATE(910),
    [sym_preproc_nullable] = STATE(910),
    [sym_preproc_error] = STATE(910),
    [sym_preproc_define] = STATE(910),
    [sym_preproc_undef] = STATE(910),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [911] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6681),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(911),
    [sym_preproc_endregion] = STATE(911),
    [sym_preproc_line] = STATE(911),
    [sym_preproc_pragma] = STATE(911),
    [sym_preproc_nullable] = STATE(911),
    [sym_preproc_error] = STATE(911),
    [sym_preproc_define] = STATE(911),
    [sym_preproc_undef] = STATE(911),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [912] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5411),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(912),
    [sym_preproc_endregion] = STATE(912),
    [sym_preproc_line] = STATE(912),
    [sym_preproc_pragma] = STATE(912),
    [sym_preproc_nullable] = STATE(912),
    [sym_preproc_error] = STATE(912),
    [sym_preproc_define] = STATE(912),
    [sym_preproc_undef] = STATE(912),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [913] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6746),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2870),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2815),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(913),
    [sym_preproc_endregion] = STATE(913),
    [sym_preproc_line] = STATE(913),
    [sym_preproc_pragma] = STATE(913),
    [sym_preproc_nullable] = STATE(913),
    [sym_preproc_error] = STATE(913),
    [sym_preproc_define] = STATE(913),
    [sym_preproc_undef] = STATE(913),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2505),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [914] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4468),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(914),
    [sym_preproc_endregion] = STATE(914),
    [sym_preproc_line] = STATE(914),
    [sym_preproc_pragma] = STATE(914),
    [sym_preproc_nullable] = STATE(914),
    [sym_preproc_error] = STATE(914),
    [sym_preproc_define] = STATE(914),
    [sym_preproc_undef] = STATE(914),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [915] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4472),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(915),
    [sym_preproc_endregion] = STATE(915),
    [sym_preproc_line] = STATE(915),
    [sym_preproc_pragma] = STATE(915),
    [sym_preproc_nullable] = STATE(915),
    [sym_preproc_error] = STATE(915),
    [sym_preproc_define] = STATE(915),
    [sym_preproc_undef] = STATE(915),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [916] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6469),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(916),
    [sym_preproc_endregion] = STATE(916),
    [sym_preproc_line] = STATE(916),
    [sym_preproc_pragma] = STATE(916),
    [sym_preproc_nullable] = STATE(916),
    [sym_preproc_error] = STATE(916),
    [sym_preproc_define] = STATE(916),
    [sym_preproc_undef] = STATE(916),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [917] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4482),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(917),
    [sym_preproc_endregion] = STATE(917),
    [sym_preproc_line] = STATE(917),
    [sym_preproc_pragma] = STATE(917),
    [sym_preproc_nullable] = STATE(917),
    [sym_preproc_error] = STATE(917),
    [sym_preproc_define] = STATE(917),
    [sym_preproc_undef] = STATE(917),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [918] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5323),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(918),
    [sym_preproc_endregion] = STATE(918),
    [sym_preproc_line] = STATE(918),
    [sym_preproc_pragma] = STATE(918),
    [sym_preproc_nullable] = STATE(918),
    [sym_preproc_error] = STATE(918),
    [sym_preproc_define] = STATE(918),
    [sym_preproc_undef] = STATE(918),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [919] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5270),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(919),
    [sym_preproc_endregion] = STATE(919),
    [sym_preproc_line] = STATE(919),
    [sym_preproc_pragma] = STATE(919),
    [sym_preproc_nullable] = STATE(919),
    [sym_preproc_error] = STATE(919),
    [sym_preproc_define] = STATE(919),
    [sym_preproc_undef] = STATE(919),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [920] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5272),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(920),
    [sym_preproc_endregion] = STATE(920),
    [sym_preproc_line] = STATE(920),
    [sym_preproc_pragma] = STATE(920),
    [sym_preproc_nullable] = STATE(920),
    [sym_preproc_error] = STATE(920),
    [sym_preproc_define] = STATE(920),
    [sym_preproc_undef] = STATE(920),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [921] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6980),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5162),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(921),
    [sym_preproc_endregion] = STATE(921),
    [sym_preproc_line] = STATE(921),
    [sym_preproc_pragma] = STATE(921),
    [sym_preproc_nullable] = STATE(921),
    [sym_preproc_error] = STATE(921),
    [sym_preproc_define] = STATE(921),
    [sym_preproc_undef] = STATE(921),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [922] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7158),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5275),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(922),
    [sym_preproc_endregion] = STATE(922),
    [sym_preproc_line] = STATE(922),
    [sym_preproc_pragma] = STATE(922),
    [sym_preproc_nullable] = STATE(922),
    [sym_preproc_error] = STATE(922),
    [sym_preproc_define] = STATE(922),
    [sym_preproc_undef] = STATE(922),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [923] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5030),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(923),
    [sym_preproc_endregion] = STATE(923),
    [sym_preproc_line] = STATE(923),
    [sym_preproc_pragma] = STATE(923),
    [sym_preproc_nullable] = STATE(923),
    [sym_preproc_error] = STATE(923),
    [sym_preproc_define] = STATE(923),
    [sym_preproc_undef] = STATE(923),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [924] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(924),
    [sym_preproc_endregion] = STATE(924),
    [sym_preproc_line] = STATE(924),
    [sym_preproc_pragma] = STATE(924),
    [sym_preproc_nullable] = STATE(924),
    [sym_preproc_error] = STATE(924),
    [sym_preproc_define] = STATE(924),
    [sym_preproc_undef] = STATE(924),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [925] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(925),
    [sym_preproc_endregion] = STATE(925),
    [sym_preproc_line] = STATE(925),
    [sym_preproc_pragma] = STATE(925),
    [sym_preproc_nullable] = STATE(925),
    [sym_preproc_error] = STATE(925),
    [sym_preproc_define] = STATE(925),
    [sym_preproc_undef] = STATE(925),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [926] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6730),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2835),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6643),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(926),
    [sym_preproc_endregion] = STATE(926),
    [sym_preproc_line] = STATE(926),
    [sym_preproc_pragma] = STATE(926),
    [sym_preproc_nullable] = STATE(926),
    [sym_preproc_error] = STATE(926),
    [sym_preproc_define] = STATE(926),
    [sym_preproc_undef] = STATE(926),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(2299),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2831),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [927] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5031),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(927),
    [sym_preproc_endregion] = STATE(927),
    [sym_preproc_line] = STATE(927),
    [sym_preproc_pragma] = STATE(927),
    [sym_preproc_nullable] = STATE(927),
    [sym_preproc_error] = STATE(927),
    [sym_preproc_define] = STATE(927),
    [sym_preproc_undef] = STATE(927),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [928] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5743),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(928),
    [sym_preproc_endregion] = STATE(928),
    [sym_preproc_line] = STATE(928),
    [sym_preproc_pragma] = STATE(928),
    [sym_preproc_nullable] = STATE(928),
    [sym_preproc_error] = STATE(928),
    [sym_preproc_define] = STATE(928),
    [sym_preproc_undef] = STATE(928),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [929] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6418),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(929),
    [sym_preproc_endregion] = STATE(929),
    [sym_preproc_line] = STATE(929),
    [sym_preproc_pragma] = STATE(929),
    [sym_preproc_nullable] = STATE(929),
    [sym_preproc_error] = STATE(929),
    [sym_preproc_define] = STATE(929),
    [sym_preproc_undef] = STATE(929),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [930] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4486),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(930),
    [sym_preproc_endregion] = STATE(930),
    [sym_preproc_line] = STATE(930),
    [sym_preproc_pragma] = STATE(930),
    [sym_preproc_nullable] = STATE(930),
    [sym_preproc_error] = STATE(930),
    [sym_preproc_define] = STATE(930),
    [sym_preproc_undef] = STATE(930),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [931] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6713),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2821),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6688),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5445),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(931),
    [sym_preproc_endregion] = STATE(931),
    [sym_preproc_line] = STATE(931),
    [sym_preproc_pragma] = STATE(931),
    [sym_preproc_nullable] = STATE(931),
    [sym_preproc_error] = STATE(931),
    [sym_preproc_define] = STATE(931),
    [sym_preproc_undef] = STATE(931),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2831),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2301),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [932] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5507),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(932),
    [sym_preproc_endregion] = STATE(932),
    [sym_preproc_line] = STATE(932),
    [sym_preproc_pragma] = STATE(932),
    [sym_preproc_nullable] = STATE(932),
    [sym_preproc_error] = STATE(932),
    [sym_preproc_define] = STATE(932),
    [sym_preproc_undef] = STATE(932),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [933] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6585),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(933),
    [sym_preproc_endregion] = STATE(933),
    [sym_preproc_line] = STATE(933),
    [sym_preproc_pragma] = STATE(933),
    [sym_preproc_nullable] = STATE(933),
    [sym_preproc_error] = STATE(933),
    [sym_preproc_define] = STATE(933),
    [sym_preproc_undef] = STATE(933),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [934] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6584),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(934),
    [sym_preproc_endregion] = STATE(934),
    [sym_preproc_line] = STATE(934),
    [sym_preproc_pragma] = STATE(934),
    [sym_preproc_nullable] = STATE(934),
    [sym_preproc_error] = STATE(934),
    [sym_preproc_define] = STATE(934),
    [sym_preproc_undef] = STATE(934),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [935] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4488),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(935),
    [sym_preproc_endregion] = STATE(935),
    [sym_preproc_line] = STATE(935),
    [sym_preproc_pragma] = STATE(935),
    [sym_preproc_nullable] = STATE(935),
    [sym_preproc_error] = STATE(935),
    [sym_preproc_define] = STATE(935),
    [sym_preproc_undef] = STATE(935),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [936] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5504),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(936),
    [sym_preproc_endregion] = STATE(936),
    [sym_preproc_line] = STATE(936),
    [sym_preproc_pragma] = STATE(936),
    [sym_preproc_nullable] = STATE(936),
    [sym_preproc_error] = STATE(936),
    [sym_preproc_define] = STATE(936),
    [sym_preproc_undef] = STATE(936),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [937] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6568),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(937),
    [sym_preproc_endregion] = STATE(937),
    [sym_preproc_line] = STATE(937),
    [sym_preproc_pragma] = STATE(937),
    [sym_preproc_nullable] = STATE(937),
    [sym_preproc_error] = STATE(937),
    [sym_preproc_define] = STATE(937),
    [sym_preproc_undef] = STATE(937),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [938] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7002),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4879),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(938),
    [sym_preproc_endregion] = STATE(938),
    [sym_preproc_line] = STATE(938),
    [sym_preproc_pragma] = STATE(938),
    [sym_preproc_nullable] = STATE(938),
    [sym_preproc_error] = STATE(938),
    [sym_preproc_define] = STATE(938),
    [sym_preproc_undef] = STATE(938),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [939] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5610),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(939),
    [sym_preproc_endregion] = STATE(939),
    [sym_preproc_line] = STATE(939),
    [sym_preproc_pragma] = STATE(939),
    [sym_preproc_nullable] = STATE(939),
    [sym_preproc_error] = STATE(939),
    [sym_preproc_define] = STATE(939),
    [sym_preproc_undef] = STATE(939),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [940] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5114),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(940),
    [sym_preproc_endregion] = STATE(940),
    [sym_preproc_line] = STATE(940),
    [sym_preproc_pragma] = STATE(940),
    [sym_preproc_nullable] = STATE(940),
    [sym_preproc_error] = STATE(940),
    [sym_preproc_define] = STATE(940),
    [sym_preproc_undef] = STATE(940),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [941] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6955),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5158),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(941),
    [sym_preproc_endregion] = STATE(941),
    [sym_preproc_line] = STATE(941),
    [sym_preproc_pragma] = STATE(941),
    [sym_preproc_nullable] = STATE(941),
    [sym_preproc_error] = STATE(941),
    [sym_preproc_define] = STATE(941),
    [sym_preproc_undef] = STATE(941),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [942] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5688),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(942),
    [sym_preproc_endregion] = STATE(942),
    [sym_preproc_line] = STATE(942),
    [sym_preproc_pragma] = STATE(942),
    [sym_preproc_nullable] = STATE(942),
    [sym_preproc_error] = STATE(942),
    [sym_preproc_define] = STATE(942),
    [sym_preproc_undef] = STATE(942),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [943] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4829),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym__ordering] = STATE(7691),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(943),
    [sym_preproc_endregion] = STATE(943),
    [sym_preproc_line] = STATE(943),
    [sym_preproc_pragma] = STATE(943),
    [sym_preproc_nullable] = STATE(943),
    [sym_preproc_error] = STATE(943),
    [sym_preproc_define] = STATE(943),
    [sym_preproc_undef] = STATE(943),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [944] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6467),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(944),
    [sym_preproc_endregion] = STATE(944),
    [sym_preproc_line] = STATE(944),
    [sym_preproc_pragma] = STATE(944),
    [sym_preproc_nullable] = STATE(944),
    [sym_preproc_error] = STATE(944),
    [sym_preproc_define] = STATE(944),
    [sym_preproc_undef] = STATE(944),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [945] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6575),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(945),
    [sym_preproc_endregion] = STATE(945),
    [sym_preproc_line] = STATE(945),
    [sym_preproc_pragma] = STATE(945),
    [sym_preproc_nullable] = STATE(945),
    [sym_preproc_error] = STATE(945),
    [sym_preproc_define] = STATE(945),
    [sym_preproc_undef] = STATE(945),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [946] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6643),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(946),
    [sym_preproc_endregion] = STATE(946),
    [sym_preproc_line] = STATE(946),
    [sym_preproc_pragma] = STATE(946),
    [sym_preproc_nullable] = STATE(946),
    [sym_preproc_error] = STATE(946),
    [sym_preproc_define] = STATE(946),
    [sym_preproc_undef] = STATE(946),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [947] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5844),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(947),
    [sym_preproc_endregion] = STATE(947),
    [sym_preproc_line] = STATE(947),
    [sym_preproc_pragma] = STATE(947),
    [sym_preproc_nullable] = STATE(947),
    [sym_preproc_error] = STATE(947),
    [sym_preproc_define] = STATE(947),
    [sym_preproc_undef] = STATE(947),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [948] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5253),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(948),
    [sym_preproc_endregion] = STATE(948),
    [sym_preproc_line] = STATE(948),
    [sym_preproc_pragma] = STATE(948),
    [sym_preproc_nullable] = STATE(948),
    [sym_preproc_error] = STATE(948),
    [sym_preproc_define] = STATE(948),
    [sym_preproc_undef] = STATE(948),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [949] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5694),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(949),
    [sym_preproc_endregion] = STATE(949),
    [sym_preproc_line] = STATE(949),
    [sym_preproc_pragma] = STATE(949),
    [sym_preproc_nullable] = STATE(949),
    [sym_preproc_error] = STATE(949),
    [sym_preproc_define] = STATE(949),
    [sym_preproc_undef] = STATE(949),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [950] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6573),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(950),
    [sym_preproc_endregion] = STATE(950),
    [sym_preproc_line] = STATE(950),
    [sym_preproc_pragma] = STATE(950),
    [sym_preproc_nullable] = STATE(950),
    [sym_preproc_error] = STATE(950),
    [sym_preproc_define] = STATE(950),
    [sym_preproc_undef] = STATE(950),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [951] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5241),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(951),
    [sym_preproc_endregion] = STATE(951),
    [sym_preproc_line] = STATE(951),
    [sym_preproc_pragma] = STATE(951),
    [sym_preproc_nullable] = STATE(951),
    [sym_preproc_error] = STATE(951),
    [sym_preproc_define] = STATE(951),
    [sym_preproc_undef] = STATE(951),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [952] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6310),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(952),
    [sym_preproc_endregion] = STATE(952),
    [sym_preproc_line] = STATE(952),
    [sym_preproc_pragma] = STATE(952),
    [sym_preproc_nullable] = STATE(952),
    [sym_preproc_error] = STATE(952),
    [sym_preproc_define] = STATE(952),
    [sym_preproc_undef] = STATE(952),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [953] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5850),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(953),
    [sym_preproc_endregion] = STATE(953),
    [sym_preproc_line] = STATE(953),
    [sym_preproc_pragma] = STATE(953),
    [sym_preproc_nullable] = STATE(953),
    [sym_preproc_error] = STATE(953),
    [sym_preproc_define] = STATE(953),
    [sym_preproc_undef] = STATE(953),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2899),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [954] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5239),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(954),
    [sym_preproc_endregion] = STATE(954),
    [sym_preproc_line] = STATE(954),
    [sym_preproc_pragma] = STATE(954),
    [sym_preproc_nullable] = STATE(954),
    [sym_preproc_error] = STATE(954),
    [sym_preproc_define] = STATE(954),
    [sym_preproc_undef] = STATE(954),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [955] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5853),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(955),
    [sym_preproc_endregion] = STATE(955),
    [sym_preproc_line] = STATE(955),
    [sym_preproc_pragma] = STATE(955),
    [sym_preproc_nullable] = STATE(955),
    [sym_preproc_error] = STATE(955),
    [sym_preproc_define] = STATE(955),
    [sym_preproc_undef] = STATE(955),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [956] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6549),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(956),
    [sym_preproc_endregion] = STATE(956),
    [sym_preproc_line] = STATE(956),
    [sym_preproc_pragma] = STATE(956),
    [sym_preproc_nullable] = STATE(956),
    [sym_preproc_error] = STATE(956),
    [sym_preproc_define] = STATE(956),
    [sym_preproc_undef] = STATE(956),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [957] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5273),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(957),
    [sym_preproc_endregion] = STATE(957),
    [sym_preproc_line] = STATE(957),
    [sym_preproc_pragma] = STATE(957),
    [sym_preproc_nullable] = STATE(957),
    [sym_preproc_error] = STATE(957),
    [sym_preproc_define] = STATE(957),
    [sym_preproc_undef] = STATE(957),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [958] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6440),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(958),
    [sym_preproc_endregion] = STATE(958),
    [sym_preproc_line] = STATE(958),
    [sym_preproc_pragma] = STATE(958),
    [sym_preproc_nullable] = STATE(958),
    [sym_preproc_error] = STATE(958),
    [sym_preproc_define] = STATE(958),
    [sym_preproc_undef] = STATE(958),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [959] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5264),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(959),
    [sym_preproc_endregion] = STATE(959),
    [sym_preproc_line] = STATE(959),
    [sym_preproc_pragma] = STATE(959),
    [sym_preproc_nullable] = STATE(959),
    [sym_preproc_error] = STATE(959),
    [sym_preproc_define] = STATE(959),
    [sym_preproc_undef] = STATE(959),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [960] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5291),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(960),
    [sym_preproc_endregion] = STATE(960),
    [sym_preproc_line] = STATE(960),
    [sym_preproc_pragma] = STATE(960),
    [sym_preproc_nullable] = STATE(960),
    [sym_preproc_error] = STATE(960),
    [sym_preproc_define] = STATE(960),
    [sym_preproc_undef] = STATE(960),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [961] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3395),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(2839),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(3093),
    [sym_implicit_type] = STATE(3310),
    [sym_array_type] = STATE(3457),
    [sym__array_base_type] = STATE(8737),
    [sym_nullable_type] = STATE(3458),
    [sym_pointer_type] = STATE(3458),
    [sym__pointer_base_type] = STATE(9246),
    [sym_function_pointer_type] = STATE(3458),
    [sym_ref_type] = STATE(3310),
    [sym_scoped_type] = STATE(3310),
    [sym_tuple_type] = STATE(3459),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2788),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(961),
    [sym_preproc_endregion] = STATE(961),
    [sym_preproc_line] = STATE(961),
    [sym_preproc_pragma] = STATE(961),
    [sym_preproc_nullable] = STATE(961),
    [sym_preproc_error] = STATE(961),
    [sym_preproc_define] = STATE(961),
    [sym_preproc_undef] = STATE(961),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_ref] = ACTIONS(2531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(2535),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2907),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2541),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2909),
    [sym_predefined_type] = ACTIONS(2911),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [962] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5985),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(962),
    [sym_preproc_endregion] = STATE(962),
    [sym_preproc_line] = STATE(962),
    [sym_preproc_pragma] = STATE(962),
    [sym_preproc_nullable] = STATE(962),
    [sym_preproc_error] = STATE(962),
    [sym_preproc_define] = STATE(962),
    [sym_preproc_undef] = STATE(962),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [963] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3017),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2757),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2756),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(963),
    [sym_preproc_endregion] = STATE(963),
    [sym_preproc_line] = STATE(963),
    [sym_preproc_pragma] = STATE(963),
    [sym_preproc_nullable] = STATE(963),
    [sym_preproc_error] = STATE(963),
    [sym_preproc_define] = STATE(963),
    [sym_preproc_undef] = STATE(963),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_ref] = ACTIONS(2363),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2915),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2843),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [964] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(3017),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2757),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(2946),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2836),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(964),
    [sym_preproc_endregion] = STATE(964),
    [sym_preproc_line] = STATE(964),
    [sym_preproc_pragma] = STATE(964),
    [sym_preproc_nullable] = STATE(964),
    [sym_preproc_error] = STATE(964),
    [sym_preproc_define] = STATE(964),
    [sym_preproc_undef] = STATE(964),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_ref] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2915),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(2353),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2917),
    [sym_predefined_type] = ACTIONS(2357),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [965] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(965),
    [sym_preproc_endregion] = STATE(965),
    [sym_preproc_line] = STATE(965),
    [sym_preproc_pragma] = STATE(965),
    [sym_preproc_nullable] = STATE(965),
    [sym_preproc_error] = STATE(965),
    [sym_preproc_define] = STATE(965),
    [sym_preproc_undef] = STATE(965),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [966] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5887),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(966),
    [sym_preproc_endregion] = STATE(966),
    [sym_preproc_line] = STATE(966),
    [sym_preproc_pragma] = STATE(966),
    [sym_preproc_nullable] = STATE(966),
    [sym_preproc_error] = STATE(966),
    [sym_preproc_define] = STATE(966),
    [sym_preproc_undef] = STATE(966),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [967] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5721),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(967),
    [sym_preproc_endregion] = STATE(967),
    [sym_preproc_line] = STATE(967),
    [sym_preproc_pragma] = STATE(967),
    [sym_preproc_nullable] = STATE(967),
    [sym_preproc_error] = STATE(967),
    [sym_preproc_define] = STATE(967),
    [sym_preproc_undef] = STATE(967),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [968] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6446),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(968),
    [sym_preproc_endregion] = STATE(968),
    [sym_preproc_line] = STATE(968),
    [sym_preproc_pragma] = STATE(968),
    [sym_preproc_nullable] = STATE(968),
    [sym_preproc_error] = STATE(968),
    [sym_preproc_define] = STATE(968),
    [sym_preproc_undef] = STATE(968),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [969] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7011),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4674),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(969),
    [sym_preproc_endregion] = STATE(969),
    [sym_preproc_line] = STATE(969),
    [sym_preproc_pragma] = STATE(969),
    [sym_preproc_nullable] = STATE(969),
    [sym_preproc_error] = STATE(969),
    [sym_preproc_define] = STATE(969),
    [sym_preproc_undef] = STATE(969),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [970] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6560),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(970),
    [sym_preproc_endregion] = STATE(970),
    [sym_preproc_line] = STATE(970),
    [sym_preproc_pragma] = STATE(970),
    [sym_preproc_nullable] = STATE(970),
    [sym_preproc_error] = STATE(970),
    [sym_preproc_define] = STATE(970),
    [sym_preproc_undef] = STATE(970),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [971] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4829),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym__ordering] = STATE(7592),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(971),
    [sym_preproc_endregion] = STATE(971),
    [sym_preproc_line] = STATE(971),
    [sym_preproc_pragma] = STATE(971),
    [sym_preproc_nullable] = STATE(971),
    [sym_preproc_error] = STATE(971),
    [sym_preproc_define] = STATE(971),
    [sym_preproc_undef] = STATE(971),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [972] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6546),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(972),
    [sym_preproc_endregion] = STATE(972),
    [sym_preproc_line] = STATE(972),
    [sym_preproc_pragma] = STATE(972),
    [sym_preproc_nullable] = STATE(972),
    [sym_preproc_error] = STATE(972),
    [sym_preproc_define] = STATE(972),
    [sym_preproc_undef] = STATE(972),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [973] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(973),
    [sym_preproc_endregion] = STATE(973),
    [sym_preproc_line] = STATE(973),
    [sym_preproc_pragma] = STATE(973),
    [sym_preproc_nullable] = STATE(973),
    [sym_preproc_error] = STATE(973),
    [sym_preproc_define] = STATE(973),
    [sym_preproc_undef] = STATE(973),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [974] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5740),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(974),
    [sym_preproc_endregion] = STATE(974),
    [sym_preproc_line] = STATE(974),
    [sym_preproc_pragma] = STATE(974),
    [sym_preproc_nullable] = STATE(974),
    [sym_preproc_error] = STATE(974),
    [sym_preproc_define] = STATE(974),
    [sym_preproc_undef] = STATE(974),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [975] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7057),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4499),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(975),
    [sym_preproc_endregion] = STATE(975),
    [sym_preproc_line] = STATE(975),
    [sym_preproc_pragma] = STATE(975),
    [sym_preproc_nullable] = STATE(975),
    [sym_preproc_error] = STATE(975),
    [sym_preproc_define] = STATE(975),
    [sym_preproc_undef] = STATE(975),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [976] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6530),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(976),
    [sym_preproc_endregion] = STATE(976),
    [sym_preproc_line] = STATE(976),
    [sym_preproc_pragma] = STATE(976),
    [sym_preproc_nullable] = STATE(976),
    [sym_preproc_error] = STATE(976),
    [sym_preproc_define] = STATE(976),
    [sym_preproc_undef] = STATE(976),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [977] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6090),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(977),
    [sym_preproc_endregion] = STATE(977),
    [sym_preproc_line] = STATE(977),
    [sym_preproc_pragma] = STATE(977),
    [sym_preproc_nullable] = STATE(977),
    [sym_preproc_error] = STATE(977),
    [sym_preproc_define] = STATE(977),
    [sym_preproc_undef] = STATE(977),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [978] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5744),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(978),
    [sym_preproc_endregion] = STATE(978),
    [sym_preproc_line] = STATE(978),
    [sym_preproc_pragma] = STATE(978),
    [sym_preproc_nullable] = STATE(978),
    [sym_preproc_error] = STATE(978),
    [sym_preproc_define] = STATE(978),
    [sym_preproc_undef] = STATE(978),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [979] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6001),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(979),
    [sym_preproc_endregion] = STATE(979),
    [sym_preproc_line] = STATE(979),
    [sym_preproc_pragma] = STATE(979),
    [sym_preproc_nullable] = STATE(979),
    [sym_preproc_error] = STATE(979),
    [sym_preproc_define] = STATE(979),
    [sym_preproc_undef] = STATE(979),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [980] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6439),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(980),
    [sym_preproc_endregion] = STATE(980),
    [sym_preproc_line] = STATE(980),
    [sym_preproc_pragma] = STATE(980),
    [sym_preproc_nullable] = STATE(980),
    [sym_preproc_error] = STATE(980),
    [sym_preproc_define] = STATE(980),
    [sym_preproc_undef] = STATE(980),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [981] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6435),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(981),
    [sym_preproc_endregion] = STATE(981),
    [sym_preproc_line] = STATE(981),
    [sym_preproc_pragma] = STATE(981),
    [sym_preproc_nullable] = STATE(981),
    [sym_preproc_error] = STATE(981),
    [sym_preproc_define] = STATE(981),
    [sym_preproc_undef] = STATE(981),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [982] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5747),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(982),
    [sym_preproc_endregion] = STATE(982),
    [sym_preproc_line] = STATE(982),
    [sym_preproc_pragma] = STATE(982),
    [sym_preproc_nullable] = STATE(982),
    [sym_preproc_error] = STATE(982),
    [sym_preproc_define] = STATE(982),
    [sym_preproc_undef] = STATE(982),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [983] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6007),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(983),
    [sym_preproc_endregion] = STATE(983),
    [sym_preproc_line] = STATE(983),
    [sym_preproc_pragma] = STATE(983),
    [sym_preproc_nullable] = STATE(983),
    [sym_preproc_error] = STATE(983),
    [sym_preproc_define] = STATE(983),
    [sym_preproc_undef] = STATE(983),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [984] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(984),
    [sym_preproc_endregion] = STATE(984),
    [sym_preproc_line] = STATE(984),
    [sym_preproc_pragma] = STATE(984),
    [sym_preproc_nullable] = STATE(984),
    [sym_preproc_error] = STATE(984),
    [sym_preproc_define] = STATE(984),
    [sym_preproc_undef] = STATE(984),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [985] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4769),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(985),
    [sym_preproc_endregion] = STATE(985),
    [sym_preproc_line] = STATE(985),
    [sym_preproc_pragma] = STATE(985),
    [sym_preproc_nullable] = STATE(985),
    [sym_preproc_error] = STATE(985),
    [sym_preproc_define] = STATE(985),
    [sym_preproc_undef] = STATE(985),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [986] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6036),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(986),
    [sym_preproc_endregion] = STATE(986),
    [sym_preproc_line] = STATE(986),
    [sym_preproc_pragma] = STATE(986),
    [sym_preproc_nullable] = STATE(986),
    [sym_preproc_error] = STATE(986),
    [sym_preproc_define] = STATE(986),
    [sym_preproc_undef] = STATE(986),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [987] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7025),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6403),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(987),
    [sym_preproc_endregion] = STATE(987),
    [sym_preproc_line] = STATE(987),
    [sym_preproc_pragma] = STATE(987),
    [sym_preproc_nullable] = STATE(987),
    [sym_preproc_error] = STATE(987),
    [sym_preproc_define] = STATE(987),
    [sym_preproc_undef] = STATE(987),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [988] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4595),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4907),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(988),
    [sym_preproc_endregion] = STATE(988),
    [sym_preproc_line] = STATE(988),
    [sym_preproc_pragma] = STATE(988),
    [sym_preproc_nullable] = STATE(988),
    [sym_preproc_error] = STATE(988),
    [sym_preproc_define] = STATE(988),
    [sym_preproc_undef] = STATE(988),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [989] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4763),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(989),
    [sym_preproc_endregion] = STATE(989),
    [sym_preproc_line] = STATE(989),
    [sym_preproc_pragma] = STATE(989),
    [sym_preproc_nullable] = STATE(989),
    [sym_preproc_error] = STATE(989),
    [sym_preproc_define] = STATE(989),
    [sym_preproc_undef] = STATE(989),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [990] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5877),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(990),
    [sym_preproc_endregion] = STATE(990),
    [sym_preproc_line] = STATE(990),
    [sym_preproc_pragma] = STATE(990),
    [sym_preproc_nullable] = STATE(990),
    [sym_preproc_error] = STATE(990),
    [sym_preproc_define] = STATE(990),
    [sym_preproc_undef] = STATE(990),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [991] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5722),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5570),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(991),
    [sym_preproc_endregion] = STATE(991),
    [sym_preproc_line] = STATE(991),
    [sym_preproc_pragma] = STATE(991),
    [sym_preproc_nullable] = STATE(991),
    [sym_preproc_error] = STATE(991),
    [sym_preproc_define] = STATE(991),
    [sym_preproc_undef] = STATE(991),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [992] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6286),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2789),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(992),
    [sym_preproc_endregion] = STATE(992),
    [sym_preproc_line] = STATE(992),
    [sym_preproc_pragma] = STATE(992),
    [sym_preproc_nullable] = STATE(992),
    [sym_preproc_error] = STATE(992),
    [sym_preproc_define] = STATE(992),
    [sym_preproc_undef] = STATE(992),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2927),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [993] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7074),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6332),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(993),
    [sym_preproc_endregion] = STATE(993),
    [sym_preproc_line] = STATE(993),
    [sym_preproc_pragma] = STATE(993),
    [sym_preproc_nullable] = STATE(993),
    [sym_preproc_error] = STATE(993),
    [sym_preproc_define] = STATE(993),
    [sym_preproc_undef] = STATE(993),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [994] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6134),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(994),
    [sym_preproc_endregion] = STATE(994),
    [sym_preproc_line] = STATE(994),
    [sym_preproc_pragma] = STATE(994),
    [sym_preproc_nullable] = STATE(994),
    [sym_preproc_error] = STATE(994),
    [sym_preproc_define] = STATE(994),
    [sym_preproc_undef] = STATE(994),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [995] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6665),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(995),
    [sym_preproc_endregion] = STATE(995),
    [sym_preproc_line] = STATE(995),
    [sym_preproc_pragma] = STATE(995),
    [sym_preproc_nullable] = STATE(995),
    [sym_preproc_error] = STATE(995),
    [sym_preproc_define] = STATE(995),
    [sym_preproc_undef] = STATE(995),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [996] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5756),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5576),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(996),
    [sym_preproc_endregion] = STATE(996),
    [sym_preproc_line] = STATE(996),
    [sym_preproc_pragma] = STATE(996),
    [sym_preproc_nullable] = STATE(996),
    [sym_preproc_error] = STATE(996),
    [sym_preproc_define] = STATE(996),
    [sym_preproc_undef] = STATE(996),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [997] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4760),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(997),
    [sym_preproc_endregion] = STATE(997),
    [sym_preproc_line] = STATE(997),
    [sym_preproc_pragma] = STATE(997),
    [sym_preproc_nullable] = STATE(997),
    [sym_preproc_error] = STATE(997),
    [sym_preproc_define] = STATE(997),
    [sym_preproc_undef] = STATE(997),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [998] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6135),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(998),
    [sym_preproc_endregion] = STATE(998),
    [sym_preproc_line] = STATE(998),
    [sym_preproc_pragma] = STATE(998),
    [sym_preproc_nullable] = STATE(998),
    [sym_preproc_error] = STATE(998),
    [sym_preproc_define] = STATE(998),
    [sym_preproc_undef] = STATE(998),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [999] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5945),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(999),
    [sym_preproc_endregion] = STATE(999),
    [sym_preproc_line] = STATE(999),
    [sym_preproc_pragma] = STATE(999),
    [sym_preproc_nullable] = STATE(999),
    [sym_preproc_error] = STATE(999),
    [sym_preproc_define] = STATE(999),
    [sym_preproc_undef] = STATE(999),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1000] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5774),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5579),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1000),
    [sym_preproc_endregion] = STATE(1000),
    [sym_preproc_line] = STATE(1000),
    [sym_preproc_pragma] = STATE(1000),
    [sym_preproc_nullable] = STATE(1000),
    [sym_preproc_error] = STATE(1000),
    [sym_preproc_define] = STATE(1000),
    [sym_preproc_undef] = STATE(1000),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1001] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7077),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5469),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1001),
    [sym_preproc_endregion] = STATE(1001),
    [sym_preproc_line] = STATE(1001),
    [sym_preproc_pragma] = STATE(1001),
    [sym_preproc_nullable] = STATE(1001),
    [sym_preproc_error] = STATE(1001),
    [sym_preproc_define] = STATE(1001),
    [sym_preproc_undef] = STATE(1001),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1002] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6415),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1002),
    [sym_preproc_endregion] = STATE(1002),
    [sym_preproc_line] = STATE(1002),
    [sym_preproc_pragma] = STATE(1002),
    [sym_preproc_nullable] = STATE(1002),
    [sym_preproc_error] = STATE(1002),
    [sym_preproc_define] = STATE(1002),
    [sym_preproc_undef] = STATE(1002),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1003] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4759),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1003),
    [sym_preproc_endregion] = STATE(1003),
    [sym_preproc_line] = STATE(1003),
    [sym_preproc_pragma] = STATE(1003),
    [sym_preproc_nullable] = STATE(1003),
    [sym_preproc_error] = STATE(1003),
    [sym_preproc_define] = STATE(1003),
    [sym_preproc_undef] = STATE(1003),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1004] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6613),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1004),
    [sym_preproc_endregion] = STATE(1004),
    [sym_preproc_line] = STATE(1004),
    [sym_preproc_pragma] = STATE(1004),
    [sym_preproc_nullable] = STATE(1004),
    [sym_preproc_error] = STATE(1004),
    [sym_preproc_define] = STATE(1004),
    [sym_preproc_undef] = STATE(1004),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_if_token3] = ACTIONS(2935),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1005] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6136),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1005),
    [sym_preproc_endregion] = STATE(1005),
    [sym_preproc_line] = STATE(1005),
    [sym_preproc_pragma] = STATE(1005),
    [sym_preproc_nullable] = STATE(1005),
    [sym_preproc_error] = STATE(1005),
    [sym_preproc_define] = STATE(1005),
    [sym_preproc_undef] = STATE(1005),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1006] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4756),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1006),
    [sym_preproc_endregion] = STATE(1006),
    [sym_preproc_line] = STATE(1006),
    [sym_preproc_pragma] = STATE(1006),
    [sym_preproc_nullable] = STATE(1006),
    [sym_preproc_error] = STATE(1006),
    [sym_preproc_define] = STATE(1006),
    [sym_preproc_undef] = STATE(1006),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1007] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5752),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5586),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1007),
    [sym_preproc_endregion] = STATE(1007),
    [sym_preproc_line] = STATE(1007),
    [sym_preproc_pragma] = STATE(1007),
    [sym_preproc_nullable] = STATE(1007),
    [sym_preproc_error] = STATE(1007),
    [sym_preproc_define] = STATE(1007),
    [sym_preproc_undef] = STATE(1007),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1008] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5940),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1008),
    [sym_preproc_endregion] = STATE(1008),
    [sym_preproc_line] = STATE(1008),
    [sym_preproc_pragma] = STATE(1008),
    [sym_preproc_nullable] = STATE(1008),
    [sym_preproc_error] = STATE(1008),
    [sym_preproc_define] = STATE(1008),
    [sym_preproc_undef] = STATE(1008),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2937),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1009] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(2854),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1009),
    [sym_preproc_endregion] = STATE(1009),
    [sym_preproc_line] = STATE(1009),
    [sym_preproc_pragma] = STATE(1009),
    [sym_preproc_nullable] = STATE(1009),
    [sym_preproc_error] = STATE(1009),
    [sym_preproc_define] = STATE(1009),
    [sym_preproc_undef] = STATE(1009),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1010] = {
    [sym_attribute_argument] = STATE(8731),
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6230),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2852),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1010),
    [sym_preproc_endregion] = STATE(1010),
    [sym_preproc_line] = STATE(1010),
    [sym_preproc_pragma] = STATE(1010),
    [sym_preproc_nullable] = STATE(1010),
    [sym_preproc_error] = STATE(1010),
    [sym_preproc_define] = STATE(1010),
    [sym_preproc_undef] = STATE(1010),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1011] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5750),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5592),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1011),
    [sym_preproc_endregion] = STATE(1011),
    [sym_preproc_line] = STATE(1011),
    [sym_preproc_pragma] = STATE(1011),
    [sym_preproc_nullable] = STATE(1011),
    [sym_preproc_error] = STATE(1011),
    [sym_preproc_define] = STATE(1011),
    [sym_preproc_undef] = STATE(1011),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1012] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6370),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1012),
    [sym_preproc_endregion] = STATE(1012),
    [sym_preproc_line] = STATE(1012),
    [sym_preproc_pragma] = STATE(1012),
    [sym_preproc_nullable] = STATE(1012),
    [sym_preproc_error] = STATE(1012),
    [sym_preproc_define] = STATE(1012),
    [sym_preproc_undef] = STATE(1012),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1013] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6490),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1013),
    [sym_preproc_endregion] = STATE(1013),
    [sym_preproc_line] = STATE(1013),
    [sym_preproc_pragma] = STATE(1013),
    [sym_preproc_nullable] = STATE(1013),
    [sym_preproc_error] = STATE(1013),
    [sym_preproc_define] = STATE(1013),
    [sym_preproc_undef] = STATE(1013),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1014] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5939),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1014),
    [sym_preproc_endregion] = STATE(1014),
    [sym_preproc_line] = STATE(1014),
    [sym_preproc_pragma] = STATE(1014),
    [sym_preproc_nullable] = STATE(1014),
    [sym_preproc_error] = STATE(1014),
    [sym_preproc_define] = STATE(1014),
    [sym_preproc_undef] = STATE(1014),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1015] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4864),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1015),
    [sym_preproc_endregion] = STATE(1015),
    [sym_preproc_line] = STATE(1015),
    [sym_preproc_pragma] = STATE(1015),
    [sym_preproc_nullable] = STATE(1015),
    [sym_preproc_error] = STATE(1015),
    [sym_preproc_define] = STATE(1015),
    [sym_preproc_undef] = STATE(1015),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1016] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5936),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1016),
    [sym_preproc_endregion] = STATE(1016),
    [sym_preproc_line] = STATE(1016),
    [sym_preproc_pragma] = STATE(1016),
    [sym_preproc_nullable] = STATE(1016),
    [sym_preproc_error] = STATE(1016),
    [sym_preproc_define] = STATE(1016),
    [sym_preproc_undef] = STATE(1016),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1017] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7112),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6103),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1017),
    [sym_preproc_endregion] = STATE(1017),
    [sym_preproc_line] = STATE(1017),
    [sym_preproc_pragma] = STATE(1017),
    [sym_preproc_nullable] = STATE(1017),
    [sym_preproc_error] = STATE(1017),
    [sym_preproc_define] = STATE(1017),
    [sym_preproc_undef] = STATE(1017),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1018] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7125),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5768),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1018),
    [sym_preproc_endregion] = STATE(1018),
    [sym_preproc_line] = STATE(1018),
    [sym_preproc_pragma] = STATE(1018),
    [sym_preproc_nullable] = STATE(1018),
    [sym_preproc_error] = STATE(1018),
    [sym_preproc_define] = STATE(1018),
    [sym_preproc_undef] = STATE(1018),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1019] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4836),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1019),
    [sym_preproc_endregion] = STATE(1019),
    [sym_preproc_line] = STATE(1019),
    [sym_preproc_pragma] = STATE(1019),
    [sym_preproc_nullable] = STATE(1019),
    [sym_preproc_error] = STATE(1019),
    [sym_preproc_define] = STATE(1019),
    [sym_preproc_undef] = STATE(1019),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1020] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4811),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1020),
    [sym_preproc_endregion] = STATE(1020),
    [sym_preproc_line] = STATE(1020),
    [sym_preproc_pragma] = STATE(1020),
    [sym_preproc_nullable] = STATE(1020),
    [sym_preproc_error] = STATE(1020),
    [sym_preproc_define] = STATE(1020),
    [sym_preproc_undef] = STATE(1020),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1021] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7031),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5466),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1021),
    [sym_preproc_endregion] = STATE(1021),
    [sym_preproc_line] = STATE(1021),
    [sym_preproc_pragma] = STATE(1021),
    [sym_preproc_nullable] = STATE(1021),
    [sym_preproc_error] = STATE(1021),
    [sym_preproc_define] = STATE(1021),
    [sym_preproc_undef] = STATE(1021),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1022] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5769),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1022),
    [sym_preproc_endregion] = STATE(1022),
    [sym_preproc_line] = STATE(1022),
    [sym_preproc_pragma] = STATE(1022),
    [sym_preproc_nullable] = STATE(1022),
    [sym_preproc_error] = STATE(1022),
    [sym_preproc_define] = STATE(1022),
    [sym_preproc_undef] = STATE(1022),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1023] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5770),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1023),
    [sym_preproc_endregion] = STATE(1023),
    [sym_preproc_line] = STATE(1023),
    [sym_preproc_pragma] = STATE(1023),
    [sym_preproc_nullable] = STATE(1023),
    [sym_preproc_error] = STATE(1023),
    [sym_preproc_define] = STATE(1023),
    [sym_preproc_undef] = STATE(1023),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1024] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6698),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6721),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5655),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1024),
    [sym_preproc_endregion] = STATE(1024),
    [sym_preproc_line] = STATE(1024),
    [sym_preproc_pragma] = STATE(1024),
    [sym_preproc_nullable] = STATE(1024),
    [sym_preproc_error] = STATE(1024),
    [sym_preproc_define] = STATE(1024),
    [sym_preproc_undef] = STATE(1024),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(2803),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2725),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1025] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6434),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1025),
    [sym_preproc_endregion] = STATE(1025),
    [sym_preproc_line] = STATE(1025),
    [sym_preproc_pragma] = STATE(1025),
    [sym_preproc_nullable] = STATE(1025),
    [sym_preproc_error] = STATE(1025),
    [sym_preproc_define] = STATE(1025),
    [sym_preproc_undef] = STATE(1025),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1026] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5788),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1026),
    [sym_preproc_endregion] = STATE(1026),
    [sym_preproc_line] = STATE(1026),
    [sym_preproc_pragma] = STATE(1026),
    [sym_preproc_nullable] = STATE(1026),
    [sym_preproc_error] = STATE(1026),
    [sym_preproc_define] = STATE(1026),
    [sym_preproc_undef] = STATE(1026),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1027] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6089),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1027),
    [sym_preproc_endregion] = STATE(1027),
    [sym_preproc_line] = STATE(1027),
    [sym_preproc_pragma] = STATE(1027),
    [sym_preproc_nullable] = STATE(1027),
    [sym_preproc_error] = STATE(1027),
    [sym_preproc_define] = STATE(1027),
    [sym_preproc_undef] = STATE(1027),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1028] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5928),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1028),
    [sym_preproc_endregion] = STATE(1028),
    [sym_preproc_line] = STATE(1028),
    [sym_preproc_pragma] = STATE(1028),
    [sym_preproc_nullable] = STATE(1028),
    [sym_preproc_error] = STATE(1028),
    [sym_preproc_define] = STATE(1028),
    [sym_preproc_undef] = STATE(1028),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1029] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7090),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5822),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1029),
    [sym_preproc_endregion] = STATE(1029),
    [sym_preproc_line] = STATE(1029),
    [sym_preproc_pragma] = STATE(1029),
    [sym_preproc_nullable] = STATE(1029),
    [sym_preproc_error] = STATE(1029),
    [sym_preproc_define] = STATE(1029),
    [sym_preproc_undef] = STATE(1029),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1030] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5789),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1030),
    [sym_preproc_endregion] = STATE(1030),
    [sym_preproc_line] = STATE(1030),
    [sym_preproc_pragma] = STATE(1030),
    [sym_preproc_nullable] = STATE(1030),
    [sym_preproc_error] = STATE(1030),
    [sym_preproc_define] = STATE(1030),
    [sym_preproc_undef] = STATE(1030),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1031] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1031),
    [sym_preproc_endregion] = STATE(1031),
    [sym_preproc_line] = STATE(1031),
    [sym_preproc_pragma] = STATE(1031),
    [sym_preproc_nullable] = STATE(1031),
    [sym_preproc_error] = STATE(1031),
    [sym_preproc_define] = STATE(1031),
    [sym_preproc_undef] = STATE(1031),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1032] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6346),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1032),
    [sym_preproc_endregion] = STATE(1032),
    [sym_preproc_line] = STATE(1032),
    [sym_preproc_pragma] = STATE(1032),
    [sym_preproc_nullable] = STATE(1032),
    [sym_preproc_error] = STATE(1032),
    [sym_preproc_define] = STATE(1032),
    [sym_preproc_undef] = STATE(1032),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1033] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4027),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5470),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1033),
    [sym_preproc_endregion] = STATE(1033),
    [sym_preproc_line] = STATE(1033),
    [sym_preproc_pragma] = STATE(1033),
    [sym_preproc_nullable] = STATE(1033),
    [sym_preproc_error] = STATE(1033),
    [sym_preproc_define] = STATE(1033),
    [sym_preproc_undef] = STATE(1033),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1034] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6964),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5404),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1034),
    [sym_preproc_endregion] = STATE(1034),
    [sym_preproc_line] = STATE(1034),
    [sym_preproc_pragma] = STATE(1034),
    [sym_preproc_nullable] = STATE(1034),
    [sym_preproc_error] = STATE(1034),
    [sym_preproc_define] = STATE(1034),
    [sym_preproc_undef] = STATE(1034),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1035] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6262),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym__anonymous_object_member_declarator] = STATE(8890),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2873),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1035),
    [sym_preproc_endregion] = STATE(1035),
    [sym_preproc_line] = STATE(1035),
    [sym_preproc_pragma] = STATE(1035),
    [sym_preproc_nullable] = STATE(1035),
    [sym_preproc_error] = STATE(1035),
    [sym_preproc_define] = STATE(1035),
    [sym_preproc_undef] = STATE(1035),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1036] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6142),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1036),
    [sym_preproc_endregion] = STATE(1036),
    [sym_preproc_line] = STATE(1036),
    [sym_preproc_pragma] = STATE(1036),
    [sym_preproc_nullable] = STATE(1036),
    [sym_preproc_error] = STATE(1036),
    [sym_preproc_define] = STATE(1036),
    [sym_preproc_undef] = STATE(1036),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1037] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5771),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1037),
    [sym_preproc_endregion] = STATE(1037),
    [sym_preproc_line] = STATE(1037),
    [sym_preproc_pragma] = STATE(1037),
    [sym_preproc_nullable] = STATE(1037),
    [sym_preproc_error] = STATE(1037),
    [sym_preproc_define] = STATE(1037),
    [sym_preproc_undef] = STATE(1037),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1038] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6144),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1038),
    [sym_preproc_endregion] = STATE(1038),
    [sym_preproc_line] = STATE(1038),
    [sym_preproc_pragma] = STATE(1038),
    [sym_preproc_nullable] = STATE(1038),
    [sym_preproc_error] = STATE(1038),
    [sym_preproc_define] = STATE(1038),
    [sym_preproc_undef] = STATE(1038),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1039] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6331),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1039),
    [sym_preproc_endregion] = STATE(1039),
    [sym_preproc_line] = STATE(1039),
    [sym_preproc_pragma] = STATE(1039),
    [sym_preproc_nullable] = STATE(1039),
    [sym_preproc_error] = STATE(1039),
    [sym_preproc_define] = STATE(1039),
    [sym_preproc_undef] = STATE(1039),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1040] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1040),
    [sym_preproc_endregion] = STATE(1040),
    [sym_preproc_line] = STATE(1040),
    [sym_preproc_pragma] = STATE(1040),
    [sym_preproc_nullable] = STATE(1040),
    [sym_preproc_error] = STATE(1040),
    [sym_preproc_define] = STATE(1040),
    [sym_preproc_undef] = STATE(1040),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1041] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5989),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1041),
    [sym_preproc_endregion] = STATE(1041),
    [sym_preproc_line] = STATE(1041),
    [sym_preproc_pragma] = STATE(1041),
    [sym_preproc_nullable] = STATE(1041),
    [sym_preproc_error] = STATE(1041),
    [sym_preproc_define] = STATE(1041),
    [sym_preproc_undef] = STATE(1041),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1042] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4035),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5471),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1042),
    [sym_preproc_endregion] = STATE(1042),
    [sym_preproc_line] = STATE(1042),
    [sym_preproc_pragma] = STATE(1042),
    [sym_preproc_nullable] = STATE(1042),
    [sym_preproc_error] = STATE(1042),
    [sym_preproc_define] = STATE(1042),
    [sym_preproc_undef] = STATE(1042),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1043] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1043),
    [sym_preproc_endregion] = STATE(1043),
    [sym_preproc_line] = STATE(1043),
    [sym_preproc_pragma] = STATE(1043),
    [sym_preproc_nullable] = STATE(1043),
    [sym_preproc_error] = STATE(1043),
    [sym_preproc_define] = STATE(1043),
    [sym_preproc_undef] = STATE(1043),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1044] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4043),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5472),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1044),
    [sym_preproc_endregion] = STATE(1044),
    [sym_preproc_line] = STATE(1044),
    [sym_preproc_pragma] = STATE(1044),
    [sym_preproc_nullable] = STATE(1044),
    [sym_preproc_error] = STATE(1044),
    [sym_preproc_define] = STATE(1044),
    [sym_preproc_undef] = STATE(1044),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1045] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5475),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1045),
    [sym_preproc_endregion] = STATE(1045),
    [sym_preproc_line] = STATE(1045),
    [sym_preproc_pragma] = STATE(1045),
    [sym_preproc_nullable] = STATE(1045),
    [sym_preproc_error] = STATE(1045),
    [sym_preproc_define] = STATE(1045),
    [sym_preproc_undef] = STATE(1045),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1046] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6954),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6602),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1046),
    [sym_preproc_endregion] = STATE(1046),
    [sym_preproc_line] = STATE(1046),
    [sym_preproc_pragma] = STATE(1046),
    [sym_preproc_nullable] = STATE(1046),
    [sym_preproc_error] = STATE(1046),
    [sym_preproc_define] = STATE(1046),
    [sym_preproc_undef] = STATE(1046),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1047] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6352),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1047),
    [sym_preproc_endregion] = STATE(1047),
    [sym_preproc_line] = STATE(1047),
    [sym_preproc_pragma] = STATE(1047),
    [sym_preproc_nullable] = STATE(1047),
    [sym_preproc_error] = STATE(1047),
    [sym_preproc_define] = STATE(1047),
    [sym_preproc_undef] = STATE(1047),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1048] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6555),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1048),
    [sym_preproc_endregion] = STATE(1048),
    [sym_preproc_line] = STATE(1048),
    [sym_preproc_pragma] = STATE(1048),
    [sym_preproc_nullable] = STATE(1048),
    [sym_preproc_error] = STATE(1048),
    [sym_preproc_define] = STATE(1048),
    [sym_preproc_undef] = STATE(1048),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1049] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6145),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1049),
    [sym_preproc_endregion] = STATE(1049),
    [sym_preproc_line] = STATE(1049),
    [sym_preproc_pragma] = STATE(1049),
    [sym_preproc_nullable] = STATE(1049),
    [sym_preproc_error] = STATE(1049),
    [sym_preproc_define] = STATE(1049),
    [sym_preproc_undef] = STATE(1049),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1050] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4067),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5778),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1050),
    [sym_preproc_endregion] = STATE(1050),
    [sym_preproc_line] = STATE(1050),
    [sym_preproc_pragma] = STATE(1050),
    [sym_preproc_nullable] = STATE(1050),
    [sym_preproc_error] = STATE(1050),
    [sym_preproc_define] = STATE(1050),
    [sym_preproc_undef] = STATE(1050),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1051] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5477),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1051),
    [sym_preproc_endregion] = STATE(1051),
    [sym_preproc_line] = STATE(1051),
    [sym_preproc_pragma] = STATE(1051),
    [sym_preproc_nullable] = STATE(1051),
    [sym_preproc_error] = STATE(1051),
    [sym_preproc_define] = STATE(1051),
    [sym_preproc_undef] = STATE(1051),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1052] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6319),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1052),
    [sym_preproc_endregion] = STATE(1052),
    [sym_preproc_line] = STATE(1052),
    [sym_preproc_pragma] = STATE(1052),
    [sym_preproc_nullable] = STATE(1052),
    [sym_preproc_error] = STATE(1052),
    [sym_preproc_define] = STATE(1052),
    [sym_preproc_undef] = STATE(1052),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1053] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6318),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1053),
    [sym_preproc_endregion] = STATE(1053),
    [sym_preproc_line] = STATE(1053),
    [sym_preproc_pragma] = STATE(1053),
    [sym_preproc_nullable] = STATE(1053),
    [sym_preproc_error] = STATE(1053),
    [sym_preproc_define] = STATE(1053),
    [sym_preproc_undef] = STATE(1053),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1054] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4634),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4757),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1054),
    [sym_preproc_endregion] = STATE(1054),
    [sym_preproc_line] = STATE(1054),
    [sym_preproc_pragma] = STATE(1054),
    [sym_preproc_nullable] = STATE(1054),
    [sym_preproc_error] = STATE(1054),
    [sym_preproc_define] = STATE(1054),
    [sym_preproc_undef] = STATE(1054),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1055] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5478),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1055),
    [sym_preproc_endregion] = STATE(1055),
    [sym_preproc_line] = STATE(1055),
    [sym_preproc_pragma] = STATE(1055),
    [sym_preproc_nullable] = STATE(1055),
    [sym_preproc_error] = STATE(1055),
    [sym_preproc_define] = STATE(1055),
    [sym_preproc_undef] = STATE(1055),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1056] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5525),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1056),
    [sym_preproc_endregion] = STATE(1056),
    [sym_preproc_line] = STATE(1056),
    [sym_preproc_pragma] = STATE(1056),
    [sym_preproc_nullable] = STATE(1056),
    [sym_preproc_error] = STATE(1056),
    [sym_preproc_define] = STATE(1056),
    [sym_preproc_undef] = STATE(1056),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1057] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5451),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1057),
    [sym_preproc_endregion] = STATE(1057),
    [sym_preproc_line] = STATE(1057),
    [sym_preproc_pragma] = STATE(1057),
    [sym_preproc_nullable] = STATE(1057),
    [sym_preproc_error] = STATE(1057),
    [sym_preproc_define] = STATE(1057),
    [sym_preproc_undef] = STATE(1057),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1058] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4974),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1058),
    [sym_preproc_endregion] = STATE(1058),
    [sym_preproc_line] = STATE(1058),
    [sym_preproc_pragma] = STATE(1058),
    [sym_preproc_nullable] = STATE(1058),
    [sym_preproc_error] = STATE(1058),
    [sym_preproc_define] = STATE(1058),
    [sym_preproc_undef] = STATE(1058),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1059] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5990),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1059),
    [sym_preproc_endregion] = STATE(1059),
    [sym_preproc_line] = STATE(1059),
    [sym_preproc_pragma] = STATE(1059),
    [sym_preproc_nullable] = STATE(1059),
    [sym_preproc_error] = STATE(1059),
    [sym_preproc_define] = STATE(1059),
    [sym_preproc_undef] = STATE(1059),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1060] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4971),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1060),
    [sym_preproc_endregion] = STATE(1060),
    [sym_preproc_line] = STATE(1060),
    [sym_preproc_pragma] = STATE(1060),
    [sym_preproc_nullable] = STATE(1060),
    [sym_preproc_error] = STATE(1060),
    [sym_preproc_define] = STATE(1060),
    [sym_preproc_undef] = STATE(1060),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1061] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5817),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1061),
    [sym_preproc_endregion] = STATE(1061),
    [sym_preproc_line] = STATE(1061),
    [sym_preproc_pragma] = STATE(1061),
    [sym_preproc_nullable] = STATE(1061),
    [sym_preproc_error] = STATE(1061),
    [sym_preproc_define] = STATE(1061),
    [sym_preproc_undef] = STATE(1061),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1062] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5815),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1062),
    [sym_preproc_endregion] = STATE(1062),
    [sym_preproc_line] = STATE(1062),
    [sym_preproc_pragma] = STATE(1062),
    [sym_preproc_nullable] = STATE(1062),
    [sym_preproc_error] = STATE(1062),
    [sym_preproc_define] = STATE(1062),
    [sym_preproc_undef] = STATE(1062),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1063] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7116),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5200),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1063),
    [sym_preproc_endregion] = STATE(1063),
    [sym_preproc_line] = STATE(1063),
    [sym_preproc_pragma] = STATE(1063),
    [sym_preproc_nullable] = STATE(1063),
    [sym_preproc_error] = STATE(1063),
    [sym_preproc_define] = STATE(1063),
    [sym_preproc_undef] = STATE(1063),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1064] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6313),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1064),
    [sym_preproc_endregion] = STATE(1064),
    [sym_preproc_line] = STATE(1064),
    [sym_preproc_pragma] = STATE(1064),
    [sym_preproc_nullable] = STATE(1064),
    [sym_preproc_error] = STATE(1064),
    [sym_preproc_define] = STATE(1064),
    [sym_preproc_undef] = STATE(1064),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1065] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5813),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1065),
    [sym_preproc_endregion] = STATE(1065),
    [sym_preproc_line] = STATE(1065),
    [sym_preproc_pragma] = STATE(1065),
    [sym_preproc_nullable] = STATE(1065),
    [sym_preproc_error] = STATE(1065),
    [sym_preproc_define] = STATE(1065),
    [sym_preproc_undef] = STATE(1065),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1066] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4970),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1066),
    [sym_preproc_endregion] = STATE(1066),
    [sym_preproc_line] = STATE(1066),
    [sym_preproc_pragma] = STATE(1066),
    [sym_preproc_nullable] = STATE(1066),
    [sym_preproc_error] = STATE(1066),
    [sym_preproc_define] = STATE(1066),
    [sym_preproc_undef] = STATE(1066),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1067] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4967),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1067),
    [sym_preproc_endregion] = STATE(1067),
    [sym_preproc_line] = STATE(1067),
    [sym_preproc_pragma] = STATE(1067),
    [sym_preproc_nullable] = STATE(1067),
    [sym_preproc_error] = STATE(1067),
    [sym_preproc_define] = STATE(1067),
    [sym_preproc_undef] = STATE(1067),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1068] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6737),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2804),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6688),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5445),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1068),
    [sym_preproc_endregion] = STATE(1068),
    [sym_preproc_line] = STATE(1068),
    [sym_preproc_pragma] = STATE(1068),
    [sym_preproc_nullable] = STATE(1068),
    [sym_preproc_error] = STATE(1068),
    [sym_preproc_define] = STATE(1068),
    [sym_preproc_undef] = STATE(1068),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_readonly] = ACTIONS(2805),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(1087),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(2605),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1069] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4966),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1069),
    [sym_preproc_endregion] = STATE(1069),
    [sym_preproc_line] = STATE(1069),
    [sym_preproc_pragma] = STATE(1069),
    [sym_preproc_nullable] = STATE(1069),
    [sym_preproc_error] = STATE(1069),
    [sym_preproc_define] = STATE(1069),
    [sym_preproc_undef] = STATE(1069),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1070] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5809),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1070),
    [sym_preproc_endregion] = STATE(1070),
    [sym_preproc_line] = STATE(1070),
    [sym_preproc_pragma] = STATE(1070),
    [sym_preproc_nullable] = STATE(1070),
    [sym_preproc_error] = STATE(1070),
    [sym_preproc_define] = STATE(1070),
    [sym_preproc_undef] = STATE(1070),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1071] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4965),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1071),
    [sym_preproc_endregion] = STATE(1071),
    [sym_preproc_line] = STATE(1071),
    [sym_preproc_pragma] = STATE(1071),
    [sym_preproc_nullable] = STATE(1071),
    [sym_preproc_error] = STATE(1071),
    [sym_preproc_define] = STATE(1071),
    [sym_preproc_undef] = STATE(1071),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1072] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6614),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1072),
    [sym_preproc_endregion] = STATE(1072),
    [sym_preproc_line] = STATE(1072),
    [sym_preproc_pragma] = STATE(1072),
    [sym_preproc_nullable] = STATE(1072),
    [sym_preproc_error] = STATE(1072),
    [sym_preproc_define] = STATE(1072),
    [sym_preproc_undef] = STATE(1072),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1073] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5119),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1073),
    [sym_preproc_endregion] = STATE(1073),
    [sym_preproc_line] = STATE(1073),
    [sym_preproc_pragma] = STATE(1073),
    [sym_preproc_nullable] = STATE(1073),
    [sym_preproc_error] = STATE(1073),
    [sym_preproc_define] = STATE(1073),
    [sym_preproc_undef] = STATE(1073),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1074] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4469),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1074),
    [sym_preproc_endregion] = STATE(1074),
    [sym_preproc_line] = STATE(1074),
    [sym_preproc_pragma] = STATE(1074),
    [sym_preproc_nullable] = STATE(1074),
    [sym_preproc_error] = STATE(1074),
    [sym_preproc_define] = STATE(1074),
    [sym_preproc_undef] = STATE(1074),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1075] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4465),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1075),
    [sym_preproc_endregion] = STATE(1075),
    [sym_preproc_line] = STATE(1075),
    [sym_preproc_pragma] = STATE(1075),
    [sym_preproc_nullable] = STATE(1075),
    [sym_preproc_error] = STATE(1075),
    [sym_preproc_define] = STATE(1075),
    [sym_preproc_undef] = STATE(1075),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1076] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5807),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1076),
    [sym_preproc_endregion] = STATE(1076),
    [sym_preproc_line] = STATE(1076),
    [sym_preproc_pragma] = STATE(1076),
    [sym_preproc_nullable] = STATE(1076),
    [sym_preproc_error] = STATE(1076),
    [sym_preproc_define] = STATE(1076),
    [sym_preproc_undef] = STATE(1076),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1077] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4077),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5773),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1077),
    [sym_preproc_endregion] = STATE(1077),
    [sym_preproc_line] = STATE(1077),
    [sym_preproc_pragma] = STATE(1077),
    [sym_preproc_nullable] = STATE(1077),
    [sym_preproc_error] = STATE(1077),
    [sym_preproc_define] = STATE(1077),
    [sym_preproc_undef] = STATE(1077),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1078] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5415),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1078),
    [sym_preproc_endregion] = STATE(1078),
    [sym_preproc_line] = STATE(1078),
    [sym_preproc_pragma] = STATE(1078),
    [sym_preproc_nullable] = STATE(1078),
    [sym_preproc_error] = STATE(1078),
    [sym_preproc_define] = STATE(1078),
    [sym_preproc_undef] = STATE(1078),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1079] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4026),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5766),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1079),
    [sym_preproc_endregion] = STATE(1079),
    [sym_preproc_line] = STATE(1079),
    [sym_preproc_pragma] = STATE(1079),
    [sym_preproc_nullable] = STATE(1079),
    [sym_preproc_error] = STATE(1079),
    [sym_preproc_define] = STATE(1079),
    [sym_preproc_undef] = STATE(1079),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1080] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4634),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4463),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1080),
    [sym_preproc_endregion] = STATE(1080),
    [sym_preproc_line] = STATE(1080),
    [sym_preproc_pragma] = STATE(1080),
    [sym_preproc_nullable] = STATE(1080),
    [sym_preproc_error] = STATE(1080),
    [sym_preproc_define] = STATE(1080),
    [sym_preproc_undef] = STATE(1080),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1081] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5117),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1081),
    [sym_preproc_endregion] = STATE(1081),
    [sym_preproc_line] = STATE(1081),
    [sym_preproc_pragma] = STATE(1081),
    [sym_preproc_nullable] = STATE(1081),
    [sym_preproc_error] = STATE(1081),
    [sym_preproc_define] = STATE(1081),
    [sym_preproc_undef] = STATE(1081),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1082] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5927),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1082),
    [sym_preproc_endregion] = STATE(1082),
    [sym_preproc_line] = STATE(1082),
    [sym_preproc_pragma] = STATE(1082),
    [sym_preproc_nullable] = STATE(1082),
    [sym_preproc_error] = STATE(1082),
    [sym_preproc_define] = STATE(1082),
    [sym_preproc_undef] = STATE(1082),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1083] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4608),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4473),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1083),
    [sym_preproc_endregion] = STATE(1083),
    [sym_preproc_line] = STATE(1083),
    [sym_preproc_pragma] = STATE(1083),
    [sym_preproc_nullable] = STATE(1083),
    [sym_preproc_error] = STATE(1083),
    [sym_preproc_define] = STATE(1083),
    [sym_preproc_undef] = STATE(1083),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1084] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4606),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4477),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1084),
    [sym_preproc_endregion] = STATE(1084),
    [sym_preproc_line] = STATE(1084),
    [sym_preproc_pragma] = STATE(1084),
    [sym_preproc_nullable] = STATE(1084),
    [sym_preproc_error] = STATE(1084),
    [sym_preproc_define] = STATE(1084),
    [sym_preproc_undef] = STATE(1084),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1085] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4595),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4479),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1085),
    [sym_preproc_endregion] = STATE(1085),
    [sym_preproc_line] = STATE(1085),
    [sym_preproc_pragma] = STATE(1085),
    [sym_preproc_nullable] = STATE(1085),
    [sym_preproc_error] = STATE(1085),
    [sym_preproc_define] = STATE(1085),
    [sym_preproc_undef] = STATE(1085),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1086] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7065),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4968),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1086),
    [sym_preproc_endregion] = STATE(1086),
    [sym_preproc_line] = STATE(1086),
    [sym_preproc_pragma] = STATE(1086),
    [sym_preproc_nullable] = STATE(1086),
    [sym_preproc_error] = STATE(1086),
    [sym_preproc_define] = STATE(1086),
    [sym_preproc_undef] = STATE(1086),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1087] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5652),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5181),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1087),
    [sym_preproc_endregion] = STATE(1087),
    [sym_preproc_line] = STATE(1087),
    [sym_preproc_pragma] = STATE(1087),
    [sym_preproc_nullable] = STATE(1087),
    [sym_preproc_error] = STATE(1087),
    [sym_preproc_define] = STATE(1087),
    [sym_preproc_undef] = STATE(1087),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1088] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5750),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5193),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1088),
    [sym_preproc_endregion] = STATE(1088),
    [sym_preproc_line] = STATE(1088),
    [sym_preproc_pragma] = STATE(1088),
    [sym_preproc_nullable] = STATE(1088),
    [sym_preproc_error] = STATE(1088),
    [sym_preproc_define] = STATE(1088),
    [sym_preproc_undef] = STATE(1088),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1089] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5752),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5197),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1089),
    [sym_preproc_endregion] = STATE(1089),
    [sym_preproc_line] = STATE(1089),
    [sym_preproc_pragma] = STATE(1089),
    [sym_preproc_nullable] = STATE(1089),
    [sym_preproc_error] = STATE(1089),
    [sym_preproc_define] = STATE(1089),
    [sym_preproc_undef] = STATE(1089),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1090] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5988),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1090),
    [sym_preproc_endregion] = STATE(1090),
    [sym_preproc_line] = STATE(1090),
    [sym_preproc_pragma] = STATE(1090),
    [sym_preproc_nullable] = STATE(1090),
    [sym_preproc_error] = STATE(1090),
    [sym_preproc_define] = STATE(1090),
    [sym_preproc_undef] = STATE(1090),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1091] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5923),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1091),
    [sym_preproc_endregion] = STATE(1091),
    [sym_preproc_line] = STATE(1091),
    [sym_preproc_pragma] = STATE(1091),
    [sym_preproc_nullable] = STATE(1091),
    [sym_preproc_error] = STATE(1091),
    [sym_preproc_define] = STATE(1091),
    [sym_preproc_undef] = STATE(1091),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1092] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5774),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5208),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1092),
    [sym_preproc_endregion] = STATE(1092),
    [sym_preproc_line] = STATE(1092),
    [sym_preproc_pragma] = STATE(1092),
    [sym_preproc_nullable] = STATE(1092),
    [sym_preproc_error] = STATE(1092),
    [sym_preproc_define] = STATE(1092),
    [sym_preproc_undef] = STATE(1092),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1093] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5111),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1093),
    [sym_preproc_endregion] = STATE(1093),
    [sym_preproc_line] = STATE(1093),
    [sym_preproc_pragma] = STATE(1093),
    [sym_preproc_nullable] = STATE(1093),
    [sym_preproc_error] = STATE(1093),
    [sym_preproc_define] = STATE(1093),
    [sym_preproc_undef] = STATE(1093),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1094] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5465),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1094),
    [sym_preproc_endregion] = STATE(1094),
    [sym_preproc_line] = STATE(1094),
    [sym_preproc_pragma] = STATE(1094),
    [sym_preproc_nullable] = STATE(1094),
    [sym_preproc_error] = STATE(1094),
    [sym_preproc_define] = STATE(1094),
    [sym_preproc_undef] = STATE(1094),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1095] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5806),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1095),
    [sym_preproc_endregion] = STATE(1095),
    [sym_preproc_line] = STATE(1095),
    [sym_preproc_pragma] = STATE(1095),
    [sym_preproc_nullable] = STATE(1095),
    [sym_preproc_error] = STATE(1095),
    [sym_preproc_define] = STATE(1095),
    [sym_preproc_undef] = STATE(1095),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1096] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5756),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5224),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1096),
    [sym_preproc_endregion] = STATE(1096),
    [sym_preproc_line] = STATE(1096),
    [sym_preproc_pragma] = STATE(1096),
    [sym_preproc_nullable] = STATE(1096),
    [sym_preproc_error] = STATE(1096),
    [sym_preproc_define] = STATE(1096),
    [sym_preproc_undef] = STATE(1096),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1097] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5462),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1097),
    [sym_preproc_endregion] = STATE(1097),
    [sym_preproc_line] = STATE(1097),
    [sym_preproc_pragma] = STATE(1097),
    [sym_preproc_nullable] = STATE(1097),
    [sym_preproc_error] = STATE(1097),
    [sym_preproc_define] = STATE(1097),
    [sym_preproc_undef] = STATE(1097),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1098] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5722),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5229),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1098),
    [sym_preproc_endregion] = STATE(1098),
    [sym_preproc_line] = STATE(1098),
    [sym_preproc_pragma] = STATE(1098),
    [sym_preproc_nullable] = STATE(1098),
    [sym_preproc_error] = STATE(1098),
    [sym_preproc_define] = STATE(1098),
    [sym_preproc_undef] = STATE(1098),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1099] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5461),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1099),
    [sym_preproc_endregion] = STATE(1099),
    [sym_preproc_line] = STATE(1099),
    [sym_preproc_pragma] = STATE(1099),
    [sym_preproc_nullable] = STATE(1099),
    [sym_preproc_error] = STATE(1099),
    [sym_preproc_define] = STATE(1099),
    [sym_preproc_undef] = STATE(1099),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1100] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7080),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4481),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1100),
    [sym_preproc_endregion] = STATE(1100),
    [sym_preproc_line] = STATE(1100),
    [sym_preproc_pragma] = STATE(1100),
    [sym_preproc_nullable] = STATE(1100),
    [sym_preproc_error] = STATE(1100),
    [sym_preproc_define] = STATE(1100),
    [sym_preproc_undef] = STATE(1100),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1101] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5459),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1101),
    [sym_preproc_endregion] = STATE(1101),
    [sym_preproc_line] = STATE(1101),
    [sym_preproc_pragma] = STATE(1101),
    [sym_preproc_nullable] = STATE(1101),
    [sym_preproc_error] = STATE(1101),
    [sym_preproc_define] = STATE(1101),
    [sym_preproc_undef] = STATE(1101),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1102] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7133),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4363),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1102),
    [sym_preproc_endregion] = STATE(1102),
    [sym_preproc_line] = STATE(1102),
    [sym_preproc_pragma] = STATE(1102),
    [sym_preproc_nullable] = STATE(1102),
    [sym_preproc_error] = STATE(1102),
    [sym_preproc_define] = STATE(1102),
    [sym_preproc_undef] = STATE(1102),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1103] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5722),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5292),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1103),
    [sym_preproc_endregion] = STATE(1103),
    [sym_preproc_line] = STATE(1103),
    [sym_preproc_pragma] = STATE(1103),
    [sym_preproc_nullable] = STATE(1103),
    [sym_preproc_error] = STATE(1103),
    [sym_preproc_define] = STATE(1103),
    [sym_preproc_undef] = STATE(1103),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1104] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5457),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1104),
    [sym_preproc_endregion] = STATE(1104),
    [sym_preproc_line] = STATE(1104),
    [sym_preproc_pragma] = STATE(1104),
    [sym_preproc_nullable] = STATE(1104),
    [sym_preproc_error] = STATE(1104),
    [sym_preproc_define] = STATE(1104),
    [sym_preproc_undef] = STATE(1104),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1105] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5756),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5290),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1105),
    [sym_preproc_endregion] = STATE(1105),
    [sym_preproc_line] = STATE(1105),
    [sym_preproc_pragma] = STATE(1105),
    [sym_preproc_nullable] = STATE(1105),
    [sym_preproc_error] = STATE(1105),
    [sym_preproc_define] = STATE(1105),
    [sym_preproc_undef] = STATE(1105),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1106] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5456),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1106),
    [sym_preproc_endregion] = STATE(1106),
    [sym_preproc_line] = STATE(1106),
    [sym_preproc_pragma] = STATE(1106),
    [sym_preproc_nullable] = STATE(1106),
    [sym_preproc_error] = STATE(1106),
    [sym_preproc_define] = STATE(1106),
    [sym_preproc_undef] = STATE(1106),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1107] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5774),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5289),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1107),
    [sym_preproc_endregion] = STATE(1107),
    [sym_preproc_line] = STATE(1107),
    [sym_preproc_pragma] = STATE(1107),
    [sym_preproc_nullable] = STATE(1107),
    [sym_preproc_error] = STATE(1107),
    [sym_preproc_define] = STATE(1107),
    [sym_preproc_undef] = STATE(1107),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1108] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1108),
    [sym_preproc_endregion] = STATE(1108),
    [sym_preproc_line] = STATE(1108),
    [sym_preproc_pragma] = STATE(1108),
    [sym_preproc_nullable] = STATE(1108),
    [sym_preproc_error] = STATE(1108),
    [sym_preproc_define] = STATE(1108),
    [sym_preproc_undef] = STATE(1108),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1109] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5752),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5287),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1109),
    [sym_preproc_endregion] = STATE(1109),
    [sym_preproc_line] = STATE(1109),
    [sym_preproc_pragma] = STATE(1109),
    [sym_preproc_nullable] = STATE(1109),
    [sym_preproc_error] = STATE(1109),
    [sym_preproc_define] = STATE(1109),
    [sym_preproc_undef] = STATE(1109),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1110] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5750),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5286),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1110),
    [sym_preproc_endregion] = STATE(1110),
    [sym_preproc_line] = STATE(1110),
    [sym_preproc_pragma] = STATE(1110),
    [sym_preproc_nullable] = STATE(1110),
    [sym_preproc_error] = STATE(1110),
    [sym_preproc_define] = STATE(1110),
    [sym_preproc_undef] = STATE(1110),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1111] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(5652),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5284),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1111),
    [sym_preproc_endregion] = STATE(1111),
    [sym_preproc_line] = STATE(1111),
    [sym_preproc_pragma] = STATE(1111),
    [sym_preproc_nullable] = STATE(1111),
    [sym_preproc_error] = STATE(1111),
    [sym_preproc_define] = STATE(1111),
    [sym_preproc_undef] = STATE(1111),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(2849),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1112] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7128),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6223),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1112),
    [sym_preproc_endregion] = STATE(1112),
    [sym_preproc_line] = STATE(1112),
    [sym_preproc_pragma] = STATE(1112),
    [sym_preproc_nullable] = STATE(1112),
    [sym_preproc_error] = STATE(1112),
    [sym_preproc_define] = STATE(1112),
    [sym_preproc_undef] = STATE(1112),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1113] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6721),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5655),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1113),
    [sym_preproc_endregion] = STATE(1113),
    [sym_preproc_line] = STATE(1113),
    [sym_preproc_pragma] = STATE(1113),
    [sym_preproc_nullable] = STATE(1113),
    [sym_preproc_error] = STATE(1113),
    [sym_preproc_define] = STATE(1113),
    [sym_preproc_undef] = STATE(1113),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1114] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4139),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5874),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1114),
    [sym_preproc_endregion] = STATE(1114),
    [sym_preproc_line] = STATE(1114),
    [sym_preproc_pragma] = STATE(1114),
    [sym_preproc_nullable] = STATE(1114),
    [sym_preproc_error] = STATE(1114),
    [sym_preproc_define] = STATE(1114),
    [sym_preproc_undef] = STATE(1114),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1115] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4105),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5871),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1115),
    [sym_preproc_endregion] = STATE(1115),
    [sym_preproc_line] = STATE(1115),
    [sym_preproc_pragma] = STATE(1115),
    [sym_preproc_nullable] = STATE(1115),
    [sym_preproc_error] = STATE(1115),
    [sym_preproc_define] = STATE(1115),
    [sym_preproc_undef] = STATE(1115),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1116] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3672),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6252),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1116),
    [sym_preproc_endregion] = STATE(1116),
    [sym_preproc_line] = STATE(1116),
    [sym_preproc_pragma] = STATE(1116),
    [sym_preproc_nullable] = STATE(1116),
    [sym_preproc_error] = STATE(1116),
    [sym_preproc_define] = STATE(1116),
    [sym_preproc_undef] = STATE(1116),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1117] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7150),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6125),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1117),
    [sym_preproc_endregion] = STATE(1117),
    [sym_preproc_line] = STATE(1117),
    [sym_preproc_pragma] = STATE(1117),
    [sym_preproc_nullable] = STATE(1117),
    [sym_preproc_error] = STATE(1117),
    [sym_preproc_define] = STATE(1117),
    [sym_preproc_undef] = STATE(1117),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1118] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3675),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6253),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1118),
    [sym_preproc_endregion] = STATE(1118),
    [sym_preproc_line] = STATE(1118),
    [sym_preproc_pragma] = STATE(1118),
    [sym_preproc_nullable] = STATE(1118),
    [sym_preproc_error] = STATE(1118),
    [sym_preproc_define] = STATE(1118),
    [sym_preproc_undef] = STATE(1118),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1119] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4143),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5869),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1119),
    [sym_preproc_endregion] = STATE(1119),
    [sym_preproc_line] = STATE(1119),
    [sym_preproc_pragma] = STATE(1119),
    [sym_preproc_nullable] = STATE(1119),
    [sym_preproc_error] = STATE(1119),
    [sym_preproc_define] = STATE(1119),
    [sym_preproc_undef] = STATE(1119),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1120] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5963),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1120),
    [sym_preproc_endregion] = STATE(1120),
    [sym_preproc_line] = STATE(1120),
    [sym_preproc_pragma] = STATE(1120),
    [sym_preproc_nullable] = STATE(1120),
    [sym_preproc_error] = STATE(1120),
    [sym_preproc_define] = STATE(1120),
    [sym_preproc_undef] = STATE(1120),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1121] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5108),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1121),
    [sym_preproc_endregion] = STATE(1121),
    [sym_preproc_line] = STATE(1121),
    [sym_preproc_pragma] = STATE(1121),
    [sym_preproc_nullable] = STATE(1121),
    [sym_preproc_error] = STATE(1121),
    [sym_preproc_define] = STATE(1121),
    [sym_preproc_undef] = STATE(1121),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1122] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3659),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6254),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1122),
    [sym_preproc_endregion] = STATE(1122),
    [sym_preproc_line] = STATE(1122),
    [sym_preproc_pragma] = STATE(1122),
    [sym_preproc_nullable] = STATE(1122),
    [sym_preproc_error] = STATE(1122),
    [sym_preproc_define] = STATE(1122),
    [sym_preproc_undef] = STATE(1122),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1123] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4606),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4815),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1123),
    [sym_preproc_endregion] = STATE(1123),
    [sym_preproc_line] = STATE(1123),
    [sym_preproc_pragma] = STATE(1123),
    [sym_preproc_nullable] = STATE(1123),
    [sym_preproc_error] = STATE(1123),
    [sym_preproc_define] = STATE(1123),
    [sym_preproc_undef] = STATE(1123),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1124] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4232),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5867),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1124),
    [sym_preproc_endregion] = STATE(1124),
    [sym_preproc_line] = STATE(1124),
    [sym_preproc_pragma] = STATE(1124),
    [sym_preproc_nullable] = STATE(1124),
    [sym_preproc_error] = STATE(1124),
    [sym_preproc_define] = STATE(1124),
    [sym_preproc_undef] = STATE(1124),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1125] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5865),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1125),
    [sym_preproc_endregion] = STATE(1125),
    [sym_preproc_line] = STATE(1125),
    [sym_preproc_pragma] = STATE(1125),
    [sym_preproc_nullable] = STATE(1125),
    [sym_preproc_error] = STATE(1125),
    [sym_preproc_define] = STATE(1125),
    [sym_preproc_undef] = STATE(1125),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1126] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3643),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6256),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1126),
    [sym_preproc_endregion] = STATE(1126),
    [sym_preproc_line] = STATE(1126),
    [sym_preproc_pragma] = STATE(1126),
    [sym_preproc_nullable] = STATE(1126),
    [sym_preproc_error] = STATE(1126),
    [sym_preproc_define] = STATE(1126),
    [sym_preproc_undef] = STATE(1126),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1127] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3759),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6429),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1127),
    [sym_preproc_endregion] = STATE(1127),
    [sym_preproc_line] = STATE(1127),
    [sym_preproc_pragma] = STATE(1127),
    [sym_preproc_nullable] = STATE(1127),
    [sym_preproc_error] = STATE(1127),
    [sym_preproc_define] = STATE(1127),
    [sym_preproc_undef] = STATE(1127),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1128] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6003),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1128),
    [sym_preproc_endregion] = STATE(1128),
    [sym_preproc_line] = STATE(1128),
    [sym_preproc_pragma] = STATE(1128),
    [sym_preproc_nullable] = STATE(1128),
    [sym_preproc_error] = STATE(1128),
    [sym_preproc_define] = STATE(1128),
    [sym_preproc_undef] = STATE(1128),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1129] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6009),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1129),
    [sym_preproc_endregion] = STATE(1129),
    [sym_preproc_line] = STATE(1129),
    [sym_preproc_pragma] = STATE(1129),
    [sym_preproc_nullable] = STATE(1129),
    [sym_preproc_error] = STATE(1129),
    [sym_preproc_define] = STATE(1129),
    [sym_preproc_undef] = STATE(1129),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1130] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5864),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1130),
    [sym_preproc_endregion] = STATE(1130),
    [sym_preproc_line] = STATE(1130),
    [sym_preproc_pragma] = STATE(1130),
    [sym_preproc_nullable] = STATE(1130),
    [sym_preproc_error] = STATE(1130),
    [sym_preproc_define] = STATE(1130),
    [sym_preproc_undef] = STATE(1130),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1131] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6484),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1131),
    [sym_preproc_endregion] = STATE(1131),
    [sym_preproc_line] = STATE(1131),
    [sym_preproc_pragma] = STATE(1131),
    [sym_preproc_nullable] = STATE(1131),
    [sym_preproc_error] = STATE(1131),
    [sym_preproc_define] = STATE(1131),
    [sym_preproc_undef] = STATE(1131),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1132] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4233),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5104),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1132),
    [sym_preproc_endregion] = STATE(1132),
    [sym_preproc_line] = STATE(1132),
    [sym_preproc_pragma] = STATE(1132),
    [sym_preproc_nullable] = STATE(1132),
    [sym_preproc_error] = STATE(1132),
    [sym_preproc_define] = STATE(1132),
    [sym_preproc_undef] = STATE(1132),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1133] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3662),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6257),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1133),
    [sym_preproc_endregion] = STATE(1133),
    [sym_preproc_line] = STATE(1133),
    [sym_preproc_pragma] = STATE(1133),
    [sym_preproc_nullable] = STATE(1133),
    [sym_preproc_error] = STATE(1133),
    [sym_preproc_define] = STATE(1133),
    [sym_preproc_undef] = STATE(1133),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1134] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7099),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5362),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1134),
    [sym_preproc_endregion] = STATE(1134),
    [sym_preproc_line] = STATE(1134),
    [sym_preproc_pragma] = STATE(1134),
    [sym_preproc_nullable] = STATE(1134),
    [sym_preproc_error] = STATE(1134),
    [sym_preproc_define] = STATE(1134),
    [sym_preproc_undef] = STATE(1134),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1135] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3780),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6462),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1135),
    [sym_preproc_endregion] = STATE(1135),
    [sym_preproc_line] = STATE(1135),
    [sym_preproc_pragma] = STATE(1135),
    [sym_preproc_nullable] = STATE(1135),
    [sym_preproc_error] = STATE(1135),
    [sym_preproc_define] = STATE(1135),
    [sym_preproc_undef] = STATE(1135),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1136] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4243),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5100),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1136),
    [sym_preproc_endregion] = STATE(1136),
    [sym_preproc_line] = STATE(1136),
    [sym_preproc_pragma] = STATE(1136),
    [sym_preproc_nullable] = STATE(1136),
    [sym_preproc_error] = STATE(1136),
    [sym_preproc_define] = STATE(1136),
    [sym_preproc_undef] = STATE(1136),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(2827),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1137] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5486),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1137),
    [sym_preproc_endregion] = STATE(1137),
    [sym_preproc_line] = STATE(1137),
    [sym_preproc_pragma] = STATE(1137),
    [sym_preproc_nullable] = STATE(1137),
    [sym_preproc_error] = STATE(1137),
    [sym_preproc_define] = STATE(1137),
    [sym_preproc_undef] = STATE(1137),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1138] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7039),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5863),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1138),
    [sym_preproc_endregion] = STATE(1138),
    [sym_preproc_line] = STATE(1138),
    [sym_preproc_pragma] = STATE(1138),
    [sym_preproc_nullable] = STATE(1138),
    [sym_preproc_error] = STATE(1138),
    [sym_preproc_define] = STATE(1138),
    [sym_preproc_undef] = STATE(1138),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_readonly] = ACTIONS(2721),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1139] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3712),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6258),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1139),
    [sym_preproc_endregion] = STATE(1139),
    [sym_preproc_line] = STATE(1139),
    [sym_preproc_pragma] = STATE(1139),
    [sym_preproc_nullable] = STATE(1139),
    [sym_preproc_error] = STATE(1139),
    [sym_preproc_define] = STATE(1139),
    [sym_preproc_undef] = STATE(1139),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1140] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3734),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6680),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1140),
    [sym_preproc_endregion] = STATE(1140),
    [sym_preproc_line] = STATE(1140),
    [sym_preproc_pragma] = STATE(1140),
    [sym_preproc_nullable] = STATE(1140),
    [sym_preproc_error] = STATE(1140),
    [sym_preproc_define] = STATE(1140),
    [sym_preproc_undef] = STATE(1140),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1141] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3771),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6670),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1141),
    [sym_preproc_endregion] = STATE(1141),
    [sym_preproc_line] = STATE(1141),
    [sym_preproc_pragma] = STATE(1141),
    [sym_preproc_nullable] = STATE(1141),
    [sym_preproc_error] = STATE(1141),
    [sym_preproc_define] = STATE(1141),
    [sym_preproc_undef] = STATE(1141),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1142] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4595),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4397),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1142),
    [sym_preproc_endregion] = STATE(1142),
    [sym_preproc_line] = STATE(1142),
    [sym_preproc_pragma] = STATE(1142),
    [sym_preproc_nullable] = STATE(1142),
    [sym_preproc_error] = STATE(1142),
    [sym_preproc_define] = STATE(1142),
    [sym_preproc_undef] = STATE(1142),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1143] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3760),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6655),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1143),
    [sym_preproc_endregion] = STATE(1143),
    [sym_preproc_line] = STATE(1143),
    [sym_preproc_pragma] = STATE(1143),
    [sym_preproc_nullable] = STATE(1143),
    [sym_preproc_error] = STATE(1143),
    [sym_preproc_define] = STATE(1143),
    [sym_preproc_undef] = STATE(1143),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1144] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4659),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4394),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1144),
    [sym_preproc_endregion] = STATE(1144),
    [sym_preproc_line] = STATE(1144),
    [sym_preproc_pragma] = STATE(1144),
    [sym_preproc_nullable] = STATE(1144),
    [sym_preproc_error] = STATE(1144),
    [sym_preproc_define] = STATE(1144),
    [sym_preproc_undef] = STATE(1144),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1145] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4606),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4395),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1145),
    [sym_preproc_endregion] = STATE(1145),
    [sym_preproc_line] = STATE(1145),
    [sym_preproc_pragma] = STATE(1145),
    [sym_preproc_nullable] = STATE(1145),
    [sym_preproc_error] = STATE(1145),
    [sym_preproc_define] = STATE(1145),
    [sym_preproc_undef] = STATE(1145),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1146] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4608),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4391),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1146),
    [sym_preproc_endregion] = STATE(1146),
    [sym_preproc_line] = STATE(1146),
    [sym_preproc_pragma] = STATE(1146),
    [sym_preproc_nullable] = STATE(1146),
    [sym_preproc_error] = STATE(1146),
    [sym_preproc_define] = STATE(1146),
    [sym_preproc_undef] = STATE(1146),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1147] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4641),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4385),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1147),
    [sym_preproc_endregion] = STATE(1147),
    [sym_preproc_line] = STATE(1147),
    [sym_preproc_pragma] = STATE(1147),
    [sym_preproc_nullable] = STATE(1147),
    [sym_preproc_error] = STATE(1147),
    [sym_preproc_define] = STATE(1147),
    [sym_preproc_undef] = STATE(1147),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1148] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(3793),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6442),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1148),
    [sym_preproc_endregion] = STATE(1148),
    [sym_preproc_line] = STATE(1148),
    [sym_preproc_pragma] = STATE(1148),
    [sym_preproc_nullable] = STATE(1148),
    [sym_preproc_error] = STATE(1148),
    [sym_preproc_define] = STATE(1148),
    [sym_preproc_undef] = STATE(1148),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1149] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4634),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4451),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1149),
    [sym_preproc_endregion] = STATE(1149),
    [sym_preproc_line] = STATE(1149),
    [sym_preproc_pragma] = STATE(1149),
    [sym_preproc_nullable] = STATE(1149),
    [sym_preproc_error] = STATE(1149),
    [sym_preproc_define] = STATE(1149),
    [sym_preproc_undef] = STATE(1149),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1150] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_block] = STATE(4608),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4807),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1150),
    [sym_preproc_endregion] = STATE(1150),
    [sym_preproc_line] = STATE(1150),
    [sym_preproc_pragma] = STATE(1150),
    [sym_preproc_nullable] = STATE(1150),
    [sym_preproc_error] = STATE(1150),
    [sym_preproc_define] = STATE(1150),
    [sym_preproc_undef] = STATE(1150),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2867),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1151] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5545),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1151),
    [sym_preproc_endregion] = STATE(1151),
    [sym_preproc_line] = STATE(1151),
    [sym_preproc_pragma] = STATE(1151),
    [sym_preproc_nullable] = STATE(1151),
    [sym_preproc_error] = STATE(1151),
    [sym_preproc_define] = STATE(1151),
    [sym_preproc_undef] = STATE(1151),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1152] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4452),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1152),
    [sym_preproc_endregion] = STATE(1152),
    [sym_preproc_line] = STATE(1152),
    [sym_preproc_pragma] = STATE(1152),
    [sym_preproc_nullable] = STATE(1152),
    [sym_preproc_error] = STATE(1152),
    [sym_preproc_define] = STATE(1152),
    [sym_preproc_undef] = STATE(1152),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1153] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5452),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1153),
    [sym_preproc_endregion] = STATE(1153),
    [sym_preproc_line] = STATE(1153),
    [sym_preproc_pragma] = STATE(1153),
    [sym_preproc_nullable] = STATE(1153),
    [sym_preproc_error] = STATE(1153),
    [sym_preproc_define] = STATE(1153),
    [sym_preproc_undef] = STATE(1153),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1154] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5430),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1154),
    [sym_preproc_endregion] = STATE(1154),
    [sym_preproc_line] = STATE(1154),
    [sym_preproc_pragma] = STATE(1154),
    [sym_preproc_nullable] = STATE(1154),
    [sym_preproc_error] = STATE(1154),
    [sym_preproc_define] = STATE(1154),
    [sym_preproc_undef] = STATE(1154),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1155] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4371),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1155),
    [sym_preproc_endregion] = STATE(1155),
    [sym_preproc_line] = STATE(1155),
    [sym_preproc_pragma] = STATE(1155),
    [sym_preproc_nullable] = STATE(1155),
    [sym_preproc_error] = STATE(1155),
    [sym_preproc_define] = STATE(1155),
    [sym_preproc_undef] = STATE(1155),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1156] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6607),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1156),
    [sym_preproc_endregion] = STATE(1156),
    [sym_preproc_line] = STATE(1156),
    [sym_preproc_pragma] = STATE(1156),
    [sym_preproc_nullable] = STATE(1156),
    [sym_preproc_error] = STATE(1156),
    [sym_preproc_define] = STATE(1156),
    [sym_preproc_undef] = STATE(1156),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1157] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5431),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1157),
    [sym_preproc_endregion] = STATE(1157),
    [sym_preproc_line] = STATE(1157),
    [sym_preproc_pragma] = STATE(1157),
    [sym_preproc_nullable] = STATE(1157),
    [sym_preproc_error] = STATE(1157),
    [sym_preproc_define] = STATE(1157),
    [sym_preproc_undef] = STATE(1157),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1158] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6678),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1158),
    [sym_preproc_endregion] = STATE(1158),
    [sym_preproc_line] = STATE(1158),
    [sym_preproc_pragma] = STATE(1158),
    [sym_preproc_nullable] = STATE(1158),
    [sym_preproc_error] = STATE(1158),
    [sym_preproc_define] = STATE(1158),
    [sym_preproc_undef] = STATE(1158),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1159] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6129),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1159),
    [sym_preproc_endregion] = STATE(1159),
    [sym_preproc_line] = STATE(1159),
    [sym_preproc_pragma] = STATE(1159),
    [sym_preproc_nullable] = STATE(1159),
    [sym_preproc_error] = STATE(1159),
    [sym_preproc_define] = STATE(1159),
    [sym_preproc_undef] = STATE(1159),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1160] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5432),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1160),
    [sym_preproc_endregion] = STATE(1160),
    [sym_preproc_line] = STATE(1160),
    [sym_preproc_pragma] = STATE(1160),
    [sym_preproc_nullable] = STATE(1160),
    [sym_preproc_error] = STATE(1160),
    [sym_preproc_define] = STATE(1160),
    [sym_preproc_undef] = STATE(1160),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1161] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6128),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1161),
    [sym_preproc_endregion] = STATE(1161),
    [sym_preproc_line] = STATE(1161),
    [sym_preproc_pragma] = STATE(1161),
    [sym_preproc_nullable] = STATE(1161),
    [sym_preproc_error] = STATE(1161),
    [sym_preproc_define] = STATE(1161),
    [sym_preproc_undef] = STATE(1161),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1162] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5992),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1162),
    [sym_preproc_endregion] = STATE(1162),
    [sym_preproc_line] = STATE(1162),
    [sym_preproc_pragma] = STATE(1162),
    [sym_preproc_nullable] = STATE(1162),
    [sym_preproc_error] = STATE(1162),
    [sym_preproc_define] = STATE(1162),
    [sym_preproc_undef] = STATE(1162),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1163] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4398),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1163),
    [sym_preproc_endregion] = STATE(1163),
    [sym_preproc_line] = STATE(1163),
    [sym_preproc_pragma] = STATE(1163),
    [sym_preproc_nullable] = STATE(1163),
    [sym_preproc_error] = STATE(1163),
    [sym_preproc_define] = STATE(1163),
    [sym_preproc_undef] = STATE(1163),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1164] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1164),
    [sym_preproc_endregion] = STATE(1164),
    [sym_preproc_line] = STATE(1164),
    [sym_preproc_pragma] = STATE(1164),
    [sym_preproc_nullable] = STATE(1164),
    [sym_preproc_error] = STATE(1164),
    [sym_preproc_define] = STATE(1164),
    [sym_preproc_undef] = STATE(1164),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1165] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1165),
    [sym_preproc_endregion] = STATE(1165),
    [sym_preproc_line] = STATE(1165),
    [sym_preproc_pragma] = STATE(1165),
    [sym_preproc_nullable] = STATE(1165),
    [sym_preproc_error] = STATE(1165),
    [sym_preproc_define] = STATE(1165),
    [sym_preproc_undef] = STATE(1165),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1166] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1166),
    [sym_preproc_endregion] = STATE(1166),
    [sym_preproc_line] = STATE(1166),
    [sym_preproc_pragma] = STATE(1166),
    [sym_preproc_nullable] = STATE(1166),
    [sym_preproc_error] = STATE(1166),
    [sym_preproc_define] = STATE(1166),
    [sym_preproc_undef] = STATE(1166),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1167] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4411),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1167),
    [sym_preproc_endregion] = STATE(1167),
    [sym_preproc_line] = STATE(1167),
    [sym_preproc_pragma] = STATE(1167),
    [sym_preproc_nullable] = STATE(1167),
    [sym_preproc_error] = STATE(1167),
    [sym_preproc_define] = STATE(1167),
    [sym_preproc_undef] = STATE(1167),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1168] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5826),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1168),
    [sym_preproc_endregion] = STATE(1168),
    [sym_preproc_line] = STATE(1168),
    [sym_preproc_pragma] = STATE(1168),
    [sym_preproc_nullable] = STATE(1168),
    [sym_preproc_error] = STATE(1168),
    [sym_preproc_define] = STATE(1168),
    [sym_preproc_undef] = STATE(1168),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1169] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1169),
    [sym_preproc_endregion] = STATE(1169),
    [sym_preproc_line] = STATE(1169),
    [sym_preproc_pragma] = STATE(1169),
    [sym_preproc_nullable] = STATE(1169),
    [sym_preproc_error] = STATE(1169),
    [sym_preproc_define] = STATE(1169),
    [sym_preproc_undef] = STATE(1169),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1170] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5394),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1170),
    [sym_preproc_endregion] = STATE(1170),
    [sym_preproc_line] = STATE(1170),
    [sym_preproc_pragma] = STATE(1170),
    [sym_preproc_nullable] = STATE(1170),
    [sym_preproc_error] = STATE(1170),
    [sym_preproc_define] = STATE(1170),
    [sym_preproc_undef] = STATE(1170),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1171] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6628),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1171),
    [sym_preproc_endregion] = STATE(1171),
    [sym_preproc_line] = STATE(1171),
    [sym_preproc_pragma] = STATE(1171),
    [sym_preproc_nullable] = STATE(1171),
    [sym_preproc_error] = STATE(1171),
    [sym_preproc_define] = STATE(1171),
    [sym_preproc_undef] = STATE(1171),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1172] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6220),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1172),
    [sym_preproc_endregion] = STATE(1172),
    [sym_preproc_line] = STATE(1172),
    [sym_preproc_pragma] = STATE(1172),
    [sym_preproc_nullable] = STATE(1172),
    [sym_preproc_error] = STATE(1172),
    [sym_preproc_define] = STATE(1172),
    [sym_preproc_undef] = STATE(1172),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1173] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5825),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1173),
    [sym_preproc_endregion] = STATE(1173),
    [sym_preproc_line] = STATE(1173),
    [sym_preproc_pragma] = STATE(1173),
    [sym_preproc_nullable] = STATE(1173),
    [sym_preproc_error] = STATE(1173),
    [sym_preproc_define] = STATE(1173),
    [sym_preproc_undef] = STATE(1173),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1174] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6267),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1174),
    [sym_preproc_endregion] = STATE(1174),
    [sym_preproc_line] = STATE(1174),
    [sym_preproc_pragma] = STATE(1174),
    [sym_preproc_nullable] = STATE(1174),
    [sym_preproc_error] = STATE(1174),
    [sym_preproc_define] = STATE(1174),
    [sym_preproc_undef] = STATE(1174),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1175] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6148),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1175),
    [sym_preproc_endregion] = STATE(1175),
    [sym_preproc_line] = STATE(1175),
    [sym_preproc_pragma] = STATE(1175),
    [sym_preproc_nullable] = STATE(1175),
    [sym_preproc_error] = STATE(1175),
    [sym_preproc_define] = STATE(1175),
    [sym_preproc_undef] = STATE(1175),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1176] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5791),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1176),
    [sym_preproc_endregion] = STATE(1176),
    [sym_preproc_line] = STATE(1176),
    [sym_preproc_pragma] = STATE(1176),
    [sym_preproc_nullable] = STATE(1176),
    [sym_preproc_error] = STATE(1176),
    [sym_preproc_define] = STATE(1176),
    [sym_preproc_undef] = STATE(1176),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1177] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1177),
    [sym_preproc_endregion] = STATE(1177),
    [sym_preproc_line] = STATE(1177),
    [sym_preproc_pragma] = STATE(1177),
    [sym_preproc_nullable] = STATE(1177),
    [sym_preproc_error] = STATE(1177),
    [sym_preproc_define] = STATE(1177),
    [sym_preproc_undef] = STATE(1177),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1178] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5824),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1178),
    [sym_preproc_endregion] = STATE(1178),
    [sym_preproc_line] = STATE(1178),
    [sym_preproc_pragma] = STATE(1178),
    [sym_preproc_nullable] = STATE(1178),
    [sym_preproc_error] = STATE(1178),
    [sym_preproc_define] = STATE(1178),
    [sym_preproc_undef] = STATE(1178),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1179] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6261),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1179),
    [sym_preproc_endregion] = STATE(1179),
    [sym_preproc_line] = STATE(1179),
    [sym_preproc_pragma] = STATE(1179),
    [sym_preproc_nullable] = STATE(1179),
    [sym_preproc_error] = STATE(1179),
    [sym_preproc_define] = STATE(1179),
    [sym_preproc_undef] = STATE(1179),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1180] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6652),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1180),
    [sym_preproc_endregion] = STATE(1180),
    [sym_preproc_line] = STATE(1180),
    [sym_preproc_pragma] = STATE(1180),
    [sym_preproc_nullable] = STATE(1180),
    [sym_preproc_error] = STATE(1180),
    [sym_preproc_define] = STATE(1180),
    [sym_preproc_undef] = STATE(1180),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1181] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6165),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1181),
    [sym_preproc_endregion] = STATE(1181),
    [sym_preproc_line] = STATE(1181),
    [sym_preproc_pragma] = STATE(1181),
    [sym_preproc_nullable] = STATE(1181),
    [sym_preproc_error] = STATE(1181),
    [sym_preproc_define] = STATE(1181),
    [sym_preproc_undef] = STATE(1181),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1182] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6667),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1182),
    [sym_preproc_endregion] = STATE(1182),
    [sym_preproc_line] = STATE(1182),
    [sym_preproc_pragma] = STATE(1182),
    [sym_preproc_nullable] = STATE(1182),
    [sym_preproc_error] = STATE(1182),
    [sym_preproc_define] = STATE(1182),
    [sym_preproc_undef] = STATE(1182),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1183] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5429),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1183),
    [sym_preproc_endregion] = STATE(1183),
    [sym_preproc_line] = STATE(1183),
    [sym_preproc_pragma] = STATE(1183),
    [sym_preproc_nullable] = STATE(1183),
    [sym_preproc_error] = STATE(1183),
    [sym_preproc_define] = STATE(1183),
    [sym_preproc_undef] = STATE(1183),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1184] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6650),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1184),
    [sym_preproc_endregion] = STATE(1184),
    [sym_preproc_line] = STATE(1184),
    [sym_preproc_pragma] = STATE(1184),
    [sym_preproc_nullable] = STATE(1184),
    [sym_preproc_error] = STATE(1184),
    [sym_preproc_define] = STATE(1184),
    [sym_preproc_undef] = STATE(1184),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1185] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6186),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1185),
    [sym_preproc_endregion] = STATE(1185),
    [sym_preproc_line] = STATE(1185),
    [sym_preproc_pragma] = STATE(1185),
    [sym_preproc_nullable] = STATE(1185),
    [sym_preproc_error] = STATE(1185),
    [sym_preproc_define] = STATE(1185),
    [sym_preproc_undef] = STATE(1185),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1186] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6482),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1186),
    [sym_preproc_endregion] = STATE(1186),
    [sym_preproc_line] = STATE(1186),
    [sym_preproc_pragma] = STATE(1186),
    [sym_preproc_nullable] = STATE(1186),
    [sym_preproc_error] = STATE(1186),
    [sym_preproc_define] = STATE(1186),
    [sym_preproc_undef] = STATE(1186),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1187] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5428),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1187),
    [sym_preproc_endregion] = STATE(1187),
    [sym_preproc_line] = STATE(1187),
    [sym_preproc_pragma] = STATE(1187),
    [sym_preproc_nullable] = STATE(1187),
    [sym_preproc_error] = STATE(1187),
    [sym_preproc_define] = STATE(1187),
    [sym_preproc_undef] = STATE(1187),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1188] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6183),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1188),
    [sym_preproc_endregion] = STATE(1188),
    [sym_preproc_line] = STATE(1188),
    [sym_preproc_pragma] = STATE(1188),
    [sym_preproc_nullable] = STATE(1188),
    [sym_preproc_error] = STATE(1188),
    [sym_preproc_define] = STATE(1188),
    [sym_preproc_undef] = STATE(1188),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1189] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1189),
    [sym_preproc_endregion] = STATE(1189),
    [sym_preproc_line] = STATE(1189),
    [sym_preproc_pragma] = STATE(1189),
    [sym_preproc_nullable] = STATE(1189),
    [sym_preproc_error] = STATE(1189),
    [sym_preproc_define] = STATE(1189),
    [sym_preproc_undef] = STATE(1189),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1190] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4421),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1190),
    [sym_preproc_endregion] = STATE(1190),
    [sym_preproc_line] = STATE(1190),
    [sym_preproc_pragma] = STATE(1190),
    [sym_preproc_nullable] = STATE(1190),
    [sym_preproc_error] = STATE(1190),
    [sym_preproc_define] = STATE(1190),
    [sym_preproc_undef] = STATE(1190),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1191] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4415),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1191),
    [sym_preproc_endregion] = STATE(1191),
    [sym_preproc_line] = STATE(1191),
    [sym_preproc_pragma] = STATE(1191),
    [sym_preproc_nullable] = STATE(1191),
    [sym_preproc_error] = STATE(1191),
    [sym_preproc_define] = STATE(1191),
    [sym_preproc_undef] = STATE(1191),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1192] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6124),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1192),
    [sym_preproc_endregion] = STATE(1192),
    [sym_preproc_line] = STATE(1192),
    [sym_preproc_pragma] = STATE(1192),
    [sym_preproc_nullable] = STATE(1192),
    [sym_preproc_error] = STATE(1192),
    [sym_preproc_define] = STATE(1192),
    [sym_preproc_undef] = STATE(1192),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1193] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6226),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1193),
    [sym_preproc_endregion] = STATE(1193),
    [sym_preproc_line] = STATE(1193),
    [sym_preproc_pragma] = STATE(1193),
    [sym_preproc_nullable] = STATE(1193),
    [sym_preproc_error] = STATE(1193),
    [sym_preproc_define] = STATE(1193),
    [sym_preproc_undef] = STATE(1193),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1194] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4414),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1194),
    [sym_preproc_endregion] = STATE(1194),
    [sym_preproc_line] = STATE(1194),
    [sym_preproc_pragma] = STATE(1194),
    [sym_preproc_nullable] = STATE(1194),
    [sym_preproc_error] = STATE(1194),
    [sym_preproc_define] = STATE(1194),
    [sym_preproc_undef] = STATE(1194),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1195] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5492),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1195),
    [sym_preproc_endregion] = STATE(1195),
    [sym_preproc_line] = STATE(1195),
    [sym_preproc_pragma] = STATE(1195),
    [sym_preproc_nullable] = STATE(1195),
    [sym_preproc_error] = STATE(1195),
    [sym_preproc_define] = STATE(1195),
    [sym_preproc_undef] = STATE(1195),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1196] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6301),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1196),
    [sym_preproc_endregion] = STATE(1196),
    [sym_preproc_line] = STATE(1196),
    [sym_preproc_pragma] = STATE(1196),
    [sym_preproc_nullable] = STATE(1196),
    [sym_preproc_error] = STATE(1196),
    [sym_preproc_define] = STATE(1196),
    [sym_preproc_undef] = STATE(1196),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1197] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4407),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1197),
    [sym_preproc_endregion] = STATE(1197),
    [sym_preproc_line] = STATE(1197),
    [sym_preproc_pragma] = STATE(1197),
    [sym_preproc_nullable] = STATE(1197),
    [sym_preproc_error] = STATE(1197),
    [sym_preproc_define] = STATE(1197),
    [sym_preproc_undef] = STATE(1197),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1198] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6651),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1198),
    [sym_preproc_endregion] = STATE(1198),
    [sym_preproc_line] = STATE(1198),
    [sym_preproc_pragma] = STATE(1198),
    [sym_preproc_nullable] = STATE(1198),
    [sym_preproc_error] = STATE(1198),
    [sym_preproc_define] = STATE(1198),
    [sym_preproc_undef] = STATE(1198),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1199] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6255),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1199),
    [sym_preproc_endregion] = STATE(1199),
    [sym_preproc_line] = STATE(1199),
    [sym_preproc_pragma] = STATE(1199),
    [sym_preproc_nullable] = STATE(1199),
    [sym_preproc_error] = STATE(1199),
    [sym_preproc_define] = STATE(1199),
    [sym_preproc_undef] = STATE(1199),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1200] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6122),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1200),
    [sym_preproc_endregion] = STATE(1200),
    [sym_preproc_line] = STATE(1200),
    [sym_preproc_pragma] = STATE(1200),
    [sym_preproc_nullable] = STATE(1200),
    [sym_preproc_error] = STATE(1200),
    [sym_preproc_define] = STATE(1200),
    [sym_preproc_undef] = STATE(1200),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1201] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4377),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1201),
    [sym_preproc_endregion] = STATE(1201),
    [sym_preproc_line] = STATE(1201),
    [sym_preproc_pragma] = STATE(1201),
    [sym_preproc_nullable] = STATE(1201),
    [sym_preproc_error] = STATE(1201),
    [sym_preproc_define] = STATE(1201),
    [sym_preproc_undef] = STATE(1201),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1202] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4434),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1202),
    [sym_preproc_endregion] = STATE(1202),
    [sym_preproc_line] = STATE(1202),
    [sym_preproc_pragma] = STATE(1202),
    [sym_preproc_nullable] = STATE(1202),
    [sym_preproc_error] = STATE(1202),
    [sym_preproc_define] = STATE(1202),
    [sym_preproc_undef] = STATE(1202),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1203] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4413),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1203),
    [sym_preproc_endregion] = STATE(1203),
    [sym_preproc_line] = STATE(1203),
    [sym_preproc_pragma] = STATE(1203),
    [sym_preproc_nullable] = STATE(1203),
    [sym_preproc_error] = STATE(1203),
    [sym_preproc_define] = STATE(1203),
    [sym_preproc_undef] = STATE(1203),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1204] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5868),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1204),
    [sym_preproc_endregion] = STATE(1204),
    [sym_preproc_line] = STATE(1204),
    [sym_preproc_pragma] = STATE(1204),
    [sym_preproc_nullable] = STATE(1204),
    [sym_preproc_error] = STATE(1204),
    [sym_preproc_define] = STATE(1204),
    [sym_preproc_undef] = STATE(1204),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1205] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4365),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1205),
    [sym_preproc_endregion] = STATE(1205),
    [sym_preproc_line] = STATE(1205),
    [sym_preproc_pragma] = STATE(1205),
    [sym_preproc_nullable] = STATE(1205),
    [sym_preproc_error] = STATE(1205),
    [sym_preproc_define] = STATE(1205),
    [sym_preproc_undef] = STATE(1205),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1206] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5427),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1206),
    [sym_preproc_endregion] = STATE(1206),
    [sym_preproc_line] = STATE(1206),
    [sym_preproc_pragma] = STATE(1206),
    [sym_preproc_nullable] = STATE(1206),
    [sym_preproc_error] = STATE(1206),
    [sym_preproc_define] = STATE(1206),
    [sym_preproc_undef] = STATE(1206),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1207] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6120),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1207),
    [sym_preproc_endregion] = STATE(1207),
    [sym_preproc_line] = STATE(1207),
    [sym_preproc_pragma] = STATE(1207),
    [sym_preproc_nullable] = STATE(1207),
    [sym_preproc_error] = STATE(1207),
    [sym_preproc_define] = STATE(1207),
    [sym_preproc_undef] = STATE(1207),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1208] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5425),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1208),
    [sym_preproc_endregion] = STATE(1208),
    [sym_preproc_line] = STATE(1208),
    [sym_preproc_pragma] = STATE(1208),
    [sym_preproc_nullable] = STATE(1208),
    [sym_preproc_error] = STATE(1208),
    [sym_preproc_define] = STATE(1208),
    [sym_preproc_undef] = STATE(1208),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1209] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6244),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1209),
    [sym_preproc_endregion] = STATE(1209),
    [sym_preproc_line] = STATE(1209),
    [sym_preproc_pragma] = STATE(1209),
    [sym_preproc_nullable] = STATE(1209),
    [sym_preproc_error] = STATE(1209),
    [sym_preproc_define] = STATE(1209),
    [sym_preproc_undef] = STATE(1209),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1210] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6243),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1210),
    [sym_preproc_endregion] = STATE(1210),
    [sym_preproc_line] = STATE(1210),
    [sym_preproc_pragma] = STATE(1210),
    [sym_preproc_nullable] = STATE(1210),
    [sym_preproc_error] = STATE(1210),
    [sym_preproc_define] = STATE(1210),
    [sym_preproc_undef] = STATE(1210),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1211] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6242),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1211),
    [sym_preproc_endregion] = STATE(1211),
    [sym_preproc_line] = STATE(1211),
    [sym_preproc_pragma] = STATE(1211),
    [sym_preproc_nullable] = STATE(1211),
    [sym_preproc_error] = STATE(1211),
    [sym_preproc_define] = STATE(1211),
    [sym_preproc_undef] = STATE(1211),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1212] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6241),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1212),
    [sym_preproc_endregion] = STATE(1212),
    [sym_preproc_line] = STATE(1212),
    [sym_preproc_pragma] = STATE(1212),
    [sym_preproc_nullable] = STATE(1212),
    [sym_preproc_error] = STATE(1212),
    [sym_preproc_define] = STATE(1212),
    [sym_preproc_undef] = STATE(1212),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1213] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6240),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1213),
    [sym_preproc_endregion] = STATE(1213),
    [sym_preproc_line] = STATE(1213),
    [sym_preproc_pragma] = STATE(1213),
    [sym_preproc_nullable] = STATE(1213),
    [sym_preproc_error] = STATE(1213),
    [sym_preproc_define] = STATE(1213),
    [sym_preproc_undef] = STATE(1213),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1214] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6239),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1214),
    [sym_preproc_endregion] = STATE(1214),
    [sym_preproc_line] = STATE(1214),
    [sym_preproc_pragma] = STATE(1214),
    [sym_preproc_nullable] = STATE(1214),
    [sym_preproc_error] = STATE(1214),
    [sym_preproc_define] = STATE(1214),
    [sym_preproc_undef] = STATE(1214),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1215] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6237),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1215),
    [sym_preproc_endregion] = STATE(1215),
    [sym_preproc_line] = STATE(1215),
    [sym_preproc_pragma] = STATE(1215),
    [sym_preproc_nullable] = STATE(1215),
    [sym_preproc_error] = STATE(1215),
    [sym_preproc_define] = STATE(1215),
    [sym_preproc_undef] = STATE(1215),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1216] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6236),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1216),
    [sym_preproc_endregion] = STATE(1216),
    [sym_preproc_line] = STATE(1216),
    [sym_preproc_pragma] = STATE(1216),
    [sym_preproc_nullable] = STATE(1216),
    [sym_preproc_error] = STATE(1216),
    [sym_preproc_define] = STATE(1216),
    [sym_preproc_undef] = STATE(1216),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1217] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6235),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1217),
    [sym_preproc_endregion] = STATE(1217),
    [sym_preproc_line] = STATE(1217),
    [sym_preproc_pragma] = STATE(1217),
    [sym_preproc_nullable] = STATE(1217),
    [sym_preproc_error] = STATE(1217),
    [sym_preproc_define] = STATE(1217),
    [sym_preproc_undef] = STATE(1217),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1218] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5109),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1218),
    [sym_preproc_endregion] = STATE(1218),
    [sym_preproc_line] = STATE(1218),
    [sym_preproc_pragma] = STATE(1218),
    [sym_preproc_nullable] = STATE(1218),
    [sym_preproc_error] = STATE(1218),
    [sym_preproc_define] = STATE(1218),
    [sym_preproc_undef] = STATE(1218),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1219] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6180),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1219),
    [sym_preproc_endregion] = STATE(1219),
    [sym_preproc_line] = STATE(1219),
    [sym_preproc_pragma] = STATE(1219),
    [sym_preproc_nullable] = STATE(1219),
    [sym_preproc_error] = STATE(1219),
    [sym_preproc_define] = STATE(1219),
    [sym_preproc_undef] = STATE(1219),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1220] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6616),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1220),
    [sym_preproc_endregion] = STATE(1220),
    [sym_preproc_line] = STATE(1220),
    [sym_preproc_pragma] = STATE(1220),
    [sym_preproc_nullable] = STATE(1220),
    [sym_preproc_error] = STATE(1220),
    [sym_preproc_define] = STATE(1220),
    [sym_preproc_undef] = STATE(1220),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1221] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1221),
    [sym_preproc_endregion] = STATE(1221),
    [sym_preproc_line] = STATE(1221),
    [sym_preproc_pragma] = STATE(1221),
    [sym_preproc_nullable] = STATE(1221),
    [sym_preproc_error] = STATE(1221),
    [sym_preproc_define] = STATE(1221),
    [sym_preproc_undef] = STATE(1221),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1222] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4367),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1222),
    [sym_preproc_endregion] = STATE(1222),
    [sym_preproc_line] = STATE(1222),
    [sym_preproc_pragma] = STATE(1222),
    [sym_preproc_nullable] = STATE(1222),
    [sym_preproc_error] = STATE(1222),
    [sym_preproc_define] = STATE(1222),
    [sym_preproc_undef] = STATE(1222),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1223] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5876),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1223),
    [sym_preproc_endregion] = STATE(1223),
    [sym_preproc_line] = STATE(1223),
    [sym_preproc_pragma] = STATE(1223),
    [sym_preproc_nullable] = STATE(1223),
    [sym_preproc_error] = STATE(1223),
    [sym_preproc_define] = STATE(1223),
    [sym_preproc_undef] = STATE(1223),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1224] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5406),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1224),
    [sym_preproc_endregion] = STATE(1224),
    [sym_preproc_line] = STATE(1224),
    [sym_preproc_pragma] = STATE(1224),
    [sym_preproc_nullable] = STATE(1224),
    [sym_preproc_error] = STATE(1224),
    [sym_preproc_define] = STATE(1224),
    [sym_preproc_undef] = STATE(1224),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1225] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6233),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1225),
    [sym_preproc_endregion] = STATE(1225),
    [sym_preproc_line] = STATE(1225),
    [sym_preproc_pragma] = STATE(1225),
    [sym_preproc_nullable] = STATE(1225),
    [sym_preproc_error] = STATE(1225),
    [sym_preproc_define] = STATE(1225),
    [sym_preproc_undef] = STATE(1225),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1226] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5403),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1226),
    [sym_preproc_endregion] = STATE(1226),
    [sym_preproc_line] = STATE(1226),
    [sym_preproc_pragma] = STATE(1226),
    [sym_preproc_nullable] = STATE(1226),
    [sym_preproc_error] = STATE(1226),
    [sym_preproc_define] = STATE(1226),
    [sym_preproc_undef] = STATE(1226),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1227] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5401),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1227),
    [sym_preproc_endregion] = STATE(1227),
    [sym_preproc_line] = STATE(1227),
    [sym_preproc_pragma] = STATE(1227),
    [sym_preproc_nullable] = STATE(1227),
    [sym_preproc_error] = STATE(1227),
    [sym_preproc_define] = STATE(1227),
    [sym_preproc_undef] = STATE(1227),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1228] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6229),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1228),
    [sym_preproc_endregion] = STATE(1228),
    [sym_preproc_line] = STATE(1228),
    [sym_preproc_pragma] = STATE(1228),
    [sym_preproc_nullable] = STATE(1228),
    [sym_preproc_error] = STATE(1228),
    [sym_preproc_define] = STATE(1228),
    [sym_preproc_undef] = STATE(1228),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1229] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1229),
    [sym_preproc_endregion] = STATE(1229),
    [sym_preproc_line] = STATE(1229),
    [sym_preproc_pragma] = STATE(1229),
    [sym_preproc_nullable] = STATE(1229),
    [sym_preproc_error] = STATE(1229),
    [sym_preproc_define] = STATE(1229),
    [sym_preproc_undef] = STATE(1229),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1230] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4369),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1230),
    [sym_preproc_endregion] = STATE(1230),
    [sym_preproc_line] = STATE(1230),
    [sym_preproc_pragma] = STATE(1230),
    [sym_preproc_nullable] = STATE(1230),
    [sym_preproc_error] = STATE(1230),
    [sym_preproc_define] = STATE(1230),
    [sym_preproc_undef] = STATE(1230),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1231] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5400),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1231),
    [sym_preproc_endregion] = STATE(1231),
    [sym_preproc_line] = STATE(1231),
    [sym_preproc_pragma] = STATE(1231),
    [sym_preproc_nullable] = STATE(1231),
    [sym_preproc_error] = STATE(1231),
    [sym_preproc_define] = STATE(1231),
    [sym_preproc_undef] = STATE(1231),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1232] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4788),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1232),
    [sym_preproc_endregion] = STATE(1232),
    [sym_preproc_line] = STATE(1232),
    [sym_preproc_pragma] = STATE(1232),
    [sym_preproc_nullable] = STATE(1232),
    [sym_preproc_error] = STATE(1232),
    [sym_preproc_define] = STATE(1232),
    [sym_preproc_undef] = STATE(1232),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1233] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5257),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1233),
    [sym_preproc_endregion] = STATE(1233),
    [sym_preproc_line] = STATE(1233),
    [sym_preproc_pragma] = STATE(1233),
    [sym_preproc_nullable] = STATE(1233),
    [sym_preproc_error] = STATE(1233),
    [sym_preproc_define] = STATE(1233),
    [sym_preproc_undef] = STATE(1233),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1234] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5277),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1234),
    [sym_preproc_endregion] = STATE(1234),
    [sym_preproc_line] = STATE(1234),
    [sym_preproc_pragma] = STATE(1234),
    [sym_preproc_nullable] = STATE(1234),
    [sym_preproc_error] = STATE(1234),
    [sym_preproc_define] = STATE(1234),
    [sym_preproc_undef] = STATE(1234),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1235] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5398),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1235),
    [sym_preproc_endregion] = STATE(1235),
    [sym_preproc_line] = STATE(1235),
    [sym_preproc_pragma] = STATE(1235),
    [sym_preproc_nullable] = STATE(1235),
    [sym_preproc_error] = STATE(1235),
    [sym_preproc_define] = STATE(1235),
    [sym_preproc_undef] = STATE(1235),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1236] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5397),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1236),
    [sym_preproc_endregion] = STATE(1236),
    [sym_preproc_line] = STATE(1236),
    [sym_preproc_pragma] = STATE(1236),
    [sym_preproc_nullable] = STATE(1236),
    [sym_preproc_error] = STATE(1236),
    [sym_preproc_define] = STATE(1236),
    [sym_preproc_undef] = STATE(1236),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1237] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5256),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1237),
    [sym_preproc_endregion] = STATE(1237),
    [sym_preproc_line] = STATE(1237),
    [sym_preproc_pragma] = STATE(1237),
    [sym_preproc_nullable] = STATE(1237),
    [sym_preproc_error] = STATE(1237),
    [sym_preproc_define] = STATE(1237),
    [sym_preproc_undef] = STATE(1237),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1238] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6639),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1238),
    [sym_preproc_endregion] = STATE(1238),
    [sym_preproc_line] = STATE(1238),
    [sym_preproc_pragma] = STATE(1238),
    [sym_preproc_nullable] = STATE(1238),
    [sym_preproc_error] = STATE(1238),
    [sym_preproc_define] = STATE(1238),
    [sym_preproc_undef] = STATE(1238),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1239] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5296),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1239),
    [sym_preproc_endregion] = STATE(1239),
    [sym_preproc_line] = STATE(1239),
    [sym_preproc_pragma] = STATE(1239),
    [sym_preproc_nullable] = STATE(1239),
    [sym_preproc_error] = STATE(1239),
    [sym_preproc_define] = STATE(1239),
    [sym_preproc_undef] = STATE(1239),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1240] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5303),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1240),
    [sym_preproc_endregion] = STATE(1240),
    [sym_preproc_line] = STATE(1240),
    [sym_preproc_pragma] = STATE(1240),
    [sym_preproc_nullable] = STATE(1240),
    [sym_preproc_error] = STATE(1240),
    [sym_preproc_define] = STATE(1240),
    [sym_preproc_undef] = STATE(1240),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1241] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5211),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1241),
    [sym_preproc_endregion] = STATE(1241),
    [sym_preproc_line] = STATE(1241),
    [sym_preproc_pragma] = STATE(1241),
    [sym_preproc_nullable] = STATE(1241),
    [sym_preproc_error] = STATE(1241),
    [sym_preproc_define] = STATE(1241),
    [sym_preproc_undef] = STATE(1241),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1242] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5453),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1242),
    [sym_preproc_endregion] = STATE(1242),
    [sym_preproc_line] = STATE(1242),
    [sym_preproc_pragma] = STATE(1242),
    [sym_preproc_nullable] = STATE(1242),
    [sym_preproc_error] = STATE(1242),
    [sym_preproc_define] = STATE(1242),
    [sym_preproc_undef] = STATE(1242),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1243] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1243),
    [sym_preproc_endregion] = STATE(1243),
    [sym_preproc_line] = STATE(1243),
    [sym_preproc_pragma] = STATE(1243),
    [sym_preproc_nullable] = STATE(1243),
    [sym_preproc_error] = STATE(1243),
    [sym_preproc_define] = STATE(1243),
    [sym_preproc_undef] = STATE(1243),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1244] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5794),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1244),
    [sym_preproc_endregion] = STATE(1244),
    [sym_preproc_line] = STATE(1244),
    [sym_preproc_pragma] = STATE(1244),
    [sym_preproc_nullable] = STATE(1244),
    [sym_preproc_error] = STATE(1244),
    [sym_preproc_define] = STATE(1244),
    [sym_preproc_undef] = STATE(1244),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1245] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4374),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1245),
    [sym_preproc_endregion] = STATE(1245),
    [sym_preproc_line] = STATE(1245),
    [sym_preproc_pragma] = STATE(1245),
    [sym_preproc_nullable] = STATE(1245),
    [sym_preproc_error] = STATE(1245),
    [sym_preproc_define] = STATE(1245),
    [sym_preproc_undef] = STATE(1245),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1246] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1246),
    [sym_preproc_endregion] = STATE(1246),
    [sym_preproc_line] = STATE(1246),
    [sym_preproc_pragma] = STATE(1246),
    [sym_preproc_nullable] = STATE(1246),
    [sym_preproc_error] = STATE(1246),
    [sym_preproc_define] = STATE(1246),
    [sym_preproc_undef] = STATE(1246),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1247] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5886),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1247),
    [sym_preproc_endregion] = STATE(1247),
    [sym_preproc_line] = STATE(1247),
    [sym_preproc_pragma] = STATE(1247),
    [sym_preproc_nullable] = STATE(1247),
    [sym_preproc_error] = STATE(1247),
    [sym_preproc_define] = STATE(1247),
    [sym_preproc_undef] = STATE(1247),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1248] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5821),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1248),
    [sym_preproc_endregion] = STATE(1248),
    [sym_preproc_line] = STATE(1248),
    [sym_preproc_pragma] = STATE(1248),
    [sym_preproc_nullable] = STATE(1248),
    [sym_preproc_error] = STATE(1248),
    [sym_preproc_define] = STATE(1248),
    [sym_preproc_undef] = STATE(1248),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1249] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1249),
    [sym_preproc_endregion] = STATE(1249),
    [sym_preproc_line] = STATE(1249),
    [sym_preproc_pragma] = STATE(1249),
    [sym_preproc_nullable] = STATE(1249),
    [sym_preproc_error] = STATE(1249),
    [sym_preproc_define] = STATE(1249),
    [sym_preproc_undef] = STATE(1249),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1250] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5455),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1250),
    [sym_preproc_endregion] = STATE(1250),
    [sym_preproc_line] = STATE(1250),
    [sym_preproc_pragma] = STATE(1250),
    [sym_preproc_nullable] = STATE(1250),
    [sym_preproc_error] = STATE(1250),
    [sym_preproc_define] = STATE(1250),
    [sym_preproc_undef] = STATE(1250),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1251] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6119),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1251),
    [sym_preproc_endregion] = STATE(1251),
    [sym_preproc_line] = STATE(1251),
    [sym_preproc_pragma] = STATE(1251),
    [sym_preproc_nullable] = STATE(1251),
    [sym_preproc_error] = STATE(1251),
    [sym_preproc_define] = STATE(1251),
    [sym_preproc_undef] = STATE(1251),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1252] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4430),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1252),
    [sym_preproc_endregion] = STATE(1252),
    [sym_preproc_line] = STATE(1252),
    [sym_preproc_pragma] = STATE(1252),
    [sym_preproc_nullable] = STATE(1252),
    [sym_preproc_error] = STATE(1252),
    [sym_preproc_define] = STATE(1252),
    [sym_preproc_undef] = STATE(1252),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1253] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5126),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1253),
    [sym_preproc_endregion] = STATE(1253),
    [sym_preproc_line] = STATE(1253),
    [sym_preproc_pragma] = STATE(1253),
    [sym_preproc_nullable] = STATE(1253),
    [sym_preproc_error] = STATE(1253),
    [sym_preproc_define] = STATE(1253),
    [sym_preproc_undef] = STATE(1253),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1254] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5622),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1254),
    [sym_preproc_endregion] = STATE(1254),
    [sym_preproc_line] = STATE(1254),
    [sym_preproc_pragma] = STATE(1254),
    [sym_preproc_nullable] = STATE(1254),
    [sym_preproc_error] = STATE(1254),
    [sym_preproc_define] = STATE(1254),
    [sym_preproc_undef] = STATE(1254),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1255] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6648),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1255),
    [sym_preproc_endregion] = STATE(1255),
    [sym_preproc_line] = STATE(1255),
    [sym_preproc_pragma] = STATE(1255),
    [sym_preproc_nullable] = STATE(1255),
    [sym_preproc_error] = STATE(1255),
    [sym_preproc_define] = STATE(1255),
    [sym_preproc_undef] = STATE(1255),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1256] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5288),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1256),
    [sym_preproc_endregion] = STATE(1256),
    [sym_preproc_line] = STATE(1256),
    [sym_preproc_pragma] = STATE(1256),
    [sym_preproc_nullable] = STATE(1256),
    [sym_preproc_error] = STATE(1256),
    [sym_preproc_define] = STATE(1256),
    [sym_preproc_undef] = STATE(1256),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1257] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6647),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1257),
    [sym_preproc_endregion] = STATE(1257),
    [sym_preproc_line] = STATE(1257),
    [sym_preproc_pragma] = STATE(1257),
    [sym_preproc_nullable] = STATE(1257),
    [sym_preproc_error] = STATE(1257),
    [sym_preproc_define] = STATE(1257),
    [sym_preproc_undef] = STATE(1257),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1258] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5097),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1258),
    [sym_preproc_endregion] = STATE(1258),
    [sym_preproc_line] = STATE(1258),
    [sym_preproc_pragma] = STATE(1258),
    [sym_preproc_nullable] = STATE(1258),
    [sym_preproc_error] = STATE(1258),
    [sym_preproc_define] = STATE(1258),
    [sym_preproc_undef] = STATE(1258),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1259] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5812),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1259),
    [sym_preproc_endregion] = STATE(1259),
    [sym_preproc_line] = STATE(1259),
    [sym_preproc_pragma] = STATE(1259),
    [sym_preproc_nullable] = STATE(1259),
    [sym_preproc_error] = STATE(1259),
    [sym_preproc_define] = STATE(1259),
    [sym_preproc_undef] = STATE(1259),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1260] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5621),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1260),
    [sym_preproc_endregion] = STATE(1260),
    [sym_preproc_line] = STATE(1260),
    [sym_preproc_pragma] = STATE(1260),
    [sym_preproc_nullable] = STATE(1260),
    [sym_preproc_error] = STATE(1260),
    [sym_preproc_define] = STATE(1260),
    [sym_preproc_undef] = STATE(1260),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1261] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5212),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1261),
    [sym_preproc_endregion] = STATE(1261),
    [sym_preproc_line] = STATE(1261),
    [sym_preproc_pragma] = STATE(1261),
    [sym_preproc_nullable] = STATE(1261),
    [sym_preproc_error] = STATE(1261),
    [sym_preproc_define] = STATE(1261),
    [sym_preproc_undef] = STATE(1261),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1262] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5293),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1262),
    [sym_preproc_endregion] = STATE(1262),
    [sym_preproc_line] = STATE(1262),
    [sym_preproc_pragma] = STATE(1262),
    [sym_preproc_nullable] = STATE(1262),
    [sym_preproc_error] = STATE(1262),
    [sym_preproc_define] = STATE(1262),
    [sym_preproc_undef] = STATE(1262),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1263] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5620),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1263),
    [sym_preproc_endregion] = STATE(1263),
    [sym_preproc_line] = STATE(1263),
    [sym_preproc_pragma] = STATE(1263),
    [sym_preproc_nullable] = STATE(1263),
    [sym_preproc_error] = STATE(1263),
    [sym_preproc_define] = STATE(1263),
    [sym_preproc_undef] = STATE(1263),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1264] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5618),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1264),
    [sym_preproc_endregion] = STATE(1264),
    [sym_preproc_line] = STATE(1264),
    [sym_preproc_pragma] = STATE(1264),
    [sym_preproc_nullable] = STATE(1264),
    [sym_preproc_error] = STATE(1264),
    [sym_preproc_define] = STATE(1264),
    [sym_preproc_undef] = STATE(1264),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1265] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1265),
    [sym_preproc_endregion] = STATE(1265),
    [sym_preproc_line] = STATE(1265),
    [sym_preproc_pragma] = STATE(1265),
    [sym_preproc_nullable] = STATE(1265),
    [sym_preproc_error] = STATE(1265),
    [sym_preproc_define] = STATE(1265),
    [sym_preproc_undef] = STATE(1265),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1266] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5828),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1266),
    [sym_preproc_endregion] = STATE(1266),
    [sym_preproc_line] = STATE(1266),
    [sym_preproc_pragma] = STATE(1266),
    [sym_preproc_nullable] = STATE(1266),
    [sym_preproc_error] = STATE(1266),
    [sym_preproc_define] = STATE(1266),
    [sym_preproc_undef] = STATE(1266),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1267] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1267),
    [sym_preproc_endregion] = STATE(1267),
    [sym_preproc_line] = STATE(1267),
    [sym_preproc_pragma] = STATE(1267),
    [sym_preproc_nullable] = STATE(1267),
    [sym_preproc_error] = STATE(1267),
    [sym_preproc_define] = STATE(1267),
    [sym_preproc_undef] = STATE(1267),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1268] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5308),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1268),
    [sym_preproc_endregion] = STATE(1268),
    [sym_preproc_line] = STATE(1268),
    [sym_preproc_pragma] = STATE(1268),
    [sym_preproc_nullable] = STATE(1268),
    [sym_preproc_error] = STATE(1268),
    [sym_preproc_define] = STATE(1268),
    [sym_preproc_undef] = STATE(1268),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1269] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5460),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1269),
    [sym_preproc_endregion] = STATE(1269),
    [sym_preproc_line] = STATE(1269),
    [sym_preproc_pragma] = STATE(1269),
    [sym_preproc_nullable] = STATE(1269),
    [sym_preproc_error] = STATE(1269),
    [sym_preproc_define] = STATE(1269),
    [sym_preproc_undef] = STATE(1269),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1270] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5216),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1270),
    [sym_preproc_endregion] = STATE(1270),
    [sym_preproc_line] = STATE(1270),
    [sym_preproc_pragma] = STATE(1270),
    [sym_preproc_nullable] = STATE(1270),
    [sym_preproc_error] = STATE(1270),
    [sym_preproc_define] = STATE(1270),
    [sym_preproc_undef] = STATE(1270),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1271] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6941),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6679),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1271),
    [sym_preproc_endregion] = STATE(1271),
    [sym_preproc_line] = STATE(1271),
    [sym_preproc_pragma] = STATE(1271),
    [sym_preproc_nullable] = STATE(1271),
    [sym_preproc_error] = STATE(1271),
    [sym_preproc_define] = STATE(1271),
    [sym_preproc_undef] = STATE(1271),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1272] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1272),
    [sym_preproc_endregion] = STATE(1272),
    [sym_preproc_line] = STATE(1272),
    [sym_preproc_pragma] = STATE(1272),
    [sym_preproc_nullable] = STATE(1272),
    [sym_preproc_error] = STATE(1272),
    [sym_preproc_define] = STATE(1272),
    [sym_preproc_undef] = STATE(1272),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1273] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6483),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1273),
    [sym_preproc_endregion] = STATE(1273),
    [sym_preproc_line] = STATE(1273),
    [sym_preproc_pragma] = STATE(1273),
    [sym_preproc_nullable] = STATE(1273),
    [sym_preproc_error] = STATE(1273),
    [sym_preproc_define] = STATE(1273),
    [sym_preproc_undef] = STATE(1273),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1274] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5488),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1274),
    [sym_preproc_endregion] = STATE(1274),
    [sym_preproc_line] = STATE(1274),
    [sym_preproc_pragma] = STATE(1274),
    [sym_preproc_nullable] = STATE(1274),
    [sym_preproc_error] = STATE(1274),
    [sym_preproc_define] = STATE(1274),
    [sym_preproc_undef] = STATE(1274),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1275] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6646),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1275),
    [sym_preproc_endregion] = STATE(1275),
    [sym_preproc_line] = STATE(1275),
    [sym_preproc_pragma] = STATE(1275),
    [sym_preproc_nullable] = STATE(1275),
    [sym_preproc_error] = STATE(1275),
    [sym_preproc_define] = STATE(1275),
    [sym_preproc_undef] = STATE(1275),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1276] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5424),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1276),
    [sym_preproc_endregion] = STATE(1276),
    [sym_preproc_line] = STATE(1276),
    [sym_preproc_pragma] = STATE(1276),
    [sym_preproc_nullable] = STATE(1276),
    [sym_preproc_error] = STATE(1276),
    [sym_preproc_define] = STATE(1276),
    [sym_preproc_undef] = STATE(1276),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1277] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5207),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1277),
    [sym_preproc_endregion] = STATE(1277),
    [sym_preproc_line] = STATE(1277),
    [sym_preproc_pragma] = STATE(1277),
    [sym_preproc_nullable] = STATE(1277),
    [sym_preproc_error] = STATE(1277),
    [sym_preproc_define] = STATE(1277),
    [sym_preproc_undef] = STATE(1277),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1278] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5738),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1278),
    [sym_preproc_endregion] = STATE(1278),
    [sym_preproc_line] = STATE(1278),
    [sym_preproc_pragma] = STATE(1278),
    [sym_preproc_nullable] = STATE(1278),
    [sym_preproc_error] = STATE(1278),
    [sym_preproc_define] = STATE(1278),
    [sym_preproc_undef] = STATE(1278),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1279] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4430),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1279),
    [sym_preproc_endregion] = STATE(1279),
    [sym_preproc_line] = STATE(1279),
    [sym_preproc_pragma] = STATE(1279),
    [sym_preproc_nullable] = STATE(1279),
    [sym_preproc_error] = STATE(1279),
    [sym_preproc_define] = STATE(1279),
    [sym_preproc_undef] = STATE(1279),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1280] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4536),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1280),
    [sym_preproc_endregion] = STATE(1280),
    [sym_preproc_line] = STATE(1280),
    [sym_preproc_pragma] = STATE(1280),
    [sym_preproc_nullable] = STATE(1280),
    [sym_preproc_error] = STATE(1280),
    [sym_preproc_define] = STATE(1280),
    [sym_preproc_undef] = STATE(1280),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1281] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6636),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1281),
    [sym_preproc_endregion] = STATE(1281),
    [sym_preproc_line] = STATE(1281),
    [sym_preproc_pragma] = STATE(1281),
    [sym_preproc_nullable] = STATE(1281),
    [sym_preproc_error] = STATE(1281),
    [sym_preproc_define] = STATE(1281),
    [sym_preproc_undef] = STATE(1281),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1282] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1282),
    [sym_preproc_endregion] = STATE(1282),
    [sym_preproc_line] = STATE(1282),
    [sym_preproc_pragma] = STATE(1282),
    [sym_preproc_nullable] = STATE(1282),
    [sym_preproc_error] = STATE(1282),
    [sym_preproc_define] = STATE(1282),
    [sym_preproc_undef] = STATE(1282),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1283] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4534),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1283),
    [sym_preproc_endregion] = STATE(1283),
    [sym_preproc_line] = STATE(1283),
    [sym_preproc_pragma] = STATE(1283),
    [sym_preproc_nullable] = STATE(1283),
    [sym_preproc_error] = STATE(1283),
    [sym_preproc_define] = STATE(1283),
    [sym_preproc_undef] = STATE(1283),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1284] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4532),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1284),
    [sym_preproc_endregion] = STATE(1284),
    [sym_preproc_line] = STATE(1284),
    [sym_preproc_pragma] = STATE(1284),
    [sym_preproc_nullable] = STATE(1284),
    [sym_preproc_error] = STATE(1284),
    [sym_preproc_define] = STATE(1284),
    [sym_preproc_undef] = STATE(1284),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1285] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4529),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1285),
    [sym_preproc_endregion] = STATE(1285),
    [sym_preproc_line] = STATE(1285),
    [sym_preproc_pragma] = STATE(1285),
    [sym_preproc_nullable] = STATE(1285),
    [sym_preproc_error] = STATE(1285),
    [sym_preproc_define] = STATE(1285),
    [sym_preproc_undef] = STATE(1285),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1286] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4456),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1286),
    [sym_preproc_endregion] = STATE(1286),
    [sym_preproc_line] = STATE(1286),
    [sym_preproc_pragma] = STATE(1286),
    [sym_preproc_nullable] = STATE(1286),
    [sym_preproc_error] = STATE(1286),
    [sym_preproc_define] = STATE(1286),
    [sym_preproc_undef] = STATE(1286),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1287] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4525),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1287),
    [sym_preproc_endregion] = STATE(1287),
    [sym_preproc_line] = STATE(1287),
    [sym_preproc_pragma] = STATE(1287),
    [sym_preproc_nullable] = STATE(1287),
    [sym_preproc_error] = STATE(1287),
    [sym_preproc_define] = STATE(1287),
    [sym_preproc_undef] = STATE(1287),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1288] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4524),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1288),
    [sym_preproc_endregion] = STATE(1288),
    [sym_preproc_line] = STATE(1288),
    [sym_preproc_pragma] = STATE(1288),
    [sym_preproc_nullable] = STATE(1288),
    [sym_preproc_error] = STATE(1288),
    [sym_preproc_define] = STATE(1288),
    [sym_preproc_undef] = STATE(1288),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1289] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4521),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1289),
    [sym_preproc_endregion] = STATE(1289),
    [sym_preproc_line] = STATE(1289),
    [sym_preproc_pragma] = STATE(1289),
    [sym_preproc_nullable] = STATE(1289),
    [sym_preproc_error] = STATE(1289),
    [sym_preproc_define] = STATE(1289),
    [sym_preproc_undef] = STATE(1289),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1290] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4455),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1290),
    [sym_preproc_endregion] = STATE(1290),
    [sym_preproc_line] = STATE(1290),
    [sym_preproc_pragma] = STATE(1290),
    [sym_preproc_nullable] = STATE(1290),
    [sym_preproc_error] = STATE(1290),
    [sym_preproc_define] = STATE(1290),
    [sym_preproc_undef] = STATE(1290),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1291] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4461),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1291),
    [sym_preproc_endregion] = STATE(1291),
    [sym_preproc_line] = STATE(1291),
    [sym_preproc_pragma] = STATE(1291),
    [sym_preproc_nullable] = STATE(1291),
    [sym_preproc_error] = STATE(1291),
    [sym_preproc_define] = STATE(1291),
    [sym_preproc_undef] = STATE(1291),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1292] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4462),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1292),
    [sym_preproc_endregion] = STATE(1292),
    [sym_preproc_line] = STATE(1292),
    [sym_preproc_pragma] = STATE(1292),
    [sym_preproc_nullable] = STATE(1292),
    [sym_preproc_error] = STATE(1292),
    [sym_preproc_define] = STATE(1292),
    [sym_preproc_undef] = STATE(1292),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1293] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1293),
    [sym_preproc_endregion] = STATE(1293),
    [sym_preproc_line] = STATE(1293),
    [sym_preproc_pragma] = STATE(1293),
    [sym_preproc_nullable] = STATE(1293),
    [sym_preproc_error] = STATE(1293),
    [sym_preproc_define] = STATE(1293),
    [sym_preproc_undef] = STATE(1293),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1294] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5727),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1294),
    [sym_preproc_endregion] = STATE(1294),
    [sym_preproc_line] = STATE(1294),
    [sym_preproc_pragma] = STATE(1294),
    [sym_preproc_nullable] = STATE(1294),
    [sym_preproc_error] = STATE(1294),
    [sym_preproc_define] = STATE(1294),
    [sym_preproc_undef] = STATE(1294),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1295] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5281),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1295),
    [sym_preproc_endregion] = STATE(1295),
    [sym_preproc_line] = STATE(1295),
    [sym_preproc_pragma] = STATE(1295),
    [sym_preproc_nullable] = STATE(1295),
    [sym_preproc_error] = STATE(1295),
    [sym_preproc_define] = STATE(1295),
    [sym_preproc_undef] = STATE(1295),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1296] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5375),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1296),
    [sym_preproc_endregion] = STATE(1296),
    [sym_preproc_line] = STATE(1296),
    [sym_preproc_pragma] = STATE(1296),
    [sym_preproc_nullable] = STATE(1296),
    [sym_preproc_error] = STATE(1296),
    [sym_preproc_define] = STATE(1296),
    [sym_preproc_undef] = STATE(1296),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1297] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5422),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1297),
    [sym_preproc_endregion] = STATE(1297),
    [sym_preproc_line] = STATE(1297),
    [sym_preproc_pragma] = STATE(1297),
    [sym_preproc_nullable] = STATE(1297),
    [sym_preproc_error] = STATE(1297),
    [sym_preproc_define] = STATE(1297),
    [sym_preproc_undef] = STATE(1297),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1298] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5337),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1298),
    [sym_preproc_endregion] = STATE(1298),
    [sym_preproc_line] = STATE(1298),
    [sym_preproc_pragma] = STATE(1298),
    [sym_preproc_nullable] = STATE(1298),
    [sym_preproc_error] = STATE(1298),
    [sym_preproc_define] = STATE(1298),
    [sym_preproc_undef] = STATE(1298),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1299] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5726),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1299),
    [sym_preproc_endregion] = STATE(1299),
    [sym_preproc_line] = STATE(1299),
    [sym_preproc_pragma] = STATE(1299),
    [sym_preproc_nullable] = STATE(1299),
    [sym_preproc_error] = STATE(1299),
    [sym_preproc_define] = STATE(1299),
    [sym_preproc_undef] = STATE(1299),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1300] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5367),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1300),
    [sym_preproc_endregion] = STATE(1300),
    [sym_preproc_line] = STATE(1300),
    [sym_preproc_pragma] = STATE(1300),
    [sym_preproc_nullable] = STATE(1300),
    [sym_preproc_error] = STATE(1300),
    [sym_preproc_define] = STATE(1300),
    [sym_preproc_undef] = STATE(1300),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1301] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5366),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1301),
    [sym_preproc_endregion] = STATE(1301),
    [sym_preproc_line] = STATE(1301),
    [sym_preproc_pragma] = STATE(1301),
    [sym_preproc_nullable] = STATE(1301),
    [sym_preproc_error] = STATE(1301),
    [sym_preproc_define] = STATE(1301),
    [sym_preproc_undef] = STATE(1301),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1302] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5365),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1302),
    [sym_preproc_endregion] = STATE(1302),
    [sym_preproc_line] = STATE(1302),
    [sym_preproc_pragma] = STATE(1302),
    [sym_preproc_nullable] = STATE(1302),
    [sym_preproc_error] = STATE(1302),
    [sym_preproc_define] = STATE(1302),
    [sym_preproc_undef] = STATE(1302),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1303] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5149),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1303),
    [sym_preproc_endregion] = STATE(1303),
    [sym_preproc_line] = STATE(1303),
    [sym_preproc_pragma] = STATE(1303),
    [sym_preproc_nullable] = STATE(1303),
    [sym_preproc_error] = STATE(1303),
    [sym_preproc_define] = STATE(1303),
    [sym_preproc_undef] = STATE(1303),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1304] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5283),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1304),
    [sym_preproc_endregion] = STATE(1304),
    [sym_preproc_line] = STATE(1304),
    [sym_preproc_pragma] = STATE(1304),
    [sym_preproc_nullable] = STATE(1304),
    [sym_preproc_error] = STATE(1304),
    [sym_preproc_define] = STATE(1304),
    [sym_preproc_undef] = STATE(1304),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1305] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5166),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1305),
    [sym_preproc_endregion] = STATE(1305),
    [sym_preproc_line] = STATE(1305),
    [sym_preproc_pragma] = STATE(1305),
    [sym_preproc_nullable] = STATE(1305),
    [sym_preproc_error] = STATE(1305),
    [sym_preproc_define] = STATE(1305),
    [sym_preproc_undef] = STATE(1305),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1306] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5171),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1306),
    [sym_preproc_endregion] = STATE(1306),
    [sym_preproc_line] = STATE(1306),
    [sym_preproc_pragma] = STATE(1306),
    [sym_preproc_nullable] = STATE(1306),
    [sym_preproc_error] = STATE(1306),
    [sym_preproc_define] = STATE(1306),
    [sym_preproc_undef] = STATE(1306),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1307] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5165),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1307),
    [sym_preproc_endregion] = STATE(1307),
    [sym_preproc_line] = STATE(1307),
    [sym_preproc_pragma] = STATE(1307),
    [sym_preproc_nullable] = STATE(1307),
    [sym_preproc_error] = STATE(1307),
    [sym_preproc_define] = STATE(1307),
    [sym_preproc_undef] = STATE(1307),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1308] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5948),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1308),
    [sym_preproc_endregion] = STATE(1308),
    [sym_preproc_line] = STATE(1308),
    [sym_preproc_pragma] = STATE(1308),
    [sym_preproc_nullable] = STATE(1308),
    [sym_preproc_error] = STATE(1308),
    [sym_preproc_define] = STATE(1308),
    [sym_preproc_undef] = STATE(1308),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1309] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5228),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1309),
    [sym_preproc_endregion] = STATE(1309),
    [sym_preproc_line] = STATE(1309),
    [sym_preproc_pragma] = STATE(1309),
    [sym_preproc_nullable] = STATE(1309),
    [sym_preproc_error] = STATE(1309),
    [sym_preproc_define] = STATE(1309),
    [sym_preproc_undef] = STATE(1309),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1310] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5405),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1310),
    [sym_preproc_endregion] = STATE(1310),
    [sym_preproc_line] = STATE(1310),
    [sym_preproc_pragma] = STATE(1310),
    [sym_preproc_nullable] = STATE(1310),
    [sym_preproc_error] = STATE(1310),
    [sym_preproc_define] = STATE(1310),
    [sym_preproc_undef] = STATE(1310),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1311] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5443),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1311),
    [sym_preproc_endregion] = STATE(1311),
    [sym_preproc_line] = STATE(1311),
    [sym_preproc_pragma] = STATE(1311),
    [sym_preproc_nullable] = STATE(1311),
    [sym_preproc_error] = STATE(1311),
    [sym_preproc_define] = STATE(1311),
    [sym_preproc_undef] = STATE(1311),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1312] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4470),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1312),
    [sym_preproc_endregion] = STATE(1312),
    [sym_preproc_line] = STATE(1312),
    [sym_preproc_pragma] = STATE(1312),
    [sym_preproc_nullable] = STATE(1312),
    [sym_preproc_error] = STATE(1312),
    [sym_preproc_define] = STATE(1312),
    [sym_preproc_undef] = STATE(1312),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1313] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5487),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1313),
    [sym_preproc_endregion] = STATE(1313),
    [sym_preproc_line] = STATE(1313),
    [sym_preproc_pragma] = STATE(1313),
    [sym_preproc_nullable] = STATE(1313),
    [sym_preproc_error] = STATE(1313),
    [sym_preproc_define] = STATE(1313),
    [sym_preproc_undef] = STATE(1313),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1314] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5361),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1314),
    [sym_preproc_endregion] = STATE(1314),
    [sym_preproc_line] = STATE(1314),
    [sym_preproc_pragma] = STATE(1314),
    [sym_preproc_nullable] = STATE(1314),
    [sym_preproc_error] = STATE(1314),
    [sym_preproc_define] = STATE(1314),
    [sym_preproc_undef] = STATE(1314),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1315] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5360),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1315),
    [sym_preproc_endregion] = STATE(1315),
    [sym_preproc_line] = STATE(1315),
    [sym_preproc_pragma] = STATE(1315),
    [sym_preproc_nullable] = STATE(1315),
    [sym_preproc_error] = STATE(1315),
    [sym_preproc_define] = STATE(1315),
    [sym_preproc_undef] = STATE(1315),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1316] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5357),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1316),
    [sym_preproc_endregion] = STATE(1316),
    [sym_preproc_line] = STATE(1316),
    [sym_preproc_pragma] = STATE(1316),
    [sym_preproc_nullable] = STATE(1316),
    [sym_preproc_error] = STATE(1316),
    [sym_preproc_define] = STATE(1316),
    [sym_preproc_undef] = STATE(1316),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1317] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5762),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1317),
    [sym_preproc_endregion] = STATE(1317),
    [sym_preproc_line] = STATE(1317),
    [sym_preproc_pragma] = STATE(1317),
    [sym_preproc_nullable] = STATE(1317),
    [sym_preproc_error] = STATE(1317),
    [sym_preproc_define] = STATE(1317),
    [sym_preproc_undef] = STATE(1317),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1318] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5485),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1318),
    [sym_preproc_endregion] = STATE(1318),
    [sym_preproc_line] = STATE(1318),
    [sym_preproc_pragma] = STATE(1318),
    [sym_preproc_nullable] = STATE(1318),
    [sym_preproc_error] = STATE(1318),
    [sym_preproc_define] = STATE(1318),
    [sym_preproc_undef] = STATE(1318),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1319] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5189),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1319),
    [sym_preproc_endregion] = STATE(1319),
    [sym_preproc_line] = STATE(1319),
    [sym_preproc_pragma] = STATE(1319),
    [sym_preproc_nullable] = STATE(1319),
    [sym_preproc_error] = STATE(1319),
    [sym_preproc_define] = STATE(1319),
    [sym_preproc_undef] = STATE(1319),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1320] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5163),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1320),
    [sym_preproc_endregion] = STATE(1320),
    [sym_preproc_line] = STATE(1320),
    [sym_preproc_pragma] = STATE(1320),
    [sym_preproc_nullable] = STATE(1320),
    [sym_preproc_error] = STATE(1320),
    [sym_preproc_define] = STATE(1320),
    [sym_preproc_undef] = STATE(1320),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1321] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1321),
    [sym_preproc_endregion] = STATE(1321),
    [sym_preproc_line] = STATE(1321),
    [sym_preproc_pragma] = STATE(1321),
    [sym_preproc_nullable] = STATE(1321),
    [sym_preproc_error] = STATE(1321),
    [sym_preproc_define] = STATE(1321),
    [sym_preproc_undef] = STATE(1321),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1322] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5161),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1322),
    [sym_preproc_endregion] = STATE(1322),
    [sym_preproc_line] = STATE(1322),
    [sym_preproc_pragma] = STATE(1322),
    [sym_preproc_nullable] = STATE(1322),
    [sym_preproc_error] = STATE(1322),
    [sym_preproc_define] = STATE(1322),
    [sym_preproc_undef] = STATE(1322),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1323] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5421),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1323),
    [sym_preproc_endregion] = STATE(1323),
    [sym_preproc_line] = STATE(1323),
    [sym_preproc_pragma] = STATE(1323),
    [sym_preproc_nullable] = STATE(1323),
    [sym_preproc_error] = STATE(1323),
    [sym_preproc_define] = STATE(1323),
    [sym_preproc_undef] = STATE(1323),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1324] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5298),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1324),
    [sym_preproc_endregion] = STATE(1324),
    [sym_preproc_line] = STATE(1324),
    [sym_preproc_pragma] = STATE(1324),
    [sym_preproc_nullable] = STATE(1324),
    [sym_preproc_error] = STATE(1324),
    [sym_preproc_define] = STATE(1324),
    [sym_preproc_undef] = STATE(1324),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1325] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5509),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1325),
    [sym_preproc_endregion] = STATE(1325),
    [sym_preproc_line] = STATE(1325),
    [sym_preproc_pragma] = STATE(1325),
    [sym_preproc_nullable] = STATE(1325),
    [sym_preproc_error] = STATE(1325),
    [sym_preproc_define] = STATE(1325),
    [sym_preproc_undef] = STATE(1325),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1326] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5484),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1326),
    [sym_preproc_endregion] = STATE(1326),
    [sym_preproc_line] = STATE(1326),
    [sym_preproc_pragma] = STATE(1326),
    [sym_preproc_nullable] = STATE(1326),
    [sym_preproc_error] = STATE(1326),
    [sym_preproc_define] = STATE(1326),
    [sym_preproc_undef] = STATE(1326),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1327] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5412),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1327),
    [sym_preproc_endregion] = STATE(1327),
    [sym_preproc_line] = STATE(1327),
    [sym_preproc_pragma] = STATE(1327),
    [sym_preproc_nullable] = STATE(1327),
    [sym_preproc_error] = STATE(1327),
    [sym_preproc_define] = STATE(1327),
    [sym_preproc_undef] = STATE(1327),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1328] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5177),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1328),
    [sym_preproc_endregion] = STATE(1328),
    [sym_preproc_line] = STATE(1328),
    [sym_preproc_pragma] = STATE(1328),
    [sym_preproc_nullable] = STATE(1328),
    [sym_preproc_error] = STATE(1328),
    [sym_preproc_define] = STATE(1328),
    [sym_preproc_undef] = STATE(1328),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1329] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5413),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1329),
    [sym_preproc_endregion] = STATE(1329),
    [sym_preproc_line] = STATE(1329),
    [sym_preproc_pragma] = STATE(1329),
    [sym_preproc_nullable] = STATE(1329),
    [sym_preproc_error] = STATE(1329),
    [sym_preproc_define] = STATE(1329),
    [sym_preproc_undef] = STATE(1329),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1330] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4980),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1330),
    [sym_preproc_endregion] = STATE(1330),
    [sym_preproc_line] = STATE(1330),
    [sym_preproc_pragma] = STATE(1330),
    [sym_preproc_nullable] = STATE(1330),
    [sym_preproc_error] = STATE(1330),
    [sym_preproc_define] = STATE(1330),
    [sym_preproc_undef] = STATE(1330),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1331] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6216),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1331),
    [sym_preproc_endregion] = STATE(1331),
    [sym_preproc_line] = STATE(1331),
    [sym_preproc_pragma] = STATE(1331),
    [sym_preproc_nullable] = STATE(1331),
    [sym_preproc_error] = STATE(1331),
    [sym_preproc_define] = STATE(1331),
    [sym_preproc_undef] = STATE(1331),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1332] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4483),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1332),
    [sym_preproc_endregion] = STATE(1332),
    [sym_preproc_line] = STATE(1332),
    [sym_preproc_pragma] = STATE(1332),
    [sym_preproc_nullable] = STATE(1332),
    [sym_preproc_error] = STATE(1332),
    [sym_preproc_define] = STATE(1332),
    [sym_preproc_undef] = STATE(1332),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1333] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4950),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1333),
    [sym_preproc_endregion] = STATE(1333),
    [sym_preproc_line] = STATE(1333),
    [sym_preproc_pragma] = STATE(1333),
    [sym_preproc_nullable] = STATE(1333),
    [sym_preproc_error] = STATE(1333),
    [sym_preproc_define] = STATE(1333),
    [sym_preproc_undef] = STATE(1333),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1334] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5414),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1334),
    [sym_preproc_endregion] = STATE(1334),
    [sym_preproc_line] = STATE(1334),
    [sym_preproc_pragma] = STATE(1334),
    [sym_preproc_nullable] = STATE(1334),
    [sym_preproc_error] = STATE(1334),
    [sym_preproc_define] = STATE(1334),
    [sym_preproc_undef] = STATE(1334),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1335] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4951),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1335),
    [sym_preproc_endregion] = STATE(1335),
    [sym_preproc_line] = STATE(1335),
    [sym_preproc_pragma] = STATE(1335),
    [sym_preproc_nullable] = STATE(1335),
    [sym_preproc_error] = STATE(1335),
    [sym_preproc_define] = STATE(1335),
    [sym_preproc_undef] = STATE(1335),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1336] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4952),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1336),
    [sym_preproc_endregion] = STATE(1336),
    [sym_preproc_line] = STATE(1336),
    [sym_preproc_pragma] = STATE(1336),
    [sym_preproc_nullable] = STATE(1336),
    [sym_preproc_error] = STATE(1336),
    [sym_preproc_define] = STATE(1336),
    [sym_preproc_undef] = STATE(1336),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1337] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5160),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1337),
    [sym_preproc_endregion] = STATE(1337),
    [sym_preproc_line] = STATE(1337),
    [sym_preproc_pragma] = STATE(1337),
    [sym_preproc_nullable] = STATE(1337),
    [sym_preproc_error] = STATE(1337),
    [sym_preproc_define] = STATE(1337),
    [sym_preproc_undef] = STATE(1337),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1338] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4953),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1338),
    [sym_preproc_endregion] = STATE(1338),
    [sym_preproc_line] = STATE(1338),
    [sym_preproc_pragma] = STATE(1338),
    [sym_preproc_nullable] = STATE(1338),
    [sym_preproc_error] = STATE(1338),
    [sym_preproc_define] = STATE(1338),
    [sym_preproc_undef] = STATE(1338),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1339] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5156),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1339),
    [sym_preproc_endregion] = STATE(1339),
    [sym_preproc_line] = STATE(1339),
    [sym_preproc_pragma] = STATE(1339),
    [sym_preproc_nullable] = STATE(1339),
    [sym_preproc_error] = STATE(1339),
    [sym_preproc_define] = STATE(1339),
    [sym_preproc_undef] = STATE(1339),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1340] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4945),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1340),
    [sym_preproc_endregion] = STATE(1340),
    [sym_preproc_line] = STATE(1340),
    [sym_preproc_pragma] = STATE(1340),
    [sym_preproc_nullable] = STATE(1340),
    [sym_preproc_error] = STATE(1340),
    [sym_preproc_define] = STATE(1340),
    [sym_preproc_undef] = STATE(1340),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1341] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4954),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1341),
    [sym_preproc_endregion] = STATE(1341),
    [sym_preproc_line] = STATE(1341),
    [sym_preproc_pragma] = STATE(1341),
    [sym_preproc_nullable] = STATE(1341),
    [sym_preproc_error] = STATE(1341),
    [sym_preproc_define] = STATE(1341),
    [sym_preproc_undef] = STATE(1341),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1342] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4955),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1342),
    [sym_preproc_endregion] = STATE(1342),
    [sym_preproc_line] = STATE(1342),
    [sym_preproc_pragma] = STATE(1342),
    [sym_preproc_nullable] = STATE(1342),
    [sym_preproc_error] = STATE(1342),
    [sym_preproc_define] = STATE(1342),
    [sym_preproc_undef] = STATE(1342),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1343] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4956),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1343),
    [sym_preproc_endregion] = STATE(1343),
    [sym_preproc_line] = STATE(1343),
    [sym_preproc_pragma] = STATE(1343),
    [sym_preproc_nullable] = STATE(1343),
    [sym_preproc_error] = STATE(1343),
    [sym_preproc_define] = STATE(1343),
    [sym_preproc_undef] = STATE(1343),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1344] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4972),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1344),
    [sym_preproc_endregion] = STATE(1344),
    [sym_preproc_line] = STATE(1344),
    [sym_preproc_pragma] = STATE(1344),
    [sym_preproc_nullable] = STATE(1344),
    [sym_preproc_error] = STATE(1344),
    [sym_preproc_define] = STATE(1344),
    [sym_preproc_undef] = STATE(1344),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1345] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5417),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1345),
    [sym_preproc_endregion] = STATE(1345),
    [sym_preproc_line] = STATE(1345),
    [sym_preproc_pragma] = STATE(1345),
    [sym_preproc_nullable] = STATE(1345),
    [sym_preproc_error] = STATE(1345),
    [sym_preproc_define] = STATE(1345),
    [sym_preproc_undef] = STATE(1345),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1346] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4976),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1346),
    [sym_preproc_endregion] = STATE(1346),
    [sym_preproc_line] = STATE(1346),
    [sym_preproc_pragma] = STATE(1346),
    [sym_preproc_nullable] = STATE(1346),
    [sym_preproc_error] = STATE(1346),
    [sym_preproc_define] = STATE(1346),
    [sym_preproc_undef] = STATE(1346),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1347] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4977),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1347),
    [sym_preproc_endregion] = STATE(1347),
    [sym_preproc_line] = STATE(1347),
    [sym_preproc_pragma] = STATE(1347),
    [sym_preproc_nullable] = STATE(1347),
    [sym_preproc_error] = STATE(1347),
    [sym_preproc_define] = STATE(1347),
    [sym_preproc_undef] = STATE(1347),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1348] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5418),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1348),
    [sym_preproc_endregion] = STATE(1348),
    [sym_preproc_line] = STATE(1348),
    [sym_preproc_pragma] = STATE(1348),
    [sym_preproc_nullable] = STATE(1348),
    [sym_preproc_error] = STATE(1348),
    [sym_preproc_define] = STATE(1348),
    [sym_preproc_undef] = STATE(1348),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1349] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5419),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1349),
    [sym_preproc_endregion] = STATE(1349),
    [sym_preproc_line] = STATE(1349),
    [sym_preproc_pragma] = STATE(1349),
    [sym_preproc_nullable] = STATE(1349),
    [sym_preproc_error] = STATE(1349),
    [sym_preproc_define] = STATE(1349),
    [sym_preproc_undef] = STATE(1349),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1350] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5420),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1350),
    [sym_preproc_endregion] = STATE(1350),
    [sym_preproc_line] = STATE(1350),
    [sym_preproc_pragma] = STATE(1350),
    [sym_preproc_nullable] = STATE(1350),
    [sym_preproc_error] = STATE(1350),
    [sym_preproc_define] = STATE(1350),
    [sym_preproc_undef] = STATE(1350),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1351] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1351),
    [sym_preproc_endregion] = STATE(1351),
    [sym_preproc_line] = STATE(1351),
    [sym_preproc_pragma] = STATE(1351),
    [sym_preproc_nullable] = STATE(1351),
    [sym_preproc_error] = STATE(1351),
    [sym_preproc_define] = STATE(1351),
    [sym_preproc_undef] = STATE(1351),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1352] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4484),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1352),
    [sym_preproc_endregion] = STATE(1352),
    [sym_preproc_line] = STATE(1352),
    [sym_preproc_pragma] = STATE(1352),
    [sym_preproc_nullable] = STATE(1352),
    [sym_preproc_error] = STATE(1352),
    [sym_preproc_define] = STATE(1352),
    [sym_preproc_undef] = STATE(1352),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1353] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5434),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1353),
    [sym_preproc_endregion] = STATE(1353),
    [sym_preproc_line] = STATE(1353),
    [sym_preproc_pragma] = STATE(1353),
    [sym_preproc_nullable] = STATE(1353),
    [sym_preproc_error] = STATE(1353),
    [sym_preproc_define] = STATE(1353),
    [sym_preproc_undef] = STATE(1353),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1354] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5435),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1354),
    [sym_preproc_endregion] = STATE(1354),
    [sym_preproc_line] = STATE(1354),
    [sym_preproc_pragma] = STATE(1354),
    [sym_preproc_nullable] = STATE(1354),
    [sym_preproc_error] = STATE(1354),
    [sym_preproc_define] = STATE(1354),
    [sym_preproc_undef] = STATE(1354),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1355] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5436),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1355),
    [sym_preproc_endregion] = STATE(1355),
    [sym_preproc_line] = STATE(1355),
    [sym_preproc_pragma] = STATE(1355),
    [sym_preproc_nullable] = STATE(1355),
    [sym_preproc_error] = STATE(1355),
    [sym_preproc_define] = STATE(1355),
    [sym_preproc_undef] = STATE(1355),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1356] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5154),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1356),
    [sym_preproc_endregion] = STATE(1356),
    [sym_preproc_line] = STATE(1356),
    [sym_preproc_pragma] = STATE(1356),
    [sym_preproc_nullable] = STATE(1356),
    [sym_preproc_error] = STATE(1356),
    [sym_preproc_define] = STATE(1356),
    [sym_preproc_undef] = STATE(1356),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1357] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5153),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1357),
    [sym_preproc_endregion] = STATE(1357),
    [sym_preproc_line] = STATE(1357),
    [sym_preproc_pragma] = STATE(1357),
    [sym_preproc_nullable] = STATE(1357),
    [sym_preproc_error] = STATE(1357),
    [sym_preproc_define] = STATE(1357),
    [sym_preproc_undef] = STATE(1357),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1358] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1358),
    [sym_preproc_endregion] = STATE(1358),
    [sym_preproc_line] = STATE(1358),
    [sym_preproc_pragma] = STATE(1358),
    [sym_preproc_nullable] = STATE(1358),
    [sym_preproc_error] = STATE(1358),
    [sym_preproc_define] = STATE(1358),
    [sym_preproc_undef] = STATE(1358),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1359] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6938),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6316),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1359),
    [sym_preproc_endregion] = STATE(1359),
    [sym_preproc_line] = STATE(1359),
    [sym_preproc_pragma] = STATE(1359),
    [sym_preproc_nullable] = STATE(1359),
    [sym_preproc_error] = STATE(1359),
    [sym_preproc_define] = STATE(1359),
    [sym_preproc_undef] = STATE(1359),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1360] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5437),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1360),
    [sym_preproc_endregion] = STATE(1360),
    [sym_preproc_line] = STATE(1360),
    [sym_preproc_pragma] = STATE(1360),
    [sym_preproc_nullable] = STATE(1360),
    [sym_preproc_error] = STATE(1360),
    [sym_preproc_define] = STATE(1360),
    [sym_preproc_undef] = STATE(1360),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1361] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4969),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1361),
    [sym_preproc_endregion] = STATE(1361),
    [sym_preproc_line] = STATE(1361),
    [sym_preproc_pragma] = STATE(1361),
    [sym_preproc_nullable] = STATE(1361),
    [sym_preproc_error] = STATE(1361),
    [sym_preproc_define] = STATE(1361),
    [sym_preproc_undef] = STATE(1361),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1362] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6306),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1362),
    [sym_preproc_endregion] = STATE(1362),
    [sym_preproc_line] = STATE(1362),
    [sym_preproc_pragma] = STATE(1362),
    [sym_preproc_nullable] = STATE(1362),
    [sym_preproc_error] = STATE(1362),
    [sym_preproc_define] = STATE(1362),
    [sym_preproc_undef] = STATE(1362),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1363] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5725),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1363),
    [sym_preproc_endregion] = STATE(1363),
    [sym_preproc_line] = STATE(1363),
    [sym_preproc_pragma] = STATE(1363),
    [sym_preproc_nullable] = STATE(1363),
    [sym_preproc_error] = STATE(1363),
    [sym_preproc_define] = STATE(1363),
    [sym_preproc_undef] = STATE(1363),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1364] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5483),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1364),
    [sym_preproc_endregion] = STATE(1364),
    [sym_preproc_line] = STATE(1364),
    [sym_preproc_pragma] = STATE(1364),
    [sym_preproc_nullable] = STATE(1364),
    [sym_preproc_error] = STATE(1364),
    [sym_preproc_define] = STATE(1364),
    [sym_preproc_undef] = STATE(1364),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1365] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6480),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1365),
    [sym_preproc_endregion] = STATE(1365),
    [sym_preproc_line] = STATE(1365),
    [sym_preproc_pragma] = STATE(1365),
    [sym_preproc_nullable] = STATE(1365),
    [sym_preproc_error] = STATE(1365),
    [sym_preproc_define] = STATE(1365),
    [sym_preproc_undef] = STATE(1365),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1366] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6314),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1366),
    [sym_preproc_endregion] = STATE(1366),
    [sym_preproc_line] = STATE(1366),
    [sym_preproc_pragma] = STATE(1366),
    [sym_preproc_nullable] = STATE(1366),
    [sym_preproc_error] = STATE(1366),
    [sym_preproc_define] = STATE(1366),
    [sym_preproc_undef] = STATE(1366),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1367] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1367),
    [sym_preproc_endregion] = STATE(1367),
    [sym_preproc_line] = STATE(1367),
    [sym_preproc_pragma] = STATE(1367),
    [sym_preproc_nullable] = STATE(1367),
    [sym_preproc_error] = STATE(1367),
    [sym_preproc_define] = STATE(1367),
    [sym_preproc_undef] = STATE(1367),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1368] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5482),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1368),
    [sym_preproc_endregion] = STATE(1368),
    [sym_preproc_line] = STATE(1368),
    [sym_preproc_pragma] = STATE(1368),
    [sym_preproc_nullable] = STATE(1368),
    [sym_preproc_error] = STATE(1368),
    [sym_preproc_define] = STATE(1368),
    [sym_preproc_undef] = STATE(1368),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1369] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1369),
    [sym_preproc_endregion] = STATE(1369),
    [sym_preproc_line] = STATE(1369),
    [sym_preproc_pragma] = STATE(1369),
    [sym_preproc_nullable] = STATE(1369),
    [sym_preproc_error] = STATE(1369),
    [sym_preproc_define] = STATE(1369),
    [sym_preproc_undef] = STATE(1369),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1370] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5746),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1370),
    [sym_preproc_endregion] = STATE(1370),
    [sym_preproc_line] = STATE(1370),
    [sym_preproc_pragma] = STATE(1370),
    [sym_preproc_nullable] = STATE(1370),
    [sym_preproc_error] = STATE(1370),
    [sym_preproc_define] = STATE(1370),
    [sym_preproc_undef] = STATE(1370),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1371] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5481),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1371),
    [sym_preproc_endregion] = STATE(1371),
    [sym_preproc_line] = STATE(1371),
    [sym_preproc_pragma] = STATE(1371),
    [sym_preproc_nullable] = STATE(1371),
    [sym_preproc_error] = STATE(1371),
    [sym_preproc_define] = STATE(1371),
    [sym_preproc_undef] = STATE(1371),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1372] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4975),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1372),
    [sym_preproc_endregion] = STATE(1372),
    [sym_preproc_line] = STATE(1372),
    [sym_preproc_pragma] = STATE(1372),
    [sym_preproc_nullable] = STATE(1372),
    [sym_preproc_error] = STATE(1372),
    [sym_preproc_define] = STATE(1372),
    [sym_preproc_undef] = STATE(1372),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1373] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5951),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1373),
    [sym_preproc_endregion] = STATE(1373),
    [sym_preproc_line] = STATE(1373),
    [sym_preproc_pragma] = STATE(1373),
    [sym_preproc_nullable] = STATE(1373),
    [sym_preproc_error] = STATE(1373),
    [sym_preproc_define] = STATE(1373),
    [sym_preproc_undef] = STATE(1373),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1374] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5952),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1374),
    [sym_preproc_endregion] = STATE(1374),
    [sym_preproc_line] = STATE(1374),
    [sym_preproc_pragma] = STATE(1374),
    [sym_preproc_nullable] = STATE(1374),
    [sym_preproc_error] = STATE(1374),
    [sym_preproc_define] = STATE(1374),
    [sym_preproc_undef] = STATE(1374),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1375] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1375),
    [sym_preproc_endregion] = STATE(1375),
    [sym_preproc_line] = STATE(1375),
    [sym_preproc_pragma] = STATE(1375),
    [sym_preproc_nullable] = STATE(1375),
    [sym_preproc_error] = STATE(1375),
    [sym_preproc_define] = STATE(1375),
    [sym_preproc_undef] = STATE(1375),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1376] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6322),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1376),
    [sym_preproc_endregion] = STATE(1376),
    [sym_preproc_line] = STATE(1376),
    [sym_preproc_pragma] = STATE(1376),
    [sym_preproc_nullable] = STATE(1376),
    [sym_preproc_error] = STATE(1376),
    [sym_preproc_define] = STATE(1376),
    [sym_preproc_undef] = STATE(1376),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1377] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5955),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1377),
    [sym_preproc_endregion] = STATE(1377),
    [sym_preproc_line] = STATE(1377),
    [sym_preproc_pragma] = STATE(1377),
    [sym_preproc_nullable] = STATE(1377),
    [sym_preproc_error] = STATE(1377),
    [sym_preproc_define] = STATE(1377),
    [sym_preproc_undef] = STATE(1377),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1378] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5967),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1378),
    [sym_preproc_endregion] = STATE(1378),
    [sym_preproc_line] = STATE(1378),
    [sym_preproc_pragma] = STATE(1378),
    [sym_preproc_nullable] = STATE(1378),
    [sym_preproc_error] = STATE(1378),
    [sym_preproc_define] = STATE(1378),
    [sym_preproc_undef] = STATE(1378),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1379] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6295),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1379),
    [sym_preproc_endregion] = STATE(1379),
    [sym_preproc_line] = STATE(1379),
    [sym_preproc_pragma] = STATE(1379),
    [sym_preproc_nullable] = STATE(1379),
    [sym_preproc_error] = STATE(1379),
    [sym_preproc_define] = STATE(1379),
    [sym_preproc_undef] = STATE(1379),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1380] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5480),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1380),
    [sym_preproc_endregion] = STATE(1380),
    [sym_preproc_line] = STATE(1380),
    [sym_preproc_pragma] = STATE(1380),
    [sym_preproc_nullable] = STATE(1380),
    [sym_preproc_error] = STATE(1380),
    [sym_preproc_define] = STATE(1380),
    [sym_preproc_undef] = STATE(1380),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1381] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5974),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1381),
    [sym_preproc_endregion] = STATE(1381),
    [sym_preproc_line] = STATE(1381),
    [sym_preproc_pragma] = STATE(1381),
    [sym_preproc_nullable] = STATE(1381),
    [sym_preproc_error] = STATE(1381),
    [sym_preproc_define] = STATE(1381),
    [sym_preproc_undef] = STATE(1381),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1382] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6302),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1382),
    [sym_preproc_endregion] = STATE(1382),
    [sym_preproc_line] = STATE(1382),
    [sym_preproc_pragma] = STATE(1382),
    [sym_preproc_nullable] = STATE(1382),
    [sym_preproc_error] = STATE(1382),
    [sym_preproc_define] = STATE(1382),
    [sym_preproc_undef] = STATE(1382),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1383] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6644),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1383),
    [sym_preproc_endregion] = STATE(1383),
    [sym_preproc_line] = STATE(1383),
    [sym_preproc_pragma] = STATE(1383),
    [sym_preproc_nullable] = STATE(1383),
    [sym_preproc_error] = STATE(1383),
    [sym_preproc_define] = STATE(1383),
    [sym_preproc_undef] = STATE(1383),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1384] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5976),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1384),
    [sym_preproc_endregion] = STATE(1384),
    [sym_preproc_line] = STATE(1384),
    [sym_preproc_pragma] = STATE(1384),
    [sym_preproc_nullable] = STATE(1384),
    [sym_preproc_error] = STATE(1384),
    [sym_preproc_define] = STATE(1384),
    [sym_preproc_undef] = STATE(1384),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1385] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5978),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1385),
    [sym_preproc_endregion] = STATE(1385),
    [sym_preproc_line] = STATE(1385),
    [sym_preproc_pragma] = STATE(1385),
    [sym_preproc_nullable] = STATE(1385),
    [sym_preproc_error] = STATE(1385),
    [sym_preproc_define] = STATE(1385),
    [sym_preproc_undef] = STATE(1385),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1386] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5840),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1386),
    [sym_preproc_endregion] = STATE(1386),
    [sym_preproc_line] = STATE(1386),
    [sym_preproc_pragma] = STATE(1386),
    [sym_preproc_nullable] = STATE(1386),
    [sym_preproc_error] = STATE(1386),
    [sym_preproc_define] = STATE(1386),
    [sym_preproc_undef] = STATE(1386),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1387] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5979),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1387),
    [sym_preproc_endregion] = STATE(1387),
    [sym_preproc_line] = STATE(1387),
    [sym_preproc_pragma] = STATE(1387),
    [sym_preproc_nullable] = STATE(1387),
    [sym_preproc_error] = STATE(1387),
    [sym_preproc_define] = STATE(1387),
    [sym_preproc_undef] = STATE(1387),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1388] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5145),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1388),
    [sym_preproc_endregion] = STATE(1388),
    [sym_preproc_line] = STATE(1388),
    [sym_preproc_pragma] = STATE(1388),
    [sym_preproc_nullable] = STATE(1388),
    [sym_preproc_error] = STATE(1388),
    [sym_preproc_define] = STATE(1388),
    [sym_preproc_undef] = STATE(1388),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1389] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5981),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1389),
    [sym_preproc_endregion] = STATE(1389),
    [sym_preproc_line] = STATE(1389),
    [sym_preproc_pragma] = STATE(1389),
    [sym_preproc_nullable] = STATE(1389),
    [sym_preproc_error] = STATE(1389),
    [sym_preproc_define] = STATE(1389),
    [sym_preproc_undef] = STATE(1389),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1390] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5479),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1390),
    [sym_preproc_endregion] = STATE(1390),
    [sym_preproc_line] = STATE(1390),
    [sym_preproc_pragma] = STATE(1390),
    [sym_preproc_nullable] = STATE(1390),
    [sym_preproc_error] = STATE(1390),
    [sym_preproc_define] = STATE(1390),
    [sym_preproc_undef] = STATE(1390),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1391] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1391),
    [sym_preproc_endregion] = STATE(1391),
    [sym_preproc_line] = STATE(1391),
    [sym_preproc_pragma] = STATE(1391),
    [sym_preproc_nullable] = STATE(1391),
    [sym_preproc_error] = STATE(1391),
    [sym_preproc_define] = STATE(1391),
    [sym_preproc_undef] = STATE(1391),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1392] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5617),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1392),
    [sym_preproc_endregion] = STATE(1392),
    [sym_preproc_line] = STATE(1392),
    [sym_preproc_pragma] = STATE(1392),
    [sym_preproc_nullable] = STATE(1392),
    [sym_preproc_error] = STATE(1392),
    [sym_preproc_define] = STATE(1392),
    [sym_preproc_undef] = STATE(1392),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1393] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6154),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1393),
    [sym_preproc_endregion] = STATE(1393),
    [sym_preproc_line] = STATE(1393),
    [sym_preproc_pragma] = STATE(1393),
    [sym_preproc_nullable] = STATE(1393),
    [sym_preproc_error] = STATE(1393),
    [sym_preproc_define] = STATE(1393),
    [sym_preproc_undef] = STATE(1393),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1394] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1394),
    [sym_preproc_endregion] = STATE(1394),
    [sym_preproc_line] = STATE(1394),
    [sym_preproc_pragma] = STATE(1394),
    [sym_preproc_nullable] = STATE(1394),
    [sym_preproc_error] = STATE(1394),
    [sym_preproc_define] = STATE(1394),
    [sym_preproc_undef] = STATE(1394),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1395] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6304),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1395),
    [sym_preproc_endregion] = STATE(1395),
    [sym_preproc_line] = STATE(1395),
    [sym_preproc_pragma] = STATE(1395),
    [sym_preproc_nullable] = STATE(1395),
    [sym_preproc_error] = STATE(1395),
    [sym_preproc_define] = STATE(1395),
    [sym_preproc_undef] = STATE(1395),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1396] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5781),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1396),
    [sym_preproc_endregion] = STATE(1396),
    [sym_preproc_line] = STATE(1396),
    [sym_preproc_pragma] = STATE(1396),
    [sym_preproc_nullable] = STATE(1396),
    [sym_preproc_error] = STATE(1396),
    [sym_preproc_define] = STATE(1396),
    [sym_preproc_undef] = STATE(1396),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1397] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4941),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1397),
    [sym_preproc_endregion] = STATE(1397),
    [sym_preproc_line] = STATE(1397),
    [sym_preproc_pragma] = STATE(1397),
    [sym_preproc_nullable] = STATE(1397),
    [sym_preproc_error] = STATE(1397),
    [sym_preproc_define] = STATE(1397),
    [sym_preproc_undef] = STATE(1397),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1398] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4978),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1398),
    [sym_preproc_endregion] = STATE(1398),
    [sym_preproc_line] = STATE(1398),
    [sym_preproc_pragma] = STATE(1398),
    [sym_preproc_nullable] = STATE(1398),
    [sym_preproc_error] = STATE(1398),
    [sym_preproc_define] = STATE(1398),
    [sym_preproc_undef] = STATE(1398),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1399] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6637),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1399),
    [sym_preproc_endregion] = STATE(1399),
    [sym_preproc_line] = STATE(1399),
    [sym_preproc_pragma] = STATE(1399),
    [sym_preproc_nullable] = STATE(1399),
    [sym_preproc_error] = STATE(1399),
    [sym_preproc_define] = STATE(1399),
    [sym_preproc_undef] = STATE(1399),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1400] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6251),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1400),
    [sym_preproc_endregion] = STATE(1400),
    [sym_preproc_line] = STATE(1400),
    [sym_preproc_pragma] = STATE(1400),
    [sym_preproc_nullable] = STATE(1400),
    [sym_preproc_error] = STATE(1400),
    [sym_preproc_define] = STATE(1400),
    [sym_preproc_undef] = STATE(1400),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1401] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5616),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1401),
    [sym_preproc_endregion] = STATE(1401),
    [sym_preproc_line] = STATE(1401),
    [sym_preproc_pragma] = STATE(1401),
    [sym_preproc_nullable] = STATE(1401),
    [sym_preproc_error] = STATE(1401),
    [sym_preproc_define] = STATE(1401),
    [sym_preproc_undef] = STATE(1401),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1402] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6326),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1402),
    [sym_preproc_endregion] = STATE(1402),
    [sym_preproc_line] = STATE(1402),
    [sym_preproc_pragma] = STATE(1402),
    [sym_preproc_nullable] = STATE(1402),
    [sym_preproc_error] = STATE(1402),
    [sym_preproc_define] = STATE(1402),
    [sym_preproc_undef] = STATE(1402),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1403] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5829),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1403),
    [sym_preproc_endregion] = STATE(1403),
    [sym_preproc_line] = STATE(1403),
    [sym_preproc_pragma] = STATE(1403),
    [sym_preproc_nullable] = STATE(1403),
    [sym_preproc_error] = STATE(1403),
    [sym_preproc_define] = STATE(1403),
    [sym_preproc_undef] = STATE(1403),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1404] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6660),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1404),
    [sym_preproc_endregion] = STATE(1404),
    [sym_preproc_line] = STATE(1404),
    [sym_preproc_pragma] = STATE(1404),
    [sym_preproc_nullable] = STATE(1404),
    [sym_preproc_error] = STATE(1404),
    [sym_preproc_define] = STATE(1404),
    [sym_preproc_undef] = STATE(1404),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1405] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5474),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1405),
    [sym_preproc_endregion] = STATE(1405),
    [sym_preproc_line] = STATE(1405),
    [sym_preproc_pragma] = STATE(1405),
    [sym_preproc_nullable] = STATE(1405),
    [sym_preproc_error] = STATE(1405),
    [sym_preproc_define] = STATE(1405),
    [sym_preproc_undef] = STATE(1405),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1406] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5856),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1406),
    [sym_preproc_endregion] = STATE(1406),
    [sym_preproc_line] = STATE(1406),
    [sym_preproc_pragma] = STATE(1406),
    [sym_preproc_nullable] = STATE(1406),
    [sym_preproc_error] = STATE(1406),
    [sym_preproc_define] = STATE(1406),
    [sym_preproc_undef] = STATE(1406),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1407] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1407),
    [sym_preproc_endregion] = STATE(1407),
    [sym_preproc_line] = STATE(1407),
    [sym_preproc_pragma] = STATE(1407),
    [sym_preproc_nullable] = STATE(1407),
    [sym_preproc_error] = STATE(1407),
    [sym_preproc_define] = STATE(1407),
    [sym_preproc_undef] = STATE(1407),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1408] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5615),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1408),
    [sym_preproc_endregion] = STATE(1408),
    [sym_preproc_line] = STATE(1408),
    [sym_preproc_pragma] = STATE(1408),
    [sym_preproc_nullable] = STATE(1408),
    [sym_preproc_error] = STATE(1408),
    [sym_preproc_define] = STATE(1408),
    [sym_preproc_undef] = STATE(1408),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1409] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6194),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1409),
    [sym_preproc_endregion] = STATE(1409),
    [sym_preproc_line] = STATE(1409),
    [sym_preproc_pragma] = STATE(1409),
    [sym_preproc_nullable] = STATE(1409),
    [sym_preproc_error] = STATE(1409),
    [sym_preproc_define] = STATE(1409),
    [sym_preproc_undef] = STATE(1409),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1410] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5211),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1410),
    [sym_preproc_endregion] = STATE(1410),
    [sym_preproc_line] = STATE(1410),
    [sym_preproc_pragma] = STATE(1410),
    [sym_preproc_nullable] = STATE(1410),
    [sym_preproc_error] = STATE(1410),
    [sym_preproc_define] = STATE(1410),
    [sym_preproc_undef] = STATE(1410),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1411] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5236),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1411),
    [sym_preproc_endregion] = STATE(1411),
    [sym_preproc_line] = STATE(1411),
    [sym_preproc_pragma] = STATE(1411),
    [sym_preproc_nullable] = STATE(1411),
    [sym_preproc_error] = STATE(1411),
    [sym_preproc_define] = STATE(1411),
    [sym_preproc_undef] = STATE(1411),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1412] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5830),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1412),
    [sym_preproc_endregion] = STATE(1412),
    [sym_preproc_line] = STATE(1412),
    [sym_preproc_pragma] = STATE(1412),
    [sym_preproc_nullable] = STATE(1412),
    [sym_preproc_error] = STATE(1412),
    [sym_preproc_define] = STATE(1412),
    [sym_preproc_undef] = STATE(1412),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1413] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4868),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1413),
    [sym_preproc_endregion] = STATE(1413),
    [sym_preproc_line] = STATE(1413),
    [sym_preproc_pragma] = STATE(1413),
    [sym_preproc_nullable] = STATE(1413),
    [sym_preproc_error] = STATE(1413),
    [sym_preproc_define] = STATE(1413),
    [sym_preproc_undef] = STATE(1413),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1414] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6623),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1414),
    [sym_preproc_endregion] = STATE(1414),
    [sym_preproc_line] = STATE(1414),
    [sym_preproc_pragma] = STATE(1414),
    [sym_preproc_nullable] = STATE(1414),
    [sym_preproc_error] = STATE(1414),
    [sym_preproc_define] = STATE(1414),
    [sym_preproc_undef] = STATE(1414),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1415] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5827),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1415),
    [sym_preproc_endregion] = STATE(1415),
    [sym_preproc_line] = STATE(1415),
    [sym_preproc_pragma] = STATE(1415),
    [sym_preproc_nullable] = STATE(1415),
    [sym_preproc_error] = STATE(1415),
    [sym_preproc_define] = STATE(1415),
    [sym_preproc_undef] = STATE(1415),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1416] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1416),
    [sym_preproc_endregion] = STATE(1416),
    [sym_preproc_line] = STATE(1416),
    [sym_preproc_pragma] = STATE(1416),
    [sym_preproc_nullable] = STATE(1416),
    [sym_preproc_error] = STATE(1416),
    [sym_preproc_define] = STATE(1416),
    [sym_preproc_undef] = STATE(1416),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1417] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6622),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1417),
    [sym_preproc_endregion] = STATE(1417),
    [sym_preproc_line] = STATE(1417),
    [sym_preproc_pragma] = STATE(1417),
    [sym_preproc_nullable] = STATE(1417),
    [sym_preproc_error] = STATE(1417),
    [sym_preproc_define] = STATE(1417),
    [sym_preproc_undef] = STATE(1417),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1418] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4877),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1418),
    [sym_preproc_endregion] = STATE(1418),
    [sym_preproc_line] = STATE(1418),
    [sym_preproc_pragma] = STATE(1418),
    [sym_preproc_nullable] = STATE(1418),
    [sym_preproc_error] = STATE(1418),
    [sym_preproc_define] = STATE(1418),
    [sym_preproc_undef] = STATE(1418),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1419] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5994),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1419),
    [sym_preproc_endregion] = STATE(1419),
    [sym_preproc_line] = STATE(1419),
    [sym_preproc_pragma] = STATE(1419),
    [sym_preproc_nullable] = STATE(1419),
    [sym_preproc_error] = STATE(1419),
    [sym_preproc_define] = STATE(1419),
    [sym_preproc_undef] = STATE(1419),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1420] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4800),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1420),
    [sym_preproc_endregion] = STATE(1420),
    [sym_preproc_line] = STATE(1420),
    [sym_preproc_pragma] = STATE(1420),
    [sym_preproc_nullable] = STATE(1420),
    [sym_preproc_error] = STATE(1420),
    [sym_preproc_define] = STATE(1420),
    [sym_preproc_undef] = STATE(1420),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1421] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1421),
    [sym_preproc_endregion] = STATE(1421),
    [sym_preproc_line] = STATE(1421),
    [sym_preproc_pragma] = STATE(1421),
    [sym_preproc_nullable] = STATE(1421),
    [sym_preproc_error] = STATE(1421),
    [sym_preproc_define] = STATE(1421),
    [sym_preproc_undef] = STATE(1421),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1422] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4416),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1422),
    [sym_preproc_endregion] = STATE(1422),
    [sym_preproc_line] = STATE(1422),
    [sym_preproc_pragma] = STATE(1422),
    [sym_preproc_nullable] = STATE(1422),
    [sym_preproc_error] = STATE(1422),
    [sym_preproc_define] = STATE(1422),
    [sym_preproc_undef] = STATE(1422),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1423] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1423),
    [sym_preproc_endregion] = STATE(1423),
    [sym_preproc_line] = STATE(1423),
    [sym_preproc_pragma] = STATE(1423),
    [sym_preproc_nullable] = STATE(1423),
    [sym_preproc_error] = STATE(1423),
    [sym_preproc_define] = STATE(1423),
    [sym_preproc_undef] = STATE(1423),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1424] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5601),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1424),
    [sym_preproc_endregion] = STATE(1424),
    [sym_preproc_line] = STATE(1424),
    [sym_preproc_pragma] = STATE(1424),
    [sym_preproc_nullable] = STATE(1424),
    [sym_preproc_error] = STATE(1424),
    [sym_preproc_define] = STATE(1424),
    [sym_preproc_undef] = STATE(1424),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1425] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5409),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1425),
    [sym_preproc_endregion] = STATE(1425),
    [sym_preproc_line] = STATE(1425),
    [sym_preproc_pragma] = STATE(1425),
    [sym_preproc_nullable] = STATE(1425),
    [sym_preproc_error] = STATE(1425),
    [sym_preproc_define] = STATE(1425),
    [sym_preproc_undef] = STATE(1425),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1426] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6333),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1426),
    [sym_preproc_endregion] = STATE(1426),
    [sym_preproc_line] = STATE(1426),
    [sym_preproc_pragma] = STATE(1426),
    [sym_preproc_nullable] = STATE(1426),
    [sym_preproc_error] = STATE(1426),
    [sym_preproc_define] = STATE(1426),
    [sym_preproc_undef] = STATE(1426),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1427] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5833),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1427),
    [sym_preproc_endregion] = STATE(1427),
    [sym_preproc_line] = STATE(1427),
    [sym_preproc_pragma] = STATE(1427),
    [sym_preproc_nullable] = STATE(1427),
    [sym_preproc_error] = STATE(1427),
    [sym_preproc_define] = STATE(1427),
    [sym_preproc_undef] = STATE(1427),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1428] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4809),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1428),
    [sym_preproc_endregion] = STATE(1428),
    [sym_preproc_line] = STATE(1428),
    [sym_preproc_pragma] = STATE(1428),
    [sym_preproc_nullable] = STATE(1428),
    [sym_preproc_error] = STATE(1428),
    [sym_preproc_define] = STATE(1428),
    [sym_preproc_undef] = STATE(1428),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1429] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5834),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1429),
    [sym_preproc_endregion] = STATE(1429),
    [sym_preproc_line] = STATE(1429),
    [sym_preproc_pragma] = STATE(1429),
    [sym_preproc_nullable] = STATE(1429),
    [sym_preproc_error] = STATE(1429),
    [sym_preproc_define] = STATE(1429),
    [sym_preproc_undef] = STATE(1429),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1430] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6487),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1430),
    [sym_preproc_endregion] = STATE(1430),
    [sym_preproc_line] = STATE(1430),
    [sym_preproc_pragma] = STATE(1430),
    [sym_preproc_nullable] = STATE(1430),
    [sym_preproc_error] = STATE(1430),
    [sym_preproc_define] = STATE(1430),
    [sym_preproc_undef] = STATE(1430),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1431] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5925),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1431),
    [sym_preproc_endregion] = STATE(1431),
    [sym_preproc_line] = STATE(1431),
    [sym_preproc_pragma] = STATE(1431),
    [sym_preproc_nullable] = STATE(1431),
    [sym_preproc_error] = STATE(1431),
    [sym_preproc_define] = STATE(1431),
    [sym_preproc_undef] = STATE(1431),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1432] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4418),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1432),
    [sym_preproc_endregion] = STATE(1432),
    [sym_preproc_line] = STATE(1432),
    [sym_preproc_pragma] = STATE(1432),
    [sym_preproc_nullable] = STATE(1432),
    [sym_preproc_error] = STATE(1432),
    [sym_preproc_define] = STATE(1432),
    [sym_preproc_undef] = STATE(1432),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1433] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4948),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1433),
    [sym_preproc_endregion] = STATE(1433),
    [sym_preproc_line] = STATE(1433),
    [sym_preproc_pragma] = STATE(1433),
    [sym_preproc_nullable] = STATE(1433),
    [sym_preproc_error] = STATE(1433),
    [sym_preproc_define] = STATE(1433),
    [sym_preproc_undef] = STATE(1433),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1434] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4375),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1434),
    [sym_preproc_endregion] = STATE(1434),
    [sym_preproc_line] = STATE(1434),
    [sym_preproc_pragma] = STATE(1434),
    [sym_preproc_nullable] = STATE(1434),
    [sym_preproc_error] = STATE(1434),
    [sym_preproc_define] = STATE(1434),
    [sym_preproc_undef] = STATE(1434),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1435] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5602),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1435),
    [sym_preproc_endregion] = STATE(1435),
    [sym_preproc_line] = STATE(1435),
    [sym_preproc_pragma] = STATE(1435),
    [sym_preproc_nullable] = STATE(1435),
    [sym_preproc_error] = STATE(1435),
    [sym_preproc_define] = STATE(1435),
    [sym_preproc_undef] = STATE(1435),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1436] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1436),
    [sym_preproc_endregion] = STATE(1436),
    [sym_preproc_line] = STATE(1436),
    [sym_preproc_pragma] = STATE(1436),
    [sym_preproc_nullable] = STATE(1436),
    [sym_preproc_error] = STATE(1436),
    [sym_preproc_define] = STATE(1436),
    [sym_preproc_undef] = STATE(1436),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1437] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6588),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1437),
    [sym_preproc_endregion] = STATE(1437),
    [sym_preproc_line] = STATE(1437),
    [sym_preproc_pragma] = STATE(1437),
    [sym_preproc_nullable] = STATE(1437),
    [sym_preproc_error] = STATE(1437),
    [sym_preproc_define] = STATE(1437),
    [sym_preproc_undef] = STATE(1437),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1438] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4375),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1438),
    [sym_preproc_endregion] = STATE(1438),
    [sym_preproc_line] = STATE(1438),
    [sym_preproc_pragma] = STATE(1438),
    [sym_preproc_nullable] = STATE(1438),
    [sym_preproc_error] = STATE(1438),
    [sym_preproc_define] = STATE(1438),
    [sym_preproc_undef] = STATE(1438),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1439] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6298),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1439),
    [sym_preproc_endregion] = STATE(1439),
    [sym_preproc_line] = STATE(1439),
    [sym_preproc_pragma] = STATE(1439),
    [sym_preproc_nullable] = STATE(1439),
    [sym_preproc_error] = STATE(1439),
    [sym_preproc_define] = STATE(1439),
    [sym_preproc_undef] = STATE(1439),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1440] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6250),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1440),
    [sym_preproc_endregion] = STATE(1440),
    [sym_preproc_line] = STATE(1440),
    [sym_preproc_pragma] = STATE(1440),
    [sym_preproc_nullable] = STATE(1440),
    [sym_preproc_error] = STATE(1440),
    [sym_preproc_define] = STATE(1440),
    [sym_preproc_undef] = STATE(1440),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1441] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1441),
    [sym_preproc_endregion] = STATE(1441),
    [sym_preproc_line] = STATE(1441),
    [sym_preproc_pragma] = STATE(1441),
    [sym_preproc_nullable] = STATE(1441),
    [sym_preproc_error] = STATE(1441),
    [sym_preproc_define] = STATE(1441),
    [sym_preproc_undef] = STATE(1441),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1442] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4871),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1442),
    [sym_preproc_endregion] = STATE(1442),
    [sym_preproc_line] = STATE(1442),
    [sym_preproc_pragma] = STATE(1442),
    [sym_preproc_nullable] = STATE(1442),
    [sym_preproc_error] = STATE(1442),
    [sym_preproc_define] = STATE(1442),
    [sym_preproc_undef] = STATE(1442),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1443] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6140),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1443),
    [sym_preproc_endregion] = STATE(1443),
    [sym_preproc_line] = STATE(1443),
    [sym_preproc_pragma] = STATE(1443),
    [sym_preproc_nullable] = STATE(1443),
    [sym_preproc_error] = STATE(1443),
    [sym_preproc_define] = STATE(1443),
    [sym_preproc_undef] = STATE(1443),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1444] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6626),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1444),
    [sym_preproc_endregion] = STATE(1444),
    [sym_preproc_line] = STATE(1444),
    [sym_preproc_pragma] = STATE(1444),
    [sym_preproc_nullable] = STATE(1444),
    [sym_preproc_error] = STATE(1444),
    [sym_preproc_define] = STATE(1444),
    [sym_preproc_undef] = STATE(1444),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1445] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1445),
    [sym_preproc_endregion] = STATE(1445),
    [sym_preproc_line] = STATE(1445),
    [sym_preproc_pragma] = STATE(1445),
    [sym_preproc_nullable] = STATE(1445),
    [sym_preproc_error] = STATE(1445),
    [sym_preproc_define] = STATE(1445),
    [sym_preproc_undef] = STATE(1445),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1446] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7135),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4375),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3567),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9505),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1446),
    [sym_preproc_endregion] = STATE(1446),
    [sym_preproc_line] = STATE(1446),
    [sym_preproc_pragma] = STATE(1446),
    [sym_preproc_nullable] = STATE(1446),
    [sym_preproc_error] = STATE(1446),
    [sym_preproc_define] = STATE(1446),
    [sym_preproc_undef] = STATE(1446),
    [aux_sym_class_declaration_repeat1] = STATE(3843),
    [aux_sym_lambda_expression_repeat1] = STATE(4135),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [anon_sym_ref] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1793),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1797),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1447] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5880),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1447),
    [sym_preproc_endregion] = STATE(1447),
    [sym_preproc_line] = STATE(1447),
    [sym_preproc_pragma] = STATE(1447),
    [sym_preproc_nullable] = STATE(1447),
    [sym_preproc_error] = STATE(1447),
    [sym_preproc_define] = STATE(1447),
    [sym_preproc_undef] = STATE(1447),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1448] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1448),
    [sym_preproc_endregion] = STATE(1448),
    [sym_preproc_line] = STATE(1448),
    [sym_preproc_pragma] = STATE(1448),
    [sym_preproc_nullable] = STATE(1448),
    [sym_preproc_error] = STATE(1448),
    [sym_preproc_define] = STATE(1448),
    [sym_preproc_undef] = STATE(1448),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1449] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5489),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1449),
    [sym_preproc_endregion] = STATE(1449),
    [sym_preproc_line] = STATE(1449),
    [sym_preproc_pragma] = STATE(1449),
    [sym_preproc_nullable] = STATE(1449),
    [sym_preproc_error] = STATE(1449),
    [sym_preproc_define] = STATE(1449),
    [sym_preproc_undef] = STATE(1449),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1450] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6491),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1450),
    [sym_preproc_endregion] = STATE(1450),
    [sym_preproc_line] = STATE(1450),
    [sym_preproc_pragma] = STATE(1450),
    [sym_preproc_nullable] = STATE(1450),
    [sym_preproc_error] = STATE(1450),
    [sym_preproc_define] = STATE(1450),
    [sym_preproc_undef] = STATE(1450),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1451] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7037),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5980),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4343),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9522),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1451),
    [sym_preproc_endregion] = STATE(1451),
    [sym_preproc_line] = STATE(1451),
    [sym_preproc_pragma] = STATE(1451),
    [sym_preproc_nullable] = STATE(1451),
    [sym_preproc_error] = STATE(1451),
    [sym_preproc_define] = STATE(1451),
    [sym_preproc_undef] = STATE(1451),
    [aux_sym_class_declaration_repeat1] = STATE(3819),
    [aux_sym_lambda_expression_repeat1] = STATE(4302),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1555),
    [anon_sym_ref] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1559),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1563),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1565),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1452] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5835),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1452),
    [sym_preproc_endregion] = STATE(1452),
    [sym_preproc_line] = STATE(1452),
    [sym_preproc_pragma] = STATE(1452),
    [sym_preproc_nullable] = STATE(1452),
    [sym_preproc_error] = STATE(1452),
    [sym_preproc_define] = STATE(1452),
    [sym_preproc_undef] = STATE(1452),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1453] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6137),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1453),
    [sym_preproc_endregion] = STATE(1453),
    [sym_preproc_line] = STATE(1453),
    [sym_preproc_pragma] = STATE(1453),
    [sym_preproc_nullable] = STATE(1453),
    [sym_preproc_error] = STATE(1453),
    [sym_preproc_define] = STATE(1453),
    [sym_preproc_undef] = STATE(1453),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1454] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1454),
    [sym_preproc_endregion] = STATE(1454),
    [sym_preproc_line] = STATE(1454),
    [sym_preproc_pragma] = STATE(1454),
    [sym_preproc_nullable] = STATE(1454),
    [sym_preproc_error] = STATE(1454),
    [sym_preproc_define] = STATE(1454),
    [sym_preproc_undef] = STATE(1454),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1455] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5129),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1455),
    [sym_preproc_endregion] = STATE(1455),
    [sym_preproc_line] = STATE(1455),
    [sym_preproc_pragma] = STATE(1455),
    [sym_preproc_nullable] = STATE(1455),
    [sym_preproc_error] = STATE(1455),
    [sym_preproc_define] = STATE(1455),
    [sym_preproc_undef] = STATE(1455),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1456] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6177),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1456),
    [sym_preproc_endregion] = STATE(1456),
    [sym_preproc_line] = STATE(1456),
    [sym_preproc_pragma] = STATE(1456),
    [sym_preproc_nullable] = STATE(1456),
    [sym_preproc_error] = STATE(1456),
    [sym_preproc_define] = STATE(1456),
    [sym_preproc_undef] = STATE(1456),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1457] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5581),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1457),
    [sym_preproc_endregion] = STATE(1457),
    [sym_preproc_line] = STATE(1457),
    [sym_preproc_pragma] = STATE(1457),
    [sym_preproc_nullable] = STATE(1457),
    [sym_preproc_error] = STATE(1457),
    [sym_preproc_define] = STATE(1457),
    [sym_preproc_undef] = STATE(1457),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1458] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5606),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1458),
    [sym_preproc_endregion] = STATE(1458),
    [sym_preproc_line] = STATE(1458),
    [sym_preproc_pragma] = STATE(1458),
    [sym_preproc_nullable] = STATE(1458),
    [sym_preproc_error] = STATE(1458),
    [sym_preproc_define] = STATE(1458),
    [sym_preproc_undef] = STATE(1458),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1459] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6374),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1459),
    [sym_preproc_endregion] = STATE(1459),
    [sym_preproc_line] = STATE(1459),
    [sym_preproc_pragma] = STATE(1459),
    [sym_preproc_nullable] = STATE(1459),
    [sym_preproc_error] = STATE(1459),
    [sym_preproc_define] = STATE(1459),
    [sym_preproc_undef] = STATE(1459),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1460] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6569),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1460),
    [sym_preproc_endregion] = STATE(1460),
    [sym_preproc_line] = STATE(1460),
    [sym_preproc_pragma] = STATE(1460),
    [sym_preproc_nullable] = STATE(1460),
    [sym_preproc_error] = STATE(1460),
    [sym_preproc_define] = STATE(1460),
    [sym_preproc_undef] = STATE(1460),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1461] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1461),
    [sym_preproc_endregion] = STATE(1461),
    [sym_preproc_line] = STATE(1461),
    [sym_preproc_pragma] = STATE(1461),
    [sym_preproc_nullable] = STATE(1461),
    [sym_preproc_error] = STATE(1461),
    [sym_preproc_define] = STATE(1461),
    [sym_preproc_undef] = STATE(1461),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1462] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5318),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1462),
    [sym_preproc_endregion] = STATE(1462),
    [sym_preproc_line] = STATE(1462),
    [sym_preproc_pragma] = STATE(1462),
    [sym_preproc_nullable] = STATE(1462),
    [sym_preproc_error] = STATE(1462),
    [sym_preproc_define] = STATE(1462),
    [sym_preproc_undef] = STATE(1462),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1463] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4935),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1463),
    [sym_preproc_endregion] = STATE(1463),
    [sym_preproc_line] = STATE(1463),
    [sym_preproc_pragma] = STATE(1463),
    [sym_preproc_nullable] = STATE(1463),
    [sym_preproc_error] = STATE(1463),
    [sym_preproc_define] = STATE(1463),
    [sym_preproc_undef] = STATE(1463),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1464] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5333),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1464),
    [sym_preproc_endregion] = STATE(1464),
    [sym_preproc_line] = STATE(1464),
    [sym_preproc_pragma] = STATE(1464),
    [sym_preproc_nullable] = STATE(1464),
    [sym_preproc_error] = STATE(1464),
    [sym_preproc_define] = STATE(1464),
    [sym_preproc_undef] = STATE(1464),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1465] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6972),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6538),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1465),
    [sym_preproc_endregion] = STATE(1465),
    [sym_preproc_line] = STATE(1465),
    [sym_preproc_pragma] = STATE(1465),
    [sym_preproc_nullable] = STATE(1465),
    [sym_preproc_error] = STATE(1465),
    [sym_preproc_define] = STATE(1465),
    [sym_preproc_undef] = STATE(1465),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1466] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5037),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1466),
    [sym_preproc_endregion] = STATE(1466),
    [sym_preproc_line] = STATE(1466),
    [sym_preproc_pragma] = STATE(1466),
    [sym_preproc_nullable] = STATE(1466),
    [sym_preproc_error] = STATE(1466),
    [sym_preproc_define] = STATE(1466),
    [sym_preproc_undef] = STATE(1466),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1467] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6309),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1467),
    [sym_preproc_endregion] = STATE(1467),
    [sym_preproc_line] = STATE(1467),
    [sym_preproc_pragma] = STATE(1467),
    [sym_preproc_nullable] = STATE(1467),
    [sym_preproc_error] = STATE(1467),
    [sym_preproc_define] = STATE(1467),
    [sym_preproc_undef] = STATE(1467),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1468] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6375),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1468),
    [sym_preproc_endregion] = STATE(1468),
    [sym_preproc_line] = STATE(1468),
    [sym_preproc_pragma] = STATE(1468),
    [sym_preproc_nullable] = STATE(1468),
    [sym_preproc_error] = STATE(1468),
    [sym_preproc_define] = STATE(1468),
    [sym_preproc_undef] = STATE(1468),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1469] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4929),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1469),
    [sym_preproc_endregion] = STATE(1469),
    [sym_preproc_line] = STATE(1469),
    [sym_preproc_pragma] = STATE(1469),
    [sym_preproc_nullable] = STATE(1469),
    [sym_preproc_error] = STATE(1469),
    [sym_preproc_define] = STATE(1469),
    [sym_preproc_undef] = STATE(1469),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1470] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7076),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4527),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3613),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7422),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9584),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1470),
    [sym_preproc_endregion] = STATE(1470),
    [sym_preproc_line] = STATE(1470),
    [sym_preproc_pragma] = STATE(1470),
    [sym_preproc_nullable] = STATE(1470),
    [sym_preproc_error] = STATE(1470),
    [sym_preproc_define] = STATE(1470),
    [sym_preproc_undef] = STATE(1470),
    [aux_sym_class_declaration_repeat1] = STATE(3818),
    [aux_sym_lambda_expression_repeat1] = STATE(4204),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_ref] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_TILDE] = ACTIONS(1653),
    [anon_sym_PLUS_PLUS] = ACTIONS(1653),
    [anon_sym_DASH_DASH] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(1651),
    [anon_sym_DASH] = ACTIONS(1651),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1671),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1471] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7117),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5173),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3915),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9497),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1471),
    [sym_preproc_endregion] = STATE(1471),
    [sym_preproc_line] = STATE(1471),
    [sym_preproc_pragma] = STATE(1471),
    [sym_preproc_nullable] = STATE(1471),
    [sym_preproc_error] = STATE(1471),
    [sym_preproc_define] = STATE(1471),
    [sym_preproc_undef] = STATE(1471),
    [aux_sym_class_declaration_repeat1] = STATE(3859),
    [aux_sym_lambda_expression_repeat1] = STATE(4149),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_ref] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_TILDE] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1483),
    [anon_sym_DASH_DASH] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1481),
    [anon_sym_DASH] = ACTIONS(1481),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1489),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1472] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6340),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1472),
    [sym_preproc_endregion] = STATE(1472),
    [sym_preproc_line] = STATE(1472),
    [sym_preproc_pragma] = STATE(1472),
    [sym_preproc_nullable] = STATE(1472),
    [sym_preproc_error] = STATE(1472),
    [sym_preproc_define] = STATE(1472),
    [sym_preproc_undef] = STATE(1472),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1473] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6342),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1473),
    [sym_preproc_endregion] = STATE(1473),
    [sym_preproc_line] = STATE(1473),
    [sym_preproc_pragma] = STATE(1473),
    [sym_preproc_nullable] = STATE(1473),
    [sym_preproc_error] = STATE(1473),
    [sym_preproc_define] = STATE(1473),
    [sym_preproc_undef] = STATE(1473),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1474] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6376),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1474),
    [sym_preproc_endregion] = STATE(1474),
    [sym_preproc_line] = STATE(1474),
    [sym_preproc_pragma] = STATE(1474),
    [sym_preproc_nullable] = STATE(1474),
    [sym_preproc_error] = STATE(1474),
    [sym_preproc_define] = STATE(1474),
    [sym_preproc_undef] = STATE(1474),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1475] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6509),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1475),
    [sym_preproc_endregion] = STATE(1475),
    [sym_preproc_line] = STATE(1475),
    [sym_preproc_pragma] = STATE(1475),
    [sym_preproc_nullable] = STATE(1475),
    [sym_preproc_error] = STATE(1475),
    [sym_preproc_define] = STATE(1475),
    [sym_preproc_undef] = STATE(1475),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1476] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6117),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1476),
    [sym_preproc_endregion] = STATE(1476),
    [sym_preproc_line] = STATE(1476),
    [sym_preproc_pragma] = STATE(1476),
    [sym_preproc_nullable] = STATE(1476),
    [sym_preproc_error] = STATE(1476),
    [sym_preproc_define] = STATE(1476),
    [sym_preproc_undef] = STATE(1476),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1477] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1477),
    [sym_preproc_endregion] = STATE(1477),
    [sym_preproc_line] = STATE(1477),
    [sym_preproc_pragma] = STATE(1477),
    [sym_preproc_nullable] = STATE(1477),
    [sym_preproc_error] = STATE(1477),
    [sym_preproc_define] = STATE(1477),
    [sym_preproc_undef] = STATE(1477),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1478] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5563),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1478),
    [sym_preproc_endregion] = STATE(1478),
    [sym_preproc_line] = STATE(1478),
    [sym_preproc_pragma] = STATE(1478),
    [sym_preproc_nullable] = STATE(1478),
    [sym_preproc_error] = STATE(1478),
    [sym_preproc_define] = STATE(1478),
    [sym_preproc_undef] = STATE(1478),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1479] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6351),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1479),
    [sym_preproc_endregion] = STATE(1479),
    [sym_preproc_line] = STATE(1479),
    [sym_preproc_pragma] = STATE(1479),
    [sym_preproc_nullable] = STATE(1479),
    [sym_preproc_error] = STATE(1479),
    [sym_preproc_define] = STATE(1479),
    [sym_preproc_undef] = STATE(1479),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1480] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6512),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1480),
    [sym_preproc_endregion] = STATE(1480),
    [sym_preproc_line] = STATE(1480),
    [sym_preproc_pragma] = STATE(1480),
    [sym_preproc_nullable] = STATE(1480),
    [sym_preproc_error] = STATE(1480),
    [sym_preproc_define] = STATE(1480),
    [sym_preproc_undef] = STATE(1480),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1481] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6133),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1481),
    [sym_preproc_endregion] = STATE(1481),
    [sym_preproc_line] = STATE(1481),
    [sym_preproc_pragma] = STATE(1481),
    [sym_preproc_nullable] = STATE(1481),
    [sym_preproc_error] = STATE(1481),
    [sym_preproc_define] = STATE(1481),
    [sym_preproc_undef] = STATE(1481),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1482] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5516),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1482),
    [sym_preproc_endregion] = STATE(1482),
    [sym_preproc_line] = STATE(1482),
    [sym_preproc_pragma] = STATE(1482),
    [sym_preproc_nullable] = STATE(1482),
    [sym_preproc_error] = STATE(1482),
    [sym_preproc_define] = STATE(1482),
    [sym_preproc_undef] = STATE(1482),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1483] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6513),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1483),
    [sym_preproc_endregion] = STATE(1483),
    [sym_preproc_line] = STATE(1483),
    [sym_preproc_pragma] = STATE(1483),
    [sym_preproc_nullable] = STATE(1483),
    [sym_preproc_error] = STATE(1483),
    [sym_preproc_define] = STATE(1483),
    [sym_preproc_undef] = STATE(1483),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1484] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6357),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1484),
    [sym_preproc_endregion] = STATE(1484),
    [sym_preproc_line] = STATE(1484),
    [sym_preproc_pragma] = STATE(1484),
    [sym_preproc_nullable] = STATE(1484),
    [sym_preproc_error] = STATE(1484),
    [sym_preproc_define] = STATE(1484),
    [sym_preproc_undef] = STATE(1484),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1485] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1485),
    [sym_preproc_endregion] = STATE(1485),
    [sym_preproc_line] = STATE(1485),
    [sym_preproc_pragma] = STATE(1485),
    [sym_preproc_nullable] = STATE(1485),
    [sym_preproc_error] = STATE(1485),
    [sym_preproc_define] = STATE(1485),
    [sym_preproc_undef] = STATE(1485),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1486] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6358),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1486),
    [sym_preproc_endregion] = STATE(1486),
    [sym_preproc_line] = STATE(1486),
    [sym_preproc_pragma] = STATE(1486),
    [sym_preproc_nullable] = STATE(1486),
    [sym_preproc_error] = STATE(1486),
    [sym_preproc_define] = STATE(1486),
    [sym_preproc_undef] = STATE(1486),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1487] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6118),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1487),
    [sym_preproc_endregion] = STATE(1487),
    [sym_preproc_line] = STATE(1487),
    [sym_preproc_pragma] = STATE(1487),
    [sym_preproc_nullable] = STATE(1487),
    [sym_preproc_error] = STATE(1487),
    [sym_preproc_define] = STATE(1487),
    [sym_preproc_undef] = STATE(1487),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1488] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6359),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1488),
    [sym_preproc_endregion] = STATE(1488),
    [sym_preproc_line] = STATE(1488),
    [sym_preproc_pragma] = STATE(1488),
    [sym_preproc_nullable] = STATE(1488),
    [sym_preproc_error] = STATE(1488),
    [sym_preproc_define] = STATE(1488),
    [sym_preproc_undef] = STATE(1488),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1489] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6360),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1489),
    [sym_preproc_endregion] = STATE(1489),
    [sym_preproc_line] = STATE(1489),
    [sym_preproc_pragma] = STATE(1489),
    [sym_preproc_nullable] = STATE(1489),
    [sym_preproc_error] = STATE(1489),
    [sym_preproc_define] = STATE(1489),
    [sym_preproc_undef] = STATE(1489),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1490] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6514),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1490),
    [sym_preproc_endregion] = STATE(1490),
    [sym_preproc_line] = STATE(1490),
    [sym_preproc_pragma] = STATE(1490),
    [sym_preproc_nullable] = STATE(1490),
    [sym_preproc_error] = STATE(1490),
    [sym_preproc_define] = STATE(1490),
    [sym_preproc_undef] = STATE(1490),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1491] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6515),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1491),
    [sym_preproc_endregion] = STATE(1491),
    [sym_preproc_line] = STATE(1491),
    [sym_preproc_pragma] = STATE(1491),
    [sym_preproc_nullable] = STATE(1491),
    [sym_preproc_error] = STATE(1491),
    [sym_preproc_define] = STATE(1491),
    [sym_preproc_undef] = STATE(1491),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1492] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6516),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1492),
    [sym_preproc_endregion] = STATE(1492),
    [sym_preproc_line] = STATE(1492),
    [sym_preproc_pragma] = STATE(1492),
    [sym_preproc_nullable] = STATE(1492),
    [sym_preproc_error] = STATE(1492),
    [sym_preproc_define] = STATE(1492),
    [sym_preproc_undef] = STATE(1492),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1493] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5353),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1493),
    [sym_preproc_endregion] = STATE(1493),
    [sym_preproc_line] = STATE(1493),
    [sym_preproc_pragma] = STATE(1493),
    [sym_preproc_nullable] = STATE(1493),
    [sym_preproc_error] = STATE(1493),
    [sym_preproc_define] = STATE(1493),
    [sym_preproc_undef] = STATE(1493),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1494] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1494),
    [sym_preproc_endregion] = STATE(1494),
    [sym_preproc_line] = STATE(1494),
    [sym_preproc_pragma] = STATE(1494),
    [sym_preproc_nullable] = STATE(1494),
    [sym_preproc_error] = STATE(1494),
    [sym_preproc_define] = STATE(1494),
    [sym_preproc_undef] = STATE(1494),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1495] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6517),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1495),
    [sym_preproc_endregion] = STATE(1495),
    [sym_preproc_line] = STATE(1495),
    [sym_preproc_pragma] = STATE(1495),
    [sym_preproc_nullable] = STATE(1495),
    [sym_preproc_error] = STATE(1495),
    [sym_preproc_define] = STATE(1495),
    [sym_preproc_undef] = STATE(1495),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1496] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6902),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6348),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1496),
    [sym_preproc_endregion] = STATE(1496),
    [sym_preproc_line] = STATE(1496),
    [sym_preproc_pragma] = STATE(1496),
    [sym_preproc_nullable] = STATE(1496),
    [sym_preproc_error] = STATE(1496),
    [sym_preproc_define] = STATE(1496),
    [sym_preproc_undef] = STATE(1496),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1497] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6192),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1497),
    [sym_preproc_endregion] = STATE(1497),
    [sym_preproc_line] = STATE(1497),
    [sym_preproc_pragma] = STATE(1497),
    [sym_preproc_nullable] = STATE(1497),
    [sym_preproc_error] = STATE(1497),
    [sym_preproc_define] = STATE(1497),
    [sym_preproc_undef] = STATE(1497),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1498] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5795),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1498),
    [sym_preproc_endregion] = STATE(1498),
    [sym_preproc_line] = STATE(1498),
    [sym_preproc_pragma] = STATE(1498),
    [sym_preproc_nullable] = STATE(1498),
    [sym_preproc_error] = STATE(1498),
    [sym_preproc_define] = STATE(1498),
    [sym_preproc_undef] = STATE(1498),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1499] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5796),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1499),
    [sym_preproc_endregion] = STATE(1499),
    [sym_preproc_line] = STATE(1499),
    [sym_preproc_pragma] = STATE(1499),
    [sym_preproc_nullable] = STATE(1499),
    [sym_preproc_error] = STATE(1499),
    [sym_preproc_define] = STATE(1499),
    [sym_preproc_undef] = STATE(1499),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1500] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4928),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1500),
    [sym_preproc_endregion] = STATE(1500),
    [sym_preproc_line] = STATE(1500),
    [sym_preproc_pragma] = STATE(1500),
    [sym_preproc_nullable] = STATE(1500),
    [sym_preproc_error] = STATE(1500),
    [sym_preproc_define] = STATE(1500),
    [sym_preproc_undef] = STATE(1500),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1501] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5515),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1501),
    [sym_preproc_endregion] = STATE(1501),
    [sym_preproc_line] = STATE(1501),
    [sym_preproc_pragma] = STATE(1501),
    [sym_preproc_nullable] = STATE(1501),
    [sym_preproc_error] = STATE(1501),
    [sym_preproc_define] = STATE(1501),
    [sym_preproc_undef] = STATE(1501),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1502] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4761),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1502),
    [sym_preproc_endregion] = STATE(1502),
    [sym_preproc_line] = STATE(1502),
    [sym_preproc_pragma] = STATE(1502),
    [sym_preproc_nullable] = STATE(1502),
    [sym_preproc_error] = STATE(1502),
    [sym_preproc_define] = STATE(1502),
    [sym_preproc_undef] = STATE(1502),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1503] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6518),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1503),
    [sym_preproc_endregion] = STATE(1503),
    [sym_preproc_line] = STATE(1503),
    [sym_preproc_pragma] = STATE(1503),
    [sym_preproc_nullable] = STATE(1503),
    [sym_preproc_error] = STATE(1503),
    [sym_preproc_define] = STATE(1503),
    [sym_preproc_undef] = STATE(1503),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1504] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5797),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1504),
    [sym_preproc_endregion] = STATE(1504),
    [sym_preproc_line] = STATE(1504),
    [sym_preproc_pragma] = STATE(1504),
    [sym_preproc_nullable] = STATE(1504),
    [sym_preproc_error] = STATE(1504),
    [sym_preproc_define] = STATE(1504),
    [sym_preproc_undef] = STATE(1504),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1505] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5352),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1505),
    [sym_preproc_endregion] = STATE(1505),
    [sym_preproc_line] = STATE(1505),
    [sym_preproc_pragma] = STATE(1505),
    [sym_preproc_nullable] = STATE(1505),
    [sym_preproc_error] = STATE(1505),
    [sym_preproc_define] = STATE(1505),
    [sym_preproc_undef] = STATE(1505),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1506] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5644),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1506),
    [sym_preproc_endregion] = STATE(1506),
    [sym_preproc_line] = STATE(1506),
    [sym_preproc_pragma] = STATE(1506),
    [sym_preproc_nullable] = STATE(1506),
    [sym_preproc_error] = STATE(1506),
    [sym_preproc_define] = STATE(1506),
    [sym_preproc_undef] = STATE(1506),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1507] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5798),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1507),
    [sym_preproc_endregion] = STATE(1507),
    [sym_preproc_line] = STATE(1507),
    [sym_preproc_pragma] = STATE(1507),
    [sym_preproc_nullable] = STATE(1507),
    [sym_preproc_error] = STATE(1507),
    [sym_preproc_define] = STATE(1507),
    [sym_preproc_undef] = STATE(1507),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1508] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6521),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1508),
    [sym_preproc_endregion] = STATE(1508),
    [sym_preproc_line] = STATE(1508),
    [sym_preproc_pragma] = STATE(1508),
    [sym_preproc_nullable] = STATE(1508),
    [sym_preproc_error] = STATE(1508),
    [sym_preproc_define] = STATE(1508),
    [sym_preproc_undef] = STATE(1508),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1509] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6522),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1509),
    [sym_preproc_endregion] = STATE(1509),
    [sym_preproc_line] = STATE(1509),
    [sym_preproc_pragma] = STATE(1509),
    [sym_preproc_nullable] = STATE(1509),
    [sym_preproc_error] = STATE(1509),
    [sym_preproc_define] = STATE(1509),
    [sym_preproc_undef] = STATE(1509),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1510] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1510),
    [sym_preproc_endregion] = STATE(1510),
    [sym_preproc_line] = STATE(1510),
    [sym_preproc_pragma] = STATE(1510),
    [sym_preproc_nullable] = STATE(1510),
    [sym_preproc_error] = STATE(1510),
    [sym_preproc_define] = STATE(1510),
    [sym_preproc_undef] = STATE(1510),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1511] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1511),
    [sym_preproc_endregion] = STATE(1511),
    [sym_preproc_line] = STATE(1511),
    [sym_preproc_pragma] = STATE(1511),
    [sym_preproc_nullable] = STATE(1511),
    [sym_preproc_error] = STATE(1511),
    [sym_preproc_define] = STATE(1511),
    [sym_preproc_undef] = STATE(1511),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1512] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4762),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1512),
    [sym_preproc_endregion] = STATE(1512),
    [sym_preproc_line] = STATE(1512),
    [sym_preproc_pragma] = STATE(1512),
    [sym_preproc_nullable] = STATE(1512),
    [sym_preproc_error] = STATE(1512),
    [sym_preproc_define] = STATE(1512),
    [sym_preproc_undef] = STATE(1512),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1513] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4764),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1513),
    [sym_preproc_endregion] = STATE(1513),
    [sym_preproc_line] = STATE(1513),
    [sym_preproc_pragma] = STATE(1513),
    [sym_preproc_nullable] = STATE(1513),
    [sym_preproc_error] = STATE(1513),
    [sym_preproc_define] = STATE(1513),
    [sym_preproc_undef] = STATE(1513),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1514] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1514),
    [sym_preproc_endregion] = STATE(1514),
    [sym_preproc_line] = STATE(1514),
    [sym_preproc_pragma] = STATE(1514),
    [sym_preproc_nullable] = STATE(1514),
    [sym_preproc_error] = STATE(1514),
    [sym_preproc_define] = STATE(1514),
    [sym_preproc_undef] = STATE(1514),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1515] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6523),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1515),
    [sym_preproc_endregion] = STATE(1515),
    [sym_preproc_line] = STATE(1515),
    [sym_preproc_pragma] = STATE(1515),
    [sym_preproc_nullable] = STATE(1515),
    [sym_preproc_error] = STATE(1515),
    [sym_preproc_define] = STATE(1515),
    [sym_preproc_undef] = STATE(1515),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1516] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5799),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1516),
    [sym_preproc_endregion] = STATE(1516),
    [sym_preproc_line] = STATE(1516),
    [sym_preproc_pragma] = STATE(1516),
    [sym_preproc_nullable] = STATE(1516),
    [sym_preproc_error] = STATE(1516),
    [sym_preproc_define] = STATE(1516),
    [sym_preproc_undef] = STATE(1516),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1517] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1517),
    [sym_preproc_endregion] = STATE(1517),
    [sym_preproc_line] = STATE(1517),
    [sym_preproc_pragma] = STATE(1517),
    [sym_preproc_nullable] = STATE(1517),
    [sym_preproc_error] = STATE(1517),
    [sym_preproc_define] = STATE(1517),
    [sym_preproc_undef] = STATE(1517),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1518] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1518),
    [sym_preproc_endregion] = STATE(1518),
    [sym_preproc_line] = STATE(1518),
    [sym_preproc_pragma] = STATE(1518),
    [sym_preproc_nullable] = STATE(1518),
    [sym_preproc_error] = STATE(1518),
    [sym_preproc_define] = STATE(1518),
    [sym_preproc_undef] = STATE(1518),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1519] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5800),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1519),
    [sym_preproc_endregion] = STATE(1519),
    [sym_preproc_line] = STATE(1519),
    [sym_preproc_pragma] = STATE(1519),
    [sym_preproc_nullable] = STATE(1519),
    [sym_preproc_error] = STATE(1519),
    [sym_preproc_define] = STATE(1519),
    [sym_preproc_undef] = STATE(1519),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1520] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4923),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1520),
    [sym_preproc_endregion] = STATE(1520),
    [sym_preproc_line] = STATE(1520),
    [sym_preproc_pragma] = STATE(1520),
    [sym_preproc_nullable] = STATE(1520),
    [sym_preproc_error] = STATE(1520),
    [sym_preproc_define] = STATE(1520),
    [sym_preproc_undef] = STATE(1520),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1521] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1521),
    [sym_preproc_endregion] = STATE(1521),
    [sym_preproc_line] = STATE(1521),
    [sym_preproc_pragma] = STATE(1521),
    [sym_preproc_nullable] = STATE(1521),
    [sym_preproc_error] = STATE(1521),
    [sym_preproc_define] = STATE(1521),
    [sym_preproc_undef] = STATE(1521),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1522] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1522),
    [sym_preproc_endregion] = STATE(1522),
    [sym_preproc_line] = STATE(1522),
    [sym_preproc_pragma] = STATE(1522),
    [sym_preproc_nullable] = STATE(1522),
    [sym_preproc_error] = STATE(1522),
    [sym_preproc_define] = STATE(1522),
    [sym_preproc_undef] = STATE(1522),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1523] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1523),
    [sym_preproc_endregion] = STATE(1523),
    [sym_preproc_line] = STATE(1523),
    [sym_preproc_pragma] = STATE(1523),
    [sym_preproc_nullable] = STATE(1523),
    [sym_preproc_error] = STATE(1523),
    [sym_preproc_define] = STATE(1523),
    [sym_preproc_undef] = STATE(1523),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1524] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1524),
    [sym_preproc_endregion] = STATE(1524),
    [sym_preproc_line] = STATE(1524),
    [sym_preproc_pragma] = STATE(1524),
    [sym_preproc_nullable] = STATE(1524),
    [sym_preproc_error] = STATE(1524),
    [sym_preproc_define] = STATE(1524),
    [sym_preproc_undef] = STATE(1524),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1525] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1525),
    [sym_preproc_endregion] = STATE(1525),
    [sym_preproc_line] = STATE(1525),
    [sym_preproc_pragma] = STATE(1525),
    [sym_preproc_nullable] = STATE(1525),
    [sym_preproc_error] = STATE(1525),
    [sym_preproc_define] = STATE(1525),
    [sym_preproc_undef] = STATE(1525),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1526] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6378),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1526),
    [sym_preproc_endregion] = STATE(1526),
    [sym_preproc_line] = STATE(1526),
    [sym_preproc_pragma] = STATE(1526),
    [sym_preproc_nullable] = STATE(1526),
    [sym_preproc_error] = STATE(1526),
    [sym_preproc_define] = STATE(1526),
    [sym_preproc_undef] = STATE(1526),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1527] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1527),
    [sym_preproc_endregion] = STATE(1527),
    [sym_preproc_line] = STATE(1527),
    [sym_preproc_pragma] = STATE(1527),
    [sym_preproc_nullable] = STATE(1527),
    [sym_preproc_error] = STATE(1527),
    [sym_preproc_define] = STATE(1527),
    [sym_preproc_undef] = STATE(1527),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1528] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1528),
    [sym_preproc_endregion] = STATE(1528),
    [sym_preproc_line] = STATE(1528),
    [sym_preproc_pragma] = STATE(1528),
    [sym_preproc_nullable] = STATE(1528),
    [sym_preproc_error] = STATE(1528),
    [sym_preproc_define] = STATE(1528),
    [sym_preproc_undef] = STATE(1528),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1529] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1529),
    [sym_preproc_endregion] = STATE(1529),
    [sym_preproc_line] = STATE(1529),
    [sym_preproc_pragma] = STATE(1529),
    [sym_preproc_nullable] = STATE(1529),
    [sym_preproc_error] = STATE(1529),
    [sym_preproc_define] = STATE(1529),
    [sym_preproc_undef] = STATE(1529),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1530] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5517),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1530),
    [sym_preproc_endregion] = STATE(1530),
    [sym_preproc_line] = STATE(1530),
    [sym_preproc_pragma] = STATE(1530),
    [sym_preproc_nullable] = STATE(1530),
    [sym_preproc_error] = STATE(1530),
    [sym_preproc_define] = STATE(1530),
    [sym_preproc_undef] = STATE(1530),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1531] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5801),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1531),
    [sym_preproc_endregion] = STATE(1531),
    [sym_preproc_line] = STATE(1531),
    [sym_preproc_pragma] = STATE(1531),
    [sym_preproc_nullable] = STATE(1531),
    [sym_preproc_error] = STATE(1531),
    [sym_preproc_define] = STATE(1531),
    [sym_preproc_undef] = STATE(1531),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1532] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6379),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1532),
    [sym_preproc_endregion] = STATE(1532),
    [sym_preproc_line] = STATE(1532),
    [sym_preproc_pragma] = STATE(1532),
    [sym_preproc_nullable] = STATE(1532),
    [sym_preproc_error] = STATE(1532),
    [sym_preproc_define] = STATE(1532),
    [sym_preproc_undef] = STATE(1532),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1533] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1533),
    [sym_preproc_endregion] = STATE(1533),
    [sym_preproc_line] = STATE(1533),
    [sym_preproc_pragma] = STATE(1533),
    [sym_preproc_nullable] = STATE(1533),
    [sym_preproc_error] = STATE(1533),
    [sym_preproc_define] = STATE(1533),
    [sym_preproc_undef] = STATE(1533),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1534] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1534),
    [sym_preproc_endregion] = STATE(1534),
    [sym_preproc_line] = STATE(1534),
    [sym_preproc_pragma] = STATE(1534),
    [sym_preproc_nullable] = STATE(1534),
    [sym_preproc_error] = STATE(1534),
    [sym_preproc_define] = STATE(1534),
    [sym_preproc_undef] = STATE(1534),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1535] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1535),
    [sym_preproc_endregion] = STATE(1535),
    [sym_preproc_line] = STATE(1535),
    [sym_preproc_pragma] = STATE(1535),
    [sym_preproc_nullable] = STATE(1535),
    [sym_preproc_error] = STATE(1535),
    [sym_preproc_define] = STATE(1535),
    [sym_preproc_undef] = STATE(1535),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1536] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5518),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1536),
    [sym_preproc_endregion] = STATE(1536),
    [sym_preproc_line] = STATE(1536),
    [sym_preproc_pragma] = STATE(1536),
    [sym_preproc_nullable] = STATE(1536),
    [sym_preproc_error] = STATE(1536),
    [sym_preproc_define] = STATE(1536),
    [sym_preproc_undef] = STATE(1536),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1537] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5802),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1537),
    [sym_preproc_endregion] = STATE(1537),
    [sym_preproc_line] = STATE(1537),
    [sym_preproc_pragma] = STATE(1537),
    [sym_preproc_nullable] = STATE(1537),
    [sym_preproc_error] = STATE(1537),
    [sym_preproc_define] = STATE(1537),
    [sym_preproc_undef] = STATE(1537),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1538] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6437),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1538),
    [sym_preproc_endregion] = STATE(1538),
    [sym_preproc_line] = STATE(1538),
    [sym_preproc_pragma] = STATE(1538),
    [sym_preproc_nullable] = STATE(1538),
    [sym_preproc_error] = STATE(1538),
    [sym_preproc_define] = STATE(1538),
    [sym_preproc_undef] = STATE(1538),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1539] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1539),
    [sym_preproc_endregion] = STATE(1539),
    [sym_preproc_line] = STATE(1539),
    [sym_preproc_pragma] = STATE(1539),
    [sym_preproc_nullable] = STATE(1539),
    [sym_preproc_error] = STATE(1539),
    [sym_preproc_define] = STATE(1539),
    [sym_preproc_undef] = STATE(1539),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1540] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1540),
    [sym_preproc_endregion] = STATE(1540),
    [sym_preproc_line] = STATE(1540),
    [sym_preproc_pragma] = STATE(1540),
    [sym_preproc_nullable] = STATE(1540),
    [sym_preproc_error] = STATE(1540),
    [sym_preproc_define] = STATE(1540),
    [sym_preproc_undef] = STATE(1540),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1541] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1541),
    [sym_preproc_endregion] = STATE(1541),
    [sym_preproc_line] = STATE(1541),
    [sym_preproc_pragma] = STATE(1541),
    [sym_preproc_nullable] = STATE(1541),
    [sym_preproc_error] = STATE(1541),
    [sym_preproc_define] = STATE(1541),
    [sym_preproc_undef] = STATE(1541),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1542] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5346),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1542),
    [sym_preproc_endregion] = STATE(1542),
    [sym_preproc_line] = STATE(1542),
    [sym_preproc_pragma] = STATE(1542),
    [sym_preproc_nullable] = STATE(1542),
    [sym_preproc_error] = STATE(1542),
    [sym_preproc_define] = STATE(1542),
    [sym_preproc_undef] = STATE(1542),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1543] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5947),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1543),
    [sym_preproc_endregion] = STATE(1543),
    [sym_preproc_line] = STATE(1543),
    [sym_preproc_pragma] = STATE(1543),
    [sym_preproc_nullable] = STATE(1543),
    [sym_preproc_error] = STATE(1543),
    [sym_preproc_define] = STATE(1543),
    [sym_preproc_undef] = STATE(1543),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1544] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1544),
    [sym_preproc_endregion] = STATE(1544),
    [sym_preproc_line] = STATE(1544),
    [sym_preproc_pragma] = STATE(1544),
    [sym_preproc_nullable] = STATE(1544),
    [sym_preproc_error] = STATE(1544),
    [sym_preproc_define] = STATE(1544),
    [sym_preproc_undef] = STATE(1544),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1545] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1545),
    [sym_preproc_endregion] = STATE(1545),
    [sym_preproc_line] = STATE(1545),
    [sym_preproc_pragma] = STATE(1545),
    [sym_preproc_nullable] = STATE(1545),
    [sym_preproc_error] = STATE(1545),
    [sym_preproc_define] = STATE(1545),
    [sym_preproc_undef] = STATE(1545),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1546] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5343),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1546),
    [sym_preproc_endregion] = STATE(1546),
    [sym_preproc_line] = STATE(1546),
    [sym_preproc_pragma] = STATE(1546),
    [sym_preproc_nullable] = STATE(1546),
    [sym_preproc_error] = STATE(1546),
    [sym_preproc_define] = STATE(1546),
    [sym_preproc_undef] = STATE(1546),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1547] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1547),
    [sym_preproc_endregion] = STATE(1547),
    [sym_preproc_line] = STATE(1547),
    [sym_preproc_pragma] = STATE(1547),
    [sym_preproc_nullable] = STATE(1547),
    [sym_preproc_error] = STATE(1547),
    [sym_preproc_define] = STATE(1547),
    [sym_preproc_undef] = STATE(1547),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1548] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1548),
    [sym_preproc_endregion] = STATE(1548),
    [sym_preproc_line] = STATE(1548),
    [sym_preproc_pragma] = STATE(1548),
    [sym_preproc_nullable] = STATE(1548),
    [sym_preproc_error] = STATE(1548),
    [sym_preproc_define] = STATE(1548),
    [sym_preproc_undef] = STATE(1548),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1549] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1549),
    [sym_preproc_endregion] = STATE(1549),
    [sym_preproc_line] = STATE(1549),
    [sym_preproc_pragma] = STATE(1549),
    [sym_preproc_nullable] = STATE(1549),
    [sym_preproc_error] = STATE(1549),
    [sym_preproc_define] = STATE(1549),
    [sym_preproc_undef] = STATE(1549),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1550] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1550),
    [sym_preproc_endregion] = STATE(1550),
    [sym_preproc_line] = STATE(1550),
    [sym_preproc_pragma] = STATE(1550),
    [sym_preproc_nullable] = STATE(1550),
    [sym_preproc_error] = STATE(1550),
    [sym_preproc_define] = STATE(1550),
    [sym_preproc_undef] = STATE(1550),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1551] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1551),
    [sym_preproc_endregion] = STATE(1551),
    [sym_preproc_line] = STATE(1551),
    [sym_preproc_pragma] = STATE(1551),
    [sym_preproc_nullable] = STATE(1551),
    [sym_preproc_error] = STATE(1551),
    [sym_preproc_define] = STATE(1551),
    [sym_preproc_undef] = STATE(1551),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1552] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5341),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1552),
    [sym_preproc_endregion] = STATE(1552),
    [sym_preproc_line] = STATE(1552),
    [sym_preproc_pragma] = STATE(1552),
    [sym_preproc_nullable] = STATE(1552),
    [sym_preproc_error] = STATE(1552),
    [sym_preproc_define] = STATE(1552),
    [sym_preproc_undef] = STATE(1552),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1553] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1553),
    [sym_preproc_endregion] = STATE(1553),
    [sym_preproc_line] = STATE(1553),
    [sym_preproc_pragma] = STATE(1553),
    [sym_preproc_nullable] = STATE(1553),
    [sym_preproc_error] = STATE(1553),
    [sym_preproc_define] = STATE(1553),
    [sym_preproc_undef] = STATE(1553),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1554] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1554),
    [sym_preproc_endregion] = STATE(1554),
    [sym_preproc_line] = STATE(1554),
    [sym_preproc_pragma] = STATE(1554),
    [sym_preproc_nullable] = STATE(1554),
    [sym_preproc_error] = STATE(1554),
    [sym_preproc_define] = STATE(1554),
    [sym_preproc_undef] = STATE(1554),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1555] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1555),
    [sym_preproc_endregion] = STATE(1555),
    [sym_preproc_line] = STATE(1555),
    [sym_preproc_pragma] = STATE(1555),
    [sym_preproc_nullable] = STATE(1555),
    [sym_preproc_error] = STATE(1555),
    [sym_preproc_define] = STATE(1555),
    [sym_preproc_undef] = STATE(1555),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1556] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6600),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1556),
    [sym_preproc_endregion] = STATE(1556),
    [sym_preproc_line] = STATE(1556),
    [sym_preproc_pragma] = STATE(1556),
    [sym_preproc_nullable] = STATE(1556),
    [sym_preproc_error] = STATE(1556),
    [sym_preproc_define] = STATE(1556),
    [sym_preproc_undef] = STATE(1556),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1557] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6339),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1557),
    [sym_preproc_endregion] = STATE(1557),
    [sym_preproc_line] = STATE(1557),
    [sym_preproc_pragma] = STATE(1557),
    [sym_preproc_nullable] = STATE(1557),
    [sym_preproc_error] = STATE(1557),
    [sym_preproc_define] = STATE(1557),
    [sym_preproc_undef] = STATE(1557),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1558] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1558),
    [sym_preproc_endregion] = STATE(1558),
    [sym_preproc_line] = STATE(1558),
    [sym_preproc_pragma] = STATE(1558),
    [sym_preproc_nullable] = STATE(1558),
    [sym_preproc_error] = STATE(1558),
    [sym_preproc_define] = STATE(1558),
    [sym_preproc_undef] = STATE(1558),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1559] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1559),
    [sym_preproc_endregion] = STATE(1559),
    [sym_preproc_line] = STATE(1559),
    [sym_preproc_pragma] = STATE(1559),
    [sym_preproc_nullable] = STATE(1559),
    [sym_preproc_error] = STATE(1559),
    [sym_preproc_define] = STATE(1559),
    [sym_preproc_undef] = STATE(1559),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1560] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6654),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1560),
    [sym_preproc_endregion] = STATE(1560),
    [sym_preproc_line] = STATE(1560),
    [sym_preproc_pragma] = STATE(1560),
    [sym_preproc_nullable] = STATE(1560),
    [sym_preproc_error] = STATE(1560),
    [sym_preproc_define] = STATE(1560),
    [sym_preproc_undef] = STATE(1560),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1561] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5336),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1561),
    [sym_preproc_endregion] = STATE(1561),
    [sym_preproc_line] = STATE(1561),
    [sym_preproc_pragma] = STATE(1561),
    [sym_preproc_nullable] = STATE(1561),
    [sym_preproc_error] = STATE(1561),
    [sym_preproc_define] = STATE(1561),
    [sym_preproc_undef] = STATE(1561),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1562] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6355),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1562),
    [sym_preproc_endregion] = STATE(1562),
    [sym_preproc_line] = STATE(1562),
    [sym_preproc_pragma] = STATE(1562),
    [sym_preproc_nullable] = STATE(1562),
    [sym_preproc_error] = STATE(1562),
    [sym_preproc_define] = STATE(1562),
    [sym_preproc_undef] = STATE(1562),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1563] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6356),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1563),
    [sym_preproc_endregion] = STATE(1563),
    [sym_preproc_line] = STATE(1563),
    [sym_preproc_pragma] = STATE(1563),
    [sym_preproc_nullable] = STATE(1563),
    [sym_preproc_error] = STATE(1563),
    [sym_preproc_define] = STATE(1563),
    [sym_preproc_undef] = STATE(1563),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1564] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4980),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1564),
    [sym_preproc_endregion] = STATE(1564),
    [sym_preproc_line] = STATE(1564),
    [sym_preproc_pragma] = STATE(1564),
    [sym_preproc_nullable] = STATE(1564),
    [sym_preproc_error] = STATE(1564),
    [sym_preproc_define] = STATE(1564),
    [sym_preproc_undef] = STATE(1564),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1565] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6361),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1565),
    [sym_preproc_endregion] = STATE(1565),
    [sym_preproc_line] = STATE(1565),
    [sym_preproc_pragma] = STATE(1565),
    [sym_preproc_nullable] = STATE(1565),
    [sym_preproc_error] = STATE(1565),
    [sym_preproc_define] = STATE(1565),
    [sym_preproc_undef] = STATE(1565),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1566] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6362),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1566),
    [sym_preproc_endregion] = STATE(1566),
    [sym_preproc_line] = STATE(1566),
    [sym_preproc_pragma] = STATE(1566),
    [sym_preproc_nullable] = STATE(1566),
    [sym_preproc_error] = STATE(1566),
    [sym_preproc_define] = STATE(1566),
    [sym_preproc_undef] = STATE(1566),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1567] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1567),
    [sym_preproc_endregion] = STATE(1567),
    [sym_preproc_line] = STATE(1567),
    [sym_preproc_pragma] = STATE(1567),
    [sym_preproc_nullable] = STATE(1567),
    [sym_preproc_error] = STATE(1567),
    [sym_preproc_define] = STATE(1567),
    [sym_preproc_undef] = STATE(1567),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1568] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6431),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1568),
    [sym_preproc_endregion] = STATE(1568),
    [sym_preproc_line] = STATE(1568),
    [sym_preproc_pragma] = STATE(1568),
    [sym_preproc_nullable] = STATE(1568),
    [sym_preproc_error] = STATE(1568),
    [sym_preproc_define] = STATE(1568),
    [sym_preproc_undef] = STATE(1568),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1569] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6363),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1569),
    [sym_preproc_endregion] = STATE(1569),
    [sym_preproc_line] = STATE(1569),
    [sym_preproc_pragma] = STATE(1569),
    [sym_preproc_nullable] = STATE(1569),
    [sym_preproc_error] = STATE(1569),
    [sym_preproc_define] = STATE(1569),
    [sym_preproc_undef] = STATE(1569),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1570] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1570),
    [sym_preproc_endregion] = STATE(1570),
    [sym_preproc_line] = STATE(1570),
    [sym_preproc_pragma] = STATE(1570),
    [sym_preproc_nullable] = STATE(1570),
    [sym_preproc_error] = STATE(1570),
    [sym_preproc_define] = STATE(1570),
    [sym_preproc_undef] = STATE(1570),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1571] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4478),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1571),
    [sym_preproc_endregion] = STATE(1571),
    [sym_preproc_line] = STATE(1571),
    [sym_preproc_pragma] = STATE(1571),
    [sym_preproc_nullable] = STATE(1571),
    [sym_preproc_error] = STATE(1571),
    [sym_preproc_define] = STATE(1571),
    [sym_preproc_undef] = STATE(1571),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1572] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6380),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1572),
    [sym_preproc_endregion] = STATE(1572),
    [sym_preproc_line] = STATE(1572),
    [sym_preproc_pragma] = STATE(1572),
    [sym_preproc_nullable] = STATE(1572),
    [sym_preproc_error] = STATE(1572),
    [sym_preproc_define] = STATE(1572),
    [sym_preproc_undef] = STATE(1572),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1573] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4765),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1573),
    [sym_preproc_endregion] = STATE(1573),
    [sym_preproc_line] = STATE(1573),
    [sym_preproc_pragma] = STATE(1573),
    [sym_preproc_nullable] = STATE(1573),
    [sym_preproc_error] = STATE(1573),
    [sym_preproc_define] = STATE(1573),
    [sym_preproc_undef] = STATE(1573),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1574] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5641),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1574),
    [sym_preproc_endregion] = STATE(1574),
    [sym_preproc_line] = STATE(1574),
    [sym_preproc_pragma] = STATE(1574),
    [sym_preproc_nullable] = STATE(1574),
    [sym_preproc_error] = STATE(1574),
    [sym_preproc_define] = STATE(1574),
    [sym_preproc_undef] = STATE(1574),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1575] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5803),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1575),
    [sym_preproc_endregion] = STATE(1575),
    [sym_preproc_line] = STATE(1575),
    [sym_preproc_pragma] = STATE(1575),
    [sym_preproc_nullable] = STATE(1575),
    [sym_preproc_error] = STATE(1575),
    [sym_preproc_define] = STATE(1575),
    [sym_preproc_undef] = STATE(1575),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1576] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1576),
    [sym_preproc_endregion] = STATE(1576),
    [sym_preproc_line] = STATE(1576),
    [sym_preproc_pragma] = STATE(1576),
    [sym_preproc_nullable] = STATE(1576),
    [sym_preproc_error] = STATE(1576),
    [sym_preproc_define] = STATE(1576),
    [sym_preproc_undef] = STATE(1576),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1577] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1577),
    [sym_preproc_endregion] = STATE(1577),
    [sym_preproc_line] = STATE(1577),
    [sym_preproc_pragma] = STATE(1577),
    [sym_preproc_nullable] = STATE(1577),
    [sym_preproc_error] = STATE(1577),
    [sym_preproc_define] = STATE(1577),
    [sym_preproc_undef] = STATE(1577),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1578] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5640),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1578),
    [sym_preproc_endregion] = STATE(1578),
    [sym_preproc_line] = STATE(1578),
    [sym_preproc_pragma] = STATE(1578),
    [sym_preproc_nullable] = STATE(1578),
    [sym_preproc_error] = STATE(1578),
    [sym_preproc_define] = STATE(1578),
    [sym_preproc_undef] = STATE(1578),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1579] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4781),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1579),
    [sym_preproc_endregion] = STATE(1579),
    [sym_preproc_line] = STATE(1579),
    [sym_preproc_pragma] = STATE(1579),
    [sym_preproc_nullable] = STATE(1579),
    [sym_preproc_error] = STATE(1579),
    [sym_preproc_define] = STATE(1579),
    [sym_preproc_undef] = STATE(1579),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1580] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6338),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1580),
    [sym_preproc_endregion] = STATE(1580),
    [sym_preproc_line] = STATE(1580),
    [sym_preproc_pragma] = STATE(1580),
    [sym_preproc_nullable] = STATE(1580),
    [sym_preproc_error] = STATE(1580),
    [sym_preproc_define] = STATE(1580),
    [sym_preproc_undef] = STATE(1580),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1581] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1581),
    [sym_preproc_endregion] = STATE(1581),
    [sym_preproc_line] = STATE(1581),
    [sym_preproc_pragma] = STATE(1581),
    [sym_preproc_nullable] = STATE(1581),
    [sym_preproc_error] = STATE(1581),
    [sym_preproc_define] = STATE(1581),
    [sym_preproc_undef] = STATE(1581),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1582] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3857),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1582),
    [sym_preproc_endregion] = STATE(1582),
    [sym_preproc_line] = STATE(1582),
    [sym_preproc_pragma] = STATE(1582),
    [sym_preproc_nullable] = STATE(1582),
    [sym_preproc_error] = STATE(1582),
    [sym_preproc_define] = STATE(1582),
    [sym_preproc_undef] = STATE(1582),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1583] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5638),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1583),
    [sym_preproc_endregion] = STATE(1583),
    [sym_preproc_line] = STATE(1583),
    [sym_preproc_pragma] = STATE(1583),
    [sym_preproc_nullable] = STATE(1583),
    [sym_preproc_error] = STATE(1583),
    [sym_preproc_define] = STATE(1583),
    [sym_preproc_undef] = STATE(1583),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1584] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6460),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1584),
    [sym_preproc_endregion] = STATE(1584),
    [sym_preproc_line] = STATE(1584),
    [sym_preproc_pragma] = STATE(1584),
    [sym_preproc_nullable] = STATE(1584),
    [sym_preproc_error] = STATE(1584),
    [sym_preproc_define] = STATE(1584),
    [sym_preproc_undef] = STATE(1584),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1585] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6736),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3197),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1585),
    [sym_preproc_endregion] = STATE(1585),
    [sym_preproc_line] = STATE(1585),
    [sym_preproc_pragma] = STATE(1585),
    [sym_preproc_nullable] = STATE(1585),
    [sym_preproc_error] = STATE(1585),
    [sym_preproc_define] = STATE(1585),
    [sym_preproc_undef] = STATE(1585),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1586] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5519),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1586),
    [sym_preproc_endregion] = STATE(1586),
    [sym_preproc_line] = STATE(1586),
    [sym_preproc_pragma] = STATE(1586),
    [sym_preproc_nullable] = STATE(1586),
    [sym_preproc_error] = STATE(1586),
    [sym_preproc_define] = STATE(1586),
    [sym_preproc_undef] = STATE(1586),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1587] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1587),
    [sym_preproc_endregion] = STATE(1587),
    [sym_preproc_line] = STATE(1587),
    [sym_preproc_pragma] = STATE(1587),
    [sym_preproc_nullable] = STATE(1587),
    [sym_preproc_error] = STATE(1587),
    [sym_preproc_define] = STATE(1587),
    [sym_preproc_undef] = STATE(1587),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1588] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6461),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1588),
    [sym_preproc_endregion] = STATE(1588),
    [sym_preproc_line] = STATE(1588),
    [sym_preproc_pragma] = STATE(1588),
    [sym_preproc_nullable] = STATE(1588),
    [sym_preproc_error] = STATE(1588),
    [sym_preproc_define] = STATE(1588),
    [sym_preproc_undef] = STATE(1588),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1589] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1589),
    [sym_preproc_endregion] = STATE(1589),
    [sym_preproc_line] = STATE(1589),
    [sym_preproc_pragma] = STATE(1589),
    [sym_preproc_nullable] = STATE(1589),
    [sym_preproc_error] = STATE(1589),
    [sym_preproc_define] = STATE(1589),
    [sym_preproc_undef] = STATE(1589),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1590] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6464),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1590),
    [sym_preproc_endregion] = STATE(1590),
    [sym_preproc_line] = STATE(1590),
    [sym_preproc_pragma] = STATE(1590),
    [sym_preproc_nullable] = STATE(1590),
    [sym_preproc_error] = STATE(1590),
    [sym_preproc_define] = STATE(1590),
    [sym_preproc_undef] = STATE(1590),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1591] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1591),
    [sym_preproc_endregion] = STATE(1591),
    [sym_preproc_line] = STATE(1591),
    [sym_preproc_pragma] = STATE(1591),
    [sym_preproc_nullable] = STATE(1591),
    [sym_preproc_error] = STATE(1591),
    [sym_preproc_define] = STATE(1591),
    [sym_preproc_undef] = STATE(1591),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1592] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1592),
    [sym_preproc_endregion] = STATE(1592),
    [sym_preproc_line] = STATE(1592),
    [sym_preproc_pragma] = STATE(1592),
    [sym_preproc_nullable] = STATE(1592),
    [sym_preproc_error] = STATE(1592),
    [sym_preproc_define] = STATE(1592),
    [sym_preproc_undef] = STATE(1592),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1593] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5502),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1593),
    [sym_preproc_endregion] = STATE(1593),
    [sym_preproc_line] = STATE(1593),
    [sym_preproc_pragma] = STATE(1593),
    [sym_preproc_nullable] = STATE(1593),
    [sym_preproc_error] = STATE(1593),
    [sym_preproc_define] = STATE(1593),
    [sym_preproc_undef] = STATE(1593),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1594] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4782),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1594),
    [sym_preproc_endregion] = STATE(1594),
    [sym_preproc_line] = STATE(1594),
    [sym_preproc_pragma] = STATE(1594),
    [sym_preproc_nullable] = STATE(1594),
    [sym_preproc_error] = STATE(1594),
    [sym_preproc_define] = STATE(1594),
    [sym_preproc_undef] = STATE(1594),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1595] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4841),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1595),
    [sym_preproc_endregion] = STATE(1595),
    [sym_preproc_line] = STATE(1595),
    [sym_preproc_pragma] = STATE(1595),
    [sym_preproc_nullable] = STATE(1595),
    [sym_preproc_error] = STATE(1595),
    [sym_preproc_define] = STATE(1595),
    [sym_preproc_undef] = STATE(1595),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1596] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1596),
    [sym_preproc_endregion] = STATE(1596),
    [sym_preproc_line] = STATE(1596),
    [sym_preproc_pragma] = STATE(1596),
    [sym_preproc_nullable] = STATE(1596),
    [sym_preproc_error] = STATE(1596),
    [sym_preproc_define] = STATE(1596),
    [sym_preproc_undef] = STATE(1596),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1597] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4375),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1597),
    [sym_preproc_endregion] = STATE(1597),
    [sym_preproc_line] = STATE(1597),
    [sym_preproc_pragma] = STATE(1597),
    [sym_preproc_nullable] = STATE(1597),
    [sym_preproc_error] = STATE(1597),
    [sym_preproc_define] = STATE(1597),
    [sym_preproc_undef] = STATE(1597),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1598] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6595),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1598),
    [sym_preproc_endregion] = STATE(1598),
    [sym_preproc_line] = STATE(1598),
    [sym_preproc_pragma] = STATE(1598),
    [sym_preproc_nullable] = STATE(1598),
    [sym_preproc_error] = STATE(1598),
    [sym_preproc_define] = STATE(1598),
    [sym_preproc_undef] = STATE(1598),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1599] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6381),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1599),
    [sym_preproc_endregion] = STATE(1599),
    [sym_preproc_line] = STATE(1599),
    [sym_preproc_pragma] = STATE(1599),
    [sym_preproc_nullable] = STATE(1599),
    [sym_preproc_error] = STATE(1599),
    [sym_preproc_define] = STATE(1599),
    [sym_preproc_undef] = STATE(1599),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1600] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1600),
    [sym_preproc_endregion] = STATE(1600),
    [sym_preproc_line] = STATE(1600),
    [sym_preproc_pragma] = STATE(1600),
    [sym_preproc_nullable] = STATE(1600),
    [sym_preproc_error] = STATE(1600),
    [sym_preproc_define] = STATE(1600),
    [sym_preproc_undef] = STATE(1600),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1601] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1601),
    [sym_preproc_endregion] = STATE(1601),
    [sym_preproc_line] = STATE(1601),
    [sym_preproc_pragma] = STATE(1601),
    [sym_preproc_nullable] = STATE(1601),
    [sym_preproc_error] = STATE(1601),
    [sym_preproc_define] = STATE(1601),
    [sym_preproc_undef] = STATE(1601),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1602] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4786),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1602),
    [sym_preproc_endregion] = STATE(1602),
    [sym_preproc_line] = STATE(1602),
    [sym_preproc_pragma] = STATE(1602),
    [sym_preproc_nullable] = STATE(1602),
    [sym_preproc_error] = STATE(1602),
    [sym_preproc_define] = STATE(1602),
    [sym_preproc_undef] = STATE(1602),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1603] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5944),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1603),
    [sym_preproc_endregion] = STATE(1603),
    [sym_preproc_line] = STATE(1603),
    [sym_preproc_pragma] = STATE(1603),
    [sym_preproc_nullable] = STATE(1603),
    [sym_preproc_error] = STATE(1603),
    [sym_preproc_define] = STATE(1603),
    [sym_preproc_undef] = STATE(1603),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1604] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6372),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1604),
    [sym_preproc_endregion] = STATE(1604),
    [sym_preproc_line] = STATE(1604),
    [sym_preproc_pragma] = STATE(1604),
    [sym_preproc_nullable] = STATE(1604),
    [sym_preproc_error] = STATE(1604),
    [sym_preproc_define] = STATE(1604),
    [sym_preproc_undef] = STATE(1604),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1605] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6395),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1605),
    [sym_preproc_endregion] = STATE(1605),
    [sym_preproc_line] = STATE(1605),
    [sym_preproc_pragma] = STATE(1605),
    [sym_preproc_nullable] = STATE(1605),
    [sym_preproc_error] = STATE(1605),
    [sym_preproc_define] = STATE(1605),
    [sym_preproc_undef] = STATE(1605),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1606] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5637),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1606),
    [sym_preproc_endregion] = STATE(1606),
    [sym_preproc_line] = STATE(1606),
    [sym_preproc_pragma] = STATE(1606),
    [sym_preproc_nullable] = STATE(1606),
    [sym_preproc_error] = STATE(1606),
    [sym_preproc_define] = STATE(1606),
    [sym_preproc_undef] = STATE(1606),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1607] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6402),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1607),
    [sym_preproc_endregion] = STATE(1607),
    [sym_preproc_line] = STATE(1607),
    [sym_preproc_pragma] = STATE(1607),
    [sym_preproc_nullable] = STATE(1607),
    [sym_preproc_error] = STATE(1607),
    [sym_preproc_define] = STATE(1607),
    [sym_preproc_undef] = STATE(1607),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1608] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1608),
    [sym_preproc_endregion] = STATE(1608),
    [sym_preproc_line] = STATE(1608),
    [sym_preproc_pragma] = STATE(1608),
    [sym_preproc_nullable] = STATE(1608),
    [sym_preproc_error] = STATE(1608),
    [sym_preproc_define] = STATE(1608),
    [sym_preproc_undef] = STATE(1608),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1609] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1609),
    [sym_preproc_endregion] = STATE(1609),
    [sym_preproc_line] = STATE(1609),
    [sym_preproc_pragma] = STATE(1609),
    [sym_preproc_nullable] = STATE(1609),
    [sym_preproc_error] = STATE(1609),
    [sym_preproc_define] = STATE(1609),
    [sym_preproc_undef] = STATE(1609),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1610] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4770),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1610),
    [sym_preproc_endregion] = STATE(1610),
    [sym_preproc_line] = STATE(1610),
    [sym_preproc_pragma] = STATE(1610),
    [sym_preproc_nullable] = STATE(1610),
    [sym_preproc_error] = STATE(1610),
    [sym_preproc_define] = STATE(1610),
    [sym_preproc_undef] = STATE(1610),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1611] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6566),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1611),
    [sym_preproc_endregion] = STATE(1611),
    [sym_preproc_line] = STATE(1611),
    [sym_preproc_pragma] = STATE(1611),
    [sym_preproc_nullable] = STATE(1611),
    [sym_preproc_error] = STATE(1611),
    [sym_preproc_define] = STATE(1611),
    [sym_preproc_undef] = STATE(1611),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1612] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5636),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1612),
    [sym_preproc_endregion] = STATE(1612),
    [sym_preproc_line] = STATE(1612),
    [sym_preproc_pragma] = STATE(1612),
    [sym_preproc_nullable] = STATE(1612),
    [sym_preproc_error] = STATE(1612),
    [sym_preproc_define] = STATE(1612),
    [sym_preproc_undef] = STATE(1612),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1613] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5582),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1613),
    [sym_preproc_endregion] = STATE(1613),
    [sym_preproc_line] = STATE(1613),
    [sym_preproc_pragma] = STATE(1613),
    [sym_preproc_nullable] = STATE(1613),
    [sym_preproc_error] = STATE(1613),
    [sym_preproc_define] = STATE(1613),
    [sym_preproc_undef] = STATE(1613),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1614] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5132),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1614),
    [sym_preproc_endregion] = STATE(1614),
    [sym_preproc_line] = STATE(1614),
    [sym_preproc_pragma] = STATE(1614),
    [sym_preproc_nullable] = STATE(1614),
    [sym_preproc_error] = STATE(1614),
    [sym_preproc_define] = STATE(1614),
    [sym_preproc_undef] = STATE(1614),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1615] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5566),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1615),
    [sym_preproc_endregion] = STATE(1615),
    [sym_preproc_line] = STATE(1615),
    [sym_preproc_pragma] = STATE(1615),
    [sym_preproc_nullable] = STATE(1615),
    [sym_preproc_error] = STATE(1615),
    [sym_preproc_define] = STATE(1615),
    [sym_preproc_undef] = STATE(1615),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1616] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7089),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5804),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4337),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7410),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9021),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1616),
    [sym_preproc_endregion] = STATE(1616),
    [sym_preproc_line] = STATE(1616),
    [sym_preproc_pragma] = STATE(1616),
    [sym_preproc_nullable] = STATE(1616),
    [sym_preproc_error] = STATE(1616),
    [sym_preproc_define] = STATE(1616),
    [sym_preproc_undef] = STATE(1616),
    [aux_sym_class_declaration_repeat1] = STATE(3858),
    [aux_sym_lambda_expression_repeat1] = STATE(4185),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_ref] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1839),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_CARET] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1847),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1617] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6383),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1617),
    [sym_preproc_endregion] = STATE(1617),
    [sym_preproc_line] = STATE(1617),
    [sym_preproc_pragma] = STATE(1617),
    [sym_preproc_nullable] = STATE(1617),
    [sym_preproc_error] = STATE(1617),
    [sym_preproc_define] = STATE(1617),
    [sym_preproc_undef] = STATE(1617),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1618] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6384),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1618),
    [sym_preproc_endregion] = STATE(1618),
    [sym_preproc_line] = STATE(1618),
    [sym_preproc_pragma] = STATE(1618),
    [sym_preproc_nullable] = STATE(1618),
    [sym_preproc_error] = STATE(1618),
    [sym_preproc_define] = STATE(1618),
    [sym_preproc_undef] = STATE(1618),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1619] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6701),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3580),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1619),
    [sym_preproc_endregion] = STATE(1619),
    [sym_preproc_line] = STATE(1619),
    [sym_preproc_pragma] = STATE(1619),
    [sym_preproc_nullable] = STATE(1619),
    [sym_preproc_error] = STATE(1619),
    [sym_preproc_define] = STATE(1619),
    [sym_preproc_undef] = STATE(1619),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1620] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6416),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1620),
    [sym_preproc_endregion] = STATE(1620),
    [sym_preproc_line] = STATE(1620),
    [sym_preproc_pragma] = STATE(1620),
    [sym_preproc_nullable] = STATE(1620),
    [sym_preproc_error] = STATE(1620),
    [sym_preproc_define] = STATE(1620),
    [sym_preproc_undef] = STATE(1620),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1621] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1621),
    [sym_preproc_endregion] = STATE(1621),
    [sym_preproc_line] = STATE(1621),
    [sym_preproc_pragma] = STATE(1621),
    [sym_preproc_nullable] = STATE(1621),
    [sym_preproc_error] = STATE(1621),
    [sym_preproc_define] = STATE(1621),
    [sym_preproc_undef] = STATE(1621),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1622] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6385),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1622),
    [sym_preproc_endregion] = STATE(1622),
    [sym_preproc_line] = STATE(1622),
    [sym_preproc_pragma] = STATE(1622),
    [sym_preproc_nullable] = STATE(1622),
    [sym_preproc_error] = STATE(1622),
    [sym_preproc_define] = STATE(1622),
    [sym_preproc_undef] = STATE(1622),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1623] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6589),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1623),
    [sym_preproc_endregion] = STATE(1623),
    [sym_preproc_line] = STATE(1623),
    [sym_preproc_pragma] = STATE(1623),
    [sym_preproc_nullable] = STATE(1623),
    [sym_preproc_error] = STATE(1623),
    [sym_preproc_define] = STATE(1623),
    [sym_preproc_undef] = STATE(1623),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1624] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6567),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1624),
    [sym_preproc_endregion] = STATE(1624),
    [sym_preproc_line] = STATE(1624),
    [sym_preproc_pragma] = STATE(1624),
    [sym_preproc_nullable] = STATE(1624),
    [sym_preproc_error] = STATE(1624),
    [sym_preproc_define] = STATE(1624),
    [sym_preproc_undef] = STATE(1624),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1625] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5520),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1625),
    [sym_preproc_endregion] = STATE(1625),
    [sym_preproc_line] = STATE(1625),
    [sym_preproc_pragma] = STATE(1625),
    [sym_preproc_nullable] = STATE(1625),
    [sym_preproc_error] = STATE(1625),
    [sym_preproc_define] = STATE(1625),
    [sym_preproc_undef] = STATE(1625),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1626] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5046),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1626),
    [sym_preproc_endregion] = STATE(1626),
    [sym_preproc_line] = STATE(1626),
    [sym_preproc_pragma] = STATE(1626),
    [sym_preproc_nullable] = STATE(1626),
    [sym_preproc_error] = STATE(1626),
    [sym_preproc_define] = STATE(1626),
    [sym_preproc_undef] = STATE(1626),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1627] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5055),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1627),
    [sym_preproc_endregion] = STATE(1627),
    [sym_preproc_line] = STATE(1627),
    [sym_preproc_pragma] = STATE(1627),
    [sym_preproc_nullable] = STATE(1627),
    [sym_preproc_error] = STATE(1627),
    [sym_preproc_define] = STATE(1627),
    [sym_preproc_undef] = STATE(1627),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1628] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5503),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1628),
    [sym_preproc_endregion] = STATE(1628),
    [sym_preproc_line] = STATE(1628),
    [sym_preproc_pragma] = STATE(1628),
    [sym_preproc_nullable] = STATE(1628),
    [sym_preproc_error] = STATE(1628),
    [sym_preproc_define] = STATE(1628),
    [sym_preproc_undef] = STATE(1628),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1629] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5439),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1629),
    [sym_preproc_endregion] = STATE(1629),
    [sym_preproc_line] = STATE(1629),
    [sym_preproc_pragma] = STATE(1629),
    [sym_preproc_nullable] = STATE(1629),
    [sym_preproc_error] = STATE(1629),
    [sym_preproc_define] = STATE(1629),
    [sym_preproc_undef] = STATE(1629),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1630] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5633),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1630),
    [sym_preproc_endregion] = STATE(1630),
    [sym_preproc_line] = STATE(1630),
    [sym_preproc_pragma] = STATE(1630),
    [sym_preproc_nullable] = STATE(1630),
    [sym_preproc_error] = STATE(1630),
    [sym_preproc_define] = STATE(1630),
    [sym_preproc_undef] = STATE(1630),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1631] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5438),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1631),
    [sym_preproc_endregion] = STATE(1631),
    [sym_preproc_line] = STATE(1631),
    [sym_preproc_pragma] = STATE(1631),
    [sym_preproc_nullable] = STATE(1631),
    [sym_preproc_error] = STATE(1631),
    [sym_preproc_define] = STATE(1631),
    [sym_preproc_undef] = STATE(1631),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1632] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5067),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1632),
    [sym_preproc_endregion] = STATE(1632),
    [sym_preproc_line] = STATE(1632),
    [sym_preproc_pragma] = STATE(1632),
    [sym_preproc_nullable] = STATE(1632),
    [sym_preproc_error] = STATE(1632),
    [sym_preproc_define] = STATE(1632),
    [sym_preproc_undef] = STATE(1632),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1633] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5521),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1633),
    [sym_preproc_endregion] = STATE(1633),
    [sym_preproc_line] = STATE(1633),
    [sym_preproc_pragma] = STATE(1633),
    [sym_preproc_nullable] = STATE(1633),
    [sym_preproc_error] = STATE(1633),
    [sym_preproc_define] = STATE(1633),
    [sym_preproc_undef] = STATE(1633),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1634] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5630),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1634),
    [sym_preproc_endregion] = STATE(1634),
    [sym_preproc_line] = STATE(1634),
    [sym_preproc_pragma] = STATE(1634),
    [sym_preproc_nullable] = STATE(1634),
    [sym_preproc_error] = STATE(1634),
    [sym_preproc_define] = STATE(1634),
    [sym_preproc_undef] = STATE(1634),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1635] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1635),
    [sym_preproc_endregion] = STATE(1635),
    [sym_preproc_line] = STATE(1635),
    [sym_preproc_pragma] = STATE(1635),
    [sym_preproc_nullable] = STATE(1635),
    [sym_preproc_error] = STATE(1635),
    [sym_preproc_define] = STATE(1635),
    [sym_preproc_undef] = STATE(1635),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1636] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5068),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1636),
    [sym_preproc_endregion] = STATE(1636),
    [sym_preproc_line] = STATE(1636),
    [sym_preproc_pragma] = STATE(1636),
    [sym_preproc_nullable] = STATE(1636),
    [sym_preproc_error] = STATE(1636),
    [sym_preproc_define] = STATE(1636),
    [sym_preproc_undef] = STATE(1636),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1637] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5069),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1637),
    [sym_preproc_endregion] = STATE(1637),
    [sym_preproc_line] = STATE(1637),
    [sym_preproc_pragma] = STATE(1637),
    [sym_preproc_nullable] = STATE(1637),
    [sym_preproc_error] = STATE(1637),
    [sym_preproc_define] = STATE(1637),
    [sym_preproc_undef] = STATE(1637),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1638] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6058),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1638),
    [sym_preproc_endregion] = STATE(1638),
    [sym_preproc_line] = STATE(1638),
    [sym_preproc_pragma] = STATE(1638),
    [sym_preproc_nullable] = STATE(1638),
    [sym_preproc_error] = STATE(1638),
    [sym_preproc_define] = STATE(1638),
    [sym_preproc_undef] = STATE(1638),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1639] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5070),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1639),
    [sym_preproc_endregion] = STATE(1639),
    [sym_preproc_line] = STATE(1639),
    [sym_preproc_pragma] = STATE(1639),
    [sym_preproc_nullable] = STATE(1639),
    [sym_preproc_error] = STATE(1639),
    [sym_preproc_define] = STATE(1639),
    [sym_preproc_undef] = STATE(1639),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1640] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6057),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1640),
    [sym_preproc_endregion] = STATE(1640),
    [sym_preproc_line] = STATE(1640),
    [sym_preproc_pragma] = STATE(1640),
    [sym_preproc_nullable] = STATE(1640),
    [sym_preproc_error] = STATE(1640),
    [sym_preproc_define] = STATE(1640),
    [sym_preproc_undef] = STATE(1640),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1641] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5074),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1641),
    [sym_preproc_endregion] = STATE(1641),
    [sym_preproc_line] = STATE(1641),
    [sym_preproc_pragma] = STATE(1641),
    [sym_preproc_nullable] = STATE(1641),
    [sym_preproc_error] = STATE(1641),
    [sym_preproc_define] = STATE(1641),
    [sym_preproc_undef] = STATE(1641),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1642] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5075),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1642),
    [sym_preproc_endregion] = STATE(1642),
    [sym_preproc_line] = STATE(1642),
    [sym_preproc_pragma] = STATE(1642),
    [sym_preproc_nullable] = STATE(1642),
    [sym_preproc_error] = STATE(1642),
    [sym_preproc_define] = STATE(1642),
    [sym_preproc_undef] = STATE(1642),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1643] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6054),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1643),
    [sym_preproc_endregion] = STATE(1643),
    [sym_preproc_line] = STATE(1643),
    [sym_preproc_pragma] = STATE(1643),
    [sym_preproc_nullable] = STATE(1643),
    [sym_preproc_error] = STATE(1643),
    [sym_preproc_define] = STATE(1643),
    [sym_preproc_undef] = STATE(1643),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1644] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1644),
    [sym_preproc_endregion] = STATE(1644),
    [sym_preproc_line] = STATE(1644),
    [sym_preproc_pragma] = STATE(1644),
    [sym_preproc_nullable] = STATE(1644),
    [sym_preproc_error] = STATE(1644),
    [sym_preproc_define] = STATE(1644),
    [sym_preproc_undef] = STATE(1644),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1645] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5627),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1645),
    [sym_preproc_endregion] = STATE(1645),
    [sym_preproc_line] = STATE(1645),
    [sym_preproc_pragma] = STATE(1645),
    [sym_preproc_nullable] = STATE(1645),
    [sym_preproc_error] = STATE(1645),
    [sym_preproc_define] = STATE(1645),
    [sym_preproc_undef] = STATE(1645),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1646] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1646),
    [sym_preproc_endregion] = STATE(1646),
    [sym_preproc_line] = STATE(1646),
    [sym_preproc_pragma] = STATE(1646),
    [sym_preproc_nullable] = STATE(1646),
    [sym_preproc_error] = STATE(1646),
    [sym_preproc_define] = STATE(1646),
    [sym_preproc_undef] = STATE(1646),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1647] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6046),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1647),
    [sym_preproc_endregion] = STATE(1647),
    [sym_preproc_line] = STATE(1647),
    [sym_preproc_pragma] = STATE(1647),
    [sym_preproc_nullable] = STATE(1647),
    [sym_preproc_error] = STATE(1647),
    [sym_preproc_define] = STATE(1647),
    [sym_preproc_undef] = STATE(1647),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1648] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6045),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1648),
    [sym_preproc_endregion] = STATE(1648),
    [sym_preproc_line] = STATE(1648),
    [sym_preproc_pragma] = STATE(1648),
    [sym_preproc_nullable] = STATE(1648),
    [sym_preproc_error] = STATE(1648),
    [sym_preproc_define] = STATE(1648),
    [sym_preproc_undef] = STATE(1648),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1649] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4660),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1649),
    [sym_preproc_endregion] = STATE(1649),
    [sym_preproc_line] = STATE(1649),
    [sym_preproc_pragma] = STATE(1649),
    [sym_preproc_nullable] = STATE(1649),
    [sym_preproc_error] = STATE(1649),
    [sym_preproc_define] = STATE(1649),
    [sym_preproc_undef] = STATE(1649),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1650] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6031),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1650),
    [sym_preproc_endregion] = STATE(1650),
    [sym_preproc_line] = STATE(1650),
    [sym_preproc_pragma] = STATE(1650),
    [sym_preproc_nullable] = STATE(1650),
    [sym_preproc_error] = STATE(1650),
    [sym_preproc_define] = STATE(1650),
    [sym_preproc_undef] = STATE(1650),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1651] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6027),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1651),
    [sym_preproc_endregion] = STATE(1651),
    [sym_preproc_line] = STATE(1651),
    [sym_preproc_pragma] = STATE(1651),
    [sym_preproc_nullable] = STATE(1651),
    [sym_preproc_error] = STATE(1651),
    [sym_preproc_define] = STATE(1651),
    [sym_preproc_undef] = STATE(1651),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1652] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5076),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1652),
    [sym_preproc_endregion] = STATE(1652),
    [sym_preproc_line] = STATE(1652),
    [sym_preproc_pragma] = STATE(1652),
    [sym_preproc_nullable] = STATE(1652),
    [sym_preproc_error] = STATE(1652),
    [sym_preproc_define] = STATE(1652),
    [sym_preproc_undef] = STATE(1652),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1653] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6025),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1653),
    [sym_preproc_endregion] = STATE(1653),
    [sym_preproc_line] = STATE(1653),
    [sym_preproc_pragma] = STATE(1653),
    [sym_preproc_nullable] = STATE(1653),
    [sym_preproc_error] = STATE(1653),
    [sym_preproc_define] = STATE(1653),
    [sym_preproc_undef] = STATE(1653),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1654] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5448),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1654),
    [sym_preproc_endregion] = STATE(1654),
    [sym_preproc_line] = STATE(1654),
    [sym_preproc_pragma] = STATE(1654),
    [sym_preproc_nullable] = STATE(1654),
    [sym_preproc_error] = STATE(1654),
    [sym_preproc_define] = STATE(1654),
    [sym_preproc_undef] = STATE(1654),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1655] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6024),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1655),
    [sym_preproc_endregion] = STATE(1655),
    [sym_preproc_line] = STATE(1655),
    [sym_preproc_pragma] = STATE(1655),
    [sym_preproc_nullable] = STATE(1655),
    [sym_preproc_error] = STATE(1655),
    [sym_preproc_define] = STATE(1655),
    [sym_preproc_undef] = STATE(1655),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1656] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6021),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1656),
    [sym_preproc_endregion] = STATE(1656),
    [sym_preproc_line] = STATE(1656),
    [sym_preproc_pragma] = STATE(1656),
    [sym_preproc_nullable] = STATE(1656),
    [sym_preproc_error] = STATE(1656),
    [sym_preproc_define] = STATE(1656),
    [sym_preproc_undef] = STATE(1656),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1657] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5082),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1657),
    [sym_preproc_endregion] = STATE(1657),
    [sym_preproc_line] = STATE(1657),
    [sym_preproc_pragma] = STATE(1657),
    [sym_preproc_nullable] = STATE(1657),
    [sym_preproc_error] = STATE(1657),
    [sym_preproc_define] = STATE(1657),
    [sym_preproc_undef] = STATE(1657),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1658] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6425),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1658),
    [sym_preproc_endregion] = STATE(1658),
    [sym_preproc_line] = STATE(1658),
    [sym_preproc_pragma] = STATE(1658),
    [sym_preproc_nullable] = STATE(1658),
    [sym_preproc_error] = STATE(1658),
    [sym_preproc_define] = STATE(1658),
    [sym_preproc_undef] = STATE(1658),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1659] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4476),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1659),
    [sym_preproc_endregion] = STATE(1659),
    [sym_preproc_line] = STATE(1659),
    [sym_preproc_pragma] = STATE(1659),
    [sym_preproc_nullable] = STATE(1659),
    [sym_preproc_error] = STATE(1659),
    [sym_preproc_define] = STATE(1659),
    [sym_preproc_undef] = STATE(1659),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1660] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5625),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1660),
    [sym_preproc_endregion] = STATE(1660),
    [sym_preproc_line] = STATE(1660),
    [sym_preproc_pragma] = STATE(1660),
    [sym_preproc_nullable] = STATE(1660),
    [sym_preproc_error] = STATE(1660),
    [sym_preproc_define] = STATE(1660),
    [sym_preproc_undef] = STATE(1660),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1661] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6388),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1661),
    [sym_preproc_endregion] = STATE(1661),
    [sym_preproc_line] = STATE(1661),
    [sym_preproc_pragma] = STATE(1661),
    [sym_preproc_nullable] = STATE(1661),
    [sym_preproc_error] = STATE(1661),
    [sym_preproc_define] = STATE(1661),
    [sym_preproc_undef] = STATE(1661),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1662] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6005),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1662),
    [sym_preproc_endregion] = STATE(1662),
    [sym_preproc_line] = STATE(1662),
    [sym_preproc_pragma] = STATE(1662),
    [sym_preproc_nullable] = STATE(1662),
    [sym_preproc_error] = STATE(1662),
    [sym_preproc_define] = STATE(1662),
    [sym_preproc_undef] = STATE(1662),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1663] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5882),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1663),
    [sym_preproc_endregion] = STATE(1663),
    [sym_preproc_line] = STATE(1663),
    [sym_preproc_pragma] = STATE(1663),
    [sym_preproc_nullable] = STATE(1663),
    [sym_preproc_error] = STATE(1663),
    [sym_preproc_define] = STATE(1663),
    [sym_preproc_undef] = STATE(1663),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1664] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5450),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1664),
    [sym_preproc_endregion] = STATE(1664),
    [sym_preproc_line] = STATE(1664),
    [sym_preproc_pragma] = STATE(1664),
    [sym_preproc_nullable] = STATE(1664),
    [sym_preproc_error] = STATE(1664),
    [sym_preproc_define] = STATE(1664),
    [sym_preproc_undef] = STATE(1664),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1665] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1665),
    [sym_preproc_endregion] = STATE(1665),
    [sym_preproc_line] = STATE(1665),
    [sym_preproc_pragma] = STATE(1665),
    [sym_preproc_nullable] = STATE(1665),
    [sym_preproc_error] = STATE(1665),
    [sym_preproc_define] = STATE(1665),
    [sym_preproc_undef] = STATE(1665),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1666] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5614),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1666),
    [sym_preproc_endregion] = STATE(1666),
    [sym_preproc_line] = STATE(1666),
    [sym_preproc_pragma] = STATE(1666),
    [sym_preproc_nullable] = STATE(1666),
    [sym_preproc_error] = STATE(1666),
    [sym_preproc_define] = STATE(1666),
    [sym_preproc_undef] = STATE(1666),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1667] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5494),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1667),
    [sym_preproc_endregion] = STATE(1667),
    [sym_preproc_line] = STATE(1667),
    [sym_preproc_pragma] = STATE(1667),
    [sym_preproc_nullable] = STATE(1667),
    [sym_preproc_error] = STATE(1667),
    [sym_preproc_define] = STATE(1667),
    [sym_preproc_undef] = STATE(1667),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1668] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5083),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1668),
    [sym_preproc_endregion] = STATE(1668),
    [sym_preproc_line] = STATE(1668),
    [sym_preproc_pragma] = STATE(1668),
    [sym_preproc_nullable] = STATE(1668),
    [sym_preproc_error] = STATE(1668),
    [sym_preproc_define] = STATE(1668),
    [sym_preproc_undef] = STATE(1668),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1669] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5358),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1669),
    [sym_preproc_endregion] = STATE(1669),
    [sym_preproc_line] = STATE(1669),
    [sym_preproc_pragma] = STATE(1669),
    [sym_preproc_nullable] = STATE(1669),
    [sym_preproc_error] = STATE(1669),
    [sym_preproc_define] = STATE(1669),
    [sym_preproc_undef] = STATE(1669),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1670] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5785),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1670),
    [sym_preproc_endregion] = STATE(1670),
    [sym_preproc_line] = STATE(1670),
    [sym_preproc_pragma] = STATE(1670),
    [sym_preproc_nullable] = STATE(1670),
    [sym_preproc_error] = STATE(1670),
    [sym_preproc_define] = STATE(1670),
    [sym_preproc_undef] = STATE(1670),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1671] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4892),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1671),
    [sym_preproc_endregion] = STATE(1671),
    [sym_preproc_line] = STATE(1671),
    [sym_preproc_pragma] = STATE(1671),
    [sym_preproc_nullable] = STATE(1671),
    [sym_preproc_error] = STATE(1671),
    [sym_preproc_define] = STATE(1671),
    [sym_preproc_undef] = STATE(1671),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1672] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6908),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6324),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1672),
    [sym_preproc_endregion] = STATE(1672),
    [sym_preproc_line] = STATE(1672),
    [sym_preproc_pragma] = STATE(1672),
    [sym_preproc_nullable] = STATE(1672),
    [sym_preproc_error] = STATE(1672),
    [sym_preproc_define] = STATE(1672),
    [sym_preproc_undef] = STATE(1672),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1673] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4999),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1673),
    [sym_preproc_endregion] = STATE(1673),
    [sym_preproc_line] = STATE(1673),
    [sym_preproc_pragma] = STATE(1673),
    [sym_preproc_nullable] = STATE(1673),
    [sym_preproc_error] = STATE(1673),
    [sym_preproc_define] = STATE(1673),
    [sym_preproc_undef] = STATE(1673),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1674] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1674),
    [sym_preproc_endregion] = STATE(1674),
    [sym_preproc_line] = STATE(1674),
    [sym_preproc_pragma] = STATE(1674),
    [sym_preproc_nullable] = STATE(1674),
    [sym_preproc_error] = STATE(1674),
    [sym_preproc_define] = STATE(1674),
    [sym_preproc_undef] = STATE(1674),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1675] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5522),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1675),
    [sym_preproc_endregion] = STATE(1675),
    [sym_preproc_line] = STATE(1675),
    [sym_preproc_pragma] = STATE(1675),
    [sym_preproc_nullable] = STATE(1675),
    [sym_preproc_error] = STATE(1675),
    [sym_preproc_define] = STATE(1675),
    [sym_preproc_undef] = STATE(1675),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1676] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1676),
    [sym_preproc_endregion] = STATE(1676),
    [sym_preproc_line] = STATE(1676),
    [sym_preproc_pragma] = STATE(1676),
    [sym_preproc_nullable] = STATE(1676),
    [sym_preproc_error] = STATE(1676),
    [sym_preproc_define] = STATE(1676),
    [sym_preproc_undef] = STATE(1676),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1677] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1677),
    [sym_preproc_endregion] = STATE(1677),
    [sym_preproc_line] = STATE(1677),
    [sym_preproc_pragma] = STATE(1677),
    [sym_preproc_nullable] = STATE(1677),
    [sym_preproc_error] = STATE(1677),
    [sym_preproc_define] = STATE(1677),
    [sym_preproc_undef] = STATE(1677),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1678] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6677),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1678),
    [sym_preproc_endregion] = STATE(1678),
    [sym_preproc_line] = STATE(1678),
    [sym_preproc_pragma] = STATE(1678),
    [sym_preproc_nullable] = STATE(1678),
    [sym_preproc_error] = STATE(1678),
    [sym_preproc_define] = STATE(1678),
    [sym_preproc_undef] = STATE(1678),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1679] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5331),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1679),
    [sym_preproc_endregion] = STATE(1679),
    [sym_preproc_line] = STATE(1679),
    [sym_preproc_pragma] = STATE(1679),
    [sym_preproc_nullable] = STATE(1679),
    [sym_preproc_error] = STATE(1679),
    [sym_preproc_define] = STATE(1679),
    [sym_preproc_undef] = STATE(1679),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1680] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5120),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1680),
    [sym_preproc_endregion] = STATE(1680),
    [sym_preproc_line] = STATE(1680),
    [sym_preproc_pragma] = STATE(1680),
    [sym_preproc_nullable] = STATE(1680),
    [sym_preproc_error] = STATE(1680),
    [sym_preproc_define] = STATE(1680),
    [sym_preproc_undef] = STATE(1680),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1681] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5328),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1681),
    [sym_preproc_endregion] = STATE(1681),
    [sym_preproc_line] = STATE(1681),
    [sym_preproc_pragma] = STATE(1681),
    [sym_preproc_nullable] = STATE(1681),
    [sym_preproc_error] = STATE(1681),
    [sym_preproc_define] = STATE(1681),
    [sym_preproc_undef] = STATE(1681),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1682] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6609),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1682),
    [sym_preproc_endregion] = STATE(1682),
    [sym_preproc_line] = STATE(1682),
    [sym_preproc_pragma] = STATE(1682),
    [sym_preproc_nullable] = STATE(1682),
    [sym_preproc_error] = STATE(1682),
    [sym_preproc_define] = STATE(1682),
    [sym_preproc_undef] = STATE(1682),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1683] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1683),
    [sym_preproc_endregion] = STATE(1683),
    [sym_preproc_line] = STATE(1683),
    [sym_preproc_pragma] = STATE(1683),
    [sym_preproc_nullable] = STATE(1683),
    [sym_preproc_error] = STATE(1683),
    [sym_preproc_define] = STATE(1683),
    [sym_preproc_undef] = STATE(1683),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1684] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6371),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1684),
    [sym_preproc_endregion] = STATE(1684),
    [sym_preproc_line] = STATE(1684),
    [sym_preproc_pragma] = STATE(1684),
    [sym_preproc_nullable] = STATE(1684),
    [sym_preproc_error] = STATE(1684),
    [sym_preproc_define] = STATE(1684),
    [sym_preproc_undef] = STATE(1684),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1685] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5491),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1685),
    [sym_preproc_endregion] = STATE(1685),
    [sym_preproc_line] = STATE(1685),
    [sym_preproc_pragma] = STATE(1685),
    [sym_preproc_nullable] = STATE(1685),
    [sym_preproc_error] = STATE(1685),
    [sym_preproc_define] = STATE(1685),
    [sym_preproc_undef] = STATE(1685),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1686] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5523),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1686),
    [sym_preproc_endregion] = STATE(1686),
    [sym_preproc_line] = STATE(1686),
    [sym_preproc_pragma] = STATE(1686),
    [sym_preproc_nullable] = STATE(1686),
    [sym_preproc_error] = STATE(1686),
    [sym_preproc_define] = STATE(1686),
    [sym_preproc_undef] = STATE(1686),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1687] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5043),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1687),
    [sym_preproc_endregion] = STATE(1687),
    [sym_preproc_line] = STATE(1687),
    [sym_preproc_pragma] = STATE(1687),
    [sym_preproc_nullable] = STATE(1687),
    [sym_preproc_error] = STATE(1687),
    [sym_preproc_define] = STATE(1687),
    [sym_preproc_undef] = STATE(1687),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1688] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5326),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1688),
    [sym_preproc_endregion] = STATE(1688),
    [sym_preproc_line] = STATE(1688),
    [sym_preproc_pragma] = STATE(1688),
    [sym_preproc_nullable] = STATE(1688),
    [sym_preproc_error] = STATE(1688),
    [sym_preproc_define] = STATE(1688),
    [sym_preproc_undef] = STATE(1688),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1689] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1689),
    [sym_preproc_endregion] = STATE(1689),
    [sym_preproc_line] = STATE(1689),
    [sym_preproc_pragma] = STATE(1689),
    [sym_preproc_nullable] = STATE(1689),
    [sym_preproc_error] = STATE(1689),
    [sym_preproc_define] = STATE(1689),
    [sym_preproc_undef] = STATE(1689),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1690] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6594),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1690),
    [sym_preproc_endregion] = STATE(1690),
    [sym_preproc_line] = STATE(1690),
    [sym_preproc_pragma] = STATE(1690),
    [sym_preproc_nullable] = STATE(1690),
    [sym_preproc_error] = STATE(1690),
    [sym_preproc_define] = STATE(1690),
    [sym_preproc_undef] = STATE(1690),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1691] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5493),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1691),
    [sym_preproc_endregion] = STATE(1691),
    [sym_preproc_line] = STATE(1691),
    [sym_preproc_pragma] = STATE(1691),
    [sym_preproc_nullable] = STATE(1691),
    [sym_preproc_error] = STATE(1691),
    [sym_preproc_define] = STATE(1691),
    [sym_preproc_undef] = STATE(1691),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1692] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6330),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1692),
    [sym_preproc_endregion] = STATE(1692),
    [sym_preproc_line] = STATE(1692),
    [sym_preproc_pragma] = STATE(1692),
    [sym_preproc_nullable] = STATE(1692),
    [sym_preproc_error] = STATE(1692),
    [sym_preproc_define] = STATE(1692),
    [sym_preproc_undef] = STATE(1692),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1693] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1693),
    [sym_preproc_endregion] = STATE(1693),
    [sym_preproc_line] = STATE(1693),
    [sym_preproc_pragma] = STATE(1693),
    [sym_preproc_nullable] = STATE(1693),
    [sym_preproc_error] = STATE(1693),
    [sym_preproc_define] = STATE(1693),
    [sym_preproc_undef] = STATE(1693),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1694] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5325),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1694),
    [sym_preproc_endregion] = STATE(1694),
    [sym_preproc_line] = STATE(1694),
    [sym_preproc_pragma] = STATE(1694),
    [sym_preproc_nullable] = STATE(1694),
    [sym_preproc_error] = STATE(1694),
    [sym_preproc_define] = STATE(1694),
    [sym_preproc_undef] = STATE(1694),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1695] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1695),
    [sym_preproc_endregion] = STATE(1695),
    [sym_preproc_line] = STATE(1695),
    [sym_preproc_pragma] = STATE(1695),
    [sym_preproc_nullable] = STATE(1695),
    [sym_preproc_error] = STATE(1695),
    [sym_preproc_define] = STATE(1695),
    [sym_preproc_undef] = STATE(1695),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1696] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1696),
    [sym_preproc_endregion] = STATE(1696),
    [sym_preproc_line] = STATE(1696),
    [sym_preproc_pragma] = STATE(1696),
    [sym_preproc_nullable] = STATE(1696),
    [sym_preproc_error] = STATE(1696),
    [sym_preproc_define] = STATE(1696),
    [sym_preproc_undef] = STATE(1696),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1697] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1697),
    [sym_preproc_endregion] = STATE(1697),
    [sym_preproc_line] = STATE(1697),
    [sym_preproc_pragma] = STATE(1697),
    [sym_preproc_nullable] = STATE(1697),
    [sym_preproc_error] = STATE(1697),
    [sym_preproc_define] = STATE(1697),
    [sym_preproc_undef] = STATE(1697),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1698] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1698),
    [sym_preproc_endregion] = STATE(1698),
    [sym_preproc_line] = STATE(1698),
    [sym_preproc_pragma] = STATE(1698),
    [sym_preproc_nullable] = STATE(1698),
    [sym_preproc_error] = STATE(1698),
    [sym_preproc_define] = STATE(1698),
    [sym_preproc_undef] = STATE(1698),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1699] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5304),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1699),
    [sym_preproc_endregion] = STATE(1699),
    [sym_preproc_line] = STATE(1699),
    [sym_preproc_pragma] = STATE(1699),
    [sym_preproc_nullable] = STATE(1699),
    [sym_preproc_error] = STATE(1699),
    [sym_preproc_define] = STATE(1699),
    [sym_preproc_undef] = STATE(1699),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1700] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5524),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1700),
    [sym_preproc_endregion] = STATE(1700),
    [sym_preproc_line] = STATE(1700),
    [sym_preproc_pragma] = STATE(1700),
    [sym_preproc_nullable] = STATE(1700),
    [sym_preproc_error] = STATE(1700),
    [sym_preproc_define] = STATE(1700),
    [sym_preproc_undef] = STATE(1700),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1701] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3573),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1701),
    [sym_preproc_endregion] = STATE(1701),
    [sym_preproc_line] = STATE(1701),
    [sym_preproc_pragma] = STATE(1701),
    [sym_preproc_nullable] = STATE(1701),
    [sym_preproc_error] = STATE(1701),
    [sym_preproc_define] = STATE(1701),
    [sym_preproc_undef] = STATE(1701),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1702] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1702),
    [sym_preproc_endregion] = STATE(1702),
    [sym_preproc_line] = STATE(1702),
    [sym_preproc_pragma] = STATE(1702),
    [sym_preproc_nullable] = STATE(1702),
    [sym_preproc_error] = STATE(1702),
    [sym_preproc_define] = STATE(1702),
    [sym_preproc_undef] = STATE(1702),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1703] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5047),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1703),
    [sym_preproc_endregion] = STATE(1703),
    [sym_preproc_line] = STATE(1703),
    [sym_preproc_pragma] = STATE(1703),
    [sym_preproc_nullable] = STATE(1703),
    [sym_preproc_error] = STATE(1703),
    [sym_preproc_define] = STATE(1703),
    [sym_preproc_undef] = STATE(1703),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1704] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1704),
    [sym_preproc_endregion] = STATE(1704),
    [sym_preproc_line] = STATE(1704),
    [sym_preproc_pragma] = STATE(1704),
    [sym_preproc_nullable] = STATE(1704),
    [sym_preproc_error] = STATE(1704),
    [sym_preproc_define] = STATE(1704),
    [sym_preproc_undef] = STATE(1704),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1705] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6123),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1705),
    [sym_preproc_endregion] = STATE(1705),
    [sym_preproc_line] = STATE(1705),
    [sym_preproc_pragma] = STATE(1705),
    [sym_preproc_nullable] = STATE(1705),
    [sym_preproc_error] = STATE(1705),
    [sym_preproc_define] = STATE(1705),
    [sym_preproc_undef] = STATE(1705),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1706] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5600),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1706),
    [sym_preproc_endregion] = STATE(1706),
    [sym_preproc_line] = STATE(1706),
    [sym_preproc_pragma] = STATE(1706),
    [sym_preproc_nullable] = STATE(1706),
    [sym_preproc_error] = STATE(1706),
    [sym_preproc_define] = STATE(1706),
    [sym_preproc_undef] = STATE(1706),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1707] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1707),
    [sym_preproc_endregion] = STATE(1707),
    [sym_preproc_line] = STATE(1707),
    [sym_preproc_pragma] = STATE(1707),
    [sym_preproc_nullable] = STATE(1707),
    [sym_preproc_error] = STATE(1707),
    [sym_preproc_define] = STATE(1707),
    [sym_preproc_undef] = STATE(1707),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1708] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6337),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1708),
    [sym_preproc_endregion] = STATE(1708),
    [sym_preproc_line] = STATE(1708),
    [sym_preproc_pragma] = STATE(1708),
    [sym_preproc_nullable] = STATE(1708),
    [sym_preproc_error] = STATE(1708),
    [sym_preproc_define] = STATE(1708),
    [sym_preproc_undef] = STATE(1708),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1709] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4485),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1709),
    [sym_preproc_endregion] = STATE(1709),
    [sym_preproc_line] = STATE(1709),
    [sym_preproc_pragma] = STATE(1709),
    [sym_preproc_nullable] = STATE(1709),
    [sym_preproc_error] = STATE(1709),
    [sym_preproc_define] = STATE(1709),
    [sym_preproc_undef] = STATE(1709),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1710] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6043),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1710),
    [sym_preproc_endregion] = STATE(1710),
    [sym_preproc_line] = STATE(1710),
    [sym_preproc_pragma] = STATE(1710),
    [sym_preproc_nullable] = STATE(1710),
    [sym_preproc_error] = STATE(1710),
    [sym_preproc_define] = STATE(1710),
    [sym_preproc_undef] = STATE(1710),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1711] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7152),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6303),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4404),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7415),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9306),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1711),
    [sym_preproc_endregion] = STATE(1711),
    [sym_preproc_line] = STATE(1711),
    [sym_preproc_pragma] = STATE(1711),
    [sym_preproc_nullable] = STATE(1711),
    [sym_preproc_error] = STATE(1711),
    [sym_preproc_define] = STATE(1711),
    [sym_preproc_undef] = STATE(1711),
    [aux_sym_class_declaration_repeat1] = STATE(3811),
    [aux_sym_lambda_expression_repeat1] = STATE(4092),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_ref] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2021),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2023),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2025),
    [anon_sym_DOT_DOT] = ACTIONS(2027),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1712] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5048),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1712),
    [sym_preproc_endregion] = STATE(1712),
    [sym_preproc_line] = STATE(1712),
    [sym_preproc_pragma] = STATE(1712),
    [sym_preproc_nullable] = STATE(1712),
    [sym_preproc_error] = STATE(1712),
    [sym_preproc_define] = STATE(1712),
    [sym_preproc_undef] = STATE(1712),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1713] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4948),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1713),
    [sym_preproc_endregion] = STATE(1713),
    [sym_preproc_line] = STATE(1713),
    [sym_preproc_pragma] = STATE(1713),
    [sym_preproc_nullable] = STATE(1713),
    [sym_preproc_error] = STATE(1713),
    [sym_preproc_define] = STATE(1713),
    [sym_preproc_undef] = STATE(1713),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1714] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6691),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1714),
    [sym_preproc_endregion] = STATE(1714),
    [sym_preproc_line] = STATE(1714),
    [sym_preproc_pragma] = STATE(1714),
    [sym_preproc_nullable] = STATE(1714),
    [sym_preproc_error] = STATE(1714),
    [sym_preproc_define] = STATE(1714),
    [sym_preproc_undef] = STATE(1714),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1715] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5265),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1715),
    [sym_preproc_endregion] = STATE(1715),
    [sym_preproc_line] = STATE(1715),
    [sym_preproc_pragma] = STATE(1715),
    [sym_preproc_nullable] = STATE(1715),
    [sym_preproc_error] = STATE(1715),
    [sym_preproc_define] = STATE(1715),
    [sym_preproc_undef] = STATE(1715),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1716] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1716),
    [sym_preproc_endregion] = STATE(1716),
    [sym_preproc_line] = STATE(1716),
    [sym_preproc_pragma] = STATE(1716),
    [sym_preproc_nullable] = STATE(1716),
    [sym_preproc_error] = STATE(1716),
    [sym_preproc_define] = STATE(1716),
    [sym_preproc_undef] = STATE(1716),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1717] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6916),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7030),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4133),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7414),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9529),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1717),
    [sym_preproc_endregion] = STATE(1717),
    [sym_preproc_line] = STATE(1717),
    [sym_preproc_pragma] = STATE(1717),
    [sym_preproc_nullable] = STATE(1717),
    [sym_preproc_error] = STATE(1717),
    [sym_preproc_define] = STATE(1717),
    [sym_preproc_undef] = STATE(1717),
    [aux_sym_class_declaration_repeat1] = STATE(3875),
    [aux_sym_lambda_expression_repeat1] = STATE(4324),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_ref] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_CARET] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1741),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1745),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1749),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1718] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1718),
    [sym_preproc_endregion] = STATE(1718),
    [sym_preproc_line] = STATE(1718),
    [sym_preproc_pragma] = STATE(1718),
    [sym_preproc_nullable] = STATE(1718),
    [sym_preproc_error] = STATE(1718),
    [sym_preproc_define] = STATE(1718),
    [sym_preproc_undef] = STATE(1718),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1719] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4832),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1719),
    [sym_preproc_endregion] = STATE(1719),
    [sym_preproc_line] = STATE(1719),
    [sym_preproc_pragma] = STATE(1719),
    [sym_preproc_nullable] = STATE(1719),
    [sym_preproc_error] = STATE(1719),
    [sym_preproc_define] = STATE(1719),
    [sym_preproc_undef] = STATE(1719),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1720] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6659),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1720),
    [sym_preproc_endregion] = STATE(1720),
    [sym_preproc_line] = STATE(1720),
    [sym_preproc_pragma] = STATE(1720),
    [sym_preproc_nullable] = STATE(1720),
    [sym_preproc_error] = STATE(1720),
    [sym_preproc_define] = STATE(1720),
    [sym_preproc_undef] = STATE(1720),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1721] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7038),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6557),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4467),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7411),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9107),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1721),
    [sym_preproc_endregion] = STATE(1721),
    [sym_preproc_line] = STATE(1721),
    [sym_preproc_pragma] = STATE(1721),
    [sym_preproc_nullable] = STATE(1721),
    [sym_preproc_error] = STATE(1721),
    [sym_preproc_define] = STATE(1721),
    [sym_preproc_undef] = STATE(1721),
    [aux_sym_class_declaration_repeat1] = STATE(3829),
    [aux_sym_lambda_expression_repeat1] = STATE(4150),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2225),
    [anon_sym_ref] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2231),
    [anon_sym_DASH] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2235),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2237),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2239),
    [anon_sym_DOT_DOT] = ACTIONS(2241),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1722] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5133),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1722),
    [sym_preproc_endregion] = STATE(1722),
    [sym_preproc_line] = STATE(1722),
    [sym_preproc_pragma] = STATE(1722),
    [sym_preproc_nullable] = STATE(1722),
    [sym_preproc_error] = STATE(1722),
    [sym_preproc_define] = STATE(1722),
    [sym_preproc_undef] = STATE(1722),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1723] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1723),
    [sym_preproc_endregion] = STATE(1723),
    [sym_preproc_line] = STATE(1723),
    [sym_preproc_pragma] = STATE(1723),
    [sym_preproc_nullable] = STATE(1723),
    [sym_preproc_error] = STATE(1723),
    [sym_preproc_define] = STATE(1723),
    [sym_preproc_undef] = STATE(1723),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1724] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5049),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1724),
    [sym_preproc_endregion] = STATE(1724),
    [sym_preproc_line] = STATE(1724),
    [sym_preproc_pragma] = STATE(1724),
    [sym_preproc_nullable] = STATE(1724),
    [sym_preproc_error] = STATE(1724),
    [sym_preproc_define] = STATE(1724),
    [sym_preproc_undef] = STATE(1724),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1725] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1725),
    [sym_preproc_endregion] = STATE(1725),
    [sym_preproc_line] = STATE(1725),
    [sym_preproc_pragma] = STATE(1725),
    [sym_preproc_nullable] = STATE(1725),
    [sym_preproc_error] = STATE(1725),
    [sym_preproc_define] = STATE(1725),
    [sym_preproc_undef] = STATE(1725),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1726] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6662),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1726),
    [sym_preproc_endregion] = STATE(1726),
    [sym_preproc_line] = STATE(1726),
    [sym_preproc_pragma] = STATE(1726),
    [sym_preproc_nullable] = STATE(1726),
    [sym_preproc_error] = STATE(1726),
    [sym_preproc_define] = STATE(1726),
    [sym_preproc_undef] = STATE(1726),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1727] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6443),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1727),
    [sym_preproc_endregion] = STATE(1727),
    [sym_preproc_line] = STATE(1727),
    [sym_preproc_pragma] = STATE(1727),
    [sym_preproc_nullable] = STATE(1727),
    [sym_preproc_error] = STATE(1727),
    [sym_preproc_define] = STATE(1727),
    [sym_preproc_undef] = STATE(1727),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1728] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6448),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1728),
    [sym_preproc_endregion] = STATE(1728),
    [sym_preproc_line] = STATE(1728),
    [sym_preproc_pragma] = STATE(1728),
    [sym_preproc_nullable] = STATE(1728),
    [sym_preproc_error] = STATE(1728),
    [sym_preproc_define] = STATE(1728),
    [sym_preproc_undef] = STATE(1728),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1729] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5134),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1729),
    [sym_preproc_endregion] = STATE(1729),
    [sym_preproc_line] = STATE(1729),
    [sym_preproc_pragma] = STATE(1729),
    [sym_preproc_nullable] = STATE(1729),
    [sym_preproc_error] = STATE(1729),
    [sym_preproc_define] = STATE(1729),
    [sym_preproc_undef] = STATE(1729),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1730] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5330),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1730),
    [sym_preproc_endregion] = STATE(1730),
    [sym_preproc_line] = STATE(1730),
    [sym_preproc_pragma] = STATE(1730),
    [sym_preproc_nullable] = STATE(1730),
    [sym_preproc_error] = STATE(1730),
    [sym_preproc_define] = STATE(1730),
    [sym_preproc_undef] = STATE(1730),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1731] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4466),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1731),
    [sym_preproc_endregion] = STATE(1731),
    [sym_preproc_line] = STATE(1731),
    [sym_preproc_pragma] = STATE(1731),
    [sym_preproc_nullable] = STATE(1731),
    [sym_preproc_error] = STATE(1731),
    [sym_preproc_define] = STATE(1731),
    [sym_preproc_undef] = STATE(1731),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1732] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4458),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1732),
    [sym_preproc_endregion] = STATE(1732),
    [sym_preproc_line] = STATE(1732),
    [sym_preproc_pragma] = STATE(1732),
    [sym_preproc_nullable] = STATE(1732),
    [sym_preproc_error] = STATE(1732),
    [sym_preproc_define] = STATE(1732),
    [sym_preproc_undef] = STATE(1732),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1733] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6663),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1733),
    [sym_preproc_endregion] = STATE(1733),
    [sym_preproc_line] = STATE(1733),
    [sym_preproc_pragma] = STATE(1733),
    [sym_preproc_nullable] = STATE(1733),
    [sym_preproc_error] = STATE(1733),
    [sym_preproc_define] = STATE(1733),
    [sym_preproc_undef] = STATE(1733),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1734] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4457),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1734),
    [sym_preproc_endregion] = STATE(1734),
    [sym_preproc_line] = STATE(1734),
    [sym_preproc_pragma] = STATE(1734),
    [sym_preproc_nullable] = STATE(1734),
    [sym_preproc_error] = STATE(1734),
    [sym_preproc_define] = STATE(1734),
    [sym_preproc_undef] = STATE(1734),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1735] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4464),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1735),
    [sym_preproc_endregion] = STATE(1735),
    [sym_preproc_line] = STATE(1735),
    [sym_preproc_pragma] = STATE(1735),
    [sym_preproc_nullable] = STATE(1735),
    [sym_preproc_error] = STATE(1735),
    [sym_preproc_define] = STATE(1735),
    [sym_preproc_undef] = STATE(1735),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1736] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5329),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1736),
    [sym_preproc_endregion] = STATE(1736),
    [sym_preproc_line] = STATE(1736),
    [sym_preproc_pragma] = STATE(1736),
    [sym_preproc_nullable] = STATE(1736),
    [sym_preproc_error] = STATE(1736),
    [sym_preproc_define] = STATE(1736),
    [sym_preproc_undef] = STATE(1736),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1737] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6056),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1737),
    [sym_preproc_endregion] = STATE(1737),
    [sym_preproc_line] = STATE(1737),
    [sym_preproc_pragma] = STATE(1737),
    [sym_preproc_nullable] = STATE(1737),
    [sym_preproc_error] = STATE(1737),
    [sym_preproc_define] = STATE(1737),
    [sym_preproc_undef] = STATE(1737),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1738] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4430),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1738),
    [sym_preproc_endregion] = STATE(1738),
    [sym_preproc_line] = STATE(1738),
    [sym_preproc_pragma] = STATE(1738),
    [sym_preproc_nullable] = STATE(1738),
    [sym_preproc_error] = STATE(1738),
    [sym_preproc_define] = STATE(1738),
    [sym_preproc_undef] = STATE(1738),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1739] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6701),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3580),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1739),
    [sym_preproc_endregion] = STATE(1739),
    [sym_preproc_line] = STATE(1739),
    [sym_preproc_pragma] = STATE(1739),
    [sym_preproc_nullable] = STATE(1739),
    [sym_preproc_error] = STATE(1739),
    [sym_preproc_define] = STATE(1739),
    [sym_preproc_undef] = STATE(1739),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1740] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4492),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1740),
    [sym_preproc_endregion] = STATE(1740),
    [sym_preproc_line] = STATE(1740),
    [sym_preproc_pragma] = STATE(1740),
    [sym_preproc_nullable] = STATE(1740),
    [sym_preproc_error] = STATE(1740),
    [sym_preproc_define] = STATE(1740),
    [sym_preproc_undef] = STATE(1740),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1741] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4495),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1741),
    [sym_preproc_endregion] = STATE(1741),
    [sym_preproc_line] = STATE(1741),
    [sym_preproc_pragma] = STATE(1741),
    [sym_preproc_nullable] = STATE(1741),
    [sym_preproc_error] = STATE(1741),
    [sym_preproc_define] = STATE(1741),
    [sym_preproc_undef] = STATE(1741),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1742] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4498),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1742),
    [sym_preproc_endregion] = STATE(1742),
    [sym_preproc_line] = STATE(1742),
    [sym_preproc_pragma] = STATE(1742),
    [sym_preproc_nullable] = STATE(1742),
    [sym_preproc_error] = STATE(1742),
    [sym_preproc_define] = STATE(1742),
    [sym_preproc_undef] = STATE(1742),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1743] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6591),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1743),
    [sym_preproc_endregion] = STATE(1743),
    [sym_preproc_line] = STATE(1743),
    [sym_preproc_pragma] = STATE(1743),
    [sym_preproc_nullable] = STATE(1743),
    [sym_preproc_error] = STATE(1743),
    [sym_preproc_define] = STATE(1743),
    [sym_preproc_undef] = STATE(1743),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1744] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1744),
    [sym_preproc_endregion] = STATE(1744),
    [sym_preproc_line] = STATE(1744),
    [sym_preproc_pragma] = STATE(1744),
    [sym_preproc_nullable] = STATE(1744),
    [sym_preproc_error] = STATE(1744),
    [sym_preproc_define] = STATE(1744),
    [sym_preproc_undef] = STATE(1744),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1745] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6611),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1745),
    [sym_preproc_endregion] = STATE(1745),
    [sym_preproc_line] = STATE(1745),
    [sym_preproc_pragma] = STATE(1745),
    [sym_preproc_nullable] = STATE(1745),
    [sym_preproc_error] = STATE(1745),
    [sym_preproc_define] = STATE(1745),
    [sym_preproc_undef] = STATE(1745),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1746] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4503),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1746),
    [sym_preproc_endregion] = STATE(1746),
    [sym_preproc_line] = STATE(1746),
    [sym_preproc_pragma] = STATE(1746),
    [sym_preproc_nullable] = STATE(1746),
    [sym_preproc_error] = STATE(1746),
    [sym_preproc_define] = STATE(1746),
    [sym_preproc_undef] = STATE(1746),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1747] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1747),
    [sym_preproc_endregion] = STATE(1747),
    [sym_preproc_line] = STATE(1747),
    [sym_preproc_pragma] = STATE(1747),
    [sym_preproc_nullable] = STATE(1747),
    [sym_preproc_error] = STATE(1747),
    [sym_preproc_define] = STATE(1747),
    [sym_preproc_undef] = STATE(1747),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1748] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4507),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1748),
    [sym_preproc_endregion] = STATE(1748),
    [sym_preproc_line] = STATE(1748),
    [sym_preproc_pragma] = STATE(1748),
    [sym_preproc_nullable] = STATE(1748),
    [sym_preproc_error] = STATE(1748),
    [sym_preproc_define] = STATE(1748),
    [sym_preproc_undef] = STATE(1748),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1749] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4509),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1749),
    [sym_preproc_endregion] = STATE(1749),
    [sym_preproc_line] = STATE(1749),
    [sym_preproc_pragma] = STATE(1749),
    [sym_preproc_nullable] = STATE(1749),
    [sym_preproc_error] = STATE(1749),
    [sym_preproc_define] = STATE(1749),
    [sym_preproc_undef] = STATE(1749),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1750] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5238),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1750),
    [sym_preproc_endregion] = STATE(1750),
    [sym_preproc_line] = STATE(1750),
    [sym_preproc_pragma] = STATE(1750),
    [sym_preproc_nullable] = STATE(1750),
    [sym_preproc_error] = STATE(1750),
    [sym_preproc_define] = STATE(1750),
    [sym_preproc_undef] = STATE(1750),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1751] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4510),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1751),
    [sym_preproc_endregion] = STATE(1751),
    [sym_preproc_line] = STATE(1751),
    [sym_preproc_pragma] = STATE(1751),
    [sym_preproc_nullable] = STATE(1751),
    [sym_preproc_error] = STATE(1751),
    [sym_preproc_define] = STATE(1751),
    [sym_preproc_undef] = STATE(1751),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1752] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4511),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1752),
    [sym_preproc_endregion] = STATE(1752),
    [sym_preproc_line] = STATE(1752),
    [sym_preproc_pragma] = STATE(1752),
    [sym_preproc_nullable] = STATE(1752),
    [sym_preproc_error] = STATE(1752),
    [sym_preproc_define] = STATE(1752),
    [sym_preproc_undef] = STATE(1752),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1753] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1753),
    [sym_preproc_endregion] = STATE(1753),
    [sym_preproc_line] = STATE(1753),
    [sym_preproc_pragma] = STATE(1753),
    [sym_preproc_nullable] = STATE(1753),
    [sym_preproc_error] = STATE(1753),
    [sym_preproc_define] = STATE(1753),
    [sym_preproc_undef] = STATE(1753),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1754] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5905),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1754),
    [sym_preproc_endregion] = STATE(1754),
    [sym_preproc_line] = STATE(1754),
    [sym_preproc_pragma] = STATE(1754),
    [sym_preproc_nullable] = STATE(1754),
    [sym_preproc_error] = STATE(1754),
    [sym_preproc_define] = STATE(1754),
    [sym_preproc_undef] = STATE(1754),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1755] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5247),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1755),
    [sym_preproc_endregion] = STATE(1755),
    [sym_preproc_line] = STATE(1755),
    [sym_preproc_pragma] = STATE(1755),
    [sym_preproc_nullable] = STATE(1755),
    [sym_preproc_error] = STATE(1755),
    [sym_preproc_define] = STATE(1755),
    [sym_preproc_undef] = STATE(1755),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1756] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5668),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1756),
    [sym_preproc_endregion] = STATE(1756),
    [sym_preproc_line] = STATE(1756),
    [sym_preproc_pragma] = STATE(1756),
    [sym_preproc_nullable] = STATE(1756),
    [sym_preproc_error] = STATE(1756),
    [sym_preproc_define] = STATE(1756),
    [sym_preproc_undef] = STATE(1756),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1757] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5667),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1757),
    [sym_preproc_endregion] = STATE(1757),
    [sym_preproc_line] = STATE(1757),
    [sym_preproc_pragma] = STATE(1757),
    [sym_preproc_nullable] = STATE(1757),
    [sym_preproc_error] = STATE(1757),
    [sym_preproc_define] = STATE(1757),
    [sym_preproc_undef] = STATE(1757),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1758] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5862),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1758),
    [sym_preproc_endregion] = STATE(1758),
    [sym_preproc_line] = STATE(1758),
    [sym_preproc_pragma] = STATE(1758),
    [sym_preproc_nullable] = STATE(1758),
    [sym_preproc_error] = STATE(1758),
    [sym_preproc_define] = STATE(1758),
    [sym_preproc_undef] = STATE(1758),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1759] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5847),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1759),
    [sym_preproc_endregion] = STATE(1759),
    [sym_preproc_line] = STATE(1759),
    [sym_preproc_pragma] = STATE(1759),
    [sym_preproc_nullable] = STATE(1759),
    [sym_preproc_error] = STATE(1759),
    [sym_preproc_define] = STATE(1759),
    [sym_preproc_undef] = STATE(1759),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1760] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5666),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1760),
    [sym_preproc_endregion] = STATE(1760),
    [sym_preproc_line] = STATE(1760),
    [sym_preproc_pragma] = STATE(1760),
    [sym_preproc_nullable] = STATE(1760),
    [sym_preproc_error] = STATE(1760),
    [sym_preproc_define] = STATE(1760),
    [sym_preproc_undef] = STATE(1760),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1761] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5254),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1761),
    [sym_preproc_endregion] = STATE(1761),
    [sym_preproc_line] = STATE(1761),
    [sym_preproc_pragma] = STATE(1761),
    [sym_preproc_nullable] = STATE(1761),
    [sym_preproc_error] = STATE(1761),
    [sym_preproc_define] = STATE(1761),
    [sym_preproc_undef] = STATE(1761),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1762] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5664),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1762),
    [sym_preproc_endregion] = STATE(1762),
    [sym_preproc_line] = STATE(1762),
    [sym_preproc_pragma] = STATE(1762),
    [sym_preproc_nullable] = STATE(1762),
    [sym_preproc_error] = STATE(1762),
    [sym_preproc_define] = STATE(1762),
    [sym_preproc_undef] = STATE(1762),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1763] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1763),
    [sym_preproc_endregion] = STATE(1763),
    [sym_preproc_line] = STATE(1763),
    [sym_preproc_pragma] = STATE(1763),
    [sym_preproc_nullable] = STATE(1763),
    [sym_preproc_error] = STATE(1763),
    [sym_preproc_define] = STATE(1763),
    [sym_preproc_undef] = STATE(1763),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1764] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5499),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1764),
    [sym_preproc_endregion] = STATE(1764),
    [sym_preproc_line] = STATE(1764),
    [sym_preproc_pragma] = STATE(1764),
    [sym_preproc_nullable] = STATE(1764),
    [sym_preproc_error] = STATE(1764),
    [sym_preproc_define] = STATE(1764),
    [sym_preproc_undef] = STATE(1764),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1765] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5662),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1765),
    [sym_preproc_endregion] = STATE(1765),
    [sym_preproc_line] = STATE(1765),
    [sym_preproc_pragma] = STATE(1765),
    [sym_preproc_nullable] = STATE(1765),
    [sym_preproc_error] = STATE(1765),
    [sym_preproc_define] = STATE(1765),
    [sym_preproc_undef] = STATE(1765),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1766] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4514),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1766),
    [sym_preproc_endregion] = STATE(1766),
    [sym_preproc_line] = STATE(1766),
    [sym_preproc_pragma] = STATE(1766),
    [sym_preproc_nullable] = STATE(1766),
    [sym_preproc_error] = STATE(1766),
    [sym_preproc_define] = STATE(1766),
    [sym_preproc_undef] = STATE(1766),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1767] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5859),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1767),
    [sym_preproc_endregion] = STATE(1767),
    [sym_preproc_line] = STATE(1767),
    [sym_preproc_pragma] = STATE(1767),
    [sym_preproc_nullable] = STATE(1767),
    [sym_preproc_error] = STATE(1767),
    [sym_preproc_define] = STATE(1767),
    [sym_preproc_undef] = STATE(1767),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1768] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6277),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1768),
    [sym_preproc_endregion] = STATE(1768),
    [sym_preproc_line] = STATE(1768),
    [sym_preproc_pragma] = STATE(1768),
    [sym_preproc_nullable] = STATE(1768),
    [sym_preproc_error] = STATE(1768),
    [sym_preproc_define] = STATE(1768),
    [sym_preproc_undef] = STATE(1768),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1769] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1769),
    [sym_preproc_endregion] = STATE(1769),
    [sym_preproc_line] = STATE(1769),
    [sym_preproc_pragma] = STATE(1769),
    [sym_preproc_nullable] = STATE(1769),
    [sym_preproc_error] = STATE(1769),
    [sym_preproc_define] = STATE(1769),
    [sym_preproc_undef] = STATE(1769),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1770] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5873),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1770),
    [sym_preproc_endregion] = STATE(1770),
    [sym_preproc_line] = STATE(1770),
    [sym_preproc_pragma] = STATE(1770),
    [sym_preproc_nullable] = STATE(1770),
    [sym_preproc_error] = STATE(1770),
    [sym_preproc_define] = STATE(1770),
    [sym_preproc_undef] = STATE(1770),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1771] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1771),
    [sym_preproc_endregion] = STATE(1771),
    [sym_preproc_line] = STATE(1771),
    [sym_preproc_pragma] = STATE(1771),
    [sym_preproc_nullable] = STATE(1771),
    [sym_preproc_error] = STATE(1771),
    [sym_preproc_define] = STATE(1771),
    [sym_preproc_undef] = STATE(1771),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1772] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6624),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1772),
    [sym_preproc_endregion] = STATE(1772),
    [sym_preproc_line] = STATE(1772),
    [sym_preproc_pragma] = STATE(1772),
    [sym_preproc_nullable] = STATE(1772),
    [sym_preproc_error] = STATE(1772),
    [sym_preproc_define] = STATE(1772),
    [sym_preproc_undef] = STATE(1772),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1773] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5050),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1773),
    [sym_preproc_endregion] = STATE(1773),
    [sym_preproc_line] = STATE(1773),
    [sym_preproc_pragma] = STATE(1773),
    [sym_preproc_nullable] = STATE(1773),
    [sym_preproc_error] = STATE(1773),
    [sym_preproc_define] = STATE(1773),
    [sym_preproc_undef] = STATE(1773),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1774] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5124),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1774),
    [sym_preproc_endregion] = STATE(1774),
    [sym_preproc_line] = STATE(1774),
    [sym_preproc_pragma] = STATE(1774),
    [sym_preproc_nullable] = STATE(1774),
    [sym_preproc_error] = STATE(1774),
    [sym_preproc_define] = STATE(1774),
    [sym_preproc_undef] = STATE(1774),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1775] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6632),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1775),
    [sym_preproc_endregion] = STATE(1775),
    [sym_preproc_line] = STATE(1775),
    [sym_preproc_pragma] = STATE(1775),
    [sym_preproc_nullable] = STATE(1775),
    [sym_preproc_error] = STATE(1775),
    [sym_preproc_define] = STATE(1775),
    [sym_preproc_undef] = STATE(1775),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1776] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4575),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1776),
    [sym_preproc_endregion] = STATE(1776),
    [sym_preproc_line] = STATE(1776),
    [sym_preproc_pragma] = STATE(1776),
    [sym_preproc_nullable] = STATE(1776),
    [sym_preproc_error] = STATE(1776),
    [sym_preproc_define] = STATE(1776),
    [sym_preproc_undef] = STATE(1776),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1777] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1777),
    [sym_preproc_endregion] = STATE(1777),
    [sym_preproc_line] = STATE(1777),
    [sym_preproc_pragma] = STATE(1777),
    [sym_preproc_nullable] = STATE(1777),
    [sym_preproc_error] = STATE(1777),
    [sym_preproc_define] = STATE(1777),
    [sym_preproc_undef] = STATE(1777),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1778] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6311),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1778),
    [sym_preproc_endregion] = STATE(1778),
    [sym_preproc_line] = STATE(1778),
    [sym_preproc_pragma] = STATE(1778),
    [sym_preproc_nullable] = STATE(1778),
    [sym_preproc_error] = STATE(1778),
    [sym_preproc_define] = STATE(1778),
    [sym_preproc_undef] = STATE(1778),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1779] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4574),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1779),
    [sym_preproc_endregion] = STATE(1779),
    [sym_preproc_line] = STATE(1779),
    [sym_preproc_pragma] = STATE(1779),
    [sym_preproc_nullable] = STATE(1779),
    [sym_preproc_error] = STATE(1779),
    [sym_preproc_define] = STATE(1779),
    [sym_preproc_undef] = STATE(1779),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1780] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1780),
    [sym_preproc_endregion] = STATE(1780),
    [sym_preproc_line] = STATE(1780),
    [sym_preproc_pragma] = STATE(1780),
    [sym_preproc_nullable] = STATE(1780),
    [sym_preproc_error] = STATE(1780),
    [sym_preproc_define] = STATE(1780),
    [sym_preproc_undef] = STATE(1780),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1781] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5661),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1781),
    [sym_preproc_endregion] = STATE(1781),
    [sym_preproc_line] = STATE(1781),
    [sym_preproc_pragma] = STATE(1781),
    [sym_preproc_nullable] = STATE(1781),
    [sym_preproc_error] = STATE(1781),
    [sym_preproc_define] = STATE(1781),
    [sym_preproc_undef] = STATE(1781),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1782] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5881),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1782),
    [sym_preproc_endregion] = STATE(1782),
    [sym_preproc_line] = STATE(1782),
    [sym_preproc_pragma] = STATE(1782),
    [sym_preproc_nullable] = STATE(1782),
    [sym_preproc_error] = STATE(1782),
    [sym_preproc_define] = STATE(1782),
    [sym_preproc_undef] = STATE(1782),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1783] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6674),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1783),
    [sym_preproc_endregion] = STATE(1783),
    [sym_preproc_line] = STATE(1783),
    [sym_preproc_pragma] = STATE(1783),
    [sym_preproc_nullable] = STATE(1783),
    [sym_preproc_error] = STATE(1783),
    [sym_preproc_define] = STATE(1783),
    [sym_preproc_undef] = STATE(1783),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1784] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5901),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1784),
    [sym_preproc_endregion] = STATE(1784),
    [sym_preproc_line] = STATE(1784),
    [sym_preproc_pragma] = STATE(1784),
    [sym_preproc_nullable] = STATE(1784),
    [sym_preproc_error] = STATE(1784),
    [sym_preproc_define] = STATE(1784),
    [sym_preproc_undef] = STATE(1784),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1785] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5904),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1785),
    [sym_preproc_endregion] = STATE(1785),
    [sym_preproc_line] = STATE(1785),
    [sym_preproc_pragma] = STATE(1785),
    [sym_preproc_nullable] = STATE(1785),
    [sym_preproc_error] = STATE(1785),
    [sym_preproc_define] = STATE(1785),
    [sym_preproc_undef] = STATE(1785),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1786] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5913),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1786),
    [sym_preproc_endregion] = STATE(1786),
    [sym_preproc_line] = STATE(1786),
    [sym_preproc_pragma] = STATE(1786),
    [sym_preproc_nullable] = STATE(1786),
    [sym_preproc_error] = STATE(1786),
    [sym_preproc_define] = STATE(1786),
    [sym_preproc_undef] = STATE(1786),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1787] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5914),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1787),
    [sym_preproc_endregion] = STATE(1787),
    [sym_preproc_line] = STATE(1787),
    [sym_preproc_pragma] = STATE(1787),
    [sym_preproc_nullable] = STATE(1787),
    [sym_preproc_error] = STATE(1787),
    [sym_preproc_define] = STATE(1787),
    [sym_preproc_undef] = STATE(1787),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1788] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5924),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1788),
    [sym_preproc_endregion] = STATE(1788),
    [sym_preproc_line] = STATE(1788),
    [sym_preproc_pragma] = STATE(1788),
    [sym_preproc_nullable] = STATE(1788),
    [sym_preproc_error] = STATE(1788),
    [sym_preproc_define] = STATE(1788),
    [sym_preproc_undef] = STATE(1788),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1789] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5935),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1789),
    [sym_preproc_endregion] = STATE(1789),
    [sym_preproc_line] = STATE(1789),
    [sym_preproc_pragma] = STATE(1789),
    [sym_preproc_nullable] = STATE(1789),
    [sym_preproc_error] = STATE(1789),
    [sym_preproc_define] = STATE(1789),
    [sym_preproc_undef] = STATE(1789),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1790] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5942),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1790),
    [sym_preproc_endregion] = STATE(1790),
    [sym_preproc_line] = STATE(1790),
    [sym_preproc_pragma] = STATE(1790),
    [sym_preproc_nullable] = STATE(1790),
    [sym_preproc_error] = STATE(1790),
    [sym_preproc_define] = STATE(1790),
    [sym_preproc_undef] = STATE(1790),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1791] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5219),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1791),
    [sym_preproc_endregion] = STATE(1791),
    [sym_preproc_line] = STATE(1791),
    [sym_preproc_pragma] = STATE(1791),
    [sym_preproc_nullable] = STATE(1791),
    [sym_preproc_error] = STATE(1791),
    [sym_preproc_define] = STATE(1791),
    [sym_preproc_undef] = STATE(1791),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1792] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6109),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1792),
    [sym_preproc_endregion] = STATE(1792),
    [sym_preproc_line] = STATE(1792),
    [sym_preproc_pragma] = STATE(1792),
    [sym_preproc_nullable] = STATE(1792),
    [sym_preproc_error] = STATE(1792),
    [sym_preproc_define] = STATE(1792),
    [sym_preproc_undef] = STATE(1792),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1793] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6016),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1793),
    [sym_preproc_endregion] = STATE(1793),
    [sym_preproc_line] = STATE(1793),
    [sym_preproc_pragma] = STATE(1793),
    [sym_preproc_nullable] = STATE(1793),
    [sym_preproc_error] = STATE(1793),
    [sym_preproc_define] = STATE(1793),
    [sym_preproc_undef] = STATE(1793),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1794] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5956),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1794),
    [sym_preproc_endregion] = STATE(1794),
    [sym_preproc_line] = STATE(1794),
    [sym_preproc_pragma] = STATE(1794),
    [sym_preproc_nullable] = STATE(1794),
    [sym_preproc_error] = STATE(1794),
    [sym_preproc_define] = STATE(1794),
    [sym_preproc_undef] = STATE(1794),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1795] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6606),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1795),
    [sym_preproc_endregion] = STATE(1795),
    [sym_preproc_line] = STATE(1795),
    [sym_preproc_pragma] = STATE(1795),
    [sym_preproc_nullable] = STATE(1795),
    [sym_preproc_error] = STATE(1795),
    [sym_preproc_define] = STATE(1795),
    [sym_preproc_undef] = STATE(1795),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1796] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5660),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1796),
    [sym_preproc_endregion] = STATE(1796),
    [sym_preproc_line] = STATE(1796),
    [sym_preproc_pragma] = STATE(1796),
    [sym_preproc_nullable] = STATE(1796),
    [sym_preproc_error] = STATE(1796),
    [sym_preproc_define] = STATE(1796),
    [sym_preproc_undef] = STATE(1796),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1797] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5701),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1797),
    [sym_preproc_endregion] = STATE(1797),
    [sym_preproc_line] = STATE(1797),
    [sym_preproc_pragma] = STATE(1797),
    [sym_preproc_nullable] = STATE(1797),
    [sym_preproc_error] = STATE(1797),
    [sym_preproc_define] = STATE(1797),
    [sym_preproc_undef] = STATE(1797),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1798] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4573),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1798),
    [sym_preproc_endregion] = STATE(1798),
    [sym_preproc_line] = STATE(1798),
    [sym_preproc_pragma] = STATE(1798),
    [sym_preproc_nullable] = STATE(1798),
    [sym_preproc_error] = STATE(1798),
    [sym_preproc_define] = STATE(1798),
    [sym_preproc_undef] = STATE(1798),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1799] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5051),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1799),
    [sym_preproc_endregion] = STATE(1799),
    [sym_preproc_line] = STATE(1799),
    [sym_preproc_pragma] = STATE(1799),
    [sym_preproc_nullable] = STATE(1799),
    [sym_preproc_error] = STATE(1799),
    [sym_preproc_define] = STATE(1799),
    [sym_preproc_undef] = STATE(1799),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1800] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5324),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1800),
    [sym_preproc_endregion] = STATE(1800),
    [sym_preproc_line] = STATE(1800),
    [sym_preproc_pragma] = STATE(1800),
    [sym_preproc_nullable] = STATE(1800),
    [sym_preproc_error] = STATE(1800),
    [sym_preproc_define] = STATE(1800),
    [sym_preproc_undef] = STATE(1800),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1801] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5500),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1801),
    [sym_preproc_endregion] = STATE(1801),
    [sym_preproc_line] = STATE(1801),
    [sym_preproc_pragma] = STATE(1801),
    [sym_preproc_nullable] = STATE(1801),
    [sym_preproc_error] = STATE(1801),
    [sym_preproc_define] = STATE(1801),
    [sym_preproc_undef] = STATE(1801),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1802] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1802),
    [sym_preproc_endregion] = STATE(1802),
    [sym_preproc_line] = STATE(1802),
    [sym_preproc_pragma] = STATE(1802),
    [sym_preproc_nullable] = STATE(1802),
    [sym_preproc_error] = STATE(1802),
    [sym_preproc_define] = STATE(1802),
    [sym_preproc_undef] = STATE(1802),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1803] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6278),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1803),
    [sym_preproc_endregion] = STATE(1803),
    [sym_preproc_line] = STATE(1803),
    [sym_preproc_pragma] = STATE(1803),
    [sym_preproc_nullable] = STATE(1803),
    [sym_preproc_error] = STATE(1803),
    [sym_preproc_define] = STATE(1803),
    [sym_preproc_undef] = STATE(1803),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1804] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6525),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1804),
    [sym_preproc_endregion] = STATE(1804),
    [sym_preproc_line] = STATE(1804),
    [sym_preproc_pragma] = STATE(1804),
    [sym_preproc_nullable] = STATE(1804),
    [sym_preproc_error] = STATE(1804),
    [sym_preproc_define] = STATE(1804),
    [sym_preproc_undef] = STATE(1804),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1805] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6282),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1805),
    [sym_preproc_endregion] = STATE(1805),
    [sym_preproc_line] = STATE(1805),
    [sym_preproc_pragma] = STATE(1805),
    [sym_preproc_nullable] = STATE(1805),
    [sym_preproc_error] = STATE(1805),
    [sym_preproc_define] = STATE(1805),
    [sym_preproc_undef] = STATE(1805),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1806] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7106),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6106),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4342),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7420),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9393),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1806),
    [sym_preproc_endregion] = STATE(1806),
    [sym_preproc_line] = STATE(1806),
    [sym_preproc_pragma] = STATE(1806),
    [sym_preproc_nullable] = STATE(1806),
    [sym_preproc_error] = STATE(1806),
    [sym_preproc_define] = STATE(1806),
    [sym_preproc_undef] = STATE(1806),
    [aux_sym_class_declaration_repeat1] = STATE(3814),
    [aux_sym_lambda_expression_repeat1] = STATE(4154),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_ref] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_TILDE] = ACTIONS(1619),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1619),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1807] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6423),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1807),
    [sym_preproc_endregion] = STATE(1807),
    [sym_preproc_line] = STATE(1807),
    [sym_preproc_pragma] = STATE(1807),
    [sym_preproc_nullable] = STATE(1807),
    [sym_preproc_error] = STATE(1807),
    [sym_preproc_define] = STATE(1807),
    [sym_preproc_undef] = STATE(1807),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1808] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6905),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6430),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1808),
    [sym_preproc_endregion] = STATE(1808),
    [sym_preproc_line] = STATE(1808),
    [sym_preproc_pragma] = STATE(1808),
    [sym_preproc_nullable] = STATE(1808),
    [sym_preproc_error] = STATE(1808),
    [sym_preproc_define] = STATE(1808),
    [sym_preproc_undef] = STATE(1808),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1809] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5036),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1809),
    [sym_preproc_endregion] = STATE(1809),
    [sym_preproc_line] = STATE(1809),
    [sym_preproc_pragma] = STATE(1809),
    [sym_preproc_nullable] = STATE(1809),
    [sym_preproc_error] = STATE(1809),
    [sym_preproc_define] = STATE(1809),
    [sym_preproc_undef] = STATE(1809),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1810] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5501),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1810),
    [sym_preproc_endregion] = STATE(1810),
    [sym_preproc_line] = STATE(1810),
    [sym_preproc_pragma] = STATE(1810),
    [sym_preproc_nullable] = STATE(1810),
    [sym_preproc_error] = STATE(1810),
    [sym_preproc_define] = STATE(1810),
    [sym_preproc_undef] = STATE(1810),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1811] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1811),
    [sym_preproc_endregion] = STATE(1811),
    [sym_preproc_line] = STATE(1811),
    [sym_preproc_pragma] = STATE(1811),
    [sym_preproc_nullable] = STATE(1811),
    [sym_preproc_error] = STATE(1811),
    [sym_preproc_define] = STATE(1811),
    [sym_preproc_undef] = STATE(1811),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1812] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1812),
    [sym_preproc_endregion] = STATE(1812),
    [sym_preproc_line] = STATE(1812),
    [sym_preproc_pragma] = STATE(1812),
    [sym_preproc_nullable] = STATE(1812),
    [sym_preproc_error] = STATE(1812),
    [sym_preproc_define] = STATE(1812),
    [sym_preproc_undef] = STATE(1812),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1813] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6542),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1813),
    [sym_preproc_endregion] = STATE(1813),
    [sym_preproc_line] = STATE(1813),
    [sym_preproc_pragma] = STATE(1813),
    [sym_preproc_nullable] = STATE(1813),
    [sym_preproc_error] = STATE(1813),
    [sym_preproc_define] = STATE(1813),
    [sym_preproc_undef] = STATE(1813),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1814] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6910),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6543),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1814),
    [sym_preproc_endregion] = STATE(1814),
    [sym_preproc_line] = STATE(1814),
    [sym_preproc_pragma] = STATE(1814),
    [sym_preproc_nullable] = STATE(1814),
    [sym_preproc_error] = STATE(1814),
    [sym_preproc_define] = STATE(1814),
    [sym_preproc_undef] = STATE(1814),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1815] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5032),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1815),
    [sym_preproc_endregion] = STATE(1815),
    [sym_preproc_line] = STATE(1815),
    [sym_preproc_pragma] = STATE(1815),
    [sym_preproc_nullable] = STATE(1815),
    [sym_preproc_error] = STATE(1815),
    [sym_preproc_define] = STATE(1815),
    [sym_preproc_undef] = STATE(1815),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1816] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6474),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7130),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4538),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9064),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1816),
    [sym_preproc_endregion] = STATE(1816),
    [sym_preproc_line] = STATE(1816),
    [sym_preproc_pragma] = STATE(1816),
    [sym_preproc_nullable] = STATE(1816),
    [sym_preproc_error] = STATE(1816),
    [sym_preproc_define] = STATE(1816),
    [sym_preproc_undef] = STATE(1816),
    [aux_sym_class_declaration_repeat1] = STATE(3873),
    [aux_sym_lambda_expression_repeat1] = STATE(4273),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1951),
    [anon_sym_TILDE] = ACTIONS(1951),
    [anon_sym_PLUS_PLUS] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1951),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1313),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1315),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1817] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5338),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1817),
    [sym_preproc_endregion] = STATE(1817),
    [sym_preproc_line] = STATE(1817),
    [sym_preproc_pragma] = STATE(1817),
    [sym_preproc_nullable] = STATE(1817),
    [sym_preproc_error] = STATE(1817),
    [sym_preproc_define] = STATE(1817),
    [sym_preproc_undef] = STATE(1817),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1818] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6341),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1818),
    [sym_preproc_endregion] = STATE(1818),
    [sym_preproc_line] = STATE(1818),
    [sym_preproc_pragma] = STATE(1818),
    [sym_preproc_nullable] = STATE(1818),
    [sym_preproc_error] = STATE(1818),
    [sym_preproc_define] = STATE(1818),
    [sym_preproc_undef] = STATE(1818),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1819] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5681),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1819),
    [sym_preproc_endregion] = STATE(1819),
    [sym_preproc_line] = STATE(1819),
    [sym_preproc_pragma] = STATE(1819),
    [sym_preproc_nullable] = STATE(1819),
    [sym_preproc_error] = STATE(1819),
    [sym_preproc_define] = STATE(1819),
    [sym_preproc_undef] = STATE(1819),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1820] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6932),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6676),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1820),
    [sym_preproc_endregion] = STATE(1820),
    [sym_preproc_line] = STATE(1820),
    [sym_preproc_pragma] = STATE(1820),
    [sym_preproc_nullable] = STATE(1820),
    [sym_preproc_error] = STATE(1820),
    [sym_preproc_define] = STATE(1820),
    [sym_preproc_undef] = STATE(1820),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1821] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5680),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1821),
    [sym_preproc_endregion] = STATE(1821),
    [sym_preproc_line] = STATE(1821),
    [sym_preproc_pragma] = STATE(1821),
    [sym_preproc_nullable] = STATE(1821),
    [sym_preproc_error] = STATE(1821),
    [sym_preproc_define] = STATE(1821),
    [sym_preproc_undef] = STATE(1821),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1822] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5676),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1822),
    [sym_preproc_endregion] = STATE(1822),
    [sym_preproc_line] = STATE(1822),
    [sym_preproc_pragma] = STATE(1822),
    [sym_preproc_nullable] = STATE(1822),
    [sym_preproc_error] = STATE(1822),
    [sym_preproc_define] = STATE(1822),
    [sym_preproc_undef] = STATE(1822),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1823] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5073),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1823),
    [sym_preproc_endregion] = STATE(1823),
    [sym_preproc_line] = STATE(1823),
    [sym_preproc_pragma] = STATE(1823),
    [sym_preproc_nullable] = STATE(1823),
    [sym_preproc_error] = STATE(1823),
    [sym_preproc_define] = STATE(1823),
    [sym_preproc_undef] = STATE(1823),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1824] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6618),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1824),
    [sym_preproc_endregion] = STATE(1824),
    [sym_preproc_line] = STATE(1824),
    [sym_preproc_pragma] = STATE(1824),
    [sym_preproc_nullable] = STATE(1824),
    [sym_preproc_error] = STATE(1824),
    [sym_preproc_define] = STATE(1824),
    [sym_preproc_undef] = STATE(1824),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1825] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5052),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1825),
    [sym_preproc_endregion] = STATE(1825),
    [sym_preproc_line] = STATE(1825),
    [sym_preproc_pragma] = STATE(1825),
    [sym_preproc_nullable] = STATE(1825),
    [sym_preproc_error] = STATE(1825),
    [sym_preproc_define] = STATE(1825),
    [sym_preproc_undef] = STATE(1825),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1826] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6289),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1826),
    [sym_preproc_endregion] = STATE(1826),
    [sym_preproc_line] = STATE(1826),
    [sym_preproc_pragma] = STATE(1826),
    [sym_preproc_nullable] = STATE(1826),
    [sym_preproc_error] = STATE(1826),
    [sym_preproc_define] = STATE(1826),
    [sym_preproc_undef] = STATE(1826),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1827] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5674),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1827),
    [sym_preproc_endregion] = STATE(1827),
    [sym_preproc_line] = STATE(1827),
    [sym_preproc_pragma] = STATE(1827),
    [sym_preproc_nullable] = STATE(1827),
    [sym_preproc_error] = STATE(1827),
    [sym_preproc_define] = STATE(1827),
    [sym_preproc_undef] = STATE(1827),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1828] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5672),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1828),
    [sym_preproc_endregion] = STATE(1828),
    [sym_preproc_line] = STATE(1828),
    [sym_preproc_pragma] = STATE(1828),
    [sym_preproc_nullable] = STATE(1828),
    [sym_preproc_error] = STATE(1828),
    [sym_preproc_define] = STATE(1828),
    [sym_preproc_undef] = STATE(1828),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1829] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5670),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1829),
    [sym_preproc_endregion] = STATE(1829),
    [sym_preproc_line] = STATE(1829),
    [sym_preproc_pragma] = STATE(1829),
    [sym_preproc_nullable] = STATE(1829),
    [sym_preproc_error] = STATE(1829),
    [sym_preproc_define] = STATE(1829),
    [sym_preproc_undef] = STATE(1829),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1830] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4703),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1830),
    [sym_preproc_endregion] = STATE(1830),
    [sym_preproc_line] = STATE(1830),
    [sym_preproc_pragma] = STATE(1830),
    [sym_preproc_nullable] = STATE(1830),
    [sym_preproc_error] = STATE(1830),
    [sym_preproc_define] = STATE(1830),
    [sym_preproc_undef] = STATE(1830),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1831] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6529),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1831),
    [sym_preproc_endregion] = STATE(1831),
    [sym_preproc_line] = STATE(1831),
    [sym_preproc_pragma] = STATE(1831),
    [sym_preproc_nullable] = STATE(1831),
    [sym_preproc_error] = STATE(1831),
    [sym_preproc_define] = STATE(1831),
    [sym_preproc_undef] = STATE(1831),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1832] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6610),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1832),
    [sym_preproc_endregion] = STATE(1832),
    [sym_preproc_line] = STATE(1832),
    [sym_preproc_pragma] = STATE(1832),
    [sym_preproc_nullable] = STATE(1832),
    [sym_preproc_error] = STATE(1832),
    [sym_preproc_define] = STATE(1832),
    [sym_preproc_undef] = STATE(1832),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1833] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6601),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1833),
    [sym_preproc_endregion] = STATE(1833),
    [sym_preproc_line] = STATE(1833),
    [sym_preproc_pragma] = STATE(1833),
    [sym_preproc_nullable] = STATE(1833),
    [sym_preproc_error] = STATE(1833),
    [sym_preproc_define] = STATE(1833),
    [sym_preproc_undef] = STATE(1833),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1834] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4571),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1834),
    [sym_preproc_endregion] = STATE(1834),
    [sym_preproc_line] = STATE(1834),
    [sym_preproc_pragma] = STATE(1834),
    [sym_preproc_nullable] = STATE(1834),
    [sym_preproc_error] = STATE(1834),
    [sym_preproc_define] = STATE(1834),
    [sym_preproc_undef] = STATE(1834),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1835] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5669),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1835),
    [sym_preproc_endregion] = STATE(1835),
    [sym_preproc_line] = STATE(1835),
    [sym_preproc_pragma] = STATE(1835),
    [sym_preproc_nullable] = STATE(1835),
    [sym_preproc_error] = STATE(1835),
    [sym_preproc_define] = STATE(1835),
    [sym_preproc_undef] = STATE(1835),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1836] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6550),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1836),
    [sym_preproc_endregion] = STATE(1836),
    [sym_preproc_line] = STATE(1836),
    [sym_preproc_pragma] = STATE(1836),
    [sym_preproc_nullable] = STATE(1836),
    [sym_preproc_error] = STATE(1836),
    [sym_preproc_define] = STATE(1836),
    [sym_preproc_undef] = STATE(1836),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1837] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6551),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1837),
    [sym_preproc_endregion] = STATE(1837),
    [sym_preproc_line] = STATE(1837),
    [sym_preproc_pragma] = STATE(1837),
    [sym_preproc_nullable] = STATE(1837),
    [sym_preproc_error] = STATE(1837),
    [sym_preproc_define] = STATE(1837),
    [sym_preproc_undef] = STATE(1837),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1838] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5665),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1838),
    [sym_preproc_endregion] = STATE(1838),
    [sym_preproc_line] = STATE(1838),
    [sym_preproc_pragma] = STATE(1838),
    [sym_preproc_nullable] = STATE(1838),
    [sym_preproc_error] = STATE(1838),
    [sym_preproc_define] = STATE(1838),
    [sym_preproc_undef] = STATE(1838),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1839] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6592),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1839),
    [sym_preproc_endregion] = STATE(1839),
    [sym_preproc_line] = STATE(1839),
    [sym_preproc_pragma] = STATE(1839),
    [sym_preproc_nullable] = STATE(1839),
    [sym_preproc_error] = STATE(1839),
    [sym_preproc_define] = STATE(1839),
    [sym_preproc_undef] = STATE(1839),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1840] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5888),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1840),
    [sym_preproc_endregion] = STATE(1840),
    [sym_preproc_line] = STATE(1840),
    [sym_preproc_pragma] = STATE(1840),
    [sym_preproc_nullable] = STATE(1840),
    [sym_preproc_error] = STATE(1840),
    [sym_preproc_define] = STATE(1840),
    [sym_preproc_undef] = STATE(1840),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1841] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5663),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1841),
    [sym_preproc_endregion] = STATE(1841),
    [sym_preproc_line] = STATE(1841),
    [sym_preproc_pragma] = STATE(1841),
    [sym_preproc_nullable] = STATE(1841),
    [sym_preproc_error] = STATE(1841),
    [sym_preproc_define] = STATE(1841),
    [sym_preproc_undef] = STATE(1841),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1842] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6554),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1842),
    [sym_preproc_endregion] = STATE(1842),
    [sym_preproc_line] = STATE(1842),
    [sym_preproc_pragma] = STATE(1842),
    [sym_preproc_nullable] = STATE(1842),
    [sym_preproc_error] = STATE(1842),
    [sym_preproc_define] = STATE(1842),
    [sym_preproc_undef] = STATE(1842),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1843] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4570),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1843),
    [sym_preproc_endregion] = STATE(1843),
    [sym_preproc_line] = STATE(1843),
    [sym_preproc_pragma] = STATE(1843),
    [sym_preproc_nullable] = STATE(1843),
    [sym_preproc_error] = STATE(1843),
    [sym_preproc_define] = STATE(1843),
    [sym_preproc_undef] = STATE(1843),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1844] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6561),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1844),
    [sym_preproc_endregion] = STATE(1844),
    [sym_preproc_line] = STATE(1844),
    [sym_preproc_pragma] = STATE(1844),
    [sym_preproc_nullable] = STATE(1844),
    [sym_preproc_error] = STATE(1844),
    [sym_preproc_define] = STATE(1844),
    [sym_preproc_undef] = STATE(1844),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1845] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5657),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1845),
    [sym_preproc_endregion] = STATE(1845),
    [sym_preproc_line] = STATE(1845),
    [sym_preproc_pragma] = STATE(1845),
    [sym_preproc_nullable] = STATE(1845),
    [sym_preproc_error] = STATE(1845),
    [sym_preproc_define] = STATE(1845),
    [sym_preproc_undef] = STATE(1845),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1846] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6564),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1846),
    [sym_preproc_endregion] = STATE(1846),
    [sym_preproc_line] = STATE(1846),
    [sym_preproc_pragma] = STATE(1846),
    [sym_preproc_nullable] = STATE(1846),
    [sym_preproc_error] = STATE(1846),
    [sym_preproc_define] = STATE(1846),
    [sym_preproc_undef] = STATE(1846),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1847] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6565),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1847),
    [sym_preproc_endregion] = STATE(1847),
    [sym_preproc_line] = STATE(1847),
    [sym_preproc_pragma] = STATE(1847),
    [sym_preproc_nullable] = STATE(1847),
    [sym_preproc_error] = STATE(1847),
    [sym_preproc_define] = STATE(1847),
    [sym_preproc_undef] = STATE(1847),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1848] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6571),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1848),
    [sym_preproc_endregion] = STATE(1848),
    [sym_preproc_line] = STATE(1848),
    [sym_preproc_pragma] = STATE(1848),
    [sym_preproc_nullable] = STATE(1848),
    [sym_preproc_error] = STATE(1848),
    [sym_preproc_define] = STATE(1848),
    [sym_preproc_undef] = STATE(1848),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1849] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6574),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1849),
    [sym_preproc_endregion] = STATE(1849),
    [sym_preproc_line] = STATE(1849),
    [sym_preproc_pragma] = STATE(1849),
    [sym_preproc_nullable] = STATE(1849),
    [sym_preproc_error] = STATE(1849),
    [sym_preproc_define] = STATE(1849),
    [sym_preproc_undef] = STATE(1849),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1850] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4569),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1850),
    [sym_preproc_endregion] = STATE(1850),
    [sym_preproc_line] = STATE(1850),
    [sym_preproc_pragma] = STATE(1850),
    [sym_preproc_nullable] = STATE(1850),
    [sym_preproc_error] = STATE(1850),
    [sym_preproc_define] = STATE(1850),
    [sym_preproc_undef] = STATE(1850),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1851] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6576),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1851),
    [sym_preproc_endregion] = STATE(1851),
    [sym_preproc_line] = STATE(1851),
    [sym_preproc_pragma] = STATE(1851),
    [sym_preproc_nullable] = STATE(1851),
    [sym_preproc_error] = STATE(1851),
    [sym_preproc_define] = STATE(1851),
    [sym_preproc_undef] = STATE(1851),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1852] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6582),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1852),
    [sym_preproc_endregion] = STATE(1852),
    [sym_preproc_line] = STATE(1852),
    [sym_preproc_pragma] = STATE(1852),
    [sym_preproc_nullable] = STATE(1852),
    [sym_preproc_error] = STATE(1852),
    [sym_preproc_define] = STATE(1852),
    [sym_preproc_undef] = STATE(1852),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1853] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6577),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1853),
    [sym_preproc_endregion] = STATE(1853),
    [sym_preproc_line] = STATE(1853),
    [sym_preproc_pragma] = STATE(1853),
    [sym_preproc_nullable] = STATE(1853),
    [sym_preproc_error] = STATE(1853),
    [sym_preproc_define] = STATE(1853),
    [sym_preproc_undef] = STATE(1853),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1854] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6946),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7126),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5593),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4141),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7407),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9380),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1854),
    [sym_preproc_endregion] = STATE(1854),
    [sym_preproc_line] = STATE(1854),
    [sym_preproc_pragma] = STATE(1854),
    [sym_preproc_nullable] = STATE(1854),
    [sym_preproc_error] = STATE(1854),
    [sym_preproc_define] = STATE(1854),
    [sym_preproc_undef] = STATE(1854),
    [aux_sym_class_declaration_repeat1] = STATE(3850),
    [aux_sym_lambda_expression_repeat1] = STATE(4144),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_ref] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_CARET] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1939),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1855] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5656),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1855),
    [sym_preproc_endregion] = STATE(1855),
    [sym_preproc_line] = STATE(1855),
    [sym_preproc_pragma] = STATE(1855),
    [sym_preproc_nullable] = STATE(1855),
    [sym_preproc_error] = STATE(1855),
    [sym_preproc_define] = STATE(1855),
    [sym_preproc_undef] = STATE(1855),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1856] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1856),
    [sym_preproc_endregion] = STATE(1856),
    [sym_preproc_line] = STATE(1856),
    [sym_preproc_pragma] = STATE(1856),
    [sym_preproc_nullable] = STATE(1856),
    [sym_preproc_error] = STATE(1856),
    [sym_preproc_define] = STATE(1856),
    [sym_preproc_undef] = STATE(1856),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1857] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4705),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1857),
    [sym_preproc_endregion] = STATE(1857),
    [sym_preproc_line] = STATE(1857),
    [sym_preproc_pragma] = STATE(1857),
    [sym_preproc_nullable] = STATE(1857),
    [sym_preproc_error] = STATE(1857),
    [sym_preproc_define] = STATE(1857),
    [sym_preproc_undef] = STATE(1857),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1858] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6444),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1858),
    [sym_preproc_endregion] = STATE(1858),
    [sym_preproc_line] = STATE(1858),
    [sym_preproc_pragma] = STATE(1858),
    [sym_preproc_nullable] = STATE(1858),
    [sym_preproc_error] = STATE(1858),
    [sym_preproc_define] = STATE(1858),
    [sym_preproc_undef] = STATE(1858),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1859] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5004),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1859),
    [sym_preproc_endregion] = STATE(1859),
    [sym_preproc_line] = STATE(1859),
    [sym_preproc_pragma] = STATE(1859),
    [sym_preproc_nullable] = STATE(1859),
    [sym_preproc_error] = STATE(1859),
    [sym_preproc_define] = STATE(1859),
    [sym_preproc_undef] = STATE(1859),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1860] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6580),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1860),
    [sym_preproc_endregion] = STATE(1860),
    [sym_preproc_line] = STATE(1860),
    [sym_preproc_pragma] = STATE(1860),
    [sym_preproc_nullable] = STATE(1860),
    [sym_preproc_error] = STATE(1860),
    [sym_preproc_define] = STATE(1860),
    [sym_preproc_undef] = STATE(1860),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1861] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6944),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6949),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5255),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3996),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7433),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9280),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1861),
    [sym_preproc_endregion] = STATE(1861),
    [sym_preproc_line] = STATE(1861),
    [sym_preproc_pragma] = STATE(1861),
    [sym_preproc_nullable] = STATE(1861),
    [sym_preproc_error] = STATE(1861),
    [sym_preproc_define] = STATE(1861),
    [sym_preproc_undef] = STATE(1861),
    [aux_sym_class_declaration_repeat1] = STATE(3817),
    [aux_sym_lambda_expression_repeat1] = STATE(4114),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_ref] = ACTIONS(1705),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1711),
    [anon_sym_DASH_DASH] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1715),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1717),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1862] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5226),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1862),
    [sym_preproc_endregion] = STATE(1862),
    [sym_preproc_line] = STATE(1862),
    [sym_preproc_pragma] = STATE(1862),
    [sym_preproc_nullable] = STATE(1862),
    [sym_preproc_error] = STATE(1862),
    [sym_preproc_define] = STATE(1862),
    [sym_preproc_undef] = STATE(1862),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1863] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1863),
    [sym_preproc_endregion] = STATE(1863),
    [sym_preproc_line] = STATE(1863),
    [sym_preproc_pragma] = STATE(1863),
    [sym_preproc_nullable] = STATE(1863),
    [sym_preproc_error] = STATE(1863),
    [sym_preproc_define] = STATE(1863),
    [sym_preproc_undef] = STATE(1863),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1864] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6562),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1864),
    [sym_preproc_endregion] = STATE(1864),
    [sym_preproc_line] = STATE(1864),
    [sym_preproc_pragma] = STATE(1864),
    [sym_preproc_nullable] = STATE(1864),
    [sym_preproc_error] = STATE(1864),
    [sym_preproc_define] = STATE(1864),
    [sym_preproc_undef] = STATE(1864),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1865] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6988),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6492),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4497),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7408),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9174),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1865),
    [sym_preproc_endregion] = STATE(1865),
    [sym_preproc_line] = STATE(1865),
    [sym_preproc_pragma] = STATE(1865),
    [sym_preproc_nullable] = STATE(1865),
    [sym_preproc_error] = STATE(1865),
    [sym_preproc_define] = STATE(1865),
    [sym_preproc_undef] = STATE(1865),
    [aux_sym_class_declaration_repeat1] = STATE(3851),
    [aux_sym_lambda_expression_repeat1] = STATE(4286),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1989),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1991),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1866] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7000),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4897),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3777),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7428),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9634),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1866),
    [sym_preproc_endregion] = STATE(1866),
    [sym_preproc_line] = STATE(1866),
    [sym_preproc_pragma] = STATE(1866),
    [sym_preproc_nullable] = STATE(1866),
    [sym_preproc_error] = STATE(1866),
    [sym_preproc_define] = STATE(1866),
    [sym_preproc_undef] = STATE(1866),
    [aux_sym_class_declaration_repeat1] = STATE(3855),
    [aux_sym_lambda_expression_repeat1] = STATE(4276),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_ref] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_AMP] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1865),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1869),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1867] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6079),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1867),
    [sym_preproc_endregion] = STATE(1867),
    [sym_preproc_line] = STATE(1867),
    [sym_preproc_pragma] = STATE(1867),
    [sym_preproc_nullable] = STATE(1867),
    [sym_preproc_error] = STATE(1867),
    [sym_preproc_define] = STATE(1867),
    [sym_preproc_undef] = STATE(1867),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1868] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4706),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1868),
    [sym_preproc_endregion] = STATE(1868),
    [sym_preproc_line] = STATE(1868),
    [sym_preproc_pragma] = STATE(1868),
    [sym_preproc_nullable] = STATE(1868),
    [sym_preproc_error] = STATE(1868),
    [sym_preproc_define] = STATE(1868),
    [sym_preproc_undef] = STATE(1868),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1869] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6078),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1869),
    [sym_preproc_endregion] = STATE(1869),
    [sym_preproc_line] = STATE(1869),
    [sym_preproc_pragma] = STATE(1869),
    [sym_preproc_nullable] = STATE(1869),
    [sym_preproc_error] = STATE(1869),
    [sym_preproc_define] = STATE(1869),
    [sym_preproc_undef] = STATE(1869),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1870] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5870),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1870),
    [sym_preproc_endregion] = STATE(1870),
    [sym_preproc_line] = STATE(1870),
    [sym_preproc_pragma] = STATE(1870),
    [sym_preproc_nullable] = STATE(1870),
    [sym_preproc_error] = STATE(1870),
    [sym_preproc_define] = STATE(1870),
    [sym_preproc_undef] = STATE(1870),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1871] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6596),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1871),
    [sym_preproc_endregion] = STATE(1871),
    [sym_preproc_line] = STATE(1871),
    [sym_preproc_pragma] = STATE(1871),
    [sym_preproc_nullable] = STATE(1871),
    [sym_preproc_error] = STATE(1871),
    [sym_preproc_define] = STATE(1871),
    [sym_preproc_undef] = STATE(1871),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1872] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6723),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(2994),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1872),
    [sym_preproc_endregion] = STATE(1872),
    [sym_preproc_line] = STATE(1872),
    [sym_preproc_pragma] = STATE(1872),
    [sym_preproc_nullable] = STATE(1872),
    [sym_preproc_error] = STATE(1872),
    [sym_preproc_define] = STATE(1872),
    [sym_preproc_undef] = STATE(1872),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1873] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1873),
    [sym_preproc_endregion] = STATE(1873),
    [sym_preproc_line] = STATE(1873),
    [sym_preproc_pragma] = STATE(1873),
    [sym_preproc_nullable] = STATE(1873),
    [sym_preproc_error] = STATE(1873),
    [sym_preproc_define] = STATE(1873),
    [sym_preproc_undef] = STATE(1873),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1874] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6077),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1874),
    [sym_preproc_endregion] = STATE(1874),
    [sym_preproc_line] = STATE(1874),
    [sym_preproc_pragma] = STATE(1874),
    [sym_preproc_nullable] = STATE(1874),
    [sym_preproc_error] = STATE(1874),
    [sym_preproc_define] = STATE(1874),
    [sym_preproc_undef] = STATE(1874),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1875] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6076),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1875),
    [sym_preproc_endregion] = STATE(1875),
    [sym_preproc_line] = STATE(1875),
    [sym_preproc_pragma] = STATE(1875),
    [sym_preproc_nullable] = STATE(1875),
    [sym_preproc_error] = STATE(1875),
    [sym_preproc_define] = STATE(1875),
    [sym_preproc_undef] = STATE(1875),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1876] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6583),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1876),
    [sym_preproc_endregion] = STATE(1876),
    [sym_preproc_line] = STATE(1876),
    [sym_preproc_pragma] = STATE(1876),
    [sym_preproc_nullable] = STATE(1876),
    [sym_preproc_error] = STATE(1876),
    [sym_preproc_define] = STATE(1876),
    [sym_preproc_undef] = STATE(1876),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1877] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5098),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1877),
    [sym_preproc_endregion] = STATE(1877),
    [sym_preproc_line] = STATE(1877),
    [sym_preproc_pragma] = STATE(1877),
    [sym_preproc_nullable] = STATE(1877),
    [sym_preproc_error] = STATE(1877),
    [sym_preproc_define] = STATE(1877),
    [sym_preproc_undef] = STATE(1877),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1878] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6075),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1878),
    [sym_preproc_endregion] = STATE(1878),
    [sym_preproc_line] = STATE(1878),
    [sym_preproc_pragma] = STATE(1878),
    [sym_preproc_nullable] = STATE(1878),
    [sym_preproc_error] = STATE(1878),
    [sym_preproc_define] = STATE(1878),
    [sym_preproc_undef] = STATE(1878),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1879] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6074),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1879),
    [sym_preproc_endregion] = STATE(1879),
    [sym_preproc_line] = STATE(1879),
    [sym_preproc_pragma] = STATE(1879),
    [sym_preproc_nullable] = STATE(1879),
    [sym_preproc_error] = STATE(1879),
    [sym_preproc_define] = STATE(1879),
    [sym_preproc_undef] = STATE(1879),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1880] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6006),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4359),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1880),
    [sym_preproc_endregion] = STATE(1880),
    [sym_preproc_line] = STATE(1880),
    [sym_preproc_pragma] = STATE(1880),
    [sym_preproc_nullable] = STATE(1880),
    [sym_preproc_error] = STATE(1880),
    [sym_preproc_define] = STATE(1880),
    [sym_preproc_undef] = STATE(1880),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1881] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6073),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1881),
    [sym_preproc_endregion] = STATE(1881),
    [sym_preproc_line] = STATE(1881),
    [sym_preproc_pragma] = STATE(1881),
    [sym_preproc_nullable] = STATE(1881),
    [sym_preproc_error] = STATE(1881),
    [sym_preproc_define] = STATE(1881),
    [sym_preproc_undef] = STATE(1881),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1882] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6072),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1882),
    [sym_preproc_endregion] = STATE(1882),
    [sym_preproc_line] = STATE(1882),
    [sym_preproc_pragma] = STATE(1882),
    [sym_preproc_nullable] = STATE(1882),
    [sym_preproc_error] = STATE(1882),
    [sym_preproc_define] = STATE(1882),
    [sym_preproc_undef] = STATE(1882),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1883] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6071),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1883),
    [sym_preproc_endregion] = STATE(1883),
    [sym_preproc_line] = STATE(1883),
    [sym_preproc_pragma] = STATE(1883),
    [sym_preproc_nullable] = STATE(1883),
    [sym_preproc_error] = STATE(1883),
    [sym_preproc_define] = STATE(1883),
    [sym_preproc_undef] = STATE(1883),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1884] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6070),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1884),
    [sym_preproc_endregion] = STATE(1884),
    [sym_preproc_line] = STATE(1884),
    [sym_preproc_pragma] = STATE(1884),
    [sym_preproc_nullable] = STATE(1884),
    [sym_preproc_error] = STATE(1884),
    [sym_preproc_define] = STATE(1884),
    [sym_preproc_undef] = STATE(1884),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1885] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5911),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1885),
    [sym_preproc_endregion] = STATE(1885),
    [sym_preproc_line] = STATE(1885),
    [sym_preproc_pragma] = STATE(1885),
    [sym_preproc_nullable] = STATE(1885),
    [sym_preproc_error] = STATE(1885),
    [sym_preproc_define] = STATE(1885),
    [sym_preproc_undef] = STATE(1885),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1886] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4609),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1886),
    [sym_preproc_endregion] = STATE(1886),
    [sym_preproc_line] = STATE(1886),
    [sym_preproc_pragma] = STATE(1886),
    [sym_preproc_nullable] = STATE(1886),
    [sym_preproc_error] = STATE(1886),
    [sym_preproc_define] = STATE(1886),
    [sym_preproc_undef] = STATE(1886),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1887] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6534),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1887),
    [sym_preproc_endregion] = STATE(1887),
    [sym_preproc_line] = STATE(1887),
    [sym_preproc_pragma] = STATE(1887),
    [sym_preproc_nullable] = STATE(1887),
    [sym_preproc_error] = STATE(1887),
    [sym_preproc_define] = STATE(1887),
    [sym_preproc_undef] = STATE(1887),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1888] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5028),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1888),
    [sym_preproc_endregion] = STATE(1888),
    [sym_preproc_line] = STATE(1888),
    [sym_preproc_pragma] = STATE(1888),
    [sym_preproc_nullable] = STATE(1888),
    [sym_preproc_error] = STATE(1888),
    [sym_preproc_define] = STATE(1888),
    [sym_preproc_undef] = STATE(1888),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1889] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6327),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1889),
    [sym_preproc_endregion] = STATE(1889),
    [sym_preproc_line] = STATE(1889),
    [sym_preproc_pragma] = STATE(1889),
    [sym_preproc_nullable] = STATE(1889),
    [sym_preproc_error] = STATE(1889),
    [sym_preproc_define] = STATE(1889),
    [sym_preproc_undef] = STATE(1889),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1890] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6026),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1890),
    [sym_preproc_endregion] = STATE(1890),
    [sym_preproc_line] = STATE(1890),
    [sym_preproc_pragma] = STATE(1890),
    [sym_preproc_nullable] = STATE(1890),
    [sym_preproc_error] = STATE(1890),
    [sym_preproc_define] = STATE(1890),
    [sym_preproc_undef] = STATE(1890),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1891] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5202),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1891),
    [sym_preproc_endregion] = STATE(1891),
    [sym_preproc_line] = STATE(1891),
    [sym_preproc_pragma] = STATE(1891),
    [sym_preproc_nullable] = STATE(1891),
    [sym_preproc_error] = STATE(1891),
    [sym_preproc_define] = STATE(1891),
    [sym_preproc_undef] = STATE(1891),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1892] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4707),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1892),
    [sym_preproc_endregion] = STATE(1892),
    [sym_preproc_line] = STATE(1892),
    [sym_preproc_pragma] = STATE(1892),
    [sym_preproc_nullable] = STATE(1892),
    [sym_preproc_error] = STATE(1892),
    [sym_preproc_define] = STATE(1892),
    [sym_preproc_undef] = STATE(1892),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1893] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5152),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1893),
    [sym_preproc_endregion] = STATE(1893),
    [sym_preproc_line] = STATE(1893),
    [sym_preproc_pragma] = STATE(1893),
    [sym_preproc_nullable] = STATE(1893),
    [sym_preproc_error] = STATE(1893),
    [sym_preproc_define] = STATE(1893),
    [sym_preproc_undef] = STATE(1893),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1894] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6494),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1894),
    [sym_preproc_endregion] = STATE(1894),
    [sym_preproc_line] = STATE(1894),
    [sym_preproc_pragma] = STATE(1894),
    [sym_preproc_nullable] = STATE(1894),
    [sym_preproc_error] = STATE(1894),
    [sym_preproc_define] = STATE(1894),
    [sym_preproc_undef] = STATE(1894),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1895] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1895),
    [sym_preproc_endregion] = STATE(1895),
    [sym_preproc_line] = STATE(1895),
    [sym_preproc_pragma] = STATE(1895),
    [sym_preproc_nullable] = STATE(1895),
    [sym_preproc_error] = STATE(1895),
    [sym_preproc_define] = STATE(1895),
    [sym_preproc_undef] = STATE(1895),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1896] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6603),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1896),
    [sym_preproc_endregion] = STATE(1896),
    [sym_preproc_line] = STATE(1896),
    [sym_preproc_pragma] = STATE(1896),
    [sym_preproc_nullable] = STATE(1896),
    [sym_preproc_error] = STATE(1896),
    [sym_preproc_define] = STATE(1896),
    [sym_preproc_undef] = STATE(1896),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1897] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6604),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1897),
    [sym_preproc_endregion] = STATE(1897),
    [sym_preproc_line] = STATE(1897),
    [sym_preproc_pragma] = STATE(1897),
    [sym_preproc_nullable] = STATE(1897),
    [sym_preproc_error] = STATE(1897),
    [sym_preproc_define] = STATE(1897),
    [sym_preproc_undef] = STATE(1897),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1898] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5235),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1898),
    [sym_preproc_endregion] = STATE(1898),
    [sym_preproc_line] = STATE(1898),
    [sym_preproc_pragma] = STATE(1898),
    [sym_preproc_nullable] = STATE(1898),
    [sym_preproc_error] = STATE(1898),
    [sym_preproc_define] = STATE(1898),
    [sym_preproc_undef] = STATE(1898),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1899] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6033),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1899),
    [sym_preproc_endregion] = STATE(1899),
    [sym_preproc_line] = STATE(1899),
    [sym_preproc_pragma] = STATE(1899),
    [sym_preproc_nullable] = STATE(1899),
    [sym_preproc_error] = STATE(1899),
    [sym_preproc_define] = STATE(1899),
    [sym_preproc_undef] = STATE(1899),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1900] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6547),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1900),
    [sym_preproc_endregion] = STATE(1900),
    [sym_preproc_line] = STATE(1900),
    [sym_preproc_pragma] = STATE(1900),
    [sym_preproc_nullable] = STATE(1900),
    [sym_preproc_error] = STATE(1900),
    [sym_preproc_define] = STATE(1900),
    [sym_preproc_undef] = STATE(1900),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1901] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6097),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1901),
    [sym_preproc_endregion] = STATE(1901),
    [sym_preproc_line] = STATE(1901),
    [sym_preproc_pragma] = STATE(1901),
    [sym_preproc_nullable] = STATE(1901),
    [sym_preproc_error] = STATE(1901),
    [sym_preproc_define] = STATE(1901),
    [sym_preproc_undef] = STATE(1901),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1902] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1902),
    [sym_preproc_endregion] = STATE(1902),
    [sym_preproc_line] = STATE(1902),
    [sym_preproc_pragma] = STATE(1902),
    [sym_preproc_nullable] = STATE(1902),
    [sym_preproc_error] = STATE(1902),
    [sym_preproc_define] = STATE(1902),
    [sym_preproc_undef] = STATE(1902),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1903] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6096),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1903),
    [sym_preproc_endregion] = STATE(1903),
    [sym_preproc_line] = STATE(1903),
    [sym_preproc_pragma] = STATE(1903),
    [sym_preproc_nullable] = STATE(1903),
    [sym_preproc_error] = STATE(1903),
    [sym_preproc_define] = STATE(1903),
    [sym_preproc_undef] = STATE(1903),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1904] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6092),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1904),
    [sym_preproc_endregion] = STATE(1904),
    [sym_preproc_line] = STATE(1904),
    [sym_preproc_pragma] = STATE(1904),
    [sym_preproc_nullable] = STATE(1904),
    [sym_preproc_error] = STATE(1904),
    [sym_preproc_define] = STATE(1904),
    [sym_preproc_undef] = STATE(1904),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1905] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6605),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1905),
    [sym_preproc_endregion] = STATE(1905),
    [sym_preproc_line] = STATE(1905),
    [sym_preproc_pragma] = STATE(1905),
    [sym_preproc_nullable] = STATE(1905),
    [sym_preproc_error] = STATE(1905),
    [sym_preproc_define] = STATE(1905),
    [sym_preproc_undef] = STATE(1905),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1906] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6041),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1906),
    [sym_preproc_endregion] = STATE(1906),
    [sym_preproc_line] = STATE(1906),
    [sym_preproc_pragma] = STATE(1906),
    [sym_preproc_nullable] = STATE(1906),
    [sym_preproc_error] = STATE(1906),
    [sym_preproc_define] = STATE(1906),
    [sym_preproc_undef] = STATE(1906),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1907] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1907),
    [sym_preproc_endregion] = STATE(1907),
    [sym_preproc_line] = STATE(1907),
    [sym_preproc_pragma] = STATE(1907),
    [sym_preproc_nullable] = STATE(1907),
    [sym_preproc_error] = STATE(1907),
    [sym_preproc_define] = STATE(1907),
    [sym_preproc_undef] = STATE(1907),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1908] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6091),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1908),
    [sym_preproc_endregion] = STATE(1908),
    [sym_preproc_line] = STATE(1908),
    [sym_preproc_pragma] = STATE(1908),
    [sym_preproc_nullable] = STATE(1908),
    [sym_preproc_error] = STATE(1908),
    [sym_preproc_define] = STATE(1908),
    [sym_preproc_undef] = STATE(1908),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1909] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6088),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1909),
    [sym_preproc_endregion] = STATE(1909),
    [sym_preproc_line] = STATE(1909),
    [sym_preproc_pragma] = STATE(1909),
    [sym_preproc_nullable] = STATE(1909),
    [sym_preproc_error] = STATE(1909),
    [sym_preproc_define] = STATE(1909),
    [sym_preproc_undef] = STATE(1909),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1910] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6087),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1910),
    [sym_preproc_endregion] = STATE(1910),
    [sym_preproc_line] = STATE(1910),
    [sym_preproc_pragma] = STATE(1910),
    [sym_preproc_nullable] = STATE(1910),
    [sym_preproc_error] = STATE(1910),
    [sym_preproc_define] = STATE(1910),
    [sym_preproc_undef] = STATE(1910),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1911] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1911),
    [sym_preproc_endregion] = STATE(1911),
    [sym_preproc_line] = STATE(1911),
    [sym_preproc_pragma] = STATE(1911),
    [sym_preproc_nullable] = STATE(1911),
    [sym_preproc_error] = STATE(1911),
    [sym_preproc_define] = STATE(1911),
    [sym_preproc_undef] = STATE(1911),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1912] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6931),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6963),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5267),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4005),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7406),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9579),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1912),
    [sym_preproc_endregion] = STATE(1912),
    [sym_preproc_line] = STATE(1912),
    [sym_preproc_pragma] = STATE(1912),
    [sym_preproc_nullable] = STATE(1912),
    [sym_preproc_error] = STATE(1912),
    [sym_preproc_define] = STATE(1912),
    [sym_preproc_undef] = STATE(1912),
    [aux_sym_class_declaration_repeat1] = STATE(3834),
    [aux_sym_lambda_expression_repeat1] = STATE(4284),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_ref] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1503),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1913] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6086),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1913),
    [sym_preproc_endregion] = STATE(1913),
    [sym_preproc_line] = STATE(1913),
    [sym_preproc_pragma] = STATE(1913),
    [sym_preproc_nullable] = STATE(1913),
    [sym_preproc_error] = STATE(1913),
    [sym_preproc_define] = STATE(1913),
    [sym_preproc_undef] = STATE(1913),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1914] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6116),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1914),
    [sym_preproc_endregion] = STATE(1914),
    [sym_preproc_line] = STATE(1914),
    [sym_preproc_pragma] = STATE(1914),
    [sym_preproc_nullable] = STATE(1914),
    [sym_preproc_error] = STATE(1914),
    [sym_preproc_define] = STATE(1914),
    [sym_preproc_undef] = STATE(1914),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1915] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6115),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1915),
    [sym_preproc_endregion] = STATE(1915),
    [sym_preproc_line] = STATE(1915),
    [sym_preproc_pragma] = STATE(1915),
    [sym_preproc_nullable] = STATE(1915),
    [sym_preproc_error] = STATE(1915),
    [sym_preproc_define] = STATE(1915),
    [sym_preproc_undef] = STATE(1915),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1916] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6104),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1916),
    [sym_preproc_endregion] = STATE(1916),
    [sym_preproc_line] = STATE(1916),
    [sym_preproc_pragma] = STATE(1916),
    [sym_preproc_nullable] = STATE(1916),
    [sym_preproc_error] = STATE(1916),
    [sym_preproc_define] = STATE(1916),
    [sym_preproc_undef] = STATE(1916),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1917] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6447),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1917),
    [sym_preproc_endregion] = STATE(1917),
    [sym_preproc_line] = STATE(1917),
    [sym_preproc_pragma] = STATE(1917),
    [sym_preproc_nullable] = STATE(1917),
    [sym_preproc_error] = STATE(1917),
    [sym_preproc_define] = STATE(1917),
    [sym_preproc_undef] = STATE(1917),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1918] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6085),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1918),
    [sym_preproc_endregion] = STATE(1918),
    [sym_preproc_line] = STATE(1918),
    [sym_preproc_pragma] = STATE(1918),
    [sym_preproc_nullable] = STATE(1918),
    [sym_preproc_error] = STATE(1918),
    [sym_preproc_define] = STATE(1918),
    [sym_preproc_undef] = STATE(1918),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1919] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6093),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1919),
    [sym_preproc_endregion] = STATE(1919),
    [sym_preproc_line] = STATE(1919),
    [sym_preproc_pragma] = STATE(1919),
    [sym_preproc_nullable] = STATE(1919),
    [sym_preproc_error] = STATE(1919),
    [sym_preproc_define] = STATE(1919),
    [sym_preproc_undef] = STATE(1919),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1920] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6084),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1920),
    [sym_preproc_endregion] = STATE(1920),
    [sym_preproc_line] = STATE(1920),
    [sym_preproc_pragma] = STATE(1920),
    [sym_preproc_nullable] = STATE(1920),
    [sym_preproc_error] = STATE(1920),
    [sym_preproc_define] = STATE(1920),
    [sym_preproc_undef] = STATE(1920),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1921] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6082),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1921),
    [sym_preproc_endregion] = STATE(1921),
    [sym_preproc_line] = STATE(1921),
    [sym_preproc_pragma] = STATE(1921),
    [sym_preproc_nullable] = STATE(1921),
    [sym_preproc_error] = STATE(1921),
    [sym_preproc_define] = STATE(1921),
    [sym_preproc_undef] = STATE(1921),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1922] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5889),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1922),
    [sym_preproc_endregion] = STATE(1922),
    [sym_preproc_line] = STATE(1922),
    [sym_preproc_pragma] = STATE(1922),
    [sym_preproc_nullable] = STATE(1922),
    [sym_preproc_error] = STATE(1922),
    [sym_preproc_define] = STATE(1922),
    [sym_preproc_undef] = STATE(1922),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1923] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5950),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1923),
    [sym_preproc_endregion] = STATE(1923),
    [sym_preproc_line] = STATE(1923),
    [sym_preproc_pragma] = STATE(1923),
    [sym_preproc_nullable] = STATE(1923),
    [sym_preproc_error] = STATE(1923),
    [sym_preproc_define] = STATE(1923),
    [sym_preproc_undef] = STATE(1923),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1924] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6069),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1924),
    [sym_preproc_endregion] = STATE(1924),
    [sym_preproc_line] = STATE(1924),
    [sym_preproc_pragma] = STATE(1924),
    [sym_preproc_nullable] = STATE(1924),
    [sym_preproc_error] = STATE(1924),
    [sym_preproc_define] = STATE(1924),
    [sym_preproc_undef] = STATE(1924),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1925] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7054),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5708),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4182),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7413),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9062),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1925),
    [sym_preproc_endregion] = STATE(1925),
    [sym_preproc_line] = STATE(1925),
    [sym_preproc_pragma] = STATE(1925),
    [sym_preproc_nullable] = STATE(1925),
    [sym_preproc_error] = STATE(1925),
    [sym_preproc_define] = STATE(1925),
    [sym_preproc_undef] = STATE(1925),
    [aux_sym_class_declaration_repeat1] = STATE(3870),
    [aux_sym_lambda_expression_repeat1] = STATE(4301),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_ref] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1109),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1129),
    [anon_sym_DOT_DOT] = ACTIONS(1133),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1926] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5783),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1926),
    [sym_preproc_endregion] = STATE(1926),
    [sym_preproc_line] = STATE(1926),
    [sym_preproc_pragma] = STATE(1926),
    [sym_preproc_nullable] = STATE(1926),
    [sym_preproc_error] = STATE(1926),
    [sym_preproc_define] = STATE(1926),
    [sym_preproc_undef] = STATE(1926),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1927] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5890),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1927),
    [sym_preproc_endregion] = STATE(1927),
    [sym_preproc_line] = STATE(1927),
    [sym_preproc_pragma] = STATE(1927),
    [sym_preproc_nullable] = STATE(1927),
    [sym_preproc_error] = STATE(1927),
    [sym_preproc_define] = STATE(1927),
    [sym_preproc_undef] = STATE(1927),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1928] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5530),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1928),
    [sym_preproc_endregion] = STATE(1928),
    [sym_preproc_line] = STATE(1928),
    [sym_preproc_pragma] = STATE(1928),
    [sym_preproc_nullable] = STATE(1928),
    [sym_preproc_error] = STATE(1928),
    [sym_preproc_define] = STATE(1928),
    [sym_preproc_undef] = STATE(1928),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1929] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5891),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1929),
    [sym_preproc_endregion] = STATE(1929),
    [sym_preproc_line] = STATE(1929),
    [sym_preproc_pragma] = STATE(1929),
    [sym_preproc_nullable] = STATE(1929),
    [sym_preproc_error] = STATE(1929),
    [sym_preproc_define] = STATE(1929),
    [sym_preproc_undef] = STATE(1929),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1930] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5347),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1930),
    [sym_preproc_endregion] = STATE(1930),
    [sym_preproc_line] = STATE(1930),
    [sym_preproc_pragma] = STATE(1930),
    [sym_preproc_nullable] = STATE(1930),
    [sym_preproc_error] = STATE(1930),
    [sym_preproc_define] = STATE(1930),
    [sym_preproc_undef] = STATE(1930),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1931] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4572),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1931),
    [sym_preproc_endregion] = STATE(1931),
    [sym_preproc_line] = STATE(1931),
    [sym_preproc_pragma] = STATE(1931),
    [sym_preproc_nullable] = STATE(1931),
    [sym_preproc_error] = STATE(1931),
    [sym_preproc_define] = STATE(1931),
    [sym_preproc_undef] = STATE(1931),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1932] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6175),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1932),
    [sym_preproc_endregion] = STATE(1932),
    [sym_preproc_line] = STATE(1932),
    [sym_preproc_pragma] = STATE(1932),
    [sym_preproc_nullable] = STATE(1932),
    [sym_preproc_error] = STATE(1932),
    [sym_preproc_define] = STATE(1932),
    [sym_preproc_undef] = STATE(1932),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1933] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6716),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3042),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1933),
    [sym_preproc_endregion] = STATE(1933),
    [sym_preproc_line] = STATE(1933),
    [sym_preproc_pragma] = STATE(1933),
    [sym_preproc_nullable] = STATE(1933),
    [sym_preproc_error] = STATE(1933),
    [sym_preproc_define] = STATE(1933),
    [sym_preproc_undef] = STATE(1933),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1934] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1934),
    [sym_preproc_endregion] = STATE(1934),
    [sym_preproc_line] = STATE(1934),
    [sym_preproc_pragma] = STATE(1934),
    [sym_preproc_nullable] = STATE(1934),
    [sym_preproc_error] = STATE(1934),
    [sym_preproc_define] = STATE(1934),
    [sym_preproc_undef] = STATE(1934),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1935] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6068),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1935),
    [sym_preproc_endregion] = STATE(1935),
    [sym_preproc_line] = STATE(1935),
    [sym_preproc_pragma] = STATE(1935),
    [sym_preproc_nullable] = STATE(1935),
    [sym_preproc_error] = STATE(1935),
    [sym_preproc_define] = STATE(1935),
    [sym_preproc_undef] = STATE(1935),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1936] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5022),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1936),
    [sym_preproc_endregion] = STATE(1936),
    [sym_preproc_line] = STATE(1936),
    [sym_preproc_pragma] = STATE(1936),
    [sym_preproc_nullable] = STATE(1936),
    [sym_preproc_error] = STATE(1936),
    [sym_preproc_define] = STATE(1936),
    [sym_preproc_undef] = STATE(1936),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1937] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5020),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1937),
    [sym_preproc_endregion] = STATE(1937),
    [sym_preproc_line] = STATE(1937),
    [sym_preproc_pragma] = STATE(1937),
    [sym_preproc_nullable] = STATE(1937),
    [sym_preproc_error] = STATE(1937),
    [sym_preproc_define] = STATE(1937),
    [sym_preproc_undef] = STATE(1937),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1938] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6456),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1938),
    [sym_preproc_endregion] = STATE(1938),
    [sym_preproc_line] = STATE(1938),
    [sym_preproc_pragma] = STATE(1938),
    [sym_preproc_nullable] = STATE(1938),
    [sym_preproc_error] = STATE(1938),
    [sym_preproc_define] = STATE(1938),
    [sym_preproc_undef] = STATE(1938),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1939] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6067),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1939),
    [sym_preproc_endregion] = STATE(1939),
    [sym_preproc_line] = STATE(1939),
    [sym_preproc_pragma] = STATE(1939),
    [sym_preproc_nullable] = STATE(1939),
    [sym_preproc_error] = STATE(1939),
    [sym_preproc_define] = STATE(1939),
    [sym_preproc_undef] = STATE(1939),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1940] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5019),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1940),
    [sym_preproc_endregion] = STATE(1940),
    [sym_preproc_line] = STATE(1940),
    [sym_preproc_pragma] = STATE(1940),
    [sym_preproc_nullable] = STATE(1940),
    [sym_preproc_error] = STATE(1940),
    [sym_preproc_define] = STATE(1940),
    [sym_preproc_undef] = STATE(1940),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1941] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5018),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1941),
    [sym_preproc_endregion] = STATE(1941),
    [sym_preproc_line] = STATE(1941),
    [sym_preproc_pragma] = STATE(1941),
    [sym_preproc_nullable] = STATE(1941),
    [sym_preproc_error] = STATE(1941),
    [sym_preproc_define] = STATE(1941),
    [sym_preproc_undef] = STATE(1941),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1942] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6044),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1942),
    [sym_preproc_endregion] = STATE(1942),
    [sym_preproc_line] = STATE(1942),
    [sym_preproc_pragma] = STATE(1942),
    [sym_preproc_nullable] = STATE(1942),
    [sym_preproc_error] = STATE(1942),
    [sym_preproc_define] = STATE(1942),
    [sym_preproc_undef] = STATE(1942),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1943] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6065),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1943),
    [sym_preproc_endregion] = STATE(1943),
    [sym_preproc_line] = STATE(1943),
    [sym_preproc_pragma] = STATE(1943),
    [sym_preproc_nullable] = STATE(1943),
    [sym_preproc_error] = STATE(1943),
    [sym_preproc_define] = STATE(1943),
    [sym_preproc_undef] = STATE(1943),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1944] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4335),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1944),
    [sym_preproc_endregion] = STATE(1944),
    [sym_preproc_line] = STATE(1944),
    [sym_preproc_pragma] = STATE(1944),
    [sym_preproc_nullable] = STATE(1944),
    [sym_preproc_error] = STATE(1944),
    [sym_preproc_define] = STATE(1944),
    [sym_preproc_undef] = STATE(1944),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1945] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6063),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1945),
    [sym_preproc_endregion] = STATE(1945),
    [sym_preproc_line] = STATE(1945),
    [sym_preproc_pragma] = STATE(1945),
    [sym_preproc_nullable] = STATE(1945),
    [sym_preproc_error] = STATE(1945),
    [sym_preproc_define] = STATE(1945),
    [sym_preproc_undef] = STATE(1945),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1946] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5012),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1946),
    [sym_preproc_endregion] = STATE(1946),
    [sym_preproc_line] = STATE(1946),
    [sym_preproc_pragma] = STATE(1946),
    [sym_preproc_nullable] = STATE(1946),
    [sym_preproc_error] = STATE(1946),
    [sym_preproc_define] = STATE(1946),
    [sym_preproc_undef] = STATE(1946),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1947] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5011),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1947),
    [sym_preproc_endregion] = STATE(1947),
    [sym_preproc_line] = STATE(1947),
    [sym_preproc_pragma] = STATE(1947),
    [sym_preproc_nullable] = STATE(1947),
    [sym_preproc_error] = STATE(1947),
    [sym_preproc_define] = STATE(1947),
    [sym_preproc_undef] = STATE(1947),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1948] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4718),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1948),
    [sym_preproc_endregion] = STATE(1948),
    [sym_preproc_line] = STATE(1948),
    [sym_preproc_pragma] = STATE(1948),
    [sym_preproc_nullable] = STATE(1948),
    [sym_preproc_error] = STATE(1948),
    [sym_preproc_define] = STATE(1948),
    [sym_preproc_undef] = STATE(1948),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1949] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4827),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1949),
    [sym_preproc_endregion] = STATE(1949),
    [sym_preproc_line] = STATE(1949),
    [sym_preproc_pragma] = STATE(1949),
    [sym_preproc_nullable] = STATE(1949),
    [sym_preproc_error] = STATE(1949),
    [sym_preproc_define] = STATE(1949),
    [sym_preproc_undef] = STATE(1949),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1950] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1950),
    [sym_preproc_endregion] = STATE(1950),
    [sym_preproc_line] = STATE(1950),
    [sym_preproc_pragma] = STATE(1950),
    [sym_preproc_nullable] = STATE(1950),
    [sym_preproc_error] = STATE(1950),
    [sym_preproc_define] = STATE(1950),
    [sym_preproc_undef] = STATE(1950),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1951] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5893),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1951),
    [sym_preproc_endregion] = STATE(1951),
    [sym_preproc_line] = STATE(1951),
    [sym_preproc_pragma] = STATE(1951),
    [sym_preproc_nullable] = STATE(1951),
    [sym_preproc_error] = STATE(1951),
    [sym_preproc_define] = STATE(1951),
    [sym_preproc_undef] = STATE(1951),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1952] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5894),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1952),
    [sym_preproc_endregion] = STATE(1952),
    [sym_preproc_line] = STATE(1952),
    [sym_preproc_pragma] = STATE(1952),
    [sym_preproc_nullable] = STATE(1952),
    [sym_preproc_error] = STATE(1952),
    [sym_preproc_define] = STATE(1952),
    [sym_preproc_undef] = STATE(1952),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1953] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5900),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1953),
    [sym_preproc_endregion] = STATE(1953),
    [sym_preproc_line] = STATE(1953),
    [sym_preproc_pragma] = STATE(1953),
    [sym_preproc_nullable] = STATE(1953),
    [sym_preproc_error] = STATE(1953),
    [sym_preproc_define] = STATE(1953),
    [sym_preproc_undef] = STATE(1953),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1954] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5805),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1954),
    [sym_preproc_endregion] = STATE(1954),
    [sym_preproc_line] = STATE(1954),
    [sym_preproc_pragma] = STATE(1954),
    [sym_preproc_nullable] = STATE(1954),
    [sym_preproc_error] = STATE(1954),
    [sym_preproc_define] = STATE(1954),
    [sym_preproc_undef] = STATE(1954),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1955] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6221),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1955),
    [sym_preproc_endregion] = STATE(1955),
    [sym_preproc_line] = STATE(1955),
    [sym_preproc_pragma] = STATE(1955),
    [sym_preproc_nullable] = STATE(1955),
    [sym_preproc_error] = STATE(1955),
    [sym_preproc_define] = STATE(1955),
    [sym_preproc_undef] = STATE(1955),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1956] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6661),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1956),
    [sym_preproc_endregion] = STATE(1956),
    [sym_preproc_line] = STATE(1956),
    [sym_preproc_pragma] = STATE(1956),
    [sym_preproc_nullable] = STATE(1956),
    [sym_preproc_error] = STATE(1956),
    [sym_preproc_define] = STATE(1956),
    [sym_preproc_undef] = STATE(1956),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1957] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6081),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1957),
    [sym_preproc_endregion] = STATE(1957),
    [sym_preproc_line] = STATE(1957),
    [sym_preproc_pragma] = STATE(1957),
    [sym_preproc_nullable] = STATE(1957),
    [sym_preproc_error] = STATE(1957),
    [sym_preproc_define] = STATE(1957),
    [sym_preproc_undef] = STATE(1957),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1958] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6617),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1958),
    [sym_preproc_endregion] = STATE(1958),
    [sym_preproc_line] = STATE(1958),
    [sym_preproc_pragma] = STATE(1958),
    [sym_preproc_nullable] = STATE(1958),
    [sym_preproc_error] = STATE(1958),
    [sym_preproc_define] = STATE(1958),
    [sym_preproc_undef] = STATE(1958),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1959] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5907),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1959),
    [sym_preproc_endregion] = STATE(1959),
    [sym_preproc_line] = STATE(1959),
    [sym_preproc_pragma] = STATE(1959),
    [sym_preproc_nullable] = STATE(1959),
    [sym_preproc_error] = STATE(1959),
    [sym_preproc_define] = STATE(1959),
    [sym_preproc_undef] = STATE(1959),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1960] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1960),
    [sym_preproc_endregion] = STATE(1960),
    [sym_preproc_line] = STATE(1960),
    [sym_preproc_pragma] = STATE(1960),
    [sym_preproc_nullable] = STATE(1960),
    [sym_preproc_error] = STATE(1960),
    [sym_preproc_define] = STATE(1960),
    [sym_preproc_undef] = STATE(1960),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1961] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1961),
    [sym_preproc_endregion] = STATE(1961),
    [sym_preproc_line] = STATE(1961),
    [sym_preproc_pragma] = STATE(1961),
    [sym_preproc_nullable] = STATE(1961),
    [sym_preproc_error] = STATE(1961),
    [sym_preproc_define] = STATE(1961),
    [sym_preproc_undef] = STATE(1961),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1962] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1962),
    [sym_preproc_endregion] = STATE(1962),
    [sym_preproc_line] = STATE(1962),
    [sym_preproc_pragma] = STATE(1962),
    [sym_preproc_nullable] = STATE(1962),
    [sym_preproc_error] = STATE(1962),
    [sym_preproc_define] = STATE(1962),
    [sym_preproc_undef] = STATE(1962),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1963] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5234),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1963),
    [sym_preproc_endregion] = STATE(1963),
    [sym_preproc_line] = STATE(1963),
    [sym_preproc_pragma] = STATE(1963),
    [sym_preproc_nullable] = STATE(1963),
    [sym_preproc_error] = STATE(1963),
    [sym_preproc_define] = STATE(1963),
    [sym_preproc_undef] = STATE(1963),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1964] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7144),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6110),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4349),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7417),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9267),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1964),
    [sym_preproc_endregion] = STATE(1964),
    [sym_preproc_line] = STATE(1964),
    [sym_preproc_pragma] = STATE(1964),
    [sym_preproc_nullable] = STATE(1964),
    [sym_preproc_error] = STATE(1964),
    [sym_preproc_define] = STATE(1964),
    [sym_preproc_undef] = STATE(1964),
    [aux_sym_class_declaration_repeat1] = STATE(3845),
    [aux_sym_lambda_expression_repeat1] = STATE(4100),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_ref] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1803),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_TILDE] = ACTIONS(1807),
    [anon_sym_PLUS_PLUS] = ACTIONS(1807),
    [anon_sym_DASH_DASH] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1811),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1813),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1965] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5908),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1965),
    [sym_preproc_endregion] = STATE(1965),
    [sym_preproc_line] = STATE(1965),
    [sym_preproc_pragma] = STATE(1965),
    [sym_preproc_nullable] = STATE(1965),
    [sym_preproc_error] = STATE(1965),
    [sym_preproc_define] = STATE(1965),
    [sym_preproc_undef] = STATE(1965),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1966] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5172),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1966),
    [sym_preproc_endregion] = STATE(1966),
    [sym_preproc_line] = STATE(1966),
    [sym_preproc_pragma] = STATE(1966),
    [sym_preproc_nullable] = STATE(1966),
    [sym_preproc_error] = STATE(1966),
    [sym_preproc_define] = STATE(1966),
    [sym_preproc_undef] = STATE(1966),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1967] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5061),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1967),
    [sym_preproc_endregion] = STATE(1967),
    [sym_preproc_line] = STATE(1967),
    [sym_preproc_pragma] = STATE(1967),
    [sym_preproc_nullable] = STATE(1967),
    [sym_preproc_error] = STATE(1967),
    [sym_preproc_define] = STATE(1967),
    [sym_preproc_undef] = STATE(1967),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1968] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5910),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1968),
    [sym_preproc_endregion] = STATE(1968),
    [sym_preproc_line] = STATE(1968),
    [sym_preproc_pragma] = STATE(1968),
    [sym_preproc_nullable] = STATE(1968),
    [sym_preproc_error] = STATE(1968),
    [sym_preproc_define] = STATE(1968),
    [sym_preproc_undef] = STATE(1968),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1969] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4819),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1969),
    [sym_preproc_endregion] = STATE(1969),
    [sym_preproc_line] = STATE(1969),
    [sym_preproc_pragma] = STATE(1969),
    [sym_preproc_nullable] = STATE(1969),
    [sym_preproc_error] = STATE(1969),
    [sym_preproc_define] = STATE(1969),
    [sym_preproc_undef] = STATE(1969),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1970] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4350),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1970),
    [sym_preproc_endregion] = STATE(1970),
    [sym_preproc_line] = STATE(1970),
    [sym_preproc_pragma] = STATE(1970),
    [sym_preproc_nullable] = STATE(1970),
    [sym_preproc_error] = STATE(1970),
    [sym_preproc_define] = STATE(1970),
    [sym_preproc_undef] = STATE(1970),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1971] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6428),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1971),
    [sym_preproc_endregion] = STATE(1971),
    [sym_preproc_line] = STATE(1971),
    [sym_preproc_pragma] = STATE(1971),
    [sym_preproc_nullable] = STATE(1971),
    [sym_preproc_error] = STATE(1971),
    [sym_preproc_define] = STATE(1971),
    [sym_preproc_undef] = STATE(1971),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1972] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5355),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1972),
    [sym_preproc_endregion] = STATE(1972),
    [sym_preproc_line] = STATE(1972),
    [sym_preproc_pragma] = STATE(1972),
    [sym_preproc_nullable] = STATE(1972),
    [sym_preproc_error] = STATE(1972),
    [sym_preproc_define] = STATE(1972),
    [sym_preproc_undef] = STATE(1972),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1973] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6141),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1973),
    [sym_preproc_endregion] = STATE(1973),
    [sym_preproc_line] = STATE(1973),
    [sym_preproc_pragma] = STATE(1973),
    [sym_preproc_nullable] = STATE(1973),
    [sym_preproc_error] = STATE(1973),
    [sym_preproc_define] = STATE(1973),
    [sym_preproc_undef] = STATE(1973),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1974] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1974),
    [sym_preproc_endregion] = STATE(1974),
    [sym_preproc_line] = STATE(1974),
    [sym_preproc_pragma] = STATE(1974),
    [sym_preproc_nullable] = STATE(1974),
    [sym_preproc_error] = STATE(1974),
    [sym_preproc_define] = STATE(1974),
    [sym_preproc_undef] = STATE(1974),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1975] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6627),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1975),
    [sym_preproc_endregion] = STATE(1975),
    [sym_preproc_line] = STATE(1975),
    [sym_preproc_pragma] = STATE(1975),
    [sym_preproc_nullable] = STATE(1975),
    [sym_preproc_error] = STATE(1975),
    [sym_preproc_define] = STATE(1975),
    [sym_preproc_undef] = STATE(1975),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1976] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5354),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1976),
    [sym_preproc_endregion] = STATE(1976),
    [sym_preproc_line] = STATE(1976),
    [sym_preproc_pragma] = STATE(1976),
    [sym_preproc_nullable] = STATE(1976),
    [sym_preproc_error] = STATE(1976),
    [sym_preproc_define] = STATE(1976),
    [sym_preproc_undef] = STATE(1976),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1977] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6121),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1977),
    [sym_preproc_endregion] = STATE(1977),
    [sym_preproc_line] = STATE(1977),
    [sym_preproc_pragma] = STATE(1977),
    [sym_preproc_nullable] = STATE(1977),
    [sym_preproc_error] = STATE(1977),
    [sym_preproc_define] = STATE(1977),
    [sym_preproc_undef] = STATE(1977),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1978] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4894),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1978),
    [sym_preproc_endregion] = STATE(1978),
    [sym_preproc_line] = STATE(1978),
    [sym_preproc_pragma] = STATE(1978),
    [sym_preproc_nullable] = STATE(1978),
    [sym_preproc_error] = STATE(1978),
    [sym_preproc_define] = STATE(1978),
    [sym_preproc_undef] = STATE(1978),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1979] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6630),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1979),
    [sym_preproc_endregion] = STATE(1979),
    [sym_preproc_line] = STATE(1979),
    [sym_preproc_pragma] = STATE(1979),
    [sym_preproc_nullable] = STATE(1979),
    [sym_preproc_error] = STATE(1979),
    [sym_preproc_define] = STATE(1979),
    [sym_preproc_undef] = STATE(1979),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1980] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6924),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7132),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6204),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4425),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7439),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9222),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(1980),
    [sym_preproc_endregion] = STATE(1980),
    [sym_preproc_line] = STATE(1980),
    [sym_preproc_pragma] = STATE(1980),
    [sym_preproc_nullable] = STATE(1980),
    [sym_preproc_error] = STATE(1980),
    [sym_preproc_define] = STATE(1980),
    [sym_preproc_undef] = STATE(1980),
    [aux_sym_class_declaration_repeat1] = STATE(3830),
    [aux_sym_lambda_expression_repeat1] = STATE(4136),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2149),
    [anon_sym_ref] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2153),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2161),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2163),
    [anon_sym_DOT_DOT] = ACTIONS(2165),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [1981] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7109),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6127),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4341),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9197),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1981),
    [sym_preproc_endregion] = STATE(1981),
    [sym_preproc_line] = STATE(1981),
    [sym_preproc_pragma] = STATE(1981),
    [sym_preproc_nullable] = STATE(1981),
    [sym_preproc_error] = STATE(1981),
    [sym_preproc_define] = STATE(1981),
    [sym_preproc_undef] = STATE(1981),
    [aux_sym_class_declaration_repeat1] = STATE(3856),
    [aux_sym_lambda_expression_repeat1] = STATE(4305),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_ref] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_AMP] = ACTIONS(693),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1982] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6625),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1982),
    [sym_preproc_endregion] = STATE(1982),
    [sym_preproc_line] = STATE(1982),
    [sym_preproc_pragma] = STATE(1982),
    [sym_preproc_nullable] = STATE(1982),
    [sym_preproc_error] = STATE(1982),
    [sym_preproc_define] = STATE(1982),
    [sym_preproc_undef] = STATE(1982),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1983] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4818),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1983),
    [sym_preproc_endregion] = STATE(1983),
    [sym_preproc_line] = STATE(1983),
    [sym_preproc_pragma] = STATE(1983),
    [sym_preproc_nullable] = STATE(1983),
    [sym_preproc_error] = STATE(1983),
    [sym_preproc_define] = STATE(1983),
    [sym_preproc_undef] = STATE(1983),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1984] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7118),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6414),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4246),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9478),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1984),
    [sym_preproc_endregion] = STATE(1984),
    [sym_preproc_line] = STATE(1984),
    [sym_preproc_pragma] = STATE(1984),
    [sym_preproc_nullable] = STATE(1984),
    [sym_preproc_error] = STATE(1984),
    [sym_preproc_define] = STATE(1984),
    [sym_preproc_undef] = STATE(1984),
    [aux_sym_class_declaration_repeat1] = STATE(3827),
    [aux_sym_lambda_expression_repeat1] = STATE(4282),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_ref] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(73),
    [anon_sym_TILDE] = ACTIONS(73),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_DASH] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_AMP] = ACTIONS(73),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1985] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4805),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1985),
    [sym_preproc_endregion] = STATE(1985),
    [sym_preproc_line] = STATE(1985),
    [sym_preproc_pragma] = STATE(1985),
    [sym_preproc_nullable] = STATE(1985),
    [sym_preproc_error] = STATE(1985),
    [sym_preproc_define] = STATE(1985),
    [sym_preproc_undef] = STATE(1985),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1986] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6499),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1986),
    [sym_preproc_endregion] = STATE(1986),
    [sym_preproc_line] = STATE(1986),
    [sym_preproc_pragma] = STATE(1986),
    [sym_preproc_nullable] = STATE(1986),
    [sym_preproc_error] = STATE(1986),
    [sym_preproc_define] = STATE(1986),
    [sym_preproc_undef] = STATE(1986),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1987] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5351),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1987),
    [sym_preproc_endregion] = STATE(1987),
    [sym_preproc_line] = STATE(1987),
    [sym_preproc_pragma] = STATE(1987),
    [sym_preproc_nullable] = STATE(1987),
    [sym_preproc_error] = STATE(1987),
    [sym_preproc_define] = STATE(1987),
    [sym_preproc_undef] = STATE(1987),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1988] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6061),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(1988),
    [sym_preproc_endregion] = STATE(1988),
    [sym_preproc_line] = STATE(1988),
    [sym_preproc_pragma] = STATE(1988),
    [sym_preproc_nullable] = STATE(1988),
    [sym_preproc_error] = STATE(1988),
    [sym_preproc_define] = STATE(1988),
    [sym_preproc_undef] = STATE(1988),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [1989] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6649),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1989),
    [sym_preproc_endregion] = STATE(1989),
    [sym_preproc_line] = STATE(1989),
    [sym_preproc_pragma] = STATE(1989),
    [sym_preproc_nullable] = STATE(1989),
    [sym_preproc_error] = STATE(1989),
    [sym_preproc_define] = STATE(1989),
    [sym_preproc_undef] = STATE(1989),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1990] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6645),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1990),
    [sym_preproc_endregion] = STATE(1990),
    [sym_preproc_line] = STATE(1990),
    [sym_preproc_pragma] = STATE(1990),
    [sym_preproc_nullable] = STATE(1990),
    [sym_preproc_error] = STATE(1990),
    [sym_preproc_define] = STATE(1990),
    [sym_preproc_undef] = STATE(1990),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1991] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1991),
    [sym_preproc_endregion] = STATE(1991),
    [sym_preproc_line] = STATE(1991),
    [sym_preproc_pragma] = STATE(1991),
    [sym_preproc_nullable] = STATE(1991),
    [sym_preproc_error] = STATE(1991),
    [sym_preproc_define] = STATE(1991),
    [sym_preproc_undef] = STATE(1991),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1992] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6608),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(1992),
    [sym_preproc_endregion] = STATE(1992),
    [sym_preproc_line] = STATE(1992),
    [sym_preproc_pragma] = STATE(1992),
    [sym_preproc_nullable] = STATE(1992),
    [sym_preproc_error] = STATE(1992),
    [sym_preproc_define] = STATE(1992),
    [sym_preproc_undef] = STATE(1992),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1993] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5349),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1993),
    [sym_preproc_endregion] = STATE(1993),
    [sym_preproc_line] = STATE(1993),
    [sym_preproc_pragma] = STATE(1993),
    [sym_preproc_nullable] = STATE(1993),
    [sym_preproc_error] = STATE(1993),
    [sym_preproc_define] = STATE(1993),
    [sym_preproc_undef] = STATE(1993),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [1994] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4795),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1994),
    [sym_preproc_endregion] = STATE(1994),
    [sym_preproc_line] = STATE(1994),
    [sym_preproc_pragma] = STATE(1994),
    [sym_preproc_nullable] = STATE(1994),
    [sym_preproc_error] = STATE(1994),
    [sym_preproc_define] = STATE(1994),
    [sym_preproc_undef] = STATE(1994),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1995] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(1995),
    [sym_preproc_endregion] = STATE(1995),
    [sym_preproc_line] = STATE(1995),
    [sym_preproc_pragma] = STATE(1995),
    [sym_preproc_nullable] = STATE(1995),
    [sym_preproc_error] = STATE(1995),
    [sym_preproc_define] = STATE(1995),
    [sym_preproc_undef] = STATE(1995),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [1996] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4747),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1996),
    [sym_preproc_endregion] = STATE(1996),
    [sym_preproc_line] = STATE(1996),
    [sym_preproc_pragma] = STATE(1996),
    [sym_preproc_nullable] = STATE(1996),
    [sym_preproc_error] = STATE(1996),
    [sym_preproc_define] = STATE(1996),
    [sym_preproc_undef] = STATE(1996),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1997] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4855),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1997),
    [sym_preproc_endregion] = STATE(1997),
    [sym_preproc_line] = STATE(1997),
    [sym_preproc_pragma] = STATE(1997),
    [sym_preproc_nullable] = STATE(1997),
    [sym_preproc_error] = STATE(1997),
    [sym_preproc_define] = STATE(1997),
    [sym_preproc_undef] = STATE(1997),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1998] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4901),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(1998),
    [sym_preproc_endregion] = STATE(1998),
    [sym_preproc_line] = STATE(1998),
    [sym_preproc_pragma] = STATE(1998),
    [sym_preproc_nullable] = STATE(1998),
    [sym_preproc_error] = STATE(1998),
    [sym_preproc_define] = STATE(1998),
    [sym_preproc_undef] = STATE(1998),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [1999] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5054),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(1999),
    [sym_preproc_endregion] = STATE(1999),
    [sym_preproc_line] = STATE(1999),
    [sym_preproc_pragma] = STATE(1999),
    [sym_preproc_nullable] = STATE(1999),
    [sym_preproc_error] = STATE(1999),
    [sym_preproc_define] = STATE(1999),
    [sym_preproc_undef] = STATE(1999),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2000] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4891),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2000),
    [sym_preproc_endregion] = STATE(2000),
    [sym_preproc_line] = STATE(2000),
    [sym_preproc_pragma] = STATE(2000),
    [sym_preproc_nullable] = STATE(2000),
    [sym_preproc_error] = STATE(2000),
    [sym_preproc_define] = STATE(2000),
    [sym_preproc_undef] = STATE(2000),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2001] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4890),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2001),
    [sym_preproc_endregion] = STATE(2001),
    [sym_preproc_line] = STATE(2001),
    [sym_preproc_pragma] = STATE(2001),
    [sym_preproc_nullable] = STATE(2001),
    [sym_preproc_error] = STATE(2001),
    [sym_preproc_define] = STATE(2001),
    [sym_preproc_undef] = STATE(2001),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2002] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4895),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2002),
    [sym_preproc_endregion] = STATE(2002),
    [sym_preproc_line] = STATE(2002),
    [sym_preproc_pragma] = STATE(2002),
    [sym_preproc_nullable] = STATE(2002),
    [sym_preproc_error] = STATE(2002),
    [sym_preproc_define] = STATE(2002),
    [sym_preproc_undef] = STATE(2002),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2003] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6593),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2003),
    [sym_preproc_endregion] = STATE(2003),
    [sym_preproc_line] = STATE(2003),
    [sym_preproc_pragma] = STATE(2003),
    [sym_preproc_nullable] = STATE(2003),
    [sym_preproc_error] = STATE(2003),
    [sym_preproc_define] = STATE(2003),
    [sym_preproc_undef] = STATE(2003),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2004] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5010),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2004),
    [sym_preproc_endregion] = STATE(2004),
    [sym_preproc_line] = STATE(2004),
    [sym_preproc_pragma] = STATE(2004),
    [sym_preproc_nullable] = STATE(2004),
    [sym_preproc_error] = STATE(2004),
    [sym_preproc_define] = STATE(2004),
    [sym_preproc_undef] = STATE(2004),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2005] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4859),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2005),
    [sym_preproc_endregion] = STATE(2005),
    [sym_preproc_line] = STATE(2005),
    [sym_preproc_pragma] = STATE(2005),
    [sym_preproc_nullable] = STATE(2005),
    [sym_preproc_error] = STATE(2005),
    [sym_preproc_define] = STATE(2005),
    [sym_preproc_undef] = STATE(2005),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2006] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6572),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2006),
    [sym_preproc_endregion] = STATE(2006),
    [sym_preproc_line] = STATE(2006),
    [sym_preproc_pragma] = STATE(2006),
    [sym_preproc_nullable] = STATE(2006),
    [sym_preproc_error] = STATE(2006),
    [sym_preproc_define] = STATE(2006),
    [sym_preproc_undef] = STATE(2006),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2007] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6563),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2007),
    [sym_preproc_endregion] = STATE(2007),
    [sym_preproc_line] = STATE(2007),
    [sym_preproc_pragma] = STATE(2007),
    [sym_preproc_nullable] = STATE(2007),
    [sym_preproc_error] = STATE(2007),
    [sym_preproc_define] = STATE(2007),
    [sym_preproc_undef] = STATE(2007),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2008] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6540),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2008),
    [sym_preproc_endregion] = STATE(2008),
    [sym_preproc_line] = STATE(2008),
    [sym_preproc_pragma] = STATE(2008),
    [sym_preproc_nullable] = STATE(2008),
    [sym_preproc_error] = STATE(2008),
    [sym_preproc_define] = STATE(2008),
    [sym_preproc_undef] = STATE(2008),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2009] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6537),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2009),
    [sym_preproc_endregion] = STATE(2009),
    [sym_preproc_line] = STATE(2009),
    [sym_preproc_pragma] = STATE(2009),
    [sym_preproc_nullable] = STATE(2009),
    [sym_preproc_error] = STATE(2009),
    [sym_preproc_define] = STATE(2009),
    [sym_preproc_undef] = STATE(2009),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2010] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6288),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2010),
    [sym_preproc_endregion] = STATE(2010),
    [sym_preproc_line] = STATE(2010),
    [sym_preproc_pragma] = STATE(2010),
    [sym_preproc_nullable] = STATE(2010),
    [sym_preproc_error] = STATE(2010),
    [sym_preproc_define] = STATE(2010),
    [sym_preproc_undef] = STATE(2010),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2011] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6927),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7078),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5449),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4278),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7426),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9445),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2011),
    [sym_preproc_endregion] = STATE(2011),
    [sym_preproc_line] = STATE(2011),
    [sym_preproc_pragma] = STATE(2011),
    [sym_preproc_nullable] = STATE(2011),
    [sym_preproc_error] = STATE(2011),
    [sym_preproc_define] = STATE(2011),
    [sym_preproc_undef] = STATE(2011),
    [aux_sym_class_declaration_repeat1] = STATE(3854),
    [aux_sym_lambda_expression_repeat1] = STATE(4173),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_ref] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1899),
    [anon_sym_TILDE] = ACTIONS(1899),
    [anon_sym_PLUS_PLUS] = ACTIONS(1899),
    [anon_sym_DASH_DASH] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_CARET] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1899),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1903),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1907),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2012] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2012),
    [sym_preproc_endregion] = STATE(2012),
    [sym_preproc_line] = STATE(2012),
    [sym_preproc_pragma] = STATE(2012),
    [sym_preproc_nullable] = STATE(2012),
    [sym_preproc_error] = STATE(2012),
    [sym_preproc_define] = STATE(2012),
    [sym_preproc_undef] = STATE(2012),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2013] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6168),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2013),
    [sym_preproc_endregion] = STATE(2013),
    [sym_preproc_line] = STATE(2013),
    [sym_preproc_pragma] = STATE(2013),
    [sym_preproc_nullable] = STATE(2013),
    [sym_preproc_error] = STATE(2013),
    [sym_preproc_define] = STATE(2013),
    [sym_preproc_undef] = STATE(2013),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2014] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6533),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2014),
    [sym_preproc_endregion] = STATE(2014),
    [sym_preproc_line] = STATE(2014),
    [sym_preproc_pragma] = STATE(2014),
    [sym_preproc_nullable] = STATE(2014),
    [sym_preproc_error] = STATE(2014),
    [sym_preproc_define] = STATE(2014),
    [sym_preproc_undef] = STATE(2014),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2015] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6169),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2015),
    [sym_preproc_endregion] = STATE(2015),
    [sym_preproc_line] = STATE(2015),
    [sym_preproc_pragma] = STATE(2015),
    [sym_preproc_nullable] = STATE(2015),
    [sym_preproc_error] = STATE(2015),
    [sym_preproc_define] = STATE(2015),
    [sym_preproc_undef] = STATE(2015),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2016] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6531),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2016),
    [sym_preproc_endregion] = STATE(2016),
    [sym_preproc_line] = STATE(2016),
    [sym_preproc_pragma] = STATE(2016),
    [sym_preproc_nullable] = STATE(2016),
    [sym_preproc_error] = STATE(2016),
    [sym_preproc_define] = STATE(2016),
    [sym_preproc_undef] = STATE(2016),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2017] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4725),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2017),
    [sym_preproc_endregion] = STATE(2017),
    [sym_preproc_line] = STATE(2017),
    [sym_preproc_pragma] = STATE(2017),
    [sym_preproc_nullable] = STATE(2017),
    [sym_preproc_error] = STATE(2017),
    [sym_preproc_define] = STATE(2017),
    [sym_preproc_undef] = STATE(2017),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2018] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6170),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2018),
    [sym_preproc_endregion] = STATE(2018),
    [sym_preproc_line] = STATE(2018),
    [sym_preproc_pragma] = STATE(2018),
    [sym_preproc_nullable] = STATE(2018),
    [sym_preproc_error] = STATE(2018),
    [sym_preproc_define] = STATE(2018),
    [sym_preproc_undef] = STATE(2018),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2019] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6163),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2019),
    [sym_preproc_endregion] = STATE(2019),
    [sym_preproc_line] = STATE(2019),
    [sym_preproc_pragma] = STATE(2019),
    [sym_preproc_nullable] = STATE(2019),
    [sym_preproc_error] = STATE(2019),
    [sym_preproc_define] = STATE(2019),
    [sym_preproc_undef] = STATE(2019),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2020] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6497),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2020),
    [sym_preproc_endregion] = STATE(2020),
    [sym_preproc_line] = STATE(2020),
    [sym_preproc_pragma] = STATE(2020),
    [sym_preproc_nullable] = STATE(2020),
    [sym_preproc_error] = STATE(2020),
    [sym_preproc_define] = STATE(2020),
    [sym_preproc_undef] = STATE(2020),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2021] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5007),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2021),
    [sym_preproc_endregion] = STATE(2021),
    [sym_preproc_line] = STATE(2021),
    [sym_preproc_pragma] = STATE(2021),
    [sym_preproc_nullable] = STATE(2021),
    [sym_preproc_error] = STATE(2021),
    [sym_preproc_define] = STATE(2021),
    [sym_preproc_undef] = STATE(2021),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2022] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7098),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5278),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(3992),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7419),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9545),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2022),
    [sym_preproc_endregion] = STATE(2022),
    [sym_preproc_line] = STATE(2022),
    [sym_preproc_pragma] = STATE(2022),
    [sym_preproc_nullable] = STATE(2022),
    [sym_preproc_error] = STATE(2022),
    [sym_preproc_define] = STATE(2022),
    [sym_preproc_undef] = STATE(2022),
    [aux_sym_class_declaration_repeat1] = STATE(3876),
    [aux_sym_lambda_expression_repeat1] = STATE(4168),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_ref] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1417),
    [anon_sym_DASH] = ACTIONS(1417),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1437),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2023] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6172),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2023),
    [sym_preproc_endregion] = STATE(2023),
    [sym_preproc_line] = STATE(2023),
    [sym_preproc_pragma] = STATE(2023),
    [sym_preproc_nullable] = STATE(2023),
    [sym_preproc_error] = STATE(2023),
    [sym_preproc_define] = STATE(2023),
    [sym_preproc_undef] = STATE(2023),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2024] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6173),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2024),
    [sym_preproc_endregion] = STATE(2024),
    [sym_preproc_line] = STATE(2024),
    [sym_preproc_pragma] = STATE(2024),
    [sym_preproc_nullable] = STATE(2024),
    [sym_preproc_error] = STATE(2024),
    [sym_preproc_define] = STATE(2024),
    [sym_preproc_undef] = STATE(2024),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2025] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5056),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2025),
    [sym_preproc_endregion] = STATE(2025),
    [sym_preproc_line] = STATE(2025),
    [sym_preproc_pragma] = STATE(2025),
    [sym_preproc_nullable] = STATE(2025),
    [sym_preproc_error] = STATE(2025),
    [sym_preproc_define] = STATE(2025),
    [sym_preproc_undef] = STATE(2025),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2026] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5130),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2026),
    [sym_preproc_endregion] = STATE(2026),
    [sym_preproc_line] = STATE(2026),
    [sym_preproc_pragma] = STATE(2026),
    [sym_preproc_nullable] = STATE(2026),
    [sym_preproc_error] = STATE(2026),
    [sym_preproc_define] = STATE(2026),
    [sym_preproc_undef] = STATE(2026),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2027] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5604),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2027),
    [sym_preproc_endregion] = STATE(2027),
    [sym_preproc_line] = STATE(2027),
    [sym_preproc_pragma] = STATE(2027),
    [sym_preproc_nullable] = STATE(2027),
    [sym_preproc_error] = STATE(2027),
    [sym_preproc_define] = STATE(2027),
    [sym_preproc_undef] = STATE(2027),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2028] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6933),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2939),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7067),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4430),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3788),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9525),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2028),
    [sym_preproc_endregion] = STATE(2028),
    [sym_preproc_line] = STATE(2028),
    [sym_preproc_pragma] = STATE(2028),
    [sym_preproc_nullable] = STATE(2028),
    [sym_preproc_error] = STATE(2028),
    [sym_preproc_define] = STATE(2028),
    [sym_preproc_undef] = STATE(2028),
    [aux_sym_class_declaration_repeat1] = STATE(3810),
    [aux_sym_lambda_expression_repeat1] = STATE(4101),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2053),
    [anon_sym_ref] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1647),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(2059),
    [anon_sym_PLUS_PLUS] = ACTIONS(2059),
    [anon_sym_DASH_DASH] = ACTIONS(2059),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2057),
    [anon_sym_DASH] = ACTIONS(2057),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_CARET] = ACTIONS(2059),
    [anon_sym_AMP] = ACTIONS(2059),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2061),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2063),
    [anon_sym_DOT_DOT] = ACTIONS(2065),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2029] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5380),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2029),
    [sym_preproc_endregion] = STATE(2029),
    [sym_preproc_line] = STATE(2029),
    [sym_preproc_pragma] = STATE(2029),
    [sym_preproc_nullable] = STATE(2029),
    [sym_preproc_error] = STATE(2029),
    [sym_preproc_define] = STATE(2029),
    [sym_preproc_undef] = STATE(2029),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2030] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5005),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2030),
    [sym_preproc_endregion] = STATE(2030),
    [sym_preproc_line] = STATE(2030),
    [sym_preproc_pragma] = STATE(2030),
    [sym_preproc_nullable] = STATE(2030),
    [sym_preproc_error] = STATE(2030),
    [sym_preproc_define] = STATE(2030),
    [sym_preproc_undef] = STATE(2030),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2031] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2031),
    [sym_preproc_endregion] = STATE(2031),
    [sym_preproc_line] = STATE(2031),
    [sym_preproc_pragma] = STATE(2031),
    [sym_preproc_nullable] = STATE(2031),
    [sym_preproc_error] = STATE(2031),
    [sym_preproc_define] = STATE(2031),
    [sym_preproc_undef] = STATE(2031),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2032] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6201),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2032),
    [sym_preproc_endregion] = STATE(2032),
    [sym_preproc_line] = STATE(2032),
    [sym_preproc_pragma] = STATE(2032),
    [sym_preproc_nullable] = STATE(2032),
    [sym_preproc_error] = STATE(2032),
    [sym_preproc_define] = STATE(2032),
    [sym_preproc_undef] = STATE(2032),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2033] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6202),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2033),
    [sym_preproc_endregion] = STATE(2033),
    [sym_preproc_line] = STATE(2033),
    [sym_preproc_pragma] = STATE(2033),
    [sym_preproc_nullable] = STATE(2033),
    [sym_preproc_error] = STATE(2033),
    [sym_preproc_define] = STATE(2033),
    [sym_preproc_undef] = STATE(2033),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2034] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6174),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2034),
    [sym_preproc_endregion] = STATE(2034),
    [sym_preproc_line] = STATE(2034),
    [sym_preproc_pragma] = STATE(2034),
    [sym_preproc_nullable] = STATE(2034),
    [sym_preproc_error] = STATE(2034),
    [sym_preproc_define] = STATE(2034),
    [sym_preproc_undef] = STATE(2034),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2035] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2035),
    [sym_preproc_endregion] = STATE(2035),
    [sym_preproc_line] = STATE(2035),
    [sym_preproc_pragma] = STATE(2035),
    [sym_preproc_nullable] = STATE(2035),
    [sym_preproc_error] = STATE(2035),
    [sym_preproc_define] = STATE(2035),
    [sym_preproc_undef] = STATE(2035),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2036] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6919),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2970),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6999),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6620),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4500),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7416),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9145),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2036),
    [sym_preproc_endregion] = STATE(2036),
    [sym_preproc_line] = STATE(2036),
    [sym_preproc_pragma] = STATE(2036),
    [sym_preproc_nullable] = STATE(2036),
    [sym_preproc_error] = STATE(2036),
    [sym_preproc_define] = STATE(2036),
    [sym_preproc_undef] = STATE(2036),
    [aux_sym_class_declaration_repeat1] = STATE(3816),
    [aux_sym_lambda_expression_repeat1] = STATE(4312),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2127),
    [anon_sym_ref] = ACTIONS(2129),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2131),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2137),
    [anon_sym_CARET] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2141),
    [anon_sym_DOT_DOT] = ACTIONS(2143),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2037] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6519),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2037),
    [sym_preproc_endregion] = STATE(2037),
    [sym_preproc_line] = STATE(2037),
    [sym_preproc_pragma] = STATE(2037),
    [sym_preproc_nullable] = STATE(2037),
    [sym_preproc_error] = STATE(2037),
    [sym_preproc_define] = STATE(2037),
    [sym_preproc_undef] = STATE(2037),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2038] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5249),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2038),
    [sym_preproc_endregion] = STATE(2038),
    [sym_preproc_line] = STATE(2038),
    [sym_preproc_pragma] = STATE(2038),
    [sym_preproc_nullable] = STATE(2038),
    [sym_preproc_error] = STATE(2038),
    [sym_preproc_define] = STATE(2038),
    [sym_preproc_undef] = STATE(2038),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2039] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6051),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2039),
    [sym_preproc_endregion] = STATE(2039),
    [sym_preproc_line] = STATE(2039),
    [sym_preproc_pragma] = STATE(2039),
    [sym_preproc_nullable] = STATE(2039),
    [sym_preproc_error] = STATE(2039),
    [sym_preproc_define] = STATE(2039),
    [sym_preproc_undef] = STATE(2039),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2040] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5003),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2040),
    [sym_preproc_endregion] = STATE(2040),
    [sym_preproc_line] = STATE(2040),
    [sym_preproc_pragma] = STATE(2040),
    [sym_preproc_nullable] = STATE(2040),
    [sym_preproc_error] = STATE(2040),
    [sym_preproc_define] = STATE(2040),
    [sym_preproc_undef] = STATE(2040),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2041] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6463),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2041),
    [sym_preproc_endregion] = STATE(2041),
    [sym_preproc_line] = STATE(2041),
    [sym_preproc_pragma] = STATE(2041),
    [sym_preproc_nullable] = STATE(2041),
    [sym_preproc_error] = STATE(2041),
    [sym_preproc_define] = STATE(2041),
    [sym_preproc_undef] = STATE(2041),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2042] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4932),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2042),
    [sym_preproc_endregion] = STATE(2042),
    [sym_preproc_line] = STATE(2042),
    [sym_preproc_pragma] = STATE(2042),
    [sym_preproc_nullable] = STATE(2042),
    [sym_preproc_error] = STATE(2042),
    [sym_preproc_define] = STATE(2042),
    [sym_preproc_undef] = STATE(2042),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2043] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4933),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2043),
    [sym_preproc_endregion] = STATE(2043),
    [sym_preproc_line] = STATE(2043),
    [sym_preproc_pragma] = STATE(2043),
    [sym_preproc_nullable] = STATE(2043),
    [sym_preproc_error] = STATE(2043),
    [sym_preproc_define] = STATE(2043),
    [sym_preproc_undef] = STATE(2043),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2044] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4934),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2044),
    [sym_preproc_endregion] = STATE(2044),
    [sym_preproc_line] = STATE(2044),
    [sym_preproc_pragma] = STATE(2044),
    [sym_preproc_nullable] = STATE(2044),
    [sym_preproc_error] = STATE(2044),
    [sym_preproc_define] = STATE(2044),
    [sym_preproc_undef] = STATE(2044),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2045] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5348),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2045),
    [sym_preproc_endregion] = STATE(2045),
    [sym_preproc_line] = STATE(2045),
    [sym_preproc_pragma] = STATE(2045),
    [sym_preproc_nullable] = STATE(2045),
    [sym_preproc_error] = STATE(2045),
    [sym_preproc_define] = STATE(2045),
    [sym_preproc_undef] = STATE(2045),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2046] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4937),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2046),
    [sym_preproc_endregion] = STATE(2046),
    [sym_preproc_line] = STATE(2046),
    [sym_preproc_pragma] = STATE(2046),
    [sym_preproc_nullable] = STATE(2046),
    [sym_preproc_error] = STATE(2046),
    [sym_preproc_define] = STATE(2046),
    [sym_preproc_undef] = STATE(2046),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2047] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4938),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2047),
    [sym_preproc_endregion] = STATE(2047),
    [sym_preproc_line] = STATE(2047),
    [sym_preproc_pragma] = STATE(2047),
    [sym_preproc_nullable] = STATE(2047),
    [sym_preproc_error] = STATE(2047),
    [sym_preproc_define] = STATE(2047),
    [sym_preproc_undef] = STATE(2047),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2048] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5211),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2048),
    [sym_preproc_endregion] = STATE(2048),
    [sym_preproc_line] = STATE(2048),
    [sym_preproc_pragma] = STATE(2048),
    [sym_preproc_nullable] = STATE(2048),
    [sym_preproc_error] = STATE(2048),
    [sym_preproc_define] = STATE(2048),
    [sym_preproc_undef] = STATE(2048),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2049] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6739),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3477),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2049),
    [sym_preproc_endregion] = STATE(2049),
    [sym_preproc_line] = STATE(2049),
    [sym_preproc_pragma] = STATE(2049),
    [sym_preproc_nullable] = STATE(2049),
    [sym_preproc_error] = STATE(2049),
    [sym_preproc_define] = STATE(2049),
    [sym_preproc_undef] = STATE(2049),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2050] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6715),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3881),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2050),
    [sym_preproc_endregion] = STATE(2050),
    [sym_preproc_line] = STATE(2050),
    [sym_preproc_pragma] = STATE(2050),
    [sym_preproc_nullable] = STATE(2050),
    [sym_preproc_error] = STATE(2050),
    [sym_preproc_define] = STATE(2050),
    [sym_preproc_undef] = STATE(2050),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2051] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4939),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2051),
    [sym_preproc_endregion] = STATE(2051),
    [sym_preproc_line] = STATE(2051),
    [sym_preproc_pragma] = STATE(2051),
    [sym_preproc_nullable] = STATE(2051),
    [sym_preproc_error] = STATE(2051),
    [sym_preproc_define] = STATE(2051),
    [sym_preproc_undef] = STATE(2051),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2052] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4918),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2052),
    [sym_preproc_endregion] = STATE(2052),
    [sym_preproc_line] = STATE(2052),
    [sym_preproc_pragma] = STATE(2052),
    [sym_preproc_nullable] = STATE(2052),
    [sym_preproc_error] = STATE(2052),
    [sym_preproc_define] = STATE(2052),
    [sym_preproc_undef] = STATE(2052),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2053] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4917),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2053),
    [sym_preproc_endregion] = STATE(2053),
    [sym_preproc_line] = STATE(2053),
    [sym_preproc_pragma] = STATE(2053),
    [sym_preproc_nullable] = STATE(2053),
    [sym_preproc_error] = STATE(2053),
    [sym_preproc_define] = STATE(2053),
    [sym_preproc_undef] = STATE(2053),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2054] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4916),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2054),
    [sym_preproc_endregion] = STATE(2054),
    [sym_preproc_line] = STATE(2054),
    [sym_preproc_pragma] = STATE(2054),
    [sym_preproc_nullable] = STATE(2054),
    [sym_preproc_error] = STATE(2054),
    [sym_preproc_define] = STATE(2054),
    [sym_preproc_undef] = STATE(2054),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2055] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4850),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2055),
    [sym_preproc_endregion] = STATE(2055),
    [sym_preproc_line] = STATE(2055),
    [sym_preproc_pragma] = STATE(2055),
    [sym_preproc_nullable] = STATE(2055),
    [sym_preproc_error] = STATE(2055),
    [sym_preproc_define] = STATE(2055),
    [sym_preproc_undef] = STATE(2055),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2056] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4849),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2056),
    [sym_preproc_endregion] = STATE(2056),
    [sym_preproc_line] = STATE(2056),
    [sym_preproc_pragma] = STATE(2056),
    [sym_preproc_nullable] = STATE(2056),
    [sym_preproc_error] = STATE(2056),
    [sym_preproc_define] = STATE(2056),
    [sym_preproc_undef] = STATE(2056),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2057] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6501),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2057),
    [sym_preproc_endregion] = STATE(2057),
    [sym_preproc_line] = STATE(2057),
    [sym_preproc_pragma] = STATE(2057),
    [sym_preproc_nullable] = STATE(2057),
    [sym_preproc_error] = STATE(2057),
    [sym_preproc_define] = STATE(2057),
    [sym_preproc_undef] = STATE(2057),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2058] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5792),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2058),
    [sym_preproc_endregion] = STATE(2058),
    [sym_preproc_line] = STATE(2058),
    [sym_preproc_pragma] = STATE(2058),
    [sym_preproc_nullable] = STATE(2058),
    [sym_preproc_error] = STATE(2058),
    [sym_preproc_define] = STATE(2058),
    [sym_preproc_undef] = STATE(2058),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2059] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6203),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2059),
    [sym_preproc_endregion] = STATE(2059),
    [sym_preproc_line] = STATE(2059),
    [sym_preproc_pragma] = STATE(2059),
    [sym_preproc_nullable] = STATE(2059),
    [sym_preproc_error] = STATE(2059),
    [sym_preproc_define] = STATE(2059),
    [sym_preproc_undef] = STATE(2059),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2060] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6206),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2060),
    [sym_preproc_endregion] = STATE(2060),
    [sym_preproc_line] = STATE(2060),
    [sym_preproc_pragma] = STATE(2060),
    [sym_preproc_nullable] = STATE(2060),
    [sym_preproc_error] = STATE(2060),
    [sym_preproc_define] = STATE(2060),
    [sym_preproc_undef] = STATE(2060),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2061] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3949),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2061),
    [sym_preproc_endregion] = STATE(2061),
    [sym_preproc_line] = STATE(2061),
    [sym_preproc_pragma] = STATE(2061),
    [sym_preproc_nullable] = STATE(2061),
    [sym_preproc_error] = STATE(2061),
    [sym_preproc_define] = STATE(2061),
    [sym_preproc_undef] = STATE(2061),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2062] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5057),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2062),
    [sym_preproc_endregion] = STATE(2062),
    [sym_preproc_line] = STATE(2062),
    [sym_preproc_pragma] = STATE(2062),
    [sym_preproc_nullable] = STATE(2062),
    [sym_preproc_error] = STATE(2062),
    [sym_preproc_define] = STATE(2062),
    [sym_preproc_undef] = STATE(2062),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2063] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6207),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2063),
    [sym_preproc_endregion] = STATE(2063),
    [sym_preproc_line] = STATE(2063),
    [sym_preproc_pragma] = STATE(2063),
    [sym_preproc_nullable] = STATE(2063),
    [sym_preproc_error] = STATE(2063),
    [sym_preproc_define] = STATE(2063),
    [sym_preproc_undef] = STATE(2063),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2064] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5053),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2064),
    [sym_preproc_endregion] = STATE(2064),
    [sym_preproc_line] = STATE(2064),
    [sym_preproc_pragma] = STATE(2064),
    [sym_preproc_nullable] = STATE(2064),
    [sym_preproc_error] = STATE(2064),
    [sym_preproc_define] = STATE(2064),
    [sym_preproc_undef] = STATE(2064),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2065] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6208),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2065),
    [sym_preproc_endregion] = STATE(2065),
    [sym_preproc_line] = STATE(2065),
    [sym_preproc_pragma] = STATE(2065),
    [sym_preproc_nullable] = STATE(2065),
    [sym_preproc_error] = STATE(2065),
    [sym_preproc_define] = STATE(2065),
    [sym_preproc_undef] = STATE(2065),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2066] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6209),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2066),
    [sym_preproc_endregion] = STATE(2066),
    [sym_preproc_line] = STATE(2066),
    [sym_preproc_pragma] = STATE(2066),
    [sym_preproc_nullable] = STATE(2066),
    [sym_preproc_error] = STATE(2066),
    [sym_preproc_define] = STATE(2066),
    [sym_preproc_undef] = STATE(2066),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2067] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6211),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2067),
    [sym_preproc_endregion] = STATE(2067),
    [sym_preproc_line] = STATE(2067),
    [sym_preproc_pragma] = STATE(2067),
    [sym_preproc_nullable] = STATE(2067),
    [sym_preproc_error] = STATE(2067),
    [sym_preproc_define] = STATE(2067),
    [sym_preproc_undef] = STATE(2067),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2068] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7055),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4501),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3628),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7421),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9045),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2068),
    [sym_preproc_endregion] = STATE(2068),
    [sym_preproc_line] = STATE(2068),
    [sym_preproc_pragma] = STATE(2068),
    [sym_preproc_nullable] = STATE(2068),
    [sym_preproc_error] = STATE(2068),
    [sym_preproc_define] = STATE(2068),
    [sym_preproc_undef] = STATE(2068),
    [aux_sym_class_declaration_repeat1] = STATE(3852),
    [aux_sym_lambda_expression_repeat1] = STATE(4292),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_ref] = ACTIONS(1161),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1189),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2069] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6390),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2069),
    [sym_preproc_endregion] = STATE(2069),
    [sym_preproc_line] = STATE(2069),
    [sym_preproc_pragma] = STATE(2069),
    [sym_preproc_nullable] = STATE(2069),
    [sym_preproc_error] = STATE(2069),
    [sym_preproc_define] = STATE(2069),
    [sym_preproc_undef] = STATE(2069),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2070] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5198),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2070),
    [sym_preproc_endregion] = STATE(2070),
    [sym_preproc_line] = STATE(2070),
    [sym_preproc_pragma] = STATE(2070),
    [sym_preproc_nullable] = STATE(2070),
    [sym_preproc_error] = STATE(2070),
    [sym_preproc_define] = STATE(2070),
    [sym_preproc_undef] = STATE(2070),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2071] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6928),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2867),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(6969),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6022),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4344),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9210),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2071),
    [sym_preproc_endregion] = STATE(2071),
    [sym_preproc_line] = STATE(2071),
    [sym_preproc_pragma] = STATE(2071),
    [sym_preproc_nullable] = STATE(2071),
    [sym_preproc_error] = STATE(2071),
    [sym_preproc_define] = STATE(2071),
    [sym_preproc_undef] = STATE(2071),
    [aux_sym_class_declaration_repeat1] = STATE(3821),
    [aux_sym_lambda_expression_repeat1] = STATE(4116),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_ref] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1413),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1773),
    [anon_sym_TILDE] = ACTIONS(1773),
    [anon_sym_PLUS_PLUS] = ACTIONS(1773),
    [anon_sym_DASH_DASH] = ACTIONS(1773),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1777),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2072] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6212),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2072),
    [sym_preproc_endregion] = STATE(2072),
    [sym_preproc_line] = STATE(2072),
    [sym_preproc_pragma] = STATE(2072),
    [sym_preproc_nullable] = STATE(2072),
    [sym_preproc_error] = STATE(2072),
    [sym_preproc_define] = STATE(2072),
    [sym_preproc_undef] = STATE(2072),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2073] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4420),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2073),
    [sym_preproc_endregion] = STATE(2073),
    [sym_preproc_line] = STATE(2073),
    [sym_preproc_pragma] = STATE(2073),
    [sym_preproc_nullable] = STATE(2073),
    [sym_preproc_error] = STATE(2073),
    [sym_preproc_define] = STATE(2073),
    [sym_preproc_undef] = STATE(2073),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2074] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6213),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2074),
    [sym_preproc_endregion] = STATE(2074),
    [sym_preproc_line] = STATE(2074),
    [sym_preproc_pragma] = STATE(2074),
    [sym_preproc_nullable] = STATE(2074),
    [sym_preproc_error] = STATE(2074),
    [sym_preproc_define] = STATE(2074),
    [sym_preproc_undef] = STATE(2074),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2075] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5344),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2075),
    [sym_preproc_endregion] = STATE(2075),
    [sym_preproc_line] = STATE(2075),
    [sym_preproc_pragma] = STATE(2075),
    [sym_preproc_nullable] = STATE(2075),
    [sym_preproc_error] = STATE(2075),
    [sym_preproc_define] = STATE(2075),
    [sym_preproc_undef] = STATE(2075),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2076] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3570),
    [sym__name] = STATE(6940),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2930),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7010),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4727),
    [sym_non_lvalue_expression] = STATE(4683),
    [sym_lvalue_expression] = STATE(3696),
    [sym__expression_statement_expression] = STATE(4686),
    [sym_assignment_expression] = STATE(4682),
    [sym_binary_expression] = STATE(4686),
    [sym_postfix_unary_expression] = STATE(4682),
    [sym_prefix_unary_expression] = STATE(4682),
    [sym__pointer_indirection_expression] = STATE(3575),
    [sym_query_expression] = STATE(4686),
    [sym_from_clause] = STATE(7427),
    [sym_conditional_expression] = STATE(4686),
    [sym_conditional_access_expression] = STATE(4686),
    [sym_as_expression] = STATE(4686),
    [sym_is_expression] = STATE(4686),
    [sym_is_pattern_expression] = STATE(4686),
    [sym_cast_expression] = STATE(4686),
    [sym_checked_expression] = STATE(4686),
    [sym_invocation_expression] = STATE(4682),
    [sym_switch_expression] = STATE(4686),
    [sym_await_expression] = STATE(4682),
    [sym_throw_expression] = STATE(4686),
    [sym_element_access_expression] = STATE(3575),
    [sym_interpolated_string_expression] = STATE(4686),
    [sym_member_access_expression] = STATE(3575),
    [sym_object_creation_expression] = STATE(4682),
    [sym_parenthesized_expression] = STATE(4682),
    [sym__parenthesized_lvalue_expression] = STATE(3575),
    [sym_lambda_expression] = STATE(4686),
    [sym__lambda_parameters] = STATE(9215),
    [sym_array_creation_expression] = STATE(4686),
    [sym_anonymous_method_expression] = STATE(4686),
    [sym_anonymous_object_creation_expression] = STATE(4686),
    [sym_implicit_array_creation_expression] = STATE(4686),
    [sym_implicit_object_creation_expression] = STATE(4686),
    [sym_implicit_stackalloc_expression] = STATE(4686),
    [sym_initializer_expression] = STATE(4686),
    [sym_default_expression] = STATE(4686),
    [sym_with_expression] = STATE(4686),
    [sym_sizeof_expression] = STATE(4686),
    [sym_typeof_expression] = STATE(4686),
    [sym_makeref_expression] = STATE(4686),
    [sym_ref_expression] = STATE(4686),
    [sym_reftype_expression] = STATE(4686),
    [sym_refvalue_expression] = STATE(4686),
    [sym_stackalloc_expression] = STATE(4686),
    [sym_range_expression] = STATE(4686),
    [sym_tuple_expression] = STATE(3575),
    [sym_literal] = STATE(4686),
    [sym_character_literal] = STATE(4664),
    [sym_string_literal] = STATE(4664),
    [sym_raw_string_literal] = STATE(4664),
    [sym_boolean_literal] = STATE(4664),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4686),
    [sym_preproc_region] = STATE(2076),
    [sym_preproc_endregion] = STATE(2076),
    [sym_preproc_line] = STATE(2076),
    [sym_preproc_pragma] = STATE(2076),
    [sym_preproc_nullable] = STATE(2076),
    [sym_preproc_error] = STATE(2076),
    [sym_preproc_define] = STATE(2076),
    [sym_preproc_undef] = STATE(2076),
    [aux_sym_class_declaration_repeat1] = STATE(3832),
    [aux_sym_lambda_expression_repeat1] = STATE(4256),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(2039),
    [anon_sym_ref] = ACTIONS(2041),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_delegate] = ACTIONS(1645),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1785),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_PLUS_PLUS] = ACTIONS(2045),
    [anon_sym_DASH_DASH] = ACTIONS(2045),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_CARET] = ACTIONS(2045),
    [anon_sym_AMP] = ACTIONS(2045),
    [anon_sym_this] = ACTIONS(1659),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1661),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1663),
    [anon_sym_unchecked] = ACTIONS(1649),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1665),
    [anon_sym_throw] = ACTIONS(2047),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2049),
    [anon_sym_DOT_DOT] = ACTIONS(2051),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_stackalloc] = ACTIONS(1675),
    [anon_sym_sizeof] = ACTIONS(1677),
    [anon_sym_typeof] = ACTIONS(1679),
    [anon_sym___makeref] = ACTIONS(1681),
    [anon_sym___reftype] = ACTIONS(1683),
    [anon_sym___refvalue] = ACTIONS(1685),
    [sym_null_literal] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [sym_real_literal] = ACTIONS(1691),
    [sym_verbatim_string_literal] = ACTIONS(1691),
    [aux_sym_preproc_if_token1] = ACTIONS(1693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1695),
    [sym_interpolation_verbatim_start] = ACTIONS(1697),
    [sym_interpolation_raw_start] = ACTIONS(1699),
    [sym_raw_string_start] = ACTIONS(1701),
  },
  [2077] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6214),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2077),
    [sym_preproc_endregion] = STATE(2077),
    [sym_preproc_line] = STATE(2077),
    [sym_preproc_pragma] = STATE(2077),
    [sym_preproc_nullable] = STATE(2077),
    [sym_preproc_error] = STATE(2077),
    [sym_preproc_define] = STATE(2077),
    [sym_preproc_undef] = STATE(2077),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2078] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5002),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2078),
    [sym_preproc_endregion] = STATE(2078),
    [sym_preproc_line] = STATE(2078),
    [sym_preproc_pragma] = STATE(2078),
    [sym_preproc_nullable] = STATE(2078),
    [sym_preproc_error] = STATE(2078),
    [sym_preproc_define] = STATE(2078),
    [sym_preproc_undef] = STATE(2078),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2079] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6486),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2079),
    [sym_preproc_endregion] = STATE(2079),
    [sym_preproc_line] = STATE(2079),
    [sym_preproc_pragma] = STATE(2079),
    [sym_preproc_nullable] = STATE(2079),
    [sym_preproc_error] = STATE(2079),
    [sym_preproc_define] = STATE(2079),
    [sym_preproc_undef] = STATE(2079),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2080] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5128),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2080),
    [sym_preproc_endregion] = STATE(2080),
    [sym_preproc_line] = STATE(2080),
    [sym_preproc_pragma] = STATE(2080),
    [sym_preproc_nullable] = STATE(2080),
    [sym_preproc_error] = STATE(2080),
    [sym_preproc_define] = STATE(2080),
    [sym_preproc_undef] = STATE(2080),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2081] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4941),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2081),
    [sym_preproc_endregion] = STATE(2081),
    [sym_preproc_line] = STATE(2081),
    [sym_preproc_pragma] = STATE(2081),
    [sym_preproc_nullable] = STATE(2081),
    [sym_preproc_error] = STATE(2081),
    [sym_preproc_define] = STATE(2081),
    [sym_preproc_undef] = STATE(2081),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2082] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5250),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2082),
    [sym_preproc_endregion] = STATE(2082),
    [sym_preproc_line] = STATE(2082),
    [sym_preproc_pragma] = STATE(2082),
    [sym_preproc_nullable] = STATE(2082),
    [sym_preproc_error] = STATE(2082),
    [sym_preproc_define] = STATE(2082),
    [sym_preproc_undef] = STATE(2082),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2083] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5058),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2083),
    [sym_preproc_endregion] = STATE(2083),
    [sym_preproc_line] = STATE(2083),
    [sym_preproc_pragma] = STATE(2083),
    [sym_preproc_nullable] = STATE(2083),
    [sym_preproc_error] = STATE(2083),
    [sym_preproc_define] = STATE(2083),
    [sym_preproc_undef] = STATE(2083),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2084] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2084),
    [sym_preproc_endregion] = STATE(2084),
    [sym_preproc_line] = STATE(2084),
    [sym_preproc_pragma] = STATE(2084),
    [sym_preproc_nullable] = STATE(2084),
    [sym_preproc_error] = STATE(2084),
    [sym_preproc_define] = STATE(2084),
    [sym_preproc_undef] = STATE(2084),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2085] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6176),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2085),
    [sym_preproc_endregion] = STATE(2085),
    [sym_preproc_line] = STATE(2085),
    [sym_preproc_pragma] = STATE(2085),
    [sym_preproc_nullable] = STATE(2085),
    [sym_preproc_error] = STATE(2085),
    [sym_preproc_define] = STATE(2085),
    [sym_preproc_undef] = STATE(2085),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2086] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5915),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2086),
    [sym_preproc_endregion] = STATE(2086),
    [sym_preproc_line] = STATE(2086),
    [sym_preproc_pragma] = STATE(2086),
    [sym_preproc_nullable] = STATE(2086),
    [sym_preproc_error] = STATE(2086),
    [sym_preproc_define] = STATE(2086),
    [sym_preproc_undef] = STATE(2086),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2087] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5251),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2087),
    [sym_preproc_endregion] = STATE(2087),
    [sym_preproc_line] = STATE(2087),
    [sym_preproc_pragma] = STATE(2087),
    [sym_preproc_nullable] = STATE(2087),
    [sym_preproc_error] = STATE(2087),
    [sym_preproc_define] = STATE(2087),
    [sym_preproc_undef] = STATE(2087),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2088] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5370),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2088),
    [sym_preproc_endregion] = STATE(2088),
    [sym_preproc_line] = STATE(2088),
    [sym_preproc_pragma] = STATE(2088),
    [sym_preproc_nullable] = STATE(2088),
    [sym_preproc_error] = STATE(2088),
    [sym_preproc_define] = STATE(2088),
    [sym_preproc_undef] = STATE(2088),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2089] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5528),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2089),
    [sym_preproc_endregion] = STATE(2089),
    [sym_preproc_line] = STATE(2089),
    [sym_preproc_pragma] = STATE(2089),
    [sym_preproc_nullable] = STATE(2089),
    [sym_preproc_error] = STATE(2089),
    [sym_preproc_define] = STATE(2089),
    [sym_preproc_undef] = STATE(2089),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2090] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5094),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2090),
    [sym_preproc_endregion] = STATE(2090),
    [sym_preproc_line] = STATE(2090),
    [sym_preproc_pragma] = STATE(2090),
    [sym_preproc_nullable] = STATE(2090),
    [sym_preproc_error] = STATE(2090),
    [sym_preproc_define] = STATE(2090),
    [sym_preproc_undef] = STATE(2090),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2091] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2091),
    [sym_preproc_endregion] = STATE(2091),
    [sym_preproc_line] = STATE(2091),
    [sym_preproc_pragma] = STATE(2091),
    [sym_preproc_nullable] = STATE(2091),
    [sym_preproc_error] = STATE(2091),
    [sym_preproc_define] = STATE(2091),
    [sym_preproc_undef] = STATE(2091),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2092] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5093),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2092),
    [sym_preproc_endregion] = STATE(2092),
    [sym_preproc_line] = STATE(2092),
    [sym_preproc_pragma] = STATE(2092),
    [sym_preproc_nullable] = STATE(2092),
    [sym_preproc_error] = STATE(2092),
    [sym_preproc_define] = STATE(2092),
    [sym_preproc_undef] = STATE(2092),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2093] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5252),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2093),
    [sym_preproc_endregion] = STATE(2093),
    [sym_preproc_line] = STATE(2093),
    [sym_preproc_pragma] = STATE(2093),
    [sym_preproc_nullable] = STATE(2093),
    [sym_preproc_error] = STATE(2093),
    [sym_preproc_define] = STATE(2093),
    [sym_preproc_undef] = STATE(2093),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2094] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6911),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2952),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6993),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3801),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7435),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9220),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2094),
    [sym_preproc_endregion] = STATE(2094),
    [sym_preproc_line] = STATE(2094),
    [sym_preproc_pragma] = STATE(2094),
    [sym_preproc_nullable] = STATE(2094),
    [sym_preproc_error] = STATE(2094),
    [sym_preproc_define] = STATE(2094),
    [sym_preproc_undef] = STATE(2094),
    [aux_sym_class_declaration_repeat1] = STATE(3861),
    [aux_sym_lambda_expression_repeat1] = STATE(4250),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_ref] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1857),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2175),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2177),
    [anon_sym_DOT_DOT] = ACTIONS(2179),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2095] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2095),
    [sym_preproc_endregion] = STATE(2095),
    [sym_preproc_line] = STATE(2095),
    [sym_preproc_pragma] = STATE(2095),
    [sym_preproc_nullable] = STATE(2095),
    [sym_preproc_error] = STATE(2095),
    [sym_preproc_define] = STATE(2095),
    [sym_preproc_undef] = STATE(2095),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2096] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5092),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2096),
    [sym_preproc_endregion] = STATE(2096),
    [sym_preproc_line] = STATE(2096),
    [sym_preproc_pragma] = STATE(2096),
    [sym_preproc_nullable] = STATE(2096),
    [sym_preproc_error] = STATE(2096),
    [sym_preproc_define] = STATE(2096),
    [sym_preproc_undef] = STATE(2096),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2097] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5755),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2097),
    [sym_preproc_endregion] = STATE(2097),
    [sym_preproc_line] = STATE(2097),
    [sym_preproc_pragma] = STATE(2097),
    [sym_preproc_nullable] = STATE(2097),
    [sym_preproc_error] = STATE(2097),
    [sym_preproc_define] = STATE(2097),
    [sym_preproc_undef] = STATE(2097),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2098] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5044),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2098),
    [sym_preproc_endregion] = STATE(2098),
    [sym_preproc_line] = STATE(2098),
    [sym_preproc_pragma] = STATE(2098),
    [sym_preproc_nullable] = STATE(2098),
    [sym_preproc_error] = STATE(2098),
    [sym_preproc_define] = STATE(2098),
    [sym_preproc_undef] = STATE(2098),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2099] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5919),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2099),
    [sym_preproc_endregion] = STATE(2099),
    [sym_preproc_line] = STATE(2099),
    [sym_preproc_pragma] = STATE(2099),
    [sym_preproc_nullable] = STATE(2099),
    [sym_preproc_error] = STATE(2099),
    [sym_preproc_define] = STATE(2099),
    [sym_preproc_undef] = STATE(2099),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2100] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6320),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2100),
    [sym_preproc_endregion] = STATE(2100),
    [sym_preproc_line] = STATE(2100),
    [sym_preproc_pragma] = STATE(2100),
    [sym_preproc_nullable] = STATE(2100),
    [sym_preproc_error] = STATE(2100),
    [sym_preproc_define] = STATE(2100),
    [sym_preproc_undef] = STATE(2100),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2101] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6367),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2101),
    [sym_preproc_endregion] = STATE(2101),
    [sym_preproc_line] = STATE(2101),
    [sym_preproc_pragma] = STATE(2101),
    [sym_preproc_nullable] = STATE(2101),
    [sym_preproc_error] = STATE(2101),
    [sym_preproc_define] = STATE(2101),
    [sym_preproc_undef] = STATE(2101),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2102] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5088),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2102),
    [sym_preproc_endregion] = STATE(2102),
    [sym_preproc_line] = STATE(2102),
    [sym_preproc_pragma] = STATE(2102),
    [sym_preproc_nullable] = STATE(2102),
    [sym_preproc_error] = STATE(2102),
    [sym_preproc_define] = STATE(2102),
    [sym_preproc_undef] = STATE(2102),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2103] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5087),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2103),
    [sym_preproc_endregion] = STATE(2103),
    [sym_preproc_line] = STATE(2103),
    [sym_preproc_pragma] = STATE(2103),
    [sym_preproc_nullable] = STATE(2103),
    [sym_preproc_error] = STATE(2103),
    [sym_preproc_define] = STATE(2103),
    [sym_preproc_undef] = STATE(2103),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2104] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6597),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2104),
    [sym_preproc_endregion] = STATE(2104),
    [sym_preproc_line] = STATE(2104),
    [sym_preproc_pragma] = STATE(2104),
    [sym_preproc_nullable] = STATE(2104),
    [sym_preproc_error] = STATE(2104),
    [sym_preproc_define] = STATE(2104),
    [sym_preproc_undef] = STATE(2104),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2105] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5086),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2105),
    [sym_preproc_endregion] = STATE(2105),
    [sym_preproc_line] = STATE(2105),
    [sym_preproc_pragma] = STATE(2105),
    [sym_preproc_nullable] = STATE(2105),
    [sym_preproc_error] = STATE(2105),
    [sym_preproc_define] = STATE(2105),
    [sym_preproc_undef] = STATE(2105),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2106] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5085),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2106),
    [sym_preproc_endregion] = STATE(2106),
    [sym_preproc_line] = STATE(2106),
    [sym_preproc_pragma] = STATE(2106),
    [sym_preproc_nullable] = STATE(2106),
    [sym_preproc_error] = STATE(2106),
    [sym_preproc_define] = STATE(2106),
    [sym_preproc_undef] = STATE(2106),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2107] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6903),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2989),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7058),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5932),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4332),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7418),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9324),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2107),
    [sym_preproc_endregion] = STATE(2107),
    [sym_preproc_line] = STATE(2107),
    [sym_preproc_pragma] = STATE(2107),
    [sym_preproc_nullable] = STATE(2107),
    [sym_preproc_error] = STATE(2107),
    [sym_preproc_define] = STATE(2107),
    [sym_preproc_undef] = STATE(2107),
    [aux_sym_class_declaration_repeat1] = STATE(3826),
    [aux_sym_lambda_expression_repeat1] = STATE(4096),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_ref] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1875),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_PLUS_PLUS] = ACTIONS(1879),
    [anon_sym_DASH_DASH] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_CARET] = ACTIONS(1879),
    [anon_sym_AMP] = ACTIONS(1879),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1883),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1887),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2108] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5125),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2108),
    [sym_preproc_endregion] = STATE(2108),
    [sym_preproc_line] = STATE(2108),
    [sym_preproc_pragma] = STATE(2108),
    [sym_preproc_nullable] = STATE(2108),
    [sym_preproc_error] = STATE(2108),
    [sym_preproc_define] = STATE(2108),
    [sym_preproc_undef] = STATE(2108),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2109] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6915),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7008),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4813),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(3787),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7440),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9580),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2109),
    [sym_preproc_endregion] = STATE(2109),
    [sym_preproc_line] = STATE(2109),
    [sym_preproc_pragma] = STATE(2109),
    [sym_preproc_nullable] = STATE(2109),
    [sym_preproc_error] = STATE(2109),
    [sym_preproc_define] = STATE(2109),
    [sym_preproc_undef] = STATE(2109),
    [aux_sym_class_declaration_repeat1] = STATE(3813),
    [aux_sym_lambda_expression_repeat1] = STATE(4259),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_ref] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1247),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_DASH_DASH] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1271),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2110] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5079),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2110),
    [sym_preproc_endregion] = STATE(2110),
    [sym_preproc_line] = STATE(2110),
    [sym_preproc_pragma] = STATE(2110),
    [sym_preproc_nullable] = STATE(2110),
    [sym_preproc_error] = STATE(2110),
    [sym_preproc_define] = STATE(2110),
    [sym_preproc_undef] = STATE(2110),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2111] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2111),
    [sym_preproc_endregion] = STATE(2111),
    [sym_preproc_line] = STATE(2111),
    [sym_preproc_pragma] = STATE(2111),
    [sym_preproc_nullable] = STATE(2111),
    [sym_preproc_error] = STATE(2111),
    [sym_preproc_define] = STATE(2111),
    [sym_preproc_undef] = STATE(2111),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2112] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6598),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2112),
    [sym_preproc_endregion] = STATE(2112),
    [sym_preproc_line] = STATE(2112),
    [sym_preproc_pragma] = STATE(2112),
    [sym_preproc_nullable] = STATE(2112),
    [sym_preproc_error] = STATE(2112),
    [sym_preproc_define] = STATE(2112),
    [sym_preproc_undef] = STATE(2112),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2113] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5084),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2113),
    [sym_preproc_endregion] = STATE(2113),
    [sym_preproc_line] = STATE(2113),
    [sym_preproc_pragma] = STATE(2113),
    [sym_preproc_nullable] = STATE(2113),
    [sym_preproc_error] = STATE(2113),
    [sym_preproc_define] = STATE(2113),
    [sym_preproc_undef] = STATE(2113),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2114] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6619),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2114),
    [sym_preproc_endregion] = STATE(2114),
    [sym_preproc_line] = STATE(2114),
    [sym_preproc_pragma] = STATE(2114),
    [sym_preproc_nullable] = STATE(2114),
    [sym_preproc_error] = STATE(2114),
    [sym_preproc_define] = STATE(2114),
    [sym_preproc_undef] = STATE(2114),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2115] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6171),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2115),
    [sym_preproc_endregion] = STATE(2115),
    [sym_preproc_line] = STATE(2115),
    [sym_preproc_pragma] = STATE(2115),
    [sym_preproc_nullable] = STATE(2115),
    [sym_preproc_error] = STATE(2115),
    [sym_preproc_define] = STATE(2115),
    [sym_preproc_undef] = STATE(2115),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2116] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6505),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2116),
    [sym_preproc_endregion] = STATE(2116),
    [sym_preproc_line] = STATE(2116),
    [sym_preproc_pragma] = STATE(2116),
    [sym_preproc_nullable] = STATE(2116),
    [sym_preproc_error] = STATE(2116),
    [sym_preproc_define] = STATE(2116),
    [sym_preproc_undef] = STATE(2116),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2117] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5689),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2117),
    [sym_preproc_endregion] = STATE(2117),
    [sym_preproc_line] = STATE(2117),
    [sym_preproc_pragma] = STATE(2117),
    [sym_preproc_nullable] = STATE(2117),
    [sym_preproc_error] = STATE(2117),
    [sym_preproc_define] = STATE(2117),
    [sym_preproc_undef] = STATE(2117),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2118] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6178),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2118),
    [sym_preproc_endregion] = STATE(2118),
    [sym_preproc_line] = STATE(2118),
    [sym_preproc_pragma] = STATE(2118),
    [sym_preproc_nullable] = STATE(2118),
    [sym_preproc_error] = STATE(2118),
    [sym_preproc_define] = STATE(2118),
    [sym_preproc_undef] = STATE(2118),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2119] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6504),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2119),
    [sym_preproc_endregion] = STATE(2119),
    [sym_preproc_line] = STATE(2119),
    [sym_preproc_pragma] = STATE(2119),
    [sym_preproc_nullable] = STATE(2119),
    [sym_preproc_error] = STATE(2119),
    [sym_preproc_define] = STATE(2119),
    [sym_preproc_undef] = STATE(2119),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2120] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5159),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2120),
    [sym_preproc_endregion] = STATE(2120),
    [sym_preproc_line] = STATE(2120),
    [sym_preproc_pragma] = STATE(2120),
    [sym_preproc_nullable] = STATE(2120),
    [sym_preproc_error] = STATE(2120),
    [sym_preproc_define] = STATE(2120),
    [sym_preproc_undef] = STATE(2120),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2121] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6179),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2121),
    [sym_preproc_endregion] = STATE(2121),
    [sym_preproc_line] = STATE(2121),
    [sym_preproc_pragma] = STATE(2121),
    [sym_preproc_nullable] = STATE(2121),
    [sym_preproc_error] = STATE(2121),
    [sym_preproc_define] = STATE(2121),
    [sym_preproc_undef] = STATE(2121),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2122] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5164),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2122),
    [sym_preproc_endregion] = STATE(2122),
    [sym_preproc_line] = STATE(2122),
    [sym_preproc_pragma] = STATE(2122),
    [sym_preproc_nullable] = STATE(2122),
    [sym_preproc_error] = STATE(2122),
    [sym_preproc_define] = STATE(2122),
    [sym_preproc_undef] = STATE(2122),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2123] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5174),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2123),
    [sym_preproc_endregion] = STATE(2123),
    [sym_preproc_line] = STATE(2123),
    [sym_preproc_pragma] = STATE(2123),
    [sym_preproc_nullable] = STATE(2123),
    [sym_preproc_error] = STATE(2123),
    [sym_preproc_define] = STATE(2123),
    [sym_preproc_undef] = STATE(2123),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2124] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5176),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2124),
    [sym_preproc_endregion] = STATE(2124),
    [sym_preproc_line] = STATE(2124),
    [sym_preproc_pragma] = STATE(2124),
    [sym_preproc_nullable] = STATE(2124),
    [sym_preproc_error] = STATE(2124),
    [sym_preproc_define] = STATE(2124),
    [sym_preproc_undef] = STATE(2124),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2125] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5179),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2125),
    [sym_preproc_endregion] = STATE(2125),
    [sym_preproc_line] = STATE(2125),
    [sym_preproc_pragma] = STATE(2125),
    [sym_preproc_nullable] = STATE(2125),
    [sym_preproc_error] = STATE(2125),
    [sym_preproc_define] = STATE(2125),
    [sym_preproc_undef] = STATE(2125),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2126] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5183),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2126),
    [sym_preproc_endregion] = STATE(2126),
    [sym_preproc_line] = STATE(2126),
    [sym_preproc_pragma] = STATE(2126),
    [sym_preproc_nullable] = STATE(2126),
    [sym_preproc_error] = STATE(2126),
    [sym_preproc_define] = STATE(2126),
    [sym_preproc_undef] = STATE(2126),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2127] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5184),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2127),
    [sym_preproc_endregion] = STATE(2127),
    [sym_preproc_line] = STATE(2127),
    [sym_preproc_pragma] = STATE(2127),
    [sym_preproc_nullable] = STATE(2127),
    [sym_preproc_error] = STATE(2127),
    [sym_preproc_define] = STATE(2127),
    [sym_preproc_undef] = STATE(2127),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2128] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5185),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2128),
    [sym_preproc_endregion] = STATE(2128),
    [sym_preproc_line] = STATE(2128),
    [sym_preproc_pragma] = STATE(2128),
    [sym_preproc_nullable] = STATE(2128),
    [sym_preproc_error] = STATE(2128),
    [sym_preproc_define] = STATE(2128),
    [sym_preproc_undef] = STATE(2128),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2129] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6190),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2129),
    [sym_preproc_endregion] = STATE(2129),
    [sym_preproc_line] = STATE(2129),
    [sym_preproc_pragma] = STATE(2129),
    [sym_preproc_nullable] = STATE(2129),
    [sym_preproc_error] = STATE(2129),
    [sym_preproc_define] = STATE(2129),
    [sym_preproc_undef] = STATE(2129),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2130] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5187),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2130),
    [sym_preproc_endregion] = STATE(2130),
    [sym_preproc_line] = STATE(2130),
    [sym_preproc_pragma] = STATE(2130),
    [sym_preproc_nullable] = STATE(2130),
    [sym_preproc_error] = STATE(2130),
    [sym_preproc_define] = STATE(2130),
    [sym_preproc_undef] = STATE(2130),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2131] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5188),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2131),
    [sym_preproc_endregion] = STATE(2131),
    [sym_preproc_line] = STATE(2131),
    [sym_preproc_pragma] = STATE(2131),
    [sym_preproc_nullable] = STATE(2131),
    [sym_preproc_error] = STATE(2131),
    [sym_preproc_define] = STATE(2131),
    [sym_preproc_undef] = STATE(2131),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2132] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5209),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2132),
    [sym_preproc_endregion] = STATE(2132),
    [sym_preproc_line] = STATE(2132),
    [sym_preproc_pragma] = STATE(2132),
    [sym_preproc_nullable] = STATE(2132),
    [sym_preproc_error] = STATE(2132),
    [sym_preproc_define] = STATE(2132),
    [sym_preproc_undef] = STATE(2132),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2133] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5631),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2133),
    [sym_preproc_endregion] = STATE(2133),
    [sym_preproc_line] = STATE(2133),
    [sym_preproc_pragma] = STATE(2133),
    [sym_preproc_nullable] = STATE(2133),
    [sym_preproc_error] = STATE(2133),
    [sym_preproc_define] = STATE(2133),
    [sym_preproc_undef] = STATE(2133),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2134] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5605),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2134),
    [sym_preproc_endregion] = STATE(2134),
    [sym_preproc_line] = STATE(2134),
    [sym_preproc_pragma] = STATE(2134),
    [sym_preproc_nullable] = STATE(2134),
    [sym_preproc_error] = STATE(2134),
    [sym_preproc_define] = STATE(2134),
    [sym_preproc_undef] = STATE(2134),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2135] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6939),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2887),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7154),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5302),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4042),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7405),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9065),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2135),
    [sym_preproc_endregion] = STATE(2135),
    [sym_preproc_line] = STATE(2135),
    [sym_preproc_pragma] = STATE(2135),
    [sym_preproc_nullable] = STATE(2135),
    [sym_preproc_error] = STATE(2135),
    [sym_preproc_define] = STATE(2135),
    [sym_preproc_undef] = STATE(2135),
    [aux_sym_class_declaration_repeat1] = STATE(3860),
    [aux_sym_lambda_expression_repeat1] = STATE(4156),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_ref] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1707),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1757),
    [anon_sym_TILDE] = ACTIONS(1757),
    [anon_sym_PLUS_PLUS] = ACTIONS(1757),
    [anon_sym_DASH_DASH] = ACTIONS(1757),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_AMP] = ACTIONS(1757),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1761),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1765),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2136] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7034),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5066),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3838),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7436),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9104),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2136),
    [sym_preproc_endregion] = STATE(2136),
    [sym_preproc_line] = STATE(2136),
    [sym_preproc_pragma] = STATE(2136),
    [sym_preproc_nullable] = STATE(2136),
    [sym_preproc_error] = STATE(2136),
    [sym_preproc_define] = STATE(2136),
    [sym_preproc_undef] = STATE(2136),
    [aux_sym_class_declaration_repeat1] = STATE(3809),
    [aux_sym_lambda_expression_repeat1] = STATE(4261),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2261),
    [anon_sym_ref] = ACTIONS(2263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2267),
    [anon_sym_TILDE] = ACTIONS(2267),
    [anon_sym_PLUS_PLUS] = ACTIONS(2267),
    [anon_sym_DASH_DASH] = ACTIONS(2267),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2265),
    [anon_sym_DASH] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_AMP] = ACTIONS(2267),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2269),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2271),
    [anon_sym_DOT_DOT] = ACTIONS(2273),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2137] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5541),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2137),
    [sym_preproc_endregion] = STATE(2137),
    [sym_preproc_line] = STATE(2137),
    [sym_preproc_pragma] = STATE(2137),
    [sym_preproc_nullable] = STATE(2137),
    [sym_preproc_error] = STATE(2137),
    [sym_preproc_define] = STATE(2137),
    [sym_preproc_undef] = STATE(2137),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2138] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5717),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2138),
    [sym_preproc_endregion] = STATE(2138),
    [sym_preproc_line] = STATE(2138),
    [sym_preproc_pragma] = STATE(2138),
    [sym_preproc_nullable] = STATE(2138),
    [sym_preproc_error] = STATE(2138),
    [sym_preproc_define] = STATE(2138),
    [sym_preproc_undef] = STATE(2138),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2139] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5542),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2139),
    [sym_preproc_endregion] = STATE(2139),
    [sym_preproc_line] = STATE(2139),
    [sym_preproc_pragma] = STATE(2139),
    [sym_preproc_nullable] = STATE(2139),
    [sym_preproc_error] = STATE(2139),
    [sym_preproc_define] = STATE(2139),
    [sym_preproc_undef] = STATE(2139),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2140] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6198),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2140),
    [sym_preproc_endregion] = STATE(2140),
    [sym_preproc_line] = STATE(2140),
    [sym_preproc_pragma] = STATE(2140),
    [sym_preproc_nullable] = STATE(2140),
    [sym_preproc_error] = STATE(2140),
    [sym_preproc_define] = STATE(2140),
    [sym_preproc_undef] = STATE(2140),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2141] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5543),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2141),
    [sym_preproc_endregion] = STATE(2141),
    [sym_preproc_line] = STATE(2141),
    [sym_preproc_pragma] = STATE(2141),
    [sym_preproc_nullable] = STATE(2141),
    [sym_preproc_error] = STATE(2141),
    [sym_preproc_define] = STATE(2141),
    [sym_preproc_undef] = STATE(2141),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2142] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5081),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2142),
    [sym_preproc_endregion] = STATE(2142),
    [sym_preproc_line] = STATE(2142),
    [sym_preproc_pragma] = STATE(2142),
    [sym_preproc_nullable] = STATE(2142),
    [sym_preproc_error] = STATE(2142),
    [sym_preproc_define] = STATE(2142),
    [sym_preproc_undef] = STATE(2142),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2143] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3566),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2143),
    [sym_preproc_endregion] = STATE(2143),
    [sym_preproc_line] = STATE(2143),
    [sym_preproc_pragma] = STATE(2143),
    [sym_preproc_nullable] = STATE(2143),
    [sym_preproc_error] = STATE(2143),
    [sym_preproc_define] = STATE(2143),
    [sym_preproc_undef] = STATE(2143),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2144] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6502),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2144),
    [sym_preproc_endregion] = STATE(2144),
    [sym_preproc_line] = STATE(2144),
    [sym_preproc_pragma] = STATE(2144),
    [sym_preproc_nullable] = STATE(2144),
    [sym_preproc_error] = STATE(2144),
    [sym_preproc_define] = STATE(2144),
    [sym_preproc_undef] = STATE(2144),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2145] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2145),
    [sym_preproc_endregion] = STATE(2145),
    [sym_preproc_line] = STATE(2145),
    [sym_preproc_pragma] = STATE(2145),
    [sym_preproc_nullable] = STATE(2145),
    [sym_preproc_error] = STATE(2145),
    [sym_preproc_define] = STATE(2145),
    [sym_preproc_undef] = STATE(2145),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2146] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5759),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2146),
    [sym_preproc_endregion] = STATE(2146),
    [sym_preproc_line] = STATE(2146),
    [sym_preproc_pragma] = STATE(2146),
    [sym_preproc_nullable] = STATE(2146),
    [sym_preproc_error] = STATE(2146),
    [sym_preproc_define] = STATE(2146),
    [sym_preproc_undef] = STATE(2146),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2147] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2147),
    [sym_preproc_endregion] = STATE(2147),
    [sym_preproc_line] = STATE(2147),
    [sym_preproc_pragma] = STATE(2147),
    [sym_preproc_nullable] = STATE(2147),
    [sym_preproc_error] = STATE(2147),
    [sym_preproc_define] = STATE(2147),
    [sym_preproc_undef] = STATE(2147),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2148] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5544),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2148),
    [sym_preproc_endregion] = STATE(2148),
    [sym_preproc_line] = STATE(2148),
    [sym_preproc_pragma] = STATE(2148),
    [sym_preproc_nullable] = STATE(2148),
    [sym_preproc_error] = STATE(2148),
    [sym_preproc_define] = STATE(2148),
    [sym_preproc_undef] = STATE(2148),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2149] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6917),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2955),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7110),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3584),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4440),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7431),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9245),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2149),
    [sym_preproc_endregion] = STATE(2149),
    [sym_preproc_line] = STATE(2149),
    [sym_preproc_pragma] = STATE(2149),
    [sym_preproc_nullable] = STATE(2149),
    [sym_preproc_error] = STATE(2149),
    [sym_preproc_define] = STATE(2149),
    [sym_preproc_undef] = STATE(2149),
    [aux_sym_class_declaration_repeat1] = STATE(3822),
    [aux_sym_lambda_expression_repeat1] = STATE(4122),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2203),
    [anon_sym_ref] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2207),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2211),
    [anon_sym_TILDE] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2209),
    [anon_sym_DASH] = ACTIONS(2209),
    [anon_sym_STAR] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2211),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2217),
    [anon_sym_DOT_DOT] = ACTIONS(2219),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2150] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4336),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2150),
    [sym_preproc_endregion] = STATE(2150),
    [sym_preproc_line] = STATE(2150),
    [sym_preproc_pragma] = STATE(2150),
    [sym_preproc_nullable] = STATE(2150),
    [sym_preproc_error] = STATE(2150),
    [sym_preproc_define] = STATE(2150),
    [sym_preproc_undef] = STATE(2150),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2151] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6920),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2977),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7081),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6398),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4480),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7434),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(8998),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2151),
    [sym_preproc_endregion] = STATE(2151),
    [sym_preproc_line] = STATE(2151),
    [sym_preproc_pragma] = STATE(2151),
    [sym_preproc_nullable] = STATE(2151),
    [sym_preproc_error] = STATE(2151),
    [sym_preproc_define] = STATE(2151),
    [sym_preproc_undef] = STATE(2151),
    [aux_sym_class_declaration_repeat1] = STATE(3868),
    [aux_sym_lambda_expression_repeat1] = STATE(4327),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2181),
    [anon_sym_ref] = ACTIONS(2183),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2185),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [anon_sym_PLUS_PLUS] = ACTIONS(2189),
    [anon_sym_DASH_DASH] = ACTIONS(2189),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2191),
    [anon_sym_CARET] = ACTIONS(2189),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2193),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2195),
    [anon_sym_DOT_DOT] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2152] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7029),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6715),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3881),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9902),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2152),
    [sym_preproc_endregion] = STATE(2152),
    [sym_preproc_line] = STATE(2152),
    [sym_preproc_pragma] = STATE(2152),
    [sym_preproc_nullable] = STATE(2152),
    [sym_preproc_error] = STATE(2152),
    [sym_preproc_define] = STATE(2152),
    [sym_preproc_undef] = STATE(2152),
    [aux_sym_class_declaration_repeat1] = STATE(3823),
    [aux_sym_lambda_expression_repeat1] = STATE(4255),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_ref] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1631),
    [anon_sym_DASH_DASH] = ACTIONS(1631),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1631),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1633),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_DOT_DOT] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2153] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3884),
    [sym__name] = STATE(6926),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2861),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2843),
    [sym_type] = STATE(7022),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5211),
    [sym_non_lvalue_expression] = STATE(5658),
    [sym_lvalue_expression] = STATE(4248),
    [sym__expression_statement_expression] = STATE(5648),
    [sym_assignment_expression] = STATE(5659),
    [sym_binary_expression] = STATE(5648),
    [sym_postfix_unary_expression] = STATE(5659),
    [sym_prefix_unary_expression] = STATE(5659),
    [sym__pointer_indirection_expression] = STATE(3888),
    [sym_query_expression] = STATE(5648),
    [sym_from_clause] = STATE(7409),
    [sym_conditional_expression] = STATE(5648),
    [sym_conditional_access_expression] = STATE(5648),
    [sym_as_expression] = STATE(5648),
    [sym_is_expression] = STATE(5648),
    [sym_is_pattern_expression] = STATE(5648),
    [sym_cast_expression] = STATE(5648),
    [sym_checked_expression] = STATE(5648),
    [sym_invocation_expression] = STATE(5659),
    [sym_switch_expression] = STATE(5648),
    [sym_await_expression] = STATE(5659),
    [sym_throw_expression] = STATE(5648),
    [sym_element_access_expression] = STATE(3888),
    [sym_interpolated_string_expression] = STATE(5648),
    [sym_member_access_expression] = STATE(3888),
    [sym_object_creation_expression] = STATE(5659),
    [sym_parenthesized_expression] = STATE(5659),
    [sym__parenthesized_lvalue_expression] = STATE(3888),
    [sym_lambda_expression] = STATE(5648),
    [sym__lambda_parameters] = STATE(9660),
    [sym_array_creation_expression] = STATE(5648),
    [sym_anonymous_method_expression] = STATE(5648),
    [sym_anonymous_object_creation_expression] = STATE(5648),
    [sym_implicit_array_creation_expression] = STATE(5648),
    [sym_implicit_object_creation_expression] = STATE(5648),
    [sym_implicit_stackalloc_expression] = STATE(5648),
    [sym_initializer_expression] = STATE(5648),
    [sym_default_expression] = STATE(5648),
    [sym_with_expression] = STATE(5648),
    [sym_sizeof_expression] = STATE(5648),
    [sym_typeof_expression] = STATE(5648),
    [sym_makeref_expression] = STATE(5648),
    [sym_ref_expression] = STATE(5648),
    [sym_reftype_expression] = STATE(5648),
    [sym_refvalue_expression] = STATE(5648),
    [sym_stackalloc_expression] = STATE(5648),
    [sym_range_expression] = STATE(5648),
    [sym_tuple_expression] = STATE(3888),
    [sym_literal] = STATE(5648),
    [sym_character_literal] = STATE(5653),
    [sym_string_literal] = STATE(5653),
    [sym_raw_string_literal] = STATE(5653),
    [sym_boolean_literal] = STATE(5653),
    [sym_identifier] = STATE(2811),
    [sym__reserved_identifier] = STATE(2797),
    [sym_preproc_if_in_expression] = STATE(5648),
    [sym_preproc_region] = STATE(2153),
    [sym_preproc_endregion] = STATE(2153),
    [sym_preproc_line] = STATE(2153),
    [sym_preproc_pragma] = STATE(2153),
    [sym_preproc_nullable] = STATE(2153),
    [sym_preproc_error] = STATE(2153),
    [sym_preproc_define] = STATE(2153),
    [sym_preproc_undef] = STATE(2153),
    [aux_sym_class_declaration_repeat1] = STATE(3867),
    [aux_sym_lambda_expression_repeat1] = STATE(4296),
    [sym__identifier_token] = ACTIONS(1399),
    [anon_sym_alias] = ACTIONS(1401),
    [anon_sym_global] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_ref] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_delegate] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(1401),
    [anon_sym_new] = ACTIONS(1479),
    [anon_sym_where] = ACTIONS(1401),
    [anon_sym_notnull] = ACTIONS(1401),
    [anon_sym_unmanaged] = ACTIONS(1401),
    [anon_sym_checked] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1727),
    [anon_sym_PLUS_PLUS] = ACTIONS(1727),
    [anon_sym_DASH_DASH] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [anon_sym_STAR] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_this] = ACTIONS(1425),
    [anon_sym_scoped] = ACTIONS(1427),
    [anon_sym_base] = ACTIONS(1429),
    [anon_sym_var] = ACTIONS(1431),
    [sym_predefined_type] = ACTIONS(1433),
    [anon_sym_unchecked] = ACTIONS(1415),
    [anon_sym_yield] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_throw] = ACTIONS(1729),
    [anon_sym_when] = ACTIONS(1401),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1733),
    [anon_sym_from] = ACTIONS(1443),
    [anon_sym_into] = ACTIONS(1401),
    [anon_sym_join] = ACTIONS(1401),
    [anon_sym_on] = ACTIONS(1401),
    [anon_sym_equals] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_orderby] = ACTIONS(1401),
    [anon_sym_ascending] = ACTIONS(1401),
    [anon_sym_descending] = ACTIONS(1401),
    [anon_sym_group] = ACTIONS(1401),
    [anon_sym_by] = ACTIONS(1401),
    [anon_sym_select] = ACTIONS(1401),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_stackalloc] = ACTIONS(1447),
    [anon_sym_sizeof] = ACTIONS(1449),
    [anon_sym_typeof] = ACTIONS(1451),
    [anon_sym___makeref] = ACTIONS(1453),
    [anon_sym___reftype] = ACTIONS(1455),
    [anon_sym___refvalue] = ACTIONS(1457),
    [sym_null_literal] = ACTIONS(1459),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [sym_real_literal] = ACTIONS(1463),
    [sym_verbatim_string_literal] = ACTIONS(1463),
    [aux_sym_preproc_if_token1] = ACTIONS(1465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1467),
    [sym_interpolation_verbatim_start] = ACTIONS(1469),
    [sym_interpolation_raw_start] = ACTIONS(1471),
    [sym_raw_string_start] = ACTIONS(1473),
  },
  [2154] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3024),
    [sym__name] = STATE(6942),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2943),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7017),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6200),
    [sym_non_lvalue_expression] = STATE(3721),
    [sym_lvalue_expression] = STATE(4362),
    [sym__expression_statement_expression] = STATE(3658),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3658),
    [sym_postfix_unary_expression] = STATE(3663),
    [sym_prefix_unary_expression] = STATE(3663),
    [sym__pointer_indirection_expression] = STATE(2992),
    [sym_query_expression] = STATE(3658),
    [sym_from_clause] = STATE(7423),
    [sym_conditional_expression] = STATE(3658),
    [sym_conditional_access_expression] = STATE(3658),
    [sym_as_expression] = STATE(3658),
    [sym_is_expression] = STATE(3658),
    [sym_is_pattern_expression] = STATE(3658),
    [sym_cast_expression] = STATE(3658),
    [sym_checked_expression] = STATE(3658),
    [sym_invocation_expression] = STATE(3663),
    [sym_switch_expression] = STATE(3658),
    [sym_await_expression] = STATE(3663),
    [sym_throw_expression] = STATE(3658),
    [sym_element_access_expression] = STATE(2992),
    [sym_interpolated_string_expression] = STATE(3658),
    [sym_member_access_expression] = STATE(2992),
    [sym_object_creation_expression] = STATE(3663),
    [sym_parenthesized_expression] = STATE(3663),
    [sym__parenthesized_lvalue_expression] = STATE(2992),
    [sym_lambda_expression] = STATE(3658),
    [sym__lambda_parameters] = STATE(9624),
    [sym_array_creation_expression] = STATE(3658),
    [sym_anonymous_method_expression] = STATE(3658),
    [sym_anonymous_object_creation_expression] = STATE(3658),
    [sym_implicit_array_creation_expression] = STATE(3658),
    [sym_implicit_object_creation_expression] = STATE(3658),
    [sym_implicit_stackalloc_expression] = STATE(3658),
    [sym_initializer_expression] = STATE(3658),
    [sym_default_expression] = STATE(3658),
    [sym_with_expression] = STATE(3658),
    [sym_sizeof_expression] = STATE(3658),
    [sym_typeof_expression] = STATE(3658),
    [sym_makeref_expression] = STATE(3658),
    [sym_ref_expression] = STATE(3658),
    [sym_reftype_expression] = STATE(3658),
    [sym_refvalue_expression] = STATE(3658),
    [sym_stackalloc_expression] = STATE(3658),
    [sym_range_expression] = STATE(3658),
    [sym_tuple_expression] = STATE(2992),
    [sym_literal] = STATE(3658),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3658),
    [sym_preproc_region] = STATE(2154),
    [sym_preproc_endregion] = STATE(2154),
    [sym_preproc_line] = STATE(2154),
    [sym_preproc_pragma] = STATE(2154),
    [sym_preproc_nullable] = STATE(2154),
    [sym_preproc_error] = STATE(2154),
    [sym_preproc_define] = STATE(2154),
    [sym_preproc_undef] = STATE(2154),
    [aux_sym_class_declaration_repeat1] = STATE(3864),
    [aux_sym_lambda_expression_repeat1] = STATE(4264),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_ref] = ACTIONS(2111),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_delegate] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2117),
    [anon_sym_DASH_DASH] = ACTIONS(2117),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(2115),
    [anon_sym_DASH] = ACTIONS(2115),
    [anon_sym_STAR] = ACTIONS(2119),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2117),
    [anon_sym_this] = ACTIONS(1259),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1261),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1249),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2123),
    [anon_sym_DOT_DOT] = ACTIONS(2125),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(1275),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(1281),
    [anon_sym___reftype] = ACTIONS(1283),
    [anon_sym___refvalue] = ACTIONS(1285),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1293),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2155] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5972),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2155),
    [sym_preproc_endregion] = STATE(2155),
    [sym_preproc_line] = STATE(2155),
    [sym_preproc_pragma] = STATE(2155),
    [sym_preproc_nullable] = STATE(2155),
    [sym_preproc_error] = STATE(2155),
    [sym_preproc_define] = STATE(2155),
    [sym_preproc_undef] = STATE(2155),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2156] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5673),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2156),
    [sym_preproc_endregion] = STATE(2156),
    [sym_preproc_line] = STATE(2156),
    [sym_preproc_pragma] = STATE(2156),
    [sym_preproc_nullable] = STATE(2156),
    [sym_preproc_error] = STATE(2156),
    [sym_preproc_define] = STATE(2156),
    [sym_preproc_undef] = STATE(2156),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2157] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5157),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2157),
    [sym_preproc_endregion] = STATE(2157),
    [sym_preproc_line] = STATE(2157),
    [sym_preproc_pragma] = STATE(2157),
    [sym_preproc_nullable] = STATE(2157),
    [sym_preproc_error] = STATE(2157),
    [sym_preproc_define] = STATE(2157),
    [sym_preproc_undef] = STATE(2157),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2158] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5589),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2158),
    [sym_preproc_endregion] = STATE(2158),
    [sym_preproc_line] = STATE(2158),
    [sym_preproc_pragma] = STATE(2158),
    [sym_preproc_nullable] = STATE(2158),
    [sym_preproc_error] = STATE(2158),
    [sym_preproc_define] = STATE(2158),
    [sym_preproc_undef] = STATE(2158),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2159] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5671),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2159),
    [sym_preproc_endregion] = STATE(2159),
    [sym_preproc_line] = STATE(2159),
    [sym_preproc_pragma] = STATE(2159),
    [sym_preproc_nullable] = STATE(2159),
    [sym_preproc_error] = STATE(2159),
    [sym_preproc_define] = STATE(2159),
    [sym_preproc_undef] = STATE(2159),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2160] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6397),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2160),
    [sym_preproc_endregion] = STATE(2160),
    [sym_preproc_line] = STATE(2160),
    [sym_preproc_pragma] = STATE(2160),
    [sym_preproc_nullable] = STATE(2160),
    [sym_preproc_error] = STATE(2160),
    [sym_preproc_define] = STATE(2160),
    [sym_preproc_undef] = STATE(2160),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2161] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6956),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3895),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9086),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2161),
    [sym_preproc_endregion] = STATE(2161),
    [sym_preproc_line] = STATE(2161),
    [sym_preproc_pragma] = STATE(2161),
    [sym_preproc_nullable] = STATE(2161),
    [sym_preproc_error] = STATE(2161),
    [sym_preproc_define] = STATE(2161),
    [sym_preproc_undef] = STATE(2161),
    [aux_sym_class_declaration_repeat1] = STATE(3865),
    [aux_sym_lambda_expression_repeat1] = STATE(4164),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1367),
    [anon_sym_ref] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_TILDE] = ACTIONS(1373),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_DASH_DASH] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1377),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1379),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2162] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6270),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6923),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6545),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4506),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9917),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2162),
    [sym_preproc_endregion] = STATE(2162),
    [sym_preproc_line] = STATE(2162),
    [sym_preproc_pragma] = STATE(2162),
    [sym_preproc_nullable] = STATE(2162),
    [sym_preproc_error] = STATE(2162),
    [sym_preproc_define] = STATE(2162),
    [sym_preproc_undef] = STATE(2162),
    [aux_sym_class_declaration_repeat1] = STATE(3835),
    [aux_sym_lambda_expression_repeat1] = STATE(4099),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(2077),
    [anon_sym_ref] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2083),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2081),
    [anon_sym_STAR] = ACTIONS(79),
    [anon_sym_CARET] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(2085),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(2087),
    [anon_sym_DOT_DOT] = ACTIONS(2089),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2163] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3953),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2163),
    [sym_preproc_endregion] = STATE(2163),
    [sym_preproc_line] = STATE(2163),
    [sym_preproc_pragma] = STATE(2163),
    [sym_preproc_nullable] = STATE(2163),
    [sym_preproc_error] = STATE(2163),
    [sym_preproc_define] = STATE(2163),
    [sym_preproc_undef] = STATE(2163),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2164] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5613),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2164),
    [sym_preproc_endregion] = STATE(2164),
    [sym_preproc_line] = STATE(2164),
    [sym_preproc_pragma] = STATE(2164),
    [sym_preproc_nullable] = STATE(2164),
    [sym_preproc_error] = STATE(2164),
    [sym_preproc_define] = STATE(2164),
    [sym_preproc_undef] = STATE(2164),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2165] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2165),
    [sym_preproc_endregion] = STATE(2165),
    [sym_preproc_line] = STATE(2165),
    [sym_preproc_pragma] = STATE(2165),
    [sym_preproc_nullable] = STATE(2165),
    [sym_preproc_error] = STATE(2165),
    [sym_preproc_define] = STATE(2165),
    [sym_preproc_undef] = STATE(2165),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2166] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5569),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2166),
    [sym_preproc_endregion] = STATE(2166),
    [sym_preproc_line] = STATE(2166),
    [sym_preproc_pragma] = STATE(2166),
    [sym_preproc_nullable] = STATE(2166),
    [sym_preproc_error] = STATE(2166),
    [sym_preproc_define] = STATE(2166),
    [sym_preproc_undef] = STATE(2166),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2167] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5546),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2167),
    [sym_preproc_endregion] = STATE(2167),
    [sym_preproc_line] = STATE(2167),
    [sym_preproc_pragma] = STATE(2167),
    [sym_preproc_nullable] = STATE(2167),
    [sym_preproc_error] = STATE(2167),
    [sym_preproc_define] = STATE(2167),
    [sym_preproc_undef] = STATE(2167),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2168] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5150),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2168),
    [sym_preproc_endregion] = STATE(2168),
    [sym_preproc_line] = STATE(2168),
    [sym_preproc_pragma] = STATE(2168),
    [sym_preproc_nullable] = STATE(2168),
    [sym_preproc_error] = STATE(2168),
    [sym_preproc_define] = STATE(2168),
    [sym_preproc_undef] = STATE(2168),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2169] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5654),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2169),
    [sym_preproc_endregion] = STATE(2169),
    [sym_preproc_line] = STATE(2169),
    [sym_preproc_pragma] = STATE(2169),
    [sym_preproc_nullable] = STATE(2169),
    [sym_preproc_error] = STATE(2169),
    [sym_preproc_define] = STATE(2169),
    [sym_preproc_undef] = STATE(2169),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2170] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5549),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2170),
    [sym_preproc_endregion] = STATE(2170),
    [sym_preproc_line] = STATE(2170),
    [sym_preproc_pragma] = STATE(2170),
    [sym_preproc_nullable] = STATE(2170),
    [sym_preproc_error] = STATE(2170),
    [sym_preproc_define] = STATE(2170),
    [sym_preproc_undef] = STATE(2170),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2171] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5643),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2171),
    [sym_preproc_endregion] = STATE(2171),
    [sym_preproc_line] = STATE(2171),
    [sym_preproc_pragma] = STATE(2171),
    [sym_preproc_nullable] = STATE(2171),
    [sym_preproc_error] = STATE(2171),
    [sym_preproc_define] = STATE(2171),
    [sym_preproc_undef] = STATE(2171),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2172] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5550),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2172),
    [sym_preproc_endregion] = STATE(2172),
    [sym_preproc_line] = STATE(2172),
    [sym_preproc_pragma] = STATE(2172),
    [sym_preproc_nullable] = STATE(2172),
    [sym_preproc_error] = STATE(2172),
    [sym_preproc_define] = STATE(2172),
    [sym_preproc_undef] = STATE(2172),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2173] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5137),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2173),
    [sym_preproc_endregion] = STATE(2173),
    [sym_preproc_line] = STATE(2173),
    [sym_preproc_pragma] = STATE(2173),
    [sym_preproc_nullable] = STATE(2173),
    [sym_preproc_error] = STATE(2173),
    [sym_preproc_define] = STATE(2173),
    [sym_preproc_undef] = STATE(2173),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2174] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5490),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2174),
    [sym_preproc_endregion] = STATE(2174),
    [sym_preproc_line] = STATE(2174),
    [sym_preproc_pragma] = STATE(2174),
    [sym_preproc_nullable] = STATE(2174),
    [sym_preproc_error] = STATE(2174),
    [sym_preproc_define] = STATE(2174),
    [sym_preproc_undef] = STATE(2174),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2175] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5588),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2175),
    [sym_preproc_endregion] = STATE(2175),
    [sym_preproc_line] = STATE(2175),
    [sym_preproc_pragma] = STATE(2175),
    [sym_preproc_nullable] = STATE(2175),
    [sym_preproc_error] = STATE(2175),
    [sym_preproc_define] = STATE(2175),
    [sym_preproc_undef] = STATE(2175),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2176] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3885),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2176),
    [sym_preproc_endregion] = STATE(2176),
    [sym_preproc_line] = STATE(2176),
    [sym_preproc_pragma] = STATE(2176),
    [sym_preproc_nullable] = STATE(2176),
    [sym_preproc_error] = STATE(2176),
    [sym_preproc_define] = STATE(2176),
    [sym_preproc_undef] = STATE(2176),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2177] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5587),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2177),
    [sym_preproc_endregion] = STATE(2177),
    [sym_preproc_line] = STATE(2177),
    [sym_preproc_pragma] = STATE(2177),
    [sym_preproc_nullable] = STATE(2177),
    [sym_preproc_error] = STATE(2177),
    [sym_preproc_define] = STATE(2177),
    [sym_preproc_undef] = STATE(2177),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2178] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3825),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2178),
    [sym_preproc_endregion] = STATE(2178),
    [sym_preproc_line] = STATE(2178),
    [sym_preproc_pragma] = STATE(2178),
    [sym_preproc_nullable] = STATE(2178),
    [sym_preproc_error] = STATE(2178),
    [sym_preproc_define] = STATE(2178),
    [sym_preproc_undef] = STATE(2178),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2179] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6947),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2947),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7092),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5551),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4196),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7437),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9419),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2179),
    [sym_preproc_endregion] = STATE(2179),
    [sym_preproc_line] = STATE(2179),
    [sym_preproc_pragma] = STATE(2179),
    [sym_preproc_nullable] = STATE(2179),
    [sym_preproc_error] = STATE(2179),
    [sym_preproc_define] = STATE(2179),
    [sym_preproc_undef] = STATE(2179),
    [aux_sym_class_declaration_repeat1] = STATE(3877),
    [aux_sym_lambda_expression_repeat1] = STATE(4159),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_ref] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1821),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1825),
    [anon_sym_TILDE] = ACTIONS(1825),
    [anon_sym_PLUS_PLUS] = ACTIONS(1825),
    [anon_sym_DASH_DASH] = ACTIONS(1825),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1825),
    [anon_sym_AMP] = ACTIONS(1825),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1833),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2180] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5201),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2180),
    [sym_preproc_endregion] = STATE(2180),
    [sym_preproc_line] = STATE(2180),
    [sym_preproc_pragma] = STATE(2180),
    [sym_preproc_nullable] = STATE(2180),
    [sym_preproc_error] = STATE(2180),
    [sym_preproc_define] = STATE(2180),
    [sym_preproc_undef] = STATE(2180),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2181] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5147),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2181),
    [sym_preproc_endregion] = STATE(2181),
    [sym_preproc_line] = STATE(2181),
    [sym_preproc_pragma] = STATE(2181),
    [sym_preproc_nullable] = STATE(2181),
    [sym_preproc_error] = STATE(2181),
    [sym_preproc_define] = STATE(2181),
    [sym_preproc_undef] = STATE(2181),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2182] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5144),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2182),
    [sym_preproc_endregion] = STATE(2182),
    [sym_preproc_line] = STATE(2182),
    [sym_preproc_pragma] = STATE(2182),
    [sym_preproc_nullable] = STATE(2182),
    [sym_preproc_error] = STATE(2182),
    [sym_preproc_define] = STATE(2182),
    [sym_preproc_undef] = STATE(2182),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2183] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5568),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2183),
    [sym_preproc_endregion] = STATE(2183),
    [sym_preproc_line] = STATE(2183),
    [sym_preproc_pragma] = STATE(2183),
    [sym_preproc_nullable] = STATE(2183),
    [sym_preproc_error] = STATE(2183),
    [sym_preproc_define] = STATE(2183),
    [sym_preproc_undef] = STATE(2183),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2184] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5442),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2184),
    [sym_preproc_endregion] = STATE(2184),
    [sym_preproc_line] = STATE(2184),
    [sym_preproc_pragma] = STATE(2184),
    [sym_preproc_nullable] = STATE(2184),
    [sym_preproc_error] = STATE(2184),
    [sym_preproc_define] = STATE(2184),
    [sym_preproc_undef] = STATE(2184),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2185] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6906),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7143),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(3820),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(3872),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7412),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9125),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2185),
    [sym_preproc_endregion] = STATE(2185),
    [sym_preproc_line] = STATE(2185),
    [sym_preproc_pragma] = STATE(2185),
    [sym_preproc_nullable] = STATE(2185),
    [sym_preproc_error] = STATE(2185),
    [sym_preproc_define] = STATE(2185),
    [sym_preproc_undef] = STATE(2185),
    [aux_sym_class_declaration_repeat1] = STATE(3839),
    [aux_sym_lambda_expression_repeat1] = STATE(4148),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_ref] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1389),
    [anon_sym_TILDE] = ACTIONS(1389),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_DASH_DASH] = ACTIONS(1389),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1393),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2186] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5651),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2186),
    [sym_preproc_endregion] = STATE(2186),
    [sym_preproc_line] = STATE(2186),
    [sym_preproc_pragma] = STATE(2186),
    [sym_preproc_nullable] = STATE(2186),
    [sym_preproc_error] = STATE(2186),
    [sym_preproc_define] = STATE(2186),
    [sym_preproc_undef] = STATE(2186),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2187] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6957),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5091),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3874),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7438),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9394),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2187),
    [sym_preproc_endregion] = STATE(2187),
    [sym_preproc_line] = STATE(2187),
    [sym_preproc_pragma] = STATE(2187),
    [sym_preproc_nullable] = STATE(2187),
    [sym_preproc_error] = STATE(2187),
    [sym_preproc_define] = STATE(2187),
    [sym_preproc_undef] = STATE(2187),
    [aux_sym_class_declaration_repeat1] = STATE(3828),
    [aux_sym_lambda_expression_repeat1] = STATE(4205),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_ref] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_TILDE] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1339),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1343),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2188] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5962),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2188),
    [sym_preproc_endregion] = STATE(2188),
    [sym_preproc_line] = STATE(2188),
    [sym_preproc_pragma] = STATE(2188),
    [sym_preproc_nullable] = STATE(2188),
    [sym_preproc_error] = STATE(2188),
    [sym_preproc_define] = STATE(2188),
    [sym_preproc_undef] = STATE(2188),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2189] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5646),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2189),
    [sym_preproc_endregion] = STATE(2189),
    [sym_preproc_line] = STATE(2189),
    [sym_preproc_pragma] = STATE(2189),
    [sym_preproc_nullable] = STATE(2189),
    [sym_preproc_error] = STATE(2189),
    [sym_preproc_define] = STATE(2189),
    [sym_preproc_undef] = STATE(2189),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2190] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5567),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2190),
    [sym_preproc_endregion] = STATE(2190),
    [sym_preproc_line] = STATE(2190),
    [sym_preproc_pragma] = STATE(2190),
    [sym_preproc_nullable] = STATE(2190),
    [sym_preproc_error] = STATE(2190),
    [sym_preproc_define] = STATE(2190),
    [sym_preproc_undef] = STATE(2190),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2191] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5611),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2191),
    [sym_preproc_endregion] = STATE(2191),
    [sym_preproc_line] = STATE(2191),
    [sym_preproc_pragma] = STATE(2191),
    [sym_preproc_nullable] = STATE(2191),
    [sym_preproc_error] = STATE(2191),
    [sym_preproc_define] = STATE(2191),
    [sym_preproc_undef] = STATE(2191),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2192] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5609),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2192),
    [sym_preproc_endregion] = STATE(2192),
    [sym_preproc_line] = STATE(2192),
    [sym_preproc_pragma] = STATE(2192),
    [sym_preproc_nullable] = STATE(2192),
    [sym_preproc_error] = STATE(2192),
    [sym_preproc_define] = STATE(2192),
    [sym_preproc_undef] = STATE(2192),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2193] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3177),
    [sym__name] = STATE(6935),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2766),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7066),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5607),
    [sym_non_lvalue_expression] = STATE(3964),
    [sym_lvalue_expression] = STATE(4299),
    [sym__expression_statement_expression] = STATE(3973),
    [sym_assignment_expression] = STATE(3963),
    [sym_binary_expression] = STATE(3973),
    [sym_postfix_unary_expression] = STATE(3963),
    [sym_prefix_unary_expression] = STATE(3963),
    [sym__pointer_indirection_expression] = STATE(3184),
    [sym_query_expression] = STATE(3973),
    [sym_from_clause] = STATE(7425),
    [sym_conditional_expression] = STATE(3973),
    [sym_conditional_access_expression] = STATE(3973),
    [sym_as_expression] = STATE(3973),
    [sym_is_expression] = STATE(3973),
    [sym_is_pattern_expression] = STATE(3973),
    [sym_cast_expression] = STATE(3973),
    [sym_checked_expression] = STATE(3973),
    [sym_invocation_expression] = STATE(3963),
    [sym_switch_expression] = STATE(3973),
    [sym_await_expression] = STATE(3963),
    [sym_throw_expression] = STATE(3973),
    [sym_element_access_expression] = STATE(3184),
    [sym_interpolated_string_expression] = STATE(3973),
    [sym_member_access_expression] = STATE(3184),
    [sym_object_creation_expression] = STATE(3963),
    [sym_parenthesized_expression] = STATE(3963),
    [sym__parenthesized_lvalue_expression] = STATE(3184),
    [sym_lambda_expression] = STATE(3973),
    [sym__lambda_parameters] = STATE(9504),
    [sym_array_creation_expression] = STATE(3973),
    [sym_anonymous_method_expression] = STATE(3973),
    [sym_anonymous_object_creation_expression] = STATE(3973),
    [sym_implicit_array_creation_expression] = STATE(3973),
    [sym_implicit_object_creation_expression] = STATE(3973),
    [sym_implicit_stackalloc_expression] = STATE(3973),
    [sym_initializer_expression] = STATE(3973),
    [sym_default_expression] = STATE(3973),
    [sym_with_expression] = STATE(3973),
    [sym_sizeof_expression] = STATE(3973),
    [sym_typeof_expression] = STATE(3973),
    [sym_makeref_expression] = STATE(3973),
    [sym_ref_expression] = STATE(3973),
    [sym_reftype_expression] = STATE(3973),
    [sym_refvalue_expression] = STATE(3973),
    [sym_stackalloc_expression] = STATE(3973),
    [sym_range_expression] = STATE(3973),
    [sym_tuple_expression] = STATE(3184),
    [sym_literal] = STATE(3973),
    [sym_character_literal] = STATE(4024),
    [sym_string_literal] = STATE(4024),
    [sym_raw_string_literal] = STATE(4024),
    [sym_boolean_literal] = STATE(4024),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3973),
    [sym_preproc_region] = STATE(2193),
    [sym_preproc_endregion] = STATE(2193),
    [sym_preproc_line] = STATE(2193),
    [sym_preproc_pragma] = STATE(2193),
    [sym_preproc_nullable] = STATE(2193),
    [sym_preproc_error] = STATE(2193),
    [sym_preproc_define] = STATE(2193),
    [sym_preproc_undef] = STATE(2193),
    [aux_sym_class_declaration_repeat1] = STATE(3824),
    [aux_sym_lambda_expression_repeat1] = STATE(4178),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_ref] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_delegate] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1167),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(1181),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1185),
    [anon_sym_unchecked] = ACTIONS(1171),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1591),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1595),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_stackalloc] = ACTIONS(1197),
    [anon_sym_sizeof] = ACTIONS(1199),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym___makeref] = ACTIONS(1203),
    [anon_sym___reftype] = ACTIONS(1205),
    [anon_sym___refvalue] = ACTIONS(1207),
    [sym_null_literal] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_integer_literal] = ACTIONS(1209),
    [sym_real_literal] = ACTIONS(1213),
    [sym_verbatim_string_literal] = ACTIONS(1213),
    [aux_sym_preproc_if_token1] = ACTIONS(1215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1217),
    [sym_interpolation_verbatim_start] = ACTIONS(1219),
    [sym_interpolation_raw_start] = ACTIONS(1221),
    [sym_raw_string_start] = ACTIONS(1223),
  },
  [2194] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5143),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2194),
    [sym_preproc_endregion] = STATE(2194),
    [sym_preproc_line] = STATE(2194),
    [sym_preproc_pragma] = STATE(2194),
    [sym_preproc_nullable] = STATE(2194),
    [sym_preproc_error] = STATE(2194),
    [sym_preproc_define] = STATE(2194),
    [sym_preproc_undef] = STATE(2194),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2195] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6389),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2195),
    [sym_preproc_endregion] = STATE(2195),
    [sym_preproc_line] = STATE(2195),
    [sym_preproc_pragma] = STATE(2195),
    [sym_preproc_nullable] = STATE(2195),
    [sym_preproc_error] = STATE(2195),
    [sym_preproc_define] = STATE(2195),
    [sym_preproc_undef] = STATE(2195),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2196] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5142),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2196),
    [sym_preproc_endregion] = STATE(2196),
    [sym_preproc_line] = STATE(2196),
    [sym_preproc_pragma] = STATE(2196),
    [sym_preproc_nullable] = STATE(2196),
    [sym_preproc_error] = STATE(2196),
    [sym_preproc_define] = STATE(2196),
    [sym_preproc_undef] = STATE(2196),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2197] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6904),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2964),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7064),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(4940),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(3796),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7432),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9658),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(3644),
    [sym_string_literal] = STATE(3644),
    [sym_raw_string_literal] = STATE(3644),
    [sym_boolean_literal] = STATE(3644),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2197),
    [sym_preproc_endregion] = STATE(2197),
    [sym_preproc_line] = STATE(2197),
    [sym_preproc_pragma] = STATE(2197),
    [sym_preproc_nullable] = STATE(2197),
    [sym_preproc_error] = STATE(2197),
    [sym_preproc_define] = STATE(2197),
    [sym_preproc_undef] = STATE(2197),
    [aux_sym_class_declaration_repeat1] = STATE(3841),
    [aux_sym_lambda_expression_repeat1] = STATE(4228),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_ref] = ACTIONS(1911),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_TILDE] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1919),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(1263),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(1265),
    [anon_sym_throw] = ACTIONS(1921),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1923),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(1277),
    [anon_sym_typeof] = ACTIONS(1279),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(1287),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [sym_integer_literal] = ACTIONS(1287),
    [sym_real_literal] = ACTIONS(1291),
    [sym_verbatim_string_literal] = ACTIONS(1291),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(1295),
    [sym_interpolation_verbatim_start] = ACTIONS(1297),
    [sym_interpolation_raw_start] = ACTIONS(1299),
    [sym_raw_string_start] = ACTIONS(1301),
  },
  [2198] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5141),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2198),
    [sym_preproc_endregion] = STATE(2198),
    [sym_preproc_line] = STATE(2198),
    [sym_preproc_pragma] = STATE(2198),
    [sym_preproc_nullable] = STATE(2198),
    [sym_preproc_error] = STATE(2198),
    [sym_preproc_define] = STATE(2198),
    [sym_preproc_undef] = STATE(2198),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2199] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2772),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7047),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5969),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4352),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9403),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2199),
    [sym_preproc_endregion] = STATE(2199),
    [sym_preproc_line] = STATE(2199),
    [sym_preproc_pragma] = STATE(2199),
    [sym_preproc_nullable] = STATE(2199),
    [sym_preproc_error] = STATE(2199),
    [sym_preproc_define] = STATE(2199),
    [sym_preproc_undef] = STATE(2199),
    [aux_sym_class_declaration_repeat1] = STATE(3869),
    [aux_sym_lambda_expression_repeat1] = STATE(4271),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_ref] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_CARET] = ACTIONS(1603),
    [anon_sym_AMP] = ACTIONS(1603),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1607),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2200] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5138),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2200),
    [sym_preproc_endregion] = STATE(2200),
    [sym_preproc_line] = STATE(2200),
    [sym_preproc_pragma] = STATE(2200),
    [sym_preproc_nullable] = STATE(2200),
    [sym_preproc_error] = STATE(2200),
    [sym_preproc_define] = STATE(2200),
    [sym_preproc_undef] = STATE(2200),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2201] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6921),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6979),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5140),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(3927),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7430),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9867),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2201),
    [sym_preproc_endregion] = STATE(2201),
    [sym_preproc_line] = STATE(2201),
    [sym_preproc_pragma] = STATE(2201),
    [sym_preproc_nullable] = STATE(2201),
    [sym_preproc_error] = STATE(2201),
    [sym_preproc_define] = STATE(2201),
    [sym_preproc_undef] = STATE(2201),
    [aux_sym_class_declaration_repeat1] = STATE(3847),
    [aux_sym_lambda_expression_repeat1] = STATE(4208),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1329),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1115),
    [anon_sym_DASH_DASH] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1115),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1361),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2202] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3451),
    [sym__name] = STATE(6907),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2902),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(6970),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(5623),
    [sym_non_lvalue_expression] = STATE(4290),
    [sym_lvalue_expression] = STATE(4245),
    [sym__expression_statement_expression] = STATE(4280),
    [sym_assignment_expression] = STATE(4293),
    [sym_binary_expression] = STATE(4280),
    [sym_postfix_unary_expression] = STATE(4293),
    [sym_prefix_unary_expression] = STATE(4293),
    [sym__pointer_indirection_expression] = STATE(3442),
    [sym_query_expression] = STATE(4280),
    [sym_from_clause] = STATE(7424),
    [sym_conditional_expression] = STATE(4280),
    [sym_conditional_access_expression] = STATE(4280),
    [sym_as_expression] = STATE(4280),
    [sym_is_expression] = STATE(4280),
    [sym_is_pattern_expression] = STATE(4280),
    [sym_cast_expression] = STATE(4280),
    [sym_checked_expression] = STATE(4280),
    [sym_invocation_expression] = STATE(4293),
    [sym_switch_expression] = STATE(4280),
    [sym_await_expression] = STATE(4293),
    [sym_throw_expression] = STATE(4280),
    [sym_element_access_expression] = STATE(3442),
    [sym_interpolated_string_expression] = STATE(4280),
    [sym_member_access_expression] = STATE(3442),
    [sym_object_creation_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4293),
    [sym__parenthesized_lvalue_expression] = STATE(3442),
    [sym_lambda_expression] = STATE(4280),
    [sym__lambda_parameters] = STATE(9779),
    [sym_array_creation_expression] = STATE(4280),
    [sym_anonymous_method_expression] = STATE(4280),
    [sym_anonymous_object_creation_expression] = STATE(4280),
    [sym_implicit_array_creation_expression] = STATE(4280),
    [sym_implicit_object_creation_expression] = STATE(4280),
    [sym_implicit_stackalloc_expression] = STATE(4280),
    [sym_initializer_expression] = STATE(4280),
    [sym_default_expression] = STATE(4280),
    [sym_with_expression] = STATE(4280),
    [sym_sizeof_expression] = STATE(4280),
    [sym_typeof_expression] = STATE(4280),
    [sym_makeref_expression] = STATE(4280),
    [sym_ref_expression] = STATE(4280),
    [sym_reftype_expression] = STATE(4280),
    [sym_refvalue_expression] = STATE(4280),
    [sym_stackalloc_expression] = STATE(4280),
    [sym_range_expression] = STATE(4280),
    [sym_tuple_expression] = STATE(3442),
    [sym_literal] = STATE(4280),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2837),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(4280),
    [sym_preproc_region] = STATE(2202),
    [sym_preproc_endregion] = STATE(2202),
    [sym_preproc_line] = STATE(2202),
    [sym_preproc_pragma] = STATE(2202),
    [sym_preproc_nullable] = STATE(2202),
    [sym_preproc_error] = STATE(2202),
    [sym_preproc_define] = STATE(2202),
    [sym_preproc_undef] = STATE(2202),
    [aux_sym_class_declaration_repeat1] = STATE(3862),
    [aux_sym_lambda_expression_repeat1] = STATE(4221),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_ref] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_delegate] = ACTIONS(1327),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1541),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_TILDE] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1543),
    [anon_sym_DASH] = ACTIONS(1543),
    [anon_sym_STAR] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_this] = ACTIONS(1335),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(1337),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1331),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1549),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1551),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(1345),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(1347),
    [anon_sym___reftype] = ACTIONS(1349),
    [anon_sym___refvalue] = ACTIONS(1351),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2203] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym_bracketed_argument_list] = STATE(3035),
    [sym__name] = STATE(6936),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(2813),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_type] = STATE(7040),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_expression] = STATE(6476),
    [sym_non_lvalue_expression] = STATE(3732),
    [sym_lvalue_expression] = STATE(4270),
    [sym__expression_statement_expression] = STATE(3753),
    [sym_assignment_expression] = STATE(3773),
    [sym_binary_expression] = STATE(3753),
    [sym_postfix_unary_expression] = STATE(3773),
    [sym_prefix_unary_expression] = STATE(3773),
    [sym__pointer_indirection_expression] = STATE(3045),
    [sym_query_expression] = STATE(3753),
    [sym_from_clause] = STATE(7429),
    [sym_conditional_expression] = STATE(3753),
    [sym_conditional_access_expression] = STATE(3753),
    [sym_as_expression] = STATE(3753),
    [sym_is_expression] = STATE(3753),
    [sym_is_pattern_expression] = STATE(3753),
    [sym_cast_expression] = STATE(3753),
    [sym_checked_expression] = STATE(3753),
    [sym_invocation_expression] = STATE(3773),
    [sym_switch_expression] = STATE(3753),
    [sym_await_expression] = STATE(3773),
    [sym_throw_expression] = STATE(3753),
    [sym_element_access_expression] = STATE(3045),
    [sym_interpolated_string_expression] = STATE(3753),
    [sym_member_access_expression] = STATE(3045),
    [sym_object_creation_expression] = STATE(3773),
    [sym_parenthesized_expression] = STATE(3773),
    [sym__parenthesized_lvalue_expression] = STATE(3045),
    [sym_lambda_expression] = STATE(3753),
    [sym__lambda_parameters] = STATE(9687),
    [sym_array_creation_expression] = STATE(3753),
    [sym_anonymous_method_expression] = STATE(3753),
    [sym_anonymous_object_creation_expression] = STATE(3753),
    [sym_implicit_array_creation_expression] = STATE(3753),
    [sym_implicit_object_creation_expression] = STATE(3753),
    [sym_implicit_stackalloc_expression] = STATE(3753),
    [sym_initializer_expression] = STATE(3753),
    [sym_default_expression] = STATE(3753),
    [sym_with_expression] = STATE(3753),
    [sym_sizeof_expression] = STATE(3753),
    [sym_typeof_expression] = STATE(3753),
    [sym_makeref_expression] = STATE(3753),
    [sym_ref_expression] = STATE(3753),
    [sym_reftype_expression] = STATE(3753),
    [sym_refvalue_expression] = STATE(3753),
    [sym_stackalloc_expression] = STATE(3753),
    [sym_range_expression] = STATE(3753),
    [sym_tuple_expression] = STATE(3045),
    [sym_literal] = STATE(3753),
    [sym_character_literal] = STATE(4237),
    [sym_string_literal] = STATE(4237),
    [sym_raw_string_literal] = STATE(4237),
    [sym_boolean_literal] = STATE(4237),
    [sym_identifier] = STATE(2753),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_if_in_expression] = STATE(3753),
    [sym_preproc_region] = STATE(2203),
    [sym_preproc_endregion] = STATE(2203),
    [sym_preproc_line] = STATE(2203),
    [sym_preproc_pragma] = STATE(2203),
    [sym_preproc_nullable] = STATE(2203),
    [sym_preproc_error] = STATE(2203),
    [sym_preproc_define] = STATE(2203),
    [sym_preproc_undef] = STATE(2203),
    [aux_sym_class_declaration_repeat1] = STATE(3878),
    [aux_sym_lambda_expression_repeat1] = STATE(4200),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(677),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_delegate] = ACTIONS(683),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_new] = ACTIONS(1073),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_checked] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_true] = ACTIONS(75),
    [anon_sym_false] = ACTIONS(75),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(697),
    [anon_sym_CARET] = ACTIONS(1527),
    [anon_sym_AMP] = ACTIONS(1527),
    [anon_sym_this] = ACTIONS(81),
    [anon_sym_scoped] = ACTIONS(83),
    [anon_sym_base] = ACTIONS(85),
    [anon_sym_var] = ACTIONS(87),
    [sym_predefined_type] = ACTIONS(89),
    [anon_sym_unchecked] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(107),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(1093),
    [anon_sym_DOT_DOT] = ACTIONS(727),
    [anon_sym_from] = ACTIONS(123),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(125),
    [anon_sym_stackalloc] = ACTIONS(127),
    [anon_sym_sizeof] = ACTIONS(129),
    [anon_sym_typeof] = ACTIONS(131),
    [anon_sym___makeref] = ACTIONS(133),
    [anon_sym___reftype] = ACTIONS(135),
    [anon_sym___refvalue] = ACTIONS(137),
    [sym_null_literal] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(141),
    [sym_integer_literal] = ACTIONS(139),
    [sym_real_literal] = ACTIONS(143),
    [sym_verbatim_string_literal] = ACTIONS(143),
    [aux_sym_preproc_if_token1] = ACTIONS(1101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(149),
    [sym_interpolation_verbatim_start] = ACTIONS(151),
    [sym_interpolation_raw_start] = ACTIONS(153),
    [sym_raw_string_start] = ACTIONS(155),
  },
  [2204] = {
    [sym_preproc_region] = STATE(2204),
    [sym_preproc_endregion] = STATE(2204),
    [sym_preproc_line] = STATE(2204),
    [sym_preproc_pragma] = STATE(2204),
    [sym_preproc_nullable] = STATE(2204),
    [sym_preproc_error] = STATE(2204),
    [sym_preproc_define] = STATE(2204),
    [sym_preproc_undef] = STATE(2204),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2205] = {
    [sym_preproc_region] = STATE(2205),
    [sym_preproc_endregion] = STATE(2205),
    [sym_preproc_line] = STATE(2205),
    [sym_preproc_pragma] = STATE(2205),
    [sym_preproc_nullable] = STATE(2205),
    [sym_preproc_error] = STATE(2205),
    [sym_preproc_define] = STATE(2205),
    [sym_preproc_undef] = STATE(2205),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_global] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_ref] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_delegate] = ACTIONS(2993),
    [anon_sym_record] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_file] = ACTIONS(2993),
    [anon_sym_fixed] = ACTIONS(2993),
    [anon_sym_internal] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_override] = ACTIONS(2993),
    [anon_sym_partial] = ACTIONS(2993),
    [anon_sym_private] = ACTIONS(2993),
    [anon_sym_protected] = ACTIONS(2993),
    [anon_sym_public] = ACTIONS(2993),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_required] = ACTIONS(2993),
    [anon_sym_sealed] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2993),
    [anon_sym_unmanaged] = ACTIONS(2993),
    [anon_sym_checked] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_true] = ACTIONS(2993),
    [anon_sym_false] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_this] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(2993),
    [anon_sym_base] = ACTIONS(2993),
    [anon_sym_var] = ACTIONS(2993),
    [sym_predefined_type] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_unchecked] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_yield] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_when] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2993),
    [anon_sym_foreach] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_else] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_into] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_ascending] = ACTIONS(2993),
    [anon_sym_descending] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_stackalloc] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2997),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym___makeref] = ACTIONS(2993),
    [anon_sym___reftype] = ACTIONS(2993),
    [anon_sym___refvalue] = ACTIONS(2993),
    [sym_null_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_integer_literal] = ACTIONS(2993),
    [sym_real_literal] = ACTIONS(2995),
    [sym_verbatim_string_literal] = ACTIONS(2995),
    [aux_sym_preproc_if_token1] = ACTIONS(2995),
    [aux_sym_preproc_if_token3] = ACTIONS(2995),
    [aux_sym_preproc_else_token1] = ACTIONS(2995),
    [aux_sym_preproc_elif_token1] = ACTIONS(2995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2995),
    [sym_interpolation_verbatim_start] = ACTIONS(2995),
    [sym_interpolation_raw_start] = ACTIONS(2995),
    [sym_raw_string_start] = ACTIONS(2995),
  },
  [2206] = {
    [sym_preproc_region] = STATE(2206),
    [sym_preproc_endregion] = STATE(2206),
    [sym_preproc_line] = STATE(2206),
    [sym_preproc_pragma] = STATE(2206),
    [sym_preproc_nullable] = STATE(2206),
    [sym_preproc_error] = STATE(2206),
    [sym_preproc_define] = STATE(2206),
    [sym_preproc_undef] = STATE(2206),
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2207] = {
    [sym_preproc_region] = STATE(2207),
    [sym_preproc_endregion] = STATE(2207),
    [sym_preproc_line] = STATE(2207),
    [sym_preproc_pragma] = STATE(2207),
    [sym_preproc_nullable] = STATE(2207),
    [sym_preproc_error] = STATE(2207),
    [sym_preproc_define] = STATE(2207),
    [sym_preproc_undef] = STATE(2207),
    [ts_builtin_sym_end] = ACTIONS(2995),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_global] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_ref] = ACTIONS(2993),
    [anon_sym_struct] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_delegate] = ACTIONS(2993),
    [anon_sym_record] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_file] = ACTIONS(2993),
    [anon_sym_fixed] = ACTIONS(2993),
    [anon_sym_internal] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_override] = ACTIONS(2993),
    [anon_sym_partial] = ACTIONS(2993),
    [anon_sym_private] = ACTIONS(2993),
    [anon_sym_protected] = ACTIONS(2993),
    [anon_sym_public] = ACTIONS(2993),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_required] = ACTIONS(2993),
    [anon_sym_sealed] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2993),
    [anon_sym_unmanaged] = ACTIONS(2993),
    [anon_sym_checked] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_true] = ACTIONS(2993),
    [anon_sym_false] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_this] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(2993),
    [anon_sym_base] = ACTIONS(2993),
    [anon_sym_var] = ACTIONS(2993),
    [sym_predefined_type] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_unchecked] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_yield] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_when] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2993),
    [anon_sym_foreach] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_else] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_into] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_ascending] = ACTIONS(2993),
    [anon_sym_descending] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_stackalloc] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2997),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym___makeref] = ACTIONS(2993),
    [anon_sym___reftype] = ACTIONS(2993),
    [anon_sym___refvalue] = ACTIONS(2993),
    [sym_null_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_integer_literal] = ACTIONS(2993),
    [sym_real_literal] = ACTIONS(2995),
    [sym_verbatim_string_literal] = ACTIONS(2995),
    [aux_sym_preproc_if_token1] = ACTIONS(2995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2995),
    [sym_interpolation_verbatim_start] = ACTIONS(2995),
    [sym_interpolation_raw_start] = ACTIONS(2995),
    [sym_raw_string_start] = ACTIONS(2995),
  },
  [2208] = {
    [sym_preproc_region] = STATE(2208),
    [sym_preproc_endregion] = STATE(2208),
    [sym_preproc_line] = STATE(2208),
    [sym_preproc_pragma] = STATE(2208),
    [sym_preproc_nullable] = STATE(2208),
    [sym_preproc_error] = STATE(2208),
    [sym_preproc_define] = STATE(2208),
    [sym_preproc_undef] = STATE(2208),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2209] = {
    [sym_preproc_region] = STATE(2209),
    [sym_preproc_endregion] = STATE(2209),
    [sym_preproc_line] = STATE(2209),
    [sym_preproc_pragma] = STATE(2209),
    [sym_preproc_nullable] = STATE(2209),
    [sym_preproc_error] = STATE(2209),
    [sym_preproc_define] = STATE(2209),
    [sym_preproc_undef] = STATE(2209),
    [sym__identifier_token] = ACTIONS(2993),
    [anon_sym_extern] = ACTIONS(2993),
    [anon_sym_alias] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_global] = ACTIONS(2993),
    [anon_sym_using] = ACTIONS(2993),
    [anon_sym_unsafe] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_ref] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_delegate] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_file] = ACTIONS(2993),
    [anon_sym_fixed] = ACTIONS(2993),
    [anon_sym_internal] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_override] = ACTIONS(2993),
    [anon_sym_partial] = ACTIONS(2993),
    [anon_sym_private] = ACTIONS(2993),
    [anon_sym_protected] = ACTIONS(2993),
    [anon_sym_public] = ACTIONS(2993),
    [anon_sym_readonly] = ACTIONS(2993),
    [anon_sym_required] = ACTIONS(2993),
    [anon_sym_sealed] = ACTIONS(2993),
    [anon_sym_virtual] = ACTIONS(2993),
    [anon_sym_volatile] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_notnull] = ACTIONS(2993),
    [anon_sym_unmanaged] = ACTIONS(2993),
    [anon_sym_checked] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_true] = ACTIONS(2993),
    [anon_sym_false] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2993),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_this] = ACTIONS(2993),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_scoped] = ACTIONS(2993),
    [anon_sym_base] = ACTIONS(2993),
    [anon_sym_var] = ACTIONS(2993),
    [sym_predefined_type] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_unchecked] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_lock] = ACTIONS(2993),
    [anon_sym_yield] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2993),
    [anon_sym_default] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_when] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2993),
    [anon_sym_foreach] = ACTIONS(2993),
    [anon_sym_goto] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_else] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_into] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_ascending] = ACTIONS(2993),
    [anon_sym_descending] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_as] = ACTIONS(2997),
    [anon_sym_is] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_stackalloc] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2997),
    [anon_sym_sizeof] = ACTIONS(2993),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym___makeref] = ACTIONS(2993),
    [anon_sym___reftype] = ACTIONS(2993),
    [anon_sym___refvalue] = ACTIONS(2993),
    [sym_null_literal] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_integer_literal] = ACTIONS(2993),
    [sym_real_literal] = ACTIONS(2995),
    [sym_verbatim_string_literal] = ACTIONS(2995),
    [aux_sym_preproc_if_token1] = ACTIONS(2995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2995),
    [sym_interpolation_verbatim_start] = ACTIONS(2995),
    [sym_interpolation_raw_start] = ACTIONS(2995),
    [sym_raw_string_start] = ACTIONS(2995),
  },
  [2210] = {
    [sym_catch_clause] = STATE(2218),
    [sym_finally_clause] = STATE(2304),
    [sym_preproc_region] = STATE(2210),
    [sym_preproc_endregion] = STATE(2210),
    [sym_preproc_line] = STATE(2210),
    [sym_preproc_pragma] = STATE(2210),
    [sym_preproc_nullable] = STATE(2210),
    [sym_preproc_error] = STATE(2210),
    [sym_preproc_define] = STATE(2210),
    [sym_preproc_undef] = STATE(2210),
    [aux_sym_try_statement_repeat1] = STATE(2212),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_record] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_catch] = ACTIONS(3005),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_finally] = ACTIONS(3007),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_if_token3] = ACTIONS(3003),
    [aux_sym_preproc_else_token1] = ACTIONS(3003),
    [aux_sym_preproc_elif_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2211] = {
    [sym_catch_clause] = STATE(2218),
    [sym_finally_clause] = STATE(2269),
    [sym_preproc_region] = STATE(2211),
    [sym_preproc_endregion] = STATE(2211),
    [sym_preproc_line] = STATE(2211),
    [sym_preproc_pragma] = STATE(2211),
    [sym_preproc_nullable] = STATE(2211),
    [sym_preproc_error] = STATE(2211),
    [sym_preproc_define] = STATE(2211),
    [sym_preproc_undef] = STATE(2211),
    [aux_sym_try_statement_repeat1] = STATE(2210),
    [sym__identifier_token] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym_alias] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_global] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_unsafe] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_ref] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3009),
    [anon_sym_record] = ACTIONS(3009),
    [anon_sym_abstract] = ACTIONS(3009),
    [anon_sym_async] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_file] = ACTIONS(3009),
    [anon_sym_fixed] = ACTIONS(3009),
    [anon_sym_internal] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_override] = ACTIONS(3009),
    [anon_sym_partial] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3009),
    [anon_sym_protected] = ACTIONS(3009),
    [anon_sym_public] = ACTIONS(3009),
    [anon_sym_readonly] = ACTIONS(3009),
    [anon_sym_required] = ACTIONS(3009),
    [anon_sym_sealed] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_where] = ACTIONS(3009),
    [anon_sym_notnull] = ACTIONS(3009),
    [anon_sym_unmanaged] = ACTIONS(3009),
    [anon_sym_checked] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_true] = ACTIONS(3009),
    [anon_sym_false] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_CARET] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_this] = ACTIONS(3009),
    [anon_sym_scoped] = ACTIONS(3009),
    [anon_sym_base] = ACTIONS(3009),
    [anon_sym_var] = ACTIONS(3009),
    [sym_predefined_type] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_unchecked] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_lock] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_catch] = ACTIONS(3005),
    [anon_sym_when] = ACTIONS(3009),
    [anon_sym_finally] = ACTIONS(3007),
    [anon_sym_await] = ACTIONS(3009),
    [anon_sym_foreach] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3011),
    [anon_sym_from] = ACTIONS(3009),
    [anon_sym_into] = ACTIONS(3009),
    [anon_sym_join] = ACTIONS(3009),
    [anon_sym_on] = ACTIONS(3009),
    [anon_sym_equals] = ACTIONS(3009),
    [anon_sym_let] = ACTIONS(3009),
    [anon_sym_orderby] = ACTIONS(3009),
    [anon_sym_ascending] = ACTIONS(3009),
    [anon_sym_descending] = ACTIONS(3009),
    [anon_sym_group] = ACTIONS(3009),
    [anon_sym_by] = ACTIONS(3009),
    [anon_sym_select] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_stackalloc] = ACTIONS(3009),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym_typeof] = ACTIONS(3009),
    [anon_sym___makeref] = ACTIONS(3009),
    [anon_sym___reftype] = ACTIONS(3009),
    [anon_sym___refvalue] = ACTIONS(3009),
    [sym_null_literal] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [sym_integer_literal] = ACTIONS(3009),
    [sym_real_literal] = ACTIONS(3011),
    [sym_verbatim_string_literal] = ACTIONS(3011),
    [aux_sym_preproc_if_token1] = ACTIONS(3011),
    [aux_sym_preproc_if_token3] = ACTIONS(3011),
    [aux_sym_preproc_else_token1] = ACTIONS(3011),
    [aux_sym_preproc_elif_token1] = ACTIONS(3011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3011),
    [sym_interpolation_verbatim_start] = ACTIONS(3011),
    [sym_interpolation_raw_start] = ACTIONS(3011),
    [sym_raw_string_start] = ACTIONS(3011),
  },
  [2212] = {
    [sym_catch_clause] = STATE(2218),
    [sym_preproc_region] = STATE(2212),
    [sym_preproc_endregion] = STATE(2212),
    [sym_preproc_line] = STATE(2212),
    [sym_preproc_pragma] = STATE(2212),
    [sym_preproc_nullable] = STATE(2212),
    [sym_preproc_error] = STATE(2212),
    [sym_preproc_define] = STATE(2212),
    [sym_preproc_undef] = STATE(2212),
    [aux_sym_try_statement_repeat1] = STATE(2212),
    [sym__identifier_token] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym_alias] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_global] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_unsafe] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_ref] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(3013),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_file] = ACTIONS(3013),
    [anon_sym_fixed] = ACTIONS(3013),
    [anon_sym_internal] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_override] = ACTIONS(3013),
    [anon_sym_partial] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_readonly] = ACTIONS(3013),
    [anon_sym_required] = ACTIONS(3013),
    [anon_sym_sealed] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_where] = ACTIONS(3013),
    [anon_sym_notnull] = ACTIONS(3013),
    [anon_sym_unmanaged] = ACTIONS(3013),
    [anon_sym_checked] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_true] = ACTIONS(3013),
    [anon_sym_false] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_this] = ACTIONS(3013),
    [anon_sym_scoped] = ACTIONS(3013),
    [anon_sym_base] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [sym_predefined_type] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_unchecked] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_lock] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_catch] = ACTIONS(3017),
    [anon_sym_when] = ACTIONS(3013),
    [anon_sym_finally] = ACTIONS(3013),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_foreach] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_DOT_DOT] = ACTIONS(3015),
    [anon_sym_from] = ACTIONS(3013),
    [anon_sym_into] = ACTIONS(3013),
    [anon_sym_join] = ACTIONS(3013),
    [anon_sym_on] = ACTIONS(3013),
    [anon_sym_equals] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_orderby] = ACTIONS(3013),
    [anon_sym_ascending] = ACTIONS(3013),
    [anon_sym_descending] = ACTIONS(3013),
    [anon_sym_group] = ACTIONS(3013),
    [anon_sym_by] = ACTIONS(3013),
    [anon_sym_select] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_stackalloc] = ACTIONS(3013),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym___makeref] = ACTIONS(3013),
    [anon_sym___reftype] = ACTIONS(3013),
    [anon_sym___refvalue] = ACTIONS(3013),
    [sym_null_literal] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(3013),
    [sym_real_literal] = ACTIONS(3015),
    [sym_verbatim_string_literal] = ACTIONS(3015),
    [aux_sym_preproc_if_token1] = ACTIONS(3015),
    [aux_sym_preproc_if_token3] = ACTIONS(3015),
    [aux_sym_preproc_else_token1] = ACTIONS(3015),
    [aux_sym_preproc_elif_token1] = ACTIONS(3015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3015),
    [sym_interpolation_verbatim_start] = ACTIONS(3015),
    [sym_interpolation_raw_start] = ACTIONS(3015),
    [sym_raw_string_start] = ACTIONS(3015),
  },
  [2213] = {
    [sym_catch_clause] = STATE(2299),
    [sym_finally_clause] = STATE(2449),
    [sym_preproc_region] = STATE(2213),
    [sym_preproc_endregion] = STATE(2213),
    [sym_preproc_line] = STATE(2213),
    [sym_preproc_pragma] = STATE(2213),
    [sym_preproc_nullable] = STATE(2213),
    [sym_preproc_error] = STATE(2213),
    [sym_preproc_define] = STATE(2213),
    [sym_preproc_undef] = STATE(2213),
    [aux_sym_try_statement_repeat1] = STATE(2221),
    [ts_builtin_sym_end] = ACTIONS(3003),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_record] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_catch] = ACTIONS(3020),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_finally] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2214] = {
    [sym_catch_clause] = STATE(2299),
    [sym_finally_clause] = STATE(2437),
    [sym_preproc_region] = STATE(2214),
    [sym_preproc_endregion] = STATE(2214),
    [sym_preproc_line] = STATE(2214),
    [sym_preproc_pragma] = STATE(2214),
    [sym_preproc_nullable] = STATE(2214),
    [sym_preproc_error] = STATE(2214),
    [sym_preproc_define] = STATE(2214),
    [sym_preproc_undef] = STATE(2214),
    [aux_sym_try_statement_repeat1] = STATE(2213),
    [ts_builtin_sym_end] = ACTIONS(3011),
    [sym__identifier_token] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym_alias] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_global] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_unsafe] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_ref] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_interface] = ACTIONS(3009),
    [anon_sym_delegate] = ACTIONS(3009),
    [anon_sym_record] = ACTIONS(3009),
    [anon_sym_abstract] = ACTIONS(3009),
    [anon_sym_async] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_file] = ACTIONS(3009),
    [anon_sym_fixed] = ACTIONS(3009),
    [anon_sym_internal] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_override] = ACTIONS(3009),
    [anon_sym_partial] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3009),
    [anon_sym_protected] = ACTIONS(3009),
    [anon_sym_public] = ACTIONS(3009),
    [anon_sym_readonly] = ACTIONS(3009),
    [anon_sym_required] = ACTIONS(3009),
    [anon_sym_sealed] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_where] = ACTIONS(3009),
    [anon_sym_notnull] = ACTIONS(3009),
    [anon_sym_unmanaged] = ACTIONS(3009),
    [anon_sym_checked] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_true] = ACTIONS(3009),
    [anon_sym_false] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_CARET] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_this] = ACTIONS(3009),
    [anon_sym_scoped] = ACTIONS(3009),
    [anon_sym_base] = ACTIONS(3009),
    [anon_sym_var] = ACTIONS(3009),
    [sym_predefined_type] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_unchecked] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_lock] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_catch] = ACTIONS(3020),
    [anon_sym_when] = ACTIONS(3009),
    [anon_sym_finally] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3009),
    [anon_sym_foreach] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3011),
    [anon_sym_from] = ACTIONS(3009),
    [anon_sym_into] = ACTIONS(3009),
    [anon_sym_join] = ACTIONS(3009),
    [anon_sym_on] = ACTIONS(3009),
    [anon_sym_equals] = ACTIONS(3009),
    [anon_sym_let] = ACTIONS(3009),
    [anon_sym_orderby] = ACTIONS(3009),
    [anon_sym_ascending] = ACTIONS(3009),
    [anon_sym_descending] = ACTIONS(3009),
    [anon_sym_group] = ACTIONS(3009),
    [anon_sym_by] = ACTIONS(3009),
    [anon_sym_select] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_stackalloc] = ACTIONS(3009),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym_typeof] = ACTIONS(3009),
    [anon_sym___makeref] = ACTIONS(3009),
    [anon_sym___reftype] = ACTIONS(3009),
    [anon_sym___refvalue] = ACTIONS(3009),
    [sym_null_literal] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [sym_integer_literal] = ACTIONS(3009),
    [sym_real_literal] = ACTIONS(3011),
    [sym_verbatim_string_literal] = ACTIONS(3011),
    [aux_sym_preproc_if_token1] = ACTIONS(3011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3011),
    [sym_interpolation_verbatim_start] = ACTIONS(3011),
    [sym_interpolation_raw_start] = ACTIONS(3011),
    [sym_raw_string_start] = ACTIONS(3011),
  },
  [2215] = {
    [sym_preproc_region] = STATE(2215),
    [sym_preproc_endregion] = STATE(2215),
    [sym_preproc_line] = STATE(2215),
    [sym_preproc_pragma] = STATE(2215),
    [sym_preproc_nullable] = STATE(2215),
    [sym_preproc_error] = STATE(2215),
    [sym_preproc_define] = STATE(2215),
    [sym_preproc_undef] = STATE(2215),
    [sym__identifier_token] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym_alias] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_global] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_unsafe] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_ref] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3024),
    [anon_sym_delegate] = ACTIONS(3024),
    [anon_sym_record] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_file] = ACTIONS(3024),
    [anon_sym_fixed] = ACTIONS(3024),
    [anon_sym_internal] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_override] = ACTIONS(3024),
    [anon_sym_partial] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_readonly] = ACTIONS(3024),
    [anon_sym_required] = ACTIONS(3024),
    [anon_sym_sealed] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_where] = ACTIONS(3024),
    [anon_sym_notnull] = ACTIONS(3024),
    [anon_sym_unmanaged] = ACTIONS(3024),
    [anon_sym_checked] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_true] = ACTIONS(3024),
    [anon_sym_false] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_CARET] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_this] = ACTIONS(3024),
    [anon_sym_scoped] = ACTIONS(3024),
    [anon_sym_base] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [sym_predefined_type] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_unchecked] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_lock] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_catch] = ACTIONS(3024),
    [anon_sym_when] = ACTIONS(3024),
    [anon_sym_finally] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_foreach] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_from] = ACTIONS(3024),
    [anon_sym_into] = ACTIONS(3024),
    [anon_sym_join] = ACTIONS(3024),
    [anon_sym_on] = ACTIONS(3024),
    [anon_sym_equals] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_orderby] = ACTIONS(3024),
    [anon_sym_ascending] = ACTIONS(3024),
    [anon_sym_descending] = ACTIONS(3024),
    [anon_sym_group] = ACTIONS(3024),
    [anon_sym_by] = ACTIONS(3024),
    [anon_sym_select] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [anon_sym_stackalloc] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym___makeref] = ACTIONS(3024),
    [anon_sym___reftype] = ACTIONS(3024),
    [anon_sym___refvalue] = ACTIONS(3024),
    [sym_null_literal] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [sym_integer_literal] = ACTIONS(3024),
    [sym_real_literal] = ACTIONS(3026),
    [sym_verbatim_string_literal] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token3] = ACTIONS(3026),
    [aux_sym_preproc_else_token1] = ACTIONS(3026),
    [aux_sym_preproc_elif_token1] = ACTIONS(3026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3026),
    [sym_interpolation_verbatim_start] = ACTIONS(3026),
    [sym_interpolation_raw_start] = ACTIONS(3026),
    [sym_raw_string_start] = ACTIONS(3026),
  },
  [2216] = {
    [sym_preproc_region] = STATE(2216),
    [sym_preproc_endregion] = STATE(2216),
    [sym_preproc_line] = STATE(2216),
    [sym_preproc_pragma] = STATE(2216),
    [sym_preproc_nullable] = STATE(2216),
    [sym_preproc_error] = STATE(2216),
    [sym_preproc_define] = STATE(2216),
    [sym_preproc_undef] = STATE(2216),
    [sym__identifier_token] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym_alias] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_global] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_unsafe] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_ref] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3028),
    [anon_sym_delegate] = ACTIONS(3028),
    [anon_sym_record] = ACTIONS(3028),
    [anon_sym_abstract] = ACTIONS(3028),
    [anon_sym_async] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_file] = ACTIONS(3028),
    [anon_sym_fixed] = ACTIONS(3028),
    [anon_sym_internal] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_override] = ACTIONS(3028),
    [anon_sym_partial] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_readonly] = ACTIONS(3028),
    [anon_sym_required] = ACTIONS(3028),
    [anon_sym_sealed] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_where] = ACTIONS(3028),
    [anon_sym_notnull] = ACTIONS(3028),
    [anon_sym_unmanaged] = ACTIONS(3028),
    [anon_sym_checked] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_true] = ACTIONS(3028),
    [anon_sym_false] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_this] = ACTIONS(3028),
    [anon_sym_scoped] = ACTIONS(3028),
    [anon_sym_base] = ACTIONS(3028),
    [anon_sym_var] = ACTIONS(3028),
    [sym_predefined_type] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_unchecked] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_lock] = ACTIONS(3028),
    [anon_sym_yield] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_catch] = ACTIONS(3028),
    [anon_sym_when] = ACTIONS(3028),
    [anon_sym_finally] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3028),
    [anon_sym_foreach] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_from] = ACTIONS(3028),
    [anon_sym_into] = ACTIONS(3028),
    [anon_sym_join] = ACTIONS(3028),
    [anon_sym_on] = ACTIONS(3028),
    [anon_sym_equals] = ACTIONS(3028),
    [anon_sym_let] = ACTIONS(3028),
    [anon_sym_orderby] = ACTIONS(3028),
    [anon_sym_ascending] = ACTIONS(3028),
    [anon_sym_descending] = ACTIONS(3028),
    [anon_sym_group] = ACTIONS(3028),
    [anon_sym_by] = ACTIONS(3028),
    [anon_sym_select] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_stackalloc] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym_typeof] = ACTIONS(3028),
    [anon_sym___makeref] = ACTIONS(3028),
    [anon_sym___reftype] = ACTIONS(3028),
    [anon_sym___refvalue] = ACTIONS(3028),
    [sym_null_literal] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [sym_integer_literal] = ACTIONS(3028),
    [sym_real_literal] = ACTIONS(3030),
    [sym_verbatim_string_literal] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token3] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3030),
    [sym_interpolation_verbatim_start] = ACTIONS(3030),
    [sym_interpolation_raw_start] = ACTIONS(3030),
    [sym_raw_string_start] = ACTIONS(3030),
  },
  [2217] = {
    [sym_preproc_region] = STATE(2217),
    [sym_preproc_endregion] = STATE(2217),
    [sym_preproc_line] = STATE(2217),
    [sym_preproc_pragma] = STATE(2217),
    [sym_preproc_nullable] = STATE(2217),
    [sym_preproc_error] = STATE(2217),
    [sym_preproc_define] = STATE(2217),
    [sym_preproc_undef] = STATE(2217),
    [sym__identifier_token] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym_alias] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym_global] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_unsafe] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_ref] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_delegate] = ACTIONS(3032),
    [anon_sym_record] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_async] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_file] = ACTIONS(3032),
    [anon_sym_fixed] = ACTIONS(3032),
    [anon_sym_internal] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_partial] = ACTIONS(3032),
    [anon_sym_private] = ACTIONS(3032),
    [anon_sym_protected] = ACTIONS(3032),
    [anon_sym_public] = ACTIONS(3032),
    [anon_sym_readonly] = ACTIONS(3032),
    [anon_sym_required] = ACTIONS(3032),
    [anon_sym_sealed] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_where] = ACTIONS(3032),
    [anon_sym_notnull] = ACTIONS(3032),
    [anon_sym_unmanaged] = ACTIONS(3032),
    [anon_sym_checked] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_true] = ACTIONS(3032),
    [anon_sym_false] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_this] = ACTIONS(3032),
    [anon_sym_scoped] = ACTIONS(3032),
    [anon_sym_base] = ACTIONS(3032),
    [anon_sym_var] = ACTIONS(3032),
    [sym_predefined_type] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_unchecked] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_lock] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_catch] = ACTIONS(3032),
    [anon_sym_when] = ACTIONS(3032),
    [anon_sym_finally] = ACTIONS(3032),
    [anon_sym_await] = ACTIONS(3032),
    [anon_sym_foreach] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3034),
    [anon_sym_from] = ACTIONS(3032),
    [anon_sym_into] = ACTIONS(3032),
    [anon_sym_join] = ACTIONS(3032),
    [anon_sym_on] = ACTIONS(3032),
    [anon_sym_equals] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_orderby] = ACTIONS(3032),
    [anon_sym_ascending] = ACTIONS(3032),
    [anon_sym_descending] = ACTIONS(3032),
    [anon_sym_group] = ACTIONS(3032),
    [anon_sym_by] = ACTIONS(3032),
    [anon_sym_select] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [anon_sym_stackalloc] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3032),
    [anon_sym___makeref] = ACTIONS(3032),
    [anon_sym___reftype] = ACTIONS(3032),
    [anon_sym___refvalue] = ACTIONS(3032),
    [sym_null_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [sym_integer_literal] = ACTIONS(3032),
    [sym_real_literal] = ACTIONS(3034),
    [sym_verbatim_string_literal] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token3] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3034),
    [sym_interpolation_verbatim_start] = ACTIONS(3034),
    [sym_interpolation_raw_start] = ACTIONS(3034),
    [sym_raw_string_start] = ACTIONS(3034),
  },
  [2218] = {
    [sym_preproc_region] = STATE(2218),
    [sym_preproc_endregion] = STATE(2218),
    [sym_preproc_line] = STATE(2218),
    [sym_preproc_pragma] = STATE(2218),
    [sym_preproc_nullable] = STATE(2218),
    [sym_preproc_error] = STATE(2218),
    [sym_preproc_define] = STATE(2218),
    [sym_preproc_undef] = STATE(2218),
    [sym__identifier_token] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym_alias] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_global] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_unsafe] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3036),
    [anon_sym_delegate] = ACTIONS(3036),
    [anon_sym_record] = ACTIONS(3036),
    [anon_sym_abstract] = ACTIONS(3036),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_file] = ACTIONS(3036),
    [anon_sym_fixed] = ACTIONS(3036),
    [anon_sym_internal] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_partial] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_required] = ACTIONS(3036),
    [anon_sym_sealed] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_where] = ACTIONS(3036),
    [anon_sym_notnull] = ACTIONS(3036),
    [anon_sym_unmanaged] = ACTIONS(3036),
    [anon_sym_checked] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_true] = ACTIONS(3036),
    [anon_sym_false] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_this] = ACTIONS(3036),
    [anon_sym_scoped] = ACTIONS(3036),
    [anon_sym_base] = ACTIONS(3036),
    [anon_sym_var] = ACTIONS(3036),
    [sym_predefined_type] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_unchecked] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_lock] = ACTIONS(3036),
    [anon_sym_yield] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_catch] = ACTIONS(3036),
    [anon_sym_when] = ACTIONS(3036),
    [anon_sym_finally] = ACTIONS(3036),
    [anon_sym_await] = ACTIONS(3036),
    [anon_sym_foreach] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_DOT_DOT] = ACTIONS(3038),
    [anon_sym_from] = ACTIONS(3036),
    [anon_sym_into] = ACTIONS(3036),
    [anon_sym_join] = ACTIONS(3036),
    [anon_sym_on] = ACTIONS(3036),
    [anon_sym_equals] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_orderby] = ACTIONS(3036),
    [anon_sym_ascending] = ACTIONS(3036),
    [anon_sym_descending] = ACTIONS(3036),
    [anon_sym_group] = ACTIONS(3036),
    [anon_sym_by] = ACTIONS(3036),
    [anon_sym_select] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_stackalloc] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym_typeof] = ACTIONS(3036),
    [anon_sym___makeref] = ACTIONS(3036),
    [anon_sym___reftype] = ACTIONS(3036),
    [anon_sym___refvalue] = ACTIONS(3036),
    [sym_null_literal] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [sym_integer_literal] = ACTIONS(3036),
    [sym_real_literal] = ACTIONS(3038),
    [sym_verbatim_string_literal] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token3] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3038),
    [sym_interpolation_verbatim_start] = ACTIONS(3038),
    [sym_interpolation_raw_start] = ACTIONS(3038),
    [sym_raw_string_start] = ACTIONS(3038),
  },
  [2219] = {
    [sym_preproc_region] = STATE(2219),
    [sym_preproc_endregion] = STATE(2219),
    [sym_preproc_line] = STATE(2219),
    [sym_preproc_pragma] = STATE(2219),
    [sym_preproc_nullable] = STATE(2219),
    [sym_preproc_error] = STATE(2219),
    [sym_preproc_define] = STATE(2219),
    [sym_preproc_undef] = STATE(2219),
    [sym__identifier_token] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym_alias] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_global] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_unsafe] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3040),
    [anon_sym_delegate] = ACTIONS(3040),
    [anon_sym_record] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_file] = ACTIONS(3040),
    [anon_sym_fixed] = ACTIONS(3040),
    [anon_sym_internal] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_partial] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_required] = ACTIONS(3040),
    [anon_sym_sealed] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3040),
    [anon_sym_notnull] = ACTIONS(3040),
    [anon_sym_unmanaged] = ACTIONS(3040),
    [anon_sym_checked] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_true] = ACTIONS(3040),
    [anon_sym_false] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_this] = ACTIONS(3040),
    [anon_sym_scoped] = ACTIONS(3040),
    [anon_sym_base] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [sym_predefined_type] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_unchecked] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_lock] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_catch] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_finally] = ACTIONS(3040),
    [anon_sym_await] = ACTIONS(3040),
    [anon_sym_foreach] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_from] = ACTIONS(3040),
    [anon_sym_into] = ACTIONS(3040),
    [anon_sym_join] = ACTIONS(3040),
    [anon_sym_on] = ACTIONS(3040),
    [anon_sym_equals] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_orderby] = ACTIONS(3040),
    [anon_sym_ascending] = ACTIONS(3040),
    [anon_sym_descending] = ACTIONS(3040),
    [anon_sym_group] = ACTIONS(3040),
    [anon_sym_by] = ACTIONS(3040),
    [anon_sym_select] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_stackalloc] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym_typeof] = ACTIONS(3040),
    [anon_sym___makeref] = ACTIONS(3040),
    [anon_sym___reftype] = ACTIONS(3040),
    [anon_sym___refvalue] = ACTIONS(3040),
    [sym_null_literal] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [sym_integer_literal] = ACTIONS(3040),
    [sym_real_literal] = ACTIONS(3042),
    [sym_verbatim_string_literal] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3042),
    [sym_interpolation_verbatim_start] = ACTIONS(3042),
    [sym_interpolation_raw_start] = ACTIONS(3042),
    [sym_raw_string_start] = ACTIONS(3042),
  },
  [2220] = {
    [sym_preproc_region] = STATE(2220),
    [sym_preproc_endregion] = STATE(2220),
    [sym_preproc_line] = STATE(2220),
    [sym_preproc_pragma] = STATE(2220),
    [sym_preproc_nullable] = STATE(2220),
    [sym_preproc_error] = STATE(2220),
    [sym_preproc_define] = STATE(2220),
    [sym_preproc_undef] = STATE(2220),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_catch] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_finally] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2221] = {
    [sym_catch_clause] = STATE(2299),
    [sym_preproc_region] = STATE(2221),
    [sym_preproc_endregion] = STATE(2221),
    [sym_preproc_line] = STATE(2221),
    [sym_preproc_pragma] = STATE(2221),
    [sym_preproc_nullable] = STATE(2221),
    [sym_preproc_error] = STATE(2221),
    [sym_preproc_define] = STATE(2221),
    [sym_preproc_undef] = STATE(2221),
    [aux_sym_try_statement_repeat1] = STATE(2221),
    [ts_builtin_sym_end] = ACTIONS(3015),
    [sym__identifier_token] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym_alias] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_global] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_unsafe] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_ref] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_interface] = ACTIONS(3013),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_record] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_file] = ACTIONS(3013),
    [anon_sym_fixed] = ACTIONS(3013),
    [anon_sym_internal] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_override] = ACTIONS(3013),
    [anon_sym_partial] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_readonly] = ACTIONS(3013),
    [anon_sym_required] = ACTIONS(3013),
    [anon_sym_sealed] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_where] = ACTIONS(3013),
    [anon_sym_notnull] = ACTIONS(3013),
    [anon_sym_unmanaged] = ACTIONS(3013),
    [anon_sym_checked] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_true] = ACTIONS(3013),
    [anon_sym_false] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_this] = ACTIONS(3013),
    [anon_sym_scoped] = ACTIONS(3013),
    [anon_sym_base] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [sym_predefined_type] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_unchecked] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_lock] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_catch] = ACTIONS(3044),
    [anon_sym_when] = ACTIONS(3013),
    [anon_sym_finally] = ACTIONS(3013),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_foreach] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_DOT_DOT] = ACTIONS(3015),
    [anon_sym_from] = ACTIONS(3013),
    [anon_sym_into] = ACTIONS(3013),
    [anon_sym_join] = ACTIONS(3013),
    [anon_sym_on] = ACTIONS(3013),
    [anon_sym_equals] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_orderby] = ACTIONS(3013),
    [anon_sym_ascending] = ACTIONS(3013),
    [anon_sym_descending] = ACTIONS(3013),
    [anon_sym_group] = ACTIONS(3013),
    [anon_sym_by] = ACTIONS(3013),
    [anon_sym_select] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_stackalloc] = ACTIONS(3013),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym___makeref] = ACTIONS(3013),
    [anon_sym___reftype] = ACTIONS(3013),
    [anon_sym___refvalue] = ACTIONS(3013),
    [sym_null_literal] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(3013),
    [sym_real_literal] = ACTIONS(3015),
    [sym_verbatim_string_literal] = ACTIONS(3015),
    [aux_sym_preproc_if_token1] = ACTIONS(3015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3015),
    [sym_interpolation_verbatim_start] = ACTIONS(3015),
    [sym_interpolation_raw_start] = ACTIONS(3015),
    [sym_raw_string_start] = ACTIONS(3015),
  },
  [2222] = {
    [sym_preproc_region] = STATE(2222),
    [sym_preproc_endregion] = STATE(2222),
    [sym_preproc_line] = STATE(2222),
    [sym_preproc_pragma] = STATE(2222),
    [sym_preproc_nullable] = STATE(2222),
    [sym_preproc_error] = STATE(2222),
    [sym_preproc_define] = STATE(2222),
    [sym_preproc_undef] = STATE(2222),
    [sym__identifier_token] = ACTIONS(3047),
    [anon_sym_extern] = ACTIONS(3047),
    [anon_sym_alias] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_global] = ACTIONS(3047),
    [anon_sym_using] = ACTIONS(3047),
    [anon_sym_unsafe] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_namespace] = ACTIONS(3047),
    [anon_sym_class] = ACTIONS(3047),
    [anon_sym_ref] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3047),
    [anon_sym_enum] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3047),
    [anon_sym_delegate] = ACTIONS(3047),
    [anon_sym_record] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_async] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_file] = ACTIONS(3047),
    [anon_sym_fixed] = ACTIONS(3047),
    [anon_sym_internal] = ACTIONS(3047),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_override] = ACTIONS(3047),
    [anon_sym_partial] = ACTIONS(3047),
    [anon_sym_private] = ACTIONS(3047),
    [anon_sym_protected] = ACTIONS(3047),
    [anon_sym_public] = ACTIONS(3047),
    [anon_sym_readonly] = ACTIONS(3047),
    [anon_sym_required] = ACTIONS(3047),
    [anon_sym_sealed] = ACTIONS(3047),
    [anon_sym_virtual] = ACTIONS(3047),
    [anon_sym_volatile] = ACTIONS(3047),
    [anon_sym_where] = ACTIONS(3047),
    [anon_sym_notnull] = ACTIONS(3047),
    [anon_sym_unmanaged] = ACTIONS(3047),
    [anon_sym_checked] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_true] = ACTIONS(3047),
    [anon_sym_false] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_this] = ACTIONS(3047),
    [anon_sym_scoped] = ACTIONS(3047),
    [anon_sym_base] = ACTIONS(3047),
    [anon_sym_var] = ACTIONS(3047),
    [sym_predefined_type] = ACTIONS(3047),
    [anon_sym_break] = ACTIONS(3047),
    [anon_sym_unchecked] = ACTIONS(3047),
    [anon_sym_continue] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_lock] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_switch] = ACTIONS(3047),
    [anon_sym_default] = ACTIONS(3047),
    [anon_sym_throw] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_when] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3047),
    [anon_sym_foreach] = ACTIONS(3047),
    [anon_sym_goto] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_from] = ACTIONS(3047),
    [anon_sym_into] = ACTIONS(3047),
    [anon_sym_join] = ACTIONS(3047),
    [anon_sym_on] = ACTIONS(3047),
    [anon_sym_equals] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_orderby] = ACTIONS(3047),
    [anon_sym_ascending] = ACTIONS(3047),
    [anon_sym_descending] = ACTIONS(3047),
    [anon_sym_group] = ACTIONS(3047),
    [anon_sym_by] = ACTIONS(3047),
    [anon_sym_select] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3047),
    [anon_sym_typeof] = ACTIONS(3047),
    [anon_sym___makeref] = ACTIONS(3047),
    [anon_sym___reftype] = ACTIONS(3047),
    [anon_sym___refvalue] = ACTIONS(3047),
    [sym_null_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_integer_literal] = ACTIONS(3047),
    [sym_real_literal] = ACTIONS(3049),
    [sym_verbatim_string_literal] = ACTIONS(3049),
    [aux_sym_preproc_if_token1] = ACTIONS(3049),
    [aux_sym_preproc_if_token3] = ACTIONS(3049),
    [aux_sym_preproc_else_token1] = ACTIONS(3049),
    [aux_sym_preproc_elif_token1] = ACTIONS(3049),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3049),
    [sym_interpolation_verbatim_start] = ACTIONS(3049),
    [sym_interpolation_raw_start] = ACTIONS(3049),
    [sym_raw_string_start] = ACTIONS(3049),
  },
  [2223] = {
    [sym_preproc_region] = STATE(2223),
    [sym_preproc_endregion] = STATE(2223),
    [sym_preproc_line] = STATE(2223),
    [sym_preproc_pragma] = STATE(2223),
    [sym_preproc_nullable] = STATE(2223),
    [sym_preproc_error] = STATE(2223),
    [sym_preproc_define] = STATE(2223),
    [sym_preproc_undef] = STATE(2223),
    [sym__identifier_token] = ACTIONS(3051),
    [anon_sym_extern] = ACTIONS(3051),
    [anon_sym_alias] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_global] = ACTIONS(3051),
    [anon_sym_using] = ACTIONS(3051),
    [anon_sym_unsafe] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_namespace] = ACTIONS(3051),
    [anon_sym_class] = ACTIONS(3051),
    [anon_sym_ref] = ACTIONS(3051),
    [anon_sym_struct] = ACTIONS(3051),
    [anon_sym_enum] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_interface] = ACTIONS(3051),
    [anon_sym_delegate] = ACTIONS(3051),
    [anon_sym_record] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_file] = ACTIONS(3051),
    [anon_sym_fixed] = ACTIONS(3051),
    [anon_sym_internal] = ACTIONS(3051),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_override] = ACTIONS(3051),
    [anon_sym_partial] = ACTIONS(3051),
    [anon_sym_private] = ACTIONS(3051),
    [anon_sym_protected] = ACTIONS(3051),
    [anon_sym_public] = ACTIONS(3051),
    [anon_sym_readonly] = ACTIONS(3051),
    [anon_sym_required] = ACTIONS(3051),
    [anon_sym_sealed] = ACTIONS(3051),
    [anon_sym_virtual] = ACTIONS(3051),
    [anon_sym_volatile] = ACTIONS(3051),
    [anon_sym_where] = ACTIONS(3051),
    [anon_sym_notnull] = ACTIONS(3051),
    [anon_sym_unmanaged] = ACTIONS(3051),
    [anon_sym_checked] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_true] = ACTIONS(3051),
    [anon_sym_false] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_this] = ACTIONS(3051),
    [anon_sym_scoped] = ACTIONS(3051),
    [anon_sym_base] = ACTIONS(3051),
    [anon_sym_var] = ACTIONS(3051),
    [sym_predefined_type] = ACTIONS(3051),
    [anon_sym_break] = ACTIONS(3051),
    [anon_sym_unchecked] = ACTIONS(3051),
    [anon_sym_continue] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_lock] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_switch] = ACTIONS(3051),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_throw] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_when] = ACTIONS(3051),
    [anon_sym_await] = ACTIONS(3051),
    [anon_sym_foreach] = ACTIONS(3051),
    [anon_sym_goto] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_from] = ACTIONS(3051),
    [anon_sym_into] = ACTIONS(3051),
    [anon_sym_join] = ACTIONS(3051),
    [anon_sym_on] = ACTIONS(3051),
    [anon_sym_equals] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_orderby] = ACTIONS(3051),
    [anon_sym_ascending] = ACTIONS(3051),
    [anon_sym_descending] = ACTIONS(3051),
    [anon_sym_group] = ACTIONS(3051),
    [anon_sym_by] = ACTIONS(3051),
    [anon_sym_select] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3051),
    [anon_sym_sizeof] = ACTIONS(3051),
    [anon_sym_typeof] = ACTIONS(3051),
    [anon_sym___makeref] = ACTIONS(3051),
    [anon_sym___reftype] = ACTIONS(3051),
    [anon_sym___refvalue] = ACTIONS(3051),
    [sym_null_literal] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [sym_integer_literal] = ACTIONS(3051),
    [sym_real_literal] = ACTIONS(3053),
    [sym_verbatim_string_literal] = ACTIONS(3053),
    [aux_sym_preproc_if_token1] = ACTIONS(3053),
    [aux_sym_preproc_if_token3] = ACTIONS(3053),
    [aux_sym_preproc_else_token1] = ACTIONS(3053),
    [aux_sym_preproc_elif_token1] = ACTIONS(3053),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3053),
    [sym_interpolation_verbatim_start] = ACTIONS(3053),
    [sym_interpolation_raw_start] = ACTIONS(3053),
    [sym_raw_string_start] = ACTIONS(3053),
  },
  [2224] = {
    [sym_preproc_region] = STATE(2224),
    [sym_preproc_endregion] = STATE(2224),
    [sym_preproc_line] = STATE(2224),
    [sym_preproc_pragma] = STATE(2224),
    [sym_preproc_nullable] = STATE(2224),
    [sym_preproc_error] = STATE(2224),
    [sym_preproc_define] = STATE(2224),
    [sym_preproc_undef] = STATE(2224),
    [sym__identifier_token] = ACTIONS(3055),
    [anon_sym_extern] = ACTIONS(3055),
    [anon_sym_alias] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_global] = ACTIONS(3055),
    [anon_sym_using] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_namespace] = ACTIONS(3055),
    [anon_sym_class] = ACTIONS(3055),
    [anon_sym_ref] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3057),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_delegate] = ACTIONS(3055),
    [anon_sym_record] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_file] = ACTIONS(3055),
    [anon_sym_fixed] = ACTIONS(3055),
    [anon_sym_internal] = ACTIONS(3055),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_override] = ACTIONS(3055),
    [anon_sym_partial] = ACTIONS(3055),
    [anon_sym_private] = ACTIONS(3055),
    [anon_sym_protected] = ACTIONS(3055),
    [anon_sym_public] = ACTIONS(3055),
    [anon_sym_readonly] = ACTIONS(3055),
    [anon_sym_required] = ACTIONS(3055),
    [anon_sym_sealed] = ACTIONS(3055),
    [anon_sym_virtual] = ACTIONS(3055),
    [anon_sym_volatile] = ACTIONS(3055),
    [anon_sym_where] = ACTIONS(3055),
    [anon_sym_notnull] = ACTIONS(3055),
    [anon_sym_unmanaged] = ACTIONS(3055),
    [anon_sym_checked] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3057),
    [anon_sym_true] = ACTIONS(3055),
    [anon_sym_false] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_this] = ACTIONS(3055),
    [anon_sym_scoped] = ACTIONS(3055),
    [anon_sym_base] = ACTIONS(3055),
    [anon_sym_var] = ACTIONS(3055),
    [sym_predefined_type] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_unchecked] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(3055),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_throw] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_when] = ACTIONS(3055),
    [anon_sym_await] = ACTIONS(3055),
    [anon_sym_foreach] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_from] = ACTIONS(3055),
    [anon_sym_into] = ACTIONS(3055),
    [anon_sym_join] = ACTIONS(3055),
    [anon_sym_on] = ACTIONS(3055),
    [anon_sym_equals] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_orderby] = ACTIONS(3055),
    [anon_sym_ascending] = ACTIONS(3055),
    [anon_sym_descending] = ACTIONS(3055),
    [anon_sym_group] = ACTIONS(3055),
    [anon_sym_by] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3055),
    [anon_sym_sizeof] = ACTIONS(3055),
    [anon_sym_typeof] = ACTIONS(3055),
    [anon_sym___makeref] = ACTIONS(3055),
    [anon_sym___reftype] = ACTIONS(3055),
    [anon_sym___refvalue] = ACTIONS(3055),
    [sym_null_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_integer_literal] = ACTIONS(3055),
    [sym_real_literal] = ACTIONS(3057),
    [sym_verbatim_string_literal] = ACTIONS(3057),
    [aux_sym_preproc_if_token1] = ACTIONS(3057),
    [aux_sym_preproc_if_token3] = ACTIONS(3057),
    [aux_sym_preproc_else_token1] = ACTIONS(3057),
    [aux_sym_preproc_elif_token1] = ACTIONS(3057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3057),
    [sym_interpolation_verbatim_start] = ACTIONS(3057),
    [sym_interpolation_raw_start] = ACTIONS(3057),
    [sym_raw_string_start] = ACTIONS(3057),
  },
  [2225] = {
    [sym_preproc_region] = STATE(2225),
    [sym_preproc_endregion] = STATE(2225),
    [sym_preproc_line] = STATE(2225),
    [sym_preproc_pragma] = STATE(2225),
    [sym_preproc_nullable] = STATE(2225),
    [sym_preproc_error] = STATE(2225),
    [sym_preproc_define] = STATE(2225),
    [sym_preproc_undef] = STATE(2225),
    [sym__identifier_token] = ACTIONS(3059),
    [anon_sym_extern] = ACTIONS(3059),
    [anon_sym_alias] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_global] = ACTIONS(3059),
    [anon_sym_using] = ACTIONS(3059),
    [anon_sym_unsafe] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_namespace] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_ref] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3059),
    [anon_sym_enum] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_interface] = ACTIONS(3059),
    [anon_sym_delegate] = ACTIONS(3059),
    [anon_sym_record] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_file] = ACTIONS(3059),
    [anon_sym_fixed] = ACTIONS(3059),
    [anon_sym_internal] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_override] = ACTIONS(3059),
    [anon_sym_partial] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3059),
    [anon_sym_protected] = ACTIONS(3059),
    [anon_sym_public] = ACTIONS(3059),
    [anon_sym_readonly] = ACTIONS(3059),
    [anon_sym_required] = ACTIONS(3059),
    [anon_sym_sealed] = ACTIONS(3059),
    [anon_sym_virtual] = ACTIONS(3059),
    [anon_sym_volatile] = ACTIONS(3059),
    [anon_sym_where] = ACTIONS(3059),
    [anon_sym_notnull] = ACTIONS(3059),
    [anon_sym_unmanaged] = ACTIONS(3059),
    [anon_sym_checked] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_true] = ACTIONS(3059),
    [anon_sym_false] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_this] = ACTIONS(3059),
    [anon_sym_scoped] = ACTIONS(3059),
    [anon_sym_base] = ACTIONS(3059),
    [anon_sym_var] = ACTIONS(3059),
    [sym_predefined_type] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_unchecked] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_lock] = ACTIONS(3059),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_throw] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_when] = ACTIONS(3059),
    [anon_sym_await] = ACTIONS(3059),
    [anon_sym_foreach] = ACTIONS(3059),
    [anon_sym_goto] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_from] = ACTIONS(3059),
    [anon_sym_into] = ACTIONS(3059),
    [anon_sym_join] = ACTIONS(3059),
    [anon_sym_on] = ACTIONS(3059),
    [anon_sym_equals] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_orderby] = ACTIONS(3059),
    [anon_sym_ascending] = ACTIONS(3059),
    [anon_sym_descending] = ACTIONS(3059),
    [anon_sym_group] = ACTIONS(3059),
    [anon_sym_by] = ACTIONS(3059),
    [anon_sym_select] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3059),
    [anon_sym_sizeof] = ACTIONS(3059),
    [anon_sym_typeof] = ACTIONS(3059),
    [anon_sym___makeref] = ACTIONS(3059),
    [anon_sym___reftype] = ACTIONS(3059),
    [anon_sym___refvalue] = ACTIONS(3059),
    [sym_null_literal] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [sym_integer_literal] = ACTIONS(3059),
    [sym_real_literal] = ACTIONS(3061),
    [sym_verbatim_string_literal] = ACTIONS(3061),
    [aux_sym_preproc_if_token1] = ACTIONS(3061),
    [aux_sym_preproc_if_token3] = ACTIONS(3061),
    [aux_sym_preproc_else_token1] = ACTIONS(3061),
    [aux_sym_preproc_elif_token1] = ACTIONS(3061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3061),
    [sym_interpolation_verbatim_start] = ACTIONS(3061),
    [sym_interpolation_raw_start] = ACTIONS(3061),
    [sym_raw_string_start] = ACTIONS(3061),
  },
  [2226] = {
    [sym_preproc_region] = STATE(2226),
    [sym_preproc_endregion] = STATE(2226),
    [sym_preproc_line] = STATE(2226),
    [sym_preproc_pragma] = STATE(2226),
    [sym_preproc_nullable] = STATE(2226),
    [sym_preproc_error] = STATE(2226),
    [sym_preproc_define] = STATE(2226),
    [sym_preproc_undef] = STATE(2226),
    [sym__identifier_token] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym_alias] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_global] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_unsafe] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_interface] = ACTIONS(3063),
    [anon_sym_delegate] = ACTIONS(3063),
    [anon_sym_record] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_file] = ACTIONS(3063),
    [anon_sym_fixed] = ACTIONS(3063),
    [anon_sym_internal] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_override] = ACTIONS(3063),
    [anon_sym_partial] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_readonly] = ACTIONS(3063),
    [anon_sym_required] = ACTIONS(3063),
    [anon_sym_sealed] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_notnull] = ACTIONS(3063),
    [anon_sym_unmanaged] = ACTIONS(3063),
    [anon_sym_checked] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_true] = ACTIONS(3063),
    [anon_sym_false] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_this] = ACTIONS(3063),
    [anon_sym_scoped] = ACTIONS(3063),
    [anon_sym_base] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [sym_predefined_type] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_unchecked] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_when] = ACTIONS(3063),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_from] = ACTIONS(3063),
    [anon_sym_into] = ACTIONS(3063),
    [anon_sym_join] = ACTIONS(3063),
    [anon_sym_on] = ACTIONS(3063),
    [anon_sym_equals] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_orderby] = ACTIONS(3063),
    [anon_sym_ascending] = ACTIONS(3063),
    [anon_sym_descending] = ACTIONS(3063),
    [anon_sym_group] = ACTIONS(3063),
    [anon_sym_by] = ACTIONS(3063),
    [anon_sym_select] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym___makeref] = ACTIONS(3063),
    [anon_sym___reftype] = ACTIONS(3063),
    [anon_sym___refvalue] = ACTIONS(3063),
    [sym_null_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_integer_literal] = ACTIONS(3063),
    [sym_real_literal] = ACTIONS(3065),
    [sym_verbatim_string_literal] = ACTIONS(3065),
    [aux_sym_preproc_if_token1] = ACTIONS(3065),
    [aux_sym_preproc_if_token3] = ACTIONS(3065),
    [aux_sym_preproc_else_token1] = ACTIONS(3065),
    [aux_sym_preproc_elif_token1] = ACTIONS(3065),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3065),
    [sym_interpolation_verbatim_start] = ACTIONS(3065),
    [sym_interpolation_raw_start] = ACTIONS(3065),
    [sym_raw_string_start] = ACTIONS(3065),
  },
  [2227] = {
    [sym_preproc_region] = STATE(2227),
    [sym_preproc_endregion] = STATE(2227),
    [sym_preproc_line] = STATE(2227),
    [sym_preproc_pragma] = STATE(2227),
    [sym_preproc_nullable] = STATE(2227),
    [sym_preproc_error] = STATE(2227),
    [sym_preproc_define] = STATE(2227),
    [sym_preproc_undef] = STATE(2227),
    [sym__identifier_token] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym_alias] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_global] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_unsafe] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_ref] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_interface] = ACTIONS(3067),
    [anon_sym_delegate] = ACTIONS(3067),
    [anon_sym_record] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_file] = ACTIONS(3067),
    [anon_sym_fixed] = ACTIONS(3067),
    [anon_sym_internal] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_override] = ACTIONS(3067),
    [anon_sym_partial] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_readonly] = ACTIONS(3067),
    [anon_sym_required] = ACTIONS(3067),
    [anon_sym_sealed] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_where] = ACTIONS(3067),
    [anon_sym_notnull] = ACTIONS(3067),
    [anon_sym_unmanaged] = ACTIONS(3067),
    [anon_sym_checked] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_true] = ACTIONS(3067),
    [anon_sym_false] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_this] = ACTIONS(3067),
    [anon_sym_scoped] = ACTIONS(3067),
    [anon_sym_base] = ACTIONS(3067),
    [anon_sym_var] = ACTIONS(3067),
    [sym_predefined_type] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_unchecked] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_lock] = ACTIONS(3067),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(3067),
    [anon_sym_await] = ACTIONS(3067),
    [anon_sym_foreach] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_from] = ACTIONS(3067),
    [anon_sym_into] = ACTIONS(3067),
    [anon_sym_join] = ACTIONS(3067),
    [anon_sym_on] = ACTIONS(3067),
    [anon_sym_equals] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_orderby] = ACTIONS(3067),
    [anon_sym_ascending] = ACTIONS(3067),
    [anon_sym_descending] = ACTIONS(3067),
    [anon_sym_group] = ACTIONS(3067),
    [anon_sym_by] = ACTIONS(3067),
    [anon_sym_select] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3067),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym_typeof] = ACTIONS(3067),
    [anon_sym___makeref] = ACTIONS(3067),
    [anon_sym___reftype] = ACTIONS(3067),
    [anon_sym___refvalue] = ACTIONS(3067),
    [sym_null_literal] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [sym_integer_literal] = ACTIONS(3067),
    [sym_real_literal] = ACTIONS(3069),
    [sym_verbatim_string_literal] = ACTIONS(3069),
    [aux_sym_preproc_if_token1] = ACTIONS(3069),
    [aux_sym_preproc_if_token3] = ACTIONS(3069),
    [aux_sym_preproc_else_token1] = ACTIONS(3069),
    [aux_sym_preproc_elif_token1] = ACTIONS(3069),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3069),
    [sym_interpolation_verbatim_start] = ACTIONS(3069),
    [sym_interpolation_raw_start] = ACTIONS(3069),
    [sym_raw_string_start] = ACTIONS(3069),
  },
  [2228] = {
    [sym_preproc_region] = STATE(2228),
    [sym_preproc_endregion] = STATE(2228),
    [sym_preproc_line] = STATE(2228),
    [sym_preproc_pragma] = STATE(2228),
    [sym_preproc_nullable] = STATE(2228),
    [sym_preproc_error] = STATE(2228),
    [sym_preproc_define] = STATE(2228),
    [sym_preproc_undef] = STATE(2228),
    [ts_builtin_sym_end] = ACTIONS(2987),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_catch] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_finally] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2229] = {
    [sym_preproc_region] = STATE(2229),
    [sym_preproc_endregion] = STATE(2229),
    [sym_preproc_line] = STATE(2229),
    [sym_preproc_pragma] = STATE(2229),
    [sym_preproc_nullable] = STATE(2229),
    [sym_preproc_error] = STATE(2229),
    [sym_preproc_define] = STATE(2229),
    [sym_preproc_undef] = STATE(2229),
    [sym__identifier_token] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym_alias] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_unsafe] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_ref] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_interface] = ACTIONS(3071),
    [anon_sym_delegate] = ACTIONS(3071),
    [anon_sym_record] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_file] = ACTIONS(3071),
    [anon_sym_fixed] = ACTIONS(3071),
    [anon_sym_internal] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_override] = ACTIONS(3071),
    [anon_sym_partial] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_readonly] = ACTIONS(3071),
    [anon_sym_required] = ACTIONS(3071),
    [anon_sym_sealed] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_notnull] = ACTIONS(3071),
    [anon_sym_unmanaged] = ACTIONS(3071),
    [anon_sym_checked] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_this] = ACTIONS(3071),
    [anon_sym_scoped] = ACTIONS(3071),
    [anon_sym_base] = ACTIONS(3071),
    [anon_sym_var] = ACTIONS(3071),
    [sym_predefined_type] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_unchecked] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_lock] = ACTIONS(3071),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_when] = ACTIONS(3071),
    [anon_sym_await] = ACTIONS(3071),
    [anon_sym_foreach] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_from] = ACTIONS(3071),
    [anon_sym_into] = ACTIONS(3071),
    [anon_sym_join] = ACTIONS(3071),
    [anon_sym_on] = ACTIONS(3071),
    [anon_sym_equals] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_orderby] = ACTIONS(3071),
    [anon_sym_ascending] = ACTIONS(3071),
    [anon_sym_descending] = ACTIONS(3071),
    [anon_sym_group] = ACTIONS(3071),
    [anon_sym_by] = ACTIONS(3071),
    [anon_sym_select] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3071),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym_typeof] = ACTIONS(3071),
    [anon_sym___makeref] = ACTIONS(3071),
    [anon_sym___reftype] = ACTIONS(3071),
    [anon_sym___refvalue] = ACTIONS(3071),
    [sym_null_literal] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [sym_integer_literal] = ACTIONS(3071),
    [sym_real_literal] = ACTIONS(3073),
    [sym_verbatim_string_literal] = ACTIONS(3073),
    [aux_sym_preproc_if_token1] = ACTIONS(3073),
    [aux_sym_preproc_if_token3] = ACTIONS(3073),
    [aux_sym_preproc_else_token1] = ACTIONS(3073),
    [aux_sym_preproc_elif_token1] = ACTIONS(3073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3073),
    [sym_interpolation_verbatim_start] = ACTIONS(3073),
    [sym_interpolation_raw_start] = ACTIONS(3073),
    [sym_raw_string_start] = ACTIONS(3073),
  },
  [2230] = {
    [sym_preproc_region] = STATE(2230),
    [sym_preproc_endregion] = STATE(2230),
    [sym_preproc_line] = STATE(2230),
    [sym_preproc_pragma] = STATE(2230),
    [sym_preproc_nullable] = STATE(2230),
    [sym_preproc_error] = STATE(2230),
    [sym_preproc_define] = STATE(2230),
    [sym_preproc_undef] = STATE(2230),
    [sym__identifier_token] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym_alias] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_global] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_unsafe] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_ref] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_interface] = ACTIONS(3075),
    [anon_sym_delegate] = ACTIONS(3075),
    [anon_sym_record] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_file] = ACTIONS(3075),
    [anon_sym_fixed] = ACTIONS(3075),
    [anon_sym_internal] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_partial] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_required] = ACTIONS(3075),
    [anon_sym_sealed] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_notnull] = ACTIONS(3075),
    [anon_sym_unmanaged] = ACTIONS(3075),
    [anon_sym_checked] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_true] = ACTIONS(3075),
    [anon_sym_false] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_this] = ACTIONS(3075),
    [anon_sym_scoped] = ACTIONS(3075),
    [anon_sym_base] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [sym_predefined_type] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_unchecked] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_lock] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_when] = ACTIONS(3075),
    [anon_sym_await] = ACTIONS(3075),
    [anon_sym_foreach] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_into] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_ascending] = ACTIONS(3075),
    [anon_sym_descending] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3075),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym___makeref] = ACTIONS(3075),
    [anon_sym___reftype] = ACTIONS(3075),
    [anon_sym___refvalue] = ACTIONS(3075),
    [sym_null_literal] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [sym_integer_literal] = ACTIONS(3075),
    [sym_real_literal] = ACTIONS(3077),
    [sym_verbatim_string_literal] = ACTIONS(3077),
    [aux_sym_preproc_if_token1] = ACTIONS(3077),
    [aux_sym_preproc_if_token3] = ACTIONS(3077),
    [aux_sym_preproc_else_token1] = ACTIONS(3077),
    [aux_sym_preproc_elif_token1] = ACTIONS(3077),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3077),
    [sym_interpolation_verbatim_start] = ACTIONS(3077),
    [sym_interpolation_raw_start] = ACTIONS(3077),
    [sym_raw_string_start] = ACTIONS(3077),
  },
  [2231] = {
    [sym_preproc_region] = STATE(2231),
    [sym_preproc_endregion] = STATE(2231),
    [sym_preproc_line] = STATE(2231),
    [sym_preproc_pragma] = STATE(2231),
    [sym_preproc_nullable] = STATE(2231),
    [sym_preproc_error] = STATE(2231),
    [sym_preproc_define] = STATE(2231),
    [sym_preproc_undef] = STATE(2231),
    [sym__identifier_token] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym_alias] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_global] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_unsafe] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_ref] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_interface] = ACTIONS(3079),
    [anon_sym_delegate] = ACTIONS(3079),
    [anon_sym_record] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_file] = ACTIONS(3079),
    [anon_sym_fixed] = ACTIONS(3079),
    [anon_sym_internal] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_override] = ACTIONS(3079),
    [anon_sym_partial] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_required] = ACTIONS(3079),
    [anon_sym_sealed] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_where] = ACTIONS(3079),
    [anon_sym_notnull] = ACTIONS(3079),
    [anon_sym_unmanaged] = ACTIONS(3079),
    [anon_sym_checked] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_true] = ACTIONS(3079),
    [anon_sym_false] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_CARET] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym_this] = ACTIONS(3079),
    [anon_sym_scoped] = ACTIONS(3079),
    [anon_sym_base] = ACTIONS(3079),
    [anon_sym_var] = ACTIONS(3079),
    [sym_predefined_type] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_unchecked] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_lock] = ACTIONS(3079),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_when] = ACTIONS(3079),
    [anon_sym_await] = ACTIONS(3079),
    [anon_sym_foreach] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_else] = ACTIONS(3079),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_from] = ACTIONS(3079),
    [anon_sym_into] = ACTIONS(3079),
    [anon_sym_join] = ACTIONS(3079),
    [anon_sym_on] = ACTIONS(3079),
    [anon_sym_equals] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_orderby] = ACTIONS(3079),
    [anon_sym_ascending] = ACTIONS(3079),
    [anon_sym_descending] = ACTIONS(3079),
    [anon_sym_group] = ACTIONS(3079),
    [anon_sym_by] = ACTIONS(3079),
    [anon_sym_select] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3079),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym_typeof] = ACTIONS(3079),
    [anon_sym___makeref] = ACTIONS(3079),
    [anon_sym___reftype] = ACTIONS(3079),
    [anon_sym___refvalue] = ACTIONS(3079),
    [sym_null_literal] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [sym_integer_literal] = ACTIONS(3079),
    [sym_real_literal] = ACTIONS(3081),
    [sym_verbatim_string_literal] = ACTIONS(3081),
    [aux_sym_preproc_if_token1] = ACTIONS(3081),
    [aux_sym_preproc_if_token3] = ACTIONS(3081),
    [aux_sym_preproc_else_token1] = ACTIONS(3081),
    [aux_sym_preproc_elif_token1] = ACTIONS(3081),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3081),
    [sym_interpolation_verbatim_start] = ACTIONS(3081),
    [sym_interpolation_raw_start] = ACTIONS(3081),
    [sym_raw_string_start] = ACTIONS(3081),
  },
  [2232] = {
    [sym_preproc_region] = STATE(2232),
    [sym_preproc_endregion] = STATE(2232),
    [sym_preproc_line] = STATE(2232),
    [sym_preproc_pragma] = STATE(2232),
    [sym_preproc_nullable] = STATE(2232),
    [sym_preproc_error] = STATE(2232),
    [sym_preproc_define] = STATE(2232),
    [sym_preproc_undef] = STATE(2232),
    [sym__identifier_token] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym_alias] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_global] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_unsafe] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_ref] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_interface] = ACTIONS(3083),
    [anon_sym_delegate] = ACTIONS(3083),
    [anon_sym_record] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_file] = ACTIONS(3083),
    [anon_sym_fixed] = ACTIONS(3083),
    [anon_sym_internal] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3083),
    [anon_sym_partial] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_readonly] = ACTIONS(3083),
    [anon_sym_required] = ACTIONS(3083),
    [anon_sym_sealed] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_where] = ACTIONS(3083),
    [anon_sym_notnull] = ACTIONS(3083),
    [anon_sym_unmanaged] = ACTIONS(3083),
    [anon_sym_checked] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_true] = ACTIONS(3083),
    [anon_sym_false] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_this] = ACTIONS(3083),
    [anon_sym_scoped] = ACTIONS(3083),
    [anon_sym_base] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [sym_predefined_type] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_unchecked] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_lock] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_when] = ACTIONS(3083),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_foreach] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_from] = ACTIONS(3083),
    [anon_sym_into] = ACTIONS(3083),
    [anon_sym_join] = ACTIONS(3083),
    [anon_sym_on] = ACTIONS(3083),
    [anon_sym_equals] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_orderby] = ACTIONS(3083),
    [anon_sym_ascending] = ACTIONS(3083),
    [anon_sym_descending] = ACTIONS(3083),
    [anon_sym_group] = ACTIONS(3083),
    [anon_sym_by] = ACTIONS(3083),
    [anon_sym_select] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3083),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym___makeref] = ACTIONS(3083),
    [anon_sym___reftype] = ACTIONS(3083),
    [anon_sym___refvalue] = ACTIONS(3083),
    [sym_null_literal] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [sym_integer_literal] = ACTIONS(3083),
    [sym_real_literal] = ACTIONS(3085),
    [sym_verbatim_string_literal] = ACTIONS(3085),
    [aux_sym_preproc_if_token1] = ACTIONS(3085),
    [aux_sym_preproc_if_token3] = ACTIONS(3085),
    [aux_sym_preproc_else_token1] = ACTIONS(3085),
    [aux_sym_preproc_elif_token1] = ACTIONS(3085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3085),
    [sym_interpolation_verbatim_start] = ACTIONS(3085),
    [sym_interpolation_raw_start] = ACTIONS(3085),
    [sym_raw_string_start] = ACTIONS(3085),
  },
  [2233] = {
    [sym_preproc_region] = STATE(2233),
    [sym_preproc_endregion] = STATE(2233),
    [sym_preproc_line] = STATE(2233),
    [sym_preproc_pragma] = STATE(2233),
    [sym_preproc_nullable] = STATE(2233),
    [sym_preproc_error] = STATE(2233),
    [sym_preproc_define] = STATE(2233),
    [sym_preproc_undef] = STATE(2233),
    [sym__identifier_token] = ACTIONS(3087),
    [anon_sym_extern] = ACTIONS(3087),
    [anon_sym_alias] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_global] = ACTIONS(3087),
    [anon_sym_using] = ACTIONS(3087),
    [anon_sym_unsafe] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_class] = ACTIONS(3087),
    [anon_sym_ref] = ACTIONS(3087),
    [anon_sym_struct] = ACTIONS(3087),
    [anon_sym_enum] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_interface] = ACTIONS(3087),
    [anon_sym_delegate] = ACTIONS(3087),
    [anon_sym_record] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_file] = ACTIONS(3087),
    [anon_sym_fixed] = ACTIONS(3087),
    [anon_sym_internal] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_partial] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_required] = ACTIONS(3087),
    [anon_sym_sealed] = ACTIONS(3087),
    [anon_sym_virtual] = ACTIONS(3087),
    [anon_sym_volatile] = ACTIONS(3087),
    [anon_sym_where] = ACTIONS(3087),
    [anon_sym_notnull] = ACTIONS(3087),
    [anon_sym_unmanaged] = ACTIONS(3087),
    [anon_sym_checked] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_true] = ACTIONS(3087),
    [anon_sym_false] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_CARET] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_this] = ACTIONS(3087),
    [anon_sym_scoped] = ACTIONS(3087),
    [anon_sym_base] = ACTIONS(3087),
    [anon_sym_var] = ACTIONS(3087),
    [sym_predefined_type] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_unchecked] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_lock] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_await] = ACTIONS(3087),
    [anon_sym_foreach] = ACTIONS(3087),
    [anon_sym_goto] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_from] = ACTIONS(3087),
    [anon_sym_into] = ACTIONS(3087),
    [anon_sym_join] = ACTIONS(3087),
    [anon_sym_on] = ACTIONS(3087),
    [anon_sym_equals] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_orderby] = ACTIONS(3087),
    [anon_sym_ascending] = ACTIONS(3087),
    [anon_sym_descending] = ACTIONS(3087),
    [anon_sym_group] = ACTIONS(3087),
    [anon_sym_by] = ACTIONS(3087),
    [anon_sym_select] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3087),
    [anon_sym_sizeof] = ACTIONS(3087),
    [anon_sym_typeof] = ACTIONS(3087),
    [anon_sym___makeref] = ACTIONS(3087),
    [anon_sym___reftype] = ACTIONS(3087),
    [anon_sym___refvalue] = ACTIONS(3087),
    [sym_null_literal] = ACTIONS(3087),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [sym_integer_literal] = ACTIONS(3087),
    [sym_real_literal] = ACTIONS(3089),
    [sym_verbatim_string_literal] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_if_token3] = ACTIONS(3089),
    [aux_sym_preproc_else_token1] = ACTIONS(3089),
    [aux_sym_preproc_elif_token1] = ACTIONS(3089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3089),
    [sym_interpolation_verbatim_start] = ACTIONS(3089),
    [sym_interpolation_raw_start] = ACTIONS(3089),
    [sym_raw_string_start] = ACTIONS(3089),
  },
  [2234] = {
    [sym_preproc_region] = STATE(2234),
    [sym_preproc_endregion] = STATE(2234),
    [sym_preproc_line] = STATE(2234),
    [sym_preproc_pragma] = STATE(2234),
    [sym_preproc_nullable] = STATE(2234),
    [sym_preproc_error] = STATE(2234),
    [sym_preproc_define] = STATE(2234),
    [sym_preproc_undef] = STATE(2234),
    [sym__identifier_token] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_alias] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_unsafe] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_ref] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_interface] = ACTIONS(3091),
    [anon_sym_delegate] = ACTIONS(3091),
    [anon_sym_record] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_file] = ACTIONS(3091),
    [anon_sym_fixed] = ACTIONS(3091),
    [anon_sym_internal] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [anon_sym_partial] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_required] = ACTIONS(3091),
    [anon_sym_sealed] = ACTIONS(3091),
    [anon_sym_virtual] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym_where] = ACTIONS(3091),
    [anon_sym_notnull] = ACTIONS(3091),
    [anon_sym_unmanaged] = ACTIONS(3091),
    [anon_sym_checked] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_true] = ACTIONS(3091),
    [anon_sym_false] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_this] = ACTIONS(3091),
    [anon_sym_scoped] = ACTIONS(3091),
    [anon_sym_base] = ACTIONS(3091),
    [anon_sym_var] = ACTIONS(3091),
    [sym_predefined_type] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_unchecked] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_lock] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_when] = ACTIONS(3091),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_foreach] = ACTIONS(3091),
    [anon_sym_goto] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_else] = ACTIONS(3091),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_from] = ACTIONS(3091),
    [anon_sym_into] = ACTIONS(3091),
    [anon_sym_join] = ACTIONS(3091),
    [anon_sym_on] = ACTIONS(3091),
    [anon_sym_equals] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_orderby] = ACTIONS(3091),
    [anon_sym_ascending] = ACTIONS(3091),
    [anon_sym_descending] = ACTIONS(3091),
    [anon_sym_group] = ACTIONS(3091),
    [anon_sym_by] = ACTIONS(3091),
    [anon_sym_select] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3091),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym___makeref] = ACTIONS(3091),
    [anon_sym___reftype] = ACTIONS(3091),
    [anon_sym___refvalue] = ACTIONS(3091),
    [sym_null_literal] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [sym_integer_literal] = ACTIONS(3091),
    [sym_real_literal] = ACTIONS(3093),
    [sym_verbatim_string_literal] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_if_token3] = ACTIONS(3093),
    [aux_sym_preproc_else_token1] = ACTIONS(3093),
    [aux_sym_preproc_elif_token1] = ACTIONS(3093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3093),
    [sym_interpolation_verbatim_start] = ACTIONS(3093),
    [sym_interpolation_raw_start] = ACTIONS(3093),
    [sym_raw_string_start] = ACTIONS(3093),
  },
  [2235] = {
    [sym_preproc_region] = STATE(2235),
    [sym_preproc_endregion] = STATE(2235),
    [sym_preproc_line] = STATE(2235),
    [sym_preproc_pragma] = STATE(2235),
    [sym_preproc_nullable] = STATE(2235),
    [sym_preproc_error] = STATE(2235),
    [sym_preproc_define] = STATE(2235),
    [sym_preproc_undef] = STATE(2235),
    [sym__identifier_token] = ACTIONS(3095),
    [anon_sym_extern] = ACTIONS(3095),
    [anon_sym_alias] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_using] = ACTIONS(3095),
    [anon_sym_unsafe] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_class] = ACTIONS(3095),
    [anon_sym_ref] = ACTIONS(3095),
    [anon_sym_struct] = ACTIONS(3095),
    [anon_sym_enum] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_interface] = ACTIONS(3095),
    [anon_sym_delegate] = ACTIONS(3095),
    [anon_sym_record] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_file] = ACTIONS(3095),
    [anon_sym_fixed] = ACTIONS(3095),
    [anon_sym_internal] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [anon_sym_partial] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_sealed] = ACTIONS(3095),
    [anon_sym_virtual] = ACTIONS(3095),
    [anon_sym_volatile] = ACTIONS(3095),
    [anon_sym_where] = ACTIONS(3095),
    [anon_sym_notnull] = ACTIONS(3095),
    [anon_sym_unmanaged] = ACTIONS(3095),
    [anon_sym_checked] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_true] = ACTIONS(3095),
    [anon_sym_false] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_this] = ACTIONS(3095),
    [anon_sym_scoped] = ACTIONS(3095),
    [anon_sym_base] = ACTIONS(3095),
    [anon_sym_var] = ACTIONS(3095),
    [sym_predefined_type] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_unchecked] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_lock] = ACTIONS(3095),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_await] = ACTIONS(3095),
    [anon_sym_foreach] = ACTIONS(3095),
    [anon_sym_goto] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_into] = ACTIONS(3095),
    [anon_sym_join] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_equals] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_orderby] = ACTIONS(3095),
    [anon_sym_ascending] = ACTIONS(3095),
    [anon_sym_descending] = ACTIONS(3095),
    [anon_sym_group] = ACTIONS(3095),
    [anon_sym_by] = ACTIONS(3095),
    [anon_sym_select] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3095),
    [anon_sym_typeof] = ACTIONS(3095),
    [anon_sym___makeref] = ACTIONS(3095),
    [anon_sym___reftype] = ACTIONS(3095),
    [anon_sym___refvalue] = ACTIONS(3095),
    [sym_null_literal] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [sym_integer_literal] = ACTIONS(3095),
    [sym_real_literal] = ACTIONS(3097),
    [sym_verbatim_string_literal] = ACTIONS(3097),
    [aux_sym_preproc_if_token1] = ACTIONS(3097),
    [aux_sym_preproc_if_token3] = ACTIONS(3097),
    [aux_sym_preproc_else_token1] = ACTIONS(3097),
    [aux_sym_preproc_elif_token1] = ACTIONS(3097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3097),
    [sym_interpolation_verbatim_start] = ACTIONS(3097),
    [sym_interpolation_raw_start] = ACTIONS(3097),
    [sym_raw_string_start] = ACTIONS(3097),
  },
  [2236] = {
    [sym_preproc_region] = STATE(2236),
    [sym_preproc_endregion] = STATE(2236),
    [sym_preproc_line] = STATE(2236),
    [sym_preproc_pragma] = STATE(2236),
    [sym_preproc_nullable] = STATE(2236),
    [sym_preproc_error] = STATE(2236),
    [sym_preproc_define] = STATE(2236),
    [sym_preproc_undef] = STATE(2236),
    [sym__identifier_token] = ACTIONS(3099),
    [anon_sym_extern] = ACTIONS(3099),
    [anon_sym_alias] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_global] = ACTIONS(3099),
    [anon_sym_using] = ACTIONS(3099),
    [anon_sym_unsafe] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_class] = ACTIONS(3099),
    [anon_sym_ref] = ACTIONS(3099),
    [anon_sym_struct] = ACTIONS(3099),
    [anon_sym_enum] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_interface] = ACTIONS(3099),
    [anon_sym_delegate] = ACTIONS(3099),
    [anon_sym_record] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_file] = ACTIONS(3099),
    [anon_sym_fixed] = ACTIONS(3099),
    [anon_sym_internal] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_partial] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_required] = ACTIONS(3099),
    [anon_sym_sealed] = ACTIONS(3099),
    [anon_sym_virtual] = ACTIONS(3099),
    [anon_sym_volatile] = ACTIONS(3099),
    [anon_sym_where] = ACTIONS(3099),
    [anon_sym_notnull] = ACTIONS(3099),
    [anon_sym_unmanaged] = ACTIONS(3099),
    [anon_sym_checked] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_true] = ACTIONS(3099),
    [anon_sym_false] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_this] = ACTIONS(3099),
    [anon_sym_scoped] = ACTIONS(3099),
    [anon_sym_base] = ACTIONS(3099),
    [anon_sym_var] = ACTIONS(3099),
    [sym_predefined_type] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_unchecked] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_lock] = ACTIONS(3099),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_when] = ACTIONS(3099),
    [anon_sym_await] = ACTIONS(3099),
    [anon_sym_foreach] = ACTIONS(3099),
    [anon_sym_goto] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3099),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_from] = ACTIONS(3099),
    [anon_sym_into] = ACTIONS(3099),
    [anon_sym_join] = ACTIONS(3099),
    [anon_sym_on] = ACTIONS(3099),
    [anon_sym_equals] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_orderby] = ACTIONS(3099),
    [anon_sym_ascending] = ACTIONS(3099),
    [anon_sym_descending] = ACTIONS(3099),
    [anon_sym_group] = ACTIONS(3099),
    [anon_sym_by] = ACTIONS(3099),
    [anon_sym_select] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3099),
    [anon_sym_sizeof] = ACTIONS(3099),
    [anon_sym_typeof] = ACTIONS(3099),
    [anon_sym___makeref] = ACTIONS(3099),
    [anon_sym___reftype] = ACTIONS(3099),
    [anon_sym___refvalue] = ACTIONS(3099),
    [sym_null_literal] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [sym_integer_literal] = ACTIONS(3099),
    [sym_real_literal] = ACTIONS(3101),
    [sym_verbatim_string_literal] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_if_token3] = ACTIONS(3101),
    [aux_sym_preproc_else_token1] = ACTIONS(3101),
    [aux_sym_preproc_elif_token1] = ACTIONS(3101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3101),
    [sym_interpolation_verbatim_start] = ACTIONS(3101),
    [sym_interpolation_raw_start] = ACTIONS(3101),
    [sym_raw_string_start] = ACTIONS(3101),
  },
  [2237] = {
    [sym_preproc_region] = STATE(2237),
    [sym_preproc_endregion] = STATE(2237),
    [sym_preproc_line] = STATE(2237),
    [sym_preproc_pragma] = STATE(2237),
    [sym_preproc_nullable] = STATE(2237),
    [sym_preproc_error] = STATE(2237),
    [sym_preproc_define] = STATE(2237),
    [sym_preproc_undef] = STATE(2237),
    [sym__identifier_token] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym_alias] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_global] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3103),
    [anon_sym_unsafe] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_ref] = ACTIONS(3103),
    [anon_sym_struct] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_interface] = ACTIONS(3103),
    [anon_sym_delegate] = ACTIONS(3103),
    [anon_sym_record] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_file] = ACTIONS(3103),
    [anon_sym_fixed] = ACTIONS(3103),
    [anon_sym_internal] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_partial] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_required] = ACTIONS(3103),
    [anon_sym_sealed] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_where] = ACTIONS(3103),
    [anon_sym_notnull] = ACTIONS(3103),
    [anon_sym_unmanaged] = ACTIONS(3103),
    [anon_sym_checked] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_true] = ACTIONS(3103),
    [anon_sym_false] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_this] = ACTIONS(3103),
    [anon_sym_scoped] = ACTIONS(3103),
    [anon_sym_base] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [sym_predefined_type] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_unchecked] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_lock] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_when] = ACTIONS(3103),
    [anon_sym_await] = ACTIONS(3103),
    [anon_sym_foreach] = ACTIONS(3103),
    [anon_sym_goto] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_from] = ACTIONS(3103),
    [anon_sym_into] = ACTIONS(3103),
    [anon_sym_join] = ACTIONS(3103),
    [anon_sym_on] = ACTIONS(3103),
    [anon_sym_equals] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_orderby] = ACTIONS(3103),
    [anon_sym_ascending] = ACTIONS(3103),
    [anon_sym_descending] = ACTIONS(3103),
    [anon_sym_group] = ACTIONS(3103),
    [anon_sym_by] = ACTIONS(3103),
    [anon_sym_select] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3103),
    [anon_sym_typeof] = ACTIONS(3103),
    [anon_sym___makeref] = ACTIONS(3103),
    [anon_sym___reftype] = ACTIONS(3103),
    [anon_sym___refvalue] = ACTIONS(3103),
    [sym_null_literal] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [sym_integer_literal] = ACTIONS(3103),
    [sym_real_literal] = ACTIONS(3105),
    [sym_verbatim_string_literal] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token3] = ACTIONS(3105),
    [aux_sym_preproc_else_token1] = ACTIONS(3105),
    [aux_sym_preproc_elif_token1] = ACTIONS(3105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3105),
    [sym_interpolation_verbatim_start] = ACTIONS(3105),
    [sym_interpolation_raw_start] = ACTIONS(3105),
    [sym_raw_string_start] = ACTIONS(3105),
  },
  [2238] = {
    [sym_preproc_region] = STATE(2238),
    [sym_preproc_endregion] = STATE(2238),
    [sym_preproc_line] = STATE(2238),
    [sym_preproc_pragma] = STATE(2238),
    [sym_preproc_nullable] = STATE(2238),
    [sym_preproc_error] = STATE(2238),
    [sym_preproc_define] = STATE(2238),
    [sym_preproc_undef] = STATE(2238),
    [sym__identifier_token] = ACTIONS(3107),
    [anon_sym_extern] = ACTIONS(3107),
    [anon_sym_alias] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_global] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_ref] = ACTIONS(3107),
    [anon_sym_struct] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_delegate] = ACTIONS(3107),
    [anon_sym_record] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_file] = ACTIONS(3107),
    [anon_sym_fixed] = ACTIONS(3107),
    [anon_sym_internal] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_partial] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_required] = ACTIONS(3107),
    [anon_sym_sealed] = ACTIONS(3107),
    [anon_sym_virtual] = ACTIONS(3107),
    [anon_sym_volatile] = ACTIONS(3107),
    [anon_sym_where] = ACTIONS(3107),
    [anon_sym_notnull] = ACTIONS(3107),
    [anon_sym_unmanaged] = ACTIONS(3107),
    [anon_sym_checked] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_true] = ACTIONS(3107),
    [anon_sym_false] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_this] = ACTIONS(3107),
    [anon_sym_scoped] = ACTIONS(3107),
    [anon_sym_base] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [sym_predefined_type] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_unchecked] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_lock] = ACTIONS(3107),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_when] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_foreach] = ACTIONS(3107),
    [anon_sym_goto] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_from] = ACTIONS(3107),
    [anon_sym_into] = ACTIONS(3107),
    [anon_sym_join] = ACTIONS(3107),
    [anon_sym_on] = ACTIONS(3107),
    [anon_sym_equals] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_orderby] = ACTIONS(3107),
    [anon_sym_ascending] = ACTIONS(3107),
    [anon_sym_descending] = ACTIONS(3107),
    [anon_sym_group] = ACTIONS(3107),
    [anon_sym_by] = ACTIONS(3107),
    [anon_sym_select] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym___makeref] = ACTIONS(3107),
    [anon_sym___reftype] = ACTIONS(3107),
    [anon_sym___refvalue] = ACTIONS(3107),
    [sym_null_literal] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [sym_integer_literal] = ACTIONS(3107),
    [sym_real_literal] = ACTIONS(3109),
    [sym_verbatim_string_literal] = ACTIONS(3109),
    [aux_sym_preproc_if_token1] = ACTIONS(3109),
    [aux_sym_preproc_if_token3] = ACTIONS(3109),
    [aux_sym_preproc_else_token1] = ACTIONS(3109),
    [aux_sym_preproc_elif_token1] = ACTIONS(3109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3109),
    [sym_interpolation_verbatim_start] = ACTIONS(3109),
    [sym_interpolation_raw_start] = ACTIONS(3109),
    [sym_raw_string_start] = ACTIONS(3109),
  },
  [2239] = {
    [sym_preproc_region] = STATE(2239),
    [sym_preproc_endregion] = STATE(2239),
    [sym_preproc_line] = STATE(2239),
    [sym_preproc_pragma] = STATE(2239),
    [sym_preproc_nullable] = STATE(2239),
    [sym_preproc_error] = STATE(2239),
    [sym_preproc_define] = STATE(2239),
    [sym_preproc_undef] = STATE(2239),
    [ts_builtin_sym_end] = ACTIONS(3034),
    [sym__identifier_token] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym_alias] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym_global] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_unsafe] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_namespace] = ACTIONS(3032),
    [anon_sym_class] = ACTIONS(3032),
    [anon_sym_ref] = ACTIONS(3032),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_enum] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3032),
    [anon_sym_delegate] = ACTIONS(3032),
    [anon_sym_record] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_async] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_file] = ACTIONS(3032),
    [anon_sym_fixed] = ACTIONS(3032),
    [anon_sym_internal] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_partial] = ACTIONS(3032),
    [anon_sym_private] = ACTIONS(3032),
    [anon_sym_protected] = ACTIONS(3032),
    [anon_sym_public] = ACTIONS(3032),
    [anon_sym_readonly] = ACTIONS(3032),
    [anon_sym_required] = ACTIONS(3032),
    [anon_sym_sealed] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_where] = ACTIONS(3032),
    [anon_sym_notnull] = ACTIONS(3032),
    [anon_sym_unmanaged] = ACTIONS(3032),
    [anon_sym_checked] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_true] = ACTIONS(3032),
    [anon_sym_false] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_this] = ACTIONS(3032),
    [anon_sym_scoped] = ACTIONS(3032),
    [anon_sym_base] = ACTIONS(3032),
    [anon_sym_var] = ACTIONS(3032),
    [sym_predefined_type] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_unchecked] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_lock] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_catch] = ACTIONS(3032),
    [anon_sym_when] = ACTIONS(3032),
    [anon_sym_finally] = ACTIONS(3032),
    [anon_sym_await] = ACTIONS(3032),
    [anon_sym_foreach] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3034),
    [anon_sym_from] = ACTIONS(3032),
    [anon_sym_into] = ACTIONS(3032),
    [anon_sym_join] = ACTIONS(3032),
    [anon_sym_on] = ACTIONS(3032),
    [anon_sym_equals] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_orderby] = ACTIONS(3032),
    [anon_sym_ascending] = ACTIONS(3032),
    [anon_sym_descending] = ACTIONS(3032),
    [anon_sym_group] = ACTIONS(3032),
    [anon_sym_by] = ACTIONS(3032),
    [anon_sym_select] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [anon_sym_stackalloc] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3032),
    [anon_sym___makeref] = ACTIONS(3032),
    [anon_sym___reftype] = ACTIONS(3032),
    [anon_sym___refvalue] = ACTIONS(3032),
    [sym_null_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [sym_integer_literal] = ACTIONS(3032),
    [sym_real_literal] = ACTIONS(3034),
    [sym_verbatim_string_literal] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3034),
    [sym_interpolation_verbatim_start] = ACTIONS(3034),
    [sym_interpolation_raw_start] = ACTIONS(3034),
    [sym_raw_string_start] = ACTIONS(3034),
  },
  [2240] = {
    [sym_preproc_region] = STATE(2240),
    [sym_preproc_endregion] = STATE(2240),
    [sym_preproc_line] = STATE(2240),
    [sym_preproc_pragma] = STATE(2240),
    [sym_preproc_nullable] = STATE(2240),
    [sym_preproc_error] = STATE(2240),
    [sym_preproc_define] = STATE(2240),
    [sym_preproc_undef] = STATE(2240),
    [sym__identifier_token] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym_alias] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_global] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_unsafe] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_ref] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_interface] = ACTIONS(3111),
    [anon_sym_delegate] = ACTIONS(3111),
    [anon_sym_record] = ACTIONS(3111),
    [anon_sym_abstract] = ACTIONS(3111),
    [anon_sym_async] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_file] = ACTIONS(3111),
    [anon_sym_fixed] = ACTIONS(3111),
    [anon_sym_internal] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3111),
    [anon_sym_partial] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_readonly] = ACTIONS(3111),
    [anon_sym_required] = ACTIONS(3111),
    [anon_sym_sealed] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_where] = ACTIONS(3111),
    [anon_sym_notnull] = ACTIONS(3111),
    [anon_sym_unmanaged] = ACTIONS(3111),
    [anon_sym_checked] = ACTIONS(3111),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_true] = ACTIONS(3111),
    [anon_sym_false] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_this] = ACTIONS(3111),
    [anon_sym_scoped] = ACTIONS(3111),
    [anon_sym_base] = ACTIONS(3111),
    [anon_sym_var] = ACTIONS(3111),
    [sym_predefined_type] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_unchecked] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_lock] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_when] = ACTIONS(3111),
    [anon_sym_await] = ACTIONS(3111),
    [anon_sym_foreach] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_else] = ACTIONS(3111),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_from] = ACTIONS(3111),
    [anon_sym_into] = ACTIONS(3111),
    [anon_sym_join] = ACTIONS(3111),
    [anon_sym_on] = ACTIONS(3111),
    [anon_sym_equals] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_orderby] = ACTIONS(3111),
    [anon_sym_ascending] = ACTIONS(3111),
    [anon_sym_descending] = ACTIONS(3111),
    [anon_sym_group] = ACTIONS(3111),
    [anon_sym_by] = ACTIONS(3111),
    [anon_sym_select] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [anon_sym_stackalloc] = ACTIONS(3111),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym_typeof] = ACTIONS(3111),
    [anon_sym___makeref] = ACTIONS(3111),
    [anon_sym___reftype] = ACTIONS(3111),
    [anon_sym___refvalue] = ACTIONS(3111),
    [sym_null_literal] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [sym_integer_literal] = ACTIONS(3111),
    [sym_real_literal] = ACTIONS(3113),
    [sym_verbatim_string_literal] = ACTIONS(3113),
    [aux_sym_preproc_if_token1] = ACTIONS(3113),
    [aux_sym_preproc_if_token3] = ACTIONS(3113),
    [aux_sym_preproc_else_token1] = ACTIONS(3113),
    [aux_sym_preproc_elif_token1] = ACTIONS(3113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3113),
    [sym_interpolation_verbatim_start] = ACTIONS(3113),
    [sym_interpolation_raw_start] = ACTIONS(3113),
    [sym_raw_string_start] = ACTIONS(3113),
  },
  [2241] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_else] = STATE(9828),
    [sym_preproc_elif] = STATE(9828),
    [sym_preproc_region] = STATE(2241),
    [sym_preproc_endregion] = STATE(2241),
    [sym_preproc_line] = STATE(2241),
    [sym_preproc_pragma] = STATE(2241),
    [sym_preproc_nullable] = STATE(2241),
    [sym_preproc_error] = STATE(2241),
    [sym_preproc_define] = STATE(2241),
    [sym_preproc_undef] = STATE(2241),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(3161),
    [aux_sym_preproc_else_token1] = ACTIONS(3163),
    [aux_sym_preproc_elif_token1] = ACTIONS(3165),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2242] = {
    [sym_preproc_region] = STATE(2242),
    [sym_preproc_endregion] = STATE(2242),
    [sym_preproc_line] = STATE(2242),
    [sym_preproc_pragma] = STATE(2242),
    [sym_preproc_nullable] = STATE(2242),
    [sym_preproc_error] = STATE(2242),
    [sym_preproc_define] = STATE(2242),
    [sym_preproc_undef] = STATE(2242),
    [sym__identifier_token] = ACTIONS(3167),
    [anon_sym_extern] = ACTIONS(3167),
    [anon_sym_alias] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_global] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_unsafe] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_ref] = ACTIONS(3167),
    [anon_sym_struct] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_delegate] = ACTIONS(3167),
    [anon_sym_record] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_file] = ACTIONS(3167),
    [anon_sym_fixed] = ACTIONS(3167),
    [anon_sym_internal] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_partial] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_required] = ACTIONS(3167),
    [anon_sym_sealed] = ACTIONS(3167),
    [anon_sym_virtual] = ACTIONS(3167),
    [anon_sym_volatile] = ACTIONS(3167),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_notnull] = ACTIONS(3167),
    [anon_sym_unmanaged] = ACTIONS(3167),
    [anon_sym_checked] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3169),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [anon_sym_true] = ACTIONS(3167),
    [anon_sym_false] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3169),
    [anon_sym_this] = ACTIONS(3167),
    [anon_sym_scoped] = ACTIONS(3167),
    [anon_sym_base] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [sym_predefined_type] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_unchecked] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_lock] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_when] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_foreach] = ACTIONS(3167),
    [anon_sym_goto] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3169),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_ascending] = ACTIONS(3167),
    [anon_sym_descending] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3167),
    [anon_sym_sizeof] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym___makeref] = ACTIONS(3167),
    [anon_sym___reftype] = ACTIONS(3167),
    [anon_sym___refvalue] = ACTIONS(3167),
    [sym_null_literal] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3169),
    [sym_integer_literal] = ACTIONS(3167),
    [sym_real_literal] = ACTIONS(3169),
    [sym_verbatim_string_literal] = ACTIONS(3169),
    [aux_sym_preproc_if_token1] = ACTIONS(3169),
    [aux_sym_preproc_if_token3] = ACTIONS(3169),
    [aux_sym_preproc_else_token1] = ACTIONS(3169),
    [aux_sym_preproc_elif_token1] = ACTIONS(3169),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3169),
    [sym_interpolation_verbatim_start] = ACTIONS(3169),
    [sym_interpolation_raw_start] = ACTIONS(3169),
    [sym_raw_string_start] = ACTIONS(3169),
  },
  [2243] = {
    [sym_preproc_region] = STATE(2243),
    [sym_preproc_endregion] = STATE(2243),
    [sym_preproc_line] = STATE(2243),
    [sym_preproc_pragma] = STATE(2243),
    [sym_preproc_nullable] = STATE(2243),
    [sym_preproc_error] = STATE(2243),
    [sym_preproc_define] = STATE(2243),
    [sym_preproc_undef] = STATE(2243),
    [sym__identifier_token] = ACTIONS(3171),
    [anon_sym_extern] = ACTIONS(3171),
    [anon_sym_alias] = ACTIONS(3171),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_global] = ACTIONS(3171),
    [anon_sym_using] = ACTIONS(3171),
    [anon_sym_unsafe] = ACTIONS(3171),
    [anon_sym_static] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_namespace] = ACTIONS(3171),
    [anon_sym_class] = ACTIONS(3171),
    [anon_sym_ref] = ACTIONS(3171),
    [anon_sym_struct] = ACTIONS(3171),
    [anon_sym_enum] = ACTIONS(3171),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_interface] = ACTIONS(3171),
    [anon_sym_delegate] = ACTIONS(3171),
    [anon_sym_record] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_file] = ACTIONS(3171),
    [anon_sym_fixed] = ACTIONS(3171),
    [anon_sym_internal] = ACTIONS(3171),
    [anon_sym_new] = ACTIONS(3171),
    [anon_sym_override] = ACTIONS(3171),
    [anon_sym_partial] = ACTIONS(3171),
    [anon_sym_private] = ACTIONS(3171),
    [anon_sym_protected] = ACTIONS(3171),
    [anon_sym_public] = ACTIONS(3171),
    [anon_sym_readonly] = ACTIONS(3171),
    [anon_sym_required] = ACTIONS(3171),
    [anon_sym_sealed] = ACTIONS(3171),
    [anon_sym_virtual] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_where] = ACTIONS(3171),
    [anon_sym_notnull] = ACTIONS(3171),
    [anon_sym_unmanaged] = ACTIONS(3171),
    [anon_sym_checked] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_true] = ACTIONS(3171),
    [anon_sym_false] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_DASH] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_AMP] = ACTIONS(3173),
    [anon_sym_this] = ACTIONS(3171),
    [anon_sym_scoped] = ACTIONS(3171),
    [anon_sym_base] = ACTIONS(3171),
    [anon_sym_var] = ACTIONS(3171),
    [sym_predefined_type] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_unchecked] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_lock] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_switch] = ACTIONS(3171),
    [anon_sym_default] = ACTIONS(3171),
    [anon_sym_throw] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_when] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3171),
    [anon_sym_foreach] = ACTIONS(3171),
    [anon_sym_goto] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_else] = ACTIONS(3171),
    [anon_sym_DOT_DOT] = ACTIONS(3173),
    [anon_sym_from] = ACTIONS(3171),
    [anon_sym_into] = ACTIONS(3171),
    [anon_sym_join] = ACTIONS(3171),
    [anon_sym_on] = ACTIONS(3171),
    [anon_sym_equals] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_orderby] = ACTIONS(3171),
    [anon_sym_ascending] = ACTIONS(3171),
    [anon_sym_descending] = ACTIONS(3171),
    [anon_sym_group] = ACTIONS(3171),
    [anon_sym_by] = ACTIONS(3171),
    [anon_sym_select] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3171),
    [anon_sym_sizeof] = ACTIONS(3171),
    [anon_sym_typeof] = ACTIONS(3171),
    [anon_sym___makeref] = ACTIONS(3171),
    [anon_sym___reftype] = ACTIONS(3171),
    [anon_sym___refvalue] = ACTIONS(3171),
    [sym_null_literal] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3173),
    [sym_integer_literal] = ACTIONS(3171),
    [sym_real_literal] = ACTIONS(3173),
    [sym_verbatim_string_literal] = ACTIONS(3173),
    [aux_sym_preproc_if_token1] = ACTIONS(3173),
    [aux_sym_preproc_if_token3] = ACTIONS(3173),
    [aux_sym_preproc_else_token1] = ACTIONS(3173),
    [aux_sym_preproc_elif_token1] = ACTIONS(3173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3173),
    [sym_interpolation_verbatim_start] = ACTIONS(3173),
    [sym_interpolation_raw_start] = ACTIONS(3173),
    [sym_raw_string_start] = ACTIONS(3173),
  },
  [2244] = {
    [sym_preproc_region] = STATE(2244),
    [sym_preproc_endregion] = STATE(2244),
    [sym_preproc_line] = STATE(2244),
    [sym_preproc_pragma] = STATE(2244),
    [sym_preproc_nullable] = STATE(2244),
    [sym_preproc_error] = STATE(2244),
    [sym_preproc_define] = STATE(2244),
    [sym_preproc_undef] = STATE(2244),
    [sym__identifier_token] = ACTIONS(3175),
    [anon_sym_extern] = ACTIONS(3175),
    [anon_sym_alias] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_global] = ACTIONS(3175),
    [anon_sym_using] = ACTIONS(3175),
    [anon_sym_unsafe] = ACTIONS(3175),
    [anon_sym_static] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_namespace] = ACTIONS(3175),
    [anon_sym_class] = ACTIONS(3175),
    [anon_sym_ref] = ACTIONS(3175),
    [anon_sym_struct] = ACTIONS(3175),
    [anon_sym_enum] = ACTIONS(3175),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_interface] = ACTIONS(3175),
    [anon_sym_delegate] = ACTIONS(3175),
    [anon_sym_record] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_async] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_file] = ACTIONS(3175),
    [anon_sym_fixed] = ACTIONS(3175),
    [anon_sym_internal] = ACTIONS(3175),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_override] = ACTIONS(3175),
    [anon_sym_partial] = ACTIONS(3175),
    [anon_sym_private] = ACTIONS(3175),
    [anon_sym_protected] = ACTIONS(3175),
    [anon_sym_public] = ACTIONS(3175),
    [anon_sym_readonly] = ACTIONS(3175),
    [anon_sym_required] = ACTIONS(3175),
    [anon_sym_sealed] = ACTIONS(3175),
    [anon_sym_virtual] = ACTIONS(3175),
    [anon_sym_volatile] = ACTIONS(3175),
    [anon_sym_where] = ACTIONS(3175),
    [anon_sym_notnull] = ACTIONS(3175),
    [anon_sym_unmanaged] = ACTIONS(3175),
    [anon_sym_checked] = ACTIONS(3175),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_true] = ACTIONS(3175),
    [anon_sym_false] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_DASH] = ACTIONS(3175),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_CARET] = ACTIONS(3177),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_this] = ACTIONS(3175),
    [anon_sym_scoped] = ACTIONS(3175),
    [anon_sym_base] = ACTIONS(3175),
    [anon_sym_var] = ACTIONS(3175),
    [sym_predefined_type] = ACTIONS(3175),
    [anon_sym_break] = ACTIONS(3175),
    [anon_sym_unchecked] = ACTIONS(3175),
    [anon_sym_continue] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_lock] = ACTIONS(3175),
    [anon_sym_yield] = ACTIONS(3175),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_default] = ACTIONS(3175),
    [anon_sym_throw] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_when] = ACTIONS(3175),
    [anon_sym_await] = ACTIONS(3175),
    [anon_sym_foreach] = ACTIONS(3175),
    [anon_sym_goto] = ACTIONS(3175),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_DOT_DOT] = ACTIONS(3177),
    [anon_sym_from] = ACTIONS(3175),
    [anon_sym_into] = ACTIONS(3175),
    [anon_sym_join] = ACTIONS(3175),
    [anon_sym_on] = ACTIONS(3175),
    [anon_sym_equals] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_orderby] = ACTIONS(3175),
    [anon_sym_ascending] = ACTIONS(3175),
    [anon_sym_descending] = ACTIONS(3175),
    [anon_sym_group] = ACTIONS(3175),
    [anon_sym_by] = ACTIONS(3175),
    [anon_sym_select] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3175),
    [anon_sym_sizeof] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3175),
    [anon_sym___makeref] = ACTIONS(3175),
    [anon_sym___reftype] = ACTIONS(3175),
    [anon_sym___refvalue] = ACTIONS(3175),
    [sym_null_literal] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [sym_integer_literal] = ACTIONS(3175),
    [sym_real_literal] = ACTIONS(3177),
    [sym_verbatim_string_literal] = ACTIONS(3177),
    [aux_sym_preproc_if_token1] = ACTIONS(3177),
    [aux_sym_preproc_if_token3] = ACTIONS(3177),
    [aux_sym_preproc_else_token1] = ACTIONS(3177),
    [aux_sym_preproc_elif_token1] = ACTIONS(3177),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3177),
    [sym_interpolation_verbatim_start] = ACTIONS(3177),
    [sym_interpolation_raw_start] = ACTIONS(3177),
    [sym_raw_string_start] = ACTIONS(3177),
  },
  [2245] = {
    [sym_preproc_region] = STATE(2245),
    [sym_preproc_endregion] = STATE(2245),
    [sym_preproc_line] = STATE(2245),
    [sym_preproc_pragma] = STATE(2245),
    [sym_preproc_nullable] = STATE(2245),
    [sym_preproc_error] = STATE(2245),
    [sym_preproc_define] = STATE(2245),
    [sym_preproc_undef] = STATE(2245),
    [sym__identifier_token] = ACTIONS(3179),
    [anon_sym_extern] = ACTIONS(3179),
    [anon_sym_alias] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_global] = ACTIONS(3179),
    [anon_sym_using] = ACTIONS(3179),
    [anon_sym_unsafe] = ACTIONS(3179),
    [anon_sym_static] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_namespace] = ACTIONS(3179),
    [anon_sym_class] = ACTIONS(3179),
    [anon_sym_ref] = ACTIONS(3179),
    [anon_sym_struct] = ACTIONS(3179),
    [anon_sym_enum] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_interface] = ACTIONS(3179),
    [anon_sym_delegate] = ACTIONS(3179),
    [anon_sym_record] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_async] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_file] = ACTIONS(3179),
    [anon_sym_fixed] = ACTIONS(3179),
    [anon_sym_internal] = ACTIONS(3179),
    [anon_sym_new] = ACTIONS(3179),
    [anon_sym_override] = ACTIONS(3179),
    [anon_sym_partial] = ACTIONS(3179),
    [anon_sym_private] = ACTIONS(3179),
    [anon_sym_protected] = ACTIONS(3179),
    [anon_sym_public] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_required] = ACTIONS(3179),
    [anon_sym_sealed] = ACTIONS(3179),
    [anon_sym_virtual] = ACTIONS(3179),
    [anon_sym_volatile] = ACTIONS(3179),
    [anon_sym_where] = ACTIONS(3179),
    [anon_sym_notnull] = ACTIONS(3179),
    [anon_sym_unmanaged] = ACTIONS(3179),
    [anon_sym_checked] = ACTIONS(3179),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_true] = ACTIONS(3179),
    [anon_sym_false] = ACTIONS(3179),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_STAR] = ACTIONS(3181),
    [anon_sym_CARET] = ACTIONS(3181),
    [anon_sym_AMP] = ACTIONS(3181),
    [anon_sym_this] = ACTIONS(3179),
    [anon_sym_scoped] = ACTIONS(3179),
    [anon_sym_base] = ACTIONS(3179),
    [anon_sym_var] = ACTIONS(3179),
    [sym_predefined_type] = ACTIONS(3179),
    [anon_sym_break] = ACTIONS(3179),
    [anon_sym_unchecked] = ACTIONS(3179),
    [anon_sym_continue] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_lock] = ACTIONS(3179),
    [anon_sym_yield] = ACTIONS(3179),
    [anon_sym_switch] = ACTIONS(3179),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_throw] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_when] = ACTIONS(3179),
    [anon_sym_await] = ACTIONS(3179),
    [anon_sym_foreach] = ACTIONS(3179),
    [anon_sym_goto] = ACTIONS(3179),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_else] = ACTIONS(3179),
    [anon_sym_DOT_DOT] = ACTIONS(3181),
    [anon_sym_from] = ACTIONS(3179),
    [anon_sym_into] = ACTIONS(3179),
    [anon_sym_join] = ACTIONS(3179),
    [anon_sym_on] = ACTIONS(3179),
    [anon_sym_equals] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_orderby] = ACTIONS(3179),
    [anon_sym_ascending] = ACTIONS(3179),
    [anon_sym_descending] = ACTIONS(3179),
    [anon_sym_group] = ACTIONS(3179),
    [anon_sym_by] = ACTIONS(3179),
    [anon_sym_select] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3179),
    [anon_sym_sizeof] = ACTIONS(3179),
    [anon_sym_typeof] = ACTIONS(3179),
    [anon_sym___makeref] = ACTIONS(3179),
    [anon_sym___reftype] = ACTIONS(3179),
    [anon_sym___refvalue] = ACTIONS(3179),
    [sym_null_literal] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [sym_integer_literal] = ACTIONS(3179),
    [sym_real_literal] = ACTIONS(3181),
    [sym_verbatim_string_literal] = ACTIONS(3181),
    [aux_sym_preproc_if_token1] = ACTIONS(3181),
    [aux_sym_preproc_if_token3] = ACTIONS(3181),
    [aux_sym_preproc_else_token1] = ACTIONS(3181),
    [aux_sym_preproc_elif_token1] = ACTIONS(3181),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3181),
    [sym_interpolation_verbatim_start] = ACTIONS(3181),
    [sym_interpolation_raw_start] = ACTIONS(3181),
    [sym_raw_string_start] = ACTIONS(3181),
  },
  [2246] = {
    [sym_preproc_region] = STATE(2246),
    [sym_preproc_endregion] = STATE(2246),
    [sym_preproc_line] = STATE(2246),
    [sym_preproc_pragma] = STATE(2246),
    [sym_preproc_nullable] = STATE(2246),
    [sym_preproc_error] = STATE(2246),
    [sym_preproc_define] = STATE(2246),
    [sym_preproc_undef] = STATE(2246),
    [sym__identifier_token] = ACTIONS(3183),
    [anon_sym_extern] = ACTIONS(3183),
    [anon_sym_alias] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_global] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_unsafe] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_ref] = ACTIONS(3183),
    [anon_sym_struct] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_delegate] = ACTIONS(3183),
    [anon_sym_record] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_file] = ACTIONS(3183),
    [anon_sym_fixed] = ACTIONS(3183),
    [anon_sym_internal] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_partial] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_required] = ACTIONS(3183),
    [anon_sym_sealed] = ACTIONS(3183),
    [anon_sym_virtual] = ACTIONS(3183),
    [anon_sym_volatile] = ACTIONS(3183),
    [anon_sym_where] = ACTIONS(3183),
    [anon_sym_notnull] = ACTIONS(3183),
    [anon_sym_unmanaged] = ACTIONS(3183),
    [anon_sym_checked] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_true] = ACTIONS(3183),
    [anon_sym_false] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_STAR] = ACTIONS(3185),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3185),
    [anon_sym_this] = ACTIONS(3183),
    [anon_sym_scoped] = ACTIONS(3183),
    [anon_sym_base] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [sym_predefined_type] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_unchecked] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_lock] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_when] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_foreach] = ACTIONS(3183),
    [anon_sym_goto] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_DOT_DOT] = ACTIONS(3185),
    [anon_sym_from] = ACTIONS(3183),
    [anon_sym_into] = ACTIONS(3183),
    [anon_sym_join] = ACTIONS(3183),
    [anon_sym_on] = ACTIONS(3183),
    [anon_sym_equals] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_orderby] = ACTIONS(3183),
    [anon_sym_ascending] = ACTIONS(3183),
    [anon_sym_descending] = ACTIONS(3183),
    [anon_sym_group] = ACTIONS(3183),
    [anon_sym_by] = ACTIONS(3183),
    [anon_sym_select] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3183),
    [anon_sym_sizeof] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym___makeref] = ACTIONS(3183),
    [anon_sym___reftype] = ACTIONS(3183),
    [anon_sym___refvalue] = ACTIONS(3183),
    [sym_null_literal] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [sym_integer_literal] = ACTIONS(3183),
    [sym_real_literal] = ACTIONS(3185),
    [sym_verbatim_string_literal] = ACTIONS(3185),
    [aux_sym_preproc_if_token1] = ACTIONS(3185),
    [aux_sym_preproc_if_token3] = ACTIONS(3185),
    [aux_sym_preproc_else_token1] = ACTIONS(3185),
    [aux_sym_preproc_elif_token1] = ACTIONS(3185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3185),
    [sym_interpolation_verbatim_start] = ACTIONS(3185),
    [sym_interpolation_raw_start] = ACTIONS(3185),
    [sym_raw_string_start] = ACTIONS(3185),
  },
  [2247] = {
    [sym_preproc_region] = STATE(2247),
    [sym_preproc_endregion] = STATE(2247),
    [sym_preproc_line] = STATE(2247),
    [sym_preproc_pragma] = STATE(2247),
    [sym_preproc_nullable] = STATE(2247),
    [sym_preproc_error] = STATE(2247),
    [sym_preproc_define] = STATE(2247),
    [sym_preproc_undef] = STATE(2247),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_namespace] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_struct] = ACTIONS(3189),
    [anon_sym_enum] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3189),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_record] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_if_token3] = ACTIONS(3191),
    [aux_sym_preproc_else_token1] = ACTIONS(3191),
    [aux_sym_preproc_elif_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [2248] = {
    [sym_preproc_region] = STATE(2248),
    [sym_preproc_endregion] = STATE(2248),
    [sym_preproc_line] = STATE(2248),
    [sym_preproc_pragma] = STATE(2248),
    [sym_preproc_nullable] = STATE(2248),
    [sym_preproc_error] = STATE(2248),
    [sym_preproc_define] = STATE(2248),
    [sym_preproc_undef] = STATE(2248),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_class] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_enum] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_record] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_if_token3] = ACTIONS(3195),
    [aux_sym_preproc_else_token1] = ACTIONS(3195),
    [aux_sym_preproc_elif_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [2249] = {
    [sym_preproc_region] = STATE(2249),
    [sym_preproc_endregion] = STATE(2249),
    [sym_preproc_line] = STATE(2249),
    [sym_preproc_pragma] = STATE(2249),
    [sym_preproc_nullable] = STATE(2249),
    [sym_preproc_error] = STATE(2249),
    [sym_preproc_define] = STATE(2249),
    [sym_preproc_undef] = STATE(2249),
    [sym__identifier_token] = ACTIONS(3197),
    [anon_sym_extern] = ACTIONS(3197),
    [anon_sym_alias] = ACTIONS(3197),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_global] = ACTIONS(3197),
    [anon_sym_using] = ACTIONS(3197),
    [anon_sym_unsafe] = ACTIONS(3197),
    [anon_sym_static] = ACTIONS(3197),
    [anon_sym_LBRACK] = ACTIONS(3199),
    [anon_sym_LPAREN] = ACTIONS(3199),
    [anon_sym_return] = ACTIONS(3197),
    [anon_sym_namespace] = ACTIONS(3197),
    [anon_sym_class] = ACTIONS(3197),
    [anon_sym_ref] = ACTIONS(3197),
    [anon_sym_struct] = ACTIONS(3197),
    [anon_sym_enum] = ACTIONS(3197),
    [anon_sym_LBRACE] = ACTIONS(3199),
    [anon_sym_interface] = ACTIONS(3197),
    [anon_sym_delegate] = ACTIONS(3197),
    [anon_sym_record] = ACTIONS(3197),
    [anon_sym_abstract] = ACTIONS(3197),
    [anon_sym_async] = ACTIONS(3197),
    [anon_sym_const] = ACTIONS(3197),
    [anon_sym_file] = ACTIONS(3197),
    [anon_sym_fixed] = ACTIONS(3197),
    [anon_sym_internal] = ACTIONS(3197),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_override] = ACTIONS(3197),
    [anon_sym_partial] = ACTIONS(3197),
    [anon_sym_private] = ACTIONS(3197),
    [anon_sym_protected] = ACTIONS(3197),
    [anon_sym_public] = ACTIONS(3197),
    [anon_sym_readonly] = ACTIONS(3197),
    [anon_sym_required] = ACTIONS(3197),
    [anon_sym_sealed] = ACTIONS(3197),
    [anon_sym_virtual] = ACTIONS(3197),
    [anon_sym_volatile] = ACTIONS(3197),
    [anon_sym_where] = ACTIONS(3197),
    [anon_sym_notnull] = ACTIONS(3197),
    [anon_sym_unmanaged] = ACTIONS(3197),
    [anon_sym_checked] = ACTIONS(3197),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_TILDE] = ACTIONS(3199),
    [anon_sym_PLUS_PLUS] = ACTIONS(3199),
    [anon_sym_DASH_DASH] = ACTIONS(3199),
    [anon_sym_true] = ACTIONS(3197),
    [anon_sym_false] = ACTIONS(3197),
    [anon_sym_PLUS] = ACTIONS(3197),
    [anon_sym_DASH] = ACTIONS(3197),
    [anon_sym_STAR] = ACTIONS(3199),
    [anon_sym_CARET] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3199),
    [anon_sym_this] = ACTIONS(3197),
    [anon_sym_scoped] = ACTIONS(3197),
    [anon_sym_base] = ACTIONS(3197),
    [anon_sym_var] = ACTIONS(3197),
    [sym_predefined_type] = ACTIONS(3197),
    [anon_sym_break] = ACTIONS(3197),
    [anon_sym_unchecked] = ACTIONS(3197),
    [anon_sym_continue] = ACTIONS(3197),
    [anon_sym_do] = ACTIONS(3197),
    [anon_sym_while] = ACTIONS(3197),
    [anon_sym_for] = ACTIONS(3197),
    [anon_sym_lock] = ACTIONS(3197),
    [anon_sym_yield] = ACTIONS(3197),
    [anon_sym_switch] = ACTIONS(3197),
    [anon_sym_default] = ACTIONS(3197),
    [anon_sym_throw] = ACTIONS(3197),
    [anon_sym_try] = ACTIONS(3197),
    [anon_sym_when] = ACTIONS(3197),
    [anon_sym_await] = ACTIONS(3197),
    [anon_sym_foreach] = ACTIONS(3197),
    [anon_sym_goto] = ACTIONS(3197),
    [anon_sym_if] = ACTIONS(3197),
    [anon_sym_else] = ACTIONS(3197),
    [anon_sym_DOT_DOT] = ACTIONS(3199),
    [anon_sym_from] = ACTIONS(3197),
    [anon_sym_into] = ACTIONS(3197),
    [anon_sym_join] = ACTIONS(3197),
    [anon_sym_on] = ACTIONS(3197),
    [anon_sym_equals] = ACTIONS(3197),
    [anon_sym_let] = ACTIONS(3197),
    [anon_sym_orderby] = ACTIONS(3197),
    [anon_sym_ascending] = ACTIONS(3197),
    [anon_sym_descending] = ACTIONS(3197),
    [anon_sym_group] = ACTIONS(3197),
    [anon_sym_by] = ACTIONS(3197),
    [anon_sym_select] = ACTIONS(3197),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3197),
    [anon_sym_sizeof] = ACTIONS(3197),
    [anon_sym_typeof] = ACTIONS(3197),
    [anon_sym___makeref] = ACTIONS(3197),
    [anon_sym___reftype] = ACTIONS(3197),
    [anon_sym___refvalue] = ACTIONS(3197),
    [sym_null_literal] = ACTIONS(3197),
    [anon_sym_SQUOTE] = ACTIONS(3199),
    [sym_integer_literal] = ACTIONS(3197),
    [sym_real_literal] = ACTIONS(3199),
    [sym_verbatim_string_literal] = ACTIONS(3199),
    [aux_sym_preproc_if_token1] = ACTIONS(3199),
    [aux_sym_preproc_if_token3] = ACTIONS(3199),
    [aux_sym_preproc_else_token1] = ACTIONS(3199),
    [aux_sym_preproc_elif_token1] = ACTIONS(3199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3199),
    [sym_interpolation_verbatim_start] = ACTIONS(3199),
    [sym_interpolation_raw_start] = ACTIONS(3199),
    [sym_raw_string_start] = ACTIONS(3199),
  },
  [2250] = {
    [sym_preproc_region] = STATE(2250),
    [sym_preproc_endregion] = STATE(2250),
    [sym_preproc_line] = STATE(2250),
    [sym_preproc_pragma] = STATE(2250),
    [sym_preproc_nullable] = STATE(2250),
    [sym_preproc_error] = STATE(2250),
    [sym_preproc_define] = STATE(2250),
    [sym_preproc_undef] = STATE(2250),
    [sym__identifier_token] = ACTIONS(3201),
    [anon_sym_extern] = ACTIONS(3201),
    [anon_sym_alias] = ACTIONS(3201),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_global] = ACTIONS(3201),
    [anon_sym_using] = ACTIONS(3201),
    [anon_sym_unsafe] = ACTIONS(3201),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_namespace] = ACTIONS(3201),
    [anon_sym_class] = ACTIONS(3201),
    [anon_sym_ref] = ACTIONS(3201),
    [anon_sym_struct] = ACTIONS(3201),
    [anon_sym_enum] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3203),
    [anon_sym_interface] = ACTIONS(3201),
    [anon_sym_delegate] = ACTIONS(3201),
    [anon_sym_record] = ACTIONS(3201),
    [anon_sym_abstract] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_file] = ACTIONS(3201),
    [anon_sym_fixed] = ACTIONS(3201),
    [anon_sym_internal] = ACTIONS(3201),
    [anon_sym_new] = ACTIONS(3201),
    [anon_sym_override] = ACTIONS(3201),
    [anon_sym_partial] = ACTIONS(3201),
    [anon_sym_private] = ACTIONS(3201),
    [anon_sym_protected] = ACTIONS(3201),
    [anon_sym_public] = ACTIONS(3201),
    [anon_sym_readonly] = ACTIONS(3201),
    [anon_sym_required] = ACTIONS(3201),
    [anon_sym_sealed] = ACTIONS(3201),
    [anon_sym_virtual] = ACTIONS(3201),
    [anon_sym_volatile] = ACTIONS(3201),
    [anon_sym_where] = ACTIONS(3201),
    [anon_sym_notnull] = ACTIONS(3201),
    [anon_sym_unmanaged] = ACTIONS(3201),
    [anon_sym_checked] = ACTIONS(3201),
    [anon_sym_BANG] = ACTIONS(3203),
    [anon_sym_TILDE] = ACTIONS(3203),
    [anon_sym_PLUS_PLUS] = ACTIONS(3203),
    [anon_sym_DASH_DASH] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(3201),
    [anon_sym_false] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(3201),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_this] = ACTIONS(3201),
    [anon_sym_scoped] = ACTIONS(3201),
    [anon_sym_base] = ACTIONS(3201),
    [anon_sym_var] = ACTIONS(3201),
    [sym_predefined_type] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_unchecked] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_do] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_lock] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_switch] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_throw] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [anon_sym_when] = ACTIONS(3201),
    [anon_sym_await] = ACTIONS(3201),
    [anon_sym_foreach] = ACTIONS(3201),
    [anon_sym_goto] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_else] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_from] = ACTIONS(3201),
    [anon_sym_into] = ACTIONS(3201),
    [anon_sym_join] = ACTIONS(3201),
    [anon_sym_on] = ACTIONS(3201),
    [anon_sym_equals] = ACTIONS(3201),
    [anon_sym_let] = ACTIONS(3201),
    [anon_sym_orderby] = ACTIONS(3201),
    [anon_sym_ascending] = ACTIONS(3201),
    [anon_sym_descending] = ACTIONS(3201),
    [anon_sym_group] = ACTIONS(3201),
    [anon_sym_by] = ACTIONS(3201),
    [anon_sym_select] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3201),
    [anon_sym_sizeof] = ACTIONS(3201),
    [anon_sym_typeof] = ACTIONS(3201),
    [anon_sym___makeref] = ACTIONS(3201),
    [anon_sym___reftype] = ACTIONS(3201),
    [anon_sym___refvalue] = ACTIONS(3201),
    [sym_null_literal] = ACTIONS(3201),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3201),
    [sym_real_literal] = ACTIONS(3203),
    [sym_verbatim_string_literal] = ACTIONS(3203),
    [aux_sym_preproc_if_token1] = ACTIONS(3203),
    [aux_sym_preproc_if_token3] = ACTIONS(3203),
    [aux_sym_preproc_else_token1] = ACTIONS(3203),
    [aux_sym_preproc_elif_token1] = ACTIONS(3203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3203),
    [sym_interpolation_verbatim_start] = ACTIONS(3203),
    [sym_interpolation_raw_start] = ACTIONS(3203),
    [sym_raw_string_start] = ACTIONS(3203),
  },
  [2251] = {
    [sym_preproc_region] = STATE(2251),
    [sym_preproc_endregion] = STATE(2251),
    [sym_preproc_line] = STATE(2251),
    [sym_preproc_pragma] = STATE(2251),
    [sym_preproc_nullable] = STATE(2251),
    [sym_preproc_error] = STATE(2251),
    [sym_preproc_define] = STATE(2251),
    [sym_preproc_undef] = STATE(2251),
    [sym__identifier_token] = ACTIONS(3205),
    [anon_sym_extern] = ACTIONS(3205),
    [anon_sym_alias] = ACTIONS(3205),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_global] = ACTIONS(3205),
    [anon_sym_using] = ACTIONS(3205),
    [anon_sym_unsafe] = ACTIONS(3205),
    [anon_sym_static] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3205),
    [anon_sym_namespace] = ACTIONS(3205),
    [anon_sym_class] = ACTIONS(3205),
    [anon_sym_ref] = ACTIONS(3205),
    [anon_sym_struct] = ACTIONS(3205),
    [anon_sym_enum] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3205),
    [anon_sym_delegate] = ACTIONS(3205),
    [anon_sym_record] = ACTIONS(3205),
    [anon_sym_abstract] = ACTIONS(3205),
    [anon_sym_async] = ACTIONS(3205),
    [anon_sym_const] = ACTIONS(3205),
    [anon_sym_file] = ACTIONS(3205),
    [anon_sym_fixed] = ACTIONS(3205),
    [anon_sym_internal] = ACTIONS(3205),
    [anon_sym_new] = ACTIONS(3205),
    [anon_sym_override] = ACTIONS(3205),
    [anon_sym_partial] = ACTIONS(3205),
    [anon_sym_private] = ACTIONS(3205),
    [anon_sym_protected] = ACTIONS(3205),
    [anon_sym_public] = ACTIONS(3205),
    [anon_sym_readonly] = ACTIONS(3205),
    [anon_sym_required] = ACTIONS(3205),
    [anon_sym_sealed] = ACTIONS(3205),
    [anon_sym_virtual] = ACTIONS(3205),
    [anon_sym_volatile] = ACTIONS(3205),
    [anon_sym_where] = ACTIONS(3205),
    [anon_sym_notnull] = ACTIONS(3205),
    [anon_sym_unmanaged] = ACTIONS(3205),
    [anon_sym_checked] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [anon_sym_true] = ACTIONS(3205),
    [anon_sym_false] = ACTIONS(3205),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_this] = ACTIONS(3205),
    [anon_sym_scoped] = ACTIONS(3205),
    [anon_sym_base] = ACTIONS(3205),
    [anon_sym_var] = ACTIONS(3205),
    [sym_predefined_type] = ACTIONS(3205),
    [anon_sym_break] = ACTIONS(3205),
    [anon_sym_unchecked] = ACTIONS(3205),
    [anon_sym_continue] = ACTIONS(3205),
    [anon_sym_do] = ACTIONS(3205),
    [anon_sym_while] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3205),
    [anon_sym_lock] = ACTIONS(3205),
    [anon_sym_yield] = ACTIONS(3205),
    [anon_sym_switch] = ACTIONS(3205),
    [anon_sym_default] = ACTIONS(3205),
    [anon_sym_throw] = ACTIONS(3205),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_when] = ACTIONS(3205),
    [anon_sym_await] = ACTIONS(3205),
    [anon_sym_foreach] = ACTIONS(3205),
    [anon_sym_goto] = ACTIONS(3205),
    [anon_sym_if] = ACTIONS(3205),
    [anon_sym_else] = ACTIONS(3205),
    [anon_sym_DOT_DOT] = ACTIONS(3207),
    [anon_sym_from] = ACTIONS(3205),
    [anon_sym_into] = ACTIONS(3205),
    [anon_sym_join] = ACTIONS(3205),
    [anon_sym_on] = ACTIONS(3205),
    [anon_sym_equals] = ACTIONS(3205),
    [anon_sym_let] = ACTIONS(3205),
    [anon_sym_orderby] = ACTIONS(3205),
    [anon_sym_ascending] = ACTIONS(3205),
    [anon_sym_descending] = ACTIONS(3205),
    [anon_sym_group] = ACTIONS(3205),
    [anon_sym_by] = ACTIONS(3205),
    [anon_sym_select] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3205),
    [anon_sym_sizeof] = ACTIONS(3205),
    [anon_sym_typeof] = ACTIONS(3205),
    [anon_sym___makeref] = ACTIONS(3205),
    [anon_sym___reftype] = ACTIONS(3205),
    [anon_sym___refvalue] = ACTIONS(3205),
    [sym_null_literal] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [sym_integer_literal] = ACTIONS(3205),
    [sym_real_literal] = ACTIONS(3207),
    [sym_verbatim_string_literal] = ACTIONS(3207),
    [aux_sym_preproc_if_token1] = ACTIONS(3207),
    [aux_sym_preproc_if_token3] = ACTIONS(3207),
    [aux_sym_preproc_else_token1] = ACTIONS(3207),
    [aux_sym_preproc_elif_token1] = ACTIONS(3207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3207),
    [sym_interpolation_verbatim_start] = ACTIONS(3207),
    [sym_interpolation_raw_start] = ACTIONS(3207),
    [sym_raw_string_start] = ACTIONS(3207),
  },
  [2252] = {
    [sym_preproc_region] = STATE(2252),
    [sym_preproc_endregion] = STATE(2252),
    [sym_preproc_line] = STATE(2252),
    [sym_preproc_pragma] = STATE(2252),
    [sym_preproc_nullable] = STATE(2252),
    [sym_preproc_error] = STATE(2252),
    [sym_preproc_define] = STATE(2252),
    [sym_preproc_undef] = STATE(2252),
    [sym__identifier_token] = ACTIONS(3209),
    [anon_sym_extern] = ACTIONS(3209),
    [anon_sym_alias] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_global] = ACTIONS(3209),
    [anon_sym_using] = ACTIONS(3209),
    [anon_sym_unsafe] = ACTIONS(3209),
    [anon_sym_static] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3209),
    [anon_sym_namespace] = ACTIONS(3209),
    [anon_sym_class] = ACTIONS(3209),
    [anon_sym_ref] = ACTIONS(3209),
    [anon_sym_struct] = ACTIONS(3209),
    [anon_sym_enum] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3209),
    [anon_sym_delegate] = ACTIONS(3209),
    [anon_sym_record] = ACTIONS(3209),
    [anon_sym_abstract] = ACTIONS(3209),
    [anon_sym_async] = ACTIONS(3209),
    [anon_sym_const] = ACTIONS(3209),
    [anon_sym_file] = ACTIONS(3209),
    [anon_sym_fixed] = ACTIONS(3209),
    [anon_sym_internal] = ACTIONS(3209),
    [anon_sym_new] = ACTIONS(3209),
    [anon_sym_override] = ACTIONS(3209),
    [anon_sym_partial] = ACTIONS(3209),
    [anon_sym_private] = ACTIONS(3209),
    [anon_sym_protected] = ACTIONS(3209),
    [anon_sym_public] = ACTIONS(3209),
    [anon_sym_readonly] = ACTIONS(3209),
    [anon_sym_required] = ACTIONS(3209),
    [anon_sym_sealed] = ACTIONS(3209),
    [anon_sym_virtual] = ACTIONS(3209),
    [anon_sym_volatile] = ACTIONS(3209),
    [anon_sym_where] = ACTIONS(3209),
    [anon_sym_notnull] = ACTIONS(3209),
    [anon_sym_unmanaged] = ACTIONS(3209),
    [anon_sym_checked] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_true] = ACTIONS(3209),
    [anon_sym_false] = ACTIONS(3209),
    [anon_sym_PLUS] = ACTIONS(3209),
    [anon_sym_DASH] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_CARET] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3211),
    [anon_sym_this] = ACTIONS(3209),
    [anon_sym_scoped] = ACTIONS(3209),
    [anon_sym_base] = ACTIONS(3209),
    [anon_sym_var] = ACTIONS(3209),
    [sym_predefined_type] = ACTIONS(3209),
    [anon_sym_break] = ACTIONS(3209),
    [anon_sym_unchecked] = ACTIONS(3209),
    [anon_sym_continue] = ACTIONS(3209),
    [anon_sym_do] = ACTIONS(3209),
    [anon_sym_while] = ACTIONS(3209),
    [anon_sym_for] = ACTIONS(3209),
    [anon_sym_lock] = ACTIONS(3209),
    [anon_sym_yield] = ACTIONS(3209),
    [anon_sym_switch] = ACTIONS(3209),
    [anon_sym_default] = ACTIONS(3209),
    [anon_sym_throw] = ACTIONS(3209),
    [anon_sym_try] = ACTIONS(3209),
    [anon_sym_when] = ACTIONS(3209),
    [anon_sym_await] = ACTIONS(3209),
    [anon_sym_foreach] = ACTIONS(3209),
    [anon_sym_goto] = ACTIONS(3209),
    [anon_sym_if] = ACTIONS(3209),
    [anon_sym_else] = ACTIONS(3209),
    [anon_sym_DOT_DOT] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3209),
    [anon_sym_into] = ACTIONS(3209),
    [anon_sym_join] = ACTIONS(3209),
    [anon_sym_on] = ACTIONS(3209),
    [anon_sym_equals] = ACTIONS(3209),
    [anon_sym_let] = ACTIONS(3209),
    [anon_sym_orderby] = ACTIONS(3209),
    [anon_sym_ascending] = ACTIONS(3209),
    [anon_sym_descending] = ACTIONS(3209),
    [anon_sym_group] = ACTIONS(3209),
    [anon_sym_by] = ACTIONS(3209),
    [anon_sym_select] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3209),
    [anon_sym_sizeof] = ACTIONS(3209),
    [anon_sym_typeof] = ACTIONS(3209),
    [anon_sym___makeref] = ACTIONS(3209),
    [anon_sym___reftype] = ACTIONS(3209),
    [anon_sym___refvalue] = ACTIONS(3209),
    [sym_null_literal] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [sym_integer_literal] = ACTIONS(3209),
    [sym_real_literal] = ACTIONS(3211),
    [sym_verbatim_string_literal] = ACTIONS(3211),
    [aux_sym_preproc_if_token1] = ACTIONS(3211),
    [aux_sym_preproc_if_token3] = ACTIONS(3211),
    [aux_sym_preproc_else_token1] = ACTIONS(3211),
    [aux_sym_preproc_elif_token1] = ACTIONS(3211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3211),
    [sym_interpolation_verbatim_start] = ACTIONS(3211),
    [sym_interpolation_raw_start] = ACTIONS(3211),
    [sym_raw_string_start] = ACTIONS(3211),
  },
  [2253] = {
    [sym_preproc_region] = STATE(2253),
    [sym_preproc_endregion] = STATE(2253),
    [sym_preproc_line] = STATE(2253),
    [sym_preproc_pragma] = STATE(2253),
    [sym_preproc_nullable] = STATE(2253),
    [sym_preproc_error] = STATE(2253),
    [sym_preproc_define] = STATE(2253),
    [sym_preproc_undef] = STATE(2253),
    [sym__identifier_token] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3213),
    [anon_sym_alias] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3215),
    [anon_sym_global] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3215),
    [anon_sym_LPAREN] = ACTIONS(3215),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_ref] = ACTIONS(3213),
    [anon_sym_struct] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_delegate] = ACTIONS(3213),
    [anon_sym_record] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_file] = ACTIONS(3213),
    [anon_sym_fixed] = ACTIONS(3213),
    [anon_sym_internal] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_partial] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_required] = ACTIONS(3213),
    [anon_sym_sealed] = ACTIONS(3213),
    [anon_sym_virtual] = ACTIONS(3213),
    [anon_sym_volatile] = ACTIONS(3213),
    [anon_sym_where] = ACTIONS(3213),
    [anon_sym_notnull] = ACTIONS(3213),
    [anon_sym_unmanaged] = ACTIONS(3213),
    [anon_sym_checked] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3215),
    [anon_sym_TILDE] = ACTIONS(3215),
    [anon_sym_PLUS_PLUS] = ACTIONS(3215),
    [anon_sym_DASH_DASH] = ACTIONS(3215),
    [anon_sym_true] = ACTIONS(3213),
    [anon_sym_false] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3215),
    [anon_sym_CARET] = ACTIONS(3215),
    [anon_sym_AMP] = ACTIONS(3215),
    [anon_sym_this] = ACTIONS(3213),
    [anon_sym_scoped] = ACTIONS(3213),
    [anon_sym_base] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [sym_predefined_type] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_unchecked] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_lock] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_when] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_foreach] = ACTIONS(3213),
    [anon_sym_goto] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_DOT_DOT] = ACTIONS(3215),
    [anon_sym_from] = ACTIONS(3213),
    [anon_sym_into] = ACTIONS(3213),
    [anon_sym_join] = ACTIONS(3213),
    [anon_sym_on] = ACTIONS(3213),
    [anon_sym_equals] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_orderby] = ACTIONS(3213),
    [anon_sym_ascending] = ACTIONS(3213),
    [anon_sym_descending] = ACTIONS(3213),
    [anon_sym_group] = ACTIONS(3213),
    [anon_sym_by] = ACTIONS(3213),
    [anon_sym_select] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3213),
    [anon_sym_sizeof] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym___makeref] = ACTIONS(3213),
    [anon_sym___reftype] = ACTIONS(3213),
    [anon_sym___refvalue] = ACTIONS(3213),
    [sym_null_literal] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3215),
    [sym_integer_literal] = ACTIONS(3213),
    [sym_real_literal] = ACTIONS(3215),
    [sym_verbatim_string_literal] = ACTIONS(3215),
    [aux_sym_preproc_if_token1] = ACTIONS(3215),
    [aux_sym_preproc_if_token3] = ACTIONS(3215),
    [aux_sym_preproc_else_token1] = ACTIONS(3215),
    [aux_sym_preproc_elif_token1] = ACTIONS(3215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3215),
    [sym_interpolation_verbatim_start] = ACTIONS(3215),
    [sym_interpolation_raw_start] = ACTIONS(3215),
    [sym_raw_string_start] = ACTIONS(3215),
  },
  [2254] = {
    [sym_preproc_region] = STATE(2254),
    [sym_preproc_endregion] = STATE(2254),
    [sym_preproc_line] = STATE(2254),
    [sym_preproc_pragma] = STATE(2254),
    [sym_preproc_nullable] = STATE(2254),
    [sym_preproc_error] = STATE(2254),
    [sym_preproc_define] = STATE(2254),
    [sym_preproc_undef] = STATE(2254),
    [sym__identifier_token] = ACTIONS(3217),
    [anon_sym_extern] = ACTIONS(3217),
    [anon_sym_alias] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_global] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_unsafe] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_ref] = ACTIONS(3217),
    [anon_sym_struct] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_delegate] = ACTIONS(3217),
    [anon_sym_record] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_file] = ACTIONS(3217),
    [anon_sym_fixed] = ACTIONS(3217),
    [anon_sym_internal] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_partial] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_required] = ACTIONS(3217),
    [anon_sym_sealed] = ACTIONS(3217),
    [anon_sym_virtual] = ACTIONS(3217),
    [anon_sym_volatile] = ACTIONS(3217),
    [anon_sym_where] = ACTIONS(3217),
    [anon_sym_notnull] = ACTIONS(3217),
    [anon_sym_unmanaged] = ACTIONS(3217),
    [anon_sym_checked] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [anon_sym_true] = ACTIONS(3217),
    [anon_sym_false] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3219),
    [anon_sym_CARET] = ACTIONS(3219),
    [anon_sym_AMP] = ACTIONS(3219),
    [anon_sym_this] = ACTIONS(3217),
    [anon_sym_scoped] = ACTIONS(3217),
    [anon_sym_base] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [sym_predefined_type] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_unchecked] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_lock] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_when] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_foreach] = ACTIONS(3217),
    [anon_sym_goto] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_DOT_DOT] = ACTIONS(3219),
    [anon_sym_from] = ACTIONS(3217),
    [anon_sym_into] = ACTIONS(3217),
    [anon_sym_join] = ACTIONS(3217),
    [anon_sym_on] = ACTIONS(3217),
    [anon_sym_equals] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_orderby] = ACTIONS(3217),
    [anon_sym_ascending] = ACTIONS(3217),
    [anon_sym_descending] = ACTIONS(3217),
    [anon_sym_group] = ACTIONS(3217),
    [anon_sym_by] = ACTIONS(3217),
    [anon_sym_select] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3217),
    [anon_sym_sizeof] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym___makeref] = ACTIONS(3217),
    [anon_sym___reftype] = ACTIONS(3217),
    [anon_sym___refvalue] = ACTIONS(3217),
    [sym_null_literal] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [sym_integer_literal] = ACTIONS(3217),
    [sym_real_literal] = ACTIONS(3219),
    [sym_verbatim_string_literal] = ACTIONS(3219),
    [aux_sym_preproc_if_token1] = ACTIONS(3219),
    [aux_sym_preproc_if_token3] = ACTIONS(3219),
    [aux_sym_preproc_else_token1] = ACTIONS(3219),
    [aux_sym_preproc_elif_token1] = ACTIONS(3219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3219),
    [sym_interpolation_verbatim_start] = ACTIONS(3219),
    [sym_interpolation_raw_start] = ACTIONS(3219),
    [sym_raw_string_start] = ACTIONS(3219),
  },
  [2255] = {
    [sym_preproc_region] = STATE(2255),
    [sym_preproc_endregion] = STATE(2255),
    [sym_preproc_line] = STATE(2255),
    [sym_preproc_pragma] = STATE(2255),
    [sym_preproc_nullable] = STATE(2255),
    [sym_preproc_error] = STATE(2255),
    [sym_preproc_define] = STATE(2255),
    [sym_preproc_undef] = STATE(2255),
    [sym__identifier_token] = ACTIONS(3221),
    [anon_sym_extern] = ACTIONS(3221),
    [anon_sym_alias] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_unsafe] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_ref] = ACTIONS(3221),
    [anon_sym_struct] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_delegate] = ACTIONS(3221),
    [anon_sym_record] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_file] = ACTIONS(3221),
    [anon_sym_fixed] = ACTIONS(3221),
    [anon_sym_internal] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_partial] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_required] = ACTIONS(3221),
    [anon_sym_sealed] = ACTIONS(3221),
    [anon_sym_virtual] = ACTIONS(3221),
    [anon_sym_volatile] = ACTIONS(3221),
    [anon_sym_where] = ACTIONS(3221),
    [anon_sym_notnull] = ACTIONS(3221),
    [anon_sym_unmanaged] = ACTIONS(3221),
    [anon_sym_checked] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [anon_sym_true] = ACTIONS(3221),
    [anon_sym_false] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_this] = ACTIONS(3221),
    [anon_sym_scoped] = ACTIONS(3221),
    [anon_sym_base] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [sym_predefined_type] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_unchecked] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_lock] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_when] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_foreach] = ACTIONS(3221),
    [anon_sym_goto] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_DOT_DOT] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3221),
    [anon_sym_into] = ACTIONS(3221),
    [anon_sym_join] = ACTIONS(3221),
    [anon_sym_on] = ACTIONS(3221),
    [anon_sym_equals] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_orderby] = ACTIONS(3221),
    [anon_sym_ascending] = ACTIONS(3221),
    [anon_sym_descending] = ACTIONS(3221),
    [anon_sym_group] = ACTIONS(3221),
    [anon_sym_by] = ACTIONS(3221),
    [anon_sym_select] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3221),
    [anon_sym_sizeof] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym___makeref] = ACTIONS(3221),
    [anon_sym___reftype] = ACTIONS(3221),
    [anon_sym___refvalue] = ACTIONS(3221),
    [sym_null_literal] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [sym_integer_literal] = ACTIONS(3221),
    [sym_real_literal] = ACTIONS(3223),
    [sym_verbatim_string_literal] = ACTIONS(3223),
    [aux_sym_preproc_if_token1] = ACTIONS(3223),
    [aux_sym_preproc_if_token3] = ACTIONS(3223),
    [aux_sym_preproc_else_token1] = ACTIONS(3223),
    [aux_sym_preproc_elif_token1] = ACTIONS(3223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3223),
    [sym_interpolation_verbatim_start] = ACTIONS(3223),
    [sym_interpolation_raw_start] = ACTIONS(3223),
    [sym_raw_string_start] = ACTIONS(3223),
  },
  [2256] = {
    [sym_preproc_region] = STATE(2256),
    [sym_preproc_endregion] = STATE(2256),
    [sym_preproc_line] = STATE(2256),
    [sym_preproc_pragma] = STATE(2256),
    [sym_preproc_nullable] = STATE(2256),
    [sym_preproc_error] = STATE(2256),
    [sym_preproc_define] = STATE(2256),
    [sym_preproc_undef] = STATE(2256),
    [sym__identifier_token] = ACTIONS(3225),
    [anon_sym_extern] = ACTIONS(3225),
    [anon_sym_alias] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_global] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_unsafe] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_ref] = ACTIONS(3225),
    [anon_sym_struct] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_delegate] = ACTIONS(3225),
    [anon_sym_record] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_file] = ACTIONS(3225),
    [anon_sym_fixed] = ACTIONS(3225),
    [anon_sym_internal] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_partial] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_required] = ACTIONS(3225),
    [anon_sym_sealed] = ACTIONS(3225),
    [anon_sym_virtual] = ACTIONS(3225),
    [anon_sym_volatile] = ACTIONS(3225),
    [anon_sym_where] = ACTIONS(3225),
    [anon_sym_notnull] = ACTIONS(3225),
    [anon_sym_unmanaged] = ACTIONS(3225),
    [anon_sym_checked] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_true] = ACTIONS(3225),
    [anon_sym_false] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_STAR] = ACTIONS(3227),
    [anon_sym_CARET] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_this] = ACTIONS(3225),
    [anon_sym_scoped] = ACTIONS(3225),
    [anon_sym_base] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [sym_predefined_type] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_unchecked] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_lock] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_when] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_foreach] = ACTIONS(3225),
    [anon_sym_goto] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_DOT_DOT] = ACTIONS(3227),
    [anon_sym_from] = ACTIONS(3225),
    [anon_sym_into] = ACTIONS(3225),
    [anon_sym_join] = ACTIONS(3225),
    [anon_sym_on] = ACTIONS(3225),
    [anon_sym_equals] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_orderby] = ACTIONS(3225),
    [anon_sym_ascending] = ACTIONS(3225),
    [anon_sym_descending] = ACTIONS(3225),
    [anon_sym_group] = ACTIONS(3225),
    [anon_sym_by] = ACTIONS(3225),
    [anon_sym_select] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3225),
    [anon_sym_sizeof] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym___makeref] = ACTIONS(3225),
    [anon_sym___reftype] = ACTIONS(3225),
    [anon_sym___refvalue] = ACTIONS(3225),
    [sym_null_literal] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [sym_integer_literal] = ACTIONS(3225),
    [sym_real_literal] = ACTIONS(3227),
    [sym_verbatim_string_literal] = ACTIONS(3227),
    [aux_sym_preproc_if_token1] = ACTIONS(3227),
    [aux_sym_preproc_if_token3] = ACTIONS(3227),
    [aux_sym_preproc_else_token1] = ACTIONS(3227),
    [aux_sym_preproc_elif_token1] = ACTIONS(3227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3227),
    [sym_interpolation_verbatim_start] = ACTIONS(3227),
    [sym_interpolation_raw_start] = ACTIONS(3227),
    [sym_raw_string_start] = ACTIONS(3227),
  },
  [2257] = {
    [sym_preproc_region] = STATE(2257),
    [sym_preproc_endregion] = STATE(2257),
    [sym_preproc_line] = STATE(2257),
    [sym_preproc_pragma] = STATE(2257),
    [sym_preproc_nullable] = STATE(2257),
    [sym_preproc_error] = STATE(2257),
    [sym_preproc_define] = STATE(2257),
    [sym_preproc_undef] = STATE(2257),
    [sym__identifier_token] = ACTIONS(3229),
    [anon_sym_extern] = ACTIONS(3229),
    [anon_sym_alias] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_global] = ACTIONS(3229),
    [anon_sym_using] = ACTIONS(3229),
    [anon_sym_unsafe] = ACTIONS(3229),
    [anon_sym_static] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3229),
    [anon_sym_namespace] = ACTIONS(3229),
    [anon_sym_class] = ACTIONS(3229),
    [anon_sym_ref] = ACTIONS(3229),
    [anon_sym_struct] = ACTIONS(3229),
    [anon_sym_enum] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3229),
    [anon_sym_delegate] = ACTIONS(3229),
    [anon_sym_record] = ACTIONS(3229),
    [anon_sym_abstract] = ACTIONS(3229),
    [anon_sym_async] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_file] = ACTIONS(3229),
    [anon_sym_fixed] = ACTIONS(3229),
    [anon_sym_internal] = ACTIONS(3229),
    [anon_sym_new] = ACTIONS(3229),
    [anon_sym_override] = ACTIONS(3229),
    [anon_sym_partial] = ACTIONS(3229),
    [anon_sym_private] = ACTIONS(3229),
    [anon_sym_protected] = ACTIONS(3229),
    [anon_sym_public] = ACTIONS(3229),
    [anon_sym_readonly] = ACTIONS(3229),
    [anon_sym_required] = ACTIONS(3229),
    [anon_sym_sealed] = ACTIONS(3229),
    [anon_sym_virtual] = ACTIONS(3229),
    [anon_sym_volatile] = ACTIONS(3229),
    [anon_sym_where] = ACTIONS(3229),
    [anon_sym_notnull] = ACTIONS(3229),
    [anon_sym_unmanaged] = ACTIONS(3229),
    [anon_sym_checked] = ACTIONS(3229),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_true] = ACTIONS(3229),
    [anon_sym_false] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_CARET] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3231),
    [anon_sym_this] = ACTIONS(3229),
    [anon_sym_scoped] = ACTIONS(3229),
    [anon_sym_base] = ACTIONS(3229),
    [anon_sym_var] = ACTIONS(3229),
    [sym_predefined_type] = ACTIONS(3229),
    [anon_sym_break] = ACTIONS(3229),
    [anon_sym_unchecked] = ACTIONS(3229),
    [anon_sym_continue] = ACTIONS(3229),
    [anon_sym_do] = ACTIONS(3229),
    [anon_sym_while] = ACTIONS(3229),
    [anon_sym_for] = ACTIONS(3229),
    [anon_sym_lock] = ACTIONS(3229),
    [anon_sym_yield] = ACTIONS(3229),
    [anon_sym_switch] = ACTIONS(3229),
    [anon_sym_default] = ACTIONS(3229),
    [anon_sym_throw] = ACTIONS(3229),
    [anon_sym_try] = ACTIONS(3229),
    [anon_sym_when] = ACTIONS(3229),
    [anon_sym_await] = ACTIONS(3229),
    [anon_sym_foreach] = ACTIONS(3229),
    [anon_sym_goto] = ACTIONS(3229),
    [anon_sym_if] = ACTIONS(3229),
    [anon_sym_else] = ACTIONS(3229),
    [anon_sym_DOT_DOT] = ACTIONS(3231),
    [anon_sym_from] = ACTIONS(3229),
    [anon_sym_into] = ACTIONS(3229),
    [anon_sym_join] = ACTIONS(3229),
    [anon_sym_on] = ACTIONS(3229),
    [anon_sym_equals] = ACTIONS(3229),
    [anon_sym_let] = ACTIONS(3229),
    [anon_sym_orderby] = ACTIONS(3229),
    [anon_sym_ascending] = ACTIONS(3229),
    [anon_sym_descending] = ACTIONS(3229),
    [anon_sym_group] = ACTIONS(3229),
    [anon_sym_by] = ACTIONS(3229),
    [anon_sym_select] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3229),
    [anon_sym_sizeof] = ACTIONS(3229),
    [anon_sym_typeof] = ACTIONS(3229),
    [anon_sym___makeref] = ACTIONS(3229),
    [anon_sym___reftype] = ACTIONS(3229),
    [anon_sym___refvalue] = ACTIONS(3229),
    [sym_null_literal] = ACTIONS(3229),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [sym_integer_literal] = ACTIONS(3229),
    [sym_real_literal] = ACTIONS(3231),
    [sym_verbatim_string_literal] = ACTIONS(3231),
    [aux_sym_preproc_if_token1] = ACTIONS(3231),
    [aux_sym_preproc_if_token3] = ACTIONS(3231),
    [aux_sym_preproc_else_token1] = ACTIONS(3231),
    [aux_sym_preproc_elif_token1] = ACTIONS(3231),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3231),
    [sym_interpolation_verbatim_start] = ACTIONS(3231),
    [sym_interpolation_raw_start] = ACTIONS(3231),
    [sym_raw_string_start] = ACTIONS(3231),
  },
  [2258] = {
    [sym_preproc_region] = STATE(2258),
    [sym_preproc_endregion] = STATE(2258),
    [sym_preproc_line] = STATE(2258),
    [sym_preproc_pragma] = STATE(2258),
    [sym_preproc_nullable] = STATE(2258),
    [sym_preproc_error] = STATE(2258),
    [sym_preproc_define] = STATE(2258),
    [sym_preproc_undef] = STATE(2258),
    [sym__identifier_token] = ACTIONS(3233),
    [anon_sym_extern] = ACTIONS(3233),
    [anon_sym_alias] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_global] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_unsafe] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_ref] = ACTIONS(3233),
    [anon_sym_struct] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_delegate] = ACTIONS(3233),
    [anon_sym_record] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_file] = ACTIONS(3233),
    [anon_sym_fixed] = ACTIONS(3233),
    [anon_sym_internal] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_partial] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_required] = ACTIONS(3233),
    [anon_sym_sealed] = ACTIONS(3233),
    [anon_sym_virtual] = ACTIONS(3233),
    [anon_sym_volatile] = ACTIONS(3233),
    [anon_sym_where] = ACTIONS(3233),
    [anon_sym_notnull] = ACTIONS(3233),
    [anon_sym_unmanaged] = ACTIONS(3233),
    [anon_sym_checked] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_true] = ACTIONS(3233),
    [anon_sym_false] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_STAR] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_this] = ACTIONS(3233),
    [anon_sym_scoped] = ACTIONS(3233),
    [anon_sym_base] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [sym_predefined_type] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_unchecked] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_lock] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_when] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_foreach] = ACTIONS(3233),
    [anon_sym_goto] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_DOT_DOT] = ACTIONS(3235),
    [anon_sym_from] = ACTIONS(3233),
    [anon_sym_into] = ACTIONS(3233),
    [anon_sym_join] = ACTIONS(3233),
    [anon_sym_on] = ACTIONS(3233),
    [anon_sym_equals] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_orderby] = ACTIONS(3233),
    [anon_sym_ascending] = ACTIONS(3233),
    [anon_sym_descending] = ACTIONS(3233),
    [anon_sym_group] = ACTIONS(3233),
    [anon_sym_by] = ACTIONS(3233),
    [anon_sym_select] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3233),
    [anon_sym_sizeof] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym___makeref] = ACTIONS(3233),
    [anon_sym___reftype] = ACTIONS(3233),
    [anon_sym___refvalue] = ACTIONS(3233),
    [sym_null_literal] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [sym_integer_literal] = ACTIONS(3233),
    [sym_real_literal] = ACTIONS(3235),
    [sym_verbatim_string_literal] = ACTIONS(3235),
    [aux_sym_preproc_if_token1] = ACTIONS(3235),
    [aux_sym_preproc_if_token3] = ACTIONS(3235),
    [aux_sym_preproc_else_token1] = ACTIONS(3235),
    [aux_sym_preproc_elif_token1] = ACTIONS(3235),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3235),
    [sym_interpolation_verbatim_start] = ACTIONS(3235),
    [sym_interpolation_raw_start] = ACTIONS(3235),
    [sym_raw_string_start] = ACTIONS(3235),
  },
  [2259] = {
    [sym_preproc_region] = STATE(2259),
    [sym_preproc_endregion] = STATE(2259),
    [sym_preproc_line] = STATE(2259),
    [sym_preproc_pragma] = STATE(2259),
    [sym_preproc_nullable] = STATE(2259),
    [sym_preproc_error] = STATE(2259),
    [sym_preproc_define] = STATE(2259),
    [sym_preproc_undef] = STATE(2259),
    [sym__identifier_token] = ACTIONS(3237),
    [anon_sym_extern] = ACTIONS(3237),
    [anon_sym_alias] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_global] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_unsafe] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_ref] = ACTIONS(3237),
    [anon_sym_struct] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_delegate] = ACTIONS(3237),
    [anon_sym_record] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_file] = ACTIONS(3237),
    [anon_sym_fixed] = ACTIONS(3237),
    [anon_sym_internal] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_partial] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_required] = ACTIONS(3237),
    [anon_sym_sealed] = ACTIONS(3237),
    [anon_sym_virtual] = ACTIONS(3237),
    [anon_sym_volatile] = ACTIONS(3237),
    [anon_sym_where] = ACTIONS(3237),
    [anon_sym_notnull] = ACTIONS(3237),
    [anon_sym_unmanaged] = ACTIONS(3237),
    [anon_sym_checked] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [anon_sym_true] = ACTIONS(3237),
    [anon_sym_false] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_CARET] = ACTIONS(3239),
    [anon_sym_AMP] = ACTIONS(3239),
    [anon_sym_this] = ACTIONS(3237),
    [anon_sym_scoped] = ACTIONS(3237),
    [anon_sym_base] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [sym_predefined_type] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_unchecked] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_lock] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_when] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_foreach] = ACTIONS(3237),
    [anon_sym_goto] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_DOT_DOT] = ACTIONS(3239),
    [anon_sym_from] = ACTIONS(3237),
    [anon_sym_into] = ACTIONS(3237),
    [anon_sym_join] = ACTIONS(3237),
    [anon_sym_on] = ACTIONS(3237),
    [anon_sym_equals] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_orderby] = ACTIONS(3237),
    [anon_sym_ascending] = ACTIONS(3237),
    [anon_sym_descending] = ACTIONS(3237),
    [anon_sym_group] = ACTIONS(3237),
    [anon_sym_by] = ACTIONS(3237),
    [anon_sym_select] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3237),
    [anon_sym_sizeof] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym___makeref] = ACTIONS(3237),
    [anon_sym___reftype] = ACTIONS(3237),
    [anon_sym___refvalue] = ACTIONS(3237),
    [sym_null_literal] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [sym_integer_literal] = ACTIONS(3237),
    [sym_real_literal] = ACTIONS(3239),
    [sym_verbatim_string_literal] = ACTIONS(3239),
    [aux_sym_preproc_if_token1] = ACTIONS(3239),
    [aux_sym_preproc_if_token3] = ACTIONS(3239),
    [aux_sym_preproc_else_token1] = ACTIONS(3239),
    [aux_sym_preproc_elif_token1] = ACTIONS(3239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3239),
    [sym_interpolation_verbatim_start] = ACTIONS(3239),
    [sym_interpolation_raw_start] = ACTIONS(3239),
    [sym_raw_string_start] = ACTIONS(3239),
  },
  [2260] = {
    [sym_preproc_region] = STATE(2260),
    [sym_preproc_endregion] = STATE(2260),
    [sym_preproc_line] = STATE(2260),
    [sym_preproc_pragma] = STATE(2260),
    [sym_preproc_nullable] = STATE(2260),
    [sym_preproc_error] = STATE(2260),
    [sym_preproc_define] = STATE(2260),
    [sym_preproc_undef] = STATE(2260),
    [sym__identifier_token] = ACTIONS(3241),
    [anon_sym_extern] = ACTIONS(3241),
    [anon_sym_alias] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_global] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_unsafe] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_ref] = ACTIONS(3241),
    [anon_sym_struct] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_delegate] = ACTIONS(3241),
    [anon_sym_record] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_file] = ACTIONS(3241),
    [anon_sym_fixed] = ACTIONS(3241),
    [anon_sym_internal] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_partial] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_required] = ACTIONS(3241),
    [anon_sym_sealed] = ACTIONS(3241),
    [anon_sym_virtual] = ACTIONS(3241),
    [anon_sym_volatile] = ACTIONS(3241),
    [anon_sym_where] = ACTIONS(3241),
    [anon_sym_notnull] = ACTIONS(3241),
    [anon_sym_unmanaged] = ACTIONS(3241),
    [anon_sym_checked] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [anon_sym_true] = ACTIONS(3241),
    [anon_sym_false] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_STAR] = ACTIONS(3243),
    [anon_sym_CARET] = ACTIONS(3243),
    [anon_sym_AMP] = ACTIONS(3243),
    [anon_sym_this] = ACTIONS(3241),
    [anon_sym_scoped] = ACTIONS(3241),
    [anon_sym_base] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [sym_predefined_type] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_unchecked] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_lock] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_when] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_foreach] = ACTIONS(3241),
    [anon_sym_goto] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_DOT_DOT] = ACTIONS(3243),
    [anon_sym_from] = ACTIONS(3241),
    [anon_sym_into] = ACTIONS(3241),
    [anon_sym_join] = ACTIONS(3241),
    [anon_sym_on] = ACTIONS(3241),
    [anon_sym_equals] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_orderby] = ACTIONS(3241),
    [anon_sym_ascending] = ACTIONS(3241),
    [anon_sym_descending] = ACTIONS(3241),
    [anon_sym_group] = ACTIONS(3241),
    [anon_sym_by] = ACTIONS(3241),
    [anon_sym_select] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3241),
    [anon_sym_sizeof] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym___makeref] = ACTIONS(3241),
    [anon_sym___reftype] = ACTIONS(3241),
    [anon_sym___refvalue] = ACTIONS(3241),
    [sym_null_literal] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [sym_integer_literal] = ACTIONS(3241),
    [sym_real_literal] = ACTIONS(3243),
    [sym_verbatim_string_literal] = ACTIONS(3243),
    [aux_sym_preproc_if_token1] = ACTIONS(3243),
    [aux_sym_preproc_if_token3] = ACTIONS(3243),
    [aux_sym_preproc_else_token1] = ACTIONS(3243),
    [aux_sym_preproc_elif_token1] = ACTIONS(3243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3243),
    [sym_interpolation_verbatim_start] = ACTIONS(3243),
    [sym_interpolation_raw_start] = ACTIONS(3243),
    [sym_raw_string_start] = ACTIONS(3243),
  },
  [2261] = {
    [sym_preproc_region] = STATE(2261),
    [sym_preproc_endregion] = STATE(2261),
    [sym_preproc_line] = STATE(2261),
    [sym_preproc_pragma] = STATE(2261),
    [sym_preproc_nullable] = STATE(2261),
    [sym_preproc_error] = STATE(2261),
    [sym_preproc_define] = STATE(2261),
    [sym_preproc_undef] = STATE(2261),
    [sym__identifier_token] = ACTIONS(3245),
    [anon_sym_extern] = ACTIONS(3245),
    [anon_sym_alias] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_global] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_unsafe] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_ref] = ACTIONS(3245),
    [anon_sym_struct] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_delegate] = ACTIONS(3245),
    [anon_sym_record] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_file] = ACTIONS(3245),
    [anon_sym_fixed] = ACTIONS(3245),
    [anon_sym_internal] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_partial] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_required] = ACTIONS(3245),
    [anon_sym_sealed] = ACTIONS(3245),
    [anon_sym_virtual] = ACTIONS(3245),
    [anon_sym_volatile] = ACTIONS(3245),
    [anon_sym_where] = ACTIONS(3245),
    [anon_sym_notnull] = ACTIONS(3245),
    [anon_sym_unmanaged] = ACTIONS(3245),
    [anon_sym_checked] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [anon_sym_true] = ACTIONS(3245),
    [anon_sym_false] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_STAR] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3247),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_this] = ACTIONS(3245),
    [anon_sym_scoped] = ACTIONS(3245),
    [anon_sym_base] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [sym_predefined_type] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_unchecked] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_lock] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_when] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_foreach] = ACTIONS(3245),
    [anon_sym_goto] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_DOT_DOT] = ACTIONS(3247),
    [anon_sym_from] = ACTIONS(3245),
    [anon_sym_into] = ACTIONS(3245),
    [anon_sym_join] = ACTIONS(3245),
    [anon_sym_on] = ACTIONS(3245),
    [anon_sym_equals] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_orderby] = ACTIONS(3245),
    [anon_sym_ascending] = ACTIONS(3245),
    [anon_sym_descending] = ACTIONS(3245),
    [anon_sym_group] = ACTIONS(3245),
    [anon_sym_by] = ACTIONS(3245),
    [anon_sym_select] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3245),
    [anon_sym_sizeof] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym___makeref] = ACTIONS(3245),
    [anon_sym___reftype] = ACTIONS(3245),
    [anon_sym___refvalue] = ACTIONS(3245),
    [sym_null_literal] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [sym_integer_literal] = ACTIONS(3245),
    [sym_real_literal] = ACTIONS(3247),
    [sym_verbatim_string_literal] = ACTIONS(3247),
    [aux_sym_preproc_if_token1] = ACTIONS(3247),
    [aux_sym_preproc_if_token3] = ACTIONS(3247),
    [aux_sym_preproc_else_token1] = ACTIONS(3247),
    [aux_sym_preproc_elif_token1] = ACTIONS(3247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3247),
    [sym_interpolation_verbatim_start] = ACTIONS(3247),
    [sym_interpolation_raw_start] = ACTIONS(3247),
    [sym_raw_string_start] = ACTIONS(3247),
  },
  [2262] = {
    [sym_preproc_region] = STATE(2262),
    [sym_preproc_endregion] = STATE(2262),
    [sym_preproc_line] = STATE(2262),
    [sym_preproc_pragma] = STATE(2262),
    [sym_preproc_nullable] = STATE(2262),
    [sym_preproc_error] = STATE(2262),
    [sym_preproc_define] = STATE(2262),
    [sym_preproc_undef] = STATE(2262),
    [sym__identifier_token] = ACTIONS(3249),
    [anon_sym_extern] = ACTIONS(3249),
    [anon_sym_alias] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_global] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_unsafe] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3251),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_ref] = ACTIONS(3249),
    [anon_sym_struct] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3251),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_delegate] = ACTIONS(3249),
    [anon_sym_record] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_file] = ACTIONS(3249),
    [anon_sym_fixed] = ACTIONS(3249),
    [anon_sym_internal] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_partial] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_required] = ACTIONS(3249),
    [anon_sym_sealed] = ACTIONS(3249),
    [anon_sym_virtual] = ACTIONS(3249),
    [anon_sym_volatile] = ACTIONS(3249),
    [anon_sym_where] = ACTIONS(3249),
    [anon_sym_notnull] = ACTIONS(3249),
    [anon_sym_unmanaged] = ACTIONS(3249),
    [anon_sym_checked] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3251),
    [anon_sym_PLUS_PLUS] = ACTIONS(3251),
    [anon_sym_DASH_DASH] = ACTIONS(3251),
    [anon_sym_true] = ACTIONS(3249),
    [anon_sym_false] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_CARET] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_this] = ACTIONS(3249),
    [anon_sym_scoped] = ACTIONS(3249),
    [anon_sym_base] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [sym_predefined_type] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_unchecked] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_lock] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_when] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_foreach] = ACTIONS(3249),
    [anon_sym_goto] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3249),
    [anon_sym_into] = ACTIONS(3249),
    [anon_sym_join] = ACTIONS(3249),
    [anon_sym_on] = ACTIONS(3249),
    [anon_sym_equals] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_orderby] = ACTIONS(3249),
    [anon_sym_ascending] = ACTIONS(3249),
    [anon_sym_descending] = ACTIONS(3249),
    [anon_sym_group] = ACTIONS(3249),
    [anon_sym_by] = ACTIONS(3249),
    [anon_sym_select] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3249),
    [anon_sym_sizeof] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym___makeref] = ACTIONS(3249),
    [anon_sym___reftype] = ACTIONS(3249),
    [anon_sym___refvalue] = ACTIONS(3249),
    [sym_null_literal] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [sym_integer_literal] = ACTIONS(3249),
    [sym_real_literal] = ACTIONS(3251),
    [sym_verbatim_string_literal] = ACTIONS(3251),
    [aux_sym_preproc_if_token1] = ACTIONS(3251),
    [aux_sym_preproc_if_token3] = ACTIONS(3251),
    [aux_sym_preproc_else_token1] = ACTIONS(3251),
    [aux_sym_preproc_elif_token1] = ACTIONS(3251),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3251),
    [sym_interpolation_verbatim_start] = ACTIONS(3251),
    [sym_interpolation_raw_start] = ACTIONS(3251),
    [sym_raw_string_start] = ACTIONS(3251),
  },
  [2263] = {
    [sym_preproc_region] = STATE(2263),
    [sym_preproc_endregion] = STATE(2263),
    [sym_preproc_line] = STATE(2263),
    [sym_preproc_pragma] = STATE(2263),
    [sym_preproc_nullable] = STATE(2263),
    [sym_preproc_error] = STATE(2263),
    [sym_preproc_define] = STATE(2263),
    [sym_preproc_undef] = STATE(2263),
    [sym__identifier_token] = ACTIONS(3253),
    [anon_sym_extern] = ACTIONS(3253),
    [anon_sym_alias] = ACTIONS(3253),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_global] = ACTIONS(3253),
    [anon_sym_using] = ACTIONS(3253),
    [anon_sym_unsafe] = ACTIONS(3253),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3253),
    [anon_sym_namespace] = ACTIONS(3253),
    [anon_sym_class] = ACTIONS(3253),
    [anon_sym_ref] = ACTIONS(3253),
    [anon_sym_struct] = ACTIONS(3253),
    [anon_sym_enum] = ACTIONS(3253),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3253),
    [anon_sym_delegate] = ACTIONS(3253),
    [anon_sym_record] = ACTIONS(3253),
    [anon_sym_abstract] = ACTIONS(3253),
    [anon_sym_async] = ACTIONS(3253),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_file] = ACTIONS(3253),
    [anon_sym_fixed] = ACTIONS(3253),
    [anon_sym_internal] = ACTIONS(3253),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_override] = ACTIONS(3253),
    [anon_sym_partial] = ACTIONS(3253),
    [anon_sym_private] = ACTIONS(3253),
    [anon_sym_protected] = ACTIONS(3253),
    [anon_sym_public] = ACTIONS(3253),
    [anon_sym_readonly] = ACTIONS(3253),
    [anon_sym_required] = ACTIONS(3253),
    [anon_sym_sealed] = ACTIONS(3253),
    [anon_sym_virtual] = ACTIONS(3253),
    [anon_sym_volatile] = ACTIONS(3253),
    [anon_sym_where] = ACTIONS(3253),
    [anon_sym_notnull] = ACTIONS(3253),
    [anon_sym_unmanaged] = ACTIONS(3253),
    [anon_sym_checked] = ACTIONS(3253),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_true] = ACTIONS(3253),
    [anon_sym_false] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_CARET] = ACTIONS(3255),
    [anon_sym_AMP] = ACTIONS(3255),
    [anon_sym_this] = ACTIONS(3253),
    [anon_sym_scoped] = ACTIONS(3253),
    [anon_sym_base] = ACTIONS(3253),
    [anon_sym_var] = ACTIONS(3253),
    [sym_predefined_type] = ACTIONS(3253),
    [anon_sym_break] = ACTIONS(3253),
    [anon_sym_unchecked] = ACTIONS(3253),
    [anon_sym_continue] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3253),
    [anon_sym_while] = ACTIONS(3253),
    [anon_sym_for] = ACTIONS(3253),
    [anon_sym_lock] = ACTIONS(3253),
    [anon_sym_yield] = ACTIONS(3253),
    [anon_sym_switch] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_throw] = ACTIONS(3253),
    [anon_sym_try] = ACTIONS(3253),
    [anon_sym_when] = ACTIONS(3253),
    [anon_sym_await] = ACTIONS(3253),
    [anon_sym_foreach] = ACTIONS(3253),
    [anon_sym_goto] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3253),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_DOT_DOT] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3253),
    [anon_sym_into] = ACTIONS(3253),
    [anon_sym_join] = ACTIONS(3253),
    [anon_sym_on] = ACTIONS(3253),
    [anon_sym_equals] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_orderby] = ACTIONS(3253),
    [anon_sym_ascending] = ACTIONS(3253),
    [anon_sym_descending] = ACTIONS(3253),
    [anon_sym_group] = ACTIONS(3253),
    [anon_sym_by] = ACTIONS(3253),
    [anon_sym_select] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3253),
    [anon_sym_sizeof] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3253),
    [anon_sym___makeref] = ACTIONS(3253),
    [anon_sym___reftype] = ACTIONS(3253),
    [anon_sym___refvalue] = ACTIONS(3253),
    [sym_null_literal] = ACTIONS(3253),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [sym_integer_literal] = ACTIONS(3253),
    [sym_real_literal] = ACTIONS(3255),
    [sym_verbatim_string_literal] = ACTIONS(3255),
    [aux_sym_preproc_if_token1] = ACTIONS(3255),
    [aux_sym_preproc_if_token3] = ACTIONS(3255),
    [aux_sym_preproc_else_token1] = ACTIONS(3255),
    [aux_sym_preproc_elif_token1] = ACTIONS(3255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3255),
    [sym_interpolation_verbatim_start] = ACTIONS(3255),
    [sym_interpolation_raw_start] = ACTIONS(3255),
    [sym_raw_string_start] = ACTIONS(3255),
  },
  [2264] = {
    [sym_preproc_region] = STATE(2264),
    [sym_preproc_endregion] = STATE(2264),
    [sym_preproc_line] = STATE(2264),
    [sym_preproc_pragma] = STATE(2264),
    [sym_preproc_nullable] = STATE(2264),
    [sym_preproc_error] = STATE(2264),
    [sym_preproc_define] = STATE(2264),
    [sym_preproc_undef] = STATE(2264),
    [sym__identifier_token] = ACTIONS(3257),
    [anon_sym_extern] = ACTIONS(3257),
    [anon_sym_alias] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_global] = ACTIONS(3257),
    [anon_sym_using] = ACTIONS(3257),
    [anon_sym_unsafe] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_class] = ACTIONS(3257),
    [anon_sym_ref] = ACTIONS(3257),
    [anon_sym_struct] = ACTIONS(3257),
    [anon_sym_enum] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [anon_sym_interface] = ACTIONS(3257),
    [anon_sym_delegate] = ACTIONS(3257),
    [anon_sym_record] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_async] = ACTIONS(3257),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_file] = ACTIONS(3257),
    [anon_sym_fixed] = ACTIONS(3257),
    [anon_sym_internal] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_partial] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_readonly] = ACTIONS(3257),
    [anon_sym_required] = ACTIONS(3257),
    [anon_sym_sealed] = ACTIONS(3257),
    [anon_sym_virtual] = ACTIONS(3257),
    [anon_sym_volatile] = ACTIONS(3257),
    [anon_sym_where] = ACTIONS(3257),
    [anon_sym_notnull] = ACTIONS(3257),
    [anon_sym_unmanaged] = ACTIONS(3257),
    [anon_sym_checked] = ACTIONS(3257),
    [anon_sym_BANG] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [anon_sym_PLUS_PLUS] = ACTIONS(3259),
    [anon_sym_DASH_DASH] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3257),
    [anon_sym_false] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_CARET] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_this] = ACTIONS(3257),
    [anon_sym_scoped] = ACTIONS(3257),
    [anon_sym_base] = ACTIONS(3257),
    [anon_sym_var] = ACTIONS(3257),
    [sym_predefined_type] = ACTIONS(3257),
    [anon_sym_break] = ACTIONS(3257),
    [anon_sym_unchecked] = ACTIONS(3257),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_lock] = ACTIONS(3257),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_switch] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_throw] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_when] = ACTIONS(3257),
    [anon_sym_await] = ACTIONS(3257),
    [anon_sym_foreach] = ACTIONS(3257),
    [anon_sym_goto] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_else] = ACTIONS(3257),
    [anon_sym_DOT_DOT] = ACTIONS(3259),
    [anon_sym_from] = ACTIONS(3257),
    [anon_sym_into] = ACTIONS(3257),
    [anon_sym_join] = ACTIONS(3257),
    [anon_sym_on] = ACTIONS(3257),
    [anon_sym_equals] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_orderby] = ACTIONS(3257),
    [anon_sym_ascending] = ACTIONS(3257),
    [anon_sym_descending] = ACTIONS(3257),
    [anon_sym_group] = ACTIONS(3257),
    [anon_sym_by] = ACTIONS(3257),
    [anon_sym_select] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3257),
    [anon_sym_sizeof] = ACTIONS(3257),
    [anon_sym_typeof] = ACTIONS(3257),
    [anon_sym___makeref] = ACTIONS(3257),
    [anon_sym___reftype] = ACTIONS(3257),
    [anon_sym___refvalue] = ACTIONS(3257),
    [sym_null_literal] = ACTIONS(3257),
    [anon_sym_SQUOTE] = ACTIONS(3259),
    [sym_integer_literal] = ACTIONS(3257),
    [sym_real_literal] = ACTIONS(3259),
    [sym_verbatim_string_literal] = ACTIONS(3259),
    [aux_sym_preproc_if_token1] = ACTIONS(3259),
    [aux_sym_preproc_if_token3] = ACTIONS(3259),
    [aux_sym_preproc_else_token1] = ACTIONS(3259),
    [aux_sym_preproc_elif_token1] = ACTIONS(3259),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3259),
    [sym_interpolation_verbatim_start] = ACTIONS(3259),
    [sym_interpolation_raw_start] = ACTIONS(3259),
    [sym_raw_string_start] = ACTIONS(3259),
  },
  [2265] = {
    [sym_preproc_region] = STATE(2265),
    [sym_preproc_endregion] = STATE(2265),
    [sym_preproc_line] = STATE(2265),
    [sym_preproc_pragma] = STATE(2265),
    [sym_preproc_nullable] = STATE(2265),
    [sym_preproc_error] = STATE(2265),
    [sym_preproc_define] = STATE(2265),
    [sym_preproc_undef] = STATE(2265),
    [ts_builtin_sym_end] = ACTIONS(3030),
    [sym__identifier_token] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym_alias] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_global] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_unsafe] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_namespace] = ACTIONS(3028),
    [anon_sym_class] = ACTIONS(3028),
    [anon_sym_ref] = ACTIONS(3028),
    [anon_sym_struct] = ACTIONS(3028),
    [anon_sym_enum] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_interface] = ACTIONS(3028),
    [anon_sym_delegate] = ACTIONS(3028),
    [anon_sym_record] = ACTIONS(3028),
    [anon_sym_abstract] = ACTIONS(3028),
    [anon_sym_async] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_file] = ACTIONS(3028),
    [anon_sym_fixed] = ACTIONS(3028),
    [anon_sym_internal] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_override] = ACTIONS(3028),
    [anon_sym_partial] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_readonly] = ACTIONS(3028),
    [anon_sym_required] = ACTIONS(3028),
    [anon_sym_sealed] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_where] = ACTIONS(3028),
    [anon_sym_notnull] = ACTIONS(3028),
    [anon_sym_unmanaged] = ACTIONS(3028),
    [anon_sym_checked] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_true] = ACTIONS(3028),
    [anon_sym_false] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_this] = ACTIONS(3028),
    [anon_sym_scoped] = ACTIONS(3028),
    [anon_sym_base] = ACTIONS(3028),
    [anon_sym_var] = ACTIONS(3028),
    [sym_predefined_type] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_unchecked] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_lock] = ACTIONS(3028),
    [anon_sym_yield] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_catch] = ACTIONS(3028),
    [anon_sym_when] = ACTIONS(3028),
    [anon_sym_finally] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3028),
    [anon_sym_foreach] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_from] = ACTIONS(3028),
    [anon_sym_into] = ACTIONS(3028),
    [anon_sym_join] = ACTIONS(3028),
    [anon_sym_on] = ACTIONS(3028),
    [anon_sym_equals] = ACTIONS(3028),
    [anon_sym_let] = ACTIONS(3028),
    [anon_sym_orderby] = ACTIONS(3028),
    [anon_sym_ascending] = ACTIONS(3028),
    [anon_sym_descending] = ACTIONS(3028),
    [anon_sym_group] = ACTIONS(3028),
    [anon_sym_by] = ACTIONS(3028),
    [anon_sym_select] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_stackalloc] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym_typeof] = ACTIONS(3028),
    [anon_sym___makeref] = ACTIONS(3028),
    [anon_sym___reftype] = ACTIONS(3028),
    [anon_sym___refvalue] = ACTIONS(3028),
    [sym_null_literal] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [sym_integer_literal] = ACTIONS(3028),
    [sym_real_literal] = ACTIONS(3030),
    [sym_verbatim_string_literal] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3030),
    [sym_interpolation_verbatim_start] = ACTIONS(3030),
    [sym_interpolation_raw_start] = ACTIONS(3030),
    [sym_raw_string_start] = ACTIONS(3030),
  },
  [2266] = {
    [sym_preproc_region] = STATE(2266),
    [sym_preproc_endregion] = STATE(2266),
    [sym_preproc_line] = STATE(2266),
    [sym_preproc_pragma] = STATE(2266),
    [sym_preproc_nullable] = STATE(2266),
    [sym_preproc_error] = STATE(2266),
    [sym_preproc_define] = STATE(2266),
    [sym_preproc_undef] = STATE(2266),
    [sym__identifier_token] = ACTIONS(3261),
    [anon_sym_extern] = ACTIONS(3261),
    [anon_sym_alias] = ACTIONS(3261),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_global] = ACTIONS(3261),
    [anon_sym_using] = ACTIONS(3261),
    [anon_sym_unsafe] = ACTIONS(3261),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_namespace] = ACTIONS(3261),
    [anon_sym_class] = ACTIONS(3261),
    [anon_sym_ref] = ACTIONS(3261),
    [anon_sym_struct] = ACTIONS(3261),
    [anon_sym_enum] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_interface] = ACTIONS(3261),
    [anon_sym_delegate] = ACTIONS(3261),
    [anon_sym_record] = ACTIONS(3261),
    [anon_sym_abstract] = ACTIONS(3261),
    [anon_sym_async] = ACTIONS(3261),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_file] = ACTIONS(3261),
    [anon_sym_fixed] = ACTIONS(3261),
    [anon_sym_internal] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_override] = ACTIONS(3261),
    [anon_sym_partial] = ACTIONS(3261),
    [anon_sym_private] = ACTIONS(3261),
    [anon_sym_protected] = ACTIONS(3261),
    [anon_sym_public] = ACTIONS(3261),
    [anon_sym_readonly] = ACTIONS(3261),
    [anon_sym_required] = ACTIONS(3261),
    [anon_sym_sealed] = ACTIONS(3261),
    [anon_sym_virtual] = ACTIONS(3261),
    [anon_sym_volatile] = ACTIONS(3261),
    [anon_sym_where] = ACTIONS(3261),
    [anon_sym_notnull] = ACTIONS(3261),
    [anon_sym_unmanaged] = ACTIONS(3261),
    [anon_sym_checked] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_true] = ACTIONS(3261),
    [anon_sym_false] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_CARET] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3263),
    [anon_sym_this] = ACTIONS(3261),
    [anon_sym_scoped] = ACTIONS(3261),
    [anon_sym_base] = ACTIONS(3261),
    [anon_sym_var] = ACTIONS(3261),
    [sym_predefined_type] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3261),
    [anon_sym_unchecked] = ACTIONS(3261),
    [anon_sym_continue] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_lock] = ACTIONS(3261),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_switch] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_throw] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_when] = ACTIONS(3261),
    [anon_sym_await] = ACTIONS(3261),
    [anon_sym_foreach] = ACTIONS(3261),
    [anon_sym_goto] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_else] = ACTIONS(3261),
    [anon_sym_DOT_DOT] = ACTIONS(3263),
    [anon_sym_from] = ACTIONS(3261),
    [anon_sym_into] = ACTIONS(3261),
    [anon_sym_join] = ACTIONS(3261),
    [anon_sym_on] = ACTIONS(3261),
    [anon_sym_equals] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_orderby] = ACTIONS(3261),
    [anon_sym_ascending] = ACTIONS(3261),
    [anon_sym_descending] = ACTIONS(3261),
    [anon_sym_group] = ACTIONS(3261),
    [anon_sym_by] = ACTIONS(3261),
    [anon_sym_select] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3261),
    [anon_sym_sizeof] = ACTIONS(3261),
    [anon_sym_typeof] = ACTIONS(3261),
    [anon_sym___makeref] = ACTIONS(3261),
    [anon_sym___reftype] = ACTIONS(3261),
    [anon_sym___refvalue] = ACTIONS(3261),
    [sym_null_literal] = ACTIONS(3261),
    [anon_sym_SQUOTE] = ACTIONS(3263),
    [sym_integer_literal] = ACTIONS(3261),
    [sym_real_literal] = ACTIONS(3263),
    [sym_verbatim_string_literal] = ACTIONS(3263),
    [aux_sym_preproc_if_token1] = ACTIONS(3263),
    [aux_sym_preproc_if_token3] = ACTIONS(3263),
    [aux_sym_preproc_else_token1] = ACTIONS(3263),
    [aux_sym_preproc_elif_token1] = ACTIONS(3263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3263),
    [sym_interpolation_verbatim_start] = ACTIONS(3263),
    [sym_interpolation_raw_start] = ACTIONS(3263),
    [sym_raw_string_start] = ACTIONS(3263),
  },
  [2267] = {
    [sym_preproc_region] = STATE(2267),
    [sym_preproc_endregion] = STATE(2267),
    [sym_preproc_line] = STATE(2267),
    [sym_preproc_pragma] = STATE(2267),
    [sym_preproc_nullable] = STATE(2267),
    [sym_preproc_error] = STATE(2267),
    [sym_preproc_define] = STATE(2267),
    [sym_preproc_undef] = STATE(2267),
    [sym__identifier_token] = ACTIONS(3265),
    [anon_sym_extern] = ACTIONS(3265),
    [anon_sym_alias] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_global] = ACTIONS(3265),
    [anon_sym_using] = ACTIONS(3265),
    [anon_sym_unsafe] = ACTIONS(3265),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3265),
    [anon_sym_namespace] = ACTIONS(3265),
    [anon_sym_class] = ACTIONS(3265),
    [anon_sym_ref] = ACTIONS(3265),
    [anon_sym_struct] = ACTIONS(3265),
    [anon_sym_enum] = ACTIONS(3265),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3265),
    [anon_sym_delegate] = ACTIONS(3265),
    [anon_sym_record] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3265),
    [anon_sym_async] = ACTIONS(3265),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_file] = ACTIONS(3265),
    [anon_sym_fixed] = ACTIONS(3265),
    [anon_sym_internal] = ACTIONS(3265),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_override] = ACTIONS(3265),
    [anon_sym_partial] = ACTIONS(3265),
    [anon_sym_private] = ACTIONS(3265),
    [anon_sym_protected] = ACTIONS(3265),
    [anon_sym_public] = ACTIONS(3265),
    [anon_sym_readonly] = ACTIONS(3265),
    [anon_sym_required] = ACTIONS(3265),
    [anon_sym_sealed] = ACTIONS(3265),
    [anon_sym_virtual] = ACTIONS(3265),
    [anon_sym_volatile] = ACTIONS(3265),
    [anon_sym_where] = ACTIONS(3265),
    [anon_sym_notnull] = ACTIONS(3265),
    [anon_sym_unmanaged] = ACTIONS(3265),
    [anon_sym_checked] = ACTIONS(3265),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [anon_sym_true] = ACTIONS(3265),
    [anon_sym_false] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_STAR] = ACTIONS(3267),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3267),
    [anon_sym_this] = ACTIONS(3265),
    [anon_sym_scoped] = ACTIONS(3265),
    [anon_sym_base] = ACTIONS(3265),
    [anon_sym_var] = ACTIONS(3265),
    [sym_predefined_type] = ACTIONS(3265),
    [anon_sym_break] = ACTIONS(3265),
    [anon_sym_unchecked] = ACTIONS(3265),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_do] = ACTIONS(3265),
    [anon_sym_while] = ACTIONS(3265),
    [anon_sym_for] = ACTIONS(3265),
    [anon_sym_lock] = ACTIONS(3265),
    [anon_sym_yield] = ACTIONS(3265),
    [anon_sym_switch] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_throw] = ACTIONS(3265),
    [anon_sym_try] = ACTIONS(3265),
    [anon_sym_when] = ACTIONS(3265),
    [anon_sym_await] = ACTIONS(3265),
    [anon_sym_foreach] = ACTIONS(3265),
    [anon_sym_goto] = ACTIONS(3265),
    [anon_sym_if] = ACTIONS(3265),
    [anon_sym_else] = ACTIONS(3265),
    [anon_sym_DOT_DOT] = ACTIONS(3267),
    [anon_sym_from] = ACTIONS(3265),
    [anon_sym_into] = ACTIONS(3265),
    [anon_sym_join] = ACTIONS(3265),
    [anon_sym_on] = ACTIONS(3265),
    [anon_sym_equals] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_orderby] = ACTIONS(3265),
    [anon_sym_ascending] = ACTIONS(3265),
    [anon_sym_descending] = ACTIONS(3265),
    [anon_sym_group] = ACTIONS(3265),
    [anon_sym_by] = ACTIONS(3265),
    [anon_sym_select] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3265),
    [anon_sym_sizeof] = ACTIONS(3265),
    [anon_sym_typeof] = ACTIONS(3265),
    [anon_sym___makeref] = ACTIONS(3265),
    [anon_sym___reftype] = ACTIONS(3265),
    [anon_sym___refvalue] = ACTIONS(3265),
    [sym_null_literal] = ACTIONS(3265),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [sym_integer_literal] = ACTIONS(3265),
    [sym_real_literal] = ACTIONS(3267),
    [sym_verbatim_string_literal] = ACTIONS(3267),
    [aux_sym_preproc_if_token1] = ACTIONS(3267),
    [aux_sym_preproc_if_token3] = ACTIONS(3267),
    [aux_sym_preproc_else_token1] = ACTIONS(3267),
    [aux_sym_preproc_elif_token1] = ACTIONS(3267),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3267),
    [sym_interpolation_verbatim_start] = ACTIONS(3267),
    [sym_interpolation_raw_start] = ACTIONS(3267),
    [sym_raw_string_start] = ACTIONS(3267),
  },
  [2268] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_else] = STATE(9151),
    [sym_preproc_elif] = STATE(9151),
    [sym_preproc_region] = STATE(2268),
    [sym_preproc_endregion] = STATE(2268),
    [sym_preproc_line] = STATE(2268),
    [sym_preproc_pragma] = STATE(2268),
    [sym_preproc_nullable] = STATE(2268),
    [sym_preproc_error] = STATE(2268),
    [sym_preproc_define] = STATE(2268),
    [sym_preproc_undef] = STATE(2268),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2241),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(3269),
    [aux_sym_preproc_else_token1] = ACTIONS(3163),
    [aux_sym_preproc_elif_token1] = ACTIONS(3165),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2269] = {
    [sym_preproc_region] = STATE(2269),
    [sym_preproc_endregion] = STATE(2269),
    [sym_preproc_line] = STATE(2269),
    [sym_preproc_pragma] = STATE(2269),
    [sym_preproc_nullable] = STATE(2269),
    [sym_preproc_error] = STATE(2269),
    [sym_preproc_define] = STATE(2269),
    [sym_preproc_undef] = STATE(2269),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_record] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_if_token3] = ACTIONS(3003),
    [aux_sym_preproc_else_token1] = ACTIONS(3003),
    [aux_sym_preproc_elif_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2270] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_else] = STATE(8999),
    [sym_preproc_elif] = STATE(8999),
    [sym_preproc_region] = STATE(2270),
    [sym_preproc_endregion] = STATE(2270),
    [sym_preproc_line] = STATE(2270),
    [sym_preproc_pragma] = STATE(2270),
    [sym_preproc_nullable] = STATE(2270),
    [sym_preproc_error] = STATE(2270),
    [sym_preproc_define] = STATE(2270),
    [sym_preproc_undef] = STATE(2270),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(3271),
    [aux_sym_preproc_else_token1] = ACTIONS(3163),
    [aux_sym_preproc_elif_token1] = ACTIONS(3165),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2271] = {
    [sym_preproc_region] = STATE(2271),
    [sym_preproc_endregion] = STATE(2271),
    [sym_preproc_line] = STATE(2271),
    [sym_preproc_pragma] = STATE(2271),
    [sym_preproc_nullable] = STATE(2271),
    [sym_preproc_error] = STATE(2271),
    [sym_preproc_define] = STATE(2271),
    [sym_preproc_undef] = STATE(2271),
    [sym__identifier_token] = ACTIONS(3273),
    [anon_sym_extern] = ACTIONS(3273),
    [anon_sym_alias] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_global] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_unsafe] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_ref] = ACTIONS(3273),
    [anon_sym_struct] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_delegate] = ACTIONS(3273),
    [anon_sym_record] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_file] = ACTIONS(3273),
    [anon_sym_fixed] = ACTIONS(3273),
    [anon_sym_internal] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_partial] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_required] = ACTIONS(3273),
    [anon_sym_sealed] = ACTIONS(3273),
    [anon_sym_virtual] = ACTIONS(3273),
    [anon_sym_volatile] = ACTIONS(3273),
    [anon_sym_where] = ACTIONS(3273),
    [anon_sym_notnull] = ACTIONS(3273),
    [anon_sym_unmanaged] = ACTIONS(3273),
    [anon_sym_checked] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [anon_sym_true] = ACTIONS(3273),
    [anon_sym_false] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3275),
    [anon_sym_CARET] = ACTIONS(3275),
    [anon_sym_AMP] = ACTIONS(3275),
    [anon_sym_this] = ACTIONS(3273),
    [anon_sym_scoped] = ACTIONS(3273),
    [anon_sym_base] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [sym_predefined_type] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_unchecked] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_lock] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_when] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_foreach] = ACTIONS(3273),
    [anon_sym_goto] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_DOT_DOT] = ACTIONS(3275),
    [anon_sym_from] = ACTIONS(3273),
    [anon_sym_into] = ACTIONS(3273),
    [anon_sym_join] = ACTIONS(3273),
    [anon_sym_on] = ACTIONS(3273),
    [anon_sym_equals] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_orderby] = ACTIONS(3273),
    [anon_sym_ascending] = ACTIONS(3273),
    [anon_sym_descending] = ACTIONS(3273),
    [anon_sym_group] = ACTIONS(3273),
    [anon_sym_by] = ACTIONS(3273),
    [anon_sym_select] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3273),
    [anon_sym_sizeof] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym___makeref] = ACTIONS(3273),
    [anon_sym___reftype] = ACTIONS(3273),
    [anon_sym___refvalue] = ACTIONS(3273),
    [sym_null_literal] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [sym_integer_literal] = ACTIONS(3273),
    [sym_real_literal] = ACTIONS(3275),
    [sym_verbatim_string_literal] = ACTIONS(3275),
    [aux_sym_preproc_if_token1] = ACTIONS(3275),
    [aux_sym_preproc_if_token3] = ACTIONS(3275),
    [aux_sym_preproc_else_token1] = ACTIONS(3275),
    [aux_sym_preproc_elif_token1] = ACTIONS(3275),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3275),
    [sym_interpolation_verbatim_start] = ACTIONS(3275),
    [sym_interpolation_raw_start] = ACTIONS(3275),
    [sym_raw_string_start] = ACTIONS(3275),
  },
  [2272] = {
    [sym_preproc_region] = STATE(2272),
    [sym_preproc_endregion] = STATE(2272),
    [sym_preproc_line] = STATE(2272),
    [sym_preproc_pragma] = STATE(2272),
    [sym_preproc_nullable] = STATE(2272),
    [sym_preproc_error] = STATE(2272),
    [sym_preproc_define] = STATE(2272),
    [sym_preproc_undef] = STATE(2272),
    [sym__identifier_token] = ACTIONS(3277),
    [anon_sym_extern] = ACTIONS(3277),
    [anon_sym_alias] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_global] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_unsafe] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_ref] = ACTIONS(3277),
    [anon_sym_struct] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_delegate] = ACTIONS(3277),
    [anon_sym_record] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_file] = ACTIONS(3277),
    [anon_sym_fixed] = ACTIONS(3277),
    [anon_sym_internal] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_partial] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_required] = ACTIONS(3277),
    [anon_sym_sealed] = ACTIONS(3277),
    [anon_sym_virtual] = ACTIONS(3277),
    [anon_sym_volatile] = ACTIONS(3277),
    [anon_sym_where] = ACTIONS(3277),
    [anon_sym_notnull] = ACTIONS(3277),
    [anon_sym_unmanaged] = ACTIONS(3277),
    [anon_sym_checked] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(3277),
    [anon_sym_false] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_STAR] = ACTIONS(3279),
    [anon_sym_CARET] = ACTIONS(3279),
    [anon_sym_AMP] = ACTIONS(3279),
    [anon_sym_this] = ACTIONS(3277),
    [anon_sym_scoped] = ACTIONS(3277),
    [anon_sym_base] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [sym_predefined_type] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_unchecked] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_lock] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_when] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_foreach] = ACTIONS(3277),
    [anon_sym_goto] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_DOT_DOT] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3277),
    [anon_sym_into] = ACTIONS(3277),
    [anon_sym_join] = ACTIONS(3277),
    [anon_sym_on] = ACTIONS(3277),
    [anon_sym_equals] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_orderby] = ACTIONS(3277),
    [anon_sym_ascending] = ACTIONS(3277),
    [anon_sym_descending] = ACTIONS(3277),
    [anon_sym_group] = ACTIONS(3277),
    [anon_sym_by] = ACTIONS(3277),
    [anon_sym_select] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3277),
    [anon_sym_sizeof] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym___makeref] = ACTIONS(3277),
    [anon_sym___reftype] = ACTIONS(3277),
    [anon_sym___refvalue] = ACTIONS(3277),
    [sym_null_literal] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [sym_integer_literal] = ACTIONS(3277),
    [sym_real_literal] = ACTIONS(3279),
    [sym_verbatim_string_literal] = ACTIONS(3279),
    [aux_sym_preproc_if_token1] = ACTIONS(3279),
    [aux_sym_preproc_if_token3] = ACTIONS(3279),
    [aux_sym_preproc_else_token1] = ACTIONS(3279),
    [aux_sym_preproc_elif_token1] = ACTIONS(3279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3279),
    [sym_interpolation_verbatim_start] = ACTIONS(3279),
    [sym_interpolation_raw_start] = ACTIONS(3279),
    [sym_raw_string_start] = ACTIONS(3279),
  },
  [2273] = {
    [sym_preproc_region] = STATE(2273),
    [sym_preproc_endregion] = STATE(2273),
    [sym_preproc_line] = STATE(2273),
    [sym_preproc_pragma] = STATE(2273),
    [sym_preproc_nullable] = STATE(2273),
    [sym_preproc_error] = STATE(2273),
    [sym_preproc_define] = STATE(2273),
    [sym_preproc_undef] = STATE(2273),
    [sym__identifier_token] = ACTIONS(3281),
    [anon_sym_extern] = ACTIONS(3281),
    [anon_sym_alias] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_global] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_unsafe] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_ref] = ACTIONS(3281),
    [anon_sym_struct] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_delegate] = ACTIONS(3281),
    [anon_sym_record] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_file] = ACTIONS(3281),
    [anon_sym_fixed] = ACTIONS(3281),
    [anon_sym_internal] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_partial] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_required] = ACTIONS(3281),
    [anon_sym_sealed] = ACTIONS(3281),
    [anon_sym_virtual] = ACTIONS(3281),
    [anon_sym_volatile] = ACTIONS(3281),
    [anon_sym_where] = ACTIONS(3281),
    [anon_sym_notnull] = ACTIONS(3281),
    [anon_sym_unmanaged] = ACTIONS(3281),
    [anon_sym_checked] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_true] = ACTIONS(3281),
    [anon_sym_false] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_this] = ACTIONS(3281),
    [anon_sym_scoped] = ACTIONS(3281),
    [anon_sym_base] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [sym_predefined_type] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_unchecked] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_lock] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_foreach] = ACTIONS(3281),
    [anon_sym_goto] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_DOT_DOT] = ACTIONS(3283),
    [anon_sym_from] = ACTIONS(3281),
    [anon_sym_into] = ACTIONS(3281),
    [anon_sym_join] = ACTIONS(3281),
    [anon_sym_on] = ACTIONS(3281),
    [anon_sym_equals] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_orderby] = ACTIONS(3281),
    [anon_sym_ascending] = ACTIONS(3281),
    [anon_sym_descending] = ACTIONS(3281),
    [anon_sym_group] = ACTIONS(3281),
    [anon_sym_by] = ACTIONS(3281),
    [anon_sym_select] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym___makeref] = ACTIONS(3281),
    [anon_sym___reftype] = ACTIONS(3281),
    [anon_sym___refvalue] = ACTIONS(3281),
    [sym_null_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [sym_integer_literal] = ACTIONS(3281),
    [sym_real_literal] = ACTIONS(3283),
    [sym_verbatim_string_literal] = ACTIONS(3283),
    [aux_sym_preproc_if_token1] = ACTIONS(3283),
    [aux_sym_preproc_if_token3] = ACTIONS(3283),
    [aux_sym_preproc_else_token1] = ACTIONS(3283),
    [aux_sym_preproc_elif_token1] = ACTIONS(3283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3283),
    [sym_interpolation_verbatim_start] = ACTIONS(3283),
    [sym_interpolation_raw_start] = ACTIONS(3283),
    [sym_raw_string_start] = ACTIONS(3283),
  },
  [2274] = {
    [sym_preproc_region] = STATE(2274),
    [sym_preproc_endregion] = STATE(2274),
    [sym_preproc_line] = STATE(2274),
    [sym_preproc_pragma] = STATE(2274),
    [sym_preproc_nullable] = STATE(2274),
    [sym_preproc_error] = STATE(2274),
    [sym_preproc_define] = STATE(2274),
    [sym_preproc_undef] = STATE(2274),
    [sym__identifier_token] = ACTIONS(3285),
    [anon_sym_extern] = ACTIONS(3285),
    [anon_sym_alias] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_unsafe] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_ref] = ACTIONS(3285),
    [anon_sym_struct] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_delegate] = ACTIONS(3285),
    [anon_sym_record] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_file] = ACTIONS(3285),
    [anon_sym_fixed] = ACTIONS(3285),
    [anon_sym_internal] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_partial] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_required] = ACTIONS(3285),
    [anon_sym_sealed] = ACTIONS(3285),
    [anon_sym_virtual] = ACTIONS(3285),
    [anon_sym_volatile] = ACTIONS(3285),
    [anon_sym_where] = ACTIONS(3285),
    [anon_sym_notnull] = ACTIONS(3285),
    [anon_sym_unmanaged] = ACTIONS(3285),
    [anon_sym_checked] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_true] = ACTIONS(3285),
    [anon_sym_false] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_CARET] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym_this] = ACTIONS(3285),
    [anon_sym_scoped] = ACTIONS(3285),
    [anon_sym_base] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [sym_predefined_type] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_unchecked] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_lock] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_when] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_foreach] = ACTIONS(3285),
    [anon_sym_goto] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_from] = ACTIONS(3285),
    [anon_sym_into] = ACTIONS(3285),
    [anon_sym_join] = ACTIONS(3285),
    [anon_sym_on] = ACTIONS(3285),
    [anon_sym_equals] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_orderby] = ACTIONS(3285),
    [anon_sym_ascending] = ACTIONS(3285),
    [anon_sym_descending] = ACTIONS(3285),
    [anon_sym_group] = ACTIONS(3285),
    [anon_sym_by] = ACTIONS(3285),
    [anon_sym_select] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3285),
    [anon_sym_sizeof] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym___makeref] = ACTIONS(3285),
    [anon_sym___reftype] = ACTIONS(3285),
    [anon_sym___refvalue] = ACTIONS(3285),
    [sym_null_literal] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [sym_integer_literal] = ACTIONS(3285),
    [sym_real_literal] = ACTIONS(3287),
    [sym_verbatim_string_literal] = ACTIONS(3287),
    [aux_sym_preproc_if_token1] = ACTIONS(3287),
    [aux_sym_preproc_if_token3] = ACTIONS(3287),
    [aux_sym_preproc_else_token1] = ACTIONS(3287),
    [aux_sym_preproc_elif_token1] = ACTIONS(3287),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3287),
    [sym_interpolation_verbatim_start] = ACTIONS(3287),
    [sym_interpolation_raw_start] = ACTIONS(3287),
    [sym_raw_string_start] = ACTIONS(3287),
  },
  [2275] = {
    [sym_preproc_region] = STATE(2275),
    [sym_preproc_endregion] = STATE(2275),
    [sym_preproc_line] = STATE(2275),
    [sym_preproc_pragma] = STATE(2275),
    [sym_preproc_nullable] = STATE(2275),
    [sym_preproc_error] = STATE(2275),
    [sym_preproc_define] = STATE(2275),
    [sym_preproc_undef] = STATE(2275),
    [sym__identifier_token] = ACTIONS(3289),
    [anon_sym_extern] = ACTIONS(3289),
    [anon_sym_alias] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_unsafe] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_ref] = ACTIONS(3289),
    [anon_sym_struct] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_delegate] = ACTIONS(3289),
    [anon_sym_record] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_file] = ACTIONS(3289),
    [anon_sym_fixed] = ACTIONS(3289),
    [anon_sym_internal] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_partial] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_required] = ACTIONS(3289),
    [anon_sym_sealed] = ACTIONS(3289),
    [anon_sym_virtual] = ACTIONS(3289),
    [anon_sym_volatile] = ACTIONS(3289),
    [anon_sym_where] = ACTIONS(3289),
    [anon_sym_notnull] = ACTIONS(3289),
    [anon_sym_unmanaged] = ACTIONS(3289),
    [anon_sym_checked] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_true] = ACTIONS(3289),
    [anon_sym_false] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3291),
    [anon_sym_CARET] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_this] = ACTIONS(3289),
    [anon_sym_scoped] = ACTIONS(3289),
    [anon_sym_base] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [sym_predefined_type] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_unchecked] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_lock] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_when] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_foreach] = ACTIONS(3289),
    [anon_sym_goto] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_DOT_DOT] = ACTIONS(3291),
    [anon_sym_from] = ACTIONS(3289),
    [anon_sym_into] = ACTIONS(3289),
    [anon_sym_join] = ACTIONS(3289),
    [anon_sym_on] = ACTIONS(3289),
    [anon_sym_equals] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_orderby] = ACTIONS(3289),
    [anon_sym_ascending] = ACTIONS(3289),
    [anon_sym_descending] = ACTIONS(3289),
    [anon_sym_group] = ACTIONS(3289),
    [anon_sym_by] = ACTIONS(3289),
    [anon_sym_select] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym___makeref] = ACTIONS(3289),
    [anon_sym___reftype] = ACTIONS(3289),
    [anon_sym___refvalue] = ACTIONS(3289),
    [sym_null_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [sym_integer_literal] = ACTIONS(3289),
    [sym_real_literal] = ACTIONS(3291),
    [sym_verbatim_string_literal] = ACTIONS(3291),
    [aux_sym_preproc_if_token1] = ACTIONS(3291),
    [aux_sym_preproc_if_token3] = ACTIONS(3291),
    [aux_sym_preproc_else_token1] = ACTIONS(3291),
    [aux_sym_preproc_elif_token1] = ACTIONS(3291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3291),
    [sym_interpolation_verbatim_start] = ACTIONS(3291),
    [sym_interpolation_raw_start] = ACTIONS(3291),
    [sym_raw_string_start] = ACTIONS(3291),
  },
  [2276] = {
    [sym_preproc_region] = STATE(2276),
    [sym_preproc_endregion] = STATE(2276),
    [sym_preproc_line] = STATE(2276),
    [sym_preproc_pragma] = STATE(2276),
    [sym_preproc_nullable] = STATE(2276),
    [sym_preproc_error] = STATE(2276),
    [sym_preproc_define] = STATE(2276),
    [sym_preproc_undef] = STATE(2276),
    [sym__identifier_token] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym_alias] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_global] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_unsafe] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_ref] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_delegate] = ACTIONS(3293),
    [anon_sym_record] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_file] = ACTIONS(3293),
    [anon_sym_fixed] = ACTIONS(3293),
    [anon_sym_internal] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_partial] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_required] = ACTIONS(3293),
    [anon_sym_sealed] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_where] = ACTIONS(3293),
    [anon_sym_notnull] = ACTIONS(3293),
    [anon_sym_unmanaged] = ACTIONS(3293),
    [anon_sym_checked] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_true] = ACTIONS(3293),
    [anon_sym_false] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_this] = ACTIONS(3293),
    [anon_sym_scoped] = ACTIONS(3293),
    [anon_sym_base] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [sym_predefined_type] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_unchecked] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_lock] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_when] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_foreach] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_from] = ACTIONS(3293),
    [anon_sym_into] = ACTIONS(3293),
    [anon_sym_join] = ACTIONS(3293),
    [anon_sym_on] = ACTIONS(3293),
    [anon_sym_equals] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_orderby] = ACTIONS(3293),
    [anon_sym_ascending] = ACTIONS(3293),
    [anon_sym_descending] = ACTIONS(3293),
    [anon_sym_group] = ACTIONS(3293),
    [anon_sym_by] = ACTIONS(3293),
    [anon_sym_select] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym___makeref] = ACTIONS(3293),
    [anon_sym___reftype] = ACTIONS(3293),
    [anon_sym___refvalue] = ACTIONS(3293),
    [sym_null_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [sym_integer_literal] = ACTIONS(3293),
    [sym_real_literal] = ACTIONS(3295),
    [sym_verbatim_string_literal] = ACTIONS(3295),
    [aux_sym_preproc_if_token1] = ACTIONS(3295),
    [aux_sym_preproc_if_token3] = ACTIONS(3295),
    [aux_sym_preproc_else_token1] = ACTIONS(3295),
    [aux_sym_preproc_elif_token1] = ACTIONS(3295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3295),
    [sym_interpolation_verbatim_start] = ACTIONS(3295),
    [sym_interpolation_raw_start] = ACTIONS(3295),
    [sym_raw_string_start] = ACTIONS(3295),
  },
  [2277] = {
    [sym_preproc_region] = STATE(2277),
    [sym_preproc_endregion] = STATE(2277),
    [sym_preproc_line] = STATE(2277),
    [sym_preproc_pragma] = STATE(2277),
    [sym_preproc_nullable] = STATE(2277),
    [sym_preproc_error] = STATE(2277),
    [sym_preproc_define] = STATE(2277),
    [sym_preproc_undef] = STATE(2277),
    [ts_builtin_sym_end] = ACTIONS(3026),
    [sym__identifier_token] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym_alias] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_global] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_unsafe] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_namespace] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_ref] = ACTIONS(3024),
    [anon_sym_struct] = ACTIONS(3024),
    [anon_sym_enum] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_interface] = ACTIONS(3024),
    [anon_sym_delegate] = ACTIONS(3024),
    [anon_sym_record] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_file] = ACTIONS(3024),
    [anon_sym_fixed] = ACTIONS(3024),
    [anon_sym_internal] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_override] = ACTIONS(3024),
    [anon_sym_partial] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_readonly] = ACTIONS(3024),
    [anon_sym_required] = ACTIONS(3024),
    [anon_sym_sealed] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_where] = ACTIONS(3024),
    [anon_sym_notnull] = ACTIONS(3024),
    [anon_sym_unmanaged] = ACTIONS(3024),
    [anon_sym_checked] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_true] = ACTIONS(3024),
    [anon_sym_false] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_CARET] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_this] = ACTIONS(3024),
    [anon_sym_scoped] = ACTIONS(3024),
    [anon_sym_base] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [sym_predefined_type] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_unchecked] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_lock] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_catch] = ACTIONS(3024),
    [anon_sym_when] = ACTIONS(3024),
    [anon_sym_finally] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_foreach] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_from] = ACTIONS(3024),
    [anon_sym_into] = ACTIONS(3024),
    [anon_sym_join] = ACTIONS(3024),
    [anon_sym_on] = ACTIONS(3024),
    [anon_sym_equals] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_orderby] = ACTIONS(3024),
    [anon_sym_ascending] = ACTIONS(3024),
    [anon_sym_descending] = ACTIONS(3024),
    [anon_sym_group] = ACTIONS(3024),
    [anon_sym_by] = ACTIONS(3024),
    [anon_sym_select] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [anon_sym_stackalloc] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym___makeref] = ACTIONS(3024),
    [anon_sym___reftype] = ACTIONS(3024),
    [anon_sym___refvalue] = ACTIONS(3024),
    [sym_null_literal] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [sym_integer_literal] = ACTIONS(3024),
    [sym_real_literal] = ACTIONS(3026),
    [sym_verbatim_string_literal] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3026),
    [sym_interpolation_verbatim_start] = ACTIONS(3026),
    [sym_interpolation_raw_start] = ACTIONS(3026),
    [sym_raw_string_start] = ACTIONS(3026),
  },
  [2278] = {
    [sym_preproc_region] = STATE(2278),
    [sym_preproc_endregion] = STATE(2278),
    [sym_preproc_line] = STATE(2278),
    [sym_preproc_pragma] = STATE(2278),
    [sym_preproc_nullable] = STATE(2278),
    [sym_preproc_error] = STATE(2278),
    [sym_preproc_define] = STATE(2278),
    [sym_preproc_undef] = STATE(2278),
    [sym__identifier_token] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym_alias] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_global] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_unsafe] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_ref] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_delegate] = ACTIONS(3297),
    [anon_sym_record] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_file] = ACTIONS(3297),
    [anon_sym_fixed] = ACTIONS(3297),
    [anon_sym_internal] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_partial] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_required] = ACTIONS(3297),
    [anon_sym_sealed] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_where] = ACTIONS(3297),
    [anon_sym_notnull] = ACTIONS(3297),
    [anon_sym_unmanaged] = ACTIONS(3297),
    [anon_sym_checked] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_true] = ACTIONS(3297),
    [anon_sym_false] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_CARET] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3299),
    [anon_sym_this] = ACTIONS(3297),
    [anon_sym_scoped] = ACTIONS(3297),
    [anon_sym_base] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [sym_predefined_type] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_unchecked] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_lock] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_when] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_foreach] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_DOT_DOT] = ACTIONS(3299),
    [anon_sym_from] = ACTIONS(3297),
    [anon_sym_into] = ACTIONS(3297),
    [anon_sym_join] = ACTIONS(3297),
    [anon_sym_on] = ACTIONS(3297),
    [anon_sym_equals] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_orderby] = ACTIONS(3297),
    [anon_sym_ascending] = ACTIONS(3297),
    [anon_sym_descending] = ACTIONS(3297),
    [anon_sym_group] = ACTIONS(3297),
    [anon_sym_by] = ACTIONS(3297),
    [anon_sym_select] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3297),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym___makeref] = ACTIONS(3297),
    [anon_sym___reftype] = ACTIONS(3297),
    [anon_sym___refvalue] = ACTIONS(3297),
    [sym_null_literal] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [sym_integer_literal] = ACTIONS(3297),
    [sym_real_literal] = ACTIONS(3299),
    [sym_verbatim_string_literal] = ACTIONS(3299),
    [aux_sym_preproc_if_token1] = ACTIONS(3299),
    [aux_sym_preproc_if_token3] = ACTIONS(3299),
    [aux_sym_preproc_else_token1] = ACTIONS(3299),
    [aux_sym_preproc_elif_token1] = ACTIONS(3299),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3299),
    [sym_interpolation_verbatim_start] = ACTIONS(3299),
    [sym_interpolation_raw_start] = ACTIONS(3299),
    [sym_raw_string_start] = ACTIONS(3299),
  },
  [2279] = {
    [sym_preproc_region] = STATE(2279),
    [sym_preproc_endregion] = STATE(2279),
    [sym_preproc_line] = STATE(2279),
    [sym_preproc_pragma] = STATE(2279),
    [sym_preproc_nullable] = STATE(2279),
    [sym_preproc_error] = STATE(2279),
    [sym_preproc_define] = STATE(2279),
    [sym_preproc_undef] = STATE(2279),
    [sym__identifier_token] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym_alias] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_global] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_unsafe] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_ref] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_delegate] = ACTIONS(3301),
    [anon_sym_record] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_file] = ACTIONS(3301),
    [anon_sym_fixed] = ACTIONS(3301),
    [anon_sym_internal] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_partial] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_required] = ACTIONS(3301),
    [anon_sym_sealed] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_where] = ACTIONS(3301),
    [anon_sym_notnull] = ACTIONS(3301),
    [anon_sym_unmanaged] = ACTIONS(3301),
    [anon_sym_checked] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_true] = ACTIONS(3301),
    [anon_sym_false] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_CARET] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_this] = ACTIONS(3301),
    [anon_sym_scoped] = ACTIONS(3301),
    [anon_sym_base] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [sym_predefined_type] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_unchecked] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_lock] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_when] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_foreach] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_DOT_DOT] = ACTIONS(3303),
    [anon_sym_from] = ACTIONS(3301),
    [anon_sym_into] = ACTIONS(3301),
    [anon_sym_join] = ACTIONS(3301),
    [anon_sym_on] = ACTIONS(3301),
    [anon_sym_equals] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_orderby] = ACTIONS(3301),
    [anon_sym_ascending] = ACTIONS(3301),
    [anon_sym_descending] = ACTIONS(3301),
    [anon_sym_group] = ACTIONS(3301),
    [anon_sym_by] = ACTIONS(3301),
    [anon_sym_select] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3301),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym___makeref] = ACTIONS(3301),
    [anon_sym___reftype] = ACTIONS(3301),
    [anon_sym___refvalue] = ACTIONS(3301),
    [sym_null_literal] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [sym_integer_literal] = ACTIONS(3301),
    [sym_real_literal] = ACTIONS(3303),
    [sym_verbatim_string_literal] = ACTIONS(3303),
    [aux_sym_preproc_if_token1] = ACTIONS(3303),
    [aux_sym_preproc_if_token3] = ACTIONS(3303),
    [aux_sym_preproc_else_token1] = ACTIONS(3303),
    [aux_sym_preproc_elif_token1] = ACTIONS(3303),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3303),
    [sym_interpolation_verbatim_start] = ACTIONS(3303),
    [sym_interpolation_raw_start] = ACTIONS(3303),
    [sym_raw_string_start] = ACTIONS(3303),
  },
  [2280] = {
    [sym_preproc_region] = STATE(2280),
    [sym_preproc_endregion] = STATE(2280),
    [sym_preproc_line] = STATE(2280),
    [sym_preproc_pragma] = STATE(2280),
    [sym_preproc_nullable] = STATE(2280),
    [sym_preproc_error] = STATE(2280),
    [sym_preproc_define] = STATE(2280),
    [sym_preproc_undef] = STATE(2280),
    [sym__identifier_token] = ACTIONS(3305),
    [anon_sym_extern] = ACTIONS(3305),
    [anon_sym_alias] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_global] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_unsafe] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_ref] = ACTIONS(3305),
    [anon_sym_struct] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_delegate] = ACTIONS(3305),
    [anon_sym_record] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_file] = ACTIONS(3305),
    [anon_sym_fixed] = ACTIONS(3305),
    [anon_sym_internal] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_partial] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_required] = ACTIONS(3305),
    [anon_sym_sealed] = ACTIONS(3305),
    [anon_sym_virtual] = ACTIONS(3305),
    [anon_sym_volatile] = ACTIONS(3305),
    [anon_sym_where] = ACTIONS(3305),
    [anon_sym_notnull] = ACTIONS(3305),
    [anon_sym_unmanaged] = ACTIONS(3305),
    [anon_sym_checked] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_true] = ACTIONS(3305),
    [anon_sym_false] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_this] = ACTIONS(3305),
    [anon_sym_scoped] = ACTIONS(3305),
    [anon_sym_base] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [sym_predefined_type] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_unchecked] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_lock] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_when] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_foreach] = ACTIONS(3305),
    [anon_sym_goto] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_DOT_DOT] = ACTIONS(3307),
    [anon_sym_from] = ACTIONS(3305),
    [anon_sym_into] = ACTIONS(3305),
    [anon_sym_join] = ACTIONS(3305),
    [anon_sym_on] = ACTIONS(3305),
    [anon_sym_equals] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_orderby] = ACTIONS(3305),
    [anon_sym_ascending] = ACTIONS(3305),
    [anon_sym_descending] = ACTIONS(3305),
    [anon_sym_group] = ACTIONS(3305),
    [anon_sym_by] = ACTIONS(3305),
    [anon_sym_select] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3305),
    [anon_sym_sizeof] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym___makeref] = ACTIONS(3305),
    [anon_sym___reftype] = ACTIONS(3305),
    [anon_sym___refvalue] = ACTIONS(3305),
    [sym_null_literal] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [sym_integer_literal] = ACTIONS(3305),
    [sym_real_literal] = ACTIONS(3307),
    [sym_verbatim_string_literal] = ACTIONS(3307),
    [aux_sym_preproc_if_token1] = ACTIONS(3307),
    [aux_sym_preproc_if_token3] = ACTIONS(3307),
    [aux_sym_preproc_else_token1] = ACTIONS(3307),
    [aux_sym_preproc_elif_token1] = ACTIONS(3307),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3307),
    [sym_interpolation_verbatim_start] = ACTIONS(3307),
    [sym_interpolation_raw_start] = ACTIONS(3307),
    [sym_raw_string_start] = ACTIONS(3307),
  },
  [2281] = {
    [sym_preproc_region] = STATE(2281),
    [sym_preproc_endregion] = STATE(2281),
    [sym_preproc_line] = STATE(2281),
    [sym_preproc_pragma] = STATE(2281),
    [sym_preproc_nullable] = STATE(2281),
    [sym_preproc_error] = STATE(2281),
    [sym_preproc_define] = STATE(2281),
    [sym_preproc_undef] = STATE(2281),
    [ts_builtin_sym_end] = ACTIONS(3042),
    [sym__identifier_token] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym_alias] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_global] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_unsafe] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3040),
    [anon_sym_delegate] = ACTIONS(3040),
    [anon_sym_record] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_file] = ACTIONS(3040),
    [anon_sym_fixed] = ACTIONS(3040),
    [anon_sym_internal] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_partial] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_required] = ACTIONS(3040),
    [anon_sym_sealed] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3040),
    [anon_sym_notnull] = ACTIONS(3040),
    [anon_sym_unmanaged] = ACTIONS(3040),
    [anon_sym_checked] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_true] = ACTIONS(3040),
    [anon_sym_false] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_this] = ACTIONS(3040),
    [anon_sym_scoped] = ACTIONS(3040),
    [anon_sym_base] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [sym_predefined_type] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_unchecked] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_lock] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_catch] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_finally] = ACTIONS(3040),
    [anon_sym_await] = ACTIONS(3040),
    [anon_sym_foreach] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_from] = ACTIONS(3040),
    [anon_sym_into] = ACTIONS(3040),
    [anon_sym_join] = ACTIONS(3040),
    [anon_sym_on] = ACTIONS(3040),
    [anon_sym_equals] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_orderby] = ACTIONS(3040),
    [anon_sym_ascending] = ACTIONS(3040),
    [anon_sym_descending] = ACTIONS(3040),
    [anon_sym_group] = ACTIONS(3040),
    [anon_sym_by] = ACTIONS(3040),
    [anon_sym_select] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_stackalloc] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym_typeof] = ACTIONS(3040),
    [anon_sym___makeref] = ACTIONS(3040),
    [anon_sym___reftype] = ACTIONS(3040),
    [anon_sym___refvalue] = ACTIONS(3040),
    [sym_null_literal] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [sym_integer_literal] = ACTIONS(3040),
    [sym_real_literal] = ACTIONS(3042),
    [sym_verbatim_string_literal] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3042),
    [sym_interpolation_verbatim_start] = ACTIONS(3042),
    [sym_interpolation_raw_start] = ACTIONS(3042),
    [sym_raw_string_start] = ACTIONS(3042),
  },
  [2282] = {
    [sym_preproc_region] = STATE(2282),
    [sym_preproc_endregion] = STATE(2282),
    [sym_preproc_line] = STATE(2282),
    [sym_preproc_pragma] = STATE(2282),
    [sym_preproc_nullable] = STATE(2282),
    [sym_preproc_error] = STATE(2282),
    [sym_preproc_define] = STATE(2282),
    [sym_preproc_undef] = STATE(2282),
    [sym__identifier_token] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym_alias] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_global] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_unsafe] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_ref] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_delegate] = ACTIONS(3309),
    [anon_sym_record] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_file] = ACTIONS(3309),
    [anon_sym_fixed] = ACTIONS(3309),
    [anon_sym_internal] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_partial] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_required] = ACTIONS(3309),
    [anon_sym_sealed] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_where] = ACTIONS(3309),
    [anon_sym_notnull] = ACTIONS(3309),
    [anon_sym_unmanaged] = ACTIONS(3309),
    [anon_sym_checked] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_true] = ACTIONS(3309),
    [anon_sym_false] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_CARET] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3311),
    [anon_sym_this] = ACTIONS(3309),
    [anon_sym_scoped] = ACTIONS(3309),
    [anon_sym_base] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [sym_predefined_type] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_unchecked] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_lock] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_when] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_foreach] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_DOT_DOT] = ACTIONS(3311),
    [anon_sym_from] = ACTIONS(3309),
    [anon_sym_into] = ACTIONS(3309),
    [anon_sym_join] = ACTIONS(3309),
    [anon_sym_on] = ACTIONS(3309),
    [anon_sym_equals] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_orderby] = ACTIONS(3309),
    [anon_sym_ascending] = ACTIONS(3309),
    [anon_sym_descending] = ACTIONS(3309),
    [anon_sym_group] = ACTIONS(3309),
    [anon_sym_by] = ACTIONS(3309),
    [anon_sym_select] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3309),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym___makeref] = ACTIONS(3309),
    [anon_sym___reftype] = ACTIONS(3309),
    [anon_sym___refvalue] = ACTIONS(3309),
    [sym_null_literal] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_integer_literal] = ACTIONS(3309),
    [sym_real_literal] = ACTIONS(3311),
    [sym_verbatim_string_literal] = ACTIONS(3311),
    [aux_sym_preproc_if_token1] = ACTIONS(3311),
    [aux_sym_preproc_if_token3] = ACTIONS(3311),
    [aux_sym_preproc_else_token1] = ACTIONS(3311),
    [aux_sym_preproc_elif_token1] = ACTIONS(3311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3311),
    [sym_interpolation_verbatim_start] = ACTIONS(3311),
    [sym_interpolation_raw_start] = ACTIONS(3311),
    [sym_raw_string_start] = ACTIONS(3311),
  },
  [2283] = {
    [sym_preproc_region] = STATE(2283),
    [sym_preproc_endregion] = STATE(2283),
    [sym_preproc_line] = STATE(2283),
    [sym_preproc_pragma] = STATE(2283),
    [sym_preproc_nullable] = STATE(2283),
    [sym_preproc_error] = STATE(2283),
    [sym_preproc_define] = STATE(2283),
    [sym_preproc_undef] = STATE(2283),
    [sym__identifier_token] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym_alias] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_global] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_unsafe] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_ref] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3313),
    [anon_sym_delegate] = ACTIONS(3313),
    [anon_sym_record] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_file] = ACTIONS(3313),
    [anon_sym_fixed] = ACTIONS(3313),
    [anon_sym_internal] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_override] = ACTIONS(3313),
    [anon_sym_partial] = ACTIONS(3313),
    [anon_sym_private] = ACTIONS(3313),
    [anon_sym_protected] = ACTIONS(3313),
    [anon_sym_public] = ACTIONS(3313),
    [anon_sym_readonly] = ACTIONS(3313),
    [anon_sym_required] = ACTIONS(3313),
    [anon_sym_sealed] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_where] = ACTIONS(3313),
    [anon_sym_notnull] = ACTIONS(3313),
    [anon_sym_unmanaged] = ACTIONS(3313),
    [anon_sym_checked] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_true] = ACTIONS(3313),
    [anon_sym_false] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3315),
    [anon_sym_CARET] = ACTIONS(3315),
    [anon_sym_AMP] = ACTIONS(3315),
    [anon_sym_this] = ACTIONS(3313),
    [anon_sym_scoped] = ACTIONS(3313),
    [anon_sym_base] = ACTIONS(3313),
    [anon_sym_var] = ACTIONS(3313),
    [sym_predefined_type] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_unchecked] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_lock] = ACTIONS(3313),
    [anon_sym_yield] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_when] = ACTIONS(3313),
    [anon_sym_await] = ACTIONS(3313),
    [anon_sym_foreach] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_else] = ACTIONS(3313),
    [anon_sym_DOT_DOT] = ACTIONS(3315),
    [anon_sym_from] = ACTIONS(3313),
    [anon_sym_into] = ACTIONS(3313),
    [anon_sym_join] = ACTIONS(3313),
    [anon_sym_on] = ACTIONS(3313),
    [anon_sym_equals] = ACTIONS(3313),
    [anon_sym_let] = ACTIONS(3313),
    [anon_sym_orderby] = ACTIONS(3313),
    [anon_sym_ascending] = ACTIONS(3313),
    [anon_sym_descending] = ACTIONS(3313),
    [anon_sym_group] = ACTIONS(3313),
    [anon_sym_by] = ACTIONS(3313),
    [anon_sym_select] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3313),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym___makeref] = ACTIONS(3313),
    [anon_sym___reftype] = ACTIONS(3313),
    [anon_sym___refvalue] = ACTIONS(3313),
    [sym_null_literal] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_integer_literal] = ACTIONS(3313),
    [sym_real_literal] = ACTIONS(3315),
    [sym_verbatim_string_literal] = ACTIONS(3315),
    [aux_sym_preproc_if_token1] = ACTIONS(3315),
    [aux_sym_preproc_if_token3] = ACTIONS(3315),
    [aux_sym_preproc_else_token1] = ACTIONS(3315),
    [aux_sym_preproc_elif_token1] = ACTIONS(3315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3315),
    [sym_interpolation_verbatim_start] = ACTIONS(3315),
    [sym_interpolation_raw_start] = ACTIONS(3315),
    [sym_raw_string_start] = ACTIONS(3315),
  },
  [2284] = {
    [sym_preproc_region] = STATE(2284),
    [sym_preproc_endregion] = STATE(2284),
    [sym_preproc_line] = STATE(2284),
    [sym_preproc_pragma] = STATE(2284),
    [sym_preproc_nullable] = STATE(2284),
    [sym_preproc_error] = STATE(2284),
    [sym_preproc_define] = STATE(2284),
    [sym_preproc_undef] = STATE(2284),
    [sym__identifier_token] = ACTIONS(3317),
    [anon_sym_extern] = ACTIONS(3317),
    [anon_sym_alias] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_unsafe] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_ref] = ACTIONS(3317),
    [anon_sym_struct] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_delegate] = ACTIONS(3317),
    [anon_sym_record] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_file] = ACTIONS(3317),
    [anon_sym_fixed] = ACTIONS(3317),
    [anon_sym_internal] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_partial] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_required] = ACTIONS(3317),
    [anon_sym_sealed] = ACTIONS(3317),
    [anon_sym_virtual] = ACTIONS(3317),
    [anon_sym_volatile] = ACTIONS(3317),
    [anon_sym_where] = ACTIONS(3317),
    [anon_sym_notnull] = ACTIONS(3317),
    [anon_sym_unmanaged] = ACTIONS(3317),
    [anon_sym_checked] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_true] = ACTIONS(3317),
    [anon_sym_false] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3319),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_this] = ACTIONS(3317),
    [anon_sym_scoped] = ACTIONS(3317),
    [anon_sym_base] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [sym_predefined_type] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_unchecked] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_lock] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_when] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_foreach] = ACTIONS(3317),
    [anon_sym_goto] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_DOT_DOT] = ACTIONS(3319),
    [anon_sym_from] = ACTIONS(3317),
    [anon_sym_into] = ACTIONS(3317),
    [anon_sym_join] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [anon_sym_equals] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_orderby] = ACTIONS(3317),
    [anon_sym_ascending] = ACTIONS(3317),
    [anon_sym_descending] = ACTIONS(3317),
    [anon_sym_group] = ACTIONS(3317),
    [anon_sym_by] = ACTIONS(3317),
    [anon_sym_select] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3317),
    [anon_sym_sizeof] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym___makeref] = ACTIONS(3317),
    [anon_sym___reftype] = ACTIONS(3317),
    [anon_sym___refvalue] = ACTIONS(3317),
    [sym_null_literal] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_integer_literal] = ACTIONS(3317),
    [sym_real_literal] = ACTIONS(3319),
    [sym_verbatim_string_literal] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_if_token3] = ACTIONS(3319),
    [aux_sym_preproc_else_token1] = ACTIONS(3319),
    [aux_sym_preproc_elif_token1] = ACTIONS(3319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3319),
    [sym_interpolation_verbatim_start] = ACTIONS(3319),
    [sym_interpolation_raw_start] = ACTIONS(3319),
    [sym_raw_string_start] = ACTIONS(3319),
  },
  [2285] = {
    [sym_preproc_region] = STATE(2285),
    [sym_preproc_endregion] = STATE(2285),
    [sym_preproc_line] = STATE(2285),
    [sym_preproc_pragma] = STATE(2285),
    [sym_preproc_nullable] = STATE(2285),
    [sym_preproc_error] = STATE(2285),
    [sym_preproc_define] = STATE(2285),
    [sym_preproc_undef] = STATE(2285),
    [sym__identifier_token] = ACTIONS(3321),
    [anon_sym_extern] = ACTIONS(3321),
    [anon_sym_alias] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_unsafe] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_ref] = ACTIONS(3321),
    [anon_sym_struct] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_delegate] = ACTIONS(3321),
    [anon_sym_record] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_file] = ACTIONS(3321),
    [anon_sym_fixed] = ACTIONS(3321),
    [anon_sym_internal] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_partial] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_required] = ACTIONS(3321),
    [anon_sym_sealed] = ACTIONS(3321),
    [anon_sym_virtual] = ACTIONS(3321),
    [anon_sym_volatile] = ACTIONS(3321),
    [anon_sym_where] = ACTIONS(3321),
    [anon_sym_notnull] = ACTIONS(3321),
    [anon_sym_unmanaged] = ACTIONS(3321),
    [anon_sym_checked] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_true] = ACTIONS(3321),
    [anon_sym_false] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_CARET] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3323),
    [anon_sym_this] = ACTIONS(3321),
    [anon_sym_scoped] = ACTIONS(3321),
    [anon_sym_base] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [sym_predefined_type] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_unchecked] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_lock] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_foreach] = ACTIONS(3321),
    [anon_sym_goto] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_DOT_DOT] = ACTIONS(3323),
    [anon_sym_from] = ACTIONS(3321),
    [anon_sym_into] = ACTIONS(3321),
    [anon_sym_join] = ACTIONS(3321),
    [anon_sym_on] = ACTIONS(3321),
    [anon_sym_equals] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_orderby] = ACTIONS(3321),
    [anon_sym_ascending] = ACTIONS(3321),
    [anon_sym_descending] = ACTIONS(3321),
    [anon_sym_group] = ACTIONS(3321),
    [anon_sym_by] = ACTIONS(3321),
    [anon_sym_select] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym___makeref] = ACTIONS(3321),
    [anon_sym___reftype] = ACTIONS(3321),
    [anon_sym___refvalue] = ACTIONS(3321),
    [sym_null_literal] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [sym_integer_literal] = ACTIONS(3321),
    [sym_real_literal] = ACTIONS(3323),
    [sym_verbatim_string_literal] = ACTIONS(3323),
    [aux_sym_preproc_if_token1] = ACTIONS(3323),
    [aux_sym_preproc_if_token3] = ACTIONS(3323),
    [aux_sym_preproc_else_token1] = ACTIONS(3323),
    [aux_sym_preproc_elif_token1] = ACTIONS(3323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3323),
    [sym_interpolation_verbatim_start] = ACTIONS(3323),
    [sym_interpolation_raw_start] = ACTIONS(3323),
    [sym_raw_string_start] = ACTIONS(3323),
  },
  [2286] = {
    [sym_preproc_region] = STATE(2286),
    [sym_preproc_endregion] = STATE(2286),
    [sym_preproc_line] = STATE(2286),
    [sym_preproc_pragma] = STATE(2286),
    [sym_preproc_nullable] = STATE(2286),
    [sym_preproc_error] = STATE(2286),
    [sym_preproc_define] = STATE(2286),
    [sym_preproc_undef] = STATE(2286),
    [sym__identifier_token] = ACTIONS(3325),
    [anon_sym_extern] = ACTIONS(3325),
    [anon_sym_alias] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_global] = ACTIONS(3325),
    [anon_sym_using] = ACTIONS(3325),
    [anon_sym_unsafe] = ACTIONS(3325),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3325),
    [anon_sym_namespace] = ACTIONS(3325),
    [anon_sym_class] = ACTIONS(3325),
    [anon_sym_ref] = ACTIONS(3325),
    [anon_sym_struct] = ACTIONS(3325),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3325),
    [anon_sym_delegate] = ACTIONS(3325),
    [anon_sym_record] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_const] = ACTIONS(3325),
    [anon_sym_file] = ACTIONS(3325),
    [anon_sym_fixed] = ACTIONS(3325),
    [anon_sym_internal] = ACTIONS(3325),
    [anon_sym_new] = ACTIONS(3325),
    [anon_sym_override] = ACTIONS(3325),
    [anon_sym_partial] = ACTIONS(3325),
    [anon_sym_private] = ACTIONS(3325),
    [anon_sym_protected] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3325),
    [anon_sym_readonly] = ACTIONS(3325),
    [anon_sym_required] = ACTIONS(3325),
    [anon_sym_sealed] = ACTIONS(3325),
    [anon_sym_virtual] = ACTIONS(3325),
    [anon_sym_volatile] = ACTIONS(3325),
    [anon_sym_where] = ACTIONS(3325),
    [anon_sym_notnull] = ACTIONS(3325),
    [anon_sym_unmanaged] = ACTIONS(3325),
    [anon_sym_checked] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_true] = ACTIONS(3325),
    [anon_sym_false] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(3327),
    [anon_sym_CARET] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3327),
    [anon_sym_this] = ACTIONS(3325),
    [anon_sym_scoped] = ACTIONS(3325),
    [anon_sym_base] = ACTIONS(3325),
    [anon_sym_var] = ACTIONS(3325),
    [sym_predefined_type] = ACTIONS(3325),
    [anon_sym_break] = ACTIONS(3325),
    [anon_sym_unchecked] = ACTIONS(3325),
    [anon_sym_continue] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_while] = ACTIONS(3325),
    [anon_sym_for] = ACTIONS(3325),
    [anon_sym_lock] = ACTIONS(3325),
    [anon_sym_yield] = ACTIONS(3325),
    [anon_sym_switch] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(3325),
    [anon_sym_throw] = ACTIONS(3325),
    [anon_sym_try] = ACTIONS(3325),
    [anon_sym_when] = ACTIONS(3325),
    [anon_sym_await] = ACTIONS(3325),
    [anon_sym_foreach] = ACTIONS(3325),
    [anon_sym_goto] = ACTIONS(3325),
    [anon_sym_if] = ACTIONS(3325),
    [anon_sym_else] = ACTIONS(3325),
    [anon_sym_DOT_DOT] = ACTIONS(3327),
    [anon_sym_from] = ACTIONS(3325),
    [anon_sym_into] = ACTIONS(3325),
    [anon_sym_join] = ACTIONS(3325),
    [anon_sym_on] = ACTIONS(3325),
    [anon_sym_equals] = ACTIONS(3325),
    [anon_sym_let] = ACTIONS(3325),
    [anon_sym_orderby] = ACTIONS(3325),
    [anon_sym_ascending] = ACTIONS(3325),
    [anon_sym_descending] = ACTIONS(3325),
    [anon_sym_group] = ACTIONS(3325),
    [anon_sym_by] = ACTIONS(3325),
    [anon_sym_select] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3325),
    [anon_sym_sizeof] = ACTIONS(3325),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym___makeref] = ACTIONS(3325),
    [anon_sym___reftype] = ACTIONS(3325),
    [anon_sym___refvalue] = ACTIONS(3325),
    [sym_null_literal] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_integer_literal] = ACTIONS(3325),
    [sym_real_literal] = ACTIONS(3327),
    [sym_verbatim_string_literal] = ACTIONS(3327),
    [aux_sym_preproc_if_token1] = ACTIONS(3327),
    [aux_sym_preproc_if_token3] = ACTIONS(3327),
    [aux_sym_preproc_else_token1] = ACTIONS(3327),
    [aux_sym_preproc_elif_token1] = ACTIONS(3327),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3327),
    [sym_interpolation_verbatim_start] = ACTIONS(3327),
    [sym_interpolation_raw_start] = ACTIONS(3327),
    [sym_raw_string_start] = ACTIONS(3327),
  },
  [2287] = {
    [sym_preproc_region] = STATE(2287),
    [sym_preproc_endregion] = STATE(2287),
    [sym_preproc_line] = STATE(2287),
    [sym_preproc_pragma] = STATE(2287),
    [sym_preproc_nullable] = STATE(2287),
    [sym_preproc_error] = STATE(2287),
    [sym_preproc_define] = STATE(2287),
    [sym_preproc_undef] = STATE(2287),
    [sym__identifier_token] = ACTIONS(3329),
    [anon_sym_extern] = ACTIONS(3329),
    [anon_sym_alias] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_global] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_unsafe] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_ref] = ACTIONS(3329),
    [anon_sym_struct] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_delegate] = ACTIONS(3329),
    [anon_sym_record] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_file] = ACTIONS(3329),
    [anon_sym_fixed] = ACTIONS(3329),
    [anon_sym_internal] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_partial] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_required] = ACTIONS(3329),
    [anon_sym_sealed] = ACTIONS(3329),
    [anon_sym_virtual] = ACTIONS(3329),
    [anon_sym_volatile] = ACTIONS(3329),
    [anon_sym_where] = ACTIONS(3329),
    [anon_sym_notnull] = ACTIONS(3329),
    [anon_sym_unmanaged] = ACTIONS(3329),
    [anon_sym_checked] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_true] = ACTIONS(3329),
    [anon_sym_false] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3331),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_this] = ACTIONS(3329),
    [anon_sym_scoped] = ACTIONS(3329),
    [anon_sym_base] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [sym_predefined_type] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_unchecked] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_lock] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_when] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_foreach] = ACTIONS(3329),
    [anon_sym_goto] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_DOT_DOT] = ACTIONS(3331),
    [anon_sym_from] = ACTIONS(3329),
    [anon_sym_into] = ACTIONS(3329),
    [anon_sym_join] = ACTIONS(3329),
    [anon_sym_on] = ACTIONS(3329),
    [anon_sym_equals] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_orderby] = ACTIONS(3329),
    [anon_sym_ascending] = ACTIONS(3329),
    [anon_sym_descending] = ACTIONS(3329),
    [anon_sym_group] = ACTIONS(3329),
    [anon_sym_by] = ACTIONS(3329),
    [anon_sym_select] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym___makeref] = ACTIONS(3329),
    [anon_sym___reftype] = ACTIONS(3329),
    [anon_sym___refvalue] = ACTIONS(3329),
    [sym_null_literal] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [sym_integer_literal] = ACTIONS(3329),
    [sym_real_literal] = ACTIONS(3331),
    [sym_verbatim_string_literal] = ACTIONS(3331),
    [aux_sym_preproc_if_token1] = ACTIONS(3331),
    [aux_sym_preproc_if_token3] = ACTIONS(3331),
    [aux_sym_preproc_else_token1] = ACTIONS(3331),
    [aux_sym_preproc_elif_token1] = ACTIONS(3331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3331),
    [sym_interpolation_verbatim_start] = ACTIONS(3331),
    [sym_interpolation_raw_start] = ACTIONS(3331),
    [sym_raw_string_start] = ACTIONS(3331),
  },
  [2288] = {
    [sym_preproc_region] = STATE(2288),
    [sym_preproc_endregion] = STATE(2288),
    [sym_preproc_line] = STATE(2288),
    [sym_preproc_pragma] = STATE(2288),
    [sym_preproc_nullable] = STATE(2288),
    [sym_preproc_error] = STATE(2288),
    [sym_preproc_define] = STATE(2288),
    [sym_preproc_undef] = STATE(2288),
    [sym__identifier_token] = ACTIONS(3333),
    [anon_sym_extern] = ACTIONS(3333),
    [anon_sym_alias] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_global] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_unsafe] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_ref] = ACTIONS(3333),
    [anon_sym_struct] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_delegate] = ACTIONS(3333),
    [anon_sym_record] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_file] = ACTIONS(3333),
    [anon_sym_fixed] = ACTIONS(3333),
    [anon_sym_internal] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_partial] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_required] = ACTIONS(3333),
    [anon_sym_sealed] = ACTIONS(3333),
    [anon_sym_virtual] = ACTIONS(3333),
    [anon_sym_volatile] = ACTIONS(3333),
    [anon_sym_where] = ACTIONS(3333),
    [anon_sym_notnull] = ACTIONS(3333),
    [anon_sym_unmanaged] = ACTIONS(3333),
    [anon_sym_checked] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_true] = ACTIONS(3333),
    [anon_sym_false] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3335),
    [anon_sym_AMP] = ACTIONS(3335),
    [anon_sym_this] = ACTIONS(3333),
    [anon_sym_scoped] = ACTIONS(3333),
    [anon_sym_base] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [sym_predefined_type] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_unchecked] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_lock] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_when] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_foreach] = ACTIONS(3333),
    [anon_sym_goto] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_DOT_DOT] = ACTIONS(3335),
    [anon_sym_from] = ACTIONS(3333),
    [anon_sym_into] = ACTIONS(3333),
    [anon_sym_join] = ACTIONS(3333),
    [anon_sym_on] = ACTIONS(3333),
    [anon_sym_equals] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_orderby] = ACTIONS(3333),
    [anon_sym_ascending] = ACTIONS(3333),
    [anon_sym_descending] = ACTIONS(3333),
    [anon_sym_group] = ACTIONS(3333),
    [anon_sym_by] = ACTIONS(3333),
    [anon_sym_select] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3333),
    [anon_sym_sizeof] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym___makeref] = ACTIONS(3333),
    [anon_sym___reftype] = ACTIONS(3333),
    [anon_sym___refvalue] = ACTIONS(3333),
    [sym_null_literal] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3335),
    [sym_integer_literal] = ACTIONS(3333),
    [sym_real_literal] = ACTIONS(3335),
    [sym_verbatim_string_literal] = ACTIONS(3335),
    [aux_sym_preproc_if_token1] = ACTIONS(3335),
    [aux_sym_preproc_if_token3] = ACTIONS(3335),
    [aux_sym_preproc_else_token1] = ACTIONS(3335),
    [aux_sym_preproc_elif_token1] = ACTIONS(3335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3335),
    [sym_interpolation_verbatim_start] = ACTIONS(3335),
    [sym_interpolation_raw_start] = ACTIONS(3335),
    [sym_raw_string_start] = ACTIONS(3335),
  },
  [2289] = {
    [sym_preproc_region] = STATE(2289),
    [sym_preproc_endregion] = STATE(2289),
    [sym_preproc_line] = STATE(2289),
    [sym_preproc_pragma] = STATE(2289),
    [sym_preproc_nullable] = STATE(2289),
    [sym_preproc_error] = STATE(2289),
    [sym_preproc_define] = STATE(2289),
    [sym_preproc_undef] = STATE(2289),
    [sym__identifier_token] = ACTIONS(3337),
    [anon_sym_extern] = ACTIONS(3337),
    [anon_sym_alias] = ACTIONS(3337),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_global] = ACTIONS(3337),
    [anon_sym_using] = ACTIONS(3337),
    [anon_sym_unsafe] = ACTIONS(3337),
    [anon_sym_static] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_return] = ACTIONS(3337),
    [anon_sym_namespace] = ACTIONS(3337),
    [anon_sym_class] = ACTIONS(3337),
    [anon_sym_ref] = ACTIONS(3337),
    [anon_sym_struct] = ACTIONS(3337),
    [anon_sym_enum] = ACTIONS(3337),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_interface] = ACTIONS(3337),
    [anon_sym_delegate] = ACTIONS(3337),
    [anon_sym_record] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3337),
    [anon_sym_async] = ACTIONS(3337),
    [anon_sym_const] = ACTIONS(3337),
    [anon_sym_file] = ACTIONS(3337),
    [anon_sym_fixed] = ACTIONS(3337),
    [anon_sym_internal] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3337),
    [anon_sym_override] = ACTIONS(3337),
    [anon_sym_partial] = ACTIONS(3337),
    [anon_sym_private] = ACTIONS(3337),
    [anon_sym_protected] = ACTIONS(3337),
    [anon_sym_public] = ACTIONS(3337),
    [anon_sym_readonly] = ACTIONS(3337),
    [anon_sym_required] = ACTIONS(3337),
    [anon_sym_sealed] = ACTIONS(3337),
    [anon_sym_virtual] = ACTIONS(3337),
    [anon_sym_volatile] = ACTIONS(3337),
    [anon_sym_where] = ACTIONS(3337),
    [anon_sym_notnull] = ACTIONS(3337),
    [anon_sym_unmanaged] = ACTIONS(3337),
    [anon_sym_checked] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_true] = ACTIONS(3337),
    [anon_sym_false] = ACTIONS(3337),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3339),
    [anon_sym_AMP] = ACTIONS(3339),
    [anon_sym_this] = ACTIONS(3337),
    [anon_sym_scoped] = ACTIONS(3337),
    [anon_sym_base] = ACTIONS(3337),
    [anon_sym_var] = ACTIONS(3337),
    [sym_predefined_type] = ACTIONS(3337),
    [anon_sym_break] = ACTIONS(3337),
    [anon_sym_unchecked] = ACTIONS(3337),
    [anon_sym_continue] = ACTIONS(3337),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_while] = ACTIONS(3337),
    [anon_sym_for] = ACTIONS(3337),
    [anon_sym_lock] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3337),
    [anon_sym_switch] = ACTIONS(3337),
    [anon_sym_default] = ACTIONS(3337),
    [anon_sym_throw] = ACTIONS(3337),
    [anon_sym_try] = ACTIONS(3337),
    [anon_sym_when] = ACTIONS(3337),
    [anon_sym_await] = ACTIONS(3337),
    [anon_sym_foreach] = ACTIONS(3337),
    [anon_sym_goto] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(3337),
    [anon_sym_else] = ACTIONS(3337),
    [anon_sym_DOT_DOT] = ACTIONS(3339),
    [anon_sym_from] = ACTIONS(3337),
    [anon_sym_into] = ACTIONS(3337),
    [anon_sym_join] = ACTIONS(3337),
    [anon_sym_on] = ACTIONS(3337),
    [anon_sym_equals] = ACTIONS(3337),
    [anon_sym_let] = ACTIONS(3337),
    [anon_sym_orderby] = ACTIONS(3337),
    [anon_sym_ascending] = ACTIONS(3337),
    [anon_sym_descending] = ACTIONS(3337),
    [anon_sym_group] = ACTIONS(3337),
    [anon_sym_by] = ACTIONS(3337),
    [anon_sym_select] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3337),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3337),
    [anon_sym___makeref] = ACTIONS(3337),
    [anon_sym___reftype] = ACTIONS(3337),
    [anon_sym___refvalue] = ACTIONS(3337),
    [sym_null_literal] = ACTIONS(3337),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [sym_integer_literal] = ACTIONS(3337),
    [sym_real_literal] = ACTIONS(3339),
    [sym_verbatim_string_literal] = ACTIONS(3339),
    [aux_sym_preproc_if_token1] = ACTIONS(3339),
    [aux_sym_preproc_if_token3] = ACTIONS(3339),
    [aux_sym_preproc_else_token1] = ACTIONS(3339),
    [aux_sym_preproc_elif_token1] = ACTIONS(3339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3339),
    [sym_interpolation_verbatim_start] = ACTIONS(3339),
    [sym_interpolation_raw_start] = ACTIONS(3339),
    [sym_raw_string_start] = ACTIONS(3339),
  },
  [2290] = {
    [sym_preproc_region] = STATE(2290),
    [sym_preproc_endregion] = STATE(2290),
    [sym_preproc_line] = STATE(2290),
    [sym_preproc_pragma] = STATE(2290),
    [sym_preproc_nullable] = STATE(2290),
    [sym_preproc_error] = STATE(2290),
    [sym_preproc_define] = STATE(2290),
    [sym_preproc_undef] = STATE(2290),
    [sym__identifier_token] = ACTIONS(3341),
    [anon_sym_extern] = ACTIONS(3341),
    [anon_sym_alias] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_global] = ACTIONS(3341),
    [anon_sym_using] = ACTIONS(3341),
    [anon_sym_unsafe] = ACTIONS(3341),
    [anon_sym_static] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3341),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_class] = ACTIONS(3341),
    [anon_sym_ref] = ACTIONS(3341),
    [anon_sym_struct] = ACTIONS(3341),
    [anon_sym_enum] = ACTIONS(3341),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3341),
    [anon_sym_delegate] = ACTIONS(3341),
    [anon_sym_record] = ACTIONS(3341),
    [anon_sym_abstract] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3341),
    [anon_sym_const] = ACTIONS(3341),
    [anon_sym_file] = ACTIONS(3341),
    [anon_sym_fixed] = ACTIONS(3341),
    [anon_sym_internal] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3341),
    [anon_sym_override] = ACTIONS(3341),
    [anon_sym_partial] = ACTIONS(3341),
    [anon_sym_private] = ACTIONS(3341),
    [anon_sym_protected] = ACTIONS(3341),
    [anon_sym_public] = ACTIONS(3341),
    [anon_sym_readonly] = ACTIONS(3341),
    [anon_sym_required] = ACTIONS(3341),
    [anon_sym_sealed] = ACTIONS(3341),
    [anon_sym_virtual] = ACTIONS(3341),
    [anon_sym_volatile] = ACTIONS(3341),
    [anon_sym_where] = ACTIONS(3341),
    [anon_sym_notnull] = ACTIONS(3341),
    [anon_sym_unmanaged] = ACTIONS(3341),
    [anon_sym_checked] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_true] = ACTIONS(3341),
    [anon_sym_false] = ACTIONS(3341),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_STAR] = ACTIONS(3343),
    [anon_sym_CARET] = ACTIONS(3343),
    [anon_sym_AMP] = ACTIONS(3343),
    [anon_sym_this] = ACTIONS(3341),
    [anon_sym_scoped] = ACTIONS(3341),
    [anon_sym_base] = ACTIONS(3341),
    [anon_sym_var] = ACTIONS(3341),
    [sym_predefined_type] = ACTIONS(3341),
    [anon_sym_break] = ACTIONS(3341),
    [anon_sym_unchecked] = ACTIONS(3341),
    [anon_sym_continue] = ACTIONS(3341),
    [anon_sym_do] = ACTIONS(3341),
    [anon_sym_while] = ACTIONS(3341),
    [anon_sym_for] = ACTIONS(3341),
    [anon_sym_lock] = ACTIONS(3341),
    [anon_sym_yield] = ACTIONS(3341),
    [anon_sym_switch] = ACTIONS(3341),
    [anon_sym_default] = ACTIONS(3341),
    [anon_sym_throw] = ACTIONS(3341),
    [anon_sym_try] = ACTIONS(3341),
    [anon_sym_when] = ACTIONS(3341),
    [anon_sym_await] = ACTIONS(3341),
    [anon_sym_foreach] = ACTIONS(3341),
    [anon_sym_goto] = ACTIONS(3341),
    [anon_sym_if] = ACTIONS(3341),
    [anon_sym_else] = ACTIONS(3341),
    [anon_sym_DOT_DOT] = ACTIONS(3343),
    [anon_sym_from] = ACTIONS(3341),
    [anon_sym_into] = ACTIONS(3341),
    [anon_sym_join] = ACTIONS(3341),
    [anon_sym_on] = ACTIONS(3341),
    [anon_sym_equals] = ACTIONS(3341),
    [anon_sym_let] = ACTIONS(3341),
    [anon_sym_orderby] = ACTIONS(3341),
    [anon_sym_ascending] = ACTIONS(3341),
    [anon_sym_descending] = ACTIONS(3341),
    [anon_sym_group] = ACTIONS(3341),
    [anon_sym_by] = ACTIONS(3341),
    [anon_sym_select] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3341),
    [anon_sym_sizeof] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3341),
    [anon_sym___makeref] = ACTIONS(3341),
    [anon_sym___reftype] = ACTIONS(3341),
    [anon_sym___refvalue] = ACTIONS(3341),
    [sym_null_literal] = ACTIONS(3341),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [sym_integer_literal] = ACTIONS(3341),
    [sym_real_literal] = ACTIONS(3343),
    [sym_verbatim_string_literal] = ACTIONS(3343),
    [aux_sym_preproc_if_token1] = ACTIONS(3343),
    [aux_sym_preproc_if_token3] = ACTIONS(3343),
    [aux_sym_preproc_else_token1] = ACTIONS(3343),
    [aux_sym_preproc_elif_token1] = ACTIONS(3343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3343),
    [sym_interpolation_verbatim_start] = ACTIONS(3343),
    [sym_interpolation_raw_start] = ACTIONS(3343),
    [sym_raw_string_start] = ACTIONS(3343),
  },
  [2291] = {
    [sym_preproc_region] = STATE(2291),
    [sym_preproc_endregion] = STATE(2291),
    [sym_preproc_line] = STATE(2291),
    [sym_preproc_pragma] = STATE(2291),
    [sym_preproc_nullable] = STATE(2291),
    [sym_preproc_error] = STATE(2291),
    [sym_preproc_define] = STATE(2291),
    [sym_preproc_undef] = STATE(2291),
    [sym__identifier_token] = ACTIONS(3345),
    [anon_sym_extern] = ACTIONS(3345),
    [anon_sym_alias] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_global] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_unsafe] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_ref] = ACTIONS(3345),
    [anon_sym_struct] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_delegate] = ACTIONS(3345),
    [anon_sym_record] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_file] = ACTIONS(3345),
    [anon_sym_fixed] = ACTIONS(3345),
    [anon_sym_internal] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_partial] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_required] = ACTIONS(3345),
    [anon_sym_sealed] = ACTIONS(3345),
    [anon_sym_virtual] = ACTIONS(3345),
    [anon_sym_volatile] = ACTIONS(3345),
    [anon_sym_where] = ACTIONS(3345),
    [anon_sym_notnull] = ACTIONS(3345),
    [anon_sym_unmanaged] = ACTIONS(3345),
    [anon_sym_checked] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [anon_sym_true] = ACTIONS(3345),
    [anon_sym_false] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_CARET] = ACTIONS(3347),
    [anon_sym_AMP] = ACTIONS(3347),
    [anon_sym_this] = ACTIONS(3345),
    [anon_sym_scoped] = ACTIONS(3345),
    [anon_sym_base] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [sym_predefined_type] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_unchecked] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_lock] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_when] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_foreach] = ACTIONS(3345),
    [anon_sym_goto] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_DOT_DOT] = ACTIONS(3347),
    [anon_sym_from] = ACTIONS(3345),
    [anon_sym_into] = ACTIONS(3345),
    [anon_sym_join] = ACTIONS(3345),
    [anon_sym_on] = ACTIONS(3345),
    [anon_sym_equals] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_orderby] = ACTIONS(3345),
    [anon_sym_ascending] = ACTIONS(3345),
    [anon_sym_descending] = ACTIONS(3345),
    [anon_sym_group] = ACTIONS(3345),
    [anon_sym_by] = ACTIONS(3345),
    [anon_sym_select] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3345),
    [anon_sym_sizeof] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym___makeref] = ACTIONS(3345),
    [anon_sym___reftype] = ACTIONS(3345),
    [anon_sym___refvalue] = ACTIONS(3345),
    [sym_null_literal] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [sym_integer_literal] = ACTIONS(3345),
    [sym_real_literal] = ACTIONS(3347),
    [sym_verbatim_string_literal] = ACTIONS(3347),
    [aux_sym_preproc_if_token1] = ACTIONS(3347),
    [aux_sym_preproc_if_token3] = ACTIONS(3347),
    [aux_sym_preproc_else_token1] = ACTIONS(3347),
    [aux_sym_preproc_elif_token1] = ACTIONS(3347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3347),
    [sym_interpolation_verbatim_start] = ACTIONS(3347),
    [sym_interpolation_raw_start] = ACTIONS(3347),
    [sym_raw_string_start] = ACTIONS(3347),
  },
  [2292] = {
    [sym_preproc_region] = STATE(2292),
    [sym_preproc_endregion] = STATE(2292),
    [sym_preproc_line] = STATE(2292),
    [sym_preproc_pragma] = STATE(2292),
    [sym_preproc_nullable] = STATE(2292),
    [sym_preproc_error] = STATE(2292),
    [sym_preproc_define] = STATE(2292),
    [sym_preproc_undef] = STATE(2292),
    [sym__identifier_token] = ACTIONS(3349),
    [anon_sym_extern] = ACTIONS(3349),
    [anon_sym_alias] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_global] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_unsafe] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_ref] = ACTIONS(3349),
    [anon_sym_struct] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_delegate] = ACTIONS(3349),
    [anon_sym_record] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_file] = ACTIONS(3349),
    [anon_sym_fixed] = ACTIONS(3349),
    [anon_sym_internal] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_partial] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_required] = ACTIONS(3349),
    [anon_sym_sealed] = ACTIONS(3349),
    [anon_sym_virtual] = ACTIONS(3349),
    [anon_sym_volatile] = ACTIONS(3349),
    [anon_sym_where] = ACTIONS(3349),
    [anon_sym_notnull] = ACTIONS(3349),
    [anon_sym_unmanaged] = ACTIONS(3349),
    [anon_sym_checked] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(3349),
    [anon_sym_false] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_CARET] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_this] = ACTIONS(3349),
    [anon_sym_scoped] = ACTIONS(3349),
    [anon_sym_base] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [sym_predefined_type] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_unchecked] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_lock] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_when] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_foreach] = ACTIONS(3349),
    [anon_sym_goto] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_DOT_DOT] = ACTIONS(3351),
    [anon_sym_from] = ACTIONS(3349),
    [anon_sym_into] = ACTIONS(3349),
    [anon_sym_join] = ACTIONS(3349),
    [anon_sym_on] = ACTIONS(3349),
    [anon_sym_equals] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_orderby] = ACTIONS(3349),
    [anon_sym_ascending] = ACTIONS(3349),
    [anon_sym_descending] = ACTIONS(3349),
    [anon_sym_group] = ACTIONS(3349),
    [anon_sym_by] = ACTIONS(3349),
    [anon_sym_select] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3349),
    [anon_sym_sizeof] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym___makeref] = ACTIONS(3349),
    [anon_sym___reftype] = ACTIONS(3349),
    [anon_sym___refvalue] = ACTIONS(3349),
    [sym_null_literal] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [sym_integer_literal] = ACTIONS(3349),
    [sym_real_literal] = ACTIONS(3351),
    [sym_verbatim_string_literal] = ACTIONS(3351),
    [aux_sym_preproc_if_token1] = ACTIONS(3351),
    [aux_sym_preproc_if_token3] = ACTIONS(3351),
    [aux_sym_preproc_else_token1] = ACTIONS(3351),
    [aux_sym_preproc_elif_token1] = ACTIONS(3351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3351),
    [sym_interpolation_verbatim_start] = ACTIONS(3351),
    [sym_interpolation_raw_start] = ACTIONS(3351),
    [sym_raw_string_start] = ACTIONS(3351),
  },
  [2293] = {
    [sym_preproc_region] = STATE(2293),
    [sym_preproc_endregion] = STATE(2293),
    [sym_preproc_line] = STATE(2293),
    [sym_preproc_pragma] = STATE(2293),
    [sym_preproc_nullable] = STATE(2293),
    [sym_preproc_error] = STATE(2293),
    [sym_preproc_define] = STATE(2293),
    [sym_preproc_undef] = STATE(2293),
    [sym__identifier_token] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym_alias] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_global] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_unsafe] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_ref] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_delegate] = ACTIONS(3353),
    [anon_sym_record] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_file] = ACTIONS(3353),
    [anon_sym_fixed] = ACTIONS(3353),
    [anon_sym_internal] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_partial] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_required] = ACTIONS(3353),
    [anon_sym_sealed] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_where] = ACTIONS(3353),
    [anon_sym_notnull] = ACTIONS(3353),
    [anon_sym_unmanaged] = ACTIONS(3353),
    [anon_sym_checked] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_true] = ACTIONS(3353),
    [anon_sym_false] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_this] = ACTIONS(3353),
    [anon_sym_scoped] = ACTIONS(3353),
    [anon_sym_base] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [sym_predefined_type] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_unchecked] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_lock] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_when] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_foreach] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3355),
    [anon_sym_from] = ACTIONS(3353),
    [anon_sym_into] = ACTIONS(3353),
    [anon_sym_join] = ACTIONS(3353),
    [anon_sym_on] = ACTIONS(3353),
    [anon_sym_equals] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_orderby] = ACTIONS(3353),
    [anon_sym_ascending] = ACTIONS(3353),
    [anon_sym_descending] = ACTIONS(3353),
    [anon_sym_group] = ACTIONS(3353),
    [anon_sym_by] = ACTIONS(3353),
    [anon_sym_select] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3353),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym___makeref] = ACTIONS(3353),
    [anon_sym___reftype] = ACTIONS(3353),
    [anon_sym___refvalue] = ACTIONS(3353),
    [sym_null_literal] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [sym_integer_literal] = ACTIONS(3353),
    [sym_real_literal] = ACTIONS(3355),
    [sym_verbatim_string_literal] = ACTIONS(3355),
    [aux_sym_preproc_if_token1] = ACTIONS(3355),
    [aux_sym_preproc_if_token3] = ACTIONS(3355),
    [aux_sym_preproc_else_token1] = ACTIONS(3355),
    [aux_sym_preproc_elif_token1] = ACTIONS(3355),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3355),
    [sym_interpolation_verbatim_start] = ACTIONS(3355),
    [sym_interpolation_raw_start] = ACTIONS(3355),
    [sym_raw_string_start] = ACTIONS(3355),
  },
  [2294] = {
    [sym_preproc_region] = STATE(2294),
    [sym_preproc_endregion] = STATE(2294),
    [sym_preproc_line] = STATE(2294),
    [sym_preproc_pragma] = STATE(2294),
    [sym_preproc_nullable] = STATE(2294),
    [sym_preproc_error] = STATE(2294),
    [sym_preproc_define] = STATE(2294),
    [sym_preproc_undef] = STATE(2294),
    [sym__identifier_token] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym_alias] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_global] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_unsafe] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_ref] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_delegate] = ACTIONS(3357),
    [anon_sym_record] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_file] = ACTIONS(3357),
    [anon_sym_fixed] = ACTIONS(3357),
    [anon_sym_internal] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_partial] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_required] = ACTIONS(3357),
    [anon_sym_sealed] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_where] = ACTIONS(3357),
    [anon_sym_notnull] = ACTIONS(3357),
    [anon_sym_unmanaged] = ACTIONS(3357),
    [anon_sym_checked] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_true] = ACTIONS(3357),
    [anon_sym_false] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_CARET] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_this] = ACTIONS(3357),
    [anon_sym_scoped] = ACTIONS(3357),
    [anon_sym_base] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [sym_predefined_type] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_unchecked] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_lock] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_when] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_foreach] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_DOT_DOT] = ACTIONS(3359),
    [anon_sym_from] = ACTIONS(3357),
    [anon_sym_into] = ACTIONS(3357),
    [anon_sym_join] = ACTIONS(3357),
    [anon_sym_on] = ACTIONS(3357),
    [anon_sym_equals] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_orderby] = ACTIONS(3357),
    [anon_sym_ascending] = ACTIONS(3357),
    [anon_sym_descending] = ACTIONS(3357),
    [anon_sym_group] = ACTIONS(3357),
    [anon_sym_by] = ACTIONS(3357),
    [anon_sym_select] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3357),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym___makeref] = ACTIONS(3357),
    [anon_sym___reftype] = ACTIONS(3357),
    [anon_sym___refvalue] = ACTIONS(3357),
    [sym_null_literal] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [sym_integer_literal] = ACTIONS(3357),
    [sym_real_literal] = ACTIONS(3359),
    [sym_verbatim_string_literal] = ACTIONS(3359),
    [aux_sym_preproc_if_token1] = ACTIONS(3359),
    [aux_sym_preproc_if_token3] = ACTIONS(3359),
    [aux_sym_preproc_else_token1] = ACTIONS(3359),
    [aux_sym_preproc_elif_token1] = ACTIONS(3359),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3359),
    [sym_interpolation_verbatim_start] = ACTIONS(3359),
    [sym_interpolation_raw_start] = ACTIONS(3359),
    [sym_raw_string_start] = ACTIONS(3359),
  },
  [2295] = {
    [sym_preproc_region] = STATE(2295),
    [sym_preproc_endregion] = STATE(2295),
    [sym_preproc_line] = STATE(2295),
    [sym_preproc_pragma] = STATE(2295),
    [sym_preproc_nullable] = STATE(2295),
    [sym_preproc_error] = STATE(2295),
    [sym_preproc_define] = STATE(2295),
    [sym_preproc_undef] = STATE(2295),
    [sym__identifier_token] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_alias] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_global] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_unsafe] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_ref] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_delegate] = ACTIONS(3361),
    [anon_sym_record] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_file] = ACTIONS(3361),
    [anon_sym_fixed] = ACTIONS(3361),
    [anon_sym_internal] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_partial] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_required] = ACTIONS(3361),
    [anon_sym_sealed] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_where] = ACTIONS(3361),
    [anon_sym_notnull] = ACTIONS(3361),
    [anon_sym_unmanaged] = ACTIONS(3361),
    [anon_sym_checked] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_true] = ACTIONS(3361),
    [anon_sym_false] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_this] = ACTIONS(3361),
    [anon_sym_scoped] = ACTIONS(3361),
    [anon_sym_base] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [sym_predefined_type] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_unchecked] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_lock] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_when] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_foreach] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_DOT_DOT] = ACTIONS(3363),
    [anon_sym_from] = ACTIONS(3361),
    [anon_sym_into] = ACTIONS(3361),
    [anon_sym_join] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [anon_sym_equals] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_orderby] = ACTIONS(3361),
    [anon_sym_ascending] = ACTIONS(3361),
    [anon_sym_descending] = ACTIONS(3361),
    [anon_sym_group] = ACTIONS(3361),
    [anon_sym_by] = ACTIONS(3361),
    [anon_sym_select] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3361),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym___makeref] = ACTIONS(3361),
    [anon_sym___reftype] = ACTIONS(3361),
    [anon_sym___refvalue] = ACTIONS(3361),
    [sym_null_literal] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [sym_integer_literal] = ACTIONS(3361),
    [sym_real_literal] = ACTIONS(3363),
    [sym_verbatim_string_literal] = ACTIONS(3363),
    [aux_sym_preproc_if_token1] = ACTIONS(3363),
    [aux_sym_preproc_if_token3] = ACTIONS(3363),
    [aux_sym_preproc_else_token1] = ACTIONS(3363),
    [aux_sym_preproc_elif_token1] = ACTIONS(3363),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3363),
    [sym_interpolation_verbatim_start] = ACTIONS(3363),
    [sym_interpolation_raw_start] = ACTIONS(3363),
    [sym_raw_string_start] = ACTIONS(3363),
  },
  [2296] = {
    [sym_preproc_region] = STATE(2296),
    [sym_preproc_endregion] = STATE(2296),
    [sym_preproc_line] = STATE(2296),
    [sym_preproc_pragma] = STATE(2296),
    [sym_preproc_nullable] = STATE(2296),
    [sym_preproc_error] = STATE(2296),
    [sym_preproc_define] = STATE(2296),
    [sym_preproc_undef] = STATE(2296),
    [sym__identifier_token] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3365),
    [anon_sym_alias] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_global] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_unsafe] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_ref] = ACTIONS(3365),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_delegate] = ACTIONS(3365),
    [anon_sym_record] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_file] = ACTIONS(3365),
    [anon_sym_fixed] = ACTIONS(3365),
    [anon_sym_internal] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_partial] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_required] = ACTIONS(3365),
    [anon_sym_sealed] = ACTIONS(3365),
    [anon_sym_virtual] = ACTIONS(3365),
    [anon_sym_volatile] = ACTIONS(3365),
    [anon_sym_where] = ACTIONS(3365),
    [anon_sym_notnull] = ACTIONS(3365),
    [anon_sym_unmanaged] = ACTIONS(3365),
    [anon_sym_checked] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [anon_sym_true] = ACTIONS(3365),
    [anon_sym_false] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_STAR] = ACTIONS(3367),
    [anon_sym_CARET] = ACTIONS(3367),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_this] = ACTIONS(3365),
    [anon_sym_scoped] = ACTIONS(3365),
    [anon_sym_base] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [sym_predefined_type] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_unchecked] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_lock] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_when] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_foreach] = ACTIONS(3365),
    [anon_sym_goto] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_DOT_DOT] = ACTIONS(3367),
    [anon_sym_from] = ACTIONS(3365),
    [anon_sym_into] = ACTIONS(3365),
    [anon_sym_join] = ACTIONS(3365),
    [anon_sym_on] = ACTIONS(3365),
    [anon_sym_equals] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_orderby] = ACTIONS(3365),
    [anon_sym_ascending] = ACTIONS(3365),
    [anon_sym_descending] = ACTIONS(3365),
    [anon_sym_group] = ACTIONS(3365),
    [anon_sym_by] = ACTIONS(3365),
    [anon_sym_select] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3365),
    [anon_sym_sizeof] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym___makeref] = ACTIONS(3365),
    [anon_sym___reftype] = ACTIONS(3365),
    [anon_sym___refvalue] = ACTIONS(3365),
    [sym_null_literal] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [sym_integer_literal] = ACTIONS(3365),
    [sym_real_literal] = ACTIONS(3367),
    [sym_verbatim_string_literal] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token3] = ACTIONS(3367),
    [aux_sym_preproc_else_token1] = ACTIONS(3367),
    [aux_sym_preproc_elif_token1] = ACTIONS(3367),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3367),
    [sym_interpolation_verbatim_start] = ACTIONS(3367),
    [sym_interpolation_raw_start] = ACTIONS(3367),
    [sym_raw_string_start] = ACTIONS(3367),
  },
  [2297] = {
    [sym_preproc_region] = STATE(2297),
    [sym_preproc_endregion] = STATE(2297),
    [sym_preproc_line] = STATE(2297),
    [sym_preproc_pragma] = STATE(2297),
    [sym_preproc_nullable] = STATE(2297),
    [sym_preproc_error] = STATE(2297),
    [sym_preproc_define] = STATE(2297),
    [sym_preproc_undef] = STATE(2297),
    [sym__identifier_token] = ACTIONS(3369),
    [anon_sym_extern] = ACTIONS(3369),
    [anon_sym_alias] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_global] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_unsafe] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_ref] = ACTIONS(3369),
    [anon_sym_struct] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_delegate] = ACTIONS(3369),
    [anon_sym_record] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_file] = ACTIONS(3369),
    [anon_sym_fixed] = ACTIONS(3369),
    [anon_sym_internal] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_partial] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_required] = ACTIONS(3369),
    [anon_sym_sealed] = ACTIONS(3369),
    [anon_sym_virtual] = ACTIONS(3369),
    [anon_sym_volatile] = ACTIONS(3369),
    [anon_sym_where] = ACTIONS(3369),
    [anon_sym_notnull] = ACTIONS(3369),
    [anon_sym_unmanaged] = ACTIONS(3369),
    [anon_sym_checked] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [anon_sym_true] = ACTIONS(3369),
    [anon_sym_false] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(3371),
    [anon_sym_CARET] = ACTIONS(3371),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_this] = ACTIONS(3369),
    [anon_sym_scoped] = ACTIONS(3369),
    [anon_sym_base] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [sym_predefined_type] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_unchecked] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_lock] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_when] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_foreach] = ACTIONS(3369),
    [anon_sym_goto] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_else] = ACTIONS(3369),
    [anon_sym_DOT_DOT] = ACTIONS(3371),
    [anon_sym_from] = ACTIONS(3369),
    [anon_sym_into] = ACTIONS(3369),
    [anon_sym_join] = ACTIONS(3369),
    [anon_sym_on] = ACTIONS(3369),
    [anon_sym_equals] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_orderby] = ACTIONS(3369),
    [anon_sym_ascending] = ACTIONS(3369),
    [anon_sym_descending] = ACTIONS(3369),
    [anon_sym_group] = ACTIONS(3369),
    [anon_sym_by] = ACTIONS(3369),
    [anon_sym_select] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym___makeref] = ACTIONS(3369),
    [anon_sym___reftype] = ACTIONS(3369),
    [anon_sym___refvalue] = ACTIONS(3369),
    [sym_null_literal] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [sym_integer_literal] = ACTIONS(3369),
    [sym_real_literal] = ACTIONS(3371),
    [sym_verbatim_string_literal] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_if_token3] = ACTIONS(3371),
    [aux_sym_preproc_else_token1] = ACTIONS(3371),
    [aux_sym_preproc_elif_token1] = ACTIONS(3371),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3371),
    [sym_interpolation_verbatim_start] = ACTIONS(3371),
    [sym_interpolation_raw_start] = ACTIONS(3371),
    [sym_raw_string_start] = ACTIONS(3371),
  },
  [2298] = {
    [sym_preproc_region] = STATE(2298),
    [sym_preproc_endregion] = STATE(2298),
    [sym_preproc_line] = STATE(2298),
    [sym_preproc_pragma] = STATE(2298),
    [sym_preproc_nullable] = STATE(2298),
    [sym_preproc_error] = STATE(2298),
    [sym_preproc_define] = STATE(2298),
    [sym_preproc_undef] = STATE(2298),
    [sym__identifier_token] = ACTIONS(3373),
    [anon_sym_extern] = ACTIONS(3373),
    [anon_sym_alias] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_global] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_unsafe] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_ref] = ACTIONS(3373),
    [anon_sym_struct] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_delegate] = ACTIONS(3373),
    [anon_sym_record] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_file] = ACTIONS(3373),
    [anon_sym_fixed] = ACTIONS(3373),
    [anon_sym_internal] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_partial] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_required] = ACTIONS(3373),
    [anon_sym_sealed] = ACTIONS(3373),
    [anon_sym_virtual] = ACTIONS(3373),
    [anon_sym_volatile] = ACTIONS(3373),
    [anon_sym_where] = ACTIONS(3373),
    [anon_sym_notnull] = ACTIONS(3373),
    [anon_sym_unmanaged] = ACTIONS(3373),
    [anon_sym_checked] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_true] = ACTIONS(3373),
    [anon_sym_false] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_CARET] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_this] = ACTIONS(3373),
    [anon_sym_scoped] = ACTIONS(3373),
    [anon_sym_base] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [sym_predefined_type] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_unchecked] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_lock] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_when] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_foreach] = ACTIONS(3373),
    [anon_sym_goto] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_DOT_DOT] = ACTIONS(3375),
    [anon_sym_from] = ACTIONS(3373),
    [anon_sym_into] = ACTIONS(3373),
    [anon_sym_join] = ACTIONS(3373),
    [anon_sym_on] = ACTIONS(3373),
    [anon_sym_equals] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_orderby] = ACTIONS(3373),
    [anon_sym_ascending] = ACTIONS(3373),
    [anon_sym_descending] = ACTIONS(3373),
    [anon_sym_group] = ACTIONS(3373),
    [anon_sym_by] = ACTIONS(3373),
    [anon_sym_select] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym___makeref] = ACTIONS(3373),
    [anon_sym___reftype] = ACTIONS(3373),
    [anon_sym___refvalue] = ACTIONS(3373),
    [sym_null_literal] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [sym_integer_literal] = ACTIONS(3373),
    [sym_real_literal] = ACTIONS(3375),
    [sym_verbatim_string_literal] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_if_token3] = ACTIONS(3375),
    [aux_sym_preproc_else_token1] = ACTIONS(3375),
    [aux_sym_preproc_elif_token1] = ACTIONS(3375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3375),
    [sym_interpolation_verbatim_start] = ACTIONS(3375),
    [sym_interpolation_raw_start] = ACTIONS(3375),
    [sym_raw_string_start] = ACTIONS(3375),
  },
  [2299] = {
    [sym_preproc_region] = STATE(2299),
    [sym_preproc_endregion] = STATE(2299),
    [sym_preproc_line] = STATE(2299),
    [sym_preproc_pragma] = STATE(2299),
    [sym_preproc_nullable] = STATE(2299),
    [sym_preproc_error] = STATE(2299),
    [sym_preproc_define] = STATE(2299),
    [sym_preproc_undef] = STATE(2299),
    [ts_builtin_sym_end] = ACTIONS(3038),
    [sym__identifier_token] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym_alias] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_global] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_unsafe] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_namespace] = ACTIONS(3036),
    [anon_sym_class] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [anon_sym_struct] = ACTIONS(3036),
    [anon_sym_enum] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_interface] = ACTIONS(3036),
    [anon_sym_delegate] = ACTIONS(3036),
    [anon_sym_record] = ACTIONS(3036),
    [anon_sym_abstract] = ACTIONS(3036),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_file] = ACTIONS(3036),
    [anon_sym_fixed] = ACTIONS(3036),
    [anon_sym_internal] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_partial] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_required] = ACTIONS(3036),
    [anon_sym_sealed] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_where] = ACTIONS(3036),
    [anon_sym_notnull] = ACTIONS(3036),
    [anon_sym_unmanaged] = ACTIONS(3036),
    [anon_sym_checked] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_true] = ACTIONS(3036),
    [anon_sym_false] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_this] = ACTIONS(3036),
    [anon_sym_scoped] = ACTIONS(3036),
    [anon_sym_base] = ACTIONS(3036),
    [anon_sym_var] = ACTIONS(3036),
    [sym_predefined_type] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_unchecked] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_lock] = ACTIONS(3036),
    [anon_sym_yield] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_catch] = ACTIONS(3036),
    [anon_sym_when] = ACTIONS(3036),
    [anon_sym_finally] = ACTIONS(3036),
    [anon_sym_await] = ACTIONS(3036),
    [anon_sym_foreach] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_DOT_DOT] = ACTIONS(3038),
    [anon_sym_from] = ACTIONS(3036),
    [anon_sym_into] = ACTIONS(3036),
    [anon_sym_join] = ACTIONS(3036),
    [anon_sym_on] = ACTIONS(3036),
    [anon_sym_equals] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_orderby] = ACTIONS(3036),
    [anon_sym_ascending] = ACTIONS(3036),
    [anon_sym_descending] = ACTIONS(3036),
    [anon_sym_group] = ACTIONS(3036),
    [anon_sym_by] = ACTIONS(3036),
    [anon_sym_select] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_stackalloc] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym_typeof] = ACTIONS(3036),
    [anon_sym___makeref] = ACTIONS(3036),
    [anon_sym___reftype] = ACTIONS(3036),
    [anon_sym___refvalue] = ACTIONS(3036),
    [sym_null_literal] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [sym_integer_literal] = ACTIONS(3036),
    [sym_real_literal] = ACTIONS(3038),
    [sym_verbatim_string_literal] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3038),
    [sym_interpolation_verbatim_start] = ACTIONS(3038),
    [sym_interpolation_raw_start] = ACTIONS(3038),
    [sym_raw_string_start] = ACTIONS(3038),
  },
  [2300] = {
    [sym_preproc_region] = STATE(2300),
    [sym_preproc_endregion] = STATE(2300),
    [sym_preproc_line] = STATE(2300),
    [sym_preproc_pragma] = STATE(2300),
    [sym_preproc_nullable] = STATE(2300),
    [sym_preproc_error] = STATE(2300),
    [sym_preproc_define] = STATE(2300),
    [sym_preproc_undef] = STATE(2300),
    [sym__identifier_token] = ACTIONS(3377),
    [anon_sym_extern] = ACTIONS(3377),
    [anon_sym_alias] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_global] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_unsafe] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_ref] = ACTIONS(3377),
    [anon_sym_struct] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_delegate] = ACTIONS(3377),
    [anon_sym_record] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_file] = ACTIONS(3377),
    [anon_sym_fixed] = ACTIONS(3377),
    [anon_sym_internal] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_partial] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_required] = ACTIONS(3377),
    [anon_sym_sealed] = ACTIONS(3377),
    [anon_sym_virtual] = ACTIONS(3377),
    [anon_sym_volatile] = ACTIONS(3377),
    [anon_sym_where] = ACTIONS(3377),
    [anon_sym_notnull] = ACTIONS(3377),
    [anon_sym_unmanaged] = ACTIONS(3377),
    [anon_sym_checked] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_true] = ACTIONS(3377),
    [anon_sym_false] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_CARET] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_this] = ACTIONS(3377),
    [anon_sym_scoped] = ACTIONS(3377),
    [anon_sym_base] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [sym_predefined_type] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_unchecked] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_lock] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_when] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_foreach] = ACTIONS(3377),
    [anon_sym_goto] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_from] = ACTIONS(3377),
    [anon_sym_into] = ACTIONS(3377),
    [anon_sym_join] = ACTIONS(3377),
    [anon_sym_on] = ACTIONS(3377),
    [anon_sym_equals] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_orderby] = ACTIONS(3377),
    [anon_sym_ascending] = ACTIONS(3377),
    [anon_sym_descending] = ACTIONS(3377),
    [anon_sym_group] = ACTIONS(3377),
    [anon_sym_by] = ACTIONS(3377),
    [anon_sym_select] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym___makeref] = ACTIONS(3377),
    [anon_sym___reftype] = ACTIONS(3377),
    [anon_sym___refvalue] = ACTIONS(3377),
    [sym_null_literal] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [sym_integer_literal] = ACTIONS(3377),
    [sym_real_literal] = ACTIONS(3379),
    [sym_verbatim_string_literal] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_if_token3] = ACTIONS(3379),
    [aux_sym_preproc_else_token1] = ACTIONS(3379),
    [aux_sym_preproc_elif_token1] = ACTIONS(3379),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3379),
    [sym_interpolation_verbatim_start] = ACTIONS(3379),
    [sym_interpolation_raw_start] = ACTIONS(3379),
    [sym_raw_string_start] = ACTIONS(3379),
  },
  [2301] = {
    [sym_preproc_region] = STATE(2301),
    [sym_preproc_endregion] = STATE(2301),
    [sym_preproc_line] = STATE(2301),
    [sym_preproc_pragma] = STATE(2301),
    [sym_preproc_nullable] = STATE(2301),
    [sym_preproc_error] = STATE(2301),
    [sym_preproc_define] = STATE(2301),
    [sym_preproc_undef] = STATE(2301),
    [sym__identifier_token] = ACTIONS(3381),
    [anon_sym_extern] = ACTIONS(3381),
    [anon_sym_alias] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_global] = ACTIONS(3381),
    [anon_sym_using] = ACTIONS(3381),
    [anon_sym_unsafe] = ACTIONS(3381),
    [anon_sym_static] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3381),
    [anon_sym_namespace] = ACTIONS(3381),
    [anon_sym_class] = ACTIONS(3381),
    [anon_sym_ref] = ACTIONS(3381),
    [anon_sym_struct] = ACTIONS(3381),
    [anon_sym_enum] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3381),
    [anon_sym_delegate] = ACTIONS(3381),
    [anon_sym_record] = ACTIONS(3381),
    [anon_sym_abstract] = ACTIONS(3381),
    [anon_sym_async] = ACTIONS(3381),
    [anon_sym_const] = ACTIONS(3381),
    [anon_sym_file] = ACTIONS(3381),
    [anon_sym_fixed] = ACTIONS(3381),
    [anon_sym_internal] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3381),
    [anon_sym_override] = ACTIONS(3381),
    [anon_sym_partial] = ACTIONS(3381),
    [anon_sym_private] = ACTIONS(3381),
    [anon_sym_protected] = ACTIONS(3381),
    [anon_sym_public] = ACTIONS(3381),
    [anon_sym_readonly] = ACTIONS(3381),
    [anon_sym_required] = ACTIONS(3381),
    [anon_sym_sealed] = ACTIONS(3381),
    [anon_sym_virtual] = ACTIONS(3381),
    [anon_sym_volatile] = ACTIONS(3381),
    [anon_sym_where] = ACTIONS(3381),
    [anon_sym_notnull] = ACTIONS(3381),
    [anon_sym_unmanaged] = ACTIONS(3381),
    [anon_sym_checked] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_true] = ACTIONS(3381),
    [anon_sym_false] = ACTIONS(3381),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_this] = ACTIONS(3381),
    [anon_sym_scoped] = ACTIONS(3381),
    [anon_sym_base] = ACTIONS(3381),
    [anon_sym_var] = ACTIONS(3381),
    [sym_predefined_type] = ACTIONS(3381),
    [anon_sym_break] = ACTIONS(3381),
    [anon_sym_unchecked] = ACTIONS(3381),
    [anon_sym_continue] = ACTIONS(3381),
    [anon_sym_do] = ACTIONS(3381),
    [anon_sym_while] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(3381),
    [anon_sym_lock] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(3381),
    [anon_sym_switch] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3381),
    [anon_sym_throw] = ACTIONS(3381),
    [anon_sym_try] = ACTIONS(3381),
    [anon_sym_when] = ACTIONS(3381),
    [anon_sym_await] = ACTIONS(3381),
    [anon_sym_foreach] = ACTIONS(3381),
    [anon_sym_goto] = ACTIONS(3381),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_else] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_from] = ACTIONS(3381),
    [anon_sym_into] = ACTIONS(3381),
    [anon_sym_join] = ACTIONS(3381),
    [anon_sym_on] = ACTIONS(3381),
    [anon_sym_equals] = ACTIONS(3381),
    [anon_sym_let] = ACTIONS(3381),
    [anon_sym_orderby] = ACTIONS(3381),
    [anon_sym_ascending] = ACTIONS(3381),
    [anon_sym_descending] = ACTIONS(3381),
    [anon_sym_group] = ACTIONS(3381),
    [anon_sym_by] = ACTIONS(3381),
    [anon_sym_select] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3381),
    [anon_sym_typeof] = ACTIONS(3381),
    [anon_sym___makeref] = ACTIONS(3381),
    [anon_sym___reftype] = ACTIONS(3381),
    [anon_sym___refvalue] = ACTIONS(3381),
    [sym_null_literal] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [sym_integer_literal] = ACTIONS(3381),
    [sym_real_literal] = ACTIONS(3383),
    [sym_verbatim_string_literal] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_if_token3] = ACTIONS(3383),
    [aux_sym_preproc_else_token1] = ACTIONS(3383),
    [aux_sym_preproc_elif_token1] = ACTIONS(3383),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3383),
    [sym_interpolation_verbatim_start] = ACTIONS(3383),
    [sym_interpolation_raw_start] = ACTIONS(3383),
    [sym_raw_string_start] = ACTIONS(3383),
  },
  [2302] = {
    [sym_preproc_region] = STATE(2302),
    [sym_preproc_endregion] = STATE(2302),
    [sym_preproc_line] = STATE(2302),
    [sym_preproc_pragma] = STATE(2302),
    [sym_preproc_nullable] = STATE(2302),
    [sym_preproc_error] = STATE(2302),
    [sym_preproc_define] = STATE(2302),
    [sym_preproc_undef] = STATE(2302),
    [sym__identifier_token] = ACTIONS(3385),
    [anon_sym_extern] = ACTIONS(3385),
    [anon_sym_alias] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_global] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_unsafe] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_ref] = ACTIONS(3385),
    [anon_sym_struct] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_delegate] = ACTIONS(3385),
    [anon_sym_record] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_file] = ACTIONS(3385),
    [anon_sym_fixed] = ACTIONS(3385),
    [anon_sym_internal] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_partial] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_required] = ACTIONS(3385),
    [anon_sym_sealed] = ACTIONS(3385),
    [anon_sym_virtual] = ACTIONS(3385),
    [anon_sym_volatile] = ACTIONS(3385),
    [anon_sym_where] = ACTIONS(3385),
    [anon_sym_notnull] = ACTIONS(3385),
    [anon_sym_unmanaged] = ACTIONS(3385),
    [anon_sym_checked] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_true] = ACTIONS(3385),
    [anon_sym_false] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_CARET] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_this] = ACTIONS(3385),
    [anon_sym_scoped] = ACTIONS(3385),
    [anon_sym_base] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [sym_predefined_type] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_unchecked] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_lock] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_when] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_foreach] = ACTIONS(3385),
    [anon_sym_goto] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_DOT_DOT] = ACTIONS(3387),
    [anon_sym_from] = ACTIONS(3385),
    [anon_sym_into] = ACTIONS(3385),
    [anon_sym_join] = ACTIONS(3385),
    [anon_sym_on] = ACTIONS(3385),
    [anon_sym_equals] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_orderby] = ACTIONS(3385),
    [anon_sym_ascending] = ACTIONS(3385),
    [anon_sym_descending] = ACTIONS(3385),
    [anon_sym_group] = ACTIONS(3385),
    [anon_sym_by] = ACTIONS(3385),
    [anon_sym_select] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym___makeref] = ACTIONS(3385),
    [anon_sym___reftype] = ACTIONS(3385),
    [anon_sym___refvalue] = ACTIONS(3385),
    [sym_null_literal] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [sym_integer_literal] = ACTIONS(3385),
    [sym_real_literal] = ACTIONS(3387),
    [sym_verbatim_string_literal] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_if_token3] = ACTIONS(3387),
    [aux_sym_preproc_else_token1] = ACTIONS(3387),
    [aux_sym_preproc_elif_token1] = ACTIONS(3387),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3387),
    [sym_interpolation_verbatim_start] = ACTIONS(3387),
    [sym_interpolation_raw_start] = ACTIONS(3387),
    [sym_raw_string_start] = ACTIONS(3387),
  },
  [2303] = {
    [sym_preproc_region] = STATE(2303),
    [sym_preproc_endregion] = STATE(2303),
    [sym_preproc_line] = STATE(2303),
    [sym_preproc_pragma] = STATE(2303),
    [sym_preproc_nullable] = STATE(2303),
    [sym_preproc_error] = STATE(2303),
    [sym_preproc_define] = STATE(2303),
    [sym_preproc_undef] = STATE(2303),
    [sym__identifier_token] = ACTIONS(3389),
    [anon_sym_extern] = ACTIONS(3389),
    [anon_sym_alias] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_global] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_unsafe] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_ref] = ACTIONS(3389),
    [anon_sym_struct] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_delegate] = ACTIONS(3389),
    [anon_sym_record] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_file] = ACTIONS(3389),
    [anon_sym_fixed] = ACTIONS(3389),
    [anon_sym_internal] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_partial] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_required] = ACTIONS(3389),
    [anon_sym_sealed] = ACTIONS(3389),
    [anon_sym_virtual] = ACTIONS(3389),
    [anon_sym_volatile] = ACTIONS(3389),
    [anon_sym_where] = ACTIONS(3389),
    [anon_sym_notnull] = ACTIONS(3389),
    [anon_sym_unmanaged] = ACTIONS(3389),
    [anon_sym_checked] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [anon_sym_true] = ACTIONS(3389),
    [anon_sym_false] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_CARET] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_this] = ACTIONS(3389),
    [anon_sym_scoped] = ACTIONS(3389),
    [anon_sym_base] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [sym_predefined_type] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_unchecked] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_lock] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_when] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_foreach] = ACTIONS(3389),
    [anon_sym_goto] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_else] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3391),
    [anon_sym_from] = ACTIONS(3389),
    [anon_sym_into] = ACTIONS(3389),
    [anon_sym_join] = ACTIONS(3389),
    [anon_sym_on] = ACTIONS(3389),
    [anon_sym_equals] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_orderby] = ACTIONS(3389),
    [anon_sym_ascending] = ACTIONS(3389),
    [anon_sym_descending] = ACTIONS(3389),
    [anon_sym_group] = ACTIONS(3389),
    [anon_sym_by] = ACTIONS(3389),
    [anon_sym_select] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym___makeref] = ACTIONS(3389),
    [anon_sym___reftype] = ACTIONS(3389),
    [anon_sym___refvalue] = ACTIONS(3389),
    [sym_null_literal] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [sym_integer_literal] = ACTIONS(3389),
    [sym_real_literal] = ACTIONS(3391),
    [sym_verbatim_string_literal] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_if_token3] = ACTIONS(3391),
    [aux_sym_preproc_else_token1] = ACTIONS(3391),
    [aux_sym_preproc_elif_token1] = ACTIONS(3391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3391),
    [sym_interpolation_verbatim_start] = ACTIONS(3391),
    [sym_interpolation_raw_start] = ACTIONS(3391),
    [sym_raw_string_start] = ACTIONS(3391),
  },
  [2304] = {
    [sym_preproc_region] = STATE(2304),
    [sym_preproc_endregion] = STATE(2304),
    [sym_preproc_line] = STATE(2304),
    [sym_preproc_pragma] = STATE(2304),
    [sym_preproc_nullable] = STATE(2304),
    [sym_preproc_error] = STATE(2304),
    [sym_preproc_define] = STATE(2304),
    [sym_preproc_undef] = STATE(2304),
    [sym__identifier_token] = ACTIONS(3393),
    [anon_sym_extern] = ACTIONS(3393),
    [anon_sym_alias] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_global] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_unsafe] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_ref] = ACTIONS(3393),
    [anon_sym_struct] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_delegate] = ACTIONS(3393),
    [anon_sym_record] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_file] = ACTIONS(3393),
    [anon_sym_fixed] = ACTIONS(3393),
    [anon_sym_internal] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_partial] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_required] = ACTIONS(3393),
    [anon_sym_sealed] = ACTIONS(3393),
    [anon_sym_virtual] = ACTIONS(3393),
    [anon_sym_volatile] = ACTIONS(3393),
    [anon_sym_where] = ACTIONS(3393),
    [anon_sym_notnull] = ACTIONS(3393),
    [anon_sym_unmanaged] = ACTIONS(3393),
    [anon_sym_checked] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [anon_sym_true] = ACTIONS(3393),
    [anon_sym_false] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_this] = ACTIONS(3393),
    [anon_sym_scoped] = ACTIONS(3393),
    [anon_sym_base] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [sym_predefined_type] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_unchecked] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_lock] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_when] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_foreach] = ACTIONS(3393),
    [anon_sym_goto] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_DOT_DOT] = ACTIONS(3395),
    [anon_sym_from] = ACTIONS(3393),
    [anon_sym_into] = ACTIONS(3393),
    [anon_sym_join] = ACTIONS(3393),
    [anon_sym_on] = ACTIONS(3393),
    [anon_sym_equals] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_orderby] = ACTIONS(3393),
    [anon_sym_ascending] = ACTIONS(3393),
    [anon_sym_descending] = ACTIONS(3393),
    [anon_sym_group] = ACTIONS(3393),
    [anon_sym_by] = ACTIONS(3393),
    [anon_sym_select] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_stackalloc] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym___makeref] = ACTIONS(3393),
    [anon_sym___reftype] = ACTIONS(3393),
    [anon_sym___refvalue] = ACTIONS(3393),
    [sym_null_literal] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [sym_integer_literal] = ACTIONS(3393),
    [sym_real_literal] = ACTIONS(3395),
    [sym_verbatim_string_literal] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_if_token3] = ACTIONS(3395),
    [aux_sym_preproc_else_token1] = ACTIONS(3395),
    [aux_sym_preproc_elif_token1] = ACTIONS(3395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3395),
    [sym_interpolation_verbatim_start] = ACTIONS(3395),
    [sym_interpolation_raw_start] = ACTIONS(3395),
    [sym_raw_string_start] = ACTIONS(3395),
  },
  [2305] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_else] = STATE(9437),
    [sym_preproc_elif] = STATE(9437),
    [sym_preproc_region] = STATE(2305),
    [sym_preproc_endregion] = STATE(2305),
    [sym_preproc_line] = STATE(2305),
    [sym_preproc_pragma] = STATE(2305),
    [sym_preproc_nullable] = STATE(2305),
    [sym_preproc_error] = STATE(2305),
    [sym_preproc_define] = STATE(2305),
    [sym_preproc_undef] = STATE(2305),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2270),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(3397),
    [aux_sym_preproc_else_token1] = ACTIONS(3163),
    [aux_sym_preproc_elif_token1] = ACTIONS(3165),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2306] = {
    [sym_preproc_region] = STATE(2306),
    [sym_preproc_endregion] = STATE(2306),
    [sym_preproc_line] = STATE(2306),
    [sym_preproc_pragma] = STATE(2306),
    [sym_preproc_nullable] = STATE(2306),
    [sym_preproc_error] = STATE(2306),
    [sym_preproc_define] = STATE(2306),
    [sym_preproc_undef] = STATE(2306),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_record] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_checked] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_true] = ACTIONS(3399),
    [anon_sym_false] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_this] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_base] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_unchecked] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_lock] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_foreach] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_DOT_DOT] = ACTIONS(3401),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym___makeref] = ACTIONS(3399),
    [anon_sym___reftype] = ACTIONS(3399),
    [anon_sym___refvalue] = ACTIONS(3399),
    [sym_null_literal] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_integer_literal] = ACTIONS(3399),
    [sym_real_literal] = ACTIONS(3401),
    [sym_verbatim_string_literal] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_if_token3] = ACTIONS(3401),
    [aux_sym_preproc_else_token1] = ACTIONS(3401),
    [aux_sym_preproc_elif_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3401),
    [sym_interpolation_verbatim_start] = ACTIONS(3401),
    [sym_interpolation_raw_start] = ACTIONS(3401),
    [sym_raw_string_start] = ACTIONS(3401),
  },
  [2307] = {
    [sym_preproc_region] = STATE(2307),
    [sym_preproc_endregion] = STATE(2307),
    [sym_preproc_line] = STATE(2307),
    [sym_preproc_pragma] = STATE(2307),
    [sym_preproc_nullable] = STATE(2307),
    [sym_preproc_error] = STATE(2307),
    [sym_preproc_define] = STATE(2307),
    [sym_preproc_undef] = STATE(2307),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_record] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_checked] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3403),
    [anon_sym_false] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_this] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_base] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_unchecked] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_lock] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_foreach] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym___makeref] = ACTIONS(3403),
    [anon_sym___reftype] = ACTIONS(3403),
    [anon_sym___refvalue] = ACTIONS(3403),
    [sym_null_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_integer_literal] = ACTIONS(3403),
    [sym_real_literal] = ACTIONS(3405),
    [sym_verbatim_string_literal] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_if_token3] = ACTIONS(3405),
    [aux_sym_preproc_else_token1] = ACTIONS(3405),
    [aux_sym_preproc_elif_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3405),
    [sym_interpolation_verbatim_start] = ACTIONS(3405),
    [sym_interpolation_raw_start] = ACTIONS(3405),
    [sym_raw_string_start] = ACTIONS(3405),
  },
  [2308] = {
    [sym_preproc_region] = STATE(2308),
    [sym_preproc_endregion] = STATE(2308),
    [sym_preproc_line] = STATE(2308),
    [sym_preproc_pragma] = STATE(2308),
    [sym_preproc_nullable] = STATE(2308),
    [sym_preproc_error] = STATE(2308),
    [sym_preproc_define] = STATE(2308),
    [sym_preproc_undef] = STATE(2308),
    [sym__identifier_token] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_alias] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_global] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_ref] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3407),
    [anon_sym_record] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_file] = ACTIONS(3407),
    [anon_sym_fixed] = ACTIONS(3407),
    [anon_sym_internal] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_partial] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_required] = ACTIONS(3407),
    [anon_sym_sealed] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_where] = ACTIONS(3407),
    [anon_sym_notnull] = ACTIONS(3407),
    [anon_sym_unmanaged] = ACTIONS(3407),
    [anon_sym_checked] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_true] = ACTIONS(3407),
    [anon_sym_false] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_CARET] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_this] = ACTIONS(3407),
    [anon_sym_scoped] = ACTIONS(3407),
    [anon_sym_base] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [sym_predefined_type] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_unchecked] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_lock] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_when] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_foreach] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_DOT_DOT] = ACTIONS(3409),
    [anon_sym_from] = ACTIONS(3407),
    [anon_sym_into] = ACTIONS(3407),
    [anon_sym_join] = ACTIONS(3407),
    [anon_sym_on] = ACTIONS(3407),
    [anon_sym_equals] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_orderby] = ACTIONS(3407),
    [anon_sym_ascending] = ACTIONS(3407),
    [anon_sym_descending] = ACTIONS(3407),
    [anon_sym_group] = ACTIONS(3407),
    [anon_sym_by] = ACTIONS(3407),
    [anon_sym_select] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [anon_sym_stackalloc] = ACTIONS(3407),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym___makeref] = ACTIONS(3407),
    [anon_sym___reftype] = ACTIONS(3407),
    [anon_sym___refvalue] = ACTIONS(3407),
    [sym_null_literal] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [sym_integer_literal] = ACTIONS(3407),
    [sym_real_literal] = ACTIONS(3409),
    [sym_verbatim_string_literal] = ACTIONS(3409),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_if_token3] = ACTIONS(3409),
    [aux_sym_preproc_else_token1] = ACTIONS(3409),
    [aux_sym_preproc_elif_token1] = ACTIONS(3409),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3409),
    [sym_interpolation_verbatim_start] = ACTIONS(3409),
    [sym_interpolation_raw_start] = ACTIONS(3409),
    [sym_raw_string_start] = ACTIONS(3409),
  },
  [2309] = {
    [sym_preproc_region] = STATE(2309),
    [sym_preproc_endregion] = STATE(2309),
    [sym_preproc_line] = STATE(2309),
    [sym_preproc_pragma] = STATE(2309),
    [sym_preproc_nullable] = STATE(2309),
    [sym_preproc_error] = STATE(2309),
    [sym_preproc_define] = STATE(2309),
    [sym_preproc_undef] = STATE(2309),
    [sym__identifier_token] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_alias] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_global] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_unsafe] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_ref] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3411),
    [anon_sym_record] = ACTIONS(3411),
    [anon_sym_abstract] = ACTIONS(3411),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_file] = ACTIONS(3411),
    [anon_sym_fixed] = ACTIONS(3411),
    [anon_sym_internal] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_override] = ACTIONS(3411),
    [anon_sym_partial] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_readonly] = ACTIONS(3411),
    [anon_sym_required] = ACTIONS(3411),
    [anon_sym_sealed] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_where] = ACTIONS(3411),
    [anon_sym_notnull] = ACTIONS(3411),
    [anon_sym_unmanaged] = ACTIONS(3411),
    [anon_sym_checked] = ACTIONS(3411),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_true] = ACTIONS(3411),
    [anon_sym_false] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_this] = ACTIONS(3411),
    [anon_sym_scoped] = ACTIONS(3411),
    [anon_sym_base] = ACTIONS(3411),
    [anon_sym_var] = ACTIONS(3411),
    [sym_predefined_type] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_unchecked] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_lock] = ACTIONS(3411),
    [anon_sym_yield] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_when] = ACTIONS(3411),
    [anon_sym_await] = ACTIONS(3411),
    [anon_sym_foreach] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_DOT_DOT] = ACTIONS(3413),
    [anon_sym_from] = ACTIONS(3411),
    [anon_sym_into] = ACTIONS(3411),
    [anon_sym_join] = ACTIONS(3411),
    [anon_sym_on] = ACTIONS(3411),
    [anon_sym_equals] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_orderby] = ACTIONS(3411),
    [anon_sym_ascending] = ACTIONS(3411),
    [anon_sym_descending] = ACTIONS(3411),
    [anon_sym_group] = ACTIONS(3411),
    [anon_sym_by] = ACTIONS(3411),
    [anon_sym_select] = ACTIONS(3411),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_stackalloc] = ACTIONS(3411),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym_typeof] = ACTIONS(3411),
    [anon_sym___makeref] = ACTIONS(3411),
    [anon_sym___reftype] = ACTIONS(3411),
    [anon_sym___refvalue] = ACTIONS(3411),
    [sym_null_literal] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [sym_integer_literal] = ACTIONS(3411),
    [sym_real_literal] = ACTIONS(3413),
    [sym_verbatim_string_literal] = ACTIONS(3413),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_if_token3] = ACTIONS(3413),
    [aux_sym_preproc_else_token1] = ACTIONS(3413),
    [aux_sym_preproc_elif_token1] = ACTIONS(3413),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3413),
    [sym_interpolation_verbatim_start] = ACTIONS(3413),
    [sym_interpolation_raw_start] = ACTIONS(3413),
    [sym_raw_string_start] = ACTIONS(3413),
  },
  [2310] = {
    [sym_preproc_region] = STATE(2310),
    [sym_preproc_endregion] = STATE(2310),
    [sym_preproc_line] = STATE(2310),
    [sym_preproc_pragma] = STATE(2310),
    [sym_preproc_nullable] = STATE(2310),
    [sym_preproc_error] = STATE(2310),
    [sym_preproc_define] = STATE(2310),
    [sym_preproc_undef] = STATE(2310),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_checked] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_true] = ACTIONS(3415),
    [anon_sym_false] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_CARET] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_this] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_base] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_unchecked] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_lock] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_foreach] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_DOT_DOT] = ACTIONS(3417),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_stackalloc] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym___makeref] = ACTIONS(3415),
    [anon_sym___reftype] = ACTIONS(3415),
    [anon_sym___refvalue] = ACTIONS(3415),
    [sym_null_literal] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [sym_integer_literal] = ACTIONS(3415),
    [sym_real_literal] = ACTIONS(3417),
    [sym_verbatim_string_literal] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token3] = ACTIONS(3417),
    [aux_sym_preproc_else_token1] = ACTIONS(3417),
    [aux_sym_preproc_elif_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3417),
    [sym_interpolation_verbatim_start] = ACTIONS(3417),
    [sym_interpolation_raw_start] = ACTIONS(3417),
    [sym_raw_string_start] = ACTIONS(3417),
  },
  [2311] = {
    [sym_preproc_region] = STATE(2311),
    [sym_preproc_endregion] = STATE(2311),
    [sym_preproc_line] = STATE(2311),
    [sym_preproc_pragma] = STATE(2311),
    [sym_preproc_nullable] = STATE(2311),
    [sym_preproc_error] = STATE(2311),
    [sym_preproc_define] = STATE(2311),
    [sym_preproc_undef] = STATE(2311),
    [sym__identifier_token] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym_alias] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_global] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_unsafe] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_ref] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_delegate] = ACTIONS(3419),
    [anon_sym_record] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_file] = ACTIONS(3419),
    [anon_sym_fixed] = ACTIONS(3419),
    [anon_sym_internal] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_partial] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_sealed] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_notnull] = ACTIONS(3419),
    [anon_sym_unmanaged] = ACTIONS(3419),
    [anon_sym_checked] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_true] = ACTIONS(3419),
    [anon_sym_false] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_this] = ACTIONS(3419),
    [anon_sym_scoped] = ACTIONS(3419),
    [anon_sym_base] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [sym_predefined_type] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_unchecked] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_lock] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_when] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_foreach] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3421),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_into] = ACTIONS(3419),
    [anon_sym_join] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_equals] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_orderby] = ACTIONS(3419),
    [anon_sym_ascending] = ACTIONS(3419),
    [anon_sym_descending] = ACTIONS(3419),
    [anon_sym_group] = ACTIONS(3419),
    [anon_sym_by] = ACTIONS(3419),
    [anon_sym_select] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_stackalloc] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym___makeref] = ACTIONS(3419),
    [anon_sym___reftype] = ACTIONS(3419),
    [anon_sym___refvalue] = ACTIONS(3419),
    [sym_null_literal] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [sym_integer_literal] = ACTIONS(3419),
    [sym_real_literal] = ACTIONS(3421),
    [sym_verbatim_string_literal] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token3] = ACTIONS(3421),
    [aux_sym_preproc_else_token1] = ACTIONS(3421),
    [aux_sym_preproc_elif_token1] = ACTIONS(3421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3421),
    [sym_interpolation_verbatim_start] = ACTIONS(3421),
    [sym_interpolation_raw_start] = ACTIONS(3421),
    [sym_raw_string_start] = ACTIONS(3421),
  },
  [2312] = {
    [sym_preproc_region] = STATE(2312),
    [sym_preproc_endregion] = STATE(2312),
    [sym_preproc_line] = STATE(2312),
    [sym_preproc_pragma] = STATE(2312),
    [sym_preproc_nullable] = STATE(2312),
    [sym_preproc_error] = STATE(2312),
    [sym_preproc_define] = STATE(2312),
    [sym_preproc_undef] = STATE(2312),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_checked] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_true] = ACTIONS(3423),
    [anon_sym_false] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_this] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_base] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_unchecked] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_lock] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_foreach] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_stackalloc] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym___makeref] = ACTIONS(3423),
    [anon_sym___reftype] = ACTIONS(3423),
    [anon_sym___refvalue] = ACTIONS(3423),
    [sym_null_literal] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [sym_integer_literal] = ACTIONS(3423),
    [sym_real_literal] = ACTIONS(3425),
    [sym_verbatim_string_literal] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token3] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3425),
    [sym_interpolation_verbatim_start] = ACTIONS(3425),
    [sym_interpolation_raw_start] = ACTIONS(3425),
    [sym_raw_string_start] = ACTIONS(3425),
  },
  [2313] = {
    [sym_preproc_region] = STATE(2313),
    [sym_preproc_endregion] = STATE(2313),
    [sym_preproc_line] = STATE(2313),
    [sym_preproc_pragma] = STATE(2313),
    [sym_preproc_nullable] = STATE(2313),
    [sym_preproc_error] = STATE(2313),
    [sym_preproc_define] = STATE(2313),
    [sym_preproc_undef] = STATE(2313),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_checked] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3427),
    [anon_sym_false] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_this] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_base] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_unchecked] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_lock] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_foreach] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_DOT_DOT] = ACTIONS(3429),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_stackalloc] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym___makeref] = ACTIONS(3427),
    [anon_sym___reftype] = ACTIONS(3427),
    [anon_sym___refvalue] = ACTIONS(3427),
    [sym_null_literal] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [sym_integer_literal] = ACTIONS(3427),
    [sym_real_literal] = ACTIONS(3429),
    [sym_verbatim_string_literal] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token3] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3429),
    [sym_interpolation_verbatim_start] = ACTIONS(3429),
    [sym_interpolation_raw_start] = ACTIONS(3429),
    [sym_raw_string_start] = ACTIONS(3429),
  },
  [2314] = {
    [sym_preproc_region] = STATE(2314),
    [sym_preproc_endregion] = STATE(2314),
    [sym_preproc_line] = STATE(2314),
    [sym_preproc_pragma] = STATE(2314),
    [sym_preproc_nullable] = STATE(2314),
    [sym_preproc_error] = STATE(2314),
    [sym_preproc_define] = STATE(2314),
    [sym_preproc_undef] = STATE(2314),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_checked] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_true] = ACTIONS(3431),
    [anon_sym_false] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_this] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_base] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_unchecked] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_lock] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_foreach] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_DOT_DOT] = ACTIONS(3433),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_stackalloc] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym___makeref] = ACTIONS(3431),
    [anon_sym___reftype] = ACTIONS(3431),
    [anon_sym___refvalue] = ACTIONS(3431),
    [sym_null_literal] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [sym_integer_literal] = ACTIONS(3431),
    [sym_real_literal] = ACTIONS(3433),
    [sym_verbatim_string_literal] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token3] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3433),
    [sym_interpolation_verbatim_start] = ACTIONS(3433),
    [sym_interpolation_raw_start] = ACTIONS(3433),
    [sym_raw_string_start] = ACTIONS(3433),
  },
  [2315] = {
    [sym_preproc_region] = STATE(2315),
    [sym_preproc_endregion] = STATE(2315),
    [sym_preproc_line] = STATE(2315),
    [sym_preproc_pragma] = STATE(2315),
    [sym_preproc_nullable] = STATE(2315),
    [sym_preproc_error] = STATE(2315),
    [sym_preproc_define] = STATE(2315),
    [sym_preproc_undef] = STATE(2315),
    [sym__identifier_token] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym_alias] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_global] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_unsafe] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_ref] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_delegate] = ACTIONS(3435),
    [anon_sym_record] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_file] = ACTIONS(3435),
    [anon_sym_fixed] = ACTIONS(3435),
    [anon_sym_internal] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_partial] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_required] = ACTIONS(3435),
    [anon_sym_sealed] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_where] = ACTIONS(3435),
    [anon_sym_notnull] = ACTIONS(3435),
    [anon_sym_unmanaged] = ACTIONS(3435),
    [anon_sym_checked] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3435),
    [anon_sym_false] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_scoped] = ACTIONS(3435),
    [anon_sym_base] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [sym_predefined_type] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_unchecked] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_lock] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_when] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_foreach] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_from] = ACTIONS(3435),
    [anon_sym_into] = ACTIONS(3435),
    [anon_sym_join] = ACTIONS(3435),
    [anon_sym_on] = ACTIONS(3435),
    [anon_sym_equals] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_orderby] = ACTIONS(3435),
    [anon_sym_ascending] = ACTIONS(3435),
    [anon_sym_descending] = ACTIONS(3435),
    [anon_sym_group] = ACTIONS(3435),
    [anon_sym_by] = ACTIONS(3435),
    [anon_sym_select] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_stackalloc] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym___makeref] = ACTIONS(3435),
    [anon_sym___reftype] = ACTIONS(3435),
    [anon_sym___refvalue] = ACTIONS(3435),
    [sym_null_literal] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [sym_integer_literal] = ACTIONS(3435),
    [sym_real_literal] = ACTIONS(3437),
    [sym_verbatim_string_literal] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token3] = ACTIONS(3437),
    [aux_sym_preproc_else_token1] = ACTIONS(3437),
    [aux_sym_preproc_elif_token1] = ACTIONS(3437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3437),
    [sym_interpolation_verbatim_start] = ACTIONS(3437),
    [sym_interpolation_raw_start] = ACTIONS(3437),
    [sym_raw_string_start] = ACTIONS(3437),
  },
  [2316] = {
    [sym_preproc_region] = STATE(2316),
    [sym_preproc_endregion] = STATE(2316),
    [sym_preproc_line] = STATE(2316),
    [sym_preproc_pragma] = STATE(2316),
    [sym_preproc_nullable] = STATE(2316),
    [sym_preproc_error] = STATE(2316),
    [sym_preproc_define] = STATE(2316),
    [sym_preproc_undef] = STATE(2316),
    [sym__identifier_token] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym_alias] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_global] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_unsafe] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_ref] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_delegate] = ACTIONS(3439),
    [anon_sym_record] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_file] = ACTIONS(3439),
    [anon_sym_fixed] = ACTIONS(3439),
    [anon_sym_internal] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_partial] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_required] = ACTIONS(3439),
    [anon_sym_sealed] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_where] = ACTIONS(3439),
    [anon_sym_notnull] = ACTIONS(3439),
    [anon_sym_unmanaged] = ACTIONS(3439),
    [anon_sym_checked] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_true] = ACTIONS(3439),
    [anon_sym_false] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_this] = ACTIONS(3439),
    [anon_sym_scoped] = ACTIONS(3439),
    [anon_sym_base] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [sym_predefined_type] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_unchecked] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_lock] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_when] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_foreach] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_DOT_DOT] = ACTIONS(3441),
    [anon_sym_from] = ACTIONS(3439),
    [anon_sym_into] = ACTIONS(3439),
    [anon_sym_join] = ACTIONS(3439),
    [anon_sym_on] = ACTIONS(3439),
    [anon_sym_equals] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_orderby] = ACTIONS(3439),
    [anon_sym_ascending] = ACTIONS(3439),
    [anon_sym_descending] = ACTIONS(3439),
    [anon_sym_group] = ACTIONS(3439),
    [anon_sym_by] = ACTIONS(3439),
    [anon_sym_select] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_stackalloc] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym___makeref] = ACTIONS(3439),
    [anon_sym___reftype] = ACTIONS(3439),
    [anon_sym___refvalue] = ACTIONS(3439),
    [sym_null_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [sym_integer_literal] = ACTIONS(3439),
    [sym_real_literal] = ACTIONS(3441),
    [sym_verbatim_string_literal] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token3] = ACTIONS(3441),
    [aux_sym_preproc_else_token1] = ACTIONS(3441),
    [aux_sym_preproc_elif_token1] = ACTIONS(3441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3441),
    [sym_interpolation_verbatim_start] = ACTIONS(3441),
    [sym_interpolation_raw_start] = ACTIONS(3441),
    [sym_raw_string_start] = ACTIONS(3441),
  },
  [2317] = {
    [sym_preproc_region] = STATE(2317),
    [sym_preproc_endregion] = STATE(2317),
    [sym_preproc_line] = STATE(2317),
    [sym_preproc_pragma] = STATE(2317),
    [sym_preproc_nullable] = STATE(2317),
    [sym_preproc_error] = STATE(2317),
    [sym_preproc_define] = STATE(2317),
    [sym_preproc_undef] = STATE(2317),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_checked] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_true] = ACTIONS(3443),
    [anon_sym_false] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_this] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_base] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_unchecked] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_lock] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_foreach] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_DOT_DOT] = ACTIONS(3445),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_stackalloc] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym___makeref] = ACTIONS(3443),
    [anon_sym___reftype] = ACTIONS(3443),
    [anon_sym___refvalue] = ACTIONS(3443),
    [sym_null_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [sym_integer_literal] = ACTIONS(3443),
    [sym_real_literal] = ACTIONS(3445),
    [sym_verbatim_string_literal] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token3] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3445),
    [sym_interpolation_verbatim_start] = ACTIONS(3445),
    [sym_interpolation_raw_start] = ACTIONS(3445),
    [sym_raw_string_start] = ACTIONS(3445),
  },
  [2318] = {
    [sym_preproc_region] = STATE(2318),
    [sym_preproc_endregion] = STATE(2318),
    [sym_preproc_line] = STATE(2318),
    [sym_preproc_pragma] = STATE(2318),
    [sym_preproc_nullable] = STATE(2318),
    [sym_preproc_error] = STATE(2318),
    [sym_preproc_define] = STATE(2318),
    [sym_preproc_undef] = STATE(2318),
    [sym__identifier_token] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym_alias] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_global] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_unsafe] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_ref] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_delegate] = ACTIONS(3447),
    [anon_sym_record] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_file] = ACTIONS(3447),
    [anon_sym_fixed] = ACTIONS(3447),
    [anon_sym_internal] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_partial] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_required] = ACTIONS(3447),
    [anon_sym_sealed] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_where] = ACTIONS(3447),
    [anon_sym_notnull] = ACTIONS(3447),
    [anon_sym_unmanaged] = ACTIONS(3447),
    [anon_sym_checked] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_true] = ACTIONS(3447),
    [anon_sym_false] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_CARET] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_this] = ACTIONS(3447),
    [anon_sym_scoped] = ACTIONS(3447),
    [anon_sym_base] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [sym_predefined_type] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_unchecked] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_lock] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_when] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_foreach] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_DOT_DOT] = ACTIONS(3449),
    [anon_sym_from] = ACTIONS(3447),
    [anon_sym_into] = ACTIONS(3447),
    [anon_sym_join] = ACTIONS(3447),
    [anon_sym_on] = ACTIONS(3447),
    [anon_sym_equals] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_orderby] = ACTIONS(3447),
    [anon_sym_ascending] = ACTIONS(3447),
    [anon_sym_descending] = ACTIONS(3447),
    [anon_sym_group] = ACTIONS(3447),
    [anon_sym_by] = ACTIONS(3447),
    [anon_sym_select] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_stackalloc] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym___makeref] = ACTIONS(3447),
    [anon_sym___reftype] = ACTIONS(3447),
    [anon_sym___refvalue] = ACTIONS(3447),
    [sym_null_literal] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [sym_integer_literal] = ACTIONS(3447),
    [sym_real_literal] = ACTIONS(3449),
    [sym_verbatim_string_literal] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token3] = ACTIONS(3449),
    [aux_sym_preproc_else_token1] = ACTIONS(3449),
    [aux_sym_preproc_elif_token1] = ACTIONS(3449),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3449),
    [sym_interpolation_verbatim_start] = ACTIONS(3449),
    [sym_interpolation_raw_start] = ACTIONS(3449),
    [sym_raw_string_start] = ACTIONS(3449),
  },
  [2319] = {
    [sym_preproc_region] = STATE(2319),
    [sym_preproc_endregion] = STATE(2319),
    [sym_preproc_line] = STATE(2319),
    [sym_preproc_pragma] = STATE(2319),
    [sym_preproc_nullable] = STATE(2319),
    [sym_preproc_error] = STATE(2319),
    [sym_preproc_define] = STATE(2319),
    [sym_preproc_undef] = STATE(2319),
    [sym__identifier_token] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym_alias] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_global] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_unsafe] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_ref] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_delegate] = ACTIONS(3451),
    [anon_sym_record] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_file] = ACTIONS(3451),
    [anon_sym_fixed] = ACTIONS(3451),
    [anon_sym_internal] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_partial] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_required] = ACTIONS(3451),
    [anon_sym_sealed] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_where] = ACTIONS(3451),
    [anon_sym_notnull] = ACTIONS(3451),
    [anon_sym_unmanaged] = ACTIONS(3451),
    [anon_sym_checked] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_true] = ACTIONS(3451),
    [anon_sym_false] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3453),
    [anon_sym_this] = ACTIONS(3451),
    [anon_sym_scoped] = ACTIONS(3451),
    [anon_sym_base] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [sym_predefined_type] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_unchecked] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_lock] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_when] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_foreach] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_DOT_DOT] = ACTIONS(3453),
    [anon_sym_from] = ACTIONS(3451),
    [anon_sym_into] = ACTIONS(3451),
    [anon_sym_join] = ACTIONS(3451),
    [anon_sym_on] = ACTIONS(3451),
    [anon_sym_equals] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_orderby] = ACTIONS(3451),
    [anon_sym_ascending] = ACTIONS(3451),
    [anon_sym_descending] = ACTIONS(3451),
    [anon_sym_group] = ACTIONS(3451),
    [anon_sym_by] = ACTIONS(3451),
    [anon_sym_select] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_stackalloc] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym___makeref] = ACTIONS(3451),
    [anon_sym___reftype] = ACTIONS(3451),
    [anon_sym___refvalue] = ACTIONS(3451),
    [sym_null_literal] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [sym_integer_literal] = ACTIONS(3451),
    [sym_real_literal] = ACTIONS(3453),
    [sym_verbatim_string_literal] = ACTIONS(3453),
    [aux_sym_preproc_if_token1] = ACTIONS(3453),
    [aux_sym_preproc_if_token3] = ACTIONS(3453),
    [aux_sym_preproc_else_token1] = ACTIONS(3453),
    [aux_sym_preproc_elif_token1] = ACTIONS(3453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3453),
    [sym_interpolation_verbatim_start] = ACTIONS(3453),
    [sym_interpolation_raw_start] = ACTIONS(3453),
    [sym_raw_string_start] = ACTIONS(3453),
  },
  [2320] = {
    [sym_preproc_region] = STATE(2320),
    [sym_preproc_endregion] = STATE(2320),
    [sym_preproc_line] = STATE(2320),
    [sym_preproc_pragma] = STATE(2320),
    [sym_preproc_nullable] = STATE(2320),
    [sym_preproc_error] = STATE(2320),
    [sym_preproc_define] = STATE(2320),
    [sym_preproc_undef] = STATE(2320),
    [sym__identifier_token] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym_alias] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_global] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_unsafe] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_ref] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_delegate] = ACTIONS(3455),
    [anon_sym_record] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_file] = ACTIONS(3455),
    [anon_sym_fixed] = ACTIONS(3455),
    [anon_sym_internal] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_partial] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_required] = ACTIONS(3455),
    [anon_sym_sealed] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_where] = ACTIONS(3455),
    [anon_sym_notnull] = ACTIONS(3455),
    [anon_sym_unmanaged] = ACTIONS(3455),
    [anon_sym_checked] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_true] = ACTIONS(3455),
    [anon_sym_false] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_this] = ACTIONS(3455),
    [anon_sym_scoped] = ACTIONS(3455),
    [anon_sym_base] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [sym_predefined_type] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_unchecked] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_lock] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_when] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_foreach] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_DOT_DOT] = ACTIONS(3457),
    [anon_sym_from] = ACTIONS(3455),
    [anon_sym_into] = ACTIONS(3455),
    [anon_sym_join] = ACTIONS(3455),
    [anon_sym_on] = ACTIONS(3455),
    [anon_sym_equals] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_orderby] = ACTIONS(3455),
    [anon_sym_ascending] = ACTIONS(3455),
    [anon_sym_descending] = ACTIONS(3455),
    [anon_sym_group] = ACTIONS(3455),
    [anon_sym_by] = ACTIONS(3455),
    [anon_sym_select] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_stackalloc] = ACTIONS(3455),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym___makeref] = ACTIONS(3455),
    [anon_sym___reftype] = ACTIONS(3455),
    [anon_sym___refvalue] = ACTIONS(3455),
    [sym_null_literal] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [sym_integer_literal] = ACTIONS(3455),
    [sym_real_literal] = ACTIONS(3457),
    [sym_verbatim_string_literal] = ACTIONS(3457),
    [aux_sym_preproc_if_token1] = ACTIONS(3457),
    [aux_sym_preproc_if_token3] = ACTIONS(3457),
    [aux_sym_preproc_else_token1] = ACTIONS(3457),
    [aux_sym_preproc_elif_token1] = ACTIONS(3457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3457),
    [sym_interpolation_verbatim_start] = ACTIONS(3457),
    [sym_interpolation_raw_start] = ACTIONS(3457),
    [sym_raw_string_start] = ACTIONS(3457),
  },
  [2321] = {
    [sym_preproc_region] = STATE(2321),
    [sym_preproc_endregion] = STATE(2321),
    [sym_preproc_line] = STATE(2321),
    [sym_preproc_pragma] = STATE(2321),
    [sym_preproc_nullable] = STATE(2321),
    [sym_preproc_error] = STATE(2321),
    [sym_preproc_define] = STATE(2321),
    [sym_preproc_undef] = STATE(2321),
    [sym__identifier_token] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym_alias] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_unsafe] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3461),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3459),
    [anon_sym_record] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3459),
    [anon_sym_fixed] = ACTIONS(3459),
    [anon_sym_internal] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_partial] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_required] = ACTIONS(3459),
    [anon_sym_sealed] = ACTIONS(3459),
    [anon_sym_virtual] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3459),
    [anon_sym_unmanaged] = ACTIONS(3459),
    [anon_sym_checked] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_true] = ACTIONS(3459),
    [anon_sym_false] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_this] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3459),
    [anon_sym_base] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [sym_predefined_type] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_unchecked] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_lock] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_foreach] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_ascending] = ACTIONS(3459),
    [anon_sym_descending] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [anon_sym_stackalloc] = ACTIONS(3459),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym___makeref] = ACTIONS(3459),
    [anon_sym___reftype] = ACTIONS(3459),
    [anon_sym___refvalue] = ACTIONS(3459),
    [sym_null_literal] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [sym_integer_literal] = ACTIONS(3459),
    [sym_real_literal] = ACTIONS(3461),
    [sym_verbatim_string_literal] = ACTIONS(3461),
    [aux_sym_preproc_if_token1] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3461),
    [aux_sym_preproc_else_token1] = ACTIONS(3461),
    [aux_sym_preproc_elif_token1] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3461),
    [sym_interpolation_verbatim_start] = ACTIONS(3461),
    [sym_interpolation_raw_start] = ACTIONS(3461),
    [sym_raw_string_start] = ACTIONS(3461),
  },
  [2322] = {
    [sym_preproc_region] = STATE(2322),
    [sym_preproc_endregion] = STATE(2322),
    [sym_preproc_line] = STATE(2322),
    [sym_preproc_pragma] = STATE(2322),
    [sym_preproc_nullable] = STATE(2322),
    [sym_preproc_error] = STATE(2322),
    [sym_preproc_define] = STATE(2322),
    [sym_preproc_undef] = STATE(2322),
    [sym__identifier_token] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym_alias] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym_global] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_unsafe] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3465),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_ref] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_delegate] = ACTIONS(3463),
    [anon_sym_record] = ACTIONS(3463),
    [anon_sym_abstract] = ACTIONS(3463),
    [anon_sym_async] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_file] = ACTIONS(3463),
    [anon_sym_fixed] = ACTIONS(3463),
    [anon_sym_internal] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_override] = ACTIONS(3463),
    [anon_sym_partial] = ACTIONS(3463),
    [anon_sym_private] = ACTIONS(3463),
    [anon_sym_protected] = ACTIONS(3463),
    [anon_sym_public] = ACTIONS(3463),
    [anon_sym_readonly] = ACTIONS(3463),
    [anon_sym_required] = ACTIONS(3463),
    [anon_sym_sealed] = ACTIONS(3463),
    [anon_sym_virtual] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_where] = ACTIONS(3463),
    [anon_sym_notnull] = ACTIONS(3463),
    [anon_sym_unmanaged] = ACTIONS(3463),
    [anon_sym_checked] = ACTIONS(3463),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_true] = ACTIONS(3463),
    [anon_sym_false] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_CARET] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3465),
    [anon_sym_this] = ACTIONS(3463),
    [anon_sym_scoped] = ACTIONS(3463),
    [anon_sym_base] = ACTIONS(3463),
    [anon_sym_var] = ACTIONS(3463),
    [sym_predefined_type] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_unchecked] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_lock] = ACTIONS(3463),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_when] = ACTIONS(3463),
    [anon_sym_await] = ACTIONS(3463),
    [anon_sym_foreach] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_DOT_DOT] = ACTIONS(3465),
    [anon_sym_from] = ACTIONS(3463),
    [anon_sym_into] = ACTIONS(3463),
    [anon_sym_join] = ACTIONS(3463),
    [anon_sym_on] = ACTIONS(3463),
    [anon_sym_equals] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_orderby] = ACTIONS(3463),
    [anon_sym_ascending] = ACTIONS(3463),
    [anon_sym_descending] = ACTIONS(3463),
    [anon_sym_group] = ACTIONS(3463),
    [anon_sym_by] = ACTIONS(3463),
    [anon_sym_select] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [anon_sym_stackalloc] = ACTIONS(3463),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym_typeof] = ACTIONS(3463),
    [anon_sym___makeref] = ACTIONS(3463),
    [anon_sym___reftype] = ACTIONS(3463),
    [anon_sym___refvalue] = ACTIONS(3463),
    [sym_null_literal] = ACTIONS(3463),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [sym_integer_literal] = ACTIONS(3463),
    [sym_real_literal] = ACTIONS(3465),
    [sym_verbatim_string_literal] = ACTIONS(3465),
    [aux_sym_preproc_if_token1] = ACTIONS(3465),
    [aux_sym_preproc_if_token3] = ACTIONS(3465),
    [aux_sym_preproc_else_token1] = ACTIONS(3465),
    [aux_sym_preproc_elif_token1] = ACTIONS(3465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3465),
    [sym_interpolation_verbatim_start] = ACTIONS(3465),
    [sym_interpolation_raw_start] = ACTIONS(3465),
    [sym_raw_string_start] = ACTIONS(3465),
  },
  [2323] = {
    [sym_preproc_region] = STATE(2323),
    [sym_preproc_endregion] = STATE(2323),
    [sym_preproc_line] = STATE(2323),
    [sym_preproc_pragma] = STATE(2323),
    [sym_preproc_nullable] = STATE(2323),
    [sym_preproc_error] = STATE(2323),
    [sym_preproc_define] = STATE(2323),
    [sym_preproc_undef] = STATE(2323),
    [sym__identifier_token] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym_alias] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym_global] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_unsafe] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3469),
    [anon_sym_LPAREN] = ACTIONS(3469),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_ref] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_delegate] = ACTIONS(3467),
    [anon_sym_record] = ACTIONS(3467),
    [anon_sym_abstract] = ACTIONS(3467),
    [anon_sym_async] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_file] = ACTIONS(3467),
    [anon_sym_fixed] = ACTIONS(3467),
    [anon_sym_internal] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_override] = ACTIONS(3467),
    [anon_sym_partial] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_readonly] = ACTIONS(3467),
    [anon_sym_required] = ACTIONS(3467),
    [anon_sym_sealed] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_where] = ACTIONS(3467),
    [anon_sym_notnull] = ACTIONS(3467),
    [anon_sym_unmanaged] = ACTIONS(3467),
    [anon_sym_checked] = ACTIONS(3467),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_true] = ACTIONS(3467),
    [anon_sym_false] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_CARET] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_this] = ACTIONS(3467),
    [anon_sym_scoped] = ACTIONS(3467),
    [anon_sym_base] = ACTIONS(3467),
    [anon_sym_var] = ACTIONS(3467),
    [sym_predefined_type] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_unchecked] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_lock] = ACTIONS(3467),
    [anon_sym_yield] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_when] = ACTIONS(3467),
    [anon_sym_await] = ACTIONS(3467),
    [anon_sym_foreach] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_DOT_DOT] = ACTIONS(3469),
    [anon_sym_from] = ACTIONS(3467),
    [anon_sym_into] = ACTIONS(3467),
    [anon_sym_join] = ACTIONS(3467),
    [anon_sym_on] = ACTIONS(3467),
    [anon_sym_equals] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_orderby] = ACTIONS(3467),
    [anon_sym_ascending] = ACTIONS(3467),
    [anon_sym_descending] = ACTIONS(3467),
    [anon_sym_group] = ACTIONS(3467),
    [anon_sym_by] = ACTIONS(3467),
    [anon_sym_select] = ACTIONS(3467),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [anon_sym_stackalloc] = ACTIONS(3467),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym_typeof] = ACTIONS(3467),
    [anon_sym___makeref] = ACTIONS(3467),
    [anon_sym___reftype] = ACTIONS(3467),
    [anon_sym___refvalue] = ACTIONS(3467),
    [sym_null_literal] = ACTIONS(3467),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [sym_integer_literal] = ACTIONS(3467),
    [sym_real_literal] = ACTIONS(3469),
    [sym_verbatim_string_literal] = ACTIONS(3469),
    [aux_sym_preproc_if_token1] = ACTIONS(3469),
    [aux_sym_preproc_if_token3] = ACTIONS(3469),
    [aux_sym_preproc_else_token1] = ACTIONS(3469),
    [aux_sym_preproc_elif_token1] = ACTIONS(3469),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3469),
    [sym_interpolation_verbatim_start] = ACTIONS(3469),
    [sym_interpolation_raw_start] = ACTIONS(3469),
    [sym_raw_string_start] = ACTIONS(3469),
  },
  [2324] = {
    [sym_preproc_region] = STATE(2324),
    [sym_preproc_endregion] = STATE(2324),
    [sym_preproc_line] = STATE(2324),
    [sym_preproc_pragma] = STATE(2324),
    [sym_preproc_nullable] = STATE(2324),
    [sym_preproc_error] = STATE(2324),
    [sym_preproc_define] = STATE(2324),
    [sym_preproc_undef] = STATE(2324),
    [sym__identifier_token] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym_alias] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym_global] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_unsafe] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3473),
    [anon_sym_LPAREN] = ACTIONS(3473),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_ref] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_delegate] = ACTIONS(3471),
    [anon_sym_record] = ACTIONS(3471),
    [anon_sym_abstract] = ACTIONS(3471),
    [anon_sym_async] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_file] = ACTIONS(3471),
    [anon_sym_fixed] = ACTIONS(3471),
    [anon_sym_internal] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_override] = ACTIONS(3471),
    [anon_sym_partial] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_readonly] = ACTIONS(3471),
    [anon_sym_required] = ACTIONS(3471),
    [anon_sym_sealed] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_where] = ACTIONS(3471),
    [anon_sym_notnull] = ACTIONS(3471),
    [anon_sym_unmanaged] = ACTIONS(3471),
    [anon_sym_checked] = ACTIONS(3471),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_true] = ACTIONS(3471),
    [anon_sym_false] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_CARET] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_this] = ACTIONS(3471),
    [anon_sym_scoped] = ACTIONS(3471),
    [anon_sym_base] = ACTIONS(3471),
    [anon_sym_var] = ACTIONS(3471),
    [sym_predefined_type] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_unchecked] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_lock] = ACTIONS(3471),
    [anon_sym_yield] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_when] = ACTIONS(3471),
    [anon_sym_await] = ACTIONS(3471),
    [anon_sym_foreach] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_DOT_DOT] = ACTIONS(3473),
    [anon_sym_from] = ACTIONS(3471),
    [anon_sym_into] = ACTIONS(3471),
    [anon_sym_join] = ACTIONS(3471),
    [anon_sym_on] = ACTIONS(3471),
    [anon_sym_equals] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_orderby] = ACTIONS(3471),
    [anon_sym_ascending] = ACTIONS(3471),
    [anon_sym_descending] = ACTIONS(3471),
    [anon_sym_group] = ACTIONS(3471),
    [anon_sym_by] = ACTIONS(3471),
    [anon_sym_select] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [anon_sym_stackalloc] = ACTIONS(3471),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym_typeof] = ACTIONS(3471),
    [anon_sym___makeref] = ACTIONS(3471),
    [anon_sym___reftype] = ACTIONS(3471),
    [anon_sym___refvalue] = ACTIONS(3471),
    [sym_null_literal] = ACTIONS(3471),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [sym_integer_literal] = ACTIONS(3471),
    [sym_real_literal] = ACTIONS(3473),
    [sym_verbatim_string_literal] = ACTIONS(3473),
    [aux_sym_preproc_if_token1] = ACTIONS(3473),
    [aux_sym_preproc_if_token3] = ACTIONS(3473),
    [aux_sym_preproc_else_token1] = ACTIONS(3473),
    [aux_sym_preproc_elif_token1] = ACTIONS(3473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3473),
    [sym_interpolation_verbatim_start] = ACTIONS(3473),
    [sym_interpolation_raw_start] = ACTIONS(3473),
    [sym_raw_string_start] = ACTIONS(3473),
  },
  [2325] = {
    [sym_preproc_region] = STATE(2325),
    [sym_preproc_endregion] = STATE(2325),
    [sym_preproc_line] = STATE(2325),
    [sym_preproc_pragma] = STATE(2325),
    [sym_preproc_nullable] = STATE(2325),
    [sym_preproc_error] = STATE(2325),
    [sym_preproc_define] = STATE(2325),
    [sym_preproc_undef] = STATE(2325),
    [sym__identifier_token] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym_alias] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym_global] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_unsafe] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_ref] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_delegate] = ACTIONS(3475),
    [anon_sym_record] = ACTIONS(3475),
    [anon_sym_abstract] = ACTIONS(3475),
    [anon_sym_async] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_file] = ACTIONS(3475),
    [anon_sym_fixed] = ACTIONS(3475),
    [anon_sym_internal] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_override] = ACTIONS(3475),
    [anon_sym_partial] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_readonly] = ACTIONS(3475),
    [anon_sym_required] = ACTIONS(3475),
    [anon_sym_sealed] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_where] = ACTIONS(3475),
    [anon_sym_notnull] = ACTIONS(3475),
    [anon_sym_unmanaged] = ACTIONS(3475),
    [anon_sym_checked] = ACTIONS(3475),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_true] = ACTIONS(3475),
    [anon_sym_false] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_CARET] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3477),
    [anon_sym_this] = ACTIONS(3475),
    [anon_sym_scoped] = ACTIONS(3475),
    [anon_sym_base] = ACTIONS(3475),
    [anon_sym_var] = ACTIONS(3475),
    [sym_predefined_type] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_unchecked] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_lock] = ACTIONS(3475),
    [anon_sym_yield] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_when] = ACTIONS(3475),
    [anon_sym_await] = ACTIONS(3475),
    [anon_sym_foreach] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_DOT_DOT] = ACTIONS(3477),
    [anon_sym_from] = ACTIONS(3475),
    [anon_sym_into] = ACTIONS(3475),
    [anon_sym_join] = ACTIONS(3475),
    [anon_sym_on] = ACTIONS(3475),
    [anon_sym_equals] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_orderby] = ACTIONS(3475),
    [anon_sym_ascending] = ACTIONS(3475),
    [anon_sym_descending] = ACTIONS(3475),
    [anon_sym_group] = ACTIONS(3475),
    [anon_sym_by] = ACTIONS(3475),
    [anon_sym_select] = ACTIONS(3475),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [anon_sym_stackalloc] = ACTIONS(3475),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym_typeof] = ACTIONS(3475),
    [anon_sym___makeref] = ACTIONS(3475),
    [anon_sym___reftype] = ACTIONS(3475),
    [anon_sym___refvalue] = ACTIONS(3475),
    [sym_null_literal] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_integer_literal] = ACTIONS(3475),
    [sym_real_literal] = ACTIONS(3477),
    [sym_verbatim_string_literal] = ACTIONS(3477),
    [aux_sym_preproc_if_token1] = ACTIONS(3477),
    [aux_sym_preproc_if_token3] = ACTIONS(3477),
    [aux_sym_preproc_else_token1] = ACTIONS(3477),
    [aux_sym_preproc_elif_token1] = ACTIONS(3477),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3477),
    [sym_interpolation_verbatim_start] = ACTIONS(3477),
    [sym_interpolation_raw_start] = ACTIONS(3477),
    [sym_raw_string_start] = ACTIONS(3477),
  },
  [2326] = {
    [sym_preproc_region] = STATE(2326),
    [sym_preproc_endregion] = STATE(2326),
    [sym_preproc_line] = STATE(2326),
    [sym_preproc_pragma] = STATE(2326),
    [sym_preproc_nullable] = STATE(2326),
    [sym_preproc_error] = STATE(2326),
    [sym_preproc_define] = STATE(2326),
    [sym_preproc_undef] = STATE(2326),
    [sym__identifier_token] = ACTIONS(3479),
    [anon_sym_extern] = ACTIONS(3479),
    [anon_sym_alias] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(3481),
    [anon_sym_global] = ACTIONS(3479),
    [anon_sym_using] = ACTIONS(3479),
    [anon_sym_unsafe] = ACTIONS(3479),
    [anon_sym_static] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(3481),
    [anon_sym_LPAREN] = ACTIONS(3481),
    [anon_sym_return] = ACTIONS(3479),
    [anon_sym_namespace] = ACTIONS(3479),
    [anon_sym_class] = ACTIONS(3479),
    [anon_sym_ref] = ACTIONS(3479),
    [anon_sym_struct] = ACTIONS(3479),
    [anon_sym_enum] = ACTIONS(3479),
    [anon_sym_LBRACE] = ACTIONS(3481),
    [anon_sym_interface] = ACTIONS(3479),
    [anon_sym_delegate] = ACTIONS(3479),
    [anon_sym_record] = ACTIONS(3479),
    [anon_sym_abstract] = ACTIONS(3479),
    [anon_sym_async] = ACTIONS(3479),
    [anon_sym_const] = ACTIONS(3479),
    [anon_sym_file] = ACTIONS(3479),
    [anon_sym_fixed] = ACTIONS(3479),
    [anon_sym_internal] = ACTIONS(3479),
    [anon_sym_new] = ACTIONS(3479),
    [anon_sym_override] = ACTIONS(3479),
    [anon_sym_partial] = ACTIONS(3479),
    [anon_sym_private] = ACTIONS(3479),
    [anon_sym_protected] = ACTIONS(3479),
    [anon_sym_public] = ACTIONS(3479),
    [anon_sym_readonly] = ACTIONS(3479),
    [anon_sym_required] = ACTIONS(3479),
    [anon_sym_sealed] = ACTIONS(3479),
    [anon_sym_virtual] = ACTIONS(3479),
    [anon_sym_volatile] = ACTIONS(3479),
    [anon_sym_where] = ACTIONS(3479),
    [anon_sym_notnull] = ACTIONS(3479),
    [anon_sym_unmanaged] = ACTIONS(3479),
    [anon_sym_checked] = ACTIONS(3479),
    [anon_sym_BANG] = ACTIONS(3481),
    [anon_sym_TILDE] = ACTIONS(3481),
    [anon_sym_PLUS_PLUS] = ACTIONS(3481),
    [anon_sym_DASH_DASH] = ACTIONS(3481),
    [anon_sym_true] = ACTIONS(3479),
    [anon_sym_false] = ACTIONS(3479),
    [anon_sym_PLUS] = ACTIONS(3479),
    [anon_sym_DASH] = ACTIONS(3479),
    [anon_sym_STAR] = ACTIONS(3481),
    [anon_sym_CARET] = ACTIONS(3481),
    [anon_sym_AMP] = ACTIONS(3481),
    [anon_sym_this] = ACTIONS(3479),
    [anon_sym_scoped] = ACTIONS(3479),
    [anon_sym_base] = ACTIONS(3479),
    [anon_sym_var] = ACTIONS(3479),
    [sym_predefined_type] = ACTIONS(3479),
    [anon_sym_break] = ACTIONS(3479),
    [anon_sym_unchecked] = ACTIONS(3479),
    [anon_sym_continue] = ACTIONS(3479),
    [anon_sym_do] = ACTIONS(3479),
    [anon_sym_while] = ACTIONS(3479),
    [anon_sym_for] = ACTIONS(3479),
    [anon_sym_lock] = ACTIONS(3479),
    [anon_sym_yield] = ACTIONS(3479),
    [anon_sym_switch] = ACTIONS(3479),
    [anon_sym_default] = ACTIONS(3479),
    [anon_sym_throw] = ACTIONS(3479),
    [anon_sym_try] = ACTIONS(3479),
    [anon_sym_when] = ACTIONS(3479),
    [anon_sym_await] = ACTIONS(3479),
    [anon_sym_foreach] = ACTIONS(3479),
    [anon_sym_goto] = ACTIONS(3479),
    [anon_sym_if] = ACTIONS(3479),
    [anon_sym_DOT_DOT] = ACTIONS(3481),
    [anon_sym_from] = ACTIONS(3479),
    [anon_sym_into] = ACTIONS(3479),
    [anon_sym_join] = ACTIONS(3479),
    [anon_sym_on] = ACTIONS(3479),
    [anon_sym_equals] = ACTIONS(3479),
    [anon_sym_let] = ACTIONS(3479),
    [anon_sym_orderby] = ACTIONS(3479),
    [anon_sym_ascending] = ACTIONS(3479),
    [anon_sym_descending] = ACTIONS(3479),
    [anon_sym_group] = ACTIONS(3479),
    [anon_sym_by] = ACTIONS(3479),
    [anon_sym_select] = ACTIONS(3479),
    [anon_sym_DQUOTE] = ACTIONS(3481),
    [anon_sym_stackalloc] = ACTIONS(3479),
    [anon_sym_sizeof] = ACTIONS(3479),
    [anon_sym_typeof] = ACTIONS(3479),
    [anon_sym___makeref] = ACTIONS(3479),
    [anon_sym___reftype] = ACTIONS(3479),
    [anon_sym___refvalue] = ACTIONS(3479),
    [sym_null_literal] = ACTIONS(3479),
    [anon_sym_SQUOTE] = ACTIONS(3481),
    [sym_integer_literal] = ACTIONS(3479),
    [sym_real_literal] = ACTIONS(3481),
    [sym_verbatim_string_literal] = ACTIONS(3481),
    [aux_sym_preproc_if_token1] = ACTIONS(3481),
    [aux_sym_preproc_if_token3] = ACTIONS(3481),
    [aux_sym_preproc_else_token1] = ACTIONS(3481),
    [aux_sym_preproc_elif_token1] = ACTIONS(3481),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3481),
    [sym_interpolation_verbatim_start] = ACTIONS(3481),
    [sym_interpolation_raw_start] = ACTIONS(3481),
    [sym_raw_string_start] = ACTIONS(3481),
  },
  [2327] = {
    [sym_preproc_region] = STATE(2327),
    [sym_preproc_endregion] = STATE(2327),
    [sym_preproc_line] = STATE(2327),
    [sym_preproc_pragma] = STATE(2327),
    [sym_preproc_nullable] = STATE(2327),
    [sym_preproc_error] = STATE(2327),
    [sym_preproc_define] = STATE(2327),
    [sym_preproc_undef] = STATE(2327),
    [sym__identifier_token] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym_alias] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym_global] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_unsafe] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_ref] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_interface] = ACTIONS(3483),
    [anon_sym_delegate] = ACTIONS(3483),
    [anon_sym_record] = ACTIONS(3483),
    [anon_sym_abstract] = ACTIONS(3483),
    [anon_sym_async] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_file] = ACTIONS(3483),
    [anon_sym_fixed] = ACTIONS(3483),
    [anon_sym_internal] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_override] = ACTIONS(3483),
    [anon_sym_partial] = ACTIONS(3483),
    [anon_sym_private] = ACTIONS(3483),
    [anon_sym_protected] = ACTIONS(3483),
    [anon_sym_public] = ACTIONS(3483),
    [anon_sym_readonly] = ACTIONS(3483),
    [anon_sym_required] = ACTIONS(3483),
    [anon_sym_sealed] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_where] = ACTIONS(3483),
    [anon_sym_notnull] = ACTIONS(3483),
    [anon_sym_unmanaged] = ACTIONS(3483),
    [anon_sym_checked] = ACTIONS(3483),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_true] = ACTIONS(3483),
    [anon_sym_false] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_CARET] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3485),
    [anon_sym_this] = ACTIONS(3483),
    [anon_sym_scoped] = ACTIONS(3483),
    [anon_sym_base] = ACTIONS(3483),
    [anon_sym_var] = ACTIONS(3483),
    [sym_predefined_type] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_unchecked] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_lock] = ACTIONS(3483),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_when] = ACTIONS(3483),
    [anon_sym_await] = ACTIONS(3483),
    [anon_sym_foreach] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_from] = ACTIONS(3483),
    [anon_sym_into] = ACTIONS(3483),
    [anon_sym_join] = ACTIONS(3483),
    [anon_sym_on] = ACTIONS(3483),
    [anon_sym_equals] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_orderby] = ACTIONS(3483),
    [anon_sym_ascending] = ACTIONS(3483),
    [anon_sym_descending] = ACTIONS(3483),
    [anon_sym_group] = ACTIONS(3483),
    [anon_sym_by] = ACTIONS(3483),
    [anon_sym_select] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [anon_sym_stackalloc] = ACTIONS(3483),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3483),
    [anon_sym___makeref] = ACTIONS(3483),
    [anon_sym___reftype] = ACTIONS(3483),
    [anon_sym___refvalue] = ACTIONS(3483),
    [sym_null_literal] = ACTIONS(3483),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [sym_integer_literal] = ACTIONS(3483),
    [sym_real_literal] = ACTIONS(3485),
    [sym_verbatim_string_literal] = ACTIONS(3485),
    [aux_sym_preproc_if_token1] = ACTIONS(3485),
    [aux_sym_preproc_if_token3] = ACTIONS(3485),
    [aux_sym_preproc_else_token1] = ACTIONS(3485),
    [aux_sym_preproc_elif_token1] = ACTIONS(3485),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3485),
    [sym_interpolation_verbatim_start] = ACTIONS(3485),
    [sym_interpolation_raw_start] = ACTIONS(3485),
    [sym_raw_string_start] = ACTIONS(3485),
  },
  [2328] = {
    [sym_preproc_region] = STATE(2328),
    [sym_preproc_endregion] = STATE(2328),
    [sym_preproc_line] = STATE(2328),
    [sym_preproc_pragma] = STATE(2328),
    [sym_preproc_nullable] = STATE(2328),
    [sym_preproc_error] = STATE(2328),
    [sym_preproc_define] = STATE(2328),
    [sym_preproc_undef] = STATE(2328),
    [sym__identifier_token] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym_alias] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym_global] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_unsafe] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LPAREN] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_ref] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_delegate] = ACTIONS(3487),
    [anon_sym_record] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_async] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_file] = ACTIONS(3487),
    [anon_sym_fixed] = ACTIONS(3487),
    [anon_sym_internal] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_partial] = ACTIONS(3487),
    [anon_sym_private] = ACTIONS(3487),
    [anon_sym_protected] = ACTIONS(3487),
    [anon_sym_public] = ACTIONS(3487),
    [anon_sym_readonly] = ACTIONS(3487),
    [anon_sym_required] = ACTIONS(3487),
    [anon_sym_sealed] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_where] = ACTIONS(3487),
    [anon_sym_notnull] = ACTIONS(3487),
    [anon_sym_unmanaged] = ACTIONS(3487),
    [anon_sym_checked] = ACTIONS(3487),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_true] = ACTIONS(3487),
    [anon_sym_false] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_CARET] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_this] = ACTIONS(3487),
    [anon_sym_scoped] = ACTIONS(3487),
    [anon_sym_base] = ACTIONS(3487),
    [anon_sym_var] = ACTIONS(3487),
    [sym_predefined_type] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_unchecked] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_lock] = ACTIONS(3487),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_when] = ACTIONS(3487),
    [anon_sym_await] = ACTIONS(3487),
    [anon_sym_foreach] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_DOT_DOT] = ACTIONS(3489),
    [anon_sym_from] = ACTIONS(3487),
    [anon_sym_into] = ACTIONS(3487),
    [anon_sym_join] = ACTIONS(3487),
    [anon_sym_on] = ACTIONS(3487),
    [anon_sym_equals] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_orderby] = ACTIONS(3487),
    [anon_sym_ascending] = ACTIONS(3487),
    [anon_sym_descending] = ACTIONS(3487),
    [anon_sym_group] = ACTIONS(3487),
    [anon_sym_by] = ACTIONS(3487),
    [anon_sym_select] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [anon_sym_stackalloc] = ACTIONS(3487),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym_typeof] = ACTIONS(3487),
    [anon_sym___makeref] = ACTIONS(3487),
    [anon_sym___reftype] = ACTIONS(3487),
    [anon_sym___refvalue] = ACTIONS(3487),
    [sym_null_literal] = ACTIONS(3487),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [sym_integer_literal] = ACTIONS(3487),
    [sym_real_literal] = ACTIONS(3489),
    [sym_verbatim_string_literal] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token3] = ACTIONS(3489),
    [aux_sym_preproc_else_token1] = ACTIONS(3489),
    [aux_sym_preproc_elif_token1] = ACTIONS(3489),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3489),
    [sym_interpolation_verbatim_start] = ACTIONS(3489),
    [sym_interpolation_raw_start] = ACTIONS(3489),
    [sym_raw_string_start] = ACTIONS(3489),
  },
  [2329] = {
    [sym_preproc_region] = STATE(2329),
    [sym_preproc_endregion] = STATE(2329),
    [sym_preproc_line] = STATE(2329),
    [sym_preproc_pragma] = STATE(2329),
    [sym_preproc_nullable] = STATE(2329),
    [sym_preproc_error] = STATE(2329),
    [sym_preproc_define] = STATE(2329),
    [sym_preproc_undef] = STATE(2329),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_ref] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3491),
    [anon_sym_delegate] = ACTIONS(3491),
    [anon_sym_record] = ACTIONS(3491),
    [anon_sym_abstract] = ACTIONS(3491),
    [anon_sym_async] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3491),
    [anon_sym_internal] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_override] = ACTIONS(3491),
    [anon_sym_partial] = ACTIONS(3491),
    [anon_sym_private] = ACTIONS(3491),
    [anon_sym_protected] = ACTIONS(3491),
    [anon_sym_public] = ACTIONS(3491),
    [anon_sym_readonly] = ACTIONS(3491),
    [anon_sym_required] = ACTIONS(3491),
    [anon_sym_sealed] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_checked] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_true] = ACTIONS(3491),
    [anon_sym_false] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_CARET] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_this] = ACTIONS(3491),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_base] = ACTIONS(3491),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_unchecked] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_lock] = ACTIONS(3491),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_await] = ACTIONS(3491),
    [anon_sym_foreach] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_stackalloc] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym_typeof] = ACTIONS(3491),
    [anon_sym___makeref] = ACTIONS(3491),
    [anon_sym___reftype] = ACTIONS(3491),
    [anon_sym___refvalue] = ACTIONS(3491),
    [sym_null_literal] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [sym_integer_literal] = ACTIONS(3491),
    [sym_real_literal] = ACTIONS(3493),
    [sym_verbatim_string_literal] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_if_token3] = ACTIONS(3493),
    [aux_sym_preproc_else_token1] = ACTIONS(3493),
    [aux_sym_preproc_elif_token1] = ACTIONS(3493),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3493),
    [sym_interpolation_verbatim_start] = ACTIONS(3493),
    [sym_interpolation_raw_start] = ACTIONS(3493),
    [sym_raw_string_start] = ACTIONS(3493),
  },
  [2330] = {
    [sym_preproc_region] = STATE(2330),
    [sym_preproc_endregion] = STATE(2330),
    [sym_preproc_line] = STATE(2330),
    [sym_preproc_pragma] = STATE(2330),
    [sym_preproc_nullable] = STATE(2330),
    [sym_preproc_error] = STATE(2330),
    [sym_preproc_define] = STATE(2330),
    [sym_preproc_undef] = STATE(2330),
    [sym__identifier_token] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym_alias] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym_global] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_unsafe] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_ref] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3495),
    [anon_sym_delegate] = ACTIONS(3495),
    [anon_sym_record] = ACTIONS(3495),
    [anon_sym_abstract] = ACTIONS(3495),
    [anon_sym_async] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_file] = ACTIONS(3495),
    [anon_sym_fixed] = ACTIONS(3495),
    [anon_sym_internal] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_override] = ACTIONS(3495),
    [anon_sym_partial] = ACTIONS(3495),
    [anon_sym_private] = ACTIONS(3495),
    [anon_sym_protected] = ACTIONS(3495),
    [anon_sym_public] = ACTIONS(3495),
    [anon_sym_readonly] = ACTIONS(3495),
    [anon_sym_required] = ACTIONS(3495),
    [anon_sym_sealed] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_where] = ACTIONS(3495),
    [anon_sym_notnull] = ACTIONS(3495),
    [anon_sym_unmanaged] = ACTIONS(3495),
    [anon_sym_checked] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_true] = ACTIONS(3495),
    [anon_sym_false] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_CARET] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_this] = ACTIONS(3495),
    [anon_sym_scoped] = ACTIONS(3495),
    [anon_sym_base] = ACTIONS(3495),
    [anon_sym_var] = ACTIONS(3495),
    [sym_predefined_type] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_unchecked] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_lock] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_when] = ACTIONS(3495),
    [anon_sym_await] = ACTIONS(3495),
    [anon_sym_foreach] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_from] = ACTIONS(3495),
    [anon_sym_into] = ACTIONS(3495),
    [anon_sym_join] = ACTIONS(3495),
    [anon_sym_on] = ACTIONS(3495),
    [anon_sym_equals] = ACTIONS(3495),
    [anon_sym_let] = ACTIONS(3495),
    [anon_sym_orderby] = ACTIONS(3495),
    [anon_sym_ascending] = ACTIONS(3495),
    [anon_sym_descending] = ACTIONS(3495),
    [anon_sym_group] = ACTIONS(3495),
    [anon_sym_by] = ACTIONS(3495),
    [anon_sym_select] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [anon_sym_stackalloc] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym_typeof] = ACTIONS(3495),
    [anon_sym___makeref] = ACTIONS(3495),
    [anon_sym___reftype] = ACTIONS(3495),
    [anon_sym___refvalue] = ACTIONS(3495),
    [sym_null_literal] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [sym_integer_literal] = ACTIONS(3495),
    [sym_real_literal] = ACTIONS(3497),
    [sym_verbatim_string_literal] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token3] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3497),
    [sym_interpolation_verbatim_start] = ACTIONS(3497),
    [sym_interpolation_raw_start] = ACTIONS(3497),
    [sym_raw_string_start] = ACTIONS(3497),
  },
  [2331] = {
    [sym_preproc_region] = STATE(2331),
    [sym_preproc_endregion] = STATE(2331),
    [sym_preproc_line] = STATE(2331),
    [sym_preproc_pragma] = STATE(2331),
    [sym_preproc_nullable] = STATE(2331),
    [sym_preproc_error] = STATE(2331),
    [sym_preproc_define] = STATE(2331),
    [sym_preproc_undef] = STATE(2331),
    [sym__identifier_token] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym_alias] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym_global] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_unsafe] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_ref] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3499),
    [anon_sym_delegate] = ACTIONS(3499),
    [anon_sym_record] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3499),
    [anon_sym_async] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_file] = ACTIONS(3499),
    [anon_sym_fixed] = ACTIONS(3499),
    [anon_sym_internal] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_override] = ACTIONS(3499),
    [anon_sym_partial] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_readonly] = ACTIONS(3499),
    [anon_sym_required] = ACTIONS(3499),
    [anon_sym_sealed] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_where] = ACTIONS(3499),
    [anon_sym_notnull] = ACTIONS(3499),
    [anon_sym_unmanaged] = ACTIONS(3499),
    [anon_sym_checked] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_true] = ACTIONS(3499),
    [anon_sym_false] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_this] = ACTIONS(3499),
    [anon_sym_scoped] = ACTIONS(3499),
    [anon_sym_base] = ACTIONS(3499),
    [anon_sym_var] = ACTIONS(3499),
    [sym_predefined_type] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_unchecked] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_lock] = ACTIONS(3499),
    [anon_sym_yield] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_when] = ACTIONS(3499),
    [anon_sym_await] = ACTIONS(3499),
    [anon_sym_foreach] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_DOT_DOT] = ACTIONS(3501),
    [anon_sym_from] = ACTIONS(3499),
    [anon_sym_into] = ACTIONS(3499),
    [anon_sym_join] = ACTIONS(3499),
    [anon_sym_on] = ACTIONS(3499),
    [anon_sym_equals] = ACTIONS(3499),
    [anon_sym_let] = ACTIONS(3499),
    [anon_sym_orderby] = ACTIONS(3499),
    [anon_sym_ascending] = ACTIONS(3499),
    [anon_sym_descending] = ACTIONS(3499),
    [anon_sym_group] = ACTIONS(3499),
    [anon_sym_by] = ACTIONS(3499),
    [anon_sym_select] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_stackalloc] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym_typeof] = ACTIONS(3499),
    [anon_sym___makeref] = ACTIONS(3499),
    [anon_sym___reftype] = ACTIONS(3499),
    [anon_sym___refvalue] = ACTIONS(3499),
    [sym_null_literal] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [sym_integer_literal] = ACTIONS(3499),
    [sym_real_literal] = ACTIONS(3501),
    [sym_verbatim_string_literal] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token3] = ACTIONS(3501),
    [aux_sym_preproc_else_token1] = ACTIONS(3501),
    [aux_sym_preproc_elif_token1] = ACTIONS(3501),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3501),
    [sym_interpolation_verbatim_start] = ACTIONS(3501),
    [sym_interpolation_raw_start] = ACTIONS(3501),
    [sym_raw_string_start] = ACTIONS(3501),
  },
  [2332] = {
    [sym_preproc_region] = STATE(2332),
    [sym_preproc_endregion] = STATE(2332),
    [sym_preproc_line] = STATE(2332),
    [sym_preproc_pragma] = STATE(2332),
    [sym_preproc_nullable] = STATE(2332),
    [sym_preproc_error] = STATE(2332),
    [sym_preproc_define] = STATE(2332),
    [sym_preproc_undef] = STATE(2332),
    [sym__identifier_token] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym_alias] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_global] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_unsafe] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_ref] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3503),
    [anon_sym_delegate] = ACTIONS(3503),
    [anon_sym_record] = ACTIONS(3503),
    [anon_sym_abstract] = ACTIONS(3503),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_file] = ACTIONS(3503),
    [anon_sym_fixed] = ACTIONS(3503),
    [anon_sym_internal] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_override] = ACTIONS(3503),
    [anon_sym_partial] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_readonly] = ACTIONS(3503),
    [anon_sym_required] = ACTIONS(3503),
    [anon_sym_sealed] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_where] = ACTIONS(3503),
    [anon_sym_notnull] = ACTIONS(3503),
    [anon_sym_unmanaged] = ACTIONS(3503),
    [anon_sym_checked] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_true] = ACTIONS(3503),
    [anon_sym_false] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_CARET] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_this] = ACTIONS(3503),
    [anon_sym_scoped] = ACTIONS(3503),
    [anon_sym_base] = ACTIONS(3503),
    [anon_sym_var] = ACTIONS(3503),
    [sym_predefined_type] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_unchecked] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_lock] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_when] = ACTIONS(3503),
    [anon_sym_await] = ACTIONS(3503),
    [anon_sym_foreach] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_DOT_DOT] = ACTIONS(3505),
    [anon_sym_from] = ACTIONS(3503),
    [anon_sym_into] = ACTIONS(3503),
    [anon_sym_join] = ACTIONS(3503),
    [anon_sym_on] = ACTIONS(3503),
    [anon_sym_equals] = ACTIONS(3503),
    [anon_sym_let] = ACTIONS(3503),
    [anon_sym_orderby] = ACTIONS(3503),
    [anon_sym_ascending] = ACTIONS(3503),
    [anon_sym_descending] = ACTIONS(3503),
    [anon_sym_group] = ACTIONS(3503),
    [anon_sym_by] = ACTIONS(3503),
    [anon_sym_select] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_stackalloc] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym_typeof] = ACTIONS(3503),
    [anon_sym___makeref] = ACTIONS(3503),
    [anon_sym___reftype] = ACTIONS(3503),
    [anon_sym___refvalue] = ACTIONS(3503),
    [sym_null_literal] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [sym_integer_literal] = ACTIONS(3503),
    [sym_real_literal] = ACTIONS(3505),
    [sym_verbatim_string_literal] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token3] = ACTIONS(3505),
    [aux_sym_preproc_else_token1] = ACTIONS(3505),
    [aux_sym_preproc_elif_token1] = ACTIONS(3505),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3505),
    [sym_interpolation_verbatim_start] = ACTIONS(3505),
    [sym_interpolation_raw_start] = ACTIONS(3505),
    [sym_raw_string_start] = ACTIONS(3505),
  },
  [2333] = {
    [sym_preproc_region] = STATE(2333),
    [sym_preproc_endregion] = STATE(2333),
    [sym_preproc_line] = STATE(2333),
    [sym_preproc_pragma] = STATE(2333),
    [sym_preproc_nullable] = STATE(2333),
    [sym_preproc_error] = STATE(2333),
    [sym_preproc_define] = STATE(2333),
    [sym_preproc_undef] = STATE(2333),
    [sym__identifier_token] = ACTIONS(3507),
    [anon_sym_extern] = ACTIONS(3507),
    [anon_sym_alias] = ACTIONS(3507),
    [anon_sym_SEMI] = ACTIONS(3509),
    [anon_sym_global] = ACTIONS(3507),
    [anon_sym_using] = ACTIONS(3507),
    [anon_sym_unsafe] = ACTIONS(3507),
    [anon_sym_static] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_class] = ACTIONS(3507),
    [anon_sym_ref] = ACTIONS(3507),
    [anon_sym_struct] = ACTIONS(3507),
    [anon_sym_enum] = ACTIONS(3507),
    [anon_sym_LBRACE] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3507),
    [anon_sym_delegate] = ACTIONS(3507),
    [anon_sym_record] = ACTIONS(3507),
    [anon_sym_abstract] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_const] = ACTIONS(3507),
    [anon_sym_file] = ACTIONS(3507),
    [anon_sym_fixed] = ACTIONS(3507),
    [anon_sym_internal] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_override] = ACTIONS(3507),
    [anon_sym_partial] = ACTIONS(3507),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_readonly] = ACTIONS(3507),
    [anon_sym_required] = ACTIONS(3507),
    [anon_sym_sealed] = ACTIONS(3507),
    [anon_sym_virtual] = ACTIONS(3507),
    [anon_sym_volatile] = ACTIONS(3507),
    [anon_sym_where] = ACTIONS(3507),
    [anon_sym_notnull] = ACTIONS(3507),
    [anon_sym_unmanaged] = ACTIONS(3507),
    [anon_sym_checked] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_PLUS_PLUS] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3509),
    [anon_sym_true] = ACTIONS(3507),
    [anon_sym_false] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_CARET] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_this] = ACTIONS(3507),
    [anon_sym_scoped] = ACTIONS(3507),
    [anon_sym_base] = ACTIONS(3507),
    [anon_sym_var] = ACTIONS(3507),
    [sym_predefined_type] = ACTIONS(3507),
    [anon_sym_break] = ACTIONS(3507),
    [anon_sym_unchecked] = ACTIONS(3507),
    [anon_sym_continue] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_lock] = ACTIONS(3507),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_switch] = ACTIONS(3507),
    [anon_sym_default] = ACTIONS(3507),
    [anon_sym_throw] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_when] = ACTIONS(3507),
    [anon_sym_await] = ACTIONS(3507),
    [anon_sym_foreach] = ACTIONS(3507),
    [anon_sym_goto] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_from] = ACTIONS(3507),
    [anon_sym_into] = ACTIONS(3507),
    [anon_sym_join] = ACTIONS(3507),
    [anon_sym_on] = ACTIONS(3507),
    [anon_sym_equals] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_orderby] = ACTIONS(3507),
    [anon_sym_ascending] = ACTIONS(3507),
    [anon_sym_descending] = ACTIONS(3507),
    [anon_sym_group] = ACTIONS(3507),
    [anon_sym_by] = ACTIONS(3507),
    [anon_sym_select] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3509),
    [anon_sym_stackalloc] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3507),
    [anon_sym_typeof] = ACTIONS(3507),
    [anon_sym___makeref] = ACTIONS(3507),
    [anon_sym___reftype] = ACTIONS(3507),
    [anon_sym___refvalue] = ACTIONS(3507),
    [sym_null_literal] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3509),
    [sym_integer_literal] = ACTIONS(3507),
    [sym_real_literal] = ACTIONS(3509),
    [sym_verbatim_string_literal] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token3] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3509),
    [sym_interpolation_verbatim_start] = ACTIONS(3509),
    [sym_interpolation_raw_start] = ACTIONS(3509),
    [sym_raw_string_start] = ACTIONS(3509),
  },
  [2334] = {
    [sym_preproc_region] = STATE(2334),
    [sym_preproc_endregion] = STATE(2334),
    [sym_preproc_line] = STATE(2334),
    [sym_preproc_pragma] = STATE(2334),
    [sym_preproc_nullable] = STATE(2334),
    [sym_preproc_error] = STATE(2334),
    [sym_preproc_define] = STATE(2334),
    [sym_preproc_undef] = STATE(2334),
    [sym__identifier_token] = ACTIONS(3511),
    [anon_sym_extern] = ACTIONS(3511),
    [anon_sym_alias] = ACTIONS(3511),
    [anon_sym_SEMI] = ACTIONS(3513),
    [anon_sym_global] = ACTIONS(3511),
    [anon_sym_using] = ACTIONS(3511),
    [anon_sym_unsafe] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_class] = ACTIONS(3511),
    [anon_sym_ref] = ACTIONS(3511),
    [anon_sym_struct] = ACTIONS(3511),
    [anon_sym_enum] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_delegate] = ACTIONS(3511),
    [anon_sym_record] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_async] = ACTIONS(3511),
    [anon_sym_const] = ACTIONS(3511),
    [anon_sym_file] = ACTIONS(3511),
    [anon_sym_fixed] = ACTIONS(3511),
    [anon_sym_internal] = ACTIONS(3511),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [anon_sym_partial] = ACTIONS(3511),
    [anon_sym_private] = ACTIONS(3511),
    [anon_sym_protected] = ACTIONS(3511),
    [anon_sym_public] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3511),
    [anon_sym_required] = ACTIONS(3511),
    [anon_sym_sealed] = ACTIONS(3511),
    [anon_sym_virtual] = ACTIONS(3511),
    [anon_sym_volatile] = ACTIONS(3511),
    [anon_sym_where] = ACTIONS(3511),
    [anon_sym_notnull] = ACTIONS(3511),
    [anon_sym_unmanaged] = ACTIONS(3511),
    [anon_sym_checked] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_PLUS_PLUS] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3513),
    [anon_sym_true] = ACTIONS(3511),
    [anon_sym_false] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_this] = ACTIONS(3511),
    [anon_sym_scoped] = ACTIONS(3511),
    [anon_sym_base] = ACTIONS(3511),
    [anon_sym_var] = ACTIONS(3511),
    [sym_predefined_type] = ACTIONS(3511),
    [anon_sym_break] = ACTIONS(3511),
    [anon_sym_unchecked] = ACTIONS(3511),
    [anon_sym_continue] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_lock] = ACTIONS(3511),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_switch] = ACTIONS(3511),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_throw] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_when] = ACTIONS(3511),
    [anon_sym_await] = ACTIONS(3511),
    [anon_sym_foreach] = ACTIONS(3511),
    [anon_sym_goto] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_DOT_DOT] = ACTIONS(3513),
    [anon_sym_from] = ACTIONS(3511),
    [anon_sym_into] = ACTIONS(3511),
    [anon_sym_join] = ACTIONS(3511),
    [anon_sym_on] = ACTIONS(3511),
    [anon_sym_equals] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_orderby] = ACTIONS(3511),
    [anon_sym_ascending] = ACTIONS(3511),
    [anon_sym_descending] = ACTIONS(3511),
    [anon_sym_group] = ACTIONS(3511),
    [anon_sym_by] = ACTIONS(3511),
    [anon_sym_select] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3513),
    [anon_sym_stackalloc] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3511),
    [anon_sym_typeof] = ACTIONS(3511),
    [anon_sym___makeref] = ACTIONS(3511),
    [anon_sym___reftype] = ACTIONS(3511),
    [anon_sym___refvalue] = ACTIONS(3511),
    [sym_null_literal] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3513),
    [sym_integer_literal] = ACTIONS(3511),
    [sym_real_literal] = ACTIONS(3513),
    [sym_verbatim_string_literal] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token3] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3513),
    [sym_interpolation_verbatim_start] = ACTIONS(3513),
    [sym_interpolation_raw_start] = ACTIONS(3513),
    [sym_raw_string_start] = ACTIONS(3513),
  },
  [2335] = {
    [sym_preproc_region] = STATE(2335),
    [sym_preproc_endregion] = STATE(2335),
    [sym_preproc_line] = STATE(2335),
    [sym_preproc_pragma] = STATE(2335),
    [sym_preproc_nullable] = STATE(2335),
    [sym_preproc_error] = STATE(2335),
    [sym_preproc_define] = STATE(2335),
    [sym_preproc_undef] = STATE(2335),
    [sym__identifier_token] = ACTIONS(3515),
    [anon_sym_extern] = ACTIONS(3515),
    [anon_sym_alias] = ACTIONS(3515),
    [anon_sym_SEMI] = ACTIONS(3517),
    [anon_sym_global] = ACTIONS(3515),
    [anon_sym_using] = ACTIONS(3515),
    [anon_sym_unsafe] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_class] = ACTIONS(3515),
    [anon_sym_ref] = ACTIONS(3515),
    [anon_sym_struct] = ACTIONS(3515),
    [anon_sym_enum] = ACTIONS(3515),
    [anon_sym_LBRACE] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_delegate] = ACTIONS(3515),
    [anon_sym_record] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_const] = ACTIONS(3515),
    [anon_sym_file] = ACTIONS(3515),
    [anon_sym_fixed] = ACTIONS(3515),
    [anon_sym_internal] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_partial] = ACTIONS(3515),
    [anon_sym_private] = ACTIONS(3515),
    [anon_sym_protected] = ACTIONS(3515),
    [anon_sym_public] = ACTIONS(3515),
    [anon_sym_readonly] = ACTIONS(3515),
    [anon_sym_required] = ACTIONS(3515),
    [anon_sym_sealed] = ACTIONS(3515),
    [anon_sym_virtual] = ACTIONS(3515),
    [anon_sym_volatile] = ACTIONS(3515),
    [anon_sym_where] = ACTIONS(3515),
    [anon_sym_notnull] = ACTIONS(3515),
    [anon_sym_unmanaged] = ACTIONS(3515),
    [anon_sym_checked] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3517),
    [anon_sym_true] = ACTIONS(3515),
    [anon_sym_false] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_this] = ACTIONS(3515),
    [anon_sym_scoped] = ACTIONS(3515),
    [anon_sym_base] = ACTIONS(3515),
    [anon_sym_var] = ACTIONS(3515),
    [sym_predefined_type] = ACTIONS(3515),
    [anon_sym_break] = ACTIONS(3515),
    [anon_sym_unchecked] = ACTIONS(3515),
    [anon_sym_continue] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_lock] = ACTIONS(3515),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_switch] = ACTIONS(3515),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_throw] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_when] = ACTIONS(3515),
    [anon_sym_await] = ACTIONS(3515),
    [anon_sym_foreach] = ACTIONS(3515),
    [anon_sym_goto] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_DOT_DOT] = ACTIONS(3517),
    [anon_sym_from] = ACTIONS(3515),
    [anon_sym_into] = ACTIONS(3515),
    [anon_sym_join] = ACTIONS(3515),
    [anon_sym_on] = ACTIONS(3515),
    [anon_sym_equals] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_orderby] = ACTIONS(3515),
    [anon_sym_ascending] = ACTIONS(3515),
    [anon_sym_descending] = ACTIONS(3515),
    [anon_sym_group] = ACTIONS(3515),
    [anon_sym_by] = ACTIONS(3515),
    [anon_sym_select] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3517),
    [anon_sym_stackalloc] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3515),
    [anon_sym_typeof] = ACTIONS(3515),
    [anon_sym___makeref] = ACTIONS(3515),
    [anon_sym___reftype] = ACTIONS(3515),
    [anon_sym___refvalue] = ACTIONS(3515),
    [sym_null_literal] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3517),
    [sym_integer_literal] = ACTIONS(3515),
    [sym_real_literal] = ACTIONS(3517),
    [sym_verbatim_string_literal] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token3] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3517),
    [sym_interpolation_verbatim_start] = ACTIONS(3517),
    [sym_interpolation_raw_start] = ACTIONS(3517),
    [sym_raw_string_start] = ACTIONS(3517),
  },
  [2336] = {
    [sym_preproc_region] = STATE(2336),
    [sym_preproc_endregion] = STATE(2336),
    [sym_preproc_line] = STATE(2336),
    [sym_preproc_pragma] = STATE(2336),
    [sym_preproc_nullable] = STATE(2336),
    [sym_preproc_error] = STATE(2336),
    [sym_preproc_define] = STATE(2336),
    [sym_preproc_undef] = STATE(2336),
    [sym__identifier_token] = ACTIONS(3519),
    [anon_sym_extern] = ACTIONS(3519),
    [anon_sym_alias] = ACTIONS(3519),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_global] = ACTIONS(3519),
    [anon_sym_using] = ACTIONS(3519),
    [anon_sym_unsafe] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_class] = ACTIONS(3519),
    [anon_sym_ref] = ACTIONS(3519),
    [anon_sym_struct] = ACTIONS(3519),
    [anon_sym_enum] = ACTIONS(3519),
    [anon_sym_LBRACE] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_delegate] = ACTIONS(3519),
    [anon_sym_record] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_async] = ACTIONS(3519),
    [anon_sym_const] = ACTIONS(3519),
    [anon_sym_file] = ACTIONS(3519),
    [anon_sym_fixed] = ACTIONS(3519),
    [anon_sym_internal] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [anon_sym_partial] = ACTIONS(3519),
    [anon_sym_private] = ACTIONS(3519),
    [anon_sym_protected] = ACTIONS(3519),
    [anon_sym_public] = ACTIONS(3519),
    [anon_sym_readonly] = ACTIONS(3519),
    [anon_sym_required] = ACTIONS(3519),
    [anon_sym_sealed] = ACTIONS(3519),
    [anon_sym_virtual] = ACTIONS(3519),
    [anon_sym_volatile] = ACTIONS(3519),
    [anon_sym_where] = ACTIONS(3519),
    [anon_sym_notnull] = ACTIONS(3519),
    [anon_sym_unmanaged] = ACTIONS(3519),
    [anon_sym_checked] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [anon_sym_PLUS_PLUS] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3521),
    [anon_sym_true] = ACTIONS(3519),
    [anon_sym_false] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_this] = ACTIONS(3519),
    [anon_sym_scoped] = ACTIONS(3519),
    [anon_sym_base] = ACTIONS(3519),
    [anon_sym_var] = ACTIONS(3519),
    [sym_predefined_type] = ACTIONS(3519),
    [anon_sym_break] = ACTIONS(3519),
    [anon_sym_unchecked] = ACTIONS(3519),
    [anon_sym_continue] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_lock] = ACTIONS(3519),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_switch] = ACTIONS(3519),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_throw] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_when] = ACTIONS(3519),
    [anon_sym_await] = ACTIONS(3519),
    [anon_sym_foreach] = ACTIONS(3519),
    [anon_sym_goto] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_DOT_DOT] = ACTIONS(3521),
    [anon_sym_from] = ACTIONS(3519),
    [anon_sym_into] = ACTIONS(3519),
    [anon_sym_join] = ACTIONS(3519),
    [anon_sym_on] = ACTIONS(3519),
    [anon_sym_equals] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_orderby] = ACTIONS(3519),
    [anon_sym_ascending] = ACTIONS(3519),
    [anon_sym_descending] = ACTIONS(3519),
    [anon_sym_group] = ACTIONS(3519),
    [anon_sym_by] = ACTIONS(3519),
    [anon_sym_select] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [anon_sym_stackalloc] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3519),
    [anon_sym_typeof] = ACTIONS(3519),
    [anon_sym___makeref] = ACTIONS(3519),
    [anon_sym___reftype] = ACTIONS(3519),
    [anon_sym___refvalue] = ACTIONS(3519),
    [sym_null_literal] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3521),
    [sym_integer_literal] = ACTIONS(3519),
    [sym_real_literal] = ACTIONS(3521),
    [sym_verbatim_string_literal] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token3] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3521),
    [sym_interpolation_verbatim_start] = ACTIONS(3521),
    [sym_interpolation_raw_start] = ACTIONS(3521),
    [sym_raw_string_start] = ACTIONS(3521),
  },
  [2337] = {
    [sym_preproc_region] = STATE(2337),
    [sym_preproc_endregion] = STATE(2337),
    [sym_preproc_line] = STATE(2337),
    [sym_preproc_pragma] = STATE(2337),
    [sym_preproc_nullable] = STATE(2337),
    [sym_preproc_error] = STATE(2337),
    [sym_preproc_define] = STATE(2337),
    [sym_preproc_undef] = STATE(2337),
    [sym__identifier_token] = ACTIONS(3523),
    [anon_sym_extern] = ACTIONS(3523),
    [anon_sym_alias] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3523),
    [anon_sym_using] = ACTIONS(3523),
    [anon_sym_unsafe] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_class] = ACTIONS(3523),
    [anon_sym_ref] = ACTIONS(3523),
    [anon_sym_struct] = ACTIONS(3523),
    [anon_sym_enum] = ACTIONS(3523),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_delegate] = ACTIONS(3523),
    [anon_sym_record] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_async] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3523),
    [anon_sym_file] = ACTIONS(3523),
    [anon_sym_fixed] = ACTIONS(3523),
    [anon_sym_internal] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [anon_sym_partial] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_readonly] = ACTIONS(3523),
    [anon_sym_required] = ACTIONS(3523),
    [anon_sym_sealed] = ACTIONS(3523),
    [anon_sym_virtual] = ACTIONS(3523),
    [anon_sym_volatile] = ACTIONS(3523),
    [anon_sym_where] = ACTIONS(3523),
    [anon_sym_notnull] = ACTIONS(3523),
    [anon_sym_unmanaged] = ACTIONS(3523),
    [anon_sym_checked] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3525),
    [anon_sym_true] = ACTIONS(3523),
    [anon_sym_false] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_CARET] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_this] = ACTIONS(3523),
    [anon_sym_scoped] = ACTIONS(3523),
    [anon_sym_base] = ACTIONS(3523),
    [anon_sym_var] = ACTIONS(3523),
    [sym_predefined_type] = ACTIONS(3523),
    [anon_sym_break] = ACTIONS(3523),
    [anon_sym_unchecked] = ACTIONS(3523),
    [anon_sym_continue] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_lock] = ACTIONS(3523),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_switch] = ACTIONS(3523),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_throw] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_when] = ACTIONS(3523),
    [anon_sym_await] = ACTIONS(3523),
    [anon_sym_foreach] = ACTIONS(3523),
    [anon_sym_goto] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_DOT_DOT] = ACTIONS(3525),
    [anon_sym_from] = ACTIONS(3523),
    [anon_sym_into] = ACTIONS(3523),
    [anon_sym_join] = ACTIONS(3523),
    [anon_sym_on] = ACTIONS(3523),
    [anon_sym_equals] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_orderby] = ACTIONS(3523),
    [anon_sym_ascending] = ACTIONS(3523),
    [anon_sym_descending] = ACTIONS(3523),
    [anon_sym_group] = ACTIONS(3523),
    [anon_sym_by] = ACTIONS(3523),
    [anon_sym_select] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_stackalloc] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3523),
    [anon_sym_typeof] = ACTIONS(3523),
    [anon_sym___makeref] = ACTIONS(3523),
    [anon_sym___reftype] = ACTIONS(3523),
    [anon_sym___refvalue] = ACTIONS(3523),
    [sym_null_literal] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3525),
    [sym_integer_literal] = ACTIONS(3523),
    [sym_real_literal] = ACTIONS(3525),
    [sym_verbatim_string_literal] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_if_token3] = ACTIONS(3525),
    [aux_sym_preproc_else_token1] = ACTIONS(3525),
    [aux_sym_preproc_elif_token1] = ACTIONS(3525),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3525),
    [sym_interpolation_verbatim_start] = ACTIONS(3525),
    [sym_interpolation_raw_start] = ACTIONS(3525),
    [sym_raw_string_start] = ACTIONS(3525),
  },
  [2338] = {
    [sym_preproc_region] = STATE(2338),
    [sym_preproc_endregion] = STATE(2338),
    [sym_preproc_line] = STATE(2338),
    [sym_preproc_pragma] = STATE(2338),
    [sym_preproc_nullable] = STATE(2338),
    [sym_preproc_error] = STATE(2338),
    [sym_preproc_define] = STATE(2338),
    [sym_preproc_undef] = STATE(2338),
    [sym__identifier_token] = ACTIONS(3527),
    [anon_sym_extern] = ACTIONS(3527),
    [anon_sym_alias] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3529),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_using] = ACTIONS(3527),
    [anon_sym_unsafe] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_class] = ACTIONS(3527),
    [anon_sym_ref] = ACTIONS(3527),
    [anon_sym_struct] = ACTIONS(3527),
    [anon_sym_enum] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_delegate] = ACTIONS(3527),
    [anon_sym_record] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_async] = ACTIONS(3527),
    [anon_sym_const] = ACTIONS(3527),
    [anon_sym_file] = ACTIONS(3527),
    [anon_sym_fixed] = ACTIONS(3527),
    [anon_sym_internal] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [anon_sym_partial] = ACTIONS(3527),
    [anon_sym_private] = ACTIONS(3527),
    [anon_sym_protected] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(3527),
    [anon_sym_readonly] = ACTIONS(3527),
    [anon_sym_required] = ACTIONS(3527),
    [anon_sym_sealed] = ACTIONS(3527),
    [anon_sym_virtual] = ACTIONS(3527),
    [anon_sym_volatile] = ACTIONS(3527),
    [anon_sym_where] = ACTIONS(3527),
    [anon_sym_notnull] = ACTIONS(3527),
    [anon_sym_unmanaged] = ACTIONS(3527),
    [anon_sym_checked] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3529),
    [anon_sym_DASH_DASH] = ACTIONS(3529),
    [anon_sym_true] = ACTIONS(3527),
    [anon_sym_false] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_CARET] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_this] = ACTIONS(3527),
    [anon_sym_scoped] = ACTIONS(3527),
    [anon_sym_base] = ACTIONS(3527),
    [anon_sym_var] = ACTIONS(3527),
    [sym_predefined_type] = ACTIONS(3527),
    [anon_sym_break] = ACTIONS(3527),
    [anon_sym_unchecked] = ACTIONS(3527),
    [anon_sym_continue] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_lock] = ACTIONS(3527),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_switch] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_throw] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_when] = ACTIONS(3527),
    [anon_sym_await] = ACTIONS(3527),
    [anon_sym_foreach] = ACTIONS(3527),
    [anon_sym_goto] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_from] = ACTIONS(3527),
    [anon_sym_into] = ACTIONS(3527),
    [anon_sym_join] = ACTIONS(3527),
    [anon_sym_on] = ACTIONS(3527),
    [anon_sym_equals] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_orderby] = ACTIONS(3527),
    [anon_sym_ascending] = ACTIONS(3527),
    [anon_sym_descending] = ACTIONS(3527),
    [anon_sym_group] = ACTIONS(3527),
    [anon_sym_by] = ACTIONS(3527),
    [anon_sym_select] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3529),
    [anon_sym_stackalloc] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3527),
    [anon_sym_typeof] = ACTIONS(3527),
    [anon_sym___makeref] = ACTIONS(3527),
    [anon_sym___reftype] = ACTIONS(3527),
    [anon_sym___refvalue] = ACTIONS(3527),
    [sym_null_literal] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3529),
    [sym_integer_literal] = ACTIONS(3527),
    [sym_real_literal] = ACTIONS(3529),
    [sym_verbatim_string_literal] = ACTIONS(3529),
    [aux_sym_preproc_if_token1] = ACTIONS(3529),
    [aux_sym_preproc_if_token3] = ACTIONS(3529),
    [aux_sym_preproc_else_token1] = ACTIONS(3529),
    [aux_sym_preproc_elif_token1] = ACTIONS(3529),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3529),
    [sym_interpolation_verbatim_start] = ACTIONS(3529),
    [sym_interpolation_raw_start] = ACTIONS(3529),
    [sym_raw_string_start] = ACTIONS(3529),
  },
  [2339] = {
    [sym_preproc_region] = STATE(2339),
    [sym_preproc_endregion] = STATE(2339),
    [sym_preproc_line] = STATE(2339),
    [sym_preproc_pragma] = STATE(2339),
    [sym_preproc_nullable] = STATE(2339),
    [sym_preproc_error] = STATE(2339),
    [sym_preproc_define] = STATE(2339),
    [sym_preproc_undef] = STATE(2339),
    [sym__identifier_token] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym_alias] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_unsafe] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_ref] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_delegate] = ACTIONS(3531),
    [anon_sym_record] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_async] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_file] = ACTIONS(3531),
    [anon_sym_fixed] = ACTIONS(3531),
    [anon_sym_internal] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [anon_sym_partial] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_readonly] = ACTIONS(3531),
    [anon_sym_required] = ACTIONS(3531),
    [anon_sym_sealed] = ACTIONS(3531),
    [anon_sym_virtual] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_where] = ACTIONS(3531),
    [anon_sym_notnull] = ACTIONS(3531),
    [anon_sym_unmanaged] = ACTIONS(3531),
    [anon_sym_checked] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_true] = ACTIONS(3531),
    [anon_sym_false] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_this] = ACTIONS(3531),
    [anon_sym_scoped] = ACTIONS(3531),
    [anon_sym_base] = ACTIONS(3531),
    [anon_sym_var] = ACTIONS(3531),
    [sym_predefined_type] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_unchecked] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_lock] = ACTIONS(3531),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_when] = ACTIONS(3531),
    [anon_sym_await] = ACTIONS(3531),
    [anon_sym_foreach] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_DOT_DOT] = ACTIONS(3533),
    [anon_sym_from] = ACTIONS(3531),
    [anon_sym_into] = ACTIONS(3531),
    [anon_sym_join] = ACTIONS(3531),
    [anon_sym_on] = ACTIONS(3531),
    [anon_sym_equals] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_orderby] = ACTIONS(3531),
    [anon_sym_ascending] = ACTIONS(3531),
    [anon_sym_descending] = ACTIONS(3531),
    [anon_sym_group] = ACTIONS(3531),
    [anon_sym_by] = ACTIONS(3531),
    [anon_sym_select] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_stackalloc] = ACTIONS(3531),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym_typeof] = ACTIONS(3531),
    [anon_sym___makeref] = ACTIONS(3531),
    [anon_sym___reftype] = ACTIONS(3531),
    [anon_sym___refvalue] = ACTIONS(3531),
    [sym_null_literal] = ACTIONS(3531),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [sym_integer_literal] = ACTIONS(3531),
    [sym_real_literal] = ACTIONS(3533),
    [sym_verbatim_string_literal] = ACTIONS(3533),
    [aux_sym_preproc_if_token1] = ACTIONS(3533),
    [aux_sym_preproc_if_token3] = ACTIONS(3533),
    [aux_sym_preproc_else_token1] = ACTIONS(3533),
    [aux_sym_preproc_elif_token1] = ACTIONS(3533),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3533),
    [sym_interpolation_verbatim_start] = ACTIONS(3533),
    [sym_interpolation_raw_start] = ACTIONS(3533),
    [sym_raw_string_start] = ACTIONS(3533),
  },
  [2340] = {
    [sym_preproc_region] = STATE(2340),
    [sym_preproc_endregion] = STATE(2340),
    [sym_preproc_line] = STATE(2340),
    [sym_preproc_pragma] = STATE(2340),
    [sym_preproc_nullable] = STATE(2340),
    [sym_preproc_error] = STATE(2340),
    [sym_preproc_define] = STATE(2340),
    [sym_preproc_undef] = STATE(2340),
    [sym__identifier_token] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym_alias] = ACTIONS(3535),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_unsafe] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_ref] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_delegate] = ACTIONS(3535),
    [anon_sym_record] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_async] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_file] = ACTIONS(3535),
    [anon_sym_fixed] = ACTIONS(3535),
    [anon_sym_internal] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [anon_sym_partial] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_readonly] = ACTIONS(3535),
    [anon_sym_required] = ACTIONS(3535),
    [anon_sym_sealed] = ACTIONS(3535),
    [anon_sym_virtual] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_where] = ACTIONS(3535),
    [anon_sym_notnull] = ACTIONS(3535),
    [anon_sym_unmanaged] = ACTIONS(3535),
    [anon_sym_checked] = ACTIONS(3535),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_true] = ACTIONS(3535),
    [anon_sym_false] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3537),
    [anon_sym_this] = ACTIONS(3535),
    [anon_sym_scoped] = ACTIONS(3535),
    [anon_sym_base] = ACTIONS(3535),
    [anon_sym_var] = ACTIONS(3535),
    [sym_predefined_type] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_unchecked] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_lock] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_when] = ACTIONS(3535),
    [anon_sym_await] = ACTIONS(3535),
    [anon_sym_foreach] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_DOT_DOT] = ACTIONS(3537),
    [anon_sym_from] = ACTIONS(3535),
    [anon_sym_into] = ACTIONS(3535),
    [anon_sym_join] = ACTIONS(3535),
    [anon_sym_on] = ACTIONS(3535),
    [anon_sym_equals] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_orderby] = ACTIONS(3535),
    [anon_sym_ascending] = ACTIONS(3535),
    [anon_sym_descending] = ACTIONS(3535),
    [anon_sym_group] = ACTIONS(3535),
    [anon_sym_by] = ACTIONS(3535),
    [anon_sym_select] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [anon_sym_stackalloc] = ACTIONS(3535),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym_typeof] = ACTIONS(3535),
    [anon_sym___makeref] = ACTIONS(3535),
    [anon_sym___reftype] = ACTIONS(3535),
    [anon_sym___refvalue] = ACTIONS(3535),
    [sym_null_literal] = ACTIONS(3535),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [sym_integer_literal] = ACTIONS(3535),
    [sym_real_literal] = ACTIONS(3537),
    [sym_verbatim_string_literal] = ACTIONS(3537),
    [aux_sym_preproc_if_token1] = ACTIONS(3537),
    [aux_sym_preproc_if_token3] = ACTIONS(3537),
    [aux_sym_preproc_else_token1] = ACTIONS(3537),
    [aux_sym_preproc_elif_token1] = ACTIONS(3537),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3537),
    [sym_interpolation_verbatim_start] = ACTIONS(3537),
    [sym_interpolation_raw_start] = ACTIONS(3537),
    [sym_raw_string_start] = ACTIONS(3537),
  },
  [2341] = {
    [sym_preproc_region] = STATE(2341),
    [sym_preproc_endregion] = STATE(2341),
    [sym_preproc_line] = STATE(2341),
    [sym_preproc_pragma] = STATE(2341),
    [sym_preproc_nullable] = STATE(2341),
    [sym_preproc_error] = STATE(2341),
    [sym_preproc_define] = STATE(2341),
    [sym_preproc_undef] = STATE(2341),
    [sym__identifier_token] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym_alias] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_unsafe] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_ref] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_delegate] = ACTIONS(3539),
    [anon_sym_record] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_async] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_file] = ACTIONS(3539),
    [anon_sym_fixed] = ACTIONS(3539),
    [anon_sym_internal] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [anon_sym_partial] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_readonly] = ACTIONS(3539),
    [anon_sym_required] = ACTIONS(3539),
    [anon_sym_sealed] = ACTIONS(3539),
    [anon_sym_virtual] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_where] = ACTIONS(3539),
    [anon_sym_notnull] = ACTIONS(3539),
    [anon_sym_unmanaged] = ACTIONS(3539),
    [anon_sym_checked] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_true] = ACTIONS(3539),
    [anon_sym_false] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_this] = ACTIONS(3539),
    [anon_sym_scoped] = ACTIONS(3539),
    [anon_sym_base] = ACTIONS(3539),
    [anon_sym_var] = ACTIONS(3539),
    [sym_predefined_type] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_unchecked] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_lock] = ACTIONS(3539),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_when] = ACTIONS(3539),
    [anon_sym_await] = ACTIONS(3539),
    [anon_sym_foreach] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_DOT_DOT] = ACTIONS(3541),
    [anon_sym_from] = ACTIONS(3539),
    [anon_sym_into] = ACTIONS(3539),
    [anon_sym_join] = ACTIONS(3539),
    [anon_sym_on] = ACTIONS(3539),
    [anon_sym_equals] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_orderby] = ACTIONS(3539),
    [anon_sym_ascending] = ACTIONS(3539),
    [anon_sym_descending] = ACTIONS(3539),
    [anon_sym_group] = ACTIONS(3539),
    [anon_sym_by] = ACTIONS(3539),
    [anon_sym_select] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [anon_sym_stackalloc] = ACTIONS(3539),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym_typeof] = ACTIONS(3539),
    [anon_sym___makeref] = ACTIONS(3539),
    [anon_sym___reftype] = ACTIONS(3539),
    [anon_sym___refvalue] = ACTIONS(3539),
    [sym_null_literal] = ACTIONS(3539),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [sym_integer_literal] = ACTIONS(3539),
    [sym_real_literal] = ACTIONS(3541),
    [sym_verbatim_string_literal] = ACTIONS(3541),
    [aux_sym_preproc_if_token1] = ACTIONS(3541),
    [aux_sym_preproc_if_token3] = ACTIONS(3541),
    [aux_sym_preproc_else_token1] = ACTIONS(3541),
    [aux_sym_preproc_elif_token1] = ACTIONS(3541),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3541),
    [sym_interpolation_verbatim_start] = ACTIONS(3541),
    [sym_interpolation_raw_start] = ACTIONS(3541),
    [sym_raw_string_start] = ACTIONS(3541),
  },
  [2342] = {
    [sym_preproc_region] = STATE(2342),
    [sym_preproc_endregion] = STATE(2342),
    [sym_preproc_line] = STATE(2342),
    [sym_preproc_pragma] = STATE(2342),
    [sym_preproc_nullable] = STATE(2342),
    [sym_preproc_error] = STATE(2342),
    [sym_preproc_define] = STATE(2342),
    [sym_preproc_undef] = STATE(2342),
    [sym__identifier_token] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym_alias] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_unsafe] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_ref] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_delegate] = ACTIONS(3543),
    [anon_sym_record] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_async] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_file] = ACTIONS(3543),
    [anon_sym_fixed] = ACTIONS(3543),
    [anon_sym_internal] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [anon_sym_partial] = ACTIONS(3543),
    [anon_sym_private] = ACTIONS(3543),
    [anon_sym_protected] = ACTIONS(3543),
    [anon_sym_public] = ACTIONS(3543),
    [anon_sym_readonly] = ACTIONS(3543),
    [anon_sym_required] = ACTIONS(3543),
    [anon_sym_sealed] = ACTIONS(3543),
    [anon_sym_virtual] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_where] = ACTIONS(3543),
    [anon_sym_notnull] = ACTIONS(3543),
    [anon_sym_unmanaged] = ACTIONS(3543),
    [anon_sym_checked] = ACTIONS(3543),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_true] = ACTIONS(3543),
    [anon_sym_false] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_CARET] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_this] = ACTIONS(3543),
    [anon_sym_scoped] = ACTIONS(3543),
    [anon_sym_base] = ACTIONS(3543),
    [anon_sym_var] = ACTIONS(3543),
    [sym_predefined_type] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_unchecked] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_lock] = ACTIONS(3543),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_when] = ACTIONS(3543),
    [anon_sym_await] = ACTIONS(3543),
    [anon_sym_foreach] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_DOT_DOT] = ACTIONS(3545),
    [anon_sym_from] = ACTIONS(3543),
    [anon_sym_into] = ACTIONS(3543),
    [anon_sym_join] = ACTIONS(3543),
    [anon_sym_on] = ACTIONS(3543),
    [anon_sym_equals] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_orderby] = ACTIONS(3543),
    [anon_sym_ascending] = ACTIONS(3543),
    [anon_sym_descending] = ACTIONS(3543),
    [anon_sym_group] = ACTIONS(3543),
    [anon_sym_by] = ACTIONS(3543),
    [anon_sym_select] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_stackalloc] = ACTIONS(3543),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym_typeof] = ACTIONS(3543),
    [anon_sym___makeref] = ACTIONS(3543),
    [anon_sym___reftype] = ACTIONS(3543),
    [anon_sym___refvalue] = ACTIONS(3543),
    [sym_null_literal] = ACTIONS(3543),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [sym_integer_literal] = ACTIONS(3543),
    [sym_real_literal] = ACTIONS(3545),
    [sym_verbatim_string_literal] = ACTIONS(3545),
    [aux_sym_preproc_if_token1] = ACTIONS(3545),
    [aux_sym_preproc_if_token3] = ACTIONS(3545),
    [aux_sym_preproc_else_token1] = ACTIONS(3545),
    [aux_sym_preproc_elif_token1] = ACTIONS(3545),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3545),
    [sym_interpolation_verbatim_start] = ACTIONS(3545),
    [sym_interpolation_raw_start] = ACTIONS(3545),
    [sym_raw_string_start] = ACTIONS(3545),
  },
  [2343] = {
    [sym_preproc_region] = STATE(2343),
    [sym_preproc_endregion] = STATE(2343),
    [sym_preproc_line] = STATE(2343),
    [sym_preproc_pragma] = STATE(2343),
    [sym_preproc_nullable] = STATE(2343),
    [sym_preproc_error] = STATE(2343),
    [sym_preproc_define] = STATE(2343),
    [sym_preproc_undef] = STATE(2343),
    [sym__identifier_token] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym_alias] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_global] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_unsafe] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3549),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_ref] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_delegate] = ACTIONS(3547),
    [anon_sym_record] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_async] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_file] = ACTIONS(3547),
    [anon_sym_fixed] = ACTIONS(3547),
    [anon_sym_internal] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [anon_sym_partial] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_required] = ACTIONS(3547),
    [anon_sym_sealed] = ACTIONS(3547),
    [anon_sym_virtual] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_where] = ACTIONS(3547),
    [anon_sym_notnull] = ACTIONS(3547),
    [anon_sym_unmanaged] = ACTIONS(3547),
    [anon_sym_checked] = ACTIONS(3547),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_true] = ACTIONS(3547),
    [anon_sym_false] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_CARET] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3549),
    [anon_sym_this] = ACTIONS(3547),
    [anon_sym_scoped] = ACTIONS(3547),
    [anon_sym_base] = ACTIONS(3547),
    [anon_sym_var] = ACTIONS(3547),
    [sym_predefined_type] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_unchecked] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_lock] = ACTIONS(3547),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_when] = ACTIONS(3547),
    [anon_sym_await] = ACTIONS(3547),
    [anon_sym_foreach] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_DOT_DOT] = ACTIONS(3549),
    [anon_sym_from] = ACTIONS(3547),
    [anon_sym_into] = ACTIONS(3547),
    [anon_sym_join] = ACTIONS(3547),
    [anon_sym_on] = ACTIONS(3547),
    [anon_sym_equals] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_orderby] = ACTIONS(3547),
    [anon_sym_ascending] = ACTIONS(3547),
    [anon_sym_descending] = ACTIONS(3547),
    [anon_sym_group] = ACTIONS(3547),
    [anon_sym_by] = ACTIONS(3547),
    [anon_sym_select] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [anon_sym_stackalloc] = ACTIONS(3547),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym_typeof] = ACTIONS(3547),
    [anon_sym___makeref] = ACTIONS(3547),
    [anon_sym___reftype] = ACTIONS(3547),
    [anon_sym___refvalue] = ACTIONS(3547),
    [sym_null_literal] = ACTIONS(3547),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [sym_integer_literal] = ACTIONS(3547),
    [sym_real_literal] = ACTIONS(3549),
    [sym_verbatim_string_literal] = ACTIONS(3549),
    [aux_sym_preproc_if_token1] = ACTIONS(3549),
    [aux_sym_preproc_if_token3] = ACTIONS(3549),
    [aux_sym_preproc_else_token1] = ACTIONS(3549),
    [aux_sym_preproc_elif_token1] = ACTIONS(3549),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3549),
    [sym_interpolation_verbatim_start] = ACTIONS(3549),
    [sym_interpolation_raw_start] = ACTIONS(3549),
    [sym_raw_string_start] = ACTIONS(3549),
  },
  [2344] = {
    [sym_preproc_region] = STATE(2344),
    [sym_preproc_endregion] = STATE(2344),
    [sym_preproc_line] = STATE(2344),
    [sym_preproc_pragma] = STATE(2344),
    [sym_preproc_nullable] = STATE(2344),
    [sym_preproc_error] = STATE(2344),
    [sym_preproc_define] = STATE(2344),
    [sym_preproc_undef] = STATE(2344),
    [sym__identifier_token] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym_alias] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym_global] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_unsafe] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3553),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_ref] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_delegate] = ACTIONS(3551),
    [anon_sym_record] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_file] = ACTIONS(3551),
    [anon_sym_fixed] = ACTIONS(3551),
    [anon_sym_internal] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [anon_sym_partial] = ACTIONS(3551),
    [anon_sym_private] = ACTIONS(3551),
    [anon_sym_protected] = ACTIONS(3551),
    [anon_sym_public] = ACTIONS(3551),
    [anon_sym_readonly] = ACTIONS(3551),
    [anon_sym_required] = ACTIONS(3551),
    [anon_sym_sealed] = ACTIONS(3551),
    [anon_sym_virtual] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_where] = ACTIONS(3551),
    [anon_sym_notnull] = ACTIONS(3551),
    [anon_sym_unmanaged] = ACTIONS(3551),
    [anon_sym_checked] = ACTIONS(3551),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_true] = ACTIONS(3551),
    [anon_sym_false] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_CARET] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3553),
    [anon_sym_this] = ACTIONS(3551),
    [anon_sym_scoped] = ACTIONS(3551),
    [anon_sym_base] = ACTIONS(3551),
    [anon_sym_var] = ACTIONS(3551),
    [sym_predefined_type] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_unchecked] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_lock] = ACTIONS(3551),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_when] = ACTIONS(3551),
    [anon_sym_await] = ACTIONS(3551),
    [anon_sym_foreach] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_DOT_DOT] = ACTIONS(3553),
    [anon_sym_from] = ACTIONS(3551),
    [anon_sym_into] = ACTIONS(3551),
    [anon_sym_join] = ACTIONS(3551),
    [anon_sym_on] = ACTIONS(3551),
    [anon_sym_equals] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_orderby] = ACTIONS(3551),
    [anon_sym_ascending] = ACTIONS(3551),
    [anon_sym_descending] = ACTIONS(3551),
    [anon_sym_group] = ACTIONS(3551),
    [anon_sym_by] = ACTIONS(3551),
    [anon_sym_select] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [anon_sym_stackalloc] = ACTIONS(3551),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym_typeof] = ACTIONS(3551),
    [anon_sym___makeref] = ACTIONS(3551),
    [anon_sym___reftype] = ACTIONS(3551),
    [anon_sym___refvalue] = ACTIONS(3551),
    [sym_null_literal] = ACTIONS(3551),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [sym_integer_literal] = ACTIONS(3551),
    [sym_real_literal] = ACTIONS(3553),
    [sym_verbatim_string_literal] = ACTIONS(3553),
    [aux_sym_preproc_if_token1] = ACTIONS(3553),
    [aux_sym_preproc_if_token3] = ACTIONS(3553),
    [aux_sym_preproc_else_token1] = ACTIONS(3553),
    [aux_sym_preproc_elif_token1] = ACTIONS(3553),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3553),
    [sym_interpolation_verbatim_start] = ACTIONS(3553),
    [sym_interpolation_raw_start] = ACTIONS(3553),
    [sym_raw_string_start] = ACTIONS(3553),
  },
  [2345] = {
    [sym_preproc_region] = STATE(2345),
    [sym_preproc_endregion] = STATE(2345),
    [sym_preproc_line] = STATE(2345),
    [sym_preproc_pragma] = STATE(2345),
    [sym_preproc_nullable] = STATE(2345),
    [sym_preproc_error] = STATE(2345),
    [sym_preproc_define] = STATE(2345),
    [sym_preproc_undef] = STATE(2345),
    [sym__identifier_token] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym_alias] = ACTIONS(3555),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym_global] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_unsafe] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_ref] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_delegate] = ACTIONS(3555),
    [anon_sym_record] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_async] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_file] = ACTIONS(3555),
    [anon_sym_fixed] = ACTIONS(3555),
    [anon_sym_internal] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [anon_sym_partial] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_readonly] = ACTIONS(3555),
    [anon_sym_required] = ACTIONS(3555),
    [anon_sym_sealed] = ACTIONS(3555),
    [anon_sym_virtual] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_where] = ACTIONS(3555),
    [anon_sym_notnull] = ACTIONS(3555),
    [anon_sym_unmanaged] = ACTIONS(3555),
    [anon_sym_checked] = ACTIONS(3555),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_true] = ACTIONS(3555),
    [anon_sym_false] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_CARET] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3557),
    [anon_sym_this] = ACTIONS(3555),
    [anon_sym_scoped] = ACTIONS(3555),
    [anon_sym_base] = ACTIONS(3555),
    [anon_sym_var] = ACTIONS(3555),
    [sym_predefined_type] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_unchecked] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_lock] = ACTIONS(3555),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_when] = ACTIONS(3555),
    [anon_sym_await] = ACTIONS(3555),
    [anon_sym_foreach] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_DOT_DOT] = ACTIONS(3557),
    [anon_sym_from] = ACTIONS(3555),
    [anon_sym_into] = ACTIONS(3555),
    [anon_sym_join] = ACTIONS(3555),
    [anon_sym_on] = ACTIONS(3555),
    [anon_sym_equals] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_orderby] = ACTIONS(3555),
    [anon_sym_ascending] = ACTIONS(3555),
    [anon_sym_descending] = ACTIONS(3555),
    [anon_sym_group] = ACTIONS(3555),
    [anon_sym_by] = ACTIONS(3555),
    [anon_sym_select] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [anon_sym_stackalloc] = ACTIONS(3555),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym_typeof] = ACTIONS(3555),
    [anon_sym___makeref] = ACTIONS(3555),
    [anon_sym___reftype] = ACTIONS(3555),
    [anon_sym___refvalue] = ACTIONS(3555),
    [sym_null_literal] = ACTIONS(3555),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [sym_integer_literal] = ACTIONS(3555),
    [sym_real_literal] = ACTIONS(3557),
    [sym_verbatim_string_literal] = ACTIONS(3557),
    [aux_sym_preproc_if_token1] = ACTIONS(3557),
    [aux_sym_preproc_if_token3] = ACTIONS(3557),
    [aux_sym_preproc_else_token1] = ACTIONS(3557),
    [aux_sym_preproc_elif_token1] = ACTIONS(3557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3557),
    [sym_interpolation_verbatim_start] = ACTIONS(3557),
    [sym_interpolation_raw_start] = ACTIONS(3557),
    [sym_raw_string_start] = ACTIONS(3557),
  },
  [2346] = {
    [sym_preproc_region] = STATE(2346),
    [sym_preproc_endregion] = STATE(2346),
    [sym_preproc_line] = STATE(2346),
    [sym_preproc_pragma] = STATE(2346),
    [sym_preproc_nullable] = STATE(2346),
    [sym_preproc_error] = STATE(2346),
    [sym_preproc_define] = STATE(2346),
    [sym_preproc_undef] = STATE(2346),
    [sym__identifier_token] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym_alias] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3561),
    [anon_sym_global] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_unsafe] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3561),
    [anon_sym_LPAREN] = ACTIONS(3561),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_ref] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_delegate] = ACTIONS(3559),
    [anon_sym_record] = ACTIONS(3559),
    [anon_sym_abstract] = ACTIONS(3559),
    [anon_sym_async] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_file] = ACTIONS(3559),
    [anon_sym_fixed] = ACTIONS(3559),
    [anon_sym_internal] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_override] = ACTIONS(3559),
    [anon_sym_partial] = ACTIONS(3559),
    [anon_sym_private] = ACTIONS(3559),
    [anon_sym_protected] = ACTIONS(3559),
    [anon_sym_public] = ACTIONS(3559),
    [anon_sym_readonly] = ACTIONS(3559),
    [anon_sym_required] = ACTIONS(3559),
    [anon_sym_sealed] = ACTIONS(3559),
    [anon_sym_virtual] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_where] = ACTIONS(3559),
    [anon_sym_notnull] = ACTIONS(3559),
    [anon_sym_unmanaged] = ACTIONS(3559),
    [anon_sym_checked] = ACTIONS(3559),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_true] = ACTIONS(3559),
    [anon_sym_false] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_CARET] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_this] = ACTIONS(3559),
    [anon_sym_scoped] = ACTIONS(3559),
    [anon_sym_base] = ACTIONS(3559),
    [anon_sym_var] = ACTIONS(3559),
    [sym_predefined_type] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_unchecked] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_lock] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_when] = ACTIONS(3559),
    [anon_sym_await] = ACTIONS(3559),
    [anon_sym_foreach] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_DOT_DOT] = ACTIONS(3561),
    [anon_sym_from] = ACTIONS(3559),
    [anon_sym_into] = ACTIONS(3559),
    [anon_sym_join] = ACTIONS(3559),
    [anon_sym_on] = ACTIONS(3559),
    [anon_sym_equals] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_orderby] = ACTIONS(3559),
    [anon_sym_ascending] = ACTIONS(3559),
    [anon_sym_descending] = ACTIONS(3559),
    [anon_sym_group] = ACTIONS(3559),
    [anon_sym_by] = ACTIONS(3559),
    [anon_sym_select] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [anon_sym_stackalloc] = ACTIONS(3559),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym_typeof] = ACTIONS(3559),
    [anon_sym___makeref] = ACTIONS(3559),
    [anon_sym___reftype] = ACTIONS(3559),
    [anon_sym___refvalue] = ACTIONS(3559),
    [sym_null_literal] = ACTIONS(3559),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [sym_integer_literal] = ACTIONS(3559),
    [sym_real_literal] = ACTIONS(3561),
    [sym_verbatim_string_literal] = ACTIONS(3561),
    [aux_sym_preproc_if_token1] = ACTIONS(3561),
    [aux_sym_preproc_if_token3] = ACTIONS(3561),
    [aux_sym_preproc_else_token1] = ACTIONS(3561),
    [aux_sym_preproc_elif_token1] = ACTIONS(3561),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3561),
    [sym_interpolation_verbatim_start] = ACTIONS(3561),
    [sym_interpolation_raw_start] = ACTIONS(3561),
    [sym_raw_string_start] = ACTIONS(3561),
  },
  [2347] = {
    [sym_preproc_region] = STATE(2347),
    [sym_preproc_endregion] = STATE(2347),
    [sym_preproc_line] = STATE(2347),
    [sym_preproc_pragma] = STATE(2347),
    [sym_preproc_nullable] = STATE(2347),
    [sym_preproc_error] = STATE(2347),
    [sym_preproc_define] = STATE(2347),
    [sym_preproc_undef] = STATE(2347),
    [sym__identifier_token] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym_alias] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_global] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_unsafe] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_LPAREN] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_ref] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_delegate] = ACTIONS(3563),
    [anon_sym_record] = ACTIONS(3563),
    [anon_sym_abstract] = ACTIONS(3563),
    [anon_sym_async] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_file] = ACTIONS(3563),
    [anon_sym_fixed] = ACTIONS(3563),
    [anon_sym_internal] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_override] = ACTIONS(3563),
    [anon_sym_partial] = ACTIONS(3563),
    [anon_sym_private] = ACTIONS(3563),
    [anon_sym_protected] = ACTIONS(3563),
    [anon_sym_public] = ACTIONS(3563),
    [anon_sym_readonly] = ACTIONS(3563),
    [anon_sym_required] = ACTIONS(3563),
    [anon_sym_sealed] = ACTIONS(3563),
    [anon_sym_virtual] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_where] = ACTIONS(3563),
    [anon_sym_notnull] = ACTIONS(3563),
    [anon_sym_unmanaged] = ACTIONS(3563),
    [anon_sym_checked] = ACTIONS(3563),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_true] = ACTIONS(3563),
    [anon_sym_false] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_this] = ACTIONS(3563),
    [anon_sym_scoped] = ACTIONS(3563),
    [anon_sym_base] = ACTIONS(3563),
    [anon_sym_var] = ACTIONS(3563),
    [sym_predefined_type] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_unchecked] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_lock] = ACTIONS(3563),
    [anon_sym_yield] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_when] = ACTIONS(3563),
    [anon_sym_await] = ACTIONS(3563),
    [anon_sym_foreach] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_DOT_DOT] = ACTIONS(3565),
    [anon_sym_from] = ACTIONS(3563),
    [anon_sym_into] = ACTIONS(3563),
    [anon_sym_join] = ACTIONS(3563),
    [anon_sym_on] = ACTIONS(3563),
    [anon_sym_equals] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_orderby] = ACTIONS(3563),
    [anon_sym_ascending] = ACTIONS(3563),
    [anon_sym_descending] = ACTIONS(3563),
    [anon_sym_group] = ACTIONS(3563),
    [anon_sym_by] = ACTIONS(3563),
    [anon_sym_select] = ACTIONS(3563),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [anon_sym_stackalloc] = ACTIONS(3563),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym_typeof] = ACTIONS(3563),
    [anon_sym___makeref] = ACTIONS(3563),
    [anon_sym___reftype] = ACTIONS(3563),
    [anon_sym___refvalue] = ACTIONS(3563),
    [sym_null_literal] = ACTIONS(3563),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [sym_integer_literal] = ACTIONS(3563),
    [sym_real_literal] = ACTIONS(3565),
    [sym_verbatim_string_literal] = ACTIONS(3565),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token3] = ACTIONS(3565),
    [aux_sym_preproc_else_token1] = ACTIONS(3565),
    [aux_sym_preproc_elif_token1] = ACTIONS(3565),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3565),
    [sym_interpolation_verbatim_start] = ACTIONS(3565),
    [sym_interpolation_raw_start] = ACTIONS(3565),
    [sym_raw_string_start] = ACTIONS(3565),
  },
  [2348] = {
    [sym_preproc_region] = STATE(2348),
    [sym_preproc_endregion] = STATE(2348),
    [sym_preproc_line] = STATE(2348),
    [sym_preproc_pragma] = STATE(2348),
    [sym_preproc_nullable] = STATE(2348),
    [sym_preproc_error] = STATE(2348),
    [sym_preproc_define] = STATE(2348),
    [sym_preproc_undef] = STATE(2348),
    [sym__identifier_token] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym_alias] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_global] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_unsafe] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(3569),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_ref] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_delegate] = ACTIONS(3567),
    [anon_sym_record] = ACTIONS(3567),
    [anon_sym_abstract] = ACTIONS(3567),
    [anon_sym_async] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_file] = ACTIONS(3567),
    [anon_sym_fixed] = ACTIONS(3567),
    [anon_sym_internal] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_override] = ACTIONS(3567),
    [anon_sym_partial] = ACTIONS(3567),
    [anon_sym_private] = ACTIONS(3567),
    [anon_sym_protected] = ACTIONS(3567),
    [anon_sym_public] = ACTIONS(3567),
    [anon_sym_readonly] = ACTIONS(3567),
    [anon_sym_required] = ACTIONS(3567),
    [anon_sym_sealed] = ACTIONS(3567),
    [anon_sym_virtual] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_where] = ACTIONS(3567),
    [anon_sym_notnull] = ACTIONS(3567),
    [anon_sym_unmanaged] = ACTIONS(3567),
    [anon_sym_checked] = ACTIONS(3567),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_true] = ACTIONS(3567),
    [anon_sym_false] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_CARET] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3569),
    [anon_sym_this] = ACTIONS(3567),
    [anon_sym_scoped] = ACTIONS(3567),
    [anon_sym_base] = ACTIONS(3567),
    [anon_sym_var] = ACTIONS(3567),
    [sym_predefined_type] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_unchecked] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_lock] = ACTIONS(3567),
    [anon_sym_yield] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_when] = ACTIONS(3567),
    [anon_sym_await] = ACTIONS(3567),
    [anon_sym_foreach] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_DOT_DOT] = ACTIONS(3569),
    [anon_sym_from] = ACTIONS(3567),
    [anon_sym_into] = ACTIONS(3567),
    [anon_sym_join] = ACTIONS(3567),
    [anon_sym_on] = ACTIONS(3567),
    [anon_sym_equals] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_orderby] = ACTIONS(3567),
    [anon_sym_ascending] = ACTIONS(3567),
    [anon_sym_descending] = ACTIONS(3567),
    [anon_sym_group] = ACTIONS(3567),
    [anon_sym_by] = ACTIONS(3567),
    [anon_sym_select] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [anon_sym_stackalloc] = ACTIONS(3567),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(3567),
    [anon_sym___makeref] = ACTIONS(3567),
    [anon_sym___reftype] = ACTIONS(3567),
    [anon_sym___refvalue] = ACTIONS(3567),
    [sym_null_literal] = ACTIONS(3567),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [sym_integer_literal] = ACTIONS(3567),
    [sym_real_literal] = ACTIONS(3569),
    [sym_verbatim_string_literal] = ACTIONS(3569),
    [aux_sym_preproc_if_token1] = ACTIONS(3569),
    [aux_sym_preproc_if_token3] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3569),
    [aux_sym_preproc_elif_token1] = ACTIONS(3569),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3569),
    [sym_interpolation_verbatim_start] = ACTIONS(3569),
    [sym_interpolation_raw_start] = ACTIONS(3569),
    [sym_raw_string_start] = ACTIONS(3569),
  },
  [2349] = {
    [sym_preproc_region] = STATE(2349),
    [sym_preproc_endregion] = STATE(2349),
    [sym_preproc_line] = STATE(2349),
    [sym_preproc_pragma] = STATE(2349),
    [sym_preproc_nullable] = STATE(2349),
    [sym_preproc_error] = STATE(2349),
    [sym_preproc_define] = STATE(2349),
    [sym_preproc_undef] = STATE(2349),
    [sym__identifier_token] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_alias] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym_global] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_unsafe] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(3573),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_ref] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_delegate] = ACTIONS(3571),
    [anon_sym_record] = ACTIONS(3571),
    [anon_sym_abstract] = ACTIONS(3571),
    [anon_sym_async] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_file] = ACTIONS(3571),
    [anon_sym_fixed] = ACTIONS(3571),
    [anon_sym_internal] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_override] = ACTIONS(3571),
    [anon_sym_partial] = ACTIONS(3571),
    [anon_sym_private] = ACTIONS(3571),
    [anon_sym_protected] = ACTIONS(3571),
    [anon_sym_public] = ACTIONS(3571),
    [anon_sym_readonly] = ACTIONS(3571),
    [anon_sym_required] = ACTIONS(3571),
    [anon_sym_sealed] = ACTIONS(3571),
    [anon_sym_virtual] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_where] = ACTIONS(3571),
    [anon_sym_notnull] = ACTIONS(3571),
    [anon_sym_unmanaged] = ACTIONS(3571),
    [anon_sym_checked] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_true] = ACTIONS(3571),
    [anon_sym_false] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_CARET] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3573),
    [anon_sym_this] = ACTIONS(3571),
    [anon_sym_scoped] = ACTIONS(3571),
    [anon_sym_base] = ACTIONS(3571),
    [anon_sym_var] = ACTIONS(3571),
    [sym_predefined_type] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_unchecked] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_lock] = ACTIONS(3571),
    [anon_sym_yield] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_when] = ACTIONS(3571),
    [anon_sym_await] = ACTIONS(3571),
    [anon_sym_foreach] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_DOT_DOT] = ACTIONS(3573),
    [anon_sym_from] = ACTIONS(3571),
    [anon_sym_into] = ACTIONS(3571),
    [anon_sym_join] = ACTIONS(3571),
    [anon_sym_on] = ACTIONS(3571),
    [anon_sym_equals] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_orderby] = ACTIONS(3571),
    [anon_sym_ascending] = ACTIONS(3571),
    [anon_sym_descending] = ACTIONS(3571),
    [anon_sym_group] = ACTIONS(3571),
    [anon_sym_by] = ACTIONS(3571),
    [anon_sym_select] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [anon_sym_stackalloc] = ACTIONS(3571),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym_typeof] = ACTIONS(3571),
    [anon_sym___makeref] = ACTIONS(3571),
    [anon_sym___reftype] = ACTIONS(3571),
    [anon_sym___refvalue] = ACTIONS(3571),
    [sym_null_literal] = ACTIONS(3571),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [sym_integer_literal] = ACTIONS(3571),
    [sym_real_literal] = ACTIONS(3573),
    [sym_verbatim_string_literal] = ACTIONS(3573),
    [aux_sym_preproc_if_token1] = ACTIONS(3573),
    [aux_sym_preproc_if_token3] = ACTIONS(3573),
    [aux_sym_preproc_else_token1] = ACTIONS(3573),
    [aux_sym_preproc_elif_token1] = ACTIONS(3573),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3573),
    [sym_interpolation_verbatim_start] = ACTIONS(3573),
    [sym_interpolation_raw_start] = ACTIONS(3573),
    [sym_raw_string_start] = ACTIONS(3573),
  },
  [2350] = {
    [sym_preproc_region] = STATE(2350),
    [sym_preproc_endregion] = STATE(2350),
    [sym_preproc_line] = STATE(2350),
    [sym_preproc_pragma] = STATE(2350),
    [sym_preproc_nullable] = STATE(2350),
    [sym_preproc_error] = STATE(2350),
    [sym_preproc_define] = STATE(2350),
    [sym_preproc_undef] = STATE(2350),
    [sym__identifier_token] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym_alias] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym_global] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_unsafe] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_ref] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_delegate] = ACTIONS(3575),
    [anon_sym_record] = ACTIONS(3575),
    [anon_sym_abstract] = ACTIONS(3575),
    [anon_sym_async] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_file] = ACTIONS(3575),
    [anon_sym_fixed] = ACTIONS(3575),
    [anon_sym_internal] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_override] = ACTIONS(3575),
    [anon_sym_partial] = ACTIONS(3575),
    [anon_sym_private] = ACTIONS(3575),
    [anon_sym_protected] = ACTIONS(3575),
    [anon_sym_public] = ACTIONS(3575),
    [anon_sym_readonly] = ACTIONS(3575),
    [anon_sym_required] = ACTIONS(3575),
    [anon_sym_sealed] = ACTIONS(3575),
    [anon_sym_virtual] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_where] = ACTIONS(3575),
    [anon_sym_notnull] = ACTIONS(3575),
    [anon_sym_unmanaged] = ACTIONS(3575),
    [anon_sym_checked] = ACTIONS(3575),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_true] = ACTIONS(3575),
    [anon_sym_false] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_this] = ACTIONS(3575),
    [anon_sym_scoped] = ACTIONS(3575),
    [anon_sym_base] = ACTIONS(3575),
    [anon_sym_var] = ACTIONS(3575),
    [sym_predefined_type] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_unchecked] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_lock] = ACTIONS(3575),
    [anon_sym_yield] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_await] = ACTIONS(3575),
    [anon_sym_foreach] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_from] = ACTIONS(3575),
    [anon_sym_into] = ACTIONS(3575),
    [anon_sym_join] = ACTIONS(3575),
    [anon_sym_on] = ACTIONS(3575),
    [anon_sym_equals] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_orderby] = ACTIONS(3575),
    [anon_sym_ascending] = ACTIONS(3575),
    [anon_sym_descending] = ACTIONS(3575),
    [anon_sym_group] = ACTIONS(3575),
    [anon_sym_by] = ACTIONS(3575),
    [anon_sym_select] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_stackalloc] = ACTIONS(3575),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym_typeof] = ACTIONS(3575),
    [anon_sym___makeref] = ACTIONS(3575),
    [anon_sym___reftype] = ACTIONS(3575),
    [anon_sym___refvalue] = ACTIONS(3575),
    [sym_null_literal] = ACTIONS(3575),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [sym_integer_literal] = ACTIONS(3575),
    [sym_real_literal] = ACTIONS(3577),
    [sym_verbatim_string_literal] = ACTIONS(3577),
    [aux_sym_preproc_if_token1] = ACTIONS(3577),
    [aux_sym_preproc_if_token3] = ACTIONS(3577),
    [aux_sym_preproc_else_token1] = ACTIONS(3577),
    [aux_sym_preproc_elif_token1] = ACTIONS(3577),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3577),
    [sym_interpolation_verbatim_start] = ACTIONS(3577),
    [sym_interpolation_raw_start] = ACTIONS(3577),
    [sym_raw_string_start] = ACTIONS(3577),
  },
  [2351] = {
    [sym_preproc_region] = STATE(2351),
    [sym_preproc_endregion] = STATE(2351),
    [sym_preproc_line] = STATE(2351),
    [sym_preproc_pragma] = STATE(2351),
    [sym_preproc_nullable] = STATE(2351),
    [sym_preproc_error] = STATE(2351),
    [sym_preproc_define] = STATE(2351),
    [sym_preproc_undef] = STATE(2351),
    [sym__identifier_token] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym_alias] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_unsafe] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_ref] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_delegate] = ACTIONS(3579),
    [anon_sym_record] = ACTIONS(3579),
    [anon_sym_abstract] = ACTIONS(3579),
    [anon_sym_async] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_file] = ACTIONS(3579),
    [anon_sym_fixed] = ACTIONS(3579),
    [anon_sym_internal] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_override] = ACTIONS(3579),
    [anon_sym_partial] = ACTIONS(3579),
    [anon_sym_private] = ACTIONS(3579),
    [anon_sym_protected] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3579),
    [anon_sym_readonly] = ACTIONS(3579),
    [anon_sym_required] = ACTIONS(3579),
    [anon_sym_sealed] = ACTIONS(3579),
    [anon_sym_virtual] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_where] = ACTIONS(3579),
    [anon_sym_notnull] = ACTIONS(3579),
    [anon_sym_unmanaged] = ACTIONS(3579),
    [anon_sym_checked] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_true] = ACTIONS(3579),
    [anon_sym_false] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_CARET] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_this] = ACTIONS(3579),
    [anon_sym_scoped] = ACTIONS(3579),
    [anon_sym_base] = ACTIONS(3579),
    [anon_sym_var] = ACTIONS(3579),
    [sym_predefined_type] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_unchecked] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_lock] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_when] = ACTIONS(3579),
    [anon_sym_await] = ACTIONS(3579),
    [anon_sym_foreach] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_DOT_DOT] = ACTIONS(3581),
    [anon_sym_from] = ACTIONS(3579),
    [anon_sym_into] = ACTIONS(3579),
    [anon_sym_join] = ACTIONS(3579),
    [anon_sym_on] = ACTIONS(3579),
    [anon_sym_equals] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_orderby] = ACTIONS(3579),
    [anon_sym_ascending] = ACTIONS(3579),
    [anon_sym_descending] = ACTIONS(3579),
    [anon_sym_group] = ACTIONS(3579),
    [anon_sym_by] = ACTIONS(3579),
    [anon_sym_select] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_stackalloc] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym_typeof] = ACTIONS(3579),
    [anon_sym___makeref] = ACTIONS(3579),
    [anon_sym___reftype] = ACTIONS(3579),
    [anon_sym___refvalue] = ACTIONS(3579),
    [sym_null_literal] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [sym_integer_literal] = ACTIONS(3579),
    [sym_real_literal] = ACTIONS(3581),
    [sym_verbatim_string_literal] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token3] = ACTIONS(3581),
    [aux_sym_preproc_else_token1] = ACTIONS(3581),
    [aux_sym_preproc_elif_token1] = ACTIONS(3581),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3581),
    [sym_interpolation_verbatim_start] = ACTIONS(3581),
    [sym_interpolation_raw_start] = ACTIONS(3581),
    [sym_raw_string_start] = ACTIONS(3581),
  },
  [2352] = {
    [sym_preproc_region] = STATE(2352),
    [sym_preproc_endregion] = STATE(2352),
    [sym_preproc_line] = STATE(2352),
    [sym_preproc_pragma] = STATE(2352),
    [sym_preproc_nullable] = STATE(2352),
    [sym_preproc_error] = STATE(2352),
    [sym_preproc_define] = STATE(2352),
    [sym_preproc_undef] = STATE(2352),
    [sym__identifier_token] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym_alias] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_unsafe] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_ref] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_delegate] = ACTIONS(3583),
    [anon_sym_record] = ACTIONS(3583),
    [anon_sym_abstract] = ACTIONS(3583),
    [anon_sym_async] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_file] = ACTIONS(3583),
    [anon_sym_fixed] = ACTIONS(3583),
    [anon_sym_internal] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_override] = ACTIONS(3583),
    [anon_sym_partial] = ACTIONS(3583),
    [anon_sym_private] = ACTIONS(3583),
    [anon_sym_protected] = ACTIONS(3583),
    [anon_sym_public] = ACTIONS(3583),
    [anon_sym_readonly] = ACTIONS(3583),
    [anon_sym_required] = ACTIONS(3583),
    [anon_sym_sealed] = ACTIONS(3583),
    [anon_sym_virtual] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_where] = ACTIONS(3583),
    [anon_sym_notnull] = ACTIONS(3583),
    [anon_sym_unmanaged] = ACTIONS(3583),
    [anon_sym_checked] = ACTIONS(3583),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_true] = ACTIONS(3583),
    [anon_sym_false] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_CARET] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_this] = ACTIONS(3583),
    [anon_sym_scoped] = ACTIONS(3583),
    [anon_sym_base] = ACTIONS(3583),
    [anon_sym_var] = ACTIONS(3583),
    [sym_predefined_type] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_unchecked] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_lock] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_when] = ACTIONS(3583),
    [anon_sym_await] = ACTIONS(3583),
    [anon_sym_foreach] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_DOT_DOT] = ACTIONS(3585),
    [anon_sym_from] = ACTIONS(3583),
    [anon_sym_into] = ACTIONS(3583),
    [anon_sym_join] = ACTIONS(3583),
    [anon_sym_on] = ACTIONS(3583),
    [anon_sym_equals] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_orderby] = ACTIONS(3583),
    [anon_sym_ascending] = ACTIONS(3583),
    [anon_sym_descending] = ACTIONS(3583),
    [anon_sym_group] = ACTIONS(3583),
    [anon_sym_by] = ACTIONS(3583),
    [anon_sym_select] = ACTIONS(3583),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_stackalloc] = ACTIONS(3583),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym_typeof] = ACTIONS(3583),
    [anon_sym___makeref] = ACTIONS(3583),
    [anon_sym___reftype] = ACTIONS(3583),
    [anon_sym___refvalue] = ACTIONS(3583),
    [sym_null_literal] = ACTIONS(3583),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [sym_integer_literal] = ACTIONS(3583),
    [sym_real_literal] = ACTIONS(3585),
    [sym_verbatim_string_literal] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token3] = ACTIONS(3585),
    [aux_sym_preproc_else_token1] = ACTIONS(3585),
    [aux_sym_preproc_elif_token1] = ACTIONS(3585),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3585),
    [sym_interpolation_verbatim_start] = ACTIONS(3585),
    [sym_interpolation_raw_start] = ACTIONS(3585),
    [sym_raw_string_start] = ACTIONS(3585),
  },
  [2353] = {
    [sym_preproc_region] = STATE(2353),
    [sym_preproc_endregion] = STATE(2353),
    [sym_preproc_line] = STATE(2353),
    [sym_preproc_pragma] = STATE(2353),
    [sym_preproc_nullable] = STATE(2353),
    [sym_preproc_error] = STATE(2353),
    [sym_preproc_define] = STATE(2353),
    [sym_preproc_undef] = STATE(2353),
    [sym__identifier_token] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym_alias] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_global] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_unsafe] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3589),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_ref] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_delegate] = ACTIONS(3587),
    [anon_sym_record] = ACTIONS(3587),
    [anon_sym_abstract] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_file] = ACTIONS(3587),
    [anon_sym_fixed] = ACTIONS(3587),
    [anon_sym_internal] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_override] = ACTIONS(3587),
    [anon_sym_partial] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_readonly] = ACTIONS(3587),
    [anon_sym_required] = ACTIONS(3587),
    [anon_sym_sealed] = ACTIONS(3587),
    [anon_sym_virtual] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_where] = ACTIONS(3587),
    [anon_sym_notnull] = ACTIONS(3587),
    [anon_sym_unmanaged] = ACTIONS(3587),
    [anon_sym_checked] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_true] = ACTIONS(3587),
    [anon_sym_false] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_CARET] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_this] = ACTIONS(3587),
    [anon_sym_scoped] = ACTIONS(3587),
    [anon_sym_base] = ACTIONS(3587),
    [anon_sym_var] = ACTIONS(3587),
    [sym_predefined_type] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_unchecked] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_lock] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_when] = ACTIONS(3587),
    [anon_sym_await] = ACTIONS(3587),
    [anon_sym_foreach] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_DOT_DOT] = ACTIONS(3589),
    [anon_sym_from] = ACTIONS(3587),
    [anon_sym_into] = ACTIONS(3587),
    [anon_sym_join] = ACTIONS(3587),
    [anon_sym_on] = ACTIONS(3587),
    [anon_sym_equals] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_orderby] = ACTIONS(3587),
    [anon_sym_ascending] = ACTIONS(3587),
    [anon_sym_descending] = ACTIONS(3587),
    [anon_sym_group] = ACTIONS(3587),
    [anon_sym_by] = ACTIONS(3587),
    [anon_sym_select] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_stackalloc] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym_typeof] = ACTIONS(3587),
    [anon_sym___makeref] = ACTIONS(3587),
    [anon_sym___reftype] = ACTIONS(3587),
    [anon_sym___refvalue] = ACTIONS(3587),
    [sym_null_literal] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [sym_integer_literal] = ACTIONS(3587),
    [sym_real_literal] = ACTIONS(3589),
    [sym_verbatim_string_literal] = ACTIONS(3589),
    [aux_sym_preproc_if_token1] = ACTIONS(3589),
    [aux_sym_preproc_if_token3] = ACTIONS(3589),
    [aux_sym_preproc_else_token1] = ACTIONS(3589),
    [aux_sym_preproc_elif_token1] = ACTIONS(3589),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3589),
    [sym_interpolation_verbatim_start] = ACTIONS(3589),
    [sym_interpolation_raw_start] = ACTIONS(3589),
    [sym_raw_string_start] = ACTIONS(3589),
  },
  [2354] = {
    [sym_preproc_region] = STATE(2354),
    [sym_preproc_endregion] = STATE(2354),
    [sym_preproc_line] = STATE(2354),
    [sym_preproc_pragma] = STATE(2354),
    [sym_preproc_nullable] = STATE(2354),
    [sym_preproc_error] = STATE(2354),
    [sym_preproc_define] = STATE(2354),
    [sym_preproc_undef] = STATE(2354),
    [sym__identifier_token] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym_alias] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_global] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_unsafe] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_ref] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_delegate] = ACTIONS(3591),
    [anon_sym_record] = ACTIONS(3591),
    [anon_sym_abstract] = ACTIONS(3591),
    [anon_sym_async] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_file] = ACTIONS(3591),
    [anon_sym_fixed] = ACTIONS(3591),
    [anon_sym_internal] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_override] = ACTIONS(3591),
    [anon_sym_partial] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_readonly] = ACTIONS(3591),
    [anon_sym_required] = ACTIONS(3591),
    [anon_sym_sealed] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_where] = ACTIONS(3591),
    [anon_sym_notnull] = ACTIONS(3591),
    [anon_sym_unmanaged] = ACTIONS(3591),
    [anon_sym_checked] = ACTIONS(3591),
    [anon_sym_BANG] = ACTIONS(3593),
    [anon_sym_TILDE] = ACTIONS(3593),
    [anon_sym_PLUS_PLUS] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3593),
    [anon_sym_true] = ACTIONS(3591),
    [anon_sym_false] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3593),
    [anon_sym_CARET] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_this] = ACTIONS(3591),
    [anon_sym_scoped] = ACTIONS(3591),
    [anon_sym_base] = ACTIONS(3591),
    [anon_sym_var] = ACTIONS(3591),
    [sym_predefined_type] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_unchecked] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_lock] = ACTIONS(3591),
    [anon_sym_yield] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_when] = ACTIONS(3591),
    [anon_sym_await] = ACTIONS(3591),
    [anon_sym_foreach] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_DOT_DOT] = ACTIONS(3593),
    [anon_sym_from] = ACTIONS(3591),
    [anon_sym_into] = ACTIONS(3591),
    [anon_sym_join] = ACTIONS(3591),
    [anon_sym_on] = ACTIONS(3591),
    [anon_sym_equals] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_orderby] = ACTIONS(3591),
    [anon_sym_ascending] = ACTIONS(3591),
    [anon_sym_descending] = ACTIONS(3591),
    [anon_sym_group] = ACTIONS(3591),
    [anon_sym_by] = ACTIONS(3591),
    [anon_sym_select] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3593),
    [anon_sym_stackalloc] = ACTIONS(3591),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym_typeof] = ACTIONS(3591),
    [anon_sym___makeref] = ACTIONS(3591),
    [anon_sym___reftype] = ACTIONS(3591),
    [anon_sym___refvalue] = ACTIONS(3591),
    [sym_null_literal] = ACTIONS(3591),
    [anon_sym_SQUOTE] = ACTIONS(3593),
    [sym_integer_literal] = ACTIONS(3591),
    [sym_real_literal] = ACTIONS(3593),
    [sym_verbatim_string_literal] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token3] = ACTIONS(3593),
    [aux_sym_preproc_else_token1] = ACTIONS(3593),
    [aux_sym_preproc_elif_token1] = ACTIONS(3593),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3593),
    [sym_interpolation_verbatim_start] = ACTIONS(3593),
    [sym_interpolation_raw_start] = ACTIONS(3593),
    [sym_raw_string_start] = ACTIONS(3593),
  },
  [2355] = {
    [sym_preproc_region] = STATE(2355),
    [sym_preproc_endregion] = STATE(2355),
    [sym_preproc_line] = STATE(2355),
    [sym_preproc_pragma] = STATE(2355),
    [sym_preproc_nullable] = STATE(2355),
    [sym_preproc_error] = STATE(2355),
    [sym_preproc_define] = STATE(2355),
    [sym_preproc_undef] = STATE(2355),
    [sym__identifier_token] = ACTIONS(3595),
    [anon_sym_extern] = ACTIONS(3595),
    [anon_sym_alias] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_global] = ACTIONS(3595),
    [anon_sym_using] = ACTIONS(3595),
    [anon_sym_unsafe] = ACTIONS(3595),
    [anon_sym_static] = ACTIONS(3595),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_LPAREN] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3595),
    [anon_sym_namespace] = ACTIONS(3595),
    [anon_sym_class] = ACTIONS(3595),
    [anon_sym_ref] = ACTIONS(3595),
    [anon_sym_struct] = ACTIONS(3595),
    [anon_sym_enum] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3595),
    [anon_sym_delegate] = ACTIONS(3595),
    [anon_sym_record] = ACTIONS(3595),
    [anon_sym_abstract] = ACTIONS(3595),
    [anon_sym_async] = ACTIONS(3595),
    [anon_sym_const] = ACTIONS(3595),
    [anon_sym_file] = ACTIONS(3595),
    [anon_sym_fixed] = ACTIONS(3595),
    [anon_sym_internal] = ACTIONS(3595),
    [anon_sym_new] = ACTIONS(3595),
    [anon_sym_override] = ACTIONS(3595),
    [anon_sym_partial] = ACTIONS(3595),
    [anon_sym_private] = ACTIONS(3595),
    [anon_sym_protected] = ACTIONS(3595),
    [anon_sym_public] = ACTIONS(3595),
    [anon_sym_readonly] = ACTIONS(3595),
    [anon_sym_required] = ACTIONS(3595),
    [anon_sym_sealed] = ACTIONS(3595),
    [anon_sym_virtual] = ACTIONS(3595),
    [anon_sym_volatile] = ACTIONS(3595),
    [anon_sym_where] = ACTIONS(3595),
    [anon_sym_notnull] = ACTIONS(3595),
    [anon_sym_unmanaged] = ACTIONS(3595),
    [anon_sym_checked] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_TILDE] = ACTIONS(3597),
    [anon_sym_PLUS_PLUS] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3597),
    [anon_sym_true] = ACTIONS(3595),
    [anon_sym_false] = ACTIONS(3595),
    [anon_sym_PLUS] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3595),
    [anon_sym_STAR] = ACTIONS(3597),
    [anon_sym_CARET] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_this] = ACTIONS(3595),
    [anon_sym_scoped] = ACTIONS(3595),
    [anon_sym_base] = ACTIONS(3595),
    [anon_sym_var] = ACTIONS(3595),
    [sym_predefined_type] = ACTIONS(3595),
    [anon_sym_break] = ACTIONS(3595),
    [anon_sym_unchecked] = ACTIONS(3595),
    [anon_sym_continue] = ACTIONS(3595),
    [anon_sym_do] = ACTIONS(3595),
    [anon_sym_while] = ACTIONS(3595),
    [anon_sym_for] = ACTIONS(3595),
    [anon_sym_lock] = ACTIONS(3595),
    [anon_sym_yield] = ACTIONS(3595),
    [anon_sym_switch] = ACTIONS(3595),
    [anon_sym_default] = ACTIONS(3595),
    [anon_sym_throw] = ACTIONS(3595),
    [anon_sym_try] = ACTIONS(3595),
    [anon_sym_when] = ACTIONS(3595),
    [anon_sym_await] = ACTIONS(3595),
    [anon_sym_foreach] = ACTIONS(3595),
    [anon_sym_goto] = ACTIONS(3595),
    [anon_sym_if] = ACTIONS(3595),
    [anon_sym_DOT_DOT] = ACTIONS(3597),
    [anon_sym_from] = ACTIONS(3595),
    [anon_sym_into] = ACTIONS(3595),
    [anon_sym_join] = ACTIONS(3595),
    [anon_sym_on] = ACTIONS(3595),
    [anon_sym_equals] = ACTIONS(3595),
    [anon_sym_let] = ACTIONS(3595),
    [anon_sym_orderby] = ACTIONS(3595),
    [anon_sym_ascending] = ACTIONS(3595),
    [anon_sym_descending] = ACTIONS(3595),
    [anon_sym_group] = ACTIONS(3595),
    [anon_sym_by] = ACTIONS(3595),
    [anon_sym_select] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3597),
    [anon_sym_stackalloc] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3595),
    [anon_sym_typeof] = ACTIONS(3595),
    [anon_sym___makeref] = ACTIONS(3595),
    [anon_sym___reftype] = ACTIONS(3595),
    [anon_sym___refvalue] = ACTIONS(3595),
    [sym_null_literal] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3597),
    [sym_integer_literal] = ACTIONS(3595),
    [sym_real_literal] = ACTIONS(3597),
    [sym_verbatim_string_literal] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token3] = ACTIONS(3597),
    [aux_sym_preproc_else_token1] = ACTIONS(3597),
    [aux_sym_preproc_elif_token1] = ACTIONS(3597),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3597),
    [sym_interpolation_verbatim_start] = ACTIONS(3597),
    [sym_interpolation_raw_start] = ACTIONS(3597),
    [sym_raw_string_start] = ACTIONS(3597),
  },
  [2356] = {
    [sym_preproc_region] = STATE(2356),
    [sym_preproc_endregion] = STATE(2356),
    [sym_preproc_line] = STATE(2356),
    [sym_preproc_pragma] = STATE(2356),
    [sym_preproc_nullable] = STATE(2356),
    [sym_preproc_error] = STATE(2356),
    [sym_preproc_define] = STATE(2356),
    [sym_preproc_undef] = STATE(2356),
    [sym__identifier_token] = ACTIONS(3599),
    [anon_sym_extern] = ACTIONS(3599),
    [anon_sym_alias] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_global] = ACTIONS(3599),
    [anon_sym_using] = ACTIONS(3599),
    [anon_sym_unsafe] = ACTIONS(3599),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_struct] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_delegate] = ACTIONS(3599),
    [anon_sym_record] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_file] = ACTIONS(3599),
    [anon_sym_fixed] = ACTIONS(3599),
    [anon_sym_internal] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_partial] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_required] = ACTIONS(3599),
    [anon_sym_sealed] = ACTIONS(3599),
    [anon_sym_virtual] = ACTIONS(3599),
    [anon_sym_volatile] = ACTIONS(3599),
    [anon_sym_where] = ACTIONS(3599),
    [anon_sym_notnull] = ACTIONS(3599),
    [anon_sym_unmanaged] = ACTIONS(3599),
    [anon_sym_checked] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_true] = ACTIONS(3599),
    [anon_sym_false] = ACTIONS(3599),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_CARET] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_this] = ACTIONS(3599),
    [anon_sym_scoped] = ACTIONS(3599),
    [anon_sym_base] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [sym_predefined_type] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_unchecked] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_lock] = ACTIONS(3599),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_default] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_when] = ACTIONS(3599),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_foreach] = ACTIONS(3599),
    [anon_sym_goto] = ACTIONS(3599),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_DOT_DOT] = ACTIONS(3601),
    [anon_sym_from] = ACTIONS(3599),
    [anon_sym_into] = ACTIONS(3599),
    [anon_sym_join] = ACTIONS(3599),
    [anon_sym_on] = ACTIONS(3599),
    [anon_sym_equals] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_orderby] = ACTIONS(3599),
    [anon_sym_ascending] = ACTIONS(3599),
    [anon_sym_descending] = ACTIONS(3599),
    [anon_sym_group] = ACTIONS(3599),
    [anon_sym_by] = ACTIONS(3599),
    [anon_sym_select] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_stackalloc] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym___makeref] = ACTIONS(3599),
    [anon_sym___reftype] = ACTIONS(3599),
    [anon_sym___refvalue] = ACTIONS(3599),
    [sym_null_literal] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_integer_literal] = ACTIONS(3599),
    [sym_real_literal] = ACTIONS(3601),
    [sym_verbatim_string_literal] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token3] = ACTIONS(3601),
    [aux_sym_preproc_else_token1] = ACTIONS(3601),
    [aux_sym_preproc_elif_token1] = ACTIONS(3601),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3601),
    [sym_interpolation_verbatim_start] = ACTIONS(3601),
    [sym_interpolation_raw_start] = ACTIONS(3601),
    [sym_raw_string_start] = ACTIONS(3601),
  },
  [2357] = {
    [sym_preproc_region] = STATE(2357),
    [sym_preproc_endregion] = STATE(2357),
    [sym_preproc_line] = STATE(2357),
    [sym_preproc_pragma] = STATE(2357),
    [sym_preproc_nullable] = STATE(2357),
    [sym_preproc_error] = STATE(2357),
    [sym_preproc_define] = STATE(2357),
    [sym_preproc_undef] = STATE(2357),
    [sym__identifier_token] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym_alias] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym_global] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_unsafe] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_ref] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_delegate] = ACTIONS(3603),
    [anon_sym_record] = ACTIONS(3603),
    [anon_sym_abstract] = ACTIONS(3603),
    [anon_sym_async] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_file] = ACTIONS(3603),
    [anon_sym_fixed] = ACTIONS(3603),
    [anon_sym_internal] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_override] = ACTIONS(3603),
    [anon_sym_partial] = ACTIONS(3603),
    [anon_sym_private] = ACTIONS(3603),
    [anon_sym_protected] = ACTIONS(3603),
    [anon_sym_public] = ACTIONS(3603),
    [anon_sym_readonly] = ACTIONS(3603),
    [anon_sym_required] = ACTIONS(3603),
    [anon_sym_sealed] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_where] = ACTIONS(3603),
    [anon_sym_notnull] = ACTIONS(3603),
    [anon_sym_unmanaged] = ACTIONS(3603),
    [anon_sym_checked] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_true] = ACTIONS(3603),
    [anon_sym_false] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_CARET] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_this] = ACTIONS(3603),
    [anon_sym_scoped] = ACTIONS(3603),
    [anon_sym_base] = ACTIONS(3603),
    [anon_sym_var] = ACTIONS(3603),
    [sym_predefined_type] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_unchecked] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_lock] = ACTIONS(3603),
    [anon_sym_yield] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_when] = ACTIONS(3603),
    [anon_sym_await] = ACTIONS(3603),
    [anon_sym_foreach] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_DOT_DOT] = ACTIONS(3605),
    [anon_sym_from] = ACTIONS(3603),
    [anon_sym_into] = ACTIONS(3603),
    [anon_sym_join] = ACTIONS(3603),
    [anon_sym_on] = ACTIONS(3603),
    [anon_sym_equals] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_orderby] = ACTIONS(3603),
    [anon_sym_ascending] = ACTIONS(3603),
    [anon_sym_descending] = ACTIONS(3603),
    [anon_sym_group] = ACTIONS(3603),
    [anon_sym_by] = ACTIONS(3603),
    [anon_sym_select] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [anon_sym_stackalloc] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym_typeof] = ACTIONS(3603),
    [anon_sym___makeref] = ACTIONS(3603),
    [anon_sym___reftype] = ACTIONS(3603),
    [anon_sym___refvalue] = ACTIONS(3603),
    [sym_null_literal] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [sym_integer_literal] = ACTIONS(3603),
    [sym_real_literal] = ACTIONS(3605),
    [sym_verbatim_string_literal] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token3] = ACTIONS(3605),
    [aux_sym_preproc_else_token1] = ACTIONS(3605),
    [aux_sym_preproc_elif_token1] = ACTIONS(3605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3605),
    [sym_interpolation_verbatim_start] = ACTIONS(3605),
    [sym_interpolation_raw_start] = ACTIONS(3605),
    [sym_raw_string_start] = ACTIONS(3605),
  },
  [2358] = {
    [sym_preproc_region] = STATE(2358),
    [sym_preproc_endregion] = STATE(2358),
    [sym_preproc_line] = STATE(2358),
    [sym_preproc_pragma] = STATE(2358),
    [sym_preproc_nullable] = STATE(2358),
    [sym_preproc_error] = STATE(2358),
    [sym_preproc_define] = STATE(2358),
    [sym_preproc_undef] = STATE(2358),
    [sym__identifier_token] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym_alias] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_global] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_unsafe] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_ref] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_delegate] = ACTIONS(3607),
    [anon_sym_record] = ACTIONS(3607),
    [anon_sym_abstract] = ACTIONS(3607),
    [anon_sym_async] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_file] = ACTIONS(3607),
    [anon_sym_fixed] = ACTIONS(3607),
    [anon_sym_internal] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_override] = ACTIONS(3607),
    [anon_sym_partial] = ACTIONS(3607),
    [anon_sym_private] = ACTIONS(3607),
    [anon_sym_protected] = ACTIONS(3607),
    [anon_sym_public] = ACTIONS(3607),
    [anon_sym_readonly] = ACTIONS(3607),
    [anon_sym_required] = ACTIONS(3607),
    [anon_sym_sealed] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_where] = ACTIONS(3607),
    [anon_sym_notnull] = ACTIONS(3607),
    [anon_sym_unmanaged] = ACTIONS(3607),
    [anon_sym_checked] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_true] = ACTIONS(3607),
    [anon_sym_false] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_this] = ACTIONS(3607),
    [anon_sym_scoped] = ACTIONS(3607),
    [anon_sym_base] = ACTIONS(3607),
    [anon_sym_var] = ACTIONS(3607),
    [sym_predefined_type] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_unchecked] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_lock] = ACTIONS(3607),
    [anon_sym_yield] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_when] = ACTIONS(3607),
    [anon_sym_await] = ACTIONS(3607),
    [anon_sym_foreach] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_DOT_DOT] = ACTIONS(3609),
    [anon_sym_from] = ACTIONS(3607),
    [anon_sym_into] = ACTIONS(3607),
    [anon_sym_join] = ACTIONS(3607),
    [anon_sym_on] = ACTIONS(3607),
    [anon_sym_equals] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_orderby] = ACTIONS(3607),
    [anon_sym_ascending] = ACTIONS(3607),
    [anon_sym_descending] = ACTIONS(3607),
    [anon_sym_group] = ACTIONS(3607),
    [anon_sym_by] = ACTIONS(3607),
    [anon_sym_select] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [anon_sym_stackalloc] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym_typeof] = ACTIONS(3607),
    [anon_sym___makeref] = ACTIONS(3607),
    [anon_sym___reftype] = ACTIONS(3607),
    [anon_sym___refvalue] = ACTIONS(3607),
    [sym_null_literal] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [sym_integer_literal] = ACTIONS(3607),
    [sym_real_literal] = ACTIONS(3609),
    [sym_verbatim_string_literal] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token3] = ACTIONS(3609),
    [aux_sym_preproc_else_token1] = ACTIONS(3609),
    [aux_sym_preproc_elif_token1] = ACTIONS(3609),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3609),
    [sym_interpolation_verbatim_start] = ACTIONS(3609),
    [sym_interpolation_raw_start] = ACTIONS(3609),
    [sym_raw_string_start] = ACTIONS(3609),
  },
  [2359] = {
    [sym_preproc_region] = STATE(2359),
    [sym_preproc_endregion] = STATE(2359),
    [sym_preproc_line] = STATE(2359),
    [sym_preproc_pragma] = STATE(2359),
    [sym_preproc_nullable] = STATE(2359),
    [sym_preproc_error] = STATE(2359),
    [sym_preproc_define] = STATE(2359),
    [sym_preproc_undef] = STATE(2359),
    [sym__identifier_token] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym_alias] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_global] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_unsafe] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_ref] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_delegate] = ACTIONS(3611),
    [anon_sym_record] = ACTIONS(3611),
    [anon_sym_abstract] = ACTIONS(3611),
    [anon_sym_async] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_file] = ACTIONS(3611),
    [anon_sym_fixed] = ACTIONS(3611),
    [anon_sym_internal] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_override] = ACTIONS(3611),
    [anon_sym_partial] = ACTIONS(3611),
    [anon_sym_private] = ACTIONS(3611),
    [anon_sym_protected] = ACTIONS(3611),
    [anon_sym_public] = ACTIONS(3611),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_required] = ACTIONS(3611),
    [anon_sym_sealed] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_where] = ACTIONS(3611),
    [anon_sym_notnull] = ACTIONS(3611),
    [anon_sym_unmanaged] = ACTIONS(3611),
    [anon_sym_checked] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_true] = ACTIONS(3611),
    [anon_sym_false] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_CARET] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_this] = ACTIONS(3611),
    [anon_sym_scoped] = ACTIONS(3611),
    [anon_sym_base] = ACTIONS(3611),
    [anon_sym_var] = ACTIONS(3611),
    [sym_predefined_type] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_unchecked] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_lock] = ACTIONS(3611),
    [anon_sym_yield] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_when] = ACTIONS(3611),
    [anon_sym_await] = ACTIONS(3611),
    [anon_sym_foreach] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_DOT_DOT] = ACTIONS(3613),
    [anon_sym_from] = ACTIONS(3611),
    [anon_sym_into] = ACTIONS(3611),
    [anon_sym_join] = ACTIONS(3611),
    [anon_sym_on] = ACTIONS(3611),
    [anon_sym_equals] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_orderby] = ACTIONS(3611),
    [anon_sym_ascending] = ACTIONS(3611),
    [anon_sym_descending] = ACTIONS(3611),
    [anon_sym_group] = ACTIONS(3611),
    [anon_sym_by] = ACTIONS(3611),
    [anon_sym_select] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [anon_sym_stackalloc] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym_typeof] = ACTIONS(3611),
    [anon_sym___makeref] = ACTIONS(3611),
    [anon_sym___reftype] = ACTIONS(3611),
    [anon_sym___refvalue] = ACTIONS(3611),
    [sym_null_literal] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [sym_integer_literal] = ACTIONS(3611),
    [sym_real_literal] = ACTIONS(3613),
    [sym_verbatim_string_literal] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token3] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3613),
    [sym_interpolation_verbatim_start] = ACTIONS(3613),
    [sym_interpolation_raw_start] = ACTIONS(3613),
    [sym_raw_string_start] = ACTIONS(3613),
  },
  [2360] = {
    [sym_preproc_region] = STATE(2360),
    [sym_preproc_endregion] = STATE(2360),
    [sym_preproc_line] = STATE(2360),
    [sym_preproc_pragma] = STATE(2360),
    [sym_preproc_nullable] = STATE(2360),
    [sym_preproc_error] = STATE(2360),
    [sym_preproc_define] = STATE(2360),
    [sym_preproc_undef] = STATE(2360),
    [sym__identifier_token] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_unsafe] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_ref] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_delegate] = ACTIONS(3615),
    [anon_sym_record] = ACTIONS(3615),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_async] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_fixed] = ACTIONS(3615),
    [anon_sym_internal] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_override] = ACTIONS(3615),
    [anon_sym_partial] = ACTIONS(3615),
    [anon_sym_private] = ACTIONS(3615),
    [anon_sym_protected] = ACTIONS(3615),
    [anon_sym_public] = ACTIONS(3615),
    [anon_sym_readonly] = ACTIONS(3615),
    [anon_sym_required] = ACTIONS(3615),
    [anon_sym_sealed] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_checked] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3615),
    [anon_sym_false] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_this] = ACTIONS(3615),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_base] = ACTIONS(3615),
    [anon_sym_var] = ACTIONS(3615),
    [sym_predefined_type] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_unchecked] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_lock] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_await] = ACTIONS(3615),
    [anon_sym_foreach] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_DOT_DOT] = ACTIONS(3617),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [anon_sym_stackalloc] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym_typeof] = ACTIONS(3615),
    [anon_sym___makeref] = ACTIONS(3615),
    [anon_sym___reftype] = ACTIONS(3615),
    [anon_sym___refvalue] = ACTIONS(3615),
    [sym_null_literal] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [sym_integer_literal] = ACTIONS(3615),
    [sym_real_literal] = ACTIONS(3617),
    [sym_verbatim_string_literal] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token3] = ACTIONS(3617),
    [aux_sym_preproc_else_token1] = ACTIONS(3617),
    [aux_sym_preproc_elif_token1] = ACTIONS(3617),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3617),
    [sym_interpolation_verbatim_start] = ACTIONS(3617),
    [sym_interpolation_raw_start] = ACTIONS(3617),
    [sym_raw_string_start] = ACTIONS(3617),
  },
  [2361] = {
    [sym_preproc_region] = STATE(2361),
    [sym_preproc_endregion] = STATE(2361),
    [sym_preproc_line] = STATE(2361),
    [sym_preproc_pragma] = STATE(2361),
    [sym_preproc_nullable] = STATE(2361),
    [sym_preproc_error] = STATE(2361),
    [sym_preproc_define] = STATE(2361),
    [sym_preproc_undef] = STATE(2361),
    [sym__identifier_token] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym_alias] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_global] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_unsafe] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_ref] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_delegate] = ACTIONS(3619),
    [anon_sym_record] = ACTIONS(3619),
    [anon_sym_abstract] = ACTIONS(3619),
    [anon_sym_async] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_file] = ACTIONS(3619),
    [anon_sym_fixed] = ACTIONS(3619),
    [anon_sym_internal] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_override] = ACTIONS(3619),
    [anon_sym_partial] = ACTIONS(3619),
    [anon_sym_private] = ACTIONS(3619),
    [anon_sym_protected] = ACTIONS(3619),
    [anon_sym_public] = ACTIONS(3619),
    [anon_sym_readonly] = ACTIONS(3619),
    [anon_sym_required] = ACTIONS(3619),
    [anon_sym_sealed] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_where] = ACTIONS(3619),
    [anon_sym_notnull] = ACTIONS(3619),
    [anon_sym_unmanaged] = ACTIONS(3619),
    [anon_sym_checked] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_true] = ACTIONS(3619),
    [anon_sym_false] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_CARET] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_this] = ACTIONS(3619),
    [anon_sym_scoped] = ACTIONS(3619),
    [anon_sym_base] = ACTIONS(3619),
    [anon_sym_var] = ACTIONS(3619),
    [sym_predefined_type] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_unchecked] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_lock] = ACTIONS(3619),
    [anon_sym_yield] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_when] = ACTIONS(3619),
    [anon_sym_await] = ACTIONS(3619),
    [anon_sym_foreach] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_DOT_DOT] = ACTIONS(3621),
    [anon_sym_from] = ACTIONS(3619),
    [anon_sym_into] = ACTIONS(3619),
    [anon_sym_join] = ACTIONS(3619),
    [anon_sym_on] = ACTIONS(3619),
    [anon_sym_equals] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_orderby] = ACTIONS(3619),
    [anon_sym_ascending] = ACTIONS(3619),
    [anon_sym_descending] = ACTIONS(3619),
    [anon_sym_group] = ACTIONS(3619),
    [anon_sym_by] = ACTIONS(3619),
    [anon_sym_select] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_stackalloc] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym_typeof] = ACTIONS(3619),
    [anon_sym___makeref] = ACTIONS(3619),
    [anon_sym___reftype] = ACTIONS(3619),
    [anon_sym___refvalue] = ACTIONS(3619),
    [sym_null_literal] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [sym_integer_literal] = ACTIONS(3619),
    [sym_real_literal] = ACTIONS(3621),
    [sym_verbatim_string_literal] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token3] = ACTIONS(3621),
    [aux_sym_preproc_else_token1] = ACTIONS(3621),
    [aux_sym_preproc_elif_token1] = ACTIONS(3621),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3621),
    [sym_interpolation_verbatim_start] = ACTIONS(3621),
    [sym_interpolation_raw_start] = ACTIONS(3621),
    [sym_raw_string_start] = ACTIONS(3621),
  },
  [2362] = {
    [sym_preproc_region] = STATE(2362),
    [sym_preproc_endregion] = STATE(2362),
    [sym_preproc_line] = STATE(2362),
    [sym_preproc_pragma] = STATE(2362),
    [sym_preproc_nullable] = STATE(2362),
    [sym_preproc_error] = STATE(2362),
    [sym_preproc_define] = STATE(2362),
    [sym_preproc_undef] = STATE(2362),
    [sym__identifier_token] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym_alias] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym_global] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_unsafe] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_LPAREN] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_ref] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_delegate] = ACTIONS(3623),
    [anon_sym_record] = ACTIONS(3623),
    [anon_sym_abstract] = ACTIONS(3623),
    [anon_sym_async] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_file] = ACTIONS(3623),
    [anon_sym_fixed] = ACTIONS(3623),
    [anon_sym_internal] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_override] = ACTIONS(3623),
    [anon_sym_partial] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_readonly] = ACTIONS(3623),
    [anon_sym_required] = ACTIONS(3623),
    [anon_sym_sealed] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_where] = ACTIONS(3623),
    [anon_sym_notnull] = ACTIONS(3623),
    [anon_sym_unmanaged] = ACTIONS(3623),
    [anon_sym_checked] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_true] = ACTIONS(3623),
    [anon_sym_false] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_CARET] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_this] = ACTIONS(3623),
    [anon_sym_scoped] = ACTIONS(3623),
    [anon_sym_base] = ACTIONS(3623),
    [anon_sym_var] = ACTIONS(3623),
    [sym_predefined_type] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_unchecked] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_lock] = ACTIONS(3623),
    [anon_sym_yield] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_when] = ACTIONS(3623),
    [anon_sym_await] = ACTIONS(3623),
    [anon_sym_foreach] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3625),
    [anon_sym_from] = ACTIONS(3623),
    [anon_sym_into] = ACTIONS(3623),
    [anon_sym_join] = ACTIONS(3623),
    [anon_sym_on] = ACTIONS(3623),
    [anon_sym_equals] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_orderby] = ACTIONS(3623),
    [anon_sym_ascending] = ACTIONS(3623),
    [anon_sym_descending] = ACTIONS(3623),
    [anon_sym_group] = ACTIONS(3623),
    [anon_sym_by] = ACTIONS(3623),
    [anon_sym_select] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [anon_sym_stackalloc] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym_typeof] = ACTIONS(3623),
    [anon_sym___makeref] = ACTIONS(3623),
    [anon_sym___reftype] = ACTIONS(3623),
    [anon_sym___refvalue] = ACTIONS(3623),
    [sym_null_literal] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [sym_integer_literal] = ACTIONS(3623),
    [sym_real_literal] = ACTIONS(3625),
    [sym_verbatim_string_literal] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token3] = ACTIONS(3625),
    [aux_sym_preproc_else_token1] = ACTIONS(3625),
    [aux_sym_preproc_elif_token1] = ACTIONS(3625),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3625),
    [sym_interpolation_verbatim_start] = ACTIONS(3625),
    [sym_interpolation_raw_start] = ACTIONS(3625),
    [sym_raw_string_start] = ACTIONS(3625),
  },
  [2363] = {
    [sym_preproc_region] = STATE(2363),
    [sym_preproc_endregion] = STATE(2363),
    [sym_preproc_line] = STATE(2363),
    [sym_preproc_pragma] = STATE(2363),
    [sym_preproc_nullable] = STATE(2363),
    [sym_preproc_error] = STATE(2363),
    [sym_preproc_define] = STATE(2363),
    [sym_preproc_undef] = STATE(2363),
    [sym__identifier_token] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_alias] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_global] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_unsafe] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_ref] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_delegate] = ACTIONS(3627),
    [anon_sym_record] = ACTIONS(3627),
    [anon_sym_abstract] = ACTIONS(3627),
    [anon_sym_async] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_file] = ACTIONS(3627),
    [anon_sym_fixed] = ACTIONS(3627),
    [anon_sym_internal] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_override] = ACTIONS(3627),
    [anon_sym_partial] = ACTIONS(3627),
    [anon_sym_private] = ACTIONS(3627),
    [anon_sym_protected] = ACTIONS(3627),
    [anon_sym_public] = ACTIONS(3627),
    [anon_sym_readonly] = ACTIONS(3627),
    [anon_sym_required] = ACTIONS(3627),
    [anon_sym_sealed] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_where] = ACTIONS(3627),
    [anon_sym_notnull] = ACTIONS(3627),
    [anon_sym_unmanaged] = ACTIONS(3627),
    [anon_sym_checked] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_true] = ACTIONS(3627),
    [anon_sym_false] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_CARET] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_this] = ACTIONS(3627),
    [anon_sym_scoped] = ACTIONS(3627),
    [anon_sym_base] = ACTIONS(3627),
    [anon_sym_var] = ACTIONS(3627),
    [sym_predefined_type] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_unchecked] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_lock] = ACTIONS(3627),
    [anon_sym_yield] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_when] = ACTIONS(3627),
    [anon_sym_await] = ACTIONS(3627),
    [anon_sym_foreach] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_DOT_DOT] = ACTIONS(3629),
    [anon_sym_from] = ACTIONS(3627),
    [anon_sym_into] = ACTIONS(3627),
    [anon_sym_join] = ACTIONS(3627),
    [anon_sym_on] = ACTIONS(3627),
    [anon_sym_equals] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_orderby] = ACTIONS(3627),
    [anon_sym_ascending] = ACTIONS(3627),
    [anon_sym_descending] = ACTIONS(3627),
    [anon_sym_group] = ACTIONS(3627),
    [anon_sym_by] = ACTIONS(3627),
    [anon_sym_select] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_stackalloc] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym___makeref] = ACTIONS(3627),
    [anon_sym___reftype] = ACTIONS(3627),
    [anon_sym___refvalue] = ACTIONS(3627),
    [sym_null_literal] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [sym_integer_literal] = ACTIONS(3627),
    [sym_real_literal] = ACTIONS(3629),
    [sym_verbatim_string_literal] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token3] = ACTIONS(3629),
    [aux_sym_preproc_else_token1] = ACTIONS(3629),
    [aux_sym_preproc_elif_token1] = ACTIONS(3629),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3629),
    [sym_interpolation_verbatim_start] = ACTIONS(3629),
    [sym_interpolation_raw_start] = ACTIONS(3629),
    [sym_raw_string_start] = ACTIONS(3629),
  },
  [2364] = {
    [sym_preproc_region] = STATE(2364),
    [sym_preproc_endregion] = STATE(2364),
    [sym_preproc_line] = STATE(2364),
    [sym_preproc_pragma] = STATE(2364),
    [sym_preproc_nullable] = STATE(2364),
    [sym_preproc_error] = STATE(2364),
    [sym_preproc_define] = STATE(2364),
    [sym_preproc_undef] = STATE(2364),
    [sym__identifier_token] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym_alias] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_unsafe] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_ref] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_delegate] = ACTIONS(3631),
    [anon_sym_record] = ACTIONS(3631),
    [anon_sym_abstract] = ACTIONS(3631),
    [anon_sym_async] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_file] = ACTIONS(3631),
    [anon_sym_fixed] = ACTIONS(3631),
    [anon_sym_internal] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_override] = ACTIONS(3631),
    [anon_sym_partial] = ACTIONS(3631),
    [anon_sym_private] = ACTIONS(3631),
    [anon_sym_protected] = ACTIONS(3631),
    [anon_sym_public] = ACTIONS(3631),
    [anon_sym_readonly] = ACTIONS(3631),
    [anon_sym_required] = ACTIONS(3631),
    [anon_sym_sealed] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_notnull] = ACTIONS(3631),
    [anon_sym_unmanaged] = ACTIONS(3631),
    [anon_sym_checked] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_true] = ACTIONS(3631),
    [anon_sym_false] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_this] = ACTIONS(3631),
    [anon_sym_scoped] = ACTIONS(3631),
    [anon_sym_base] = ACTIONS(3631),
    [anon_sym_var] = ACTIONS(3631),
    [sym_predefined_type] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_unchecked] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_lock] = ACTIONS(3631),
    [anon_sym_yield] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_when] = ACTIONS(3631),
    [anon_sym_await] = ACTIONS(3631),
    [anon_sym_foreach] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_DOT_DOT] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3631),
    [anon_sym_into] = ACTIONS(3631),
    [anon_sym_join] = ACTIONS(3631),
    [anon_sym_on] = ACTIONS(3631),
    [anon_sym_equals] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_orderby] = ACTIONS(3631),
    [anon_sym_ascending] = ACTIONS(3631),
    [anon_sym_descending] = ACTIONS(3631),
    [anon_sym_group] = ACTIONS(3631),
    [anon_sym_by] = ACTIONS(3631),
    [anon_sym_select] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [anon_sym_stackalloc] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym_typeof] = ACTIONS(3631),
    [anon_sym___makeref] = ACTIONS(3631),
    [anon_sym___reftype] = ACTIONS(3631),
    [anon_sym___refvalue] = ACTIONS(3631),
    [sym_null_literal] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [sym_integer_literal] = ACTIONS(3631),
    [sym_real_literal] = ACTIONS(3633),
    [sym_verbatim_string_literal] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3633),
    [aux_sym_preproc_else_token1] = ACTIONS(3633),
    [aux_sym_preproc_elif_token1] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3633),
    [sym_interpolation_verbatim_start] = ACTIONS(3633),
    [sym_interpolation_raw_start] = ACTIONS(3633),
    [sym_raw_string_start] = ACTIONS(3633),
  },
  [2365] = {
    [sym_preproc_region] = STATE(2365),
    [sym_preproc_endregion] = STATE(2365),
    [sym_preproc_line] = STATE(2365),
    [sym_preproc_pragma] = STATE(2365),
    [sym_preproc_nullable] = STATE(2365),
    [sym_preproc_error] = STATE(2365),
    [sym_preproc_define] = STATE(2365),
    [sym_preproc_undef] = STATE(2365),
    [sym__identifier_token] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym_alias] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_global] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_unsafe] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_ref] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_delegate] = ACTIONS(3635),
    [anon_sym_record] = ACTIONS(3635),
    [anon_sym_abstract] = ACTIONS(3635),
    [anon_sym_async] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_file] = ACTIONS(3635),
    [anon_sym_fixed] = ACTIONS(3635),
    [anon_sym_internal] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_override] = ACTIONS(3635),
    [anon_sym_partial] = ACTIONS(3635),
    [anon_sym_private] = ACTIONS(3635),
    [anon_sym_protected] = ACTIONS(3635),
    [anon_sym_public] = ACTIONS(3635),
    [anon_sym_readonly] = ACTIONS(3635),
    [anon_sym_required] = ACTIONS(3635),
    [anon_sym_sealed] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_where] = ACTIONS(3635),
    [anon_sym_notnull] = ACTIONS(3635),
    [anon_sym_unmanaged] = ACTIONS(3635),
    [anon_sym_checked] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [anon_sym_true] = ACTIONS(3635),
    [anon_sym_false] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3637),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_this] = ACTIONS(3635),
    [anon_sym_scoped] = ACTIONS(3635),
    [anon_sym_base] = ACTIONS(3635),
    [anon_sym_var] = ACTIONS(3635),
    [sym_predefined_type] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_unchecked] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_lock] = ACTIONS(3635),
    [anon_sym_yield] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_when] = ACTIONS(3635),
    [anon_sym_await] = ACTIONS(3635),
    [anon_sym_foreach] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_DOT_DOT] = ACTIONS(3637),
    [anon_sym_from] = ACTIONS(3635),
    [anon_sym_into] = ACTIONS(3635),
    [anon_sym_join] = ACTIONS(3635),
    [anon_sym_on] = ACTIONS(3635),
    [anon_sym_equals] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_orderby] = ACTIONS(3635),
    [anon_sym_ascending] = ACTIONS(3635),
    [anon_sym_descending] = ACTIONS(3635),
    [anon_sym_group] = ACTIONS(3635),
    [anon_sym_by] = ACTIONS(3635),
    [anon_sym_select] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3637),
    [anon_sym_stackalloc] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym_typeof] = ACTIONS(3635),
    [anon_sym___makeref] = ACTIONS(3635),
    [anon_sym___reftype] = ACTIONS(3635),
    [anon_sym___refvalue] = ACTIONS(3635),
    [sym_null_literal] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3637),
    [sym_integer_literal] = ACTIONS(3635),
    [sym_real_literal] = ACTIONS(3637),
    [sym_verbatim_string_literal] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token3] = ACTIONS(3637),
    [aux_sym_preproc_else_token1] = ACTIONS(3637),
    [aux_sym_preproc_elif_token1] = ACTIONS(3637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3637),
    [sym_interpolation_verbatim_start] = ACTIONS(3637),
    [sym_interpolation_raw_start] = ACTIONS(3637),
    [sym_raw_string_start] = ACTIONS(3637),
  },
  [2366] = {
    [sym_preproc_region] = STATE(2366),
    [sym_preproc_endregion] = STATE(2366),
    [sym_preproc_line] = STATE(2366),
    [sym_preproc_pragma] = STATE(2366),
    [sym_preproc_nullable] = STATE(2366),
    [sym_preproc_error] = STATE(2366),
    [sym_preproc_define] = STATE(2366),
    [sym_preproc_undef] = STATE(2366),
    [sym__identifier_token] = ACTIONS(3639),
    [anon_sym_extern] = ACTIONS(3639),
    [anon_sym_alias] = ACTIONS(3639),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_global] = ACTIONS(3639),
    [anon_sym_using] = ACTIONS(3639),
    [anon_sym_unsafe] = ACTIONS(3639),
    [anon_sym_static] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3639),
    [anon_sym_namespace] = ACTIONS(3639),
    [anon_sym_class] = ACTIONS(3639),
    [anon_sym_ref] = ACTIONS(3639),
    [anon_sym_struct] = ACTIONS(3639),
    [anon_sym_enum] = ACTIONS(3639),
    [anon_sym_LBRACE] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3639),
    [anon_sym_delegate] = ACTIONS(3639),
    [anon_sym_record] = ACTIONS(3639),
    [anon_sym_abstract] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_const] = ACTIONS(3639),
    [anon_sym_file] = ACTIONS(3639),
    [anon_sym_fixed] = ACTIONS(3639),
    [anon_sym_internal] = ACTIONS(3639),
    [anon_sym_new] = ACTIONS(3639),
    [anon_sym_override] = ACTIONS(3639),
    [anon_sym_partial] = ACTIONS(3639),
    [anon_sym_private] = ACTIONS(3639),
    [anon_sym_protected] = ACTIONS(3639),
    [anon_sym_public] = ACTIONS(3639),
    [anon_sym_readonly] = ACTIONS(3639),
    [anon_sym_required] = ACTIONS(3639),
    [anon_sym_sealed] = ACTIONS(3639),
    [anon_sym_virtual] = ACTIONS(3639),
    [anon_sym_volatile] = ACTIONS(3639),
    [anon_sym_where] = ACTIONS(3639),
    [anon_sym_notnull] = ACTIONS(3639),
    [anon_sym_unmanaged] = ACTIONS(3639),
    [anon_sym_checked] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_true] = ACTIONS(3639),
    [anon_sym_false] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_this] = ACTIONS(3639),
    [anon_sym_scoped] = ACTIONS(3639),
    [anon_sym_base] = ACTIONS(3639),
    [anon_sym_var] = ACTIONS(3639),
    [sym_predefined_type] = ACTIONS(3639),
    [anon_sym_break] = ACTIONS(3639),
    [anon_sym_unchecked] = ACTIONS(3639),
    [anon_sym_continue] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3639),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_for] = ACTIONS(3639),
    [anon_sym_lock] = ACTIONS(3639),
    [anon_sym_yield] = ACTIONS(3639),
    [anon_sym_switch] = ACTIONS(3639),
    [anon_sym_default] = ACTIONS(3639),
    [anon_sym_throw] = ACTIONS(3639),
    [anon_sym_try] = ACTIONS(3639),
    [anon_sym_when] = ACTIONS(3639),
    [anon_sym_await] = ACTIONS(3639),
    [anon_sym_foreach] = ACTIONS(3639),
    [anon_sym_goto] = ACTIONS(3639),
    [anon_sym_if] = ACTIONS(3639),
    [anon_sym_DOT_DOT] = ACTIONS(3641),
    [anon_sym_from] = ACTIONS(3639),
    [anon_sym_into] = ACTIONS(3639),
    [anon_sym_join] = ACTIONS(3639),
    [anon_sym_on] = ACTIONS(3639),
    [anon_sym_equals] = ACTIONS(3639),
    [anon_sym_let] = ACTIONS(3639),
    [anon_sym_orderby] = ACTIONS(3639),
    [anon_sym_ascending] = ACTIONS(3639),
    [anon_sym_descending] = ACTIONS(3639),
    [anon_sym_group] = ACTIONS(3639),
    [anon_sym_by] = ACTIONS(3639),
    [anon_sym_select] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3641),
    [anon_sym_stackalloc] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3639),
    [anon_sym_typeof] = ACTIONS(3639),
    [anon_sym___makeref] = ACTIONS(3639),
    [anon_sym___reftype] = ACTIONS(3639),
    [anon_sym___refvalue] = ACTIONS(3639),
    [sym_null_literal] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3641),
    [sym_integer_literal] = ACTIONS(3639),
    [sym_real_literal] = ACTIONS(3641),
    [sym_verbatim_string_literal] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token3] = ACTIONS(3641),
    [aux_sym_preproc_else_token1] = ACTIONS(3641),
    [aux_sym_preproc_elif_token1] = ACTIONS(3641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3641),
    [sym_interpolation_verbatim_start] = ACTIONS(3641),
    [sym_interpolation_raw_start] = ACTIONS(3641),
    [sym_raw_string_start] = ACTIONS(3641),
  },
  [2367] = {
    [sym_preproc_region] = STATE(2367),
    [sym_preproc_endregion] = STATE(2367),
    [sym_preproc_line] = STATE(2367),
    [sym_preproc_pragma] = STATE(2367),
    [sym_preproc_nullable] = STATE(2367),
    [sym_preproc_error] = STATE(2367),
    [sym_preproc_define] = STATE(2367),
    [sym_preproc_undef] = STATE(2367),
    [sym__identifier_token] = ACTIONS(3643),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym_alias] = ACTIONS(3643),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_global] = ACTIONS(3643),
    [anon_sym_using] = ACTIONS(3643),
    [anon_sym_unsafe] = ACTIONS(3643),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3643),
    [anon_sym_namespace] = ACTIONS(3643),
    [anon_sym_class] = ACTIONS(3643),
    [anon_sym_ref] = ACTIONS(3643),
    [anon_sym_struct] = ACTIONS(3643),
    [anon_sym_enum] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3643),
    [anon_sym_delegate] = ACTIONS(3643),
    [anon_sym_record] = ACTIONS(3643),
    [anon_sym_abstract] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3643),
    [anon_sym_file] = ACTIONS(3643),
    [anon_sym_fixed] = ACTIONS(3643),
    [anon_sym_internal] = ACTIONS(3643),
    [anon_sym_new] = ACTIONS(3643),
    [anon_sym_override] = ACTIONS(3643),
    [anon_sym_partial] = ACTIONS(3643),
    [anon_sym_private] = ACTIONS(3643),
    [anon_sym_protected] = ACTIONS(3643),
    [anon_sym_public] = ACTIONS(3643),
    [anon_sym_readonly] = ACTIONS(3643),
    [anon_sym_required] = ACTIONS(3643),
    [anon_sym_sealed] = ACTIONS(3643),
    [anon_sym_virtual] = ACTIONS(3643),
    [anon_sym_volatile] = ACTIONS(3643),
    [anon_sym_where] = ACTIONS(3643),
    [anon_sym_notnull] = ACTIONS(3643),
    [anon_sym_unmanaged] = ACTIONS(3643),
    [anon_sym_checked] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3645),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [anon_sym_true] = ACTIONS(3643),
    [anon_sym_false] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3645),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_this] = ACTIONS(3643),
    [anon_sym_scoped] = ACTIONS(3643),
    [anon_sym_base] = ACTIONS(3643),
    [anon_sym_var] = ACTIONS(3643),
    [sym_predefined_type] = ACTIONS(3643),
    [anon_sym_break] = ACTIONS(3643),
    [anon_sym_unchecked] = ACTIONS(3643),
    [anon_sym_continue] = ACTIONS(3643),
    [anon_sym_do] = ACTIONS(3643),
    [anon_sym_while] = ACTIONS(3643),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_lock] = ACTIONS(3643),
    [anon_sym_yield] = ACTIONS(3643),
    [anon_sym_switch] = ACTIONS(3643),
    [anon_sym_default] = ACTIONS(3643),
    [anon_sym_throw] = ACTIONS(3643),
    [anon_sym_try] = ACTIONS(3643),
    [anon_sym_when] = ACTIONS(3643),
    [anon_sym_await] = ACTIONS(3643),
    [anon_sym_foreach] = ACTIONS(3643),
    [anon_sym_goto] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(3643),
    [anon_sym_DOT_DOT] = ACTIONS(3645),
    [anon_sym_from] = ACTIONS(3643),
    [anon_sym_into] = ACTIONS(3643),
    [anon_sym_join] = ACTIONS(3643),
    [anon_sym_on] = ACTIONS(3643),
    [anon_sym_equals] = ACTIONS(3643),
    [anon_sym_let] = ACTIONS(3643),
    [anon_sym_orderby] = ACTIONS(3643),
    [anon_sym_ascending] = ACTIONS(3643),
    [anon_sym_descending] = ACTIONS(3643),
    [anon_sym_group] = ACTIONS(3643),
    [anon_sym_by] = ACTIONS(3643),
    [anon_sym_select] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_stackalloc] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3643),
    [anon_sym_typeof] = ACTIONS(3643),
    [anon_sym___makeref] = ACTIONS(3643),
    [anon_sym___reftype] = ACTIONS(3643),
    [anon_sym___refvalue] = ACTIONS(3643),
    [sym_null_literal] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3645),
    [sym_integer_literal] = ACTIONS(3643),
    [sym_real_literal] = ACTIONS(3645),
    [sym_verbatim_string_literal] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token3] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3645),
    [sym_interpolation_verbatim_start] = ACTIONS(3645),
    [sym_interpolation_raw_start] = ACTIONS(3645),
    [sym_raw_string_start] = ACTIONS(3645),
  },
  [2368] = {
    [sym_preproc_region] = STATE(2368),
    [sym_preproc_endregion] = STATE(2368),
    [sym_preproc_line] = STATE(2368),
    [sym_preproc_pragma] = STATE(2368),
    [sym_preproc_nullable] = STATE(2368),
    [sym_preproc_error] = STATE(2368),
    [sym_preproc_define] = STATE(2368),
    [sym_preproc_undef] = STATE(2368),
    [sym__identifier_token] = ACTIONS(3647),
    [anon_sym_extern] = ACTIONS(3647),
    [anon_sym_alias] = ACTIONS(3647),
    [anon_sym_SEMI] = ACTIONS(3649),
    [anon_sym_global] = ACTIONS(3647),
    [anon_sym_using] = ACTIONS(3647),
    [anon_sym_unsafe] = ACTIONS(3647),
    [anon_sym_static] = ACTIONS(3647),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_LPAREN] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_namespace] = ACTIONS(3647),
    [anon_sym_class] = ACTIONS(3647),
    [anon_sym_ref] = ACTIONS(3647),
    [anon_sym_struct] = ACTIONS(3647),
    [anon_sym_enum] = ACTIONS(3647),
    [anon_sym_LBRACE] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3647),
    [anon_sym_delegate] = ACTIONS(3647),
    [anon_sym_record] = ACTIONS(3647),
    [anon_sym_abstract] = ACTIONS(3647),
    [anon_sym_async] = ACTIONS(3647),
    [anon_sym_const] = ACTIONS(3647),
    [anon_sym_file] = ACTIONS(3647),
    [anon_sym_fixed] = ACTIONS(3647),
    [anon_sym_internal] = ACTIONS(3647),
    [anon_sym_new] = ACTIONS(3647),
    [anon_sym_override] = ACTIONS(3647),
    [anon_sym_partial] = ACTIONS(3647),
    [anon_sym_private] = ACTIONS(3647),
    [anon_sym_protected] = ACTIONS(3647),
    [anon_sym_public] = ACTIONS(3647),
    [anon_sym_readonly] = ACTIONS(3647),
    [anon_sym_required] = ACTIONS(3647),
    [anon_sym_sealed] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(3647),
    [anon_sym_volatile] = ACTIONS(3647),
    [anon_sym_where] = ACTIONS(3647),
    [anon_sym_notnull] = ACTIONS(3647),
    [anon_sym_unmanaged] = ACTIONS(3647),
    [anon_sym_checked] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3649),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3649),
    [anon_sym_true] = ACTIONS(3647),
    [anon_sym_false] = ACTIONS(3647),
    [anon_sym_PLUS] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_CARET] = ACTIONS(3649),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_this] = ACTIONS(3647),
    [anon_sym_scoped] = ACTIONS(3647),
    [anon_sym_base] = ACTIONS(3647),
    [anon_sym_var] = ACTIONS(3647),
    [sym_predefined_type] = ACTIONS(3647),
    [anon_sym_break] = ACTIONS(3647),
    [anon_sym_unchecked] = ACTIONS(3647),
    [anon_sym_continue] = ACTIONS(3647),
    [anon_sym_do] = ACTIONS(3647),
    [anon_sym_while] = ACTIONS(3647),
    [anon_sym_for] = ACTIONS(3647),
    [anon_sym_lock] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3647),
    [anon_sym_switch] = ACTIONS(3647),
    [anon_sym_default] = ACTIONS(3647),
    [anon_sym_throw] = ACTIONS(3647),
    [anon_sym_try] = ACTIONS(3647),
    [anon_sym_when] = ACTIONS(3647),
    [anon_sym_await] = ACTIONS(3647),
    [anon_sym_foreach] = ACTIONS(3647),
    [anon_sym_goto] = ACTIONS(3647),
    [anon_sym_if] = ACTIONS(3647),
    [anon_sym_DOT_DOT] = ACTIONS(3649),
    [anon_sym_from] = ACTIONS(3647),
    [anon_sym_into] = ACTIONS(3647),
    [anon_sym_join] = ACTIONS(3647),
    [anon_sym_on] = ACTIONS(3647),
    [anon_sym_equals] = ACTIONS(3647),
    [anon_sym_let] = ACTIONS(3647),
    [anon_sym_orderby] = ACTIONS(3647),
    [anon_sym_ascending] = ACTIONS(3647),
    [anon_sym_descending] = ACTIONS(3647),
    [anon_sym_group] = ACTIONS(3647),
    [anon_sym_by] = ACTIONS(3647),
    [anon_sym_select] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3649),
    [anon_sym_stackalloc] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3647),
    [anon_sym_typeof] = ACTIONS(3647),
    [anon_sym___makeref] = ACTIONS(3647),
    [anon_sym___reftype] = ACTIONS(3647),
    [anon_sym___refvalue] = ACTIONS(3647),
    [sym_null_literal] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3649),
    [sym_integer_literal] = ACTIONS(3647),
    [sym_real_literal] = ACTIONS(3649),
    [sym_verbatim_string_literal] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token3] = ACTIONS(3649),
    [aux_sym_preproc_else_token1] = ACTIONS(3649),
    [aux_sym_preproc_elif_token1] = ACTIONS(3649),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3649),
    [sym_interpolation_verbatim_start] = ACTIONS(3649),
    [sym_interpolation_raw_start] = ACTIONS(3649),
    [sym_raw_string_start] = ACTIONS(3649),
  },
  [2369] = {
    [sym_preproc_region] = STATE(2369),
    [sym_preproc_endregion] = STATE(2369),
    [sym_preproc_line] = STATE(2369),
    [sym_preproc_pragma] = STATE(2369),
    [sym_preproc_nullable] = STATE(2369),
    [sym_preproc_error] = STATE(2369),
    [sym_preproc_define] = STATE(2369),
    [sym_preproc_undef] = STATE(2369),
    [sym__identifier_token] = ACTIONS(3651),
    [anon_sym_extern] = ACTIONS(3651),
    [anon_sym_alias] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_global] = ACTIONS(3651),
    [anon_sym_using] = ACTIONS(3651),
    [anon_sym_unsafe] = ACTIONS(3651),
    [anon_sym_static] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_return] = ACTIONS(3651),
    [anon_sym_namespace] = ACTIONS(3651),
    [anon_sym_class] = ACTIONS(3651),
    [anon_sym_ref] = ACTIONS(3651),
    [anon_sym_struct] = ACTIONS(3651),
    [anon_sym_enum] = ACTIONS(3651),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_interface] = ACTIONS(3651),
    [anon_sym_delegate] = ACTIONS(3651),
    [anon_sym_record] = ACTIONS(3651),
    [anon_sym_abstract] = ACTIONS(3651),
    [anon_sym_async] = ACTIONS(3651),
    [anon_sym_const] = ACTIONS(3651),
    [anon_sym_file] = ACTIONS(3651),
    [anon_sym_fixed] = ACTIONS(3651),
    [anon_sym_internal] = ACTIONS(3651),
    [anon_sym_new] = ACTIONS(3651),
    [anon_sym_override] = ACTIONS(3651),
    [anon_sym_partial] = ACTIONS(3651),
    [anon_sym_private] = ACTIONS(3651),
    [anon_sym_protected] = ACTIONS(3651),
    [anon_sym_public] = ACTIONS(3651),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_required] = ACTIONS(3651),
    [anon_sym_sealed] = ACTIONS(3651),
    [anon_sym_virtual] = ACTIONS(3651),
    [anon_sym_volatile] = ACTIONS(3651),
    [anon_sym_where] = ACTIONS(3651),
    [anon_sym_notnull] = ACTIONS(3651),
    [anon_sym_unmanaged] = ACTIONS(3651),
    [anon_sym_checked] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_true] = ACTIONS(3651),
    [anon_sym_false] = ACTIONS(3651),
    [anon_sym_PLUS] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_this] = ACTIONS(3651),
    [anon_sym_scoped] = ACTIONS(3651),
    [anon_sym_base] = ACTIONS(3651),
    [anon_sym_var] = ACTIONS(3651),
    [sym_predefined_type] = ACTIONS(3651),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_unchecked] = ACTIONS(3651),
    [anon_sym_continue] = ACTIONS(3651),
    [anon_sym_do] = ACTIONS(3651),
    [anon_sym_while] = ACTIONS(3651),
    [anon_sym_for] = ACTIONS(3651),
    [anon_sym_lock] = ACTIONS(3651),
    [anon_sym_yield] = ACTIONS(3651),
    [anon_sym_switch] = ACTIONS(3651),
    [anon_sym_default] = ACTIONS(3651),
    [anon_sym_throw] = ACTIONS(3651),
    [anon_sym_try] = ACTIONS(3651),
    [anon_sym_when] = ACTIONS(3651),
    [anon_sym_await] = ACTIONS(3651),
    [anon_sym_foreach] = ACTIONS(3651),
    [anon_sym_goto] = ACTIONS(3651),
    [anon_sym_if] = ACTIONS(3651),
    [anon_sym_DOT_DOT] = ACTIONS(3653),
    [anon_sym_from] = ACTIONS(3651),
    [anon_sym_into] = ACTIONS(3651),
    [anon_sym_join] = ACTIONS(3651),
    [anon_sym_on] = ACTIONS(3651),
    [anon_sym_equals] = ACTIONS(3651),
    [anon_sym_let] = ACTIONS(3651),
    [anon_sym_orderby] = ACTIONS(3651),
    [anon_sym_ascending] = ACTIONS(3651),
    [anon_sym_descending] = ACTIONS(3651),
    [anon_sym_group] = ACTIONS(3651),
    [anon_sym_by] = ACTIONS(3651),
    [anon_sym_select] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [anon_sym_stackalloc] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3651),
    [anon_sym_typeof] = ACTIONS(3651),
    [anon_sym___makeref] = ACTIONS(3651),
    [anon_sym___reftype] = ACTIONS(3651),
    [anon_sym___refvalue] = ACTIONS(3651),
    [sym_null_literal] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [sym_integer_literal] = ACTIONS(3651),
    [sym_real_literal] = ACTIONS(3653),
    [sym_verbatim_string_literal] = ACTIONS(3653),
    [aux_sym_preproc_if_token1] = ACTIONS(3653),
    [aux_sym_preproc_if_token3] = ACTIONS(3653),
    [aux_sym_preproc_else_token1] = ACTIONS(3653),
    [aux_sym_preproc_elif_token1] = ACTIONS(3653),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3653),
    [sym_interpolation_verbatim_start] = ACTIONS(3653),
    [sym_interpolation_raw_start] = ACTIONS(3653),
    [sym_raw_string_start] = ACTIONS(3653),
  },
  [2370] = {
    [sym_preproc_region] = STATE(2370),
    [sym_preproc_endregion] = STATE(2370),
    [sym_preproc_line] = STATE(2370),
    [sym_preproc_pragma] = STATE(2370),
    [sym_preproc_nullable] = STATE(2370),
    [sym_preproc_error] = STATE(2370),
    [sym_preproc_define] = STATE(2370),
    [sym_preproc_undef] = STATE(2370),
    [sym__identifier_token] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym_alias] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3657),
    [anon_sym_global] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_unsafe] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3657),
    [anon_sym_LPAREN] = ACTIONS(3657),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_ref] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3657),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_delegate] = ACTIONS(3655),
    [anon_sym_record] = ACTIONS(3655),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_async] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_file] = ACTIONS(3655),
    [anon_sym_fixed] = ACTIONS(3655),
    [anon_sym_internal] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_override] = ACTIONS(3655),
    [anon_sym_partial] = ACTIONS(3655),
    [anon_sym_private] = ACTIONS(3655),
    [anon_sym_protected] = ACTIONS(3655),
    [anon_sym_public] = ACTIONS(3655),
    [anon_sym_readonly] = ACTIONS(3655),
    [anon_sym_required] = ACTIONS(3655),
    [anon_sym_sealed] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_where] = ACTIONS(3655),
    [anon_sym_notnull] = ACTIONS(3655),
    [anon_sym_unmanaged] = ACTIONS(3655),
    [anon_sym_checked] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3657),
    [anon_sym_TILDE] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3657),
    [anon_sym_DASH_DASH] = ACTIONS(3657),
    [anon_sym_true] = ACTIONS(3655),
    [anon_sym_false] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_CARET] = ACTIONS(3657),
    [anon_sym_AMP] = ACTIONS(3657),
    [anon_sym_this] = ACTIONS(3655),
    [anon_sym_scoped] = ACTIONS(3655),
    [anon_sym_base] = ACTIONS(3655),
    [anon_sym_var] = ACTIONS(3655),
    [sym_predefined_type] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_unchecked] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_lock] = ACTIONS(3655),
    [anon_sym_yield] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_when] = ACTIONS(3655),
    [anon_sym_await] = ACTIONS(3655),
    [anon_sym_foreach] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_DOT_DOT] = ACTIONS(3657),
    [anon_sym_from] = ACTIONS(3655),
    [anon_sym_into] = ACTIONS(3655),
    [anon_sym_join] = ACTIONS(3655),
    [anon_sym_on] = ACTIONS(3655),
    [anon_sym_equals] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_orderby] = ACTIONS(3655),
    [anon_sym_ascending] = ACTIONS(3655),
    [anon_sym_descending] = ACTIONS(3655),
    [anon_sym_group] = ACTIONS(3655),
    [anon_sym_by] = ACTIONS(3655),
    [anon_sym_select] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [anon_sym_stackalloc] = ACTIONS(3655),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym_typeof] = ACTIONS(3655),
    [anon_sym___makeref] = ACTIONS(3655),
    [anon_sym___reftype] = ACTIONS(3655),
    [anon_sym___refvalue] = ACTIONS(3655),
    [sym_null_literal] = ACTIONS(3655),
    [anon_sym_SQUOTE] = ACTIONS(3657),
    [sym_integer_literal] = ACTIONS(3655),
    [sym_real_literal] = ACTIONS(3657),
    [sym_verbatim_string_literal] = ACTIONS(3657),
    [aux_sym_preproc_if_token1] = ACTIONS(3657),
    [aux_sym_preproc_if_token3] = ACTIONS(3657),
    [aux_sym_preproc_else_token1] = ACTIONS(3657),
    [aux_sym_preproc_elif_token1] = ACTIONS(3657),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3657),
    [sym_interpolation_verbatim_start] = ACTIONS(3657),
    [sym_interpolation_raw_start] = ACTIONS(3657),
    [sym_raw_string_start] = ACTIONS(3657),
  },
  [2371] = {
    [sym_preproc_region] = STATE(2371),
    [sym_preproc_endregion] = STATE(2371),
    [sym_preproc_line] = STATE(2371),
    [sym_preproc_pragma] = STATE(2371),
    [sym_preproc_nullable] = STATE(2371),
    [sym_preproc_error] = STATE(2371),
    [sym_preproc_define] = STATE(2371),
    [sym_preproc_undef] = STATE(2371),
    [sym__identifier_token] = ACTIONS(3659),
    [anon_sym_extern] = ACTIONS(3659),
    [anon_sym_alias] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3661),
    [anon_sym_global] = ACTIONS(3659),
    [anon_sym_using] = ACTIONS(3659),
    [anon_sym_unsafe] = ACTIONS(3659),
    [anon_sym_static] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_LPAREN] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3659),
    [anon_sym_namespace] = ACTIONS(3659),
    [anon_sym_class] = ACTIONS(3659),
    [anon_sym_ref] = ACTIONS(3659),
    [anon_sym_struct] = ACTIONS(3659),
    [anon_sym_enum] = ACTIONS(3659),
    [anon_sym_LBRACE] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3659),
    [anon_sym_delegate] = ACTIONS(3659),
    [anon_sym_record] = ACTIONS(3659),
    [anon_sym_abstract] = ACTIONS(3659),
    [anon_sym_async] = ACTIONS(3659),
    [anon_sym_const] = ACTIONS(3659),
    [anon_sym_file] = ACTIONS(3659),
    [anon_sym_fixed] = ACTIONS(3659),
    [anon_sym_internal] = ACTIONS(3659),
    [anon_sym_new] = ACTIONS(3659),
    [anon_sym_override] = ACTIONS(3659),
    [anon_sym_partial] = ACTIONS(3659),
    [anon_sym_private] = ACTIONS(3659),
    [anon_sym_protected] = ACTIONS(3659),
    [anon_sym_public] = ACTIONS(3659),
    [anon_sym_readonly] = ACTIONS(3659),
    [anon_sym_required] = ACTIONS(3659),
    [anon_sym_sealed] = ACTIONS(3659),
    [anon_sym_virtual] = ACTIONS(3659),
    [anon_sym_volatile] = ACTIONS(3659),
    [anon_sym_where] = ACTIONS(3659),
    [anon_sym_notnull] = ACTIONS(3659),
    [anon_sym_unmanaged] = ACTIONS(3659),
    [anon_sym_checked] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_PLUS_PLUS] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3661),
    [anon_sym_true] = ACTIONS(3659),
    [anon_sym_false] = ACTIONS(3659),
    [anon_sym_PLUS] = ACTIONS(3659),
    [anon_sym_DASH] = ACTIONS(3659),
    [anon_sym_STAR] = ACTIONS(3661),
    [anon_sym_CARET] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_this] = ACTIONS(3659),
    [anon_sym_scoped] = ACTIONS(3659),
    [anon_sym_base] = ACTIONS(3659),
    [anon_sym_var] = ACTIONS(3659),
    [sym_predefined_type] = ACTIONS(3659),
    [anon_sym_break] = ACTIONS(3659),
    [anon_sym_unchecked] = ACTIONS(3659),
    [anon_sym_continue] = ACTIONS(3659),
    [anon_sym_do] = ACTIONS(3659),
    [anon_sym_while] = ACTIONS(3659),
    [anon_sym_for] = ACTIONS(3659),
    [anon_sym_lock] = ACTIONS(3659),
    [anon_sym_yield] = ACTIONS(3659),
    [anon_sym_switch] = ACTIONS(3659),
    [anon_sym_default] = ACTIONS(3659),
    [anon_sym_throw] = ACTIONS(3659),
    [anon_sym_try] = ACTIONS(3659),
    [anon_sym_when] = ACTIONS(3659),
    [anon_sym_await] = ACTIONS(3659),
    [anon_sym_foreach] = ACTIONS(3659),
    [anon_sym_goto] = ACTIONS(3659),
    [anon_sym_if] = ACTIONS(3659),
    [anon_sym_DOT_DOT] = ACTIONS(3661),
    [anon_sym_from] = ACTIONS(3659),
    [anon_sym_into] = ACTIONS(3659),
    [anon_sym_join] = ACTIONS(3659),
    [anon_sym_on] = ACTIONS(3659),
    [anon_sym_equals] = ACTIONS(3659),
    [anon_sym_let] = ACTIONS(3659),
    [anon_sym_orderby] = ACTIONS(3659),
    [anon_sym_ascending] = ACTIONS(3659),
    [anon_sym_descending] = ACTIONS(3659),
    [anon_sym_group] = ACTIONS(3659),
    [anon_sym_by] = ACTIONS(3659),
    [anon_sym_select] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [anon_sym_stackalloc] = ACTIONS(3659),
    [anon_sym_sizeof] = ACTIONS(3659),
    [anon_sym_typeof] = ACTIONS(3659),
    [anon_sym___makeref] = ACTIONS(3659),
    [anon_sym___reftype] = ACTIONS(3659),
    [anon_sym___refvalue] = ACTIONS(3659),
    [sym_null_literal] = ACTIONS(3659),
    [anon_sym_SQUOTE] = ACTIONS(3661),
    [sym_integer_literal] = ACTIONS(3659),
    [sym_real_literal] = ACTIONS(3661),
    [sym_verbatim_string_literal] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token3] = ACTIONS(3661),
    [aux_sym_preproc_else_token1] = ACTIONS(3661),
    [aux_sym_preproc_elif_token1] = ACTIONS(3661),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3661),
    [sym_interpolation_verbatim_start] = ACTIONS(3661),
    [sym_interpolation_raw_start] = ACTIONS(3661),
    [sym_raw_string_start] = ACTIONS(3661),
  },
  [2372] = {
    [sym_preproc_region] = STATE(2372),
    [sym_preproc_endregion] = STATE(2372),
    [sym_preproc_line] = STATE(2372),
    [sym_preproc_pragma] = STATE(2372),
    [sym_preproc_nullable] = STATE(2372),
    [sym_preproc_error] = STATE(2372),
    [sym_preproc_define] = STATE(2372),
    [sym_preproc_undef] = STATE(2372),
    [sym__identifier_token] = ACTIONS(3663),
    [anon_sym_extern] = ACTIONS(3663),
    [anon_sym_alias] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_global] = ACTIONS(3663),
    [anon_sym_using] = ACTIONS(3663),
    [anon_sym_unsafe] = ACTIONS(3663),
    [anon_sym_static] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_LPAREN] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3663),
    [anon_sym_namespace] = ACTIONS(3663),
    [anon_sym_class] = ACTIONS(3663),
    [anon_sym_ref] = ACTIONS(3663),
    [anon_sym_struct] = ACTIONS(3663),
    [anon_sym_enum] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3663),
    [anon_sym_delegate] = ACTIONS(3663),
    [anon_sym_record] = ACTIONS(3663),
    [anon_sym_abstract] = ACTIONS(3663),
    [anon_sym_async] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3663),
    [anon_sym_file] = ACTIONS(3663),
    [anon_sym_fixed] = ACTIONS(3663),
    [anon_sym_internal] = ACTIONS(3663),
    [anon_sym_new] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_partial] = ACTIONS(3663),
    [anon_sym_private] = ACTIONS(3663),
    [anon_sym_protected] = ACTIONS(3663),
    [anon_sym_public] = ACTIONS(3663),
    [anon_sym_readonly] = ACTIONS(3663),
    [anon_sym_required] = ACTIONS(3663),
    [anon_sym_sealed] = ACTIONS(3663),
    [anon_sym_virtual] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym_where] = ACTIONS(3663),
    [anon_sym_notnull] = ACTIONS(3663),
    [anon_sym_unmanaged] = ACTIONS(3663),
    [anon_sym_checked] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3665),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_PLUS_PLUS] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3665),
    [anon_sym_true] = ACTIONS(3663),
    [anon_sym_false] = ACTIONS(3663),
    [anon_sym_PLUS] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3663),
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_CARET] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_this] = ACTIONS(3663),
    [anon_sym_scoped] = ACTIONS(3663),
    [anon_sym_base] = ACTIONS(3663),
    [anon_sym_var] = ACTIONS(3663),
    [sym_predefined_type] = ACTIONS(3663),
    [anon_sym_break] = ACTIONS(3663),
    [anon_sym_unchecked] = ACTIONS(3663),
    [anon_sym_continue] = ACTIONS(3663),
    [anon_sym_do] = ACTIONS(3663),
    [anon_sym_while] = ACTIONS(3663),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_lock] = ACTIONS(3663),
    [anon_sym_yield] = ACTIONS(3663),
    [anon_sym_switch] = ACTIONS(3663),
    [anon_sym_default] = ACTIONS(3663),
    [anon_sym_throw] = ACTIONS(3663),
    [anon_sym_try] = ACTIONS(3663),
    [anon_sym_when] = ACTIONS(3663),
    [anon_sym_await] = ACTIONS(3663),
    [anon_sym_foreach] = ACTIONS(3663),
    [anon_sym_goto] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3663),
    [anon_sym_DOT_DOT] = ACTIONS(3665),
    [anon_sym_from] = ACTIONS(3663),
    [anon_sym_into] = ACTIONS(3663),
    [anon_sym_join] = ACTIONS(3663),
    [anon_sym_on] = ACTIONS(3663),
    [anon_sym_equals] = ACTIONS(3663),
    [anon_sym_let] = ACTIONS(3663),
    [anon_sym_orderby] = ACTIONS(3663),
    [anon_sym_ascending] = ACTIONS(3663),
    [anon_sym_descending] = ACTIONS(3663),
    [anon_sym_group] = ACTIONS(3663),
    [anon_sym_by] = ACTIONS(3663),
    [anon_sym_select] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [anon_sym_stackalloc] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3663),
    [anon_sym_typeof] = ACTIONS(3663),
    [anon_sym___makeref] = ACTIONS(3663),
    [anon_sym___reftype] = ACTIONS(3663),
    [anon_sym___refvalue] = ACTIONS(3663),
    [sym_null_literal] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3665),
    [sym_integer_literal] = ACTIONS(3663),
    [sym_real_literal] = ACTIONS(3665),
    [sym_verbatim_string_literal] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token3] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3665),
    [sym_interpolation_verbatim_start] = ACTIONS(3665),
    [sym_interpolation_raw_start] = ACTIONS(3665),
    [sym_raw_string_start] = ACTIONS(3665),
  },
  [2373] = {
    [sym_preproc_region] = STATE(2373),
    [sym_preproc_endregion] = STATE(2373),
    [sym_preproc_line] = STATE(2373),
    [sym_preproc_pragma] = STATE(2373),
    [sym_preproc_nullable] = STATE(2373),
    [sym_preproc_error] = STATE(2373),
    [sym_preproc_define] = STATE(2373),
    [sym_preproc_undef] = STATE(2373),
    [sym__identifier_token] = ACTIONS(3667),
    [anon_sym_extern] = ACTIONS(3667),
    [anon_sym_alias] = ACTIONS(3667),
    [anon_sym_SEMI] = ACTIONS(3669),
    [anon_sym_global] = ACTIONS(3667),
    [anon_sym_using] = ACTIONS(3667),
    [anon_sym_unsafe] = ACTIONS(3667),
    [anon_sym_static] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3667),
    [anon_sym_namespace] = ACTIONS(3667),
    [anon_sym_class] = ACTIONS(3667),
    [anon_sym_ref] = ACTIONS(3667),
    [anon_sym_struct] = ACTIONS(3667),
    [anon_sym_enum] = ACTIONS(3667),
    [anon_sym_LBRACE] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3667),
    [anon_sym_delegate] = ACTIONS(3667),
    [anon_sym_record] = ACTIONS(3667),
    [anon_sym_abstract] = ACTIONS(3667),
    [anon_sym_async] = ACTIONS(3667),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_file] = ACTIONS(3667),
    [anon_sym_fixed] = ACTIONS(3667),
    [anon_sym_internal] = ACTIONS(3667),
    [anon_sym_new] = ACTIONS(3667),
    [anon_sym_override] = ACTIONS(3667),
    [anon_sym_partial] = ACTIONS(3667),
    [anon_sym_private] = ACTIONS(3667),
    [anon_sym_protected] = ACTIONS(3667),
    [anon_sym_public] = ACTIONS(3667),
    [anon_sym_readonly] = ACTIONS(3667),
    [anon_sym_required] = ACTIONS(3667),
    [anon_sym_sealed] = ACTIONS(3667),
    [anon_sym_virtual] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_where] = ACTIONS(3667),
    [anon_sym_notnull] = ACTIONS(3667),
    [anon_sym_unmanaged] = ACTIONS(3667),
    [anon_sym_checked] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3669),
    [anon_sym_PLUS_PLUS] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3669),
    [anon_sym_true] = ACTIONS(3667),
    [anon_sym_false] = ACTIONS(3667),
    [anon_sym_PLUS] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_this] = ACTIONS(3667),
    [anon_sym_scoped] = ACTIONS(3667),
    [anon_sym_base] = ACTIONS(3667),
    [anon_sym_var] = ACTIONS(3667),
    [sym_predefined_type] = ACTIONS(3667),
    [anon_sym_break] = ACTIONS(3667),
    [anon_sym_unchecked] = ACTIONS(3667),
    [anon_sym_continue] = ACTIONS(3667),
    [anon_sym_do] = ACTIONS(3667),
    [anon_sym_while] = ACTIONS(3667),
    [anon_sym_for] = ACTIONS(3667),
    [anon_sym_lock] = ACTIONS(3667),
    [anon_sym_yield] = ACTIONS(3667),
    [anon_sym_switch] = ACTIONS(3667),
    [anon_sym_default] = ACTIONS(3667),
    [anon_sym_throw] = ACTIONS(3667),
    [anon_sym_try] = ACTIONS(3667),
    [anon_sym_when] = ACTIONS(3667),
    [anon_sym_await] = ACTIONS(3667),
    [anon_sym_foreach] = ACTIONS(3667),
    [anon_sym_goto] = ACTIONS(3667),
    [anon_sym_if] = ACTIONS(3667),
    [anon_sym_DOT_DOT] = ACTIONS(3669),
    [anon_sym_from] = ACTIONS(3667),
    [anon_sym_into] = ACTIONS(3667),
    [anon_sym_join] = ACTIONS(3667),
    [anon_sym_on] = ACTIONS(3667),
    [anon_sym_equals] = ACTIONS(3667),
    [anon_sym_let] = ACTIONS(3667),
    [anon_sym_orderby] = ACTIONS(3667),
    [anon_sym_ascending] = ACTIONS(3667),
    [anon_sym_descending] = ACTIONS(3667),
    [anon_sym_group] = ACTIONS(3667),
    [anon_sym_by] = ACTIONS(3667),
    [anon_sym_select] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3669),
    [anon_sym_stackalloc] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3667),
    [anon_sym_typeof] = ACTIONS(3667),
    [anon_sym___makeref] = ACTIONS(3667),
    [anon_sym___reftype] = ACTIONS(3667),
    [anon_sym___refvalue] = ACTIONS(3667),
    [sym_null_literal] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3669),
    [sym_integer_literal] = ACTIONS(3667),
    [sym_real_literal] = ACTIONS(3669),
    [sym_verbatim_string_literal] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token3] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3669),
    [sym_interpolation_verbatim_start] = ACTIONS(3669),
    [sym_interpolation_raw_start] = ACTIONS(3669),
    [sym_raw_string_start] = ACTIONS(3669),
  },
  [2374] = {
    [sym_preproc_region] = STATE(2374),
    [sym_preproc_endregion] = STATE(2374),
    [sym_preproc_line] = STATE(2374),
    [sym_preproc_pragma] = STATE(2374),
    [sym_preproc_nullable] = STATE(2374),
    [sym_preproc_error] = STATE(2374),
    [sym_preproc_define] = STATE(2374),
    [sym_preproc_undef] = STATE(2374),
    [sym__identifier_token] = ACTIONS(3671),
    [anon_sym_extern] = ACTIONS(3671),
    [anon_sym_alias] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3673),
    [anon_sym_global] = ACTIONS(3671),
    [anon_sym_using] = ACTIONS(3671),
    [anon_sym_unsafe] = ACTIONS(3671),
    [anon_sym_static] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_LPAREN] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3671),
    [anon_sym_namespace] = ACTIONS(3671),
    [anon_sym_class] = ACTIONS(3671),
    [anon_sym_ref] = ACTIONS(3671),
    [anon_sym_struct] = ACTIONS(3671),
    [anon_sym_enum] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3671),
    [anon_sym_delegate] = ACTIONS(3671),
    [anon_sym_record] = ACTIONS(3671),
    [anon_sym_abstract] = ACTIONS(3671),
    [anon_sym_async] = ACTIONS(3671),
    [anon_sym_const] = ACTIONS(3671),
    [anon_sym_file] = ACTIONS(3671),
    [anon_sym_fixed] = ACTIONS(3671),
    [anon_sym_internal] = ACTIONS(3671),
    [anon_sym_new] = ACTIONS(3671),
    [anon_sym_override] = ACTIONS(3671),
    [anon_sym_partial] = ACTIONS(3671),
    [anon_sym_private] = ACTIONS(3671),
    [anon_sym_protected] = ACTIONS(3671),
    [anon_sym_public] = ACTIONS(3671),
    [anon_sym_readonly] = ACTIONS(3671),
    [anon_sym_required] = ACTIONS(3671),
    [anon_sym_sealed] = ACTIONS(3671),
    [anon_sym_virtual] = ACTIONS(3671),
    [anon_sym_volatile] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_notnull] = ACTIONS(3671),
    [anon_sym_unmanaged] = ACTIONS(3671),
    [anon_sym_checked] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3673),
    [anon_sym_true] = ACTIONS(3671),
    [anon_sym_false] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3673),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_this] = ACTIONS(3671),
    [anon_sym_scoped] = ACTIONS(3671),
    [anon_sym_base] = ACTIONS(3671),
    [anon_sym_var] = ACTIONS(3671),
    [sym_predefined_type] = ACTIONS(3671),
    [anon_sym_break] = ACTIONS(3671),
    [anon_sym_unchecked] = ACTIONS(3671),
    [anon_sym_continue] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_while] = ACTIONS(3671),
    [anon_sym_for] = ACTIONS(3671),
    [anon_sym_lock] = ACTIONS(3671),
    [anon_sym_yield] = ACTIONS(3671),
    [anon_sym_switch] = ACTIONS(3671),
    [anon_sym_default] = ACTIONS(3671),
    [anon_sym_throw] = ACTIONS(3671),
    [anon_sym_try] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_await] = ACTIONS(3671),
    [anon_sym_foreach] = ACTIONS(3671),
    [anon_sym_goto] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_DOT_DOT] = ACTIONS(3673),
    [anon_sym_from] = ACTIONS(3671),
    [anon_sym_into] = ACTIONS(3671),
    [anon_sym_join] = ACTIONS(3671),
    [anon_sym_on] = ACTIONS(3671),
    [anon_sym_equals] = ACTIONS(3671),
    [anon_sym_let] = ACTIONS(3671),
    [anon_sym_orderby] = ACTIONS(3671),
    [anon_sym_ascending] = ACTIONS(3671),
    [anon_sym_descending] = ACTIONS(3671),
    [anon_sym_group] = ACTIONS(3671),
    [anon_sym_by] = ACTIONS(3671),
    [anon_sym_select] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3673),
    [anon_sym_stackalloc] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3671),
    [anon_sym_typeof] = ACTIONS(3671),
    [anon_sym___makeref] = ACTIONS(3671),
    [anon_sym___reftype] = ACTIONS(3671),
    [anon_sym___refvalue] = ACTIONS(3671),
    [sym_null_literal] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3673),
    [sym_integer_literal] = ACTIONS(3671),
    [sym_real_literal] = ACTIONS(3673),
    [sym_verbatim_string_literal] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token3] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3673),
    [sym_interpolation_verbatim_start] = ACTIONS(3673),
    [sym_interpolation_raw_start] = ACTIONS(3673),
    [sym_raw_string_start] = ACTIONS(3673),
  },
  [2375] = {
    [sym_preproc_region] = STATE(2375),
    [sym_preproc_endregion] = STATE(2375),
    [sym_preproc_line] = STATE(2375),
    [sym_preproc_pragma] = STATE(2375),
    [sym_preproc_nullable] = STATE(2375),
    [sym_preproc_error] = STATE(2375),
    [sym_preproc_define] = STATE(2375),
    [sym_preproc_undef] = STATE(2375),
    [sym__identifier_token] = ACTIONS(3675),
    [anon_sym_extern] = ACTIONS(3675),
    [anon_sym_alias] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3677),
    [anon_sym_global] = ACTIONS(3675),
    [anon_sym_using] = ACTIONS(3675),
    [anon_sym_unsafe] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_namespace] = ACTIONS(3675),
    [anon_sym_class] = ACTIONS(3675),
    [anon_sym_ref] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(3675),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_LBRACE] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3675),
    [anon_sym_delegate] = ACTIONS(3675),
    [anon_sym_record] = ACTIONS(3675),
    [anon_sym_abstract] = ACTIONS(3675),
    [anon_sym_async] = ACTIONS(3675),
    [anon_sym_const] = ACTIONS(3675),
    [anon_sym_file] = ACTIONS(3675),
    [anon_sym_fixed] = ACTIONS(3675),
    [anon_sym_internal] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_override] = ACTIONS(3675),
    [anon_sym_partial] = ACTIONS(3675),
    [anon_sym_private] = ACTIONS(3675),
    [anon_sym_protected] = ACTIONS(3675),
    [anon_sym_public] = ACTIONS(3675),
    [anon_sym_readonly] = ACTIONS(3675),
    [anon_sym_required] = ACTIONS(3675),
    [anon_sym_sealed] = ACTIONS(3675),
    [anon_sym_virtual] = ACTIONS(3675),
    [anon_sym_volatile] = ACTIONS(3675),
    [anon_sym_where] = ACTIONS(3675),
    [anon_sym_notnull] = ACTIONS(3675),
    [anon_sym_unmanaged] = ACTIONS(3675),
    [anon_sym_checked] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3677),
    [anon_sym_PLUS_PLUS] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3677),
    [anon_sym_true] = ACTIONS(3675),
    [anon_sym_false] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_CARET] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_this] = ACTIONS(3675),
    [anon_sym_scoped] = ACTIONS(3675),
    [anon_sym_base] = ACTIONS(3675),
    [anon_sym_var] = ACTIONS(3675),
    [sym_predefined_type] = ACTIONS(3675),
    [anon_sym_break] = ACTIONS(3675),
    [anon_sym_unchecked] = ACTIONS(3675),
    [anon_sym_continue] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_lock] = ACTIONS(3675),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_switch] = ACTIONS(3675),
    [anon_sym_default] = ACTIONS(3675),
    [anon_sym_throw] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_when] = ACTIONS(3675),
    [anon_sym_await] = ACTIONS(3675),
    [anon_sym_foreach] = ACTIONS(3675),
    [anon_sym_goto] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_DOT_DOT] = ACTIONS(3677),
    [anon_sym_from] = ACTIONS(3675),
    [anon_sym_into] = ACTIONS(3675),
    [anon_sym_join] = ACTIONS(3675),
    [anon_sym_on] = ACTIONS(3675),
    [anon_sym_equals] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_orderby] = ACTIONS(3675),
    [anon_sym_ascending] = ACTIONS(3675),
    [anon_sym_descending] = ACTIONS(3675),
    [anon_sym_group] = ACTIONS(3675),
    [anon_sym_by] = ACTIONS(3675),
    [anon_sym_select] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3677),
    [anon_sym_stackalloc] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3675),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym___makeref] = ACTIONS(3675),
    [anon_sym___reftype] = ACTIONS(3675),
    [anon_sym___refvalue] = ACTIONS(3675),
    [sym_null_literal] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3677),
    [sym_integer_literal] = ACTIONS(3675),
    [sym_real_literal] = ACTIONS(3677),
    [sym_verbatim_string_literal] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token3] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3677),
    [sym_interpolation_verbatim_start] = ACTIONS(3677),
    [sym_interpolation_raw_start] = ACTIONS(3677),
    [sym_raw_string_start] = ACTIONS(3677),
  },
  [2376] = {
    [sym_preproc_region] = STATE(2376),
    [sym_preproc_endregion] = STATE(2376),
    [sym_preproc_line] = STATE(2376),
    [sym_preproc_pragma] = STATE(2376),
    [sym_preproc_nullable] = STATE(2376),
    [sym_preproc_error] = STATE(2376),
    [sym_preproc_define] = STATE(2376),
    [sym_preproc_undef] = STATE(2376),
    [sym__identifier_token] = ACTIONS(3679),
    [anon_sym_extern] = ACTIONS(3679),
    [anon_sym_alias] = ACTIONS(3679),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3679),
    [anon_sym_using] = ACTIONS(3679),
    [anon_sym_unsafe] = ACTIONS(3679),
    [anon_sym_static] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_namespace] = ACTIONS(3679),
    [anon_sym_class] = ACTIONS(3679),
    [anon_sym_ref] = ACTIONS(3679),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_enum] = ACTIONS(3679),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3679),
    [anon_sym_delegate] = ACTIONS(3679),
    [anon_sym_record] = ACTIONS(3679),
    [anon_sym_abstract] = ACTIONS(3679),
    [anon_sym_async] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3679),
    [anon_sym_file] = ACTIONS(3679),
    [anon_sym_fixed] = ACTIONS(3679),
    [anon_sym_internal] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_override] = ACTIONS(3679),
    [anon_sym_partial] = ACTIONS(3679),
    [anon_sym_private] = ACTIONS(3679),
    [anon_sym_protected] = ACTIONS(3679),
    [anon_sym_public] = ACTIONS(3679),
    [anon_sym_readonly] = ACTIONS(3679),
    [anon_sym_required] = ACTIONS(3679),
    [anon_sym_sealed] = ACTIONS(3679),
    [anon_sym_virtual] = ACTIONS(3679),
    [anon_sym_volatile] = ACTIONS(3679),
    [anon_sym_where] = ACTIONS(3679),
    [anon_sym_notnull] = ACTIONS(3679),
    [anon_sym_unmanaged] = ACTIONS(3679),
    [anon_sym_checked] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_true] = ACTIONS(3679),
    [anon_sym_false] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym_this] = ACTIONS(3679),
    [anon_sym_scoped] = ACTIONS(3679),
    [anon_sym_base] = ACTIONS(3679),
    [anon_sym_var] = ACTIONS(3679),
    [sym_predefined_type] = ACTIONS(3679),
    [anon_sym_break] = ACTIONS(3679),
    [anon_sym_unchecked] = ACTIONS(3679),
    [anon_sym_continue] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_lock] = ACTIONS(3679),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_switch] = ACTIONS(3679),
    [anon_sym_default] = ACTIONS(3679),
    [anon_sym_throw] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_when] = ACTIONS(3679),
    [anon_sym_await] = ACTIONS(3679),
    [anon_sym_foreach] = ACTIONS(3679),
    [anon_sym_goto] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_DOT_DOT] = ACTIONS(3681),
    [anon_sym_from] = ACTIONS(3679),
    [anon_sym_into] = ACTIONS(3679),
    [anon_sym_join] = ACTIONS(3679),
    [anon_sym_on] = ACTIONS(3679),
    [anon_sym_equals] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_orderby] = ACTIONS(3679),
    [anon_sym_ascending] = ACTIONS(3679),
    [anon_sym_descending] = ACTIONS(3679),
    [anon_sym_group] = ACTIONS(3679),
    [anon_sym_by] = ACTIONS(3679),
    [anon_sym_select] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_stackalloc] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3679),
    [anon_sym_typeof] = ACTIONS(3679),
    [anon_sym___makeref] = ACTIONS(3679),
    [anon_sym___reftype] = ACTIONS(3679),
    [anon_sym___refvalue] = ACTIONS(3679),
    [sym_null_literal] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [sym_integer_literal] = ACTIONS(3679),
    [sym_real_literal] = ACTIONS(3681),
    [sym_verbatim_string_literal] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token3] = ACTIONS(3681),
    [aux_sym_preproc_else_token1] = ACTIONS(3681),
    [aux_sym_preproc_elif_token1] = ACTIONS(3681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3681),
    [sym_interpolation_verbatim_start] = ACTIONS(3681),
    [sym_interpolation_raw_start] = ACTIONS(3681),
    [sym_raw_string_start] = ACTIONS(3681),
  },
  [2377] = {
    [sym_preproc_region] = STATE(2377),
    [sym_preproc_endregion] = STATE(2377),
    [sym_preproc_line] = STATE(2377),
    [sym_preproc_pragma] = STATE(2377),
    [sym_preproc_nullable] = STATE(2377),
    [sym_preproc_error] = STATE(2377),
    [sym_preproc_define] = STATE(2377),
    [sym_preproc_undef] = STATE(2377),
    [sym__identifier_token] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym_alias] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_using] = ACTIONS(3683),
    [anon_sym_unsafe] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3683),
    [anon_sym_namespace] = ACTIONS(3683),
    [anon_sym_class] = ACTIONS(3683),
    [anon_sym_ref] = ACTIONS(3683),
    [anon_sym_struct] = ACTIONS(3683),
    [anon_sym_enum] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3683),
    [anon_sym_delegate] = ACTIONS(3683),
    [anon_sym_record] = ACTIONS(3683),
    [anon_sym_abstract] = ACTIONS(3683),
    [anon_sym_async] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(3683),
    [anon_sym_file] = ACTIONS(3683),
    [anon_sym_fixed] = ACTIONS(3683),
    [anon_sym_internal] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3683),
    [anon_sym_override] = ACTIONS(3683),
    [anon_sym_partial] = ACTIONS(3683),
    [anon_sym_private] = ACTIONS(3683),
    [anon_sym_protected] = ACTIONS(3683),
    [anon_sym_public] = ACTIONS(3683),
    [anon_sym_readonly] = ACTIONS(3683),
    [anon_sym_required] = ACTIONS(3683),
    [anon_sym_sealed] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_volatile] = ACTIONS(3683),
    [anon_sym_where] = ACTIONS(3683),
    [anon_sym_notnull] = ACTIONS(3683),
    [anon_sym_unmanaged] = ACTIONS(3683),
    [anon_sym_checked] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3685),
    [anon_sym_PLUS_PLUS] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3685),
    [anon_sym_true] = ACTIONS(3683),
    [anon_sym_false] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3685),
    [anon_sym_CARET] = ACTIONS(3685),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_this] = ACTIONS(3683),
    [anon_sym_scoped] = ACTIONS(3683),
    [anon_sym_base] = ACTIONS(3683),
    [anon_sym_var] = ACTIONS(3683),
    [sym_predefined_type] = ACTIONS(3683),
    [anon_sym_break] = ACTIONS(3683),
    [anon_sym_unchecked] = ACTIONS(3683),
    [anon_sym_continue] = ACTIONS(3683),
    [anon_sym_do] = ACTIONS(3683),
    [anon_sym_while] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3683),
    [anon_sym_lock] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3683),
    [anon_sym_switch] = ACTIONS(3683),
    [anon_sym_default] = ACTIONS(3683),
    [anon_sym_throw] = ACTIONS(3683),
    [anon_sym_try] = ACTIONS(3683),
    [anon_sym_when] = ACTIONS(3683),
    [anon_sym_await] = ACTIONS(3683),
    [anon_sym_foreach] = ACTIONS(3683),
    [anon_sym_goto] = ACTIONS(3683),
    [anon_sym_if] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3685),
    [anon_sym_from] = ACTIONS(3683),
    [anon_sym_into] = ACTIONS(3683),
    [anon_sym_join] = ACTIONS(3683),
    [anon_sym_on] = ACTIONS(3683),
    [anon_sym_equals] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_orderby] = ACTIONS(3683),
    [anon_sym_ascending] = ACTIONS(3683),
    [anon_sym_descending] = ACTIONS(3683),
    [anon_sym_group] = ACTIONS(3683),
    [anon_sym_by] = ACTIONS(3683),
    [anon_sym_select] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_stackalloc] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3683),
    [anon_sym_typeof] = ACTIONS(3683),
    [anon_sym___makeref] = ACTIONS(3683),
    [anon_sym___reftype] = ACTIONS(3683),
    [anon_sym___refvalue] = ACTIONS(3683),
    [sym_null_literal] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3685),
    [sym_integer_literal] = ACTIONS(3683),
    [sym_real_literal] = ACTIONS(3685),
    [sym_verbatim_string_literal] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token3] = ACTIONS(3685),
    [aux_sym_preproc_else_token1] = ACTIONS(3685),
    [aux_sym_preproc_elif_token1] = ACTIONS(3685),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3685),
    [sym_interpolation_verbatim_start] = ACTIONS(3685),
    [sym_interpolation_raw_start] = ACTIONS(3685),
    [sym_raw_string_start] = ACTIONS(3685),
  },
  [2378] = {
    [sym_preproc_region] = STATE(2378),
    [sym_preproc_endregion] = STATE(2378),
    [sym_preproc_line] = STATE(2378),
    [sym_preproc_pragma] = STATE(2378),
    [sym_preproc_nullable] = STATE(2378),
    [sym_preproc_error] = STATE(2378),
    [sym_preproc_define] = STATE(2378),
    [sym_preproc_undef] = STATE(2378),
    [sym__identifier_token] = ACTIONS(3687),
    [anon_sym_extern] = ACTIONS(3687),
    [anon_sym_alias] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(3689),
    [anon_sym_global] = ACTIONS(3687),
    [anon_sym_using] = ACTIONS(3687),
    [anon_sym_unsafe] = ACTIONS(3687),
    [anon_sym_static] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_namespace] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_ref] = ACTIONS(3687),
    [anon_sym_struct] = ACTIONS(3687),
    [anon_sym_enum] = ACTIONS(3687),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_interface] = ACTIONS(3687),
    [anon_sym_delegate] = ACTIONS(3687),
    [anon_sym_record] = ACTIONS(3687),
    [anon_sym_abstract] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_const] = ACTIONS(3687),
    [anon_sym_file] = ACTIONS(3687),
    [anon_sym_fixed] = ACTIONS(3687),
    [anon_sym_internal] = ACTIONS(3687),
    [anon_sym_new] = ACTIONS(3687),
    [anon_sym_override] = ACTIONS(3687),
    [anon_sym_partial] = ACTIONS(3687),
    [anon_sym_private] = ACTIONS(3687),
    [anon_sym_protected] = ACTIONS(3687),
    [anon_sym_public] = ACTIONS(3687),
    [anon_sym_readonly] = ACTIONS(3687),
    [anon_sym_required] = ACTIONS(3687),
    [anon_sym_sealed] = ACTIONS(3687),
    [anon_sym_virtual] = ACTIONS(3687),
    [anon_sym_volatile] = ACTIONS(3687),
    [anon_sym_where] = ACTIONS(3687),
    [anon_sym_notnull] = ACTIONS(3687),
    [anon_sym_unmanaged] = ACTIONS(3687),
    [anon_sym_checked] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3689),
    [anon_sym_PLUS_PLUS] = ACTIONS(3689),
    [anon_sym_DASH_DASH] = ACTIONS(3689),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_CARET] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_this] = ACTIONS(3687),
    [anon_sym_scoped] = ACTIONS(3687),
    [anon_sym_base] = ACTIONS(3687),
    [anon_sym_var] = ACTIONS(3687),
    [sym_predefined_type] = ACTIONS(3687),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_unchecked] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_do] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_lock] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [anon_sym_switch] = ACTIONS(3687),
    [anon_sym_default] = ACTIONS(3687),
    [anon_sym_throw] = ACTIONS(3687),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_when] = ACTIONS(3687),
    [anon_sym_await] = ACTIONS(3687),
    [anon_sym_foreach] = ACTIONS(3687),
    [anon_sym_goto] = ACTIONS(3687),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_from] = ACTIONS(3687),
    [anon_sym_into] = ACTIONS(3687),
    [anon_sym_join] = ACTIONS(3687),
    [anon_sym_on] = ACTIONS(3687),
    [anon_sym_equals] = ACTIONS(3687),
    [anon_sym_let] = ACTIONS(3687),
    [anon_sym_orderby] = ACTIONS(3687),
    [anon_sym_ascending] = ACTIONS(3687),
    [anon_sym_descending] = ACTIONS(3687),
    [anon_sym_group] = ACTIONS(3687),
    [anon_sym_by] = ACTIONS(3687),
    [anon_sym_select] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_stackalloc] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3687),
    [anon_sym_typeof] = ACTIONS(3687),
    [anon_sym___makeref] = ACTIONS(3687),
    [anon_sym___reftype] = ACTIONS(3687),
    [anon_sym___refvalue] = ACTIONS(3687),
    [sym_null_literal] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3689),
    [sym_integer_literal] = ACTIONS(3687),
    [sym_real_literal] = ACTIONS(3689),
    [sym_verbatim_string_literal] = ACTIONS(3689),
    [aux_sym_preproc_if_token1] = ACTIONS(3689),
    [aux_sym_preproc_if_token3] = ACTIONS(3689),
    [aux_sym_preproc_else_token1] = ACTIONS(3689),
    [aux_sym_preproc_elif_token1] = ACTIONS(3689),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3689),
    [sym_interpolation_verbatim_start] = ACTIONS(3689),
    [sym_interpolation_raw_start] = ACTIONS(3689),
    [sym_raw_string_start] = ACTIONS(3689),
  },
  [2379] = {
    [sym_preproc_region] = STATE(2379),
    [sym_preproc_endregion] = STATE(2379),
    [sym_preproc_line] = STATE(2379),
    [sym_preproc_pragma] = STATE(2379),
    [sym_preproc_nullable] = STATE(2379),
    [sym_preproc_error] = STATE(2379),
    [sym_preproc_define] = STATE(2379),
    [sym_preproc_undef] = STATE(2379),
    [sym__identifier_token] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym_alias] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym_global] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_unsafe] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_ref] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_delegate] = ACTIONS(3691),
    [anon_sym_record] = ACTIONS(3691),
    [anon_sym_abstract] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_file] = ACTIONS(3691),
    [anon_sym_fixed] = ACTIONS(3691),
    [anon_sym_internal] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_override] = ACTIONS(3691),
    [anon_sym_partial] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_readonly] = ACTIONS(3691),
    [anon_sym_required] = ACTIONS(3691),
    [anon_sym_sealed] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_where] = ACTIONS(3691),
    [anon_sym_notnull] = ACTIONS(3691),
    [anon_sym_unmanaged] = ACTIONS(3691),
    [anon_sym_checked] = ACTIONS(3691),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_true] = ACTIONS(3691),
    [anon_sym_false] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_CARET] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_this] = ACTIONS(3691),
    [anon_sym_scoped] = ACTIONS(3691),
    [anon_sym_base] = ACTIONS(3691),
    [anon_sym_var] = ACTIONS(3691),
    [sym_predefined_type] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_unchecked] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_lock] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_when] = ACTIONS(3691),
    [anon_sym_await] = ACTIONS(3691),
    [anon_sym_foreach] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3693),
    [anon_sym_from] = ACTIONS(3691),
    [anon_sym_into] = ACTIONS(3691),
    [anon_sym_join] = ACTIONS(3691),
    [anon_sym_on] = ACTIONS(3691),
    [anon_sym_equals] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_orderby] = ACTIONS(3691),
    [anon_sym_ascending] = ACTIONS(3691),
    [anon_sym_descending] = ACTIONS(3691),
    [anon_sym_group] = ACTIONS(3691),
    [anon_sym_by] = ACTIONS(3691),
    [anon_sym_select] = ACTIONS(3691),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_stackalloc] = ACTIONS(3691),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym_typeof] = ACTIONS(3691),
    [anon_sym___makeref] = ACTIONS(3691),
    [anon_sym___reftype] = ACTIONS(3691),
    [anon_sym___refvalue] = ACTIONS(3691),
    [sym_null_literal] = ACTIONS(3691),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [sym_integer_literal] = ACTIONS(3691),
    [sym_real_literal] = ACTIONS(3693),
    [sym_verbatim_string_literal] = ACTIONS(3693),
    [aux_sym_preproc_if_token1] = ACTIONS(3693),
    [aux_sym_preproc_if_token3] = ACTIONS(3693),
    [aux_sym_preproc_else_token1] = ACTIONS(3693),
    [aux_sym_preproc_elif_token1] = ACTIONS(3693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3693),
    [sym_interpolation_verbatim_start] = ACTIONS(3693),
    [sym_interpolation_raw_start] = ACTIONS(3693),
    [sym_raw_string_start] = ACTIONS(3693),
  },
  [2380] = {
    [sym_preproc_region] = STATE(2380),
    [sym_preproc_endregion] = STATE(2380),
    [sym_preproc_line] = STATE(2380),
    [sym_preproc_pragma] = STATE(2380),
    [sym_preproc_nullable] = STATE(2380),
    [sym_preproc_error] = STATE(2380),
    [sym_preproc_define] = STATE(2380),
    [sym_preproc_undef] = STATE(2380),
    [sym__identifier_token] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym_alias] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_unsafe] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_ref] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_delegate] = ACTIONS(3695),
    [anon_sym_record] = ACTIONS(3695),
    [anon_sym_abstract] = ACTIONS(3695),
    [anon_sym_async] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_file] = ACTIONS(3695),
    [anon_sym_fixed] = ACTIONS(3695),
    [anon_sym_internal] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_override] = ACTIONS(3695),
    [anon_sym_partial] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_readonly] = ACTIONS(3695),
    [anon_sym_required] = ACTIONS(3695),
    [anon_sym_sealed] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_where] = ACTIONS(3695),
    [anon_sym_notnull] = ACTIONS(3695),
    [anon_sym_unmanaged] = ACTIONS(3695),
    [anon_sym_checked] = ACTIONS(3695),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_true] = ACTIONS(3695),
    [anon_sym_false] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_CARET] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_this] = ACTIONS(3695),
    [anon_sym_scoped] = ACTIONS(3695),
    [anon_sym_base] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3695),
    [sym_predefined_type] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_unchecked] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_lock] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_when] = ACTIONS(3695),
    [anon_sym_await] = ACTIONS(3695),
    [anon_sym_foreach] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3697),
    [anon_sym_from] = ACTIONS(3695),
    [anon_sym_into] = ACTIONS(3695),
    [anon_sym_join] = ACTIONS(3695),
    [anon_sym_on] = ACTIONS(3695),
    [anon_sym_equals] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_orderby] = ACTIONS(3695),
    [anon_sym_ascending] = ACTIONS(3695),
    [anon_sym_descending] = ACTIONS(3695),
    [anon_sym_group] = ACTIONS(3695),
    [anon_sym_by] = ACTIONS(3695),
    [anon_sym_select] = ACTIONS(3695),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_stackalloc] = ACTIONS(3695),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym_typeof] = ACTIONS(3695),
    [anon_sym___makeref] = ACTIONS(3695),
    [anon_sym___reftype] = ACTIONS(3695),
    [anon_sym___refvalue] = ACTIONS(3695),
    [sym_null_literal] = ACTIONS(3695),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [sym_integer_literal] = ACTIONS(3695),
    [sym_real_literal] = ACTIONS(3697),
    [sym_verbatim_string_literal] = ACTIONS(3697),
    [aux_sym_preproc_if_token1] = ACTIONS(3697),
    [aux_sym_preproc_if_token3] = ACTIONS(3697),
    [aux_sym_preproc_else_token1] = ACTIONS(3697),
    [aux_sym_preproc_elif_token1] = ACTIONS(3697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3697),
    [sym_interpolation_verbatim_start] = ACTIONS(3697),
    [sym_interpolation_raw_start] = ACTIONS(3697),
    [sym_raw_string_start] = ACTIONS(3697),
  },
  [2381] = {
    [sym_preproc_region] = STATE(2381),
    [sym_preproc_endregion] = STATE(2381),
    [sym_preproc_line] = STATE(2381),
    [sym_preproc_pragma] = STATE(2381),
    [sym_preproc_nullable] = STATE(2381),
    [sym_preproc_error] = STATE(2381),
    [sym_preproc_define] = STATE(2381),
    [sym_preproc_undef] = STATE(2381),
    [sym__identifier_token] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym_alias] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_unsafe] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_ref] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_delegate] = ACTIONS(3699),
    [anon_sym_record] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3699),
    [anon_sym_fixed] = ACTIONS(3699),
    [anon_sym_internal] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_override] = ACTIONS(3699),
    [anon_sym_partial] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_required] = ACTIONS(3699),
    [anon_sym_sealed] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_where] = ACTIONS(3699),
    [anon_sym_notnull] = ACTIONS(3699),
    [anon_sym_unmanaged] = ACTIONS(3699),
    [anon_sym_checked] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_true] = ACTIONS(3699),
    [anon_sym_false] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_scoped] = ACTIONS(3699),
    [anon_sym_base] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3699),
    [sym_predefined_type] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_unchecked] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_lock] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_when] = ACTIONS(3699),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_foreach] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3699),
    [anon_sym_into] = ACTIONS(3699),
    [anon_sym_join] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_orderby] = ACTIONS(3699),
    [anon_sym_ascending] = ACTIONS(3699),
    [anon_sym_descending] = ACTIONS(3699),
    [anon_sym_group] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_select] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_stackalloc] = ACTIONS(3699),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym___makeref] = ACTIONS(3699),
    [anon_sym___reftype] = ACTIONS(3699),
    [anon_sym___refvalue] = ACTIONS(3699),
    [sym_null_literal] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [sym_integer_literal] = ACTIONS(3699),
    [sym_real_literal] = ACTIONS(3701),
    [sym_verbatim_string_literal] = ACTIONS(3701),
    [aux_sym_preproc_if_token1] = ACTIONS(3701),
    [aux_sym_preproc_if_token3] = ACTIONS(3701),
    [aux_sym_preproc_else_token1] = ACTIONS(3701),
    [aux_sym_preproc_elif_token1] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3701),
    [sym_interpolation_verbatim_start] = ACTIONS(3701),
    [sym_interpolation_raw_start] = ACTIONS(3701),
    [sym_raw_string_start] = ACTIONS(3701),
  },
  [2382] = {
    [sym_preproc_region] = STATE(2382),
    [sym_preproc_endregion] = STATE(2382),
    [sym_preproc_line] = STATE(2382),
    [sym_preproc_pragma] = STATE(2382),
    [sym_preproc_nullable] = STATE(2382),
    [sym_preproc_error] = STATE(2382),
    [sym_preproc_define] = STATE(2382),
    [sym_preproc_undef] = STATE(2382),
    [sym__identifier_token] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym_alias] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_global] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_unsafe] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_interface] = ACTIONS(3063),
    [anon_sym_delegate] = ACTIONS(3063),
    [anon_sym_record] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_file] = ACTIONS(3063),
    [anon_sym_fixed] = ACTIONS(3063),
    [anon_sym_internal] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_override] = ACTIONS(3063),
    [anon_sym_partial] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_readonly] = ACTIONS(3063),
    [anon_sym_required] = ACTIONS(3063),
    [anon_sym_sealed] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_notnull] = ACTIONS(3063),
    [anon_sym_unmanaged] = ACTIONS(3063),
    [anon_sym_checked] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_true] = ACTIONS(3063),
    [anon_sym_false] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_this] = ACTIONS(3063),
    [anon_sym_scoped] = ACTIONS(3063),
    [anon_sym_base] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [sym_predefined_type] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_unchecked] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_when] = ACTIONS(3063),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_from] = ACTIONS(3063),
    [anon_sym_into] = ACTIONS(3063),
    [anon_sym_join] = ACTIONS(3063),
    [anon_sym_on] = ACTIONS(3063),
    [anon_sym_equals] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_orderby] = ACTIONS(3063),
    [anon_sym_ascending] = ACTIONS(3063),
    [anon_sym_descending] = ACTIONS(3063),
    [anon_sym_group] = ACTIONS(3063),
    [anon_sym_by] = ACTIONS(3063),
    [anon_sym_select] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym___makeref] = ACTIONS(3063),
    [anon_sym___reftype] = ACTIONS(3063),
    [anon_sym___refvalue] = ACTIONS(3063),
    [sym_null_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_integer_literal] = ACTIONS(3063),
    [sym_real_literal] = ACTIONS(3065),
    [sym_verbatim_string_literal] = ACTIONS(3065),
    [aux_sym_preproc_if_token1] = ACTIONS(3065),
    [aux_sym_preproc_if_token3] = ACTIONS(3065),
    [aux_sym_preproc_else_token1] = ACTIONS(3065),
    [aux_sym_preproc_elif_token1] = ACTIONS(3065),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3065),
    [sym_interpolation_verbatim_start] = ACTIONS(3065),
    [sym_interpolation_raw_start] = ACTIONS(3065),
    [sym_raw_string_start] = ACTIONS(3065),
  },
  [2383] = {
    [sym_preproc_region] = STATE(2383),
    [sym_preproc_endregion] = STATE(2383),
    [sym_preproc_line] = STATE(2383),
    [sym_preproc_pragma] = STATE(2383),
    [sym_preproc_nullable] = STATE(2383),
    [sym_preproc_error] = STATE(2383),
    [sym_preproc_define] = STATE(2383),
    [sym_preproc_undef] = STATE(2383),
    [sym__identifier_token] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym_alias] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_unsafe] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_ref] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_delegate] = ACTIONS(3703),
    [anon_sym_record] = ACTIONS(3703),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_async] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3703),
    [anon_sym_fixed] = ACTIONS(3703),
    [anon_sym_internal] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_override] = ACTIONS(3703),
    [anon_sym_partial] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_readonly] = ACTIONS(3703),
    [anon_sym_required] = ACTIONS(3703),
    [anon_sym_sealed] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_where] = ACTIONS(3703),
    [anon_sym_notnull] = ACTIONS(3703),
    [anon_sym_unmanaged] = ACTIONS(3703),
    [anon_sym_checked] = ACTIONS(3703),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_true] = ACTIONS(3703),
    [anon_sym_false] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_CARET] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_this] = ACTIONS(3703),
    [anon_sym_scoped] = ACTIONS(3703),
    [anon_sym_base] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3703),
    [sym_predefined_type] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_unchecked] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_lock] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_when] = ACTIONS(3703),
    [anon_sym_await] = ACTIONS(3703),
    [anon_sym_foreach] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_DOT_DOT] = ACTIONS(3705),
    [anon_sym_from] = ACTIONS(3703),
    [anon_sym_into] = ACTIONS(3703),
    [anon_sym_join] = ACTIONS(3703),
    [anon_sym_on] = ACTIONS(3703),
    [anon_sym_equals] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_orderby] = ACTIONS(3703),
    [anon_sym_ascending] = ACTIONS(3703),
    [anon_sym_descending] = ACTIONS(3703),
    [anon_sym_group] = ACTIONS(3703),
    [anon_sym_by] = ACTIONS(3703),
    [anon_sym_select] = ACTIONS(3703),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_stackalloc] = ACTIONS(3703),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym_typeof] = ACTIONS(3703),
    [anon_sym___makeref] = ACTIONS(3703),
    [anon_sym___reftype] = ACTIONS(3703),
    [anon_sym___refvalue] = ACTIONS(3703),
    [sym_null_literal] = ACTIONS(3703),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [sym_integer_literal] = ACTIONS(3703),
    [sym_real_literal] = ACTIONS(3705),
    [sym_verbatim_string_literal] = ACTIONS(3705),
    [aux_sym_preproc_if_token1] = ACTIONS(3705),
    [aux_sym_preproc_if_token3] = ACTIONS(3705),
    [aux_sym_preproc_else_token1] = ACTIONS(3705),
    [aux_sym_preproc_elif_token1] = ACTIONS(3705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3705),
    [sym_interpolation_verbatim_start] = ACTIONS(3705),
    [sym_interpolation_raw_start] = ACTIONS(3705),
    [sym_raw_string_start] = ACTIONS(3705),
  },
  [2384] = {
    [sym_preproc_region] = STATE(2384),
    [sym_preproc_endregion] = STATE(2384),
    [sym_preproc_line] = STATE(2384),
    [sym_preproc_pragma] = STATE(2384),
    [sym_preproc_nullable] = STATE(2384),
    [sym_preproc_error] = STATE(2384),
    [sym_preproc_define] = STATE(2384),
    [sym_preproc_undef] = STATE(2384),
    [sym__identifier_token] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym_alias] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_ref] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_delegate] = ACTIONS(3707),
    [anon_sym_record] = ACTIONS(3707),
    [anon_sym_abstract] = ACTIONS(3707),
    [anon_sym_async] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_file] = ACTIONS(3707),
    [anon_sym_fixed] = ACTIONS(3707),
    [anon_sym_internal] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_override] = ACTIONS(3707),
    [anon_sym_partial] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_readonly] = ACTIONS(3707),
    [anon_sym_required] = ACTIONS(3707),
    [anon_sym_sealed] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_notnull] = ACTIONS(3707),
    [anon_sym_unmanaged] = ACTIONS(3707),
    [anon_sym_checked] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_this] = ACTIONS(3707),
    [anon_sym_scoped] = ACTIONS(3707),
    [anon_sym_base] = ACTIONS(3707),
    [anon_sym_var] = ACTIONS(3707),
    [sym_predefined_type] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_unchecked] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_lock] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_when] = ACTIONS(3707),
    [anon_sym_await] = ACTIONS(3707),
    [anon_sym_foreach] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_from] = ACTIONS(3707),
    [anon_sym_into] = ACTIONS(3707),
    [anon_sym_join] = ACTIONS(3707),
    [anon_sym_on] = ACTIONS(3707),
    [anon_sym_equals] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_orderby] = ACTIONS(3707),
    [anon_sym_ascending] = ACTIONS(3707),
    [anon_sym_descending] = ACTIONS(3707),
    [anon_sym_group] = ACTIONS(3707),
    [anon_sym_by] = ACTIONS(3707),
    [anon_sym_select] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [anon_sym_stackalloc] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym_typeof] = ACTIONS(3707),
    [anon_sym___makeref] = ACTIONS(3707),
    [anon_sym___reftype] = ACTIONS(3707),
    [anon_sym___refvalue] = ACTIONS(3707),
    [sym_null_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [sym_integer_literal] = ACTIONS(3707),
    [sym_real_literal] = ACTIONS(3709),
    [sym_verbatim_string_literal] = ACTIONS(3709),
    [aux_sym_preproc_if_token1] = ACTIONS(3709),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3709),
    [sym_interpolation_verbatim_start] = ACTIONS(3709),
    [sym_interpolation_raw_start] = ACTIONS(3709),
    [sym_raw_string_start] = ACTIONS(3709),
  },
  [2385] = {
    [sym_preproc_region] = STATE(2385),
    [sym_preproc_endregion] = STATE(2385),
    [sym_preproc_line] = STATE(2385),
    [sym_preproc_pragma] = STATE(2385),
    [sym_preproc_nullable] = STATE(2385),
    [sym_preproc_error] = STATE(2385),
    [sym_preproc_define] = STATE(2385),
    [sym_preproc_undef] = STATE(2385),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_unsafe] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_ref] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_delegate] = ACTIONS(3711),
    [anon_sym_record] = ACTIONS(3711),
    [anon_sym_abstract] = ACTIONS(3711),
    [anon_sym_async] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_fixed] = ACTIONS(3711),
    [anon_sym_internal] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_override] = ACTIONS(3711),
    [anon_sym_partial] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_readonly] = ACTIONS(3711),
    [anon_sym_required] = ACTIONS(3711),
    [anon_sym_sealed] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_checked] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_true] = ACTIONS(3711),
    [anon_sym_false] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_this] = ACTIONS(3711),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_base] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [sym_predefined_type] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_unchecked] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_lock] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_await] = ACTIONS(3711),
    [anon_sym_foreach] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3713),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [anon_sym_stackalloc] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym_typeof] = ACTIONS(3711),
    [anon_sym___makeref] = ACTIONS(3711),
    [anon_sym___reftype] = ACTIONS(3711),
    [anon_sym___refvalue] = ACTIONS(3711),
    [sym_null_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [sym_integer_literal] = ACTIONS(3711),
    [sym_real_literal] = ACTIONS(3713),
    [sym_verbatim_string_literal] = ACTIONS(3713),
    [aux_sym_preproc_if_token1] = ACTIONS(3713),
    [aux_sym_preproc_if_token3] = ACTIONS(3713),
    [aux_sym_preproc_else_token1] = ACTIONS(3713),
    [aux_sym_preproc_elif_token1] = ACTIONS(3713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3713),
    [sym_interpolation_verbatim_start] = ACTIONS(3713),
    [sym_interpolation_raw_start] = ACTIONS(3713),
    [sym_raw_string_start] = ACTIONS(3713),
  },
  [2386] = {
    [sym_preproc_region] = STATE(2386),
    [sym_preproc_endregion] = STATE(2386),
    [sym_preproc_line] = STATE(2386),
    [sym_preproc_pragma] = STATE(2386),
    [sym_preproc_nullable] = STATE(2386),
    [sym_preproc_error] = STATE(2386),
    [sym_preproc_define] = STATE(2386),
    [sym_preproc_undef] = STATE(2386),
    [sym__identifier_token] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym_alias] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_global] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_unsafe] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(3717),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_ref] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_delegate] = ACTIONS(3715),
    [anon_sym_record] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_file] = ACTIONS(3715),
    [anon_sym_fixed] = ACTIONS(3715),
    [anon_sym_internal] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_partial] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_required] = ACTIONS(3715),
    [anon_sym_sealed] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_where] = ACTIONS(3715),
    [anon_sym_notnull] = ACTIONS(3715),
    [anon_sym_unmanaged] = ACTIONS(3715),
    [anon_sym_checked] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_true] = ACTIONS(3715),
    [anon_sym_false] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_CARET] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3717),
    [anon_sym_this] = ACTIONS(3715),
    [anon_sym_scoped] = ACTIONS(3715),
    [anon_sym_base] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [sym_predefined_type] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_unchecked] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_lock] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_when] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_foreach] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_DOT_DOT] = ACTIONS(3717),
    [anon_sym_from] = ACTIONS(3715),
    [anon_sym_into] = ACTIONS(3715),
    [anon_sym_join] = ACTIONS(3715),
    [anon_sym_on] = ACTIONS(3715),
    [anon_sym_equals] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_orderby] = ACTIONS(3715),
    [anon_sym_ascending] = ACTIONS(3715),
    [anon_sym_descending] = ACTIONS(3715),
    [anon_sym_group] = ACTIONS(3715),
    [anon_sym_by] = ACTIONS(3715),
    [anon_sym_select] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [anon_sym_stackalloc] = ACTIONS(3715),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym___makeref] = ACTIONS(3715),
    [anon_sym___reftype] = ACTIONS(3715),
    [anon_sym___refvalue] = ACTIONS(3715),
    [sym_null_literal] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [sym_integer_literal] = ACTIONS(3715),
    [sym_real_literal] = ACTIONS(3717),
    [sym_verbatim_string_literal] = ACTIONS(3717),
    [aux_sym_preproc_if_token1] = ACTIONS(3717),
    [aux_sym_preproc_if_token3] = ACTIONS(3717),
    [aux_sym_preproc_else_token1] = ACTIONS(3717),
    [aux_sym_preproc_elif_token1] = ACTIONS(3717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3717),
    [sym_interpolation_verbatim_start] = ACTIONS(3717),
    [sym_interpolation_raw_start] = ACTIONS(3717),
    [sym_raw_string_start] = ACTIONS(3717),
  },
  [2387] = {
    [sym_preproc_region] = STATE(2387),
    [sym_preproc_endregion] = STATE(2387),
    [sym_preproc_line] = STATE(2387),
    [sym_preproc_pragma] = STATE(2387),
    [sym_preproc_nullable] = STATE(2387),
    [sym_preproc_error] = STATE(2387),
    [sym_preproc_define] = STATE(2387),
    [sym_preproc_undef] = STATE(2387),
    [sym__identifier_token] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym_alias] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_unsafe] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3721),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3719),
    [anon_sym_record] = ACTIONS(3719),
    [anon_sym_abstract] = ACTIONS(3719),
    [anon_sym_async] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3719),
    [anon_sym_fixed] = ACTIONS(3719),
    [anon_sym_internal] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_override] = ACTIONS(3719),
    [anon_sym_partial] = ACTIONS(3719),
    [anon_sym_private] = ACTIONS(3719),
    [anon_sym_protected] = ACTIONS(3719),
    [anon_sym_public] = ACTIONS(3719),
    [anon_sym_readonly] = ACTIONS(3719),
    [anon_sym_required] = ACTIONS(3719),
    [anon_sym_sealed] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3719),
    [anon_sym_unmanaged] = ACTIONS(3719),
    [anon_sym_checked] = ACTIONS(3719),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_true] = ACTIONS(3719),
    [anon_sym_false] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_this] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3719),
    [anon_sym_base] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3719),
    [sym_predefined_type] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_unchecked] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_lock] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_await] = ACTIONS(3719),
    [anon_sym_foreach] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_ascending] = ACTIONS(3719),
    [anon_sym_descending] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [anon_sym_stackalloc] = ACTIONS(3719),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym_typeof] = ACTIONS(3719),
    [anon_sym___makeref] = ACTIONS(3719),
    [anon_sym___reftype] = ACTIONS(3719),
    [anon_sym___refvalue] = ACTIONS(3719),
    [sym_null_literal] = ACTIONS(3719),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [sym_integer_literal] = ACTIONS(3719),
    [sym_real_literal] = ACTIONS(3721),
    [sym_verbatim_string_literal] = ACTIONS(3721),
    [aux_sym_preproc_if_token1] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3721),
    [aux_sym_preproc_else_token1] = ACTIONS(3721),
    [aux_sym_preproc_elif_token1] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3721),
    [sym_interpolation_verbatim_start] = ACTIONS(3721),
    [sym_interpolation_raw_start] = ACTIONS(3721),
    [sym_raw_string_start] = ACTIONS(3721),
  },
  [2388] = {
    [sym_preproc_region] = STATE(2388),
    [sym_preproc_endregion] = STATE(2388),
    [sym_preproc_line] = STATE(2388),
    [sym_preproc_pragma] = STATE(2388),
    [sym_preproc_nullable] = STATE(2388),
    [sym_preproc_error] = STATE(2388),
    [sym_preproc_define] = STATE(2388),
    [sym_preproc_undef] = STATE(2388),
    [sym__identifier_token] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym_alias] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_global] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_unsafe] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_ref] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_delegate] = ACTIONS(3723),
    [anon_sym_record] = ACTIONS(3723),
    [anon_sym_abstract] = ACTIONS(3723),
    [anon_sym_async] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_file] = ACTIONS(3723),
    [anon_sym_fixed] = ACTIONS(3723),
    [anon_sym_internal] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_override] = ACTIONS(3723),
    [anon_sym_partial] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(3723),
    [anon_sym_protected] = ACTIONS(3723),
    [anon_sym_public] = ACTIONS(3723),
    [anon_sym_readonly] = ACTIONS(3723),
    [anon_sym_required] = ACTIONS(3723),
    [anon_sym_sealed] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_where] = ACTIONS(3723),
    [anon_sym_notnull] = ACTIONS(3723),
    [anon_sym_unmanaged] = ACTIONS(3723),
    [anon_sym_checked] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_true] = ACTIONS(3723),
    [anon_sym_false] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_this] = ACTIONS(3723),
    [anon_sym_scoped] = ACTIONS(3723),
    [anon_sym_base] = ACTIONS(3723),
    [anon_sym_var] = ACTIONS(3723),
    [sym_predefined_type] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_unchecked] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_lock] = ACTIONS(3723),
    [anon_sym_yield] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_when] = ACTIONS(3723),
    [anon_sym_await] = ACTIONS(3723),
    [anon_sym_foreach] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_DOT_DOT] = ACTIONS(3725),
    [anon_sym_from] = ACTIONS(3723),
    [anon_sym_into] = ACTIONS(3723),
    [anon_sym_join] = ACTIONS(3723),
    [anon_sym_on] = ACTIONS(3723),
    [anon_sym_equals] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_orderby] = ACTIONS(3723),
    [anon_sym_ascending] = ACTIONS(3723),
    [anon_sym_descending] = ACTIONS(3723),
    [anon_sym_group] = ACTIONS(3723),
    [anon_sym_by] = ACTIONS(3723),
    [anon_sym_select] = ACTIONS(3723),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [anon_sym_stackalloc] = ACTIONS(3723),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym_typeof] = ACTIONS(3723),
    [anon_sym___makeref] = ACTIONS(3723),
    [anon_sym___reftype] = ACTIONS(3723),
    [anon_sym___refvalue] = ACTIONS(3723),
    [sym_null_literal] = ACTIONS(3723),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [sym_integer_literal] = ACTIONS(3723),
    [sym_real_literal] = ACTIONS(3725),
    [sym_verbatim_string_literal] = ACTIONS(3725),
    [aux_sym_preproc_if_token1] = ACTIONS(3725),
    [aux_sym_preproc_if_token3] = ACTIONS(3725),
    [aux_sym_preproc_else_token1] = ACTIONS(3725),
    [aux_sym_preproc_elif_token1] = ACTIONS(3725),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3725),
    [sym_interpolation_verbatim_start] = ACTIONS(3725),
    [sym_interpolation_raw_start] = ACTIONS(3725),
    [sym_raw_string_start] = ACTIONS(3725),
  },
  [2389] = {
    [sym_preproc_region] = STATE(2389),
    [sym_preproc_endregion] = STATE(2389),
    [sym_preproc_line] = STATE(2389),
    [sym_preproc_pragma] = STATE(2389),
    [sym_preproc_nullable] = STATE(2389),
    [sym_preproc_error] = STATE(2389),
    [sym_preproc_define] = STATE(2389),
    [sym_preproc_undef] = STATE(2389),
    [sym__identifier_token] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym_alias] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_global] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_unsafe] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3729),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_ref] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_delegate] = ACTIONS(3727),
    [anon_sym_record] = ACTIONS(3727),
    [anon_sym_abstract] = ACTIONS(3727),
    [anon_sym_async] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_file] = ACTIONS(3727),
    [anon_sym_fixed] = ACTIONS(3727),
    [anon_sym_internal] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_override] = ACTIONS(3727),
    [anon_sym_partial] = ACTIONS(3727),
    [anon_sym_private] = ACTIONS(3727),
    [anon_sym_protected] = ACTIONS(3727),
    [anon_sym_public] = ACTIONS(3727),
    [anon_sym_readonly] = ACTIONS(3727),
    [anon_sym_required] = ACTIONS(3727),
    [anon_sym_sealed] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_where] = ACTIONS(3727),
    [anon_sym_notnull] = ACTIONS(3727),
    [anon_sym_unmanaged] = ACTIONS(3727),
    [anon_sym_checked] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_true] = ACTIONS(3727),
    [anon_sym_false] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_this] = ACTIONS(3727),
    [anon_sym_scoped] = ACTIONS(3727),
    [anon_sym_base] = ACTIONS(3727),
    [anon_sym_var] = ACTIONS(3727),
    [sym_predefined_type] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_unchecked] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_lock] = ACTIONS(3727),
    [anon_sym_yield] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_when] = ACTIONS(3727),
    [anon_sym_await] = ACTIONS(3727),
    [anon_sym_foreach] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_DOT_DOT] = ACTIONS(3729),
    [anon_sym_from] = ACTIONS(3727),
    [anon_sym_into] = ACTIONS(3727),
    [anon_sym_join] = ACTIONS(3727),
    [anon_sym_on] = ACTIONS(3727),
    [anon_sym_equals] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_orderby] = ACTIONS(3727),
    [anon_sym_ascending] = ACTIONS(3727),
    [anon_sym_descending] = ACTIONS(3727),
    [anon_sym_group] = ACTIONS(3727),
    [anon_sym_by] = ACTIONS(3727),
    [anon_sym_select] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [anon_sym_stackalloc] = ACTIONS(3727),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym_typeof] = ACTIONS(3727),
    [anon_sym___makeref] = ACTIONS(3727),
    [anon_sym___reftype] = ACTIONS(3727),
    [anon_sym___refvalue] = ACTIONS(3727),
    [sym_null_literal] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [sym_integer_literal] = ACTIONS(3727),
    [sym_real_literal] = ACTIONS(3729),
    [sym_verbatim_string_literal] = ACTIONS(3729),
    [aux_sym_preproc_if_token1] = ACTIONS(3729),
    [aux_sym_preproc_if_token3] = ACTIONS(3729),
    [aux_sym_preproc_else_token1] = ACTIONS(3729),
    [aux_sym_preproc_elif_token1] = ACTIONS(3729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3729),
    [sym_interpolation_verbatim_start] = ACTIONS(3729),
    [sym_interpolation_raw_start] = ACTIONS(3729),
    [sym_raw_string_start] = ACTIONS(3729),
  },
  [2390] = {
    [sym_preproc_region] = STATE(2390),
    [sym_preproc_endregion] = STATE(2390),
    [sym_preproc_line] = STATE(2390),
    [sym_preproc_pragma] = STATE(2390),
    [sym_preproc_nullable] = STATE(2390),
    [sym_preproc_error] = STATE(2390),
    [sym_preproc_define] = STATE(2390),
    [sym_preproc_undef] = STATE(2390),
    [sym__identifier_token] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym_alias] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym_global] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_unsafe] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_ref] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_delegate] = ACTIONS(3731),
    [anon_sym_record] = ACTIONS(3731),
    [anon_sym_abstract] = ACTIONS(3731),
    [anon_sym_async] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_file] = ACTIONS(3731),
    [anon_sym_fixed] = ACTIONS(3731),
    [anon_sym_internal] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_override] = ACTIONS(3731),
    [anon_sym_partial] = ACTIONS(3731),
    [anon_sym_private] = ACTIONS(3731),
    [anon_sym_protected] = ACTIONS(3731),
    [anon_sym_public] = ACTIONS(3731),
    [anon_sym_readonly] = ACTIONS(3731),
    [anon_sym_required] = ACTIONS(3731),
    [anon_sym_sealed] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_where] = ACTIONS(3731),
    [anon_sym_notnull] = ACTIONS(3731),
    [anon_sym_unmanaged] = ACTIONS(3731),
    [anon_sym_checked] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_true] = ACTIONS(3731),
    [anon_sym_false] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_CARET] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3733),
    [anon_sym_this] = ACTIONS(3731),
    [anon_sym_scoped] = ACTIONS(3731),
    [anon_sym_base] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3731),
    [sym_predefined_type] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_unchecked] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_lock] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(3731),
    [anon_sym_await] = ACTIONS(3731),
    [anon_sym_foreach] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3733),
    [anon_sym_from] = ACTIONS(3731),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_join] = ACTIONS(3731),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_orderby] = ACTIONS(3731),
    [anon_sym_ascending] = ACTIONS(3731),
    [anon_sym_descending] = ACTIONS(3731),
    [anon_sym_group] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_select] = ACTIONS(3731),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [anon_sym_stackalloc] = ACTIONS(3731),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym_typeof] = ACTIONS(3731),
    [anon_sym___makeref] = ACTIONS(3731),
    [anon_sym___reftype] = ACTIONS(3731),
    [anon_sym___refvalue] = ACTIONS(3731),
    [sym_null_literal] = ACTIONS(3731),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [sym_integer_literal] = ACTIONS(3731),
    [sym_real_literal] = ACTIONS(3733),
    [sym_verbatim_string_literal] = ACTIONS(3733),
    [aux_sym_preproc_if_token1] = ACTIONS(3733),
    [aux_sym_preproc_if_token3] = ACTIONS(3733),
    [aux_sym_preproc_else_token1] = ACTIONS(3733),
    [aux_sym_preproc_elif_token1] = ACTIONS(3733),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3733),
    [sym_interpolation_verbatim_start] = ACTIONS(3733),
    [sym_interpolation_raw_start] = ACTIONS(3733),
    [sym_raw_string_start] = ACTIONS(3733),
  },
  [2391] = {
    [sym_preproc_region] = STATE(2391),
    [sym_preproc_endregion] = STATE(2391),
    [sym_preproc_line] = STATE(2391),
    [sym_preproc_pragma] = STATE(2391),
    [sym_preproc_nullable] = STATE(2391),
    [sym_preproc_error] = STATE(2391),
    [sym_preproc_define] = STATE(2391),
    [sym_preproc_undef] = STATE(2391),
    [sym__identifier_token] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym_alias] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym_global] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_unsafe] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3737),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_ref] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_delegate] = ACTIONS(3735),
    [anon_sym_record] = ACTIONS(3735),
    [anon_sym_abstract] = ACTIONS(3735),
    [anon_sym_async] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_file] = ACTIONS(3735),
    [anon_sym_fixed] = ACTIONS(3735),
    [anon_sym_internal] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_override] = ACTIONS(3735),
    [anon_sym_partial] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_readonly] = ACTIONS(3735),
    [anon_sym_required] = ACTIONS(3735),
    [anon_sym_sealed] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_where] = ACTIONS(3735),
    [anon_sym_notnull] = ACTIONS(3735),
    [anon_sym_unmanaged] = ACTIONS(3735),
    [anon_sym_checked] = ACTIONS(3735),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_true] = ACTIONS(3735),
    [anon_sym_false] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_CARET] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_this] = ACTIONS(3735),
    [anon_sym_scoped] = ACTIONS(3735),
    [anon_sym_base] = ACTIONS(3735),
    [anon_sym_var] = ACTIONS(3735),
    [sym_predefined_type] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_unchecked] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_lock] = ACTIONS(3735),
    [anon_sym_yield] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_when] = ACTIONS(3735),
    [anon_sym_await] = ACTIONS(3735),
    [anon_sym_foreach] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_DOT_DOT] = ACTIONS(3737),
    [anon_sym_from] = ACTIONS(3735),
    [anon_sym_into] = ACTIONS(3735),
    [anon_sym_join] = ACTIONS(3735),
    [anon_sym_on] = ACTIONS(3735),
    [anon_sym_equals] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_orderby] = ACTIONS(3735),
    [anon_sym_ascending] = ACTIONS(3735),
    [anon_sym_descending] = ACTIONS(3735),
    [anon_sym_group] = ACTIONS(3735),
    [anon_sym_by] = ACTIONS(3735),
    [anon_sym_select] = ACTIONS(3735),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [anon_sym_stackalloc] = ACTIONS(3735),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3735),
    [anon_sym___makeref] = ACTIONS(3735),
    [anon_sym___reftype] = ACTIONS(3735),
    [anon_sym___refvalue] = ACTIONS(3735),
    [sym_null_literal] = ACTIONS(3735),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [sym_integer_literal] = ACTIONS(3735),
    [sym_real_literal] = ACTIONS(3737),
    [sym_verbatim_string_literal] = ACTIONS(3737),
    [aux_sym_preproc_if_token1] = ACTIONS(3737),
    [aux_sym_preproc_if_token3] = ACTIONS(3737),
    [aux_sym_preproc_else_token1] = ACTIONS(3737),
    [aux_sym_preproc_elif_token1] = ACTIONS(3737),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3737),
    [sym_interpolation_verbatim_start] = ACTIONS(3737),
    [sym_interpolation_raw_start] = ACTIONS(3737),
    [sym_raw_string_start] = ACTIONS(3737),
  },
  [2392] = {
    [sym_preproc_region] = STATE(2392),
    [sym_preproc_endregion] = STATE(2392),
    [sym_preproc_line] = STATE(2392),
    [sym_preproc_pragma] = STATE(2392),
    [sym_preproc_nullable] = STATE(2392),
    [sym_preproc_error] = STATE(2392),
    [sym_preproc_define] = STATE(2392),
    [sym_preproc_undef] = STATE(2392),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_global] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_unsafe] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_ref] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_delegate] = ACTIONS(3739),
    [anon_sym_record] = ACTIONS(3739),
    [anon_sym_abstract] = ACTIONS(3739),
    [anon_sym_async] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_file] = ACTIONS(3739),
    [anon_sym_fixed] = ACTIONS(3739),
    [anon_sym_internal] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_override] = ACTIONS(3739),
    [anon_sym_partial] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_readonly] = ACTIONS(3739),
    [anon_sym_required] = ACTIONS(3739),
    [anon_sym_sealed] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_where] = ACTIONS(3739),
    [anon_sym_notnull] = ACTIONS(3739),
    [anon_sym_unmanaged] = ACTIONS(3739),
    [anon_sym_checked] = ACTIONS(3739),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_true] = ACTIONS(3739),
    [anon_sym_false] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_CARET] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_this] = ACTIONS(3739),
    [anon_sym_scoped] = ACTIONS(3739),
    [anon_sym_base] = ACTIONS(3739),
    [anon_sym_var] = ACTIONS(3739),
    [sym_predefined_type] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_unchecked] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_lock] = ACTIONS(3739),
    [anon_sym_yield] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_when] = ACTIONS(3739),
    [anon_sym_await] = ACTIONS(3739),
    [anon_sym_foreach] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_from] = ACTIONS(3739),
    [anon_sym_into] = ACTIONS(3739),
    [anon_sym_join] = ACTIONS(3739),
    [anon_sym_on] = ACTIONS(3739),
    [anon_sym_equals] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_orderby] = ACTIONS(3739),
    [anon_sym_ascending] = ACTIONS(3739),
    [anon_sym_descending] = ACTIONS(3739),
    [anon_sym_group] = ACTIONS(3739),
    [anon_sym_by] = ACTIONS(3739),
    [anon_sym_select] = ACTIONS(3739),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [anon_sym_stackalloc] = ACTIONS(3739),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym_typeof] = ACTIONS(3739),
    [anon_sym___makeref] = ACTIONS(3739),
    [anon_sym___reftype] = ACTIONS(3739),
    [anon_sym___refvalue] = ACTIONS(3739),
    [sym_null_literal] = ACTIONS(3739),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [sym_integer_literal] = ACTIONS(3739),
    [sym_real_literal] = ACTIONS(3741),
    [sym_verbatim_string_literal] = ACTIONS(3741),
    [aux_sym_preproc_if_token1] = ACTIONS(3741),
    [aux_sym_preproc_if_token3] = ACTIONS(3741),
    [aux_sym_preproc_else_token1] = ACTIONS(3741),
    [aux_sym_preproc_elif_token1] = ACTIONS(3741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3741),
    [sym_interpolation_verbatim_start] = ACTIONS(3741),
    [sym_interpolation_raw_start] = ACTIONS(3741),
    [sym_raw_string_start] = ACTIONS(3741),
  },
  [2393] = {
    [sym_preproc_region] = STATE(2393),
    [sym_preproc_endregion] = STATE(2393),
    [sym_preproc_line] = STATE(2393),
    [sym_preproc_pragma] = STATE(2393),
    [sym_preproc_nullable] = STATE(2393),
    [sym_preproc_error] = STATE(2393),
    [sym_preproc_define] = STATE(2393),
    [sym_preproc_undef] = STATE(2393),
    [sym__identifier_token] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_unsafe] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_ref] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_delegate] = ACTIONS(3743),
    [anon_sym_record] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_fixed] = ACTIONS(3743),
    [anon_sym_internal] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_partial] = ACTIONS(3743),
    [anon_sym_private] = ACTIONS(3743),
    [anon_sym_protected] = ACTIONS(3743),
    [anon_sym_public] = ACTIONS(3743),
    [anon_sym_readonly] = ACTIONS(3743),
    [anon_sym_required] = ACTIONS(3743),
    [anon_sym_sealed] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_checked] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_true] = ACTIONS(3743),
    [anon_sym_false] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_CARET] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_this] = ACTIONS(3743),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_base] = ACTIONS(3743),
    [anon_sym_var] = ACTIONS(3743),
    [sym_predefined_type] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_unchecked] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_lock] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_when] = ACTIONS(3743),
    [anon_sym_await] = ACTIONS(3743),
    [anon_sym_foreach] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_DOT_DOT] = ACTIONS(3745),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [anon_sym_stackalloc] = ACTIONS(3743),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym_typeof] = ACTIONS(3743),
    [anon_sym___makeref] = ACTIONS(3743),
    [anon_sym___reftype] = ACTIONS(3743),
    [anon_sym___refvalue] = ACTIONS(3743),
    [sym_null_literal] = ACTIONS(3743),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [sym_integer_literal] = ACTIONS(3743),
    [sym_real_literal] = ACTIONS(3745),
    [sym_verbatim_string_literal] = ACTIONS(3745),
    [aux_sym_preproc_if_token1] = ACTIONS(3745),
    [aux_sym_preproc_if_token3] = ACTIONS(3745),
    [aux_sym_preproc_else_token1] = ACTIONS(3745),
    [aux_sym_preproc_elif_token1] = ACTIONS(3745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3745),
    [sym_interpolation_verbatim_start] = ACTIONS(3745),
    [sym_interpolation_raw_start] = ACTIONS(3745),
    [sym_raw_string_start] = ACTIONS(3745),
  },
  [2394] = {
    [sym_preproc_region] = STATE(2394),
    [sym_preproc_endregion] = STATE(2394),
    [sym_preproc_line] = STATE(2394),
    [sym_preproc_pragma] = STATE(2394),
    [sym_preproc_nullable] = STATE(2394),
    [sym_preproc_error] = STATE(2394),
    [sym_preproc_define] = STATE(2394),
    [sym_preproc_undef] = STATE(2394),
    [sym__identifier_token] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym_alias] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_global] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_unsafe] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_ref] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_delegate] = ACTIONS(3747),
    [anon_sym_record] = ACTIONS(3747),
    [anon_sym_abstract] = ACTIONS(3747),
    [anon_sym_async] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_file] = ACTIONS(3747),
    [anon_sym_fixed] = ACTIONS(3747),
    [anon_sym_internal] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_override] = ACTIONS(3747),
    [anon_sym_partial] = ACTIONS(3747),
    [anon_sym_private] = ACTIONS(3747),
    [anon_sym_protected] = ACTIONS(3747),
    [anon_sym_public] = ACTIONS(3747),
    [anon_sym_readonly] = ACTIONS(3747),
    [anon_sym_required] = ACTIONS(3747),
    [anon_sym_sealed] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_where] = ACTIONS(3747),
    [anon_sym_notnull] = ACTIONS(3747),
    [anon_sym_unmanaged] = ACTIONS(3747),
    [anon_sym_checked] = ACTIONS(3747),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_true] = ACTIONS(3747),
    [anon_sym_false] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3749),
    [anon_sym_this] = ACTIONS(3747),
    [anon_sym_scoped] = ACTIONS(3747),
    [anon_sym_base] = ACTIONS(3747),
    [anon_sym_var] = ACTIONS(3747),
    [sym_predefined_type] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_unchecked] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_lock] = ACTIONS(3747),
    [anon_sym_yield] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_when] = ACTIONS(3747),
    [anon_sym_await] = ACTIONS(3747),
    [anon_sym_foreach] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_DOT_DOT] = ACTIONS(3749),
    [anon_sym_from] = ACTIONS(3747),
    [anon_sym_into] = ACTIONS(3747),
    [anon_sym_join] = ACTIONS(3747),
    [anon_sym_on] = ACTIONS(3747),
    [anon_sym_equals] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_orderby] = ACTIONS(3747),
    [anon_sym_ascending] = ACTIONS(3747),
    [anon_sym_descending] = ACTIONS(3747),
    [anon_sym_group] = ACTIONS(3747),
    [anon_sym_by] = ACTIONS(3747),
    [anon_sym_select] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [anon_sym_stackalloc] = ACTIONS(3747),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym___makeref] = ACTIONS(3747),
    [anon_sym___reftype] = ACTIONS(3747),
    [anon_sym___refvalue] = ACTIONS(3747),
    [sym_null_literal] = ACTIONS(3747),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [sym_integer_literal] = ACTIONS(3747),
    [sym_real_literal] = ACTIONS(3749),
    [sym_verbatim_string_literal] = ACTIONS(3749),
    [aux_sym_preproc_if_token1] = ACTIONS(3749),
    [aux_sym_preproc_if_token3] = ACTIONS(3749),
    [aux_sym_preproc_else_token1] = ACTIONS(3749),
    [aux_sym_preproc_elif_token1] = ACTIONS(3749),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3749),
    [sym_interpolation_verbatim_start] = ACTIONS(3749),
    [sym_interpolation_raw_start] = ACTIONS(3749),
    [sym_raw_string_start] = ACTIONS(3749),
  },
  [2395] = {
    [sym_preproc_region] = STATE(2395),
    [sym_preproc_endregion] = STATE(2395),
    [sym_preproc_line] = STATE(2395),
    [sym_preproc_pragma] = STATE(2395),
    [sym_preproc_nullable] = STATE(2395),
    [sym_preproc_error] = STATE(2395),
    [sym_preproc_define] = STATE(2395),
    [sym_preproc_undef] = STATE(2395),
    [sym__identifier_token] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym_alias] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym_global] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_unsafe] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_delegate] = ACTIONS(3751),
    [anon_sym_record] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3751),
    [anon_sym_async] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_file] = ACTIONS(3751),
    [anon_sym_fixed] = ACTIONS(3751),
    [anon_sym_internal] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_override] = ACTIONS(3751),
    [anon_sym_partial] = ACTIONS(3751),
    [anon_sym_private] = ACTIONS(3751),
    [anon_sym_protected] = ACTIONS(3751),
    [anon_sym_public] = ACTIONS(3751),
    [anon_sym_readonly] = ACTIONS(3751),
    [anon_sym_required] = ACTIONS(3751),
    [anon_sym_sealed] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_where] = ACTIONS(3751),
    [anon_sym_notnull] = ACTIONS(3751),
    [anon_sym_unmanaged] = ACTIONS(3751),
    [anon_sym_checked] = ACTIONS(3751),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_true] = ACTIONS(3751),
    [anon_sym_false] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_this] = ACTIONS(3751),
    [anon_sym_scoped] = ACTIONS(3751),
    [anon_sym_base] = ACTIONS(3751),
    [anon_sym_var] = ACTIONS(3751),
    [sym_predefined_type] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_unchecked] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_lock] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_when] = ACTIONS(3751),
    [anon_sym_await] = ACTIONS(3751),
    [anon_sym_foreach] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_DOT_DOT] = ACTIONS(3753),
    [anon_sym_from] = ACTIONS(3751),
    [anon_sym_into] = ACTIONS(3751),
    [anon_sym_join] = ACTIONS(3751),
    [anon_sym_on] = ACTIONS(3751),
    [anon_sym_equals] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_orderby] = ACTIONS(3751),
    [anon_sym_ascending] = ACTIONS(3751),
    [anon_sym_descending] = ACTIONS(3751),
    [anon_sym_group] = ACTIONS(3751),
    [anon_sym_by] = ACTIONS(3751),
    [anon_sym_select] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_stackalloc] = ACTIONS(3751),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym_typeof] = ACTIONS(3751),
    [anon_sym___makeref] = ACTIONS(3751),
    [anon_sym___reftype] = ACTIONS(3751),
    [anon_sym___refvalue] = ACTIONS(3751),
    [sym_null_literal] = ACTIONS(3751),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [sym_integer_literal] = ACTIONS(3751),
    [sym_real_literal] = ACTIONS(3753),
    [sym_verbatim_string_literal] = ACTIONS(3753),
    [aux_sym_preproc_if_token1] = ACTIONS(3753),
    [aux_sym_preproc_if_token3] = ACTIONS(3753),
    [aux_sym_preproc_else_token1] = ACTIONS(3753),
    [aux_sym_preproc_elif_token1] = ACTIONS(3753),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3753),
    [sym_interpolation_verbatim_start] = ACTIONS(3753),
    [sym_interpolation_raw_start] = ACTIONS(3753),
    [sym_raw_string_start] = ACTIONS(3753),
  },
  [2396] = {
    [sym_preproc_region] = STATE(2396),
    [sym_preproc_endregion] = STATE(2396),
    [sym_preproc_line] = STATE(2396),
    [sym_preproc_pragma] = STATE(2396),
    [sym_preproc_nullable] = STATE(2396),
    [sym_preproc_error] = STATE(2396),
    [sym_preproc_define] = STATE(2396),
    [sym_preproc_undef] = STATE(2396),
    [sym__identifier_token] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym_alias] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym_global] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_unsafe] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3757),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_ref] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_delegate] = ACTIONS(3755),
    [anon_sym_record] = ACTIONS(3755),
    [anon_sym_abstract] = ACTIONS(3755),
    [anon_sym_async] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_file] = ACTIONS(3755),
    [anon_sym_fixed] = ACTIONS(3755),
    [anon_sym_internal] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_override] = ACTIONS(3755),
    [anon_sym_partial] = ACTIONS(3755),
    [anon_sym_private] = ACTIONS(3755),
    [anon_sym_protected] = ACTIONS(3755),
    [anon_sym_public] = ACTIONS(3755),
    [anon_sym_readonly] = ACTIONS(3755),
    [anon_sym_required] = ACTIONS(3755),
    [anon_sym_sealed] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_where] = ACTIONS(3755),
    [anon_sym_notnull] = ACTIONS(3755),
    [anon_sym_unmanaged] = ACTIONS(3755),
    [anon_sym_checked] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_true] = ACTIONS(3755),
    [anon_sym_false] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_CARET] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_this] = ACTIONS(3755),
    [anon_sym_scoped] = ACTIONS(3755),
    [anon_sym_base] = ACTIONS(3755),
    [anon_sym_var] = ACTIONS(3755),
    [sym_predefined_type] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_unchecked] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_lock] = ACTIONS(3755),
    [anon_sym_yield] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_when] = ACTIONS(3755),
    [anon_sym_await] = ACTIONS(3755),
    [anon_sym_foreach] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_from] = ACTIONS(3755),
    [anon_sym_into] = ACTIONS(3755),
    [anon_sym_join] = ACTIONS(3755),
    [anon_sym_on] = ACTIONS(3755),
    [anon_sym_equals] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_orderby] = ACTIONS(3755),
    [anon_sym_ascending] = ACTIONS(3755),
    [anon_sym_descending] = ACTIONS(3755),
    [anon_sym_group] = ACTIONS(3755),
    [anon_sym_by] = ACTIONS(3755),
    [anon_sym_select] = ACTIONS(3755),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [anon_sym_stackalloc] = ACTIONS(3755),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym_typeof] = ACTIONS(3755),
    [anon_sym___makeref] = ACTIONS(3755),
    [anon_sym___reftype] = ACTIONS(3755),
    [anon_sym___refvalue] = ACTIONS(3755),
    [sym_null_literal] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [sym_integer_literal] = ACTIONS(3755),
    [sym_real_literal] = ACTIONS(3757),
    [sym_verbatim_string_literal] = ACTIONS(3757),
    [aux_sym_preproc_if_token1] = ACTIONS(3757),
    [aux_sym_preproc_if_token3] = ACTIONS(3757),
    [aux_sym_preproc_else_token1] = ACTIONS(3757),
    [aux_sym_preproc_elif_token1] = ACTIONS(3757),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3757),
    [sym_interpolation_verbatim_start] = ACTIONS(3757),
    [sym_interpolation_raw_start] = ACTIONS(3757),
    [sym_raw_string_start] = ACTIONS(3757),
  },
  [2397] = {
    [sym_preproc_region] = STATE(2397),
    [sym_preproc_endregion] = STATE(2397),
    [sym_preproc_line] = STATE(2397),
    [sym_preproc_pragma] = STATE(2397),
    [sym_preproc_nullable] = STATE(2397),
    [sym_preproc_error] = STATE(2397),
    [sym_preproc_define] = STATE(2397),
    [sym_preproc_undef] = STATE(2397),
    [sym__identifier_token] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym_alias] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_global] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_unsafe] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(3761),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_ref] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_async] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_file] = ACTIONS(3759),
    [anon_sym_fixed] = ACTIONS(3759),
    [anon_sym_internal] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [anon_sym_partial] = ACTIONS(3759),
    [anon_sym_private] = ACTIONS(3759),
    [anon_sym_protected] = ACTIONS(3759),
    [anon_sym_public] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3759),
    [anon_sym_required] = ACTIONS(3759),
    [anon_sym_sealed] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_where] = ACTIONS(3759),
    [anon_sym_notnull] = ACTIONS(3759),
    [anon_sym_unmanaged] = ACTIONS(3759),
    [anon_sym_checked] = ACTIONS(3759),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_true] = ACTIONS(3759),
    [anon_sym_false] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_this] = ACTIONS(3759),
    [anon_sym_scoped] = ACTIONS(3759),
    [anon_sym_base] = ACTIONS(3759),
    [anon_sym_var] = ACTIONS(3759),
    [sym_predefined_type] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_unchecked] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_lock] = ACTIONS(3759),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_when] = ACTIONS(3759),
    [anon_sym_await] = ACTIONS(3759),
    [anon_sym_foreach] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_DOT_DOT] = ACTIONS(3761),
    [anon_sym_from] = ACTIONS(3759),
    [anon_sym_into] = ACTIONS(3759),
    [anon_sym_join] = ACTIONS(3759),
    [anon_sym_on] = ACTIONS(3759),
    [anon_sym_equals] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_orderby] = ACTIONS(3759),
    [anon_sym_ascending] = ACTIONS(3759),
    [anon_sym_descending] = ACTIONS(3759),
    [anon_sym_group] = ACTIONS(3759),
    [anon_sym_by] = ACTIONS(3759),
    [anon_sym_select] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [anon_sym_stackalloc] = ACTIONS(3759),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym_typeof] = ACTIONS(3759),
    [anon_sym___makeref] = ACTIONS(3759),
    [anon_sym___reftype] = ACTIONS(3759),
    [anon_sym___refvalue] = ACTIONS(3759),
    [sym_null_literal] = ACTIONS(3759),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [sym_integer_literal] = ACTIONS(3759),
    [sym_real_literal] = ACTIONS(3761),
    [sym_verbatim_string_literal] = ACTIONS(3761),
    [aux_sym_preproc_if_token1] = ACTIONS(3761),
    [aux_sym_preproc_if_token3] = ACTIONS(3761),
    [aux_sym_preproc_else_token1] = ACTIONS(3761),
    [aux_sym_preproc_elif_token1] = ACTIONS(3761),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3761),
    [sym_interpolation_verbatim_start] = ACTIONS(3761),
    [sym_interpolation_raw_start] = ACTIONS(3761),
    [sym_raw_string_start] = ACTIONS(3761),
  },
  [2398] = {
    [sym_preproc_region] = STATE(2398),
    [sym_preproc_endregion] = STATE(2398),
    [sym_preproc_line] = STATE(2398),
    [sym_preproc_pragma] = STATE(2398),
    [sym_preproc_nullable] = STATE(2398),
    [sym_preproc_error] = STATE(2398),
    [sym_preproc_define] = STATE(2398),
    [sym_preproc_undef] = STATE(2398),
    [sym__identifier_token] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym_alias] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_global] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_unsafe] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_ref] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_delegate] = ACTIONS(3763),
    [anon_sym_record] = ACTIONS(3763),
    [anon_sym_abstract] = ACTIONS(3763),
    [anon_sym_async] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_file] = ACTIONS(3763),
    [anon_sym_fixed] = ACTIONS(3763),
    [anon_sym_internal] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_override] = ACTIONS(3763),
    [anon_sym_partial] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_readonly] = ACTIONS(3763),
    [anon_sym_required] = ACTIONS(3763),
    [anon_sym_sealed] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_where] = ACTIONS(3763),
    [anon_sym_notnull] = ACTIONS(3763),
    [anon_sym_unmanaged] = ACTIONS(3763),
    [anon_sym_checked] = ACTIONS(3763),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_true] = ACTIONS(3763),
    [anon_sym_false] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_CARET] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3765),
    [anon_sym_this] = ACTIONS(3763),
    [anon_sym_scoped] = ACTIONS(3763),
    [anon_sym_base] = ACTIONS(3763),
    [anon_sym_var] = ACTIONS(3763),
    [sym_predefined_type] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_unchecked] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_lock] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_when] = ACTIONS(3763),
    [anon_sym_await] = ACTIONS(3763),
    [anon_sym_foreach] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_DOT_DOT] = ACTIONS(3765),
    [anon_sym_from] = ACTIONS(3763),
    [anon_sym_into] = ACTIONS(3763),
    [anon_sym_join] = ACTIONS(3763),
    [anon_sym_on] = ACTIONS(3763),
    [anon_sym_equals] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_orderby] = ACTIONS(3763),
    [anon_sym_ascending] = ACTIONS(3763),
    [anon_sym_descending] = ACTIONS(3763),
    [anon_sym_group] = ACTIONS(3763),
    [anon_sym_by] = ACTIONS(3763),
    [anon_sym_select] = ACTIONS(3763),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [anon_sym_stackalloc] = ACTIONS(3763),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym_typeof] = ACTIONS(3763),
    [anon_sym___makeref] = ACTIONS(3763),
    [anon_sym___reftype] = ACTIONS(3763),
    [anon_sym___refvalue] = ACTIONS(3763),
    [sym_null_literal] = ACTIONS(3763),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [sym_integer_literal] = ACTIONS(3763),
    [sym_real_literal] = ACTIONS(3765),
    [sym_verbatim_string_literal] = ACTIONS(3765),
    [aux_sym_preproc_if_token1] = ACTIONS(3765),
    [aux_sym_preproc_if_token3] = ACTIONS(3765),
    [aux_sym_preproc_else_token1] = ACTIONS(3765),
    [aux_sym_preproc_elif_token1] = ACTIONS(3765),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3765),
    [sym_interpolation_verbatim_start] = ACTIONS(3765),
    [sym_interpolation_raw_start] = ACTIONS(3765),
    [sym_raw_string_start] = ACTIONS(3765),
  },
  [2399] = {
    [sym_preproc_region] = STATE(2399),
    [sym_preproc_endregion] = STATE(2399),
    [sym_preproc_line] = STATE(2399),
    [sym_preproc_pragma] = STATE(2399),
    [sym_preproc_nullable] = STATE(2399),
    [sym_preproc_error] = STATE(2399),
    [sym_preproc_define] = STATE(2399),
    [sym_preproc_undef] = STATE(2399),
    [sym__identifier_token] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym_alias] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym_global] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_unsafe] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(3769),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_ref] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_delegate] = ACTIONS(3767),
    [anon_sym_record] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_async] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_file] = ACTIONS(3767),
    [anon_sym_fixed] = ACTIONS(3767),
    [anon_sym_internal] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [anon_sym_partial] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3767),
    [anon_sym_protected] = ACTIONS(3767),
    [anon_sym_public] = ACTIONS(3767),
    [anon_sym_readonly] = ACTIONS(3767),
    [anon_sym_required] = ACTIONS(3767),
    [anon_sym_sealed] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_where] = ACTIONS(3767),
    [anon_sym_notnull] = ACTIONS(3767),
    [anon_sym_unmanaged] = ACTIONS(3767),
    [anon_sym_checked] = ACTIONS(3767),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_true] = ACTIONS(3767),
    [anon_sym_false] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_this] = ACTIONS(3767),
    [anon_sym_scoped] = ACTIONS(3767),
    [anon_sym_base] = ACTIONS(3767),
    [anon_sym_var] = ACTIONS(3767),
    [sym_predefined_type] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_unchecked] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_lock] = ACTIONS(3767),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_when] = ACTIONS(3767),
    [anon_sym_await] = ACTIONS(3767),
    [anon_sym_foreach] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_DOT_DOT] = ACTIONS(3769),
    [anon_sym_from] = ACTIONS(3767),
    [anon_sym_into] = ACTIONS(3767),
    [anon_sym_join] = ACTIONS(3767),
    [anon_sym_on] = ACTIONS(3767),
    [anon_sym_equals] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_orderby] = ACTIONS(3767),
    [anon_sym_ascending] = ACTIONS(3767),
    [anon_sym_descending] = ACTIONS(3767),
    [anon_sym_group] = ACTIONS(3767),
    [anon_sym_by] = ACTIONS(3767),
    [anon_sym_select] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [anon_sym_stackalloc] = ACTIONS(3767),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym___makeref] = ACTIONS(3767),
    [anon_sym___reftype] = ACTIONS(3767),
    [anon_sym___refvalue] = ACTIONS(3767),
    [sym_null_literal] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [sym_integer_literal] = ACTIONS(3767),
    [sym_real_literal] = ACTIONS(3769),
    [sym_verbatim_string_literal] = ACTIONS(3769),
    [aux_sym_preproc_if_token1] = ACTIONS(3769),
    [aux_sym_preproc_if_token3] = ACTIONS(3769),
    [aux_sym_preproc_else_token1] = ACTIONS(3769),
    [aux_sym_preproc_elif_token1] = ACTIONS(3769),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3769),
    [sym_interpolation_verbatim_start] = ACTIONS(3769),
    [sym_interpolation_raw_start] = ACTIONS(3769),
    [sym_raw_string_start] = ACTIONS(3769),
  },
  [2400] = {
    [sym_preproc_region] = STATE(2400),
    [sym_preproc_endregion] = STATE(2400),
    [sym_preproc_line] = STATE(2400),
    [sym_preproc_pragma] = STATE(2400),
    [sym_preproc_nullable] = STATE(2400),
    [sym_preproc_error] = STATE(2400),
    [sym_preproc_define] = STATE(2400),
    [sym_preproc_undef] = STATE(2400),
    [sym__identifier_token] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym_alias] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym_global] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_unsafe] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_LPAREN] = ACTIONS(3773),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_ref] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_delegate] = ACTIONS(3771),
    [anon_sym_record] = ACTIONS(3771),
    [anon_sym_abstract] = ACTIONS(3771),
    [anon_sym_async] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_file] = ACTIONS(3771),
    [anon_sym_fixed] = ACTIONS(3771),
    [anon_sym_internal] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_override] = ACTIONS(3771),
    [anon_sym_partial] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3771),
    [anon_sym_required] = ACTIONS(3771),
    [anon_sym_sealed] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_where] = ACTIONS(3771),
    [anon_sym_notnull] = ACTIONS(3771),
    [anon_sym_unmanaged] = ACTIONS(3771),
    [anon_sym_checked] = ACTIONS(3771),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_true] = ACTIONS(3771),
    [anon_sym_false] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_CARET] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
    [anon_sym_this] = ACTIONS(3771),
    [anon_sym_scoped] = ACTIONS(3771),
    [anon_sym_base] = ACTIONS(3771),
    [anon_sym_var] = ACTIONS(3771),
    [sym_predefined_type] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_unchecked] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_lock] = ACTIONS(3771),
    [anon_sym_yield] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_when] = ACTIONS(3771),
    [anon_sym_await] = ACTIONS(3771),
    [anon_sym_foreach] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_from] = ACTIONS(3771),
    [anon_sym_into] = ACTIONS(3771),
    [anon_sym_join] = ACTIONS(3771),
    [anon_sym_on] = ACTIONS(3771),
    [anon_sym_equals] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_orderby] = ACTIONS(3771),
    [anon_sym_ascending] = ACTIONS(3771),
    [anon_sym_descending] = ACTIONS(3771),
    [anon_sym_group] = ACTIONS(3771),
    [anon_sym_by] = ACTIONS(3771),
    [anon_sym_select] = ACTIONS(3771),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [anon_sym_stackalloc] = ACTIONS(3771),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym_typeof] = ACTIONS(3771),
    [anon_sym___makeref] = ACTIONS(3771),
    [anon_sym___reftype] = ACTIONS(3771),
    [anon_sym___refvalue] = ACTIONS(3771),
    [sym_null_literal] = ACTIONS(3771),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [sym_integer_literal] = ACTIONS(3771),
    [sym_real_literal] = ACTIONS(3773),
    [sym_verbatim_string_literal] = ACTIONS(3773),
    [aux_sym_preproc_if_token1] = ACTIONS(3773),
    [aux_sym_preproc_if_token3] = ACTIONS(3773),
    [aux_sym_preproc_else_token1] = ACTIONS(3773),
    [aux_sym_preproc_elif_token1] = ACTIONS(3773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3773),
    [sym_interpolation_verbatim_start] = ACTIONS(3773),
    [sym_interpolation_raw_start] = ACTIONS(3773),
    [sym_raw_string_start] = ACTIONS(3773),
  },
  [2401] = {
    [sym_preproc_region] = STATE(2401),
    [sym_preproc_endregion] = STATE(2401),
    [sym_preproc_line] = STATE(2401),
    [sym_preproc_pragma] = STATE(2401),
    [sym_preproc_nullable] = STATE(2401),
    [sym_preproc_error] = STATE(2401),
    [sym_preproc_define] = STATE(2401),
    [sym_preproc_undef] = STATE(2401),
    [sym__identifier_token] = ACTIONS(3775),
    [anon_sym_extern] = ACTIONS(3775),
    [anon_sym_alias] = ACTIONS(3775),
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_global] = ACTIONS(3775),
    [anon_sym_using] = ACTIONS(3775),
    [anon_sym_unsafe] = ACTIONS(3775),
    [anon_sym_static] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_LPAREN] = ACTIONS(3777),
    [anon_sym_return] = ACTIONS(3775),
    [anon_sym_namespace] = ACTIONS(3775),
    [anon_sym_class] = ACTIONS(3775),
    [anon_sym_ref] = ACTIONS(3775),
    [anon_sym_struct] = ACTIONS(3775),
    [anon_sym_enum] = ACTIONS(3775),
    [anon_sym_LBRACE] = ACTIONS(3777),
    [anon_sym_interface] = ACTIONS(3775),
    [anon_sym_delegate] = ACTIONS(3775),
    [anon_sym_record] = ACTIONS(3775),
    [anon_sym_abstract] = ACTIONS(3775),
    [anon_sym_async] = ACTIONS(3775),
    [anon_sym_const] = ACTIONS(3775),
    [anon_sym_file] = ACTIONS(3775),
    [anon_sym_fixed] = ACTIONS(3775),
    [anon_sym_internal] = ACTIONS(3775),
    [anon_sym_new] = ACTIONS(3775),
    [anon_sym_override] = ACTIONS(3775),
    [anon_sym_partial] = ACTIONS(3775),
    [anon_sym_private] = ACTIONS(3775),
    [anon_sym_protected] = ACTIONS(3775),
    [anon_sym_public] = ACTIONS(3775),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_required] = ACTIONS(3775),
    [anon_sym_sealed] = ACTIONS(3775),
    [anon_sym_virtual] = ACTIONS(3775),
    [anon_sym_volatile] = ACTIONS(3775),
    [anon_sym_where] = ACTIONS(3775),
    [anon_sym_notnull] = ACTIONS(3775),
    [anon_sym_unmanaged] = ACTIONS(3775),
    [anon_sym_checked] = ACTIONS(3775),
    [anon_sym_BANG] = ACTIONS(3777),
    [anon_sym_TILDE] = ACTIONS(3777),
    [anon_sym_PLUS_PLUS] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3777),
    [anon_sym_true] = ACTIONS(3775),
    [anon_sym_false] = ACTIONS(3775),
    [anon_sym_PLUS] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3775),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_this] = ACTIONS(3775),
    [anon_sym_scoped] = ACTIONS(3775),
    [anon_sym_base] = ACTIONS(3775),
    [anon_sym_var] = ACTIONS(3775),
    [sym_predefined_type] = ACTIONS(3775),
    [anon_sym_break] = ACTIONS(3775),
    [anon_sym_unchecked] = ACTIONS(3775),
    [anon_sym_continue] = ACTIONS(3775),
    [anon_sym_do] = ACTIONS(3775),
    [anon_sym_while] = ACTIONS(3775),
    [anon_sym_for] = ACTIONS(3775),
    [anon_sym_lock] = ACTIONS(3775),
    [anon_sym_yield] = ACTIONS(3775),
    [anon_sym_switch] = ACTIONS(3775),
    [anon_sym_default] = ACTIONS(3775),
    [anon_sym_throw] = ACTIONS(3775),
    [anon_sym_try] = ACTIONS(3775),
    [anon_sym_when] = ACTIONS(3775),
    [anon_sym_await] = ACTIONS(3775),
    [anon_sym_foreach] = ACTIONS(3775),
    [anon_sym_goto] = ACTIONS(3775),
    [anon_sym_if] = ACTIONS(3775),
    [anon_sym_DOT_DOT] = ACTIONS(3777),
    [anon_sym_from] = ACTIONS(3775),
    [anon_sym_into] = ACTIONS(3775),
    [anon_sym_join] = ACTIONS(3775),
    [anon_sym_on] = ACTIONS(3775),
    [anon_sym_equals] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_orderby] = ACTIONS(3775),
    [anon_sym_ascending] = ACTIONS(3775),
    [anon_sym_descending] = ACTIONS(3775),
    [anon_sym_group] = ACTIONS(3775),
    [anon_sym_by] = ACTIONS(3775),
    [anon_sym_select] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(3777),
    [anon_sym_stackalloc] = ACTIONS(3775),
    [anon_sym_sizeof] = ACTIONS(3775),
    [anon_sym_typeof] = ACTIONS(3775),
    [anon_sym___makeref] = ACTIONS(3775),
    [anon_sym___reftype] = ACTIONS(3775),
    [anon_sym___refvalue] = ACTIONS(3775),
    [sym_null_literal] = ACTIONS(3775),
    [anon_sym_SQUOTE] = ACTIONS(3777),
    [sym_integer_literal] = ACTIONS(3775),
    [sym_real_literal] = ACTIONS(3777),
    [sym_verbatim_string_literal] = ACTIONS(3777),
    [aux_sym_preproc_if_token1] = ACTIONS(3777),
    [aux_sym_preproc_if_token3] = ACTIONS(3777),
    [aux_sym_preproc_else_token1] = ACTIONS(3777),
    [aux_sym_preproc_elif_token1] = ACTIONS(3777),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3777),
    [sym_interpolation_verbatim_start] = ACTIONS(3777),
    [sym_interpolation_raw_start] = ACTIONS(3777),
    [sym_raw_string_start] = ACTIONS(3777),
  },
  [2402] = {
    [sym_preproc_region] = STATE(2402),
    [sym_preproc_endregion] = STATE(2402),
    [sym_preproc_line] = STATE(2402),
    [sym_preproc_pragma] = STATE(2402),
    [sym_preproc_nullable] = STATE(2402),
    [sym_preproc_error] = STATE(2402),
    [sym_preproc_define] = STATE(2402),
    [sym_preproc_undef] = STATE(2402),
    [sym__identifier_token] = ACTIONS(3779),
    [anon_sym_extern] = ACTIONS(3779),
    [anon_sym_alias] = ACTIONS(3779),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_global] = ACTIONS(3779),
    [anon_sym_using] = ACTIONS(3779),
    [anon_sym_unsafe] = ACTIONS(3779),
    [anon_sym_static] = ACTIONS(3779),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3779),
    [anon_sym_namespace] = ACTIONS(3779),
    [anon_sym_class] = ACTIONS(3779),
    [anon_sym_ref] = ACTIONS(3779),
    [anon_sym_struct] = ACTIONS(3779),
    [anon_sym_enum] = ACTIONS(3779),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3779),
    [anon_sym_delegate] = ACTIONS(3779),
    [anon_sym_record] = ACTIONS(3779),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_async] = ACTIONS(3779),
    [anon_sym_const] = ACTIONS(3779),
    [anon_sym_file] = ACTIONS(3779),
    [anon_sym_fixed] = ACTIONS(3779),
    [anon_sym_internal] = ACTIONS(3779),
    [anon_sym_new] = ACTIONS(3779),
    [anon_sym_override] = ACTIONS(3779),
    [anon_sym_partial] = ACTIONS(3779),
    [anon_sym_private] = ACTIONS(3779),
    [anon_sym_protected] = ACTIONS(3779),
    [anon_sym_public] = ACTIONS(3779),
    [anon_sym_readonly] = ACTIONS(3779),
    [anon_sym_required] = ACTIONS(3779),
    [anon_sym_sealed] = ACTIONS(3779),
    [anon_sym_virtual] = ACTIONS(3779),
    [anon_sym_volatile] = ACTIONS(3779),
    [anon_sym_where] = ACTIONS(3779),
    [anon_sym_notnull] = ACTIONS(3779),
    [anon_sym_unmanaged] = ACTIONS(3779),
    [anon_sym_checked] = ACTIONS(3779),
    [anon_sym_BANG] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_true] = ACTIONS(3779),
    [anon_sym_false] = ACTIONS(3779),
    [anon_sym_PLUS] = ACTIONS(3779),
    [anon_sym_DASH] = ACTIONS(3779),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_this] = ACTIONS(3779),
    [anon_sym_scoped] = ACTIONS(3779),
    [anon_sym_base] = ACTIONS(3779),
    [anon_sym_var] = ACTIONS(3779),
    [sym_predefined_type] = ACTIONS(3779),
    [anon_sym_break] = ACTIONS(3779),
    [anon_sym_unchecked] = ACTIONS(3779),
    [anon_sym_continue] = ACTIONS(3779),
    [anon_sym_do] = ACTIONS(3779),
    [anon_sym_while] = ACTIONS(3779),
    [anon_sym_for] = ACTIONS(3779),
    [anon_sym_lock] = ACTIONS(3779),
    [anon_sym_yield] = ACTIONS(3779),
    [anon_sym_switch] = ACTIONS(3779),
    [anon_sym_default] = ACTIONS(3779),
    [anon_sym_throw] = ACTIONS(3779),
    [anon_sym_try] = ACTIONS(3779),
    [anon_sym_when] = ACTIONS(3779),
    [anon_sym_await] = ACTIONS(3779),
    [anon_sym_foreach] = ACTIONS(3779),
    [anon_sym_goto] = ACTIONS(3779),
    [anon_sym_if] = ACTIONS(3779),
    [anon_sym_DOT_DOT] = ACTIONS(3781),
    [anon_sym_from] = ACTIONS(3779),
    [anon_sym_into] = ACTIONS(3779),
    [anon_sym_join] = ACTIONS(3779),
    [anon_sym_on] = ACTIONS(3779),
    [anon_sym_equals] = ACTIONS(3779),
    [anon_sym_let] = ACTIONS(3779),
    [anon_sym_orderby] = ACTIONS(3779),
    [anon_sym_ascending] = ACTIONS(3779),
    [anon_sym_descending] = ACTIONS(3779),
    [anon_sym_group] = ACTIONS(3779),
    [anon_sym_by] = ACTIONS(3779),
    [anon_sym_select] = ACTIONS(3779),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_stackalloc] = ACTIONS(3779),
    [anon_sym_sizeof] = ACTIONS(3779),
    [anon_sym_typeof] = ACTIONS(3779),
    [anon_sym___makeref] = ACTIONS(3779),
    [anon_sym___reftype] = ACTIONS(3779),
    [anon_sym___refvalue] = ACTIONS(3779),
    [sym_null_literal] = ACTIONS(3779),
    [anon_sym_SQUOTE] = ACTIONS(3781),
    [sym_integer_literal] = ACTIONS(3779),
    [sym_real_literal] = ACTIONS(3781),
    [sym_verbatim_string_literal] = ACTIONS(3781),
    [aux_sym_preproc_if_token1] = ACTIONS(3781),
    [aux_sym_preproc_if_token3] = ACTIONS(3781),
    [aux_sym_preproc_else_token1] = ACTIONS(3781),
    [aux_sym_preproc_elif_token1] = ACTIONS(3781),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3781),
    [sym_interpolation_verbatim_start] = ACTIONS(3781),
    [sym_interpolation_raw_start] = ACTIONS(3781),
    [sym_raw_string_start] = ACTIONS(3781),
  },
  [2403] = {
    [sym_preproc_region] = STATE(2403),
    [sym_preproc_endregion] = STATE(2403),
    [sym_preproc_line] = STATE(2403),
    [sym_preproc_pragma] = STATE(2403),
    [sym_preproc_nullable] = STATE(2403),
    [sym_preproc_error] = STATE(2403),
    [sym_preproc_define] = STATE(2403),
    [sym_preproc_undef] = STATE(2403),
    [sym__identifier_token] = ACTIONS(3783),
    [anon_sym_extern] = ACTIONS(3783),
    [anon_sym_alias] = ACTIONS(3783),
    [anon_sym_SEMI] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3783),
    [anon_sym_using] = ACTIONS(3783),
    [anon_sym_unsafe] = ACTIONS(3783),
    [anon_sym_static] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_LPAREN] = ACTIONS(3785),
    [anon_sym_return] = ACTIONS(3783),
    [anon_sym_namespace] = ACTIONS(3783),
    [anon_sym_class] = ACTIONS(3783),
    [anon_sym_ref] = ACTIONS(3783),
    [anon_sym_struct] = ACTIONS(3783),
    [anon_sym_enum] = ACTIONS(3783),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_interface] = ACTIONS(3783),
    [anon_sym_delegate] = ACTIONS(3783),
    [anon_sym_record] = ACTIONS(3783),
    [anon_sym_abstract] = ACTIONS(3783),
    [anon_sym_async] = ACTIONS(3783),
    [anon_sym_const] = ACTIONS(3783),
    [anon_sym_file] = ACTIONS(3783),
    [anon_sym_fixed] = ACTIONS(3783),
    [anon_sym_internal] = ACTIONS(3783),
    [anon_sym_new] = ACTIONS(3783),
    [anon_sym_override] = ACTIONS(3783),
    [anon_sym_partial] = ACTIONS(3783),
    [anon_sym_private] = ACTIONS(3783),
    [anon_sym_protected] = ACTIONS(3783),
    [anon_sym_public] = ACTIONS(3783),
    [anon_sym_readonly] = ACTIONS(3783),
    [anon_sym_required] = ACTIONS(3783),
    [anon_sym_sealed] = ACTIONS(3783),
    [anon_sym_virtual] = ACTIONS(3783),
    [anon_sym_volatile] = ACTIONS(3783),
    [anon_sym_where] = ACTIONS(3783),
    [anon_sym_notnull] = ACTIONS(3783),
    [anon_sym_unmanaged] = ACTIONS(3783),
    [anon_sym_checked] = ACTIONS(3783),
    [anon_sym_BANG] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_PLUS_PLUS] = ACTIONS(3785),
    [anon_sym_DASH_DASH] = ACTIONS(3785),
    [anon_sym_true] = ACTIONS(3783),
    [anon_sym_false] = ACTIONS(3783),
    [anon_sym_PLUS] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_this] = ACTIONS(3783),
    [anon_sym_scoped] = ACTIONS(3783),
    [anon_sym_base] = ACTIONS(3783),
    [anon_sym_var] = ACTIONS(3783),
    [sym_predefined_type] = ACTIONS(3783),
    [anon_sym_break] = ACTIONS(3783),
    [anon_sym_unchecked] = ACTIONS(3783),
    [anon_sym_continue] = ACTIONS(3783),
    [anon_sym_do] = ACTIONS(3783),
    [anon_sym_while] = ACTIONS(3783),
    [anon_sym_for] = ACTIONS(3783),
    [anon_sym_lock] = ACTIONS(3783),
    [anon_sym_yield] = ACTIONS(3783),
    [anon_sym_switch] = ACTIONS(3783),
    [anon_sym_default] = ACTIONS(3783),
    [anon_sym_throw] = ACTIONS(3783),
    [anon_sym_try] = ACTIONS(3783),
    [anon_sym_when] = ACTIONS(3783),
    [anon_sym_await] = ACTIONS(3783),
    [anon_sym_foreach] = ACTIONS(3783),
    [anon_sym_goto] = ACTIONS(3783),
    [anon_sym_if] = ACTIONS(3783),
    [anon_sym_DOT_DOT] = ACTIONS(3785),
    [anon_sym_from] = ACTIONS(3783),
    [anon_sym_into] = ACTIONS(3783),
    [anon_sym_join] = ACTIONS(3783),
    [anon_sym_on] = ACTIONS(3783),
    [anon_sym_equals] = ACTIONS(3783),
    [anon_sym_let] = ACTIONS(3783),
    [anon_sym_orderby] = ACTIONS(3783),
    [anon_sym_ascending] = ACTIONS(3783),
    [anon_sym_descending] = ACTIONS(3783),
    [anon_sym_group] = ACTIONS(3783),
    [anon_sym_by] = ACTIONS(3783),
    [anon_sym_select] = ACTIONS(3783),
    [anon_sym_DQUOTE] = ACTIONS(3785),
    [anon_sym_stackalloc] = ACTIONS(3783),
    [anon_sym_sizeof] = ACTIONS(3783),
    [anon_sym_typeof] = ACTIONS(3783),
    [anon_sym___makeref] = ACTIONS(3783),
    [anon_sym___reftype] = ACTIONS(3783),
    [anon_sym___refvalue] = ACTIONS(3783),
    [sym_null_literal] = ACTIONS(3783),
    [anon_sym_SQUOTE] = ACTIONS(3785),
    [sym_integer_literal] = ACTIONS(3783),
    [sym_real_literal] = ACTIONS(3785),
    [sym_verbatim_string_literal] = ACTIONS(3785),
    [aux_sym_preproc_if_token1] = ACTIONS(3785),
    [aux_sym_preproc_if_token3] = ACTIONS(3785),
    [aux_sym_preproc_else_token1] = ACTIONS(3785),
    [aux_sym_preproc_elif_token1] = ACTIONS(3785),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3785),
    [sym_interpolation_verbatim_start] = ACTIONS(3785),
    [sym_interpolation_raw_start] = ACTIONS(3785),
    [sym_raw_string_start] = ACTIONS(3785),
  },
  [2404] = {
    [sym_preproc_region] = STATE(2404),
    [sym_preproc_endregion] = STATE(2404),
    [sym_preproc_line] = STATE(2404),
    [sym_preproc_pragma] = STATE(2404),
    [sym_preproc_nullable] = STATE(2404),
    [sym_preproc_error] = STATE(2404),
    [sym_preproc_define] = STATE(2404),
    [sym_preproc_undef] = STATE(2404),
    [sym__identifier_token] = ACTIONS(3787),
    [anon_sym_extern] = ACTIONS(3787),
    [anon_sym_alias] = ACTIONS(3787),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_global] = ACTIONS(3787),
    [anon_sym_using] = ACTIONS(3787),
    [anon_sym_unsafe] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_LPAREN] = ACTIONS(3789),
    [anon_sym_return] = ACTIONS(3787),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_class] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3787),
    [anon_sym_struct] = ACTIONS(3787),
    [anon_sym_enum] = ACTIONS(3787),
    [anon_sym_LBRACE] = ACTIONS(3789),
    [anon_sym_interface] = ACTIONS(3787),
    [anon_sym_delegate] = ACTIONS(3787),
    [anon_sym_record] = ACTIONS(3787),
    [anon_sym_abstract] = ACTIONS(3787),
    [anon_sym_async] = ACTIONS(3787),
    [anon_sym_const] = ACTIONS(3787),
    [anon_sym_file] = ACTIONS(3787),
    [anon_sym_fixed] = ACTIONS(3787),
    [anon_sym_internal] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(3787),
    [anon_sym_override] = ACTIONS(3787),
    [anon_sym_partial] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3787),
    [anon_sym_protected] = ACTIONS(3787),
    [anon_sym_public] = ACTIONS(3787),
    [anon_sym_readonly] = ACTIONS(3787),
    [anon_sym_required] = ACTIONS(3787),
    [anon_sym_sealed] = ACTIONS(3787),
    [anon_sym_virtual] = ACTIONS(3787),
    [anon_sym_volatile] = ACTIONS(3787),
    [anon_sym_where] = ACTIONS(3787),
    [anon_sym_notnull] = ACTIONS(3787),
    [anon_sym_unmanaged] = ACTIONS(3787),
    [anon_sym_checked] = ACTIONS(3787),
    [anon_sym_BANG] = ACTIONS(3789),
    [anon_sym_TILDE] = ACTIONS(3789),
    [anon_sym_PLUS_PLUS] = ACTIONS(3789),
    [anon_sym_DASH_DASH] = ACTIONS(3789),
    [anon_sym_true] = ACTIONS(3787),
    [anon_sym_false] = ACTIONS(3787),
    [anon_sym_PLUS] = ACTIONS(3787),
    [anon_sym_DASH] = ACTIONS(3787),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_CARET] = ACTIONS(3789),
    [anon_sym_AMP] = ACTIONS(3789),
    [anon_sym_this] = ACTIONS(3787),
    [anon_sym_scoped] = ACTIONS(3787),
    [anon_sym_base] = ACTIONS(3787),
    [anon_sym_var] = ACTIONS(3787),
    [sym_predefined_type] = ACTIONS(3787),
    [anon_sym_break] = ACTIONS(3787),
    [anon_sym_unchecked] = ACTIONS(3787),
    [anon_sym_continue] = ACTIONS(3787),
    [anon_sym_do] = ACTIONS(3787),
    [anon_sym_while] = ACTIONS(3787),
    [anon_sym_for] = ACTIONS(3787),
    [anon_sym_lock] = ACTIONS(3787),
    [anon_sym_yield] = ACTIONS(3787),
    [anon_sym_switch] = ACTIONS(3787),
    [anon_sym_default] = ACTIONS(3787),
    [anon_sym_throw] = ACTIONS(3787),
    [anon_sym_try] = ACTIONS(3787),
    [anon_sym_when] = ACTIONS(3787),
    [anon_sym_await] = ACTIONS(3787),
    [anon_sym_foreach] = ACTIONS(3787),
    [anon_sym_goto] = ACTIONS(3787),
    [anon_sym_if] = ACTIONS(3787),
    [anon_sym_DOT_DOT] = ACTIONS(3789),
    [anon_sym_from] = ACTIONS(3787),
    [anon_sym_into] = ACTIONS(3787),
    [anon_sym_join] = ACTIONS(3787),
    [anon_sym_on] = ACTIONS(3787),
    [anon_sym_equals] = ACTIONS(3787),
    [anon_sym_let] = ACTIONS(3787),
    [anon_sym_orderby] = ACTIONS(3787),
    [anon_sym_ascending] = ACTIONS(3787),
    [anon_sym_descending] = ACTIONS(3787),
    [anon_sym_group] = ACTIONS(3787),
    [anon_sym_by] = ACTIONS(3787),
    [anon_sym_select] = ACTIONS(3787),
    [anon_sym_DQUOTE] = ACTIONS(3789),
    [anon_sym_stackalloc] = ACTIONS(3787),
    [anon_sym_sizeof] = ACTIONS(3787),
    [anon_sym_typeof] = ACTIONS(3787),
    [anon_sym___makeref] = ACTIONS(3787),
    [anon_sym___reftype] = ACTIONS(3787),
    [anon_sym___refvalue] = ACTIONS(3787),
    [sym_null_literal] = ACTIONS(3787),
    [anon_sym_SQUOTE] = ACTIONS(3789),
    [sym_integer_literal] = ACTIONS(3787),
    [sym_real_literal] = ACTIONS(3789),
    [sym_verbatim_string_literal] = ACTIONS(3789),
    [aux_sym_preproc_if_token1] = ACTIONS(3789),
    [aux_sym_preproc_if_token3] = ACTIONS(3789),
    [aux_sym_preproc_else_token1] = ACTIONS(3789),
    [aux_sym_preproc_elif_token1] = ACTIONS(3789),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3789),
    [sym_interpolation_verbatim_start] = ACTIONS(3789),
    [sym_interpolation_raw_start] = ACTIONS(3789),
    [sym_raw_string_start] = ACTIONS(3789),
  },
  [2405] = {
    [sym_preproc_region] = STATE(2405),
    [sym_preproc_endregion] = STATE(2405),
    [sym_preproc_line] = STATE(2405),
    [sym_preproc_pragma] = STATE(2405),
    [sym_preproc_nullable] = STATE(2405),
    [sym_preproc_error] = STATE(2405),
    [sym_preproc_define] = STATE(2405),
    [sym_preproc_undef] = STATE(2405),
    [sym__identifier_token] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_unsafe] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3793),
    [anon_sym_return] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_ref] = ACTIONS(3791),
    [anon_sym_struct] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_delegate] = ACTIONS(3791),
    [anon_sym_record] = ACTIONS(3791),
    [anon_sym_abstract] = ACTIONS(3791),
    [anon_sym_async] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_fixed] = ACTIONS(3791),
    [anon_sym_internal] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_override] = ACTIONS(3791),
    [anon_sym_partial] = ACTIONS(3791),
    [anon_sym_private] = ACTIONS(3791),
    [anon_sym_protected] = ACTIONS(3791),
    [anon_sym_public] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(3791),
    [anon_sym_required] = ACTIONS(3791),
    [anon_sym_sealed] = ACTIONS(3791),
    [anon_sym_virtual] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_checked] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_true] = ACTIONS(3791),
    [anon_sym_false] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_CARET] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_this] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_base] = ACTIONS(3791),
    [anon_sym_var] = ACTIONS(3791),
    [sym_predefined_type] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3791),
    [anon_sym_unchecked] = ACTIONS(3791),
    [anon_sym_continue] = ACTIONS(3791),
    [anon_sym_do] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3791),
    [anon_sym_for] = ACTIONS(3791),
    [anon_sym_lock] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3791),
    [anon_sym_default] = ACTIONS(3791),
    [anon_sym_throw] = ACTIONS(3791),
    [anon_sym_try] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_await] = ACTIONS(3791),
    [anon_sym_foreach] = ACTIONS(3791),
    [anon_sym_goto] = ACTIONS(3791),
    [anon_sym_if] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3793),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_DQUOTE] = ACTIONS(3793),
    [anon_sym_stackalloc] = ACTIONS(3791),
    [anon_sym_sizeof] = ACTIONS(3791),
    [anon_sym_typeof] = ACTIONS(3791),
    [anon_sym___makeref] = ACTIONS(3791),
    [anon_sym___reftype] = ACTIONS(3791),
    [anon_sym___refvalue] = ACTIONS(3791),
    [sym_null_literal] = ACTIONS(3791),
    [anon_sym_SQUOTE] = ACTIONS(3793),
    [sym_integer_literal] = ACTIONS(3791),
    [sym_real_literal] = ACTIONS(3793),
    [sym_verbatim_string_literal] = ACTIONS(3793),
    [aux_sym_preproc_if_token1] = ACTIONS(3793),
    [aux_sym_preproc_if_token3] = ACTIONS(3793),
    [aux_sym_preproc_else_token1] = ACTIONS(3793),
    [aux_sym_preproc_elif_token1] = ACTIONS(3793),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3793),
    [sym_interpolation_verbatim_start] = ACTIONS(3793),
    [sym_interpolation_raw_start] = ACTIONS(3793),
    [sym_raw_string_start] = ACTIONS(3793),
  },
  [2406] = {
    [sym_preproc_region] = STATE(2406),
    [sym_preproc_endregion] = STATE(2406),
    [sym_preproc_line] = STATE(2406),
    [sym_preproc_pragma] = STATE(2406),
    [sym_preproc_nullable] = STATE(2406),
    [sym_preproc_error] = STATE(2406),
    [sym_preproc_define] = STATE(2406),
    [sym_preproc_undef] = STATE(2406),
    [sym__identifier_token] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym_alias] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym_global] = ACTIONS(3795),
    [anon_sym_using] = ACTIONS(3795),
    [anon_sym_unsafe] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(3797),
    [anon_sym_return] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_ref] = ACTIONS(3795),
    [anon_sym_struct] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_delegate] = ACTIONS(3795),
    [anon_sym_record] = ACTIONS(3795),
    [anon_sym_abstract] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_file] = ACTIONS(3795),
    [anon_sym_fixed] = ACTIONS(3795),
    [anon_sym_internal] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [anon_sym_override] = ACTIONS(3795),
    [anon_sym_partial] = ACTIONS(3795),
    [anon_sym_private] = ACTIONS(3795),
    [anon_sym_protected] = ACTIONS(3795),
    [anon_sym_public] = ACTIONS(3795),
    [anon_sym_readonly] = ACTIONS(3795),
    [anon_sym_required] = ACTIONS(3795),
    [anon_sym_sealed] = ACTIONS(3795),
    [anon_sym_virtual] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_where] = ACTIONS(3795),
    [anon_sym_notnull] = ACTIONS(3795),
    [anon_sym_unmanaged] = ACTIONS(3795),
    [anon_sym_checked] = ACTIONS(3795),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_true] = ACTIONS(3795),
    [anon_sym_false] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_CARET] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3797),
    [anon_sym_this] = ACTIONS(3795),
    [anon_sym_scoped] = ACTIONS(3795),
    [anon_sym_base] = ACTIONS(3795),
    [anon_sym_var] = ACTIONS(3795),
    [sym_predefined_type] = ACTIONS(3795),
    [anon_sym_break] = ACTIONS(3795),
    [anon_sym_unchecked] = ACTIONS(3795),
    [anon_sym_continue] = ACTIONS(3795),
    [anon_sym_do] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3795),
    [anon_sym_lock] = ACTIONS(3795),
    [anon_sym_yield] = ACTIONS(3795),
    [anon_sym_switch] = ACTIONS(3795),
    [anon_sym_default] = ACTIONS(3795),
    [anon_sym_throw] = ACTIONS(3795),
    [anon_sym_try] = ACTIONS(3795),
    [anon_sym_when] = ACTIONS(3795),
    [anon_sym_await] = ACTIONS(3795),
    [anon_sym_foreach] = ACTIONS(3795),
    [anon_sym_goto] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3797),
    [anon_sym_from] = ACTIONS(3795),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3795),
    [anon_sym_on] = ACTIONS(3795),
    [anon_sym_equals] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_orderby] = ACTIONS(3795),
    [anon_sym_ascending] = ACTIONS(3795),
    [anon_sym_descending] = ACTIONS(3795),
    [anon_sym_group] = ACTIONS(3795),
    [anon_sym_by] = ACTIONS(3795),
    [anon_sym_select] = ACTIONS(3795),
    [anon_sym_DQUOTE] = ACTIONS(3797),
    [anon_sym_stackalloc] = ACTIONS(3795),
    [anon_sym_sizeof] = ACTIONS(3795),
    [anon_sym_typeof] = ACTIONS(3795),
    [anon_sym___makeref] = ACTIONS(3795),
    [anon_sym___reftype] = ACTIONS(3795),
    [anon_sym___refvalue] = ACTIONS(3795),
    [sym_null_literal] = ACTIONS(3795),
    [anon_sym_SQUOTE] = ACTIONS(3797),
    [sym_integer_literal] = ACTIONS(3795),
    [sym_real_literal] = ACTIONS(3797),
    [sym_verbatim_string_literal] = ACTIONS(3797),
    [aux_sym_preproc_if_token1] = ACTIONS(3797),
    [aux_sym_preproc_if_token3] = ACTIONS(3797),
    [aux_sym_preproc_else_token1] = ACTIONS(3797),
    [aux_sym_preproc_elif_token1] = ACTIONS(3797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3797),
    [sym_interpolation_verbatim_start] = ACTIONS(3797),
    [sym_interpolation_raw_start] = ACTIONS(3797),
    [sym_raw_string_start] = ACTIONS(3797),
  },
  [2407] = {
    [sym_preproc_region] = STATE(2407),
    [sym_preproc_endregion] = STATE(2407),
    [sym_preproc_line] = STATE(2407),
    [sym_preproc_pragma] = STATE(2407),
    [sym_preproc_nullable] = STATE(2407),
    [sym_preproc_error] = STATE(2407),
    [sym_preproc_define] = STATE(2407),
    [sym_preproc_undef] = STATE(2407),
    [sym__identifier_token] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym_alias] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym_global] = ACTIONS(3799),
    [anon_sym_using] = ACTIONS(3799),
    [anon_sym_unsafe] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3801),
    [anon_sym_return] = ACTIONS(3799),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_class] = ACTIONS(3799),
    [anon_sym_ref] = ACTIONS(3799),
    [anon_sym_struct] = ACTIONS(3799),
    [anon_sym_enum] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_interface] = ACTIONS(3799),
    [anon_sym_delegate] = ACTIONS(3799),
    [anon_sym_record] = ACTIONS(3799),
    [anon_sym_abstract] = ACTIONS(3799),
    [anon_sym_async] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_file] = ACTIONS(3799),
    [anon_sym_fixed] = ACTIONS(3799),
    [anon_sym_internal] = ACTIONS(3799),
    [anon_sym_new] = ACTIONS(3799),
    [anon_sym_override] = ACTIONS(3799),
    [anon_sym_partial] = ACTIONS(3799),
    [anon_sym_private] = ACTIONS(3799),
    [anon_sym_protected] = ACTIONS(3799),
    [anon_sym_public] = ACTIONS(3799),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_required] = ACTIONS(3799),
    [anon_sym_sealed] = ACTIONS(3799),
    [anon_sym_virtual] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_where] = ACTIONS(3799),
    [anon_sym_notnull] = ACTIONS(3799),
    [anon_sym_unmanaged] = ACTIONS(3799),
    [anon_sym_checked] = ACTIONS(3799),
    [anon_sym_BANG] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_true] = ACTIONS(3799),
    [anon_sym_false] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_CARET] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3801),
    [anon_sym_this] = ACTIONS(3799),
    [anon_sym_scoped] = ACTIONS(3799),
    [anon_sym_base] = ACTIONS(3799),
    [anon_sym_var] = ACTIONS(3799),
    [sym_predefined_type] = ACTIONS(3799),
    [anon_sym_break] = ACTIONS(3799),
    [anon_sym_unchecked] = ACTIONS(3799),
    [anon_sym_continue] = ACTIONS(3799),
    [anon_sym_do] = ACTIONS(3799),
    [anon_sym_while] = ACTIONS(3799),
    [anon_sym_for] = ACTIONS(3799),
    [anon_sym_lock] = ACTIONS(3799),
    [anon_sym_yield] = ACTIONS(3799),
    [anon_sym_switch] = ACTIONS(3799),
    [anon_sym_default] = ACTIONS(3799),
    [anon_sym_throw] = ACTIONS(3799),
    [anon_sym_try] = ACTIONS(3799),
    [anon_sym_when] = ACTIONS(3799),
    [anon_sym_await] = ACTIONS(3799),
    [anon_sym_foreach] = ACTIONS(3799),
    [anon_sym_goto] = ACTIONS(3799),
    [anon_sym_if] = ACTIONS(3799),
    [anon_sym_DOT_DOT] = ACTIONS(3801),
    [anon_sym_from] = ACTIONS(3799),
    [anon_sym_into] = ACTIONS(3799),
    [anon_sym_join] = ACTIONS(3799),
    [anon_sym_on] = ACTIONS(3799),
    [anon_sym_equals] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_orderby] = ACTIONS(3799),
    [anon_sym_ascending] = ACTIONS(3799),
    [anon_sym_descending] = ACTIONS(3799),
    [anon_sym_group] = ACTIONS(3799),
    [anon_sym_by] = ACTIONS(3799),
    [anon_sym_select] = ACTIONS(3799),
    [anon_sym_DQUOTE] = ACTIONS(3801),
    [anon_sym_stackalloc] = ACTIONS(3799),
    [anon_sym_sizeof] = ACTIONS(3799),
    [anon_sym_typeof] = ACTIONS(3799),
    [anon_sym___makeref] = ACTIONS(3799),
    [anon_sym___reftype] = ACTIONS(3799),
    [anon_sym___refvalue] = ACTIONS(3799),
    [sym_null_literal] = ACTIONS(3799),
    [anon_sym_SQUOTE] = ACTIONS(3801),
    [sym_integer_literal] = ACTIONS(3799),
    [sym_real_literal] = ACTIONS(3801),
    [sym_verbatim_string_literal] = ACTIONS(3801),
    [aux_sym_preproc_if_token1] = ACTIONS(3801),
    [aux_sym_preproc_if_token3] = ACTIONS(3801),
    [aux_sym_preproc_else_token1] = ACTIONS(3801),
    [aux_sym_preproc_elif_token1] = ACTIONS(3801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3801),
    [sym_interpolation_verbatim_start] = ACTIONS(3801),
    [sym_interpolation_raw_start] = ACTIONS(3801),
    [sym_raw_string_start] = ACTIONS(3801),
  },
  [2408] = {
    [sym_preproc_region] = STATE(2408),
    [sym_preproc_endregion] = STATE(2408),
    [sym_preproc_line] = STATE(2408),
    [sym_preproc_pragma] = STATE(2408),
    [sym_preproc_nullable] = STATE(2408),
    [sym_preproc_error] = STATE(2408),
    [sym_preproc_define] = STATE(2408),
    [sym_preproc_undef] = STATE(2408),
    [sym__identifier_token] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym_alias] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_global] = ACTIONS(3803),
    [anon_sym_using] = ACTIONS(3803),
    [anon_sym_unsafe] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3805),
    [anon_sym_return] = ACTIONS(3803),
    [anon_sym_namespace] = ACTIONS(3803),
    [anon_sym_class] = ACTIONS(3803),
    [anon_sym_ref] = ACTIONS(3803),
    [anon_sym_struct] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_interface] = ACTIONS(3803),
    [anon_sym_delegate] = ACTIONS(3803),
    [anon_sym_record] = ACTIONS(3803),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_async] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_file] = ACTIONS(3803),
    [anon_sym_fixed] = ACTIONS(3803),
    [anon_sym_internal] = ACTIONS(3803),
    [anon_sym_new] = ACTIONS(3803),
    [anon_sym_override] = ACTIONS(3803),
    [anon_sym_partial] = ACTIONS(3803),
    [anon_sym_private] = ACTIONS(3803),
    [anon_sym_protected] = ACTIONS(3803),
    [anon_sym_public] = ACTIONS(3803),
    [anon_sym_readonly] = ACTIONS(3803),
    [anon_sym_required] = ACTIONS(3803),
    [anon_sym_sealed] = ACTIONS(3803),
    [anon_sym_virtual] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_where] = ACTIONS(3803),
    [anon_sym_notnull] = ACTIONS(3803),
    [anon_sym_unmanaged] = ACTIONS(3803),
    [anon_sym_checked] = ACTIONS(3803),
    [anon_sym_BANG] = ACTIONS(3805),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_true] = ACTIONS(3803),
    [anon_sym_false] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3805),
    [anon_sym_this] = ACTIONS(3803),
    [anon_sym_scoped] = ACTIONS(3803),
    [anon_sym_base] = ACTIONS(3803),
    [anon_sym_var] = ACTIONS(3803),
    [sym_predefined_type] = ACTIONS(3803),
    [anon_sym_break] = ACTIONS(3803),
    [anon_sym_unchecked] = ACTIONS(3803),
    [anon_sym_continue] = ACTIONS(3803),
    [anon_sym_do] = ACTIONS(3803),
    [anon_sym_while] = ACTIONS(3803),
    [anon_sym_for] = ACTIONS(3803),
    [anon_sym_lock] = ACTIONS(3803),
    [anon_sym_yield] = ACTIONS(3803),
    [anon_sym_switch] = ACTIONS(3803),
    [anon_sym_default] = ACTIONS(3803),
    [anon_sym_throw] = ACTIONS(3803),
    [anon_sym_try] = ACTIONS(3803),
    [anon_sym_when] = ACTIONS(3803),
    [anon_sym_await] = ACTIONS(3803),
    [anon_sym_foreach] = ACTIONS(3803),
    [anon_sym_goto] = ACTIONS(3803),
    [anon_sym_if] = ACTIONS(3803),
    [anon_sym_DOT_DOT] = ACTIONS(3805),
    [anon_sym_from] = ACTIONS(3803),
    [anon_sym_into] = ACTIONS(3803),
    [anon_sym_join] = ACTIONS(3803),
    [anon_sym_on] = ACTIONS(3803),
    [anon_sym_equals] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_orderby] = ACTIONS(3803),
    [anon_sym_ascending] = ACTIONS(3803),
    [anon_sym_descending] = ACTIONS(3803),
    [anon_sym_group] = ACTIONS(3803),
    [anon_sym_by] = ACTIONS(3803),
    [anon_sym_select] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(3805),
    [anon_sym_stackalloc] = ACTIONS(3803),
    [anon_sym_sizeof] = ACTIONS(3803),
    [anon_sym_typeof] = ACTIONS(3803),
    [anon_sym___makeref] = ACTIONS(3803),
    [anon_sym___reftype] = ACTIONS(3803),
    [anon_sym___refvalue] = ACTIONS(3803),
    [sym_null_literal] = ACTIONS(3803),
    [anon_sym_SQUOTE] = ACTIONS(3805),
    [sym_integer_literal] = ACTIONS(3803),
    [sym_real_literal] = ACTIONS(3805),
    [sym_verbatim_string_literal] = ACTIONS(3805),
    [aux_sym_preproc_if_token1] = ACTIONS(3805),
    [aux_sym_preproc_if_token3] = ACTIONS(3805),
    [aux_sym_preproc_else_token1] = ACTIONS(3805),
    [aux_sym_preproc_elif_token1] = ACTIONS(3805),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3805),
    [sym_interpolation_verbatim_start] = ACTIONS(3805),
    [sym_interpolation_raw_start] = ACTIONS(3805),
    [sym_raw_string_start] = ACTIONS(3805),
  },
  [2409] = {
    [sym_preproc_region] = STATE(2409),
    [sym_preproc_endregion] = STATE(2409),
    [sym_preproc_line] = STATE(2409),
    [sym_preproc_pragma] = STATE(2409),
    [sym_preproc_nullable] = STATE(2409),
    [sym_preproc_error] = STATE(2409),
    [sym_preproc_define] = STATE(2409),
    [sym_preproc_undef] = STATE(2409),
    [sym__identifier_token] = ACTIONS(3807),
    [anon_sym_extern] = ACTIONS(3807),
    [anon_sym_alias] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3809),
    [anon_sym_global] = ACTIONS(3807),
    [anon_sym_using] = ACTIONS(3807),
    [anon_sym_unsafe] = ACTIONS(3807),
    [anon_sym_static] = ACTIONS(3807),
    [anon_sym_LBRACK] = ACTIONS(3809),
    [anon_sym_LPAREN] = ACTIONS(3809),
    [anon_sym_return] = ACTIONS(3807),
    [anon_sym_namespace] = ACTIONS(3807),
    [anon_sym_class] = ACTIONS(3807),
    [anon_sym_ref] = ACTIONS(3807),
    [anon_sym_struct] = ACTIONS(3807),
    [anon_sym_enum] = ACTIONS(3807),
    [anon_sym_LBRACE] = ACTIONS(3809),
    [anon_sym_interface] = ACTIONS(3807),
    [anon_sym_delegate] = ACTIONS(3807),
    [anon_sym_record] = ACTIONS(3807),
    [anon_sym_abstract] = ACTIONS(3807),
    [anon_sym_async] = ACTIONS(3807),
    [anon_sym_const] = ACTIONS(3807),
    [anon_sym_file] = ACTIONS(3807),
    [anon_sym_fixed] = ACTIONS(3807),
    [anon_sym_internal] = ACTIONS(3807),
    [anon_sym_new] = ACTIONS(3807),
    [anon_sym_override] = ACTIONS(3807),
    [anon_sym_partial] = ACTIONS(3807),
    [anon_sym_private] = ACTIONS(3807),
    [anon_sym_protected] = ACTIONS(3807),
    [anon_sym_public] = ACTIONS(3807),
    [anon_sym_readonly] = ACTIONS(3807),
    [anon_sym_required] = ACTIONS(3807),
    [anon_sym_sealed] = ACTIONS(3807),
    [anon_sym_virtual] = ACTIONS(3807),
    [anon_sym_volatile] = ACTIONS(3807),
    [anon_sym_where] = ACTIONS(3807),
    [anon_sym_notnull] = ACTIONS(3807),
    [anon_sym_unmanaged] = ACTIONS(3807),
    [anon_sym_checked] = ACTIONS(3807),
    [anon_sym_BANG] = ACTIONS(3809),
    [anon_sym_TILDE] = ACTIONS(3809),
    [anon_sym_PLUS_PLUS] = ACTIONS(3809),
    [anon_sym_DASH_DASH] = ACTIONS(3809),
    [anon_sym_true] = ACTIONS(3807),
    [anon_sym_false] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_DASH] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3809),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_this] = ACTIONS(3807),
    [anon_sym_scoped] = ACTIONS(3807),
    [anon_sym_base] = ACTIONS(3807),
    [anon_sym_var] = ACTIONS(3807),
    [sym_predefined_type] = ACTIONS(3807),
    [anon_sym_break] = ACTIONS(3807),
    [anon_sym_unchecked] = ACTIONS(3807),
    [anon_sym_continue] = ACTIONS(3807),
    [anon_sym_do] = ACTIONS(3807),
    [anon_sym_while] = ACTIONS(3807),
    [anon_sym_for] = ACTIONS(3807),
    [anon_sym_lock] = ACTIONS(3807),
    [anon_sym_yield] = ACTIONS(3807),
    [anon_sym_switch] = ACTIONS(3807),
    [anon_sym_default] = ACTIONS(3807),
    [anon_sym_throw] = ACTIONS(3807),
    [anon_sym_try] = ACTIONS(3807),
    [anon_sym_when] = ACTIONS(3807),
    [anon_sym_await] = ACTIONS(3807),
    [anon_sym_foreach] = ACTIONS(3807),
    [anon_sym_goto] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3809),
    [anon_sym_from] = ACTIONS(3807),
    [anon_sym_into] = ACTIONS(3807),
    [anon_sym_join] = ACTIONS(3807),
    [anon_sym_on] = ACTIONS(3807),
    [anon_sym_equals] = ACTIONS(3807),
    [anon_sym_let] = ACTIONS(3807),
    [anon_sym_orderby] = ACTIONS(3807),
    [anon_sym_ascending] = ACTIONS(3807),
    [anon_sym_descending] = ACTIONS(3807),
    [anon_sym_group] = ACTIONS(3807),
    [anon_sym_by] = ACTIONS(3807),
    [anon_sym_select] = ACTIONS(3807),
    [anon_sym_DQUOTE] = ACTIONS(3809),
    [anon_sym_stackalloc] = ACTIONS(3807),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym_typeof] = ACTIONS(3807),
    [anon_sym___makeref] = ACTIONS(3807),
    [anon_sym___reftype] = ACTIONS(3807),
    [anon_sym___refvalue] = ACTIONS(3807),
    [sym_null_literal] = ACTIONS(3807),
    [anon_sym_SQUOTE] = ACTIONS(3809),
    [sym_integer_literal] = ACTIONS(3807),
    [sym_real_literal] = ACTIONS(3809),
    [sym_verbatim_string_literal] = ACTIONS(3809),
    [aux_sym_preproc_if_token1] = ACTIONS(3809),
    [aux_sym_preproc_if_token3] = ACTIONS(3809),
    [aux_sym_preproc_else_token1] = ACTIONS(3809),
    [aux_sym_preproc_elif_token1] = ACTIONS(3809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3809),
    [sym_interpolation_verbatim_start] = ACTIONS(3809),
    [sym_interpolation_raw_start] = ACTIONS(3809),
    [sym_raw_string_start] = ACTIONS(3809),
  },
  [2410] = {
    [sym_preproc_region] = STATE(2410),
    [sym_preproc_endregion] = STATE(2410),
    [sym_preproc_line] = STATE(2410),
    [sym_preproc_pragma] = STATE(2410),
    [sym_preproc_nullable] = STATE(2410),
    [sym_preproc_error] = STATE(2410),
    [sym_preproc_define] = STATE(2410),
    [sym_preproc_undef] = STATE(2410),
    [sym__identifier_token] = ACTIONS(3811),
    [anon_sym_extern] = ACTIONS(3811),
    [anon_sym_alias] = ACTIONS(3811),
    [anon_sym_SEMI] = ACTIONS(3813),
    [anon_sym_global] = ACTIONS(3811),
    [anon_sym_using] = ACTIONS(3811),
    [anon_sym_unsafe] = ACTIONS(3811),
    [anon_sym_static] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_namespace] = ACTIONS(3811),
    [anon_sym_class] = ACTIONS(3811),
    [anon_sym_ref] = ACTIONS(3811),
    [anon_sym_struct] = ACTIONS(3811),
    [anon_sym_enum] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3811),
    [anon_sym_delegate] = ACTIONS(3811),
    [anon_sym_record] = ACTIONS(3811),
    [anon_sym_abstract] = ACTIONS(3811),
    [anon_sym_async] = ACTIONS(3811),
    [anon_sym_const] = ACTIONS(3811),
    [anon_sym_file] = ACTIONS(3811),
    [anon_sym_fixed] = ACTIONS(3811),
    [anon_sym_internal] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3811),
    [anon_sym_override] = ACTIONS(3811),
    [anon_sym_partial] = ACTIONS(3811),
    [anon_sym_private] = ACTIONS(3811),
    [anon_sym_protected] = ACTIONS(3811),
    [anon_sym_public] = ACTIONS(3811),
    [anon_sym_readonly] = ACTIONS(3811),
    [anon_sym_required] = ACTIONS(3811),
    [anon_sym_sealed] = ACTIONS(3811),
    [anon_sym_virtual] = ACTIONS(3811),
    [anon_sym_volatile] = ACTIONS(3811),
    [anon_sym_where] = ACTIONS(3811),
    [anon_sym_notnull] = ACTIONS(3811),
    [anon_sym_unmanaged] = ACTIONS(3811),
    [anon_sym_checked] = ACTIONS(3811),
    [anon_sym_BANG] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(3813),
    [anon_sym_DASH_DASH] = ACTIONS(3813),
    [anon_sym_true] = ACTIONS(3811),
    [anon_sym_false] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_CARET] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_this] = ACTIONS(3811),
    [anon_sym_scoped] = ACTIONS(3811),
    [anon_sym_base] = ACTIONS(3811),
    [anon_sym_var] = ACTIONS(3811),
    [sym_predefined_type] = ACTIONS(3811),
    [anon_sym_break] = ACTIONS(3811),
    [anon_sym_unchecked] = ACTIONS(3811),
    [anon_sym_continue] = ACTIONS(3811),
    [anon_sym_do] = ACTIONS(3811),
    [anon_sym_while] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3811),
    [anon_sym_lock] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3811),
    [anon_sym_switch] = ACTIONS(3811),
    [anon_sym_default] = ACTIONS(3811),
    [anon_sym_throw] = ACTIONS(3811),
    [anon_sym_try] = ACTIONS(3811),
    [anon_sym_when] = ACTIONS(3811),
    [anon_sym_await] = ACTIONS(3811),
    [anon_sym_foreach] = ACTIONS(3811),
    [anon_sym_goto] = ACTIONS(3811),
    [anon_sym_if] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3813),
    [anon_sym_from] = ACTIONS(3811),
    [anon_sym_into] = ACTIONS(3811),
    [anon_sym_join] = ACTIONS(3811),
    [anon_sym_on] = ACTIONS(3811),
    [anon_sym_equals] = ACTIONS(3811),
    [anon_sym_let] = ACTIONS(3811),
    [anon_sym_orderby] = ACTIONS(3811),
    [anon_sym_ascending] = ACTIONS(3811),
    [anon_sym_descending] = ACTIONS(3811),
    [anon_sym_group] = ACTIONS(3811),
    [anon_sym_by] = ACTIONS(3811),
    [anon_sym_select] = ACTIONS(3811),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_stackalloc] = ACTIONS(3811),
    [anon_sym_sizeof] = ACTIONS(3811),
    [anon_sym_typeof] = ACTIONS(3811),
    [anon_sym___makeref] = ACTIONS(3811),
    [anon_sym___reftype] = ACTIONS(3811),
    [anon_sym___refvalue] = ACTIONS(3811),
    [sym_null_literal] = ACTIONS(3811),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [sym_integer_literal] = ACTIONS(3811),
    [sym_real_literal] = ACTIONS(3813),
    [sym_verbatim_string_literal] = ACTIONS(3813),
    [aux_sym_preproc_if_token1] = ACTIONS(3813),
    [aux_sym_preproc_if_token3] = ACTIONS(3813),
    [aux_sym_preproc_else_token1] = ACTIONS(3813),
    [aux_sym_preproc_elif_token1] = ACTIONS(3813),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3813),
    [sym_interpolation_verbatim_start] = ACTIONS(3813),
    [sym_interpolation_raw_start] = ACTIONS(3813),
    [sym_raw_string_start] = ACTIONS(3813),
  },
  [2411] = {
    [sym_preproc_region] = STATE(2411),
    [sym_preproc_endregion] = STATE(2411),
    [sym_preproc_line] = STATE(2411),
    [sym_preproc_pragma] = STATE(2411),
    [sym_preproc_nullable] = STATE(2411),
    [sym_preproc_error] = STATE(2411),
    [sym_preproc_define] = STATE(2411),
    [sym_preproc_undef] = STATE(2411),
    [sym__identifier_token] = ACTIONS(3815),
    [anon_sym_extern] = ACTIONS(3815),
    [anon_sym_alias] = ACTIONS(3815),
    [anon_sym_SEMI] = ACTIONS(3817),
    [anon_sym_global] = ACTIONS(3815),
    [anon_sym_using] = ACTIONS(3815),
    [anon_sym_unsafe] = ACTIONS(3815),
    [anon_sym_static] = ACTIONS(3815),
    [anon_sym_LBRACK] = ACTIONS(3817),
    [anon_sym_LPAREN] = ACTIONS(3817),
    [anon_sym_return] = ACTIONS(3815),
    [anon_sym_namespace] = ACTIONS(3815),
    [anon_sym_class] = ACTIONS(3815),
    [anon_sym_ref] = ACTIONS(3815),
    [anon_sym_struct] = ACTIONS(3815),
    [anon_sym_enum] = ACTIONS(3815),
    [anon_sym_LBRACE] = ACTIONS(3817),
    [anon_sym_interface] = ACTIONS(3815),
    [anon_sym_delegate] = ACTIONS(3815),
    [anon_sym_record] = ACTIONS(3815),
    [anon_sym_abstract] = ACTIONS(3815),
    [anon_sym_async] = ACTIONS(3815),
    [anon_sym_const] = ACTIONS(3815),
    [anon_sym_file] = ACTIONS(3815),
    [anon_sym_fixed] = ACTIONS(3815),
    [anon_sym_internal] = ACTIONS(3815),
    [anon_sym_new] = ACTIONS(3815),
    [anon_sym_override] = ACTIONS(3815),
    [anon_sym_partial] = ACTIONS(3815),
    [anon_sym_private] = ACTIONS(3815),
    [anon_sym_protected] = ACTIONS(3815),
    [anon_sym_public] = ACTIONS(3815),
    [anon_sym_readonly] = ACTIONS(3815),
    [anon_sym_required] = ACTIONS(3815),
    [anon_sym_sealed] = ACTIONS(3815),
    [anon_sym_virtual] = ACTIONS(3815),
    [anon_sym_volatile] = ACTIONS(3815),
    [anon_sym_where] = ACTIONS(3815),
    [anon_sym_notnull] = ACTIONS(3815),
    [anon_sym_unmanaged] = ACTIONS(3815),
    [anon_sym_checked] = ACTIONS(3815),
    [anon_sym_BANG] = ACTIONS(3817),
    [anon_sym_TILDE] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_true] = ACTIONS(3815),
    [anon_sym_false] = ACTIONS(3815),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_STAR] = ACTIONS(3817),
    [anon_sym_CARET] = ACTIONS(3817),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_this] = ACTIONS(3815),
    [anon_sym_scoped] = ACTIONS(3815),
    [anon_sym_base] = ACTIONS(3815),
    [anon_sym_var] = ACTIONS(3815),
    [sym_predefined_type] = ACTIONS(3815),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_unchecked] = ACTIONS(3815),
    [anon_sym_continue] = ACTIONS(3815),
    [anon_sym_do] = ACTIONS(3815),
    [anon_sym_while] = ACTIONS(3815),
    [anon_sym_for] = ACTIONS(3815),
    [anon_sym_lock] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(3815),
    [anon_sym_switch] = ACTIONS(3815),
    [anon_sym_default] = ACTIONS(3815),
    [anon_sym_throw] = ACTIONS(3815),
    [anon_sym_try] = ACTIONS(3815),
    [anon_sym_when] = ACTIONS(3815),
    [anon_sym_await] = ACTIONS(3815),
    [anon_sym_foreach] = ACTIONS(3815),
    [anon_sym_goto] = ACTIONS(3815),
    [anon_sym_if] = ACTIONS(3815),
    [anon_sym_DOT_DOT] = ACTIONS(3817),
    [anon_sym_from] = ACTIONS(3815),
    [anon_sym_into] = ACTIONS(3815),
    [anon_sym_join] = ACTIONS(3815),
    [anon_sym_on] = ACTIONS(3815),
    [anon_sym_equals] = ACTIONS(3815),
    [anon_sym_let] = ACTIONS(3815),
    [anon_sym_orderby] = ACTIONS(3815),
    [anon_sym_ascending] = ACTIONS(3815),
    [anon_sym_descending] = ACTIONS(3815),
    [anon_sym_group] = ACTIONS(3815),
    [anon_sym_by] = ACTIONS(3815),
    [anon_sym_select] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3817),
    [anon_sym_stackalloc] = ACTIONS(3815),
    [anon_sym_sizeof] = ACTIONS(3815),
    [anon_sym_typeof] = ACTIONS(3815),
    [anon_sym___makeref] = ACTIONS(3815),
    [anon_sym___reftype] = ACTIONS(3815),
    [anon_sym___refvalue] = ACTIONS(3815),
    [sym_null_literal] = ACTIONS(3815),
    [anon_sym_SQUOTE] = ACTIONS(3817),
    [sym_integer_literal] = ACTIONS(3815),
    [sym_real_literal] = ACTIONS(3817),
    [sym_verbatim_string_literal] = ACTIONS(3817),
    [aux_sym_preproc_if_token1] = ACTIONS(3817),
    [aux_sym_preproc_if_token3] = ACTIONS(3817),
    [aux_sym_preproc_else_token1] = ACTIONS(3817),
    [aux_sym_preproc_elif_token1] = ACTIONS(3817),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3817),
    [sym_interpolation_verbatim_start] = ACTIONS(3817),
    [sym_interpolation_raw_start] = ACTIONS(3817),
    [sym_raw_string_start] = ACTIONS(3817),
  },
  [2412] = {
    [sym_preproc_region] = STATE(2412),
    [sym_preproc_endregion] = STATE(2412),
    [sym_preproc_line] = STATE(2412),
    [sym_preproc_pragma] = STATE(2412),
    [sym_preproc_nullable] = STATE(2412),
    [sym_preproc_error] = STATE(2412),
    [sym_preproc_define] = STATE(2412),
    [sym_preproc_undef] = STATE(2412),
    [sym__identifier_token] = ACTIONS(3819),
    [anon_sym_extern] = ACTIONS(3819),
    [anon_sym_alias] = ACTIONS(3819),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_global] = ACTIONS(3819),
    [anon_sym_using] = ACTIONS(3819),
    [anon_sym_unsafe] = ACTIONS(3819),
    [anon_sym_static] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(3821),
    [anon_sym_LPAREN] = ACTIONS(3821),
    [anon_sym_return] = ACTIONS(3819),
    [anon_sym_namespace] = ACTIONS(3819),
    [anon_sym_class] = ACTIONS(3819),
    [anon_sym_ref] = ACTIONS(3819),
    [anon_sym_struct] = ACTIONS(3819),
    [anon_sym_enum] = ACTIONS(3819),
    [anon_sym_LBRACE] = ACTIONS(3821),
    [anon_sym_interface] = ACTIONS(3819),
    [anon_sym_delegate] = ACTIONS(3819),
    [anon_sym_record] = ACTIONS(3819),
    [anon_sym_abstract] = ACTIONS(3819),
    [anon_sym_async] = ACTIONS(3819),
    [anon_sym_const] = ACTIONS(3819),
    [anon_sym_file] = ACTIONS(3819),
    [anon_sym_fixed] = ACTIONS(3819),
    [anon_sym_internal] = ACTIONS(3819),
    [anon_sym_new] = ACTIONS(3819),
    [anon_sym_override] = ACTIONS(3819),
    [anon_sym_partial] = ACTIONS(3819),
    [anon_sym_private] = ACTIONS(3819),
    [anon_sym_protected] = ACTIONS(3819),
    [anon_sym_public] = ACTIONS(3819),
    [anon_sym_readonly] = ACTIONS(3819),
    [anon_sym_required] = ACTIONS(3819),
    [anon_sym_sealed] = ACTIONS(3819),
    [anon_sym_virtual] = ACTIONS(3819),
    [anon_sym_volatile] = ACTIONS(3819),
    [anon_sym_where] = ACTIONS(3819),
    [anon_sym_notnull] = ACTIONS(3819),
    [anon_sym_unmanaged] = ACTIONS(3819),
    [anon_sym_checked] = ACTIONS(3819),
    [anon_sym_BANG] = ACTIONS(3821),
    [anon_sym_TILDE] = ACTIONS(3821),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [anon_sym_true] = ACTIONS(3819),
    [anon_sym_false] = ACTIONS(3819),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_STAR] = ACTIONS(3821),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3821),
    [anon_sym_this] = ACTIONS(3819),
    [anon_sym_scoped] = ACTIONS(3819),
    [anon_sym_base] = ACTIONS(3819),
    [anon_sym_var] = ACTIONS(3819),
    [sym_predefined_type] = ACTIONS(3819),
    [anon_sym_break] = ACTIONS(3819),
    [anon_sym_unchecked] = ACTIONS(3819),
    [anon_sym_continue] = ACTIONS(3819),
    [anon_sym_do] = ACTIONS(3819),
    [anon_sym_while] = ACTIONS(3819),
    [anon_sym_for] = ACTIONS(3819),
    [anon_sym_lock] = ACTIONS(3819),
    [anon_sym_yield] = ACTIONS(3819),
    [anon_sym_switch] = ACTIONS(3819),
    [anon_sym_default] = ACTIONS(3819),
    [anon_sym_throw] = ACTIONS(3819),
    [anon_sym_try] = ACTIONS(3819),
    [anon_sym_when] = ACTIONS(3819),
    [anon_sym_await] = ACTIONS(3819),
    [anon_sym_foreach] = ACTIONS(3819),
    [anon_sym_goto] = ACTIONS(3819),
    [anon_sym_if] = ACTIONS(3819),
    [anon_sym_DOT_DOT] = ACTIONS(3821),
    [anon_sym_from] = ACTIONS(3819),
    [anon_sym_into] = ACTIONS(3819),
    [anon_sym_join] = ACTIONS(3819),
    [anon_sym_on] = ACTIONS(3819),
    [anon_sym_equals] = ACTIONS(3819),
    [anon_sym_let] = ACTIONS(3819),
    [anon_sym_orderby] = ACTIONS(3819),
    [anon_sym_ascending] = ACTIONS(3819),
    [anon_sym_descending] = ACTIONS(3819),
    [anon_sym_group] = ACTIONS(3819),
    [anon_sym_by] = ACTIONS(3819),
    [anon_sym_select] = ACTIONS(3819),
    [anon_sym_DQUOTE] = ACTIONS(3821),
    [anon_sym_stackalloc] = ACTIONS(3819),
    [anon_sym_sizeof] = ACTIONS(3819),
    [anon_sym_typeof] = ACTIONS(3819),
    [anon_sym___makeref] = ACTIONS(3819),
    [anon_sym___reftype] = ACTIONS(3819),
    [anon_sym___refvalue] = ACTIONS(3819),
    [sym_null_literal] = ACTIONS(3819),
    [anon_sym_SQUOTE] = ACTIONS(3821),
    [sym_integer_literal] = ACTIONS(3819),
    [sym_real_literal] = ACTIONS(3821),
    [sym_verbatim_string_literal] = ACTIONS(3821),
    [aux_sym_preproc_if_token1] = ACTIONS(3821),
    [aux_sym_preproc_if_token3] = ACTIONS(3821),
    [aux_sym_preproc_else_token1] = ACTIONS(3821),
    [aux_sym_preproc_elif_token1] = ACTIONS(3821),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3821),
    [sym_interpolation_verbatim_start] = ACTIONS(3821),
    [sym_interpolation_raw_start] = ACTIONS(3821),
    [sym_raw_string_start] = ACTIONS(3821),
  },
  [2413] = {
    [sym_preproc_region] = STATE(2413),
    [sym_preproc_endregion] = STATE(2413),
    [sym_preproc_line] = STATE(2413),
    [sym_preproc_pragma] = STATE(2413),
    [sym_preproc_nullable] = STATE(2413),
    [sym_preproc_error] = STATE(2413),
    [sym_preproc_define] = STATE(2413),
    [sym_preproc_undef] = STATE(2413),
    [sym__identifier_token] = ACTIONS(3823),
    [anon_sym_extern] = ACTIONS(3823),
    [anon_sym_alias] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3825),
    [anon_sym_global] = ACTIONS(3823),
    [anon_sym_using] = ACTIONS(3823),
    [anon_sym_unsafe] = ACTIONS(3823),
    [anon_sym_static] = ACTIONS(3823),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3823),
    [anon_sym_namespace] = ACTIONS(3823),
    [anon_sym_class] = ACTIONS(3823),
    [anon_sym_ref] = ACTIONS(3823),
    [anon_sym_struct] = ACTIONS(3823),
    [anon_sym_enum] = ACTIONS(3823),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_interface] = ACTIONS(3823),
    [anon_sym_delegate] = ACTIONS(3823),
    [anon_sym_record] = ACTIONS(3823),
    [anon_sym_abstract] = ACTIONS(3823),
    [anon_sym_async] = ACTIONS(3823),
    [anon_sym_const] = ACTIONS(3823),
    [anon_sym_file] = ACTIONS(3823),
    [anon_sym_fixed] = ACTIONS(3823),
    [anon_sym_internal] = ACTIONS(3823),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_override] = ACTIONS(3823),
    [anon_sym_partial] = ACTIONS(3823),
    [anon_sym_private] = ACTIONS(3823),
    [anon_sym_protected] = ACTIONS(3823),
    [anon_sym_public] = ACTIONS(3823),
    [anon_sym_readonly] = ACTIONS(3823),
    [anon_sym_required] = ACTIONS(3823),
    [anon_sym_sealed] = ACTIONS(3823),
    [anon_sym_virtual] = ACTIONS(3823),
    [anon_sym_volatile] = ACTIONS(3823),
    [anon_sym_where] = ACTIONS(3823),
    [anon_sym_notnull] = ACTIONS(3823),
    [anon_sym_unmanaged] = ACTIONS(3823),
    [anon_sym_checked] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [anon_sym_PLUS_PLUS] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(3825),
    [anon_sym_true] = ACTIONS(3823),
    [anon_sym_false] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(3823),
    [anon_sym_DASH] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_this] = ACTIONS(3823),
    [anon_sym_scoped] = ACTIONS(3823),
    [anon_sym_base] = ACTIONS(3823),
    [anon_sym_var] = ACTIONS(3823),
    [sym_predefined_type] = ACTIONS(3823),
    [anon_sym_break] = ACTIONS(3823),
    [anon_sym_unchecked] = ACTIONS(3823),
    [anon_sym_continue] = ACTIONS(3823),
    [anon_sym_do] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3823),
    [anon_sym_lock] = ACTIONS(3823),
    [anon_sym_yield] = ACTIONS(3823),
    [anon_sym_switch] = ACTIONS(3823),
    [anon_sym_default] = ACTIONS(3823),
    [anon_sym_throw] = ACTIONS(3823),
    [anon_sym_try] = ACTIONS(3823),
    [anon_sym_when] = ACTIONS(3823),
    [anon_sym_await] = ACTIONS(3823),
    [anon_sym_foreach] = ACTIONS(3823),
    [anon_sym_goto] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3825),
    [anon_sym_from] = ACTIONS(3823),
    [anon_sym_into] = ACTIONS(3823),
    [anon_sym_join] = ACTIONS(3823),
    [anon_sym_on] = ACTIONS(3823),
    [anon_sym_equals] = ACTIONS(3823),
    [anon_sym_let] = ACTIONS(3823),
    [anon_sym_orderby] = ACTIONS(3823),
    [anon_sym_ascending] = ACTIONS(3823),
    [anon_sym_descending] = ACTIONS(3823),
    [anon_sym_group] = ACTIONS(3823),
    [anon_sym_by] = ACTIONS(3823),
    [anon_sym_select] = ACTIONS(3823),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_stackalloc] = ACTIONS(3823),
    [anon_sym_sizeof] = ACTIONS(3823),
    [anon_sym_typeof] = ACTIONS(3823),
    [anon_sym___makeref] = ACTIONS(3823),
    [anon_sym___reftype] = ACTIONS(3823),
    [anon_sym___refvalue] = ACTIONS(3823),
    [sym_null_literal] = ACTIONS(3823),
    [anon_sym_SQUOTE] = ACTIONS(3825),
    [sym_integer_literal] = ACTIONS(3823),
    [sym_real_literal] = ACTIONS(3825),
    [sym_verbatim_string_literal] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token3] = ACTIONS(3825),
    [aux_sym_preproc_else_token1] = ACTIONS(3825),
    [aux_sym_preproc_elif_token1] = ACTIONS(3825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3825),
    [sym_interpolation_verbatim_start] = ACTIONS(3825),
    [sym_interpolation_raw_start] = ACTIONS(3825),
    [sym_raw_string_start] = ACTIONS(3825),
  },
  [2414] = {
    [sym_preproc_region] = STATE(2414),
    [sym_preproc_endregion] = STATE(2414),
    [sym_preproc_line] = STATE(2414),
    [sym_preproc_pragma] = STATE(2414),
    [sym_preproc_nullable] = STATE(2414),
    [sym_preproc_error] = STATE(2414),
    [sym_preproc_define] = STATE(2414),
    [sym_preproc_undef] = STATE(2414),
    [sym__identifier_token] = ACTIONS(3827),
    [anon_sym_extern] = ACTIONS(3827),
    [anon_sym_alias] = ACTIONS(3827),
    [anon_sym_SEMI] = ACTIONS(3829),
    [anon_sym_global] = ACTIONS(3827),
    [anon_sym_using] = ACTIONS(3827),
    [anon_sym_unsafe] = ACTIONS(3827),
    [anon_sym_static] = ACTIONS(3827),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3827),
    [anon_sym_namespace] = ACTIONS(3827),
    [anon_sym_class] = ACTIONS(3827),
    [anon_sym_ref] = ACTIONS(3827),
    [anon_sym_struct] = ACTIONS(3827),
    [anon_sym_enum] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_interface] = ACTIONS(3827),
    [anon_sym_delegate] = ACTIONS(3827),
    [anon_sym_record] = ACTIONS(3827),
    [anon_sym_abstract] = ACTIONS(3827),
    [anon_sym_async] = ACTIONS(3827),
    [anon_sym_const] = ACTIONS(3827),
    [anon_sym_file] = ACTIONS(3827),
    [anon_sym_fixed] = ACTIONS(3827),
    [anon_sym_internal] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3827),
    [anon_sym_override] = ACTIONS(3827),
    [anon_sym_partial] = ACTIONS(3827),
    [anon_sym_private] = ACTIONS(3827),
    [anon_sym_protected] = ACTIONS(3827),
    [anon_sym_public] = ACTIONS(3827),
    [anon_sym_readonly] = ACTIONS(3827),
    [anon_sym_required] = ACTIONS(3827),
    [anon_sym_sealed] = ACTIONS(3827),
    [anon_sym_virtual] = ACTIONS(3827),
    [anon_sym_volatile] = ACTIONS(3827),
    [anon_sym_where] = ACTIONS(3827),
    [anon_sym_notnull] = ACTIONS(3827),
    [anon_sym_unmanaged] = ACTIONS(3827),
    [anon_sym_checked] = ACTIONS(3827),
    [anon_sym_BANG] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3829),
    [anon_sym_PLUS_PLUS] = ACTIONS(3829),
    [anon_sym_DASH_DASH] = ACTIONS(3829),
    [anon_sym_true] = ACTIONS(3827),
    [anon_sym_false] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3829),
    [anon_sym_CARET] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_this] = ACTIONS(3827),
    [anon_sym_scoped] = ACTIONS(3827),
    [anon_sym_base] = ACTIONS(3827),
    [anon_sym_var] = ACTIONS(3827),
    [sym_predefined_type] = ACTIONS(3827),
    [anon_sym_break] = ACTIONS(3827),
    [anon_sym_unchecked] = ACTIONS(3827),
    [anon_sym_continue] = ACTIONS(3827),
    [anon_sym_do] = ACTIONS(3827),
    [anon_sym_while] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_lock] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3827),
    [anon_sym_switch] = ACTIONS(3827),
    [anon_sym_default] = ACTIONS(3827),
    [anon_sym_throw] = ACTIONS(3827),
    [anon_sym_try] = ACTIONS(3827),
    [anon_sym_when] = ACTIONS(3827),
    [anon_sym_await] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3827),
    [anon_sym_goto] = ACTIONS(3827),
    [anon_sym_if] = ACTIONS(3827),
    [anon_sym_DOT_DOT] = ACTIONS(3829),
    [anon_sym_from] = ACTIONS(3827),
    [anon_sym_into] = ACTIONS(3827),
    [anon_sym_join] = ACTIONS(3827),
    [anon_sym_on] = ACTIONS(3827),
    [anon_sym_equals] = ACTIONS(3827),
    [anon_sym_let] = ACTIONS(3827),
    [anon_sym_orderby] = ACTIONS(3827),
    [anon_sym_ascending] = ACTIONS(3827),
    [anon_sym_descending] = ACTIONS(3827),
    [anon_sym_group] = ACTIONS(3827),
    [anon_sym_by] = ACTIONS(3827),
    [anon_sym_select] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_stackalloc] = ACTIONS(3827),
    [anon_sym_sizeof] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3827),
    [anon_sym___makeref] = ACTIONS(3827),
    [anon_sym___reftype] = ACTIONS(3827),
    [anon_sym___refvalue] = ACTIONS(3827),
    [sym_null_literal] = ACTIONS(3827),
    [anon_sym_SQUOTE] = ACTIONS(3829),
    [sym_integer_literal] = ACTIONS(3827),
    [sym_real_literal] = ACTIONS(3829),
    [sym_verbatim_string_literal] = ACTIONS(3829),
    [aux_sym_preproc_if_token1] = ACTIONS(3829),
    [aux_sym_preproc_if_token3] = ACTIONS(3829),
    [aux_sym_preproc_else_token1] = ACTIONS(3829),
    [aux_sym_preproc_elif_token1] = ACTIONS(3829),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3829),
    [sym_interpolation_verbatim_start] = ACTIONS(3829),
    [sym_interpolation_raw_start] = ACTIONS(3829),
    [sym_raw_string_start] = ACTIONS(3829),
  },
  [2415] = {
    [sym_preproc_region] = STATE(2415),
    [sym_preproc_endregion] = STATE(2415),
    [sym_preproc_line] = STATE(2415),
    [sym_preproc_pragma] = STATE(2415),
    [sym_preproc_nullable] = STATE(2415),
    [sym_preproc_error] = STATE(2415),
    [sym_preproc_define] = STATE(2415),
    [sym_preproc_undef] = STATE(2415),
    [sym__identifier_token] = ACTIONS(3831),
    [anon_sym_extern] = ACTIONS(3831),
    [anon_sym_alias] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3833),
    [anon_sym_global] = ACTIONS(3831),
    [anon_sym_using] = ACTIONS(3831),
    [anon_sym_unsafe] = ACTIONS(3831),
    [anon_sym_static] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LPAREN] = ACTIONS(3833),
    [anon_sym_return] = ACTIONS(3831),
    [anon_sym_namespace] = ACTIONS(3831),
    [anon_sym_class] = ACTIONS(3831),
    [anon_sym_ref] = ACTIONS(3831),
    [anon_sym_struct] = ACTIONS(3831),
    [anon_sym_enum] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3833),
    [anon_sym_interface] = ACTIONS(3831),
    [anon_sym_delegate] = ACTIONS(3831),
    [anon_sym_record] = ACTIONS(3831),
    [anon_sym_abstract] = ACTIONS(3831),
    [anon_sym_async] = ACTIONS(3831),
    [anon_sym_const] = ACTIONS(3831),
    [anon_sym_file] = ACTIONS(3831),
    [anon_sym_fixed] = ACTIONS(3831),
    [anon_sym_internal] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3831),
    [anon_sym_override] = ACTIONS(3831),
    [anon_sym_partial] = ACTIONS(3831),
    [anon_sym_private] = ACTIONS(3831),
    [anon_sym_protected] = ACTIONS(3831),
    [anon_sym_public] = ACTIONS(3831),
    [anon_sym_readonly] = ACTIONS(3831),
    [anon_sym_required] = ACTIONS(3831),
    [anon_sym_sealed] = ACTIONS(3831),
    [anon_sym_virtual] = ACTIONS(3831),
    [anon_sym_volatile] = ACTIONS(3831),
    [anon_sym_where] = ACTIONS(3831),
    [anon_sym_notnull] = ACTIONS(3831),
    [anon_sym_unmanaged] = ACTIONS(3831),
    [anon_sym_checked] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3833),
    [anon_sym_TILDE] = ACTIONS(3833),
    [anon_sym_PLUS_PLUS] = ACTIONS(3833),
    [anon_sym_DASH_DASH] = ACTIONS(3833),
    [anon_sym_true] = ACTIONS(3831),
    [anon_sym_false] = ACTIONS(3831),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3833),
    [anon_sym_CARET] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_this] = ACTIONS(3831),
    [anon_sym_scoped] = ACTIONS(3831),
    [anon_sym_base] = ACTIONS(3831),
    [anon_sym_var] = ACTIONS(3831),
    [sym_predefined_type] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3831),
    [anon_sym_unchecked] = ACTIONS(3831),
    [anon_sym_continue] = ACTIONS(3831),
    [anon_sym_do] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3831),
    [anon_sym_lock] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3831),
    [anon_sym_switch] = ACTIONS(3831),
    [anon_sym_default] = ACTIONS(3831),
    [anon_sym_throw] = ACTIONS(3831),
    [anon_sym_try] = ACTIONS(3831),
    [anon_sym_when] = ACTIONS(3831),
    [anon_sym_await] = ACTIONS(3831),
    [anon_sym_foreach] = ACTIONS(3831),
    [anon_sym_goto] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_from] = ACTIONS(3831),
    [anon_sym_into] = ACTIONS(3831),
    [anon_sym_join] = ACTIONS(3831),
    [anon_sym_on] = ACTIONS(3831),
    [anon_sym_equals] = ACTIONS(3831),
    [anon_sym_let] = ACTIONS(3831),
    [anon_sym_orderby] = ACTIONS(3831),
    [anon_sym_ascending] = ACTIONS(3831),
    [anon_sym_descending] = ACTIONS(3831),
    [anon_sym_group] = ACTIONS(3831),
    [anon_sym_by] = ACTIONS(3831),
    [anon_sym_select] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3833),
    [anon_sym_stackalloc] = ACTIONS(3831),
    [anon_sym_sizeof] = ACTIONS(3831),
    [anon_sym_typeof] = ACTIONS(3831),
    [anon_sym___makeref] = ACTIONS(3831),
    [anon_sym___reftype] = ACTIONS(3831),
    [anon_sym___refvalue] = ACTIONS(3831),
    [sym_null_literal] = ACTIONS(3831),
    [anon_sym_SQUOTE] = ACTIONS(3833),
    [sym_integer_literal] = ACTIONS(3831),
    [sym_real_literal] = ACTIONS(3833),
    [sym_verbatim_string_literal] = ACTIONS(3833),
    [aux_sym_preproc_if_token1] = ACTIONS(3833),
    [aux_sym_preproc_if_token3] = ACTIONS(3833),
    [aux_sym_preproc_else_token1] = ACTIONS(3833),
    [aux_sym_preproc_elif_token1] = ACTIONS(3833),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3833),
    [sym_interpolation_verbatim_start] = ACTIONS(3833),
    [sym_interpolation_raw_start] = ACTIONS(3833),
    [sym_raw_string_start] = ACTIONS(3833),
  },
  [2416] = {
    [sym_preproc_region] = STATE(2416),
    [sym_preproc_endregion] = STATE(2416),
    [sym_preproc_line] = STATE(2416),
    [sym_preproc_pragma] = STATE(2416),
    [sym_preproc_nullable] = STATE(2416),
    [sym_preproc_error] = STATE(2416),
    [sym_preproc_define] = STATE(2416),
    [sym_preproc_undef] = STATE(2416),
    [sym__identifier_token] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(3835),
    [anon_sym_alias] = ACTIONS(3835),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_global] = ACTIONS(3835),
    [anon_sym_using] = ACTIONS(3835),
    [anon_sym_unsafe] = ACTIONS(3835),
    [anon_sym_static] = ACTIONS(3835),
    [anon_sym_LBRACK] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3837),
    [anon_sym_return] = ACTIONS(3835),
    [anon_sym_namespace] = ACTIONS(3835),
    [anon_sym_class] = ACTIONS(3835),
    [anon_sym_ref] = ACTIONS(3835),
    [anon_sym_struct] = ACTIONS(3835),
    [anon_sym_enum] = ACTIONS(3835),
    [anon_sym_LBRACE] = ACTIONS(3837),
    [anon_sym_interface] = ACTIONS(3835),
    [anon_sym_delegate] = ACTIONS(3835),
    [anon_sym_record] = ACTIONS(3835),
    [anon_sym_abstract] = ACTIONS(3835),
    [anon_sym_async] = ACTIONS(3835),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_file] = ACTIONS(3835),
    [anon_sym_fixed] = ACTIONS(3835),
    [anon_sym_internal] = ACTIONS(3835),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_override] = ACTIONS(3835),
    [anon_sym_partial] = ACTIONS(3835),
    [anon_sym_private] = ACTIONS(3835),
    [anon_sym_protected] = ACTIONS(3835),
    [anon_sym_public] = ACTIONS(3835),
    [anon_sym_readonly] = ACTIONS(3835),
    [anon_sym_required] = ACTIONS(3835),
    [anon_sym_sealed] = ACTIONS(3835),
    [anon_sym_virtual] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_where] = ACTIONS(3835),
    [anon_sym_notnull] = ACTIONS(3835),
    [anon_sym_unmanaged] = ACTIONS(3835),
    [anon_sym_checked] = ACTIONS(3835),
    [anon_sym_BANG] = ACTIONS(3837),
    [anon_sym_TILDE] = ACTIONS(3837),
    [anon_sym_PLUS_PLUS] = ACTIONS(3837),
    [anon_sym_DASH_DASH] = ACTIONS(3837),
    [anon_sym_true] = ACTIONS(3835),
    [anon_sym_false] = ACTIONS(3835),
    [anon_sym_PLUS] = ACTIONS(3835),
    [anon_sym_DASH] = ACTIONS(3835),
    [anon_sym_STAR] = ACTIONS(3837),
    [anon_sym_CARET] = ACTIONS(3837),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_this] = ACTIONS(3835),
    [anon_sym_scoped] = ACTIONS(3835),
    [anon_sym_base] = ACTIONS(3835),
    [anon_sym_var] = ACTIONS(3835),
    [sym_predefined_type] = ACTIONS(3835),
    [anon_sym_break] = ACTIONS(3835),
    [anon_sym_unchecked] = ACTIONS(3835),
    [anon_sym_continue] = ACTIONS(3835),
    [anon_sym_do] = ACTIONS(3835),
    [anon_sym_while] = ACTIONS(3835),
    [anon_sym_for] = ACTIONS(3835),
    [anon_sym_lock] = ACTIONS(3835),
    [anon_sym_yield] = ACTIONS(3835),
    [anon_sym_switch] = ACTIONS(3835),
    [anon_sym_default] = ACTIONS(3835),
    [anon_sym_throw] = ACTIONS(3835),
    [anon_sym_try] = ACTIONS(3835),
    [anon_sym_when] = ACTIONS(3835),
    [anon_sym_await] = ACTIONS(3835),
    [anon_sym_foreach] = ACTIONS(3835),
    [anon_sym_goto] = ACTIONS(3835),
    [anon_sym_if] = ACTIONS(3835),
    [anon_sym_DOT_DOT] = ACTIONS(3837),
    [anon_sym_from] = ACTIONS(3835),
    [anon_sym_into] = ACTIONS(3835),
    [anon_sym_join] = ACTIONS(3835),
    [anon_sym_on] = ACTIONS(3835),
    [anon_sym_equals] = ACTIONS(3835),
    [anon_sym_let] = ACTIONS(3835),
    [anon_sym_orderby] = ACTIONS(3835),
    [anon_sym_ascending] = ACTIONS(3835),
    [anon_sym_descending] = ACTIONS(3835),
    [anon_sym_group] = ACTIONS(3835),
    [anon_sym_by] = ACTIONS(3835),
    [anon_sym_select] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_stackalloc] = ACTIONS(3835),
    [anon_sym_sizeof] = ACTIONS(3835),
    [anon_sym_typeof] = ACTIONS(3835),
    [anon_sym___makeref] = ACTIONS(3835),
    [anon_sym___reftype] = ACTIONS(3835),
    [anon_sym___refvalue] = ACTIONS(3835),
    [sym_null_literal] = ACTIONS(3835),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [sym_integer_literal] = ACTIONS(3835),
    [sym_real_literal] = ACTIONS(3837),
    [sym_verbatim_string_literal] = ACTIONS(3837),
    [aux_sym_preproc_if_token1] = ACTIONS(3837),
    [aux_sym_preproc_if_token3] = ACTIONS(3837),
    [aux_sym_preproc_else_token1] = ACTIONS(3837),
    [aux_sym_preproc_elif_token1] = ACTIONS(3837),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3837),
    [sym_interpolation_verbatim_start] = ACTIONS(3837),
    [sym_interpolation_raw_start] = ACTIONS(3837),
    [sym_raw_string_start] = ACTIONS(3837),
  },
  [2417] = {
    [sym_preproc_region] = STATE(2417),
    [sym_preproc_endregion] = STATE(2417),
    [sym_preproc_line] = STATE(2417),
    [sym_preproc_pragma] = STATE(2417),
    [sym_preproc_nullable] = STATE(2417),
    [sym_preproc_error] = STATE(2417),
    [sym_preproc_define] = STATE(2417),
    [sym_preproc_undef] = STATE(2417),
    [sym__identifier_token] = ACTIONS(3839),
    [anon_sym_extern] = ACTIONS(3839),
    [anon_sym_alias] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3841),
    [anon_sym_global] = ACTIONS(3839),
    [anon_sym_using] = ACTIONS(3839),
    [anon_sym_unsafe] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3839),
    [anon_sym_namespace] = ACTIONS(3839),
    [anon_sym_class] = ACTIONS(3839),
    [anon_sym_ref] = ACTIONS(3839),
    [anon_sym_struct] = ACTIONS(3839),
    [anon_sym_enum] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3839),
    [anon_sym_delegate] = ACTIONS(3839),
    [anon_sym_record] = ACTIONS(3839),
    [anon_sym_abstract] = ACTIONS(3839),
    [anon_sym_async] = ACTIONS(3839),
    [anon_sym_const] = ACTIONS(3839),
    [anon_sym_file] = ACTIONS(3839),
    [anon_sym_fixed] = ACTIONS(3839),
    [anon_sym_internal] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3839),
    [anon_sym_override] = ACTIONS(3839),
    [anon_sym_partial] = ACTIONS(3839),
    [anon_sym_private] = ACTIONS(3839),
    [anon_sym_protected] = ACTIONS(3839),
    [anon_sym_public] = ACTIONS(3839),
    [anon_sym_readonly] = ACTIONS(3839),
    [anon_sym_required] = ACTIONS(3839),
    [anon_sym_sealed] = ACTIONS(3839),
    [anon_sym_virtual] = ACTIONS(3839),
    [anon_sym_volatile] = ACTIONS(3839),
    [anon_sym_where] = ACTIONS(3839),
    [anon_sym_notnull] = ACTIONS(3839),
    [anon_sym_unmanaged] = ACTIONS(3839),
    [anon_sym_checked] = ACTIONS(3839),
    [anon_sym_BANG] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3841),
    [anon_sym_PLUS_PLUS] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3841),
    [anon_sym_true] = ACTIONS(3839),
    [anon_sym_false] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3839),
    [anon_sym_DASH] = ACTIONS(3839),
    [anon_sym_STAR] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_this] = ACTIONS(3839),
    [anon_sym_scoped] = ACTIONS(3839),
    [anon_sym_base] = ACTIONS(3839),
    [anon_sym_var] = ACTIONS(3839),
    [sym_predefined_type] = ACTIONS(3839),
    [anon_sym_break] = ACTIONS(3839),
    [anon_sym_unchecked] = ACTIONS(3839),
    [anon_sym_continue] = ACTIONS(3839),
    [anon_sym_do] = ACTIONS(3839),
    [anon_sym_while] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3839),
    [anon_sym_lock] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3839),
    [anon_sym_switch] = ACTIONS(3839),
    [anon_sym_default] = ACTIONS(3839),
    [anon_sym_throw] = ACTIONS(3839),
    [anon_sym_try] = ACTIONS(3839),
    [anon_sym_when] = ACTIONS(3839),
    [anon_sym_await] = ACTIONS(3839),
    [anon_sym_foreach] = ACTIONS(3839),
    [anon_sym_goto] = ACTIONS(3839),
    [anon_sym_if] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3841),
    [anon_sym_from] = ACTIONS(3839),
    [anon_sym_into] = ACTIONS(3839),
    [anon_sym_join] = ACTIONS(3839),
    [anon_sym_on] = ACTIONS(3839),
    [anon_sym_equals] = ACTIONS(3839),
    [anon_sym_let] = ACTIONS(3839),
    [anon_sym_orderby] = ACTIONS(3839),
    [anon_sym_ascending] = ACTIONS(3839),
    [anon_sym_descending] = ACTIONS(3839),
    [anon_sym_group] = ACTIONS(3839),
    [anon_sym_by] = ACTIONS(3839),
    [anon_sym_select] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_stackalloc] = ACTIONS(3839),
    [anon_sym_sizeof] = ACTIONS(3839),
    [anon_sym_typeof] = ACTIONS(3839),
    [anon_sym___makeref] = ACTIONS(3839),
    [anon_sym___reftype] = ACTIONS(3839),
    [anon_sym___refvalue] = ACTIONS(3839),
    [sym_null_literal] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(3841),
    [sym_integer_literal] = ACTIONS(3839),
    [sym_real_literal] = ACTIONS(3841),
    [sym_verbatim_string_literal] = ACTIONS(3841),
    [aux_sym_preproc_if_token1] = ACTIONS(3841),
    [aux_sym_preproc_if_token3] = ACTIONS(3841),
    [aux_sym_preproc_else_token1] = ACTIONS(3841),
    [aux_sym_preproc_elif_token1] = ACTIONS(3841),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3841),
    [sym_interpolation_verbatim_start] = ACTIONS(3841),
    [sym_interpolation_raw_start] = ACTIONS(3841),
    [sym_raw_string_start] = ACTIONS(3841),
  },
  [2418] = {
    [sym_preproc_region] = STATE(2418),
    [sym_preproc_endregion] = STATE(2418),
    [sym_preproc_line] = STATE(2418),
    [sym_preproc_pragma] = STATE(2418),
    [sym_preproc_nullable] = STATE(2418),
    [sym_preproc_error] = STATE(2418),
    [sym_preproc_define] = STATE(2418),
    [sym_preproc_undef] = STATE(2418),
    [sym__identifier_token] = ACTIONS(3843),
    [anon_sym_extern] = ACTIONS(3843),
    [anon_sym_alias] = ACTIONS(3843),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_global] = ACTIONS(3843),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_unsafe] = ACTIONS(3843),
    [anon_sym_static] = ACTIONS(3843),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3843),
    [anon_sym_namespace] = ACTIONS(3843),
    [anon_sym_class] = ACTIONS(3843),
    [anon_sym_ref] = ACTIONS(3843),
    [anon_sym_struct] = ACTIONS(3843),
    [anon_sym_enum] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3843),
    [anon_sym_delegate] = ACTIONS(3843),
    [anon_sym_record] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3843),
    [anon_sym_async] = ACTIONS(3843),
    [anon_sym_const] = ACTIONS(3843),
    [anon_sym_file] = ACTIONS(3843),
    [anon_sym_fixed] = ACTIONS(3843),
    [anon_sym_internal] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3843),
    [anon_sym_override] = ACTIONS(3843),
    [anon_sym_partial] = ACTIONS(3843),
    [anon_sym_private] = ACTIONS(3843),
    [anon_sym_protected] = ACTIONS(3843),
    [anon_sym_public] = ACTIONS(3843),
    [anon_sym_readonly] = ACTIONS(3843),
    [anon_sym_required] = ACTIONS(3843),
    [anon_sym_sealed] = ACTIONS(3843),
    [anon_sym_virtual] = ACTIONS(3843),
    [anon_sym_volatile] = ACTIONS(3843),
    [anon_sym_where] = ACTIONS(3843),
    [anon_sym_notnull] = ACTIONS(3843),
    [anon_sym_unmanaged] = ACTIONS(3843),
    [anon_sym_checked] = ACTIONS(3843),
    [anon_sym_BANG] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_PLUS_PLUS] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3845),
    [anon_sym_true] = ACTIONS(3843),
    [anon_sym_false] = ACTIONS(3843),
    [anon_sym_PLUS] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [anon_sym_STAR] = ACTIONS(3845),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_this] = ACTIONS(3843),
    [anon_sym_scoped] = ACTIONS(3843),
    [anon_sym_base] = ACTIONS(3843),
    [anon_sym_var] = ACTIONS(3843),
    [sym_predefined_type] = ACTIONS(3843),
    [anon_sym_break] = ACTIONS(3843),
    [anon_sym_unchecked] = ACTIONS(3843),
    [anon_sym_continue] = ACTIONS(3843),
    [anon_sym_do] = ACTIONS(3843),
    [anon_sym_while] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3843),
    [anon_sym_lock] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3843),
    [anon_sym_switch] = ACTIONS(3843),
    [anon_sym_default] = ACTIONS(3843),
    [anon_sym_throw] = ACTIONS(3843),
    [anon_sym_try] = ACTIONS(3843),
    [anon_sym_when] = ACTIONS(3843),
    [anon_sym_await] = ACTIONS(3843),
    [anon_sym_foreach] = ACTIONS(3843),
    [anon_sym_goto] = ACTIONS(3843),
    [anon_sym_if] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_from] = ACTIONS(3843),
    [anon_sym_into] = ACTIONS(3843),
    [anon_sym_join] = ACTIONS(3843),
    [anon_sym_on] = ACTIONS(3843),
    [anon_sym_equals] = ACTIONS(3843),
    [anon_sym_let] = ACTIONS(3843),
    [anon_sym_orderby] = ACTIONS(3843),
    [anon_sym_ascending] = ACTIONS(3843),
    [anon_sym_descending] = ACTIONS(3843),
    [anon_sym_group] = ACTIONS(3843),
    [anon_sym_by] = ACTIONS(3843),
    [anon_sym_select] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_stackalloc] = ACTIONS(3843),
    [anon_sym_sizeof] = ACTIONS(3843),
    [anon_sym_typeof] = ACTIONS(3843),
    [anon_sym___makeref] = ACTIONS(3843),
    [anon_sym___reftype] = ACTIONS(3843),
    [anon_sym___refvalue] = ACTIONS(3843),
    [sym_null_literal] = ACTIONS(3843),
    [anon_sym_SQUOTE] = ACTIONS(3845),
    [sym_integer_literal] = ACTIONS(3843),
    [sym_real_literal] = ACTIONS(3845),
    [sym_verbatim_string_literal] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token3] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3845),
    [sym_interpolation_verbatim_start] = ACTIONS(3845),
    [sym_interpolation_raw_start] = ACTIONS(3845),
    [sym_raw_string_start] = ACTIONS(3845),
  },
  [2419] = {
    [sym_preproc_region] = STATE(2419),
    [sym_preproc_endregion] = STATE(2419),
    [sym_preproc_line] = STATE(2419),
    [sym_preproc_pragma] = STATE(2419),
    [sym_preproc_nullable] = STATE(2419),
    [sym_preproc_error] = STATE(2419),
    [sym_preproc_define] = STATE(2419),
    [sym_preproc_undef] = STATE(2419),
    [sym__identifier_token] = ACTIONS(3847),
    [anon_sym_extern] = ACTIONS(3847),
    [anon_sym_alias] = ACTIONS(3847),
    [anon_sym_SEMI] = ACTIONS(3849),
    [anon_sym_global] = ACTIONS(3847),
    [anon_sym_using] = ACTIONS(3847),
    [anon_sym_unsafe] = ACTIONS(3847),
    [anon_sym_static] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_namespace] = ACTIONS(3847),
    [anon_sym_class] = ACTIONS(3847),
    [anon_sym_ref] = ACTIONS(3847),
    [anon_sym_struct] = ACTIONS(3847),
    [anon_sym_enum] = ACTIONS(3847),
    [anon_sym_LBRACE] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3847),
    [anon_sym_delegate] = ACTIONS(3847),
    [anon_sym_record] = ACTIONS(3847),
    [anon_sym_abstract] = ACTIONS(3847),
    [anon_sym_async] = ACTIONS(3847),
    [anon_sym_const] = ACTIONS(3847),
    [anon_sym_file] = ACTIONS(3847),
    [anon_sym_fixed] = ACTIONS(3847),
    [anon_sym_internal] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_override] = ACTIONS(3847),
    [anon_sym_partial] = ACTIONS(3847),
    [anon_sym_private] = ACTIONS(3847),
    [anon_sym_protected] = ACTIONS(3847),
    [anon_sym_public] = ACTIONS(3847),
    [anon_sym_readonly] = ACTIONS(3847),
    [anon_sym_required] = ACTIONS(3847),
    [anon_sym_sealed] = ACTIONS(3847),
    [anon_sym_virtual] = ACTIONS(3847),
    [anon_sym_volatile] = ACTIONS(3847),
    [anon_sym_where] = ACTIONS(3847),
    [anon_sym_notnull] = ACTIONS(3847),
    [anon_sym_unmanaged] = ACTIONS(3847),
    [anon_sym_checked] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3849),
    [anon_sym_TILDE] = ACTIONS(3849),
    [anon_sym_PLUS_PLUS] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3849),
    [anon_sym_true] = ACTIONS(3847),
    [anon_sym_false] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3849),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_this] = ACTIONS(3847),
    [anon_sym_scoped] = ACTIONS(3847),
    [anon_sym_base] = ACTIONS(3847),
    [anon_sym_var] = ACTIONS(3847),
    [sym_predefined_type] = ACTIONS(3847),
    [anon_sym_break] = ACTIONS(3847),
    [anon_sym_unchecked] = ACTIONS(3847),
    [anon_sym_continue] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_lock] = ACTIONS(3847),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_switch] = ACTIONS(3847),
    [anon_sym_default] = ACTIONS(3847),
    [anon_sym_throw] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_when] = ACTIONS(3847),
    [anon_sym_await] = ACTIONS(3847),
    [anon_sym_foreach] = ACTIONS(3847),
    [anon_sym_goto] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_from] = ACTIONS(3847),
    [anon_sym_into] = ACTIONS(3847),
    [anon_sym_join] = ACTIONS(3847),
    [anon_sym_on] = ACTIONS(3847),
    [anon_sym_equals] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_orderby] = ACTIONS(3847),
    [anon_sym_ascending] = ACTIONS(3847),
    [anon_sym_descending] = ACTIONS(3847),
    [anon_sym_group] = ACTIONS(3847),
    [anon_sym_by] = ACTIONS(3847),
    [anon_sym_select] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3849),
    [anon_sym_stackalloc] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3847),
    [anon_sym_typeof] = ACTIONS(3847),
    [anon_sym___makeref] = ACTIONS(3847),
    [anon_sym___reftype] = ACTIONS(3847),
    [anon_sym___refvalue] = ACTIONS(3847),
    [sym_null_literal] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3849),
    [sym_integer_literal] = ACTIONS(3847),
    [sym_real_literal] = ACTIONS(3849),
    [sym_verbatim_string_literal] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token3] = ACTIONS(3849),
    [aux_sym_preproc_else_token1] = ACTIONS(3849),
    [aux_sym_preproc_elif_token1] = ACTIONS(3849),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3849),
    [sym_interpolation_verbatim_start] = ACTIONS(3849),
    [sym_interpolation_raw_start] = ACTIONS(3849),
    [sym_raw_string_start] = ACTIONS(3849),
  },
  [2420] = {
    [sym_preproc_region] = STATE(2420),
    [sym_preproc_endregion] = STATE(2420),
    [sym_preproc_line] = STATE(2420),
    [sym_preproc_pragma] = STATE(2420),
    [sym_preproc_nullable] = STATE(2420),
    [sym_preproc_error] = STATE(2420),
    [sym_preproc_define] = STATE(2420),
    [sym_preproc_undef] = STATE(2420),
    [sym__identifier_token] = ACTIONS(3851),
    [anon_sym_extern] = ACTIONS(3851),
    [anon_sym_alias] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3853),
    [anon_sym_global] = ACTIONS(3851),
    [anon_sym_using] = ACTIONS(3851),
    [anon_sym_unsafe] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_LPAREN] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3851),
    [anon_sym_namespace] = ACTIONS(3851),
    [anon_sym_class] = ACTIONS(3851),
    [anon_sym_ref] = ACTIONS(3851),
    [anon_sym_struct] = ACTIONS(3851),
    [anon_sym_enum] = ACTIONS(3851),
    [anon_sym_LBRACE] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3851),
    [anon_sym_delegate] = ACTIONS(3851),
    [anon_sym_record] = ACTIONS(3851),
    [anon_sym_abstract] = ACTIONS(3851),
    [anon_sym_async] = ACTIONS(3851),
    [anon_sym_const] = ACTIONS(3851),
    [anon_sym_file] = ACTIONS(3851),
    [anon_sym_fixed] = ACTIONS(3851),
    [anon_sym_internal] = ACTIONS(3851),
    [anon_sym_new] = ACTIONS(3851),
    [anon_sym_override] = ACTIONS(3851),
    [anon_sym_partial] = ACTIONS(3851),
    [anon_sym_private] = ACTIONS(3851),
    [anon_sym_protected] = ACTIONS(3851),
    [anon_sym_public] = ACTIONS(3851),
    [anon_sym_readonly] = ACTIONS(3851),
    [anon_sym_required] = ACTIONS(3851),
    [anon_sym_sealed] = ACTIONS(3851),
    [anon_sym_virtual] = ACTIONS(3851),
    [anon_sym_volatile] = ACTIONS(3851),
    [anon_sym_where] = ACTIONS(3851),
    [anon_sym_notnull] = ACTIONS(3851),
    [anon_sym_unmanaged] = ACTIONS(3851),
    [anon_sym_checked] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_PLUS_PLUS] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3853),
    [anon_sym_true] = ACTIONS(3851),
    [anon_sym_false] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_this] = ACTIONS(3851),
    [anon_sym_scoped] = ACTIONS(3851),
    [anon_sym_base] = ACTIONS(3851),
    [anon_sym_var] = ACTIONS(3851),
    [sym_predefined_type] = ACTIONS(3851),
    [anon_sym_break] = ACTIONS(3851),
    [anon_sym_unchecked] = ACTIONS(3851),
    [anon_sym_continue] = ACTIONS(3851),
    [anon_sym_do] = ACTIONS(3851),
    [anon_sym_while] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3851),
    [anon_sym_lock] = ACTIONS(3851),
    [anon_sym_yield] = ACTIONS(3851),
    [anon_sym_switch] = ACTIONS(3851),
    [anon_sym_default] = ACTIONS(3851),
    [anon_sym_throw] = ACTIONS(3851),
    [anon_sym_try] = ACTIONS(3851),
    [anon_sym_when] = ACTIONS(3851),
    [anon_sym_await] = ACTIONS(3851),
    [anon_sym_foreach] = ACTIONS(3851),
    [anon_sym_goto] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_DOT_DOT] = ACTIONS(3853),
    [anon_sym_from] = ACTIONS(3851),
    [anon_sym_into] = ACTIONS(3851),
    [anon_sym_join] = ACTIONS(3851),
    [anon_sym_on] = ACTIONS(3851),
    [anon_sym_equals] = ACTIONS(3851),
    [anon_sym_let] = ACTIONS(3851),
    [anon_sym_orderby] = ACTIONS(3851),
    [anon_sym_ascending] = ACTIONS(3851),
    [anon_sym_descending] = ACTIONS(3851),
    [anon_sym_group] = ACTIONS(3851),
    [anon_sym_by] = ACTIONS(3851),
    [anon_sym_select] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3853),
    [anon_sym_stackalloc] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3851),
    [anon_sym_typeof] = ACTIONS(3851),
    [anon_sym___makeref] = ACTIONS(3851),
    [anon_sym___reftype] = ACTIONS(3851),
    [anon_sym___refvalue] = ACTIONS(3851),
    [sym_null_literal] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3853),
    [sym_integer_literal] = ACTIONS(3851),
    [sym_real_literal] = ACTIONS(3853),
    [sym_verbatim_string_literal] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token3] = ACTIONS(3853),
    [aux_sym_preproc_else_token1] = ACTIONS(3853),
    [aux_sym_preproc_elif_token1] = ACTIONS(3853),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3853),
    [sym_interpolation_verbatim_start] = ACTIONS(3853),
    [sym_interpolation_raw_start] = ACTIONS(3853),
    [sym_raw_string_start] = ACTIONS(3853),
  },
  [2421] = {
    [sym_preproc_region] = STATE(2421),
    [sym_preproc_endregion] = STATE(2421),
    [sym_preproc_line] = STATE(2421),
    [sym_preproc_pragma] = STATE(2421),
    [sym_preproc_nullable] = STATE(2421),
    [sym_preproc_error] = STATE(2421),
    [sym_preproc_define] = STATE(2421),
    [sym_preproc_undef] = STATE(2421),
    [sym__identifier_token] = ACTIONS(3855),
    [anon_sym_extern] = ACTIONS(3855),
    [anon_sym_alias] = ACTIONS(3855),
    [anon_sym_SEMI] = ACTIONS(3857),
    [anon_sym_global] = ACTIONS(3855),
    [anon_sym_using] = ACTIONS(3855),
    [anon_sym_unsafe] = ACTIONS(3855),
    [anon_sym_static] = ACTIONS(3855),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_LPAREN] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3855),
    [anon_sym_namespace] = ACTIONS(3855),
    [anon_sym_class] = ACTIONS(3855),
    [anon_sym_ref] = ACTIONS(3855),
    [anon_sym_struct] = ACTIONS(3855),
    [anon_sym_enum] = ACTIONS(3855),
    [anon_sym_LBRACE] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3855),
    [anon_sym_delegate] = ACTIONS(3855),
    [anon_sym_record] = ACTIONS(3855),
    [anon_sym_abstract] = ACTIONS(3855),
    [anon_sym_async] = ACTIONS(3855),
    [anon_sym_const] = ACTIONS(3855),
    [anon_sym_file] = ACTIONS(3855),
    [anon_sym_fixed] = ACTIONS(3855),
    [anon_sym_internal] = ACTIONS(3855),
    [anon_sym_new] = ACTIONS(3855),
    [anon_sym_override] = ACTIONS(3855),
    [anon_sym_partial] = ACTIONS(3855),
    [anon_sym_private] = ACTIONS(3855),
    [anon_sym_protected] = ACTIONS(3855),
    [anon_sym_public] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3855),
    [anon_sym_required] = ACTIONS(3855),
    [anon_sym_sealed] = ACTIONS(3855),
    [anon_sym_virtual] = ACTIONS(3855),
    [anon_sym_volatile] = ACTIONS(3855),
    [anon_sym_where] = ACTIONS(3855),
    [anon_sym_notnull] = ACTIONS(3855),
    [anon_sym_unmanaged] = ACTIONS(3855),
    [anon_sym_checked] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3857),
    [anon_sym_TILDE] = ACTIONS(3857),
    [anon_sym_PLUS_PLUS] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3857),
    [anon_sym_true] = ACTIONS(3855),
    [anon_sym_false] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_STAR] = ACTIONS(3857),
    [anon_sym_CARET] = ACTIONS(3857),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_this] = ACTIONS(3855),
    [anon_sym_scoped] = ACTIONS(3855),
    [anon_sym_base] = ACTIONS(3855),
    [anon_sym_var] = ACTIONS(3855),
    [sym_predefined_type] = ACTIONS(3855),
    [anon_sym_break] = ACTIONS(3855),
    [anon_sym_unchecked] = ACTIONS(3855),
    [anon_sym_continue] = ACTIONS(3855),
    [anon_sym_do] = ACTIONS(3855),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_for] = ACTIONS(3855),
    [anon_sym_lock] = ACTIONS(3855),
    [anon_sym_yield] = ACTIONS(3855),
    [anon_sym_switch] = ACTIONS(3855),
    [anon_sym_default] = ACTIONS(3855),
    [anon_sym_throw] = ACTIONS(3855),
    [anon_sym_try] = ACTIONS(3855),
    [anon_sym_when] = ACTIONS(3855),
    [anon_sym_await] = ACTIONS(3855),
    [anon_sym_foreach] = ACTIONS(3855),
    [anon_sym_goto] = ACTIONS(3855),
    [anon_sym_if] = ACTIONS(3855),
    [anon_sym_DOT_DOT] = ACTIONS(3857),
    [anon_sym_from] = ACTIONS(3855),
    [anon_sym_into] = ACTIONS(3855),
    [anon_sym_join] = ACTIONS(3855),
    [anon_sym_on] = ACTIONS(3855),
    [anon_sym_equals] = ACTIONS(3855),
    [anon_sym_let] = ACTIONS(3855),
    [anon_sym_orderby] = ACTIONS(3855),
    [anon_sym_ascending] = ACTIONS(3855),
    [anon_sym_descending] = ACTIONS(3855),
    [anon_sym_group] = ACTIONS(3855),
    [anon_sym_by] = ACTIONS(3855),
    [anon_sym_select] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3857),
    [anon_sym_stackalloc] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3855),
    [anon_sym_typeof] = ACTIONS(3855),
    [anon_sym___makeref] = ACTIONS(3855),
    [anon_sym___reftype] = ACTIONS(3855),
    [anon_sym___refvalue] = ACTIONS(3855),
    [sym_null_literal] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3857),
    [sym_integer_literal] = ACTIONS(3855),
    [sym_real_literal] = ACTIONS(3857),
    [sym_verbatim_string_literal] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token3] = ACTIONS(3857),
    [aux_sym_preproc_else_token1] = ACTIONS(3857),
    [aux_sym_preproc_elif_token1] = ACTIONS(3857),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3857),
    [sym_interpolation_verbatim_start] = ACTIONS(3857),
    [sym_interpolation_raw_start] = ACTIONS(3857),
    [sym_raw_string_start] = ACTIONS(3857),
  },
  [2422] = {
    [sym_preproc_region] = STATE(2422),
    [sym_preproc_endregion] = STATE(2422),
    [sym_preproc_line] = STATE(2422),
    [sym_preproc_pragma] = STATE(2422),
    [sym_preproc_nullable] = STATE(2422),
    [sym_preproc_error] = STATE(2422),
    [sym_preproc_define] = STATE(2422),
    [sym_preproc_undef] = STATE(2422),
    [sym__identifier_token] = ACTIONS(3859),
    [anon_sym_extern] = ACTIONS(3859),
    [anon_sym_alias] = ACTIONS(3859),
    [anon_sym_SEMI] = ACTIONS(3861),
    [anon_sym_global] = ACTIONS(3859),
    [anon_sym_using] = ACTIONS(3859),
    [anon_sym_unsafe] = ACTIONS(3859),
    [anon_sym_static] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_namespace] = ACTIONS(3859),
    [anon_sym_class] = ACTIONS(3859),
    [anon_sym_ref] = ACTIONS(3859),
    [anon_sym_struct] = ACTIONS(3859),
    [anon_sym_enum] = ACTIONS(3859),
    [anon_sym_LBRACE] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3859),
    [anon_sym_delegate] = ACTIONS(3859),
    [anon_sym_record] = ACTIONS(3859),
    [anon_sym_abstract] = ACTIONS(3859),
    [anon_sym_async] = ACTIONS(3859),
    [anon_sym_const] = ACTIONS(3859),
    [anon_sym_file] = ACTIONS(3859),
    [anon_sym_fixed] = ACTIONS(3859),
    [anon_sym_internal] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_override] = ACTIONS(3859),
    [anon_sym_partial] = ACTIONS(3859),
    [anon_sym_private] = ACTIONS(3859),
    [anon_sym_protected] = ACTIONS(3859),
    [anon_sym_public] = ACTIONS(3859),
    [anon_sym_readonly] = ACTIONS(3859),
    [anon_sym_required] = ACTIONS(3859),
    [anon_sym_sealed] = ACTIONS(3859),
    [anon_sym_virtual] = ACTIONS(3859),
    [anon_sym_volatile] = ACTIONS(3859),
    [anon_sym_where] = ACTIONS(3859),
    [anon_sym_notnull] = ACTIONS(3859),
    [anon_sym_unmanaged] = ACTIONS(3859),
    [anon_sym_checked] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3861),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_PLUS_PLUS] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3861),
    [anon_sym_true] = ACTIONS(3859),
    [anon_sym_false] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_this] = ACTIONS(3859),
    [anon_sym_scoped] = ACTIONS(3859),
    [anon_sym_base] = ACTIONS(3859),
    [anon_sym_var] = ACTIONS(3859),
    [sym_predefined_type] = ACTIONS(3859),
    [anon_sym_break] = ACTIONS(3859),
    [anon_sym_unchecked] = ACTIONS(3859),
    [anon_sym_continue] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_lock] = ACTIONS(3859),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_switch] = ACTIONS(3859),
    [anon_sym_default] = ACTIONS(3859),
    [anon_sym_throw] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_when] = ACTIONS(3859),
    [anon_sym_await] = ACTIONS(3859),
    [anon_sym_foreach] = ACTIONS(3859),
    [anon_sym_goto] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_from] = ACTIONS(3859),
    [anon_sym_into] = ACTIONS(3859),
    [anon_sym_join] = ACTIONS(3859),
    [anon_sym_on] = ACTIONS(3859),
    [anon_sym_equals] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_orderby] = ACTIONS(3859),
    [anon_sym_ascending] = ACTIONS(3859),
    [anon_sym_descending] = ACTIONS(3859),
    [anon_sym_group] = ACTIONS(3859),
    [anon_sym_by] = ACTIONS(3859),
    [anon_sym_select] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3861),
    [anon_sym_stackalloc] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym_typeof] = ACTIONS(3859),
    [anon_sym___makeref] = ACTIONS(3859),
    [anon_sym___reftype] = ACTIONS(3859),
    [anon_sym___refvalue] = ACTIONS(3859),
    [sym_null_literal] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3861),
    [sym_integer_literal] = ACTIONS(3859),
    [sym_real_literal] = ACTIONS(3861),
    [sym_verbatim_string_literal] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token3] = ACTIONS(3861),
    [aux_sym_preproc_else_token1] = ACTIONS(3861),
    [aux_sym_preproc_elif_token1] = ACTIONS(3861),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3861),
    [sym_interpolation_verbatim_start] = ACTIONS(3861),
    [sym_interpolation_raw_start] = ACTIONS(3861),
    [sym_raw_string_start] = ACTIONS(3861),
  },
  [2423] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_region] = STATE(2423),
    [sym_preproc_endregion] = STATE(2423),
    [sym_preproc_line] = STATE(2423),
    [sym_preproc_pragma] = STATE(2423),
    [sym_preproc_nullable] = STATE(2423),
    [sym_preproc_error] = STATE(2423),
    [sym_preproc_define] = STATE(2423),
    [sym_preproc_undef] = STATE(2423),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3863),
    [anon_sym_extern] = ACTIONS(3866),
    [anon_sym_alias] = ACTIONS(3869),
    [anon_sym_global] = ACTIONS(3872),
    [anon_sym_using] = ACTIONS(3875),
    [anon_sym_unsafe] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [anon_sym_LPAREN] = ACTIONS(3884),
    [anon_sym_event] = ACTIONS(3887),
    [anon_sym_namespace] = ACTIONS(3890),
    [anon_sym_class] = ACTIONS(3893),
    [anon_sym_ref] = ACTIONS(3896),
    [anon_sym_struct] = ACTIONS(3899),
    [anon_sym_enum] = ACTIONS(3902),
    [anon_sym_RBRACE] = ACTIONS(3905),
    [anon_sym_interface] = ACTIONS(3907),
    [anon_sym_delegate] = ACTIONS(3910),
    [anon_sym_record] = ACTIONS(3913),
    [anon_sym_abstract] = ACTIONS(3878),
    [anon_sym_async] = ACTIONS(3878),
    [anon_sym_const] = ACTIONS(3878),
    [anon_sym_file] = ACTIONS(3916),
    [anon_sym_fixed] = ACTIONS(3878),
    [anon_sym_internal] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_override] = ACTIONS(3878),
    [anon_sym_partial] = ACTIONS(3878),
    [anon_sym_private] = ACTIONS(3878),
    [anon_sym_protected] = ACTIONS(3878),
    [anon_sym_public] = ACTIONS(3878),
    [anon_sym_readonly] = ACTIONS(3878),
    [anon_sym_required] = ACTIONS(3878),
    [anon_sym_sealed] = ACTIONS(3878),
    [anon_sym_virtual] = ACTIONS(3878),
    [anon_sym_volatile] = ACTIONS(3878),
    [anon_sym_where] = ACTIONS(3869),
    [anon_sym_notnull] = ACTIONS(3869),
    [anon_sym_unmanaged] = ACTIONS(3869),
    [anon_sym_TILDE] = ACTIONS(3919),
    [anon_sym_implicit] = ACTIONS(3922),
    [anon_sym_explicit] = ACTIONS(3922),
    [anon_sym_scoped] = ACTIONS(3925),
    [anon_sym_var] = ACTIONS(3928),
    [sym_predefined_type] = ACTIONS(3931),
    [anon_sym_yield] = ACTIONS(3869),
    [anon_sym_when] = ACTIONS(3869),
    [anon_sym_from] = ACTIONS(3869),
    [anon_sym_into] = ACTIONS(3869),
    [anon_sym_join] = ACTIONS(3869),
    [anon_sym_on] = ACTIONS(3869),
    [anon_sym_equals] = ACTIONS(3869),
    [anon_sym_let] = ACTIONS(3869),
    [anon_sym_orderby] = ACTIONS(3869),
    [anon_sym_ascending] = ACTIONS(3869),
    [anon_sym_descending] = ACTIONS(3869),
    [anon_sym_group] = ACTIONS(3869),
    [anon_sym_by] = ACTIONS(3869),
    [anon_sym_select] = ACTIONS(3869),
    [aux_sym_preproc_if_token1] = ACTIONS(3934),
    [aux_sym_preproc_if_token3] = ACTIONS(3905),
    [aux_sym_preproc_else_token1] = ACTIONS(3905),
    [aux_sym_preproc_elif_token1] = ACTIONS(3905),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2424] = {
    [sym_preproc_region] = STATE(2424),
    [sym_preproc_endregion] = STATE(2424),
    [sym_preproc_line] = STATE(2424),
    [sym_preproc_pragma] = STATE(2424),
    [sym_preproc_nullable] = STATE(2424),
    [sym_preproc_error] = STATE(2424),
    [sym_preproc_define] = STATE(2424),
    [sym_preproc_undef] = STATE(2424),
    [sym__identifier_token] = ACTIONS(3937),
    [anon_sym_extern] = ACTIONS(3937),
    [anon_sym_alias] = ACTIONS(3937),
    [anon_sym_SEMI] = ACTIONS(3939),
    [anon_sym_global] = ACTIONS(3937),
    [anon_sym_using] = ACTIONS(3937),
    [anon_sym_unsafe] = ACTIONS(3937),
    [anon_sym_static] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_namespace] = ACTIONS(3937),
    [anon_sym_class] = ACTIONS(3937),
    [anon_sym_ref] = ACTIONS(3937),
    [anon_sym_struct] = ACTIONS(3937),
    [anon_sym_enum] = ACTIONS(3937),
    [anon_sym_LBRACE] = ACTIONS(3939),
    [anon_sym_interface] = ACTIONS(3937),
    [anon_sym_delegate] = ACTIONS(3937),
    [anon_sym_record] = ACTIONS(3937),
    [anon_sym_abstract] = ACTIONS(3937),
    [anon_sym_async] = ACTIONS(3937),
    [anon_sym_const] = ACTIONS(3937),
    [anon_sym_file] = ACTIONS(3937),
    [anon_sym_fixed] = ACTIONS(3937),
    [anon_sym_internal] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_override] = ACTIONS(3937),
    [anon_sym_partial] = ACTIONS(3937),
    [anon_sym_private] = ACTIONS(3937),
    [anon_sym_protected] = ACTIONS(3937),
    [anon_sym_public] = ACTIONS(3937),
    [anon_sym_readonly] = ACTIONS(3937),
    [anon_sym_required] = ACTIONS(3937),
    [anon_sym_sealed] = ACTIONS(3937),
    [anon_sym_virtual] = ACTIONS(3937),
    [anon_sym_volatile] = ACTIONS(3937),
    [anon_sym_where] = ACTIONS(3937),
    [anon_sym_notnull] = ACTIONS(3937),
    [anon_sym_unmanaged] = ACTIONS(3937),
    [anon_sym_checked] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3939),
    [anon_sym_TILDE] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3939),
    [anon_sym_true] = ACTIONS(3937),
    [anon_sym_false] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_this] = ACTIONS(3937),
    [anon_sym_scoped] = ACTIONS(3937),
    [anon_sym_base] = ACTIONS(3937),
    [anon_sym_var] = ACTIONS(3937),
    [sym_predefined_type] = ACTIONS(3937),
    [anon_sym_break] = ACTIONS(3937),
    [anon_sym_unchecked] = ACTIONS(3937),
    [anon_sym_continue] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_lock] = ACTIONS(3937),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_switch] = ACTIONS(3937),
    [anon_sym_default] = ACTIONS(3937),
    [anon_sym_throw] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_when] = ACTIONS(3937),
    [anon_sym_await] = ACTIONS(3937),
    [anon_sym_foreach] = ACTIONS(3937),
    [anon_sym_goto] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_from] = ACTIONS(3937),
    [anon_sym_into] = ACTIONS(3937),
    [anon_sym_join] = ACTIONS(3937),
    [anon_sym_on] = ACTIONS(3937),
    [anon_sym_equals] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_orderby] = ACTIONS(3937),
    [anon_sym_ascending] = ACTIONS(3937),
    [anon_sym_descending] = ACTIONS(3937),
    [anon_sym_group] = ACTIONS(3937),
    [anon_sym_by] = ACTIONS(3937),
    [anon_sym_select] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_stackalloc] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3937),
    [anon_sym_typeof] = ACTIONS(3937),
    [anon_sym___makeref] = ACTIONS(3937),
    [anon_sym___reftype] = ACTIONS(3937),
    [anon_sym___refvalue] = ACTIONS(3937),
    [sym_null_literal] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3939),
    [sym_integer_literal] = ACTIONS(3937),
    [sym_real_literal] = ACTIONS(3939),
    [sym_verbatim_string_literal] = ACTIONS(3939),
    [aux_sym_preproc_if_token1] = ACTIONS(3939),
    [aux_sym_preproc_if_token3] = ACTIONS(3939),
    [aux_sym_preproc_else_token1] = ACTIONS(3939),
    [aux_sym_preproc_elif_token1] = ACTIONS(3939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3939),
    [sym_interpolation_verbatim_start] = ACTIONS(3939),
    [sym_interpolation_raw_start] = ACTIONS(3939),
    [sym_raw_string_start] = ACTIONS(3939),
  },
  [2425] = {
    [sym_preproc_region] = STATE(2425),
    [sym_preproc_endregion] = STATE(2425),
    [sym_preproc_line] = STATE(2425),
    [sym_preproc_pragma] = STATE(2425),
    [sym_preproc_nullable] = STATE(2425),
    [sym_preproc_error] = STATE(2425),
    [sym_preproc_define] = STATE(2425),
    [sym_preproc_undef] = STATE(2425),
    [sym__identifier_token] = ACTIONS(3941),
    [anon_sym_extern] = ACTIONS(3941),
    [anon_sym_alias] = ACTIONS(3941),
    [anon_sym_SEMI] = ACTIONS(3943),
    [anon_sym_global] = ACTIONS(3941),
    [anon_sym_using] = ACTIONS(3941),
    [anon_sym_unsafe] = ACTIONS(3941),
    [anon_sym_static] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_namespace] = ACTIONS(3941),
    [anon_sym_class] = ACTIONS(3941),
    [anon_sym_ref] = ACTIONS(3941),
    [anon_sym_struct] = ACTIONS(3941),
    [anon_sym_enum] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3943),
    [anon_sym_interface] = ACTIONS(3941),
    [anon_sym_delegate] = ACTIONS(3941),
    [anon_sym_record] = ACTIONS(3941),
    [anon_sym_abstract] = ACTIONS(3941),
    [anon_sym_async] = ACTIONS(3941),
    [anon_sym_const] = ACTIONS(3941),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(3941),
    [anon_sym_internal] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_override] = ACTIONS(3941),
    [anon_sym_partial] = ACTIONS(3941),
    [anon_sym_private] = ACTIONS(3941),
    [anon_sym_protected] = ACTIONS(3941),
    [anon_sym_public] = ACTIONS(3941),
    [anon_sym_readonly] = ACTIONS(3941),
    [anon_sym_required] = ACTIONS(3941),
    [anon_sym_sealed] = ACTIONS(3941),
    [anon_sym_virtual] = ACTIONS(3941),
    [anon_sym_volatile] = ACTIONS(3941),
    [anon_sym_where] = ACTIONS(3941),
    [anon_sym_notnull] = ACTIONS(3941),
    [anon_sym_unmanaged] = ACTIONS(3941),
    [anon_sym_checked] = ACTIONS(3941),
    [anon_sym_BANG] = ACTIONS(3943),
    [anon_sym_TILDE] = ACTIONS(3943),
    [anon_sym_PLUS_PLUS] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3943),
    [anon_sym_true] = ACTIONS(3941),
    [anon_sym_false] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_STAR] = ACTIONS(3943),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_this] = ACTIONS(3941),
    [anon_sym_scoped] = ACTIONS(3941),
    [anon_sym_base] = ACTIONS(3941),
    [anon_sym_var] = ACTIONS(3941),
    [sym_predefined_type] = ACTIONS(3941),
    [anon_sym_break] = ACTIONS(3941),
    [anon_sym_unchecked] = ACTIONS(3941),
    [anon_sym_continue] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_lock] = ACTIONS(3941),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_switch] = ACTIONS(3941),
    [anon_sym_default] = ACTIONS(3941),
    [anon_sym_throw] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_when] = ACTIONS(3941),
    [anon_sym_await] = ACTIONS(3941),
    [anon_sym_foreach] = ACTIONS(3941),
    [anon_sym_goto] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_from] = ACTIONS(3941),
    [anon_sym_into] = ACTIONS(3941),
    [anon_sym_join] = ACTIONS(3941),
    [anon_sym_on] = ACTIONS(3941),
    [anon_sym_equals] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_orderby] = ACTIONS(3941),
    [anon_sym_ascending] = ACTIONS(3941),
    [anon_sym_descending] = ACTIONS(3941),
    [anon_sym_group] = ACTIONS(3941),
    [anon_sym_by] = ACTIONS(3941),
    [anon_sym_select] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3943),
    [anon_sym_stackalloc] = ACTIONS(3941),
    [anon_sym_sizeof] = ACTIONS(3941),
    [anon_sym_typeof] = ACTIONS(3941),
    [anon_sym___makeref] = ACTIONS(3941),
    [anon_sym___reftype] = ACTIONS(3941),
    [anon_sym___refvalue] = ACTIONS(3941),
    [sym_null_literal] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3943),
    [sym_integer_literal] = ACTIONS(3941),
    [sym_real_literal] = ACTIONS(3943),
    [sym_verbatim_string_literal] = ACTIONS(3943),
    [aux_sym_preproc_if_token1] = ACTIONS(3943),
    [aux_sym_preproc_if_token3] = ACTIONS(3943),
    [aux_sym_preproc_else_token1] = ACTIONS(3943),
    [aux_sym_preproc_elif_token1] = ACTIONS(3943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3943),
    [sym_interpolation_verbatim_start] = ACTIONS(3943),
    [sym_interpolation_raw_start] = ACTIONS(3943),
    [sym_raw_string_start] = ACTIONS(3943),
  },
  [2426] = {
    [sym_preproc_region] = STATE(2426),
    [sym_preproc_endregion] = STATE(2426),
    [sym_preproc_line] = STATE(2426),
    [sym_preproc_pragma] = STATE(2426),
    [sym_preproc_nullable] = STATE(2426),
    [sym_preproc_error] = STATE(2426),
    [sym_preproc_define] = STATE(2426),
    [sym_preproc_undef] = STATE(2426),
    [sym__identifier_token] = ACTIONS(3945),
    [anon_sym_extern] = ACTIONS(3945),
    [anon_sym_alias] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3947),
    [anon_sym_global] = ACTIONS(3945),
    [anon_sym_using] = ACTIONS(3945),
    [anon_sym_unsafe] = ACTIONS(3945),
    [anon_sym_static] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3947),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_namespace] = ACTIONS(3945),
    [anon_sym_class] = ACTIONS(3945),
    [anon_sym_ref] = ACTIONS(3945),
    [anon_sym_struct] = ACTIONS(3945),
    [anon_sym_enum] = ACTIONS(3945),
    [anon_sym_LBRACE] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(3945),
    [anon_sym_delegate] = ACTIONS(3945),
    [anon_sym_record] = ACTIONS(3945),
    [anon_sym_abstract] = ACTIONS(3945),
    [anon_sym_async] = ACTIONS(3945),
    [anon_sym_const] = ACTIONS(3945),
    [anon_sym_file] = ACTIONS(3945),
    [anon_sym_fixed] = ACTIONS(3945),
    [anon_sym_internal] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_override] = ACTIONS(3945),
    [anon_sym_partial] = ACTIONS(3945),
    [anon_sym_private] = ACTIONS(3945),
    [anon_sym_protected] = ACTIONS(3945),
    [anon_sym_public] = ACTIONS(3945),
    [anon_sym_readonly] = ACTIONS(3945),
    [anon_sym_required] = ACTIONS(3945),
    [anon_sym_sealed] = ACTIONS(3945),
    [anon_sym_virtual] = ACTIONS(3945),
    [anon_sym_volatile] = ACTIONS(3945),
    [anon_sym_where] = ACTIONS(3945),
    [anon_sym_notnull] = ACTIONS(3945),
    [anon_sym_unmanaged] = ACTIONS(3945),
    [anon_sym_checked] = ACTIONS(3945),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_TILDE] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3947),
    [anon_sym_DASH_DASH] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(3945),
    [anon_sym_false] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_this] = ACTIONS(3945),
    [anon_sym_scoped] = ACTIONS(3945),
    [anon_sym_base] = ACTIONS(3945),
    [anon_sym_var] = ACTIONS(3945),
    [sym_predefined_type] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3945),
    [anon_sym_unchecked] = ACTIONS(3945),
    [anon_sym_continue] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_lock] = ACTIONS(3945),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_switch] = ACTIONS(3945),
    [anon_sym_default] = ACTIONS(3945),
    [anon_sym_throw] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_when] = ACTIONS(3945),
    [anon_sym_await] = ACTIONS(3945),
    [anon_sym_foreach] = ACTIONS(3945),
    [anon_sym_goto] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_from] = ACTIONS(3945),
    [anon_sym_into] = ACTIONS(3945),
    [anon_sym_join] = ACTIONS(3945),
    [anon_sym_on] = ACTIONS(3945),
    [anon_sym_equals] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_orderby] = ACTIONS(3945),
    [anon_sym_ascending] = ACTIONS(3945),
    [anon_sym_descending] = ACTIONS(3945),
    [anon_sym_group] = ACTIONS(3945),
    [anon_sym_by] = ACTIONS(3945),
    [anon_sym_select] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3947),
    [anon_sym_stackalloc] = ACTIONS(3945),
    [anon_sym_sizeof] = ACTIONS(3945),
    [anon_sym_typeof] = ACTIONS(3945),
    [anon_sym___makeref] = ACTIONS(3945),
    [anon_sym___reftype] = ACTIONS(3945),
    [anon_sym___refvalue] = ACTIONS(3945),
    [sym_null_literal] = ACTIONS(3945),
    [anon_sym_SQUOTE] = ACTIONS(3947),
    [sym_integer_literal] = ACTIONS(3945),
    [sym_real_literal] = ACTIONS(3947),
    [sym_verbatim_string_literal] = ACTIONS(3947),
    [aux_sym_preproc_if_token1] = ACTIONS(3947),
    [aux_sym_preproc_if_token3] = ACTIONS(3947),
    [aux_sym_preproc_else_token1] = ACTIONS(3947),
    [aux_sym_preproc_elif_token1] = ACTIONS(3947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3947),
    [sym_interpolation_verbatim_start] = ACTIONS(3947),
    [sym_interpolation_raw_start] = ACTIONS(3947),
    [sym_raw_string_start] = ACTIONS(3947),
  },
  [2427] = {
    [sym_preproc_region] = STATE(2427),
    [sym_preproc_endregion] = STATE(2427),
    [sym_preproc_line] = STATE(2427),
    [sym_preproc_pragma] = STATE(2427),
    [sym_preproc_nullable] = STATE(2427),
    [sym_preproc_error] = STATE(2427),
    [sym_preproc_define] = STATE(2427),
    [sym_preproc_undef] = STATE(2427),
    [sym__identifier_token] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym_alias] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym_global] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_unsafe] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_ref] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_delegate] = ACTIONS(3949),
    [anon_sym_record] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3949),
    [anon_sym_async] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3949),
    [anon_sym_fixed] = ACTIONS(3949),
    [anon_sym_internal] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_override] = ACTIONS(3949),
    [anon_sym_partial] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_readonly] = ACTIONS(3949),
    [anon_sym_required] = ACTIONS(3949),
    [anon_sym_sealed] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_where] = ACTIONS(3949),
    [anon_sym_notnull] = ACTIONS(3949),
    [anon_sym_unmanaged] = ACTIONS(3949),
    [anon_sym_checked] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_true] = ACTIONS(3949),
    [anon_sym_false] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_CARET] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_this] = ACTIONS(3949),
    [anon_sym_scoped] = ACTIONS(3949),
    [anon_sym_base] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3949),
    [sym_predefined_type] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_unchecked] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_lock] = ACTIONS(3949),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_when] = ACTIONS(3949),
    [anon_sym_await] = ACTIONS(3949),
    [anon_sym_foreach] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_from] = ACTIONS(3949),
    [anon_sym_into] = ACTIONS(3949),
    [anon_sym_join] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_orderby] = ACTIONS(3949),
    [anon_sym_ascending] = ACTIONS(3949),
    [anon_sym_descending] = ACTIONS(3949),
    [anon_sym_group] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_select] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [anon_sym_stackalloc] = ACTIONS(3949),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym_typeof] = ACTIONS(3949),
    [anon_sym___makeref] = ACTIONS(3949),
    [anon_sym___reftype] = ACTIONS(3949),
    [anon_sym___refvalue] = ACTIONS(3949),
    [sym_null_literal] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [sym_integer_literal] = ACTIONS(3949),
    [sym_real_literal] = ACTIONS(3951),
    [sym_verbatim_string_literal] = ACTIONS(3951),
    [aux_sym_preproc_if_token1] = ACTIONS(3951),
    [aux_sym_preproc_if_token3] = ACTIONS(3951),
    [aux_sym_preproc_else_token1] = ACTIONS(3951),
    [aux_sym_preproc_elif_token1] = ACTIONS(3951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3951),
    [sym_interpolation_verbatim_start] = ACTIONS(3951),
    [sym_interpolation_raw_start] = ACTIONS(3951),
    [sym_raw_string_start] = ACTIONS(3951),
  },
  [2428] = {
    [sym_preproc_region] = STATE(2428),
    [sym_preproc_endregion] = STATE(2428),
    [sym_preproc_line] = STATE(2428),
    [sym_preproc_pragma] = STATE(2428),
    [sym_preproc_nullable] = STATE(2428),
    [sym_preproc_error] = STATE(2428),
    [sym_preproc_define] = STATE(2428),
    [sym_preproc_undef] = STATE(2428),
    [sym__identifier_token] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym_alias] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym_global] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_unsafe] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3955),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_ref] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_delegate] = ACTIONS(3953),
    [anon_sym_record] = ACTIONS(3953),
    [anon_sym_abstract] = ACTIONS(3953),
    [anon_sym_async] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_file] = ACTIONS(3953),
    [anon_sym_fixed] = ACTIONS(3953),
    [anon_sym_internal] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_override] = ACTIONS(3953),
    [anon_sym_partial] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3953),
    [anon_sym_required] = ACTIONS(3953),
    [anon_sym_sealed] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_where] = ACTIONS(3953),
    [anon_sym_notnull] = ACTIONS(3953),
    [anon_sym_unmanaged] = ACTIONS(3953),
    [anon_sym_checked] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_true] = ACTIONS(3953),
    [anon_sym_false] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3955),
    [anon_sym_this] = ACTIONS(3953),
    [anon_sym_scoped] = ACTIONS(3953),
    [anon_sym_base] = ACTIONS(3953),
    [anon_sym_var] = ACTIONS(3953),
    [sym_predefined_type] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_unchecked] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_lock] = ACTIONS(3953),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_when] = ACTIONS(3953),
    [anon_sym_await] = ACTIONS(3953),
    [anon_sym_foreach] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_from] = ACTIONS(3953),
    [anon_sym_into] = ACTIONS(3953),
    [anon_sym_join] = ACTIONS(3953),
    [anon_sym_on] = ACTIONS(3953),
    [anon_sym_equals] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_orderby] = ACTIONS(3953),
    [anon_sym_ascending] = ACTIONS(3953),
    [anon_sym_descending] = ACTIONS(3953),
    [anon_sym_group] = ACTIONS(3953),
    [anon_sym_by] = ACTIONS(3953),
    [anon_sym_select] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [anon_sym_stackalloc] = ACTIONS(3953),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3953),
    [anon_sym___makeref] = ACTIONS(3953),
    [anon_sym___reftype] = ACTIONS(3953),
    [anon_sym___refvalue] = ACTIONS(3953),
    [sym_null_literal] = ACTIONS(3953),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [sym_integer_literal] = ACTIONS(3953),
    [sym_real_literal] = ACTIONS(3955),
    [sym_verbatim_string_literal] = ACTIONS(3955),
    [aux_sym_preproc_if_token1] = ACTIONS(3955),
    [aux_sym_preproc_if_token3] = ACTIONS(3955),
    [aux_sym_preproc_else_token1] = ACTIONS(3955),
    [aux_sym_preproc_elif_token1] = ACTIONS(3955),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3955),
    [sym_interpolation_verbatim_start] = ACTIONS(3955),
    [sym_interpolation_raw_start] = ACTIONS(3955),
    [sym_raw_string_start] = ACTIONS(3955),
  },
  [2429] = {
    [sym_preproc_region] = STATE(2429),
    [sym_preproc_endregion] = STATE(2429),
    [sym_preproc_line] = STATE(2429),
    [sym_preproc_pragma] = STATE(2429),
    [sym_preproc_nullable] = STATE(2429),
    [sym_preproc_error] = STATE(2429),
    [sym_preproc_define] = STATE(2429),
    [sym_preproc_undef] = STATE(2429),
    [sym__identifier_token] = ACTIONS(3957),
    [anon_sym_extern] = ACTIONS(3957),
    [anon_sym_alias] = ACTIONS(3957),
    [anon_sym_SEMI] = ACTIONS(3959),
    [anon_sym_global] = ACTIONS(3957),
    [anon_sym_using] = ACTIONS(3957),
    [anon_sym_unsafe] = ACTIONS(3957),
    [anon_sym_static] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3959),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_namespace] = ACTIONS(3957),
    [anon_sym_class] = ACTIONS(3957),
    [anon_sym_ref] = ACTIONS(3957),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_enum] = ACTIONS(3957),
    [anon_sym_LBRACE] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3957),
    [anon_sym_delegate] = ACTIONS(3957),
    [anon_sym_record] = ACTIONS(3957),
    [anon_sym_abstract] = ACTIONS(3957),
    [anon_sym_async] = ACTIONS(3957),
    [anon_sym_const] = ACTIONS(3957),
    [anon_sym_file] = ACTIONS(3957),
    [anon_sym_fixed] = ACTIONS(3957),
    [anon_sym_internal] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_override] = ACTIONS(3957),
    [anon_sym_partial] = ACTIONS(3957),
    [anon_sym_private] = ACTIONS(3957),
    [anon_sym_protected] = ACTIONS(3957),
    [anon_sym_public] = ACTIONS(3957),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_required] = ACTIONS(3957),
    [anon_sym_sealed] = ACTIONS(3957),
    [anon_sym_virtual] = ACTIONS(3957),
    [anon_sym_volatile] = ACTIONS(3957),
    [anon_sym_where] = ACTIONS(3957),
    [anon_sym_notnull] = ACTIONS(3957),
    [anon_sym_unmanaged] = ACTIONS(3957),
    [anon_sym_checked] = ACTIONS(3957),
    [anon_sym_BANG] = ACTIONS(3959),
    [anon_sym_TILDE] = ACTIONS(3959),
    [anon_sym_PLUS_PLUS] = ACTIONS(3959),
    [anon_sym_DASH_DASH] = ACTIONS(3959),
    [anon_sym_true] = ACTIONS(3957),
    [anon_sym_false] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_this] = ACTIONS(3957),
    [anon_sym_scoped] = ACTIONS(3957),
    [anon_sym_base] = ACTIONS(3957),
    [anon_sym_var] = ACTIONS(3957),
    [sym_predefined_type] = ACTIONS(3957),
    [anon_sym_break] = ACTIONS(3957),
    [anon_sym_unchecked] = ACTIONS(3957),
    [anon_sym_continue] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_lock] = ACTIONS(3957),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_switch] = ACTIONS(3957),
    [anon_sym_default] = ACTIONS(3957),
    [anon_sym_throw] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_when] = ACTIONS(3957),
    [anon_sym_await] = ACTIONS(3957),
    [anon_sym_foreach] = ACTIONS(3957),
    [anon_sym_goto] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_from] = ACTIONS(3957),
    [anon_sym_into] = ACTIONS(3957),
    [anon_sym_join] = ACTIONS(3957),
    [anon_sym_on] = ACTIONS(3957),
    [anon_sym_equals] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_orderby] = ACTIONS(3957),
    [anon_sym_ascending] = ACTIONS(3957),
    [anon_sym_descending] = ACTIONS(3957),
    [anon_sym_group] = ACTIONS(3957),
    [anon_sym_by] = ACTIONS(3957),
    [anon_sym_select] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3959),
    [anon_sym_stackalloc] = ACTIONS(3957),
    [anon_sym_sizeof] = ACTIONS(3957),
    [anon_sym_typeof] = ACTIONS(3957),
    [anon_sym___makeref] = ACTIONS(3957),
    [anon_sym___reftype] = ACTIONS(3957),
    [anon_sym___refvalue] = ACTIONS(3957),
    [sym_null_literal] = ACTIONS(3957),
    [anon_sym_SQUOTE] = ACTIONS(3959),
    [sym_integer_literal] = ACTIONS(3957),
    [sym_real_literal] = ACTIONS(3959),
    [sym_verbatim_string_literal] = ACTIONS(3959),
    [aux_sym_preproc_if_token1] = ACTIONS(3959),
    [aux_sym_preproc_if_token3] = ACTIONS(3959),
    [aux_sym_preproc_else_token1] = ACTIONS(3959),
    [aux_sym_preproc_elif_token1] = ACTIONS(3959),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3959),
    [sym_interpolation_verbatim_start] = ACTIONS(3959),
    [sym_interpolation_raw_start] = ACTIONS(3959),
    [sym_raw_string_start] = ACTIONS(3959),
  },
  [2430] = {
    [sym_preproc_region] = STATE(2430),
    [sym_preproc_endregion] = STATE(2430),
    [sym_preproc_line] = STATE(2430),
    [sym_preproc_pragma] = STATE(2430),
    [sym_preproc_nullable] = STATE(2430),
    [sym_preproc_error] = STATE(2430),
    [sym_preproc_define] = STATE(2430),
    [sym_preproc_undef] = STATE(2430),
    [sym__identifier_token] = ACTIONS(3961),
    [anon_sym_extern] = ACTIONS(3961),
    [anon_sym_alias] = ACTIONS(3961),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_global] = ACTIONS(3961),
    [anon_sym_using] = ACTIONS(3961),
    [anon_sym_unsafe] = ACTIONS(3961),
    [anon_sym_static] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_namespace] = ACTIONS(3961),
    [anon_sym_class] = ACTIONS(3961),
    [anon_sym_ref] = ACTIONS(3961),
    [anon_sym_struct] = ACTIONS(3961),
    [anon_sym_enum] = ACTIONS(3961),
    [anon_sym_LBRACE] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3961),
    [anon_sym_delegate] = ACTIONS(3961),
    [anon_sym_record] = ACTIONS(3961),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_async] = ACTIONS(3961),
    [anon_sym_const] = ACTIONS(3961),
    [anon_sym_file] = ACTIONS(3961),
    [anon_sym_fixed] = ACTIONS(3961),
    [anon_sym_internal] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_override] = ACTIONS(3961),
    [anon_sym_partial] = ACTIONS(3961),
    [anon_sym_private] = ACTIONS(3961),
    [anon_sym_protected] = ACTIONS(3961),
    [anon_sym_public] = ACTIONS(3961),
    [anon_sym_readonly] = ACTIONS(3961),
    [anon_sym_required] = ACTIONS(3961),
    [anon_sym_sealed] = ACTIONS(3961),
    [anon_sym_virtual] = ACTIONS(3961),
    [anon_sym_volatile] = ACTIONS(3961),
    [anon_sym_where] = ACTIONS(3961),
    [anon_sym_notnull] = ACTIONS(3961),
    [anon_sym_unmanaged] = ACTIONS(3961),
    [anon_sym_checked] = ACTIONS(3961),
    [anon_sym_BANG] = ACTIONS(3963),
    [anon_sym_TILDE] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [anon_sym_true] = ACTIONS(3961),
    [anon_sym_false] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_this] = ACTIONS(3961),
    [anon_sym_scoped] = ACTIONS(3961),
    [anon_sym_base] = ACTIONS(3961),
    [anon_sym_var] = ACTIONS(3961),
    [sym_predefined_type] = ACTIONS(3961),
    [anon_sym_break] = ACTIONS(3961),
    [anon_sym_unchecked] = ACTIONS(3961),
    [anon_sym_continue] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_lock] = ACTIONS(3961),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_switch] = ACTIONS(3961),
    [anon_sym_default] = ACTIONS(3961),
    [anon_sym_throw] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_when] = ACTIONS(3961),
    [anon_sym_await] = ACTIONS(3961),
    [anon_sym_foreach] = ACTIONS(3961),
    [anon_sym_goto] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_from] = ACTIONS(3961),
    [anon_sym_into] = ACTIONS(3961),
    [anon_sym_join] = ACTIONS(3961),
    [anon_sym_on] = ACTIONS(3961),
    [anon_sym_equals] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_orderby] = ACTIONS(3961),
    [anon_sym_ascending] = ACTIONS(3961),
    [anon_sym_descending] = ACTIONS(3961),
    [anon_sym_group] = ACTIONS(3961),
    [anon_sym_by] = ACTIONS(3961),
    [anon_sym_select] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3963),
    [anon_sym_stackalloc] = ACTIONS(3961),
    [anon_sym_sizeof] = ACTIONS(3961),
    [anon_sym_typeof] = ACTIONS(3961),
    [anon_sym___makeref] = ACTIONS(3961),
    [anon_sym___reftype] = ACTIONS(3961),
    [anon_sym___refvalue] = ACTIONS(3961),
    [sym_null_literal] = ACTIONS(3961),
    [anon_sym_SQUOTE] = ACTIONS(3963),
    [sym_integer_literal] = ACTIONS(3961),
    [sym_real_literal] = ACTIONS(3963),
    [sym_verbatim_string_literal] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token3] = ACTIONS(3963),
    [aux_sym_preproc_else_token1] = ACTIONS(3963),
    [aux_sym_preproc_elif_token1] = ACTIONS(3963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3963),
    [sym_interpolation_verbatim_start] = ACTIONS(3963),
    [sym_interpolation_raw_start] = ACTIONS(3963),
    [sym_raw_string_start] = ACTIONS(3963),
  },
  [2431] = {
    [sym_preproc_region] = STATE(2431),
    [sym_preproc_endregion] = STATE(2431),
    [sym_preproc_line] = STATE(2431),
    [sym_preproc_pragma] = STATE(2431),
    [sym_preproc_nullable] = STATE(2431),
    [sym_preproc_error] = STATE(2431),
    [sym_preproc_define] = STATE(2431),
    [sym_preproc_undef] = STATE(2431),
    [sym__identifier_token] = ACTIONS(3965),
    [anon_sym_extern] = ACTIONS(3965),
    [anon_sym_alias] = ACTIONS(3965),
    [anon_sym_SEMI] = ACTIONS(3967),
    [anon_sym_global] = ACTIONS(3965),
    [anon_sym_using] = ACTIONS(3965),
    [anon_sym_unsafe] = ACTIONS(3965),
    [anon_sym_static] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_namespace] = ACTIONS(3965),
    [anon_sym_class] = ACTIONS(3965),
    [anon_sym_ref] = ACTIONS(3965),
    [anon_sym_struct] = ACTIONS(3965),
    [anon_sym_enum] = ACTIONS(3965),
    [anon_sym_LBRACE] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3965),
    [anon_sym_delegate] = ACTIONS(3965),
    [anon_sym_record] = ACTIONS(3965),
    [anon_sym_abstract] = ACTIONS(3965),
    [anon_sym_async] = ACTIONS(3965),
    [anon_sym_const] = ACTIONS(3965),
    [anon_sym_file] = ACTIONS(3965),
    [anon_sym_fixed] = ACTIONS(3965),
    [anon_sym_internal] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_override] = ACTIONS(3965),
    [anon_sym_partial] = ACTIONS(3965),
    [anon_sym_private] = ACTIONS(3965),
    [anon_sym_protected] = ACTIONS(3965),
    [anon_sym_public] = ACTIONS(3965),
    [anon_sym_readonly] = ACTIONS(3965),
    [anon_sym_required] = ACTIONS(3965),
    [anon_sym_sealed] = ACTIONS(3965),
    [anon_sym_virtual] = ACTIONS(3965),
    [anon_sym_volatile] = ACTIONS(3965),
    [anon_sym_where] = ACTIONS(3965),
    [anon_sym_notnull] = ACTIONS(3965),
    [anon_sym_unmanaged] = ACTIONS(3965),
    [anon_sym_checked] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_TILDE] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3967),
    [anon_sym_true] = ACTIONS(3965),
    [anon_sym_false] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_this] = ACTIONS(3965),
    [anon_sym_scoped] = ACTIONS(3965),
    [anon_sym_base] = ACTIONS(3965),
    [anon_sym_var] = ACTIONS(3965),
    [sym_predefined_type] = ACTIONS(3965),
    [anon_sym_break] = ACTIONS(3965),
    [anon_sym_unchecked] = ACTIONS(3965),
    [anon_sym_continue] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_lock] = ACTIONS(3965),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_switch] = ACTIONS(3965),
    [anon_sym_default] = ACTIONS(3965),
    [anon_sym_throw] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_when] = ACTIONS(3965),
    [anon_sym_await] = ACTIONS(3965),
    [anon_sym_foreach] = ACTIONS(3965),
    [anon_sym_goto] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_from] = ACTIONS(3965),
    [anon_sym_into] = ACTIONS(3965),
    [anon_sym_join] = ACTIONS(3965),
    [anon_sym_on] = ACTIONS(3965),
    [anon_sym_equals] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_orderby] = ACTIONS(3965),
    [anon_sym_ascending] = ACTIONS(3965),
    [anon_sym_descending] = ACTIONS(3965),
    [anon_sym_group] = ACTIONS(3965),
    [anon_sym_by] = ACTIONS(3965),
    [anon_sym_select] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3967),
    [anon_sym_stackalloc] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3965),
    [anon_sym_typeof] = ACTIONS(3965),
    [anon_sym___makeref] = ACTIONS(3965),
    [anon_sym___reftype] = ACTIONS(3965),
    [anon_sym___refvalue] = ACTIONS(3965),
    [sym_null_literal] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3967),
    [sym_integer_literal] = ACTIONS(3965),
    [sym_real_literal] = ACTIONS(3967),
    [sym_verbatim_string_literal] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token3] = ACTIONS(3967),
    [aux_sym_preproc_else_token1] = ACTIONS(3967),
    [aux_sym_preproc_elif_token1] = ACTIONS(3967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3967),
    [sym_interpolation_verbatim_start] = ACTIONS(3967),
    [sym_interpolation_raw_start] = ACTIONS(3967),
    [sym_raw_string_start] = ACTIONS(3967),
  },
  [2432] = {
    [sym_preproc_region] = STATE(2432),
    [sym_preproc_endregion] = STATE(2432),
    [sym_preproc_line] = STATE(2432),
    [sym_preproc_pragma] = STATE(2432),
    [sym_preproc_nullable] = STATE(2432),
    [sym_preproc_error] = STATE(2432),
    [sym_preproc_define] = STATE(2432),
    [sym_preproc_undef] = STATE(2432),
    [sym__identifier_token] = ACTIONS(3969),
    [anon_sym_extern] = ACTIONS(3969),
    [anon_sym_alias] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3971),
    [anon_sym_global] = ACTIONS(3969),
    [anon_sym_using] = ACTIONS(3969),
    [anon_sym_unsafe] = ACTIONS(3969),
    [anon_sym_static] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_namespace] = ACTIONS(3969),
    [anon_sym_class] = ACTIONS(3969),
    [anon_sym_ref] = ACTIONS(3969),
    [anon_sym_struct] = ACTIONS(3969),
    [anon_sym_enum] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3969),
    [anon_sym_delegate] = ACTIONS(3969),
    [anon_sym_record] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_const] = ACTIONS(3969),
    [anon_sym_file] = ACTIONS(3969),
    [anon_sym_fixed] = ACTIONS(3969),
    [anon_sym_internal] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_override] = ACTIONS(3969),
    [anon_sym_partial] = ACTIONS(3969),
    [anon_sym_private] = ACTIONS(3969),
    [anon_sym_protected] = ACTIONS(3969),
    [anon_sym_public] = ACTIONS(3969),
    [anon_sym_readonly] = ACTIONS(3969),
    [anon_sym_required] = ACTIONS(3969),
    [anon_sym_sealed] = ACTIONS(3969),
    [anon_sym_virtual] = ACTIONS(3969),
    [anon_sym_volatile] = ACTIONS(3969),
    [anon_sym_where] = ACTIONS(3969),
    [anon_sym_notnull] = ACTIONS(3969),
    [anon_sym_unmanaged] = ACTIONS(3969),
    [anon_sym_checked] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_TILDE] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [anon_sym_true] = ACTIONS(3969),
    [anon_sym_false] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_this] = ACTIONS(3969),
    [anon_sym_scoped] = ACTIONS(3969),
    [anon_sym_base] = ACTIONS(3969),
    [anon_sym_var] = ACTIONS(3969),
    [sym_predefined_type] = ACTIONS(3969),
    [anon_sym_break] = ACTIONS(3969),
    [anon_sym_unchecked] = ACTIONS(3969),
    [anon_sym_continue] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_lock] = ACTIONS(3969),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_switch] = ACTIONS(3969),
    [anon_sym_default] = ACTIONS(3969),
    [anon_sym_throw] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_when] = ACTIONS(3969),
    [anon_sym_await] = ACTIONS(3969),
    [anon_sym_foreach] = ACTIONS(3969),
    [anon_sym_goto] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_from] = ACTIONS(3969),
    [anon_sym_into] = ACTIONS(3969),
    [anon_sym_join] = ACTIONS(3969),
    [anon_sym_on] = ACTIONS(3969),
    [anon_sym_equals] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_orderby] = ACTIONS(3969),
    [anon_sym_ascending] = ACTIONS(3969),
    [anon_sym_descending] = ACTIONS(3969),
    [anon_sym_group] = ACTIONS(3969),
    [anon_sym_by] = ACTIONS(3969),
    [anon_sym_select] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3971),
    [anon_sym_stackalloc] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3969),
    [anon_sym_typeof] = ACTIONS(3969),
    [anon_sym___makeref] = ACTIONS(3969),
    [anon_sym___reftype] = ACTIONS(3969),
    [anon_sym___refvalue] = ACTIONS(3969),
    [sym_null_literal] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3971),
    [sym_integer_literal] = ACTIONS(3969),
    [sym_real_literal] = ACTIONS(3971),
    [sym_verbatim_string_literal] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token3] = ACTIONS(3971),
    [aux_sym_preproc_else_token1] = ACTIONS(3971),
    [aux_sym_preproc_elif_token1] = ACTIONS(3971),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3971),
    [sym_interpolation_verbatim_start] = ACTIONS(3971),
    [sym_interpolation_raw_start] = ACTIONS(3971),
    [sym_raw_string_start] = ACTIONS(3971),
  },
  [2433] = {
    [sym_preproc_region] = STATE(2433),
    [sym_preproc_endregion] = STATE(2433),
    [sym_preproc_line] = STATE(2433),
    [sym_preproc_pragma] = STATE(2433),
    [sym_preproc_nullable] = STATE(2433),
    [sym_preproc_error] = STATE(2433),
    [sym_preproc_define] = STATE(2433),
    [sym_preproc_undef] = STATE(2433),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3973),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_using] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3973),
    [anon_sym_static] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3975),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_namespace] = ACTIONS(3973),
    [anon_sym_class] = ACTIONS(3973),
    [anon_sym_ref] = ACTIONS(3973),
    [anon_sym_struct] = ACTIONS(3973),
    [anon_sym_enum] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_interface] = ACTIONS(3973),
    [anon_sym_delegate] = ACTIONS(3973),
    [anon_sym_record] = ACTIONS(3973),
    [anon_sym_abstract] = ACTIONS(3973),
    [anon_sym_async] = ACTIONS(3973),
    [anon_sym_const] = ACTIONS(3973),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3973),
    [anon_sym_internal] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_override] = ACTIONS(3973),
    [anon_sym_partial] = ACTIONS(3973),
    [anon_sym_private] = ACTIONS(3973),
    [anon_sym_protected] = ACTIONS(3973),
    [anon_sym_public] = ACTIONS(3973),
    [anon_sym_readonly] = ACTIONS(3973),
    [anon_sym_required] = ACTIONS(3973),
    [anon_sym_sealed] = ACTIONS(3973),
    [anon_sym_virtual] = ACTIONS(3973),
    [anon_sym_volatile] = ACTIONS(3973),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_checked] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_TILDE] = ACTIONS(3975),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_true] = ACTIONS(3973),
    [anon_sym_false] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_this] = ACTIONS(3973),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_base] = ACTIONS(3973),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3973),
    [anon_sym_break] = ACTIONS(3973),
    [anon_sym_unchecked] = ACTIONS(3973),
    [anon_sym_continue] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_lock] = ACTIONS(3973),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_switch] = ACTIONS(3973),
    [anon_sym_default] = ACTIONS(3973),
    [anon_sym_throw] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_await] = ACTIONS(3973),
    [anon_sym_foreach] = ACTIONS(3973),
    [anon_sym_goto] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_stackalloc] = ACTIONS(3973),
    [anon_sym_sizeof] = ACTIONS(3973),
    [anon_sym_typeof] = ACTIONS(3973),
    [anon_sym___makeref] = ACTIONS(3973),
    [anon_sym___reftype] = ACTIONS(3973),
    [anon_sym___refvalue] = ACTIONS(3973),
    [sym_null_literal] = ACTIONS(3973),
    [anon_sym_SQUOTE] = ACTIONS(3975),
    [sym_integer_literal] = ACTIONS(3973),
    [sym_real_literal] = ACTIONS(3975),
    [sym_verbatim_string_literal] = ACTIONS(3975),
    [aux_sym_preproc_if_token1] = ACTIONS(3975),
    [aux_sym_preproc_if_token3] = ACTIONS(3975),
    [aux_sym_preproc_else_token1] = ACTIONS(3975),
    [aux_sym_preproc_elif_token1] = ACTIONS(3975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3975),
    [sym_interpolation_verbatim_start] = ACTIONS(3975),
    [sym_interpolation_raw_start] = ACTIONS(3975),
    [sym_raw_string_start] = ACTIONS(3975),
  },
  [2434] = {
    [sym_preproc_region] = STATE(2434),
    [sym_preproc_endregion] = STATE(2434),
    [sym_preproc_line] = STATE(2434),
    [sym_preproc_pragma] = STATE(2434),
    [sym_preproc_nullable] = STATE(2434),
    [sym_preproc_error] = STATE(2434),
    [sym_preproc_define] = STATE(2434),
    [sym_preproc_undef] = STATE(2434),
    [sym__identifier_token] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym_alias] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym_global] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_unsafe] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3979),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_ref] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_delegate] = ACTIONS(3977),
    [anon_sym_record] = ACTIONS(3977),
    [anon_sym_abstract] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_file] = ACTIONS(3977),
    [anon_sym_fixed] = ACTIONS(3977),
    [anon_sym_internal] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_override] = ACTIONS(3977),
    [anon_sym_partial] = ACTIONS(3977),
    [anon_sym_private] = ACTIONS(3977),
    [anon_sym_protected] = ACTIONS(3977),
    [anon_sym_public] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3977),
    [anon_sym_required] = ACTIONS(3977),
    [anon_sym_sealed] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_where] = ACTIONS(3977),
    [anon_sym_notnull] = ACTIONS(3977),
    [anon_sym_unmanaged] = ACTIONS(3977),
    [anon_sym_checked] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_true] = ACTIONS(3977),
    [anon_sym_false] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_this] = ACTIONS(3977),
    [anon_sym_scoped] = ACTIONS(3977),
    [anon_sym_base] = ACTIONS(3977),
    [anon_sym_var] = ACTIONS(3977),
    [sym_predefined_type] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_unchecked] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_lock] = ACTIONS(3977),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_when] = ACTIONS(3977),
    [anon_sym_await] = ACTIONS(3977),
    [anon_sym_foreach] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_from] = ACTIONS(3977),
    [anon_sym_into] = ACTIONS(3977),
    [anon_sym_join] = ACTIONS(3977),
    [anon_sym_on] = ACTIONS(3977),
    [anon_sym_equals] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_orderby] = ACTIONS(3977),
    [anon_sym_ascending] = ACTIONS(3977),
    [anon_sym_descending] = ACTIONS(3977),
    [anon_sym_group] = ACTIONS(3977),
    [anon_sym_by] = ACTIONS(3977),
    [anon_sym_select] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [anon_sym_stackalloc] = ACTIONS(3977),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym_typeof] = ACTIONS(3977),
    [anon_sym___makeref] = ACTIONS(3977),
    [anon_sym___reftype] = ACTIONS(3977),
    [anon_sym___refvalue] = ACTIONS(3977),
    [sym_null_literal] = ACTIONS(3977),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [sym_integer_literal] = ACTIONS(3977),
    [sym_real_literal] = ACTIONS(3979),
    [sym_verbatim_string_literal] = ACTIONS(3979),
    [aux_sym_preproc_if_token1] = ACTIONS(3979),
    [aux_sym_preproc_if_token3] = ACTIONS(3979),
    [aux_sym_preproc_else_token1] = ACTIONS(3979),
    [aux_sym_preproc_elif_token1] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3979),
    [sym_interpolation_verbatim_start] = ACTIONS(3979),
    [sym_interpolation_raw_start] = ACTIONS(3979),
    [sym_raw_string_start] = ACTIONS(3979),
  },
  [2435] = {
    [sym_preproc_region] = STATE(2435),
    [sym_preproc_endregion] = STATE(2435),
    [sym_preproc_line] = STATE(2435),
    [sym_preproc_pragma] = STATE(2435),
    [sym_preproc_nullable] = STATE(2435),
    [sym_preproc_error] = STATE(2435),
    [sym_preproc_define] = STATE(2435),
    [sym_preproc_undef] = STATE(2435),
    [sym__identifier_token] = ACTIONS(3981),
    [anon_sym_extern] = ACTIONS(3981),
    [anon_sym_alias] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3983),
    [anon_sym_global] = ACTIONS(3981),
    [anon_sym_using] = ACTIONS(3981),
    [anon_sym_unsafe] = ACTIONS(3981),
    [anon_sym_static] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3981),
    [anon_sym_namespace] = ACTIONS(3981),
    [anon_sym_class] = ACTIONS(3981),
    [anon_sym_ref] = ACTIONS(3981),
    [anon_sym_struct] = ACTIONS(3981),
    [anon_sym_enum] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3981),
    [anon_sym_delegate] = ACTIONS(3981),
    [anon_sym_record] = ACTIONS(3981),
    [anon_sym_abstract] = ACTIONS(3981),
    [anon_sym_async] = ACTIONS(3981),
    [anon_sym_const] = ACTIONS(3981),
    [anon_sym_file] = ACTIONS(3981),
    [anon_sym_fixed] = ACTIONS(3981),
    [anon_sym_internal] = ACTIONS(3981),
    [anon_sym_new] = ACTIONS(3981),
    [anon_sym_override] = ACTIONS(3981),
    [anon_sym_partial] = ACTIONS(3981),
    [anon_sym_private] = ACTIONS(3981),
    [anon_sym_protected] = ACTIONS(3981),
    [anon_sym_public] = ACTIONS(3981),
    [anon_sym_readonly] = ACTIONS(3981),
    [anon_sym_required] = ACTIONS(3981),
    [anon_sym_sealed] = ACTIONS(3981),
    [anon_sym_virtual] = ACTIONS(3981),
    [anon_sym_volatile] = ACTIONS(3981),
    [anon_sym_where] = ACTIONS(3981),
    [anon_sym_notnull] = ACTIONS(3981),
    [anon_sym_unmanaged] = ACTIONS(3981),
    [anon_sym_checked] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_TILDE] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3983),
    [anon_sym_true] = ACTIONS(3981),
    [anon_sym_false] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_CARET] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_this] = ACTIONS(3981),
    [anon_sym_scoped] = ACTIONS(3981),
    [anon_sym_base] = ACTIONS(3981),
    [anon_sym_var] = ACTIONS(3981),
    [sym_predefined_type] = ACTIONS(3981),
    [anon_sym_break] = ACTIONS(3981),
    [anon_sym_unchecked] = ACTIONS(3981),
    [anon_sym_continue] = ACTIONS(3981),
    [anon_sym_do] = ACTIONS(3981),
    [anon_sym_while] = ACTIONS(3981),
    [anon_sym_for] = ACTIONS(3981),
    [anon_sym_lock] = ACTIONS(3981),
    [anon_sym_yield] = ACTIONS(3981),
    [anon_sym_switch] = ACTIONS(3981),
    [anon_sym_default] = ACTIONS(3981),
    [anon_sym_throw] = ACTIONS(3981),
    [anon_sym_try] = ACTIONS(3981),
    [anon_sym_when] = ACTIONS(3981),
    [anon_sym_await] = ACTIONS(3981),
    [anon_sym_foreach] = ACTIONS(3981),
    [anon_sym_goto] = ACTIONS(3981),
    [anon_sym_if] = ACTIONS(3981),
    [anon_sym_DOT_DOT] = ACTIONS(3983),
    [anon_sym_from] = ACTIONS(3981),
    [anon_sym_into] = ACTIONS(3981),
    [anon_sym_join] = ACTIONS(3981),
    [anon_sym_on] = ACTIONS(3981),
    [anon_sym_equals] = ACTIONS(3981),
    [anon_sym_let] = ACTIONS(3981),
    [anon_sym_orderby] = ACTIONS(3981),
    [anon_sym_ascending] = ACTIONS(3981),
    [anon_sym_descending] = ACTIONS(3981),
    [anon_sym_group] = ACTIONS(3981),
    [anon_sym_by] = ACTIONS(3981),
    [anon_sym_select] = ACTIONS(3981),
    [anon_sym_DQUOTE] = ACTIONS(3983),
    [anon_sym_stackalloc] = ACTIONS(3981),
    [anon_sym_sizeof] = ACTIONS(3981),
    [anon_sym_typeof] = ACTIONS(3981),
    [anon_sym___makeref] = ACTIONS(3981),
    [anon_sym___reftype] = ACTIONS(3981),
    [anon_sym___refvalue] = ACTIONS(3981),
    [sym_null_literal] = ACTIONS(3981),
    [anon_sym_SQUOTE] = ACTIONS(3983),
    [sym_integer_literal] = ACTIONS(3981),
    [sym_real_literal] = ACTIONS(3983),
    [sym_verbatim_string_literal] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token3] = ACTIONS(3983),
    [aux_sym_preproc_else_token1] = ACTIONS(3983),
    [aux_sym_preproc_elif_token1] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3983),
    [sym_interpolation_verbatim_start] = ACTIONS(3983),
    [sym_interpolation_raw_start] = ACTIONS(3983),
    [sym_raw_string_start] = ACTIONS(3983),
  },
  [2436] = {
    [sym_preproc_region] = STATE(2436),
    [sym_preproc_endregion] = STATE(2436),
    [sym_preproc_line] = STATE(2436),
    [sym_preproc_pragma] = STATE(2436),
    [sym_preproc_nullable] = STATE(2436),
    [sym_preproc_error] = STATE(2436),
    [sym_preproc_define] = STATE(2436),
    [sym_preproc_undef] = STATE(2436),
    [ts_builtin_sym_end] = ACTIONS(3073),
    [sym__identifier_token] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym_alias] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_unsafe] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_ref] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_interface] = ACTIONS(3071),
    [anon_sym_delegate] = ACTIONS(3071),
    [anon_sym_record] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_file] = ACTIONS(3071),
    [anon_sym_fixed] = ACTIONS(3071),
    [anon_sym_internal] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_override] = ACTIONS(3071),
    [anon_sym_partial] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_readonly] = ACTIONS(3071),
    [anon_sym_required] = ACTIONS(3071),
    [anon_sym_sealed] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_notnull] = ACTIONS(3071),
    [anon_sym_unmanaged] = ACTIONS(3071),
    [anon_sym_checked] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_this] = ACTIONS(3071),
    [anon_sym_scoped] = ACTIONS(3071),
    [anon_sym_base] = ACTIONS(3071),
    [anon_sym_var] = ACTIONS(3071),
    [sym_predefined_type] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_unchecked] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_lock] = ACTIONS(3071),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_when] = ACTIONS(3071),
    [anon_sym_await] = ACTIONS(3071),
    [anon_sym_foreach] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_from] = ACTIONS(3071),
    [anon_sym_into] = ACTIONS(3071),
    [anon_sym_join] = ACTIONS(3071),
    [anon_sym_on] = ACTIONS(3071),
    [anon_sym_equals] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_orderby] = ACTIONS(3071),
    [anon_sym_ascending] = ACTIONS(3071),
    [anon_sym_descending] = ACTIONS(3071),
    [anon_sym_group] = ACTIONS(3071),
    [anon_sym_by] = ACTIONS(3071),
    [anon_sym_select] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3071),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym_typeof] = ACTIONS(3071),
    [anon_sym___makeref] = ACTIONS(3071),
    [anon_sym___reftype] = ACTIONS(3071),
    [anon_sym___refvalue] = ACTIONS(3071),
    [sym_null_literal] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [sym_integer_literal] = ACTIONS(3071),
    [sym_real_literal] = ACTIONS(3073),
    [sym_verbatim_string_literal] = ACTIONS(3073),
    [aux_sym_preproc_if_token1] = ACTIONS(3073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3073),
    [sym_interpolation_verbatim_start] = ACTIONS(3073),
    [sym_interpolation_raw_start] = ACTIONS(3073),
    [sym_raw_string_start] = ACTIONS(3073),
  },
  [2437] = {
    [sym_preproc_region] = STATE(2437),
    [sym_preproc_endregion] = STATE(2437),
    [sym_preproc_line] = STATE(2437),
    [sym_preproc_pragma] = STATE(2437),
    [sym_preproc_nullable] = STATE(2437),
    [sym_preproc_error] = STATE(2437),
    [sym_preproc_define] = STATE(2437),
    [sym_preproc_undef] = STATE(2437),
    [ts_builtin_sym_end] = ACTIONS(3003),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_namespace] = ACTIONS(3001),
    [anon_sym_class] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_struct] = ACTIONS(3001),
    [anon_sym_enum] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3001),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_record] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2438] = {
    [sym_preproc_region] = STATE(2438),
    [sym_preproc_endregion] = STATE(2438),
    [sym_preproc_line] = STATE(2438),
    [sym_preproc_pragma] = STATE(2438),
    [sym_preproc_nullable] = STATE(2438),
    [sym_preproc_error] = STATE(2438),
    [sym_preproc_define] = STATE(2438),
    [sym_preproc_undef] = STATE(2438),
    [ts_builtin_sym_end] = ACTIONS(3311),
    [sym__identifier_token] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym_alias] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_global] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_unsafe] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_ref] = ACTIONS(3309),
    [anon_sym_struct] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_delegate] = ACTIONS(3309),
    [anon_sym_record] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_file] = ACTIONS(3309),
    [anon_sym_fixed] = ACTIONS(3309),
    [anon_sym_internal] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_partial] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_required] = ACTIONS(3309),
    [anon_sym_sealed] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_where] = ACTIONS(3309),
    [anon_sym_notnull] = ACTIONS(3309),
    [anon_sym_unmanaged] = ACTIONS(3309),
    [anon_sym_checked] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_true] = ACTIONS(3309),
    [anon_sym_false] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_CARET] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3311),
    [anon_sym_this] = ACTIONS(3309),
    [anon_sym_scoped] = ACTIONS(3309),
    [anon_sym_base] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [sym_predefined_type] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_unchecked] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_lock] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_when] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_foreach] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_DOT_DOT] = ACTIONS(3311),
    [anon_sym_from] = ACTIONS(3309),
    [anon_sym_into] = ACTIONS(3309),
    [anon_sym_join] = ACTIONS(3309),
    [anon_sym_on] = ACTIONS(3309),
    [anon_sym_equals] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_orderby] = ACTIONS(3309),
    [anon_sym_ascending] = ACTIONS(3309),
    [anon_sym_descending] = ACTIONS(3309),
    [anon_sym_group] = ACTIONS(3309),
    [anon_sym_by] = ACTIONS(3309),
    [anon_sym_select] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3309),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym___makeref] = ACTIONS(3309),
    [anon_sym___reftype] = ACTIONS(3309),
    [anon_sym___refvalue] = ACTIONS(3309),
    [sym_null_literal] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_integer_literal] = ACTIONS(3309),
    [sym_real_literal] = ACTIONS(3311),
    [sym_verbatim_string_literal] = ACTIONS(3311),
    [aux_sym_preproc_if_token1] = ACTIONS(3311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3311),
    [sym_interpolation_verbatim_start] = ACTIONS(3311),
    [sym_interpolation_raw_start] = ACTIONS(3311),
    [sym_raw_string_start] = ACTIONS(3311),
  },
  [2439] = {
    [sym_preproc_region] = STATE(2439),
    [sym_preproc_endregion] = STATE(2439),
    [sym_preproc_line] = STATE(2439),
    [sym_preproc_pragma] = STATE(2439),
    [sym_preproc_nullable] = STATE(2439),
    [sym_preproc_error] = STATE(2439),
    [sym_preproc_define] = STATE(2439),
    [sym_preproc_undef] = STATE(2439),
    [ts_builtin_sym_end] = ACTIONS(3303),
    [sym__identifier_token] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym_alias] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_global] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_unsafe] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_namespace] = ACTIONS(3301),
    [anon_sym_class] = ACTIONS(3301),
    [anon_sym_ref] = ACTIONS(3301),
    [anon_sym_struct] = ACTIONS(3301),
    [anon_sym_enum] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_interface] = ACTIONS(3301),
    [anon_sym_delegate] = ACTIONS(3301),
    [anon_sym_record] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_file] = ACTIONS(3301),
    [anon_sym_fixed] = ACTIONS(3301),
    [anon_sym_internal] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_partial] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_required] = ACTIONS(3301),
    [anon_sym_sealed] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_where] = ACTIONS(3301),
    [anon_sym_notnull] = ACTIONS(3301),
    [anon_sym_unmanaged] = ACTIONS(3301),
    [anon_sym_checked] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_true] = ACTIONS(3301),
    [anon_sym_false] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_CARET] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_this] = ACTIONS(3301),
    [anon_sym_scoped] = ACTIONS(3301),
    [anon_sym_base] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [sym_predefined_type] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_unchecked] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_lock] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_when] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_foreach] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_DOT_DOT] = ACTIONS(3303),
    [anon_sym_from] = ACTIONS(3301),
    [anon_sym_into] = ACTIONS(3301),
    [anon_sym_join] = ACTIONS(3301),
    [anon_sym_on] = ACTIONS(3301),
    [anon_sym_equals] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_orderby] = ACTIONS(3301),
    [anon_sym_ascending] = ACTIONS(3301),
    [anon_sym_descending] = ACTIONS(3301),
    [anon_sym_group] = ACTIONS(3301),
    [anon_sym_by] = ACTIONS(3301),
    [anon_sym_select] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3301),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym___makeref] = ACTIONS(3301),
    [anon_sym___reftype] = ACTIONS(3301),
    [anon_sym___refvalue] = ACTIONS(3301),
    [sym_null_literal] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [sym_integer_literal] = ACTIONS(3301),
    [sym_real_literal] = ACTIONS(3303),
    [sym_verbatim_string_literal] = ACTIONS(3303),
    [aux_sym_preproc_if_token1] = ACTIONS(3303),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3303),
    [sym_interpolation_verbatim_start] = ACTIONS(3303),
    [sym_interpolation_raw_start] = ACTIONS(3303),
    [sym_raw_string_start] = ACTIONS(3303),
  },
  [2440] = {
    [sym_preproc_region] = STATE(2440),
    [sym_preproc_endregion] = STATE(2440),
    [sym_preproc_line] = STATE(2440),
    [sym_preproc_pragma] = STATE(2440),
    [sym_preproc_nullable] = STATE(2440),
    [sym_preproc_error] = STATE(2440),
    [sym_preproc_define] = STATE(2440),
    [sym_preproc_undef] = STATE(2440),
    [ts_builtin_sym_end] = ACTIONS(3335),
    [sym__identifier_token] = ACTIONS(3333),
    [anon_sym_extern] = ACTIONS(3333),
    [anon_sym_alias] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_global] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_unsafe] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_namespace] = ACTIONS(3333),
    [anon_sym_class] = ACTIONS(3333),
    [anon_sym_ref] = ACTIONS(3333),
    [anon_sym_struct] = ACTIONS(3333),
    [anon_sym_enum] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_interface] = ACTIONS(3333),
    [anon_sym_delegate] = ACTIONS(3333),
    [anon_sym_record] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_file] = ACTIONS(3333),
    [anon_sym_fixed] = ACTIONS(3333),
    [anon_sym_internal] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_partial] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_required] = ACTIONS(3333),
    [anon_sym_sealed] = ACTIONS(3333),
    [anon_sym_virtual] = ACTIONS(3333),
    [anon_sym_volatile] = ACTIONS(3333),
    [anon_sym_where] = ACTIONS(3333),
    [anon_sym_notnull] = ACTIONS(3333),
    [anon_sym_unmanaged] = ACTIONS(3333),
    [anon_sym_checked] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_true] = ACTIONS(3333),
    [anon_sym_false] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3335),
    [anon_sym_AMP] = ACTIONS(3335),
    [anon_sym_this] = ACTIONS(3333),
    [anon_sym_scoped] = ACTIONS(3333),
    [anon_sym_base] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [sym_predefined_type] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_unchecked] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_lock] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_when] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_foreach] = ACTIONS(3333),
    [anon_sym_goto] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_DOT_DOT] = ACTIONS(3335),
    [anon_sym_from] = ACTIONS(3333),
    [anon_sym_into] = ACTIONS(3333),
    [anon_sym_join] = ACTIONS(3333),
    [anon_sym_on] = ACTIONS(3333),
    [anon_sym_equals] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_orderby] = ACTIONS(3333),
    [anon_sym_ascending] = ACTIONS(3333),
    [anon_sym_descending] = ACTIONS(3333),
    [anon_sym_group] = ACTIONS(3333),
    [anon_sym_by] = ACTIONS(3333),
    [anon_sym_select] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3333),
    [anon_sym_sizeof] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym___makeref] = ACTIONS(3333),
    [anon_sym___reftype] = ACTIONS(3333),
    [anon_sym___refvalue] = ACTIONS(3333),
    [sym_null_literal] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3335),
    [sym_integer_literal] = ACTIONS(3333),
    [sym_real_literal] = ACTIONS(3335),
    [sym_verbatim_string_literal] = ACTIONS(3335),
    [aux_sym_preproc_if_token1] = ACTIONS(3335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3335),
    [sym_interpolation_verbatim_start] = ACTIONS(3335),
    [sym_interpolation_raw_start] = ACTIONS(3335),
    [sym_raw_string_start] = ACTIONS(3335),
  },
  [2441] = {
    [sym_preproc_region] = STATE(2441),
    [sym_preproc_endregion] = STATE(2441),
    [sym_preproc_line] = STATE(2441),
    [sym_preproc_pragma] = STATE(2441),
    [sym_preproc_nullable] = STATE(2441),
    [sym_preproc_error] = STATE(2441),
    [sym_preproc_define] = STATE(2441),
    [sym_preproc_undef] = STATE(2441),
    [ts_builtin_sym_end] = ACTIONS(3299),
    [sym__identifier_token] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym_alias] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_global] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_unsafe] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_namespace] = ACTIONS(3297),
    [anon_sym_class] = ACTIONS(3297),
    [anon_sym_ref] = ACTIONS(3297),
    [anon_sym_struct] = ACTIONS(3297),
    [anon_sym_enum] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_interface] = ACTIONS(3297),
    [anon_sym_delegate] = ACTIONS(3297),
    [anon_sym_record] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_file] = ACTIONS(3297),
    [anon_sym_fixed] = ACTIONS(3297),
    [anon_sym_internal] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_partial] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_required] = ACTIONS(3297),
    [anon_sym_sealed] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_where] = ACTIONS(3297),
    [anon_sym_notnull] = ACTIONS(3297),
    [anon_sym_unmanaged] = ACTIONS(3297),
    [anon_sym_checked] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_true] = ACTIONS(3297),
    [anon_sym_false] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_CARET] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3299),
    [anon_sym_this] = ACTIONS(3297),
    [anon_sym_scoped] = ACTIONS(3297),
    [anon_sym_base] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [sym_predefined_type] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_unchecked] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_lock] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_when] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_foreach] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_DOT_DOT] = ACTIONS(3299),
    [anon_sym_from] = ACTIONS(3297),
    [anon_sym_into] = ACTIONS(3297),
    [anon_sym_join] = ACTIONS(3297),
    [anon_sym_on] = ACTIONS(3297),
    [anon_sym_equals] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_orderby] = ACTIONS(3297),
    [anon_sym_ascending] = ACTIONS(3297),
    [anon_sym_descending] = ACTIONS(3297),
    [anon_sym_group] = ACTIONS(3297),
    [anon_sym_by] = ACTIONS(3297),
    [anon_sym_select] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3297),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym___makeref] = ACTIONS(3297),
    [anon_sym___reftype] = ACTIONS(3297),
    [anon_sym___refvalue] = ACTIONS(3297),
    [sym_null_literal] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [sym_integer_literal] = ACTIONS(3297),
    [sym_real_literal] = ACTIONS(3299),
    [sym_verbatim_string_literal] = ACTIONS(3299),
    [aux_sym_preproc_if_token1] = ACTIONS(3299),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3299),
    [sym_interpolation_verbatim_start] = ACTIONS(3299),
    [sym_interpolation_raw_start] = ACTIONS(3299),
    [sym_raw_string_start] = ACTIONS(3299),
  },
  [2442] = {
    [sym_preproc_region] = STATE(2442),
    [sym_preproc_endregion] = STATE(2442),
    [sym_preproc_line] = STATE(2442),
    [sym_preproc_pragma] = STATE(2442),
    [sym_preproc_nullable] = STATE(2442),
    [sym_preproc_error] = STATE(2442),
    [sym_preproc_define] = STATE(2442),
    [sym_preproc_undef] = STATE(2442),
    [ts_builtin_sym_end] = ACTIONS(3207),
    [sym__identifier_token] = ACTIONS(3205),
    [anon_sym_extern] = ACTIONS(3205),
    [anon_sym_alias] = ACTIONS(3205),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_global] = ACTIONS(3205),
    [anon_sym_using] = ACTIONS(3205),
    [anon_sym_unsafe] = ACTIONS(3205),
    [anon_sym_static] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3205),
    [anon_sym_namespace] = ACTIONS(3205),
    [anon_sym_class] = ACTIONS(3205),
    [anon_sym_ref] = ACTIONS(3205),
    [anon_sym_struct] = ACTIONS(3205),
    [anon_sym_enum] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_interface] = ACTIONS(3205),
    [anon_sym_delegate] = ACTIONS(3205),
    [anon_sym_record] = ACTIONS(3205),
    [anon_sym_abstract] = ACTIONS(3205),
    [anon_sym_async] = ACTIONS(3205),
    [anon_sym_const] = ACTIONS(3205),
    [anon_sym_file] = ACTIONS(3205),
    [anon_sym_fixed] = ACTIONS(3205),
    [anon_sym_internal] = ACTIONS(3205),
    [anon_sym_new] = ACTIONS(3205),
    [anon_sym_override] = ACTIONS(3205),
    [anon_sym_partial] = ACTIONS(3205),
    [anon_sym_private] = ACTIONS(3205),
    [anon_sym_protected] = ACTIONS(3205),
    [anon_sym_public] = ACTIONS(3205),
    [anon_sym_readonly] = ACTIONS(3205),
    [anon_sym_required] = ACTIONS(3205),
    [anon_sym_sealed] = ACTIONS(3205),
    [anon_sym_virtual] = ACTIONS(3205),
    [anon_sym_volatile] = ACTIONS(3205),
    [anon_sym_where] = ACTIONS(3205),
    [anon_sym_notnull] = ACTIONS(3205),
    [anon_sym_unmanaged] = ACTIONS(3205),
    [anon_sym_checked] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [anon_sym_true] = ACTIONS(3205),
    [anon_sym_false] = ACTIONS(3205),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_this] = ACTIONS(3205),
    [anon_sym_scoped] = ACTIONS(3205),
    [anon_sym_base] = ACTIONS(3205),
    [anon_sym_var] = ACTIONS(3205),
    [sym_predefined_type] = ACTIONS(3205),
    [anon_sym_break] = ACTIONS(3205),
    [anon_sym_unchecked] = ACTIONS(3205),
    [anon_sym_continue] = ACTIONS(3205),
    [anon_sym_do] = ACTIONS(3205),
    [anon_sym_while] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3205),
    [anon_sym_lock] = ACTIONS(3205),
    [anon_sym_yield] = ACTIONS(3205),
    [anon_sym_switch] = ACTIONS(3205),
    [anon_sym_default] = ACTIONS(3205),
    [anon_sym_throw] = ACTIONS(3205),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_when] = ACTIONS(3205),
    [anon_sym_await] = ACTIONS(3205),
    [anon_sym_foreach] = ACTIONS(3205),
    [anon_sym_goto] = ACTIONS(3205),
    [anon_sym_if] = ACTIONS(3205),
    [anon_sym_else] = ACTIONS(3205),
    [anon_sym_DOT_DOT] = ACTIONS(3207),
    [anon_sym_from] = ACTIONS(3205),
    [anon_sym_into] = ACTIONS(3205),
    [anon_sym_join] = ACTIONS(3205),
    [anon_sym_on] = ACTIONS(3205),
    [anon_sym_equals] = ACTIONS(3205),
    [anon_sym_let] = ACTIONS(3205),
    [anon_sym_orderby] = ACTIONS(3205),
    [anon_sym_ascending] = ACTIONS(3205),
    [anon_sym_descending] = ACTIONS(3205),
    [anon_sym_group] = ACTIONS(3205),
    [anon_sym_by] = ACTIONS(3205),
    [anon_sym_select] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3205),
    [anon_sym_sizeof] = ACTIONS(3205),
    [anon_sym_typeof] = ACTIONS(3205),
    [anon_sym___makeref] = ACTIONS(3205),
    [anon_sym___reftype] = ACTIONS(3205),
    [anon_sym___refvalue] = ACTIONS(3205),
    [sym_null_literal] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [sym_integer_literal] = ACTIONS(3205),
    [sym_real_literal] = ACTIONS(3207),
    [sym_verbatim_string_literal] = ACTIONS(3207),
    [aux_sym_preproc_if_token1] = ACTIONS(3207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3207),
    [sym_interpolation_verbatim_start] = ACTIONS(3207),
    [sym_interpolation_raw_start] = ACTIONS(3207),
    [sym_raw_string_start] = ACTIONS(3207),
  },
  [2443] = {
    [sym_preproc_region] = STATE(2443),
    [sym_preproc_endregion] = STATE(2443),
    [sym_preproc_line] = STATE(2443),
    [sym_preproc_pragma] = STATE(2443),
    [sym_preproc_nullable] = STATE(2443),
    [sym_preproc_error] = STATE(2443),
    [sym_preproc_define] = STATE(2443),
    [sym_preproc_undef] = STATE(2443),
    [ts_builtin_sym_end] = ACTIONS(3295),
    [sym__identifier_token] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym_alias] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_global] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_unsafe] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_ref] = ACTIONS(3293),
    [anon_sym_struct] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_delegate] = ACTIONS(3293),
    [anon_sym_record] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_file] = ACTIONS(3293),
    [anon_sym_fixed] = ACTIONS(3293),
    [anon_sym_internal] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_partial] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_required] = ACTIONS(3293),
    [anon_sym_sealed] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_where] = ACTIONS(3293),
    [anon_sym_notnull] = ACTIONS(3293),
    [anon_sym_unmanaged] = ACTIONS(3293),
    [anon_sym_checked] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_true] = ACTIONS(3293),
    [anon_sym_false] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_this] = ACTIONS(3293),
    [anon_sym_scoped] = ACTIONS(3293),
    [anon_sym_base] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [sym_predefined_type] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_unchecked] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_lock] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_when] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_foreach] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_from] = ACTIONS(3293),
    [anon_sym_into] = ACTIONS(3293),
    [anon_sym_join] = ACTIONS(3293),
    [anon_sym_on] = ACTIONS(3293),
    [anon_sym_equals] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_orderby] = ACTIONS(3293),
    [anon_sym_ascending] = ACTIONS(3293),
    [anon_sym_descending] = ACTIONS(3293),
    [anon_sym_group] = ACTIONS(3293),
    [anon_sym_by] = ACTIONS(3293),
    [anon_sym_select] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym___makeref] = ACTIONS(3293),
    [anon_sym___reftype] = ACTIONS(3293),
    [anon_sym___refvalue] = ACTIONS(3293),
    [sym_null_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [sym_integer_literal] = ACTIONS(3293),
    [sym_real_literal] = ACTIONS(3295),
    [sym_verbatim_string_literal] = ACTIONS(3295),
    [aux_sym_preproc_if_token1] = ACTIONS(3295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3295),
    [sym_interpolation_verbatim_start] = ACTIONS(3295),
    [sym_interpolation_raw_start] = ACTIONS(3295),
    [sym_raw_string_start] = ACTIONS(3295),
  },
  [2444] = {
    [sym_preproc_region] = STATE(2444),
    [sym_preproc_endregion] = STATE(2444),
    [sym_preproc_line] = STATE(2444),
    [sym_preproc_pragma] = STATE(2444),
    [sym_preproc_nullable] = STATE(2444),
    [sym_preproc_error] = STATE(2444),
    [sym_preproc_define] = STATE(2444),
    [sym_preproc_undef] = STATE(2444),
    [ts_builtin_sym_end] = ACTIONS(3195),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_namespace] = ACTIONS(3193),
    [anon_sym_class] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_enum] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_interface] = ACTIONS(3193),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_record] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [2445] = {
    [sym_preproc_region] = STATE(2445),
    [sym_preproc_endregion] = STATE(2445),
    [sym_preproc_line] = STATE(2445),
    [sym_preproc_pragma] = STATE(2445),
    [sym_preproc_nullable] = STATE(2445),
    [sym_preproc_error] = STATE(2445),
    [sym_preproc_define] = STATE(2445),
    [sym_preproc_undef] = STATE(2445),
    [ts_builtin_sym_end] = ACTIONS(3291),
    [sym__identifier_token] = ACTIONS(3289),
    [anon_sym_extern] = ACTIONS(3289),
    [anon_sym_alias] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_unsafe] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_ref] = ACTIONS(3289),
    [anon_sym_struct] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_delegate] = ACTIONS(3289),
    [anon_sym_record] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_file] = ACTIONS(3289),
    [anon_sym_fixed] = ACTIONS(3289),
    [anon_sym_internal] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_partial] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_required] = ACTIONS(3289),
    [anon_sym_sealed] = ACTIONS(3289),
    [anon_sym_virtual] = ACTIONS(3289),
    [anon_sym_volatile] = ACTIONS(3289),
    [anon_sym_where] = ACTIONS(3289),
    [anon_sym_notnull] = ACTIONS(3289),
    [anon_sym_unmanaged] = ACTIONS(3289),
    [anon_sym_checked] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_true] = ACTIONS(3289),
    [anon_sym_false] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3291),
    [anon_sym_CARET] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_this] = ACTIONS(3289),
    [anon_sym_scoped] = ACTIONS(3289),
    [anon_sym_base] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [sym_predefined_type] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_unchecked] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_lock] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_when] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_foreach] = ACTIONS(3289),
    [anon_sym_goto] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_DOT_DOT] = ACTIONS(3291),
    [anon_sym_from] = ACTIONS(3289),
    [anon_sym_into] = ACTIONS(3289),
    [anon_sym_join] = ACTIONS(3289),
    [anon_sym_on] = ACTIONS(3289),
    [anon_sym_equals] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_orderby] = ACTIONS(3289),
    [anon_sym_ascending] = ACTIONS(3289),
    [anon_sym_descending] = ACTIONS(3289),
    [anon_sym_group] = ACTIONS(3289),
    [anon_sym_by] = ACTIONS(3289),
    [anon_sym_select] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym___makeref] = ACTIONS(3289),
    [anon_sym___reftype] = ACTIONS(3289),
    [anon_sym___refvalue] = ACTIONS(3289),
    [sym_null_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [sym_integer_literal] = ACTIONS(3289),
    [sym_real_literal] = ACTIONS(3291),
    [sym_verbatim_string_literal] = ACTIONS(3291),
    [aux_sym_preproc_if_token1] = ACTIONS(3291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3291),
    [sym_interpolation_verbatim_start] = ACTIONS(3291),
    [sym_interpolation_raw_start] = ACTIONS(3291),
    [sym_raw_string_start] = ACTIONS(3291),
  },
  [2446] = {
    [sym_preproc_region] = STATE(2446),
    [sym_preproc_endregion] = STATE(2446),
    [sym_preproc_line] = STATE(2446),
    [sym_preproc_pragma] = STATE(2446),
    [sym_preproc_nullable] = STATE(2446),
    [sym_preproc_error] = STATE(2446),
    [sym_preproc_define] = STATE(2446),
    [sym_preproc_undef] = STATE(2446),
    [ts_builtin_sym_end] = ACTIONS(3199),
    [sym__identifier_token] = ACTIONS(3197),
    [anon_sym_extern] = ACTIONS(3197),
    [anon_sym_alias] = ACTIONS(3197),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_global] = ACTIONS(3197),
    [anon_sym_using] = ACTIONS(3197),
    [anon_sym_unsafe] = ACTIONS(3197),
    [anon_sym_static] = ACTIONS(3197),
    [anon_sym_LBRACK] = ACTIONS(3199),
    [anon_sym_LPAREN] = ACTIONS(3199),
    [anon_sym_return] = ACTIONS(3197),
    [anon_sym_namespace] = ACTIONS(3197),
    [anon_sym_class] = ACTIONS(3197),
    [anon_sym_ref] = ACTIONS(3197),
    [anon_sym_struct] = ACTIONS(3197),
    [anon_sym_enum] = ACTIONS(3197),
    [anon_sym_LBRACE] = ACTIONS(3199),
    [anon_sym_interface] = ACTIONS(3197),
    [anon_sym_delegate] = ACTIONS(3197),
    [anon_sym_record] = ACTIONS(3197),
    [anon_sym_abstract] = ACTIONS(3197),
    [anon_sym_async] = ACTIONS(3197),
    [anon_sym_const] = ACTIONS(3197),
    [anon_sym_file] = ACTIONS(3197),
    [anon_sym_fixed] = ACTIONS(3197),
    [anon_sym_internal] = ACTIONS(3197),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_override] = ACTIONS(3197),
    [anon_sym_partial] = ACTIONS(3197),
    [anon_sym_private] = ACTIONS(3197),
    [anon_sym_protected] = ACTIONS(3197),
    [anon_sym_public] = ACTIONS(3197),
    [anon_sym_readonly] = ACTIONS(3197),
    [anon_sym_required] = ACTIONS(3197),
    [anon_sym_sealed] = ACTIONS(3197),
    [anon_sym_virtual] = ACTIONS(3197),
    [anon_sym_volatile] = ACTIONS(3197),
    [anon_sym_where] = ACTIONS(3197),
    [anon_sym_notnull] = ACTIONS(3197),
    [anon_sym_unmanaged] = ACTIONS(3197),
    [anon_sym_checked] = ACTIONS(3197),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_TILDE] = ACTIONS(3199),
    [anon_sym_PLUS_PLUS] = ACTIONS(3199),
    [anon_sym_DASH_DASH] = ACTIONS(3199),
    [anon_sym_true] = ACTIONS(3197),
    [anon_sym_false] = ACTIONS(3197),
    [anon_sym_PLUS] = ACTIONS(3197),
    [anon_sym_DASH] = ACTIONS(3197),
    [anon_sym_STAR] = ACTIONS(3199),
    [anon_sym_CARET] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3199),
    [anon_sym_this] = ACTIONS(3197),
    [anon_sym_scoped] = ACTIONS(3197),
    [anon_sym_base] = ACTIONS(3197),
    [anon_sym_var] = ACTIONS(3197),
    [sym_predefined_type] = ACTIONS(3197),
    [anon_sym_break] = ACTIONS(3197),
    [anon_sym_unchecked] = ACTIONS(3197),
    [anon_sym_continue] = ACTIONS(3197),
    [anon_sym_do] = ACTIONS(3197),
    [anon_sym_while] = ACTIONS(3197),
    [anon_sym_for] = ACTIONS(3197),
    [anon_sym_lock] = ACTIONS(3197),
    [anon_sym_yield] = ACTIONS(3197),
    [anon_sym_switch] = ACTIONS(3197),
    [anon_sym_default] = ACTIONS(3197),
    [anon_sym_throw] = ACTIONS(3197),
    [anon_sym_try] = ACTIONS(3197),
    [anon_sym_when] = ACTIONS(3197),
    [anon_sym_await] = ACTIONS(3197),
    [anon_sym_foreach] = ACTIONS(3197),
    [anon_sym_goto] = ACTIONS(3197),
    [anon_sym_if] = ACTIONS(3197),
    [anon_sym_else] = ACTIONS(3197),
    [anon_sym_DOT_DOT] = ACTIONS(3199),
    [anon_sym_from] = ACTIONS(3197),
    [anon_sym_into] = ACTIONS(3197),
    [anon_sym_join] = ACTIONS(3197),
    [anon_sym_on] = ACTIONS(3197),
    [anon_sym_equals] = ACTIONS(3197),
    [anon_sym_let] = ACTIONS(3197),
    [anon_sym_orderby] = ACTIONS(3197),
    [anon_sym_ascending] = ACTIONS(3197),
    [anon_sym_descending] = ACTIONS(3197),
    [anon_sym_group] = ACTIONS(3197),
    [anon_sym_by] = ACTIONS(3197),
    [anon_sym_select] = ACTIONS(3197),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3197),
    [anon_sym_sizeof] = ACTIONS(3197),
    [anon_sym_typeof] = ACTIONS(3197),
    [anon_sym___makeref] = ACTIONS(3197),
    [anon_sym___reftype] = ACTIONS(3197),
    [anon_sym___refvalue] = ACTIONS(3197),
    [sym_null_literal] = ACTIONS(3197),
    [anon_sym_SQUOTE] = ACTIONS(3199),
    [sym_integer_literal] = ACTIONS(3197),
    [sym_real_literal] = ACTIONS(3199),
    [sym_verbatim_string_literal] = ACTIONS(3199),
    [aux_sym_preproc_if_token1] = ACTIONS(3199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3199),
    [sym_interpolation_verbatim_start] = ACTIONS(3199),
    [sym_interpolation_raw_start] = ACTIONS(3199),
    [sym_raw_string_start] = ACTIONS(3199),
  },
  [2447] = {
    [sym_preproc_region] = STATE(2447),
    [sym_preproc_endregion] = STATE(2447),
    [sym_preproc_line] = STATE(2447),
    [sym_preproc_pragma] = STATE(2447),
    [sym_preproc_nullable] = STATE(2447),
    [sym_preproc_error] = STATE(2447),
    [sym_preproc_define] = STATE(2447),
    [sym_preproc_undef] = STATE(2447),
    [ts_builtin_sym_end] = ACTIONS(3085),
    [sym__identifier_token] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym_alias] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_global] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_unsafe] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_ref] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_interface] = ACTIONS(3083),
    [anon_sym_delegate] = ACTIONS(3083),
    [anon_sym_record] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_file] = ACTIONS(3083),
    [anon_sym_fixed] = ACTIONS(3083),
    [anon_sym_internal] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3083),
    [anon_sym_partial] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_readonly] = ACTIONS(3083),
    [anon_sym_required] = ACTIONS(3083),
    [anon_sym_sealed] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_where] = ACTIONS(3083),
    [anon_sym_notnull] = ACTIONS(3083),
    [anon_sym_unmanaged] = ACTIONS(3083),
    [anon_sym_checked] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_true] = ACTIONS(3083),
    [anon_sym_false] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_this] = ACTIONS(3083),
    [anon_sym_scoped] = ACTIONS(3083),
    [anon_sym_base] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [sym_predefined_type] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_unchecked] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_lock] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_when] = ACTIONS(3083),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_foreach] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_from] = ACTIONS(3083),
    [anon_sym_into] = ACTIONS(3083),
    [anon_sym_join] = ACTIONS(3083),
    [anon_sym_on] = ACTIONS(3083),
    [anon_sym_equals] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_orderby] = ACTIONS(3083),
    [anon_sym_ascending] = ACTIONS(3083),
    [anon_sym_descending] = ACTIONS(3083),
    [anon_sym_group] = ACTIONS(3083),
    [anon_sym_by] = ACTIONS(3083),
    [anon_sym_select] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3083),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym___makeref] = ACTIONS(3083),
    [anon_sym___reftype] = ACTIONS(3083),
    [anon_sym___refvalue] = ACTIONS(3083),
    [sym_null_literal] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [sym_integer_literal] = ACTIONS(3083),
    [sym_real_literal] = ACTIONS(3085),
    [sym_verbatim_string_literal] = ACTIONS(3085),
    [aux_sym_preproc_if_token1] = ACTIONS(3085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3085),
    [sym_interpolation_verbatim_start] = ACTIONS(3085),
    [sym_interpolation_raw_start] = ACTIONS(3085),
    [sym_raw_string_start] = ACTIONS(3085),
  },
  [2448] = {
    [sym_preproc_region] = STATE(2448),
    [sym_preproc_endregion] = STATE(2448),
    [sym_preproc_line] = STATE(2448),
    [sym_preproc_pragma] = STATE(2448),
    [sym_preproc_nullable] = STATE(2448),
    [sym_preproc_error] = STATE(2448),
    [sym_preproc_define] = STATE(2448),
    [sym_preproc_undef] = STATE(2448),
    [ts_builtin_sym_end] = ACTIONS(3383),
    [sym__identifier_token] = ACTIONS(3381),
    [anon_sym_extern] = ACTIONS(3381),
    [anon_sym_alias] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_global] = ACTIONS(3381),
    [anon_sym_using] = ACTIONS(3381),
    [anon_sym_unsafe] = ACTIONS(3381),
    [anon_sym_static] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3381),
    [anon_sym_namespace] = ACTIONS(3381),
    [anon_sym_class] = ACTIONS(3381),
    [anon_sym_ref] = ACTIONS(3381),
    [anon_sym_struct] = ACTIONS(3381),
    [anon_sym_enum] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_interface] = ACTIONS(3381),
    [anon_sym_delegate] = ACTIONS(3381),
    [anon_sym_record] = ACTIONS(3381),
    [anon_sym_abstract] = ACTIONS(3381),
    [anon_sym_async] = ACTIONS(3381),
    [anon_sym_const] = ACTIONS(3381),
    [anon_sym_file] = ACTIONS(3381),
    [anon_sym_fixed] = ACTIONS(3381),
    [anon_sym_internal] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3381),
    [anon_sym_override] = ACTIONS(3381),
    [anon_sym_partial] = ACTIONS(3381),
    [anon_sym_private] = ACTIONS(3381),
    [anon_sym_protected] = ACTIONS(3381),
    [anon_sym_public] = ACTIONS(3381),
    [anon_sym_readonly] = ACTIONS(3381),
    [anon_sym_required] = ACTIONS(3381),
    [anon_sym_sealed] = ACTIONS(3381),
    [anon_sym_virtual] = ACTIONS(3381),
    [anon_sym_volatile] = ACTIONS(3381),
    [anon_sym_where] = ACTIONS(3381),
    [anon_sym_notnull] = ACTIONS(3381),
    [anon_sym_unmanaged] = ACTIONS(3381),
    [anon_sym_checked] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_true] = ACTIONS(3381),
    [anon_sym_false] = ACTIONS(3381),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_this] = ACTIONS(3381),
    [anon_sym_scoped] = ACTIONS(3381),
    [anon_sym_base] = ACTIONS(3381),
    [anon_sym_var] = ACTIONS(3381),
    [sym_predefined_type] = ACTIONS(3381),
    [anon_sym_break] = ACTIONS(3381),
    [anon_sym_unchecked] = ACTIONS(3381),
    [anon_sym_continue] = ACTIONS(3381),
    [anon_sym_do] = ACTIONS(3381),
    [anon_sym_while] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(3381),
    [anon_sym_lock] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(3381),
    [anon_sym_switch] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3381),
    [anon_sym_throw] = ACTIONS(3381),
    [anon_sym_try] = ACTIONS(3381),
    [anon_sym_when] = ACTIONS(3381),
    [anon_sym_await] = ACTIONS(3381),
    [anon_sym_foreach] = ACTIONS(3381),
    [anon_sym_goto] = ACTIONS(3381),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_else] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_from] = ACTIONS(3381),
    [anon_sym_into] = ACTIONS(3381),
    [anon_sym_join] = ACTIONS(3381),
    [anon_sym_on] = ACTIONS(3381),
    [anon_sym_equals] = ACTIONS(3381),
    [anon_sym_let] = ACTIONS(3381),
    [anon_sym_orderby] = ACTIONS(3381),
    [anon_sym_ascending] = ACTIONS(3381),
    [anon_sym_descending] = ACTIONS(3381),
    [anon_sym_group] = ACTIONS(3381),
    [anon_sym_by] = ACTIONS(3381),
    [anon_sym_select] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3381),
    [anon_sym_typeof] = ACTIONS(3381),
    [anon_sym___makeref] = ACTIONS(3381),
    [anon_sym___reftype] = ACTIONS(3381),
    [anon_sym___refvalue] = ACTIONS(3381),
    [sym_null_literal] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [sym_integer_literal] = ACTIONS(3381),
    [sym_real_literal] = ACTIONS(3383),
    [sym_verbatim_string_literal] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3383),
    [sym_interpolation_verbatim_start] = ACTIONS(3383),
    [sym_interpolation_raw_start] = ACTIONS(3383),
    [sym_raw_string_start] = ACTIONS(3383),
  },
  [2449] = {
    [sym_preproc_region] = STATE(2449),
    [sym_preproc_endregion] = STATE(2449),
    [sym_preproc_line] = STATE(2449),
    [sym_preproc_pragma] = STATE(2449),
    [sym_preproc_nullable] = STATE(2449),
    [sym_preproc_error] = STATE(2449),
    [sym_preproc_define] = STATE(2449),
    [sym_preproc_undef] = STATE(2449),
    [ts_builtin_sym_end] = ACTIONS(3395),
    [sym__identifier_token] = ACTIONS(3393),
    [anon_sym_extern] = ACTIONS(3393),
    [anon_sym_alias] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_global] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_unsafe] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_namespace] = ACTIONS(3393),
    [anon_sym_class] = ACTIONS(3393),
    [anon_sym_ref] = ACTIONS(3393),
    [anon_sym_struct] = ACTIONS(3393),
    [anon_sym_enum] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_interface] = ACTIONS(3393),
    [anon_sym_delegate] = ACTIONS(3393),
    [anon_sym_record] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_file] = ACTIONS(3393),
    [anon_sym_fixed] = ACTIONS(3393),
    [anon_sym_internal] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_partial] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_required] = ACTIONS(3393),
    [anon_sym_sealed] = ACTIONS(3393),
    [anon_sym_virtual] = ACTIONS(3393),
    [anon_sym_volatile] = ACTIONS(3393),
    [anon_sym_where] = ACTIONS(3393),
    [anon_sym_notnull] = ACTIONS(3393),
    [anon_sym_unmanaged] = ACTIONS(3393),
    [anon_sym_checked] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [anon_sym_true] = ACTIONS(3393),
    [anon_sym_false] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_this] = ACTIONS(3393),
    [anon_sym_scoped] = ACTIONS(3393),
    [anon_sym_base] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [sym_predefined_type] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_unchecked] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_lock] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_when] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_foreach] = ACTIONS(3393),
    [anon_sym_goto] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_DOT_DOT] = ACTIONS(3395),
    [anon_sym_from] = ACTIONS(3393),
    [anon_sym_into] = ACTIONS(3393),
    [anon_sym_join] = ACTIONS(3393),
    [anon_sym_on] = ACTIONS(3393),
    [anon_sym_equals] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_orderby] = ACTIONS(3393),
    [anon_sym_ascending] = ACTIONS(3393),
    [anon_sym_descending] = ACTIONS(3393),
    [anon_sym_group] = ACTIONS(3393),
    [anon_sym_by] = ACTIONS(3393),
    [anon_sym_select] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_stackalloc] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym___makeref] = ACTIONS(3393),
    [anon_sym___reftype] = ACTIONS(3393),
    [anon_sym___refvalue] = ACTIONS(3393),
    [sym_null_literal] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [sym_integer_literal] = ACTIONS(3393),
    [sym_real_literal] = ACTIONS(3395),
    [sym_verbatim_string_literal] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3395),
    [sym_interpolation_verbatim_start] = ACTIONS(3395),
    [sym_interpolation_raw_start] = ACTIONS(3395),
    [sym_raw_string_start] = ACTIONS(3395),
  },
  [2450] = {
    [sym_preproc_region] = STATE(2450),
    [sym_preproc_endregion] = STATE(2450),
    [sym_preproc_line] = STATE(2450),
    [sym_preproc_pragma] = STATE(2450),
    [sym_preproc_nullable] = STATE(2450),
    [sym_preproc_error] = STATE(2450),
    [sym_preproc_define] = STATE(2450),
    [sym_preproc_undef] = STATE(2450),
    [ts_builtin_sym_end] = ACTIONS(3405),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_namespace] = ACTIONS(3403),
    [anon_sym_class] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_struct] = ACTIONS(3403),
    [anon_sym_enum] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_interface] = ACTIONS(3403),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_record] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_checked] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3403),
    [anon_sym_false] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_this] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_base] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_unchecked] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_lock] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_foreach] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym___makeref] = ACTIONS(3403),
    [anon_sym___reftype] = ACTIONS(3403),
    [anon_sym___refvalue] = ACTIONS(3403),
    [sym_null_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_integer_literal] = ACTIONS(3403),
    [sym_real_literal] = ACTIONS(3405),
    [sym_verbatim_string_literal] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3405),
    [sym_interpolation_verbatim_start] = ACTIONS(3405),
    [sym_interpolation_raw_start] = ACTIONS(3405),
    [sym_raw_string_start] = ACTIONS(3405),
  },
  [2451] = {
    [sym_preproc_region] = STATE(2451),
    [sym_preproc_endregion] = STATE(2451),
    [sym_preproc_line] = STATE(2451),
    [sym_preproc_pragma] = STATE(2451),
    [sym_preproc_nullable] = STATE(2451),
    [sym_preproc_error] = STATE(2451),
    [sym_preproc_define] = STATE(2451),
    [sym_preproc_undef] = STATE(2451),
    [ts_builtin_sym_end] = ACTIONS(3371),
    [sym__identifier_token] = ACTIONS(3369),
    [anon_sym_extern] = ACTIONS(3369),
    [anon_sym_alias] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_global] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_unsafe] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_namespace] = ACTIONS(3369),
    [anon_sym_class] = ACTIONS(3369),
    [anon_sym_ref] = ACTIONS(3369),
    [anon_sym_struct] = ACTIONS(3369),
    [anon_sym_enum] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_interface] = ACTIONS(3369),
    [anon_sym_delegate] = ACTIONS(3369),
    [anon_sym_record] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_file] = ACTIONS(3369),
    [anon_sym_fixed] = ACTIONS(3369),
    [anon_sym_internal] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_partial] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_required] = ACTIONS(3369),
    [anon_sym_sealed] = ACTIONS(3369),
    [anon_sym_virtual] = ACTIONS(3369),
    [anon_sym_volatile] = ACTIONS(3369),
    [anon_sym_where] = ACTIONS(3369),
    [anon_sym_notnull] = ACTIONS(3369),
    [anon_sym_unmanaged] = ACTIONS(3369),
    [anon_sym_checked] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [anon_sym_true] = ACTIONS(3369),
    [anon_sym_false] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(3371),
    [anon_sym_CARET] = ACTIONS(3371),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_this] = ACTIONS(3369),
    [anon_sym_scoped] = ACTIONS(3369),
    [anon_sym_base] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [sym_predefined_type] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_unchecked] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_lock] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_when] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_foreach] = ACTIONS(3369),
    [anon_sym_goto] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_else] = ACTIONS(3369),
    [anon_sym_DOT_DOT] = ACTIONS(3371),
    [anon_sym_from] = ACTIONS(3369),
    [anon_sym_into] = ACTIONS(3369),
    [anon_sym_join] = ACTIONS(3369),
    [anon_sym_on] = ACTIONS(3369),
    [anon_sym_equals] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_orderby] = ACTIONS(3369),
    [anon_sym_ascending] = ACTIONS(3369),
    [anon_sym_descending] = ACTIONS(3369),
    [anon_sym_group] = ACTIONS(3369),
    [anon_sym_by] = ACTIONS(3369),
    [anon_sym_select] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym___makeref] = ACTIONS(3369),
    [anon_sym___reftype] = ACTIONS(3369),
    [anon_sym___refvalue] = ACTIONS(3369),
    [sym_null_literal] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [sym_integer_literal] = ACTIONS(3369),
    [sym_real_literal] = ACTIONS(3371),
    [sym_verbatim_string_literal] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3371),
    [sym_interpolation_verbatim_start] = ACTIONS(3371),
    [sym_interpolation_raw_start] = ACTIONS(3371),
    [sym_raw_string_start] = ACTIONS(3371),
  },
  [2452] = {
    [sym_preproc_region] = STATE(2452),
    [sym_preproc_endregion] = STATE(2452),
    [sym_preproc_line] = STATE(2452),
    [sym_preproc_pragma] = STATE(2452),
    [sym_preproc_nullable] = STATE(2452),
    [sym_preproc_error] = STATE(2452),
    [sym_preproc_define] = STATE(2452),
    [sym_preproc_undef] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(3401),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_namespace] = ACTIONS(3399),
    [anon_sym_class] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_struct] = ACTIONS(3399),
    [anon_sym_enum] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_interface] = ACTIONS(3399),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_record] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_checked] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_true] = ACTIONS(3399),
    [anon_sym_false] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_this] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_base] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_unchecked] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_lock] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_foreach] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_DOT_DOT] = ACTIONS(3401),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym___makeref] = ACTIONS(3399),
    [anon_sym___reftype] = ACTIONS(3399),
    [anon_sym___refvalue] = ACTIONS(3399),
    [sym_null_literal] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_integer_literal] = ACTIONS(3399),
    [sym_real_literal] = ACTIONS(3401),
    [sym_verbatim_string_literal] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3401),
    [sym_interpolation_verbatim_start] = ACTIONS(3401),
    [sym_interpolation_raw_start] = ACTIONS(3401),
    [sym_raw_string_start] = ACTIONS(3401),
  },
  [2453] = {
    [sym_preproc_region] = STATE(2453),
    [sym_preproc_endregion] = STATE(2453),
    [sym_preproc_line] = STATE(2453),
    [sym_preproc_pragma] = STATE(2453),
    [sym_preproc_nullable] = STATE(2453),
    [sym_preproc_error] = STATE(2453),
    [sym_preproc_define] = STATE(2453),
    [sym_preproc_undef] = STATE(2453),
    [ts_builtin_sym_end] = ACTIONS(3255),
    [sym__identifier_token] = ACTIONS(3253),
    [anon_sym_extern] = ACTIONS(3253),
    [anon_sym_alias] = ACTIONS(3253),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_global] = ACTIONS(3253),
    [anon_sym_using] = ACTIONS(3253),
    [anon_sym_unsafe] = ACTIONS(3253),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3253),
    [anon_sym_namespace] = ACTIONS(3253),
    [anon_sym_class] = ACTIONS(3253),
    [anon_sym_ref] = ACTIONS(3253),
    [anon_sym_struct] = ACTIONS(3253),
    [anon_sym_enum] = ACTIONS(3253),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_interface] = ACTIONS(3253),
    [anon_sym_delegate] = ACTIONS(3253),
    [anon_sym_record] = ACTIONS(3253),
    [anon_sym_abstract] = ACTIONS(3253),
    [anon_sym_async] = ACTIONS(3253),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_file] = ACTIONS(3253),
    [anon_sym_fixed] = ACTIONS(3253),
    [anon_sym_internal] = ACTIONS(3253),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_override] = ACTIONS(3253),
    [anon_sym_partial] = ACTIONS(3253),
    [anon_sym_private] = ACTIONS(3253),
    [anon_sym_protected] = ACTIONS(3253),
    [anon_sym_public] = ACTIONS(3253),
    [anon_sym_readonly] = ACTIONS(3253),
    [anon_sym_required] = ACTIONS(3253),
    [anon_sym_sealed] = ACTIONS(3253),
    [anon_sym_virtual] = ACTIONS(3253),
    [anon_sym_volatile] = ACTIONS(3253),
    [anon_sym_where] = ACTIONS(3253),
    [anon_sym_notnull] = ACTIONS(3253),
    [anon_sym_unmanaged] = ACTIONS(3253),
    [anon_sym_checked] = ACTIONS(3253),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_true] = ACTIONS(3253),
    [anon_sym_false] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_CARET] = ACTIONS(3255),
    [anon_sym_AMP] = ACTIONS(3255),
    [anon_sym_this] = ACTIONS(3253),
    [anon_sym_scoped] = ACTIONS(3253),
    [anon_sym_base] = ACTIONS(3253),
    [anon_sym_var] = ACTIONS(3253),
    [sym_predefined_type] = ACTIONS(3253),
    [anon_sym_break] = ACTIONS(3253),
    [anon_sym_unchecked] = ACTIONS(3253),
    [anon_sym_continue] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3253),
    [anon_sym_while] = ACTIONS(3253),
    [anon_sym_for] = ACTIONS(3253),
    [anon_sym_lock] = ACTIONS(3253),
    [anon_sym_yield] = ACTIONS(3253),
    [anon_sym_switch] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_throw] = ACTIONS(3253),
    [anon_sym_try] = ACTIONS(3253),
    [anon_sym_when] = ACTIONS(3253),
    [anon_sym_await] = ACTIONS(3253),
    [anon_sym_foreach] = ACTIONS(3253),
    [anon_sym_goto] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3253),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_DOT_DOT] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3253),
    [anon_sym_into] = ACTIONS(3253),
    [anon_sym_join] = ACTIONS(3253),
    [anon_sym_on] = ACTIONS(3253),
    [anon_sym_equals] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_orderby] = ACTIONS(3253),
    [anon_sym_ascending] = ACTIONS(3253),
    [anon_sym_descending] = ACTIONS(3253),
    [anon_sym_group] = ACTIONS(3253),
    [anon_sym_by] = ACTIONS(3253),
    [anon_sym_select] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3253),
    [anon_sym_sizeof] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3253),
    [anon_sym___makeref] = ACTIONS(3253),
    [anon_sym___reftype] = ACTIONS(3253),
    [anon_sym___refvalue] = ACTIONS(3253),
    [sym_null_literal] = ACTIONS(3253),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [sym_integer_literal] = ACTIONS(3253),
    [sym_real_literal] = ACTIONS(3255),
    [sym_verbatim_string_literal] = ACTIONS(3255),
    [aux_sym_preproc_if_token1] = ACTIONS(3255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3255),
    [sym_interpolation_verbatim_start] = ACTIONS(3255),
    [sym_interpolation_raw_start] = ACTIONS(3255),
    [sym_raw_string_start] = ACTIONS(3255),
  },
  [2454] = {
    [sym_preproc_region] = STATE(2454),
    [sym_preproc_endregion] = STATE(2454),
    [sym_preproc_line] = STATE(2454),
    [sym_preproc_pragma] = STATE(2454),
    [sym_preproc_nullable] = STATE(2454),
    [sym_preproc_error] = STATE(2454),
    [sym_preproc_define] = STATE(2454),
    [sym_preproc_undef] = STATE(2454),
    [ts_builtin_sym_end] = ACTIONS(3203),
    [sym__identifier_token] = ACTIONS(3201),
    [anon_sym_extern] = ACTIONS(3201),
    [anon_sym_alias] = ACTIONS(3201),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_global] = ACTIONS(3201),
    [anon_sym_using] = ACTIONS(3201),
    [anon_sym_unsafe] = ACTIONS(3201),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_namespace] = ACTIONS(3201),
    [anon_sym_class] = ACTIONS(3201),
    [anon_sym_ref] = ACTIONS(3201),
    [anon_sym_struct] = ACTIONS(3201),
    [anon_sym_enum] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3203),
    [anon_sym_interface] = ACTIONS(3201),
    [anon_sym_delegate] = ACTIONS(3201),
    [anon_sym_record] = ACTIONS(3201),
    [anon_sym_abstract] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_file] = ACTIONS(3201),
    [anon_sym_fixed] = ACTIONS(3201),
    [anon_sym_internal] = ACTIONS(3201),
    [anon_sym_new] = ACTIONS(3201),
    [anon_sym_override] = ACTIONS(3201),
    [anon_sym_partial] = ACTIONS(3201),
    [anon_sym_private] = ACTIONS(3201),
    [anon_sym_protected] = ACTIONS(3201),
    [anon_sym_public] = ACTIONS(3201),
    [anon_sym_readonly] = ACTIONS(3201),
    [anon_sym_required] = ACTIONS(3201),
    [anon_sym_sealed] = ACTIONS(3201),
    [anon_sym_virtual] = ACTIONS(3201),
    [anon_sym_volatile] = ACTIONS(3201),
    [anon_sym_where] = ACTIONS(3201),
    [anon_sym_notnull] = ACTIONS(3201),
    [anon_sym_unmanaged] = ACTIONS(3201),
    [anon_sym_checked] = ACTIONS(3201),
    [anon_sym_BANG] = ACTIONS(3203),
    [anon_sym_TILDE] = ACTIONS(3203),
    [anon_sym_PLUS_PLUS] = ACTIONS(3203),
    [anon_sym_DASH_DASH] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(3201),
    [anon_sym_false] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(3201),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_this] = ACTIONS(3201),
    [anon_sym_scoped] = ACTIONS(3201),
    [anon_sym_base] = ACTIONS(3201),
    [anon_sym_var] = ACTIONS(3201),
    [sym_predefined_type] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_unchecked] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_do] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_lock] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_switch] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_throw] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [anon_sym_when] = ACTIONS(3201),
    [anon_sym_await] = ACTIONS(3201),
    [anon_sym_foreach] = ACTIONS(3201),
    [anon_sym_goto] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_else] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_from] = ACTIONS(3201),
    [anon_sym_into] = ACTIONS(3201),
    [anon_sym_join] = ACTIONS(3201),
    [anon_sym_on] = ACTIONS(3201),
    [anon_sym_equals] = ACTIONS(3201),
    [anon_sym_let] = ACTIONS(3201),
    [anon_sym_orderby] = ACTIONS(3201),
    [anon_sym_ascending] = ACTIONS(3201),
    [anon_sym_descending] = ACTIONS(3201),
    [anon_sym_group] = ACTIONS(3201),
    [anon_sym_by] = ACTIONS(3201),
    [anon_sym_select] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3201),
    [anon_sym_sizeof] = ACTIONS(3201),
    [anon_sym_typeof] = ACTIONS(3201),
    [anon_sym___makeref] = ACTIONS(3201),
    [anon_sym___reftype] = ACTIONS(3201),
    [anon_sym___refvalue] = ACTIONS(3201),
    [sym_null_literal] = ACTIONS(3201),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3201),
    [sym_real_literal] = ACTIONS(3203),
    [sym_verbatim_string_literal] = ACTIONS(3203),
    [aux_sym_preproc_if_token1] = ACTIONS(3203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3203),
    [sym_interpolation_verbatim_start] = ACTIONS(3203),
    [sym_interpolation_raw_start] = ACTIONS(3203),
    [sym_raw_string_start] = ACTIONS(3203),
  },
  [2455] = {
    [sym_preproc_region] = STATE(2455),
    [sym_preproc_endregion] = STATE(2455),
    [sym_preproc_line] = STATE(2455),
    [sym_preproc_pragma] = STATE(2455),
    [sym_preproc_nullable] = STATE(2455),
    [sym_preproc_error] = STATE(2455),
    [sym_preproc_define] = STATE(2455),
    [sym_preproc_undef] = STATE(2455),
    [ts_builtin_sym_end] = ACTIONS(3275),
    [sym__identifier_token] = ACTIONS(3273),
    [anon_sym_extern] = ACTIONS(3273),
    [anon_sym_alias] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_global] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_unsafe] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_namespace] = ACTIONS(3273),
    [anon_sym_class] = ACTIONS(3273),
    [anon_sym_ref] = ACTIONS(3273),
    [anon_sym_struct] = ACTIONS(3273),
    [anon_sym_enum] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_interface] = ACTIONS(3273),
    [anon_sym_delegate] = ACTIONS(3273),
    [anon_sym_record] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_file] = ACTIONS(3273),
    [anon_sym_fixed] = ACTIONS(3273),
    [anon_sym_internal] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_partial] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_required] = ACTIONS(3273),
    [anon_sym_sealed] = ACTIONS(3273),
    [anon_sym_virtual] = ACTIONS(3273),
    [anon_sym_volatile] = ACTIONS(3273),
    [anon_sym_where] = ACTIONS(3273),
    [anon_sym_notnull] = ACTIONS(3273),
    [anon_sym_unmanaged] = ACTIONS(3273),
    [anon_sym_checked] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [anon_sym_true] = ACTIONS(3273),
    [anon_sym_false] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3275),
    [anon_sym_CARET] = ACTIONS(3275),
    [anon_sym_AMP] = ACTIONS(3275),
    [anon_sym_this] = ACTIONS(3273),
    [anon_sym_scoped] = ACTIONS(3273),
    [anon_sym_base] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [sym_predefined_type] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_unchecked] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_lock] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_when] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_foreach] = ACTIONS(3273),
    [anon_sym_goto] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_DOT_DOT] = ACTIONS(3275),
    [anon_sym_from] = ACTIONS(3273),
    [anon_sym_into] = ACTIONS(3273),
    [anon_sym_join] = ACTIONS(3273),
    [anon_sym_on] = ACTIONS(3273),
    [anon_sym_equals] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_orderby] = ACTIONS(3273),
    [anon_sym_ascending] = ACTIONS(3273),
    [anon_sym_descending] = ACTIONS(3273),
    [anon_sym_group] = ACTIONS(3273),
    [anon_sym_by] = ACTIONS(3273),
    [anon_sym_select] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3273),
    [anon_sym_sizeof] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym___makeref] = ACTIONS(3273),
    [anon_sym___reftype] = ACTIONS(3273),
    [anon_sym___refvalue] = ACTIONS(3273),
    [sym_null_literal] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [sym_integer_literal] = ACTIONS(3273),
    [sym_real_literal] = ACTIONS(3275),
    [sym_verbatim_string_literal] = ACTIONS(3275),
    [aux_sym_preproc_if_token1] = ACTIONS(3275),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3275),
    [sym_interpolation_verbatim_start] = ACTIONS(3275),
    [sym_interpolation_raw_start] = ACTIONS(3275),
    [sym_raw_string_start] = ACTIONS(3275),
  },
  [2456] = {
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7320),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6812),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2456),
    [sym_preproc_endregion] = STATE(2456),
    [sym_preproc_line] = STATE(2456),
    [sym_preproc_pragma] = STATE(2456),
    [sym_preproc_nullable] = STATE(2456),
    [sym_preproc_error] = STATE(2456),
    [sym_preproc_define] = STATE(2456),
    [sym_preproc_undef] = STATE(2456),
    [sym__identifier_token] = ACTIONS(3985),
    [anon_sym_alias] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3995),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3988),
    [anon_sym_unmanaged] = ACTIONS(3988),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4002),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4005),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3988),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3988),
    [anon_sym_into] = ACTIONS(3988),
    [anon_sym_join] = ACTIONS(3988),
    [anon_sym_on] = ACTIONS(3988),
    [anon_sym_equals] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_orderby] = ACTIONS(3988),
    [anon_sym_ascending] = ACTIONS(3988),
    [anon_sym_descending] = ACTIONS(3988),
    [anon_sym_group] = ACTIONS(3988),
    [anon_sym_by] = ACTIONS(3988),
    [anon_sym_select] = ACTIONS(3988),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2457] = {
    [sym_preproc_region] = STATE(2457),
    [sym_preproc_endregion] = STATE(2457),
    [sym_preproc_line] = STATE(2457),
    [sym_preproc_pragma] = STATE(2457),
    [sym_preproc_nullable] = STATE(2457),
    [sym_preproc_error] = STATE(2457),
    [sym_preproc_define] = STATE(2457),
    [sym_preproc_undef] = STATE(2457),
    [ts_builtin_sym_end] = ACTIONS(3185),
    [sym__identifier_token] = ACTIONS(3183),
    [anon_sym_extern] = ACTIONS(3183),
    [anon_sym_alias] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_global] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_unsafe] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_namespace] = ACTIONS(3183),
    [anon_sym_class] = ACTIONS(3183),
    [anon_sym_ref] = ACTIONS(3183),
    [anon_sym_struct] = ACTIONS(3183),
    [anon_sym_enum] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_interface] = ACTIONS(3183),
    [anon_sym_delegate] = ACTIONS(3183),
    [anon_sym_record] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_file] = ACTIONS(3183),
    [anon_sym_fixed] = ACTIONS(3183),
    [anon_sym_internal] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_partial] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_required] = ACTIONS(3183),
    [anon_sym_sealed] = ACTIONS(3183),
    [anon_sym_virtual] = ACTIONS(3183),
    [anon_sym_volatile] = ACTIONS(3183),
    [anon_sym_where] = ACTIONS(3183),
    [anon_sym_notnull] = ACTIONS(3183),
    [anon_sym_unmanaged] = ACTIONS(3183),
    [anon_sym_checked] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_true] = ACTIONS(3183),
    [anon_sym_false] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_STAR] = ACTIONS(3185),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3185),
    [anon_sym_this] = ACTIONS(3183),
    [anon_sym_scoped] = ACTIONS(3183),
    [anon_sym_base] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [sym_predefined_type] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_unchecked] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_lock] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_when] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_foreach] = ACTIONS(3183),
    [anon_sym_goto] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(4008),
    [anon_sym_DOT_DOT] = ACTIONS(3185),
    [anon_sym_from] = ACTIONS(3183),
    [anon_sym_into] = ACTIONS(3183),
    [anon_sym_join] = ACTIONS(3183),
    [anon_sym_on] = ACTIONS(3183),
    [anon_sym_equals] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_orderby] = ACTIONS(3183),
    [anon_sym_ascending] = ACTIONS(3183),
    [anon_sym_descending] = ACTIONS(3183),
    [anon_sym_group] = ACTIONS(3183),
    [anon_sym_by] = ACTIONS(3183),
    [anon_sym_select] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3183),
    [anon_sym_sizeof] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym___makeref] = ACTIONS(3183),
    [anon_sym___reftype] = ACTIONS(3183),
    [anon_sym___refvalue] = ACTIONS(3183),
    [sym_null_literal] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [sym_integer_literal] = ACTIONS(3183),
    [sym_real_literal] = ACTIONS(3185),
    [sym_verbatim_string_literal] = ACTIONS(3185),
    [aux_sym_preproc_if_token1] = ACTIONS(3185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3185),
    [sym_interpolation_verbatim_start] = ACTIONS(3185),
    [sym_interpolation_raw_start] = ACTIONS(3185),
    [sym_raw_string_start] = ACTIONS(3185),
  },
  [2458] = {
    [sym_preproc_region] = STATE(2458),
    [sym_preproc_endregion] = STATE(2458),
    [sym_preproc_line] = STATE(2458),
    [sym_preproc_pragma] = STATE(2458),
    [sym_preproc_nullable] = STATE(2458),
    [sym_preproc_error] = STATE(2458),
    [sym_preproc_define] = STATE(2458),
    [sym_preproc_undef] = STATE(2458),
    [ts_builtin_sym_end] = ACTIONS(3109),
    [sym__identifier_token] = ACTIONS(3107),
    [anon_sym_extern] = ACTIONS(3107),
    [anon_sym_alias] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_global] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_ref] = ACTIONS(3107),
    [anon_sym_struct] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_interface] = ACTIONS(3107),
    [anon_sym_delegate] = ACTIONS(3107),
    [anon_sym_record] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_file] = ACTIONS(3107),
    [anon_sym_fixed] = ACTIONS(3107),
    [anon_sym_internal] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_partial] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_required] = ACTIONS(3107),
    [anon_sym_sealed] = ACTIONS(3107),
    [anon_sym_virtual] = ACTIONS(3107),
    [anon_sym_volatile] = ACTIONS(3107),
    [anon_sym_where] = ACTIONS(3107),
    [anon_sym_notnull] = ACTIONS(3107),
    [anon_sym_unmanaged] = ACTIONS(3107),
    [anon_sym_checked] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_true] = ACTIONS(3107),
    [anon_sym_false] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_this] = ACTIONS(3107),
    [anon_sym_scoped] = ACTIONS(3107),
    [anon_sym_base] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [sym_predefined_type] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_unchecked] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_lock] = ACTIONS(3107),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_when] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_foreach] = ACTIONS(3107),
    [anon_sym_goto] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_from] = ACTIONS(3107),
    [anon_sym_into] = ACTIONS(3107),
    [anon_sym_join] = ACTIONS(3107),
    [anon_sym_on] = ACTIONS(3107),
    [anon_sym_equals] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_orderby] = ACTIONS(3107),
    [anon_sym_ascending] = ACTIONS(3107),
    [anon_sym_descending] = ACTIONS(3107),
    [anon_sym_group] = ACTIONS(3107),
    [anon_sym_by] = ACTIONS(3107),
    [anon_sym_select] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym___makeref] = ACTIONS(3107),
    [anon_sym___reftype] = ACTIONS(3107),
    [anon_sym___refvalue] = ACTIONS(3107),
    [sym_null_literal] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [sym_integer_literal] = ACTIONS(3107),
    [sym_real_literal] = ACTIONS(3109),
    [sym_verbatim_string_literal] = ACTIONS(3109),
    [aux_sym_preproc_if_token1] = ACTIONS(3109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3109),
    [sym_interpolation_verbatim_start] = ACTIONS(3109),
    [sym_interpolation_raw_start] = ACTIONS(3109),
    [sym_raw_string_start] = ACTIONS(3109),
  },
  [2459] = {
    [sym_preproc_region] = STATE(2459),
    [sym_preproc_endregion] = STATE(2459),
    [sym_preproc_line] = STATE(2459),
    [sym_preproc_pragma] = STATE(2459),
    [sym_preproc_nullable] = STATE(2459),
    [sym_preproc_error] = STATE(2459),
    [sym_preproc_define] = STATE(2459),
    [sym_preproc_undef] = STATE(2459),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [sym__identifier_token] = ACTIONS(3285),
    [anon_sym_extern] = ACTIONS(3285),
    [anon_sym_alias] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_unsafe] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_ref] = ACTIONS(3285),
    [anon_sym_struct] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_delegate] = ACTIONS(3285),
    [anon_sym_record] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_file] = ACTIONS(3285),
    [anon_sym_fixed] = ACTIONS(3285),
    [anon_sym_internal] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_partial] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_required] = ACTIONS(3285),
    [anon_sym_sealed] = ACTIONS(3285),
    [anon_sym_virtual] = ACTIONS(3285),
    [anon_sym_volatile] = ACTIONS(3285),
    [anon_sym_where] = ACTIONS(3285),
    [anon_sym_notnull] = ACTIONS(3285),
    [anon_sym_unmanaged] = ACTIONS(3285),
    [anon_sym_checked] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_true] = ACTIONS(3285),
    [anon_sym_false] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_CARET] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym_this] = ACTIONS(3285),
    [anon_sym_scoped] = ACTIONS(3285),
    [anon_sym_base] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [sym_predefined_type] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_unchecked] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_lock] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_when] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_foreach] = ACTIONS(3285),
    [anon_sym_goto] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_from] = ACTIONS(3285),
    [anon_sym_into] = ACTIONS(3285),
    [anon_sym_join] = ACTIONS(3285),
    [anon_sym_on] = ACTIONS(3285),
    [anon_sym_equals] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_orderby] = ACTIONS(3285),
    [anon_sym_ascending] = ACTIONS(3285),
    [anon_sym_descending] = ACTIONS(3285),
    [anon_sym_group] = ACTIONS(3285),
    [anon_sym_by] = ACTIONS(3285),
    [anon_sym_select] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3285),
    [anon_sym_sizeof] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym___makeref] = ACTIONS(3285),
    [anon_sym___reftype] = ACTIONS(3285),
    [anon_sym___refvalue] = ACTIONS(3285),
    [sym_null_literal] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [sym_integer_literal] = ACTIONS(3285),
    [sym_real_literal] = ACTIONS(3287),
    [sym_verbatim_string_literal] = ACTIONS(3287),
    [aux_sym_preproc_if_token1] = ACTIONS(3287),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3287),
    [sym_interpolation_verbatim_start] = ACTIONS(3287),
    [sym_interpolation_raw_start] = ACTIONS(3287),
    [sym_raw_string_start] = ACTIONS(3287),
  },
  [2460] = {
    [sym_preproc_region] = STATE(2460),
    [sym_preproc_endregion] = STATE(2460),
    [sym_preproc_line] = STATE(2460),
    [sym_preproc_pragma] = STATE(2460),
    [sym_preproc_nullable] = STATE(2460),
    [sym_preproc_error] = STATE(2460),
    [sym_preproc_define] = STATE(2460),
    [sym_preproc_undef] = STATE(2460),
    [ts_builtin_sym_end] = ACTIONS(3173),
    [sym__identifier_token] = ACTIONS(3171),
    [anon_sym_extern] = ACTIONS(3171),
    [anon_sym_alias] = ACTIONS(3171),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_global] = ACTIONS(3171),
    [anon_sym_using] = ACTIONS(3171),
    [anon_sym_unsafe] = ACTIONS(3171),
    [anon_sym_static] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_namespace] = ACTIONS(3171),
    [anon_sym_class] = ACTIONS(3171),
    [anon_sym_ref] = ACTIONS(3171),
    [anon_sym_struct] = ACTIONS(3171),
    [anon_sym_enum] = ACTIONS(3171),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_interface] = ACTIONS(3171),
    [anon_sym_delegate] = ACTIONS(3171),
    [anon_sym_record] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_file] = ACTIONS(3171),
    [anon_sym_fixed] = ACTIONS(3171),
    [anon_sym_internal] = ACTIONS(3171),
    [anon_sym_new] = ACTIONS(3171),
    [anon_sym_override] = ACTIONS(3171),
    [anon_sym_partial] = ACTIONS(3171),
    [anon_sym_private] = ACTIONS(3171),
    [anon_sym_protected] = ACTIONS(3171),
    [anon_sym_public] = ACTIONS(3171),
    [anon_sym_readonly] = ACTIONS(3171),
    [anon_sym_required] = ACTIONS(3171),
    [anon_sym_sealed] = ACTIONS(3171),
    [anon_sym_virtual] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_where] = ACTIONS(3171),
    [anon_sym_notnull] = ACTIONS(3171),
    [anon_sym_unmanaged] = ACTIONS(3171),
    [anon_sym_checked] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_true] = ACTIONS(3171),
    [anon_sym_false] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_DASH] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_AMP] = ACTIONS(3173),
    [anon_sym_this] = ACTIONS(3171),
    [anon_sym_scoped] = ACTIONS(3171),
    [anon_sym_base] = ACTIONS(3171),
    [anon_sym_var] = ACTIONS(3171),
    [sym_predefined_type] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_unchecked] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_lock] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_switch] = ACTIONS(3171),
    [anon_sym_default] = ACTIONS(3171),
    [anon_sym_throw] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_when] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3171),
    [anon_sym_foreach] = ACTIONS(3171),
    [anon_sym_goto] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_else] = ACTIONS(3171),
    [anon_sym_DOT_DOT] = ACTIONS(3173),
    [anon_sym_from] = ACTIONS(3171),
    [anon_sym_into] = ACTIONS(3171),
    [anon_sym_join] = ACTIONS(3171),
    [anon_sym_on] = ACTIONS(3171),
    [anon_sym_equals] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_orderby] = ACTIONS(3171),
    [anon_sym_ascending] = ACTIONS(3171),
    [anon_sym_descending] = ACTIONS(3171),
    [anon_sym_group] = ACTIONS(3171),
    [anon_sym_by] = ACTIONS(3171),
    [anon_sym_select] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3171),
    [anon_sym_sizeof] = ACTIONS(3171),
    [anon_sym_typeof] = ACTIONS(3171),
    [anon_sym___makeref] = ACTIONS(3171),
    [anon_sym___reftype] = ACTIONS(3171),
    [anon_sym___refvalue] = ACTIONS(3171),
    [sym_null_literal] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3173),
    [sym_integer_literal] = ACTIONS(3171),
    [sym_real_literal] = ACTIONS(3173),
    [sym_verbatim_string_literal] = ACTIONS(3173),
    [aux_sym_preproc_if_token1] = ACTIONS(3173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3173),
    [sym_interpolation_verbatim_start] = ACTIONS(3173),
    [sym_interpolation_raw_start] = ACTIONS(3173),
    [sym_raw_string_start] = ACTIONS(3173),
  },
  [2461] = {
    [sym_preproc_region] = STATE(2461),
    [sym_preproc_endregion] = STATE(2461),
    [sym_preproc_line] = STATE(2461),
    [sym_preproc_pragma] = STATE(2461),
    [sym_preproc_nullable] = STATE(2461),
    [sym_preproc_error] = STATE(2461),
    [sym_preproc_define] = STATE(2461),
    [sym_preproc_undef] = STATE(2461),
    [ts_builtin_sym_end] = ACTIONS(3101),
    [sym__identifier_token] = ACTIONS(3099),
    [anon_sym_extern] = ACTIONS(3099),
    [anon_sym_alias] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_global] = ACTIONS(3099),
    [anon_sym_using] = ACTIONS(3099),
    [anon_sym_unsafe] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_class] = ACTIONS(3099),
    [anon_sym_ref] = ACTIONS(3099),
    [anon_sym_struct] = ACTIONS(3099),
    [anon_sym_enum] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_interface] = ACTIONS(3099),
    [anon_sym_delegate] = ACTIONS(3099),
    [anon_sym_record] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_file] = ACTIONS(3099),
    [anon_sym_fixed] = ACTIONS(3099),
    [anon_sym_internal] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_partial] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_required] = ACTIONS(3099),
    [anon_sym_sealed] = ACTIONS(3099),
    [anon_sym_virtual] = ACTIONS(3099),
    [anon_sym_volatile] = ACTIONS(3099),
    [anon_sym_where] = ACTIONS(3099),
    [anon_sym_notnull] = ACTIONS(3099),
    [anon_sym_unmanaged] = ACTIONS(3099),
    [anon_sym_checked] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_true] = ACTIONS(3099),
    [anon_sym_false] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_this] = ACTIONS(3099),
    [anon_sym_scoped] = ACTIONS(3099),
    [anon_sym_base] = ACTIONS(3099),
    [anon_sym_var] = ACTIONS(3099),
    [sym_predefined_type] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_unchecked] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_lock] = ACTIONS(3099),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_when] = ACTIONS(3099),
    [anon_sym_await] = ACTIONS(3099),
    [anon_sym_foreach] = ACTIONS(3099),
    [anon_sym_goto] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3099),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_from] = ACTIONS(3099),
    [anon_sym_into] = ACTIONS(3099),
    [anon_sym_join] = ACTIONS(3099),
    [anon_sym_on] = ACTIONS(3099),
    [anon_sym_equals] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_orderby] = ACTIONS(3099),
    [anon_sym_ascending] = ACTIONS(3099),
    [anon_sym_descending] = ACTIONS(3099),
    [anon_sym_group] = ACTIONS(3099),
    [anon_sym_by] = ACTIONS(3099),
    [anon_sym_select] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3099),
    [anon_sym_sizeof] = ACTIONS(3099),
    [anon_sym_typeof] = ACTIONS(3099),
    [anon_sym___makeref] = ACTIONS(3099),
    [anon_sym___reftype] = ACTIONS(3099),
    [anon_sym___refvalue] = ACTIONS(3099),
    [sym_null_literal] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [sym_integer_literal] = ACTIONS(3099),
    [sym_real_literal] = ACTIONS(3101),
    [sym_verbatim_string_literal] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3101),
    [sym_interpolation_verbatim_start] = ACTIONS(3101),
    [sym_interpolation_raw_start] = ACTIONS(3101),
    [sym_raw_string_start] = ACTIONS(3101),
  },
  [2462] = {
    [sym_preproc_region] = STATE(2462),
    [sym_preproc_endregion] = STATE(2462),
    [sym_preproc_line] = STATE(2462),
    [sym_preproc_pragma] = STATE(2462),
    [sym_preproc_nullable] = STATE(2462),
    [sym_preproc_error] = STATE(2462),
    [sym_preproc_define] = STATE(2462),
    [sym_preproc_undef] = STATE(2462),
    [ts_builtin_sym_end] = ACTIONS(3211),
    [sym__identifier_token] = ACTIONS(3209),
    [anon_sym_extern] = ACTIONS(3209),
    [anon_sym_alias] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_global] = ACTIONS(3209),
    [anon_sym_using] = ACTIONS(3209),
    [anon_sym_unsafe] = ACTIONS(3209),
    [anon_sym_static] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3209),
    [anon_sym_namespace] = ACTIONS(3209),
    [anon_sym_class] = ACTIONS(3209),
    [anon_sym_ref] = ACTIONS(3209),
    [anon_sym_struct] = ACTIONS(3209),
    [anon_sym_enum] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_interface] = ACTIONS(3209),
    [anon_sym_delegate] = ACTIONS(3209),
    [anon_sym_record] = ACTIONS(3209),
    [anon_sym_abstract] = ACTIONS(3209),
    [anon_sym_async] = ACTIONS(3209),
    [anon_sym_const] = ACTIONS(3209),
    [anon_sym_file] = ACTIONS(3209),
    [anon_sym_fixed] = ACTIONS(3209),
    [anon_sym_internal] = ACTIONS(3209),
    [anon_sym_new] = ACTIONS(3209),
    [anon_sym_override] = ACTIONS(3209),
    [anon_sym_partial] = ACTIONS(3209),
    [anon_sym_private] = ACTIONS(3209),
    [anon_sym_protected] = ACTIONS(3209),
    [anon_sym_public] = ACTIONS(3209),
    [anon_sym_readonly] = ACTIONS(3209),
    [anon_sym_required] = ACTIONS(3209),
    [anon_sym_sealed] = ACTIONS(3209),
    [anon_sym_virtual] = ACTIONS(3209),
    [anon_sym_volatile] = ACTIONS(3209),
    [anon_sym_where] = ACTIONS(3209),
    [anon_sym_notnull] = ACTIONS(3209),
    [anon_sym_unmanaged] = ACTIONS(3209),
    [anon_sym_checked] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_true] = ACTIONS(3209),
    [anon_sym_false] = ACTIONS(3209),
    [anon_sym_PLUS] = ACTIONS(3209),
    [anon_sym_DASH] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_CARET] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3211),
    [anon_sym_this] = ACTIONS(3209),
    [anon_sym_scoped] = ACTIONS(3209),
    [anon_sym_base] = ACTIONS(3209),
    [anon_sym_var] = ACTIONS(3209),
    [sym_predefined_type] = ACTIONS(3209),
    [anon_sym_break] = ACTIONS(3209),
    [anon_sym_unchecked] = ACTIONS(3209),
    [anon_sym_continue] = ACTIONS(3209),
    [anon_sym_do] = ACTIONS(3209),
    [anon_sym_while] = ACTIONS(3209),
    [anon_sym_for] = ACTIONS(3209),
    [anon_sym_lock] = ACTIONS(3209),
    [anon_sym_yield] = ACTIONS(3209),
    [anon_sym_switch] = ACTIONS(3209),
    [anon_sym_default] = ACTIONS(3209),
    [anon_sym_throw] = ACTIONS(3209),
    [anon_sym_try] = ACTIONS(3209),
    [anon_sym_when] = ACTIONS(3209),
    [anon_sym_await] = ACTIONS(3209),
    [anon_sym_foreach] = ACTIONS(3209),
    [anon_sym_goto] = ACTIONS(3209),
    [anon_sym_if] = ACTIONS(3209),
    [anon_sym_else] = ACTIONS(3209),
    [anon_sym_DOT_DOT] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3209),
    [anon_sym_into] = ACTIONS(3209),
    [anon_sym_join] = ACTIONS(3209),
    [anon_sym_on] = ACTIONS(3209),
    [anon_sym_equals] = ACTIONS(3209),
    [anon_sym_let] = ACTIONS(3209),
    [anon_sym_orderby] = ACTIONS(3209),
    [anon_sym_ascending] = ACTIONS(3209),
    [anon_sym_descending] = ACTIONS(3209),
    [anon_sym_group] = ACTIONS(3209),
    [anon_sym_by] = ACTIONS(3209),
    [anon_sym_select] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3209),
    [anon_sym_sizeof] = ACTIONS(3209),
    [anon_sym_typeof] = ACTIONS(3209),
    [anon_sym___makeref] = ACTIONS(3209),
    [anon_sym___reftype] = ACTIONS(3209),
    [anon_sym___refvalue] = ACTIONS(3209),
    [sym_null_literal] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [sym_integer_literal] = ACTIONS(3209),
    [sym_real_literal] = ACTIONS(3211),
    [sym_verbatim_string_literal] = ACTIONS(3211),
    [aux_sym_preproc_if_token1] = ACTIONS(3211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3211),
    [sym_interpolation_verbatim_start] = ACTIONS(3211),
    [sym_interpolation_raw_start] = ACTIONS(3211),
    [sym_raw_string_start] = ACTIONS(3211),
  },
  [2463] = {
    [sym_preproc_region] = STATE(2463),
    [sym_preproc_endregion] = STATE(2463),
    [sym_preproc_line] = STATE(2463),
    [sym_preproc_pragma] = STATE(2463),
    [sym_preproc_nullable] = STATE(2463),
    [sym_preproc_error] = STATE(2463),
    [sym_preproc_define] = STATE(2463),
    [sym_preproc_undef] = STATE(2463),
    [ts_builtin_sym_end] = ACTIONS(3279),
    [sym__identifier_token] = ACTIONS(3277),
    [anon_sym_extern] = ACTIONS(3277),
    [anon_sym_alias] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_global] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_unsafe] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_namespace] = ACTIONS(3277),
    [anon_sym_class] = ACTIONS(3277),
    [anon_sym_ref] = ACTIONS(3277),
    [anon_sym_struct] = ACTIONS(3277),
    [anon_sym_enum] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_interface] = ACTIONS(3277),
    [anon_sym_delegate] = ACTIONS(3277),
    [anon_sym_record] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_file] = ACTIONS(3277),
    [anon_sym_fixed] = ACTIONS(3277),
    [anon_sym_internal] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_partial] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_required] = ACTIONS(3277),
    [anon_sym_sealed] = ACTIONS(3277),
    [anon_sym_virtual] = ACTIONS(3277),
    [anon_sym_volatile] = ACTIONS(3277),
    [anon_sym_where] = ACTIONS(3277),
    [anon_sym_notnull] = ACTIONS(3277),
    [anon_sym_unmanaged] = ACTIONS(3277),
    [anon_sym_checked] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(3277),
    [anon_sym_false] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_STAR] = ACTIONS(3279),
    [anon_sym_CARET] = ACTIONS(3279),
    [anon_sym_AMP] = ACTIONS(3279),
    [anon_sym_this] = ACTIONS(3277),
    [anon_sym_scoped] = ACTIONS(3277),
    [anon_sym_base] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [sym_predefined_type] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_unchecked] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_lock] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_when] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_foreach] = ACTIONS(3277),
    [anon_sym_goto] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_DOT_DOT] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3277),
    [anon_sym_into] = ACTIONS(3277),
    [anon_sym_join] = ACTIONS(3277),
    [anon_sym_on] = ACTIONS(3277),
    [anon_sym_equals] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_orderby] = ACTIONS(3277),
    [anon_sym_ascending] = ACTIONS(3277),
    [anon_sym_descending] = ACTIONS(3277),
    [anon_sym_group] = ACTIONS(3277),
    [anon_sym_by] = ACTIONS(3277),
    [anon_sym_select] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3277),
    [anon_sym_sizeof] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym___makeref] = ACTIONS(3277),
    [anon_sym___reftype] = ACTIONS(3277),
    [anon_sym___refvalue] = ACTIONS(3277),
    [sym_null_literal] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [sym_integer_literal] = ACTIONS(3277),
    [sym_real_literal] = ACTIONS(3279),
    [sym_verbatim_string_literal] = ACTIONS(3279),
    [aux_sym_preproc_if_token1] = ACTIONS(3279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3279),
    [sym_interpolation_verbatim_start] = ACTIONS(3279),
    [sym_interpolation_raw_start] = ACTIONS(3279),
    [sym_raw_string_start] = ACTIONS(3279),
  },
  [2464] = {
    [sym_preproc_region] = STATE(2464),
    [sym_preproc_endregion] = STATE(2464),
    [sym_preproc_line] = STATE(2464),
    [sym_preproc_pragma] = STATE(2464),
    [sym_preproc_nullable] = STATE(2464),
    [sym_preproc_error] = STATE(2464),
    [sym_preproc_define] = STATE(2464),
    [sym_preproc_undef] = STATE(2464),
    [ts_builtin_sym_end] = ACTIONS(3347),
    [sym__identifier_token] = ACTIONS(3345),
    [anon_sym_extern] = ACTIONS(3345),
    [anon_sym_alias] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_global] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_unsafe] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_namespace] = ACTIONS(3345),
    [anon_sym_class] = ACTIONS(3345),
    [anon_sym_ref] = ACTIONS(3345),
    [anon_sym_struct] = ACTIONS(3345),
    [anon_sym_enum] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_interface] = ACTIONS(3345),
    [anon_sym_delegate] = ACTIONS(3345),
    [anon_sym_record] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_file] = ACTIONS(3345),
    [anon_sym_fixed] = ACTIONS(3345),
    [anon_sym_internal] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_partial] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_required] = ACTIONS(3345),
    [anon_sym_sealed] = ACTIONS(3345),
    [anon_sym_virtual] = ACTIONS(3345),
    [anon_sym_volatile] = ACTIONS(3345),
    [anon_sym_where] = ACTIONS(3345),
    [anon_sym_notnull] = ACTIONS(3345),
    [anon_sym_unmanaged] = ACTIONS(3345),
    [anon_sym_checked] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [anon_sym_true] = ACTIONS(3345),
    [anon_sym_false] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_CARET] = ACTIONS(3347),
    [anon_sym_AMP] = ACTIONS(3347),
    [anon_sym_this] = ACTIONS(3345),
    [anon_sym_scoped] = ACTIONS(3345),
    [anon_sym_base] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [sym_predefined_type] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_unchecked] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_lock] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_when] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_foreach] = ACTIONS(3345),
    [anon_sym_goto] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_DOT_DOT] = ACTIONS(3347),
    [anon_sym_from] = ACTIONS(3345),
    [anon_sym_into] = ACTIONS(3345),
    [anon_sym_join] = ACTIONS(3345),
    [anon_sym_on] = ACTIONS(3345),
    [anon_sym_equals] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_orderby] = ACTIONS(3345),
    [anon_sym_ascending] = ACTIONS(3345),
    [anon_sym_descending] = ACTIONS(3345),
    [anon_sym_group] = ACTIONS(3345),
    [anon_sym_by] = ACTIONS(3345),
    [anon_sym_select] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3345),
    [anon_sym_sizeof] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym___makeref] = ACTIONS(3345),
    [anon_sym___reftype] = ACTIONS(3345),
    [anon_sym___refvalue] = ACTIONS(3345),
    [sym_null_literal] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [sym_integer_literal] = ACTIONS(3345),
    [sym_real_literal] = ACTIONS(3347),
    [sym_verbatim_string_literal] = ACTIONS(3347),
    [aux_sym_preproc_if_token1] = ACTIONS(3347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3347),
    [sym_interpolation_verbatim_start] = ACTIONS(3347),
    [sym_interpolation_raw_start] = ACTIONS(3347),
    [sym_raw_string_start] = ACTIONS(3347),
  },
  [2465] = {
    [sym_preproc_region] = STATE(2465),
    [sym_preproc_endregion] = STATE(2465),
    [sym_preproc_line] = STATE(2465),
    [sym_preproc_pragma] = STATE(2465),
    [sym_preproc_nullable] = STATE(2465),
    [sym_preproc_error] = STATE(2465),
    [sym_preproc_define] = STATE(2465),
    [sym_preproc_undef] = STATE(2465),
    [ts_builtin_sym_end] = ACTIONS(3049),
    [sym__identifier_token] = ACTIONS(3047),
    [anon_sym_extern] = ACTIONS(3047),
    [anon_sym_alias] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_global] = ACTIONS(3047),
    [anon_sym_using] = ACTIONS(3047),
    [anon_sym_unsafe] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_namespace] = ACTIONS(3047),
    [anon_sym_class] = ACTIONS(3047),
    [anon_sym_ref] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3047),
    [anon_sym_enum] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3047),
    [anon_sym_delegate] = ACTIONS(3047),
    [anon_sym_record] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_async] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_file] = ACTIONS(3047),
    [anon_sym_fixed] = ACTIONS(3047),
    [anon_sym_internal] = ACTIONS(3047),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_override] = ACTIONS(3047),
    [anon_sym_partial] = ACTIONS(3047),
    [anon_sym_private] = ACTIONS(3047),
    [anon_sym_protected] = ACTIONS(3047),
    [anon_sym_public] = ACTIONS(3047),
    [anon_sym_readonly] = ACTIONS(3047),
    [anon_sym_required] = ACTIONS(3047),
    [anon_sym_sealed] = ACTIONS(3047),
    [anon_sym_virtual] = ACTIONS(3047),
    [anon_sym_volatile] = ACTIONS(3047),
    [anon_sym_where] = ACTIONS(3047),
    [anon_sym_notnull] = ACTIONS(3047),
    [anon_sym_unmanaged] = ACTIONS(3047),
    [anon_sym_checked] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_true] = ACTIONS(3047),
    [anon_sym_false] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_this] = ACTIONS(3047),
    [anon_sym_scoped] = ACTIONS(3047),
    [anon_sym_base] = ACTIONS(3047),
    [anon_sym_var] = ACTIONS(3047),
    [sym_predefined_type] = ACTIONS(3047),
    [anon_sym_break] = ACTIONS(3047),
    [anon_sym_unchecked] = ACTIONS(3047),
    [anon_sym_continue] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_lock] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_switch] = ACTIONS(3047),
    [anon_sym_default] = ACTIONS(3047),
    [anon_sym_throw] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_when] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3047),
    [anon_sym_foreach] = ACTIONS(3047),
    [anon_sym_goto] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_from] = ACTIONS(3047),
    [anon_sym_into] = ACTIONS(3047),
    [anon_sym_join] = ACTIONS(3047),
    [anon_sym_on] = ACTIONS(3047),
    [anon_sym_equals] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_orderby] = ACTIONS(3047),
    [anon_sym_ascending] = ACTIONS(3047),
    [anon_sym_descending] = ACTIONS(3047),
    [anon_sym_group] = ACTIONS(3047),
    [anon_sym_by] = ACTIONS(3047),
    [anon_sym_select] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3047),
    [anon_sym_typeof] = ACTIONS(3047),
    [anon_sym___makeref] = ACTIONS(3047),
    [anon_sym___reftype] = ACTIONS(3047),
    [anon_sym___refvalue] = ACTIONS(3047),
    [sym_null_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_integer_literal] = ACTIONS(3047),
    [sym_real_literal] = ACTIONS(3049),
    [sym_verbatim_string_literal] = ACTIONS(3049),
    [aux_sym_preproc_if_token1] = ACTIONS(3049),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3049),
    [sym_interpolation_verbatim_start] = ACTIONS(3049),
    [sym_interpolation_raw_start] = ACTIONS(3049),
    [sym_raw_string_start] = ACTIONS(3049),
  },
  [2466] = {
    [sym_preproc_region] = STATE(2466),
    [sym_preproc_endregion] = STATE(2466),
    [sym_preproc_line] = STATE(2466),
    [sym_preproc_pragma] = STATE(2466),
    [sym_preproc_nullable] = STATE(2466),
    [sym_preproc_error] = STATE(2466),
    [sym_preproc_define] = STATE(2466),
    [sym_preproc_undef] = STATE(2466),
    [ts_builtin_sym_end] = ACTIONS(3215),
    [sym__identifier_token] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3213),
    [anon_sym_alias] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3215),
    [anon_sym_global] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3215),
    [anon_sym_LPAREN] = ACTIONS(3215),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_namespace] = ACTIONS(3213),
    [anon_sym_class] = ACTIONS(3213),
    [anon_sym_ref] = ACTIONS(3213),
    [anon_sym_struct] = ACTIONS(3213),
    [anon_sym_enum] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_interface] = ACTIONS(3213),
    [anon_sym_delegate] = ACTIONS(3213),
    [anon_sym_record] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_file] = ACTIONS(3213),
    [anon_sym_fixed] = ACTIONS(3213),
    [anon_sym_internal] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_partial] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_required] = ACTIONS(3213),
    [anon_sym_sealed] = ACTIONS(3213),
    [anon_sym_virtual] = ACTIONS(3213),
    [anon_sym_volatile] = ACTIONS(3213),
    [anon_sym_where] = ACTIONS(3213),
    [anon_sym_notnull] = ACTIONS(3213),
    [anon_sym_unmanaged] = ACTIONS(3213),
    [anon_sym_checked] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3215),
    [anon_sym_TILDE] = ACTIONS(3215),
    [anon_sym_PLUS_PLUS] = ACTIONS(3215),
    [anon_sym_DASH_DASH] = ACTIONS(3215),
    [anon_sym_true] = ACTIONS(3213),
    [anon_sym_false] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3215),
    [anon_sym_CARET] = ACTIONS(3215),
    [anon_sym_AMP] = ACTIONS(3215),
    [anon_sym_this] = ACTIONS(3213),
    [anon_sym_scoped] = ACTIONS(3213),
    [anon_sym_base] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [sym_predefined_type] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_unchecked] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_lock] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_when] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_foreach] = ACTIONS(3213),
    [anon_sym_goto] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_DOT_DOT] = ACTIONS(3215),
    [anon_sym_from] = ACTIONS(3213),
    [anon_sym_into] = ACTIONS(3213),
    [anon_sym_join] = ACTIONS(3213),
    [anon_sym_on] = ACTIONS(3213),
    [anon_sym_equals] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_orderby] = ACTIONS(3213),
    [anon_sym_ascending] = ACTIONS(3213),
    [anon_sym_descending] = ACTIONS(3213),
    [anon_sym_group] = ACTIONS(3213),
    [anon_sym_by] = ACTIONS(3213),
    [anon_sym_select] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3213),
    [anon_sym_sizeof] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym___makeref] = ACTIONS(3213),
    [anon_sym___reftype] = ACTIONS(3213),
    [anon_sym___refvalue] = ACTIONS(3213),
    [sym_null_literal] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3215),
    [sym_integer_literal] = ACTIONS(3213),
    [sym_real_literal] = ACTIONS(3215),
    [sym_verbatim_string_literal] = ACTIONS(3215),
    [aux_sym_preproc_if_token1] = ACTIONS(3215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3215),
    [sym_interpolation_verbatim_start] = ACTIONS(3215),
    [sym_interpolation_raw_start] = ACTIONS(3215),
    [sym_raw_string_start] = ACTIONS(3215),
  },
  [2467] = {
    [sym_preproc_region] = STATE(2467),
    [sym_preproc_endregion] = STATE(2467),
    [sym_preproc_line] = STATE(2467),
    [sym_preproc_pragma] = STATE(2467),
    [sym_preproc_nullable] = STATE(2467),
    [sym_preproc_error] = STATE(2467),
    [sym_preproc_define] = STATE(2467),
    [sym_preproc_undef] = STATE(2467),
    [ts_builtin_sym_end] = ACTIONS(3307),
    [sym__identifier_token] = ACTIONS(3305),
    [anon_sym_extern] = ACTIONS(3305),
    [anon_sym_alias] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_global] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_unsafe] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_namespace] = ACTIONS(3305),
    [anon_sym_class] = ACTIONS(3305),
    [anon_sym_ref] = ACTIONS(3305),
    [anon_sym_struct] = ACTIONS(3305),
    [anon_sym_enum] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_interface] = ACTIONS(3305),
    [anon_sym_delegate] = ACTIONS(3305),
    [anon_sym_record] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_file] = ACTIONS(3305),
    [anon_sym_fixed] = ACTIONS(3305),
    [anon_sym_internal] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_partial] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_required] = ACTIONS(3305),
    [anon_sym_sealed] = ACTIONS(3305),
    [anon_sym_virtual] = ACTIONS(3305),
    [anon_sym_volatile] = ACTIONS(3305),
    [anon_sym_where] = ACTIONS(3305),
    [anon_sym_notnull] = ACTIONS(3305),
    [anon_sym_unmanaged] = ACTIONS(3305),
    [anon_sym_checked] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_true] = ACTIONS(3305),
    [anon_sym_false] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_this] = ACTIONS(3305),
    [anon_sym_scoped] = ACTIONS(3305),
    [anon_sym_base] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [sym_predefined_type] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_unchecked] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_lock] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_when] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_foreach] = ACTIONS(3305),
    [anon_sym_goto] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_DOT_DOT] = ACTIONS(3307),
    [anon_sym_from] = ACTIONS(3305),
    [anon_sym_into] = ACTIONS(3305),
    [anon_sym_join] = ACTIONS(3305),
    [anon_sym_on] = ACTIONS(3305),
    [anon_sym_equals] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_orderby] = ACTIONS(3305),
    [anon_sym_ascending] = ACTIONS(3305),
    [anon_sym_descending] = ACTIONS(3305),
    [anon_sym_group] = ACTIONS(3305),
    [anon_sym_by] = ACTIONS(3305),
    [anon_sym_select] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3305),
    [anon_sym_sizeof] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym___makeref] = ACTIONS(3305),
    [anon_sym___reftype] = ACTIONS(3305),
    [anon_sym___refvalue] = ACTIONS(3305),
    [sym_null_literal] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [sym_integer_literal] = ACTIONS(3305),
    [sym_real_literal] = ACTIONS(3307),
    [sym_verbatim_string_literal] = ACTIONS(3307),
    [aux_sym_preproc_if_token1] = ACTIONS(3307),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3307),
    [sym_interpolation_verbatim_start] = ACTIONS(3307),
    [sym_interpolation_raw_start] = ACTIONS(3307),
    [sym_raw_string_start] = ACTIONS(3307),
  },
  [2468] = {
    [sym_preproc_region] = STATE(2468),
    [sym_preproc_endregion] = STATE(2468),
    [sym_preproc_line] = STATE(2468),
    [sym_preproc_pragma] = STATE(2468),
    [sym_preproc_nullable] = STATE(2468),
    [sym_preproc_error] = STATE(2468),
    [sym_preproc_define] = STATE(2468),
    [sym_preproc_undef] = STATE(2468),
    [ts_builtin_sym_end] = ACTIONS(3323),
    [sym__identifier_token] = ACTIONS(3321),
    [anon_sym_extern] = ACTIONS(3321),
    [anon_sym_alias] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_unsafe] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_namespace] = ACTIONS(3321),
    [anon_sym_class] = ACTIONS(3321),
    [anon_sym_ref] = ACTIONS(3321),
    [anon_sym_struct] = ACTIONS(3321),
    [anon_sym_enum] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_interface] = ACTIONS(3321),
    [anon_sym_delegate] = ACTIONS(3321),
    [anon_sym_record] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_file] = ACTIONS(3321),
    [anon_sym_fixed] = ACTIONS(3321),
    [anon_sym_internal] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_partial] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_required] = ACTIONS(3321),
    [anon_sym_sealed] = ACTIONS(3321),
    [anon_sym_virtual] = ACTIONS(3321),
    [anon_sym_volatile] = ACTIONS(3321),
    [anon_sym_where] = ACTIONS(3321),
    [anon_sym_notnull] = ACTIONS(3321),
    [anon_sym_unmanaged] = ACTIONS(3321),
    [anon_sym_checked] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_true] = ACTIONS(3321),
    [anon_sym_false] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_CARET] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3323),
    [anon_sym_this] = ACTIONS(3321),
    [anon_sym_scoped] = ACTIONS(3321),
    [anon_sym_base] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [sym_predefined_type] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_unchecked] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_lock] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_foreach] = ACTIONS(3321),
    [anon_sym_goto] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_DOT_DOT] = ACTIONS(3323),
    [anon_sym_from] = ACTIONS(3321),
    [anon_sym_into] = ACTIONS(3321),
    [anon_sym_join] = ACTIONS(3321),
    [anon_sym_on] = ACTIONS(3321),
    [anon_sym_equals] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_orderby] = ACTIONS(3321),
    [anon_sym_ascending] = ACTIONS(3321),
    [anon_sym_descending] = ACTIONS(3321),
    [anon_sym_group] = ACTIONS(3321),
    [anon_sym_by] = ACTIONS(3321),
    [anon_sym_select] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym___makeref] = ACTIONS(3321),
    [anon_sym___reftype] = ACTIONS(3321),
    [anon_sym___refvalue] = ACTIONS(3321),
    [sym_null_literal] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [sym_integer_literal] = ACTIONS(3321),
    [sym_real_literal] = ACTIONS(3323),
    [sym_verbatim_string_literal] = ACTIONS(3323),
    [aux_sym_preproc_if_token1] = ACTIONS(3323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3323),
    [sym_interpolation_verbatim_start] = ACTIONS(3323),
    [sym_interpolation_raw_start] = ACTIONS(3323),
    [sym_raw_string_start] = ACTIONS(3323),
  },
  [2469] = {
    [sym_preproc_region] = STATE(2469),
    [sym_preproc_endregion] = STATE(2469),
    [sym_preproc_line] = STATE(2469),
    [sym_preproc_pragma] = STATE(2469),
    [sym_preproc_nullable] = STATE(2469),
    [sym_preproc_error] = STATE(2469),
    [sym_preproc_define] = STATE(2469),
    [sym_preproc_undef] = STATE(2469),
    [ts_builtin_sym_end] = ACTIONS(3097),
    [sym__identifier_token] = ACTIONS(3095),
    [anon_sym_extern] = ACTIONS(3095),
    [anon_sym_alias] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_using] = ACTIONS(3095),
    [anon_sym_unsafe] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_class] = ACTIONS(3095),
    [anon_sym_ref] = ACTIONS(3095),
    [anon_sym_struct] = ACTIONS(3095),
    [anon_sym_enum] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_interface] = ACTIONS(3095),
    [anon_sym_delegate] = ACTIONS(3095),
    [anon_sym_record] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_file] = ACTIONS(3095),
    [anon_sym_fixed] = ACTIONS(3095),
    [anon_sym_internal] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [anon_sym_partial] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_sealed] = ACTIONS(3095),
    [anon_sym_virtual] = ACTIONS(3095),
    [anon_sym_volatile] = ACTIONS(3095),
    [anon_sym_where] = ACTIONS(3095),
    [anon_sym_notnull] = ACTIONS(3095),
    [anon_sym_unmanaged] = ACTIONS(3095),
    [anon_sym_checked] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_true] = ACTIONS(3095),
    [anon_sym_false] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_this] = ACTIONS(3095),
    [anon_sym_scoped] = ACTIONS(3095),
    [anon_sym_base] = ACTIONS(3095),
    [anon_sym_var] = ACTIONS(3095),
    [sym_predefined_type] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_unchecked] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_lock] = ACTIONS(3095),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_await] = ACTIONS(3095),
    [anon_sym_foreach] = ACTIONS(3095),
    [anon_sym_goto] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_into] = ACTIONS(3095),
    [anon_sym_join] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_equals] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_orderby] = ACTIONS(3095),
    [anon_sym_ascending] = ACTIONS(3095),
    [anon_sym_descending] = ACTIONS(3095),
    [anon_sym_group] = ACTIONS(3095),
    [anon_sym_by] = ACTIONS(3095),
    [anon_sym_select] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3095),
    [anon_sym_typeof] = ACTIONS(3095),
    [anon_sym___makeref] = ACTIONS(3095),
    [anon_sym___reftype] = ACTIONS(3095),
    [anon_sym___refvalue] = ACTIONS(3095),
    [sym_null_literal] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [sym_integer_literal] = ACTIONS(3095),
    [sym_real_literal] = ACTIONS(3097),
    [sym_verbatim_string_literal] = ACTIONS(3097),
    [aux_sym_preproc_if_token1] = ACTIONS(3097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3097),
    [sym_interpolation_verbatim_start] = ACTIONS(3097),
    [sym_interpolation_raw_start] = ACTIONS(3097),
    [sym_raw_string_start] = ACTIONS(3097),
  },
  [2470] = {
    [sym_preproc_region] = STATE(2470),
    [sym_preproc_endregion] = STATE(2470),
    [sym_preproc_line] = STATE(2470),
    [sym_preproc_pragma] = STATE(2470),
    [sym_preproc_nullable] = STATE(2470),
    [sym_preproc_error] = STATE(2470),
    [sym_preproc_define] = STATE(2470),
    [sym_preproc_undef] = STATE(2470),
    [ts_builtin_sym_end] = ACTIONS(3259),
    [sym__identifier_token] = ACTIONS(3257),
    [anon_sym_extern] = ACTIONS(3257),
    [anon_sym_alias] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_global] = ACTIONS(3257),
    [anon_sym_using] = ACTIONS(3257),
    [anon_sym_unsafe] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_namespace] = ACTIONS(3257),
    [anon_sym_class] = ACTIONS(3257),
    [anon_sym_ref] = ACTIONS(3257),
    [anon_sym_struct] = ACTIONS(3257),
    [anon_sym_enum] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [anon_sym_interface] = ACTIONS(3257),
    [anon_sym_delegate] = ACTIONS(3257),
    [anon_sym_record] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_async] = ACTIONS(3257),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_file] = ACTIONS(3257),
    [anon_sym_fixed] = ACTIONS(3257),
    [anon_sym_internal] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_partial] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_readonly] = ACTIONS(3257),
    [anon_sym_required] = ACTIONS(3257),
    [anon_sym_sealed] = ACTIONS(3257),
    [anon_sym_virtual] = ACTIONS(3257),
    [anon_sym_volatile] = ACTIONS(3257),
    [anon_sym_where] = ACTIONS(3257),
    [anon_sym_notnull] = ACTIONS(3257),
    [anon_sym_unmanaged] = ACTIONS(3257),
    [anon_sym_checked] = ACTIONS(3257),
    [anon_sym_BANG] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [anon_sym_PLUS_PLUS] = ACTIONS(3259),
    [anon_sym_DASH_DASH] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3257),
    [anon_sym_false] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_CARET] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_this] = ACTIONS(3257),
    [anon_sym_scoped] = ACTIONS(3257),
    [anon_sym_base] = ACTIONS(3257),
    [anon_sym_var] = ACTIONS(3257),
    [sym_predefined_type] = ACTIONS(3257),
    [anon_sym_break] = ACTIONS(3257),
    [anon_sym_unchecked] = ACTIONS(3257),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_lock] = ACTIONS(3257),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_switch] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_throw] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_when] = ACTIONS(3257),
    [anon_sym_await] = ACTIONS(3257),
    [anon_sym_foreach] = ACTIONS(3257),
    [anon_sym_goto] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_else] = ACTIONS(3257),
    [anon_sym_DOT_DOT] = ACTIONS(3259),
    [anon_sym_from] = ACTIONS(3257),
    [anon_sym_into] = ACTIONS(3257),
    [anon_sym_join] = ACTIONS(3257),
    [anon_sym_on] = ACTIONS(3257),
    [anon_sym_equals] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_orderby] = ACTIONS(3257),
    [anon_sym_ascending] = ACTIONS(3257),
    [anon_sym_descending] = ACTIONS(3257),
    [anon_sym_group] = ACTIONS(3257),
    [anon_sym_by] = ACTIONS(3257),
    [anon_sym_select] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3257),
    [anon_sym_sizeof] = ACTIONS(3257),
    [anon_sym_typeof] = ACTIONS(3257),
    [anon_sym___makeref] = ACTIONS(3257),
    [anon_sym___reftype] = ACTIONS(3257),
    [anon_sym___refvalue] = ACTIONS(3257),
    [sym_null_literal] = ACTIONS(3257),
    [anon_sym_SQUOTE] = ACTIONS(3259),
    [sym_integer_literal] = ACTIONS(3257),
    [sym_real_literal] = ACTIONS(3259),
    [sym_verbatim_string_literal] = ACTIONS(3259),
    [aux_sym_preproc_if_token1] = ACTIONS(3259),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3259),
    [sym_interpolation_verbatim_start] = ACTIONS(3259),
    [sym_interpolation_raw_start] = ACTIONS(3259),
    [sym_raw_string_start] = ACTIONS(3259),
  },
  [2471] = {
    [sym_preproc_region] = STATE(2471),
    [sym_preproc_endregion] = STATE(2471),
    [sym_preproc_line] = STATE(2471),
    [sym_preproc_pragma] = STATE(2471),
    [sym_preproc_nullable] = STATE(2471),
    [sym_preproc_error] = STATE(2471),
    [sym_preproc_define] = STATE(2471),
    [sym_preproc_undef] = STATE(2471),
    [ts_builtin_sym_end] = ACTIONS(3315),
    [sym__identifier_token] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym_alias] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_global] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_unsafe] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_namespace] = ACTIONS(3313),
    [anon_sym_class] = ACTIONS(3313),
    [anon_sym_ref] = ACTIONS(3313),
    [anon_sym_struct] = ACTIONS(3313),
    [anon_sym_enum] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_interface] = ACTIONS(3313),
    [anon_sym_delegate] = ACTIONS(3313),
    [anon_sym_record] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_file] = ACTIONS(3313),
    [anon_sym_fixed] = ACTIONS(3313),
    [anon_sym_internal] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_override] = ACTIONS(3313),
    [anon_sym_partial] = ACTIONS(3313),
    [anon_sym_private] = ACTIONS(3313),
    [anon_sym_protected] = ACTIONS(3313),
    [anon_sym_public] = ACTIONS(3313),
    [anon_sym_readonly] = ACTIONS(3313),
    [anon_sym_required] = ACTIONS(3313),
    [anon_sym_sealed] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_where] = ACTIONS(3313),
    [anon_sym_notnull] = ACTIONS(3313),
    [anon_sym_unmanaged] = ACTIONS(3313),
    [anon_sym_checked] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_true] = ACTIONS(3313),
    [anon_sym_false] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3315),
    [anon_sym_CARET] = ACTIONS(3315),
    [anon_sym_AMP] = ACTIONS(3315),
    [anon_sym_this] = ACTIONS(3313),
    [anon_sym_scoped] = ACTIONS(3313),
    [anon_sym_base] = ACTIONS(3313),
    [anon_sym_var] = ACTIONS(3313),
    [sym_predefined_type] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_unchecked] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_lock] = ACTIONS(3313),
    [anon_sym_yield] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_when] = ACTIONS(3313),
    [anon_sym_await] = ACTIONS(3313),
    [anon_sym_foreach] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_else] = ACTIONS(3313),
    [anon_sym_DOT_DOT] = ACTIONS(3315),
    [anon_sym_from] = ACTIONS(3313),
    [anon_sym_into] = ACTIONS(3313),
    [anon_sym_join] = ACTIONS(3313),
    [anon_sym_on] = ACTIONS(3313),
    [anon_sym_equals] = ACTIONS(3313),
    [anon_sym_let] = ACTIONS(3313),
    [anon_sym_orderby] = ACTIONS(3313),
    [anon_sym_ascending] = ACTIONS(3313),
    [anon_sym_descending] = ACTIONS(3313),
    [anon_sym_group] = ACTIONS(3313),
    [anon_sym_by] = ACTIONS(3313),
    [anon_sym_select] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3313),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym___makeref] = ACTIONS(3313),
    [anon_sym___reftype] = ACTIONS(3313),
    [anon_sym___refvalue] = ACTIONS(3313),
    [sym_null_literal] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_integer_literal] = ACTIONS(3313),
    [sym_real_literal] = ACTIONS(3315),
    [sym_verbatim_string_literal] = ACTIONS(3315),
    [aux_sym_preproc_if_token1] = ACTIONS(3315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3315),
    [sym_interpolation_verbatim_start] = ACTIONS(3315),
    [sym_interpolation_raw_start] = ACTIONS(3315),
    [sym_raw_string_start] = ACTIONS(3315),
  },
  [2472] = {
    [sym_preproc_region] = STATE(2472),
    [sym_preproc_endregion] = STATE(2472),
    [sym_preproc_line] = STATE(2472),
    [sym_preproc_pragma] = STATE(2472),
    [sym_preproc_nullable] = STATE(2472),
    [sym_preproc_error] = STATE(2472),
    [sym_preproc_define] = STATE(2472),
    [sym_preproc_undef] = STATE(2472),
    [ts_builtin_sym_end] = ACTIONS(3379),
    [sym__identifier_token] = ACTIONS(3377),
    [anon_sym_extern] = ACTIONS(3377),
    [anon_sym_alias] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_global] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_unsafe] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_ref] = ACTIONS(3377),
    [anon_sym_struct] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_delegate] = ACTIONS(3377),
    [anon_sym_record] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_file] = ACTIONS(3377),
    [anon_sym_fixed] = ACTIONS(3377),
    [anon_sym_internal] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_partial] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_required] = ACTIONS(3377),
    [anon_sym_sealed] = ACTIONS(3377),
    [anon_sym_virtual] = ACTIONS(3377),
    [anon_sym_volatile] = ACTIONS(3377),
    [anon_sym_where] = ACTIONS(3377),
    [anon_sym_notnull] = ACTIONS(3377),
    [anon_sym_unmanaged] = ACTIONS(3377),
    [anon_sym_checked] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_true] = ACTIONS(3377),
    [anon_sym_false] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_CARET] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_this] = ACTIONS(3377),
    [anon_sym_scoped] = ACTIONS(3377),
    [anon_sym_base] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [sym_predefined_type] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_unchecked] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_lock] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_when] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_foreach] = ACTIONS(3377),
    [anon_sym_goto] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_from] = ACTIONS(3377),
    [anon_sym_into] = ACTIONS(3377),
    [anon_sym_join] = ACTIONS(3377),
    [anon_sym_on] = ACTIONS(3377),
    [anon_sym_equals] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_orderby] = ACTIONS(3377),
    [anon_sym_ascending] = ACTIONS(3377),
    [anon_sym_descending] = ACTIONS(3377),
    [anon_sym_group] = ACTIONS(3377),
    [anon_sym_by] = ACTIONS(3377),
    [anon_sym_select] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym___makeref] = ACTIONS(3377),
    [anon_sym___reftype] = ACTIONS(3377),
    [anon_sym___refvalue] = ACTIONS(3377),
    [sym_null_literal] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [sym_integer_literal] = ACTIONS(3377),
    [sym_real_literal] = ACTIONS(3379),
    [sym_verbatim_string_literal] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3379),
    [sym_interpolation_verbatim_start] = ACTIONS(3379),
    [sym_interpolation_raw_start] = ACTIONS(3379),
    [sym_raw_string_start] = ACTIONS(3379),
  },
  [2473] = {
    [sym_preproc_region] = STATE(2473),
    [sym_preproc_endregion] = STATE(2473),
    [sym_preproc_line] = STATE(2473),
    [sym_preproc_pragma] = STATE(2473),
    [sym_preproc_nullable] = STATE(2473),
    [sym_preproc_error] = STATE(2473),
    [sym_preproc_define] = STATE(2473),
    [sym_preproc_undef] = STATE(2473),
    [ts_builtin_sym_end] = ACTIONS(3227),
    [sym__identifier_token] = ACTIONS(3225),
    [anon_sym_extern] = ACTIONS(3225),
    [anon_sym_alias] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_global] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_unsafe] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_namespace] = ACTIONS(3225),
    [anon_sym_class] = ACTIONS(3225),
    [anon_sym_ref] = ACTIONS(3225),
    [anon_sym_struct] = ACTIONS(3225),
    [anon_sym_enum] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_interface] = ACTIONS(3225),
    [anon_sym_delegate] = ACTIONS(3225),
    [anon_sym_record] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_file] = ACTIONS(3225),
    [anon_sym_fixed] = ACTIONS(3225),
    [anon_sym_internal] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_partial] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_required] = ACTIONS(3225),
    [anon_sym_sealed] = ACTIONS(3225),
    [anon_sym_virtual] = ACTIONS(3225),
    [anon_sym_volatile] = ACTIONS(3225),
    [anon_sym_where] = ACTIONS(3225),
    [anon_sym_notnull] = ACTIONS(3225),
    [anon_sym_unmanaged] = ACTIONS(3225),
    [anon_sym_checked] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_true] = ACTIONS(3225),
    [anon_sym_false] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_STAR] = ACTIONS(3227),
    [anon_sym_CARET] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_this] = ACTIONS(3225),
    [anon_sym_scoped] = ACTIONS(3225),
    [anon_sym_base] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [sym_predefined_type] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_unchecked] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_lock] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_when] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_foreach] = ACTIONS(3225),
    [anon_sym_goto] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_DOT_DOT] = ACTIONS(3227),
    [anon_sym_from] = ACTIONS(3225),
    [anon_sym_into] = ACTIONS(3225),
    [anon_sym_join] = ACTIONS(3225),
    [anon_sym_on] = ACTIONS(3225),
    [anon_sym_equals] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_orderby] = ACTIONS(3225),
    [anon_sym_ascending] = ACTIONS(3225),
    [anon_sym_descending] = ACTIONS(3225),
    [anon_sym_group] = ACTIONS(3225),
    [anon_sym_by] = ACTIONS(3225),
    [anon_sym_select] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3225),
    [anon_sym_sizeof] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym___makeref] = ACTIONS(3225),
    [anon_sym___reftype] = ACTIONS(3225),
    [anon_sym___refvalue] = ACTIONS(3225),
    [sym_null_literal] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [sym_integer_literal] = ACTIONS(3225),
    [sym_real_literal] = ACTIONS(3227),
    [sym_verbatim_string_literal] = ACTIONS(3227),
    [aux_sym_preproc_if_token1] = ACTIONS(3227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3227),
    [sym_interpolation_verbatim_start] = ACTIONS(3227),
    [sym_interpolation_raw_start] = ACTIONS(3227),
    [sym_raw_string_start] = ACTIONS(3227),
  },
  [2474] = {
    [sym_preproc_region] = STATE(2474),
    [sym_preproc_endregion] = STATE(2474),
    [sym_preproc_line] = STATE(2474),
    [sym_preproc_pragma] = STATE(2474),
    [sym_preproc_nullable] = STATE(2474),
    [sym_preproc_error] = STATE(2474),
    [sym_preproc_define] = STATE(2474),
    [sym_preproc_undef] = STATE(2474),
    [ts_builtin_sym_end] = ACTIONS(3331),
    [sym__identifier_token] = ACTIONS(3329),
    [anon_sym_extern] = ACTIONS(3329),
    [anon_sym_alias] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_global] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_unsafe] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_namespace] = ACTIONS(3329),
    [anon_sym_class] = ACTIONS(3329),
    [anon_sym_ref] = ACTIONS(3329),
    [anon_sym_struct] = ACTIONS(3329),
    [anon_sym_enum] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_interface] = ACTIONS(3329),
    [anon_sym_delegate] = ACTIONS(3329),
    [anon_sym_record] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_file] = ACTIONS(3329),
    [anon_sym_fixed] = ACTIONS(3329),
    [anon_sym_internal] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_partial] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_required] = ACTIONS(3329),
    [anon_sym_sealed] = ACTIONS(3329),
    [anon_sym_virtual] = ACTIONS(3329),
    [anon_sym_volatile] = ACTIONS(3329),
    [anon_sym_where] = ACTIONS(3329),
    [anon_sym_notnull] = ACTIONS(3329),
    [anon_sym_unmanaged] = ACTIONS(3329),
    [anon_sym_checked] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_true] = ACTIONS(3329),
    [anon_sym_false] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3331),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_this] = ACTIONS(3329),
    [anon_sym_scoped] = ACTIONS(3329),
    [anon_sym_base] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [sym_predefined_type] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_unchecked] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_lock] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_when] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_foreach] = ACTIONS(3329),
    [anon_sym_goto] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_DOT_DOT] = ACTIONS(3331),
    [anon_sym_from] = ACTIONS(3329),
    [anon_sym_into] = ACTIONS(3329),
    [anon_sym_join] = ACTIONS(3329),
    [anon_sym_on] = ACTIONS(3329),
    [anon_sym_equals] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_orderby] = ACTIONS(3329),
    [anon_sym_ascending] = ACTIONS(3329),
    [anon_sym_descending] = ACTIONS(3329),
    [anon_sym_group] = ACTIONS(3329),
    [anon_sym_by] = ACTIONS(3329),
    [anon_sym_select] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym___makeref] = ACTIONS(3329),
    [anon_sym___reftype] = ACTIONS(3329),
    [anon_sym___refvalue] = ACTIONS(3329),
    [sym_null_literal] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [sym_integer_literal] = ACTIONS(3329),
    [sym_real_literal] = ACTIONS(3331),
    [sym_verbatim_string_literal] = ACTIONS(3331),
    [aux_sym_preproc_if_token1] = ACTIONS(3331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3331),
    [sym_interpolation_verbatim_start] = ACTIONS(3331),
    [sym_interpolation_raw_start] = ACTIONS(3331),
    [sym_raw_string_start] = ACTIONS(3331),
  },
  [2475] = {
    [sym_preproc_region] = STATE(2475),
    [sym_preproc_endregion] = STATE(2475),
    [sym_preproc_line] = STATE(2475),
    [sym_preproc_pragma] = STATE(2475),
    [sym_preproc_nullable] = STATE(2475),
    [sym_preproc_error] = STATE(2475),
    [sym_preproc_define] = STATE(2475),
    [sym_preproc_undef] = STATE(2475),
    [ts_builtin_sym_end] = ACTIONS(3319),
    [sym__identifier_token] = ACTIONS(3317),
    [anon_sym_extern] = ACTIONS(3317),
    [anon_sym_alias] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_unsafe] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_namespace] = ACTIONS(3317),
    [anon_sym_class] = ACTIONS(3317),
    [anon_sym_ref] = ACTIONS(3317),
    [anon_sym_struct] = ACTIONS(3317),
    [anon_sym_enum] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_interface] = ACTIONS(3317),
    [anon_sym_delegate] = ACTIONS(3317),
    [anon_sym_record] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_file] = ACTIONS(3317),
    [anon_sym_fixed] = ACTIONS(3317),
    [anon_sym_internal] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_partial] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_required] = ACTIONS(3317),
    [anon_sym_sealed] = ACTIONS(3317),
    [anon_sym_virtual] = ACTIONS(3317),
    [anon_sym_volatile] = ACTIONS(3317),
    [anon_sym_where] = ACTIONS(3317),
    [anon_sym_notnull] = ACTIONS(3317),
    [anon_sym_unmanaged] = ACTIONS(3317),
    [anon_sym_checked] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_true] = ACTIONS(3317),
    [anon_sym_false] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3319),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_this] = ACTIONS(3317),
    [anon_sym_scoped] = ACTIONS(3317),
    [anon_sym_base] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [sym_predefined_type] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_unchecked] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_lock] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_when] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_foreach] = ACTIONS(3317),
    [anon_sym_goto] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_DOT_DOT] = ACTIONS(3319),
    [anon_sym_from] = ACTIONS(3317),
    [anon_sym_into] = ACTIONS(3317),
    [anon_sym_join] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [anon_sym_equals] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_orderby] = ACTIONS(3317),
    [anon_sym_ascending] = ACTIONS(3317),
    [anon_sym_descending] = ACTIONS(3317),
    [anon_sym_group] = ACTIONS(3317),
    [anon_sym_by] = ACTIONS(3317),
    [anon_sym_select] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3317),
    [anon_sym_sizeof] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym___makeref] = ACTIONS(3317),
    [anon_sym___reftype] = ACTIONS(3317),
    [anon_sym___refvalue] = ACTIONS(3317),
    [sym_null_literal] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_integer_literal] = ACTIONS(3317),
    [sym_real_literal] = ACTIONS(3319),
    [sym_verbatim_string_literal] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3319),
    [sym_interpolation_verbatim_start] = ACTIONS(3319),
    [sym_interpolation_raw_start] = ACTIONS(3319),
    [sym_raw_string_start] = ACTIONS(3319),
  },
  [2476] = {
    [sym_preproc_region] = STATE(2476),
    [sym_preproc_endregion] = STATE(2476),
    [sym_preproc_line] = STATE(2476),
    [sym_preproc_pragma] = STATE(2476),
    [sym_preproc_nullable] = STATE(2476),
    [sym_preproc_error] = STATE(2476),
    [sym_preproc_define] = STATE(2476),
    [sym_preproc_undef] = STATE(2476),
    [ts_builtin_sym_end] = ACTIONS(3343),
    [sym__identifier_token] = ACTIONS(3341),
    [anon_sym_extern] = ACTIONS(3341),
    [anon_sym_alias] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_global] = ACTIONS(3341),
    [anon_sym_using] = ACTIONS(3341),
    [anon_sym_unsafe] = ACTIONS(3341),
    [anon_sym_static] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3341),
    [anon_sym_namespace] = ACTIONS(3341),
    [anon_sym_class] = ACTIONS(3341),
    [anon_sym_ref] = ACTIONS(3341),
    [anon_sym_struct] = ACTIONS(3341),
    [anon_sym_enum] = ACTIONS(3341),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_interface] = ACTIONS(3341),
    [anon_sym_delegate] = ACTIONS(3341),
    [anon_sym_record] = ACTIONS(3341),
    [anon_sym_abstract] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3341),
    [anon_sym_const] = ACTIONS(3341),
    [anon_sym_file] = ACTIONS(3341),
    [anon_sym_fixed] = ACTIONS(3341),
    [anon_sym_internal] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3341),
    [anon_sym_override] = ACTIONS(3341),
    [anon_sym_partial] = ACTIONS(3341),
    [anon_sym_private] = ACTIONS(3341),
    [anon_sym_protected] = ACTIONS(3341),
    [anon_sym_public] = ACTIONS(3341),
    [anon_sym_readonly] = ACTIONS(3341),
    [anon_sym_required] = ACTIONS(3341),
    [anon_sym_sealed] = ACTIONS(3341),
    [anon_sym_virtual] = ACTIONS(3341),
    [anon_sym_volatile] = ACTIONS(3341),
    [anon_sym_where] = ACTIONS(3341),
    [anon_sym_notnull] = ACTIONS(3341),
    [anon_sym_unmanaged] = ACTIONS(3341),
    [anon_sym_checked] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_true] = ACTIONS(3341),
    [anon_sym_false] = ACTIONS(3341),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_STAR] = ACTIONS(3343),
    [anon_sym_CARET] = ACTIONS(3343),
    [anon_sym_AMP] = ACTIONS(3343),
    [anon_sym_this] = ACTIONS(3341),
    [anon_sym_scoped] = ACTIONS(3341),
    [anon_sym_base] = ACTIONS(3341),
    [anon_sym_var] = ACTIONS(3341),
    [sym_predefined_type] = ACTIONS(3341),
    [anon_sym_break] = ACTIONS(3341),
    [anon_sym_unchecked] = ACTIONS(3341),
    [anon_sym_continue] = ACTIONS(3341),
    [anon_sym_do] = ACTIONS(3341),
    [anon_sym_while] = ACTIONS(3341),
    [anon_sym_for] = ACTIONS(3341),
    [anon_sym_lock] = ACTIONS(3341),
    [anon_sym_yield] = ACTIONS(3341),
    [anon_sym_switch] = ACTIONS(3341),
    [anon_sym_default] = ACTIONS(3341),
    [anon_sym_throw] = ACTIONS(3341),
    [anon_sym_try] = ACTIONS(3341),
    [anon_sym_when] = ACTIONS(3341),
    [anon_sym_await] = ACTIONS(3341),
    [anon_sym_foreach] = ACTIONS(3341),
    [anon_sym_goto] = ACTIONS(3341),
    [anon_sym_if] = ACTIONS(3341),
    [anon_sym_else] = ACTIONS(3341),
    [anon_sym_DOT_DOT] = ACTIONS(3343),
    [anon_sym_from] = ACTIONS(3341),
    [anon_sym_into] = ACTIONS(3341),
    [anon_sym_join] = ACTIONS(3341),
    [anon_sym_on] = ACTIONS(3341),
    [anon_sym_equals] = ACTIONS(3341),
    [anon_sym_let] = ACTIONS(3341),
    [anon_sym_orderby] = ACTIONS(3341),
    [anon_sym_ascending] = ACTIONS(3341),
    [anon_sym_descending] = ACTIONS(3341),
    [anon_sym_group] = ACTIONS(3341),
    [anon_sym_by] = ACTIONS(3341),
    [anon_sym_select] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3341),
    [anon_sym_sizeof] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3341),
    [anon_sym___makeref] = ACTIONS(3341),
    [anon_sym___reftype] = ACTIONS(3341),
    [anon_sym___refvalue] = ACTIONS(3341),
    [sym_null_literal] = ACTIONS(3341),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [sym_integer_literal] = ACTIONS(3341),
    [sym_real_literal] = ACTIONS(3343),
    [sym_verbatim_string_literal] = ACTIONS(3343),
    [aux_sym_preproc_if_token1] = ACTIONS(3343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3343),
    [sym_interpolation_verbatim_start] = ACTIONS(3343),
    [sym_interpolation_raw_start] = ACTIONS(3343),
    [sym_raw_string_start] = ACTIONS(3343),
  },
  [2477] = {
    [sym_preproc_region] = STATE(2477),
    [sym_preproc_endregion] = STATE(2477),
    [sym_preproc_line] = STATE(2477),
    [sym_preproc_pragma] = STATE(2477),
    [sym_preproc_nullable] = STATE(2477),
    [sym_preproc_error] = STATE(2477),
    [sym_preproc_define] = STATE(2477),
    [sym_preproc_undef] = STATE(2477),
    [ts_builtin_sym_end] = ACTIONS(3351),
    [sym__identifier_token] = ACTIONS(3349),
    [anon_sym_extern] = ACTIONS(3349),
    [anon_sym_alias] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_global] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_unsafe] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_namespace] = ACTIONS(3349),
    [anon_sym_class] = ACTIONS(3349),
    [anon_sym_ref] = ACTIONS(3349),
    [anon_sym_struct] = ACTIONS(3349),
    [anon_sym_enum] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_interface] = ACTIONS(3349),
    [anon_sym_delegate] = ACTIONS(3349),
    [anon_sym_record] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_file] = ACTIONS(3349),
    [anon_sym_fixed] = ACTIONS(3349),
    [anon_sym_internal] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_partial] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_required] = ACTIONS(3349),
    [anon_sym_sealed] = ACTIONS(3349),
    [anon_sym_virtual] = ACTIONS(3349),
    [anon_sym_volatile] = ACTIONS(3349),
    [anon_sym_where] = ACTIONS(3349),
    [anon_sym_notnull] = ACTIONS(3349),
    [anon_sym_unmanaged] = ACTIONS(3349),
    [anon_sym_checked] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(3349),
    [anon_sym_false] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_CARET] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_this] = ACTIONS(3349),
    [anon_sym_scoped] = ACTIONS(3349),
    [anon_sym_base] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [sym_predefined_type] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_unchecked] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_lock] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_when] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_foreach] = ACTIONS(3349),
    [anon_sym_goto] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_DOT_DOT] = ACTIONS(3351),
    [anon_sym_from] = ACTIONS(3349),
    [anon_sym_into] = ACTIONS(3349),
    [anon_sym_join] = ACTIONS(3349),
    [anon_sym_on] = ACTIONS(3349),
    [anon_sym_equals] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_orderby] = ACTIONS(3349),
    [anon_sym_ascending] = ACTIONS(3349),
    [anon_sym_descending] = ACTIONS(3349),
    [anon_sym_group] = ACTIONS(3349),
    [anon_sym_by] = ACTIONS(3349),
    [anon_sym_select] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3349),
    [anon_sym_sizeof] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym___makeref] = ACTIONS(3349),
    [anon_sym___reftype] = ACTIONS(3349),
    [anon_sym___refvalue] = ACTIONS(3349),
    [sym_null_literal] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [sym_integer_literal] = ACTIONS(3349),
    [sym_real_literal] = ACTIONS(3351),
    [sym_verbatim_string_literal] = ACTIONS(3351),
    [aux_sym_preproc_if_token1] = ACTIONS(3351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3351),
    [sym_interpolation_verbatim_start] = ACTIONS(3351),
    [sym_interpolation_raw_start] = ACTIONS(3351),
    [sym_raw_string_start] = ACTIONS(3351),
  },
  [2478] = {
    [sym_preproc_region] = STATE(2478),
    [sym_preproc_endregion] = STATE(2478),
    [sym_preproc_line] = STATE(2478),
    [sym_preproc_pragma] = STATE(2478),
    [sym_preproc_nullable] = STATE(2478),
    [sym_preproc_error] = STATE(2478),
    [sym_preproc_define] = STATE(2478),
    [sym_preproc_undef] = STATE(2478),
    [ts_builtin_sym_end] = ACTIONS(3391),
    [sym__identifier_token] = ACTIONS(3389),
    [anon_sym_extern] = ACTIONS(3389),
    [anon_sym_alias] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_global] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_unsafe] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_namespace] = ACTIONS(3389),
    [anon_sym_class] = ACTIONS(3389),
    [anon_sym_ref] = ACTIONS(3389),
    [anon_sym_struct] = ACTIONS(3389),
    [anon_sym_enum] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_interface] = ACTIONS(3389),
    [anon_sym_delegate] = ACTIONS(3389),
    [anon_sym_record] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_file] = ACTIONS(3389),
    [anon_sym_fixed] = ACTIONS(3389),
    [anon_sym_internal] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_partial] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_required] = ACTIONS(3389),
    [anon_sym_sealed] = ACTIONS(3389),
    [anon_sym_virtual] = ACTIONS(3389),
    [anon_sym_volatile] = ACTIONS(3389),
    [anon_sym_where] = ACTIONS(3389),
    [anon_sym_notnull] = ACTIONS(3389),
    [anon_sym_unmanaged] = ACTIONS(3389),
    [anon_sym_checked] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [anon_sym_true] = ACTIONS(3389),
    [anon_sym_false] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_CARET] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_this] = ACTIONS(3389),
    [anon_sym_scoped] = ACTIONS(3389),
    [anon_sym_base] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [sym_predefined_type] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_unchecked] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_lock] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_when] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_foreach] = ACTIONS(3389),
    [anon_sym_goto] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_else] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3391),
    [anon_sym_from] = ACTIONS(3389),
    [anon_sym_into] = ACTIONS(3389),
    [anon_sym_join] = ACTIONS(3389),
    [anon_sym_on] = ACTIONS(3389),
    [anon_sym_equals] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_orderby] = ACTIONS(3389),
    [anon_sym_ascending] = ACTIONS(3389),
    [anon_sym_descending] = ACTIONS(3389),
    [anon_sym_group] = ACTIONS(3389),
    [anon_sym_by] = ACTIONS(3389),
    [anon_sym_select] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym___makeref] = ACTIONS(3389),
    [anon_sym___reftype] = ACTIONS(3389),
    [anon_sym___refvalue] = ACTIONS(3389),
    [sym_null_literal] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [sym_integer_literal] = ACTIONS(3389),
    [sym_real_literal] = ACTIONS(3391),
    [sym_verbatim_string_literal] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3391),
    [sym_interpolation_verbatim_start] = ACTIONS(3391),
    [sym_interpolation_raw_start] = ACTIONS(3391),
    [sym_raw_string_start] = ACTIONS(3391),
  },
  [2479] = {
    [sym_preproc_region] = STATE(2479),
    [sym_preproc_endregion] = STATE(2479),
    [sym_preproc_line] = STATE(2479),
    [sym_preproc_pragma] = STATE(2479),
    [sym_preproc_nullable] = STATE(2479),
    [sym_preproc_error] = STATE(2479),
    [sym_preproc_define] = STATE(2479),
    [sym_preproc_undef] = STATE(2479),
    [ts_builtin_sym_end] = ACTIONS(3181),
    [sym__identifier_token] = ACTIONS(3179),
    [anon_sym_extern] = ACTIONS(3179),
    [anon_sym_alias] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_global] = ACTIONS(3179),
    [anon_sym_using] = ACTIONS(3179),
    [anon_sym_unsafe] = ACTIONS(3179),
    [anon_sym_static] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_namespace] = ACTIONS(3179),
    [anon_sym_class] = ACTIONS(3179),
    [anon_sym_ref] = ACTIONS(3179),
    [anon_sym_struct] = ACTIONS(3179),
    [anon_sym_enum] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_interface] = ACTIONS(3179),
    [anon_sym_delegate] = ACTIONS(3179),
    [anon_sym_record] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_async] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_file] = ACTIONS(3179),
    [anon_sym_fixed] = ACTIONS(3179),
    [anon_sym_internal] = ACTIONS(3179),
    [anon_sym_new] = ACTIONS(3179),
    [anon_sym_override] = ACTIONS(3179),
    [anon_sym_partial] = ACTIONS(3179),
    [anon_sym_private] = ACTIONS(3179),
    [anon_sym_protected] = ACTIONS(3179),
    [anon_sym_public] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_required] = ACTIONS(3179),
    [anon_sym_sealed] = ACTIONS(3179),
    [anon_sym_virtual] = ACTIONS(3179),
    [anon_sym_volatile] = ACTIONS(3179),
    [anon_sym_where] = ACTIONS(3179),
    [anon_sym_notnull] = ACTIONS(3179),
    [anon_sym_unmanaged] = ACTIONS(3179),
    [anon_sym_checked] = ACTIONS(3179),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_true] = ACTIONS(3179),
    [anon_sym_false] = ACTIONS(3179),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_STAR] = ACTIONS(3181),
    [anon_sym_CARET] = ACTIONS(3181),
    [anon_sym_AMP] = ACTIONS(3181),
    [anon_sym_this] = ACTIONS(3179),
    [anon_sym_scoped] = ACTIONS(3179),
    [anon_sym_base] = ACTIONS(3179),
    [anon_sym_var] = ACTIONS(3179),
    [sym_predefined_type] = ACTIONS(3179),
    [anon_sym_break] = ACTIONS(3179),
    [anon_sym_unchecked] = ACTIONS(3179),
    [anon_sym_continue] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_lock] = ACTIONS(3179),
    [anon_sym_yield] = ACTIONS(3179),
    [anon_sym_switch] = ACTIONS(3179),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_throw] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_when] = ACTIONS(3179),
    [anon_sym_await] = ACTIONS(3179),
    [anon_sym_foreach] = ACTIONS(3179),
    [anon_sym_goto] = ACTIONS(3179),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_else] = ACTIONS(3179),
    [anon_sym_DOT_DOT] = ACTIONS(3181),
    [anon_sym_from] = ACTIONS(3179),
    [anon_sym_into] = ACTIONS(3179),
    [anon_sym_join] = ACTIONS(3179),
    [anon_sym_on] = ACTIONS(3179),
    [anon_sym_equals] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_orderby] = ACTIONS(3179),
    [anon_sym_ascending] = ACTIONS(3179),
    [anon_sym_descending] = ACTIONS(3179),
    [anon_sym_group] = ACTIONS(3179),
    [anon_sym_by] = ACTIONS(3179),
    [anon_sym_select] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3179),
    [anon_sym_sizeof] = ACTIONS(3179),
    [anon_sym_typeof] = ACTIONS(3179),
    [anon_sym___makeref] = ACTIONS(3179),
    [anon_sym___reftype] = ACTIONS(3179),
    [anon_sym___refvalue] = ACTIONS(3179),
    [sym_null_literal] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [sym_integer_literal] = ACTIONS(3179),
    [sym_real_literal] = ACTIONS(3181),
    [sym_verbatim_string_literal] = ACTIONS(3181),
    [aux_sym_preproc_if_token1] = ACTIONS(3181),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3181),
    [sym_interpolation_verbatim_start] = ACTIONS(3181),
    [sym_interpolation_raw_start] = ACTIONS(3181),
    [sym_raw_string_start] = ACTIONS(3181),
  },
  [2480] = {
    [sym_preproc_region] = STATE(2480),
    [sym_preproc_endregion] = STATE(2480),
    [sym_preproc_line] = STATE(2480),
    [sym_preproc_pragma] = STATE(2480),
    [sym_preproc_nullable] = STATE(2480),
    [sym_preproc_error] = STATE(2480),
    [sym_preproc_define] = STATE(2480),
    [sym_preproc_undef] = STATE(2480),
    [ts_builtin_sym_end] = ACTIONS(3355),
    [sym__identifier_token] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym_alias] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_global] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_unsafe] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_namespace] = ACTIONS(3353),
    [anon_sym_class] = ACTIONS(3353),
    [anon_sym_ref] = ACTIONS(3353),
    [anon_sym_struct] = ACTIONS(3353),
    [anon_sym_enum] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_interface] = ACTIONS(3353),
    [anon_sym_delegate] = ACTIONS(3353),
    [anon_sym_record] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_file] = ACTIONS(3353),
    [anon_sym_fixed] = ACTIONS(3353),
    [anon_sym_internal] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_partial] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_required] = ACTIONS(3353),
    [anon_sym_sealed] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_where] = ACTIONS(3353),
    [anon_sym_notnull] = ACTIONS(3353),
    [anon_sym_unmanaged] = ACTIONS(3353),
    [anon_sym_checked] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_true] = ACTIONS(3353),
    [anon_sym_false] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_this] = ACTIONS(3353),
    [anon_sym_scoped] = ACTIONS(3353),
    [anon_sym_base] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [sym_predefined_type] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_unchecked] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_lock] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_when] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_foreach] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3355),
    [anon_sym_from] = ACTIONS(3353),
    [anon_sym_into] = ACTIONS(3353),
    [anon_sym_join] = ACTIONS(3353),
    [anon_sym_on] = ACTIONS(3353),
    [anon_sym_equals] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_orderby] = ACTIONS(3353),
    [anon_sym_ascending] = ACTIONS(3353),
    [anon_sym_descending] = ACTIONS(3353),
    [anon_sym_group] = ACTIONS(3353),
    [anon_sym_by] = ACTIONS(3353),
    [anon_sym_select] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3353),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym___makeref] = ACTIONS(3353),
    [anon_sym___reftype] = ACTIONS(3353),
    [anon_sym___refvalue] = ACTIONS(3353),
    [sym_null_literal] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [sym_integer_literal] = ACTIONS(3353),
    [sym_real_literal] = ACTIONS(3355),
    [sym_verbatim_string_literal] = ACTIONS(3355),
    [aux_sym_preproc_if_token1] = ACTIONS(3355),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3355),
    [sym_interpolation_verbatim_start] = ACTIONS(3355),
    [sym_interpolation_raw_start] = ACTIONS(3355),
    [sym_raw_string_start] = ACTIONS(3355),
  },
  [2481] = {
    [sym_preproc_region] = STATE(2481),
    [sym_preproc_endregion] = STATE(2481),
    [sym_preproc_line] = STATE(2481),
    [sym_preproc_pragma] = STATE(2481),
    [sym_preproc_nullable] = STATE(2481),
    [sym_preproc_error] = STATE(2481),
    [sym_preproc_define] = STATE(2481),
    [sym_preproc_undef] = STATE(2481),
    [ts_builtin_sym_end] = ACTIONS(3263),
    [sym__identifier_token] = ACTIONS(3261),
    [anon_sym_extern] = ACTIONS(3261),
    [anon_sym_alias] = ACTIONS(3261),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_global] = ACTIONS(3261),
    [anon_sym_using] = ACTIONS(3261),
    [anon_sym_unsafe] = ACTIONS(3261),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_namespace] = ACTIONS(3261),
    [anon_sym_class] = ACTIONS(3261),
    [anon_sym_ref] = ACTIONS(3261),
    [anon_sym_struct] = ACTIONS(3261),
    [anon_sym_enum] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_interface] = ACTIONS(3261),
    [anon_sym_delegate] = ACTIONS(3261),
    [anon_sym_record] = ACTIONS(3261),
    [anon_sym_abstract] = ACTIONS(3261),
    [anon_sym_async] = ACTIONS(3261),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_file] = ACTIONS(3261),
    [anon_sym_fixed] = ACTIONS(3261),
    [anon_sym_internal] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_override] = ACTIONS(3261),
    [anon_sym_partial] = ACTIONS(3261),
    [anon_sym_private] = ACTIONS(3261),
    [anon_sym_protected] = ACTIONS(3261),
    [anon_sym_public] = ACTIONS(3261),
    [anon_sym_readonly] = ACTIONS(3261),
    [anon_sym_required] = ACTIONS(3261),
    [anon_sym_sealed] = ACTIONS(3261),
    [anon_sym_virtual] = ACTIONS(3261),
    [anon_sym_volatile] = ACTIONS(3261),
    [anon_sym_where] = ACTIONS(3261),
    [anon_sym_notnull] = ACTIONS(3261),
    [anon_sym_unmanaged] = ACTIONS(3261),
    [anon_sym_checked] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_true] = ACTIONS(3261),
    [anon_sym_false] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_CARET] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3263),
    [anon_sym_this] = ACTIONS(3261),
    [anon_sym_scoped] = ACTIONS(3261),
    [anon_sym_base] = ACTIONS(3261),
    [anon_sym_var] = ACTIONS(3261),
    [sym_predefined_type] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3261),
    [anon_sym_unchecked] = ACTIONS(3261),
    [anon_sym_continue] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_lock] = ACTIONS(3261),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_switch] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_throw] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_when] = ACTIONS(3261),
    [anon_sym_await] = ACTIONS(3261),
    [anon_sym_foreach] = ACTIONS(3261),
    [anon_sym_goto] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_else] = ACTIONS(3261),
    [anon_sym_DOT_DOT] = ACTIONS(3263),
    [anon_sym_from] = ACTIONS(3261),
    [anon_sym_into] = ACTIONS(3261),
    [anon_sym_join] = ACTIONS(3261),
    [anon_sym_on] = ACTIONS(3261),
    [anon_sym_equals] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_orderby] = ACTIONS(3261),
    [anon_sym_ascending] = ACTIONS(3261),
    [anon_sym_descending] = ACTIONS(3261),
    [anon_sym_group] = ACTIONS(3261),
    [anon_sym_by] = ACTIONS(3261),
    [anon_sym_select] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3261),
    [anon_sym_sizeof] = ACTIONS(3261),
    [anon_sym_typeof] = ACTIONS(3261),
    [anon_sym___makeref] = ACTIONS(3261),
    [anon_sym___reftype] = ACTIONS(3261),
    [anon_sym___refvalue] = ACTIONS(3261),
    [sym_null_literal] = ACTIONS(3261),
    [anon_sym_SQUOTE] = ACTIONS(3263),
    [sym_integer_literal] = ACTIONS(3261),
    [sym_real_literal] = ACTIONS(3263),
    [sym_verbatim_string_literal] = ACTIONS(3263),
    [aux_sym_preproc_if_token1] = ACTIONS(3263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3263),
    [sym_interpolation_verbatim_start] = ACTIONS(3263),
    [sym_interpolation_raw_start] = ACTIONS(3263),
    [sym_raw_string_start] = ACTIONS(3263),
  },
  [2482] = {
    [sym_preproc_region] = STATE(2482),
    [sym_preproc_endregion] = STATE(2482),
    [sym_preproc_line] = STATE(2482),
    [sym_preproc_pragma] = STATE(2482),
    [sym_preproc_nullable] = STATE(2482),
    [sym_preproc_error] = STATE(2482),
    [sym_preproc_define] = STATE(2482),
    [sym_preproc_undef] = STATE(2482),
    [ts_builtin_sym_end] = ACTIONS(3367),
    [sym__identifier_token] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3365),
    [anon_sym_alias] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_global] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_unsafe] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_ref] = ACTIONS(3365),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_delegate] = ACTIONS(3365),
    [anon_sym_record] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_file] = ACTIONS(3365),
    [anon_sym_fixed] = ACTIONS(3365),
    [anon_sym_internal] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_partial] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_required] = ACTIONS(3365),
    [anon_sym_sealed] = ACTIONS(3365),
    [anon_sym_virtual] = ACTIONS(3365),
    [anon_sym_volatile] = ACTIONS(3365),
    [anon_sym_where] = ACTIONS(3365),
    [anon_sym_notnull] = ACTIONS(3365),
    [anon_sym_unmanaged] = ACTIONS(3365),
    [anon_sym_checked] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [anon_sym_true] = ACTIONS(3365),
    [anon_sym_false] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_STAR] = ACTIONS(3367),
    [anon_sym_CARET] = ACTIONS(3367),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_this] = ACTIONS(3365),
    [anon_sym_scoped] = ACTIONS(3365),
    [anon_sym_base] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [sym_predefined_type] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_unchecked] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_lock] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_when] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_foreach] = ACTIONS(3365),
    [anon_sym_goto] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_DOT_DOT] = ACTIONS(3367),
    [anon_sym_from] = ACTIONS(3365),
    [anon_sym_into] = ACTIONS(3365),
    [anon_sym_join] = ACTIONS(3365),
    [anon_sym_on] = ACTIONS(3365),
    [anon_sym_equals] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_orderby] = ACTIONS(3365),
    [anon_sym_ascending] = ACTIONS(3365),
    [anon_sym_descending] = ACTIONS(3365),
    [anon_sym_group] = ACTIONS(3365),
    [anon_sym_by] = ACTIONS(3365),
    [anon_sym_select] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3365),
    [anon_sym_sizeof] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym___makeref] = ACTIONS(3365),
    [anon_sym___reftype] = ACTIONS(3365),
    [anon_sym___refvalue] = ACTIONS(3365),
    [sym_null_literal] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [sym_integer_literal] = ACTIONS(3365),
    [sym_real_literal] = ACTIONS(3367),
    [sym_verbatim_string_literal] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3367),
    [sym_interpolation_verbatim_start] = ACTIONS(3367),
    [sym_interpolation_raw_start] = ACTIONS(3367),
    [sym_raw_string_start] = ACTIONS(3367),
  },
  [2483] = {
    [sym_preproc_region] = STATE(2483),
    [sym_preproc_endregion] = STATE(2483),
    [sym_preproc_line] = STATE(2483),
    [sym_preproc_pragma] = STATE(2483),
    [sym_preproc_nullable] = STATE(2483),
    [sym_preproc_error] = STATE(2483),
    [sym_preproc_define] = STATE(2483),
    [sym_preproc_undef] = STATE(2483),
    [ts_builtin_sym_end] = ACTIONS(3375),
    [sym__identifier_token] = ACTIONS(3373),
    [anon_sym_extern] = ACTIONS(3373),
    [anon_sym_alias] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_global] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_unsafe] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_namespace] = ACTIONS(3373),
    [anon_sym_class] = ACTIONS(3373),
    [anon_sym_ref] = ACTIONS(3373),
    [anon_sym_struct] = ACTIONS(3373),
    [anon_sym_enum] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(3373),
    [anon_sym_delegate] = ACTIONS(3373),
    [anon_sym_record] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_file] = ACTIONS(3373),
    [anon_sym_fixed] = ACTIONS(3373),
    [anon_sym_internal] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_partial] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_required] = ACTIONS(3373),
    [anon_sym_sealed] = ACTIONS(3373),
    [anon_sym_virtual] = ACTIONS(3373),
    [anon_sym_volatile] = ACTIONS(3373),
    [anon_sym_where] = ACTIONS(3373),
    [anon_sym_notnull] = ACTIONS(3373),
    [anon_sym_unmanaged] = ACTIONS(3373),
    [anon_sym_checked] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_true] = ACTIONS(3373),
    [anon_sym_false] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_CARET] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_this] = ACTIONS(3373),
    [anon_sym_scoped] = ACTIONS(3373),
    [anon_sym_base] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [sym_predefined_type] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_unchecked] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_lock] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_when] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_foreach] = ACTIONS(3373),
    [anon_sym_goto] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_DOT_DOT] = ACTIONS(3375),
    [anon_sym_from] = ACTIONS(3373),
    [anon_sym_into] = ACTIONS(3373),
    [anon_sym_join] = ACTIONS(3373),
    [anon_sym_on] = ACTIONS(3373),
    [anon_sym_equals] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_orderby] = ACTIONS(3373),
    [anon_sym_ascending] = ACTIONS(3373),
    [anon_sym_descending] = ACTIONS(3373),
    [anon_sym_group] = ACTIONS(3373),
    [anon_sym_by] = ACTIONS(3373),
    [anon_sym_select] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym___makeref] = ACTIONS(3373),
    [anon_sym___reftype] = ACTIONS(3373),
    [anon_sym___refvalue] = ACTIONS(3373),
    [sym_null_literal] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [sym_integer_literal] = ACTIONS(3373),
    [sym_real_literal] = ACTIONS(3375),
    [sym_verbatim_string_literal] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3375),
    [sym_interpolation_verbatim_start] = ACTIONS(3375),
    [sym_interpolation_raw_start] = ACTIONS(3375),
    [sym_raw_string_start] = ACTIONS(3375),
  },
  [2484] = {
    [sym_preproc_region] = STATE(2484),
    [sym_preproc_endregion] = STATE(2484),
    [sym_preproc_line] = STATE(2484),
    [sym_preproc_pragma] = STATE(2484),
    [sym_preproc_nullable] = STATE(2484),
    [sym_preproc_error] = STATE(2484),
    [sym_preproc_define] = STATE(2484),
    [sym_preproc_undef] = STATE(2484),
    [ts_builtin_sym_end] = ACTIONS(3363),
    [sym__identifier_token] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_alias] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_global] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_unsafe] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_ref] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_delegate] = ACTIONS(3361),
    [anon_sym_record] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_file] = ACTIONS(3361),
    [anon_sym_fixed] = ACTIONS(3361),
    [anon_sym_internal] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_partial] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_required] = ACTIONS(3361),
    [anon_sym_sealed] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_where] = ACTIONS(3361),
    [anon_sym_notnull] = ACTIONS(3361),
    [anon_sym_unmanaged] = ACTIONS(3361),
    [anon_sym_checked] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_true] = ACTIONS(3361),
    [anon_sym_false] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_this] = ACTIONS(3361),
    [anon_sym_scoped] = ACTIONS(3361),
    [anon_sym_base] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [sym_predefined_type] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_unchecked] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_lock] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_when] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_foreach] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_DOT_DOT] = ACTIONS(3363),
    [anon_sym_from] = ACTIONS(3361),
    [anon_sym_into] = ACTIONS(3361),
    [anon_sym_join] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [anon_sym_equals] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_orderby] = ACTIONS(3361),
    [anon_sym_ascending] = ACTIONS(3361),
    [anon_sym_descending] = ACTIONS(3361),
    [anon_sym_group] = ACTIONS(3361),
    [anon_sym_by] = ACTIONS(3361),
    [anon_sym_select] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3361),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym___makeref] = ACTIONS(3361),
    [anon_sym___reftype] = ACTIONS(3361),
    [anon_sym___refvalue] = ACTIONS(3361),
    [sym_null_literal] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [sym_integer_literal] = ACTIONS(3361),
    [sym_real_literal] = ACTIONS(3363),
    [sym_verbatim_string_literal] = ACTIONS(3363),
    [aux_sym_preproc_if_token1] = ACTIONS(3363),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3363),
    [sym_interpolation_verbatim_start] = ACTIONS(3363),
    [sym_interpolation_raw_start] = ACTIONS(3363),
    [sym_raw_string_start] = ACTIONS(3363),
  },
  [2485] = {
    [sym_preproc_region] = STATE(2485),
    [sym_preproc_endregion] = STATE(2485),
    [sym_preproc_line] = STATE(2485),
    [sym_preproc_pragma] = STATE(2485),
    [sym_preproc_nullable] = STATE(2485),
    [sym_preproc_error] = STATE(2485),
    [sym_preproc_define] = STATE(2485),
    [sym_preproc_undef] = STATE(2485),
    [ts_builtin_sym_end] = ACTIONS(3327),
    [sym__identifier_token] = ACTIONS(3325),
    [anon_sym_extern] = ACTIONS(3325),
    [anon_sym_alias] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_global] = ACTIONS(3325),
    [anon_sym_using] = ACTIONS(3325),
    [anon_sym_unsafe] = ACTIONS(3325),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3325),
    [anon_sym_namespace] = ACTIONS(3325),
    [anon_sym_class] = ACTIONS(3325),
    [anon_sym_ref] = ACTIONS(3325),
    [anon_sym_struct] = ACTIONS(3325),
    [anon_sym_enum] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_interface] = ACTIONS(3325),
    [anon_sym_delegate] = ACTIONS(3325),
    [anon_sym_record] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_const] = ACTIONS(3325),
    [anon_sym_file] = ACTIONS(3325),
    [anon_sym_fixed] = ACTIONS(3325),
    [anon_sym_internal] = ACTIONS(3325),
    [anon_sym_new] = ACTIONS(3325),
    [anon_sym_override] = ACTIONS(3325),
    [anon_sym_partial] = ACTIONS(3325),
    [anon_sym_private] = ACTIONS(3325),
    [anon_sym_protected] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3325),
    [anon_sym_readonly] = ACTIONS(3325),
    [anon_sym_required] = ACTIONS(3325),
    [anon_sym_sealed] = ACTIONS(3325),
    [anon_sym_virtual] = ACTIONS(3325),
    [anon_sym_volatile] = ACTIONS(3325),
    [anon_sym_where] = ACTIONS(3325),
    [anon_sym_notnull] = ACTIONS(3325),
    [anon_sym_unmanaged] = ACTIONS(3325),
    [anon_sym_checked] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_true] = ACTIONS(3325),
    [anon_sym_false] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(3327),
    [anon_sym_CARET] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3327),
    [anon_sym_this] = ACTIONS(3325),
    [anon_sym_scoped] = ACTIONS(3325),
    [anon_sym_base] = ACTIONS(3325),
    [anon_sym_var] = ACTIONS(3325),
    [sym_predefined_type] = ACTIONS(3325),
    [anon_sym_break] = ACTIONS(3325),
    [anon_sym_unchecked] = ACTIONS(3325),
    [anon_sym_continue] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_while] = ACTIONS(3325),
    [anon_sym_for] = ACTIONS(3325),
    [anon_sym_lock] = ACTIONS(3325),
    [anon_sym_yield] = ACTIONS(3325),
    [anon_sym_switch] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(3325),
    [anon_sym_throw] = ACTIONS(3325),
    [anon_sym_try] = ACTIONS(3325),
    [anon_sym_when] = ACTIONS(3325),
    [anon_sym_await] = ACTIONS(3325),
    [anon_sym_foreach] = ACTIONS(3325),
    [anon_sym_goto] = ACTIONS(3325),
    [anon_sym_if] = ACTIONS(3325),
    [anon_sym_else] = ACTIONS(3325),
    [anon_sym_DOT_DOT] = ACTIONS(3327),
    [anon_sym_from] = ACTIONS(3325),
    [anon_sym_into] = ACTIONS(3325),
    [anon_sym_join] = ACTIONS(3325),
    [anon_sym_on] = ACTIONS(3325),
    [anon_sym_equals] = ACTIONS(3325),
    [anon_sym_let] = ACTIONS(3325),
    [anon_sym_orderby] = ACTIONS(3325),
    [anon_sym_ascending] = ACTIONS(3325),
    [anon_sym_descending] = ACTIONS(3325),
    [anon_sym_group] = ACTIONS(3325),
    [anon_sym_by] = ACTIONS(3325),
    [anon_sym_select] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3325),
    [anon_sym_sizeof] = ACTIONS(3325),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym___makeref] = ACTIONS(3325),
    [anon_sym___reftype] = ACTIONS(3325),
    [anon_sym___refvalue] = ACTIONS(3325),
    [sym_null_literal] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_integer_literal] = ACTIONS(3325),
    [sym_real_literal] = ACTIONS(3327),
    [sym_verbatim_string_literal] = ACTIONS(3327),
    [aux_sym_preproc_if_token1] = ACTIONS(3327),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3327),
    [sym_interpolation_verbatim_start] = ACTIONS(3327),
    [sym_interpolation_raw_start] = ACTIONS(3327),
    [sym_raw_string_start] = ACTIONS(3327),
  },
  [2486] = {
    [sym_preproc_region] = STATE(2486),
    [sym_preproc_endregion] = STATE(2486),
    [sym_preproc_line] = STATE(2486),
    [sym_preproc_pragma] = STATE(2486),
    [sym_preproc_nullable] = STATE(2486),
    [sym_preproc_error] = STATE(2486),
    [sym_preproc_define] = STATE(2486),
    [sym_preproc_undef] = STATE(2486),
    [ts_builtin_sym_end] = ACTIONS(3283),
    [sym__identifier_token] = ACTIONS(3281),
    [anon_sym_extern] = ACTIONS(3281),
    [anon_sym_alias] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_global] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_unsafe] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_namespace] = ACTIONS(3281),
    [anon_sym_class] = ACTIONS(3281),
    [anon_sym_ref] = ACTIONS(3281),
    [anon_sym_struct] = ACTIONS(3281),
    [anon_sym_enum] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3281),
    [anon_sym_delegate] = ACTIONS(3281),
    [anon_sym_record] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_file] = ACTIONS(3281),
    [anon_sym_fixed] = ACTIONS(3281),
    [anon_sym_internal] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_partial] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_required] = ACTIONS(3281),
    [anon_sym_sealed] = ACTIONS(3281),
    [anon_sym_virtual] = ACTIONS(3281),
    [anon_sym_volatile] = ACTIONS(3281),
    [anon_sym_where] = ACTIONS(3281),
    [anon_sym_notnull] = ACTIONS(3281),
    [anon_sym_unmanaged] = ACTIONS(3281),
    [anon_sym_checked] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_true] = ACTIONS(3281),
    [anon_sym_false] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_this] = ACTIONS(3281),
    [anon_sym_scoped] = ACTIONS(3281),
    [anon_sym_base] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [sym_predefined_type] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_unchecked] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_lock] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_foreach] = ACTIONS(3281),
    [anon_sym_goto] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_DOT_DOT] = ACTIONS(3283),
    [anon_sym_from] = ACTIONS(3281),
    [anon_sym_into] = ACTIONS(3281),
    [anon_sym_join] = ACTIONS(3281),
    [anon_sym_on] = ACTIONS(3281),
    [anon_sym_equals] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_orderby] = ACTIONS(3281),
    [anon_sym_ascending] = ACTIONS(3281),
    [anon_sym_descending] = ACTIONS(3281),
    [anon_sym_group] = ACTIONS(3281),
    [anon_sym_by] = ACTIONS(3281),
    [anon_sym_select] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym___makeref] = ACTIONS(3281),
    [anon_sym___reftype] = ACTIONS(3281),
    [anon_sym___refvalue] = ACTIONS(3281),
    [sym_null_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [sym_integer_literal] = ACTIONS(3281),
    [sym_real_literal] = ACTIONS(3283),
    [sym_verbatim_string_literal] = ACTIONS(3283),
    [aux_sym_preproc_if_token1] = ACTIONS(3283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3283),
    [sym_interpolation_verbatim_start] = ACTIONS(3283),
    [sym_interpolation_raw_start] = ACTIONS(3283),
    [sym_raw_string_start] = ACTIONS(3283),
  },
  [2487] = {
    [sym_preproc_region] = STATE(2487),
    [sym_preproc_endregion] = STATE(2487),
    [sym_preproc_line] = STATE(2487),
    [sym_preproc_pragma] = STATE(2487),
    [sym_preproc_nullable] = STATE(2487),
    [sym_preproc_error] = STATE(2487),
    [sym_preproc_define] = STATE(2487),
    [sym_preproc_undef] = STATE(2487),
    [ts_builtin_sym_end] = ACTIONS(3359),
    [sym__identifier_token] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym_alias] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_global] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_unsafe] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_namespace] = ACTIONS(3357),
    [anon_sym_class] = ACTIONS(3357),
    [anon_sym_ref] = ACTIONS(3357),
    [anon_sym_struct] = ACTIONS(3357),
    [anon_sym_enum] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_interface] = ACTIONS(3357),
    [anon_sym_delegate] = ACTIONS(3357),
    [anon_sym_record] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_file] = ACTIONS(3357),
    [anon_sym_fixed] = ACTIONS(3357),
    [anon_sym_internal] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_partial] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_required] = ACTIONS(3357),
    [anon_sym_sealed] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_where] = ACTIONS(3357),
    [anon_sym_notnull] = ACTIONS(3357),
    [anon_sym_unmanaged] = ACTIONS(3357),
    [anon_sym_checked] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_true] = ACTIONS(3357),
    [anon_sym_false] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_CARET] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_this] = ACTIONS(3357),
    [anon_sym_scoped] = ACTIONS(3357),
    [anon_sym_base] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [sym_predefined_type] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_unchecked] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_lock] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_when] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_foreach] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_DOT_DOT] = ACTIONS(3359),
    [anon_sym_from] = ACTIONS(3357),
    [anon_sym_into] = ACTIONS(3357),
    [anon_sym_join] = ACTIONS(3357),
    [anon_sym_on] = ACTIONS(3357),
    [anon_sym_equals] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_orderby] = ACTIONS(3357),
    [anon_sym_ascending] = ACTIONS(3357),
    [anon_sym_descending] = ACTIONS(3357),
    [anon_sym_group] = ACTIONS(3357),
    [anon_sym_by] = ACTIONS(3357),
    [anon_sym_select] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3357),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym___makeref] = ACTIONS(3357),
    [anon_sym___reftype] = ACTIONS(3357),
    [anon_sym___refvalue] = ACTIONS(3357),
    [sym_null_literal] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [sym_integer_literal] = ACTIONS(3357),
    [sym_real_literal] = ACTIONS(3359),
    [sym_verbatim_string_literal] = ACTIONS(3359),
    [aux_sym_preproc_if_token1] = ACTIONS(3359),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3359),
    [sym_interpolation_verbatim_start] = ACTIONS(3359),
    [sym_interpolation_raw_start] = ACTIONS(3359),
    [sym_raw_string_start] = ACTIONS(3359),
  },
  [2488] = {
    [sym_preproc_region] = STATE(2488),
    [sym_preproc_endregion] = STATE(2488),
    [sym_preproc_line] = STATE(2488),
    [sym_preproc_pragma] = STATE(2488),
    [sym_preproc_nullable] = STATE(2488),
    [sym_preproc_error] = STATE(2488),
    [sym_preproc_define] = STATE(2488),
    [sym_preproc_undef] = STATE(2488),
    [ts_builtin_sym_end] = ACTIONS(3113),
    [sym__identifier_token] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym_alias] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_global] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_unsafe] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_ref] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_interface] = ACTIONS(3111),
    [anon_sym_delegate] = ACTIONS(3111),
    [anon_sym_record] = ACTIONS(3111),
    [anon_sym_abstract] = ACTIONS(3111),
    [anon_sym_async] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_file] = ACTIONS(3111),
    [anon_sym_fixed] = ACTIONS(3111),
    [anon_sym_internal] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3111),
    [anon_sym_partial] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_readonly] = ACTIONS(3111),
    [anon_sym_required] = ACTIONS(3111),
    [anon_sym_sealed] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_where] = ACTIONS(3111),
    [anon_sym_notnull] = ACTIONS(3111),
    [anon_sym_unmanaged] = ACTIONS(3111),
    [anon_sym_checked] = ACTIONS(3111),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_true] = ACTIONS(3111),
    [anon_sym_false] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_this] = ACTIONS(3111),
    [anon_sym_scoped] = ACTIONS(3111),
    [anon_sym_base] = ACTIONS(3111),
    [anon_sym_var] = ACTIONS(3111),
    [sym_predefined_type] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_unchecked] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_lock] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_when] = ACTIONS(3111),
    [anon_sym_await] = ACTIONS(3111),
    [anon_sym_foreach] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_else] = ACTIONS(3111),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_from] = ACTIONS(3111),
    [anon_sym_into] = ACTIONS(3111),
    [anon_sym_join] = ACTIONS(3111),
    [anon_sym_on] = ACTIONS(3111),
    [anon_sym_equals] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_orderby] = ACTIONS(3111),
    [anon_sym_ascending] = ACTIONS(3111),
    [anon_sym_descending] = ACTIONS(3111),
    [anon_sym_group] = ACTIONS(3111),
    [anon_sym_by] = ACTIONS(3111),
    [anon_sym_select] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [anon_sym_stackalloc] = ACTIONS(3111),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym_typeof] = ACTIONS(3111),
    [anon_sym___makeref] = ACTIONS(3111),
    [anon_sym___reftype] = ACTIONS(3111),
    [anon_sym___refvalue] = ACTIONS(3111),
    [sym_null_literal] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [sym_integer_literal] = ACTIONS(3111),
    [sym_real_literal] = ACTIONS(3113),
    [sym_verbatim_string_literal] = ACTIONS(3113),
    [aux_sym_preproc_if_token1] = ACTIONS(3113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3113),
    [sym_interpolation_verbatim_start] = ACTIONS(3113),
    [sym_interpolation_raw_start] = ACTIONS(3113),
    [sym_raw_string_start] = ACTIONS(3113),
  },
  [2489] = {
    [sym_preproc_region] = STATE(2489),
    [sym_preproc_endregion] = STATE(2489),
    [sym_preproc_line] = STATE(2489),
    [sym_preproc_pragma] = STATE(2489),
    [sym_preproc_nullable] = STATE(2489),
    [sym_preproc_error] = STATE(2489),
    [sym_preproc_define] = STATE(2489),
    [sym_preproc_undef] = STATE(2489),
    [ts_builtin_sym_end] = ACTIONS(3053),
    [sym__identifier_token] = ACTIONS(3051),
    [anon_sym_extern] = ACTIONS(3051),
    [anon_sym_alias] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_global] = ACTIONS(3051),
    [anon_sym_using] = ACTIONS(3051),
    [anon_sym_unsafe] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_namespace] = ACTIONS(3051),
    [anon_sym_class] = ACTIONS(3051),
    [anon_sym_ref] = ACTIONS(3051),
    [anon_sym_struct] = ACTIONS(3051),
    [anon_sym_enum] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_interface] = ACTIONS(3051),
    [anon_sym_delegate] = ACTIONS(3051),
    [anon_sym_record] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_file] = ACTIONS(3051),
    [anon_sym_fixed] = ACTIONS(3051),
    [anon_sym_internal] = ACTIONS(3051),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_override] = ACTIONS(3051),
    [anon_sym_partial] = ACTIONS(3051),
    [anon_sym_private] = ACTIONS(3051),
    [anon_sym_protected] = ACTIONS(3051),
    [anon_sym_public] = ACTIONS(3051),
    [anon_sym_readonly] = ACTIONS(3051),
    [anon_sym_required] = ACTIONS(3051),
    [anon_sym_sealed] = ACTIONS(3051),
    [anon_sym_virtual] = ACTIONS(3051),
    [anon_sym_volatile] = ACTIONS(3051),
    [anon_sym_where] = ACTIONS(3051),
    [anon_sym_notnull] = ACTIONS(3051),
    [anon_sym_unmanaged] = ACTIONS(3051),
    [anon_sym_checked] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_true] = ACTIONS(3051),
    [anon_sym_false] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_this] = ACTIONS(3051),
    [anon_sym_scoped] = ACTIONS(3051),
    [anon_sym_base] = ACTIONS(3051),
    [anon_sym_var] = ACTIONS(3051),
    [sym_predefined_type] = ACTIONS(3051),
    [anon_sym_break] = ACTIONS(3051),
    [anon_sym_unchecked] = ACTIONS(3051),
    [anon_sym_continue] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_lock] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_switch] = ACTIONS(3051),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_throw] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_when] = ACTIONS(3051),
    [anon_sym_await] = ACTIONS(3051),
    [anon_sym_foreach] = ACTIONS(3051),
    [anon_sym_goto] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_from] = ACTIONS(3051),
    [anon_sym_into] = ACTIONS(3051),
    [anon_sym_join] = ACTIONS(3051),
    [anon_sym_on] = ACTIONS(3051),
    [anon_sym_equals] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_orderby] = ACTIONS(3051),
    [anon_sym_ascending] = ACTIONS(3051),
    [anon_sym_descending] = ACTIONS(3051),
    [anon_sym_group] = ACTIONS(3051),
    [anon_sym_by] = ACTIONS(3051),
    [anon_sym_select] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3051),
    [anon_sym_sizeof] = ACTIONS(3051),
    [anon_sym_typeof] = ACTIONS(3051),
    [anon_sym___makeref] = ACTIONS(3051),
    [anon_sym___reftype] = ACTIONS(3051),
    [anon_sym___refvalue] = ACTIONS(3051),
    [sym_null_literal] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [sym_integer_literal] = ACTIONS(3051),
    [sym_real_literal] = ACTIONS(3053),
    [sym_verbatim_string_literal] = ACTIONS(3053),
    [aux_sym_preproc_if_token1] = ACTIONS(3053),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3053),
    [sym_interpolation_verbatim_start] = ACTIONS(3053),
    [sym_interpolation_raw_start] = ACTIONS(3053),
    [sym_raw_string_start] = ACTIONS(3053),
  },
  [2490] = {
    [sym_preproc_region] = STATE(2490),
    [sym_preproc_endregion] = STATE(2490),
    [sym_preproc_line] = STATE(2490),
    [sym_preproc_pragma] = STATE(2490),
    [sym_preproc_nullable] = STATE(2490),
    [sym_preproc_error] = STATE(2490),
    [sym_preproc_define] = STATE(2490),
    [sym_preproc_undef] = STATE(2490),
    [ts_builtin_sym_end] = ACTIONS(3251),
    [sym__identifier_token] = ACTIONS(3249),
    [anon_sym_extern] = ACTIONS(3249),
    [anon_sym_alias] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_global] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_unsafe] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3251),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_namespace] = ACTIONS(3249),
    [anon_sym_class] = ACTIONS(3249),
    [anon_sym_ref] = ACTIONS(3249),
    [anon_sym_struct] = ACTIONS(3249),
    [anon_sym_enum] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3251),
    [anon_sym_interface] = ACTIONS(3249),
    [anon_sym_delegate] = ACTIONS(3249),
    [anon_sym_record] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_file] = ACTIONS(3249),
    [anon_sym_fixed] = ACTIONS(3249),
    [anon_sym_internal] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_partial] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_required] = ACTIONS(3249),
    [anon_sym_sealed] = ACTIONS(3249),
    [anon_sym_virtual] = ACTIONS(3249),
    [anon_sym_volatile] = ACTIONS(3249),
    [anon_sym_where] = ACTIONS(3249),
    [anon_sym_notnull] = ACTIONS(3249),
    [anon_sym_unmanaged] = ACTIONS(3249),
    [anon_sym_checked] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3251),
    [anon_sym_PLUS_PLUS] = ACTIONS(3251),
    [anon_sym_DASH_DASH] = ACTIONS(3251),
    [anon_sym_true] = ACTIONS(3249),
    [anon_sym_false] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_CARET] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_this] = ACTIONS(3249),
    [anon_sym_scoped] = ACTIONS(3249),
    [anon_sym_base] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [sym_predefined_type] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_unchecked] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_lock] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_when] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_foreach] = ACTIONS(3249),
    [anon_sym_goto] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3249),
    [anon_sym_into] = ACTIONS(3249),
    [anon_sym_join] = ACTIONS(3249),
    [anon_sym_on] = ACTIONS(3249),
    [anon_sym_equals] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_orderby] = ACTIONS(3249),
    [anon_sym_ascending] = ACTIONS(3249),
    [anon_sym_descending] = ACTIONS(3249),
    [anon_sym_group] = ACTIONS(3249),
    [anon_sym_by] = ACTIONS(3249),
    [anon_sym_select] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3249),
    [anon_sym_sizeof] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym___makeref] = ACTIONS(3249),
    [anon_sym___reftype] = ACTIONS(3249),
    [anon_sym___refvalue] = ACTIONS(3249),
    [sym_null_literal] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [sym_integer_literal] = ACTIONS(3249),
    [sym_real_literal] = ACTIONS(3251),
    [sym_verbatim_string_literal] = ACTIONS(3251),
    [aux_sym_preproc_if_token1] = ACTIONS(3251),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3251),
    [sym_interpolation_verbatim_start] = ACTIONS(3251),
    [sym_interpolation_raw_start] = ACTIONS(3251),
    [sym_raw_string_start] = ACTIONS(3251),
  },
  [2491] = {
    [sym_preproc_region] = STATE(2491),
    [sym_preproc_endregion] = STATE(2491),
    [sym_preproc_line] = STATE(2491),
    [sym_preproc_pragma] = STATE(2491),
    [sym_preproc_nullable] = STATE(2491),
    [sym_preproc_error] = STATE(2491),
    [sym_preproc_define] = STATE(2491),
    [sym_preproc_undef] = STATE(2491),
    [ts_builtin_sym_end] = ACTIONS(3061),
    [sym__identifier_token] = ACTIONS(3059),
    [anon_sym_extern] = ACTIONS(3059),
    [anon_sym_alias] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_global] = ACTIONS(3059),
    [anon_sym_using] = ACTIONS(3059),
    [anon_sym_unsafe] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_namespace] = ACTIONS(3059),
    [anon_sym_class] = ACTIONS(3059),
    [anon_sym_ref] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3059),
    [anon_sym_enum] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_interface] = ACTIONS(3059),
    [anon_sym_delegate] = ACTIONS(3059),
    [anon_sym_record] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_file] = ACTIONS(3059),
    [anon_sym_fixed] = ACTIONS(3059),
    [anon_sym_internal] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_override] = ACTIONS(3059),
    [anon_sym_partial] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3059),
    [anon_sym_protected] = ACTIONS(3059),
    [anon_sym_public] = ACTIONS(3059),
    [anon_sym_readonly] = ACTIONS(3059),
    [anon_sym_required] = ACTIONS(3059),
    [anon_sym_sealed] = ACTIONS(3059),
    [anon_sym_virtual] = ACTIONS(3059),
    [anon_sym_volatile] = ACTIONS(3059),
    [anon_sym_where] = ACTIONS(3059),
    [anon_sym_notnull] = ACTIONS(3059),
    [anon_sym_unmanaged] = ACTIONS(3059),
    [anon_sym_checked] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_true] = ACTIONS(3059),
    [anon_sym_false] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_this] = ACTIONS(3059),
    [anon_sym_scoped] = ACTIONS(3059),
    [anon_sym_base] = ACTIONS(3059),
    [anon_sym_var] = ACTIONS(3059),
    [sym_predefined_type] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_unchecked] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_lock] = ACTIONS(3059),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_throw] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_when] = ACTIONS(3059),
    [anon_sym_await] = ACTIONS(3059),
    [anon_sym_foreach] = ACTIONS(3059),
    [anon_sym_goto] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_from] = ACTIONS(3059),
    [anon_sym_into] = ACTIONS(3059),
    [anon_sym_join] = ACTIONS(3059),
    [anon_sym_on] = ACTIONS(3059),
    [anon_sym_equals] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_orderby] = ACTIONS(3059),
    [anon_sym_ascending] = ACTIONS(3059),
    [anon_sym_descending] = ACTIONS(3059),
    [anon_sym_group] = ACTIONS(3059),
    [anon_sym_by] = ACTIONS(3059),
    [anon_sym_select] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3059),
    [anon_sym_sizeof] = ACTIONS(3059),
    [anon_sym_typeof] = ACTIONS(3059),
    [anon_sym___makeref] = ACTIONS(3059),
    [anon_sym___reftype] = ACTIONS(3059),
    [anon_sym___refvalue] = ACTIONS(3059),
    [sym_null_literal] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [sym_integer_literal] = ACTIONS(3059),
    [sym_real_literal] = ACTIONS(3061),
    [sym_verbatim_string_literal] = ACTIONS(3061),
    [aux_sym_preproc_if_token1] = ACTIONS(3061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3061),
    [sym_interpolation_verbatim_start] = ACTIONS(3061),
    [sym_interpolation_raw_start] = ACTIONS(3061),
    [sym_raw_string_start] = ACTIONS(3061),
  },
  [2492] = {
    [sym_preproc_region] = STATE(2492),
    [sym_preproc_endregion] = STATE(2492),
    [sym_preproc_line] = STATE(2492),
    [sym_preproc_pragma] = STATE(2492),
    [sym_preproc_nullable] = STATE(2492),
    [sym_preproc_error] = STATE(2492),
    [sym_preproc_define] = STATE(2492),
    [sym_preproc_undef] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(3231),
    [sym__identifier_token] = ACTIONS(3229),
    [anon_sym_extern] = ACTIONS(3229),
    [anon_sym_alias] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_global] = ACTIONS(3229),
    [anon_sym_using] = ACTIONS(3229),
    [anon_sym_unsafe] = ACTIONS(3229),
    [anon_sym_static] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3229),
    [anon_sym_namespace] = ACTIONS(3229),
    [anon_sym_class] = ACTIONS(3229),
    [anon_sym_ref] = ACTIONS(3229),
    [anon_sym_struct] = ACTIONS(3229),
    [anon_sym_enum] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_interface] = ACTIONS(3229),
    [anon_sym_delegate] = ACTIONS(3229),
    [anon_sym_record] = ACTIONS(3229),
    [anon_sym_abstract] = ACTIONS(3229),
    [anon_sym_async] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_file] = ACTIONS(3229),
    [anon_sym_fixed] = ACTIONS(3229),
    [anon_sym_internal] = ACTIONS(3229),
    [anon_sym_new] = ACTIONS(3229),
    [anon_sym_override] = ACTIONS(3229),
    [anon_sym_partial] = ACTIONS(3229),
    [anon_sym_private] = ACTIONS(3229),
    [anon_sym_protected] = ACTIONS(3229),
    [anon_sym_public] = ACTIONS(3229),
    [anon_sym_readonly] = ACTIONS(3229),
    [anon_sym_required] = ACTIONS(3229),
    [anon_sym_sealed] = ACTIONS(3229),
    [anon_sym_virtual] = ACTIONS(3229),
    [anon_sym_volatile] = ACTIONS(3229),
    [anon_sym_where] = ACTIONS(3229),
    [anon_sym_notnull] = ACTIONS(3229),
    [anon_sym_unmanaged] = ACTIONS(3229),
    [anon_sym_checked] = ACTIONS(3229),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_true] = ACTIONS(3229),
    [anon_sym_false] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_CARET] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3231),
    [anon_sym_this] = ACTIONS(3229),
    [anon_sym_scoped] = ACTIONS(3229),
    [anon_sym_base] = ACTIONS(3229),
    [anon_sym_var] = ACTIONS(3229),
    [sym_predefined_type] = ACTIONS(3229),
    [anon_sym_break] = ACTIONS(3229),
    [anon_sym_unchecked] = ACTIONS(3229),
    [anon_sym_continue] = ACTIONS(3229),
    [anon_sym_do] = ACTIONS(3229),
    [anon_sym_while] = ACTIONS(3229),
    [anon_sym_for] = ACTIONS(3229),
    [anon_sym_lock] = ACTIONS(3229),
    [anon_sym_yield] = ACTIONS(3229),
    [anon_sym_switch] = ACTIONS(3229),
    [anon_sym_default] = ACTIONS(3229),
    [anon_sym_throw] = ACTIONS(3229),
    [anon_sym_try] = ACTIONS(3229),
    [anon_sym_when] = ACTIONS(3229),
    [anon_sym_await] = ACTIONS(3229),
    [anon_sym_foreach] = ACTIONS(3229),
    [anon_sym_goto] = ACTIONS(3229),
    [anon_sym_if] = ACTIONS(3229),
    [anon_sym_else] = ACTIONS(3229),
    [anon_sym_DOT_DOT] = ACTIONS(3231),
    [anon_sym_from] = ACTIONS(3229),
    [anon_sym_into] = ACTIONS(3229),
    [anon_sym_join] = ACTIONS(3229),
    [anon_sym_on] = ACTIONS(3229),
    [anon_sym_equals] = ACTIONS(3229),
    [anon_sym_let] = ACTIONS(3229),
    [anon_sym_orderby] = ACTIONS(3229),
    [anon_sym_ascending] = ACTIONS(3229),
    [anon_sym_descending] = ACTIONS(3229),
    [anon_sym_group] = ACTIONS(3229),
    [anon_sym_by] = ACTIONS(3229),
    [anon_sym_select] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3229),
    [anon_sym_sizeof] = ACTIONS(3229),
    [anon_sym_typeof] = ACTIONS(3229),
    [anon_sym___makeref] = ACTIONS(3229),
    [anon_sym___reftype] = ACTIONS(3229),
    [anon_sym___refvalue] = ACTIONS(3229),
    [sym_null_literal] = ACTIONS(3229),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [sym_integer_literal] = ACTIONS(3229),
    [sym_real_literal] = ACTIONS(3231),
    [sym_verbatim_string_literal] = ACTIONS(3231),
    [aux_sym_preproc_if_token1] = ACTIONS(3231),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3231),
    [sym_interpolation_verbatim_start] = ACTIONS(3231),
    [sym_interpolation_raw_start] = ACTIONS(3231),
    [sym_raw_string_start] = ACTIONS(3231),
  },
  [2493] = {
    [sym_preproc_region] = STATE(2493),
    [sym_preproc_endregion] = STATE(2493),
    [sym_preproc_line] = STATE(2493),
    [sym_preproc_pragma] = STATE(2493),
    [sym_preproc_nullable] = STATE(2493),
    [sym_preproc_error] = STATE(2493),
    [sym_preproc_define] = STATE(2493),
    [sym_preproc_undef] = STATE(2493),
    [ts_builtin_sym_end] = ACTIONS(3243),
    [sym__identifier_token] = ACTIONS(3241),
    [anon_sym_extern] = ACTIONS(3241),
    [anon_sym_alias] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_global] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_unsafe] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_namespace] = ACTIONS(3241),
    [anon_sym_class] = ACTIONS(3241),
    [anon_sym_ref] = ACTIONS(3241),
    [anon_sym_struct] = ACTIONS(3241),
    [anon_sym_enum] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_interface] = ACTIONS(3241),
    [anon_sym_delegate] = ACTIONS(3241),
    [anon_sym_record] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_file] = ACTIONS(3241),
    [anon_sym_fixed] = ACTIONS(3241),
    [anon_sym_internal] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_partial] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_required] = ACTIONS(3241),
    [anon_sym_sealed] = ACTIONS(3241),
    [anon_sym_virtual] = ACTIONS(3241),
    [anon_sym_volatile] = ACTIONS(3241),
    [anon_sym_where] = ACTIONS(3241),
    [anon_sym_notnull] = ACTIONS(3241),
    [anon_sym_unmanaged] = ACTIONS(3241),
    [anon_sym_checked] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [anon_sym_true] = ACTIONS(3241),
    [anon_sym_false] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_STAR] = ACTIONS(3243),
    [anon_sym_CARET] = ACTIONS(3243),
    [anon_sym_AMP] = ACTIONS(3243),
    [anon_sym_this] = ACTIONS(3241),
    [anon_sym_scoped] = ACTIONS(3241),
    [anon_sym_base] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [sym_predefined_type] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_unchecked] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_lock] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_when] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_foreach] = ACTIONS(3241),
    [anon_sym_goto] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_DOT_DOT] = ACTIONS(3243),
    [anon_sym_from] = ACTIONS(3241),
    [anon_sym_into] = ACTIONS(3241),
    [anon_sym_join] = ACTIONS(3241),
    [anon_sym_on] = ACTIONS(3241),
    [anon_sym_equals] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_orderby] = ACTIONS(3241),
    [anon_sym_ascending] = ACTIONS(3241),
    [anon_sym_descending] = ACTIONS(3241),
    [anon_sym_group] = ACTIONS(3241),
    [anon_sym_by] = ACTIONS(3241),
    [anon_sym_select] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3241),
    [anon_sym_sizeof] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym___makeref] = ACTIONS(3241),
    [anon_sym___reftype] = ACTIONS(3241),
    [anon_sym___refvalue] = ACTIONS(3241),
    [sym_null_literal] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [sym_integer_literal] = ACTIONS(3241),
    [sym_real_literal] = ACTIONS(3243),
    [sym_verbatim_string_literal] = ACTIONS(3243),
    [aux_sym_preproc_if_token1] = ACTIONS(3243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3243),
    [sym_interpolation_verbatim_start] = ACTIONS(3243),
    [sym_interpolation_raw_start] = ACTIONS(3243),
    [sym_raw_string_start] = ACTIONS(3243),
  },
  [2494] = {
    [sym_preproc_region] = STATE(2494),
    [sym_preproc_endregion] = STATE(2494),
    [sym_preproc_line] = STATE(2494),
    [sym_preproc_pragma] = STATE(2494),
    [sym_preproc_nullable] = STATE(2494),
    [sym_preproc_error] = STATE(2494),
    [sym_preproc_define] = STATE(2494),
    [sym_preproc_undef] = STATE(2494),
    [ts_builtin_sym_end] = ACTIONS(3267),
    [sym__identifier_token] = ACTIONS(3265),
    [anon_sym_extern] = ACTIONS(3265),
    [anon_sym_alias] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_global] = ACTIONS(3265),
    [anon_sym_using] = ACTIONS(3265),
    [anon_sym_unsafe] = ACTIONS(3265),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3265),
    [anon_sym_namespace] = ACTIONS(3265),
    [anon_sym_class] = ACTIONS(3265),
    [anon_sym_ref] = ACTIONS(3265),
    [anon_sym_struct] = ACTIONS(3265),
    [anon_sym_enum] = ACTIONS(3265),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_interface] = ACTIONS(3265),
    [anon_sym_delegate] = ACTIONS(3265),
    [anon_sym_record] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3265),
    [anon_sym_async] = ACTIONS(3265),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_file] = ACTIONS(3265),
    [anon_sym_fixed] = ACTIONS(3265),
    [anon_sym_internal] = ACTIONS(3265),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_override] = ACTIONS(3265),
    [anon_sym_partial] = ACTIONS(3265),
    [anon_sym_private] = ACTIONS(3265),
    [anon_sym_protected] = ACTIONS(3265),
    [anon_sym_public] = ACTIONS(3265),
    [anon_sym_readonly] = ACTIONS(3265),
    [anon_sym_required] = ACTIONS(3265),
    [anon_sym_sealed] = ACTIONS(3265),
    [anon_sym_virtual] = ACTIONS(3265),
    [anon_sym_volatile] = ACTIONS(3265),
    [anon_sym_where] = ACTIONS(3265),
    [anon_sym_notnull] = ACTIONS(3265),
    [anon_sym_unmanaged] = ACTIONS(3265),
    [anon_sym_checked] = ACTIONS(3265),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [anon_sym_true] = ACTIONS(3265),
    [anon_sym_false] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_STAR] = ACTIONS(3267),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3267),
    [anon_sym_this] = ACTIONS(3265),
    [anon_sym_scoped] = ACTIONS(3265),
    [anon_sym_base] = ACTIONS(3265),
    [anon_sym_var] = ACTIONS(3265),
    [sym_predefined_type] = ACTIONS(3265),
    [anon_sym_break] = ACTIONS(3265),
    [anon_sym_unchecked] = ACTIONS(3265),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_do] = ACTIONS(3265),
    [anon_sym_while] = ACTIONS(3265),
    [anon_sym_for] = ACTIONS(3265),
    [anon_sym_lock] = ACTIONS(3265),
    [anon_sym_yield] = ACTIONS(3265),
    [anon_sym_switch] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_throw] = ACTIONS(3265),
    [anon_sym_try] = ACTIONS(3265),
    [anon_sym_when] = ACTIONS(3265),
    [anon_sym_await] = ACTIONS(3265),
    [anon_sym_foreach] = ACTIONS(3265),
    [anon_sym_goto] = ACTIONS(3265),
    [anon_sym_if] = ACTIONS(3265),
    [anon_sym_else] = ACTIONS(3265),
    [anon_sym_DOT_DOT] = ACTIONS(3267),
    [anon_sym_from] = ACTIONS(3265),
    [anon_sym_into] = ACTIONS(3265),
    [anon_sym_join] = ACTIONS(3265),
    [anon_sym_on] = ACTIONS(3265),
    [anon_sym_equals] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_orderby] = ACTIONS(3265),
    [anon_sym_ascending] = ACTIONS(3265),
    [anon_sym_descending] = ACTIONS(3265),
    [anon_sym_group] = ACTIONS(3265),
    [anon_sym_by] = ACTIONS(3265),
    [anon_sym_select] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3265),
    [anon_sym_sizeof] = ACTIONS(3265),
    [anon_sym_typeof] = ACTIONS(3265),
    [anon_sym___makeref] = ACTIONS(3265),
    [anon_sym___reftype] = ACTIONS(3265),
    [anon_sym___refvalue] = ACTIONS(3265),
    [sym_null_literal] = ACTIONS(3265),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [sym_integer_literal] = ACTIONS(3265),
    [sym_real_literal] = ACTIONS(3267),
    [sym_verbatim_string_literal] = ACTIONS(3267),
    [aux_sym_preproc_if_token1] = ACTIONS(3267),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3267),
    [sym_interpolation_verbatim_start] = ACTIONS(3267),
    [sym_interpolation_raw_start] = ACTIONS(3267),
    [sym_raw_string_start] = ACTIONS(3267),
  },
  [2495] = {
    [sym_preproc_region] = STATE(2495),
    [sym_preproc_endregion] = STATE(2495),
    [sym_preproc_line] = STATE(2495),
    [sym_preproc_pragma] = STATE(2495),
    [sym_preproc_nullable] = STATE(2495),
    [sym_preproc_error] = STATE(2495),
    [sym_preproc_define] = STATE(2495),
    [sym_preproc_undef] = STATE(2495),
    [ts_builtin_sym_end] = ACTIONS(3223),
    [sym__identifier_token] = ACTIONS(3221),
    [anon_sym_extern] = ACTIONS(3221),
    [anon_sym_alias] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_unsafe] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_namespace] = ACTIONS(3221),
    [anon_sym_class] = ACTIONS(3221),
    [anon_sym_ref] = ACTIONS(3221),
    [anon_sym_struct] = ACTIONS(3221),
    [anon_sym_enum] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_interface] = ACTIONS(3221),
    [anon_sym_delegate] = ACTIONS(3221),
    [anon_sym_record] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_file] = ACTIONS(3221),
    [anon_sym_fixed] = ACTIONS(3221),
    [anon_sym_internal] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_partial] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_required] = ACTIONS(3221),
    [anon_sym_sealed] = ACTIONS(3221),
    [anon_sym_virtual] = ACTIONS(3221),
    [anon_sym_volatile] = ACTIONS(3221),
    [anon_sym_where] = ACTIONS(3221),
    [anon_sym_notnull] = ACTIONS(3221),
    [anon_sym_unmanaged] = ACTIONS(3221),
    [anon_sym_checked] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [anon_sym_true] = ACTIONS(3221),
    [anon_sym_false] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_this] = ACTIONS(3221),
    [anon_sym_scoped] = ACTIONS(3221),
    [anon_sym_base] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [sym_predefined_type] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_unchecked] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_lock] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_when] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_foreach] = ACTIONS(3221),
    [anon_sym_goto] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_DOT_DOT] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3221),
    [anon_sym_into] = ACTIONS(3221),
    [anon_sym_join] = ACTIONS(3221),
    [anon_sym_on] = ACTIONS(3221),
    [anon_sym_equals] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_orderby] = ACTIONS(3221),
    [anon_sym_ascending] = ACTIONS(3221),
    [anon_sym_descending] = ACTIONS(3221),
    [anon_sym_group] = ACTIONS(3221),
    [anon_sym_by] = ACTIONS(3221),
    [anon_sym_select] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3221),
    [anon_sym_sizeof] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym___makeref] = ACTIONS(3221),
    [anon_sym___reftype] = ACTIONS(3221),
    [anon_sym___refvalue] = ACTIONS(3221),
    [sym_null_literal] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [sym_integer_literal] = ACTIONS(3221),
    [sym_real_literal] = ACTIONS(3223),
    [sym_verbatim_string_literal] = ACTIONS(3223),
    [aux_sym_preproc_if_token1] = ACTIONS(3223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3223),
    [sym_interpolation_verbatim_start] = ACTIONS(3223),
    [sym_interpolation_raw_start] = ACTIONS(3223),
    [sym_raw_string_start] = ACTIONS(3223),
  },
  [2496] = {
    [sym_preproc_region] = STATE(2496),
    [sym_preproc_endregion] = STATE(2496),
    [sym_preproc_line] = STATE(2496),
    [sym_preproc_pragma] = STATE(2496),
    [sym_preproc_nullable] = STATE(2496),
    [sym_preproc_error] = STATE(2496),
    [sym_preproc_define] = STATE(2496),
    [sym_preproc_undef] = STATE(2496),
    [ts_builtin_sym_end] = ACTIONS(3219),
    [sym__identifier_token] = ACTIONS(3217),
    [anon_sym_extern] = ACTIONS(3217),
    [anon_sym_alias] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_global] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_unsafe] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_namespace] = ACTIONS(3217),
    [anon_sym_class] = ACTIONS(3217),
    [anon_sym_ref] = ACTIONS(3217),
    [anon_sym_struct] = ACTIONS(3217),
    [anon_sym_enum] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_interface] = ACTIONS(3217),
    [anon_sym_delegate] = ACTIONS(3217),
    [anon_sym_record] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_file] = ACTIONS(3217),
    [anon_sym_fixed] = ACTIONS(3217),
    [anon_sym_internal] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_partial] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_required] = ACTIONS(3217),
    [anon_sym_sealed] = ACTIONS(3217),
    [anon_sym_virtual] = ACTIONS(3217),
    [anon_sym_volatile] = ACTIONS(3217),
    [anon_sym_where] = ACTIONS(3217),
    [anon_sym_notnull] = ACTIONS(3217),
    [anon_sym_unmanaged] = ACTIONS(3217),
    [anon_sym_checked] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [anon_sym_true] = ACTIONS(3217),
    [anon_sym_false] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3219),
    [anon_sym_CARET] = ACTIONS(3219),
    [anon_sym_AMP] = ACTIONS(3219),
    [anon_sym_this] = ACTIONS(3217),
    [anon_sym_scoped] = ACTIONS(3217),
    [anon_sym_base] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [sym_predefined_type] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_unchecked] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_lock] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_when] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_foreach] = ACTIONS(3217),
    [anon_sym_goto] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_DOT_DOT] = ACTIONS(3219),
    [anon_sym_from] = ACTIONS(3217),
    [anon_sym_into] = ACTIONS(3217),
    [anon_sym_join] = ACTIONS(3217),
    [anon_sym_on] = ACTIONS(3217),
    [anon_sym_equals] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_orderby] = ACTIONS(3217),
    [anon_sym_ascending] = ACTIONS(3217),
    [anon_sym_descending] = ACTIONS(3217),
    [anon_sym_group] = ACTIONS(3217),
    [anon_sym_by] = ACTIONS(3217),
    [anon_sym_select] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3217),
    [anon_sym_sizeof] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym___makeref] = ACTIONS(3217),
    [anon_sym___reftype] = ACTIONS(3217),
    [anon_sym___refvalue] = ACTIONS(3217),
    [sym_null_literal] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [sym_integer_literal] = ACTIONS(3217),
    [sym_real_literal] = ACTIONS(3219),
    [sym_verbatim_string_literal] = ACTIONS(3219),
    [aux_sym_preproc_if_token1] = ACTIONS(3219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3219),
    [sym_interpolation_verbatim_start] = ACTIONS(3219),
    [sym_interpolation_raw_start] = ACTIONS(3219),
    [sym_raw_string_start] = ACTIONS(3219),
  },
  [2497] = {
    [sym_preproc_region] = STATE(2497),
    [sym_preproc_endregion] = STATE(2497),
    [sym_preproc_line] = STATE(2497),
    [sym_preproc_pragma] = STATE(2497),
    [sym_preproc_nullable] = STATE(2497),
    [sym_preproc_error] = STATE(2497),
    [sym_preproc_define] = STATE(2497),
    [sym_preproc_undef] = STATE(2497),
    [ts_builtin_sym_end] = ACTIONS(3069),
    [sym__identifier_token] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym_alias] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_global] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_unsafe] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_ref] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_interface] = ACTIONS(3067),
    [anon_sym_delegate] = ACTIONS(3067),
    [anon_sym_record] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_file] = ACTIONS(3067),
    [anon_sym_fixed] = ACTIONS(3067),
    [anon_sym_internal] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_override] = ACTIONS(3067),
    [anon_sym_partial] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_readonly] = ACTIONS(3067),
    [anon_sym_required] = ACTIONS(3067),
    [anon_sym_sealed] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_where] = ACTIONS(3067),
    [anon_sym_notnull] = ACTIONS(3067),
    [anon_sym_unmanaged] = ACTIONS(3067),
    [anon_sym_checked] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_true] = ACTIONS(3067),
    [anon_sym_false] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_this] = ACTIONS(3067),
    [anon_sym_scoped] = ACTIONS(3067),
    [anon_sym_base] = ACTIONS(3067),
    [anon_sym_var] = ACTIONS(3067),
    [sym_predefined_type] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_unchecked] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_lock] = ACTIONS(3067),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(3067),
    [anon_sym_await] = ACTIONS(3067),
    [anon_sym_foreach] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_from] = ACTIONS(3067),
    [anon_sym_into] = ACTIONS(3067),
    [anon_sym_join] = ACTIONS(3067),
    [anon_sym_on] = ACTIONS(3067),
    [anon_sym_equals] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_orderby] = ACTIONS(3067),
    [anon_sym_ascending] = ACTIONS(3067),
    [anon_sym_descending] = ACTIONS(3067),
    [anon_sym_group] = ACTIONS(3067),
    [anon_sym_by] = ACTIONS(3067),
    [anon_sym_select] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3067),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym_typeof] = ACTIONS(3067),
    [anon_sym___makeref] = ACTIONS(3067),
    [anon_sym___reftype] = ACTIONS(3067),
    [anon_sym___refvalue] = ACTIONS(3067),
    [sym_null_literal] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [sym_integer_literal] = ACTIONS(3067),
    [sym_real_literal] = ACTIONS(3069),
    [sym_verbatim_string_literal] = ACTIONS(3069),
    [aux_sym_preproc_if_token1] = ACTIONS(3069),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3069),
    [sym_interpolation_verbatim_start] = ACTIONS(3069),
    [sym_interpolation_raw_start] = ACTIONS(3069),
    [sym_raw_string_start] = ACTIONS(3069),
  },
  [2498] = {
    [sym_preproc_region] = STATE(2498),
    [sym_preproc_endregion] = STATE(2498),
    [sym_preproc_line] = STATE(2498),
    [sym_preproc_pragma] = STATE(2498),
    [sym_preproc_nullable] = STATE(2498),
    [sym_preproc_error] = STATE(2498),
    [sym_preproc_define] = STATE(2498),
    [sym_preproc_undef] = STATE(2498),
    [ts_builtin_sym_end] = ACTIONS(3177),
    [sym__identifier_token] = ACTIONS(3175),
    [anon_sym_extern] = ACTIONS(3175),
    [anon_sym_alias] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_global] = ACTIONS(3175),
    [anon_sym_using] = ACTIONS(3175),
    [anon_sym_unsafe] = ACTIONS(3175),
    [anon_sym_static] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_namespace] = ACTIONS(3175),
    [anon_sym_class] = ACTIONS(3175),
    [anon_sym_ref] = ACTIONS(3175),
    [anon_sym_struct] = ACTIONS(3175),
    [anon_sym_enum] = ACTIONS(3175),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_interface] = ACTIONS(3175),
    [anon_sym_delegate] = ACTIONS(3175),
    [anon_sym_record] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_async] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_file] = ACTIONS(3175),
    [anon_sym_fixed] = ACTIONS(3175),
    [anon_sym_internal] = ACTIONS(3175),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_override] = ACTIONS(3175),
    [anon_sym_partial] = ACTIONS(3175),
    [anon_sym_private] = ACTIONS(3175),
    [anon_sym_protected] = ACTIONS(3175),
    [anon_sym_public] = ACTIONS(3175),
    [anon_sym_readonly] = ACTIONS(3175),
    [anon_sym_required] = ACTIONS(3175),
    [anon_sym_sealed] = ACTIONS(3175),
    [anon_sym_virtual] = ACTIONS(3175),
    [anon_sym_volatile] = ACTIONS(3175),
    [anon_sym_where] = ACTIONS(3175),
    [anon_sym_notnull] = ACTIONS(3175),
    [anon_sym_unmanaged] = ACTIONS(3175),
    [anon_sym_checked] = ACTIONS(3175),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_true] = ACTIONS(3175),
    [anon_sym_false] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_DASH] = ACTIONS(3175),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_CARET] = ACTIONS(3177),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_this] = ACTIONS(3175),
    [anon_sym_scoped] = ACTIONS(3175),
    [anon_sym_base] = ACTIONS(3175),
    [anon_sym_var] = ACTIONS(3175),
    [sym_predefined_type] = ACTIONS(3175),
    [anon_sym_break] = ACTIONS(3175),
    [anon_sym_unchecked] = ACTIONS(3175),
    [anon_sym_continue] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_lock] = ACTIONS(3175),
    [anon_sym_yield] = ACTIONS(3175),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_default] = ACTIONS(3175),
    [anon_sym_throw] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_when] = ACTIONS(3175),
    [anon_sym_await] = ACTIONS(3175),
    [anon_sym_foreach] = ACTIONS(3175),
    [anon_sym_goto] = ACTIONS(3175),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_DOT_DOT] = ACTIONS(3177),
    [anon_sym_from] = ACTIONS(3175),
    [anon_sym_into] = ACTIONS(3175),
    [anon_sym_join] = ACTIONS(3175),
    [anon_sym_on] = ACTIONS(3175),
    [anon_sym_equals] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_orderby] = ACTIONS(3175),
    [anon_sym_ascending] = ACTIONS(3175),
    [anon_sym_descending] = ACTIONS(3175),
    [anon_sym_group] = ACTIONS(3175),
    [anon_sym_by] = ACTIONS(3175),
    [anon_sym_select] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3175),
    [anon_sym_sizeof] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3175),
    [anon_sym___makeref] = ACTIONS(3175),
    [anon_sym___reftype] = ACTIONS(3175),
    [anon_sym___refvalue] = ACTIONS(3175),
    [sym_null_literal] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [sym_integer_literal] = ACTIONS(3175),
    [sym_real_literal] = ACTIONS(3177),
    [sym_verbatim_string_literal] = ACTIONS(3177),
    [aux_sym_preproc_if_token1] = ACTIONS(3177),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3177),
    [sym_interpolation_verbatim_start] = ACTIONS(3177),
    [sym_interpolation_raw_start] = ACTIONS(3177),
    [sym_raw_string_start] = ACTIONS(3177),
  },
  [2499] = {
    [sym_catch_clause] = STATE(2654),
    [sym_finally_clause] = STATE(2671),
    [sym_preproc_region] = STATE(2499),
    [sym_preproc_endregion] = STATE(2499),
    [sym_preproc_line] = STATE(2499),
    [sym_preproc_pragma] = STATE(2499),
    [sym_preproc_nullable] = STATE(2499),
    [sym_preproc_error] = STATE(2499),
    [sym_preproc_define] = STATE(2499),
    [sym_preproc_undef] = STATE(2499),
    [aux_sym_try_statement_repeat1] = STATE(2609),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_RBRACE] = ACTIONS(3003),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_catch] = ACTIONS(4010),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_finally] = ACTIONS(4012),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2500] = {
    [sym_preproc_region] = STATE(2500),
    [sym_preproc_endregion] = STATE(2500),
    [sym_preproc_line] = STATE(2500),
    [sym_preproc_pragma] = STATE(2500),
    [sym_preproc_nullable] = STATE(2500),
    [sym_preproc_error] = STATE(2500),
    [sym_preproc_define] = STATE(2500),
    [sym_preproc_undef] = STATE(2500),
    [ts_builtin_sym_end] = ACTIONS(3093),
    [sym__identifier_token] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_alias] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_unsafe] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_ref] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_interface] = ACTIONS(3091),
    [anon_sym_delegate] = ACTIONS(3091),
    [anon_sym_record] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_file] = ACTIONS(3091),
    [anon_sym_fixed] = ACTIONS(3091),
    [anon_sym_internal] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [anon_sym_partial] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_required] = ACTIONS(3091),
    [anon_sym_sealed] = ACTIONS(3091),
    [anon_sym_virtual] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym_where] = ACTIONS(3091),
    [anon_sym_notnull] = ACTIONS(3091),
    [anon_sym_unmanaged] = ACTIONS(3091),
    [anon_sym_checked] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_true] = ACTIONS(3091),
    [anon_sym_false] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_this] = ACTIONS(3091),
    [anon_sym_scoped] = ACTIONS(3091),
    [anon_sym_base] = ACTIONS(3091),
    [anon_sym_var] = ACTIONS(3091),
    [sym_predefined_type] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_unchecked] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_lock] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_when] = ACTIONS(3091),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_foreach] = ACTIONS(3091),
    [anon_sym_goto] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_else] = ACTIONS(3091),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_from] = ACTIONS(3091),
    [anon_sym_into] = ACTIONS(3091),
    [anon_sym_join] = ACTIONS(3091),
    [anon_sym_on] = ACTIONS(3091),
    [anon_sym_equals] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_orderby] = ACTIONS(3091),
    [anon_sym_ascending] = ACTIONS(3091),
    [anon_sym_descending] = ACTIONS(3091),
    [anon_sym_group] = ACTIONS(3091),
    [anon_sym_by] = ACTIONS(3091),
    [anon_sym_select] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3091),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym___makeref] = ACTIONS(3091),
    [anon_sym___reftype] = ACTIONS(3091),
    [anon_sym___refvalue] = ACTIONS(3091),
    [sym_null_literal] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [sym_integer_literal] = ACTIONS(3091),
    [sym_real_literal] = ACTIONS(3093),
    [sym_verbatim_string_literal] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3093),
    [sym_interpolation_verbatim_start] = ACTIONS(3093),
    [sym_interpolation_raw_start] = ACTIONS(3093),
    [sym_raw_string_start] = ACTIONS(3093),
  },
  [2501] = {
    [sym_preproc_region] = STATE(2501),
    [sym_preproc_endregion] = STATE(2501),
    [sym_preproc_line] = STATE(2501),
    [sym_preproc_pragma] = STATE(2501),
    [sym_preproc_nullable] = STATE(2501),
    [sym_preproc_error] = STATE(2501),
    [sym_preproc_define] = STATE(2501),
    [sym_preproc_undef] = STATE(2501),
    [ts_builtin_sym_end] = ACTIONS(3089),
    [sym__identifier_token] = ACTIONS(3087),
    [anon_sym_extern] = ACTIONS(3087),
    [anon_sym_alias] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_global] = ACTIONS(3087),
    [anon_sym_using] = ACTIONS(3087),
    [anon_sym_unsafe] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_class] = ACTIONS(3087),
    [anon_sym_ref] = ACTIONS(3087),
    [anon_sym_struct] = ACTIONS(3087),
    [anon_sym_enum] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_interface] = ACTIONS(3087),
    [anon_sym_delegate] = ACTIONS(3087),
    [anon_sym_record] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_file] = ACTIONS(3087),
    [anon_sym_fixed] = ACTIONS(3087),
    [anon_sym_internal] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_partial] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_required] = ACTIONS(3087),
    [anon_sym_sealed] = ACTIONS(3087),
    [anon_sym_virtual] = ACTIONS(3087),
    [anon_sym_volatile] = ACTIONS(3087),
    [anon_sym_where] = ACTIONS(3087),
    [anon_sym_notnull] = ACTIONS(3087),
    [anon_sym_unmanaged] = ACTIONS(3087),
    [anon_sym_checked] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_true] = ACTIONS(3087),
    [anon_sym_false] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_CARET] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_this] = ACTIONS(3087),
    [anon_sym_scoped] = ACTIONS(3087),
    [anon_sym_base] = ACTIONS(3087),
    [anon_sym_var] = ACTIONS(3087),
    [sym_predefined_type] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_unchecked] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_lock] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_await] = ACTIONS(3087),
    [anon_sym_foreach] = ACTIONS(3087),
    [anon_sym_goto] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_from] = ACTIONS(3087),
    [anon_sym_into] = ACTIONS(3087),
    [anon_sym_join] = ACTIONS(3087),
    [anon_sym_on] = ACTIONS(3087),
    [anon_sym_equals] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_orderby] = ACTIONS(3087),
    [anon_sym_ascending] = ACTIONS(3087),
    [anon_sym_descending] = ACTIONS(3087),
    [anon_sym_group] = ACTIONS(3087),
    [anon_sym_by] = ACTIONS(3087),
    [anon_sym_select] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3087),
    [anon_sym_sizeof] = ACTIONS(3087),
    [anon_sym_typeof] = ACTIONS(3087),
    [anon_sym___makeref] = ACTIONS(3087),
    [anon_sym___reftype] = ACTIONS(3087),
    [anon_sym___refvalue] = ACTIONS(3087),
    [sym_null_literal] = ACTIONS(3087),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [sym_integer_literal] = ACTIONS(3087),
    [sym_real_literal] = ACTIONS(3089),
    [sym_verbatim_string_literal] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3089),
    [sym_interpolation_verbatim_start] = ACTIONS(3089),
    [sym_interpolation_raw_start] = ACTIONS(3089),
    [sym_raw_string_start] = ACTIONS(3089),
  },
  [2502] = {
    [sym_preproc_region] = STATE(2502),
    [sym_preproc_endregion] = STATE(2502),
    [sym_preproc_line] = STATE(2502),
    [sym_preproc_pragma] = STATE(2502),
    [sym_preproc_nullable] = STATE(2502),
    [sym_preproc_error] = STATE(2502),
    [sym_preproc_define] = STATE(2502),
    [sym_preproc_undef] = STATE(2502),
    [ts_builtin_sym_end] = ACTIONS(3105),
    [sym__identifier_token] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym_alias] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_global] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3103),
    [anon_sym_unsafe] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_ref] = ACTIONS(3103),
    [anon_sym_struct] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_interface] = ACTIONS(3103),
    [anon_sym_delegate] = ACTIONS(3103),
    [anon_sym_record] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_file] = ACTIONS(3103),
    [anon_sym_fixed] = ACTIONS(3103),
    [anon_sym_internal] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_partial] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_required] = ACTIONS(3103),
    [anon_sym_sealed] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_where] = ACTIONS(3103),
    [anon_sym_notnull] = ACTIONS(3103),
    [anon_sym_unmanaged] = ACTIONS(3103),
    [anon_sym_checked] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_true] = ACTIONS(3103),
    [anon_sym_false] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_this] = ACTIONS(3103),
    [anon_sym_scoped] = ACTIONS(3103),
    [anon_sym_base] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [sym_predefined_type] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_unchecked] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_lock] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_when] = ACTIONS(3103),
    [anon_sym_await] = ACTIONS(3103),
    [anon_sym_foreach] = ACTIONS(3103),
    [anon_sym_goto] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_from] = ACTIONS(3103),
    [anon_sym_into] = ACTIONS(3103),
    [anon_sym_join] = ACTIONS(3103),
    [anon_sym_on] = ACTIONS(3103),
    [anon_sym_equals] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_orderby] = ACTIONS(3103),
    [anon_sym_ascending] = ACTIONS(3103),
    [anon_sym_descending] = ACTIONS(3103),
    [anon_sym_group] = ACTIONS(3103),
    [anon_sym_by] = ACTIONS(3103),
    [anon_sym_select] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3103),
    [anon_sym_typeof] = ACTIONS(3103),
    [anon_sym___makeref] = ACTIONS(3103),
    [anon_sym___reftype] = ACTIONS(3103),
    [anon_sym___refvalue] = ACTIONS(3103),
    [sym_null_literal] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [sym_integer_literal] = ACTIONS(3103),
    [sym_real_literal] = ACTIONS(3105),
    [sym_verbatim_string_literal] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3105),
    [sym_interpolation_verbatim_start] = ACTIONS(3105),
    [sym_interpolation_raw_start] = ACTIONS(3105),
    [sym_raw_string_start] = ACTIONS(3105),
  },
  [2503] = {
    [sym_preproc_region] = STATE(2503),
    [sym_preproc_endregion] = STATE(2503),
    [sym_preproc_line] = STATE(2503),
    [sym_preproc_pragma] = STATE(2503),
    [sym_preproc_nullable] = STATE(2503),
    [sym_preproc_error] = STATE(2503),
    [sym_preproc_define] = STATE(2503),
    [sym_preproc_undef] = STATE(2503),
    [ts_builtin_sym_end] = ACTIONS(3081),
    [sym__identifier_token] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym_alias] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_global] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_unsafe] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_ref] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_interface] = ACTIONS(3079),
    [anon_sym_delegate] = ACTIONS(3079),
    [anon_sym_record] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_file] = ACTIONS(3079),
    [anon_sym_fixed] = ACTIONS(3079),
    [anon_sym_internal] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_override] = ACTIONS(3079),
    [anon_sym_partial] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_required] = ACTIONS(3079),
    [anon_sym_sealed] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_where] = ACTIONS(3079),
    [anon_sym_notnull] = ACTIONS(3079),
    [anon_sym_unmanaged] = ACTIONS(3079),
    [anon_sym_checked] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_true] = ACTIONS(3079),
    [anon_sym_false] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_CARET] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym_this] = ACTIONS(3079),
    [anon_sym_scoped] = ACTIONS(3079),
    [anon_sym_base] = ACTIONS(3079),
    [anon_sym_var] = ACTIONS(3079),
    [sym_predefined_type] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_unchecked] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_lock] = ACTIONS(3079),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_when] = ACTIONS(3079),
    [anon_sym_await] = ACTIONS(3079),
    [anon_sym_foreach] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_else] = ACTIONS(3079),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_from] = ACTIONS(3079),
    [anon_sym_into] = ACTIONS(3079),
    [anon_sym_join] = ACTIONS(3079),
    [anon_sym_on] = ACTIONS(3079),
    [anon_sym_equals] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_orderby] = ACTIONS(3079),
    [anon_sym_ascending] = ACTIONS(3079),
    [anon_sym_descending] = ACTIONS(3079),
    [anon_sym_group] = ACTIONS(3079),
    [anon_sym_by] = ACTIONS(3079),
    [anon_sym_select] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3079),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym_typeof] = ACTIONS(3079),
    [anon_sym___makeref] = ACTIONS(3079),
    [anon_sym___reftype] = ACTIONS(3079),
    [anon_sym___refvalue] = ACTIONS(3079),
    [sym_null_literal] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [sym_integer_literal] = ACTIONS(3079),
    [sym_real_literal] = ACTIONS(3081),
    [sym_verbatim_string_literal] = ACTIONS(3081),
    [aux_sym_preproc_if_token1] = ACTIONS(3081),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3081),
    [sym_interpolation_verbatim_start] = ACTIONS(3081),
    [sym_interpolation_raw_start] = ACTIONS(3081),
    [sym_raw_string_start] = ACTIONS(3081),
  },
  [2504] = {
    [sym_preproc_region] = STATE(2504),
    [sym_preproc_endregion] = STATE(2504),
    [sym_preproc_line] = STATE(2504),
    [sym_preproc_pragma] = STATE(2504),
    [sym_preproc_nullable] = STATE(2504),
    [sym_preproc_error] = STATE(2504),
    [sym_preproc_define] = STATE(2504),
    [sym_preproc_undef] = STATE(2504),
    [ts_builtin_sym_end] = ACTIONS(3247),
    [sym__identifier_token] = ACTIONS(3245),
    [anon_sym_extern] = ACTIONS(3245),
    [anon_sym_alias] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_global] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_unsafe] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_class] = ACTIONS(3245),
    [anon_sym_ref] = ACTIONS(3245),
    [anon_sym_struct] = ACTIONS(3245),
    [anon_sym_enum] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_interface] = ACTIONS(3245),
    [anon_sym_delegate] = ACTIONS(3245),
    [anon_sym_record] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_file] = ACTIONS(3245),
    [anon_sym_fixed] = ACTIONS(3245),
    [anon_sym_internal] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_partial] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_required] = ACTIONS(3245),
    [anon_sym_sealed] = ACTIONS(3245),
    [anon_sym_virtual] = ACTIONS(3245),
    [anon_sym_volatile] = ACTIONS(3245),
    [anon_sym_where] = ACTIONS(3245),
    [anon_sym_notnull] = ACTIONS(3245),
    [anon_sym_unmanaged] = ACTIONS(3245),
    [anon_sym_checked] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [anon_sym_true] = ACTIONS(3245),
    [anon_sym_false] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_STAR] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3247),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_this] = ACTIONS(3245),
    [anon_sym_scoped] = ACTIONS(3245),
    [anon_sym_base] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [sym_predefined_type] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_unchecked] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_lock] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_when] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_foreach] = ACTIONS(3245),
    [anon_sym_goto] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_DOT_DOT] = ACTIONS(3247),
    [anon_sym_from] = ACTIONS(3245),
    [anon_sym_into] = ACTIONS(3245),
    [anon_sym_join] = ACTIONS(3245),
    [anon_sym_on] = ACTIONS(3245),
    [anon_sym_equals] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_orderby] = ACTIONS(3245),
    [anon_sym_ascending] = ACTIONS(3245),
    [anon_sym_descending] = ACTIONS(3245),
    [anon_sym_group] = ACTIONS(3245),
    [anon_sym_by] = ACTIONS(3245),
    [anon_sym_select] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3245),
    [anon_sym_sizeof] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym___makeref] = ACTIONS(3245),
    [anon_sym___reftype] = ACTIONS(3245),
    [anon_sym___refvalue] = ACTIONS(3245),
    [sym_null_literal] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [sym_integer_literal] = ACTIONS(3245),
    [sym_real_literal] = ACTIONS(3247),
    [sym_verbatim_string_literal] = ACTIONS(3247),
    [aux_sym_preproc_if_token1] = ACTIONS(3247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3247),
    [sym_interpolation_verbatim_start] = ACTIONS(3247),
    [sym_interpolation_raw_start] = ACTIONS(3247),
    [sym_raw_string_start] = ACTIONS(3247),
  },
  [2505] = {
    [sym_preproc_region] = STATE(2505),
    [sym_preproc_endregion] = STATE(2505),
    [sym_preproc_line] = STATE(2505),
    [sym_preproc_pragma] = STATE(2505),
    [sym_preproc_nullable] = STATE(2505),
    [sym_preproc_error] = STATE(2505),
    [sym_preproc_define] = STATE(2505),
    [sym_preproc_undef] = STATE(2505),
    [ts_builtin_sym_end] = ACTIONS(3077),
    [sym__identifier_token] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym_alias] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_global] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_unsafe] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_ref] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_interface] = ACTIONS(3075),
    [anon_sym_delegate] = ACTIONS(3075),
    [anon_sym_record] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_file] = ACTIONS(3075),
    [anon_sym_fixed] = ACTIONS(3075),
    [anon_sym_internal] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_partial] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_required] = ACTIONS(3075),
    [anon_sym_sealed] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_notnull] = ACTIONS(3075),
    [anon_sym_unmanaged] = ACTIONS(3075),
    [anon_sym_checked] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_true] = ACTIONS(3075),
    [anon_sym_false] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_this] = ACTIONS(3075),
    [anon_sym_scoped] = ACTIONS(3075),
    [anon_sym_base] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [sym_predefined_type] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_unchecked] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_lock] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_when] = ACTIONS(3075),
    [anon_sym_await] = ACTIONS(3075),
    [anon_sym_foreach] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_into] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_ascending] = ACTIONS(3075),
    [anon_sym_descending] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3075),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym___makeref] = ACTIONS(3075),
    [anon_sym___reftype] = ACTIONS(3075),
    [anon_sym___refvalue] = ACTIONS(3075),
    [sym_null_literal] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [sym_integer_literal] = ACTIONS(3075),
    [sym_real_literal] = ACTIONS(3077),
    [sym_verbatim_string_literal] = ACTIONS(3077),
    [aux_sym_preproc_if_token1] = ACTIONS(3077),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3077),
    [sym_interpolation_verbatim_start] = ACTIONS(3077),
    [sym_interpolation_raw_start] = ACTIONS(3077),
    [sym_raw_string_start] = ACTIONS(3077),
  },
  [2506] = {
    [sym_preproc_region] = STATE(2506),
    [sym_preproc_endregion] = STATE(2506),
    [sym_preproc_line] = STATE(2506),
    [sym_preproc_pragma] = STATE(2506),
    [sym_preproc_nullable] = STATE(2506),
    [sym_preproc_error] = STATE(2506),
    [sym_preproc_define] = STATE(2506),
    [sym_preproc_undef] = STATE(2506),
    [ts_builtin_sym_end] = ACTIONS(3387),
    [sym__identifier_token] = ACTIONS(3385),
    [anon_sym_extern] = ACTIONS(3385),
    [anon_sym_alias] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_global] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_unsafe] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_namespace] = ACTIONS(3385),
    [anon_sym_class] = ACTIONS(3385),
    [anon_sym_ref] = ACTIONS(3385),
    [anon_sym_struct] = ACTIONS(3385),
    [anon_sym_enum] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_interface] = ACTIONS(3385),
    [anon_sym_delegate] = ACTIONS(3385),
    [anon_sym_record] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_file] = ACTIONS(3385),
    [anon_sym_fixed] = ACTIONS(3385),
    [anon_sym_internal] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_partial] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_required] = ACTIONS(3385),
    [anon_sym_sealed] = ACTIONS(3385),
    [anon_sym_virtual] = ACTIONS(3385),
    [anon_sym_volatile] = ACTIONS(3385),
    [anon_sym_where] = ACTIONS(3385),
    [anon_sym_notnull] = ACTIONS(3385),
    [anon_sym_unmanaged] = ACTIONS(3385),
    [anon_sym_checked] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_true] = ACTIONS(3385),
    [anon_sym_false] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_CARET] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_this] = ACTIONS(3385),
    [anon_sym_scoped] = ACTIONS(3385),
    [anon_sym_base] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [sym_predefined_type] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_unchecked] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_lock] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_when] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_foreach] = ACTIONS(3385),
    [anon_sym_goto] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_DOT_DOT] = ACTIONS(3387),
    [anon_sym_from] = ACTIONS(3385),
    [anon_sym_into] = ACTIONS(3385),
    [anon_sym_join] = ACTIONS(3385),
    [anon_sym_on] = ACTIONS(3385),
    [anon_sym_equals] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_orderby] = ACTIONS(3385),
    [anon_sym_ascending] = ACTIONS(3385),
    [anon_sym_descending] = ACTIONS(3385),
    [anon_sym_group] = ACTIONS(3385),
    [anon_sym_by] = ACTIONS(3385),
    [anon_sym_select] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym___makeref] = ACTIONS(3385),
    [anon_sym___reftype] = ACTIONS(3385),
    [anon_sym___refvalue] = ACTIONS(3385),
    [sym_null_literal] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [sym_integer_literal] = ACTIONS(3385),
    [sym_real_literal] = ACTIONS(3387),
    [sym_verbatim_string_literal] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3387),
    [sym_interpolation_verbatim_start] = ACTIONS(3387),
    [sym_interpolation_raw_start] = ACTIONS(3387),
    [sym_raw_string_start] = ACTIONS(3387),
  },
  [2507] = {
    [sym_preproc_region] = STATE(2507),
    [sym_preproc_endregion] = STATE(2507),
    [sym_preproc_line] = STATE(2507),
    [sym_preproc_pragma] = STATE(2507),
    [sym_preproc_nullable] = STATE(2507),
    [sym_preproc_error] = STATE(2507),
    [sym_preproc_define] = STATE(2507),
    [sym_preproc_undef] = STATE(2507),
    [ts_builtin_sym_end] = ACTIONS(3235),
    [sym__identifier_token] = ACTIONS(3233),
    [anon_sym_extern] = ACTIONS(3233),
    [anon_sym_alias] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_global] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_unsafe] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_namespace] = ACTIONS(3233),
    [anon_sym_class] = ACTIONS(3233),
    [anon_sym_ref] = ACTIONS(3233),
    [anon_sym_struct] = ACTIONS(3233),
    [anon_sym_enum] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_interface] = ACTIONS(3233),
    [anon_sym_delegate] = ACTIONS(3233),
    [anon_sym_record] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_file] = ACTIONS(3233),
    [anon_sym_fixed] = ACTIONS(3233),
    [anon_sym_internal] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_partial] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_required] = ACTIONS(3233),
    [anon_sym_sealed] = ACTIONS(3233),
    [anon_sym_virtual] = ACTIONS(3233),
    [anon_sym_volatile] = ACTIONS(3233),
    [anon_sym_where] = ACTIONS(3233),
    [anon_sym_notnull] = ACTIONS(3233),
    [anon_sym_unmanaged] = ACTIONS(3233),
    [anon_sym_checked] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_true] = ACTIONS(3233),
    [anon_sym_false] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_STAR] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_this] = ACTIONS(3233),
    [anon_sym_scoped] = ACTIONS(3233),
    [anon_sym_base] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [sym_predefined_type] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_unchecked] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_lock] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_when] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_foreach] = ACTIONS(3233),
    [anon_sym_goto] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_DOT_DOT] = ACTIONS(3235),
    [anon_sym_from] = ACTIONS(3233),
    [anon_sym_into] = ACTIONS(3233),
    [anon_sym_join] = ACTIONS(3233),
    [anon_sym_on] = ACTIONS(3233),
    [anon_sym_equals] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_orderby] = ACTIONS(3233),
    [anon_sym_ascending] = ACTIONS(3233),
    [anon_sym_descending] = ACTIONS(3233),
    [anon_sym_group] = ACTIONS(3233),
    [anon_sym_by] = ACTIONS(3233),
    [anon_sym_select] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3233),
    [anon_sym_sizeof] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym___makeref] = ACTIONS(3233),
    [anon_sym___reftype] = ACTIONS(3233),
    [anon_sym___refvalue] = ACTIONS(3233),
    [sym_null_literal] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [sym_integer_literal] = ACTIONS(3233),
    [sym_real_literal] = ACTIONS(3235),
    [sym_verbatim_string_literal] = ACTIONS(3235),
    [aux_sym_preproc_if_token1] = ACTIONS(3235),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3235),
    [sym_interpolation_verbatim_start] = ACTIONS(3235),
    [sym_interpolation_raw_start] = ACTIONS(3235),
    [sym_raw_string_start] = ACTIONS(3235),
  },
  [2508] = {
    [sym_preproc_region] = STATE(2508),
    [sym_preproc_endregion] = STATE(2508),
    [sym_preproc_line] = STATE(2508),
    [sym_preproc_pragma] = STATE(2508),
    [sym_preproc_nullable] = STATE(2508),
    [sym_preproc_error] = STATE(2508),
    [sym_preproc_define] = STATE(2508),
    [sym_preproc_undef] = STATE(2508),
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym__identifier_token] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym_alias] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_global] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_unsafe] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_namespace] = ACTIONS(3063),
    [anon_sym_class] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_enum] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_interface] = ACTIONS(3063),
    [anon_sym_delegate] = ACTIONS(3063),
    [anon_sym_record] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_file] = ACTIONS(3063),
    [anon_sym_fixed] = ACTIONS(3063),
    [anon_sym_internal] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_override] = ACTIONS(3063),
    [anon_sym_partial] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_readonly] = ACTIONS(3063),
    [anon_sym_required] = ACTIONS(3063),
    [anon_sym_sealed] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_notnull] = ACTIONS(3063),
    [anon_sym_unmanaged] = ACTIONS(3063),
    [anon_sym_checked] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_true] = ACTIONS(3063),
    [anon_sym_false] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_this] = ACTIONS(3063),
    [anon_sym_scoped] = ACTIONS(3063),
    [anon_sym_base] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [sym_predefined_type] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_unchecked] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_when] = ACTIONS(3063),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_from] = ACTIONS(3063),
    [anon_sym_into] = ACTIONS(3063),
    [anon_sym_join] = ACTIONS(3063),
    [anon_sym_on] = ACTIONS(3063),
    [anon_sym_equals] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_orderby] = ACTIONS(3063),
    [anon_sym_ascending] = ACTIONS(3063),
    [anon_sym_descending] = ACTIONS(3063),
    [anon_sym_group] = ACTIONS(3063),
    [anon_sym_by] = ACTIONS(3063),
    [anon_sym_select] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym___makeref] = ACTIONS(3063),
    [anon_sym___reftype] = ACTIONS(3063),
    [anon_sym___refvalue] = ACTIONS(3063),
    [sym_null_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_integer_literal] = ACTIONS(3063),
    [sym_real_literal] = ACTIONS(3065),
    [sym_verbatim_string_literal] = ACTIONS(3065),
    [aux_sym_preproc_if_token1] = ACTIONS(3065),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3065),
    [sym_interpolation_verbatim_start] = ACTIONS(3065),
    [sym_interpolation_raw_start] = ACTIONS(3065),
    [sym_raw_string_start] = ACTIONS(3065),
  },
  [2509] = {
    [sym_preproc_region] = STATE(2509),
    [sym_preproc_endregion] = STATE(2509),
    [sym_preproc_line] = STATE(2509),
    [sym_preproc_pragma] = STATE(2509),
    [sym_preproc_nullable] = STATE(2509),
    [sym_preproc_error] = STATE(2509),
    [sym_preproc_define] = STATE(2509),
    [sym_preproc_undef] = STATE(2509),
    [ts_builtin_sym_end] = ACTIONS(3191),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_namespace] = ACTIONS(3189),
    [anon_sym_class] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_struct] = ACTIONS(3189),
    [anon_sym_enum] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_interface] = ACTIONS(3189),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_record] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [2510] = {
    [sym_catch_clause] = STATE(2654),
    [sym_finally_clause] = STATE(2659),
    [sym_preproc_region] = STATE(2510),
    [sym_preproc_endregion] = STATE(2510),
    [sym_preproc_line] = STATE(2510),
    [sym_preproc_pragma] = STATE(2510),
    [sym_preproc_nullable] = STATE(2510),
    [sym_preproc_error] = STATE(2510),
    [sym_preproc_define] = STATE(2510),
    [sym_preproc_undef] = STATE(2510),
    [aux_sym_try_statement_repeat1] = STATE(2499),
    [sym__identifier_token] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym_alias] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym_global] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_unsafe] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_ref] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_delegate] = ACTIONS(3009),
    [anon_sym_abstract] = ACTIONS(3009),
    [anon_sym_async] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_file] = ACTIONS(3009),
    [anon_sym_fixed] = ACTIONS(3009),
    [anon_sym_internal] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_override] = ACTIONS(3009),
    [anon_sym_partial] = ACTIONS(3009),
    [anon_sym_private] = ACTIONS(3009),
    [anon_sym_protected] = ACTIONS(3009),
    [anon_sym_public] = ACTIONS(3009),
    [anon_sym_readonly] = ACTIONS(3009),
    [anon_sym_required] = ACTIONS(3009),
    [anon_sym_sealed] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_where] = ACTIONS(3009),
    [anon_sym_notnull] = ACTIONS(3009),
    [anon_sym_unmanaged] = ACTIONS(3009),
    [anon_sym_checked] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_true] = ACTIONS(3009),
    [anon_sym_false] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_CARET] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_this] = ACTIONS(3009),
    [anon_sym_scoped] = ACTIONS(3009),
    [anon_sym_base] = ACTIONS(3009),
    [anon_sym_var] = ACTIONS(3009),
    [sym_predefined_type] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_unchecked] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_lock] = ACTIONS(3009),
    [anon_sym_yield] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_catch] = ACTIONS(4010),
    [anon_sym_when] = ACTIONS(3009),
    [anon_sym_finally] = ACTIONS(4012),
    [anon_sym_await] = ACTIONS(3009),
    [anon_sym_foreach] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_else] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3011),
    [anon_sym_from] = ACTIONS(3009),
    [anon_sym_into] = ACTIONS(3009),
    [anon_sym_join] = ACTIONS(3009),
    [anon_sym_on] = ACTIONS(3009),
    [anon_sym_equals] = ACTIONS(3009),
    [anon_sym_let] = ACTIONS(3009),
    [anon_sym_orderby] = ACTIONS(3009),
    [anon_sym_ascending] = ACTIONS(3009),
    [anon_sym_descending] = ACTIONS(3009),
    [anon_sym_group] = ACTIONS(3009),
    [anon_sym_by] = ACTIONS(3009),
    [anon_sym_select] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_stackalloc] = ACTIONS(3009),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym_typeof] = ACTIONS(3009),
    [anon_sym___makeref] = ACTIONS(3009),
    [anon_sym___reftype] = ACTIONS(3009),
    [anon_sym___refvalue] = ACTIONS(3009),
    [sym_null_literal] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [sym_integer_literal] = ACTIONS(3009),
    [sym_real_literal] = ACTIONS(3011),
    [sym_verbatim_string_literal] = ACTIONS(3011),
    [aux_sym_preproc_if_token1] = ACTIONS(3011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3011),
    [sym_interpolation_verbatim_start] = ACTIONS(3011),
    [sym_interpolation_raw_start] = ACTIONS(3011),
    [sym_raw_string_start] = ACTIONS(3011),
  },
  [2511] = {
    [sym_preproc_region] = STATE(2511),
    [sym_preproc_endregion] = STATE(2511),
    [sym_preproc_line] = STATE(2511),
    [sym_preproc_pragma] = STATE(2511),
    [sym_preproc_nullable] = STATE(2511),
    [sym_preproc_error] = STATE(2511),
    [sym_preproc_define] = STATE(2511),
    [sym_preproc_undef] = STATE(2511),
    [ts_builtin_sym_end] = ACTIONS(3169),
    [sym__identifier_token] = ACTIONS(3167),
    [anon_sym_extern] = ACTIONS(3167),
    [anon_sym_alias] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_global] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_unsafe] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_namespace] = ACTIONS(3167),
    [anon_sym_class] = ACTIONS(3167),
    [anon_sym_ref] = ACTIONS(3167),
    [anon_sym_struct] = ACTIONS(3167),
    [anon_sym_enum] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_interface] = ACTIONS(3167),
    [anon_sym_delegate] = ACTIONS(3167),
    [anon_sym_record] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_file] = ACTIONS(3167),
    [anon_sym_fixed] = ACTIONS(3167),
    [anon_sym_internal] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_partial] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_required] = ACTIONS(3167),
    [anon_sym_sealed] = ACTIONS(3167),
    [anon_sym_virtual] = ACTIONS(3167),
    [anon_sym_volatile] = ACTIONS(3167),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_notnull] = ACTIONS(3167),
    [anon_sym_unmanaged] = ACTIONS(3167),
    [anon_sym_checked] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3169),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [anon_sym_true] = ACTIONS(3167),
    [anon_sym_false] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3169),
    [anon_sym_this] = ACTIONS(3167),
    [anon_sym_scoped] = ACTIONS(3167),
    [anon_sym_base] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [sym_predefined_type] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_unchecked] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_lock] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_when] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_foreach] = ACTIONS(3167),
    [anon_sym_goto] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3169),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_ascending] = ACTIONS(3167),
    [anon_sym_descending] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3167),
    [anon_sym_sizeof] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym___makeref] = ACTIONS(3167),
    [anon_sym___reftype] = ACTIONS(3167),
    [anon_sym___refvalue] = ACTIONS(3167),
    [sym_null_literal] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3169),
    [sym_integer_literal] = ACTIONS(3167),
    [sym_real_literal] = ACTIONS(3169),
    [sym_verbatim_string_literal] = ACTIONS(3169),
    [aux_sym_preproc_if_token1] = ACTIONS(3169),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3169),
    [sym_interpolation_verbatim_start] = ACTIONS(3169),
    [sym_interpolation_raw_start] = ACTIONS(3169),
    [sym_raw_string_start] = ACTIONS(3169),
  },
  [2512] = {
    [sym_preproc_region] = STATE(2512),
    [sym_preproc_endregion] = STATE(2512),
    [sym_preproc_line] = STATE(2512),
    [sym_preproc_pragma] = STATE(2512),
    [sym_preproc_nullable] = STATE(2512),
    [sym_preproc_error] = STATE(2512),
    [sym_preproc_define] = STATE(2512),
    [sym_preproc_undef] = STATE(2512),
    [ts_builtin_sym_end] = ACTIONS(3239),
    [sym__identifier_token] = ACTIONS(3237),
    [anon_sym_extern] = ACTIONS(3237),
    [anon_sym_alias] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_global] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_unsafe] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_namespace] = ACTIONS(3237),
    [anon_sym_class] = ACTIONS(3237),
    [anon_sym_ref] = ACTIONS(3237),
    [anon_sym_struct] = ACTIONS(3237),
    [anon_sym_enum] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_interface] = ACTIONS(3237),
    [anon_sym_delegate] = ACTIONS(3237),
    [anon_sym_record] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_file] = ACTIONS(3237),
    [anon_sym_fixed] = ACTIONS(3237),
    [anon_sym_internal] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_partial] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_required] = ACTIONS(3237),
    [anon_sym_sealed] = ACTIONS(3237),
    [anon_sym_virtual] = ACTIONS(3237),
    [anon_sym_volatile] = ACTIONS(3237),
    [anon_sym_where] = ACTIONS(3237),
    [anon_sym_notnull] = ACTIONS(3237),
    [anon_sym_unmanaged] = ACTIONS(3237),
    [anon_sym_checked] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [anon_sym_true] = ACTIONS(3237),
    [anon_sym_false] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_CARET] = ACTIONS(3239),
    [anon_sym_AMP] = ACTIONS(3239),
    [anon_sym_this] = ACTIONS(3237),
    [anon_sym_scoped] = ACTIONS(3237),
    [anon_sym_base] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [sym_predefined_type] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_unchecked] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_lock] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_when] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_foreach] = ACTIONS(3237),
    [anon_sym_goto] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_DOT_DOT] = ACTIONS(3239),
    [anon_sym_from] = ACTIONS(3237),
    [anon_sym_into] = ACTIONS(3237),
    [anon_sym_join] = ACTIONS(3237),
    [anon_sym_on] = ACTIONS(3237),
    [anon_sym_equals] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_orderby] = ACTIONS(3237),
    [anon_sym_ascending] = ACTIONS(3237),
    [anon_sym_descending] = ACTIONS(3237),
    [anon_sym_group] = ACTIONS(3237),
    [anon_sym_by] = ACTIONS(3237),
    [anon_sym_select] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3237),
    [anon_sym_sizeof] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym___makeref] = ACTIONS(3237),
    [anon_sym___reftype] = ACTIONS(3237),
    [anon_sym___refvalue] = ACTIONS(3237),
    [sym_null_literal] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [sym_integer_literal] = ACTIONS(3237),
    [sym_real_literal] = ACTIONS(3239),
    [sym_verbatim_string_literal] = ACTIONS(3239),
    [aux_sym_preproc_if_token1] = ACTIONS(3239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3239),
    [sym_interpolation_verbatim_start] = ACTIONS(3239),
    [sym_interpolation_raw_start] = ACTIONS(3239),
    [sym_raw_string_start] = ACTIONS(3239),
  },
  [2513] = {
    [sym_preproc_region] = STATE(2513),
    [sym_preproc_endregion] = STATE(2513),
    [sym_preproc_line] = STATE(2513),
    [sym_preproc_pragma] = STATE(2513),
    [sym_preproc_nullable] = STATE(2513),
    [sym_preproc_error] = STATE(2513),
    [sym_preproc_define] = STATE(2513),
    [sym_preproc_undef] = STATE(2513),
    [ts_builtin_sym_end] = ACTIONS(3057),
    [sym__identifier_token] = ACTIONS(3055),
    [anon_sym_extern] = ACTIONS(3055),
    [anon_sym_alias] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_global] = ACTIONS(3055),
    [anon_sym_using] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_namespace] = ACTIONS(3055),
    [anon_sym_class] = ACTIONS(3055),
    [anon_sym_ref] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_enum] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3057),
    [anon_sym_interface] = ACTIONS(3055),
    [anon_sym_delegate] = ACTIONS(3055),
    [anon_sym_record] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_file] = ACTIONS(3055),
    [anon_sym_fixed] = ACTIONS(3055),
    [anon_sym_internal] = ACTIONS(3055),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_override] = ACTIONS(3055),
    [anon_sym_partial] = ACTIONS(3055),
    [anon_sym_private] = ACTIONS(3055),
    [anon_sym_protected] = ACTIONS(3055),
    [anon_sym_public] = ACTIONS(3055),
    [anon_sym_readonly] = ACTIONS(3055),
    [anon_sym_required] = ACTIONS(3055),
    [anon_sym_sealed] = ACTIONS(3055),
    [anon_sym_virtual] = ACTIONS(3055),
    [anon_sym_volatile] = ACTIONS(3055),
    [anon_sym_where] = ACTIONS(3055),
    [anon_sym_notnull] = ACTIONS(3055),
    [anon_sym_unmanaged] = ACTIONS(3055),
    [anon_sym_checked] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3057),
    [anon_sym_true] = ACTIONS(3055),
    [anon_sym_false] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_this] = ACTIONS(3055),
    [anon_sym_scoped] = ACTIONS(3055),
    [anon_sym_base] = ACTIONS(3055),
    [anon_sym_var] = ACTIONS(3055),
    [sym_predefined_type] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_unchecked] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(3055),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_throw] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_when] = ACTIONS(3055),
    [anon_sym_await] = ACTIONS(3055),
    [anon_sym_foreach] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_from] = ACTIONS(3055),
    [anon_sym_into] = ACTIONS(3055),
    [anon_sym_join] = ACTIONS(3055),
    [anon_sym_on] = ACTIONS(3055),
    [anon_sym_equals] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_orderby] = ACTIONS(3055),
    [anon_sym_ascending] = ACTIONS(3055),
    [anon_sym_descending] = ACTIONS(3055),
    [anon_sym_group] = ACTIONS(3055),
    [anon_sym_by] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3055),
    [anon_sym_sizeof] = ACTIONS(3055),
    [anon_sym_typeof] = ACTIONS(3055),
    [anon_sym___makeref] = ACTIONS(3055),
    [anon_sym___reftype] = ACTIONS(3055),
    [anon_sym___refvalue] = ACTIONS(3055),
    [sym_null_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_integer_literal] = ACTIONS(3055),
    [sym_real_literal] = ACTIONS(3057),
    [sym_verbatim_string_literal] = ACTIONS(3057),
    [aux_sym_preproc_if_token1] = ACTIONS(3057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3057),
    [sym_interpolation_verbatim_start] = ACTIONS(3057),
    [sym_interpolation_raw_start] = ACTIONS(3057),
    [sym_raw_string_start] = ACTIONS(3057),
  },
  [2514] = {
    [sym_preproc_region] = STATE(2514),
    [sym_preproc_endregion] = STATE(2514),
    [sym_preproc_line] = STATE(2514),
    [sym_preproc_pragma] = STATE(2514),
    [sym_preproc_nullable] = STATE(2514),
    [sym_preproc_error] = STATE(2514),
    [sym_preproc_define] = STATE(2514),
    [sym_preproc_undef] = STATE(2514),
    [ts_builtin_sym_end] = ACTIONS(3339),
    [sym__identifier_token] = ACTIONS(3337),
    [anon_sym_extern] = ACTIONS(3337),
    [anon_sym_alias] = ACTIONS(3337),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_global] = ACTIONS(3337),
    [anon_sym_using] = ACTIONS(3337),
    [anon_sym_unsafe] = ACTIONS(3337),
    [anon_sym_static] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_return] = ACTIONS(3337),
    [anon_sym_namespace] = ACTIONS(3337),
    [anon_sym_class] = ACTIONS(3337),
    [anon_sym_ref] = ACTIONS(3337),
    [anon_sym_struct] = ACTIONS(3337),
    [anon_sym_enum] = ACTIONS(3337),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_interface] = ACTIONS(3337),
    [anon_sym_delegate] = ACTIONS(3337),
    [anon_sym_record] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3337),
    [anon_sym_async] = ACTIONS(3337),
    [anon_sym_const] = ACTIONS(3337),
    [anon_sym_file] = ACTIONS(3337),
    [anon_sym_fixed] = ACTIONS(3337),
    [anon_sym_internal] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3337),
    [anon_sym_override] = ACTIONS(3337),
    [anon_sym_partial] = ACTIONS(3337),
    [anon_sym_private] = ACTIONS(3337),
    [anon_sym_protected] = ACTIONS(3337),
    [anon_sym_public] = ACTIONS(3337),
    [anon_sym_readonly] = ACTIONS(3337),
    [anon_sym_required] = ACTIONS(3337),
    [anon_sym_sealed] = ACTIONS(3337),
    [anon_sym_virtual] = ACTIONS(3337),
    [anon_sym_volatile] = ACTIONS(3337),
    [anon_sym_where] = ACTIONS(3337),
    [anon_sym_notnull] = ACTIONS(3337),
    [anon_sym_unmanaged] = ACTIONS(3337),
    [anon_sym_checked] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_true] = ACTIONS(3337),
    [anon_sym_false] = ACTIONS(3337),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3339),
    [anon_sym_AMP] = ACTIONS(3339),
    [anon_sym_this] = ACTIONS(3337),
    [anon_sym_scoped] = ACTIONS(3337),
    [anon_sym_base] = ACTIONS(3337),
    [anon_sym_var] = ACTIONS(3337),
    [sym_predefined_type] = ACTIONS(3337),
    [anon_sym_break] = ACTIONS(3337),
    [anon_sym_unchecked] = ACTIONS(3337),
    [anon_sym_continue] = ACTIONS(3337),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_while] = ACTIONS(3337),
    [anon_sym_for] = ACTIONS(3337),
    [anon_sym_lock] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3337),
    [anon_sym_switch] = ACTIONS(3337),
    [anon_sym_default] = ACTIONS(3337),
    [anon_sym_throw] = ACTIONS(3337),
    [anon_sym_try] = ACTIONS(3337),
    [anon_sym_when] = ACTIONS(3337),
    [anon_sym_await] = ACTIONS(3337),
    [anon_sym_foreach] = ACTIONS(3337),
    [anon_sym_goto] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(3337),
    [anon_sym_else] = ACTIONS(3337),
    [anon_sym_DOT_DOT] = ACTIONS(3339),
    [anon_sym_from] = ACTIONS(3337),
    [anon_sym_into] = ACTIONS(3337),
    [anon_sym_join] = ACTIONS(3337),
    [anon_sym_on] = ACTIONS(3337),
    [anon_sym_equals] = ACTIONS(3337),
    [anon_sym_let] = ACTIONS(3337),
    [anon_sym_orderby] = ACTIONS(3337),
    [anon_sym_ascending] = ACTIONS(3337),
    [anon_sym_descending] = ACTIONS(3337),
    [anon_sym_group] = ACTIONS(3337),
    [anon_sym_by] = ACTIONS(3337),
    [anon_sym_select] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3337),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3337),
    [anon_sym___makeref] = ACTIONS(3337),
    [anon_sym___reftype] = ACTIONS(3337),
    [anon_sym___refvalue] = ACTIONS(3337),
    [sym_null_literal] = ACTIONS(3337),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [sym_integer_literal] = ACTIONS(3337),
    [sym_real_literal] = ACTIONS(3339),
    [sym_verbatim_string_literal] = ACTIONS(3339),
    [aux_sym_preproc_if_token1] = ACTIONS(3339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3339),
    [sym_interpolation_verbatim_start] = ACTIONS(3339),
    [sym_interpolation_raw_start] = ACTIONS(3339),
    [sym_raw_string_start] = ACTIONS(3339),
  },
  [2515] = {
    [sym_preproc_region] = STATE(2515),
    [sym_preproc_endregion] = STATE(2515),
    [sym_preproc_line] = STATE(2515),
    [sym_preproc_pragma] = STATE(2515),
    [sym_preproc_nullable] = STATE(2515),
    [sym_preproc_error] = STATE(2515),
    [sym_preproc_define] = STATE(2515),
    [sym_preproc_undef] = STATE(2515),
    [ts_builtin_sym_end] = ACTIONS(3421),
    [sym__identifier_token] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym_alias] = ACTIONS(3419),
    [anon_sym_SEMI] = ACTIONS(3421),
    [anon_sym_global] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_unsafe] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_return] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_ref] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_LBRACE] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_delegate] = ACTIONS(3419),
    [anon_sym_record] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_file] = ACTIONS(3419),
    [anon_sym_fixed] = ACTIONS(3419),
    [anon_sym_internal] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_partial] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_sealed] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_notnull] = ACTIONS(3419),
    [anon_sym_unmanaged] = ACTIONS(3419),
    [anon_sym_checked] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_PLUS_PLUS] = ACTIONS(3421),
    [anon_sym_DASH_DASH] = ACTIONS(3421),
    [anon_sym_true] = ACTIONS(3419),
    [anon_sym_false] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3419),
    [anon_sym_DASH] = ACTIONS(3419),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_this] = ACTIONS(3419),
    [anon_sym_scoped] = ACTIONS(3419),
    [anon_sym_base] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [sym_predefined_type] = ACTIONS(3419),
    [anon_sym_break] = ACTIONS(3419),
    [anon_sym_unchecked] = ACTIONS(3419),
    [anon_sym_continue] = ACTIONS(3419),
    [anon_sym_do] = ACTIONS(3419),
    [anon_sym_while] = ACTIONS(3419),
    [anon_sym_for] = ACTIONS(3419),
    [anon_sym_lock] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_switch] = ACTIONS(3419),
    [anon_sym_default] = ACTIONS(3419),
    [anon_sym_throw] = ACTIONS(3419),
    [anon_sym_try] = ACTIONS(3419),
    [anon_sym_when] = ACTIONS(3419),
    [anon_sym_await] = ACTIONS(3419),
    [anon_sym_foreach] = ACTIONS(3419),
    [anon_sym_goto] = ACTIONS(3419),
    [anon_sym_if] = ACTIONS(3419),
    [anon_sym_DOT_DOT] = ACTIONS(3421),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_into] = ACTIONS(3419),
    [anon_sym_join] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_equals] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_orderby] = ACTIONS(3419),
    [anon_sym_ascending] = ACTIONS(3419),
    [anon_sym_descending] = ACTIONS(3419),
    [anon_sym_group] = ACTIONS(3419),
    [anon_sym_by] = ACTIONS(3419),
    [anon_sym_select] = ACTIONS(3419),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [anon_sym_stackalloc] = ACTIONS(3419),
    [anon_sym_sizeof] = ACTIONS(3419),
    [anon_sym_typeof] = ACTIONS(3419),
    [anon_sym___makeref] = ACTIONS(3419),
    [anon_sym___reftype] = ACTIONS(3419),
    [anon_sym___refvalue] = ACTIONS(3419),
    [sym_null_literal] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3421),
    [sym_integer_literal] = ACTIONS(3419),
    [sym_real_literal] = ACTIONS(3421),
    [sym_verbatim_string_literal] = ACTIONS(3421),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3421),
    [sym_interpolation_verbatim_start] = ACTIONS(3421),
    [sym_interpolation_raw_start] = ACTIONS(3421),
    [sym_raw_string_start] = ACTIONS(3421),
  },
  [2516] = {
    [sym_preproc_region] = STATE(2516),
    [sym_preproc_endregion] = STATE(2516),
    [sym_preproc_line] = STATE(2516),
    [sym_preproc_pragma] = STATE(2516),
    [sym_preproc_nullable] = STATE(2516),
    [sym_preproc_error] = STATE(2516),
    [sym_preproc_define] = STATE(2516),
    [sym_preproc_undef] = STATE(2516),
    [ts_builtin_sym_end] = ACTIONS(3457),
    [sym__identifier_token] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym_alias] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3457),
    [anon_sym_global] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_unsafe] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_ref] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_delegate] = ACTIONS(3455),
    [anon_sym_record] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_file] = ACTIONS(3455),
    [anon_sym_fixed] = ACTIONS(3455),
    [anon_sym_internal] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_partial] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_required] = ACTIONS(3455),
    [anon_sym_sealed] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_where] = ACTIONS(3455),
    [anon_sym_notnull] = ACTIONS(3455),
    [anon_sym_unmanaged] = ACTIONS(3455),
    [anon_sym_checked] = ACTIONS(3455),
    [anon_sym_BANG] = ACTIONS(3457),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_PLUS_PLUS] = ACTIONS(3457),
    [anon_sym_DASH_DASH] = ACTIONS(3457),
    [anon_sym_true] = ACTIONS(3455),
    [anon_sym_false] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3457),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_AMP] = ACTIONS(3457),
    [anon_sym_this] = ACTIONS(3455),
    [anon_sym_scoped] = ACTIONS(3455),
    [anon_sym_base] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [sym_predefined_type] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_unchecked] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_lock] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_when] = ACTIONS(3455),
    [anon_sym_await] = ACTIONS(3455),
    [anon_sym_foreach] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_DOT_DOT] = ACTIONS(3457),
    [anon_sym_from] = ACTIONS(3455),
    [anon_sym_into] = ACTIONS(3455),
    [anon_sym_join] = ACTIONS(3455),
    [anon_sym_on] = ACTIONS(3455),
    [anon_sym_equals] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_orderby] = ACTIONS(3455),
    [anon_sym_ascending] = ACTIONS(3455),
    [anon_sym_descending] = ACTIONS(3455),
    [anon_sym_group] = ACTIONS(3455),
    [anon_sym_by] = ACTIONS(3455),
    [anon_sym_select] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_stackalloc] = ACTIONS(3455),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym_typeof] = ACTIONS(3455),
    [anon_sym___makeref] = ACTIONS(3455),
    [anon_sym___reftype] = ACTIONS(3455),
    [anon_sym___refvalue] = ACTIONS(3455),
    [sym_null_literal] = ACTIONS(3455),
    [anon_sym_SQUOTE] = ACTIONS(3457),
    [sym_integer_literal] = ACTIONS(3455),
    [sym_real_literal] = ACTIONS(3457),
    [sym_verbatim_string_literal] = ACTIONS(3457),
    [aux_sym_preproc_if_token1] = ACTIONS(3457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3457),
    [sym_interpolation_verbatim_start] = ACTIONS(3457),
    [sym_interpolation_raw_start] = ACTIONS(3457),
    [sym_raw_string_start] = ACTIONS(3457),
  },
  [2517] = {
    [sym_preproc_region] = STATE(2517),
    [sym_preproc_endregion] = STATE(2517),
    [sym_preproc_line] = STATE(2517),
    [sym_preproc_pragma] = STATE(2517),
    [sym_preproc_nullable] = STATE(2517),
    [sym_preproc_error] = STATE(2517),
    [sym_preproc_define] = STATE(2517),
    [sym_preproc_undef] = STATE(2517),
    [ts_builtin_sym_end] = ACTIONS(3593),
    [sym__identifier_token] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym_alias] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_global] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_unsafe] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3593),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_ref] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_delegate] = ACTIONS(3591),
    [anon_sym_record] = ACTIONS(3591),
    [anon_sym_abstract] = ACTIONS(3591),
    [anon_sym_async] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_file] = ACTIONS(3591),
    [anon_sym_fixed] = ACTIONS(3591),
    [anon_sym_internal] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_override] = ACTIONS(3591),
    [anon_sym_partial] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_readonly] = ACTIONS(3591),
    [anon_sym_required] = ACTIONS(3591),
    [anon_sym_sealed] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_where] = ACTIONS(3591),
    [anon_sym_notnull] = ACTIONS(3591),
    [anon_sym_unmanaged] = ACTIONS(3591),
    [anon_sym_checked] = ACTIONS(3591),
    [anon_sym_BANG] = ACTIONS(3593),
    [anon_sym_TILDE] = ACTIONS(3593),
    [anon_sym_PLUS_PLUS] = ACTIONS(3593),
    [anon_sym_DASH_DASH] = ACTIONS(3593),
    [anon_sym_true] = ACTIONS(3591),
    [anon_sym_false] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_STAR] = ACTIONS(3593),
    [anon_sym_CARET] = ACTIONS(3593),
    [anon_sym_AMP] = ACTIONS(3593),
    [anon_sym_this] = ACTIONS(3591),
    [anon_sym_scoped] = ACTIONS(3591),
    [anon_sym_base] = ACTIONS(3591),
    [anon_sym_var] = ACTIONS(3591),
    [sym_predefined_type] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_unchecked] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_lock] = ACTIONS(3591),
    [anon_sym_yield] = ACTIONS(3591),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_when] = ACTIONS(3591),
    [anon_sym_await] = ACTIONS(3591),
    [anon_sym_foreach] = ACTIONS(3591),
    [anon_sym_goto] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_DOT_DOT] = ACTIONS(3593),
    [anon_sym_from] = ACTIONS(3591),
    [anon_sym_into] = ACTIONS(3591),
    [anon_sym_join] = ACTIONS(3591),
    [anon_sym_on] = ACTIONS(3591),
    [anon_sym_equals] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_orderby] = ACTIONS(3591),
    [anon_sym_ascending] = ACTIONS(3591),
    [anon_sym_descending] = ACTIONS(3591),
    [anon_sym_group] = ACTIONS(3591),
    [anon_sym_by] = ACTIONS(3591),
    [anon_sym_select] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3593),
    [anon_sym_stackalloc] = ACTIONS(3591),
    [anon_sym_sizeof] = ACTIONS(3591),
    [anon_sym_typeof] = ACTIONS(3591),
    [anon_sym___makeref] = ACTIONS(3591),
    [anon_sym___reftype] = ACTIONS(3591),
    [anon_sym___refvalue] = ACTIONS(3591),
    [sym_null_literal] = ACTIONS(3591),
    [anon_sym_SQUOTE] = ACTIONS(3593),
    [sym_integer_literal] = ACTIONS(3591),
    [sym_real_literal] = ACTIONS(3593),
    [sym_verbatim_string_literal] = ACTIONS(3593),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3593),
    [sym_interpolation_verbatim_start] = ACTIONS(3593),
    [sym_interpolation_raw_start] = ACTIONS(3593),
    [sym_raw_string_start] = ACTIONS(3593),
  },
  [2518] = {
    [sym_preproc_region] = STATE(2518),
    [sym_preproc_endregion] = STATE(2518),
    [sym_preproc_line] = STATE(2518),
    [sym_preproc_pragma] = STATE(2518),
    [sym_preproc_nullable] = STATE(2518),
    [sym_preproc_error] = STATE(2518),
    [sym_preproc_define] = STATE(2518),
    [sym_preproc_undef] = STATE(2518),
    [ts_builtin_sym_end] = ACTIONS(3589),
    [sym__identifier_token] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym_alias] = ACTIONS(3587),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_global] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_unsafe] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3589),
    [anon_sym_return] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_ref] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_LBRACE] = ACTIONS(3589),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_delegate] = ACTIONS(3587),
    [anon_sym_record] = ACTIONS(3587),
    [anon_sym_abstract] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_file] = ACTIONS(3587),
    [anon_sym_fixed] = ACTIONS(3587),
    [anon_sym_internal] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_override] = ACTIONS(3587),
    [anon_sym_partial] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_readonly] = ACTIONS(3587),
    [anon_sym_required] = ACTIONS(3587),
    [anon_sym_sealed] = ACTIONS(3587),
    [anon_sym_virtual] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_where] = ACTIONS(3587),
    [anon_sym_notnull] = ACTIONS(3587),
    [anon_sym_unmanaged] = ACTIONS(3587),
    [anon_sym_checked] = ACTIONS(3587),
    [anon_sym_BANG] = ACTIONS(3589),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_PLUS_PLUS] = ACTIONS(3589),
    [anon_sym_DASH_DASH] = ACTIONS(3589),
    [anon_sym_true] = ACTIONS(3587),
    [anon_sym_false] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_CARET] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_this] = ACTIONS(3587),
    [anon_sym_scoped] = ACTIONS(3587),
    [anon_sym_base] = ACTIONS(3587),
    [anon_sym_var] = ACTIONS(3587),
    [sym_predefined_type] = ACTIONS(3587),
    [anon_sym_break] = ACTIONS(3587),
    [anon_sym_unchecked] = ACTIONS(3587),
    [anon_sym_continue] = ACTIONS(3587),
    [anon_sym_do] = ACTIONS(3587),
    [anon_sym_while] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_lock] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3587),
    [anon_sym_switch] = ACTIONS(3587),
    [anon_sym_default] = ACTIONS(3587),
    [anon_sym_throw] = ACTIONS(3587),
    [anon_sym_try] = ACTIONS(3587),
    [anon_sym_when] = ACTIONS(3587),
    [anon_sym_await] = ACTIONS(3587),
    [anon_sym_foreach] = ACTIONS(3587),
    [anon_sym_goto] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_DOT_DOT] = ACTIONS(3589),
    [anon_sym_from] = ACTIONS(3587),
    [anon_sym_into] = ACTIONS(3587),
    [anon_sym_join] = ACTIONS(3587),
    [anon_sym_on] = ACTIONS(3587),
    [anon_sym_equals] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_orderby] = ACTIONS(3587),
    [anon_sym_ascending] = ACTIONS(3587),
    [anon_sym_descending] = ACTIONS(3587),
    [anon_sym_group] = ACTIONS(3587),
    [anon_sym_by] = ACTIONS(3587),
    [anon_sym_select] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(3589),
    [anon_sym_stackalloc] = ACTIONS(3587),
    [anon_sym_sizeof] = ACTIONS(3587),
    [anon_sym_typeof] = ACTIONS(3587),
    [anon_sym___makeref] = ACTIONS(3587),
    [anon_sym___reftype] = ACTIONS(3587),
    [anon_sym___refvalue] = ACTIONS(3587),
    [sym_null_literal] = ACTIONS(3587),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [sym_integer_literal] = ACTIONS(3587),
    [sym_real_literal] = ACTIONS(3589),
    [sym_verbatim_string_literal] = ACTIONS(3589),
    [aux_sym_preproc_if_token1] = ACTIONS(3589),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3589),
    [sym_interpolation_verbatim_start] = ACTIONS(3589),
    [sym_interpolation_raw_start] = ACTIONS(3589),
    [sym_raw_string_start] = ACTIONS(3589),
  },
  [2519] = {
    [sym_preproc_region] = STATE(2519),
    [sym_preproc_endregion] = STATE(2519),
    [sym_preproc_line] = STATE(2519),
    [sym_preproc_pragma] = STATE(2519),
    [sym_preproc_nullable] = STATE(2519),
    [sym_preproc_error] = STATE(2519),
    [sym_preproc_define] = STATE(2519),
    [sym_preproc_undef] = STATE(2519),
    [ts_builtin_sym_end] = ACTIONS(3565),
    [sym__identifier_token] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym_alias] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3565),
    [anon_sym_global] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_unsafe] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_LPAREN] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_ref] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_LBRACE] = ACTIONS(3565),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_delegate] = ACTIONS(3563),
    [anon_sym_record] = ACTIONS(3563),
    [anon_sym_abstract] = ACTIONS(3563),
    [anon_sym_async] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_file] = ACTIONS(3563),
    [anon_sym_fixed] = ACTIONS(3563),
    [anon_sym_internal] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_override] = ACTIONS(3563),
    [anon_sym_partial] = ACTIONS(3563),
    [anon_sym_private] = ACTIONS(3563),
    [anon_sym_protected] = ACTIONS(3563),
    [anon_sym_public] = ACTIONS(3563),
    [anon_sym_readonly] = ACTIONS(3563),
    [anon_sym_required] = ACTIONS(3563),
    [anon_sym_sealed] = ACTIONS(3563),
    [anon_sym_virtual] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_where] = ACTIONS(3563),
    [anon_sym_notnull] = ACTIONS(3563),
    [anon_sym_unmanaged] = ACTIONS(3563),
    [anon_sym_checked] = ACTIONS(3563),
    [anon_sym_BANG] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3565),
    [anon_sym_DASH_DASH] = ACTIONS(3565),
    [anon_sym_true] = ACTIONS(3563),
    [anon_sym_false] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(3563),
    [anon_sym_DASH] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3565),
    [anon_sym_CARET] = ACTIONS(3565),
    [anon_sym_AMP] = ACTIONS(3565),
    [anon_sym_this] = ACTIONS(3563),
    [anon_sym_scoped] = ACTIONS(3563),
    [anon_sym_base] = ACTIONS(3563),
    [anon_sym_var] = ACTIONS(3563),
    [sym_predefined_type] = ACTIONS(3563),
    [anon_sym_break] = ACTIONS(3563),
    [anon_sym_unchecked] = ACTIONS(3563),
    [anon_sym_continue] = ACTIONS(3563),
    [anon_sym_do] = ACTIONS(3563),
    [anon_sym_while] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3563),
    [anon_sym_lock] = ACTIONS(3563),
    [anon_sym_yield] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3563),
    [anon_sym_default] = ACTIONS(3563),
    [anon_sym_throw] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3563),
    [anon_sym_when] = ACTIONS(3563),
    [anon_sym_await] = ACTIONS(3563),
    [anon_sym_foreach] = ACTIONS(3563),
    [anon_sym_goto] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3563),
    [anon_sym_DOT_DOT] = ACTIONS(3565),
    [anon_sym_from] = ACTIONS(3563),
    [anon_sym_into] = ACTIONS(3563),
    [anon_sym_join] = ACTIONS(3563),
    [anon_sym_on] = ACTIONS(3563),
    [anon_sym_equals] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_orderby] = ACTIONS(3563),
    [anon_sym_ascending] = ACTIONS(3563),
    [anon_sym_descending] = ACTIONS(3563),
    [anon_sym_group] = ACTIONS(3563),
    [anon_sym_by] = ACTIONS(3563),
    [anon_sym_select] = ACTIONS(3563),
    [anon_sym_DQUOTE] = ACTIONS(3565),
    [anon_sym_stackalloc] = ACTIONS(3563),
    [anon_sym_sizeof] = ACTIONS(3563),
    [anon_sym_typeof] = ACTIONS(3563),
    [anon_sym___makeref] = ACTIONS(3563),
    [anon_sym___reftype] = ACTIONS(3563),
    [anon_sym___refvalue] = ACTIONS(3563),
    [sym_null_literal] = ACTIONS(3563),
    [anon_sym_SQUOTE] = ACTIONS(3565),
    [sym_integer_literal] = ACTIONS(3563),
    [sym_real_literal] = ACTIONS(3565),
    [sym_verbatim_string_literal] = ACTIONS(3565),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3565),
    [sym_interpolation_verbatim_start] = ACTIONS(3565),
    [sym_interpolation_raw_start] = ACTIONS(3565),
    [sym_raw_string_start] = ACTIONS(3565),
  },
  [2520] = {
    [sym_preproc_region] = STATE(2520),
    [sym_preproc_endregion] = STATE(2520),
    [sym_preproc_line] = STATE(2520),
    [sym_preproc_pragma] = STATE(2520),
    [sym_preproc_nullable] = STATE(2520),
    [sym_preproc_error] = STATE(2520),
    [sym_preproc_define] = STATE(2520),
    [sym_preproc_undef] = STATE(2520),
    [ts_builtin_sym_end] = ACTIONS(3561),
    [sym__identifier_token] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym_alias] = ACTIONS(3559),
    [anon_sym_SEMI] = ACTIONS(3561),
    [anon_sym_global] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_unsafe] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3561),
    [anon_sym_LPAREN] = ACTIONS(3561),
    [anon_sym_return] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_ref] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_LBRACE] = ACTIONS(3561),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_delegate] = ACTIONS(3559),
    [anon_sym_record] = ACTIONS(3559),
    [anon_sym_abstract] = ACTIONS(3559),
    [anon_sym_async] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_file] = ACTIONS(3559),
    [anon_sym_fixed] = ACTIONS(3559),
    [anon_sym_internal] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_override] = ACTIONS(3559),
    [anon_sym_partial] = ACTIONS(3559),
    [anon_sym_private] = ACTIONS(3559),
    [anon_sym_protected] = ACTIONS(3559),
    [anon_sym_public] = ACTIONS(3559),
    [anon_sym_readonly] = ACTIONS(3559),
    [anon_sym_required] = ACTIONS(3559),
    [anon_sym_sealed] = ACTIONS(3559),
    [anon_sym_virtual] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_where] = ACTIONS(3559),
    [anon_sym_notnull] = ACTIONS(3559),
    [anon_sym_unmanaged] = ACTIONS(3559),
    [anon_sym_checked] = ACTIONS(3559),
    [anon_sym_BANG] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3561),
    [anon_sym_DASH_DASH] = ACTIONS(3561),
    [anon_sym_true] = ACTIONS(3559),
    [anon_sym_false] = ACTIONS(3559),
    [anon_sym_PLUS] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3559),
    [anon_sym_STAR] = ACTIONS(3561),
    [anon_sym_CARET] = ACTIONS(3561),
    [anon_sym_AMP] = ACTIONS(3561),
    [anon_sym_this] = ACTIONS(3559),
    [anon_sym_scoped] = ACTIONS(3559),
    [anon_sym_base] = ACTIONS(3559),
    [anon_sym_var] = ACTIONS(3559),
    [sym_predefined_type] = ACTIONS(3559),
    [anon_sym_break] = ACTIONS(3559),
    [anon_sym_unchecked] = ACTIONS(3559),
    [anon_sym_continue] = ACTIONS(3559),
    [anon_sym_do] = ACTIONS(3559),
    [anon_sym_while] = ACTIONS(3559),
    [anon_sym_for] = ACTIONS(3559),
    [anon_sym_lock] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3559),
    [anon_sym_switch] = ACTIONS(3559),
    [anon_sym_default] = ACTIONS(3559),
    [anon_sym_throw] = ACTIONS(3559),
    [anon_sym_try] = ACTIONS(3559),
    [anon_sym_when] = ACTIONS(3559),
    [anon_sym_await] = ACTIONS(3559),
    [anon_sym_foreach] = ACTIONS(3559),
    [anon_sym_goto] = ACTIONS(3559),
    [anon_sym_if] = ACTIONS(3559),
    [anon_sym_DOT_DOT] = ACTIONS(3561),
    [anon_sym_from] = ACTIONS(3559),
    [anon_sym_into] = ACTIONS(3559),
    [anon_sym_join] = ACTIONS(3559),
    [anon_sym_on] = ACTIONS(3559),
    [anon_sym_equals] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_orderby] = ACTIONS(3559),
    [anon_sym_ascending] = ACTIONS(3559),
    [anon_sym_descending] = ACTIONS(3559),
    [anon_sym_group] = ACTIONS(3559),
    [anon_sym_by] = ACTIONS(3559),
    [anon_sym_select] = ACTIONS(3559),
    [anon_sym_DQUOTE] = ACTIONS(3561),
    [anon_sym_stackalloc] = ACTIONS(3559),
    [anon_sym_sizeof] = ACTIONS(3559),
    [anon_sym_typeof] = ACTIONS(3559),
    [anon_sym___makeref] = ACTIONS(3559),
    [anon_sym___reftype] = ACTIONS(3559),
    [anon_sym___refvalue] = ACTIONS(3559),
    [sym_null_literal] = ACTIONS(3559),
    [anon_sym_SQUOTE] = ACTIONS(3561),
    [sym_integer_literal] = ACTIONS(3559),
    [sym_real_literal] = ACTIONS(3561),
    [sym_verbatim_string_literal] = ACTIONS(3561),
    [aux_sym_preproc_if_token1] = ACTIONS(3561),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3561),
    [sym_interpolation_verbatim_start] = ACTIONS(3561),
    [sym_interpolation_raw_start] = ACTIONS(3561),
    [sym_raw_string_start] = ACTIONS(3561),
  },
  [2521] = {
    [sym_preproc_region] = STATE(2521),
    [sym_preproc_endregion] = STATE(2521),
    [sym_preproc_line] = STATE(2521),
    [sym_preproc_pragma] = STATE(2521),
    [sym_preproc_nullable] = STATE(2521),
    [sym_preproc_error] = STATE(2521),
    [sym_preproc_define] = STATE(2521),
    [sym_preproc_undef] = STATE(2521),
    [ts_builtin_sym_end] = ACTIONS(3513),
    [sym__identifier_token] = ACTIONS(3511),
    [anon_sym_extern] = ACTIONS(3511),
    [anon_sym_alias] = ACTIONS(3511),
    [anon_sym_SEMI] = ACTIONS(3513),
    [anon_sym_global] = ACTIONS(3511),
    [anon_sym_using] = ACTIONS(3511),
    [anon_sym_unsafe] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_class] = ACTIONS(3511),
    [anon_sym_ref] = ACTIONS(3511),
    [anon_sym_struct] = ACTIONS(3511),
    [anon_sym_enum] = ACTIONS(3511),
    [anon_sym_LBRACE] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_delegate] = ACTIONS(3511),
    [anon_sym_record] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_async] = ACTIONS(3511),
    [anon_sym_const] = ACTIONS(3511),
    [anon_sym_file] = ACTIONS(3511),
    [anon_sym_fixed] = ACTIONS(3511),
    [anon_sym_internal] = ACTIONS(3511),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [anon_sym_partial] = ACTIONS(3511),
    [anon_sym_private] = ACTIONS(3511),
    [anon_sym_protected] = ACTIONS(3511),
    [anon_sym_public] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3511),
    [anon_sym_required] = ACTIONS(3511),
    [anon_sym_sealed] = ACTIONS(3511),
    [anon_sym_virtual] = ACTIONS(3511),
    [anon_sym_volatile] = ACTIONS(3511),
    [anon_sym_where] = ACTIONS(3511),
    [anon_sym_notnull] = ACTIONS(3511),
    [anon_sym_unmanaged] = ACTIONS(3511),
    [anon_sym_checked] = ACTIONS(3511),
    [anon_sym_BANG] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_PLUS_PLUS] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3513),
    [anon_sym_true] = ACTIONS(3511),
    [anon_sym_false] = ACTIONS(3511),
    [anon_sym_PLUS] = ACTIONS(3511),
    [anon_sym_DASH] = ACTIONS(3511),
    [anon_sym_STAR] = ACTIONS(3513),
    [anon_sym_CARET] = ACTIONS(3513),
    [anon_sym_AMP] = ACTIONS(3513),
    [anon_sym_this] = ACTIONS(3511),
    [anon_sym_scoped] = ACTIONS(3511),
    [anon_sym_base] = ACTIONS(3511),
    [anon_sym_var] = ACTIONS(3511),
    [sym_predefined_type] = ACTIONS(3511),
    [anon_sym_break] = ACTIONS(3511),
    [anon_sym_unchecked] = ACTIONS(3511),
    [anon_sym_continue] = ACTIONS(3511),
    [anon_sym_do] = ACTIONS(3511),
    [anon_sym_while] = ACTIONS(3511),
    [anon_sym_for] = ACTIONS(3511),
    [anon_sym_lock] = ACTIONS(3511),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_switch] = ACTIONS(3511),
    [anon_sym_default] = ACTIONS(3511),
    [anon_sym_throw] = ACTIONS(3511),
    [anon_sym_try] = ACTIONS(3511),
    [anon_sym_when] = ACTIONS(3511),
    [anon_sym_await] = ACTIONS(3511),
    [anon_sym_foreach] = ACTIONS(3511),
    [anon_sym_goto] = ACTIONS(3511),
    [anon_sym_if] = ACTIONS(3511),
    [anon_sym_DOT_DOT] = ACTIONS(3513),
    [anon_sym_from] = ACTIONS(3511),
    [anon_sym_into] = ACTIONS(3511),
    [anon_sym_join] = ACTIONS(3511),
    [anon_sym_on] = ACTIONS(3511),
    [anon_sym_equals] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_orderby] = ACTIONS(3511),
    [anon_sym_ascending] = ACTIONS(3511),
    [anon_sym_descending] = ACTIONS(3511),
    [anon_sym_group] = ACTIONS(3511),
    [anon_sym_by] = ACTIONS(3511),
    [anon_sym_select] = ACTIONS(3511),
    [anon_sym_DQUOTE] = ACTIONS(3513),
    [anon_sym_stackalloc] = ACTIONS(3511),
    [anon_sym_sizeof] = ACTIONS(3511),
    [anon_sym_typeof] = ACTIONS(3511),
    [anon_sym___makeref] = ACTIONS(3511),
    [anon_sym___reftype] = ACTIONS(3511),
    [anon_sym___refvalue] = ACTIONS(3511),
    [sym_null_literal] = ACTIONS(3511),
    [anon_sym_SQUOTE] = ACTIONS(3513),
    [sym_integer_literal] = ACTIONS(3511),
    [sym_real_literal] = ACTIONS(3513),
    [sym_verbatim_string_literal] = ACTIONS(3513),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3513),
    [sym_interpolation_verbatim_start] = ACTIONS(3513),
    [sym_interpolation_raw_start] = ACTIONS(3513),
    [sym_raw_string_start] = ACTIONS(3513),
  },
  [2522] = {
    [sym_preproc_region] = STATE(2522),
    [sym_preproc_endregion] = STATE(2522),
    [sym_preproc_line] = STATE(2522),
    [sym_preproc_pragma] = STATE(2522),
    [sym_preproc_nullable] = STATE(2522),
    [sym_preproc_error] = STATE(2522),
    [sym_preproc_define] = STATE(2522),
    [sym_preproc_undef] = STATE(2522),
    [ts_builtin_sym_end] = ACTIONS(3605),
    [sym__identifier_token] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym_alias] = ACTIONS(3603),
    [anon_sym_SEMI] = ACTIONS(3605),
    [anon_sym_global] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_unsafe] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_return] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_ref] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_LBRACE] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_delegate] = ACTIONS(3603),
    [anon_sym_record] = ACTIONS(3603),
    [anon_sym_abstract] = ACTIONS(3603),
    [anon_sym_async] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_file] = ACTIONS(3603),
    [anon_sym_fixed] = ACTIONS(3603),
    [anon_sym_internal] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_override] = ACTIONS(3603),
    [anon_sym_partial] = ACTIONS(3603),
    [anon_sym_private] = ACTIONS(3603),
    [anon_sym_protected] = ACTIONS(3603),
    [anon_sym_public] = ACTIONS(3603),
    [anon_sym_readonly] = ACTIONS(3603),
    [anon_sym_required] = ACTIONS(3603),
    [anon_sym_sealed] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_where] = ACTIONS(3603),
    [anon_sym_notnull] = ACTIONS(3603),
    [anon_sym_unmanaged] = ACTIONS(3603),
    [anon_sym_checked] = ACTIONS(3603),
    [anon_sym_BANG] = ACTIONS(3605),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_PLUS_PLUS] = ACTIONS(3605),
    [anon_sym_DASH_DASH] = ACTIONS(3605),
    [anon_sym_true] = ACTIONS(3603),
    [anon_sym_false] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(3603),
    [anon_sym_DASH] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_CARET] = ACTIONS(3605),
    [anon_sym_AMP] = ACTIONS(3605),
    [anon_sym_this] = ACTIONS(3603),
    [anon_sym_scoped] = ACTIONS(3603),
    [anon_sym_base] = ACTIONS(3603),
    [anon_sym_var] = ACTIONS(3603),
    [sym_predefined_type] = ACTIONS(3603),
    [anon_sym_break] = ACTIONS(3603),
    [anon_sym_unchecked] = ACTIONS(3603),
    [anon_sym_continue] = ACTIONS(3603),
    [anon_sym_do] = ACTIONS(3603),
    [anon_sym_while] = ACTIONS(3603),
    [anon_sym_for] = ACTIONS(3603),
    [anon_sym_lock] = ACTIONS(3603),
    [anon_sym_yield] = ACTIONS(3603),
    [anon_sym_switch] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3603),
    [anon_sym_throw] = ACTIONS(3603),
    [anon_sym_try] = ACTIONS(3603),
    [anon_sym_when] = ACTIONS(3603),
    [anon_sym_await] = ACTIONS(3603),
    [anon_sym_foreach] = ACTIONS(3603),
    [anon_sym_goto] = ACTIONS(3603),
    [anon_sym_if] = ACTIONS(3603),
    [anon_sym_DOT_DOT] = ACTIONS(3605),
    [anon_sym_from] = ACTIONS(3603),
    [anon_sym_into] = ACTIONS(3603),
    [anon_sym_join] = ACTIONS(3603),
    [anon_sym_on] = ACTIONS(3603),
    [anon_sym_equals] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_orderby] = ACTIONS(3603),
    [anon_sym_ascending] = ACTIONS(3603),
    [anon_sym_descending] = ACTIONS(3603),
    [anon_sym_group] = ACTIONS(3603),
    [anon_sym_by] = ACTIONS(3603),
    [anon_sym_select] = ACTIONS(3603),
    [anon_sym_DQUOTE] = ACTIONS(3605),
    [anon_sym_stackalloc] = ACTIONS(3603),
    [anon_sym_sizeof] = ACTIONS(3603),
    [anon_sym_typeof] = ACTIONS(3603),
    [anon_sym___makeref] = ACTIONS(3603),
    [anon_sym___reftype] = ACTIONS(3603),
    [anon_sym___refvalue] = ACTIONS(3603),
    [sym_null_literal] = ACTIONS(3603),
    [anon_sym_SQUOTE] = ACTIONS(3605),
    [sym_integer_literal] = ACTIONS(3603),
    [sym_real_literal] = ACTIONS(3605),
    [sym_verbatim_string_literal] = ACTIONS(3605),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3605),
    [sym_interpolation_verbatim_start] = ACTIONS(3605),
    [sym_interpolation_raw_start] = ACTIONS(3605),
    [sym_raw_string_start] = ACTIONS(3605),
  },
  [2523] = {
    [sym_preproc_region] = STATE(2523),
    [sym_preproc_endregion] = STATE(2523),
    [sym_preproc_line] = STATE(2523),
    [sym_preproc_pragma] = STATE(2523),
    [sym_preproc_nullable] = STATE(2523),
    [sym_preproc_error] = STATE(2523),
    [sym_preproc_define] = STATE(2523),
    [sym_preproc_undef] = STATE(2523),
    [ts_builtin_sym_end] = ACTIONS(3505),
    [sym__identifier_token] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym_alias] = ACTIONS(3503),
    [anon_sym_SEMI] = ACTIONS(3505),
    [anon_sym_global] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_unsafe] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_return] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_ref] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_LBRACE] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3503),
    [anon_sym_delegate] = ACTIONS(3503),
    [anon_sym_record] = ACTIONS(3503),
    [anon_sym_abstract] = ACTIONS(3503),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_file] = ACTIONS(3503),
    [anon_sym_fixed] = ACTIONS(3503),
    [anon_sym_internal] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_override] = ACTIONS(3503),
    [anon_sym_partial] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_readonly] = ACTIONS(3503),
    [anon_sym_required] = ACTIONS(3503),
    [anon_sym_sealed] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_where] = ACTIONS(3503),
    [anon_sym_notnull] = ACTIONS(3503),
    [anon_sym_unmanaged] = ACTIONS(3503),
    [anon_sym_checked] = ACTIONS(3503),
    [anon_sym_BANG] = ACTIONS(3505),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_PLUS_PLUS] = ACTIONS(3505),
    [anon_sym_DASH_DASH] = ACTIONS(3505),
    [anon_sym_true] = ACTIONS(3503),
    [anon_sym_false] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(3503),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(3505),
    [anon_sym_CARET] = ACTIONS(3505),
    [anon_sym_AMP] = ACTIONS(3505),
    [anon_sym_this] = ACTIONS(3503),
    [anon_sym_scoped] = ACTIONS(3503),
    [anon_sym_base] = ACTIONS(3503),
    [anon_sym_var] = ACTIONS(3503),
    [sym_predefined_type] = ACTIONS(3503),
    [anon_sym_break] = ACTIONS(3503),
    [anon_sym_unchecked] = ACTIONS(3503),
    [anon_sym_continue] = ACTIONS(3503),
    [anon_sym_do] = ACTIONS(3503),
    [anon_sym_while] = ACTIONS(3503),
    [anon_sym_for] = ACTIONS(3503),
    [anon_sym_lock] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3503),
    [anon_sym_switch] = ACTIONS(3503),
    [anon_sym_default] = ACTIONS(3503),
    [anon_sym_throw] = ACTIONS(3503),
    [anon_sym_try] = ACTIONS(3503),
    [anon_sym_when] = ACTIONS(3503),
    [anon_sym_await] = ACTIONS(3503),
    [anon_sym_foreach] = ACTIONS(3503),
    [anon_sym_goto] = ACTIONS(3503),
    [anon_sym_if] = ACTIONS(3503),
    [anon_sym_DOT_DOT] = ACTIONS(3505),
    [anon_sym_from] = ACTIONS(3503),
    [anon_sym_into] = ACTIONS(3503),
    [anon_sym_join] = ACTIONS(3503),
    [anon_sym_on] = ACTIONS(3503),
    [anon_sym_equals] = ACTIONS(3503),
    [anon_sym_let] = ACTIONS(3503),
    [anon_sym_orderby] = ACTIONS(3503),
    [anon_sym_ascending] = ACTIONS(3503),
    [anon_sym_descending] = ACTIONS(3503),
    [anon_sym_group] = ACTIONS(3503),
    [anon_sym_by] = ACTIONS(3503),
    [anon_sym_select] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3505),
    [anon_sym_stackalloc] = ACTIONS(3503),
    [anon_sym_sizeof] = ACTIONS(3503),
    [anon_sym_typeof] = ACTIONS(3503),
    [anon_sym___makeref] = ACTIONS(3503),
    [anon_sym___reftype] = ACTIONS(3503),
    [anon_sym___refvalue] = ACTIONS(3503),
    [sym_null_literal] = ACTIONS(3503),
    [anon_sym_SQUOTE] = ACTIONS(3505),
    [sym_integer_literal] = ACTIONS(3503),
    [sym_real_literal] = ACTIONS(3505),
    [sym_verbatim_string_literal] = ACTIONS(3505),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3505),
    [sym_interpolation_verbatim_start] = ACTIONS(3505),
    [sym_interpolation_raw_start] = ACTIONS(3505),
    [sym_raw_string_start] = ACTIONS(3505),
  },
  [2524] = {
    [sym_preproc_region] = STATE(2524),
    [sym_preproc_endregion] = STATE(2524),
    [sym_preproc_line] = STATE(2524),
    [sym_preproc_pragma] = STATE(2524),
    [sym_preproc_nullable] = STATE(2524),
    [sym_preproc_error] = STATE(2524),
    [sym_preproc_define] = STATE(2524),
    [sym_preproc_undef] = STATE(2524),
    [ts_builtin_sym_end] = ACTIONS(3733),
    [sym__identifier_token] = ACTIONS(3731),
    [anon_sym_extern] = ACTIONS(3731),
    [anon_sym_alias] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3733),
    [anon_sym_global] = ACTIONS(3731),
    [anon_sym_using] = ACTIONS(3731),
    [anon_sym_unsafe] = ACTIONS(3731),
    [anon_sym_static] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3733),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [anon_sym_return] = ACTIONS(3731),
    [anon_sym_namespace] = ACTIONS(3731),
    [anon_sym_class] = ACTIONS(3731),
    [anon_sym_ref] = ACTIONS(3731),
    [anon_sym_struct] = ACTIONS(3731),
    [anon_sym_enum] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3733),
    [anon_sym_interface] = ACTIONS(3731),
    [anon_sym_delegate] = ACTIONS(3731),
    [anon_sym_record] = ACTIONS(3731),
    [anon_sym_abstract] = ACTIONS(3731),
    [anon_sym_async] = ACTIONS(3731),
    [anon_sym_const] = ACTIONS(3731),
    [anon_sym_file] = ACTIONS(3731),
    [anon_sym_fixed] = ACTIONS(3731),
    [anon_sym_internal] = ACTIONS(3731),
    [anon_sym_new] = ACTIONS(3731),
    [anon_sym_override] = ACTIONS(3731),
    [anon_sym_partial] = ACTIONS(3731),
    [anon_sym_private] = ACTIONS(3731),
    [anon_sym_protected] = ACTIONS(3731),
    [anon_sym_public] = ACTIONS(3731),
    [anon_sym_readonly] = ACTIONS(3731),
    [anon_sym_required] = ACTIONS(3731),
    [anon_sym_sealed] = ACTIONS(3731),
    [anon_sym_virtual] = ACTIONS(3731),
    [anon_sym_volatile] = ACTIONS(3731),
    [anon_sym_where] = ACTIONS(3731),
    [anon_sym_notnull] = ACTIONS(3731),
    [anon_sym_unmanaged] = ACTIONS(3731),
    [anon_sym_checked] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3733),
    [anon_sym_TILDE] = ACTIONS(3733),
    [anon_sym_PLUS_PLUS] = ACTIONS(3733),
    [anon_sym_DASH_DASH] = ACTIONS(3733),
    [anon_sym_true] = ACTIONS(3731),
    [anon_sym_false] = ACTIONS(3731),
    [anon_sym_PLUS] = ACTIONS(3731),
    [anon_sym_DASH] = ACTIONS(3731),
    [anon_sym_STAR] = ACTIONS(3733),
    [anon_sym_CARET] = ACTIONS(3733),
    [anon_sym_AMP] = ACTIONS(3733),
    [anon_sym_this] = ACTIONS(3731),
    [anon_sym_scoped] = ACTIONS(3731),
    [anon_sym_base] = ACTIONS(3731),
    [anon_sym_var] = ACTIONS(3731),
    [sym_predefined_type] = ACTIONS(3731),
    [anon_sym_break] = ACTIONS(3731),
    [anon_sym_unchecked] = ACTIONS(3731),
    [anon_sym_continue] = ACTIONS(3731),
    [anon_sym_do] = ACTIONS(3731),
    [anon_sym_while] = ACTIONS(3731),
    [anon_sym_for] = ACTIONS(3731),
    [anon_sym_lock] = ACTIONS(3731),
    [anon_sym_yield] = ACTIONS(3731),
    [anon_sym_switch] = ACTIONS(3731),
    [anon_sym_default] = ACTIONS(3731),
    [anon_sym_throw] = ACTIONS(3731),
    [anon_sym_try] = ACTIONS(3731),
    [anon_sym_when] = ACTIONS(3731),
    [anon_sym_await] = ACTIONS(3731),
    [anon_sym_foreach] = ACTIONS(3731),
    [anon_sym_goto] = ACTIONS(3731),
    [anon_sym_if] = ACTIONS(3731),
    [anon_sym_DOT_DOT] = ACTIONS(3733),
    [anon_sym_from] = ACTIONS(3731),
    [anon_sym_into] = ACTIONS(3731),
    [anon_sym_join] = ACTIONS(3731),
    [anon_sym_on] = ACTIONS(3731),
    [anon_sym_equals] = ACTIONS(3731),
    [anon_sym_let] = ACTIONS(3731),
    [anon_sym_orderby] = ACTIONS(3731),
    [anon_sym_ascending] = ACTIONS(3731),
    [anon_sym_descending] = ACTIONS(3731),
    [anon_sym_group] = ACTIONS(3731),
    [anon_sym_by] = ACTIONS(3731),
    [anon_sym_select] = ACTIONS(3731),
    [anon_sym_DQUOTE] = ACTIONS(3733),
    [anon_sym_stackalloc] = ACTIONS(3731),
    [anon_sym_sizeof] = ACTIONS(3731),
    [anon_sym_typeof] = ACTIONS(3731),
    [anon_sym___makeref] = ACTIONS(3731),
    [anon_sym___reftype] = ACTIONS(3731),
    [anon_sym___refvalue] = ACTIONS(3731),
    [sym_null_literal] = ACTIONS(3731),
    [anon_sym_SQUOTE] = ACTIONS(3733),
    [sym_integer_literal] = ACTIONS(3731),
    [sym_real_literal] = ACTIONS(3733),
    [sym_verbatim_string_literal] = ACTIONS(3733),
    [aux_sym_preproc_if_token1] = ACTIONS(3733),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3733),
    [sym_interpolation_verbatim_start] = ACTIONS(3733),
    [sym_interpolation_raw_start] = ACTIONS(3733),
    [sym_raw_string_start] = ACTIONS(3733),
  },
  [2525] = {
    [sym_preproc_region] = STATE(2525),
    [sym_preproc_endregion] = STATE(2525),
    [sym_preproc_line] = STATE(2525),
    [sym_preproc_pragma] = STATE(2525),
    [sym_preproc_nullable] = STATE(2525),
    [sym_preproc_error] = STATE(2525),
    [sym_preproc_define] = STATE(2525),
    [sym_preproc_undef] = STATE(2525),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [sym__identifier_token] = ACTIONS(3523),
    [anon_sym_extern] = ACTIONS(3523),
    [anon_sym_alias] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3523),
    [anon_sym_using] = ACTIONS(3523),
    [anon_sym_unsafe] = ACTIONS(3523),
    [anon_sym_static] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_namespace] = ACTIONS(3523),
    [anon_sym_class] = ACTIONS(3523),
    [anon_sym_ref] = ACTIONS(3523),
    [anon_sym_struct] = ACTIONS(3523),
    [anon_sym_enum] = ACTIONS(3523),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3523),
    [anon_sym_delegate] = ACTIONS(3523),
    [anon_sym_record] = ACTIONS(3523),
    [anon_sym_abstract] = ACTIONS(3523),
    [anon_sym_async] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3523),
    [anon_sym_file] = ACTIONS(3523),
    [anon_sym_fixed] = ACTIONS(3523),
    [anon_sym_internal] = ACTIONS(3523),
    [anon_sym_new] = ACTIONS(3523),
    [anon_sym_override] = ACTIONS(3523),
    [anon_sym_partial] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_readonly] = ACTIONS(3523),
    [anon_sym_required] = ACTIONS(3523),
    [anon_sym_sealed] = ACTIONS(3523),
    [anon_sym_virtual] = ACTIONS(3523),
    [anon_sym_volatile] = ACTIONS(3523),
    [anon_sym_where] = ACTIONS(3523),
    [anon_sym_notnull] = ACTIONS(3523),
    [anon_sym_unmanaged] = ACTIONS(3523),
    [anon_sym_checked] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3525),
    [anon_sym_true] = ACTIONS(3523),
    [anon_sym_false] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_CARET] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_this] = ACTIONS(3523),
    [anon_sym_scoped] = ACTIONS(3523),
    [anon_sym_base] = ACTIONS(3523),
    [anon_sym_var] = ACTIONS(3523),
    [sym_predefined_type] = ACTIONS(3523),
    [anon_sym_break] = ACTIONS(3523),
    [anon_sym_unchecked] = ACTIONS(3523),
    [anon_sym_continue] = ACTIONS(3523),
    [anon_sym_do] = ACTIONS(3523),
    [anon_sym_while] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3523),
    [anon_sym_lock] = ACTIONS(3523),
    [anon_sym_yield] = ACTIONS(3523),
    [anon_sym_switch] = ACTIONS(3523),
    [anon_sym_default] = ACTIONS(3523),
    [anon_sym_throw] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3523),
    [anon_sym_when] = ACTIONS(3523),
    [anon_sym_await] = ACTIONS(3523),
    [anon_sym_foreach] = ACTIONS(3523),
    [anon_sym_goto] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(3523),
    [anon_sym_DOT_DOT] = ACTIONS(3525),
    [anon_sym_from] = ACTIONS(3523),
    [anon_sym_into] = ACTIONS(3523),
    [anon_sym_join] = ACTIONS(3523),
    [anon_sym_on] = ACTIONS(3523),
    [anon_sym_equals] = ACTIONS(3523),
    [anon_sym_let] = ACTIONS(3523),
    [anon_sym_orderby] = ACTIONS(3523),
    [anon_sym_ascending] = ACTIONS(3523),
    [anon_sym_descending] = ACTIONS(3523),
    [anon_sym_group] = ACTIONS(3523),
    [anon_sym_by] = ACTIONS(3523),
    [anon_sym_select] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_stackalloc] = ACTIONS(3523),
    [anon_sym_sizeof] = ACTIONS(3523),
    [anon_sym_typeof] = ACTIONS(3523),
    [anon_sym___makeref] = ACTIONS(3523),
    [anon_sym___reftype] = ACTIONS(3523),
    [anon_sym___refvalue] = ACTIONS(3523),
    [sym_null_literal] = ACTIONS(3523),
    [anon_sym_SQUOTE] = ACTIONS(3525),
    [sym_integer_literal] = ACTIONS(3523),
    [sym_real_literal] = ACTIONS(3525),
    [sym_verbatim_string_literal] = ACTIONS(3525),
    [aux_sym_preproc_if_token1] = ACTIONS(3525),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3525),
    [sym_interpolation_verbatim_start] = ACTIONS(3525),
    [sym_interpolation_raw_start] = ACTIONS(3525),
    [sym_raw_string_start] = ACTIONS(3525),
  },
  [2526] = {
    [sym_preproc_region] = STATE(2526),
    [sym_preproc_endregion] = STATE(2526),
    [sym_preproc_line] = STATE(2526),
    [sym_preproc_pragma] = STATE(2526),
    [sym_preproc_nullable] = STATE(2526),
    [sym_preproc_error] = STATE(2526),
    [sym_preproc_define] = STATE(2526),
    [sym_preproc_undef] = STATE(2526),
    [ts_builtin_sym_end] = ACTIONS(3613),
    [sym__identifier_token] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym_alias] = ACTIONS(3611),
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_global] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_unsafe] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [anon_sym_return] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_ref] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_LBRACE] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_delegate] = ACTIONS(3611),
    [anon_sym_record] = ACTIONS(3611),
    [anon_sym_abstract] = ACTIONS(3611),
    [anon_sym_async] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_file] = ACTIONS(3611),
    [anon_sym_fixed] = ACTIONS(3611),
    [anon_sym_internal] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_override] = ACTIONS(3611),
    [anon_sym_partial] = ACTIONS(3611),
    [anon_sym_private] = ACTIONS(3611),
    [anon_sym_protected] = ACTIONS(3611),
    [anon_sym_public] = ACTIONS(3611),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_required] = ACTIONS(3611),
    [anon_sym_sealed] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_where] = ACTIONS(3611),
    [anon_sym_notnull] = ACTIONS(3611),
    [anon_sym_unmanaged] = ACTIONS(3611),
    [anon_sym_checked] = ACTIONS(3611),
    [anon_sym_BANG] = ACTIONS(3613),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_PLUS_PLUS] = ACTIONS(3613),
    [anon_sym_DASH_DASH] = ACTIONS(3613),
    [anon_sym_true] = ACTIONS(3611),
    [anon_sym_false] = ACTIONS(3611),
    [anon_sym_PLUS] = ACTIONS(3611),
    [anon_sym_DASH] = ACTIONS(3611),
    [anon_sym_STAR] = ACTIONS(3613),
    [anon_sym_CARET] = ACTIONS(3613),
    [anon_sym_AMP] = ACTIONS(3613),
    [anon_sym_this] = ACTIONS(3611),
    [anon_sym_scoped] = ACTIONS(3611),
    [anon_sym_base] = ACTIONS(3611),
    [anon_sym_var] = ACTIONS(3611),
    [sym_predefined_type] = ACTIONS(3611),
    [anon_sym_break] = ACTIONS(3611),
    [anon_sym_unchecked] = ACTIONS(3611),
    [anon_sym_continue] = ACTIONS(3611),
    [anon_sym_do] = ACTIONS(3611),
    [anon_sym_while] = ACTIONS(3611),
    [anon_sym_for] = ACTIONS(3611),
    [anon_sym_lock] = ACTIONS(3611),
    [anon_sym_yield] = ACTIONS(3611),
    [anon_sym_switch] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3611),
    [anon_sym_throw] = ACTIONS(3611),
    [anon_sym_try] = ACTIONS(3611),
    [anon_sym_when] = ACTIONS(3611),
    [anon_sym_await] = ACTIONS(3611),
    [anon_sym_foreach] = ACTIONS(3611),
    [anon_sym_goto] = ACTIONS(3611),
    [anon_sym_if] = ACTIONS(3611),
    [anon_sym_DOT_DOT] = ACTIONS(3613),
    [anon_sym_from] = ACTIONS(3611),
    [anon_sym_into] = ACTIONS(3611),
    [anon_sym_join] = ACTIONS(3611),
    [anon_sym_on] = ACTIONS(3611),
    [anon_sym_equals] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_orderby] = ACTIONS(3611),
    [anon_sym_ascending] = ACTIONS(3611),
    [anon_sym_descending] = ACTIONS(3611),
    [anon_sym_group] = ACTIONS(3611),
    [anon_sym_by] = ACTIONS(3611),
    [anon_sym_select] = ACTIONS(3611),
    [anon_sym_DQUOTE] = ACTIONS(3613),
    [anon_sym_stackalloc] = ACTIONS(3611),
    [anon_sym_sizeof] = ACTIONS(3611),
    [anon_sym_typeof] = ACTIONS(3611),
    [anon_sym___makeref] = ACTIONS(3611),
    [anon_sym___reftype] = ACTIONS(3611),
    [anon_sym___refvalue] = ACTIONS(3611),
    [sym_null_literal] = ACTIONS(3611),
    [anon_sym_SQUOTE] = ACTIONS(3613),
    [sym_integer_literal] = ACTIONS(3611),
    [sym_real_literal] = ACTIONS(3613),
    [sym_verbatim_string_literal] = ACTIONS(3613),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3613),
    [sym_interpolation_verbatim_start] = ACTIONS(3613),
    [sym_interpolation_raw_start] = ACTIONS(3613),
    [sym_raw_string_start] = ACTIONS(3613),
  },
  [2527] = {
    [sym_preproc_region] = STATE(2527),
    [sym_preproc_endregion] = STATE(2527),
    [sym_preproc_line] = STATE(2527),
    [sym_preproc_pragma] = STATE(2527),
    [sym_preproc_nullable] = STATE(2527),
    [sym_preproc_error] = STATE(2527),
    [sym_preproc_define] = STATE(2527),
    [sym_preproc_undef] = STATE(2527),
    [ts_builtin_sym_end] = ACTIONS(3629),
    [sym__identifier_token] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_alias] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_global] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_unsafe] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_ref] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_delegate] = ACTIONS(3627),
    [anon_sym_record] = ACTIONS(3627),
    [anon_sym_abstract] = ACTIONS(3627),
    [anon_sym_async] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_file] = ACTIONS(3627),
    [anon_sym_fixed] = ACTIONS(3627),
    [anon_sym_internal] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_override] = ACTIONS(3627),
    [anon_sym_partial] = ACTIONS(3627),
    [anon_sym_private] = ACTIONS(3627),
    [anon_sym_protected] = ACTIONS(3627),
    [anon_sym_public] = ACTIONS(3627),
    [anon_sym_readonly] = ACTIONS(3627),
    [anon_sym_required] = ACTIONS(3627),
    [anon_sym_sealed] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_where] = ACTIONS(3627),
    [anon_sym_notnull] = ACTIONS(3627),
    [anon_sym_unmanaged] = ACTIONS(3627),
    [anon_sym_checked] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_true] = ACTIONS(3627),
    [anon_sym_false] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_STAR] = ACTIONS(3629),
    [anon_sym_CARET] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3629),
    [anon_sym_this] = ACTIONS(3627),
    [anon_sym_scoped] = ACTIONS(3627),
    [anon_sym_base] = ACTIONS(3627),
    [anon_sym_var] = ACTIONS(3627),
    [sym_predefined_type] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_unchecked] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_lock] = ACTIONS(3627),
    [anon_sym_yield] = ACTIONS(3627),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_when] = ACTIONS(3627),
    [anon_sym_await] = ACTIONS(3627),
    [anon_sym_foreach] = ACTIONS(3627),
    [anon_sym_goto] = ACTIONS(3627),
    [anon_sym_if] = ACTIONS(3627),
    [anon_sym_DOT_DOT] = ACTIONS(3629),
    [anon_sym_from] = ACTIONS(3627),
    [anon_sym_into] = ACTIONS(3627),
    [anon_sym_join] = ACTIONS(3627),
    [anon_sym_on] = ACTIONS(3627),
    [anon_sym_equals] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_orderby] = ACTIONS(3627),
    [anon_sym_ascending] = ACTIONS(3627),
    [anon_sym_descending] = ACTIONS(3627),
    [anon_sym_group] = ACTIONS(3627),
    [anon_sym_by] = ACTIONS(3627),
    [anon_sym_select] = ACTIONS(3627),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_stackalloc] = ACTIONS(3627),
    [anon_sym_sizeof] = ACTIONS(3627),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym___makeref] = ACTIONS(3627),
    [anon_sym___reftype] = ACTIONS(3627),
    [anon_sym___refvalue] = ACTIONS(3627),
    [sym_null_literal] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [sym_integer_literal] = ACTIONS(3627),
    [sym_real_literal] = ACTIONS(3629),
    [sym_verbatim_string_literal] = ACTIONS(3629),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3629),
    [sym_interpolation_verbatim_start] = ACTIONS(3629),
    [sym_interpolation_raw_start] = ACTIONS(3629),
    [sym_raw_string_start] = ACTIONS(3629),
  },
  [2528] = {
    [sym_preproc_region] = STATE(2528),
    [sym_preproc_endregion] = STATE(2528),
    [sym_preproc_line] = STATE(2528),
    [sym_preproc_pragma] = STATE(2528),
    [sym_preproc_nullable] = STATE(2528),
    [sym_preproc_error] = STATE(2528),
    [sym_preproc_define] = STATE(2528),
    [sym_preproc_undef] = STATE(2528),
    [ts_builtin_sym_end] = ACTIONS(3637),
    [sym__identifier_token] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym_alias] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_global] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_unsafe] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_ref] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_LBRACE] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_delegate] = ACTIONS(3635),
    [anon_sym_record] = ACTIONS(3635),
    [anon_sym_abstract] = ACTIONS(3635),
    [anon_sym_async] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_file] = ACTIONS(3635),
    [anon_sym_fixed] = ACTIONS(3635),
    [anon_sym_internal] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_override] = ACTIONS(3635),
    [anon_sym_partial] = ACTIONS(3635),
    [anon_sym_private] = ACTIONS(3635),
    [anon_sym_protected] = ACTIONS(3635),
    [anon_sym_public] = ACTIONS(3635),
    [anon_sym_readonly] = ACTIONS(3635),
    [anon_sym_required] = ACTIONS(3635),
    [anon_sym_sealed] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_where] = ACTIONS(3635),
    [anon_sym_notnull] = ACTIONS(3635),
    [anon_sym_unmanaged] = ACTIONS(3635),
    [anon_sym_checked] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3637),
    [anon_sym_true] = ACTIONS(3635),
    [anon_sym_false] = ACTIONS(3635),
    [anon_sym_PLUS] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3635),
    [anon_sym_STAR] = ACTIONS(3637),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3637),
    [anon_sym_this] = ACTIONS(3635),
    [anon_sym_scoped] = ACTIONS(3635),
    [anon_sym_base] = ACTIONS(3635),
    [anon_sym_var] = ACTIONS(3635),
    [sym_predefined_type] = ACTIONS(3635),
    [anon_sym_break] = ACTIONS(3635),
    [anon_sym_unchecked] = ACTIONS(3635),
    [anon_sym_continue] = ACTIONS(3635),
    [anon_sym_do] = ACTIONS(3635),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3635),
    [anon_sym_lock] = ACTIONS(3635),
    [anon_sym_yield] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3635),
    [anon_sym_default] = ACTIONS(3635),
    [anon_sym_throw] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3635),
    [anon_sym_when] = ACTIONS(3635),
    [anon_sym_await] = ACTIONS(3635),
    [anon_sym_foreach] = ACTIONS(3635),
    [anon_sym_goto] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3635),
    [anon_sym_DOT_DOT] = ACTIONS(3637),
    [anon_sym_from] = ACTIONS(3635),
    [anon_sym_into] = ACTIONS(3635),
    [anon_sym_join] = ACTIONS(3635),
    [anon_sym_on] = ACTIONS(3635),
    [anon_sym_equals] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_orderby] = ACTIONS(3635),
    [anon_sym_ascending] = ACTIONS(3635),
    [anon_sym_descending] = ACTIONS(3635),
    [anon_sym_group] = ACTIONS(3635),
    [anon_sym_by] = ACTIONS(3635),
    [anon_sym_select] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3637),
    [anon_sym_stackalloc] = ACTIONS(3635),
    [anon_sym_sizeof] = ACTIONS(3635),
    [anon_sym_typeof] = ACTIONS(3635),
    [anon_sym___makeref] = ACTIONS(3635),
    [anon_sym___reftype] = ACTIONS(3635),
    [anon_sym___refvalue] = ACTIONS(3635),
    [sym_null_literal] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3637),
    [sym_integer_literal] = ACTIONS(3635),
    [sym_real_literal] = ACTIONS(3637),
    [sym_verbatim_string_literal] = ACTIONS(3637),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3637),
    [sym_interpolation_verbatim_start] = ACTIONS(3637),
    [sym_interpolation_raw_start] = ACTIONS(3637),
    [sym_raw_string_start] = ACTIONS(3637),
  },
  [2529] = {
    [sym_preproc_region] = STATE(2529),
    [sym_preproc_endregion] = STATE(2529),
    [sym_preproc_line] = STATE(2529),
    [sym_preproc_pragma] = STATE(2529),
    [sym_preproc_nullable] = STATE(2529),
    [sym_preproc_error] = STATE(2529),
    [sym_preproc_define] = STATE(2529),
    [sym_preproc_undef] = STATE(2529),
    [ts_builtin_sym_end] = ACTIONS(3641),
    [sym__identifier_token] = ACTIONS(3639),
    [anon_sym_extern] = ACTIONS(3639),
    [anon_sym_alias] = ACTIONS(3639),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_global] = ACTIONS(3639),
    [anon_sym_using] = ACTIONS(3639),
    [anon_sym_unsafe] = ACTIONS(3639),
    [anon_sym_static] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_return] = ACTIONS(3639),
    [anon_sym_namespace] = ACTIONS(3639),
    [anon_sym_class] = ACTIONS(3639),
    [anon_sym_ref] = ACTIONS(3639),
    [anon_sym_struct] = ACTIONS(3639),
    [anon_sym_enum] = ACTIONS(3639),
    [anon_sym_LBRACE] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3639),
    [anon_sym_delegate] = ACTIONS(3639),
    [anon_sym_record] = ACTIONS(3639),
    [anon_sym_abstract] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_const] = ACTIONS(3639),
    [anon_sym_file] = ACTIONS(3639),
    [anon_sym_fixed] = ACTIONS(3639),
    [anon_sym_internal] = ACTIONS(3639),
    [anon_sym_new] = ACTIONS(3639),
    [anon_sym_override] = ACTIONS(3639),
    [anon_sym_partial] = ACTIONS(3639),
    [anon_sym_private] = ACTIONS(3639),
    [anon_sym_protected] = ACTIONS(3639),
    [anon_sym_public] = ACTIONS(3639),
    [anon_sym_readonly] = ACTIONS(3639),
    [anon_sym_required] = ACTIONS(3639),
    [anon_sym_sealed] = ACTIONS(3639),
    [anon_sym_virtual] = ACTIONS(3639),
    [anon_sym_volatile] = ACTIONS(3639),
    [anon_sym_where] = ACTIONS(3639),
    [anon_sym_notnull] = ACTIONS(3639),
    [anon_sym_unmanaged] = ACTIONS(3639),
    [anon_sym_checked] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3641),
    [anon_sym_TILDE] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_true] = ACTIONS(3639),
    [anon_sym_false] = ACTIONS(3639),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_AMP] = ACTIONS(3641),
    [anon_sym_this] = ACTIONS(3639),
    [anon_sym_scoped] = ACTIONS(3639),
    [anon_sym_base] = ACTIONS(3639),
    [anon_sym_var] = ACTIONS(3639),
    [sym_predefined_type] = ACTIONS(3639),
    [anon_sym_break] = ACTIONS(3639),
    [anon_sym_unchecked] = ACTIONS(3639),
    [anon_sym_continue] = ACTIONS(3639),
    [anon_sym_do] = ACTIONS(3639),
    [anon_sym_while] = ACTIONS(3639),
    [anon_sym_for] = ACTIONS(3639),
    [anon_sym_lock] = ACTIONS(3639),
    [anon_sym_yield] = ACTIONS(3639),
    [anon_sym_switch] = ACTIONS(3639),
    [anon_sym_default] = ACTIONS(3639),
    [anon_sym_throw] = ACTIONS(3639),
    [anon_sym_try] = ACTIONS(3639),
    [anon_sym_when] = ACTIONS(3639),
    [anon_sym_await] = ACTIONS(3639),
    [anon_sym_foreach] = ACTIONS(3639),
    [anon_sym_goto] = ACTIONS(3639),
    [anon_sym_if] = ACTIONS(3639),
    [anon_sym_DOT_DOT] = ACTIONS(3641),
    [anon_sym_from] = ACTIONS(3639),
    [anon_sym_into] = ACTIONS(3639),
    [anon_sym_join] = ACTIONS(3639),
    [anon_sym_on] = ACTIONS(3639),
    [anon_sym_equals] = ACTIONS(3639),
    [anon_sym_let] = ACTIONS(3639),
    [anon_sym_orderby] = ACTIONS(3639),
    [anon_sym_ascending] = ACTIONS(3639),
    [anon_sym_descending] = ACTIONS(3639),
    [anon_sym_group] = ACTIONS(3639),
    [anon_sym_by] = ACTIONS(3639),
    [anon_sym_select] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3641),
    [anon_sym_stackalloc] = ACTIONS(3639),
    [anon_sym_sizeof] = ACTIONS(3639),
    [anon_sym_typeof] = ACTIONS(3639),
    [anon_sym___makeref] = ACTIONS(3639),
    [anon_sym___reftype] = ACTIONS(3639),
    [anon_sym___refvalue] = ACTIONS(3639),
    [sym_null_literal] = ACTIONS(3639),
    [anon_sym_SQUOTE] = ACTIONS(3641),
    [sym_integer_literal] = ACTIONS(3639),
    [sym_real_literal] = ACTIONS(3641),
    [sym_verbatim_string_literal] = ACTIONS(3641),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3641),
    [sym_interpolation_verbatim_start] = ACTIONS(3641),
    [sym_interpolation_raw_start] = ACTIONS(3641),
    [sym_raw_string_start] = ACTIONS(3641),
  },
  [2530] = {
    [sym_preproc_region] = STATE(2530),
    [sym_preproc_endregion] = STATE(2530),
    [sym_preproc_line] = STATE(2530),
    [sym_preproc_pragma] = STATE(2530),
    [sym_preproc_nullable] = STATE(2530),
    [sym_preproc_error] = STATE(2530),
    [sym_preproc_define] = STATE(2530),
    [sym_preproc_undef] = STATE(2530),
    [ts_builtin_sym_end] = ACTIONS(3545),
    [sym__identifier_token] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym_alias] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_unsafe] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_return] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_ref] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_LBRACE] = ACTIONS(3545),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_delegate] = ACTIONS(3543),
    [anon_sym_record] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_async] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_file] = ACTIONS(3543),
    [anon_sym_fixed] = ACTIONS(3543),
    [anon_sym_internal] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [anon_sym_partial] = ACTIONS(3543),
    [anon_sym_private] = ACTIONS(3543),
    [anon_sym_protected] = ACTIONS(3543),
    [anon_sym_public] = ACTIONS(3543),
    [anon_sym_readonly] = ACTIONS(3543),
    [anon_sym_required] = ACTIONS(3543),
    [anon_sym_sealed] = ACTIONS(3543),
    [anon_sym_virtual] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_where] = ACTIONS(3543),
    [anon_sym_notnull] = ACTIONS(3543),
    [anon_sym_unmanaged] = ACTIONS(3543),
    [anon_sym_checked] = ACTIONS(3543),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_PLUS_PLUS] = ACTIONS(3545),
    [anon_sym_DASH_DASH] = ACTIONS(3545),
    [anon_sym_true] = ACTIONS(3543),
    [anon_sym_false] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(3543),
    [anon_sym_DASH] = ACTIONS(3543),
    [anon_sym_STAR] = ACTIONS(3545),
    [anon_sym_CARET] = ACTIONS(3545),
    [anon_sym_AMP] = ACTIONS(3545),
    [anon_sym_this] = ACTIONS(3543),
    [anon_sym_scoped] = ACTIONS(3543),
    [anon_sym_base] = ACTIONS(3543),
    [anon_sym_var] = ACTIONS(3543),
    [sym_predefined_type] = ACTIONS(3543),
    [anon_sym_break] = ACTIONS(3543),
    [anon_sym_unchecked] = ACTIONS(3543),
    [anon_sym_continue] = ACTIONS(3543),
    [anon_sym_do] = ACTIONS(3543),
    [anon_sym_while] = ACTIONS(3543),
    [anon_sym_for] = ACTIONS(3543),
    [anon_sym_lock] = ACTIONS(3543),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_switch] = ACTIONS(3543),
    [anon_sym_default] = ACTIONS(3543),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_try] = ACTIONS(3543),
    [anon_sym_when] = ACTIONS(3543),
    [anon_sym_await] = ACTIONS(3543),
    [anon_sym_foreach] = ACTIONS(3543),
    [anon_sym_goto] = ACTIONS(3543),
    [anon_sym_if] = ACTIONS(3543),
    [anon_sym_DOT_DOT] = ACTIONS(3545),
    [anon_sym_from] = ACTIONS(3543),
    [anon_sym_into] = ACTIONS(3543),
    [anon_sym_join] = ACTIONS(3543),
    [anon_sym_on] = ACTIONS(3543),
    [anon_sym_equals] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_orderby] = ACTIONS(3543),
    [anon_sym_ascending] = ACTIONS(3543),
    [anon_sym_descending] = ACTIONS(3543),
    [anon_sym_group] = ACTIONS(3543),
    [anon_sym_by] = ACTIONS(3543),
    [anon_sym_select] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(3545),
    [anon_sym_stackalloc] = ACTIONS(3543),
    [anon_sym_sizeof] = ACTIONS(3543),
    [anon_sym_typeof] = ACTIONS(3543),
    [anon_sym___makeref] = ACTIONS(3543),
    [anon_sym___reftype] = ACTIONS(3543),
    [anon_sym___refvalue] = ACTIONS(3543),
    [sym_null_literal] = ACTIONS(3543),
    [anon_sym_SQUOTE] = ACTIONS(3545),
    [sym_integer_literal] = ACTIONS(3543),
    [sym_real_literal] = ACTIONS(3545),
    [sym_verbatim_string_literal] = ACTIONS(3545),
    [aux_sym_preproc_if_token1] = ACTIONS(3545),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3545),
    [sym_interpolation_verbatim_start] = ACTIONS(3545),
    [sym_interpolation_raw_start] = ACTIONS(3545),
    [sym_raw_string_start] = ACTIONS(3545),
  },
  [2531] = {
    [sym_preproc_region] = STATE(2531),
    [sym_preproc_endregion] = STATE(2531),
    [sym_preproc_line] = STATE(2531),
    [sym_preproc_pragma] = STATE(2531),
    [sym_preproc_nullable] = STATE(2531),
    [sym_preproc_error] = STATE(2531),
    [sym_preproc_define] = STATE(2531),
    [sym_preproc_undef] = STATE(2531),
    [ts_builtin_sym_end] = ACTIONS(3645),
    [sym__identifier_token] = ACTIONS(3643),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym_alias] = ACTIONS(3643),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_global] = ACTIONS(3643),
    [anon_sym_using] = ACTIONS(3643),
    [anon_sym_unsafe] = ACTIONS(3643),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_return] = ACTIONS(3643),
    [anon_sym_namespace] = ACTIONS(3643),
    [anon_sym_class] = ACTIONS(3643),
    [anon_sym_ref] = ACTIONS(3643),
    [anon_sym_struct] = ACTIONS(3643),
    [anon_sym_enum] = ACTIONS(3643),
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3643),
    [anon_sym_delegate] = ACTIONS(3643),
    [anon_sym_record] = ACTIONS(3643),
    [anon_sym_abstract] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3643),
    [anon_sym_file] = ACTIONS(3643),
    [anon_sym_fixed] = ACTIONS(3643),
    [anon_sym_internal] = ACTIONS(3643),
    [anon_sym_new] = ACTIONS(3643),
    [anon_sym_override] = ACTIONS(3643),
    [anon_sym_partial] = ACTIONS(3643),
    [anon_sym_private] = ACTIONS(3643),
    [anon_sym_protected] = ACTIONS(3643),
    [anon_sym_public] = ACTIONS(3643),
    [anon_sym_readonly] = ACTIONS(3643),
    [anon_sym_required] = ACTIONS(3643),
    [anon_sym_sealed] = ACTIONS(3643),
    [anon_sym_virtual] = ACTIONS(3643),
    [anon_sym_volatile] = ACTIONS(3643),
    [anon_sym_where] = ACTIONS(3643),
    [anon_sym_notnull] = ACTIONS(3643),
    [anon_sym_unmanaged] = ACTIONS(3643),
    [anon_sym_checked] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3645),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [anon_sym_true] = ACTIONS(3643),
    [anon_sym_false] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3645),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3645),
    [anon_sym_this] = ACTIONS(3643),
    [anon_sym_scoped] = ACTIONS(3643),
    [anon_sym_base] = ACTIONS(3643),
    [anon_sym_var] = ACTIONS(3643),
    [sym_predefined_type] = ACTIONS(3643),
    [anon_sym_break] = ACTIONS(3643),
    [anon_sym_unchecked] = ACTIONS(3643),
    [anon_sym_continue] = ACTIONS(3643),
    [anon_sym_do] = ACTIONS(3643),
    [anon_sym_while] = ACTIONS(3643),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_lock] = ACTIONS(3643),
    [anon_sym_yield] = ACTIONS(3643),
    [anon_sym_switch] = ACTIONS(3643),
    [anon_sym_default] = ACTIONS(3643),
    [anon_sym_throw] = ACTIONS(3643),
    [anon_sym_try] = ACTIONS(3643),
    [anon_sym_when] = ACTIONS(3643),
    [anon_sym_await] = ACTIONS(3643),
    [anon_sym_foreach] = ACTIONS(3643),
    [anon_sym_goto] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(3643),
    [anon_sym_DOT_DOT] = ACTIONS(3645),
    [anon_sym_from] = ACTIONS(3643),
    [anon_sym_into] = ACTIONS(3643),
    [anon_sym_join] = ACTIONS(3643),
    [anon_sym_on] = ACTIONS(3643),
    [anon_sym_equals] = ACTIONS(3643),
    [anon_sym_let] = ACTIONS(3643),
    [anon_sym_orderby] = ACTIONS(3643),
    [anon_sym_ascending] = ACTIONS(3643),
    [anon_sym_descending] = ACTIONS(3643),
    [anon_sym_group] = ACTIONS(3643),
    [anon_sym_by] = ACTIONS(3643),
    [anon_sym_select] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_stackalloc] = ACTIONS(3643),
    [anon_sym_sizeof] = ACTIONS(3643),
    [anon_sym_typeof] = ACTIONS(3643),
    [anon_sym___makeref] = ACTIONS(3643),
    [anon_sym___reftype] = ACTIONS(3643),
    [anon_sym___refvalue] = ACTIONS(3643),
    [sym_null_literal] = ACTIONS(3643),
    [anon_sym_SQUOTE] = ACTIONS(3645),
    [sym_integer_literal] = ACTIONS(3643),
    [sym_real_literal] = ACTIONS(3645),
    [sym_verbatim_string_literal] = ACTIONS(3645),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3645),
    [sym_interpolation_verbatim_start] = ACTIONS(3645),
    [sym_interpolation_raw_start] = ACTIONS(3645),
    [sym_raw_string_start] = ACTIONS(3645),
  },
  [2532] = {
    [sym_preproc_region] = STATE(2532),
    [sym_preproc_endregion] = STATE(2532),
    [sym_preproc_line] = STATE(2532),
    [sym_preproc_pragma] = STATE(2532),
    [sym_preproc_nullable] = STATE(2532),
    [sym_preproc_error] = STATE(2532),
    [sym_preproc_define] = STATE(2532),
    [sym_preproc_undef] = STATE(2532),
    [ts_builtin_sym_end] = ACTIONS(3541),
    [sym__identifier_token] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym_alias] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_unsafe] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_ref] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_delegate] = ACTIONS(3539),
    [anon_sym_record] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_async] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_file] = ACTIONS(3539),
    [anon_sym_fixed] = ACTIONS(3539),
    [anon_sym_internal] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [anon_sym_partial] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_readonly] = ACTIONS(3539),
    [anon_sym_required] = ACTIONS(3539),
    [anon_sym_sealed] = ACTIONS(3539),
    [anon_sym_virtual] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_where] = ACTIONS(3539),
    [anon_sym_notnull] = ACTIONS(3539),
    [anon_sym_unmanaged] = ACTIONS(3539),
    [anon_sym_checked] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3541),
    [anon_sym_true] = ACTIONS(3539),
    [anon_sym_false] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3539),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_this] = ACTIONS(3539),
    [anon_sym_scoped] = ACTIONS(3539),
    [anon_sym_base] = ACTIONS(3539),
    [anon_sym_var] = ACTIONS(3539),
    [sym_predefined_type] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3539),
    [anon_sym_unchecked] = ACTIONS(3539),
    [anon_sym_continue] = ACTIONS(3539),
    [anon_sym_do] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3539),
    [anon_sym_lock] = ACTIONS(3539),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3539),
    [anon_sym_default] = ACTIONS(3539),
    [anon_sym_throw] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3539),
    [anon_sym_when] = ACTIONS(3539),
    [anon_sym_await] = ACTIONS(3539),
    [anon_sym_foreach] = ACTIONS(3539),
    [anon_sym_goto] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3539),
    [anon_sym_DOT_DOT] = ACTIONS(3541),
    [anon_sym_from] = ACTIONS(3539),
    [anon_sym_into] = ACTIONS(3539),
    [anon_sym_join] = ACTIONS(3539),
    [anon_sym_on] = ACTIONS(3539),
    [anon_sym_equals] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_orderby] = ACTIONS(3539),
    [anon_sym_ascending] = ACTIONS(3539),
    [anon_sym_descending] = ACTIONS(3539),
    [anon_sym_group] = ACTIONS(3539),
    [anon_sym_by] = ACTIONS(3539),
    [anon_sym_select] = ACTIONS(3539),
    [anon_sym_DQUOTE] = ACTIONS(3541),
    [anon_sym_stackalloc] = ACTIONS(3539),
    [anon_sym_sizeof] = ACTIONS(3539),
    [anon_sym_typeof] = ACTIONS(3539),
    [anon_sym___makeref] = ACTIONS(3539),
    [anon_sym___reftype] = ACTIONS(3539),
    [anon_sym___refvalue] = ACTIONS(3539),
    [sym_null_literal] = ACTIONS(3539),
    [anon_sym_SQUOTE] = ACTIONS(3541),
    [sym_integer_literal] = ACTIONS(3539),
    [sym_real_literal] = ACTIONS(3541),
    [sym_verbatim_string_literal] = ACTIONS(3541),
    [aux_sym_preproc_if_token1] = ACTIONS(3541),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3541),
    [sym_interpolation_verbatim_start] = ACTIONS(3541),
    [sym_interpolation_raw_start] = ACTIONS(3541),
    [sym_raw_string_start] = ACTIONS(3541),
  },
  [2533] = {
    [sym_preproc_region] = STATE(2533),
    [sym_preproc_endregion] = STATE(2533),
    [sym_preproc_line] = STATE(2533),
    [sym_preproc_pragma] = STATE(2533),
    [sym_preproc_nullable] = STATE(2533),
    [sym_preproc_error] = STATE(2533),
    [sym_preproc_define] = STATE(2533),
    [sym_preproc_undef] = STATE(2533),
    [ts_builtin_sym_end] = ACTIONS(3665),
    [sym__identifier_token] = ACTIONS(3663),
    [anon_sym_extern] = ACTIONS(3663),
    [anon_sym_alias] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3665),
    [anon_sym_global] = ACTIONS(3663),
    [anon_sym_using] = ACTIONS(3663),
    [anon_sym_unsafe] = ACTIONS(3663),
    [anon_sym_static] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_LPAREN] = ACTIONS(3665),
    [anon_sym_return] = ACTIONS(3663),
    [anon_sym_namespace] = ACTIONS(3663),
    [anon_sym_class] = ACTIONS(3663),
    [anon_sym_ref] = ACTIONS(3663),
    [anon_sym_struct] = ACTIONS(3663),
    [anon_sym_enum] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3663),
    [anon_sym_delegate] = ACTIONS(3663),
    [anon_sym_record] = ACTIONS(3663),
    [anon_sym_abstract] = ACTIONS(3663),
    [anon_sym_async] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3663),
    [anon_sym_file] = ACTIONS(3663),
    [anon_sym_fixed] = ACTIONS(3663),
    [anon_sym_internal] = ACTIONS(3663),
    [anon_sym_new] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_partial] = ACTIONS(3663),
    [anon_sym_private] = ACTIONS(3663),
    [anon_sym_protected] = ACTIONS(3663),
    [anon_sym_public] = ACTIONS(3663),
    [anon_sym_readonly] = ACTIONS(3663),
    [anon_sym_required] = ACTIONS(3663),
    [anon_sym_sealed] = ACTIONS(3663),
    [anon_sym_virtual] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym_where] = ACTIONS(3663),
    [anon_sym_notnull] = ACTIONS(3663),
    [anon_sym_unmanaged] = ACTIONS(3663),
    [anon_sym_checked] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3665),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_PLUS_PLUS] = ACTIONS(3665),
    [anon_sym_DASH_DASH] = ACTIONS(3665),
    [anon_sym_true] = ACTIONS(3663),
    [anon_sym_false] = ACTIONS(3663),
    [anon_sym_PLUS] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3663),
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_CARET] = ACTIONS(3665),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_this] = ACTIONS(3663),
    [anon_sym_scoped] = ACTIONS(3663),
    [anon_sym_base] = ACTIONS(3663),
    [anon_sym_var] = ACTIONS(3663),
    [sym_predefined_type] = ACTIONS(3663),
    [anon_sym_break] = ACTIONS(3663),
    [anon_sym_unchecked] = ACTIONS(3663),
    [anon_sym_continue] = ACTIONS(3663),
    [anon_sym_do] = ACTIONS(3663),
    [anon_sym_while] = ACTIONS(3663),
    [anon_sym_for] = ACTIONS(3663),
    [anon_sym_lock] = ACTIONS(3663),
    [anon_sym_yield] = ACTIONS(3663),
    [anon_sym_switch] = ACTIONS(3663),
    [anon_sym_default] = ACTIONS(3663),
    [anon_sym_throw] = ACTIONS(3663),
    [anon_sym_try] = ACTIONS(3663),
    [anon_sym_when] = ACTIONS(3663),
    [anon_sym_await] = ACTIONS(3663),
    [anon_sym_foreach] = ACTIONS(3663),
    [anon_sym_goto] = ACTIONS(3663),
    [anon_sym_if] = ACTIONS(3663),
    [anon_sym_DOT_DOT] = ACTIONS(3665),
    [anon_sym_from] = ACTIONS(3663),
    [anon_sym_into] = ACTIONS(3663),
    [anon_sym_join] = ACTIONS(3663),
    [anon_sym_on] = ACTIONS(3663),
    [anon_sym_equals] = ACTIONS(3663),
    [anon_sym_let] = ACTIONS(3663),
    [anon_sym_orderby] = ACTIONS(3663),
    [anon_sym_ascending] = ACTIONS(3663),
    [anon_sym_descending] = ACTIONS(3663),
    [anon_sym_group] = ACTIONS(3663),
    [anon_sym_by] = ACTIONS(3663),
    [anon_sym_select] = ACTIONS(3663),
    [anon_sym_DQUOTE] = ACTIONS(3665),
    [anon_sym_stackalloc] = ACTIONS(3663),
    [anon_sym_sizeof] = ACTIONS(3663),
    [anon_sym_typeof] = ACTIONS(3663),
    [anon_sym___makeref] = ACTIONS(3663),
    [anon_sym___reftype] = ACTIONS(3663),
    [anon_sym___refvalue] = ACTIONS(3663),
    [sym_null_literal] = ACTIONS(3663),
    [anon_sym_SQUOTE] = ACTIONS(3665),
    [sym_integer_literal] = ACTIONS(3663),
    [sym_real_literal] = ACTIONS(3665),
    [sym_verbatim_string_literal] = ACTIONS(3665),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3665),
    [sym_interpolation_verbatim_start] = ACTIONS(3665),
    [sym_interpolation_raw_start] = ACTIONS(3665),
    [sym_raw_string_start] = ACTIONS(3665),
  },
  [2534] = {
    [sym_preproc_region] = STATE(2534),
    [sym_preproc_endregion] = STATE(2534),
    [sym_preproc_line] = STATE(2534),
    [sym_preproc_pragma] = STATE(2534),
    [sym_preproc_nullable] = STATE(2534),
    [sym_preproc_error] = STATE(2534),
    [sym_preproc_define] = STATE(2534),
    [sym_preproc_undef] = STATE(2534),
    [ts_builtin_sym_end] = ACTIONS(3669),
    [sym__identifier_token] = ACTIONS(3667),
    [anon_sym_extern] = ACTIONS(3667),
    [anon_sym_alias] = ACTIONS(3667),
    [anon_sym_SEMI] = ACTIONS(3669),
    [anon_sym_global] = ACTIONS(3667),
    [anon_sym_using] = ACTIONS(3667),
    [anon_sym_unsafe] = ACTIONS(3667),
    [anon_sym_static] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_return] = ACTIONS(3667),
    [anon_sym_namespace] = ACTIONS(3667),
    [anon_sym_class] = ACTIONS(3667),
    [anon_sym_ref] = ACTIONS(3667),
    [anon_sym_struct] = ACTIONS(3667),
    [anon_sym_enum] = ACTIONS(3667),
    [anon_sym_LBRACE] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3667),
    [anon_sym_delegate] = ACTIONS(3667),
    [anon_sym_record] = ACTIONS(3667),
    [anon_sym_abstract] = ACTIONS(3667),
    [anon_sym_async] = ACTIONS(3667),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_file] = ACTIONS(3667),
    [anon_sym_fixed] = ACTIONS(3667),
    [anon_sym_internal] = ACTIONS(3667),
    [anon_sym_new] = ACTIONS(3667),
    [anon_sym_override] = ACTIONS(3667),
    [anon_sym_partial] = ACTIONS(3667),
    [anon_sym_private] = ACTIONS(3667),
    [anon_sym_protected] = ACTIONS(3667),
    [anon_sym_public] = ACTIONS(3667),
    [anon_sym_readonly] = ACTIONS(3667),
    [anon_sym_required] = ACTIONS(3667),
    [anon_sym_sealed] = ACTIONS(3667),
    [anon_sym_virtual] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_where] = ACTIONS(3667),
    [anon_sym_notnull] = ACTIONS(3667),
    [anon_sym_unmanaged] = ACTIONS(3667),
    [anon_sym_checked] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3669),
    [anon_sym_TILDE] = ACTIONS(3669),
    [anon_sym_PLUS_PLUS] = ACTIONS(3669),
    [anon_sym_DASH_DASH] = ACTIONS(3669),
    [anon_sym_true] = ACTIONS(3667),
    [anon_sym_false] = ACTIONS(3667),
    [anon_sym_PLUS] = ACTIONS(3667),
    [anon_sym_DASH] = ACTIONS(3667),
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3669),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_this] = ACTIONS(3667),
    [anon_sym_scoped] = ACTIONS(3667),
    [anon_sym_base] = ACTIONS(3667),
    [anon_sym_var] = ACTIONS(3667),
    [sym_predefined_type] = ACTIONS(3667),
    [anon_sym_break] = ACTIONS(3667),
    [anon_sym_unchecked] = ACTIONS(3667),
    [anon_sym_continue] = ACTIONS(3667),
    [anon_sym_do] = ACTIONS(3667),
    [anon_sym_while] = ACTIONS(3667),
    [anon_sym_for] = ACTIONS(3667),
    [anon_sym_lock] = ACTIONS(3667),
    [anon_sym_yield] = ACTIONS(3667),
    [anon_sym_switch] = ACTIONS(3667),
    [anon_sym_default] = ACTIONS(3667),
    [anon_sym_throw] = ACTIONS(3667),
    [anon_sym_try] = ACTIONS(3667),
    [anon_sym_when] = ACTIONS(3667),
    [anon_sym_await] = ACTIONS(3667),
    [anon_sym_foreach] = ACTIONS(3667),
    [anon_sym_goto] = ACTIONS(3667),
    [anon_sym_if] = ACTIONS(3667),
    [anon_sym_DOT_DOT] = ACTIONS(3669),
    [anon_sym_from] = ACTIONS(3667),
    [anon_sym_into] = ACTIONS(3667),
    [anon_sym_join] = ACTIONS(3667),
    [anon_sym_on] = ACTIONS(3667),
    [anon_sym_equals] = ACTIONS(3667),
    [anon_sym_let] = ACTIONS(3667),
    [anon_sym_orderby] = ACTIONS(3667),
    [anon_sym_ascending] = ACTIONS(3667),
    [anon_sym_descending] = ACTIONS(3667),
    [anon_sym_group] = ACTIONS(3667),
    [anon_sym_by] = ACTIONS(3667),
    [anon_sym_select] = ACTIONS(3667),
    [anon_sym_DQUOTE] = ACTIONS(3669),
    [anon_sym_stackalloc] = ACTIONS(3667),
    [anon_sym_sizeof] = ACTIONS(3667),
    [anon_sym_typeof] = ACTIONS(3667),
    [anon_sym___makeref] = ACTIONS(3667),
    [anon_sym___reftype] = ACTIONS(3667),
    [anon_sym___refvalue] = ACTIONS(3667),
    [sym_null_literal] = ACTIONS(3667),
    [anon_sym_SQUOTE] = ACTIONS(3669),
    [sym_integer_literal] = ACTIONS(3667),
    [sym_real_literal] = ACTIONS(3669),
    [sym_verbatim_string_literal] = ACTIONS(3669),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3669),
    [sym_interpolation_verbatim_start] = ACTIONS(3669),
    [sym_interpolation_raw_start] = ACTIONS(3669),
    [sym_raw_string_start] = ACTIONS(3669),
  },
  [2535] = {
    [sym_preproc_region] = STATE(2535),
    [sym_preproc_endregion] = STATE(2535),
    [sym_preproc_line] = STATE(2535),
    [sym_preproc_pragma] = STATE(2535),
    [sym_preproc_nullable] = STATE(2535),
    [sym_preproc_error] = STATE(2535),
    [sym_preproc_define] = STATE(2535),
    [sym_preproc_undef] = STATE(2535),
    [ts_builtin_sym_end] = ACTIONS(3537),
    [sym__identifier_token] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym_alias] = ACTIONS(3535),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_unsafe] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_return] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_ref] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(3537),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_delegate] = ACTIONS(3535),
    [anon_sym_record] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_async] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_file] = ACTIONS(3535),
    [anon_sym_fixed] = ACTIONS(3535),
    [anon_sym_internal] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [anon_sym_partial] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_readonly] = ACTIONS(3535),
    [anon_sym_required] = ACTIONS(3535),
    [anon_sym_sealed] = ACTIONS(3535),
    [anon_sym_virtual] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_where] = ACTIONS(3535),
    [anon_sym_notnull] = ACTIONS(3535),
    [anon_sym_unmanaged] = ACTIONS(3535),
    [anon_sym_checked] = ACTIONS(3535),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_PLUS_PLUS] = ACTIONS(3537),
    [anon_sym_DASH_DASH] = ACTIONS(3537),
    [anon_sym_true] = ACTIONS(3535),
    [anon_sym_false] = ACTIONS(3535),
    [anon_sym_PLUS] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(3535),
    [anon_sym_STAR] = ACTIONS(3537),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_AMP] = ACTIONS(3537),
    [anon_sym_this] = ACTIONS(3535),
    [anon_sym_scoped] = ACTIONS(3535),
    [anon_sym_base] = ACTIONS(3535),
    [anon_sym_var] = ACTIONS(3535),
    [sym_predefined_type] = ACTIONS(3535),
    [anon_sym_break] = ACTIONS(3535),
    [anon_sym_unchecked] = ACTIONS(3535),
    [anon_sym_continue] = ACTIONS(3535),
    [anon_sym_do] = ACTIONS(3535),
    [anon_sym_while] = ACTIONS(3535),
    [anon_sym_for] = ACTIONS(3535),
    [anon_sym_lock] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_switch] = ACTIONS(3535),
    [anon_sym_default] = ACTIONS(3535),
    [anon_sym_throw] = ACTIONS(3535),
    [anon_sym_try] = ACTIONS(3535),
    [anon_sym_when] = ACTIONS(3535),
    [anon_sym_await] = ACTIONS(3535),
    [anon_sym_foreach] = ACTIONS(3535),
    [anon_sym_goto] = ACTIONS(3535),
    [anon_sym_if] = ACTIONS(3535),
    [anon_sym_DOT_DOT] = ACTIONS(3537),
    [anon_sym_from] = ACTIONS(3535),
    [anon_sym_into] = ACTIONS(3535),
    [anon_sym_join] = ACTIONS(3535),
    [anon_sym_on] = ACTIONS(3535),
    [anon_sym_equals] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_orderby] = ACTIONS(3535),
    [anon_sym_ascending] = ACTIONS(3535),
    [anon_sym_descending] = ACTIONS(3535),
    [anon_sym_group] = ACTIONS(3535),
    [anon_sym_by] = ACTIONS(3535),
    [anon_sym_select] = ACTIONS(3535),
    [anon_sym_DQUOTE] = ACTIONS(3537),
    [anon_sym_stackalloc] = ACTIONS(3535),
    [anon_sym_sizeof] = ACTIONS(3535),
    [anon_sym_typeof] = ACTIONS(3535),
    [anon_sym___makeref] = ACTIONS(3535),
    [anon_sym___reftype] = ACTIONS(3535),
    [anon_sym___refvalue] = ACTIONS(3535),
    [sym_null_literal] = ACTIONS(3535),
    [anon_sym_SQUOTE] = ACTIONS(3537),
    [sym_integer_literal] = ACTIONS(3535),
    [sym_real_literal] = ACTIONS(3537),
    [sym_verbatim_string_literal] = ACTIONS(3537),
    [aux_sym_preproc_if_token1] = ACTIONS(3537),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3537),
    [sym_interpolation_verbatim_start] = ACTIONS(3537),
    [sym_interpolation_raw_start] = ACTIONS(3537),
    [sym_raw_string_start] = ACTIONS(3537),
  },
  [2536] = {
    [sym_preproc_region] = STATE(2536),
    [sym_preproc_endregion] = STATE(2536),
    [sym_preproc_line] = STATE(2536),
    [sym_preproc_pragma] = STATE(2536),
    [sym_preproc_nullable] = STATE(2536),
    [sym_preproc_error] = STATE(2536),
    [sym_preproc_define] = STATE(2536),
    [sym_preproc_undef] = STATE(2536),
    [ts_builtin_sym_end] = ACTIONS(3705),
    [sym__identifier_token] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym_alias] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_unsafe] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_return] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_ref] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_delegate] = ACTIONS(3703),
    [anon_sym_record] = ACTIONS(3703),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_async] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3703),
    [anon_sym_fixed] = ACTIONS(3703),
    [anon_sym_internal] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_override] = ACTIONS(3703),
    [anon_sym_partial] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_readonly] = ACTIONS(3703),
    [anon_sym_required] = ACTIONS(3703),
    [anon_sym_sealed] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_where] = ACTIONS(3703),
    [anon_sym_notnull] = ACTIONS(3703),
    [anon_sym_unmanaged] = ACTIONS(3703),
    [anon_sym_checked] = ACTIONS(3703),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_true] = ACTIONS(3703),
    [anon_sym_false] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(3703),
    [anon_sym_DASH] = ACTIONS(3703),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_CARET] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_this] = ACTIONS(3703),
    [anon_sym_scoped] = ACTIONS(3703),
    [anon_sym_base] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3703),
    [sym_predefined_type] = ACTIONS(3703),
    [anon_sym_break] = ACTIONS(3703),
    [anon_sym_unchecked] = ACTIONS(3703),
    [anon_sym_continue] = ACTIONS(3703),
    [anon_sym_do] = ACTIONS(3703),
    [anon_sym_while] = ACTIONS(3703),
    [anon_sym_for] = ACTIONS(3703),
    [anon_sym_lock] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3703),
    [anon_sym_switch] = ACTIONS(3703),
    [anon_sym_default] = ACTIONS(3703),
    [anon_sym_throw] = ACTIONS(3703),
    [anon_sym_try] = ACTIONS(3703),
    [anon_sym_when] = ACTIONS(3703),
    [anon_sym_await] = ACTIONS(3703),
    [anon_sym_foreach] = ACTIONS(3703),
    [anon_sym_goto] = ACTIONS(3703),
    [anon_sym_if] = ACTIONS(3703),
    [anon_sym_DOT_DOT] = ACTIONS(3705),
    [anon_sym_from] = ACTIONS(3703),
    [anon_sym_into] = ACTIONS(3703),
    [anon_sym_join] = ACTIONS(3703),
    [anon_sym_on] = ACTIONS(3703),
    [anon_sym_equals] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_orderby] = ACTIONS(3703),
    [anon_sym_ascending] = ACTIONS(3703),
    [anon_sym_descending] = ACTIONS(3703),
    [anon_sym_group] = ACTIONS(3703),
    [anon_sym_by] = ACTIONS(3703),
    [anon_sym_select] = ACTIONS(3703),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_stackalloc] = ACTIONS(3703),
    [anon_sym_sizeof] = ACTIONS(3703),
    [anon_sym_typeof] = ACTIONS(3703),
    [anon_sym___makeref] = ACTIONS(3703),
    [anon_sym___reftype] = ACTIONS(3703),
    [anon_sym___refvalue] = ACTIONS(3703),
    [sym_null_literal] = ACTIONS(3703),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [sym_integer_literal] = ACTIONS(3703),
    [sym_real_literal] = ACTIONS(3705),
    [sym_verbatim_string_literal] = ACTIONS(3705),
    [aux_sym_preproc_if_token1] = ACTIONS(3705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3705),
    [sym_interpolation_verbatim_start] = ACTIONS(3705),
    [sym_interpolation_raw_start] = ACTIONS(3705),
    [sym_raw_string_start] = ACTIONS(3705),
  },
  [2537] = {
    [sym_preproc_region] = STATE(2537),
    [sym_preproc_endregion] = STATE(2537),
    [sym_preproc_line] = STATE(2537),
    [sym_preproc_pragma] = STATE(2537),
    [sym_preproc_nullable] = STATE(2537),
    [sym_preproc_error] = STATE(2537),
    [sym_preproc_define] = STATE(2537),
    [sym_preproc_undef] = STATE(2537),
    [ts_builtin_sym_end] = ACTIONS(3709),
    [sym__identifier_token] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym_alias] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_global] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_ref] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_delegate] = ACTIONS(3707),
    [anon_sym_record] = ACTIONS(3707),
    [anon_sym_abstract] = ACTIONS(3707),
    [anon_sym_async] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_file] = ACTIONS(3707),
    [anon_sym_fixed] = ACTIONS(3707),
    [anon_sym_internal] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_override] = ACTIONS(3707),
    [anon_sym_partial] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_readonly] = ACTIONS(3707),
    [anon_sym_required] = ACTIONS(3707),
    [anon_sym_sealed] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_notnull] = ACTIONS(3707),
    [anon_sym_unmanaged] = ACTIONS(3707),
    [anon_sym_checked] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3709),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [anon_sym_true] = ACTIONS(3707),
    [anon_sym_false] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3709),
    [anon_sym_this] = ACTIONS(3707),
    [anon_sym_scoped] = ACTIONS(3707),
    [anon_sym_base] = ACTIONS(3707),
    [anon_sym_var] = ACTIONS(3707),
    [sym_predefined_type] = ACTIONS(3707),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_unchecked] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_lock] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3707),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_when] = ACTIONS(3707),
    [anon_sym_await] = ACTIONS(3707),
    [anon_sym_foreach] = ACTIONS(3707),
    [anon_sym_goto] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_DOT_DOT] = ACTIONS(3709),
    [anon_sym_from] = ACTIONS(3707),
    [anon_sym_into] = ACTIONS(3707),
    [anon_sym_join] = ACTIONS(3707),
    [anon_sym_on] = ACTIONS(3707),
    [anon_sym_equals] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_orderby] = ACTIONS(3707),
    [anon_sym_ascending] = ACTIONS(3707),
    [anon_sym_descending] = ACTIONS(3707),
    [anon_sym_group] = ACTIONS(3707),
    [anon_sym_by] = ACTIONS(3707),
    [anon_sym_select] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3709),
    [anon_sym_stackalloc] = ACTIONS(3707),
    [anon_sym_sizeof] = ACTIONS(3707),
    [anon_sym_typeof] = ACTIONS(3707),
    [anon_sym___makeref] = ACTIONS(3707),
    [anon_sym___reftype] = ACTIONS(3707),
    [anon_sym___refvalue] = ACTIONS(3707),
    [sym_null_literal] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3709),
    [sym_integer_literal] = ACTIONS(3707),
    [sym_real_literal] = ACTIONS(3709),
    [sym_verbatim_string_literal] = ACTIONS(3709),
    [aux_sym_preproc_if_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3709),
    [sym_interpolation_verbatim_start] = ACTIONS(3709),
    [sym_interpolation_raw_start] = ACTIONS(3709),
    [sym_raw_string_start] = ACTIONS(3709),
  },
  [2538] = {
    [sym_preproc_region] = STATE(2538),
    [sym_preproc_endregion] = STATE(2538),
    [sym_preproc_line] = STATE(2538),
    [sym_preproc_pragma] = STATE(2538),
    [sym_preproc_nullable] = STATE(2538),
    [sym_preproc_error] = STATE(2538),
    [sym_preproc_define] = STATE(2538),
    [sym_preproc_undef] = STATE(2538),
    [ts_builtin_sym_end] = ACTIONS(3529),
    [sym__identifier_token] = ACTIONS(3527),
    [anon_sym_extern] = ACTIONS(3527),
    [anon_sym_alias] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3529),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_using] = ACTIONS(3527),
    [anon_sym_unsafe] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_class] = ACTIONS(3527),
    [anon_sym_ref] = ACTIONS(3527),
    [anon_sym_struct] = ACTIONS(3527),
    [anon_sym_enum] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_delegate] = ACTIONS(3527),
    [anon_sym_record] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_async] = ACTIONS(3527),
    [anon_sym_const] = ACTIONS(3527),
    [anon_sym_file] = ACTIONS(3527),
    [anon_sym_fixed] = ACTIONS(3527),
    [anon_sym_internal] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [anon_sym_partial] = ACTIONS(3527),
    [anon_sym_private] = ACTIONS(3527),
    [anon_sym_protected] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(3527),
    [anon_sym_readonly] = ACTIONS(3527),
    [anon_sym_required] = ACTIONS(3527),
    [anon_sym_sealed] = ACTIONS(3527),
    [anon_sym_virtual] = ACTIONS(3527),
    [anon_sym_volatile] = ACTIONS(3527),
    [anon_sym_where] = ACTIONS(3527),
    [anon_sym_notnull] = ACTIONS(3527),
    [anon_sym_unmanaged] = ACTIONS(3527),
    [anon_sym_checked] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3529),
    [anon_sym_DASH_DASH] = ACTIONS(3529),
    [anon_sym_true] = ACTIONS(3527),
    [anon_sym_false] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_CARET] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_this] = ACTIONS(3527),
    [anon_sym_scoped] = ACTIONS(3527),
    [anon_sym_base] = ACTIONS(3527),
    [anon_sym_var] = ACTIONS(3527),
    [sym_predefined_type] = ACTIONS(3527),
    [anon_sym_break] = ACTIONS(3527),
    [anon_sym_unchecked] = ACTIONS(3527),
    [anon_sym_continue] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_lock] = ACTIONS(3527),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_switch] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_throw] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_when] = ACTIONS(3527),
    [anon_sym_await] = ACTIONS(3527),
    [anon_sym_foreach] = ACTIONS(3527),
    [anon_sym_goto] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_DOT_DOT] = ACTIONS(3529),
    [anon_sym_from] = ACTIONS(3527),
    [anon_sym_into] = ACTIONS(3527),
    [anon_sym_join] = ACTIONS(3527),
    [anon_sym_on] = ACTIONS(3527),
    [anon_sym_equals] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_orderby] = ACTIONS(3527),
    [anon_sym_ascending] = ACTIONS(3527),
    [anon_sym_descending] = ACTIONS(3527),
    [anon_sym_group] = ACTIONS(3527),
    [anon_sym_by] = ACTIONS(3527),
    [anon_sym_select] = ACTIONS(3527),
    [anon_sym_DQUOTE] = ACTIONS(3529),
    [anon_sym_stackalloc] = ACTIONS(3527),
    [anon_sym_sizeof] = ACTIONS(3527),
    [anon_sym_typeof] = ACTIONS(3527),
    [anon_sym___makeref] = ACTIONS(3527),
    [anon_sym___reftype] = ACTIONS(3527),
    [anon_sym___refvalue] = ACTIONS(3527),
    [sym_null_literal] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3529),
    [sym_integer_literal] = ACTIONS(3527),
    [sym_real_literal] = ACTIONS(3529),
    [sym_verbatim_string_literal] = ACTIONS(3529),
    [aux_sym_preproc_if_token1] = ACTIONS(3529),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3529),
    [sym_interpolation_verbatim_start] = ACTIONS(3529),
    [sym_interpolation_raw_start] = ACTIONS(3529),
    [sym_raw_string_start] = ACTIONS(3529),
  },
  [2539] = {
    [sym_preproc_region] = STATE(2539),
    [sym_preproc_endregion] = STATE(2539),
    [sym_preproc_line] = STATE(2539),
    [sym_preproc_pragma] = STATE(2539),
    [sym_preproc_nullable] = STATE(2539),
    [sym_preproc_error] = STATE(2539),
    [sym_preproc_define] = STATE(2539),
    [sym_preproc_undef] = STATE(2539),
    [ts_builtin_sym_end] = ACTIONS(3521),
    [sym__identifier_token] = ACTIONS(3519),
    [anon_sym_extern] = ACTIONS(3519),
    [anon_sym_alias] = ACTIONS(3519),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_global] = ACTIONS(3519),
    [anon_sym_using] = ACTIONS(3519),
    [anon_sym_unsafe] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_return] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_class] = ACTIONS(3519),
    [anon_sym_ref] = ACTIONS(3519),
    [anon_sym_struct] = ACTIONS(3519),
    [anon_sym_enum] = ACTIONS(3519),
    [anon_sym_LBRACE] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_delegate] = ACTIONS(3519),
    [anon_sym_record] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_async] = ACTIONS(3519),
    [anon_sym_const] = ACTIONS(3519),
    [anon_sym_file] = ACTIONS(3519),
    [anon_sym_fixed] = ACTIONS(3519),
    [anon_sym_internal] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [anon_sym_partial] = ACTIONS(3519),
    [anon_sym_private] = ACTIONS(3519),
    [anon_sym_protected] = ACTIONS(3519),
    [anon_sym_public] = ACTIONS(3519),
    [anon_sym_readonly] = ACTIONS(3519),
    [anon_sym_required] = ACTIONS(3519),
    [anon_sym_sealed] = ACTIONS(3519),
    [anon_sym_virtual] = ACTIONS(3519),
    [anon_sym_volatile] = ACTIONS(3519),
    [anon_sym_where] = ACTIONS(3519),
    [anon_sym_notnull] = ACTIONS(3519),
    [anon_sym_unmanaged] = ACTIONS(3519),
    [anon_sym_checked] = ACTIONS(3519),
    [anon_sym_BANG] = ACTIONS(3521),
    [anon_sym_TILDE] = ACTIONS(3521),
    [anon_sym_PLUS_PLUS] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3521),
    [anon_sym_true] = ACTIONS(3519),
    [anon_sym_false] = ACTIONS(3519),
    [anon_sym_PLUS] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3519),
    [anon_sym_STAR] = ACTIONS(3521),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_AMP] = ACTIONS(3521),
    [anon_sym_this] = ACTIONS(3519),
    [anon_sym_scoped] = ACTIONS(3519),
    [anon_sym_base] = ACTIONS(3519),
    [anon_sym_var] = ACTIONS(3519),
    [sym_predefined_type] = ACTIONS(3519),
    [anon_sym_break] = ACTIONS(3519),
    [anon_sym_unchecked] = ACTIONS(3519),
    [anon_sym_continue] = ACTIONS(3519),
    [anon_sym_do] = ACTIONS(3519),
    [anon_sym_while] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_lock] = ACTIONS(3519),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_switch] = ACTIONS(3519),
    [anon_sym_default] = ACTIONS(3519),
    [anon_sym_throw] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3519),
    [anon_sym_when] = ACTIONS(3519),
    [anon_sym_await] = ACTIONS(3519),
    [anon_sym_foreach] = ACTIONS(3519),
    [anon_sym_goto] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3519),
    [anon_sym_DOT_DOT] = ACTIONS(3521),
    [anon_sym_from] = ACTIONS(3519),
    [anon_sym_into] = ACTIONS(3519),
    [anon_sym_join] = ACTIONS(3519),
    [anon_sym_on] = ACTIONS(3519),
    [anon_sym_equals] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_orderby] = ACTIONS(3519),
    [anon_sym_ascending] = ACTIONS(3519),
    [anon_sym_descending] = ACTIONS(3519),
    [anon_sym_group] = ACTIONS(3519),
    [anon_sym_by] = ACTIONS(3519),
    [anon_sym_select] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3521),
    [anon_sym_stackalloc] = ACTIONS(3519),
    [anon_sym_sizeof] = ACTIONS(3519),
    [anon_sym_typeof] = ACTIONS(3519),
    [anon_sym___makeref] = ACTIONS(3519),
    [anon_sym___reftype] = ACTIONS(3519),
    [anon_sym___refvalue] = ACTIONS(3519),
    [sym_null_literal] = ACTIONS(3519),
    [anon_sym_SQUOTE] = ACTIONS(3521),
    [sym_integer_literal] = ACTIONS(3519),
    [sym_real_literal] = ACTIONS(3521),
    [sym_verbatim_string_literal] = ACTIONS(3521),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3521),
    [sym_interpolation_verbatim_start] = ACTIONS(3521),
    [sym_interpolation_raw_start] = ACTIONS(3521),
    [sym_raw_string_start] = ACTIONS(3521),
  },
  [2540] = {
    [sym_preproc_region] = STATE(2540),
    [sym_preproc_endregion] = STATE(2540),
    [sym_preproc_line] = STATE(2540),
    [sym_preproc_pragma] = STATE(2540),
    [sym_preproc_nullable] = STATE(2540),
    [sym_preproc_error] = STATE(2540),
    [sym_preproc_define] = STATE(2540),
    [sym_preproc_undef] = STATE(2540),
    [ts_builtin_sym_end] = ACTIONS(3601),
    [sym__identifier_token] = ACTIONS(3599),
    [anon_sym_extern] = ACTIONS(3599),
    [anon_sym_alias] = ACTIONS(3599),
    [anon_sym_SEMI] = ACTIONS(3601),
    [anon_sym_global] = ACTIONS(3599),
    [anon_sym_using] = ACTIONS(3599),
    [anon_sym_unsafe] = ACTIONS(3599),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_return] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_struct] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_LBRACE] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_delegate] = ACTIONS(3599),
    [anon_sym_record] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_file] = ACTIONS(3599),
    [anon_sym_fixed] = ACTIONS(3599),
    [anon_sym_internal] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_partial] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_required] = ACTIONS(3599),
    [anon_sym_sealed] = ACTIONS(3599),
    [anon_sym_virtual] = ACTIONS(3599),
    [anon_sym_volatile] = ACTIONS(3599),
    [anon_sym_where] = ACTIONS(3599),
    [anon_sym_notnull] = ACTIONS(3599),
    [anon_sym_unmanaged] = ACTIONS(3599),
    [anon_sym_checked] = ACTIONS(3599),
    [anon_sym_BANG] = ACTIONS(3601),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_PLUS_PLUS] = ACTIONS(3601),
    [anon_sym_DASH_DASH] = ACTIONS(3601),
    [anon_sym_true] = ACTIONS(3599),
    [anon_sym_false] = ACTIONS(3599),
    [anon_sym_PLUS] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_STAR] = ACTIONS(3601),
    [anon_sym_CARET] = ACTIONS(3601),
    [anon_sym_AMP] = ACTIONS(3601),
    [anon_sym_this] = ACTIONS(3599),
    [anon_sym_scoped] = ACTIONS(3599),
    [anon_sym_base] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [sym_predefined_type] = ACTIONS(3599),
    [anon_sym_break] = ACTIONS(3599),
    [anon_sym_unchecked] = ACTIONS(3599),
    [anon_sym_continue] = ACTIONS(3599),
    [anon_sym_do] = ACTIONS(3599),
    [anon_sym_while] = ACTIONS(3599),
    [anon_sym_for] = ACTIONS(3599),
    [anon_sym_lock] = ACTIONS(3599),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_switch] = ACTIONS(3599),
    [anon_sym_default] = ACTIONS(3599),
    [anon_sym_throw] = ACTIONS(3599),
    [anon_sym_try] = ACTIONS(3599),
    [anon_sym_when] = ACTIONS(3599),
    [anon_sym_await] = ACTIONS(3599),
    [anon_sym_foreach] = ACTIONS(3599),
    [anon_sym_goto] = ACTIONS(3599),
    [anon_sym_if] = ACTIONS(3599),
    [anon_sym_DOT_DOT] = ACTIONS(3601),
    [anon_sym_from] = ACTIONS(3599),
    [anon_sym_into] = ACTIONS(3599),
    [anon_sym_join] = ACTIONS(3599),
    [anon_sym_on] = ACTIONS(3599),
    [anon_sym_equals] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_orderby] = ACTIONS(3599),
    [anon_sym_ascending] = ACTIONS(3599),
    [anon_sym_descending] = ACTIONS(3599),
    [anon_sym_group] = ACTIONS(3599),
    [anon_sym_by] = ACTIONS(3599),
    [anon_sym_select] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(3601),
    [anon_sym_stackalloc] = ACTIONS(3599),
    [anon_sym_sizeof] = ACTIONS(3599),
    [anon_sym_typeof] = ACTIONS(3599),
    [anon_sym___makeref] = ACTIONS(3599),
    [anon_sym___reftype] = ACTIONS(3599),
    [anon_sym___refvalue] = ACTIONS(3599),
    [sym_null_literal] = ACTIONS(3599),
    [anon_sym_SQUOTE] = ACTIONS(3601),
    [sym_integer_literal] = ACTIONS(3599),
    [sym_real_literal] = ACTIONS(3601),
    [sym_verbatim_string_literal] = ACTIONS(3601),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3601),
    [sym_interpolation_verbatim_start] = ACTIONS(3601),
    [sym_interpolation_raw_start] = ACTIONS(3601),
    [sym_raw_string_start] = ACTIONS(3601),
  },
  [2541] = {
    [sym_preproc_region] = STATE(2541),
    [sym_preproc_endregion] = STATE(2541),
    [sym_preproc_line] = STATE(2541),
    [sym_preproc_pragma] = STATE(2541),
    [sym_preproc_nullable] = STATE(2541),
    [sym_preproc_error] = STATE(2541),
    [sym_preproc_define] = STATE(2541),
    [sym_preproc_undef] = STATE(2541),
    [ts_builtin_sym_end] = ACTIONS(3625),
    [sym__identifier_token] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym_alias] = ACTIONS(3623),
    [anon_sym_SEMI] = ACTIONS(3625),
    [anon_sym_global] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_unsafe] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_LPAREN] = ACTIONS(3625),
    [anon_sym_return] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_ref] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_delegate] = ACTIONS(3623),
    [anon_sym_record] = ACTIONS(3623),
    [anon_sym_abstract] = ACTIONS(3623),
    [anon_sym_async] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_file] = ACTIONS(3623),
    [anon_sym_fixed] = ACTIONS(3623),
    [anon_sym_internal] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_override] = ACTIONS(3623),
    [anon_sym_partial] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_readonly] = ACTIONS(3623),
    [anon_sym_required] = ACTIONS(3623),
    [anon_sym_sealed] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_where] = ACTIONS(3623),
    [anon_sym_notnull] = ACTIONS(3623),
    [anon_sym_unmanaged] = ACTIONS(3623),
    [anon_sym_checked] = ACTIONS(3623),
    [anon_sym_BANG] = ACTIONS(3625),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_PLUS_PLUS] = ACTIONS(3625),
    [anon_sym_DASH_DASH] = ACTIONS(3625),
    [anon_sym_true] = ACTIONS(3623),
    [anon_sym_false] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(3623),
    [anon_sym_DASH] = ACTIONS(3623),
    [anon_sym_STAR] = ACTIONS(3625),
    [anon_sym_CARET] = ACTIONS(3625),
    [anon_sym_AMP] = ACTIONS(3625),
    [anon_sym_this] = ACTIONS(3623),
    [anon_sym_scoped] = ACTIONS(3623),
    [anon_sym_base] = ACTIONS(3623),
    [anon_sym_var] = ACTIONS(3623),
    [sym_predefined_type] = ACTIONS(3623),
    [anon_sym_break] = ACTIONS(3623),
    [anon_sym_unchecked] = ACTIONS(3623),
    [anon_sym_continue] = ACTIONS(3623),
    [anon_sym_do] = ACTIONS(3623),
    [anon_sym_while] = ACTIONS(3623),
    [anon_sym_for] = ACTIONS(3623),
    [anon_sym_lock] = ACTIONS(3623),
    [anon_sym_yield] = ACTIONS(3623),
    [anon_sym_switch] = ACTIONS(3623),
    [anon_sym_default] = ACTIONS(3623),
    [anon_sym_throw] = ACTIONS(3623),
    [anon_sym_try] = ACTIONS(3623),
    [anon_sym_when] = ACTIONS(3623),
    [anon_sym_await] = ACTIONS(3623),
    [anon_sym_foreach] = ACTIONS(3623),
    [anon_sym_goto] = ACTIONS(3623),
    [anon_sym_if] = ACTIONS(3623),
    [anon_sym_DOT_DOT] = ACTIONS(3625),
    [anon_sym_from] = ACTIONS(3623),
    [anon_sym_into] = ACTIONS(3623),
    [anon_sym_join] = ACTIONS(3623),
    [anon_sym_on] = ACTIONS(3623),
    [anon_sym_equals] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_orderby] = ACTIONS(3623),
    [anon_sym_ascending] = ACTIONS(3623),
    [anon_sym_descending] = ACTIONS(3623),
    [anon_sym_group] = ACTIONS(3623),
    [anon_sym_by] = ACTIONS(3623),
    [anon_sym_select] = ACTIONS(3623),
    [anon_sym_DQUOTE] = ACTIONS(3625),
    [anon_sym_stackalloc] = ACTIONS(3623),
    [anon_sym_sizeof] = ACTIONS(3623),
    [anon_sym_typeof] = ACTIONS(3623),
    [anon_sym___makeref] = ACTIONS(3623),
    [anon_sym___reftype] = ACTIONS(3623),
    [anon_sym___refvalue] = ACTIONS(3623),
    [sym_null_literal] = ACTIONS(3623),
    [anon_sym_SQUOTE] = ACTIONS(3625),
    [sym_integer_literal] = ACTIONS(3623),
    [sym_real_literal] = ACTIONS(3625),
    [sym_verbatim_string_literal] = ACTIONS(3625),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3625),
    [sym_interpolation_verbatim_start] = ACTIONS(3625),
    [sym_interpolation_raw_start] = ACTIONS(3625),
    [sym_raw_string_start] = ACTIONS(3625),
  },
  [2542] = {
    [sym_preproc_region] = STATE(2542),
    [sym_preproc_endregion] = STATE(2542),
    [sym_preproc_line] = STATE(2542),
    [sym_preproc_pragma] = STATE(2542),
    [sym_preproc_nullable] = STATE(2542),
    [sym_preproc_error] = STATE(2542),
    [sym_preproc_define] = STATE(2542),
    [sym_preproc_undef] = STATE(2542),
    [ts_builtin_sym_end] = ACTIONS(3717),
    [sym__identifier_token] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym_alias] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_global] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_unsafe] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(3717),
    [anon_sym_return] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_ref] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_delegate] = ACTIONS(3715),
    [anon_sym_record] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_file] = ACTIONS(3715),
    [anon_sym_fixed] = ACTIONS(3715),
    [anon_sym_internal] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_partial] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_required] = ACTIONS(3715),
    [anon_sym_sealed] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_where] = ACTIONS(3715),
    [anon_sym_notnull] = ACTIONS(3715),
    [anon_sym_unmanaged] = ACTIONS(3715),
    [anon_sym_checked] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3717),
    [anon_sym_DASH_DASH] = ACTIONS(3717),
    [anon_sym_true] = ACTIONS(3715),
    [anon_sym_false] = ACTIONS(3715),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_CARET] = ACTIONS(3717),
    [anon_sym_AMP] = ACTIONS(3717),
    [anon_sym_this] = ACTIONS(3715),
    [anon_sym_scoped] = ACTIONS(3715),
    [anon_sym_base] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [sym_predefined_type] = ACTIONS(3715),
    [anon_sym_break] = ACTIONS(3715),
    [anon_sym_unchecked] = ACTIONS(3715),
    [anon_sym_continue] = ACTIONS(3715),
    [anon_sym_do] = ACTIONS(3715),
    [anon_sym_while] = ACTIONS(3715),
    [anon_sym_for] = ACTIONS(3715),
    [anon_sym_lock] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_switch] = ACTIONS(3715),
    [anon_sym_default] = ACTIONS(3715),
    [anon_sym_throw] = ACTIONS(3715),
    [anon_sym_try] = ACTIONS(3715),
    [anon_sym_when] = ACTIONS(3715),
    [anon_sym_await] = ACTIONS(3715),
    [anon_sym_foreach] = ACTIONS(3715),
    [anon_sym_goto] = ACTIONS(3715),
    [anon_sym_if] = ACTIONS(3715),
    [anon_sym_DOT_DOT] = ACTIONS(3717),
    [anon_sym_from] = ACTIONS(3715),
    [anon_sym_into] = ACTIONS(3715),
    [anon_sym_join] = ACTIONS(3715),
    [anon_sym_on] = ACTIONS(3715),
    [anon_sym_equals] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_orderby] = ACTIONS(3715),
    [anon_sym_ascending] = ACTIONS(3715),
    [anon_sym_descending] = ACTIONS(3715),
    [anon_sym_group] = ACTIONS(3715),
    [anon_sym_by] = ACTIONS(3715),
    [anon_sym_select] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [anon_sym_stackalloc] = ACTIONS(3715),
    [anon_sym_sizeof] = ACTIONS(3715),
    [anon_sym_typeof] = ACTIONS(3715),
    [anon_sym___makeref] = ACTIONS(3715),
    [anon_sym___reftype] = ACTIONS(3715),
    [anon_sym___refvalue] = ACTIONS(3715),
    [sym_null_literal] = ACTIONS(3715),
    [anon_sym_SQUOTE] = ACTIONS(3717),
    [sym_integer_literal] = ACTIONS(3715),
    [sym_real_literal] = ACTIONS(3717),
    [sym_verbatim_string_literal] = ACTIONS(3717),
    [aux_sym_preproc_if_token1] = ACTIONS(3717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3717),
    [sym_interpolation_verbatim_start] = ACTIONS(3717),
    [sym_interpolation_raw_start] = ACTIONS(3717),
    [sym_raw_string_start] = ACTIONS(3717),
  },
  [2543] = {
    [sym_preproc_region] = STATE(2543),
    [sym_preproc_endregion] = STATE(2543),
    [sym_preproc_line] = STATE(2543),
    [sym_preproc_pragma] = STATE(2543),
    [sym_preproc_nullable] = STATE(2543),
    [sym_preproc_error] = STATE(2543),
    [sym_preproc_define] = STATE(2543),
    [sym_preproc_undef] = STATE(2543),
    [ts_builtin_sym_end] = ACTIONS(3729),
    [sym__identifier_token] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym_alias] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3729),
    [anon_sym_global] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_unsafe] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3729),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_ref] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_delegate] = ACTIONS(3727),
    [anon_sym_record] = ACTIONS(3727),
    [anon_sym_abstract] = ACTIONS(3727),
    [anon_sym_async] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_file] = ACTIONS(3727),
    [anon_sym_fixed] = ACTIONS(3727),
    [anon_sym_internal] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_override] = ACTIONS(3727),
    [anon_sym_partial] = ACTIONS(3727),
    [anon_sym_private] = ACTIONS(3727),
    [anon_sym_protected] = ACTIONS(3727),
    [anon_sym_public] = ACTIONS(3727),
    [anon_sym_readonly] = ACTIONS(3727),
    [anon_sym_required] = ACTIONS(3727),
    [anon_sym_sealed] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_where] = ACTIONS(3727),
    [anon_sym_notnull] = ACTIONS(3727),
    [anon_sym_unmanaged] = ACTIONS(3727),
    [anon_sym_checked] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3729),
    [anon_sym_DASH_DASH] = ACTIONS(3729),
    [anon_sym_true] = ACTIONS(3727),
    [anon_sym_false] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3729),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_this] = ACTIONS(3727),
    [anon_sym_scoped] = ACTIONS(3727),
    [anon_sym_base] = ACTIONS(3727),
    [anon_sym_var] = ACTIONS(3727),
    [sym_predefined_type] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_unchecked] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_lock] = ACTIONS(3727),
    [anon_sym_yield] = ACTIONS(3727),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_when] = ACTIONS(3727),
    [anon_sym_await] = ACTIONS(3727),
    [anon_sym_foreach] = ACTIONS(3727),
    [anon_sym_goto] = ACTIONS(3727),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_DOT_DOT] = ACTIONS(3729),
    [anon_sym_from] = ACTIONS(3727),
    [anon_sym_into] = ACTIONS(3727),
    [anon_sym_join] = ACTIONS(3727),
    [anon_sym_on] = ACTIONS(3727),
    [anon_sym_equals] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_orderby] = ACTIONS(3727),
    [anon_sym_ascending] = ACTIONS(3727),
    [anon_sym_descending] = ACTIONS(3727),
    [anon_sym_group] = ACTIONS(3727),
    [anon_sym_by] = ACTIONS(3727),
    [anon_sym_select] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3729),
    [anon_sym_stackalloc] = ACTIONS(3727),
    [anon_sym_sizeof] = ACTIONS(3727),
    [anon_sym_typeof] = ACTIONS(3727),
    [anon_sym___makeref] = ACTIONS(3727),
    [anon_sym___reftype] = ACTIONS(3727),
    [anon_sym___refvalue] = ACTIONS(3727),
    [sym_null_literal] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3729),
    [sym_integer_literal] = ACTIONS(3727),
    [sym_real_literal] = ACTIONS(3729),
    [sym_verbatim_string_literal] = ACTIONS(3729),
    [aux_sym_preproc_if_token1] = ACTIONS(3729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3729),
    [sym_interpolation_verbatim_start] = ACTIONS(3729),
    [sym_interpolation_raw_start] = ACTIONS(3729),
    [sym_raw_string_start] = ACTIONS(3729),
  },
  [2544] = {
    [sym_preproc_region] = STATE(2544),
    [sym_preproc_endregion] = STATE(2544),
    [sym_preproc_line] = STATE(2544),
    [sym_preproc_pragma] = STATE(2544),
    [sym_preproc_nullable] = STATE(2544),
    [sym_preproc_error] = STATE(2544),
    [sym_preproc_define] = STATE(2544),
    [sym_preproc_undef] = STATE(2544),
    [ts_builtin_sym_end] = ACTIONS(4014),
    [sym__identifier_token] = ACTIONS(4016),
    [anon_sym_extern] = ACTIONS(4016),
    [anon_sym_alias] = ACTIONS(4016),
    [anon_sym_SEMI] = ACTIONS(4014),
    [anon_sym_global] = ACTIONS(4016),
    [anon_sym_using] = ACTIONS(4016),
    [anon_sym_unsafe] = ACTIONS(4016),
    [anon_sym_static] = ACTIONS(4016),
    [anon_sym_LBRACK] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4014),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_namespace] = ACTIONS(4016),
    [anon_sym_class] = ACTIONS(4016),
    [anon_sym_ref] = ACTIONS(4016),
    [anon_sym_struct] = ACTIONS(4016),
    [anon_sym_enum] = ACTIONS(4016),
    [anon_sym_LBRACE] = ACTIONS(4014),
    [anon_sym_interface] = ACTIONS(4016),
    [anon_sym_delegate] = ACTIONS(4016),
    [anon_sym_record] = ACTIONS(4016),
    [anon_sym_abstract] = ACTIONS(4016),
    [anon_sym_async] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4016),
    [anon_sym_file] = ACTIONS(4016),
    [anon_sym_fixed] = ACTIONS(4016),
    [anon_sym_internal] = ACTIONS(4016),
    [anon_sym_new] = ACTIONS(4016),
    [anon_sym_override] = ACTIONS(4016),
    [anon_sym_partial] = ACTIONS(4016),
    [anon_sym_private] = ACTIONS(4016),
    [anon_sym_protected] = ACTIONS(4016),
    [anon_sym_public] = ACTIONS(4016),
    [anon_sym_readonly] = ACTIONS(4016),
    [anon_sym_required] = ACTIONS(4016),
    [anon_sym_sealed] = ACTIONS(4016),
    [anon_sym_virtual] = ACTIONS(4016),
    [anon_sym_volatile] = ACTIONS(4016),
    [anon_sym_where] = ACTIONS(4016),
    [anon_sym_notnull] = ACTIONS(4016),
    [anon_sym_unmanaged] = ACTIONS(4016),
    [anon_sym_checked] = ACTIONS(4016),
    [anon_sym_BANG] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4014),
    [anon_sym_PLUS_PLUS] = ACTIONS(4014),
    [anon_sym_DASH_DASH] = ACTIONS(4014),
    [anon_sym_true] = ACTIONS(4016),
    [anon_sym_false] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4014),
    [anon_sym_CARET] = ACTIONS(4014),
    [anon_sym_AMP] = ACTIONS(4014),
    [anon_sym_this] = ACTIONS(4016),
    [anon_sym_scoped] = ACTIONS(4016),
    [anon_sym_base] = ACTIONS(4016),
    [anon_sym_var] = ACTIONS(4016),
    [sym_predefined_type] = ACTIONS(4016),
    [anon_sym_break] = ACTIONS(4016),
    [anon_sym_unchecked] = ACTIONS(4016),
    [anon_sym_continue] = ACTIONS(4016),
    [anon_sym_do] = ACTIONS(4016),
    [anon_sym_while] = ACTIONS(4016),
    [anon_sym_for] = ACTIONS(4016),
    [anon_sym_lock] = ACTIONS(4016),
    [anon_sym_yield] = ACTIONS(4016),
    [anon_sym_switch] = ACTIONS(4016),
    [anon_sym_default] = ACTIONS(4016),
    [anon_sym_throw] = ACTIONS(4016),
    [anon_sym_try] = ACTIONS(4016),
    [anon_sym_when] = ACTIONS(4016),
    [anon_sym_await] = ACTIONS(4016),
    [anon_sym_foreach] = ACTIONS(4016),
    [anon_sym_goto] = ACTIONS(4016),
    [anon_sym_if] = ACTIONS(4016),
    [anon_sym_DOT_DOT] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4016),
    [anon_sym_into] = ACTIONS(4016),
    [anon_sym_join] = ACTIONS(4016),
    [anon_sym_on] = ACTIONS(4016),
    [anon_sym_equals] = ACTIONS(4016),
    [anon_sym_let] = ACTIONS(4016),
    [anon_sym_orderby] = ACTIONS(4016),
    [anon_sym_ascending] = ACTIONS(4016),
    [anon_sym_descending] = ACTIONS(4016),
    [anon_sym_group] = ACTIONS(4016),
    [anon_sym_by] = ACTIONS(4016),
    [anon_sym_select] = ACTIONS(4016),
    [anon_sym_DQUOTE] = ACTIONS(4014),
    [anon_sym_stackalloc] = ACTIONS(4016),
    [anon_sym_sizeof] = ACTIONS(4016),
    [anon_sym_typeof] = ACTIONS(4016),
    [anon_sym___makeref] = ACTIONS(4016),
    [anon_sym___reftype] = ACTIONS(4016),
    [anon_sym___refvalue] = ACTIONS(4016),
    [sym_null_literal] = ACTIONS(4016),
    [anon_sym_SQUOTE] = ACTIONS(4014),
    [sym_integer_literal] = ACTIONS(4016),
    [sym_real_literal] = ACTIONS(4014),
    [sym_verbatim_string_literal] = ACTIONS(4014),
    [aux_sym_preproc_if_token1] = ACTIONS(4014),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(4014),
    [sym_interpolation_verbatim_start] = ACTIONS(4014),
    [sym_interpolation_raw_start] = ACTIONS(4014),
    [sym_raw_string_start] = ACTIONS(4014),
  },
  [2545] = {
    [sym_preproc_region] = STATE(2545),
    [sym_preproc_endregion] = STATE(2545),
    [sym_preproc_line] = STATE(2545),
    [sym_preproc_pragma] = STATE(2545),
    [sym_preproc_nullable] = STATE(2545),
    [sym_preproc_error] = STATE(2545),
    [sym_preproc_define] = STATE(2545),
    [sym_preproc_undef] = STATE(2545),
    [ts_builtin_sym_end] = ACTIONS(3509),
    [sym__identifier_token] = ACTIONS(3507),
    [anon_sym_extern] = ACTIONS(3507),
    [anon_sym_alias] = ACTIONS(3507),
    [anon_sym_SEMI] = ACTIONS(3509),
    [anon_sym_global] = ACTIONS(3507),
    [anon_sym_using] = ACTIONS(3507),
    [anon_sym_unsafe] = ACTIONS(3507),
    [anon_sym_static] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3509),
    [anon_sym_return] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_class] = ACTIONS(3507),
    [anon_sym_ref] = ACTIONS(3507),
    [anon_sym_struct] = ACTIONS(3507),
    [anon_sym_enum] = ACTIONS(3507),
    [anon_sym_LBRACE] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3507),
    [anon_sym_delegate] = ACTIONS(3507),
    [anon_sym_record] = ACTIONS(3507),
    [anon_sym_abstract] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_const] = ACTIONS(3507),
    [anon_sym_file] = ACTIONS(3507),
    [anon_sym_fixed] = ACTIONS(3507),
    [anon_sym_internal] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_override] = ACTIONS(3507),
    [anon_sym_partial] = ACTIONS(3507),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_readonly] = ACTIONS(3507),
    [anon_sym_required] = ACTIONS(3507),
    [anon_sym_sealed] = ACTIONS(3507),
    [anon_sym_virtual] = ACTIONS(3507),
    [anon_sym_volatile] = ACTIONS(3507),
    [anon_sym_where] = ACTIONS(3507),
    [anon_sym_notnull] = ACTIONS(3507),
    [anon_sym_unmanaged] = ACTIONS(3507),
    [anon_sym_checked] = ACTIONS(3507),
    [anon_sym_BANG] = ACTIONS(3509),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_PLUS_PLUS] = ACTIONS(3509),
    [anon_sym_DASH_DASH] = ACTIONS(3509),
    [anon_sym_true] = ACTIONS(3507),
    [anon_sym_false] = ACTIONS(3507),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_STAR] = ACTIONS(3509),
    [anon_sym_CARET] = ACTIONS(3509),
    [anon_sym_AMP] = ACTIONS(3509),
    [anon_sym_this] = ACTIONS(3507),
    [anon_sym_scoped] = ACTIONS(3507),
    [anon_sym_base] = ACTIONS(3507),
    [anon_sym_var] = ACTIONS(3507),
    [sym_predefined_type] = ACTIONS(3507),
    [anon_sym_break] = ACTIONS(3507),
    [anon_sym_unchecked] = ACTIONS(3507),
    [anon_sym_continue] = ACTIONS(3507),
    [anon_sym_do] = ACTIONS(3507),
    [anon_sym_while] = ACTIONS(3507),
    [anon_sym_for] = ACTIONS(3507),
    [anon_sym_lock] = ACTIONS(3507),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_switch] = ACTIONS(3507),
    [anon_sym_default] = ACTIONS(3507),
    [anon_sym_throw] = ACTIONS(3507),
    [anon_sym_try] = ACTIONS(3507),
    [anon_sym_when] = ACTIONS(3507),
    [anon_sym_await] = ACTIONS(3507),
    [anon_sym_foreach] = ACTIONS(3507),
    [anon_sym_goto] = ACTIONS(3507),
    [anon_sym_if] = ACTIONS(3507),
    [anon_sym_DOT_DOT] = ACTIONS(3509),
    [anon_sym_from] = ACTIONS(3507),
    [anon_sym_into] = ACTIONS(3507),
    [anon_sym_join] = ACTIONS(3507),
    [anon_sym_on] = ACTIONS(3507),
    [anon_sym_equals] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_orderby] = ACTIONS(3507),
    [anon_sym_ascending] = ACTIONS(3507),
    [anon_sym_descending] = ACTIONS(3507),
    [anon_sym_group] = ACTIONS(3507),
    [anon_sym_by] = ACTIONS(3507),
    [anon_sym_select] = ACTIONS(3507),
    [anon_sym_DQUOTE] = ACTIONS(3509),
    [anon_sym_stackalloc] = ACTIONS(3507),
    [anon_sym_sizeof] = ACTIONS(3507),
    [anon_sym_typeof] = ACTIONS(3507),
    [anon_sym___makeref] = ACTIONS(3507),
    [anon_sym___reftype] = ACTIONS(3507),
    [anon_sym___refvalue] = ACTIONS(3507),
    [sym_null_literal] = ACTIONS(3507),
    [anon_sym_SQUOTE] = ACTIONS(3509),
    [sym_integer_literal] = ACTIONS(3507),
    [sym_real_literal] = ACTIONS(3509),
    [sym_verbatim_string_literal] = ACTIONS(3509),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3509),
    [sym_interpolation_verbatim_start] = ACTIONS(3509),
    [sym_interpolation_raw_start] = ACTIONS(3509),
    [sym_raw_string_start] = ACTIONS(3509),
  },
  [2546] = {
    [sym_preproc_region] = STATE(2546),
    [sym_preproc_endregion] = STATE(2546),
    [sym_preproc_line] = STATE(2546),
    [sym_preproc_pragma] = STATE(2546),
    [sym_preproc_nullable] = STATE(2546),
    [sym_preproc_error] = STATE(2546),
    [sym_preproc_define] = STATE(2546),
    [sym_preproc_undef] = STATE(2546),
    [ts_builtin_sym_end] = ACTIONS(3649),
    [sym__identifier_token] = ACTIONS(3647),
    [anon_sym_extern] = ACTIONS(3647),
    [anon_sym_alias] = ACTIONS(3647),
    [anon_sym_SEMI] = ACTIONS(3649),
    [anon_sym_global] = ACTIONS(3647),
    [anon_sym_using] = ACTIONS(3647),
    [anon_sym_unsafe] = ACTIONS(3647),
    [anon_sym_static] = ACTIONS(3647),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_LPAREN] = ACTIONS(3649),
    [anon_sym_return] = ACTIONS(3647),
    [anon_sym_namespace] = ACTIONS(3647),
    [anon_sym_class] = ACTIONS(3647),
    [anon_sym_ref] = ACTIONS(3647),
    [anon_sym_struct] = ACTIONS(3647),
    [anon_sym_enum] = ACTIONS(3647),
    [anon_sym_LBRACE] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3647),
    [anon_sym_delegate] = ACTIONS(3647),
    [anon_sym_record] = ACTIONS(3647),
    [anon_sym_abstract] = ACTIONS(3647),
    [anon_sym_async] = ACTIONS(3647),
    [anon_sym_const] = ACTIONS(3647),
    [anon_sym_file] = ACTIONS(3647),
    [anon_sym_fixed] = ACTIONS(3647),
    [anon_sym_internal] = ACTIONS(3647),
    [anon_sym_new] = ACTIONS(3647),
    [anon_sym_override] = ACTIONS(3647),
    [anon_sym_partial] = ACTIONS(3647),
    [anon_sym_private] = ACTIONS(3647),
    [anon_sym_protected] = ACTIONS(3647),
    [anon_sym_public] = ACTIONS(3647),
    [anon_sym_readonly] = ACTIONS(3647),
    [anon_sym_required] = ACTIONS(3647),
    [anon_sym_sealed] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(3647),
    [anon_sym_volatile] = ACTIONS(3647),
    [anon_sym_where] = ACTIONS(3647),
    [anon_sym_notnull] = ACTIONS(3647),
    [anon_sym_unmanaged] = ACTIONS(3647),
    [anon_sym_checked] = ACTIONS(3647),
    [anon_sym_BANG] = ACTIONS(3649),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3649),
    [anon_sym_DASH_DASH] = ACTIONS(3649),
    [anon_sym_true] = ACTIONS(3647),
    [anon_sym_false] = ACTIONS(3647),
    [anon_sym_PLUS] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_CARET] = ACTIONS(3649),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_this] = ACTIONS(3647),
    [anon_sym_scoped] = ACTIONS(3647),
    [anon_sym_base] = ACTIONS(3647),
    [anon_sym_var] = ACTIONS(3647),
    [sym_predefined_type] = ACTIONS(3647),
    [anon_sym_break] = ACTIONS(3647),
    [anon_sym_unchecked] = ACTIONS(3647),
    [anon_sym_continue] = ACTIONS(3647),
    [anon_sym_do] = ACTIONS(3647),
    [anon_sym_while] = ACTIONS(3647),
    [anon_sym_for] = ACTIONS(3647),
    [anon_sym_lock] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3647),
    [anon_sym_switch] = ACTIONS(3647),
    [anon_sym_default] = ACTIONS(3647),
    [anon_sym_throw] = ACTIONS(3647),
    [anon_sym_try] = ACTIONS(3647),
    [anon_sym_when] = ACTIONS(3647),
    [anon_sym_await] = ACTIONS(3647),
    [anon_sym_foreach] = ACTIONS(3647),
    [anon_sym_goto] = ACTIONS(3647),
    [anon_sym_if] = ACTIONS(3647),
    [anon_sym_DOT_DOT] = ACTIONS(3649),
    [anon_sym_from] = ACTIONS(3647),
    [anon_sym_into] = ACTIONS(3647),
    [anon_sym_join] = ACTIONS(3647),
    [anon_sym_on] = ACTIONS(3647),
    [anon_sym_equals] = ACTIONS(3647),
    [anon_sym_let] = ACTIONS(3647),
    [anon_sym_orderby] = ACTIONS(3647),
    [anon_sym_ascending] = ACTIONS(3647),
    [anon_sym_descending] = ACTIONS(3647),
    [anon_sym_group] = ACTIONS(3647),
    [anon_sym_by] = ACTIONS(3647),
    [anon_sym_select] = ACTIONS(3647),
    [anon_sym_DQUOTE] = ACTIONS(3649),
    [anon_sym_stackalloc] = ACTIONS(3647),
    [anon_sym_sizeof] = ACTIONS(3647),
    [anon_sym_typeof] = ACTIONS(3647),
    [anon_sym___makeref] = ACTIONS(3647),
    [anon_sym___reftype] = ACTIONS(3647),
    [anon_sym___refvalue] = ACTIONS(3647),
    [sym_null_literal] = ACTIONS(3647),
    [anon_sym_SQUOTE] = ACTIONS(3649),
    [sym_integer_literal] = ACTIONS(3647),
    [sym_real_literal] = ACTIONS(3649),
    [sym_verbatim_string_literal] = ACTIONS(3649),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3649),
    [sym_interpolation_verbatim_start] = ACTIONS(3649),
    [sym_interpolation_raw_start] = ACTIONS(3649),
    [sym_raw_string_start] = ACTIONS(3649),
  },
  [2547] = {
    [sym_preproc_region] = STATE(2547),
    [sym_preproc_endregion] = STATE(2547),
    [sym_preproc_line] = STATE(2547),
    [sym_preproc_pragma] = STATE(2547),
    [sym_preproc_nullable] = STATE(2547),
    [sym_preproc_error] = STATE(2547),
    [sym_preproc_define] = STATE(2547),
    [sym_preproc_undef] = STATE(2547),
    [ts_builtin_sym_end] = ACTIONS(3769),
    [sym__identifier_token] = ACTIONS(3767),
    [anon_sym_extern] = ACTIONS(3767),
    [anon_sym_alias] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3769),
    [anon_sym_global] = ACTIONS(3767),
    [anon_sym_using] = ACTIONS(3767),
    [anon_sym_unsafe] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3769),
    [anon_sym_LPAREN] = ACTIONS(3769),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_ref] = ACTIONS(3767),
    [anon_sym_struct] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_delegate] = ACTIONS(3767),
    [anon_sym_record] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_async] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_file] = ACTIONS(3767),
    [anon_sym_fixed] = ACTIONS(3767),
    [anon_sym_internal] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_override] = ACTIONS(3767),
    [anon_sym_partial] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3767),
    [anon_sym_protected] = ACTIONS(3767),
    [anon_sym_public] = ACTIONS(3767),
    [anon_sym_readonly] = ACTIONS(3767),
    [anon_sym_required] = ACTIONS(3767),
    [anon_sym_sealed] = ACTIONS(3767),
    [anon_sym_virtual] = ACTIONS(3767),
    [anon_sym_volatile] = ACTIONS(3767),
    [anon_sym_where] = ACTIONS(3767),
    [anon_sym_notnull] = ACTIONS(3767),
    [anon_sym_unmanaged] = ACTIONS(3767),
    [anon_sym_checked] = ACTIONS(3767),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_TILDE] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3769),
    [anon_sym_DASH_DASH] = ACTIONS(3769),
    [anon_sym_true] = ACTIONS(3767),
    [anon_sym_false] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_CARET] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_this] = ACTIONS(3767),
    [anon_sym_scoped] = ACTIONS(3767),
    [anon_sym_base] = ACTIONS(3767),
    [anon_sym_var] = ACTIONS(3767),
    [sym_predefined_type] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_unchecked] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_lock] = ACTIONS(3767),
    [anon_sym_yield] = ACTIONS(3767),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_when] = ACTIONS(3767),
    [anon_sym_await] = ACTIONS(3767),
    [anon_sym_foreach] = ACTIONS(3767),
    [anon_sym_goto] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_DOT_DOT] = ACTIONS(3769),
    [anon_sym_from] = ACTIONS(3767),
    [anon_sym_into] = ACTIONS(3767),
    [anon_sym_join] = ACTIONS(3767),
    [anon_sym_on] = ACTIONS(3767),
    [anon_sym_equals] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_orderby] = ACTIONS(3767),
    [anon_sym_ascending] = ACTIONS(3767),
    [anon_sym_descending] = ACTIONS(3767),
    [anon_sym_group] = ACTIONS(3767),
    [anon_sym_by] = ACTIONS(3767),
    [anon_sym_select] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(3769),
    [anon_sym_stackalloc] = ACTIONS(3767),
    [anon_sym_sizeof] = ACTIONS(3767),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym___makeref] = ACTIONS(3767),
    [anon_sym___reftype] = ACTIONS(3767),
    [anon_sym___refvalue] = ACTIONS(3767),
    [sym_null_literal] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(3769),
    [sym_integer_literal] = ACTIONS(3767),
    [sym_real_literal] = ACTIONS(3769),
    [sym_verbatim_string_literal] = ACTIONS(3769),
    [aux_sym_preproc_if_token1] = ACTIONS(3769),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3769),
    [sym_interpolation_verbatim_start] = ACTIONS(3769),
    [sym_interpolation_raw_start] = ACTIONS(3769),
    [sym_raw_string_start] = ACTIONS(3769),
  },
  [2548] = {
    [sym_preproc_region] = STATE(2548),
    [sym_preproc_endregion] = STATE(2548),
    [sym_preproc_line] = STATE(2548),
    [sym_preproc_pragma] = STATE(2548),
    [sym_preproc_nullable] = STATE(2548),
    [sym_preproc_error] = STATE(2548),
    [sym_preproc_define] = STATE(2548),
    [sym_preproc_undef] = STATE(2548),
    [ts_builtin_sym_end] = ACTIONS(4018),
    [sym__identifier_token] = ACTIONS(4020),
    [anon_sym_extern] = ACTIONS(4020),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_using] = ACTIONS(4020),
    [anon_sym_unsafe] = ACTIONS(4020),
    [anon_sym_static] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4020),
    [anon_sym_namespace] = ACTIONS(4020),
    [anon_sym_class] = ACTIONS(4020),
    [anon_sym_ref] = ACTIONS(4020),
    [anon_sym_struct] = ACTIONS(4020),
    [anon_sym_enum] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4020),
    [anon_sym_delegate] = ACTIONS(4020),
    [anon_sym_record] = ACTIONS(4020),
    [anon_sym_abstract] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(4020),
    [anon_sym_const] = ACTIONS(4020),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_fixed] = ACTIONS(4020),
    [anon_sym_internal] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4020),
    [anon_sym_override] = ACTIONS(4020),
    [anon_sym_partial] = ACTIONS(4020),
    [anon_sym_private] = ACTIONS(4020),
    [anon_sym_protected] = ACTIONS(4020),
    [anon_sym_public] = ACTIONS(4020),
    [anon_sym_readonly] = ACTIONS(4020),
    [anon_sym_required] = ACTIONS(4020),
    [anon_sym_sealed] = ACTIONS(4020),
    [anon_sym_virtual] = ACTIONS(4020),
    [anon_sym_volatile] = ACTIONS(4020),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_checked] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4018),
    [anon_sym_DASH_DASH] = ACTIONS(4018),
    [anon_sym_true] = ACTIONS(4020),
    [anon_sym_false] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4020),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_CARET] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_this] = ACTIONS(4020),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_base] = ACTIONS(4020),
    [anon_sym_var] = ACTIONS(4020),
    [sym_predefined_type] = ACTIONS(4020),
    [anon_sym_break] = ACTIONS(4020),
    [anon_sym_unchecked] = ACTIONS(4020),
    [anon_sym_continue] = ACTIONS(4020),
    [anon_sym_do] = ACTIONS(4020),
    [anon_sym_while] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4020),
    [anon_sym_lock] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4020),
    [anon_sym_throw] = ACTIONS(4020),
    [anon_sym_try] = ACTIONS(4020),
    [anon_sym_when] = ACTIONS(4020),
    [anon_sym_await] = ACTIONS(4020),
    [anon_sym_foreach] = ACTIONS(4020),
    [anon_sym_goto] = ACTIONS(4020),
    [anon_sym_if] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4018),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_stackalloc] = ACTIONS(4020),
    [anon_sym_sizeof] = ACTIONS(4020),
    [anon_sym_typeof] = ACTIONS(4020),
    [anon_sym___makeref] = ACTIONS(4020),
    [anon_sym___reftype] = ACTIONS(4020),
    [anon_sym___refvalue] = ACTIONS(4020),
    [sym_null_literal] = ACTIONS(4020),
    [anon_sym_SQUOTE] = ACTIONS(4018),
    [sym_integer_literal] = ACTIONS(4020),
    [sym_real_literal] = ACTIONS(4018),
    [sym_verbatim_string_literal] = ACTIONS(4018),
    [aux_sym_preproc_if_token1] = ACTIONS(4018),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(4018),
    [sym_interpolation_verbatim_start] = ACTIONS(4018),
    [sym_interpolation_raw_start] = ACTIONS(4018),
    [sym_raw_string_start] = ACTIONS(4018),
  },
  [2549] = {
    [sym_preproc_region] = STATE(2549),
    [sym_preproc_endregion] = STATE(2549),
    [sym_preproc_line] = STATE(2549),
    [sym_preproc_pragma] = STATE(2549),
    [sym_preproc_nullable] = STATE(2549),
    [sym_preproc_error] = STATE(2549),
    [sym_preproc_define] = STATE(2549),
    [sym_preproc_undef] = STATE(2549),
    [ts_builtin_sym_end] = ACTIONS(3621),
    [sym__identifier_token] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym_alias] = ACTIONS(3619),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_global] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_unsafe] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_return] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_ref] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_LBRACE] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_delegate] = ACTIONS(3619),
    [anon_sym_record] = ACTIONS(3619),
    [anon_sym_abstract] = ACTIONS(3619),
    [anon_sym_async] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_file] = ACTIONS(3619),
    [anon_sym_fixed] = ACTIONS(3619),
    [anon_sym_internal] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_override] = ACTIONS(3619),
    [anon_sym_partial] = ACTIONS(3619),
    [anon_sym_private] = ACTIONS(3619),
    [anon_sym_protected] = ACTIONS(3619),
    [anon_sym_public] = ACTIONS(3619),
    [anon_sym_readonly] = ACTIONS(3619),
    [anon_sym_required] = ACTIONS(3619),
    [anon_sym_sealed] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_where] = ACTIONS(3619),
    [anon_sym_notnull] = ACTIONS(3619),
    [anon_sym_unmanaged] = ACTIONS(3619),
    [anon_sym_checked] = ACTIONS(3619),
    [anon_sym_BANG] = ACTIONS(3621),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_PLUS_PLUS] = ACTIONS(3621),
    [anon_sym_DASH_DASH] = ACTIONS(3621),
    [anon_sym_true] = ACTIONS(3619),
    [anon_sym_false] = ACTIONS(3619),
    [anon_sym_PLUS] = ACTIONS(3619),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_STAR] = ACTIONS(3621),
    [anon_sym_CARET] = ACTIONS(3621),
    [anon_sym_AMP] = ACTIONS(3621),
    [anon_sym_this] = ACTIONS(3619),
    [anon_sym_scoped] = ACTIONS(3619),
    [anon_sym_base] = ACTIONS(3619),
    [anon_sym_var] = ACTIONS(3619),
    [sym_predefined_type] = ACTIONS(3619),
    [anon_sym_break] = ACTIONS(3619),
    [anon_sym_unchecked] = ACTIONS(3619),
    [anon_sym_continue] = ACTIONS(3619),
    [anon_sym_do] = ACTIONS(3619),
    [anon_sym_while] = ACTIONS(3619),
    [anon_sym_for] = ACTIONS(3619),
    [anon_sym_lock] = ACTIONS(3619),
    [anon_sym_yield] = ACTIONS(3619),
    [anon_sym_switch] = ACTIONS(3619),
    [anon_sym_default] = ACTIONS(3619),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_try] = ACTIONS(3619),
    [anon_sym_when] = ACTIONS(3619),
    [anon_sym_await] = ACTIONS(3619),
    [anon_sym_foreach] = ACTIONS(3619),
    [anon_sym_goto] = ACTIONS(3619),
    [anon_sym_if] = ACTIONS(3619),
    [anon_sym_DOT_DOT] = ACTIONS(3621),
    [anon_sym_from] = ACTIONS(3619),
    [anon_sym_into] = ACTIONS(3619),
    [anon_sym_join] = ACTIONS(3619),
    [anon_sym_on] = ACTIONS(3619),
    [anon_sym_equals] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_orderby] = ACTIONS(3619),
    [anon_sym_ascending] = ACTIONS(3619),
    [anon_sym_descending] = ACTIONS(3619),
    [anon_sym_group] = ACTIONS(3619),
    [anon_sym_by] = ACTIONS(3619),
    [anon_sym_select] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_stackalloc] = ACTIONS(3619),
    [anon_sym_sizeof] = ACTIONS(3619),
    [anon_sym_typeof] = ACTIONS(3619),
    [anon_sym___makeref] = ACTIONS(3619),
    [anon_sym___reftype] = ACTIONS(3619),
    [anon_sym___refvalue] = ACTIONS(3619),
    [sym_null_literal] = ACTIONS(3619),
    [anon_sym_SQUOTE] = ACTIONS(3621),
    [sym_integer_literal] = ACTIONS(3619),
    [sym_real_literal] = ACTIONS(3621),
    [sym_verbatim_string_literal] = ACTIONS(3621),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3621),
    [sym_interpolation_verbatim_start] = ACTIONS(3621),
    [sym_interpolation_raw_start] = ACTIONS(3621),
    [sym_raw_string_start] = ACTIONS(3621),
  },
  [2550] = {
    [sym_preproc_region] = STATE(2550),
    [sym_preproc_endregion] = STATE(2550),
    [sym_preproc_line] = STATE(2550),
    [sym_preproc_pragma] = STATE(2550),
    [sym_preproc_nullable] = STATE(2550),
    [sym_preproc_error] = STATE(2550),
    [sym_preproc_define] = STATE(2550),
    [sym_preproc_undef] = STATE(2550),
    [ts_builtin_sym_end] = ACTIONS(4022),
    [sym__identifier_token] = ACTIONS(4024),
    [anon_sym_extern] = ACTIONS(4024),
    [anon_sym_alias] = ACTIONS(4024),
    [anon_sym_SEMI] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4024),
    [anon_sym_using] = ACTIONS(4024),
    [anon_sym_unsafe] = ACTIONS(4024),
    [anon_sym_static] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(4022),
    [anon_sym_return] = ACTIONS(4024),
    [anon_sym_namespace] = ACTIONS(4024),
    [anon_sym_class] = ACTIONS(4024),
    [anon_sym_ref] = ACTIONS(4024),
    [anon_sym_struct] = ACTIONS(4024),
    [anon_sym_enum] = ACTIONS(4024),
    [anon_sym_LBRACE] = ACTIONS(4022),
    [anon_sym_interface] = ACTIONS(4024),
    [anon_sym_delegate] = ACTIONS(4024),
    [anon_sym_record] = ACTIONS(4024),
    [anon_sym_abstract] = ACTIONS(4024),
    [anon_sym_async] = ACTIONS(4024),
    [anon_sym_const] = ACTIONS(4024),
    [anon_sym_file] = ACTIONS(4024),
    [anon_sym_fixed] = ACTIONS(4024),
    [anon_sym_internal] = ACTIONS(4024),
    [anon_sym_new] = ACTIONS(4024),
    [anon_sym_override] = ACTIONS(4024),
    [anon_sym_partial] = ACTIONS(4024),
    [anon_sym_private] = ACTIONS(4024),
    [anon_sym_protected] = ACTIONS(4024),
    [anon_sym_public] = ACTIONS(4024),
    [anon_sym_readonly] = ACTIONS(4024),
    [anon_sym_required] = ACTIONS(4024),
    [anon_sym_sealed] = ACTIONS(4024),
    [anon_sym_virtual] = ACTIONS(4024),
    [anon_sym_volatile] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4024),
    [anon_sym_notnull] = ACTIONS(4024),
    [anon_sym_unmanaged] = ACTIONS(4024),
    [anon_sym_checked] = ACTIONS(4024),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(4022),
    [anon_sym_PLUS_PLUS] = ACTIONS(4022),
    [anon_sym_DASH_DASH] = ACTIONS(4022),
    [anon_sym_true] = ACTIONS(4024),
    [anon_sym_false] = ACTIONS(4024),
    [anon_sym_PLUS] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(4024),
    [anon_sym_STAR] = ACTIONS(4022),
    [anon_sym_CARET] = ACTIONS(4022),
    [anon_sym_AMP] = ACTIONS(4022),
    [anon_sym_this] = ACTIONS(4024),
    [anon_sym_scoped] = ACTIONS(4024),
    [anon_sym_base] = ACTIONS(4024),
    [anon_sym_var] = ACTIONS(4024),
    [sym_predefined_type] = ACTIONS(4024),
    [anon_sym_break] = ACTIONS(4024),
    [anon_sym_unchecked] = ACTIONS(4024),
    [anon_sym_continue] = ACTIONS(4024),
    [anon_sym_do] = ACTIONS(4024),
    [anon_sym_while] = ACTIONS(4024),
    [anon_sym_for] = ACTIONS(4024),
    [anon_sym_lock] = ACTIONS(4024),
    [anon_sym_yield] = ACTIONS(4024),
    [anon_sym_switch] = ACTIONS(4024),
    [anon_sym_default] = ACTIONS(4024),
    [anon_sym_throw] = ACTIONS(4024),
    [anon_sym_try] = ACTIONS(4024),
    [anon_sym_when] = ACTIONS(4024),
    [anon_sym_await] = ACTIONS(4024),
    [anon_sym_foreach] = ACTIONS(4024),
    [anon_sym_goto] = ACTIONS(4024),
    [anon_sym_if] = ACTIONS(4024),
    [anon_sym_DOT_DOT] = ACTIONS(4022),
    [anon_sym_from] = ACTIONS(4024),
    [anon_sym_into] = ACTIONS(4024),
    [anon_sym_join] = ACTIONS(4024),
    [anon_sym_on] = ACTIONS(4024),
    [anon_sym_equals] = ACTIONS(4024),
    [anon_sym_let] = ACTIONS(4024),
    [anon_sym_orderby] = ACTIONS(4024),
    [anon_sym_ascending] = ACTIONS(4024),
    [anon_sym_descending] = ACTIONS(4024),
    [anon_sym_group] = ACTIONS(4024),
    [anon_sym_by] = ACTIONS(4024),
    [anon_sym_select] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(4022),
    [anon_sym_stackalloc] = ACTIONS(4024),
    [anon_sym_sizeof] = ACTIONS(4024),
    [anon_sym_typeof] = ACTIONS(4024),
    [anon_sym___makeref] = ACTIONS(4024),
    [anon_sym___reftype] = ACTIONS(4024),
    [anon_sym___refvalue] = ACTIONS(4024),
    [sym_null_literal] = ACTIONS(4024),
    [anon_sym_SQUOTE] = ACTIONS(4022),
    [sym_integer_literal] = ACTIONS(4024),
    [sym_real_literal] = ACTIONS(4022),
    [sym_verbatim_string_literal] = ACTIONS(4022),
    [aux_sym_preproc_if_token1] = ACTIONS(4022),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(4022),
    [sym_interpolation_verbatim_start] = ACTIONS(4022),
    [sym_interpolation_raw_start] = ACTIONS(4022),
    [sym_raw_string_start] = ACTIONS(4022),
  },
  [2551] = {
    [sym_preproc_region] = STATE(2551),
    [sym_preproc_endregion] = STATE(2551),
    [sym_preproc_line] = STATE(2551),
    [sym_preproc_pragma] = STATE(2551),
    [sym_preproc_nullable] = STATE(2551),
    [sym_preproc_error] = STATE(2551),
    [sym_preproc_define] = STATE(2551),
    [sym_preproc_undef] = STATE(2551),
    [ts_builtin_sym_end] = ACTIONS(3585),
    [sym__identifier_token] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym_alias] = ACTIONS(3583),
    [anon_sym_SEMI] = ACTIONS(3585),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_unsafe] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_return] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_ref] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_LBRACE] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_delegate] = ACTIONS(3583),
    [anon_sym_record] = ACTIONS(3583),
    [anon_sym_abstract] = ACTIONS(3583),
    [anon_sym_async] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_file] = ACTIONS(3583),
    [anon_sym_fixed] = ACTIONS(3583),
    [anon_sym_internal] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_override] = ACTIONS(3583),
    [anon_sym_partial] = ACTIONS(3583),
    [anon_sym_private] = ACTIONS(3583),
    [anon_sym_protected] = ACTIONS(3583),
    [anon_sym_public] = ACTIONS(3583),
    [anon_sym_readonly] = ACTIONS(3583),
    [anon_sym_required] = ACTIONS(3583),
    [anon_sym_sealed] = ACTIONS(3583),
    [anon_sym_virtual] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_where] = ACTIONS(3583),
    [anon_sym_notnull] = ACTIONS(3583),
    [anon_sym_unmanaged] = ACTIONS(3583),
    [anon_sym_checked] = ACTIONS(3583),
    [anon_sym_BANG] = ACTIONS(3585),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_PLUS_PLUS] = ACTIONS(3585),
    [anon_sym_DASH_DASH] = ACTIONS(3585),
    [anon_sym_true] = ACTIONS(3583),
    [anon_sym_false] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(3583),
    [anon_sym_DASH] = ACTIONS(3583),
    [anon_sym_STAR] = ACTIONS(3585),
    [anon_sym_CARET] = ACTIONS(3585),
    [anon_sym_AMP] = ACTIONS(3585),
    [anon_sym_this] = ACTIONS(3583),
    [anon_sym_scoped] = ACTIONS(3583),
    [anon_sym_base] = ACTIONS(3583),
    [anon_sym_var] = ACTIONS(3583),
    [sym_predefined_type] = ACTIONS(3583),
    [anon_sym_break] = ACTIONS(3583),
    [anon_sym_unchecked] = ACTIONS(3583),
    [anon_sym_continue] = ACTIONS(3583),
    [anon_sym_do] = ACTIONS(3583),
    [anon_sym_while] = ACTIONS(3583),
    [anon_sym_for] = ACTIONS(3583),
    [anon_sym_lock] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3583),
    [anon_sym_switch] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3583),
    [anon_sym_throw] = ACTIONS(3583),
    [anon_sym_try] = ACTIONS(3583),
    [anon_sym_when] = ACTIONS(3583),
    [anon_sym_await] = ACTIONS(3583),
    [anon_sym_foreach] = ACTIONS(3583),
    [anon_sym_goto] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(3583),
    [anon_sym_DOT_DOT] = ACTIONS(3585),
    [anon_sym_from] = ACTIONS(3583),
    [anon_sym_into] = ACTIONS(3583),
    [anon_sym_join] = ACTIONS(3583),
    [anon_sym_on] = ACTIONS(3583),
    [anon_sym_equals] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_orderby] = ACTIONS(3583),
    [anon_sym_ascending] = ACTIONS(3583),
    [anon_sym_descending] = ACTIONS(3583),
    [anon_sym_group] = ACTIONS(3583),
    [anon_sym_by] = ACTIONS(3583),
    [anon_sym_select] = ACTIONS(3583),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_stackalloc] = ACTIONS(3583),
    [anon_sym_sizeof] = ACTIONS(3583),
    [anon_sym_typeof] = ACTIONS(3583),
    [anon_sym___makeref] = ACTIONS(3583),
    [anon_sym___reftype] = ACTIONS(3583),
    [anon_sym___refvalue] = ACTIONS(3583),
    [sym_null_literal] = ACTIONS(3583),
    [anon_sym_SQUOTE] = ACTIONS(3585),
    [sym_integer_literal] = ACTIONS(3583),
    [sym_real_literal] = ACTIONS(3585),
    [sym_verbatim_string_literal] = ACTIONS(3585),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3585),
    [sym_interpolation_verbatim_start] = ACTIONS(3585),
    [sym_interpolation_raw_start] = ACTIONS(3585),
    [sym_raw_string_start] = ACTIONS(3585),
  },
  [2552] = {
    [sym_preproc_region] = STATE(2552),
    [sym_preproc_endregion] = STATE(2552),
    [sym_preproc_line] = STATE(2552),
    [sym_preproc_pragma] = STATE(2552),
    [sym_preproc_nullable] = STATE(2552),
    [sym_preproc_error] = STATE(2552),
    [sym_preproc_define] = STATE(2552),
    [sym_preproc_undef] = STATE(2552),
    [ts_builtin_sym_end] = ACTIONS(3801),
    [sym__identifier_token] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym_alias] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3801),
    [anon_sym_global] = ACTIONS(3799),
    [anon_sym_using] = ACTIONS(3799),
    [anon_sym_unsafe] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3801),
    [anon_sym_return] = ACTIONS(3799),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_class] = ACTIONS(3799),
    [anon_sym_ref] = ACTIONS(3799),
    [anon_sym_struct] = ACTIONS(3799),
    [anon_sym_enum] = ACTIONS(3799),
    [anon_sym_LBRACE] = ACTIONS(3801),
    [anon_sym_interface] = ACTIONS(3799),
    [anon_sym_delegate] = ACTIONS(3799),
    [anon_sym_record] = ACTIONS(3799),
    [anon_sym_abstract] = ACTIONS(3799),
    [anon_sym_async] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_file] = ACTIONS(3799),
    [anon_sym_fixed] = ACTIONS(3799),
    [anon_sym_internal] = ACTIONS(3799),
    [anon_sym_new] = ACTIONS(3799),
    [anon_sym_override] = ACTIONS(3799),
    [anon_sym_partial] = ACTIONS(3799),
    [anon_sym_private] = ACTIONS(3799),
    [anon_sym_protected] = ACTIONS(3799),
    [anon_sym_public] = ACTIONS(3799),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_required] = ACTIONS(3799),
    [anon_sym_sealed] = ACTIONS(3799),
    [anon_sym_virtual] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_where] = ACTIONS(3799),
    [anon_sym_notnull] = ACTIONS(3799),
    [anon_sym_unmanaged] = ACTIONS(3799),
    [anon_sym_checked] = ACTIONS(3799),
    [anon_sym_BANG] = ACTIONS(3801),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_PLUS_PLUS] = ACTIONS(3801),
    [anon_sym_DASH_DASH] = ACTIONS(3801),
    [anon_sym_true] = ACTIONS(3799),
    [anon_sym_false] = ACTIONS(3799),
    [anon_sym_PLUS] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(3799),
    [anon_sym_STAR] = ACTIONS(3801),
    [anon_sym_CARET] = ACTIONS(3801),
    [anon_sym_AMP] = ACTIONS(3801),
    [anon_sym_this] = ACTIONS(3799),
    [anon_sym_scoped] = ACTIONS(3799),
    [anon_sym_base] = ACTIONS(3799),
    [anon_sym_var] = ACTIONS(3799),
    [sym_predefined_type] = ACTIONS(3799),
    [anon_sym_break] = ACTIONS(3799),
    [anon_sym_unchecked] = ACTIONS(3799),
    [anon_sym_continue] = ACTIONS(3799),
    [anon_sym_do] = ACTIONS(3799),
    [anon_sym_while] = ACTIONS(3799),
    [anon_sym_for] = ACTIONS(3799),
    [anon_sym_lock] = ACTIONS(3799),
    [anon_sym_yield] = ACTIONS(3799),
    [anon_sym_switch] = ACTIONS(3799),
    [anon_sym_default] = ACTIONS(3799),
    [anon_sym_throw] = ACTIONS(3799),
    [anon_sym_try] = ACTIONS(3799),
    [anon_sym_when] = ACTIONS(3799),
    [anon_sym_await] = ACTIONS(3799),
    [anon_sym_foreach] = ACTIONS(3799),
    [anon_sym_goto] = ACTIONS(3799),
    [anon_sym_if] = ACTIONS(3799),
    [anon_sym_DOT_DOT] = ACTIONS(3801),
    [anon_sym_from] = ACTIONS(3799),
    [anon_sym_into] = ACTIONS(3799),
    [anon_sym_join] = ACTIONS(3799),
    [anon_sym_on] = ACTIONS(3799),
    [anon_sym_equals] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_orderby] = ACTIONS(3799),
    [anon_sym_ascending] = ACTIONS(3799),
    [anon_sym_descending] = ACTIONS(3799),
    [anon_sym_group] = ACTIONS(3799),
    [anon_sym_by] = ACTIONS(3799),
    [anon_sym_select] = ACTIONS(3799),
    [anon_sym_DQUOTE] = ACTIONS(3801),
    [anon_sym_stackalloc] = ACTIONS(3799),
    [anon_sym_sizeof] = ACTIONS(3799),
    [anon_sym_typeof] = ACTIONS(3799),
    [anon_sym___makeref] = ACTIONS(3799),
    [anon_sym___reftype] = ACTIONS(3799),
    [anon_sym___refvalue] = ACTIONS(3799),
    [sym_null_literal] = ACTIONS(3799),
    [anon_sym_SQUOTE] = ACTIONS(3801),
    [sym_integer_literal] = ACTIONS(3799),
    [sym_real_literal] = ACTIONS(3801),
    [sym_verbatim_string_literal] = ACTIONS(3801),
    [aux_sym_preproc_if_token1] = ACTIONS(3801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3801),
    [sym_interpolation_verbatim_start] = ACTIONS(3801),
    [sym_interpolation_raw_start] = ACTIONS(3801),
    [sym_raw_string_start] = ACTIONS(3801),
  },
  [2553] = {
    [sym_preproc_region] = STATE(2553),
    [sym_preproc_endregion] = STATE(2553),
    [sym_preproc_line] = STATE(2553),
    [sym_preproc_pragma] = STATE(2553),
    [sym_preproc_nullable] = STATE(2553),
    [sym_preproc_error] = STATE(2553),
    [sym_preproc_define] = STATE(2553),
    [sym_preproc_undef] = STATE(2553),
    [ts_builtin_sym_end] = ACTIONS(3757),
    [sym__identifier_token] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym_alias] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3757),
    [anon_sym_global] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_unsafe] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3757),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_ref] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3757),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_delegate] = ACTIONS(3755),
    [anon_sym_record] = ACTIONS(3755),
    [anon_sym_abstract] = ACTIONS(3755),
    [anon_sym_async] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_file] = ACTIONS(3755),
    [anon_sym_fixed] = ACTIONS(3755),
    [anon_sym_internal] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_override] = ACTIONS(3755),
    [anon_sym_partial] = ACTIONS(3755),
    [anon_sym_private] = ACTIONS(3755),
    [anon_sym_protected] = ACTIONS(3755),
    [anon_sym_public] = ACTIONS(3755),
    [anon_sym_readonly] = ACTIONS(3755),
    [anon_sym_required] = ACTIONS(3755),
    [anon_sym_sealed] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_where] = ACTIONS(3755),
    [anon_sym_notnull] = ACTIONS(3755),
    [anon_sym_unmanaged] = ACTIONS(3755),
    [anon_sym_checked] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3757),
    [anon_sym_true] = ACTIONS(3755),
    [anon_sym_false] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3757),
    [anon_sym_CARET] = ACTIONS(3757),
    [anon_sym_AMP] = ACTIONS(3757),
    [anon_sym_this] = ACTIONS(3755),
    [anon_sym_scoped] = ACTIONS(3755),
    [anon_sym_base] = ACTIONS(3755),
    [anon_sym_var] = ACTIONS(3755),
    [sym_predefined_type] = ACTIONS(3755),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_unchecked] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_lock] = ACTIONS(3755),
    [anon_sym_yield] = ACTIONS(3755),
    [anon_sym_switch] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_when] = ACTIONS(3755),
    [anon_sym_await] = ACTIONS(3755),
    [anon_sym_foreach] = ACTIONS(3755),
    [anon_sym_goto] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_DOT_DOT] = ACTIONS(3757),
    [anon_sym_from] = ACTIONS(3755),
    [anon_sym_into] = ACTIONS(3755),
    [anon_sym_join] = ACTIONS(3755),
    [anon_sym_on] = ACTIONS(3755),
    [anon_sym_equals] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_orderby] = ACTIONS(3755),
    [anon_sym_ascending] = ACTIONS(3755),
    [anon_sym_descending] = ACTIONS(3755),
    [anon_sym_group] = ACTIONS(3755),
    [anon_sym_by] = ACTIONS(3755),
    [anon_sym_select] = ACTIONS(3755),
    [anon_sym_DQUOTE] = ACTIONS(3757),
    [anon_sym_stackalloc] = ACTIONS(3755),
    [anon_sym_sizeof] = ACTIONS(3755),
    [anon_sym_typeof] = ACTIONS(3755),
    [anon_sym___makeref] = ACTIONS(3755),
    [anon_sym___reftype] = ACTIONS(3755),
    [anon_sym___refvalue] = ACTIONS(3755),
    [sym_null_literal] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3757),
    [sym_integer_literal] = ACTIONS(3755),
    [sym_real_literal] = ACTIONS(3757),
    [sym_verbatim_string_literal] = ACTIONS(3757),
    [aux_sym_preproc_if_token1] = ACTIONS(3757),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3757),
    [sym_interpolation_verbatim_start] = ACTIONS(3757),
    [sym_interpolation_raw_start] = ACTIONS(3757),
    [sym_raw_string_start] = ACTIONS(3757),
  },
  [2554] = {
    [sym_preproc_region] = STATE(2554),
    [sym_preproc_endregion] = STATE(2554),
    [sym_preproc_line] = STATE(2554),
    [sym_preproc_pragma] = STATE(2554),
    [sym_preproc_nullable] = STATE(2554),
    [sym_preproc_error] = STATE(2554),
    [sym_preproc_define] = STATE(2554),
    [sym_preproc_undef] = STATE(2554),
    [ts_builtin_sym_end] = ACTIONS(3493),
    [sym__identifier_token] = ACTIONS(3491),
    [anon_sym_extern] = ACTIONS(3491),
    [anon_sym_alias] = ACTIONS(3491),
    [anon_sym_SEMI] = ACTIONS(3493),
    [anon_sym_global] = ACTIONS(3491),
    [anon_sym_using] = ACTIONS(3491),
    [anon_sym_unsafe] = ACTIONS(3491),
    [anon_sym_static] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(3493),
    [anon_sym_LPAREN] = ACTIONS(3493),
    [anon_sym_return] = ACTIONS(3491),
    [anon_sym_namespace] = ACTIONS(3491),
    [anon_sym_class] = ACTIONS(3491),
    [anon_sym_ref] = ACTIONS(3491),
    [anon_sym_struct] = ACTIONS(3491),
    [anon_sym_enum] = ACTIONS(3491),
    [anon_sym_LBRACE] = ACTIONS(3493),
    [anon_sym_interface] = ACTIONS(3491),
    [anon_sym_delegate] = ACTIONS(3491),
    [anon_sym_record] = ACTIONS(3491),
    [anon_sym_abstract] = ACTIONS(3491),
    [anon_sym_async] = ACTIONS(3491),
    [anon_sym_const] = ACTIONS(3491),
    [anon_sym_file] = ACTIONS(3491),
    [anon_sym_fixed] = ACTIONS(3491),
    [anon_sym_internal] = ACTIONS(3491),
    [anon_sym_new] = ACTIONS(3491),
    [anon_sym_override] = ACTIONS(3491),
    [anon_sym_partial] = ACTIONS(3491),
    [anon_sym_private] = ACTIONS(3491),
    [anon_sym_protected] = ACTIONS(3491),
    [anon_sym_public] = ACTIONS(3491),
    [anon_sym_readonly] = ACTIONS(3491),
    [anon_sym_required] = ACTIONS(3491),
    [anon_sym_sealed] = ACTIONS(3491),
    [anon_sym_virtual] = ACTIONS(3491),
    [anon_sym_volatile] = ACTIONS(3491),
    [anon_sym_where] = ACTIONS(3491),
    [anon_sym_notnull] = ACTIONS(3491),
    [anon_sym_unmanaged] = ACTIONS(3491),
    [anon_sym_checked] = ACTIONS(3491),
    [anon_sym_BANG] = ACTIONS(3493),
    [anon_sym_TILDE] = ACTIONS(3493),
    [anon_sym_PLUS_PLUS] = ACTIONS(3493),
    [anon_sym_DASH_DASH] = ACTIONS(3493),
    [anon_sym_true] = ACTIONS(3491),
    [anon_sym_false] = ACTIONS(3491),
    [anon_sym_PLUS] = ACTIONS(3491),
    [anon_sym_DASH] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(3493),
    [anon_sym_CARET] = ACTIONS(3493),
    [anon_sym_AMP] = ACTIONS(3493),
    [anon_sym_this] = ACTIONS(3491),
    [anon_sym_scoped] = ACTIONS(3491),
    [anon_sym_base] = ACTIONS(3491),
    [anon_sym_var] = ACTIONS(3491),
    [sym_predefined_type] = ACTIONS(3491),
    [anon_sym_break] = ACTIONS(3491),
    [anon_sym_unchecked] = ACTIONS(3491),
    [anon_sym_continue] = ACTIONS(3491),
    [anon_sym_do] = ACTIONS(3491),
    [anon_sym_while] = ACTIONS(3491),
    [anon_sym_for] = ACTIONS(3491),
    [anon_sym_lock] = ACTIONS(3491),
    [anon_sym_yield] = ACTIONS(3491),
    [anon_sym_switch] = ACTIONS(3491),
    [anon_sym_default] = ACTIONS(3491),
    [anon_sym_throw] = ACTIONS(3491),
    [anon_sym_try] = ACTIONS(3491),
    [anon_sym_when] = ACTIONS(3491),
    [anon_sym_await] = ACTIONS(3491),
    [anon_sym_foreach] = ACTIONS(3491),
    [anon_sym_goto] = ACTIONS(3491),
    [anon_sym_if] = ACTIONS(3491),
    [anon_sym_DOT_DOT] = ACTIONS(3493),
    [anon_sym_from] = ACTIONS(3491),
    [anon_sym_into] = ACTIONS(3491),
    [anon_sym_join] = ACTIONS(3491),
    [anon_sym_on] = ACTIONS(3491),
    [anon_sym_equals] = ACTIONS(3491),
    [anon_sym_let] = ACTIONS(3491),
    [anon_sym_orderby] = ACTIONS(3491),
    [anon_sym_ascending] = ACTIONS(3491),
    [anon_sym_descending] = ACTIONS(3491),
    [anon_sym_group] = ACTIONS(3491),
    [anon_sym_by] = ACTIONS(3491),
    [anon_sym_select] = ACTIONS(3491),
    [anon_sym_DQUOTE] = ACTIONS(3493),
    [anon_sym_stackalloc] = ACTIONS(3491),
    [anon_sym_sizeof] = ACTIONS(3491),
    [anon_sym_typeof] = ACTIONS(3491),
    [anon_sym___makeref] = ACTIONS(3491),
    [anon_sym___reftype] = ACTIONS(3491),
    [anon_sym___refvalue] = ACTIONS(3491),
    [sym_null_literal] = ACTIONS(3491),
    [anon_sym_SQUOTE] = ACTIONS(3493),
    [sym_integer_literal] = ACTIONS(3491),
    [sym_real_literal] = ACTIONS(3493),
    [sym_verbatim_string_literal] = ACTIONS(3493),
    [aux_sym_preproc_if_token1] = ACTIONS(3493),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3493),
    [sym_interpolation_verbatim_start] = ACTIONS(3493),
    [sym_interpolation_raw_start] = ACTIONS(3493),
    [sym_raw_string_start] = ACTIONS(3493),
  },
  [2555] = {
    [sym_preproc_region] = STATE(2555),
    [sym_preproc_endregion] = STATE(2555),
    [sym_preproc_line] = STATE(2555),
    [sym_preproc_pragma] = STATE(2555),
    [sym_preproc_nullable] = STATE(2555),
    [sym_preproc_error] = STATE(2555),
    [sym_preproc_define] = STATE(2555),
    [sym_preproc_undef] = STATE(2555),
    [ts_builtin_sym_end] = ACTIONS(3749),
    [sym__identifier_token] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym_alias] = ACTIONS(3747),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_global] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_unsafe] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_ref] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_delegate] = ACTIONS(3747),
    [anon_sym_record] = ACTIONS(3747),
    [anon_sym_abstract] = ACTIONS(3747),
    [anon_sym_async] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_file] = ACTIONS(3747),
    [anon_sym_fixed] = ACTIONS(3747),
    [anon_sym_internal] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_override] = ACTIONS(3747),
    [anon_sym_partial] = ACTIONS(3747),
    [anon_sym_private] = ACTIONS(3747),
    [anon_sym_protected] = ACTIONS(3747),
    [anon_sym_public] = ACTIONS(3747),
    [anon_sym_readonly] = ACTIONS(3747),
    [anon_sym_required] = ACTIONS(3747),
    [anon_sym_sealed] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_where] = ACTIONS(3747),
    [anon_sym_notnull] = ACTIONS(3747),
    [anon_sym_unmanaged] = ACTIONS(3747),
    [anon_sym_checked] = ACTIONS(3747),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_true] = ACTIONS(3747),
    [anon_sym_false] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3747),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_STAR] = ACTIONS(3749),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3749),
    [anon_sym_this] = ACTIONS(3747),
    [anon_sym_scoped] = ACTIONS(3747),
    [anon_sym_base] = ACTIONS(3747),
    [anon_sym_var] = ACTIONS(3747),
    [sym_predefined_type] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_unchecked] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_do] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_lock] = ACTIONS(3747),
    [anon_sym_yield] = ACTIONS(3747),
    [anon_sym_switch] = ACTIONS(3747),
    [anon_sym_default] = ACTIONS(3747),
    [anon_sym_throw] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_when] = ACTIONS(3747),
    [anon_sym_await] = ACTIONS(3747),
    [anon_sym_foreach] = ACTIONS(3747),
    [anon_sym_goto] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_DOT_DOT] = ACTIONS(3749),
    [anon_sym_from] = ACTIONS(3747),
    [anon_sym_into] = ACTIONS(3747),
    [anon_sym_join] = ACTIONS(3747),
    [anon_sym_on] = ACTIONS(3747),
    [anon_sym_equals] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_orderby] = ACTIONS(3747),
    [anon_sym_ascending] = ACTIONS(3747),
    [anon_sym_descending] = ACTIONS(3747),
    [anon_sym_group] = ACTIONS(3747),
    [anon_sym_by] = ACTIONS(3747),
    [anon_sym_select] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [anon_sym_stackalloc] = ACTIONS(3747),
    [anon_sym_sizeof] = ACTIONS(3747),
    [anon_sym_typeof] = ACTIONS(3747),
    [anon_sym___makeref] = ACTIONS(3747),
    [anon_sym___reftype] = ACTIONS(3747),
    [anon_sym___refvalue] = ACTIONS(3747),
    [sym_null_literal] = ACTIONS(3747),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [sym_integer_literal] = ACTIONS(3747),
    [sym_real_literal] = ACTIONS(3749),
    [sym_verbatim_string_literal] = ACTIONS(3749),
    [aux_sym_preproc_if_token1] = ACTIONS(3749),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3749),
    [sym_interpolation_verbatim_start] = ACTIONS(3749),
    [sym_interpolation_raw_start] = ACTIONS(3749),
    [sym_raw_string_start] = ACTIONS(3749),
  },
  [2556] = {
    [sym_preproc_region] = STATE(2556),
    [sym_preproc_endregion] = STATE(2556),
    [sym_preproc_line] = STATE(2556),
    [sym_preproc_pragma] = STATE(2556),
    [sym_preproc_nullable] = STATE(2556),
    [sym_preproc_error] = STATE(2556),
    [sym_preproc_define] = STATE(2556),
    [sym_preproc_undef] = STATE(2556),
    [ts_builtin_sym_end] = ACTIONS(3413),
    [sym__identifier_token] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_alias] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(3413),
    [anon_sym_global] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_unsafe] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_return] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_ref] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_LBRACE] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3411),
    [anon_sym_record] = ACTIONS(3411),
    [anon_sym_abstract] = ACTIONS(3411),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_file] = ACTIONS(3411),
    [anon_sym_fixed] = ACTIONS(3411),
    [anon_sym_internal] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_override] = ACTIONS(3411),
    [anon_sym_partial] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_readonly] = ACTIONS(3411),
    [anon_sym_required] = ACTIONS(3411),
    [anon_sym_sealed] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_where] = ACTIONS(3411),
    [anon_sym_notnull] = ACTIONS(3411),
    [anon_sym_unmanaged] = ACTIONS(3411),
    [anon_sym_checked] = ACTIONS(3411),
    [anon_sym_BANG] = ACTIONS(3413),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_PLUS_PLUS] = ACTIONS(3413),
    [anon_sym_DASH_DASH] = ACTIONS(3413),
    [anon_sym_true] = ACTIONS(3411),
    [anon_sym_false] = ACTIONS(3411),
    [anon_sym_PLUS] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(3411),
    [anon_sym_STAR] = ACTIONS(3413),
    [anon_sym_CARET] = ACTIONS(3413),
    [anon_sym_AMP] = ACTIONS(3413),
    [anon_sym_this] = ACTIONS(3411),
    [anon_sym_scoped] = ACTIONS(3411),
    [anon_sym_base] = ACTIONS(3411),
    [anon_sym_var] = ACTIONS(3411),
    [sym_predefined_type] = ACTIONS(3411),
    [anon_sym_break] = ACTIONS(3411),
    [anon_sym_unchecked] = ACTIONS(3411),
    [anon_sym_continue] = ACTIONS(3411),
    [anon_sym_do] = ACTIONS(3411),
    [anon_sym_while] = ACTIONS(3411),
    [anon_sym_for] = ACTIONS(3411),
    [anon_sym_lock] = ACTIONS(3411),
    [anon_sym_yield] = ACTIONS(3411),
    [anon_sym_switch] = ACTIONS(3411),
    [anon_sym_default] = ACTIONS(3411),
    [anon_sym_throw] = ACTIONS(3411),
    [anon_sym_try] = ACTIONS(3411),
    [anon_sym_when] = ACTIONS(3411),
    [anon_sym_await] = ACTIONS(3411),
    [anon_sym_foreach] = ACTIONS(3411),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym_if] = ACTIONS(3411),
    [anon_sym_DOT_DOT] = ACTIONS(3413),
    [anon_sym_from] = ACTIONS(3411),
    [anon_sym_into] = ACTIONS(3411),
    [anon_sym_join] = ACTIONS(3411),
    [anon_sym_on] = ACTIONS(3411),
    [anon_sym_equals] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_orderby] = ACTIONS(3411),
    [anon_sym_ascending] = ACTIONS(3411),
    [anon_sym_descending] = ACTIONS(3411),
    [anon_sym_group] = ACTIONS(3411),
    [anon_sym_by] = ACTIONS(3411),
    [anon_sym_select] = ACTIONS(3411),
    [anon_sym_DQUOTE] = ACTIONS(3413),
    [anon_sym_stackalloc] = ACTIONS(3411),
    [anon_sym_sizeof] = ACTIONS(3411),
    [anon_sym_typeof] = ACTIONS(3411),
    [anon_sym___makeref] = ACTIONS(3411),
    [anon_sym___reftype] = ACTIONS(3411),
    [anon_sym___refvalue] = ACTIONS(3411),
    [sym_null_literal] = ACTIONS(3411),
    [anon_sym_SQUOTE] = ACTIONS(3413),
    [sym_integer_literal] = ACTIONS(3411),
    [sym_real_literal] = ACTIONS(3413),
    [sym_verbatim_string_literal] = ACTIONS(3413),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3413),
    [sym_interpolation_verbatim_start] = ACTIONS(3413),
    [sym_interpolation_raw_start] = ACTIONS(3413),
    [sym_raw_string_start] = ACTIONS(3413),
  },
  [2557] = {
    [sym_preproc_region] = STATE(2557),
    [sym_preproc_endregion] = STATE(2557),
    [sym_preproc_line] = STATE(2557),
    [sym_preproc_pragma] = STATE(2557),
    [sym_preproc_nullable] = STATE(2557),
    [sym_preproc_error] = STATE(2557),
    [sym_preproc_define] = STATE(2557),
    [sym_preproc_undef] = STATE(2557),
    [ts_builtin_sym_end] = ACTIONS(4018),
    [sym__identifier_token] = ACTIONS(4020),
    [anon_sym_extern] = ACTIONS(4020),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_using] = ACTIONS(4020),
    [anon_sym_unsafe] = ACTIONS(4020),
    [anon_sym_static] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_return] = ACTIONS(4020),
    [anon_sym_namespace] = ACTIONS(4020),
    [anon_sym_class] = ACTIONS(4020),
    [anon_sym_ref] = ACTIONS(4020),
    [anon_sym_struct] = ACTIONS(4020),
    [anon_sym_enum] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(4018),
    [anon_sym_interface] = ACTIONS(4020),
    [anon_sym_delegate] = ACTIONS(4020),
    [anon_sym_record] = ACTIONS(4020),
    [anon_sym_abstract] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(4020),
    [anon_sym_const] = ACTIONS(4020),
    [anon_sym_file] = ACTIONS(4020),
    [anon_sym_fixed] = ACTIONS(4020),
    [anon_sym_internal] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4020),
    [anon_sym_override] = ACTIONS(4020),
    [anon_sym_partial] = ACTIONS(4020),
    [anon_sym_private] = ACTIONS(4020),
    [anon_sym_protected] = ACTIONS(4020),
    [anon_sym_public] = ACTIONS(4020),
    [anon_sym_readonly] = ACTIONS(4020),
    [anon_sym_required] = ACTIONS(4020),
    [anon_sym_sealed] = ACTIONS(4020),
    [anon_sym_virtual] = ACTIONS(4020),
    [anon_sym_volatile] = ACTIONS(4020),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_checked] = ACTIONS(4020),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_PLUS_PLUS] = ACTIONS(4018),
    [anon_sym_DASH_DASH] = ACTIONS(4018),
    [anon_sym_true] = ACTIONS(4020),
    [anon_sym_false] = ACTIONS(4020),
    [anon_sym_PLUS] = ACTIONS(4020),
    [anon_sym_DASH] = ACTIONS(4020),
    [anon_sym_STAR] = ACTIONS(4018),
    [anon_sym_CARET] = ACTIONS(4018),
    [anon_sym_AMP] = ACTIONS(4018),
    [anon_sym_this] = ACTIONS(4020),
    [anon_sym_scoped] = ACTIONS(4020),
    [anon_sym_base] = ACTIONS(4020),
    [anon_sym_var] = ACTIONS(4020),
    [sym_predefined_type] = ACTIONS(4020),
    [anon_sym_break] = ACTIONS(4020),
    [anon_sym_unchecked] = ACTIONS(4020),
    [anon_sym_continue] = ACTIONS(4020),
    [anon_sym_do] = ACTIONS(4020),
    [anon_sym_while] = ACTIONS(4020),
    [anon_sym_for] = ACTIONS(4020),
    [anon_sym_lock] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_switch] = ACTIONS(4020),
    [anon_sym_default] = ACTIONS(4020),
    [anon_sym_throw] = ACTIONS(4020),
    [anon_sym_try] = ACTIONS(4020),
    [anon_sym_when] = ACTIONS(4020),
    [anon_sym_await] = ACTIONS(4020),
    [anon_sym_foreach] = ACTIONS(4020),
    [anon_sym_goto] = ACTIONS(4020),
    [anon_sym_if] = ACTIONS(4020),
    [anon_sym_DOT_DOT] = ACTIONS(4018),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [anon_sym_DQUOTE] = ACTIONS(4018),
    [anon_sym_stackalloc] = ACTIONS(4020),
    [anon_sym_sizeof] = ACTIONS(4020),
    [anon_sym_typeof] = ACTIONS(4020),
    [anon_sym___makeref] = ACTIONS(4020),
    [anon_sym___reftype] = ACTIONS(4020),
    [anon_sym___refvalue] = ACTIONS(4020),
    [sym_null_literal] = ACTIONS(4020),
    [anon_sym_SQUOTE] = ACTIONS(4018),
    [sym_integer_literal] = ACTIONS(4020),
    [sym_real_literal] = ACTIONS(4018),
    [sym_verbatim_string_literal] = ACTIONS(4018),
    [aux_sym_preproc_if_token1] = ACTIONS(4018),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(4018),
    [sym_interpolation_verbatim_start] = ACTIONS(4018),
    [sym_interpolation_raw_start] = ACTIONS(4018),
    [sym_raw_string_start] = ACTIONS(4018),
  },
  [2558] = {
    [sym_preproc_region] = STATE(2558),
    [sym_preproc_endregion] = STATE(2558),
    [sym_preproc_line] = STATE(2558),
    [sym_preproc_pragma] = STATE(2558),
    [sym_preproc_nullable] = STATE(2558),
    [sym_preproc_error] = STATE(2558),
    [sym_preproc_define] = STATE(2558),
    [sym_preproc_undef] = STATE(2558),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [sym__identifier_token] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym_alias] = ACTIONS(3763),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_global] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_unsafe] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_return] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_ref] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_delegate] = ACTIONS(3763),
    [anon_sym_record] = ACTIONS(3763),
    [anon_sym_abstract] = ACTIONS(3763),
    [anon_sym_async] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_file] = ACTIONS(3763),
    [anon_sym_fixed] = ACTIONS(3763),
    [anon_sym_internal] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_override] = ACTIONS(3763),
    [anon_sym_partial] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_readonly] = ACTIONS(3763),
    [anon_sym_required] = ACTIONS(3763),
    [anon_sym_sealed] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_where] = ACTIONS(3763),
    [anon_sym_notnull] = ACTIONS(3763),
    [anon_sym_unmanaged] = ACTIONS(3763),
    [anon_sym_checked] = ACTIONS(3763),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_true] = ACTIONS(3763),
    [anon_sym_false] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(3763),
    [anon_sym_DASH] = ACTIONS(3763),
    [anon_sym_STAR] = ACTIONS(3765),
    [anon_sym_CARET] = ACTIONS(3765),
    [anon_sym_AMP] = ACTIONS(3765),
    [anon_sym_this] = ACTIONS(3763),
    [anon_sym_scoped] = ACTIONS(3763),
    [anon_sym_base] = ACTIONS(3763),
    [anon_sym_var] = ACTIONS(3763),
    [sym_predefined_type] = ACTIONS(3763),
    [anon_sym_break] = ACTIONS(3763),
    [anon_sym_unchecked] = ACTIONS(3763),
    [anon_sym_continue] = ACTIONS(3763),
    [anon_sym_do] = ACTIONS(3763),
    [anon_sym_while] = ACTIONS(3763),
    [anon_sym_for] = ACTIONS(3763),
    [anon_sym_lock] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(3763),
    [anon_sym_switch] = ACTIONS(3763),
    [anon_sym_default] = ACTIONS(3763),
    [anon_sym_throw] = ACTIONS(3763),
    [anon_sym_try] = ACTIONS(3763),
    [anon_sym_when] = ACTIONS(3763),
    [anon_sym_await] = ACTIONS(3763),
    [anon_sym_foreach] = ACTIONS(3763),
    [anon_sym_goto] = ACTIONS(3763),
    [anon_sym_if] = ACTIONS(3763),
    [anon_sym_DOT_DOT] = ACTIONS(3765),
    [anon_sym_from] = ACTIONS(3763),
    [anon_sym_into] = ACTIONS(3763),
    [anon_sym_join] = ACTIONS(3763),
    [anon_sym_on] = ACTIONS(3763),
    [anon_sym_equals] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_orderby] = ACTIONS(3763),
    [anon_sym_ascending] = ACTIONS(3763),
    [anon_sym_descending] = ACTIONS(3763),
    [anon_sym_group] = ACTIONS(3763),
    [anon_sym_by] = ACTIONS(3763),
    [anon_sym_select] = ACTIONS(3763),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [anon_sym_stackalloc] = ACTIONS(3763),
    [anon_sym_sizeof] = ACTIONS(3763),
    [anon_sym_typeof] = ACTIONS(3763),
    [anon_sym___makeref] = ACTIONS(3763),
    [anon_sym___reftype] = ACTIONS(3763),
    [anon_sym___refvalue] = ACTIONS(3763),
    [sym_null_literal] = ACTIONS(3763),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [sym_integer_literal] = ACTIONS(3763),
    [sym_real_literal] = ACTIONS(3765),
    [sym_verbatim_string_literal] = ACTIONS(3765),
    [aux_sym_preproc_if_token1] = ACTIONS(3765),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3765),
    [sym_interpolation_verbatim_start] = ACTIONS(3765),
    [sym_interpolation_raw_start] = ACTIONS(3765),
    [sym_raw_string_start] = ACTIONS(3765),
  },
  [2559] = {
    [sym_preproc_region] = STATE(2559),
    [sym_preproc_endregion] = STATE(2559),
    [sym_preproc_line] = STATE(2559),
    [sym_preproc_pragma] = STATE(2559),
    [sym_preproc_nullable] = STATE(2559),
    [sym_preproc_error] = STATE(2559),
    [sym_preproc_define] = STATE(2559),
    [sym_preproc_undef] = STATE(2559),
    [ts_builtin_sym_end] = ACTIONS(3633),
    [sym__identifier_token] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym_alias] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3633),
    [anon_sym_global] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_unsafe] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_return] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_ref] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_delegate] = ACTIONS(3631),
    [anon_sym_record] = ACTIONS(3631),
    [anon_sym_abstract] = ACTIONS(3631),
    [anon_sym_async] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_file] = ACTIONS(3631),
    [anon_sym_fixed] = ACTIONS(3631),
    [anon_sym_internal] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_override] = ACTIONS(3631),
    [anon_sym_partial] = ACTIONS(3631),
    [anon_sym_private] = ACTIONS(3631),
    [anon_sym_protected] = ACTIONS(3631),
    [anon_sym_public] = ACTIONS(3631),
    [anon_sym_readonly] = ACTIONS(3631),
    [anon_sym_required] = ACTIONS(3631),
    [anon_sym_sealed] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_notnull] = ACTIONS(3631),
    [anon_sym_unmanaged] = ACTIONS(3631),
    [anon_sym_checked] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3633),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_PLUS_PLUS] = ACTIONS(3633),
    [anon_sym_DASH_DASH] = ACTIONS(3633),
    [anon_sym_true] = ACTIONS(3631),
    [anon_sym_false] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3633),
    [anon_sym_CARET] = ACTIONS(3633),
    [anon_sym_AMP] = ACTIONS(3633),
    [anon_sym_this] = ACTIONS(3631),
    [anon_sym_scoped] = ACTIONS(3631),
    [anon_sym_base] = ACTIONS(3631),
    [anon_sym_var] = ACTIONS(3631),
    [sym_predefined_type] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3631),
    [anon_sym_unchecked] = ACTIONS(3631),
    [anon_sym_continue] = ACTIONS(3631),
    [anon_sym_do] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3631),
    [anon_sym_lock] = ACTIONS(3631),
    [anon_sym_yield] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3631),
    [anon_sym_default] = ACTIONS(3631),
    [anon_sym_throw] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3631),
    [anon_sym_when] = ACTIONS(3631),
    [anon_sym_await] = ACTIONS(3631),
    [anon_sym_foreach] = ACTIONS(3631),
    [anon_sym_goto] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3631),
    [anon_sym_DOT_DOT] = ACTIONS(3633),
    [anon_sym_from] = ACTIONS(3631),
    [anon_sym_into] = ACTIONS(3631),
    [anon_sym_join] = ACTIONS(3631),
    [anon_sym_on] = ACTIONS(3631),
    [anon_sym_equals] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_orderby] = ACTIONS(3631),
    [anon_sym_ascending] = ACTIONS(3631),
    [anon_sym_descending] = ACTIONS(3631),
    [anon_sym_group] = ACTIONS(3631),
    [anon_sym_by] = ACTIONS(3631),
    [anon_sym_select] = ACTIONS(3631),
    [anon_sym_DQUOTE] = ACTIONS(3633),
    [anon_sym_stackalloc] = ACTIONS(3631),
    [anon_sym_sizeof] = ACTIONS(3631),
    [anon_sym_typeof] = ACTIONS(3631),
    [anon_sym___makeref] = ACTIONS(3631),
    [anon_sym___reftype] = ACTIONS(3631),
    [anon_sym___refvalue] = ACTIONS(3631),
    [sym_null_literal] = ACTIONS(3631),
    [anon_sym_SQUOTE] = ACTIONS(3633),
    [sym_integer_literal] = ACTIONS(3631),
    [sym_real_literal] = ACTIONS(3633),
    [sym_verbatim_string_literal] = ACTIONS(3633),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3633),
    [sym_interpolation_verbatim_start] = ACTIONS(3633),
    [sym_interpolation_raw_start] = ACTIONS(3633),
    [sym_raw_string_start] = ACTIONS(3633),
  },
  [2560] = {
    [sym_preproc_region] = STATE(2560),
    [sym_preproc_endregion] = STATE(2560),
    [sym_preproc_line] = STATE(2560),
    [sym_preproc_pragma] = STATE(2560),
    [sym_preproc_nullable] = STATE(2560),
    [sym_preproc_error] = STATE(2560),
    [sym_preproc_define] = STATE(2560),
    [sym_preproc_undef] = STATE(2560),
    [ts_builtin_sym_end] = ACTIONS(3445),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_return] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_checked] = ACTIONS(3443),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_true] = ACTIONS(3443),
    [anon_sym_false] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3443),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_this] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_base] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_break] = ACTIONS(3443),
    [anon_sym_unchecked] = ACTIONS(3443),
    [anon_sym_continue] = ACTIONS(3443),
    [anon_sym_do] = ACTIONS(3443),
    [anon_sym_while] = ACTIONS(3443),
    [anon_sym_for] = ACTIONS(3443),
    [anon_sym_lock] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_switch] = ACTIONS(3443),
    [anon_sym_default] = ACTIONS(3443),
    [anon_sym_throw] = ACTIONS(3443),
    [anon_sym_try] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_await] = ACTIONS(3443),
    [anon_sym_foreach] = ACTIONS(3443),
    [anon_sym_goto] = ACTIONS(3443),
    [anon_sym_if] = ACTIONS(3443),
    [anon_sym_DOT_DOT] = ACTIONS(3445),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_stackalloc] = ACTIONS(3443),
    [anon_sym_sizeof] = ACTIONS(3443),
    [anon_sym_typeof] = ACTIONS(3443),
    [anon_sym___makeref] = ACTIONS(3443),
    [anon_sym___reftype] = ACTIONS(3443),
    [anon_sym___refvalue] = ACTIONS(3443),
    [sym_null_literal] = ACTIONS(3443),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [sym_integer_literal] = ACTIONS(3443),
    [sym_real_literal] = ACTIONS(3445),
    [sym_verbatim_string_literal] = ACTIONS(3445),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3445),
    [sym_interpolation_verbatim_start] = ACTIONS(3445),
    [sym_interpolation_raw_start] = ACTIONS(3445),
    [sym_raw_string_start] = ACTIONS(3445),
  },
  [2561] = {
    [sym_preproc_region] = STATE(2561),
    [sym_preproc_endregion] = STATE(2561),
    [sym_preproc_line] = STATE(2561),
    [sym_preproc_pragma] = STATE(2561),
    [sym_preproc_nullable] = STATE(2561),
    [sym_preproc_error] = STATE(2561),
    [sym_preproc_define] = STATE(2561),
    [sym_preproc_undef] = STATE(2561),
    [ts_builtin_sym_end] = ACTIONS(3429),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3429),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_LBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_checked] = ACTIONS(3427),
    [anon_sym_BANG] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3427),
    [anon_sym_false] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_DASH] = ACTIONS(3427),
    [anon_sym_STAR] = ACTIONS(3429),
    [anon_sym_CARET] = ACTIONS(3429),
    [anon_sym_AMP] = ACTIONS(3429),
    [anon_sym_this] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_base] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_break] = ACTIONS(3427),
    [anon_sym_unchecked] = ACTIONS(3427),
    [anon_sym_continue] = ACTIONS(3427),
    [anon_sym_do] = ACTIONS(3427),
    [anon_sym_while] = ACTIONS(3427),
    [anon_sym_for] = ACTIONS(3427),
    [anon_sym_lock] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_switch] = ACTIONS(3427),
    [anon_sym_default] = ACTIONS(3427),
    [anon_sym_throw] = ACTIONS(3427),
    [anon_sym_try] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_await] = ACTIONS(3427),
    [anon_sym_foreach] = ACTIONS(3427),
    [anon_sym_goto] = ACTIONS(3427),
    [anon_sym_if] = ACTIONS(3427),
    [anon_sym_DOT_DOT] = ACTIONS(3429),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3429),
    [anon_sym_stackalloc] = ACTIONS(3427),
    [anon_sym_sizeof] = ACTIONS(3427),
    [anon_sym_typeof] = ACTIONS(3427),
    [anon_sym___makeref] = ACTIONS(3427),
    [anon_sym___reftype] = ACTIONS(3427),
    [anon_sym___refvalue] = ACTIONS(3427),
    [sym_null_literal] = ACTIONS(3427),
    [anon_sym_SQUOTE] = ACTIONS(3429),
    [sym_integer_literal] = ACTIONS(3427),
    [sym_real_literal] = ACTIONS(3429),
    [sym_verbatim_string_literal] = ACTIONS(3429),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3429),
    [sym_interpolation_verbatim_start] = ACTIONS(3429),
    [sym_interpolation_raw_start] = ACTIONS(3429),
    [sym_raw_string_start] = ACTIONS(3429),
  },
  [2562] = {
    [sym_preproc_region] = STATE(2562),
    [sym_preproc_endregion] = STATE(2562),
    [sym_preproc_line] = STATE(2562),
    [sym_preproc_pragma] = STATE(2562),
    [sym_preproc_nullable] = STATE(2562),
    [sym_preproc_error] = STATE(2562),
    [sym_preproc_define] = STATE(2562),
    [sym_preproc_undef] = STATE(2562),
    [ts_builtin_sym_end] = ACTIONS(3809),
    [sym__identifier_token] = ACTIONS(3807),
    [anon_sym_extern] = ACTIONS(3807),
    [anon_sym_alias] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3809),
    [anon_sym_global] = ACTIONS(3807),
    [anon_sym_using] = ACTIONS(3807),
    [anon_sym_unsafe] = ACTIONS(3807),
    [anon_sym_static] = ACTIONS(3807),
    [anon_sym_LBRACK] = ACTIONS(3809),
    [anon_sym_LPAREN] = ACTIONS(3809),
    [anon_sym_return] = ACTIONS(3807),
    [anon_sym_namespace] = ACTIONS(3807),
    [anon_sym_class] = ACTIONS(3807),
    [anon_sym_ref] = ACTIONS(3807),
    [anon_sym_struct] = ACTIONS(3807),
    [anon_sym_enum] = ACTIONS(3807),
    [anon_sym_LBRACE] = ACTIONS(3809),
    [anon_sym_interface] = ACTIONS(3807),
    [anon_sym_delegate] = ACTIONS(3807),
    [anon_sym_record] = ACTIONS(3807),
    [anon_sym_abstract] = ACTIONS(3807),
    [anon_sym_async] = ACTIONS(3807),
    [anon_sym_const] = ACTIONS(3807),
    [anon_sym_file] = ACTIONS(3807),
    [anon_sym_fixed] = ACTIONS(3807),
    [anon_sym_internal] = ACTIONS(3807),
    [anon_sym_new] = ACTIONS(3807),
    [anon_sym_override] = ACTIONS(3807),
    [anon_sym_partial] = ACTIONS(3807),
    [anon_sym_private] = ACTIONS(3807),
    [anon_sym_protected] = ACTIONS(3807),
    [anon_sym_public] = ACTIONS(3807),
    [anon_sym_readonly] = ACTIONS(3807),
    [anon_sym_required] = ACTIONS(3807),
    [anon_sym_sealed] = ACTIONS(3807),
    [anon_sym_virtual] = ACTIONS(3807),
    [anon_sym_volatile] = ACTIONS(3807),
    [anon_sym_where] = ACTIONS(3807),
    [anon_sym_notnull] = ACTIONS(3807),
    [anon_sym_unmanaged] = ACTIONS(3807),
    [anon_sym_checked] = ACTIONS(3807),
    [anon_sym_BANG] = ACTIONS(3809),
    [anon_sym_TILDE] = ACTIONS(3809),
    [anon_sym_PLUS_PLUS] = ACTIONS(3809),
    [anon_sym_DASH_DASH] = ACTIONS(3809),
    [anon_sym_true] = ACTIONS(3807),
    [anon_sym_false] = ACTIONS(3807),
    [anon_sym_PLUS] = ACTIONS(3807),
    [anon_sym_DASH] = ACTIONS(3807),
    [anon_sym_STAR] = ACTIONS(3809),
    [anon_sym_CARET] = ACTIONS(3809),
    [anon_sym_AMP] = ACTIONS(3809),
    [anon_sym_this] = ACTIONS(3807),
    [anon_sym_scoped] = ACTIONS(3807),
    [anon_sym_base] = ACTIONS(3807),
    [anon_sym_var] = ACTIONS(3807),
    [sym_predefined_type] = ACTIONS(3807),
    [anon_sym_break] = ACTIONS(3807),
    [anon_sym_unchecked] = ACTIONS(3807),
    [anon_sym_continue] = ACTIONS(3807),
    [anon_sym_do] = ACTIONS(3807),
    [anon_sym_while] = ACTIONS(3807),
    [anon_sym_for] = ACTIONS(3807),
    [anon_sym_lock] = ACTIONS(3807),
    [anon_sym_yield] = ACTIONS(3807),
    [anon_sym_switch] = ACTIONS(3807),
    [anon_sym_default] = ACTIONS(3807),
    [anon_sym_throw] = ACTIONS(3807),
    [anon_sym_try] = ACTIONS(3807),
    [anon_sym_when] = ACTIONS(3807),
    [anon_sym_await] = ACTIONS(3807),
    [anon_sym_foreach] = ACTIONS(3807),
    [anon_sym_goto] = ACTIONS(3807),
    [anon_sym_if] = ACTIONS(3807),
    [anon_sym_DOT_DOT] = ACTIONS(3809),
    [anon_sym_from] = ACTIONS(3807),
    [anon_sym_into] = ACTIONS(3807),
    [anon_sym_join] = ACTIONS(3807),
    [anon_sym_on] = ACTIONS(3807),
    [anon_sym_equals] = ACTIONS(3807),
    [anon_sym_let] = ACTIONS(3807),
    [anon_sym_orderby] = ACTIONS(3807),
    [anon_sym_ascending] = ACTIONS(3807),
    [anon_sym_descending] = ACTIONS(3807),
    [anon_sym_group] = ACTIONS(3807),
    [anon_sym_by] = ACTIONS(3807),
    [anon_sym_select] = ACTIONS(3807),
    [anon_sym_DQUOTE] = ACTIONS(3809),
    [anon_sym_stackalloc] = ACTIONS(3807),
    [anon_sym_sizeof] = ACTIONS(3807),
    [anon_sym_typeof] = ACTIONS(3807),
    [anon_sym___makeref] = ACTIONS(3807),
    [anon_sym___reftype] = ACTIONS(3807),
    [anon_sym___refvalue] = ACTIONS(3807),
    [sym_null_literal] = ACTIONS(3807),
    [anon_sym_SQUOTE] = ACTIONS(3809),
    [sym_integer_literal] = ACTIONS(3807),
    [sym_real_literal] = ACTIONS(3809),
    [sym_verbatim_string_literal] = ACTIONS(3809),
    [aux_sym_preproc_if_token1] = ACTIONS(3809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3809),
    [sym_interpolation_verbatim_start] = ACTIONS(3809),
    [sym_interpolation_raw_start] = ACTIONS(3809),
    [sym_raw_string_start] = ACTIONS(3809),
  },
  [2563] = {
    [sym_preproc_region] = STATE(2563),
    [sym_preproc_endregion] = STATE(2563),
    [sym_preproc_line] = STATE(2563),
    [sym_preproc_pragma] = STATE(2563),
    [sym_preproc_nullable] = STATE(2563),
    [sym_preproc_error] = STATE(2563),
    [sym_preproc_define] = STATE(2563),
    [sym_preproc_undef] = STATE(2563),
    [ts_builtin_sym_end] = ACTIONS(3617),
    [sym__identifier_token] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_SEMI] = ACTIONS(3617),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_unsafe] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_return] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_ref] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_delegate] = ACTIONS(3615),
    [anon_sym_record] = ACTIONS(3615),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_async] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_fixed] = ACTIONS(3615),
    [anon_sym_internal] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_override] = ACTIONS(3615),
    [anon_sym_partial] = ACTIONS(3615),
    [anon_sym_private] = ACTIONS(3615),
    [anon_sym_protected] = ACTIONS(3615),
    [anon_sym_public] = ACTIONS(3615),
    [anon_sym_readonly] = ACTIONS(3615),
    [anon_sym_required] = ACTIONS(3615),
    [anon_sym_sealed] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_checked] = ACTIONS(3615),
    [anon_sym_BANG] = ACTIONS(3617),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_PLUS_PLUS] = ACTIONS(3617),
    [anon_sym_DASH_DASH] = ACTIONS(3617),
    [anon_sym_true] = ACTIONS(3615),
    [anon_sym_false] = ACTIONS(3615),
    [anon_sym_PLUS] = ACTIONS(3615),
    [anon_sym_DASH] = ACTIONS(3615),
    [anon_sym_STAR] = ACTIONS(3617),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_AMP] = ACTIONS(3617),
    [anon_sym_this] = ACTIONS(3615),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_base] = ACTIONS(3615),
    [anon_sym_var] = ACTIONS(3615),
    [sym_predefined_type] = ACTIONS(3615),
    [anon_sym_break] = ACTIONS(3615),
    [anon_sym_unchecked] = ACTIONS(3615),
    [anon_sym_continue] = ACTIONS(3615),
    [anon_sym_do] = ACTIONS(3615),
    [anon_sym_while] = ACTIONS(3615),
    [anon_sym_for] = ACTIONS(3615),
    [anon_sym_lock] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_switch] = ACTIONS(3615),
    [anon_sym_default] = ACTIONS(3615),
    [anon_sym_throw] = ACTIONS(3615),
    [anon_sym_try] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_await] = ACTIONS(3615),
    [anon_sym_foreach] = ACTIONS(3615),
    [anon_sym_goto] = ACTIONS(3615),
    [anon_sym_if] = ACTIONS(3615),
    [anon_sym_DOT_DOT] = ACTIONS(3617),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [anon_sym_stackalloc] = ACTIONS(3615),
    [anon_sym_sizeof] = ACTIONS(3615),
    [anon_sym_typeof] = ACTIONS(3615),
    [anon_sym___makeref] = ACTIONS(3615),
    [anon_sym___reftype] = ACTIONS(3615),
    [anon_sym___refvalue] = ACTIONS(3615),
    [sym_null_literal] = ACTIONS(3615),
    [anon_sym_SQUOTE] = ACTIONS(3617),
    [sym_integer_literal] = ACTIONS(3615),
    [sym_real_literal] = ACTIONS(3617),
    [sym_verbatim_string_literal] = ACTIONS(3617),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3617),
    [sym_interpolation_verbatim_start] = ACTIONS(3617),
    [sym_interpolation_raw_start] = ACTIONS(3617),
    [sym_raw_string_start] = ACTIONS(3617),
  },
  [2564] = {
    [sym_preproc_region] = STATE(2564),
    [sym_preproc_endregion] = STATE(2564),
    [sym_preproc_line] = STATE(2564),
    [sym_preproc_pragma] = STATE(2564),
    [sym_preproc_nullable] = STATE(2564),
    [sym_preproc_error] = STATE(2564),
    [sym_preproc_define] = STATE(2564),
    [sym_preproc_undef] = STATE(2564),
    [ts_builtin_sym_end] = ACTIONS(3817),
    [sym__identifier_token] = ACTIONS(3815),
    [anon_sym_extern] = ACTIONS(3815),
    [anon_sym_alias] = ACTIONS(3815),
    [anon_sym_SEMI] = ACTIONS(3817),
    [anon_sym_global] = ACTIONS(3815),
    [anon_sym_using] = ACTIONS(3815),
    [anon_sym_unsafe] = ACTIONS(3815),
    [anon_sym_static] = ACTIONS(3815),
    [anon_sym_LBRACK] = ACTIONS(3817),
    [anon_sym_LPAREN] = ACTIONS(3817),
    [anon_sym_return] = ACTIONS(3815),
    [anon_sym_namespace] = ACTIONS(3815),
    [anon_sym_class] = ACTIONS(3815),
    [anon_sym_ref] = ACTIONS(3815),
    [anon_sym_struct] = ACTIONS(3815),
    [anon_sym_enum] = ACTIONS(3815),
    [anon_sym_LBRACE] = ACTIONS(3817),
    [anon_sym_interface] = ACTIONS(3815),
    [anon_sym_delegate] = ACTIONS(3815),
    [anon_sym_record] = ACTIONS(3815),
    [anon_sym_abstract] = ACTIONS(3815),
    [anon_sym_async] = ACTIONS(3815),
    [anon_sym_const] = ACTIONS(3815),
    [anon_sym_file] = ACTIONS(3815),
    [anon_sym_fixed] = ACTIONS(3815),
    [anon_sym_internal] = ACTIONS(3815),
    [anon_sym_new] = ACTIONS(3815),
    [anon_sym_override] = ACTIONS(3815),
    [anon_sym_partial] = ACTIONS(3815),
    [anon_sym_private] = ACTIONS(3815),
    [anon_sym_protected] = ACTIONS(3815),
    [anon_sym_public] = ACTIONS(3815),
    [anon_sym_readonly] = ACTIONS(3815),
    [anon_sym_required] = ACTIONS(3815),
    [anon_sym_sealed] = ACTIONS(3815),
    [anon_sym_virtual] = ACTIONS(3815),
    [anon_sym_volatile] = ACTIONS(3815),
    [anon_sym_where] = ACTIONS(3815),
    [anon_sym_notnull] = ACTIONS(3815),
    [anon_sym_unmanaged] = ACTIONS(3815),
    [anon_sym_checked] = ACTIONS(3815),
    [anon_sym_BANG] = ACTIONS(3817),
    [anon_sym_TILDE] = ACTIONS(3817),
    [anon_sym_PLUS_PLUS] = ACTIONS(3817),
    [anon_sym_DASH_DASH] = ACTIONS(3817),
    [anon_sym_true] = ACTIONS(3815),
    [anon_sym_false] = ACTIONS(3815),
    [anon_sym_PLUS] = ACTIONS(3815),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_STAR] = ACTIONS(3817),
    [anon_sym_CARET] = ACTIONS(3817),
    [anon_sym_AMP] = ACTIONS(3817),
    [anon_sym_this] = ACTIONS(3815),
    [anon_sym_scoped] = ACTIONS(3815),
    [anon_sym_base] = ACTIONS(3815),
    [anon_sym_var] = ACTIONS(3815),
    [sym_predefined_type] = ACTIONS(3815),
    [anon_sym_break] = ACTIONS(3815),
    [anon_sym_unchecked] = ACTIONS(3815),
    [anon_sym_continue] = ACTIONS(3815),
    [anon_sym_do] = ACTIONS(3815),
    [anon_sym_while] = ACTIONS(3815),
    [anon_sym_for] = ACTIONS(3815),
    [anon_sym_lock] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(3815),
    [anon_sym_switch] = ACTIONS(3815),
    [anon_sym_default] = ACTIONS(3815),
    [anon_sym_throw] = ACTIONS(3815),
    [anon_sym_try] = ACTIONS(3815),
    [anon_sym_when] = ACTIONS(3815),
    [anon_sym_await] = ACTIONS(3815),
    [anon_sym_foreach] = ACTIONS(3815),
    [anon_sym_goto] = ACTIONS(3815),
    [anon_sym_if] = ACTIONS(3815),
    [anon_sym_DOT_DOT] = ACTIONS(3817),
    [anon_sym_from] = ACTIONS(3815),
    [anon_sym_into] = ACTIONS(3815),
    [anon_sym_join] = ACTIONS(3815),
    [anon_sym_on] = ACTIONS(3815),
    [anon_sym_equals] = ACTIONS(3815),
    [anon_sym_let] = ACTIONS(3815),
    [anon_sym_orderby] = ACTIONS(3815),
    [anon_sym_ascending] = ACTIONS(3815),
    [anon_sym_descending] = ACTIONS(3815),
    [anon_sym_group] = ACTIONS(3815),
    [anon_sym_by] = ACTIONS(3815),
    [anon_sym_select] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(3817),
    [anon_sym_stackalloc] = ACTIONS(3815),
    [anon_sym_sizeof] = ACTIONS(3815),
    [anon_sym_typeof] = ACTIONS(3815),
    [anon_sym___makeref] = ACTIONS(3815),
    [anon_sym___reftype] = ACTIONS(3815),
    [anon_sym___refvalue] = ACTIONS(3815),
    [sym_null_literal] = ACTIONS(3815),
    [anon_sym_SQUOTE] = ACTIONS(3817),
    [sym_integer_literal] = ACTIONS(3815),
    [sym_real_literal] = ACTIONS(3817),
    [sym_verbatim_string_literal] = ACTIONS(3817),
    [aux_sym_preproc_if_token1] = ACTIONS(3817),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3817),
    [sym_interpolation_verbatim_start] = ACTIONS(3817),
    [sym_interpolation_raw_start] = ACTIONS(3817),
    [sym_raw_string_start] = ACTIONS(3817),
  },
  [2565] = {
    [sym_preproc_region] = STATE(2565),
    [sym_preproc_endregion] = STATE(2565),
    [sym_preproc_line] = STATE(2565),
    [sym_preproc_pragma] = STATE(2565),
    [sym_preproc_nullable] = STATE(2565),
    [sym_preproc_error] = STATE(2565),
    [sym_preproc_define] = STATE(2565),
    [sym_preproc_undef] = STATE(2565),
    [ts_builtin_sym_end] = ACTIONS(3821),
    [sym__identifier_token] = ACTIONS(3819),
    [anon_sym_extern] = ACTIONS(3819),
    [anon_sym_alias] = ACTIONS(3819),
    [anon_sym_SEMI] = ACTIONS(3821),
    [anon_sym_global] = ACTIONS(3819),
    [anon_sym_using] = ACTIONS(3819),
    [anon_sym_unsafe] = ACTIONS(3819),
    [anon_sym_static] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(3821),
    [anon_sym_LPAREN] = ACTIONS(3821),
    [anon_sym_return] = ACTIONS(3819),
    [anon_sym_namespace] = ACTIONS(3819),
    [anon_sym_class] = ACTIONS(3819),
    [anon_sym_ref] = ACTIONS(3819),
    [anon_sym_struct] = ACTIONS(3819),
    [anon_sym_enum] = ACTIONS(3819),
    [anon_sym_LBRACE] = ACTIONS(3821),
    [anon_sym_interface] = ACTIONS(3819),
    [anon_sym_delegate] = ACTIONS(3819),
    [anon_sym_record] = ACTIONS(3819),
    [anon_sym_abstract] = ACTIONS(3819),
    [anon_sym_async] = ACTIONS(3819),
    [anon_sym_const] = ACTIONS(3819),
    [anon_sym_file] = ACTIONS(3819),
    [anon_sym_fixed] = ACTIONS(3819),
    [anon_sym_internal] = ACTIONS(3819),
    [anon_sym_new] = ACTIONS(3819),
    [anon_sym_override] = ACTIONS(3819),
    [anon_sym_partial] = ACTIONS(3819),
    [anon_sym_private] = ACTIONS(3819),
    [anon_sym_protected] = ACTIONS(3819),
    [anon_sym_public] = ACTIONS(3819),
    [anon_sym_readonly] = ACTIONS(3819),
    [anon_sym_required] = ACTIONS(3819),
    [anon_sym_sealed] = ACTIONS(3819),
    [anon_sym_virtual] = ACTIONS(3819),
    [anon_sym_volatile] = ACTIONS(3819),
    [anon_sym_where] = ACTIONS(3819),
    [anon_sym_notnull] = ACTIONS(3819),
    [anon_sym_unmanaged] = ACTIONS(3819),
    [anon_sym_checked] = ACTIONS(3819),
    [anon_sym_BANG] = ACTIONS(3821),
    [anon_sym_TILDE] = ACTIONS(3821),
    [anon_sym_PLUS_PLUS] = ACTIONS(3821),
    [anon_sym_DASH_DASH] = ACTIONS(3821),
    [anon_sym_true] = ACTIONS(3819),
    [anon_sym_false] = ACTIONS(3819),
    [anon_sym_PLUS] = ACTIONS(3819),
    [anon_sym_DASH] = ACTIONS(3819),
    [anon_sym_STAR] = ACTIONS(3821),
    [anon_sym_CARET] = ACTIONS(3821),
    [anon_sym_AMP] = ACTIONS(3821),
    [anon_sym_this] = ACTIONS(3819),
    [anon_sym_scoped] = ACTIONS(3819),
    [anon_sym_base] = ACTIONS(3819),
    [anon_sym_var] = ACTIONS(3819),
    [sym_predefined_type] = ACTIONS(3819),
    [anon_sym_break] = ACTIONS(3819),
    [anon_sym_unchecked] = ACTIONS(3819),
    [anon_sym_continue] = ACTIONS(3819),
    [anon_sym_do] = ACTIONS(3819),
    [anon_sym_while] = ACTIONS(3819),
    [anon_sym_for] = ACTIONS(3819),
    [anon_sym_lock] = ACTIONS(3819),
    [anon_sym_yield] = ACTIONS(3819),
    [anon_sym_switch] = ACTIONS(3819),
    [anon_sym_default] = ACTIONS(3819),
    [anon_sym_throw] = ACTIONS(3819),
    [anon_sym_try] = ACTIONS(3819),
    [anon_sym_when] = ACTIONS(3819),
    [anon_sym_await] = ACTIONS(3819),
    [anon_sym_foreach] = ACTIONS(3819),
    [anon_sym_goto] = ACTIONS(3819),
    [anon_sym_if] = ACTIONS(3819),
    [anon_sym_DOT_DOT] = ACTIONS(3821),
    [anon_sym_from] = ACTIONS(3819),
    [anon_sym_into] = ACTIONS(3819),
    [anon_sym_join] = ACTIONS(3819),
    [anon_sym_on] = ACTIONS(3819),
    [anon_sym_equals] = ACTIONS(3819),
    [anon_sym_let] = ACTIONS(3819),
    [anon_sym_orderby] = ACTIONS(3819),
    [anon_sym_ascending] = ACTIONS(3819),
    [anon_sym_descending] = ACTIONS(3819),
    [anon_sym_group] = ACTIONS(3819),
    [anon_sym_by] = ACTIONS(3819),
    [anon_sym_select] = ACTIONS(3819),
    [anon_sym_DQUOTE] = ACTIONS(3821),
    [anon_sym_stackalloc] = ACTIONS(3819),
    [anon_sym_sizeof] = ACTIONS(3819),
    [anon_sym_typeof] = ACTIONS(3819),
    [anon_sym___makeref] = ACTIONS(3819),
    [anon_sym___reftype] = ACTIONS(3819),
    [anon_sym___refvalue] = ACTIONS(3819),
    [sym_null_literal] = ACTIONS(3819),
    [anon_sym_SQUOTE] = ACTIONS(3821),
    [sym_integer_literal] = ACTIONS(3819),
    [sym_real_literal] = ACTIONS(3821),
    [sym_verbatim_string_literal] = ACTIONS(3821),
    [aux_sym_preproc_if_token1] = ACTIONS(3821),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3821),
    [sym_interpolation_verbatim_start] = ACTIONS(3821),
    [sym_interpolation_raw_start] = ACTIONS(3821),
    [sym_raw_string_start] = ACTIONS(3821),
  },
  [2566] = {
    [sym_preproc_region] = STATE(2566),
    [sym_preproc_endregion] = STATE(2566),
    [sym_preproc_line] = STATE(2566),
    [sym_preproc_pragma] = STATE(2566),
    [sym_preproc_nullable] = STATE(2566),
    [sym_preproc_error] = STATE(2566),
    [sym_preproc_define] = STATE(2566),
    [sym_preproc_undef] = STATE(2566),
    [ts_builtin_sym_end] = ACTIONS(3837),
    [sym__identifier_token] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(3835),
    [anon_sym_alias] = ACTIONS(3835),
    [anon_sym_SEMI] = ACTIONS(3837),
    [anon_sym_global] = ACTIONS(3835),
    [anon_sym_using] = ACTIONS(3835),
    [anon_sym_unsafe] = ACTIONS(3835),
    [anon_sym_static] = ACTIONS(3835),
    [anon_sym_LBRACK] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3837),
    [anon_sym_return] = ACTIONS(3835),
    [anon_sym_namespace] = ACTIONS(3835),
    [anon_sym_class] = ACTIONS(3835),
    [anon_sym_ref] = ACTIONS(3835),
    [anon_sym_struct] = ACTIONS(3835),
    [anon_sym_enum] = ACTIONS(3835),
    [anon_sym_LBRACE] = ACTIONS(3837),
    [anon_sym_interface] = ACTIONS(3835),
    [anon_sym_delegate] = ACTIONS(3835),
    [anon_sym_record] = ACTIONS(3835),
    [anon_sym_abstract] = ACTIONS(3835),
    [anon_sym_async] = ACTIONS(3835),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_file] = ACTIONS(3835),
    [anon_sym_fixed] = ACTIONS(3835),
    [anon_sym_internal] = ACTIONS(3835),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_override] = ACTIONS(3835),
    [anon_sym_partial] = ACTIONS(3835),
    [anon_sym_private] = ACTIONS(3835),
    [anon_sym_protected] = ACTIONS(3835),
    [anon_sym_public] = ACTIONS(3835),
    [anon_sym_readonly] = ACTIONS(3835),
    [anon_sym_required] = ACTIONS(3835),
    [anon_sym_sealed] = ACTIONS(3835),
    [anon_sym_virtual] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_where] = ACTIONS(3835),
    [anon_sym_notnull] = ACTIONS(3835),
    [anon_sym_unmanaged] = ACTIONS(3835),
    [anon_sym_checked] = ACTIONS(3835),
    [anon_sym_BANG] = ACTIONS(3837),
    [anon_sym_TILDE] = ACTIONS(3837),
    [anon_sym_PLUS_PLUS] = ACTIONS(3837),
    [anon_sym_DASH_DASH] = ACTIONS(3837),
    [anon_sym_true] = ACTIONS(3835),
    [anon_sym_false] = ACTIONS(3835),
    [anon_sym_PLUS] = ACTIONS(3835),
    [anon_sym_DASH] = ACTIONS(3835),
    [anon_sym_STAR] = ACTIONS(3837),
    [anon_sym_CARET] = ACTIONS(3837),
    [anon_sym_AMP] = ACTIONS(3837),
    [anon_sym_this] = ACTIONS(3835),
    [anon_sym_scoped] = ACTIONS(3835),
    [anon_sym_base] = ACTIONS(3835),
    [anon_sym_var] = ACTIONS(3835),
    [sym_predefined_type] = ACTIONS(3835),
    [anon_sym_break] = ACTIONS(3835),
    [anon_sym_unchecked] = ACTIONS(3835),
    [anon_sym_continue] = ACTIONS(3835),
    [anon_sym_do] = ACTIONS(3835),
    [anon_sym_while] = ACTIONS(3835),
    [anon_sym_for] = ACTIONS(3835),
    [anon_sym_lock] = ACTIONS(3835),
    [anon_sym_yield] = ACTIONS(3835),
    [anon_sym_switch] = ACTIONS(3835),
    [anon_sym_default] = ACTIONS(3835),
    [anon_sym_throw] = ACTIONS(3835),
    [anon_sym_try] = ACTIONS(3835),
    [anon_sym_when] = ACTIONS(3835),
    [anon_sym_await] = ACTIONS(3835),
    [anon_sym_foreach] = ACTIONS(3835),
    [anon_sym_goto] = ACTIONS(3835),
    [anon_sym_if] = ACTIONS(3835),
    [anon_sym_DOT_DOT] = ACTIONS(3837),
    [anon_sym_from] = ACTIONS(3835),
    [anon_sym_into] = ACTIONS(3835),
    [anon_sym_join] = ACTIONS(3835),
    [anon_sym_on] = ACTIONS(3835),
    [anon_sym_equals] = ACTIONS(3835),
    [anon_sym_let] = ACTIONS(3835),
    [anon_sym_orderby] = ACTIONS(3835),
    [anon_sym_ascending] = ACTIONS(3835),
    [anon_sym_descending] = ACTIONS(3835),
    [anon_sym_group] = ACTIONS(3835),
    [anon_sym_by] = ACTIONS(3835),
    [anon_sym_select] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(3837),
    [anon_sym_stackalloc] = ACTIONS(3835),
    [anon_sym_sizeof] = ACTIONS(3835),
    [anon_sym_typeof] = ACTIONS(3835),
    [anon_sym___makeref] = ACTIONS(3835),
    [anon_sym___reftype] = ACTIONS(3835),
    [anon_sym___refvalue] = ACTIONS(3835),
    [sym_null_literal] = ACTIONS(3835),
    [anon_sym_SQUOTE] = ACTIONS(3837),
    [sym_integer_literal] = ACTIONS(3835),
    [sym_real_literal] = ACTIONS(3837),
    [sym_verbatim_string_literal] = ACTIONS(3837),
    [aux_sym_preproc_if_token1] = ACTIONS(3837),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3837),
    [sym_interpolation_verbatim_start] = ACTIONS(3837),
    [sym_interpolation_raw_start] = ACTIONS(3837),
    [sym_raw_string_start] = ACTIONS(3837),
  },
  [2567] = {
    [sym_preproc_region] = STATE(2567),
    [sym_preproc_endregion] = STATE(2567),
    [sym_preproc_line] = STATE(2567),
    [sym_preproc_pragma] = STATE(2567),
    [sym_preproc_nullable] = STATE(2567),
    [sym_preproc_error] = STATE(2567),
    [sym_preproc_define] = STATE(2567),
    [sym_preproc_undef] = STATE(2567),
    [ts_builtin_sym_end] = ACTIONS(3425),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3425),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_return] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_checked] = ACTIONS(3423),
    [anon_sym_BANG] = ACTIONS(3425),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_PLUS_PLUS] = ACTIONS(3425),
    [anon_sym_DASH_DASH] = ACTIONS(3425),
    [anon_sym_true] = ACTIONS(3423),
    [anon_sym_false] = ACTIONS(3423),
    [anon_sym_PLUS] = ACTIONS(3423),
    [anon_sym_DASH] = ACTIONS(3423),
    [anon_sym_STAR] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_this] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_base] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_break] = ACTIONS(3423),
    [anon_sym_unchecked] = ACTIONS(3423),
    [anon_sym_continue] = ACTIONS(3423),
    [anon_sym_do] = ACTIONS(3423),
    [anon_sym_while] = ACTIONS(3423),
    [anon_sym_for] = ACTIONS(3423),
    [anon_sym_lock] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_switch] = ACTIONS(3423),
    [anon_sym_default] = ACTIONS(3423),
    [anon_sym_throw] = ACTIONS(3423),
    [anon_sym_try] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_await] = ACTIONS(3423),
    [anon_sym_foreach] = ACTIONS(3423),
    [anon_sym_goto] = ACTIONS(3423),
    [anon_sym_if] = ACTIONS(3423),
    [anon_sym_DOT_DOT] = ACTIONS(3425),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [anon_sym_stackalloc] = ACTIONS(3423),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym_typeof] = ACTIONS(3423),
    [anon_sym___makeref] = ACTIONS(3423),
    [anon_sym___reftype] = ACTIONS(3423),
    [anon_sym___refvalue] = ACTIONS(3423),
    [sym_null_literal] = ACTIONS(3423),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [sym_integer_literal] = ACTIONS(3423),
    [sym_real_literal] = ACTIONS(3425),
    [sym_verbatim_string_literal] = ACTIONS(3425),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3425),
    [sym_interpolation_verbatim_start] = ACTIONS(3425),
    [sym_interpolation_raw_start] = ACTIONS(3425),
    [sym_raw_string_start] = ACTIONS(3425),
  },
  [2568] = {
    [sym_preproc_region] = STATE(2568),
    [sym_preproc_endregion] = STATE(2568),
    [sym_preproc_line] = STATE(2568),
    [sym_preproc_pragma] = STATE(2568),
    [sym_preproc_nullable] = STATE(2568),
    [sym_preproc_error] = STATE(2568),
    [sym_preproc_define] = STATE(2568),
    [sym_preproc_undef] = STATE(2568),
    [ts_builtin_sym_end] = ACTIONS(3857),
    [sym__identifier_token] = ACTIONS(3855),
    [anon_sym_extern] = ACTIONS(3855),
    [anon_sym_alias] = ACTIONS(3855),
    [anon_sym_SEMI] = ACTIONS(3857),
    [anon_sym_global] = ACTIONS(3855),
    [anon_sym_using] = ACTIONS(3855),
    [anon_sym_unsafe] = ACTIONS(3855),
    [anon_sym_static] = ACTIONS(3855),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_LPAREN] = ACTIONS(3857),
    [anon_sym_return] = ACTIONS(3855),
    [anon_sym_namespace] = ACTIONS(3855),
    [anon_sym_class] = ACTIONS(3855),
    [anon_sym_ref] = ACTIONS(3855),
    [anon_sym_struct] = ACTIONS(3855),
    [anon_sym_enum] = ACTIONS(3855),
    [anon_sym_LBRACE] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3855),
    [anon_sym_delegate] = ACTIONS(3855),
    [anon_sym_record] = ACTIONS(3855),
    [anon_sym_abstract] = ACTIONS(3855),
    [anon_sym_async] = ACTIONS(3855),
    [anon_sym_const] = ACTIONS(3855),
    [anon_sym_file] = ACTIONS(3855),
    [anon_sym_fixed] = ACTIONS(3855),
    [anon_sym_internal] = ACTIONS(3855),
    [anon_sym_new] = ACTIONS(3855),
    [anon_sym_override] = ACTIONS(3855),
    [anon_sym_partial] = ACTIONS(3855),
    [anon_sym_private] = ACTIONS(3855),
    [anon_sym_protected] = ACTIONS(3855),
    [anon_sym_public] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3855),
    [anon_sym_required] = ACTIONS(3855),
    [anon_sym_sealed] = ACTIONS(3855),
    [anon_sym_virtual] = ACTIONS(3855),
    [anon_sym_volatile] = ACTIONS(3855),
    [anon_sym_where] = ACTIONS(3855),
    [anon_sym_notnull] = ACTIONS(3855),
    [anon_sym_unmanaged] = ACTIONS(3855),
    [anon_sym_checked] = ACTIONS(3855),
    [anon_sym_BANG] = ACTIONS(3857),
    [anon_sym_TILDE] = ACTIONS(3857),
    [anon_sym_PLUS_PLUS] = ACTIONS(3857),
    [anon_sym_DASH_DASH] = ACTIONS(3857),
    [anon_sym_true] = ACTIONS(3855),
    [anon_sym_false] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_STAR] = ACTIONS(3857),
    [anon_sym_CARET] = ACTIONS(3857),
    [anon_sym_AMP] = ACTIONS(3857),
    [anon_sym_this] = ACTIONS(3855),
    [anon_sym_scoped] = ACTIONS(3855),
    [anon_sym_base] = ACTIONS(3855),
    [anon_sym_var] = ACTIONS(3855),
    [sym_predefined_type] = ACTIONS(3855),
    [anon_sym_break] = ACTIONS(3855),
    [anon_sym_unchecked] = ACTIONS(3855),
    [anon_sym_continue] = ACTIONS(3855),
    [anon_sym_do] = ACTIONS(3855),
    [anon_sym_while] = ACTIONS(3855),
    [anon_sym_for] = ACTIONS(3855),
    [anon_sym_lock] = ACTIONS(3855),
    [anon_sym_yield] = ACTIONS(3855),
    [anon_sym_switch] = ACTIONS(3855),
    [anon_sym_default] = ACTIONS(3855),
    [anon_sym_throw] = ACTIONS(3855),
    [anon_sym_try] = ACTIONS(3855),
    [anon_sym_when] = ACTIONS(3855),
    [anon_sym_await] = ACTIONS(3855),
    [anon_sym_foreach] = ACTIONS(3855),
    [anon_sym_goto] = ACTIONS(3855),
    [anon_sym_if] = ACTIONS(3855),
    [anon_sym_DOT_DOT] = ACTIONS(3857),
    [anon_sym_from] = ACTIONS(3855),
    [anon_sym_into] = ACTIONS(3855),
    [anon_sym_join] = ACTIONS(3855),
    [anon_sym_on] = ACTIONS(3855),
    [anon_sym_equals] = ACTIONS(3855),
    [anon_sym_let] = ACTIONS(3855),
    [anon_sym_orderby] = ACTIONS(3855),
    [anon_sym_ascending] = ACTIONS(3855),
    [anon_sym_descending] = ACTIONS(3855),
    [anon_sym_group] = ACTIONS(3855),
    [anon_sym_by] = ACTIONS(3855),
    [anon_sym_select] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3857),
    [anon_sym_stackalloc] = ACTIONS(3855),
    [anon_sym_sizeof] = ACTIONS(3855),
    [anon_sym_typeof] = ACTIONS(3855),
    [anon_sym___makeref] = ACTIONS(3855),
    [anon_sym___reftype] = ACTIONS(3855),
    [anon_sym___refvalue] = ACTIONS(3855),
    [sym_null_literal] = ACTIONS(3855),
    [anon_sym_SQUOTE] = ACTIONS(3857),
    [sym_integer_literal] = ACTIONS(3855),
    [sym_real_literal] = ACTIONS(3857),
    [sym_verbatim_string_literal] = ACTIONS(3857),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3857),
    [sym_interpolation_verbatim_start] = ACTIONS(3857),
    [sym_interpolation_raw_start] = ACTIONS(3857),
    [sym_raw_string_start] = ACTIONS(3857),
  },
  [2569] = {
    [sym_preproc_region] = STATE(2569),
    [sym_preproc_endregion] = STATE(2569),
    [sym_preproc_line] = STATE(2569),
    [sym_preproc_pragma] = STATE(2569),
    [sym_preproc_nullable] = STATE(2569),
    [sym_preproc_error] = STATE(2569),
    [sym_preproc_define] = STATE(2569),
    [sym_preproc_undef] = STATE(2569),
    [ts_builtin_sym_end] = ACTIONS(3861),
    [sym__identifier_token] = ACTIONS(3859),
    [anon_sym_extern] = ACTIONS(3859),
    [anon_sym_alias] = ACTIONS(3859),
    [anon_sym_SEMI] = ACTIONS(3861),
    [anon_sym_global] = ACTIONS(3859),
    [anon_sym_using] = ACTIONS(3859),
    [anon_sym_unsafe] = ACTIONS(3859),
    [anon_sym_static] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3861),
    [anon_sym_return] = ACTIONS(3859),
    [anon_sym_namespace] = ACTIONS(3859),
    [anon_sym_class] = ACTIONS(3859),
    [anon_sym_ref] = ACTIONS(3859),
    [anon_sym_struct] = ACTIONS(3859),
    [anon_sym_enum] = ACTIONS(3859),
    [anon_sym_LBRACE] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3859),
    [anon_sym_delegate] = ACTIONS(3859),
    [anon_sym_record] = ACTIONS(3859),
    [anon_sym_abstract] = ACTIONS(3859),
    [anon_sym_async] = ACTIONS(3859),
    [anon_sym_const] = ACTIONS(3859),
    [anon_sym_file] = ACTIONS(3859),
    [anon_sym_fixed] = ACTIONS(3859),
    [anon_sym_internal] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_override] = ACTIONS(3859),
    [anon_sym_partial] = ACTIONS(3859),
    [anon_sym_private] = ACTIONS(3859),
    [anon_sym_protected] = ACTIONS(3859),
    [anon_sym_public] = ACTIONS(3859),
    [anon_sym_readonly] = ACTIONS(3859),
    [anon_sym_required] = ACTIONS(3859),
    [anon_sym_sealed] = ACTIONS(3859),
    [anon_sym_virtual] = ACTIONS(3859),
    [anon_sym_volatile] = ACTIONS(3859),
    [anon_sym_where] = ACTIONS(3859),
    [anon_sym_notnull] = ACTIONS(3859),
    [anon_sym_unmanaged] = ACTIONS(3859),
    [anon_sym_checked] = ACTIONS(3859),
    [anon_sym_BANG] = ACTIONS(3861),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_PLUS_PLUS] = ACTIONS(3861),
    [anon_sym_DASH_DASH] = ACTIONS(3861),
    [anon_sym_true] = ACTIONS(3859),
    [anon_sym_false] = ACTIONS(3859),
    [anon_sym_PLUS] = ACTIONS(3859),
    [anon_sym_DASH] = ACTIONS(3859),
    [anon_sym_STAR] = ACTIONS(3861),
    [anon_sym_CARET] = ACTIONS(3861),
    [anon_sym_AMP] = ACTIONS(3861),
    [anon_sym_this] = ACTIONS(3859),
    [anon_sym_scoped] = ACTIONS(3859),
    [anon_sym_base] = ACTIONS(3859),
    [anon_sym_var] = ACTIONS(3859),
    [sym_predefined_type] = ACTIONS(3859),
    [anon_sym_break] = ACTIONS(3859),
    [anon_sym_unchecked] = ACTIONS(3859),
    [anon_sym_continue] = ACTIONS(3859),
    [anon_sym_do] = ACTIONS(3859),
    [anon_sym_while] = ACTIONS(3859),
    [anon_sym_for] = ACTIONS(3859),
    [anon_sym_lock] = ACTIONS(3859),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_switch] = ACTIONS(3859),
    [anon_sym_default] = ACTIONS(3859),
    [anon_sym_throw] = ACTIONS(3859),
    [anon_sym_try] = ACTIONS(3859),
    [anon_sym_when] = ACTIONS(3859),
    [anon_sym_await] = ACTIONS(3859),
    [anon_sym_foreach] = ACTIONS(3859),
    [anon_sym_goto] = ACTIONS(3859),
    [anon_sym_if] = ACTIONS(3859),
    [anon_sym_DOT_DOT] = ACTIONS(3861),
    [anon_sym_from] = ACTIONS(3859),
    [anon_sym_into] = ACTIONS(3859),
    [anon_sym_join] = ACTIONS(3859),
    [anon_sym_on] = ACTIONS(3859),
    [anon_sym_equals] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_orderby] = ACTIONS(3859),
    [anon_sym_ascending] = ACTIONS(3859),
    [anon_sym_descending] = ACTIONS(3859),
    [anon_sym_group] = ACTIONS(3859),
    [anon_sym_by] = ACTIONS(3859),
    [anon_sym_select] = ACTIONS(3859),
    [anon_sym_DQUOTE] = ACTIONS(3861),
    [anon_sym_stackalloc] = ACTIONS(3859),
    [anon_sym_sizeof] = ACTIONS(3859),
    [anon_sym_typeof] = ACTIONS(3859),
    [anon_sym___makeref] = ACTIONS(3859),
    [anon_sym___reftype] = ACTIONS(3859),
    [anon_sym___refvalue] = ACTIONS(3859),
    [sym_null_literal] = ACTIONS(3859),
    [anon_sym_SQUOTE] = ACTIONS(3861),
    [sym_integer_literal] = ACTIONS(3859),
    [sym_real_literal] = ACTIONS(3861),
    [sym_verbatim_string_literal] = ACTIONS(3861),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3861),
    [sym_interpolation_verbatim_start] = ACTIONS(3861),
    [sym_interpolation_raw_start] = ACTIONS(3861),
    [sym_raw_string_start] = ACTIONS(3861),
  },
  [2570] = {
    [sym_preproc_region] = STATE(2570),
    [sym_preproc_endregion] = STATE(2570),
    [sym_preproc_line] = STATE(2570),
    [sym_preproc_pragma] = STATE(2570),
    [sym_preproc_nullable] = STATE(2570),
    [sym_preproc_error] = STATE(2570),
    [sym_preproc_define] = STATE(2570),
    [sym_preproc_undef] = STATE(2570),
    [ts_builtin_sym_end] = ACTIONS(3453),
    [sym__identifier_token] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym_alias] = ACTIONS(3451),
    [anon_sym_SEMI] = ACTIONS(3453),
    [anon_sym_global] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_unsafe] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_return] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_ref] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_LBRACE] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_delegate] = ACTIONS(3451),
    [anon_sym_record] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_file] = ACTIONS(3451),
    [anon_sym_fixed] = ACTIONS(3451),
    [anon_sym_internal] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_partial] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_required] = ACTIONS(3451),
    [anon_sym_sealed] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_where] = ACTIONS(3451),
    [anon_sym_notnull] = ACTIONS(3451),
    [anon_sym_unmanaged] = ACTIONS(3451),
    [anon_sym_checked] = ACTIONS(3451),
    [anon_sym_BANG] = ACTIONS(3453),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_PLUS_PLUS] = ACTIONS(3453),
    [anon_sym_DASH_DASH] = ACTIONS(3453),
    [anon_sym_true] = ACTIONS(3451),
    [anon_sym_false] = ACTIONS(3451),
    [anon_sym_PLUS] = ACTIONS(3451),
    [anon_sym_DASH] = ACTIONS(3451),
    [anon_sym_STAR] = ACTIONS(3453),
    [anon_sym_CARET] = ACTIONS(3453),
    [anon_sym_AMP] = ACTIONS(3453),
    [anon_sym_this] = ACTIONS(3451),
    [anon_sym_scoped] = ACTIONS(3451),
    [anon_sym_base] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [sym_predefined_type] = ACTIONS(3451),
    [anon_sym_break] = ACTIONS(3451),
    [anon_sym_unchecked] = ACTIONS(3451),
    [anon_sym_continue] = ACTIONS(3451),
    [anon_sym_do] = ACTIONS(3451),
    [anon_sym_while] = ACTIONS(3451),
    [anon_sym_for] = ACTIONS(3451),
    [anon_sym_lock] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_switch] = ACTIONS(3451),
    [anon_sym_default] = ACTIONS(3451),
    [anon_sym_throw] = ACTIONS(3451),
    [anon_sym_try] = ACTIONS(3451),
    [anon_sym_when] = ACTIONS(3451),
    [anon_sym_await] = ACTIONS(3451),
    [anon_sym_foreach] = ACTIONS(3451),
    [anon_sym_goto] = ACTIONS(3451),
    [anon_sym_if] = ACTIONS(3451),
    [anon_sym_DOT_DOT] = ACTIONS(3453),
    [anon_sym_from] = ACTIONS(3451),
    [anon_sym_into] = ACTIONS(3451),
    [anon_sym_join] = ACTIONS(3451),
    [anon_sym_on] = ACTIONS(3451),
    [anon_sym_equals] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_orderby] = ACTIONS(3451),
    [anon_sym_ascending] = ACTIONS(3451),
    [anon_sym_descending] = ACTIONS(3451),
    [anon_sym_group] = ACTIONS(3451),
    [anon_sym_by] = ACTIONS(3451),
    [anon_sym_select] = ACTIONS(3451),
    [anon_sym_DQUOTE] = ACTIONS(3453),
    [anon_sym_stackalloc] = ACTIONS(3451),
    [anon_sym_sizeof] = ACTIONS(3451),
    [anon_sym_typeof] = ACTIONS(3451),
    [anon_sym___makeref] = ACTIONS(3451),
    [anon_sym___reftype] = ACTIONS(3451),
    [anon_sym___refvalue] = ACTIONS(3451),
    [sym_null_literal] = ACTIONS(3451),
    [anon_sym_SQUOTE] = ACTIONS(3453),
    [sym_integer_literal] = ACTIONS(3451),
    [sym_real_literal] = ACTIONS(3453),
    [sym_verbatim_string_literal] = ACTIONS(3453),
    [aux_sym_preproc_if_token1] = ACTIONS(3453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3453),
    [sym_interpolation_verbatim_start] = ACTIONS(3453),
    [sym_interpolation_raw_start] = ACTIONS(3453),
    [sym_raw_string_start] = ACTIONS(3453),
  },
  [2571] = {
    [sym_preproc_region] = STATE(2571),
    [sym_preproc_endregion] = STATE(2571),
    [sym_preproc_line] = STATE(2571),
    [sym_preproc_pragma] = STATE(2571),
    [sym_preproc_nullable] = STATE(2571),
    [sym_preproc_error] = STATE(2571),
    [sym_preproc_define] = STATE(2571),
    [sym_preproc_undef] = STATE(2571),
    [ts_builtin_sym_end] = ACTIONS(3449),
    [sym__identifier_token] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym_alias] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_global] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_unsafe] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_ref] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_delegate] = ACTIONS(3447),
    [anon_sym_record] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_file] = ACTIONS(3447),
    [anon_sym_fixed] = ACTIONS(3447),
    [anon_sym_internal] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_partial] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_required] = ACTIONS(3447),
    [anon_sym_sealed] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_where] = ACTIONS(3447),
    [anon_sym_notnull] = ACTIONS(3447),
    [anon_sym_unmanaged] = ACTIONS(3447),
    [anon_sym_checked] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3449),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_PLUS_PLUS] = ACTIONS(3449),
    [anon_sym_DASH_DASH] = ACTIONS(3449),
    [anon_sym_true] = ACTIONS(3447),
    [anon_sym_false] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3449),
    [anon_sym_CARET] = ACTIONS(3449),
    [anon_sym_AMP] = ACTIONS(3449),
    [anon_sym_this] = ACTIONS(3447),
    [anon_sym_scoped] = ACTIONS(3447),
    [anon_sym_base] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [sym_predefined_type] = ACTIONS(3447),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_unchecked] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_lock] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_when] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_foreach] = ACTIONS(3447),
    [anon_sym_goto] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_DOT_DOT] = ACTIONS(3449),
    [anon_sym_from] = ACTIONS(3447),
    [anon_sym_into] = ACTIONS(3447),
    [anon_sym_join] = ACTIONS(3447),
    [anon_sym_on] = ACTIONS(3447),
    [anon_sym_equals] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_orderby] = ACTIONS(3447),
    [anon_sym_ascending] = ACTIONS(3447),
    [anon_sym_descending] = ACTIONS(3447),
    [anon_sym_group] = ACTIONS(3447),
    [anon_sym_by] = ACTIONS(3447),
    [anon_sym_select] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3449),
    [anon_sym_stackalloc] = ACTIONS(3447),
    [anon_sym_sizeof] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym___makeref] = ACTIONS(3447),
    [anon_sym___reftype] = ACTIONS(3447),
    [anon_sym___refvalue] = ACTIONS(3447),
    [sym_null_literal] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3449),
    [sym_integer_literal] = ACTIONS(3447),
    [sym_real_literal] = ACTIONS(3449),
    [sym_verbatim_string_literal] = ACTIONS(3449),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3449),
    [sym_interpolation_verbatim_start] = ACTIONS(3449),
    [sym_interpolation_raw_start] = ACTIONS(3449),
    [sym_raw_string_start] = ACTIONS(3449),
  },
  [2572] = {
    [sym_preproc_region] = STATE(2572),
    [sym_preproc_endregion] = STATE(2572),
    [sym_preproc_line] = STATE(2572),
    [sym_preproc_pragma] = STATE(2572),
    [sym_preproc_nullable] = STATE(2572),
    [sym_preproc_error] = STATE(2572),
    [sym_preproc_define] = STATE(2572),
    [sym_preproc_undef] = STATE(2572),
    [ts_builtin_sym_end] = ACTIONS(3437),
    [sym__identifier_token] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym_alias] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3437),
    [anon_sym_global] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_unsafe] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_ref] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_delegate] = ACTIONS(3435),
    [anon_sym_record] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_file] = ACTIONS(3435),
    [anon_sym_fixed] = ACTIONS(3435),
    [anon_sym_internal] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_partial] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_required] = ACTIONS(3435),
    [anon_sym_sealed] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_where] = ACTIONS(3435),
    [anon_sym_notnull] = ACTIONS(3435),
    [anon_sym_unmanaged] = ACTIONS(3435),
    [anon_sym_checked] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3437),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_PLUS_PLUS] = ACTIONS(3437),
    [anon_sym_DASH_DASH] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3435),
    [anon_sym_false] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_AMP] = ACTIONS(3437),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_scoped] = ACTIONS(3435),
    [anon_sym_base] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [sym_predefined_type] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_unchecked] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_lock] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_when] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_foreach] = ACTIONS(3435),
    [anon_sym_goto] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_DOT_DOT] = ACTIONS(3437),
    [anon_sym_from] = ACTIONS(3435),
    [anon_sym_into] = ACTIONS(3435),
    [anon_sym_join] = ACTIONS(3435),
    [anon_sym_on] = ACTIONS(3435),
    [anon_sym_equals] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_orderby] = ACTIONS(3435),
    [anon_sym_ascending] = ACTIONS(3435),
    [anon_sym_descending] = ACTIONS(3435),
    [anon_sym_group] = ACTIONS(3435),
    [anon_sym_by] = ACTIONS(3435),
    [anon_sym_select] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [anon_sym_stackalloc] = ACTIONS(3435),
    [anon_sym_sizeof] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym___makeref] = ACTIONS(3435),
    [anon_sym___reftype] = ACTIONS(3435),
    [anon_sym___refvalue] = ACTIONS(3435),
    [sym_null_literal] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3437),
    [sym_integer_literal] = ACTIONS(3435),
    [sym_real_literal] = ACTIONS(3437),
    [sym_verbatim_string_literal] = ACTIONS(3437),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3437),
    [sym_interpolation_verbatim_start] = ACTIONS(3437),
    [sym_interpolation_raw_start] = ACTIONS(3437),
    [sym_raw_string_start] = ACTIONS(3437),
  },
  [2573] = {
    [sym_preproc_region] = STATE(2573),
    [sym_preproc_endregion] = STATE(2573),
    [sym_preproc_line] = STATE(2573),
    [sym_preproc_pragma] = STATE(2573),
    [sym_preproc_nullable] = STATE(2573),
    [sym_preproc_error] = STATE(2573),
    [sym_preproc_define] = STATE(2573),
    [sym_preproc_undef] = STATE(2573),
    [ts_builtin_sym_end] = ACTIONS(3433),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_return] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_checked] = ACTIONS(3431),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_true] = ACTIONS(3431),
    [anon_sym_false] = ACTIONS(3431),
    [anon_sym_PLUS] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3431),
    [anon_sym_STAR] = ACTIONS(3433),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_AMP] = ACTIONS(3433),
    [anon_sym_this] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_base] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_break] = ACTIONS(3431),
    [anon_sym_unchecked] = ACTIONS(3431),
    [anon_sym_continue] = ACTIONS(3431),
    [anon_sym_do] = ACTIONS(3431),
    [anon_sym_while] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3431),
    [anon_sym_lock] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3431),
    [anon_sym_default] = ACTIONS(3431),
    [anon_sym_throw] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3431),
    [anon_sym_foreach] = ACTIONS(3431),
    [anon_sym_goto] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_DOT_DOT] = ACTIONS(3433),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_stackalloc] = ACTIONS(3431),
    [anon_sym_sizeof] = ACTIONS(3431),
    [anon_sym_typeof] = ACTIONS(3431),
    [anon_sym___makeref] = ACTIONS(3431),
    [anon_sym___reftype] = ACTIONS(3431),
    [anon_sym___refvalue] = ACTIONS(3431),
    [sym_null_literal] = ACTIONS(3431),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [sym_integer_literal] = ACTIONS(3431),
    [sym_real_literal] = ACTIONS(3433),
    [sym_verbatim_string_literal] = ACTIONS(3433),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3433),
    [sym_interpolation_verbatim_start] = ACTIONS(3433),
    [sym_interpolation_raw_start] = ACTIONS(3433),
    [sym_raw_string_start] = ACTIONS(3433),
  },
  [2574] = {
    [sym_preproc_region] = STATE(2574),
    [sym_preproc_endregion] = STATE(2574),
    [sym_preproc_line] = STATE(2574),
    [sym_preproc_pragma] = STATE(2574),
    [sym_preproc_nullable] = STATE(2574),
    [sym_preproc_error] = STATE(2574),
    [sym_preproc_define] = STATE(2574),
    [sym_preproc_undef] = STATE(2574),
    [ts_builtin_sym_end] = ACTIONS(3943),
    [sym__identifier_token] = ACTIONS(3941),
    [anon_sym_extern] = ACTIONS(3941),
    [anon_sym_alias] = ACTIONS(3941),
    [anon_sym_SEMI] = ACTIONS(3943),
    [anon_sym_global] = ACTIONS(3941),
    [anon_sym_using] = ACTIONS(3941),
    [anon_sym_unsafe] = ACTIONS(3941),
    [anon_sym_static] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_return] = ACTIONS(3941),
    [anon_sym_namespace] = ACTIONS(3941),
    [anon_sym_class] = ACTIONS(3941),
    [anon_sym_ref] = ACTIONS(3941),
    [anon_sym_struct] = ACTIONS(3941),
    [anon_sym_enum] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3943),
    [anon_sym_interface] = ACTIONS(3941),
    [anon_sym_delegate] = ACTIONS(3941),
    [anon_sym_record] = ACTIONS(3941),
    [anon_sym_abstract] = ACTIONS(3941),
    [anon_sym_async] = ACTIONS(3941),
    [anon_sym_const] = ACTIONS(3941),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(3941),
    [anon_sym_internal] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_override] = ACTIONS(3941),
    [anon_sym_partial] = ACTIONS(3941),
    [anon_sym_private] = ACTIONS(3941),
    [anon_sym_protected] = ACTIONS(3941),
    [anon_sym_public] = ACTIONS(3941),
    [anon_sym_readonly] = ACTIONS(3941),
    [anon_sym_required] = ACTIONS(3941),
    [anon_sym_sealed] = ACTIONS(3941),
    [anon_sym_virtual] = ACTIONS(3941),
    [anon_sym_volatile] = ACTIONS(3941),
    [anon_sym_where] = ACTIONS(3941),
    [anon_sym_notnull] = ACTIONS(3941),
    [anon_sym_unmanaged] = ACTIONS(3941),
    [anon_sym_checked] = ACTIONS(3941),
    [anon_sym_BANG] = ACTIONS(3943),
    [anon_sym_TILDE] = ACTIONS(3943),
    [anon_sym_PLUS_PLUS] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3943),
    [anon_sym_true] = ACTIONS(3941),
    [anon_sym_false] = ACTIONS(3941),
    [anon_sym_PLUS] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3941),
    [anon_sym_STAR] = ACTIONS(3943),
    [anon_sym_CARET] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3943),
    [anon_sym_this] = ACTIONS(3941),
    [anon_sym_scoped] = ACTIONS(3941),
    [anon_sym_base] = ACTIONS(3941),
    [anon_sym_var] = ACTIONS(3941),
    [sym_predefined_type] = ACTIONS(3941),
    [anon_sym_break] = ACTIONS(3941),
    [anon_sym_unchecked] = ACTIONS(3941),
    [anon_sym_continue] = ACTIONS(3941),
    [anon_sym_do] = ACTIONS(3941),
    [anon_sym_while] = ACTIONS(3941),
    [anon_sym_for] = ACTIONS(3941),
    [anon_sym_lock] = ACTIONS(3941),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_switch] = ACTIONS(3941),
    [anon_sym_default] = ACTIONS(3941),
    [anon_sym_throw] = ACTIONS(3941),
    [anon_sym_try] = ACTIONS(3941),
    [anon_sym_when] = ACTIONS(3941),
    [anon_sym_await] = ACTIONS(3941),
    [anon_sym_foreach] = ACTIONS(3941),
    [anon_sym_goto] = ACTIONS(3941),
    [anon_sym_if] = ACTIONS(3941),
    [anon_sym_DOT_DOT] = ACTIONS(3943),
    [anon_sym_from] = ACTIONS(3941),
    [anon_sym_into] = ACTIONS(3941),
    [anon_sym_join] = ACTIONS(3941),
    [anon_sym_on] = ACTIONS(3941),
    [anon_sym_equals] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_orderby] = ACTIONS(3941),
    [anon_sym_ascending] = ACTIONS(3941),
    [anon_sym_descending] = ACTIONS(3941),
    [anon_sym_group] = ACTIONS(3941),
    [anon_sym_by] = ACTIONS(3941),
    [anon_sym_select] = ACTIONS(3941),
    [anon_sym_DQUOTE] = ACTIONS(3943),
    [anon_sym_stackalloc] = ACTIONS(3941),
    [anon_sym_sizeof] = ACTIONS(3941),
    [anon_sym_typeof] = ACTIONS(3941),
    [anon_sym___makeref] = ACTIONS(3941),
    [anon_sym___reftype] = ACTIONS(3941),
    [anon_sym___refvalue] = ACTIONS(3941),
    [sym_null_literal] = ACTIONS(3941),
    [anon_sym_SQUOTE] = ACTIONS(3943),
    [sym_integer_literal] = ACTIONS(3941),
    [sym_real_literal] = ACTIONS(3943),
    [sym_verbatim_string_literal] = ACTIONS(3943),
    [aux_sym_preproc_if_token1] = ACTIONS(3943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3943),
    [sym_interpolation_verbatim_start] = ACTIONS(3943),
    [sym_interpolation_raw_start] = ACTIONS(3943),
    [sym_raw_string_start] = ACTIONS(3943),
  },
  [2575] = {
    [sym_preproc_region] = STATE(2575),
    [sym_preproc_endregion] = STATE(2575),
    [sym_preproc_line] = STATE(2575),
    [sym_preproc_pragma] = STATE(2575),
    [sym_preproc_nullable] = STATE(2575),
    [sym_preproc_error] = STATE(2575),
    [sym_preproc_define] = STATE(2575),
    [sym_preproc_undef] = STATE(2575),
    [ts_builtin_sym_end] = ACTIONS(3955),
    [sym__identifier_token] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym_alias] = ACTIONS(3953),
    [anon_sym_SEMI] = ACTIONS(3955),
    [anon_sym_global] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_unsafe] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3955),
    [anon_sym_return] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_ref] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_LBRACE] = ACTIONS(3955),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_delegate] = ACTIONS(3953),
    [anon_sym_record] = ACTIONS(3953),
    [anon_sym_abstract] = ACTIONS(3953),
    [anon_sym_async] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_file] = ACTIONS(3953),
    [anon_sym_fixed] = ACTIONS(3953),
    [anon_sym_internal] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_override] = ACTIONS(3953),
    [anon_sym_partial] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3953),
    [anon_sym_required] = ACTIONS(3953),
    [anon_sym_sealed] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_where] = ACTIONS(3953),
    [anon_sym_notnull] = ACTIONS(3953),
    [anon_sym_unmanaged] = ACTIONS(3953),
    [anon_sym_checked] = ACTIONS(3953),
    [anon_sym_BANG] = ACTIONS(3955),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_PLUS_PLUS] = ACTIONS(3955),
    [anon_sym_DASH_DASH] = ACTIONS(3955),
    [anon_sym_true] = ACTIONS(3953),
    [anon_sym_false] = ACTIONS(3953),
    [anon_sym_PLUS] = ACTIONS(3953),
    [anon_sym_DASH] = ACTIONS(3953),
    [anon_sym_STAR] = ACTIONS(3955),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_AMP] = ACTIONS(3955),
    [anon_sym_this] = ACTIONS(3953),
    [anon_sym_scoped] = ACTIONS(3953),
    [anon_sym_base] = ACTIONS(3953),
    [anon_sym_var] = ACTIONS(3953),
    [sym_predefined_type] = ACTIONS(3953),
    [anon_sym_break] = ACTIONS(3953),
    [anon_sym_unchecked] = ACTIONS(3953),
    [anon_sym_continue] = ACTIONS(3953),
    [anon_sym_do] = ACTIONS(3953),
    [anon_sym_while] = ACTIONS(3953),
    [anon_sym_for] = ACTIONS(3953),
    [anon_sym_lock] = ACTIONS(3953),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_switch] = ACTIONS(3953),
    [anon_sym_default] = ACTIONS(3953),
    [anon_sym_throw] = ACTIONS(3953),
    [anon_sym_try] = ACTIONS(3953),
    [anon_sym_when] = ACTIONS(3953),
    [anon_sym_await] = ACTIONS(3953),
    [anon_sym_foreach] = ACTIONS(3953),
    [anon_sym_goto] = ACTIONS(3953),
    [anon_sym_if] = ACTIONS(3953),
    [anon_sym_DOT_DOT] = ACTIONS(3955),
    [anon_sym_from] = ACTIONS(3953),
    [anon_sym_into] = ACTIONS(3953),
    [anon_sym_join] = ACTIONS(3953),
    [anon_sym_on] = ACTIONS(3953),
    [anon_sym_equals] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_orderby] = ACTIONS(3953),
    [anon_sym_ascending] = ACTIONS(3953),
    [anon_sym_descending] = ACTIONS(3953),
    [anon_sym_group] = ACTIONS(3953),
    [anon_sym_by] = ACTIONS(3953),
    [anon_sym_select] = ACTIONS(3953),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [anon_sym_stackalloc] = ACTIONS(3953),
    [anon_sym_sizeof] = ACTIONS(3953),
    [anon_sym_typeof] = ACTIONS(3953),
    [anon_sym___makeref] = ACTIONS(3953),
    [anon_sym___reftype] = ACTIONS(3953),
    [anon_sym___refvalue] = ACTIONS(3953),
    [sym_null_literal] = ACTIONS(3953),
    [anon_sym_SQUOTE] = ACTIONS(3955),
    [sym_integer_literal] = ACTIONS(3953),
    [sym_real_literal] = ACTIONS(3955),
    [sym_verbatim_string_literal] = ACTIONS(3955),
    [aux_sym_preproc_if_token1] = ACTIONS(3955),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3955),
    [sym_interpolation_verbatim_start] = ACTIONS(3955),
    [sym_interpolation_raw_start] = ACTIONS(3955),
    [sym_raw_string_start] = ACTIONS(3955),
  },
  [2576] = {
    [sym_preproc_region] = STATE(2576),
    [sym_preproc_endregion] = STATE(2576),
    [sym_preproc_line] = STATE(2576),
    [sym_preproc_pragma] = STATE(2576),
    [sym_preproc_nullable] = STATE(2576),
    [sym_preproc_error] = STATE(2576),
    [sym_preproc_define] = STATE(2576),
    [sym_preproc_undef] = STATE(2576),
    [ts_builtin_sym_end] = ACTIONS(3469),
    [sym__identifier_token] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym_alias] = ACTIONS(3467),
    [anon_sym_SEMI] = ACTIONS(3469),
    [anon_sym_global] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_unsafe] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3469),
    [anon_sym_LPAREN] = ACTIONS(3469),
    [anon_sym_return] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_ref] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_LBRACE] = ACTIONS(3469),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_delegate] = ACTIONS(3467),
    [anon_sym_record] = ACTIONS(3467),
    [anon_sym_abstract] = ACTIONS(3467),
    [anon_sym_async] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_file] = ACTIONS(3467),
    [anon_sym_fixed] = ACTIONS(3467),
    [anon_sym_internal] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_override] = ACTIONS(3467),
    [anon_sym_partial] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_readonly] = ACTIONS(3467),
    [anon_sym_required] = ACTIONS(3467),
    [anon_sym_sealed] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_where] = ACTIONS(3467),
    [anon_sym_notnull] = ACTIONS(3467),
    [anon_sym_unmanaged] = ACTIONS(3467),
    [anon_sym_checked] = ACTIONS(3467),
    [anon_sym_BANG] = ACTIONS(3469),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_PLUS_PLUS] = ACTIONS(3469),
    [anon_sym_DASH_DASH] = ACTIONS(3469),
    [anon_sym_true] = ACTIONS(3467),
    [anon_sym_false] = ACTIONS(3467),
    [anon_sym_PLUS] = ACTIONS(3467),
    [anon_sym_DASH] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3469),
    [anon_sym_CARET] = ACTIONS(3469),
    [anon_sym_AMP] = ACTIONS(3469),
    [anon_sym_this] = ACTIONS(3467),
    [anon_sym_scoped] = ACTIONS(3467),
    [anon_sym_base] = ACTIONS(3467),
    [anon_sym_var] = ACTIONS(3467),
    [sym_predefined_type] = ACTIONS(3467),
    [anon_sym_break] = ACTIONS(3467),
    [anon_sym_unchecked] = ACTIONS(3467),
    [anon_sym_continue] = ACTIONS(3467),
    [anon_sym_do] = ACTIONS(3467),
    [anon_sym_while] = ACTIONS(3467),
    [anon_sym_for] = ACTIONS(3467),
    [anon_sym_lock] = ACTIONS(3467),
    [anon_sym_yield] = ACTIONS(3467),
    [anon_sym_switch] = ACTIONS(3467),
    [anon_sym_default] = ACTIONS(3467),
    [anon_sym_throw] = ACTIONS(3467),
    [anon_sym_try] = ACTIONS(3467),
    [anon_sym_when] = ACTIONS(3467),
    [anon_sym_await] = ACTIONS(3467),
    [anon_sym_foreach] = ACTIONS(3467),
    [anon_sym_goto] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(3467),
    [anon_sym_DOT_DOT] = ACTIONS(3469),
    [anon_sym_from] = ACTIONS(3467),
    [anon_sym_into] = ACTIONS(3467),
    [anon_sym_join] = ACTIONS(3467),
    [anon_sym_on] = ACTIONS(3467),
    [anon_sym_equals] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_orderby] = ACTIONS(3467),
    [anon_sym_ascending] = ACTIONS(3467),
    [anon_sym_descending] = ACTIONS(3467),
    [anon_sym_group] = ACTIONS(3467),
    [anon_sym_by] = ACTIONS(3467),
    [anon_sym_select] = ACTIONS(3467),
    [anon_sym_DQUOTE] = ACTIONS(3469),
    [anon_sym_stackalloc] = ACTIONS(3467),
    [anon_sym_sizeof] = ACTIONS(3467),
    [anon_sym_typeof] = ACTIONS(3467),
    [anon_sym___makeref] = ACTIONS(3467),
    [anon_sym___reftype] = ACTIONS(3467),
    [anon_sym___refvalue] = ACTIONS(3467),
    [sym_null_literal] = ACTIONS(3467),
    [anon_sym_SQUOTE] = ACTIONS(3469),
    [sym_integer_literal] = ACTIONS(3467),
    [sym_real_literal] = ACTIONS(3469),
    [sym_verbatim_string_literal] = ACTIONS(3469),
    [aux_sym_preproc_if_token1] = ACTIONS(3469),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3469),
    [sym_interpolation_verbatim_start] = ACTIONS(3469),
    [sym_interpolation_raw_start] = ACTIONS(3469),
    [sym_raw_string_start] = ACTIONS(3469),
  },
  [2577] = {
    [sym_preproc_region] = STATE(2577),
    [sym_preproc_endregion] = STATE(2577),
    [sym_preproc_line] = STATE(2577),
    [sym_preproc_pragma] = STATE(2577),
    [sym_preproc_nullable] = STATE(2577),
    [sym_preproc_error] = STATE(2577),
    [sym_preproc_define] = STATE(2577),
    [sym_preproc_undef] = STATE(2577),
    [ts_builtin_sym_end] = ACTIONS(3473),
    [sym__identifier_token] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym_alias] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym_global] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_unsafe] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3473),
    [anon_sym_LPAREN] = ACTIONS(3473),
    [anon_sym_return] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_ref] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_LBRACE] = ACTIONS(3473),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_delegate] = ACTIONS(3471),
    [anon_sym_record] = ACTIONS(3471),
    [anon_sym_abstract] = ACTIONS(3471),
    [anon_sym_async] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_file] = ACTIONS(3471),
    [anon_sym_fixed] = ACTIONS(3471),
    [anon_sym_internal] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_override] = ACTIONS(3471),
    [anon_sym_partial] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_readonly] = ACTIONS(3471),
    [anon_sym_required] = ACTIONS(3471),
    [anon_sym_sealed] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_where] = ACTIONS(3471),
    [anon_sym_notnull] = ACTIONS(3471),
    [anon_sym_unmanaged] = ACTIONS(3471),
    [anon_sym_checked] = ACTIONS(3471),
    [anon_sym_BANG] = ACTIONS(3473),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_PLUS_PLUS] = ACTIONS(3473),
    [anon_sym_DASH_DASH] = ACTIONS(3473),
    [anon_sym_true] = ACTIONS(3471),
    [anon_sym_false] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3471),
    [anon_sym_DASH] = ACTIONS(3471),
    [anon_sym_STAR] = ACTIONS(3473),
    [anon_sym_CARET] = ACTIONS(3473),
    [anon_sym_AMP] = ACTIONS(3473),
    [anon_sym_this] = ACTIONS(3471),
    [anon_sym_scoped] = ACTIONS(3471),
    [anon_sym_base] = ACTIONS(3471),
    [anon_sym_var] = ACTIONS(3471),
    [sym_predefined_type] = ACTIONS(3471),
    [anon_sym_break] = ACTIONS(3471),
    [anon_sym_unchecked] = ACTIONS(3471),
    [anon_sym_continue] = ACTIONS(3471),
    [anon_sym_do] = ACTIONS(3471),
    [anon_sym_while] = ACTIONS(3471),
    [anon_sym_for] = ACTIONS(3471),
    [anon_sym_lock] = ACTIONS(3471),
    [anon_sym_yield] = ACTIONS(3471),
    [anon_sym_switch] = ACTIONS(3471),
    [anon_sym_default] = ACTIONS(3471),
    [anon_sym_throw] = ACTIONS(3471),
    [anon_sym_try] = ACTIONS(3471),
    [anon_sym_when] = ACTIONS(3471),
    [anon_sym_await] = ACTIONS(3471),
    [anon_sym_foreach] = ACTIONS(3471),
    [anon_sym_goto] = ACTIONS(3471),
    [anon_sym_if] = ACTIONS(3471),
    [anon_sym_DOT_DOT] = ACTIONS(3473),
    [anon_sym_from] = ACTIONS(3471),
    [anon_sym_into] = ACTIONS(3471),
    [anon_sym_join] = ACTIONS(3471),
    [anon_sym_on] = ACTIONS(3471),
    [anon_sym_equals] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_orderby] = ACTIONS(3471),
    [anon_sym_ascending] = ACTIONS(3471),
    [anon_sym_descending] = ACTIONS(3471),
    [anon_sym_group] = ACTIONS(3471),
    [anon_sym_by] = ACTIONS(3471),
    [anon_sym_select] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(3473),
    [anon_sym_stackalloc] = ACTIONS(3471),
    [anon_sym_sizeof] = ACTIONS(3471),
    [anon_sym_typeof] = ACTIONS(3471),
    [anon_sym___makeref] = ACTIONS(3471),
    [anon_sym___reftype] = ACTIONS(3471),
    [anon_sym___refvalue] = ACTIONS(3471),
    [sym_null_literal] = ACTIONS(3471),
    [anon_sym_SQUOTE] = ACTIONS(3473),
    [sym_integer_literal] = ACTIONS(3471),
    [sym_real_literal] = ACTIONS(3473),
    [sym_verbatim_string_literal] = ACTIONS(3473),
    [aux_sym_preproc_if_token1] = ACTIONS(3473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3473),
    [sym_interpolation_verbatim_start] = ACTIONS(3473),
    [sym_interpolation_raw_start] = ACTIONS(3473),
    [sym_raw_string_start] = ACTIONS(3473),
  },
  [2578] = {
    [sym_preproc_region] = STATE(2578),
    [sym_preproc_endregion] = STATE(2578),
    [sym_preproc_line] = STATE(2578),
    [sym_preproc_pragma] = STATE(2578),
    [sym_preproc_nullable] = STATE(2578),
    [sym_preproc_error] = STATE(2578),
    [sym_preproc_define] = STATE(2578),
    [sym_preproc_undef] = STATE(2578),
    [ts_builtin_sym_end] = ACTIONS(3979),
    [sym__identifier_token] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym_alias] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3979),
    [anon_sym_global] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_unsafe] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3979),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_ref] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_delegate] = ACTIONS(3977),
    [anon_sym_record] = ACTIONS(3977),
    [anon_sym_abstract] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_file] = ACTIONS(3977),
    [anon_sym_fixed] = ACTIONS(3977),
    [anon_sym_internal] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_override] = ACTIONS(3977),
    [anon_sym_partial] = ACTIONS(3977),
    [anon_sym_private] = ACTIONS(3977),
    [anon_sym_protected] = ACTIONS(3977),
    [anon_sym_public] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3977),
    [anon_sym_required] = ACTIONS(3977),
    [anon_sym_sealed] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_where] = ACTIONS(3977),
    [anon_sym_notnull] = ACTIONS(3977),
    [anon_sym_unmanaged] = ACTIONS(3977),
    [anon_sym_checked] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3979),
    [anon_sym_DASH_DASH] = ACTIONS(3979),
    [anon_sym_true] = ACTIONS(3977),
    [anon_sym_false] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_this] = ACTIONS(3977),
    [anon_sym_scoped] = ACTIONS(3977),
    [anon_sym_base] = ACTIONS(3977),
    [anon_sym_var] = ACTIONS(3977),
    [sym_predefined_type] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_unchecked] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_lock] = ACTIONS(3977),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_when] = ACTIONS(3977),
    [anon_sym_await] = ACTIONS(3977),
    [anon_sym_foreach] = ACTIONS(3977),
    [anon_sym_goto] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_DOT_DOT] = ACTIONS(3979),
    [anon_sym_from] = ACTIONS(3977),
    [anon_sym_into] = ACTIONS(3977),
    [anon_sym_join] = ACTIONS(3977),
    [anon_sym_on] = ACTIONS(3977),
    [anon_sym_equals] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_orderby] = ACTIONS(3977),
    [anon_sym_ascending] = ACTIONS(3977),
    [anon_sym_descending] = ACTIONS(3977),
    [anon_sym_group] = ACTIONS(3977),
    [anon_sym_by] = ACTIONS(3977),
    [anon_sym_select] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(3979),
    [anon_sym_stackalloc] = ACTIONS(3977),
    [anon_sym_sizeof] = ACTIONS(3977),
    [anon_sym_typeof] = ACTIONS(3977),
    [anon_sym___makeref] = ACTIONS(3977),
    [anon_sym___reftype] = ACTIONS(3977),
    [anon_sym___refvalue] = ACTIONS(3977),
    [sym_null_literal] = ACTIONS(3977),
    [anon_sym_SQUOTE] = ACTIONS(3979),
    [sym_integer_literal] = ACTIONS(3977),
    [sym_real_literal] = ACTIONS(3979),
    [sym_verbatim_string_literal] = ACTIONS(3979),
    [aux_sym_preproc_if_token1] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3979),
    [sym_interpolation_verbatim_start] = ACTIONS(3979),
    [sym_interpolation_raw_start] = ACTIONS(3979),
    [sym_raw_string_start] = ACTIONS(3979),
  },
  [2579] = {
    [sym_preproc_region] = STATE(2579),
    [sym_preproc_endregion] = STATE(2579),
    [sym_preproc_line] = STATE(2579),
    [sym_preproc_pragma] = STATE(2579),
    [sym_preproc_nullable] = STATE(2579),
    [sym_preproc_error] = STATE(2579),
    [sym_preproc_define] = STATE(2579),
    [sym_preproc_undef] = STATE(2579),
    [ts_builtin_sym_end] = ACTIONS(3983),
    [sym__identifier_token] = ACTIONS(3981),
    [anon_sym_extern] = ACTIONS(3981),
    [anon_sym_alias] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3983),
    [anon_sym_global] = ACTIONS(3981),
    [anon_sym_using] = ACTIONS(3981),
    [anon_sym_unsafe] = ACTIONS(3981),
    [anon_sym_static] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3981),
    [anon_sym_namespace] = ACTIONS(3981),
    [anon_sym_class] = ACTIONS(3981),
    [anon_sym_ref] = ACTIONS(3981),
    [anon_sym_struct] = ACTIONS(3981),
    [anon_sym_enum] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3981),
    [anon_sym_delegate] = ACTIONS(3981),
    [anon_sym_record] = ACTIONS(3981),
    [anon_sym_abstract] = ACTIONS(3981),
    [anon_sym_async] = ACTIONS(3981),
    [anon_sym_const] = ACTIONS(3981),
    [anon_sym_file] = ACTIONS(3981),
    [anon_sym_fixed] = ACTIONS(3981),
    [anon_sym_internal] = ACTIONS(3981),
    [anon_sym_new] = ACTIONS(3981),
    [anon_sym_override] = ACTIONS(3981),
    [anon_sym_partial] = ACTIONS(3981),
    [anon_sym_private] = ACTIONS(3981),
    [anon_sym_protected] = ACTIONS(3981),
    [anon_sym_public] = ACTIONS(3981),
    [anon_sym_readonly] = ACTIONS(3981),
    [anon_sym_required] = ACTIONS(3981),
    [anon_sym_sealed] = ACTIONS(3981),
    [anon_sym_virtual] = ACTIONS(3981),
    [anon_sym_volatile] = ACTIONS(3981),
    [anon_sym_where] = ACTIONS(3981),
    [anon_sym_notnull] = ACTIONS(3981),
    [anon_sym_unmanaged] = ACTIONS(3981),
    [anon_sym_checked] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_TILDE] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3983),
    [anon_sym_true] = ACTIONS(3981),
    [anon_sym_false] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3981),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_CARET] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_this] = ACTIONS(3981),
    [anon_sym_scoped] = ACTIONS(3981),
    [anon_sym_base] = ACTIONS(3981),
    [anon_sym_var] = ACTIONS(3981),
    [sym_predefined_type] = ACTIONS(3981),
    [anon_sym_break] = ACTIONS(3981),
    [anon_sym_unchecked] = ACTIONS(3981),
    [anon_sym_continue] = ACTIONS(3981),
    [anon_sym_do] = ACTIONS(3981),
    [anon_sym_while] = ACTIONS(3981),
    [anon_sym_for] = ACTIONS(3981),
    [anon_sym_lock] = ACTIONS(3981),
    [anon_sym_yield] = ACTIONS(3981),
    [anon_sym_switch] = ACTIONS(3981),
    [anon_sym_default] = ACTIONS(3981),
    [anon_sym_throw] = ACTIONS(3981),
    [anon_sym_try] = ACTIONS(3981),
    [anon_sym_when] = ACTIONS(3981),
    [anon_sym_await] = ACTIONS(3981),
    [anon_sym_foreach] = ACTIONS(3981),
    [anon_sym_goto] = ACTIONS(3981),
    [anon_sym_if] = ACTIONS(3981),
    [anon_sym_DOT_DOT] = ACTIONS(3983),
    [anon_sym_from] = ACTIONS(3981),
    [anon_sym_into] = ACTIONS(3981),
    [anon_sym_join] = ACTIONS(3981),
    [anon_sym_on] = ACTIONS(3981),
    [anon_sym_equals] = ACTIONS(3981),
    [anon_sym_let] = ACTIONS(3981),
    [anon_sym_orderby] = ACTIONS(3981),
    [anon_sym_ascending] = ACTIONS(3981),
    [anon_sym_descending] = ACTIONS(3981),
    [anon_sym_group] = ACTIONS(3981),
    [anon_sym_by] = ACTIONS(3981),
    [anon_sym_select] = ACTIONS(3981),
    [anon_sym_DQUOTE] = ACTIONS(3983),
    [anon_sym_stackalloc] = ACTIONS(3981),
    [anon_sym_sizeof] = ACTIONS(3981),
    [anon_sym_typeof] = ACTIONS(3981),
    [anon_sym___makeref] = ACTIONS(3981),
    [anon_sym___reftype] = ACTIONS(3981),
    [anon_sym___refvalue] = ACTIONS(3981),
    [sym_null_literal] = ACTIONS(3981),
    [anon_sym_SQUOTE] = ACTIONS(3983),
    [sym_integer_literal] = ACTIONS(3981),
    [sym_real_literal] = ACTIONS(3983),
    [sym_verbatim_string_literal] = ACTIONS(3983),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3983),
    [sym_interpolation_verbatim_start] = ACTIONS(3983),
    [sym_interpolation_raw_start] = ACTIONS(3983),
    [sym_raw_string_start] = ACTIONS(3983),
  },
  [2580] = {
    [sym_preproc_region] = STATE(2580),
    [sym_preproc_endregion] = STATE(2580),
    [sym_preproc_line] = STATE(2580),
    [sym_preproc_pragma] = STATE(2580),
    [sym_preproc_nullable] = STATE(2580),
    [sym_preproc_error] = STATE(2580),
    [sym_preproc_define] = STATE(2580),
    [sym_preproc_undef] = STATE(2580),
    [ts_builtin_sym_end] = ACTIONS(3477),
    [sym__identifier_token] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym_alias] = ACTIONS(3475),
    [anon_sym_SEMI] = ACTIONS(3477),
    [anon_sym_global] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_unsafe] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_return] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_ref] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_LBRACE] = ACTIONS(3477),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_delegate] = ACTIONS(3475),
    [anon_sym_record] = ACTIONS(3475),
    [anon_sym_abstract] = ACTIONS(3475),
    [anon_sym_async] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_file] = ACTIONS(3475),
    [anon_sym_fixed] = ACTIONS(3475),
    [anon_sym_internal] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_override] = ACTIONS(3475),
    [anon_sym_partial] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_readonly] = ACTIONS(3475),
    [anon_sym_required] = ACTIONS(3475),
    [anon_sym_sealed] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_where] = ACTIONS(3475),
    [anon_sym_notnull] = ACTIONS(3475),
    [anon_sym_unmanaged] = ACTIONS(3475),
    [anon_sym_checked] = ACTIONS(3475),
    [anon_sym_BANG] = ACTIONS(3477),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_PLUS_PLUS] = ACTIONS(3477),
    [anon_sym_DASH_DASH] = ACTIONS(3477),
    [anon_sym_true] = ACTIONS(3475),
    [anon_sym_false] = ACTIONS(3475),
    [anon_sym_PLUS] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3475),
    [anon_sym_STAR] = ACTIONS(3477),
    [anon_sym_CARET] = ACTIONS(3477),
    [anon_sym_AMP] = ACTIONS(3477),
    [anon_sym_this] = ACTIONS(3475),
    [anon_sym_scoped] = ACTIONS(3475),
    [anon_sym_base] = ACTIONS(3475),
    [anon_sym_var] = ACTIONS(3475),
    [sym_predefined_type] = ACTIONS(3475),
    [anon_sym_break] = ACTIONS(3475),
    [anon_sym_unchecked] = ACTIONS(3475),
    [anon_sym_continue] = ACTIONS(3475),
    [anon_sym_do] = ACTIONS(3475),
    [anon_sym_while] = ACTIONS(3475),
    [anon_sym_for] = ACTIONS(3475),
    [anon_sym_lock] = ACTIONS(3475),
    [anon_sym_yield] = ACTIONS(3475),
    [anon_sym_switch] = ACTIONS(3475),
    [anon_sym_default] = ACTIONS(3475),
    [anon_sym_throw] = ACTIONS(3475),
    [anon_sym_try] = ACTIONS(3475),
    [anon_sym_when] = ACTIONS(3475),
    [anon_sym_await] = ACTIONS(3475),
    [anon_sym_foreach] = ACTIONS(3475),
    [anon_sym_goto] = ACTIONS(3475),
    [anon_sym_if] = ACTIONS(3475),
    [anon_sym_DOT_DOT] = ACTIONS(3477),
    [anon_sym_from] = ACTIONS(3475),
    [anon_sym_into] = ACTIONS(3475),
    [anon_sym_join] = ACTIONS(3475),
    [anon_sym_on] = ACTIONS(3475),
    [anon_sym_equals] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_orderby] = ACTIONS(3475),
    [anon_sym_ascending] = ACTIONS(3475),
    [anon_sym_descending] = ACTIONS(3475),
    [anon_sym_group] = ACTIONS(3475),
    [anon_sym_by] = ACTIONS(3475),
    [anon_sym_select] = ACTIONS(3475),
    [anon_sym_DQUOTE] = ACTIONS(3477),
    [anon_sym_stackalloc] = ACTIONS(3475),
    [anon_sym_sizeof] = ACTIONS(3475),
    [anon_sym_typeof] = ACTIONS(3475),
    [anon_sym___makeref] = ACTIONS(3475),
    [anon_sym___reftype] = ACTIONS(3475),
    [anon_sym___refvalue] = ACTIONS(3475),
    [sym_null_literal] = ACTIONS(3475),
    [anon_sym_SQUOTE] = ACTIONS(3477),
    [sym_integer_literal] = ACTIONS(3475),
    [sym_real_literal] = ACTIONS(3477),
    [sym_verbatim_string_literal] = ACTIONS(3477),
    [aux_sym_preproc_if_token1] = ACTIONS(3477),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3477),
    [sym_interpolation_verbatim_start] = ACTIONS(3477),
    [sym_interpolation_raw_start] = ACTIONS(3477),
    [sym_raw_string_start] = ACTIONS(3477),
  },
  [2581] = {
    [sym_preproc_region] = STATE(2581),
    [sym_preproc_endregion] = STATE(2581),
    [sym_preproc_line] = STATE(2581),
    [sym_preproc_pragma] = STATE(2581),
    [sym_preproc_nullable] = STATE(2581),
    [sym_preproc_error] = STATE(2581),
    [sym_preproc_define] = STATE(2581),
    [sym_preproc_undef] = STATE(2581),
    [ts_builtin_sym_end] = ACTIONS(3609),
    [sym__identifier_token] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym_alias] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_global] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_unsafe] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_ref] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_delegate] = ACTIONS(3607),
    [anon_sym_record] = ACTIONS(3607),
    [anon_sym_abstract] = ACTIONS(3607),
    [anon_sym_async] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_file] = ACTIONS(3607),
    [anon_sym_fixed] = ACTIONS(3607),
    [anon_sym_internal] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_override] = ACTIONS(3607),
    [anon_sym_partial] = ACTIONS(3607),
    [anon_sym_private] = ACTIONS(3607),
    [anon_sym_protected] = ACTIONS(3607),
    [anon_sym_public] = ACTIONS(3607),
    [anon_sym_readonly] = ACTIONS(3607),
    [anon_sym_required] = ACTIONS(3607),
    [anon_sym_sealed] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_where] = ACTIONS(3607),
    [anon_sym_notnull] = ACTIONS(3607),
    [anon_sym_unmanaged] = ACTIONS(3607),
    [anon_sym_checked] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_true] = ACTIONS(3607),
    [anon_sym_false] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_STAR] = ACTIONS(3609),
    [anon_sym_CARET] = ACTIONS(3609),
    [anon_sym_AMP] = ACTIONS(3609),
    [anon_sym_this] = ACTIONS(3607),
    [anon_sym_scoped] = ACTIONS(3607),
    [anon_sym_base] = ACTIONS(3607),
    [anon_sym_var] = ACTIONS(3607),
    [sym_predefined_type] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_unchecked] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_lock] = ACTIONS(3607),
    [anon_sym_yield] = ACTIONS(3607),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_when] = ACTIONS(3607),
    [anon_sym_await] = ACTIONS(3607),
    [anon_sym_foreach] = ACTIONS(3607),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym_if] = ACTIONS(3607),
    [anon_sym_DOT_DOT] = ACTIONS(3609),
    [anon_sym_from] = ACTIONS(3607),
    [anon_sym_into] = ACTIONS(3607),
    [anon_sym_join] = ACTIONS(3607),
    [anon_sym_on] = ACTIONS(3607),
    [anon_sym_equals] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_orderby] = ACTIONS(3607),
    [anon_sym_ascending] = ACTIONS(3607),
    [anon_sym_descending] = ACTIONS(3607),
    [anon_sym_group] = ACTIONS(3607),
    [anon_sym_by] = ACTIONS(3607),
    [anon_sym_select] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [anon_sym_stackalloc] = ACTIONS(3607),
    [anon_sym_sizeof] = ACTIONS(3607),
    [anon_sym_typeof] = ACTIONS(3607),
    [anon_sym___makeref] = ACTIONS(3607),
    [anon_sym___reftype] = ACTIONS(3607),
    [anon_sym___refvalue] = ACTIONS(3607),
    [sym_null_literal] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [sym_integer_literal] = ACTIONS(3607),
    [sym_real_literal] = ACTIONS(3609),
    [sym_verbatim_string_literal] = ACTIONS(3609),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3609),
    [sym_interpolation_verbatim_start] = ACTIONS(3609),
    [sym_interpolation_raw_start] = ACTIONS(3609),
    [sym_raw_string_start] = ACTIONS(3609),
  },
  [2582] = {
    [sym_preproc_region] = STATE(2582),
    [sym_preproc_endregion] = STATE(2582),
    [sym_preproc_line] = STATE(2582),
    [sym_preproc_pragma] = STATE(2582),
    [sym_preproc_nullable] = STATE(2582),
    [sym_preproc_error] = STATE(2582),
    [sym_preproc_define] = STATE(2582),
    [sym_preproc_undef] = STATE(2582),
    [ts_builtin_sym_end] = ACTIONS(3581),
    [sym__identifier_token] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym_alias] = ACTIONS(3579),
    [anon_sym_SEMI] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_unsafe] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_ref] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_LBRACE] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_delegate] = ACTIONS(3579),
    [anon_sym_record] = ACTIONS(3579),
    [anon_sym_abstract] = ACTIONS(3579),
    [anon_sym_async] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_file] = ACTIONS(3579),
    [anon_sym_fixed] = ACTIONS(3579),
    [anon_sym_internal] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_override] = ACTIONS(3579),
    [anon_sym_partial] = ACTIONS(3579),
    [anon_sym_private] = ACTIONS(3579),
    [anon_sym_protected] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3579),
    [anon_sym_readonly] = ACTIONS(3579),
    [anon_sym_required] = ACTIONS(3579),
    [anon_sym_sealed] = ACTIONS(3579),
    [anon_sym_virtual] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_where] = ACTIONS(3579),
    [anon_sym_notnull] = ACTIONS(3579),
    [anon_sym_unmanaged] = ACTIONS(3579),
    [anon_sym_checked] = ACTIONS(3579),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_PLUS_PLUS] = ACTIONS(3581),
    [anon_sym_DASH_DASH] = ACTIONS(3581),
    [anon_sym_true] = ACTIONS(3579),
    [anon_sym_false] = ACTIONS(3579),
    [anon_sym_PLUS] = ACTIONS(3579),
    [anon_sym_DASH] = ACTIONS(3579),
    [anon_sym_STAR] = ACTIONS(3581),
    [anon_sym_CARET] = ACTIONS(3581),
    [anon_sym_AMP] = ACTIONS(3581),
    [anon_sym_this] = ACTIONS(3579),
    [anon_sym_scoped] = ACTIONS(3579),
    [anon_sym_base] = ACTIONS(3579),
    [anon_sym_var] = ACTIONS(3579),
    [sym_predefined_type] = ACTIONS(3579),
    [anon_sym_break] = ACTIONS(3579),
    [anon_sym_unchecked] = ACTIONS(3579),
    [anon_sym_continue] = ACTIONS(3579),
    [anon_sym_do] = ACTIONS(3579),
    [anon_sym_while] = ACTIONS(3579),
    [anon_sym_for] = ACTIONS(3579),
    [anon_sym_lock] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3579),
    [anon_sym_switch] = ACTIONS(3579),
    [anon_sym_default] = ACTIONS(3579),
    [anon_sym_throw] = ACTIONS(3579),
    [anon_sym_try] = ACTIONS(3579),
    [anon_sym_when] = ACTIONS(3579),
    [anon_sym_await] = ACTIONS(3579),
    [anon_sym_foreach] = ACTIONS(3579),
    [anon_sym_goto] = ACTIONS(3579),
    [anon_sym_if] = ACTIONS(3579),
    [anon_sym_DOT_DOT] = ACTIONS(3581),
    [anon_sym_from] = ACTIONS(3579),
    [anon_sym_into] = ACTIONS(3579),
    [anon_sym_join] = ACTIONS(3579),
    [anon_sym_on] = ACTIONS(3579),
    [anon_sym_equals] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_orderby] = ACTIONS(3579),
    [anon_sym_ascending] = ACTIONS(3579),
    [anon_sym_descending] = ACTIONS(3579),
    [anon_sym_group] = ACTIONS(3579),
    [anon_sym_by] = ACTIONS(3579),
    [anon_sym_select] = ACTIONS(3579),
    [anon_sym_DQUOTE] = ACTIONS(3581),
    [anon_sym_stackalloc] = ACTIONS(3579),
    [anon_sym_sizeof] = ACTIONS(3579),
    [anon_sym_typeof] = ACTIONS(3579),
    [anon_sym___makeref] = ACTIONS(3579),
    [anon_sym___reftype] = ACTIONS(3579),
    [anon_sym___refvalue] = ACTIONS(3579),
    [sym_null_literal] = ACTIONS(3579),
    [anon_sym_SQUOTE] = ACTIONS(3581),
    [sym_integer_literal] = ACTIONS(3579),
    [sym_real_literal] = ACTIONS(3581),
    [sym_verbatim_string_literal] = ACTIONS(3581),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3581),
    [sym_interpolation_verbatim_start] = ACTIONS(3581),
    [sym_interpolation_raw_start] = ACTIONS(3581),
    [sym_raw_string_start] = ACTIONS(3581),
  },
  [2583] = {
    [sym_preproc_region] = STATE(2583),
    [sym_preproc_endregion] = STATE(2583),
    [sym_preproc_line] = STATE(2583),
    [sym_preproc_pragma] = STATE(2583),
    [sym_preproc_nullable] = STATE(2583),
    [sym_preproc_error] = STATE(2583),
    [sym_preproc_define] = STATE(2583),
    [sym_preproc_undef] = STATE(2583),
    [ts_builtin_sym_end] = ACTIONS(3685),
    [sym__identifier_token] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym_alias] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_using] = ACTIONS(3683),
    [anon_sym_unsafe] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_return] = ACTIONS(3683),
    [anon_sym_namespace] = ACTIONS(3683),
    [anon_sym_class] = ACTIONS(3683),
    [anon_sym_ref] = ACTIONS(3683),
    [anon_sym_struct] = ACTIONS(3683),
    [anon_sym_enum] = ACTIONS(3683),
    [anon_sym_LBRACE] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3683),
    [anon_sym_delegate] = ACTIONS(3683),
    [anon_sym_record] = ACTIONS(3683),
    [anon_sym_abstract] = ACTIONS(3683),
    [anon_sym_async] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(3683),
    [anon_sym_file] = ACTIONS(3683),
    [anon_sym_fixed] = ACTIONS(3683),
    [anon_sym_internal] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3683),
    [anon_sym_override] = ACTIONS(3683),
    [anon_sym_partial] = ACTIONS(3683),
    [anon_sym_private] = ACTIONS(3683),
    [anon_sym_protected] = ACTIONS(3683),
    [anon_sym_public] = ACTIONS(3683),
    [anon_sym_readonly] = ACTIONS(3683),
    [anon_sym_required] = ACTIONS(3683),
    [anon_sym_sealed] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_volatile] = ACTIONS(3683),
    [anon_sym_where] = ACTIONS(3683),
    [anon_sym_notnull] = ACTIONS(3683),
    [anon_sym_unmanaged] = ACTIONS(3683),
    [anon_sym_checked] = ACTIONS(3683),
    [anon_sym_BANG] = ACTIONS(3685),
    [anon_sym_TILDE] = ACTIONS(3685),
    [anon_sym_PLUS_PLUS] = ACTIONS(3685),
    [anon_sym_DASH_DASH] = ACTIONS(3685),
    [anon_sym_true] = ACTIONS(3683),
    [anon_sym_false] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(3683),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(3685),
    [anon_sym_CARET] = ACTIONS(3685),
    [anon_sym_AMP] = ACTIONS(3685),
    [anon_sym_this] = ACTIONS(3683),
    [anon_sym_scoped] = ACTIONS(3683),
    [anon_sym_base] = ACTIONS(3683),
    [anon_sym_var] = ACTIONS(3683),
    [sym_predefined_type] = ACTIONS(3683),
    [anon_sym_break] = ACTIONS(3683),
    [anon_sym_unchecked] = ACTIONS(3683),
    [anon_sym_continue] = ACTIONS(3683),
    [anon_sym_do] = ACTIONS(3683),
    [anon_sym_while] = ACTIONS(3683),
    [anon_sym_for] = ACTIONS(3683),
    [anon_sym_lock] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3683),
    [anon_sym_switch] = ACTIONS(3683),
    [anon_sym_default] = ACTIONS(3683),
    [anon_sym_throw] = ACTIONS(3683),
    [anon_sym_try] = ACTIONS(3683),
    [anon_sym_when] = ACTIONS(3683),
    [anon_sym_await] = ACTIONS(3683),
    [anon_sym_foreach] = ACTIONS(3683),
    [anon_sym_goto] = ACTIONS(3683),
    [anon_sym_if] = ACTIONS(3683),
    [anon_sym_DOT_DOT] = ACTIONS(3685),
    [anon_sym_from] = ACTIONS(3683),
    [anon_sym_into] = ACTIONS(3683),
    [anon_sym_join] = ACTIONS(3683),
    [anon_sym_on] = ACTIONS(3683),
    [anon_sym_equals] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_orderby] = ACTIONS(3683),
    [anon_sym_ascending] = ACTIONS(3683),
    [anon_sym_descending] = ACTIONS(3683),
    [anon_sym_group] = ACTIONS(3683),
    [anon_sym_by] = ACTIONS(3683),
    [anon_sym_select] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_stackalloc] = ACTIONS(3683),
    [anon_sym_sizeof] = ACTIONS(3683),
    [anon_sym_typeof] = ACTIONS(3683),
    [anon_sym___makeref] = ACTIONS(3683),
    [anon_sym___reftype] = ACTIONS(3683),
    [anon_sym___refvalue] = ACTIONS(3683),
    [sym_null_literal] = ACTIONS(3683),
    [anon_sym_SQUOTE] = ACTIONS(3685),
    [sym_integer_literal] = ACTIONS(3683),
    [sym_real_literal] = ACTIONS(3685),
    [sym_verbatim_string_literal] = ACTIONS(3685),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3685),
    [sym_interpolation_verbatim_start] = ACTIONS(3685),
    [sym_interpolation_raw_start] = ACTIONS(3685),
    [sym_raw_string_start] = ACTIONS(3685),
  },
  [2584] = {
    [sym_preproc_region] = STATE(2584),
    [sym_preproc_endregion] = STATE(2584),
    [sym_preproc_line] = STATE(2584),
    [sym_preproc_pragma] = STATE(2584),
    [sym_preproc_nullable] = STATE(2584),
    [sym_preproc_error] = STATE(2584),
    [sym_preproc_define] = STATE(2584),
    [sym_preproc_undef] = STATE(2584),
    [ts_builtin_sym_end] = ACTIONS(3577),
    [sym__identifier_token] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym_alias] = ACTIONS(3575),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym_global] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_unsafe] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_return] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_ref] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_LBRACE] = ACTIONS(3577),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_delegate] = ACTIONS(3575),
    [anon_sym_record] = ACTIONS(3575),
    [anon_sym_abstract] = ACTIONS(3575),
    [anon_sym_async] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_file] = ACTIONS(3575),
    [anon_sym_fixed] = ACTIONS(3575),
    [anon_sym_internal] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_override] = ACTIONS(3575),
    [anon_sym_partial] = ACTIONS(3575),
    [anon_sym_private] = ACTIONS(3575),
    [anon_sym_protected] = ACTIONS(3575),
    [anon_sym_public] = ACTIONS(3575),
    [anon_sym_readonly] = ACTIONS(3575),
    [anon_sym_required] = ACTIONS(3575),
    [anon_sym_sealed] = ACTIONS(3575),
    [anon_sym_virtual] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_where] = ACTIONS(3575),
    [anon_sym_notnull] = ACTIONS(3575),
    [anon_sym_unmanaged] = ACTIONS(3575),
    [anon_sym_checked] = ACTIONS(3575),
    [anon_sym_BANG] = ACTIONS(3577),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_PLUS_PLUS] = ACTIONS(3577),
    [anon_sym_DASH_DASH] = ACTIONS(3577),
    [anon_sym_true] = ACTIONS(3575),
    [anon_sym_false] = ACTIONS(3575),
    [anon_sym_PLUS] = ACTIONS(3575),
    [anon_sym_DASH] = ACTIONS(3575),
    [anon_sym_STAR] = ACTIONS(3577),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_AMP] = ACTIONS(3577),
    [anon_sym_this] = ACTIONS(3575),
    [anon_sym_scoped] = ACTIONS(3575),
    [anon_sym_base] = ACTIONS(3575),
    [anon_sym_var] = ACTIONS(3575),
    [sym_predefined_type] = ACTIONS(3575),
    [anon_sym_break] = ACTIONS(3575),
    [anon_sym_unchecked] = ACTIONS(3575),
    [anon_sym_continue] = ACTIONS(3575),
    [anon_sym_do] = ACTIONS(3575),
    [anon_sym_while] = ACTIONS(3575),
    [anon_sym_for] = ACTIONS(3575),
    [anon_sym_lock] = ACTIONS(3575),
    [anon_sym_yield] = ACTIONS(3575),
    [anon_sym_switch] = ACTIONS(3575),
    [anon_sym_default] = ACTIONS(3575),
    [anon_sym_throw] = ACTIONS(3575),
    [anon_sym_try] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_await] = ACTIONS(3575),
    [anon_sym_foreach] = ACTIONS(3575),
    [anon_sym_goto] = ACTIONS(3575),
    [anon_sym_if] = ACTIONS(3575),
    [anon_sym_DOT_DOT] = ACTIONS(3577),
    [anon_sym_from] = ACTIONS(3575),
    [anon_sym_into] = ACTIONS(3575),
    [anon_sym_join] = ACTIONS(3575),
    [anon_sym_on] = ACTIONS(3575),
    [anon_sym_equals] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_orderby] = ACTIONS(3575),
    [anon_sym_ascending] = ACTIONS(3575),
    [anon_sym_descending] = ACTIONS(3575),
    [anon_sym_group] = ACTIONS(3575),
    [anon_sym_by] = ACTIONS(3575),
    [anon_sym_select] = ACTIONS(3575),
    [anon_sym_DQUOTE] = ACTIONS(3577),
    [anon_sym_stackalloc] = ACTIONS(3575),
    [anon_sym_sizeof] = ACTIONS(3575),
    [anon_sym_typeof] = ACTIONS(3575),
    [anon_sym___makeref] = ACTIONS(3575),
    [anon_sym___reftype] = ACTIONS(3575),
    [anon_sym___refvalue] = ACTIONS(3575),
    [sym_null_literal] = ACTIONS(3575),
    [anon_sym_SQUOTE] = ACTIONS(3577),
    [sym_integer_literal] = ACTIONS(3575),
    [sym_real_literal] = ACTIONS(3577),
    [sym_verbatim_string_literal] = ACTIONS(3577),
    [aux_sym_preproc_if_token1] = ACTIONS(3577),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3577),
    [sym_interpolation_verbatim_start] = ACTIONS(3577),
    [sym_interpolation_raw_start] = ACTIONS(3577),
    [sym_raw_string_start] = ACTIONS(3577),
  },
  [2585] = {
    [sym_preproc_region] = STATE(2585),
    [sym_preproc_endregion] = STATE(2585),
    [sym_preproc_line] = STATE(2585),
    [sym_preproc_pragma] = STATE(2585),
    [sym_preproc_nullable] = STATE(2585),
    [sym_preproc_error] = STATE(2585),
    [sym_preproc_define] = STATE(2585),
    [sym_preproc_undef] = STATE(2585),
    [ts_builtin_sym_end] = ACTIONS(3597),
    [sym__identifier_token] = ACTIONS(3595),
    [anon_sym_extern] = ACTIONS(3595),
    [anon_sym_alias] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_global] = ACTIONS(3595),
    [anon_sym_using] = ACTIONS(3595),
    [anon_sym_unsafe] = ACTIONS(3595),
    [anon_sym_static] = ACTIONS(3595),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_LPAREN] = ACTIONS(3597),
    [anon_sym_return] = ACTIONS(3595),
    [anon_sym_namespace] = ACTIONS(3595),
    [anon_sym_class] = ACTIONS(3595),
    [anon_sym_ref] = ACTIONS(3595),
    [anon_sym_struct] = ACTIONS(3595),
    [anon_sym_enum] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3595),
    [anon_sym_delegate] = ACTIONS(3595),
    [anon_sym_record] = ACTIONS(3595),
    [anon_sym_abstract] = ACTIONS(3595),
    [anon_sym_async] = ACTIONS(3595),
    [anon_sym_const] = ACTIONS(3595),
    [anon_sym_file] = ACTIONS(3595),
    [anon_sym_fixed] = ACTIONS(3595),
    [anon_sym_internal] = ACTIONS(3595),
    [anon_sym_new] = ACTIONS(3595),
    [anon_sym_override] = ACTIONS(3595),
    [anon_sym_partial] = ACTIONS(3595),
    [anon_sym_private] = ACTIONS(3595),
    [anon_sym_protected] = ACTIONS(3595),
    [anon_sym_public] = ACTIONS(3595),
    [anon_sym_readonly] = ACTIONS(3595),
    [anon_sym_required] = ACTIONS(3595),
    [anon_sym_sealed] = ACTIONS(3595),
    [anon_sym_virtual] = ACTIONS(3595),
    [anon_sym_volatile] = ACTIONS(3595),
    [anon_sym_where] = ACTIONS(3595),
    [anon_sym_notnull] = ACTIONS(3595),
    [anon_sym_unmanaged] = ACTIONS(3595),
    [anon_sym_checked] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_TILDE] = ACTIONS(3597),
    [anon_sym_PLUS_PLUS] = ACTIONS(3597),
    [anon_sym_DASH_DASH] = ACTIONS(3597),
    [anon_sym_true] = ACTIONS(3595),
    [anon_sym_false] = ACTIONS(3595),
    [anon_sym_PLUS] = ACTIONS(3595),
    [anon_sym_DASH] = ACTIONS(3595),
    [anon_sym_STAR] = ACTIONS(3597),
    [anon_sym_CARET] = ACTIONS(3597),
    [anon_sym_AMP] = ACTIONS(3597),
    [anon_sym_this] = ACTIONS(3595),
    [anon_sym_scoped] = ACTIONS(3595),
    [anon_sym_base] = ACTIONS(3595),
    [anon_sym_var] = ACTIONS(3595),
    [sym_predefined_type] = ACTIONS(3595),
    [anon_sym_break] = ACTIONS(3595),
    [anon_sym_unchecked] = ACTIONS(3595),
    [anon_sym_continue] = ACTIONS(3595),
    [anon_sym_do] = ACTIONS(3595),
    [anon_sym_while] = ACTIONS(3595),
    [anon_sym_for] = ACTIONS(3595),
    [anon_sym_lock] = ACTIONS(3595),
    [anon_sym_yield] = ACTIONS(3595),
    [anon_sym_switch] = ACTIONS(3595),
    [anon_sym_default] = ACTIONS(3595),
    [anon_sym_throw] = ACTIONS(3595),
    [anon_sym_try] = ACTIONS(3595),
    [anon_sym_when] = ACTIONS(3595),
    [anon_sym_await] = ACTIONS(3595),
    [anon_sym_foreach] = ACTIONS(3595),
    [anon_sym_goto] = ACTIONS(3595),
    [anon_sym_if] = ACTIONS(3595),
    [anon_sym_DOT_DOT] = ACTIONS(3597),
    [anon_sym_from] = ACTIONS(3595),
    [anon_sym_into] = ACTIONS(3595),
    [anon_sym_join] = ACTIONS(3595),
    [anon_sym_on] = ACTIONS(3595),
    [anon_sym_equals] = ACTIONS(3595),
    [anon_sym_let] = ACTIONS(3595),
    [anon_sym_orderby] = ACTIONS(3595),
    [anon_sym_ascending] = ACTIONS(3595),
    [anon_sym_descending] = ACTIONS(3595),
    [anon_sym_group] = ACTIONS(3595),
    [anon_sym_by] = ACTIONS(3595),
    [anon_sym_select] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3597),
    [anon_sym_stackalloc] = ACTIONS(3595),
    [anon_sym_sizeof] = ACTIONS(3595),
    [anon_sym_typeof] = ACTIONS(3595),
    [anon_sym___makeref] = ACTIONS(3595),
    [anon_sym___reftype] = ACTIONS(3595),
    [anon_sym___refvalue] = ACTIONS(3595),
    [sym_null_literal] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3597),
    [sym_integer_literal] = ACTIONS(3595),
    [sym_real_literal] = ACTIONS(3597),
    [sym_verbatim_string_literal] = ACTIONS(3597),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3597),
    [sym_interpolation_verbatim_start] = ACTIONS(3597),
    [sym_interpolation_raw_start] = ACTIONS(3597),
    [sym_raw_string_start] = ACTIONS(3597),
  },
  [2586] = {
    [sym_preproc_region] = STATE(2586),
    [sym_preproc_endregion] = STATE(2586),
    [sym_preproc_line] = STATE(2586),
    [sym_preproc_pragma] = STATE(2586),
    [sym_preproc_nullable] = STATE(2586),
    [sym_preproc_error] = STATE(2586),
    [sym_preproc_define] = STATE(2586),
    [sym_preproc_undef] = STATE(2586),
    [ts_builtin_sym_end] = ACTIONS(3713),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_SEMI] = ACTIONS(3713),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_unsafe] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_return] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_ref] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_delegate] = ACTIONS(3711),
    [anon_sym_record] = ACTIONS(3711),
    [anon_sym_abstract] = ACTIONS(3711),
    [anon_sym_async] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_fixed] = ACTIONS(3711),
    [anon_sym_internal] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_override] = ACTIONS(3711),
    [anon_sym_partial] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_readonly] = ACTIONS(3711),
    [anon_sym_required] = ACTIONS(3711),
    [anon_sym_sealed] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_checked] = ACTIONS(3711),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3713),
    [anon_sym_DASH_DASH] = ACTIONS(3713),
    [anon_sym_true] = ACTIONS(3711),
    [anon_sym_false] = ACTIONS(3711),
    [anon_sym_PLUS] = ACTIONS(3711),
    [anon_sym_DASH] = ACTIONS(3711),
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3713),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_this] = ACTIONS(3711),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_base] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [sym_predefined_type] = ACTIONS(3711),
    [anon_sym_break] = ACTIONS(3711),
    [anon_sym_unchecked] = ACTIONS(3711),
    [anon_sym_continue] = ACTIONS(3711),
    [anon_sym_do] = ACTIONS(3711),
    [anon_sym_while] = ACTIONS(3711),
    [anon_sym_for] = ACTIONS(3711),
    [anon_sym_lock] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_switch] = ACTIONS(3711),
    [anon_sym_default] = ACTIONS(3711),
    [anon_sym_throw] = ACTIONS(3711),
    [anon_sym_try] = ACTIONS(3711),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_await] = ACTIONS(3711),
    [anon_sym_foreach] = ACTIONS(3711),
    [anon_sym_goto] = ACTIONS(3711),
    [anon_sym_if] = ACTIONS(3711),
    [anon_sym_DOT_DOT] = ACTIONS(3713),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [anon_sym_DQUOTE] = ACTIONS(3713),
    [anon_sym_stackalloc] = ACTIONS(3711),
    [anon_sym_sizeof] = ACTIONS(3711),
    [anon_sym_typeof] = ACTIONS(3711),
    [anon_sym___makeref] = ACTIONS(3711),
    [anon_sym___reftype] = ACTIONS(3711),
    [anon_sym___refvalue] = ACTIONS(3711),
    [sym_null_literal] = ACTIONS(3711),
    [anon_sym_SQUOTE] = ACTIONS(3713),
    [sym_integer_literal] = ACTIONS(3711),
    [sym_real_literal] = ACTIONS(3713),
    [sym_verbatim_string_literal] = ACTIONS(3713),
    [aux_sym_preproc_if_token1] = ACTIONS(3713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3713),
    [sym_interpolation_verbatim_start] = ACTIONS(3713),
    [sym_interpolation_raw_start] = ACTIONS(3713),
    [sym_raw_string_start] = ACTIONS(3713),
  },
  [2587] = {
    [sym_preproc_region] = STATE(2587),
    [sym_preproc_endregion] = STATE(2587),
    [sym_preproc_line] = STATE(2587),
    [sym_preproc_pragma] = STATE(2587),
    [sym_preproc_nullable] = STATE(2587),
    [sym_preproc_error] = STATE(2587),
    [sym_preproc_define] = STATE(2587),
    [sym_preproc_undef] = STATE(2587),
    [ts_builtin_sym_end] = ACTIONS(3975),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3973),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_using] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3973),
    [anon_sym_static] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3975),
    [anon_sym_return] = ACTIONS(3973),
    [anon_sym_namespace] = ACTIONS(3973),
    [anon_sym_class] = ACTIONS(3973),
    [anon_sym_ref] = ACTIONS(3973),
    [anon_sym_struct] = ACTIONS(3973),
    [anon_sym_enum] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_interface] = ACTIONS(3973),
    [anon_sym_delegate] = ACTIONS(3973),
    [anon_sym_record] = ACTIONS(3973),
    [anon_sym_abstract] = ACTIONS(3973),
    [anon_sym_async] = ACTIONS(3973),
    [anon_sym_const] = ACTIONS(3973),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3973),
    [anon_sym_internal] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_override] = ACTIONS(3973),
    [anon_sym_partial] = ACTIONS(3973),
    [anon_sym_private] = ACTIONS(3973),
    [anon_sym_protected] = ACTIONS(3973),
    [anon_sym_public] = ACTIONS(3973),
    [anon_sym_readonly] = ACTIONS(3973),
    [anon_sym_required] = ACTIONS(3973),
    [anon_sym_sealed] = ACTIONS(3973),
    [anon_sym_virtual] = ACTIONS(3973),
    [anon_sym_volatile] = ACTIONS(3973),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_checked] = ACTIONS(3973),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_TILDE] = ACTIONS(3975),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_true] = ACTIONS(3973),
    [anon_sym_false] = ACTIONS(3973),
    [anon_sym_PLUS] = ACTIONS(3973),
    [anon_sym_DASH] = ACTIONS(3973),
    [anon_sym_STAR] = ACTIONS(3975),
    [anon_sym_CARET] = ACTIONS(3975),
    [anon_sym_AMP] = ACTIONS(3975),
    [anon_sym_this] = ACTIONS(3973),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_base] = ACTIONS(3973),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3973),
    [anon_sym_break] = ACTIONS(3973),
    [anon_sym_unchecked] = ACTIONS(3973),
    [anon_sym_continue] = ACTIONS(3973),
    [anon_sym_do] = ACTIONS(3973),
    [anon_sym_while] = ACTIONS(3973),
    [anon_sym_for] = ACTIONS(3973),
    [anon_sym_lock] = ACTIONS(3973),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_switch] = ACTIONS(3973),
    [anon_sym_default] = ACTIONS(3973),
    [anon_sym_throw] = ACTIONS(3973),
    [anon_sym_try] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_await] = ACTIONS(3973),
    [anon_sym_foreach] = ACTIONS(3973),
    [anon_sym_goto] = ACTIONS(3973),
    [anon_sym_if] = ACTIONS(3973),
    [anon_sym_DOT_DOT] = ACTIONS(3975),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_stackalloc] = ACTIONS(3973),
    [anon_sym_sizeof] = ACTIONS(3973),
    [anon_sym_typeof] = ACTIONS(3973),
    [anon_sym___makeref] = ACTIONS(3973),
    [anon_sym___reftype] = ACTIONS(3973),
    [anon_sym___refvalue] = ACTIONS(3973),
    [sym_null_literal] = ACTIONS(3973),
    [anon_sym_SQUOTE] = ACTIONS(3975),
    [sym_integer_literal] = ACTIONS(3973),
    [sym_real_literal] = ACTIONS(3975),
    [sym_verbatim_string_literal] = ACTIONS(3975),
    [aux_sym_preproc_if_token1] = ACTIONS(3975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3975),
    [sym_interpolation_verbatim_start] = ACTIONS(3975),
    [sym_interpolation_raw_start] = ACTIONS(3975),
    [sym_raw_string_start] = ACTIONS(3975),
  },
  [2588] = {
    [sym_preproc_region] = STATE(2588),
    [sym_preproc_endregion] = STATE(2588),
    [sym_preproc_line] = STATE(2588),
    [sym_preproc_pragma] = STATE(2588),
    [sym_preproc_nullable] = STATE(2588),
    [sym_preproc_error] = STATE(2588),
    [sym_preproc_define] = STATE(2588),
    [sym_preproc_undef] = STATE(2588),
    [ts_builtin_sym_end] = ACTIONS(3971),
    [sym__identifier_token] = ACTIONS(3969),
    [anon_sym_extern] = ACTIONS(3969),
    [anon_sym_alias] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3971),
    [anon_sym_global] = ACTIONS(3969),
    [anon_sym_using] = ACTIONS(3969),
    [anon_sym_unsafe] = ACTIONS(3969),
    [anon_sym_static] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_return] = ACTIONS(3969),
    [anon_sym_namespace] = ACTIONS(3969),
    [anon_sym_class] = ACTIONS(3969),
    [anon_sym_ref] = ACTIONS(3969),
    [anon_sym_struct] = ACTIONS(3969),
    [anon_sym_enum] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3969),
    [anon_sym_delegate] = ACTIONS(3969),
    [anon_sym_record] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_const] = ACTIONS(3969),
    [anon_sym_file] = ACTIONS(3969),
    [anon_sym_fixed] = ACTIONS(3969),
    [anon_sym_internal] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_override] = ACTIONS(3969),
    [anon_sym_partial] = ACTIONS(3969),
    [anon_sym_private] = ACTIONS(3969),
    [anon_sym_protected] = ACTIONS(3969),
    [anon_sym_public] = ACTIONS(3969),
    [anon_sym_readonly] = ACTIONS(3969),
    [anon_sym_required] = ACTIONS(3969),
    [anon_sym_sealed] = ACTIONS(3969),
    [anon_sym_virtual] = ACTIONS(3969),
    [anon_sym_volatile] = ACTIONS(3969),
    [anon_sym_where] = ACTIONS(3969),
    [anon_sym_notnull] = ACTIONS(3969),
    [anon_sym_unmanaged] = ACTIONS(3969),
    [anon_sym_checked] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3971),
    [anon_sym_TILDE] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [anon_sym_true] = ACTIONS(3969),
    [anon_sym_false] = ACTIONS(3969),
    [anon_sym_PLUS] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3969),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_AMP] = ACTIONS(3971),
    [anon_sym_this] = ACTIONS(3969),
    [anon_sym_scoped] = ACTIONS(3969),
    [anon_sym_base] = ACTIONS(3969),
    [anon_sym_var] = ACTIONS(3969),
    [sym_predefined_type] = ACTIONS(3969),
    [anon_sym_break] = ACTIONS(3969),
    [anon_sym_unchecked] = ACTIONS(3969),
    [anon_sym_continue] = ACTIONS(3969),
    [anon_sym_do] = ACTIONS(3969),
    [anon_sym_while] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_lock] = ACTIONS(3969),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_switch] = ACTIONS(3969),
    [anon_sym_default] = ACTIONS(3969),
    [anon_sym_throw] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3969),
    [anon_sym_when] = ACTIONS(3969),
    [anon_sym_await] = ACTIONS(3969),
    [anon_sym_foreach] = ACTIONS(3969),
    [anon_sym_goto] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_DOT_DOT] = ACTIONS(3971),
    [anon_sym_from] = ACTIONS(3969),
    [anon_sym_into] = ACTIONS(3969),
    [anon_sym_join] = ACTIONS(3969),
    [anon_sym_on] = ACTIONS(3969),
    [anon_sym_equals] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_orderby] = ACTIONS(3969),
    [anon_sym_ascending] = ACTIONS(3969),
    [anon_sym_descending] = ACTIONS(3969),
    [anon_sym_group] = ACTIONS(3969),
    [anon_sym_by] = ACTIONS(3969),
    [anon_sym_select] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3971),
    [anon_sym_stackalloc] = ACTIONS(3969),
    [anon_sym_sizeof] = ACTIONS(3969),
    [anon_sym_typeof] = ACTIONS(3969),
    [anon_sym___makeref] = ACTIONS(3969),
    [anon_sym___reftype] = ACTIONS(3969),
    [anon_sym___refvalue] = ACTIONS(3969),
    [sym_null_literal] = ACTIONS(3969),
    [anon_sym_SQUOTE] = ACTIONS(3971),
    [sym_integer_literal] = ACTIONS(3969),
    [sym_real_literal] = ACTIONS(3971),
    [sym_verbatim_string_literal] = ACTIONS(3971),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3971),
    [sym_interpolation_verbatim_start] = ACTIONS(3971),
    [sym_interpolation_raw_start] = ACTIONS(3971),
    [sym_raw_string_start] = ACTIONS(3971),
  },
  [2589] = {
    [sym_preproc_region] = STATE(2589),
    [sym_preproc_endregion] = STATE(2589),
    [sym_preproc_line] = STATE(2589),
    [sym_preproc_pragma] = STATE(2589),
    [sym_preproc_nullable] = STATE(2589),
    [sym_preproc_error] = STATE(2589),
    [sym_preproc_define] = STATE(2589),
    [sym_preproc_undef] = STATE(2589),
    [ts_builtin_sym_end] = ACTIONS(3967),
    [sym__identifier_token] = ACTIONS(3965),
    [anon_sym_extern] = ACTIONS(3965),
    [anon_sym_alias] = ACTIONS(3965),
    [anon_sym_SEMI] = ACTIONS(3967),
    [anon_sym_global] = ACTIONS(3965),
    [anon_sym_using] = ACTIONS(3965),
    [anon_sym_unsafe] = ACTIONS(3965),
    [anon_sym_static] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3965),
    [anon_sym_namespace] = ACTIONS(3965),
    [anon_sym_class] = ACTIONS(3965),
    [anon_sym_ref] = ACTIONS(3965),
    [anon_sym_struct] = ACTIONS(3965),
    [anon_sym_enum] = ACTIONS(3965),
    [anon_sym_LBRACE] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3965),
    [anon_sym_delegate] = ACTIONS(3965),
    [anon_sym_record] = ACTIONS(3965),
    [anon_sym_abstract] = ACTIONS(3965),
    [anon_sym_async] = ACTIONS(3965),
    [anon_sym_const] = ACTIONS(3965),
    [anon_sym_file] = ACTIONS(3965),
    [anon_sym_fixed] = ACTIONS(3965),
    [anon_sym_internal] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_override] = ACTIONS(3965),
    [anon_sym_partial] = ACTIONS(3965),
    [anon_sym_private] = ACTIONS(3965),
    [anon_sym_protected] = ACTIONS(3965),
    [anon_sym_public] = ACTIONS(3965),
    [anon_sym_readonly] = ACTIONS(3965),
    [anon_sym_required] = ACTIONS(3965),
    [anon_sym_sealed] = ACTIONS(3965),
    [anon_sym_virtual] = ACTIONS(3965),
    [anon_sym_volatile] = ACTIONS(3965),
    [anon_sym_where] = ACTIONS(3965),
    [anon_sym_notnull] = ACTIONS(3965),
    [anon_sym_unmanaged] = ACTIONS(3965),
    [anon_sym_checked] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_TILDE] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3967),
    [anon_sym_true] = ACTIONS(3965),
    [anon_sym_false] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(3965),
    [anon_sym_DASH] = ACTIONS(3965),
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3967),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_this] = ACTIONS(3965),
    [anon_sym_scoped] = ACTIONS(3965),
    [anon_sym_base] = ACTIONS(3965),
    [anon_sym_var] = ACTIONS(3965),
    [sym_predefined_type] = ACTIONS(3965),
    [anon_sym_break] = ACTIONS(3965),
    [anon_sym_unchecked] = ACTIONS(3965),
    [anon_sym_continue] = ACTIONS(3965),
    [anon_sym_do] = ACTIONS(3965),
    [anon_sym_while] = ACTIONS(3965),
    [anon_sym_for] = ACTIONS(3965),
    [anon_sym_lock] = ACTIONS(3965),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_switch] = ACTIONS(3965),
    [anon_sym_default] = ACTIONS(3965),
    [anon_sym_throw] = ACTIONS(3965),
    [anon_sym_try] = ACTIONS(3965),
    [anon_sym_when] = ACTIONS(3965),
    [anon_sym_await] = ACTIONS(3965),
    [anon_sym_foreach] = ACTIONS(3965),
    [anon_sym_goto] = ACTIONS(3965),
    [anon_sym_if] = ACTIONS(3965),
    [anon_sym_DOT_DOT] = ACTIONS(3967),
    [anon_sym_from] = ACTIONS(3965),
    [anon_sym_into] = ACTIONS(3965),
    [anon_sym_join] = ACTIONS(3965),
    [anon_sym_on] = ACTIONS(3965),
    [anon_sym_equals] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_orderby] = ACTIONS(3965),
    [anon_sym_ascending] = ACTIONS(3965),
    [anon_sym_descending] = ACTIONS(3965),
    [anon_sym_group] = ACTIONS(3965),
    [anon_sym_by] = ACTIONS(3965),
    [anon_sym_select] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(3967),
    [anon_sym_stackalloc] = ACTIONS(3965),
    [anon_sym_sizeof] = ACTIONS(3965),
    [anon_sym_typeof] = ACTIONS(3965),
    [anon_sym___makeref] = ACTIONS(3965),
    [anon_sym___reftype] = ACTIONS(3965),
    [anon_sym___refvalue] = ACTIONS(3965),
    [sym_null_literal] = ACTIONS(3965),
    [anon_sym_SQUOTE] = ACTIONS(3967),
    [sym_integer_literal] = ACTIONS(3965),
    [sym_real_literal] = ACTIONS(3967),
    [sym_verbatim_string_literal] = ACTIONS(3967),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3967),
    [sym_interpolation_verbatim_start] = ACTIONS(3967),
    [sym_interpolation_raw_start] = ACTIONS(3967),
    [sym_raw_string_start] = ACTIONS(3967),
  },
  [2590] = {
    [sym_preproc_region] = STATE(2590),
    [sym_preproc_endregion] = STATE(2590),
    [sym_preproc_line] = STATE(2590),
    [sym_preproc_pragma] = STATE(2590),
    [sym_preproc_nullable] = STATE(2590),
    [sym_preproc_error] = STATE(2590),
    [sym_preproc_define] = STATE(2590),
    [sym_preproc_undef] = STATE(2590),
    [ts_builtin_sym_end] = ACTIONS(3963),
    [sym__identifier_token] = ACTIONS(3961),
    [anon_sym_extern] = ACTIONS(3961),
    [anon_sym_alias] = ACTIONS(3961),
    [anon_sym_SEMI] = ACTIONS(3963),
    [anon_sym_global] = ACTIONS(3961),
    [anon_sym_using] = ACTIONS(3961),
    [anon_sym_unsafe] = ACTIONS(3961),
    [anon_sym_static] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_return] = ACTIONS(3961),
    [anon_sym_namespace] = ACTIONS(3961),
    [anon_sym_class] = ACTIONS(3961),
    [anon_sym_ref] = ACTIONS(3961),
    [anon_sym_struct] = ACTIONS(3961),
    [anon_sym_enum] = ACTIONS(3961),
    [anon_sym_LBRACE] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3961),
    [anon_sym_delegate] = ACTIONS(3961),
    [anon_sym_record] = ACTIONS(3961),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_async] = ACTIONS(3961),
    [anon_sym_const] = ACTIONS(3961),
    [anon_sym_file] = ACTIONS(3961),
    [anon_sym_fixed] = ACTIONS(3961),
    [anon_sym_internal] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_override] = ACTIONS(3961),
    [anon_sym_partial] = ACTIONS(3961),
    [anon_sym_private] = ACTIONS(3961),
    [anon_sym_protected] = ACTIONS(3961),
    [anon_sym_public] = ACTIONS(3961),
    [anon_sym_readonly] = ACTIONS(3961),
    [anon_sym_required] = ACTIONS(3961),
    [anon_sym_sealed] = ACTIONS(3961),
    [anon_sym_virtual] = ACTIONS(3961),
    [anon_sym_volatile] = ACTIONS(3961),
    [anon_sym_where] = ACTIONS(3961),
    [anon_sym_notnull] = ACTIONS(3961),
    [anon_sym_unmanaged] = ACTIONS(3961),
    [anon_sym_checked] = ACTIONS(3961),
    [anon_sym_BANG] = ACTIONS(3963),
    [anon_sym_TILDE] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3963),
    [anon_sym_DASH_DASH] = ACTIONS(3963),
    [anon_sym_true] = ACTIONS(3961),
    [anon_sym_false] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3961),
    [anon_sym_DASH] = ACTIONS(3961),
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3963),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_this] = ACTIONS(3961),
    [anon_sym_scoped] = ACTIONS(3961),
    [anon_sym_base] = ACTIONS(3961),
    [anon_sym_var] = ACTIONS(3961),
    [sym_predefined_type] = ACTIONS(3961),
    [anon_sym_break] = ACTIONS(3961),
    [anon_sym_unchecked] = ACTIONS(3961),
    [anon_sym_continue] = ACTIONS(3961),
    [anon_sym_do] = ACTIONS(3961),
    [anon_sym_while] = ACTIONS(3961),
    [anon_sym_for] = ACTIONS(3961),
    [anon_sym_lock] = ACTIONS(3961),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_switch] = ACTIONS(3961),
    [anon_sym_default] = ACTIONS(3961),
    [anon_sym_throw] = ACTIONS(3961),
    [anon_sym_try] = ACTIONS(3961),
    [anon_sym_when] = ACTIONS(3961),
    [anon_sym_await] = ACTIONS(3961),
    [anon_sym_foreach] = ACTIONS(3961),
    [anon_sym_goto] = ACTIONS(3961),
    [anon_sym_if] = ACTIONS(3961),
    [anon_sym_DOT_DOT] = ACTIONS(3963),
    [anon_sym_from] = ACTIONS(3961),
    [anon_sym_into] = ACTIONS(3961),
    [anon_sym_join] = ACTIONS(3961),
    [anon_sym_on] = ACTIONS(3961),
    [anon_sym_equals] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_orderby] = ACTIONS(3961),
    [anon_sym_ascending] = ACTIONS(3961),
    [anon_sym_descending] = ACTIONS(3961),
    [anon_sym_group] = ACTIONS(3961),
    [anon_sym_by] = ACTIONS(3961),
    [anon_sym_select] = ACTIONS(3961),
    [anon_sym_DQUOTE] = ACTIONS(3963),
    [anon_sym_stackalloc] = ACTIONS(3961),
    [anon_sym_sizeof] = ACTIONS(3961),
    [anon_sym_typeof] = ACTIONS(3961),
    [anon_sym___makeref] = ACTIONS(3961),
    [anon_sym___reftype] = ACTIONS(3961),
    [anon_sym___refvalue] = ACTIONS(3961),
    [sym_null_literal] = ACTIONS(3961),
    [anon_sym_SQUOTE] = ACTIONS(3963),
    [sym_integer_literal] = ACTIONS(3961),
    [sym_real_literal] = ACTIONS(3963),
    [sym_verbatim_string_literal] = ACTIONS(3963),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3963),
    [sym_interpolation_verbatim_start] = ACTIONS(3963),
    [sym_interpolation_raw_start] = ACTIONS(3963),
    [sym_raw_string_start] = ACTIONS(3963),
  },
  [2591] = {
    [sym_preproc_region] = STATE(2591),
    [sym_preproc_endregion] = STATE(2591),
    [sym_preproc_line] = STATE(2591),
    [sym_preproc_pragma] = STATE(2591),
    [sym_preproc_nullable] = STATE(2591),
    [sym_preproc_error] = STATE(2591),
    [sym_preproc_define] = STATE(2591),
    [sym_preproc_undef] = STATE(2591),
    [ts_builtin_sym_end] = ACTIONS(3951),
    [sym__identifier_token] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym_alias] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym_global] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_unsafe] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3951),
    [anon_sym_return] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_ref] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_LBRACE] = ACTIONS(3951),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_delegate] = ACTIONS(3949),
    [anon_sym_record] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3949),
    [anon_sym_async] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3949),
    [anon_sym_fixed] = ACTIONS(3949),
    [anon_sym_internal] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_override] = ACTIONS(3949),
    [anon_sym_partial] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_readonly] = ACTIONS(3949),
    [anon_sym_required] = ACTIONS(3949),
    [anon_sym_sealed] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_where] = ACTIONS(3949),
    [anon_sym_notnull] = ACTIONS(3949),
    [anon_sym_unmanaged] = ACTIONS(3949),
    [anon_sym_checked] = ACTIONS(3949),
    [anon_sym_BANG] = ACTIONS(3951),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_PLUS_PLUS] = ACTIONS(3951),
    [anon_sym_DASH_DASH] = ACTIONS(3951),
    [anon_sym_true] = ACTIONS(3949),
    [anon_sym_false] = ACTIONS(3949),
    [anon_sym_PLUS] = ACTIONS(3949),
    [anon_sym_DASH] = ACTIONS(3949),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_CARET] = ACTIONS(3951),
    [anon_sym_AMP] = ACTIONS(3951),
    [anon_sym_this] = ACTIONS(3949),
    [anon_sym_scoped] = ACTIONS(3949),
    [anon_sym_base] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3949),
    [sym_predefined_type] = ACTIONS(3949),
    [anon_sym_break] = ACTIONS(3949),
    [anon_sym_unchecked] = ACTIONS(3949),
    [anon_sym_continue] = ACTIONS(3949),
    [anon_sym_do] = ACTIONS(3949),
    [anon_sym_while] = ACTIONS(3949),
    [anon_sym_for] = ACTIONS(3949),
    [anon_sym_lock] = ACTIONS(3949),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_switch] = ACTIONS(3949),
    [anon_sym_default] = ACTIONS(3949),
    [anon_sym_throw] = ACTIONS(3949),
    [anon_sym_try] = ACTIONS(3949),
    [anon_sym_when] = ACTIONS(3949),
    [anon_sym_await] = ACTIONS(3949),
    [anon_sym_foreach] = ACTIONS(3949),
    [anon_sym_goto] = ACTIONS(3949),
    [anon_sym_if] = ACTIONS(3949),
    [anon_sym_DOT_DOT] = ACTIONS(3951),
    [anon_sym_from] = ACTIONS(3949),
    [anon_sym_into] = ACTIONS(3949),
    [anon_sym_join] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_orderby] = ACTIONS(3949),
    [anon_sym_ascending] = ACTIONS(3949),
    [anon_sym_descending] = ACTIONS(3949),
    [anon_sym_group] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_select] = ACTIONS(3949),
    [anon_sym_DQUOTE] = ACTIONS(3951),
    [anon_sym_stackalloc] = ACTIONS(3949),
    [anon_sym_sizeof] = ACTIONS(3949),
    [anon_sym_typeof] = ACTIONS(3949),
    [anon_sym___makeref] = ACTIONS(3949),
    [anon_sym___reftype] = ACTIONS(3949),
    [anon_sym___refvalue] = ACTIONS(3949),
    [sym_null_literal] = ACTIONS(3949),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [sym_integer_literal] = ACTIONS(3949),
    [sym_real_literal] = ACTIONS(3951),
    [sym_verbatim_string_literal] = ACTIONS(3951),
    [aux_sym_preproc_if_token1] = ACTIONS(3951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3951),
    [sym_interpolation_verbatim_start] = ACTIONS(3951),
    [sym_interpolation_raw_start] = ACTIONS(3951),
    [sym_raw_string_start] = ACTIONS(3951),
  },
  [2592] = {
    [sym_preproc_region] = STATE(2592),
    [sym_preproc_endregion] = STATE(2592),
    [sym_preproc_line] = STATE(2592),
    [sym_preproc_pragma] = STATE(2592),
    [sym_preproc_nullable] = STATE(2592),
    [sym_preproc_error] = STATE(2592),
    [sym_preproc_define] = STATE(2592),
    [sym_preproc_undef] = STATE(2592),
    [ts_builtin_sym_end] = ACTIONS(3947),
    [sym__identifier_token] = ACTIONS(3945),
    [anon_sym_extern] = ACTIONS(3945),
    [anon_sym_alias] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3947),
    [anon_sym_global] = ACTIONS(3945),
    [anon_sym_using] = ACTIONS(3945),
    [anon_sym_unsafe] = ACTIONS(3945),
    [anon_sym_static] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3947),
    [anon_sym_return] = ACTIONS(3945),
    [anon_sym_namespace] = ACTIONS(3945),
    [anon_sym_class] = ACTIONS(3945),
    [anon_sym_ref] = ACTIONS(3945),
    [anon_sym_struct] = ACTIONS(3945),
    [anon_sym_enum] = ACTIONS(3945),
    [anon_sym_LBRACE] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(3945),
    [anon_sym_delegate] = ACTIONS(3945),
    [anon_sym_record] = ACTIONS(3945),
    [anon_sym_abstract] = ACTIONS(3945),
    [anon_sym_async] = ACTIONS(3945),
    [anon_sym_const] = ACTIONS(3945),
    [anon_sym_file] = ACTIONS(3945),
    [anon_sym_fixed] = ACTIONS(3945),
    [anon_sym_internal] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_override] = ACTIONS(3945),
    [anon_sym_partial] = ACTIONS(3945),
    [anon_sym_private] = ACTIONS(3945),
    [anon_sym_protected] = ACTIONS(3945),
    [anon_sym_public] = ACTIONS(3945),
    [anon_sym_readonly] = ACTIONS(3945),
    [anon_sym_required] = ACTIONS(3945),
    [anon_sym_sealed] = ACTIONS(3945),
    [anon_sym_virtual] = ACTIONS(3945),
    [anon_sym_volatile] = ACTIONS(3945),
    [anon_sym_where] = ACTIONS(3945),
    [anon_sym_notnull] = ACTIONS(3945),
    [anon_sym_unmanaged] = ACTIONS(3945),
    [anon_sym_checked] = ACTIONS(3945),
    [anon_sym_BANG] = ACTIONS(3947),
    [anon_sym_TILDE] = ACTIONS(3947),
    [anon_sym_PLUS_PLUS] = ACTIONS(3947),
    [anon_sym_DASH_DASH] = ACTIONS(3947),
    [anon_sym_true] = ACTIONS(3945),
    [anon_sym_false] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(3945),
    [anon_sym_DASH] = ACTIONS(3945),
    [anon_sym_STAR] = ACTIONS(3947),
    [anon_sym_CARET] = ACTIONS(3947),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_this] = ACTIONS(3945),
    [anon_sym_scoped] = ACTIONS(3945),
    [anon_sym_base] = ACTIONS(3945),
    [anon_sym_var] = ACTIONS(3945),
    [sym_predefined_type] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3945),
    [anon_sym_unchecked] = ACTIONS(3945),
    [anon_sym_continue] = ACTIONS(3945),
    [anon_sym_do] = ACTIONS(3945),
    [anon_sym_while] = ACTIONS(3945),
    [anon_sym_for] = ACTIONS(3945),
    [anon_sym_lock] = ACTIONS(3945),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_switch] = ACTIONS(3945),
    [anon_sym_default] = ACTIONS(3945),
    [anon_sym_throw] = ACTIONS(3945),
    [anon_sym_try] = ACTIONS(3945),
    [anon_sym_when] = ACTIONS(3945),
    [anon_sym_await] = ACTIONS(3945),
    [anon_sym_foreach] = ACTIONS(3945),
    [anon_sym_goto] = ACTIONS(3945),
    [anon_sym_if] = ACTIONS(3945),
    [anon_sym_DOT_DOT] = ACTIONS(3947),
    [anon_sym_from] = ACTIONS(3945),
    [anon_sym_into] = ACTIONS(3945),
    [anon_sym_join] = ACTIONS(3945),
    [anon_sym_on] = ACTIONS(3945),
    [anon_sym_equals] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_orderby] = ACTIONS(3945),
    [anon_sym_ascending] = ACTIONS(3945),
    [anon_sym_descending] = ACTIONS(3945),
    [anon_sym_group] = ACTIONS(3945),
    [anon_sym_by] = ACTIONS(3945),
    [anon_sym_select] = ACTIONS(3945),
    [anon_sym_DQUOTE] = ACTIONS(3947),
    [anon_sym_stackalloc] = ACTIONS(3945),
    [anon_sym_sizeof] = ACTIONS(3945),
    [anon_sym_typeof] = ACTIONS(3945),
    [anon_sym___makeref] = ACTIONS(3945),
    [anon_sym___reftype] = ACTIONS(3945),
    [anon_sym___refvalue] = ACTIONS(3945),
    [sym_null_literal] = ACTIONS(3945),
    [anon_sym_SQUOTE] = ACTIONS(3947),
    [sym_integer_literal] = ACTIONS(3945),
    [sym_real_literal] = ACTIONS(3947),
    [sym_verbatim_string_literal] = ACTIONS(3947),
    [aux_sym_preproc_if_token1] = ACTIONS(3947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3947),
    [sym_interpolation_verbatim_start] = ACTIONS(3947),
    [sym_interpolation_raw_start] = ACTIONS(3947),
    [sym_raw_string_start] = ACTIONS(3947),
  },
  [2593] = {
    [sym_preproc_region] = STATE(2593),
    [sym_preproc_endregion] = STATE(2593),
    [sym_preproc_line] = STATE(2593),
    [sym_preproc_pragma] = STATE(2593),
    [sym_preproc_nullable] = STATE(2593),
    [sym_preproc_error] = STATE(2593),
    [sym_preproc_define] = STATE(2593),
    [sym_preproc_undef] = STATE(2593),
    [ts_builtin_sym_end] = ACTIONS(3841),
    [sym__identifier_token] = ACTIONS(3839),
    [anon_sym_extern] = ACTIONS(3839),
    [anon_sym_alias] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3841),
    [anon_sym_global] = ACTIONS(3839),
    [anon_sym_using] = ACTIONS(3839),
    [anon_sym_unsafe] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_return] = ACTIONS(3839),
    [anon_sym_namespace] = ACTIONS(3839),
    [anon_sym_class] = ACTIONS(3839),
    [anon_sym_ref] = ACTIONS(3839),
    [anon_sym_struct] = ACTIONS(3839),
    [anon_sym_enum] = ACTIONS(3839),
    [anon_sym_LBRACE] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3839),
    [anon_sym_delegate] = ACTIONS(3839),
    [anon_sym_record] = ACTIONS(3839),
    [anon_sym_abstract] = ACTIONS(3839),
    [anon_sym_async] = ACTIONS(3839),
    [anon_sym_const] = ACTIONS(3839),
    [anon_sym_file] = ACTIONS(3839),
    [anon_sym_fixed] = ACTIONS(3839),
    [anon_sym_internal] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3839),
    [anon_sym_override] = ACTIONS(3839),
    [anon_sym_partial] = ACTIONS(3839),
    [anon_sym_private] = ACTIONS(3839),
    [anon_sym_protected] = ACTIONS(3839),
    [anon_sym_public] = ACTIONS(3839),
    [anon_sym_readonly] = ACTIONS(3839),
    [anon_sym_required] = ACTIONS(3839),
    [anon_sym_sealed] = ACTIONS(3839),
    [anon_sym_virtual] = ACTIONS(3839),
    [anon_sym_volatile] = ACTIONS(3839),
    [anon_sym_where] = ACTIONS(3839),
    [anon_sym_notnull] = ACTIONS(3839),
    [anon_sym_unmanaged] = ACTIONS(3839),
    [anon_sym_checked] = ACTIONS(3839),
    [anon_sym_BANG] = ACTIONS(3841),
    [anon_sym_TILDE] = ACTIONS(3841),
    [anon_sym_PLUS_PLUS] = ACTIONS(3841),
    [anon_sym_DASH_DASH] = ACTIONS(3841),
    [anon_sym_true] = ACTIONS(3839),
    [anon_sym_false] = ACTIONS(3839),
    [anon_sym_PLUS] = ACTIONS(3839),
    [anon_sym_DASH] = ACTIONS(3839),
    [anon_sym_STAR] = ACTIONS(3841),
    [anon_sym_CARET] = ACTIONS(3841),
    [anon_sym_AMP] = ACTIONS(3841),
    [anon_sym_this] = ACTIONS(3839),
    [anon_sym_scoped] = ACTIONS(3839),
    [anon_sym_base] = ACTIONS(3839),
    [anon_sym_var] = ACTIONS(3839),
    [sym_predefined_type] = ACTIONS(3839),
    [anon_sym_break] = ACTIONS(3839),
    [anon_sym_unchecked] = ACTIONS(3839),
    [anon_sym_continue] = ACTIONS(3839),
    [anon_sym_do] = ACTIONS(3839),
    [anon_sym_while] = ACTIONS(3839),
    [anon_sym_for] = ACTIONS(3839),
    [anon_sym_lock] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3839),
    [anon_sym_switch] = ACTIONS(3839),
    [anon_sym_default] = ACTIONS(3839),
    [anon_sym_throw] = ACTIONS(3839),
    [anon_sym_try] = ACTIONS(3839),
    [anon_sym_when] = ACTIONS(3839),
    [anon_sym_await] = ACTIONS(3839),
    [anon_sym_foreach] = ACTIONS(3839),
    [anon_sym_goto] = ACTIONS(3839),
    [anon_sym_if] = ACTIONS(3839),
    [anon_sym_DOT_DOT] = ACTIONS(3841),
    [anon_sym_from] = ACTIONS(3839),
    [anon_sym_into] = ACTIONS(3839),
    [anon_sym_join] = ACTIONS(3839),
    [anon_sym_on] = ACTIONS(3839),
    [anon_sym_equals] = ACTIONS(3839),
    [anon_sym_let] = ACTIONS(3839),
    [anon_sym_orderby] = ACTIONS(3839),
    [anon_sym_ascending] = ACTIONS(3839),
    [anon_sym_descending] = ACTIONS(3839),
    [anon_sym_group] = ACTIONS(3839),
    [anon_sym_by] = ACTIONS(3839),
    [anon_sym_select] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(3841),
    [anon_sym_stackalloc] = ACTIONS(3839),
    [anon_sym_sizeof] = ACTIONS(3839),
    [anon_sym_typeof] = ACTIONS(3839),
    [anon_sym___makeref] = ACTIONS(3839),
    [anon_sym___reftype] = ACTIONS(3839),
    [anon_sym___refvalue] = ACTIONS(3839),
    [sym_null_literal] = ACTIONS(3839),
    [anon_sym_SQUOTE] = ACTIONS(3841),
    [sym_integer_literal] = ACTIONS(3839),
    [sym_real_literal] = ACTIONS(3841),
    [sym_verbatim_string_literal] = ACTIONS(3841),
    [aux_sym_preproc_if_token1] = ACTIONS(3841),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3841),
    [sym_interpolation_verbatim_start] = ACTIONS(3841),
    [sym_interpolation_raw_start] = ACTIONS(3841),
    [sym_raw_string_start] = ACTIONS(3841),
  },
  [2594] = {
    [sym_preproc_region] = STATE(2594),
    [sym_preproc_endregion] = STATE(2594),
    [sym_preproc_line] = STATE(2594),
    [sym_preproc_pragma] = STATE(2594),
    [sym_preproc_nullable] = STATE(2594),
    [sym_preproc_error] = STATE(2594),
    [sym_preproc_define] = STATE(2594),
    [sym_preproc_undef] = STATE(2594),
    [ts_builtin_sym_end] = ACTIONS(3745),
    [sym__identifier_token] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_unsafe] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_ref] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_delegate] = ACTIONS(3743),
    [anon_sym_record] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_fixed] = ACTIONS(3743),
    [anon_sym_internal] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_partial] = ACTIONS(3743),
    [anon_sym_private] = ACTIONS(3743),
    [anon_sym_protected] = ACTIONS(3743),
    [anon_sym_public] = ACTIONS(3743),
    [anon_sym_readonly] = ACTIONS(3743),
    [anon_sym_required] = ACTIONS(3743),
    [anon_sym_sealed] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_checked] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_PLUS_PLUS] = ACTIONS(3745),
    [anon_sym_DASH_DASH] = ACTIONS(3745),
    [anon_sym_true] = ACTIONS(3743),
    [anon_sym_false] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3745),
    [anon_sym_CARET] = ACTIONS(3745),
    [anon_sym_AMP] = ACTIONS(3745),
    [anon_sym_this] = ACTIONS(3743),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_base] = ACTIONS(3743),
    [anon_sym_var] = ACTIONS(3743),
    [sym_predefined_type] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_unchecked] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_lock] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_when] = ACTIONS(3743),
    [anon_sym_await] = ACTIONS(3743),
    [anon_sym_foreach] = ACTIONS(3743),
    [anon_sym_goto] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_DOT_DOT] = ACTIONS(3745),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3745),
    [anon_sym_stackalloc] = ACTIONS(3743),
    [anon_sym_sizeof] = ACTIONS(3743),
    [anon_sym_typeof] = ACTIONS(3743),
    [anon_sym___makeref] = ACTIONS(3743),
    [anon_sym___reftype] = ACTIONS(3743),
    [anon_sym___refvalue] = ACTIONS(3743),
    [sym_null_literal] = ACTIONS(3743),
    [anon_sym_SQUOTE] = ACTIONS(3745),
    [sym_integer_literal] = ACTIONS(3743),
    [sym_real_literal] = ACTIONS(3745),
    [sym_verbatim_string_literal] = ACTIONS(3745),
    [aux_sym_preproc_if_token1] = ACTIONS(3745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3745),
    [sym_interpolation_verbatim_start] = ACTIONS(3745),
    [sym_interpolation_raw_start] = ACTIONS(3745),
    [sym_raw_string_start] = ACTIONS(3745),
  },
  [2595] = {
    [sym_preproc_region] = STATE(2595),
    [sym_preproc_endregion] = STATE(2595),
    [sym_preproc_line] = STATE(2595),
    [sym_preproc_pragma] = STATE(2595),
    [sym_preproc_nullable] = STATE(2595),
    [sym_preproc_error] = STATE(2595),
    [sym_preproc_define] = STATE(2595),
    [sym_preproc_undef] = STATE(2595),
    [ts_builtin_sym_end] = ACTIONS(3789),
    [sym__identifier_token] = ACTIONS(3787),
    [anon_sym_extern] = ACTIONS(3787),
    [anon_sym_alias] = ACTIONS(3787),
    [anon_sym_SEMI] = ACTIONS(3789),
    [anon_sym_global] = ACTIONS(3787),
    [anon_sym_using] = ACTIONS(3787),
    [anon_sym_unsafe] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_LPAREN] = ACTIONS(3789),
    [anon_sym_return] = ACTIONS(3787),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_class] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3787),
    [anon_sym_struct] = ACTIONS(3787),
    [anon_sym_enum] = ACTIONS(3787),
    [anon_sym_LBRACE] = ACTIONS(3789),
    [anon_sym_interface] = ACTIONS(3787),
    [anon_sym_delegate] = ACTIONS(3787),
    [anon_sym_record] = ACTIONS(3787),
    [anon_sym_abstract] = ACTIONS(3787),
    [anon_sym_async] = ACTIONS(3787),
    [anon_sym_const] = ACTIONS(3787),
    [anon_sym_file] = ACTIONS(3787),
    [anon_sym_fixed] = ACTIONS(3787),
    [anon_sym_internal] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(3787),
    [anon_sym_override] = ACTIONS(3787),
    [anon_sym_partial] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3787),
    [anon_sym_protected] = ACTIONS(3787),
    [anon_sym_public] = ACTIONS(3787),
    [anon_sym_readonly] = ACTIONS(3787),
    [anon_sym_required] = ACTIONS(3787),
    [anon_sym_sealed] = ACTIONS(3787),
    [anon_sym_virtual] = ACTIONS(3787),
    [anon_sym_volatile] = ACTIONS(3787),
    [anon_sym_where] = ACTIONS(3787),
    [anon_sym_notnull] = ACTIONS(3787),
    [anon_sym_unmanaged] = ACTIONS(3787),
    [anon_sym_checked] = ACTIONS(3787),
    [anon_sym_BANG] = ACTIONS(3789),
    [anon_sym_TILDE] = ACTIONS(3789),
    [anon_sym_PLUS_PLUS] = ACTIONS(3789),
    [anon_sym_DASH_DASH] = ACTIONS(3789),
    [anon_sym_true] = ACTIONS(3787),
    [anon_sym_false] = ACTIONS(3787),
    [anon_sym_PLUS] = ACTIONS(3787),
    [anon_sym_DASH] = ACTIONS(3787),
    [anon_sym_STAR] = ACTIONS(3789),
    [anon_sym_CARET] = ACTIONS(3789),
    [anon_sym_AMP] = ACTIONS(3789),
    [anon_sym_this] = ACTIONS(3787),
    [anon_sym_scoped] = ACTIONS(3787),
    [anon_sym_base] = ACTIONS(3787),
    [anon_sym_var] = ACTIONS(3787),
    [sym_predefined_type] = ACTIONS(3787),
    [anon_sym_break] = ACTIONS(3787),
    [anon_sym_unchecked] = ACTIONS(3787),
    [anon_sym_continue] = ACTIONS(3787),
    [anon_sym_do] = ACTIONS(3787),
    [anon_sym_while] = ACTIONS(3787),
    [anon_sym_for] = ACTIONS(3787),
    [anon_sym_lock] = ACTIONS(3787),
    [anon_sym_yield] = ACTIONS(3787),
    [anon_sym_switch] = ACTIONS(3787),
    [anon_sym_default] = ACTIONS(3787),
    [anon_sym_throw] = ACTIONS(3787),
    [anon_sym_try] = ACTIONS(3787),
    [anon_sym_when] = ACTIONS(3787),
    [anon_sym_await] = ACTIONS(3787),
    [anon_sym_foreach] = ACTIONS(3787),
    [anon_sym_goto] = ACTIONS(3787),
    [anon_sym_if] = ACTIONS(3787),
    [anon_sym_DOT_DOT] = ACTIONS(3789),
    [anon_sym_from] = ACTIONS(3787),
    [anon_sym_into] = ACTIONS(3787),
    [anon_sym_join] = ACTIONS(3787),
    [anon_sym_on] = ACTIONS(3787),
    [anon_sym_equals] = ACTIONS(3787),
    [anon_sym_let] = ACTIONS(3787),
    [anon_sym_orderby] = ACTIONS(3787),
    [anon_sym_ascending] = ACTIONS(3787),
    [anon_sym_descending] = ACTIONS(3787),
    [anon_sym_group] = ACTIONS(3787),
    [anon_sym_by] = ACTIONS(3787),
    [anon_sym_select] = ACTIONS(3787),
    [anon_sym_DQUOTE] = ACTIONS(3789),
    [anon_sym_stackalloc] = ACTIONS(3787),
    [anon_sym_sizeof] = ACTIONS(3787),
    [anon_sym_typeof] = ACTIONS(3787),
    [anon_sym___makeref] = ACTIONS(3787),
    [anon_sym___reftype] = ACTIONS(3787),
    [anon_sym___refvalue] = ACTIONS(3787),
    [sym_null_literal] = ACTIONS(3787),
    [anon_sym_SQUOTE] = ACTIONS(3789),
    [sym_integer_literal] = ACTIONS(3787),
    [sym_real_literal] = ACTIONS(3789),
    [sym_verbatim_string_literal] = ACTIONS(3789),
    [aux_sym_preproc_if_token1] = ACTIONS(3789),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3789),
    [sym_interpolation_verbatim_start] = ACTIONS(3789),
    [sym_interpolation_raw_start] = ACTIONS(3789),
    [sym_raw_string_start] = ACTIONS(3789),
  },
  [2596] = {
    [sym_preproc_region] = STATE(2596),
    [sym_preproc_endregion] = STATE(2596),
    [sym_preproc_line] = STATE(2596),
    [sym_preproc_pragma] = STATE(2596),
    [sym_preproc_nullable] = STATE(2596),
    [sym_preproc_error] = STATE(2596),
    [sym_preproc_define] = STATE(2596),
    [sym_preproc_undef] = STATE(2596),
    [ts_builtin_sym_end] = ACTIONS(3833),
    [sym__identifier_token] = ACTIONS(3831),
    [anon_sym_extern] = ACTIONS(3831),
    [anon_sym_alias] = ACTIONS(3831),
    [anon_sym_SEMI] = ACTIONS(3833),
    [anon_sym_global] = ACTIONS(3831),
    [anon_sym_using] = ACTIONS(3831),
    [anon_sym_unsafe] = ACTIONS(3831),
    [anon_sym_static] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LPAREN] = ACTIONS(3833),
    [anon_sym_return] = ACTIONS(3831),
    [anon_sym_namespace] = ACTIONS(3831),
    [anon_sym_class] = ACTIONS(3831),
    [anon_sym_ref] = ACTIONS(3831),
    [anon_sym_struct] = ACTIONS(3831),
    [anon_sym_enum] = ACTIONS(3831),
    [anon_sym_LBRACE] = ACTIONS(3833),
    [anon_sym_interface] = ACTIONS(3831),
    [anon_sym_delegate] = ACTIONS(3831),
    [anon_sym_record] = ACTIONS(3831),
    [anon_sym_abstract] = ACTIONS(3831),
    [anon_sym_async] = ACTIONS(3831),
    [anon_sym_const] = ACTIONS(3831),
    [anon_sym_file] = ACTIONS(3831),
    [anon_sym_fixed] = ACTIONS(3831),
    [anon_sym_internal] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3831),
    [anon_sym_override] = ACTIONS(3831),
    [anon_sym_partial] = ACTIONS(3831),
    [anon_sym_private] = ACTIONS(3831),
    [anon_sym_protected] = ACTIONS(3831),
    [anon_sym_public] = ACTIONS(3831),
    [anon_sym_readonly] = ACTIONS(3831),
    [anon_sym_required] = ACTIONS(3831),
    [anon_sym_sealed] = ACTIONS(3831),
    [anon_sym_virtual] = ACTIONS(3831),
    [anon_sym_volatile] = ACTIONS(3831),
    [anon_sym_where] = ACTIONS(3831),
    [anon_sym_notnull] = ACTIONS(3831),
    [anon_sym_unmanaged] = ACTIONS(3831),
    [anon_sym_checked] = ACTIONS(3831),
    [anon_sym_BANG] = ACTIONS(3833),
    [anon_sym_TILDE] = ACTIONS(3833),
    [anon_sym_PLUS_PLUS] = ACTIONS(3833),
    [anon_sym_DASH_DASH] = ACTIONS(3833),
    [anon_sym_true] = ACTIONS(3831),
    [anon_sym_false] = ACTIONS(3831),
    [anon_sym_PLUS] = ACTIONS(3831),
    [anon_sym_DASH] = ACTIONS(3831),
    [anon_sym_STAR] = ACTIONS(3833),
    [anon_sym_CARET] = ACTIONS(3833),
    [anon_sym_AMP] = ACTIONS(3833),
    [anon_sym_this] = ACTIONS(3831),
    [anon_sym_scoped] = ACTIONS(3831),
    [anon_sym_base] = ACTIONS(3831),
    [anon_sym_var] = ACTIONS(3831),
    [sym_predefined_type] = ACTIONS(3831),
    [anon_sym_break] = ACTIONS(3831),
    [anon_sym_unchecked] = ACTIONS(3831),
    [anon_sym_continue] = ACTIONS(3831),
    [anon_sym_do] = ACTIONS(3831),
    [anon_sym_while] = ACTIONS(3831),
    [anon_sym_for] = ACTIONS(3831),
    [anon_sym_lock] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3831),
    [anon_sym_switch] = ACTIONS(3831),
    [anon_sym_default] = ACTIONS(3831),
    [anon_sym_throw] = ACTIONS(3831),
    [anon_sym_try] = ACTIONS(3831),
    [anon_sym_when] = ACTIONS(3831),
    [anon_sym_await] = ACTIONS(3831),
    [anon_sym_foreach] = ACTIONS(3831),
    [anon_sym_goto] = ACTIONS(3831),
    [anon_sym_if] = ACTIONS(3831),
    [anon_sym_DOT_DOT] = ACTIONS(3833),
    [anon_sym_from] = ACTIONS(3831),
    [anon_sym_into] = ACTIONS(3831),
    [anon_sym_join] = ACTIONS(3831),
    [anon_sym_on] = ACTIONS(3831),
    [anon_sym_equals] = ACTIONS(3831),
    [anon_sym_let] = ACTIONS(3831),
    [anon_sym_orderby] = ACTIONS(3831),
    [anon_sym_ascending] = ACTIONS(3831),
    [anon_sym_descending] = ACTIONS(3831),
    [anon_sym_group] = ACTIONS(3831),
    [anon_sym_by] = ACTIONS(3831),
    [anon_sym_select] = ACTIONS(3831),
    [anon_sym_DQUOTE] = ACTIONS(3833),
    [anon_sym_stackalloc] = ACTIONS(3831),
    [anon_sym_sizeof] = ACTIONS(3831),
    [anon_sym_typeof] = ACTIONS(3831),
    [anon_sym___makeref] = ACTIONS(3831),
    [anon_sym___reftype] = ACTIONS(3831),
    [anon_sym___refvalue] = ACTIONS(3831),
    [sym_null_literal] = ACTIONS(3831),
    [anon_sym_SQUOTE] = ACTIONS(3833),
    [sym_integer_literal] = ACTIONS(3831),
    [sym_real_literal] = ACTIONS(3833),
    [sym_verbatim_string_literal] = ACTIONS(3833),
    [aux_sym_preproc_if_token1] = ACTIONS(3833),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3833),
    [sym_interpolation_verbatim_start] = ACTIONS(3833),
    [sym_interpolation_raw_start] = ACTIONS(3833),
    [sym_raw_string_start] = ACTIONS(3833),
  },
  [2597] = {
    [sym_preproc_region] = STATE(2597),
    [sym_preproc_endregion] = STATE(2597),
    [sym_preproc_line] = STATE(2597),
    [sym_preproc_pragma] = STATE(2597),
    [sym_preproc_nullable] = STATE(2597),
    [sym_preproc_error] = STATE(2597),
    [sym_preproc_define] = STATE(2597),
    [sym_preproc_undef] = STATE(2597),
    [ts_builtin_sym_end] = ACTIONS(3829),
    [sym__identifier_token] = ACTIONS(3827),
    [anon_sym_extern] = ACTIONS(3827),
    [anon_sym_alias] = ACTIONS(3827),
    [anon_sym_SEMI] = ACTIONS(3829),
    [anon_sym_global] = ACTIONS(3827),
    [anon_sym_using] = ACTIONS(3827),
    [anon_sym_unsafe] = ACTIONS(3827),
    [anon_sym_static] = ACTIONS(3827),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_return] = ACTIONS(3827),
    [anon_sym_namespace] = ACTIONS(3827),
    [anon_sym_class] = ACTIONS(3827),
    [anon_sym_ref] = ACTIONS(3827),
    [anon_sym_struct] = ACTIONS(3827),
    [anon_sym_enum] = ACTIONS(3827),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_interface] = ACTIONS(3827),
    [anon_sym_delegate] = ACTIONS(3827),
    [anon_sym_record] = ACTIONS(3827),
    [anon_sym_abstract] = ACTIONS(3827),
    [anon_sym_async] = ACTIONS(3827),
    [anon_sym_const] = ACTIONS(3827),
    [anon_sym_file] = ACTIONS(3827),
    [anon_sym_fixed] = ACTIONS(3827),
    [anon_sym_internal] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3827),
    [anon_sym_override] = ACTIONS(3827),
    [anon_sym_partial] = ACTIONS(3827),
    [anon_sym_private] = ACTIONS(3827),
    [anon_sym_protected] = ACTIONS(3827),
    [anon_sym_public] = ACTIONS(3827),
    [anon_sym_readonly] = ACTIONS(3827),
    [anon_sym_required] = ACTIONS(3827),
    [anon_sym_sealed] = ACTIONS(3827),
    [anon_sym_virtual] = ACTIONS(3827),
    [anon_sym_volatile] = ACTIONS(3827),
    [anon_sym_where] = ACTIONS(3827),
    [anon_sym_notnull] = ACTIONS(3827),
    [anon_sym_unmanaged] = ACTIONS(3827),
    [anon_sym_checked] = ACTIONS(3827),
    [anon_sym_BANG] = ACTIONS(3829),
    [anon_sym_TILDE] = ACTIONS(3829),
    [anon_sym_PLUS_PLUS] = ACTIONS(3829),
    [anon_sym_DASH_DASH] = ACTIONS(3829),
    [anon_sym_true] = ACTIONS(3827),
    [anon_sym_false] = ACTIONS(3827),
    [anon_sym_PLUS] = ACTIONS(3827),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_STAR] = ACTIONS(3829),
    [anon_sym_CARET] = ACTIONS(3829),
    [anon_sym_AMP] = ACTIONS(3829),
    [anon_sym_this] = ACTIONS(3827),
    [anon_sym_scoped] = ACTIONS(3827),
    [anon_sym_base] = ACTIONS(3827),
    [anon_sym_var] = ACTIONS(3827),
    [sym_predefined_type] = ACTIONS(3827),
    [anon_sym_break] = ACTIONS(3827),
    [anon_sym_unchecked] = ACTIONS(3827),
    [anon_sym_continue] = ACTIONS(3827),
    [anon_sym_do] = ACTIONS(3827),
    [anon_sym_while] = ACTIONS(3827),
    [anon_sym_for] = ACTIONS(3827),
    [anon_sym_lock] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3827),
    [anon_sym_switch] = ACTIONS(3827),
    [anon_sym_default] = ACTIONS(3827),
    [anon_sym_throw] = ACTIONS(3827),
    [anon_sym_try] = ACTIONS(3827),
    [anon_sym_when] = ACTIONS(3827),
    [anon_sym_await] = ACTIONS(3827),
    [anon_sym_foreach] = ACTIONS(3827),
    [anon_sym_goto] = ACTIONS(3827),
    [anon_sym_if] = ACTIONS(3827),
    [anon_sym_DOT_DOT] = ACTIONS(3829),
    [anon_sym_from] = ACTIONS(3827),
    [anon_sym_into] = ACTIONS(3827),
    [anon_sym_join] = ACTIONS(3827),
    [anon_sym_on] = ACTIONS(3827),
    [anon_sym_equals] = ACTIONS(3827),
    [anon_sym_let] = ACTIONS(3827),
    [anon_sym_orderby] = ACTIONS(3827),
    [anon_sym_ascending] = ACTIONS(3827),
    [anon_sym_descending] = ACTIONS(3827),
    [anon_sym_group] = ACTIONS(3827),
    [anon_sym_by] = ACTIONS(3827),
    [anon_sym_select] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(3829),
    [anon_sym_stackalloc] = ACTIONS(3827),
    [anon_sym_sizeof] = ACTIONS(3827),
    [anon_sym_typeof] = ACTIONS(3827),
    [anon_sym___makeref] = ACTIONS(3827),
    [anon_sym___reftype] = ACTIONS(3827),
    [anon_sym___refvalue] = ACTIONS(3827),
    [sym_null_literal] = ACTIONS(3827),
    [anon_sym_SQUOTE] = ACTIONS(3829),
    [sym_integer_literal] = ACTIONS(3827),
    [sym_real_literal] = ACTIONS(3829),
    [sym_verbatim_string_literal] = ACTIONS(3829),
    [aux_sym_preproc_if_token1] = ACTIONS(3829),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3829),
    [sym_interpolation_verbatim_start] = ACTIONS(3829),
    [sym_interpolation_raw_start] = ACTIONS(3829),
    [sym_raw_string_start] = ACTIONS(3829),
  },
  [2598] = {
    [sym_preproc_region] = STATE(2598),
    [sym_preproc_endregion] = STATE(2598),
    [sym_preproc_line] = STATE(2598),
    [sym_preproc_pragma] = STATE(2598),
    [sym_preproc_nullable] = STATE(2598),
    [sym_preproc_error] = STATE(2598),
    [sym_preproc_define] = STATE(2598),
    [sym_preproc_undef] = STATE(2598),
    [ts_builtin_sym_end] = ACTIONS(3825),
    [sym__identifier_token] = ACTIONS(3823),
    [anon_sym_extern] = ACTIONS(3823),
    [anon_sym_alias] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(3825),
    [anon_sym_global] = ACTIONS(3823),
    [anon_sym_using] = ACTIONS(3823),
    [anon_sym_unsafe] = ACTIONS(3823),
    [anon_sym_static] = ACTIONS(3823),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_return] = ACTIONS(3823),
    [anon_sym_namespace] = ACTIONS(3823),
    [anon_sym_class] = ACTIONS(3823),
    [anon_sym_ref] = ACTIONS(3823),
    [anon_sym_struct] = ACTIONS(3823),
    [anon_sym_enum] = ACTIONS(3823),
    [anon_sym_LBRACE] = ACTIONS(3825),
    [anon_sym_interface] = ACTIONS(3823),
    [anon_sym_delegate] = ACTIONS(3823),
    [anon_sym_record] = ACTIONS(3823),
    [anon_sym_abstract] = ACTIONS(3823),
    [anon_sym_async] = ACTIONS(3823),
    [anon_sym_const] = ACTIONS(3823),
    [anon_sym_file] = ACTIONS(3823),
    [anon_sym_fixed] = ACTIONS(3823),
    [anon_sym_internal] = ACTIONS(3823),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_override] = ACTIONS(3823),
    [anon_sym_partial] = ACTIONS(3823),
    [anon_sym_private] = ACTIONS(3823),
    [anon_sym_protected] = ACTIONS(3823),
    [anon_sym_public] = ACTIONS(3823),
    [anon_sym_readonly] = ACTIONS(3823),
    [anon_sym_required] = ACTIONS(3823),
    [anon_sym_sealed] = ACTIONS(3823),
    [anon_sym_virtual] = ACTIONS(3823),
    [anon_sym_volatile] = ACTIONS(3823),
    [anon_sym_where] = ACTIONS(3823),
    [anon_sym_notnull] = ACTIONS(3823),
    [anon_sym_unmanaged] = ACTIONS(3823),
    [anon_sym_checked] = ACTIONS(3823),
    [anon_sym_BANG] = ACTIONS(3825),
    [anon_sym_TILDE] = ACTIONS(3825),
    [anon_sym_PLUS_PLUS] = ACTIONS(3825),
    [anon_sym_DASH_DASH] = ACTIONS(3825),
    [anon_sym_true] = ACTIONS(3823),
    [anon_sym_false] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(3823),
    [anon_sym_DASH] = ACTIONS(3823),
    [anon_sym_STAR] = ACTIONS(3825),
    [anon_sym_CARET] = ACTIONS(3825),
    [anon_sym_AMP] = ACTIONS(3825),
    [anon_sym_this] = ACTIONS(3823),
    [anon_sym_scoped] = ACTIONS(3823),
    [anon_sym_base] = ACTIONS(3823),
    [anon_sym_var] = ACTIONS(3823),
    [sym_predefined_type] = ACTIONS(3823),
    [anon_sym_break] = ACTIONS(3823),
    [anon_sym_unchecked] = ACTIONS(3823),
    [anon_sym_continue] = ACTIONS(3823),
    [anon_sym_do] = ACTIONS(3823),
    [anon_sym_while] = ACTIONS(3823),
    [anon_sym_for] = ACTIONS(3823),
    [anon_sym_lock] = ACTIONS(3823),
    [anon_sym_yield] = ACTIONS(3823),
    [anon_sym_switch] = ACTIONS(3823),
    [anon_sym_default] = ACTIONS(3823),
    [anon_sym_throw] = ACTIONS(3823),
    [anon_sym_try] = ACTIONS(3823),
    [anon_sym_when] = ACTIONS(3823),
    [anon_sym_await] = ACTIONS(3823),
    [anon_sym_foreach] = ACTIONS(3823),
    [anon_sym_goto] = ACTIONS(3823),
    [anon_sym_if] = ACTIONS(3823),
    [anon_sym_DOT_DOT] = ACTIONS(3825),
    [anon_sym_from] = ACTIONS(3823),
    [anon_sym_into] = ACTIONS(3823),
    [anon_sym_join] = ACTIONS(3823),
    [anon_sym_on] = ACTIONS(3823),
    [anon_sym_equals] = ACTIONS(3823),
    [anon_sym_let] = ACTIONS(3823),
    [anon_sym_orderby] = ACTIONS(3823),
    [anon_sym_ascending] = ACTIONS(3823),
    [anon_sym_descending] = ACTIONS(3823),
    [anon_sym_group] = ACTIONS(3823),
    [anon_sym_by] = ACTIONS(3823),
    [anon_sym_select] = ACTIONS(3823),
    [anon_sym_DQUOTE] = ACTIONS(3825),
    [anon_sym_stackalloc] = ACTIONS(3823),
    [anon_sym_sizeof] = ACTIONS(3823),
    [anon_sym_typeof] = ACTIONS(3823),
    [anon_sym___makeref] = ACTIONS(3823),
    [anon_sym___reftype] = ACTIONS(3823),
    [anon_sym___refvalue] = ACTIONS(3823),
    [sym_null_literal] = ACTIONS(3823),
    [anon_sym_SQUOTE] = ACTIONS(3825),
    [sym_integer_literal] = ACTIONS(3823),
    [sym_real_literal] = ACTIONS(3825),
    [sym_verbatim_string_literal] = ACTIONS(3825),
    [aux_sym_preproc_if_token1] = ACTIONS(3825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3825),
    [sym_interpolation_verbatim_start] = ACTIONS(3825),
    [sym_interpolation_raw_start] = ACTIONS(3825),
    [sym_raw_string_start] = ACTIONS(3825),
  },
  [2599] = {
    [sym_preproc_region] = STATE(2599),
    [sym_preproc_endregion] = STATE(2599),
    [sym_preproc_line] = STATE(2599),
    [sym_preproc_pragma] = STATE(2599),
    [sym_preproc_nullable] = STATE(2599),
    [sym_preproc_error] = STATE(2599),
    [sym_preproc_define] = STATE(2599),
    [sym_preproc_undef] = STATE(2599),
    [ts_builtin_sym_end] = ACTIONS(3465),
    [sym__identifier_token] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym_alias] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3465),
    [anon_sym_global] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_unsafe] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3465),
    [anon_sym_return] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_ref] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_LBRACE] = ACTIONS(3465),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_delegate] = ACTIONS(3463),
    [anon_sym_record] = ACTIONS(3463),
    [anon_sym_abstract] = ACTIONS(3463),
    [anon_sym_async] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_file] = ACTIONS(3463),
    [anon_sym_fixed] = ACTIONS(3463),
    [anon_sym_internal] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_override] = ACTIONS(3463),
    [anon_sym_partial] = ACTIONS(3463),
    [anon_sym_private] = ACTIONS(3463),
    [anon_sym_protected] = ACTIONS(3463),
    [anon_sym_public] = ACTIONS(3463),
    [anon_sym_readonly] = ACTIONS(3463),
    [anon_sym_required] = ACTIONS(3463),
    [anon_sym_sealed] = ACTIONS(3463),
    [anon_sym_virtual] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_where] = ACTIONS(3463),
    [anon_sym_notnull] = ACTIONS(3463),
    [anon_sym_unmanaged] = ACTIONS(3463),
    [anon_sym_checked] = ACTIONS(3463),
    [anon_sym_BANG] = ACTIONS(3465),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_PLUS_PLUS] = ACTIONS(3465),
    [anon_sym_DASH_DASH] = ACTIONS(3465),
    [anon_sym_true] = ACTIONS(3463),
    [anon_sym_false] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3463),
    [anon_sym_STAR] = ACTIONS(3465),
    [anon_sym_CARET] = ACTIONS(3465),
    [anon_sym_AMP] = ACTIONS(3465),
    [anon_sym_this] = ACTIONS(3463),
    [anon_sym_scoped] = ACTIONS(3463),
    [anon_sym_base] = ACTIONS(3463),
    [anon_sym_var] = ACTIONS(3463),
    [sym_predefined_type] = ACTIONS(3463),
    [anon_sym_break] = ACTIONS(3463),
    [anon_sym_unchecked] = ACTIONS(3463),
    [anon_sym_continue] = ACTIONS(3463),
    [anon_sym_do] = ACTIONS(3463),
    [anon_sym_while] = ACTIONS(3463),
    [anon_sym_for] = ACTIONS(3463),
    [anon_sym_lock] = ACTIONS(3463),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_switch] = ACTIONS(3463),
    [anon_sym_default] = ACTIONS(3463),
    [anon_sym_throw] = ACTIONS(3463),
    [anon_sym_try] = ACTIONS(3463),
    [anon_sym_when] = ACTIONS(3463),
    [anon_sym_await] = ACTIONS(3463),
    [anon_sym_foreach] = ACTIONS(3463),
    [anon_sym_goto] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(3463),
    [anon_sym_DOT_DOT] = ACTIONS(3465),
    [anon_sym_from] = ACTIONS(3463),
    [anon_sym_into] = ACTIONS(3463),
    [anon_sym_join] = ACTIONS(3463),
    [anon_sym_on] = ACTIONS(3463),
    [anon_sym_equals] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_orderby] = ACTIONS(3463),
    [anon_sym_ascending] = ACTIONS(3463),
    [anon_sym_descending] = ACTIONS(3463),
    [anon_sym_group] = ACTIONS(3463),
    [anon_sym_by] = ACTIONS(3463),
    [anon_sym_select] = ACTIONS(3463),
    [anon_sym_DQUOTE] = ACTIONS(3465),
    [anon_sym_stackalloc] = ACTIONS(3463),
    [anon_sym_sizeof] = ACTIONS(3463),
    [anon_sym_typeof] = ACTIONS(3463),
    [anon_sym___makeref] = ACTIONS(3463),
    [anon_sym___reftype] = ACTIONS(3463),
    [anon_sym___refvalue] = ACTIONS(3463),
    [sym_null_literal] = ACTIONS(3463),
    [anon_sym_SQUOTE] = ACTIONS(3465),
    [sym_integer_literal] = ACTIONS(3463),
    [sym_real_literal] = ACTIONS(3465),
    [sym_verbatim_string_literal] = ACTIONS(3465),
    [aux_sym_preproc_if_token1] = ACTIONS(3465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3465),
    [sym_interpolation_verbatim_start] = ACTIONS(3465),
    [sym_interpolation_raw_start] = ACTIONS(3465),
    [sym_raw_string_start] = ACTIONS(3465),
  },
  [2600] = {
    [sym_preproc_region] = STATE(2600),
    [sym_preproc_endregion] = STATE(2600),
    [sym_preproc_line] = STATE(2600),
    [sym_preproc_pragma] = STATE(2600),
    [sym_preproc_nullable] = STATE(2600),
    [sym_preproc_error] = STATE(2600),
    [sym_preproc_define] = STATE(2600),
    [sym_preproc_undef] = STATE(2600),
    [ts_builtin_sym_end] = ACTIONS(3653),
    [sym__identifier_token] = ACTIONS(3651),
    [anon_sym_extern] = ACTIONS(3651),
    [anon_sym_alias] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_global] = ACTIONS(3651),
    [anon_sym_using] = ACTIONS(3651),
    [anon_sym_unsafe] = ACTIONS(3651),
    [anon_sym_static] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_return] = ACTIONS(3651),
    [anon_sym_namespace] = ACTIONS(3651),
    [anon_sym_class] = ACTIONS(3651),
    [anon_sym_ref] = ACTIONS(3651),
    [anon_sym_struct] = ACTIONS(3651),
    [anon_sym_enum] = ACTIONS(3651),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_interface] = ACTIONS(3651),
    [anon_sym_delegate] = ACTIONS(3651),
    [anon_sym_record] = ACTIONS(3651),
    [anon_sym_abstract] = ACTIONS(3651),
    [anon_sym_async] = ACTIONS(3651),
    [anon_sym_const] = ACTIONS(3651),
    [anon_sym_file] = ACTIONS(3651),
    [anon_sym_fixed] = ACTIONS(3651),
    [anon_sym_internal] = ACTIONS(3651),
    [anon_sym_new] = ACTIONS(3651),
    [anon_sym_override] = ACTIONS(3651),
    [anon_sym_partial] = ACTIONS(3651),
    [anon_sym_private] = ACTIONS(3651),
    [anon_sym_protected] = ACTIONS(3651),
    [anon_sym_public] = ACTIONS(3651),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_required] = ACTIONS(3651),
    [anon_sym_sealed] = ACTIONS(3651),
    [anon_sym_virtual] = ACTIONS(3651),
    [anon_sym_volatile] = ACTIONS(3651),
    [anon_sym_where] = ACTIONS(3651),
    [anon_sym_notnull] = ACTIONS(3651),
    [anon_sym_unmanaged] = ACTIONS(3651),
    [anon_sym_checked] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_true] = ACTIONS(3651),
    [anon_sym_false] = ACTIONS(3651),
    [anon_sym_PLUS] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3651),
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_this] = ACTIONS(3651),
    [anon_sym_scoped] = ACTIONS(3651),
    [anon_sym_base] = ACTIONS(3651),
    [anon_sym_var] = ACTIONS(3651),
    [sym_predefined_type] = ACTIONS(3651),
    [anon_sym_break] = ACTIONS(3651),
    [anon_sym_unchecked] = ACTIONS(3651),
    [anon_sym_continue] = ACTIONS(3651),
    [anon_sym_do] = ACTIONS(3651),
    [anon_sym_while] = ACTIONS(3651),
    [anon_sym_for] = ACTIONS(3651),
    [anon_sym_lock] = ACTIONS(3651),
    [anon_sym_yield] = ACTIONS(3651),
    [anon_sym_switch] = ACTIONS(3651),
    [anon_sym_default] = ACTIONS(3651),
    [anon_sym_throw] = ACTIONS(3651),
    [anon_sym_try] = ACTIONS(3651),
    [anon_sym_when] = ACTIONS(3651),
    [anon_sym_await] = ACTIONS(3651),
    [anon_sym_foreach] = ACTIONS(3651),
    [anon_sym_goto] = ACTIONS(3651),
    [anon_sym_if] = ACTIONS(3651),
    [anon_sym_DOT_DOT] = ACTIONS(3653),
    [anon_sym_from] = ACTIONS(3651),
    [anon_sym_into] = ACTIONS(3651),
    [anon_sym_join] = ACTIONS(3651),
    [anon_sym_on] = ACTIONS(3651),
    [anon_sym_equals] = ACTIONS(3651),
    [anon_sym_let] = ACTIONS(3651),
    [anon_sym_orderby] = ACTIONS(3651),
    [anon_sym_ascending] = ACTIONS(3651),
    [anon_sym_descending] = ACTIONS(3651),
    [anon_sym_group] = ACTIONS(3651),
    [anon_sym_by] = ACTIONS(3651),
    [anon_sym_select] = ACTIONS(3651),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [anon_sym_stackalloc] = ACTIONS(3651),
    [anon_sym_sizeof] = ACTIONS(3651),
    [anon_sym_typeof] = ACTIONS(3651),
    [anon_sym___makeref] = ACTIONS(3651),
    [anon_sym___reftype] = ACTIONS(3651),
    [anon_sym___refvalue] = ACTIONS(3651),
    [sym_null_literal] = ACTIONS(3651),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [sym_integer_literal] = ACTIONS(3651),
    [sym_real_literal] = ACTIONS(3653),
    [sym_verbatim_string_literal] = ACTIONS(3653),
    [aux_sym_preproc_if_token1] = ACTIONS(3653),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3653),
    [sym_interpolation_verbatim_start] = ACTIONS(3653),
    [sym_interpolation_raw_start] = ACTIONS(3653),
    [sym_raw_string_start] = ACTIONS(3653),
  },
  [2601] = {
    [sym_preproc_region] = STATE(2601),
    [sym_preproc_endregion] = STATE(2601),
    [sym_preproc_line] = STATE(2601),
    [sym_preproc_pragma] = STATE(2601),
    [sym_preproc_nullable] = STATE(2601),
    [sym_preproc_error] = STATE(2601),
    [sym_preproc_define] = STATE(2601),
    [sym_preproc_undef] = STATE(2601),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_global] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_unsafe] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_ref] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_delegate] = ACTIONS(3739),
    [anon_sym_record] = ACTIONS(3739),
    [anon_sym_abstract] = ACTIONS(3739),
    [anon_sym_async] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_file] = ACTIONS(3739),
    [anon_sym_fixed] = ACTIONS(3739),
    [anon_sym_internal] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_override] = ACTIONS(3739),
    [anon_sym_partial] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_readonly] = ACTIONS(3739),
    [anon_sym_required] = ACTIONS(3739),
    [anon_sym_sealed] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_where] = ACTIONS(3739),
    [anon_sym_notnull] = ACTIONS(3739),
    [anon_sym_unmanaged] = ACTIONS(3739),
    [anon_sym_checked] = ACTIONS(3739),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_true] = ACTIONS(3739),
    [anon_sym_false] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3739),
    [anon_sym_DASH] = ACTIONS(3739),
    [anon_sym_STAR] = ACTIONS(3741),
    [anon_sym_CARET] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_this] = ACTIONS(3739),
    [anon_sym_scoped] = ACTIONS(3739),
    [anon_sym_base] = ACTIONS(3739),
    [anon_sym_var] = ACTIONS(3739),
    [sym_predefined_type] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_unchecked] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_do] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_lock] = ACTIONS(3739),
    [anon_sym_yield] = ACTIONS(3739),
    [anon_sym_switch] = ACTIONS(3739),
    [anon_sym_default] = ACTIONS(3739),
    [anon_sym_throw] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_when] = ACTIONS(3739),
    [anon_sym_await] = ACTIONS(3739),
    [anon_sym_foreach] = ACTIONS(3739),
    [anon_sym_goto] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_DOT_DOT] = ACTIONS(3741),
    [anon_sym_from] = ACTIONS(3739),
    [anon_sym_into] = ACTIONS(3739),
    [anon_sym_join] = ACTIONS(3739),
    [anon_sym_on] = ACTIONS(3739),
    [anon_sym_equals] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_orderby] = ACTIONS(3739),
    [anon_sym_ascending] = ACTIONS(3739),
    [anon_sym_descending] = ACTIONS(3739),
    [anon_sym_group] = ACTIONS(3739),
    [anon_sym_by] = ACTIONS(3739),
    [anon_sym_select] = ACTIONS(3739),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [anon_sym_stackalloc] = ACTIONS(3739),
    [anon_sym_sizeof] = ACTIONS(3739),
    [anon_sym_typeof] = ACTIONS(3739),
    [anon_sym___makeref] = ACTIONS(3739),
    [anon_sym___reftype] = ACTIONS(3739),
    [anon_sym___refvalue] = ACTIONS(3739),
    [sym_null_literal] = ACTIONS(3739),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [sym_integer_literal] = ACTIONS(3739),
    [sym_real_literal] = ACTIONS(3741),
    [sym_verbatim_string_literal] = ACTIONS(3741),
    [aux_sym_preproc_if_token1] = ACTIONS(3741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3741),
    [sym_interpolation_verbatim_start] = ACTIONS(3741),
    [sym_interpolation_raw_start] = ACTIONS(3741),
    [sym_raw_string_start] = ACTIONS(3741),
  },
  [2602] = {
    [sym_preproc_region] = STATE(2602),
    [sym_preproc_endregion] = STATE(2602),
    [sym_preproc_line] = STATE(2602),
    [sym_preproc_pragma] = STATE(2602),
    [sym_preproc_nullable] = STATE(2602),
    [sym_preproc_error] = STATE(2602),
    [sym_preproc_define] = STATE(2602),
    [sym_preproc_undef] = STATE(2602),
    [ts_builtin_sym_end] = ACTIONS(3553),
    [sym__identifier_token] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym_alias] = ACTIONS(3551),
    [anon_sym_SEMI] = ACTIONS(3553),
    [anon_sym_global] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_unsafe] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3553),
    [anon_sym_return] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_ref] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_LBRACE] = ACTIONS(3553),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_delegate] = ACTIONS(3551),
    [anon_sym_record] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_file] = ACTIONS(3551),
    [anon_sym_fixed] = ACTIONS(3551),
    [anon_sym_internal] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [anon_sym_partial] = ACTIONS(3551),
    [anon_sym_private] = ACTIONS(3551),
    [anon_sym_protected] = ACTIONS(3551),
    [anon_sym_public] = ACTIONS(3551),
    [anon_sym_readonly] = ACTIONS(3551),
    [anon_sym_required] = ACTIONS(3551),
    [anon_sym_sealed] = ACTIONS(3551),
    [anon_sym_virtual] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_where] = ACTIONS(3551),
    [anon_sym_notnull] = ACTIONS(3551),
    [anon_sym_unmanaged] = ACTIONS(3551),
    [anon_sym_checked] = ACTIONS(3551),
    [anon_sym_BANG] = ACTIONS(3553),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_PLUS_PLUS] = ACTIONS(3553),
    [anon_sym_DASH_DASH] = ACTIONS(3553),
    [anon_sym_true] = ACTIONS(3551),
    [anon_sym_false] = ACTIONS(3551),
    [anon_sym_PLUS] = ACTIONS(3551),
    [anon_sym_DASH] = ACTIONS(3551),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_CARET] = ACTIONS(3553),
    [anon_sym_AMP] = ACTIONS(3553),
    [anon_sym_this] = ACTIONS(3551),
    [anon_sym_scoped] = ACTIONS(3551),
    [anon_sym_base] = ACTIONS(3551),
    [anon_sym_var] = ACTIONS(3551),
    [sym_predefined_type] = ACTIONS(3551),
    [anon_sym_break] = ACTIONS(3551),
    [anon_sym_unchecked] = ACTIONS(3551),
    [anon_sym_continue] = ACTIONS(3551),
    [anon_sym_do] = ACTIONS(3551),
    [anon_sym_while] = ACTIONS(3551),
    [anon_sym_for] = ACTIONS(3551),
    [anon_sym_lock] = ACTIONS(3551),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_switch] = ACTIONS(3551),
    [anon_sym_default] = ACTIONS(3551),
    [anon_sym_throw] = ACTIONS(3551),
    [anon_sym_try] = ACTIONS(3551),
    [anon_sym_when] = ACTIONS(3551),
    [anon_sym_await] = ACTIONS(3551),
    [anon_sym_foreach] = ACTIONS(3551),
    [anon_sym_goto] = ACTIONS(3551),
    [anon_sym_if] = ACTIONS(3551),
    [anon_sym_DOT_DOT] = ACTIONS(3553),
    [anon_sym_from] = ACTIONS(3551),
    [anon_sym_into] = ACTIONS(3551),
    [anon_sym_join] = ACTIONS(3551),
    [anon_sym_on] = ACTIONS(3551),
    [anon_sym_equals] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_orderby] = ACTIONS(3551),
    [anon_sym_ascending] = ACTIONS(3551),
    [anon_sym_descending] = ACTIONS(3551),
    [anon_sym_group] = ACTIONS(3551),
    [anon_sym_by] = ACTIONS(3551),
    [anon_sym_select] = ACTIONS(3551),
    [anon_sym_DQUOTE] = ACTIONS(3553),
    [anon_sym_stackalloc] = ACTIONS(3551),
    [anon_sym_sizeof] = ACTIONS(3551),
    [anon_sym_typeof] = ACTIONS(3551),
    [anon_sym___makeref] = ACTIONS(3551),
    [anon_sym___reftype] = ACTIONS(3551),
    [anon_sym___refvalue] = ACTIONS(3551),
    [sym_null_literal] = ACTIONS(3551),
    [anon_sym_SQUOTE] = ACTIONS(3553),
    [sym_integer_literal] = ACTIONS(3551),
    [sym_real_literal] = ACTIONS(3553),
    [sym_verbatim_string_literal] = ACTIONS(3553),
    [aux_sym_preproc_if_token1] = ACTIONS(3553),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3553),
    [sym_interpolation_verbatim_start] = ACTIONS(3553),
    [sym_interpolation_raw_start] = ACTIONS(3553),
    [sym_raw_string_start] = ACTIONS(3553),
  },
  [2603] = {
    [sym_preproc_region] = STATE(2603),
    [sym_preproc_endregion] = STATE(2603),
    [sym_preproc_line] = STATE(2603),
    [sym_preproc_pragma] = STATE(2603),
    [sym_preproc_nullable] = STATE(2603),
    [sym_preproc_error] = STATE(2603),
    [sym_preproc_define] = STATE(2603),
    [sym_preproc_undef] = STATE(2603),
    [ts_builtin_sym_end] = ACTIONS(3737),
    [sym__identifier_token] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym_alias] = ACTIONS(3735),
    [anon_sym_SEMI] = ACTIONS(3737),
    [anon_sym_global] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_unsafe] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3737),
    [anon_sym_return] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_ref] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_delegate] = ACTIONS(3735),
    [anon_sym_record] = ACTIONS(3735),
    [anon_sym_abstract] = ACTIONS(3735),
    [anon_sym_async] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_file] = ACTIONS(3735),
    [anon_sym_fixed] = ACTIONS(3735),
    [anon_sym_internal] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_override] = ACTIONS(3735),
    [anon_sym_partial] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_readonly] = ACTIONS(3735),
    [anon_sym_required] = ACTIONS(3735),
    [anon_sym_sealed] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_where] = ACTIONS(3735),
    [anon_sym_notnull] = ACTIONS(3735),
    [anon_sym_unmanaged] = ACTIONS(3735),
    [anon_sym_checked] = ACTIONS(3735),
    [anon_sym_BANG] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_PLUS_PLUS] = ACTIONS(3737),
    [anon_sym_DASH_DASH] = ACTIONS(3737),
    [anon_sym_true] = ACTIONS(3735),
    [anon_sym_false] = ACTIONS(3735),
    [anon_sym_PLUS] = ACTIONS(3735),
    [anon_sym_DASH] = ACTIONS(3735),
    [anon_sym_STAR] = ACTIONS(3737),
    [anon_sym_CARET] = ACTIONS(3737),
    [anon_sym_AMP] = ACTIONS(3737),
    [anon_sym_this] = ACTIONS(3735),
    [anon_sym_scoped] = ACTIONS(3735),
    [anon_sym_base] = ACTIONS(3735),
    [anon_sym_var] = ACTIONS(3735),
    [sym_predefined_type] = ACTIONS(3735),
    [anon_sym_break] = ACTIONS(3735),
    [anon_sym_unchecked] = ACTIONS(3735),
    [anon_sym_continue] = ACTIONS(3735),
    [anon_sym_do] = ACTIONS(3735),
    [anon_sym_while] = ACTIONS(3735),
    [anon_sym_for] = ACTIONS(3735),
    [anon_sym_lock] = ACTIONS(3735),
    [anon_sym_yield] = ACTIONS(3735),
    [anon_sym_switch] = ACTIONS(3735),
    [anon_sym_default] = ACTIONS(3735),
    [anon_sym_throw] = ACTIONS(3735),
    [anon_sym_try] = ACTIONS(3735),
    [anon_sym_when] = ACTIONS(3735),
    [anon_sym_await] = ACTIONS(3735),
    [anon_sym_foreach] = ACTIONS(3735),
    [anon_sym_goto] = ACTIONS(3735),
    [anon_sym_if] = ACTIONS(3735),
    [anon_sym_DOT_DOT] = ACTIONS(3737),
    [anon_sym_from] = ACTIONS(3735),
    [anon_sym_into] = ACTIONS(3735),
    [anon_sym_join] = ACTIONS(3735),
    [anon_sym_on] = ACTIONS(3735),
    [anon_sym_equals] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_orderby] = ACTIONS(3735),
    [anon_sym_ascending] = ACTIONS(3735),
    [anon_sym_descending] = ACTIONS(3735),
    [anon_sym_group] = ACTIONS(3735),
    [anon_sym_by] = ACTIONS(3735),
    [anon_sym_select] = ACTIONS(3735),
    [anon_sym_DQUOTE] = ACTIONS(3737),
    [anon_sym_stackalloc] = ACTIONS(3735),
    [anon_sym_sizeof] = ACTIONS(3735),
    [anon_sym_typeof] = ACTIONS(3735),
    [anon_sym___makeref] = ACTIONS(3735),
    [anon_sym___reftype] = ACTIONS(3735),
    [anon_sym___refvalue] = ACTIONS(3735),
    [sym_null_literal] = ACTIONS(3735),
    [anon_sym_SQUOTE] = ACTIONS(3737),
    [sym_integer_literal] = ACTIONS(3735),
    [sym_real_literal] = ACTIONS(3737),
    [sym_verbatim_string_literal] = ACTIONS(3737),
    [aux_sym_preproc_if_token1] = ACTIONS(3737),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3737),
    [sym_interpolation_verbatim_start] = ACTIONS(3737),
    [sym_interpolation_raw_start] = ACTIONS(3737),
    [sym_raw_string_start] = ACTIONS(3737),
  },
  [2604] = {
    [sym_preproc_region] = STATE(2604),
    [sym_preproc_endregion] = STATE(2604),
    [sym_preproc_line] = STATE(2604),
    [sym_preproc_pragma] = STATE(2604),
    [sym_preproc_nullable] = STATE(2604),
    [sym_preproc_error] = STATE(2604),
    [sym_preproc_define] = STATE(2604),
    [sym_preproc_undef] = STATE(2604),
    [ts_builtin_sym_end] = ACTIONS(3533),
    [sym__identifier_token] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym_alias] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_unsafe] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_ref] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_delegate] = ACTIONS(3531),
    [anon_sym_record] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_async] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_file] = ACTIONS(3531),
    [anon_sym_fixed] = ACTIONS(3531),
    [anon_sym_internal] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [anon_sym_partial] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_readonly] = ACTIONS(3531),
    [anon_sym_required] = ACTIONS(3531),
    [anon_sym_sealed] = ACTIONS(3531),
    [anon_sym_virtual] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_where] = ACTIONS(3531),
    [anon_sym_notnull] = ACTIONS(3531),
    [anon_sym_unmanaged] = ACTIONS(3531),
    [anon_sym_checked] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3533),
    [anon_sym_DASH_DASH] = ACTIONS(3533),
    [anon_sym_true] = ACTIONS(3531),
    [anon_sym_false] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3531),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_CARET] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_this] = ACTIONS(3531),
    [anon_sym_scoped] = ACTIONS(3531),
    [anon_sym_base] = ACTIONS(3531),
    [anon_sym_var] = ACTIONS(3531),
    [sym_predefined_type] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3531),
    [anon_sym_unchecked] = ACTIONS(3531),
    [anon_sym_continue] = ACTIONS(3531),
    [anon_sym_do] = ACTIONS(3531),
    [anon_sym_while] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3531),
    [anon_sym_lock] = ACTIONS(3531),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3531),
    [anon_sym_default] = ACTIONS(3531),
    [anon_sym_throw] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3531),
    [anon_sym_when] = ACTIONS(3531),
    [anon_sym_await] = ACTIONS(3531),
    [anon_sym_foreach] = ACTIONS(3531),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym_if] = ACTIONS(3531),
    [anon_sym_DOT_DOT] = ACTIONS(3533),
    [anon_sym_from] = ACTIONS(3531),
    [anon_sym_into] = ACTIONS(3531),
    [anon_sym_join] = ACTIONS(3531),
    [anon_sym_on] = ACTIONS(3531),
    [anon_sym_equals] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_orderby] = ACTIONS(3531),
    [anon_sym_ascending] = ACTIONS(3531),
    [anon_sym_descending] = ACTIONS(3531),
    [anon_sym_group] = ACTIONS(3531),
    [anon_sym_by] = ACTIONS(3531),
    [anon_sym_select] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(3533),
    [anon_sym_stackalloc] = ACTIONS(3531),
    [anon_sym_sizeof] = ACTIONS(3531),
    [anon_sym_typeof] = ACTIONS(3531),
    [anon_sym___makeref] = ACTIONS(3531),
    [anon_sym___reftype] = ACTIONS(3531),
    [anon_sym___refvalue] = ACTIONS(3531),
    [sym_null_literal] = ACTIONS(3531),
    [anon_sym_SQUOTE] = ACTIONS(3533),
    [sym_integer_literal] = ACTIONS(3531),
    [sym_real_literal] = ACTIONS(3533),
    [sym_verbatim_string_literal] = ACTIONS(3533),
    [aux_sym_preproc_if_token1] = ACTIONS(3533),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3533),
    [sym_interpolation_verbatim_start] = ACTIONS(3533),
    [sym_interpolation_raw_start] = ACTIONS(3533),
    [sym_raw_string_start] = ACTIONS(3533),
  },
  [2605] = {
    [sym_preproc_region] = STATE(2605),
    [sym_preproc_endregion] = STATE(2605),
    [sym_preproc_line] = STATE(2605),
    [sym_preproc_pragma] = STATE(2605),
    [sym_preproc_nullable] = STATE(2605),
    [sym_preproc_error] = STATE(2605),
    [sym_preproc_define] = STATE(2605),
    [sym_preproc_undef] = STATE(2605),
    [ts_builtin_sym_end] = ACTIONS(3417),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3417),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_return] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_checked] = ACTIONS(3415),
    [anon_sym_BANG] = ACTIONS(3417),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_PLUS_PLUS] = ACTIONS(3417),
    [anon_sym_DASH_DASH] = ACTIONS(3417),
    [anon_sym_true] = ACTIONS(3415),
    [anon_sym_false] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(3415),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_CARET] = ACTIONS(3417),
    [anon_sym_AMP] = ACTIONS(3417),
    [anon_sym_this] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_base] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_break] = ACTIONS(3415),
    [anon_sym_unchecked] = ACTIONS(3415),
    [anon_sym_continue] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_while] = ACTIONS(3415),
    [anon_sym_for] = ACTIONS(3415),
    [anon_sym_lock] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_switch] = ACTIONS(3415),
    [anon_sym_default] = ACTIONS(3415),
    [anon_sym_throw] = ACTIONS(3415),
    [anon_sym_try] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_await] = ACTIONS(3415),
    [anon_sym_foreach] = ACTIONS(3415),
    [anon_sym_goto] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_DOT_DOT] = ACTIONS(3417),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_stackalloc] = ACTIONS(3415),
    [anon_sym_sizeof] = ACTIONS(3415),
    [anon_sym_typeof] = ACTIONS(3415),
    [anon_sym___makeref] = ACTIONS(3415),
    [anon_sym___reftype] = ACTIONS(3415),
    [anon_sym___refvalue] = ACTIONS(3415),
    [sym_null_literal] = ACTIONS(3415),
    [anon_sym_SQUOTE] = ACTIONS(3417),
    [sym_integer_literal] = ACTIONS(3415),
    [sym_real_literal] = ACTIONS(3417),
    [sym_verbatim_string_literal] = ACTIONS(3417),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3417),
    [sym_interpolation_verbatim_start] = ACTIONS(3417),
    [sym_interpolation_raw_start] = ACTIONS(3417),
    [sym_raw_string_start] = ACTIONS(3417),
  },
  [2606] = {
    [sym_preproc_region] = STATE(2606),
    [sym_preproc_endregion] = STATE(2606),
    [sym_preproc_line] = STATE(2606),
    [sym_preproc_pragma] = STATE(2606),
    [sym_preproc_nullable] = STATE(2606),
    [sym_preproc_error] = STATE(2606),
    [sym_preproc_define] = STATE(2606),
    [sym_preproc_undef] = STATE(2606),
    [ts_builtin_sym_end] = ACTIONS(3485),
    [sym__identifier_token] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym_alias] = ACTIONS(3483),
    [anon_sym_SEMI] = ACTIONS(3485),
    [anon_sym_global] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_unsafe] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3485),
    [anon_sym_return] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_ref] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_LBRACE] = ACTIONS(3485),
    [anon_sym_interface] = ACTIONS(3483),
    [anon_sym_delegate] = ACTIONS(3483),
    [anon_sym_record] = ACTIONS(3483),
    [anon_sym_abstract] = ACTIONS(3483),
    [anon_sym_async] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_file] = ACTIONS(3483),
    [anon_sym_fixed] = ACTIONS(3483),
    [anon_sym_internal] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_override] = ACTIONS(3483),
    [anon_sym_partial] = ACTIONS(3483),
    [anon_sym_private] = ACTIONS(3483),
    [anon_sym_protected] = ACTIONS(3483),
    [anon_sym_public] = ACTIONS(3483),
    [anon_sym_readonly] = ACTIONS(3483),
    [anon_sym_required] = ACTIONS(3483),
    [anon_sym_sealed] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_where] = ACTIONS(3483),
    [anon_sym_notnull] = ACTIONS(3483),
    [anon_sym_unmanaged] = ACTIONS(3483),
    [anon_sym_checked] = ACTIONS(3483),
    [anon_sym_BANG] = ACTIONS(3485),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_PLUS_PLUS] = ACTIONS(3485),
    [anon_sym_DASH_DASH] = ACTIONS(3485),
    [anon_sym_true] = ACTIONS(3483),
    [anon_sym_false] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3483),
    [anon_sym_STAR] = ACTIONS(3485),
    [anon_sym_CARET] = ACTIONS(3485),
    [anon_sym_AMP] = ACTIONS(3485),
    [anon_sym_this] = ACTIONS(3483),
    [anon_sym_scoped] = ACTIONS(3483),
    [anon_sym_base] = ACTIONS(3483),
    [anon_sym_var] = ACTIONS(3483),
    [sym_predefined_type] = ACTIONS(3483),
    [anon_sym_break] = ACTIONS(3483),
    [anon_sym_unchecked] = ACTIONS(3483),
    [anon_sym_continue] = ACTIONS(3483),
    [anon_sym_do] = ACTIONS(3483),
    [anon_sym_while] = ACTIONS(3483),
    [anon_sym_for] = ACTIONS(3483),
    [anon_sym_lock] = ACTIONS(3483),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_switch] = ACTIONS(3483),
    [anon_sym_default] = ACTIONS(3483),
    [anon_sym_throw] = ACTIONS(3483),
    [anon_sym_try] = ACTIONS(3483),
    [anon_sym_when] = ACTIONS(3483),
    [anon_sym_await] = ACTIONS(3483),
    [anon_sym_foreach] = ACTIONS(3483),
    [anon_sym_goto] = ACTIONS(3483),
    [anon_sym_if] = ACTIONS(3483),
    [anon_sym_DOT_DOT] = ACTIONS(3485),
    [anon_sym_from] = ACTIONS(3483),
    [anon_sym_into] = ACTIONS(3483),
    [anon_sym_join] = ACTIONS(3483),
    [anon_sym_on] = ACTIONS(3483),
    [anon_sym_equals] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_orderby] = ACTIONS(3483),
    [anon_sym_ascending] = ACTIONS(3483),
    [anon_sym_descending] = ACTIONS(3483),
    [anon_sym_group] = ACTIONS(3483),
    [anon_sym_by] = ACTIONS(3483),
    [anon_sym_select] = ACTIONS(3483),
    [anon_sym_DQUOTE] = ACTIONS(3485),
    [anon_sym_stackalloc] = ACTIONS(3483),
    [anon_sym_sizeof] = ACTIONS(3483),
    [anon_sym_typeof] = ACTIONS(3483),
    [anon_sym___makeref] = ACTIONS(3483),
    [anon_sym___reftype] = ACTIONS(3483),
    [anon_sym___refvalue] = ACTIONS(3483),
    [sym_null_literal] = ACTIONS(3483),
    [anon_sym_SQUOTE] = ACTIONS(3485),
    [sym_integer_literal] = ACTIONS(3483),
    [sym_real_literal] = ACTIONS(3485),
    [sym_verbatim_string_literal] = ACTIONS(3485),
    [aux_sym_preproc_if_token1] = ACTIONS(3485),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3485),
    [sym_interpolation_verbatim_start] = ACTIONS(3485),
    [sym_interpolation_raw_start] = ACTIONS(3485),
    [sym_raw_string_start] = ACTIONS(3485),
  },
  [2607] = {
    [sym_preproc_region] = STATE(2607),
    [sym_preproc_endregion] = STATE(2607),
    [sym_preproc_line] = STATE(2607),
    [sym_preproc_pragma] = STATE(2607),
    [sym_preproc_nullable] = STATE(2607),
    [sym_preproc_error] = STATE(2607),
    [sym_preproc_define] = STATE(2607),
    [sym_preproc_undef] = STATE(2607),
    [ts_builtin_sym_end] = ACTIONS(3661),
    [sym__identifier_token] = ACTIONS(3659),
    [anon_sym_extern] = ACTIONS(3659),
    [anon_sym_alias] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3661),
    [anon_sym_global] = ACTIONS(3659),
    [anon_sym_using] = ACTIONS(3659),
    [anon_sym_unsafe] = ACTIONS(3659),
    [anon_sym_static] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_LPAREN] = ACTIONS(3661),
    [anon_sym_return] = ACTIONS(3659),
    [anon_sym_namespace] = ACTIONS(3659),
    [anon_sym_class] = ACTIONS(3659),
    [anon_sym_ref] = ACTIONS(3659),
    [anon_sym_struct] = ACTIONS(3659),
    [anon_sym_enum] = ACTIONS(3659),
    [anon_sym_LBRACE] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3659),
    [anon_sym_delegate] = ACTIONS(3659),
    [anon_sym_record] = ACTIONS(3659),
    [anon_sym_abstract] = ACTIONS(3659),
    [anon_sym_async] = ACTIONS(3659),
    [anon_sym_const] = ACTIONS(3659),
    [anon_sym_file] = ACTIONS(3659),
    [anon_sym_fixed] = ACTIONS(3659),
    [anon_sym_internal] = ACTIONS(3659),
    [anon_sym_new] = ACTIONS(3659),
    [anon_sym_override] = ACTIONS(3659),
    [anon_sym_partial] = ACTIONS(3659),
    [anon_sym_private] = ACTIONS(3659),
    [anon_sym_protected] = ACTIONS(3659),
    [anon_sym_public] = ACTIONS(3659),
    [anon_sym_readonly] = ACTIONS(3659),
    [anon_sym_required] = ACTIONS(3659),
    [anon_sym_sealed] = ACTIONS(3659),
    [anon_sym_virtual] = ACTIONS(3659),
    [anon_sym_volatile] = ACTIONS(3659),
    [anon_sym_where] = ACTIONS(3659),
    [anon_sym_notnull] = ACTIONS(3659),
    [anon_sym_unmanaged] = ACTIONS(3659),
    [anon_sym_checked] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_PLUS_PLUS] = ACTIONS(3661),
    [anon_sym_DASH_DASH] = ACTIONS(3661),
    [anon_sym_true] = ACTIONS(3659),
    [anon_sym_false] = ACTIONS(3659),
    [anon_sym_PLUS] = ACTIONS(3659),
    [anon_sym_DASH] = ACTIONS(3659),
    [anon_sym_STAR] = ACTIONS(3661),
    [anon_sym_CARET] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_this] = ACTIONS(3659),
    [anon_sym_scoped] = ACTIONS(3659),
    [anon_sym_base] = ACTIONS(3659),
    [anon_sym_var] = ACTIONS(3659),
    [sym_predefined_type] = ACTIONS(3659),
    [anon_sym_break] = ACTIONS(3659),
    [anon_sym_unchecked] = ACTIONS(3659),
    [anon_sym_continue] = ACTIONS(3659),
    [anon_sym_do] = ACTIONS(3659),
    [anon_sym_while] = ACTIONS(3659),
    [anon_sym_for] = ACTIONS(3659),
    [anon_sym_lock] = ACTIONS(3659),
    [anon_sym_yield] = ACTIONS(3659),
    [anon_sym_switch] = ACTIONS(3659),
    [anon_sym_default] = ACTIONS(3659),
    [anon_sym_throw] = ACTIONS(3659),
    [anon_sym_try] = ACTIONS(3659),
    [anon_sym_when] = ACTIONS(3659),
    [anon_sym_await] = ACTIONS(3659),
    [anon_sym_foreach] = ACTIONS(3659),
    [anon_sym_goto] = ACTIONS(3659),
    [anon_sym_if] = ACTIONS(3659),
    [anon_sym_DOT_DOT] = ACTIONS(3661),
    [anon_sym_from] = ACTIONS(3659),
    [anon_sym_into] = ACTIONS(3659),
    [anon_sym_join] = ACTIONS(3659),
    [anon_sym_on] = ACTIONS(3659),
    [anon_sym_equals] = ACTIONS(3659),
    [anon_sym_let] = ACTIONS(3659),
    [anon_sym_orderby] = ACTIONS(3659),
    [anon_sym_ascending] = ACTIONS(3659),
    [anon_sym_descending] = ACTIONS(3659),
    [anon_sym_group] = ACTIONS(3659),
    [anon_sym_by] = ACTIONS(3659),
    [anon_sym_select] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [anon_sym_stackalloc] = ACTIONS(3659),
    [anon_sym_sizeof] = ACTIONS(3659),
    [anon_sym_typeof] = ACTIONS(3659),
    [anon_sym___makeref] = ACTIONS(3659),
    [anon_sym___reftype] = ACTIONS(3659),
    [anon_sym___refvalue] = ACTIONS(3659),
    [sym_null_literal] = ACTIONS(3659),
    [anon_sym_SQUOTE] = ACTIONS(3661),
    [sym_integer_literal] = ACTIONS(3659),
    [sym_real_literal] = ACTIONS(3661),
    [sym_verbatim_string_literal] = ACTIONS(3661),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3661),
    [sym_interpolation_verbatim_start] = ACTIONS(3661),
    [sym_interpolation_raw_start] = ACTIONS(3661),
    [sym_raw_string_start] = ACTIONS(3661),
  },
  [2608] = {
    [sym_preproc_region] = STATE(2608),
    [sym_preproc_endregion] = STATE(2608),
    [sym_preproc_line] = STATE(2608),
    [sym_preproc_pragma] = STATE(2608),
    [sym_preproc_nullable] = STATE(2608),
    [sym_preproc_error] = STATE(2608),
    [sym_preproc_define] = STATE(2608),
    [sym_preproc_undef] = STATE(2608),
    [ts_builtin_sym_end] = ACTIONS(3761),
    [sym__identifier_token] = ACTIONS(3759),
    [anon_sym_extern] = ACTIONS(3759),
    [anon_sym_alias] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_global] = ACTIONS(3759),
    [anon_sym_using] = ACTIONS(3759),
    [anon_sym_unsafe] = ACTIONS(3759),
    [anon_sym_static] = ACTIONS(3759),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(3761),
    [anon_sym_return] = ACTIONS(3759),
    [anon_sym_namespace] = ACTIONS(3759),
    [anon_sym_class] = ACTIONS(3759),
    [anon_sym_ref] = ACTIONS(3759),
    [anon_sym_struct] = ACTIONS(3759),
    [anon_sym_enum] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(3761),
    [anon_sym_interface] = ACTIONS(3759),
    [anon_sym_delegate] = ACTIONS(3759),
    [anon_sym_record] = ACTIONS(3759),
    [anon_sym_abstract] = ACTIONS(3759),
    [anon_sym_async] = ACTIONS(3759),
    [anon_sym_const] = ACTIONS(3759),
    [anon_sym_file] = ACTIONS(3759),
    [anon_sym_fixed] = ACTIONS(3759),
    [anon_sym_internal] = ACTIONS(3759),
    [anon_sym_new] = ACTIONS(3759),
    [anon_sym_override] = ACTIONS(3759),
    [anon_sym_partial] = ACTIONS(3759),
    [anon_sym_private] = ACTIONS(3759),
    [anon_sym_protected] = ACTIONS(3759),
    [anon_sym_public] = ACTIONS(3759),
    [anon_sym_readonly] = ACTIONS(3759),
    [anon_sym_required] = ACTIONS(3759),
    [anon_sym_sealed] = ACTIONS(3759),
    [anon_sym_virtual] = ACTIONS(3759),
    [anon_sym_volatile] = ACTIONS(3759),
    [anon_sym_where] = ACTIONS(3759),
    [anon_sym_notnull] = ACTIONS(3759),
    [anon_sym_unmanaged] = ACTIONS(3759),
    [anon_sym_checked] = ACTIONS(3759),
    [anon_sym_BANG] = ACTIONS(3761),
    [anon_sym_TILDE] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_true] = ACTIONS(3759),
    [anon_sym_false] = ACTIONS(3759),
    [anon_sym_PLUS] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3759),
    [anon_sym_STAR] = ACTIONS(3761),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_AMP] = ACTIONS(3761),
    [anon_sym_this] = ACTIONS(3759),
    [anon_sym_scoped] = ACTIONS(3759),
    [anon_sym_base] = ACTIONS(3759),
    [anon_sym_var] = ACTIONS(3759),
    [sym_predefined_type] = ACTIONS(3759),
    [anon_sym_break] = ACTIONS(3759),
    [anon_sym_unchecked] = ACTIONS(3759),
    [anon_sym_continue] = ACTIONS(3759),
    [anon_sym_do] = ACTIONS(3759),
    [anon_sym_while] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3759),
    [anon_sym_lock] = ACTIONS(3759),
    [anon_sym_yield] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3759),
    [anon_sym_default] = ACTIONS(3759),
    [anon_sym_throw] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3759),
    [anon_sym_when] = ACTIONS(3759),
    [anon_sym_await] = ACTIONS(3759),
    [anon_sym_foreach] = ACTIONS(3759),
    [anon_sym_goto] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3759),
    [anon_sym_DOT_DOT] = ACTIONS(3761),
    [anon_sym_from] = ACTIONS(3759),
    [anon_sym_into] = ACTIONS(3759),
    [anon_sym_join] = ACTIONS(3759),
    [anon_sym_on] = ACTIONS(3759),
    [anon_sym_equals] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3759),
    [anon_sym_orderby] = ACTIONS(3759),
    [anon_sym_ascending] = ACTIONS(3759),
    [anon_sym_descending] = ACTIONS(3759),
    [anon_sym_group] = ACTIONS(3759),
    [anon_sym_by] = ACTIONS(3759),
    [anon_sym_select] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3761),
    [anon_sym_stackalloc] = ACTIONS(3759),
    [anon_sym_sizeof] = ACTIONS(3759),
    [anon_sym_typeof] = ACTIONS(3759),
    [anon_sym___makeref] = ACTIONS(3759),
    [anon_sym___reftype] = ACTIONS(3759),
    [anon_sym___refvalue] = ACTIONS(3759),
    [sym_null_literal] = ACTIONS(3759),
    [anon_sym_SQUOTE] = ACTIONS(3761),
    [sym_integer_literal] = ACTIONS(3759),
    [sym_real_literal] = ACTIONS(3761),
    [sym_verbatim_string_literal] = ACTIONS(3761),
    [aux_sym_preproc_if_token1] = ACTIONS(3761),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3761),
    [sym_interpolation_verbatim_start] = ACTIONS(3761),
    [sym_interpolation_raw_start] = ACTIONS(3761),
    [sym_raw_string_start] = ACTIONS(3761),
  },
  [2609] = {
    [sym_catch_clause] = STATE(2654),
    [sym_preproc_region] = STATE(2609),
    [sym_preproc_endregion] = STATE(2609),
    [sym_preproc_line] = STATE(2609),
    [sym_preproc_pragma] = STATE(2609),
    [sym_preproc_nullable] = STATE(2609),
    [sym_preproc_error] = STATE(2609),
    [sym_preproc_define] = STATE(2609),
    [sym_preproc_undef] = STATE(2609),
    [aux_sym_try_statement_repeat1] = STATE(2609),
    [sym__identifier_token] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym_alias] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_global] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_unsafe] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_ref] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_delegate] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_file] = ACTIONS(3013),
    [anon_sym_fixed] = ACTIONS(3013),
    [anon_sym_internal] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_override] = ACTIONS(3013),
    [anon_sym_partial] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_readonly] = ACTIONS(3013),
    [anon_sym_required] = ACTIONS(3013),
    [anon_sym_sealed] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_where] = ACTIONS(3013),
    [anon_sym_notnull] = ACTIONS(3013),
    [anon_sym_unmanaged] = ACTIONS(3013),
    [anon_sym_checked] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_true] = ACTIONS(3013),
    [anon_sym_false] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_CARET] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3015),
    [anon_sym_this] = ACTIONS(3013),
    [anon_sym_scoped] = ACTIONS(3013),
    [anon_sym_base] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [sym_predefined_type] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_unchecked] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_lock] = ACTIONS(3013),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_catch] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(3013),
    [anon_sym_finally] = ACTIONS(3013),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_foreach] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_DOT_DOT] = ACTIONS(3015),
    [anon_sym_from] = ACTIONS(3013),
    [anon_sym_into] = ACTIONS(3013),
    [anon_sym_join] = ACTIONS(3013),
    [anon_sym_on] = ACTIONS(3013),
    [anon_sym_equals] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_orderby] = ACTIONS(3013),
    [anon_sym_ascending] = ACTIONS(3013),
    [anon_sym_descending] = ACTIONS(3013),
    [anon_sym_group] = ACTIONS(3013),
    [anon_sym_by] = ACTIONS(3013),
    [anon_sym_select] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_stackalloc] = ACTIONS(3013),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym___makeref] = ACTIONS(3013),
    [anon_sym___reftype] = ACTIONS(3013),
    [anon_sym___refvalue] = ACTIONS(3013),
    [sym_null_literal] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [sym_integer_literal] = ACTIONS(3013),
    [sym_real_literal] = ACTIONS(3015),
    [sym_verbatim_string_literal] = ACTIONS(3015),
    [aux_sym_preproc_if_token1] = ACTIONS(3015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3015),
    [sym_interpolation_verbatim_start] = ACTIONS(3015),
    [sym_interpolation_raw_start] = ACTIONS(3015),
    [sym_raw_string_start] = ACTIONS(3015),
  },
  [2610] = {
    [sym_preproc_region] = STATE(2610),
    [sym_preproc_endregion] = STATE(2610),
    [sym_preproc_line] = STATE(2610),
    [sym_preproc_pragma] = STATE(2610),
    [sym_preproc_nullable] = STATE(2610),
    [sym_preproc_error] = STATE(2610),
    [sym_preproc_define] = STATE(2610),
    [sym_preproc_undef] = STATE(2610),
    [ts_builtin_sym_end] = ACTIONS(3461),
    [sym__identifier_token] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym_alias] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3461),
    [anon_sym_global] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_unsafe] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3461),
    [anon_sym_return] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_LBRACE] = ACTIONS(3461),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3459),
    [anon_sym_record] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3459),
    [anon_sym_fixed] = ACTIONS(3459),
    [anon_sym_internal] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_partial] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_required] = ACTIONS(3459),
    [anon_sym_sealed] = ACTIONS(3459),
    [anon_sym_virtual] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3459),
    [anon_sym_unmanaged] = ACTIONS(3459),
    [anon_sym_checked] = ACTIONS(3459),
    [anon_sym_BANG] = ACTIONS(3461),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_PLUS_PLUS] = ACTIONS(3461),
    [anon_sym_DASH_DASH] = ACTIONS(3461),
    [anon_sym_true] = ACTIONS(3459),
    [anon_sym_false] = ACTIONS(3459),
    [anon_sym_PLUS] = ACTIONS(3459),
    [anon_sym_DASH] = ACTIONS(3459),
    [anon_sym_STAR] = ACTIONS(3461),
    [anon_sym_CARET] = ACTIONS(3461),
    [anon_sym_AMP] = ACTIONS(3461),
    [anon_sym_this] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3459),
    [anon_sym_base] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [sym_predefined_type] = ACTIONS(3459),
    [anon_sym_break] = ACTIONS(3459),
    [anon_sym_unchecked] = ACTIONS(3459),
    [anon_sym_continue] = ACTIONS(3459),
    [anon_sym_do] = ACTIONS(3459),
    [anon_sym_while] = ACTIONS(3459),
    [anon_sym_for] = ACTIONS(3459),
    [anon_sym_lock] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_switch] = ACTIONS(3459),
    [anon_sym_default] = ACTIONS(3459),
    [anon_sym_throw] = ACTIONS(3459),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_await] = ACTIONS(3459),
    [anon_sym_foreach] = ACTIONS(3459),
    [anon_sym_goto] = ACTIONS(3459),
    [anon_sym_if] = ACTIONS(3459),
    [anon_sym_DOT_DOT] = ACTIONS(3461),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_ascending] = ACTIONS(3459),
    [anon_sym_descending] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [anon_sym_DQUOTE] = ACTIONS(3461),
    [anon_sym_stackalloc] = ACTIONS(3459),
    [anon_sym_sizeof] = ACTIONS(3459),
    [anon_sym_typeof] = ACTIONS(3459),
    [anon_sym___makeref] = ACTIONS(3459),
    [anon_sym___reftype] = ACTIONS(3459),
    [anon_sym___refvalue] = ACTIONS(3459),
    [sym_null_literal] = ACTIONS(3459),
    [anon_sym_SQUOTE] = ACTIONS(3461),
    [sym_integer_literal] = ACTIONS(3459),
    [sym_real_literal] = ACTIONS(3461),
    [sym_verbatim_string_literal] = ACTIONS(3461),
    [aux_sym_preproc_if_token1] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3461),
    [sym_interpolation_verbatim_start] = ACTIONS(3461),
    [sym_interpolation_raw_start] = ACTIONS(3461),
    [sym_raw_string_start] = ACTIONS(3461),
  },
  [2611] = {
    [sym_preproc_region] = STATE(2611),
    [sym_preproc_endregion] = STATE(2611),
    [sym_preproc_line] = STATE(2611),
    [sym_preproc_pragma] = STATE(2611),
    [sym_preproc_nullable] = STATE(2611),
    [sym_preproc_error] = STATE(2611),
    [sym_preproc_define] = STATE(2611),
    [sym_preproc_undef] = STATE(2611),
    [ts_builtin_sym_end] = ACTIONS(3489),
    [sym__identifier_token] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym_alias] = ACTIONS(3487),
    [anon_sym_SEMI] = ACTIONS(3489),
    [anon_sym_global] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_unsafe] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LPAREN] = ACTIONS(3489),
    [anon_sym_return] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_ref] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_delegate] = ACTIONS(3487),
    [anon_sym_record] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_async] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_file] = ACTIONS(3487),
    [anon_sym_fixed] = ACTIONS(3487),
    [anon_sym_internal] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_partial] = ACTIONS(3487),
    [anon_sym_private] = ACTIONS(3487),
    [anon_sym_protected] = ACTIONS(3487),
    [anon_sym_public] = ACTIONS(3487),
    [anon_sym_readonly] = ACTIONS(3487),
    [anon_sym_required] = ACTIONS(3487),
    [anon_sym_sealed] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_where] = ACTIONS(3487),
    [anon_sym_notnull] = ACTIONS(3487),
    [anon_sym_unmanaged] = ACTIONS(3487),
    [anon_sym_checked] = ACTIONS(3487),
    [anon_sym_BANG] = ACTIONS(3489),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_PLUS_PLUS] = ACTIONS(3489),
    [anon_sym_DASH_DASH] = ACTIONS(3489),
    [anon_sym_true] = ACTIONS(3487),
    [anon_sym_false] = ACTIONS(3487),
    [anon_sym_PLUS] = ACTIONS(3487),
    [anon_sym_DASH] = ACTIONS(3487),
    [anon_sym_STAR] = ACTIONS(3489),
    [anon_sym_CARET] = ACTIONS(3489),
    [anon_sym_AMP] = ACTIONS(3489),
    [anon_sym_this] = ACTIONS(3487),
    [anon_sym_scoped] = ACTIONS(3487),
    [anon_sym_base] = ACTIONS(3487),
    [anon_sym_var] = ACTIONS(3487),
    [sym_predefined_type] = ACTIONS(3487),
    [anon_sym_break] = ACTIONS(3487),
    [anon_sym_unchecked] = ACTIONS(3487),
    [anon_sym_continue] = ACTIONS(3487),
    [anon_sym_do] = ACTIONS(3487),
    [anon_sym_while] = ACTIONS(3487),
    [anon_sym_for] = ACTIONS(3487),
    [anon_sym_lock] = ACTIONS(3487),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_switch] = ACTIONS(3487),
    [anon_sym_default] = ACTIONS(3487),
    [anon_sym_throw] = ACTIONS(3487),
    [anon_sym_try] = ACTIONS(3487),
    [anon_sym_when] = ACTIONS(3487),
    [anon_sym_await] = ACTIONS(3487),
    [anon_sym_foreach] = ACTIONS(3487),
    [anon_sym_goto] = ACTIONS(3487),
    [anon_sym_if] = ACTIONS(3487),
    [anon_sym_DOT_DOT] = ACTIONS(3489),
    [anon_sym_from] = ACTIONS(3487),
    [anon_sym_into] = ACTIONS(3487),
    [anon_sym_join] = ACTIONS(3487),
    [anon_sym_on] = ACTIONS(3487),
    [anon_sym_equals] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_orderby] = ACTIONS(3487),
    [anon_sym_ascending] = ACTIONS(3487),
    [anon_sym_descending] = ACTIONS(3487),
    [anon_sym_group] = ACTIONS(3487),
    [anon_sym_by] = ACTIONS(3487),
    [anon_sym_select] = ACTIONS(3487),
    [anon_sym_DQUOTE] = ACTIONS(3489),
    [anon_sym_stackalloc] = ACTIONS(3487),
    [anon_sym_sizeof] = ACTIONS(3487),
    [anon_sym_typeof] = ACTIONS(3487),
    [anon_sym___makeref] = ACTIONS(3487),
    [anon_sym___reftype] = ACTIONS(3487),
    [anon_sym___refvalue] = ACTIONS(3487),
    [sym_null_literal] = ACTIONS(3487),
    [anon_sym_SQUOTE] = ACTIONS(3489),
    [sym_integer_literal] = ACTIONS(3487),
    [sym_real_literal] = ACTIONS(3489),
    [sym_verbatim_string_literal] = ACTIONS(3489),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3489),
    [sym_interpolation_verbatim_start] = ACTIONS(3489),
    [sym_interpolation_raw_start] = ACTIONS(3489),
    [sym_raw_string_start] = ACTIONS(3489),
  },
  [2612] = {
    [sym_preproc_region] = STATE(2612),
    [sym_preproc_endregion] = STATE(2612),
    [sym_preproc_line] = STATE(2612),
    [sym_preproc_pragma] = STATE(2612),
    [sym_preproc_nullable] = STATE(2612),
    [sym_preproc_error] = STATE(2612),
    [sym_preproc_define] = STATE(2612),
    [sym_preproc_undef] = STATE(2612),
    [ts_builtin_sym_end] = ACTIONS(3497),
    [sym__identifier_token] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym_alias] = ACTIONS(3495),
    [anon_sym_SEMI] = ACTIONS(3497),
    [anon_sym_global] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_unsafe] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_return] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_ref] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3495),
    [anon_sym_delegate] = ACTIONS(3495),
    [anon_sym_record] = ACTIONS(3495),
    [anon_sym_abstract] = ACTIONS(3495),
    [anon_sym_async] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_file] = ACTIONS(3495),
    [anon_sym_fixed] = ACTIONS(3495),
    [anon_sym_internal] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_override] = ACTIONS(3495),
    [anon_sym_partial] = ACTIONS(3495),
    [anon_sym_private] = ACTIONS(3495),
    [anon_sym_protected] = ACTIONS(3495),
    [anon_sym_public] = ACTIONS(3495),
    [anon_sym_readonly] = ACTIONS(3495),
    [anon_sym_required] = ACTIONS(3495),
    [anon_sym_sealed] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_where] = ACTIONS(3495),
    [anon_sym_notnull] = ACTIONS(3495),
    [anon_sym_unmanaged] = ACTIONS(3495),
    [anon_sym_checked] = ACTIONS(3495),
    [anon_sym_BANG] = ACTIONS(3497),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_PLUS_PLUS] = ACTIONS(3497),
    [anon_sym_DASH_DASH] = ACTIONS(3497),
    [anon_sym_true] = ACTIONS(3495),
    [anon_sym_false] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3495),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_CARET] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_this] = ACTIONS(3495),
    [anon_sym_scoped] = ACTIONS(3495),
    [anon_sym_base] = ACTIONS(3495),
    [anon_sym_var] = ACTIONS(3495),
    [sym_predefined_type] = ACTIONS(3495),
    [anon_sym_break] = ACTIONS(3495),
    [anon_sym_unchecked] = ACTIONS(3495),
    [anon_sym_continue] = ACTIONS(3495),
    [anon_sym_do] = ACTIONS(3495),
    [anon_sym_while] = ACTIONS(3495),
    [anon_sym_for] = ACTIONS(3495),
    [anon_sym_lock] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3495),
    [anon_sym_switch] = ACTIONS(3495),
    [anon_sym_default] = ACTIONS(3495),
    [anon_sym_throw] = ACTIONS(3495),
    [anon_sym_try] = ACTIONS(3495),
    [anon_sym_when] = ACTIONS(3495),
    [anon_sym_await] = ACTIONS(3495),
    [anon_sym_foreach] = ACTIONS(3495),
    [anon_sym_goto] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(3495),
    [anon_sym_DOT_DOT] = ACTIONS(3497),
    [anon_sym_from] = ACTIONS(3495),
    [anon_sym_into] = ACTIONS(3495),
    [anon_sym_join] = ACTIONS(3495),
    [anon_sym_on] = ACTIONS(3495),
    [anon_sym_equals] = ACTIONS(3495),
    [anon_sym_let] = ACTIONS(3495),
    [anon_sym_orderby] = ACTIONS(3495),
    [anon_sym_ascending] = ACTIONS(3495),
    [anon_sym_descending] = ACTIONS(3495),
    [anon_sym_group] = ACTIONS(3495),
    [anon_sym_by] = ACTIONS(3495),
    [anon_sym_select] = ACTIONS(3495),
    [anon_sym_DQUOTE] = ACTIONS(3497),
    [anon_sym_stackalloc] = ACTIONS(3495),
    [anon_sym_sizeof] = ACTIONS(3495),
    [anon_sym_typeof] = ACTIONS(3495),
    [anon_sym___makeref] = ACTIONS(3495),
    [anon_sym___reftype] = ACTIONS(3495),
    [anon_sym___refvalue] = ACTIONS(3495),
    [sym_null_literal] = ACTIONS(3495),
    [anon_sym_SQUOTE] = ACTIONS(3497),
    [sym_integer_literal] = ACTIONS(3495),
    [sym_real_literal] = ACTIONS(3497),
    [sym_verbatim_string_literal] = ACTIONS(3497),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3497),
    [sym_interpolation_verbatim_start] = ACTIONS(3497),
    [sym_interpolation_raw_start] = ACTIONS(3497),
    [sym_raw_string_start] = ACTIONS(3497),
  },
  [2613] = {
    [sym_preproc_region] = STATE(2613),
    [sym_preproc_endregion] = STATE(2613),
    [sym_preproc_line] = STATE(2613),
    [sym_preproc_pragma] = STATE(2613),
    [sym_preproc_nullable] = STATE(2613),
    [sym_preproc_error] = STATE(2613),
    [sym_preproc_define] = STATE(2613),
    [sym_preproc_undef] = STATE(2613),
    [ts_builtin_sym_end] = ACTIONS(3501),
    [sym__identifier_token] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym_alias] = ACTIONS(3499),
    [anon_sym_SEMI] = ACTIONS(3501),
    [anon_sym_global] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_unsafe] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_return] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_ref] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_LBRACE] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3499),
    [anon_sym_delegate] = ACTIONS(3499),
    [anon_sym_record] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3499),
    [anon_sym_async] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_file] = ACTIONS(3499),
    [anon_sym_fixed] = ACTIONS(3499),
    [anon_sym_internal] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_override] = ACTIONS(3499),
    [anon_sym_partial] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_readonly] = ACTIONS(3499),
    [anon_sym_required] = ACTIONS(3499),
    [anon_sym_sealed] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_where] = ACTIONS(3499),
    [anon_sym_notnull] = ACTIONS(3499),
    [anon_sym_unmanaged] = ACTIONS(3499),
    [anon_sym_checked] = ACTIONS(3499),
    [anon_sym_BANG] = ACTIONS(3501),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_PLUS_PLUS] = ACTIONS(3501),
    [anon_sym_DASH_DASH] = ACTIONS(3501),
    [anon_sym_true] = ACTIONS(3499),
    [anon_sym_false] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(3499),
    [anon_sym_DASH] = ACTIONS(3499),
    [anon_sym_STAR] = ACTIONS(3501),
    [anon_sym_CARET] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3501),
    [anon_sym_this] = ACTIONS(3499),
    [anon_sym_scoped] = ACTIONS(3499),
    [anon_sym_base] = ACTIONS(3499),
    [anon_sym_var] = ACTIONS(3499),
    [sym_predefined_type] = ACTIONS(3499),
    [anon_sym_break] = ACTIONS(3499),
    [anon_sym_unchecked] = ACTIONS(3499),
    [anon_sym_continue] = ACTIONS(3499),
    [anon_sym_do] = ACTIONS(3499),
    [anon_sym_while] = ACTIONS(3499),
    [anon_sym_for] = ACTIONS(3499),
    [anon_sym_lock] = ACTIONS(3499),
    [anon_sym_yield] = ACTIONS(3499),
    [anon_sym_switch] = ACTIONS(3499),
    [anon_sym_default] = ACTIONS(3499),
    [anon_sym_throw] = ACTIONS(3499),
    [anon_sym_try] = ACTIONS(3499),
    [anon_sym_when] = ACTIONS(3499),
    [anon_sym_await] = ACTIONS(3499),
    [anon_sym_foreach] = ACTIONS(3499),
    [anon_sym_goto] = ACTIONS(3499),
    [anon_sym_if] = ACTIONS(3499),
    [anon_sym_DOT_DOT] = ACTIONS(3501),
    [anon_sym_from] = ACTIONS(3499),
    [anon_sym_into] = ACTIONS(3499),
    [anon_sym_join] = ACTIONS(3499),
    [anon_sym_on] = ACTIONS(3499),
    [anon_sym_equals] = ACTIONS(3499),
    [anon_sym_let] = ACTIONS(3499),
    [anon_sym_orderby] = ACTIONS(3499),
    [anon_sym_ascending] = ACTIONS(3499),
    [anon_sym_descending] = ACTIONS(3499),
    [anon_sym_group] = ACTIONS(3499),
    [anon_sym_by] = ACTIONS(3499),
    [anon_sym_select] = ACTIONS(3499),
    [anon_sym_DQUOTE] = ACTIONS(3501),
    [anon_sym_stackalloc] = ACTIONS(3499),
    [anon_sym_sizeof] = ACTIONS(3499),
    [anon_sym_typeof] = ACTIONS(3499),
    [anon_sym___makeref] = ACTIONS(3499),
    [anon_sym___reftype] = ACTIONS(3499),
    [anon_sym___refvalue] = ACTIONS(3499),
    [sym_null_literal] = ACTIONS(3499),
    [anon_sym_SQUOTE] = ACTIONS(3501),
    [sym_integer_literal] = ACTIONS(3499),
    [sym_real_literal] = ACTIONS(3501),
    [sym_verbatim_string_literal] = ACTIONS(3501),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3501),
    [sym_interpolation_verbatim_start] = ACTIONS(3501),
    [sym_interpolation_raw_start] = ACTIONS(3501),
    [sym_raw_string_start] = ACTIONS(3501),
  },
  [2614] = {
    [sym_preproc_region] = STATE(2614),
    [sym_preproc_endregion] = STATE(2614),
    [sym_preproc_line] = STATE(2614),
    [sym_preproc_pragma] = STATE(2614),
    [sym_preproc_nullable] = STATE(2614),
    [sym_preproc_error] = STATE(2614),
    [sym_preproc_define] = STATE(2614),
    [sym_preproc_undef] = STATE(2614),
    [ts_builtin_sym_end] = ACTIONS(3573),
    [sym__identifier_token] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_alias] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym_global] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_unsafe] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(3573),
    [anon_sym_return] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_ref] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(3573),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_delegate] = ACTIONS(3571),
    [anon_sym_record] = ACTIONS(3571),
    [anon_sym_abstract] = ACTIONS(3571),
    [anon_sym_async] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_file] = ACTIONS(3571),
    [anon_sym_fixed] = ACTIONS(3571),
    [anon_sym_internal] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_override] = ACTIONS(3571),
    [anon_sym_partial] = ACTIONS(3571),
    [anon_sym_private] = ACTIONS(3571),
    [anon_sym_protected] = ACTIONS(3571),
    [anon_sym_public] = ACTIONS(3571),
    [anon_sym_readonly] = ACTIONS(3571),
    [anon_sym_required] = ACTIONS(3571),
    [anon_sym_sealed] = ACTIONS(3571),
    [anon_sym_virtual] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_where] = ACTIONS(3571),
    [anon_sym_notnull] = ACTIONS(3571),
    [anon_sym_unmanaged] = ACTIONS(3571),
    [anon_sym_checked] = ACTIONS(3571),
    [anon_sym_BANG] = ACTIONS(3573),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_PLUS_PLUS] = ACTIONS(3573),
    [anon_sym_DASH_DASH] = ACTIONS(3573),
    [anon_sym_true] = ACTIONS(3571),
    [anon_sym_false] = ACTIONS(3571),
    [anon_sym_PLUS] = ACTIONS(3571),
    [anon_sym_DASH] = ACTIONS(3571),
    [anon_sym_STAR] = ACTIONS(3573),
    [anon_sym_CARET] = ACTIONS(3573),
    [anon_sym_AMP] = ACTIONS(3573),
    [anon_sym_this] = ACTIONS(3571),
    [anon_sym_scoped] = ACTIONS(3571),
    [anon_sym_base] = ACTIONS(3571),
    [anon_sym_var] = ACTIONS(3571),
    [sym_predefined_type] = ACTIONS(3571),
    [anon_sym_break] = ACTIONS(3571),
    [anon_sym_unchecked] = ACTIONS(3571),
    [anon_sym_continue] = ACTIONS(3571),
    [anon_sym_do] = ACTIONS(3571),
    [anon_sym_while] = ACTIONS(3571),
    [anon_sym_for] = ACTIONS(3571),
    [anon_sym_lock] = ACTIONS(3571),
    [anon_sym_yield] = ACTIONS(3571),
    [anon_sym_switch] = ACTIONS(3571),
    [anon_sym_default] = ACTIONS(3571),
    [anon_sym_throw] = ACTIONS(3571),
    [anon_sym_try] = ACTIONS(3571),
    [anon_sym_when] = ACTIONS(3571),
    [anon_sym_await] = ACTIONS(3571),
    [anon_sym_foreach] = ACTIONS(3571),
    [anon_sym_goto] = ACTIONS(3571),
    [anon_sym_if] = ACTIONS(3571),
    [anon_sym_DOT_DOT] = ACTIONS(3573),
    [anon_sym_from] = ACTIONS(3571),
    [anon_sym_into] = ACTIONS(3571),
    [anon_sym_join] = ACTIONS(3571),
    [anon_sym_on] = ACTIONS(3571),
    [anon_sym_equals] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_orderby] = ACTIONS(3571),
    [anon_sym_ascending] = ACTIONS(3571),
    [anon_sym_descending] = ACTIONS(3571),
    [anon_sym_group] = ACTIONS(3571),
    [anon_sym_by] = ACTIONS(3571),
    [anon_sym_select] = ACTIONS(3571),
    [anon_sym_DQUOTE] = ACTIONS(3573),
    [anon_sym_stackalloc] = ACTIONS(3571),
    [anon_sym_sizeof] = ACTIONS(3571),
    [anon_sym_typeof] = ACTIONS(3571),
    [anon_sym___makeref] = ACTIONS(3571),
    [anon_sym___reftype] = ACTIONS(3571),
    [anon_sym___refvalue] = ACTIONS(3571),
    [sym_null_literal] = ACTIONS(3571),
    [anon_sym_SQUOTE] = ACTIONS(3573),
    [sym_integer_literal] = ACTIONS(3571),
    [sym_real_literal] = ACTIONS(3573),
    [sym_verbatim_string_literal] = ACTIONS(3573),
    [aux_sym_preproc_if_token1] = ACTIONS(3573),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3573),
    [sym_interpolation_verbatim_start] = ACTIONS(3573),
    [sym_interpolation_raw_start] = ACTIONS(3573),
    [sym_raw_string_start] = ACTIONS(3573),
  },
  [2615] = {
    [sym_preproc_region] = STATE(2615),
    [sym_preproc_endregion] = STATE(2615),
    [sym_preproc_line] = STATE(2615),
    [sym_preproc_pragma] = STATE(2615),
    [sym_preproc_nullable] = STATE(2615),
    [sym_preproc_error] = STATE(2615),
    [sym_preproc_define] = STATE(2615),
    [sym_preproc_undef] = STATE(2615),
    [ts_builtin_sym_end] = ACTIONS(3845),
    [sym__identifier_token] = ACTIONS(3843),
    [anon_sym_extern] = ACTIONS(3843),
    [anon_sym_alias] = ACTIONS(3843),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_global] = ACTIONS(3843),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_unsafe] = ACTIONS(3843),
    [anon_sym_static] = ACTIONS(3843),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_return] = ACTIONS(3843),
    [anon_sym_namespace] = ACTIONS(3843),
    [anon_sym_class] = ACTIONS(3843),
    [anon_sym_ref] = ACTIONS(3843),
    [anon_sym_struct] = ACTIONS(3843),
    [anon_sym_enum] = ACTIONS(3843),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3843),
    [anon_sym_delegate] = ACTIONS(3843),
    [anon_sym_record] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3843),
    [anon_sym_async] = ACTIONS(3843),
    [anon_sym_const] = ACTIONS(3843),
    [anon_sym_file] = ACTIONS(3843),
    [anon_sym_fixed] = ACTIONS(3843),
    [anon_sym_internal] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3843),
    [anon_sym_override] = ACTIONS(3843),
    [anon_sym_partial] = ACTIONS(3843),
    [anon_sym_private] = ACTIONS(3843),
    [anon_sym_protected] = ACTIONS(3843),
    [anon_sym_public] = ACTIONS(3843),
    [anon_sym_readonly] = ACTIONS(3843),
    [anon_sym_required] = ACTIONS(3843),
    [anon_sym_sealed] = ACTIONS(3843),
    [anon_sym_virtual] = ACTIONS(3843),
    [anon_sym_volatile] = ACTIONS(3843),
    [anon_sym_where] = ACTIONS(3843),
    [anon_sym_notnull] = ACTIONS(3843),
    [anon_sym_unmanaged] = ACTIONS(3843),
    [anon_sym_checked] = ACTIONS(3843),
    [anon_sym_BANG] = ACTIONS(3845),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_PLUS_PLUS] = ACTIONS(3845),
    [anon_sym_DASH_DASH] = ACTIONS(3845),
    [anon_sym_true] = ACTIONS(3843),
    [anon_sym_false] = ACTIONS(3843),
    [anon_sym_PLUS] = ACTIONS(3843),
    [anon_sym_DASH] = ACTIONS(3843),
    [anon_sym_STAR] = ACTIONS(3845),
    [anon_sym_CARET] = ACTIONS(3845),
    [anon_sym_AMP] = ACTIONS(3845),
    [anon_sym_this] = ACTIONS(3843),
    [anon_sym_scoped] = ACTIONS(3843),
    [anon_sym_base] = ACTIONS(3843),
    [anon_sym_var] = ACTIONS(3843),
    [sym_predefined_type] = ACTIONS(3843),
    [anon_sym_break] = ACTIONS(3843),
    [anon_sym_unchecked] = ACTIONS(3843),
    [anon_sym_continue] = ACTIONS(3843),
    [anon_sym_do] = ACTIONS(3843),
    [anon_sym_while] = ACTIONS(3843),
    [anon_sym_for] = ACTIONS(3843),
    [anon_sym_lock] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3843),
    [anon_sym_switch] = ACTIONS(3843),
    [anon_sym_default] = ACTIONS(3843),
    [anon_sym_throw] = ACTIONS(3843),
    [anon_sym_try] = ACTIONS(3843),
    [anon_sym_when] = ACTIONS(3843),
    [anon_sym_await] = ACTIONS(3843),
    [anon_sym_foreach] = ACTIONS(3843),
    [anon_sym_goto] = ACTIONS(3843),
    [anon_sym_if] = ACTIONS(3843),
    [anon_sym_DOT_DOT] = ACTIONS(3845),
    [anon_sym_from] = ACTIONS(3843),
    [anon_sym_into] = ACTIONS(3843),
    [anon_sym_join] = ACTIONS(3843),
    [anon_sym_on] = ACTIONS(3843),
    [anon_sym_equals] = ACTIONS(3843),
    [anon_sym_let] = ACTIONS(3843),
    [anon_sym_orderby] = ACTIONS(3843),
    [anon_sym_ascending] = ACTIONS(3843),
    [anon_sym_descending] = ACTIONS(3843),
    [anon_sym_group] = ACTIONS(3843),
    [anon_sym_by] = ACTIONS(3843),
    [anon_sym_select] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(3845),
    [anon_sym_stackalloc] = ACTIONS(3843),
    [anon_sym_sizeof] = ACTIONS(3843),
    [anon_sym_typeof] = ACTIONS(3843),
    [anon_sym___makeref] = ACTIONS(3843),
    [anon_sym___reftype] = ACTIONS(3843),
    [anon_sym___refvalue] = ACTIONS(3843),
    [sym_null_literal] = ACTIONS(3843),
    [anon_sym_SQUOTE] = ACTIONS(3845),
    [sym_integer_literal] = ACTIONS(3843),
    [sym_real_literal] = ACTIONS(3845),
    [sym_verbatim_string_literal] = ACTIONS(3845),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3845),
    [sym_interpolation_verbatim_start] = ACTIONS(3845),
    [sym_interpolation_raw_start] = ACTIONS(3845),
    [sym_raw_string_start] = ACTIONS(3845),
  },
  [2616] = {
    [sym_preproc_region] = STATE(2616),
    [sym_preproc_endregion] = STATE(2616),
    [sym_preproc_line] = STATE(2616),
    [sym_preproc_pragma] = STATE(2616),
    [sym_preproc_nullable] = STATE(2616),
    [sym_preproc_error] = STATE(2616),
    [sym_preproc_define] = STATE(2616),
    [sym_preproc_undef] = STATE(2616),
    [ts_builtin_sym_end] = ACTIONS(3849),
    [sym__identifier_token] = ACTIONS(3847),
    [anon_sym_extern] = ACTIONS(3847),
    [anon_sym_alias] = ACTIONS(3847),
    [anon_sym_SEMI] = ACTIONS(3849),
    [anon_sym_global] = ACTIONS(3847),
    [anon_sym_using] = ACTIONS(3847),
    [anon_sym_unsafe] = ACTIONS(3847),
    [anon_sym_static] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3847),
    [anon_sym_namespace] = ACTIONS(3847),
    [anon_sym_class] = ACTIONS(3847),
    [anon_sym_ref] = ACTIONS(3847),
    [anon_sym_struct] = ACTIONS(3847),
    [anon_sym_enum] = ACTIONS(3847),
    [anon_sym_LBRACE] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3847),
    [anon_sym_delegate] = ACTIONS(3847),
    [anon_sym_record] = ACTIONS(3847),
    [anon_sym_abstract] = ACTIONS(3847),
    [anon_sym_async] = ACTIONS(3847),
    [anon_sym_const] = ACTIONS(3847),
    [anon_sym_file] = ACTIONS(3847),
    [anon_sym_fixed] = ACTIONS(3847),
    [anon_sym_internal] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_override] = ACTIONS(3847),
    [anon_sym_partial] = ACTIONS(3847),
    [anon_sym_private] = ACTIONS(3847),
    [anon_sym_protected] = ACTIONS(3847),
    [anon_sym_public] = ACTIONS(3847),
    [anon_sym_readonly] = ACTIONS(3847),
    [anon_sym_required] = ACTIONS(3847),
    [anon_sym_sealed] = ACTIONS(3847),
    [anon_sym_virtual] = ACTIONS(3847),
    [anon_sym_volatile] = ACTIONS(3847),
    [anon_sym_where] = ACTIONS(3847),
    [anon_sym_notnull] = ACTIONS(3847),
    [anon_sym_unmanaged] = ACTIONS(3847),
    [anon_sym_checked] = ACTIONS(3847),
    [anon_sym_BANG] = ACTIONS(3849),
    [anon_sym_TILDE] = ACTIONS(3849),
    [anon_sym_PLUS_PLUS] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3849),
    [anon_sym_true] = ACTIONS(3847),
    [anon_sym_false] = ACTIONS(3847),
    [anon_sym_PLUS] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3847),
    [anon_sym_STAR] = ACTIONS(3849),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_AMP] = ACTIONS(3849),
    [anon_sym_this] = ACTIONS(3847),
    [anon_sym_scoped] = ACTIONS(3847),
    [anon_sym_base] = ACTIONS(3847),
    [anon_sym_var] = ACTIONS(3847),
    [sym_predefined_type] = ACTIONS(3847),
    [anon_sym_break] = ACTIONS(3847),
    [anon_sym_unchecked] = ACTIONS(3847),
    [anon_sym_continue] = ACTIONS(3847),
    [anon_sym_do] = ACTIONS(3847),
    [anon_sym_while] = ACTIONS(3847),
    [anon_sym_for] = ACTIONS(3847),
    [anon_sym_lock] = ACTIONS(3847),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_switch] = ACTIONS(3847),
    [anon_sym_default] = ACTIONS(3847),
    [anon_sym_throw] = ACTIONS(3847),
    [anon_sym_try] = ACTIONS(3847),
    [anon_sym_when] = ACTIONS(3847),
    [anon_sym_await] = ACTIONS(3847),
    [anon_sym_foreach] = ACTIONS(3847),
    [anon_sym_goto] = ACTIONS(3847),
    [anon_sym_if] = ACTIONS(3847),
    [anon_sym_DOT_DOT] = ACTIONS(3849),
    [anon_sym_from] = ACTIONS(3847),
    [anon_sym_into] = ACTIONS(3847),
    [anon_sym_join] = ACTIONS(3847),
    [anon_sym_on] = ACTIONS(3847),
    [anon_sym_equals] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_orderby] = ACTIONS(3847),
    [anon_sym_ascending] = ACTIONS(3847),
    [anon_sym_descending] = ACTIONS(3847),
    [anon_sym_group] = ACTIONS(3847),
    [anon_sym_by] = ACTIONS(3847),
    [anon_sym_select] = ACTIONS(3847),
    [anon_sym_DQUOTE] = ACTIONS(3849),
    [anon_sym_stackalloc] = ACTIONS(3847),
    [anon_sym_sizeof] = ACTIONS(3847),
    [anon_sym_typeof] = ACTIONS(3847),
    [anon_sym___makeref] = ACTIONS(3847),
    [anon_sym___reftype] = ACTIONS(3847),
    [anon_sym___refvalue] = ACTIONS(3847),
    [sym_null_literal] = ACTIONS(3847),
    [anon_sym_SQUOTE] = ACTIONS(3849),
    [sym_integer_literal] = ACTIONS(3847),
    [sym_real_literal] = ACTIONS(3849),
    [sym_verbatim_string_literal] = ACTIONS(3849),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3849),
    [sym_interpolation_verbatim_start] = ACTIONS(3849),
    [sym_interpolation_raw_start] = ACTIONS(3849),
    [sym_raw_string_start] = ACTIONS(3849),
  },
  [2617] = {
    [sym_preproc_region] = STATE(2617),
    [sym_preproc_endregion] = STATE(2617),
    [sym_preproc_line] = STATE(2617),
    [sym_preproc_pragma] = STATE(2617),
    [sym_preproc_nullable] = STATE(2617),
    [sym_preproc_error] = STATE(2617),
    [sym_preproc_define] = STATE(2617),
    [sym_preproc_undef] = STATE(2617),
    [ts_builtin_sym_end] = ACTIONS(3673),
    [sym__identifier_token] = ACTIONS(3671),
    [anon_sym_extern] = ACTIONS(3671),
    [anon_sym_alias] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3673),
    [anon_sym_global] = ACTIONS(3671),
    [anon_sym_using] = ACTIONS(3671),
    [anon_sym_unsafe] = ACTIONS(3671),
    [anon_sym_static] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_LPAREN] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3671),
    [anon_sym_namespace] = ACTIONS(3671),
    [anon_sym_class] = ACTIONS(3671),
    [anon_sym_ref] = ACTIONS(3671),
    [anon_sym_struct] = ACTIONS(3671),
    [anon_sym_enum] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3671),
    [anon_sym_delegate] = ACTIONS(3671),
    [anon_sym_record] = ACTIONS(3671),
    [anon_sym_abstract] = ACTIONS(3671),
    [anon_sym_async] = ACTIONS(3671),
    [anon_sym_const] = ACTIONS(3671),
    [anon_sym_file] = ACTIONS(3671),
    [anon_sym_fixed] = ACTIONS(3671),
    [anon_sym_internal] = ACTIONS(3671),
    [anon_sym_new] = ACTIONS(3671),
    [anon_sym_override] = ACTIONS(3671),
    [anon_sym_partial] = ACTIONS(3671),
    [anon_sym_private] = ACTIONS(3671),
    [anon_sym_protected] = ACTIONS(3671),
    [anon_sym_public] = ACTIONS(3671),
    [anon_sym_readonly] = ACTIONS(3671),
    [anon_sym_required] = ACTIONS(3671),
    [anon_sym_sealed] = ACTIONS(3671),
    [anon_sym_virtual] = ACTIONS(3671),
    [anon_sym_volatile] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_notnull] = ACTIONS(3671),
    [anon_sym_unmanaged] = ACTIONS(3671),
    [anon_sym_checked] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3673),
    [anon_sym_TILDE] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3673),
    [anon_sym_DASH_DASH] = ACTIONS(3673),
    [anon_sym_true] = ACTIONS(3671),
    [anon_sym_false] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3671),
    [anon_sym_DASH] = ACTIONS(3671),
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3673),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_this] = ACTIONS(3671),
    [anon_sym_scoped] = ACTIONS(3671),
    [anon_sym_base] = ACTIONS(3671),
    [anon_sym_var] = ACTIONS(3671),
    [sym_predefined_type] = ACTIONS(3671),
    [anon_sym_break] = ACTIONS(3671),
    [anon_sym_unchecked] = ACTIONS(3671),
    [anon_sym_continue] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_while] = ACTIONS(3671),
    [anon_sym_for] = ACTIONS(3671),
    [anon_sym_lock] = ACTIONS(3671),
    [anon_sym_yield] = ACTIONS(3671),
    [anon_sym_switch] = ACTIONS(3671),
    [anon_sym_default] = ACTIONS(3671),
    [anon_sym_throw] = ACTIONS(3671),
    [anon_sym_try] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_await] = ACTIONS(3671),
    [anon_sym_foreach] = ACTIONS(3671),
    [anon_sym_goto] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_DOT_DOT] = ACTIONS(3673),
    [anon_sym_from] = ACTIONS(3671),
    [anon_sym_into] = ACTIONS(3671),
    [anon_sym_join] = ACTIONS(3671),
    [anon_sym_on] = ACTIONS(3671),
    [anon_sym_equals] = ACTIONS(3671),
    [anon_sym_let] = ACTIONS(3671),
    [anon_sym_orderby] = ACTIONS(3671),
    [anon_sym_ascending] = ACTIONS(3671),
    [anon_sym_descending] = ACTIONS(3671),
    [anon_sym_group] = ACTIONS(3671),
    [anon_sym_by] = ACTIONS(3671),
    [anon_sym_select] = ACTIONS(3671),
    [anon_sym_DQUOTE] = ACTIONS(3673),
    [anon_sym_stackalloc] = ACTIONS(3671),
    [anon_sym_sizeof] = ACTIONS(3671),
    [anon_sym_typeof] = ACTIONS(3671),
    [anon_sym___makeref] = ACTIONS(3671),
    [anon_sym___reftype] = ACTIONS(3671),
    [anon_sym___refvalue] = ACTIONS(3671),
    [sym_null_literal] = ACTIONS(3671),
    [anon_sym_SQUOTE] = ACTIONS(3673),
    [sym_integer_literal] = ACTIONS(3671),
    [sym_real_literal] = ACTIONS(3673),
    [sym_verbatim_string_literal] = ACTIONS(3673),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3673),
    [sym_interpolation_verbatim_start] = ACTIONS(3673),
    [sym_interpolation_raw_start] = ACTIONS(3673),
    [sym_raw_string_start] = ACTIONS(3673),
  },
  [2618] = {
    [sym_preproc_region] = STATE(2618),
    [sym_preproc_endregion] = STATE(2618),
    [sym_preproc_line] = STATE(2618),
    [sym_preproc_pragma] = STATE(2618),
    [sym_preproc_nullable] = STATE(2618),
    [sym_preproc_error] = STATE(2618),
    [sym_preproc_define] = STATE(2618),
    [sym_preproc_undef] = STATE(2618),
    [ts_builtin_sym_end] = ACTIONS(3689),
    [sym__identifier_token] = ACTIONS(3687),
    [anon_sym_extern] = ACTIONS(3687),
    [anon_sym_alias] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(3689),
    [anon_sym_global] = ACTIONS(3687),
    [anon_sym_using] = ACTIONS(3687),
    [anon_sym_unsafe] = ACTIONS(3687),
    [anon_sym_static] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_namespace] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_ref] = ACTIONS(3687),
    [anon_sym_struct] = ACTIONS(3687),
    [anon_sym_enum] = ACTIONS(3687),
    [anon_sym_LBRACE] = ACTIONS(3689),
    [anon_sym_interface] = ACTIONS(3687),
    [anon_sym_delegate] = ACTIONS(3687),
    [anon_sym_record] = ACTIONS(3687),
    [anon_sym_abstract] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_const] = ACTIONS(3687),
    [anon_sym_file] = ACTIONS(3687),
    [anon_sym_fixed] = ACTIONS(3687),
    [anon_sym_internal] = ACTIONS(3687),
    [anon_sym_new] = ACTIONS(3687),
    [anon_sym_override] = ACTIONS(3687),
    [anon_sym_partial] = ACTIONS(3687),
    [anon_sym_private] = ACTIONS(3687),
    [anon_sym_protected] = ACTIONS(3687),
    [anon_sym_public] = ACTIONS(3687),
    [anon_sym_readonly] = ACTIONS(3687),
    [anon_sym_required] = ACTIONS(3687),
    [anon_sym_sealed] = ACTIONS(3687),
    [anon_sym_virtual] = ACTIONS(3687),
    [anon_sym_volatile] = ACTIONS(3687),
    [anon_sym_where] = ACTIONS(3687),
    [anon_sym_notnull] = ACTIONS(3687),
    [anon_sym_unmanaged] = ACTIONS(3687),
    [anon_sym_checked] = ACTIONS(3687),
    [anon_sym_BANG] = ACTIONS(3689),
    [anon_sym_TILDE] = ACTIONS(3689),
    [anon_sym_PLUS_PLUS] = ACTIONS(3689),
    [anon_sym_DASH_DASH] = ACTIONS(3689),
    [anon_sym_true] = ACTIONS(3687),
    [anon_sym_false] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [anon_sym_STAR] = ACTIONS(3689),
    [anon_sym_CARET] = ACTIONS(3689),
    [anon_sym_AMP] = ACTIONS(3689),
    [anon_sym_this] = ACTIONS(3687),
    [anon_sym_scoped] = ACTIONS(3687),
    [anon_sym_base] = ACTIONS(3687),
    [anon_sym_var] = ACTIONS(3687),
    [sym_predefined_type] = ACTIONS(3687),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_unchecked] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_do] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_lock] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [anon_sym_switch] = ACTIONS(3687),
    [anon_sym_default] = ACTIONS(3687),
    [anon_sym_throw] = ACTIONS(3687),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_when] = ACTIONS(3687),
    [anon_sym_await] = ACTIONS(3687),
    [anon_sym_foreach] = ACTIONS(3687),
    [anon_sym_goto] = ACTIONS(3687),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_DOT_DOT] = ACTIONS(3689),
    [anon_sym_from] = ACTIONS(3687),
    [anon_sym_into] = ACTIONS(3687),
    [anon_sym_join] = ACTIONS(3687),
    [anon_sym_on] = ACTIONS(3687),
    [anon_sym_equals] = ACTIONS(3687),
    [anon_sym_let] = ACTIONS(3687),
    [anon_sym_orderby] = ACTIONS(3687),
    [anon_sym_ascending] = ACTIONS(3687),
    [anon_sym_descending] = ACTIONS(3687),
    [anon_sym_group] = ACTIONS(3687),
    [anon_sym_by] = ACTIONS(3687),
    [anon_sym_select] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3689),
    [anon_sym_stackalloc] = ACTIONS(3687),
    [anon_sym_sizeof] = ACTIONS(3687),
    [anon_sym_typeof] = ACTIONS(3687),
    [anon_sym___makeref] = ACTIONS(3687),
    [anon_sym___reftype] = ACTIONS(3687),
    [anon_sym___refvalue] = ACTIONS(3687),
    [sym_null_literal] = ACTIONS(3687),
    [anon_sym_SQUOTE] = ACTIONS(3689),
    [sym_integer_literal] = ACTIONS(3687),
    [sym_real_literal] = ACTIONS(3689),
    [sym_verbatim_string_literal] = ACTIONS(3689),
    [aux_sym_preproc_if_token1] = ACTIONS(3689),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3689),
    [sym_interpolation_verbatim_start] = ACTIONS(3689),
    [sym_interpolation_raw_start] = ACTIONS(3689),
    [sym_raw_string_start] = ACTIONS(3689),
  },
  [2619] = {
    [sym_preproc_region] = STATE(2619),
    [sym_preproc_endregion] = STATE(2619),
    [sym_preproc_line] = STATE(2619),
    [sym_preproc_pragma] = STATE(2619),
    [sym_preproc_nullable] = STATE(2619),
    [sym_preproc_error] = STATE(2619),
    [sym_preproc_define] = STATE(2619),
    [sym_preproc_undef] = STATE(2619),
    [ts_builtin_sym_end] = ACTIONS(3693),
    [sym__identifier_token] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym_alias] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym_global] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_unsafe] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_ref] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_delegate] = ACTIONS(3691),
    [anon_sym_record] = ACTIONS(3691),
    [anon_sym_abstract] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_file] = ACTIONS(3691),
    [anon_sym_fixed] = ACTIONS(3691),
    [anon_sym_internal] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_override] = ACTIONS(3691),
    [anon_sym_partial] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_readonly] = ACTIONS(3691),
    [anon_sym_required] = ACTIONS(3691),
    [anon_sym_sealed] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_where] = ACTIONS(3691),
    [anon_sym_notnull] = ACTIONS(3691),
    [anon_sym_unmanaged] = ACTIONS(3691),
    [anon_sym_checked] = ACTIONS(3691),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_true] = ACTIONS(3691),
    [anon_sym_false] = ACTIONS(3691),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_CARET] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3693),
    [anon_sym_this] = ACTIONS(3691),
    [anon_sym_scoped] = ACTIONS(3691),
    [anon_sym_base] = ACTIONS(3691),
    [anon_sym_var] = ACTIONS(3691),
    [sym_predefined_type] = ACTIONS(3691),
    [anon_sym_break] = ACTIONS(3691),
    [anon_sym_unchecked] = ACTIONS(3691),
    [anon_sym_continue] = ACTIONS(3691),
    [anon_sym_do] = ACTIONS(3691),
    [anon_sym_while] = ACTIONS(3691),
    [anon_sym_for] = ACTIONS(3691),
    [anon_sym_lock] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3691),
    [anon_sym_switch] = ACTIONS(3691),
    [anon_sym_default] = ACTIONS(3691),
    [anon_sym_throw] = ACTIONS(3691),
    [anon_sym_try] = ACTIONS(3691),
    [anon_sym_when] = ACTIONS(3691),
    [anon_sym_await] = ACTIONS(3691),
    [anon_sym_foreach] = ACTIONS(3691),
    [anon_sym_goto] = ACTIONS(3691),
    [anon_sym_if] = ACTIONS(3691),
    [anon_sym_DOT_DOT] = ACTIONS(3693),
    [anon_sym_from] = ACTIONS(3691),
    [anon_sym_into] = ACTIONS(3691),
    [anon_sym_join] = ACTIONS(3691),
    [anon_sym_on] = ACTIONS(3691),
    [anon_sym_equals] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_orderby] = ACTIONS(3691),
    [anon_sym_ascending] = ACTIONS(3691),
    [anon_sym_descending] = ACTIONS(3691),
    [anon_sym_group] = ACTIONS(3691),
    [anon_sym_by] = ACTIONS(3691),
    [anon_sym_select] = ACTIONS(3691),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_stackalloc] = ACTIONS(3691),
    [anon_sym_sizeof] = ACTIONS(3691),
    [anon_sym_typeof] = ACTIONS(3691),
    [anon_sym___makeref] = ACTIONS(3691),
    [anon_sym___reftype] = ACTIONS(3691),
    [anon_sym___refvalue] = ACTIONS(3691),
    [sym_null_literal] = ACTIONS(3691),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [sym_integer_literal] = ACTIONS(3691),
    [sym_real_literal] = ACTIONS(3693),
    [sym_verbatim_string_literal] = ACTIONS(3693),
    [aux_sym_preproc_if_token1] = ACTIONS(3693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3693),
    [sym_interpolation_verbatim_start] = ACTIONS(3693),
    [sym_interpolation_raw_start] = ACTIONS(3693),
    [sym_raw_string_start] = ACTIONS(3693),
  },
  [2620] = {
    [sym_preproc_region] = STATE(2620),
    [sym_preproc_endregion] = STATE(2620),
    [sym_preproc_line] = STATE(2620),
    [sym_preproc_pragma] = STATE(2620),
    [sym_preproc_nullable] = STATE(2620),
    [sym_preproc_error] = STATE(2620),
    [sym_preproc_define] = STATE(2620),
    [sym_preproc_undef] = STATE(2620),
    [ts_builtin_sym_end] = ACTIONS(3657),
    [sym__identifier_token] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym_alias] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3657),
    [anon_sym_global] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_unsafe] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3657),
    [anon_sym_LPAREN] = ACTIONS(3657),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_ref] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3657),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_delegate] = ACTIONS(3655),
    [anon_sym_record] = ACTIONS(3655),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_async] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_file] = ACTIONS(3655),
    [anon_sym_fixed] = ACTIONS(3655),
    [anon_sym_internal] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_override] = ACTIONS(3655),
    [anon_sym_partial] = ACTIONS(3655),
    [anon_sym_private] = ACTIONS(3655),
    [anon_sym_protected] = ACTIONS(3655),
    [anon_sym_public] = ACTIONS(3655),
    [anon_sym_readonly] = ACTIONS(3655),
    [anon_sym_required] = ACTIONS(3655),
    [anon_sym_sealed] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_where] = ACTIONS(3655),
    [anon_sym_notnull] = ACTIONS(3655),
    [anon_sym_unmanaged] = ACTIONS(3655),
    [anon_sym_checked] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3657),
    [anon_sym_TILDE] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3657),
    [anon_sym_DASH_DASH] = ACTIONS(3657),
    [anon_sym_true] = ACTIONS(3655),
    [anon_sym_false] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_CARET] = ACTIONS(3657),
    [anon_sym_AMP] = ACTIONS(3657),
    [anon_sym_this] = ACTIONS(3655),
    [anon_sym_scoped] = ACTIONS(3655),
    [anon_sym_base] = ACTIONS(3655),
    [anon_sym_var] = ACTIONS(3655),
    [sym_predefined_type] = ACTIONS(3655),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_unchecked] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_lock] = ACTIONS(3655),
    [anon_sym_yield] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_when] = ACTIONS(3655),
    [anon_sym_await] = ACTIONS(3655),
    [anon_sym_foreach] = ACTIONS(3655),
    [anon_sym_goto] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_DOT_DOT] = ACTIONS(3657),
    [anon_sym_from] = ACTIONS(3655),
    [anon_sym_into] = ACTIONS(3655),
    [anon_sym_join] = ACTIONS(3655),
    [anon_sym_on] = ACTIONS(3655),
    [anon_sym_equals] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_orderby] = ACTIONS(3655),
    [anon_sym_ascending] = ACTIONS(3655),
    [anon_sym_descending] = ACTIONS(3655),
    [anon_sym_group] = ACTIONS(3655),
    [anon_sym_by] = ACTIONS(3655),
    [anon_sym_select] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(3657),
    [anon_sym_stackalloc] = ACTIONS(3655),
    [anon_sym_sizeof] = ACTIONS(3655),
    [anon_sym_typeof] = ACTIONS(3655),
    [anon_sym___makeref] = ACTIONS(3655),
    [anon_sym___reftype] = ACTIONS(3655),
    [anon_sym___refvalue] = ACTIONS(3655),
    [sym_null_literal] = ACTIONS(3655),
    [anon_sym_SQUOTE] = ACTIONS(3657),
    [sym_integer_literal] = ACTIONS(3655),
    [sym_real_literal] = ACTIONS(3657),
    [sym_verbatim_string_literal] = ACTIONS(3657),
    [aux_sym_preproc_if_token1] = ACTIONS(3657),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3657),
    [sym_interpolation_verbatim_start] = ACTIONS(3657),
    [sym_interpolation_raw_start] = ACTIONS(3657),
    [sym_raw_string_start] = ACTIONS(3657),
  },
  [2621] = {
    [sym_preproc_region] = STATE(2621),
    [sym_preproc_endregion] = STATE(2621),
    [sym_preproc_line] = STATE(2621),
    [sym_preproc_pragma] = STATE(2621),
    [sym_preproc_nullable] = STATE(2621),
    [sym_preproc_error] = STATE(2621),
    [sym_preproc_define] = STATE(2621),
    [sym_preproc_undef] = STATE(2621),
    [ts_builtin_sym_end] = ACTIONS(3409),
    [sym__identifier_token] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_alias] = ACTIONS(3407),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_global] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_return] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_ref] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_LBRACE] = ACTIONS(3409),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3407),
    [anon_sym_record] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_file] = ACTIONS(3407),
    [anon_sym_fixed] = ACTIONS(3407),
    [anon_sym_internal] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_partial] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_required] = ACTIONS(3407),
    [anon_sym_sealed] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_where] = ACTIONS(3407),
    [anon_sym_notnull] = ACTIONS(3407),
    [anon_sym_unmanaged] = ACTIONS(3407),
    [anon_sym_checked] = ACTIONS(3407),
    [anon_sym_BANG] = ACTIONS(3409),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_PLUS_PLUS] = ACTIONS(3409),
    [anon_sym_DASH_DASH] = ACTIONS(3409),
    [anon_sym_true] = ACTIONS(3407),
    [anon_sym_false] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3407),
    [anon_sym_STAR] = ACTIONS(3409),
    [anon_sym_CARET] = ACTIONS(3409),
    [anon_sym_AMP] = ACTIONS(3409),
    [anon_sym_this] = ACTIONS(3407),
    [anon_sym_scoped] = ACTIONS(3407),
    [anon_sym_base] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [sym_predefined_type] = ACTIONS(3407),
    [anon_sym_break] = ACTIONS(3407),
    [anon_sym_unchecked] = ACTIONS(3407),
    [anon_sym_continue] = ACTIONS(3407),
    [anon_sym_do] = ACTIONS(3407),
    [anon_sym_while] = ACTIONS(3407),
    [anon_sym_for] = ACTIONS(3407),
    [anon_sym_lock] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_switch] = ACTIONS(3407),
    [anon_sym_default] = ACTIONS(3407),
    [anon_sym_throw] = ACTIONS(3407),
    [anon_sym_try] = ACTIONS(3407),
    [anon_sym_when] = ACTIONS(3407),
    [anon_sym_await] = ACTIONS(3407),
    [anon_sym_foreach] = ACTIONS(3407),
    [anon_sym_goto] = ACTIONS(3407),
    [anon_sym_if] = ACTIONS(3407),
    [anon_sym_DOT_DOT] = ACTIONS(3409),
    [anon_sym_from] = ACTIONS(3407),
    [anon_sym_into] = ACTIONS(3407),
    [anon_sym_join] = ACTIONS(3407),
    [anon_sym_on] = ACTIONS(3407),
    [anon_sym_equals] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_orderby] = ACTIONS(3407),
    [anon_sym_ascending] = ACTIONS(3407),
    [anon_sym_descending] = ACTIONS(3407),
    [anon_sym_group] = ACTIONS(3407),
    [anon_sym_by] = ACTIONS(3407),
    [anon_sym_select] = ACTIONS(3407),
    [anon_sym_DQUOTE] = ACTIONS(3409),
    [anon_sym_stackalloc] = ACTIONS(3407),
    [anon_sym_sizeof] = ACTIONS(3407),
    [anon_sym_typeof] = ACTIONS(3407),
    [anon_sym___makeref] = ACTIONS(3407),
    [anon_sym___reftype] = ACTIONS(3407),
    [anon_sym___refvalue] = ACTIONS(3407),
    [sym_null_literal] = ACTIONS(3407),
    [anon_sym_SQUOTE] = ACTIONS(3409),
    [sym_integer_literal] = ACTIONS(3407),
    [sym_real_literal] = ACTIONS(3409),
    [sym_verbatim_string_literal] = ACTIONS(3409),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3409),
    [sym_interpolation_verbatim_start] = ACTIONS(3409),
    [sym_interpolation_raw_start] = ACTIONS(3409),
    [sym_raw_string_start] = ACTIONS(3409),
  },
  [2622] = {
    [sym_preproc_region] = STATE(2622),
    [sym_preproc_endregion] = STATE(2622),
    [sym_preproc_line] = STATE(2622),
    [sym_preproc_pragma] = STATE(2622),
    [sym_preproc_nullable] = STATE(2622),
    [sym_preproc_error] = STATE(2622),
    [sym_preproc_define] = STATE(2622),
    [sym_preproc_undef] = STATE(2622),
    [ts_builtin_sym_end] = ACTIONS(3853),
    [sym__identifier_token] = ACTIONS(3851),
    [anon_sym_extern] = ACTIONS(3851),
    [anon_sym_alias] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3853),
    [anon_sym_global] = ACTIONS(3851),
    [anon_sym_using] = ACTIONS(3851),
    [anon_sym_unsafe] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_LPAREN] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3851),
    [anon_sym_namespace] = ACTIONS(3851),
    [anon_sym_class] = ACTIONS(3851),
    [anon_sym_ref] = ACTIONS(3851),
    [anon_sym_struct] = ACTIONS(3851),
    [anon_sym_enum] = ACTIONS(3851),
    [anon_sym_LBRACE] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3851),
    [anon_sym_delegate] = ACTIONS(3851),
    [anon_sym_record] = ACTIONS(3851),
    [anon_sym_abstract] = ACTIONS(3851),
    [anon_sym_async] = ACTIONS(3851),
    [anon_sym_const] = ACTIONS(3851),
    [anon_sym_file] = ACTIONS(3851),
    [anon_sym_fixed] = ACTIONS(3851),
    [anon_sym_internal] = ACTIONS(3851),
    [anon_sym_new] = ACTIONS(3851),
    [anon_sym_override] = ACTIONS(3851),
    [anon_sym_partial] = ACTIONS(3851),
    [anon_sym_private] = ACTIONS(3851),
    [anon_sym_protected] = ACTIONS(3851),
    [anon_sym_public] = ACTIONS(3851),
    [anon_sym_readonly] = ACTIONS(3851),
    [anon_sym_required] = ACTIONS(3851),
    [anon_sym_sealed] = ACTIONS(3851),
    [anon_sym_virtual] = ACTIONS(3851),
    [anon_sym_volatile] = ACTIONS(3851),
    [anon_sym_where] = ACTIONS(3851),
    [anon_sym_notnull] = ACTIONS(3851),
    [anon_sym_unmanaged] = ACTIONS(3851),
    [anon_sym_checked] = ACTIONS(3851),
    [anon_sym_BANG] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_PLUS_PLUS] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3853),
    [anon_sym_true] = ACTIONS(3851),
    [anon_sym_false] = ACTIONS(3851),
    [anon_sym_PLUS] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3851),
    [anon_sym_STAR] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3853),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_this] = ACTIONS(3851),
    [anon_sym_scoped] = ACTIONS(3851),
    [anon_sym_base] = ACTIONS(3851),
    [anon_sym_var] = ACTIONS(3851),
    [sym_predefined_type] = ACTIONS(3851),
    [anon_sym_break] = ACTIONS(3851),
    [anon_sym_unchecked] = ACTIONS(3851),
    [anon_sym_continue] = ACTIONS(3851),
    [anon_sym_do] = ACTIONS(3851),
    [anon_sym_while] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3851),
    [anon_sym_lock] = ACTIONS(3851),
    [anon_sym_yield] = ACTIONS(3851),
    [anon_sym_switch] = ACTIONS(3851),
    [anon_sym_default] = ACTIONS(3851),
    [anon_sym_throw] = ACTIONS(3851),
    [anon_sym_try] = ACTIONS(3851),
    [anon_sym_when] = ACTIONS(3851),
    [anon_sym_await] = ACTIONS(3851),
    [anon_sym_foreach] = ACTIONS(3851),
    [anon_sym_goto] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(3851),
    [anon_sym_DOT_DOT] = ACTIONS(3853),
    [anon_sym_from] = ACTIONS(3851),
    [anon_sym_into] = ACTIONS(3851),
    [anon_sym_join] = ACTIONS(3851),
    [anon_sym_on] = ACTIONS(3851),
    [anon_sym_equals] = ACTIONS(3851),
    [anon_sym_let] = ACTIONS(3851),
    [anon_sym_orderby] = ACTIONS(3851),
    [anon_sym_ascending] = ACTIONS(3851),
    [anon_sym_descending] = ACTIONS(3851),
    [anon_sym_group] = ACTIONS(3851),
    [anon_sym_by] = ACTIONS(3851),
    [anon_sym_select] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3853),
    [anon_sym_stackalloc] = ACTIONS(3851),
    [anon_sym_sizeof] = ACTIONS(3851),
    [anon_sym_typeof] = ACTIONS(3851),
    [anon_sym___makeref] = ACTIONS(3851),
    [anon_sym___reftype] = ACTIONS(3851),
    [anon_sym___refvalue] = ACTIONS(3851),
    [sym_null_literal] = ACTIONS(3851),
    [anon_sym_SQUOTE] = ACTIONS(3853),
    [sym_integer_literal] = ACTIONS(3851),
    [sym_real_literal] = ACTIONS(3853),
    [sym_verbatim_string_literal] = ACTIONS(3853),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3853),
    [sym_interpolation_verbatim_start] = ACTIONS(3853),
    [sym_interpolation_raw_start] = ACTIONS(3853),
    [sym_raw_string_start] = ACTIONS(3853),
  },
  [2623] = {
    [sym_preproc_region] = STATE(2623),
    [sym_preproc_endregion] = STATE(2623),
    [sym_preproc_line] = STATE(2623),
    [sym_preproc_pragma] = STATE(2623),
    [sym_preproc_nullable] = STATE(2623),
    [sym_preproc_error] = STATE(2623),
    [sym_preproc_define] = STATE(2623),
    [sym_preproc_undef] = STATE(2623),
    [ts_builtin_sym_end] = ACTIONS(3697),
    [sym__identifier_token] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym_alias] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_unsafe] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_ref] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_delegate] = ACTIONS(3695),
    [anon_sym_record] = ACTIONS(3695),
    [anon_sym_abstract] = ACTIONS(3695),
    [anon_sym_async] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_file] = ACTIONS(3695),
    [anon_sym_fixed] = ACTIONS(3695),
    [anon_sym_internal] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_override] = ACTIONS(3695),
    [anon_sym_partial] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_readonly] = ACTIONS(3695),
    [anon_sym_required] = ACTIONS(3695),
    [anon_sym_sealed] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_where] = ACTIONS(3695),
    [anon_sym_notnull] = ACTIONS(3695),
    [anon_sym_unmanaged] = ACTIONS(3695),
    [anon_sym_checked] = ACTIONS(3695),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_true] = ACTIONS(3695),
    [anon_sym_false] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_CARET] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3697),
    [anon_sym_this] = ACTIONS(3695),
    [anon_sym_scoped] = ACTIONS(3695),
    [anon_sym_base] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3695),
    [sym_predefined_type] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_unchecked] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_lock] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_when] = ACTIONS(3695),
    [anon_sym_await] = ACTIONS(3695),
    [anon_sym_foreach] = ACTIONS(3695),
    [anon_sym_goto] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_DOT_DOT] = ACTIONS(3697),
    [anon_sym_from] = ACTIONS(3695),
    [anon_sym_into] = ACTIONS(3695),
    [anon_sym_join] = ACTIONS(3695),
    [anon_sym_on] = ACTIONS(3695),
    [anon_sym_equals] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_orderby] = ACTIONS(3695),
    [anon_sym_ascending] = ACTIONS(3695),
    [anon_sym_descending] = ACTIONS(3695),
    [anon_sym_group] = ACTIONS(3695),
    [anon_sym_by] = ACTIONS(3695),
    [anon_sym_select] = ACTIONS(3695),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_stackalloc] = ACTIONS(3695),
    [anon_sym_sizeof] = ACTIONS(3695),
    [anon_sym_typeof] = ACTIONS(3695),
    [anon_sym___makeref] = ACTIONS(3695),
    [anon_sym___reftype] = ACTIONS(3695),
    [anon_sym___refvalue] = ACTIONS(3695),
    [sym_null_literal] = ACTIONS(3695),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [sym_integer_literal] = ACTIONS(3695),
    [sym_real_literal] = ACTIONS(3697),
    [sym_verbatim_string_literal] = ACTIONS(3697),
    [aux_sym_preproc_if_token1] = ACTIONS(3697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3697),
    [sym_interpolation_verbatim_start] = ACTIONS(3697),
    [sym_interpolation_raw_start] = ACTIONS(3697),
    [sym_raw_string_start] = ACTIONS(3697),
  },
  [2624] = {
    [sym_preproc_region] = STATE(2624),
    [sym_preproc_endregion] = STATE(2624),
    [sym_preproc_line] = STATE(2624),
    [sym_preproc_pragma] = STATE(2624),
    [sym_preproc_nullable] = STATE(2624),
    [sym_preproc_error] = STATE(2624),
    [sym_preproc_define] = STATE(2624),
    [sym_preproc_undef] = STATE(2624),
    [ts_builtin_sym_end] = ACTIONS(3701),
    [sym__identifier_token] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym_alias] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_unsafe] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_ref] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3701),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_delegate] = ACTIONS(3699),
    [anon_sym_record] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3699),
    [anon_sym_fixed] = ACTIONS(3699),
    [anon_sym_internal] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_override] = ACTIONS(3699),
    [anon_sym_partial] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_required] = ACTIONS(3699),
    [anon_sym_sealed] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_where] = ACTIONS(3699),
    [anon_sym_notnull] = ACTIONS(3699),
    [anon_sym_unmanaged] = ACTIONS(3699),
    [anon_sym_checked] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(3701),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_PLUS_PLUS] = ACTIONS(3701),
    [anon_sym_DASH_DASH] = ACTIONS(3701),
    [anon_sym_true] = ACTIONS(3699),
    [anon_sym_false] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3701),
    [anon_sym_CARET] = ACTIONS(3701),
    [anon_sym_AMP] = ACTIONS(3701),
    [anon_sym_this] = ACTIONS(3699),
    [anon_sym_scoped] = ACTIONS(3699),
    [anon_sym_base] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3699),
    [sym_predefined_type] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_unchecked] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_lock] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_when] = ACTIONS(3699),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_foreach] = ACTIONS(3699),
    [anon_sym_goto] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_DOT_DOT] = ACTIONS(3701),
    [anon_sym_from] = ACTIONS(3699),
    [anon_sym_into] = ACTIONS(3699),
    [anon_sym_join] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_orderby] = ACTIONS(3699),
    [anon_sym_ascending] = ACTIONS(3699),
    [anon_sym_descending] = ACTIONS(3699),
    [anon_sym_group] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_select] = ACTIONS(3699),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_stackalloc] = ACTIONS(3699),
    [anon_sym_sizeof] = ACTIONS(3699),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym___makeref] = ACTIONS(3699),
    [anon_sym___reftype] = ACTIONS(3699),
    [anon_sym___refvalue] = ACTIONS(3699),
    [sym_null_literal] = ACTIONS(3699),
    [anon_sym_SQUOTE] = ACTIONS(3701),
    [sym_integer_literal] = ACTIONS(3699),
    [sym_real_literal] = ACTIONS(3701),
    [sym_verbatim_string_literal] = ACTIONS(3701),
    [aux_sym_preproc_if_token1] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3701),
    [sym_interpolation_verbatim_start] = ACTIONS(3701),
    [sym_interpolation_raw_start] = ACTIONS(3701),
    [sym_raw_string_start] = ACTIONS(3701),
  },
  [2625] = {
    [sym_preproc_region] = STATE(2625),
    [sym_preproc_endregion] = STATE(2625),
    [sym_preproc_line] = STATE(2625),
    [sym_preproc_pragma] = STATE(2625),
    [sym_preproc_nullable] = STATE(2625),
    [sym_preproc_error] = STATE(2625),
    [sym_preproc_define] = STATE(2625),
    [sym_preproc_undef] = STATE(2625),
    [ts_builtin_sym_end] = ACTIONS(3773),
    [sym__identifier_token] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym_alias] = ACTIONS(3771),
    [anon_sym_SEMI] = ACTIONS(3773),
    [anon_sym_global] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_unsafe] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_LPAREN] = ACTIONS(3773),
    [anon_sym_return] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_ref] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_LBRACE] = ACTIONS(3773),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_delegate] = ACTIONS(3771),
    [anon_sym_record] = ACTIONS(3771),
    [anon_sym_abstract] = ACTIONS(3771),
    [anon_sym_async] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_file] = ACTIONS(3771),
    [anon_sym_fixed] = ACTIONS(3771),
    [anon_sym_internal] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_override] = ACTIONS(3771),
    [anon_sym_partial] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3771),
    [anon_sym_required] = ACTIONS(3771),
    [anon_sym_sealed] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_where] = ACTIONS(3771),
    [anon_sym_notnull] = ACTIONS(3771),
    [anon_sym_unmanaged] = ACTIONS(3771),
    [anon_sym_checked] = ACTIONS(3771),
    [anon_sym_BANG] = ACTIONS(3773),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_PLUS_PLUS] = ACTIONS(3773),
    [anon_sym_DASH_DASH] = ACTIONS(3773),
    [anon_sym_true] = ACTIONS(3771),
    [anon_sym_false] = ACTIONS(3771),
    [anon_sym_PLUS] = ACTIONS(3771),
    [anon_sym_DASH] = ACTIONS(3771),
    [anon_sym_STAR] = ACTIONS(3773),
    [anon_sym_CARET] = ACTIONS(3773),
    [anon_sym_AMP] = ACTIONS(3773),
    [anon_sym_this] = ACTIONS(3771),
    [anon_sym_scoped] = ACTIONS(3771),
    [anon_sym_base] = ACTIONS(3771),
    [anon_sym_var] = ACTIONS(3771),
    [sym_predefined_type] = ACTIONS(3771),
    [anon_sym_break] = ACTIONS(3771),
    [anon_sym_unchecked] = ACTIONS(3771),
    [anon_sym_continue] = ACTIONS(3771),
    [anon_sym_do] = ACTIONS(3771),
    [anon_sym_while] = ACTIONS(3771),
    [anon_sym_for] = ACTIONS(3771),
    [anon_sym_lock] = ACTIONS(3771),
    [anon_sym_yield] = ACTIONS(3771),
    [anon_sym_switch] = ACTIONS(3771),
    [anon_sym_default] = ACTIONS(3771),
    [anon_sym_throw] = ACTIONS(3771),
    [anon_sym_try] = ACTIONS(3771),
    [anon_sym_when] = ACTIONS(3771),
    [anon_sym_await] = ACTIONS(3771),
    [anon_sym_foreach] = ACTIONS(3771),
    [anon_sym_goto] = ACTIONS(3771),
    [anon_sym_if] = ACTIONS(3771),
    [anon_sym_DOT_DOT] = ACTIONS(3773),
    [anon_sym_from] = ACTIONS(3771),
    [anon_sym_into] = ACTIONS(3771),
    [anon_sym_join] = ACTIONS(3771),
    [anon_sym_on] = ACTIONS(3771),
    [anon_sym_equals] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_orderby] = ACTIONS(3771),
    [anon_sym_ascending] = ACTIONS(3771),
    [anon_sym_descending] = ACTIONS(3771),
    [anon_sym_group] = ACTIONS(3771),
    [anon_sym_by] = ACTIONS(3771),
    [anon_sym_select] = ACTIONS(3771),
    [anon_sym_DQUOTE] = ACTIONS(3773),
    [anon_sym_stackalloc] = ACTIONS(3771),
    [anon_sym_sizeof] = ACTIONS(3771),
    [anon_sym_typeof] = ACTIONS(3771),
    [anon_sym___makeref] = ACTIONS(3771),
    [anon_sym___reftype] = ACTIONS(3771),
    [anon_sym___refvalue] = ACTIONS(3771),
    [sym_null_literal] = ACTIONS(3771),
    [anon_sym_SQUOTE] = ACTIONS(3773),
    [sym_integer_literal] = ACTIONS(3771),
    [sym_real_literal] = ACTIONS(3773),
    [sym_verbatim_string_literal] = ACTIONS(3773),
    [aux_sym_preproc_if_token1] = ACTIONS(3773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3773),
    [sym_interpolation_verbatim_start] = ACTIONS(3773),
    [sym_interpolation_raw_start] = ACTIONS(3773),
    [sym_raw_string_start] = ACTIONS(3773),
  },
  [2626] = {
    [sym_preproc_region] = STATE(2626),
    [sym_preproc_endregion] = STATE(2626),
    [sym_preproc_line] = STATE(2626),
    [sym_preproc_pragma] = STATE(2626),
    [sym_preproc_nullable] = STATE(2626),
    [sym_preproc_error] = STATE(2626),
    [sym_preproc_define] = STATE(2626),
    [sym_preproc_undef] = STATE(2626),
    [ts_builtin_sym_end] = ACTIONS(3793),
    [sym__identifier_token] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_unsafe] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3793),
    [anon_sym_return] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_ref] = ACTIONS(3791),
    [anon_sym_struct] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_delegate] = ACTIONS(3791),
    [anon_sym_record] = ACTIONS(3791),
    [anon_sym_abstract] = ACTIONS(3791),
    [anon_sym_async] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_fixed] = ACTIONS(3791),
    [anon_sym_internal] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_override] = ACTIONS(3791),
    [anon_sym_partial] = ACTIONS(3791),
    [anon_sym_private] = ACTIONS(3791),
    [anon_sym_protected] = ACTIONS(3791),
    [anon_sym_public] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(3791),
    [anon_sym_required] = ACTIONS(3791),
    [anon_sym_sealed] = ACTIONS(3791),
    [anon_sym_virtual] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_checked] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_true] = ACTIONS(3791),
    [anon_sym_false] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_STAR] = ACTIONS(3793),
    [anon_sym_CARET] = ACTIONS(3793),
    [anon_sym_AMP] = ACTIONS(3793),
    [anon_sym_this] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_base] = ACTIONS(3791),
    [anon_sym_var] = ACTIONS(3791),
    [sym_predefined_type] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3791),
    [anon_sym_unchecked] = ACTIONS(3791),
    [anon_sym_continue] = ACTIONS(3791),
    [anon_sym_do] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3791),
    [anon_sym_for] = ACTIONS(3791),
    [anon_sym_lock] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_switch] = ACTIONS(3791),
    [anon_sym_default] = ACTIONS(3791),
    [anon_sym_throw] = ACTIONS(3791),
    [anon_sym_try] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_await] = ACTIONS(3791),
    [anon_sym_foreach] = ACTIONS(3791),
    [anon_sym_goto] = ACTIONS(3791),
    [anon_sym_if] = ACTIONS(3791),
    [anon_sym_DOT_DOT] = ACTIONS(3793),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [anon_sym_DQUOTE] = ACTIONS(3793),
    [anon_sym_stackalloc] = ACTIONS(3791),
    [anon_sym_sizeof] = ACTIONS(3791),
    [anon_sym_typeof] = ACTIONS(3791),
    [anon_sym___makeref] = ACTIONS(3791),
    [anon_sym___reftype] = ACTIONS(3791),
    [anon_sym___refvalue] = ACTIONS(3791),
    [sym_null_literal] = ACTIONS(3791),
    [anon_sym_SQUOTE] = ACTIONS(3793),
    [sym_integer_literal] = ACTIONS(3791),
    [sym_real_literal] = ACTIONS(3793),
    [sym_verbatim_string_literal] = ACTIONS(3793),
    [aux_sym_preproc_if_token1] = ACTIONS(3793),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3793),
    [sym_interpolation_verbatim_start] = ACTIONS(3793),
    [sym_interpolation_raw_start] = ACTIONS(3793),
    [sym_raw_string_start] = ACTIONS(3793),
  },
  [2627] = {
    [sym_preproc_region] = STATE(2627),
    [sym_preproc_endregion] = STATE(2627),
    [sym_preproc_line] = STATE(2627),
    [sym_preproc_pragma] = STATE(2627),
    [sym_preproc_nullable] = STATE(2627),
    [sym_preproc_error] = STATE(2627),
    [sym_preproc_define] = STATE(2627),
    [sym_preproc_undef] = STATE(2627),
    [ts_builtin_sym_end] = ACTIONS(3797),
    [sym__identifier_token] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym_alias] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym_global] = ACTIONS(3795),
    [anon_sym_using] = ACTIONS(3795),
    [anon_sym_unsafe] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(3797),
    [anon_sym_return] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_ref] = ACTIONS(3795),
    [anon_sym_struct] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_delegate] = ACTIONS(3795),
    [anon_sym_record] = ACTIONS(3795),
    [anon_sym_abstract] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_file] = ACTIONS(3795),
    [anon_sym_fixed] = ACTIONS(3795),
    [anon_sym_internal] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [anon_sym_override] = ACTIONS(3795),
    [anon_sym_partial] = ACTIONS(3795),
    [anon_sym_private] = ACTIONS(3795),
    [anon_sym_protected] = ACTIONS(3795),
    [anon_sym_public] = ACTIONS(3795),
    [anon_sym_readonly] = ACTIONS(3795),
    [anon_sym_required] = ACTIONS(3795),
    [anon_sym_sealed] = ACTIONS(3795),
    [anon_sym_virtual] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_where] = ACTIONS(3795),
    [anon_sym_notnull] = ACTIONS(3795),
    [anon_sym_unmanaged] = ACTIONS(3795),
    [anon_sym_checked] = ACTIONS(3795),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_true] = ACTIONS(3795),
    [anon_sym_false] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_STAR] = ACTIONS(3797),
    [anon_sym_CARET] = ACTIONS(3797),
    [anon_sym_AMP] = ACTIONS(3797),
    [anon_sym_this] = ACTIONS(3795),
    [anon_sym_scoped] = ACTIONS(3795),
    [anon_sym_base] = ACTIONS(3795),
    [anon_sym_var] = ACTIONS(3795),
    [sym_predefined_type] = ACTIONS(3795),
    [anon_sym_break] = ACTIONS(3795),
    [anon_sym_unchecked] = ACTIONS(3795),
    [anon_sym_continue] = ACTIONS(3795),
    [anon_sym_do] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_for] = ACTIONS(3795),
    [anon_sym_lock] = ACTIONS(3795),
    [anon_sym_yield] = ACTIONS(3795),
    [anon_sym_switch] = ACTIONS(3795),
    [anon_sym_default] = ACTIONS(3795),
    [anon_sym_throw] = ACTIONS(3795),
    [anon_sym_try] = ACTIONS(3795),
    [anon_sym_when] = ACTIONS(3795),
    [anon_sym_await] = ACTIONS(3795),
    [anon_sym_foreach] = ACTIONS(3795),
    [anon_sym_goto] = ACTIONS(3795),
    [anon_sym_if] = ACTIONS(3795),
    [anon_sym_DOT_DOT] = ACTIONS(3797),
    [anon_sym_from] = ACTIONS(3795),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3795),
    [anon_sym_on] = ACTIONS(3795),
    [anon_sym_equals] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_orderby] = ACTIONS(3795),
    [anon_sym_ascending] = ACTIONS(3795),
    [anon_sym_descending] = ACTIONS(3795),
    [anon_sym_group] = ACTIONS(3795),
    [anon_sym_by] = ACTIONS(3795),
    [anon_sym_select] = ACTIONS(3795),
    [anon_sym_DQUOTE] = ACTIONS(3797),
    [anon_sym_stackalloc] = ACTIONS(3795),
    [anon_sym_sizeof] = ACTIONS(3795),
    [anon_sym_typeof] = ACTIONS(3795),
    [anon_sym___makeref] = ACTIONS(3795),
    [anon_sym___reftype] = ACTIONS(3795),
    [anon_sym___refvalue] = ACTIONS(3795),
    [sym_null_literal] = ACTIONS(3795),
    [anon_sym_SQUOTE] = ACTIONS(3797),
    [sym_integer_literal] = ACTIONS(3795),
    [sym_real_literal] = ACTIONS(3797),
    [sym_verbatim_string_literal] = ACTIONS(3797),
    [aux_sym_preproc_if_token1] = ACTIONS(3797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3797),
    [sym_interpolation_verbatim_start] = ACTIONS(3797),
    [sym_interpolation_raw_start] = ACTIONS(3797),
    [sym_raw_string_start] = ACTIONS(3797),
  },
  [2628] = {
    [sym_preproc_region] = STATE(2628),
    [sym_preproc_endregion] = STATE(2628),
    [sym_preproc_line] = STATE(2628),
    [sym_preproc_pragma] = STATE(2628),
    [sym_preproc_nullable] = STATE(2628),
    [sym_preproc_error] = STATE(2628),
    [sym_preproc_define] = STATE(2628),
    [sym_preproc_undef] = STATE(2628),
    [ts_builtin_sym_end] = ACTIONS(3805),
    [sym__identifier_token] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym_alias] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3805),
    [anon_sym_global] = ACTIONS(3803),
    [anon_sym_using] = ACTIONS(3803),
    [anon_sym_unsafe] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3805),
    [anon_sym_return] = ACTIONS(3803),
    [anon_sym_namespace] = ACTIONS(3803),
    [anon_sym_class] = ACTIONS(3803),
    [anon_sym_ref] = ACTIONS(3803),
    [anon_sym_struct] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(3803),
    [anon_sym_LBRACE] = ACTIONS(3805),
    [anon_sym_interface] = ACTIONS(3803),
    [anon_sym_delegate] = ACTIONS(3803),
    [anon_sym_record] = ACTIONS(3803),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_async] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_file] = ACTIONS(3803),
    [anon_sym_fixed] = ACTIONS(3803),
    [anon_sym_internal] = ACTIONS(3803),
    [anon_sym_new] = ACTIONS(3803),
    [anon_sym_override] = ACTIONS(3803),
    [anon_sym_partial] = ACTIONS(3803),
    [anon_sym_private] = ACTIONS(3803),
    [anon_sym_protected] = ACTIONS(3803),
    [anon_sym_public] = ACTIONS(3803),
    [anon_sym_readonly] = ACTIONS(3803),
    [anon_sym_required] = ACTIONS(3803),
    [anon_sym_sealed] = ACTIONS(3803),
    [anon_sym_virtual] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_where] = ACTIONS(3803),
    [anon_sym_notnull] = ACTIONS(3803),
    [anon_sym_unmanaged] = ACTIONS(3803),
    [anon_sym_checked] = ACTIONS(3803),
    [anon_sym_BANG] = ACTIONS(3805),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_PLUS_PLUS] = ACTIONS(3805),
    [anon_sym_DASH_DASH] = ACTIONS(3805),
    [anon_sym_true] = ACTIONS(3803),
    [anon_sym_false] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_STAR] = ACTIONS(3805),
    [anon_sym_CARET] = ACTIONS(3805),
    [anon_sym_AMP] = ACTIONS(3805),
    [anon_sym_this] = ACTIONS(3803),
    [anon_sym_scoped] = ACTIONS(3803),
    [anon_sym_base] = ACTIONS(3803),
    [anon_sym_var] = ACTIONS(3803),
    [sym_predefined_type] = ACTIONS(3803),
    [anon_sym_break] = ACTIONS(3803),
    [anon_sym_unchecked] = ACTIONS(3803),
    [anon_sym_continue] = ACTIONS(3803),
    [anon_sym_do] = ACTIONS(3803),
    [anon_sym_while] = ACTIONS(3803),
    [anon_sym_for] = ACTIONS(3803),
    [anon_sym_lock] = ACTIONS(3803),
    [anon_sym_yield] = ACTIONS(3803),
    [anon_sym_switch] = ACTIONS(3803),
    [anon_sym_default] = ACTIONS(3803),
    [anon_sym_throw] = ACTIONS(3803),
    [anon_sym_try] = ACTIONS(3803),
    [anon_sym_when] = ACTIONS(3803),
    [anon_sym_await] = ACTIONS(3803),
    [anon_sym_foreach] = ACTIONS(3803),
    [anon_sym_goto] = ACTIONS(3803),
    [anon_sym_if] = ACTIONS(3803),
    [anon_sym_DOT_DOT] = ACTIONS(3805),
    [anon_sym_from] = ACTIONS(3803),
    [anon_sym_into] = ACTIONS(3803),
    [anon_sym_join] = ACTIONS(3803),
    [anon_sym_on] = ACTIONS(3803),
    [anon_sym_equals] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_orderby] = ACTIONS(3803),
    [anon_sym_ascending] = ACTIONS(3803),
    [anon_sym_descending] = ACTIONS(3803),
    [anon_sym_group] = ACTIONS(3803),
    [anon_sym_by] = ACTIONS(3803),
    [anon_sym_select] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(3805),
    [anon_sym_stackalloc] = ACTIONS(3803),
    [anon_sym_sizeof] = ACTIONS(3803),
    [anon_sym_typeof] = ACTIONS(3803),
    [anon_sym___makeref] = ACTIONS(3803),
    [anon_sym___reftype] = ACTIONS(3803),
    [anon_sym___refvalue] = ACTIONS(3803),
    [sym_null_literal] = ACTIONS(3803),
    [anon_sym_SQUOTE] = ACTIONS(3805),
    [sym_integer_literal] = ACTIONS(3803),
    [sym_real_literal] = ACTIONS(3805),
    [sym_verbatim_string_literal] = ACTIONS(3805),
    [aux_sym_preproc_if_token1] = ACTIONS(3805),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3805),
    [sym_interpolation_verbatim_start] = ACTIONS(3805),
    [sym_interpolation_raw_start] = ACTIONS(3805),
    [sym_raw_string_start] = ACTIONS(3805),
  },
  [2629] = {
    [sym_preproc_region] = STATE(2629),
    [sym_preproc_endregion] = STATE(2629),
    [sym_preproc_line] = STATE(2629),
    [sym_preproc_pragma] = STATE(2629),
    [sym_preproc_nullable] = STATE(2629),
    [sym_preproc_error] = STATE(2629),
    [sym_preproc_define] = STATE(2629),
    [sym_preproc_undef] = STATE(2629),
    [ts_builtin_sym_end] = ACTIONS(3813),
    [sym__identifier_token] = ACTIONS(3811),
    [anon_sym_extern] = ACTIONS(3811),
    [anon_sym_alias] = ACTIONS(3811),
    [anon_sym_SEMI] = ACTIONS(3813),
    [anon_sym_global] = ACTIONS(3811),
    [anon_sym_using] = ACTIONS(3811),
    [anon_sym_unsafe] = ACTIONS(3811),
    [anon_sym_static] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_return] = ACTIONS(3811),
    [anon_sym_namespace] = ACTIONS(3811),
    [anon_sym_class] = ACTIONS(3811),
    [anon_sym_ref] = ACTIONS(3811),
    [anon_sym_struct] = ACTIONS(3811),
    [anon_sym_enum] = ACTIONS(3811),
    [anon_sym_LBRACE] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3811),
    [anon_sym_delegate] = ACTIONS(3811),
    [anon_sym_record] = ACTIONS(3811),
    [anon_sym_abstract] = ACTIONS(3811),
    [anon_sym_async] = ACTIONS(3811),
    [anon_sym_const] = ACTIONS(3811),
    [anon_sym_file] = ACTIONS(3811),
    [anon_sym_fixed] = ACTIONS(3811),
    [anon_sym_internal] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3811),
    [anon_sym_override] = ACTIONS(3811),
    [anon_sym_partial] = ACTIONS(3811),
    [anon_sym_private] = ACTIONS(3811),
    [anon_sym_protected] = ACTIONS(3811),
    [anon_sym_public] = ACTIONS(3811),
    [anon_sym_readonly] = ACTIONS(3811),
    [anon_sym_required] = ACTIONS(3811),
    [anon_sym_sealed] = ACTIONS(3811),
    [anon_sym_virtual] = ACTIONS(3811),
    [anon_sym_volatile] = ACTIONS(3811),
    [anon_sym_where] = ACTIONS(3811),
    [anon_sym_notnull] = ACTIONS(3811),
    [anon_sym_unmanaged] = ACTIONS(3811),
    [anon_sym_checked] = ACTIONS(3811),
    [anon_sym_BANG] = ACTIONS(3813),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_PLUS_PLUS] = ACTIONS(3813),
    [anon_sym_DASH_DASH] = ACTIONS(3813),
    [anon_sym_true] = ACTIONS(3811),
    [anon_sym_false] = ACTIONS(3811),
    [anon_sym_PLUS] = ACTIONS(3811),
    [anon_sym_DASH] = ACTIONS(3811),
    [anon_sym_STAR] = ACTIONS(3813),
    [anon_sym_CARET] = ACTIONS(3813),
    [anon_sym_AMP] = ACTIONS(3813),
    [anon_sym_this] = ACTIONS(3811),
    [anon_sym_scoped] = ACTIONS(3811),
    [anon_sym_base] = ACTIONS(3811),
    [anon_sym_var] = ACTIONS(3811),
    [sym_predefined_type] = ACTIONS(3811),
    [anon_sym_break] = ACTIONS(3811),
    [anon_sym_unchecked] = ACTIONS(3811),
    [anon_sym_continue] = ACTIONS(3811),
    [anon_sym_do] = ACTIONS(3811),
    [anon_sym_while] = ACTIONS(3811),
    [anon_sym_for] = ACTIONS(3811),
    [anon_sym_lock] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3811),
    [anon_sym_switch] = ACTIONS(3811),
    [anon_sym_default] = ACTIONS(3811),
    [anon_sym_throw] = ACTIONS(3811),
    [anon_sym_try] = ACTIONS(3811),
    [anon_sym_when] = ACTIONS(3811),
    [anon_sym_await] = ACTIONS(3811),
    [anon_sym_foreach] = ACTIONS(3811),
    [anon_sym_goto] = ACTIONS(3811),
    [anon_sym_if] = ACTIONS(3811),
    [anon_sym_DOT_DOT] = ACTIONS(3813),
    [anon_sym_from] = ACTIONS(3811),
    [anon_sym_into] = ACTIONS(3811),
    [anon_sym_join] = ACTIONS(3811),
    [anon_sym_on] = ACTIONS(3811),
    [anon_sym_equals] = ACTIONS(3811),
    [anon_sym_let] = ACTIONS(3811),
    [anon_sym_orderby] = ACTIONS(3811),
    [anon_sym_ascending] = ACTIONS(3811),
    [anon_sym_descending] = ACTIONS(3811),
    [anon_sym_group] = ACTIONS(3811),
    [anon_sym_by] = ACTIONS(3811),
    [anon_sym_select] = ACTIONS(3811),
    [anon_sym_DQUOTE] = ACTIONS(3813),
    [anon_sym_stackalloc] = ACTIONS(3811),
    [anon_sym_sizeof] = ACTIONS(3811),
    [anon_sym_typeof] = ACTIONS(3811),
    [anon_sym___makeref] = ACTIONS(3811),
    [anon_sym___reftype] = ACTIONS(3811),
    [anon_sym___refvalue] = ACTIONS(3811),
    [sym_null_literal] = ACTIONS(3811),
    [anon_sym_SQUOTE] = ACTIONS(3813),
    [sym_integer_literal] = ACTIONS(3811),
    [sym_real_literal] = ACTIONS(3813),
    [sym_verbatim_string_literal] = ACTIONS(3813),
    [aux_sym_preproc_if_token1] = ACTIONS(3813),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3813),
    [sym_interpolation_verbatim_start] = ACTIONS(3813),
    [sym_interpolation_raw_start] = ACTIONS(3813),
    [sym_raw_string_start] = ACTIONS(3813),
  },
  [2630] = {
    [sym_preproc_region] = STATE(2630),
    [sym_preproc_endregion] = STATE(2630),
    [sym_preproc_line] = STATE(2630),
    [sym_preproc_pragma] = STATE(2630),
    [sym_preproc_nullable] = STATE(2630),
    [sym_preproc_error] = STATE(2630),
    [sym_preproc_define] = STATE(2630),
    [sym_preproc_undef] = STATE(2630),
    [ts_builtin_sym_end] = ACTIONS(3959),
    [sym__identifier_token] = ACTIONS(3957),
    [anon_sym_extern] = ACTIONS(3957),
    [anon_sym_alias] = ACTIONS(3957),
    [anon_sym_SEMI] = ACTIONS(3959),
    [anon_sym_global] = ACTIONS(3957),
    [anon_sym_using] = ACTIONS(3957),
    [anon_sym_unsafe] = ACTIONS(3957),
    [anon_sym_static] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3959),
    [anon_sym_return] = ACTIONS(3957),
    [anon_sym_namespace] = ACTIONS(3957),
    [anon_sym_class] = ACTIONS(3957),
    [anon_sym_ref] = ACTIONS(3957),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_enum] = ACTIONS(3957),
    [anon_sym_LBRACE] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3957),
    [anon_sym_delegate] = ACTIONS(3957),
    [anon_sym_record] = ACTIONS(3957),
    [anon_sym_abstract] = ACTIONS(3957),
    [anon_sym_async] = ACTIONS(3957),
    [anon_sym_const] = ACTIONS(3957),
    [anon_sym_file] = ACTIONS(3957),
    [anon_sym_fixed] = ACTIONS(3957),
    [anon_sym_internal] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_override] = ACTIONS(3957),
    [anon_sym_partial] = ACTIONS(3957),
    [anon_sym_private] = ACTIONS(3957),
    [anon_sym_protected] = ACTIONS(3957),
    [anon_sym_public] = ACTIONS(3957),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_required] = ACTIONS(3957),
    [anon_sym_sealed] = ACTIONS(3957),
    [anon_sym_virtual] = ACTIONS(3957),
    [anon_sym_volatile] = ACTIONS(3957),
    [anon_sym_where] = ACTIONS(3957),
    [anon_sym_notnull] = ACTIONS(3957),
    [anon_sym_unmanaged] = ACTIONS(3957),
    [anon_sym_checked] = ACTIONS(3957),
    [anon_sym_BANG] = ACTIONS(3959),
    [anon_sym_TILDE] = ACTIONS(3959),
    [anon_sym_PLUS_PLUS] = ACTIONS(3959),
    [anon_sym_DASH_DASH] = ACTIONS(3959),
    [anon_sym_true] = ACTIONS(3957),
    [anon_sym_false] = ACTIONS(3957),
    [anon_sym_PLUS] = ACTIONS(3957),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_STAR] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3959),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_this] = ACTIONS(3957),
    [anon_sym_scoped] = ACTIONS(3957),
    [anon_sym_base] = ACTIONS(3957),
    [anon_sym_var] = ACTIONS(3957),
    [sym_predefined_type] = ACTIONS(3957),
    [anon_sym_break] = ACTIONS(3957),
    [anon_sym_unchecked] = ACTIONS(3957),
    [anon_sym_continue] = ACTIONS(3957),
    [anon_sym_do] = ACTIONS(3957),
    [anon_sym_while] = ACTIONS(3957),
    [anon_sym_for] = ACTIONS(3957),
    [anon_sym_lock] = ACTIONS(3957),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_switch] = ACTIONS(3957),
    [anon_sym_default] = ACTIONS(3957),
    [anon_sym_throw] = ACTIONS(3957),
    [anon_sym_try] = ACTIONS(3957),
    [anon_sym_when] = ACTIONS(3957),
    [anon_sym_await] = ACTIONS(3957),
    [anon_sym_foreach] = ACTIONS(3957),
    [anon_sym_goto] = ACTIONS(3957),
    [anon_sym_if] = ACTIONS(3957),
    [anon_sym_DOT_DOT] = ACTIONS(3959),
    [anon_sym_from] = ACTIONS(3957),
    [anon_sym_into] = ACTIONS(3957),
    [anon_sym_join] = ACTIONS(3957),
    [anon_sym_on] = ACTIONS(3957),
    [anon_sym_equals] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_orderby] = ACTIONS(3957),
    [anon_sym_ascending] = ACTIONS(3957),
    [anon_sym_descending] = ACTIONS(3957),
    [anon_sym_group] = ACTIONS(3957),
    [anon_sym_by] = ACTIONS(3957),
    [anon_sym_select] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(3959),
    [anon_sym_stackalloc] = ACTIONS(3957),
    [anon_sym_sizeof] = ACTIONS(3957),
    [anon_sym_typeof] = ACTIONS(3957),
    [anon_sym___makeref] = ACTIONS(3957),
    [anon_sym___reftype] = ACTIONS(3957),
    [anon_sym___refvalue] = ACTIONS(3957),
    [sym_null_literal] = ACTIONS(3957),
    [anon_sym_SQUOTE] = ACTIONS(3959),
    [sym_integer_literal] = ACTIONS(3957),
    [sym_real_literal] = ACTIONS(3959),
    [sym_verbatim_string_literal] = ACTIONS(3959),
    [aux_sym_preproc_if_token1] = ACTIONS(3959),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3959),
    [sym_interpolation_verbatim_start] = ACTIONS(3959),
    [sym_interpolation_raw_start] = ACTIONS(3959),
    [sym_raw_string_start] = ACTIONS(3959),
  },
  [2631] = {
    [sym_preproc_region] = STATE(2631),
    [sym_preproc_endregion] = STATE(2631),
    [sym_preproc_line] = STATE(2631),
    [sym_preproc_pragma] = STATE(2631),
    [sym_preproc_nullable] = STATE(2631),
    [sym_preproc_error] = STATE(2631),
    [sym_preproc_define] = STATE(2631),
    [sym_preproc_undef] = STATE(2631),
    [ts_builtin_sym_end] = ACTIONS(3557),
    [sym__identifier_token] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym_alias] = ACTIONS(3555),
    [anon_sym_SEMI] = ACTIONS(3557),
    [anon_sym_global] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_unsafe] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_return] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_ref] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_LBRACE] = ACTIONS(3557),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_delegate] = ACTIONS(3555),
    [anon_sym_record] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_async] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_file] = ACTIONS(3555),
    [anon_sym_fixed] = ACTIONS(3555),
    [anon_sym_internal] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [anon_sym_partial] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_readonly] = ACTIONS(3555),
    [anon_sym_required] = ACTIONS(3555),
    [anon_sym_sealed] = ACTIONS(3555),
    [anon_sym_virtual] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_where] = ACTIONS(3555),
    [anon_sym_notnull] = ACTIONS(3555),
    [anon_sym_unmanaged] = ACTIONS(3555),
    [anon_sym_checked] = ACTIONS(3555),
    [anon_sym_BANG] = ACTIONS(3557),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_PLUS_PLUS] = ACTIONS(3557),
    [anon_sym_DASH_DASH] = ACTIONS(3557),
    [anon_sym_true] = ACTIONS(3555),
    [anon_sym_false] = ACTIONS(3555),
    [anon_sym_PLUS] = ACTIONS(3555),
    [anon_sym_DASH] = ACTIONS(3555),
    [anon_sym_STAR] = ACTIONS(3557),
    [anon_sym_CARET] = ACTIONS(3557),
    [anon_sym_AMP] = ACTIONS(3557),
    [anon_sym_this] = ACTIONS(3555),
    [anon_sym_scoped] = ACTIONS(3555),
    [anon_sym_base] = ACTIONS(3555),
    [anon_sym_var] = ACTIONS(3555),
    [sym_predefined_type] = ACTIONS(3555),
    [anon_sym_break] = ACTIONS(3555),
    [anon_sym_unchecked] = ACTIONS(3555),
    [anon_sym_continue] = ACTIONS(3555),
    [anon_sym_do] = ACTIONS(3555),
    [anon_sym_while] = ACTIONS(3555),
    [anon_sym_for] = ACTIONS(3555),
    [anon_sym_lock] = ACTIONS(3555),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_switch] = ACTIONS(3555),
    [anon_sym_default] = ACTIONS(3555),
    [anon_sym_throw] = ACTIONS(3555),
    [anon_sym_try] = ACTIONS(3555),
    [anon_sym_when] = ACTIONS(3555),
    [anon_sym_await] = ACTIONS(3555),
    [anon_sym_foreach] = ACTIONS(3555),
    [anon_sym_goto] = ACTIONS(3555),
    [anon_sym_if] = ACTIONS(3555),
    [anon_sym_DOT_DOT] = ACTIONS(3557),
    [anon_sym_from] = ACTIONS(3555),
    [anon_sym_into] = ACTIONS(3555),
    [anon_sym_join] = ACTIONS(3555),
    [anon_sym_on] = ACTIONS(3555),
    [anon_sym_equals] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_orderby] = ACTIONS(3555),
    [anon_sym_ascending] = ACTIONS(3555),
    [anon_sym_descending] = ACTIONS(3555),
    [anon_sym_group] = ACTIONS(3555),
    [anon_sym_by] = ACTIONS(3555),
    [anon_sym_select] = ACTIONS(3555),
    [anon_sym_DQUOTE] = ACTIONS(3557),
    [anon_sym_stackalloc] = ACTIONS(3555),
    [anon_sym_sizeof] = ACTIONS(3555),
    [anon_sym_typeof] = ACTIONS(3555),
    [anon_sym___makeref] = ACTIONS(3555),
    [anon_sym___reftype] = ACTIONS(3555),
    [anon_sym___refvalue] = ACTIONS(3555),
    [sym_null_literal] = ACTIONS(3555),
    [anon_sym_SQUOTE] = ACTIONS(3557),
    [sym_integer_literal] = ACTIONS(3555),
    [sym_real_literal] = ACTIONS(3557),
    [sym_verbatim_string_literal] = ACTIONS(3557),
    [aux_sym_preproc_if_token1] = ACTIONS(3557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3557),
    [sym_interpolation_verbatim_start] = ACTIONS(3557),
    [sym_interpolation_raw_start] = ACTIONS(3557),
    [sym_raw_string_start] = ACTIONS(3557),
  },
  [2632] = {
    [sym_preproc_region] = STATE(2632),
    [sym_preproc_endregion] = STATE(2632),
    [sym_preproc_line] = STATE(2632),
    [sym_preproc_pragma] = STATE(2632),
    [sym_preproc_nullable] = STATE(2632),
    [sym_preproc_error] = STATE(2632),
    [sym_preproc_define] = STATE(2632),
    [sym_preproc_undef] = STATE(2632),
    [ts_builtin_sym_end] = ACTIONS(3549),
    [sym__identifier_token] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym_alias] = ACTIONS(3547),
    [anon_sym_SEMI] = ACTIONS(3549),
    [anon_sym_global] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_unsafe] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3549),
    [anon_sym_return] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_ref] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_LBRACE] = ACTIONS(3549),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_delegate] = ACTIONS(3547),
    [anon_sym_record] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_async] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_file] = ACTIONS(3547),
    [anon_sym_fixed] = ACTIONS(3547),
    [anon_sym_internal] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [anon_sym_partial] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_required] = ACTIONS(3547),
    [anon_sym_sealed] = ACTIONS(3547),
    [anon_sym_virtual] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_where] = ACTIONS(3547),
    [anon_sym_notnull] = ACTIONS(3547),
    [anon_sym_unmanaged] = ACTIONS(3547),
    [anon_sym_checked] = ACTIONS(3547),
    [anon_sym_BANG] = ACTIONS(3549),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(3549),
    [anon_sym_DASH_DASH] = ACTIONS(3549),
    [anon_sym_true] = ACTIONS(3547),
    [anon_sym_false] = ACTIONS(3547),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_STAR] = ACTIONS(3549),
    [anon_sym_CARET] = ACTIONS(3549),
    [anon_sym_AMP] = ACTIONS(3549),
    [anon_sym_this] = ACTIONS(3547),
    [anon_sym_scoped] = ACTIONS(3547),
    [anon_sym_base] = ACTIONS(3547),
    [anon_sym_var] = ACTIONS(3547),
    [sym_predefined_type] = ACTIONS(3547),
    [anon_sym_break] = ACTIONS(3547),
    [anon_sym_unchecked] = ACTIONS(3547),
    [anon_sym_continue] = ACTIONS(3547),
    [anon_sym_do] = ACTIONS(3547),
    [anon_sym_while] = ACTIONS(3547),
    [anon_sym_for] = ACTIONS(3547),
    [anon_sym_lock] = ACTIONS(3547),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_switch] = ACTIONS(3547),
    [anon_sym_default] = ACTIONS(3547),
    [anon_sym_throw] = ACTIONS(3547),
    [anon_sym_try] = ACTIONS(3547),
    [anon_sym_when] = ACTIONS(3547),
    [anon_sym_await] = ACTIONS(3547),
    [anon_sym_foreach] = ACTIONS(3547),
    [anon_sym_goto] = ACTIONS(3547),
    [anon_sym_if] = ACTIONS(3547),
    [anon_sym_DOT_DOT] = ACTIONS(3549),
    [anon_sym_from] = ACTIONS(3547),
    [anon_sym_into] = ACTIONS(3547),
    [anon_sym_join] = ACTIONS(3547),
    [anon_sym_on] = ACTIONS(3547),
    [anon_sym_equals] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_orderby] = ACTIONS(3547),
    [anon_sym_ascending] = ACTIONS(3547),
    [anon_sym_descending] = ACTIONS(3547),
    [anon_sym_group] = ACTIONS(3547),
    [anon_sym_by] = ACTIONS(3547),
    [anon_sym_select] = ACTIONS(3547),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [anon_sym_stackalloc] = ACTIONS(3547),
    [anon_sym_sizeof] = ACTIONS(3547),
    [anon_sym_typeof] = ACTIONS(3547),
    [anon_sym___makeref] = ACTIONS(3547),
    [anon_sym___reftype] = ACTIONS(3547),
    [anon_sym___refvalue] = ACTIONS(3547),
    [sym_null_literal] = ACTIONS(3547),
    [anon_sym_SQUOTE] = ACTIONS(3549),
    [sym_integer_literal] = ACTIONS(3547),
    [sym_real_literal] = ACTIONS(3549),
    [sym_verbatim_string_literal] = ACTIONS(3549),
    [aux_sym_preproc_if_token1] = ACTIONS(3549),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3549),
    [sym_interpolation_verbatim_start] = ACTIONS(3549),
    [sym_interpolation_raw_start] = ACTIONS(3549),
    [sym_raw_string_start] = ACTIONS(3549),
  },
  [2633] = {
    [sym_preproc_region] = STATE(2633),
    [sym_preproc_endregion] = STATE(2633),
    [sym_preproc_line] = STATE(2633),
    [sym_preproc_pragma] = STATE(2633),
    [sym_preproc_nullable] = STATE(2633),
    [sym_preproc_error] = STATE(2633),
    [sym_preproc_define] = STATE(2633),
    [sym_preproc_undef] = STATE(2633),
    [ts_builtin_sym_end] = ACTIONS(3677),
    [sym__identifier_token] = ACTIONS(3675),
    [anon_sym_extern] = ACTIONS(3675),
    [anon_sym_alias] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3677),
    [anon_sym_global] = ACTIONS(3675),
    [anon_sym_using] = ACTIONS(3675),
    [anon_sym_unsafe] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_return] = ACTIONS(3675),
    [anon_sym_namespace] = ACTIONS(3675),
    [anon_sym_class] = ACTIONS(3675),
    [anon_sym_ref] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(3675),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_LBRACE] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3675),
    [anon_sym_delegate] = ACTIONS(3675),
    [anon_sym_record] = ACTIONS(3675),
    [anon_sym_abstract] = ACTIONS(3675),
    [anon_sym_async] = ACTIONS(3675),
    [anon_sym_const] = ACTIONS(3675),
    [anon_sym_file] = ACTIONS(3675),
    [anon_sym_fixed] = ACTIONS(3675),
    [anon_sym_internal] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_override] = ACTIONS(3675),
    [anon_sym_partial] = ACTIONS(3675),
    [anon_sym_private] = ACTIONS(3675),
    [anon_sym_protected] = ACTIONS(3675),
    [anon_sym_public] = ACTIONS(3675),
    [anon_sym_readonly] = ACTIONS(3675),
    [anon_sym_required] = ACTIONS(3675),
    [anon_sym_sealed] = ACTIONS(3675),
    [anon_sym_virtual] = ACTIONS(3675),
    [anon_sym_volatile] = ACTIONS(3675),
    [anon_sym_where] = ACTIONS(3675),
    [anon_sym_notnull] = ACTIONS(3675),
    [anon_sym_unmanaged] = ACTIONS(3675),
    [anon_sym_checked] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3677),
    [anon_sym_TILDE] = ACTIONS(3677),
    [anon_sym_PLUS_PLUS] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3677),
    [anon_sym_true] = ACTIONS(3675),
    [anon_sym_false] = ACTIONS(3675),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_CARET] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3677),
    [anon_sym_this] = ACTIONS(3675),
    [anon_sym_scoped] = ACTIONS(3675),
    [anon_sym_base] = ACTIONS(3675),
    [anon_sym_var] = ACTIONS(3675),
    [sym_predefined_type] = ACTIONS(3675),
    [anon_sym_break] = ACTIONS(3675),
    [anon_sym_unchecked] = ACTIONS(3675),
    [anon_sym_continue] = ACTIONS(3675),
    [anon_sym_do] = ACTIONS(3675),
    [anon_sym_while] = ACTIONS(3675),
    [anon_sym_for] = ACTIONS(3675),
    [anon_sym_lock] = ACTIONS(3675),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_switch] = ACTIONS(3675),
    [anon_sym_default] = ACTIONS(3675),
    [anon_sym_throw] = ACTIONS(3675),
    [anon_sym_try] = ACTIONS(3675),
    [anon_sym_when] = ACTIONS(3675),
    [anon_sym_await] = ACTIONS(3675),
    [anon_sym_foreach] = ACTIONS(3675),
    [anon_sym_goto] = ACTIONS(3675),
    [anon_sym_if] = ACTIONS(3675),
    [anon_sym_DOT_DOT] = ACTIONS(3677),
    [anon_sym_from] = ACTIONS(3675),
    [anon_sym_into] = ACTIONS(3675),
    [anon_sym_join] = ACTIONS(3675),
    [anon_sym_on] = ACTIONS(3675),
    [anon_sym_equals] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_orderby] = ACTIONS(3675),
    [anon_sym_ascending] = ACTIONS(3675),
    [anon_sym_descending] = ACTIONS(3675),
    [anon_sym_group] = ACTIONS(3675),
    [anon_sym_by] = ACTIONS(3675),
    [anon_sym_select] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(3677),
    [anon_sym_stackalloc] = ACTIONS(3675),
    [anon_sym_sizeof] = ACTIONS(3675),
    [anon_sym_typeof] = ACTIONS(3675),
    [anon_sym___makeref] = ACTIONS(3675),
    [anon_sym___reftype] = ACTIONS(3675),
    [anon_sym___refvalue] = ACTIONS(3675),
    [sym_null_literal] = ACTIONS(3675),
    [anon_sym_SQUOTE] = ACTIONS(3677),
    [sym_integer_literal] = ACTIONS(3675),
    [sym_real_literal] = ACTIONS(3677),
    [sym_verbatim_string_literal] = ACTIONS(3677),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3677),
    [sym_interpolation_verbatim_start] = ACTIONS(3677),
    [sym_interpolation_raw_start] = ACTIONS(3677),
    [sym_raw_string_start] = ACTIONS(3677),
  },
  [2634] = {
    [sym_preproc_region] = STATE(2634),
    [sym_preproc_endregion] = STATE(2634),
    [sym_preproc_line] = STATE(2634),
    [sym_preproc_pragma] = STATE(2634),
    [sym_preproc_nullable] = STATE(2634),
    [sym_preproc_error] = STATE(2634),
    [sym_preproc_define] = STATE(2634),
    [sym_preproc_undef] = STATE(2634),
    [ts_builtin_sym_end] = ACTIONS(3569),
    [sym__identifier_token] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym_alias] = ACTIONS(3567),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_global] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_unsafe] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(3569),
    [anon_sym_return] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_ref] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_delegate] = ACTIONS(3567),
    [anon_sym_record] = ACTIONS(3567),
    [anon_sym_abstract] = ACTIONS(3567),
    [anon_sym_async] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_file] = ACTIONS(3567),
    [anon_sym_fixed] = ACTIONS(3567),
    [anon_sym_internal] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_override] = ACTIONS(3567),
    [anon_sym_partial] = ACTIONS(3567),
    [anon_sym_private] = ACTIONS(3567),
    [anon_sym_protected] = ACTIONS(3567),
    [anon_sym_public] = ACTIONS(3567),
    [anon_sym_readonly] = ACTIONS(3567),
    [anon_sym_required] = ACTIONS(3567),
    [anon_sym_sealed] = ACTIONS(3567),
    [anon_sym_virtual] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_where] = ACTIONS(3567),
    [anon_sym_notnull] = ACTIONS(3567),
    [anon_sym_unmanaged] = ACTIONS(3567),
    [anon_sym_checked] = ACTIONS(3567),
    [anon_sym_BANG] = ACTIONS(3569),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_PLUS_PLUS] = ACTIONS(3569),
    [anon_sym_DASH_DASH] = ACTIONS(3569),
    [anon_sym_true] = ACTIONS(3567),
    [anon_sym_false] = ACTIONS(3567),
    [anon_sym_PLUS] = ACTIONS(3567),
    [anon_sym_DASH] = ACTIONS(3567),
    [anon_sym_STAR] = ACTIONS(3569),
    [anon_sym_CARET] = ACTIONS(3569),
    [anon_sym_AMP] = ACTIONS(3569),
    [anon_sym_this] = ACTIONS(3567),
    [anon_sym_scoped] = ACTIONS(3567),
    [anon_sym_base] = ACTIONS(3567),
    [anon_sym_var] = ACTIONS(3567),
    [sym_predefined_type] = ACTIONS(3567),
    [anon_sym_break] = ACTIONS(3567),
    [anon_sym_unchecked] = ACTIONS(3567),
    [anon_sym_continue] = ACTIONS(3567),
    [anon_sym_do] = ACTIONS(3567),
    [anon_sym_while] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3567),
    [anon_sym_lock] = ACTIONS(3567),
    [anon_sym_yield] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3567),
    [anon_sym_default] = ACTIONS(3567),
    [anon_sym_throw] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3567),
    [anon_sym_when] = ACTIONS(3567),
    [anon_sym_await] = ACTIONS(3567),
    [anon_sym_foreach] = ACTIONS(3567),
    [anon_sym_goto] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3567),
    [anon_sym_DOT_DOT] = ACTIONS(3569),
    [anon_sym_from] = ACTIONS(3567),
    [anon_sym_into] = ACTIONS(3567),
    [anon_sym_join] = ACTIONS(3567),
    [anon_sym_on] = ACTIONS(3567),
    [anon_sym_equals] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_orderby] = ACTIONS(3567),
    [anon_sym_ascending] = ACTIONS(3567),
    [anon_sym_descending] = ACTIONS(3567),
    [anon_sym_group] = ACTIONS(3567),
    [anon_sym_by] = ACTIONS(3567),
    [anon_sym_select] = ACTIONS(3567),
    [anon_sym_DQUOTE] = ACTIONS(3569),
    [anon_sym_stackalloc] = ACTIONS(3567),
    [anon_sym_sizeof] = ACTIONS(3567),
    [anon_sym_typeof] = ACTIONS(3567),
    [anon_sym___makeref] = ACTIONS(3567),
    [anon_sym___reftype] = ACTIONS(3567),
    [anon_sym___refvalue] = ACTIONS(3567),
    [sym_null_literal] = ACTIONS(3567),
    [anon_sym_SQUOTE] = ACTIONS(3569),
    [sym_integer_literal] = ACTIONS(3567),
    [sym_real_literal] = ACTIONS(3569),
    [sym_verbatim_string_literal] = ACTIONS(3569),
    [aux_sym_preproc_if_token1] = ACTIONS(3569),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3569),
    [sym_interpolation_verbatim_start] = ACTIONS(3569),
    [sym_interpolation_raw_start] = ACTIONS(3569),
    [sym_raw_string_start] = ACTIONS(3569),
  },
  [2635] = {
    [sym_preproc_region] = STATE(2635),
    [sym_preproc_endregion] = STATE(2635),
    [sym_preproc_line] = STATE(2635),
    [sym_preproc_pragma] = STATE(2635),
    [sym_preproc_nullable] = STATE(2635),
    [sym_preproc_error] = STATE(2635),
    [sym_preproc_define] = STATE(2635),
    [sym_preproc_undef] = STATE(2635),
    [ts_builtin_sym_end] = ACTIONS(3441),
    [sym__identifier_token] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym_alias] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3441),
    [anon_sym_global] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_unsafe] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_ref] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_delegate] = ACTIONS(3439),
    [anon_sym_record] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_file] = ACTIONS(3439),
    [anon_sym_fixed] = ACTIONS(3439),
    [anon_sym_internal] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_partial] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_required] = ACTIONS(3439),
    [anon_sym_sealed] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_where] = ACTIONS(3439),
    [anon_sym_notnull] = ACTIONS(3439),
    [anon_sym_unmanaged] = ACTIONS(3439),
    [anon_sym_checked] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3441),
    [anon_sym_true] = ACTIONS(3439),
    [anon_sym_false] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3439),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_CARET] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_this] = ACTIONS(3439),
    [anon_sym_scoped] = ACTIONS(3439),
    [anon_sym_base] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [sym_predefined_type] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3439),
    [anon_sym_unchecked] = ACTIONS(3439),
    [anon_sym_continue] = ACTIONS(3439),
    [anon_sym_do] = ACTIONS(3439),
    [anon_sym_while] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3439),
    [anon_sym_lock] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3439),
    [anon_sym_default] = ACTIONS(3439),
    [anon_sym_throw] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3439),
    [anon_sym_when] = ACTIONS(3439),
    [anon_sym_await] = ACTIONS(3439),
    [anon_sym_foreach] = ACTIONS(3439),
    [anon_sym_goto] = ACTIONS(3439),
    [anon_sym_if] = ACTIONS(3439),
    [anon_sym_DOT_DOT] = ACTIONS(3441),
    [anon_sym_from] = ACTIONS(3439),
    [anon_sym_into] = ACTIONS(3439),
    [anon_sym_join] = ACTIONS(3439),
    [anon_sym_on] = ACTIONS(3439),
    [anon_sym_equals] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_orderby] = ACTIONS(3439),
    [anon_sym_ascending] = ACTIONS(3439),
    [anon_sym_descending] = ACTIONS(3439),
    [anon_sym_group] = ACTIONS(3439),
    [anon_sym_by] = ACTIONS(3439),
    [anon_sym_select] = ACTIONS(3439),
    [anon_sym_DQUOTE] = ACTIONS(3441),
    [anon_sym_stackalloc] = ACTIONS(3439),
    [anon_sym_sizeof] = ACTIONS(3439),
    [anon_sym_typeof] = ACTIONS(3439),
    [anon_sym___makeref] = ACTIONS(3439),
    [anon_sym___reftype] = ACTIONS(3439),
    [anon_sym___refvalue] = ACTIONS(3439),
    [sym_null_literal] = ACTIONS(3439),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [sym_integer_literal] = ACTIONS(3439),
    [sym_real_literal] = ACTIONS(3441),
    [sym_verbatim_string_literal] = ACTIONS(3441),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3441),
    [sym_interpolation_verbatim_start] = ACTIONS(3441),
    [sym_interpolation_raw_start] = ACTIONS(3441),
    [sym_raw_string_start] = ACTIONS(3441),
  },
  [2636] = {
    [sym_preproc_region] = STATE(2636),
    [sym_preproc_endregion] = STATE(2636),
    [sym_preproc_line] = STATE(2636),
    [sym_preproc_pragma] = STATE(2636),
    [sym_preproc_nullable] = STATE(2636),
    [sym_preproc_error] = STATE(2636),
    [sym_preproc_define] = STATE(2636),
    [sym_preproc_undef] = STATE(2636),
    [ts_builtin_sym_end] = ACTIONS(3517),
    [sym__identifier_token] = ACTIONS(3515),
    [anon_sym_extern] = ACTIONS(3515),
    [anon_sym_alias] = ACTIONS(3515),
    [anon_sym_SEMI] = ACTIONS(3517),
    [anon_sym_global] = ACTIONS(3515),
    [anon_sym_using] = ACTIONS(3515),
    [anon_sym_unsafe] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_class] = ACTIONS(3515),
    [anon_sym_ref] = ACTIONS(3515),
    [anon_sym_struct] = ACTIONS(3515),
    [anon_sym_enum] = ACTIONS(3515),
    [anon_sym_LBRACE] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_delegate] = ACTIONS(3515),
    [anon_sym_record] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_const] = ACTIONS(3515),
    [anon_sym_file] = ACTIONS(3515),
    [anon_sym_fixed] = ACTIONS(3515),
    [anon_sym_internal] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_partial] = ACTIONS(3515),
    [anon_sym_private] = ACTIONS(3515),
    [anon_sym_protected] = ACTIONS(3515),
    [anon_sym_public] = ACTIONS(3515),
    [anon_sym_readonly] = ACTIONS(3515),
    [anon_sym_required] = ACTIONS(3515),
    [anon_sym_sealed] = ACTIONS(3515),
    [anon_sym_virtual] = ACTIONS(3515),
    [anon_sym_volatile] = ACTIONS(3515),
    [anon_sym_where] = ACTIONS(3515),
    [anon_sym_notnull] = ACTIONS(3515),
    [anon_sym_unmanaged] = ACTIONS(3515),
    [anon_sym_checked] = ACTIONS(3515),
    [anon_sym_BANG] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3517),
    [anon_sym_true] = ACTIONS(3515),
    [anon_sym_false] = ACTIONS(3515),
    [anon_sym_PLUS] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3515),
    [anon_sym_STAR] = ACTIONS(3517),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_AMP] = ACTIONS(3517),
    [anon_sym_this] = ACTIONS(3515),
    [anon_sym_scoped] = ACTIONS(3515),
    [anon_sym_base] = ACTIONS(3515),
    [anon_sym_var] = ACTIONS(3515),
    [sym_predefined_type] = ACTIONS(3515),
    [anon_sym_break] = ACTIONS(3515),
    [anon_sym_unchecked] = ACTIONS(3515),
    [anon_sym_continue] = ACTIONS(3515),
    [anon_sym_do] = ACTIONS(3515),
    [anon_sym_while] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3515),
    [anon_sym_lock] = ACTIONS(3515),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_switch] = ACTIONS(3515),
    [anon_sym_default] = ACTIONS(3515),
    [anon_sym_throw] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3515),
    [anon_sym_when] = ACTIONS(3515),
    [anon_sym_await] = ACTIONS(3515),
    [anon_sym_foreach] = ACTIONS(3515),
    [anon_sym_goto] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3515),
    [anon_sym_DOT_DOT] = ACTIONS(3517),
    [anon_sym_from] = ACTIONS(3515),
    [anon_sym_into] = ACTIONS(3515),
    [anon_sym_join] = ACTIONS(3515),
    [anon_sym_on] = ACTIONS(3515),
    [anon_sym_equals] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_orderby] = ACTIONS(3515),
    [anon_sym_ascending] = ACTIONS(3515),
    [anon_sym_descending] = ACTIONS(3515),
    [anon_sym_group] = ACTIONS(3515),
    [anon_sym_by] = ACTIONS(3515),
    [anon_sym_select] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3517),
    [anon_sym_stackalloc] = ACTIONS(3515),
    [anon_sym_sizeof] = ACTIONS(3515),
    [anon_sym_typeof] = ACTIONS(3515),
    [anon_sym___makeref] = ACTIONS(3515),
    [anon_sym___reftype] = ACTIONS(3515),
    [anon_sym___refvalue] = ACTIONS(3515),
    [sym_null_literal] = ACTIONS(3515),
    [anon_sym_SQUOTE] = ACTIONS(3517),
    [sym_integer_literal] = ACTIONS(3515),
    [sym_real_literal] = ACTIONS(3517),
    [sym_verbatim_string_literal] = ACTIONS(3517),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3517),
    [sym_interpolation_verbatim_start] = ACTIONS(3517),
    [sym_interpolation_raw_start] = ACTIONS(3517),
    [sym_raw_string_start] = ACTIONS(3517),
  },
  [2637] = {
    [sym_preproc_region] = STATE(2637),
    [sym_preproc_endregion] = STATE(2637),
    [sym_preproc_line] = STATE(2637),
    [sym_preproc_pragma] = STATE(2637),
    [sym_preproc_nullable] = STATE(2637),
    [sym_preproc_error] = STATE(2637),
    [sym_preproc_define] = STATE(2637),
    [sym_preproc_undef] = STATE(2637),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [sym__identifier_token] = ACTIONS(3779),
    [anon_sym_extern] = ACTIONS(3779),
    [anon_sym_alias] = ACTIONS(3779),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_global] = ACTIONS(3779),
    [anon_sym_using] = ACTIONS(3779),
    [anon_sym_unsafe] = ACTIONS(3779),
    [anon_sym_static] = ACTIONS(3779),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_return] = ACTIONS(3779),
    [anon_sym_namespace] = ACTIONS(3779),
    [anon_sym_class] = ACTIONS(3779),
    [anon_sym_ref] = ACTIONS(3779),
    [anon_sym_struct] = ACTIONS(3779),
    [anon_sym_enum] = ACTIONS(3779),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_interface] = ACTIONS(3779),
    [anon_sym_delegate] = ACTIONS(3779),
    [anon_sym_record] = ACTIONS(3779),
    [anon_sym_abstract] = ACTIONS(3779),
    [anon_sym_async] = ACTIONS(3779),
    [anon_sym_const] = ACTIONS(3779),
    [anon_sym_file] = ACTIONS(3779),
    [anon_sym_fixed] = ACTIONS(3779),
    [anon_sym_internal] = ACTIONS(3779),
    [anon_sym_new] = ACTIONS(3779),
    [anon_sym_override] = ACTIONS(3779),
    [anon_sym_partial] = ACTIONS(3779),
    [anon_sym_private] = ACTIONS(3779),
    [anon_sym_protected] = ACTIONS(3779),
    [anon_sym_public] = ACTIONS(3779),
    [anon_sym_readonly] = ACTIONS(3779),
    [anon_sym_required] = ACTIONS(3779),
    [anon_sym_sealed] = ACTIONS(3779),
    [anon_sym_virtual] = ACTIONS(3779),
    [anon_sym_volatile] = ACTIONS(3779),
    [anon_sym_where] = ACTIONS(3779),
    [anon_sym_notnull] = ACTIONS(3779),
    [anon_sym_unmanaged] = ACTIONS(3779),
    [anon_sym_checked] = ACTIONS(3779),
    [anon_sym_BANG] = ACTIONS(3781),
    [anon_sym_TILDE] = ACTIONS(3781),
    [anon_sym_PLUS_PLUS] = ACTIONS(3781),
    [anon_sym_DASH_DASH] = ACTIONS(3781),
    [anon_sym_true] = ACTIONS(3779),
    [anon_sym_false] = ACTIONS(3779),
    [anon_sym_PLUS] = ACTIONS(3779),
    [anon_sym_DASH] = ACTIONS(3779),
    [anon_sym_STAR] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3781),
    [anon_sym_AMP] = ACTIONS(3781),
    [anon_sym_this] = ACTIONS(3779),
    [anon_sym_scoped] = ACTIONS(3779),
    [anon_sym_base] = ACTIONS(3779),
    [anon_sym_var] = ACTIONS(3779),
    [sym_predefined_type] = ACTIONS(3779),
    [anon_sym_break] = ACTIONS(3779),
    [anon_sym_unchecked] = ACTIONS(3779),
    [anon_sym_continue] = ACTIONS(3779),
    [anon_sym_do] = ACTIONS(3779),
    [anon_sym_while] = ACTIONS(3779),
    [anon_sym_for] = ACTIONS(3779),
    [anon_sym_lock] = ACTIONS(3779),
    [anon_sym_yield] = ACTIONS(3779),
    [anon_sym_switch] = ACTIONS(3779),
    [anon_sym_default] = ACTIONS(3779),
    [anon_sym_throw] = ACTIONS(3779),
    [anon_sym_try] = ACTIONS(3779),
    [anon_sym_when] = ACTIONS(3779),
    [anon_sym_await] = ACTIONS(3779),
    [anon_sym_foreach] = ACTIONS(3779),
    [anon_sym_goto] = ACTIONS(3779),
    [anon_sym_if] = ACTIONS(3779),
    [anon_sym_DOT_DOT] = ACTIONS(3781),
    [anon_sym_from] = ACTIONS(3779),
    [anon_sym_into] = ACTIONS(3779),
    [anon_sym_join] = ACTIONS(3779),
    [anon_sym_on] = ACTIONS(3779),
    [anon_sym_equals] = ACTIONS(3779),
    [anon_sym_let] = ACTIONS(3779),
    [anon_sym_orderby] = ACTIONS(3779),
    [anon_sym_ascending] = ACTIONS(3779),
    [anon_sym_descending] = ACTIONS(3779),
    [anon_sym_group] = ACTIONS(3779),
    [anon_sym_by] = ACTIONS(3779),
    [anon_sym_select] = ACTIONS(3779),
    [anon_sym_DQUOTE] = ACTIONS(3781),
    [anon_sym_stackalloc] = ACTIONS(3779),
    [anon_sym_sizeof] = ACTIONS(3779),
    [anon_sym_typeof] = ACTIONS(3779),
    [anon_sym___makeref] = ACTIONS(3779),
    [anon_sym___reftype] = ACTIONS(3779),
    [anon_sym___refvalue] = ACTIONS(3779),
    [sym_null_literal] = ACTIONS(3779),
    [anon_sym_SQUOTE] = ACTIONS(3781),
    [sym_integer_literal] = ACTIONS(3779),
    [sym_real_literal] = ACTIONS(3781),
    [sym_verbatim_string_literal] = ACTIONS(3781),
    [aux_sym_preproc_if_token1] = ACTIONS(3781),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3781),
    [sym_interpolation_verbatim_start] = ACTIONS(3781),
    [sym_interpolation_raw_start] = ACTIONS(3781),
    [sym_raw_string_start] = ACTIONS(3781),
  },
  [2638] = {
    [sym_preproc_region] = STATE(2638),
    [sym_preproc_endregion] = STATE(2638),
    [sym_preproc_line] = STATE(2638),
    [sym_preproc_pragma] = STATE(2638),
    [sym_preproc_nullable] = STATE(2638),
    [sym_preproc_error] = STATE(2638),
    [sym_preproc_define] = STATE(2638),
    [sym_preproc_undef] = STATE(2638),
    [ts_builtin_sym_end] = ACTIONS(3785),
    [sym__identifier_token] = ACTIONS(3783),
    [anon_sym_extern] = ACTIONS(3783),
    [anon_sym_alias] = ACTIONS(3783),
    [anon_sym_SEMI] = ACTIONS(3785),
    [anon_sym_global] = ACTIONS(3783),
    [anon_sym_using] = ACTIONS(3783),
    [anon_sym_unsafe] = ACTIONS(3783),
    [anon_sym_static] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_LPAREN] = ACTIONS(3785),
    [anon_sym_return] = ACTIONS(3783),
    [anon_sym_namespace] = ACTIONS(3783),
    [anon_sym_class] = ACTIONS(3783),
    [anon_sym_ref] = ACTIONS(3783),
    [anon_sym_struct] = ACTIONS(3783),
    [anon_sym_enum] = ACTIONS(3783),
    [anon_sym_LBRACE] = ACTIONS(3785),
    [anon_sym_interface] = ACTIONS(3783),
    [anon_sym_delegate] = ACTIONS(3783),
    [anon_sym_record] = ACTIONS(3783),
    [anon_sym_abstract] = ACTIONS(3783),
    [anon_sym_async] = ACTIONS(3783),
    [anon_sym_const] = ACTIONS(3783),
    [anon_sym_file] = ACTIONS(3783),
    [anon_sym_fixed] = ACTIONS(3783),
    [anon_sym_internal] = ACTIONS(3783),
    [anon_sym_new] = ACTIONS(3783),
    [anon_sym_override] = ACTIONS(3783),
    [anon_sym_partial] = ACTIONS(3783),
    [anon_sym_private] = ACTIONS(3783),
    [anon_sym_protected] = ACTIONS(3783),
    [anon_sym_public] = ACTIONS(3783),
    [anon_sym_readonly] = ACTIONS(3783),
    [anon_sym_required] = ACTIONS(3783),
    [anon_sym_sealed] = ACTIONS(3783),
    [anon_sym_virtual] = ACTIONS(3783),
    [anon_sym_volatile] = ACTIONS(3783),
    [anon_sym_where] = ACTIONS(3783),
    [anon_sym_notnull] = ACTIONS(3783),
    [anon_sym_unmanaged] = ACTIONS(3783),
    [anon_sym_checked] = ACTIONS(3783),
    [anon_sym_BANG] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_PLUS_PLUS] = ACTIONS(3785),
    [anon_sym_DASH_DASH] = ACTIONS(3785),
    [anon_sym_true] = ACTIONS(3783),
    [anon_sym_false] = ACTIONS(3783),
    [anon_sym_PLUS] = ACTIONS(3783),
    [anon_sym_DASH] = ACTIONS(3783),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_CARET] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_this] = ACTIONS(3783),
    [anon_sym_scoped] = ACTIONS(3783),
    [anon_sym_base] = ACTIONS(3783),
    [anon_sym_var] = ACTIONS(3783),
    [sym_predefined_type] = ACTIONS(3783),
    [anon_sym_break] = ACTIONS(3783),
    [anon_sym_unchecked] = ACTIONS(3783),
    [anon_sym_continue] = ACTIONS(3783),
    [anon_sym_do] = ACTIONS(3783),
    [anon_sym_while] = ACTIONS(3783),
    [anon_sym_for] = ACTIONS(3783),
    [anon_sym_lock] = ACTIONS(3783),
    [anon_sym_yield] = ACTIONS(3783),
    [anon_sym_switch] = ACTIONS(3783),
    [anon_sym_default] = ACTIONS(3783),
    [anon_sym_throw] = ACTIONS(3783),
    [anon_sym_try] = ACTIONS(3783),
    [anon_sym_when] = ACTIONS(3783),
    [anon_sym_await] = ACTIONS(3783),
    [anon_sym_foreach] = ACTIONS(3783),
    [anon_sym_goto] = ACTIONS(3783),
    [anon_sym_if] = ACTIONS(3783),
    [anon_sym_DOT_DOT] = ACTIONS(3785),
    [anon_sym_from] = ACTIONS(3783),
    [anon_sym_into] = ACTIONS(3783),
    [anon_sym_join] = ACTIONS(3783),
    [anon_sym_on] = ACTIONS(3783),
    [anon_sym_equals] = ACTIONS(3783),
    [anon_sym_let] = ACTIONS(3783),
    [anon_sym_orderby] = ACTIONS(3783),
    [anon_sym_ascending] = ACTIONS(3783),
    [anon_sym_descending] = ACTIONS(3783),
    [anon_sym_group] = ACTIONS(3783),
    [anon_sym_by] = ACTIONS(3783),
    [anon_sym_select] = ACTIONS(3783),
    [anon_sym_DQUOTE] = ACTIONS(3785),
    [anon_sym_stackalloc] = ACTIONS(3783),
    [anon_sym_sizeof] = ACTIONS(3783),
    [anon_sym_typeof] = ACTIONS(3783),
    [anon_sym___makeref] = ACTIONS(3783),
    [anon_sym___reftype] = ACTIONS(3783),
    [anon_sym___refvalue] = ACTIONS(3783),
    [sym_null_literal] = ACTIONS(3783),
    [anon_sym_SQUOTE] = ACTIONS(3785),
    [sym_integer_literal] = ACTIONS(3783),
    [sym_real_literal] = ACTIONS(3785),
    [sym_verbatim_string_literal] = ACTIONS(3785),
    [aux_sym_preproc_if_token1] = ACTIONS(3785),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3785),
    [sym_interpolation_verbatim_start] = ACTIONS(3785),
    [sym_interpolation_raw_start] = ACTIONS(3785),
    [sym_raw_string_start] = ACTIONS(3785),
  },
  [2639] = {
    [sym_preproc_region] = STATE(2639),
    [sym_preproc_endregion] = STATE(2639),
    [sym_preproc_line] = STATE(2639),
    [sym_preproc_pragma] = STATE(2639),
    [sym_preproc_nullable] = STATE(2639),
    [sym_preproc_error] = STATE(2639),
    [sym_preproc_define] = STATE(2639),
    [sym_preproc_undef] = STATE(2639),
    [ts_builtin_sym_end] = ACTIONS(3777),
    [sym__identifier_token] = ACTIONS(3775),
    [anon_sym_extern] = ACTIONS(3775),
    [anon_sym_alias] = ACTIONS(3775),
    [anon_sym_SEMI] = ACTIONS(3777),
    [anon_sym_global] = ACTIONS(3775),
    [anon_sym_using] = ACTIONS(3775),
    [anon_sym_unsafe] = ACTIONS(3775),
    [anon_sym_static] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_LPAREN] = ACTIONS(3777),
    [anon_sym_return] = ACTIONS(3775),
    [anon_sym_namespace] = ACTIONS(3775),
    [anon_sym_class] = ACTIONS(3775),
    [anon_sym_ref] = ACTIONS(3775),
    [anon_sym_struct] = ACTIONS(3775),
    [anon_sym_enum] = ACTIONS(3775),
    [anon_sym_LBRACE] = ACTIONS(3777),
    [anon_sym_interface] = ACTIONS(3775),
    [anon_sym_delegate] = ACTIONS(3775),
    [anon_sym_record] = ACTIONS(3775),
    [anon_sym_abstract] = ACTIONS(3775),
    [anon_sym_async] = ACTIONS(3775),
    [anon_sym_const] = ACTIONS(3775),
    [anon_sym_file] = ACTIONS(3775),
    [anon_sym_fixed] = ACTIONS(3775),
    [anon_sym_internal] = ACTIONS(3775),
    [anon_sym_new] = ACTIONS(3775),
    [anon_sym_override] = ACTIONS(3775),
    [anon_sym_partial] = ACTIONS(3775),
    [anon_sym_private] = ACTIONS(3775),
    [anon_sym_protected] = ACTIONS(3775),
    [anon_sym_public] = ACTIONS(3775),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_required] = ACTIONS(3775),
    [anon_sym_sealed] = ACTIONS(3775),
    [anon_sym_virtual] = ACTIONS(3775),
    [anon_sym_volatile] = ACTIONS(3775),
    [anon_sym_where] = ACTIONS(3775),
    [anon_sym_notnull] = ACTIONS(3775),
    [anon_sym_unmanaged] = ACTIONS(3775),
    [anon_sym_checked] = ACTIONS(3775),
    [anon_sym_BANG] = ACTIONS(3777),
    [anon_sym_TILDE] = ACTIONS(3777),
    [anon_sym_PLUS_PLUS] = ACTIONS(3777),
    [anon_sym_DASH_DASH] = ACTIONS(3777),
    [anon_sym_true] = ACTIONS(3775),
    [anon_sym_false] = ACTIONS(3775),
    [anon_sym_PLUS] = ACTIONS(3775),
    [anon_sym_DASH] = ACTIONS(3775),
    [anon_sym_STAR] = ACTIONS(3777),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_AMP] = ACTIONS(3777),
    [anon_sym_this] = ACTIONS(3775),
    [anon_sym_scoped] = ACTIONS(3775),
    [anon_sym_base] = ACTIONS(3775),
    [anon_sym_var] = ACTIONS(3775),
    [sym_predefined_type] = ACTIONS(3775),
    [anon_sym_break] = ACTIONS(3775),
    [anon_sym_unchecked] = ACTIONS(3775),
    [anon_sym_continue] = ACTIONS(3775),
    [anon_sym_do] = ACTIONS(3775),
    [anon_sym_while] = ACTIONS(3775),
    [anon_sym_for] = ACTIONS(3775),
    [anon_sym_lock] = ACTIONS(3775),
    [anon_sym_yield] = ACTIONS(3775),
    [anon_sym_switch] = ACTIONS(3775),
    [anon_sym_default] = ACTIONS(3775),
    [anon_sym_throw] = ACTIONS(3775),
    [anon_sym_try] = ACTIONS(3775),
    [anon_sym_when] = ACTIONS(3775),
    [anon_sym_await] = ACTIONS(3775),
    [anon_sym_foreach] = ACTIONS(3775),
    [anon_sym_goto] = ACTIONS(3775),
    [anon_sym_if] = ACTIONS(3775),
    [anon_sym_DOT_DOT] = ACTIONS(3777),
    [anon_sym_from] = ACTIONS(3775),
    [anon_sym_into] = ACTIONS(3775),
    [anon_sym_join] = ACTIONS(3775),
    [anon_sym_on] = ACTIONS(3775),
    [anon_sym_equals] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_orderby] = ACTIONS(3775),
    [anon_sym_ascending] = ACTIONS(3775),
    [anon_sym_descending] = ACTIONS(3775),
    [anon_sym_group] = ACTIONS(3775),
    [anon_sym_by] = ACTIONS(3775),
    [anon_sym_select] = ACTIONS(3775),
    [anon_sym_DQUOTE] = ACTIONS(3777),
    [anon_sym_stackalloc] = ACTIONS(3775),
    [anon_sym_sizeof] = ACTIONS(3775),
    [anon_sym_typeof] = ACTIONS(3775),
    [anon_sym___makeref] = ACTIONS(3775),
    [anon_sym___reftype] = ACTIONS(3775),
    [anon_sym___refvalue] = ACTIONS(3775),
    [sym_null_literal] = ACTIONS(3775),
    [anon_sym_SQUOTE] = ACTIONS(3777),
    [sym_integer_literal] = ACTIONS(3775),
    [sym_real_literal] = ACTIONS(3777),
    [sym_verbatim_string_literal] = ACTIONS(3777),
    [aux_sym_preproc_if_token1] = ACTIONS(3777),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3777),
    [sym_interpolation_verbatim_start] = ACTIONS(3777),
    [sym_interpolation_raw_start] = ACTIONS(3777),
    [sym_raw_string_start] = ACTIONS(3777),
  },
  [2640] = {
    [sym_preproc_region] = STATE(2640),
    [sym_preproc_endregion] = STATE(2640),
    [sym_preproc_line] = STATE(2640),
    [sym_preproc_pragma] = STATE(2640),
    [sym_preproc_nullable] = STATE(2640),
    [sym_preproc_error] = STATE(2640),
    [sym_preproc_define] = STATE(2640),
    [sym_preproc_undef] = STATE(2640),
    [ts_builtin_sym_end] = ACTIONS(3753),
    [sym__identifier_token] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym_alias] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym_global] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_unsafe] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_delegate] = ACTIONS(3751),
    [anon_sym_record] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3751),
    [anon_sym_async] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_file] = ACTIONS(3751),
    [anon_sym_fixed] = ACTIONS(3751),
    [anon_sym_internal] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_override] = ACTIONS(3751),
    [anon_sym_partial] = ACTIONS(3751),
    [anon_sym_private] = ACTIONS(3751),
    [anon_sym_protected] = ACTIONS(3751),
    [anon_sym_public] = ACTIONS(3751),
    [anon_sym_readonly] = ACTIONS(3751),
    [anon_sym_required] = ACTIONS(3751),
    [anon_sym_sealed] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_where] = ACTIONS(3751),
    [anon_sym_notnull] = ACTIONS(3751),
    [anon_sym_unmanaged] = ACTIONS(3751),
    [anon_sym_checked] = ACTIONS(3751),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_true] = ACTIONS(3751),
    [anon_sym_false] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_this] = ACTIONS(3751),
    [anon_sym_scoped] = ACTIONS(3751),
    [anon_sym_base] = ACTIONS(3751),
    [anon_sym_var] = ACTIONS(3751),
    [sym_predefined_type] = ACTIONS(3751),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_unchecked] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_lock] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_when] = ACTIONS(3751),
    [anon_sym_await] = ACTIONS(3751),
    [anon_sym_foreach] = ACTIONS(3751),
    [anon_sym_goto] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_DOT_DOT] = ACTIONS(3753),
    [anon_sym_from] = ACTIONS(3751),
    [anon_sym_into] = ACTIONS(3751),
    [anon_sym_join] = ACTIONS(3751),
    [anon_sym_on] = ACTIONS(3751),
    [anon_sym_equals] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_orderby] = ACTIONS(3751),
    [anon_sym_ascending] = ACTIONS(3751),
    [anon_sym_descending] = ACTIONS(3751),
    [anon_sym_group] = ACTIONS(3751),
    [anon_sym_by] = ACTIONS(3751),
    [anon_sym_select] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_stackalloc] = ACTIONS(3751),
    [anon_sym_sizeof] = ACTIONS(3751),
    [anon_sym_typeof] = ACTIONS(3751),
    [anon_sym___makeref] = ACTIONS(3751),
    [anon_sym___reftype] = ACTIONS(3751),
    [anon_sym___refvalue] = ACTIONS(3751),
    [sym_null_literal] = ACTIONS(3751),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [sym_integer_literal] = ACTIONS(3751),
    [sym_real_literal] = ACTIONS(3753),
    [sym_verbatim_string_literal] = ACTIONS(3753),
    [aux_sym_preproc_if_token1] = ACTIONS(3753),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3753),
    [sym_interpolation_verbatim_start] = ACTIONS(3753),
    [sym_interpolation_raw_start] = ACTIONS(3753),
    [sym_raw_string_start] = ACTIONS(3753),
  },
  [2641] = {
    [sym_preproc_region] = STATE(2641),
    [sym_preproc_endregion] = STATE(2641),
    [sym_preproc_line] = STATE(2641),
    [sym_preproc_pragma] = STATE(2641),
    [sym_preproc_nullable] = STATE(2641),
    [sym_preproc_error] = STATE(2641),
    [sym_preproc_define] = STATE(2641),
    [sym_preproc_undef] = STATE(2641),
    [ts_builtin_sym_end] = ACTIONS(3725),
    [sym__identifier_token] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym_alias] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_global] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_unsafe] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [anon_sym_return] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_ref] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_delegate] = ACTIONS(3723),
    [anon_sym_record] = ACTIONS(3723),
    [anon_sym_abstract] = ACTIONS(3723),
    [anon_sym_async] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_file] = ACTIONS(3723),
    [anon_sym_fixed] = ACTIONS(3723),
    [anon_sym_internal] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_override] = ACTIONS(3723),
    [anon_sym_partial] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(3723),
    [anon_sym_protected] = ACTIONS(3723),
    [anon_sym_public] = ACTIONS(3723),
    [anon_sym_readonly] = ACTIONS(3723),
    [anon_sym_required] = ACTIONS(3723),
    [anon_sym_sealed] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_where] = ACTIONS(3723),
    [anon_sym_notnull] = ACTIONS(3723),
    [anon_sym_unmanaged] = ACTIONS(3723),
    [anon_sym_checked] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_true] = ACTIONS(3723),
    [anon_sym_false] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3723),
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_this] = ACTIONS(3723),
    [anon_sym_scoped] = ACTIONS(3723),
    [anon_sym_base] = ACTIONS(3723),
    [anon_sym_var] = ACTIONS(3723),
    [sym_predefined_type] = ACTIONS(3723),
    [anon_sym_break] = ACTIONS(3723),
    [anon_sym_unchecked] = ACTIONS(3723),
    [anon_sym_continue] = ACTIONS(3723),
    [anon_sym_do] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3723),
    [anon_sym_for] = ACTIONS(3723),
    [anon_sym_lock] = ACTIONS(3723),
    [anon_sym_yield] = ACTIONS(3723),
    [anon_sym_switch] = ACTIONS(3723),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_throw] = ACTIONS(3723),
    [anon_sym_try] = ACTIONS(3723),
    [anon_sym_when] = ACTIONS(3723),
    [anon_sym_await] = ACTIONS(3723),
    [anon_sym_foreach] = ACTIONS(3723),
    [anon_sym_goto] = ACTIONS(3723),
    [anon_sym_if] = ACTIONS(3723),
    [anon_sym_DOT_DOT] = ACTIONS(3725),
    [anon_sym_from] = ACTIONS(3723),
    [anon_sym_into] = ACTIONS(3723),
    [anon_sym_join] = ACTIONS(3723),
    [anon_sym_on] = ACTIONS(3723),
    [anon_sym_equals] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_orderby] = ACTIONS(3723),
    [anon_sym_ascending] = ACTIONS(3723),
    [anon_sym_descending] = ACTIONS(3723),
    [anon_sym_group] = ACTIONS(3723),
    [anon_sym_by] = ACTIONS(3723),
    [anon_sym_select] = ACTIONS(3723),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [anon_sym_stackalloc] = ACTIONS(3723),
    [anon_sym_sizeof] = ACTIONS(3723),
    [anon_sym_typeof] = ACTIONS(3723),
    [anon_sym___makeref] = ACTIONS(3723),
    [anon_sym___reftype] = ACTIONS(3723),
    [anon_sym___refvalue] = ACTIONS(3723),
    [sym_null_literal] = ACTIONS(3723),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [sym_integer_literal] = ACTIONS(3723),
    [sym_real_literal] = ACTIONS(3725),
    [sym_verbatim_string_literal] = ACTIONS(3725),
    [aux_sym_preproc_if_token1] = ACTIONS(3725),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3725),
    [sym_interpolation_verbatim_start] = ACTIONS(3725),
    [sym_interpolation_raw_start] = ACTIONS(3725),
    [sym_raw_string_start] = ACTIONS(3725),
  },
  [2642] = {
    [sym_preproc_region] = STATE(2642),
    [sym_preproc_endregion] = STATE(2642),
    [sym_preproc_line] = STATE(2642),
    [sym_preproc_pragma] = STATE(2642),
    [sym_preproc_nullable] = STATE(2642),
    [sym_preproc_error] = STATE(2642),
    [sym_preproc_define] = STATE(2642),
    [sym_preproc_undef] = STATE(2642),
    [ts_builtin_sym_end] = ACTIONS(3721),
    [sym__identifier_token] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym_alias] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3721),
    [anon_sym_global] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_unsafe] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3721),
    [anon_sym_return] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3719),
    [anon_sym_record] = ACTIONS(3719),
    [anon_sym_abstract] = ACTIONS(3719),
    [anon_sym_async] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3719),
    [anon_sym_fixed] = ACTIONS(3719),
    [anon_sym_internal] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_override] = ACTIONS(3719),
    [anon_sym_partial] = ACTIONS(3719),
    [anon_sym_private] = ACTIONS(3719),
    [anon_sym_protected] = ACTIONS(3719),
    [anon_sym_public] = ACTIONS(3719),
    [anon_sym_readonly] = ACTIONS(3719),
    [anon_sym_required] = ACTIONS(3719),
    [anon_sym_sealed] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3719),
    [anon_sym_unmanaged] = ACTIONS(3719),
    [anon_sym_checked] = ACTIONS(3719),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3721),
    [anon_sym_DASH_DASH] = ACTIONS(3721),
    [anon_sym_true] = ACTIONS(3719),
    [anon_sym_false] = ACTIONS(3719),
    [anon_sym_PLUS] = ACTIONS(3719),
    [anon_sym_DASH] = ACTIONS(3719),
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3721),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_this] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3719),
    [anon_sym_base] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3719),
    [sym_predefined_type] = ACTIONS(3719),
    [anon_sym_break] = ACTIONS(3719),
    [anon_sym_unchecked] = ACTIONS(3719),
    [anon_sym_continue] = ACTIONS(3719),
    [anon_sym_do] = ACTIONS(3719),
    [anon_sym_while] = ACTIONS(3719),
    [anon_sym_for] = ACTIONS(3719),
    [anon_sym_lock] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(3719),
    [anon_sym_switch] = ACTIONS(3719),
    [anon_sym_default] = ACTIONS(3719),
    [anon_sym_throw] = ACTIONS(3719),
    [anon_sym_try] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_await] = ACTIONS(3719),
    [anon_sym_foreach] = ACTIONS(3719),
    [anon_sym_goto] = ACTIONS(3719),
    [anon_sym_if] = ACTIONS(3719),
    [anon_sym_DOT_DOT] = ACTIONS(3721),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_ascending] = ACTIONS(3719),
    [anon_sym_descending] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [anon_sym_DQUOTE] = ACTIONS(3721),
    [anon_sym_stackalloc] = ACTIONS(3719),
    [anon_sym_sizeof] = ACTIONS(3719),
    [anon_sym_typeof] = ACTIONS(3719),
    [anon_sym___makeref] = ACTIONS(3719),
    [anon_sym___reftype] = ACTIONS(3719),
    [anon_sym___refvalue] = ACTIONS(3719),
    [sym_null_literal] = ACTIONS(3719),
    [anon_sym_SQUOTE] = ACTIONS(3721),
    [sym_integer_literal] = ACTIONS(3719),
    [sym_real_literal] = ACTIONS(3721),
    [sym_verbatim_string_literal] = ACTIONS(3721),
    [aux_sym_preproc_if_token1] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3721),
    [sym_interpolation_verbatim_start] = ACTIONS(3721),
    [sym_interpolation_raw_start] = ACTIONS(3721),
    [sym_raw_string_start] = ACTIONS(3721),
  },
  [2643] = {
    [sym_preproc_region] = STATE(2643),
    [sym_preproc_endregion] = STATE(2643),
    [sym_preproc_line] = STATE(2643),
    [sym_preproc_pragma] = STATE(2643),
    [sym_preproc_nullable] = STATE(2643),
    [sym_preproc_error] = STATE(2643),
    [sym_preproc_define] = STATE(2643),
    [sym_preproc_undef] = STATE(2643),
    [ts_builtin_sym_end] = ACTIONS(3681),
    [sym__identifier_token] = ACTIONS(3679),
    [anon_sym_extern] = ACTIONS(3679),
    [anon_sym_alias] = ACTIONS(3679),
    [anon_sym_SEMI] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3679),
    [anon_sym_using] = ACTIONS(3679),
    [anon_sym_unsafe] = ACTIONS(3679),
    [anon_sym_static] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_namespace] = ACTIONS(3679),
    [anon_sym_class] = ACTIONS(3679),
    [anon_sym_ref] = ACTIONS(3679),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_enum] = ACTIONS(3679),
    [anon_sym_LBRACE] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3679),
    [anon_sym_delegate] = ACTIONS(3679),
    [anon_sym_record] = ACTIONS(3679),
    [anon_sym_abstract] = ACTIONS(3679),
    [anon_sym_async] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3679),
    [anon_sym_file] = ACTIONS(3679),
    [anon_sym_fixed] = ACTIONS(3679),
    [anon_sym_internal] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_override] = ACTIONS(3679),
    [anon_sym_partial] = ACTIONS(3679),
    [anon_sym_private] = ACTIONS(3679),
    [anon_sym_protected] = ACTIONS(3679),
    [anon_sym_public] = ACTIONS(3679),
    [anon_sym_readonly] = ACTIONS(3679),
    [anon_sym_required] = ACTIONS(3679),
    [anon_sym_sealed] = ACTIONS(3679),
    [anon_sym_virtual] = ACTIONS(3679),
    [anon_sym_volatile] = ACTIONS(3679),
    [anon_sym_where] = ACTIONS(3679),
    [anon_sym_notnull] = ACTIONS(3679),
    [anon_sym_unmanaged] = ACTIONS(3679),
    [anon_sym_checked] = ACTIONS(3679),
    [anon_sym_BANG] = ACTIONS(3681),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_PLUS_PLUS] = ACTIONS(3681),
    [anon_sym_DASH_DASH] = ACTIONS(3681),
    [anon_sym_true] = ACTIONS(3679),
    [anon_sym_false] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_CARET] = ACTIONS(3681),
    [anon_sym_AMP] = ACTIONS(3681),
    [anon_sym_this] = ACTIONS(3679),
    [anon_sym_scoped] = ACTIONS(3679),
    [anon_sym_base] = ACTIONS(3679),
    [anon_sym_var] = ACTIONS(3679),
    [sym_predefined_type] = ACTIONS(3679),
    [anon_sym_break] = ACTIONS(3679),
    [anon_sym_unchecked] = ACTIONS(3679),
    [anon_sym_continue] = ACTIONS(3679),
    [anon_sym_do] = ACTIONS(3679),
    [anon_sym_while] = ACTIONS(3679),
    [anon_sym_for] = ACTIONS(3679),
    [anon_sym_lock] = ACTIONS(3679),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_switch] = ACTIONS(3679),
    [anon_sym_default] = ACTIONS(3679),
    [anon_sym_throw] = ACTIONS(3679),
    [anon_sym_try] = ACTIONS(3679),
    [anon_sym_when] = ACTIONS(3679),
    [anon_sym_await] = ACTIONS(3679),
    [anon_sym_foreach] = ACTIONS(3679),
    [anon_sym_goto] = ACTIONS(3679),
    [anon_sym_if] = ACTIONS(3679),
    [anon_sym_DOT_DOT] = ACTIONS(3681),
    [anon_sym_from] = ACTIONS(3679),
    [anon_sym_into] = ACTIONS(3679),
    [anon_sym_join] = ACTIONS(3679),
    [anon_sym_on] = ACTIONS(3679),
    [anon_sym_equals] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_orderby] = ACTIONS(3679),
    [anon_sym_ascending] = ACTIONS(3679),
    [anon_sym_descending] = ACTIONS(3679),
    [anon_sym_group] = ACTIONS(3679),
    [anon_sym_by] = ACTIONS(3679),
    [anon_sym_select] = ACTIONS(3679),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_stackalloc] = ACTIONS(3679),
    [anon_sym_sizeof] = ACTIONS(3679),
    [anon_sym_typeof] = ACTIONS(3679),
    [anon_sym___makeref] = ACTIONS(3679),
    [anon_sym___reftype] = ACTIONS(3679),
    [anon_sym___refvalue] = ACTIONS(3679),
    [sym_null_literal] = ACTIONS(3679),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [sym_integer_literal] = ACTIONS(3679),
    [sym_real_literal] = ACTIONS(3681),
    [sym_verbatim_string_literal] = ACTIONS(3681),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3681),
    [sym_interpolation_verbatim_start] = ACTIONS(3681),
    [sym_interpolation_raw_start] = ACTIONS(3681),
    [sym_raw_string_start] = ACTIONS(3681),
  },
  [2644] = {
    [sym_preproc_region] = STATE(2644),
    [sym_preproc_endregion] = STATE(2644),
    [sym_preproc_line] = STATE(2644),
    [sym_preproc_pragma] = STATE(2644),
    [sym_preproc_nullable] = STATE(2644),
    [sym_preproc_error] = STATE(2644),
    [sym_preproc_define] = STATE(2644),
    [sym_preproc_undef] = STATE(2644),
    [ts_builtin_sym_end] = ACTIONS(3939),
    [sym__identifier_token] = ACTIONS(3937),
    [anon_sym_extern] = ACTIONS(3937),
    [anon_sym_alias] = ACTIONS(3937),
    [anon_sym_SEMI] = ACTIONS(3939),
    [anon_sym_global] = ACTIONS(3937),
    [anon_sym_using] = ACTIONS(3937),
    [anon_sym_unsafe] = ACTIONS(3937),
    [anon_sym_static] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_return] = ACTIONS(3937),
    [anon_sym_namespace] = ACTIONS(3937),
    [anon_sym_class] = ACTIONS(3937),
    [anon_sym_ref] = ACTIONS(3937),
    [anon_sym_struct] = ACTIONS(3937),
    [anon_sym_enum] = ACTIONS(3937),
    [anon_sym_LBRACE] = ACTIONS(3939),
    [anon_sym_interface] = ACTIONS(3937),
    [anon_sym_delegate] = ACTIONS(3937),
    [anon_sym_record] = ACTIONS(3937),
    [anon_sym_abstract] = ACTIONS(3937),
    [anon_sym_async] = ACTIONS(3937),
    [anon_sym_const] = ACTIONS(3937),
    [anon_sym_file] = ACTIONS(3937),
    [anon_sym_fixed] = ACTIONS(3937),
    [anon_sym_internal] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_override] = ACTIONS(3937),
    [anon_sym_partial] = ACTIONS(3937),
    [anon_sym_private] = ACTIONS(3937),
    [anon_sym_protected] = ACTIONS(3937),
    [anon_sym_public] = ACTIONS(3937),
    [anon_sym_readonly] = ACTIONS(3937),
    [anon_sym_required] = ACTIONS(3937),
    [anon_sym_sealed] = ACTIONS(3937),
    [anon_sym_virtual] = ACTIONS(3937),
    [anon_sym_volatile] = ACTIONS(3937),
    [anon_sym_where] = ACTIONS(3937),
    [anon_sym_notnull] = ACTIONS(3937),
    [anon_sym_unmanaged] = ACTIONS(3937),
    [anon_sym_checked] = ACTIONS(3937),
    [anon_sym_BANG] = ACTIONS(3939),
    [anon_sym_TILDE] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3939),
    [anon_sym_true] = ACTIONS(3937),
    [anon_sym_false] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_this] = ACTIONS(3937),
    [anon_sym_scoped] = ACTIONS(3937),
    [anon_sym_base] = ACTIONS(3937),
    [anon_sym_var] = ACTIONS(3937),
    [sym_predefined_type] = ACTIONS(3937),
    [anon_sym_break] = ACTIONS(3937),
    [anon_sym_unchecked] = ACTIONS(3937),
    [anon_sym_continue] = ACTIONS(3937),
    [anon_sym_do] = ACTIONS(3937),
    [anon_sym_while] = ACTIONS(3937),
    [anon_sym_for] = ACTIONS(3937),
    [anon_sym_lock] = ACTIONS(3937),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_switch] = ACTIONS(3937),
    [anon_sym_default] = ACTIONS(3937),
    [anon_sym_throw] = ACTIONS(3937),
    [anon_sym_try] = ACTIONS(3937),
    [anon_sym_when] = ACTIONS(3937),
    [anon_sym_await] = ACTIONS(3937),
    [anon_sym_foreach] = ACTIONS(3937),
    [anon_sym_goto] = ACTIONS(3937),
    [anon_sym_if] = ACTIONS(3937),
    [anon_sym_DOT_DOT] = ACTIONS(3939),
    [anon_sym_from] = ACTIONS(3937),
    [anon_sym_into] = ACTIONS(3937),
    [anon_sym_join] = ACTIONS(3937),
    [anon_sym_on] = ACTIONS(3937),
    [anon_sym_equals] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_orderby] = ACTIONS(3937),
    [anon_sym_ascending] = ACTIONS(3937),
    [anon_sym_descending] = ACTIONS(3937),
    [anon_sym_group] = ACTIONS(3937),
    [anon_sym_by] = ACTIONS(3937),
    [anon_sym_select] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(3939),
    [anon_sym_stackalloc] = ACTIONS(3937),
    [anon_sym_sizeof] = ACTIONS(3937),
    [anon_sym_typeof] = ACTIONS(3937),
    [anon_sym___makeref] = ACTIONS(3937),
    [anon_sym___reftype] = ACTIONS(3937),
    [anon_sym___refvalue] = ACTIONS(3937),
    [sym_null_literal] = ACTIONS(3937),
    [anon_sym_SQUOTE] = ACTIONS(3939),
    [sym_integer_literal] = ACTIONS(3937),
    [sym_real_literal] = ACTIONS(3939),
    [sym_verbatim_string_literal] = ACTIONS(3939),
    [aux_sym_preproc_if_token1] = ACTIONS(3939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3939),
    [sym_interpolation_verbatim_start] = ACTIONS(3939),
    [sym_interpolation_raw_start] = ACTIONS(3939),
    [sym_raw_string_start] = ACTIONS(3939),
  },
  [2645] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_region] = STATE(2645),
    [sym_preproc_endregion] = STATE(2645),
    [sym_preproc_line] = STATE(2645),
    [sym_preproc_pragma] = STATE(2645),
    [sym_preproc_nullable] = STATE(2645),
    [sym_preproc_error] = STATE(2645),
    [sym_preproc_define] = STATE(2645),
    [sym_preproc_undef] = STATE(2645),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2647),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_RBRACE] = ACTIONS(4029),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2646] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_region] = STATE(2646),
    [sym_preproc_endregion] = STATE(2646),
    [sym_preproc_line] = STATE(2646),
    [sym_preproc_pragma] = STATE(2646),
    [sym_preproc_nullable] = STATE(2646),
    [sym_preproc_error] = STATE(2646),
    [sym_preproc_define] = STATE(2646),
    [sym_preproc_undef] = STATE(2646),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(4031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2647] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_region] = STATE(2647),
    [sym_preproc_endregion] = STATE(2647),
    [sym_preproc_line] = STATE(2647),
    [sym_preproc_pragma] = STATE(2647),
    [sym_preproc_nullable] = STATE(2647),
    [sym_preproc_error] = STATE(2647),
    [sym_preproc_define] = STATE(2647),
    [sym_preproc_undef] = STATE(2647),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2423),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_RBRACE] = ACTIONS(4033),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2648] = {
    [sym_using_directive] = STATE(3394),
    [sym_attribute_list] = STATE(3778),
    [sym_namespace_declaration] = STATE(3394),
    [sym_class_declaration] = STATE(3394),
    [sym_struct_declaration] = STATE(3394),
    [sym_enum_declaration] = STATE(3394),
    [sym_interface_declaration] = STATE(3394),
    [sym_delegate_declaration] = STATE(3394),
    [sym_record_declaration] = STATE(3394),
    [sym_modifier] = STATE(3802),
    [sym_operator_declaration] = STATE(3394),
    [sym_conversion_operator_declaration] = STATE(3394),
    [sym_declaration] = STATE(3392),
    [sym_field_declaration] = STATE(3394),
    [sym_constructor_declaration] = STATE(3394),
    [sym_destructor_declaration] = STATE(3394),
    [sym_method_declaration] = STATE(3394),
    [sym_event_declaration] = STATE(3394),
    [sym_event_field_declaration] = STATE(3394),
    [sym_indexer_declaration] = STATE(3394),
    [sym_property_declaration] = STATE(3394),
    [sym_variable_declaration] = STATE(9033),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6325),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6755),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_if] = STATE(3394),
    [sym_preproc_region] = STATE(2648),
    [sym_preproc_endregion] = STATE(2648),
    [sym_preproc_line] = STATE(2648),
    [sym_preproc_pragma] = STATE(2648),
    [sym_preproc_nullable] = STATE(2648),
    [sym_preproc_error] = STATE(2648),
    [sym_preproc_define] = STATE(2648),
    [sym_preproc_undef] = STATE(2648),
    [aux_sym_class_declaration_repeat1] = STATE(2781),
    [aux_sym_class_declaration_repeat2] = STATE(2857),
    [aux_sym_declaration_list_repeat1] = STATE(2646),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3117),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3121),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(3129),
    [anon_sym_namespace] = ACTIONS(3131),
    [anon_sym_class] = ACTIONS(3133),
    [anon_sym_ref] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3137),
    [anon_sym_enum] = ACTIONS(3139),
    [anon_sym_interface] = ACTIONS(3141),
    [anon_sym_delegate] = ACTIONS(3143),
    [anon_sym_record] = ACTIONS(3145),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3149),
    [anon_sym_implicit] = ACTIONS(3151),
    [anon_sym_explicit] = ACTIONS(3151),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3159),
    [aux_sym_preproc_if_token3] = ACTIONS(4035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2649] = {
    [sym_preproc_region] = STATE(2649),
    [sym_preproc_endregion] = STATE(2649),
    [sym_preproc_line] = STATE(2649),
    [sym_preproc_pragma] = STATE(2649),
    [sym_preproc_nullable] = STATE(2649),
    [sym_preproc_error] = STATE(2649),
    [sym_preproc_define] = STATE(2649),
    [sym_preproc_undef] = STATE(2649),
    [sym__identifier_token] = ACTIONS(3032),
    [anon_sym_extern] = ACTIONS(3032),
    [anon_sym_alias] = ACTIONS(3032),
    [anon_sym_SEMI] = ACTIONS(3034),
    [anon_sym_global] = ACTIONS(3032),
    [anon_sym_using] = ACTIONS(3032),
    [anon_sym_unsafe] = ACTIONS(3032),
    [anon_sym_static] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_LPAREN] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_ref] = ACTIONS(3032),
    [anon_sym_LBRACE] = ACTIONS(3034),
    [anon_sym_RBRACE] = ACTIONS(3034),
    [anon_sym_delegate] = ACTIONS(3032),
    [anon_sym_abstract] = ACTIONS(3032),
    [anon_sym_async] = ACTIONS(3032),
    [anon_sym_const] = ACTIONS(3032),
    [anon_sym_file] = ACTIONS(3032),
    [anon_sym_fixed] = ACTIONS(3032),
    [anon_sym_internal] = ACTIONS(3032),
    [anon_sym_new] = ACTIONS(3032),
    [anon_sym_override] = ACTIONS(3032),
    [anon_sym_partial] = ACTIONS(3032),
    [anon_sym_private] = ACTIONS(3032),
    [anon_sym_protected] = ACTIONS(3032),
    [anon_sym_public] = ACTIONS(3032),
    [anon_sym_readonly] = ACTIONS(3032),
    [anon_sym_required] = ACTIONS(3032),
    [anon_sym_sealed] = ACTIONS(3032),
    [anon_sym_virtual] = ACTIONS(3032),
    [anon_sym_volatile] = ACTIONS(3032),
    [anon_sym_where] = ACTIONS(3032),
    [anon_sym_notnull] = ACTIONS(3032),
    [anon_sym_unmanaged] = ACTIONS(3032),
    [anon_sym_checked] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3034),
    [anon_sym_TILDE] = ACTIONS(3034),
    [anon_sym_PLUS_PLUS] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3034),
    [anon_sym_true] = ACTIONS(3032),
    [anon_sym_false] = ACTIONS(3032),
    [anon_sym_PLUS] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3034),
    [anon_sym_CARET] = ACTIONS(3034),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_this] = ACTIONS(3032),
    [anon_sym_scoped] = ACTIONS(3032),
    [anon_sym_base] = ACTIONS(3032),
    [anon_sym_var] = ACTIONS(3032),
    [sym_predefined_type] = ACTIONS(3032),
    [anon_sym_break] = ACTIONS(3032),
    [anon_sym_unchecked] = ACTIONS(3032),
    [anon_sym_continue] = ACTIONS(3032),
    [anon_sym_do] = ACTIONS(3032),
    [anon_sym_while] = ACTIONS(3032),
    [anon_sym_for] = ACTIONS(3032),
    [anon_sym_lock] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3032),
    [anon_sym_switch] = ACTIONS(3032),
    [anon_sym_case] = ACTIONS(3032),
    [anon_sym_default] = ACTIONS(3032),
    [anon_sym_throw] = ACTIONS(3032),
    [anon_sym_try] = ACTIONS(3032),
    [anon_sym_catch] = ACTIONS(3032),
    [anon_sym_when] = ACTIONS(3032),
    [anon_sym_finally] = ACTIONS(3032),
    [anon_sym_await] = ACTIONS(3032),
    [anon_sym_foreach] = ACTIONS(3032),
    [anon_sym_goto] = ACTIONS(3032),
    [anon_sym_if] = ACTIONS(3032),
    [anon_sym_else] = ACTIONS(3032),
    [anon_sym_DOT_DOT] = ACTIONS(3034),
    [anon_sym_from] = ACTIONS(3032),
    [anon_sym_into] = ACTIONS(3032),
    [anon_sym_join] = ACTIONS(3032),
    [anon_sym_on] = ACTIONS(3032),
    [anon_sym_equals] = ACTIONS(3032),
    [anon_sym_let] = ACTIONS(3032),
    [anon_sym_orderby] = ACTIONS(3032),
    [anon_sym_ascending] = ACTIONS(3032),
    [anon_sym_descending] = ACTIONS(3032),
    [anon_sym_group] = ACTIONS(3032),
    [anon_sym_by] = ACTIONS(3032),
    [anon_sym_select] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3034),
    [anon_sym_stackalloc] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3032),
    [anon_sym_typeof] = ACTIONS(3032),
    [anon_sym___makeref] = ACTIONS(3032),
    [anon_sym___reftype] = ACTIONS(3032),
    [anon_sym___refvalue] = ACTIONS(3032),
    [sym_null_literal] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3034),
    [sym_integer_literal] = ACTIONS(3032),
    [sym_real_literal] = ACTIONS(3034),
    [sym_verbatim_string_literal] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3034),
    [sym_interpolation_verbatim_start] = ACTIONS(3034),
    [sym_interpolation_raw_start] = ACTIONS(3034),
    [sym_raw_string_start] = ACTIONS(3034),
  },
  [2650] = {
    [sym_preproc_region] = STATE(2650),
    [sym_preproc_endregion] = STATE(2650),
    [sym_preproc_line] = STATE(2650),
    [sym_preproc_pragma] = STATE(2650),
    [sym_preproc_nullable] = STATE(2650),
    [sym_preproc_error] = STATE(2650),
    [sym_preproc_define] = STATE(2650),
    [sym_preproc_undef] = STATE(2650),
    [sym__identifier_token] = ACTIONS(3024),
    [anon_sym_extern] = ACTIONS(3024),
    [anon_sym_alias] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3026),
    [anon_sym_global] = ACTIONS(3024),
    [anon_sym_using] = ACTIONS(3024),
    [anon_sym_unsafe] = ACTIONS(3024),
    [anon_sym_static] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_LPAREN] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_ref] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_RBRACE] = ACTIONS(3026),
    [anon_sym_delegate] = ACTIONS(3024),
    [anon_sym_abstract] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_file] = ACTIONS(3024),
    [anon_sym_fixed] = ACTIONS(3024),
    [anon_sym_internal] = ACTIONS(3024),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_override] = ACTIONS(3024),
    [anon_sym_partial] = ACTIONS(3024),
    [anon_sym_private] = ACTIONS(3024),
    [anon_sym_protected] = ACTIONS(3024),
    [anon_sym_public] = ACTIONS(3024),
    [anon_sym_readonly] = ACTIONS(3024),
    [anon_sym_required] = ACTIONS(3024),
    [anon_sym_sealed] = ACTIONS(3024),
    [anon_sym_virtual] = ACTIONS(3024),
    [anon_sym_volatile] = ACTIONS(3024),
    [anon_sym_where] = ACTIONS(3024),
    [anon_sym_notnull] = ACTIONS(3024),
    [anon_sym_unmanaged] = ACTIONS(3024),
    [anon_sym_checked] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3026),
    [anon_sym_PLUS_PLUS] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3026),
    [anon_sym_true] = ACTIONS(3024),
    [anon_sym_false] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_CARET] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_this] = ACTIONS(3024),
    [anon_sym_scoped] = ACTIONS(3024),
    [anon_sym_base] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [sym_predefined_type] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_unchecked] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_lock] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_catch] = ACTIONS(3024),
    [anon_sym_when] = ACTIONS(3024),
    [anon_sym_finally] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_foreach] = ACTIONS(3024),
    [anon_sym_goto] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3024),
    [anon_sym_DOT_DOT] = ACTIONS(3026),
    [anon_sym_from] = ACTIONS(3024),
    [anon_sym_into] = ACTIONS(3024),
    [anon_sym_join] = ACTIONS(3024),
    [anon_sym_on] = ACTIONS(3024),
    [anon_sym_equals] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_orderby] = ACTIONS(3024),
    [anon_sym_ascending] = ACTIONS(3024),
    [anon_sym_descending] = ACTIONS(3024),
    [anon_sym_group] = ACTIONS(3024),
    [anon_sym_by] = ACTIONS(3024),
    [anon_sym_select] = ACTIONS(3024),
    [anon_sym_DQUOTE] = ACTIONS(3026),
    [anon_sym_stackalloc] = ACTIONS(3024),
    [anon_sym_sizeof] = ACTIONS(3024),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym___makeref] = ACTIONS(3024),
    [anon_sym___reftype] = ACTIONS(3024),
    [anon_sym___refvalue] = ACTIONS(3024),
    [sym_null_literal] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(3026),
    [sym_integer_literal] = ACTIONS(3024),
    [sym_real_literal] = ACTIONS(3026),
    [sym_verbatim_string_literal] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3026),
    [sym_interpolation_verbatim_start] = ACTIONS(3026),
    [sym_interpolation_raw_start] = ACTIONS(3026),
    [sym_raw_string_start] = ACTIONS(3026),
  },
  [2651] = {
    [sym_preproc_region] = STATE(2651),
    [sym_preproc_endregion] = STATE(2651),
    [sym_preproc_line] = STATE(2651),
    [sym_preproc_pragma] = STATE(2651),
    [sym_preproc_nullable] = STATE(2651),
    [sym_preproc_error] = STATE(2651),
    [sym_preproc_define] = STATE(2651),
    [sym_preproc_undef] = STATE(2651),
    [sym__identifier_token] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym_alias] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_global] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_unsafe] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_LBRACE] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_delegate] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_file] = ACTIONS(3040),
    [anon_sym_fixed] = ACTIONS(3040),
    [anon_sym_internal] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_partial] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_required] = ACTIONS(3040),
    [anon_sym_sealed] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3040),
    [anon_sym_notnull] = ACTIONS(3040),
    [anon_sym_unmanaged] = ACTIONS(3040),
    [anon_sym_checked] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3042),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_true] = ACTIONS(3040),
    [anon_sym_false] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_this] = ACTIONS(3040),
    [anon_sym_scoped] = ACTIONS(3040),
    [anon_sym_base] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [sym_predefined_type] = ACTIONS(3040),
    [anon_sym_break] = ACTIONS(3040),
    [anon_sym_unchecked] = ACTIONS(3040),
    [anon_sym_continue] = ACTIONS(3040),
    [anon_sym_do] = ACTIONS(3040),
    [anon_sym_while] = ACTIONS(3040),
    [anon_sym_for] = ACTIONS(3040),
    [anon_sym_lock] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_switch] = ACTIONS(3040),
    [anon_sym_case] = ACTIONS(3040),
    [anon_sym_default] = ACTIONS(3040),
    [anon_sym_throw] = ACTIONS(3040),
    [anon_sym_try] = ACTIONS(3040),
    [anon_sym_catch] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_finally] = ACTIONS(3040),
    [anon_sym_await] = ACTIONS(3040),
    [anon_sym_foreach] = ACTIONS(3040),
    [anon_sym_goto] = ACTIONS(3040),
    [anon_sym_if] = ACTIONS(3040),
    [anon_sym_else] = ACTIONS(3040),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_from] = ACTIONS(3040),
    [anon_sym_into] = ACTIONS(3040),
    [anon_sym_join] = ACTIONS(3040),
    [anon_sym_on] = ACTIONS(3040),
    [anon_sym_equals] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_orderby] = ACTIONS(3040),
    [anon_sym_ascending] = ACTIONS(3040),
    [anon_sym_descending] = ACTIONS(3040),
    [anon_sym_group] = ACTIONS(3040),
    [anon_sym_by] = ACTIONS(3040),
    [anon_sym_select] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3042),
    [anon_sym_stackalloc] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3040),
    [anon_sym_typeof] = ACTIONS(3040),
    [anon_sym___makeref] = ACTIONS(3040),
    [anon_sym___reftype] = ACTIONS(3040),
    [anon_sym___refvalue] = ACTIONS(3040),
    [sym_null_literal] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3042),
    [sym_integer_literal] = ACTIONS(3040),
    [sym_real_literal] = ACTIONS(3042),
    [sym_verbatim_string_literal] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3042),
    [sym_interpolation_verbatim_start] = ACTIONS(3042),
    [sym_interpolation_raw_start] = ACTIONS(3042),
    [sym_raw_string_start] = ACTIONS(3042),
  },
  [2652] = {
    [sym_preproc_region] = STATE(2652),
    [sym_preproc_endregion] = STATE(2652),
    [sym_preproc_line] = STATE(2652),
    [sym_preproc_pragma] = STATE(2652),
    [sym_preproc_nullable] = STATE(2652),
    [sym_preproc_error] = STATE(2652),
    [sym_preproc_define] = STATE(2652),
    [sym_preproc_undef] = STATE(2652),
    [sym__identifier_token] = ACTIONS(3028),
    [anon_sym_extern] = ACTIONS(3028),
    [anon_sym_alias] = ACTIONS(3028),
    [anon_sym_SEMI] = ACTIONS(3030),
    [anon_sym_global] = ACTIONS(3028),
    [anon_sym_using] = ACTIONS(3028),
    [anon_sym_unsafe] = ACTIONS(3028),
    [anon_sym_static] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3028),
    [anon_sym_ref] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3030),
    [anon_sym_delegate] = ACTIONS(3028),
    [anon_sym_abstract] = ACTIONS(3028),
    [anon_sym_async] = ACTIONS(3028),
    [anon_sym_const] = ACTIONS(3028),
    [anon_sym_file] = ACTIONS(3028),
    [anon_sym_fixed] = ACTIONS(3028),
    [anon_sym_internal] = ACTIONS(3028),
    [anon_sym_new] = ACTIONS(3028),
    [anon_sym_override] = ACTIONS(3028),
    [anon_sym_partial] = ACTIONS(3028),
    [anon_sym_private] = ACTIONS(3028),
    [anon_sym_protected] = ACTIONS(3028),
    [anon_sym_public] = ACTIONS(3028),
    [anon_sym_readonly] = ACTIONS(3028),
    [anon_sym_required] = ACTIONS(3028),
    [anon_sym_sealed] = ACTIONS(3028),
    [anon_sym_virtual] = ACTIONS(3028),
    [anon_sym_volatile] = ACTIONS(3028),
    [anon_sym_where] = ACTIONS(3028),
    [anon_sym_notnull] = ACTIONS(3028),
    [anon_sym_unmanaged] = ACTIONS(3028),
    [anon_sym_checked] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3030),
    [anon_sym_TILDE] = ACTIONS(3030),
    [anon_sym_PLUS_PLUS] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3030),
    [anon_sym_true] = ACTIONS(3028),
    [anon_sym_false] = ACTIONS(3028),
    [anon_sym_PLUS] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3030),
    [anon_sym_CARET] = ACTIONS(3030),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_this] = ACTIONS(3028),
    [anon_sym_scoped] = ACTIONS(3028),
    [anon_sym_base] = ACTIONS(3028),
    [anon_sym_var] = ACTIONS(3028),
    [sym_predefined_type] = ACTIONS(3028),
    [anon_sym_break] = ACTIONS(3028),
    [anon_sym_unchecked] = ACTIONS(3028),
    [anon_sym_continue] = ACTIONS(3028),
    [anon_sym_do] = ACTIONS(3028),
    [anon_sym_while] = ACTIONS(3028),
    [anon_sym_for] = ACTIONS(3028),
    [anon_sym_lock] = ACTIONS(3028),
    [anon_sym_yield] = ACTIONS(3028),
    [anon_sym_switch] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(3028),
    [anon_sym_default] = ACTIONS(3028),
    [anon_sym_throw] = ACTIONS(3028),
    [anon_sym_try] = ACTIONS(3028),
    [anon_sym_catch] = ACTIONS(3028),
    [anon_sym_when] = ACTIONS(3028),
    [anon_sym_finally] = ACTIONS(3028),
    [anon_sym_await] = ACTIONS(3028),
    [anon_sym_foreach] = ACTIONS(3028),
    [anon_sym_goto] = ACTIONS(3028),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_else] = ACTIONS(3028),
    [anon_sym_DOT_DOT] = ACTIONS(3030),
    [anon_sym_from] = ACTIONS(3028),
    [anon_sym_into] = ACTIONS(3028),
    [anon_sym_join] = ACTIONS(3028),
    [anon_sym_on] = ACTIONS(3028),
    [anon_sym_equals] = ACTIONS(3028),
    [anon_sym_let] = ACTIONS(3028),
    [anon_sym_orderby] = ACTIONS(3028),
    [anon_sym_ascending] = ACTIONS(3028),
    [anon_sym_descending] = ACTIONS(3028),
    [anon_sym_group] = ACTIONS(3028),
    [anon_sym_by] = ACTIONS(3028),
    [anon_sym_select] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3030),
    [anon_sym_stackalloc] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3028),
    [anon_sym_typeof] = ACTIONS(3028),
    [anon_sym___makeref] = ACTIONS(3028),
    [anon_sym___reftype] = ACTIONS(3028),
    [anon_sym___refvalue] = ACTIONS(3028),
    [sym_null_literal] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3030),
    [sym_integer_literal] = ACTIONS(3028),
    [sym_real_literal] = ACTIONS(3030),
    [sym_verbatim_string_literal] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3030),
    [sym_interpolation_verbatim_start] = ACTIONS(3030),
    [sym_interpolation_raw_start] = ACTIONS(3030),
    [sym_raw_string_start] = ACTIONS(3030),
  },
  [2653] = {
    [sym_preproc_region] = STATE(2653),
    [sym_preproc_endregion] = STATE(2653),
    [sym_preproc_line] = STATE(2653),
    [sym_preproc_pragma] = STATE(2653),
    [sym_preproc_nullable] = STATE(2653),
    [sym_preproc_error] = STATE(2653),
    [sym_preproc_define] = STATE(2653),
    [sym_preproc_undef] = STATE(2653),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_checked] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_true] = ACTIONS(2985),
    [anon_sym_false] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_this] = ACTIONS(2985),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_base] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_unchecked] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_lock] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2985),
    [anon_sym_default] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_catch] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_finally] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_foreach] = ACTIONS(2985),
    [anon_sym_goto] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_else] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_stackalloc] = ACTIONS(2985),
    [anon_sym_sizeof] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym___makeref] = ACTIONS(2985),
    [anon_sym___reftype] = ACTIONS(2985),
    [anon_sym___refvalue] = ACTIONS(2985),
    [sym_null_literal] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_integer_literal] = ACTIONS(2985),
    [sym_real_literal] = ACTIONS(2987),
    [sym_verbatim_string_literal] = ACTIONS(2987),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(2987),
    [sym_interpolation_verbatim_start] = ACTIONS(2987),
    [sym_interpolation_raw_start] = ACTIONS(2987),
    [sym_raw_string_start] = ACTIONS(2987),
  },
  [2654] = {
    [sym_preproc_region] = STATE(2654),
    [sym_preproc_endregion] = STATE(2654),
    [sym_preproc_line] = STATE(2654),
    [sym_preproc_pragma] = STATE(2654),
    [sym_preproc_nullable] = STATE(2654),
    [sym_preproc_error] = STATE(2654),
    [sym_preproc_define] = STATE(2654),
    [sym_preproc_undef] = STATE(2654),
    [sym__identifier_token] = ACTIONS(3036),
    [anon_sym_extern] = ACTIONS(3036),
    [anon_sym_alias] = ACTIONS(3036),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_global] = ACTIONS(3036),
    [anon_sym_using] = ACTIONS(3036),
    [anon_sym_unsafe] = ACTIONS(3036),
    [anon_sym_static] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3036),
    [anon_sym_ref] = ACTIONS(3036),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_delegate] = ACTIONS(3036),
    [anon_sym_abstract] = ACTIONS(3036),
    [anon_sym_async] = ACTIONS(3036),
    [anon_sym_const] = ACTIONS(3036),
    [anon_sym_file] = ACTIONS(3036),
    [anon_sym_fixed] = ACTIONS(3036),
    [anon_sym_internal] = ACTIONS(3036),
    [anon_sym_new] = ACTIONS(3036),
    [anon_sym_override] = ACTIONS(3036),
    [anon_sym_partial] = ACTIONS(3036),
    [anon_sym_private] = ACTIONS(3036),
    [anon_sym_protected] = ACTIONS(3036),
    [anon_sym_public] = ACTIONS(3036),
    [anon_sym_readonly] = ACTIONS(3036),
    [anon_sym_required] = ACTIONS(3036),
    [anon_sym_sealed] = ACTIONS(3036),
    [anon_sym_virtual] = ACTIONS(3036),
    [anon_sym_volatile] = ACTIONS(3036),
    [anon_sym_where] = ACTIONS(3036),
    [anon_sym_notnull] = ACTIONS(3036),
    [anon_sym_unmanaged] = ACTIONS(3036),
    [anon_sym_checked] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3038),
    [anon_sym_TILDE] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_true] = ACTIONS(3036),
    [anon_sym_false] = ACTIONS(3036),
    [anon_sym_PLUS] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3036),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_this] = ACTIONS(3036),
    [anon_sym_scoped] = ACTIONS(3036),
    [anon_sym_base] = ACTIONS(3036),
    [anon_sym_var] = ACTIONS(3036),
    [sym_predefined_type] = ACTIONS(3036),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_unchecked] = ACTIONS(3036),
    [anon_sym_continue] = ACTIONS(3036),
    [anon_sym_do] = ACTIONS(3036),
    [anon_sym_while] = ACTIONS(3036),
    [anon_sym_for] = ACTIONS(3036),
    [anon_sym_lock] = ACTIONS(3036),
    [anon_sym_yield] = ACTIONS(3036),
    [anon_sym_switch] = ACTIONS(3036),
    [anon_sym_case] = ACTIONS(3036),
    [anon_sym_default] = ACTIONS(3036),
    [anon_sym_throw] = ACTIONS(3036),
    [anon_sym_try] = ACTIONS(3036),
    [anon_sym_catch] = ACTIONS(3036),
    [anon_sym_when] = ACTIONS(3036),
    [anon_sym_finally] = ACTIONS(3036),
    [anon_sym_await] = ACTIONS(3036),
    [anon_sym_foreach] = ACTIONS(3036),
    [anon_sym_goto] = ACTIONS(3036),
    [anon_sym_if] = ACTIONS(3036),
    [anon_sym_else] = ACTIONS(3036),
    [anon_sym_DOT_DOT] = ACTIONS(3038),
    [anon_sym_from] = ACTIONS(3036),
    [anon_sym_into] = ACTIONS(3036),
    [anon_sym_join] = ACTIONS(3036),
    [anon_sym_on] = ACTIONS(3036),
    [anon_sym_equals] = ACTIONS(3036),
    [anon_sym_let] = ACTIONS(3036),
    [anon_sym_orderby] = ACTIONS(3036),
    [anon_sym_ascending] = ACTIONS(3036),
    [anon_sym_descending] = ACTIONS(3036),
    [anon_sym_group] = ACTIONS(3036),
    [anon_sym_by] = ACTIONS(3036),
    [anon_sym_select] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_stackalloc] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3036),
    [anon_sym_typeof] = ACTIONS(3036),
    [anon_sym___makeref] = ACTIONS(3036),
    [anon_sym___reftype] = ACTIONS(3036),
    [anon_sym___refvalue] = ACTIONS(3036),
    [sym_null_literal] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [sym_integer_literal] = ACTIONS(3036),
    [sym_real_literal] = ACTIONS(3038),
    [sym_verbatim_string_literal] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3038),
    [sym_interpolation_verbatim_start] = ACTIONS(3038),
    [sym_interpolation_raw_start] = ACTIONS(3038),
    [sym_raw_string_start] = ACTIONS(3038),
  },
  [2655] = {
    [sym_preproc_region] = STATE(2655),
    [sym_preproc_endregion] = STATE(2655),
    [sym_preproc_line] = STATE(2655),
    [sym_preproc_pragma] = STATE(2655),
    [sym_preproc_nullable] = STATE(2655),
    [sym_preproc_error] = STATE(2655),
    [sym_preproc_define] = STATE(2655),
    [sym_preproc_undef] = STATE(2655),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2656] = {
    [sym_preproc_region] = STATE(2656),
    [sym_preproc_endregion] = STATE(2656),
    [sym_preproc_line] = STATE(2656),
    [sym_preproc_pragma] = STATE(2656),
    [sym_preproc_nullable] = STATE(2656),
    [sym_preproc_error] = STATE(2656),
    [sym_preproc_define] = STATE(2656),
    [sym_preproc_undef] = STATE(2656),
    [sym__identifier_token] = ACTIONS(3225),
    [anon_sym_extern] = ACTIONS(3225),
    [anon_sym_alias] = ACTIONS(3225),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_global] = ACTIONS(3225),
    [anon_sym_using] = ACTIONS(3225),
    [anon_sym_unsafe] = ACTIONS(3225),
    [anon_sym_static] = ACTIONS(3225),
    [anon_sym_LBRACK] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3225),
    [anon_sym_ref] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3227),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_delegate] = ACTIONS(3225),
    [anon_sym_abstract] = ACTIONS(3225),
    [anon_sym_async] = ACTIONS(3225),
    [anon_sym_const] = ACTIONS(3225),
    [anon_sym_file] = ACTIONS(3225),
    [anon_sym_fixed] = ACTIONS(3225),
    [anon_sym_internal] = ACTIONS(3225),
    [anon_sym_new] = ACTIONS(3225),
    [anon_sym_override] = ACTIONS(3225),
    [anon_sym_partial] = ACTIONS(3225),
    [anon_sym_private] = ACTIONS(3225),
    [anon_sym_protected] = ACTIONS(3225),
    [anon_sym_public] = ACTIONS(3225),
    [anon_sym_readonly] = ACTIONS(3225),
    [anon_sym_required] = ACTIONS(3225),
    [anon_sym_sealed] = ACTIONS(3225),
    [anon_sym_virtual] = ACTIONS(3225),
    [anon_sym_volatile] = ACTIONS(3225),
    [anon_sym_where] = ACTIONS(3225),
    [anon_sym_notnull] = ACTIONS(3225),
    [anon_sym_unmanaged] = ACTIONS(3225),
    [anon_sym_checked] = ACTIONS(3225),
    [anon_sym_BANG] = ACTIONS(3227),
    [anon_sym_TILDE] = ACTIONS(3227),
    [anon_sym_PLUS_PLUS] = ACTIONS(3227),
    [anon_sym_DASH_DASH] = ACTIONS(3227),
    [anon_sym_true] = ACTIONS(3225),
    [anon_sym_false] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3225),
    [anon_sym_DASH] = ACTIONS(3225),
    [anon_sym_STAR] = ACTIONS(3227),
    [anon_sym_CARET] = ACTIONS(3227),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_this] = ACTIONS(3225),
    [anon_sym_scoped] = ACTIONS(3225),
    [anon_sym_base] = ACTIONS(3225),
    [anon_sym_var] = ACTIONS(3225),
    [sym_predefined_type] = ACTIONS(3225),
    [anon_sym_break] = ACTIONS(3225),
    [anon_sym_unchecked] = ACTIONS(3225),
    [anon_sym_continue] = ACTIONS(3225),
    [anon_sym_do] = ACTIONS(3225),
    [anon_sym_while] = ACTIONS(3225),
    [anon_sym_for] = ACTIONS(3225),
    [anon_sym_lock] = ACTIONS(3225),
    [anon_sym_yield] = ACTIONS(3225),
    [anon_sym_switch] = ACTIONS(3225),
    [anon_sym_case] = ACTIONS(3225),
    [anon_sym_default] = ACTIONS(3225),
    [anon_sym_throw] = ACTIONS(3225),
    [anon_sym_try] = ACTIONS(3225),
    [anon_sym_when] = ACTIONS(3225),
    [anon_sym_await] = ACTIONS(3225),
    [anon_sym_foreach] = ACTIONS(3225),
    [anon_sym_goto] = ACTIONS(3225),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_else] = ACTIONS(3225),
    [anon_sym_DOT_DOT] = ACTIONS(3227),
    [anon_sym_from] = ACTIONS(3225),
    [anon_sym_into] = ACTIONS(3225),
    [anon_sym_join] = ACTIONS(3225),
    [anon_sym_on] = ACTIONS(3225),
    [anon_sym_equals] = ACTIONS(3225),
    [anon_sym_let] = ACTIONS(3225),
    [anon_sym_orderby] = ACTIONS(3225),
    [anon_sym_ascending] = ACTIONS(3225),
    [anon_sym_descending] = ACTIONS(3225),
    [anon_sym_group] = ACTIONS(3225),
    [anon_sym_by] = ACTIONS(3225),
    [anon_sym_select] = ACTIONS(3225),
    [anon_sym_DQUOTE] = ACTIONS(3227),
    [anon_sym_stackalloc] = ACTIONS(3225),
    [anon_sym_sizeof] = ACTIONS(3225),
    [anon_sym_typeof] = ACTIONS(3225),
    [anon_sym___makeref] = ACTIONS(3225),
    [anon_sym___reftype] = ACTIONS(3225),
    [anon_sym___refvalue] = ACTIONS(3225),
    [sym_null_literal] = ACTIONS(3225),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [sym_integer_literal] = ACTIONS(3225),
    [sym_real_literal] = ACTIONS(3227),
    [sym_verbatim_string_literal] = ACTIONS(3227),
    [aux_sym_preproc_if_token1] = ACTIONS(3227),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3227),
    [sym_interpolation_verbatim_start] = ACTIONS(3227),
    [sym_interpolation_raw_start] = ACTIONS(3227),
    [sym_raw_string_start] = ACTIONS(3227),
  },
  [2657] = {
    [sym_preproc_region] = STATE(2657),
    [sym_preproc_endregion] = STATE(2657),
    [sym_preproc_line] = STATE(2657),
    [sym_preproc_pragma] = STATE(2657),
    [sym_preproc_nullable] = STATE(2657),
    [sym_preproc_error] = STATE(2657),
    [sym_preproc_define] = STATE(2657),
    [sym_preproc_undef] = STATE(2657),
    [sym__identifier_token] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym_alias] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_global] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_unsafe] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_ref] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [anon_sym_delegate] = ACTIONS(3083),
    [anon_sym_abstract] = ACTIONS(3083),
    [anon_sym_async] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_file] = ACTIONS(3083),
    [anon_sym_fixed] = ACTIONS(3083),
    [anon_sym_internal] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_override] = ACTIONS(3083),
    [anon_sym_partial] = ACTIONS(3083),
    [anon_sym_private] = ACTIONS(3083),
    [anon_sym_protected] = ACTIONS(3083),
    [anon_sym_public] = ACTIONS(3083),
    [anon_sym_readonly] = ACTIONS(3083),
    [anon_sym_required] = ACTIONS(3083),
    [anon_sym_sealed] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_where] = ACTIONS(3083),
    [anon_sym_notnull] = ACTIONS(3083),
    [anon_sym_unmanaged] = ACTIONS(3083),
    [anon_sym_checked] = ACTIONS(3083),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_true] = ACTIONS(3083),
    [anon_sym_false] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_this] = ACTIONS(3083),
    [anon_sym_scoped] = ACTIONS(3083),
    [anon_sym_base] = ACTIONS(3083),
    [anon_sym_var] = ACTIONS(3083),
    [sym_predefined_type] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_unchecked] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_lock] = ACTIONS(3083),
    [anon_sym_yield] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_when] = ACTIONS(3083),
    [anon_sym_await] = ACTIONS(3083),
    [anon_sym_foreach] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_else] = ACTIONS(3083),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_from] = ACTIONS(3083),
    [anon_sym_into] = ACTIONS(3083),
    [anon_sym_join] = ACTIONS(3083),
    [anon_sym_on] = ACTIONS(3083),
    [anon_sym_equals] = ACTIONS(3083),
    [anon_sym_let] = ACTIONS(3083),
    [anon_sym_orderby] = ACTIONS(3083),
    [anon_sym_ascending] = ACTIONS(3083),
    [anon_sym_descending] = ACTIONS(3083),
    [anon_sym_group] = ACTIONS(3083),
    [anon_sym_by] = ACTIONS(3083),
    [anon_sym_select] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [anon_sym_stackalloc] = ACTIONS(3083),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym_typeof] = ACTIONS(3083),
    [anon_sym___makeref] = ACTIONS(3083),
    [anon_sym___reftype] = ACTIONS(3083),
    [anon_sym___refvalue] = ACTIONS(3083),
    [sym_null_literal] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [sym_integer_literal] = ACTIONS(3083),
    [sym_real_literal] = ACTIONS(3085),
    [sym_verbatim_string_literal] = ACTIONS(3085),
    [aux_sym_preproc_if_token1] = ACTIONS(3085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3085),
    [sym_interpolation_verbatim_start] = ACTIONS(3085),
    [sym_interpolation_raw_start] = ACTIONS(3085),
    [sym_raw_string_start] = ACTIONS(3085),
  },
  [2658] = {
    [sym_preproc_region] = STATE(2658),
    [sym_preproc_endregion] = STATE(2658),
    [sym_preproc_line] = STATE(2658),
    [sym_preproc_pragma] = STATE(2658),
    [sym_preproc_nullable] = STATE(2658),
    [sym_preproc_error] = STATE(2658),
    [sym_preproc_define] = STATE(2658),
    [sym_preproc_undef] = STATE(2658),
    [sym__identifier_token] = ACTIONS(3281),
    [anon_sym_extern] = ACTIONS(3281),
    [anon_sym_alias] = ACTIONS(3281),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_global] = ACTIONS(3281),
    [anon_sym_using] = ACTIONS(3281),
    [anon_sym_unsafe] = ACTIONS(3281),
    [anon_sym_static] = ACTIONS(3281),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_return] = ACTIONS(3281),
    [anon_sym_ref] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_delegate] = ACTIONS(3281),
    [anon_sym_abstract] = ACTIONS(3281),
    [anon_sym_async] = ACTIONS(3281),
    [anon_sym_const] = ACTIONS(3281),
    [anon_sym_file] = ACTIONS(3281),
    [anon_sym_fixed] = ACTIONS(3281),
    [anon_sym_internal] = ACTIONS(3281),
    [anon_sym_new] = ACTIONS(3281),
    [anon_sym_override] = ACTIONS(3281),
    [anon_sym_partial] = ACTIONS(3281),
    [anon_sym_private] = ACTIONS(3281),
    [anon_sym_protected] = ACTIONS(3281),
    [anon_sym_public] = ACTIONS(3281),
    [anon_sym_readonly] = ACTIONS(3281),
    [anon_sym_required] = ACTIONS(3281),
    [anon_sym_sealed] = ACTIONS(3281),
    [anon_sym_virtual] = ACTIONS(3281),
    [anon_sym_volatile] = ACTIONS(3281),
    [anon_sym_where] = ACTIONS(3281),
    [anon_sym_notnull] = ACTIONS(3281),
    [anon_sym_unmanaged] = ACTIONS(3281),
    [anon_sym_checked] = ACTIONS(3281),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_true] = ACTIONS(3281),
    [anon_sym_false] = ACTIONS(3281),
    [anon_sym_PLUS] = ACTIONS(3281),
    [anon_sym_DASH] = ACTIONS(3281),
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_this] = ACTIONS(3281),
    [anon_sym_scoped] = ACTIONS(3281),
    [anon_sym_base] = ACTIONS(3281),
    [anon_sym_var] = ACTIONS(3281),
    [sym_predefined_type] = ACTIONS(3281),
    [anon_sym_break] = ACTIONS(3281),
    [anon_sym_unchecked] = ACTIONS(3281),
    [anon_sym_continue] = ACTIONS(3281),
    [anon_sym_do] = ACTIONS(3281),
    [anon_sym_while] = ACTIONS(3281),
    [anon_sym_for] = ACTIONS(3281),
    [anon_sym_lock] = ACTIONS(3281),
    [anon_sym_yield] = ACTIONS(3281),
    [anon_sym_switch] = ACTIONS(3281),
    [anon_sym_case] = ACTIONS(3281),
    [anon_sym_default] = ACTIONS(3281),
    [anon_sym_throw] = ACTIONS(3281),
    [anon_sym_try] = ACTIONS(3281),
    [anon_sym_when] = ACTIONS(3281),
    [anon_sym_await] = ACTIONS(3281),
    [anon_sym_foreach] = ACTIONS(3281),
    [anon_sym_goto] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(3281),
    [anon_sym_else] = ACTIONS(3281),
    [anon_sym_DOT_DOT] = ACTIONS(3283),
    [anon_sym_from] = ACTIONS(3281),
    [anon_sym_into] = ACTIONS(3281),
    [anon_sym_join] = ACTIONS(3281),
    [anon_sym_on] = ACTIONS(3281),
    [anon_sym_equals] = ACTIONS(3281),
    [anon_sym_let] = ACTIONS(3281),
    [anon_sym_orderby] = ACTIONS(3281),
    [anon_sym_ascending] = ACTIONS(3281),
    [anon_sym_descending] = ACTIONS(3281),
    [anon_sym_group] = ACTIONS(3281),
    [anon_sym_by] = ACTIONS(3281),
    [anon_sym_select] = ACTIONS(3281),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_stackalloc] = ACTIONS(3281),
    [anon_sym_sizeof] = ACTIONS(3281),
    [anon_sym_typeof] = ACTIONS(3281),
    [anon_sym___makeref] = ACTIONS(3281),
    [anon_sym___reftype] = ACTIONS(3281),
    [anon_sym___refvalue] = ACTIONS(3281),
    [sym_null_literal] = ACTIONS(3281),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [sym_integer_literal] = ACTIONS(3281),
    [sym_real_literal] = ACTIONS(3283),
    [sym_verbatim_string_literal] = ACTIONS(3283),
    [aux_sym_preproc_if_token1] = ACTIONS(3283),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3283),
    [sym_interpolation_verbatim_start] = ACTIONS(3283),
    [sym_interpolation_raw_start] = ACTIONS(3283),
    [sym_raw_string_start] = ACTIONS(3283),
  },
  [2659] = {
    [sym_preproc_region] = STATE(2659),
    [sym_preproc_endregion] = STATE(2659),
    [sym_preproc_line] = STATE(2659),
    [sym_preproc_pragma] = STATE(2659),
    [sym_preproc_nullable] = STATE(2659),
    [sym_preproc_error] = STATE(2659),
    [sym_preproc_define] = STATE(2659),
    [sym_preproc_undef] = STATE(2659),
    [sym__identifier_token] = ACTIONS(3001),
    [anon_sym_extern] = ACTIONS(3001),
    [anon_sym_alias] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_global] = ACTIONS(3001),
    [anon_sym_using] = ACTIONS(3001),
    [anon_sym_unsafe] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3001),
    [anon_sym_LBRACK] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3001),
    [anon_sym_ref] = ACTIONS(3001),
    [anon_sym_LBRACE] = ACTIONS(3003),
    [anon_sym_RBRACE] = ACTIONS(3003),
    [anon_sym_delegate] = ACTIONS(3001),
    [anon_sym_abstract] = ACTIONS(3001),
    [anon_sym_async] = ACTIONS(3001),
    [anon_sym_const] = ACTIONS(3001),
    [anon_sym_file] = ACTIONS(3001),
    [anon_sym_fixed] = ACTIONS(3001),
    [anon_sym_internal] = ACTIONS(3001),
    [anon_sym_new] = ACTIONS(3001),
    [anon_sym_override] = ACTIONS(3001),
    [anon_sym_partial] = ACTIONS(3001),
    [anon_sym_private] = ACTIONS(3001),
    [anon_sym_protected] = ACTIONS(3001),
    [anon_sym_public] = ACTIONS(3001),
    [anon_sym_readonly] = ACTIONS(3001),
    [anon_sym_required] = ACTIONS(3001),
    [anon_sym_sealed] = ACTIONS(3001),
    [anon_sym_virtual] = ACTIONS(3001),
    [anon_sym_volatile] = ACTIONS(3001),
    [anon_sym_where] = ACTIONS(3001),
    [anon_sym_notnull] = ACTIONS(3001),
    [anon_sym_unmanaged] = ACTIONS(3001),
    [anon_sym_checked] = ACTIONS(3001),
    [anon_sym_BANG] = ACTIONS(3003),
    [anon_sym_TILDE] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3003),
    [anon_sym_DASH_DASH] = ACTIONS(3003),
    [anon_sym_true] = ACTIONS(3001),
    [anon_sym_false] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(3001),
    [anon_sym_DASH] = ACTIONS(3001),
    [anon_sym_STAR] = ACTIONS(3003),
    [anon_sym_CARET] = ACTIONS(3003),
    [anon_sym_AMP] = ACTIONS(3003),
    [anon_sym_this] = ACTIONS(3001),
    [anon_sym_scoped] = ACTIONS(3001),
    [anon_sym_base] = ACTIONS(3001),
    [anon_sym_var] = ACTIONS(3001),
    [sym_predefined_type] = ACTIONS(3001),
    [anon_sym_break] = ACTIONS(3001),
    [anon_sym_unchecked] = ACTIONS(3001),
    [anon_sym_continue] = ACTIONS(3001),
    [anon_sym_do] = ACTIONS(3001),
    [anon_sym_while] = ACTIONS(3001),
    [anon_sym_for] = ACTIONS(3001),
    [anon_sym_lock] = ACTIONS(3001),
    [anon_sym_yield] = ACTIONS(3001),
    [anon_sym_switch] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3001),
    [anon_sym_default] = ACTIONS(3001),
    [anon_sym_throw] = ACTIONS(3001),
    [anon_sym_try] = ACTIONS(3001),
    [anon_sym_when] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3001),
    [anon_sym_foreach] = ACTIONS(3001),
    [anon_sym_goto] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(3001),
    [anon_sym_else] = ACTIONS(3001),
    [anon_sym_DOT_DOT] = ACTIONS(3003),
    [anon_sym_from] = ACTIONS(3001),
    [anon_sym_into] = ACTIONS(3001),
    [anon_sym_join] = ACTIONS(3001),
    [anon_sym_on] = ACTIONS(3001),
    [anon_sym_equals] = ACTIONS(3001),
    [anon_sym_let] = ACTIONS(3001),
    [anon_sym_orderby] = ACTIONS(3001),
    [anon_sym_ascending] = ACTIONS(3001),
    [anon_sym_descending] = ACTIONS(3001),
    [anon_sym_group] = ACTIONS(3001),
    [anon_sym_by] = ACTIONS(3001),
    [anon_sym_select] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3003),
    [anon_sym_stackalloc] = ACTIONS(3001),
    [anon_sym_sizeof] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3001),
    [anon_sym___makeref] = ACTIONS(3001),
    [anon_sym___reftype] = ACTIONS(3001),
    [anon_sym___refvalue] = ACTIONS(3001),
    [sym_null_literal] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_integer_literal] = ACTIONS(3001),
    [sym_real_literal] = ACTIONS(3003),
    [sym_verbatim_string_literal] = ACTIONS(3003),
    [aux_sym_preproc_if_token1] = ACTIONS(3003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3003),
    [sym_interpolation_verbatim_start] = ACTIONS(3003),
    [sym_interpolation_raw_start] = ACTIONS(3003),
    [sym_raw_string_start] = ACTIONS(3003),
  },
  [2660] = {
    [sym_preproc_region] = STATE(2660),
    [sym_preproc_endregion] = STATE(2660),
    [sym_preproc_line] = STATE(2660),
    [sym_preproc_pragma] = STATE(2660),
    [sym_preproc_nullable] = STATE(2660),
    [sym_preproc_error] = STATE(2660),
    [sym_preproc_define] = STATE(2660),
    [sym_preproc_undef] = STATE(2660),
    [sym__identifier_token] = ACTIONS(3265),
    [anon_sym_extern] = ACTIONS(3265),
    [anon_sym_alias] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3267),
    [anon_sym_global] = ACTIONS(3265),
    [anon_sym_using] = ACTIONS(3265),
    [anon_sym_unsafe] = ACTIONS(3265),
    [anon_sym_static] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3267),
    [anon_sym_LPAREN] = ACTIONS(3267),
    [anon_sym_return] = ACTIONS(3265),
    [anon_sym_ref] = ACTIONS(3265),
    [anon_sym_LBRACE] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3267),
    [anon_sym_delegate] = ACTIONS(3265),
    [anon_sym_abstract] = ACTIONS(3265),
    [anon_sym_async] = ACTIONS(3265),
    [anon_sym_const] = ACTIONS(3265),
    [anon_sym_file] = ACTIONS(3265),
    [anon_sym_fixed] = ACTIONS(3265),
    [anon_sym_internal] = ACTIONS(3265),
    [anon_sym_new] = ACTIONS(3265),
    [anon_sym_override] = ACTIONS(3265),
    [anon_sym_partial] = ACTIONS(3265),
    [anon_sym_private] = ACTIONS(3265),
    [anon_sym_protected] = ACTIONS(3265),
    [anon_sym_public] = ACTIONS(3265),
    [anon_sym_readonly] = ACTIONS(3265),
    [anon_sym_required] = ACTIONS(3265),
    [anon_sym_sealed] = ACTIONS(3265),
    [anon_sym_virtual] = ACTIONS(3265),
    [anon_sym_volatile] = ACTIONS(3265),
    [anon_sym_where] = ACTIONS(3265),
    [anon_sym_notnull] = ACTIONS(3265),
    [anon_sym_unmanaged] = ACTIONS(3265),
    [anon_sym_checked] = ACTIONS(3265),
    [anon_sym_BANG] = ACTIONS(3267),
    [anon_sym_TILDE] = ACTIONS(3267),
    [anon_sym_PLUS_PLUS] = ACTIONS(3267),
    [anon_sym_DASH_DASH] = ACTIONS(3267),
    [anon_sym_true] = ACTIONS(3265),
    [anon_sym_false] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_STAR] = ACTIONS(3267),
    [anon_sym_CARET] = ACTIONS(3267),
    [anon_sym_AMP] = ACTIONS(3267),
    [anon_sym_this] = ACTIONS(3265),
    [anon_sym_scoped] = ACTIONS(3265),
    [anon_sym_base] = ACTIONS(3265),
    [anon_sym_var] = ACTIONS(3265),
    [sym_predefined_type] = ACTIONS(3265),
    [anon_sym_break] = ACTIONS(3265),
    [anon_sym_unchecked] = ACTIONS(3265),
    [anon_sym_continue] = ACTIONS(3265),
    [anon_sym_do] = ACTIONS(3265),
    [anon_sym_while] = ACTIONS(3265),
    [anon_sym_for] = ACTIONS(3265),
    [anon_sym_lock] = ACTIONS(3265),
    [anon_sym_yield] = ACTIONS(3265),
    [anon_sym_switch] = ACTIONS(3265),
    [anon_sym_case] = ACTIONS(3265),
    [anon_sym_default] = ACTIONS(3265),
    [anon_sym_throw] = ACTIONS(3265),
    [anon_sym_try] = ACTIONS(3265),
    [anon_sym_when] = ACTIONS(3265),
    [anon_sym_await] = ACTIONS(3265),
    [anon_sym_foreach] = ACTIONS(3265),
    [anon_sym_goto] = ACTIONS(3265),
    [anon_sym_if] = ACTIONS(3265),
    [anon_sym_else] = ACTIONS(3265),
    [anon_sym_DOT_DOT] = ACTIONS(3267),
    [anon_sym_from] = ACTIONS(3265),
    [anon_sym_into] = ACTIONS(3265),
    [anon_sym_join] = ACTIONS(3265),
    [anon_sym_on] = ACTIONS(3265),
    [anon_sym_equals] = ACTIONS(3265),
    [anon_sym_let] = ACTIONS(3265),
    [anon_sym_orderby] = ACTIONS(3265),
    [anon_sym_ascending] = ACTIONS(3265),
    [anon_sym_descending] = ACTIONS(3265),
    [anon_sym_group] = ACTIONS(3265),
    [anon_sym_by] = ACTIONS(3265),
    [anon_sym_select] = ACTIONS(3265),
    [anon_sym_DQUOTE] = ACTIONS(3267),
    [anon_sym_stackalloc] = ACTIONS(3265),
    [anon_sym_sizeof] = ACTIONS(3265),
    [anon_sym_typeof] = ACTIONS(3265),
    [anon_sym___makeref] = ACTIONS(3265),
    [anon_sym___reftype] = ACTIONS(3265),
    [anon_sym___refvalue] = ACTIONS(3265),
    [sym_null_literal] = ACTIONS(3265),
    [anon_sym_SQUOTE] = ACTIONS(3267),
    [sym_integer_literal] = ACTIONS(3265),
    [sym_real_literal] = ACTIONS(3267),
    [sym_verbatim_string_literal] = ACTIONS(3267),
    [aux_sym_preproc_if_token1] = ACTIONS(3267),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3267),
    [sym_interpolation_verbatim_start] = ACTIONS(3267),
    [sym_interpolation_raw_start] = ACTIONS(3267),
    [sym_raw_string_start] = ACTIONS(3267),
  },
  [2661] = {
    [sym_preproc_region] = STATE(2661),
    [sym_preproc_endregion] = STATE(2661),
    [sym_preproc_line] = STATE(2661),
    [sym_preproc_pragma] = STATE(2661),
    [sym_preproc_nullable] = STATE(2661),
    [sym_preproc_error] = STATE(2661),
    [sym_preproc_define] = STATE(2661),
    [sym_preproc_undef] = STATE(2661),
    [sym__identifier_token] = ACTIONS(3261),
    [anon_sym_extern] = ACTIONS(3261),
    [anon_sym_alias] = ACTIONS(3261),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_global] = ACTIONS(3261),
    [anon_sym_using] = ACTIONS(3261),
    [anon_sym_unsafe] = ACTIONS(3261),
    [anon_sym_static] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_return] = ACTIONS(3261),
    [anon_sym_ref] = ACTIONS(3261),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_delegate] = ACTIONS(3261),
    [anon_sym_abstract] = ACTIONS(3261),
    [anon_sym_async] = ACTIONS(3261),
    [anon_sym_const] = ACTIONS(3261),
    [anon_sym_file] = ACTIONS(3261),
    [anon_sym_fixed] = ACTIONS(3261),
    [anon_sym_internal] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_override] = ACTIONS(3261),
    [anon_sym_partial] = ACTIONS(3261),
    [anon_sym_private] = ACTIONS(3261),
    [anon_sym_protected] = ACTIONS(3261),
    [anon_sym_public] = ACTIONS(3261),
    [anon_sym_readonly] = ACTIONS(3261),
    [anon_sym_required] = ACTIONS(3261),
    [anon_sym_sealed] = ACTIONS(3261),
    [anon_sym_virtual] = ACTIONS(3261),
    [anon_sym_volatile] = ACTIONS(3261),
    [anon_sym_where] = ACTIONS(3261),
    [anon_sym_notnull] = ACTIONS(3261),
    [anon_sym_unmanaged] = ACTIONS(3261),
    [anon_sym_checked] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [anon_sym_true] = ACTIONS(3261),
    [anon_sym_false] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_STAR] = ACTIONS(3263),
    [anon_sym_CARET] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3263),
    [anon_sym_this] = ACTIONS(3261),
    [anon_sym_scoped] = ACTIONS(3261),
    [anon_sym_base] = ACTIONS(3261),
    [anon_sym_var] = ACTIONS(3261),
    [sym_predefined_type] = ACTIONS(3261),
    [anon_sym_break] = ACTIONS(3261),
    [anon_sym_unchecked] = ACTIONS(3261),
    [anon_sym_continue] = ACTIONS(3261),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_while] = ACTIONS(3261),
    [anon_sym_for] = ACTIONS(3261),
    [anon_sym_lock] = ACTIONS(3261),
    [anon_sym_yield] = ACTIONS(3261),
    [anon_sym_switch] = ACTIONS(3261),
    [anon_sym_case] = ACTIONS(3261),
    [anon_sym_default] = ACTIONS(3261),
    [anon_sym_throw] = ACTIONS(3261),
    [anon_sym_try] = ACTIONS(3261),
    [anon_sym_when] = ACTIONS(3261),
    [anon_sym_await] = ACTIONS(3261),
    [anon_sym_foreach] = ACTIONS(3261),
    [anon_sym_goto] = ACTIONS(3261),
    [anon_sym_if] = ACTIONS(3261),
    [anon_sym_else] = ACTIONS(3261),
    [anon_sym_DOT_DOT] = ACTIONS(3263),
    [anon_sym_from] = ACTIONS(3261),
    [anon_sym_into] = ACTIONS(3261),
    [anon_sym_join] = ACTIONS(3261),
    [anon_sym_on] = ACTIONS(3261),
    [anon_sym_equals] = ACTIONS(3261),
    [anon_sym_let] = ACTIONS(3261),
    [anon_sym_orderby] = ACTIONS(3261),
    [anon_sym_ascending] = ACTIONS(3261),
    [anon_sym_descending] = ACTIONS(3261),
    [anon_sym_group] = ACTIONS(3261),
    [anon_sym_by] = ACTIONS(3261),
    [anon_sym_select] = ACTIONS(3261),
    [anon_sym_DQUOTE] = ACTIONS(3263),
    [anon_sym_stackalloc] = ACTIONS(3261),
    [anon_sym_sizeof] = ACTIONS(3261),
    [anon_sym_typeof] = ACTIONS(3261),
    [anon_sym___makeref] = ACTIONS(3261),
    [anon_sym___reftype] = ACTIONS(3261),
    [anon_sym___refvalue] = ACTIONS(3261),
    [sym_null_literal] = ACTIONS(3261),
    [anon_sym_SQUOTE] = ACTIONS(3263),
    [sym_integer_literal] = ACTIONS(3261),
    [sym_real_literal] = ACTIONS(3263),
    [sym_verbatim_string_literal] = ACTIONS(3263),
    [aux_sym_preproc_if_token1] = ACTIONS(3263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3263),
    [sym_interpolation_verbatim_start] = ACTIONS(3263),
    [sym_interpolation_raw_start] = ACTIONS(3263),
    [sym_raw_string_start] = ACTIONS(3263),
  },
  [2662] = {
    [sym_preproc_region] = STATE(2662),
    [sym_preproc_endregion] = STATE(2662),
    [sym_preproc_line] = STATE(2662),
    [sym_preproc_pragma] = STATE(2662),
    [sym_preproc_nullable] = STATE(2662),
    [sym_preproc_error] = STATE(2662),
    [sym_preproc_define] = STATE(2662),
    [sym_preproc_undef] = STATE(2662),
    [sym__identifier_token] = ACTIONS(3055),
    [anon_sym_extern] = ACTIONS(3055),
    [anon_sym_alias] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_global] = ACTIONS(3055),
    [anon_sym_using] = ACTIONS(3055),
    [anon_sym_unsafe] = ACTIONS(3055),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_ref] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_delegate] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_file] = ACTIONS(3055),
    [anon_sym_fixed] = ACTIONS(3055),
    [anon_sym_internal] = ACTIONS(3055),
    [anon_sym_new] = ACTIONS(3055),
    [anon_sym_override] = ACTIONS(3055),
    [anon_sym_partial] = ACTIONS(3055),
    [anon_sym_private] = ACTIONS(3055),
    [anon_sym_protected] = ACTIONS(3055),
    [anon_sym_public] = ACTIONS(3055),
    [anon_sym_readonly] = ACTIONS(3055),
    [anon_sym_required] = ACTIONS(3055),
    [anon_sym_sealed] = ACTIONS(3055),
    [anon_sym_virtual] = ACTIONS(3055),
    [anon_sym_volatile] = ACTIONS(3055),
    [anon_sym_where] = ACTIONS(3055),
    [anon_sym_notnull] = ACTIONS(3055),
    [anon_sym_unmanaged] = ACTIONS(3055),
    [anon_sym_checked] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3057),
    [anon_sym_true] = ACTIONS(3055),
    [anon_sym_false] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_this] = ACTIONS(3055),
    [anon_sym_scoped] = ACTIONS(3055),
    [anon_sym_base] = ACTIONS(3055),
    [anon_sym_var] = ACTIONS(3055),
    [sym_predefined_type] = ACTIONS(3055),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_unchecked] = ACTIONS(3055),
    [anon_sym_continue] = ACTIONS(3055),
    [anon_sym_do] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_lock] = ACTIONS(3055),
    [anon_sym_yield] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(3055),
    [anon_sym_case] = ACTIONS(3055),
    [anon_sym_default] = ACTIONS(3055),
    [anon_sym_throw] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_when] = ACTIONS(3055),
    [anon_sym_await] = ACTIONS(3055),
    [anon_sym_foreach] = ACTIONS(3055),
    [anon_sym_goto] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_from] = ACTIONS(3055),
    [anon_sym_into] = ACTIONS(3055),
    [anon_sym_join] = ACTIONS(3055),
    [anon_sym_on] = ACTIONS(3055),
    [anon_sym_equals] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_orderby] = ACTIONS(3055),
    [anon_sym_ascending] = ACTIONS(3055),
    [anon_sym_descending] = ACTIONS(3055),
    [anon_sym_group] = ACTIONS(3055),
    [anon_sym_by] = ACTIONS(3055),
    [anon_sym_select] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_stackalloc] = ACTIONS(3055),
    [anon_sym_sizeof] = ACTIONS(3055),
    [anon_sym_typeof] = ACTIONS(3055),
    [anon_sym___makeref] = ACTIONS(3055),
    [anon_sym___reftype] = ACTIONS(3055),
    [anon_sym___refvalue] = ACTIONS(3055),
    [sym_null_literal] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_integer_literal] = ACTIONS(3055),
    [sym_real_literal] = ACTIONS(3057),
    [sym_verbatim_string_literal] = ACTIONS(3057),
    [aux_sym_preproc_if_token1] = ACTIONS(3057),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3057),
    [sym_interpolation_verbatim_start] = ACTIONS(3057),
    [sym_interpolation_raw_start] = ACTIONS(3057),
    [sym_raw_string_start] = ACTIONS(3057),
  },
  [2663] = {
    [sym_preproc_region] = STATE(2663),
    [sym_preproc_endregion] = STATE(2663),
    [sym_preproc_line] = STATE(2663),
    [sym_preproc_pragma] = STATE(2663),
    [sym_preproc_nullable] = STATE(2663),
    [sym_preproc_error] = STATE(2663),
    [sym_preproc_define] = STATE(2663),
    [sym_preproc_undef] = STATE(2663),
    [sym__identifier_token] = ACTIONS(3257),
    [anon_sym_extern] = ACTIONS(3257),
    [anon_sym_alias] = ACTIONS(3257),
    [anon_sym_SEMI] = ACTIONS(3259),
    [anon_sym_global] = ACTIONS(3257),
    [anon_sym_using] = ACTIONS(3257),
    [anon_sym_unsafe] = ACTIONS(3257),
    [anon_sym_static] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LPAREN] = ACTIONS(3259),
    [anon_sym_return] = ACTIONS(3257),
    [anon_sym_ref] = ACTIONS(3257),
    [anon_sym_LBRACE] = ACTIONS(3259),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_delegate] = ACTIONS(3257),
    [anon_sym_abstract] = ACTIONS(3257),
    [anon_sym_async] = ACTIONS(3257),
    [anon_sym_const] = ACTIONS(3257),
    [anon_sym_file] = ACTIONS(3257),
    [anon_sym_fixed] = ACTIONS(3257),
    [anon_sym_internal] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(3257),
    [anon_sym_override] = ACTIONS(3257),
    [anon_sym_partial] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_readonly] = ACTIONS(3257),
    [anon_sym_required] = ACTIONS(3257),
    [anon_sym_sealed] = ACTIONS(3257),
    [anon_sym_virtual] = ACTIONS(3257),
    [anon_sym_volatile] = ACTIONS(3257),
    [anon_sym_where] = ACTIONS(3257),
    [anon_sym_notnull] = ACTIONS(3257),
    [anon_sym_unmanaged] = ACTIONS(3257),
    [anon_sym_checked] = ACTIONS(3257),
    [anon_sym_BANG] = ACTIONS(3259),
    [anon_sym_TILDE] = ACTIONS(3259),
    [anon_sym_PLUS_PLUS] = ACTIONS(3259),
    [anon_sym_DASH_DASH] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3257),
    [anon_sym_false] = ACTIONS(3257),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3259),
    [anon_sym_CARET] = ACTIONS(3259),
    [anon_sym_AMP] = ACTIONS(3259),
    [anon_sym_this] = ACTIONS(3257),
    [anon_sym_scoped] = ACTIONS(3257),
    [anon_sym_base] = ACTIONS(3257),
    [anon_sym_var] = ACTIONS(3257),
    [sym_predefined_type] = ACTIONS(3257),
    [anon_sym_break] = ACTIONS(3257),
    [anon_sym_unchecked] = ACTIONS(3257),
    [anon_sym_continue] = ACTIONS(3257),
    [anon_sym_do] = ACTIONS(3257),
    [anon_sym_while] = ACTIONS(3257),
    [anon_sym_for] = ACTIONS(3257),
    [anon_sym_lock] = ACTIONS(3257),
    [anon_sym_yield] = ACTIONS(3257),
    [anon_sym_switch] = ACTIONS(3257),
    [anon_sym_case] = ACTIONS(3257),
    [anon_sym_default] = ACTIONS(3257),
    [anon_sym_throw] = ACTIONS(3257),
    [anon_sym_try] = ACTIONS(3257),
    [anon_sym_when] = ACTIONS(3257),
    [anon_sym_await] = ACTIONS(3257),
    [anon_sym_foreach] = ACTIONS(3257),
    [anon_sym_goto] = ACTIONS(3257),
    [anon_sym_if] = ACTIONS(3257),
    [anon_sym_else] = ACTIONS(3257),
    [anon_sym_DOT_DOT] = ACTIONS(3259),
    [anon_sym_from] = ACTIONS(3257),
    [anon_sym_into] = ACTIONS(3257),
    [anon_sym_join] = ACTIONS(3257),
    [anon_sym_on] = ACTIONS(3257),
    [anon_sym_equals] = ACTIONS(3257),
    [anon_sym_let] = ACTIONS(3257),
    [anon_sym_orderby] = ACTIONS(3257),
    [anon_sym_ascending] = ACTIONS(3257),
    [anon_sym_descending] = ACTIONS(3257),
    [anon_sym_group] = ACTIONS(3257),
    [anon_sym_by] = ACTIONS(3257),
    [anon_sym_select] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(3259),
    [anon_sym_stackalloc] = ACTIONS(3257),
    [anon_sym_sizeof] = ACTIONS(3257),
    [anon_sym_typeof] = ACTIONS(3257),
    [anon_sym___makeref] = ACTIONS(3257),
    [anon_sym___reftype] = ACTIONS(3257),
    [anon_sym___refvalue] = ACTIONS(3257),
    [sym_null_literal] = ACTIONS(3257),
    [anon_sym_SQUOTE] = ACTIONS(3259),
    [sym_integer_literal] = ACTIONS(3257),
    [sym_real_literal] = ACTIONS(3259),
    [sym_verbatim_string_literal] = ACTIONS(3259),
    [aux_sym_preproc_if_token1] = ACTIONS(3259),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3259),
    [sym_interpolation_verbatim_start] = ACTIONS(3259),
    [sym_interpolation_raw_start] = ACTIONS(3259),
    [sym_raw_string_start] = ACTIONS(3259),
  },
  [2664] = {
    [sym_preproc_region] = STATE(2664),
    [sym_preproc_endregion] = STATE(2664),
    [sym_preproc_line] = STATE(2664),
    [sym_preproc_pragma] = STATE(2664),
    [sym_preproc_nullable] = STATE(2664),
    [sym_preproc_error] = STATE(2664),
    [sym_preproc_define] = STATE(2664),
    [sym_preproc_undef] = STATE(2664),
    [sym__identifier_token] = ACTIONS(3313),
    [anon_sym_extern] = ACTIONS(3313),
    [anon_sym_alias] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3315),
    [anon_sym_global] = ACTIONS(3313),
    [anon_sym_using] = ACTIONS(3313),
    [anon_sym_unsafe] = ACTIONS(3313),
    [anon_sym_static] = ACTIONS(3313),
    [anon_sym_LBRACK] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(3315),
    [anon_sym_return] = ACTIONS(3313),
    [anon_sym_ref] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(3315),
    [anon_sym_RBRACE] = ACTIONS(3315),
    [anon_sym_delegate] = ACTIONS(3313),
    [anon_sym_abstract] = ACTIONS(3313),
    [anon_sym_async] = ACTIONS(3313),
    [anon_sym_const] = ACTIONS(3313),
    [anon_sym_file] = ACTIONS(3313),
    [anon_sym_fixed] = ACTIONS(3313),
    [anon_sym_internal] = ACTIONS(3313),
    [anon_sym_new] = ACTIONS(3313),
    [anon_sym_override] = ACTIONS(3313),
    [anon_sym_partial] = ACTIONS(3313),
    [anon_sym_private] = ACTIONS(3313),
    [anon_sym_protected] = ACTIONS(3313),
    [anon_sym_public] = ACTIONS(3313),
    [anon_sym_readonly] = ACTIONS(3313),
    [anon_sym_required] = ACTIONS(3313),
    [anon_sym_sealed] = ACTIONS(3313),
    [anon_sym_virtual] = ACTIONS(3313),
    [anon_sym_volatile] = ACTIONS(3313),
    [anon_sym_where] = ACTIONS(3313),
    [anon_sym_notnull] = ACTIONS(3313),
    [anon_sym_unmanaged] = ACTIONS(3313),
    [anon_sym_checked] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(3315),
    [anon_sym_TILDE] = ACTIONS(3315),
    [anon_sym_PLUS_PLUS] = ACTIONS(3315),
    [anon_sym_DASH_DASH] = ACTIONS(3315),
    [anon_sym_true] = ACTIONS(3313),
    [anon_sym_false] = ACTIONS(3313),
    [anon_sym_PLUS] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3313),
    [anon_sym_STAR] = ACTIONS(3315),
    [anon_sym_CARET] = ACTIONS(3315),
    [anon_sym_AMP] = ACTIONS(3315),
    [anon_sym_this] = ACTIONS(3313),
    [anon_sym_scoped] = ACTIONS(3313),
    [anon_sym_base] = ACTIONS(3313),
    [anon_sym_var] = ACTIONS(3313),
    [sym_predefined_type] = ACTIONS(3313),
    [anon_sym_break] = ACTIONS(3313),
    [anon_sym_unchecked] = ACTIONS(3313),
    [anon_sym_continue] = ACTIONS(3313),
    [anon_sym_do] = ACTIONS(3313),
    [anon_sym_while] = ACTIONS(3313),
    [anon_sym_for] = ACTIONS(3313),
    [anon_sym_lock] = ACTIONS(3313),
    [anon_sym_yield] = ACTIONS(3313),
    [anon_sym_switch] = ACTIONS(3313),
    [anon_sym_case] = ACTIONS(3313),
    [anon_sym_default] = ACTIONS(3313),
    [anon_sym_throw] = ACTIONS(3313),
    [anon_sym_try] = ACTIONS(3313),
    [anon_sym_when] = ACTIONS(3313),
    [anon_sym_await] = ACTIONS(3313),
    [anon_sym_foreach] = ACTIONS(3313),
    [anon_sym_goto] = ACTIONS(3313),
    [anon_sym_if] = ACTIONS(3313),
    [anon_sym_else] = ACTIONS(3313),
    [anon_sym_DOT_DOT] = ACTIONS(3315),
    [anon_sym_from] = ACTIONS(3313),
    [anon_sym_into] = ACTIONS(3313),
    [anon_sym_join] = ACTIONS(3313),
    [anon_sym_on] = ACTIONS(3313),
    [anon_sym_equals] = ACTIONS(3313),
    [anon_sym_let] = ACTIONS(3313),
    [anon_sym_orderby] = ACTIONS(3313),
    [anon_sym_ascending] = ACTIONS(3313),
    [anon_sym_descending] = ACTIONS(3313),
    [anon_sym_group] = ACTIONS(3313),
    [anon_sym_by] = ACTIONS(3313),
    [anon_sym_select] = ACTIONS(3313),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_stackalloc] = ACTIONS(3313),
    [anon_sym_sizeof] = ACTIONS(3313),
    [anon_sym_typeof] = ACTIONS(3313),
    [anon_sym___makeref] = ACTIONS(3313),
    [anon_sym___reftype] = ACTIONS(3313),
    [anon_sym___refvalue] = ACTIONS(3313),
    [sym_null_literal] = ACTIONS(3313),
    [anon_sym_SQUOTE] = ACTIONS(3315),
    [sym_integer_literal] = ACTIONS(3313),
    [sym_real_literal] = ACTIONS(3315),
    [sym_verbatim_string_literal] = ACTIONS(3315),
    [aux_sym_preproc_if_token1] = ACTIONS(3315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3315),
    [sym_interpolation_verbatim_start] = ACTIONS(3315),
    [sym_interpolation_raw_start] = ACTIONS(3315),
    [sym_raw_string_start] = ACTIONS(3315),
  },
  [2665] = {
    [sym_preproc_region] = STATE(2665),
    [sym_preproc_endregion] = STATE(2665),
    [sym_preproc_line] = STATE(2665),
    [sym_preproc_pragma] = STATE(2665),
    [sym_preproc_nullable] = STATE(2665),
    [sym_preproc_error] = STATE(2665),
    [sym_preproc_define] = STATE(2665),
    [sym_preproc_undef] = STATE(2665),
    [sym__identifier_token] = ACTIONS(3373),
    [anon_sym_extern] = ACTIONS(3373),
    [anon_sym_alias] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(3375),
    [anon_sym_global] = ACTIONS(3373),
    [anon_sym_using] = ACTIONS(3373),
    [anon_sym_unsafe] = ACTIONS(3373),
    [anon_sym_static] = ACTIONS(3373),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(3375),
    [anon_sym_return] = ACTIONS(3373),
    [anon_sym_ref] = ACTIONS(3373),
    [anon_sym_LBRACE] = ACTIONS(3375),
    [anon_sym_RBRACE] = ACTIONS(3375),
    [anon_sym_delegate] = ACTIONS(3373),
    [anon_sym_abstract] = ACTIONS(3373),
    [anon_sym_async] = ACTIONS(3373),
    [anon_sym_const] = ACTIONS(3373),
    [anon_sym_file] = ACTIONS(3373),
    [anon_sym_fixed] = ACTIONS(3373),
    [anon_sym_internal] = ACTIONS(3373),
    [anon_sym_new] = ACTIONS(3373),
    [anon_sym_override] = ACTIONS(3373),
    [anon_sym_partial] = ACTIONS(3373),
    [anon_sym_private] = ACTIONS(3373),
    [anon_sym_protected] = ACTIONS(3373),
    [anon_sym_public] = ACTIONS(3373),
    [anon_sym_readonly] = ACTIONS(3373),
    [anon_sym_required] = ACTIONS(3373),
    [anon_sym_sealed] = ACTIONS(3373),
    [anon_sym_virtual] = ACTIONS(3373),
    [anon_sym_volatile] = ACTIONS(3373),
    [anon_sym_where] = ACTIONS(3373),
    [anon_sym_notnull] = ACTIONS(3373),
    [anon_sym_unmanaged] = ACTIONS(3373),
    [anon_sym_checked] = ACTIONS(3373),
    [anon_sym_BANG] = ACTIONS(3375),
    [anon_sym_TILDE] = ACTIONS(3375),
    [anon_sym_PLUS_PLUS] = ACTIONS(3375),
    [anon_sym_DASH_DASH] = ACTIONS(3375),
    [anon_sym_true] = ACTIONS(3373),
    [anon_sym_false] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(3373),
    [anon_sym_DASH] = ACTIONS(3373),
    [anon_sym_STAR] = ACTIONS(3375),
    [anon_sym_CARET] = ACTIONS(3375),
    [anon_sym_AMP] = ACTIONS(3375),
    [anon_sym_this] = ACTIONS(3373),
    [anon_sym_scoped] = ACTIONS(3373),
    [anon_sym_base] = ACTIONS(3373),
    [anon_sym_var] = ACTIONS(3373),
    [sym_predefined_type] = ACTIONS(3373),
    [anon_sym_break] = ACTIONS(3373),
    [anon_sym_unchecked] = ACTIONS(3373),
    [anon_sym_continue] = ACTIONS(3373),
    [anon_sym_do] = ACTIONS(3373),
    [anon_sym_while] = ACTIONS(3373),
    [anon_sym_for] = ACTIONS(3373),
    [anon_sym_lock] = ACTIONS(3373),
    [anon_sym_yield] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(3373),
    [anon_sym_case] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3373),
    [anon_sym_throw] = ACTIONS(3373),
    [anon_sym_try] = ACTIONS(3373),
    [anon_sym_when] = ACTIONS(3373),
    [anon_sym_await] = ACTIONS(3373),
    [anon_sym_foreach] = ACTIONS(3373),
    [anon_sym_goto] = ACTIONS(3373),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_else] = ACTIONS(3373),
    [anon_sym_DOT_DOT] = ACTIONS(3375),
    [anon_sym_from] = ACTIONS(3373),
    [anon_sym_into] = ACTIONS(3373),
    [anon_sym_join] = ACTIONS(3373),
    [anon_sym_on] = ACTIONS(3373),
    [anon_sym_equals] = ACTIONS(3373),
    [anon_sym_let] = ACTIONS(3373),
    [anon_sym_orderby] = ACTIONS(3373),
    [anon_sym_ascending] = ACTIONS(3373),
    [anon_sym_descending] = ACTIONS(3373),
    [anon_sym_group] = ACTIONS(3373),
    [anon_sym_by] = ACTIONS(3373),
    [anon_sym_select] = ACTIONS(3373),
    [anon_sym_DQUOTE] = ACTIONS(3375),
    [anon_sym_stackalloc] = ACTIONS(3373),
    [anon_sym_sizeof] = ACTIONS(3373),
    [anon_sym_typeof] = ACTIONS(3373),
    [anon_sym___makeref] = ACTIONS(3373),
    [anon_sym___reftype] = ACTIONS(3373),
    [anon_sym___refvalue] = ACTIONS(3373),
    [sym_null_literal] = ACTIONS(3373),
    [anon_sym_SQUOTE] = ACTIONS(3375),
    [sym_integer_literal] = ACTIONS(3373),
    [sym_real_literal] = ACTIONS(3375),
    [sym_verbatim_string_literal] = ACTIONS(3375),
    [aux_sym_preproc_if_token1] = ACTIONS(3375),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3375),
    [sym_interpolation_verbatim_start] = ACTIONS(3375),
    [sym_interpolation_raw_start] = ACTIONS(3375),
    [sym_raw_string_start] = ACTIONS(3375),
  },
  [2666] = {
    [sym_preproc_region] = STATE(2666),
    [sym_preproc_endregion] = STATE(2666),
    [sym_preproc_line] = STATE(2666),
    [sym_preproc_pragma] = STATE(2666),
    [sym_preproc_nullable] = STATE(2666),
    [sym_preproc_error] = STATE(2666),
    [sym_preproc_define] = STATE(2666),
    [sym_preproc_undef] = STATE(2666),
    [sym__identifier_token] = ACTIONS(3245),
    [anon_sym_extern] = ACTIONS(3245),
    [anon_sym_alias] = ACTIONS(3245),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_global] = ACTIONS(3245),
    [anon_sym_using] = ACTIONS(3245),
    [anon_sym_unsafe] = ACTIONS(3245),
    [anon_sym_static] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_return] = ACTIONS(3245),
    [anon_sym_ref] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_delegate] = ACTIONS(3245),
    [anon_sym_abstract] = ACTIONS(3245),
    [anon_sym_async] = ACTIONS(3245),
    [anon_sym_const] = ACTIONS(3245),
    [anon_sym_file] = ACTIONS(3245),
    [anon_sym_fixed] = ACTIONS(3245),
    [anon_sym_internal] = ACTIONS(3245),
    [anon_sym_new] = ACTIONS(3245),
    [anon_sym_override] = ACTIONS(3245),
    [anon_sym_partial] = ACTIONS(3245),
    [anon_sym_private] = ACTIONS(3245),
    [anon_sym_protected] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3245),
    [anon_sym_readonly] = ACTIONS(3245),
    [anon_sym_required] = ACTIONS(3245),
    [anon_sym_sealed] = ACTIONS(3245),
    [anon_sym_virtual] = ACTIONS(3245),
    [anon_sym_volatile] = ACTIONS(3245),
    [anon_sym_where] = ACTIONS(3245),
    [anon_sym_notnull] = ACTIONS(3245),
    [anon_sym_unmanaged] = ACTIONS(3245),
    [anon_sym_checked] = ACTIONS(3245),
    [anon_sym_BANG] = ACTIONS(3247),
    [anon_sym_TILDE] = ACTIONS(3247),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [anon_sym_true] = ACTIONS(3245),
    [anon_sym_false] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_STAR] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3247),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_this] = ACTIONS(3245),
    [anon_sym_scoped] = ACTIONS(3245),
    [anon_sym_base] = ACTIONS(3245),
    [anon_sym_var] = ACTIONS(3245),
    [sym_predefined_type] = ACTIONS(3245),
    [anon_sym_break] = ACTIONS(3245),
    [anon_sym_unchecked] = ACTIONS(3245),
    [anon_sym_continue] = ACTIONS(3245),
    [anon_sym_do] = ACTIONS(3245),
    [anon_sym_while] = ACTIONS(3245),
    [anon_sym_for] = ACTIONS(3245),
    [anon_sym_lock] = ACTIONS(3245),
    [anon_sym_yield] = ACTIONS(3245),
    [anon_sym_switch] = ACTIONS(3245),
    [anon_sym_case] = ACTIONS(3245),
    [anon_sym_default] = ACTIONS(3245),
    [anon_sym_throw] = ACTIONS(3245),
    [anon_sym_try] = ACTIONS(3245),
    [anon_sym_when] = ACTIONS(3245),
    [anon_sym_await] = ACTIONS(3245),
    [anon_sym_foreach] = ACTIONS(3245),
    [anon_sym_goto] = ACTIONS(3245),
    [anon_sym_if] = ACTIONS(3245),
    [anon_sym_else] = ACTIONS(3245),
    [anon_sym_DOT_DOT] = ACTIONS(3247),
    [anon_sym_from] = ACTIONS(3245),
    [anon_sym_into] = ACTIONS(3245),
    [anon_sym_join] = ACTIONS(3245),
    [anon_sym_on] = ACTIONS(3245),
    [anon_sym_equals] = ACTIONS(3245),
    [anon_sym_let] = ACTIONS(3245),
    [anon_sym_orderby] = ACTIONS(3245),
    [anon_sym_ascending] = ACTIONS(3245),
    [anon_sym_descending] = ACTIONS(3245),
    [anon_sym_group] = ACTIONS(3245),
    [anon_sym_by] = ACTIONS(3245),
    [anon_sym_select] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3247),
    [anon_sym_stackalloc] = ACTIONS(3245),
    [anon_sym_sizeof] = ACTIONS(3245),
    [anon_sym_typeof] = ACTIONS(3245),
    [anon_sym___makeref] = ACTIONS(3245),
    [anon_sym___reftype] = ACTIONS(3245),
    [anon_sym___refvalue] = ACTIONS(3245),
    [sym_null_literal] = ACTIONS(3245),
    [anon_sym_SQUOTE] = ACTIONS(3247),
    [sym_integer_literal] = ACTIONS(3245),
    [sym_real_literal] = ACTIONS(3247),
    [sym_verbatim_string_literal] = ACTIONS(3247),
    [aux_sym_preproc_if_token1] = ACTIONS(3247),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3247),
    [sym_interpolation_verbatim_start] = ACTIONS(3247),
    [sym_interpolation_raw_start] = ACTIONS(3247),
    [sym_raw_string_start] = ACTIONS(3247),
  },
  [2667] = {
    [sym_preproc_region] = STATE(2667),
    [sym_preproc_endregion] = STATE(2667),
    [sym_preproc_line] = STATE(2667),
    [sym_preproc_pragma] = STATE(2667),
    [sym_preproc_nullable] = STATE(2667),
    [sym_preproc_error] = STATE(2667),
    [sym_preproc_define] = STATE(2667),
    [sym_preproc_undef] = STATE(2667),
    [sym__identifier_token] = ACTIONS(3237),
    [anon_sym_extern] = ACTIONS(3237),
    [anon_sym_alias] = ACTIONS(3237),
    [anon_sym_SEMI] = ACTIONS(3239),
    [anon_sym_global] = ACTIONS(3237),
    [anon_sym_using] = ACTIONS(3237),
    [anon_sym_unsafe] = ACTIONS(3237),
    [anon_sym_static] = ACTIONS(3237),
    [anon_sym_LBRACK] = ACTIONS(3239),
    [anon_sym_LPAREN] = ACTIONS(3239),
    [anon_sym_return] = ACTIONS(3237),
    [anon_sym_ref] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3239),
    [anon_sym_RBRACE] = ACTIONS(3239),
    [anon_sym_delegate] = ACTIONS(3237),
    [anon_sym_abstract] = ACTIONS(3237),
    [anon_sym_async] = ACTIONS(3237),
    [anon_sym_const] = ACTIONS(3237),
    [anon_sym_file] = ACTIONS(3237),
    [anon_sym_fixed] = ACTIONS(3237),
    [anon_sym_internal] = ACTIONS(3237),
    [anon_sym_new] = ACTIONS(3237),
    [anon_sym_override] = ACTIONS(3237),
    [anon_sym_partial] = ACTIONS(3237),
    [anon_sym_private] = ACTIONS(3237),
    [anon_sym_protected] = ACTIONS(3237),
    [anon_sym_public] = ACTIONS(3237),
    [anon_sym_readonly] = ACTIONS(3237),
    [anon_sym_required] = ACTIONS(3237),
    [anon_sym_sealed] = ACTIONS(3237),
    [anon_sym_virtual] = ACTIONS(3237),
    [anon_sym_volatile] = ACTIONS(3237),
    [anon_sym_where] = ACTIONS(3237),
    [anon_sym_notnull] = ACTIONS(3237),
    [anon_sym_unmanaged] = ACTIONS(3237),
    [anon_sym_checked] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(3239),
    [anon_sym_TILDE] = ACTIONS(3239),
    [anon_sym_PLUS_PLUS] = ACTIONS(3239),
    [anon_sym_DASH_DASH] = ACTIONS(3239),
    [anon_sym_true] = ACTIONS(3237),
    [anon_sym_false] = ACTIONS(3237),
    [anon_sym_PLUS] = ACTIONS(3237),
    [anon_sym_DASH] = ACTIONS(3237),
    [anon_sym_STAR] = ACTIONS(3239),
    [anon_sym_CARET] = ACTIONS(3239),
    [anon_sym_AMP] = ACTIONS(3239),
    [anon_sym_this] = ACTIONS(3237),
    [anon_sym_scoped] = ACTIONS(3237),
    [anon_sym_base] = ACTIONS(3237),
    [anon_sym_var] = ACTIONS(3237),
    [sym_predefined_type] = ACTIONS(3237),
    [anon_sym_break] = ACTIONS(3237),
    [anon_sym_unchecked] = ACTIONS(3237),
    [anon_sym_continue] = ACTIONS(3237),
    [anon_sym_do] = ACTIONS(3237),
    [anon_sym_while] = ACTIONS(3237),
    [anon_sym_for] = ACTIONS(3237),
    [anon_sym_lock] = ACTIONS(3237),
    [anon_sym_yield] = ACTIONS(3237),
    [anon_sym_switch] = ACTIONS(3237),
    [anon_sym_case] = ACTIONS(3237),
    [anon_sym_default] = ACTIONS(3237),
    [anon_sym_throw] = ACTIONS(3237),
    [anon_sym_try] = ACTIONS(3237),
    [anon_sym_when] = ACTIONS(3237),
    [anon_sym_await] = ACTIONS(3237),
    [anon_sym_foreach] = ACTIONS(3237),
    [anon_sym_goto] = ACTIONS(3237),
    [anon_sym_if] = ACTIONS(3237),
    [anon_sym_else] = ACTIONS(3237),
    [anon_sym_DOT_DOT] = ACTIONS(3239),
    [anon_sym_from] = ACTIONS(3237),
    [anon_sym_into] = ACTIONS(3237),
    [anon_sym_join] = ACTIONS(3237),
    [anon_sym_on] = ACTIONS(3237),
    [anon_sym_equals] = ACTIONS(3237),
    [anon_sym_let] = ACTIONS(3237),
    [anon_sym_orderby] = ACTIONS(3237),
    [anon_sym_ascending] = ACTIONS(3237),
    [anon_sym_descending] = ACTIONS(3237),
    [anon_sym_group] = ACTIONS(3237),
    [anon_sym_by] = ACTIONS(3237),
    [anon_sym_select] = ACTIONS(3237),
    [anon_sym_DQUOTE] = ACTIONS(3239),
    [anon_sym_stackalloc] = ACTIONS(3237),
    [anon_sym_sizeof] = ACTIONS(3237),
    [anon_sym_typeof] = ACTIONS(3237),
    [anon_sym___makeref] = ACTIONS(3237),
    [anon_sym___reftype] = ACTIONS(3237),
    [anon_sym___refvalue] = ACTIONS(3237),
    [sym_null_literal] = ACTIONS(3237),
    [anon_sym_SQUOTE] = ACTIONS(3239),
    [sym_integer_literal] = ACTIONS(3237),
    [sym_real_literal] = ACTIONS(3239),
    [sym_verbatim_string_literal] = ACTIONS(3239),
    [aux_sym_preproc_if_token1] = ACTIONS(3239),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3239),
    [sym_interpolation_verbatim_start] = ACTIONS(3239),
    [sym_interpolation_raw_start] = ACTIONS(3239),
    [sym_raw_string_start] = ACTIONS(3239),
  },
  [2668] = {
    [sym_preproc_region] = STATE(2668),
    [sym_preproc_endregion] = STATE(2668),
    [sym_preproc_line] = STATE(2668),
    [sym_preproc_pragma] = STATE(2668),
    [sym_preproc_nullable] = STATE(2668),
    [sym_preproc_error] = STATE(2668),
    [sym_preproc_define] = STATE(2668),
    [sym_preproc_undef] = STATE(2668),
    [sym__identifier_token] = ACTIONS(3321),
    [anon_sym_extern] = ACTIONS(3321),
    [anon_sym_alias] = ACTIONS(3321),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_using] = ACTIONS(3321),
    [anon_sym_unsafe] = ACTIONS(3321),
    [anon_sym_static] = ACTIONS(3321),
    [anon_sym_LBRACK] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(3323),
    [anon_sym_return] = ACTIONS(3321),
    [anon_sym_ref] = ACTIONS(3321),
    [anon_sym_LBRACE] = ACTIONS(3323),
    [anon_sym_RBRACE] = ACTIONS(3323),
    [anon_sym_delegate] = ACTIONS(3321),
    [anon_sym_abstract] = ACTIONS(3321),
    [anon_sym_async] = ACTIONS(3321),
    [anon_sym_const] = ACTIONS(3321),
    [anon_sym_file] = ACTIONS(3321),
    [anon_sym_fixed] = ACTIONS(3321),
    [anon_sym_internal] = ACTIONS(3321),
    [anon_sym_new] = ACTIONS(3321),
    [anon_sym_override] = ACTIONS(3321),
    [anon_sym_partial] = ACTIONS(3321),
    [anon_sym_private] = ACTIONS(3321),
    [anon_sym_protected] = ACTIONS(3321),
    [anon_sym_public] = ACTIONS(3321),
    [anon_sym_readonly] = ACTIONS(3321),
    [anon_sym_required] = ACTIONS(3321),
    [anon_sym_sealed] = ACTIONS(3321),
    [anon_sym_virtual] = ACTIONS(3321),
    [anon_sym_volatile] = ACTIONS(3321),
    [anon_sym_where] = ACTIONS(3321),
    [anon_sym_notnull] = ACTIONS(3321),
    [anon_sym_unmanaged] = ACTIONS(3321),
    [anon_sym_checked] = ACTIONS(3321),
    [anon_sym_BANG] = ACTIONS(3323),
    [anon_sym_TILDE] = ACTIONS(3323),
    [anon_sym_PLUS_PLUS] = ACTIONS(3323),
    [anon_sym_DASH_DASH] = ACTIONS(3323),
    [anon_sym_true] = ACTIONS(3321),
    [anon_sym_false] = ACTIONS(3321),
    [anon_sym_PLUS] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3321),
    [anon_sym_STAR] = ACTIONS(3323),
    [anon_sym_CARET] = ACTIONS(3323),
    [anon_sym_AMP] = ACTIONS(3323),
    [anon_sym_this] = ACTIONS(3321),
    [anon_sym_scoped] = ACTIONS(3321),
    [anon_sym_base] = ACTIONS(3321),
    [anon_sym_var] = ACTIONS(3321),
    [sym_predefined_type] = ACTIONS(3321),
    [anon_sym_break] = ACTIONS(3321),
    [anon_sym_unchecked] = ACTIONS(3321),
    [anon_sym_continue] = ACTIONS(3321),
    [anon_sym_do] = ACTIONS(3321),
    [anon_sym_while] = ACTIONS(3321),
    [anon_sym_for] = ACTIONS(3321),
    [anon_sym_lock] = ACTIONS(3321),
    [anon_sym_yield] = ACTIONS(3321),
    [anon_sym_switch] = ACTIONS(3321),
    [anon_sym_case] = ACTIONS(3321),
    [anon_sym_default] = ACTIONS(3321),
    [anon_sym_throw] = ACTIONS(3321),
    [anon_sym_try] = ACTIONS(3321),
    [anon_sym_when] = ACTIONS(3321),
    [anon_sym_await] = ACTIONS(3321),
    [anon_sym_foreach] = ACTIONS(3321),
    [anon_sym_goto] = ACTIONS(3321),
    [anon_sym_if] = ACTIONS(3321),
    [anon_sym_else] = ACTIONS(3321),
    [anon_sym_DOT_DOT] = ACTIONS(3323),
    [anon_sym_from] = ACTIONS(3321),
    [anon_sym_into] = ACTIONS(3321),
    [anon_sym_join] = ACTIONS(3321),
    [anon_sym_on] = ACTIONS(3321),
    [anon_sym_equals] = ACTIONS(3321),
    [anon_sym_let] = ACTIONS(3321),
    [anon_sym_orderby] = ACTIONS(3321),
    [anon_sym_ascending] = ACTIONS(3321),
    [anon_sym_descending] = ACTIONS(3321),
    [anon_sym_group] = ACTIONS(3321),
    [anon_sym_by] = ACTIONS(3321),
    [anon_sym_select] = ACTIONS(3321),
    [anon_sym_DQUOTE] = ACTIONS(3323),
    [anon_sym_stackalloc] = ACTIONS(3321),
    [anon_sym_sizeof] = ACTIONS(3321),
    [anon_sym_typeof] = ACTIONS(3321),
    [anon_sym___makeref] = ACTIONS(3321),
    [anon_sym___reftype] = ACTIONS(3321),
    [anon_sym___refvalue] = ACTIONS(3321),
    [sym_null_literal] = ACTIONS(3321),
    [anon_sym_SQUOTE] = ACTIONS(3323),
    [sym_integer_literal] = ACTIONS(3321),
    [sym_real_literal] = ACTIONS(3323),
    [sym_verbatim_string_literal] = ACTIONS(3323),
    [aux_sym_preproc_if_token1] = ACTIONS(3323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3323),
    [sym_interpolation_verbatim_start] = ACTIONS(3323),
    [sym_interpolation_raw_start] = ACTIONS(3323),
    [sym_raw_string_start] = ACTIONS(3323),
  },
  [2669] = {
    [sym_preproc_region] = STATE(2669),
    [sym_preproc_endregion] = STATE(2669),
    [sym_preproc_line] = STATE(2669),
    [sym_preproc_pragma] = STATE(2669),
    [sym_preproc_nullable] = STATE(2669),
    [sym_preproc_error] = STATE(2669),
    [sym_preproc_define] = STATE(2669),
    [sym_preproc_undef] = STATE(2669),
    [sym__identifier_token] = ACTIONS(3305),
    [anon_sym_extern] = ACTIONS(3305),
    [anon_sym_alias] = ACTIONS(3305),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_global] = ACTIONS(3305),
    [anon_sym_using] = ACTIONS(3305),
    [anon_sym_unsafe] = ACTIONS(3305),
    [anon_sym_static] = ACTIONS(3305),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_return] = ACTIONS(3305),
    [anon_sym_ref] = ACTIONS(3305),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_delegate] = ACTIONS(3305),
    [anon_sym_abstract] = ACTIONS(3305),
    [anon_sym_async] = ACTIONS(3305),
    [anon_sym_const] = ACTIONS(3305),
    [anon_sym_file] = ACTIONS(3305),
    [anon_sym_fixed] = ACTIONS(3305),
    [anon_sym_internal] = ACTIONS(3305),
    [anon_sym_new] = ACTIONS(3305),
    [anon_sym_override] = ACTIONS(3305),
    [anon_sym_partial] = ACTIONS(3305),
    [anon_sym_private] = ACTIONS(3305),
    [anon_sym_protected] = ACTIONS(3305),
    [anon_sym_public] = ACTIONS(3305),
    [anon_sym_readonly] = ACTIONS(3305),
    [anon_sym_required] = ACTIONS(3305),
    [anon_sym_sealed] = ACTIONS(3305),
    [anon_sym_virtual] = ACTIONS(3305),
    [anon_sym_volatile] = ACTIONS(3305),
    [anon_sym_where] = ACTIONS(3305),
    [anon_sym_notnull] = ACTIONS(3305),
    [anon_sym_unmanaged] = ACTIONS(3305),
    [anon_sym_checked] = ACTIONS(3305),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_true] = ACTIONS(3305),
    [anon_sym_false] = ACTIONS(3305),
    [anon_sym_PLUS] = ACTIONS(3305),
    [anon_sym_DASH] = ACTIONS(3305),
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_this] = ACTIONS(3305),
    [anon_sym_scoped] = ACTIONS(3305),
    [anon_sym_base] = ACTIONS(3305),
    [anon_sym_var] = ACTIONS(3305),
    [sym_predefined_type] = ACTIONS(3305),
    [anon_sym_break] = ACTIONS(3305),
    [anon_sym_unchecked] = ACTIONS(3305),
    [anon_sym_continue] = ACTIONS(3305),
    [anon_sym_do] = ACTIONS(3305),
    [anon_sym_while] = ACTIONS(3305),
    [anon_sym_for] = ACTIONS(3305),
    [anon_sym_lock] = ACTIONS(3305),
    [anon_sym_yield] = ACTIONS(3305),
    [anon_sym_switch] = ACTIONS(3305),
    [anon_sym_case] = ACTIONS(3305),
    [anon_sym_default] = ACTIONS(3305),
    [anon_sym_throw] = ACTIONS(3305),
    [anon_sym_try] = ACTIONS(3305),
    [anon_sym_when] = ACTIONS(3305),
    [anon_sym_await] = ACTIONS(3305),
    [anon_sym_foreach] = ACTIONS(3305),
    [anon_sym_goto] = ACTIONS(3305),
    [anon_sym_if] = ACTIONS(3305),
    [anon_sym_else] = ACTIONS(3305),
    [anon_sym_DOT_DOT] = ACTIONS(3307),
    [anon_sym_from] = ACTIONS(3305),
    [anon_sym_into] = ACTIONS(3305),
    [anon_sym_join] = ACTIONS(3305),
    [anon_sym_on] = ACTIONS(3305),
    [anon_sym_equals] = ACTIONS(3305),
    [anon_sym_let] = ACTIONS(3305),
    [anon_sym_orderby] = ACTIONS(3305),
    [anon_sym_ascending] = ACTIONS(3305),
    [anon_sym_descending] = ACTIONS(3305),
    [anon_sym_group] = ACTIONS(3305),
    [anon_sym_by] = ACTIONS(3305),
    [anon_sym_select] = ACTIONS(3305),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_stackalloc] = ACTIONS(3305),
    [anon_sym_sizeof] = ACTIONS(3305),
    [anon_sym_typeof] = ACTIONS(3305),
    [anon_sym___makeref] = ACTIONS(3305),
    [anon_sym___reftype] = ACTIONS(3305),
    [anon_sym___refvalue] = ACTIONS(3305),
    [sym_null_literal] = ACTIONS(3305),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [sym_integer_literal] = ACTIONS(3305),
    [sym_real_literal] = ACTIONS(3307),
    [sym_verbatim_string_literal] = ACTIONS(3307),
    [aux_sym_preproc_if_token1] = ACTIONS(3307),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3307),
    [sym_interpolation_verbatim_start] = ACTIONS(3307),
    [sym_interpolation_raw_start] = ACTIONS(3307),
    [sym_raw_string_start] = ACTIONS(3307),
  },
  [2670] = {
    [sym_preproc_region] = STATE(2670),
    [sym_preproc_endregion] = STATE(2670),
    [sym_preproc_line] = STATE(2670),
    [sym_preproc_pragma] = STATE(2670),
    [sym_preproc_nullable] = STATE(2670),
    [sym_preproc_error] = STATE(2670),
    [sym_preproc_define] = STATE(2670),
    [sym_preproc_undef] = STATE(2670),
    [sym__identifier_token] = ACTIONS(3285),
    [anon_sym_extern] = ACTIONS(3285),
    [anon_sym_alias] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3285),
    [anon_sym_using] = ACTIONS(3285),
    [anon_sym_unsafe] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_ref] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_delegate] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [anon_sym_file] = ACTIONS(3285),
    [anon_sym_fixed] = ACTIONS(3285),
    [anon_sym_internal] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_override] = ACTIONS(3285),
    [anon_sym_partial] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_readonly] = ACTIONS(3285),
    [anon_sym_required] = ACTIONS(3285),
    [anon_sym_sealed] = ACTIONS(3285),
    [anon_sym_virtual] = ACTIONS(3285),
    [anon_sym_volatile] = ACTIONS(3285),
    [anon_sym_where] = ACTIONS(3285),
    [anon_sym_notnull] = ACTIONS(3285),
    [anon_sym_unmanaged] = ACTIONS(3285),
    [anon_sym_checked] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_true] = ACTIONS(3285),
    [anon_sym_false] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3287),
    [anon_sym_CARET] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym_this] = ACTIONS(3285),
    [anon_sym_scoped] = ACTIONS(3285),
    [anon_sym_base] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [sym_predefined_type] = ACTIONS(3285),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_unchecked] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_lock] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_when] = ACTIONS(3285),
    [anon_sym_await] = ACTIONS(3285),
    [anon_sym_foreach] = ACTIONS(3285),
    [anon_sym_goto] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_DOT_DOT] = ACTIONS(3287),
    [anon_sym_from] = ACTIONS(3285),
    [anon_sym_into] = ACTIONS(3285),
    [anon_sym_join] = ACTIONS(3285),
    [anon_sym_on] = ACTIONS(3285),
    [anon_sym_equals] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_orderby] = ACTIONS(3285),
    [anon_sym_ascending] = ACTIONS(3285),
    [anon_sym_descending] = ACTIONS(3285),
    [anon_sym_group] = ACTIONS(3285),
    [anon_sym_by] = ACTIONS(3285),
    [anon_sym_select] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_stackalloc] = ACTIONS(3285),
    [anon_sym_sizeof] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym___makeref] = ACTIONS(3285),
    [anon_sym___reftype] = ACTIONS(3285),
    [anon_sym___refvalue] = ACTIONS(3285),
    [sym_null_literal] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [sym_integer_literal] = ACTIONS(3285),
    [sym_real_literal] = ACTIONS(3287),
    [sym_verbatim_string_literal] = ACTIONS(3287),
    [aux_sym_preproc_if_token1] = ACTIONS(3287),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3287),
    [sym_interpolation_verbatim_start] = ACTIONS(3287),
    [sym_interpolation_raw_start] = ACTIONS(3287),
    [sym_raw_string_start] = ACTIONS(3287),
  },
  [2671] = {
    [sym_preproc_region] = STATE(2671),
    [sym_preproc_endregion] = STATE(2671),
    [sym_preproc_line] = STATE(2671),
    [sym_preproc_pragma] = STATE(2671),
    [sym_preproc_nullable] = STATE(2671),
    [sym_preproc_error] = STATE(2671),
    [sym_preproc_define] = STATE(2671),
    [sym_preproc_undef] = STATE(2671),
    [sym__identifier_token] = ACTIONS(3393),
    [anon_sym_extern] = ACTIONS(3393),
    [anon_sym_alias] = ACTIONS(3393),
    [anon_sym_SEMI] = ACTIONS(3395),
    [anon_sym_global] = ACTIONS(3393),
    [anon_sym_using] = ACTIONS(3393),
    [anon_sym_unsafe] = ACTIONS(3393),
    [anon_sym_static] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_LPAREN] = ACTIONS(3395),
    [anon_sym_return] = ACTIONS(3393),
    [anon_sym_ref] = ACTIONS(3393),
    [anon_sym_LBRACE] = ACTIONS(3395),
    [anon_sym_RBRACE] = ACTIONS(3395),
    [anon_sym_delegate] = ACTIONS(3393),
    [anon_sym_abstract] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_const] = ACTIONS(3393),
    [anon_sym_file] = ACTIONS(3393),
    [anon_sym_fixed] = ACTIONS(3393),
    [anon_sym_internal] = ACTIONS(3393),
    [anon_sym_new] = ACTIONS(3393),
    [anon_sym_override] = ACTIONS(3393),
    [anon_sym_partial] = ACTIONS(3393),
    [anon_sym_private] = ACTIONS(3393),
    [anon_sym_protected] = ACTIONS(3393),
    [anon_sym_public] = ACTIONS(3393),
    [anon_sym_readonly] = ACTIONS(3393),
    [anon_sym_required] = ACTIONS(3393),
    [anon_sym_sealed] = ACTIONS(3393),
    [anon_sym_virtual] = ACTIONS(3393),
    [anon_sym_volatile] = ACTIONS(3393),
    [anon_sym_where] = ACTIONS(3393),
    [anon_sym_notnull] = ACTIONS(3393),
    [anon_sym_unmanaged] = ACTIONS(3393),
    [anon_sym_checked] = ACTIONS(3393),
    [anon_sym_BANG] = ACTIONS(3395),
    [anon_sym_TILDE] = ACTIONS(3395),
    [anon_sym_PLUS_PLUS] = ACTIONS(3395),
    [anon_sym_DASH_DASH] = ACTIONS(3395),
    [anon_sym_true] = ACTIONS(3393),
    [anon_sym_false] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_this] = ACTIONS(3393),
    [anon_sym_scoped] = ACTIONS(3393),
    [anon_sym_base] = ACTIONS(3393),
    [anon_sym_var] = ACTIONS(3393),
    [sym_predefined_type] = ACTIONS(3393),
    [anon_sym_break] = ACTIONS(3393),
    [anon_sym_unchecked] = ACTIONS(3393),
    [anon_sym_continue] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3393),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_lock] = ACTIONS(3393),
    [anon_sym_yield] = ACTIONS(3393),
    [anon_sym_switch] = ACTIONS(3393),
    [anon_sym_case] = ACTIONS(3393),
    [anon_sym_default] = ACTIONS(3393),
    [anon_sym_throw] = ACTIONS(3393),
    [anon_sym_try] = ACTIONS(3393),
    [anon_sym_when] = ACTIONS(3393),
    [anon_sym_await] = ACTIONS(3393),
    [anon_sym_foreach] = ACTIONS(3393),
    [anon_sym_goto] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_DOT_DOT] = ACTIONS(3395),
    [anon_sym_from] = ACTIONS(3393),
    [anon_sym_into] = ACTIONS(3393),
    [anon_sym_join] = ACTIONS(3393),
    [anon_sym_on] = ACTIONS(3393),
    [anon_sym_equals] = ACTIONS(3393),
    [anon_sym_let] = ACTIONS(3393),
    [anon_sym_orderby] = ACTIONS(3393),
    [anon_sym_ascending] = ACTIONS(3393),
    [anon_sym_descending] = ACTIONS(3393),
    [anon_sym_group] = ACTIONS(3393),
    [anon_sym_by] = ACTIONS(3393),
    [anon_sym_select] = ACTIONS(3393),
    [anon_sym_DQUOTE] = ACTIONS(3395),
    [anon_sym_stackalloc] = ACTIONS(3393),
    [anon_sym_sizeof] = ACTIONS(3393),
    [anon_sym_typeof] = ACTIONS(3393),
    [anon_sym___makeref] = ACTIONS(3393),
    [anon_sym___reftype] = ACTIONS(3393),
    [anon_sym___refvalue] = ACTIONS(3393),
    [sym_null_literal] = ACTIONS(3393),
    [anon_sym_SQUOTE] = ACTIONS(3395),
    [sym_integer_literal] = ACTIONS(3393),
    [sym_real_literal] = ACTIONS(3395),
    [sym_verbatim_string_literal] = ACTIONS(3395),
    [aux_sym_preproc_if_token1] = ACTIONS(3395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3395),
    [sym_interpolation_verbatim_start] = ACTIONS(3395),
    [sym_interpolation_raw_start] = ACTIONS(3395),
    [sym_raw_string_start] = ACTIONS(3395),
  },
  [2672] = {
    [sym_preproc_region] = STATE(2672),
    [sym_preproc_endregion] = STATE(2672),
    [sym_preproc_line] = STATE(2672),
    [sym_preproc_pragma] = STATE(2672),
    [sym_preproc_nullable] = STATE(2672),
    [sym_preproc_error] = STATE(2672),
    [sym_preproc_define] = STATE(2672),
    [sym_preproc_undef] = STATE(2672),
    [sym__identifier_token] = ACTIONS(3377),
    [anon_sym_extern] = ACTIONS(3377),
    [anon_sym_alias] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_global] = ACTIONS(3377),
    [anon_sym_using] = ACTIONS(3377),
    [anon_sym_unsafe] = ACTIONS(3377),
    [anon_sym_static] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_ref] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_delegate] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [anon_sym_file] = ACTIONS(3377),
    [anon_sym_fixed] = ACTIONS(3377),
    [anon_sym_internal] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [anon_sym_override] = ACTIONS(3377),
    [anon_sym_partial] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_readonly] = ACTIONS(3377),
    [anon_sym_required] = ACTIONS(3377),
    [anon_sym_sealed] = ACTIONS(3377),
    [anon_sym_virtual] = ACTIONS(3377),
    [anon_sym_volatile] = ACTIONS(3377),
    [anon_sym_where] = ACTIONS(3377),
    [anon_sym_notnull] = ACTIONS(3377),
    [anon_sym_unmanaged] = ACTIONS(3377),
    [anon_sym_checked] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_true] = ACTIONS(3377),
    [anon_sym_false] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_STAR] = ACTIONS(3379),
    [anon_sym_CARET] = ACTIONS(3379),
    [anon_sym_AMP] = ACTIONS(3379),
    [anon_sym_this] = ACTIONS(3377),
    [anon_sym_scoped] = ACTIONS(3377),
    [anon_sym_base] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [sym_predefined_type] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_unchecked] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_lock] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_when] = ACTIONS(3377),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_foreach] = ACTIONS(3377),
    [anon_sym_goto] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_from] = ACTIONS(3377),
    [anon_sym_into] = ACTIONS(3377),
    [anon_sym_join] = ACTIONS(3377),
    [anon_sym_on] = ACTIONS(3377),
    [anon_sym_equals] = ACTIONS(3377),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_orderby] = ACTIONS(3377),
    [anon_sym_ascending] = ACTIONS(3377),
    [anon_sym_descending] = ACTIONS(3377),
    [anon_sym_group] = ACTIONS(3377),
    [anon_sym_by] = ACTIONS(3377),
    [anon_sym_select] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_stackalloc] = ACTIONS(3377),
    [anon_sym_sizeof] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym___makeref] = ACTIONS(3377),
    [anon_sym___reftype] = ACTIONS(3377),
    [anon_sym___refvalue] = ACTIONS(3377),
    [sym_null_literal] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [sym_integer_literal] = ACTIONS(3377),
    [sym_real_literal] = ACTIONS(3379),
    [sym_verbatim_string_literal] = ACTIONS(3379),
    [aux_sym_preproc_if_token1] = ACTIONS(3379),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3379),
    [sym_interpolation_verbatim_start] = ACTIONS(3379),
    [sym_interpolation_raw_start] = ACTIONS(3379),
    [sym_raw_string_start] = ACTIONS(3379),
  },
  [2673] = {
    [sym_preproc_region] = STATE(2673),
    [sym_preproc_endregion] = STATE(2673),
    [sym_preproc_line] = STATE(2673),
    [sym_preproc_pragma] = STATE(2673),
    [sym_preproc_nullable] = STATE(2673),
    [sym_preproc_error] = STATE(2673),
    [sym_preproc_define] = STATE(2673),
    [sym_preproc_undef] = STATE(2673),
    [sym__identifier_token] = ACTIONS(3233),
    [anon_sym_extern] = ACTIONS(3233),
    [anon_sym_alias] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(3235),
    [anon_sym_global] = ACTIONS(3233),
    [anon_sym_using] = ACTIONS(3233),
    [anon_sym_unsafe] = ACTIONS(3233),
    [anon_sym_static] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_LPAREN] = ACTIONS(3235),
    [anon_sym_return] = ACTIONS(3233),
    [anon_sym_ref] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3235),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_delegate] = ACTIONS(3233),
    [anon_sym_abstract] = ACTIONS(3233),
    [anon_sym_async] = ACTIONS(3233),
    [anon_sym_const] = ACTIONS(3233),
    [anon_sym_file] = ACTIONS(3233),
    [anon_sym_fixed] = ACTIONS(3233),
    [anon_sym_internal] = ACTIONS(3233),
    [anon_sym_new] = ACTIONS(3233),
    [anon_sym_override] = ACTIONS(3233),
    [anon_sym_partial] = ACTIONS(3233),
    [anon_sym_private] = ACTIONS(3233),
    [anon_sym_protected] = ACTIONS(3233),
    [anon_sym_public] = ACTIONS(3233),
    [anon_sym_readonly] = ACTIONS(3233),
    [anon_sym_required] = ACTIONS(3233),
    [anon_sym_sealed] = ACTIONS(3233),
    [anon_sym_virtual] = ACTIONS(3233),
    [anon_sym_volatile] = ACTIONS(3233),
    [anon_sym_where] = ACTIONS(3233),
    [anon_sym_notnull] = ACTIONS(3233),
    [anon_sym_unmanaged] = ACTIONS(3233),
    [anon_sym_checked] = ACTIONS(3233),
    [anon_sym_BANG] = ACTIONS(3235),
    [anon_sym_TILDE] = ACTIONS(3235),
    [anon_sym_PLUS_PLUS] = ACTIONS(3235),
    [anon_sym_DASH_DASH] = ACTIONS(3235),
    [anon_sym_true] = ACTIONS(3233),
    [anon_sym_false] = ACTIONS(3233),
    [anon_sym_PLUS] = ACTIONS(3233),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_STAR] = ACTIONS(3235),
    [anon_sym_CARET] = ACTIONS(3235),
    [anon_sym_AMP] = ACTIONS(3235),
    [anon_sym_this] = ACTIONS(3233),
    [anon_sym_scoped] = ACTIONS(3233),
    [anon_sym_base] = ACTIONS(3233),
    [anon_sym_var] = ACTIONS(3233),
    [sym_predefined_type] = ACTIONS(3233),
    [anon_sym_break] = ACTIONS(3233),
    [anon_sym_unchecked] = ACTIONS(3233),
    [anon_sym_continue] = ACTIONS(3233),
    [anon_sym_do] = ACTIONS(3233),
    [anon_sym_while] = ACTIONS(3233),
    [anon_sym_for] = ACTIONS(3233),
    [anon_sym_lock] = ACTIONS(3233),
    [anon_sym_yield] = ACTIONS(3233),
    [anon_sym_switch] = ACTIONS(3233),
    [anon_sym_case] = ACTIONS(3233),
    [anon_sym_default] = ACTIONS(3233),
    [anon_sym_throw] = ACTIONS(3233),
    [anon_sym_try] = ACTIONS(3233),
    [anon_sym_when] = ACTIONS(3233),
    [anon_sym_await] = ACTIONS(3233),
    [anon_sym_foreach] = ACTIONS(3233),
    [anon_sym_goto] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(3233),
    [anon_sym_else] = ACTIONS(3233),
    [anon_sym_DOT_DOT] = ACTIONS(3235),
    [anon_sym_from] = ACTIONS(3233),
    [anon_sym_into] = ACTIONS(3233),
    [anon_sym_join] = ACTIONS(3233),
    [anon_sym_on] = ACTIONS(3233),
    [anon_sym_equals] = ACTIONS(3233),
    [anon_sym_let] = ACTIONS(3233),
    [anon_sym_orderby] = ACTIONS(3233),
    [anon_sym_ascending] = ACTIONS(3233),
    [anon_sym_descending] = ACTIONS(3233),
    [anon_sym_group] = ACTIONS(3233),
    [anon_sym_by] = ACTIONS(3233),
    [anon_sym_select] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_stackalloc] = ACTIONS(3233),
    [anon_sym_sizeof] = ACTIONS(3233),
    [anon_sym_typeof] = ACTIONS(3233),
    [anon_sym___makeref] = ACTIONS(3233),
    [anon_sym___reftype] = ACTIONS(3233),
    [anon_sym___refvalue] = ACTIONS(3233),
    [sym_null_literal] = ACTIONS(3233),
    [anon_sym_SQUOTE] = ACTIONS(3235),
    [sym_integer_literal] = ACTIONS(3233),
    [sym_real_literal] = ACTIONS(3235),
    [sym_verbatim_string_literal] = ACTIONS(3235),
    [aux_sym_preproc_if_token1] = ACTIONS(3235),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3235),
    [sym_interpolation_verbatim_start] = ACTIONS(3235),
    [sym_interpolation_raw_start] = ACTIONS(3235),
    [sym_raw_string_start] = ACTIONS(3235),
  },
  [2674] = {
    [sym_preproc_region] = STATE(2674),
    [sym_preproc_endregion] = STATE(2674),
    [sym_preproc_line] = STATE(2674),
    [sym_preproc_pragma] = STATE(2674),
    [sym_preproc_nullable] = STATE(2674),
    [sym_preproc_error] = STATE(2674),
    [sym_preproc_define] = STATE(2674),
    [sym_preproc_undef] = STATE(2674),
    [sym__identifier_token] = ACTIONS(3229),
    [anon_sym_extern] = ACTIONS(3229),
    [anon_sym_alias] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym_global] = ACTIONS(3229),
    [anon_sym_using] = ACTIONS(3229),
    [anon_sym_unsafe] = ACTIONS(3229),
    [anon_sym_static] = ACTIONS(3229),
    [anon_sym_LBRACK] = ACTIONS(3231),
    [anon_sym_LPAREN] = ACTIONS(3231),
    [anon_sym_return] = ACTIONS(3229),
    [anon_sym_ref] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3231),
    [anon_sym_RBRACE] = ACTIONS(3231),
    [anon_sym_delegate] = ACTIONS(3229),
    [anon_sym_abstract] = ACTIONS(3229),
    [anon_sym_async] = ACTIONS(3229),
    [anon_sym_const] = ACTIONS(3229),
    [anon_sym_file] = ACTIONS(3229),
    [anon_sym_fixed] = ACTIONS(3229),
    [anon_sym_internal] = ACTIONS(3229),
    [anon_sym_new] = ACTIONS(3229),
    [anon_sym_override] = ACTIONS(3229),
    [anon_sym_partial] = ACTIONS(3229),
    [anon_sym_private] = ACTIONS(3229),
    [anon_sym_protected] = ACTIONS(3229),
    [anon_sym_public] = ACTIONS(3229),
    [anon_sym_readonly] = ACTIONS(3229),
    [anon_sym_required] = ACTIONS(3229),
    [anon_sym_sealed] = ACTIONS(3229),
    [anon_sym_virtual] = ACTIONS(3229),
    [anon_sym_volatile] = ACTIONS(3229),
    [anon_sym_where] = ACTIONS(3229),
    [anon_sym_notnull] = ACTIONS(3229),
    [anon_sym_unmanaged] = ACTIONS(3229),
    [anon_sym_checked] = ACTIONS(3229),
    [anon_sym_BANG] = ACTIONS(3231),
    [anon_sym_TILDE] = ACTIONS(3231),
    [anon_sym_PLUS_PLUS] = ACTIONS(3231),
    [anon_sym_DASH_DASH] = ACTIONS(3231),
    [anon_sym_true] = ACTIONS(3229),
    [anon_sym_false] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3229),
    [anon_sym_DASH] = ACTIONS(3229),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_CARET] = ACTIONS(3231),
    [anon_sym_AMP] = ACTIONS(3231),
    [anon_sym_this] = ACTIONS(3229),
    [anon_sym_scoped] = ACTIONS(3229),
    [anon_sym_base] = ACTIONS(3229),
    [anon_sym_var] = ACTIONS(3229),
    [sym_predefined_type] = ACTIONS(3229),
    [anon_sym_break] = ACTIONS(3229),
    [anon_sym_unchecked] = ACTIONS(3229),
    [anon_sym_continue] = ACTIONS(3229),
    [anon_sym_do] = ACTIONS(3229),
    [anon_sym_while] = ACTIONS(3229),
    [anon_sym_for] = ACTIONS(3229),
    [anon_sym_lock] = ACTIONS(3229),
    [anon_sym_yield] = ACTIONS(3229),
    [anon_sym_switch] = ACTIONS(3229),
    [anon_sym_case] = ACTIONS(3229),
    [anon_sym_default] = ACTIONS(3229),
    [anon_sym_throw] = ACTIONS(3229),
    [anon_sym_try] = ACTIONS(3229),
    [anon_sym_when] = ACTIONS(3229),
    [anon_sym_await] = ACTIONS(3229),
    [anon_sym_foreach] = ACTIONS(3229),
    [anon_sym_goto] = ACTIONS(3229),
    [anon_sym_if] = ACTIONS(3229),
    [anon_sym_else] = ACTIONS(3229),
    [anon_sym_DOT_DOT] = ACTIONS(3231),
    [anon_sym_from] = ACTIONS(3229),
    [anon_sym_into] = ACTIONS(3229),
    [anon_sym_join] = ACTIONS(3229),
    [anon_sym_on] = ACTIONS(3229),
    [anon_sym_equals] = ACTIONS(3229),
    [anon_sym_let] = ACTIONS(3229),
    [anon_sym_orderby] = ACTIONS(3229),
    [anon_sym_ascending] = ACTIONS(3229),
    [anon_sym_descending] = ACTIONS(3229),
    [anon_sym_group] = ACTIONS(3229),
    [anon_sym_by] = ACTIONS(3229),
    [anon_sym_select] = ACTIONS(3229),
    [anon_sym_DQUOTE] = ACTIONS(3231),
    [anon_sym_stackalloc] = ACTIONS(3229),
    [anon_sym_sizeof] = ACTIONS(3229),
    [anon_sym_typeof] = ACTIONS(3229),
    [anon_sym___makeref] = ACTIONS(3229),
    [anon_sym___reftype] = ACTIONS(3229),
    [anon_sym___refvalue] = ACTIONS(3229),
    [sym_null_literal] = ACTIONS(3229),
    [anon_sym_SQUOTE] = ACTIONS(3231),
    [sym_integer_literal] = ACTIONS(3229),
    [sym_real_literal] = ACTIONS(3231),
    [sym_verbatim_string_literal] = ACTIONS(3231),
    [aux_sym_preproc_if_token1] = ACTIONS(3231),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3231),
    [sym_interpolation_verbatim_start] = ACTIONS(3231),
    [sym_interpolation_raw_start] = ACTIONS(3231),
    [sym_raw_string_start] = ACTIONS(3231),
  },
  [2675] = {
    [sym_preproc_region] = STATE(2675),
    [sym_preproc_endregion] = STATE(2675),
    [sym_preproc_line] = STATE(2675),
    [sym_preproc_pragma] = STATE(2675),
    [sym_preproc_nullable] = STATE(2675),
    [sym_preproc_error] = STATE(2675),
    [sym_preproc_define] = STATE(2675),
    [sym_preproc_undef] = STATE(2675),
    [sym__identifier_token] = ACTIONS(3309),
    [anon_sym_extern] = ACTIONS(3309),
    [anon_sym_alias] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3311),
    [anon_sym_global] = ACTIONS(3309),
    [anon_sym_using] = ACTIONS(3309),
    [anon_sym_unsafe] = ACTIONS(3309),
    [anon_sym_static] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_LPAREN] = ACTIONS(3311),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_ref] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3311),
    [anon_sym_RBRACE] = ACTIONS(3311),
    [anon_sym_delegate] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_file] = ACTIONS(3309),
    [anon_sym_fixed] = ACTIONS(3309),
    [anon_sym_internal] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_override] = ACTIONS(3309),
    [anon_sym_partial] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_readonly] = ACTIONS(3309),
    [anon_sym_required] = ACTIONS(3309),
    [anon_sym_sealed] = ACTIONS(3309),
    [anon_sym_virtual] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(3309),
    [anon_sym_where] = ACTIONS(3309),
    [anon_sym_notnull] = ACTIONS(3309),
    [anon_sym_unmanaged] = ACTIONS(3309),
    [anon_sym_checked] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3311),
    [anon_sym_TILDE] = ACTIONS(3311),
    [anon_sym_PLUS_PLUS] = ACTIONS(3311),
    [anon_sym_DASH_DASH] = ACTIONS(3311),
    [anon_sym_true] = ACTIONS(3309),
    [anon_sym_false] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3311),
    [anon_sym_CARET] = ACTIONS(3311),
    [anon_sym_AMP] = ACTIONS(3311),
    [anon_sym_this] = ACTIONS(3309),
    [anon_sym_scoped] = ACTIONS(3309),
    [anon_sym_base] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [sym_predefined_type] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_unchecked] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_lock] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_when] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_foreach] = ACTIONS(3309),
    [anon_sym_goto] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_DOT_DOT] = ACTIONS(3311),
    [anon_sym_from] = ACTIONS(3309),
    [anon_sym_into] = ACTIONS(3309),
    [anon_sym_join] = ACTIONS(3309),
    [anon_sym_on] = ACTIONS(3309),
    [anon_sym_equals] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_orderby] = ACTIONS(3309),
    [anon_sym_ascending] = ACTIONS(3309),
    [anon_sym_descending] = ACTIONS(3309),
    [anon_sym_group] = ACTIONS(3309),
    [anon_sym_by] = ACTIONS(3309),
    [anon_sym_select] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3311),
    [anon_sym_stackalloc] = ACTIONS(3309),
    [anon_sym_sizeof] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym___makeref] = ACTIONS(3309),
    [anon_sym___reftype] = ACTIONS(3309),
    [anon_sym___refvalue] = ACTIONS(3309),
    [sym_null_literal] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3311),
    [sym_integer_literal] = ACTIONS(3309),
    [sym_real_literal] = ACTIONS(3311),
    [sym_verbatim_string_literal] = ACTIONS(3311),
    [aux_sym_preproc_if_token1] = ACTIONS(3311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3311),
    [sym_interpolation_verbatim_start] = ACTIONS(3311),
    [sym_interpolation_raw_start] = ACTIONS(3311),
    [sym_raw_string_start] = ACTIONS(3311),
  },
  [2676] = {
    [sym_preproc_region] = STATE(2676),
    [sym_preproc_endregion] = STATE(2676),
    [sym_preproc_line] = STATE(2676),
    [sym_preproc_pragma] = STATE(2676),
    [sym_preproc_nullable] = STATE(2676),
    [sym_preproc_error] = STATE(2676),
    [sym_preproc_define] = STATE(2676),
    [sym_preproc_undef] = STATE(2676),
    [sym__identifier_token] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3365),
    [anon_sym_alias] = ACTIONS(3365),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_global] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_unsafe] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3365),
    [anon_sym_ref] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_delegate] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_file] = ACTIONS(3365),
    [anon_sym_fixed] = ACTIONS(3365),
    [anon_sym_internal] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_partial] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_required] = ACTIONS(3365),
    [anon_sym_sealed] = ACTIONS(3365),
    [anon_sym_virtual] = ACTIONS(3365),
    [anon_sym_volatile] = ACTIONS(3365),
    [anon_sym_where] = ACTIONS(3365),
    [anon_sym_notnull] = ACTIONS(3365),
    [anon_sym_unmanaged] = ACTIONS(3365),
    [anon_sym_checked] = ACTIONS(3365),
    [anon_sym_BANG] = ACTIONS(3367),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [anon_sym_true] = ACTIONS(3365),
    [anon_sym_false] = ACTIONS(3365),
    [anon_sym_PLUS] = ACTIONS(3365),
    [anon_sym_DASH] = ACTIONS(3365),
    [anon_sym_STAR] = ACTIONS(3367),
    [anon_sym_CARET] = ACTIONS(3367),
    [anon_sym_AMP] = ACTIONS(3367),
    [anon_sym_this] = ACTIONS(3365),
    [anon_sym_scoped] = ACTIONS(3365),
    [anon_sym_base] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [sym_predefined_type] = ACTIONS(3365),
    [anon_sym_break] = ACTIONS(3365),
    [anon_sym_unchecked] = ACTIONS(3365),
    [anon_sym_continue] = ACTIONS(3365),
    [anon_sym_do] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_for] = ACTIONS(3365),
    [anon_sym_lock] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_switch] = ACTIONS(3365),
    [anon_sym_case] = ACTIONS(3365),
    [anon_sym_default] = ACTIONS(3365),
    [anon_sym_throw] = ACTIONS(3365),
    [anon_sym_try] = ACTIONS(3365),
    [anon_sym_when] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3365),
    [anon_sym_foreach] = ACTIONS(3365),
    [anon_sym_goto] = ACTIONS(3365),
    [anon_sym_if] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_DOT_DOT] = ACTIONS(3367),
    [anon_sym_from] = ACTIONS(3365),
    [anon_sym_into] = ACTIONS(3365),
    [anon_sym_join] = ACTIONS(3365),
    [anon_sym_on] = ACTIONS(3365),
    [anon_sym_equals] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_orderby] = ACTIONS(3365),
    [anon_sym_ascending] = ACTIONS(3365),
    [anon_sym_descending] = ACTIONS(3365),
    [anon_sym_group] = ACTIONS(3365),
    [anon_sym_by] = ACTIONS(3365),
    [anon_sym_select] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_stackalloc] = ACTIONS(3365),
    [anon_sym_sizeof] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3365),
    [anon_sym___makeref] = ACTIONS(3365),
    [anon_sym___reftype] = ACTIONS(3365),
    [anon_sym___refvalue] = ACTIONS(3365),
    [sym_null_literal] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3367),
    [sym_integer_literal] = ACTIONS(3365),
    [sym_real_literal] = ACTIONS(3367),
    [sym_verbatim_string_literal] = ACTIONS(3367),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3367),
    [sym_interpolation_verbatim_start] = ACTIONS(3367),
    [sym_interpolation_raw_start] = ACTIONS(3367),
    [sym_raw_string_start] = ACTIONS(3367),
  },
  [2677] = {
    [sym_preproc_region] = STATE(2677),
    [sym_preproc_endregion] = STATE(2677),
    [sym_preproc_line] = STATE(2677),
    [sym_preproc_pragma] = STATE(2677),
    [sym_preproc_nullable] = STATE(2677),
    [sym_preproc_error] = STATE(2677),
    [sym_preproc_define] = STATE(2677),
    [sym_preproc_undef] = STATE(2677),
    [sym__identifier_token] = ACTIONS(3345),
    [anon_sym_extern] = ACTIONS(3345),
    [anon_sym_alias] = ACTIONS(3345),
    [anon_sym_SEMI] = ACTIONS(3347),
    [anon_sym_global] = ACTIONS(3345),
    [anon_sym_using] = ACTIONS(3345),
    [anon_sym_unsafe] = ACTIONS(3345),
    [anon_sym_static] = ACTIONS(3345),
    [anon_sym_LBRACK] = ACTIONS(3347),
    [anon_sym_LPAREN] = ACTIONS(3347),
    [anon_sym_return] = ACTIONS(3345),
    [anon_sym_ref] = ACTIONS(3345),
    [anon_sym_LBRACE] = ACTIONS(3347),
    [anon_sym_RBRACE] = ACTIONS(3347),
    [anon_sym_delegate] = ACTIONS(3345),
    [anon_sym_abstract] = ACTIONS(3345),
    [anon_sym_async] = ACTIONS(3345),
    [anon_sym_const] = ACTIONS(3345),
    [anon_sym_file] = ACTIONS(3345),
    [anon_sym_fixed] = ACTIONS(3345),
    [anon_sym_internal] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(3345),
    [anon_sym_override] = ACTIONS(3345),
    [anon_sym_partial] = ACTIONS(3345),
    [anon_sym_private] = ACTIONS(3345),
    [anon_sym_protected] = ACTIONS(3345),
    [anon_sym_public] = ACTIONS(3345),
    [anon_sym_readonly] = ACTIONS(3345),
    [anon_sym_required] = ACTIONS(3345),
    [anon_sym_sealed] = ACTIONS(3345),
    [anon_sym_virtual] = ACTIONS(3345),
    [anon_sym_volatile] = ACTIONS(3345),
    [anon_sym_where] = ACTIONS(3345),
    [anon_sym_notnull] = ACTIONS(3345),
    [anon_sym_unmanaged] = ACTIONS(3345),
    [anon_sym_checked] = ACTIONS(3345),
    [anon_sym_BANG] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3347),
    [anon_sym_PLUS_PLUS] = ACTIONS(3347),
    [anon_sym_DASH_DASH] = ACTIONS(3347),
    [anon_sym_true] = ACTIONS(3345),
    [anon_sym_false] = ACTIONS(3345),
    [anon_sym_PLUS] = ACTIONS(3345),
    [anon_sym_DASH] = ACTIONS(3345),
    [anon_sym_STAR] = ACTIONS(3347),
    [anon_sym_CARET] = ACTIONS(3347),
    [anon_sym_AMP] = ACTIONS(3347),
    [anon_sym_this] = ACTIONS(3345),
    [anon_sym_scoped] = ACTIONS(3345),
    [anon_sym_base] = ACTIONS(3345),
    [anon_sym_var] = ACTIONS(3345),
    [sym_predefined_type] = ACTIONS(3345),
    [anon_sym_break] = ACTIONS(3345),
    [anon_sym_unchecked] = ACTIONS(3345),
    [anon_sym_continue] = ACTIONS(3345),
    [anon_sym_do] = ACTIONS(3345),
    [anon_sym_while] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(3345),
    [anon_sym_lock] = ACTIONS(3345),
    [anon_sym_yield] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(3345),
    [anon_sym_case] = ACTIONS(3345),
    [anon_sym_default] = ACTIONS(3345),
    [anon_sym_throw] = ACTIONS(3345),
    [anon_sym_try] = ACTIONS(3345),
    [anon_sym_when] = ACTIONS(3345),
    [anon_sym_await] = ACTIONS(3345),
    [anon_sym_foreach] = ACTIONS(3345),
    [anon_sym_goto] = ACTIONS(3345),
    [anon_sym_if] = ACTIONS(3345),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_DOT_DOT] = ACTIONS(3347),
    [anon_sym_from] = ACTIONS(3345),
    [anon_sym_into] = ACTIONS(3345),
    [anon_sym_join] = ACTIONS(3345),
    [anon_sym_on] = ACTIONS(3345),
    [anon_sym_equals] = ACTIONS(3345),
    [anon_sym_let] = ACTIONS(3345),
    [anon_sym_orderby] = ACTIONS(3345),
    [anon_sym_ascending] = ACTIONS(3345),
    [anon_sym_descending] = ACTIONS(3345),
    [anon_sym_group] = ACTIONS(3345),
    [anon_sym_by] = ACTIONS(3345),
    [anon_sym_select] = ACTIONS(3345),
    [anon_sym_DQUOTE] = ACTIONS(3347),
    [anon_sym_stackalloc] = ACTIONS(3345),
    [anon_sym_sizeof] = ACTIONS(3345),
    [anon_sym_typeof] = ACTIONS(3345),
    [anon_sym___makeref] = ACTIONS(3345),
    [anon_sym___reftype] = ACTIONS(3345),
    [anon_sym___refvalue] = ACTIONS(3345),
    [sym_null_literal] = ACTIONS(3345),
    [anon_sym_SQUOTE] = ACTIONS(3347),
    [sym_integer_literal] = ACTIONS(3345),
    [sym_real_literal] = ACTIONS(3347),
    [sym_verbatim_string_literal] = ACTIONS(3347),
    [aux_sym_preproc_if_token1] = ACTIONS(3347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3347),
    [sym_interpolation_verbatim_start] = ACTIONS(3347),
    [sym_interpolation_raw_start] = ACTIONS(3347),
    [sym_raw_string_start] = ACTIONS(3347),
  },
  [2678] = {
    [sym_preproc_region] = STATE(2678),
    [sym_preproc_endregion] = STATE(2678),
    [sym_preproc_line] = STATE(2678),
    [sym_preproc_pragma] = STATE(2678),
    [sym_preproc_nullable] = STATE(2678),
    [sym_preproc_error] = STATE(2678),
    [sym_preproc_define] = STATE(2678),
    [sym_preproc_undef] = STATE(2678),
    [sym__identifier_token] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_alias] = ACTIONS(3361),
    [anon_sym_SEMI] = ACTIONS(3363),
    [anon_sym_global] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_unsafe] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_return] = ACTIONS(3361),
    [anon_sym_ref] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_delegate] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_file] = ACTIONS(3361),
    [anon_sym_fixed] = ACTIONS(3361),
    [anon_sym_internal] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_partial] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_required] = ACTIONS(3361),
    [anon_sym_sealed] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_where] = ACTIONS(3361),
    [anon_sym_notnull] = ACTIONS(3361),
    [anon_sym_unmanaged] = ACTIONS(3361),
    [anon_sym_checked] = ACTIONS(3361),
    [anon_sym_BANG] = ACTIONS(3363),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_PLUS_PLUS] = ACTIONS(3363),
    [anon_sym_DASH_DASH] = ACTIONS(3363),
    [anon_sym_true] = ACTIONS(3361),
    [anon_sym_false] = ACTIONS(3361),
    [anon_sym_PLUS] = ACTIONS(3361),
    [anon_sym_DASH] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3363),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_this] = ACTIONS(3361),
    [anon_sym_scoped] = ACTIONS(3361),
    [anon_sym_base] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [sym_predefined_type] = ACTIONS(3361),
    [anon_sym_break] = ACTIONS(3361),
    [anon_sym_unchecked] = ACTIONS(3361),
    [anon_sym_continue] = ACTIONS(3361),
    [anon_sym_do] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_for] = ACTIONS(3361),
    [anon_sym_lock] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_switch] = ACTIONS(3361),
    [anon_sym_case] = ACTIONS(3361),
    [anon_sym_default] = ACTIONS(3361),
    [anon_sym_throw] = ACTIONS(3361),
    [anon_sym_try] = ACTIONS(3361),
    [anon_sym_when] = ACTIONS(3361),
    [anon_sym_await] = ACTIONS(3361),
    [anon_sym_foreach] = ACTIONS(3361),
    [anon_sym_goto] = ACTIONS(3361),
    [anon_sym_if] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_DOT_DOT] = ACTIONS(3363),
    [anon_sym_from] = ACTIONS(3361),
    [anon_sym_into] = ACTIONS(3361),
    [anon_sym_join] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [anon_sym_equals] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_orderby] = ACTIONS(3361),
    [anon_sym_ascending] = ACTIONS(3361),
    [anon_sym_descending] = ACTIONS(3361),
    [anon_sym_group] = ACTIONS(3361),
    [anon_sym_by] = ACTIONS(3361),
    [anon_sym_select] = ACTIONS(3361),
    [anon_sym_DQUOTE] = ACTIONS(3363),
    [anon_sym_stackalloc] = ACTIONS(3361),
    [anon_sym_sizeof] = ACTIONS(3361),
    [anon_sym_typeof] = ACTIONS(3361),
    [anon_sym___makeref] = ACTIONS(3361),
    [anon_sym___reftype] = ACTIONS(3361),
    [anon_sym___refvalue] = ACTIONS(3361),
    [sym_null_literal] = ACTIONS(3361),
    [anon_sym_SQUOTE] = ACTIONS(3363),
    [sym_integer_literal] = ACTIONS(3361),
    [sym_real_literal] = ACTIONS(3363),
    [sym_verbatim_string_literal] = ACTIONS(3363),
    [aux_sym_preproc_if_token1] = ACTIONS(3363),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3363),
    [sym_interpolation_verbatim_start] = ACTIONS(3363),
    [sym_interpolation_raw_start] = ACTIONS(3363),
    [sym_raw_string_start] = ACTIONS(3363),
  },
  [2679] = {
    [sym_preproc_region] = STATE(2679),
    [sym_preproc_endregion] = STATE(2679),
    [sym_preproc_line] = STATE(2679),
    [sym_preproc_pragma] = STATE(2679),
    [sym_preproc_nullable] = STATE(2679),
    [sym_preproc_error] = STATE(2679),
    [sym_preproc_define] = STATE(2679),
    [sym_preproc_undef] = STATE(2679),
    [sym__identifier_token] = ACTIONS(3357),
    [anon_sym_extern] = ACTIONS(3357),
    [anon_sym_alias] = ACTIONS(3357),
    [anon_sym_SEMI] = ACTIONS(3359),
    [anon_sym_global] = ACTIONS(3357),
    [anon_sym_using] = ACTIONS(3357),
    [anon_sym_unsafe] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(3359),
    [anon_sym_return] = ACTIONS(3357),
    [anon_sym_ref] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(3359),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_delegate] = ACTIONS(3357),
    [anon_sym_abstract] = ACTIONS(3357),
    [anon_sym_async] = ACTIONS(3357),
    [anon_sym_const] = ACTIONS(3357),
    [anon_sym_file] = ACTIONS(3357),
    [anon_sym_fixed] = ACTIONS(3357),
    [anon_sym_internal] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(3357),
    [anon_sym_override] = ACTIONS(3357),
    [anon_sym_partial] = ACTIONS(3357),
    [anon_sym_private] = ACTIONS(3357),
    [anon_sym_protected] = ACTIONS(3357),
    [anon_sym_public] = ACTIONS(3357),
    [anon_sym_readonly] = ACTIONS(3357),
    [anon_sym_required] = ACTIONS(3357),
    [anon_sym_sealed] = ACTIONS(3357),
    [anon_sym_virtual] = ACTIONS(3357),
    [anon_sym_volatile] = ACTIONS(3357),
    [anon_sym_where] = ACTIONS(3357),
    [anon_sym_notnull] = ACTIONS(3357),
    [anon_sym_unmanaged] = ACTIONS(3357),
    [anon_sym_checked] = ACTIONS(3357),
    [anon_sym_BANG] = ACTIONS(3359),
    [anon_sym_TILDE] = ACTIONS(3359),
    [anon_sym_PLUS_PLUS] = ACTIONS(3359),
    [anon_sym_DASH_DASH] = ACTIONS(3359),
    [anon_sym_true] = ACTIONS(3357),
    [anon_sym_false] = ACTIONS(3357),
    [anon_sym_PLUS] = ACTIONS(3357),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_STAR] = ACTIONS(3359),
    [anon_sym_CARET] = ACTIONS(3359),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_this] = ACTIONS(3357),
    [anon_sym_scoped] = ACTIONS(3357),
    [anon_sym_base] = ACTIONS(3357),
    [anon_sym_var] = ACTIONS(3357),
    [sym_predefined_type] = ACTIONS(3357),
    [anon_sym_break] = ACTIONS(3357),
    [anon_sym_unchecked] = ACTIONS(3357),
    [anon_sym_continue] = ACTIONS(3357),
    [anon_sym_do] = ACTIONS(3357),
    [anon_sym_while] = ACTIONS(3357),
    [anon_sym_for] = ACTIONS(3357),
    [anon_sym_lock] = ACTIONS(3357),
    [anon_sym_yield] = ACTIONS(3357),
    [anon_sym_switch] = ACTIONS(3357),
    [anon_sym_case] = ACTIONS(3357),
    [anon_sym_default] = ACTIONS(3357),
    [anon_sym_throw] = ACTIONS(3357),
    [anon_sym_try] = ACTIONS(3357),
    [anon_sym_when] = ACTIONS(3357),
    [anon_sym_await] = ACTIONS(3357),
    [anon_sym_foreach] = ACTIONS(3357),
    [anon_sym_goto] = ACTIONS(3357),
    [anon_sym_if] = ACTIONS(3357),
    [anon_sym_else] = ACTIONS(3357),
    [anon_sym_DOT_DOT] = ACTIONS(3359),
    [anon_sym_from] = ACTIONS(3357),
    [anon_sym_into] = ACTIONS(3357),
    [anon_sym_join] = ACTIONS(3357),
    [anon_sym_on] = ACTIONS(3357),
    [anon_sym_equals] = ACTIONS(3357),
    [anon_sym_let] = ACTIONS(3357),
    [anon_sym_orderby] = ACTIONS(3357),
    [anon_sym_ascending] = ACTIONS(3357),
    [anon_sym_descending] = ACTIONS(3357),
    [anon_sym_group] = ACTIONS(3357),
    [anon_sym_by] = ACTIONS(3357),
    [anon_sym_select] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(3359),
    [anon_sym_stackalloc] = ACTIONS(3357),
    [anon_sym_sizeof] = ACTIONS(3357),
    [anon_sym_typeof] = ACTIONS(3357),
    [anon_sym___makeref] = ACTIONS(3357),
    [anon_sym___reftype] = ACTIONS(3357),
    [anon_sym___refvalue] = ACTIONS(3357),
    [sym_null_literal] = ACTIONS(3357),
    [anon_sym_SQUOTE] = ACTIONS(3359),
    [sym_integer_literal] = ACTIONS(3357),
    [sym_real_literal] = ACTIONS(3359),
    [sym_verbatim_string_literal] = ACTIONS(3359),
    [aux_sym_preproc_if_token1] = ACTIONS(3359),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3359),
    [sym_interpolation_verbatim_start] = ACTIONS(3359),
    [sym_interpolation_raw_start] = ACTIONS(3359),
    [sym_raw_string_start] = ACTIONS(3359),
  },
  [2680] = {
    [sym_preproc_region] = STATE(2680),
    [sym_preproc_endregion] = STATE(2680),
    [sym_preproc_line] = STATE(2680),
    [sym_preproc_pragma] = STATE(2680),
    [sym_preproc_nullable] = STATE(2680),
    [sym_preproc_error] = STATE(2680),
    [sym_preproc_define] = STATE(2680),
    [sym_preproc_undef] = STATE(2680),
    [sym__identifier_token] = ACTIONS(3381),
    [anon_sym_extern] = ACTIONS(3381),
    [anon_sym_alias] = ACTIONS(3381),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_global] = ACTIONS(3381),
    [anon_sym_using] = ACTIONS(3381),
    [anon_sym_unsafe] = ACTIONS(3381),
    [anon_sym_static] = ACTIONS(3381),
    [anon_sym_LBRACK] = ACTIONS(3383),
    [anon_sym_LPAREN] = ACTIONS(3383),
    [anon_sym_return] = ACTIONS(3381),
    [anon_sym_ref] = ACTIONS(3381),
    [anon_sym_LBRACE] = ACTIONS(3383),
    [anon_sym_RBRACE] = ACTIONS(3383),
    [anon_sym_delegate] = ACTIONS(3381),
    [anon_sym_abstract] = ACTIONS(3381),
    [anon_sym_async] = ACTIONS(3381),
    [anon_sym_const] = ACTIONS(3381),
    [anon_sym_file] = ACTIONS(3381),
    [anon_sym_fixed] = ACTIONS(3381),
    [anon_sym_internal] = ACTIONS(3381),
    [anon_sym_new] = ACTIONS(3381),
    [anon_sym_override] = ACTIONS(3381),
    [anon_sym_partial] = ACTIONS(3381),
    [anon_sym_private] = ACTIONS(3381),
    [anon_sym_protected] = ACTIONS(3381),
    [anon_sym_public] = ACTIONS(3381),
    [anon_sym_readonly] = ACTIONS(3381),
    [anon_sym_required] = ACTIONS(3381),
    [anon_sym_sealed] = ACTIONS(3381),
    [anon_sym_virtual] = ACTIONS(3381),
    [anon_sym_volatile] = ACTIONS(3381),
    [anon_sym_where] = ACTIONS(3381),
    [anon_sym_notnull] = ACTIONS(3381),
    [anon_sym_unmanaged] = ACTIONS(3381),
    [anon_sym_checked] = ACTIONS(3381),
    [anon_sym_BANG] = ACTIONS(3383),
    [anon_sym_TILDE] = ACTIONS(3383),
    [anon_sym_PLUS_PLUS] = ACTIONS(3383),
    [anon_sym_DASH_DASH] = ACTIONS(3383),
    [anon_sym_true] = ACTIONS(3381),
    [anon_sym_false] = ACTIONS(3381),
    [anon_sym_PLUS] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3381),
    [anon_sym_STAR] = ACTIONS(3383),
    [anon_sym_CARET] = ACTIONS(3383),
    [anon_sym_AMP] = ACTIONS(3383),
    [anon_sym_this] = ACTIONS(3381),
    [anon_sym_scoped] = ACTIONS(3381),
    [anon_sym_base] = ACTIONS(3381),
    [anon_sym_var] = ACTIONS(3381),
    [sym_predefined_type] = ACTIONS(3381),
    [anon_sym_break] = ACTIONS(3381),
    [anon_sym_unchecked] = ACTIONS(3381),
    [anon_sym_continue] = ACTIONS(3381),
    [anon_sym_do] = ACTIONS(3381),
    [anon_sym_while] = ACTIONS(3381),
    [anon_sym_for] = ACTIONS(3381),
    [anon_sym_lock] = ACTIONS(3381),
    [anon_sym_yield] = ACTIONS(3381),
    [anon_sym_switch] = ACTIONS(3381),
    [anon_sym_case] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3381),
    [anon_sym_throw] = ACTIONS(3381),
    [anon_sym_try] = ACTIONS(3381),
    [anon_sym_when] = ACTIONS(3381),
    [anon_sym_await] = ACTIONS(3381),
    [anon_sym_foreach] = ACTIONS(3381),
    [anon_sym_goto] = ACTIONS(3381),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_else] = ACTIONS(3381),
    [anon_sym_DOT_DOT] = ACTIONS(3383),
    [anon_sym_from] = ACTIONS(3381),
    [anon_sym_into] = ACTIONS(3381),
    [anon_sym_join] = ACTIONS(3381),
    [anon_sym_on] = ACTIONS(3381),
    [anon_sym_equals] = ACTIONS(3381),
    [anon_sym_let] = ACTIONS(3381),
    [anon_sym_orderby] = ACTIONS(3381),
    [anon_sym_ascending] = ACTIONS(3381),
    [anon_sym_descending] = ACTIONS(3381),
    [anon_sym_group] = ACTIONS(3381),
    [anon_sym_by] = ACTIONS(3381),
    [anon_sym_select] = ACTIONS(3381),
    [anon_sym_DQUOTE] = ACTIONS(3383),
    [anon_sym_stackalloc] = ACTIONS(3381),
    [anon_sym_sizeof] = ACTIONS(3381),
    [anon_sym_typeof] = ACTIONS(3381),
    [anon_sym___makeref] = ACTIONS(3381),
    [anon_sym___reftype] = ACTIONS(3381),
    [anon_sym___refvalue] = ACTIONS(3381),
    [sym_null_literal] = ACTIONS(3381),
    [anon_sym_SQUOTE] = ACTIONS(3383),
    [sym_integer_literal] = ACTIONS(3381),
    [sym_real_literal] = ACTIONS(3383),
    [sym_verbatim_string_literal] = ACTIONS(3383),
    [aux_sym_preproc_if_token1] = ACTIONS(3383),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3383),
    [sym_interpolation_verbatim_start] = ACTIONS(3383),
    [sym_interpolation_raw_start] = ACTIONS(3383),
    [sym_raw_string_start] = ACTIONS(3383),
  },
  [2681] = {
    [sym_preproc_region] = STATE(2681),
    [sym_preproc_endregion] = STATE(2681),
    [sym_preproc_line] = STATE(2681),
    [sym_preproc_pragma] = STATE(2681),
    [sym_preproc_nullable] = STATE(2681),
    [sym_preproc_error] = STATE(2681),
    [sym_preproc_define] = STATE(2681),
    [sym_preproc_undef] = STATE(2681),
    [sym__identifier_token] = ACTIONS(3205),
    [anon_sym_extern] = ACTIONS(3205),
    [anon_sym_alias] = ACTIONS(3205),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_global] = ACTIONS(3205),
    [anon_sym_using] = ACTIONS(3205),
    [anon_sym_unsafe] = ACTIONS(3205),
    [anon_sym_static] = ACTIONS(3205),
    [anon_sym_LBRACK] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3205),
    [anon_sym_ref] = ACTIONS(3205),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_delegate] = ACTIONS(3205),
    [anon_sym_abstract] = ACTIONS(3205),
    [anon_sym_async] = ACTIONS(3205),
    [anon_sym_const] = ACTIONS(3205),
    [anon_sym_file] = ACTIONS(3205),
    [anon_sym_fixed] = ACTIONS(3205),
    [anon_sym_internal] = ACTIONS(3205),
    [anon_sym_new] = ACTIONS(3205),
    [anon_sym_override] = ACTIONS(3205),
    [anon_sym_partial] = ACTIONS(3205),
    [anon_sym_private] = ACTIONS(3205),
    [anon_sym_protected] = ACTIONS(3205),
    [anon_sym_public] = ACTIONS(3205),
    [anon_sym_readonly] = ACTIONS(3205),
    [anon_sym_required] = ACTIONS(3205),
    [anon_sym_sealed] = ACTIONS(3205),
    [anon_sym_virtual] = ACTIONS(3205),
    [anon_sym_volatile] = ACTIONS(3205),
    [anon_sym_where] = ACTIONS(3205),
    [anon_sym_notnull] = ACTIONS(3205),
    [anon_sym_unmanaged] = ACTIONS(3205),
    [anon_sym_checked] = ACTIONS(3205),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_TILDE] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3207),
    [anon_sym_DASH_DASH] = ACTIONS(3207),
    [anon_sym_true] = ACTIONS(3205),
    [anon_sym_false] = ACTIONS(3205),
    [anon_sym_PLUS] = ACTIONS(3205),
    [anon_sym_DASH] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_this] = ACTIONS(3205),
    [anon_sym_scoped] = ACTIONS(3205),
    [anon_sym_base] = ACTIONS(3205),
    [anon_sym_var] = ACTIONS(3205),
    [sym_predefined_type] = ACTIONS(3205),
    [anon_sym_break] = ACTIONS(3205),
    [anon_sym_unchecked] = ACTIONS(3205),
    [anon_sym_continue] = ACTIONS(3205),
    [anon_sym_do] = ACTIONS(3205),
    [anon_sym_while] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3205),
    [anon_sym_lock] = ACTIONS(3205),
    [anon_sym_yield] = ACTIONS(3205),
    [anon_sym_switch] = ACTIONS(3205),
    [anon_sym_case] = ACTIONS(3205),
    [anon_sym_default] = ACTIONS(3205),
    [anon_sym_throw] = ACTIONS(3205),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_when] = ACTIONS(3205),
    [anon_sym_await] = ACTIONS(3205),
    [anon_sym_foreach] = ACTIONS(3205),
    [anon_sym_goto] = ACTIONS(3205),
    [anon_sym_if] = ACTIONS(3205),
    [anon_sym_else] = ACTIONS(3205),
    [anon_sym_DOT_DOT] = ACTIONS(3207),
    [anon_sym_from] = ACTIONS(3205),
    [anon_sym_into] = ACTIONS(3205),
    [anon_sym_join] = ACTIONS(3205),
    [anon_sym_on] = ACTIONS(3205),
    [anon_sym_equals] = ACTIONS(3205),
    [anon_sym_let] = ACTIONS(3205),
    [anon_sym_orderby] = ACTIONS(3205),
    [anon_sym_ascending] = ACTIONS(3205),
    [anon_sym_descending] = ACTIONS(3205),
    [anon_sym_group] = ACTIONS(3205),
    [anon_sym_by] = ACTIONS(3205),
    [anon_sym_select] = ACTIONS(3205),
    [anon_sym_DQUOTE] = ACTIONS(3207),
    [anon_sym_stackalloc] = ACTIONS(3205),
    [anon_sym_sizeof] = ACTIONS(3205),
    [anon_sym_typeof] = ACTIONS(3205),
    [anon_sym___makeref] = ACTIONS(3205),
    [anon_sym___reftype] = ACTIONS(3205),
    [anon_sym___refvalue] = ACTIONS(3205),
    [sym_null_literal] = ACTIONS(3205),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [sym_integer_literal] = ACTIONS(3205),
    [sym_real_literal] = ACTIONS(3207),
    [sym_verbatim_string_literal] = ACTIONS(3207),
    [aux_sym_preproc_if_token1] = ACTIONS(3207),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3207),
    [sym_interpolation_verbatim_start] = ACTIONS(3207),
    [sym_interpolation_raw_start] = ACTIONS(3207),
    [sym_raw_string_start] = ACTIONS(3207),
  },
  [2682] = {
    [sym_preproc_region] = STATE(2682),
    [sym_preproc_endregion] = STATE(2682),
    [sym_preproc_line] = STATE(2682),
    [sym_preproc_pragma] = STATE(2682),
    [sym_preproc_nullable] = STATE(2682),
    [sym_preproc_error] = STATE(2682),
    [sym_preproc_define] = STATE(2682),
    [sym_preproc_undef] = STATE(2682),
    [sym__identifier_token] = ACTIONS(3277),
    [anon_sym_extern] = ACTIONS(3277),
    [anon_sym_alias] = ACTIONS(3277),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_global] = ACTIONS(3277),
    [anon_sym_using] = ACTIONS(3277),
    [anon_sym_unsafe] = ACTIONS(3277),
    [anon_sym_static] = ACTIONS(3277),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3277),
    [anon_sym_ref] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3279),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_delegate] = ACTIONS(3277),
    [anon_sym_abstract] = ACTIONS(3277),
    [anon_sym_async] = ACTIONS(3277),
    [anon_sym_const] = ACTIONS(3277),
    [anon_sym_file] = ACTIONS(3277),
    [anon_sym_fixed] = ACTIONS(3277),
    [anon_sym_internal] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(3277),
    [anon_sym_override] = ACTIONS(3277),
    [anon_sym_partial] = ACTIONS(3277),
    [anon_sym_private] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(3277),
    [anon_sym_public] = ACTIONS(3277),
    [anon_sym_readonly] = ACTIONS(3277),
    [anon_sym_required] = ACTIONS(3277),
    [anon_sym_sealed] = ACTIONS(3277),
    [anon_sym_virtual] = ACTIONS(3277),
    [anon_sym_volatile] = ACTIONS(3277),
    [anon_sym_where] = ACTIONS(3277),
    [anon_sym_notnull] = ACTIONS(3277),
    [anon_sym_unmanaged] = ACTIONS(3277),
    [anon_sym_checked] = ACTIONS(3277),
    [anon_sym_BANG] = ACTIONS(3279),
    [anon_sym_TILDE] = ACTIONS(3279),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_true] = ACTIONS(3277),
    [anon_sym_false] = ACTIONS(3277),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_STAR] = ACTIONS(3279),
    [anon_sym_CARET] = ACTIONS(3279),
    [anon_sym_AMP] = ACTIONS(3279),
    [anon_sym_this] = ACTIONS(3277),
    [anon_sym_scoped] = ACTIONS(3277),
    [anon_sym_base] = ACTIONS(3277),
    [anon_sym_var] = ACTIONS(3277),
    [sym_predefined_type] = ACTIONS(3277),
    [anon_sym_break] = ACTIONS(3277),
    [anon_sym_unchecked] = ACTIONS(3277),
    [anon_sym_continue] = ACTIONS(3277),
    [anon_sym_do] = ACTIONS(3277),
    [anon_sym_while] = ACTIONS(3277),
    [anon_sym_for] = ACTIONS(3277),
    [anon_sym_lock] = ACTIONS(3277),
    [anon_sym_yield] = ACTIONS(3277),
    [anon_sym_switch] = ACTIONS(3277),
    [anon_sym_case] = ACTIONS(3277),
    [anon_sym_default] = ACTIONS(3277),
    [anon_sym_throw] = ACTIONS(3277),
    [anon_sym_try] = ACTIONS(3277),
    [anon_sym_when] = ACTIONS(3277),
    [anon_sym_await] = ACTIONS(3277),
    [anon_sym_foreach] = ACTIONS(3277),
    [anon_sym_goto] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(3277),
    [anon_sym_else] = ACTIONS(3277),
    [anon_sym_DOT_DOT] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3277),
    [anon_sym_into] = ACTIONS(3277),
    [anon_sym_join] = ACTIONS(3277),
    [anon_sym_on] = ACTIONS(3277),
    [anon_sym_equals] = ACTIONS(3277),
    [anon_sym_let] = ACTIONS(3277),
    [anon_sym_orderby] = ACTIONS(3277),
    [anon_sym_ascending] = ACTIONS(3277),
    [anon_sym_descending] = ACTIONS(3277),
    [anon_sym_group] = ACTIONS(3277),
    [anon_sym_by] = ACTIONS(3277),
    [anon_sym_select] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(3279),
    [anon_sym_stackalloc] = ACTIONS(3277),
    [anon_sym_sizeof] = ACTIONS(3277),
    [anon_sym_typeof] = ACTIONS(3277),
    [anon_sym___makeref] = ACTIONS(3277),
    [anon_sym___reftype] = ACTIONS(3277),
    [anon_sym___refvalue] = ACTIONS(3277),
    [sym_null_literal] = ACTIONS(3277),
    [anon_sym_SQUOTE] = ACTIONS(3279),
    [sym_integer_literal] = ACTIONS(3277),
    [sym_real_literal] = ACTIONS(3279),
    [sym_verbatim_string_literal] = ACTIONS(3279),
    [aux_sym_preproc_if_token1] = ACTIONS(3279),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3279),
    [sym_interpolation_verbatim_start] = ACTIONS(3279),
    [sym_interpolation_raw_start] = ACTIONS(3279),
    [sym_raw_string_start] = ACTIONS(3279),
  },
  [2683] = {
    [sym_preproc_region] = STATE(2683),
    [sym_preproc_endregion] = STATE(2683),
    [sym_preproc_line] = STATE(2683),
    [sym_preproc_pragma] = STATE(2683),
    [sym_preproc_nullable] = STATE(2683),
    [sym_preproc_error] = STATE(2683),
    [sym_preproc_define] = STATE(2683),
    [sym_preproc_undef] = STATE(2683),
    [sym__identifier_token] = ACTIONS(3175),
    [anon_sym_extern] = ACTIONS(3175),
    [anon_sym_alias] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_global] = ACTIONS(3175),
    [anon_sym_using] = ACTIONS(3175),
    [anon_sym_unsafe] = ACTIONS(3175),
    [anon_sym_static] = ACTIONS(3175),
    [anon_sym_LBRACK] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_ref] = ACTIONS(3175),
    [anon_sym_LBRACE] = ACTIONS(3177),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_delegate] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_async] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_file] = ACTIONS(3175),
    [anon_sym_fixed] = ACTIONS(3175),
    [anon_sym_internal] = ACTIONS(3175),
    [anon_sym_new] = ACTIONS(3175),
    [anon_sym_override] = ACTIONS(3175),
    [anon_sym_partial] = ACTIONS(3175),
    [anon_sym_private] = ACTIONS(3175),
    [anon_sym_protected] = ACTIONS(3175),
    [anon_sym_public] = ACTIONS(3175),
    [anon_sym_readonly] = ACTIONS(3175),
    [anon_sym_required] = ACTIONS(3175),
    [anon_sym_sealed] = ACTIONS(3175),
    [anon_sym_virtual] = ACTIONS(3175),
    [anon_sym_volatile] = ACTIONS(3175),
    [anon_sym_where] = ACTIONS(3175),
    [anon_sym_notnull] = ACTIONS(3175),
    [anon_sym_unmanaged] = ACTIONS(3175),
    [anon_sym_checked] = ACTIONS(3175),
    [anon_sym_BANG] = ACTIONS(3177),
    [anon_sym_TILDE] = ACTIONS(3177),
    [anon_sym_PLUS_PLUS] = ACTIONS(3177),
    [anon_sym_DASH_DASH] = ACTIONS(3177),
    [anon_sym_true] = ACTIONS(3175),
    [anon_sym_false] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_DASH] = ACTIONS(3175),
    [anon_sym_STAR] = ACTIONS(3177),
    [anon_sym_CARET] = ACTIONS(3177),
    [anon_sym_AMP] = ACTIONS(3177),
    [anon_sym_this] = ACTIONS(3175),
    [anon_sym_scoped] = ACTIONS(3175),
    [anon_sym_base] = ACTIONS(3175),
    [anon_sym_var] = ACTIONS(3175),
    [sym_predefined_type] = ACTIONS(3175),
    [anon_sym_break] = ACTIONS(3175),
    [anon_sym_unchecked] = ACTIONS(3175),
    [anon_sym_continue] = ACTIONS(3175),
    [anon_sym_do] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_lock] = ACTIONS(3175),
    [anon_sym_yield] = ACTIONS(3175),
    [anon_sym_switch] = ACTIONS(3175),
    [anon_sym_case] = ACTIONS(3175),
    [anon_sym_default] = ACTIONS(3175),
    [anon_sym_throw] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_when] = ACTIONS(3175),
    [anon_sym_await] = ACTIONS(3175),
    [anon_sym_foreach] = ACTIONS(3175),
    [anon_sym_goto] = ACTIONS(3175),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_DOT_DOT] = ACTIONS(3177),
    [anon_sym_from] = ACTIONS(3175),
    [anon_sym_into] = ACTIONS(3175),
    [anon_sym_join] = ACTIONS(3175),
    [anon_sym_on] = ACTIONS(3175),
    [anon_sym_equals] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_orderby] = ACTIONS(3175),
    [anon_sym_ascending] = ACTIONS(3175),
    [anon_sym_descending] = ACTIONS(3175),
    [anon_sym_group] = ACTIONS(3175),
    [anon_sym_by] = ACTIONS(3175),
    [anon_sym_select] = ACTIONS(3175),
    [anon_sym_DQUOTE] = ACTIONS(3177),
    [anon_sym_stackalloc] = ACTIONS(3175),
    [anon_sym_sizeof] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3175),
    [anon_sym___makeref] = ACTIONS(3175),
    [anon_sym___reftype] = ACTIONS(3175),
    [anon_sym___refvalue] = ACTIONS(3175),
    [sym_null_literal] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [sym_integer_literal] = ACTIONS(3175),
    [sym_real_literal] = ACTIONS(3177),
    [sym_verbatim_string_literal] = ACTIONS(3177),
    [aux_sym_preproc_if_token1] = ACTIONS(3177),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3177),
    [sym_interpolation_verbatim_start] = ACTIONS(3177),
    [sym_interpolation_raw_start] = ACTIONS(3177),
    [sym_raw_string_start] = ACTIONS(3177),
  },
  [2684] = {
    [sym_preproc_region] = STATE(2684),
    [sym_preproc_endregion] = STATE(2684),
    [sym_preproc_line] = STATE(2684),
    [sym_preproc_pragma] = STATE(2684),
    [sym_preproc_nullable] = STATE(2684),
    [sym_preproc_error] = STATE(2684),
    [sym_preproc_define] = STATE(2684),
    [sym_preproc_undef] = STATE(2684),
    [sym__identifier_token] = ACTIONS(3325),
    [anon_sym_extern] = ACTIONS(3325),
    [anon_sym_alias] = ACTIONS(3325),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym_global] = ACTIONS(3325),
    [anon_sym_using] = ACTIONS(3325),
    [anon_sym_unsafe] = ACTIONS(3325),
    [anon_sym_static] = ACTIONS(3325),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_return] = ACTIONS(3325),
    [anon_sym_ref] = ACTIONS(3325),
    [anon_sym_LBRACE] = ACTIONS(3327),
    [anon_sym_RBRACE] = ACTIONS(3327),
    [anon_sym_delegate] = ACTIONS(3325),
    [anon_sym_abstract] = ACTIONS(3325),
    [anon_sym_async] = ACTIONS(3325),
    [anon_sym_const] = ACTIONS(3325),
    [anon_sym_file] = ACTIONS(3325),
    [anon_sym_fixed] = ACTIONS(3325),
    [anon_sym_internal] = ACTIONS(3325),
    [anon_sym_new] = ACTIONS(3325),
    [anon_sym_override] = ACTIONS(3325),
    [anon_sym_partial] = ACTIONS(3325),
    [anon_sym_private] = ACTIONS(3325),
    [anon_sym_protected] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3325),
    [anon_sym_readonly] = ACTIONS(3325),
    [anon_sym_required] = ACTIONS(3325),
    [anon_sym_sealed] = ACTIONS(3325),
    [anon_sym_virtual] = ACTIONS(3325),
    [anon_sym_volatile] = ACTIONS(3325),
    [anon_sym_where] = ACTIONS(3325),
    [anon_sym_notnull] = ACTIONS(3325),
    [anon_sym_unmanaged] = ACTIONS(3325),
    [anon_sym_checked] = ACTIONS(3325),
    [anon_sym_BANG] = ACTIONS(3327),
    [anon_sym_TILDE] = ACTIONS(3327),
    [anon_sym_PLUS_PLUS] = ACTIONS(3327),
    [anon_sym_DASH_DASH] = ACTIONS(3327),
    [anon_sym_true] = ACTIONS(3325),
    [anon_sym_false] = ACTIONS(3325),
    [anon_sym_PLUS] = ACTIONS(3325),
    [anon_sym_DASH] = ACTIONS(3325),
    [anon_sym_STAR] = ACTIONS(3327),
    [anon_sym_CARET] = ACTIONS(3327),
    [anon_sym_AMP] = ACTIONS(3327),
    [anon_sym_this] = ACTIONS(3325),
    [anon_sym_scoped] = ACTIONS(3325),
    [anon_sym_base] = ACTIONS(3325),
    [anon_sym_var] = ACTIONS(3325),
    [sym_predefined_type] = ACTIONS(3325),
    [anon_sym_break] = ACTIONS(3325),
    [anon_sym_unchecked] = ACTIONS(3325),
    [anon_sym_continue] = ACTIONS(3325),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_while] = ACTIONS(3325),
    [anon_sym_for] = ACTIONS(3325),
    [anon_sym_lock] = ACTIONS(3325),
    [anon_sym_yield] = ACTIONS(3325),
    [anon_sym_switch] = ACTIONS(3325),
    [anon_sym_case] = ACTIONS(3325),
    [anon_sym_default] = ACTIONS(3325),
    [anon_sym_throw] = ACTIONS(3325),
    [anon_sym_try] = ACTIONS(3325),
    [anon_sym_when] = ACTIONS(3325),
    [anon_sym_await] = ACTIONS(3325),
    [anon_sym_foreach] = ACTIONS(3325),
    [anon_sym_goto] = ACTIONS(3325),
    [anon_sym_if] = ACTIONS(3325),
    [anon_sym_else] = ACTIONS(3325),
    [anon_sym_DOT_DOT] = ACTIONS(3327),
    [anon_sym_from] = ACTIONS(3325),
    [anon_sym_into] = ACTIONS(3325),
    [anon_sym_join] = ACTIONS(3325),
    [anon_sym_on] = ACTIONS(3325),
    [anon_sym_equals] = ACTIONS(3325),
    [anon_sym_let] = ACTIONS(3325),
    [anon_sym_orderby] = ACTIONS(3325),
    [anon_sym_ascending] = ACTIONS(3325),
    [anon_sym_descending] = ACTIONS(3325),
    [anon_sym_group] = ACTIONS(3325),
    [anon_sym_by] = ACTIONS(3325),
    [anon_sym_select] = ACTIONS(3325),
    [anon_sym_DQUOTE] = ACTIONS(3327),
    [anon_sym_stackalloc] = ACTIONS(3325),
    [anon_sym_sizeof] = ACTIONS(3325),
    [anon_sym_typeof] = ACTIONS(3325),
    [anon_sym___makeref] = ACTIONS(3325),
    [anon_sym___reftype] = ACTIONS(3325),
    [anon_sym___refvalue] = ACTIONS(3325),
    [sym_null_literal] = ACTIONS(3325),
    [anon_sym_SQUOTE] = ACTIONS(3327),
    [sym_integer_literal] = ACTIONS(3325),
    [sym_real_literal] = ACTIONS(3327),
    [sym_verbatim_string_literal] = ACTIONS(3327),
    [aux_sym_preproc_if_token1] = ACTIONS(3327),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3327),
    [sym_interpolation_verbatim_start] = ACTIONS(3327),
    [sym_interpolation_raw_start] = ACTIONS(3327),
    [sym_raw_string_start] = ACTIONS(3327),
  },
  [2685] = {
    [sym_preproc_region] = STATE(2685),
    [sym_preproc_endregion] = STATE(2685),
    [sym_preproc_line] = STATE(2685),
    [sym_preproc_pragma] = STATE(2685),
    [sym_preproc_nullable] = STATE(2685),
    [sym_preproc_error] = STATE(2685),
    [sym_preproc_define] = STATE(2685),
    [sym_preproc_undef] = STATE(2685),
    [sym__identifier_token] = ACTIONS(3171),
    [anon_sym_extern] = ACTIONS(3171),
    [anon_sym_alias] = ACTIONS(3171),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_global] = ACTIONS(3171),
    [anon_sym_using] = ACTIONS(3171),
    [anon_sym_unsafe] = ACTIONS(3171),
    [anon_sym_static] = ACTIONS(3171),
    [anon_sym_LBRACK] = ACTIONS(3173),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_ref] = ACTIONS(3171),
    [anon_sym_LBRACE] = ACTIONS(3173),
    [anon_sym_RBRACE] = ACTIONS(3173),
    [anon_sym_delegate] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_async] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_file] = ACTIONS(3171),
    [anon_sym_fixed] = ACTIONS(3171),
    [anon_sym_internal] = ACTIONS(3171),
    [anon_sym_new] = ACTIONS(3171),
    [anon_sym_override] = ACTIONS(3171),
    [anon_sym_partial] = ACTIONS(3171),
    [anon_sym_private] = ACTIONS(3171),
    [anon_sym_protected] = ACTIONS(3171),
    [anon_sym_public] = ACTIONS(3171),
    [anon_sym_readonly] = ACTIONS(3171),
    [anon_sym_required] = ACTIONS(3171),
    [anon_sym_sealed] = ACTIONS(3171),
    [anon_sym_virtual] = ACTIONS(3171),
    [anon_sym_volatile] = ACTIONS(3171),
    [anon_sym_where] = ACTIONS(3171),
    [anon_sym_notnull] = ACTIONS(3171),
    [anon_sym_unmanaged] = ACTIONS(3171),
    [anon_sym_checked] = ACTIONS(3171),
    [anon_sym_BANG] = ACTIONS(3173),
    [anon_sym_TILDE] = ACTIONS(3173),
    [anon_sym_PLUS_PLUS] = ACTIONS(3173),
    [anon_sym_DASH_DASH] = ACTIONS(3173),
    [anon_sym_true] = ACTIONS(3171),
    [anon_sym_false] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_DASH] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_CARET] = ACTIONS(3173),
    [anon_sym_AMP] = ACTIONS(3173),
    [anon_sym_this] = ACTIONS(3171),
    [anon_sym_scoped] = ACTIONS(3171),
    [anon_sym_base] = ACTIONS(3171),
    [anon_sym_var] = ACTIONS(3171),
    [sym_predefined_type] = ACTIONS(3171),
    [anon_sym_break] = ACTIONS(3171),
    [anon_sym_unchecked] = ACTIONS(3171),
    [anon_sym_continue] = ACTIONS(3171),
    [anon_sym_do] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_lock] = ACTIONS(3171),
    [anon_sym_yield] = ACTIONS(3171),
    [anon_sym_switch] = ACTIONS(3171),
    [anon_sym_case] = ACTIONS(3171),
    [anon_sym_default] = ACTIONS(3171),
    [anon_sym_throw] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_when] = ACTIONS(3171),
    [anon_sym_await] = ACTIONS(3171),
    [anon_sym_foreach] = ACTIONS(3171),
    [anon_sym_goto] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_else] = ACTIONS(3171),
    [anon_sym_DOT_DOT] = ACTIONS(3173),
    [anon_sym_from] = ACTIONS(3171),
    [anon_sym_into] = ACTIONS(3171),
    [anon_sym_join] = ACTIONS(3171),
    [anon_sym_on] = ACTIONS(3171),
    [anon_sym_equals] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_orderby] = ACTIONS(3171),
    [anon_sym_ascending] = ACTIONS(3171),
    [anon_sym_descending] = ACTIONS(3171),
    [anon_sym_group] = ACTIONS(3171),
    [anon_sym_by] = ACTIONS(3171),
    [anon_sym_select] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [anon_sym_stackalloc] = ACTIONS(3171),
    [anon_sym_sizeof] = ACTIONS(3171),
    [anon_sym_typeof] = ACTIONS(3171),
    [anon_sym___makeref] = ACTIONS(3171),
    [anon_sym___reftype] = ACTIONS(3171),
    [anon_sym___refvalue] = ACTIONS(3171),
    [sym_null_literal] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3173),
    [sym_integer_literal] = ACTIONS(3171),
    [sym_real_literal] = ACTIONS(3173),
    [sym_verbatim_string_literal] = ACTIONS(3173),
    [aux_sym_preproc_if_token1] = ACTIONS(3173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3173),
    [sym_interpolation_verbatim_start] = ACTIONS(3173),
    [sym_interpolation_raw_start] = ACTIONS(3173),
    [sym_raw_string_start] = ACTIONS(3173),
  },
  [2686] = {
    [sym_preproc_region] = STATE(2686),
    [sym_preproc_endregion] = STATE(2686),
    [sym_preproc_line] = STATE(2686),
    [sym_preproc_pragma] = STATE(2686),
    [sym_preproc_nullable] = STATE(2686),
    [sym_preproc_error] = STATE(2686),
    [sym_preproc_define] = STATE(2686),
    [sym_preproc_undef] = STATE(2686),
    [sym__identifier_token] = ACTIONS(3353),
    [anon_sym_extern] = ACTIONS(3353),
    [anon_sym_alias] = ACTIONS(3353),
    [anon_sym_SEMI] = ACTIONS(3355),
    [anon_sym_global] = ACTIONS(3353),
    [anon_sym_using] = ACTIONS(3353),
    [anon_sym_unsafe] = ACTIONS(3353),
    [anon_sym_static] = ACTIONS(3353),
    [anon_sym_LBRACK] = ACTIONS(3355),
    [anon_sym_LPAREN] = ACTIONS(3355),
    [anon_sym_return] = ACTIONS(3353),
    [anon_sym_ref] = ACTIONS(3353),
    [anon_sym_LBRACE] = ACTIONS(3355),
    [anon_sym_RBRACE] = ACTIONS(3355),
    [anon_sym_delegate] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3353),
    [anon_sym_async] = ACTIONS(3353),
    [anon_sym_const] = ACTIONS(3353),
    [anon_sym_file] = ACTIONS(3353),
    [anon_sym_fixed] = ACTIONS(3353),
    [anon_sym_internal] = ACTIONS(3353),
    [anon_sym_new] = ACTIONS(3353),
    [anon_sym_override] = ACTIONS(3353),
    [anon_sym_partial] = ACTIONS(3353),
    [anon_sym_private] = ACTIONS(3353),
    [anon_sym_protected] = ACTIONS(3353),
    [anon_sym_public] = ACTIONS(3353),
    [anon_sym_readonly] = ACTIONS(3353),
    [anon_sym_required] = ACTIONS(3353),
    [anon_sym_sealed] = ACTIONS(3353),
    [anon_sym_virtual] = ACTIONS(3353),
    [anon_sym_volatile] = ACTIONS(3353),
    [anon_sym_where] = ACTIONS(3353),
    [anon_sym_notnull] = ACTIONS(3353),
    [anon_sym_unmanaged] = ACTIONS(3353),
    [anon_sym_checked] = ACTIONS(3353),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_TILDE] = ACTIONS(3355),
    [anon_sym_PLUS_PLUS] = ACTIONS(3355),
    [anon_sym_DASH_DASH] = ACTIONS(3355),
    [anon_sym_true] = ACTIONS(3353),
    [anon_sym_false] = ACTIONS(3353),
    [anon_sym_PLUS] = ACTIONS(3353),
    [anon_sym_DASH] = ACTIONS(3353),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_CARET] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_this] = ACTIONS(3353),
    [anon_sym_scoped] = ACTIONS(3353),
    [anon_sym_base] = ACTIONS(3353),
    [anon_sym_var] = ACTIONS(3353),
    [sym_predefined_type] = ACTIONS(3353),
    [anon_sym_break] = ACTIONS(3353),
    [anon_sym_unchecked] = ACTIONS(3353),
    [anon_sym_continue] = ACTIONS(3353),
    [anon_sym_do] = ACTIONS(3353),
    [anon_sym_while] = ACTIONS(3353),
    [anon_sym_for] = ACTIONS(3353),
    [anon_sym_lock] = ACTIONS(3353),
    [anon_sym_yield] = ACTIONS(3353),
    [anon_sym_switch] = ACTIONS(3353),
    [anon_sym_case] = ACTIONS(3353),
    [anon_sym_default] = ACTIONS(3353),
    [anon_sym_throw] = ACTIONS(3353),
    [anon_sym_try] = ACTIONS(3353),
    [anon_sym_when] = ACTIONS(3353),
    [anon_sym_await] = ACTIONS(3353),
    [anon_sym_foreach] = ACTIONS(3353),
    [anon_sym_goto] = ACTIONS(3353),
    [anon_sym_if] = ACTIONS(3353),
    [anon_sym_else] = ACTIONS(3353),
    [anon_sym_DOT_DOT] = ACTIONS(3355),
    [anon_sym_from] = ACTIONS(3353),
    [anon_sym_into] = ACTIONS(3353),
    [anon_sym_join] = ACTIONS(3353),
    [anon_sym_on] = ACTIONS(3353),
    [anon_sym_equals] = ACTIONS(3353),
    [anon_sym_let] = ACTIONS(3353),
    [anon_sym_orderby] = ACTIONS(3353),
    [anon_sym_ascending] = ACTIONS(3353),
    [anon_sym_descending] = ACTIONS(3353),
    [anon_sym_group] = ACTIONS(3353),
    [anon_sym_by] = ACTIONS(3353),
    [anon_sym_select] = ACTIONS(3353),
    [anon_sym_DQUOTE] = ACTIONS(3355),
    [anon_sym_stackalloc] = ACTIONS(3353),
    [anon_sym_sizeof] = ACTIONS(3353),
    [anon_sym_typeof] = ACTIONS(3353),
    [anon_sym___makeref] = ACTIONS(3353),
    [anon_sym___reftype] = ACTIONS(3353),
    [anon_sym___refvalue] = ACTIONS(3353),
    [sym_null_literal] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(3355),
    [sym_integer_literal] = ACTIONS(3353),
    [sym_real_literal] = ACTIONS(3355),
    [sym_verbatim_string_literal] = ACTIONS(3355),
    [aux_sym_preproc_if_token1] = ACTIONS(3355),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3355),
    [sym_interpolation_verbatim_start] = ACTIONS(3355),
    [sym_interpolation_raw_start] = ACTIONS(3355),
    [sym_raw_string_start] = ACTIONS(3355),
  },
  [2687] = {
    [sym_preproc_region] = STATE(2687),
    [sym_preproc_endregion] = STATE(2687),
    [sym_preproc_line] = STATE(2687),
    [sym_preproc_pragma] = STATE(2687),
    [sym_preproc_nullable] = STATE(2687),
    [sym_preproc_error] = STATE(2687),
    [sym_preproc_define] = STATE(2687),
    [sym_preproc_undef] = STATE(2687),
    [sym__identifier_token] = ACTIONS(3369),
    [anon_sym_extern] = ACTIONS(3369),
    [anon_sym_alias] = ACTIONS(3369),
    [anon_sym_SEMI] = ACTIONS(3371),
    [anon_sym_global] = ACTIONS(3369),
    [anon_sym_using] = ACTIONS(3369),
    [anon_sym_unsafe] = ACTIONS(3369),
    [anon_sym_static] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3371),
    [anon_sym_LPAREN] = ACTIONS(3371),
    [anon_sym_return] = ACTIONS(3369),
    [anon_sym_ref] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3371),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_delegate] = ACTIONS(3369),
    [anon_sym_abstract] = ACTIONS(3369),
    [anon_sym_async] = ACTIONS(3369),
    [anon_sym_const] = ACTIONS(3369),
    [anon_sym_file] = ACTIONS(3369),
    [anon_sym_fixed] = ACTIONS(3369),
    [anon_sym_internal] = ACTIONS(3369),
    [anon_sym_new] = ACTIONS(3369),
    [anon_sym_override] = ACTIONS(3369),
    [anon_sym_partial] = ACTIONS(3369),
    [anon_sym_private] = ACTIONS(3369),
    [anon_sym_protected] = ACTIONS(3369),
    [anon_sym_public] = ACTIONS(3369),
    [anon_sym_readonly] = ACTIONS(3369),
    [anon_sym_required] = ACTIONS(3369),
    [anon_sym_sealed] = ACTIONS(3369),
    [anon_sym_virtual] = ACTIONS(3369),
    [anon_sym_volatile] = ACTIONS(3369),
    [anon_sym_where] = ACTIONS(3369),
    [anon_sym_notnull] = ACTIONS(3369),
    [anon_sym_unmanaged] = ACTIONS(3369),
    [anon_sym_checked] = ACTIONS(3369),
    [anon_sym_BANG] = ACTIONS(3371),
    [anon_sym_TILDE] = ACTIONS(3371),
    [anon_sym_PLUS_PLUS] = ACTIONS(3371),
    [anon_sym_DASH_DASH] = ACTIONS(3371),
    [anon_sym_true] = ACTIONS(3369),
    [anon_sym_false] = ACTIONS(3369),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(3371),
    [anon_sym_CARET] = ACTIONS(3371),
    [anon_sym_AMP] = ACTIONS(3371),
    [anon_sym_this] = ACTIONS(3369),
    [anon_sym_scoped] = ACTIONS(3369),
    [anon_sym_base] = ACTIONS(3369),
    [anon_sym_var] = ACTIONS(3369),
    [sym_predefined_type] = ACTIONS(3369),
    [anon_sym_break] = ACTIONS(3369),
    [anon_sym_unchecked] = ACTIONS(3369),
    [anon_sym_continue] = ACTIONS(3369),
    [anon_sym_do] = ACTIONS(3369),
    [anon_sym_while] = ACTIONS(3369),
    [anon_sym_for] = ACTIONS(3369),
    [anon_sym_lock] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(3369),
    [anon_sym_switch] = ACTIONS(3369),
    [anon_sym_case] = ACTIONS(3369),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_throw] = ACTIONS(3369),
    [anon_sym_try] = ACTIONS(3369),
    [anon_sym_when] = ACTIONS(3369),
    [anon_sym_await] = ACTIONS(3369),
    [anon_sym_foreach] = ACTIONS(3369),
    [anon_sym_goto] = ACTIONS(3369),
    [anon_sym_if] = ACTIONS(3369),
    [anon_sym_else] = ACTIONS(3369),
    [anon_sym_DOT_DOT] = ACTIONS(3371),
    [anon_sym_from] = ACTIONS(3369),
    [anon_sym_into] = ACTIONS(3369),
    [anon_sym_join] = ACTIONS(3369),
    [anon_sym_on] = ACTIONS(3369),
    [anon_sym_equals] = ACTIONS(3369),
    [anon_sym_let] = ACTIONS(3369),
    [anon_sym_orderby] = ACTIONS(3369),
    [anon_sym_ascending] = ACTIONS(3369),
    [anon_sym_descending] = ACTIONS(3369),
    [anon_sym_group] = ACTIONS(3369),
    [anon_sym_by] = ACTIONS(3369),
    [anon_sym_select] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(3371),
    [anon_sym_stackalloc] = ACTIONS(3369),
    [anon_sym_sizeof] = ACTIONS(3369),
    [anon_sym_typeof] = ACTIONS(3369),
    [anon_sym___makeref] = ACTIONS(3369),
    [anon_sym___reftype] = ACTIONS(3369),
    [anon_sym___refvalue] = ACTIONS(3369),
    [sym_null_literal] = ACTIONS(3369),
    [anon_sym_SQUOTE] = ACTIONS(3371),
    [sym_integer_literal] = ACTIONS(3369),
    [sym_real_literal] = ACTIONS(3371),
    [sym_verbatim_string_literal] = ACTIONS(3371),
    [aux_sym_preproc_if_token1] = ACTIONS(3371),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3371),
    [sym_interpolation_verbatim_start] = ACTIONS(3371),
    [sym_interpolation_raw_start] = ACTIONS(3371),
    [sym_raw_string_start] = ACTIONS(3371),
  },
  [2688] = {
    [sym_preproc_region] = STATE(2688),
    [sym_preproc_endregion] = STATE(2688),
    [sym_preproc_line] = STATE(2688),
    [sym_preproc_pragma] = STATE(2688),
    [sym_preproc_nullable] = STATE(2688),
    [sym_preproc_error] = STATE(2688),
    [sym_preproc_define] = STATE(2688),
    [sym_preproc_undef] = STATE(2688),
    [sym__identifier_token] = ACTIONS(3349),
    [anon_sym_extern] = ACTIONS(3349),
    [anon_sym_alias] = ACTIONS(3349),
    [anon_sym_SEMI] = ACTIONS(3351),
    [anon_sym_global] = ACTIONS(3349),
    [anon_sym_using] = ACTIONS(3349),
    [anon_sym_unsafe] = ACTIONS(3349),
    [anon_sym_static] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(3351),
    [anon_sym_LPAREN] = ACTIONS(3351),
    [anon_sym_return] = ACTIONS(3349),
    [anon_sym_ref] = ACTIONS(3349),
    [anon_sym_LBRACE] = ACTIONS(3351),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_delegate] = ACTIONS(3349),
    [anon_sym_abstract] = ACTIONS(3349),
    [anon_sym_async] = ACTIONS(3349),
    [anon_sym_const] = ACTIONS(3349),
    [anon_sym_file] = ACTIONS(3349),
    [anon_sym_fixed] = ACTIONS(3349),
    [anon_sym_internal] = ACTIONS(3349),
    [anon_sym_new] = ACTIONS(3349),
    [anon_sym_override] = ACTIONS(3349),
    [anon_sym_partial] = ACTIONS(3349),
    [anon_sym_private] = ACTIONS(3349),
    [anon_sym_protected] = ACTIONS(3349),
    [anon_sym_public] = ACTIONS(3349),
    [anon_sym_readonly] = ACTIONS(3349),
    [anon_sym_required] = ACTIONS(3349),
    [anon_sym_sealed] = ACTIONS(3349),
    [anon_sym_virtual] = ACTIONS(3349),
    [anon_sym_volatile] = ACTIONS(3349),
    [anon_sym_where] = ACTIONS(3349),
    [anon_sym_notnull] = ACTIONS(3349),
    [anon_sym_unmanaged] = ACTIONS(3349),
    [anon_sym_checked] = ACTIONS(3349),
    [anon_sym_BANG] = ACTIONS(3351),
    [anon_sym_TILDE] = ACTIONS(3351),
    [anon_sym_PLUS_PLUS] = ACTIONS(3351),
    [anon_sym_DASH_DASH] = ACTIONS(3351),
    [anon_sym_true] = ACTIONS(3349),
    [anon_sym_false] = ACTIONS(3349),
    [anon_sym_PLUS] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_STAR] = ACTIONS(3351),
    [anon_sym_CARET] = ACTIONS(3351),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_this] = ACTIONS(3349),
    [anon_sym_scoped] = ACTIONS(3349),
    [anon_sym_base] = ACTIONS(3349),
    [anon_sym_var] = ACTIONS(3349),
    [sym_predefined_type] = ACTIONS(3349),
    [anon_sym_break] = ACTIONS(3349),
    [anon_sym_unchecked] = ACTIONS(3349),
    [anon_sym_continue] = ACTIONS(3349),
    [anon_sym_do] = ACTIONS(3349),
    [anon_sym_while] = ACTIONS(3349),
    [anon_sym_for] = ACTIONS(3349),
    [anon_sym_lock] = ACTIONS(3349),
    [anon_sym_yield] = ACTIONS(3349),
    [anon_sym_switch] = ACTIONS(3349),
    [anon_sym_case] = ACTIONS(3349),
    [anon_sym_default] = ACTIONS(3349),
    [anon_sym_throw] = ACTIONS(3349),
    [anon_sym_try] = ACTIONS(3349),
    [anon_sym_when] = ACTIONS(3349),
    [anon_sym_await] = ACTIONS(3349),
    [anon_sym_foreach] = ACTIONS(3349),
    [anon_sym_goto] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(3349),
    [anon_sym_else] = ACTIONS(3349),
    [anon_sym_DOT_DOT] = ACTIONS(3351),
    [anon_sym_from] = ACTIONS(3349),
    [anon_sym_into] = ACTIONS(3349),
    [anon_sym_join] = ACTIONS(3349),
    [anon_sym_on] = ACTIONS(3349),
    [anon_sym_equals] = ACTIONS(3349),
    [anon_sym_let] = ACTIONS(3349),
    [anon_sym_orderby] = ACTIONS(3349),
    [anon_sym_ascending] = ACTIONS(3349),
    [anon_sym_descending] = ACTIONS(3349),
    [anon_sym_group] = ACTIONS(3349),
    [anon_sym_by] = ACTIONS(3349),
    [anon_sym_select] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(3351),
    [anon_sym_stackalloc] = ACTIONS(3349),
    [anon_sym_sizeof] = ACTIONS(3349),
    [anon_sym_typeof] = ACTIONS(3349),
    [anon_sym___makeref] = ACTIONS(3349),
    [anon_sym___reftype] = ACTIONS(3349),
    [anon_sym___refvalue] = ACTIONS(3349),
    [sym_null_literal] = ACTIONS(3349),
    [anon_sym_SQUOTE] = ACTIONS(3351),
    [sym_integer_literal] = ACTIONS(3349),
    [sym_real_literal] = ACTIONS(3351),
    [sym_verbatim_string_literal] = ACTIONS(3351),
    [aux_sym_preproc_if_token1] = ACTIONS(3351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3351),
    [sym_interpolation_verbatim_start] = ACTIONS(3351),
    [sym_interpolation_raw_start] = ACTIONS(3351),
    [sym_raw_string_start] = ACTIONS(3351),
  },
  [2689] = {
    [sym_preproc_region] = STATE(2689),
    [sym_preproc_endregion] = STATE(2689),
    [sym_preproc_line] = STATE(2689),
    [sym_preproc_pragma] = STATE(2689),
    [sym_preproc_nullable] = STATE(2689),
    [sym_preproc_error] = STATE(2689),
    [sym_preproc_define] = STATE(2689),
    [sym_preproc_undef] = STATE(2689),
    [sym__identifier_token] = ACTIONS(3107),
    [anon_sym_extern] = ACTIONS(3107),
    [anon_sym_alias] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_global] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_unsafe] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_ref] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_delegate] = ACTIONS(3107),
    [anon_sym_abstract] = ACTIONS(3107),
    [anon_sym_async] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_file] = ACTIONS(3107),
    [anon_sym_fixed] = ACTIONS(3107),
    [anon_sym_internal] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_override] = ACTIONS(3107),
    [anon_sym_partial] = ACTIONS(3107),
    [anon_sym_private] = ACTIONS(3107),
    [anon_sym_protected] = ACTIONS(3107),
    [anon_sym_public] = ACTIONS(3107),
    [anon_sym_readonly] = ACTIONS(3107),
    [anon_sym_required] = ACTIONS(3107),
    [anon_sym_sealed] = ACTIONS(3107),
    [anon_sym_virtual] = ACTIONS(3107),
    [anon_sym_volatile] = ACTIONS(3107),
    [anon_sym_where] = ACTIONS(3107),
    [anon_sym_notnull] = ACTIONS(3107),
    [anon_sym_unmanaged] = ACTIONS(3107),
    [anon_sym_checked] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_true] = ACTIONS(3107),
    [anon_sym_false] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_this] = ACTIONS(3107),
    [anon_sym_scoped] = ACTIONS(3107),
    [anon_sym_base] = ACTIONS(3107),
    [anon_sym_var] = ACTIONS(3107),
    [sym_predefined_type] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_unchecked] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_lock] = ACTIONS(3107),
    [anon_sym_yield] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_when] = ACTIONS(3107),
    [anon_sym_await] = ACTIONS(3107),
    [anon_sym_foreach] = ACTIONS(3107),
    [anon_sym_goto] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_else] = ACTIONS(3107),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_from] = ACTIONS(3107),
    [anon_sym_into] = ACTIONS(3107),
    [anon_sym_join] = ACTIONS(3107),
    [anon_sym_on] = ACTIONS(3107),
    [anon_sym_equals] = ACTIONS(3107),
    [anon_sym_let] = ACTIONS(3107),
    [anon_sym_orderby] = ACTIONS(3107),
    [anon_sym_ascending] = ACTIONS(3107),
    [anon_sym_descending] = ACTIONS(3107),
    [anon_sym_group] = ACTIONS(3107),
    [anon_sym_by] = ACTIONS(3107),
    [anon_sym_select] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [anon_sym_stackalloc] = ACTIONS(3107),
    [anon_sym_sizeof] = ACTIONS(3107),
    [anon_sym_typeof] = ACTIONS(3107),
    [anon_sym___makeref] = ACTIONS(3107),
    [anon_sym___reftype] = ACTIONS(3107),
    [anon_sym___refvalue] = ACTIONS(3107),
    [sym_null_literal] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [sym_integer_literal] = ACTIONS(3107),
    [sym_real_literal] = ACTIONS(3109),
    [sym_verbatim_string_literal] = ACTIONS(3109),
    [aux_sym_preproc_if_token1] = ACTIONS(3109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3109),
    [sym_interpolation_verbatim_start] = ACTIONS(3109),
    [sym_interpolation_raw_start] = ACTIONS(3109),
    [sym_raw_string_start] = ACTIONS(3109),
  },
  [2690] = {
    [sym_preproc_region] = STATE(2690),
    [sym_preproc_endregion] = STATE(2690),
    [sym_preproc_line] = STATE(2690),
    [sym_preproc_pragma] = STATE(2690),
    [sym_preproc_nullable] = STATE(2690),
    [sym_preproc_error] = STATE(2690),
    [sym_preproc_define] = STATE(2690),
    [sym_preproc_undef] = STATE(2690),
    [sym__identifier_token] = ACTIONS(3095),
    [anon_sym_extern] = ACTIONS(3095),
    [anon_sym_alias] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_using] = ACTIONS(3095),
    [anon_sym_unsafe] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_ref] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_delegate] = ACTIONS(3095),
    [anon_sym_abstract] = ACTIONS(3095),
    [anon_sym_async] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_file] = ACTIONS(3095),
    [anon_sym_fixed] = ACTIONS(3095),
    [anon_sym_internal] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_override] = ACTIONS(3095),
    [anon_sym_partial] = ACTIONS(3095),
    [anon_sym_private] = ACTIONS(3095),
    [anon_sym_protected] = ACTIONS(3095),
    [anon_sym_public] = ACTIONS(3095),
    [anon_sym_readonly] = ACTIONS(3095),
    [anon_sym_required] = ACTIONS(3095),
    [anon_sym_sealed] = ACTIONS(3095),
    [anon_sym_virtual] = ACTIONS(3095),
    [anon_sym_volatile] = ACTIONS(3095),
    [anon_sym_where] = ACTIONS(3095),
    [anon_sym_notnull] = ACTIONS(3095),
    [anon_sym_unmanaged] = ACTIONS(3095),
    [anon_sym_checked] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_true] = ACTIONS(3095),
    [anon_sym_false] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_this] = ACTIONS(3095),
    [anon_sym_scoped] = ACTIONS(3095),
    [anon_sym_base] = ACTIONS(3095),
    [anon_sym_var] = ACTIONS(3095),
    [sym_predefined_type] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_unchecked] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_lock] = ACTIONS(3095),
    [anon_sym_yield] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_case] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_when] = ACTIONS(3095),
    [anon_sym_await] = ACTIONS(3095),
    [anon_sym_foreach] = ACTIONS(3095),
    [anon_sym_goto] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_else] = ACTIONS(3095),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_from] = ACTIONS(3095),
    [anon_sym_into] = ACTIONS(3095),
    [anon_sym_join] = ACTIONS(3095),
    [anon_sym_on] = ACTIONS(3095),
    [anon_sym_equals] = ACTIONS(3095),
    [anon_sym_let] = ACTIONS(3095),
    [anon_sym_orderby] = ACTIONS(3095),
    [anon_sym_ascending] = ACTIONS(3095),
    [anon_sym_descending] = ACTIONS(3095),
    [anon_sym_group] = ACTIONS(3095),
    [anon_sym_by] = ACTIONS(3095),
    [anon_sym_select] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [anon_sym_stackalloc] = ACTIONS(3095),
    [anon_sym_sizeof] = ACTIONS(3095),
    [anon_sym_typeof] = ACTIONS(3095),
    [anon_sym___makeref] = ACTIONS(3095),
    [anon_sym___reftype] = ACTIONS(3095),
    [anon_sym___refvalue] = ACTIONS(3095),
    [sym_null_literal] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [sym_integer_literal] = ACTIONS(3095),
    [sym_real_literal] = ACTIONS(3097),
    [sym_verbatim_string_literal] = ACTIONS(3097),
    [aux_sym_preproc_if_token1] = ACTIONS(3097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3097),
    [sym_interpolation_verbatim_start] = ACTIONS(3097),
    [sym_interpolation_raw_start] = ACTIONS(3097),
    [sym_raw_string_start] = ACTIONS(3097),
  },
  [2691] = {
    [sym_preproc_region] = STATE(2691),
    [sym_preproc_endregion] = STATE(2691),
    [sym_preproc_line] = STATE(2691),
    [sym_preproc_pragma] = STATE(2691),
    [sym_preproc_nullable] = STATE(2691),
    [sym_preproc_error] = STATE(2691),
    [sym_preproc_define] = STATE(2691),
    [sym_preproc_undef] = STATE(2691),
    [sym__identifier_token] = ACTIONS(3047),
    [anon_sym_extern] = ACTIONS(3047),
    [anon_sym_alias] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_global] = ACTIONS(3047),
    [anon_sym_using] = ACTIONS(3047),
    [anon_sym_unsafe] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_ref] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_delegate] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_async] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_file] = ACTIONS(3047),
    [anon_sym_fixed] = ACTIONS(3047),
    [anon_sym_internal] = ACTIONS(3047),
    [anon_sym_new] = ACTIONS(3047),
    [anon_sym_override] = ACTIONS(3047),
    [anon_sym_partial] = ACTIONS(3047),
    [anon_sym_private] = ACTIONS(3047),
    [anon_sym_protected] = ACTIONS(3047),
    [anon_sym_public] = ACTIONS(3047),
    [anon_sym_readonly] = ACTIONS(3047),
    [anon_sym_required] = ACTIONS(3047),
    [anon_sym_sealed] = ACTIONS(3047),
    [anon_sym_virtual] = ACTIONS(3047),
    [anon_sym_volatile] = ACTIONS(3047),
    [anon_sym_where] = ACTIONS(3047),
    [anon_sym_notnull] = ACTIONS(3047),
    [anon_sym_unmanaged] = ACTIONS(3047),
    [anon_sym_checked] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3049),
    [anon_sym_true] = ACTIONS(3047),
    [anon_sym_false] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_this] = ACTIONS(3047),
    [anon_sym_scoped] = ACTIONS(3047),
    [anon_sym_base] = ACTIONS(3047),
    [anon_sym_var] = ACTIONS(3047),
    [sym_predefined_type] = ACTIONS(3047),
    [anon_sym_break] = ACTIONS(3047),
    [anon_sym_unchecked] = ACTIONS(3047),
    [anon_sym_continue] = ACTIONS(3047),
    [anon_sym_do] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_lock] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3047),
    [anon_sym_switch] = ACTIONS(3047),
    [anon_sym_case] = ACTIONS(3047),
    [anon_sym_default] = ACTIONS(3047),
    [anon_sym_throw] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_when] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3047),
    [anon_sym_foreach] = ACTIONS(3047),
    [anon_sym_goto] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_from] = ACTIONS(3047),
    [anon_sym_into] = ACTIONS(3047),
    [anon_sym_join] = ACTIONS(3047),
    [anon_sym_on] = ACTIONS(3047),
    [anon_sym_equals] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_orderby] = ACTIONS(3047),
    [anon_sym_ascending] = ACTIONS(3047),
    [anon_sym_descending] = ACTIONS(3047),
    [anon_sym_group] = ACTIONS(3047),
    [anon_sym_by] = ACTIONS(3047),
    [anon_sym_select] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3049),
    [anon_sym_stackalloc] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3047),
    [anon_sym_typeof] = ACTIONS(3047),
    [anon_sym___makeref] = ACTIONS(3047),
    [anon_sym___reftype] = ACTIONS(3047),
    [anon_sym___refvalue] = ACTIONS(3047),
    [sym_null_literal] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_integer_literal] = ACTIONS(3047),
    [sym_real_literal] = ACTIONS(3049),
    [sym_verbatim_string_literal] = ACTIONS(3049),
    [aux_sym_preproc_if_token1] = ACTIONS(3049),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3049),
    [sym_interpolation_verbatim_start] = ACTIONS(3049),
    [sym_interpolation_raw_start] = ACTIONS(3049),
    [sym_raw_string_start] = ACTIONS(3049),
  },
  [2692] = {
    [sym_preproc_region] = STATE(2692),
    [sym_preproc_endregion] = STATE(2692),
    [sym_preproc_line] = STATE(2692),
    [sym_preproc_pragma] = STATE(2692),
    [sym_preproc_nullable] = STATE(2692),
    [sym_preproc_error] = STATE(2692),
    [sym_preproc_define] = STATE(2692),
    [sym_preproc_undef] = STATE(2692),
    [sym__identifier_token] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym_alias] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_unsafe] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_ref] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_delegate] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_async] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_file] = ACTIONS(3071),
    [anon_sym_fixed] = ACTIONS(3071),
    [anon_sym_internal] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_override] = ACTIONS(3071),
    [anon_sym_partial] = ACTIONS(3071),
    [anon_sym_private] = ACTIONS(3071),
    [anon_sym_protected] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_readonly] = ACTIONS(3071),
    [anon_sym_required] = ACTIONS(3071),
    [anon_sym_sealed] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_notnull] = ACTIONS(3071),
    [anon_sym_unmanaged] = ACTIONS(3071),
    [anon_sym_checked] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_this] = ACTIONS(3071),
    [anon_sym_scoped] = ACTIONS(3071),
    [anon_sym_base] = ACTIONS(3071),
    [anon_sym_var] = ACTIONS(3071),
    [sym_predefined_type] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_unchecked] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_lock] = ACTIONS(3071),
    [anon_sym_yield] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_when] = ACTIONS(3071),
    [anon_sym_await] = ACTIONS(3071),
    [anon_sym_foreach] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_from] = ACTIONS(3071),
    [anon_sym_into] = ACTIONS(3071),
    [anon_sym_join] = ACTIONS(3071),
    [anon_sym_on] = ACTIONS(3071),
    [anon_sym_equals] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_orderby] = ACTIONS(3071),
    [anon_sym_ascending] = ACTIONS(3071),
    [anon_sym_descending] = ACTIONS(3071),
    [anon_sym_group] = ACTIONS(3071),
    [anon_sym_by] = ACTIONS(3071),
    [anon_sym_select] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [anon_sym_stackalloc] = ACTIONS(3071),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym_typeof] = ACTIONS(3071),
    [anon_sym___makeref] = ACTIONS(3071),
    [anon_sym___reftype] = ACTIONS(3071),
    [anon_sym___refvalue] = ACTIONS(3071),
    [sym_null_literal] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [sym_integer_literal] = ACTIONS(3071),
    [sym_real_literal] = ACTIONS(3073),
    [sym_verbatim_string_literal] = ACTIONS(3073),
    [aux_sym_preproc_if_token1] = ACTIONS(3073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3073),
    [sym_interpolation_verbatim_start] = ACTIONS(3073),
    [sym_interpolation_raw_start] = ACTIONS(3073),
    [sym_raw_string_start] = ACTIONS(3073),
  },
  [2693] = {
    [sym_preproc_region] = STATE(2693),
    [sym_preproc_endregion] = STATE(2693),
    [sym_preproc_line] = STATE(2693),
    [sym_preproc_pragma] = STATE(2693),
    [sym_preproc_nullable] = STATE(2693),
    [sym_preproc_error] = STATE(2693),
    [sym_preproc_define] = STATE(2693),
    [sym_preproc_undef] = STATE(2693),
    [sym__identifier_token] = ACTIONS(3333),
    [anon_sym_extern] = ACTIONS(3333),
    [anon_sym_alias] = ACTIONS(3333),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym_global] = ACTIONS(3333),
    [anon_sym_using] = ACTIONS(3333),
    [anon_sym_unsafe] = ACTIONS(3333),
    [anon_sym_static] = ACTIONS(3333),
    [anon_sym_LBRACK] = ACTIONS(3335),
    [anon_sym_LPAREN] = ACTIONS(3335),
    [anon_sym_return] = ACTIONS(3333),
    [anon_sym_ref] = ACTIONS(3333),
    [anon_sym_LBRACE] = ACTIONS(3335),
    [anon_sym_RBRACE] = ACTIONS(3335),
    [anon_sym_delegate] = ACTIONS(3333),
    [anon_sym_abstract] = ACTIONS(3333),
    [anon_sym_async] = ACTIONS(3333),
    [anon_sym_const] = ACTIONS(3333),
    [anon_sym_file] = ACTIONS(3333),
    [anon_sym_fixed] = ACTIONS(3333),
    [anon_sym_internal] = ACTIONS(3333),
    [anon_sym_new] = ACTIONS(3333),
    [anon_sym_override] = ACTIONS(3333),
    [anon_sym_partial] = ACTIONS(3333),
    [anon_sym_private] = ACTIONS(3333),
    [anon_sym_protected] = ACTIONS(3333),
    [anon_sym_public] = ACTIONS(3333),
    [anon_sym_readonly] = ACTIONS(3333),
    [anon_sym_required] = ACTIONS(3333),
    [anon_sym_sealed] = ACTIONS(3333),
    [anon_sym_virtual] = ACTIONS(3333),
    [anon_sym_volatile] = ACTIONS(3333),
    [anon_sym_where] = ACTIONS(3333),
    [anon_sym_notnull] = ACTIONS(3333),
    [anon_sym_unmanaged] = ACTIONS(3333),
    [anon_sym_checked] = ACTIONS(3333),
    [anon_sym_BANG] = ACTIONS(3335),
    [anon_sym_TILDE] = ACTIONS(3335),
    [anon_sym_PLUS_PLUS] = ACTIONS(3335),
    [anon_sym_DASH_DASH] = ACTIONS(3335),
    [anon_sym_true] = ACTIONS(3333),
    [anon_sym_false] = ACTIONS(3333),
    [anon_sym_PLUS] = ACTIONS(3333),
    [anon_sym_DASH] = ACTIONS(3333),
    [anon_sym_STAR] = ACTIONS(3335),
    [anon_sym_CARET] = ACTIONS(3335),
    [anon_sym_AMP] = ACTIONS(3335),
    [anon_sym_this] = ACTIONS(3333),
    [anon_sym_scoped] = ACTIONS(3333),
    [anon_sym_base] = ACTIONS(3333),
    [anon_sym_var] = ACTIONS(3333),
    [sym_predefined_type] = ACTIONS(3333),
    [anon_sym_break] = ACTIONS(3333),
    [anon_sym_unchecked] = ACTIONS(3333),
    [anon_sym_continue] = ACTIONS(3333),
    [anon_sym_do] = ACTIONS(3333),
    [anon_sym_while] = ACTIONS(3333),
    [anon_sym_for] = ACTIONS(3333),
    [anon_sym_lock] = ACTIONS(3333),
    [anon_sym_yield] = ACTIONS(3333),
    [anon_sym_switch] = ACTIONS(3333),
    [anon_sym_case] = ACTIONS(3333),
    [anon_sym_default] = ACTIONS(3333),
    [anon_sym_throw] = ACTIONS(3333),
    [anon_sym_try] = ACTIONS(3333),
    [anon_sym_when] = ACTIONS(3333),
    [anon_sym_await] = ACTIONS(3333),
    [anon_sym_foreach] = ACTIONS(3333),
    [anon_sym_goto] = ACTIONS(3333),
    [anon_sym_if] = ACTIONS(3333),
    [anon_sym_else] = ACTIONS(3333),
    [anon_sym_DOT_DOT] = ACTIONS(3335),
    [anon_sym_from] = ACTIONS(3333),
    [anon_sym_into] = ACTIONS(3333),
    [anon_sym_join] = ACTIONS(3333),
    [anon_sym_on] = ACTIONS(3333),
    [anon_sym_equals] = ACTIONS(3333),
    [anon_sym_let] = ACTIONS(3333),
    [anon_sym_orderby] = ACTIONS(3333),
    [anon_sym_ascending] = ACTIONS(3333),
    [anon_sym_descending] = ACTIONS(3333),
    [anon_sym_group] = ACTIONS(3333),
    [anon_sym_by] = ACTIONS(3333),
    [anon_sym_select] = ACTIONS(3333),
    [anon_sym_DQUOTE] = ACTIONS(3335),
    [anon_sym_stackalloc] = ACTIONS(3333),
    [anon_sym_sizeof] = ACTIONS(3333),
    [anon_sym_typeof] = ACTIONS(3333),
    [anon_sym___makeref] = ACTIONS(3333),
    [anon_sym___reftype] = ACTIONS(3333),
    [anon_sym___refvalue] = ACTIONS(3333),
    [sym_null_literal] = ACTIONS(3333),
    [anon_sym_SQUOTE] = ACTIONS(3335),
    [sym_integer_literal] = ACTIONS(3333),
    [sym_real_literal] = ACTIONS(3335),
    [sym_verbatim_string_literal] = ACTIONS(3335),
    [aux_sym_preproc_if_token1] = ACTIONS(3335),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3335),
    [sym_interpolation_verbatim_start] = ACTIONS(3335),
    [sym_interpolation_raw_start] = ACTIONS(3335),
    [sym_raw_string_start] = ACTIONS(3335),
  },
  [2694] = {
    [sym_preproc_region] = STATE(2694),
    [sym_preproc_endregion] = STATE(2694),
    [sym_preproc_line] = STATE(2694),
    [sym_preproc_pragma] = STATE(2694),
    [sym_preproc_nullable] = STATE(2694),
    [sym_preproc_error] = STATE(2694),
    [sym_preproc_define] = STATE(2694),
    [sym_preproc_undef] = STATE(2694),
    [sym__identifier_token] = ACTIONS(3329),
    [anon_sym_extern] = ACTIONS(3329),
    [anon_sym_alias] = ACTIONS(3329),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_global] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3329),
    [anon_sym_unsafe] = ACTIONS(3329),
    [anon_sym_static] = ACTIONS(3329),
    [anon_sym_LBRACK] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3331),
    [anon_sym_return] = ACTIONS(3329),
    [anon_sym_ref] = ACTIONS(3329),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_delegate] = ACTIONS(3329),
    [anon_sym_abstract] = ACTIONS(3329),
    [anon_sym_async] = ACTIONS(3329),
    [anon_sym_const] = ACTIONS(3329),
    [anon_sym_file] = ACTIONS(3329),
    [anon_sym_fixed] = ACTIONS(3329),
    [anon_sym_internal] = ACTIONS(3329),
    [anon_sym_new] = ACTIONS(3329),
    [anon_sym_override] = ACTIONS(3329),
    [anon_sym_partial] = ACTIONS(3329),
    [anon_sym_private] = ACTIONS(3329),
    [anon_sym_protected] = ACTIONS(3329),
    [anon_sym_public] = ACTIONS(3329),
    [anon_sym_readonly] = ACTIONS(3329),
    [anon_sym_required] = ACTIONS(3329),
    [anon_sym_sealed] = ACTIONS(3329),
    [anon_sym_virtual] = ACTIONS(3329),
    [anon_sym_volatile] = ACTIONS(3329),
    [anon_sym_where] = ACTIONS(3329),
    [anon_sym_notnull] = ACTIONS(3329),
    [anon_sym_unmanaged] = ACTIONS(3329),
    [anon_sym_checked] = ACTIONS(3329),
    [anon_sym_BANG] = ACTIONS(3331),
    [anon_sym_TILDE] = ACTIONS(3331),
    [anon_sym_PLUS_PLUS] = ACTIONS(3331),
    [anon_sym_DASH_DASH] = ACTIONS(3331),
    [anon_sym_true] = ACTIONS(3329),
    [anon_sym_false] = ACTIONS(3329),
    [anon_sym_PLUS] = ACTIONS(3329),
    [anon_sym_DASH] = ACTIONS(3329),
    [anon_sym_STAR] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3331),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_this] = ACTIONS(3329),
    [anon_sym_scoped] = ACTIONS(3329),
    [anon_sym_base] = ACTIONS(3329),
    [anon_sym_var] = ACTIONS(3329),
    [sym_predefined_type] = ACTIONS(3329),
    [anon_sym_break] = ACTIONS(3329),
    [anon_sym_unchecked] = ACTIONS(3329),
    [anon_sym_continue] = ACTIONS(3329),
    [anon_sym_do] = ACTIONS(3329),
    [anon_sym_while] = ACTIONS(3329),
    [anon_sym_for] = ACTIONS(3329),
    [anon_sym_lock] = ACTIONS(3329),
    [anon_sym_yield] = ACTIONS(3329),
    [anon_sym_switch] = ACTIONS(3329),
    [anon_sym_case] = ACTIONS(3329),
    [anon_sym_default] = ACTIONS(3329),
    [anon_sym_throw] = ACTIONS(3329),
    [anon_sym_try] = ACTIONS(3329),
    [anon_sym_when] = ACTIONS(3329),
    [anon_sym_await] = ACTIONS(3329),
    [anon_sym_foreach] = ACTIONS(3329),
    [anon_sym_goto] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(3329),
    [anon_sym_else] = ACTIONS(3329),
    [anon_sym_DOT_DOT] = ACTIONS(3331),
    [anon_sym_from] = ACTIONS(3329),
    [anon_sym_into] = ACTIONS(3329),
    [anon_sym_join] = ACTIONS(3329),
    [anon_sym_on] = ACTIONS(3329),
    [anon_sym_equals] = ACTIONS(3329),
    [anon_sym_let] = ACTIONS(3329),
    [anon_sym_orderby] = ACTIONS(3329),
    [anon_sym_ascending] = ACTIONS(3329),
    [anon_sym_descending] = ACTIONS(3329),
    [anon_sym_group] = ACTIONS(3329),
    [anon_sym_by] = ACTIONS(3329),
    [anon_sym_select] = ACTIONS(3329),
    [anon_sym_DQUOTE] = ACTIONS(3331),
    [anon_sym_stackalloc] = ACTIONS(3329),
    [anon_sym_sizeof] = ACTIONS(3329),
    [anon_sym_typeof] = ACTIONS(3329),
    [anon_sym___makeref] = ACTIONS(3329),
    [anon_sym___reftype] = ACTIONS(3329),
    [anon_sym___refvalue] = ACTIONS(3329),
    [sym_null_literal] = ACTIONS(3329),
    [anon_sym_SQUOTE] = ACTIONS(3331),
    [sym_integer_literal] = ACTIONS(3329),
    [sym_real_literal] = ACTIONS(3331),
    [sym_verbatim_string_literal] = ACTIONS(3331),
    [aux_sym_preproc_if_token1] = ACTIONS(3331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3331),
    [sym_interpolation_verbatim_start] = ACTIONS(3331),
    [sym_interpolation_raw_start] = ACTIONS(3331),
    [sym_raw_string_start] = ACTIONS(3331),
  },
  [2695] = {
    [sym_preproc_region] = STATE(2695),
    [sym_preproc_endregion] = STATE(2695),
    [sym_preproc_line] = STATE(2695),
    [sym_preproc_pragma] = STATE(2695),
    [sym_preproc_nullable] = STATE(2695),
    [sym_preproc_error] = STATE(2695),
    [sym_preproc_define] = STATE(2695),
    [sym_preproc_undef] = STATE(2695),
    [sym__identifier_token] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym_alias] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_global] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_unsafe] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_ref] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_delegate] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_async] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_file] = ACTIONS(3067),
    [anon_sym_fixed] = ACTIONS(3067),
    [anon_sym_internal] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_override] = ACTIONS(3067),
    [anon_sym_partial] = ACTIONS(3067),
    [anon_sym_private] = ACTIONS(3067),
    [anon_sym_protected] = ACTIONS(3067),
    [anon_sym_public] = ACTIONS(3067),
    [anon_sym_readonly] = ACTIONS(3067),
    [anon_sym_required] = ACTIONS(3067),
    [anon_sym_sealed] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_where] = ACTIONS(3067),
    [anon_sym_notnull] = ACTIONS(3067),
    [anon_sym_unmanaged] = ACTIONS(3067),
    [anon_sym_checked] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_true] = ACTIONS(3067),
    [anon_sym_false] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_this] = ACTIONS(3067),
    [anon_sym_scoped] = ACTIONS(3067),
    [anon_sym_base] = ACTIONS(3067),
    [anon_sym_var] = ACTIONS(3067),
    [sym_predefined_type] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_unchecked] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_lock] = ACTIONS(3067),
    [anon_sym_yield] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(3067),
    [anon_sym_await] = ACTIONS(3067),
    [anon_sym_foreach] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_from] = ACTIONS(3067),
    [anon_sym_into] = ACTIONS(3067),
    [anon_sym_join] = ACTIONS(3067),
    [anon_sym_on] = ACTIONS(3067),
    [anon_sym_equals] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_orderby] = ACTIONS(3067),
    [anon_sym_ascending] = ACTIONS(3067),
    [anon_sym_descending] = ACTIONS(3067),
    [anon_sym_group] = ACTIONS(3067),
    [anon_sym_by] = ACTIONS(3067),
    [anon_sym_select] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [anon_sym_stackalloc] = ACTIONS(3067),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym_typeof] = ACTIONS(3067),
    [anon_sym___makeref] = ACTIONS(3067),
    [anon_sym___reftype] = ACTIONS(3067),
    [anon_sym___refvalue] = ACTIONS(3067),
    [sym_null_literal] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [sym_integer_literal] = ACTIONS(3067),
    [sym_real_literal] = ACTIONS(3069),
    [sym_verbatim_string_literal] = ACTIONS(3069),
    [aux_sym_preproc_if_token1] = ACTIONS(3069),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3069),
    [sym_interpolation_verbatim_start] = ACTIONS(3069),
    [sym_interpolation_raw_start] = ACTIONS(3069),
    [sym_raw_string_start] = ACTIONS(3069),
  },
  [2696] = {
    [sym_preproc_region] = STATE(2696),
    [sym_preproc_endregion] = STATE(2696),
    [sym_preproc_line] = STATE(2696),
    [sym_preproc_pragma] = STATE(2696),
    [sym_preproc_nullable] = STATE(2696),
    [sym_preproc_error] = STATE(2696),
    [sym_preproc_define] = STATE(2696),
    [sym_preproc_undef] = STATE(2696),
    [sym__identifier_token] = ACTIONS(3253),
    [anon_sym_extern] = ACTIONS(3253),
    [anon_sym_alias] = ACTIONS(3253),
    [anon_sym_SEMI] = ACTIONS(3255),
    [anon_sym_global] = ACTIONS(3253),
    [anon_sym_using] = ACTIONS(3253),
    [anon_sym_unsafe] = ACTIONS(3253),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3255),
    [anon_sym_return] = ACTIONS(3253),
    [anon_sym_ref] = ACTIONS(3253),
    [anon_sym_LBRACE] = ACTIONS(3255),
    [anon_sym_RBRACE] = ACTIONS(3255),
    [anon_sym_delegate] = ACTIONS(3253),
    [anon_sym_abstract] = ACTIONS(3253),
    [anon_sym_async] = ACTIONS(3253),
    [anon_sym_const] = ACTIONS(3253),
    [anon_sym_file] = ACTIONS(3253),
    [anon_sym_fixed] = ACTIONS(3253),
    [anon_sym_internal] = ACTIONS(3253),
    [anon_sym_new] = ACTIONS(3253),
    [anon_sym_override] = ACTIONS(3253),
    [anon_sym_partial] = ACTIONS(3253),
    [anon_sym_private] = ACTIONS(3253),
    [anon_sym_protected] = ACTIONS(3253),
    [anon_sym_public] = ACTIONS(3253),
    [anon_sym_readonly] = ACTIONS(3253),
    [anon_sym_required] = ACTIONS(3253),
    [anon_sym_sealed] = ACTIONS(3253),
    [anon_sym_virtual] = ACTIONS(3253),
    [anon_sym_volatile] = ACTIONS(3253),
    [anon_sym_where] = ACTIONS(3253),
    [anon_sym_notnull] = ACTIONS(3253),
    [anon_sym_unmanaged] = ACTIONS(3253),
    [anon_sym_checked] = ACTIONS(3253),
    [anon_sym_BANG] = ACTIONS(3255),
    [anon_sym_TILDE] = ACTIONS(3255),
    [anon_sym_PLUS_PLUS] = ACTIONS(3255),
    [anon_sym_DASH_DASH] = ACTIONS(3255),
    [anon_sym_true] = ACTIONS(3253),
    [anon_sym_false] = ACTIONS(3253),
    [anon_sym_PLUS] = ACTIONS(3253),
    [anon_sym_DASH] = ACTIONS(3253),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_CARET] = ACTIONS(3255),
    [anon_sym_AMP] = ACTIONS(3255),
    [anon_sym_this] = ACTIONS(3253),
    [anon_sym_scoped] = ACTIONS(3253),
    [anon_sym_base] = ACTIONS(3253),
    [anon_sym_var] = ACTIONS(3253),
    [sym_predefined_type] = ACTIONS(3253),
    [anon_sym_break] = ACTIONS(3253),
    [anon_sym_unchecked] = ACTIONS(3253),
    [anon_sym_continue] = ACTIONS(3253),
    [anon_sym_do] = ACTIONS(3253),
    [anon_sym_while] = ACTIONS(3253),
    [anon_sym_for] = ACTIONS(3253),
    [anon_sym_lock] = ACTIONS(3253),
    [anon_sym_yield] = ACTIONS(3253),
    [anon_sym_switch] = ACTIONS(3253),
    [anon_sym_case] = ACTIONS(3253),
    [anon_sym_default] = ACTIONS(3253),
    [anon_sym_throw] = ACTIONS(3253),
    [anon_sym_try] = ACTIONS(3253),
    [anon_sym_when] = ACTIONS(3253),
    [anon_sym_await] = ACTIONS(3253),
    [anon_sym_foreach] = ACTIONS(3253),
    [anon_sym_goto] = ACTIONS(3253),
    [anon_sym_if] = ACTIONS(3253),
    [anon_sym_else] = ACTIONS(3253),
    [anon_sym_DOT_DOT] = ACTIONS(3255),
    [anon_sym_from] = ACTIONS(3253),
    [anon_sym_into] = ACTIONS(3253),
    [anon_sym_join] = ACTIONS(3253),
    [anon_sym_on] = ACTIONS(3253),
    [anon_sym_equals] = ACTIONS(3253),
    [anon_sym_let] = ACTIONS(3253),
    [anon_sym_orderby] = ACTIONS(3253),
    [anon_sym_ascending] = ACTIONS(3253),
    [anon_sym_descending] = ACTIONS(3253),
    [anon_sym_group] = ACTIONS(3253),
    [anon_sym_by] = ACTIONS(3253),
    [anon_sym_select] = ACTIONS(3253),
    [anon_sym_DQUOTE] = ACTIONS(3255),
    [anon_sym_stackalloc] = ACTIONS(3253),
    [anon_sym_sizeof] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3253),
    [anon_sym___makeref] = ACTIONS(3253),
    [anon_sym___reftype] = ACTIONS(3253),
    [anon_sym___refvalue] = ACTIONS(3253),
    [sym_null_literal] = ACTIONS(3253),
    [anon_sym_SQUOTE] = ACTIONS(3255),
    [sym_integer_literal] = ACTIONS(3253),
    [sym_real_literal] = ACTIONS(3255),
    [sym_verbatim_string_literal] = ACTIONS(3255),
    [aux_sym_preproc_if_token1] = ACTIONS(3255),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3255),
    [sym_interpolation_verbatim_start] = ACTIONS(3255),
    [sym_interpolation_raw_start] = ACTIONS(3255),
    [sym_raw_string_start] = ACTIONS(3255),
  },
  [2697] = {
    [sym_preproc_region] = STATE(2697),
    [sym_preproc_endregion] = STATE(2697),
    [sym_preproc_line] = STATE(2697),
    [sym_preproc_pragma] = STATE(2697),
    [sym_preproc_nullable] = STATE(2697),
    [sym_preproc_error] = STATE(2697),
    [sym_preproc_define] = STATE(2697),
    [sym_preproc_undef] = STATE(2697),
    [sym__identifier_token] = ACTIONS(3337),
    [anon_sym_extern] = ACTIONS(3337),
    [anon_sym_alias] = ACTIONS(3337),
    [anon_sym_SEMI] = ACTIONS(3339),
    [anon_sym_global] = ACTIONS(3337),
    [anon_sym_using] = ACTIONS(3337),
    [anon_sym_unsafe] = ACTIONS(3337),
    [anon_sym_static] = ACTIONS(3337),
    [anon_sym_LBRACK] = ACTIONS(3339),
    [anon_sym_LPAREN] = ACTIONS(3339),
    [anon_sym_return] = ACTIONS(3337),
    [anon_sym_ref] = ACTIONS(3337),
    [anon_sym_LBRACE] = ACTIONS(3339),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_delegate] = ACTIONS(3337),
    [anon_sym_abstract] = ACTIONS(3337),
    [anon_sym_async] = ACTIONS(3337),
    [anon_sym_const] = ACTIONS(3337),
    [anon_sym_file] = ACTIONS(3337),
    [anon_sym_fixed] = ACTIONS(3337),
    [anon_sym_internal] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(3337),
    [anon_sym_override] = ACTIONS(3337),
    [anon_sym_partial] = ACTIONS(3337),
    [anon_sym_private] = ACTIONS(3337),
    [anon_sym_protected] = ACTIONS(3337),
    [anon_sym_public] = ACTIONS(3337),
    [anon_sym_readonly] = ACTIONS(3337),
    [anon_sym_required] = ACTIONS(3337),
    [anon_sym_sealed] = ACTIONS(3337),
    [anon_sym_virtual] = ACTIONS(3337),
    [anon_sym_volatile] = ACTIONS(3337),
    [anon_sym_where] = ACTIONS(3337),
    [anon_sym_notnull] = ACTIONS(3337),
    [anon_sym_unmanaged] = ACTIONS(3337),
    [anon_sym_checked] = ACTIONS(3337),
    [anon_sym_BANG] = ACTIONS(3339),
    [anon_sym_TILDE] = ACTIONS(3339),
    [anon_sym_PLUS_PLUS] = ACTIONS(3339),
    [anon_sym_DASH_DASH] = ACTIONS(3339),
    [anon_sym_true] = ACTIONS(3337),
    [anon_sym_false] = ACTIONS(3337),
    [anon_sym_PLUS] = ACTIONS(3337),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_STAR] = ACTIONS(3339),
    [anon_sym_CARET] = ACTIONS(3339),
    [anon_sym_AMP] = ACTIONS(3339),
    [anon_sym_this] = ACTIONS(3337),
    [anon_sym_scoped] = ACTIONS(3337),
    [anon_sym_base] = ACTIONS(3337),
    [anon_sym_var] = ACTIONS(3337),
    [sym_predefined_type] = ACTIONS(3337),
    [anon_sym_break] = ACTIONS(3337),
    [anon_sym_unchecked] = ACTIONS(3337),
    [anon_sym_continue] = ACTIONS(3337),
    [anon_sym_do] = ACTIONS(3337),
    [anon_sym_while] = ACTIONS(3337),
    [anon_sym_for] = ACTIONS(3337),
    [anon_sym_lock] = ACTIONS(3337),
    [anon_sym_yield] = ACTIONS(3337),
    [anon_sym_switch] = ACTIONS(3337),
    [anon_sym_case] = ACTIONS(3337),
    [anon_sym_default] = ACTIONS(3337),
    [anon_sym_throw] = ACTIONS(3337),
    [anon_sym_try] = ACTIONS(3337),
    [anon_sym_when] = ACTIONS(3337),
    [anon_sym_await] = ACTIONS(3337),
    [anon_sym_foreach] = ACTIONS(3337),
    [anon_sym_goto] = ACTIONS(3337),
    [anon_sym_if] = ACTIONS(3337),
    [anon_sym_else] = ACTIONS(3337),
    [anon_sym_DOT_DOT] = ACTIONS(3339),
    [anon_sym_from] = ACTIONS(3337),
    [anon_sym_into] = ACTIONS(3337),
    [anon_sym_join] = ACTIONS(3337),
    [anon_sym_on] = ACTIONS(3337),
    [anon_sym_equals] = ACTIONS(3337),
    [anon_sym_let] = ACTIONS(3337),
    [anon_sym_orderby] = ACTIONS(3337),
    [anon_sym_ascending] = ACTIONS(3337),
    [anon_sym_descending] = ACTIONS(3337),
    [anon_sym_group] = ACTIONS(3337),
    [anon_sym_by] = ACTIONS(3337),
    [anon_sym_select] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(3339),
    [anon_sym_stackalloc] = ACTIONS(3337),
    [anon_sym_sizeof] = ACTIONS(3337),
    [anon_sym_typeof] = ACTIONS(3337),
    [anon_sym___makeref] = ACTIONS(3337),
    [anon_sym___reftype] = ACTIONS(3337),
    [anon_sym___refvalue] = ACTIONS(3337),
    [sym_null_literal] = ACTIONS(3337),
    [anon_sym_SQUOTE] = ACTIONS(3339),
    [sym_integer_literal] = ACTIONS(3337),
    [sym_real_literal] = ACTIONS(3339),
    [sym_verbatim_string_literal] = ACTIONS(3339),
    [aux_sym_preproc_if_token1] = ACTIONS(3339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3339),
    [sym_interpolation_verbatim_start] = ACTIONS(3339),
    [sym_interpolation_raw_start] = ACTIONS(3339),
    [sym_raw_string_start] = ACTIONS(3339),
  },
  [2698] = {
    [sym_preproc_region] = STATE(2698),
    [sym_preproc_endregion] = STATE(2698),
    [sym_preproc_line] = STATE(2698),
    [sym_preproc_pragma] = STATE(2698),
    [sym_preproc_nullable] = STATE(2698),
    [sym_preproc_error] = STATE(2698),
    [sym_preproc_define] = STATE(2698),
    [sym_preproc_undef] = STATE(2698),
    [sym__identifier_token] = ACTIONS(3063),
    [anon_sym_extern] = ACTIONS(3063),
    [anon_sym_alias] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_global] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_unsafe] = ACTIONS(3063),
    [anon_sym_static] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3065),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_ref] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_delegate] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_async] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_file] = ACTIONS(3063),
    [anon_sym_fixed] = ACTIONS(3063),
    [anon_sym_internal] = ACTIONS(3063),
    [anon_sym_new] = ACTIONS(3063),
    [anon_sym_override] = ACTIONS(3063),
    [anon_sym_partial] = ACTIONS(3063),
    [anon_sym_private] = ACTIONS(3063),
    [anon_sym_protected] = ACTIONS(3063),
    [anon_sym_public] = ACTIONS(3063),
    [anon_sym_readonly] = ACTIONS(3063),
    [anon_sym_required] = ACTIONS(3063),
    [anon_sym_sealed] = ACTIONS(3063),
    [anon_sym_virtual] = ACTIONS(3063),
    [anon_sym_volatile] = ACTIONS(3063),
    [anon_sym_where] = ACTIONS(3063),
    [anon_sym_notnull] = ACTIONS(3063),
    [anon_sym_unmanaged] = ACTIONS(3063),
    [anon_sym_checked] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_true] = ACTIONS(3063),
    [anon_sym_false] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_this] = ACTIONS(3063),
    [anon_sym_scoped] = ACTIONS(3063),
    [anon_sym_base] = ACTIONS(3063),
    [anon_sym_var] = ACTIONS(3063),
    [sym_predefined_type] = ACTIONS(3063),
    [anon_sym_break] = ACTIONS(3063),
    [anon_sym_unchecked] = ACTIONS(3063),
    [anon_sym_continue] = ACTIONS(3063),
    [anon_sym_do] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_lock] = ACTIONS(3063),
    [anon_sym_yield] = ACTIONS(3063),
    [anon_sym_switch] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3063),
    [anon_sym_default] = ACTIONS(3063),
    [anon_sym_throw] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_when] = ACTIONS(3063),
    [anon_sym_await] = ACTIONS(3063),
    [anon_sym_foreach] = ACTIONS(3063),
    [anon_sym_goto] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_from] = ACTIONS(3063),
    [anon_sym_into] = ACTIONS(3063),
    [anon_sym_join] = ACTIONS(3063),
    [anon_sym_on] = ACTIONS(3063),
    [anon_sym_equals] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_orderby] = ACTIONS(3063),
    [anon_sym_ascending] = ACTIONS(3063),
    [anon_sym_descending] = ACTIONS(3063),
    [anon_sym_group] = ACTIONS(3063),
    [anon_sym_by] = ACTIONS(3063),
    [anon_sym_select] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [anon_sym_stackalloc] = ACTIONS(3063),
    [anon_sym_sizeof] = ACTIONS(3063),
    [anon_sym_typeof] = ACTIONS(3063),
    [anon_sym___makeref] = ACTIONS(3063),
    [anon_sym___reftype] = ACTIONS(3063),
    [anon_sym___refvalue] = ACTIONS(3063),
    [sym_null_literal] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [sym_integer_literal] = ACTIONS(3063),
    [sym_real_literal] = ACTIONS(3065),
    [sym_verbatim_string_literal] = ACTIONS(3065),
    [aux_sym_preproc_if_token1] = ACTIONS(3065),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3065),
    [sym_interpolation_verbatim_start] = ACTIONS(3065),
    [sym_interpolation_raw_start] = ACTIONS(3065),
    [sym_raw_string_start] = ACTIONS(3065),
  },
  [2699] = {
    [sym_preproc_region] = STATE(2699),
    [sym_preproc_endregion] = STATE(2699),
    [sym_preproc_line] = STATE(2699),
    [sym_preproc_pragma] = STATE(2699),
    [sym_preproc_nullable] = STATE(2699),
    [sym_preproc_error] = STATE(2699),
    [sym_preproc_define] = STATE(2699),
    [sym_preproc_undef] = STATE(2699),
    [sym__identifier_token] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym_alias] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_global] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_unsafe] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_ref] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_delegate] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_file] = ACTIONS(3075),
    [anon_sym_fixed] = ACTIONS(3075),
    [anon_sym_internal] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_override] = ACTIONS(3075),
    [anon_sym_partial] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_readonly] = ACTIONS(3075),
    [anon_sym_required] = ACTIONS(3075),
    [anon_sym_sealed] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_notnull] = ACTIONS(3075),
    [anon_sym_unmanaged] = ACTIONS(3075),
    [anon_sym_checked] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_true] = ACTIONS(3075),
    [anon_sym_false] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_this] = ACTIONS(3075),
    [anon_sym_scoped] = ACTIONS(3075),
    [anon_sym_base] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [sym_predefined_type] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_unchecked] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_lock] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_when] = ACTIONS(3075),
    [anon_sym_await] = ACTIONS(3075),
    [anon_sym_foreach] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_into] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_ascending] = ACTIONS(3075),
    [anon_sym_descending] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_stackalloc] = ACTIONS(3075),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym___makeref] = ACTIONS(3075),
    [anon_sym___reftype] = ACTIONS(3075),
    [anon_sym___refvalue] = ACTIONS(3075),
    [sym_null_literal] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [sym_integer_literal] = ACTIONS(3075),
    [sym_real_literal] = ACTIONS(3077),
    [sym_verbatim_string_literal] = ACTIONS(3077),
    [aux_sym_preproc_if_token1] = ACTIONS(3077),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3077),
    [sym_interpolation_verbatim_start] = ACTIONS(3077),
    [sym_interpolation_raw_start] = ACTIONS(3077),
    [sym_raw_string_start] = ACTIONS(3077),
  },
  [2700] = {
    [sym_preproc_region] = STATE(2700),
    [sym_preproc_endregion] = STATE(2700),
    [sym_preproc_line] = STATE(2700),
    [sym_preproc_pragma] = STATE(2700),
    [sym_preproc_nullable] = STATE(2700),
    [sym_preproc_error] = STATE(2700),
    [sym_preproc_define] = STATE(2700),
    [sym_preproc_undef] = STATE(2700),
    [sym__identifier_token] = ACTIONS(3317),
    [anon_sym_extern] = ACTIONS(3317),
    [anon_sym_alias] = ACTIONS(3317),
    [anon_sym_SEMI] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3317),
    [anon_sym_using] = ACTIONS(3317),
    [anon_sym_unsafe] = ACTIONS(3317),
    [anon_sym_static] = ACTIONS(3317),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_LPAREN] = ACTIONS(3319),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_ref] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(3319),
    [anon_sym_RBRACE] = ACTIONS(3319),
    [anon_sym_delegate] = ACTIONS(3317),
    [anon_sym_abstract] = ACTIONS(3317),
    [anon_sym_async] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3317),
    [anon_sym_file] = ACTIONS(3317),
    [anon_sym_fixed] = ACTIONS(3317),
    [anon_sym_internal] = ACTIONS(3317),
    [anon_sym_new] = ACTIONS(3317),
    [anon_sym_override] = ACTIONS(3317),
    [anon_sym_partial] = ACTIONS(3317),
    [anon_sym_private] = ACTIONS(3317),
    [anon_sym_protected] = ACTIONS(3317),
    [anon_sym_public] = ACTIONS(3317),
    [anon_sym_readonly] = ACTIONS(3317),
    [anon_sym_required] = ACTIONS(3317),
    [anon_sym_sealed] = ACTIONS(3317),
    [anon_sym_virtual] = ACTIONS(3317),
    [anon_sym_volatile] = ACTIONS(3317),
    [anon_sym_where] = ACTIONS(3317),
    [anon_sym_notnull] = ACTIONS(3317),
    [anon_sym_unmanaged] = ACTIONS(3317),
    [anon_sym_checked] = ACTIONS(3317),
    [anon_sym_BANG] = ACTIONS(3319),
    [anon_sym_TILDE] = ACTIONS(3319),
    [anon_sym_PLUS_PLUS] = ACTIONS(3319),
    [anon_sym_DASH_DASH] = ACTIONS(3319),
    [anon_sym_true] = ACTIONS(3317),
    [anon_sym_false] = ACTIONS(3317),
    [anon_sym_PLUS] = ACTIONS(3317),
    [anon_sym_DASH] = ACTIONS(3317),
    [anon_sym_STAR] = ACTIONS(3319),
    [anon_sym_CARET] = ACTIONS(3319),
    [anon_sym_AMP] = ACTIONS(3319),
    [anon_sym_this] = ACTIONS(3317),
    [anon_sym_scoped] = ACTIONS(3317),
    [anon_sym_base] = ACTIONS(3317),
    [anon_sym_var] = ACTIONS(3317),
    [sym_predefined_type] = ACTIONS(3317),
    [anon_sym_break] = ACTIONS(3317),
    [anon_sym_unchecked] = ACTIONS(3317),
    [anon_sym_continue] = ACTIONS(3317),
    [anon_sym_do] = ACTIONS(3317),
    [anon_sym_while] = ACTIONS(3317),
    [anon_sym_for] = ACTIONS(3317),
    [anon_sym_lock] = ACTIONS(3317),
    [anon_sym_yield] = ACTIONS(3317),
    [anon_sym_switch] = ACTIONS(3317),
    [anon_sym_case] = ACTIONS(3317),
    [anon_sym_default] = ACTIONS(3317),
    [anon_sym_throw] = ACTIONS(3317),
    [anon_sym_try] = ACTIONS(3317),
    [anon_sym_when] = ACTIONS(3317),
    [anon_sym_await] = ACTIONS(3317),
    [anon_sym_foreach] = ACTIONS(3317),
    [anon_sym_goto] = ACTIONS(3317),
    [anon_sym_if] = ACTIONS(3317),
    [anon_sym_else] = ACTIONS(3317),
    [anon_sym_DOT_DOT] = ACTIONS(3319),
    [anon_sym_from] = ACTIONS(3317),
    [anon_sym_into] = ACTIONS(3317),
    [anon_sym_join] = ACTIONS(3317),
    [anon_sym_on] = ACTIONS(3317),
    [anon_sym_equals] = ACTIONS(3317),
    [anon_sym_let] = ACTIONS(3317),
    [anon_sym_orderby] = ACTIONS(3317),
    [anon_sym_ascending] = ACTIONS(3317),
    [anon_sym_descending] = ACTIONS(3317),
    [anon_sym_group] = ACTIONS(3317),
    [anon_sym_by] = ACTIONS(3317),
    [anon_sym_select] = ACTIONS(3317),
    [anon_sym_DQUOTE] = ACTIONS(3319),
    [anon_sym_stackalloc] = ACTIONS(3317),
    [anon_sym_sizeof] = ACTIONS(3317),
    [anon_sym_typeof] = ACTIONS(3317),
    [anon_sym___makeref] = ACTIONS(3317),
    [anon_sym___reftype] = ACTIONS(3317),
    [anon_sym___refvalue] = ACTIONS(3317),
    [sym_null_literal] = ACTIONS(3317),
    [anon_sym_SQUOTE] = ACTIONS(3319),
    [sym_integer_literal] = ACTIONS(3317),
    [sym_real_literal] = ACTIONS(3319),
    [sym_verbatim_string_literal] = ACTIONS(3319),
    [aux_sym_preproc_if_token1] = ACTIONS(3319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3319),
    [sym_interpolation_verbatim_start] = ACTIONS(3319),
    [sym_interpolation_raw_start] = ACTIONS(3319),
    [sym_raw_string_start] = ACTIONS(3319),
  },
  [2701] = {
    [sym_preproc_region] = STATE(2701),
    [sym_preproc_endregion] = STATE(2701),
    [sym_preproc_line] = STATE(2701),
    [sym_preproc_pragma] = STATE(2701),
    [sym_preproc_nullable] = STATE(2701),
    [sym_preproc_error] = STATE(2701),
    [sym_preproc_define] = STATE(2701),
    [sym_preproc_undef] = STATE(2701),
    [sym__identifier_token] = ACTIONS(3099),
    [anon_sym_extern] = ACTIONS(3099),
    [anon_sym_alias] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_global] = ACTIONS(3099),
    [anon_sym_using] = ACTIONS(3099),
    [anon_sym_unsafe] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_ref] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_RBRACE] = ACTIONS(3101),
    [anon_sym_delegate] = ACTIONS(3099),
    [anon_sym_abstract] = ACTIONS(3099),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_file] = ACTIONS(3099),
    [anon_sym_fixed] = ACTIONS(3099),
    [anon_sym_internal] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_override] = ACTIONS(3099),
    [anon_sym_partial] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3099),
    [anon_sym_required] = ACTIONS(3099),
    [anon_sym_sealed] = ACTIONS(3099),
    [anon_sym_virtual] = ACTIONS(3099),
    [anon_sym_volatile] = ACTIONS(3099),
    [anon_sym_where] = ACTIONS(3099),
    [anon_sym_notnull] = ACTIONS(3099),
    [anon_sym_unmanaged] = ACTIONS(3099),
    [anon_sym_checked] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_true] = ACTIONS(3099),
    [anon_sym_false] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_this] = ACTIONS(3099),
    [anon_sym_scoped] = ACTIONS(3099),
    [anon_sym_base] = ACTIONS(3099),
    [anon_sym_var] = ACTIONS(3099),
    [sym_predefined_type] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_unchecked] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_lock] = ACTIONS(3099),
    [anon_sym_yield] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_case] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_when] = ACTIONS(3099),
    [anon_sym_await] = ACTIONS(3099),
    [anon_sym_foreach] = ACTIONS(3099),
    [anon_sym_goto] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3099),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_from] = ACTIONS(3099),
    [anon_sym_into] = ACTIONS(3099),
    [anon_sym_join] = ACTIONS(3099),
    [anon_sym_on] = ACTIONS(3099),
    [anon_sym_equals] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3099),
    [anon_sym_orderby] = ACTIONS(3099),
    [anon_sym_ascending] = ACTIONS(3099),
    [anon_sym_descending] = ACTIONS(3099),
    [anon_sym_group] = ACTIONS(3099),
    [anon_sym_by] = ACTIONS(3099),
    [anon_sym_select] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [anon_sym_stackalloc] = ACTIONS(3099),
    [anon_sym_sizeof] = ACTIONS(3099),
    [anon_sym_typeof] = ACTIONS(3099),
    [anon_sym___makeref] = ACTIONS(3099),
    [anon_sym___reftype] = ACTIONS(3099),
    [anon_sym___refvalue] = ACTIONS(3099),
    [sym_null_literal] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [sym_integer_literal] = ACTIONS(3099),
    [sym_real_literal] = ACTIONS(3101),
    [sym_verbatim_string_literal] = ACTIONS(3101),
    [aux_sym_preproc_if_token1] = ACTIONS(3101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3101),
    [sym_interpolation_verbatim_start] = ACTIONS(3101),
    [sym_interpolation_raw_start] = ACTIONS(3101),
    [sym_raw_string_start] = ACTIONS(3101),
  },
  [2702] = {
    [sym_preproc_region] = STATE(2702),
    [sym_preproc_endregion] = STATE(2702),
    [sym_preproc_line] = STATE(2702),
    [sym_preproc_pragma] = STATE(2702),
    [sym_preproc_nullable] = STATE(2702),
    [sym_preproc_error] = STATE(2702),
    [sym_preproc_define] = STATE(2702),
    [sym_preproc_undef] = STATE(2702),
    [sym__identifier_token] = ACTIONS(3403),
    [anon_sym_extern] = ACTIONS(3403),
    [anon_sym_alias] = ACTIONS(3403),
    [anon_sym_SEMI] = ACTIONS(3405),
    [anon_sym_global] = ACTIONS(3403),
    [anon_sym_using] = ACTIONS(3403),
    [anon_sym_unsafe] = ACTIONS(3403),
    [anon_sym_static] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_LPAREN] = ACTIONS(3405),
    [anon_sym_return] = ACTIONS(3403),
    [anon_sym_ref] = ACTIONS(3403),
    [anon_sym_LBRACE] = ACTIONS(3405),
    [anon_sym_RBRACE] = ACTIONS(3405),
    [anon_sym_delegate] = ACTIONS(3403),
    [anon_sym_abstract] = ACTIONS(3403),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_const] = ACTIONS(3403),
    [anon_sym_file] = ACTIONS(3403),
    [anon_sym_fixed] = ACTIONS(3403),
    [anon_sym_internal] = ACTIONS(3403),
    [anon_sym_new] = ACTIONS(3403),
    [anon_sym_override] = ACTIONS(3403),
    [anon_sym_partial] = ACTIONS(3403),
    [anon_sym_private] = ACTIONS(3403),
    [anon_sym_protected] = ACTIONS(3403),
    [anon_sym_public] = ACTIONS(3403),
    [anon_sym_readonly] = ACTIONS(3403),
    [anon_sym_required] = ACTIONS(3403),
    [anon_sym_sealed] = ACTIONS(3403),
    [anon_sym_virtual] = ACTIONS(3403),
    [anon_sym_volatile] = ACTIONS(3403),
    [anon_sym_where] = ACTIONS(3403),
    [anon_sym_notnull] = ACTIONS(3403),
    [anon_sym_unmanaged] = ACTIONS(3403),
    [anon_sym_checked] = ACTIONS(3403),
    [anon_sym_BANG] = ACTIONS(3405),
    [anon_sym_TILDE] = ACTIONS(3405),
    [anon_sym_PLUS_PLUS] = ACTIONS(3405),
    [anon_sym_DASH_DASH] = ACTIONS(3405),
    [anon_sym_true] = ACTIONS(3403),
    [anon_sym_false] = ACTIONS(3403),
    [anon_sym_PLUS] = ACTIONS(3403),
    [anon_sym_DASH] = ACTIONS(3403),
    [anon_sym_STAR] = ACTIONS(3405),
    [anon_sym_CARET] = ACTIONS(3405),
    [anon_sym_AMP] = ACTIONS(3405),
    [anon_sym_this] = ACTIONS(3403),
    [anon_sym_scoped] = ACTIONS(3403),
    [anon_sym_base] = ACTIONS(3403),
    [anon_sym_var] = ACTIONS(3403),
    [sym_predefined_type] = ACTIONS(3403),
    [anon_sym_break] = ACTIONS(3403),
    [anon_sym_unchecked] = ACTIONS(3403),
    [anon_sym_continue] = ACTIONS(3403),
    [anon_sym_do] = ACTIONS(3403),
    [anon_sym_while] = ACTIONS(3403),
    [anon_sym_for] = ACTIONS(3403),
    [anon_sym_lock] = ACTIONS(3403),
    [anon_sym_yield] = ACTIONS(3403),
    [anon_sym_switch] = ACTIONS(3403),
    [anon_sym_case] = ACTIONS(3403),
    [anon_sym_default] = ACTIONS(3403),
    [anon_sym_throw] = ACTIONS(3403),
    [anon_sym_try] = ACTIONS(3403),
    [anon_sym_when] = ACTIONS(3403),
    [anon_sym_await] = ACTIONS(3403),
    [anon_sym_foreach] = ACTIONS(3403),
    [anon_sym_goto] = ACTIONS(3403),
    [anon_sym_if] = ACTIONS(3403),
    [anon_sym_else] = ACTIONS(3403),
    [anon_sym_DOT_DOT] = ACTIONS(3405),
    [anon_sym_from] = ACTIONS(3403),
    [anon_sym_into] = ACTIONS(3403),
    [anon_sym_join] = ACTIONS(3403),
    [anon_sym_on] = ACTIONS(3403),
    [anon_sym_equals] = ACTIONS(3403),
    [anon_sym_let] = ACTIONS(3403),
    [anon_sym_orderby] = ACTIONS(3403),
    [anon_sym_ascending] = ACTIONS(3403),
    [anon_sym_descending] = ACTIONS(3403),
    [anon_sym_group] = ACTIONS(3403),
    [anon_sym_by] = ACTIONS(3403),
    [anon_sym_select] = ACTIONS(3403),
    [anon_sym_DQUOTE] = ACTIONS(3405),
    [anon_sym_stackalloc] = ACTIONS(3403),
    [anon_sym_sizeof] = ACTIONS(3403),
    [anon_sym_typeof] = ACTIONS(3403),
    [anon_sym___makeref] = ACTIONS(3403),
    [anon_sym___reftype] = ACTIONS(3403),
    [anon_sym___refvalue] = ACTIONS(3403),
    [sym_null_literal] = ACTIONS(3403),
    [anon_sym_SQUOTE] = ACTIONS(3405),
    [sym_integer_literal] = ACTIONS(3403),
    [sym_real_literal] = ACTIONS(3405),
    [sym_verbatim_string_literal] = ACTIONS(3405),
    [aux_sym_preproc_if_token1] = ACTIONS(3405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3405),
    [sym_interpolation_verbatim_start] = ACTIONS(3405),
    [sym_interpolation_raw_start] = ACTIONS(3405),
    [sym_raw_string_start] = ACTIONS(3405),
  },
  [2703] = {
    [sym_preproc_region] = STATE(2703),
    [sym_preproc_endregion] = STATE(2703),
    [sym_preproc_line] = STATE(2703),
    [sym_preproc_pragma] = STATE(2703),
    [sym_preproc_nullable] = STATE(2703),
    [sym_preproc_error] = STATE(2703),
    [sym_preproc_define] = STATE(2703),
    [sym_preproc_undef] = STATE(2703),
    [sym__identifier_token] = ACTIONS(3213),
    [anon_sym_extern] = ACTIONS(3213),
    [anon_sym_alias] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3215),
    [anon_sym_global] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_unsafe] = ACTIONS(3213),
    [anon_sym_static] = ACTIONS(3213),
    [anon_sym_LBRACK] = ACTIONS(3215),
    [anon_sym_LPAREN] = ACTIONS(3215),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_ref] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_delegate] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_async] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_file] = ACTIONS(3213),
    [anon_sym_fixed] = ACTIONS(3213),
    [anon_sym_internal] = ACTIONS(3213),
    [anon_sym_new] = ACTIONS(3213),
    [anon_sym_override] = ACTIONS(3213),
    [anon_sym_partial] = ACTIONS(3213),
    [anon_sym_private] = ACTIONS(3213),
    [anon_sym_protected] = ACTIONS(3213),
    [anon_sym_public] = ACTIONS(3213),
    [anon_sym_readonly] = ACTIONS(3213),
    [anon_sym_required] = ACTIONS(3213),
    [anon_sym_sealed] = ACTIONS(3213),
    [anon_sym_virtual] = ACTIONS(3213),
    [anon_sym_volatile] = ACTIONS(3213),
    [anon_sym_where] = ACTIONS(3213),
    [anon_sym_notnull] = ACTIONS(3213),
    [anon_sym_unmanaged] = ACTIONS(3213),
    [anon_sym_checked] = ACTIONS(3213),
    [anon_sym_BANG] = ACTIONS(3215),
    [anon_sym_TILDE] = ACTIONS(3215),
    [anon_sym_PLUS_PLUS] = ACTIONS(3215),
    [anon_sym_DASH_DASH] = ACTIONS(3215),
    [anon_sym_true] = ACTIONS(3213),
    [anon_sym_false] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(3215),
    [anon_sym_CARET] = ACTIONS(3215),
    [anon_sym_AMP] = ACTIONS(3215),
    [anon_sym_this] = ACTIONS(3213),
    [anon_sym_scoped] = ACTIONS(3213),
    [anon_sym_base] = ACTIONS(3213),
    [anon_sym_var] = ACTIONS(3213),
    [sym_predefined_type] = ACTIONS(3213),
    [anon_sym_break] = ACTIONS(3213),
    [anon_sym_unchecked] = ACTIONS(3213),
    [anon_sym_continue] = ACTIONS(3213),
    [anon_sym_do] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_lock] = ACTIONS(3213),
    [anon_sym_yield] = ACTIONS(3213),
    [anon_sym_switch] = ACTIONS(3213),
    [anon_sym_case] = ACTIONS(3213),
    [anon_sym_default] = ACTIONS(3213),
    [anon_sym_throw] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_when] = ACTIONS(3213),
    [anon_sym_await] = ACTIONS(3213),
    [anon_sym_foreach] = ACTIONS(3213),
    [anon_sym_goto] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_DOT_DOT] = ACTIONS(3215),
    [anon_sym_from] = ACTIONS(3213),
    [anon_sym_into] = ACTIONS(3213),
    [anon_sym_join] = ACTIONS(3213),
    [anon_sym_on] = ACTIONS(3213),
    [anon_sym_equals] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_orderby] = ACTIONS(3213),
    [anon_sym_ascending] = ACTIONS(3213),
    [anon_sym_descending] = ACTIONS(3213),
    [anon_sym_group] = ACTIONS(3213),
    [anon_sym_by] = ACTIONS(3213),
    [anon_sym_select] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_stackalloc] = ACTIONS(3213),
    [anon_sym_sizeof] = ACTIONS(3213),
    [anon_sym_typeof] = ACTIONS(3213),
    [anon_sym___makeref] = ACTIONS(3213),
    [anon_sym___reftype] = ACTIONS(3213),
    [anon_sym___refvalue] = ACTIONS(3213),
    [sym_null_literal] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3215),
    [sym_integer_literal] = ACTIONS(3213),
    [sym_real_literal] = ACTIONS(3215),
    [sym_verbatim_string_literal] = ACTIONS(3215),
    [aux_sym_preproc_if_token1] = ACTIONS(3215),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3215),
    [sym_interpolation_verbatim_start] = ACTIONS(3215),
    [sym_interpolation_raw_start] = ACTIONS(3215),
    [sym_raw_string_start] = ACTIONS(3215),
  },
  [2704] = {
    [sym_preproc_region] = STATE(2704),
    [sym_preproc_endregion] = STATE(2704),
    [sym_preproc_line] = STATE(2704),
    [sym_preproc_pragma] = STATE(2704),
    [sym_preproc_nullable] = STATE(2704),
    [sym_preproc_error] = STATE(2704),
    [sym_preproc_define] = STATE(2704),
    [sym_preproc_undef] = STATE(2704),
    [sym__identifier_token] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym_alias] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_global] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_unsafe] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_ref] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_delegate] = ACTIONS(3079),
    [anon_sym_abstract] = ACTIONS(3079),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_file] = ACTIONS(3079),
    [anon_sym_fixed] = ACTIONS(3079),
    [anon_sym_internal] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_override] = ACTIONS(3079),
    [anon_sym_partial] = ACTIONS(3079),
    [anon_sym_private] = ACTIONS(3079),
    [anon_sym_protected] = ACTIONS(3079),
    [anon_sym_public] = ACTIONS(3079),
    [anon_sym_readonly] = ACTIONS(3079),
    [anon_sym_required] = ACTIONS(3079),
    [anon_sym_sealed] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_where] = ACTIONS(3079),
    [anon_sym_notnull] = ACTIONS(3079),
    [anon_sym_unmanaged] = ACTIONS(3079),
    [anon_sym_checked] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_true] = ACTIONS(3079),
    [anon_sym_false] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_CARET] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym_this] = ACTIONS(3079),
    [anon_sym_scoped] = ACTIONS(3079),
    [anon_sym_base] = ACTIONS(3079),
    [anon_sym_var] = ACTIONS(3079),
    [sym_predefined_type] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_unchecked] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_lock] = ACTIONS(3079),
    [anon_sym_yield] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_when] = ACTIONS(3079),
    [anon_sym_await] = ACTIONS(3079),
    [anon_sym_foreach] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_else] = ACTIONS(3079),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_from] = ACTIONS(3079),
    [anon_sym_into] = ACTIONS(3079),
    [anon_sym_join] = ACTIONS(3079),
    [anon_sym_on] = ACTIONS(3079),
    [anon_sym_equals] = ACTIONS(3079),
    [anon_sym_let] = ACTIONS(3079),
    [anon_sym_orderby] = ACTIONS(3079),
    [anon_sym_ascending] = ACTIONS(3079),
    [anon_sym_descending] = ACTIONS(3079),
    [anon_sym_group] = ACTIONS(3079),
    [anon_sym_by] = ACTIONS(3079),
    [anon_sym_select] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [anon_sym_stackalloc] = ACTIONS(3079),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym_typeof] = ACTIONS(3079),
    [anon_sym___makeref] = ACTIONS(3079),
    [anon_sym___reftype] = ACTIONS(3079),
    [anon_sym___refvalue] = ACTIONS(3079),
    [sym_null_literal] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [sym_integer_literal] = ACTIONS(3079),
    [sym_real_literal] = ACTIONS(3081),
    [sym_verbatim_string_literal] = ACTIONS(3081),
    [aux_sym_preproc_if_token1] = ACTIONS(3081),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3081),
    [sym_interpolation_verbatim_start] = ACTIONS(3081),
    [sym_interpolation_raw_start] = ACTIONS(3081),
    [sym_raw_string_start] = ACTIONS(3081),
  },
  [2705] = {
    [sym_preproc_region] = STATE(2705),
    [sym_preproc_endregion] = STATE(2705),
    [sym_preproc_line] = STATE(2705),
    [sym_preproc_pragma] = STATE(2705),
    [sym_preproc_nullable] = STATE(2705),
    [sym_preproc_error] = STATE(2705),
    [sym_preproc_define] = STATE(2705),
    [sym_preproc_undef] = STATE(2705),
    [sym__identifier_token] = ACTIONS(3399),
    [anon_sym_extern] = ACTIONS(3399),
    [anon_sym_alias] = ACTIONS(3399),
    [anon_sym_SEMI] = ACTIONS(3401),
    [anon_sym_global] = ACTIONS(3399),
    [anon_sym_using] = ACTIONS(3399),
    [anon_sym_unsafe] = ACTIONS(3399),
    [anon_sym_static] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(3401),
    [anon_sym_LPAREN] = ACTIONS(3401),
    [anon_sym_return] = ACTIONS(3399),
    [anon_sym_ref] = ACTIONS(3399),
    [anon_sym_LBRACE] = ACTIONS(3401),
    [anon_sym_RBRACE] = ACTIONS(3401),
    [anon_sym_delegate] = ACTIONS(3399),
    [anon_sym_abstract] = ACTIONS(3399),
    [anon_sym_async] = ACTIONS(3399),
    [anon_sym_const] = ACTIONS(3399),
    [anon_sym_file] = ACTIONS(3399),
    [anon_sym_fixed] = ACTIONS(3399),
    [anon_sym_internal] = ACTIONS(3399),
    [anon_sym_new] = ACTIONS(3399),
    [anon_sym_override] = ACTIONS(3399),
    [anon_sym_partial] = ACTIONS(3399),
    [anon_sym_private] = ACTIONS(3399),
    [anon_sym_protected] = ACTIONS(3399),
    [anon_sym_public] = ACTIONS(3399),
    [anon_sym_readonly] = ACTIONS(3399),
    [anon_sym_required] = ACTIONS(3399),
    [anon_sym_sealed] = ACTIONS(3399),
    [anon_sym_virtual] = ACTIONS(3399),
    [anon_sym_volatile] = ACTIONS(3399),
    [anon_sym_where] = ACTIONS(3399),
    [anon_sym_notnull] = ACTIONS(3399),
    [anon_sym_unmanaged] = ACTIONS(3399),
    [anon_sym_checked] = ACTIONS(3399),
    [anon_sym_BANG] = ACTIONS(3401),
    [anon_sym_TILDE] = ACTIONS(3401),
    [anon_sym_PLUS_PLUS] = ACTIONS(3401),
    [anon_sym_DASH_DASH] = ACTIONS(3401),
    [anon_sym_true] = ACTIONS(3399),
    [anon_sym_false] = ACTIONS(3399),
    [anon_sym_PLUS] = ACTIONS(3399),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_STAR] = ACTIONS(3401),
    [anon_sym_CARET] = ACTIONS(3401),
    [anon_sym_AMP] = ACTIONS(3401),
    [anon_sym_this] = ACTIONS(3399),
    [anon_sym_scoped] = ACTIONS(3399),
    [anon_sym_base] = ACTIONS(3399),
    [anon_sym_var] = ACTIONS(3399),
    [sym_predefined_type] = ACTIONS(3399),
    [anon_sym_break] = ACTIONS(3399),
    [anon_sym_unchecked] = ACTIONS(3399),
    [anon_sym_continue] = ACTIONS(3399),
    [anon_sym_do] = ACTIONS(3399),
    [anon_sym_while] = ACTIONS(3399),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_lock] = ACTIONS(3399),
    [anon_sym_yield] = ACTIONS(3399),
    [anon_sym_switch] = ACTIONS(3399),
    [anon_sym_case] = ACTIONS(3399),
    [anon_sym_default] = ACTIONS(3399),
    [anon_sym_throw] = ACTIONS(3399),
    [anon_sym_try] = ACTIONS(3399),
    [anon_sym_when] = ACTIONS(3399),
    [anon_sym_await] = ACTIONS(3399),
    [anon_sym_foreach] = ACTIONS(3399),
    [anon_sym_goto] = ACTIONS(3399),
    [anon_sym_if] = ACTIONS(3399),
    [anon_sym_else] = ACTIONS(3399),
    [anon_sym_DOT_DOT] = ACTIONS(3401),
    [anon_sym_from] = ACTIONS(3399),
    [anon_sym_into] = ACTIONS(3399),
    [anon_sym_join] = ACTIONS(3399),
    [anon_sym_on] = ACTIONS(3399),
    [anon_sym_equals] = ACTIONS(3399),
    [anon_sym_let] = ACTIONS(3399),
    [anon_sym_orderby] = ACTIONS(3399),
    [anon_sym_ascending] = ACTIONS(3399),
    [anon_sym_descending] = ACTIONS(3399),
    [anon_sym_group] = ACTIONS(3399),
    [anon_sym_by] = ACTIONS(3399),
    [anon_sym_select] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(3401),
    [anon_sym_stackalloc] = ACTIONS(3399),
    [anon_sym_sizeof] = ACTIONS(3399),
    [anon_sym_typeof] = ACTIONS(3399),
    [anon_sym___makeref] = ACTIONS(3399),
    [anon_sym___reftype] = ACTIONS(3399),
    [anon_sym___refvalue] = ACTIONS(3399),
    [sym_null_literal] = ACTIONS(3399),
    [anon_sym_SQUOTE] = ACTIONS(3401),
    [sym_integer_literal] = ACTIONS(3399),
    [sym_real_literal] = ACTIONS(3401),
    [sym_verbatim_string_literal] = ACTIONS(3401),
    [aux_sym_preproc_if_token1] = ACTIONS(3401),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3401),
    [sym_interpolation_verbatim_start] = ACTIONS(3401),
    [sym_interpolation_raw_start] = ACTIONS(3401),
    [sym_raw_string_start] = ACTIONS(3401),
  },
  [2706] = {
    [sym_preproc_region] = STATE(2706),
    [sym_preproc_endregion] = STATE(2706),
    [sym_preproc_line] = STATE(2706),
    [sym_preproc_pragma] = STATE(2706),
    [sym_preproc_nullable] = STATE(2706),
    [sym_preproc_error] = STATE(2706),
    [sym_preproc_define] = STATE(2706),
    [sym_preproc_undef] = STATE(2706),
    [sym__identifier_token] = ACTIONS(3389),
    [anon_sym_extern] = ACTIONS(3389),
    [anon_sym_alias] = ACTIONS(3389),
    [anon_sym_SEMI] = ACTIONS(3391),
    [anon_sym_global] = ACTIONS(3389),
    [anon_sym_using] = ACTIONS(3389),
    [anon_sym_unsafe] = ACTIONS(3389),
    [anon_sym_static] = ACTIONS(3389),
    [anon_sym_LBRACK] = ACTIONS(3391),
    [anon_sym_LPAREN] = ACTIONS(3391),
    [anon_sym_return] = ACTIONS(3389),
    [anon_sym_ref] = ACTIONS(3389),
    [anon_sym_LBRACE] = ACTIONS(3391),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_delegate] = ACTIONS(3389),
    [anon_sym_abstract] = ACTIONS(3389),
    [anon_sym_async] = ACTIONS(3389),
    [anon_sym_const] = ACTIONS(3389),
    [anon_sym_file] = ACTIONS(3389),
    [anon_sym_fixed] = ACTIONS(3389),
    [anon_sym_internal] = ACTIONS(3389),
    [anon_sym_new] = ACTIONS(3389),
    [anon_sym_override] = ACTIONS(3389),
    [anon_sym_partial] = ACTIONS(3389),
    [anon_sym_private] = ACTIONS(3389),
    [anon_sym_protected] = ACTIONS(3389),
    [anon_sym_public] = ACTIONS(3389),
    [anon_sym_readonly] = ACTIONS(3389),
    [anon_sym_required] = ACTIONS(3389),
    [anon_sym_sealed] = ACTIONS(3389),
    [anon_sym_virtual] = ACTIONS(3389),
    [anon_sym_volatile] = ACTIONS(3389),
    [anon_sym_where] = ACTIONS(3389),
    [anon_sym_notnull] = ACTIONS(3389),
    [anon_sym_unmanaged] = ACTIONS(3389),
    [anon_sym_checked] = ACTIONS(3389),
    [anon_sym_BANG] = ACTIONS(3391),
    [anon_sym_TILDE] = ACTIONS(3391),
    [anon_sym_PLUS_PLUS] = ACTIONS(3391),
    [anon_sym_DASH_DASH] = ACTIONS(3391),
    [anon_sym_true] = ACTIONS(3389),
    [anon_sym_false] = ACTIONS(3389),
    [anon_sym_PLUS] = ACTIONS(3389),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_STAR] = ACTIONS(3391),
    [anon_sym_CARET] = ACTIONS(3391),
    [anon_sym_AMP] = ACTIONS(3391),
    [anon_sym_this] = ACTIONS(3389),
    [anon_sym_scoped] = ACTIONS(3389),
    [anon_sym_base] = ACTIONS(3389),
    [anon_sym_var] = ACTIONS(3389),
    [sym_predefined_type] = ACTIONS(3389),
    [anon_sym_break] = ACTIONS(3389),
    [anon_sym_unchecked] = ACTIONS(3389),
    [anon_sym_continue] = ACTIONS(3389),
    [anon_sym_do] = ACTIONS(3389),
    [anon_sym_while] = ACTIONS(3389),
    [anon_sym_for] = ACTIONS(3389),
    [anon_sym_lock] = ACTIONS(3389),
    [anon_sym_yield] = ACTIONS(3389),
    [anon_sym_switch] = ACTIONS(3389),
    [anon_sym_case] = ACTIONS(3389),
    [anon_sym_default] = ACTIONS(3389),
    [anon_sym_throw] = ACTIONS(3389),
    [anon_sym_try] = ACTIONS(3389),
    [anon_sym_when] = ACTIONS(3389),
    [anon_sym_await] = ACTIONS(3389),
    [anon_sym_foreach] = ACTIONS(3389),
    [anon_sym_goto] = ACTIONS(3389),
    [anon_sym_if] = ACTIONS(3389),
    [anon_sym_else] = ACTIONS(3389),
    [anon_sym_DOT_DOT] = ACTIONS(3391),
    [anon_sym_from] = ACTIONS(3389),
    [anon_sym_into] = ACTIONS(3389),
    [anon_sym_join] = ACTIONS(3389),
    [anon_sym_on] = ACTIONS(3389),
    [anon_sym_equals] = ACTIONS(3389),
    [anon_sym_let] = ACTIONS(3389),
    [anon_sym_orderby] = ACTIONS(3389),
    [anon_sym_ascending] = ACTIONS(3389),
    [anon_sym_descending] = ACTIONS(3389),
    [anon_sym_group] = ACTIONS(3389),
    [anon_sym_by] = ACTIONS(3389),
    [anon_sym_select] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(3391),
    [anon_sym_stackalloc] = ACTIONS(3389),
    [anon_sym_sizeof] = ACTIONS(3389),
    [anon_sym_typeof] = ACTIONS(3389),
    [anon_sym___makeref] = ACTIONS(3389),
    [anon_sym___reftype] = ACTIONS(3389),
    [anon_sym___refvalue] = ACTIONS(3389),
    [sym_null_literal] = ACTIONS(3389),
    [anon_sym_SQUOTE] = ACTIONS(3391),
    [sym_integer_literal] = ACTIONS(3389),
    [sym_real_literal] = ACTIONS(3391),
    [sym_verbatim_string_literal] = ACTIONS(3391),
    [aux_sym_preproc_if_token1] = ACTIONS(3391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3391),
    [sym_interpolation_verbatim_start] = ACTIONS(3391),
    [sym_interpolation_raw_start] = ACTIONS(3391),
    [sym_raw_string_start] = ACTIONS(3391),
  },
  [2707] = {
    [sym_preproc_region] = STATE(2707),
    [sym_preproc_endregion] = STATE(2707),
    [sym_preproc_line] = STATE(2707),
    [sym_preproc_pragma] = STATE(2707),
    [sym_preproc_nullable] = STATE(2707),
    [sym_preproc_error] = STATE(2707),
    [sym_preproc_define] = STATE(2707),
    [sym_preproc_undef] = STATE(2707),
    [sym__identifier_token] = ACTIONS(3385),
    [anon_sym_extern] = ACTIONS(3385),
    [anon_sym_alias] = ACTIONS(3385),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_global] = ACTIONS(3385),
    [anon_sym_using] = ACTIONS(3385),
    [anon_sym_unsafe] = ACTIONS(3385),
    [anon_sym_static] = ACTIONS(3385),
    [anon_sym_LBRACK] = ACTIONS(3387),
    [anon_sym_LPAREN] = ACTIONS(3387),
    [anon_sym_return] = ACTIONS(3385),
    [anon_sym_ref] = ACTIONS(3385),
    [anon_sym_LBRACE] = ACTIONS(3387),
    [anon_sym_RBRACE] = ACTIONS(3387),
    [anon_sym_delegate] = ACTIONS(3385),
    [anon_sym_abstract] = ACTIONS(3385),
    [anon_sym_async] = ACTIONS(3385),
    [anon_sym_const] = ACTIONS(3385),
    [anon_sym_file] = ACTIONS(3385),
    [anon_sym_fixed] = ACTIONS(3385),
    [anon_sym_internal] = ACTIONS(3385),
    [anon_sym_new] = ACTIONS(3385),
    [anon_sym_override] = ACTIONS(3385),
    [anon_sym_partial] = ACTIONS(3385),
    [anon_sym_private] = ACTIONS(3385),
    [anon_sym_protected] = ACTIONS(3385),
    [anon_sym_public] = ACTIONS(3385),
    [anon_sym_readonly] = ACTIONS(3385),
    [anon_sym_required] = ACTIONS(3385),
    [anon_sym_sealed] = ACTIONS(3385),
    [anon_sym_virtual] = ACTIONS(3385),
    [anon_sym_volatile] = ACTIONS(3385),
    [anon_sym_where] = ACTIONS(3385),
    [anon_sym_notnull] = ACTIONS(3385),
    [anon_sym_unmanaged] = ACTIONS(3385),
    [anon_sym_checked] = ACTIONS(3385),
    [anon_sym_BANG] = ACTIONS(3387),
    [anon_sym_TILDE] = ACTIONS(3387),
    [anon_sym_PLUS_PLUS] = ACTIONS(3387),
    [anon_sym_DASH_DASH] = ACTIONS(3387),
    [anon_sym_true] = ACTIONS(3385),
    [anon_sym_false] = ACTIONS(3385),
    [anon_sym_PLUS] = ACTIONS(3385),
    [anon_sym_DASH] = ACTIONS(3385),
    [anon_sym_STAR] = ACTIONS(3387),
    [anon_sym_CARET] = ACTIONS(3387),
    [anon_sym_AMP] = ACTIONS(3387),
    [anon_sym_this] = ACTIONS(3385),
    [anon_sym_scoped] = ACTIONS(3385),
    [anon_sym_base] = ACTIONS(3385),
    [anon_sym_var] = ACTIONS(3385),
    [sym_predefined_type] = ACTIONS(3385),
    [anon_sym_break] = ACTIONS(3385),
    [anon_sym_unchecked] = ACTIONS(3385),
    [anon_sym_continue] = ACTIONS(3385),
    [anon_sym_do] = ACTIONS(3385),
    [anon_sym_while] = ACTIONS(3385),
    [anon_sym_for] = ACTIONS(3385),
    [anon_sym_lock] = ACTIONS(3385),
    [anon_sym_yield] = ACTIONS(3385),
    [anon_sym_switch] = ACTIONS(3385),
    [anon_sym_case] = ACTIONS(3385),
    [anon_sym_default] = ACTIONS(3385),
    [anon_sym_throw] = ACTIONS(3385),
    [anon_sym_try] = ACTIONS(3385),
    [anon_sym_when] = ACTIONS(3385),
    [anon_sym_await] = ACTIONS(3385),
    [anon_sym_foreach] = ACTIONS(3385),
    [anon_sym_goto] = ACTIONS(3385),
    [anon_sym_if] = ACTIONS(3385),
    [anon_sym_else] = ACTIONS(3385),
    [anon_sym_DOT_DOT] = ACTIONS(3387),
    [anon_sym_from] = ACTIONS(3385),
    [anon_sym_into] = ACTIONS(3385),
    [anon_sym_join] = ACTIONS(3385),
    [anon_sym_on] = ACTIONS(3385),
    [anon_sym_equals] = ACTIONS(3385),
    [anon_sym_let] = ACTIONS(3385),
    [anon_sym_orderby] = ACTIONS(3385),
    [anon_sym_ascending] = ACTIONS(3385),
    [anon_sym_descending] = ACTIONS(3385),
    [anon_sym_group] = ACTIONS(3385),
    [anon_sym_by] = ACTIONS(3385),
    [anon_sym_select] = ACTIONS(3385),
    [anon_sym_DQUOTE] = ACTIONS(3387),
    [anon_sym_stackalloc] = ACTIONS(3385),
    [anon_sym_sizeof] = ACTIONS(3385),
    [anon_sym_typeof] = ACTIONS(3385),
    [anon_sym___makeref] = ACTIONS(3385),
    [anon_sym___reftype] = ACTIONS(3385),
    [anon_sym___refvalue] = ACTIONS(3385),
    [sym_null_literal] = ACTIONS(3385),
    [anon_sym_SQUOTE] = ACTIONS(3387),
    [sym_integer_literal] = ACTIONS(3385),
    [sym_real_literal] = ACTIONS(3387),
    [sym_verbatim_string_literal] = ACTIONS(3387),
    [aux_sym_preproc_if_token1] = ACTIONS(3387),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3387),
    [sym_interpolation_verbatim_start] = ACTIONS(3387),
    [sym_interpolation_raw_start] = ACTIONS(3387),
    [sym_raw_string_start] = ACTIONS(3387),
  },
  [2708] = {
    [sym_preproc_region] = STATE(2708),
    [sym_preproc_endregion] = STATE(2708),
    [sym_preproc_line] = STATE(2708),
    [sym_preproc_pragma] = STATE(2708),
    [sym_preproc_nullable] = STATE(2708),
    [sym_preproc_error] = STATE(2708),
    [sym_preproc_define] = STATE(2708),
    [sym_preproc_undef] = STATE(2708),
    [sym__identifier_token] = ACTIONS(3209),
    [anon_sym_extern] = ACTIONS(3209),
    [anon_sym_alias] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_global] = ACTIONS(3209),
    [anon_sym_using] = ACTIONS(3209),
    [anon_sym_unsafe] = ACTIONS(3209),
    [anon_sym_static] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3211),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_return] = ACTIONS(3209),
    [anon_sym_ref] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_delegate] = ACTIONS(3209),
    [anon_sym_abstract] = ACTIONS(3209),
    [anon_sym_async] = ACTIONS(3209),
    [anon_sym_const] = ACTIONS(3209),
    [anon_sym_file] = ACTIONS(3209),
    [anon_sym_fixed] = ACTIONS(3209),
    [anon_sym_internal] = ACTIONS(3209),
    [anon_sym_new] = ACTIONS(3209),
    [anon_sym_override] = ACTIONS(3209),
    [anon_sym_partial] = ACTIONS(3209),
    [anon_sym_private] = ACTIONS(3209),
    [anon_sym_protected] = ACTIONS(3209),
    [anon_sym_public] = ACTIONS(3209),
    [anon_sym_readonly] = ACTIONS(3209),
    [anon_sym_required] = ACTIONS(3209),
    [anon_sym_sealed] = ACTIONS(3209),
    [anon_sym_virtual] = ACTIONS(3209),
    [anon_sym_volatile] = ACTIONS(3209),
    [anon_sym_where] = ACTIONS(3209),
    [anon_sym_notnull] = ACTIONS(3209),
    [anon_sym_unmanaged] = ACTIONS(3209),
    [anon_sym_checked] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3211),
    [anon_sym_TILDE] = ACTIONS(3211),
    [anon_sym_PLUS_PLUS] = ACTIONS(3211),
    [anon_sym_DASH_DASH] = ACTIONS(3211),
    [anon_sym_true] = ACTIONS(3209),
    [anon_sym_false] = ACTIONS(3209),
    [anon_sym_PLUS] = ACTIONS(3209),
    [anon_sym_DASH] = ACTIONS(3209),
    [anon_sym_STAR] = ACTIONS(3211),
    [anon_sym_CARET] = ACTIONS(3211),
    [anon_sym_AMP] = ACTIONS(3211),
    [anon_sym_this] = ACTIONS(3209),
    [anon_sym_scoped] = ACTIONS(3209),
    [anon_sym_base] = ACTIONS(3209),
    [anon_sym_var] = ACTIONS(3209),
    [sym_predefined_type] = ACTIONS(3209),
    [anon_sym_break] = ACTIONS(3209),
    [anon_sym_unchecked] = ACTIONS(3209),
    [anon_sym_continue] = ACTIONS(3209),
    [anon_sym_do] = ACTIONS(3209),
    [anon_sym_while] = ACTIONS(3209),
    [anon_sym_for] = ACTIONS(3209),
    [anon_sym_lock] = ACTIONS(3209),
    [anon_sym_yield] = ACTIONS(3209),
    [anon_sym_switch] = ACTIONS(3209),
    [anon_sym_case] = ACTIONS(3209),
    [anon_sym_default] = ACTIONS(3209),
    [anon_sym_throw] = ACTIONS(3209),
    [anon_sym_try] = ACTIONS(3209),
    [anon_sym_when] = ACTIONS(3209),
    [anon_sym_await] = ACTIONS(3209),
    [anon_sym_foreach] = ACTIONS(3209),
    [anon_sym_goto] = ACTIONS(3209),
    [anon_sym_if] = ACTIONS(3209),
    [anon_sym_else] = ACTIONS(3209),
    [anon_sym_DOT_DOT] = ACTIONS(3211),
    [anon_sym_from] = ACTIONS(3209),
    [anon_sym_into] = ACTIONS(3209),
    [anon_sym_join] = ACTIONS(3209),
    [anon_sym_on] = ACTIONS(3209),
    [anon_sym_equals] = ACTIONS(3209),
    [anon_sym_let] = ACTIONS(3209),
    [anon_sym_orderby] = ACTIONS(3209),
    [anon_sym_ascending] = ACTIONS(3209),
    [anon_sym_descending] = ACTIONS(3209),
    [anon_sym_group] = ACTIONS(3209),
    [anon_sym_by] = ACTIONS(3209),
    [anon_sym_select] = ACTIONS(3209),
    [anon_sym_DQUOTE] = ACTIONS(3211),
    [anon_sym_stackalloc] = ACTIONS(3209),
    [anon_sym_sizeof] = ACTIONS(3209),
    [anon_sym_typeof] = ACTIONS(3209),
    [anon_sym___makeref] = ACTIONS(3209),
    [anon_sym___reftype] = ACTIONS(3209),
    [anon_sym___refvalue] = ACTIONS(3209),
    [sym_null_literal] = ACTIONS(3209),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [sym_integer_literal] = ACTIONS(3209),
    [sym_real_literal] = ACTIONS(3211),
    [sym_verbatim_string_literal] = ACTIONS(3211),
    [aux_sym_preproc_if_token1] = ACTIONS(3211),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3211),
    [sym_interpolation_verbatim_start] = ACTIONS(3211),
    [sym_interpolation_raw_start] = ACTIONS(3211),
    [sym_raw_string_start] = ACTIONS(3211),
  },
  [2709] = {
    [sym_preproc_region] = STATE(2709),
    [sym_preproc_endregion] = STATE(2709),
    [sym_preproc_line] = STATE(2709),
    [sym_preproc_pragma] = STATE(2709),
    [sym_preproc_nullable] = STATE(2709),
    [sym_preproc_error] = STATE(2709),
    [sym_preproc_define] = STATE(2709),
    [sym_preproc_undef] = STATE(2709),
    [sym__identifier_token] = ACTIONS(3341),
    [anon_sym_extern] = ACTIONS(3341),
    [anon_sym_alias] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_global] = ACTIONS(3341),
    [anon_sym_using] = ACTIONS(3341),
    [anon_sym_unsafe] = ACTIONS(3341),
    [anon_sym_static] = ACTIONS(3341),
    [anon_sym_LBRACK] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(3343),
    [anon_sym_return] = ACTIONS(3341),
    [anon_sym_ref] = ACTIONS(3341),
    [anon_sym_LBRACE] = ACTIONS(3343),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [anon_sym_delegate] = ACTIONS(3341),
    [anon_sym_abstract] = ACTIONS(3341),
    [anon_sym_async] = ACTIONS(3341),
    [anon_sym_const] = ACTIONS(3341),
    [anon_sym_file] = ACTIONS(3341),
    [anon_sym_fixed] = ACTIONS(3341),
    [anon_sym_internal] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(3341),
    [anon_sym_override] = ACTIONS(3341),
    [anon_sym_partial] = ACTIONS(3341),
    [anon_sym_private] = ACTIONS(3341),
    [anon_sym_protected] = ACTIONS(3341),
    [anon_sym_public] = ACTIONS(3341),
    [anon_sym_readonly] = ACTIONS(3341),
    [anon_sym_required] = ACTIONS(3341),
    [anon_sym_sealed] = ACTIONS(3341),
    [anon_sym_virtual] = ACTIONS(3341),
    [anon_sym_volatile] = ACTIONS(3341),
    [anon_sym_where] = ACTIONS(3341),
    [anon_sym_notnull] = ACTIONS(3341),
    [anon_sym_unmanaged] = ACTIONS(3341),
    [anon_sym_checked] = ACTIONS(3341),
    [anon_sym_BANG] = ACTIONS(3343),
    [anon_sym_TILDE] = ACTIONS(3343),
    [anon_sym_PLUS_PLUS] = ACTIONS(3343),
    [anon_sym_DASH_DASH] = ACTIONS(3343),
    [anon_sym_true] = ACTIONS(3341),
    [anon_sym_false] = ACTIONS(3341),
    [anon_sym_PLUS] = ACTIONS(3341),
    [anon_sym_DASH] = ACTIONS(3341),
    [anon_sym_STAR] = ACTIONS(3343),
    [anon_sym_CARET] = ACTIONS(3343),
    [anon_sym_AMP] = ACTIONS(3343),
    [anon_sym_this] = ACTIONS(3341),
    [anon_sym_scoped] = ACTIONS(3341),
    [anon_sym_base] = ACTIONS(3341),
    [anon_sym_var] = ACTIONS(3341),
    [sym_predefined_type] = ACTIONS(3341),
    [anon_sym_break] = ACTIONS(3341),
    [anon_sym_unchecked] = ACTIONS(3341),
    [anon_sym_continue] = ACTIONS(3341),
    [anon_sym_do] = ACTIONS(3341),
    [anon_sym_while] = ACTIONS(3341),
    [anon_sym_for] = ACTIONS(3341),
    [anon_sym_lock] = ACTIONS(3341),
    [anon_sym_yield] = ACTIONS(3341),
    [anon_sym_switch] = ACTIONS(3341),
    [anon_sym_case] = ACTIONS(3341),
    [anon_sym_default] = ACTIONS(3341),
    [anon_sym_throw] = ACTIONS(3341),
    [anon_sym_try] = ACTIONS(3341),
    [anon_sym_when] = ACTIONS(3341),
    [anon_sym_await] = ACTIONS(3341),
    [anon_sym_foreach] = ACTIONS(3341),
    [anon_sym_goto] = ACTIONS(3341),
    [anon_sym_if] = ACTIONS(3341),
    [anon_sym_else] = ACTIONS(3341),
    [anon_sym_DOT_DOT] = ACTIONS(3343),
    [anon_sym_from] = ACTIONS(3341),
    [anon_sym_into] = ACTIONS(3341),
    [anon_sym_join] = ACTIONS(3341),
    [anon_sym_on] = ACTIONS(3341),
    [anon_sym_equals] = ACTIONS(3341),
    [anon_sym_let] = ACTIONS(3341),
    [anon_sym_orderby] = ACTIONS(3341),
    [anon_sym_ascending] = ACTIONS(3341),
    [anon_sym_descending] = ACTIONS(3341),
    [anon_sym_group] = ACTIONS(3341),
    [anon_sym_by] = ACTIONS(3341),
    [anon_sym_select] = ACTIONS(3341),
    [anon_sym_DQUOTE] = ACTIONS(3343),
    [anon_sym_stackalloc] = ACTIONS(3341),
    [anon_sym_sizeof] = ACTIONS(3341),
    [anon_sym_typeof] = ACTIONS(3341),
    [anon_sym___makeref] = ACTIONS(3341),
    [anon_sym___reftype] = ACTIONS(3341),
    [anon_sym___refvalue] = ACTIONS(3341),
    [sym_null_literal] = ACTIONS(3341),
    [anon_sym_SQUOTE] = ACTIONS(3343),
    [sym_integer_literal] = ACTIONS(3341),
    [sym_real_literal] = ACTIONS(3343),
    [sym_verbatim_string_literal] = ACTIONS(3343),
    [aux_sym_preproc_if_token1] = ACTIONS(3343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3343),
    [sym_interpolation_verbatim_start] = ACTIONS(3343),
    [sym_interpolation_raw_start] = ACTIONS(3343),
    [sym_raw_string_start] = ACTIONS(3343),
  },
  [2710] = {
    [sym_preproc_region] = STATE(2710),
    [sym_preproc_endregion] = STATE(2710),
    [sym_preproc_line] = STATE(2710),
    [sym_preproc_pragma] = STATE(2710),
    [sym_preproc_nullable] = STATE(2710),
    [sym_preproc_error] = STATE(2710),
    [sym_preproc_define] = STATE(2710),
    [sym_preproc_undef] = STATE(2710),
    [sym__identifier_token] = ACTIONS(3059),
    [anon_sym_extern] = ACTIONS(3059),
    [anon_sym_alias] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_global] = ACTIONS(3059),
    [anon_sym_using] = ACTIONS(3059),
    [anon_sym_unsafe] = ACTIONS(3059),
    [anon_sym_static] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3061),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_ref] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_delegate] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_file] = ACTIONS(3059),
    [anon_sym_fixed] = ACTIONS(3059),
    [anon_sym_internal] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3059),
    [anon_sym_override] = ACTIONS(3059),
    [anon_sym_partial] = ACTIONS(3059),
    [anon_sym_private] = ACTIONS(3059),
    [anon_sym_protected] = ACTIONS(3059),
    [anon_sym_public] = ACTIONS(3059),
    [anon_sym_readonly] = ACTIONS(3059),
    [anon_sym_required] = ACTIONS(3059),
    [anon_sym_sealed] = ACTIONS(3059),
    [anon_sym_virtual] = ACTIONS(3059),
    [anon_sym_volatile] = ACTIONS(3059),
    [anon_sym_where] = ACTIONS(3059),
    [anon_sym_notnull] = ACTIONS(3059),
    [anon_sym_unmanaged] = ACTIONS(3059),
    [anon_sym_checked] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_PLUS_PLUS] = ACTIONS(3061),
    [anon_sym_DASH_DASH] = ACTIONS(3061),
    [anon_sym_true] = ACTIONS(3059),
    [anon_sym_false] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_this] = ACTIONS(3059),
    [anon_sym_scoped] = ACTIONS(3059),
    [anon_sym_base] = ACTIONS(3059),
    [anon_sym_var] = ACTIONS(3059),
    [sym_predefined_type] = ACTIONS(3059),
    [anon_sym_break] = ACTIONS(3059),
    [anon_sym_unchecked] = ACTIONS(3059),
    [anon_sym_continue] = ACTIONS(3059),
    [anon_sym_do] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_lock] = ACTIONS(3059),
    [anon_sym_yield] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_case] = ACTIONS(3059),
    [anon_sym_default] = ACTIONS(3059),
    [anon_sym_throw] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_when] = ACTIONS(3059),
    [anon_sym_await] = ACTIONS(3059),
    [anon_sym_foreach] = ACTIONS(3059),
    [anon_sym_goto] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_from] = ACTIONS(3059),
    [anon_sym_into] = ACTIONS(3059),
    [anon_sym_join] = ACTIONS(3059),
    [anon_sym_on] = ACTIONS(3059),
    [anon_sym_equals] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_orderby] = ACTIONS(3059),
    [anon_sym_ascending] = ACTIONS(3059),
    [anon_sym_descending] = ACTIONS(3059),
    [anon_sym_group] = ACTIONS(3059),
    [anon_sym_by] = ACTIONS(3059),
    [anon_sym_select] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3061),
    [anon_sym_stackalloc] = ACTIONS(3059),
    [anon_sym_sizeof] = ACTIONS(3059),
    [anon_sym_typeof] = ACTIONS(3059),
    [anon_sym___makeref] = ACTIONS(3059),
    [anon_sym___reftype] = ACTIONS(3059),
    [anon_sym___refvalue] = ACTIONS(3059),
    [sym_null_literal] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [sym_integer_literal] = ACTIONS(3059),
    [sym_real_literal] = ACTIONS(3061),
    [sym_verbatim_string_literal] = ACTIONS(3061),
    [aux_sym_preproc_if_token1] = ACTIONS(3061),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3061),
    [sym_interpolation_verbatim_start] = ACTIONS(3061),
    [sym_interpolation_raw_start] = ACTIONS(3061),
    [sym_raw_string_start] = ACTIONS(3061),
  },
  [2711] = {
    [sym_preproc_region] = STATE(2711),
    [sym_preproc_endregion] = STATE(2711),
    [sym_preproc_line] = STATE(2711),
    [sym_preproc_pragma] = STATE(2711),
    [sym_preproc_nullable] = STATE(2711),
    [sym_preproc_error] = STATE(2711),
    [sym_preproc_define] = STATE(2711),
    [sym_preproc_undef] = STATE(2711),
    [sym__identifier_token] = ACTIONS(3301),
    [anon_sym_extern] = ACTIONS(3301),
    [anon_sym_alias] = ACTIONS(3301),
    [anon_sym_SEMI] = ACTIONS(3303),
    [anon_sym_global] = ACTIONS(3301),
    [anon_sym_using] = ACTIONS(3301),
    [anon_sym_unsafe] = ACTIONS(3301),
    [anon_sym_static] = ACTIONS(3301),
    [anon_sym_LBRACK] = ACTIONS(3303),
    [anon_sym_LPAREN] = ACTIONS(3303),
    [anon_sym_return] = ACTIONS(3301),
    [anon_sym_ref] = ACTIONS(3301),
    [anon_sym_LBRACE] = ACTIONS(3303),
    [anon_sym_RBRACE] = ACTIONS(3303),
    [anon_sym_delegate] = ACTIONS(3301),
    [anon_sym_abstract] = ACTIONS(3301),
    [anon_sym_async] = ACTIONS(3301),
    [anon_sym_const] = ACTIONS(3301),
    [anon_sym_file] = ACTIONS(3301),
    [anon_sym_fixed] = ACTIONS(3301),
    [anon_sym_internal] = ACTIONS(3301),
    [anon_sym_new] = ACTIONS(3301),
    [anon_sym_override] = ACTIONS(3301),
    [anon_sym_partial] = ACTIONS(3301),
    [anon_sym_private] = ACTIONS(3301),
    [anon_sym_protected] = ACTIONS(3301),
    [anon_sym_public] = ACTIONS(3301),
    [anon_sym_readonly] = ACTIONS(3301),
    [anon_sym_required] = ACTIONS(3301),
    [anon_sym_sealed] = ACTIONS(3301),
    [anon_sym_virtual] = ACTIONS(3301),
    [anon_sym_volatile] = ACTIONS(3301),
    [anon_sym_where] = ACTIONS(3301),
    [anon_sym_notnull] = ACTIONS(3301),
    [anon_sym_unmanaged] = ACTIONS(3301),
    [anon_sym_checked] = ACTIONS(3301),
    [anon_sym_BANG] = ACTIONS(3303),
    [anon_sym_TILDE] = ACTIONS(3303),
    [anon_sym_PLUS_PLUS] = ACTIONS(3303),
    [anon_sym_DASH_DASH] = ACTIONS(3303),
    [anon_sym_true] = ACTIONS(3301),
    [anon_sym_false] = ACTIONS(3301),
    [anon_sym_PLUS] = ACTIONS(3301),
    [anon_sym_DASH] = ACTIONS(3301),
    [anon_sym_STAR] = ACTIONS(3303),
    [anon_sym_CARET] = ACTIONS(3303),
    [anon_sym_AMP] = ACTIONS(3303),
    [anon_sym_this] = ACTIONS(3301),
    [anon_sym_scoped] = ACTIONS(3301),
    [anon_sym_base] = ACTIONS(3301),
    [anon_sym_var] = ACTIONS(3301),
    [sym_predefined_type] = ACTIONS(3301),
    [anon_sym_break] = ACTIONS(3301),
    [anon_sym_unchecked] = ACTIONS(3301),
    [anon_sym_continue] = ACTIONS(3301),
    [anon_sym_do] = ACTIONS(3301),
    [anon_sym_while] = ACTIONS(3301),
    [anon_sym_for] = ACTIONS(3301),
    [anon_sym_lock] = ACTIONS(3301),
    [anon_sym_yield] = ACTIONS(3301),
    [anon_sym_switch] = ACTIONS(3301),
    [anon_sym_case] = ACTIONS(3301),
    [anon_sym_default] = ACTIONS(3301),
    [anon_sym_throw] = ACTIONS(3301),
    [anon_sym_try] = ACTIONS(3301),
    [anon_sym_when] = ACTIONS(3301),
    [anon_sym_await] = ACTIONS(3301),
    [anon_sym_foreach] = ACTIONS(3301),
    [anon_sym_goto] = ACTIONS(3301),
    [anon_sym_if] = ACTIONS(3301),
    [anon_sym_else] = ACTIONS(3301),
    [anon_sym_DOT_DOT] = ACTIONS(3303),
    [anon_sym_from] = ACTIONS(3301),
    [anon_sym_into] = ACTIONS(3301),
    [anon_sym_join] = ACTIONS(3301),
    [anon_sym_on] = ACTIONS(3301),
    [anon_sym_equals] = ACTIONS(3301),
    [anon_sym_let] = ACTIONS(3301),
    [anon_sym_orderby] = ACTIONS(3301),
    [anon_sym_ascending] = ACTIONS(3301),
    [anon_sym_descending] = ACTIONS(3301),
    [anon_sym_group] = ACTIONS(3301),
    [anon_sym_by] = ACTIONS(3301),
    [anon_sym_select] = ACTIONS(3301),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [anon_sym_stackalloc] = ACTIONS(3301),
    [anon_sym_sizeof] = ACTIONS(3301),
    [anon_sym_typeof] = ACTIONS(3301),
    [anon_sym___makeref] = ACTIONS(3301),
    [anon_sym___reftype] = ACTIONS(3301),
    [anon_sym___refvalue] = ACTIONS(3301),
    [sym_null_literal] = ACTIONS(3301),
    [anon_sym_SQUOTE] = ACTIONS(3303),
    [sym_integer_literal] = ACTIONS(3301),
    [sym_real_literal] = ACTIONS(3303),
    [sym_verbatim_string_literal] = ACTIONS(3303),
    [aux_sym_preproc_if_token1] = ACTIONS(3303),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3303),
    [sym_interpolation_verbatim_start] = ACTIONS(3303),
    [sym_interpolation_raw_start] = ACTIONS(3303),
    [sym_raw_string_start] = ACTIONS(3303),
  },
  [2712] = {
    [sym_preproc_region] = STATE(2712),
    [sym_preproc_endregion] = STATE(2712),
    [sym_preproc_line] = STATE(2712),
    [sym_preproc_pragma] = STATE(2712),
    [sym_preproc_nullable] = STATE(2712),
    [sym_preproc_error] = STATE(2712),
    [sym_preproc_define] = STATE(2712),
    [sym_preproc_undef] = STATE(2712),
    [sym__identifier_token] = ACTIONS(3297),
    [anon_sym_extern] = ACTIONS(3297),
    [anon_sym_alias] = ACTIONS(3297),
    [anon_sym_SEMI] = ACTIONS(3299),
    [anon_sym_global] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3297),
    [anon_sym_unsafe] = ACTIONS(3297),
    [anon_sym_static] = ACTIONS(3297),
    [anon_sym_LBRACK] = ACTIONS(3299),
    [anon_sym_LPAREN] = ACTIONS(3299),
    [anon_sym_return] = ACTIONS(3297),
    [anon_sym_ref] = ACTIONS(3297),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3299),
    [anon_sym_delegate] = ACTIONS(3297),
    [anon_sym_abstract] = ACTIONS(3297),
    [anon_sym_async] = ACTIONS(3297),
    [anon_sym_const] = ACTIONS(3297),
    [anon_sym_file] = ACTIONS(3297),
    [anon_sym_fixed] = ACTIONS(3297),
    [anon_sym_internal] = ACTIONS(3297),
    [anon_sym_new] = ACTIONS(3297),
    [anon_sym_override] = ACTIONS(3297),
    [anon_sym_partial] = ACTIONS(3297),
    [anon_sym_private] = ACTIONS(3297),
    [anon_sym_protected] = ACTIONS(3297),
    [anon_sym_public] = ACTIONS(3297),
    [anon_sym_readonly] = ACTIONS(3297),
    [anon_sym_required] = ACTIONS(3297),
    [anon_sym_sealed] = ACTIONS(3297),
    [anon_sym_virtual] = ACTIONS(3297),
    [anon_sym_volatile] = ACTIONS(3297),
    [anon_sym_where] = ACTIONS(3297),
    [anon_sym_notnull] = ACTIONS(3297),
    [anon_sym_unmanaged] = ACTIONS(3297),
    [anon_sym_checked] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_TILDE] = ACTIONS(3299),
    [anon_sym_PLUS_PLUS] = ACTIONS(3299),
    [anon_sym_DASH_DASH] = ACTIONS(3299),
    [anon_sym_true] = ACTIONS(3297),
    [anon_sym_false] = ACTIONS(3297),
    [anon_sym_PLUS] = ACTIONS(3297),
    [anon_sym_DASH] = ACTIONS(3297),
    [anon_sym_STAR] = ACTIONS(3299),
    [anon_sym_CARET] = ACTIONS(3299),
    [anon_sym_AMP] = ACTIONS(3299),
    [anon_sym_this] = ACTIONS(3297),
    [anon_sym_scoped] = ACTIONS(3297),
    [anon_sym_base] = ACTIONS(3297),
    [anon_sym_var] = ACTIONS(3297),
    [sym_predefined_type] = ACTIONS(3297),
    [anon_sym_break] = ACTIONS(3297),
    [anon_sym_unchecked] = ACTIONS(3297),
    [anon_sym_continue] = ACTIONS(3297),
    [anon_sym_do] = ACTIONS(3297),
    [anon_sym_while] = ACTIONS(3297),
    [anon_sym_for] = ACTIONS(3297),
    [anon_sym_lock] = ACTIONS(3297),
    [anon_sym_yield] = ACTIONS(3297),
    [anon_sym_switch] = ACTIONS(3297),
    [anon_sym_case] = ACTIONS(3297),
    [anon_sym_default] = ACTIONS(3297),
    [anon_sym_throw] = ACTIONS(3297),
    [anon_sym_try] = ACTIONS(3297),
    [anon_sym_when] = ACTIONS(3297),
    [anon_sym_await] = ACTIONS(3297),
    [anon_sym_foreach] = ACTIONS(3297),
    [anon_sym_goto] = ACTIONS(3297),
    [anon_sym_if] = ACTIONS(3297),
    [anon_sym_else] = ACTIONS(3297),
    [anon_sym_DOT_DOT] = ACTIONS(3299),
    [anon_sym_from] = ACTIONS(3297),
    [anon_sym_into] = ACTIONS(3297),
    [anon_sym_join] = ACTIONS(3297),
    [anon_sym_on] = ACTIONS(3297),
    [anon_sym_equals] = ACTIONS(3297),
    [anon_sym_let] = ACTIONS(3297),
    [anon_sym_orderby] = ACTIONS(3297),
    [anon_sym_ascending] = ACTIONS(3297),
    [anon_sym_descending] = ACTIONS(3297),
    [anon_sym_group] = ACTIONS(3297),
    [anon_sym_by] = ACTIONS(3297),
    [anon_sym_select] = ACTIONS(3297),
    [anon_sym_DQUOTE] = ACTIONS(3299),
    [anon_sym_stackalloc] = ACTIONS(3297),
    [anon_sym_sizeof] = ACTIONS(3297),
    [anon_sym_typeof] = ACTIONS(3297),
    [anon_sym___makeref] = ACTIONS(3297),
    [anon_sym___reftype] = ACTIONS(3297),
    [anon_sym___refvalue] = ACTIONS(3297),
    [sym_null_literal] = ACTIONS(3297),
    [anon_sym_SQUOTE] = ACTIONS(3299),
    [sym_integer_literal] = ACTIONS(3297),
    [sym_real_literal] = ACTIONS(3299),
    [sym_verbatim_string_literal] = ACTIONS(3299),
    [aux_sym_preproc_if_token1] = ACTIONS(3299),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3299),
    [sym_interpolation_verbatim_start] = ACTIONS(3299),
    [sym_interpolation_raw_start] = ACTIONS(3299),
    [sym_raw_string_start] = ACTIONS(3299),
  },
  [2713] = {
    [sym_preproc_region] = STATE(2713),
    [sym_preproc_endregion] = STATE(2713),
    [sym_preproc_line] = STATE(2713),
    [sym_preproc_pragma] = STATE(2713),
    [sym_preproc_nullable] = STATE(2713),
    [sym_preproc_error] = STATE(2713),
    [sym_preproc_define] = STATE(2713),
    [sym_preproc_undef] = STATE(2713),
    [sym__identifier_token] = ACTIONS(3293),
    [anon_sym_extern] = ACTIONS(3293),
    [anon_sym_alias] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym_global] = ACTIONS(3293),
    [anon_sym_using] = ACTIONS(3293),
    [anon_sym_unsafe] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3295),
    [anon_sym_LPAREN] = ACTIONS(3295),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_ref] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3295),
    [anon_sym_RBRACE] = ACTIONS(3295),
    [anon_sym_delegate] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [anon_sym_file] = ACTIONS(3293),
    [anon_sym_fixed] = ACTIONS(3293),
    [anon_sym_internal] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_override] = ACTIONS(3293),
    [anon_sym_partial] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_readonly] = ACTIONS(3293),
    [anon_sym_required] = ACTIONS(3293),
    [anon_sym_sealed] = ACTIONS(3293),
    [anon_sym_virtual] = ACTIONS(3293),
    [anon_sym_volatile] = ACTIONS(3293),
    [anon_sym_where] = ACTIONS(3293),
    [anon_sym_notnull] = ACTIONS(3293),
    [anon_sym_unmanaged] = ACTIONS(3293),
    [anon_sym_checked] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3295),
    [anon_sym_TILDE] = ACTIONS(3295),
    [anon_sym_PLUS_PLUS] = ACTIONS(3295),
    [anon_sym_DASH_DASH] = ACTIONS(3295),
    [anon_sym_true] = ACTIONS(3293),
    [anon_sym_false] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_CARET] = ACTIONS(3295),
    [anon_sym_AMP] = ACTIONS(3295),
    [anon_sym_this] = ACTIONS(3293),
    [anon_sym_scoped] = ACTIONS(3293),
    [anon_sym_base] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [sym_predefined_type] = ACTIONS(3293),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_unchecked] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_lock] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_when] = ACTIONS(3293),
    [anon_sym_await] = ACTIONS(3293),
    [anon_sym_foreach] = ACTIONS(3293),
    [anon_sym_goto] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_DOT_DOT] = ACTIONS(3295),
    [anon_sym_from] = ACTIONS(3293),
    [anon_sym_into] = ACTIONS(3293),
    [anon_sym_join] = ACTIONS(3293),
    [anon_sym_on] = ACTIONS(3293),
    [anon_sym_equals] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_orderby] = ACTIONS(3293),
    [anon_sym_ascending] = ACTIONS(3293),
    [anon_sym_descending] = ACTIONS(3293),
    [anon_sym_group] = ACTIONS(3293),
    [anon_sym_by] = ACTIONS(3293),
    [anon_sym_select] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3295),
    [anon_sym_stackalloc] = ACTIONS(3293),
    [anon_sym_sizeof] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym___makeref] = ACTIONS(3293),
    [anon_sym___reftype] = ACTIONS(3293),
    [anon_sym___refvalue] = ACTIONS(3293),
    [sym_null_literal] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3295),
    [sym_integer_literal] = ACTIONS(3293),
    [sym_real_literal] = ACTIONS(3295),
    [sym_verbatim_string_literal] = ACTIONS(3295),
    [aux_sym_preproc_if_token1] = ACTIONS(3295),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3295),
    [sym_interpolation_verbatim_start] = ACTIONS(3295),
    [sym_interpolation_raw_start] = ACTIONS(3295),
    [sym_raw_string_start] = ACTIONS(3295),
  },
  [2714] = {
    [sym_preproc_region] = STATE(2714),
    [sym_preproc_endregion] = STATE(2714),
    [sym_preproc_line] = STATE(2714),
    [sym_preproc_pragma] = STATE(2714),
    [sym_preproc_nullable] = STATE(2714),
    [sym_preproc_error] = STATE(2714),
    [sym_preproc_define] = STATE(2714),
    [sym_preproc_undef] = STATE(2714),
    [sym__identifier_token] = ACTIONS(3201),
    [anon_sym_extern] = ACTIONS(3201),
    [anon_sym_alias] = ACTIONS(3201),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_global] = ACTIONS(3201),
    [anon_sym_using] = ACTIONS(3201),
    [anon_sym_unsafe] = ACTIONS(3201),
    [anon_sym_static] = ACTIONS(3201),
    [anon_sym_LBRACK] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3201),
    [anon_sym_ref] = ACTIONS(3201),
    [anon_sym_LBRACE] = ACTIONS(3203),
    [anon_sym_RBRACE] = ACTIONS(3203),
    [anon_sym_delegate] = ACTIONS(3201),
    [anon_sym_abstract] = ACTIONS(3201),
    [anon_sym_async] = ACTIONS(3201),
    [anon_sym_const] = ACTIONS(3201),
    [anon_sym_file] = ACTIONS(3201),
    [anon_sym_fixed] = ACTIONS(3201),
    [anon_sym_internal] = ACTIONS(3201),
    [anon_sym_new] = ACTIONS(3201),
    [anon_sym_override] = ACTIONS(3201),
    [anon_sym_partial] = ACTIONS(3201),
    [anon_sym_private] = ACTIONS(3201),
    [anon_sym_protected] = ACTIONS(3201),
    [anon_sym_public] = ACTIONS(3201),
    [anon_sym_readonly] = ACTIONS(3201),
    [anon_sym_required] = ACTIONS(3201),
    [anon_sym_sealed] = ACTIONS(3201),
    [anon_sym_virtual] = ACTIONS(3201),
    [anon_sym_volatile] = ACTIONS(3201),
    [anon_sym_where] = ACTIONS(3201),
    [anon_sym_notnull] = ACTIONS(3201),
    [anon_sym_unmanaged] = ACTIONS(3201),
    [anon_sym_checked] = ACTIONS(3201),
    [anon_sym_BANG] = ACTIONS(3203),
    [anon_sym_TILDE] = ACTIONS(3203),
    [anon_sym_PLUS_PLUS] = ACTIONS(3203),
    [anon_sym_DASH_DASH] = ACTIONS(3203),
    [anon_sym_true] = ACTIONS(3201),
    [anon_sym_false] = ACTIONS(3201),
    [anon_sym_PLUS] = ACTIONS(3201),
    [anon_sym_DASH] = ACTIONS(3201),
    [anon_sym_STAR] = ACTIONS(3203),
    [anon_sym_CARET] = ACTIONS(3203),
    [anon_sym_AMP] = ACTIONS(3203),
    [anon_sym_this] = ACTIONS(3201),
    [anon_sym_scoped] = ACTIONS(3201),
    [anon_sym_base] = ACTIONS(3201),
    [anon_sym_var] = ACTIONS(3201),
    [sym_predefined_type] = ACTIONS(3201),
    [anon_sym_break] = ACTIONS(3201),
    [anon_sym_unchecked] = ACTIONS(3201),
    [anon_sym_continue] = ACTIONS(3201),
    [anon_sym_do] = ACTIONS(3201),
    [anon_sym_while] = ACTIONS(3201),
    [anon_sym_for] = ACTIONS(3201),
    [anon_sym_lock] = ACTIONS(3201),
    [anon_sym_yield] = ACTIONS(3201),
    [anon_sym_switch] = ACTIONS(3201),
    [anon_sym_case] = ACTIONS(3201),
    [anon_sym_default] = ACTIONS(3201),
    [anon_sym_throw] = ACTIONS(3201),
    [anon_sym_try] = ACTIONS(3201),
    [anon_sym_when] = ACTIONS(3201),
    [anon_sym_await] = ACTIONS(3201),
    [anon_sym_foreach] = ACTIONS(3201),
    [anon_sym_goto] = ACTIONS(3201),
    [anon_sym_if] = ACTIONS(3201),
    [anon_sym_else] = ACTIONS(3201),
    [anon_sym_DOT_DOT] = ACTIONS(3203),
    [anon_sym_from] = ACTIONS(3201),
    [anon_sym_into] = ACTIONS(3201),
    [anon_sym_join] = ACTIONS(3201),
    [anon_sym_on] = ACTIONS(3201),
    [anon_sym_equals] = ACTIONS(3201),
    [anon_sym_let] = ACTIONS(3201),
    [anon_sym_orderby] = ACTIONS(3201),
    [anon_sym_ascending] = ACTIONS(3201),
    [anon_sym_descending] = ACTIONS(3201),
    [anon_sym_group] = ACTIONS(3201),
    [anon_sym_by] = ACTIONS(3201),
    [anon_sym_select] = ACTIONS(3201),
    [anon_sym_DQUOTE] = ACTIONS(3203),
    [anon_sym_stackalloc] = ACTIONS(3201),
    [anon_sym_sizeof] = ACTIONS(3201),
    [anon_sym_typeof] = ACTIONS(3201),
    [anon_sym___makeref] = ACTIONS(3201),
    [anon_sym___reftype] = ACTIONS(3201),
    [anon_sym___refvalue] = ACTIONS(3201),
    [sym_null_literal] = ACTIONS(3201),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [sym_integer_literal] = ACTIONS(3201),
    [sym_real_literal] = ACTIONS(3203),
    [sym_verbatim_string_literal] = ACTIONS(3203),
    [aux_sym_preproc_if_token1] = ACTIONS(3203),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3203),
    [sym_interpolation_verbatim_start] = ACTIONS(3203),
    [sym_interpolation_raw_start] = ACTIONS(3203),
    [sym_raw_string_start] = ACTIONS(3203),
  },
  [2715] = {
    [sym_preproc_region] = STATE(2715),
    [sym_preproc_endregion] = STATE(2715),
    [sym_preproc_line] = STATE(2715),
    [sym_preproc_pragma] = STATE(2715),
    [sym_preproc_nullable] = STATE(2715),
    [sym_preproc_error] = STATE(2715),
    [sym_preproc_define] = STATE(2715),
    [sym_preproc_undef] = STATE(2715),
    [sym__identifier_token] = ACTIONS(3197),
    [anon_sym_extern] = ACTIONS(3197),
    [anon_sym_alias] = ACTIONS(3197),
    [anon_sym_SEMI] = ACTIONS(3199),
    [anon_sym_global] = ACTIONS(3197),
    [anon_sym_using] = ACTIONS(3197),
    [anon_sym_unsafe] = ACTIONS(3197),
    [anon_sym_static] = ACTIONS(3197),
    [anon_sym_LBRACK] = ACTIONS(3199),
    [anon_sym_LPAREN] = ACTIONS(3199),
    [anon_sym_return] = ACTIONS(3197),
    [anon_sym_ref] = ACTIONS(3197),
    [anon_sym_LBRACE] = ACTIONS(3199),
    [anon_sym_RBRACE] = ACTIONS(3199),
    [anon_sym_delegate] = ACTIONS(3197),
    [anon_sym_abstract] = ACTIONS(3197),
    [anon_sym_async] = ACTIONS(3197),
    [anon_sym_const] = ACTIONS(3197),
    [anon_sym_file] = ACTIONS(3197),
    [anon_sym_fixed] = ACTIONS(3197),
    [anon_sym_internal] = ACTIONS(3197),
    [anon_sym_new] = ACTIONS(3197),
    [anon_sym_override] = ACTIONS(3197),
    [anon_sym_partial] = ACTIONS(3197),
    [anon_sym_private] = ACTIONS(3197),
    [anon_sym_protected] = ACTIONS(3197),
    [anon_sym_public] = ACTIONS(3197),
    [anon_sym_readonly] = ACTIONS(3197),
    [anon_sym_required] = ACTIONS(3197),
    [anon_sym_sealed] = ACTIONS(3197),
    [anon_sym_virtual] = ACTIONS(3197),
    [anon_sym_volatile] = ACTIONS(3197),
    [anon_sym_where] = ACTIONS(3197),
    [anon_sym_notnull] = ACTIONS(3197),
    [anon_sym_unmanaged] = ACTIONS(3197),
    [anon_sym_checked] = ACTIONS(3197),
    [anon_sym_BANG] = ACTIONS(3199),
    [anon_sym_TILDE] = ACTIONS(3199),
    [anon_sym_PLUS_PLUS] = ACTIONS(3199),
    [anon_sym_DASH_DASH] = ACTIONS(3199),
    [anon_sym_true] = ACTIONS(3197),
    [anon_sym_false] = ACTIONS(3197),
    [anon_sym_PLUS] = ACTIONS(3197),
    [anon_sym_DASH] = ACTIONS(3197),
    [anon_sym_STAR] = ACTIONS(3199),
    [anon_sym_CARET] = ACTIONS(3199),
    [anon_sym_AMP] = ACTIONS(3199),
    [anon_sym_this] = ACTIONS(3197),
    [anon_sym_scoped] = ACTIONS(3197),
    [anon_sym_base] = ACTIONS(3197),
    [anon_sym_var] = ACTIONS(3197),
    [sym_predefined_type] = ACTIONS(3197),
    [anon_sym_break] = ACTIONS(3197),
    [anon_sym_unchecked] = ACTIONS(3197),
    [anon_sym_continue] = ACTIONS(3197),
    [anon_sym_do] = ACTIONS(3197),
    [anon_sym_while] = ACTIONS(3197),
    [anon_sym_for] = ACTIONS(3197),
    [anon_sym_lock] = ACTIONS(3197),
    [anon_sym_yield] = ACTIONS(3197),
    [anon_sym_switch] = ACTIONS(3197),
    [anon_sym_case] = ACTIONS(3197),
    [anon_sym_default] = ACTIONS(3197),
    [anon_sym_throw] = ACTIONS(3197),
    [anon_sym_try] = ACTIONS(3197),
    [anon_sym_when] = ACTIONS(3197),
    [anon_sym_await] = ACTIONS(3197),
    [anon_sym_foreach] = ACTIONS(3197),
    [anon_sym_goto] = ACTIONS(3197),
    [anon_sym_if] = ACTIONS(3197),
    [anon_sym_else] = ACTIONS(3197),
    [anon_sym_DOT_DOT] = ACTIONS(3199),
    [anon_sym_from] = ACTIONS(3197),
    [anon_sym_into] = ACTIONS(3197),
    [anon_sym_join] = ACTIONS(3197),
    [anon_sym_on] = ACTIONS(3197),
    [anon_sym_equals] = ACTIONS(3197),
    [anon_sym_let] = ACTIONS(3197),
    [anon_sym_orderby] = ACTIONS(3197),
    [anon_sym_ascending] = ACTIONS(3197),
    [anon_sym_descending] = ACTIONS(3197),
    [anon_sym_group] = ACTIONS(3197),
    [anon_sym_by] = ACTIONS(3197),
    [anon_sym_select] = ACTIONS(3197),
    [anon_sym_DQUOTE] = ACTIONS(3199),
    [anon_sym_stackalloc] = ACTIONS(3197),
    [anon_sym_sizeof] = ACTIONS(3197),
    [anon_sym_typeof] = ACTIONS(3197),
    [anon_sym___makeref] = ACTIONS(3197),
    [anon_sym___reftype] = ACTIONS(3197),
    [anon_sym___refvalue] = ACTIONS(3197),
    [sym_null_literal] = ACTIONS(3197),
    [anon_sym_SQUOTE] = ACTIONS(3199),
    [sym_integer_literal] = ACTIONS(3197),
    [sym_real_literal] = ACTIONS(3199),
    [sym_verbatim_string_literal] = ACTIONS(3199),
    [aux_sym_preproc_if_token1] = ACTIONS(3199),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3199),
    [sym_interpolation_verbatim_start] = ACTIONS(3199),
    [sym_interpolation_raw_start] = ACTIONS(3199),
    [sym_raw_string_start] = ACTIONS(3199),
  },
  [2716] = {
    [sym_preproc_region] = STATE(2716),
    [sym_preproc_endregion] = STATE(2716),
    [sym_preproc_line] = STATE(2716),
    [sym_preproc_pragma] = STATE(2716),
    [sym_preproc_nullable] = STATE(2716),
    [sym_preproc_error] = STATE(2716),
    [sym_preproc_define] = STATE(2716),
    [sym_preproc_undef] = STATE(2716),
    [sym__identifier_token] = ACTIONS(3289),
    [anon_sym_extern] = ACTIONS(3289),
    [anon_sym_alias] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_using] = ACTIONS(3289),
    [anon_sym_unsafe] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_ref] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_delegate] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [anon_sym_file] = ACTIONS(3289),
    [anon_sym_fixed] = ACTIONS(3289),
    [anon_sym_internal] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_override] = ACTIONS(3289),
    [anon_sym_partial] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_readonly] = ACTIONS(3289),
    [anon_sym_required] = ACTIONS(3289),
    [anon_sym_sealed] = ACTIONS(3289),
    [anon_sym_virtual] = ACTIONS(3289),
    [anon_sym_volatile] = ACTIONS(3289),
    [anon_sym_where] = ACTIONS(3289),
    [anon_sym_notnull] = ACTIONS(3289),
    [anon_sym_unmanaged] = ACTIONS(3289),
    [anon_sym_checked] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_true] = ACTIONS(3289),
    [anon_sym_false] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3291),
    [anon_sym_CARET] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_this] = ACTIONS(3289),
    [anon_sym_scoped] = ACTIONS(3289),
    [anon_sym_base] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [sym_predefined_type] = ACTIONS(3289),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_unchecked] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_lock] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_case] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_when] = ACTIONS(3289),
    [anon_sym_await] = ACTIONS(3289),
    [anon_sym_foreach] = ACTIONS(3289),
    [anon_sym_goto] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_DOT_DOT] = ACTIONS(3291),
    [anon_sym_from] = ACTIONS(3289),
    [anon_sym_into] = ACTIONS(3289),
    [anon_sym_join] = ACTIONS(3289),
    [anon_sym_on] = ACTIONS(3289),
    [anon_sym_equals] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_orderby] = ACTIONS(3289),
    [anon_sym_ascending] = ACTIONS(3289),
    [anon_sym_descending] = ACTIONS(3289),
    [anon_sym_group] = ACTIONS(3289),
    [anon_sym_by] = ACTIONS(3289),
    [anon_sym_select] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_stackalloc] = ACTIONS(3289),
    [anon_sym_sizeof] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym___makeref] = ACTIONS(3289),
    [anon_sym___reftype] = ACTIONS(3289),
    [anon_sym___refvalue] = ACTIONS(3289),
    [sym_null_literal] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [sym_integer_literal] = ACTIONS(3289),
    [sym_real_literal] = ACTIONS(3291),
    [sym_verbatim_string_literal] = ACTIONS(3291),
    [aux_sym_preproc_if_token1] = ACTIONS(3291),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3291),
    [sym_interpolation_verbatim_start] = ACTIONS(3291),
    [sym_interpolation_raw_start] = ACTIONS(3291),
    [sym_raw_string_start] = ACTIONS(3291),
  },
  [2717] = {
    [sym_preproc_region] = STATE(2717),
    [sym_preproc_endregion] = STATE(2717),
    [sym_preproc_line] = STATE(2717),
    [sym_preproc_pragma] = STATE(2717),
    [sym_preproc_nullable] = STATE(2717),
    [sym_preproc_error] = STATE(2717),
    [sym_preproc_define] = STATE(2717),
    [sym_preproc_undef] = STATE(2717),
    [sym__identifier_token] = ACTIONS(3273),
    [anon_sym_extern] = ACTIONS(3273),
    [anon_sym_alias] = ACTIONS(3273),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_global] = ACTIONS(3273),
    [anon_sym_using] = ACTIONS(3273),
    [anon_sym_unsafe] = ACTIONS(3273),
    [anon_sym_static] = ACTIONS(3273),
    [anon_sym_LBRACK] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_return] = ACTIONS(3273),
    [anon_sym_ref] = ACTIONS(3273),
    [anon_sym_LBRACE] = ACTIONS(3275),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_delegate] = ACTIONS(3273),
    [anon_sym_abstract] = ACTIONS(3273),
    [anon_sym_async] = ACTIONS(3273),
    [anon_sym_const] = ACTIONS(3273),
    [anon_sym_file] = ACTIONS(3273),
    [anon_sym_fixed] = ACTIONS(3273),
    [anon_sym_internal] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(3273),
    [anon_sym_override] = ACTIONS(3273),
    [anon_sym_partial] = ACTIONS(3273),
    [anon_sym_private] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(3273),
    [anon_sym_public] = ACTIONS(3273),
    [anon_sym_readonly] = ACTIONS(3273),
    [anon_sym_required] = ACTIONS(3273),
    [anon_sym_sealed] = ACTIONS(3273),
    [anon_sym_virtual] = ACTIONS(3273),
    [anon_sym_volatile] = ACTIONS(3273),
    [anon_sym_where] = ACTIONS(3273),
    [anon_sym_notnull] = ACTIONS(3273),
    [anon_sym_unmanaged] = ACTIONS(3273),
    [anon_sym_checked] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3275),
    [anon_sym_TILDE] = ACTIONS(3275),
    [anon_sym_PLUS_PLUS] = ACTIONS(3275),
    [anon_sym_DASH_DASH] = ACTIONS(3275),
    [anon_sym_true] = ACTIONS(3273),
    [anon_sym_false] = ACTIONS(3273),
    [anon_sym_PLUS] = ACTIONS(3273),
    [anon_sym_DASH] = ACTIONS(3273),
    [anon_sym_STAR] = ACTIONS(3275),
    [anon_sym_CARET] = ACTIONS(3275),
    [anon_sym_AMP] = ACTIONS(3275),
    [anon_sym_this] = ACTIONS(3273),
    [anon_sym_scoped] = ACTIONS(3273),
    [anon_sym_base] = ACTIONS(3273),
    [anon_sym_var] = ACTIONS(3273),
    [sym_predefined_type] = ACTIONS(3273),
    [anon_sym_break] = ACTIONS(3273),
    [anon_sym_unchecked] = ACTIONS(3273),
    [anon_sym_continue] = ACTIONS(3273),
    [anon_sym_do] = ACTIONS(3273),
    [anon_sym_while] = ACTIONS(3273),
    [anon_sym_for] = ACTIONS(3273),
    [anon_sym_lock] = ACTIONS(3273),
    [anon_sym_yield] = ACTIONS(3273),
    [anon_sym_switch] = ACTIONS(3273),
    [anon_sym_case] = ACTIONS(3273),
    [anon_sym_default] = ACTIONS(3273),
    [anon_sym_throw] = ACTIONS(3273),
    [anon_sym_try] = ACTIONS(3273),
    [anon_sym_when] = ACTIONS(3273),
    [anon_sym_await] = ACTIONS(3273),
    [anon_sym_foreach] = ACTIONS(3273),
    [anon_sym_goto] = ACTIONS(3273),
    [anon_sym_if] = ACTIONS(3273),
    [anon_sym_else] = ACTIONS(3273),
    [anon_sym_DOT_DOT] = ACTIONS(3275),
    [anon_sym_from] = ACTIONS(3273),
    [anon_sym_into] = ACTIONS(3273),
    [anon_sym_join] = ACTIONS(3273),
    [anon_sym_on] = ACTIONS(3273),
    [anon_sym_equals] = ACTIONS(3273),
    [anon_sym_let] = ACTIONS(3273),
    [anon_sym_orderby] = ACTIONS(3273),
    [anon_sym_ascending] = ACTIONS(3273),
    [anon_sym_descending] = ACTIONS(3273),
    [anon_sym_group] = ACTIONS(3273),
    [anon_sym_by] = ACTIONS(3273),
    [anon_sym_select] = ACTIONS(3273),
    [anon_sym_DQUOTE] = ACTIONS(3275),
    [anon_sym_stackalloc] = ACTIONS(3273),
    [anon_sym_sizeof] = ACTIONS(3273),
    [anon_sym_typeof] = ACTIONS(3273),
    [anon_sym___makeref] = ACTIONS(3273),
    [anon_sym___reftype] = ACTIONS(3273),
    [anon_sym___refvalue] = ACTIONS(3273),
    [sym_null_literal] = ACTIONS(3273),
    [anon_sym_SQUOTE] = ACTIONS(3275),
    [sym_integer_literal] = ACTIONS(3273),
    [sym_real_literal] = ACTIONS(3275),
    [sym_verbatim_string_literal] = ACTIONS(3275),
    [aux_sym_preproc_if_token1] = ACTIONS(3275),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3275),
    [sym_interpolation_verbatim_start] = ACTIONS(3275),
    [sym_interpolation_raw_start] = ACTIONS(3275),
    [sym_raw_string_start] = ACTIONS(3275),
  },
  [2718] = {
    [sym_preproc_region] = STATE(2718),
    [sym_preproc_endregion] = STATE(2718),
    [sym_preproc_line] = STATE(2718),
    [sym_preproc_pragma] = STATE(2718),
    [sym_preproc_nullable] = STATE(2718),
    [sym_preproc_error] = STATE(2718),
    [sym_preproc_define] = STATE(2718),
    [sym_preproc_undef] = STATE(2718),
    [sym__identifier_token] = ACTIONS(3051),
    [anon_sym_extern] = ACTIONS(3051),
    [anon_sym_alias] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_global] = ACTIONS(3051),
    [anon_sym_using] = ACTIONS(3051),
    [anon_sym_unsafe] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_ref] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_delegate] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_async] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_file] = ACTIONS(3051),
    [anon_sym_fixed] = ACTIONS(3051),
    [anon_sym_internal] = ACTIONS(3051),
    [anon_sym_new] = ACTIONS(3051),
    [anon_sym_override] = ACTIONS(3051),
    [anon_sym_partial] = ACTIONS(3051),
    [anon_sym_private] = ACTIONS(3051),
    [anon_sym_protected] = ACTIONS(3051),
    [anon_sym_public] = ACTIONS(3051),
    [anon_sym_readonly] = ACTIONS(3051),
    [anon_sym_required] = ACTIONS(3051),
    [anon_sym_sealed] = ACTIONS(3051),
    [anon_sym_virtual] = ACTIONS(3051),
    [anon_sym_volatile] = ACTIONS(3051),
    [anon_sym_where] = ACTIONS(3051),
    [anon_sym_notnull] = ACTIONS(3051),
    [anon_sym_unmanaged] = ACTIONS(3051),
    [anon_sym_checked] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_PLUS_PLUS] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3053),
    [anon_sym_true] = ACTIONS(3051),
    [anon_sym_false] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_this] = ACTIONS(3051),
    [anon_sym_scoped] = ACTIONS(3051),
    [anon_sym_base] = ACTIONS(3051),
    [anon_sym_var] = ACTIONS(3051),
    [sym_predefined_type] = ACTIONS(3051),
    [anon_sym_break] = ACTIONS(3051),
    [anon_sym_unchecked] = ACTIONS(3051),
    [anon_sym_continue] = ACTIONS(3051),
    [anon_sym_do] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_lock] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3051),
    [anon_sym_switch] = ACTIONS(3051),
    [anon_sym_case] = ACTIONS(3051),
    [anon_sym_default] = ACTIONS(3051),
    [anon_sym_throw] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_when] = ACTIONS(3051),
    [anon_sym_await] = ACTIONS(3051),
    [anon_sym_foreach] = ACTIONS(3051),
    [anon_sym_goto] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_from] = ACTIONS(3051),
    [anon_sym_into] = ACTIONS(3051),
    [anon_sym_join] = ACTIONS(3051),
    [anon_sym_on] = ACTIONS(3051),
    [anon_sym_equals] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_orderby] = ACTIONS(3051),
    [anon_sym_ascending] = ACTIONS(3051),
    [anon_sym_descending] = ACTIONS(3051),
    [anon_sym_group] = ACTIONS(3051),
    [anon_sym_by] = ACTIONS(3051),
    [anon_sym_select] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_stackalloc] = ACTIONS(3051),
    [anon_sym_sizeof] = ACTIONS(3051),
    [anon_sym_typeof] = ACTIONS(3051),
    [anon_sym___makeref] = ACTIONS(3051),
    [anon_sym___reftype] = ACTIONS(3051),
    [anon_sym___refvalue] = ACTIONS(3051),
    [sym_null_literal] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [sym_integer_literal] = ACTIONS(3051),
    [sym_real_literal] = ACTIONS(3053),
    [sym_verbatim_string_literal] = ACTIONS(3053),
    [aux_sym_preproc_if_token1] = ACTIONS(3053),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3053),
    [sym_interpolation_verbatim_start] = ACTIONS(3053),
    [sym_interpolation_raw_start] = ACTIONS(3053),
    [sym_raw_string_start] = ACTIONS(3053),
  },
  [2719] = {
    [sym_preproc_region] = STATE(2719),
    [sym_preproc_endregion] = STATE(2719),
    [sym_preproc_line] = STATE(2719),
    [sym_preproc_pragma] = STATE(2719),
    [sym_preproc_nullable] = STATE(2719),
    [sym_preproc_error] = STATE(2719),
    [sym_preproc_define] = STATE(2719),
    [sym_preproc_undef] = STATE(2719),
    [sym__identifier_token] = ACTIONS(3249),
    [anon_sym_extern] = ACTIONS(3249),
    [anon_sym_alias] = ACTIONS(3249),
    [anon_sym_SEMI] = ACTIONS(3251),
    [anon_sym_global] = ACTIONS(3249),
    [anon_sym_using] = ACTIONS(3249),
    [anon_sym_unsafe] = ACTIONS(3249),
    [anon_sym_static] = ACTIONS(3249),
    [anon_sym_LBRACK] = ACTIONS(3251),
    [anon_sym_LPAREN] = ACTIONS(3251),
    [anon_sym_return] = ACTIONS(3249),
    [anon_sym_ref] = ACTIONS(3249),
    [anon_sym_LBRACE] = ACTIONS(3251),
    [anon_sym_RBRACE] = ACTIONS(3251),
    [anon_sym_delegate] = ACTIONS(3249),
    [anon_sym_abstract] = ACTIONS(3249),
    [anon_sym_async] = ACTIONS(3249),
    [anon_sym_const] = ACTIONS(3249),
    [anon_sym_file] = ACTIONS(3249),
    [anon_sym_fixed] = ACTIONS(3249),
    [anon_sym_internal] = ACTIONS(3249),
    [anon_sym_new] = ACTIONS(3249),
    [anon_sym_override] = ACTIONS(3249),
    [anon_sym_partial] = ACTIONS(3249),
    [anon_sym_private] = ACTIONS(3249),
    [anon_sym_protected] = ACTIONS(3249),
    [anon_sym_public] = ACTIONS(3249),
    [anon_sym_readonly] = ACTIONS(3249),
    [anon_sym_required] = ACTIONS(3249),
    [anon_sym_sealed] = ACTIONS(3249),
    [anon_sym_virtual] = ACTIONS(3249),
    [anon_sym_volatile] = ACTIONS(3249),
    [anon_sym_where] = ACTIONS(3249),
    [anon_sym_notnull] = ACTIONS(3249),
    [anon_sym_unmanaged] = ACTIONS(3249),
    [anon_sym_checked] = ACTIONS(3249),
    [anon_sym_BANG] = ACTIONS(3251),
    [anon_sym_TILDE] = ACTIONS(3251),
    [anon_sym_PLUS_PLUS] = ACTIONS(3251),
    [anon_sym_DASH_DASH] = ACTIONS(3251),
    [anon_sym_true] = ACTIONS(3249),
    [anon_sym_false] = ACTIONS(3249),
    [anon_sym_PLUS] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_CARET] = ACTIONS(3251),
    [anon_sym_AMP] = ACTIONS(3251),
    [anon_sym_this] = ACTIONS(3249),
    [anon_sym_scoped] = ACTIONS(3249),
    [anon_sym_base] = ACTIONS(3249),
    [anon_sym_var] = ACTIONS(3249),
    [sym_predefined_type] = ACTIONS(3249),
    [anon_sym_break] = ACTIONS(3249),
    [anon_sym_unchecked] = ACTIONS(3249),
    [anon_sym_continue] = ACTIONS(3249),
    [anon_sym_do] = ACTIONS(3249),
    [anon_sym_while] = ACTIONS(3249),
    [anon_sym_for] = ACTIONS(3249),
    [anon_sym_lock] = ACTIONS(3249),
    [anon_sym_yield] = ACTIONS(3249),
    [anon_sym_switch] = ACTIONS(3249),
    [anon_sym_case] = ACTIONS(3249),
    [anon_sym_default] = ACTIONS(3249),
    [anon_sym_throw] = ACTIONS(3249),
    [anon_sym_try] = ACTIONS(3249),
    [anon_sym_when] = ACTIONS(3249),
    [anon_sym_await] = ACTIONS(3249),
    [anon_sym_foreach] = ACTIONS(3249),
    [anon_sym_goto] = ACTIONS(3249),
    [anon_sym_if] = ACTIONS(3249),
    [anon_sym_else] = ACTIONS(3249),
    [anon_sym_DOT_DOT] = ACTIONS(3251),
    [anon_sym_from] = ACTIONS(3249),
    [anon_sym_into] = ACTIONS(3249),
    [anon_sym_join] = ACTIONS(3249),
    [anon_sym_on] = ACTIONS(3249),
    [anon_sym_equals] = ACTIONS(3249),
    [anon_sym_let] = ACTIONS(3249),
    [anon_sym_orderby] = ACTIONS(3249),
    [anon_sym_ascending] = ACTIONS(3249),
    [anon_sym_descending] = ACTIONS(3249),
    [anon_sym_group] = ACTIONS(3249),
    [anon_sym_by] = ACTIONS(3249),
    [anon_sym_select] = ACTIONS(3249),
    [anon_sym_DQUOTE] = ACTIONS(3251),
    [anon_sym_stackalloc] = ACTIONS(3249),
    [anon_sym_sizeof] = ACTIONS(3249),
    [anon_sym_typeof] = ACTIONS(3249),
    [anon_sym___makeref] = ACTIONS(3249),
    [anon_sym___reftype] = ACTIONS(3249),
    [anon_sym___refvalue] = ACTIONS(3249),
    [sym_null_literal] = ACTIONS(3249),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [sym_integer_literal] = ACTIONS(3249),
    [sym_real_literal] = ACTIONS(3251),
    [sym_verbatim_string_literal] = ACTIONS(3251),
    [aux_sym_preproc_if_token1] = ACTIONS(3251),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3251),
    [sym_interpolation_verbatim_start] = ACTIONS(3251),
    [sym_interpolation_raw_start] = ACTIONS(3251),
    [sym_raw_string_start] = ACTIONS(3251),
  },
  [2720] = {
    [sym_preproc_region] = STATE(2720),
    [sym_preproc_endregion] = STATE(2720),
    [sym_preproc_line] = STATE(2720),
    [sym_preproc_pragma] = STATE(2720),
    [sym_preproc_nullable] = STATE(2720),
    [sym_preproc_error] = STATE(2720),
    [sym_preproc_define] = STATE(2720),
    [sym_preproc_undef] = STATE(2720),
    [sym__identifier_token] = ACTIONS(3193),
    [anon_sym_extern] = ACTIONS(3193),
    [anon_sym_alias] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_global] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_unsafe] = ACTIONS(3193),
    [anon_sym_static] = ACTIONS(3193),
    [anon_sym_LBRACK] = ACTIONS(3195),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_ref] = ACTIONS(3193),
    [anon_sym_LBRACE] = ACTIONS(3195),
    [anon_sym_RBRACE] = ACTIONS(3195),
    [anon_sym_delegate] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_async] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_file] = ACTIONS(3193),
    [anon_sym_fixed] = ACTIONS(3193),
    [anon_sym_internal] = ACTIONS(3193),
    [anon_sym_new] = ACTIONS(3193),
    [anon_sym_override] = ACTIONS(3193),
    [anon_sym_partial] = ACTIONS(3193),
    [anon_sym_private] = ACTIONS(3193),
    [anon_sym_protected] = ACTIONS(3193),
    [anon_sym_public] = ACTIONS(3193),
    [anon_sym_readonly] = ACTIONS(3193),
    [anon_sym_required] = ACTIONS(3193),
    [anon_sym_sealed] = ACTIONS(3193),
    [anon_sym_virtual] = ACTIONS(3193),
    [anon_sym_volatile] = ACTIONS(3193),
    [anon_sym_where] = ACTIONS(3193),
    [anon_sym_notnull] = ACTIONS(3193),
    [anon_sym_unmanaged] = ACTIONS(3193),
    [anon_sym_checked] = ACTIONS(3193),
    [anon_sym_BANG] = ACTIONS(3195),
    [anon_sym_TILDE] = ACTIONS(3195),
    [anon_sym_PLUS_PLUS] = ACTIONS(3195),
    [anon_sym_DASH_DASH] = ACTIONS(3195),
    [anon_sym_true] = ACTIONS(3193),
    [anon_sym_false] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [anon_sym_STAR] = ACTIONS(3195),
    [anon_sym_CARET] = ACTIONS(3195),
    [anon_sym_AMP] = ACTIONS(3195),
    [anon_sym_this] = ACTIONS(3193),
    [anon_sym_scoped] = ACTIONS(3193),
    [anon_sym_base] = ACTIONS(3193),
    [anon_sym_var] = ACTIONS(3193),
    [sym_predefined_type] = ACTIONS(3193),
    [anon_sym_break] = ACTIONS(3193),
    [anon_sym_unchecked] = ACTIONS(3193),
    [anon_sym_continue] = ACTIONS(3193),
    [anon_sym_do] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_lock] = ACTIONS(3193),
    [anon_sym_yield] = ACTIONS(3193),
    [anon_sym_switch] = ACTIONS(3193),
    [anon_sym_case] = ACTIONS(3193),
    [anon_sym_default] = ACTIONS(3193),
    [anon_sym_throw] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_when] = ACTIONS(3193),
    [anon_sym_await] = ACTIONS(3193),
    [anon_sym_foreach] = ACTIONS(3193),
    [anon_sym_goto] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_DOT_DOT] = ACTIONS(3195),
    [anon_sym_from] = ACTIONS(3193),
    [anon_sym_into] = ACTIONS(3193),
    [anon_sym_join] = ACTIONS(3193),
    [anon_sym_on] = ACTIONS(3193),
    [anon_sym_equals] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_orderby] = ACTIONS(3193),
    [anon_sym_ascending] = ACTIONS(3193),
    [anon_sym_descending] = ACTIONS(3193),
    [anon_sym_group] = ACTIONS(3193),
    [anon_sym_by] = ACTIONS(3193),
    [anon_sym_select] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_stackalloc] = ACTIONS(3193),
    [anon_sym_sizeof] = ACTIONS(3193),
    [anon_sym_typeof] = ACTIONS(3193),
    [anon_sym___makeref] = ACTIONS(3193),
    [anon_sym___reftype] = ACTIONS(3193),
    [anon_sym___refvalue] = ACTIONS(3193),
    [sym_null_literal] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [sym_integer_literal] = ACTIONS(3193),
    [sym_real_literal] = ACTIONS(3195),
    [sym_verbatim_string_literal] = ACTIONS(3195),
    [aux_sym_preproc_if_token1] = ACTIONS(3195),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3195),
    [sym_interpolation_verbatim_start] = ACTIONS(3195),
    [sym_interpolation_raw_start] = ACTIONS(3195),
    [sym_raw_string_start] = ACTIONS(3195),
  },
  [2721] = {
    [sym_preproc_region] = STATE(2721),
    [sym_preproc_endregion] = STATE(2721),
    [sym_preproc_line] = STATE(2721),
    [sym_preproc_pragma] = STATE(2721),
    [sym_preproc_nullable] = STATE(2721),
    [sym_preproc_error] = STATE(2721),
    [sym_preproc_define] = STATE(2721),
    [sym_preproc_undef] = STATE(2721),
    [sym__identifier_token] = ACTIONS(3189),
    [anon_sym_extern] = ACTIONS(3189),
    [anon_sym_alias] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_global] = ACTIONS(3189),
    [anon_sym_using] = ACTIONS(3189),
    [anon_sym_unsafe] = ACTIONS(3189),
    [anon_sym_static] = ACTIONS(3189),
    [anon_sym_LBRACK] = ACTIONS(3191),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_return] = ACTIONS(3189),
    [anon_sym_ref] = ACTIONS(3189),
    [anon_sym_LBRACE] = ACTIONS(3191),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_delegate] = ACTIONS(3189),
    [anon_sym_abstract] = ACTIONS(3189),
    [anon_sym_async] = ACTIONS(3189),
    [anon_sym_const] = ACTIONS(3189),
    [anon_sym_file] = ACTIONS(3189),
    [anon_sym_fixed] = ACTIONS(3189),
    [anon_sym_internal] = ACTIONS(3189),
    [anon_sym_new] = ACTIONS(3189),
    [anon_sym_override] = ACTIONS(3189),
    [anon_sym_partial] = ACTIONS(3189),
    [anon_sym_private] = ACTIONS(3189),
    [anon_sym_protected] = ACTIONS(3189),
    [anon_sym_public] = ACTIONS(3189),
    [anon_sym_readonly] = ACTIONS(3189),
    [anon_sym_required] = ACTIONS(3189),
    [anon_sym_sealed] = ACTIONS(3189),
    [anon_sym_virtual] = ACTIONS(3189),
    [anon_sym_volatile] = ACTIONS(3189),
    [anon_sym_where] = ACTIONS(3189),
    [anon_sym_notnull] = ACTIONS(3189),
    [anon_sym_unmanaged] = ACTIONS(3189),
    [anon_sym_checked] = ACTIONS(3189),
    [anon_sym_BANG] = ACTIONS(3191),
    [anon_sym_TILDE] = ACTIONS(3191),
    [anon_sym_PLUS_PLUS] = ACTIONS(3191),
    [anon_sym_DASH_DASH] = ACTIONS(3191),
    [anon_sym_true] = ACTIONS(3189),
    [anon_sym_false] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3189),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_STAR] = ACTIONS(3191),
    [anon_sym_CARET] = ACTIONS(3191),
    [anon_sym_AMP] = ACTIONS(3191),
    [anon_sym_this] = ACTIONS(3189),
    [anon_sym_scoped] = ACTIONS(3189),
    [anon_sym_base] = ACTIONS(3189),
    [anon_sym_var] = ACTIONS(3189),
    [sym_predefined_type] = ACTIONS(3189),
    [anon_sym_break] = ACTIONS(3189),
    [anon_sym_unchecked] = ACTIONS(3189),
    [anon_sym_continue] = ACTIONS(3189),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_while] = ACTIONS(3189),
    [anon_sym_for] = ACTIONS(3189),
    [anon_sym_lock] = ACTIONS(3189),
    [anon_sym_yield] = ACTIONS(3189),
    [anon_sym_switch] = ACTIONS(3189),
    [anon_sym_case] = ACTIONS(3189),
    [anon_sym_default] = ACTIONS(3189),
    [anon_sym_throw] = ACTIONS(3189),
    [anon_sym_try] = ACTIONS(3189),
    [anon_sym_when] = ACTIONS(3189),
    [anon_sym_await] = ACTIONS(3189),
    [anon_sym_foreach] = ACTIONS(3189),
    [anon_sym_goto] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3189),
    [anon_sym_else] = ACTIONS(3189),
    [anon_sym_DOT_DOT] = ACTIONS(3191),
    [anon_sym_from] = ACTIONS(3189),
    [anon_sym_into] = ACTIONS(3189),
    [anon_sym_join] = ACTIONS(3189),
    [anon_sym_on] = ACTIONS(3189),
    [anon_sym_equals] = ACTIONS(3189),
    [anon_sym_let] = ACTIONS(3189),
    [anon_sym_orderby] = ACTIONS(3189),
    [anon_sym_ascending] = ACTIONS(3189),
    [anon_sym_descending] = ACTIONS(3189),
    [anon_sym_group] = ACTIONS(3189),
    [anon_sym_by] = ACTIONS(3189),
    [anon_sym_select] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(3191),
    [anon_sym_stackalloc] = ACTIONS(3189),
    [anon_sym_sizeof] = ACTIONS(3189),
    [anon_sym_typeof] = ACTIONS(3189),
    [anon_sym___makeref] = ACTIONS(3189),
    [anon_sym___reftype] = ACTIONS(3189),
    [anon_sym___refvalue] = ACTIONS(3189),
    [sym_null_literal] = ACTIONS(3189),
    [anon_sym_SQUOTE] = ACTIONS(3191),
    [sym_integer_literal] = ACTIONS(3189),
    [sym_real_literal] = ACTIONS(3191),
    [sym_verbatim_string_literal] = ACTIONS(3191),
    [aux_sym_preproc_if_token1] = ACTIONS(3191),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3191),
    [sym_interpolation_verbatim_start] = ACTIONS(3191),
    [sym_interpolation_raw_start] = ACTIONS(3191),
    [sym_raw_string_start] = ACTIONS(3191),
  },
  [2722] = {
    [sym_preproc_region] = STATE(2722),
    [sym_preproc_endregion] = STATE(2722),
    [sym_preproc_line] = STATE(2722),
    [sym_preproc_pragma] = STATE(2722),
    [sym_preproc_nullable] = STATE(2722),
    [sym_preproc_error] = STATE(2722),
    [sym_preproc_define] = STATE(2722),
    [sym_preproc_undef] = STATE(2722),
    [sym__identifier_token] = ACTIONS(3241),
    [anon_sym_extern] = ACTIONS(3241),
    [anon_sym_alias] = ACTIONS(3241),
    [anon_sym_SEMI] = ACTIONS(3243),
    [anon_sym_global] = ACTIONS(3241),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_unsafe] = ACTIONS(3241),
    [anon_sym_static] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3243),
    [anon_sym_LPAREN] = ACTIONS(3243),
    [anon_sym_return] = ACTIONS(3241),
    [anon_sym_ref] = ACTIONS(3241),
    [anon_sym_LBRACE] = ACTIONS(3243),
    [anon_sym_RBRACE] = ACTIONS(3243),
    [anon_sym_delegate] = ACTIONS(3241),
    [anon_sym_abstract] = ACTIONS(3241),
    [anon_sym_async] = ACTIONS(3241),
    [anon_sym_const] = ACTIONS(3241),
    [anon_sym_file] = ACTIONS(3241),
    [anon_sym_fixed] = ACTIONS(3241),
    [anon_sym_internal] = ACTIONS(3241),
    [anon_sym_new] = ACTIONS(3241),
    [anon_sym_override] = ACTIONS(3241),
    [anon_sym_partial] = ACTIONS(3241),
    [anon_sym_private] = ACTIONS(3241),
    [anon_sym_protected] = ACTIONS(3241),
    [anon_sym_public] = ACTIONS(3241),
    [anon_sym_readonly] = ACTIONS(3241),
    [anon_sym_required] = ACTIONS(3241),
    [anon_sym_sealed] = ACTIONS(3241),
    [anon_sym_virtual] = ACTIONS(3241),
    [anon_sym_volatile] = ACTIONS(3241),
    [anon_sym_where] = ACTIONS(3241),
    [anon_sym_notnull] = ACTIONS(3241),
    [anon_sym_unmanaged] = ACTIONS(3241),
    [anon_sym_checked] = ACTIONS(3241),
    [anon_sym_BANG] = ACTIONS(3243),
    [anon_sym_TILDE] = ACTIONS(3243),
    [anon_sym_PLUS_PLUS] = ACTIONS(3243),
    [anon_sym_DASH_DASH] = ACTIONS(3243),
    [anon_sym_true] = ACTIONS(3241),
    [anon_sym_false] = ACTIONS(3241),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_STAR] = ACTIONS(3243),
    [anon_sym_CARET] = ACTIONS(3243),
    [anon_sym_AMP] = ACTIONS(3243),
    [anon_sym_this] = ACTIONS(3241),
    [anon_sym_scoped] = ACTIONS(3241),
    [anon_sym_base] = ACTIONS(3241),
    [anon_sym_var] = ACTIONS(3241),
    [sym_predefined_type] = ACTIONS(3241),
    [anon_sym_break] = ACTIONS(3241),
    [anon_sym_unchecked] = ACTIONS(3241),
    [anon_sym_continue] = ACTIONS(3241),
    [anon_sym_do] = ACTIONS(3241),
    [anon_sym_while] = ACTIONS(3241),
    [anon_sym_for] = ACTIONS(3241),
    [anon_sym_lock] = ACTIONS(3241),
    [anon_sym_yield] = ACTIONS(3241),
    [anon_sym_switch] = ACTIONS(3241),
    [anon_sym_case] = ACTIONS(3241),
    [anon_sym_default] = ACTIONS(3241),
    [anon_sym_throw] = ACTIONS(3241),
    [anon_sym_try] = ACTIONS(3241),
    [anon_sym_when] = ACTIONS(3241),
    [anon_sym_await] = ACTIONS(3241),
    [anon_sym_foreach] = ACTIONS(3241),
    [anon_sym_goto] = ACTIONS(3241),
    [anon_sym_if] = ACTIONS(3241),
    [anon_sym_else] = ACTIONS(3241),
    [anon_sym_DOT_DOT] = ACTIONS(3243),
    [anon_sym_from] = ACTIONS(3241),
    [anon_sym_into] = ACTIONS(3241),
    [anon_sym_join] = ACTIONS(3241),
    [anon_sym_on] = ACTIONS(3241),
    [anon_sym_equals] = ACTIONS(3241),
    [anon_sym_let] = ACTIONS(3241),
    [anon_sym_orderby] = ACTIONS(3241),
    [anon_sym_ascending] = ACTIONS(3241),
    [anon_sym_descending] = ACTIONS(3241),
    [anon_sym_group] = ACTIONS(3241),
    [anon_sym_by] = ACTIONS(3241),
    [anon_sym_select] = ACTIONS(3241),
    [anon_sym_DQUOTE] = ACTIONS(3243),
    [anon_sym_stackalloc] = ACTIONS(3241),
    [anon_sym_sizeof] = ACTIONS(3241),
    [anon_sym_typeof] = ACTIONS(3241),
    [anon_sym___makeref] = ACTIONS(3241),
    [anon_sym___reftype] = ACTIONS(3241),
    [anon_sym___refvalue] = ACTIONS(3241),
    [sym_null_literal] = ACTIONS(3241),
    [anon_sym_SQUOTE] = ACTIONS(3243),
    [sym_integer_literal] = ACTIONS(3241),
    [sym_real_literal] = ACTIONS(3243),
    [sym_verbatim_string_literal] = ACTIONS(3243),
    [aux_sym_preproc_if_token1] = ACTIONS(3243),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3243),
    [sym_interpolation_verbatim_start] = ACTIONS(3243),
    [sym_interpolation_raw_start] = ACTIONS(3243),
    [sym_raw_string_start] = ACTIONS(3243),
  },
  [2723] = {
    [sym_preproc_region] = STATE(2723),
    [sym_preproc_endregion] = STATE(2723),
    [sym_preproc_line] = STATE(2723),
    [sym_preproc_pragma] = STATE(2723),
    [sym_preproc_nullable] = STATE(2723),
    [sym_preproc_error] = STATE(2723),
    [sym_preproc_define] = STATE(2723),
    [sym_preproc_undef] = STATE(2723),
    [sym__identifier_token] = ACTIONS(3221),
    [anon_sym_extern] = ACTIONS(3221),
    [anon_sym_alias] = ACTIONS(3221),
    [anon_sym_SEMI] = ACTIONS(3223),
    [anon_sym_global] = ACTIONS(3221),
    [anon_sym_using] = ACTIONS(3221),
    [anon_sym_unsafe] = ACTIONS(3221),
    [anon_sym_static] = ACTIONS(3221),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_LPAREN] = ACTIONS(3223),
    [anon_sym_return] = ACTIONS(3221),
    [anon_sym_ref] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_delegate] = ACTIONS(3221),
    [anon_sym_abstract] = ACTIONS(3221),
    [anon_sym_async] = ACTIONS(3221),
    [anon_sym_const] = ACTIONS(3221),
    [anon_sym_file] = ACTIONS(3221),
    [anon_sym_fixed] = ACTIONS(3221),
    [anon_sym_internal] = ACTIONS(3221),
    [anon_sym_new] = ACTIONS(3221),
    [anon_sym_override] = ACTIONS(3221),
    [anon_sym_partial] = ACTIONS(3221),
    [anon_sym_private] = ACTIONS(3221),
    [anon_sym_protected] = ACTIONS(3221),
    [anon_sym_public] = ACTIONS(3221),
    [anon_sym_readonly] = ACTIONS(3221),
    [anon_sym_required] = ACTIONS(3221),
    [anon_sym_sealed] = ACTIONS(3221),
    [anon_sym_virtual] = ACTIONS(3221),
    [anon_sym_volatile] = ACTIONS(3221),
    [anon_sym_where] = ACTIONS(3221),
    [anon_sym_notnull] = ACTIONS(3221),
    [anon_sym_unmanaged] = ACTIONS(3221),
    [anon_sym_checked] = ACTIONS(3221),
    [anon_sym_BANG] = ACTIONS(3223),
    [anon_sym_TILDE] = ACTIONS(3223),
    [anon_sym_PLUS_PLUS] = ACTIONS(3223),
    [anon_sym_DASH_DASH] = ACTIONS(3223),
    [anon_sym_true] = ACTIONS(3221),
    [anon_sym_false] = ACTIONS(3221),
    [anon_sym_PLUS] = ACTIONS(3221),
    [anon_sym_DASH] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(3223),
    [anon_sym_CARET] = ACTIONS(3223),
    [anon_sym_AMP] = ACTIONS(3223),
    [anon_sym_this] = ACTIONS(3221),
    [anon_sym_scoped] = ACTIONS(3221),
    [anon_sym_base] = ACTIONS(3221),
    [anon_sym_var] = ACTIONS(3221),
    [sym_predefined_type] = ACTIONS(3221),
    [anon_sym_break] = ACTIONS(3221),
    [anon_sym_unchecked] = ACTIONS(3221),
    [anon_sym_continue] = ACTIONS(3221),
    [anon_sym_do] = ACTIONS(3221),
    [anon_sym_while] = ACTIONS(3221),
    [anon_sym_for] = ACTIONS(3221),
    [anon_sym_lock] = ACTIONS(3221),
    [anon_sym_yield] = ACTIONS(3221),
    [anon_sym_switch] = ACTIONS(3221),
    [anon_sym_case] = ACTIONS(3221),
    [anon_sym_default] = ACTIONS(3221),
    [anon_sym_throw] = ACTIONS(3221),
    [anon_sym_try] = ACTIONS(3221),
    [anon_sym_when] = ACTIONS(3221),
    [anon_sym_await] = ACTIONS(3221),
    [anon_sym_foreach] = ACTIONS(3221),
    [anon_sym_goto] = ACTIONS(3221),
    [anon_sym_if] = ACTIONS(3221),
    [anon_sym_else] = ACTIONS(3221),
    [anon_sym_DOT_DOT] = ACTIONS(3223),
    [anon_sym_from] = ACTIONS(3221),
    [anon_sym_into] = ACTIONS(3221),
    [anon_sym_join] = ACTIONS(3221),
    [anon_sym_on] = ACTIONS(3221),
    [anon_sym_equals] = ACTIONS(3221),
    [anon_sym_let] = ACTIONS(3221),
    [anon_sym_orderby] = ACTIONS(3221),
    [anon_sym_ascending] = ACTIONS(3221),
    [anon_sym_descending] = ACTIONS(3221),
    [anon_sym_group] = ACTIONS(3221),
    [anon_sym_by] = ACTIONS(3221),
    [anon_sym_select] = ACTIONS(3221),
    [anon_sym_DQUOTE] = ACTIONS(3223),
    [anon_sym_stackalloc] = ACTIONS(3221),
    [anon_sym_sizeof] = ACTIONS(3221),
    [anon_sym_typeof] = ACTIONS(3221),
    [anon_sym___makeref] = ACTIONS(3221),
    [anon_sym___reftype] = ACTIONS(3221),
    [anon_sym___refvalue] = ACTIONS(3221),
    [sym_null_literal] = ACTIONS(3221),
    [anon_sym_SQUOTE] = ACTIONS(3223),
    [sym_integer_literal] = ACTIONS(3221),
    [sym_real_literal] = ACTIONS(3223),
    [sym_verbatim_string_literal] = ACTIONS(3223),
    [aux_sym_preproc_if_token1] = ACTIONS(3223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3223),
    [sym_interpolation_verbatim_start] = ACTIONS(3223),
    [sym_interpolation_raw_start] = ACTIONS(3223),
    [sym_raw_string_start] = ACTIONS(3223),
  },
  [2724] = {
    [sym_preproc_region] = STATE(2724),
    [sym_preproc_endregion] = STATE(2724),
    [sym_preproc_line] = STATE(2724),
    [sym_preproc_pragma] = STATE(2724),
    [sym_preproc_nullable] = STATE(2724),
    [sym_preproc_error] = STATE(2724),
    [sym_preproc_define] = STATE(2724),
    [sym_preproc_undef] = STATE(2724),
    [sym__identifier_token] = ACTIONS(3217),
    [anon_sym_extern] = ACTIONS(3217),
    [anon_sym_alias] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_global] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_unsafe] = ACTIONS(3217),
    [anon_sym_static] = ACTIONS(3217),
    [anon_sym_LBRACK] = ACTIONS(3219),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_ref] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_delegate] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_async] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_file] = ACTIONS(3217),
    [anon_sym_fixed] = ACTIONS(3217),
    [anon_sym_internal] = ACTIONS(3217),
    [anon_sym_new] = ACTIONS(3217),
    [anon_sym_override] = ACTIONS(3217),
    [anon_sym_partial] = ACTIONS(3217),
    [anon_sym_private] = ACTIONS(3217),
    [anon_sym_protected] = ACTIONS(3217),
    [anon_sym_public] = ACTIONS(3217),
    [anon_sym_readonly] = ACTIONS(3217),
    [anon_sym_required] = ACTIONS(3217),
    [anon_sym_sealed] = ACTIONS(3217),
    [anon_sym_virtual] = ACTIONS(3217),
    [anon_sym_volatile] = ACTIONS(3217),
    [anon_sym_where] = ACTIONS(3217),
    [anon_sym_notnull] = ACTIONS(3217),
    [anon_sym_unmanaged] = ACTIONS(3217),
    [anon_sym_checked] = ACTIONS(3217),
    [anon_sym_BANG] = ACTIONS(3219),
    [anon_sym_TILDE] = ACTIONS(3219),
    [anon_sym_PLUS_PLUS] = ACTIONS(3219),
    [anon_sym_DASH_DASH] = ACTIONS(3219),
    [anon_sym_true] = ACTIONS(3217),
    [anon_sym_false] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_DASH] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3219),
    [anon_sym_CARET] = ACTIONS(3219),
    [anon_sym_AMP] = ACTIONS(3219),
    [anon_sym_this] = ACTIONS(3217),
    [anon_sym_scoped] = ACTIONS(3217),
    [anon_sym_base] = ACTIONS(3217),
    [anon_sym_var] = ACTIONS(3217),
    [sym_predefined_type] = ACTIONS(3217),
    [anon_sym_break] = ACTIONS(3217),
    [anon_sym_unchecked] = ACTIONS(3217),
    [anon_sym_continue] = ACTIONS(3217),
    [anon_sym_do] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_lock] = ACTIONS(3217),
    [anon_sym_yield] = ACTIONS(3217),
    [anon_sym_switch] = ACTIONS(3217),
    [anon_sym_case] = ACTIONS(3217),
    [anon_sym_default] = ACTIONS(3217),
    [anon_sym_throw] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_when] = ACTIONS(3217),
    [anon_sym_await] = ACTIONS(3217),
    [anon_sym_foreach] = ACTIONS(3217),
    [anon_sym_goto] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_DOT_DOT] = ACTIONS(3219),
    [anon_sym_from] = ACTIONS(3217),
    [anon_sym_into] = ACTIONS(3217),
    [anon_sym_join] = ACTIONS(3217),
    [anon_sym_on] = ACTIONS(3217),
    [anon_sym_equals] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_orderby] = ACTIONS(3217),
    [anon_sym_ascending] = ACTIONS(3217),
    [anon_sym_descending] = ACTIONS(3217),
    [anon_sym_group] = ACTIONS(3217),
    [anon_sym_by] = ACTIONS(3217),
    [anon_sym_select] = ACTIONS(3217),
    [anon_sym_DQUOTE] = ACTIONS(3219),
    [anon_sym_stackalloc] = ACTIONS(3217),
    [anon_sym_sizeof] = ACTIONS(3217),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym___makeref] = ACTIONS(3217),
    [anon_sym___reftype] = ACTIONS(3217),
    [anon_sym___refvalue] = ACTIONS(3217),
    [sym_null_literal] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [sym_integer_literal] = ACTIONS(3217),
    [sym_real_literal] = ACTIONS(3219),
    [sym_verbatim_string_literal] = ACTIONS(3219),
    [aux_sym_preproc_if_token1] = ACTIONS(3219),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3219),
    [sym_interpolation_verbatim_start] = ACTIONS(3219),
    [sym_interpolation_raw_start] = ACTIONS(3219),
    [sym_raw_string_start] = ACTIONS(3219),
  },
  [2725] = {
    [sym_preproc_region] = STATE(2725),
    [sym_preproc_endregion] = STATE(2725),
    [sym_preproc_line] = STATE(2725),
    [sym_preproc_pragma] = STATE(2725),
    [sym_preproc_nullable] = STATE(2725),
    [sym_preproc_error] = STATE(2725),
    [sym_preproc_define] = STATE(2725),
    [sym_preproc_undef] = STATE(2725),
    [sym__identifier_token] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym_alias] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_unsafe] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_ref] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_RBRACE] = ACTIONS(3093),
    [anon_sym_delegate] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3091),
    [anon_sym_async] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_file] = ACTIONS(3091),
    [anon_sym_fixed] = ACTIONS(3091),
    [anon_sym_internal] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_override] = ACTIONS(3091),
    [anon_sym_partial] = ACTIONS(3091),
    [anon_sym_private] = ACTIONS(3091),
    [anon_sym_protected] = ACTIONS(3091),
    [anon_sym_public] = ACTIONS(3091),
    [anon_sym_readonly] = ACTIONS(3091),
    [anon_sym_required] = ACTIONS(3091),
    [anon_sym_sealed] = ACTIONS(3091),
    [anon_sym_virtual] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym_where] = ACTIONS(3091),
    [anon_sym_notnull] = ACTIONS(3091),
    [anon_sym_unmanaged] = ACTIONS(3091),
    [anon_sym_checked] = ACTIONS(3091),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_true] = ACTIONS(3091),
    [anon_sym_false] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_this] = ACTIONS(3091),
    [anon_sym_scoped] = ACTIONS(3091),
    [anon_sym_base] = ACTIONS(3091),
    [anon_sym_var] = ACTIONS(3091),
    [sym_predefined_type] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_unchecked] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_lock] = ACTIONS(3091),
    [anon_sym_yield] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_case] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_when] = ACTIONS(3091),
    [anon_sym_await] = ACTIONS(3091),
    [anon_sym_foreach] = ACTIONS(3091),
    [anon_sym_goto] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_else] = ACTIONS(3091),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_from] = ACTIONS(3091),
    [anon_sym_into] = ACTIONS(3091),
    [anon_sym_join] = ACTIONS(3091),
    [anon_sym_on] = ACTIONS(3091),
    [anon_sym_equals] = ACTIONS(3091),
    [anon_sym_let] = ACTIONS(3091),
    [anon_sym_orderby] = ACTIONS(3091),
    [anon_sym_ascending] = ACTIONS(3091),
    [anon_sym_descending] = ACTIONS(3091),
    [anon_sym_group] = ACTIONS(3091),
    [anon_sym_by] = ACTIONS(3091),
    [anon_sym_select] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [anon_sym_stackalloc] = ACTIONS(3091),
    [anon_sym_sizeof] = ACTIONS(3091),
    [anon_sym_typeof] = ACTIONS(3091),
    [anon_sym___makeref] = ACTIONS(3091),
    [anon_sym___reftype] = ACTIONS(3091),
    [anon_sym___refvalue] = ACTIONS(3091),
    [sym_null_literal] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [sym_integer_literal] = ACTIONS(3091),
    [sym_real_literal] = ACTIONS(3093),
    [sym_verbatim_string_literal] = ACTIONS(3093),
    [aux_sym_preproc_if_token1] = ACTIONS(3093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3093),
    [sym_interpolation_verbatim_start] = ACTIONS(3093),
    [sym_interpolation_raw_start] = ACTIONS(3093),
    [sym_raw_string_start] = ACTIONS(3093),
  },
  [2726] = {
    [sym_preproc_region] = STATE(2726),
    [sym_preproc_endregion] = STATE(2726),
    [sym_preproc_line] = STATE(2726),
    [sym_preproc_pragma] = STATE(2726),
    [sym_preproc_nullable] = STATE(2726),
    [sym_preproc_error] = STATE(2726),
    [sym_preproc_define] = STATE(2726),
    [sym_preproc_undef] = STATE(2726),
    [sym__identifier_token] = ACTIONS(3183),
    [anon_sym_extern] = ACTIONS(3183),
    [anon_sym_alias] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_global] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_unsafe] = ACTIONS(3183),
    [anon_sym_static] = ACTIONS(3183),
    [anon_sym_LBRACK] = ACTIONS(3185),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_ref] = ACTIONS(3183),
    [anon_sym_LBRACE] = ACTIONS(3185),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_delegate] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_async] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_file] = ACTIONS(3183),
    [anon_sym_fixed] = ACTIONS(3183),
    [anon_sym_internal] = ACTIONS(3183),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_override] = ACTIONS(3183),
    [anon_sym_partial] = ACTIONS(3183),
    [anon_sym_private] = ACTIONS(3183),
    [anon_sym_protected] = ACTIONS(3183),
    [anon_sym_public] = ACTIONS(3183),
    [anon_sym_readonly] = ACTIONS(3183),
    [anon_sym_required] = ACTIONS(3183),
    [anon_sym_sealed] = ACTIONS(3183),
    [anon_sym_virtual] = ACTIONS(3183),
    [anon_sym_volatile] = ACTIONS(3183),
    [anon_sym_where] = ACTIONS(3183),
    [anon_sym_notnull] = ACTIONS(3183),
    [anon_sym_unmanaged] = ACTIONS(3183),
    [anon_sym_checked] = ACTIONS(3183),
    [anon_sym_BANG] = ACTIONS(3185),
    [anon_sym_TILDE] = ACTIONS(3185),
    [anon_sym_PLUS_PLUS] = ACTIONS(3185),
    [anon_sym_DASH_DASH] = ACTIONS(3185),
    [anon_sym_true] = ACTIONS(3183),
    [anon_sym_false] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_DASH] = ACTIONS(3183),
    [anon_sym_STAR] = ACTIONS(3185),
    [anon_sym_CARET] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3185),
    [anon_sym_this] = ACTIONS(3183),
    [anon_sym_scoped] = ACTIONS(3183),
    [anon_sym_base] = ACTIONS(3183),
    [anon_sym_var] = ACTIONS(3183),
    [sym_predefined_type] = ACTIONS(3183),
    [anon_sym_break] = ACTIONS(3183),
    [anon_sym_unchecked] = ACTIONS(3183),
    [anon_sym_continue] = ACTIONS(3183),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_lock] = ACTIONS(3183),
    [anon_sym_yield] = ACTIONS(3183),
    [anon_sym_switch] = ACTIONS(3183),
    [anon_sym_case] = ACTIONS(3183),
    [anon_sym_default] = ACTIONS(3183),
    [anon_sym_throw] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_when] = ACTIONS(3183),
    [anon_sym_await] = ACTIONS(3183),
    [anon_sym_foreach] = ACTIONS(3183),
    [anon_sym_goto] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(4045),
    [anon_sym_DOT_DOT] = ACTIONS(3185),
    [anon_sym_from] = ACTIONS(3183),
    [anon_sym_into] = ACTIONS(3183),
    [anon_sym_join] = ACTIONS(3183),
    [anon_sym_on] = ACTIONS(3183),
    [anon_sym_equals] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_orderby] = ACTIONS(3183),
    [anon_sym_ascending] = ACTIONS(3183),
    [anon_sym_descending] = ACTIONS(3183),
    [anon_sym_group] = ACTIONS(3183),
    [anon_sym_by] = ACTIONS(3183),
    [anon_sym_select] = ACTIONS(3183),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [anon_sym_stackalloc] = ACTIONS(3183),
    [anon_sym_sizeof] = ACTIONS(3183),
    [anon_sym_typeof] = ACTIONS(3183),
    [anon_sym___makeref] = ACTIONS(3183),
    [anon_sym___reftype] = ACTIONS(3183),
    [anon_sym___refvalue] = ACTIONS(3183),
    [sym_null_literal] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [sym_integer_literal] = ACTIONS(3183),
    [sym_real_literal] = ACTIONS(3185),
    [sym_verbatim_string_literal] = ACTIONS(3185),
    [aux_sym_preproc_if_token1] = ACTIONS(3185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3185),
    [sym_interpolation_verbatim_start] = ACTIONS(3185),
    [sym_interpolation_raw_start] = ACTIONS(3185),
    [sym_raw_string_start] = ACTIONS(3185),
  },
  [2727] = {
    [sym_preproc_region] = STATE(2727),
    [sym_preproc_endregion] = STATE(2727),
    [sym_preproc_line] = STATE(2727),
    [sym_preproc_pragma] = STATE(2727),
    [sym_preproc_nullable] = STATE(2727),
    [sym_preproc_error] = STATE(2727),
    [sym_preproc_define] = STATE(2727),
    [sym_preproc_undef] = STATE(2727),
    [sym__identifier_token] = ACTIONS(3179),
    [anon_sym_extern] = ACTIONS(3179),
    [anon_sym_alias] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_global] = ACTIONS(3179),
    [anon_sym_using] = ACTIONS(3179),
    [anon_sym_unsafe] = ACTIONS(3179),
    [anon_sym_static] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_ref] = ACTIONS(3179),
    [anon_sym_LBRACE] = ACTIONS(3181),
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_delegate] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_async] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_file] = ACTIONS(3179),
    [anon_sym_fixed] = ACTIONS(3179),
    [anon_sym_internal] = ACTIONS(3179),
    [anon_sym_new] = ACTIONS(3179),
    [anon_sym_override] = ACTIONS(3179),
    [anon_sym_partial] = ACTIONS(3179),
    [anon_sym_private] = ACTIONS(3179),
    [anon_sym_protected] = ACTIONS(3179),
    [anon_sym_public] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3179),
    [anon_sym_required] = ACTIONS(3179),
    [anon_sym_sealed] = ACTIONS(3179),
    [anon_sym_virtual] = ACTIONS(3179),
    [anon_sym_volatile] = ACTIONS(3179),
    [anon_sym_where] = ACTIONS(3179),
    [anon_sym_notnull] = ACTIONS(3179),
    [anon_sym_unmanaged] = ACTIONS(3179),
    [anon_sym_checked] = ACTIONS(3179),
    [anon_sym_BANG] = ACTIONS(3181),
    [anon_sym_TILDE] = ACTIONS(3181),
    [anon_sym_PLUS_PLUS] = ACTIONS(3181),
    [anon_sym_DASH_DASH] = ACTIONS(3181),
    [anon_sym_true] = ACTIONS(3179),
    [anon_sym_false] = ACTIONS(3179),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [anon_sym_STAR] = ACTIONS(3181),
    [anon_sym_CARET] = ACTIONS(3181),
    [anon_sym_AMP] = ACTIONS(3181),
    [anon_sym_this] = ACTIONS(3179),
    [anon_sym_scoped] = ACTIONS(3179),
    [anon_sym_base] = ACTIONS(3179),
    [anon_sym_var] = ACTIONS(3179),
    [sym_predefined_type] = ACTIONS(3179),
    [anon_sym_break] = ACTIONS(3179),
    [anon_sym_unchecked] = ACTIONS(3179),
    [anon_sym_continue] = ACTIONS(3179),
    [anon_sym_do] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_lock] = ACTIONS(3179),
    [anon_sym_yield] = ACTIONS(3179),
    [anon_sym_switch] = ACTIONS(3179),
    [anon_sym_case] = ACTIONS(3179),
    [anon_sym_default] = ACTIONS(3179),
    [anon_sym_throw] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_when] = ACTIONS(3179),
    [anon_sym_await] = ACTIONS(3179),
    [anon_sym_foreach] = ACTIONS(3179),
    [anon_sym_goto] = ACTIONS(3179),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_else] = ACTIONS(3179),
    [anon_sym_DOT_DOT] = ACTIONS(3181),
    [anon_sym_from] = ACTIONS(3179),
    [anon_sym_into] = ACTIONS(3179),
    [anon_sym_join] = ACTIONS(3179),
    [anon_sym_on] = ACTIONS(3179),
    [anon_sym_equals] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_orderby] = ACTIONS(3179),
    [anon_sym_ascending] = ACTIONS(3179),
    [anon_sym_descending] = ACTIONS(3179),
    [anon_sym_group] = ACTIONS(3179),
    [anon_sym_by] = ACTIONS(3179),
    [anon_sym_select] = ACTIONS(3179),
    [anon_sym_DQUOTE] = ACTIONS(3181),
    [anon_sym_stackalloc] = ACTIONS(3179),
    [anon_sym_sizeof] = ACTIONS(3179),
    [anon_sym_typeof] = ACTIONS(3179),
    [anon_sym___makeref] = ACTIONS(3179),
    [anon_sym___reftype] = ACTIONS(3179),
    [anon_sym___refvalue] = ACTIONS(3179),
    [sym_null_literal] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [sym_integer_literal] = ACTIONS(3179),
    [sym_real_literal] = ACTIONS(3181),
    [sym_verbatim_string_literal] = ACTIONS(3181),
    [aux_sym_preproc_if_token1] = ACTIONS(3181),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3181),
    [sym_interpolation_verbatim_start] = ACTIONS(3181),
    [sym_interpolation_raw_start] = ACTIONS(3181),
    [sym_raw_string_start] = ACTIONS(3181),
  },
  [2728] = {
    [sym_preproc_region] = STATE(2728),
    [sym_preproc_endregion] = STATE(2728),
    [sym_preproc_line] = STATE(2728),
    [sym_preproc_pragma] = STATE(2728),
    [sym_preproc_nullable] = STATE(2728),
    [sym_preproc_error] = STATE(2728),
    [sym_preproc_define] = STATE(2728),
    [sym_preproc_undef] = STATE(2728),
    [sym__identifier_token] = ACTIONS(3167),
    [anon_sym_extern] = ACTIONS(3167),
    [anon_sym_alias] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_global] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_unsafe] = ACTIONS(3167),
    [anon_sym_static] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_ref] = ACTIONS(3167),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_delegate] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_async] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_file] = ACTIONS(3167),
    [anon_sym_fixed] = ACTIONS(3167),
    [anon_sym_internal] = ACTIONS(3167),
    [anon_sym_new] = ACTIONS(3167),
    [anon_sym_override] = ACTIONS(3167),
    [anon_sym_partial] = ACTIONS(3167),
    [anon_sym_private] = ACTIONS(3167),
    [anon_sym_protected] = ACTIONS(3167),
    [anon_sym_public] = ACTIONS(3167),
    [anon_sym_readonly] = ACTIONS(3167),
    [anon_sym_required] = ACTIONS(3167),
    [anon_sym_sealed] = ACTIONS(3167),
    [anon_sym_virtual] = ACTIONS(3167),
    [anon_sym_volatile] = ACTIONS(3167),
    [anon_sym_where] = ACTIONS(3167),
    [anon_sym_notnull] = ACTIONS(3167),
    [anon_sym_unmanaged] = ACTIONS(3167),
    [anon_sym_checked] = ACTIONS(3167),
    [anon_sym_BANG] = ACTIONS(3169),
    [anon_sym_TILDE] = ACTIONS(3169),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [anon_sym_true] = ACTIONS(3167),
    [anon_sym_false] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_STAR] = ACTIONS(3169),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3169),
    [anon_sym_this] = ACTIONS(3167),
    [anon_sym_scoped] = ACTIONS(3167),
    [anon_sym_base] = ACTIONS(3167),
    [anon_sym_var] = ACTIONS(3167),
    [sym_predefined_type] = ACTIONS(3167),
    [anon_sym_break] = ACTIONS(3167),
    [anon_sym_unchecked] = ACTIONS(3167),
    [anon_sym_continue] = ACTIONS(3167),
    [anon_sym_do] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_lock] = ACTIONS(3167),
    [anon_sym_yield] = ACTIONS(3167),
    [anon_sym_switch] = ACTIONS(3167),
    [anon_sym_case] = ACTIONS(3167),
    [anon_sym_default] = ACTIONS(3167),
    [anon_sym_throw] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_when] = ACTIONS(3167),
    [anon_sym_await] = ACTIONS(3167),
    [anon_sym_foreach] = ACTIONS(3167),
    [anon_sym_goto] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_DOT_DOT] = ACTIONS(3169),
    [anon_sym_from] = ACTIONS(3167),
    [anon_sym_into] = ACTIONS(3167),
    [anon_sym_join] = ACTIONS(3167),
    [anon_sym_on] = ACTIONS(3167),
    [anon_sym_equals] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_orderby] = ACTIONS(3167),
    [anon_sym_ascending] = ACTIONS(3167),
    [anon_sym_descending] = ACTIONS(3167),
    [anon_sym_group] = ACTIONS(3167),
    [anon_sym_by] = ACTIONS(3167),
    [anon_sym_select] = ACTIONS(3167),
    [anon_sym_DQUOTE] = ACTIONS(3169),
    [anon_sym_stackalloc] = ACTIONS(3167),
    [anon_sym_sizeof] = ACTIONS(3167),
    [anon_sym_typeof] = ACTIONS(3167),
    [anon_sym___makeref] = ACTIONS(3167),
    [anon_sym___reftype] = ACTIONS(3167),
    [anon_sym___refvalue] = ACTIONS(3167),
    [sym_null_literal] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3169),
    [sym_integer_literal] = ACTIONS(3167),
    [sym_real_literal] = ACTIONS(3169),
    [sym_verbatim_string_literal] = ACTIONS(3169),
    [aux_sym_preproc_if_token1] = ACTIONS(3169),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3169),
    [sym_interpolation_verbatim_start] = ACTIONS(3169),
    [sym_interpolation_raw_start] = ACTIONS(3169),
    [sym_raw_string_start] = ACTIONS(3169),
  },
  [2729] = {
    [sym_preproc_region] = STATE(2729),
    [sym_preproc_endregion] = STATE(2729),
    [sym_preproc_line] = STATE(2729),
    [sym_preproc_pragma] = STATE(2729),
    [sym_preproc_nullable] = STATE(2729),
    [sym_preproc_error] = STATE(2729),
    [sym_preproc_define] = STATE(2729),
    [sym_preproc_undef] = STATE(2729),
    [sym__identifier_token] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym_alias] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_global] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_unsafe] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_ref] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_RBRACE] = ACTIONS(3113),
    [anon_sym_delegate] = ACTIONS(3111),
    [anon_sym_abstract] = ACTIONS(3111),
    [anon_sym_async] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_file] = ACTIONS(3111),
    [anon_sym_fixed] = ACTIONS(3111),
    [anon_sym_internal] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_override] = ACTIONS(3111),
    [anon_sym_partial] = ACTIONS(3111),
    [anon_sym_private] = ACTIONS(3111),
    [anon_sym_protected] = ACTIONS(3111),
    [anon_sym_public] = ACTIONS(3111),
    [anon_sym_readonly] = ACTIONS(3111),
    [anon_sym_required] = ACTIONS(3111),
    [anon_sym_sealed] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_where] = ACTIONS(3111),
    [anon_sym_notnull] = ACTIONS(3111),
    [anon_sym_unmanaged] = ACTIONS(3111),
    [anon_sym_checked] = ACTIONS(3111),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_true] = ACTIONS(3111),
    [anon_sym_false] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_this] = ACTIONS(3111),
    [anon_sym_scoped] = ACTIONS(3111),
    [anon_sym_base] = ACTIONS(3111),
    [anon_sym_var] = ACTIONS(3111),
    [sym_predefined_type] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_unchecked] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_lock] = ACTIONS(3111),
    [anon_sym_yield] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_when] = ACTIONS(3111),
    [anon_sym_await] = ACTIONS(3111),
    [anon_sym_foreach] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_else] = ACTIONS(3111),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_from] = ACTIONS(3111),
    [anon_sym_into] = ACTIONS(3111),
    [anon_sym_join] = ACTIONS(3111),
    [anon_sym_on] = ACTIONS(3111),
    [anon_sym_equals] = ACTIONS(3111),
    [anon_sym_let] = ACTIONS(3111),
    [anon_sym_orderby] = ACTIONS(3111),
    [anon_sym_ascending] = ACTIONS(3111),
    [anon_sym_descending] = ACTIONS(3111),
    [anon_sym_group] = ACTIONS(3111),
    [anon_sym_by] = ACTIONS(3111),
    [anon_sym_select] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [anon_sym_stackalloc] = ACTIONS(3111),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym_typeof] = ACTIONS(3111),
    [anon_sym___makeref] = ACTIONS(3111),
    [anon_sym___reftype] = ACTIONS(3111),
    [anon_sym___refvalue] = ACTIONS(3111),
    [sym_null_literal] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [sym_integer_literal] = ACTIONS(3111),
    [sym_real_literal] = ACTIONS(3113),
    [sym_verbatim_string_literal] = ACTIONS(3113),
    [aux_sym_preproc_if_token1] = ACTIONS(3113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3113),
    [sym_interpolation_verbatim_start] = ACTIONS(3113),
    [sym_interpolation_raw_start] = ACTIONS(3113),
    [sym_raw_string_start] = ACTIONS(3113),
  },
  [2730] = {
    [sym_preproc_region] = STATE(2730),
    [sym_preproc_endregion] = STATE(2730),
    [sym_preproc_line] = STATE(2730),
    [sym_preproc_pragma] = STATE(2730),
    [sym_preproc_nullable] = STATE(2730),
    [sym_preproc_error] = STATE(2730),
    [sym_preproc_define] = STATE(2730),
    [sym_preproc_undef] = STATE(2730),
    [sym__identifier_token] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym_alias] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_global] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3103),
    [anon_sym_unsafe] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_ref] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_delegate] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_file] = ACTIONS(3103),
    [anon_sym_fixed] = ACTIONS(3103),
    [anon_sym_internal] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_partial] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_required] = ACTIONS(3103),
    [anon_sym_sealed] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_where] = ACTIONS(3103),
    [anon_sym_notnull] = ACTIONS(3103),
    [anon_sym_unmanaged] = ACTIONS(3103),
    [anon_sym_checked] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_true] = ACTIONS(3103),
    [anon_sym_false] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_this] = ACTIONS(3103),
    [anon_sym_scoped] = ACTIONS(3103),
    [anon_sym_base] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [sym_predefined_type] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_unchecked] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_lock] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_case] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_when] = ACTIONS(3103),
    [anon_sym_await] = ACTIONS(3103),
    [anon_sym_foreach] = ACTIONS(3103),
    [anon_sym_goto] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_from] = ACTIONS(3103),
    [anon_sym_into] = ACTIONS(3103),
    [anon_sym_join] = ACTIONS(3103),
    [anon_sym_on] = ACTIONS(3103),
    [anon_sym_equals] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_orderby] = ACTIONS(3103),
    [anon_sym_ascending] = ACTIONS(3103),
    [anon_sym_descending] = ACTIONS(3103),
    [anon_sym_group] = ACTIONS(3103),
    [anon_sym_by] = ACTIONS(3103),
    [anon_sym_select] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [anon_sym_stackalloc] = ACTIONS(3103),
    [anon_sym_sizeof] = ACTIONS(3103),
    [anon_sym_typeof] = ACTIONS(3103),
    [anon_sym___makeref] = ACTIONS(3103),
    [anon_sym___reftype] = ACTIONS(3103),
    [anon_sym___refvalue] = ACTIONS(3103),
    [sym_null_literal] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [sym_integer_literal] = ACTIONS(3103),
    [sym_real_literal] = ACTIONS(3105),
    [sym_verbatim_string_literal] = ACTIONS(3105),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3105),
    [sym_interpolation_verbatim_start] = ACTIONS(3105),
    [sym_interpolation_raw_start] = ACTIONS(3105),
    [sym_raw_string_start] = ACTIONS(3105),
  },
  [2731] = {
    [sym_preproc_region] = STATE(2731),
    [sym_preproc_endregion] = STATE(2731),
    [sym_preproc_line] = STATE(2731),
    [sym_preproc_pragma] = STATE(2731),
    [sym_preproc_nullable] = STATE(2731),
    [sym_preproc_error] = STATE(2731),
    [sym_preproc_define] = STATE(2731),
    [sym_preproc_undef] = STATE(2731),
    [sym__identifier_token] = ACTIONS(3087),
    [anon_sym_extern] = ACTIONS(3087),
    [anon_sym_alias] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_global] = ACTIONS(3087),
    [anon_sym_using] = ACTIONS(3087),
    [anon_sym_unsafe] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_ref] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_delegate] = ACTIONS(3087),
    [anon_sym_abstract] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_file] = ACTIONS(3087),
    [anon_sym_fixed] = ACTIONS(3087),
    [anon_sym_internal] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_override] = ACTIONS(3087),
    [anon_sym_partial] = ACTIONS(3087),
    [anon_sym_private] = ACTIONS(3087),
    [anon_sym_protected] = ACTIONS(3087),
    [anon_sym_public] = ACTIONS(3087),
    [anon_sym_readonly] = ACTIONS(3087),
    [anon_sym_required] = ACTIONS(3087),
    [anon_sym_sealed] = ACTIONS(3087),
    [anon_sym_virtual] = ACTIONS(3087),
    [anon_sym_volatile] = ACTIONS(3087),
    [anon_sym_where] = ACTIONS(3087),
    [anon_sym_notnull] = ACTIONS(3087),
    [anon_sym_unmanaged] = ACTIONS(3087),
    [anon_sym_checked] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_true] = ACTIONS(3087),
    [anon_sym_false] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_CARET] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_this] = ACTIONS(3087),
    [anon_sym_scoped] = ACTIONS(3087),
    [anon_sym_base] = ACTIONS(3087),
    [anon_sym_var] = ACTIONS(3087),
    [sym_predefined_type] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_unchecked] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_lock] = ACTIONS(3087),
    [anon_sym_yield] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_case] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_when] = ACTIONS(3087),
    [anon_sym_await] = ACTIONS(3087),
    [anon_sym_foreach] = ACTIONS(3087),
    [anon_sym_goto] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_else] = ACTIONS(3087),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_from] = ACTIONS(3087),
    [anon_sym_into] = ACTIONS(3087),
    [anon_sym_join] = ACTIONS(3087),
    [anon_sym_on] = ACTIONS(3087),
    [anon_sym_equals] = ACTIONS(3087),
    [anon_sym_let] = ACTIONS(3087),
    [anon_sym_orderby] = ACTIONS(3087),
    [anon_sym_ascending] = ACTIONS(3087),
    [anon_sym_descending] = ACTIONS(3087),
    [anon_sym_group] = ACTIONS(3087),
    [anon_sym_by] = ACTIONS(3087),
    [anon_sym_select] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_stackalloc] = ACTIONS(3087),
    [anon_sym_sizeof] = ACTIONS(3087),
    [anon_sym_typeof] = ACTIONS(3087),
    [anon_sym___makeref] = ACTIONS(3087),
    [anon_sym___reftype] = ACTIONS(3087),
    [anon_sym___refvalue] = ACTIONS(3087),
    [sym_null_literal] = ACTIONS(3087),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [sym_integer_literal] = ACTIONS(3087),
    [sym_real_literal] = ACTIONS(3089),
    [sym_verbatim_string_literal] = ACTIONS(3089),
    [aux_sym_preproc_if_token1] = ACTIONS(3089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(3089),
    [sym_interpolation_verbatim_start] = ACTIONS(3089),
    [sym_interpolation_raw_start] = ACTIONS(3089),
    [sym_raw_string_start] = ACTIONS(3089),
  },
  [2732] = {
    [sym_preproc_region] = STATE(2732),
    [sym_preproc_endregion] = STATE(2732),
    [sym_preproc_line] = STATE(2732),
    [sym_preproc_pragma] = STATE(2732),
    [sym_preproc_nullable] = STATE(2732),
    [sym_preproc_error] = STATE(2732),
    [sym_preproc_define] = STATE(2732),
    [sym_preproc_undef] = STATE(2732),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2733] = {
    [sym_preproc_region] = STATE(2733),
    [sym_preproc_endregion] = STATE(2733),
    [sym_preproc_line] = STATE(2733),
    [sym_preproc_pragma] = STATE(2733),
    [sym_preproc_nullable] = STATE(2733),
    [sym_preproc_error] = STATE(2733),
    [sym_preproc_define] = STATE(2733),
    [sym_preproc_undef] = STATE(2733),
    [sym__identifier_token] = ACTIONS(4047),
    [anon_sym_extern] = ACTIONS(4047),
    [anon_sym_alias] = ACTIONS(4047),
    [anon_sym_SEMI] = ACTIONS(4049),
    [anon_sym_global] = ACTIONS(4047),
    [anon_sym_using] = ACTIONS(4047),
    [anon_sym_unsafe] = ACTIONS(4047),
    [anon_sym_static] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(4049),
    [anon_sym_LPAREN] = ACTIONS(4049),
    [anon_sym_return] = ACTIONS(4047),
    [anon_sym_ref] = ACTIONS(4047),
    [anon_sym_LBRACE] = ACTIONS(4049),
    [anon_sym_RBRACE] = ACTIONS(4049),
    [anon_sym_delegate] = ACTIONS(4047),
    [anon_sym_abstract] = ACTIONS(4047),
    [anon_sym_async] = ACTIONS(4047),
    [anon_sym_const] = ACTIONS(4047),
    [anon_sym_file] = ACTIONS(4047),
    [anon_sym_fixed] = ACTIONS(4047),
    [anon_sym_internal] = ACTIONS(4047),
    [anon_sym_new] = ACTIONS(4047),
    [anon_sym_override] = ACTIONS(4047),
    [anon_sym_partial] = ACTIONS(4047),
    [anon_sym_private] = ACTIONS(4047),
    [anon_sym_protected] = ACTIONS(4047),
    [anon_sym_public] = ACTIONS(4047),
    [anon_sym_readonly] = ACTIONS(4047),
    [anon_sym_required] = ACTIONS(4047),
    [anon_sym_sealed] = ACTIONS(4047),
    [anon_sym_virtual] = ACTIONS(4047),
    [anon_sym_volatile] = ACTIONS(4047),
    [anon_sym_where] = ACTIONS(4047),
    [anon_sym_notnull] = ACTIONS(4047),
    [anon_sym_unmanaged] = ACTIONS(4047),
    [anon_sym_checked] = ACTIONS(4047),
    [anon_sym_BANG] = ACTIONS(4049),
    [anon_sym_TILDE] = ACTIONS(4049),
    [anon_sym_PLUS_PLUS] = ACTIONS(4049),
    [anon_sym_DASH_DASH] = ACTIONS(4049),
    [anon_sym_true] = ACTIONS(4047),
    [anon_sym_false] = ACTIONS(4047),
    [anon_sym_PLUS] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4047),
    [anon_sym_STAR] = ACTIONS(4049),
    [anon_sym_CARET] = ACTIONS(4049),
    [anon_sym_AMP] = ACTIONS(4049),
    [anon_sym_this] = ACTIONS(4047),
    [anon_sym_scoped] = ACTIONS(4047),
    [anon_sym_base] = ACTIONS(4047),
    [anon_sym_var] = ACTIONS(4047),
    [sym_predefined_type] = ACTIONS(4047),
    [anon_sym_break] = ACTIONS(4047),
    [anon_sym_unchecked] = ACTIONS(4047),
    [anon_sym_continue] = ACTIONS(4047),
    [anon_sym_do] = ACTIONS(4047),
    [anon_sym_while] = ACTIONS(4047),
    [anon_sym_for] = ACTIONS(4047),
    [anon_sym_lock] = ACTIONS(4047),
    [anon_sym_yield] = ACTIONS(4047),
    [anon_sym_switch] = ACTIONS(4047),
    [anon_sym_case] = ACTIONS(4047),
    [anon_sym_default] = ACTIONS(4047),
    [anon_sym_throw] = ACTIONS(4047),
    [anon_sym_try] = ACTIONS(4047),
    [anon_sym_when] = ACTIONS(4047),
    [anon_sym_await] = ACTIONS(4047),
    [anon_sym_foreach] = ACTIONS(4047),
    [anon_sym_goto] = ACTIONS(4047),
    [anon_sym_if] = ACTIONS(4047),
    [anon_sym_DOT_DOT] = ACTIONS(4049),
    [anon_sym_from] = ACTIONS(4047),
    [anon_sym_into] = ACTIONS(4047),
    [anon_sym_join] = ACTIONS(4047),
    [anon_sym_on] = ACTIONS(4047),
    [anon_sym_equals] = ACTIONS(4047),
    [anon_sym_let] = ACTIONS(4047),
    [anon_sym_orderby] = ACTIONS(4047),
    [anon_sym_ascending] = ACTIONS(4047),
    [anon_sym_descending] = ACTIONS(4047),
    [anon_sym_group] = ACTIONS(4047),
    [anon_sym_by] = ACTIONS(4047),
    [anon_sym_select] = ACTIONS(4047),
    [anon_sym_DQUOTE] = ACTIONS(4049),
    [anon_sym_stackalloc] = ACTIONS(4047),
    [anon_sym_sizeof] = ACTIONS(4047),
    [anon_sym_typeof] = ACTIONS(4047),
    [anon_sym___makeref] = ACTIONS(4047),
    [anon_sym___reftype] = ACTIONS(4047),
    [anon_sym___refvalue] = ACTIONS(4047),
    [sym_null_literal] = ACTIONS(4047),
    [anon_sym_SQUOTE] = ACTIONS(4049),
    [sym_integer_literal] = ACTIONS(4047),
    [sym_real_literal] = ACTIONS(4049),
    [sym_verbatim_string_literal] = ACTIONS(4049),
    [aux_sym_preproc_if_token1] = ACTIONS(4049),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_regular_start] = ACTIONS(4049),
    [sym_interpolation_verbatim_start] = ACTIONS(4049),
    [sym_interpolation_raw_start] = ACTIONS(4049),
    [sym_raw_string_start] = ACTIONS(4049),
  },
  [2734] = {
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7320),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6812),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2734),
    [sym_preproc_endregion] = STATE(2734),
    [sym_preproc_line] = STATE(2734),
    [sym_preproc_pragma] = STATE(2734),
    [sym_preproc_nullable] = STATE(2734),
    [sym_preproc_error] = STATE(2734),
    [sym_preproc_define] = STATE(2734),
    [sym_preproc_undef] = STATE(2734),
    [sym__identifier_token] = ACTIONS(3985),
    [anon_sym_alias] = ACTIONS(3988),
    [anon_sym_global] = ACTIONS(3988),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3995),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3988),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3988),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3988),
    [anon_sym_unmanaged] = ACTIONS(3988),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4002),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4005),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3988),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3988),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3988),
    [anon_sym_into] = ACTIONS(3988),
    [anon_sym_join] = ACTIONS(3988),
    [anon_sym_on] = ACTIONS(3988),
    [anon_sym_equals] = ACTIONS(3988),
    [anon_sym_let] = ACTIONS(3988),
    [anon_sym_orderby] = ACTIONS(3988),
    [anon_sym_ascending] = ACTIONS(3988),
    [anon_sym_descending] = ACTIONS(3988),
    [anon_sym_group] = ACTIONS(3988),
    [anon_sym_by] = ACTIONS(3988),
    [anon_sym_select] = ACTIONS(3988),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2735] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2735),
    [sym_preproc_endregion] = STATE(2735),
    [sym_preproc_line] = STATE(2735),
    [sym_preproc_pragma] = STATE(2735),
    [sym_preproc_nullable] = STATE(2735),
    [sym_preproc_error] = STATE(2735),
    [sym_preproc_define] = STATE(2735),
    [sym_preproc_undef] = STATE(2735),
    [sym__identifier_token] = ACTIONS(4051),
    [anon_sym_alias] = ACTIONS(4055),
    [anon_sym_global] = ACTIONS(4055),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_file] = ACTIONS(4055),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4055),
    [anon_sym_unmanaged] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4055),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4055),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(4055),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4055),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4055),
    [anon_sym_into] = ACTIONS(4055),
    [anon_sym_join] = ACTIONS(4055),
    [anon_sym_on] = ACTIONS(4055),
    [anon_sym_equals] = ACTIONS(4055),
    [anon_sym_let] = ACTIONS(4055),
    [anon_sym_orderby] = ACTIONS(4055),
    [anon_sym_ascending] = ACTIONS(4055),
    [anon_sym_descending] = ACTIONS(4055),
    [anon_sym_group] = ACTIONS(4055),
    [anon_sym_by] = ACTIONS(4055),
    [anon_sym_select] = ACTIONS(4055),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2736] = {
    [sym__name] = STATE(3026),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2736),
    [sym_preproc_endregion] = STATE(2736),
    [sym_preproc_line] = STATE(2736),
    [sym_preproc_pragma] = STATE(2736),
    [sym_preproc_nullable] = STATE(2736),
    [sym_preproc_error] = STATE(2736),
    [sym_preproc_define] = STATE(2736),
    [sym_preproc_undef] = STATE(2736),
    [sym__identifier_token] = ACTIONS(4062),
    [anon_sym_alias] = ACTIONS(4065),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4065),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4065),
    [anon_sym_unmanaged] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4065),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4065),
    [anon_sym_yield] = ACTIONS(4065),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4065),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4065),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4065),
    [anon_sym_equals] = ACTIONS(4065),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4065),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2737] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2737),
    [sym_preproc_endregion] = STATE(2737),
    [sym_preproc_line] = STATE(2737),
    [sym_preproc_pragma] = STATE(2737),
    [sym_preproc_nullable] = STATE(2737),
    [sym_preproc_error] = STATE(2737),
    [sym_preproc_define] = STATE(2737),
    [sym_preproc_undef] = STATE(2737),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4073),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2738] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2738),
    [sym_preproc_endregion] = STATE(2738),
    [sym_preproc_line] = STATE(2738),
    [sym_preproc_pragma] = STATE(2738),
    [sym_preproc_nullable] = STATE(2738),
    [sym_preproc_error] = STATE(2738),
    [sym_preproc_define] = STATE(2738),
    [sym_preproc_undef] = STATE(2738),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4073),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2739] = {
    [sym__variable_designation] = STATE(4072),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2739),
    [sym_preproc_endregion] = STATE(2739),
    [sym_preproc_line] = STATE(2739),
    [sym_preproc_pragma] = STATE(2739),
    [sym_preproc_nullable] = STATE(2739),
    [sym_preproc_error] = STATE(2739),
    [sym_preproc_define] = STATE(2739),
    [sym_preproc_undef] = STATE(2739),
    [sym__identifier_token] = ACTIONS(4078),
    [anon_sym_alias] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_global] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4092),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4082),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4082),
    [anon_sym_unmanaged] = ACTIONS(4082),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4082),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4082),
    [sym_discard] = ACTIONS(4096),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4082),
    [anon_sym_into] = ACTIONS(4082),
    [anon_sym_join] = ACTIONS(4082),
    [anon_sym_on] = ACTIONS(4082),
    [anon_sym_equals] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_orderby] = ACTIONS(4082),
    [anon_sym_ascending] = ACTIONS(4082),
    [anon_sym_descending] = ACTIONS(4082),
    [anon_sym_group] = ACTIONS(4082),
    [anon_sym_by] = ACTIONS(4082),
    [anon_sym_select] = ACTIONS(4082),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2740] = {
    [sym__name] = STATE(3176),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(3127),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2740),
    [sym_preproc_endregion] = STATE(2740),
    [sym_preproc_line] = STATE(2740),
    [sym_preproc_pragma] = STATE(2740),
    [sym_preproc_nullable] = STATE(2740),
    [sym_preproc_error] = STATE(2740),
    [sym_preproc_define] = STATE(2740),
    [sym_preproc_undef] = STATE(2740),
    [sym__identifier_token] = ACTIONS(4062),
    [anon_sym_alias] = ACTIONS(4065),
    [anon_sym_global] = ACTIONS(4065),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4065),
    [anon_sym_unmanaged] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4065),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4065),
    [anon_sym_yield] = ACTIONS(4065),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4065),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4065),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4065),
    [anon_sym_equals] = ACTIONS(4065),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4065),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2741] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2741),
    [sym_preproc_endregion] = STATE(2741),
    [sym_preproc_line] = STATE(2741),
    [sym_preproc_pragma] = STATE(2741),
    [sym_preproc_nullable] = STATE(2741),
    [sym_preproc_error] = STATE(2741),
    [sym_preproc_define] = STATE(2741),
    [sym_preproc_undef] = STATE(2741),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4102),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4073),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2742] = {
    [sym__name] = STATE(3290),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(3453),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(3371),
    [sym_ref_type] = STATE(3288),
    [sym__scoped_base_type] = STATE(3287),
    [sym_identifier] = STATE(3152),
    [sym__reserved_identifier] = STATE(3207),
    [sym_preproc_region] = STATE(2742),
    [sym_preproc_endregion] = STATE(2742),
    [sym_preproc_line] = STATE(2742),
    [sym_preproc_pragma] = STATE(2742),
    [sym_preproc_nullable] = STATE(2742),
    [sym_preproc_error] = STATE(2742),
    [sym_preproc_define] = STATE(2742),
    [sym_preproc_undef] = STATE(2742),
    [sym__identifier_token] = ACTIONS(4104),
    [anon_sym_alias] = ACTIONS(4107),
    [anon_sym_global] = ACTIONS(4107),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4107),
    [anon_sym_unmanaged] = ACTIONS(4107),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4107),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_yield] = ACTIONS(4107),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4107),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4107),
    [anon_sym_into] = ACTIONS(4107),
    [anon_sym_join] = ACTIONS(4107),
    [anon_sym_on] = ACTIONS(4107),
    [anon_sym_equals] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_orderby] = ACTIONS(4107),
    [anon_sym_ascending] = ACTIONS(4107),
    [anon_sym_descending] = ACTIONS(4107),
    [anon_sym_group] = ACTIONS(4107),
    [anon_sym_by] = ACTIONS(4107),
    [anon_sym_select] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2743] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2743),
    [sym_preproc_endregion] = STATE(2743),
    [sym_preproc_line] = STATE(2743),
    [sym_preproc_pragma] = STATE(2743),
    [sym_preproc_nullable] = STATE(2743),
    [sym_preproc_error] = STATE(2743),
    [sym_preproc_define] = STATE(2743),
    [sym_preproc_undef] = STATE(2743),
    [sym__identifier_token] = ACTIONS(4078),
    [anon_sym_alias] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_global] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4082),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4082),
    [anon_sym_unmanaged] = ACTIONS(4082),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4082),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4082),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4082),
    [anon_sym_into] = ACTIONS(4082),
    [anon_sym_join] = ACTIONS(4082),
    [anon_sym_on] = ACTIONS(4082),
    [anon_sym_equals] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_orderby] = ACTIONS(4082),
    [anon_sym_ascending] = ACTIONS(4082),
    [anon_sym_descending] = ACTIONS(4082),
    [anon_sym_group] = ACTIONS(4082),
    [anon_sym_by] = ACTIONS(4082),
    [anon_sym_select] = ACTIONS(4082),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2744] = {
    [sym_preproc_region] = STATE(2744),
    [sym_preproc_endregion] = STATE(2744),
    [sym_preproc_line] = STATE(2744),
    [sym_preproc_pragma] = STATE(2744),
    [sym_preproc_nullable] = STATE(2744),
    [sym_preproc_error] = STATE(2744),
    [sym_preproc_define] = STATE(2744),
    [sym_preproc_undef] = STATE(2744),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_operator] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_this] = ACTIONS(4120),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2745] = {
    [sym_preproc_region] = STATE(2745),
    [sym_preproc_endregion] = STATE(2745),
    [sym_preproc_line] = STATE(2745),
    [sym_preproc_pragma] = STATE(2745),
    [sym_preproc_nullable] = STATE(2745),
    [sym_preproc_error] = STATE(2745),
    [sym_preproc_define] = STATE(2745),
    [sym_preproc_undef] = STATE(2745),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_this] = ACTIONS(3993),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2746] = {
    [sym__name] = STATE(6890),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(6766),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2746),
    [sym_preproc_endregion] = STATE(2746),
    [sym_preproc_line] = STATE(2746),
    [sym_preproc_pragma] = STATE(2746),
    [sym_preproc_nullable] = STATE(2746),
    [sym_preproc_error] = STATE(2746),
    [sym_preproc_define] = STATE(2746),
    [sym_preproc_undef] = STATE(2746),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4124),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4073),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2747] = {
    [sym_preproc_region] = STATE(2747),
    [sym_preproc_endregion] = STATE(2747),
    [sym_preproc_line] = STATE(2747),
    [sym_preproc_pragma] = STATE(2747),
    [sym_preproc_nullable] = STATE(2747),
    [sym_preproc_error] = STATE(2747),
    [sym_preproc_define] = STATE(2747),
    [sym_preproc_undef] = STATE(2747),
    [sym__identifier_token] = ACTIONS(4126),
    [anon_sym_alias] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_global] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_file] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4126),
    [anon_sym_unmanaged] = ACTIONS(4126),
    [anon_sym_operator] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_this] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_var] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4126),
    [sym_discard] = ACTIONS(4126),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4126),
    [anon_sym_join] = ACTIONS(4126),
    [anon_sym_on] = ACTIONS(4126),
    [anon_sym_equals] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_orderby] = ACTIONS(4126),
    [anon_sym_ascending] = ACTIONS(4126),
    [anon_sym_descending] = ACTIONS(4126),
    [anon_sym_group] = ACTIONS(4126),
    [anon_sym_by] = ACTIONS(4126),
    [anon_sym_select] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2748] = {
    [sym_preproc_region] = STATE(2748),
    [sym_preproc_endregion] = STATE(2748),
    [sym_preproc_line] = STATE(2748),
    [sym_preproc_pragma] = STATE(2748),
    [sym_preproc_nullable] = STATE(2748),
    [sym_preproc_error] = STATE(2748),
    [sym_preproc_define] = STATE(2748),
    [sym_preproc_undef] = STATE(2748),
    [sym__identifier_token] = ACTIONS(4130),
    [anon_sym_alias] = ACTIONS(4130),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_global] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_file] = ACTIONS(4130),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_notnull] = ACTIONS(4130),
    [anon_sym_unmanaged] = ACTIONS(4130),
    [anon_sym_operator] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_this] = ACTIONS(4130),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_scoped] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_var] = ACTIONS(4130),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_switch] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_is] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4130),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2749] = {
    [sym_preproc_region] = STATE(2749),
    [sym_preproc_endregion] = STATE(2749),
    [sym_preproc_line] = STATE(2749),
    [sym_preproc_pragma] = STATE(2749),
    [sym_preproc_nullable] = STATE(2749),
    [sym_preproc_error] = STATE(2749),
    [sym_preproc_define] = STATE(2749),
    [sym_preproc_undef] = STATE(2749),
    [sym__identifier_token] = ACTIONS(4134),
    [anon_sym_alias] = ACTIONS(4134),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_global] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_file] = ACTIONS(4134),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_notnull] = ACTIONS(4134),
    [anon_sym_unmanaged] = ACTIONS(4134),
    [anon_sym_operator] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_this] = ACTIONS(4134),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_scoped] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_var] = ACTIONS(4134),
    [anon_sym_yield] = ACTIONS(4134),
    [anon_sym_switch] = ACTIONS(4134),
    [anon_sym_when] = ACTIONS(4134),
    [sym_discard] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_from] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4134),
    [anon_sym_join] = ACTIONS(4134),
    [anon_sym_on] = ACTIONS(4134),
    [anon_sym_equals] = ACTIONS(4134),
    [anon_sym_let] = ACTIONS(4134),
    [anon_sym_orderby] = ACTIONS(4134),
    [anon_sym_ascending] = ACTIONS(4134),
    [anon_sym_descending] = ACTIONS(4134),
    [anon_sym_group] = ACTIONS(4134),
    [anon_sym_by] = ACTIONS(4134),
    [anon_sym_select] = ACTIONS(4134),
    [anon_sym_as] = ACTIONS(4134),
    [anon_sym_is] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4134),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2750] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2750),
    [sym_preproc_endregion] = STATE(2750),
    [sym_preproc_line] = STATE(2750),
    [sym_preproc_pragma] = STATE(2750),
    [sym_preproc_nullable] = STATE(2750),
    [sym_preproc_error] = STATE(2750),
    [sym_preproc_define] = STATE(2750),
    [sym_preproc_undef] = STATE(2750),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4073),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2751] = {
    [sym_preproc_region] = STATE(2751),
    [sym_preproc_endregion] = STATE(2751),
    [sym_preproc_line] = STATE(2751),
    [sym_preproc_pragma] = STATE(2751),
    [sym_preproc_nullable] = STATE(2751),
    [sym_preproc_error] = STATE(2751),
    [sym_preproc_define] = STATE(2751),
    [sym_preproc_undef] = STATE(2751),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_operator] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_this] = ACTIONS(4138),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2752] = {
    [sym_preproc_region] = STATE(2752),
    [sym_preproc_endregion] = STATE(2752),
    [sym_preproc_line] = STATE(2752),
    [sym_preproc_pragma] = STATE(2752),
    [sym_preproc_nullable] = STATE(2752),
    [sym_preproc_error] = STATE(2752),
    [sym_preproc_define] = STATE(2752),
    [sym_preproc_undef] = STATE(2752),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_operator] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_this] = ACTIONS(4142),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2753] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2753),
    [sym_preproc_endregion] = STATE(2753),
    [sym_preproc_line] = STATE(2753),
    [sym_preproc_pragma] = STATE(2753),
    [sym_preproc_nullable] = STATE(2753),
    [sym_preproc_error] = STATE(2753),
    [sym_preproc_define] = STATE(2753),
    [sym_preproc_undef] = STATE(2753),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2754] = {
    [sym_preproc_region] = STATE(2754),
    [sym_preproc_endregion] = STATE(2754),
    [sym_preproc_line] = STATE(2754),
    [sym_preproc_pragma] = STATE(2754),
    [sym_preproc_nullable] = STATE(2754),
    [sym_preproc_error] = STATE(2754),
    [sym_preproc_define] = STATE(2754),
    [sym_preproc_undef] = STATE(2754),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2755] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2755),
    [sym_preproc_endregion] = STATE(2755),
    [sym_preproc_line] = STATE(2755),
    [sym_preproc_pragma] = STATE(2755),
    [sym_preproc_nullable] = STATE(2755),
    [sym_preproc_error] = STATE(2755),
    [sym_preproc_define] = STATE(2755),
    [sym_preproc_undef] = STATE(2755),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2756] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2756),
    [sym_preproc_endregion] = STATE(2756),
    [sym_preproc_line] = STATE(2756),
    [sym_preproc_pragma] = STATE(2756),
    [sym_preproc_nullable] = STATE(2756),
    [sym_preproc_error] = STATE(2756),
    [sym_preproc_define] = STATE(2756),
    [sym_preproc_undef] = STATE(2756),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4153),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2757] = {
    [sym_preproc_region] = STATE(2757),
    [sym_preproc_endregion] = STATE(2757),
    [sym_preproc_line] = STATE(2757),
    [sym_preproc_pragma] = STATE(2757),
    [sym_preproc_nullable] = STATE(2757),
    [sym_preproc_error] = STATE(2757),
    [sym_preproc_define] = STATE(2757),
    [sym_preproc_undef] = STATE(2757),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_in] = ACTIONS(4155),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4164),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym_GT_GT_GT] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4161),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_QMARK_QMARK] = ACTIONS(4164),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2758] = {
    [sym_preproc_region] = STATE(2758),
    [sym_preproc_endregion] = STATE(2758),
    [sym_preproc_line] = STATE(2758),
    [sym_preproc_pragma] = STATE(2758),
    [sym_preproc_nullable] = STATE(2758),
    [sym_preproc_error] = STATE(2758),
    [sym_preproc_define] = STATE(2758),
    [sym_preproc_undef] = STATE(2758),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2759] = {
    [sym_preproc_region] = STATE(2759),
    [sym_preproc_endregion] = STATE(2759),
    [sym_preproc_line] = STATE(2759),
    [sym_preproc_pragma] = STATE(2759),
    [sym_preproc_nullable] = STATE(2759),
    [sym_preproc_error] = STATE(2759),
    [sym_preproc_define] = STATE(2759),
    [sym_preproc_undef] = STATE(2759),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4175),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_in] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_if_token3] = ACTIONS(4175),
    [aux_sym_preproc_else_token1] = ACTIONS(4175),
    [aux_sym_preproc_elif_token1] = ACTIONS(4175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2760] = {
    [sym_preproc_region] = STATE(2760),
    [sym_preproc_endregion] = STATE(2760),
    [sym_preproc_line] = STATE(2760),
    [sym_preproc_pragma] = STATE(2760),
    [sym_preproc_nullable] = STATE(2760),
    [sym_preproc_error] = STATE(2760),
    [sym_preproc_define] = STATE(2760),
    [sym_preproc_undef] = STATE(2760),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4175),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_in] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_if_token3] = ACTIONS(4175),
    [aux_sym_preproc_else_token1] = ACTIONS(4175),
    [aux_sym_preproc_elif_token1] = ACTIONS(4175),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2761] = {
    [sym_preproc_region] = STATE(2761),
    [sym_preproc_endregion] = STATE(2761),
    [sym_preproc_line] = STATE(2761),
    [sym_preproc_pragma] = STATE(2761),
    [sym_preproc_nullable] = STATE(2761),
    [sym_preproc_error] = STATE(2761),
    [sym_preproc_define] = STATE(2761),
    [sym_preproc_undef] = STATE(2761),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2762] = {
    [sym_preproc_region] = STATE(2762),
    [sym_preproc_endregion] = STATE(2762),
    [sym_preproc_line] = STATE(2762),
    [sym_preproc_pragma] = STATE(2762),
    [sym_preproc_nullable] = STATE(2762),
    [sym_preproc_error] = STATE(2762),
    [sym_preproc_define] = STATE(2762),
    [sym_preproc_undef] = STATE(2762),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4183),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_RBRACK] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4183),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4183),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_in] = ACTIONS(4194),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4183),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4183),
    [aux_sym_preproc_else_token1] = ACTIONS(4183),
    [aux_sym_preproc_elif_token1] = ACTIONS(4183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2763] = {
    [sym_preproc_region] = STATE(2763),
    [sym_preproc_endregion] = STATE(2763),
    [sym_preproc_line] = STATE(2763),
    [sym_preproc_pragma] = STATE(2763),
    [sym_preproc_nullable] = STATE(2763),
    [sym_preproc_error] = STATE(2763),
    [sym_preproc_define] = STATE(2763),
    [sym_preproc_undef] = STATE(2763),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4183),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_RBRACK] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4183),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4183),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_in] = ACTIONS(4194),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4183),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_if_token3] = ACTIONS(4183),
    [aux_sym_preproc_else_token1] = ACTIONS(4183),
    [aux_sym_preproc_elif_token1] = ACTIONS(4183),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2764] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3150),
    [sym_preproc_region] = STATE(2764),
    [sym_preproc_endregion] = STATE(2764),
    [sym_preproc_line] = STATE(2764),
    [sym_preproc_pragma] = STATE(2764),
    [sym_preproc_nullable] = STATE(2764),
    [sym_preproc_error] = STATE(2764),
    [sym_preproc_define] = STATE(2764),
    [sym_preproc_undef] = STATE(2764),
    [sym__identifier_token] = ACTIONS(4197),
    [anon_sym_alias] = ACTIONS(4201),
    [anon_sym_global] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4201),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4201),
    [anon_sym_unmanaged] = ACTIONS(4201),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4201),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4201),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4201),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4201),
    [anon_sym_into] = ACTIONS(4201),
    [anon_sym_join] = ACTIONS(4201),
    [anon_sym_on] = ACTIONS(4201),
    [anon_sym_equals] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_orderby] = ACTIONS(4201),
    [anon_sym_ascending] = ACTIONS(4201),
    [anon_sym_descending] = ACTIONS(4201),
    [anon_sym_group] = ACTIONS(4201),
    [anon_sym_by] = ACTIONS(4201),
    [anon_sym_select] = ACTIONS(4201),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2765] = {
    [sym_preproc_region] = STATE(2765),
    [sym_preproc_endregion] = STATE(2765),
    [sym_preproc_line] = STATE(2765),
    [sym_preproc_pragma] = STATE(2765),
    [sym_preproc_nullable] = STATE(2765),
    [sym_preproc_error] = STATE(2765),
    [sym_preproc_define] = STATE(2765),
    [sym_preproc_undef] = STATE(2765),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2766] = {
    [sym_preproc_region] = STATE(2766),
    [sym_preproc_endregion] = STATE(2766),
    [sym_preproc_line] = STATE(2766),
    [sym_preproc_pragma] = STATE(2766),
    [sym_preproc_nullable] = STATE(2766),
    [sym_preproc_error] = STATE(2766),
    [sym_preproc_define] = STATE(2766),
    [sym_preproc_undef] = STATE(2766),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2767] = {
    [sym__variable_designation] = STATE(5584),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2767),
    [sym_preproc_endregion] = STATE(2767),
    [sym_preproc_line] = STATE(2767),
    [sym_preproc_pragma] = STATE(2767),
    [sym_preproc_nullable] = STATE(2767),
    [sym_preproc_error] = STATE(2767),
    [sym_preproc_define] = STATE(2767),
    [sym_preproc_undef] = STATE(2767),
    [sym__identifier_token] = ACTIONS(4205),
    [anon_sym_alias] = ACTIONS(4209),
    [anon_sym_global] = ACTIONS(4209),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4213),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4209),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4209),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4209),
    [anon_sym_unmanaged] = ACTIONS(4209),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4209),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4209),
    [anon_sym_yield] = ACTIONS(4209),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4209),
    [sym_discard] = ACTIONS(4217),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4209),
    [anon_sym_into] = ACTIONS(4209),
    [anon_sym_join] = ACTIONS(4209),
    [anon_sym_on] = ACTIONS(4209),
    [anon_sym_equals] = ACTIONS(4209),
    [anon_sym_let] = ACTIONS(4209),
    [anon_sym_orderby] = ACTIONS(4209),
    [anon_sym_ascending] = ACTIONS(4209),
    [anon_sym_descending] = ACTIONS(4209),
    [anon_sym_group] = ACTIONS(4209),
    [anon_sym_by] = ACTIONS(4209),
    [anon_sym_select] = ACTIONS(4209),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4086),
  },
  [2768] = {
    [sym_preproc_region] = STATE(2768),
    [sym_preproc_endregion] = STATE(2768),
    [sym_preproc_line] = STATE(2768),
    [sym_preproc_pragma] = STATE(2768),
    [sym_preproc_nullable] = STATE(2768),
    [sym_preproc_error] = STATE(2768),
    [sym_preproc_define] = STATE(2768),
    [sym_preproc_undef] = STATE(2768),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2769] = {
    [sym_preproc_region] = STATE(2769),
    [sym_preproc_endregion] = STATE(2769),
    [sym_preproc_line] = STATE(2769),
    [sym_preproc_pragma] = STATE(2769),
    [sym_preproc_nullable] = STATE(2769),
    [sym_preproc_error] = STATE(2769),
    [sym_preproc_define] = STATE(2769),
    [sym_preproc_undef] = STATE(2769),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2770] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3150),
    [sym_preproc_region] = STATE(2770),
    [sym_preproc_endregion] = STATE(2770),
    [sym_preproc_line] = STATE(2770),
    [sym_preproc_pragma] = STATE(2770),
    [sym_preproc_nullable] = STATE(2770),
    [sym_preproc_error] = STATE(2770),
    [sym_preproc_define] = STATE(2770),
    [sym_preproc_undef] = STATE(2770),
    [sym__identifier_token] = ACTIONS(4197),
    [anon_sym_alias] = ACTIONS(4201),
    [anon_sym_global] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4201),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4201),
    [anon_sym_unmanaged] = ACTIONS(4201),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4201),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4201),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4201),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4201),
    [anon_sym_into] = ACTIONS(4201),
    [anon_sym_join] = ACTIONS(4201),
    [anon_sym_on] = ACTIONS(4201),
    [anon_sym_equals] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_orderby] = ACTIONS(4201),
    [anon_sym_ascending] = ACTIONS(4201),
    [anon_sym_descending] = ACTIONS(4201),
    [anon_sym_group] = ACTIONS(4201),
    [anon_sym_by] = ACTIONS(4201),
    [anon_sym_select] = ACTIONS(4201),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2771] = {
    [sym__name] = STATE(3922),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_ref_type] = STATE(3918),
    [sym__scoped_base_type] = STATE(3879),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(2771),
    [sym_preproc_endregion] = STATE(2771),
    [sym_preproc_line] = STATE(2771),
    [sym_preproc_pragma] = STATE(2771),
    [sym_preproc_nullable] = STATE(2771),
    [sym_preproc_error] = STATE(2771),
    [sym_preproc_define] = STATE(2771),
    [sym_preproc_undef] = STATE(2771),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4225),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4223),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2772] = {
    [sym_preproc_region] = STATE(2772),
    [sym_preproc_endregion] = STATE(2772),
    [sym_preproc_line] = STATE(2772),
    [sym_preproc_pragma] = STATE(2772),
    [sym_preproc_nullable] = STATE(2772),
    [sym_preproc_error] = STATE(2772),
    [sym_preproc_define] = STATE(2772),
    [sym_preproc_undef] = STATE(2772),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2773] = {
    [sym__name] = STATE(3026),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2773),
    [sym_preproc_endregion] = STATE(2773),
    [sym_preproc_line] = STATE(2773),
    [sym_preproc_pragma] = STATE(2773),
    [sym_preproc_nullable] = STATE(2773),
    [sym_preproc_error] = STATE(2773),
    [sym_preproc_define] = STATE(2773),
    [sym_preproc_undef] = STATE(2773),
    [sym__identifier_token] = ACTIONS(4062),
    [anon_sym_alias] = ACTIONS(4065),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4065),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4065),
    [anon_sym_unmanaged] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4065),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4065),
    [anon_sym_yield] = ACTIONS(4065),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4065),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4065),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4065),
    [anon_sym_equals] = ACTIONS(4065),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4065),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2774] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3150),
    [sym_preproc_region] = STATE(2774),
    [sym_preproc_endregion] = STATE(2774),
    [sym_preproc_line] = STATE(2774),
    [sym_preproc_pragma] = STATE(2774),
    [sym_preproc_nullable] = STATE(2774),
    [sym_preproc_error] = STATE(2774),
    [sym_preproc_define] = STATE(2774),
    [sym_preproc_undef] = STATE(2774),
    [sym__identifier_token] = ACTIONS(4197),
    [anon_sym_alias] = ACTIONS(4201),
    [anon_sym_global] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4201),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4201),
    [anon_sym_unmanaged] = ACTIONS(4201),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4201),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4201),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4201),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4201),
    [anon_sym_into] = ACTIONS(4201),
    [anon_sym_join] = ACTIONS(4201),
    [anon_sym_on] = ACTIONS(4201),
    [anon_sym_equals] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_orderby] = ACTIONS(4201),
    [anon_sym_ascending] = ACTIONS(4201),
    [anon_sym_descending] = ACTIONS(4201),
    [anon_sym_group] = ACTIONS(4201),
    [anon_sym_by] = ACTIONS(4201),
    [anon_sym_select] = ACTIONS(4201),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2775] = {
    [sym_preproc_region] = STATE(2775),
    [sym_preproc_endregion] = STATE(2775),
    [sym_preproc_line] = STATE(2775),
    [sym_preproc_pragma] = STATE(2775),
    [sym_preproc_nullable] = STATE(2775),
    [sym_preproc_error] = STATE(2775),
    [sym_preproc_define] = STATE(2775),
    [sym_preproc_undef] = STATE(2775),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2776] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2776),
    [sym_preproc_endregion] = STATE(2776),
    [sym_preproc_line] = STATE(2776),
    [sym_preproc_pragma] = STATE(2776),
    [sym_preproc_nullable] = STATE(2776),
    [sym_preproc_error] = STATE(2776),
    [sym_preproc_define] = STATE(2776),
    [sym_preproc_undef] = STATE(2776),
    [sym__identifier_token] = ACTIONS(4230),
    [anon_sym_alias] = ACTIONS(4234),
    [anon_sym_global] = ACTIONS(4234),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4234),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4234),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4234),
    [anon_sym_unmanaged] = ACTIONS(4234),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4234),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4234),
    [anon_sym_yield] = ACTIONS(4234),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4234),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4234),
    [anon_sym_into] = ACTIONS(4234),
    [anon_sym_join] = ACTIONS(4234),
    [anon_sym_on] = ACTIONS(4234),
    [anon_sym_equals] = ACTIONS(4234),
    [anon_sym_let] = ACTIONS(4234),
    [anon_sym_orderby] = ACTIONS(4234),
    [anon_sym_ascending] = ACTIONS(4234),
    [anon_sym_descending] = ACTIONS(4234),
    [anon_sym_group] = ACTIONS(4234),
    [anon_sym_by] = ACTIONS(4234),
    [anon_sym_select] = ACTIONS(4234),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2777] = {
    [sym__variable_designation] = STATE(4547),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2777),
    [sym_preproc_endregion] = STATE(2777),
    [sym_preproc_line] = STATE(2777),
    [sym_preproc_pragma] = STATE(2777),
    [sym_preproc_nullable] = STATE(2777),
    [sym_preproc_error] = STATE(2777),
    [sym_preproc_define] = STATE(2777),
    [sym_preproc_undef] = STATE(2777),
    [sym__identifier_token] = ACTIONS(4238),
    [anon_sym_alias] = ACTIONS(4242),
    [anon_sym_global] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4246),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4242),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4242),
    [anon_sym_unmanaged] = ACTIONS(4242),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4242),
    [anon_sym_yield] = ACTIONS(4242),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4242),
    [sym_discard] = ACTIONS(4250),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4242),
    [anon_sym_into] = ACTIONS(4242),
    [anon_sym_join] = ACTIONS(4242),
    [anon_sym_on] = ACTIONS(4242),
    [anon_sym_equals] = ACTIONS(4242),
    [anon_sym_let] = ACTIONS(4242),
    [anon_sym_orderby] = ACTIONS(4242),
    [anon_sym_ascending] = ACTIONS(4242),
    [anon_sym_descending] = ACTIONS(4242),
    [anon_sym_group] = ACTIONS(4242),
    [anon_sym_by] = ACTIONS(4242),
    [anon_sym_select] = ACTIONS(4242),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2778] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2778),
    [sym_preproc_endregion] = STATE(2778),
    [sym_preproc_line] = STATE(2778),
    [sym_preproc_pragma] = STATE(2778),
    [sym_preproc_nullable] = STATE(2778),
    [sym_preproc_error] = STATE(2778),
    [sym_preproc_define] = STATE(2778),
    [sym_preproc_undef] = STATE(2778),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2779] = {
    [sym__name] = STATE(4163),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2779),
    [sym_preproc_endregion] = STATE(2779),
    [sym_preproc_line] = STATE(2779),
    [sym_preproc_pragma] = STATE(2779),
    [sym_preproc_nullable] = STATE(2779),
    [sym_preproc_error] = STATE(2779),
    [sym_preproc_define] = STATE(2779),
    [sym_preproc_undef] = STATE(2779),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4260),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2780] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2780),
    [sym_preproc_endregion] = STATE(2780),
    [sym_preproc_line] = STATE(2780),
    [sym_preproc_pragma] = STATE(2780),
    [sym_preproc_nullable] = STATE(2780),
    [sym_preproc_error] = STATE(2780),
    [sym_preproc_define] = STATE(2780),
    [sym_preproc_undef] = STATE(2780),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4262),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2781] = {
    [sym_attribute_list] = STATE(3778),
    [sym_modifier] = STATE(3802),
    [sym_variable_declaration] = STATE(9558),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6419),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6744),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2781),
    [sym_preproc_endregion] = STATE(2781),
    [sym_preproc_line] = STATE(2781),
    [sym_preproc_pragma] = STATE(2781),
    [sym_preproc_nullable] = STATE(2781),
    [sym_preproc_error] = STATE(2781),
    [sym_preproc_define] = STATE(2781),
    [sym_preproc_undef] = STATE(2781),
    [aux_sym_class_declaration_repeat1] = STATE(3606),
    [aux_sym_class_declaration_repeat2] = STATE(2851),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(4266),
    [anon_sym_class] = ACTIONS(4268),
    [anon_sym_ref] = ACTIONS(4270),
    [anon_sym_struct] = ACTIONS(4272),
    [anon_sym_enum] = ACTIONS(4274),
    [anon_sym_interface] = ACTIONS(4276),
    [anon_sym_delegate] = ACTIONS(4278),
    [anon_sym_record] = ACTIONS(4280),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_implicit] = ACTIONS(4284),
    [anon_sym_explicit] = ACTIONS(4284),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2782] = {
    [sym__name] = STATE(4331),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_ref_type] = STATE(3620),
    [sym__scoped_base_type] = STATE(3619),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(2782),
    [sym_preproc_endregion] = STATE(2782),
    [sym_preproc_line] = STATE(2782),
    [sym_preproc_pragma] = STATE(2782),
    [sym_preproc_nullable] = STATE(2782),
    [sym_preproc_error] = STATE(2782),
    [sym_preproc_define] = STATE(2782),
    [sym_preproc_undef] = STATE(2782),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2783] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2783),
    [sym_preproc_endregion] = STATE(2783),
    [sym_preproc_line] = STATE(2783),
    [sym_preproc_pragma] = STATE(2783),
    [sym_preproc_nullable] = STATE(2783),
    [sym_preproc_error] = STATE(2783),
    [sym_preproc_define] = STATE(2783),
    [sym_preproc_undef] = STATE(2783),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4262),
    [anon_sym_COMMA] = ACTIONS(4298),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4298),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2784] = {
    [sym_preproc_region] = STATE(2784),
    [sym_preproc_endregion] = STATE(2784),
    [sym_preproc_line] = STATE(2784),
    [sym_preproc_pragma] = STATE(2784),
    [sym_preproc_nullable] = STATE(2784),
    [sym_preproc_error] = STATE(2784),
    [sym_preproc_define] = STATE(2784),
    [sym_preproc_undef] = STATE(2784),
    [sym__identifier_token] = ACTIONS(2667),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2667),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4301),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_file] = ACTIONS(2667),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_scoped] = ACTIONS(2667),
    [anon_sym_var] = ACTIONS(2667),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2785] = {
    [sym__variable_designation] = STATE(5016),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(2785),
    [sym_preproc_endregion] = STATE(2785),
    [sym_preproc_line] = STATE(2785),
    [sym_preproc_pragma] = STATE(2785),
    [sym_preproc_nullable] = STATE(2785),
    [sym_preproc_error] = STATE(2785),
    [sym_preproc_define] = STATE(2785),
    [sym_preproc_undef] = STATE(2785),
    [sym__identifier_token] = ACTIONS(4304),
    [anon_sym_alias] = ACTIONS(4308),
    [anon_sym_global] = ACTIONS(4308),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4312),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4308),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4308),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4308),
    [anon_sym_unmanaged] = ACTIONS(4308),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4308),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4308),
    [anon_sym_yield] = ACTIONS(4308),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4308),
    [sym_discard] = ACTIONS(4316),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4308),
    [anon_sym_into] = ACTIONS(4308),
    [anon_sym_join] = ACTIONS(4308),
    [anon_sym_on] = ACTIONS(4308),
    [anon_sym_equals] = ACTIONS(4308),
    [anon_sym_let] = ACTIONS(4308),
    [anon_sym_orderby] = ACTIONS(4308),
    [anon_sym_ascending] = ACTIONS(4308),
    [anon_sym_descending] = ACTIONS(4308),
    [anon_sym_group] = ACTIONS(4308),
    [anon_sym_by] = ACTIONS(4308),
    [anon_sym_select] = ACTIONS(4308),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2786] = {
    [sym_preproc_region] = STATE(2786),
    [sym_preproc_endregion] = STATE(2786),
    [sym_preproc_line] = STATE(2786),
    [sym_preproc_pragma] = STATE(2786),
    [sym_preproc_nullable] = STATE(2786),
    [sym_preproc_error] = STATE(2786),
    [sym_preproc_define] = STATE(2786),
    [sym_preproc_undef] = STATE(2786),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2787] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2787),
    [sym_preproc_endregion] = STATE(2787),
    [sym_preproc_line] = STATE(2787),
    [sym_preproc_pragma] = STATE(2787),
    [sym_preproc_nullable] = STATE(2787),
    [sym_preproc_error] = STATE(2787),
    [sym_preproc_define] = STATE(2787),
    [sym_preproc_undef] = STATE(2787),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4262),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2788] = {
    [sym_type_argument_list] = STATE(2830),
    [sym_preproc_region] = STATE(2788),
    [sym_preproc_endregion] = STATE(2788),
    [sym_preproc_line] = STATE(2788),
    [sym_preproc_pragma] = STATE(2788),
    [sym_preproc_nullable] = STATE(2788),
    [sym_preproc_error] = STATE(2788),
    [sym_preproc_define] = STATE(2788),
    [sym_preproc_undef] = STATE(2788),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4322),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4325),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [2789] = {
    [sym_preproc_region] = STATE(2789),
    [sym_preproc_endregion] = STATE(2789),
    [sym_preproc_line] = STATE(2789),
    [sym_preproc_pragma] = STATE(2789),
    [sym_preproc_nullable] = STATE(2789),
    [sym_preproc_error] = STATE(2789),
    [sym_preproc_define] = STATE(2789),
    [sym_preproc_undef] = STATE(2789),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2790] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2790),
    [sym_preproc_endregion] = STATE(2790),
    [sym_preproc_line] = STATE(2790),
    [sym_preproc_pragma] = STATE(2790),
    [sym_preproc_nullable] = STATE(2790),
    [sym_preproc_error] = STATE(2790),
    [sym_preproc_define] = STATE(2790),
    [sym_preproc_undef] = STATE(2790),
    [sym__identifier_token] = ACTIONS(4078),
    [anon_sym_alias] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4082),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4082),
    [anon_sym_unmanaged] = ACTIONS(4082),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4082),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4082),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4082),
    [anon_sym_into] = ACTIONS(4082),
    [anon_sym_join] = ACTIONS(4082),
    [anon_sym_on] = ACTIONS(4082),
    [anon_sym_equals] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_orderby] = ACTIONS(4082),
    [anon_sym_ascending] = ACTIONS(4082),
    [anon_sym_descending] = ACTIONS(4082),
    [anon_sym_group] = ACTIONS(4082),
    [anon_sym_by] = ACTIONS(4082),
    [anon_sym_select] = ACTIONS(4082),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2791] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2791),
    [sym_preproc_endregion] = STATE(2791),
    [sym_preproc_line] = STATE(2791),
    [sym_preproc_pragma] = STATE(2791),
    [sym_preproc_nullable] = STATE(2791),
    [sym_preproc_error] = STATE(2791),
    [sym_preproc_define] = STATE(2791),
    [sym_preproc_undef] = STATE(2791),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4295),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2792] = {
    [sym_preproc_region] = STATE(2792),
    [sym_preproc_endregion] = STATE(2792),
    [sym_preproc_line] = STATE(2792),
    [sym_preproc_pragma] = STATE(2792),
    [sym_preproc_nullable] = STATE(2792),
    [sym_preproc_error] = STATE(2792),
    [sym_preproc_define] = STATE(2792),
    [sym_preproc_undef] = STATE(2792),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2793] = {
    [sym__variable_designation] = STATE(4226),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3150),
    [sym_preproc_region] = STATE(2793),
    [sym_preproc_endregion] = STATE(2793),
    [sym_preproc_line] = STATE(2793),
    [sym_preproc_pragma] = STATE(2793),
    [sym_preproc_nullable] = STATE(2793),
    [sym_preproc_error] = STATE(2793),
    [sym_preproc_define] = STATE(2793),
    [sym_preproc_undef] = STATE(2793),
    [sym__identifier_token] = ACTIONS(4197),
    [anon_sym_alias] = ACTIONS(4201),
    [anon_sym_global] = ACTIONS(4201),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4201),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4201),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4201),
    [anon_sym_unmanaged] = ACTIONS(4201),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4201),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4201),
    [anon_sym_yield] = ACTIONS(4201),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4201),
    [sym_discard] = ACTIONS(4116),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4201),
    [anon_sym_into] = ACTIONS(4201),
    [anon_sym_join] = ACTIONS(4201),
    [anon_sym_on] = ACTIONS(4201),
    [anon_sym_equals] = ACTIONS(4201),
    [anon_sym_let] = ACTIONS(4201),
    [anon_sym_orderby] = ACTIONS(4201),
    [anon_sym_ascending] = ACTIONS(4201),
    [anon_sym_descending] = ACTIONS(4201),
    [anon_sym_group] = ACTIONS(4201),
    [anon_sym_by] = ACTIONS(4201),
    [anon_sym_select] = ACTIONS(4201),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2794] = {
    [sym__variable_designation] = STATE(5016),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(2794),
    [sym_preproc_endregion] = STATE(2794),
    [sym_preproc_line] = STATE(2794),
    [sym_preproc_pragma] = STATE(2794),
    [sym_preproc_nullable] = STATE(2794),
    [sym_preproc_error] = STATE(2794),
    [sym_preproc_define] = STATE(2794),
    [sym_preproc_undef] = STATE(2794),
    [sym__identifier_token] = ACTIONS(4327),
    [anon_sym_alias] = ACTIONS(4331),
    [anon_sym_global] = ACTIONS(4331),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4312),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4331),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4331),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4331),
    [anon_sym_unmanaged] = ACTIONS(4331),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4331),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4331),
    [anon_sym_yield] = ACTIONS(4331),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4331),
    [sym_discard] = ACTIONS(4316),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4331),
    [anon_sym_into] = ACTIONS(4331),
    [anon_sym_join] = ACTIONS(4331),
    [anon_sym_on] = ACTIONS(4331),
    [anon_sym_equals] = ACTIONS(4331),
    [anon_sym_let] = ACTIONS(4331),
    [anon_sym_orderby] = ACTIONS(4331),
    [anon_sym_ascending] = ACTIONS(4331),
    [anon_sym_descending] = ACTIONS(4331),
    [anon_sym_group] = ACTIONS(4331),
    [anon_sym_by] = ACTIONS(4331),
    [anon_sym_select] = ACTIONS(4331),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2795] = {
    [sym__variable_designation] = STATE(4072),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2795),
    [sym_preproc_endregion] = STATE(2795),
    [sym_preproc_line] = STATE(2795),
    [sym_preproc_pragma] = STATE(2795),
    [sym_preproc_nullable] = STATE(2795),
    [sym_preproc_error] = STATE(2795),
    [sym_preproc_define] = STATE(2795),
    [sym_preproc_undef] = STATE(2795),
    [sym__identifier_token] = ACTIONS(4078),
    [anon_sym_alias] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4082),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4092),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4082),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4082),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4082),
    [anon_sym_unmanaged] = ACTIONS(4082),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4082),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4082),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4082),
    [sym_discard] = ACTIONS(4096),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4082),
    [anon_sym_into] = ACTIONS(4082),
    [anon_sym_join] = ACTIONS(4082),
    [anon_sym_on] = ACTIONS(4082),
    [anon_sym_equals] = ACTIONS(4082),
    [anon_sym_let] = ACTIONS(4082),
    [anon_sym_orderby] = ACTIONS(4082),
    [anon_sym_ascending] = ACTIONS(4082),
    [anon_sym_descending] = ACTIONS(4082),
    [anon_sym_group] = ACTIONS(4082),
    [anon_sym_by] = ACTIONS(4082),
    [anon_sym_select] = ACTIONS(4082),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2796] = {
    [sym_preproc_region] = STATE(2796),
    [sym_preproc_endregion] = STATE(2796),
    [sym_preproc_line] = STATE(2796),
    [sym_preproc_pragma] = STATE(2796),
    [sym_preproc_nullable] = STATE(2796),
    [sym_preproc_error] = STATE(2796),
    [sym_preproc_define] = STATE(2796),
    [sym_preproc_undef] = STATE(2796),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_RBRACK] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4183),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4183),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2797] = {
    [sym_preproc_region] = STATE(2797),
    [sym_preproc_endregion] = STATE(2797),
    [sym_preproc_line] = STATE(2797),
    [sym_preproc_pragma] = STATE(2797),
    [sym_preproc_nullable] = STATE(2797),
    [sym_preproc_error] = STATE(2797),
    [sym_preproc_define] = STATE(2797),
    [sym_preproc_undef] = STATE(2797),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4122),
  },
  [2798] = {
    [sym_preproc_region] = STATE(2798),
    [sym_preproc_endregion] = STATE(2798),
    [sym_preproc_line] = STATE(2798),
    [sym_preproc_pragma] = STATE(2798),
    [sym_preproc_nullable] = STATE(2798),
    [sym_preproc_error] = STATE(2798),
    [sym_preproc_define] = STATE(2798),
    [sym_preproc_undef] = STATE(2798),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2799] = {
    [sym_preproc_region] = STATE(2799),
    [sym_preproc_endregion] = STATE(2799),
    [sym_preproc_line] = STATE(2799),
    [sym_preproc_pragma] = STATE(2799),
    [sym_preproc_nullable] = STATE(2799),
    [sym_preproc_error] = STATE(2799),
    [sym_preproc_define] = STATE(2799),
    [sym_preproc_undef] = STATE(2799),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2800] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2800),
    [sym_preproc_endregion] = STATE(2800),
    [sym_preproc_line] = STATE(2800),
    [sym_preproc_pragma] = STATE(2800),
    [sym_preproc_nullable] = STATE(2800),
    [sym_preproc_error] = STATE(2800),
    [sym_preproc_define] = STATE(2800),
    [sym_preproc_undef] = STATE(2800),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_RBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_in] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_if_token3] = ACTIONS(4339),
    [aux_sym_preproc_else_token1] = ACTIONS(4339),
    [aux_sym_preproc_elif_token1] = ACTIONS(4339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2801] = {
    [sym_preproc_region] = STATE(2801),
    [sym_preproc_endregion] = STATE(2801),
    [sym_preproc_line] = STATE(2801),
    [sym_preproc_pragma] = STATE(2801),
    [sym_preproc_nullable] = STATE(2801),
    [sym_preproc_error] = STATE(2801),
    [sym_preproc_define] = STATE(2801),
    [sym_preproc_undef] = STATE(2801),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4086),
  },
  [2802] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2802),
    [sym_preproc_endregion] = STATE(2802),
    [sym_preproc_line] = STATE(2802),
    [sym_preproc_pragma] = STATE(2802),
    [sym_preproc_nullable] = STATE(2802),
    [sym_preproc_error] = STATE(2802),
    [sym_preproc_define] = STATE(2802),
    [sym_preproc_undef] = STATE(2802),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2803] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2803),
    [sym_preproc_endregion] = STATE(2803),
    [sym_preproc_line] = STATE(2803),
    [sym_preproc_pragma] = STATE(2803),
    [sym_preproc_nullable] = STATE(2803),
    [sym_preproc_error] = STATE(2803),
    [sym_preproc_define] = STATE(2803),
    [sym_preproc_undef] = STATE(2803),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_RBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_in] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_if_token3] = ACTIONS(4339),
    [aux_sym_preproc_else_token1] = ACTIONS(4339),
    [aux_sym_preproc_elif_token1] = ACTIONS(4339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2804] = {
    [sym_preproc_region] = STATE(2804),
    [sym_preproc_endregion] = STATE(2804),
    [sym_preproc_line] = STATE(2804),
    [sym_preproc_pragma] = STATE(2804),
    [sym_preproc_nullable] = STATE(2804),
    [sym_preproc_error] = STATE(2804),
    [sym_preproc_define] = STATE(2804),
    [sym_preproc_undef] = STATE(2804),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_RBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2805] = {
    [sym__name] = STATE(3758),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(2805),
    [sym_preproc_endregion] = STATE(2805),
    [sym_preproc_line] = STATE(2805),
    [sym_preproc_pragma] = STATE(2805),
    [sym_preproc_nullable] = STATE(2805),
    [sym_preproc_error] = STATE(2805),
    [sym_preproc_define] = STATE(2805),
    [sym_preproc_undef] = STATE(2805),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2806] = {
    [sym_preproc_region] = STATE(2806),
    [sym_preproc_endregion] = STATE(2806),
    [sym_preproc_line] = STATE(2806),
    [sym_preproc_pragma] = STATE(2806),
    [sym_preproc_nullable] = STATE(2806),
    [sym_preproc_error] = STATE(2806),
    [sym_preproc_define] = STATE(2806),
    [sym_preproc_undef] = STATE(2806),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2807] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2807),
    [sym_preproc_endregion] = STATE(2807),
    [sym_preproc_line] = STATE(2807),
    [sym_preproc_pragma] = STATE(2807),
    [sym_preproc_nullable] = STATE(2807),
    [sym_preproc_error] = STATE(2807),
    [sym_preproc_define] = STATE(2807),
    [sym_preproc_undef] = STATE(2807),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_RBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_if_token3] = ACTIONS(4339),
    [aux_sym_preproc_else_token1] = ACTIONS(4339),
    [aux_sym_preproc_elif_token1] = ACTIONS(4339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2808] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2808),
    [sym_preproc_endregion] = STATE(2808),
    [sym_preproc_line] = STATE(2808),
    [sym_preproc_pragma] = STATE(2808),
    [sym_preproc_nullable] = STATE(2808),
    [sym_preproc_error] = STATE(2808),
    [sym_preproc_define] = STATE(2808),
    [sym_preproc_undef] = STATE(2808),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4339),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_RBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_RPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_if_token3] = ACTIONS(4339),
    [aux_sym_preproc_else_token1] = ACTIONS(4339),
    [aux_sym_preproc_elif_token1] = ACTIONS(4339),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2809] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2809),
    [sym_preproc_endregion] = STATE(2809),
    [sym_preproc_line] = STATE(2809),
    [sym_preproc_pragma] = STATE(2809),
    [sym_preproc_nullable] = STATE(2809),
    [sym_preproc_error] = STATE(2809),
    [sym_preproc_define] = STATE(2809),
    [sym_preproc_undef] = STATE(2809),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_RBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_RPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_if_token3] = ACTIONS(4349),
    [aux_sym_preproc_else_token1] = ACTIONS(4349),
    [aux_sym_preproc_elif_token1] = ACTIONS(4349),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2810] = {
    [sym_type_argument_list] = STATE(2830),
    [sym_preproc_region] = STATE(2810),
    [sym_preproc_endregion] = STATE(2810),
    [sym_preproc_line] = STATE(2810),
    [sym_preproc_pragma] = STATE(2810),
    [sym_preproc_nullable] = STATE(2810),
    [sym_preproc_error] = STATE(2810),
    [sym_preproc_define] = STATE(2810),
    [sym_preproc_undef] = STATE(2810),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4322),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [2811] = {
    [sym_type_argument_list] = STATE(2830),
    [sym_preproc_region] = STATE(2811),
    [sym_preproc_endregion] = STATE(2811),
    [sym_preproc_line] = STATE(2811),
    [sym_preproc_pragma] = STATE(2811),
    [sym_preproc_nullable] = STATE(2811),
    [sym_preproc_error] = STATE(2811),
    [sym_preproc_define] = STATE(2811),
    [sym_preproc_undef] = STATE(2811),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4322),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [2812] = {
    [sym_attribute_list] = STATE(3778),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2812),
    [sym_preproc_endregion] = STATE(2812),
    [sym_preproc_line] = STATE(2812),
    [sym_preproc_pragma] = STATE(2812),
    [sym_preproc_nullable] = STATE(2812),
    [sym_preproc_error] = STATE(2812),
    [sym_preproc_define] = STATE(2812),
    [sym_preproc_undef] = STATE(2812),
    [aux_sym_class_declaration_repeat1] = STATE(3606),
    [aux_sym_class_declaration_repeat2] = STATE(2967),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_ref] = ACTIONS(4363),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_interface] = ACTIONS(4367),
    [anon_sym_delegate] = ACTIONS(4369),
    [anon_sym_record] = ACTIONS(4371),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2813] = {
    [sym_preproc_region] = STATE(2813),
    [sym_preproc_endregion] = STATE(2813),
    [sym_preproc_line] = STATE(2813),
    [sym_preproc_pragma] = STATE(2813),
    [sym_preproc_nullable] = STATE(2813),
    [sym_preproc_error] = STATE(2813),
    [sym_preproc_define] = STATE(2813),
    [sym_preproc_undef] = STATE(2813),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2814] = {
    [sym_preproc_region] = STATE(2814),
    [sym_preproc_endregion] = STATE(2814),
    [sym_preproc_line] = STATE(2814),
    [sym_preproc_pragma] = STATE(2814),
    [sym_preproc_nullable] = STATE(2814),
    [sym_preproc_error] = STATE(2814),
    [sym_preproc_define] = STATE(2814),
    [sym_preproc_undef] = STATE(2814),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_return] = ACTIONS(4373),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(4375),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2815] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2815),
    [sym_preproc_endregion] = STATE(2815),
    [sym_preproc_line] = STATE(2815),
    [sym_preproc_pragma] = STATE(2815),
    [sym_preproc_nullable] = STATE(2815),
    [sym_preproc_error] = STATE(2815),
    [sym_preproc_define] = STATE(2815),
    [sym_preproc_undef] = STATE(2815),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4377),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2816] = {
    [sym_attribute_list] = STATE(3778),
    [sym_modifier] = STATE(3802),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6962),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2816),
    [sym_preproc_endregion] = STATE(2816),
    [sym_preproc_line] = STATE(2816),
    [sym_preproc_pragma] = STATE(2816),
    [sym_preproc_nullable] = STATE(2816),
    [sym_preproc_error] = STATE(2816),
    [sym_preproc_define] = STATE(2816),
    [sym_preproc_undef] = STATE(2816),
    [aux_sym_class_declaration_repeat1] = STATE(3606),
    [aux_sym_class_declaration_repeat2] = STATE(2958),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(3125),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_class] = ACTIONS(4379),
    [anon_sym_ref] = ACTIONS(4381),
    [anon_sym_struct] = ACTIONS(2729),
    [anon_sym_enum] = ACTIONS(4383),
    [anon_sym_interface] = ACTIONS(4385),
    [anon_sym_delegate] = ACTIONS(4387),
    [anon_sym_record] = ACTIONS(4389),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(37),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2817] = {
    [sym_preproc_region] = STATE(2817),
    [sym_preproc_endregion] = STATE(2817),
    [sym_preproc_line] = STATE(2817),
    [sym_preproc_pragma] = STATE(2817),
    [sym_preproc_nullable] = STATE(2817),
    [sym_preproc_error] = STATE(2817),
    [sym_preproc_define] = STATE(2817),
    [sym_preproc_undef] = STATE(2817),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2818] = {
    [sym_preproc_region] = STATE(2818),
    [sym_preproc_endregion] = STATE(2818),
    [sym_preproc_line] = STATE(2818),
    [sym_preproc_pragma] = STATE(2818),
    [sym_preproc_nullable] = STATE(2818),
    [sym_preproc_error] = STATE(2818),
    [sym_preproc_define] = STATE(2818),
    [sym_preproc_undef] = STATE(2818),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2819] = {
    [sym_preproc_region] = STATE(2819),
    [sym_preproc_endregion] = STATE(2819),
    [sym_preproc_line] = STATE(2819),
    [sym_preproc_pragma] = STATE(2819),
    [sym_preproc_nullable] = STATE(2819),
    [sym_preproc_error] = STATE(2819),
    [sym_preproc_define] = STATE(2819),
    [sym_preproc_undef] = STATE(2819),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4183),
  },
  [2820] = {
    [sym_preproc_region] = STATE(2820),
    [sym_preproc_endregion] = STATE(2820),
    [sym_preproc_line] = STATE(2820),
    [sym_preproc_pragma] = STATE(2820),
    [sym_preproc_nullable] = STATE(2820),
    [sym_preproc_error] = STATE(2820),
    [sym_preproc_define] = STATE(2820),
    [sym_preproc_undef] = STATE(2820),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_return] = ACTIONS(4391),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(4393),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2821] = {
    [sym_preproc_region] = STATE(2821),
    [sym_preproc_endregion] = STATE(2821),
    [sym_preproc_line] = STATE(2821),
    [sym_preproc_pragma] = STATE(2821),
    [sym_preproc_nullable] = STATE(2821),
    [sym_preproc_error] = STATE(2821),
    [sym_preproc_define] = STATE(2821),
    [sym_preproc_undef] = STATE(2821),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2822] = {
    [sym_preproc_region] = STATE(2822),
    [sym_preproc_endregion] = STATE(2822),
    [sym_preproc_line] = STATE(2822),
    [sym_preproc_pragma] = STATE(2822),
    [sym_preproc_nullable] = STATE(2822),
    [sym_preproc_error] = STATE(2822),
    [sym_preproc_define] = STATE(2822),
    [sym_preproc_undef] = STATE(2822),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2823] = {
    [sym_preproc_region] = STATE(2823),
    [sym_preproc_endregion] = STATE(2823),
    [sym_preproc_line] = STATE(2823),
    [sym_preproc_pragma] = STATE(2823),
    [sym_preproc_nullable] = STATE(2823),
    [sym_preproc_error] = STATE(2823),
    [sym_preproc_define] = STATE(2823),
    [sym_preproc_undef] = STATE(2823),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2824] = {
    [sym_preproc_region] = STATE(2824),
    [sym_preproc_endregion] = STATE(2824),
    [sym_preproc_line] = STATE(2824),
    [sym_preproc_pragma] = STATE(2824),
    [sym_preproc_nullable] = STATE(2824),
    [sym_preproc_error] = STATE(2824),
    [sym_preproc_define] = STATE(2824),
    [sym_preproc_undef] = STATE(2824),
    [sym__identifier_token] = ACTIONS(4126),
    [anon_sym_alias] = ACTIONS(4126),
    [anon_sym_global] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_file] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4126),
    [anon_sym_unmanaged] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4126),
    [anon_sym_var] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4126),
    [sym_discard] = ACTIONS(4126),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4126),
    [anon_sym_join] = ACTIONS(4126),
    [anon_sym_on] = ACTIONS(4126),
    [anon_sym_equals] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_orderby] = ACTIONS(4126),
    [anon_sym_ascending] = ACTIONS(4126),
    [anon_sym_descending] = ACTIONS(4126),
    [anon_sym_group] = ACTIONS(4126),
    [anon_sym_by] = ACTIONS(4126),
    [anon_sym_select] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4128),
  },
  [2825] = {
    [sym_preproc_region] = STATE(2825),
    [sym_preproc_endregion] = STATE(2825),
    [sym_preproc_line] = STATE(2825),
    [sym_preproc_pragma] = STATE(2825),
    [sym_preproc_nullable] = STATE(2825),
    [sym_preproc_error] = STATE(2825),
    [sym_preproc_define] = STATE(2825),
    [sym_preproc_undef] = STATE(2825),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4122),
  },
  [2826] = {
    [sym_preproc_region] = STATE(2826),
    [sym_preproc_endregion] = STATE(2826),
    [sym_preproc_line] = STATE(2826),
    [sym_preproc_pragma] = STATE(2826),
    [sym_preproc_nullable] = STATE(2826),
    [sym_preproc_error] = STATE(2826),
    [sym_preproc_define] = STATE(2826),
    [sym_preproc_undef] = STATE(2826),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4183),
  },
  [2827] = {
    [sym_property_pattern_clause] = STATE(2874),
    [sym__variable_designation] = STATE(4058),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2827),
    [sym_preproc_endregion] = STATE(2827),
    [sym_preproc_line] = STATE(2827),
    [sym_preproc_pragma] = STATE(2827),
    [sym_preproc_nullable] = STATE(2827),
    [sym_preproc_error] = STATE(2827),
    [sym_preproc_define] = STATE(2827),
    [sym_preproc_undef] = STATE(2827),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4395),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_RBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_RPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_in] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_if_token3] = ACTIONS(4395),
    [aux_sym_preproc_else_token1] = ACTIONS(4395),
    [aux_sym_preproc_elif_token1] = ACTIONS(4395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2828] = {
    [sym_preproc_region] = STATE(2828),
    [sym_preproc_endregion] = STATE(2828),
    [sym_preproc_line] = STATE(2828),
    [sym_preproc_pragma] = STATE(2828),
    [sym_preproc_nullable] = STATE(2828),
    [sym_preproc_error] = STATE(2828),
    [sym_preproc_define] = STATE(2828),
    [sym_preproc_undef] = STATE(2828),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2829] = {
    [sym_preproc_region] = STATE(2829),
    [sym_preproc_endregion] = STATE(2829),
    [sym_preproc_line] = STATE(2829),
    [sym_preproc_pragma] = STATE(2829),
    [sym_preproc_nullable] = STATE(2829),
    [sym_preproc_error] = STATE(2829),
    [sym_preproc_define] = STATE(2829),
    [sym_preproc_undef] = STATE(2829),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2830] = {
    [sym_preproc_region] = STATE(2830),
    [sym_preproc_endregion] = STATE(2830),
    [sym_preproc_line] = STATE(2830),
    [sym_preproc_pragma] = STATE(2830),
    [sym_preproc_nullable] = STATE(2830),
    [sym_preproc_error] = STATE(2830),
    [sym_preproc_define] = STATE(2830),
    [sym_preproc_undef] = STATE(2830),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4144),
  },
  [2831] = {
    [sym_preproc_region] = STATE(2831),
    [sym_preproc_endregion] = STATE(2831),
    [sym_preproc_line] = STATE(2831),
    [sym_preproc_pragma] = STATE(2831),
    [sym_preproc_nullable] = STATE(2831),
    [sym_preproc_error] = STATE(2831),
    [sym_preproc_define] = STATE(2831),
    [sym_preproc_undef] = STATE(2831),
    [sym__identifier_token] = ACTIONS(4130),
    [anon_sym_alias] = ACTIONS(4130),
    [anon_sym_global] = ACTIONS(4130),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_file] = ACTIONS(4130),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_notnull] = ACTIONS(4130),
    [anon_sym_unmanaged] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_scoped] = ACTIONS(4130),
    [anon_sym_var] = ACTIONS(4130),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_switch] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_is] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4130),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4132),
  },
  [2832] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2832),
    [sym_preproc_endregion] = STATE(2832),
    [sym_preproc_line] = STATE(2832),
    [sym_preproc_pragma] = STATE(2832),
    [sym_preproc_nullable] = STATE(2832),
    [sym_preproc_error] = STATE(2832),
    [sym_preproc_define] = STATE(2832),
    [sym_preproc_undef] = STATE(2832),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4399),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2833] = {
    [sym_preproc_region] = STATE(2833),
    [sym_preproc_endregion] = STATE(2833),
    [sym_preproc_line] = STATE(2833),
    [sym_preproc_pragma] = STATE(2833),
    [sym_preproc_nullable] = STATE(2833),
    [sym_preproc_error] = STATE(2833),
    [sym_preproc_define] = STATE(2833),
    [sym_preproc_undef] = STATE(2833),
    [sym__identifier_token] = ACTIONS(4134),
    [anon_sym_alias] = ACTIONS(4134),
    [anon_sym_global] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_file] = ACTIONS(4134),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_notnull] = ACTIONS(4134),
    [anon_sym_unmanaged] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_scoped] = ACTIONS(4134),
    [anon_sym_var] = ACTIONS(4134),
    [anon_sym_yield] = ACTIONS(4134),
    [anon_sym_switch] = ACTIONS(4134),
    [anon_sym_when] = ACTIONS(4134),
    [sym_discard] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_from] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4134),
    [anon_sym_join] = ACTIONS(4134),
    [anon_sym_on] = ACTIONS(4134),
    [anon_sym_equals] = ACTIONS(4134),
    [anon_sym_let] = ACTIONS(4134),
    [anon_sym_orderby] = ACTIONS(4134),
    [anon_sym_ascending] = ACTIONS(4134),
    [anon_sym_descending] = ACTIONS(4134),
    [anon_sym_group] = ACTIONS(4134),
    [anon_sym_by] = ACTIONS(4134),
    [anon_sym_select] = ACTIONS(4134),
    [anon_sym_as] = ACTIONS(4134),
    [anon_sym_is] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4134),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4136),
  },
  [2834] = {
    [sym_preproc_region] = STATE(2834),
    [sym_preproc_endregion] = STATE(2834),
    [sym_preproc_line] = STATE(2834),
    [sym_preproc_pragma] = STATE(2834),
    [sym_preproc_nullable] = STATE(2834),
    [sym_preproc_error] = STATE(2834),
    [sym_preproc_define] = STATE(2834),
    [sym_preproc_undef] = STATE(2834),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(4401),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2835] = {
    [sym_preproc_region] = STATE(2835),
    [sym_preproc_endregion] = STATE(2835),
    [sym_preproc_line] = STATE(2835),
    [sym_preproc_pragma] = STATE(2835),
    [sym_preproc_nullable] = STATE(2835),
    [sym_preproc_error] = STATE(2835),
    [sym_preproc_define] = STATE(2835),
    [sym_preproc_undef] = STATE(2835),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2836] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2836),
    [sym_preproc_endregion] = STATE(2836),
    [sym_preproc_line] = STATE(2836),
    [sym_preproc_pragma] = STATE(2836),
    [sym_preproc_nullable] = STATE(2836),
    [sym_preproc_error] = STATE(2836),
    [sym_preproc_define] = STATE(2836),
    [sym_preproc_undef] = STATE(2836),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(4153),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2837] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2837),
    [sym_preproc_endregion] = STATE(2837),
    [sym_preproc_line] = STATE(2837),
    [sym_preproc_pragma] = STATE(2837),
    [sym_preproc_nullable] = STATE(2837),
    [sym_preproc_error] = STATE(2837),
    [sym_preproc_define] = STATE(2837),
    [sym_preproc_undef] = STATE(2837),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2838] = {
    [sym_preproc_region] = STATE(2838),
    [sym_preproc_endregion] = STATE(2838),
    [sym_preproc_line] = STATE(2838),
    [sym_preproc_pragma] = STATE(2838),
    [sym_preproc_nullable] = STATE(2838),
    [sym_preproc_error] = STATE(2838),
    [sym_preproc_define] = STATE(2838),
    [sym_preproc_undef] = STATE(2838),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4175),
  },
  [2839] = {
    [sym_preproc_region] = STATE(2839),
    [sym_preproc_endregion] = STATE(2839),
    [sym_preproc_line] = STATE(2839),
    [sym_preproc_pragma] = STATE(2839),
    [sym_preproc_nullable] = STATE(2839),
    [sym_preproc_error] = STATE(2839),
    [sym_preproc_define] = STATE(2839),
    [sym_preproc_undef] = STATE(2839),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4164),
    [anon_sym_GT] = ACTIONS(4164),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4164),
    [anon_sym_PLUS_PLUS] = ACTIONS(4161),
    [anon_sym_DASH_DASH] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4164),
    [anon_sym_DASH] = ACTIONS(4164),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4164),
    [anon_sym_PERCENT] = ACTIONS(4164),
    [anon_sym_CARET] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_AMP] = ACTIONS(4164),
    [anon_sym_LT_LT] = ACTIONS(4164),
    [anon_sym_GT_GT] = ACTIONS(4164),
    [anon_sym_GT_GT_GT] = ACTIONS(4164),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_GT_EQ] = ACTIONS(4161),
    [anon_sym_LT_EQ] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4161),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_PIPE_PIPE] = ACTIONS(4161),
    [anon_sym_QMARK_QMARK] = ACTIONS(4164),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4164),
    [anon_sym_is] = ACTIONS(4164),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4164),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4157),
  },
  [2840] = {
    [sym_preproc_region] = STATE(2840),
    [sym_preproc_endregion] = STATE(2840),
    [sym_preproc_line] = STATE(2840),
    [sym_preproc_pragma] = STATE(2840),
    [sym_preproc_nullable] = STATE(2840),
    [sym_preproc_error] = STATE(2840),
    [sym_preproc_define] = STATE(2840),
    [sym_preproc_undef] = STATE(2840),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4178),
  },
  [2841] = {
    [sym_preproc_region] = STATE(2841),
    [sym_preproc_endregion] = STATE(2841),
    [sym_preproc_line] = STATE(2841),
    [sym_preproc_pragma] = STATE(2841),
    [sym_preproc_nullable] = STATE(2841),
    [sym_preproc_error] = STATE(2841),
    [sym_preproc_define] = STATE(2841),
    [sym_preproc_undef] = STATE(2841),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4175),
  },
  [2842] = {
    [sym_property_pattern_clause] = STATE(2868),
    [sym__variable_designation] = STATE(4019),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2842),
    [sym_preproc_endregion] = STATE(2842),
    [sym_preproc_line] = STATE(2842),
    [sym_preproc_pragma] = STATE(2842),
    [sym_preproc_nullable] = STATE(2842),
    [sym_preproc_error] = STATE(2842),
    [sym_preproc_define] = STATE(2842),
    [sym_preproc_undef] = STATE(2842),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4403),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_RBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_RPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_in] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_if_token3] = ACTIONS(4403),
    [aux_sym_preproc_else_token1] = ACTIONS(4403),
    [aux_sym_preproc_elif_token1] = ACTIONS(4403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2843] = {
    [sym_preproc_region] = STATE(2843),
    [sym_preproc_endregion] = STATE(2843),
    [sym_preproc_line] = STATE(2843),
    [sym_preproc_pragma] = STATE(2843),
    [sym_preproc_nullable] = STATE(2843),
    [sym_preproc_error] = STATE(2843),
    [sym_preproc_define] = STATE(2843),
    [sym_preproc_undef] = STATE(2843),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [2844] = {
    [sym_preproc_region] = STATE(2844),
    [sym_preproc_endregion] = STATE(2844),
    [sym_preproc_line] = STATE(2844),
    [sym_preproc_pragma] = STATE(2844),
    [sym_preproc_nullable] = STATE(2844),
    [sym_preproc_error] = STATE(2844),
    [sym_preproc_define] = STATE(2844),
    [sym_preproc_undef] = STATE(2844),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4183),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4194),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2845] = {
    [sym_preproc_region] = STATE(2845),
    [sym_preproc_endregion] = STATE(2845),
    [sym_preproc_line] = STATE(2845),
    [sym_preproc_pragma] = STATE(2845),
    [sym_preproc_nullable] = STATE(2845),
    [sym_preproc_error] = STATE(2845),
    [sym_preproc_define] = STATE(2845),
    [sym_preproc_undef] = STATE(2845),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2846] = {
    [sym_preproc_region] = STATE(2846),
    [sym_preproc_endregion] = STATE(2846),
    [sym_preproc_line] = STATE(2846),
    [sym_preproc_pragma] = STATE(2846),
    [sym_preproc_nullable] = STATE(2846),
    [sym_preproc_error] = STATE(2846),
    [sym_preproc_define] = STATE(2846),
    [sym_preproc_undef] = STATE(2846),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(4089),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4089),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4089),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4089),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2847] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2847),
    [sym_preproc_endregion] = STATE(2847),
    [sym_preproc_line] = STATE(2847),
    [sym_preproc_pragma] = STATE(2847),
    [sym_preproc_nullable] = STATE(2847),
    [sym_preproc_error] = STATE(2847),
    [sym_preproc_define] = STATE(2847),
    [sym_preproc_undef] = STATE(2847),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4407),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2848] = {
    [sym__name] = STATE(3176),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(3127),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2848),
    [sym_preproc_endregion] = STATE(2848),
    [sym_preproc_line] = STATE(2848),
    [sym_preproc_pragma] = STATE(2848),
    [sym_preproc_nullable] = STATE(2848),
    [sym_preproc_error] = STATE(2848),
    [sym_preproc_define] = STATE(2848),
    [sym_preproc_undef] = STATE(2848),
    [sym__identifier_token] = ACTIONS(4062),
    [anon_sym_alias] = ACTIONS(4065),
    [anon_sym_global] = ACTIONS(4065),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4065),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4065),
    [anon_sym_unmanaged] = ACTIONS(4065),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4065),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4065),
    [anon_sym_yield] = ACTIONS(4065),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4065),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4065),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4065),
    [anon_sym_equals] = ACTIONS(4065),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4065),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2849] = {
    [sym_preproc_region] = STATE(2849),
    [sym_preproc_endregion] = STATE(2849),
    [sym_preproc_line] = STATE(2849),
    [sym_preproc_pragma] = STATE(2849),
    [sym_preproc_nullable] = STATE(2849),
    [sym_preproc_error] = STATE(2849),
    [sym_preproc_define] = STATE(2849),
    [sym_preproc_undef] = STATE(2849),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4180),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2850] = {
    [sym_preproc_region] = STATE(2850),
    [sym_preproc_endregion] = STATE(2850),
    [sym_preproc_line] = STATE(2850),
    [sym_preproc_pragma] = STATE(2850),
    [sym_preproc_nullable] = STATE(2850),
    [sym_preproc_error] = STATE(2850),
    [sym_preproc_define] = STATE(2850),
    [sym_preproc_undef] = STATE(2850),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4180),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2851] = {
    [sym_modifier] = STATE(3802),
    [sym_variable_declaration] = STATE(9776),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6353),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6742),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2851),
    [sym_preproc_endregion] = STATE(2851),
    [sym_preproc_line] = STATE(2851),
    [sym_preproc_pragma] = STATE(2851),
    [sym_preproc_nullable] = STATE(2851),
    [sym_preproc_error] = STATE(2851),
    [sym_preproc_define] = STATE(2851),
    [sym_preproc_undef] = STATE(2851),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(4409),
    [anon_sym_class] = ACTIONS(4411),
    [anon_sym_ref] = ACTIONS(4413),
    [anon_sym_struct] = ACTIONS(4415),
    [anon_sym_enum] = ACTIONS(4417),
    [anon_sym_interface] = ACTIONS(4419),
    [anon_sym_delegate] = ACTIONS(4421),
    [anon_sym_record] = ACTIONS(4423),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_implicit] = ACTIONS(4425),
    [anon_sym_explicit] = ACTIONS(4425),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2852] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2852),
    [sym_preproc_endregion] = STATE(2852),
    [sym_preproc_line] = STATE(2852),
    [sym_preproc_pragma] = STATE(2852),
    [sym_preproc_nullable] = STATE(2852),
    [sym_preproc_error] = STATE(2852),
    [sym_preproc_define] = STATE(2852),
    [sym_preproc_undef] = STATE(2852),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4427),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2853] = {
    [sym_property_pattern_clause] = STATE(2899),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2853),
    [sym_preproc_endregion] = STATE(2853),
    [sym_preproc_line] = STATE(2853),
    [sym_preproc_pragma] = STATE(2853),
    [sym_preproc_nullable] = STATE(2853),
    [sym_preproc_error] = STATE(2853),
    [sym_preproc_define] = STATE(2853),
    [sym_preproc_undef] = STATE(2853),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4403),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_RBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_RPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_if_token3] = ACTIONS(4403),
    [aux_sym_preproc_else_token1] = ACTIONS(4403),
    [aux_sym_preproc_elif_token1] = ACTIONS(4403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2854] = {
    [sym_parameter_list] = STATE(9912),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(9488),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(2854),
    [sym_preproc_endregion] = STATE(2854),
    [sym_preproc_line] = STATE(2854),
    [sym_preproc_pragma] = STATE(2854),
    [sym_preproc_nullable] = STATE(2854),
    [sym_preproc_error] = STATE(2854),
    [sym_preproc_define] = STATE(2854),
    [sym_preproc_undef] = STATE(2854),
    [sym__identifier_token] = ACTIONS(4429),
    [anon_sym_alias] = ACTIONS(4429),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_global] = ACTIONS(4429),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_file] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4429),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_notnull] = ACTIONS(4429),
    [anon_sym_unmanaged] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_scoped] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_var] = ACTIONS(4429),
    [anon_sym_yield] = ACTIONS(4429),
    [anon_sym_switch] = ACTIONS(4429),
    [anon_sym_when] = ACTIONS(4429),
    [sym_discard] = ACTIONS(4429),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4429),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4429),
    [anon_sym_into] = ACTIONS(4429),
    [anon_sym_join] = ACTIONS(4429),
    [anon_sym_on] = ACTIONS(4429),
    [anon_sym_equals] = ACTIONS(4429),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_orderby] = ACTIONS(4429),
    [anon_sym_ascending] = ACTIONS(4429),
    [anon_sym_descending] = ACTIONS(4429),
    [anon_sym_group] = ACTIONS(4429),
    [anon_sym_by] = ACTIONS(4429),
    [anon_sym_select] = ACTIONS(4429),
    [anon_sym_as] = ACTIONS(4429),
    [anon_sym_is] = ACTIONS(4429),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4429),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2855] = {
    [sym_preproc_region] = STATE(2855),
    [sym_preproc_endregion] = STATE(2855),
    [sym_preproc_line] = STATE(2855),
    [sym_preproc_pragma] = STATE(2855),
    [sym_preproc_nullable] = STATE(2855),
    [sym_preproc_error] = STATE(2855),
    [sym_preproc_define] = STATE(2855),
    [sym_preproc_undef] = STATE(2855),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4175),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4180),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2856] = {
    [sym_property_pattern_clause] = STATE(2898),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2856),
    [sym_preproc_endregion] = STATE(2856),
    [sym_preproc_line] = STATE(2856),
    [sym_preproc_pragma] = STATE(2856),
    [sym_preproc_nullable] = STATE(2856),
    [sym_preproc_error] = STATE(2856),
    [sym_preproc_define] = STATE(2856),
    [sym_preproc_undef] = STATE(2856),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4395),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_RBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_RPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_if_token3] = ACTIONS(4395),
    [aux_sym_preproc_else_token1] = ACTIONS(4395),
    [aux_sym_preproc_elif_token1] = ACTIONS(4395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2857] = {
    [sym_modifier] = STATE(3802),
    [sym_variable_declaration] = STATE(9558),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6419),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6744),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2857),
    [sym_preproc_endregion] = STATE(2857),
    [sym_preproc_line] = STATE(2857),
    [sym_preproc_pragma] = STATE(2857),
    [sym_preproc_nullable] = STATE(2857),
    [sym_preproc_error] = STATE(2857),
    [sym_preproc_define] = STATE(2857),
    [sym_preproc_undef] = STATE(2857),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_event] = ACTIONS(4266),
    [anon_sym_class] = ACTIONS(4268),
    [anon_sym_ref] = ACTIONS(4270),
    [anon_sym_struct] = ACTIONS(4272),
    [anon_sym_enum] = ACTIONS(4274),
    [anon_sym_interface] = ACTIONS(4276),
    [anon_sym_delegate] = ACTIONS(4278),
    [anon_sym_record] = ACTIONS(4280),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_implicit] = ACTIONS(4284),
    [anon_sym_explicit] = ACTIONS(4284),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2858] = {
    [sym_preproc_region] = STATE(2858),
    [sym_preproc_endregion] = STATE(2858),
    [sym_preproc_line] = STATE(2858),
    [sym_preproc_pragma] = STATE(2858),
    [sym_preproc_nullable] = STATE(2858),
    [sym_preproc_error] = STATE(2858),
    [sym_preproc_define] = STATE(2858),
    [sym_preproc_undef] = STATE(2858),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4183),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4194),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2859] = {
    [sym_preproc_region] = STATE(2859),
    [sym_preproc_endregion] = STATE(2859),
    [sym_preproc_line] = STATE(2859),
    [sym_preproc_pragma] = STATE(2859),
    [sym_preproc_nullable] = STATE(2859),
    [sym_preproc_error] = STATE(2859),
    [sym_preproc_define] = STATE(2859),
    [sym_preproc_undef] = STATE(2859),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4183),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4194),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2860] = {
    [sym_preproc_region] = STATE(2860),
    [sym_preproc_endregion] = STATE(2860),
    [sym_preproc_line] = STATE(2860),
    [sym_preproc_pragma] = STATE(2860),
    [sym_preproc_nullable] = STATE(2860),
    [sym_preproc_error] = STATE(2860),
    [sym_preproc_define] = STATE(2860),
    [sym_preproc_undef] = STATE(2860),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4171),
  },
  [2861] = {
    [sym_preproc_region] = STATE(2861),
    [sym_preproc_endregion] = STATE(2861),
    [sym_preproc_line] = STATE(2861),
    [sym_preproc_pragma] = STATE(2861),
    [sym_preproc_nullable] = STATE(2861),
    [sym_preproc_error] = STATE(2861),
    [sym_preproc_define] = STATE(2861),
    [sym_preproc_undef] = STATE(2861),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4167),
  },
  [2862] = {
    [sym_preproc_region] = STATE(2862),
    [sym_preproc_endregion] = STATE(2862),
    [sym_preproc_line] = STATE(2862),
    [sym_preproc_pragma] = STATE(2862),
    [sym_preproc_nullable] = STATE(2862),
    [sym_preproc_error] = STATE(2862),
    [sym_preproc_define] = STATE(2862),
    [sym_preproc_undef] = STATE(2862),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2863] = {
    [sym__name] = STATE(3290),
    [sym_alias_qualified_name] = STATE(3453),
    [sym__simple_name] = STATE(3453),
    [sym_qualified_name] = STATE(3453),
    [sym_generic_name] = STATE(3371),
    [sym_ref_type] = STATE(3288),
    [sym__scoped_base_type] = STATE(3287),
    [sym_identifier] = STATE(3152),
    [sym__reserved_identifier] = STATE(3207),
    [sym_preproc_region] = STATE(2863),
    [sym_preproc_endregion] = STATE(2863),
    [sym_preproc_line] = STATE(2863),
    [sym_preproc_pragma] = STATE(2863),
    [sym_preproc_nullable] = STATE(2863),
    [sym_preproc_error] = STATE(2863),
    [sym_preproc_define] = STATE(2863),
    [sym_preproc_undef] = STATE(2863),
    [sym__identifier_token] = ACTIONS(4104),
    [anon_sym_alias] = ACTIONS(4107),
    [anon_sym_global] = ACTIONS(4107),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4107),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4107),
    [anon_sym_unmanaged] = ACTIONS(4107),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4107),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4107),
    [anon_sym_yield] = ACTIONS(4107),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4107),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4107),
    [anon_sym_into] = ACTIONS(4107),
    [anon_sym_join] = ACTIONS(4107),
    [anon_sym_on] = ACTIONS(4107),
    [anon_sym_equals] = ACTIONS(4107),
    [anon_sym_let] = ACTIONS(4107),
    [anon_sym_orderby] = ACTIONS(4107),
    [anon_sym_ascending] = ACTIONS(4107),
    [anon_sym_descending] = ACTIONS(4107),
    [anon_sym_group] = ACTIONS(4107),
    [anon_sym_by] = ACTIONS(4107),
    [anon_sym_select] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2864] = {
    [sym_preproc_region] = STATE(2864),
    [sym_preproc_endregion] = STATE(2864),
    [sym_preproc_line] = STATE(2864),
    [sym_preproc_pragma] = STATE(2864),
    [sym_preproc_nullable] = STATE(2864),
    [sym_preproc_error] = STATE(2864),
    [sym_preproc_define] = STATE(2864),
    [sym_preproc_undef] = STATE(2864),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4180),
    [anon_sym_descending] = ACTIONS(4180),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2865] = {
    [sym_preproc_region] = STATE(2865),
    [sym_preproc_endregion] = STATE(2865),
    [sym_preproc_line] = STATE(2865),
    [sym_preproc_pragma] = STATE(2865),
    [sym_preproc_nullable] = STATE(2865),
    [sym_preproc_error] = STATE(2865),
    [sym_preproc_define] = STATE(2865),
    [sym_preproc_undef] = STATE(2865),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4194),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4194),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4194),
    [anon_sym_orderby] = ACTIONS(4194),
    [anon_sym_ascending] = ACTIONS(4194),
    [anon_sym_descending] = ACTIONS(4194),
    [anon_sym_group] = ACTIONS(4194),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4194),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2866] = {
    [sym_preproc_region] = STATE(2866),
    [sym_preproc_endregion] = STATE(2866),
    [sym_preproc_line] = STATE(2866),
    [sym_preproc_pragma] = STATE(2866),
    [sym_preproc_nullable] = STATE(2866),
    [sym_preproc_error] = STATE(2866),
    [sym_preproc_define] = STATE(2866),
    [sym_preproc_undef] = STATE(2866),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2867] = {
    [sym_preproc_region] = STATE(2867),
    [sym_preproc_endregion] = STATE(2867),
    [sym_preproc_line] = STATE(2867),
    [sym_preproc_pragma] = STATE(2867),
    [sym_preproc_nullable] = STATE(2867),
    [sym_preproc_error] = STATE(2867),
    [sym_preproc_define] = STATE(2867),
    [sym_preproc_undef] = STATE(2867),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4167),
  },
  [2868] = {
    [sym__variable_designation] = STATE(3999),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2868),
    [sym_preproc_endregion] = STATE(2868),
    [sym_preproc_line] = STATE(2868),
    [sym_preproc_pragma] = STATE(2868),
    [sym_preproc_nullable] = STATE(2868),
    [sym_preproc_error] = STATE(2868),
    [sym_preproc_define] = STATE(2868),
    [sym_preproc_undef] = STATE(2868),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4433),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_RPAREN] = ACTIONS(4433),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_in] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4433),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_if_token3] = ACTIONS(4433),
    [aux_sym_preproc_else_token1] = ACTIONS(4433),
    [aux_sym_preproc_elif_token1] = ACTIONS(4433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2869] = {
    [sym_preproc_region] = STATE(2869),
    [sym_preproc_endregion] = STATE(2869),
    [sym_preproc_line] = STATE(2869),
    [sym_preproc_pragma] = STATE(2869),
    [sym_preproc_nullable] = STATE(2869),
    [sym_preproc_error] = STATE(2869),
    [sym_preproc_define] = STATE(2869),
    [sym_preproc_undef] = STATE(2869),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4194),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4194),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4194),
    [anon_sym_orderby] = ACTIONS(4194),
    [anon_sym_ascending] = ACTIONS(4194),
    [anon_sym_descending] = ACTIONS(4194),
    [anon_sym_group] = ACTIONS(4194),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4194),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2870] = {
    [sym_preproc_region] = STATE(2870),
    [sym_preproc_endregion] = STATE(2870),
    [sym_preproc_line] = STATE(2870),
    [sym_preproc_pragma] = STATE(2870),
    [sym_preproc_nullable] = STATE(2870),
    [sym_preproc_error] = STATE(2870),
    [sym_preproc_define] = STATE(2870),
    [sym_preproc_undef] = STATE(2870),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2871] = {
    [sym_preproc_region] = STATE(2871),
    [sym_preproc_endregion] = STATE(2871),
    [sym_preproc_line] = STATE(2871),
    [sym_preproc_pragma] = STATE(2871),
    [sym_preproc_nullable] = STATE(2871),
    [sym_preproc_error] = STATE(2871),
    [sym_preproc_define] = STATE(2871),
    [sym_preproc_undef] = STATE(2871),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_return] = ACTIONS(4437),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(4439),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2872] = {
    [sym_preproc_region] = STATE(2872),
    [sym_preproc_endregion] = STATE(2872),
    [sym_preproc_line] = STATE(2872),
    [sym_preproc_pragma] = STATE(2872),
    [sym_preproc_nullable] = STATE(2872),
    [sym_preproc_error] = STATE(2872),
    [sym_preproc_define] = STATE(2872),
    [sym_preproc_undef] = STATE(2872),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2873] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2873),
    [sym_preproc_endregion] = STATE(2873),
    [sym_preproc_line] = STATE(2873),
    [sym_preproc_pragma] = STATE(2873),
    [sym_preproc_nullable] = STATE(2873),
    [sym_preproc_error] = STATE(2873),
    [sym_preproc_define] = STATE(2873),
    [sym_preproc_undef] = STATE(2873),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2874] = {
    [sym__variable_designation] = STATE(4008),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2874),
    [sym_preproc_endregion] = STATE(2874),
    [sym_preproc_line] = STATE(2874),
    [sym_preproc_pragma] = STATE(2874),
    [sym_preproc_nullable] = STATE(2874),
    [sym_preproc_error] = STATE(2874),
    [sym_preproc_define] = STATE(2874),
    [sym_preproc_undef] = STATE(2874),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4443),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_RBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_RPAREN] = ACTIONS(4443),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_in] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4443),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_if_token3] = ACTIONS(4443),
    [aux_sym_preproc_else_token1] = ACTIONS(4443),
    [aux_sym_preproc_elif_token1] = ACTIONS(4443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2875] = {
    [sym_preproc_region] = STATE(2875),
    [sym_preproc_endregion] = STATE(2875),
    [sym_preproc_line] = STATE(2875),
    [sym_preproc_pragma] = STATE(2875),
    [sym_preproc_nullable] = STATE(2875),
    [sym_preproc_error] = STATE(2875),
    [sym_preproc_define] = STATE(2875),
    [sym_preproc_undef] = STATE(2875),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4183),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4194),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2876] = {
    [sym__variable_designation] = STATE(4055),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2876),
    [sym_preproc_endregion] = STATE(2876),
    [sym_preproc_line] = STATE(2876),
    [sym_preproc_pragma] = STATE(2876),
    [sym_preproc_nullable] = STATE(2876),
    [sym_preproc_error] = STATE(2876),
    [sym_preproc_define] = STATE(2876),
    [sym_preproc_undef] = STATE(2876),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4395),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_RBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_RPAREN] = ACTIONS(4395),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_in] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_if_token3] = ACTIONS(4395),
    [aux_sym_preproc_else_token1] = ACTIONS(4395),
    [aux_sym_preproc_elif_token1] = ACTIONS(4395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2877] = {
    [sym_preproc_region] = STATE(2877),
    [sym_preproc_endregion] = STATE(2877),
    [sym_preproc_line] = STATE(2877),
    [sym_preproc_pragma] = STATE(2877),
    [sym_preproc_nullable] = STATE(2877),
    [sym_preproc_error] = STATE(2877),
    [sym_preproc_define] = STATE(2877),
    [sym_preproc_undef] = STATE(2877),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2878] = {
    [sym_preproc_region] = STATE(2878),
    [sym_preproc_endregion] = STATE(2878),
    [sym_preproc_line] = STATE(2878),
    [sym_preproc_pragma] = STATE(2878),
    [sym_preproc_nullable] = STATE(2878),
    [sym_preproc_error] = STATE(2878),
    [sym_preproc_define] = STATE(2878),
    [sym_preproc_undef] = STATE(2878),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_return] = ACTIONS(4447),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_break] = ACTIONS(4449),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2879] = {
    [sym_preproc_region] = STATE(2879),
    [sym_preproc_endregion] = STATE(2879),
    [sym_preproc_line] = STATE(2879),
    [sym_preproc_pragma] = STATE(2879),
    [sym_preproc_nullable] = STATE(2879),
    [sym_preproc_error] = STATE(2879),
    [sym_preproc_define] = STATE(2879),
    [sym_preproc_undef] = STATE(2879),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4171),
  },
  [2880] = {
    [sym_preproc_region] = STATE(2880),
    [sym_preproc_endregion] = STATE(2880),
    [sym_preproc_line] = STATE(2880),
    [sym_preproc_pragma] = STATE(2880),
    [sym_preproc_nullable] = STATE(2880),
    [sym_preproc_error] = STATE(2880),
    [sym_preproc_define] = STATE(2880),
    [sym_preproc_undef] = STATE(2880),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4180),
    [anon_sym_descending] = ACTIONS(4180),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2881] = {
    [sym__variable_designation] = STATE(4018),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2881),
    [sym_preproc_endregion] = STATE(2881),
    [sym_preproc_line] = STATE(2881),
    [sym_preproc_pragma] = STATE(2881),
    [sym_preproc_nullable] = STATE(2881),
    [sym_preproc_error] = STATE(2881),
    [sym_preproc_define] = STATE(2881),
    [sym_preproc_undef] = STATE(2881),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4403),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_RBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_RPAREN] = ACTIONS(4403),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_in] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_if_token3] = ACTIONS(4403),
    [aux_sym_preproc_else_token1] = ACTIONS(4403),
    [aux_sym_preproc_elif_token1] = ACTIONS(4403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2882] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2882),
    [sym_preproc_endregion] = STATE(2882),
    [sym_preproc_line] = STATE(2882),
    [sym_preproc_pragma] = STATE(2882),
    [sym_preproc_nullable] = STATE(2882),
    [sym_preproc_error] = STATE(2882),
    [sym_preproc_define] = STATE(2882),
    [sym_preproc_undef] = STATE(2882),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4395),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_RBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_RPAREN] = ACTIONS(4395),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_if_token3] = ACTIONS(4395),
    [aux_sym_preproc_else_token1] = ACTIONS(4395),
    [aux_sym_preproc_elif_token1] = ACTIONS(4395),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2883] = {
    [sym_preproc_region] = STATE(2883),
    [sym_preproc_endregion] = STATE(2883),
    [sym_preproc_line] = STATE(2883),
    [sym_preproc_pragma] = STATE(2883),
    [sym_preproc_nullable] = STATE(2883),
    [sym_preproc_error] = STATE(2883),
    [sym_preproc_define] = STATE(2883),
    [sym_preproc_undef] = STATE(2883),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_operator] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_this] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2884] = {
    [sym_preproc_region] = STATE(2884),
    [sym_preproc_endregion] = STATE(2884),
    [sym_preproc_line] = STATE(2884),
    [sym_preproc_pragma] = STATE(2884),
    [sym_preproc_nullable] = STATE(2884),
    [sym_preproc_error] = STATE(2884),
    [sym_preproc_define] = STATE(2884),
    [sym_preproc_undef] = STATE(2884),
    [sym__identifier_token] = ACTIONS(4455),
    [anon_sym_alias] = ACTIONS(4455),
    [anon_sym_SEMI] = ACTIONS(4457),
    [anon_sym_global] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_RBRACK] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4457),
    [anon_sym_file] = ACTIONS(4455),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_in] = ACTIONS(4455),
    [anon_sym_where] = ACTIONS(4455),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_notnull] = ACTIONS(4455),
    [anon_sym_unmanaged] = ACTIONS(4455),
    [anon_sym_operator] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_this] = ACTIONS(4455),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_scoped] = ACTIONS(4455),
    [anon_sym_EQ_GT] = ACTIONS(4457),
    [anon_sym_var] = ACTIONS(4455),
    [anon_sym_yield] = ACTIONS(4455),
    [anon_sym_switch] = ACTIONS(4455),
    [anon_sym_when] = ACTIONS(4455),
    [sym_discard] = ACTIONS(4455),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4455),
    [anon_sym_or] = ACTIONS(4455),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_from] = ACTIONS(4455),
    [anon_sym_into] = ACTIONS(4455),
    [anon_sym_join] = ACTIONS(4455),
    [anon_sym_on] = ACTIONS(4455),
    [anon_sym_equals] = ACTIONS(4455),
    [anon_sym_let] = ACTIONS(4455),
    [anon_sym_orderby] = ACTIONS(4455),
    [anon_sym_ascending] = ACTIONS(4455),
    [anon_sym_descending] = ACTIONS(4455),
    [anon_sym_group] = ACTIONS(4455),
    [anon_sym_by] = ACTIONS(4455),
    [anon_sym_select] = ACTIONS(4455),
    [anon_sym_as] = ACTIONS(4455),
    [anon_sym_is] = ACTIONS(4455),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4455),
    [aux_sym_preproc_if_token3] = ACTIONS(4457),
    [aux_sym_preproc_else_token1] = ACTIONS(4457),
    [aux_sym_preproc_elif_token1] = ACTIONS(4457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2885] = {
    [sym_preproc_region] = STATE(2885),
    [sym_preproc_endregion] = STATE(2885),
    [sym_preproc_line] = STATE(2885),
    [sym_preproc_pragma] = STATE(2885),
    [sym_preproc_nullable] = STATE(2885),
    [sym_preproc_error] = STATE(2885),
    [sym_preproc_define] = STATE(2885),
    [sym_preproc_undef] = STATE(2885),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4180),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2886] = {
    [sym_preproc_region] = STATE(2886),
    [sym_preproc_endregion] = STATE(2886),
    [sym_preproc_line] = STATE(2886),
    [sym_preproc_pragma] = STATE(2886),
    [sym_preproc_nullable] = STATE(2886),
    [sym_preproc_error] = STATE(2886),
    [sym_preproc_define] = STATE(2886),
    [sym_preproc_undef] = STATE(2886),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4194),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4194),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4194),
    [anon_sym_orderby] = ACTIONS(4194),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4194),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4194),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2887] = {
    [sym_preproc_region] = STATE(2887),
    [sym_preproc_endregion] = STATE(2887),
    [sym_preproc_line] = STATE(2887),
    [sym_preproc_pragma] = STATE(2887),
    [sym_preproc_nullable] = STATE(2887),
    [sym_preproc_error] = STATE(2887),
    [sym_preproc_define] = STATE(2887),
    [sym_preproc_undef] = STATE(2887),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2888] = {
    [sym__name] = STATE(5294),
    [sym_alias_qualified_name] = STATE(5396),
    [sym__simple_name] = STATE(5396),
    [sym_qualified_name] = STATE(5396),
    [sym_generic_name] = STATE(5280),
    [sym_ref_type] = STATE(5299),
    [sym__scoped_base_type] = STATE(5307),
    [sym_identifier] = STATE(5110),
    [sym__reserved_identifier] = STATE(5191),
    [sym_preproc_region] = STATE(2888),
    [sym_preproc_endregion] = STATE(2888),
    [sym_preproc_line] = STATE(2888),
    [sym_preproc_pragma] = STATE(2888),
    [sym_preproc_nullable] = STATE(2888),
    [sym_preproc_error] = STATE(2888),
    [sym_preproc_define] = STATE(2888),
    [sym_preproc_undef] = STATE(2888),
    [sym__identifier_token] = ACTIONS(4459),
    [anon_sym_alias] = ACTIONS(4461),
    [anon_sym_global] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4463),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4461),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4461),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4461),
    [anon_sym_unmanaged] = ACTIONS(4461),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4461),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4461),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4461),
    [anon_sym_into] = ACTIONS(4461),
    [anon_sym_join] = ACTIONS(4461),
    [anon_sym_on] = ACTIONS(4461),
    [anon_sym_equals] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_orderby] = ACTIONS(4461),
    [anon_sym_ascending] = ACTIONS(4461),
    [anon_sym_descending] = ACTIONS(4461),
    [anon_sym_group] = ACTIONS(4461),
    [anon_sym_by] = ACTIONS(4461),
    [anon_sym_select] = ACTIONS(4461),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2889] = {
    [sym_preproc_region] = STATE(2889),
    [sym_preproc_endregion] = STATE(2889),
    [sym_preproc_line] = STATE(2889),
    [sym_preproc_pragma] = STATE(2889),
    [sym_preproc_nullable] = STATE(2889),
    [sym_preproc_error] = STATE(2889),
    [sym_preproc_define] = STATE(2889),
    [sym_preproc_undef] = STATE(2889),
    [sym__identifier_token] = ACTIONS(4465),
    [anon_sym_alias] = ACTIONS(4465),
    [anon_sym_SEMI] = ACTIONS(4467),
    [anon_sym_global] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_RBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_file] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(4465),
    [anon_sym_where] = ACTIONS(4465),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_notnull] = ACTIONS(4465),
    [anon_sym_unmanaged] = ACTIONS(4465),
    [anon_sym_operator] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_this] = ACTIONS(4465),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_scoped] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4467),
    [anon_sym_var] = ACTIONS(4465),
    [anon_sym_yield] = ACTIONS(4465),
    [anon_sym_switch] = ACTIONS(4465),
    [anon_sym_when] = ACTIONS(4465),
    [sym_discard] = ACTIONS(4465),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4465),
    [anon_sym_or] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_from] = ACTIONS(4465),
    [anon_sym_into] = ACTIONS(4465),
    [anon_sym_join] = ACTIONS(4465),
    [anon_sym_on] = ACTIONS(4465),
    [anon_sym_equals] = ACTIONS(4465),
    [anon_sym_let] = ACTIONS(4465),
    [anon_sym_orderby] = ACTIONS(4465),
    [anon_sym_ascending] = ACTIONS(4465),
    [anon_sym_descending] = ACTIONS(4465),
    [anon_sym_group] = ACTIONS(4465),
    [anon_sym_by] = ACTIONS(4465),
    [anon_sym_select] = ACTIONS(4465),
    [anon_sym_as] = ACTIONS(4465),
    [anon_sym_is] = ACTIONS(4465),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4465),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2890] = {
    [sym_preproc_region] = STATE(2890),
    [sym_preproc_endregion] = STATE(2890),
    [sym_preproc_line] = STATE(2890),
    [sym_preproc_pragma] = STATE(2890),
    [sym_preproc_nullable] = STATE(2890),
    [sym_preproc_error] = STATE(2890),
    [sym_preproc_define] = STATE(2890),
    [sym_preproc_undef] = STATE(2890),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2891] = {
    [sym_preproc_region] = STATE(2891),
    [sym_preproc_endregion] = STATE(2891),
    [sym_preproc_line] = STATE(2891),
    [sym_preproc_pragma] = STATE(2891),
    [sym_preproc_nullable] = STATE(2891),
    [sym_preproc_error] = STATE(2891),
    [sym_preproc_define] = STATE(2891),
    [sym_preproc_undef] = STATE(2891),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4180),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2892] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2892),
    [sym_preproc_endregion] = STATE(2892),
    [sym_preproc_line] = STATE(2892),
    [sym_preproc_pragma] = STATE(2892),
    [sym_preproc_nullable] = STATE(2892),
    [sym_preproc_error] = STATE(2892),
    [sym_preproc_define] = STATE(2892),
    [sym_preproc_undef] = STATE(2892),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4469),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2893] = {
    [sym_preproc_region] = STATE(2893),
    [sym_preproc_endregion] = STATE(2893),
    [sym_preproc_line] = STATE(2893),
    [sym_preproc_pragma] = STATE(2893),
    [sym_preproc_nullable] = STATE(2893),
    [sym_preproc_error] = STATE(2893),
    [sym_preproc_define] = STATE(2893),
    [sym_preproc_undef] = STATE(2893),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2894] = {
    [sym_preproc_region] = STATE(2894),
    [sym_preproc_endregion] = STATE(2894),
    [sym_preproc_line] = STATE(2894),
    [sym_preproc_pragma] = STATE(2894),
    [sym_preproc_nullable] = STATE(2894),
    [sym_preproc_error] = STATE(2894),
    [sym_preproc_define] = STATE(2894),
    [sym_preproc_undef] = STATE(2894),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4180),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2895] = {
    [sym_preproc_region] = STATE(2895),
    [sym_preproc_endregion] = STATE(2895),
    [sym_preproc_line] = STATE(2895),
    [sym_preproc_pragma] = STATE(2895),
    [sym_preproc_nullable] = STATE(2895),
    [sym_preproc_error] = STATE(2895),
    [sym_preproc_define] = STATE(2895),
    [sym_preproc_undef] = STATE(2895),
    [sym__identifier_token] = ACTIONS(4471),
    [anon_sym_alias] = ACTIONS(4471),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_global] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_RBRACK] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_file] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_in] = ACTIONS(4471),
    [anon_sym_where] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_notnull] = ACTIONS(4471),
    [anon_sym_unmanaged] = ACTIONS(4471),
    [anon_sym_operator] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_this] = ACTIONS(4471),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_scoped] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4473),
    [anon_sym_var] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4471),
    [anon_sym_switch] = ACTIONS(4471),
    [anon_sym_when] = ACTIONS(4471),
    [sym_discard] = ACTIONS(4471),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4471),
    [anon_sym_or] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_from] = ACTIONS(4471),
    [anon_sym_into] = ACTIONS(4471),
    [anon_sym_join] = ACTIONS(4471),
    [anon_sym_on] = ACTIONS(4471),
    [anon_sym_equals] = ACTIONS(4471),
    [anon_sym_let] = ACTIONS(4471),
    [anon_sym_orderby] = ACTIONS(4471),
    [anon_sym_ascending] = ACTIONS(4471),
    [anon_sym_descending] = ACTIONS(4471),
    [anon_sym_group] = ACTIONS(4471),
    [anon_sym_by] = ACTIONS(4471),
    [anon_sym_select] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4471),
    [anon_sym_is] = ACTIONS(4471),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4471),
    [aux_sym_preproc_if_token3] = ACTIONS(4473),
    [aux_sym_preproc_else_token1] = ACTIONS(4473),
    [aux_sym_preproc_elif_token1] = ACTIONS(4473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2896] = {
    [sym_preproc_region] = STATE(2896),
    [sym_preproc_endregion] = STATE(2896),
    [sym_preproc_line] = STATE(2896),
    [sym_preproc_pragma] = STATE(2896),
    [sym_preproc_nullable] = STATE(2896),
    [sym_preproc_error] = STATE(2896),
    [sym_preproc_define] = STATE(2896),
    [sym_preproc_undef] = STATE(2896),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4194),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2897] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2897),
    [sym_preproc_endregion] = STATE(2897),
    [sym_preproc_line] = STATE(2897),
    [sym_preproc_pragma] = STATE(2897),
    [sym_preproc_nullable] = STATE(2897),
    [sym_preproc_error] = STATE(2897),
    [sym_preproc_define] = STATE(2897),
    [sym_preproc_undef] = STATE(2897),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4403),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_RBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_RPAREN] = ACTIONS(4403),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_if_token3] = ACTIONS(4403),
    [aux_sym_preproc_else_token1] = ACTIONS(4403),
    [aux_sym_preproc_elif_token1] = ACTIONS(4403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2898] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2898),
    [sym_preproc_endregion] = STATE(2898),
    [sym_preproc_line] = STATE(2898),
    [sym_preproc_pragma] = STATE(2898),
    [sym_preproc_nullable] = STATE(2898),
    [sym_preproc_error] = STATE(2898),
    [sym_preproc_define] = STATE(2898),
    [sym_preproc_undef] = STATE(2898),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4443),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_RBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_RPAREN] = ACTIONS(4443),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4443),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_if_token3] = ACTIONS(4443),
    [aux_sym_preproc_else_token1] = ACTIONS(4443),
    [aux_sym_preproc_elif_token1] = ACTIONS(4443),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2899] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(2899),
    [sym_preproc_endregion] = STATE(2899),
    [sym_preproc_line] = STATE(2899),
    [sym_preproc_pragma] = STATE(2899),
    [sym_preproc_nullable] = STATE(2899),
    [sym_preproc_error] = STATE(2899),
    [sym_preproc_define] = STATE(2899),
    [sym_preproc_undef] = STATE(2899),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_SEMI] = ACTIONS(4433),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_RBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_RPAREN] = ACTIONS(4433),
    [anon_sym_RBRACE] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4433),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_if_token3] = ACTIONS(4433),
    [aux_sym_preproc_else_token1] = ACTIONS(4433),
    [aux_sym_preproc_elif_token1] = ACTIONS(4433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2900] = {
    [sym__name] = STATE(5294),
    [sym_alias_qualified_name] = STATE(5396),
    [sym__simple_name] = STATE(5396),
    [sym_qualified_name] = STATE(5396),
    [sym_generic_name] = STATE(5280),
    [sym_ref_type] = STATE(5299),
    [sym__scoped_base_type] = STATE(5307),
    [sym_identifier] = STATE(5110),
    [sym__reserved_identifier] = STATE(5191),
    [sym_preproc_region] = STATE(2900),
    [sym_preproc_endregion] = STATE(2900),
    [sym_preproc_line] = STATE(2900),
    [sym_preproc_pragma] = STATE(2900),
    [sym_preproc_nullable] = STATE(2900),
    [sym_preproc_error] = STATE(2900),
    [sym_preproc_define] = STATE(2900),
    [sym_preproc_undef] = STATE(2900),
    [sym__identifier_token] = ACTIONS(4459),
    [anon_sym_alias] = ACTIONS(4461),
    [anon_sym_global] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4475),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4461),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4461),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4461),
    [anon_sym_unmanaged] = ACTIONS(4461),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4461),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4461),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4461),
    [anon_sym_into] = ACTIONS(4477),
    [anon_sym_join] = ACTIONS(4461),
    [anon_sym_on] = ACTIONS(4461),
    [anon_sym_equals] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_orderby] = ACTIONS(4461),
    [anon_sym_ascending] = ACTIONS(4461),
    [anon_sym_descending] = ACTIONS(4461),
    [anon_sym_group] = ACTIONS(4461),
    [anon_sym_by] = ACTIONS(4461),
    [anon_sym_select] = ACTIONS(4461),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [2901] = {
    [sym_preproc_region] = STATE(2901),
    [sym_preproc_endregion] = STATE(2901),
    [sym_preproc_line] = STATE(2901),
    [sym_preproc_pragma] = STATE(2901),
    [sym_preproc_nullable] = STATE(2901),
    [sym_preproc_error] = STATE(2901),
    [sym_preproc_define] = STATE(2901),
    [sym_preproc_undef] = STATE(2901),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2902] = {
    [sym_preproc_region] = STATE(2902),
    [sym_preproc_endregion] = STATE(2902),
    [sym_preproc_line] = STATE(2902),
    [sym_preproc_pragma] = STATE(2902),
    [sym_preproc_nullable] = STATE(2902),
    [sym_preproc_error] = STATE(2902),
    [sym_preproc_define] = STATE(2902),
    [sym_preproc_undef] = STATE(2902),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2903] = {
    [sym_preproc_region] = STATE(2903),
    [sym_preproc_endregion] = STATE(2903),
    [sym_preproc_line] = STATE(2903),
    [sym_preproc_pragma] = STATE(2903),
    [sym_preproc_nullable] = STATE(2903),
    [sym_preproc_error] = STATE(2903),
    [sym_preproc_define] = STATE(2903),
    [sym_preproc_undef] = STATE(2903),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4194),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2904] = {
    [sym_preproc_region] = STATE(2904),
    [sym_preproc_endregion] = STATE(2904),
    [sym_preproc_line] = STATE(2904),
    [sym_preproc_pragma] = STATE(2904),
    [sym_preproc_nullable] = STATE(2904),
    [sym_preproc_error] = STATE(2904),
    [sym_preproc_define] = STATE(2904),
    [sym_preproc_undef] = STATE(2904),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2905] = {
    [sym_preproc_region] = STATE(2905),
    [sym_preproc_endregion] = STATE(2905),
    [sym_preproc_line] = STATE(2905),
    [sym_preproc_pragma] = STATE(2905),
    [sym_preproc_nullable] = STATE(2905),
    [sym_preproc_error] = STATE(2905),
    [sym_preproc_define] = STATE(2905),
    [sym_preproc_undef] = STATE(2905),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2906] = {
    [sym_preproc_region] = STATE(2906),
    [sym_preproc_endregion] = STATE(2906),
    [sym_preproc_line] = STATE(2906),
    [sym_preproc_pragma] = STATE(2906),
    [sym_preproc_nullable] = STATE(2906),
    [sym_preproc_error] = STATE(2906),
    [sym_preproc_define] = STATE(2906),
    [sym_preproc_undef] = STATE(2906),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_file] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_operator] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_this] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_scoped] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_var] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [sym_discard] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2907] = {
    [sym_preproc_region] = STATE(2907),
    [sym_preproc_endregion] = STATE(2907),
    [sym_preproc_line] = STATE(2907),
    [sym_preproc_pragma] = STATE(2907),
    [sym_preproc_nullable] = STATE(2907),
    [sym_preproc_error] = STATE(2907),
    [sym_preproc_define] = STATE(2907),
    [sym_preproc_undef] = STATE(2907),
    [sym__identifier_token] = ACTIONS(4484),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_RBRACK] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_in] = ACTIONS(4484),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_operator] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_this] = ACTIONS(4484),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_EQ_GT] = ACTIONS(4486),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4484),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4484),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4484),
    [anon_sym_or] = ACTIONS(4484),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4484),
    [anon_sym_is] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4484),
    [aux_sym_preproc_if_token3] = ACTIONS(4486),
    [aux_sym_preproc_else_token1] = ACTIONS(4486),
    [aux_sym_preproc_elif_token1] = ACTIONS(4486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2908] = {
    [sym_preproc_region] = STATE(2908),
    [sym_preproc_endregion] = STATE(2908),
    [sym_preproc_line] = STATE(2908),
    [sym_preproc_pragma] = STATE(2908),
    [sym_preproc_nullable] = STATE(2908),
    [sym_preproc_error] = STATE(2908),
    [sym_preproc_define] = STATE(2908),
    [sym_preproc_undef] = STATE(2908),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4194),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4194),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4194),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4194),
    [anon_sym_orderby] = ACTIONS(4194),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4194),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4194),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2909] = {
    [sym_preproc_region] = STATE(2909),
    [sym_preproc_endregion] = STATE(2909),
    [sym_preproc_line] = STATE(2909),
    [sym_preproc_pragma] = STATE(2909),
    [sym_preproc_nullable] = STATE(2909),
    [sym_preproc_error] = STATE(2909),
    [sym_preproc_define] = STATE(2909),
    [sym_preproc_undef] = STATE(2909),
    [sym__identifier_token] = ACTIONS(4488),
    [anon_sym_alias] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_global] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_RBRACK] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_file] = ACTIONS(4488),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_where] = ACTIONS(4488),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_notnull] = ACTIONS(4488),
    [anon_sym_unmanaged] = ACTIONS(4488),
    [anon_sym_operator] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_this] = ACTIONS(4488),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_scoped] = ACTIONS(4488),
    [anon_sym_EQ_GT] = ACTIONS(4490),
    [anon_sym_var] = ACTIONS(4488),
    [anon_sym_yield] = ACTIONS(4488),
    [anon_sym_switch] = ACTIONS(4488),
    [anon_sym_when] = ACTIONS(4488),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4488),
    [anon_sym_or] = ACTIONS(4488),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_from] = ACTIONS(4488),
    [anon_sym_into] = ACTIONS(4488),
    [anon_sym_join] = ACTIONS(4488),
    [anon_sym_on] = ACTIONS(4488),
    [anon_sym_equals] = ACTIONS(4488),
    [anon_sym_let] = ACTIONS(4488),
    [anon_sym_orderby] = ACTIONS(4488),
    [anon_sym_ascending] = ACTIONS(4488),
    [anon_sym_descending] = ACTIONS(4488),
    [anon_sym_group] = ACTIONS(4488),
    [anon_sym_by] = ACTIONS(4488),
    [anon_sym_select] = ACTIONS(4488),
    [anon_sym_as] = ACTIONS(4488),
    [anon_sym_is] = ACTIONS(4488),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4488),
    [aux_sym_preproc_if_token3] = ACTIONS(4490),
    [aux_sym_preproc_else_token1] = ACTIONS(4490),
    [aux_sym_preproc_elif_token1] = ACTIONS(4490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2910] = {
    [sym_preproc_region] = STATE(2910),
    [sym_preproc_endregion] = STATE(2910),
    [sym_preproc_line] = STATE(2910),
    [sym_preproc_pragma] = STATE(2910),
    [sym_preproc_nullable] = STATE(2910),
    [sym_preproc_error] = STATE(2910),
    [sym_preproc_define] = STATE(2910),
    [sym_preproc_undef] = STATE(2910),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4194),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2911] = {
    [sym_preproc_region] = STATE(2911),
    [sym_preproc_endregion] = STATE(2911),
    [sym_preproc_line] = STATE(2911),
    [sym_preproc_pragma] = STATE(2911),
    [sym_preproc_nullable] = STATE(2911),
    [sym_preproc_error] = STATE(2911),
    [sym_preproc_define] = STATE(2911),
    [sym_preproc_undef] = STATE(2911),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4194),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2912] = {
    [sym_preproc_region] = STATE(2912),
    [sym_preproc_endregion] = STATE(2912),
    [sym_preproc_line] = STATE(2912),
    [sym_preproc_pragma] = STATE(2912),
    [sym_preproc_nullable] = STATE(2912),
    [sym_preproc_error] = STATE(2912),
    [sym_preproc_define] = STATE(2912),
    [sym_preproc_undef] = STATE(2912),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2913] = {
    [sym_type_argument_list] = STATE(2752),
    [sym_preproc_region] = STATE(2913),
    [sym_preproc_endregion] = STATE(2913),
    [sym_preproc_line] = STATE(2913),
    [sym_preproc_pragma] = STATE(2913),
    [sym_preproc_nullable] = STATE(2913),
    [sym_preproc_error] = STATE(2913),
    [sym_preproc_define] = STATE(2913),
    [sym_preproc_undef] = STATE(2913),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4146),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_COLON_COLON] = ACTIONS(4151),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2914] = {
    [sym_preproc_region] = STATE(2914),
    [sym_preproc_endregion] = STATE(2914),
    [sym_preproc_line] = STATE(2914),
    [sym_preproc_pragma] = STATE(2914),
    [sym_preproc_nullable] = STATE(2914),
    [sym_preproc_error] = STATE(2914),
    [sym_preproc_define] = STATE(2914),
    [sym_preproc_undef] = STATE(2914),
    [sym__identifier_token] = ACTIONS(4494),
    [anon_sym_alias] = ACTIONS(4494),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4494),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_RBRACK] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_file] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_notnull] = ACTIONS(4494),
    [anon_sym_unmanaged] = ACTIONS(4494),
    [anon_sym_operator] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_this] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_scoped] = ACTIONS(4494),
    [anon_sym_EQ_GT] = ACTIONS(4496),
    [anon_sym_var] = ACTIONS(4494),
    [anon_sym_yield] = ACTIONS(4494),
    [anon_sym_switch] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [sym_discard] = ACTIONS(4494),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4494),
    [anon_sym_or] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_from] = ACTIONS(4494),
    [anon_sym_into] = ACTIONS(4494),
    [anon_sym_join] = ACTIONS(4494),
    [anon_sym_on] = ACTIONS(4494),
    [anon_sym_equals] = ACTIONS(4494),
    [anon_sym_let] = ACTIONS(4494),
    [anon_sym_orderby] = ACTIONS(4494),
    [anon_sym_ascending] = ACTIONS(4494),
    [anon_sym_descending] = ACTIONS(4494),
    [anon_sym_group] = ACTIONS(4494),
    [anon_sym_by] = ACTIONS(4494),
    [anon_sym_select] = ACTIONS(4494),
    [anon_sym_as] = ACTIONS(4494),
    [anon_sym_is] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4494),
    [aux_sym_preproc_if_token3] = ACTIONS(4496),
    [aux_sym_preproc_else_token1] = ACTIONS(4496),
    [aux_sym_preproc_elif_token1] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2915] = {
    [sym_preproc_region] = STATE(2915),
    [sym_preproc_endregion] = STATE(2915),
    [sym_preproc_line] = STATE(2915),
    [sym_preproc_pragma] = STATE(2915),
    [sym_preproc_nullable] = STATE(2915),
    [sym_preproc_error] = STATE(2915),
    [sym_preproc_define] = STATE(2915),
    [sym_preproc_undef] = STATE(2915),
    [sym__identifier_token] = ACTIONS(4498),
    [anon_sym_alias] = ACTIONS(4498),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_global] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_RBRACK] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_file] = ACTIONS(4498),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_in] = ACTIONS(4498),
    [anon_sym_where] = ACTIONS(4498),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_notnull] = ACTIONS(4498),
    [anon_sym_unmanaged] = ACTIONS(4498),
    [anon_sym_operator] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_this] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_scoped] = ACTIONS(4498),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4498),
    [anon_sym_yield] = ACTIONS(4498),
    [anon_sym_switch] = ACTIONS(4498),
    [anon_sym_when] = ACTIONS(4498),
    [sym_discard] = ACTIONS(4498),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4498),
    [anon_sym_or] = ACTIONS(4498),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_from] = ACTIONS(4498),
    [anon_sym_into] = ACTIONS(4498),
    [anon_sym_join] = ACTIONS(4498),
    [anon_sym_on] = ACTIONS(4498),
    [anon_sym_equals] = ACTIONS(4498),
    [anon_sym_let] = ACTIONS(4498),
    [anon_sym_orderby] = ACTIONS(4498),
    [anon_sym_ascending] = ACTIONS(4498),
    [anon_sym_descending] = ACTIONS(4498),
    [anon_sym_group] = ACTIONS(4498),
    [anon_sym_by] = ACTIONS(4498),
    [anon_sym_select] = ACTIONS(4498),
    [anon_sym_as] = ACTIONS(4498),
    [anon_sym_is] = ACTIONS(4498),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4498),
    [aux_sym_preproc_if_token3] = ACTIONS(4500),
    [aux_sym_preproc_else_token1] = ACTIONS(4500),
    [aux_sym_preproc_elif_token1] = ACTIONS(4500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2916] = {
    [sym_preproc_region] = STATE(2916),
    [sym_preproc_endregion] = STATE(2916),
    [sym_preproc_line] = STATE(2916),
    [sym_preproc_pragma] = STATE(2916),
    [sym_preproc_nullable] = STATE(2916),
    [sym_preproc_error] = STATE(2916),
    [sym_preproc_define] = STATE(2916),
    [sym_preproc_undef] = STATE(2916),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4194),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2917] = {
    [sym_preproc_region] = STATE(2917),
    [sym_preproc_endregion] = STATE(2917),
    [sym_preproc_line] = STATE(2917),
    [sym_preproc_pragma] = STATE(2917),
    [sym_preproc_nullable] = STATE(2917),
    [sym_preproc_error] = STATE(2917),
    [sym_preproc_define] = STATE(2917),
    [sym_preproc_undef] = STATE(2917),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_using] = ACTIONS(4502),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2918] = {
    [sym_preproc_region] = STATE(2918),
    [sym_preproc_endregion] = STATE(2918),
    [sym_preproc_line] = STATE(2918),
    [sym_preproc_pragma] = STATE(2918),
    [sym_preproc_nullable] = STATE(2918),
    [sym_preproc_error] = STATE(2918),
    [sym_preproc_define] = STATE(2918),
    [sym_preproc_undef] = STATE(2918),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4190),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(4190),
    [anon_sym_PERCENT] = ACTIONS(4190),
    [anon_sym_CARET] = ACTIONS(4190),
    [anon_sym_PIPE] = ACTIONS(4190),
    [anon_sym_AMP] = ACTIONS(4190),
    [anon_sym_LT_LT] = ACTIONS(4190),
    [anon_sym_GT_GT] = ACTIONS(4190),
    [anon_sym_GT_GT_GT] = ACTIONS(4190),
    [anon_sym_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_DOT] = ACTIONS(4190),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4190),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4186),
    [anon_sym_and] = ACTIONS(4194),
    [anon_sym_or] = ACTIONS(4194),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_QMARK_QMARK] = ACTIONS(4190),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4194),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4194),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4190),
    [anon_sym_is] = ACTIONS(4190),
    [anon_sym_DASH_GT] = ACTIONS(4186),
    [anon_sym_with] = ACTIONS(4190),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2919] = {
    [sym_preproc_region] = STATE(2919),
    [sym_preproc_endregion] = STATE(2919),
    [sym_preproc_line] = STATE(2919),
    [sym_preproc_pragma] = STATE(2919),
    [sym_preproc_nullable] = STATE(2919),
    [sym_preproc_error] = STATE(2919),
    [sym_preproc_define] = STATE(2919),
    [sym_preproc_undef] = STATE(2919),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4180),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_LT_LT] = ACTIONS(4180),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4180),
    [anon_sym_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4175),
    [anon_sym_and] = ACTIONS(4180),
    [anon_sym_or] = ACTIONS(4180),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_QMARK_QMARK] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4180),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4180),
    [anon_sym_is] = ACTIONS(4180),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4180),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2920] = {
    [sym_type_argument_list] = STATE(2957),
    [sym_preproc_region] = STATE(2920),
    [sym_preproc_endregion] = STATE(2920),
    [sym_preproc_line] = STATE(2920),
    [sym_preproc_pragma] = STATE(2920),
    [sym_preproc_nullable] = STATE(2920),
    [sym_preproc_error] = STATE(2920),
    [sym_preproc_define] = STATE(2920),
    [sym_preproc_undef] = STATE(2920),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4504),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2921] = {
    [sym__name] = STATE(4163),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2921),
    [sym_preproc_endregion] = STATE(2921),
    [sym_preproc_line] = STATE(2921),
    [sym_preproc_pragma] = STATE(2921),
    [sym_preproc_nullable] = STATE(2921),
    [sym_preproc_error] = STATE(2921),
    [sym_preproc_define] = STATE(2921),
    [sym_preproc_undef] = STATE(2921),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4509),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2922] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7111),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2922),
    [sym_preproc_endregion] = STATE(2922),
    [sym_preproc_line] = STATE(2922),
    [sym_preproc_pragma] = STATE(2922),
    [sym_preproc_nullable] = STATE(2922),
    [sym_preproc_error] = STATE(2922),
    [sym_preproc_define] = STATE(2922),
    [sym_preproc_undef] = STATE(2922),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [aux_sym_class_declaration_repeat2] = STATE(3128),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2923] = {
    [sym_modifier] = STATE(3802),
    [sym_variable_declaration] = STATE(9564),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6998),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2923),
    [sym_preproc_endregion] = STATE(2923),
    [sym_preproc_line] = STATE(2923),
    [sym_preproc_pragma] = STATE(2923),
    [sym_preproc_nullable] = STATE(2923),
    [sym_preproc_error] = STATE(2923),
    [sym_preproc_define] = STATE(2923),
    [sym_preproc_undef] = STATE(2923),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_ref] = ACTIONS(4363),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(4365),
    [anon_sym_interface] = ACTIONS(4367),
    [anon_sym_delegate] = ACTIONS(4369),
    [anon_sym_record] = ACTIONS(4371),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2924] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7001),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2924),
    [sym_preproc_endregion] = STATE(2924),
    [sym_preproc_line] = STATE(2924),
    [sym_preproc_pragma] = STATE(2924),
    [sym_preproc_nullable] = STATE(2924),
    [sym_preproc_error] = STATE(2924),
    [sym_preproc_define] = STATE(2924),
    [sym_preproc_undef] = STATE(2924),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [aux_sym_class_declaration_repeat2] = STATE(3125),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2925] = {
    [sym_preproc_region] = STATE(2925),
    [sym_preproc_endregion] = STATE(2925),
    [sym_preproc_line] = STATE(2925),
    [sym_preproc_pragma] = STATE(2925),
    [sym_preproc_nullable] = STATE(2925),
    [sym_preproc_error] = STATE(2925),
    [sym_preproc_define] = STATE(2925),
    [sym_preproc_undef] = STATE(2925),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2926] = {
    [sym_preproc_region] = STATE(2926),
    [sym_preproc_endregion] = STATE(2926),
    [sym_preproc_line] = STATE(2926),
    [sym_preproc_pragma] = STATE(2926),
    [sym_preproc_nullable] = STATE(2926),
    [sym_preproc_error] = STATE(2926),
    [sym_preproc_define] = STATE(2926),
    [sym_preproc_undef] = STATE(2926),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2927] = {
    [sym_preproc_region] = STATE(2927),
    [sym_preproc_endregion] = STATE(2927),
    [sym_preproc_line] = STATE(2927),
    [sym_preproc_pragma] = STATE(2927),
    [sym_preproc_nullable] = STATE(2927),
    [sym_preproc_error] = STATE(2927),
    [sym_preproc_define] = STATE(2927),
    [sym_preproc_undef] = STATE(2927),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2928] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(2928),
    [sym_preproc_endregion] = STATE(2928),
    [sym_preproc_line] = STATE(2928),
    [sym_preproc_pragma] = STATE(2928),
    [sym_preproc_nullable] = STATE(2928),
    [sym_preproc_error] = STATE(2928),
    [sym_preproc_define] = STATE(2928),
    [sym_preproc_undef] = STATE(2928),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(4524),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2929] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6967),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2929),
    [sym_preproc_endregion] = STATE(2929),
    [sym_preproc_line] = STATE(2929),
    [sym_preproc_pragma] = STATE(2929),
    [sym_preproc_nullable] = STATE(2929),
    [sym_preproc_error] = STATE(2929),
    [sym_preproc_define] = STATE(2929),
    [sym_preproc_undef] = STATE(2929),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [aux_sym_class_declaration_repeat2] = STATE(3122),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2930] = {
    [sym_preproc_region] = STATE(2930),
    [sym_preproc_endregion] = STATE(2930),
    [sym_preproc_line] = STATE(2930),
    [sym_preproc_pragma] = STATE(2930),
    [sym_preproc_nullable] = STATE(2930),
    [sym_preproc_error] = STATE(2930),
    [sym_preproc_define] = STATE(2930),
    [sym_preproc_undef] = STATE(2930),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4164),
    [anon_sym_descending] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2931] = {
    [sym_preproc_region] = STATE(2931),
    [sym_preproc_endregion] = STATE(2931),
    [sym_preproc_line] = STATE(2931),
    [sym_preproc_pragma] = STATE(2931),
    [sym_preproc_nullable] = STATE(2931),
    [sym_preproc_error] = STATE(2931),
    [sym_preproc_define] = STATE(2931),
    [sym_preproc_undef] = STATE(2931),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4180),
    [anon_sym_descending] = ACTIONS(4180),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2932] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7043),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9741),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2932),
    [sym_preproc_endregion] = STATE(2932),
    [sym_preproc_line] = STATE(2932),
    [sym_preproc_pragma] = STATE(2932),
    [sym_preproc_nullable] = STATE(2932),
    [sym_preproc_error] = STATE(2932),
    [sym_preproc_define] = STATE(2932),
    [sym_preproc_undef] = STATE(2932),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [aux_sym_class_declaration_repeat2] = STATE(3125),
    [aux_sym_lambda_expression_repeat1] = STATE(4215),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2933] = {
    [sym_preproc_region] = STATE(2933),
    [sym_preproc_endregion] = STATE(2933),
    [sym_preproc_line] = STATE(2933),
    [sym_preproc_pragma] = STATE(2933),
    [sym_preproc_nullable] = STATE(2933),
    [sym_preproc_error] = STATE(2933),
    [sym_preproc_define] = STATE(2933),
    [sym_preproc_undef] = STATE(2933),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4180),
    [anon_sym_descending] = ACTIONS(4180),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2934] = {
    [sym__name] = STATE(3922),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_ref_type] = STATE(3918),
    [sym__scoped_base_type] = STATE(3879),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(2934),
    [sym_preproc_endregion] = STATE(2934),
    [sym_preproc_line] = STATE(2934),
    [sym_preproc_pragma] = STATE(2934),
    [sym_preproc_nullable] = STATE(2934),
    [sym_preproc_error] = STATE(2934),
    [sym_preproc_define] = STATE(2934),
    [sym_preproc_undef] = STATE(2934),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4223),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4227),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2935] = {
    [sym_attribute_list] = STATE(4530),
    [sym_modifier] = STATE(4685),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6962),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2935),
    [sym_preproc_endregion] = STATE(2935),
    [sym_preproc_line] = STATE(2935),
    [sym_preproc_pragma] = STATE(2935),
    [sym_preproc_nullable] = STATE(2935),
    [sym_preproc_error] = STATE(2935),
    [sym_preproc_define] = STATE(2935),
    [sym_preproc_undef] = STATE(2935),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [aux_sym_class_declaration_repeat2] = STATE(3124),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2936] = {
    [sym_modifier] = STATE(3802),
    [sym_variable_declaration] = STATE(9853),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6974),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2936),
    [sym_preproc_endregion] = STATE(2936),
    [sym_preproc_line] = STATE(2936),
    [sym_preproc_pragma] = STATE(2936),
    [sym_preproc_nullable] = STATE(2936),
    [sym_preproc_error] = STATE(2936),
    [sym_preproc_define] = STATE(2936),
    [sym_preproc_undef] = STATE(2936),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(4379),
    [anon_sym_ref] = ACTIONS(4381),
    [anon_sym_struct] = ACTIONS(2729),
    [anon_sym_enum] = ACTIONS(4383),
    [anon_sym_interface] = ACTIONS(4385),
    [anon_sym_delegate] = ACTIONS(4387),
    [anon_sym_record] = ACTIONS(4389),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(3147),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2937] = {
    [sym__name] = STATE(5995),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(5363),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(2937),
    [sym_preproc_endregion] = STATE(2937),
    [sym_preproc_line] = STATE(2937),
    [sym_preproc_pragma] = STATE(2937),
    [sym_preproc_nullable] = STATE(2937),
    [sym_preproc_error] = STATE(2937),
    [sym_preproc_define] = STATE(2937),
    [sym_preproc_undef] = STATE(2937),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2938] = {
    [sym_type_argument_list] = STATE(2957),
    [sym_preproc_region] = STATE(2938),
    [sym_preproc_endregion] = STATE(2938),
    [sym_preproc_line] = STATE(2938),
    [sym_preproc_pragma] = STATE(2938),
    [sym_preproc_nullable] = STATE(2938),
    [sym_preproc_error] = STATE(2938),
    [sym_preproc_define] = STATE(2938),
    [sym_preproc_undef] = STATE(2938),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4504),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(4153),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2939] = {
    [sym_preproc_region] = STATE(2939),
    [sym_preproc_endregion] = STATE(2939),
    [sym_preproc_line] = STATE(2939),
    [sym_preproc_pragma] = STATE(2939),
    [sym_preproc_nullable] = STATE(2939),
    [sym_preproc_error] = STATE(2939),
    [sym_preproc_define] = STATE(2939),
    [sym_preproc_undef] = STATE(2939),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4164),
    [anon_sym_descending] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2940] = {
    [sym_preproc_region] = STATE(2940),
    [sym_preproc_endregion] = STATE(2940),
    [sym_preproc_line] = STATE(2940),
    [sym_preproc_pragma] = STATE(2940),
    [sym_preproc_nullable] = STATE(2940),
    [sym_preproc_error] = STATE(2940),
    [sym_preproc_define] = STATE(2940),
    [sym_preproc_undef] = STATE(2940),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4180),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2941] = {
    [sym_preproc_region] = STATE(2941),
    [sym_preproc_endregion] = STATE(2941),
    [sym_preproc_line] = STATE(2941),
    [sym_preproc_pragma] = STATE(2941),
    [sym_preproc_nullable] = STATE(2941),
    [sym_preproc_error] = STATE(2941),
    [sym_preproc_define] = STATE(2941),
    [sym_preproc_undef] = STATE(2941),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2942] = {
    [sym_preproc_region] = STATE(2942),
    [sym_preproc_endregion] = STATE(2942),
    [sym_preproc_line] = STATE(2942),
    [sym_preproc_pragma] = STATE(2942),
    [sym_preproc_nullable] = STATE(2942),
    [sym_preproc_error] = STATE(2942),
    [sym_preproc_define] = STATE(2942),
    [sym_preproc_undef] = STATE(2942),
    [sym__identifier_token] = ACTIONS(4534),
    [anon_sym_alias] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_global] = ACTIONS(4534),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_file] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_where] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_notnull] = ACTIONS(4534),
    [anon_sym_unmanaged] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_scoped] = ACTIONS(4534),
    [anon_sym_EQ_GT] = ACTIONS(4536),
    [anon_sym_var] = ACTIONS(4534),
    [anon_sym_yield] = ACTIONS(4534),
    [anon_sym_switch] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [sym_discard] = ACTIONS(4534),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_from] = ACTIONS(4534),
    [anon_sym_into] = ACTIONS(4534),
    [anon_sym_join] = ACTIONS(4534),
    [anon_sym_on] = ACTIONS(4534),
    [anon_sym_equals] = ACTIONS(4534),
    [anon_sym_let] = ACTIONS(4534),
    [anon_sym_orderby] = ACTIONS(4534),
    [anon_sym_ascending] = ACTIONS(4534),
    [anon_sym_descending] = ACTIONS(4534),
    [anon_sym_group] = ACTIONS(4534),
    [anon_sym_by] = ACTIONS(4534),
    [anon_sym_select] = ACTIONS(4534),
    [anon_sym_as] = ACTIONS(4534),
    [anon_sym_is] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4534),
    [aux_sym_preproc_if_token3] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2943] = {
    [sym_preproc_region] = STATE(2943),
    [sym_preproc_endregion] = STATE(2943),
    [sym_preproc_line] = STATE(2943),
    [sym_preproc_pragma] = STATE(2943),
    [sym_preproc_nullable] = STATE(2943),
    [sym_preproc_error] = STATE(2943),
    [sym_preproc_define] = STATE(2943),
    [sym_preproc_undef] = STATE(2943),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2944] = {
    [sym_preproc_region] = STATE(2944),
    [sym_preproc_endregion] = STATE(2944),
    [sym_preproc_line] = STATE(2944),
    [sym_preproc_pragma] = STATE(2944),
    [sym_preproc_nullable] = STATE(2944),
    [sym_preproc_error] = STATE(2944),
    [sym_preproc_define] = STATE(2944),
    [sym_preproc_undef] = STATE(2944),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2945] = {
    [sym_preproc_region] = STATE(2945),
    [sym_preproc_endregion] = STATE(2945),
    [sym_preproc_line] = STATE(2945),
    [sym_preproc_pragma] = STATE(2945),
    [sym_preproc_nullable] = STATE(2945),
    [sym_preproc_error] = STATE(2945),
    [sym_preproc_define] = STATE(2945),
    [sym_preproc_undef] = STATE(2945),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2946] = {
    [sym_preproc_region] = STATE(2946),
    [sym_preproc_endregion] = STATE(2946),
    [sym_preproc_line] = STATE(2946),
    [sym_preproc_pragma] = STATE(2946),
    [sym_preproc_nullable] = STATE(2946),
    [sym_preproc_error] = STATE(2946),
    [sym_preproc_define] = STATE(2946),
    [sym_preproc_undef] = STATE(2946),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2947] = {
    [sym_preproc_region] = STATE(2947),
    [sym_preproc_endregion] = STATE(2947),
    [sym_preproc_line] = STATE(2947),
    [sym_preproc_pragma] = STATE(2947),
    [sym_preproc_nullable] = STATE(2947),
    [sym_preproc_error] = STATE(2947),
    [sym_preproc_define] = STATE(2947),
    [sym_preproc_undef] = STATE(2947),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2948] = {
    [sym_preproc_region] = STATE(2948),
    [sym_preproc_endregion] = STATE(2948),
    [sym_preproc_line] = STATE(2948),
    [sym_preproc_pragma] = STATE(2948),
    [sym_preproc_nullable] = STATE(2948),
    [sym_preproc_error] = STATE(2948),
    [sym_preproc_define] = STATE(2948),
    [sym_preproc_undef] = STATE(2948),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4155),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4155),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4155),
    [anon_sym_is] = ACTIONS(4155),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4155),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2949] = {
    [sym_preproc_region] = STATE(2949),
    [sym_preproc_endregion] = STATE(2949),
    [sym_preproc_line] = STATE(2949),
    [sym_preproc_pragma] = STATE(2949),
    [sym_preproc_nullable] = STATE(2949),
    [sym_preproc_error] = STATE(2949),
    [sym_preproc_define] = STATE(2949),
    [sym_preproc_undef] = STATE(2949),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4180),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2950] = {
    [sym_preproc_region] = STATE(2950),
    [sym_preproc_endregion] = STATE(2950),
    [sym_preproc_line] = STATE(2950),
    [sym_preproc_pragma] = STATE(2950),
    [sym_preproc_nullable] = STATE(2950),
    [sym_preproc_error] = STATE(2950),
    [sym_preproc_define] = STATE(2950),
    [sym_preproc_undef] = STATE(2950),
    [sym__identifier_token] = ACTIONS(4429),
    [anon_sym_alias] = ACTIONS(4429),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_global] = ACTIONS(4429),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_file] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4429),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_notnull] = ACTIONS(4429),
    [anon_sym_unmanaged] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_scoped] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_var] = ACTIONS(4429),
    [anon_sym_yield] = ACTIONS(4429),
    [anon_sym_switch] = ACTIONS(4429),
    [anon_sym_when] = ACTIONS(4429),
    [sym_discard] = ACTIONS(4429),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4429),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4429),
    [anon_sym_into] = ACTIONS(4429),
    [anon_sym_join] = ACTIONS(4429),
    [anon_sym_on] = ACTIONS(4429),
    [anon_sym_equals] = ACTIONS(4429),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_orderby] = ACTIONS(4429),
    [anon_sym_ascending] = ACTIONS(4429),
    [anon_sym_descending] = ACTIONS(4429),
    [anon_sym_group] = ACTIONS(4429),
    [anon_sym_by] = ACTIONS(4429),
    [anon_sym_select] = ACTIONS(4429),
    [anon_sym_as] = ACTIONS(4429),
    [anon_sym_is] = ACTIONS(4429),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4429),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2951] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3064),
    [sym_property_pattern_clause] = STATE(3126),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2951),
    [sym_preproc_endregion] = STATE(2951),
    [sym_preproc_line] = STATE(2951),
    [sym_preproc_pragma] = STATE(2951),
    [sym_preproc_nullable] = STATE(2951),
    [sym_preproc_error] = STATE(2951),
    [sym_preproc_define] = STATE(2951),
    [sym_preproc_undef] = STATE(2951),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4339),
  },
  [2952] = {
    [sym_preproc_region] = STATE(2952),
    [sym_preproc_endregion] = STATE(2952),
    [sym_preproc_line] = STATE(2952),
    [sym_preproc_pragma] = STATE(2952),
    [sym_preproc_nullable] = STATE(2952),
    [sym_preproc_error] = STATE(2952),
    [sym_preproc_define] = STATE(2952),
    [sym_preproc_undef] = STATE(2952),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2953] = {
    [sym_preproc_region] = STATE(2953),
    [sym_preproc_endregion] = STATE(2953),
    [sym_preproc_line] = STATE(2953),
    [sym_preproc_pragma] = STATE(2953),
    [sym_preproc_nullable] = STATE(2953),
    [sym_preproc_error] = STATE(2953),
    [sym_preproc_define] = STATE(2953),
    [sym_preproc_undef] = STATE(2953),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2954] = {
    [sym_preproc_region] = STATE(2954),
    [sym_preproc_endregion] = STATE(2954),
    [sym_preproc_line] = STATE(2954),
    [sym_preproc_pragma] = STATE(2954),
    [sym_preproc_nullable] = STATE(2954),
    [sym_preproc_error] = STATE(2954),
    [sym_preproc_define] = STATE(2954),
    [sym_preproc_undef] = STATE(2954),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2955] = {
    [sym_preproc_region] = STATE(2955),
    [sym_preproc_endregion] = STATE(2955),
    [sym_preproc_line] = STATE(2955),
    [sym_preproc_pragma] = STATE(2955),
    [sym_preproc_nullable] = STATE(2955),
    [sym_preproc_error] = STATE(2955),
    [sym_preproc_define] = STATE(2955),
    [sym_preproc_undef] = STATE(2955),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2956] = {
    [sym_preproc_region] = STATE(2956),
    [sym_preproc_endregion] = STATE(2956),
    [sym_preproc_line] = STATE(2956),
    [sym_preproc_pragma] = STATE(2956),
    [sym_preproc_nullable] = STATE(2956),
    [sym_preproc_error] = STATE(2956),
    [sym_preproc_define] = STATE(2956),
    [sym_preproc_undef] = STATE(2956),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RBRACK] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_in] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4559),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_if_token3] = ACTIONS(4557),
    [aux_sym_preproc_else_token1] = ACTIONS(4557),
    [aux_sym_preproc_elif_token1] = ACTIONS(4557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2957] = {
    [sym_preproc_region] = STATE(2957),
    [sym_preproc_endregion] = STATE(2957),
    [sym_preproc_line] = STATE(2957),
    [sym_preproc_pragma] = STATE(2957),
    [sym_preproc_nullable] = STATE(2957),
    [sym_preproc_error] = STATE(2957),
    [sym_preproc_define] = STATE(2957),
    [sym_preproc_undef] = STATE(2957),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2958] = {
    [sym_modifier] = STATE(3802),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7307),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2958),
    [sym_preproc_endregion] = STATE(2958),
    [sym_preproc_line] = STATE(2958),
    [sym_preproc_pragma] = STATE(2958),
    [sym_preproc_nullable] = STATE(2958),
    [sym_preproc_error] = STATE(2958),
    [sym_preproc_define] = STATE(2958),
    [sym_preproc_undef] = STATE(2958),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(4561),
    [anon_sym_ref] = ACTIONS(4563),
    [anon_sym_struct] = ACTIONS(4565),
    [anon_sym_enum] = ACTIONS(4567),
    [anon_sym_interface] = ACTIONS(4569),
    [anon_sym_delegate] = ACTIONS(4571),
    [anon_sym_record] = ACTIONS(4573),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(4575),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2959] = {
    [sym_preproc_region] = STATE(2959),
    [sym_preproc_endregion] = STATE(2959),
    [sym_preproc_line] = STATE(2959),
    [sym_preproc_pragma] = STATE(2959),
    [sym_preproc_nullable] = STATE(2959),
    [sym_preproc_error] = STATE(2959),
    [sym_preproc_define] = STATE(2959),
    [sym_preproc_undef] = STATE(2959),
    [sym__identifier_token] = ACTIONS(4577),
    [anon_sym_alias] = ACTIONS(4577),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_global] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_file] = ACTIONS(4577),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_in] = ACTIONS(4577),
    [anon_sym_where] = ACTIONS(4577),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_notnull] = ACTIONS(4577),
    [anon_sym_unmanaged] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_scoped] = ACTIONS(4577),
    [anon_sym_EQ_GT] = ACTIONS(4579),
    [anon_sym_var] = ACTIONS(4577),
    [anon_sym_yield] = ACTIONS(4577),
    [anon_sym_switch] = ACTIONS(4577),
    [anon_sym_when] = ACTIONS(4577),
    [sym_discard] = ACTIONS(4577),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_from] = ACTIONS(4577),
    [anon_sym_into] = ACTIONS(4577),
    [anon_sym_join] = ACTIONS(4577),
    [anon_sym_on] = ACTIONS(4577),
    [anon_sym_equals] = ACTIONS(4577),
    [anon_sym_let] = ACTIONS(4577),
    [anon_sym_orderby] = ACTIONS(4577),
    [anon_sym_ascending] = ACTIONS(4577),
    [anon_sym_descending] = ACTIONS(4577),
    [anon_sym_group] = ACTIONS(4577),
    [anon_sym_by] = ACTIONS(4577),
    [anon_sym_select] = ACTIONS(4577),
    [anon_sym_as] = ACTIONS(4577),
    [anon_sym_is] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4577),
    [aux_sym_preproc_if_token3] = ACTIONS(4579),
    [aux_sym_preproc_else_token1] = ACTIONS(4579),
    [aux_sym_preproc_elif_token1] = ACTIONS(4579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2960] = {
    [sym_preproc_region] = STATE(2960),
    [sym_preproc_endregion] = STATE(2960),
    [sym_preproc_line] = STATE(2960),
    [sym_preproc_pragma] = STATE(2960),
    [sym_preproc_nullable] = STATE(2960),
    [sym_preproc_error] = STATE(2960),
    [sym_preproc_define] = STATE(2960),
    [sym_preproc_undef] = STATE(2960),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2961] = {
    [sym_preproc_region] = STATE(2961),
    [sym_preproc_endregion] = STATE(2961),
    [sym_preproc_line] = STATE(2961),
    [sym_preproc_pragma] = STATE(2961),
    [sym_preproc_nullable] = STATE(2961),
    [sym_preproc_error] = STATE(2961),
    [sym_preproc_define] = STATE(2961),
    [sym_preproc_undef] = STATE(2961),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2962] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3090),
    [sym_property_pattern_clause] = STATE(3133),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2962),
    [sym_preproc_endregion] = STATE(2962),
    [sym_preproc_line] = STATE(2962),
    [sym_preproc_pragma] = STATE(2962),
    [sym_preproc_nullable] = STATE(2962),
    [sym_preproc_error] = STATE(2962),
    [sym_preproc_define] = STATE(2962),
    [sym_preproc_undef] = STATE(2962),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4339),
  },
  [2963] = {
    [sym_type_argument_list] = STATE(3025),
    [sym_preproc_region] = STATE(2963),
    [sym_preproc_endregion] = STATE(2963),
    [sym_preproc_line] = STATE(2963),
    [sym_preproc_pragma] = STATE(2963),
    [sym_preproc_nullable] = STATE(2963),
    [sym_preproc_error] = STATE(2963),
    [sym_preproc_define] = STATE(2963),
    [sym_preproc_undef] = STATE(2963),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4585),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2964] = {
    [sym_preproc_region] = STATE(2964),
    [sym_preproc_endregion] = STATE(2964),
    [sym_preproc_line] = STATE(2964),
    [sym_preproc_pragma] = STATE(2964),
    [sym_preproc_nullable] = STATE(2964),
    [sym_preproc_error] = STATE(2964),
    [sym_preproc_define] = STATE(2964),
    [sym_preproc_undef] = STATE(2964),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4164),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2965] = {
    [sym_preproc_region] = STATE(2965),
    [sym_preproc_endregion] = STATE(2965),
    [sym_preproc_line] = STATE(2965),
    [sym_preproc_pragma] = STATE(2965),
    [sym_preproc_nullable] = STATE(2965),
    [sym_preproc_error] = STATE(2965),
    [sym_preproc_define] = STATE(2965),
    [sym_preproc_undef] = STATE(2965),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2966] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3064),
    [sym_property_pattern_clause] = STATE(3126),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2966),
    [sym_preproc_endregion] = STATE(2966),
    [sym_preproc_line] = STATE(2966),
    [sym_preproc_pragma] = STATE(2966),
    [sym_preproc_nullable] = STATE(2966),
    [sym_preproc_error] = STATE(2966),
    [sym_preproc_define] = STATE(2966),
    [sym_preproc_undef] = STATE(2966),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4349),
  },
  [2967] = {
    [sym_modifier] = STATE(3802),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7309),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(2967),
    [sym_preproc_endregion] = STATE(2967),
    [sym_preproc_line] = STATE(2967),
    [sym_preproc_pragma] = STATE(2967),
    [sym_preproc_nullable] = STATE(2967),
    [sym_preproc_error] = STATE(2967),
    [sym_preproc_define] = STATE(2967),
    [sym_preproc_undef] = STATE(2967),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(63),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(4588),
    [anon_sym_ref] = ACTIONS(4590),
    [anon_sym_struct] = ACTIONS(4592),
    [anon_sym_enum] = ACTIONS(4594),
    [anon_sym_interface] = ACTIONS(4596),
    [anon_sym_delegate] = ACTIONS(4598),
    [anon_sym_record] = ACTIONS(4600),
    [anon_sym_abstract] = ACTIONS(63),
    [anon_sym_async] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(63),
    [anon_sym_file] = ACTIONS(4575),
    [anon_sym_fixed] = ACTIONS(63),
    [anon_sym_internal] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_override] = ACTIONS(63),
    [anon_sym_partial] = ACTIONS(63),
    [anon_sym_private] = ACTIONS(63),
    [anon_sym_protected] = ACTIONS(63),
    [anon_sym_public] = ACTIONS(63),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_required] = ACTIONS(63),
    [anon_sym_sealed] = ACTIONS(63),
    [anon_sym_virtual] = ACTIONS(63),
    [anon_sym_volatile] = ACTIONS(63),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2968] = {
    [sym_preproc_region] = STATE(2968),
    [sym_preproc_endregion] = STATE(2968),
    [sym_preproc_line] = STATE(2968),
    [sym_preproc_pragma] = STATE(2968),
    [sym_preproc_nullable] = STATE(2968),
    [sym_preproc_error] = STATE(2968),
    [sym_preproc_define] = STATE(2968),
    [sym_preproc_undef] = STATE(2968),
    [sym__identifier_token] = ACTIONS(4134),
    [anon_sym_alias] = ACTIONS(4134),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_global] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_file] = ACTIONS(4134),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_notnull] = ACTIONS(4134),
    [anon_sym_unmanaged] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_scoped] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_var] = ACTIONS(4134),
    [anon_sym_yield] = ACTIONS(4134),
    [anon_sym_switch] = ACTIONS(4134),
    [anon_sym_when] = ACTIONS(4134),
    [sym_discard] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_from] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4134),
    [anon_sym_join] = ACTIONS(4134),
    [anon_sym_on] = ACTIONS(4134),
    [anon_sym_equals] = ACTIONS(4134),
    [anon_sym_let] = ACTIONS(4134),
    [anon_sym_orderby] = ACTIONS(4134),
    [anon_sym_ascending] = ACTIONS(4134),
    [anon_sym_descending] = ACTIONS(4134),
    [anon_sym_group] = ACTIONS(4134),
    [anon_sym_by] = ACTIONS(4134),
    [anon_sym_select] = ACTIONS(4134),
    [anon_sym_as] = ACTIONS(4134),
    [anon_sym_is] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4134),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2969] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3090),
    [sym_property_pattern_clause] = STATE(3133),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2969),
    [sym_preproc_endregion] = STATE(2969),
    [sym_preproc_line] = STATE(2969),
    [sym_preproc_pragma] = STATE(2969),
    [sym_preproc_nullable] = STATE(2969),
    [sym_preproc_error] = STATE(2969),
    [sym_preproc_define] = STATE(2969),
    [sym_preproc_undef] = STATE(2969),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4339),
  },
  [2970] = {
    [sym_preproc_region] = STATE(2970),
    [sym_preproc_endregion] = STATE(2970),
    [sym_preproc_line] = STATE(2970),
    [sym_preproc_pragma] = STATE(2970),
    [sym_preproc_nullable] = STATE(2970),
    [sym_preproc_error] = STATE(2970),
    [sym_preproc_define] = STATE(2970),
    [sym_preproc_undef] = STATE(2970),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2971] = {
    [sym_preproc_region] = STATE(2971),
    [sym_preproc_endregion] = STATE(2971),
    [sym_preproc_line] = STATE(2971),
    [sym_preproc_pragma] = STATE(2971),
    [sym_preproc_nullable] = STATE(2971),
    [sym_preproc_error] = STATE(2971),
    [sym_preproc_define] = STATE(2971),
    [sym_preproc_undef] = STATE(2971),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_SEMI] = ACTIONS(4557),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_RBRACK] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_RPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_in] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4559),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_if_token3] = ACTIONS(4557),
    [aux_sym_preproc_else_token1] = ACTIONS(4557),
    [aux_sym_preproc_elif_token1] = ACTIONS(4557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2972] = {
    [sym_preproc_region] = STATE(2972),
    [sym_preproc_endregion] = STATE(2972),
    [sym_preproc_line] = STATE(2972),
    [sym_preproc_pragma] = STATE(2972),
    [sym_preproc_nullable] = STATE(2972),
    [sym_preproc_error] = STATE(2972),
    [sym_preproc_define] = STATE(2972),
    [sym_preproc_undef] = STATE(2972),
    [sym__identifier_token] = ACTIONS(4130),
    [anon_sym_alias] = ACTIONS(4130),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_global] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_file] = ACTIONS(4130),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_notnull] = ACTIONS(4130),
    [anon_sym_unmanaged] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_scoped] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_var] = ACTIONS(4130),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_switch] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_is] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4130),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2973] = {
    [sym_preproc_region] = STATE(2973),
    [sym_preproc_endregion] = STATE(2973),
    [sym_preproc_line] = STATE(2973),
    [sym_preproc_pragma] = STATE(2973),
    [sym_preproc_nullable] = STATE(2973),
    [sym_preproc_error] = STATE(2973),
    [sym_preproc_define] = STATE(2973),
    [sym_preproc_undef] = STATE(2973),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4180),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2974] = {
    [sym_preproc_region] = STATE(2974),
    [sym_preproc_endregion] = STATE(2974),
    [sym_preproc_line] = STATE(2974),
    [sym_preproc_pragma] = STATE(2974),
    [sym_preproc_nullable] = STATE(2974),
    [sym_preproc_error] = STATE(2974),
    [sym_preproc_define] = STATE(2974),
    [sym_preproc_undef] = STATE(2974),
    [sym__identifier_token] = ACTIONS(4602),
    [anon_sym_alias] = ACTIONS(4602),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_global] = ACTIONS(4602),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_file] = ACTIONS(4602),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_in] = ACTIONS(4602),
    [anon_sym_where] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_notnull] = ACTIONS(4602),
    [anon_sym_unmanaged] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_scoped] = ACTIONS(4602),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_var] = ACTIONS(4602),
    [anon_sym_yield] = ACTIONS(4602),
    [anon_sym_switch] = ACTIONS(4602),
    [anon_sym_when] = ACTIONS(4602),
    [sym_discard] = ACTIONS(4602),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4602),
    [anon_sym_or] = ACTIONS(4602),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_from] = ACTIONS(4602),
    [anon_sym_into] = ACTIONS(4602),
    [anon_sym_join] = ACTIONS(4602),
    [anon_sym_on] = ACTIONS(4602),
    [anon_sym_equals] = ACTIONS(4602),
    [anon_sym_let] = ACTIONS(4602),
    [anon_sym_orderby] = ACTIONS(4602),
    [anon_sym_ascending] = ACTIONS(4602),
    [anon_sym_descending] = ACTIONS(4602),
    [anon_sym_group] = ACTIONS(4602),
    [anon_sym_by] = ACTIONS(4602),
    [anon_sym_select] = ACTIONS(4602),
    [anon_sym_as] = ACTIONS(4602),
    [anon_sym_is] = ACTIONS(4602),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4602),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2975] = {
    [sym_preproc_region] = STATE(2975),
    [sym_preproc_endregion] = STATE(2975),
    [sym_preproc_line] = STATE(2975),
    [sym_preproc_pragma] = STATE(2975),
    [sym_preproc_nullable] = STATE(2975),
    [sym_preproc_error] = STATE(2975),
    [sym_preproc_define] = STATE(2975),
    [sym_preproc_undef] = STATE(2975),
    [sym__identifier_token] = ACTIONS(4126),
    [anon_sym_alias] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_global] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_file] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4126),
    [anon_sym_unmanaged] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_var] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4126),
    [sym_discard] = ACTIONS(4126),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_from] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4126),
    [anon_sym_join] = ACTIONS(4126),
    [anon_sym_on] = ACTIONS(4126),
    [anon_sym_equals] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_orderby] = ACTIONS(4126),
    [anon_sym_ascending] = ACTIONS(4126),
    [anon_sym_descending] = ACTIONS(4126),
    [anon_sym_group] = ACTIONS(4126),
    [anon_sym_by] = ACTIONS(4126),
    [anon_sym_select] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2976] = {
    [sym_preproc_region] = STATE(2976),
    [sym_preproc_endregion] = STATE(2976),
    [sym_preproc_line] = STATE(2976),
    [sym_preproc_pragma] = STATE(2976),
    [sym_preproc_nullable] = STATE(2976),
    [sym_preproc_error] = STATE(2976),
    [sym_preproc_define] = STATE(2976),
    [sym_preproc_undef] = STATE(2976),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4169),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4169),
    [anon_sym_is] = ACTIONS(4169),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4169),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2977] = {
    [sym_preproc_region] = STATE(2977),
    [sym_preproc_endregion] = STATE(2977),
    [sym_preproc_line] = STATE(2977),
    [sym_preproc_pragma] = STATE(2977),
    [sym_preproc_nullable] = STATE(2977),
    [sym_preproc_error] = STATE(2977),
    [sym_preproc_define] = STATE(2977),
    [sym_preproc_undef] = STATE(2977),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2978] = {
    [sym__name] = STATE(6146),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(5496),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2978),
    [sym_preproc_endregion] = STATE(2978),
    [sym_preproc_line] = STATE(2978),
    [sym_preproc_pragma] = STATE(2978),
    [sym_preproc_nullable] = STATE(2978),
    [sym_preproc_error] = STATE(2978),
    [sym_preproc_define] = STATE(2978),
    [sym_preproc_undef] = STATE(2978),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2979] = {
    [sym_preproc_region] = STATE(2979),
    [sym_preproc_endregion] = STATE(2979),
    [sym_preproc_line] = STATE(2979),
    [sym_preproc_pragma] = STATE(2979),
    [sym_preproc_nullable] = STATE(2979),
    [sym_preproc_error] = STATE(2979),
    [sym_preproc_define] = STATE(2979),
    [sym_preproc_undef] = STATE(2979),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4180),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4173),
    [anon_sym_when] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4173),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4180),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4173),
    [anon_sym_DASH_GT] = ACTIONS(4175),
    [anon_sym_with] = ACTIONS(4173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2980] = {
    [sym_preproc_region] = STATE(2980),
    [sym_preproc_endregion] = STATE(2980),
    [sym_preproc_line] = STATE(2980),
    [sym_preproc_pragma] = STATE(2980),
    [sym_preproc_nullable] = STATE(2980),
    [sym_preproc_error] = STATE(2980),
    [sym_preproc_define] = STATE(2980),
    [sym_preproc_undef] = STATE(2980),
    [sym__identifier_token] = ACTIONS(4608),
    [anon_sym_alias] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_global] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_RBRACK] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_file] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4608),
    [anon_sym_where] = ACTIONS(4608),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_notnull] = ACTIONS(4608),
    [anon_sym_unmanaged] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_scoped] = ACTIONS(4608),
    [anon_sym_EQ_GT] = ACTIONS(4610),
    [anon_sym_var] = ACTIONS(4608),
    [anon_sym_yield] = ACTIONS(4608),
    [anon_sym_switch] = ACTIONS(4608),
    [anon_sym_when] = ACTIONS(4608),
    [sym_discard] = ACTIONS(4608),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4608),
    [anon_sym_or] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_from] = ACTIONS(4608),
    [anon_sym_into] = ACTIONS(4608),
    [anon_sym_join] = ACTIONS(4608),
    [anon_sym_on] = ACTIONS(4608),
    [anon_sym_equals] = ACTIONS(4608),
    [anon_sym_let] = ACTIONS(4608),
    [anon_sym_orderby] = ACTIONS(4608),
    [anon_sym_ascending] = ACTIONS(4608),
    [anon_sym_descending] = ACTIONS(4608),
    [anon_sym_group] = ACTIONS(4608),
    [anon_sym_by] = ACTIONS(4608),
    [anon_sym_select] = ACTIONS(4608),
    [anon_sym_as] = ACTIONS(4608),
    [anon_sym_is] = ACTIONS(4608),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4608),
    [aux_sym_preproc_if_token3] = ACTIONS(4610),
    [aux_sym_preproc_else_token1] = ACTIONS(4610),
    [aux_sym_preproc_elif_token1] = ACTIONS(4610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2981] = {
    [sym__name] = STATE(3026),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2981),
    [sym_preproc_endregion] = STATE(2981),
    [sym_preproc_line] = STATE(2981),
    [sym_preproc_pragma] = STATE(2981),
    [sym_preproc_nullable] = STATE(2981),
    [sym_preproc_error] = STATE(2981),
    [sym_preproc_define] = STATE(2981),
    [sym_preproc_undef] = STATE(2981),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4616),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4614),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4065),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2982] = {
    [sym_preproc_region] = STATE(2982),
    [sym_preproc_endregion] = STATE(2982),
    [sym_preproc_line] = STATE(2982),
    [sym_preproc_pragma] = STATE(2982),
    [sym_preproc_nullable] = STATE(2982),
    [sym_preproc_error] = STATE(2982),
    [sym_preproc_define] = STATE(2982),
    [sym_preproc_undef] = STATE(2982),
    [sym__identifier_token] = ACTIONS(4618),
    [anon_sym_alias] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_global] = ACTIONS(4618),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_file] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_notnull] = ACTIONS(4618),
    [anon_sym_unmanaged] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_scoped] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_var] = ACTIONS(4618),
    [anon_sym_yield] = ACTIONS(4618),
    [anon_sym_switch] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [sym_discard] = ACTIONS(4618),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4618),
    [anon_sym_or] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_from] = ACTIONS(4618),
    [anon_sym_into] = ACTIONS(4618),
    [anon_sym_join] = ACTIONS(4618),
    [anon_sym_on] = ACTIONS(4618),
    [anon_sym_equals] = ACTIONS(4618),
    [anon_sym_let] = ACTIONS(4618),
    [anon_sym_orderby] = ACTIONS(4618),
    [anon_sym_ascending] = ACTIONS(4618),
    [anon_sym_descending] = ACTIONS(4618),
    [anon_sym_group] = ACTIONS(4618),
    [anon_sym_by] = ACTIONS(4618),
    [anon_sym_select] = ACTIONS(4618),
    [anon_sym_as] = ACTIONS(4618),
    [anon_sym_is] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4618),
    [aux_sym_preproc_if_token3] = ACTIONS(4620),
    [aux_sym_preproc_else_token1] = ACTIONS(4620),
    [aux_sym_preproc_elif_token1] = ACTIONS(4620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2983] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3090),
    [sym_property_pattern_clause] = STATE(3133),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2983),
    [sym_preproc_endregion] = STATE(2983),
    [sym_preproc_line] = STATE(2983),
    [sym_preproc_pragma] = STATE(2983),
    [sym_preproc_nullable] = STATE(2983),
    [sym_preproc_error] = STATE(2983),
    [sym_preproc_define] = STATE(2983),
    [sym_preproc_undef] = STATE(2983),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4349),
  },
  [2984] = {
    [sym_preproc_region] = STATE(2984),
    [sym_preproc_endregion] = STATE(2984),
    [sym_preproc_line] = STATE(2984),
    [sym_preproc_pragma] = STATE(2984),
    [sym_preproc_nullable] = STATE(2984),
    [sym_preproc_error] = STATE(2984),
    [sym_preproc_define] = STATE(2984),
    [sym_preproc_undef] = STATE(2984),
    [sym__identifier_token] = ACTIONS(4622),
    [anon_sym_alias] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_global] = ACTIONS(4622),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_RBRACK] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_file] = ACTIONS(4622),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_in] = ACTIONS(4622),
    [anon_sym_where] = ACTIONS(4622),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_notnull] = ACTIONS(4622),
    [anon_sym_unmanaged] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_scoped] = ACTIONS(4622),
    [anon_sym_EQ_GT] = ACTIONS(4624),
    [anon_sym_var] = ACTIONS(4622),
    [anon_sym_yield] = ACTIONS(4622),
    [anon_sym_switch] = ACTIONS(4622),
    [anon_sym_when] = ACTIONS(4622),
    [sym_discard] = ACTIONS(4622),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4622),
    [anon_sym_or] = ACTIONS(4622),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_from] = ACTIONS(4622),
    [anon_sym_into] = ACTIONS(4622),
    [anon_sym_join] = ACTIONS(4622),
    [anon_sym_on] = ACTIONS(4622),
    [anon_sym_equals] = ACTIONS(4622),
    [anon_sym_let] = ACTIONS(4622),
    [anon_sym_orderby] = ACTIONS(4622),
    [anon_sym_ascending] = ACTIONS(4622),
    [anon_sym_descending] = ACTIONS(4622),
    [anon_sym_group] = ACTIONS(4622),
    [anon_sym_by] = ACTIONS(4622),
    [anon_sym_select] = ACTIONS(4622),
    [anon_sym_as] = ACTIONS(4622),
    [anon_sym_is] = ACTIONS(4622),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4622),
    [aux_sym_preproc_if_token3] = ACTIONS(4624),
    [aux_sym_preproc_else_token1] = ACTIONS(4624),
    [aux_sym_preproc_elif_token1] = ACTIONS(4624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2985] = {
    [sym_preproc_region] = STATE(2985),
    [sym_preproc_endregion] = STATE(2985),
    [sym_preproc_line] = STATE(2985),
    [sym_preproc_pragma] = STATE(2985),
    [sym_preproc_nullable] = STATE(2985),
    [sym_preproc_error] = STATE(2985),
    [sym_preproc_define] = STATE(2985),
    [sym_preproc_undef] = STATE(2985),
    [sym__identifier_token] = ACTIONS(4626),
    [anon_sym_alias] = ACTIONS(4626),
    [anon_sym_SEMI] = ACTIONS(4628),
    [anon_sym_global] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_COLON] = ACTIONS(4628),
    [anon_sym_COMMA] = ACTIONS(4628),
    [anon_sym_RBRACK] = ACTIONS(4628),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(4628),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [anon_sym_file] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4626),
    [anon_sym_GT] = ACTIONS(4626),
    [anon_sym_in] = ACTIONS(4626),
    [anon_sym_where] = ACTIONS(4626),
    [anon_sym_QMARK] = ACTIONS(4626),
    [anon_sym_notnull] = ACTIONS(4626),
    [anon_sym_unmanaged] = ACTIONS(4626),
    [anon_sym_BANG] = ACTIONS(4626),
    [anon_sym_PLUS_PLUS] = ACTIONS(4628),
    [anon_sym_DASH_DASH] = ACTIONS(4628),
    [anon_sym_PLUS] = ACTIONS(4626),
    [anon_sym_DASH] = ACTIONS(4626),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_SLASH] = ACTIONS(4626),
    [anon_sym_PERCENT] = ACTIONS(4628),
    [anon_sym_CARET] = ACTIONS(4628),
    [anon_sym_PIPE] = ACTIONS(4626),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT_LT] = ACTIONS(4628),
    [anon_sym_GT_GT] = ACTIONS(4626),
    [anon_sym_GT_GT_GT] = ACTIONS(4628),
    [anon_sym_EQ_EQ] = ACTIONS(4628),
    [anon_sym_BANG_EQ] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4628),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_DOT] = ACTIONS(4626),
    [anon_sym_scoped] = ACTIONS(4626),
    [anon_sym_EQ_GT] = ACTIONS(4628),
    [anon_sym_var] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4626),
    [anon_sym_switch] = ACTIONS(4626),
    [anon_sym_when] = ACTIONS(4626),
    [sym_discard] = ACTIONS(4626),
    [anon_sym_DOT_DOT] = ACTIONS(4628),
    [anon_sym_and] = ACTIONS(4626),
    [anon_sym_or] = ACTIONS(4626),
    [anon_sym_AMP_AMP] = ACTIONS(4628),
    [anon_sym_PIPE_PIPE] = ACTIONS(4628),
    [anon_sym_QMARK_QMARK] = ACTIONS(4628),
    [anon_sym_from] = ACTIONS(4626),
    [anon_sym_into] = ACTIONS(4626),
    [anon_sym_join] = ACTIONS(4626),
    [anon_sym_on] = ACTIONS(4626),
    [anon_sym_equals] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4626),
    [anon_sym_orderby] = ACTIONS(4626),
    [anon_sym_ascending] = ACTIONS(4626),
    [anon_sym_descending] = ACTIONS(4626),
    [anon_sym_group] = ACTIONS(4626),
    [anon_sym_by] = ACTIONS(4626),
    [anon_sym_select] = ACTIONS(4626),
    [anon_sym_as] = ACTIONS(4626),
    [anon_sym_is] = ACTIONS(4626),
    [anon_sym_DASH_GT] = ACTIONS(4628),
    [anon_sym_with] = ACTIONS(4626),
    [aux_sym_preproc_if_token3] = ACTIONS(4628),
    [aux_sym_preproc_else_token1] = ACTIONS(4628),
    [aux_sym_preproc_elif_token1] = ACTIONS(4628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2986] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3064),
    [sym_property_pattern_clause] = STATE(3126),
    [sym__variable_designation] = STATE(5580),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5310),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(2986),
    [sym_preproc_endregion] = STATE(2986),
    [sym_preproc_line] = STATE(2986),
    [sym_preproc_pragma] = STATE(2986),
    [sym_preproc_nullable] = STATE(2986),
    [sym_preproc_error] = STATE(2986),
    [sym_preproc_define] = STATE(2986),
    [sym_preproc_undef] = STATE(2986),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4339),
  },
  [2987] = {
    [sym_preproc_region] = STATE(2987),
    [sym_preproc_endregion] = STATE(2987),
    [sym_preproc_line] = STATE(2987),
    [sym_preproc_pragma] = STATE(2987),
    [sym_preproc_nullable] = STATE(2987),
    [sym_preproc_error] = STATE(2987),
    [sym_preproc_define] = STATE(2987),
    [sym_preproc_undef] = STATE(2987),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4630),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2988] = {
    [sym__name] = STATE(3026),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(2988),
    [sym_preproc_endregion] = STATE(2988),
    [sym_preproc_line] = STATE(2988),
    [sym_preproc_pragma] = STATE(2988),
    [sym_preproc_nullable] = STATE(2988),
    [sym_preproc_error] = STATE(2988),
    [sym_preproc_define] = STATE(2988),
    [sym_preproc_undef] = STATE(2988),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4065),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4614),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4065),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4065),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4065),
    [anon_sym_orderby] = ACTIONS(4065),
    [anon_sym_ascending] = ACTIONS(4065),
    [anon_sym_descending] = ACTIONS(4065),
    [anon_sym_group] = ACTIONS(4065),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2989] = {
    [sym_preproc_region] = STATE(2989),
    [sym_preproc_endregion] = STATE(2989),
    [sym_preproc_line] = STATE(2989),
    [sym_preproc_pragma] = STATE(2989),
    [sym_preproc_nullable] = STATE(2989),
    [sym_preproc_error] = STATE(2989),
    [sym_preproc_define] = STATE(2989),
    [sym_preproc_undef] = STATE(2989),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4161),
    [anon_sym_LPAREN] = ACTIONS(4161),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4164),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4164),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4159),
    [anon_sym_when] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4159),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4159),
    [anon_sym_DASH_GT] = ACTIONS(4161),
    [anon_sym_with] = ACTIONS(4159),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2990] = {
    [sym_preproc_region] = STATE(2990),
    [sym_preproc_endregion] = STATE(2990),
    [sym_preproc_line] = STATE(2990),
    [sym_preproc_pragma] = STATE(2990),
    [sym_preproc_nullable] = STATE(2990),
    [sym_preproc_error] = STATE(2990),
    [sym_preproc_define] = STATE(2990),
    [sym_preproc_undef] = STATE(2990),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_RBRACK] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_in] = ACTIONS(4642),
    [anon_sym_where] = ACTIONS(4636),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_EQ_GT] = ACTIONS(4636),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4642),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_from] = ACTIONS(4636),
    [anon_sym_into] = ACTIONS(4636),
    [anon_sym_join] = ACTIONS(4636),
    [anon_sym_on] = ACTIONS(4636),
    [anon_sym_equals] = ACTIONS(4636),
    [anon_sym_let] = ACTIONS(4636),
    [anon_sym_orderby] = ACTIONS(4636),
    [anon_sym_group] = ACTIONS(4636),
    [anon_sym_by] = ACTIONS(4636),
    [anon_sym_select] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_if_token3] = ACTIONS(4636),
    [aux_sym_preproc_else_token1] = ACTIONS(4636),
    [aux_sym_preproc_elif_token1] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2991] = {
    [sym_preproc_region] = STATE(2991),
    [sym_preproc_endregion] = STATE(2991),
    [sym_preproc_line] = STATE(2991),
    [sym_preproc_pragma] = STATE(2991),
    [sym_preproc_nullable] = STATE(2991),
    [sym_preproc_error] = STATE(2991),
    [sym_preproc_define] = STATE(2991),
    [sym_preproc_undef] = STATE(2991),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_COMMA] = ACTIONS(4644),
    [anon_sym_RBRACK] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_LT] = ACTIONS(4646),
    [anon_sym_GT] = ACTIONS(4646),
    [anon_sym_in] = ACTIONS(4646),
    [anon_sym_where] = ACTIONS(4644),
    [anon_sym_QMARK] = ACTIONS(4646),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_STAR] = ACTIONS(4646),
    [anon_sym_SLASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4646),
    [anon_sym_AMP] = ACTIONS(4646),
    [anon_sym_LT_LT] = ACTIONS(4646),
    [anon_sym_GT_GT] = ACTIONS(4646),
    [anon_sym_GT_GT_GT] = ACTIONS(4646),
    [anon_sym_EQ_EQ] = ACTIONS(4644),
    [anon_sym_BANG_EQ] = ACTIONS(4644),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_LT_EQ] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_EQ_GT] = ACTIONS(4644),
    [anon_sym_switch] = ACTIONS(4644),
    [anon_sym_DOT_DOT] = ACTIONS(4644),
    [anon_sym_and] = ACTIONS(4644),
    [anon_sym_or] = ACTIONS(4646),
    [anon_sym_PLUS_EQ] = ACTIONS(4644),
    [anon_sym_DASH_EQ] = ACTIONS(4644),
    [anon_sym_STAR_EQ] = ACTIONS(4644),
    [anon_sym_SLASH_EQ] = ACTIONS(4644),
    [anon_sym_PERCENT_EQ] = ACTIONS(4644),
    [anon_sym_AMP_EQ] = ACTIONS(4644),
    [anon_sym_CARET_EQ] = ACTIONS(4644),
    [anon_sym_PIPE_EQ] = ACTIONS(4644),
    [anon_sym_LT_LT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4644),
    [anon_sym_AMP_AMP] = ACTIONS(4644),
    [anon_sym_PIPE_PIPE] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK] = ACTIONS(4646),
    [anon_sym_from] = ACTIONS(4644),
    [anon_sym_into] = ACTIONS(4644),
    [anon_sym_join] = ACTIONS(4644),
    [anon_sym_on] = ACTIONS(4644),
    [anon_sym_equals] = ACTIONS(4644),
    [anon_sym_let] = ACTIONS(4644),
    [anon_sym_orderby] = ACTIONS(4644),
    [anon_sym_group] = ACTIONS(4644),
    [anon_sym_by] = ACTIONS(4644),
    [anon_sym_select] = ACTIONS(4644),
    [anon_sym_as] = ACTIONS(4644),
    [anon_sym_is] = ACTIONS(4644),
    [anon_sym_DASH_GT] = ACTIONS(4644),
    [anon_sym_with] = ACTIONS(4644),
    [aux_sym_preproc_if_token3] = ACTIONS(4644),
    [aux_sym_preproc_else_token1] = ACTIONS(4644),
    [aux_sym_preproc_elif_token1] = ACTIONS(4644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2992] = {
    [sym_preproc_region] = STATE(2992),
    [sym_preproc_endregion] = STATE(2992),
    [sym_preproc_line] = STATE(2992),
    [sym_preproc_pragma] = STATE(2992),
    [sym_preproc_nullable] = STATE(2992),
    [sym_preproc_error] = STATE(2992),
    [sym_preproc_define] = STATE(2992),
    [sym_preproc_undef] = STATE(2992),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4167),
    [anon_sym_into] = ACTIONS(4167),
    [anon_sym_join] = ACTIONS(4167),
    [anon_sym_on] = ACTIONS(4167),
    [anon_sym_equals] = ACTIONS(4167),
    [anon_sym_let] = ACTIONS(4167),
    [anon_sym_orderby] = ACTIONS(4167),
    [anon_sym_group] = ACTIONS(4167),
    [anon_sym_by] = ACTIONS(4167),
    [anon_sym_select] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2993] = {
    [sym_preproc_region] = STATE(2993),
    [sym_preproc_endregion] = STATE(2993),
    [sym_preproc_line] = STATE(2993),
    [sym_preproc_pragma] = STATE(2993),
    [sym_preproc_nullable] = STATE(2993),
    [sym_preproc_error] = STATE(2993),
    [sym_preproc_define] = STATE(2993),
    [sym_preproc_undef] = STATE(2993),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4648),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2994] = {
    [sym_preproc_region] = STATE(2994),
    [sym_preproc_endregion] = STATE(2994),
    [sym_preproc_line] = STATE(2994),
    [sym_preproc_pragma] = STATE(2994),
    [sym_preproc_nullable] = STATE(2994),
    [sym_preproc_error] = STATE(2994),
    [sym_preproc_define] = STATE(2994),
    [sym_preproc_undef] = STATE(2994),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_in] = ACTIONS(4652),
    [anon_sym_where] = ACTIONS(4650),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_EQ_GT] = ACTIONS(4650),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4652),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_from] = ACTIONS(4650),
    [anon_sym_into] = ACTIONS(4650),
    [anon_sym_join] = ACTIONS(4650),
    [anon_sym_on] = ACTIONS(4650),
    [anon_sym_equals] = ACTIONS(4650),
    [anon_sym_let] = ACTIONS(4650),
    [anon_sym_orderby] = ACTIONS(4650),
    [anon_sym_group] = ACTIONS(4650),
    [anon_sym_by] = ACTIONS(4650),
    [anon_sym_select] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4650),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_if_token3] = ACTIONS(4650),
    [aux_sym_preproc_else_token1] = ACTIONS(4650),
    [aux_sym_preproc_elif_token1] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2995] = {
    [sym_preproc_region] = STATE(2995),
    [sym_preproc_endregion] = STATE(2995),
    [sym_preproc_line] = STATE(2995),
    [sym_preproc_pragma] = STATE(2995),
    [sym_preproc_nullable] = STATE(2995),
    [sym_preproc_error] = STATE(2995),
    [sym_preproc_define] = STATE(2995),
    [sym_preproc_undef] = STATE(2995),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_RBRACK] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_in] = ACTIONS(4656),
    [anon_sym_where] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_EQ_GT] = ACTIONS(4654),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4656),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_from] = ACTIONS(4654),
    [anon_sym_into] = ACTIONS(4654),
    [anon_sym_join] = ACTIONS(4654),
    [anon_sym_on] = ACTIONS(4654),
    [anon_sym_equals] = ACTIONS(4654),
    [anon_sym_let] = ACTIONS(4654),
    [anon_sym_orderby] = ACTIONS(4654),
    [anon_sym_group] = ACTIONS(4654),
    [anon_sym_by] = ACTIONS(4654),
    [anon_sym_select] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4654),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_if_token3] = ACTIONS(4654),
    [aux_sym_preproc_else_token1] = ACTIONS(4654),
    [aux_sym_preproc_elif_token1] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2996] = {
    [sym_preproc_region] = STATE(2996),
    [sym_preproc_endregion] = STATE(2996),
    [sym_preproc_line] = STATE(2996),
    [sym_preproc_pragma] = STATE(2996),
    [sym_preproc_nullable] = STATE(2996),
    [sym_preproc_error] = STATE(2996),
    [sym_preproc_define] = STATE(2996),
    [sym_preproc_undef] = STATE(2996),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2997] = {
    [sym__name] = STATE(4163),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2997),
    [sym_preproc_endregion] = STATE(2997),
    [sym_preproc_line] = STATE(2997),
    [sym_preproc_pragma] = STATE(2997),
    [sym_preproc_nullable] = STATE(2997),
    [sym_preproc_error] = STATE(2997),
    [sym_preproc_define] = STATE(2997),
    [sym_preproc_undef] = STATE(2997),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4658),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4509),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2998] = {
    [sym__name] = STATE(4163),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(2998),
    [sym_preproc_endregion] = STATE(2998),
    [sym_preproc_line] = STATE(2998),
    [sym_preproc_pragma] = STATE(2998),
    [sym_preproc_nullable] = STATE(2998),
    [sym_preproc_error] = STATE(2998),
    [sym_preproc_define] = STATE(2998),
    [sym_preproc_undef] = STATE(2998),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4660),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4509),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [2999] = {
    [sym_preproc_region] = STATE(2999),
    [sym_preproc_endregion] = STATE(2999),
    [sym_preproc_line] = STATE(2999),
    [sym_preproc_pragma] = STATE(2999),
    [sym_preproc_nullable] = STATE(2999),
    [sym_preproc_error] = STATE(2999),
    [sym_preproc_define] = STATE(2999),
    [sym_preproc_undef] = STATE(2999),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4136),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_from] = ACTIONS(4136),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_join] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_let] = ACTIONS(4136),
    [anon_sym_orderby] = ACTIONS(4136),
    [anon_sym_group] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_select] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3000] = {
    [sym_preproc_region] = STATE(3000),
    [sym_preproc_endregion] = STATE(3000),
    [sym_preproc_line] = STATE(3000),
    [sym_preproc_pragma] = STATE(3000),
    [sym_preproc_nullable] = STATE(3000),
    [sym_preproc_error] = STATE(3000),
    [sym_preproc_define] = STATE(3000),
    [sym_preproc_undef] = STATE(3000),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3001] = {
    [sym_preproc_region] = STATE(3001),
    [sym_preproc_endregion] = STATE(3001),
    [sym_preproc_line] = STATE(3001),
    [sym_preproc_pragma] = STATE(3001),
    [sym_preproc_nullable] = STATE(3001),
    [sym_preproc_error] = STATE(3001),
    [sym_preproc_define] = STATE(3001),
    [sym_preproc_undef] = STATE(3001),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_COMMA] = ACTIONS(4666),
    [anon_sym_RBRACK] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_GT] = ACTIONS(4664),
    [anon_sym_in] = ACTIONS(4664),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4664),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_SLASH] = ACTIONS(4664),
    [anon_sym_PERCENT] = ACTIONS(4666),
    [anon_sym_CARET] = ACTIONS(4666),
    [anon_sym_PIPE] = ACTIONS(4664),
    [anon_sym_AMP] = ACTIONS(4664),
    [anon_sym_LT_LT] = ACTIONS(4666),
    [anon_sym_GT_GT] = ACTIONS(4664),
    [anon_sym_GT_GT_GT] = ACTIONS(4666),
    [anon_sym_EQ_EQ] = ACTIONS(4666),
    [anon_sym_BANG_EQ] = ACTIONS(4666),
    [anon_sym_GT_EQ] = ACTIONS(4666),
    [anon_sym_LT_EQ] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4664),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_EQ_GT] = ACTIONS(4666),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4664),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4666),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4666),
    [anon_sym_QMARK_QMARK] = ACTIONS(4666),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4664),
    [anon_sym_is] = ACTIONS(4664),
    [anon_sym_DASH_GT] = ACTIONS(4666),
    [anon_sym_with] = ACTIONS(4664),
    [aux_sym_preproc_if_token3] = ACTIONS(4666),
    [aux_sym_preproc_else_token1] = ACTIONS(4666),
    [aux_sym_preproc_elif_token1] = ACTIONS(4666),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3002] = {
    [sym_preproc_region] = STATE(3002),
    [sym_preproc_endregion] = STATE(3002),
    [sym_preproc_line] = STATE(3002),
    [sym_preproc_pragma] = STATE(3002),
    [sym_preproc_nullable] = STATE(3002),
    [sym_preproc_error] = STATE(3002),
    [sym_preproc_define] = STATE(3002),
    [sym_preproc_undef] = STATE(3002),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_from] = ACTIONS(4128),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_join] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_let] = ACTIONS(4128),
    [anon_sym_orderby] = ACTIONS(4128),
    [anon_sym_group] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_select] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3003] = {
    [sym_preproc_region] = STATE(3003),
    [sym_preproc_endregion] = STATE(3003),
    [sym_preproc_line] = STATE(3003),
    [sym_preproc_pragma] = STATE(3003),
    [sym_preproc_nullable] = STATE(3003),
    [sym_preproc_error] = STATE(3003),
    [sym_preproc_define] = STATE(3003),
    [sym_preproc_undef] = STATE(3003),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4132),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_from] = ACTIONS(4132),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_join] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_let] = ACTIONS(4132),
    [anon_sym_orderby] = ACTIONS(4132),
    [anon_sym_group] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_select] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3004] = {
    [sym_preproc_region] = STATE(3004),
    [sym_preproc_endregion] = STATE(3004),
    [sym_preproc_line] = STATE(3004),
    [sym_preproc_pragma] = STATE(3004),
    [sym_preproc_nullable] = STATE(3004),
    [sym_preproc_error] = STATE(3004),
    [sym_preproc_define] = STATE(3004),
    [sym_preproc_undef] = STATE(3004),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_COMMA] = ACTIONS(4666),
    [anon_sym_RBRACK] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_GT] = ACTIONS(4664),
    [anon_sym_in] = ACTIONS(4664),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4664),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_SLASH] = ACTIONS(4664),
    [anon_sym_PERCENT] = ACTIONS(4666),
    [anon_sym_CARET] = ACTIONS(4666),
    [anon_sym_PIPE] = ACTIONS(4664),
    [anon_sym_AMP] = ACTIONS(4664),
    [anon_sym_LT_LT] = ACTIONS(4666),
    [anon_sym_GT_GT] = ACTIONS(4664),
    [anon_sym_GT_GT_GT] = ACTIONS(4666),
    [anon_sym_EQ_EQ] = ACTIONS(4666),
    [anon_sym_BANG_EQ] = ACTIONS(4666),
    [anon_sym_GT_EQ] = ACTIONS(4666),
    [anon_sym_LT_EQ] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4664),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_EQ_GT] = ACTIONS(4666),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4664),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4666),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4666),
    [anon_sym_QMARK_QMARK] = ACTIONS(4666),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4664),
    [anon_sym_is] = ACTIONS(4664),
    [anon_sym_DASH_GT] = ACTIONS(4666),
    [anon_sym_with] = ACTIONS(4664),
    [aux_sym_preproc_if_token3] = ACTIONS(4666),
    [aux_sym_preproc_else_token1] = ACTIONS(4666),
    [aux_sym_preproc_elif_token1] = ACTIONS(4666),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3005] = {
    [sym_preproc_region] = STATE(3005),
    [sym_preproc_endregion] = STATE(3005),
    [sym_preproc_line] = STATE(3005),
    [sym_preproc_pragma] = STATE(3005),
    [sym_preproc_nullable] = STATE(3005),
    [sym_preproc_error] = STATE(3005),
    [sym_preproc_define] = STATE(3005),
    [sym_preproc_undef] = STATE(3005),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_COMMA] = ACTIONS(4670),
    [anon_sym_RBRACK] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(4668),
    [anon_sym_GT] = ACTIONS(4668),
    [anon_sym_in] = ACTIONS(4668),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(4668),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_SLASH] = ACTIONS(4668),
    [anon_sym_PERCENT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(4670),
    [anon_sym_PIPE] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4668),
    [anon_sym_LT_LT] = ACTIONS(4670),
    [anon_sym_GT_GT] = ACTIONS(4668),
    [anon_sym_GT_GT_GT] = ACTIONS(4670),
    [anon_sym_EQ_EQ] = ACTIONS(4670),
    [anon_sym_BANG_EQ] = ACTIONS(4670),
    [anon_sym_GT_EQ] = ACTIONS(4670),
    [anon_sym_LT_EQ] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4668),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_EQ_GT] = ACTIONS(4670),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(4668),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(4670),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(4670),
    [anon_sym_PIPE_PIPE] = ACTIONS(4670),
    [anon_sym_QMARK_QMARK] = ACTIONS(4670),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(4668),
    [anon_sym_is] = ACTIONS(4668),
    [anon_sym_DASH_GT] = ACTIONS(4670),
    [anon_sym_with] = ACTIONS(4668),
    [aux_sym_preproc_if_token3] = ACTIONS(4670),
    [aux_sym_preproc_else_token1] = ACTIONS(4670),
    [aux_sym_preproc_elif_token1] = ACTIONS(4670),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3006] = {
    [sym_preproc_region] = STATE(3006),
    [sym_preproc_endregion] = STATE(3006),
    [sym_preproc_line] = STATE(3006),
    [sym_preproc_pragma] = STATE(3006),
    [sym_preproc_nullable] = STATE(3006),
    [sym_preproc_error] = STATE(3006),
    [sym_preproc_define] = STATE(3006),
    [sym_preproc_undef] = STATE(3006),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_COMMA] = ACTIONS(4670),
    [anon_sym_RBRACK] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(4668),
    [anon_sym_GT] = ACTIONS(4668),
    [anon_sym_in] = ACTIONS(4668),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(4668),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_SLASH] = ACTIONS(4668),
    [anon_sym_PERCENT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(4670),
    [anon_sym_PIPE] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4668),
    [anon_sym_LT_LT] = ACTIONS(4670),
    [anon_sym_GT_GT] = ACTIONS(4668),
    [anon_sym_GT_GT_GT] = ACTIONS(4670),
    [anon_sym_EQ_EQ] = ACTIONS(4670),
    [anon_sym_BANG_EQ] = ACTIONS(4670),
    [anon_sym_GT_EQ] = ACTIONS(4670),
    [anon_sym_LT_EQ] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4668),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_EQ_GT] = ACTIONS(4670),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(4668),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(4670),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(4670),
    [anon_sym_PIPE_PIPE] = ACTIONS(4670),
    [anon_sym_QMARK_QMARK] = ACTIONS(4670),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(4668),
    [anon_sym_is] = ACTIONS(4668),
    [anon_sym_DASH_GT] = ACTIONS(4670),
    [anon_sym_with] = ACTIONS(4668),
    [aux_sym_preproc_if_token3] = ACTIONS(4670),
    [aux_sym_preproc_else_token1] = ACTIONS(4670),
    [aux_sym_preproc_elif_token1] = ACTIONS(4670),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3007] = {
    [sym__name] = STATE(4163),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_ref_type] = STATE(4010),
    [sym__scoped_base_type] = STATE(4009),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3007),
    [sym_preproc_endregion] = STATE(3007),
    [sym_preproc_line] = STATE(3007),
    [sym_preproc_pragma] = STATE(3007),
    [sym_preproc_nullable] = STATE(3007),
    [sym_preproc_error] = STATE(3007),
    [sym_preproc_define] = STATE(3007),
    [sym_preproc_undef] = STATE(3007),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4509),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3008] = {
    [sym_preproc_region] = STATE(3008),
    [sym_preproc_endregion] = STATE(3008),
    [sym_preproc_line] = STATE(3008),
    [sym_preproc_pragma] = STATE(3008),
    [sym_preproc_nullable] = STATE(3008),
    [sym_preproc_error] = STATE(3008),
    [sym_preproc_define] = STATE(3008),
    [sym_preproc_undef] = STATE(3008),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4171),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4171),
    [anon_sym_into] = ACTIONS(4171),
    [anon_sym_join] = ACTIONS(4171),
    [anon_sym_on] = ACTIONS(4171),
    [anon_sym_equals] = ACTIONS(4171),
    [anon_sym_let] = ACTIONS(4171),
    [anon_sym_orderby] = ACTIONS(4171),
    [anon_sym_group] = ACTIONS(4171),
    [anon_sym_by] = ACTIONS(4171),
    [anon_sym_select] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_is] = ACTIONS(4171),
    [anon_sym_DASH_GT] = ACTIONS(4171),
    [anon_sym_with] = ACTIONS(4171),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3009] = {
    [sym__name] = STATE(3758),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3009),
    [sym_preproc_endregion] = STATE(3009),
    [sym_preproc_line] = STATE(3009),
    [sym_preproc_pragma] = STATE(3009),
    [sym_preproc_nullable] = STATE(3009),
    [sym_preproc_error] = STATE(3009),
    [sym_preproc_define] = STATE(3009),
    [sym_preproc_undef] = STATE(3009),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4674),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4676),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4676),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4676),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4676),
    [anon_sym_orderby] = ACTIONS(4676),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4676),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4676),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3010] = {
    [sym__name] = STATE(3922),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_ref_type] = STATE(3918),
    [sym__scoped_base_type] = STATE(3879),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(3010),
    [sym_preproc_endregion] = STATE(3010),
    [sym_preproc_line] = STATE(3010),
    [sym_preproc_pragma] = STATE(3010),
    [sym_preproc_nullable] = STATE(3010),
    [sym_preproc_error] = STATE(3010),
    [sym_preproc_define] = STATE(3010),
    [sym_preproc_undef] = STATE(3010),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4679),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4227),
    [anon_sym_select] = ACTIONS(4223),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3011] = {
    [sym_preproc_region] = STATE(3011),
    [sym_preproc_endregion] = STATE(3011),
    [sym_preproc_line] = STATE(3011),
    [sym_preproc_pragma] = STATE(3011),
    [sym_preproc_nullable] = STATE(3011),
    [sym_preproc_error] = STATE(3011),
    [sym_preproc_define] = STATE(3011),
    [sym_preproc_undef] = STATE(3011),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_RPAREN] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_in] = ACTIONS(4683),
    [anon_sym_where] = ACTIONS(4681),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_EQ_GT] = ACTIONS(4681),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4683),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_from] = ACTIONS(4681),
    [anon_sym_into] = ACTIONS(4681),
    [anon_sym_join] = ACTIONS(4681),
    [anon_sym_on] = ACTIONS(4681),
    [anon_sym_equals] = ACTIONS(4681),
    [anon_sym_let] = ACTIONS(4681),
    [anon_sym_orderby] = ACTIONS(4681),
    [anon_sym_group] = ACTIONS(4681),
    [anon_sym_by] = ACTIONS(4681),
    [anon_sym_select] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4681),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_if_token3] = ACTIONS(4681),
    [aux_sym_preproc_else_token1] = ACTIONS(4681),
    [aux_sym_preproc_elif_token1] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3012] = {
    [sym_preproc_region] = STATE(3012),
    [sym_preproc_endregion] = STATE(3012),
    [sym_preproc_line] = STATE(3012),
    [sym_preproc_pragma] = STATE(3012),
    [sym_preproc_nullable] = STATE(3012),
    [sym_preproc_error] = STATE(3012),
    [sym_preproc_define] = STATE(3012),
    [sym_preproc_undef] = STATE(3012),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4685),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3013] = {
    [sym__name] = STATE(3922),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_ref_type] = STATE(3918),
    [sym__scoped_base_type] = STATE(3879),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(3013),
    [sym_preproc_endregion] = STATE(3013),
    [sym_preproc_line] = STATE(3013),
    [sym_preproc_pragma] = STATE(3013),
    [sym_preproc_nullable] = STATE(3013),
    [sym_preproc_error] = STATE(3013),
    [sym_preproc_define] = STATE(3013),
    [sym_preproc_undef] = STATE(3013),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4687),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4227),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3014] = {
    [sym__name] = STATE(3922),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_ref_type] = STATE(3918),
    [sym__scoped_base_type] = STATE(3879),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(3014),
    [sym_preproc_endregion] = STATE(3014),
    [sym_preproc_line] = STATE(3014),
    [sym_preproc_pragma] = STATE(3014),
    [sym_preproc_nullable] = STATE(3014),
    [sym_preproc_error] = STATE(3014),
    [sym_preproc_define] = STATE(3014),
    [sym_preproc_undef] = STATE(3014),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4223),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4227),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4227),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3015] = {
    [sym_preproc_region] = STATE(3015),
    [sym_preproc_endregion] = STATE(3015),
    [sym_preproc_line] = STATE(3015),
    [sym_preproc_pragma] = STATE(3015),
    [sym_preproc_nullable] = STATE(3015),
    [sym_preproc_error] = STATE(3015),
    [sym_preproc_define] = STATE(3015),
    [sym_preproc_undef] = STATE(3015),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_in] = ACTIONS(4693),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_EQ_GT] = ACTIONS(4691),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_from] = ACTIONS(4691),
    [anon_sym_into] = ACTIONS(4691),
    [anon_sym_join] = ACTIONS(4691),
    [anon_sym_on] = ACTIONS(4691),
    [anon_sym_equals] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4691),
    [anon_sym_orderby] = ACTIONS(4691),
    [anon_sym_group] = ACTIONS(4691),
    [anon_sym_by] = ACTIONS(4691),
    [anon_sym_select] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4691),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_if_token3] = ACTIONS(4691),
    [aux_sym_preproc_else_token1] = ACTIONS(4691),
    [aux_sym_preproc_elif_token1] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3016] = {
    [sym_preproc_region] = STATE(3016),
    [sym_preproc_endregion] = STATE(3016),
    [sym_preproc_line] = STATE(3016),
    [sym_preproc_pragma] = STATE(3016),
    [sym_preproc_nullable] = STATE(3016),
    [sym_preproc_error] = STATE(3016),
    [sym_preproc_define] = STATE(3016),
    [sym_preproc_undef] = STATE(3016),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3017] = {
    [sym_preproc_region] = STATE(3017),
    [sym_preproc_endregion] = STATE(3017),
    [sym_preproc_line] = STATE(3017),
    [sym_preproc_pragma] = STATE(3017),
    [sym_preproc_nullable] = STATE(3017),
    [sym_preproc_error] = STATE(3017),
    [sym_preproc_define] = STATE(3017),
    [sym_preproc_undef] = STATE(3017),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3018] = {
    [sym_preproc_region] = STATE(3018),
    [sym_preproc_endregion] = STATE(3018),
    [sym_preproc_line] = STATE(3018),
    [sym_preproc_pragma] = STATE(3018),
    [sym_preproc_nullable] = STATE(3018),
    [sym_preproc_error] = STATE(3018),
    [sym_preproc_define] = STATE(3018),
    [sym_preproc_undef] = STATE(3018),
    [sym__identifier_token] = ACTIONS(4701),
    [anon_sym_alias] = ACTIONS(4701),
    [anon_sym_SEMI] = ACTIONS(4703),
    [anon_sym_global] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4703),
    [anon_sym_COLON] = ACTIONS(4703),
    [anon_sym_COMMA] = ACTIONS(4703),
    [anon_sym_RBRACK] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4703),
    [anon_sym_RPAREN] = ACTIONS(4703),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [anon_sym_file] = ACTIONS(4701),
    [anon_sym_LT] = ACTIONS(4701),
    [anon_sym_GT] = ACTIONS(4701),
    [anon_sym_in] = ACTIONS(4701),
    [anon_sym_where] = ACTIONS(4701),
    [anon_sym_QMARK] = ACTIONS(4701),
    [anon_sym_notnull] = ACTIONS(4701),
    [anon_sym_unmanaged] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4703),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4703),
    [anon_sym_SLASH] = ACTIONS(4701),
    [anon_sym_PERCENT] = ACTIONS(4703),
    [anon_sym_CARET] = ACTIONS(4703),
    [anon_sym_PIPE] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_LT_LT] = ACTIONS(4703),
    [anon_sym_GT_GT] = ACTIONS(4701),
    [anon_sym_GT_GT_GT] = ACTIONS(4703),
    [anon_sym_EQ_EQ] = ACTIONS(4703),
    [anon_sym_BANG_EQ] = ACTIONS(4703),
    [anon_sym_GT_EQ] = ACTIONS(4703),
    [anon_sym_LT_EQ] = ACTIONS(4703),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_scoped] = ACTIONS(4701),
    [anon_sym_EQ_GT] = ACTIONS(4703),
    [anon_sym_var] = ACTIONS(4701),
    [anon_sym_yield] = ACTIONS(4701),
    [anon_sym_switch] = ACTIONS(4701),
    [anon_sym_when] = ACTIONS(4701),
    [sym_discard] = ACTIONS(4701),
    [anon_sym_DOT_DOT] = ACTIONS(4703),
    [anon_sym_and] = ACTIONS(4701),
    [anon_sym_or] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4703),
    [anon_sym_PIPE_PIPE] = ACTIONS(4703),
    [anon_sym_QMARK_QMARK] = ACTIONS(4703),
    [anon_sym_from] = ACTIONS(4701),
    [anon_sym_into] = ACTIONS(4701),
    [anon_sym_join] = ACTIONS(4701),
    [anon_sym_on] = ACTIONS(4701),
    [anon_sym_equals] = ACTIONS(4701),
    [anon_sym_let] = ACTIONS(4701),
    [anon_sym_orderby] = ACTIONS(4701),
    [anon_sym_ascending] = ACTIONS(4701),
    [anon_sym_descending] = ACTIONS(4701),
    [anon_sym_group] = ACTIONS(4701),
    [anon_sym_by] = ACTIONS(4701),
    [anon_sym_select] = ACTIONS(4701),
    [anon_sym_as] = ACTIONS(4701),
    [anon_sym_is] = ACTIONS(4701),
    [anon_sym_DASH_GT] = ACTIONS(4703),
    [anon_sym_with] = ACTIONS(4701),
    [aux_sym_preproc_if_token3] = ACTIONS(4703),
    [aux_sym_preproc_else_token1] = ACTIONS(4703),
    [aux_sym_preproc_elif_token1] = ACTIONS(4703),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3019] = {
    [sym_preproc_region] = STATE(3019),
    [sym_preproc_endregion] = STATE(3019),
    [sym_preproc_line] = STATE(3019),
    [sym_preproc_pragma] = STATE(3019),
    [sym_preproc_nullable] = STATE(3019),
    [sym_preproc_error] = STATE(3019),
    [sym_preproc_define] = STATE(3019),
    [sym_preproc_undef] = STATE(3019),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4122),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_join] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_orderby] = ACTIONS(4122),
    [anon_sym_group] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_select] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3020] = {
    [sym_preproc_region] = STATE(3020),
    [sym_preproc_endregion] = STATE(3020),
    [sym_preproc_line] = STATE(3020),
    [sym_preproc_pragma] = STATE(3020),
    [sym_preproc_nullable] = STATE(3020),
    [sym_preproc_error] = STATE(3020),
    [sym_preproc_define] = STATE(3020),
    [sym_preproc_undef] = STATE(3020),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_in] = ACTIONS(4707),
    [anon_sym_where] = ACTIONS(4705),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_EQ_GT] = ACTIONS(4705),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4707),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_from] = ACTIONS(4705),
    [anon_sym_into] = ACTIONS(4705),
    [anon_sym_join] = ACTIONS(4705),
    [anon_sym_on] = ACTIONS(4705),
    [anon_sym_equals] = ACTIONS(4705),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_orderby] = ACTIONS(4705),
    [anon_sym_group] = ACTIONS(4705),
    [anon_sym_by] = ACTIONS(4705),
    [anon_sym_select] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4705),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_if_token3] = ACTIONS(4705),
    [aux_sym_preproc_else_token1] = ACTIONS(4705),
    [aux_sym_preproc_elif_token1] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3021] = {
    [sym__name] = STATE(4957),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_ref_type] = STATE(3620),
    [sym__scoped_base_type] = STATE(3619),
    [sym_identifier] = STATE(4618),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3021),
    [sym_preproc_endregion] = STATE(3021),
    [sym_preproc_line] = STATE(3021),
    [sym_preproc_pragma] = STATE(3021),
    [sym_preproc_nullable] = STATE(3021),
    [sym_preproc_error] = STATE(3021),
    [sym_preproc_define] = STATE(3021),
    [sym_preproc_undef] = STATE(3021),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4709),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4292),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4292),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4292),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4292),
    [anon_sym_orderby] = ACTIONS(4292),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4292),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4292),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3022] = {
    [sym_preproc_region] = STATE(3022),
    [sym_preproc_endregion] = STATE(3022),
    [sym_preproc_line] = STATE(3022),
    [sym_preproc_pragma] = STATE(3022),
    [sym_preproc_nullable] = STATE(3022),
    [sym_preproc_error] = STATE(3022),
    [sym_preproc_define] = STATE(3022),
    [sym_preproc_undef] = STATE(3022),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3023] = {
    [sym_preproc_region] = STATE(3023),
    [sym_preproc_endregion] = STATE(3023),
    [sym_preproc_line] = STATE(3023),
    [sym_preproc_pragma] = STATE(3023),
    [sym_preproc_nullable] = STATE(3023),
    [sym_preproc_error] = STATE(3023),
    [sym_preproc_define] = STATE(3023),
    [sym_preproc_undef] = STATE(3023),
    [sym__identifier_token] = ACTIONS(4711),
    [anon_sym_alias] = ACTIONS(4711),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_global] = ACTIONS(4711),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_COLON] = ACTIONS(4713),
    [anon_sym_COMMA] = ACTIONS(4713),
    [anon_sym_RBRACK] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_file] = ACTIONS(4711),
    [anon_sym_LT] = ACTIONS(4711),
    [anon_sym_GT] = ACTIONS(4711),
    [anon_sym_in] = ACTIONS(4711),
    [anon_sym_where] = ACTIONS(4711),
    [anon_sym_QMARK] = ACTIONS(4711),
    [anon_sym_notnull] = ACTIONS(4711),
    [anon_sym_unmanaged] = ACTIONS(4711),
    [anon_sym_BANG] = ACTIONS(4711),
    [anon_sym_PLUS_PLUS] = ACTIONS(4713),
    [anon_sym_DASH_DASH] = ACTIONS(4713),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_SLASH] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4713),
    [anon_sym_CARET] = ACTIONS(4713),
    [anon_sym_PIPE] = ACTIONS(4711),
    [anon_sym_AMP] = ACTIONS(4711),
    [anon_sym_LT_LT] = ACTIONS(4713),
    [anon_sym_GT_GT] = ACTIONS(4711),
    [anon_sym_GT_GT_GT] = ACTIONS(4713),
    [anon_sym_EQ_EQ] = ACTIONS(4713),
    [anon_sym_BANG_EQ] = ACTIONS(4713),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4711),
    [anon_sym_scoped] = ACTIONS(4711),
    [anon_sym_EQ_GT] = ACTIONS(4713),
    [anon_sym_var] = ACTIONS(4711),
    [anon_sym_yield] = ACTIONS(4711),
    [anon_sym_switch] = ACTIONS(4711),
    [anon_sym_when] = ACTIONS(4711),
    [sym_discard] = ACTIONS(4711),
    [anon_sym_DOT_DOT] = ACTIONS(4713),
    [anon_sym_and] = ACTIONS(4711),
    [anon_sym_or] = ACTIONS(4711),
    [anon_sym_AMP_AMP] = ACTIONS(4713),
    [anon_sym_PIPE_PIPE] = ACTIONS(4713),
    [anon_sym_QMARK_QMARK] = ACTIONS(4713),
    [anon_sym_from] = ACTIONS(4711),
    [anon_sym_into] = ACTIONS(4711),
    [anon_sym_join] = ACTIONS(4711),
    [anon_sym_on] = ACTIONS(4711),
    [anon_sym_equals] = ACTIONS(4711),
    [anon_sym_let] = ACTIONS(4711),
    [anon_sym_orderby] = ACTIONS(4711),
    [anon_sym_ascending] = ACTIONS(4711),
    [anon_sym_descending] = ACTIONS(4711),
    [anon_sym_group] = ACTIONS(4711),
    [anon_sym_by] = ACTIONS(4711),
    [anon_sym_select] = ACTIONS(4711),
    [anon_sym_as] = ACTIONS(4711),
    [anon_sym_is] = ACTIONS(4711),
    [anon_sym_DASH_GT] = ACTIONS(4713),
    [anon_sym_with] = ACTIONS(4711),
    [aux_sym_preproc_if_token3] = ACTIONS(4713),
    [aux_sym_preproc_else_token1] = ACTIONS(4713),
    [aux_sym_preproc_elif_token1] = ACTIONS(4713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3024] = {
    [sym_preproc_region] = STATE(3024),
    [sym_preproc_endregion] = STATE(3024),
    [sym_preproc_line] = STATE(3024),
    [sym_preproc_pragma] = STATE(3024),
    [sym_preproc_nullable] = STATE(3024),
    [sym_preproc_error] = STATE(3024),
    [sym_preproc_define] = STATE(3024),
    [sym_preproc_undef] = STATE(3024),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_RBRACK] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_in] = ACTIONS(4638),
    [anon_sym_where] = ACTIONS(4640),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_EQ_GT] = ACTIONS(4640),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4638),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_from] = ACTIONS(4640),
    [anon_sym_into] = ACTIONS(4640),
    [anon_sym_join] = ACTIONS(4640),
    [anon_sym_on] = ACTIONS(4640),
    [anon_sym_equals] = ACTIONS(4640),
    [anon_sym_let] = ACTIONS(4640),
    [anon_sym_orderby] = ACTIONS(4640),
    [anon_sym_group] = ACTIONS(4640),
    [anon_sym_by] = ACTIONS(4640),
    [anon_sym_select] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4640),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_if_token3] = ACTIONS(4640),
    [aux_sym_preproc_else_token1] = ACTIONS(4640),
    [aux_sym_preproc_elif_token1] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3025] = {
    [sym_preproc_region] = STATE(3025),
    [sym_preproc_endregion] = STATE(3025),
    [sym_preproc_line] = STATE(3025),
    [sym_preproc_pragma] = STATE(3025),
    [sym_preproc_nullable] = STATE(3025),
    [sym_preproc_error] = STATE(3025),
    [sym_preproc_define] = STATE(3025),
    [sym_preproc_undef] = STATE(3025),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3026] = {
    [sym_preproc_region] = STATE(3026),
    [sym_preproc_endregion] = STATE(3026),
    [sym_preproc_line] = STATE(3026),
    [sym_preproc_pragma] = STATE(3026),
    [sym_preproc_nullable] = STATE(3026),
    [sym_preproc_error] = STATE(3026),
    [sym_preproc_define] = STATE(3026),
    [sym_preproc_undef] = STATE(3026),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_file] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4685),
    [anon_sym_scoped] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_var] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [sym_discard] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3027] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3027),
    [sym_preproc_endregion] = STATE(3027),
    [sym_preproc_line] = STATE(3027),
    [sym_preproc_pragma] = STATE(3027),
    [sym_preproc_nullable] = STATE(3027),
    [sym_preproc_error] = STATE(3027),
    [sym_preproc_define] = STATE(3027),
    [sym_preproc_undef] = STATE(3027),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3028] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3209),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3028),
    [sym_preproc_endregion] = STATE(3028),
    [sym_preproc_line] = STATE(3028),
    [sym_preproc_pragma] = STATE(3028),
    [sym_preproc_nullable] = STATE(3028),
    [sym_preproc_error] = STATE(3028),
    [sym_preproc_define] = STATE(3028),
    [sym_preproc_undef] = STATE(3028),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4343),
    [anon_sym_descending] = ACTIONS(4343),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3029] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3168),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3029),
    [sym_preproc_endregion] = STATE(3029),
    [sym_preproc_line] = STATE(3029),
    [sym_preproc_pragma] = STATE(3029),
    [sym_preproc_nullable] = STATE(3029),
    [sym_preproc_error] = STATE(3029),
    [sym_preproc_define] = STATE(3029),
    [sym_preproc_undef] = STATE(3029),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3030] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3168),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3030),
    [sym_preproc_endregion] = STATE(3030),
    [sym_preproc_line] = STATE(3030),
    [sym_preproc_pragma] = STATE(3030),
    [sym_preproc_nullable] = STATE(3030),
    [sym_preproc_error] = STATE(3030),
    [sym_preproc_define] = STATE(3030),
    [sym_preproc_undef] = STATE(3030),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4343),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3031] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3187),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3031),
    [sym_preproc_endregion] = STATE(3031),
    [sym_preproc_line] = STATE(3031),
    [sym_preproc_pragma] = STATE(3031),
    [sym_preproc_nullable] = STATE(3031),
    [sym_preproc_error] = STATE(3031),
    [sym_preproc_define] = STATE(3031),
    [sym_preproc_undef] = STATE(3031),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4343),
    [anon_sym_descending] = ACTIONS(4343),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3032] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3121),
    [sym_property_pattern_clause] = STATE(3172),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3032),
    [sym_preproc_endregion] = STATE(3032),
    [sym_preproc_line] = STATE(3032),
    [sym_preproc_pragma] = STATE(3032),
    [sym_preproc_nullable] = STATE(3032),
    [sym_preproc_error] = STATE(3032),
    [sym_preproc_define] = STATE(3032),
    [sym_preproc_undef] = STATE(3032),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4343),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3033] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3033),
    [sym_preproc_endregion] = STATE(3033),
    [sym_preproc_line] = STATE(3033),
    [sym_preproc_pragma] = STATE(3033),
    [sym_preproc_nullable] = STATE(3033),
    [sym_preproc_error] = STATE(3033),
    [sym_preproc_define] = STATE(3033),
    [sym_preproc_undef] = STATE(3033),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3034] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3187),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3034),
    [sym_preproc_endregion] = STATE(3034),
    [sym_preproc_line] = STATE(3034),
    [sym_preproc_pragma] = STATE(3034),
    [sym_preproc_nullable] = STATE(3034),
    [sym_preproc_error] = STATE(3034),
    [sym_preproc_define] = STATE(3034),
    [sym_preproc_undef] = STATE(3034),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3035] = {
    [sym_preproc_region] = STATE(3035),
    [sym_preproc_endregion] = STATE(3035),
    [sym_preproc_line] = STATE(3035),
    [sym_preproc_pragma] = STATE(3035),
    [sym_preproc_nullable] = STATE(3035),
    [sym_preproc_error] = STATE(3035),
    [sym_preproc_define] = STATE(3035),
    [sym_preproc_undef] = STATE(3035),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_RBRACK] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_in] = ACTIONS(4640),
    [anon_sym_where] = ACTIONS(4640),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_EQ_GT] = ACTIONS(4640),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4638),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_from] = ACTIONS(4640),
    [anon_sym_join] = ACTIONS(4640),
    [anon_sym_on] = ACTIONS(4640),
    [anon_sym_equals] = ACTIONS(4640),
    [anon_sym_let] = ACTIONS(4640),
    [anon_sym_orderby] = ACTIONS(4640),
    [anon_sym_group] = ACTIONS(4640),
    [anon_sym_by] = ACTIONS(4640),
    [anon_sym_select] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4640),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_if_token3] = ACTIONS(4640),
    [aux_sym_preproc_else_token1] = ACTIONS(4640),
    [aux_sym_preproc_elif_token1] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3036] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3168),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3036),
    [sym_preproc_endregion] = STATE(3036),
    [sym_preproc_line] = STATE(3036),
    [sym_preproc_pragma] = STATE(3036),
    [sym_preproc_nullable] = STATE(3036),
    [sym_preproc_error] = STATE(3036),
    [sym_preproc_define] = STATE(3036),
    [sym_preproc_undef] = STATE(3036),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3037] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3037),
    [sym_preproc_endregion] = STATE(3037),
    [sym_preproc_line] = STATE(3037),
    [sym_preproc_pragma] = STATE(3037),
    [sym_preproc_nullable] = STATE(3037),
    [sym_preproc_error] = STATE(3037),
    [sym_preproc_define] = STATE(3037),
    [sym_preproc_undef] = STATE(3037),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3038] = {
    [sym_preproc_region] = STATE(3038),
    [sym_preproc_endregion] = STATE(3038),
    [sym_preproc_line] = STATE(3038),
    [sym_preproc_pragma] = STATE(3038),
    [sym_preproc_nullable] = STATE(3038),
    [sym_preproc_error] = STATE(3038),
    [sym_preproc_define] = STATE(3038),
    [sym_preproc_undef] = STATE(3038),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4695),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3039] = {
    [sym_preproc_region] = STATE(3039),
    [sym_preproc_endregion] = STATE(3039),
    [sym_preproc_line] = STATE(3039),
    [sym_preproc_pragma] = STATE(3039),
    [sym_preproc_nullable] = STATE(3039),
    [sym_preproc_error] = STATE(3039),
    [sym_preproc_define] = STATE(3039),
    [sym_preproc_undef] = STATE(3039),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_RBRACK] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_in] = ACTIONS(4636),
    [anon_sym_where] = ACTIONS(4636),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_EQ_GT] = ACTIONS(4636),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4642),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_from] = ACTIONS(4636),
    [anon_sym_join] = ACTIONS(4636),
    [anon_sym_on] = ACTIONS(4636),
    [anon_sym_equals] = ACTIONS(4636),
    [anon_sym_let] = ACTIONS(4636),
    [anon_sym_orderby] = ACTIONS(4636),
    [anon_sym_group] = ACTIONS(4636),
    [anon_sym_by] = ACTIONS(4636),
    [anon_sym_select] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_if_token3] = ACTIONS(4636),
    [aux_sym_preproc_else_token1] = ACTIONS(4636),
    [aux_sym_preproc_elif_token1] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3040] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3121),
    [sym_property_pattern_clause] = STATE(3172),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3040),
    [sym_preproc_endregion] = STATE(3040),
    [sym_preproc_line] = STATE(3040),
    [sym_preproc_pragma] = STATE(3040),
    [sym_preproc_nullable] = STATE(3040),
    [sym_preproc_error] = STATE(3040),
    [sym_preproc_define] = STATE(3040),
    [sym_preproc_undef] = STATE(3040),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3041] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3041),
    [sym_preproc_endregion] = STATE(3041),
    [sym_preproc_line] = STATE(3041),
    [sym_preproc_pragma] = STATE(3041),
    [sym_preproc_nullable] = STATE(3041),
    [sym_preproc_error] = STATE(3041),
    [sym_preproc_define] = STATE(3041),
    [sym_preproc_undef] = STATE(3041),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3042] = {
    [sym_preproc_region] = STATE(3042),
    [sym_preproc_endregion] = STATE(3042),
    [sym_preproc_line] = STATE(3042),
    [sym_preproc_pragma] = STATE(3042),
    [sym_preproc_nullable] = STATE(3042),
    [sym_preproc_error] = STATE(3042),
    [sym_preproc_define] = STATE(3042),
    [sym_preproc_undef] = STATE(3042),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_in] = ACTIONS(4650),
    [anon_sym_where] = ACTIONS(4650),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_EQ_GT] = ACTIONS(4650),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4652),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_from] = ACTIONS(4650),
    [anon_sym_join] = ACTIONS(4650),
    [anon_sym_on] = ACTIONS(4650),
    [anon_sym_equals] = ACTIONS(4650),
    [anon_sym_let] = ACTIONS(4650),
    [anon_sym_orderby] = ACTIONS(4650),
    [anon_sym_group] = ACTIONS(4650),
    [anon_sym_by] = ACTIONS(4650),
    [anon_sym_select] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4650),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_if_token3] = ACTIONS(4650),
    [aux_sym_preproc_else_token1] = ACTIONS(4650),
    [aux_sym_preproc_elif_token1] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3043] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3209),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3043),
    [sym_preproc_endregion] = STATE(3043),
    [sym_preproc_line] = STATE(3043),
    [sym_preproc_pragma] = STATE(3043),
    [sym_preproc_nullable] = STATE(3043),
    [sym_preproc_error] = STATE(3043),
    [sym_preproc_define] = STATE(3043),
    [sym_preproc_undef] = STATE(3043),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4343),
    [anon_sym_descending] = ACTIONS(4343),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3044] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3121),
    [sym_property_pattern_clause] = STATE(3172),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3044),
    [sym_preproc_endregion] = STATE(3044),
    [sym_preproc_line] = STATE(3044),
    [sym_preproc_pragma] = STATE(3044),
    [sym_preproc_nullable] = STATE(3044),
    [sym_preproc_error] = STATE(3044),
    [sym_preproc_define] = STATE(3044),
    [sym_preproc_undef] = STATE(3044),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COLON] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4347),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3045] = {
    [sym_preproc_region] = STATE(3045),
    [sym_preproc_endregion] = STATE(3045),
    [sym_preproc_line] = STATE(3045),
    [sym_preproc_pragma] = STATE(3045),
    [sym_preproc_nullable] = STATE(3045),
    [sym_preproc_error] = STATE(3045),
    [sym_preproc_define] = STATE(3045),
    [sym_preproc_undef] = STATE(3045),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4167),
    [anon_sym_where] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4167),
    [anon_sym_join] = ACTIONS(4167),
    [anon_sym_on] = ACTIONS(4167),
    [anon_sym_equals] = ACTIONS(4167),
    [anon_sym_let] = ACTIONS(4167),
    [anon_sym_orderby] = ACTIONS(4167),
    [anon_sym_group] = ACTIONS(4167),
    [anon_sym_by] = ACTIONS(4167),
    [anon_sym_select] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3046] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3204),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3046),
    [sym_preproc_endregion] = STATE(3046),
    [sym_preproc_line] = STATE(3046),
    [sym_preproc_pragma] = STATE(3046),
    [sym_preproc_nullable] = STATE(3046),
    [sym_preproc_error] = STATE(3046),
    [sym_preproc_define] = STATE(3046),
    [sym_preproc_undef] = STATE(3046),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_in] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3047] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3140),
    [sym_property_pattern_clause] = STATE(3187),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3047),
    [sym_preproc_endregion] = STATE(3047),
    [sym_preproc_line] = STATE(3047),
    [sym_preproc_pragma] = STATE(3047),
    [sym_preproc_nullable] = STATE(3047),
    [sym_preproc_error] = STATE(3047),
    [sym_preproc_define] = STATE(3047),
    [sym_preproc_undef] = STATE(3047),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4343),
    [anon_sym_descending] = ACTIONS(4343),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3048] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3204),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3048),
    [sym_preproc_endregion] = STATE(3048),
    [sym_preproc_line] = STATE(3048),
    [sym_preproc_pragma] = STATE(3048),
    [sym_preproc_nullable] = STATE(3048),
    [sym_preproc_error] = STATE(3048),
    [sym_preproc_define] = STATE(3048),
    [sym_preproc_undef] = STATE(3048),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_in] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3049] = {
    [sym_preproc_region] = STATE(3049),
    [sym_preproc_endregion] = STATE(3049),
    [sym_preproc_line] = STATE(3049),
    [sym_preproc_pragma] = STATE(3049),
    [sym_preproc_nullable] = STATE(3049),
    [sym_preproc_error] = STATE(3049),
    [sym_preproc_define] = STATE(3049),
    [sym_preproc_undef] = STATE(3049),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_EQ_GT] = ACTIONS(4691),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_from] = ACTIONS(4691),
    [anon_sym_join] = ACTIONS(4691),
    [anon_sym_on] = ACTIONS(4691),
    [anon_sym_equals] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4691),
    [anon_sym_orderby] = ACTIONS(4691),
    [anon_sym_group] = ACTIONS(4691),
    [anon_sym_by] = ACTIONS(4691),
    [anon_sym_select] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4691),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_if_token3] = ACTIONS(4691),
    [aux_sym_preproc_else_token1] = ACTIONS(4691),
    [aux_sym_preproc_elif_token1] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3050] = {
    [sym_preproc_region] = STATE(3050),
    [sym_preproc_endregion] = STATE(3050),
    [sym_preproc_line] = STATE(3050),
    [sym_preproc_pragma] = STATE(3050),
    [sym_preproc_nullable] = STATE(3050),
    [sym_preproc_error] = STATE(3050),
    [sym_preproc_define] = STATE(3050),
    [sym_preproc_undef] = STATE(3050),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_RPAREN] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_in] = ACTIONS(4681),
    [anon_sym_where] = ACTIONS(4681),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_EQ_GT] = ACTIONS(4681),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4683),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_from] = ACTIONS(4681),
    [anon_sym_join] = ACTIONS(4681),
    [anon_sym_on] = ACTIONS(4681),
    [anon_sym_equals] = ACTIONS(4681),
    [anon_sym_let] = ACTIONS(4681),
    [anon_sym_orderby] = ACTIONS(4681),
    [anon_sym_group] = ACTIONS(4681),
    [anon_sym_by] = ACTIONS(4681),
    [anon_sym_select] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4681),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_if_token3] = ACTIONS(4681),
    [aux_sym_preproc_else_token1] = ACTIONS(4681),
    [aux_sym_preproc_elif_token1] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3051] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3139),
    [sym_property_pattern_clause] = STATE(3204),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3051),
    [sym_preproc_endregion] = STATE(3051),
    [sym_preproc_line] = STATE(3051),
    [sym_preproc_pragma] = STATE(3051),
    [sym_preproc_nullable] = STATE(3051),
    [sym_preproc_error] = STATE(3051),
    [sym_preproc_define] = STATE(3051),
    [sym_preproc_undef] = STATE(3051),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_in] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3052] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3123),
    [sym_property_pattern_clause] = STATE(3209),
    [sym__variable_designation] = STATE(4543),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4502),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3052),
    [sym_preproc_endregion] = STATE(3052),
    [sym_preproc_line] = STATE(3052),
    [sym_preproc_pragma] = STATE(3052),
    [sym_preproc_nullable] = STATE(3052),
    [sym_preproc_error] = STATE(3052),
    [sym_preproc_define] = STATE(3052),
    [sym_preproc_undef] = STATE(3052),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_COMMA] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4347),
    [anon_sym_descending] = ACTIONS(4347),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3053] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2842),
    [sym_property_pattern_clause] = STATE(2881),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3053),
    [sym_preproc_endregion] = STATE(3053),
    [sym_preproc_line] = STATE(3053),
    [sym_preproc_pragma] = STATE(3053),
    [sym_preproc_nullable] = STATE(3053),
    [sym_preproc_error] = STATE(3053),
    [sym_preproc_define] = STATE(3053),
    [sym_preproc_undef] = STATE(3053),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3054] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3121),
    [sym_property_pattern_clause] = STATE(3172),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3054),
    [sym_preproc_endregion] = STATE(3054),
    [sym_preproc_line] = STATE(3054),
    [sym_preproc_pragma] = STATE(3054),
    [sym_preproc_nullable] = STATE(3054),
    [sym_preproc_error] = STATE(3054),
    [sym_preproc_define] = STATE(3054),
    [sym_preproc_undef] = STATE(3054),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_COLON] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4343),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3055] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3119),
    [sym_property_pattern_clause] = STATE(3168),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3055),
    [sym_preproc_endregion] = STATE(3055),
    [sym_preproc_line] = STATE(3055),
    [sym_preproc_pragma] = STATE(3055),
    [sym_preproc_nullable] = STATE(3055),
    [sym_preproc_error] = STATE(3055),
    [sym_preproc_define] = STATE(3055),
    [sym_preproc_undef] = STATE(3055),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4343),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3056] = {
    [sym_preproc_region] = STATE(3056),
    [sym_preproc_endregion] = STATE(3056),
    [sym_preproc_line] = STATE(3056),
    [sym_preproc_pragma] = STATE(3056),
    [sym_preproc_nullable] = STATE(3056),
    [sym_preproc_error] = STATE(3056),
    [sym_preproc_define] = STATE(3056),
    [sym_preproc_undef] = STATE(3056),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_RBRACK] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_in] = ACTIONS(4654),
    [anon_sym_where] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_EQ_GT] = ACTIONS(4654),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4656),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_from] = ACTIONS(4654),
    [anon_sym_join] = ACTIONS(4654),
    [anon_sym_on] = ACTIONS(4654),
    [anon_sym_equals] = ACTIONS(4654),
    [anon_sym_let] = ACTIONS(4654),
    [anon_sym_orderby] = ACTIONS(4654),
    [anon_sym_group] = ACTIONS(4654),
    [anon_sym_by] = ACTIONS(4654),
    [anon_sym_select] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4654),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_if_token3] = ACTIONS(4654),
    [aux_sym_preproc_else_token1] = ACTIONS(4654),
    [aux_sym_preproc_elif_token1] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3057] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(2853),
    [sym_property_pattern_clause] = STATE(2897),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(5917),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3057),
    [sym_preproc_endregion] = STATE(3057),
    [sym_preproc_line] = STATE(3057),
    [sym_preproc_pragma] = STATE(3057),
    [sym_preproc_nullable] = STATE(3057),
    [sym_preproc_error] = STATE(3057),
    [sym_preproc_define] = STATE(3057),
    [sym_preproc_undef] = STATE(3057),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4339),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3058] = {
    [sym_preproc_region] = STATE(3058),
    [sym_preproc_endregion] = STATE(3058),
    [sym_preproc_line] = STATE(3058),
    [sym_preproc_pragma] = STATE(3058),
    [sym_preproc_nullable] = STATE(3058),
    [sym_preproc_error] = STATE(3058),
    [sym_preproc_define] = STATE(3058),
    [sym_preproc_undef] = STATE(3058),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_in] = ACTIONS(4705),
    [anon_sym_where] = ACTIONS(4705),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_EQ_GT] = ACTIONS(4705),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4707),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_from] = ACTIONS(4705),
    [anon_sym_join] = ACTIONS(4705),
    [anon_sym_on] = ACTIONS(4705),
    [anon_sym_equals] = ACTIONS(4705),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_orderby] = ACTIONS(4705),
    [anon_sym_group] = ACTIONS(4705),
    [anon_sym_by] = ACTIONS(4705),
    [anon_sym_select] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4705),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_if_token3] = ACTIONS(4705),
    [aux_sym_preproc_else_token1] = ACTIONS(4705),
    [aux_sym_preproc_elif_token1] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3059] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3160),
    [sym_property_pattern_clause] = STATE(3289),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3059),
    [sym_preproc_endregion] = STATE(3059),
    [sym_preproc_line] = STATE(3059),
    [sym_preproc_pragma] = STATE(3059),
    [sym_preproc_nullable] = STATE(3059),
    [sym_preproc_error] = STATE(3059),
    [sym_preproc_define] = STATE(3059),
    [sym_preproc_undef] = STATE(3059),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3060] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3148),
    [sym_property_pattern_clause] = STATE(3464),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3060),
    [sym_preproc_endregion] = STATE(3060),
    [sym_preproc_line] = STATE(3060),
    [sym_preproc_pragma] = STATE(3060),
    [sym_preproc_nullable] = STATE(3060),
    [sym_preproc_error] = STATE(3060),
    [sym_preproc_define] = STATE(3060),
    [sym_preproc_undef] = STATE(3060),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4343),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3061] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3160),
    [sym_property_pattern_clause] = STATE(3289),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3061),
    [sym_preproc_endregion] = STATE(3061),
    [sym_preproc_line] = STATE(3061),
    [sym_preproc_pragma] = STATE(3061),
    [sym_preproc_nullable] = STATE(3061),
    [sym_preproc_error] = STATE(3061),
    [sym_preproc_define] = STATE(3061),
    [sym_preproc_undef] = STATE(3061),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3062] = {
    [sym__name] = STATE(4331),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_ref_type] = STATE(3620),
    [sym__scoped_base_type] = STATE(3619),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3062),
    [sym_preproc_endregion] = STATE(3062),
    [sym_preproc_line] = STATE(3062),
    [sym_preproc_pragma] = STATE(3062),
    [sym_preproc_nullable] = STATE(3062),
    [sym_preproc_error] = STATE(3062),
    [sym_preproc_define] = STATE(3062),
    [sym_preproc_undef] = STATE(3062),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4292),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3063] = {
    [sym__name] = STATE(3758),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3063),
    [sym_preproc_endregion] = STATE(3063),
    [sym_preproc_line] = STATE(3063),
    [sym_preproc_pragma] = STATE(3063),
    [sym_preproc_nullable] = STATE(3063),
    [sym_preproc_error] = STATE(3063),
    [sym_preproc_define] = STATE(3063),
    [sym_preproc_undef] = STATE(3063),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4721),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4676),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3064] = {
    [sym_property_pattern_clause] = STATE(3138),
    [sym__variable_designation] = STATE(5559),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3064),
    [sym_preproc_endregion] = STATE(3064),
    [sym_preproc_line] = STATE(3064),
    [sym_preproc_pragma] = STATE(3064),
    [sym_preproc_nullable] = STATE(3064),
    [sym_preproc_error] = STATE(3064),
    [sym_preproc_define] = STATE(3064),
    [sym_preproc_undef] = STATE(3064),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4403),
  },
  [3065] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3160),
    [sym_property_pattern_clause] = STATE(3289),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3065),
    [sym_preproc_endregion] = STATE(3065),
    [sym_preproc_line] = STATE(3065),
    [sym_preproc_pragma] = STATE(3065),
    [sym_preproc_nullable] = STATE(3065),
    [sym_preproc_error] = STATE(3065),
    [sym_preproc_define] = STATE(3065),
    [sym_preproc_undef] = STATE(3065),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3066] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3147),
    [sym_property_pattern_clause] = STATE(3243),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3066),
    [sym_preproc_endregion] = STATE(3066),
    [sym_preproc_line] = STATE(3066),
    [sym_preproc_pragma] = STATE(3066),
    [sym_preproc_nullable] = STATE(3066),
    [sym_preproc_error] = STATE(3066),
    [sym_preproc_define] = STATE(3066),
    [sym_preproc_undef] = STATE(3066),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4343),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3067] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3148),
    [sym_property_pattern_clause] = STATE(3464),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3067),
    [sym_preproc_endregion] = STATE(3067),
    [sym_preproc_line] = STATE(3067),
    [sym_preproc_pragma] = STATE(3067),
    [sym_preproc_nullable] = STATE(3067),
    [sym_preproc_error] = STATE(3067),
    [sym_preproc_define] = STATE(3067),
    [sym_preproc_undef] = STATE(3067),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3068] = {
    [sym__name] = STATE(4331),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_ref_type] = STATE(3620),
    [sym__scoped_base_type] = STATE(3619),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3068),
    [sym_preproc_endregion] = STATE(3068),
    [sym_preproc_line] = STATE(3068),
    [sym_preproc_pragma] = STATE(3068),
    [sym_preproc_nullable] = STATE(3068),
    [sym_preproc_error] = STATE(3068),
    [sym_preproc_define] = STATE(3068),
    [sym_preproc_undef] = STATE(3068),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4292),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3069] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3301),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3069),
    [sym_preproc_endregion] = STATE(3069),
    [sym_preproc_line] = STATE(3069),
    [sym_preproc_pragma] = STATE(3069),
    [sym_preproc_nullable] = STATE(3069),
    [sym_preproc_error] = STATE(3069),
    [sym_preproc_define] = STATE(3069),
    [sym_preproc_undef] = STATE(3069),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4343),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3070] = {
    [sym__name] = STATE(3758),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3070),
    [sym_preproc_endregion] = STATE(3070),
    [sym_preproc_line] = STATE(3070),
    [sym_preproc_pragma] = STATE(3070),
    [sym_preproc_nullable] = STATE(3070),
    [sym_preproc_error] = STATE(3070),
    [sym_preproc_define] = STATE(3070),
    [sym_preproc_undef] = STATE(3070),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4676),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3071] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3301),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3071),
    [sym_preproc_endregion] = STATE(3071),
    [sym_preproc_line] = STATE(3071),
    [sym_preproc_pragma] = STATE(3071),
    [sym_preproc_nullable] = STATE(3071),
    [sym_preproc_error] = STATE(3071),
    [sym_preproc_define] = STATE(3071),
    [sym_preproc_undef] = STATE(3071),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4343),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3072] = {
    [sym_property_pattern_clause] = STATE(3135),
    [sym__variable_designation] = STATE(5578),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3072),
    [sym_preproc_endregion] = STATE(3072),
    [sym_preproc_line] = STATE(3072),
    [sym_preproc_pragma] = STATE(3072),
    [sym_preproc_nullable] = STATE(3072),
    [sym_preproc_error] = STATE(3072),
    [sym_preproc_define] = STATE(3072),
    [sym_preproc_undef] = STATE(3072),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4395),
  },
  [3073] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3161),
    [sym_property_pattern_clause] = STATE(3328),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3073),
    [sym_preproc_endregion] = STATE(3073),
    [sym_preproc_line] = STATE(3073),
    [sym_preproc_pragma] = STATE(3073),
    [sym_preproc_nullable] = STATE(3073),
    [sym_preproc_error] = STATE(3073),
    [sym_preproc_define] = STATE(3073),
    [sym_preproc_undef] = STATE(3073),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3074] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3146),
    [sym_property_pattern_clause] = STATE(3267),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3074),
    [sym_preproc_endregion] = STATE(3074),
    [sym_preproc_line] = STATE(3074),
    [sym_preproc_pragma] = STATE(3074),
    [sym_preproc_nullable] = STATE(3074),
    [sym_preproc_error] = STATE(3074),
    [sym_preproc_define] = STATE(3074),
    [sym_preproc_undef] = STATE(3074),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3075] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3161),
    [sym_property_pattern_clause] = STATE(3328),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3075),
    [sym_preproc_endregion] = STATE(3075),
    [sym_preproc_line] = STATE(3075),
    [sym_preproc_pragma] = STATE(3075),
    [sym_preproc_nullable] = STATE(3075),
    [sym_preproc_error] = STATE(3075),
    [sym_preproc_define] = STATE(3075),
    [sym_preproc_undef] = STATE(3075),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4347),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4347),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4347),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4347),
    [anon_sym_orderby] = ACTIONS(4347),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4347),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3076] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3258),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3076),
    [sym_preproc_endregion] = STATE(3076),
    [sym_preproc_line] = STATE(3076),
    [sym_preproc_pragma] = STATE(3076),
    [sym_preproc_nullable] = STATE(3076),
    [sym_preproc_error] = STATE(3076),
    [sym_preproc_define] = STATE(3076),
    [sym_preproc_undef] = STATE(3076),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3077] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3258),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3077),
    [sym_preproc_endregion] = STATE(3077),
    [sym_preproc_line] = STATE(3077),
    [sym_preproc_pragma] = STATE(3077),
    [sym_preproc_nullable] = STATE(3077),
    [sym_preproc_error] = STATE(3077),
    [sym_preproc_define] = STATE(3077),
    [sym_preproc_undef] = STATE(3077),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4343),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3078] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3161),
    [sym_property_pattern_clause] = STATE(3328),
    [sym__variable_designation] = STATE(5014),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4981),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3078),
    [sym_preproc_endregion] = STATE(3078),
    [sym_preproc_line] = STATE(3078),
    [sym_preproc_pragma] = STATE(3078),
    [sym_preproc_nullable] = STATE(3078),
    [sym_preproc_error] = STATE(3078),
    [sym_preproc_define] = STATE(3078),
    [sym_preproc_undef] = STATE(3078),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4343),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4343),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4343),
    [anon_sym_orderby] = ACTIONS(4343),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4343),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4343),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3079] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3156),
    [sym_property_pattern_clause] = STATE(3275),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3079),
    [sym_preproc_endregion] = STATE(3079),
    [sym_preproc_line] = STATE(3079),
    [sym_preproc_pragma] = STATE(3079),
    [sym_preproc_nullable] = STATE(3079),
    [sym_preproc_error] = STATE(3079),
    [sym_preproc_define] = STATE(3079),
    [sym_preproc_undef] = STATE(3079),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4347),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3080] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3156),
    [sym_property_pattern_clause] = STATE(3275),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3080),
    [sym_preproc_endregion] = STATE(3080),
    [sym_preproc_line] = STATE(3080),
    [sym_preproc_pragma] = STATE(3080),
    [sym_preproc_nullable] = STATE(3080),
    [sym_preproc_error] = STATE(3080),
    [sym_preproc_define] = STATE(3080),
    [sym_preproc_undef] = STATE(3080),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4343),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3081] = {
    [sym__name] = STATE(3758),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_ref_type] = STATE(3697),
    [sym__scoped_base_type] = STATE(3700),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3081),
    [sym_preproc_endregion] = STATE(3081),
    [sym_preproc_line] = STATE(3081),
    [sym_preproc_pragma] = STATE(3081),
    [sym_preproc_nullable] = STATE(3081),
    [sym_preproc_error] = STATE(3081),
    [sym_preproc_define] = STATE(3081),
    [sym_preproc_undef] = STATE(3081),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4676),
    [anon_sym_select] = ACTIONS(4353),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3082] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3146),
    [sym_property_pattern_clause] = STATE(3267),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3082),
    [sym_preproc_endregion] = STATE(3082),
    [sym_preproc_line] = STATE(3082),
    [sym_preproc_pragma] = STATE(3082),
    [sym_preproc_nullable] = STATE(3082),
    [sym_preproc_error] = STATE(3082),
    [sym_preproc_define] = STATE(3082),
    [sym_preproc_undef] = STATE(3082),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4343),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3083] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3146),
    [sym_property_pattern_clause] = STATE(3267),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3083),
    [sym_preproc_endregion] = STATE(3083),
    [sym_preproc_line] = STATE(3083),
    [sym_preproc_pragma] = STATE(3083),
    [sym_preproc_nullable] = STATE(3083),
    [sym_preproc_error] = STATE(3083),
    [sym_preproc_define] = STATE(3083),
    [sym_preproc_undef] = STATE(3083),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4343),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3084] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3148),
    [sym_property_pattern_clause] = STATE(3464),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3084),
    [sym_preproc_endregion] = STATE(3084),
    [sym_preproc_line] = STATE(3084),
    [sym_preproc_pragma] = STATE(3084),
    [sym_preproc_nullable] = STATE(3084),
    [sym_preproc_error] = STATE(3084),
    [sym_preproc_define] = STATE(3084),
    [sym_preproc_undef] = STATE(3084),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4343),
    [anon_sym_or] = ACTIONS(4343),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4343),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3085] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3147),
    [sym_property_pattern_clause] = STATE(3243),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3085),
    [sym_preproc_endregion] = STATE(3085),
    [sym_preproc_line] = STATE(3085),
    [sym_preproc_pragma] = STATE(3085),
    [sym_preproc_nullable] = STATE(3085),
    [sym_preproc_error] = STATE(3085),
    [sym_preproc_define] = STATE(3085),
    [sym_preproc_undef] = STATE(3085),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4347),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4347),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3086] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3147),
    [sym_property_pattern_clause] = STATE(3243),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3086),
    [sym_preproc_endregion] = STATE(3086),
    [sym_preproc_line] = STATE(3086),
    [sym_preproc_pragma] = STATE(3086),
    [sym_preproc_nullable] = STATE(3086),
    [sym_preproc_error] = STATE(3086),
    [sym_preproc_define] = STATE(3086),
    [sym_preproc_undef] = STATE(3086),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4343),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3087] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3149),
    [sym_property_pattern_clause] = STATE(3301),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3087),
    [sym_preproc_endregion] = STATE(3087),
    [sym_preproc_line] = STATE(3087),
    [sym_preproc_pragma] = STATE(3087),
    [sym_preproc_nullable] = STATE(3087),
    [sym_preproc_error] = STATE(3087),
    [sym_preproc_define] = STATE(3087),
    [sym_preproc_undef] = STATE(3087),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4347),
    [anon_sym_GT] = ACTIONS(4347),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4347),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4347),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_PLUS] = ACTIONS(4347),
    [anon_sym_DASH] = ACTIONS(4347),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4347),
    [anon_sym_PERCENT] = ACTIONS(4349),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_PIPE] = ACTIONS(4347),
    [anon_sym_AMP] = ACTIONS(4347),
    [anon_sym_LT_LT] = ACTIONS(4349),
    [anon_sym_GT_GT] = ACTIONS(4347),
    [anon_sym_GT_GT_GT] = ACTIONS(4349),
    [anon_sym_EQ_EQ] = ACTIONS(4349),
    [anon_sym_BANG_EQ] = ACTIONS(4349),
    [anon_sym_GT_EQ] = ACTIONS(4349),
    [anon_sym_LT_EQ] = ACTIONS(4349),
    [anon_sym_DOT] = ACTIONS(4347),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4347),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4349),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4349),
    [anon_sym_PIPE_PIPE] = ACTIONS(4349),
    [anon_sym_QMARK_QMARK] = ACTIONS(4349),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4347),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4347),
    [anon_sym_is] = ACTIONS(4347),
    [anon_sym_DASH_GT] = ACTIONS(4349),
    [anon_sym_with] = ACTIONS(4347),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3088] = {
    [sym_property_pattern_clause] = STATE(3132),
    [sym__variable_designation] = STATE(5578),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3088),
    [sym_preproc_endregion] = STATE(3088),
    [sym_preproc_line] = STATE(3088),
    [sym_preproc_pragma] = STATE(3088),
    [sym_preproc_nullable] = STATE(3088),
    [sym_preproc_error] = STATE(3088),
    [sym_preproc_define] = STATE(3088),
    [sym_preproc_undef] = STATE(3088),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4395),
  },
  [3089] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3158),
    [sym_property_pattern_clause] = STATE(3258),
    [sym__variable_designation] = STATE(4068),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4070),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3089),
    [sym_preproc_endregion] = STATE(3089),
    [sym_preproc_line] = STATE(3089),
    [sym_preproc_pragma] = STATE(3089),
    [sym_preproc_nullable] = STATE(3089),
    [sym_preproc_error] = STATE(3089),
    [sym_preproc_define] = STATE(3089),
    [sym_preproc_undef] = STATE(3089),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4343),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4343),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3090] = {
    [sym_property_pattern_clause] = STATE(3131),
    [sym__variable_designation] = STATE(5559),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3090),
    [sym_preproc_endregion] = STATE(3090),
    [sym_preproc_line] = STATE(3090),
    [sym_preproc_pragma] = STATE(3090),
    [sym_preproc_nullable] = STATE(3090),
    [sym_preproc_error] = STATE(3090),
    [sym_preproc_define] = STATE(3090),
    [sym_preproc_undef] = STATE(3090),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4403),
  },
  [3091] = {
    [sym__name] = STATE(4331),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_ref_type] = STATE(3620),
    [sym__scoped_base_type] = STATE(3619),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3091),
    [sym_preproc_endregion] = STATE(3091),
    [sym_preproc_line] = STATE(3091),
    [sym_preproc_pragma] = STATE(3091),
    [sym_preproc_nullable] = STATE(3091),
    [sym_preproc_error] = STATE(3091),
    [sym_preproc_define] = STATE(3091),
    [sym_preproc_undef] = STATE(3091),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4729),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4292),
    [anon_sym_select] = ACTIONS(4288),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3092] = {
    [sym_parameter_list] = STATE(9912),
    [sym_positional_pattern_clause] = STATE(3156),
    [sym_property_pattern_clause] = STATE(3275),
    [sym__variable_designation] = STATE(4219),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(4218),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3092),
    [sym_preproc_endregion] = STATE(3092),
    [sym_preproc_line] = STATE(3092),
    [sym_preproc_pragma] = STATE(3092),
    [sym_preproc_nullable] = STATE(3092),
    [sym_preproc_error] = STATE(3092),
    [sym_preproc_define] = STATE(3092),
    [sym_preproc_undef] = STATE(3092),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4343),
    [anon_sym_GT] = ACTIONS(4343),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4343),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4343),
    [anon_sym_PLUS_PLUS] = ACTIONS(4339),
    [anon_sym_DASH_DASH] = ACTIONS(4339),
    [anon_sym_PLUS] = ACTIONS(4343),
    [anon_sym_DASH] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4339),
    [anon_sym_SLASH] = ACTIONS(4343),
    [anon_sym_PERCENT] = ACTIONS(4339),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_PIPE] = ACTIONS(4343),
    [anon_sym_AMP] = ACTIONS(4343),
    [anon_sym_LT_LT] = ACTIONS(4339),
    [anon_sym_GT_GT] = ACTIONS(4343),
    [anon_sym_GT_GT_GT] = ACTIONS(4339),
    [anon_sym_EQ_EQ] = ACTIONS(4339),
    [anon_sym_BANG_EQ] = ACTIONS(4339),
    [anon_sym_GT_EQ] = ACTIONS(4339),
    [anon_sym_LT_EQ] = ACTIONS(4339),
    [anon_sym_DOT] = ACTIONS(4343),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4343),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4339),
    [anon_sym_and] = ACTIONS(4347),
    [anon_sym_or] = ACTIONS(4347),
    [anon_sym_AMP_AMP] = ACTIONS(4339),
    [anon_sym_PIPE_PIPE] = ACTIONS(4339),
    [anon_sym_QMARK_QMARK] = ACTIONS(4339),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4343),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4343),
    [anon_sym_is] = ACTIONS(4343),
    [anon_sym_DASH_GT] = ACTIONS(4339),
    [anon_sym_with] = ACTIONS(4343),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3093] = {
    [sym_parameter_list] = STATE(9912),
    [sym__lambda_parameters] = STATE(9629),
    [sym_identifier] = STATE(9488),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3093),
    [sym_preproc_endregion] = STATE(3093),
    [sym_preproc_line] = STATE(3093),
    [sym_preproc_pragma] = STATE(3093),
    [sym_preproc_nullable] = STATE(3093),
    [sym_preproc_error] = STATE(3093),
    [sym_preproc_define] = STATE(3093),
    [sym_preproc_undef] = STATE(3093),
    [sym__identifier_token] = ACTIONS(4429),
    [anon_sym_alias] = ACTIONS(4429),
    [anon_sym_global] = ACTIONS(4429),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_file] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4429),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_notnull] = ACTIONS(4429),
    [anon_sym_unmanaged] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_scoped] = ACTIONS(4429),
    [anon_sym_var] = ACTIONS(4429),
    [anon_sym_yield] = ACTIONS(4429),
    [anon_sym_switch] = ACTIONS(4429),
    [anon_sym_when] = ACTIONS(4429),
    [sym_discard] = ACTIONS(4429),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4429),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4429),
    [anon_sym_into] = ACTIONS(4429),
    [anon_sym_join] = ACTIONS(4429),
    [anon_sym_on] = ACTIONS(4429),
    [anon_sym_equals] = ACTIONS(4429),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_orderby] = ACTIONS(4429),
    [anon_sym_ascending] = ACTIONS(4429),
    [anon_sym_descending] = ACTIONS(4429),
    [anon_sym_group] = ACTIONS(4429),
    [anon_sym_by] = ACTIONS(4429),
    [anon_sym_select] = ACTIONS(4429),
    [anon_sym_as] = ACTIONS(4429),
    [anon_sym_is] = ACTIONS(4429),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4431),
  },
  [3094] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9853),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3094),
    [sym_preproc_endregion] = STATE(3094),
    [sym_preproc_line] = STATE(3094),
    [sym_preproc_pragma] = STATE(3094),
    [sym_preproc_nullable] = STATE(3094),
    [sym_preproc_error] = STATE(3094),
    [sym_preproc_define] = STATE(3094),
    [sym_preproc_undef] = STATE(3094),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3095] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9531),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7113),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3095),
    [sym_preproc_endregion] = STATE(3095),
    [sym_preproc_line] = STATE(3095),
    [sym_preproc_pragma] = STATE(3095),
    [sym_preproc_nullable] = STATE(3095),
    [sym_preproc_error] = STATE(3095),
    [sym_preproc_define] = STATE(3095),
    [sym_preproc_undef] = STATE(3095),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3096] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9485),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3096),
    [sym_preproc_endregion] = STATE(3096),
    [sym_preproc_line] = STATE(3096),
    [sym_preproc_pragma] = STATE(3096),
    [sym_preproc_nullable] = STATE(3096),
    [sym_preproc_error] = STATE(3096),
    [sym_preproc_define] = STATE(3096),
    [sym_preproc_undef] = STATE(3096),
    [aux_sym_class_declaration_repeat2] = STATE(3097),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4733),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3097] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9175),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3097),
    [sym_preproc_endregion] = STATE(3097),
    [sym_preproc_line] = STATE(3097),
    [sym_preproc_pragma] = STATE(3097),
    [sym_preproc_nullable] = STATE(3097),
    [sym_preproc_error] = STATE(3097),
    [sym_preproc_define] = STATE(3097),
    [sym_preproc_undef] = STATE(3097),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3098] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9564),
    [sym__name] = STATE(6909),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6761),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3098),
    [sym_preproc_endregion] = STATE(3098),
    [sym_preproc_line] = STATE(3098),
    [sym_preproc_pragma] = STATE(3098),
    [sym_preproc_nullable] = STATE(3098),
    [sym_preproc_error] = STATE(3098),
    [sym_preproc_define] = STATE(3098),
    [sym_preproc_undef] = STATE(3098),
    [aux_sym_class_declaration_repeat2] = STATE(3116),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(4735),
    [anon_sym_static] = ACTIONS(4737),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3099] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9031),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3099),
    [sym_preproc_endregion] = STATE(3099),
    [sym_preproc_line] = STATE(3099),
    [sym_preproc_pragma] = STATE(3099),
    [sym_preproc_nullable] = STATE(3099),
    [sym_preproc_error] = STATE(3099),
    [sym_preproc_define] = STATE(3099),
    [sym_preproc_undef] = STATE(3099),
    [aux_sym_class_declaration_repeat2] = STATE(3104),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4741),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3100] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(5155),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3100),
    [sym_preproc_endregion] = STATE(3100),
    [sym_preproc_line] = STATE(3100),
    [sym_preproc_pragma] = STATE(3100),
    [sym_preproc_nullable] = STATE(3100),
    [sym_preproc_error] = STATE(3100),
    [sym_preproc_define] = STATE(3100),
    [sym_preproc_undef] = STATE(3100),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(4524),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3101] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9485),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3101),
    [sym_preproc_endregion] = STATE(3101),
    [sym_preproc_line] = STATE(3101),
    [sym_preproc_pragma] = STATE(3101),
    [sym_preproc_nullable] = STATE(3101),
    [sym_preproc_error] = STATE(3101),
    [sym_preproc_define] = STATE(3101),
    [sym_preproc_undef] = STATE(3101),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3102] = {
    [sym_property_pattern_clause] = STATE(3169),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3102),
    [sym_preproc_endregion] = STATE(3102),
    [sym_preproc_line] = STATE(3102),
    [sym_preproc_pragma] = STATE(3102),
    [sym_preproc_nullable] = STATE(3102),
    [sym_preproc_error] = STATE(3102),
    [sym_preproc_define] = STATE(3102),
    [sym_preproc_undef] = STATE(3102),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4397),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3103] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9087),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7044),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3103),
    [sym_preproc_endregion] = STATE(3103),
    [sym_preproc_line] = STATE(3103),
    [sym_preproc_pragma] = STATE(3103),
    [sym_preproc_nullable] = STATE(3103),
    [sym_preproc_error] = STATE(3103),
    [sym_preproc_define] = STATE(3103),
    [sym_preproc_undef] = STATE(3103),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3104] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9158),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3104),
    [sym_preproc_endregion] = STATE(3104),
    [sym_preproc_line] = STATE(3104),
    [sym_preproc_pragma] = STATE(3104),
    [sym_preproc_nullable] = STATE(3104),
    [sym_preproc_error] = STATE(3104),
    [sym_preproc_define] = STATE(3104),
    [sym_preproc_undef] = STATE(3104),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3105] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9564),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6998),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3105),
    [sym_preproc_endregion] = STATE(3105),
    [sym_preproc_line] = STATE(3105),
    [sym_preproc_pragma] = STATE(3105),
    [sym_preproc_nullable] = STATE(3105),
    [sym_preproc_error] = STATE(3105),
    [sym_preproc_define] = STATE(3105),
    [sym_preproc_undef] = STATE(3105),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3106] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9420),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3106),
    [sym_preproc_endregion] = STATE(3106),
    [sym_preproc_line] = STATE(3106),
    [sym_preproc_pragma] = STATE(3106),
    [sym_preproc_nullable] = STATE(3106),
    [sym_preproc_error] = STATE(3106),
    [sym_preproc_define] = STATE(3106),
    [sym_preproc_undef] = STATE(3106),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3107] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9531),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3107),
    [sym_preproc_endregion] = STATE(3107),
    [sym_preproc_line] = STATE(3107),
    [sym_preproc_pragma] = STATE(3107),
    [sym_preproc_nullable] = STATE(3107),
    [sym_preproc_error] = STATE(3107),
    [sym_preproc_define] = STATE(3107),
    [sym_preproc_undef] = STATE(3107),
    [aux_sym_class_declaration_repeat2] = STATE(3113),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3108] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9617),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3108),
    [sym_preproc_endregion] = STATE(3108),
    [sym_preproc_line] = STATE(3108),
    [sym_preproc_pragma] = STATE(3108),
    [sym_preproc_nullable] = STATE(3108),
    [sym_preproc_error] = STATE(3108),
    [sym_preproc_define] = STATE(3108),
    [sym_preproc_undef] = STATE(3108),
    [aux_sym_class_declaration_repeat2] = STATE(3110),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4745),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3109] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9031),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3109),
    [sym_preproc_endregion] = STATE(3109),
    [sym_preproc_line] = STATE(3109),
    [sym_preproc_pragma] = STATE(3109),
    [sym_preproc_nullable] = STATE(3109),
    [sym_preproc_error] = STATE(3109),
    [sym_preproc_define] = STATE(3109),
    [sym_preproc_undef] = STATE(3109),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3110] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9718),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3110),
    [sym_preproc_endregion] = STATE(3110),
    [sym_preproc_line] = STATE(3110),
    [sym_preproc_pragma] = STATE(3110),
    [sym_preproc_nullable] = STATE(3110),
    [sym_preproc_error] = STATE(3110),
    [sym_preproc_define] = STATE(3110),
    [sym_preproc_undef] = STATE(3110),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3111] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9564),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3111),
    [sym_preproc_endregion] = STATE(3111),
    [sym_preproc_line] = STATE(3111),
    [sym_preproc_pragma] = STATE(3111),
    [sym_preproc_nullable] = STATE(3111),
    [sym_preproc_error] = STATE(3111),
    [sym_preproc_define] = STATE(3111),
    [sym_preproc_undef] = STATE(3111),
    [aux_sym_class_declaration_repeat2] = STATE(3116),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3112] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9853),
    [sym__name] = STATE(6943),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6762),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3112),
    [sym_preproc_endregion] = STATE(3112),
    [sym_preproc_line] = STATE(3112),
    [sym_preproc_pragma] = STATE(3112),
    [sym_preproc_nullable] = STATE(3112),
    [sym_preproc_error] = STATE(3112),
    [sym_preproc_define] = STATE(3112),
    [sym_preproc_undef] = STATE(3112),
    [aux_sym_class_declaration_repeat2] = STATE(3101),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(4747),
    [anon_sym_static] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3113] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9617),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3113),
    [sym_preproc_endregion] = STATE(3113),
    [sym_preproc_line] = STATE(3113),
    [sym_preproc_pragma] = STATE(3113),
    [sym_preproc_nullable] = STATE(3113),
    [sym_preproc_error] = STATE(3113),
    [sym_preproc_define] = STATE(3113),
    [sym_preproc_undef] = STATE(3113),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3114] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9853),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6974),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3114),
    [sym_preproc_endregion] = STATE(3114),
    [sym_preproc_line] = STATE(3114),
    [sym_preproc_pragma] = STATE(3114),
    [sym_preproc_nullable] = STATE(3114),
    [sym_preproc_error] = STATE(3114),
    [sym_preproc_define] = STATE(3114),
    [sym_preproc_undef] = STATE(3114),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3115] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9507),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3115),
    [sym_preproc_endregion] = STATE(3115),
    [sym_preproc_line] = STATE(3115),
    [sym_preproc_pragma] = STATE(3115),
    [sym_preproc_nullable] = STATE(3115),
    [sym_preproc_error] = STATE(3115),
    [sym_preproc_define] = STATE(3115),
    [sym_preproc_undef] = STATE(3115),
    [aux_sym_class_declaration_repeat2] = STATE(3106),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4751),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3116] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9507),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3116),
    [sym_preproc_endregion] = STATE(3116),
    [sym_preproc_line] = STATE(3116),
    [sym_preproc_pragma] = STATE(3116),
    [sym_preproc_nullable] = STATE(3116),
    [sym_preproc_error] = STATE(3116),
    [sym_preproc_define] = STATE(3116),
    [sym_preproc_undef] = STATE(3116),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3117] = {
    [sym_modifier] = STATE(4685),
    [sym_variable_declaration] = STATE(9087),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7059),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3117),
    [sym_preproc_endregion] = STATE(3117),
    [sym_preproc_line] = STATE(3117),
    [sym_preproc_pragma] = STATE(3117),
    [sym_preproc_nullable] = STATE(3117),
    [sym_preproc_error] = STATE(3117),
    [sym_preproc_define] = STATE(3117),
    [sym_preproc_undef] = STATE(3117),
    [aux_sym_class_declaration_repeat2] = STATE(3109),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(4753),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4514),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3118] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3118),
    [sym_preproc_endregion] = STATE(3118),
    [sym_preproc_line] = STATE(3118),
    [sym_preproc_pragma] = STATE(3118),
    [sym_preproc_nullable] = STATE(3118),
    [sym_preproc_error] = STATE(3118),
    [sym_preproc_define] = STATE(3118),
    [sym_preproc_undef] = STATE(3118),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(4524),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3119] = {
    [sym_property_pattern_clause] = STATE(3166),
    [sym__variable_designation] = STATE(4019),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3119),
    [sym_preproc_endregion] = STATE(3119),
    [sym_preproc_line] = STATE(3119),
    [sym_preproc_pragma] = STATE(3119),
    [sym_preproc_nullable] = STATE(3119),
    [sym_preproc_error] = STATE(3119),
    [sym_preproc_define] = STATE(3119),
    [sym_preproc_undef] = STATE(3119),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4405),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3120] = {
    [sym_property_pattern_clause] = STATE(3167),
    [sym__variable_designation] = STATE(4058),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3120),
    [sym_preproc_endregion] = STATE(3120),
    [sym_preproc_line] = STATE(3120),
    [sym_preproc_pragma] = STATE(3120),
    [sym_preproc_nullable] = STATE(3120),
    [sym_preproc_error] = STATE(3120),
    [sym_preproc_define] = STATE(3120),
    [sym_preproc_undef] = STATE(3120),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4397),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3121] = {
    [sym_property_pattern_clause] = STATE(3164),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3121),
    [sym_preproc_endregion] = STATE(3121),
    [sym_preproc_line] = STATE(3121),
    [sym_preproc_pragma] = STATE(3121),
    [sym_preproc_nullable] = STATE(3121),
    [sym_preproc_error] = STATE(3121),
    [sym_preproc_define] = STATE(3121),
    [sym_preproc_undef] = STATE(3121),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4405),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3122] = {
    [sym_modifier] = STATE(4685),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7309),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3122),
    [sym_preproc_endregion] = STATE(3122),
    [sym_preproc_line] = STATE(3122),
    [sym_preproc_pragma] = STATE(3122),
    [sym_preproc_nullable] = STATE(3122),
    [sym_preproc_error] = STATE(3122),
    [sym_preproc_define] = STATE(3122),
    [sym_preproc_undef] = STATE(3122),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4755),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3123] = {
    [sym_property_pattern_clause] = STATE(3190),
    [sym__variable_designation] = STATE(4565),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3123),
    [sym_preproc_endregion] = STATE(3123),
    [sym_preproc_line] = STATE(3123),
    [sym_preproc_pragma] = STATE(3123),
    [sym_preproc_nullable] = STATE(3123),
    [sym_preproc_error] = STATE(3123),
    [sym_preproc_define] = STATE(3123),
    [sym_preproc_undef] = STATE(3123),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4405),
    [anon_sym_descending] = ACTIONS(4405),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3124] = {
    [sym_modifier] = STATE(4685),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7307),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3124),
    [sym_preproc_endregion] = STATE(3124),
    [sym_preproc_line] = STATE(3124),
    [sym_preproc_pragma] = STATE(3124),
    [sym_preproc_nullable] = STATE(3124),
    [sym_preproc_error] = STATE(3124),
    [sym_preproc_define] = STATE(3124),
    [sym_preproc_undef] = STATE(3124),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4755),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3125] = {
    [sym_modifier] = STATE(4685),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7323),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3125),
    [sym_preproc_endregion] = STATE(3125),
    [sym_preproc_line] = STATE(3125),
    [sym_preproc_pragma] = STATE(3125),
    [sym_preproc_nullable] = STATE(3125),
    [sym_preproc_error] = STATE(3125),
    [sym_preproc_define] = STATE(3125),
    [sym_preproc_undef] = STATE(3125),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4755),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3126] = {
    [sym__variable_designation] = STATE(5558),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3126),
    [sym_preproc_endregion] = STATE(3126),
    [sym_preproc_line] = STATE(3126),
    [sym_preproc_pragma] = STATE(3126),
    [sym_preproc_nullable] = STATE(3126),
    [sym_preproc_error] = STATE(3126),
    [sym_preproc_define] = STATE(3126),
    [sym_preproc_undef] = STATE(3126),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4403),
  },
  [3127] = {
    [sym_type_argument_list] = STATE(2957),
    [sym_preproc_region] = STATE(3127),
    [sym_preproc_endregion] = STATE(3127),
    [sym_preproc_line] = STATE(3127),
    [sym_preproc_pragma] = STATE(3127),
    [sym_preproc_nullable] = STATE(3127),
    [sym_preproc_error] = STATE(3127),
    [sym_preproc_define] = STATE(3127),
    [sym_preproc_undef] = STATE(3127),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4504),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_COLON_COLON] = ACTIONS(4254),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3128] = {
    [sym_modifier] = STATE(4685),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7313),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3128),
    [sym_preproc_endregion] = STATE(3128),
    [sym_preproc_line] = STATE(3128),
    [sym_preproc_pragma] = STATE(3128),
    [sym_preproc_nullable] = STATE(3128),
    [sym_preproc_error] = STATE(3128),
    [sym_preproc_define] = STATE(3128),
    [sym_preproc_undef] = STATE(3128),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(659),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_unsafe] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_async] = ACTIONS(659),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_file] = ACTIONS(4755),
    [anon_sym_fixed] = ACTIONS(659),
    [anon_sym_internal] = ACTIONS(659),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_override] = ACTIONS(659),
    [anon_sym_partial] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_readonly] = ACTIONS(659),
    [anon_sym_required] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_virtual] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3129] = {
    [sym_property_pattern_clause] = STATE(3188),
    [sym__variable_designation] = STATE(4584),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3129),
    [sym_preproc_endregion] = STATE(3129),
    [sym_preproc_line] = STATE(3129),
    [sym_preproc_pragma] = STATE(3129),
    [sym_preproc_nullable] = STATE(3129),
    [sym_preproc_error] = STATE(3129),
    [sym_preproc_define] = STATE(3129),
    [sym_preproc_undef] = STATE(3129),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4397),
    [anon_sym_descending] = ACTIONS(4397),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3130] = {
    [sym__variable_designation] = STATE(5577),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3130),
    [sym_preproc_endregion] = STATE(3130),
    [sym_preproc_line] = STATE(3130),
    [sym_preproc_pragma] = STATE(3130),
    [sym_preproc_nullable] = STATE(3130),
    [sym_preproc_error] = STATE(3130),
    [sym_preproc_define] = STATE(3130),
    [sym_preproc_undef] = STATE(3130),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4395),
  },
  [3131] = {
    [sym__variable_designation] = STATE(5552),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3131),
    [sym_preproc_endregion] = STATE(3131),
    [sym_preproc_line] = STATE(3131),
    [sym_preproc_pragma] = STATE(3131),
    [sym_preproc_nullable] = STATE(3131),
    [sym_preproc_error] = STATE(3131),
    [sym_preproc_define] = STATE(3131),
    [sym_preproc_undef] = STATE(3131),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4433),
  },
  [3132] = {
    [sym__variable_designation] = STATE(5556),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3132),
    [sym_preproc_endregion] = STATE(3132),
    [sym_preproc_line] = STATE(3132),
    [sym_preproc_pragma] = STATE(3132),
    [sym_preproc_nullable] = STATE(3132),
    [sym_preproc_error] = STATE(3132),
    [sym_preproc_define] = STATE(3132),
    [sym_preproc_undef] = STATE(3132),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4443),
  },
  [3133] = {
    [sym__variable_designation] = STATE(5558),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3133),
    [sym_preproc_endregion] = STATE(3133),
    [sym_preproc_line] = STATE(3133),
    [sym_preproc_pragma] = STATE(3133),
    [sym_preproc_nullable] = STATE(3133),
    [sym_preproc_error] = STATE(3133),
    [sym_preproc_define] = STATE(3133),
    [sym_preproc_undef] = STATE(3133),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4403),
  },
  [3134] = {
    [sym__variable_designation] = STATE(5577),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3134),
    [sym_preproc_endregion] = STATE(3134),
    [sym_preproc_line] = STATE(3134),
    [sym_preproc_pragma] = STATE(3134),
    [sym_preproc_nullable] = STATE(3134),
    [sym_preproc_error] = STATE(3134),
    [sym_preproc_define] = STATE(3134),
    [sym_preproc_undef] = STATE(3134),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4549),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4395),
  },
  [3135] = {
    [sym__variable_designation] = STATE(5556),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3135),
    [sym_preproc_endregion] = STATE(3135),
    [sym_preproc_line] = STATE(3135),
    [sym_preproc_pragma] = STATE(3135),
    [sym_preproc_nullable] = STATE(3135),
    [sym_preproc_error] = STATE(3135),
    [sym_preproc_define] = STATE(3135),
    [sym_preproc_undef] = STATE(3135),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4443),
  },
  [3136] = {
    [sym_property_pattern_clause] = STATE(3202),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3136),
    [sym_preproc_endregion] = STATE(3136),
    [sym_preproc_line] = STATE(3136),
    [sym_preproc_pragma] = STATE(3136),
    [sym_preproc_nullable] = STATE(3136),
    [sym_preproc_error] = STATE(3136),
    [sym_preproc_define] = STATE(3136),
    [sym_preproc_undef] = STATE(3136),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_in] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3137] = {
    [sym_property_pattern_clause] = STATE(3208),
    [sym__variable_designation] = STATE(4584),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3137),
    [sym_preproc_endregion] = STATE(3137),
    [sym_preproc_line] = STATE(3137),
    [sym_preproc_pragma] = STATE(3137),
    [sym_preproc_nullable] = STATE(3137),
    [sym_preproc_error] = STATE(3137),
    [sym_preproc_define] = STATE(3137),
    [sym_preproc_undef] = STATE(3137),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4397),
    [anon_sym_descending] = ACTIONS(4397),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3138] = {
    [sym__variable_designation] = STATE(5552),
    [sym_parenthesized_variable_designation] = STATE(5585),
    [sym_identifier] = STATE(5583),
    [sym__reserved_identifier] = STATE(5210),
    [sym_preproc_region] = STATE(3138),
    [sym_preproc_endregion] = STATE(3138),
    [sym_preproc_line] = STATE(3138),
    [sym_preproc_pragma] = STATE(3138),
    [sym_preproc_nullable] = STATE(3138),
    [sym_preproc_error] = STATE(3138),
    [sym_preproc_define] = STATE(3138),
    [sym_preproc_undef] = STATE(3138),
    [sym__identifier_token] = ACTIONS(4547),
    [anon_sym_alias] = ACTIONS(4549),
    [anon_sym_global] = ACTIONS(4549),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4549),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4549),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4549),
    [anon_sym_unmanaged] = ACTIONS(4549),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4549),
    [anon_sym_var] = ACTIONS(4549),
    [anon_sym_yield] = ACTIONS(4549),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4549),
    [sym_discard] = ACTIONS(4553),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4549),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4549),
    [anon_sym_on] = ACTIONS(4549),
    [anon_sym_equals] = ACTIONS(4549),
    [anon_sym_let] = ACTIONS(4549),
    [anon_sym_orderby] = ACTIONS(4549),
    [anon_sym_ascending] = ACTIONS(4549),
    [anon_sym_descending] = ACTIONS(4549),
    [anon_sym_group] = ACTIONS(4549),
    [anon_sym_by] = ACTIONS(4549),
    [anon_sym_select] = ACTIONS(4549),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4433),
  },
  [3139] = {
    [sym_property_pattern_clause] = STATE(3175),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3139),
    [sym_preproc_endregion] = STATE(3139),
    [sym_preproc_line] = STATE(3139),
    [sym_preproc_pragma] = STATE(3139),
    [sym_preproc_nullable] = STATE(3139),
    [sym_preproc_error] = STATE(3139),
    [sym_preproc_define] = STATE(3139),
    [sym_preproc_undef] = STATE(3139),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_in] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3140] = {
    [sym_property_pattern_clause] = STATE(3189),
    [sym__variable_designation] = STATE(4565),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3140),
    [sym_preproc_endregion] = STATE(3140),
    [sym_preproc_line] = STATE(3140),
    [sym_preproc_pragma] = STATE(3140),
    [sym_preproc_nullable] = STATE(3140),
    [sym_preproc_error] = STATE(3140),
    [sym_preproc_define] = STATE(3140),
    [sym_preproc_undef] = STATE(3140),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4405),
    [anon_sym_descending] = ACTIONS(4405),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3141] = {
    [sym_property_pattern_clause] = STATE(3269),
    [sym__variable_designation] = STATE(4058),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3141),
    [sym_preproc_endregion] = STATE(3141),
    [sym_preproc_line] = STATE(3141),
    [sym_preproc_pragma] = STATE(3141),
    [sym_preproc_nullable] = STATE(3141),
    [sym_preproc_error] = STATE(3141),
    [sym_preproc_define] = STATE(3141),
    [sym_preproc_undef] = STATE(3141),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4397),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3142] = {
    [sym_preproc_region] = STATE(3142),
    [sym_preproc_endregion] = STATE(3142),
    [sym_preproc_line] = STATE(3142),
    [sym_preproc_pragma] = STATE(3142),
    [sym_preproc_nullable] = STATE(3142),
    [sym_preproc_error] = STATE(3142),
    [sym_preproc_define] = STATE(3142),
    [sym_preproc_undef] = STATE(3142),
    [sym__identifier_token] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_alias] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3361),
    [anon_sym_unsafe] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_LPAREN] = ACTIONS(3363),
    [anon_sym_event] = ACTIONS(3361),
    [anon_sym_namespace] = ACTIONS(3361),
    [anon_sym_class] = ACTIONS(3361),
    [anon_sym_ref] = ACTIONS(3361),
    [anon_sym_struct] = ACTIONS(3361),
    [anon_sym_enum] = ACTIONS(3361),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_interface] = ACTIONS(3361),
    [anon_sym_delegate] = ACTIONS(3361),
    [anon_sym_record] = ACTIONS(3361),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_file] = ACTIONS(3361),
    [anon_sym_fixed] = ACTIONS(3361),
    [anon_sym_internal] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_partial] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_required] = ACTIONS(3361),
    [anon_sym_sealed] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_where] = ACTIONS(3361),
    [anon_sym_notnull] = ACTIONS(3361),
    [anon_sym_unmanaged] = ACTIONS(3361),
    [anon_sym_TILDE] = ACTIONS(3363),
    [anon_sym_implicit] = ACTIONS(3361),
    [anon_sym_explicit] = ACTIONS(3361),
    [anon_sym_scoped] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [sym_predefined_type] = ACTIONS(3361),
    [anon_sym_while] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_when] = ACTIONS(3361),
    [anon_sym_else] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3361),
    [anon_sym_into] = ACTIONS(3361),
    [anon_sym_join] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [anon_sym_equals] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_orderby] = ACTIONS(3361),
    [anon_sym_ascending] = ACTIONS(3361),
    [anon_sym_descending] = ACTIONS(3361),
    [anon_sym_group] = ACTIONS(3361),
    [anon_sym_by] = ACTIONS(3361),
    [anon_sym_select] = ACTIONS(3361),
    [aux_sym_preproc_if_token1] = ACTIONS(3363),
    [aux_sym_preproc_if_token3] = ACTIONS(3363),
    [aux_sym_preproc_else_token1] = ACTIONS(3363),
    [aux_sym_preproc_elif_token1] = ACTIONS(3363),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3143] = {
    [sym_property_pattern_clause] = STATE(3294),
    [sym__variable_designation] = STATE(5008),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3143),
    [sym_preproc_endregion] = STATE(3143),
    [sym_preproc_line] = STATE(3143),
    [sym_preproc_pragma] = STATE(3143),
    [sym_preproc_nullable] = STATE(3143),
    [sym_preproc_error] = STATE(3143),
    [sym_preproc_define] = STATE(3143),
    [sym_preproc_undef] = STATE(3143),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3144] = {
    [sym_type_argument_list] = STATE(3195),
    [sym_preproc_region] = STATE(3144),
    [sym_preproc_endregion] = STATE(3144),
    [sym_preproc_line] = STATE(3144),
    [sym_preproc_pragma] = STATE(3144),
    [sym_preproc_nullable] = STATE(3144),
    [sym_preproc_error] = STATE(3144),
    [sym_preproc_define] = STATE(3144),
    [sym_preproc_undef] = STATE(3144),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3145] = {
    [sym_preproc_region] = STATE(3145),
    [sym_preproc_endregion] = STATE(3145),
    [sym_preproc_line] = STATE(3145),
    [sym_preproc_pragma] = STATE(3145),
    [sym_preproc_nullable] = STATE(3145),
    [sym_preproc_error] = STATE(3145),
    [sym_preproc_define] = STATE(3145),
    [sym_preproc_undef] = STATE(3145),
    [sym__identifier_token] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3365),
    [anon_sym_alias] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3365),
    [anon_sym_using] = ACTIONS(3365),
    [anon_sym_unsafe] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_event] = ACTIONS(3365),
    [anon_sym_namespace] = ACTIONS(3365),
    [anon_sym_class] = ACTIONS(3365),
    [anon_sym_ref] = ACTIONS(3365),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_enum] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_interface] = ACTIONS(3365),
    [anon_sym_delegate] = ACTIONS(3365),
    [anon_sym_record] = ACTIONS(3365),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_file] = ACTIONS(3365),
    [anon_sym_fixed] = ACTIONS(3365),
    [anon_sym_internal] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_partial] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_required] = ACTIONS(3365),
    [anon_sym_sealed] = ACTIONS(3365),
    [anon_sym_virtual] = ACTIONS(3365),
    [anon_sym_volatile] = ACTIONS(3365),
    [anon_sym_where] = ACTIONS(3365),
    [anon_sym_notnull] = ACTIONS(3365),
    [anon_sym_unmanaged] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3367),
    [anon_sym_implicit] = ACTIONS(3365),
    [anon_sym_explicit] = ACTIONS(3365),
    [anon_sym_scoped] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [sym_predefined_type] = ACTIONS(3365),
    [anon_sym_while] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_when] = ACTIONS(3365),
    [anon_sym_else] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3365),
    [anon_sym_into] = ACTIONS(3365),
    [anon_sym_join] = ACTIONS(3365),
    [anon_sym_on] = ACTIONS(3365),
    [anon_sym_equals] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_orderby] = ACTIONS(3365),
    [anon_sym_ascending] = ACTIONS(3365),
    [anon_sym_descending] = ACTIONS(3365),
    [anon_sym_group] = ACTIONS(3365),
    [anon_sym_by] = ACTIONS(3365),
    [anon_sym_select] = ACTIONS(3365),
    [aux_sym_preproc_if_token1] = ACTIONS(3367),
    [aux_sym_preproc_if_token3] = ACTIONS(3367),
    [aux_sym_preproc_else_token1] = ACTIONS(3367),
    [aux_sym_preproc_elif_token1] = ACTIONS(3367),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3146] = {
    [sym_property_pattern_clause] = STATE(3271),
    [sym__variable_designation] = STATE(4019),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3146),
    [sym_preproc_endregion] = STATE(3146),
    [sym_preproc_line] = STATE(3146),
    [sym_preproc_pragma] = STATE(3146),
    [sym_preproc_nullable] = STATE(3146),
    [sym_preproc_error] = STATE(3146),
    [sym_preproc_define] = STATE(3146),
    [sym_preproc_undef] = STATE(3146),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4405),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3147] = {
    [sym_property_pattern_clause] = STATE(3240),
    [sym__variable_designation] = STATE(4019),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3147),
    [sym_preproc_endregion] = STATE(3147),
    [sym_preproc_line] = STATE(3147),
    [sym_preproc_pragma] = STATE(3147),
    [sym_preproc_nullable] = STATE(3147),
    [sym_preproc_error] = STATE(3147),
    [sym_preproc_define] = STATE(3147),
    [sym_preproc_undef] = STATE(3147),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4405),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3148] = {
    [sym_property_pattern_clause] = STATE(3450),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3148),
    [sym_preproc_endregion] = STATE(3148),
    [sym_preproc_line] = STATE(3148),
    [sym_preproc_pragma] = STATE(3148),
    [sym_preproc_nullable] = STATE(3148),
    [sym_preproc_error] = STATE(3148),
    [sym_preproc_define] = STATE(3148),
    [sym_preproc_undef] = STATE(3148),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4405),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3149] = {
    [sym_property_pattern_clause] = STATE(3297),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3149),
    [sym_preproc_endregion] = STATE(3149),
    [sym_preproc_line] = STATE(3149),
    [sym_preproc_pragma] = STATE(3149),
    [sym_preproc_nullable] = STATE(3149),
    [sym_preproc_error] = STATE(3149),
    [sym_preproc_define] = STATE(3149),
    [sym_preproc_undef] = STATE(3149),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4405),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3150] = {
    [sym_preproc_region] = STATE(3150),
    [sym_preproc_endregion] = STATE(3150),
    [sym_preproc_line] = STATE(3150),
    [sym_preproc_pragma] = STATE(3150),
    [sym_preproc_nullable] = STATE(3150),
    [sym_preproc_error] = STATE(3150),
    [sym_preproc_define] = STATE(3150),
    [sym_preproc_undef] = STATE(3150),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4122),
    [anon_sym_where] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_when] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3151] = {
    [sym_property_pattern_clause] = STATE(3298),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3151),
    [sym_preproc_endregion] = STATE(3151),
    [sym_preproc_line] = STATE(3151),
    [sym_preproc_pragma] = STATE(3151),
    [sym_preproc_nullable] = STATE(3151),
    [sym_preproc_error] = STATE(3151),
    [sym_preproc_define] = STATE(3151),
    [sym_preproc_undef] = STATE(3151),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4397),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3152] = {
    [sym_type_argument_list] = STATE(3370),
    [sym_preproc_region] = STATE(3152),
    [sym_preproc_endregion] = STATE(3152),
    [sym_preproc_line] = STATE(3152),
    [sym_preproc_pragma] = STATE(3152),
    [sym_preproc_nullable] = STATE(3152),
    [sym_preproc_error] = STATE(3152),
    [sym_preproc_define] = STATE(3152),
    [sym_preproc_undef] = STATE(3152),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4760),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_COLON_COLON] = ACTIONS(4325),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [3153] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3153),
    [sym_preproc_endregion] = STATE(3153),
    [sym_preproc_line] = STATE(3153),
    [sym_preproc_pragma] = STATE(3153),
    [sym_preproc_nullable] = STATE(3153),
    [sym_preproc_error] = STATE(3153),
    [sym_preproc_define] = STATE(3153),
    [sym_preproc_undef] = STATE(3153),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4397),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3154] = {
    [sym_preproc_region] = STATE(3154),
    [sym_preproc_endregion] = STATE(3154),
    [sym_preproc_line] = STATE(3154),
    [sym_preproc_pragma] = STATE(3154),
    [sym_preproc_nullable] = STATE(3154),
    [sym_preproc_error] = STATE(3154),
    [sym_preproc_define] = STATE(3154),
    [sym_preproc_undef] = STATE(3154),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4763),
    [anon_sym_COMMA] = ACTIONS(4666),
    [anon_sym_RBRACK] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_EQ_GT] = ACTIONS(4666),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4765),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4765),
    [anon_sym_is] = ACTIONS(4765),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4765),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3155] = {
    [sym_preproc_region] = STATE(3155),
    [sym_preproc_endregion] = STATE(3155),
    [sym_preproc_line] = STATE(3155),
    [sym_preproc_pragma] = STATE(3155),
    [sym_preproc_nullable] = STATE(3155),
    [sym_preproc_error] = STATE(3155),
    [sym_preproc_define] = STATE(3155),
    [sym_preproc_undef] = STATE(3155),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(4670),
    [anon_sym_RBRACK] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_EQ_GT] = ACTIONS(4670),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3156] = {
    [sym_property_pattern_clause] = STATE(3270),
    [sym__variable_designation] = STATE(4195),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3156),
    [sym_preproc_endregion] = STATE(3156),
    [sym_preproc_line] = STATE(3156),
    [sym_preproc_pragma] = STATE(3156),
    [sym_preproc_nullable] = STATE(3156),
    [sym_preproc_error] = STATE(3156),
    [sym_preproc_define] = STATE(3156),
    [sym_preproc_undef] = STATE(3156),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4405),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3157] = {
    [sym_property_pattern_clause] = STATE(3242),
    [sym__variable_designation] = STATE(4058),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3157),
    [sym_preproc_endregion] = STATE(3157),
    [sym_preproc_line] = STATE(3157),
    [sym_preproc_pragma] = STATE(3157),
    [sym_preproc_nullable] = STATE(3157),
    [sym_preproc_error] = STATE(3157),
    [sym_preproc_define] = STATE(3157),
    [sym_preproc_undef] = STATE(3157),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4397),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3158] = {
    [sym_property_pattern_clause] = STATE(3261),
    [sym__variable_designation] = STATE(4019),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3158),
    [sym_preproc_endregion] = STATE(3158),
    [sym_preproc_line] = STATE(3158),
    [sym_preproc_pragma] = STATE(3158),
    [sym_preproc_nullable] = STATE(3158),
    [sym_preproc_error] = STATE(3158),
    [sym_preproc_define] = STATE(3158),
    [sym_preproc_undef] = STATE(3158),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4405),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3159] = {
    [sym_property_pattern_clause] = STATE(3462),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3159),
    [sym_preproc_endregion] = STATE(3159),
    [sym_preproc_line] = STATE(3159),
    [sym_preproc_pragma] = STATE(3159),
    [sym_preproc_nullable] = STATE(3159),
    [sym_preproc_error] = STATE(3159),
    [sym_preproc_define] = STATE(3159),
    [sym_preproc_undef] = STATE(3159),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4397),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3160] = {
    [sym_property_pattern_clause] = STATE(3342),
    [sym__variable_designation] = STATE(4986),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3160),
    [sym_preproc_endregion] = STATE(3160),
    [sym_preproc_line] = STATE(3160),
    [sym_preproc_pragma] = STATE(3160),
    [sym_preproc_nullable] = STATE(3160),
    [sym_preproc_error] = STATE(3160),
    [sym_preproc_define] = STATE(3160),
    [sym_preproc_undef] = STATE(3160),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3161] = {
    [sym_property_pattern_clause] = STATE(3324),
    [sym__variable_designation] = STATE(4986),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3161),
    [sym_preproc_endregion] = STATE(3161),
    [sym_preproc_line] = STATE(3161),
    [sym_preproc_pragma] = STATE(3161),
    [sym_preproc_nullable] = STATE(3161),
    [sym_preproc_error] = STATE(3161),
    [sym_preproc_define] = STATE(3161),
    [sym_preproc_undef] = STATE(3161),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3162] = {
    [sym_property_pattern_clause] = STATE(3259),
    [sym__variable_designation] = STATE(4058),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3162),
    [sym_preproc_endregion] = STATE(3162),
    [sym_preproc_line] = STATE(3162),
    [sym_preproc_pragma] = STATE(3162),
    [sym_preproc_nullable] = STATE(3162),
    [sym_preproc_error] = STATE(3162),
    [sym_preproc_define] = STATE(3162),
    [sym_preproc_undef] = STATE(3162),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4397),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3163] = {
    [sym_property_pattern_clause] = STATE(3326),
    [sym__variable_designation] = STATE(5008),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3163),
    [sym_preproc_endregion] = STATE(3163),
    [sym_preproc_line] = STATE(3163),
    [sym_preproc_pragma] = STATE(3163),
    [sym_preproc_nullable] = STATE(3163),
    [sym_preproc_error] = STATE(3163),
    [sym_preproc_define] = STATE(3163),
    [sym_preproc_undef] = STATE(3163),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3164] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3164),
    [sym_preproc_endregion] = STATE(3164),
    [sym_preproc_line] = STATE(3164),
    [sym_preproc_pragma] = STATE(3164),
    [sym_preproc_nullable] = STATE(3164),
    [sym_preproc_error] = STATE(3164),
    [sym_preproc_define] = STATE(3164),
    [sym_preproc_undef] = STATE(3164),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4433),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4435),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3165] = {
    [sym_preproc_region] = STATE(3165),
    [sym_preproc_endregion] = STATE(3165),
    [sym_preproc_line] = STATE(3165),
    [sym_preproc_pragma] = STATE(3165),
    [sym_preproc_nullable] = STATE(3165),
    [sym_preproc_error] = STATE(3165),
    [sym_preproc_define] = STATE(3165),
    [sym_preproc_undef] = STATE(3165),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3166] = {
    [sym__variable_designation] = STATE(3999),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3166),
    [sym_preproc_endregion] = STATE(3166),
    [sym_preproc_line] = STATE(3166),
    [sym_preproc_pragma] = STATE(3166),
    [sym_preproc_nullable] = STATE(3166),
    [sym_preproc_error] = STATE(3166),
    [sym_preproc_define] = STATE(3166),
    [sym_preproc_undef] = STATE(3166),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4433),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4435),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3167] = {
    [sym__variable_designation] = STATE(4008),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3167),
    [sym_preproc_endregion] = STATE(3167),
    [sym_preproc_line] = STATE(3167),
    [sym_preproc_pragma] = STATE(3167),
    [sym_preproc_nullable] = STATE(3167),
    [sym_preproc_error] = STATE(3167),
    [sym_preproc_define] = STATE(3167),
    [sym_preproc_undef] = STATE(3167),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4443),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4445),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3168] = {
    [sym__variable_designation] = STATE(4018),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3168),
    [sym_preproc_endregion] = STATE(3168),
    [sym_preproc_line] = STATE(3168),
    [sym_preproc_pragma] = STATE(3168),
    [sym_preproc_nullable] = STATE(3168),
    [sym_preproc_error] = STATE(3168),
    [sym_preproc_define] = STATE(3168),
    [sym_preproc_undef] = STATE(3168),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4405),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3169] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3169),
    [sym_preproc_endregion] = STATE(3169),
    [sym_preproc_line] = STATE(3169),
    [sym_preproc_pragma] = STATE(3169),
    [sym_preproc_nullable] = STATE(3169),
    [sym_preproc_error] = STATE(3169),
    [sym_preproc_define] = STATE(3169),
    [sym_preproc_undef] = STATE(3169),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COLON] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4443),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4445),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3170] = {
    [sym_preproc_region] = STATE(3170),
    [sym_preproc_endregion] = STATE(3170),
    [sym_preproc_line] = STATE(3170),
    [sym_preproc_pragma] = STATE(3170),
    [sym_preproc_nullable] = STATE(3170),
    [sym_preproc_error] = STATE(3170),
    [sym_preproc_define] = STATE(3170),
    [sym_preproc_undef] = STATE(3170),
    [sym__identifier_token] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym_alias] = ACTIONS(3103),
    [anon_sym_global] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3103),
    [anon_sym_unsafe] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_event] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_ref] = ACTIONS(3103),
    [anon_sym_struct] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_interface] = ACTIONS(3103),
    [anon_sym_delegate] = ACTIONS(3103),
    [anon_sym_record] = ACTIONS(3103),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_file] = ACTIONS(3103),
    [anon_sym_fixed] = ACTIONS(3103),
    [anon_sym_internal] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_partial] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_required] = ACTIONS(3103),
    [anon_sym_sealed] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_where] = ACTIONS(3103),
    [anon_sym_notnull] = ACTIONS(3103),
    [anon_sym_unmanaged] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_implicit] = ACTIONS(3103),
    [anon_sym_explicit] = ACTIONS(3103),
    [anon_sym_scoped] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [sym_predefined_type] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_when] = ACTIONS(3103),
    [anon_sym_else] = ACTIONS(3103),
    [anon_sym_from] = ACTIONS(3103),
    [anon_sym_into] = ACTIONS(3103),
    [anon_sym_join] = ACTIONS(3103),
    [anon_sym_on] = ACTIONS(3103),
    [anon_sym_equals] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_orderby] = ACTIONS(3103),
    [anon_sym_ascending] = ACTIONS(3103),
    [anon_sym_descending] = ACTIONS(3103),
    [anon_sym_group] = ACTIONS(3103),
    [anon_sym_by] = ACTIONS(3103),
    [anon_sym_select] = ACTIONS(3103),
    [aux_sym_preproc_if_token1] = ACTIONS(3105),
    [aux_sym_preproc_if_token3] = ACTIONS(3105),
    [aux_sym_preproc_else_token1] = ACTIONS(3105),
    [aux_sym_preproc_elif_token1] = ACTIONS(3105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3171] = {
    [sym__variable_designation] = STATE(4055),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3171),
    [sym_preproc_endregion] = STATE(3171),
    [sym_preproc_line] = STATE(3171),
    [sym_preproc_pragma] = STATE(3171),
    [sym_preproc_nullable] = STATE(3171),
    [sym_preproc_error] = STATE(3171),
    [sym_preproc_define] = STATE(3171),
    [sym_preproc_undef] = STATE(3171),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COLON] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4395),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4397),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3172] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3172),
    [sym_preproc_endregion] = STATE(3172),
    [sym_preproc_line] = STATE(3172),
    [sym_preproc_pragma] = STATE(3172),
    [sym_preproc_nullable] = STATE(3172),
    [sym_preproc_error] = STATE(3172),
    [sym_preproc_define] = STATE(3172),
    [sym_preproc_undef] = STATE(3172),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COLON] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_EQ_GT] = ACTIONS(4403),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4405),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3173] = {
    [sym_property_pattern_clause] = STATE(3272),
    [sym__variable_designation] = STATE(4214),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3173),
    [sym_preproc_endregion] = STATE(3173),
    [sym_preproc_line] = STATE(3173),
    [sym_preproc_pragma] = STATE(3173),
    [sym_preproc_nullable] = STATE(3173),
    [sym_preproc_error] = STATE(3173),
    [sym_preproc_define] = STATE(3173),
    [sym_preproc_undef] = STATE(3173),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_LBRACE] = ACTIONS(4341),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4397),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3174] = {
    [sym_preproc_region] = STATE(3174),
    [sym_preproc_endregion] = STATE(3174),
    [sym_preproc_line] = STATE(3174),
    [sym_preproc_pragma] = STATE(3174),
    [sym_preproc_nullable] = STATE(3174),
    [sym_preproc_error] = STATE(3174),
    [sym_preproc_define] = STATE(3174),
    [sym_preproc_undef] = STATE(3174),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_COMMA] = ACTIONS(4644),
    [anon_sym_RBRACK] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_LBRACE] = ACTIONS(4644),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_LT] = ACTIONS(4646),
    [anon_sym_GT] = ACTIONS(4646),
    [anon_sym_in] = ACTIONS(4644),
    [anon_sym_QMARK] = ACTIONS(4646),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_STAR] = ACTIONS(4646),
    [anon_sym_SLASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4646),
    [anon_sym_AMP] = ACTIONS(4646),
    [anon_sym_LT_LT] = ACTIONS(4646),
    [anon_sym_GT_GT] = ACTIONS(4646),
    [anon_sym_GT_GT_GT] = ACTIONS(4646),
    [anon_sym_EQ_EQ] = ACTIONS(4644),
    [anon_sym_BANG_EQ] = ACTIONS(4644),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_LT_EQ] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_EQ_GT] = ACTIONS(4644),
    [anon_sym_switch] = ACTIONS(4644),
    [anon_sym_when] = ACTIONS(4644),
    [anon_sym_DOT_DOT] = ACTIONS(4644),
    [anon_sym_and] = ACTIONS(4644),
    [anon_sym_or] = ACTIONS(4644),
    [anon_sym_PLUS_EQ] = ACTIONS(4644),
    [anon_sym_DASH_EQ] = ACTIONS(4644),
    [anon_sym_STAR_EQ] = ACTIONS(4644),
    [anon_sym_SLASH_EQ] = ACTIONS(4644),
    [anon_sym_PERCENT_EQ] = ACTIONS(4644),
    [anon_sym_AMP_EQ] = ACTIONS(4644),
    [anon_sym_CARET_EQ] = ACTIONS(4644),
    [anon_sym_PIPE_EQ] = ACTIONS(4644),
    [anon_sym_LT_LT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4644),
    [anon_sym_AMP_AMP] = ACTIONS(4644),
    [anon_sym_PIPE_PIPE] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK] = ACTIONS(4646),
    [anon_sym_on] = ACTIONS(4644),
    [anon_sym_equals] = ACTIONS(4644),
    [anon_sym_by] = ACTIONS(4644),
    [anon_sym_as] = ACTIONS(4644),
    [anon_sym_is] = ACTIONS(4644),
    [anon_sym_DASH_GT] = ACTIONS(4644),
    [anon_sym_with] = ACTIONS(4644),
    [aux_sym_preproc_if_token3] = ACTIONS(4644),
    [aux_sym_preproc_else_token1] = ACTIONS(4644),
    [aux_sym_preproc_elif_token1] = ACTIONS(4644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3175] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3175),
    [sym_preproc_endregion] = STATE(3175),
    [sym_preproc_line] = STATE(3175),
    [sym_preproc_pragma] = STATE(3175),
    [sym_preproc_nullable] = STATE(3175),
    [sym_preproc_error] = STATE(3175),
    [sym_preproc_define] = STATE(3175),
    [sym_preproc_undef] = STATE(3175),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_in] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3176] = {
    [sym_preproc_region] = STATE(3176),
    [sym_preproc_endregion] = STATE(3176),
    [sym_preproc_line] = STATE(3176),
    [sym_preproc_pragma] = STATE(3176),
    [sym_preproc_nullable] = STATE(3176),
    [sym_preproc_error] = STATE(3176),
    [sym_preproc_define] = STATE(3176),
    [sym_preproc_undef] = STATE(3176),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_file] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_scoped] = ACTIONS(4480),
    [anon_sym_var] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [sym_discard] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3177] = {
    [sym_preproc_region] = STATE(3177),
    [sym_preproc_endregion] = STATE(3177),
    [sym_preproc_line] = STATE(3177),
    [sym_preproc_pragma] = STATE(3177),
    [sym_preproc_nullable] = STATE(3177),
    [sym_preproc_error] = STATE(3177),
    [sym_preproc_define] = STATE(3177),
    [sym_preproc_undef] = STATE(3177),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_RBRACK] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_in] = ACTIONS(4638),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_EQ_GT] = ACTIONS(4640),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_when] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4640),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_into] = ACTIONS(4640),
    [anon_sym_on] = ACTIONS(4640),
    [anon_sym_equals] = ACTIONS(4640),
    [anon_sym_by] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4640),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_if_token3] = ACTIONS(4640),
    [aux_sym_preproc_else_token1] = ACTIONS(4640),
    [aux_sym_preproc_elif_token1] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3178] = {
    [sym_preproc_region] = STATE(3178),
    [sym_preproc_endregion] = STATE(3178),
    [sym_preproc_line] = STATE(3178),
    [sym_preproc_pragma] = STATE(3178),
    [sym_preproc_nullable] = STATE(3178),
    [sym_preproc_error] = STATE(3178),
    [sym_preproc_define] = STATE(3178),
    [sym_preproc_undef] = STATE(3178),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3179] = {
    [sym_preproc_region] = STATE(3179),
    [sym_preproc_endregion] = STATE(3179),
    [sym_preproc_line] = STATE(3179),
    [sym_preproc_pragma] = STATE(3179),
    [sym_preproc_nullable] = STATE(3179),
    [sym_preproc_error] = STATE(3179),
    [sym_preproc_define] = STATE(3179),
    [sym_preproc_undef] = STATE(3179),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3180] = {
    [sym__variable_designation] = STATE(4741),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3180),
    [sym_preproc_endregion] = STATE(3180),
    [sym_preproc_line] = STATE(3180),
    [sym_preproc_pragma] = STATE(3180),
    [sym_preproc_nullable] = STATE(3180),
    [sym_preproc_error] = STATE(3180),
    [sym_preproc_define] = STATE(3180),
    [sym_preproc_undef] = STATE(3180),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4397),
    [anon_sym_descending] = ACTIONS(4397),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3181] = {
    [sym_preproc_region] = STATE(3181),
    [sym_preproc_endregion] = STATE(3181),
    [sym_preproc_line] = STATE(3181),
    [sym_preproc_pragma] = STATE(3181),
    [sym_preproc_nullable] = STATE(3181),
    [sym_preproc_error] = STATE(3181),
    [sym_preproc_define] = STATE(3181),
    [sym_preproc_undef] = STATE(3181),
    [sym__identifier_token] = ACTIONS(4769),
    [anon_sym_extern] = ACTIONS(4769),
    [anon_sym_alias] = ACTIONS(4769),
    [anon_sym_global] = ACTIONS(4769),
    [anon_sym_using] = ACTIONS(4769),
    [anon_sym_unsafe] = ACTIONS(4769),
    [anon_sym_EQ] = ACTIONS(4771),
    [anon_sym_static] = ACTIONS(4769),
    [anon_sym_LBRACK] = ACTIONS(4773),
    [anon_sym_LPAREN] = ACTIONS(4773),
    [anon_sym_event] = ACTIONS(4769),
    [anon_sym_namespace] = ACTIONS(4769),
    [anon_sym_class] = ACTIONS(4769),
    [anon_sym_ref] = ACTIONS(4769),
    [anon_sym_struct] = ACTIONS(4769),
    [anon_sym_enum] = ACTIONS(4769),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_interface] = ACTIONS(4769),
    [anon_sym_delegate] = ACTIONS(4769),
    [anon_sym_record] = ACTIONS(4769),
    [anon_sym_abstract] = ACTIONS(4769),
    [anon_sym_async] = ACTIONS(4769),
    [anon_sym_const] = ACTIONS(4769),
    [anon_sym_file] = ACTIONS(4769),
    [anon_sym_fixed] = ACTIONS(4769),
    [anon_sym_internal] = ACTIONS(4769),
    [anon_sym_new] = ACTIONS(4769),
    [anon_sym_override] = ACTIONS(4769),
    [anon_sym_partial] = ACTIONS(4769),
    [anon_sym_private] = ACTIONS(4769),
    [anon_sym_protected] = ACTIONS(4769),
    [anon_sym_public] = ACTIONS(4769),
    [anon_sym_readonly] = ACTIONS(4769),
    [anon_sym_required] = ACTIONS(4769),
    [anon_sym_sealed] = ACTIONS(4769),
    [anon_sym_virtual] = ACTIONS(4769),
    [anon_sym_volatile] = ACTIONS(4769),
    [anon_sym_where] = ACTIONS(4769),
    [anon_sym_notnull] = ACTIONS(4769),
    [anon_sym_unmanaged] = ACTIONS(4769),
    [anon_sym_TILDE] = ACTIONS(4773),
    [anon_sym_implicit] = ACTIONS(4769),
    [anon_sym_explicit] = ACTIONS(4769),
    [anon_sym_scoped] = ACTIONS(4769),
    [anon_sym_var] = ACTIONS(4769),
    [sym_predefined_type] = ACTIONS(4769),
    [anon_sym_yield] = ACTIONS(4769),
    [anon_sym_when] = ACTIONS(4769),
    [anon_sym_from] = ACTIONS(4769),
    [anon_sym_into] = ACTIONS(4769),
    [anon_sym_join] = ACTIONS(4769),
    [anon_sym_on] = ACTIONS(4769),
    [anon_sym_equals] = ACTIONS(4769),
    [anon_sym_let] = ACTIONS(4769),
    [anon_sym_orderby] = ACTIONS(4769),
    [anon_sym_ascending] = ACTIONS(4769),
    [anon_sym_descending] = ACTIONS(4769),
    [anon_sym_group] = ACTIONS(4769),
    [anon_sym_by] = ACTIONS(4769),
    [anon_sym_select] = ACTIONS(4769),
    [aux_sym_preproc_if_token1] = ACTIONS(4773),
    [aux_sym_preproc_if_token3] = ACTIONS(4773),
    [aux_sym_preproc_else_token1] = ACTIONS(4773),
    [aux_sym_preproc_elif_token1] = ACTIONS(4773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3182] = {
    [sym_preproc_region] = STATE(3182),
    [sym_preproc_endregion] = STATE(3182),
    [sym_preproc_line] = STATE(3182),
    [sym_preproc_pragma] = STATE(3182),
    [sym_preproc_nullable] = STATE(3182),
    [sym_preproc_error] = STATE(3182),
    [sym_preproc_define] = STATE(3182),
    [sym_preproc_undef] = STATE(3182),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3183] = {
    [sym_preproc_region] = STATE(3183),
    [sym_preproc_endregion] = STATE(3183),
    [sym_preproc_line] = STATE(3183),
    [sym_preproc_pragma] = STATE(3183),
    [sym_preproc_nullable] = STATE(3183),
    [sym_preproc_error] = STATE(3183),
    [sym_preproc_define] = STATE(3183),
    [sym_preproc_undef] = STATE(3183),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3184] = {
    [sym_preproc_region] = STATE(3184),
    [sym_preproc_endregion] = STATE(3184),
    [sym_preproc_line] = STATE(3184),
    [sym_preproc_pragma] = STATE(3184),
    [sym_preproc_nullable] = STATE(3184),
    [sym_preproc_error] = STATE(3184),
    [sym_preproc_define] = STATE(3184),
    [sym_preproc_undef] = STATE(3184),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_when] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4167),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4167),
    [anon_sym_on] = ACTIONS(4167),
    [anon_sym_equals] = ACTIONS(4167),
    [anon_sym_by] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3185] = {
    [sym_preproc_region] = STATE(3185),
    [sym_preproc_endregion] = STATE(3185),
    [sym_preproc_line] = STATE(3185),
    [sym_preproc_pragma] = STATE(3185),
    [sym_preproc_nullable] = STATE(3185),
    [sym_preproc_error] = STATE(3185),
    [sym_preproc_define] = STATE(3185),
    [sym_preproc_undef] = STATE(3185),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4559),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4557),
  },
  [3186] = {
    [sym_preproc_region] = STATE(3186),
    [sym_preproc_endregion] = STATE(3186),
    [sym_preproc_line] = STATE(3186),
    [sym_preproc_pragma] = STATE(3186),
    [sym_preproc_nullable] = STATE(3186),
    [sym_preproc_error] = STATE(3186),
    [sym_preproc_define] = STATE(3186),
    [sym_preproc_undef] = STATE(3186),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_when] = ACTIONS(4171),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4171),
    [anon_sym_or] = ACTIONS(4171),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_into] = ACTIONS(4171),
    [anon_sym_on] = ACTIONS(4171),
    [anon_sym_equals] = ACTIONS(4171),
    [anon_sym_by] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_is] = ACTIONS(4171),
    [anon_sym_DASH_GT] = ACTIONS(4171),
    [anon_sym_with] = ACTIONS(4171),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3187] = {
    [sym__variable_designation] = STATE(4566),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3187),
    [sym_preproc_endregion] = STATE(3187),
    [sym_preproc_line] = STATE(3187),
    [sym_preproc_pragma] = STATE(3187),
    [sym_preproc_nullable] = STATE(3187),
    [sym_preproc_error] = STATE(3187),
    [sym_preproc_define] = STATE(3187),
    [sym_preproc_undef] = STATE(3187),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4405),
    [anon_sym_descending] = ACTIONS(4405),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3188] = {
    [sym__variable_designation] = STATE(4568),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3188),
    [sym_preproc_endregion] = STATE(3188),
    [sym_preproc_line] = STATE(3188),
    [sym_preproc_pragma] = STATE(3188),
    [sym_preproc_nullable] = STATE(3188),
    [sym_preproc_error] = STATE(3188),
    [sym_preproc_define] = STATE(3188),
    [sym_preproc_undef] = STATE(3188),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4445),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4445),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4445),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4445),
    [anon_sym_orderby] = ACTIONS(4445),
    [anon_sym_ascending] = ACTIONS(4445),
    [anon_sym_descending] = ACTIONS(4445),
    [anon_sym_group] = ACTIONS(4445),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4445),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3189] = {
    [sym__variable_designation] = STATE(4582),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3189),
    [sym_preproc_endregion] = STATE(3189),
    [sym_preproc_line] = STATE(3189),
    [sym_preproc_pragma] = STATE(3189),
    [sym_preproc_nullable] = STATE(3189),
    [sym_preproc_error] = STATE(3189),
    [sym_preproc_define] = STATE(3189),
    [sym_preproc_undef] = STATE(3189),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4435),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4435),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4435),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4435),
    [anon_sym_orderby] = ACTIONS(4435),
    [anon_sym_ascending] = ACTIONS(4435),
    [anon_sym_descending] = ACTIONS(4435),
    [anon_sym_group] = ACTIONS(4435),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4435),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3190] = {
    [sym__variable_designation] = STATE(4582),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3190),
    [sym_preproc_endregion] = STATE(3190),
    [sym_preproc_line] = STATE(3190),
    [sym_preproc_pragma] = STATE(3190),
    [sym_preproc_nullable] = STATE(3190),
    [sym_preproc_error] = STATE(3190),
    [sym_preproc_define] = STATE(3190),
    [sym_preproc_undef] = STATE(3190),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4435),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4435),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4435),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4435),
    [anon_sym_orderby] = ACTIONS(4435),
    [anon_sym_ascending] = ACTIONS(4435),
    [anon_sym_descending] = ACTIONS(4435),
    [anon_sym_group] = ACTIONS(4435),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4435),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3191] = {
    [sym_preproc_region] = STATE(3191),
    [sym_preproc_endregion] = STATE(3191),
    [sym_preproc_line] = STATE(3191),
    [sym_preproc_pragma] = STATE(3191),
    [sym_preproc_nullable] = STATE(3191),
    [sym_preproc_error] = STATE(3191),
    [sym_preproc_define] = STATE(3191),
    [sym_preproc_undef] = STATE(3191),
    [sym__identifier_token] = ACTIONS(4777),
    [anon_sym_extern] = ACTIONS(4777),
    [anon_sym_alias] = ACTIONS(4777),
    [anon_sym_global] = ACTIONS(4777),
    [anon_sym_using] = ACTIONS(4777),
    [anon_sym_unsafe] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(4779),
    [anon_sym_static] = ACTIONS(4777),
    [anon_sym_LBRACK] = ACTIONS(4781),
    [anon_sym_LPAREN] = ACTIONS(4781),
    [anon_sym_event] = ACTIONS(4777),
    [anon_sym_namespace] = ACTIONS(4777),
    [anon_sym_class] = ACTIONS(4777),
    [anon_sym_ref] = ACTIONS(4777),
    [anon_sym_struct] = ACTIONS(4777),
    [anon_sym_enum] = ACTIONS(4777),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_interface] = ACTIONS(4777),
    [anon_sym_delegate] = ACTIONS(4777),
    [anon_sym_record] = ACTIONS(4777),
    [anon_sym_abstract] = ACTIONS(4777),
    [anon_sym_async] = ACTIONS(4777),
    [anon_sym_const] = ACTIONS(4777),
    [anon_sym_file] = ACTIONS(4777),
    [anon_sym_fixed] = ACTIONS(4777),
    [anon_sym_internal] = ACTIONS(4777),
    [anon_sym_new] = ACTIONS(4777),
    [anon_sym_override] = ACTIONS(4777),
    [anon_sym_partial] = ACTIONS(4777),
    [anon_sym_private] = ACTIONS(4777),
    [anon_sym_protected] = ACTIONS(4777),
    [anon_sym_public] = ACTIONS(4777),
    [anon_sym_readonly] = ACTIONS(4777),
    [anon_sym_required] = ACTIONS(4777),
    [anon_sym_sealed] = ACTIONS(4777),
    [anon_sym_virtual] = ACTIONS(4777),
    [anon_sym_volatile] = ACTIONS(4777),
    [anon_sym_where] = ACTIONS(4777),
    [anon_sym_notnull] = ACTIONS(4777),
    [anon_sym_unmanaged] = ACTIONS(4777),
    [anon_sym_TILDE] = ACTIONS(4781),
    [anon_sym_implicit] = ACTIONS(4777),
    [anon_sym_explicit] = ACTIONS(4777),
    [anon_sym_scoped] = ACTIONS(4777),
    [anon_sym_var] = ACTIONS(4777),
    [sym_predefined_type] = ACTIONS(4777),
    [anon_sym_yield] = ACTIONS(4777),
    [anon_sym_when] = ACTIONS(4777),
    [anon_sym_from] = ACTIONS(4777),
    [anon_sym_into] = ACTIONS(4777),
    [anon_sym_join] = ACTIONS(4777),
    [anon_sym_on] = ACTIONS(4777),
    [anon_sym_equals] = ACTIONS(4777),
    [anon_sym_let] = ACTIONS(4777),
    [anon_sym_orderby] = ACTIONS(4777),
    [anon_sym_ascending] = ACTIONS(4777),
    [anon_sym_descending] = ACTIONS(4777),
    [anon_sym_group] = ACTIONS(4777),
    [anon_sym_by] = ACTIONS(4777),
    [anon_sym_select] = ACTIONS(4777),
    [aux_sym_preproc_if_token1] = ACTIONS(4781),
    [aux_sym_preproc_if_token3] = ACTIONS(4781),
    [aux_sym_preproc_else_token1] = ACTIONS(4781),
    [aux_sym_preproc_elif_token1] = ACTIONS(4781),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3192] = {
    [sym_preproc_region] = STATE(3192),
    [sym_preproc_endregion] = STATE(3192),
    [sym_preproc_line] = STATE(3192),
    [sym_preproc_pragma] = STATE(3192),
    [sym_preproc_nullable] = STATE(3192),
    [sym_preproc_error] = STATE(3192),
    [sym_preproc_define] = STATE(3192),
    [sym_preproc_undef] = STATE(3192),
    [sym__identifier_token] = ACTIONS(4783),
    [anon_sym_extern] = ACTIONS(4783),
    [anon_sym_alias] = ACTIONS(4783),
    [anon_sym_global] = ACTIONS(4783),
    [anon_sym_using] = ACTIONS(4783),
    [anon_sym_unsafe] = ACTIONS(4783),
    [anon_sym_EQ] = ACTIONS(4785),
    [anon_sym_static] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(4787),
    [anon_sym_event] = ACTIONS(4783),
    [anon_sym_namespace] = ACTIONS(4783),
    [anon_sym_class] = ACTIONS(4783),
    [anon_sym_ref] = ACTIONS(4783),
    [anon_sym_struct] = ACTIONS(4783),
    [anon_sym_enum] = ACTIONS(4783),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [anon_sym_interface] = ACTIONS(4783),
    [anon_sym_delegate] = ACTIONS(4783),
    [anon_sym_record] = ACTIONS(4783),
    [anon_sym_abstract] = ACTIONS(4783),
    [anon_sym_async] = ACTIONS(4783),
    [anon_sym_const] = ACTIONS(4783),
    [anon_sym_file] = ACTIONS(4783),
    [anon_sym_fixed] = ACTIONS(4783),
    [anon_sym_internal] = ACTIONS(4783),
    [anon_sym_new] = ACTIONS(4783),
    [anon_sym_override] = ACTIONS(4783),
    [anon_sym_partial] = ACTIONS(4783),
    [anon_sym_private] = ACTIONS(4783),
    [anon_sym_protected] = ACTIONS(4783),
    [anon_sym_public] = ACTIONS(4783),
    [anon_sym_readonly] = ACTIONS(4783),
    [anon_sym_required] = ACTIONS(4783),
    [anon_sym_sealed] = ACTIONS(4783),
    [anon_sym_virtual] = ACTIONS(4783),
    [anon_sym_volatile] = ACTIONS(4783),
    [anon_sym_where] = ACTIONS(4783),
    [anon_sym_notnull] = ACTIONS(4783),
    [anon_sym_unmanaged] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4787),
    [anon_sym_implicit] = ACTIONS(4783),
    [anon_sym_explicit] = ACTIONS(4783),
    [anon_sym_scoped] = ACTIONS(4783),
    [anon_sym_var] = ACTIONS(4783),
    [sym_predefined_type] = ACTIONS(4783),
    [anon_sym_yield] = ACTIONS(4783),
    [anon_sym_when] = ACTIONS(4783),
    [anon_sym_from] = ACTIONS(4783),
    [anon_sym_into] = ACTIONS(4783),
    [anon_sym_join] = ACTIONS(4783),
    [anon_sym_on] = ACTIONS(4783),
    [anon_sym_equals] = ACTIONS(4783),
    [anon_sym_let] = ACTIONS(4783),
    [anon_sym_orderby] = ACTIONS(4783),
    [anon_sym_ascending] = ACTIONS(4783),
    [anon_sym_descending] = ACTIONS(4783),
    [anon_sym_group] = ACTIONS(4783),
    [anon_sym_by] = ACTIONS(4783),
    [anon_sym_select] = ACTIONS(4783),
    [aux_sym_preproc_if_token1] = ACTIONS(4787),
    [aux_sym_preproc_if_token3] = ACTIONS(4787),
    [aux_sym_preproc_else_token1] = ACTIONS(4787),
    [aux_sym_preproc_elif_token1] = ACTIONS(4787),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3193] = {
    [sym_preproc_region] = STATE(3193),
    [sym_preproc_endregion] = STATE(3193),
    [sym_preproc_line] = STATE(3193),
    [sym_preproc_pragma] = STATE(3193),
    [sym_preproc_nullable] = STATE(3193),
    [sym_preproc_error] = STATE(3193),
    [sym_preproc_define] = STATE(3193),
    [sym_preproc_undef] = STATE(3193),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3194] = {
    [sym__variable_designation] = STATE(4741),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3194),
    [sym_preproc_endregion] = STATE(3194),
    [sym_preproc_line] = STATE(3194),
    [sym_preproc_pragma] = STATE(3194),
    [sym_preproc_nullable] = STATE(3194),
    [sym_preproc_error] = STATE(3194),
    [sym_preproc_define] = STATE(3194),
    [sym_preproc_undef] = STATE(3194),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_COMMA] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4397),
    [anon_sym_descending] = ACTIONS(4397),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3195] = {
    [sym_preproc_region] = STATE(3195),
    [sym_preproc_endregion] = STATE(3195),
    [sym_preproc_line] = STATE(3195),
    [sym_preproc_pragma] = STATE(3195),
    [sym_preproc_nullable] = STATE(3195),
    [sym_preproc_error] = STATE(3195),
    [sym_preproc_define] = STATE(3195),
    [sym_preproc_undef] = STATE(3195),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3196] = {
    [sym_preproc_region] = STATE(3196),
    [sym_preproc_endregion] = STATE(3196),
    [sym_preproc_line] = STATE(3196),
    [sym_preproc_pragma] = STATE(3196),
    [sym_preproc_nullable] = STATE(3196),
    [sym_preproc_error] = STATE(3196),
    [sym_preproc_define] = STATE(3196),
    [sym_preproc_undef] = STATE(3196),
    [sym__identifier_token] = ACTIONS(4789),
    [anon_sym_extern] = ACTIONS(4789),
    [anon_sym_alias] = ACTIONS(4789),
    [anon_sym_global] = ACTIONS(4789),
    [anon_sym_using] = ACTIONS(4789),
    [anon_sym_unsafe] = ACTIONS(4789),
    [anon_sym_EQ] = ACTIONS(4791),
    [anon_sym_static] = ACTIONS(4789),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [anon_sym_LPAREN] = ACTIONS(4791),
    [anon_sym_event] = ACTIONS(4789),
    [anon_sym_namespace] = ACTIONS(4789),
    [anon_sym_class] = ACTIONS(4789),
    [anon_sym_ref] = ACTIONS(4789),
    [anon_sym_struct] = ACTIONS(4789),
    [anon_sym_enum] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(4791),
    [anon_sym_interface] = ACTIONS(4789),
    [anon_sym_delegate] = ACTIONS(4789),
    [anon_sym_record] = ACTIONS(4789),
    [anon_sym_abstract] = ACTIONS(4789),
    [anon_sym_async] = ACTIONS(4789),
    [anon_sym_const] = ACTIONS(4789),
    [anon_sym_file] = ACTIONS(4789),
    [anon_sym_fixed] = ACTIONS(4789),
    [anon_sym_internal] = ACTIONS(4789),
    [anon_sym_new] = ACTIONS(4789),
    [anon_sym_override] = ACTIONS(4789),
    [anon_sym_partial] = ACTIONS(4789),
    [anon_sym_private] = ACTIONS(4789),
    [anon_sym_protected] = ACTIONS(4789),
    [anon_sym_public] = ACTIONS(4789),
    [anon_sym_readonly] = ACTIONS(4789),
    [anon_sym_required] = ACTIONS(4789),
    [anon_sym_sealed] = ACTIONS(4789),
    [anon_sym_virtual] = ACTIONS(4789),
    [anon_sym_volatile] = ACTIONS(4789),
    [anon_sym_where] = ACTIONS(4789),
    [anon_sym_notnull] = ACTIONS(4789),
    [anon_sym_unmanaged] = ACTIONS(4789),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_implicit] = ACTIONS(4789),
    [anon_sym_explicit] = ACTIONS(4789),
    [anon_sym_scoped] = ACTIONS(4789),
    [anon_sym_var] = ACTIONS(4789),
    [sym_predefined_type] = ACTIONS(4789),
    [anon_sym_yield] = ACTIONS(4789),
    [anon_sym_when] = ACTIONS(4789),
    [anon_sym_from] = ACTIONS(4789),
    [anon_sym_into] = ACTIONS(4789),
    [anon_sym_join] = ACTIONS(4789),
    [anon_sym_on] = ACTIONS(4789),
    [anon_sym_equals] = ACTIONS(4789),
    [anon_sym_let] = ACTIONS(4789),
    [anon_sym_orderby] = ACTIONS(4789),
    [anon_sym_ascending] = ACTIONS(4789),
    [anon_sym_descending] = ACTIONS(4789),
    [anon_sym_group] = ACTIONS(4789),
    [anon_sym_by] = ACTIONS(4789),
    [anon_sym_select] = ACTIONS(4789),
    [aux_sym_preproc_if_token1] = ACTIONS(4791),
    [aux_sym_preproc_if_token3] = ACTIONS(4791),
    [aux_sym_preproc_else_token1] = ACTIONS(4791),
    [aux_sym_preproc_elif_token1] = ACTIONS(4791),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3197] = {
    [sym_preproc_region] = STATE(3197),
    [sym_preproc_endregion] = STATE(3197),
    [sym_preproc_line] = STATE(3197),
    [sym_preproc_pragma] = STATE(3197),
    [sym_preproc_nullable] = STATE(3197),
    [sym_preproc_error] = STATE(3197),
    [sym_preproc_define] = STATE(3197),
    [sym_preproc_undef] = STATE(3197),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_in] = ACTIONS(4652),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_EQ_GT] = ACTIONS(4650),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_when] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4650),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_into] = ACTIONS(4650),
    [anon_sym_on] = ACTIONS(4650),
    [anon_sym_equals] = ACTIONS(4650),
    [anon_sym_by] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4650),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_if_token3] = ACTIONS(4650),
    [aux_sym_preproc_else_token1] = ACTIONS(4650),
    [aux_sym_preproc_elif_token1] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3198] = {
    [sym_preproc_region] = STATE(3198),
    [sym_preproc_endregion] = STATE(3198),
    [sym_preproc_line] = STATE(3198),
    [sym_preproc_pragma] = STATE(3198),
    [sym_preproc_nullable] = STATE(3198),
    [sym_preproc_error] = STATE(3198),
    [sym_preproc_define] = STATE(3198),
    [sym_preproc_undef] = STATE(3198),
    [sym__identifier_token] = ACTIONS(4793),
    [anon_sym_extern] = ACTIONS(4793),
    [anon_sym_alias] = ACTIONS(4793),
    [anon_sym_global] = ACTIONS(4793),
    [anon_sym_using] = ACTIONS(4793),
    [anon_sym_unsafe] = ACTIONS(4793),
    [anon_sym_EQ] = ACTIONS(4795),
    [anon_sym_static] = ACTIONS(4793),
    [anon_sym_LBRACK] = ACTIONS(4797),
    [anon_sym_LPAREN] = ACTIONS(4797),
    [anon_sym_event] = ACTIONS(4793),
    [anon_sym_namespace] = ACTIONS(4793),
    [anon_sym_class] = ACTIONS(4793),
    [anon_sym_ref] = ACTIONS(4793),
    [anon_sym_struct] = ACTIONS(4793),
    [anon_sym_enum] = ACTIONS(4793),
    [anon_sym_RBRACE] = ACTIONS(4797),
    [anon_sym_interface] = ACTIONS(4793),
    [anon_sym_delegate] = ACTIONS(4793),
    [anon_sym_record] = ACTIONS(4793),
    [anon_sym_abstract] = ACTIONS(4793),
    [anon_sym_async] = ACTIONS(4793),
    [anon_sym_const] = ACTIONS(4793),
    [anon_sym_file] = ACTIONS(4793),
    [anon_sym_fixed] = ACTIONS(4793),
    [anon_sym_internal] = ACTIONS(4793),
    [anon_sym_new] = ACTIONS(4793),
    [anon_sym_override] = ACTIONS(4793),
    [anon_sym_partial] = ACTIONS(4793),
    [anon_sym_private] = ACTIONS(4793),
    [anon_sym_protected] = ACTIONS(4793),
    [anon_sym_public] = ACTIONS(4793),
    [anon_sym_readonly] = ACTIONS(4793),
    [anon_sym_required] = ACTIONS(4793),
    [anon_sym_sealed] = ACTIONS(4793),
    [anon_sym_virtual] = ACTIONS(4793),
    [anon_sym_volatile] = ACTIONS(4793),
    [anon_sym_where] = ACTIONS(4793),
    [anon_sym_notnull] = ACTIONS(4793),
    [anon_sym_unmanaged] = ACTIONS(4793),
    [anon_sym_TILDE] = ACTIONS(4797),
    [anon_sym_implicit] = ACTIONS(4793),
    [anon_sym_explicit] = ACTIONS(4793),
    [anon_sym_scoped] = ACTIONS(4793),
    [anon_sym_var] = ACTIONS(4793),
    [sym_predefined_type] = ACTIONS(4793),
    [anon_sym_yield] = ACTIONS(4793),
    [anon_sym_when] = ACTIONS(4793),
    [anon_sym_from] = ACTIONS(4793),
    [anon_sym_into] = ACTIONS(4793),
    [anon_sym_join] = ACTIONS(4793),
    [anon_sym_on] = ACTIONS(4793),
    [anon_sym_equals] = ACTIONS(4793),
    [anon_sym_let] = ACTIONS(4793),
    [anon_sym_orderby] = ACTIONS(4793),
    [anon_sym_ascending] = ACTIONS(4793),
    [anon_sym_descending] = ACTIONS(4793),
    [anon_sym_group] = ACTIONS(4793),
    [anon_sym_by] = ACTIONS(4793),
    [anon_sym_select] = ACTIONS(4793),
    [aux_sym_preproc_if_token1] = ACTIONS(4797),
    [aux_sym_preproc_if_token3] = ACTIONS(4797),
    [aux_sym_preproc_else_token1] = ACTIONS(4797),
    [aux_sym_preproc_elif_token1] = ACTIONS(4797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3199] = {
    [sym_preproc_region] = STATE(3199),
    [sym_preproc_endregion] = STATE(3199),
    [sym_preproc_line] = STATE(3199),
    [sym_preproc_pragma] = STATE(3199),
    [sym_preproc_nullable] = STATE(3199),
    [sym_preproc_error] = STATE(3199),
    [sym_preproc_define] = STATE(3199),
    [sym_preproc_undef] = STATE(3199),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4697),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_when] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3200] = {
    [sym_preproc_region] = STATE(3200),
    [sym_preproc_endregion] = STATE(3200),
    [sym_preproc_line] = STATE(3200),
    [sym_preproc_pragma] = STATE(3200),
    [sym_preproc_nullable] = STATE(3200),
    [sym_preproc_error] = STATE(3200),
    [sym_preproc_define] = STATE(3200),
    [sym_preproc_undef] = STATE(3200),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_in] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_EQ_GT] = ACTIONS(4691),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_into] = ACTIONS(4691),
    [anon_sym_on] = ACTIONS(4691),
    [anon_sym_equals] = ACTIONS(4691),
    [anon_sym_by] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4691),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_if_token3] = ACTIONS(4691),
    [aux_sym_preproc_else_token1] = ACTIONS(4691),
    [aux_sym_preproc_elif_token1] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3201] = {
    [sym_preproc_region] = STATE(3201),
    [sym_preproc_endregion] = STATE(3201),
    [sym_preproc_line] = STATE(3201),
    [sym_preproc_pragma] = STATE(3201),
    [sym_preproc_nullable] = STATE(3201),
    [sym_preproc_error] = STATE(3201),
    [sym_preproc_define] = STATE(3201),
    [sym_preproc_undef] = STATE(3201),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_RPAREN] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_in] = ACTIONS(4683),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_EQ_GT] = ACTIONS(4681),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_when] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4681),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_into] = ACTIONS(4681),
    [anon_sym_on] = ACTIONS(4681),
    [anon_sym_equals] = ACTIONS(4681),
    [anon_sym_by] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4681),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_if_token3] = ACTIONS(4681),
    [aux_sym_preproc_else_token1] = ACTIONS(4681),
    [aux_sym_preproc_elif_token1] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3202] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3202),
    [sym_preproc_endregion] = STATE(3202),
    [sym_preproc_line] = STATE(3202),
    [sym_preproc_pragma] = STATE(3202),
    [sym_preproc_nullable] = STATE(3202),
    [sym_preproc_error] = STATE(3202),
    [sym_preproc_define] = STATE(3202),
    [sym_preproc_undef] = STATE(3202),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_in] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3203] = {
    [sym_preproc_region] = STATE(3203),
    [sym_preproc_endregion] = STATE(3203),
    [sym_preproc_line] = STATE(3203),
    [sym_preproc_pragma] = STATE(3203),
    [sym_preproc_nullable] = STATE(3203),
    [sym_preproc_error] = STATE(3203),
    [sym_preproc_define] = STATE(3203),
    [sym_preproc_undef] = STATE(3203),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4801),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_in] = ACTIONS(4807),
    [anon_sym_QMARK] = ACTIONS(4804),
    [anon_sym_BANG] = ACTIONS(4804),
    [anon_sym_PLUS_PLUS] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4801),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(4804),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_CARET] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_GT_GT_GT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4801),
    [anon_sym_BANG_EQ] = ACTIONS(4801),
    [anon_sym_GT_EQ] = ACTIONS(4801),
    [anon_sym_LT_EQ] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(4801),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(4801),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE] = ACTIONS(4801),
    [anon_sym_QMARK_QMARK] = ACTIONS(4804),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(4801),
    [anon_sym_is] = ACTIONS(4801),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4801),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3204] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3204),
    [sym_preproc_endregion] = STATE(3204),
    [sym_preproc_line] = STATE(3204),
    [sym_preproc_pragma] = STATE(3204),
    [sym_preproc_nullable] = STATE(3204),
    [sym_preproc_error] = STATE(3204),
    [sym_preproc_define] = STATE(3204),
    [sym_preproc_undef] = STATE(3204),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_in] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3205] = {
    [sym_preproc_region] = STATE(3205),
    [sym_preproc_endregion] = STATE(3205),
    [sym_preproc_line] = STATE(3205),
    [sym_preproc_pragma] = STATE(3205),
    [sym_preproc_nullable] = STATE(3205),
    [sym_preproc_error] = STATE(3205),
    [sym_preproc_define] = STATE(3205),
    [sym_preproc_undef] = STATE(3205),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_RBRACK] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_in] = ACTIONS(4656),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_EQ_GT] = ACTIONS(4654),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_when] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4654),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_into] = ACTIONS(4654),
    [anon_sym_on] = ACTIONS(4654),
    [anon_sym_equals] = ACTIONS(4654),
    [anon_sym_by] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4654),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_if_token3] = ACTIONS(4654),
    [aux_sym_preproc_else_token1] = ACTIONS(4654),
    [aux_sym_preproc_elif_token1] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3206] = {
    [sym_preproc_region] = STATE(3206),
    [sym_preproc_endregion] = STATE(3206),
    [sym_preproc_line] = STATE(3206),
    [sym_preproc_pragma] = STATE(3206),
    [sym_preproc_nullable] = STATE(3206),
    [sym_preproc_error] = STATE(3206),
    [sym_preproc_define] = STATE(3206),
    [sym_preproc_undef] = STATE(3206),
    [sym__identifier_token] = ACTIONS(4809),
    [anon_sym_extern] = ACTIONS(4809),
    [anon_sym_alias] = ACTIONS(4809),
    [anon_sym_global] = ACTIONS(4809),
    [anon_sym_using] = ACTIONS(4809),
    [anon_sym_unsafe] = ACTIONS(4809),
    [anon_sym_EQ] = ACTIONS(4811),
    [anon_sym_static] = ACTIONS(4809),
    [anon_sym_LBRACK] = ACTIONS(4813),
    [anon_sym_LPAREN] = ACTIONS(4813),
    [anon_sym_event] = ACTIONS(4809),
    [anon_sym_namespace] = ACTIONS(4809),
    [anon_sym_class] = ACTIONS(4809),
    [anon_sym_ref] = ACTIONS(4809),
    [anon_sym_struct] = ACTIONS(4809),
    [anon_sym_enum] = ACTIONS(4809),
    [anon_sym_RBRACE] = ACTIONS(4813),
    [anon_sym_interface] = ACTIONS(4809),
    [anon_sym_delegate] = ACTIONS(4809),
    [anon_sym_record] = ACTIONS(4809),
    [anon_sym_abstract] = ACTIONS(4809),
    [anon_sym_async] = ACTIONS(4809),
    [anon_sym_const] = ACTIONS(4809),
    [anon_sym_file] = ACTIONS(4809),
    [anon_sym_fixed] = ACTIONS(4809),
    [anon_sym_internal] = ACTIONS(4809),
    [anon_sym_new] = ACTIONS(4809),
    [anon_sym_override] = ACTIONS(4809),
    [anon_sym_partial] = ACTIONS(4809),
    [anon_sym_private] = ACTIONS(4809),
    [anon_sym_protected] = ACTIONS(4809),
    [anon_sym_public] = ACTIONS(4809),
    [anon_sym_readonly] = ACTIONS(4809),
    [anon_sym_required] = ACTIONS(4809),
    [anon_sym_sealed] = ACTIONS(4809),
    [anon_sym_virtual] = ACTIONS(4809),
    [anon_sym_volatile] = ACTIONS(4809),
    [anon_sym_where] = ACTIONS(4809),
    [anon_sym_notnull] = ACTIONS(4809),
    [anon_sym_unmanaged] = ACTIONS(4809),
    [anon_sym_TILDE] = ACTIONS(4813),
    [anon_sym_implicit] = ACTIONS(4809),
    [anon_sym_explicit] = ACTIONS(4809),
    [anon_sym_scoped] = ACTIONS(4809),
    [anon_sym_var] = ACTIONS(4809),
    [sym_predefined_type] = ACTIONS(4809),
    [anon_sym_yield] = ACTIONS(4809),
    [anon_sym_when] = ACTIONS(4809),
    [anon_sym_from] = ACTIONS(4809),
    [anon_sym_into] = ACTIONS(4809),
    [anon_sym_join] = ACTIONS(4809),
    [anon_sym_on] = ACTIONS(4809),
    [anon_sym_equals] = ACTIONS(4809),
    [anon_sym_let] = ACTIONS(4809),
    [anon_sym_orderby] = ACTIONS(4809),
    [anon_sym_ascending] = ACTIONS(4809),
    [anon_sym_descending] = ACTIONS(4809),
    [anon_sym_group] = ACTIONS(4809),
    [anon_sym_by] = ACTIONS(4809),
    [anon_sym_select] = ACTIONS(4809),
    [aux_sym_preproc_if_token1] = ACTIONS(4813),
    [aux_sym_preproc_if_token3] = ACTIONS(4813),
    [aux_sym_preproc_else_token1] = ACTIONS(4813),
    [aux_sym_preproc_elif_token1] = ACTIONS(4813),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3207] = {
    [sym_preproc_region] = STATE(3207),
    [sym_preproc_endregion] = STATE(3207),
    [sym_preproc_line] = STATE(3207),
    [sym_preproc_pragma] = STATE(3207),
    [sym_preproc_nullable] = STATE(3207),
    [sym_preproc_error] = STATE(3207),
    [sym_preproc_define] = STATE(3207),
    [sym_preproc_undef] = STATE(3207),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4122),
  },
  [3208] = {
    [sym__variable_designation] = STATE(4568),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3208),
    [sym_preproc_endregion] = STATE(3208),
    [sym_preproc_line] = STATE(3208),
    [sym_preproc_pragma] = STATE(3208),
    [sym_preproc_nullable] = STATE(3208),
    [sym_preproc_error] = STATE(3208),
    [sym_preproc_define] = STATE(3208),
    [sym_preproc_undef] = STATE(3208),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4445),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4445),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4445),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4445),
    [anon_sym_orderby] = ACTIONS(4445),
    [anon_sym_ascending] = ACTIONS(4445),
    [anon_sym_descending] = ACTIONS(4445),
    [anon_sym_group] = ACTIONS(4445),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4445),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3209] = {
    [sym__variable_designation] = STATE(4566),
    [sym_parenthesized_variable_designation] = STATE(4549),
    [sym_identifier] = STATE(4545),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(3209),
    [sym_preproc_endregion] = STATE(3209),
    [sym_preproc_line] = STATE(3209),
    [sym_preproc_pragma] = STATE(3209),
    [sym_preproc_nullable] = STATE(3209),
    [sym_preproc_error] = STATE(3209),
    [sym_preproc_define] = STATE(3209),
    [sym_preproc_undef] = STATE(3209),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4614),
    [sym_discard] = ACTIONS(4715),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4405),
    [anon_sym_descending] = ACTIONS(4405),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3210] = {
    [sym_preproc_region] = STATE(3210),
    [sym_preproc_endregion] = STATE(3210),
    [sym_preproc_line] = STATE(3210),
    [sym_preproc_pragma] = STATE(3210),
    [sym_preproc_nullable] = STATE(3210),
    [sym_preproc_error] = STATE(3210),
    [sym_preproc_define] = STATE(3210),
    [sym_preproc_undef] = STATE(3210),
    [sym__identifier_token] = ACTIONS(4089),
    [anon_sym_alias] = ACTIONS(4089),
    [anon_sym_global] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_file] = ACTIONS(4089),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_notnull] = ACTIONS(4089),
    [anon_sym_unmanaged] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_scoped] = ACTIONS(4089),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4089),
    [anon_sym_yield] = ACTIONS(4089),
    [anon_sym_switch] = ACTIONS(4089),
    [anon_sym_when] = ACTIONS(4089),
    [sym_discard] = ACTIONS(4089),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4089),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_from] = ACTIONS(4089),
    [anon_sym_into] = ACTIONS(4089),
    [anon_sym_join] = ACTIONS(4089),
    [anon_sym_on] = ACTIONS(4089),
    [anon_sym_equals] = ACTIONS(4089),
    [anon_sym_let] = ACTIONS(4089),
    [anon_sym_orderby] = ACTIONS(4089),
    [anon_sym_ascending] = ACTIONS(4089),
    [anon_sym_descending] = ACTIONS(4089),
    [anon_sym_group] = ACTIONS(4089),
    [anon_sym_by] = ACTIONS(4089),
    [anon_sym_select] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(4089),
    [anon_sym_is] = ACTIONS(4089),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4086),
  },
  [3211] = {
    [sym_preproc_region] = STATE(3211),
    [sym_preproc_endregion] = STATE(3211),
    [sym_preproc_line] = STATE(3211),
    [sym_preproc_pragma] = STATE(3211),
    [sym_preproc_nullable] = STATE(3211),
    [sym_preproc_error] = STATE(3211),
    [sym_preproc_define] = STATE(3211),
    [sym_preproc_undef] = STATE(3211),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_in] = ACTIONS(4707),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_EQ_GT] = ACTIONS(4705),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_when] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4705),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_into] = ACTIONS(4705),
    [anon_sym_on] = ACTIONS(4705),
    [anon_sym_equals] = ACTIONS(4705),
    [anon_sym_by] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4705),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_if_token3] = ACTIONS(4705),
    [aux_sym_preproc_else_token1] = ACTIONS(4705),
    [aux_sym_preproc_elif_token1] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3212] = {
    [sym_preproc_region] = STATE(3212),
    [sym_preproc_endregion] = STATE(3212),
    [sym_preproc_line] = STATE(3212),
    [sym_preproc_pragma] = STATE(3212),
    [sym_preproc_nullable] = STATE(3212),
    [sym_preproc_error] = STATE(3212),
    [sym_preproc_define] = STATE(3212),
    [sym_preproc_undef] = STATE(3212),
    [sym__identifier_token] = ACTIONS(4815),
    [anon_sym_extern] = ACTIONS(4815),
    [anon_sym_alias] = ACTIONS(4815),
    [anon_sym_global] = ACTIONS(4815),
    [anon_sym_using] = ACTIONS(4815),
    [anon_sym_unsafe] = ACTIONS(4815),
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_static] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_event] = ACTIONS(4815),
    [anon_sym_namespace] = ACTIONS(4815),
    [anon_sym_class] = ACTIONS(4815),
    [anon_sym_ref] = ACTIONS(4815),
    [anon_sym_struct] = ACTIONS(4815),
    [anon_sym_enum] = ACTIONS(4815),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_interface] = ACTIONS(4815),
    [anon_sym_delegate] = ACTIONS(4815),
    [anon_sym_record] = ACTIONS(4815),
    [anon_sym_abstract] = ACTIONS(4815),
    [anon_sym_async] = ACTIONS(4815),
    [anon_sym_const] = ACTIONS(4815),
    [anon_sym_file] = ACTIONS(4815),
    [anon_sym_fixed] = ACTIONS(4815),
    [anon_sym_internal] = ACTIONS(4815),
    [anon_sym_new] = ACTIONS(4815),
    [anon_sym_override] = ACTIONS(4815),
    [anon_sym_partial] = ACTIONS(4815),
    [anon_sym_private] = ACTIONS(4815),
    [anon_sym_protected] = ACTIONS(4815),
    [anon_sym_public] = ACTIONS(4815),
    [anon_sym_readonly] = ACTIONS(4815),
    [anon_sym_required] = ACTIONS(4815),
    [anon_sym_sealed] = ACTIONS(4815),
    [anon_sym_virtual] = ACTIONS(4815),
    [anon_sym_volatile] = ACTIONS(4815),
    [anon_sym_where] = ACTIONS(4815),
    [anon_sym_notnull] = ACTIONS(4815),
    [anon_sym_unmanaged] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_implicit] = ACTIONS(4815),
    [anon_sym_explicit] = ACTIONS(4815),
    [anon_sym_scoped] = ACTIONS(4815),
    [anon_sym_var] = ACTIONS(4815),
    [sym_predefined_type] = ACTIONS(4815),
    [anon_sym_yield] = ACTIONS(4815),
    [anon_sym_when] = ACTIONS(4815),
    [anon_sym_from] = ACTIONS(4815),
    [anon_sym_into] = ACTIONS(4815),
    [anon_sym_join] = ACTIONS(4815),
    [anon_sym_on] = ACTIONS(4815),
    [anon_sym_equals] = ACTIONS(4815),
    [anon_sym_let] = ACTIONS(4815),
    [anon_sym_orderby] = ACTIONS(4815),
    [anon_sym_ascending] = ACTIONS(4815),
    [anon_sym_descending] = ACTIONS(4815),
    [anon_sym_group] = ACTIONS(4815),
    [anon_sym_by] = ACTIONS(4815),
    [anon_sym_select] = ACTIONS(4815),
    [aux_sym_preproc_if_token1] = ACTIONS(4819),
    [aux_sym_preproc_if_token3] = ACTIONS(4819),
    [aux_sym_preproc_else_token1] = ACTIONS(4819),
    [aux_sym_preproc_elif_token1] = ACTIONS(4819),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3213] = {
    [sym_preproc_region] = STATE(3213),
    [sym_preproc_endregion] = STATE(3213),
    [sym_preproc_line] = STATE(3213),
    [sym_preproc_pragma] = STATE(3213),
    [sym_preproc_nullable] = STATE(3213),
    [sym_preproc_error] = STATE(3213),
    [sym_preproc_define] = STATE(3213),
    [sym_preproc_undef] = STATE(3213),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3214] = {
    [sym_preproc_region] = STATE(3214),
    [sym_preproc_endregion] = STATE(3214),
    [sym_preproc_line] = STATE(3214),
    [sym_preproc_pragma] = STATE(3214),
    [sym_preproc_nullable] = STATE(3214),
    [sym_preproc_error] = STATE(3214),
    [sym_preproc_define] = STATE(3214),
    [sym_preproc_undef] = STATE(3214),
    [sym__identifier_token] = ACTIONS(4821),
    [anon_sym_extern] = ACTIONS(4821),
    [anon_sym_alias] = ACTIONS(4821),
    [anon_sym_global] = ACTIONS(4821),
    [anon_sym_using] = ACTIONS(4821),
    [anon_sym_unsafe] = ACTIONS(4821),
    [anon_sym_EQ] = ACTIONS(4823),
    [anon_sym_static] = ACTIONS(4821),
    [anon_sym_LBRACK] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4823),
    [anon_sym_event] = ACTIONS(4821),
    [anon_sym_namespace] = ACTIONS(4821),
    [anon_sym_class] = ACTIONS(4821),
    [anon_sym_ref] = ACTIONS(4821),
    [anon_sym_struct] = ACTIONS(4821),
    [anon_sym_enum] = ACTIONS(4821),
    [anon_sym_RBRACE] = ACTIONS(4823),
    [anon_sym_interface] = ACTIONS(4821),
    [anon_sym_delegate] = ACTIONS(4821),
    [anon_sym_record] = ACTIONS(4821),
    [anon_sym_abstract] = ACTIONS(4821),
    [anon_sym_async] = ACTIONS(4821),
    [anon_sym_const] = ACTIONS(4821),
    [anon_sym_file] = ACTIONS(4821),
    [anon_sym_fixed] = ACTIONS(4821),
    [anon_sym_internal] = ACTIONS(4821),
    [anon_sym_new] = ACTIONS(4821),
    [anon_sym_override] = ACTIONS(4821),
    [anon_sym_partial] = ACTIONS(4821),
    [anon_sym_private] = ACTIONS(4821),
    [anon_sym_protected] = ACTIONS(4821),
    [anon_sym_public] = ACTIONS(4821),
    [anon_sym_readonly] = ACTIONS(4821),
    [anon_sym_required] = ACTIONS(4821),
    [anon_sym_sealed] = ACTIONS(4821),
    [anon_sym_virtual] = ACTIONS(4821),
    [anon_sym_volatile] = ACTIONS(4821),
    [anon_sym_where] = ACTIONS(4821),
    [anon_sym_notnull] = ACTIONS(4821),
    [anon_sym_unmanaged] = ACTIONS(4821),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_implicit] = ACTIONS(4821),
    [anon_sym_explicit] = ACTIONS(4821),
    [anon_sym_scoped] = ACTIONS(4821),
    [anon_sym_var] = ACTIONS(4821),
    [sym_predefined_type] = ACTIONS(4821),
    [anon_sym_yield] = ACTIONS(4821),
    [anon_sym_when] = ACTIONS(4821),
    [anon_sym_from] = ACTIONS(4821),
    [anon_sym_into] = ACTIONS(4821),
    [anon_sym_join] = ACTIONS(4821),
    [anon_sym_on] = ACTIONS(4821),
    [anon_sym_equals] = ACTIONS(4821),
    [anon_sym_let] = ACTIONS(4821),
    [anon_sym_orderby] = ACTIONS(4821),
    [anon_sym_ascending] = ACTIONS(4821),
    [anon_sym_descending] = ACTIONS(4821),
    [anon_sym_group] = ACTIONS(4821),
    [anon_sym_by] = ACTIONS(4821),
    [anon_sym_select] = ACTIONS(4821),
    [aux_sym_preproc_if_token1] = ACTIONS(4823),
    [aux_sym_preproc_if_token3] = ACTIONS(4823),
    [aux_sym_preproc_else_token1] = ACTIONS(4823),
    [aux_sym_preproc_elif_token1] = ACTIONS(4823),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3215] = {
    [sym_preproc_region] = STATE(3215),
    [sym_preproc_endregion] = STATE(3215),
    [sym_preproc_line] = STATE(3215),
    [sym_preproc_pragma] = STATE(3215),
    [sym_preproc_nullable] = STATE(3215),
    [sym_preproc_error] = STATE(3215),
    [sym_preproc_define] = STATE(3215),
    [sym_preproc_undef] = STATE(3215),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_when] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4128),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3216] = {
    [sym_preproc_region] = STATE(3216),
    [sym_preproc_endregion] = STATE(3216),
    [sym_preproc_line] = STATE(3216),
    [sym_preproc_pragma] = STATE(3216),
    [sym_preproc_nullable] = STATE(3216),
    [sym_preproc_error] = STATE(3216),
    [sym_preproc_define] = STATE(3216),
    [sym_preproc_undef] = STATE(3216),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_when] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4132),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3217] = {
    [sym_preproc_region] = STATE(3217),
    [sym_preproc_endregion] = STATE(3217),
    [sym_preproc_line] = STATE(3217),
    [sym_preproc_pragma] = STATE(3217),
    [sym_preproc_nullable] = STATE(3217),
    [sym_preproc_error] = STATE(3217),
    [sym_preproc_define] = STATE(3217),
    [sym_preproc_undef] = STATE(3217),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_RBRACK] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_in] = ACTIONS(4642),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_EQ_GT] = ACTIONS(4636),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_when] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4636),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_into] = ACTIONS(4636),
    [anon_sym_on] = ACTIONS(4636),
    [anon_sym_equals] = ACTIONS(4636),
    [anon_sym_by] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_if_token3] = ACTIONS(4636),
    [aux_sym_preproc_else_token1] = ACTIONS(4636),
    [aux_sym_preproc_elif_token1] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3218] = {
    [sym_preproc_region] = STATE(3218),
    [sym_preproc_endregion] = STATE(3218),
    [sym_preproc_line] = STATE(3218),
    [sym_preproc_pragma] = STATE(3218),
    [sym_preproc_nullable] = STATE(3218),
    [sym_preproc_error] = STATE(3218),
    [sym_preproc_define] = STATE(3218),
    [sym_preproc_undef] = STATE(3218),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [3219] = {
    [sym_preproc_region] = STATE(3219),
    [sym_preproc_endregion] = STATE(3219),
    [sym_preproc_line] = STATE(3219),
    [sym_preproc_pragma] = STATE(3219),
    [sym_preproc_nullable] = STATE(3219),
    [sym_preproc_error] = STATE(3219),
    [sym_preproc_define] = STATE(3219),
    [sym_preproc_undef] = STATE(3219),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4825),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3220] = {
    [sym_preproc_region] = STATE(3220),
    [sym_preproc_endregion] = STATE(3220),
    [sym_preproc_line] = STATE(3220),
    [sym_preproc_pragma] = STATE(3220),
    [sym_preproc_nullable] = STATE(3220),
    [sym_preproc_error] = STATE(3220),
    [sym_preproc_define] = STATE(3220),
    [sym_preproc_undef] = STATE(3220),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_COLON] = ACTIONS(4557),
    [anon_sym_COMMA] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4559),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4557),
  },
  [3221] = {
    [sym_preproc_region] = STATE(3221),
    [sym_preproc_endregion] = STATE(3221),
    [sym_preproc_line] = STATE(3221),
    [sym_preproc_pragma] = STATE(3221),
    [sym_preproc_nullable] = STATE(3221),
    [sym_preproc_error] = STATE(3221),
    [sym_preproc_define] = STATE(3221),
    [sym_preproc_undef] = STATE(3221),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_when] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4136),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3222] = {
    [sym_preproc_region] = STATE(3222),
    [sym_preproc_endregion] = STATE(3222),
    [sym_preproc_line] = STATE(3222),
    [sym_preproc_pragma] = STATE(3222),
    [sym_preproc_nullable] = STATE(3222),
    [sym_preproc_error] = STATE(3222),
    [sym_preproc_define] = STATE(3222),
    [sym_preproc_undef] = STATE(3222),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_when] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3223] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(3223),
    [sym_preproc_endregion] = STATE(3223),
    [sym_preproc_line] = STATE(3223),
    [sym_preproc_pragma] = STATE(3223),
    [sym_preproc_nullable] = STATE(3223),
    [sym_preproc_error] = STATE(3223),
    [sym_preproc_define] = STATE(3223),
    [sym_preproc_undef] = STATE(3223),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_in] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4258),
    [anon_sym_var] = ACTIONS(4258),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4258),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3224] = {
    [sym_preproc_region] = STATE(3224),
    [sym_preproc_endregion] = STATE(3224),
    [sym_preproc_line] = STATE(3224),
    [sym_preproc_pragma] = STATE(3224),
    [sym_preproc_nullable] = STATE(3224),
    [sym_preproc_error] = STATE(3224),
    [sym_preproc_define] = STATE(3224),
    [sym_preproc_undef] = STATE(3224),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_COMMA] = ACTIONS(4644),
    [anon_sym_RBRACK] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_LT] = ACTIONS(4646),
    [anon_sym_GT] = ACTIONS(4646),
    [anon_sym_in] = ACTIONS(4646),
    [anon_sym_QMARK] = ACTIONS(4646),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_STAR] = ACTIONS(4646),
    [anon_sym_SLASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4646),
    [anon_sym_AMP] = ACTIONS(4646),
    [anon_sym_LT_LT] = ACTIONS(4646),
    [anon_sym_GT_GT] = ACTIONS(4646),
    [anon_sym_GT_GT_GT] = ACTIONS(4646),
    [anon_sym_EQ_EQ] = ACTIONS(4644),
    [anon_sym_BANG_EQ] = ACTIONS(4644),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_LT_EQ] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_EQ_GT] = ACTIONS(4644),
    [anon_sym_switch] = ACTIONS(4644),
    [anon_sym_when] = ACTIONS(4644),
    [anon_sym_DOT_DOT] = ACTIONS(4644),
    [anon_sym_and] = ACTIONS(4644),
    [anon_sym_or] = ACTIONS(4644),
    [anon_sym_PLUS_EQ] = ACTIONS(4644),
    [anon_sym_DASH_EQ] = ACTIONS(4644),
    [anon_sym_STAR_EQ] = ACTIONS(4644),
    [anon_sym_SLASH_EQ] = ACTIONS(4644),
    [anon_sym_PERCENT_EQ] = ACTIONS(4644),
    [anon_sym_AMP_EQ] = ACTIONS(4644),
    [anon_sym_CARET_EQ] = ACTIONS(4644),
    [anon_sym_PIPE_EQ] = ACTIONS(4644),
    [anon_sym_LT_LT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4644),
    [anon_sym_AMP_AMP] = ACTIONS(4644),
    [anon_sym_PIPE_PIPE] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK] = ACTIONS(4646),
    [anon_sym_into] = ACTIONS(4644),
    [anon_sym_on] = ACTIONS(4644),
    [anon_sym_equals] = ACTIONS(4644),
    [anon_sym_by] = ACTIONS(4644),
    [anon_sym_as] = ACTIONS(4644),
    [anon_sym_is] = ACTIONS(4644),
    [anon_sym_DASH_GT] = ACTIONS(4644),
    [anon_sym_with] = ACTIONS(4644),
    [aux_sym_preproc_if_token3] = ACTIONS(4644),
    [aux_sym_preproc_else_token1] = ACTIONS(4644),
    [aux_sym_preproc_elif_token1] = ACTIONS(4644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3225] = {
    [sym_type_argument_list] = STATE(3370),
    [sym_preproc_region] = STATE(3225),
    [sym_preproc_endregion] = STATE(3225),
    [sym_preproc_line] = STATE(3225),
    [sym_preproc_pragma] = STATE(3225),
    [sym_preproc_nullable] = STATE(3225),
    [sym_preproc_error] = STATE(3225),
    [sym_preproc_define] = STATE(3225),
    [sym_preproc_undef] = STATE(3225),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4760),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [3226] = {
    [sym_preproc_region] = STATE(3226),
    [sym_preproc_endregion] = STATE(3226),
    [sym_preproc_line] = STATE(3226),
    [sym_preproc_pragma] = STATE(3226),
    [sym_preproc_nullable] = STATE(3226),
    [sym_preproc_error] = STATE(3226),
    [sym_preproc_define] = STATE(3226),
    [sym_preproc_undef] = STATE(3226),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4827),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3227] = {
    [sym_type_argument_list] = STATE(3260),
    [sym_preproc_region] = STATE(3227),
    [sym_preproc_endregion] = STATE(3227),
    [sym_preproc_line] = STATE(3227),
    [sym_preproc_pragma] = STATE(3227),
    [sym_preproc_nullable] = STATE(3227),
    [sym_preproc_error] = STATE(3227),
    [sym_preproc_define] = STATE(3227),
    [sym_preproc_undef] = STATE(3227),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4829),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3228] = {
    [sym_preproc_region] = STATE(3228),
    [sym_preproc_endregion] = STATE(3228),
    [sym_preproc_line] = STATE(3228),
    [sym_preproc_pragma] = STATE(3228),
    [sym_preproc_nullable] = STATE(3228),
    [sym_preproc_error] = STATE(3228),
    [sym_preproc_define] = STATE(3228),
    [sym_preproc_undef] = STATE(3228),
    [sym__identifier_token] = ACTIONS(3487),
    [anon_sym_extern] = ACTIONS(3487),
    [anon_sym_alias] = ACTIONS(3487),
    [anon_sym_global] = ACTIONS(3487),
    [anon_sym_using] = ACTIONS(3487),
    [anon_sym_unsafe] = ACTIONS(3487),
    [anon_sym_static] = ACTIONS(3487),
    [anon_sym_LBRACK] = ACTIONS(3489),
    [anon_sym_LPAREN] = ACTIONS(3489),
    [anon_sym_event] = ACTIONS(3487),
    [anon_sym_namespace] = ACTIONS(3487),
    [anon_sym_class] = ACTIONS(3487),
    [anon_sym_ref] = ACTIONS(3487),
    [anon_sym_struct] = ACTIONS(3487),
    [anon_sym_enum] = ACTIONS(3487),
    [anon_sym_RBRACE] = ACTIONS(3489),
    [anon_sym_interface] = ACTIONS(3487),
    [anon_sym_delegate] = ACTIONS(3487),
    [anon_sym_record] = ACTIONS(3487),
    [anon_sym_abstract] = ACTIONS(3487),
    [anon_sym_async] = ACTIONS(3487),
    [anon_sym_const] = ACTIONS(3487),
    [anon_sym_file] = ACTIONS(3487),
    [anon_sym_fixed] = ACTIONS(3487),
    [anon_sym_internal] = ACTIONS(3487),
    [anon_sym_new] = ACTIONS(3487),
    [anon_sym_override] = ACTIONS(3487),
    [anon_sym_partial] = ACTIONS(3487),
    [anon_sym_private] = ACTIONS(3487),
    [anon_sym_protected] = ACTIONS(3487),
    [anon_sym_public] = ACTIONS(3487),
    [anon_sym_readonly] = ACTIONS(3487),
    [anon_sym_required] = ACTIONS(3487),
    [anon_sym_sealed] = ACTIONS(3487),
    [anon_sym_virtual] = ACTIONS(3487),
    [anon_sym_volatile] = ACTIONS(3487),
    [anon_sym_where] = ACTIONS(3487),
    [anon_sym_notnull] = ACTIONS(3487),
    [anon_sym_unmanaged] = ACTIONS(3487),
    [anon_sym_TILDE] = ACTIONS(3489),
    [anon_sym_implicit] = ACTIONS(3487),
    [anon_sym_explicit] = ACTIONS(3487),
    [anon_sym_scoped] = ACTIONS(3487),
    [anon_sym_var] = ACTIONS(3487),
    [sym_predefined_type] = ACTIONS(3487),
    [anon_sym_yield] = ACTIONS(3487),
    [anon_sym_when] = ACTIONS(3487),
    [anon_sym_from] = ACTIONS(3487),
    [anon_sym_into] = ACTIONS(3487),
    [anon_sym_join] = ACTIONS(3487),
    [anon_sym_on] = ACTIONS(3487),
    [anon_sym_equals] = ACTIONS(3487),
    [anon_sym_let] = ACTIONS(3487),
    [anon_sym_orderby] = ACTIONS(3487),
    [anon_sym_ascending] = ACTIONS(3487),
    [anon_sym_descending] = ACTIONS(3487),
    [anon_sym_group] = ACTIONS(3487),
    [anon_sym_by] = ACTIONS(3487),
    [anon_sym_select] = ACTIONS(3487),
    [aux_sym_preproc_if_token1] = ACTIONS(3489),
    [aux_sym_preproc_if_token3] = ACTIONS(3489),
    [aux_sym_preproc_else_token1] = ACTIONS(3489),
    [aux_sym_preproc_elif_token1] = ACTIONS(3489),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3229] = {
    [sym_preproc_region] = STATE(3229),
    [sym_preproc_endregion] = STATE(3229),
    [sym_preproc_line] = STATE(3229),
    [sym_preproc_pragma] = STATE(3229),
    [sym_preproc_nullable] = STATE(3229),
    [sym_preproc_error] = STATE(3229),
    [sym_preproc_define] = STATE(3229),
    [sym_preproc_undef] = STATE(3229),
    [sym__identifier_token] = ACTIONS(3467),
    [anon_sym_extern] = ACTIONS(3467),
    [anon_sym_alias] = ACTIONS(3467),
    [anon_sym_global] = ACTIONS(3467),
    [anon_sym_using] = ACTIONS(3467),
    [anon_sym_unsafe] = ACTIONS(3467),
    [anon_sym_static] = ACTIONS(3467),
    [anon_sym_LBRACK] = ACTIONS(3469),
    [anon_sym_LPAREN] = ACTIONS(3469),
    [anon_sym_event] = ACTIONS(3467),
    [anon_sym_namespace] = ACTIONS(3467),
    [anon_sym_class] = ACTIONS(3467),
    [anon_sym_ref] = ACTIONS(3467),
    [anon_sym_struct] = ACTIONS(3467),
    [anon_sym_enum] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(3469),
    [anon_sym_interface] = ACTIONS(3467),
    [anon_sym_delegate] = ACTIONS(3467),
    [anon_sym_record] = ACTIONS(3467),
    [anon_sym_abstract] = ACTIONS(3467),
    [anon_sym_async] = ACTIONS(3467),
    [anon_sym_const] = ACTIONS(3467),
    [anon_sym_file] = ACTIONS(3467),
    [anon_sym_fixed] = ACTIONS(3467),
    [anon_sym_internal] = ACTIONS(3467),
    [anon_sym_new] = ACTIONS(3467),
    [anon_sym_override] = ACTIONS(3467),
    [anon_sym_partial] = ACTIONS(3467),
    [anon_sym_private] = ACTIONS(3467),
    [anon_sym_protected] = ACTIONS(3467),
    [anon_sym_public] = ACTIONS(3467),
    [anon_sym_readonly] = ACTIONS(3467),
    [anon_sym_required] = ACTIONS(3467),
    [anon_sym_sealed] = ACTIONS(3467),
    [anon_sym_virtual] = ACTIONS(3467),
    [anon_sym_volatile] = ACTIONS(3467),
    [anon_sym_where] = ACTIONS(3467),
    [anon_sym_notnull] = ACTIONS(3467),
    [anon_sym_unmanaged] = ACTIONS(3467),
    [anon_sym_TILDE] = ACTIONS(3469),
    [anon_sym_implicit] = ACTIONS(3467),
    [anon_sym_explicit] = ACTIONS(3467),
    [anon_sym_scoped] = ACTIONS(3467),
    [anon_sym_var] = ACTIONS(3467),
    [sym_predefined_type] = ACTIONS(3467),
    [anon_sym_yield] = ACTIONS(3467),
    [anon_sym_when] = ACTIONS(3467),
    [anon_sym_from] = ACTIONS(3467),
    [anon_sym_into] = ACTIONS(3467),
    [anon_sym_join] = ACTIONS(3467),
    [anon_sym_on] = ACTIONS(3467),
    [anon_sym_equals] = ACTIONS(3467),
    [anon_sym_let] = ACTIONS(3467),
    [anon_sym_orderby] = ACTIONS(3467),
    [anon_sym_ascending] = ACTIONS(3467),
    [anon_sym_descending] = ACTIONS(3467),
    [anon_sym_group] = ACTIONS(3467),
    [anon_sym_by] = ACTIONS(3467),
    [anon_sym_select] = ACTIONS(3467),
    [aux_sym_preproc_if_token1] = ACTIONS(3469),
    [aux_sym_preproc_if_token3] = ACTIONS(3469),
    [aux_sym_preproc_else_token1] = ACTIONS(3469),
    [aux_sym_preproc_elif_token1] = ACTIONS(3469),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3230] = {
    [sym_preproc_region] = STATE(3230),
    [sym_preproc_endregion] = STATE(3230),
    [sym_preproc_line] = STATE(3230),
    [sym_preproc_pragma] = STATE(3230),
    [sym_preproc_nullable] = STATE(3230),
    [sym_preproc_error] = STATE(3230),
    [sym_preproc_define] = STATE(3230),
    [sym_preproc_undef] = STATE(3230),
    [sym__identifier_token] = ACTIONS(4622),
    [anon_sym_alias] = ACTIONS(4622),
    [anon_sym_global] = ACTIONS(4622),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_file] = ACTIONS(4622),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_where] = ACTIONS(4622),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_notnull] = ACTIONS(4622),
    [anon_sym_unmanaged] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_scoped] = ACTIONS(4622),
    [anon_sym_var] = ACTIONS(4622),
    [anon_sym_yield] = ACTIONS(4622),
    [anon_sym_switch] = ACTIONS(4622),
    [anon_sym_when] = ACTIONS(4622),
    [sym_discard] = ACTIONS(4622),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4622),
    [anon_sym_or] = ACTIONS(4622),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_from] = ACTIONS(4622),
    [anon_sym_into] = ACTIONS(4622),
    [anon_sym_join] = ACTIONS(4622),
    [anon_sym_on] = ACTIONS(4622),
    [anon_sym_equals] = ACTIONS(4622),
    [anon_sym_let] = ACTIONS(4622),
    [anon_sym_orderby] = ACTIONS(4622),
    [anon_sym_ascending] = ACTIONS(4622),
    [anon_sym_descending] = ACTIONS(4622),
    [anon_sym_group] = ACTIONS(4622),
    [anon_sym_by] = ACTIONS(4622),
    [anon_sym_select] = ACTIONS(4622),
    [anon_sym_as] = ACTIONS(4622),
    [anon_sym_is] = ACTIONS(4622),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4622),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4624),
  },
  [3231] = {
    [sym_preproc_region] = STATE(3231),
    [sym_preproc_endregion] = STATE(3231),
    [sym_preproc_line] = STATE(3231),
    [sym_preproc_pragma] = STATE(3231),
    [sym_preproc_nullable] = STATE(3231),
    [sym_preproc_error] = STATE(3231),
    [sym_preproc_define] = STATE(3231),
    [sym_preproc_undef] = STATE(3231),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4136),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_when] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4136),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3232] = {
    [sym_preproc_region] = STATE(3232),
    [sym_preproc_endregion] = STATE(3232),
    [sym_preproc_line] = STATE(3232),
    [sym_preproc_pragma] = STATE(3232),
    [sym_preproc_nullable] = STATE(3232),
    [sym_preproc_error] = STATE(3232),
    [sym_preproc_define] = STATE(3232),
    [sym_preproc_undef] = STATE(3232),
    [sym__identifier_token] = ACTIONS(3547),
    [anon_sym_extern] = ACTIONS(3547),
    [anon_sym_alias] = ACTIONS(3547),
    [anon_sym_global] = ACTIONS(3547),
    [anon_sym_using] = ACTIONS(3547),
    [anon_sym_unsafe] = ACTIONS(3547),
    [anon_sym_static] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(3549),
    [anon_sym_event] = ACTIONS(3547),
    [anon_sym_namespace] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3547),
    [anon_sym_ref] = ACTIONS(3547),
    [anon_sym_struct] = ACTIONS(3547),
    [anon_sym_enum] = ACTIONS(3547),
    [anon_sym_RBRACE] = ACTIONS(3549),
    [anon_sym_interface] = ACTIONS(3547),
    [anon_sym_delegate] = ACTIONS(3547),
    [anon_sym_record] = ACTIONS(3547),
    [anon_sym_abstract] = ACTIONS(3547),
    [anon_sym_async] = ACTIONS(3547),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_file] = ACTIONS(3547),
    [anon_sym_fixed] = ACTIONS(3547),
    [anon_sym_internal] = ACTIONS(3547),
    [anon_sym_new] = ACTIONS(3547),
    [anon_sym_override] = ACTIONS(3547),
    [anon_sym_partial] = ACTIONS(3547),
    [anon_sym_private] = ACTIONS(3547),
    [anon_sym_protected] = ACTIONS(3547),
    [anon_sym_public] = ACTIONS(3547),
    [anon_sym_readonly] = ACTIONS(3547),
    [anon_sym_required] = ACTIONS(3547),
    [anon_sym_sealed] = ACTIONS(3547),
    [anon_sym_virtual] = ACTIONS(3547),
    [anon_sym_volatile] = ACTIONS(3547),
    [anon_sym_where] = ACTIONS(3547),
    [anon_sym_notnull] = ACTIONS(3547),
    [anon_sym_unmanaged] = ACTIONS(3547),
    [anon_sym_TILDE] = ACTIONS(3549),
    [anon_sym_implicit] = ACTIONS(3547),
    [anon_sym_explicit] = ACTIONS(3547),
    [anon_sym_scoped] = ACTIONS(3547),
    [anon_sym_var] = ACTIONS(3547),
    [sym_predefined_type] = ACTIONS(3547),
    [anon_sym_yield] = ACTIONS(3547),
    [anon_sym_when] = ACTIONS(3547),
    [anon_sym_from] = ACTIONS(3547),
    [anon_sym_into] = ACTIONS(3547),
    [anon_sym_join] = ACTIONS(3547),
    [anon_sym_on] = ACTIONS(3547),
    [anon_sym_equals] = ACTIONS(3547),
    [anon_sym_let] = ACTIONS(3547),
    [anon_sym_orderby] = ACTIONS(3547),
    [anon_sym_ascending] = ACTIONS(3547),
    [anon_sym_descending] = ACTIONS(3547),
    [anon_sym_group] = ACTIONS(3547),
    [anon_sym_by] = ACTIONS(3547),
    [anon_sym_select] = ACTIONS(3547),
    [aux_sym_preproc_if_token1] = ACTIONS(3549),
    [aux_sym_preproc_if_token3] = ACTIONS(3549),
    [aux_sym_preproc_else_token1] = ACTIONS(3549),
    [aux_sym_preproc_elif_token1] = ACTIONS(3549),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3233] = {
    [sym__variable_designation] = STATE(5013),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3233),
    [sym_preproc_endregion] = STATE(3233),
    [sym_preproc_line] = STATE(3233),
    [sym_preproc_pragma] = STATE(3233),
    [sym_preproc_nullable] = STATE(3233),
    [sym_preproc_error] = STATE(3233),
    [sym_preproc_define] = STATE(3233),
    [sym_preproc_undef] = STATE(3233),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3234] = {
    [sym_preproc_region] = STATE(3234),
    [sym_preproc_endregion] = STATE(3234),
    [sym_preproc_line] = STATE(3234),
    [sym_preproc_pragma] = STATE(3234),
    [sym_preproc_nullable] = STATE(3234),
    [sym_preproc_error] = STATE(3234),
    [sym_preproc_define] = STATE(3234),
    [sym_preproc_undef] = STATE(3234),
    [sym__identifier_token] = ACTIONS(4832),
    [anon_sym_extern] = ACTIONS(4832),
    [anon_sym_alias] = ACTIONS(4832),
    [anon_sym_global] = ACTIONS(4832),
    [anon_sym_using] = ACTIONS(4832),
    [anon_sym_unsafe] = ACTIONS(4832),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_LPAREN] = ACTIONS(4834),
    [anon_sym_event] = ACTIONS(4832),
    [anon_sym_namespace] = ACTIONS(4832),
    [anon_sym_class] = ACTIONS(4832),
    [anon_sym_ref] = ACTIONS(4832),
    [anon_sym_struct] = ACTIONS(4832),
    [anon_sym_enum] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4834),
    [anon_sym_interface] = ACTIONS(4832),
    [anon_sym_delegate] = ACTIONS(4832),
    [anon_sym_record] = ACTIONS(4832),
    [anon_sym_abstract] = ACTIONS(4832),
    [anon_sym_async] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4832),
    [anon_sym_file] = ACTIONS(4832),
    [anon_sym_fixed] = ACTIONS(4832),
    [anon_sym_internal] = ACTIONS(4832),
    [anon_sym_new] = ACTIONS(4832),
    [anon_sym_override] = ACTIONS(4832),
    [anon_sym_partial] = ACTIONS(4832),
    [anon_sym_private] = ACTIONS(4832),
    [anon_sym_protected] = ACTIONS(4832),
    [anon_sym_public] = ACTIONS(4832),
    [anon_sym_readonly] = ACTIONS(4832),
    [anon_sym_required] = ACTIONS(4832),
    [anon_sym_sealed] = ACTIONS(4832),
    [anon_sym_virtual] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym_where] = ACTIONS(4832),
    [anon_sym_notnull] = ACTIONS(4832),
    [anon_sym_unmanaged] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4834),
    [anon_sym_implicit] = ACTIONS(4832),
    [anon_sym_explicit] = ACTIONS(4832),
    [anon_sym_scoped] = ACTIONS(4832),
    [anon_sym_var] = ACTIONS(4832),
    [sym_predefined_type] = ACTIONS(4832),
    [anon_sym_yield] = ACTIONS(4832),
    [anon_sym_when] = ACTIONS(4832),
    [anon_sym_from] = ACTIONS(4832),
    [anon_sym_into] = ACTIONS(4832),
    [anon_sym_join] = ACTIONS(4832),
    [anon_sym_on] = ACTIONS(4832),
    [anon_sym_equals] = ACTIONS(4832),
    [anon_sym_let] = ACTIONS(4832),
    [anon_sym_orderby] = ACTIONS(4832),
    [anon_sym_ascending] = ACTIONS(4832),
    [anon_sym_descending] = ACTIONS(4832),
    [anon_sym_group] = ACTIONS(4832),
    [anon_sym_by] = ACTIONS(4832),
    [anon_sym_select] = ACTIONS(4832),
    [aux_sym_preproc_if_token1] = ACTIONS(4834),
    [aux_sym_preproc_if_token3] = ACTIONS(4834),
    [aux_sym_preproc_else_token1] = ACTIONS(4834),
    [aux_sym_preproc_elif_token1] = ACTIONS(4834),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3235] = {
    [sym__variable_designation] = STATE(4055),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3235),
    [sym_preproc_endregion] = STATE(3235),
    [sym_preproc_line] = STATE(3235),
    [sym_preproc_pragma] = STATE(3235),
    [sym_preproc_nullable] = STATE(3235),
    [sym_preproc_error] = STATE(3235),
    [sym_preproc_define] = STATE(3235),
    [sym_preproc_undef] = STATE(3235),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4397),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3236] = {
    [sym_preproc_region] = STATE(3236),
    [sym_preproc_endregion] = STATE(3236),
    [sym_preproc_line] = STATE(3236),
    [sym_preproc_pragma] = STATE(3236),
    [sym_preproc_nullable] = STATE(3236),
    [sym_preproc_error] = STATE(3236),
    [sym_preproc_define] = STATE(3236),
    [sym_preproc_undef] = STATE(3236),
    [sym__identifier_token] = ACTIONS(3555),
    [anon_sym_extern] = ACTIONS(3555),
    [anon_sym_alias] = ACTIONS(3555),
    [anon_sym_global] = ACTIONS(3555),
    [anon_sym_using] = ACTIONS(3555),
    [anon_sym_unsafe] = ACTIONS(3555),
    [anon_sym_static] = ACTIONS(3555),
    [anon_sym_LBRACK] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(3557),
    [anon_sym_event] = ACTIONS(3555),
    [anon_sym_namespace] = ACTIONS(3555),
    [anon_sym_class] = ACTIONS(3555),
    [anon_sym_ref] = ACTIONS(3555),
    [anon_sym_struct] = ACTIONS(3555),
    [anon_sym_enum] = ACTIONS(3555),
    [anon_sym_RBRACE] = ACTIONS(3557),
    [anon_sym_interface] = ACTIONS(3555),
    [anon_sym_delegate] = ACTIONS(3555),
    [anon_sym_record] = ACTIONS(3555),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_async] = ACTIONS(3555),
    [anon_sym_const] = ACTIONS(3555),
    [anon_sym_file] = ACTIONS(3555),
    [anon_sym_fixed] = ACTIONS(3555),
    [anon_sym_internal] = ACTIONS(3555),
    [anon_sym_new] = ACTIONS(3555),
    [anon_sym_override] = ACTIONS(3555),
    [anon_sym_partial] = ACTIONS(3555),
    [anon_sym_private] = ACTIONS(3555),
    [anon_sym_protected] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(3555),
    [anon_sym_readonly] = ACTIONS(3555),
    [anon_sym_required] = ACTIONS(3555),
    [anon_sym_sealed] = ACTIONS(3555),
    [anon_sym_virtual] = ACTIONS(3555),
    [anon_sym_volatile] = ACTIONS(3555),
    [anon_sym_where] = ACTIONS(3555),
    [anon_sym_notnull] = ACTIONS(3555),
    [anon_sym_unmanaged] = ACTIONS(3555),
    [anon_sym_TILDE] = ACTIONS(3557),
    [anon_sym_implicit] = ACTIONS(3555),
    [anon_sym_explicit] = ACTIONS(3555),
    [anon_sym_scoped] = ACTIONS(3555),
    [anon_sym_var] = ACTIONS(3555),
    [sym_predefined_type] = ACTIONS(3555),
    [anon_sym_yield] = ACTIONS(3555),
    [anon_sym_when] = ACTIONS(3555),
    [anon_sym_from] = ACTIONS(3555),
    [anon_sym_into] = ACTIONS(3555),
    [anon_sym_join] = ACTIONS(3555),
    [anon_sym_on] = ACTIONS(3555),
    [anon_sym_equals] = ACTIONS(3555),
    [anon_sym_let] = ACTIONS(3555),
    [anon_sym_orderby] = ACTIONS(3555),
    [anon_sym_ascending] = ACTIONS(3555),
    [anon_sym_descending] = ACTIONS(3555),
    [anon_sym_group] = ACTIONS(3555),
    [anon_sym_by] = ACTIONS(3555),
    [anon_sym_select] = ACTIONS(3555),
    [aux_sym_preproc_if_token1] = ACTIONS(3557),
    [aux_sym_preproc_if_token3] = ACTIONS(3557),
    [aux_sym_preproc_else_token1] = ACTIONS(3557),
    [aux_sym_preproc_elif_token1] = ACTIONS(3557),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3237] = {
    [sym_preproc_region] = STATE(3237),
    [sym_preproc_endregion] = STATE(3237),
    [sym_preproc_line] = STATE(3237),
    [sym_preproc_pragma] = STATE(3237),
    [sym_preproc_nullable] = STATE(3237),
    [sym_preproc_error] = STATE(3237),
    [sym_preproc_define] = STATE(3237),
    [sym_preproc_undef] = STATE(3237),
    [sym__identifier_token] = ACTIONS(3755),
    [anon_sym_extern] = ACTIONS(3755),
    [anon_sym_alias] = ACTIONS(3755),
    [anon_sym_global] = ACTIONS(3755),
    [anon_sym_using] = ACTIONS(3755),
    [anon_sym_unsafe] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3757),
    [anon_sym_event] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_ref] = ACTIONS(3755),
    [anon_sym_struct] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3757),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_delegate] = ACTIONS(3755),
    [anon_sym_record] = ACTIONS(3755),
    [anon_sym_abstract] = ACTIONS(3755),
    [anon_sym_async] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [anon_sym_file] = ACTIONS(3755),
    [anon_sym_fixed] = ACTIONS(3755),
    [anon_sym_internal] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_override] = ACTIONS(3755),
    [anon_sym_partial] = ACTIONS(3755),
    [anon_sym_private] = ACTIONS(3755),
    [anon_sym_protected] = ACTIONS(3755),
    [anon_sym_public] = ACTIONS(3755),
    [anon_sym_readonly] = ACTIONS(3755),
    [anon_sym_required] = ACTIONS(3755),
    [anon_sym_sealed] = ACTIONS(3755),
    [anon_sym_virtual] = ACTIONS(3755),
    [anon_sym_volatile] = ACTIONS(3755),
    [anon_sym_where] = ACTIONS(3755),
    [anon_sym_notnull] = ACTIONS(3755),
    [anon_sym_unmanaged] = ACTIONS(3755),
    [anon_sym_TILDE] = ACTIONS(3757),
    [anon_sym_implicit] = ACTIONS(3755),
    [anon_sym_explicit] = ACTIONS(3755),
    [anon_sym_scoped] = ACTIONS(3755),
    [anon_sym_var] = ACTIONS(3755),
    [sym_predefined_type] = ACTIONS(3755),
    [anon_sym_yield] = ACTIONS(3755),
    [anon_sym_when] = ACTIONS(3755),
    [anon_sym_from] = ACTIONS(3755),
    [anon_sym_into] = ACTIONS(3755),
    [anon_sym_join] = ACTIONS(3755),
    [anon_sym_on] = ACTIONS(3755),
    [anon_sym_equals] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_orderby] = ACTIONS(3755),
    [anon_sym_ascending] = ACTIONS(3755),
    [anon_sym_descending] = ACTIONS(3755),
    [anon_sym_group] = ACTIONS(3755),
    [anon_sym_by] = ACTIONS(3755),
    [anon_sym_select] = ACTIONS(3755),
    [aux_sym_preproc_if_token1] = ACTIONS(3757),
    [aux_sym_preproc_if_token3] = ACTIONS(3757),
    [aux_sym_preproc_else_token1] = ACTIONS(3757),
    [aux_sym_preproc_elif_token1] = ACTIONS(3757),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3238] = {
    [sym_preproc_region] = STATE(3238),
    [sym_preproc_endregion] = STATE(3238),
    [sym_preproc_line] = STATE(3238),
    [sym_preproc_pragma] = STATE(3238),
    [sym_preproc_nullable] = STATE(3238),
    [sym_preproc_error] = STATE(3238),
    [sym_preproc_define] = STATE(3238),
    [sym_preproc_undef] = STATE(3238),
    [sym__identifier_token] = ACTIONS(4618),
    [anon_sym_alias] = ACTIONS(4618),
    [anon_sym_global] = ACTIONS(4618),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_file] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_notnull] = ACTIONS(4618),
    [anon_sym_unmanaged] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_scoped] = ACTIONS(4618),
    [anon_sym_var] = ACTIONS(4618),
    [anon_sym_yield] = ACTIONS(4618),
    [anon_sym_switch] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [sym_discard] = ACTIONS(4618),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4618),
    [anon_sym_or] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_from] = ACTIONS(4618),
    [anon_sym_into] = ACTIONS(4618),
    [anon_sym_join] = ACTIONS(4618),
    [anon_sym_on] = ACTIONS(4618),
    [anon_sym_equals] = ACTIONS(4618),
    [anon_sym_let] = ACTIONS(4618),
    [anon_sym_orderby] = ACTIONS(4618),
    [anon_sym_ascending] = ACTIONS(4618),
    [anon_sym_descending] = ACTIONS(4618),
    [anon_sym_group] = ACTIONS(4618),
    [anon_sym_by] = ACTIONS(4618),
    [anon_sym_select] = ACTIONS(4618),
    [anon_sym_as] = ACTIONS(4618),
    [anon_sym_is] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4618),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4620),
  },
  [3239] = {
    [sym_preproc_region] = STATE(3239),
    [sym_preproc_endregion] = STATE(3239),
    [sym_preproc_line] = STATE(3239),
    [sym_preproc_pragma] = STATE(3239),
    [sym_preproc_nullable] = STATE(3239),
    [sym_preproc_error] = STATE(3239),
    [sym_preproc_define] = STATE(3239),
    [sym_preproc_undef] = STATE(3239),
    [sym__identifier_token] = ACTIONS(3799),
    [anon_sym_extern] = ACTIONS(3799),
    [anon_sym_alias] = ACTIONS(3799),
    [anon_sym_global] = ACTIONS(3799),
    [anon_sym_using] = ACTIONS(3799),
    [anon_sym_unsafe] = ACTIONS(3799),
    [anon_sym_static] = ACTIONS(3799),
    [anon_sym_LBRACK] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3801),
    [anon_sym_event] = ACTIONS(3799),
    [anon_sym_namespace] = ACTIONS(3799),
    [anon_sym_class] = ACTIONS(3799),
    [anon_sym_ref] = ACTIONS(3799),
    [anon_sym_struct] = ACTIONS(3799),
    [anon_sym_enum] = ACTIONS(3799),
    [anon_sym_RBRACE] = ACTIONS(3801),
    [anon_sym_interface] = ACTIONS(3799),
    [anon_sym_delegate] = ACTIONS(3799),
    [anon_sym_record] = ACTIONS(3799),
    [anon_sym_abstract] = ACTIONS(3799),
    [anon_sym_async] = ACTIONS(3799),
    [anon_sym_const] = ACTIONS(3799),
    [anon_sym_file] = ACTIONS(3799),
    [anon_sym_fixed] = ACTIONS(3799),
    [anon_sym_internal] = ACTIONS(3799),
    [anon_sym_new] = ACTIONS(3799),
    [anon_sym_override] = ACTIONS(3799),
    [anon_sym_partial] = ACTIONS(3799),
    [anon_sym_private] = ACTIONS(3799),
    [anon_sym_protected] = ACTIONS(3799),
    [anon_sym_public] = ACTIONS(3799),
    [anon_sym_readonly] = ACTIONS(3799),
    [anon_sym_required] = ACTIONS(3799),
    [anon_sym_sealed] = ACTIONS(3799),
    [anon_sym_virtual] = ACTIONS(3799),
    [anon_sym_volatile] = ACTIONS(3799),
    [anon_sym_where] = ACTIONS(3799),
    [anon_sym_notnull] = ACTIONS(3799),
    [anon_sym_unmanaged] = ACTIONS(3799),
    [anon_sym_TILDE] = ACTIONS(3801),
    [anon_sym_implicit] = ACTIONS(3799),
    [anon_sym_explicit] = ACTIONS(3799),
    [anon_sym_scoped] = ACTIONS(3799),
    [anon_sym_var] = ACTIONS(3799),
    [sym_predefined_type] = ACTIONS(3799),
    [anon_sym_yield] = ACTIONS(3799),
    [anon_sym_when] = ACTIONS(3799),
    [anon_sym_from] = ACTIONS(3799),
    [anon_sym_into] = ACTIONS(3799),
    [anon_sym_join] = ACTIONS(3799),
    [anon_sym_on] = ACTIONS(3799),
    [anon_sym_equals] = ACTIONS(3799),
    [anon_sym_let] = ACTIONS(3799),
    [anon_sym_orderby] = ACTIONS(3799),
    [anon_sym_ascending] = ACTIONS(3799),
    [anon_sym_descending] = ACTIONS(3799),
    [anon_sym_group] = ACTIONS(3799),
    [anon_sym_by] = ACTIONS(3799),
    [anon_sym_select] = ACTIONS(3799),
    [aux_sym_preproc_if_token1] = ACTIONS(3801),
    [aux_sym_preproc_if_token3] = ACTIONS(3801),
    [aux_sym_preproc_else_token1] = ACTIONS(3801),
    [aux_sym_preproc_elif_token1] = ACTIONS(3801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3240] = {
    [sym__variable_designation] = STATE(3999),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3240),
    [sym_preproc_endregion] = STATE(3240),
    [sym_preproc_line] = STATE(3240),
    [sym_preproc_pragma] = STATE(3240),
    [sym_preproc_nullable] = STATE(3240),
    [sym_preproc_error] = STATE(3240),
    [sym_preproc_define] = STATE(3240),
    [sym_preproc_undef] = STATE(3240),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4435),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3241] = {
    [sym_preproc_region] = STATE(3241),
    [sym_preproc_endregion] = STATE(3241),
    [sym_preproc_line] = STATE(3241),
    [sym_preproc_pragma] = STATE(3241),
    [sym_preproc_nullable] = STATE(3241),
    [sym_preproc_error] = STATE(3241),
    [sym_preproc_define] = STATE(3241),
    [sym_preproc_undef] = STATE(3241),
    [sym__identifier_token] = ACTIONS(3655),
    [anon_sym_extern] = ACTIONS(3655),
    [anon_sym_alias] = ACTIONS(3655),
    [anon_sym_global] = ACTIONS(3655),
    [anon_sym_using] = ACTIONS(3655),
    [anon_sym_unsafe] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3657),
    [anon_sym_LPAREN] = ACTIONS(3657),
    [anon_sym_event] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_ref] = ACTIONS(3655),
    [anon_sym_struct] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_delegate] = ACTIONS(3655),
    [anon_sym_record] = ACTIONS(3655),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_async] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [anon_sym_file] = ACTIONS(3655),
    [anon_sym_fixed] = ACTIONS(3655),
    [anon_sym_internal] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_override] = ACTIONS(3655),
    [anon_sym_partial] = ACTIONS(3655),
    [anon_sym_private] = ACTIONS(3655),
    [anon_sym_protected] = ACTIONS(3655),
    [anon_sym_public] = ACTIONS(3655),
    [anon_sym_readonly] = ACTIONS(3655),
    [anon_sym_required] = ACTIONS(3655),
    [anon_sym_sealed] = ACTIONS(3655),
    [anon_sym_virtual] = ACTIONS(3655),
    [anon_sym_volatile] = ACTIONS(3655),
    [anon_sym_where] = ACTIONS(3655),
    [anon_sym_notnull] = ACTIONS(3655),
    [anon_sym_unmanaged] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3657),
    [anon_sym_implicit] = ACTIONS(3655),
    [anon_sym_explicit] = ACTIONS(3655),
    [anon_sym_scoped] = ACTIONS(3655),
    [anon_sym_var] = ACTIONS(3655),
    [sym_predefined_type] = ACTIONS(3655),
    [anon_sym_yield] = ACTIONS(3655),
    [anon_sym_when] = ACTIONS(3655),
    [anon_sym_from] = ACTIONS(3655),
    [anon_sym_into] = ACTIONS(3655),
    [anon_sym_join] = ACTIONS(3655),
    [anon_sym_on] = ACTIONS(3655),
    [anon_sym_equals] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_orderby] = ACTIONS(3655),
    [anon_sym_ascending] = ACTIONS(3655),
    [anon_sym_descending] = ACTIONS(3655),
    [anon_sym_group] = ACTIONS(3655),
    [anon_sym_by] = ACTIONS(3655),
    [anon_sym_select] = ACTIONS(3655),
    [aux_sym_preproc_if_token1] = ACTIONS(3657),
    [aux_sym_preproc_if_token3] = ACTIONS(3657),
    [aux_sym_preproc_else_token1] = ACTIONS(3657),
    [aux_sym_preproc_elif_token1] = ACTIONS(3657),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3242] = {
    [sym__variable_designation] = STATE(4008),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3242),
    [sym_preproc_endregion] = STATE(3242),
    [sym_preproc_line] = STATE(3242),
    [sym_preproc_pragma] = STATE(3242),
    [sym_preproc_nullable] = STATE(3242),
    [sym_preproc_error] = STATE(3242),
    [sym_preproc_define] = STATE(3242),
    [sym_preproc_undef] = STATE(3242),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4445),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3243] = {
    [sym__variable_designation] = STATE(4018),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3243),
    [sym_preproc_endregion] = STATE(3243),
    [sym_preproc_line] = STATE(3243),
    [sym_preproc_pragma] = STATE(3243),
    [sym_preproc_nullable] = STATE(3243),
    [sym_preproc_error] = STATE(3243),
    [sym_preproc_define] = STATE(3243),
    [sym_preproc_undef] = STATE(3243),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4405),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3244] = {
    [sym_preproc_region] = STATE(3244),
    [sym_preproc_endregion] = STATE(3244),
    [sym_preproc_line] = STATE(3244),
    [sym_preproc_pragma] = STATE(3244),
    [sym_preproc_nullable] = STATE(3244),
    [sym_preproc_error] = STATE(3244),
    [sym_preproc_define] = STATE(3244),
    [sym_preproc_undef] = STATE(3244),
    [sym__identifier_token] = ACTIONS(3439),
    [anon_sym_extern] = ACTIONS(3439),
    [anon_sym_alias] = ACTIONS(3439),
    [anon_sym_global] = ACTIONS(3439),
    [anon_sym_using] = ACTIONS(3439),
    [anon_sym_unsafe] = ACTIONS(3439),
    [anon_sym_static] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3441),
    [anon_sym_event] = ACTIONS(3439),
    [anon_sym_namespace] = ACTIONS(3439),
    [anon_sym_class] = ACTIONS(3439),
    [anon_sym_ref] = ACTIONS(3439),
    [anon_sym_struct] = ACTIONS(3439),
    [anon_sym_enum] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_interface] = ACTIONS(3439),
    [anon_sym_delegate] = ACTIONS(3439),
    [anon_sym_record] = ACTIONS(3439),
    [anon_sym_abstract] = ACTIONS(3439),
    [anon_sym_async] = ACTIONS(3439),
    [anon_sym_const] = ACTIONS(3439),
    [anon_sym_file] = ACTIONS(3439),
    [anon_sym_fixed] = ACTIONS(3439),
    [anon_sym_internal] = ACTIONS(3439),
    [anon_sym_new] = ACTIONS(3439),
    [anon_sym_override] = ACTIONS(3439),
    [anon_sym_partial] = ACTIONS(3439),
    [anon_sym_private] = ACTIONS(3439),
    [anon_sym_protected] = ACTIONS(3439),
    [anon_sym_public] = ACTIONS(3439),
    [anon_sym_readonly] = ACTIONS(3439),
    [anon_sym_required] = ACTIONS(3439),
    [anon_sym_sealed] = ACTIONS(3439),
    [anon_sym_virtual] = ACTIONS(3439),
    [anon_sym_volatile] = ACTIONS(3439),
    [anon_sym_where] = ACTIONS(3439),
    [anon_sym_notnull] = ACTIONS(3439),
    [anon_sym_unmanaged] = ACTIONS(3439),
    [anon_sym_TILDE] = ACTIONS(3441),
    [anon_sym_implicit] = ACTIONS(3439),
    [anon_sym_explicit] = ACTIONS(3439),
    [anon_sym_scoped] = ACTIONS(3439),
    [anon_sym_var] = ACTIONS(3439),
    [sym_predefined_type] = ACTIONS(3439),
    [anon_sym_yield] = ACTIONS(3439),
    [anon_sym_when] = ACTIONS(3439),
    [anon_sym_from] = ACTIONS(3439),
    [anon_sym_into] = ACTIONS(3439),
    [anon_sym_join] = ACTIONS(3439),
    [anon_sym_on] = ACTIONS(3439),
    [anon_sym_equals] = ACTIONS(3439),
    [anon_sym_let] = ACTIONS(3439),
    [anon_sym_orderby] = ACTIONS(3439),
    [anon_sym_ascending] = ACTIONS(3439),
    [anon_sym_descending] = ACTIONS(3439),
    [anon_sym_group] = ACTIONS(3439),
    [anon_sym_by] = ACTIONS(3439),
    [anon_sym_select] = ACTIONS(3439),
    [aux_sym_preproc_if_token1] = ACTIONS(3441),
    [aux_sym_preproc_if_token3] = ACTIONS(3441),
    [aux_sym_preproc_else_token1] = ACTIONS(3441),
    [aux_sym_preproc_elif_token1] = ACTIONS(3441),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3245] = {
    [sym_preproc_region] = STATE(3245),
    [sym_preproc_endregion] = STATE(3245),
    [sym_preproc_line] = STATE(3245),
    [sym_preproc_pragma] = STATE(3245),
    [sym_preproc_nullable] = STATE(3245),
    [sym_preproc_error] = STATE(3245),
    [sym_preproc_define] = STATE(3245),
    [sym_preproc_undef] = STATE(3245),
    [sym__identifier_token] = ACTIONS(3743),
    [anon_sym_extern] = ACTIONS(3743),
    [anon_sym_alias] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_using] = ACTIONS(3743),
    [anon_sym_unsafe] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [anon_sym_event] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_ref] = ACTIONS(3743),
    [anon_sym_struct] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_delegate] = ACTIONS(3743),
    [anon_sym_record] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [anon_sym_file] = ACTIONS(3743),
    [anon_sym_fixed] = ACTIONS(3743),
    [anon_sym_internal] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_override] = ACTIONS(3743),
    [anon_sym_partial] = ACTIONS(3743),
    [anon_sym_private] = ACTIONS(3743),
    [anon_sym_protected] = ACTIONS(3743),
    [anon_sym_public] = ACTIONS(3743),
    [anon_sym_readonly] = ACTIONS(3743),
    [anon_sym_required] = ACTIONS(3743),
    [anon_sym_sealed] = ACTIONS(3743),
    [anon_sym_virtual] = ACTIONS(3743),
    [anon_sym_volatile] = ACTIONS(3743),
    [anon_sym_where] = ACTIONS(3743),
    [anon_sym_notnull] = ACTIONS(3743),
    [anon_sym_unmanaged] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_implicit] = ACTIONS(3743),
    [anon_sym_explicit] = ACTIONS(3743),
    [anon_sym_scoped] = ACTIONS(3743),
    [anon_sym_var] = ACTIONS(3743),
    [sym_predefined_type] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_when] = ACTIONS(3743),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_into] = ACTIONS(3743),
    [anon_sym_join] = ACTIONS(3743),
    [anon_sym_on] = ACTIONS(3743),
    [anon_sym_equals] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_orderby] = ACTIONS(3743),
    [anon_sym_ascending] = ACTIONS(3743),
    [anon_sym_descending] = ACTIONS(3743),
    [anon_sym_group] = ACTIONS(3743),
    [anon_sym_by] = ACTIONS(3743),
    [anon_sym_select] = ACTIONS(3743),
    [aux_sym_preproc_if_token1] = ACTIONS(3745),
    [aux_sym_preproc_if_token3] = ACTIONS(3745),
    [aux_sym_preproc_else_token1] = ACTIONS(3745),
    [aux_sym_preproc_elif_token1] = ACTIONS(3745),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3246] = {
    [sym_preproc_region] = STATE(3246),
    [sym_preproc_endregion] = STATE(3246),
    [sym_preproc_line] = STATE(3246),
    [sym_preproc_pragma] = STATE(3246),
    [sym_preproc_nullable] = STATE(3246),
    [sym_preproc_error] = STATE(3246),
    [sym_preproc_define] = STATE(3246),
    [sym_preproc_undef] = STATE(3246),
    [sym__identifier_token] = ACTIONS(3515),
    [anon_sym_extern] = ACTIONS(3515),
    [anon_sym_alias] = ACTIONS(3515),
    [anon_sym_global] = ACTIONS(3515),
    [anon_sym_using] = ACTIONS(3515),
    [anon_sym_unsafe] = ACTIONS(3515),
    [anon_sym_static] = ACTIONS(3515),
    [anon_sym_LBRACK] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3517),
    [anon_sym_event] = ACTIONS(3515),
    [anon_sym_namespace] = ACTIONS(3515),
    [anon_sym_class] = ACTIONS(3515),
    [anon_sym_ref] = ACTIONS(3515),
    [anon_sym_struct] = ACTIONS(3515),
    [anon_sym_enum] = ACTIONS(3515),
    [anon_sym_RBRACE] = ACTIONS(3517),
    [anon_sym_interface] = ACTIONS(3515),
    [anon_sym_delegate] = ACTIONS(3515),
    [anon_sym_record] = ACTIONS(3515),
    [anon_sym_abstract] = ACTIONS(3515),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_const] = ACTIONS(3515),
    [anon_sym_file] = ACTIONS(3515),
    [anon_sym_fixed] = ACTIONS(3515),
    [anon_sym_internal] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3515),
    [anon_sym_override] = ACTIONS(3515),
    [anon_sym_partial] = ACTIONS(3515),
    [anon_sym_private] = ACTIONS(3515),
    [anon_sym_protected] = ACTIONS(3515),
    [anon_sym_public] = ACTIONS(3515),
    [anon_sym_readonly] = ACTIONS(3515),
    [anon_sym_required] = ACTIONS(3515),
    [anon_sym_sealed] = ACTIONS(3515),
    [anon_sym_virtual] = ACTIONS(3515),
    [anon_sym_volatile] = ACTIONS(3515),
    [anon_sym_where] = ACTIONS(3515),
    [anon_sym_notnull] = ACTIONS(3515),
    [anon_sym_unmanaged] = ACTIONS(3515),
    [anon_sym_TILDE] = ACTIONS(3517),
    [anon_sym_implicit] = ACTIONS(3515),
    [anon_sym_explicit] = ACTIONS(3515),
    [anon_sym_scoped] = ACTIONS(3515),
    [anon_sym_var] = ACTIONS(3515),
    [sym_predefined_type] = ACTIONS(3515),
    [anon_sym_yield] = ACTIONS(3515),
    [anon_sym_when] = ACTIONS(3515),
    [anon_sym_from] = ACTIONS(3515),
    [anon_sym_into] = ACTIONS(3515),
    [anon_sym_join] = ACTIONS(3515),
    [anon_sym_on] = ACTIONS(3515),
    [anon_sym_equals] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3515),
    [anon_sym_orderby] = ACTIONS(3515),
    [anon_sym_ascending] = ACTIONS(3515),
    [anon_sym_descending] = ACTIONS(3515),
    [anon_sym_group] = ACTIONS(3515),
    [anon_sym_by] = ACTIONS(3515),
    [anon_sym_select] = ACTIONS(3515),
    [aux_sym_preproc_if_token1] = ACTIONS(3517),
    [aux_sym_preproc_if_token3] = ACTIONS(3517),
    [aux_sym_preproc_else_token1] = ACTIONS(3517),
    [aux_sym_preproc_elif_token1] = ACTIONS(3517),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3247] = {
    [sym_preproc_region] = STATE(3247),
    [sym_preproc_endregion] = STATE(3247),
    [sym_preproc_line] = STATE(3247),
    [sym_preproc_pragma] = STATE(3247),
    [sym_preproc_nullable] = STATE(3247),
    [sym_preproc_error] = STATE(3247),
    [sym_preproc_define] = STATE(3247),
    [sym_preproc_undef] = STATE(3247),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_RBRACK] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_in] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_EQ_GT] = ACTIONS(4654),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_when] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4654),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_on] = ACTIONS(4654),
    [anon_sym_equals] = ACTIONS(4654),
    [anon_sym_by] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4654),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_if_token3] = ACTIONS(4654),
    [aux_sym_preproc_else_token1] = ACTIONS(4654),
    [aux_sym_preproc_elif_token1] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3248] = {
    [sym_preproc_region] = STATE(3248),
    [sym_preproc_endregion] = STATE(3248),
    [sym_preproc_line] = STATE(3248),
    [sym_preproc_pragma] = STATE(3248),
    [sym_preproc_nullable] = STATE(3248),
    [sym_preproc_error] = STATE(3248),
    [sym_preproc_define] = STATE(3248),
    [sym_preproc_undef] = STATE(3248),
    [sym__identifier_token] = ACTIONS(4836),
    [anon_sym_extern] = ACTIONS(4836),
    [anon_sym_alias] = ACTIONS(4836),
    [anon_sym_global] = ACTIONS(4836),
    [anon_sym_using] = ACTIONS(4836),
    [anon_sym_unsafe] = ACTIONS(4836),
    [anon_sym_static] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4838),
    [anon_sym_LPAREN] = ACTIONS(4838),
    [anon_sym_event] = ACTIONS(4836),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_class] = ACTIONS(4836),
    [anon_sym_ref] = ACTIONS(4836),
    [anon_sym_struct] = ACTIONS(4836),
    [anon_sym_enum] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_interface] = ACTIONS(4836),
    [anon_sym_delegate] = ACTIONS(4836),
    [anon_sym_record] = ACTIONS(4836),
    [anon_sym_abstract] = ACTIONS(4836),
    [anon_sym_async] = ACTIONS(4836),
    [anon_sym_const] = ACTIONS(4836),
    [anon_sym_file] = ACTIONS(4836),
    [anon_sym_fixed] = ACTIONS(4836),
    [anon_sym_internal] = ACTIONS(4836),
    [anon_sym_new] = ACTIONS(4836),
    [anon_sym_override] = ACTIONS(4836),
    [anon_sym_partial] = ACTIONS(4836),
    [anon_sym_private] = ACTIONS(4836),
    [anon_sym_protected] = ACTIONS(4836),
    [anon_sym_public] = ACTIONS(4836),
    [anon_sym_readonly] = ACTIONS(4836),
    [anon_sym_required] = ACTIONS(4836),
    [anon_sym_sealed] = ACTIONS(4836),
    [anon_sym_virtual] = ACTIONS(4836),
    [anon_sym_volatile] = ACTIONS(4836),
    [anon_sym_where] = ACTIONS(4836),
    [anon_sym_notnull] = ACTIONS(4836),
    [anon_sym_unmanaged] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4838),
    [anon_sym_implicit] = ACTIONS(4836),
    [anon_sym_explicit] = ACTIONS(4836),
    [anon_sym_scoped] = ACTIONS(4836),
    [anon_sym_var] = ACTIONS(4836),
    [sym_predefined_type] = ACTIONS(4836),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_when] = ACTIONS(4836),
    [anon_sym_from] = ACTIONS(4836),
    [anon_sym_into] = ACTIONS(4836),
    [anon_sym_join] = ACTIONS(4836),
    [anon_sym_on] = ACTIONS(4836),
    [anon_sym_equals] = ACTIONS(4836),
    [anon_sym_let] = ACTIONS(4836),
    [anon_sym_orderby] = ACTIONS(4836),
    [anon_sym_ascending] = ACTIONS(4836),
    [anon_sym_descending] = ACTIONS(4836),
    [anon_sym_group] = ACTIONS(4836),
    [anon_sym_by] = ACTIONS(4836),
    [anon_sym_select] = ACTIONS(4836),
    [aux_sym_preproc_if_token1] = ACTIONS(4838),
    [aux_sym_preproc_if_token3] = ACTIONS(4838),
    [aux_sym_preproc_else_token1] = ACTIONS(4838),
    [aux_sym_preproc_elif_token1] = ACTIONS(4838),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3249] = {
    [sym_preproc_region] = STATE(3249),
    [sym_preproc_endregion] = STATE(3249),
    [sym_preproc_line] = STATE(3249),
    [sym_preproc_pragma] = STATE(3249),
    [sym_preproc_nullable] = STATE(3249),
    [sym_preproc_error] = STATE(3249),
    [sym_preproc_define] = STATE(3249),
    [sym_preproc_undef] = STATE(3249),
    [sym__identifier_token] = ACTIONS(3607),
    [anon_sym_extern] = ACTIONS(3607),
    [anon_sym_alias] = ACTIONS(3607),
    [anon_sym_global] = ACTIONS(3607),
    [anon_sym_using] = ACTIONS(3607),
    [anon_sym_unsafe] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [anon_sym_event] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_ref] = ACTIONS(3607),
    [anon_sym_struct] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_delegate] = ACTIONS(3607),
    [anon_sym_record] = ACTIONS(3607),
    [anon_sym_abstract] = ACTIONS(3607),
    [anon_sym_async] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [anon_sym_file] = ACTIONS(3607),
    [anon_sym_fixed] = ACTIONS(3607),
    [anon_sym_internal] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [anon_sym_override] = ACTIONS(3607),
    [anon_sym_partial] = ACTIONS(3607),
    [anon_sym_private] = ACTIONS(3607),
    [anon_sym_protected] = ACTIONS(3607),
    [anon_sym_public] = ACTIONS(3607),
    [anon_sym_readonly] = ACTIONS(3607),
    [anon_sym_required] = ACTIONS(3607),
    [anon_sym_sealed] = ACTIONS(3607),
    [anon_sym_virtual] = ACTIONS(3607),
    [anon_sym_volatile] = ACTIONS(3607),
    [anon_sym_where] = ACTIONS(3607),
    [anon_sym_notnull] = ACTIONS(3607),
    [anon_sym_unmanaged] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_implicit] = ACTIONS(3607),
    [anon_sym_explicit] = ACTIONS(3607),
    [anon_sym_scoped] = ACTIONS(3607),
    [anon_sym_var] = ACTIONS(3607),
    [sym_predefined_type] = ACTIONS(3607),
    [anon_sym_yield] = ACTIONS(3607),
    [anon_sym_when] = ACTIONS(3607),
    [anon_sym_from] = ACTIONS(3607),
    [anon_sym_into] = ACTIONS(3607),
    [anon_sym_join] = ACTIONS(3607),
    [anon_sym_on] = ACTIONS(3607),
    [anon_sym_equals] = ACTIONS(3607),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_orderby] = ACTIONS(3607),
    [anon_sym_ascending] = ACTIONS(3607),
    [anon_sym_descending] = ACTIONS(3607),
    [anon_sym_group] = ACTIONS(3607),
    [anon_sym_by] = ACTIONS(3607),
    [anon_sym_select] = ACTIONS(3607),
    [aux_sym_preproc_if_token1] = ACTIONS(3609),
    [aux_sym_preproc_if_token3] = ACTIONS(3609),
    [aux_sym_preproc_else_token1] = ACTIONS(3609),
    [aux_sym_preproc_elif_token1] = ACTIONS(3609),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3250] = {
    [sym_preproc_region] = STATE(3250),
    [sym_preproc_endregion] = STATE(3250),
    [sym_preproc_line] = STATE(3250),
    [sym_preproc_pragma] = STATE(3250),
    [sym_preproc_nullable] = STATE(3250),
    [sym_preproc_error] = STATE(3250),
    [sym_preproc_define] = STATE(3250),
    [sym_preproc_undef] = STATE(3250),
    [sym__identifier_token] = ACTIONS(3615),
    [anon_sym_extern] = ACTIONS(3615),
    [anon_sym_alias] = ACTIONS(3615),
    [anon_sym_global] = ACTIONS(3615),
    [anon_sym_using] = ACTIONS(3615),
    [anon_sym_unsafe] = ACTIONS(3615),
    [anon_sym_static] = ACTIONS(3615),
    [anon_sym_LBRACK] = ACTIONS(3617),
    [anon_sym_LPAREN] = ACTIONS(3617),
    [anon_sym_event] = ACTIONS(3615),
    [anon_sym_namespace] = ACTIONS(3615),
    [anon_sym_class] = ACTIONS(3615),
    [anon_sym_ref] = ACTIONS(3615),
    [anon_sym_struct] = ACTIONS(3615),
    [anon_sym_enum] = ACTIONS(3615),
    [anon_sym_RBRACE] = ACTIONS(3617),
    [anon_sym_interface] = ACTIONS(3615),
    [anon_sym_delegate] = ACTIONS(3615),
    [anon_sym_record] = ACTIONS(3615),
    [anon_sym_abstract] = ACTIONS(3615),
    [anon_sym_async] = ACTIONS(3615),
    [anon_sym_const] = ACTIONS(3615),
    [anon_sym_file] = ACTIONS(3615),
    [anon_sym_fixed] = ACTIONS(3615),
    [anon_sym_internal] = ACTIONS(3615),
    [anon_sym_new] = ACTIONS(3615),
    [anon_sym_override] = ACTIONS(3615),
    [anon_sym_partial] = ACTIONS(3615),
    [anon_sym_private] = ACTIONS(3615),
    [anon_sym_protected] = ACTIONS(3615),
    [anon_sym_public] = ACTIONS(3615),
    [anon_sym_readonly] = ACTIONS(3615),
    [anon_sym_required] = ACTIONS(3615),
    [anon_sym_sealed] = ACTIONS(3615),
    [anon_sym_virtual] = ACTIONS(3615),
    [anon_sym_volatile] = ACTIONS(3615),
    [anon_sym_where] = ACTIONS(3615),
    [anon_sym_notnull] = ACTIONS(3615),
    [anon_sym_unmanaged] = ACTIONS(3615),
    [anon_sym_TILDE] = ACTIONS(3617),
    [anon_sym_implicit] = ACTIONS(3615),
    [anon_sym_explicit] = ACTIONS(3615),
    [anon_sym_scoped] = ACTIONS(3615),
    [anon_sym_var] = ACTIONS(3615),
    [sym_predefined_type] = ACTIONS(3615),
    [anon_sym_yield] = ACTIONS(3615),
    [anon_sym_when] = ACTIONS(3615),
    [anon_sym_from] = ACTIONS(3615),
    [anon_sym_into] = ACTIONS(3615),
    [anon_sym_join] = ACTIONS(3615),
    [anon_sym_on] = ACTIONS(3615),
    [anon_sym_equals] = ACTIONS(3615),
    [anon_sym_let] = ACTIONS(3615),
    [anon_sym_orderby] = ACTIONS(3615),
    [anon_sym_ascending] = ACTIONS(3615),
    [anon_sym_descending] = ACTIONS(3615),
    [anon_sym_group] = ACTIONS(3615),
    [anon_sym_by] = ACTIONS(3615),
    [anon_sym_select] = ACTIONS(3615),
    [aux_sym_preproc_if_token1] = ACTIONS(3617),
    [aux_sym_preproc_if_token3] = ACTIONS(3617),
    [aux_sym_preproc_else_token1] = ACTIONS(3617),
    [aux_sym_preproc_elif_token1] = ACTIONS(3617),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3251] = {
    [sym_preproc_region] = STATE(3251),
    [sym_preproc_endregion] = STATE(3251),
    [sym_preproc_line] = STATE(3251),
    [sym_preproc_pragma] = STATE(3251),
    [sym_preproc_nullable] = STATE(3251),
    [sym_preproc_error] = STATE(3251),
    [sym_preproc_define] = STATE(3251),
    [sym_preproc_undef] = STATE(3251),
    [sym__identifier_token] = ACTIONS(3619),
    [anon_sym_extern] = ACTIONS(3619),
    [anon_sym_alias] = ACTIONS(3619),
    [anon_sym_global] = ACTIONS(3619),
    [anon_sym_using] = ACTIONS(3619),
    [anon_sym_unsafe] = ACTIONS(3619),
    [anon_sym_static] = ACTIONS(3619),
    [anon_sym_LBRACK] = ACTIONS(3621),
    [anon_sym_LPAREN] = ACTIONS(3621),
    [anon_sym_event] = ACTIONS(3619),
    [anon_sym_namespace] = ACTIONS(3619),
    [anon_sym_class] = ACTIONS(3619),
    [anon_sym_ref] = ACTIONS(3619),
    [anon_sym_struct] = ACTIONS(3619),
    [anon_sym_enum] = ACTIONS(3619),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_interface] = ACTIONS(3619),
    [anon_sym_delegate] = ACTIONS(3619),
    [anon_sym_record] = ACTIONS(3619),
    [anon_sym_abstract] = ACTIONS(3619),
    [anon_sym_async] = ACTIONS(3619),
    [anon_sym_const] = ACTIONS(3619),
    [anon_sym_file] = ACTIONS(3619),
    [anon_sym_fixed] = ACTIONS(3619),
    [anon_sym_internal] = ACTIONS(3619),
    [anon_sym_new] = ACTIONS(3619),
    [anon_sym_override] = ACTIONS(3619),
    [anon_sym_partial] = ACTIONS(3619),
    [anon_sym_private] = ACTIONS(3619),
    [anon_sym_protected] = ACTIONS(3619),
    [anon_sym_public] = ACTIONS(3619),
    [anon_sym_readonly] = ACTIONS(3619),
    [anon_sym_required] = ACTIONS(3619),
    [anon_sym_sealed] = ACTIONS(3619),
    [anon_sym_virtual] = ACTIONS(3619),
    [anon_sym_volatile] = ACTIONS(3619),
    [anon_sym_where] = ACTIONS(3619),
    [anon_sym_notnull] = ACTIONS(3619),
    [anon_sym_unmanaged] = ACTIONS(3619),
    [anon_sym_TILDE] = ACTIONS(3621),
    [anon_sym_implicit] = ACTIONS(3619),
    [anon_sym_explicit] = ACTIONS(3619),
    [anon_sym_scoped] = ACTIONS(3619),
    [anon_sym_var] = ACTIONS(3619),
    [sym_predefined_type] = ACTIONS(3619),
    [anon_sym_yield] = ACTIONS(3619),
    [anon_sym_when] = ACTIONS(3619),
    [anon_sym_from] = ACTIONS(3619),
    [anon_sym_into] = ACTIONS(3619),
    [anon_sym_join] = ACTIONS(3619),
    [anon_sym_on] = ACTIONS(3619),
    [anon_sym_equals] = ACTIONS(3619),
    [anon_sym_let] = ACTIONS(3619),
    [anon_sym_orderby] = ACTIONS(3619),
    [anon_sym_ascending] = ACTIONS(3619),
    [anon_sym_descending] = ACTIONS(3619),
    [anon_sym_group] = ACTIONS(3619),
    [anon_sym_by] = ACTIONS(3619),
    [anon_sym_select] = ACTIONS(3619),
    [aux_sym_preproc_if_token1] = ACTIONS(3621),
    [aux_sym_preproc_if_token3] = ACTIONS(3621),
    [aux_sym_preproc_else_token1] = ACTIONS(3621),
    [aux_sym_preproc_elif_token1] = ACTIONS(3621),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3252] = {
    [sym_preproc_region] = STATE(3252),
    [sym_preproc_endregion] = STATE(3252),
    [sym_preproc_line] = STATE(3252),
    [sym_preproc_pragma] = STATE(3252),
    [sym_preproc_nullable] = STATE(3252),
    [sym_preproc_error] = STATE(3252),
    [sym_preproc_define] = STATE(3252),
    [sym_preproc_undef] = STATE(3252),
    [sym__identifier_token] = ACTIONS(3627),
    [anon_sym_extern] = ACTIONS(3627),
    [anon_sym_alias] = ACTIONS(3627),
    [anon_sym_global] = ACTIONS(3627),
    [anon_sym_using] = ACTIONS(3627),
    [anon_sym_unsafe] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [anon_sym_event] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_ref] = ACTIONS(3627),
    [anon_sym_struct] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_delegate] = ACTIONS(3627),
    [anon_sym_record] = ACTIONS(3627),
    [anon_sym_abstract] = ACTIONS(3627),
    [anon_sym_async] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [anon_sym_file] = ACTIONS(3627),
    [anon_sym_fixed] = ACTIONS(3627),
    [anon_sym_internal] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [anon_sym_override] = ACTIONS(3627),
    [anon_sym_partial] = ACTIONS(3627),
    [anon_sym_private] = ACTIONS(3627),
    [anon_sym_protected] = ACTIONS(3627),
    [anon_sym_public] = ACTIONS(3627),
    [anon_sym_readonly] = ACTIONS(3627),
    [anon_sym_required] = ACTIONS(3627),
    [anon_sym_sealed] = ACTIONS(3627),
    [anon_sym_virtual] = ACTIONS(3627),
    [anon_sym_volatile] = ACTIONS(3627),
    [anon_sym_where] = ACTIONS(3627),
    [anon_sym_notnull] = ACTIONS(3627),
    [anon_sym_unmanaged] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_implicit] = ACTIONS(3627),
    [anon_sym_explicit] = ACTIONS(3627),
    [anon_sym_scoped] = ACTIONS(3627),
    [anon_sym_var] = ACTIONS(3627),
    [sym_predefined_type] = ACTIONS(3627),
    [anon_sym_yield] = ACTIONS(3627),
    [anon_sym_when] = ACTIONS(3627),
    [anon_sym_from] = ACTIONS(3627),
    [anon_sym_into] = ACTIONS(3627),
    [anon_sym_join] = ACTIONS(3627),
    [anon_sym_on] = ACTIONS(3627),
    [anon_sym_equals] = ACTIONS(3627),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_orderby] = ACTIONS(3627),
    [anon_sym_ascending] = ACTIONS(3627),
    [anon_sym_descending] = ACTIONS(3627),
    [anon_sym_group] = ACTIONS(3627),
    [anon_sym_by] = ACTIONS(3627),
    [anon_sym_select] = ACTIONS(3627),
    [aux_sym_preproc_if_token1] = ACTIONS(3629),
    [aux_sym_preproc_if_token3] = ACTIONS(3629),
    [aux_sym_preproc_else_token1] = ACTIONS(3629),
    [aux_sym_preproc_elif_token1] = ACTIONS(3629),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3253] = {
    [sym_preproc_region] = STATE(3253),
    [sym_preproc_endregion] = STATE(3253),
    [sym_preproc_line] = STATE(3253),
    [sym_preproc_pragma] = STATE(3253),
    [sym_preproc_nullable] = STATE(3253),
    [sym_preproc_error] = STATE(3253),
    [sym_preproc_define] = STATE(3253),
    [sym_preproc_undef] = STATE(3253),
    [sym__identifier_token] = ACTIONS(3631),
    [anon_sym_extern] = ACTIONS(3631),
    [anon_sym_alias] = ACTIONS(3631),
    [anon_sym_global] = ACTIONS(3631),
    [anon_sym_using] = ACTIONS(3631),
    [anon_sym_unsafe] = ACTIONS(3631),
    [anon_sym_static] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3633),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_event] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3631),
    [anon_sym_class] = ACTIONS(3631),
    [anon_sym_ref] = ACTIONS(3631),
    [anon_sym_struct] = ACTIONS(3631),
    [anon_sym_enum] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3633),
    [anon_sym_interface] = ACTIONS(3631),
    [anon_sym_delegate] = ACTIONS(3631),
    [anon_sym_record] = ACTIONS(3631),
    [anon_sym_abstract] = ACTIONS(3631),
    [anon_sym_async] = ACTIONS(3631),
    [anon_sym_const] = ACTIONS(3631),
    [anon_sym_file] = ACTIONS(3631),
    [anon_sym_fixed] = ACTIONS(3631),
    [anon_sym_internal] = ACTIONS(3631),
    [anon_sym_new] = ACTIONS(3631),
    [anon_sym_override] = ACTIONS(3631),
    [anon_sym_partial] = ACTIONS(3631),
    [anon_sym_private] = ACTIONS(3631),
    [anon_sym_protected] = ACTIONS(3631),
    [anon_sym_public] = ACTIONS(3631),
    [anon_sym_readonly] = ACTIONS(3631),
    [anon_sym_required] = ACTIONS(3631),
    [anon_sym_sealed] = ACTIONS(3631),
    [anon_sym_virtual] = ACTIONS(3631),
    [anon_sym_volatile] = ACTIONS(3631),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_notnull] = ACTIONS(3631),
    [anon_sym_unmanaged] = ACTIONS(3631),
    [anon_sym_TILDE] = ACTIONS(3633),
    [anon_sym_implicit] = ACTIONS(3631),
    [anon_sym_explicit] = ACTIONS(3631),
    [anon_sym_scoped] = ACTIONS(3631),
    [anon_sym_var] = ACTIONS(3631),
    [sym_predefined_type] = ACTIONS(3631),
    [anon_sym_yield] = ACTIONS(3631),
    [anon_sym_when] = ACTIONS(3631),
    [anon_sym_from] = ACTIONS(3631),
    [anon_sym_into] = ACTIONS(3631),
    [anon_sym_join] = ACTIONS(3631),
    [anon_sym_on] = ACTIONS(3631),
    [anon_sym_equals] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3631),
    [anon_sym_orderby] = ACTIONS(3631),
    [anon_sym_ascending] = ACTIONS(3631),
    [anon_sym_descending] = ACTIONS(3631),
    [anon_sym_group] = ACTIONS(3631),
    [anon_sym_by] = ACTIONS(3631),
    [anon_sym_select] = ACTIONS(3631),
    [aux_sym_preproc_if_token1] = ACTIONS(3633),
    [aux_sym_preproc_if_token3] = ACTIONS(3633),
    [aux_sym_preproc_else_token1] = ACTIONS(3633),
    [aux_sym_preproc_elif_token1] = ACTIONS(3633),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3254] = {
    [sym_preproc_region] = STATE(3254),
    [sym_preproc_endregion] = STATE(3254),
    [sym_preproc_line] = STATE(3254),
    [sym_preproc_pragma] = STATE(3254),
    [sym_preproc_nullable] = STATE(3254),
    [sym_preproc_error] = STATE(3254),
    [sym_preproc_define] = STATE(3254),
    [sym_preproc_undef] = STATE(3254),
    [sym__identifier_token] = ACTIONS(4169),
    [anon_sym_alias] = ACTIONS(4169),
    [anon_sym_global] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_file] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_where] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_notnull] = ACTIONS(4169),
    [anon_sym_unmanaged] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_scoped] = ACTIONS(4169),
    [anon_sym_var] = ACTIONS(4169),
    [anon_sym_yield] = ACTIONS(4169),
    [anon_sym_switch] = ACTIONS(4169),
    [anon_sym_when] = ACTIONS(4169),
    [sym_discard] = ACTIONS(4169),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4169),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4169),
    [anon_sym_into] = ACTIONS(4169),
    [anon_sym_join] = ACTIONS(4169),
    [anon_sym_on] = ACTIONS(4169),
    [anon_sym_equals] = ACTIONS(4169),
    [anon_sym_let] = ACTIONS(4169),
    [anon_sym_orderby] = ACTIONS(4169),
    [anon_sym_ascending] = ACTIONS(4169),
    [anon_sym_descending] = ACTIONS(4169),
    [anon_sym_group] = ACTIONS(4169),
    [anon_sym_by] = ACTIONS(4169),
    [anon_sym_select] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4169),
    [anon_sym_is] = ACTIONS(4169),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4169),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4178),
  },
  [3255] = {
    [sym_preproc_region] = STATE(3255),
    [sym_preproc_endregion] = STATE(3255),
    [sym_preproc_line] = STATE(3255),
    [sym_preproc_pragma] = STATE(3255),
    [sym_preproc_nullable] = STATE(3255),
    [sym_preproc_error] = STATE(3255),
    [sym_preproc_define] = STATE(3255),
    [sym_preproc_undef] = STATE(3255),
    [sym__identifier_token] = ACTIONS(4494),
    [anon_sym_alias] = ACTIONS(4494),
    [anon_sym_global] = ACTIONS(4494),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_file] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_notnull] = ACTIONS(4494),
    [anon_sym_unmanaged] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_scoped] = ACTIONS(4494),
    [anon_sym_var] = ACTIONS(4494),
    [anon_sym_yield] = ACTIONS(4494),
    [anon_sym_switch] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [sym_discard] = ACTIONS(4494),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4494),
    [anon_sym_or] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_from] = ACTIONS(4494),
    [anon_sym_into] = ACTIONS(4494),
    [anon_sym_join] = ACTIONS(4494),
    [anon_sym_on] = ACTIONS(4494),
    [anon_sym_equals] = ACTIONS(4494),
    [anon_sym_let] = ACTIONS(4494),
    [anon_sym_orderby] = ACTIONS(4494),
    [anon_sym_ascending] = ACTIONS(4494),
    [anon_sym_descending] = ACTIONS(4494),
    [anon_sym_group] = ACTIONS(4494),
    [anon_sym_by] = ACTIONS(4494),
    [anon_sym_select] = ACTIONS(4494),
    [anon_sym_as] = ACTIONS(4494),
    [anon_sym_is] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4494),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4496),
  },
  [3256] = {
    [sym__variable_designation] = STATE(4055),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3256),
    [sym_preproc_endregion] = STATE(3256),
    [sym_preproc_line] = STATE(3256),
    [sym_preproc_pragma] = STATE(3256),
    [sym_preproc_nullable] = STATE(3256),
    [sym_preproc_error] = STATE(3256),
    [sym_preproc_define] = STATE(3256),
    [sym_preproc_undef] = STATE(3256),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4397),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3257] = {
    [sym_preproc_region] = STATE(3257),
    [sym_preproc_endregion] = STATE(3257),
    [sym_preproc_line] = STATE(3257),
    [sym_preproc_pragma] = STATE(3257),
    [sym_preproc_nullable] = STATE(3257),
    [sym_preproc_error] = STATE(3257),
    [sym_preproc_define] = STATE(3257),
    [sym_preproc_undef] = STATE(3257),
    [sym__identifier_token] = ACTIONS(4429),
    [anon_sym_alias] = ACTIONS(4429),
    [anon_sym_global] = ACTIONS(4429),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_file] = ACTIONS(4429),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4429),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_notnull] = ACTIONS(4429),
    [anon_sym_unmanaged] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_scoped] = ACTIONS(4429),
    [anon_sym_var] = ACTIONS(4429),
    [anon_sym_yield] = ACTIONS(4429),
    [anon_sym_switch] = ACTIONS(4429),
    [anon_sym_when] = ACTIONS(4429),
    [sym_discard] = ACTIONS(4429),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4429),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4429),
    [anon_sym_into] = ACTIONS(4429),
    [anon_sym_join] = ACTIONS(4429),
    [anon_sym_on] = ACTIONS(4429),
    [anon_sym_equals] = ACTIONS(4429),
    [anon_sym_let] = ACTIONS(4429),
    [anon_sym_orderby] = ACTIONS(4429),
    [anon_sym_ascending] = ACTIONS(4429),
    [anon_sym_descending] = ACTIONS(4429),
    [anon_sym_group] = ACTIONS(4429),
    [anon_sym_by] = ACTIONS(4429),
    [anon_sym_select] = ACTIONS(4429),
    [anon_sym_as] = ACTIONS(4429),
    [anon_sym_is] = ACTIONS(4429),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4431),
  },
  [3258] = {
    [sym__variable_designation] = STATE(4018),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3258),
    [sym_preproc_endregion] = STATE(3258),
    [sym_preproc_line] = STATE(3258),
    [sym_preproc_pragma] = STATE(3258),
    [sym_preproc_nullable] = STATE(3258),
    [sym_preproc_error] = STATE(3258),
    [sym_preproc_define] = STATE(3258),
    [sym_preproc_undef] = STATE(3258),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4405),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3259] = {
    [sym__variable_designation] = STATE(4008),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3259),
    [sym_preproc_endregion] = STATE(3259),
    [sym_preproc_line] = STATE(3259),
    [sym_preproc_pragma] = STATE(3259),
    [sym_preproc_nullable] = STATE(3259),
    [sym_preproc_error] = STATE(3259),
    [sym_preproc_define] = STATE(3259),
    [sym_preproc_undef] = STATE(3259),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4445),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3260] = {
    [sym_preproc_region] = STATE(3260),
    [sym_preproc_endregion] = STATE(3260),
    [sym_preproc_line] = STATE(3260),
    [sym_preproc_pragma] = STATE(3260),
    [sym_preproc_nullable] = STATE(3260),
    [sym_preproc_error] = STATE(3260),
    [sym_preproc_define] = STATE(3260),
    [sym_preproc_undef] = STATE(3260),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3261] = {
    [sym__variable_designation] = STATE(3999),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3261),
    [sym_preproc_endregion] = STATE(3261),
    [sym_preproc_line] = STATE(3261),
    [sym_preproc_pragma] = STATE(3261),
    [sym_preproc_nullable] = STATE(3261),
    [sym_preproc_error] = STATE(3261),
    [sym_preproc_define] = STATE(3261),
    [sym_preproc_undef] = STATE(3261),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4435),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3262] = {
    [sym_preproc_region] = STATE(3262),
    [sym_preproc_endregion] = STATE(3262),
    [sym_preproc_line] = STATE(3262),
    [sym_preproc_pragma] = STATE(3262),
    [sym_preproc_nullable] = STATE(3262),
    [sym_preproc_error] = STATE(3262),
    [sym_preproc_define] = STATE(3262),
    [sym_preproc_undef] = STATE(3262),
    [sym__identifier_token] = ACTIONS(4840),
    [anon_sym_extern] = ACTIONS(4840),
    [anon_sym_alias] = ACTIONS(4840),
    [anon_sym_global] = ACTIONS(4840),
    [anon_sym_using] = ACTIONS(4840),
    [anon_sym_unsafe] = ACTIONS(4840),
    [anon_sym_static] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(4842),
    [anon_sym_event] = ACTIONS(4840),
    [anon_sym_namespace] = ACTIONS(4840),
    [anon_sym_class] = ACTIONS(4840),
    [anon_sym_ref] = ACTIONS(4840),
    [anon_sym_struct] = ACTIONS(4840),
    [anon_sym_enum] = ACTIONS(4840),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [anon_sym_interface] = ACTIONS(4840),
    [anon_sym_delegate] = ACTIONS(4840),
    [anon_sym_record] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(4840),
    [anon_sym_async] = ACTIONS(4840),
    [anon_sym_const] = ACTIONS(4840),
    [anon_sym_file] = ACTIONS(4840),
    [anon_sym_fixed] = ACTIONS(4840),
    [anon_sym_internal] = ACTIONS(4840),
    [anon_sym_new] = ACTIONS(4840),
    [anon_sym_override] = ACTIONS(4840),
    [anon_sym_partial] = ACTIONS(4840),
    [anon_sym_private] = ACTIONS(4840),
    [anon_sym_protected] = ACTIONS(4840),
    [anon_sym_public] = ACTIONS(4840),
    [anon_sym_readonly] = ACTIONS(4840),
    [anon_sym_required] = ACTIONS(4840),
    [anon_sym_sealed] = ACTIONS(4840),
    [anon_sym_virtual] = ACTIONS(4840),
    [anon_sym_volatile] = ACTIONS(4840),
    [anon_sym_where] = ACTIONS(4840),
    [anon_sym_notnull] = ACTIONS(4840),
    [anon_sym_unmanaged] = ACTIONS(4840),
    [anon_sym_TILDE] = ACTIONS(4842),
    [anon_sym_implicit] = ACTIONS(4840),
    [anon_sym_explicit] = ACTIONS(4840),
    [anon_sym_scoped] = ACTIONS(4840),
    [anon_sym_var] = ACTIONS(4840),
    [sym_predefined_type] = ACTIONS(4840),
    [anon_sym_yield] = ACTIONS(4840),
    [anon_sym_when] = ACTIONS(4840),
    [anon_sym_from] = ACTIONS(4840),
    [anon_sym_into] = ACTIONS(4840),
    [anon_sym_join] = ACTIONS(4840),
    [anon_sym_on] = ACTIONS(4840),
    [anon_sym_equals] = ACTIONS(4840),
    [anon_sym_let] = ACTIONS(4840),
    [anon_sym_orderby] = ACTIONS(4840),
    [anon_sym_ascending] = ACTIONS(4840),
    [anon_sym_descending] = ACTIONS(4840),
    [anon_sym_group] = ACTIONS(4840),
    [anon_sym_by] = ACTIONS(4840),
    [anon_sym_select] = ACTIONS(4840),
    [aux_sym_preproc_if_token1] = ACTIONS(4842),
    [aux_sym_preproc_if_token3] = ACTIONS(4842),
    [aux_sym_preproc_else_token1] = ACTIONS(4842),
    [aux_sym_preproc_elif_token1] = ACTIONS(4842),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3263] = {
    [sym_preproc_region] = STATE(3263),
    [sym_preproc_endregion] = STATE(3263),
    [sym_preproc_line] = STATE(3263),
    [sym_preproc_pragma] = STATE(3263),
    [sym_preproc_nullable] = STATE(3263),
    [sym_preproc_error] = STATE(3263),
    [sym_preproc_define] = STATE(3263),
    [sym_preproc_undef] = STATE(3263),
    [sym__identifier_token] = ACTIONS(4844),
    [anon_sym_extern] = ACTIONS(4844),
    [anon_sym_alias] = ACTIONS(4844),
    [anon_sym_global] = ACTIONS(4844),
    [anon_sym_using] = ACTIONS(4844),
    [anon_sym_unsafe] = ACTIONS(4844),
    [anon_sym_static] = ACTIONS(4844),
    [anon_sym_LBRACK] = ACTIONS(4846),
    [anon_sym_LPAREN] = ACTIONS(4846),
    [anon_sym_event] = ACTIONS(4844),
    [anon_sym_namespace] = ACTIONS(4844),
    [anon_sym_class] = ACTIONS(4844),
    [anon_sym_ref] = ACTIONS(4844),
    [anon_sym_struct] = ACTIONS(4844),
    [anon_sym_enum] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_interface] = ACTIONS(4844),
    [anon_sym_delegate] = ACTIONS(4844),
    [anon_sym_record] = ACTIONS(4844),
    [anon_sym_abstract] = ACTIONS(4844),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_const] = ACTIONS(4844),
    [anon_sym_file] = ACTIONS(4844),
    [anon_sym_fixed] = ACTIONS(4844),
    [anon_sym_internal] = ACTIONS(4844),
    [anon_sym_new] = ACTIONS(4844),
    [anon_sym_override] = ACTIONS(4844),
    [anon_sym_partial] = ACTIONS(4844),
    [anon_sym_private] = ACTIONS(4844),
    [anon_sym_protected] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4844),
    [anon_sym_readonly] = ACTIONS(4844),
    [anon_sym_required] = ACTIONS(4844),
    [anon_sym_sealed] = ACTIONS(4844),
    [anon_sym_virtual] = ACTIONS(4844),
    [anon_sym_volatile] = ACTIONS(4844),
    [anon_sym_where] = ACTIONS(4844),
    [anon_sym_notnull] = ACTIONS(4844),
    [anon_sym_unmanaged] = ACTIONS(4844),
    [anon_sym_TILDE] = ACTIONS(4846),
    [anon_sym_implicit] = ACTIONS(4844),
    [anon_sym_explicit] = ACTIONS(4844),
    [anon_sym_scoped] = ACTIONS(4844),
    [anon_sym_var] = ACTIONS(4844),
    [sym_predefined_type] = ACTIONS(4844),
    [anon_sym_yield] = ACTIONS(4844),
    [anon_sym_when] = ACTIONS(4844),
    [anon_sym_from] = ACTIONS(4844),
    [anon_sym_into] = ACTIONS(4844),
    [anon_sym_join] = ACTIONS(4844),
    [anon_sym_on] = ACTIONS(4844),
    [anon_sym_equals] = ACTIONS(4844),
    [anon_sym_let] = ACTIONS(4844),
    [anon_sym_orderby] = ACTIONS(4844),
    [anon_sym_ascending] = ACTIONS(4844),
    [anon_sym_descending] = ACTIONS(4844),
    [anon_sym_group] = ACTIONS(4844),
    [anon_sym_by] = ACTIONS(4844),
    [anon_sym_select] = ACTIONS(4844),
    [aux_sym_preproc_if_token1] = ACTIONS(4846),
    [aux_sym_preproc_if_token3] = ACTIONS(4846),
    [aux_sym_preproc_else_token1] = ACTIONS(4846),
    [aux_sym_preproc_elif_token1] = ACTIONS(4846),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3264] = {
    [sym_preproc_region] = STATE(3264),
    [sym_preproc_endregion] = STATE(3264),
    [sym_preproc_line] = STATE(3264),
    [sym_preproc_pragma] = STATE(3264),
    [sym_preproc_nullable] = STATE(3264),
    [sym_preproc_error] = STATE(3264),
    [sym_preproc_define] = STATE(3264),
    [sym_preproc_undef] = STATE(3264),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4851),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4853),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3265] = {
    [sym_preproc_region] = STATE(3265),
    [sym_preproc_endregion] = STATE(3265),
    [sym_preproc_line] = STATE(3265),
    [sym_preproc_pragma] = STATE(3265),
    [sym_preproc_nullable] = STATE(3265),
    [sym_preproc_error] = STATE(3265),
    [sym_preproc_define] = STATE(3265),
    [sym_preproc_undef] = STATE(3265),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_file] = ACTIONS(4120),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_scoped] = ACTIONS(4120),
    [anon_sym_var] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [sym_discard] = ACTIONS(4120),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4120),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [anon_sym_as] = ACTIONS(4120),
    [anon_sym_is] = ACTIONS(4120),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4120),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4122),
  },
  [3266] = {
    [sym__variable_designation] = STATE(4055),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3266),
    [sym_preproc_endregion] = STATE(3266),
    [sym_preproc_line] = STATE(3266),
    [sym_preproc_pragma] = STATE(3266),
    [sym_preproc_nullable] = STATE(3266),
    [sym_preproc_error] = STATE(3266),
    [sym_preproc_define] = STATE(3266),
    [sym_preproc_undef] = STATE(3266),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4397),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3267] = {
    [sym__variable_designation] = STATE(4018),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3267),
    [sym_preproc_endregion] = STATE(3267),
    [sym_preproc_line] = STATE(3267),
    [sym_preproc_pragma] = STATE(3267),
    [sym_preproc_nullable] = STATE(3267),
    [sym_preproc_error] = STATE(3267),
    [sym_preproc_define] = STATE(3267),
    [sym_preproc_undef] = STATE(3267),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4405),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3268] = {
    [sym_preproc_region] = STATE(3268),
    [sym_preproc_endregion] = STATE(3268),
    [sym_preproc_line] = STATE(3268),
    [sym_preproc_pragma] = STATE(3268),
    [sym_preproc_nullable] = STATE(3268),
    [sym_preproc_error] = STATE(3268),
    [sym_preproc_define] = STATE(3268),
    [sym_preproc_undef] = STATE(3268),
    [sym__identifier_token] = ACTIONS(3993),
    [anon_sym_alias] = ACTIONS(3993),
    [anon_sym_global] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(3993),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_notnull] = ACTIONS(3993),
    [anon_sym_unmanaged] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_scoped] = ACTIONS(3993),
    [anon_sym_var] = ACTIONS(3993),
    [anon_sym_yield] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3993),
    [anon_sym_when] = ACTIONS(3993),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3993),
    [anon_sym_join] = ACTIONS(3993),
    [anon_sym_on] = ACTIONS(3993),
    [anon_sym_equals] = ACTIONS(3993),
    [anon_sym_let] = ACTIONS(3993),
    [anon_sym_orderby] = ACTIONS(3993),
    [anon_sym_ascending] = ACTIONS(3993),
    [anon_sym_descending] = ACTIONS(3993),
    [anon_sym_group] = ACTIONS(3993),
    [anon_sym_by] = ACTIONS(3993),
    [anon_sym_select] = ACTIONS(3993),
    [anon_sym_as] = ACTIONS(3993),
    [anon_sym_is] = ACTIONS(3993),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3993),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [3269] = {
    [sym__variable_designation] = STATE(4008),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3269),
    [sym_preproc_endregion] = STATE(3269),
    [sym_preproc_line] = STATE(3269),
    [sym_preproc_pragma] = STATE(3269),
    [sym_preproc_nullable] = STATE(3269),
    [sym_preproc_error] = STATE(3269),
    [sym_preproc_define] = STATE(3269),
    [sym_preproc_undef] = STATE(3269),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4445),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3270] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3270),
    [sym_preproc_endregion] = STATE(3270),
    [sym_preproc_line] = STATE(3270),
    [sym_preproc_pragma] = STATE(3270),
    [sym_preproc_nullable] = STATE(3270),
    [sym_preproc_error] = STATE(3270),
    [sym_preproc_define] = STATE(3270),
    [sym_preproc_undef] = STATE(3270),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4435),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3271] = {
    [sym__variable_designation] = STATE(3999),
    [sym_parenthesized_variable_designation] = STATE(4073),
    [sym_identifier] = STATE(4071),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3271),
    [sym_preproc_endregion] = STATE(3271),
    [sym_preproc_line] = STATE(3271),
    [sym_preproc_pragma] = STATE(3271),
    [sym_preproc_nullable] = STATE(3271),
    [sym_preproc_error] = STATE(3271),
    [sym_preproc_define] = STATE(3271),
    [sym_preproc_undef] = STATE(3271),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4345),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4435),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3272] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3272),
    [sym_preproc_endregion] = STATE(3272),
    [sym_preproc_line] = STATE(3272),
    [sym_preproc_pragma] = STATE(3272),
    [sym_preproc_nullable] = STATE(3272),
    [sym_preproc_error] = STATE(3272),
    [sym_preproc_define] = STATE(3272),
    [sym_preproc_undef] = STATE(3272),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4445),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3273] = {
    [sym_preproc_region] = STATE(3273),
    [sym_preproc_endregion] = STATE(3273),
    [sym_preproc_line] = STATE(3273),
    [sym_preproc_pragma] = STATE(3273),
    [sym_preproc_nullable] = STATE(3273),
    [sym_preproc_error] = STATE(3273),
    [sym_preproc_define] = STATE(3273),
    [sym_preproc_undef] = STATE(3273),
    [sym__identifier_token] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym_alias] = ACTIONS(3455),
    [anon_sym_global] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_unsafe] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3457),
    [anon_sym_LPAREN] = ACTIONS(3457),
    [anon_sym_event] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_ref] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(3457),
    [anon_sym_interface] = ACTIONS(3455),
    [anon_sym_delegate] = ACTIONS(3455),
    [anon_sym_record] = ACTIONS(3455),
    [anon_sym_abstract] = ACTIONS(3455),
    [anon_sym_async] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_file] = ACTIONS(3455),
    [anon_sym_fixed] = ACTIONS(3455),
    [anon_sym_internal] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_override] = ACTIONS(3455),
    [anon_sym_partial] = ACTIONS(3455),
    [anon_sym_private] = ACTIONS(3455),
    [anon_sym_protected] = ACTIONS(3455),
    [anon_sym_public] = ACTIONS(3455),
    [anon_sym_readonly] = ACTIONS(3455),
    [anon_sym_required] = ACTIONS(3455),
    [anon_sym_sealed] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_where] = ACTIONS(3455),
    [anon_sym_notnull] = ACTIONS(3455),
    [anon_sym_unmanaged] = ACTIONS(3455),
    [anon_sym_TILDE] = ACTIONS(3457),
    [anon_sym_implicit] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_scoped] = ACTIONS(3455),
    [anon_sym_var] = ACTIONS(3455),
    [sym_predefined_type] = ACTIONS(3455),
    [anon_sym_yield] = ACTIONS(3455),
    [anon_sym_when] = ACTIONS(3455),
    [anon_sym_from] = ACTIONS(3455),
    [anon_sym_into] = ACTIONS(3455),
    [anon_sym_join] = ACTIONS(3455),
    [anon_sym_on] = ACTIONS(3455),
    [anon_sym_equals] = ACTIONS(3455),
    [anon_sym_let] = ACTIONS(3455),
    [anon_sym_orderby] = ACTIONS(3455),
    [anon_sym_ascending] = ACTIONS(3455),
    [anon_sym_descending] = ACTIONS(3455),
    [anon_sym_group] = ACTIONS(3455),
    [anon_sym_by] = ACTIONS(3455),
    [anon_sym_select] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3457),
    [aux_sym_preproc_if_token3] = ACTIONS(3457),
    [aux_sym_preproc_else_token1] = ACTIONS(3457),
    [aux_sym_preproc_elif_token1] = ACTIONS(3457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3274] = {
    [sym_preproc_region] = STATE(3274),
    [sym_preproc_endregion] = STATE(3274),
    [sym_preproc_line] = STATE(3274),
    [sym_preproc_pragma] = STATE(3274),
    [sym_preproc_nullable] = STATE(3274),
    [sym_preproc_error] = STATE(3274),
    [sym_preproc_define] = STATE(3274),
    [sym_preproc_undef] = STATE(3274),
    [sym__identifier_token] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym_alias] = ACTIONS(4855),
    [anon_sym_global] = ACTIONS(4855),
    [anon_sym_using] = ACTIONS(4855),
    [anon_sym_unsafe] = ACTIONS(4855),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_LPAREN] = ACTIONS(4857),
    [anon_sym_event] = ACTIONS(4855),
    [anon_sym_namespace] = ACTIONS(4855),
    [anon_sym_class] = ACTIONS(4855),
    [anon_sym_ref] = ACTIONS(4855),
    [anon_sym_struct] = ACTIONS(4855),
    [anon_sym_enum] = ACTIONS(4855),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_interface] = ACTIONS(4855),
    [anon_sym_delegate] = ACTIONS(4855),
    [anon_sym_record] = ACTIONS(4855),
    [anon_sym_abstract] = ACTIONS(4855),
    [anon_sym_async] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_file] = ACTIONS(4855),
    [anon_sym_fixed] = ACTIONS(4855),
    [anon_sym_internal] = ACTIONS(4855),
    [anon_sym_new] = ACTIONS(4855),
    [anon_sym_override] = ACTIONS(4855),
    [anon_sym_partial] = ACTIONS(4855),
    [anon_sym_private] = ACTIONS(4855),
    [anon_sym_protected] = ACTIONS(4855),
    [anon_sym_public] = ACTIONS(4855),
    [anon_sym_readonly] = ACTIONS(4855),
    [anon_sym_required] = ACTIONS(4855),
    [anon_sym_sealed] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_where] = ACTIONS(4855),
    [anon_sym_notnull] = ACTIONS(4855),
    [anon_sym_unmanaged] = ACTIONS(4855),
    [anon_sym_TILDE] = ACTIONS(4857),
    [anon_sym_implicit] = ACTIONS(4855),
    [anon_sym_explicit] = ACTIONS(4855),
    [anon_sym_scoped] = ACTIONS(4855),
    [anon_sym_var] = ACTIONS(4855),
    [sym_predefined_type] = ACTIONS(4855),
    [anon_sym_yield] = ACTIONS(4855),
    [anon_sym_when] = ACTIONS(4855),
    [anon_sym_from] = ACTIONS(4855),
    [anon_sym_into] = ACTIONS(4855),
    [anon_sym_join] = ACTIONS(4855),
    [anon_sym_on] = ACTIONS(4855),
    [anon_sym_equals] = ACTIONS(4855),
    [anon_sym_let] = ACTIONS(4855),
    [anon_sym_orderby] = ACTIONS(4855),
    [anon_sym_ascending] = ACTIONS(4855),
    [anon_sym_descending] = ACTIONS(4855),
    [anon_sym_group] = ACTIONS(4855),
    [anon_sym_by] = ACTIONS(4855),
    [anon_sym_select] = ACTIONS(4855),
    [aux_sym_preproc_if_token1] = ACTIONS(4857),
    [aux_sym_preproc_if_token3] = ACTIONS(4857),
    [aux_sym_preproc_else_token1] = ACTIONS(4857),
    [aux_sym_preproc_elif_token1] = ACTIONS(4857),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3275] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3275),
    [sym_preproc_endregion] = STATE(3275),
    [sym_preproc_line] = STATE(3275),
    [sym_preproc_pragma] = STATE(3275),
    [sym_preproc_nullable] = STATE(3275),
    [sym_preproc_error] = STATE(3275),
    [sym_preproc_define] = STATE(3275),
    [sym_preproc_undef] = STATE(3275),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4405),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3276] = {
    [sym_preproc_region] = STATE(3276),
    [sym_preproc_endregion] = STATE(3276),
    [sym_preproc_line] = STATE(3276),
    [sym_preproc_pragma] = STATE(3276),
    [sym_preproc_nullable] = STATE(3276),
    [sym_preproc_error] = STATE(3276),
    [sym_preproc_define] = STATE(3276),
    [sym_preproc_undef] = STATE(3276),
    [sym__identifier_token] = ACTIONS(4455),
    [anon_sym_alias] = ACTIONS(4455),
    [anon_sym_global] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_file] = ACTIONS(4455),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_where] = ACTIONS(4455),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_notnull] = ACTIONS(4455),
    [anon_sym_unmanaged] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_scoped] = ACTIONS(4455),
    [anon_sym_var] = ACTIONS(4455),
    [anon_sym_yield] = ACTIONS(4455),
    [anon_sym_switch] = ACTIONS(4455),
    [anon_sym_when] = ACTIONS(4455),
    [sym_discard] = ACTIONS(4455),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4455),
    [anon_sym_or] = ACTIONS(4455),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_from] = ACTIONS(4455),
    [anon_sym_into] = ACTIONS(4455),
    [anon_sym_join] = ACTIONS(4455),
    [anon_sym_on] = ACTIONS(4455),
    [anon_sym_equals] = ACTIONS(4455),
    [anon_sym_let] = ACTIONS(4455),
    [anon_sym_orderby] = ACTIONS(4455),
    [anon_sym_ascending] = ACTIONS(4455),
    [anon_sym_descending] = ACTIONS(4455),
    [anon_sym_group] = ACTIONS(4455),
    [anon_sym_by] = ACTIONS(4455),
    [anon_sym_select] = ACTIONS(4455),
    [anon_sym_as] = ACTIONS(4455),
    [anon_sym_is] = ACTIONS(4455),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4455),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4457),
  },
  [3277] = {
    [sym_preproc_region] = STATE(3277),
    [sym_preproc_endregion] = STATE(3277),
    [sym_preproc_line] = STATE(3277),
    [sym_preproc_pragma] = STATE(3277),
    [sym_preproc_nullable] = STATE(3277),
    [sym_preproc_error] = STATE(3277),
    [sym_preproc_define] = STATE(3277),
    [sym_preproc_undef] = STATE(3277),
    [sym__identifier_token] = ACTIONS(4602),
    [anon_sym_alias] = ACTIONS(4602),
    [anon_sym_global] = ACTIONS(4602),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_file] = ACTIONS(4602),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_where] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_notnull] = ACTIONS(4602),
    [anon_sym_unmanaged] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_scoped] = ACTIONS(4602),
    [anon_sym_var] = ACTIONS(4602),
    [anon_sym_yield] = ACTIONS(4602),
    [anon_sym_switch] = ACTIONS(4602),
    [anon_sym_when] = ACTIONS(4602),
    [sym_discard] = ACTIONS(4602),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4602),
    [anon_sym_or] = ACTIONS(4602),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_from] = ACTIONS(4602),
    [anon_sym_into] = ACTIONS(4602),
    [anon_sym_join] = ACTIONS(4602),
    [anon_sym_on] = ACTIONS(4602),
    [anon_sym_equals] = ACTIONS(4602),
    [anon_sym_let] = ACTIONS(4602),
    [anon_sym_orderby] = ACTIONS(4602),
    [anon_sym_ascending] = ACTIONS(4602),
    [anon_sym_descending] = ACTIONS(4602),
    [anon_sym_group] = ACTIONS(4602),
    [anon_sym_by] = ACTIONS(4602),
    [anon_sym_select] = ACTIONS(4602),
    [anon_sym_as] = ACTIONS(4602),
    [anon_sym_is] = ACTIONS(4602),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4602),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4604),
  },
  [3278] = {
    [sym_preproc_region] = STATE(3278),
    [sym_preproc_endregion] = STATE(3278),
    [sym_preproc_line] = STATE(3278),
    [sym_preproc_pragma] = STATE(3278),
    [sym_preproc_nullable] = STATE(3278),
    [sym_preproc_error] = STATE(3278),
    [sym_preproc_define] = STATE(3278),
    [sym_preproc_undef] = STATE(3278),
    [sym__identifier_token] = ACTIONS(3463),
    [anon_sym_extern] = ACTIONS(3463),
    [anon_sym_alias] = ACTIONS(3463),
    [anon_sym_global] = ACTIONS(3463),
    [anon_sym_using] = ACTIONS(3463),
    [anon_sym_unsafe] = ACTIONS(3463),
    [anon_sym_static] = ACTIONS(3463),
    [anon_sym_LBRACK] = ACTIONS(3465),
    [anon_sym_LPAREN] = ACTIONS(3465),
    [anon_sym_event] = ACTIONS(3463),
    [anon_sym_namespace] = ACTIONS(3463),
    [anon_sym_class] = ACTIONS(3463),
    [anon_sym_ref] = ACTIONS(3463),
    [anon_sym_struct] = ACTIONS(3463),
    [anon_sym_enum] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3465),
    [anon_sym_interface] = ACTIONS(3463),
    [anon_sym_delegate] = ACTIONS(3463),
    [anon_sym_record] = ACTIONS(3463),
    [anon_sym_abstract] = ACTIONS(3463),
    [anon_sym_async] = ACTIONS(3463),
    [anon_sym_const] = ACTIONS(3463),
    [anon_sym_file] = ACTIONS(3463),
    [anon_sym_fixed] = ACTIONS(3463),
    [anon_sym_internal] = ACTIONS(3463),
    [anon_sym_new] = ACTIONS(3463),
    [anon_sym_override] = ACTIONS(3463),
    [anon_sym_partial] = ACTIONS(3463),
    [anon_sym_private] = ACTIONS(3463),
    [anon_sym_protected] = ACTIONS(3463),
    [anon_sym_public] = ACTIONS(3463),
    [anon_sym_readonly] = ACTIONS(3463),
    [anon_sym_required] = ACTIONS(3463),
    [anon_sym_sealed] = ACTIONS(3463),
    [anon_sym_virtual] = ACTIONS(3463),
    [anon_sym_volatile] = ACTIONS(3463),
    [anon_sym_where] = ACTIONS(3463),
    [anon_sym_notnull] = ACTIONS(3463),
    [anon_sym_unmanaged] = ACTIONS(3463),
    [anon_sym_TILDE] = ACTIONS(3465),
    [anon_sym_implicit] = ACTIONS(3463),
    [anon_sym_explicit] = ACTIONS(3463),
    [anon_sym_scoped] = ACTIONS(3463),
    [anon_sym_var] = ACTIONS(3463),
    [sym_predefined_type] = ACTIONS(3463),
    [anon_sym_yield] = ACTIONS(3463),
    [anon_sym_when] = ACTIONS(3463),
    [anon_sym_from] = ACTIONS(3463),
    [anon_sym_into] = ACTIONS(3463),
    [anon_sym_join] = ACTIONS(3463),
    [anon_sym_on] = ACTIONS(3463),
    [anon_sym_equals] = ACTIONS(3463),
    [anon_sym_let] = ACTIONS(3463),
    [anon_sym_orderby] = ACTIONS(3463),
    [anon_sym_ascending] = ACTIONS(3463),
    [anon_sym_descending] = ACTIONS(3463),
    [anon_sym_group] = ACTIONS(3463),
    [anon_sym_by] = ACTIONS(3463),
    [anon_sym_select] = ACTIONS(3463),
    [aux_sym_preproc_if_token1] = ACTIONS(3465),
    [aux_sym_preproc_if_token3] = ACTIONS(3465),
    [aux_sym_preproc_else_token1] = ACTIONS(3465),
    [aux_sym_preproc_elif_token1] = ACTIONS(3465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3279] = {
    [sym_preproc_region] = STATE(3279),
    [sym_preproc_endregion] = STATE(3279),
    [sym_preproc_line] = STATE(3279),
    [sym_preproc_pragma] = STATE(3279),
    [sym_preproc_nullable] = STATE(3279),
    [sym_preproc_error] = STATE(3279),
    [sym_preproc_define] = STATE(3279),
    [sym_preproc_undef] = STATE(3279),
    [sym__identifier_token] = ACTIONS(4859),
    [anon_sym_extern] = ACTIONS(4859),
    [anon_sym_alias] = ACTIONS(4859),
    [anon_sym_global] = ACTIONS(4859),
    [anon_sym_using] = ACTIONS(4859),
    [anon_sym_unsafe] = ACTIONS(4859),
    [anon_sym_static] = ACTIONS(4859),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_LPAREN] = ACTIONS(4861),
    [anon_sym_event] = ACTIONS(4859),
    [anon_sym_namespace] = ACTIONS(4859),
    [anon_sym_class] = ACTIONS(4859),
    [anon_sym_ref] = ACTIONS(4859),
    [anon_sym_struct] = ACTIONS(4859),
    [anon_sym_enum] = ACTIONS(4859),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_interface] = ACTIONS(4859),
    [anon_sym_delegate] = ACTIONS(4859),
    [anon_sym_record] = ACTIONS(4859),
    [anon_sym_abstract] = ACTIONS(4859),
    [anon_sym_async] = ACTIONS(4859),
    [anon_sym_const] = ACTIONS(4859),
    [anon_sym_file] = ACTIONS(4859),
    [anon_sym_fixed] = ACTIONS(4859),
    [anon_sym_internal] = ACTIONS(4859),
    [anon_sym_new] = ACTIONS(4859),
    [anon_sym_override] = ACTIONS(4859),
    [anon_sym_partial] = ACTIONS(4859),
    [anon_sym_private] = ACTIONS(4859),
    [anon_sym_protected] = ACTIONS(4859),
    [anon_sym_public] = ACTIONS(4859),
    [anon_sym_readonly] = ACTIONS(4859),
    [anon_sym_required] = ACTIONS(4859),
    [anon_sym_sealed] = ACTIONS(4859),
    [anon_sym_virtual] = ACTIONS(4859),
    [anon_sym_volatile] = ACTIONS(4859),
    [anon_sym_where] = ACTIONS(4859),
    [anon_sym_notnull] = ACTIONS(4859),
    [anon_sym_unmanaged] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_implicit] = ACTIONS(4859),
    [anon_sym_explicit] = ACTIONS(4859),
    [anon_sym_scoped] = ACTIONS(4859),
    [anon_sym_var] = ACTIONS(4859),
    [sym_predefined_type] = ACTIONS(4859),
    [anon_sym_yield] = ACTIONS(4859),
    [anon_sym_when] = ACTIONS(4859),
    [anon_sym_from] = ACTIONS(4859),
    [anon_sym_into] = ACTIONS(4859),
    [anon_sym_join] = ACTIONS(4859),
    [anon_sym_on] = ACTIONS(4859),
    [anon_sym_equals] = ACTIONS(4859),
    [anon_sym_let] = ACTIONS(4859),
    [anon_sym_orderby] = ACTIONS(4859),
    [anon_sym_ascending] = ACTIONS(4859),
    [anon_sym_descending] = ACTIONS(4859),
    [anon_sym_group] = ACTIONS(4859),
    [anon_sym_by] = ACTIONS(4859),
    [anon_sym_select] = ACTIONS(4859),
    [aux_sym_preproc_if_token1] = ACTIONS(4861),
    [aux_sym_preproc_if_token3] = ACTIONS(4861),
    [aux_sym_preproc_else_token1] = ACTIONS(4861),
    [aux_sym_preproc_elif_token1] = ACTIONS(4861),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3280] = {
    [sym_preproc_region] = STATE(3280),
    [sym_preproc_endregion] = STATE(3280),
    [sym_preproc_line] = STATE(3280),
    [sym_preproc_pragma] = STATE(3280),
    [sym_preproc_nullable] = STATE(3280),
    [sym_preproc_error] = STATE(3280),
    [sym_preproc_define] = STATE(3280),
    [sym_preproc_undef] = STATE(3280),
    [sym__identifier_token] = ACTIONS(3459),
    [anon_sym_extern] = ACTIONS(3459),
    [anon_sym_alias] = ACTIONS(3459),
    [anon_sym_global] = ACTIONS(3459),
    [anon_sym_using] = ACTIONS(3459),
    [anon_sym_unsafe] = ACTIONS(3459),
    [anon_sym_static] = ACTIONS(3459),
    [anon_sym_LBRACK] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(3461),
    [anon_sym_event] = ACTIONS(3459),
    [anon_sym_namespace] = ACTIONS(3459),
    [anon_sym_class] = ACTIONS(3459),
    [anon_sym_ref] = ACTIONS(3459),
    [anon_sym_struct] = ACTIONS(3459),
    [anon_sym_enum] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3461),
    [anon_sym_interface] = ACTIONS(3459),
    [anon_sym_delegate] = ACTIONS(3459),
    [anon_sym_record] = ACTIONS(3459),
    [anon_sym_abstract] = ACTIONS(3459),
    [anon_sym_async] = ACTIONS(3459),
    [anon_sym_const] = ACTIONS(3459),
    [anon_sym_file] = ACTIONS(3459),
    [anon_sym_fixed] = ACTIONS(3459),
    [anon_sym_internal] = ACTIONS(3459),
    [anon_sym_new] = ACTIONS(3459),
    [anon_sym_override] = ACTIONS(3459),
    [anon_sym_partial] = ACTIONS(3459),
    [anon_sym_private] = ACTIONS(3459),
    [anon_sym_protected] = ACTIONS(3459),
    [anon_sym_public] = ACTIONS(3459),
    [anon_sym_readonly] = ACTIONS(3459),
    [anon_sym_required] = ACTIONS(3459),
    [anon_sym_sealed] = ACTIONS(3459),
    [anon_sym_virtual] = ACTIONS(3459),
    [anon_sym_volatile] = ACTIONS(3459),
    [anon_sym_where] = ACTIONS(3459),
    [anon_sym_notnull] = ACTIONS(3459),
    [anon_sym_unmanaged] = ACTIONS(3459),
    [anon_sym_TILDE] = ACTIONS(3461),
    [anon_sym_implicit] = ACTIONS(3459),
    [anon_sym_explicit] = ACTIONS(3459),
    [anon_sym_scoped] = ACTIONS(3459),
    [anon_sym_var] = ACTIONS(3459),
    [sym_predefined_type] = ACTIONS(3459),
    [anon_sym_yield] = ACTIONS(3459),
    [anon_sym_when] = ACTIONS(3459),
    [anon_sym_from] = ACTIONS(3459),
    [anon_sym_into] = ACTIONS(3459),
    [anon_sym_join] = ACTIONS(3459),
    [anon_sym_on] = ACTIONS(3459),
    [anon_sym_equals] = ACTIONS(3459),
    [anon_sym_let] = ACTIONS(3459),
    [anon_sym_orderby] = ACTIONS(3459),
    [anon_sym_ascending] = ACTIONS(3459),
    [anon_sym_descending] = ACTIONS(3459),
    [anon_sym_group] = ACTIONS(3459),
    [anon_sym_by] = ACTIONS(3459),
    [anon_sym_select] = ACTIONS(3459),
    [aux_sym_preproc_if_token1] = ACTIONS(3461),
    [aux_sym_preproc_if_token3] = ACTIONS(3461),
    [aux_sym_preproc_else_token1] = ACTIONS(3461),
    [aux_sym_preproc_elif_token1] = ACTIONS(3461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3281] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3281),
    [sym_preproc_endregion] = STATE(3281),
    [sym_preproc_line] = STATE(3281),
    [sym_preproc_pragma] = STATE(3281),
    [sym_preproc_nullable] = STATE(3281),
    [sym_preproc_error] = STATE(3281),
    [sym_preproc_define] = STATE(3281),
    [sym_preproc_undef] = STATE(3281),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4397),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3282] = {
    [sym_preproc_region] = STATE(3282),
    [sym_preproc_endregion] = STATE(3282),
    [sym_preproc_line] = STATE(3282),
    [sym_preproc_pragma] = STATE(3282),
    [sym_preproc_nullable] = STATE(3282),
    [sym_preproc_error] = STATE(3282),
    [sym_preproc_define] = STATE(3282),
    [sym_preproc_undef] = STATE(3282),
    [sym__identifier_token] = ACTIONS(4863),
    [anon_sym_extern] = ACTIONS(4863),
    [anon_sym_alias] = ACTIONS(4863),
    [anon_sym_global] = ACTIONS(4863),
    [anon_sym_using] = ACTIONS(4863),
    [anon_sym_unsafe] = ACTIONS(4863),
    [anon_sym_static] = ACTIONS(4863),
    [anon_sym_LBRACK] = ACTIONS(4865),
    [anon_sym_LPAREN] = ACTIONS(4865),
    [anon_sym_event] = ACTIONS(4863),
    [anon_sym_namespace] = ACTIONS(4863),
    [anon_sym_class] = ACTIONS(4863),
    [anon_sym_ref] = ACTIONS(4863),
    [anon_sym_struct] = ACTIONS(4863),
    [anon_sym_enum] = ACTIONS(4863),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_interface] = ACTIONS(4863),
    [anon_sym_delegate] = ACTIONS(4863),
    [anon_sym_record] = ACTIONS(4863),
    [anon_sym_abstract] = ACTIONS(4863),
    [anon_sym_async] = ACTIONS(4863),
    [anon_sym_const] = ACTIONS(4863),
    [anon_sym_file] = ACTIONS(4863),
    [anon_sym_fixed] = ACTIONS(4863),
    [anon_sym_internal] = ACTIONS(4863),
    [anon_sym_new] = ACTIONS(4863),
    [anon_sym_override] = ACTIONS(4863),
    [anon_sym_partial] = ACTIONS(4863),
    [anon_sym_private] = ACTIONS(4863),
    [anon_sym_protected] = ACTIONS(4863),
    [anon_sym_public] = ACTIONS(4863),
    [anon_sym_readonly] = ACTIONS(4863),
    [anon_sym_required] = ACTIONS(4863),
    [anon_sym_sealed] = ACTIONS(4863),
    [anon_sym_virtual] = ACTIONS(4863),
    [anon_sym_volatile] = ACTIONS(4863),
    [anon_sym_where] = ACTIONS(4863),
    [anon_sym_notnull] = ACTIONS(4863),
    [anon_sym_unmanaged] = ACTIONS(4863),
    [anon_sym_TILDE] = ACTIONS(4865),
    [anon_sym_implicit] = ACTIONS(4863),
    [anon_sym_explicit] = ACTIONS(4863),
    [anon_sym_scoped] = ACTIONS(4863),
    [anon_sym_var] = ACTIONS(4863),
    [sym_predefined_type] = ACTIONS(4863),
    [anon_sym_yield] = ACTIONS(4863),
    [anon_sym_when] = ACTIONS(4863),
    [anon_sym_from] = ACTIONS(4863),
    [anon_sym_into] = ACTIONS(4863),
    [anon_sym_join] = ACTIONS(4863),
    [anon_sym_on] = ACTIONS(4863),
    [anon_sym_equals] = ACTIONS(4863),
    [anon_sym_let] = ACTIONS(4863),
    [anon_sym_orderby] = ACTIONS(4863),
    [anon_sym_ascending] = ACTIONS(4863),
    [anon_sym_descending] = ACTIONS(4863),
    [anon_sym_group] = ACTIONS(4863),
    [anon_sym_by] = ACTIONS(4863),
    [anon_sym_select] = ACTIONS(4863),
    [aux_sym_preproc_if_token1] = ACTIONS(4865),
    [aux_sym_preproc_if_token3] = ACTIONS(4865),
    [aux_sym_preproc_else_token1] = ACTIONS(4865),
    [aux_sym_preproc_elif_token1] = ACTIONS(4865),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3283] = {
    [sym_preproc_region] = STATE(3283),
    [sym_preproc_endregion] = STATE(3283),
    [sym_preproc_line] = STATE(3283),
    [sym_preproc_pragma] = STATE(3283),
    [sym_preproc_nullable] = STATE(3283),
    [sym_preproc_error] = STATE(3283),
    [sym_preproc_define] = STATE(3283),
    [sym_preproc_undef] = STATE(3283),
    [sym__identifier_token] = ACTIONS(4867),
    [anon_sym_extern] = ACTIONS(4867),
    [anon_sym_alias] = ACTIONS(4867),
    [anon_sym_global] = ACTIONS(4867),
    [anon_sym_using] = ACTIONS(4867),
    [anon_sym_unsafe] = ACTIONS(4867),
    [anon_sym_static] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4869),
    [anon_sym_LPAREN] = ACTIONS(4869),
    [anon_sym_event] = ACTIONS(4867),
    [anon_sym_namespace] = ACTIONS(4867),
    [anon_sym_class] = ACTIONS(4867),
    [anon_sym_ref] = ACTIONS(4867),
    [anon_sym_struct] = ACTIONS(4867),
    [anon_sym_enum] = ACTIONS(4867),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_interface] = ACTIONS(4867),
    [anon_sym_delegate] = ACTIONS(4867),
    [anon_sym_record] = ACTIONS(4867),
    [anon_sym_abstract] = ACTIONS(4867),
    [anon_sym_async] = ACTIONS(4867),
    [anon_sym_const] = ACTIONS(4867),
    [anon_sym_file] = ACTIONS(4867),
    [anon_sym_fixed] = ACTIONS(4867),
    [anon_sym_internal] = ACTIONS(4867),
    [anon_sym_new] = ACTIONS(4867),
    [anon_sym_override] = ACTIONS(4867),
    [anon_sym_partial] = ACTIONS(4867),
    [anon_sym_private] = ACTIONS(4867),
    [anon_sym_protected] = ACTIONS(4867),
    [anon_sym_public] = ACTIONS(4867),
    [anon_sym_readonly] = ACTIONS(4867),
    [anon_sym_required] = ACTIONS(4867),
    [anon_sym_sealed] = ACTIONS(4867),
    [anon_sym_virtual] = ACTIONS(4867),
    [anon_sym_volatile] = ACTIONS(4867),
    [anon_sym_where] = ACTIONS(4867),
    [anon_sym_notnull] = ACTIONS(4867),
    [anon_sym_unmanaged] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4869),
    [anon_sym_implicit] = ACTIONS(4867),
    [anon_sym_explicit] = ACTIONS(4867),
    [anon_sym_scoped] = ACTIONS(4867),
    [anon_sym_var] = ACTIONS(4867),
    [sym_predefined_type] = ACTIONS(4867),
    [anon_sym_yield] = ACTIONS(4867),
    [anon_sym_when] = ACTIONS(4867),
    [anon_sym_from] = ACTIONS(4867),
    [anon_sym_into] = ACTIONS(4867),
    [anon_sym_join] = ACTIONS(4867),
    [anon_sym_on] = ACTIONS(4867),
    [anon_sym_equals] = ACTIONS(4867),
    [anon_sym_let] = ACTIONS(4867),
    [anon_sym_orderby] = ACTIONS(4867),
    [anon_sym_ascending] = ACTIONS(4867),
    [anon_sym_descending] = ACTIONS(4867),
    [anon_sym_group] = ACTIONS(4867),
    [anon_sym_by] = ACTIONS(4867),
    [anon_sym_select] = ACTIONS(4867),
    [aux_sym_preproc_if_token1] = ACTIONS(4869),
    [aux_sym_preproc_if_token3] = ACTIONS(4869),
    [aux_sym_preproc_else_token1] = ACTIONS(4869),
    [aux_sym_preproc_elif_token1] = ACTIONS(4869),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3284] = {
    [sym_preproc_region] = STATE(3284),
    [sym_preproc_endregion] = STATE(3284),
    [sym_preproc_line] = STATE(3284),
    [sym_preproc_pragma] = STATE(3284),
    [sym_preproc_nullable] = STATE(3284),
    [sym_preproc_error] = STATE(3284),
    [sym_preproc_define] = STATE(3284),
    [sym_preproc_undef] = STATE(3284),
    [sym__identifier_token] = ACTIONS(4871),
    [anon_sym_extern] = ACTIONS(4871),
    [anon_sym_alias] = ACTIONS(4871),
    [anon_sym_global] = ACTIONS(4871),
    [anon_sym_using] = ACTIONS(4871),
    [anon_sym_unsafe] = ACTIONS(4871),
    [anon_sym_static] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4873),
    [anon_sym_LPAREN] = ACTIONS(4873),
    [anon_sym_event] = ACTIONS(4871),
    [anon_sym_namespace] = ACTIONS(4871),
    [anon_sym_class] = ACTIONS(4871),
    [anon_sym_ref] = ACTIONS(4871),
    [anon_sym_struct] = ACTIONS(4871),
    [anon_sym_enum] = ACTIONS(4871),
    [anon_sym_RBRACE] = ACTIONS(4873),
    [anon_sym_interface] = ACTIONS(4871),
    [anon_sym_delegate] = ACTIONS(4871),
    [anon_sym_record] = ACTIONS(4871),
    [anon_sym_abstract] = ACTIONS(4871),
    [anon_sym_async] = ACTIONS(4871),
    [anon_sym_const] = ACTIONS(4871),
    [anon_sym_file] = ACTIONS(4871),
    [anon_sym_fixed] = ACTIONS(4871),
    [anon_sym_internal] = ACTIONS(4871),
    [anon_sym_new] = ACTIONS(4871),
    [anon_sym_override] = ACTIONS(4871),
    [anon_sym_partial] = ACTIONS(4871),
    [anon_sym_private] = ACTIONS(4871),
    [anon_sym_protected] = ACTIONS(4871),
    [anon_sym_public] = ACTIONS(4871),
    [anon_sym_readonly] = ACTIONS(4871),
    [anon_sym_required] = ACTIONS(4871),
    [anon_sym_sealed] = ACTIONS(4871),
    [anon_sym_virtual] = ACTIONS(4871),
    [anon_sym_volatile] = ACTIONS(4871),
    [anon_sym_where] = ACTIONS(4871),
    [anon_sym_notnull] = ACTIONS(4871),
    [anon_sym_unmanaged] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4873),
    [anon_sym_implicit] = ACTIONS(4871),
    [anon_sym_explicit] = ACTIONS(4871),
    [anon_sym_scoped] = ACTIONS(4871),
    [anon_sym_var] = ACTIONS(4871),
    [sym_predefined_type] = ACTIONS(4871),
    [anon_sym_yield] = ACTIONS(4871),
    [anon_sym_when] = ACTIONS(4871),
    [anon_sym_from] = ACTIONS(4871),
    [anon_sym_into] = ACTIONS(4871),
    [anon_sym_join] = ACTIONS(4871),
    [anon_sym_on] = ACTIONS(4871),
    [anon_sym_equals] = ACTIONS(4871),
    [anon_sym_let] = ACTIONS(4871),
    [anon_sym_orderby] = ACTIONS(4871),
    [anon_sym_ascending] = ACTIONS(4871),
    [anon_sym_descending] = ACTIONS(4871),
    [anon_sym_group] = ACTIONS(4871),
    [anon_sym_by] = ACTIONS(4871),
    [anon_sym_select] = ACTIONS(4871),
    [aux_sym_preproc_if_token1] = ACTIONS(4873),
    [aux_sym_preproc_if_token3] = ACTIONS(4873),
    [aux_sym_preproc_else_token1] = ACTIONS(4873),
    [aux_sym_preproc_elif_token1] = ACTIONS(4873),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3285] = {
    [sym_preproc_region] = STATE(3285),
    [sym_preproc_endregion] = STATE(3285),
    [sym_preproc_line] = STATE(3285),
    [sym_preproc_pragma] = STATE(3285),
    [sym_preproc_nullable] = STATE(3285),
    [sym_preproc_error] = STATE(3285),
    [sym_preproc_define] = STATE(3285),
    [sym_preproc_undef] = STATE(3285),
    [sym__identifier_token] = ACTIONS(4875),
    [anon_sym_extern] = ACTIONS(4875),
    [anon_sym_alias] = ACTIONS(4875),
    [anon_sym_global] = ACTIONS(4875),
    [anon_sym_using] = ACTIONS(4875),
    [anon_sym_unsafe] = ACTIONS(4875),
    [anon_sym_static] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_LPAREN] = ACTIONS(4877),
    [anon_sym_event] = ACTIONS(4875),
    [anon_sym_namespace] = ACTIONS(4875),
    [anon_sym_class] = ACTIONS(4875),
    [anon_sym_ref] = ACTIONS(4875),
    [anon_sym_struct] = ACTIONS(4875),
    [anon_sym_enum] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_interface] = ACTIONS(4875),
    [anon_sym_delegate] = ACTIONS(4875),
    [anon_sym_record] = ACTIONS(4875),
    [anon_sym_abstract] = ACTIONS(4875),
    [anon_sym_async] = ACTIONS(4875),
    [anon_sym_const] = ACTIONS(4875),
    [anon_sym_file] = ACTIONS(4875),
    [anon_sym_fixed] = ACTIONS(4875),
    [anon_sym_internal] = ACTIONS(4875),
    [anon_sym_new] = ACTIONS(4875),
    [anon_sym_override] = ACTIONS(4875),
    [anon_sym_partial] = ACTIONS(4875),
    [anon_sym_private] = ACTIONS(4875),
    [anon_sym_protected] = ACTIONS(4875),
    [anon_sym_public] = ACTIONS(4875),
    [anon_sym_readonly] = ACTIONS(4875),
    [anon_sym_required] = ACTIONS(4875),
    [anon_sym_sealed] = ACTIONS(4875),
    [anon_sym_virtual] = ACTIONS(4875),
    [anon_sym_volatile] = ACTIONS(4875),
    [anon_sym_where] = ACTIONS(4875),
    [anon_sym_notnull] = ACTIONS(4875),
    [anon_sym_unmanaged] = ACTIONS(4875),
    [anon_sym_TILDE] = ACTIONS(4877),
    [anon_sym_implicit] = ACTIONS(4875),
    [anon_sym_explicit] = ACTIONS(4875),
    [anon_sym_scoped] = ACTIONS(4875),
    [anon_sym_var] = ACTIONS(4875),
    [sym_predefined_type] = ACTIONS(4875),
    [anon_sym_yield] = ACTIONS(4875),
    [anon_sym_when] = ACTIONS(4875),
    [anon_sym_from] = ACTIONS(4875),
    [anon_sym_into] = ACTIONS(4875),
    [anon_sym_join] = ACTIONS(4875),
    [anon_sym_on] = ACTIONS(4875),
    [anon_sym_equals] = ACTIONS(4875),
    [anon_sym_let] = ACTIONS(4875),
    [anon_sym_orderby] = ACTIONS(4875),
    [anon_sym_ascending] = ACTIONS(4875),
    [anon_sym_descending] = ACTIONS(4875),
    [anon_sym_group] = ACTIONS(4875),
    [anon_sym_by] = ACTIONS(4875),
    [anon_sym_select] = ACTIONS(4875),
    [aux_sym_preproc_if_token1] = ACTIONS(4877),
    [aux_sym_preproc_if_token3] = ACTIONS(4877),
    [aux_sym_preproc_else_token1] = ACTIONS(4877),
    [aux_sym_preproc_elif_token1] = ACTIONS(4877),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3286] = {
    [sym_preproc_region] = STATE(3286),
    [sym_preproc_endregion] = STATE(3286),
    [sym_preproc_line] = STATE(3286),
    [sym_preproc_pragma] = STATE(3286),
    [sym_preproc_nullable] = STATE(3286),
    [sym_preproc_error] = STATE(3286),
    [sym_preproc_define] = STATE(3286),
    [sym_preproc_undef] = STATE(3286),
    [sym__identifier_token] = ACTIONS(4488),
    [anon_sym_alias] = ACTIONS(4488),
    [anon_sym_global] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_file] = ACTIONS(4488),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_where] = ACTIONS(4488),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_notnull] = ACTIONS(4488),
    [anon_sym_unmanaged] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_scoped] = ACTIONS(4488),
    [anon_sym_var] = ACTIONS(4488),
    [anon_sym_yield] = ACTIONS(4488),
    [anon_sym_switch] = ACTIONS(4488),
    [anon_sym_when] = ACTIONS(4488),
    [sym_discard] = ACTIONS(4488),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4488),
    [anon_sym_or] = ACTIONS(4488),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_from] = ACTIONS(4488),
    [anon_sym_into] = ACTIONS(4488),
    [anon_sym_join] = ACTIONS(4488),
    [anon_sym_on] = ACTIONS(4488),
    [anon_sym_equals] = ACTIONS(4488),
    [anon_sym_let] = ACTIONS(4488),
    [anon_sym_orderby] = ACTIONS(4488),
    [anon_sym_ascending] = ACTIONS(4488),
    [anon_sym_descending] = ACTIONS(4488),
    [anon_sym_group] = ACTIONS(4488),
    [anon_sym_by] = ACTIONS(4488),
    [anon_sym_select] = ACTIONS(4488),
    [anon_sym_as] = ACTIONS(4488),
    [anon_sym_is] = ACTIONS(4488),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4488),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4490),
  },
  [3287] = {
    [sym_preproc_region] = STATE(3287),
    [sym_preproc_endregion] = STATE(3287),
    [sym_preproc_line] = STATE(3287),
    [sym_preproc_pragma] = STATE(3287),
    [sym_preproc_nullable] = STATE(3287),
    [sym_preproc_error] = STATE(3287),
    [sym_preproc_define] = STATE(3287),
    [sym_preproc_undef] = STATE(3287),
    [sym__identifier_token] = ACTIONS(4484),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_file] = ACTIONS(4484),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_scoped] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_switch] = ACTIONS(4484),
    [anon_sym_when] = ACTIONS(4484),
    [sym_discard] = ACTIONS(4484),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4484),
    [anon_sym_or] = ACTIONS(4484),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(4484),
    [anon_sym_is] = ACTIONS(4484),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4484),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4486),
  },
  [3288] = {
    [sym_preproc_region] = STATE(3288),
    [sym_preproc_endregion] = STATE(3288),
    [sym_preproc_line] = STATE(3288),
    [sym_preproc_pragma] = STATE(3288),
    [sym_preproc_nullable] = STATE(3288),
    [sym_preproc_error] = STATE(3288),
    [sym_preproc_define] = STATE(3288),
    [sym_preproc_undef] = STATE(3288),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_file] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_scoped] = ACTIONS(4480),
    [anon_sym_var] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [sym_discard] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4482),
  },
  [3289] = {
    [sym__variable_designation] = STATE(4984),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3289),
    [sym_preproc_endregion] = STATE(3289),
    [sym_preproc_line] = STATE(3289),
    [sym_preproc_pragma] = STATE(3289),
    [sym_preproc_nullable] = STATE(3289),
    [sym_preproc_error] = STATE(3289),
    [sym_preproc_define] = STATE(3289),
    [sym_preproc_undef] = STATE(3289),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3290] = {
    [sym_preproc_region] = STATE(3290),
    [sym_preproc_endregion] = STATE(3290),
    [sym_preproc_line] = STATE(3290),
    [sym_preproc_pragma] = STATE(3290),
    [sym_preproc_nullable] = STATE(3290),
    [sym_preproc_error] = STATE(3290),
    [sym_preproc_define] = STATE(3290),
    [sym_preproc_undef] = STATE(3290),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_file] = ACTIONS(4480),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4879),
    [anon_sym_scoped] = ACTIONS(4480),
    [anon_sym_var] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_switch] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [sym_discard] = ACTIONS(4480),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4480),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [anon_sym_as] = ACTIONS(4480),
    [anon_sym_is] = ACTIONS(4480),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4480),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4482),
  },
  [3291] = {
    [sym_preproc_region] = STATE(3291),
    [sym_preproc_endregion] = STATE(3291),
    [sym_preproc_line] = STATE(3291),
    [sym_preproc_pragma] = STATE(3291),
    [sym_preproc_nullable] = STATE(3291),
    [sym_preproc_error] = STATE(3291),
    [sym_preproc_define] = STATE(3291),
    [sym_preproc_undef] = STATE(3291),
    [sym__identifier_token] = ACTIONS(4881),
    [anon_sym_extern] = ACTIONS(4881),
    [anon_sym_alias] = ACTIONS(4881),
    [anon_sym_global] = ACTIONS(4881),
    [anon_sym_using] = ACTIONS(4881),
    [anon_sym_unsafe] = ACTIONS(4881),
    [anon_sym_static] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4883),
    [anon_sym_LPAREN] = ACTIONS(4883),
    [anon_sym_event] = ACTIONS(4881),
    [anon_sym_namespace] = ACTIONS(4881),
    [anon_sym_class] = ACTIONS(4881),
    [anon_sym_ref] = ACTIONS(4881),
    [anon_sym_struct] = ACTIONS(4881),
    [anon_sym_enum] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4883),
    [anon_sym_interface] = ACTIONS(4881),
    [anon_sym_delegate] = ACTIONS(4881),
    [anon_sym_record] = ACTIONS(4881),
    [anon_sym_abstract] = ACTIONS(4881),
    [anon_sym_async] = ACTIONS(4881),
    [anon_sym_const] = ACTIONS(4881),
    [anon_sym_file] = ACTIONS(4881),
    [anon_sym_fixed] = ACTIONS(4881),
    [anon_sym_internal] = ACTIONS(4881),
    [anon_sym_new] = ACTIONS(4881),
    [anon_sym_override] = ACTIONS(4881),
    [anon_sym_partial] = ACTIONS(4881),
    [anon_sym_private] = ACTIONS(4881),
    [anon_sym_protected] = ACTIONS(4881),
    [anon_sym_public] = ACTIONS(4881),
    [anon_sym_readonly] = ACTIONS(4881),
    [anon_sym_required] = ACTIONS(4881),
    [anon_sym_sealed] = ACTIONS(4881),
    [anon_sym_virtual] = ACTIONS(4881),
    [anon_sym_volatile] = ACTIONS(4881),
    [anon_sym_where] = ACTIONS(4881),
    [anon_sym_notnull] = ACTIONS(4881),
    [anon_sym_unmanaged] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4883),
    [anon_sym_implicit] = ACTIONS(4881),
    [anon_sym_explicit] = ACTIONS(4881),
    [anon_sym_scoped] = ACTIONS(4881),
    [anon_sym_var] = ACTIONS(4881),
    [sym_predefined_type] = ACTIONS(4881),
    [anon_sym_yield] = ACTIONS(4881),
    [anon_sym_when] = ACTIONS(4881),
    [anon_sym_from] = ACTIONS(4881),
    [anon_sym_into] = ACTIONS(4881),
    [anon_sym_join] = ACTIONS(4881),
    [anon_sym_on] = ACTIONS(4881),
    [anon_sym_equals] = ACTIONS(4881),
    [anon_sym_let] = ACTIONS(4881),
    [anon_sym_orderby] = ACTIONS(4881),
    [anon_sym_ascending] = ACTIONS(4881),
    [anon_sym_descending] = ACTIONS(4881),
    [anon_sym_group] = ACTIONS(4881),
    [anon_sym_by] = ACTIONS(4881),
    [anon_sym_select] = ACTIONS(4881),
    [aux_sym_preproc_if_token1] = ACTIONS(4883),
    [aux_sym_preproc_if_token3] = ACTIONS(4883),
    [aux_sym_preproc_else_token1] = ACTIONS(4883),
    [aux_sym_preproc_elif_token1] = ACTIONS(4883),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3292] = {
    [sym_preproc_region] = STATE(3292),
    [sym_preproc_endregion] = STATE(3292),
    [sym_preproc_line] = STATE(3292),
    [sym_preproc_pragma] = STATE(3292),
    [sym_preproc_nullable] = STATE(3292),
    [sym_preproc_error] = STATE(3292),
    [sym_preproc_define] = STATE(3292),
    [sym_preproc_undef] = STATE(3292),
    [sym__identifier_token] = ACTIONS(4885),
    [anon_sym_extern] = ACTIONS(4885),
    [anon_sym_alias] = ACTIONS(4885),
    [anon_sym_global] = ACTIONS(4885),
    [anon_sym_using] = ACTIONS(4885),
    [anon_sym_unsafe] = ACTIONS(4885),
    [anon_sym_static] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(4887),
    [anon_sym_LPAREN] = ACTIONS(4887),
    [anon_sym_event] = ACTIONS(4885),
    [anon_sym_namespace] = ACTIONS(4885),
    [anon_sym_class] = ACTIONS(4885),
    [anon_sym_ref] = ACTIONS(4885),
    [anon_sym_struct] = ACTIONS(4885),
    [anon_sym_enum] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4887),
    [anon_sym_interface] = ACTIONS(4885),
    [anon_sym_delegate] = ACTIONS(4885),
    [anon_sym_record] = ACTIONS(4885),
    [anon_sym_abstract] = ACTIONS(4885),
    [anon_sym_async] = ACTIONS(4885),
    [anon_sym_const] = ACTIONS(4885),
    [anon_sym_file] = ACTIONS(4885),
    [anon_sym_fixed] = ACTIONS(4885),
    [anon_sym_internal] = ACTIONS(4885),
    [anon_sym_new] = ACTIONS(4885),
    [anon_sym_override] = ACTIONS(4885),
    [anon_sym_partial] = ACTIONS(4885),
    [anon_sym_private] = ACTIONS(4885),
    [anon_sym_protected] = ACTIONS(4885),
    [anon_sym_public] = ACTIONS(4885),
    [anon_sym_readonly] = ACTIONS(4885),
    [anon_sym_required] = ACTIONS(4885),
    [anon_sym_sealed] = ACTIONS(4885),
    [anon_sym_virtual] = ACTIONS(4885),
    [anon_sym_volatile] = ACTIONS(4885),
    [anon_sym_where] = ACTIONS(4885),
    [anon_sym_notnull] = ACTIONS(4885),
    [anon_sym_unmanaged] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4887),
    [anon_sym_implicit] = ACTIONS(4885),
    [anon_sym_explicit] = ACTIONS(4885),
    [anon_sym_scoped] = ACTIONS(4885),
    [anon_sym_var] = ACTIONS(4885),
    [sym_predefined_type] = ACTIONS(4885),
    [anon_sym_yield] = ACTIONS(4885),
    [anon_sym_when] = ACTIONS(4885),
    [anon_sym_from] = ACTIONS(4885),
    [anon_sym_into] = ACTIONS(4885),
    [anon_sym_join] = ACTIONS(4885),
    [anon_sym_on] = ACTIONS(4885),
    [anon_sym_equals] = ACTIONS(4885),
    [anon_sym_let] = ACTIONS(4885),
    [anon_sym_orderby] = ACTIONS(4885),
    [anon_sym_ascending] = ACTIONS(4885),
    [anon_sym_descending] = ACTIONS(4885),
    [anon_sym_group] = ACTIONS(4885),
    [anon_sym_by] = ACTIONS(4885),
    [anon_sym_select] = ACTIONS(4885),
    [aux_sym_preproc_if_token1] = ACTIONS(4887),
    [aux_sym_preproc_if_token3] = ACTIONS(4887),
    [aux_sym_preproc_else_token1] = ACTIONS(4887),
    [aux_sym_preproc_elif_token1] = ACTIONS(4887),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3293] = {
    [sym_preproc_region] = STATE(3293),
    [sym_preproc_endregion] = STATE(3293),
    [sym_preproc_line] = STATE(3293),
    [sym_preproc_pragma] = STATE(3293),
    [sym_preproc_nullable] = STATE(3293),
    [sym_preproc_error] = STATE(3293),
    [sym_preproc_define] = STATE(3293),
    [sym_preproc_undef] = STATE(3293),
    [sym__identifier_token] = ACTIONS(4889),
    [anon_sym_extern] = ACTIONS(4889),
    [anon_sym_alias] = ACTIONS(4889),
    [anon_sym_global] = ACTIONS(4889),
    [anon_sym_using] = ACTIONS(4889),
    [anon_sym_unsafe] = ACTIONS(4889),
    [anon_sym_static] = ACTIONS(4889),
    [anon_sym_LBRACK] = ACTIONS(4891),
    [anon_sym_LPAREN] = ACTIONS(4891),
    [anon_sym_event] = ACTIONS(4889),
    [anon_sym_namespace] = ACTIONS(4889),
    [anon_sym_class] = ACTIONS(4889),
    [anon_sym_ref] = ACTIONS(4889),
    [anon_sym_struct] = ACTIONS(4889),
    [anon_sym_enum] = ACTIONS(4889),
    [anon_sym_RBRACE] = ACTIONS(4891),
    [anon_sym_interface] = ACTIONS(4889),
    [anon_sym_delegate] = ACTIONS(4889),
    [anon_sym_record] = ACTIONS(4889),
    [anon_sym_abstract] = ACTIONS(4889),
    [anon_sym_async] = ACTIONS(4889),
    [anon_sym_const] = ACTIONS(4889),
    [anon_sym_file] = ACTIONS(4889),
    [anon_sym_fixed] = ACTIONS(4889),
    [anon_sym_internal] = ACTIONS(4889),
    [anon_sym_new] = ACTIONS(4889),
    [anon_sym_override] = ACTIONS(4889),
    [anon_sym_partial] = ACTIONS(4889),
    [anon_sym_private] = ACTIONS(4889),
    [anon_sym_protected] = ACTIONS(4889),
    [anon_sym_public] = ACTIONS(4889),
    [anon_sym_readonly] = ACTIONS(4889),
    [anon_sym_required] = ACTIONS(4889),
    [anon_sym_sealed] = ACTIONS(4889),
    [anon_sym_virtual] = ACTIONS(4889),
    [anon_sym_volatile] = ACTIONS(4889),
    [anon_sym_where] = ACTIONS(4889),
    [anon_sym_notnull] = ACTIONS(4889),
    [anon_sym_unmanaged] = ACTIONS(4889),
    [anon_sym_TILDE] = ACTIONS(4891),
    [anon_sym_implicit] = ACTIONS(4889),
    [anon_sym_explicit] = ACTIONS(4889),
    [anon_sym_scoped] = ACTIONS(4889),
    [anon_sym_var] = ACTIONS(4889),
    [sym_predefined_type] = ACTIONS(4889),
    [anon_sym_yield] = ACTIONS(4889),
    [anon_sym_when] = ACTIONS(4889),
    [anon_sym_from] = ACTIONS(4889),
    [anon_sym_into] = ACTIONS(4889),
    [anon_sym_join] = ACTIONS(4889),
    [anon_sym_on] = ACTIONS(4889),
    [anon_sym_equals] = ACTIONS(4889),
    [anon_sym_let] = ACTIONS(4889),
    [anon_sym_orderby] = ACTIONS(4889),
    [anon_sym_ascending] = ACTIONS(4889),
    [anon_sym_descending] = ACTIONS(4889),
    [anon_sym_group] = ACTIONS(4889),
    [anon_sym_by] = ACTIONS(4889),
    [anon_sym_select] = ACTIONS(4889),
    [aux_sym_preproc_if_token1] = ACTIONS(4891),
    [aux_sym_preproc_if_token3] = ACTIONS(4891),
    [aux_sym_preproc_else_token1] = ACTIONS(4891),
    [aux_sym_preproc_elif_token1] = ACTIONS(4891),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3294] = {
    [sym__variable_designation] = STATE(4989),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3294),
    [sym_preproc_endregion] = STATE(3294),
    [sym_preproc_line] = STATE(3294),
    [sym_preproc_pragma] = STATE(3294),
    [sym_preproc_nullable] = STATE(3294),
    [sym_preproc_error] = STATE(3294),
    [sym_preproc_define] = STATE(3294),
    [sym_preproc_undef] = STATE(3294),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4445),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4445),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4445),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4445),
    [anon_sym_orderby] = ACTIONS(4445),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4445),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4445),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3295] = {
    [sym_preproc_region] = STATE(3295),
    [sym_preproc_endregion] = STATE(3295),
    [sym_preproc_line] = STATE(3295),
    [sym_preproc_pragma] = STATE(3295),
    [sym_preproc_nullable] = STATE(3295),
    [sym_preproc_error] = STATE(3295),
    [sym_preproc_define] = STATE(3295),
    [sym_preproc_undef] = STATE(3295),
    [sym__identifier_token] = ACTIONS(4893),
    [anon_sym_extern] = ACTIONS(4893),
    [anon_sym_alias] = ACTIONS(4893),
    [anon_sym_global] = ACTIONS(4893),
    [anon_sym_using] = ACTIONS(4893),
    [anon_sym_unsafe] = ACTIONS(4893),
    [anon_sym_static] = ACTIONS(4893),
    [anon_sym_LBRACK] = ACTIONS(4895),
    [anon_sym_LPAREN] = ACTIONS(4895),
    [anon_sym_event] = ACTIONS(4893),
    [anon_sym_namespace] = ACTIONS(4893),
    [anon_sym_class] = ACTIONS(4893),
    [anon_sym_ref] = ACTIONS(4893),
    [anon_sym_struct] = ACTIONS(4893),
    [anon_sym_enum] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4895),
    [anon_sym_interface] = ACTIONS(4893),
    [anon_sym_delegate] = ACTIONS(4893),
    [anon_sym_record] = ACTIONS(4893),
    [anon_sym_abstract] = ACTIONS(4893),
    [anon_sym_async] = ACTIONS(4893),
    [anon_sym_const] = ACTIONS(4893),
    [anon_sym_file] = ACTIONS(4893),
    [anon_sym_fixed] = ACTIONS(4893),
    [anon_sym_internal] = ACTIONS(4893),
    [anon_sym_new] = ACTIONS(4893),
    [anon_sym_override] = ACTIONS(4893),
    [anon_sym_partial] = ACTIONS(4893),
    [anon_sym_private] = ACTIONS(4893),
    [anon_sym_protected] = ACTIONS(4893),
    [anon_sym_public] = ACTIONS(4893),
    [anon_sym_readonly] = ACTIONS(4893),
    [anon_sym_required] = ACTIONS(4893),
    [anon_sym_sealed] = ACTIONS(4893),
    [anon_sym_virtual] = ACTIONS(4893),
    [anon_sym_volatile] = ACTIONS(4893),
    [anon_sym_where] = ACTIONS(4893),
    [anon_sym_notnull] = ACTIONS(4893),
    [anon_sym_unmanaged] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4895),
    [anon_sym_implicit] = ACTIONS(4893),
    [anon_sym_explicit] = ACTIONS(4893),
    [anon_sym_scoped] = ACTIONS(4893),
    [anon_sym_var] = ACTIONS(4893),
    [sym_predefined_type] = ACTIONS(4893),
    [anon_sym_yield] = ACTIONS(4893),
    [anon_sym_when] = ACTIONS(4893),
    [anon_sym_from] = ACTIONS(4893),
    [anon_sym_into] = ACTIONS(4893),
    [anon_sym_join] = ACTIONS(4893),
    [anon_sym_on] = ACTIONS(4893),
    [anon_sym_equals] = ACTIONS(4893),
    [anon_sym_let] = ACTIONS(4893),
    [anon_sym_orderby] = ACTIONS(4893),
    [anon_sym_ascending] = ACTIONS(4893),
    [anon_sym_descending] = ACTIONS(4893),
    [anon_sym_group] = ACTIONS(4893),
    [anon_sym_by] = ACTIONS(4893),
    [anon_sym_select] = ACTIONS(4893),
    [aux_sym_preproc_if_token1] = ACTIONS(4895),
    [aux_sym_preproc_if_token3] = ACTIONS(4895),
    [aux_sym_preproc_else_token1] = ACTIONS(4895),
    [aux_sym_preproc_elif_token1] = ACTIONS(4895),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3296] = {
    [sym_preproc_region] = STATE(3296),
    [sym_preproc_endregion] = STATE(3296),
    [sym_preproc_line] = STATE(3296),
    [sym_preproc_pragma] = STATE(3296),
    [sym_preproc_nullable] = STATE(3296),
    [sym_preproc_error] = STATE(3296),
    [sym_preproc_define] = STATE(3296),
    [sym_preproc_undef] = STATE(3296),
    [sym__identifier_token] = ACTIONS(4897),
    [anon_sym_extern] = ACTIONS(4897),
    [anon_sym_alias] = ACTIONS(4897),
    [anon_sym_global] = ACTIONS(4897),
    [anon_sym_using] = ACTIONS(4897),
    [anon_sym_unsafe] = ACTIONS(4897),
    [anon_sym_static] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4899),
    [anon_sym_LPAREN] = ACTIONS(4899),
    [anon_sym_event] = ACTIONS(4897),
    [anon_sym_namespace] = ACTIONS(4897),
    [anon_sym_class] = ACTIONS(4897),
    [anon_sym_ref] = ACTIONS(4897),
    [anon_sym_struct] = ACTIONS(4897),
    [anon_sym_enum] = ACTIONS(4897),
    [anon_sym_RBRACE] = ACTIONS(4899),
    [anon_sym_interface] = ACTIONS(4897),
    [anon_sym_delegate] = ACTIONS(4897),
    [anon_sym_record] = ACTIONS(4897),
    [anon_sym_abstract] = ACTIONS(4897),
    [anon_sym_async] = ACTIONS(4897),
    [anon_sym_const] = ACTIONS(4897),
    [anon_sym_file] = ACTIONS(4897),
    [anon_sym_fixed] = ACTIONS(4897),
    [anon_sym_internal] = ACTIONS(4897),
    [anon_sym_new] = ACTIONS(4897),
    [anon_sym_override] = ACTIONS(4897),
    [anon_sym_partial] = ACTIONS(4897),
    [anon_sym_private] = ACTIONS(4897),
    [anon_sym_protected] = ACTIONS(4897),
    [anon_sym_public] = ACTIONS(4897),
    [anon_sym_readonly] = ACTIONS(4897),
    [anon_sym_required] = ACTIONS(4897),
    [anon_sym_sealed] = ACTIONS(4897),
    [anon_sym_virtual] = ACTIONS(4897),
    [anon_sym_volatile] = ACTIONS(4897),
    [anon_sym_where] = ACTIONS(4897),
    [anon_sym_notnull] = ACTIONS(4897),
    [anon_sym_unmanaged] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4899),
    [anon_sym_implicit] = ACTIONS(4897),
    [anon_sym_explicit] = ACTIONS(4897),
    [anon_sym_scoped] = ACTIONS(4897),
    [anon_sym_var] = ACTIONS(4897),
    [sym_predefined_type] = ACTIONS(4897),
    [anon_sym_yield] = ACTIONS(4897),
    [anon_sym_when] = ACTIONS(4897),
    [anon_sym_from] = ACTIONS(4897),
    [anon_sym_into] = ACTIONS(4897),
    [anon_sym_join] = ACTIONS(4897),
    [anon_sym_on] = ACTIONS(4897),
    [anon_sym_equals] = ACTIONS(4897),
    [anon_sym_let] = ACTIONS(4897),
    [anon_sym_orderby] = ACTIONS(4897),
    [anon_sym_ascending] = ACTIONS(4897),
    [anon_sym_descending] = ACTIONS(4897),
    [anon_sym_group] = ACTIONS(4897),
    [anon_sym_by] = ACTIONS(4897),
    [anon_sym_select] = ACTIONS(4897),
    [aux_sym_preproc_if_token1] = ACTIONS(4899),
    [aux_sym_preproc_if_token3] = ACTIONS(4899),
    [aux_sym_preproc_else_token1] = ACTIONS(4899),
    [aux_sym_preproc_elif_token1] = ACTIONS(4899),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3297] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3297),
    [sym_preproc_endregion] = STATE(3297),
    [sym_preproc_line] = STATE(3297),
    [sym_preproc_pragma] = STATE(3297),
    [sym_preproc_nullable] = STATE(3297),
    [sym_preproc_error] = STATE(3297),
    [sym_preproc_define] = STATE(3297),
    [sym_preproc_undef] = STATE(3297),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4435),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3298] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3298),
    [sym_preproc_endregion] = STATE(3298),
    [sym_preproc_line] = STATE(3298),
    [sym_preproc_pragma] = STATE(3298),
    [sym_preproc_nullable] = STATE(3298),
    [sym_preproc_error] = STATE(3298),
    [sym_preproc_define] = STATE(3298),
    [sym_preproc_undef] = STATE(3298),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4445),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3299] = {
    [sym_preproc_region] = STATE(3299),
    [sym_preproc_endregion] = STATE(3299),
    [sym_preproc_line] = STATE(3299),
    [sym_preproc_pragma] = STATE(3299),
    [sym_preproc_nullable] = STATE(3299),
    [sym_preproc_error] = STATE(3299),
    [sym_preproc_define] = STATE(3299),
    [sym_preproc_undef] = STATE(3299),
    [sym__identifier_token] = ACTIONS(4901),
    [anon_sym_extern] = ACTIONS(4901),
    [anon_sym_alias] = ACTIONS(4901),
    [anon_sym_global] = ACTIONS(4901),
    [anon_sym_using] = ACTIONS(4901),
    [anon_sym_unsafe] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(4903),
    [anon_sym_LPAREN] = ACTIONS(4903),
    [anon_sym_event] = ACTIONS(4901),
    [anon_sym_namespace] = ACTIONS(4901),
    [anon_sym_class] = ACTIONS(4901),
    [anon_sym_ref] = ACTIONS(4901),
    [anon_sym_struct] = ACTIONS(4901),
    [anon_sym_enum] = ACTIONS(4901),
    [anon_sym_RBRACE] = ACTIONS(4903),
    [anon_sym_interface] = ACTIONS(4901),
    [anon_sym_delegate] = ACTIONS(4901),
    [anon_sym_record] = ACTIONS(4901),
    [anon_sym_abstract] = ACTIONS(4901),
    [anon_sym_async] = ACTIONS(4901),
    [anon_sym_const] = ACTIONS(4901),
    [anon_sym_file] = ACTIONS(4901),
    [anon_sym_fixed] = ACTIONS(4901),
    [anon_sym_internal] = ACTIONS(4901),
    [anon_sym_new] = ACTIONS(4901),
    [anon_sym_override] = ACTIONS(4901),
    [anon_sym_partial] = ACTIONS(4901),
    [anon_sym_private] = ACTIONS(4901),
    [anon_sym_protected] = ACTIONS(4901),
    [anon_sym_public] = ACTIONS(4901),
    [anon_sym_readonly] = ACTIONS(4901),
    [anon_sym_required] = ACTIONS(4901),
    [anon_sym_sealed] = ACTIONS(4901),
    [anon_sym_virtual] = ACTIONS(4901),
    [anon_sym_volatile] = ACTIONS(4901),
    [anon_sym_where] = ACTIONS(4901),
    [anon_sym_notnull] = ACTIONS(4901),
    [anon_sym_unmanaged] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4903),
    [anon_sym_implicit] = ACTIONS(4901),
    [anon_sym_explicit] = ACTIONS(4901),
    [anon_sym_scoped] = ACTIONS(4901),
    [anon_sym_var] = ACTIONS(4901),
    [sym_predefined_type] = ACTIONS(4901),
    [anon_sym_yield] = ACTIONS(4901),
    [anon_sym_when] = ACTIONS(4901),
    [anon_sym_from] = ACTIONS(4901),
    [anon_sym_into] = ACTIONS(4901),
    [anon_sym_join] = ACTIONS(4901),
    [anon_sym_on] = ACTIONS(4901),
    [anon_sym_equals] = ACTIONS(4901),
    [anon_sym_let] = ACTIONS(4901),
    [anon_sym_orderby] = ACTIONS(4901),
    [anon_sym_ascending] = ACTIONS(4901),
    [anon_sym_descending] = ACTIONS(4901),
    [anon_sym_group] = ACTIONS(4901),
    [anon_sym_by] = ACTIONS(4901),
    [anon_sym_select] = ACTIONS(4901),
    [aux_sym_preproc_if_token1] = ACTIONS(4903),
    [aux_sym_preproc_if_token3] = ACTIONS(4903),
    [aux_sym_preproc_else_token1] = ACTIONS(4903),
    [aux_sym_preproc_elif_token1] = ACTIONS(4903),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3300] = {
    [sym_preproc_region] = STATE(3300),
    [sym_preproc_endregion] = STATE(3300),
    [sym_preproc_line] = STATE(3300),
    [sym_preproc_pragma] = STATE(3300),
    [sym_preproc_nullable] = STATE(3300),
    [sym_preproc_error] = STATE(3300),
    [sym_preproc_define] = STATE(3300),
    [sym_preproc_undef] = STATE(3300),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4132),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_when] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4132),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3301] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3301),
    [sym_preproc_endregion] = STATE(3301),
    [sym_preproc_line] = STATE(3301),
    [sym_preproc_pragma] = STATE(3301),
    [sym_preproc_nullable] = STATE(3301),
    [sym_preproc_error] = STATE(3301),
    [sym_preproc_define] = STATE(3301),
    [sym_preproc_undef] = STATE(3301),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4405),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3302] = {
    [sym_preproc_region] = STATE(3302),
    [sym_preproc_endregion] = STATE(3302),
    [sym_preproc_line] = STATE(3302),
    [sym_preproc_pragma] = STATE(3302),
    [sym_preproc_nullable] = STATE(3302),
    [sym_preproc_error] = STATE(3302),
    [sym_preproc_define] = STATE(3302),
    [sym_preproc_undef] = STATE(3302),
    [sym__identifier_token] = ACTIONS(3937),
    [anon_sym_extern] = ACTIONS(3937),
    [anon_sym_alias] = ACTIONS(3937),
    [anon_sym_global] = ACTIONS(3937),
    [anon_sym_using] = ACTIONS(3937),
    [anon_sym_unsafe] = ACTIONS(3937),
    [anon_sym_static] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_event] = ACTIONS(3937),
    [anon_sym_namespace] = ACTIONS(3937),
    [anon_sym_class] = ACTIONS(3937),
    [anon_sym_ref] = ACTIONS(3937),
    [anon_sym_struct] = ACTIONS(3937),
    [anon_sym_enum] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [anon_sym_interface] = ACTIONS(3937),
    [anon_sym_delegate] = ACTIONS(3937),
    [anon_sym_record] = ACTIONS(3937),
    [anon_sym_abstract] = ACTIONS(3937),
    [anon_sym_async] = ACTIONS(3937),
    [anon_sym_const] = ACTIONS(3937),
    [anon_sym_file] = ACTIONS(3937),
    [anon_sym_fixed] = ACTIONS(3937),
    [anon_sym_internal] = ACTIONS(3937),
    [anon_sym_new] = ACTIONS(3937),
    [anon_sym_override] = ACTIONS(3937),
    [anon_sym_partial] = ACTIONS(3937),
    [anon_sym_private] = ACTIONS(3937),
    [anon_sym_protected] = ACTIONS(3937),
    [anon_sym_public] = ACTIONS(3937),
    [anon_sym_readonly] = ACTIONS(3937),
    [anon_sym_required] = ACTIONS(3937),
    [anon_sym_sealed] = ACTIONS(3937),
    [anon_sym_virtual] = ACTIONS(3937),
    [anon_sym_volatile] = ACTIONS(3937),
    [anon_sym_where] = ACTIONS(3937),
    [anon_sym_notnull] = ACTIONS(3937),
    [anon_sym_unmanaged] = ACTIONS(3937),
    [anon_sym_TILDE] = ACTIONS(3939),
    [anon_sym_implicit] = ACTIONS(3937),
    [anon_sym_explicit] = ACTIONS(3937),
    [anon_sym_scoped] = ACTIONS(3937),
    [anon_sym_var] = ACTIONS(3937),
    [sym_predefined_type] = ACTIONS(3937),
    [anon_sym_yield] = ACTIONS(3937),
    [anon_sym_when] = ACTIONS(3937),
    [anon_sym_from] = ACTIONS(3937),
    [anon_sym_into] = ACTIONS(3937),
    [anon_sym_join] = ACTIONS(3937),
    [anon_sym_on] = ACTIONS(3937),
    [anon_sym_equals] = ACTIONS(3937),
    [anon_sym_let] = ACTIONS(3937),
    [anon_sym_orderby] = ACTIONS(3937),
    [anon_sym_ascending] = ACTIONS(3937),
    [anon_sym_descending] = ACTIONS(3937),
    [anon_sym_group] = ACTIONS(3937),
    [anon_sym_by] = ACTIONS(3937),
    [anon_sym_select] = ACTIONS(3937),
    [aux_sym_preproc_if_token1] = ACTIONS(3939),
    [aux_sym_preproc_if_token3] = ACTIONS(3939),
    [aux_sym_preproc_else_token1] = ACTIONS(3939),
    [aux_sym_preproc_elif_token1] = ACTIONS(3939),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3303] = {
    [sym_preproc_region] = STATE(3303),
    [sym_preproc_endregion] = STATE(3303),
    [sym_preproc_line] = STATE(3303),
    [sym_preproc_pragma] = STATE(3303),
    [sym_preproc_nullable] = STATE(3303),
    [sym_preproc_error] = STATE(3303),
    [sym_preproc_define] = STATE(3303),
    [sym_preproc_undef] = STATE(3303),
    [sym__identifier_token] = ACTIONS(3851),
    [anon_sym_extern] = ACTIONS(3851),
    [anon_sym_alias] = ACTIONS(3851),
    [anon_sym_global] = ACTIONS(3851),
    [anon_sym_using] = ACTIONS(3851),
    [anon_sym_unsafe] = ACTIONS(3851),
    [anon_sym_static] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3853),
    [anon_sym_LPAREN] = ACTIONS(3853),
    [anon_sym_event] = ACTIONS(3851),
    [anon_sym_namespace] = ACTIONS(3851),
    [anon_sym_class] = ACTIONS(3851),
    [anon_sym_ref] = ACTIONS(3851),
    [anon_sym_struct] = ACTIONS(3851),
    [anon_sym_enum] = ACTIONS(3851),
    [anon_sym_RBRACE] = ACTIONS(3853),
    [anon_sym_interface] = ACTIONS(3851),
    [anon_sym_delegate] = ACTIONS(3851),
    [anon_sym_record] = ACTIONS(3851),
    [anon_sym_abstract] = ACTIONS(3851),
    [anon_sym_async] = ACTIONS(3851),
    [anon_sym_const] = ACTIONS(3851),
    [anon_sym_file] = ACTIONS(3851),
    [anon_sym_fixed] = ACTIONS(3851),
    [anon_sym_internal] = ACTIONS(3851),
    [anon_sym_new] = ACTIONS(3851),
    [anon_sym_override] = ACTIONS(3851),
    [anon_sym_partial] = ACTIONS(3851),
    [anon_sym_private] = ACTIONS(3851),
    [anon_sym_protected] = ACTIONS(3851),
    [anon_sym_public] = ACTIONS(3851),
    [anon_sym_readonly] = ACTIONS(3851),
    [anon_sym_required] = ACTIONS(3851),
    [anon_sym_sealed] = ACTIONS(3851),
    [anon_sym_virtual] = ACTIONS(3851),
    [anon_sym_volatile] = ACTIONS(3851),
    [anon_sym_where] = ACTIONS(3851),
    [anon_sym_notnull] = ACTIONS(3851),
    [anon_sym_unmanaged] = ACTIONS(3851),
    [anon_sym_TILDE] = ACTIONS(3853),
    [anon_sym_implicit] = ACTIONS(3851),
    [anon_sym_explicit] = ACTIONS(3851),
    [anon_sym_scoped] = ACTIONS(3851),
    [anon_sym_var] = ACTIONS(3851),
    [sym_predefined_type] = ACTIONS(3851),
    [anon_sym_yield] = ACTIONS(3851),
    [anon_sym_when] = ACTIONS(3851),
    [anon_sym_from] = ACTIONS(3851),
    [anon_sym_into] = ACTIONS(3851),
    [anon_sym_join] = ACTIONS(3851),
    [anon_sym_on] = ACTIONS(3851),
    [anon_sym_equals] = ACTIONS(3851),
    [anon_sym_let] = ACTIONS(3851),
    [anon_sym_orderby] = ACTIONS(3851),
    [anon_sym_ascending] = ACTIONS(3851),
    [anon_sym_descending] = ACTIONS(3851),
    [anon_sym_group] = ACTIONS(3851),
    [anon_sym_by] = ACTIONS(3851),
    [anon_sym_select] = ACTIONS(3851),
    [aux_sym_preproc_if_token1] = ACTIONS(3853),
    [aux_sym_preproc_if_token3] = ACTIONS(3853),
    [aux_sym_preproc_else_token1] = ACTIONS(3853),
    [aux_sym_preproc_elif_token1] = ACTIONS(3853),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3304] = {
    [sym_preproc_region] = STATE(3304),
    [sym_preproc_endregion] = STATE(3304),
    [sym_preproc_line] = STATE(3304),
    [sym_preproc_pragma] = STATE(3304),
    [sym_preproc_nullable] = STATE(3304),
    [sym_preproc_error] = STATE(3304),
    [sym_preproc_define] = STATE(3304),
    [sym_preproc_undef] = STATE(3304),
    [sym__identifier_token] = ACTIONS(3847),
    [anon_sym_extern] = ACTIONS(3847),
    [anon_sym_alias] = ACTIONS(3847),
    [anon_sym_global] = ACTIONS(3847),
    [anon_sym_using] = ACTIONS(3847),
    [anon_sym_unsafe] = ACTIONS(3847),
    [anon_sym_static] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3849),
    [anon_sym_event] = ACTIONS(3847),
    [anon_sym_namespace] = ACTIONS(3847),
    [anon_sym_class] = ACTIONS(3847),
    [anon_sym_ref] = ACTIONS(3847),
    [anon_sym_struct] = ACTIONS(3847),
    [anon_sym_enum] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3849),
    [anon_sym_interface] = ACTIONS(3847),
    [anon_sym_delegate] = ACTIONS(3847),
    [anon_sym_record] = ACTIONS(3847),
    [anon_sym_abstract] = ACTIONS(3847),
    [anon_sym_async] = ACTIONS(3847),
    [anon_sym_const] = ACTIONS(3847),
    [anon_sym_file] = ACTIONS(3847),
    [anon_sym_fixed] = ACTIONS(3847),
    [anon_sym_internal] = ACTIONS(3847),
    [anon_sym_new] = ACTIONS(3847),
    [anon_sym_override] = ACTIONS(3847),
    [anon_sym_partial] = ACTIONS(3847),
    [anon_sym_private] = ACTIONS(3847),
    [anon_sym_protected] = ACTIONS(3847),
    [anon_sym_public] = ACTIONS(3847),
    [anon_sym_readonly] = ACTIONS(3847),
    [anon_sym_required] = ACTIONS(3847),
    [anon_sym_sealed] = ACTIONS(3847),
    [anon_sym_virtual] = ACTIONS(3847),
    [anon_sym_volatile] = ACTIONS(3847),
    [anon_sym_where] = ACTIONS(3847),
    [anon_sym_notnull] = ACTIONS(3847),
    [anon_sym_unmanaged] = ACTIONS(3847),
    [anon_sym_TILDE] = ACTIONS(3849),
    [anon_sym_implicit] = ACTIONS(3847),
    [anon_sym_explicit] = ACTIONS(3847),
    [anon_sym_scoped] = ACTIONS(3847),
    [anon_sym_var] = ACTIONS(3847),
    [sym_predefined_type] = ACTIONS(3847),
    [anon_sym_yield] = ACTIONS(3847),
    [anon_sym_when] = ACTIONS(3847),
    [anon_sym_from] = ACTIONS(3847),
    [anon_sym_into] = ACTIONS(3847),
    [anon_sym_join] = ACTIONS(3847),
    [anon_sym_on] = ACTIONS(3847),
    [anon_sym_equals] = ACTIONS(3847),
    [anon_sym_let] = ACTIONS(3847),
    [anon_sym_orderby] = ACTIONS(3847),
    [anon_sym_ascending] = ACTIONS(3847),
    [anon_sym_descending] = ACTIONS(3847),
    [anon_sym_group] = ACTIONS(3847),
    [anon_sym_by] = ACTIONS(3847),
    [anon_sym_select] = ACTIONS(3847),
    [aux_sym_preproc_if_token1] = ACTIONS(3849),
    [aux_sym_preproc_if_token3] = ACTIONS(3849),
    [aux_sym_preproc_else_token1] = ACTIONS(3849),
    [aux_sym_preproc_elif_token1] = ACTIONS(3849),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3305] = {
    [sym_preproc_region] = STATE(3305),
    [sym_preproc_endregion] = STATE(3305),
    [sym_preproc_line] = STATE(3305),
    [sym_preproc_pragma] = STATE(3305),
    [sym_preproc_nullable] = STATE(3305),
    [sym_preproc_error] = STATE(3305),
    [sym_preproc_define] = STATE(3305),
    [sym_preproc_undef] = STATE(3305),
    [sym__identifier_token] = ACTIONS(3843),
    [anon_sym_extern] = ACTIONS(3843),
    [anon_sym_alias] = ACTIONS(3843),
    [anon_sym_global] = ACTIONS(3843),
    [anon_sym_using] = ACTIONS(3843),
    [anon_sym_unsafe] = ACTIONS(3843),
    [anon_sym_static] = ACTIONS(3843),
    [anon_sym_LBRACK] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3845),
    [anon_sym_event] = ACTIONS(3843),
    [anon_sym_namespace] = ACTIONS(3843),
    [anon_sym_class] = ACTIONS(3843),
    [anon_sym_ref] = ACTIONS(3843),
    [anon_sym_struct] = ACTIONS(3843),
    [anon_sym_enum] = ACTIONS(3843),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_interface] = ACTIONS(3843),
    [anon_sym_delegate] = ACTIONS(3843),
    [anon_sym_record] = ACTIONS(3843),
    [anon_sym_abstract] = ACTIONS(3843),
    [anon_sym_async] = ACTIONS(3843),
    [anon_sym_const] = ACTIONS(3843),
    [anon_sym_file] = ACTIONS(3843),
    [anon_sym_fixed] = ACTIONS(3843),
    [anon_sym_internal] = ACTIONS(3843),
    [anon_sym_new] = ACTIONS(3843),
    [anon_sym_override] = ACTIONS(3843),
    [anon_sym_partial] = ACTIONS(3843),
    [anon_sym_private] = ACTIONS(3843),
    [anon_sym_protected] = ACTIONS(3843),
    [anon_sym_public] = ACTIONS(3843),
    [anon_sym_readonly] = ACTIONS(3843),
    [anon_sym_required] = ACTIONS(3843),
    [anon_sym_sealed] = ACTIONS(3843),
    [anon_sym_virtual] = ACTIONS(3843),
    [anon_sym_volatile] = ACTIONS(3843),
    [anon_sym_where] = ACTIONS(3843),
    [anon_sym_notnull] = ACTIONS(3843),
    [anon_sym_unmanaged] = ACTIONS(3843),
    [anon_sym_TILDE] = ACTIONS(3845),
    [anon_sym_implicit] = ACTIONS(3843),
    [anon_sym_explicit] = ACTIONS(3843),
    [anon_sym_scoped] = ACTIONS(3843),
    [anon_sym_var] = ACTIONS(3843),
    [sym_predefined_type] = ACTIONS(3843),
    [anon_sym_yield] = ACTIONS(3843),
    [anon_sym_when] = ACTIONS(3843),
    [anon_sym_from] = ACTIONS(3843),
    [anon_sym_into] = ACTIONS(3843),
    [anon_sym_join] = ACTIONS(3843),
    [anon_sym_on] = ACTIONS(3843),
    [anon_sym_equals] = ACTIONS(3843),
    [anon_sym_let] = ACTIONS(3843),
    [anon_sym_orderby] = ACTIONS(3843),
    [anon_sym_ascending] = ACTIONS(3843),
    [anon_sym_descending] = ACTIONS(3843),
    [anon_sym_group] = ACTIONS(3843),
    [anon_sym_by] = ACTIONS(3843),
    [anon_sym_select] = ACTIONS(3843),
    [aux_sym_preproc_if_token1] = ACTIONS(3845),
    [aux_sym_preproc_if_token3] = ACTIONS(3845),
    [aux_sym_preproc_else_token1] = ACTIONS(3845),
    [aux_sym_preproc_elif_token1] = ACTIONS(3845),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3306] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3306),
    [sym_preproc_endregion] = STATE(3306),
    [sym_preproc_line] = STATE(3306),
    [sym_preproc_pragma] = STATE(3306),
    [sym_preproc_nullable] = STATE(3306),
    [sym_preproc_error] = STATE(3306),
    [sym_preproc_define] = STATE(3306),
    [sym_preproc_undef] = STATE(3306),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4397),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4337),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3307] = {
    [sym_preproc_region] = STATE(3307),
    [sym_preproc_endregion] = STATE(3307),
    [sym_preproc_line] = STATE(3307),
    [sym_preproc_pragma] = STATE(3307),
    [sym_preproc_nullable] = STATE(3307),
    [sym_preproc_error] = STATE(3307),
    [sym_preproc_define] = STATE(3307),
    [sym_preproc_undef] = STATE(3307),
    [sym__identifier_token] = ACTIONS(3787),
    [anon_sym_extern] = ACTIONS(3787),
    [anon_sym_alias] = ACTIONS(3787),
    [anon_sym_global] = ACTIONS(3787),
    [anon_sym_using] = ACTIONS(3787),
    [anon_sym_unsafe] = ACTIONS(3787),
    [anon_sym_static] = ACTIONS(3787),
    [anon_sym_LBRACK] = ACTIONS(3789),
    [anon_sym_LPAREN] = ACTIONS(3789),
    [anon_sym_event] = ACTIONS(3787),
    [anon_sym_namespace] = ACTIONS(3787),
    [anon_sym_class] = ACTIONS(3787),
    [anon_sym_ref] = ACTIONS(3787),
    [anon_sym_struct] = ACTIONS(3787),
    [anon_sym_enum] = ACTIONS(3787),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_interface] = ACTIONS(3787),
    [anon_sym_delegate] = ACTIONS(3787),
    [anon_sym_record] = ACTIONS(3787),
    [anon_sym_abstract] = ACTIONS(3787),
    [anon_sym_async] = ACTIONS(3787),
    [anon_sym_const] = ACTIONS(3787),
    [anon_sym_file] = ACTIONS(3787),
    [anon_sym_fixed] = ACTIONS(3787),
    [anon_sym_internal] = ACTIONS(3787),
    [anon_sym_new] = ACTIONS(3787),
    [anon_sym_override] = ACTIONS(3787),
    [anon_sym_partial] = ACTIONS(3787),
    [anon_sym_private] = ACTIONS(3787),
    [anon_sym_protected] = ACTIONS(3787),
    [anon_sym_public] = ACTIONS(3787),
    [anon_sym_readonly] = ACTIONS(3787),
    [anon_sym_required] = ACTIONS(3787),
    [anon_sym_sealed] = ACTIONS(3787),
    [anon_sym_virtual] = ACTIONS(3787),
    [anon_sym_volatile] = ACTIONS(3787),
    [anon_sym_where] = ACTIONS(3787),
    [anon_sym_notnull] = ACTIONS(3787),
    [anon_sym_unmanaged] = ACTIONS(3787),
    [anon_sym_TILDE] = ACTIONS(3789),
    [anon_sym_implicit] = ACTIONS(3787),
    [anon_sym_explicit] = ACTIONS(3787),
    [anon_sym_scoped] = ACTIONS(3787),
    [anon_sym_var] = ACTIONS(3787),
    [sym_predefined_type] = ACTIONS(3787),
    [anon_sym_yield] = ACTIONS(3787),
    [anon_sym_when] = ACTIONS(3787),
    [anon_sym_from] = ACTIONS(3787),
    [anon_sym_into] = ACTIONS(3787),
    [anon_sym_join] = ACTIONS(3787),
    [anon_sym_on] = ACTIONS(3787),
    [anon_sym_equals] = ACTIONS(3787),
    [anon_sym_let] = ACTIONS(3787),
    [anon_sym_orderby] = ACTIONS(3787),
    [anon_sym_ascending] = ACTIONS(3787),
    [anon_sym_descending] = ACTIONS(3787),
    [anon_sym_group] = ACTIONS(3787),
    [anon_sym_by] = ACTIONS(3787),
    [anon_sym_select] = ACTIONS(3787),
    [aux_sym_preproc_if_token1] = ACTIONS(3789),
    [aux_sym_preproc_if_token3] = ACTIONS(3789),
    [aux_sym_preproc_else_token1] = ACTIONS(3789),
    [aux_sym_preproc_elif_token1] = ACTIONS(3789),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3308] = {
    [sym_preproc_region] = STATE(3308),
    [sym_preproc_endregion] = STATE(3308),
    [sym_preproc_line] = STATE(3308),
    [sym_preproc_pragma] = STATE(3308),
    [sym_preproc_nullable] = STATE(3308),
    [sym_preproc_error] = STATE(3308),
    [sym_preproc_define] = STATE(3308),
    [sym_preproc_undef] = STATE(3308),
    [sym__identifier_token] = ACTIONS(4905),
    [anon_sym_extern] = ACTIONS(4905),
    [anon_sym_alias] = ACTIONS(4905),
    [anon_sym_global] = ACTIONS(4905),
    [anon_sym_using] = ACTIONS(4905),
    [anon_sym_unsafe] = ACTIONS(4905),
    [anon_sym_static] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(4907),
    [anon_sym_LPAREN] = ACTIONS(4907),
    [anon_sym_event] = ACTIONS(4905),
    [anon_sym_namespace] = ACTIONS(4905),
    [anon_sym_class] = ACTIONS(4905),
    [anon_sym_ref] = ACTIONS(4905),
    [anon_sym_struct] = ACTIONS(4905),
    [anon_sym_enum] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4907),
    [anon_sym_interface] = ACTIONS(4905),
    [anon_sym_delegate] = ACTIONS(4905),
    [anon_sym_record] = ACTIONS(4905),
    [anon_sym_abstract] = ACTIONS(4905),
    [anon_sym_async] = ACTIONS(4905),
    [anon_sym_const] = ACTIONS(4905),
    [anon_sym_file] = ACTIONS(4905),
    [anon_sym_fixed] = ACTIONS(4905),
    [anon_sym_internal] = ACTIONS(4905),
    [anon_sym_new] = ACTIONS(4905),
    [anon_sym_override] = ACTIONS(4905),
    [anon_sym_partial] = ACTIONS(4905),
    [anon_sym_private] = ACTIONS(4905),
    [anon_sym_protected] = ACTIONS(4905),
    [anon_sym_public] = ACTIONS(4905),
    [anon_sym_readonly] = ACTIONS(4905),
    [anon_sym_required] = ACTIONS(4905),
    [anon_sym_sealed] = ACTIONS(4905),
    [anon_sym_virtual] = ACTIONS(4905),
    [anon_sym_volatile] = ACTIONS(4905),
    [anon_sym_where] = ACTIONS(4905),
    [anon_sym_notnull] = ACTIONS(4905),
    [anon_sym_unmanaged] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4907),
    [anon_sym_implicit] = ACTIONS(4905),
    [anon_sym_explicit] = ACTIONS(4905),
    [anon_sym_scoped] = ACTIONS(4905),
    [anon_sym_var] = ACTIONS(4905),
    [sym_predefined_type] = ACTIONS(4905),
    [anon_sym_yield] = ACTIONS(4905),
    [anon_sym_when] = ACTIONS(4905),
    [anon_sym_from] = ACTIONS(4905),
    [anon_sym_into] = ACTIONS(4905),
    [anon_sym_join] = ACTIONS(4905),
    [anon_sym_on] = ACTIONS(4905),
    [anon_sym_equals] = ACTIONS(4905),
    [anon_sym_let] = ACTIONS(4905),
    [anon_sym_orderby] = ACTIONS(4905),
    [anon_sym_ascending] = ACTIONS(4905),
    [anon_sym_descending] = ACTIONS(4905),
    [anon_sym_group] = ACTIONS(4905),
    [anon_sym_by] = ACTIONS(4905),
    [anon_sym_select] = ACTIONS(4905),
    [aux_sym_preproc_if_token1] = ACTIONS(4907),
    [aux_sym_preproc_if_token3] = ACTIONS(4907),
    [aux_sym_preproc_else_token1] = ACTIONS(4907),
    [aux_sym_preproc_elif_token1] = ACTIONS(4907),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3309] = {
    [sym_preproc_region] = STATE(3309),
    [sym_preproc_endregion] = STATE(3309),
    [sym_preproc_line] = STATE(3309),
    [sym_preproc_pragma] = STATE(3309),
    [sym_preproc_nullable] = STATE(3309),
    [sym_preproc_error] = STATE(3309),
    [sym_preproc_define] = STATE(3309),
    [sym_preproc_undef] = STATE(3309),
    [sym__identifier_token] = ACTIONS(4909),
    [anon_sym_extern] = ACTIONS(4909),
    [anon_sym_alias] = ACTIONS(4909),
    [anon_sym_global] = ACTIONS(4909),
    [anon_sym_using] = ACTIONS(4909),
    [anon_sym_unsafe] = ACTIONS(4909),
    [anon_sym_static] = ACTIONS(4909),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [anon_sym_event] = ACTIONS(4909),
    [anon_sym_namespace] = ACTIONS(4909),
    [anon_sym_class] = ACTIONS(4909),
    [anon_sym_ref] = ACTIONS(4909),
    [anon_sym_struct] = ACTIONS(4909),
    [anon_sym_enum] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_interface] = ACTIONS(4909),
    [anon_sym_delegate] = ACTIONS(4909),
    [anon_sym_record] = ACTIONS(4909),
    [anon_sym_abstract] = ACTIONS(4909),
    [anon_sym_async] = ACTIONS(4909),
    [anon_sym_const] = ACTIONS(4909),
    [anon_sym_file] = ACTIONS(4909),
    [anon_sym_fixed] = ACTIONS(4909),
    [anon_sym_internal] = ACTIONS(4909),
    [anon_sym_new] = ACTIONS(4909),
    [anon_sym_override] = ACTIONS(4909),
    [anon_sym_partial] = ACTIONS(4909),
    [anon_sym_private] = ACTIONS(4909),
    [anon_sym_protected] = ACTIONS(4909),
    [anon_sym_public] = ACTIONS(4909),
    [anon_sym_readonly] = ACTIONS(4909),
    [anon_sym_required] = ACTIONS(4909),
    [anon_sym_sealed] = ACTIONS(4909),
    [anon_sym_virtual] = ACTIONS(4909),
    [anon_sym_volatile] = ACTIONS(4909),
    [anon_sym_where] = ACTIONS(4909),
    [anon_sym_notnull] = ACTIONS(4909),
    [anon_sym_unmanaged] = ACTIONS(4909),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_implicit] = ACTIONS(4909),
    [anon_sym_explicit] = ACTIONS(4909),
    [anon_sym_scoped] = ACTIONS(4909),
    [anon_sym_var] = ACTIONS(4909),
    [sym_predefined_type] = ACTIONS(4909),
    [anon_sym_yield] = ACTIONS(4909),
    [anon_sym_when] = ACTIONS(4909),
    [anon_sym_from] = ACTIONS(4909),
    [anon_sym_into] = ACTIONS(4909),
    [anon_sym_join] = ACTIONS(4909),
    [anon_sym_on] = ACTIONS(4909),
    [anon_sym_equals] = ACTIONS(4909),
    [anon_sym_let] = ACTIONS(4909),
    [anon_sym_orderby] = ACTIONS(4909),
    [anon_sym_ascending] = ACTIONS(4909),
    [anon_sym_descending] = ACTIONS(4909),
    [anon_sym_group] = ACTIONS(4909),
    [anon_sym_by] = ACTIONS(4909),
    [anon_sym_select] = ACTIONS(4909),
    [aux_sym_preproc_if_token1] = ACTIONS(4911),
    [aux_sym_preproc_if_token3] = ACTIONS(4911),
    [aux_sym_preproc_else_token1] = ACTIONS(4911),
    [aux_sym_preproc_elif_token1] = ACTIONS(4911),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3310] = {
    [sym_preproc_region] = STATE(3310),
    [sym_preproc_endregion] = STATE(3310),
    [sym_preproc_line] = STATE(3310),
    [sym_preproc_pragma] = STATE(3310),
    [sym_preproc_nullable] = STATE(3310),
    [sym_preproc_error] = STATE(3310),
    [sym_preproc_define] = STATE(3310),
    [sym_preproc_undef] = STATE(3310),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3311] = {
    [sym_preproc_region] = STATE(3311),
    [sym_preproc_endregion] = STATE(3311),
    [sym_preproc_line] = STATE(3311),
    [sym_preproc_pragma] = STATE(3311),
    [sym_preproc_nullable] = STATE(3311),
    [sym_preproc_error] = STATE(3311),
    [sym_preproc_define] = STATE(3311),
    [sym_preproc_undef] = STATE(3311),
    [sym__identifier_token] = ACTIONS(4913),
    [anon_sym_extern] = ACTIONS(4913),
    [anon_sym_alias] = ACTIONS(4913),
    [anon_sym_global] = ACTIONS(4913),
    [anon_sym_using] = ACTIONS(4913),
    [anon_sym_unsafe] = ACTIONS(4913),
    [anon_sym_static] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_LPAREN] = ACTIONS(4915),
    [anon_sym_event] = ACTIONS(4913),
    [anon_sym_namespace] = ACTIONS(4913),
    [anon_sym_class] = ACTIONS(4913),
    [anon_sym_ref] = ACTIONS(4913),
    [anon_sym_struct] = ACTIONS(4913),
    [anon_sym_enum] = ACTIONS(4913),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_interface] = ACTIONS(4913),
    [anon_sym_delegate] = ACTIONS(4913),
    [anon_sym_record] = ACTIONS(4913),
    [anon_sym_abstract] = ACTIONS(4913),
    [anon_sym_async] = ACTIONS(4913),
    [anon_sym_const] = ACTIONS(4913),
    [anon_sym_file] = ACTIONS(4913),
    [anon_sym_fixed] = ACTIONS(4913),
    [anon_sym_internal] = ACTIONS(4913),
    [anon_sym_new] = ACTIONS(4913),
    [anon_sym_override] = ACTIONS(4913),
    [anon_sym_partial] = ACTIONS(4913),
    [anon_sym_private] = ACTIONS(4913),
    [anon_sym_protected] = ACTIONS(4913),
    [anon_sym_public] = ACTIONS(4913),
    [anon_sym_readonly] = ACTIONS(4913),
    [anon_sym_required] = ACTIONS(4913),
    [anon_sym_sealed] = ACTIONS(4913),
    [anon_sym_virtual] = ACTIONS(4913),
    [anon_sym_volatile] = ACTIONS(4913),
    [anon_sym_where] = ACTIONS(4913),
    [anon_sym_notnull] = ACTIONS(4913),
    [anon_sym_unmanaged] = ACTIONS(4913),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_implicit] = ACTIONS(4913),
    [anon_sym_explicit] = ACTIONS(4913),
    [anon_sym_scoped] = ACTIONS(4913),
    [anon_sym_var] = ACTIONS(4913),
    [sym_predefined_type] = ACTIONS(4913),
    [anon_sym_yield] = ACTIONS(4913),
    [anon_sym_when] = ACTIONS(4913),
    [anon_sym_from] = ACTIONS(4913),
    [anon_sym_into] = ACTIONS(4913),
    [anon_sym_join] = ACTIONS(4913),
    [anon_sym_on] = ACTIONS(4913),
    [anon_sym_equals] = ACTIONS(4913),
    [anon_sym_let] = ACTIONS(4913),
    [anon_sym_orderby] = ACTIONS(4913),
    [anon_sym_ascending] = ACTIONS(4913),
    [anon_sym_descending] = ACTIONS(4913),
    [anon_sym_group] = ACTIONS(4913),
    [anon_sym_by] = ACTIONS(4913),
    [anon_sym_select] = ACTIONS(4913),
    [aux_sym_preproc_if_token1] = ACTIONS(4915),
    [aux_sym_preproc_if_token3] = ACTIONS(4915),
    [aux_sym_preproc_else_token1] = ACTIONS(4915),
    [aux_sym_preproc_elif_token1] = ACTIONS(4915),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3312] = {
    [sym_preproc_region] = STATE(3312),
    [sym_preproc_endregion] = STATE(3312),
    [sym_preproc_line] = STATE(3312),
    [sym_preproc_pragma] = STATE(3312),
    [sym_preproc_nullable] = STATE(3312),
    [sym_preproc_error] = STATE(3312),
    [sym_preproc_define] = STATE(3312),
    [sym_preproc_undef] = STATE(3312),
    [sym__identifier_token] = ACTIONS(4498),
    [anon_sym_alias] = ACTIONS(4498),
    [anon_sym_global] = ACTIONS(4498),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_file] = ACTIONS(4498),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_where] = ACTIONS(4498),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_notnull] = ACTIONS(4498),
    [anon_sym_unmanaged] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_scoped] = ACTIONS(4498),
    [anon_sym_var] = ACTIONS(4498),
    [anon_sym_yield] = ACTIONS(4498),
    [anon_sym_switch] = ACTIONS(4498),
    [anon_sym_when] = ACTIONS(4498),
    [sym_discard] = ACTIONS(4498),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4498),
    [anon_sym_or] = ACTIONS(4498),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_from] = ACTIONS(4498),
    [anon_sym_into] = ACTIONS(4498),
    [anon_sym_join] = ACTIONS(4498),
    [anon_sym_on] = ACTIONS(4498),
    [anon_sym_equals] = ACTIONS(4498),
    [anon_sym_let] = ACTIONS(4498),
    [anon_sym_orderby] = ACTIONS(4498),
    [anon_sym_ascending] = ACTIONS(4498),
    [anon_sym_descending] = ACTIONS(4498),
    [anon_sym_group] = ACTIONS(4498),
    [anon_sym_by] = ACTIONS(4498),
    [anon_sym_select] = ACTIONS(4498),
    [anon_sym_as] = ACTIONS(4498),
    [anon_sym_is] = ACTIONS(4498),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4498),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4500),
  },
  [3313] = {
    [sym_preproc_region] = STATE(3313),
    [sym_preproc_endregion] = STATE(3313),
    [sym_preproc_line] = STATE(3313),
    [sym_preproc_pragma] = STATE(3313),
    [sym_preproc_nullable] = STATE(3313),
    [sym_preproc_error] = STATE(3313),
    [sym_preproc_define] = STATE(3313),
    [sym_preproc_undef] = STATE(3313),
    [sym__identifier_token] = ACTIONS(3551),
    [anon_sym_extern] = ACTIONS(3551),
    [anon_sym_alias] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3551),
    [anon_sym_using] = ACTIONS(3551),
    [anon_sym_unsafe] = ACTIONS(3551),
    [anon_sym_static] = ACTIONS(3551),
    [anon_sym_LBRACK] = ACTIONS(3553),
    [anon_sym_LPAREN] = ACTIONS(3553),
    [anon_sym_event] = ACTIONS(3551),
    [anon_sym_namespace] = ACTIONS(3551),
    [anon_sym_class] = ACTIONS(3551),
    [anon_sym_ref] = ACTIONS(3551),
    [anon_sym_struct] = ACTIONS(3551),
    [anon_sym_enum] = ACTIONS(3551),
    [anon_sym_RBRACE] = ACTIONS(3553),
    [anon_sym_interface] = ACTIONS(3551),
    [anon_sym_delegate] = ACTIONS(3551),
    [anon_sym_record] = ACTIONS(3551),
    [anon_sym_abstract] = ACTIONS(3551),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_file] = ACTIONS(3551),
    [anon_sym_fixed] = ACTIONS(3551),
    [anon_sym_internal] = ACTIONS(3551),
    [anon_sym_new] = ACTIONS(3551),
    [anon_sym_override] = ACTIONS(3551),
    [anon_sym_partial] = ACTIONS(3551),
    [anon_sym_private] = ACTIONS(3551),
    [anon_sym_protected] = ACTIONS(3551),
    [anon_sym_public] = ACTIONS(3551),
    [anon_sym_readonly] = ACTIONS(3551),
    [anon_sym_required] = ACTIONS(3551),
    [anon_sym_sealed] = ACTIONS(3551),
    [anon_sym_virtual] = ACTIONS(3551),
    [anon_sym_volatile] = ACTIONS(3551),
    [anon_sym_where] = ACTIONS(3551),
    [anon_sym_notnull] = ACTIONS(3551),
    [anon_sym_unmanaged] = ACTIONS(3551),
    [anon_sym_TILDE] = ACTIONS(3553),
    [anon_sym_implicit] = ACTIONS(3551),
    [anon_sym_explicit] = ACTIONS(3551),
    [anon_sym_scoped] = ACTIONS(3551),
    [anon_sym_var] = ACTIONS(3551),
    [sym_predefined_type] = ACTIONS(3551),
    [anon_sym_yield] = ACTIONS(3551),
    [anon_sym_when] = ACTIONS(3551),
    [anon_sym_from] = ACTIONS(3551),
    [anon_sym_into] = ACTIONS(3551),
    [anon_sym_join] = ACTIONS(3551),
    [anon_sym_on] = ACTIONS(3551),
    [anon_sym_equals] = ACTIONS(3551),
    [anon_sym_let] = ACTIONS(3551),
    [anon_sym_orderby] = ACTIONS(3551),
    [anon_sym_ascending] = ACTIONS(3551),
    [anon_sym_descending] = ACTIONS(3551),
    [anon_sym_group] = ACTIONS(3551),
    [anon_sym_by] = ACTIONS(3551),
    [anon_sym_select] = ACTIONS(3551),
    [aux_sym_preproc_if_token1] = ACTIONS(3553),
    [aux_sym_preproc_if_token3] = ACTIONS(3553),
    [aux_sym_preproc_else_token1] = ACTIONS(3553),
    [aux_sym_preproc_elif_token1] = ACTIONS(3553),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3314] = {
    [sym_preproc_region] = STATE(3314),
    [sym_preproc_endregion] = STATE(3314),
    [sym_preproc_line] = STATE(3314),
    [sym_preproc_pragma] = STATE(3314),
    [sym_preproc_nullable] = STATE(3314),
    [sym_preproc_error] = STATE(3314),
    [sym_preproc_define] = STATE(3314),
    [sym_preproc_undef] = STATE(3314),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3315] = {
    [sym_preproc_region] = STATE(3315),
    [sym_preproc_endregion] = STATE(3315),
    [sym_preproc_line] = STATE(3315),
    [sym_preproc_pragma] = STATE(3315),
    [sym_preproc_nullable] = STATE(3315),
    [sym_preproc_error] = STATE(3315),
    [sym_preproc_define] = STATE(3315),
    [sym_preproc_undef] = STATE(3315),
    [sym__identifier_token] = ACTIONS(4917),
    [anon_sym_extern] = ACTIONS(4917),
    [anon_sym_alias] = ACTIONS(4917),
    [anon_sym_global] = ACTIONS(4917),
    [anon_sym_using] = ACTIONS(4917),
    [anon_sym_unsafe] = ACTIONS(4917),
    [anon_sym_static] = ACTIONS(4917),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(4919),
    [anon_sym_event] = ACTIONS(4917),
    [anon_sym_namespace] = ACTIONS(4917),
    [anon_sym_class] = ACTIONS(4917),
    [anon_sym_ref] = ACTIONS(4917),
    [anon_sym_struct] = ACTIONS(4917),
    [anon_sym_enum] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_interface] = ACTIONS(4917),
    [anon_sym_delegate] = ACTIONS(4917),
    [anon_sym_record] = ACTIONS(4917),
    [anon_sym_abstract] = ACTIONS(4917),
    [anon_sym_async] = ACTIONS(4917),
    [anon_sym_const] = ACTIONS(4917),
    [anon_sym_file] = ACTIONS(4917),
    [anon_sym_fixed] = ACTIONS(4917),
    [anon_sym_internal] = ACTIONS(4917),
    [anon_sym_new] = ACTIONS(4917),
    [anon_sym_override] = ACTIONS(4917),
    [anon_sym_partial] = ACTIONS(4917),
    [anon_sym_private] = ACTIONS(4917),
    [anon_sym_protected] = ACTIONS(4917),
    [anon_sym_public] = ACTIONS(4917),
    [anon_sym_readonly] = ACTIONS(4917),
    [anon_sym_required] = ACTIONS(4917),
    [anon_sym_sealed] = ACTIONS(4917),
    [anon_sym_virtual] = ACTIONS(4917),
    [anon_sym_volatile] = ACTIONS(4917),
    [anon_sym_where] = ACTIONS(4917),
    [anon_sym_notnull] = ACTIONS(4917),
    [anon_sym_unmanaged] = ACTIONS(4917),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_implicit] = ACTIONS(4917),
    [anon_sym_explicit] = ACTIONS(4917),
    [anon_sym_scoped] = ACTIONS(4917),
    [anon_sym_var] = ACTIONS(4917),
    [sym_predefined_type] = ACTIONS(4917),
    [anon_sym_yield] = ACTIONS(4917),
    [anon_sym_when] = ACTIONS(4917),
    [anon_sym_from] = ACTIONS(4917),
    [anon_sym_into] = ACTIONS(4917),
    [anon_sym_join] = ACTIONS(4917),
    [anon_sym_on] = ACTIONS(4917),
    [anon_sym_equals] = ACTIONS(4917),
    [anon_sym_let] = ACTIONS(4917),
    [anon_sym_orderby] = ACTIONS(4917),
    [anon_sym_ascending] = ACTIONS(4917),
    [anon_sym_descending] = ACTIONS(4917),
    [anon_sym_group] = ACTIONS(4917),
    [anon_sym_by] = ACTIONS(4917),
    [anon_sym_select] = ACTIONS(4917),
    [aux_sym_preproc_if_token1] = ACTIONS(4919),
    [aux_sym_preproc_if_token3] = ACTIONS(4919),
    [aux_sym_preproc_else_token1] = ACTIONS(4919),
    [aux_sym_preproc_elif_token1] = ACTIONS(4919),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3316] = {
    [sym_preproc_region] = STATE(3316),
    [sym_preproc_endregion] = STATE(3316),
    [sym_preproc_line] = STATE(3316),
    [sym_preproc_pragma] = STATE(3316),
    [sym_preproc_nullable] = STATE(3316),
    [sym_preproc_error] = STATE(3316),
    [sym_preproc_define] = STATE(3316),
    [sym_preproc_undef] = STATE(3316),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_in] = ACTIONS(4705),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_EQ_GT] = ACTIONS(4705),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_when] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4705),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_on] = ACTIONS(4705),
    [anon_sym_equals] = ACTIONS(4705),
    [anon_sym_by] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4705),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_if_token3] = ACTIONS(4705),
    [aux_sym_preproc_else_token1] = ACTIONS(4705),
    [aux_sym_preproc_elif_token1] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3317] = {
    [sym_preproc_region] = STATE(3317),
    [sym_preproc_endregion] = STATE(3317),
    [sym_preproc_line] = STATE(3317),
    [sym_preproc_pragma] = STATE(3317),
    [sym_preproc_nullable] = STATE(3317),
    [sym_preproc_error] = STATE(3317),
    [sym_preproc_define] = STATE(3317),
    [sym_preproc_undef] = STATE(3317),
    [sym__identifier_token] = ACTIONS(3567),
    [anon_sym_extern] = ACTIONS(3567),
    [anon_sym_alias] = ACTIONS(3567),
    [anon_sym_global] = ACTIONS(3567),
    [anon_sym_using] = ACTIONS(3567),
    [anon_sym_unsafe] = ACTIONS(3567),
    [anon_sym_static] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(3569),
    [anon_sym_event] = ACTIONS(3567),
    [anon_sym_namespace] = ACTIONS(3567),
    [anon_sym_class] = ACTIONS(3567),
    [anon_sym_ref] = ACTIONS(3567),
    [anon_sym_struct] = ACTIONS(3567),
    [anon_sym_enum] = ACTIONS(3567),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_interface] = ACTIONS(3567),
    [anon_sym_delegate] = ACTIONS(3567),
    [anon_sym_record] = ACTIONS(3567),
    [anon_sym_abstract] = ACTIONS(3567),
    [anon_sym_async] = ACTIONS(3567),
    [anon_sym_const] = ACTIONS(3567),
    [anon_sym_file] = ACTIONS(3567),
    [anon_sym_fixed] = ACTIONS(3567),
    [anon_sym_internal] = ACTIONS(3567),
    [anon_sym_new] = ACTIONS(3567),
    [anon_sym_override] = ACTIONS(3567),
    [anon_sym_partial] = ACTIONS(3567),
    [anon_sym_private] = ACTIONS(3567),
    [anon_sym_protected] = ACTIONS(3567),
    [anon_sym_public] = ACTIONS(3567),
    [anon_sym_readonly] = ACTIONS(3567),
    [anon_sym_required] = ACTIONS(3567),
    [anon_sym_sealed] = ACTIONS(3567),
    [anon_sym_virtual] = ACTIONS(3567),
    [anon_sym_volatile] = ACTIONS(3567),
    [anon_sym_where] = ACTIONS(3567),
    [anon_sym_notnull] = ACTIONS(3567),
    [anon_sym_unmanaged] = ACTIONS(3567),
    [anon_sym_TILDE] = ACTIONS(3569),
    [anon_sym_implicit] = ACTIONS(3567),
    [anon_sym_explicit] = ACTIONS(3567),
    [anon_sym_scoped] = ACTIONS(3567),
    [anon_sym_var] = ACTIONS(3567),
    [sym_predefined_type] = ACTIONS(3567),
    [anon_sym_yield] = ACTIONS(3567),
    [anon_sym_when] = ACTIONS(3567),
    [anon_sym_from] = ACTIONS(3567),
    [anon_sym_into] = ACTIONS(3567),
    [anon_sym_join] = ACTIONS(3567),
    [anon_sym_on] = ACTIONS(3567),
    [anon_sym_equals] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3567),
    [anon_sym_orderby] = ACTIONS(3567),
    [anon_sym_ascending] = ACTIONS(3567),
    [anon_sym_descending] = ACTIONS(3567),
    [anon_sym_group] = ACTIONS(3567),
    [anon_sym_by] = ACTIONS(3567),
    [anon_sym_select] = ACTIONS(3567),
    [aux_sym_preproc_if_token1] = ACTIONS(3569),
    [aux_sym_preproc_if_token3] = ACTIONS(3569),
    [aux_sym_preproc_else_token1] = ACTIONS(3569),
    [aux_sym_preproc_elif_token1] = ACTIONS(3569),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3318] = {
    [sym_preproc_region] = STATE(3318),
    [sym_preproc_endregion] = STATE(3318),
    [sym_preproc_line] = STATE(3318),
    [sym_preproc_pragma] = STATE(3318),
    [sym_preproc_nullable] = STATE(3318),
    [sym_preproc_error] = STATE(3318),
    [sym_preproc_define] = STATE(3318),
    [sym_preproc_undef] = STATE(3318),
    [sym__identifier_token] = ACTIONS(3571),
    [anon_sym_extern] = ACTIONS(3571),
    [anon_sym_alias] = ACTIONS(3571),
    [anon_sym_global] = ACTIONS(3571),
    [anon_sym_using] = ACTIONS(3571),
    [anon_sym_unsafe] = ACTIONS(3571),
    [anon_sym_static] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3573),
    [anon_sym_LPAREN] = ACTIONS(3573),
    [anon_sym_event] = ACTIONS(3571),
    [anon_sym_namespace] = ACTIONS(3571),
    [anon_sym_class] = ACTIONS(3571),
    [anon_sym_ref] = ACTIONS(3571),
    [anon_sym_struct] = ACTIONS(3571),
    [anon_sym_enum] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [anon_sym_interface] = ACTIONS(3571),
    [anon_sym_delegate] = ACTIONS(3571),
    [anon_sym_record] = ACTIONS(3571),
    [anon_sym_abstract] = ACTIONS(3571),
    [anon_sym_async] = ACTIONS(3571),
    [anon_sym_const] = ACTIONS(3571),
    [anon_sym_file] = ACTIONS(3571),
    [anon_sym_fixed] = ACTIONS(3571),
    [anon_sym_internal] = ACTIONS(3571),
    [anon_sym_new] = ACTIONS(3571),
    [anon_sym_override] = ACTIONS(3571),
    [anon_sym_partial] = ACTIONS(3571),
    [anon_sym_private] = ACTIONS(3571),
    [anon_sym_protected] = ACTIONS(3571),
    [anon_sym_public] = ACTIONS(3571),
    [anon_sym_readonly] = ACTIONS(3571),
    [anon_sym_required] = ACTIONS(3571),
    [anon_sym_sealed] = ACTIONS(3571),
    [anon_sym_virtual] = ACTIONS(3571),
    [anon_sym_volatile] = ACTIONS(3571),
    [anon_sym_where] = ACTIONS(3571),
    [anon_sym_notnull] = ACTIONS(3571),
    [anon_sym_unmanaged] = ACTIONS(3571),
    [anon_sym_TILDE] = ACTIONS(3573),
    [anon_sym_implicit] = ACTIONS(3571),
    [anon_sym_explicit] = ACTIONS(3571),
    [anon_sym_scoped] = ACTIONS(3571),
    [anon_sym_var] = ACTIONS(3571),
    [sym_predefined_type] = ACTIONS(3571),
    [anon_sym_yield] = ACTIONS(3571),
    [anon_sym_when] = ACTIONS(3571),
    [anon_sym_from] = ACTIONS(3571),
    [anon_sym_into] = ACTIONS(3571),
    [anon_sym_join] = ACTIONS(3571),
    [anon_sym_on] = ACTIONS(3571),
    [anon_sym_equals] = ACTIONS(3571),
    [anon_sym_let] = ACTIONS(3571),
    [anon_sym_orderby] = ACTIONS(3571),
    [anon_sym_ascending] = ACTIONS(3571),
    [anon_sym_descending] = ACTIONS(3571),
    [anon_sym_group] = ACTIONS(3571),
    [anon_sym_by] = ACTIONS(3571),
    [anon_sym_select] = ACTIONS(3571),
    [aux_sym_preproc_if_token1] = ACTIONS(3573),
    [aux_sym_preproc_if_token3] = ACTIONS(3573),
    [aux_sym_preproc_else_token1] = ACTIONS(3573),
    [aux_sym_preproc_elif_token1] = ACTIONS(3573),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3319] = {
    [sym_preproc_region] = STATE(3319),
    [sym_preproc_endregion] = STATE(3319),
    [sym_preproc_line] = STATE(3319),
    [sym_preproc_pragma] = STATE(3319),
    [sym_preproc_nullable] = STATE(3319),
    [sym_preproc_error] = STATE(3319),
    [sym_preproc_define] = STATE(3319),
    [sym_preproc_undef] = STATE(3319),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4921),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4853),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3320] = {
    [sym_preproc_region] = STATE(3320),
    [sym_preproc_endregion] = STATE(3320),
    [sym_preproc_line] = STATE(3320),
    [sym_preproc_pragma] = STATE(3320),
    [sym_preproc_nullable] = STATE(3320),
    [sym_preproc_error] = STATE(3320),
    [sym_preproc_define] = STATE(3320),
    [sym_preproc_undef] = STATE(3320),
    [sym__identifier_token] = ACTIONS(3579),
    [anon_sym_extern] = ACTIONS(3579),
    [anon_sym_alias] = ACTIONS(3579),
    [anon_sym_global] = ACTIONS(3579),
    [anon_sym_using] = ACTIONS(3579),
    [anon_sym_unsafe] = ACTIONS(3579),
    [anon_sym_static] = ACTIONS(3579),
    [anon_sym_LBRACK] = ACTIONS(3581),
    [anon_sym_LPAREN] = ACTIONS(3581),
    [anon_sym_event] = ACTIONS(3579),
    [anon_sym_namespace] = ACTIONS(3579),
    [anon_sym_class] = ACTIONS(3579),
    [anon_sym_ref] = ACTIONS(3579),
    [anon_sym_struct] = ACTIONS(3579),
    [anon_sym_enum] = ACTIONS(3579),
    [anon_sym_RBRACE] = ACTIONS(3581),
    [anon_sym_interface] = ACTIONS(3579),
    [anon_sym_delegate] = ACTIONS(3579),
    [anon_sym_record] = ACTIONS(3579),
    [anon_sym_abstract] = ACTIONS(3579),
    [anon_sym_async] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3579),
    [anon_sym_file] = ACTIONS(3579),
    [anon_sym_fixed] = ACTIONS(3579),
    [anon_sym_internal] = ACTIONS(3579),
    [anon_sym_new] = ACTIONS(3579),
    [anon_sym_override] = ACTIONS(3579),
    [anon_sym_partial] = ACTIONS(3579),
    [anon_sym_private] = ACTIONS(3579),
    [anon_sym_protected] = ACTIONS(3579),
    [anon_sym_public] = ACTIONS(3579),
    [anon_sym_readonly] = ACTIONS(3579),
    [anon_sym_required] = ACTIONS(3579),
    [anon_sym_sealed] = ACTIONS(3579),
    [anon_sym_virtual] = ACTIONS(3579),
    [anon_sym_volatile] = ACTIONS(3579),
    [anon_sym_where] = ACTIONS(3579),
    [anon_sym_notnull] = ACTIONS(3579),
    [anon_sym_unmanaged] = ACTIONS(3579),
    [anon_sym_TILDE] = ACTIONS(3581),
    [anon_sym_implicit] = ACTIONS(3579),
    [anon_sym_explicit] = ACTIONS(3579),
    [anon_sym_scoped] = ACTIONS(3579),
    [anon_sym_var] = ACTIONS(3579),
    [sym_predefined_type] = ACTIONS(3579),
    [anon_sym_yield] = ACTIONS(3579),
    [anon_sym_when] = ACTIONS(3579),
    [anon_sym_from] = ACTIONS(3579),
    [anon_sym_into] = ACTIONS(3579),
    [anon_sym_join] = ACTIONS(3579),
    [anon_sym_on] = ACTIONS(3579),
    [anon_sym_equals] = ACTIONS(3579),
    [anon_sym_let] = ACTIONS(3579),
    [anon_sym_orderby] = ACTIONS(3579),
    [anon_sym_ascending] = ACTIONS(3579),
    [anon_sym_descending] = ACTIONS(3579),
    [anon_sym_group] = ACTIONS(3579),
    [anon_sym_by] = ACTIONS(3579),
    [anon_sym_select] = ACTIONS(3579),
    [aux_sym_preproc_if_token1] = ACTIONS(3581),
    [aux_sym_preproc_if_token3] = ACTIONS(3581),
    [aux_sym_preproc_else_token1] = ACTIONS(3581),
    [aux_sym_preproc_elif_token1] = ACTIONS(3581),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3321] = {
    [sym_preproc_region] = STATE(3321),
    [sym_preproc_endregion] = STATE(3321),
    [sym_preproc_line] = STATE(3321),
    [sym_preproc_pragma] = STATE(3321),
    [sym_preproc_nullable] = STATE(3321),
    [sym_preproc_error] = STATE(3321),
    [sym_preproc_define] = STATE(3321),
    [sym_preproc_undef] = STATE(3321),
    [sym__identifier_token] = ACTIONS(3583),
    [anon_sym_extern] = ACTIONS(3583),
    [anon_sym_alias] = ACTIONS(3583),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_using] = ACTIONS(3583),
    [anon_sym_unsafe] = ACTIONS(3583),
    [anon_sym_static] = ACTIONS(3583),
    [anon_sym_LBRACK] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(3585),
    [anon_sym_event] = ACTIONS(3583),
    [anon_sym_namespace] = ACTIONS(3583),
    [anon_sym_class] = ACTIONS(3583),
    [anon_sym_ref] = ACTIONS(3583),
    [anon_sym_struct] = ACTIONS(3583),
    [anon_sym_enum] = ACTIONS(3583),
    [anon_sym_RBRACE] = ACTIONS(3585),
    [anon_sym_interface] = ACTIONS(3583),
    [anon_sym_delegate] = ACTIONS(3583),
    [anon_sym_record] = ACTIONS(3583),
    [anon_sym_abstract] = ACTIONS(3583),
    [anon_sym_async] = ACTIONS(3583),
    [anon_sym_const] = ACTIONS(3583),
    [anon_sym_file] = ACTIONS(3583),
    [anon_sym_fixed] = ACTIONS(3583),
    [anon_sym_internal] = ACTIONS(3583),
    [anon_sym_new] = ACTIONS(3583),
    [anon_sym_override] = ACTIONS(3583),
    [anon_sym_partial] = ACTIONS(3583),
    [anon_sym_private] = ACTIONS(3583),
    [anon_sym_protected] = ACTIONS(3583),
    [anon_sym_public] = ACTIONS(3583),
    [anon_sym_readonly] = ACTIONS(3583),
    [anon_sym_required] = ACTIONS(3583),
    [anon_sym_sealed] = ACTIONS(3583),
    [anon_sym_virtual] = ACTIONS(3583),
    [anon_sym_volatile] = ACTIONS(3583),
    [anon_sym_where] = ACTIONS(3583),
    [anon_sym_notnull] = ACTIONS(3583),
    [anon_sym_unmanaged] = ACTIONS(3583),
    [anon_sym_TILDE] = ACTIONS(3585),
    [anon_sym_implicit] = ACTIONS(3583),
    [anon_sym_explicit] = ACTIONS(3583),
    [anon_sym_scoped] = ACTIONS(3583),
    [anon_sym_var] = ACTIONS(3583),
    [sym_predefined_type] = ACTIONS(3583),
    [anon_sym_yield] = ACTIONS(3583),
    [anon_sym_when] = ACTIONS(3583),
    [anon_sym_from] = ACTIONS(3583),
    [anon_sym_into] = ACTIONS(3583),
    [anon_sym_join] = ACTIONS(3583),
    [anon_sym_on] = ACTIONS(3583),
    [anon_sym_equals] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3583),
    [anon_sym_orderby] = ACTIONS(3583),
    [anon_sym_ascending] = ACTIONS(3583),
    [anon_sym_descending] = ACTIONS(3583),
    [anon_sym_group] = ACTIONS(3583),
    [anon_sym_by] = ACTIONS(3583),
    [anon_sym_select] = ACTIONS(3583),
    [aux_sym_preproc_if_token1] = ACTIONS(3585),
    [aux_sym_preproc_if_token3] = ACTIONS(3585),
    [aux_sym_preproc_else_token1] = ACTIONS(3585),
    [aux_sym_preproc_elif_token1] = ACTIONS(3585),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3322] = {
    [sym_preproc_region] = STATE(3322),
    [sym_preproc_endregion] = STATE(3322),
    [sym_preproc_line] = STATE(3322),
    [sym_preproc_pragma] = STATE(3322),
    [sym_preproc_nullable] = STATE(3322),
    [sym_preproc_error] = STATE(3322),
    [sym_preproc_define] = STATE(3322),
    [sym_preproc_undef] = STATE(3322),
    [sym__identifier_token] = ACTIONS(3595),
    [anon_sym_extern] = ACTIONS(3595),
    [anon_sym_alias] = ACTIONS(3595),
    [anon_sym_global] = ACTIONS(3595),
    [anon_sym_using] = ACTIONS(3595),
    [anon_sym_unsafe] = ACTIONS(3595),
    [anon_sym_static] = ACTIONS(3595),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [anon_sym_LPAREN] = ACTIONS(3597),
    [anon_sym_event] = ACTIONS(3595),
    [anon_sym_namespace] = ACTIONS(3595),
    [anon_sym_class] = ACTIONS(3595),
    [anon_sym_ref] = ACTIONS(3595),
    [anon_sym_struct] = ACTIONS(3595),
    [anon_sym_enum] = ACTIONS(3595),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3595),
    [anon_sym_delegate] = ACTIONS(3595),
    [anon_sym_record] = ACTIONS(3595),
    [anon_sym_abstract] = ACTIONS(3595),
    [anon_sym_async] = ACTIONS(3595),
    [anon_sym_const] = ACTIONS(3595),
    [anon_sym_file] = ACTIONS(3595),
    [anon_sym_fixed] = ACTIONS(3595),
    [anon_sym_internal] = ACTIONS(3595),
    [anon_sym_new] = ACTIONS(3595),
    [anon_sym_override] = ACTIONS(3595),
    [anon_sym_partial] = ACTIONS(3595),
    [anon_sym_private] = ACTIONS(3595),
    [anon_sym_protected] = ACTIONS(3595),
    [anon_sym_public] = ACTIONS(3595),
    [anon_sym_readonly] = ACTIONS(3595),
    [anon_sym_required] = ACTIONS(3595),
    [anon_sym_sealed] = ACTIONS(3595),
    [anon_sym_virtual] = ACTIONS(3595),
    [anon_sym_volatile] = ACTIONS(3595),
    [anon_sym_where] = ACTIONS(3595),
    [anon_sym_notnull] = ACTIONS(3595),
    [anon_sym_unmanaged] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3597),
    [anon_sym_implicit] = ACTIONS(3595),
    [anon_sym_explicit] = ACTIONS(3595),
    [anon_sym_scoped] = ACTIONS(3595),
    [anon_sym_var] = ACTIONS(3595),
    [sym_predefined_type] = ACTIONS(3595),
    [anon_sym_yield] = ACTIONS(3595),
    [anon_sym_when] = ACTIONS(3595),
    [anon_sym_from] = ACTIONS(3595),
    [anon_sym_into] = ACTIONS(3595),
    [anon_sym_join] = ACTIONS(3595),
    [anon_sym_on] = ACTIONS(3595),
    [anon_sym_equals] = ACTIONS(3595),
    [anon_sym_let] = ACTIONS(3595),
    [anon_sym_orderby] = ACTIONS(3595),
    [anon_sym_ascending] = ACTIONS(3595),
    [anon_sym_descending] = ACTIONS(3595),
    [anon_sym_group] = ACTIONS(3595),
    [anon_sym_by] = ACTIONS(3595),
    [anon_sym_select] = ACTIONS(3595),
    [aux_sym_preproc_if_token1] = ACTIONS(3597),
    [aux_sym_preproc_if_token3] = ACTIONS(3597),
    [aux_sym_preproc_else_token1] = ACTIONS(3597),
    [aux_sym_preproc_elif_token1] = ACTIONS(3597),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3323] = {
    [sym_preproc_region] = STATE(3323),
    [sym_preproc_endregion] = STATE(3323),
    [sym_preproc_line] = STATE(3323),
    [sym_preproc_pragma] = STATE(3323),
    [sym_preproc_nullable] = STATE(3323),
    [sym_preproc_error] = STATE(3323),
    [sym_preproc_define] = STATE(3323),
    [sym_preproc_undef] = STATE(3323),
    [sym__identifier_token] = ACTIONS(3599),
    [anon_sym_extern] = ACTIONS(3599),
    [anon_sym_alias] = ACTIONS(3599),
    [anon_sym_global] = ACTIONS(3599),
    [anon_sym_using] = ACTIONS(3599),
    [anon_sym_unsafe] = ACTIONS(3599),
    [anon_sym_static] = ACTIONS(3599),
    [anon_sym_LBRACK] = ACTIONS(3601),
    [anon_sym_LPAREN] = ACTIONS(3601),
    [anon_sym_event] = ACTIONS(3599),
    [anon_sym_namespace] = ACTIONS(3599),
    [anon_sym_class] = ACTIONS(3599),
    [anon_sym_ref] = ACTIONS(3599),
    [anon_sym_struct] = ACTIONS(3599),
    [anon_sym_enum] = ACTIONS(3599),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_interface] = ACTIONS(3599),
    [anon_sym_delegate] = ACTIONS(3599),
    [anon_sym_record] = ACTIONS(3599),
    [anon_sym_abstract] = ACTIONS(3599),
    [anon_sym_async] = ACTIONS(3599),
    [anon_sym_const] = ACTIONS(3599),
    [anon_sym_file] = ACTIONS(3599),
    [anon_sym_fixed] = ACTIONS(3599),
    [anon_sym_internal] = ACTIONS(3599),
    [anon_sym_new] = ACTIONS(3599),
    [anon_sym_override] = ACTIONS(3599),
    [anon_sym_partial] = ACTIONS(3599),
    [anon_sym_private] = ACTIONS(3599),
    [anon_sym_protected] = ACTIONS(3599),
    [anon_sym_public] = ACTIONS(3599),
    [anon_sym_readonly] = ACTIONS(3599),
    [anon_sym_required] = ACTIONS(3599),
    [anon_sym_sealed] = ACTIONS(3599),
    [anon_sym_virtual] = ACTIONS(3599),
    [anon_sym_volatile] = ACTIONS(3599),
    [anon_sym_where] = ACTIONS(3599),
    [anon_sym_notnull] = ACTIONS(3599),
    [anon_sym_unmanaged] = ACTIONS(3599),
    [anon_sym_TILDE] = ACTIONS(3601),
    [anon_sym_implicit] = ACTIONS(3599),
    [anon_sym_explicit] = ACTIONS(3599),
    [anon_sym_scoped] = ACTIONS(3599),
    [anon_sym_var] = ACTIONS(3599),
    [sym_predefined_type] = ACTIONS(3599),
    [anon_sym_yield] = ACTIONS(3599),
    [anon_sym_when] = ACTIONS(3599),
    [anon_sym_from] = ACTIONS(3599),
    [anon_sym_into] = ACTIONS(3599),
    [anon_sym_join] = ACTIONS(3599),
    [anon_sym_on] = ACTIONS(3599),
    [anon_sym_equals] = ACTIONS(3599),
    [anon_sym_let] = ACTIONS(3599),
    [anon_sym_orderby] = ACTIONS(3599),
    [anon_sym_ascending] = ACTIONS(3599),
    [anon_sym_descending] = ACTIONS(3599),
    [anon_sym_group] = ACTIONS(3599),
    [anon_sym_by] = ACTIONS(3599),
    [anon_sym_select] = ACTIONS(3599),
    [aux_sym_preproc_if_token1] = ACTIONS(3601),
    [aux_sym_preproc_if_token3] = ACTIONS(3601),
    [aux_sym_preproc_else_token1] = ACTIONS(3601),
    [aux_sym_preproc_elif_token1] = ACTIONS(3601),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3324] = {
    [sym__variable_designation] = STATE(4998),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3324),
    [sym_preproc_endregion] = STATE(3324),
    [sym_preproc_line] = STATE(3324),
    [sym_preproc_pragma] = STATE(3324),
    [sym_preproc_nullable] = STATE(3324),
    [sym_preproc_error] = STATE(3324),
    [sym_preproc_define] = STATE(3324),
    [sym_preproc_undef] = STATE(3324),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4435),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4435),
    [anon_sym_into] = ACTIONS(4435),
    [anon_sym_join] = ACTIONS(4435),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4435),
    [anon_sym_orderby] = ACTIONS(4435),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4435),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4435),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3325] = {
    [sym_preproc_region] = STATE(3325),
    [sym_preproc_endregion] = STATE(3325),
    [sym_preproc_line] = STATE(3325),
    [sym_preproc_pragma] = STATE(3325),
    [sym_preproc_nullable] = STATE(3325),
    [sym_preproc_error] = STATE(3325),
    [sym_preproc_define] = STATE(3325),
    [sym_preproc_undef] = STATE(3325),
    [sym__identifier_token] = ACTIONS(3711),
    [anon_sym_extern] = ACTIONS(3711),
    [anon_sym_alias] = ACTIONS(3711),
    [anon_sym_global] = ACTIONS(3711),
    [anon_sym_using] = ACTIONS(3711),
    [anon_sym_unsafe] = ACTIONS(3711),
    [anon_sym_static] = ACTIONS(3711),
    [anon_sym_LBRACK] = ACTIONS(3713),
    [anon_sym_LPAREN] = ACTIONS(3713),
    [anon_sym_event] = ACTIONS(3711),
    [anon_sym_namespace] = ACTIONS(3711),
    [anon_sym_class] = ACTIONS(3711),
    [anon_sym_ref] = ACTIONS(3711),
    [anon_sym_struct] = ACTIONS(3711),
    [anon_sym_enum] = ACTIONS(3711),
    [anon_sym_RBRACE] = ACTIONS(3713),
    [anon_sym_interface] = ACTIONS(3711),
    [anon_sym_delegate] = ACTIONS(3711),
    [anon_sym_record] = ACTIONS(3711),
    [anon_sym_abstract] = ACTIONS(3711),
    [anon_sym_async] = ACTIONS(3711),
    [anon_sym_const] = ACTIONS(3711),
    [anon_sym_file] = ACTIONS(3711),
    [anon_sym_fixed] = ACTIONS(3711),
    [anon_sym_internal] = ACTIONS(3711),
    [anon_sym_new] = ACTIONS(3711),
    [anon_sym_override] = ACTIONS(3711),
    [anon_sym_partial] = ACTIONS(3711),
    [anon_sym_private] = ACTIONS(3711),
    [anon_sym_protected] = ACTIONS(3711),
    [anon_sym_public] = ACTIONS(3711),
    [anon_sym_readonly] = ACTIONS(3711),
    [anon_sym_required] = ACTIONS(3711),
    [anon_sym_sealed] = ACTIONS(3711),
    [anon_sym_virtual] = ACTIONS(3711),
    [anon_sym_volatile] = ACTIONS(3711),
    [anon_sym_where] = ACTIONS(3711),
    [anon_sym_notnull] = ACTIONS(3711),
    [anon_sym_unmanaged] = ACTIONS(3711),
    [anon_sym_TILDE] = ACTIONS(3713),
    [anon_sym_implicit] = ACTIONS(3711),
    [anon_sym_explicit] = ACTIONS(3711),
    [anon_sym_scoped] = ACTIONS(3711),
    [anon_sym_var] = ACTIONS(3711),
    [sym_predefined_type] = ACTIONS(3711),
    [anon_sym_yield] = ACTIONS(3711),
    [anon_sym_when] = ACTIONS(3711),
    [anon_sym_from] = ACTIONS(3711),
    [anon_sym_into] = ACTIONS(3711),
    [anon_sym_join] = ACTIONS(3711),
    [anon_sym_on] = ACTIONS(3711),
    [anon_sym_equals] = ACTIONS(3711),
    [anon_sym_let] = ACTIONS(3711),
    [anon_sym_orderby] = ACTIONS(3711),
    [anon_sym_ascending] = ACTIONS(3711),
    [anon_sym_descending] = ACTIONS(3711),
    [anon_sym_group] = ACTIONS(3711),
    [anon_sym_by] = ACTIONS(3711),
    [anon_sym_select] = ACTIONS(3711),
    [aux_sym_preproc_if_token1] = ACTIONS(3713),
    [aux_sym_preproc_if_token3] = ACTIONS(3713),
    [aux_sym_preproc_else_token1] = ACTIONS(3713),
    [aux_sym_preproc_elif_token1] = ACTIONS(3713),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3326] = {
    [sym__variable_designation] = STATE(4989),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3326),
    [sym_preproc_endregion] = STATE(3326),
    [sym_preproc_line] = STATE(3326),
    [sym_preproc_pragma] = STATE(3326),
    [sym_preproc_nullable] = STATE(3326),
    [sym_preproc_error] = STATE(3326),
    [sym_preproc_define] = STATE(3326),
    [sym_preproc_undef] = STATE(3326),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4445),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4445),
    [anon_sym_into] = ACTIONS(4445),
    [anon_sym_join] = ACTIONS(4445),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4445),
    [anon_sym_orderby] = ACTIONS(4445),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4445),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4445),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3327] = {
    [sym_preproc_region] = STATE(3327),
    [sym_preproc_endregion] = STATE(3327),
    [sym_preproc_line] = STATE(3327),
    [sym_preproc_pragma] = STATE(3327),
    [sym_preproc_nullable] = STATE(3327),
    [sym_preproc_error] = STATE(3327),
    [sym_preproc_define] = STATE(3327),
    [sym_preproc_undef] = STATE(3327),
    [sym__identifier_token] = ACTIONS(4923),
    [anon_sym_extern] = ACTIONS(4923),
    [anon_sym_alias] = ACTIONS(4923),
    [anon_sym_global] = ACTIONS(4923),
    [anon_sym_using] = ACTIONS(4923),
    [anon_sym_unsafe] = ACTIONS(4923),
    [anon_sym_static] = ACTIONS(4923),
    [anon_sym_LBRACK] = ACTIONS(4925),
    [anon_sym_LPAREN] = ACTIONS(4925),
    [anon_sym_event] = ACTIONS(4923),
    [anon_sym_namespace] = ACTIONS(4923),
    [anon_sym_class] = ACTIONS(4923),
    [anon_sym_ref] = ACTIONS(4923),
    [anon_sym_struct] = ACTIONS(4923),
    [anon_sym_enum] = ACTIONS(4923),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [anon_sym_interface] = ACTIONS(4923),
    [anon_sym_delegate] = ACTIONS(4923),
    [anon_sym_record] = ACTIONS(4923),
    [anon_sym_abstract] = ACTIONS(4923),
    [anon_sym_async] = ACTIONS(4923),
    [anon_sym_const] = ACTIONS(4923),
    [anon_sym_file] = ACTIONS(4923),
    [anon_sym_fixed] = ACTIONS(4923),
    [anon_sym_internal] = ACTIONS(4923),
    [anon_sym_new] = ACTIONS(4923),
    [anon_sym_override] = ACTIONS(4923),
    [anon_sym_partial] = ACTIONS(4923),
    [anon_sym_private] = ACTIONS(4923),
    [anon_sym_protected] = ACTIONS(4923),
    [anon_sym_public] = ACTIONS(4923),
    [anon_sym_readonly] = ACTIONS(4923),
    [anon_sym_required] = ACTIONS(4923),
    [anon_sym_sealed] = ACTIONS(4923),
    [anon_sym_virtual] = ACTIONS(4923),
    [anon_sym_volatile] = ACTIONS(4923),
    [anon_sym_where] = ACTIONS(4923),
    [anon_sym_notnull] = ACTIONS(4923),
    [anon_sym_unmanaged] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4925),
    [anon_sym_implicit] = ACTIONS(4923),
    [anon_sym_explicit] = ACTIONS(4923),
    [anon_sym_scoped] = ACTIONS(4923),
    [anon_sym_var] = ACTIONS(4923),
    [sym_predefined_type] = ACTIONS(4923),
    [anon_sym_yield] = ACTIONS(4923),
    [anon_sym_when] = ACTIONS(4923),
    [anon_sym_from] = ACTIONS(4923),
    [anon_sym_into] = ACTIONS(4923),
    [anon_sym_join] = ACTIONS(4923),
    [anon_sym_on] = ACTIONS(4923),
    [anon_sym_equals] = ACTIONS(4923),
    [anon_sym_let] = ACTIONS(4923),
    [anon_sym_orderby] = ACTIONS(4923),
    [anon_sym_ascending] = ACTIONS(4923),
    [anon_sym_descending] = ACTIONS(4923),
    [anon_sym_group] = ACTIONS(4923),
    [anon_sym_by] = ACTIONS(4923),
    [anon_sym_select] = ACTIONS(4923),
    [aux_sym_preproc_if_token1] = ACTIONS(4925),
    [aux_sym_preproc_if_token3] = ACTIONS(4925),
    [aux_sym_preproc_else_token1] = ACTIONS(4925),
    [aux_sym_preproc_elif_token1] = ACTIONS(4925),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3328] = {
    [sym__variable_designation] = STATE(4984),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3328),
    [sym_preproc_endregion] = STATE(3328),
    [sym_preproc_line] = STATE(3328),
    [sym_preproc_pragma] = STATE(3328),
    [sym_preproc_nullable] = STATE(3328),
    [sym_preproc_error] = STATE(3328),
    [sym_preproc_define] = STATE(3328),
    [sym_preproc_undef] = STATE(3328),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4405),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4405),
    [anon_sym_into] = ACTIONS(4405),
    [anon_sym_join] = ACTIONS(4405),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4405),
    [anon_sym_orderby] = ACTIONS(4405),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4405),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4405),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3329] = {
    [sym_preproc_region] = STATE(3329),
    [sym_preproc_endregion] = STATE(3329),
    [sym_preproc_line] = STATE(3329),
    [sym_preproc_pragma] = STATE(3329),
    [sym_preproc_nullable] = STATE(3329),
    [sym_preproc_error] = STATE(3329),
    [sym_preproc_define] = STATE(3329),
    [sym_preproc_undef] = STATE(3329),
    [sym__identifier_token] = ACTIONS(4927),
    [anon_sym_extern] = ACTIONS(4927),
    [anon_sym_alias] = ACTIONS(4927),
    [anon_sym_global] = ACTIONS(4927),
    [anon_sym_using] = ACTIONS(4927),
    [anon_sym_unsafe] = ACTIONS(4927),
    [anon_sym_static] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4929),
    [anon_sym_LPAREN] = ACTIONS(4929),
    [anon_sym_event] = ACTIONS(4927),
    [anon_sym_namespace] = ACTIONS(4927),
    [anon_sym_class] = ACTIONS(4927),
    [anon_sym_ref] = ACTIONS(4927),
    [anon_sym_struct] = ACTIONS(4927),
    [anon_sym_enum] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4929),
    [anon_sym_interface] = ACTIONS(4927),
    [anon_sym_delegate] = ACTIONS(4927),
    [anon_sym_record] = ACTIONS(4927),
    [anon_sym_abstract] = ACTIONS(4927),
    [anon_sym_async] = ACTIONS(4927),
    [anon_sym_const] = ACTIONS(4927),
    [anon_sym_file] = ACTIONS(4927),
    [anon_sym_fixed] = ACTIONS(4927),
    [anon_sym_internal] = ACTIONS(4927),
    [anon_sym_new] = ACTIONS(4927),
    [anon_sym_override] = ACTIONS(4927),
    [anon_sym_partial] = ACTIONS(4927),
    [anon_sym_private] = ACTIONS(4927),
    [anon_sym_protected] = ACTIONS(4927),
    [anon_sym_public] = ACTIONS(4927),
    [anon_sym_readonly] = ACTIONS(4927),
    [anon_sym_required] = ACTIONS(4927),
    [anon_sym_sealed] = ACTIONS(4927),
    [anon_sym_virtual] = ACTIONS(4927),
    [anon_sym_volatile] = ACTIONS(4927),
    [anon_sym_where] = ACTIONS(4927),
    [anon_sym_notnull] = ACTIONS(4927),
    [anon_sym_unmanaged] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4929),
    [anon_sym_implicit] = ACTIONS(4927),
    [anon_sym_explicit] = ACTIONS(4927),
    [anon_sym_scoped] = ACTIONS(4927),
    [anon_sym_var] = ACTIONS(4927),
    [sym_predefined_type] = ACTIONS(4927),
    [anon_sym_yield] = ACTIONS(4927),
    [anon_sym_when] = ACTIONS(4927),
    [anon_sym_from] = ACTIONS(4927),
    [anon_sym_into] = ACTIONS(4927),
    [anon_sym_join] = ACTIONS(4927),
    [anon_sym_on] = ACTIONS(4927),
    [anon_sym_equals] = ACTIONS(4927),
    [anon_sym_let] = ACTIONS(4927),
    [anon_sym_orderby] = ACTIONS(4927),
    [anon_sym_ascending] = ACTIONS(4927),
    [anon_sym_descending] = ACTIONS(4927),
    [anon_sym_group] = ACTIONS(4927),
    [anon_sym_by] = ACTIONS(4927),
    [anon_sym_select] = ACTIONS(4927),
    [aux_sym_preproc_if_token1] = ACTIONS(4929),
    [aux_sym_preproc_if_token3] = ACTIONS(4929),
    [aux_sym_preproc_else_token1] = ACTIONS(4929),
    [aux_sym_preproc_elif_token1] = ACTIONS(4929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3330] = {
    [sym_preproc_region] = STATE(3330),
    [sym_preproc_endregion] = STATE(3330),
    [sym_preproc_line] = STATE(3330),
    [sym_preproc_pragma] = STATE(3330),
    [sym_preproc_nullable] = STATE(3330),
    [sym_preproc_error] = STATE(3330),
    [sym_preproc_define] = STATE(3330),
    [sym_preproc_undef] = STATE(3330),
    [sym__identifier_token] = ACTIONS(3411),
    [anon_sym_extern] = ACTIONS(3411),
    [anon_sym_alias] = ACTIONS(3411),
    [anon_sym_global] = ACTIONS(3411),
    [anon_sym_using] = ACTIONS(3411),
    [anon_sym_unsafe] = ACTIONS(3411),
    [anon_sym_static] = ACTIONS(3411),
    [anon_sym_LBRACK] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(3413),
    [anon_sym_event] = ACTIONS(3411),
    [anon_sym_namespace] = ACTIONS(3411),
    [anon_sym_class] = ACTIONS(3411),
    [anon_sym_ref] = ACTIONS(3411),
    [anon_sym_struct] = ACTIONS(3411),
    [anon_sym_enum] = ACTIONS(3411),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_interface] = ACTIONS(3411),
    [anon_sym_delegate] = ACTIONS(3411),
    [anon_sym_record] = ACTIONS(3411),
    [anon_sym_abstract] = ACTIONS(3411),
    [anon_sym_async] = ACTIONS(3411),
    [anon_sym_const] = ACTIONS(3411),
    [anon_sym_file] = ACTIONS(3411),
    [anon_sym_fixed] = ACTIONS(3411),
    [anon_sym_internal] = ACTIONS(3411),
    [anon_sym_new] = ACTIONS(3411),
    [anon_sym_override] = ACTIONS(3411),
    [anon_sym_partial] = ACTIONS(3411),
    [anon_sym_private] = ACTIONS(3411),
    [anon_sym_protected] = ACTIONS(3411),
    [anon_sym_public] = ACTIONS(3411),
    [anon_sym_readonly] = ACTIONS(3411),
    [anon_sym_required] = ACTIONS(3411),
    [anon_sym_sealed] = ACTIONS(3411),
    [anon_sym_virtual] = ACTIONS(3411),
    [anon_sym_volatile] = ACTIONS(3411),
    [anon_sym_where] = ACTIONS(3411),
    [anon_sym_notnull] = ACTIONS(3411),
    [anon_sym_unmanaged] = ACTIONS(3411),
    [anon_sym_TILDE] = ACTIONS(3413),
    [anon_sym_implicit] = ACTIONS(3411),
    [anon_sym_explicit] = ACTIONS(3411),
    [anon_sym_scoped] = ACTIONS(3411),
    [anon_sym_var] = ACTIONS(3411),
    [sym_predefined_type] = ACTIONS(3411),
    [anon_sym_yield] = ACTIONS(3411),
    [anon_sym_when] = ACTIONS(3411),
    [anon_sym_from] = ACTIONS(3411),
    [anon_sym_into] = ACTIONS(3411),
    [anon_sym_join] = ACTIONS(3411),
    [anon_sym_on] = ACTIONS(3411),
    [anon_sym_equals] = ACTIONS(3411),
    [anon_sym_let] = ACTIONS(3411),
    [anon_sym_orderby] = ACTIONS(3411),
    [anon_sym_ascending] = ACTIONS(3411),
    [anon_sym_descending] = ACTIONS(3411),
    [anon_sym_group] = ACTIONS(3411),
    [anon_sym_by] = ACTIONS(3411),
    [anon_sym_select] = ACTIONS(3411),
    [aux_sym_preproc_if_token1] = ACTIONS(3413),
    [aux_sym_preproc_if_token3] = ACTIONS(3413),
    [aux_sym_preproc_else_token1] = ACTIONS(3413),
    [aux_sym_preproc_elif_token1] = ACTIONS(3413),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3331] = {
    [sym_preproc_region] = STATE(3331),
    [sym_preproc_endregion] = STATE(3331),
    [sym_preproc_line] = STATE(3331),
    [sym_preproc_pragma] = STATE(3331),
    [sym_preproc_nullable] = STATE(3331),
    [sym_preproc_error] = STATE(3331),
    [sym_preproc_define] = STATE(3331),
    [sym_preproc_undef] = STATE(3331),
    [sym__identifier_token] = ACTIONS(3739),
    [anon_sym_extern] = ACTIONS(3739),
    [anon_sym_alias] = ACTIONS(3739),
    [anon_sym_global] = ACTIONS(3739),
    [anon_sym_using] = ACTIONS(3739),
    [anon_sym_unsafe] = ACTIONS(3739),
    [anon_sym_static] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_event] = ACTIONS(3739),
    [anon_sym_namespace] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_ref] = ACTIONS(3739),
    [anon_sym_struct] = ACTIONS(3739),
    [anon_sym_enum] = ACTIONS(3739),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_interface] = ACTIONS(3739),
    [anon_sym_delegate] = ACTIONS(3739),
    [anon_sym_record] = ACTIONS(3739),
    [anon_sym_abstract] = ACTIONS(3739),
    [anon_sym_async] = ACTIONS(3739),
    [anon_sym_const] = ACTIONS(3739),
    [anon_sym_file] = ACTIONS(3739),
    [anon_sym_fixed] = ACTIONS(3739),
    [anon_sym_internal] = ACTIONS(3739),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_override] = ACTIONS(3739),
    [anon_sym_partial] = ACTIONS(3739),
    [anon_sym_private] = ACTIONS(3739),
    [anon_sym_protected] = ACTIONS(3739),
    [anon_sym_public] = ACTIONS(3739),
    [anon_sym_readonly] = ACTIONS(3739),
    [anon_sym_required] = ACTIONS(3739),
    [anon_sym_sealed] = ACTIONS(3739),
    [anon_sym_virtual] = ACTIONS(3739),
    [anon_sym_volatile] = ACTIONS(3739),
    [anon_sym_where] = ACTIONS(3739),
    [anon_sym_notnull] = ACTIONS(3739),
    [anon_sym_unmanaged] = ACTIONS(3739),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_implicit] = ACTIONS(3739),
    [anon_sym_explicit] = ACTIONS(3739),
    [anon_sym_scoped] = ACTIONS(3739),
    [anon_sym_var] = ACTIONS(3739),
    [sym_predefined_type] = ACTIONS(3739),
    [anon_sym_yield] = ACTIONS(3739),
    [anon_sym_when] = ACTIONS(3739),
    [anon_sym_from] = ACTIONS(3739),
    [anon_sym_into] = ACTIONS(3739),
    [anon_sym_join] = ACTIONS(3739),
    [anon_sym_on] = ACTIONS(3739),
    [anon_sym_equals] = ACTIONS(3739),
    [anon_sym_let] = ACTIONS(3739),
    [anon_sym_orderby] = ACTIONS(3739),
    [anon_sym_ascending] = ACTIONS(3739),
    [anon_sym_descending] = ACTIONS(3739),
    [anon_sym_group] = ACTIONS(3739),
    [anon_sym_by] = ACTIONS(3739),
    [anon_sym_select] = ACTIONS(3739),
    [aux_sym_preproc_if_token1] = ACTIONS(3741),
    [aux_sym_preproc_if_token3] = ACTIONS(3741),
    [aux_sym_preproc_else_token1] = ACTIONS(3741),
    [aux_sym_preproc_elif_token1] = ACTIONS(3741),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3332] = {
    [sym_preproc_region] = STATE(3332),
    [sym_preproc_endregion] = STATE(3332),
    [sym_preproc_line] = STATE(3332),
    [sym_preproc_pragma] = STATE(3332),
    [sym_preproc_nullable] = STATE(3332),
    [sym_preproc_error] = STATE(3332),
    [sym_preproc_define] = STATE(3332),
    [sym_preproc_undef] = STATE(3332),
    [sym__identifier_token] = ACTIONS(3683),
    [anon_sym_extern] = ACTIONS(3683),
    [anon_sym_alias] = ACTIONS(3683),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_using] = ACTIONS(3683),
    [anon_sym_unsafe] = ACTIONS(3683),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_LBRACK] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_event] = ACTIONS(3683),
    [anon_sym_namespace] = ACTIONS(3683),
    [anon_sym_class] = ACTIONS(3683),
    [anon_sym_ref] = ACTIONS(3683),
    [anon_sym_struct] = ACTIONS(3683),
    [anon_sym_enum] = ACTIONS(3683),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_interface] = ACTIONS(3683),
    [anon_sym_delegate] = ACTIONS(3683),
    [anon_sym_record] = ACTIONS(3683),
    [anon_sym_abstract] = ACTIONS(3683),
    [anon_sym_async] = ACTIONS(3683),
    [anon_sym_const] = ACTIONS(3683),
    [anon_sym_file] = ACTIONS(3683),
    [anon_sym_fixed] = ACTIONS(3683),
    [anon_sym_internal] = ACTIONS(3683),
    [anon_sym_new] = ACTIONS(3683),
    [anon_sym_override] = ACTIONS(3683),
    [anon_sym_partial] = ACTIONS(3683),
    [anon_sym_private] = ACTIONS(3683),
    [anon_sym_protected] = ACTIONS(3683),
    [anon_sym_public] = ACTIONS(3683),
    [anon_sym_readonly] = ACTIONS(3683),
    [anon_sym_required] = ACTIONS(3683),
    [anon_sym_sealed] = ACTIONS(3683),
    [anon_sym_virtual] = ACTIONS(3683),
    [anon_sym_volatile] = ACTIONS(3683),
    [anon_sym_where] = ACTIONS(3683),
    [anon_sym_notnull] = ACTIONS(3683),
    [anon_sym_unmanaged] = ACTIONS(3683),
    [anon_sym_TILDE] = ACTIONS(3685),
    [anon_sym_implicit] = ACTIONS(3683),
    [anon_sym_explicit] = ACTIONS(3683),
    [anon_sym_scoped] = ACTIONS(3683),
    [anon_sym_var] = ACTIONS(3683),
    [sym_predefined_type] = ACTIONS(3683),
    [anon_sym_yield] = ACTIONS(3683),
    [anon_sym_when] = ACTIONS(3683),
    [anon_sym_from] = ACTIONS(3683),
    [anon_sym_into] = ACTIONS(3683),
    [anon_sym_join] = ACTIONS(3683),
    [anon_sym_on] = ACTIONS(3683),
    [anon_sym_equals] = ACTIONS(3683),
    [anon_sym_let] = ACTIONS(3683),
    [anon_sym_orderby] = ACTIONS(3683),
    [anon_sym_ascending] = ACTIONS(3683),
    [anon_sym_descending] = ACTIONS(3683),
    [anon_sym_group] = ACTIONS(3683),
    [anon_sym_by] = ACTIONS(3683),
    [anon_sym_select] = ACTIONS(3683),
    [aux_sym_preproc_if_token1] = ACTIONS(3685),
    [aux_sym_preproc_if_token3] = ACTIONS(3685),
    [aux_sym_preproc_else_token1] = ACTIONS(3685),
    [aux_sym_preproc_elif_token1] = ACTIONS(3685),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3333] = {
    [sym_preproc_region] = STATE(3333),
    [sym_preproc_endregion] = STATE(3333),
    [sym_preproc_line] = STATE(3333),
    [sym_preproc_pragma] = STATE(3333),
    [sym_preproc_nullable] = STATE(3333),
    [sym_preproc_error] = STATE(3333),
    [sym_preproc_define] = STATE(3333),
    [sym_preproc_undef] = STATE(3333),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_in] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_EQ_GT] = ACTIONS(4171),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_when] = ACTIONS(4171),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4171),
    [anon_sym_or] = ACTIONS(4171),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_on] = ACTIONS(4171),
    [anon_sym_equals] = ACTIONS(4171),
    [anon_sym_by] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_is] = ACTIONS(4171),
    [anon_sym_DASH_GT] = ACTIONS(4171),
    [anon_sym_with] = ACTIONS(4171),
    [aux_sym_preproc_if_token3] = ACTIONS(4171),
    [aux_sym_preproc_else_token1] = ACTIONS(4171),
    [aux_sym_preproc_elif_token1] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3334] = {
    [sym_preproc_region] = STATE(3334),
    [sym_preproc_endregion] = STATE(3334),
    [sym_preproc_line] = STATE(3334),
    [sym_preproc_pragma] = STATE(3334),
    [sym_preproc_nullable] = STATE(3334),
    [sym_preproc_error] = STATE(3334),
    [sym_preproc_define] = STATE(3334),
    [sym_preproc_undef] = STATE(3334),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_event] = ACTIONS(4040),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_operator] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_implicit] = ACTIONS(4040),
    [anon_sym_explicit] = ACTIONS(4040),
    [anon_sym_this] = ACTIONS(3993),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3335] = {
    [sym__variable_designation] = STATE(5013),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(3335),
    [sym_preproc_endregion] = STATE(3335),
    [sym_preproc_line] = STATE(3335),
    [sym_preproc_pragma] = STATE(3335),
    [sym_preproc_nullable] = STATE(3335),
    [sym_preproc_error] = STATE(3335),
    [sym_preproc_define] = STATE(3335),
    [sym_preproc_undef] = STATE(3335),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4288),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4397),
    [anon_sym_into] = ACTIONS(4397),
    [anon_sym_join] = ACTIONS(4397),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4397),
    [anon_sym_orderby] = ACTIONS(4397),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4397),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4397),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3336] = {
    [sym_preproc_region] = STATE(3336),
    [sym_preproc_endregion] = STATE(3336),
    [sym_preproc_line] = STATE(3336),
    [sym_preproc_pragma] = STATE(3336),
    [sym_preproc_nullable] = STATE(3336),
    [sym_preproc_error] = STATE(3336),
    [sym_preproc_define] = STATE(3336),
    [sym_preproc_undef] = STATE(3336),
    [sym__identifier_token] = ACTIONS(3419),
    [anon_sym_extern] = ACTIONS(3419),
    [anon_sym_alias] = ACTIONS(3419),
    [anon_sym_global] = ACTIONS(3419),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_unsafe] = ACTIONS(3419),
    [anon_sym_static] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3421),
    [anon_sym_LPAREN] = ACTIONS(3421),
    [anon_sym_event] = ACTIONS(3419),
    [anon_sym_namespace] = ACTIONS(3419),
    [anon_sym_class] = ACTIONS(3419),
    [anon_sym_ref] = ACTIONS(3419),
    [anon_sym_struct] = ACTIONS(3419),
    [anon_sym_enum] = ACTIONS(3419),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_interface] = ACTIONS(3419),
    [anon_sym_delegate] = ACTIONS(3419),
    [anon_sym_record] = ACTIONS(3419),
    [anon_sym_abstract] = ACTIONS(3419),
    [anon_sym_async] = ACTIONS(3419),
    [anon_sym_const] = ACTIONS(3419),
    [anon_sym_file] = ACTIONS(3419),
    [anon_sym_fixed] = ACTIONS(3419),
    [anon_sym_internal] = ACTIONS(3419),
    [anon_sym_new] = ACTIONS(3419),
    [anon_sym_override] = ACTIONS(3419),
    [anon_sym_partial] = ACTIONS(3419),
    [anon_sym_private] = ACTIONS(3419),
    [anon_sym_protected] = ACTIONS(3419),
    [anon_sym_public] = ACTIONS(3419),
    [anon_sym_readonly] = ACTIONS(3419),
    [anon_sym_required] = ACTIONS(3419),
    [anon_sym_sealed] = ACTIONS(3419),
    [anon_sym_virtual] = ACTIONS(3419),
    [anon_sym_volatile] = ACTIONS(3419),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_notnull] = ACTIONS(3419),
    [anon_sym_unmanaged] = ACTIONS(3419),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_implicit] = ACTIONS(3419),
    [anon_sym_explicit] = ACTIONS(3419),
    [anon_sym_scoped] = ACTIONS(3419),
    [anon_sym_var] = ACTIONS(3419),
    [sym_predefined_type] = ACTIONS(3419),
    [anon_sym_yield] = ACTIONS(3419),
    [anon_sym_when] = ACTIONS(3419),
    [anon_sym_from] = ACTIONS(3419),
    [anon_sym_into] = ACTIONS(3419),
    [anon_sym_join] = ACTIONS(3419),
    [anon_sym_on] = ACTIONS(3419),
    [anon_sym_equals] = ACTIONS(3419),
    [anon_sym_let] = ACTIONS(3419),
    [anon_sym_orderby] = ACTIONS(3419),
    [anon_sym_ascending] = ACTIONS(3419),
    [anon_sym_descending] = ACTIONS(3419),
    [anon_sym_group] = ACTIONS(3419),
    [anon_sym_by] = ACTIONS(3419),
    [anon_sym_select] = ACTIONS(3419),
    [aux_sym_preproc_if_token1] = ACTIONS(3421),
    [aux_sym_preproc_if_token3] = ACTIONS(3421),
    [aux_sym_preproc_else_token1] = ACTIONS(3421),
    [aux_sym_preproc_elif_token1] = ACTIONS(3421),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3337] = {
    [sym_preproc_region] = STATE(3337),
    [sym_preproc_endregion] = STATE(3337),
    [sym_preproc_line] = STATE(3337),
    [sym_preproc_pragma] = STATE(3337),
    [sym_preproc_nullable] = STATE(3337),
    [sym_preproc_error] = STATE(3337),
    [sym_preproc_define] = STATE(3337),
    [sym_preproc_undef] = STATE(3337),
    [sym__identifier_token] = ACTIONS(3423),
    [anon_sym_extern] = ACTIONS(3423),
    [anon_sym_alias] = ACTIONS(3423),
    [anon_sym_global] = ACTIONS(3423),
    [anon_sym_using] = ACTIONS(3423),
    [anon_sym_unsafe] = ACTIONS(3423),
    [anon_sym_static] = ACTIONS(3423),
    [anon_sym_LBRACK] = ACTIONS(3425),
    [anon_sym_LPAREN] = ACTIONS(3425),
    [anon_sym_event] = ACTIONS(3423),
    [anon_sym_namespace] = ACTIONS(3423),
    [anon_sym_class] = ACTIONS(3423),
    [anon_sym_ref] = ACTIONS(3423),
    [anon_sym_struct] = ACTIONS(3423),
    [anon_sym_enum] = ACTIONS(3423),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_interface] = ACTIONS(3423),
    [anon_sym_delegate] = ACTIONS(3423),
    [anon_sym_record] = ACTIONS(3423),
    [anon_sym_abstract] = ACTIONS(3423),
    [anon_sym_async] = ACTIONS(3423),
    [anon_sym_const] = ACTIONS(3423),
    [anon_sym_file] = ACTIONS(3423),
    [anon_sym_fixed] = ACTIONS(3423),
    [anon_sym_internal] = ACTIONS(3423),
    [anon_sym_new] = ACTIONS(3423),
    [anon_sym_override] = ACTIONS(3423),
    [anon_sym_partial] = ACTIONS(3423),
    [anon_sym_private] = ACTIONS(3423),
    [anon_sym_protected] = ACTIONS(3423),
    [anon_sym_public] = ACTIONS(3423),
    [anon_sym_readonly] = ACTIONS(3423),
    [anon_sym_required] = ACTIONS(3423),
    [anon_sym_sealed] = ACTIONS(3423),
    [anon_sym_virtual] = ACTIONS(3423),
    [anon_sym_volatile] = ACTIONS(3423),
    [anon_sym_where] = ACTIONS(3423),
    [anon_sym_notnull] = ACTIONS(3423),
    [anon_sym_unmanaged] = ACTIONS(3423),
    [anon_sym_TILDE] = ACTIONS(3425),
    [anon_sym_implicit] = ACTIONS(3423),
    [anon_sym_explicit] = ACTIONS(3423),
    [anon_sym_scoped] = ACTIONS(3423),
    [anon_sym_var] = ACTIONS(3423),
    [sym_predefined_type] = ACTIONS(3423),
    [anon_sym_yield] = ACTIONS(3423),
    [anon_sym_when] = ACTIONS(3423),
    [anon_sym_from] = ACTIONS(3423),
    [anon_sym_into] = ACTIONS(3423),
    [anon_sym_join] = ACTIONS(3423),
    [anon_sym_on] = ACTIONS(3423),
    [anon_sym_equals] = ACTIONS(3423),
    [anon_sym_let] = ACTIONS(3423),
    [anon_sym_orderby] = ACTIONS(3423),
    [anon_sym_ascending] = ACTIONS(3423),
    [anon_sym_descending] = ACTIONS(3423),
    [anon_sym_group] = ACTIONS(3423),
    [anon_sym_by] = ACTIONS(3423),
    [anon_sym_select] = ACTIONS(3423),
    [aux_sym_preproc_if_token1] = ACTIONS(3425),
    [aux_sym_preproc_if_token3] = ACTIONS(3425),
    [aux_sym_preproc_else_token1] = ACTIONS(3425),
    [aux_sym_preproc_elif_token1] = ACTIONS(3425),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3338] = {
    [sym_preproc_region] = STATE(3338),
    [sym_preproc_endregion] = STATE(3338),
    [sym_preproc_line] = STATE(3338),
    [sym_preproc_pragma] = STATE(3338),
    [sym_preproc_nullable] = STATE(3338),
    [sym_preproc_error] = STATE(3338),
    [sym_preproc_define] = STATE(3338),
    [sym_preproc_undef] = STATE(3338),
    [sym__identifier_token] = ACTIONS(3427),
    [anon_sym_extern] = ACTIONS(3427),
    [anon_sym_alias] = ACTIONS(3427),
    [anon_sym_global] = ACTIONS(3427),
    [anon_sym_using] = ACTIONS(3427),
    [anon_sym_unsafe] = ACTIONS(3427),
    [anon_sym_static] = ACTIONS(3427),
    [anon_sym_LBRACK] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3429),
    [anon_sym_event] = ACTIONS(3427),
    [anon_sym_namespace] = ACTIONS(3427),
    [anon_sym_class] = ACTIONS(3427),
    [anon_sym_ref] = ACTIONS(3427),
    [anon_sym_struct] = ACTIONS(3427),
    [anon_sym_enum] = ACTIONS(3427),
    [anon_sym_RBRACE] = ACTIONS(3429),
    [anon_sym_interface] = ACTIONS(3427),
    [anon_sym_delegate] = ACTIONS(3427),
    [anon_sym_record] = ACTIONS(3427),
    [anon_sym_abstract] = ACTIONS(3427),
    [anon_sym_async] = ACTIONS(3427),
    [anon_sym_const] = ACTIONS(3427),
    [anon_sym_file] = ACTIONS(3427),
    [anon_sym_fixed] = ACTIONS(3427),
    [anon_sym_internal] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(3427),
    [anon_sym_override] = ACTIONS(3427),
    [anon_sym_partial] = ACTIONS(3427),
    [anon_sym_private] = ACTIONS(3427),
    [anon_sym_protected] = ACTIONS(3427),
    [anon_sym_public] = ACTIONS(3427),
    [anon_sym_readonly] = ACTIONS(3427),
    [anon_sym_required] = ACTIONS(3427),
    [anon_sym_sealed] = ACTIONS(3427),
    [anon_sym_virtual] = ACTIONS(3427),
    [anon_sym_volatile] = ACTIONS(3427),
    [anon_sym_where] = ACTIONS(3427),
    [anon_sym_notnull] = ACTIONS(3427),
    [anon_sym_unmanaged] = ACTIONS(3427),
    [anon_sym_TILDE] = ACTIONS(3429),
    [anon_sym_implicit] = ACTIONS(3427),
    [anon_sym_explicit] = ACTIONS(3427),
    [anon_sym_scoped] = ACTIONS(3427),
    [anon_sym_var] = ACTIONS(3427),
    [sym_predefined_type] = ACTIONS(3427),
    [anon_sym_yield] = ACTIONS(3427),
    [anon_sym_when] = ACTIONS(3427),
    [anon_sym_from] = ACTIONS(3427),
    [anon_sym_into] = ACTIONS(3427),
    [anon_sym_join] = ACTIONS(3427),
    [anon_sym_on] = ACTIONS(3427),
    [anon_sym_equals] = ACTIONS(3427),
    [anon_sym_let] = ACTIONS(3427),
    [anon_sym_orderby] = ACTIONS(3427),
    [anon_sym_ascending] = ACTIONS(3427),
    [anon_sym_descending] = ACTIONS(3427),
    [anon_sym_group] = ACTIONS(3427),
    [anon_sym_by] = ACTIONS(3427),
    [anon_sym_select] = ACTIONS(3427),
    [aux_sym_preproc_if_token1] = ACTIONS(3429),
    [aux_sym_preproc_if_token3] = ACTIONS(3429),
    [aux_sym_preproc_else_token1] = ACTIONS(3429),
    [aux_sym_preproc_elif_token1] = ACTIONS(3429),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3339] = {
    [sym_preproc_region] = STATE(3339),
    [sym_preproc_endregion] = STATE(3339),
    [sym_preproc_line] = STATE(3339),
    [sym_preproc_pragma] = STATE(3339),
    [sym_preproc_nullable] = STATE(3339),
    [sym_preproc_error] = STATE(3339),
    [sym_preproc_define] = STATE(3339),
    [sym_preproc_undef] = STATE(3339),
    [sym__identifier_token] = ACTIONS(4931),
    [anon_sym_extern] = ACTIONS(4931),
    [anon_sym_alias] = ACTIONS(4931),
    [anon_sym_global] = ACTIONS(4931),
    [anon_sym_using] = ACTIONS(4931),
    [anon_sym_unsafe] = ACTIONS(4931),
    [anon_sym_static] = ACTIONS(4931),
    [anon_sym_LBRACK] = ACTIONS(4933),
    [anon_sym_LPAREN] = ACTIONS(4933),
    [anon_sym_event] = ACTIONS(4931),
    [anon_sym_namespace] = ACTIONS(4931),
    [anon_sym_class] = ACTIONS(4931),
    [anon_sym_ref] = ACTIONS(4931),
    [anon_sym_struct] = ACTIONS(4931),
    [anon_sym_enum] = ACTIONS(4931),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym_interface] = ACTIONS(4931),
    [anon_sym_delegate] = ACTIONS(4931),
    [anon_sym_record] = ACTIONS(4931),
    [anon_sym_abstract] = ACTIONS(4931),
    [anon_sym_async] = ACTIONS(4931),
    [anon_sym_const] = ACTIONS(4931),
    [anon_sym_file] = ACTIONS(4931),
    [anon_sym_fixed] = ACTIONS(4931),
    [anon_sym_internal] = ACTIONS(4931),
    [anon_sym_new] = ACTIONS(4931),
    [anon_sym_override] = ACTIONS(4931),
    [anon_sym_partial] = ACTIONS(4931),
    [anon_sym_private] = ACTIONS(4931),
    [anon_sym_protected] = ACTIONS(4931),
    [anon_sym_public] = ACTIONS(4931),
    [anon_sym_readonly] = ACTIONS(4931),
    [anon_sym_required] = ACTIONS(4931),
    [anon_sym_sealed] = ACTIONS(4931),
    [anon_sym_virtual] = ACTIONS(4931),
    [anon_sym_volatile] = ACTIONS(4931),
    [anon_sym_where] = ACTIONS(4931),
    [anon_sym_notnull] = ACTIONS(4931),
    [anon_sym_unmanaged] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4933),
    [anon_sym_implicit] = ACTIONS(4931),
    [anon_sym_explicit] = ACTIONS(4931),
    [anon_sym_scoped] = ACTIONS(4931),
    [anon_sym_var] = ACTIONS(4931),
    [sym_predefined_type] = ACTIONS(4931),
    [anon_sym_yield] = ACTIONS(4931),
    [anon_sym_when] = ACTIONS(4931),
    [anon_sym_from] = ACTIONS(4931),
    [anon_sym_into] = ACTIONS(4931),
    [anon_sym_join] = ACTIONS(4931),
    [anon_sym_on] = ACTIONS(4931),
    [anon_sym_equals] = ACTIONS(4931),
    [anon_sym_let] = ACTIONS(4931),
    [anon_sym_orderby] = ACTIONS(4931),
    [anon_sym_ascending] = ACTIONS(4931),
    [anon_sym_descending] = ACTIONS(4931),
    [anon_sym_group] = ACTIONS(4931),
    [anon_sym_by] = ACTIONS(4931),
    [anon_sym_select] = ACTIONS(4931),
    [aux_sym_preproc_if_token1] = ACTIONS(4933),
    [aux_sym_preproc_if_token3] = ACTIONS(4933),
    [aux_sym_preproc_else_token1] = ACTIONS(4933),
    [aux_sym_preproc_elif_token1] = ACTIONS(4933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3340] = {
    [sym_preproc_region] = STATE(3340),
    [sym_preproc_endregion] = STATE(3340),
    [sym_preproc_line] = STATE(3340),
    [sym_preproc_pragma] = STATE(3340),
    [sym_preproc_nullable] = STATE(3340),
    [sym_preproc_error] = STATE(3340),
    [sym_preproc_define] = STATE(3340),
    [sym_preproc_undef] = STATE(3340),
    [sym__identifier_token] = ACTIONS(3443),
    [anon_sym_extern] = ACTIONS(3443),
    [anon_sym_alias] = ACTIONS(3443),
    [anon_sym_global] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3443),
    [anon_sym_unsafe] = ACTIONS(3443),
    [anon_sym_static] = ACTIONS(3443),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_event] = ACTIONS(3443),
    [anon_sym_namespace] = ACTIONS(3443),
    [anon_sym_class] = ACTIONS(3443),
    [anon_sym_ref] = ACTIONS(3443),
    [anon_sym_struct] = ACTIONS(3443),
    [anon_sym_enum] = ACTIONS(3443),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3443),
    [anon_sym_delegate] = ACTIONS(3443),
    [anon_sym_record] = ACTIONS(3443),
    [anon_sym_abstract] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(3443),
    [anon_sym_const] = ACTIONS(3443),
    [anon_sym_file] = ACTIONS(3443),
    [anon_sym_fixed] = ACTIONS(3443),
    [anon_sym_internal] = ACTIONS(3443),
    [anon_sym_new] = ACTIONS(3443),
    [anon_sym_override] = ACTIONS(3443),
    [anon_sym_partial] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_readonly] = ACTIONS(3443),
    [anon_sym_required] = ACTIONS(3443),
    [anon_sym_sealed] = ACTIONS(3443),
    [anon_sym_virtual] = ACTIONS(3443),
    [anon_sym_volatile] = ACTIONS(3443),
    [anon_sym_where] = ACTIONS(3443),
    [anon_sym_notnull] = ACTIONS(3443),
    [anon_sym_unmanaged] = ACTIONS(3443),
    [anon_sym_TILDE] = ACTIONS(3445),
    [anon_sym_implicit] = ACTIONS(3443),
    [anon_sym_explicit] = ACTIONS(3443),
    [anon_sym_scoped] = ACTIONS(3443),
    [anon_sym_var] = ACTIONS(3443),
    [sym_predefined_type] = ACTIONS(3443),
    [anon_sym_yield] = ACTIONS(3443),
    [anon_sym_when] = ACTIONS(3443),
    [anon_sym_from] = ACTIONS(3443),
    [anon_sym_into] = ACTIONS(3443),
    [anon_sym_join] = ACTIONS(3443),
    [anon_sym_on] = ACTIONS(3443),
    [anon_sym_equals] = ACTIONS(3443),
    [anon_sym_let] = ACTIONS(3443),
    [anon_sym_orderby] = ACTIONS(3443),
    [anon_sym_ascending] = ACTIONS(3443),
    [anon_sym_descending] = ACTIONS(3443),
    [anon_sym_group] = ACTIONS(3443),
    [anon_sym_by] = ACTIONS(3443),
    [anon_sym_select] = ACTIONS(3443),
    [aux_sym_preproc_if_token1] = ACTIONS(3445),
    [aux_sym_preproc_if_token3] = ACTIONS(3445),
    [aux_sym_preproc_else_token1] = ACTIONS(3445),
    [aux_sym_preproc_elif_token1] = ACTIONS(3445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3341] = {
    [sym_preproc_region] = STATE(3341),
    [sym_preproc_endregion] = STATE(3341),
    [sym_preproc_line] = STATE(3341),
    [sym_preproc_pragma] = STATE(3341),
    [sym_preproc_nullable] = STATE(3341),
    [sym_preproc_error] = STATE(3341),
    [sym_preproc_define] = STATE(3341),
    [sym_preproc_undef] = STATE(3341),
    [sym__identifier_token] = ACTIONS(4626),
    [anon_sym_alias] = ACTIONS(4626),
    [anon_sym_global] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_COLON] = ACTIONS(4628),
    [anon_sym_COMMA] = ACTIONS(4628),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(4628),
    [anon_sym_file] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4626),
    [anon_sym_GT] = ACTIONS(4626),
    [anon_sym_where] = ACTIONS(4626),
    [anon_sym_QMARK] = ACTIONS(4626),
    [anon_sym_notnull] = ACTIONS(4626),
    [anon_sym_unmanaged] = ACTIONS(4626),
    [anon_sym_BANG] = ACTIONS(4626),
    [anon_sym_PLUS_PLUS] = ACTIONS(4628),
    [anon_sym_DASH_DASH] = ACTIONS(4628),
    [anon_sym_PLUS] = ACTIONS(4626),
    [anon_sym_DASH] = ACTIONS(4626),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_SLASH] = ACTIONS(4626),
    [anon_sym_PERCENT] = ACTIONS(4628),
    [anon_sym_CARET] = ACTIONS(4628),
    [anon_sym_PIPE] = ACTIONS(4626),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT_LT] = ACTIONS(4628),
    [anon_sym_GT_GT] = ACTIONS(4626),
    [anon_sym_GT_GT_GT] = ACTIONS(4628),
    [anon_sym_EQ_EQ] = ACTIONS(4628),
    [anon_sym_BANG_EQ] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4628),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_DOT] = ACTIONS(4626),
    [anon_sym_scoped] = ACTIONS(4626),
    [anon_sym_var] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4626),
    [anon_sym_switch] = ACTIONS(4626),
    [anon_sym_when] = ACTIONS(4626),
    [sym_discard] = ACTIONS(4626),
    [anon_sym_DOT_DOT] = ACTIONS(4628),
    [anon_sym_and] = ACTIONS(4626),
    [anon_sym_or] = ACTIONS(4626),
    [anon_sym_AMP_AMP] = ACTIONS(4628),
    [anon_sym_PIPE_PIPE] = ACTIONS(4628),
    [anon_sym_QMARK_QMARK] = ACTIONS(4628),
    [anon_sym_from] = ACTIONS(4626),
    [anon_sym_into] = ACTIONS(4626),
    [anon_sym_join] = ACTIONS(4626),
    [anon_sym_on] = ACTIONS(4626),
    [anon_sym_equals] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4626),
    [anon_sym_orderby] = ACTIONS(4626),
    [anon_sym_ascending] = ACTIONS(4626),
    [anon_sym_descending] = ACTIONS(4626),
    [anon_sym_group] = ACTIONS(4626),
    [anon_sym_by] = ACTIONS(4626),
    [anon_sym_select] = ACTIONS(4626),
    [anon_sym_as] = ACTIONS(4626),
    [anon_sym_is] = ACTIONS(4626),
    [anon_sym_DASH_GT] = ACTIONS(4628),
    [anon_sym_with] = ACTIONS(4626),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4628),
  },
  [3342] = {
    [sym__variable_designation] = STATE(4998),
    [sym_parenthesized_variable_designation] = STATE(5017),
    [sym_identifier] = STATE(5015),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(3342),
    [sym_preproc_endregion] = STATE(3342),
    [sym_preproc_line] = STATE(3342),
    [sym_preproc_pragma] = STATE(3342),
    [sym_preproc_nullable] = STATE(3342),
    [sym_preproc_error] = STATE(3342),
    [sym_preproc_define] = STATE(3342),
    [sym_preproc_undef] = STATE(3342),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4435),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4353),
    [anon_sym_var] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4353),
    [sym_discard] = ACTIONS(4717),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4435),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4435),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4435),
    [anon_sym_orderby] = ACTIONS(4435),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4435),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4435),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3343] = {
    [sym_preproc_region] = STATE(3343),
    [sym_preproc_endregion] = STATE(3343),
    [sym_preproc_line] = STATE(3343),
    [sym_preproc_pragma] = STATE(3343),
    [sym_preproc_nullable] = STATE(3343),
    [sym_preproc_error] = STATE(3343),
    [sym_preproc_define] = STATE(3343),
    [sym_preproc_undef] = STATE(3343),
    [sym__identifier_token] = ACTIONS(4577),
    [anon_sym_alias] = ACTIONS(4577),
    [anon_sym_global] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_file] = ACTIONS(4577),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_where] = ACTIONS(4577),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_notnull] = ACTIONS(4577),
    [anon_sym_unmanaged] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_scoped] = ACTIONS(4577),
    [anon_sym_var] = ACTIONS(4577),
    [anon_sym_yield] = ACTIONS(4577),
    [anon_sym_switch] = ACTIONS(4577),
    [anon_sym_when] = ACTIONS(4577),
    [sym_discard] = ACTIONS(4577),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4577),
    [anon_sym_or] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_from] = ACTIONS(4577),
    [anon_sym_into] = ACTIONS(4577),
    [anon_sym_join] = ACTIONS(4577),
    [anon_sym_on] = ACTIONS(4577),
    [anon_sym_equals] = ACTIONS(4577),
    [anon_sym_let] = ACTIONS(4577),
    [anon_sym_orderby] = ACTIONS(4577),
    [anon_sym_ascending] = ACTIONS(4577),
    [anon_sym_descending] = ACTIONS(4577),
    [anon_sym_group] = ACTIONS(4577),
    [anon_sym_by] = ACTIONS(4577),
    [anon_sym_select] = ACTIONS(4577),
    [anon_sym_as] = ACTIONS(4577),
    [anon_sym_is] = ACTIONS(4577),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4577),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4579),
  },
  [3344] = {
    [sym_preproc_region] = STATE(3344),
    [sym_preproc_endregion] = STATE(3344),
    [sym_preproc_line] = STATE(3344),
    [sym_preproc_pragma] = STATE(3344),
    [sym_preproc_nullable] = STATE(3344),
    [sym_preproc_error] = STATE(3344),
    [sym_preproc_define] = STATE(3344),
    [sym_preproc_undef] = STATE(3344),
    [sym__identifier_token] = ACTIONS(3735),
    [anon_sym_extern] = ACTIONS(3735),
    [anon_sym_alias] = ACTIONS(3735),
    [anon_sym_global] = ACTIONS(3735),
    [anon_sym_using] = ACTIONS(3735),
    [anon_sym_unsafe] = ACTIONS(3735),
    [anon_sym_static] = ACTIONS(3735),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [anon_sym_LPAREN] = ACTIONS(3737),
    [anon_sym_event] = ACTIONS(3735),
    [anon_sym_namespace] = ACTIONS(3735),
    [anon_sym_class] = ACTIONS(3735),
    [anon_sym_ref] = ACTIONS(3735),
    [anon_sym_struct] = ACTIONS(3735),
    [anon_sym_enum] = ACTIONS(3735),
    [anon_sym_RBRACE] = ACTIONS(3737),
    [anon_sym_interface] = ACTIONS(3735),
    [anon_sym_delegate] = ACTIONS(3735),
    [anon_sym_record] = ACTIONS(3735),
    [anon_sym_abstract] = ACTIONS(3735),
    [anon_sym_async] = ACTIONS(3735),
    [anon_sym_const] = ACTIONS(3735),
    [anon_sym_file] = ACTIONS(3735),
    [anon_sym_fixed] = ACTIONS(3735),
    [anon_sym_internal] = ACTIONS(3735),
    [anon_sym_new] = ACTIONS(3735),
    [anon_sym_override] = ACTIONS(3735),
    [anon_sym_partial] = ACTIONS(3735),
    [anon_sym_private] = ACTIONS(3735),
    [anon_sym_protected] = ACTIONS(3735),
    [anon_sym_public] = ACTIONS(3735),
    [anon_sym_readonly] = ACTIONS(3735),
    [anon_sym_required] = ACTIONS(3735),
    [anon_sym_sealed] = ACTIONS(3735),
    [anon_sym_virtual] = ACTIONS(3735),
    [anon_sym_volatile] = ACTIONS(3735),
    [anon_sym_where] = ACTIONS(3735),
    [anon_sym_notnull] = ACTIONS(3735),
    [anon_sym_unmanaged] = ACTIONS(3735),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_implicit] = ACTIONS(3735),
    [anon_sym_explicit] = ACTIONS(3735),
    [anon_sym_scoped] = ACTIONS(3735),
    [anon_sym_var] = ACTIONS(3735),
    [sym_predefined_type] = ACTIONS(3735),
    [anon_sym_yield] = ACTIONS(3735),
    [anon_sym_when] = ACTIONS(3735),
    [anon_sym_from] = ACTIONS(3735),
    [anon_sym_into] = ACTIONS(3735),
    [anon_sym_join] = ACTIONS(3735),
    [anon_sym_on] = ACTIONS(3735),
    [anon_sym_equals] = ACTIONS(3735),
    [anon_sym_let] = ACTIONS(3735),
    [anon_sym_orderby] = ACTIONS(3735),
    [anon_sym_ascending] = ACTIONS(3735),
    [anon_sym_descending] = ACTIONS(3735),
    [anon_sym_group] = ACTIONS(3735),
    [anon_sym_by] = ACTIONS(3735),
    [anon_sym_select] = ACTIONS(3735),
    [aux_sym_preproc_if_token1] = ACTIONS(3737),
    [aux_sym_preproc_if_token3] = ACTIONS(3737),
    [aux_sym_preproc_else_token1] = ACTIONS(3737),
    [aux_sym_preproc_elif_token1] = ACTIONS(3737),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3345] = {
    [sym_preproc_region] = STATE(3345),
    [sym_preproc_endregion] = STATE(3345),
    [sym_preproc_line] = STATE(3345),
    [sym_preproc_pragma] = STATE(3345),
    [sym_preproc_nullable] = STATE(3345),
    [sym_preproc_error] = STATE(3345),
    [sym_preproc_define] = STATE(3345),
    [sym_preproc_undef] = STATE(3345),
    [sym__identifier_token] = ACTIONS(3507),
    [anon_sym_extern] = ACTIONS(3507),
    [anon_sym_alias] = ACTIONS(3507),
    [anon_sym_global] = ACTIONS(3507),
    [anon_sym_using] = ACTIONS(3507),
    [anon_sym_unsafe] = ACTIONS(3507),
    [anon_sym_static] = ACTIONS(3507),
    [anon_sym_LBRACK] = ACTIONS(3509),
    [anon_sym_LPAREN] = ACTIONS(3509),
    [anon_sym_event] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3507),
    [anon_sym_class] = ACTIONS(3507),
    [anon_sym_ref] = ACTIONS(3507),
    [anon_sym_struct] = ACTIONS(3507),
    [anon_sym_enum] = ACTIONS(3507),
    [anon_sym_RBRACE] = ACTIONS(3509),
    [anon_sym_interface] = ACTIONS(3507),
    [anon_sym_delegate] = ACTIONS(3507),
    [anon_sym_record] = ACTIONS(3507),
    [anon_sym_abstract] = ACTIONS(3507),
    [anon_sym_async] = ACTIONS(3507),
    [anon_sym_const] = ACTIONS(3507),
    [anon_sym_file] = ACTIONS(3507),
    [anon_sym_fixed] = ACTIONS(3507),
    [anon_sym_internal] = ACTIONS(3507),
    [anon_sym_new] = ACTIONS(3507),
    [anon_sym_override] = ACTIONS(3507),
    [anon_sym_partial] = ACTIONS(3507),
    [anon_sym_private] = ACTIONS(3507),
    [anon_sym_protected] = ACTIONS(3507),
    [anon_sym_public] = ACTIONS(3507),
    [anon_sym_readonly] = ACTIONS(3507),
    [anon_sym_required] = ACTIONS(3507),
    [anon_sym_sealed] = ACTIONS(3507),
    [anon_sym_virtual] = ACTIONS(3507),
    [anon_sym_volatile] = ACTIONS(3507),
    [anon_sym_where] = ACTIONS(3507),
    [anon_sym_notnull] = ACTIONS(3507),
    [anon_sym_unmanaged] = ACTIONS(3507),
    [anon_sym_TILDE] = ACTIONS(3509),
    [anon_sym_implicit] = ACTIONS(3507),
    [anon_sym_explicit] = ACTIONS(3507),
    [anon_sym_scoped] = ACTIONS(3507),
    [anon_sym_var] = ACTIONS(3507),
    [sym_predefined_type] = ACTIONS(3507),
    [anon_sym_yield] = ACTIONS(3507),
    [anon_sym_when] = ACTIONS(3507),
    [anon_sym_from] = ACTIONS(3507),
    [anon_sym_into] = ACTIONS(3507),
    [anon_sym_join] = ACTIONS(3507),
    [anon_sym_on] = ACTIONS(3507),
    [anon_sym_equals] = ACTIONS(3507),
    [anon_sym_let] = ACTIONS(3507),
    [anon_sym_orderby] = ACTIONS(3507),
    [anon_sym_ascending] = ACTIONS(3507),
    [anon_sym_descending] = ACTIONS(3507),
    [anon_sym_group] = ACTIONS(3507),
    [anon_sym_by] = ACTIONS(3507),
    [anon_sym_select] = ACTIONS(3507),
    [aux_sym_preproc_if_token1] = ACTIONS(3509),
    [aux_sym_preproc_if_token3] = ACTIONS(3509),
    [aux_sym_preproc_else_token1] = ACTIONS(3509),
    [aux_sym_preproc_elif_token1] = ACTIONS(3509),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3346] = {
    [sym_preproc_region] = STATE(3346),
    [sym_preproc_endregion] = STATE(3346),
    [sym_preproc_line] = STATE(3346),
    [sym_preproc_pragma] = STATE(3346),
    [sym_preproc_nullable] = STATE(3346),
    [sym_preproc_error] = STATE(3346),
    [sym_preproc_define] = STATE(3346),
    [sym_preproc_undef] = STATE(3346),
    [sym__identifier_token] = ACTIONS(3519),
    [anon_sym_extern] = ACTIONS(3519),
    [anon_sym_alias] = ACTIONS(3519),
    [anon_sym_global] = ACTIONS(3519),
    [anon_sym_using] = ACTIONS(3519),
    [anon_sym_unsafe] = ACTIONS(3519),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_event] = ACTIONS(3519),
    [anon_sym_namespace] = ACTIONS(3519),
    [anon_sym_class] = ACTIONS(3519),
    [anon_sym_ref] = ACTIONS(3519),
    [anon_sym_struct] = ACTIONS(3519),
    [anon_sym_enum] = ACTIONS(3519),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3519),
    [anon_sym_delegate] = ACTIONS(3519),
    [anon_sym_record] = ACTIONS(3519),
    [anon_sym_abstract] = ACTIONS(3519),
    [anon_sym_async] = ACTIONS(3519),
    [anon_sym_const] = ACTIONS(3519),
    [anon_sym_file] = ACTIONS(3519),
    [anon_sym_fixed] = ACTIONS(3519),
    [anon_sym_internal] = ACTIONS(3519),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_override] = ACTIONS(3519),
    [anon_sym_partial] = ACTIONS(3519),
    [anon_sym_private] = ACTIONS(3519),
    [anon_sym_protected] = ACTIONS(3519),
    [anon_sym_public] = ACTIONS(3519),
    [anon_sym_readonly] = ACTIONS(3519),
    [anon_sym_required] = ACTIONS(3519),
    [anon_sym_sealed] = ACTIONS(3519),
    [anon_sym_virtual] = ACTIONS(3519),
    [anon_sym_volatile] = ACTIONS(3519),
    [anon_sym_where] = ACTIONS(3519),
    [anon_sym_notnull] = ACTIONS(3519),
    [anon_sym_unmanaged] = ACTIONS(3519),
    [anon_sym_TILDE] = ACTIONS(3521),
    [anon_sym_implicit] = ACTIONS(3519),
    [anon_sym_explicit] = ACTIONS(3519),
    [anon_sym_scoped] = ACTIONS(3519),
    [anon_sym_var] = ACTIONS(3519),
    [sym_predefined_type] = ACTIONS(3519),
    [anon_sym_yield] = ACTIONS(3519),
    [anon_sym_when] = ACTIONS(3519),
    [anon_sym_from] = ACTIONS(3519),
    [anon_sym_into] = ACTIONS(3519),
    [anon_sym_join] = ACTIONS(3519),
    [anon_sym_on] = ACTIONS(3519),
    [anon_sym_equals] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3519),
    [anon_sym_orderby] = ACTIONS(3519),
    [anon_sym_ascending] = ACTIONS(3519),
    [anon_sym_descending] = ACTIONS(3519),
    [anon_sym_group] = ACTIONS(3519),
    [anon_sym_by] = ACTIONS(3519),
    [anon_sym_select] = ACTIONS(3519),
    [aux_sym_preproc_if_token1] = ACTIONS(3521),
    [aux_sym_preproc_if_token3] = ACTIONS(3521),
    [aux_sym_preproc_else_token1] = ACTIONS(3521),
    [aux_sym_preproc_elif_token1] = ACTIONS(3521),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3347] = {
    [sym_preproc_region] = STATE(3347),
    [sym_preproc_endregion] = STATE(3347),
    [sym_preproc_line] = STATE(3347),
    [sym_preproc_pragma] = STATE(3347),
    [sym_preproc_nullable] = STATE(3347),
    [sym_preproc_error] = STATE(3347),
    [sym_preproc_define] = STATE(3347),
    [sym_preproc_undef] = STATE(3347),
    [sym__identifier_token] = ACTIONS(3527),
    [anon_sym_extern] = ACTIONS(3527),
    [anon_sym_alias] = ACTIONS(3527),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_using] = ACTIONS(3527),
    [anon_sym_unsafe] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3529),
    [anon_sym_event] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_class] = ACTIONS(3527),
    [anon_sym_ref] = ACTIONS(3527),
    [anon_sym_struct] = ACTIONS(3527),
    [anon_sym_enum] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3529),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_delegate] = ACTIONS(3527),
    [anon_sym_record] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_async] = ACTIONS(3527),
    [anon_sym_const] = ACTIONS(3527),
    [anon_sym_file] = ACTIONS(3527),
    [anon_sym_fixed] = ACTIONS(3527),
    [anon_sym_internal] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_override] = ACTIONS(3527),
    [anon_sym_partial] = ACTIONS(3527),
    [anon_sym_private] = ACTIONS(3527),
    [anon_sym_protected] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(3527),
    [anon_sym_readonly] = ACTIONS(3527),
    [anon_sym_required] = ACTIONS(3527),
    [anon_sym_sealed] = ACTIONS(3527),
    [anon_sym_virtual] = ACTIONS(3527),
    [anon_sym_volatile] = ACTIONS(3527),
    [anon_sym_where] = ACTIONS(3527),
    [anon_sym_notnull] = ACTIONS(3527),
    [anon_sym_unmanaged] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3529),
    [anon_sym_implicit] = ACTIONS(3527),
    [anon_sym_explicit] = ACTIONS(3527),
    [anon_sym_scoped] = ACTIONS(3527),
    [anon_sym_var] = ACTIONS(3527),
    [sym_predefined_type] = ACTIONS(3527),
    [anon_sym_yield] = ACTIONS(3527),
    [anon_sym_when] = ACTIONS(3527),
    [anon_sym_from] = ACTIONS(3527),
    [anon_sym_into] = ACTIONS(3527),
    [anon_sym_join] = ACTIONS(3527),
    [anon_sym_on] = ACTIONS(3527),
    [anon_sym_equals] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_orderby] = ACTIONS(3527),
    [anon_sym_ascending] = ACTIONS(3527),
    [anon_sym_descending] = ACTIONS(3527),
    [anon_sym_group] = ACTIONS(3527),
    [anon_sym_by] = ACTIONS(3527),
    [anon_sym_select] = ACTIONS(3527),
    [aux_sym_preproc_if_token1] = ACTIONS(3529),
    [aux_sym_preproc_if_token3] = ACTIONS(3529),
    [aux_sym_preproc_else_token1] = ACTIONS(3529),
    [aux_sym_preproc_elif_token1] = ACTIONS(3529),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3348] = {
    [sym_preproc_region] = STATE(3348),
    [sym_preproc_endregion] = STATE(3348),
    [sym_preproc_line] = STATE(3348),
    [sym_preproc_pragma] = STATE(3348),
    [sym_preproc_nullable] = STATE(3348),
    [sym_preproc_error] = STATE(3348),
    [sym_preproc_define] = STATE(3348),
    [sym_preproc_undef] = STATE(3348),
    [sym__identifier_token] = ACTIONS(3535),
    [anon_sym_extern] = ACTIONS(3535),
    [anon_sym_alias] = ACTIONS(3535),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_using] = ACTIONS(3535),
    [anon_sym_unsafe] = ACTIONS(3535),
    [anon_sym_static] = ACTIONS(3535),
    [anon_sym_LBRACK] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_event] = ACTIONS(3535),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_class] = ACTIONS(3535),
    [anon_sym_ref] = ACTIONS(3535),
    [anon_sym_struct] = ACTIONS(3535),
    [anon_sym_enum] = ACTIONS(3535),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_interface] = ACTIONS(3535),
    [anon_sym_delegate] = ACTIONS(3535),
    [anon_sym_record] = ACTIONS(3535),
    [anon_sym_abstract] = ACTIONS(3535),
    [anon_sym_async] = ACTIONS(3535),
    [anon_sym_const] = ACTIONS(3535),
    [anon_sym_file] = ACTIONS(3535),
    [anon_sym_fixed] = ACTIONS(3535),
    [anon_sym_internal] = ACTIONS(3535),
    [anon_sym_new] = ACTIONS(3535),
    [anon_sym_override] = ACTIONS(3535),
    [anon_sym_partial] = ACTIONS(3535),
    [anon_sym_private] = ACTIONS(3535),
    [anon_sym_protected] = ACTIONS(3535),
    [anon_sym_public] = ACTIONS(3535),
    [anon_sym_readonly] = ACTIONS(3535),
    [anon_sym_required] = ACTIONS(3535),
    [anon_sym_sealed] = ACTIONS(3535),
    [anon_sym_virtual] = ACTIONS(3535),
    [anon_sym_volatile] = ACTIONS(3535),
    [anon_sym_where] = ACTIONS(3535),
    [anon_sym_notnull] = ACTIONS(3535),
    [anon_sym_unmanaged] = ACTIONS(3535),
    [anon_sym_TILDE] = ACTIONS(3537),
    [anon_sym_implicit] = ACTIONS(3535),
    [anon_sym_explicit] = ACTIONS(3535),
    [anon_sym_scoped] = ACTIONS(3535),
    [anon_sym_var] = ACTIONS(3535),
    [sym_predefined_type] = ACTIONS(3535),
    [anon_sym_yield] = ACTIONS(3535),
    [anon_sym_when] = ACTIONS(3535),
    [anon_sym_from] = ACTIONS(3535),
    [anon_sym_into] = ACTIONS(3535),
    [anon_sym_join] = ACTIONS(3535),
    [anon_sym_on] = ACTIONS(3535),
    [anon_sym_equals] = ACTIONS(3535),
    [anon_sym_let] = ACTIONS(3535),
    [anon_sym_orderby] = ACTIONS(3535),
    [anon_sym_ascending] = ACTIONS(3535),
    [anon_sym_descending] = ACTIONS(3535),
    [anon_sym_group] = ACTIONS(3535),
    [anon_sym_by] = ACTIONS(3535),
    [anon_sym_select] = ACTIONS(3535),
    [aux_sym_preproc_if_token1] = ACTIONS(3537),
    [aux_sym_preproc_if_token3] = ACTIONS(3537),
    [aux_sym_preproc_else_token1] = ACTIONS(3537),
    [aux_sym_preproc_elif_token1] = ACTIONS(3537),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3349] = {
    [sym_preproc_region] = STATE(3349),
    [sym_preproc_endregion] = STATE(3349),
    [sym_preproc_line] = STATE(3349),
    [sym_preproc_pragma] = STATE(3349),
    [sym_preproc_nullable] = STATE(3349),
    [sym_preproc_error] = STATE(3349),
    [sym_preproc_define] = STATE(3349),
    [sym_preproc_undef] = STATE(3349),
    [sym__identifier_token] = ACTIONS(4935),
    [anon_sym_extern] = ACTIONS(4935),
    [anon_sym_alias] = ACTIONS(4935),
    [anon_sym_global] = ACTIONS(4935),
    [anon_sym_using] = ACTIONS(4935),
    [anon_sym_unsafe] = ACTIONS(4935),
    [anon_sym_static] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4937),
    [anon_sym_LPAREN] = ACTIONS(4937),
    [anon_sym_event] = ACTIONS(4935),
    [anon_sym_namespace] = ACTIONS(4935),
    [anon_sym_class] = ACTIONS(4935),
    [anon_sym_ref] = ACTIONS(4935),
    [anon_sym_struct] = ACTIONS(4935),
    [anon_sym_enum] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym_interface] = ACTIONS(4935),
    [anon_sym_delegate] = ACTIONS(4935),
    [anon_sym_record] = ACTIONS(4935),
    [anon_sym_abstract] = ACTIONS(4935),
    [anon_sym_async] = ACTIONS(4935),
    [anon_sym_const] = ACTIONS(4935),
    [anon_sym_file] = ACTIONS(4935),
    [anon_sym_fixed] = ACTIONS(4935),
    [anon_sym_internal] = ACTIONS(4935),
    [anon_sym_new] = ACTIONS(4935),
    [anon_sym_override] = ACTIONS(4935),
    [anon_sym_partial] = ACTIONS(4935),
    [anon_sym_private] = ACTIONS(4935),
    [anon_sym_protected] = ACTIONS(4935),
    [anon_sym_public] = ACTIONS(4935),
    [anon_sym_readonly] = ACTIONS(4935),
    [anon_sym_required] = ACTIONS(4935),
    [anon_sym_sealed] = ACTIONS(4935),
    [anon_sym_virtual] = ACTIONS(4935),
    [anon_sym_volatile] = ACTIONS(4935),
    [anon_sym_where] = ACTIONS(4935),
    [anon_sym_notnull] = ACTIONS(4935),
    [anon_sym_unmanaged] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4937),
    [anon_sym_implicit] = ACTIONS(4935),
    [anon_sym_explicit] = ACTIONS(4935),
    [anon_sym_scoped] = ACTIONS(4935),
    [anon_sym_var] = ACTIONS(4935),
    [sym_predefined_type] = ACTIONS(4935),
    [anon_sym_yield] = ACTIONS(4935),
    [anon_sym_when] = ACTIONS(4935),
    [anon_sym_from] = ACTIONS(4935),
    [anon_sym_into] = ACTIONS(4935),
    [anon_sym_join] = ACTIONS(4935),
    [anon_sym_on] = ACTIONS(4935),
    [anon_sym_equals] = ACTIONS(4935),
    [anon_sym_let] = ACTIONS(4935),
    [anon_sym_orderby] = ACTIONS(4935),
    [anon_sym_ascending] = ACTIONS(4935),
    [anon_sym_descending] = ACTIONS(4935),
    [anon_sym_group] = ACTIONS(4935),
    [anon_sym_by] = ACTIONS(4935),
    [anon_sym_select] = ACTIONS(4935),
    [aux_sym_preproc_if_token1] = ACTIONS(4937),
    [aux_sym_preproc_if_token3] = ACTIONS(4937),
    [aux_sym_preproc_else_token1] = ACTIONS(4937),
    [aux_sym_preproc_elif_token1] = ACTIONS(4937),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3350] = {
    [sym_preproc_region] = STATE(3350),
    [sym_preproc_endregion] = STATE(3350),
    [sym_preproc_line] = STATE(3350),
    [sym_preproc_pragma] = STATE(3350),
    [sym_preproc_nullable] = STATE(3350),
    [sym_preproc_error] = STATE(3350),
    [sym_preproc_define] = STATE(3350),
    [sym_preproc_undef] = STATE(3350),
    [sym__identifier_token] = ACTIONS(4126),
    [anon_sym_alias] = ACTIONS(4126),
    [anon_sym_global] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_file] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_notnull] = ACTIONS(4126),
    [anon_sym_unmanaged] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_scoped] = ACTIONS(4126),
    [anon_sym_var] = ACTIONS(4126),
    [anon_sym_yield] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4126),
    [anon_sym_when] = ACTIONS(4126),
    [sym_discard] = ACTIONS(4126),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4126),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_from] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4126),
    [anon_sym_join] = ACTIONS(4126),
    [anon_sym_on] = ACTIONS(4126),
    [anon_sym_equals] = ACTIONS(4126),
    [anon_sym_let] = ACTIONS(4126),
    [anon_sym_orderby] = ACTIONS(4126),
    [anon_sym_ascending] = ACTIONS(4126),
    [anon_sym_descending] = ACTIONS(4126),
    [anon_sym_group] = ACTIONS(4126),
    [anon_sym_by] = ACTIONS(4126),
    [anon_sym_select] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_is] = ACTIONS(4126),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4126),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4128),
  },
  [3351] = {
    [sym_preproc_region] = STATE(3351),
    [sym_preproc_endregion] = STATE(3351),
    [sym_preproc_line] = STATE(3351),
    [sym_preproc_pragma] = STATE(3351),
    [sym_preproc_nullable] = STATE(3351),
    [sym_preproc_error] = STATE(3351),
    [sym_preproc_define] = STATE(3351),
    [sym_preproc_undef] = STATE(3351),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_when] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4128),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3352] = {
    [sym_preproc_region] = STATE(3352),
    [sym_preproc_endregion] = STATE(3352),
    [sym_preproc_line] = STATE(3352),
    [sym_preproc_pragma] = STATE(3352),
    [sym_preproc_nullable] = STATE(3352),
    [sym_preproc_error] = STATE(3352),
    [sym_preproc_define] = STATE(3352),
    [sym_preproc_undef] = STATE(3352),
    [sym__identifier_token] = ACTIONS(3539),
    [anon_sym_extern] = ACTIONS(3539),
    [anon_sym_alias] = ACTIONS(3539),
    [anon_sym_global] = ACTIONS(3539),
    [anon_sym_using] = ACTIONS(3539),
    [anon_sym_unsafe] = ACTIONS(3539),
    [anon_sym_static] = ACTIONS(3539),
    [anon_sym_LBRACK] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3541),
    [anon_sym_event] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3539),
    [anon_sym_class] = ACTIONS(3539),
    [anon_sym_ref] = ACTIONS(3539),
    [anon_sym_struct] = ACTIONS(3539),
    [anon_sym_enum] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3541),
    [anon_sym_interface] = ACTIONS(3539),
    [anon_sym_delegate] = ACTIONS(3539),
    [anon_sym_record] = ACTIONS(3539),
    [anon_sym_abstract] = ACTIONS(3539),
    [anon_sym_async] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3539),
    [anon_sym_file] = ACTIONS(3539),
    [anon_sym_fixed] = ACTIONS(3539),
    [anon_sym_internal] = ACTIONS(3539),
    [anon_sym_new] = ACTIONS(3539),
    [anon_sym_override] = ACTIONS(3539),
    [anon_sym_partial] = ACTIONS(3539),
    [anon_sym_private] = ACTIONS(3539),
    [anon_sym_protected] = ACTIONS(3539),
    [anon_sym_public] = ACTIONS(3539),
    [anon_sym_readonly] = ACTIONS(3539),
    [anon_sym_required] = ACTIONS(3539),
    [anon_sym_sealed] = ACTIONS(3539),
    [anon_sym_virtual] = ACTIONS(3539),
    [anon_sym_volatile] = ACTIONS(3539),
    [anon_sym_where] = ACTIONS(3539),
    [anon_sym_notnull] = ACTIONS(3539),
    [anon_sym_unmanaged] = ACTIONS(3539),
    [anon_sym_TILDE] = ACTIONS(3541),
    [anon_sym_implicit] = ACTIONS(3539),
    [anon_sym_explicit] = ACTIONS(3539),
    [anon_sym_scoped] = ACTIONS(3539),
    [anon_sym_var] = ACTIONS(3539),
    [sym_predefined_type] = ACTIONS(3539),
    [anon_sym_yield] = ACTIONS(3539),
    [anon_sym_when] = ACTIONS(3539),
    [anon_sym_from] = ACTIONS(3539),
    [anon_sym_into] = ACTIONS(3539),
    [anon_sym_join] = ACTIONS(3539),
    [anon_sym_on] = ACTIONS(3539),
    [anon_sym_equals] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3539),
    [anon_sym_orderby] = ACTIONS(3539),
    [anon_sym_ascending] = ACTIONS(3539),
    [anon_sym_descending] = ACTIONS(3539),
    [anon_sym_group] = ACTIONS(3539),
    [anon_sym_by] = ACTIONS(3539),
    [anon_sym_select] = ACTIONS(3539),
    [aux_sym_preproc_if_token1] = ACTIONS(3541),
    [aux_sym_preproc_if_token3] = ACTIONS(3541),
    [aux_sym_preproc_else_token1] = ACTIONS(3541),
    [aux_sym_preproc_elif_token1] = ACTIONS(3541),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3353] = {
    [sym_preproc_region] = STATE(3353),
    [sym_preproc_endregion] = STATE(3353),
    [sym_preproc_line] = STATE(3353),
    [sym_preproc_pragma] = STATE(3353),
    [sym_preproc_nullable] = STATE(3353),
    [sym_preproc_error] = STATE(3353),
    [sym_preproc_define] = STATE(3353),
    [sym_preproc_undef] = STATE(3353),
    [sym__identifier_token] = ACTIONS(3543),
    [anon_sym_extern] = ACTIONS(3543),
    [anon_sym_alias] = ACTIONS(3543),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_using] = ACTIONS(3543),
    [anon_sym_unsafe] = ACTIONS(3543),
    [anon_sym_static] = ACTIONS(3543),
    [anon_sym_LBRACK] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(3545),
    [anon_sym_event] = ACTIONS(3543),
    [anon_sym_namespace] = ACTIONS(3543),
    [anon_sym_class] = ACTIONS(3543),
    [anon_sym_ref] = ACTIONS(3543),
    [anon_sym_struct] = ACTIONS(3543),
    [anon_sym_enum] = ACTIONS(3543),
    [anon_sym_RBRACE] = ACTIONS(3545),
    [anon_sym_interface] = ACTIONS(3543),
    [anon_sym_delegate] = ACTIONS(3543),
    [anon_sym_record] = ACTIONS(3543),
    [anon_sym_abstract] = ACTIONS(3543),
    [anon_sym_async] = ACTIONS(3543),
    [anon_sym_const] = ACTIONS(3543),
    [anon_sym_file] = ACTIONS(3543),
    [anon_sym_fixed] = ACTIONS(3543),
    [anon_sym_internal] = ACTIONS(3543),
    [anon_sym_new] = ACTIONS(3543),
    [anon_sym_override] = ACTIONS(3543),
    [anon_sym_partial] = ACTIONS(3543),
    [anon_sym_private] = ACTIONS(3543),
    [anon_sym_protected] = ACTIONS(3543),
    [anon_sym_public] = ACTIONS(3543),
    [anon_sym_readonly] = ACTIONS(3543),
    [anon_sym_required] = ACTIONS(3543),
    [anon_sym_sealed] = ACTIONS(3543),
    [anon_sym_virtual] = ACTIONS(3543),
    [anon_sym_volatile] = ACTIONS(3543),
    [anon_sym_where] = ACTIONS(3543),
    [anon_sym_notnull] = ACTIONS(3543),
    [anon_sym_unmanaged] = ACTIONS(3543),
    [anon_sym_TILDE] = ACTIONS(3545),
    [anon_sym_implicit] = ACTIONS(3543),
    [anon_sym_explicit] = ACTIONS(3543),
    [anon_sym_scoped] = ACTIONS(3543),
    [anon_sym_var] = ACTIONS(3543),
    [sym_predefined_type] = ACTIONS(3543),
    [anon_sym_yield] = ACTIONS(3543),
    [anon_sym_when] = ACTIONS(3543),
    [anon_sym_from] = ACTIONS(3543),
    [anon_sym_into] = ACTIONS(3543),
    [anon_sym_join] = ACTIONS(3543),
    [anon_sym_on] = ACTIONS(3543),
    [anon_sym_equals] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3543),
    [anon_sym_orderby] = ACTIONS(3543),
    [anon_sym_ascending] = ACTIONS(3543),
    [anon_sym_descending] = ACTIONS(3543),
    [anon_sym_group] = ACTIONS(3543),
    [anon_sym_by] = ACTIONS(3543),
    [anon_sym_select] = ACTIONS(3543),
    [aux_sym_preproc_if_token1] = ACTIONS(3545),
    [aux_sym_preproc_if_token3] = ACTIONS(3545),
    [aux_sym_preproc_else_token1] = ACTIONS(3545),
    [aux_sym_preproc_elif_token1] = ACTIONS(3545),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3354] = {
    [sym_preproc_region] = STATE(3354),
    [sym_preproc_endregion] = STATE(3354),
    [sym_preproc_line] = STATE(3354),
    [sym_preproc_pragma] = STATE(3354),
    [sym_preproc_nullable] = STATE(3354),
    [sym_preproc_error] = STATE(3354),
    [sym_preproc_define] = STATE(3354),
    [sym_preproc_undef] = STATE(3354),
    [sym__identifier_token] = ACTIONS(4939),
    [anon_sym_extern] = ACTIONS(4939),
    [anon_sym_alias] = ACTIONS(4939),
    [anon_sym_global] = ACTIONS(4939),
    [anon_sym_using] = ACTIONS(4939),
    [anon_sym_unsafe] = ACTIONS(4939),
    [anon_sym_static] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_LPAREN] = ACTIONS(4941),
    [anon_sym_event] = ACTIONS(4939),
    [anon_sym_namespace] = ACTIONS(4939),
    [anon_sym_class] = ACTIONS(4939),
    [anon_sym_ref] = ACTIONS(4939),
    [anon_sym_struct] = ACTIONS(4939),
    [anon_sym_enum] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_interface] = ACTIONS(4939),
    [anon_sym_delegate] = ACTIONS(4939),
    [anon_sym_record] = ACTIONS(4939),
    [anon_sym_abstract] = ACTIONS(4939),
    [anon_sym_async] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_file] = ACTIONS(4939),
    [anon_sym_fixed] = ACTIONS(4939),
    [anon_sym_internal] = ACTIONS(4939),
    [anon_sym_new] = ACTIONS(4939),
    [anon_sym_override] = ACTIONS(4939),
    [anon_sym_partial] = ACTIONS(4939),
    [anon_sym_private] = ACTIONS(4939),
    [anon_sym_protected] = ACTIONS(4939),
    [anon_sym_public] = ACTIONS(4939),
    [anon_sym_readonly] = ACTIONS(4939),
    [anon_sym_required] = ACTIONS(4939),
    [anon_sym_sealed] = ACTIONS(4939),
    [anon_sym_virtual] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_where] = ACTIONS(4939),
    [anon_sym_notnull] = ACTIONS(4939),
    [anon_sym_unmanaged] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4941),
    [anon_sym_implicit] = ACTIONS(4939),
    [anon_sym_explicit] = ACTIONS(4939),
    [anon_sym_scoped] = ACTIONS(4939),
    [anon_sym_var] = ACTIONS(4939),
    [sym_predefined_type] = ACTIONS(4939),
    [anon_sym_yield] = ACTIONS(4939),
    [anon_sym_when] = ACTIONS(4939),
    [anon_sym_from] = ACTIONS(4939),
    [anon_sym_into] = ACTIONS(4939),
    [anon_sym_join] = ACTIONS(4939),
    [anon_sym_on] = ACTIONS(4939),
    [anon_sym_equals] = ACTIONS(4939),
    [anon_sym_let] = ACTIONS(4939),
    [anon_sym_orderby] = ACTIONS(4939),
    [anon_sym_ascending] = ACTIONS(4939),
    [anon_sym_descending] = ACTIONS(4939),
    [anon_sym_group] = ACTIONS(4939),
    [anon_sym_by] = ACTIONS(4939),
    [anon_sym_select] = ACTIONS(4939),
    [aux_sym_preproc_if_token1] = ACTIONS(4941),
    [aux_sym_preproc_if_token3] = ACTIONS(4941),
    [aux_sym_preproc_else_token1] = ACTIONS(4941),
    [aux_sym_preproc_elif_token1] = ACTIONS(4941),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3355] = {
    [sym_preproc_region] = STATE(3355),
    [sym_preproc_endregion] = STATE(3355),
    [sym_preproc_line] = STATE(3355),
    [sym_preproc_pragma] = STATE(3355),
    [sym_preproc_nullable] = STATE(3355),
    [sym_preproc_error] = STATE(3355),
    [sym_preproc_define] = STATE(3355),
    [sym_preproc_undef] = STATE(3355),
    [sym__identifier_token] = ACTIONS(3575),
    [anon_sym_extern] = ACTIONS(3575),
    [anon_sym_alias] = ACTIONS(3575),
    [anon_sym_global] = ACTIONS(3575),
    [anon_sym_using] = ACTIONS(3575),
    [anon_sym_unsafe] = ACTIONS(3575),
    [anon_sym_static] = ACTIONS(3575),
    [anon_sym_LBRACK] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3577),
    [anon_sym_event] = ACTIONS(3575),
    [anon_sym_namespace] = ACTIONS(3575),
    [anon_sym_class] = ACTIONS(3575),
    [anon_sym_ref] = ACTIONS(3575),
    [anon_sym_struct] = ACTIONS(3575),
    [anon_sym_enum] = ACTIONS(3575),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_interface] = ACTIONS(3575),
    [anon_sym_delegate] = ACTIONS(3575),
    [anon_sym_record] = ACTIONS(3575),
    [anon_sym_abstract] = ACTIONS(3575),
    [anon_sym_async] = ACTIONS(3575),
    [anon_sym_const] = ACTIONS(3575),
    [anon_sym_file] = ACTIONS(3575),
    [anon_sym_fixed] = ACTIONS(3575),
    [anon_sym_internal] = ACTIONS(3575),
    [anon_sym_new] = ACTIONS(3575),
    [anon_sym_override] = ACTIONS(3575),
    [anon_sym_partial] = ACTIONS(3575),
    [anon_sym_private] = ACTIONS(3575),
    [anon_sym_protected] = ACTIONS(3575),
    [anon_sym_public] = ACTIONS(3575),
    [anon_sym_readonly] = ACTIONS(3575),
    [anon_sym_required] = ACTIONS(3575),
    [anon_sym_sealed] = ACTIONS(3575),
    [anon_sym_virtual] = ACTIONS(3575),
    [anon_sym_volatile] = ACTIONS(3575),
    [anon_sym_where] = ACTIONS(3575),
    [anon_sym_notnull] = ACTIONS(3575),
    [anon_sym_unmanaged] = ACTIONS(3575),
    [anon_sym_TILDE] = ACTIONS(3577),
    [anon_sym_implicit] = ACTIONS(3575),
    [anon_sym_explicit] = ACTIONS(3575),
    [anon_sym_scoped] = ACTIONS(3575),
    [anon_sym_var] = ACTIONS(3575),
    [sym_predefined_type] = ACTIONS(3575),
    [anon_sym_yield] = ACTIONS(3575),
    [anon_sym_when] = ACTIONS(3575),
    [anon_sym_from] = ACTIONS(3575),
    [anon_sym_into] = ACTIONS(3575),
    [anon_sym_join] = ACTIONS(3575),
    [anon_sym_on] = ACTIONS(3575),
    [anon_sym_equals] = ACTIONS(3575),
    [anon_sym_let] = ACTIONS(3575),
    [anon_sym_orderby] = ACTIONS(3575),
    [anon_sym_ascending] = ACTIONS(3575),
    [anon_sym_descending] = ACTIONS(3575),
    [anon_sym_group] = ACTIONS(3575),
    [anon_sym_by] = ACTIONS(3575),
    [anon_sym_select] = ACTIONS(3575),
    [aux_sym_preproc_if_token1] = ACTIONS(3577),
    [aux_sym_preproc_if_token3] = ACTIONS(3577),
    [aux_sym_preproc_else_token1] = ACTIONS(3577),
    [aux_sym_preproc_elif_token1] = ACTIONS(3577),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3356] = {
    [sym_preproc_region] = STATE(3356),
    [sym_preproc_endregion] = STATE(3356),
    [sym_preproc_line] = STATE(3356),
    [sym_preproc_pragma] = STATE(3356),
    [sym_preproc_nullable] = STATE(3356),
    [sym_preproc_error] = STATE(3356),
    [sym_preproc_define] = STATE(3356),
    [sym_preproc_undef] = STATE(3356),
    [sym__identifier_token] = ACTIONS(4130),
    [anon_sym_alias] = ACTIONS(4130),
    [anon_sym_global] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_file] = ACTIONS(4130),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_notnull] = ACTIONS(4130),
    [anon_sym_unmanaged] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_scoped] = ACTIONS(4130),
    [anon_sym_var] = ACTIONS(4130),
    [anon_sym_yield] = ACTIONS(4130),
    [anon_sym_switch] = ACTIONS(4130),
    [anon_sym_when] = ACTIONS(4130),
    [sym_discard] = ACTIONS(4130),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4130),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_from] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4130),
    [anon_sym_join] = ACTIONS(4130),
    [anon_sym_on] = ACTIONS(4130),
    [anon_sym_equals] = ACTIONS(4130),
    [anon_sym_let] = ACTIONS(4130),
    [anon_sym_orderby] = ACTIONS(4130),
    [anon_sym_ascending] = ACTIONS(4130),
    [anon_sym_descending] = ACTIONS(4130),
    [anon_sym_group] = ACTIONS(4130),
    [anon_sym_by] = ACTIONS(4130),
    [anon_sym_select] = ACTIONS(4130),
    [anon_sym_as] = ACTIONS(4130),
    [anon_sym_is] = ACTIONS(4130),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4130),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4132),
  },
  [3357] = {
    [sym_preproc_region] = STATE(3357),
    [sym_preproc_endregion] = STATE(3357),
    [sym_preproc_line] = STATE(3357),
    [sym_preproc_pragma] = STATE(3357),
    [sym_preproc_nullable] = STATE(3357),
    [sym_preproc_error] = STATE(3357),
    [sym_preproc_define] = STATE(3357),
    [sym_preproc_undef] = STATE(3357),
    [sym__identifier_token] = ACTIONS(3587),
    [anon_sym_extern] = ACTIONS(3587),
    [anon_sym_alias] = ACTIONS(3587),
    [anon_sym_global] = ACTIONS(3587),
    [anon_sym_using] = ACTIONS(3587),
    [anon_sym_unsafe] = ACTIONS(3587),
    [anon_sym_static] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [anon_sym_LPAREN] = ACTIONS(3589),
    [anon_sym_event] = ACTIONS(3587),
    [anon_sym_namespace] = ACTIONS(3587),
    [anon_sym_class] = ACTIONS(3587),
    [anon_sym_ref] = ACTIONS(3587),
    [anon_sym_struct] = ACTIONS(3587),
    [anon_sym_enum] = ACTIONS(3587),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_interface] = ACTIONS(3587),
    [anon_sym_delegate] = ACTIONS(3587),
    [anon_sym_record] = ACTIONS(3587),
    [anon_sym_abstract] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(3587),
    [anon_sym_const] = ACTIONS(3587),
    [anon_sym_file] = ACTIONS(3587),
    [anon_sym_fixed] = ACTIONS(3587),
    [anon_sym_internal] = ACTIONS(3587),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_override] = ACTIONS(3587),
    [anon_sym_partial] = ACTIONS(3587),
    [anon_sym_private] = ACTIONS(3587),
    [anon_sym_protected] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3587),
    [anon_sym_readonly] = ACTIONS(3587),
    [anon_sym_required] = ACTIONS(3587),
    [anon_sym_sealed] = ACTIONS(3587),
    [anon_sym_virtual] = ACTIONS(3587),
    [anon_sym_volatile] = ACTIONS(3587),
    [anon_sym_where] = ACTIONS(3587),
    [anon_sym_notnull] = ACTIONS(3587),
    [anon_sym_unmanaged] = ACTIONS(3587),
    [anon_sym_TILDE] = ACTIONS(3589),
    [anon_sym_implicit] = ACTIONS(3587),
    [anon_sym_explicit] = ACTIONS(3587),
    [anon_sym_scoped] = ACTIONS(3587),
    [anon_sym_var] = ACTIONS(3587),
    [sym_predefined_type] = ACTIONS(3587),
    [anon_sym_yield] = ACTIONS(3587),
    [anon_sym_when] = ACTIONS(3587),
    [anon_sym_from] = ACTIONS(3587),
    [anon_sym_into] = ACTIONS(3587),
    [anon_sym_join] = ACTIONS(3587),
    [anon_sym_on] = ACTIONS(3587),
    [anon_sym_equals] = ACTIONS(3587),
    [anon_sym_let] = ACTIONS(3587),
    [anon_sym_orderby] = ACTIONS(3587),
    [anon_sym_ascending] = ACTIONS(3587),
    [anon_sym_descending] = ACTIONS(3587),
    [anon_sym_group] = ACTIONS(3587),
    [anon_sym_by] = ACTIONS(3587),
    [anon_sym_select] = ACTIONS(3587),
    [aux_sym_preproc_if_token1] = ACTIONS(3589),
    [aux_sym_preproc_if_token3] = ACTIONS(3589),
    [aux_sym_preproc_else_token1] = ACTIONS(3589),
    [aux_sym_preproc_elif_token1] = ACTIONS(3589),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3358] = {
    [sym_preproc_region] = STATE(3358),
    [sym_preproc_endregion] = STATE(3358),
    [sym_preproc_line] = STATE(3358),
    [sym_preproc_pragma] = STATE(3358),
    [sym_preproc_nullable] = STATE(3358),
    [sym_preproc_error] = STATE(3358),
    [sym_preproc_define] = STATE(3358),
    [sym_preproc_undef] = STATE(3358),
    [sym__identifier_token] = ACTIONS(3603),
    [anon_sym_extern] = ACTIONS(3603),
    [anon_sym_alias] = ACTIONS(3603),
    [anon_sym_global] = ACTIONS(3603),
    [anon_sym_using] = ACTIONS(3603),
    [anon_sym_unsafe] = ACTIONS(3603),
    [anon_sym_static] = ACTIONS(3603),
    [anon_sym_LBRACK] = ACTIONS(3605),
    [anon_sym_LPAREN] = ACTIONS(3605),
    [anon_sym_event] = ACTIONS(3603),
    [anon_sym_namespace] = ACTIONS(3603),
    [anon_sym_class] = ACTIONS(3603),
    [anon_sym_ref] = ACTIONS(3603),
    [anon_sym_struct] = ACTIONS(3603),
    [anon_sym_enum] = ACTIONS(3603),
    [anon_sym_RBRACE] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(3603),
    [anon_sym_delegate] = ACTIONS(3603),
    [anon_sym_record] = ACTIONS(3603),
    [anon_sym_abstract] = ACTIONS(3603),
    [anon_sym_async] = ACTIONS(3603),
    [anon_sym_const] = ACTIONS(3603),
    [anon_sym_file] = ACTIONS(3603),
    [anon_sym_fixed] = ACTIONS(3603),
    [anon_sym_internal] = ACTIONS(3603),
    [anon_sym_new] = ACTIONS(3603),
    [anon_sym_override] = ACTIONS(3603),
    [anon_sym_partial] = ACTIONS(3603),
    [anon_sym_private] = ACTIONS(3603),
    [anon_sym_protected] = ACTIONS(3603),
    [anon_sym_public] = ACTIONS(3603),
    [anon_sym_readonly] = ACTIONS(3603),
    [anon_sym_required] = ACTIONS(3603),
    [anon_sym_sealed] = ACTIONS(3603),
    [anon_sym_virtual] = ACTIONS(3603),
    [anon_sym_volatile] = ACTIONS(3603),
    [anon_sym_where] = ACTIONS(3603),
    [anon_sym_notnull] = ACTIONS(3603),
    [anon_sym_unmanaged] = ACTIONS(3603),
    [anon_sym_TILDE] = ACTIONS(3605),
    [anon_sym_implicit] = ACTIONS(3603),
    [anon_sym_explicit] = ACTIONS(3603),
    [anon_sym_scoped] = ACTIONS(3603),
    [anon_sym_var] = ACTIONS(3603),
    [sym_predefined_type] = ACTIONS(3603),
    [anon_sym_yield] = ACTIONS(3603),
    [anon_sym_when] = ACTIONS(3603),
    [anon_sym_from] = ACTIONS(3603),
    [anon_sym_into] = ACTIONS(3603),
    [anon_sym_join] = ACTIONS(3603),
    [anon_sym_on] = ACTIONS(3603),
    [anon_sym_equals] = ACTIONS(3603),
    [anon_sym_let] = ACTIONS(3603),
    [anon_sym_orderby] = ACTIONS(3603),
    [anon_sym_ascending] = ACTIONS(3603),
    [anon_sym_descending] = ACTIONS(3603),
    [anon_sym_group] = ACTIONS(3603),
    [anon_sym_by] = ACTIONS(3603),
    [anon_sym_select] = ACTIONS(3603),
    [aux_sym_preproc_if_token1] = ACTIONS(3605),
    [aux_sym_preproc_if_token3] = ACTIONS(3605),
    [aux_sym_preproc_else_token1] = ACTIONS(3605),
    [aux_sym_preproc_elif_token1] = ACTIONS(3605),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3359] = {
    [sym_preproc_region] = STATE(3359),
    [sym_preproc_endregion] = STATE(3359),
    [sym_preproc_line] = STATE(3359),
    [sym_preproc_pragma] = STATE(3359),
    [sym_preproc_nullable] = STATE(3359),
    [sym_preproc_error] = STATE(3359),
    [sym_preproc_define] = STATE(3359),
    [sym_preproc_undef] = STATE(3359),
    [sym__identifier_token] = ACTIONS(3611),
    [anon_sym_extern] = ACTIONS(3611),
    [anon_sym_alias] = ACTIONS(3611),
    [anon_sym_global] = ACTIONS(3611),
    [anon_sym_using] = ACTIONS(3611),
    [anon_sym_unsafe] = ACTIONS(3611),
    [anon_sym_static] = ACTIONS(3611),
    [anon_sym_LBRACK] = ACTIONS(3613),
    [anon_sym_LPAREN] = ACTIONS(3613),
    [anon_sym_event] = ACTIONS(3611),
    [anon_sym_namespace] = ACTIONS(3611),
    [anon_sym_class] = ACTIONS(3611),
    [anon_sym_ref] = ACTIONS(3611),
    [anon_sym_struct] = ACTIONS(3611),
    [anon_sym_enum] = ACTIONS(3611),
    [anon_sym_RBRACE] = ACTIONS(3613),
    [anon_sym_interface] = ACTIONS(3611),
    [anon_sym_delegate] = ACTIONS(3611),
    [anon_sym_record] = ACTIONS(3611),
    [anon_sym_abstract] = ACTIONS(3611),
    [anon_sym_async] = ACTIONS(3611),
    [anon_sym_const] = ACTIONS(3611),
    [anon_sym_file] = ACTIONS(3611),
    [anon_sym_fixed] = ACTIONS(3611),
    [anon_sym_internal] = ACTIONS(3611),
    [anon_sym_new] = ACTIONS(3611),
    [anon_sym_override] = ACTIONS(3611),
    [anon_sym_partial] = ACTIONS(3611),
    [anon_sym_private] = ACTIONS(3611),
    [anon_sym_protected] = ACTIONS(3611),
    [anon_sym_public] = ACTIONS(3611),
    [anon_sym_readonly] = ACTIONS(3611),
    [anon_sym_required] = ACTIONS(3611),
    [anon_sym_sealed] = ACTIONS(3611),
    [anon_sym_virtual] = ACTIONS(3611),
    [anon_sym_volatile] = ACTIONS(3611),
    [anon_sym_where] = ACTIONS(3611),
    [anon_sym_notnull] = ACTIONS(3611),
    [anon_sym_unmanaged] = ACTIONS(3611),
    [anon_sym_TILDE] = ACTIONS(3613),
    [anon_sym_implicit] = ACTIONS(3611),
    [anon_sym_explicit] = ACTIONS(3611),
    [anon_sym_scoped] = ACTIONS(3611),
    [anon_sym_var] = ACTIONS(3611),
    [sym_predefined_type] = ACTIONS(3611),
    [anon_sym_yield] = ACTIONS(3611),
    [anon_sym_when] = ACTIONS(3611),
    [anon_sym_from] = ACTIONS(3611),
    [anon_sym_into] = ACTIONS(3611),
    [anon_sym_join] = ACTIONS(3611),
    [anon_sym_on] = ACTIONS(3611),
    [anon_sym_equals] = ACTIONS(3611),
    [anon_sym_let] = ACTIONS(3611),
    [anon_sym_orderby] = ACTIONS(3611),
    [anon_sym_ascending] = ACTIONS(3611),
    [anon_sym_descending] = ACTIONS(3611),
    [anon_sym_group] = ACTIONS(3611),
    [anon_sym_by] = ACTIONS(3611),
    [anon_sym_select] = ACTIONS(3611),
    [aux_sym_preproc_if_token1] = ACTIONS(3613),
    [aux_sym_preproc_if_token3] = ACTIONS(3613),
    [aux_sym_preproc_else_token1] = ACTIONS(3613),
    [aux_sym_preproc_elif_token1] = ACTIONS(3613),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3360] = {
    [sym_preproc_region] = STATE(3360),
    [sym_preproc_endregion] = STATE(3360),
    [sym_preproc_line] = STATE(3360),
    [sym_preproc_pragma] = STATE(3360),
    [sym_preproc_nullable] = STATE(3360),
    [sym_preproc_error] = STATE(3360),
    [sym_preproc_define] = STATE(3360),
    [sym_preproc_undef] = STATE(3360),
    [sym__identifier_token] = ACTIONS(3623),
    [anon_sym_extern] = ACTIONS(3623),
    [anon_sym_alias] = ACTIONS(3623),
    [anon_sym_global] = ACTIONS(3623),
    [anon_sym_using] = ACTIONS(3623),
    [anon_sym_unsafe] = ACTIONS(3623),
    [anon_sym_static] = ACTIONS(3623),
    [anon_sym_LBRACK] = ACTIONS(3625),
    [anon_sym_LPAREN] = ACTIONS(3625),
    [anon_sym_event] = ACTIONS(3623),
    [anon_sym_namespace] = ACTIONS(3623),
    [anon_sym_class] = ACTIONS(3623),
    [anon_sym_ref] = ACTIONS(3623),
    [anon_sym_struct] = ACTIONS(3623),
    [anon_sym_enum] = ACTIONS(3623),
    [anon_sym_RBRACE] = ACTIONS(3625),
    [anon_sym_interface] = ACTIONS(3623),
    [anon_sym_delegate] = ACTIONS(3623),
    [anon_sym_record] = ACTIONS(3623),
    [anon_sym_abstract] = ACTIONS(3623),
    [anon_sym_async] = ACTIONS(3623),
    [anon_sym_const] = ACTIONS(3623),
    [anon_sym_file] = ACTIONS(3623),
    [anon_sym_fixed] = ACTIONS(3623),
    [anon_sym_internal] = ACTIONS(3623),
    [anon_sym_new] = ACTIONS(3623),
    [anon_sym_override] = ACTIONS(3623),
    [anon_sym_partial] = ACTIONS(3623),
    [anon_sym_private] = ACTIONS(3623),
    [anon_sym_protected] = ACTIONS(3623),
    [anon_sym_public] = ACTIONS(3623),
    [anon_sym_readonly] = ACTIONS(3623),
    [anon_sym_required] = ACTIONS(3623),
    [anon_sym_sealed] = ACTIONS(3623),
    [anon_sym_virtual] = ACTIONS(3623),
    [anon_sym_volatile] = ACTIONS(3623),
    [anon_sym_where] = ACTIONS(3623),
    [anon_sym_notnull] = ACTIONS(3623),
    [anon_sym_unmanaged] = ACTIONS(3623),
    [anon_sym_TILDE] = ACTIONS(3625),
    [anon_sym_implicit] = ACTIONS(3623),
    [anon_sym_explicit] = ACTIONS(3623),
    [anon_sym_scoped] = ACTIONS(3623),
    [anon_sym_var] = ACTIONS(3623),
    [sym_predefined_type] = ACTIONS(3623),
    [anon_sym_yield] = ACTIONS(3623),
    [anon_sym_when] = ACTIONS(3623),
    [anon_sym_from] = ACTIONS(3623),
    [anon_sym_into] = ACTIONS(3623),
    [anon_sym_join] = ACTIONS(3623),
    [anon_sym_on] = ACTIONS(3623),
    [anon_sym_equals] = ACTIONS(3623),
    [anon_sym_let] = ACTIONS(3623),
    [anon_sym_orderby] = ACTIONS(3623),
    [anon_sym_ascending] = ACTIONS(3623),
    [anon_sym_descending] = ACTIONS(3623),
    [anon_sym_group] = ACTIONS(3623),
    [anon_sym_by] = ACTIONS(3623),
    [anon_sym_select] = ACTIONS(3623),
    [aux_sym_preproc_if_token1] = ACTIONS(3625),
    [aux_sym_preproc_if_token3] = ACTIONS(3625),
    [aux_sym_preproc_else_token1] = ACTIONS(3625),
    [aux_sym_preproc_elif_token1] = ACTIONS(3625),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3361] = {
    [sym_preproc_region] = STATE(3361),
    [sym_preproc_endregion] = STATE(3361),
    [sym_preproc_line] = STATE(3361),
    [sym_preproc_pragma] = STATE(3361),
    [sym_preproc_nullable] = STATE(3361),
    [sym_preproc_error] = STATE(3361),
    [sym_preproc_define] = STATE(3361),
    [sym_preproc_undef] = STATE(3361),
    [sym__identifier_token] = ACTIONS(3647),
    [anon_sym_extern] = ACTIONS(3647),
    [anon_sym_alias] = ACTIONS(3647),
    [anon_sym_global] = ACTIONS(3647),
    [anon_sym_using] = ACTIONS(3647),
    [anon_sym_unsafe] = ACTIONS(3647),
    [anon_sym_static] = ACTIONS(3647),
    [anon_sym_LBRACK] = ACTIONS(3649),
    [anon_sym_LPAREN] = ACTIONS(3649),
    [anon_sym_event] = ACTIONS(3647),
    [anon_sym_namespace] = ACTIONS(3647),
    [anon_sym_class] = ACTIONS(3647),
    [anon_sym_ref] = ACTIONS(3647),
    [anon_sym_struct] = ACTIONS(3647),
    [anon_sym_enum] = ACTIONS(3647),
    [anon_sym_RBRACE] = ACTIONS(3649),
    [anon_sym_interface] = ACTIONS(3647),
    [anon_sym_delegate] = ACTIONS(3647),
    [anon_sym_record] = ACTIONS(3647),
    [anon_sym_abstract] = ACTIONS(3647),
    [anon_sym_async] = ACTIONS(3647),
    [anon_sym_const] = ACTIONS(3647),
    [anon_sym_file] = ACTIONS(3647),
    [anon_sym_fixed] = ACTIONS(3647),
    [anon_sym_internal] = ACTIONS(3647),
    [anon_sym_new] = ACTIONS(3647),
    [anon_sym_override] = ACTIONS(3647),
    [anon_sym_partial] = ACTIONS(3647),
    [anon_sym_private] = ACTIONS(3647),
    [anon_sym_protected] = ACTIONS(3647),
    [anon_sym_public] = ACTIONS(3647),
    [anon_sym_readonly] = ACTIONS(3647),
    [anon_sym_required] = ACTIONS(3647),
    [anon_sym_sealed] = ACTIONS(3647),
    [anon_sym_virtual] = ACTIONS(3647),
    [anon_sym_volatile] = ACTIONS(3647),
    [anon_sym_where] = ACTIONS(3647),
    [anon_sym_notnull] = ACTIONS(3647),
    [anon_sym_unmanaged] = ACTIONS(3647),
    [anon_sym_TILDE] = ACTIONS(3649),
    [anon_sym_implicit] = ACTIONS(3647),
    [anon_sym_explicit] = ACTIONS(3647),
    [anon_sym_scoped] = ACTIONS(3647),
    [anon_sym_var] = ACTIONS(3647),
    [sym_predefined_type] = ACTIONS(3647),
    [anon_sym_yield] = ACTIONS(3647),
    [anon_sym_when] = ACTIONS(3647),
    [anon_sym_from] = ACTIONS(3647),
    [anon_sym_into] = ACTIONS(3647),
    [anon_sym_join] = ACTIONS(3647),
    [anon_sym_on] = ACTIONS(3647),
    [anon_sym_equals] = ACTIONS(3647),
    [anon_sym_let] = ACTIONS(3647),
    [anon_sym_orderby] = ACTIONS(3647),
    [anon_sym_ascending] = ACTIONS(3647),
    [anon_sym_descending] = ACTIONS(3647),
    [anon_sym_group] = ACTIONS(3647),
    [anon_sym_by] = ACTIONS(3647),
    [anon_sym_select] = ACTIONS(3647),
    [aux_sym_preproc_if_token1] = ACTIONS(3649),
    [aux_sym_preproc_if_token3] = ACTIONS(3649),
    [aux_sym_preproc_else_token1] = ACTIONS(3649),
    [aux_sym_preproc_elif_token1] = ACTIONS(3649),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3362] = {
    [sym_preproc_region] = STATE(3362),
    [sym_preproc_endregion] = STATE(3362),
    [sym_preproc_line] = STATE(3362),
    [sym_preproc_pragma] = STATE(3362),
    [sym_preproc_nullable] = STATE(3362),
    [sym_preproc_error] = STATE(3362),
    [sym_preproc_define] = STATE(3362),
    [sym_preproc_undef] = STATE(3362),
    [sym__identifier_token] = ACTIONS(4471),
    [anon_sym_alias] = ACTIONS(4471),
    [anon_sym_global] = ACTIONS(4471),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_file] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_where] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_notnull] = ACTIONS(4471),
    [anon_sym_unmanaged] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_scoped] = ACTIONS(4471),
    [anon_sym_var] = ACTIONS(4471),
    [anon_sym_yield] = ACTIONS(4471),
    [anon_sym_switch] = ACTIONS(4471),
    [anon_sym_when] = ACTIONS(4471),
    [sym_discard] = ACTIONS(4471),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4471),
    [anon_sym_or] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_from] = ACTIONS(4471),
    [anon_sym_into] = ACTIONS(4471),
    [anon_sym_join] = ACTIONS(4471),
    [anon_sym_on] = ACTIONS(4471),
    [anon_sym_equals] = ACTIONS(4471),
    [anon_sym_let] = ACTIONS(4471),
    [anon_sym_orderby] = ACTIONS(4471),
    [anon_sym_ascending] = ACTIONS(4471),
    [anon_sym_descending] = ACTIONS(4471),
    [anon_sym_group] = ACTIONS(4471),
    [anon_sym_by] = ACTIONS(4471),
    [anon_sym_select] = ACTIONS(4471),
    [anon_sym_as] = ACTIONS(4471),
    [anon_sym_is] = ACTIONS(4471),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4471),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4473),
  },
  [3363] = {
    [sym_preproc_region] = STATE(3363),
    [sym_preproc_endregion] = STATE(3363),
    [sym_preproc_line] = STATE(3363),
    [sym_preproc_pragma] = STATE(3363),
    [sym_preproc_nullable] = STATE(3363),
    [sym_preproc_error] = STATE(3363),
    [sym_preproc_define] = STATE(3363),
    [sym_preproc_undef] = STATE(3363),
    [sym__identifier_token] = ACTIONS(4134),
    [anon_sym_alias] = ACTIONS(4134),
    [anon_sym_global] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_file] = ACTIONS(4134),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_notnull] = ACTIONS(4134),
    [anon_sym_unmanaged] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_scoped] = ACTIONS(4134),
    [anon_sym_var] = ACTIONS(4134),
    [anon_sym_yield] = ACTIONS(4134),
    [anon_sym_switch] = ACTIONS(4134),
    [anon_sym_when] = ACTIONS(4134),
    [sym_discard] = ACTIONS(4134),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_from] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4134),
    [anon_sym_join] = ACTIONS(4134),
    [anon_sym_on] = ACTIONS(4134),
    [anon_sym_equals] = ACTIONS(4134),
    [anon_sym_let] = ACTIONS(4134),
    [anon_sym_orderby] = ACTIONS(4134),
    [anon_sym_ascending] = ACTIONS(4134),
    [anon_sym_descending] = ACTIONS(4134),
    [anon_sym_group] = ACTIONS(4134),
    [anon_sym_by] = ACTIONS(4134),
    [anon_sym_select] = ACTIONS(4134),
    [anon_sym_as] = ACTIONS(4134),
    [anon_sym_is] = ACTIONS(4134),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4134),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4136),
  },
  [3364] = {
    [sym_preproc_region] = STATE(3364),
    [sym_preproc_endregion] = STATE(3364),
    [sym_preproc_line] = STATE(3364),
    [sym_preproc_pragma] = STATE(3364),
    [sym_preproc_nullable] = STATE(3364),
    [sym_preproc_error] = STATE(3364),
    [sym_preproc_define] = STATE(3364),
    [sym_preproc_undef] = STATE(3364),
    [sym__identifier_token] = ACTIONS(3651),
    [anon_sym_extern] = ACTIONS(3651),
    [anon_sym_alias] = ACTIONS(3651),
    [anon_sym_global] = ACTIONS(3651),
    [anon_sym_using] = ACTIONS(3651),
    [anon_sym_unsafe] = ACTIONS(3651),
    [anon_sym_static] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_event] = ACTIONS(3651),
    [anon_sym_namespace] = ACTIONS(3651),
    [anon_sym_class] = ACTIONS(3651),
    [anon_sym_ref] = ACTIONS(3651),
    [anon_sym_struct] = ACTIONS(3651),
    [anon_sym_enum] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_interface] = ACTIONS(3651),
    [anon_sym_delegate] = ACTIONS(3651),
    [anon_sym_record] = ACTIONS(3651),
    [anon_sym_abstract] = ACTIONS(3651),
    [anon_sym_async] = ACTIONS(3651),
    [anon_sym_const] = ACTIONS(3651),
    [anon_sym_file] = ACTIONS(3651),
    [anon_sym_fixed] = ACTIONS(3651),
    [anon_sym_internal] = ACTIONS(3651),
    [anon_sym_new] = ACTIONS(3651),
    [anon_sym_override] = ACTIONS(3651),
    [anon_sym_partial] = ACTIONS(3651),
    [anon_sym_private] = ACTIONS(3651),
    [anon_sym_protected] = ACTIONS(3651),
    [anon_sym_public] = ACTIONS(3651),
    [anon_sym_readonly] = ACTIONS(3651),
    [anon_sym_required] = ACTIONS(3651),
    [anon_sym_sealed] = ACTIONS(3651),
    [anon_sym_virtual] = ACTIONS(3651),
    [anon_sym_volatile] = ACTIONS(3651),
    [anon_sym_where] = ACTIONS(3651),
    [anon_sym_notnull] = ACTIONS(3651),
    [anon_sym_unmanaged] = ACTIONS(3651),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_implicit] = ACTIONS(3651),
    [anon_sym_explicit] = ACTIONS(3651),
    [anon_sym_scoped] = ACTIONS(3651),
    [anon_sym_var] = ACTIONS(3651),
    [sym_predefined_type] = ACTIONS(3651),
    [anon_sym_yield] = ACTIONS(3651),
    [anon_sym_when] = ACTIONS(3651),
    [anon_sym_from] = ACTIONS(3651),
    [anon_sym_into] = ACTIONS(3651),
    [anon_sym_join] = ACTIONS(3651),
    [anon_sym_on] = ACTIONS(3651),
    [anon_sym_equals] = ACTIONS(3651),
    [anon_sym_let] = ACTIONS(3651),
    [anon_sym_orderby] = ACTIONS(3651),
    [anon_sym_ascending] = ACTIONS(3651),
    [anon_sym_descending] = ACTIONS(3651),
    [anon_sym_group] = ACTIONS(3651),
    [anon_sym_by] = ACTIONS(3651),
    [anon_sym_select] = ACTIONS(3651),
    [aux_sym_preproc_if_token1] = ACTIONS(3653),
    [aux_sym_preproc_if_token3] = ACTIONS(3653),
    [aux_sym_preproc_else_token1] = ACTIONS(3653),
    [aux_sym_preproc_elif_token1] = ACTIONS(3653),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3365] = {
    [sym_preproc_region] = STATE(3365),
    [sym_preproc_endregion] = STATE(3365),
    [sym_preproc_line] = STATE(3365),
    [sym_preproc_pragma] = STATE(3365),
    [sym_preproc_nullable] = STATE(3365),
    [sym_preproc_error] = STATE(3365),
    [sym_preproc_define] = STATE(3365),
    [sym_preproc_undef] = STATE(3365),
    [sym__identifier_token] = ACTIONS(3659),
    [anon_sym_extern] = ACTIONS(3659),
    [anon_sym_alias] = ACTIONS(3659),
    [anon_sym_global] = ACTIONS(3659),
    [anon_sym_using] = ACTIONS(3659),
    [anon_sym_unsafe] = ACTIONS(3659),
    [anon_sym_static] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [anon_sym_LPAREN] = ACTIONS(3661),
    [anon_sym_event] = ACTIONS(3659),
    [anon_sym_namespace] = ACTIONS(3659),
    [anon_sym_class] = ACTIONS(3659),
    [anon_sym_ref] = ACTIONS(3659),
    [anon_sym_struct] = ACTIONS(3659),
    [anon_sym_enum] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3659),
    [anon_sym_delegate] = ACTIONS(3659),
    [anon_sym_record] = ACTIONS(3659),
    [anon_sym_abstract] = ACTIONS(3659),
    [anon_sym_async] = ACTIONS(3659),
    [anon_sym_const] = ACTIONS(3659),
    [anon_sym_file] = ACTIONS(3659),
    [anon_sym_fixed] = ACTIONS(3659),
    [anon_sym_internal] = ACTIONS(3659),
    [anon_sym_new] = ACTIONS(3659),
    [anon_sym_override] = ACTIONS(3659),
    [anon_sym_partial] = ACTIONS(3659),
    [anon_sym_private] = ACTIONS(3659),
    [anon_sym_protected] = ACTIONS(3659),
    [anon_sym_public] = ACTIONS(3659),
    [anon_sym_readonly] = ACTIONS(3659),
    [anon_sym_required] = ACTIONS(3659),
    [anon_sym_sealed] = ACTIONS(3659),
    [anon_sym_virtual] = ACTIONS(3659),
    [anon_sym_volatile] = ACTIONS(3659),
    [anon_sym_where] = ACTIONS(3659),
    [anon_sym_notnull] = ACTIONS(3659),
    [anon_sym_unmanaged] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_implicit] = ACTIONS(3659),
    [anon_sym_explicit] = ACTIONS(3659),
    [anon_sym_scoped] = ACTIONS(3659),
    [anon_sym_var] = ACTIONS(3659),
    [sym_predefined_type] = ACTIONS(3659),
    [anon_sym_yield] = ACTIONS(3659),
    [anon_sym_when] = ACTIONS(3659),
    [anon_sym_from] = ACTIONS(3659),
    [anon_sym_into] = ACTIONS(3659),
    [anon_sym_join] = ACTIONS(3659),
    [anon_sym_on] = ACTIONS(3659),
    [anon_sym_equals] = ACTIONS(3659),
    [anon_sym_let] = ACTIONS(3659),
    [anon_sym_orderby] = ACTIONS(3659),
    [anon_sym_ascending] = ACTIONS(3659),
    [anon_sym_descending] = ACTIONS(3659),
    [anon_sym_group] = ACTIONS(3659),
    [anon_sym_by] = ACTIONS(3659),
    [anon_sym_select] = ACTIONS(3659),
    [aux_sym_preproc_if_token1] = ACTIONS(3661),
    [aux_sym_preproc_if_token3] = ACTIONS(3661),
    [aux_sym_preproc_else_token1] = ACTIONS(3661),
    [aux_sym_preproc_elif_token1] = ACTIONS(3661),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3366] = {
    [sym_preproc_region] = STATE(3366),
    [sym_preproc_endregion] = STATE(3366),
    [sym_preproc_line] = STATE(3366),
    [sym_preproc_pragma] = STATE(3366),
    [sym_preproc_nullable] = STATE(3366),
    [sym_preproc_error] = STATE(3366),
    [sym_preproc_define] = STATE(3366),
    [sym_preproc_undef] = STATE(3366),
    [sym__identifier_token] = ACTIONS(3675),
    [anon_sym_extern] = ACTIONS(3675),
    [anon_sym_alias] = ACTIONS(3675),
    [anon_sym_global] = ACTIONS(3675),
    [anon_sym_using] = ACTIONS(3675),
    [anon_sym_unsafe] = ACTIONS(3675),
    [anon_sym_static] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_event] = ACTIONS(3675),
    [anon_sym_namespace] = ACTIONS(3675),
    [anon_sym_class] = ACTIONS(3675),
    [anon_sym_ref] = ACTIONS(3675),
    [anon_sym_struct] = ACTIONS(3675),
    [anon_sym_enum] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_interface] = ACTIONS(3675),
    [anon_sym_delegate] = ACTIONS(3675),
    [anon_sym_record] = ACTIONS(3675),
    [anon_sym_abstract] = ACTIONS(3675),
    [anon_sym_async] = ACTIONS(3675),
    [anon_sym_const] = ACTIONS(3675),
    [anon_sym_file] = ACTIONS(3675),
    [anon_sym_fixed] = ACTIONS(3675),
    [anon_sym_internal] = ACTIONS(3675),
    [anon_sym_new] = ACTIONS(3675),
    [anon_sym_override] = ACTIONS(3675),
    [anon_sym_partial] = ACTIONS(3675),
    [anon_sym_private] = ACTIONS(3675),
    [anon_sym_protected] = ACTIONS(3675),
    [anon_sym_public] = ACTIONS(3675),
    [anon_sym_readonly] = ACTIONS(3675),
    [anon_sym_required] = ACTIONS(3675),
    [anon_sym_sealed] = ACTIONS(3675),
    [anon_sym_virtual] = ACTIONS(3675),
    [anon_sym_volatile] = ACTIONS(3675),
    [anon_sym_where] = ACTIONS(3675),
    [anon_sym_notnull] = ACTIONS(3675),
    [anon_sym_unmanaged] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3677),
    [anon_sym_implicit] = ACTIONS(3675),
    [anon_sym_explicit] = ACTIONS(3675),
    [anon_sym_scoped] = ACTIONS(3675),
    [anon_sym_var] = ACTIONS(3675),
    [sym_predefined_type] = ACTIONS(3675),
    [anon_sym_yield] = ACTIONS(3675),
    [anon_sym_when] = ACTIONS(3675),
    [anon_sym_from] = ACTIONS(3675),
    [anon_sym_into] = ACTIONS(3675),
    [anon_sym_join] = ACTIONS(3675),
    [anon_sym_on] = ACTIONS(3675),
    [anon_sym_equals] = ACTIONS(3675),
    [anon_sym_let] = ACTIONS(3675),
    [anon_sym_orderby] = ACTIONS(3675),
    [anon_sym_ascending] = ACTIONS(3675),
    [anon_sym_descending] = ACTIONS(3675),
    [anon_sym_group] = ACTIONS(3675),
    [anon_sym_by] = ACTIONS(3675),
    [anon_sym_select] = ACTIONS(3675),
    [aux_sym_preproc_if_token1] = ACTIONS(3677),
    [aux_sym_preproc_if_token3] = ACTIONS(3677),
    [aux_sym_preproc_else_token1] = ACTIONS(3677),
    [aux_sym_preproc_elif_token1] = ACTIONS(3677),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3367] = {
    [sym_preproc_region] = STATE(3367),
    [sym_preproc_endregion] = STATE(3367),
    [sym_preproc_line] = STATE(3367),
    [sym_preproc_pragma] = STATE(3367),
    [sym_preproc_nullable] = STATE(3367),
    [sym_preproc_error] = STATE(3367),
    [sym_preproc_define] = STATE(3367),
    [sym_preproc_undef] = STATE(3367),
    [sym__identifier_token] = ACTIONS(3679),
    [anon_sym_extern] = ACTIONS(3679),
    [anon_sym_alias] = ACTIONS(3679),
    [anon_sym_global] = ACTIONS(3679),
    [anon_sym_using] = ACTIONS(3679),
    [anon_sym_unsafe] = ACTIONS(3679),
    [anon_sym_static] = ACTIONS(3679),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_LPAREN] = ACTIONS(3681),
    [anon_sym_event] = ACTIONS(3679),
    [anon_sym_namespace] = ACTIONS(3679),
    [anon_sym_class] = ACTIONS(3679),
    [anon_sym_ref] = ACTIONS(3679),
    [anon_sym_struct] = ACTIONS(3679),
    [anon_sym_enum] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_interface] = ACTIONS(3679),
    [anon_sym_delegate] = ACTIONS(3679),
    [anon_sym_record] = ACTIONS(3679),
    [anon_sym_abstract] = ACTIONS(3679),
    [anon_sym_async] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3679),
    [anon_sym_file] = ACTIONS(3679),
    [anon_sym_fixed] = ACTIONS(3679),
    [anon_sym_internal] = ACTIONS(3679),
    [anon_sym_new] = ACTIONS(3679),
    [anon_sym_override] = ACTIONS(3679),
    [anon_sym_partial] = ACTIONS(3679),
    [anon_sym_private] = ACTIONS(3679),
    [anon_sym_protected] = ACTIONS(3679),
    [anon_sym_public] = ACTIONS(3679),
    [anon_sym_readonly] = ACTIONS(3679),
    [anon_sym_required] = ACTIONS(3679),
    [anon_sym_sealed] = ACTIONS(3679),
    [anon_sym_virtual] = ACTIONS(3679),
    [anon_sym_volatile] = ACTIONS(3679),
    [anon_sym_where] = ACTIONS(3679),
    [anon_sym_notnull] = ACTIONS(3679),
    [anon_sym_unmanaged] = ACTIONS(3679),
    [anon_sym_TILDE] = ACTIONS(3681),
    [anon_sym_implicit] = ACTIONS(3679),
    [anon_sym_explicit] = ACTIONS(3679),
    [anon_sym_scoped] = ACTIONS(3679),
    [anon_sym_var] = ACTIONS(3679),
    [sym_predefined_type] = ACTIONS(3679),
    [anon_sym_yield] = ACTIONS(3679),
    [anon_sym_when] = ACTIONS(3679),
    [anon_sym_from] = ACTIONS(3679),
    [anon_sym_into] = ACTIONS(3679),
    [anon_sym_join] = ACTIONS(3679),
    [anon_sym_on] = ACTIONS(3679),
    [anon_sym_equals] = ACTIONS(3679),
    [anon_sym_let] = ACTIONS(3679),
    [anon_sym_orderby] = ACTIONS(3679),
    [anon_sym_ascending] = ACTIONS(3679),
    [anon_sym_descending] = ACTIONS(3679),
    [anon_sym_group] = ACTIONS(3679),
    [anon_sym_by] = ACTIONS(3679),
    [anon_sym_select] = ACTIONS(3679),
    [aux_sym_preproc_if_token1] = ACTIONS(3681),
    [aux_sym_preproc_if_token3] = ACTIONS(3681),
    [aux_sym_preproc_else_token1] = ACTIONS(3681),
    [aux_sym_preproc_elif_token1] = ACTIONS(3681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3368] = {
    [sym_preproc_region] = STATE(3368),
    [sym_preproc_endregion] = STATE(3368),
    [sym_preproc_line] = STATE(3368),
    [sym_preproc_pragma] = STATE(3368),
    [sym_preproc_nullable] = STATE(3368),
    [sym_preproc_error] = STATE(3368),
    [sym_preproc_define] = STATE(3368),
    [sym_preproc_undef] = STATE(3368),
    [sym__identifier_token] = ACTIONS(4943),
    [anon_sym_extern] = ACTIONS(4943),
    [anon_sym_alias] = ACTIONS(4943),
    [anon_sym_global] = ACTIONS(4943),
    [anon_sym_using] = ACTIONS(4943),
    [anon_sym_unsafe] = ACTIONS(4943),
    [anon_sym_static] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_LPAREN] = ACTIONS(4945),
    [anon_sym_event] = ACTIONS(4943),
    [anon_sym_namespace] = ACTIONS(4943),
    [anon_sym_class] = ACTIONS(4943),
    [anon_sym_ref] = ACTIONS(4943),
    [anon_sym_struct] = ACTIONS(4943),
    [anon_sym_enum] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [anon_sym_interface] = ACTIONS(4943),
    [anon_sym_delegate] = ACTIONS(4943),
    [anon_sym_record] = ACTIONS(4943),
    [anon_sym_abstract] = ACTIONS(4943),
    [anon_sym_async] = ACTIONS(4943),
    [anon_sym_const] = ACTIONS(4943),
    [anon_sym_file] = ACTIONS(4943),
    [anon_sym_fixed] = ACTIONS(4943),
    [anon_sym_internal] = ACTIONS(4943),
    [anon_sym_new] = ACTIONS(4943),
    [anon_sym_override] = ACTIONS(4943),
    [anon_sym_partial] = ACTIONS(4943),
    [anon_sym_private] = ACTIONS(4943),
    [anon_sym_protected] = ACTIONS(4943),
    [anon_sym_public] = ACTIONS(4943),
    [anon_sym_readonly] = ACTIONS(4943),
    [anon_sym_required] = ACTIONS(4943),
    [anon_sym_sealed] = ACTIONS(4943),
    [anon_sym_virtual] = ACTIONS(4943),
    [anon_sym_volatile] = ACTIONS(4943),
    [anon_sym_where] = ACTIONS(4943),
    [anon_sym_notnull] = ACTIONS(4943),
    [anon_sym_unmanaged] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4945),
    [anon_sym_implicit] = ACTIONS(4943),
    [anon_sym_explicit] = ACTIONS(4943),
    [anon_sym_scoped] = ACTIONS(4943),
    [anon_sym_var] = ACTIONS(4943),
    [sym_predefined_type] = ACTIONS(4943),
    [anon_sym_yield] = ACTIONS(4943),
    [anon_sym_when] = ACTIONS(4943),
    [anon_sym_from] = ACTIONS(4943),
    [anon_sym_into] = ACTIONS(4943),
    [anon_sym_join] = ACTIONS(4943),
    [anon_sym_on] = ACTIONS(4943),
    [anon_sym_equals] = ACTIONS(4943),
    [anon_sym_let] = ACTIONS(4943),
    [anon_sym_orderby] = ACTIONS(4943),
    [anon_sym_ascending] = ACTIONS(4943),
    [anon_sym_descending] = ACTIONS(4943),
    [anon_sym_group] = ACTIONS(4943),
    [anon_sym_by] = ACTIONS(4943),
    [anon_sym_select] = ACTIONS(4943),
    [aux_sym_preproc_if_token1] = ACTIONS(4945),
    [aux_sym_preproc_if_token3] = ACTIONS(4945),
    [aux_sym_preproc_else_token1] = ACTIONS(4945),
    [aux_sym_preproc_elif_token1] = ACTIONS(4945),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3369] = {
    [sym_preproc_region] = STATE(3369),
    [sym_preproc_endregion] = STATE(3369),
    [sym_preproc_line] = STATE(3369),
    [sym_preproc_pragma] = STATE(3369),
    [sym_preproc_nullable] = STATE(3369),
    [sym_preproc_error] = STATE(3369),
    [sym_preproc_define] = STATE(3369),
    [sym_preproc_undef] = STATE(3369),
    [sym__identifier_token] = ACTIONS(3719),
    [anon_sym_extern] = ACTIONS(3719),
    [anon_sym_alias] = ACTIONS(3719),
    [anon_sym_global] = ACTIONS(3719),
    [anon_sym_using] = ACTIONS(3719),
    [anon_sym_unsafe] = ACTIONS(3719),
    [anon_sym_static] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_LPAREN] = ACTIONS(3721),
    [anon_sym_event] = ACTIONS(3719),
    [anon_sym_namespace] = ACTIONS(3719),
    [anon_sym_class] = ACTIONS(3719),
    [anon_sym_ref] = ACTIONS(3719),
    [anon_sym_struct] = ACTIONS(3719),
    [anon_sym_enum] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3721),
    [anon_sym_interface] = ACTIONS(3719),
    [anon_sym_delegate] = ACTIONS(3719),
    [anon_sym_record] = ACTIONS(3719),
    [anon_sym_abstract] = ACTIONS(3719),
    [anon_sym_async] = ACTIONS(3719),
    [anon_sym_const] = ACTIONS(3719),
    [anon_sym_file] = ACTIONS(3719),
    [anon_sym_fixed] = ACTIONS(3719),
    [anon_sym_internal] = ACTIONS(3719),
    [anon_sym_new] = ACTIONS(3719),
    [anon_sym_override] = ACTIONS(3719),
    [anon_sym_partial] = ACTIONS(3719),
    [anon_sym_private] = ACTIONS(3719),
    [anon_sym_protected] = ACTIONS(3719),
    [anon_sym_public] = ACTIONS(3719),
    [anon_sym_readonly] = ACTIONS(3719),
    [anon_sym_required] = ACTIONS(3719),
    [anon_sym_sealed] = ACTIONS(3719),
    [anon_sym_virtual] = ACTIONS(3719),
    [anon_sym_volatile] = ACTIONS(3719),
    [anon_sym_where] = ACTIONS(3719),
    [anon_sym_notnull] = ACTIONS(3719),
    [anon_sym_unmanaged] = ACTIONS(3719),
    [anon_sym_TILDE] = ACTIONS(3721),
    [anon_sym_implicit] = ACTIONS(3719),
    [anon_sym_explicit] = ACTIONS(3719),
    [anon_sym_scoped] = ACTIONS(3719),
    [anon_sym_var] = ACTIONS(3719),
    [sym_predefined_type] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(3719),
    [anon_sym_when] = ACTIONS(3719),
    [anon_sym_from] = ACTIONS(3719),
    [anon_sym_into] = ACTIONS(3719),
    [anon_sym_join] = ACTIONS(3719),
    [anon_sym_on] = ACTIONS(3719),
    [anon_sym_equals] = ACTIONS(3719),
    [anon_sym_let] = ACTIONS(3719),
    [anon_sym_orderby] = ACTIONS(3719),
    [anon_sym_ascending] = ACTIONS(3719),
    [anon_sym_descending] = ACTIONS(3719),
    [anon_sym_group] = ACTIONS(3719),
    [anon_sym_by] = ACTIONS(3719),
    [anon_sym_select] = ACTIONS(3719),
    [aux_sym_preproc_if_token1] = ACTIONS(3721),
    [aux_sym_preproc_if_token3] = ACTIONS(3721),
    [aux_sym_preproc_else_token1] = ACTIONS(3721),
    [aux_sym_preproc_elif_token1] = ACTIONS(3721),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3370] = {
    [sym_preproc_region] = STATE(3370),
    [sym_preproc_endregion] = STATE(3370),
    [sym_preproc_line] = STATE(3370),
    [sym_preproc_pragma] = STATE(3370),
    [sym_preproc_nullable] = STATE(3370),
    [sym_preproc_error] = STATE(3370),
    [sym_preproc_define] = STATE(3370),
    [sym_preproc_undef] = STATE(3370),
    [sym__identifier_token] = ACTIONS(4142),
    [anon_sym_alias] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_file] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_notnull] = ACTIONS(4142),
    [anon_sym_unmanaged] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_scoped] = ACTIONS(4142),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_when] = ACTIONS(4142),
    [sym_discard] = ACTIONS(4142),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4142),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4142),
    [anon_sym_join] = ACTIONS(4142),
    [anon_sym_on] = ACTIONS(4142),
    [anon_sym_equals] = ACTIONS(4142),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_orderby] = ACTIONS(4142),
    [anon_sym_ascending] = ACTIONS(4142),
    [anon_sym_descending] = ACTIONS(4142),
    [anon_sym_group] = ACTIONS(4142),
    [anon_sym_by] = ACTIONS(4142),
    [anon_sym_select] = ACTIONS(4142),
    [anon_sym_as] = ACTIONS(4142),
    [anon_sym_is] = ACTIONS(4142),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4144),
  },
  [3371] = {
    [sym_preproc_region] = STATE(3371),
    [sym_preproc_endregion] = STATE(3371),
    [sym_preproc_line] = STATE(3371),
    [sym_preproc_pragma] = STATE(3371),
    [sym_preproc_nullable] = STATE(3371),
    [sym_preproc_error] = STATE(3371),
    [sym_preproc_define] = STATE(3371),
    [sym_preproc_undef] = STATE(3371),
    [sym__identifier_token] = ACTIONS(4138),
    [anon_sym_alias] = ACTIONS(4138),
    [anon_sym_global] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_file] = ACTIONS(4138),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_notnull] = ACTIONS(4138),
    [anon_sym_unmanaged] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_scoped] = ACTIONS(4138),
    [anon_sym_var] = ACTIONS(4138),
    [anon_sym_yield] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4138),
    [anon_sym_when] = ACTIONS(4138),
    [sym_discard] = ACTIONS(4138),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4138),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4138),
    [anon_sym_join] = ACTIONS(4138),
    [anon_sym_on] = ACTIONS(4138),
    [anon_sym_equals] = ACTIONS(4138),
    [anon_sym_let] = ACTIONS(4138),
    [anon_sym_orderby] = ACTIONS(4138),
    [anon_sym_ascending] = ACTIONS(4138),
    [anon_sym_descending] = ACTIONS(4138),
    [anon_sym_group] = ACTIONS(4138),
    [anon_sym_by] = ACTIONS(4138),
    [anon_sym_select] = ACTIONS(4138),
    [anon_sym_as] = ACTIONS(4138),
    [anon_sym_is] = ACTIONS(4138),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4138),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [3372] = {
    [sym_preproc_region] = STATE(3372),
    [sym_preproc_endregion] = STATE(3372),
    [sym_preproc_line] = STATE(3372),
    [sym_preproc_pragma] = STATE(3372),
    [sym_preproc_nullable] = STATE(3372),
    [sym_preproc_error] = STATE(3372),
    [sym_preproc_define] = STATE(3372),
    [sym_preproc_undef] = STATE(3372),
    [sym__identifier_token] = ACTIONS(3723),
    [anon_sym_extern] = ACTIONS(3723),
    [anon_sym_alias] = ACTIONS(3723),
    [anon_sym_global] = ACTIONS(3723),
    [anon_sym_using] = ACTIONS(3723),
    [anon_sym_unsafe] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [anon_sym_event] = ACTIONS(3723),
    [anon_sym_namespace] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(3723),
    [anon_sym_ref] = ACTIONS(3723),
    [anon_sym_struct] = ACTIONS(3723),
    [anon_sym_enum] = ACTIONS(3723),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3723),
    [anon_sym_delegate] = ACTIONS(3723),
    [anon_sym_record] = ACTIONS(3723),
    [anon_sym_abstract] = ACTIONS(3723),
    [anon_sym_async] = ACTIONS(3723),
    [anon_sym_const] = ACTIONS(3723),
    [anon_sym_file] = ACTIONS(3723),
    [anon_sym_fixed] = ACTIONS(3723),
    [anon_sym_internal] = ACTIONS(3723),
    [anon_sym_new] = ACTIONS(3723),
    [anon_sym_override] = ACTIONS(3723),
    [anon_sym_partial] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(3723),
    [anon_sym_protected] = ACTIONS(3723),
    [anon_sym_public] = ACTIONS(3723),
    [anon_sym_readonly] = ACTIONS(3723),
    [anon_sym_required] = ACTIONS(3723),
    [anon_sym_sealed] = ACTIONS(3723),
    [anon_sym_virtual] = ACTIONS(3723),
    [anon_sym_volatile] = ACTIONS(3723),
    [anon_sym_where] = ACTIONS(3723),
    [anon_sym_notnull] = ACTIONS(3723),
    [anon_sym_unmanaged] = ACTIONS(3723),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_implicit] = ACTIONS(3723),
    [anon_sym_explicit] = ACTIONS(3723),
    [anon_sym_scoped] = ACTIONS(3723),
    [anon_sym_var] = ACTIONS(3723),
    [sym_predefined_type] = ACTIONS(3723),
    [anon_sym_yield] = ACTIONS(3723),
    [anon_sym_when] = ACTIONS(3723),
    [anon_sym_from] = ACTIONS(3723),
    [anon_sym_into] = ACTIONS(3723),
    [anon_sym_join] = ACTIONS(3723),
    [anon_sym_on] = ACTIONS(3723),
    [anon_sym_equals] = ACTIONS(3723),
    [anon_sym_let] = ACTIONS(3723),
    [anon_sym_orderby] = ACTIONS(3723),
    [anon_sym_ascending] = ACTIONS(3723),
    [anon_sym_descending] = ACTIONS(3723),
    [anon_sym_group] = ACTIONS(3723),
    [anon_sym_by] = ACTIONS(3723),
    [anon_sym_select] = ACTIONS(3723),
    [aux_sym_preproc_if_token1] = ACTIONS(3725),
    [aux_sym_preproc_if_token3] = ACTIONS(3725),
    [aux_sym_preproc_else_token1] = ACTIONS(3725),
    [aux_sym_preproc_elif_token1] = ACTIONS(3725),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3373] = {
    [sym_preproc_region] = STATE(3373),
    [sym_preproc_endregion] = STATE(3373),
    [sym_preproc_line] = STATE(3373),
    [sym_preproc_pragma] = STATE(3373),
    [sym_preproc_nullable] = STATE(3373),
    [sym_preproc_error] = STATE(3373),
    [sym_preproc_define] = STATE(3373),
    [sym_preproc_undef] = STATE(3373),
    [sym__identifier_token] = ACTIONS(3751),
    [anon_sym_extern] = ACTIONS(3751),
    [anon_sym_alias] = ACTIONS(3751),
    [anon_sym_global] = ACTIONS(3751),
    [anon_sym_using] = ACTIONS(3751),
    [anon_sym_unsafe] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_event] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_ref] = ACTIONS(3751),
    [anon_sym_struct] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_delegate] = ACTIONS(3751),
    [anon_sym_record] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3751),
    [anon_sym_async] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [anon_sym_file] = ACTIONS(3751),
    [anon_sym_fixed] = ACTIONS(3751),
    [anon_sym_internal] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_override] = ACTIONS(3751),
    [anon_sym_partial] = ACTIONS(3751),
    [anon_sym_private] = ACTIONS(3751),
    [anon_sym_protected] = ACTIONS(3751),
    [anon_sym_public] = ACTIONS(3751),
    [anon_sym_readonly] = ACTIONS(3751),
    [anon_sym_required] = ACTIONS(3751),
    [anon_sym_sealed] = ACTIONS(3751),
    [anon_sym_virtual] = ACTIONS(3751),
    [anon_sym_volatile] = ACTIONS(3751),
    [anon_sym_where] = ACTIONS(3751),
    [anon_sym_notnull] = ACTIONS(3751),
    [anon_sym_unmanaged] = ACTIONS(3751),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_implicit] = ACTIONS(3751),
    [anon_sym_explicit] = ACTIONS(3751),
    [anon_sym_scoped] = ACTIONS(3751),
    [anon_sym_var] = ACTIONS(3751),
    [sym_predefined_type] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3751),
    [anon_sym_when] = ACTIONS(3751),
    [anon_sym_from] = ACTIONS(3751),
    [anon_sym_into] = ACTIONS(3751),
    [anon_sym_join] = ACTIONS(3751),
    [anon_sym_on] = ACTIONS(3751),
    [anon_sym_equals] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_orderby] = ACTIONS(3751),
    [anon_sym_ascending] = ACTIONS(3751),
    [anon_sym_descending] = ACTIONS(3751),
    [anon_sym_group] = ACTIONS(3751),
    [anon_sym_by] = ACTIONS(3751),
    [anon_sym_select] = ACTIONS(3751),
    [aux_sym_preproc_if_token1] = ACTIONS(3753),
    [aux_sym_preproc_if_token3] = ACTIONS(3753),
    [aux_sym_preproc_else_token1] = ACTIONS(3753),
    [aux_sym_preproc_elif_token1] = ACTIONS(3753),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3374] = {
    [sym_preproc_region] = STATE(3374),
    [sym_preproc_endregion] = STATE(3374),
    [sym_preproc_line] = STATE(3374),
    [sym_preproc_pragma] = STATE(3374),
    [sym_preproc_nullable] = STATE(3374),
    [sym_preproc_error] = STATE(3374),
    [sym_preproc_define] = STATE(3374),
    [sym_preproc_undef] = STATE(3374),
    [sym__identifier_token] = ACTIONS(3775),
    [anon_sym_extern] = ACTIONS(3775),
    [anon_sym_alias] = ACTIONS(3775),
    [anon_sym_global] = ACTIONS(3775),
    [anon_sym_using] = ACTIONS(3775),
    [anon_sym_unsafe] = ACTIONS(3775),
    [anon_sym_static] = ACTIONS(3775),
    [anon_sym_LBRACK] = ACTIONS(3777),
    [anon_sym_LPAREN] = ACTIONS(3777),
    [anon_sym_event] = ACTIONS(3775),
    [anon_sym_namespace] = ACTIONS(3775),
    [anon_sym_class] = ACTIONS(3775),
    [anon_sym_ref] = ACTIONS(3775),
    [anon_sym_struct] = ACTIONS(3775),
    [anon_sym_enum] = ACTIONS(3775),
    [anon_sym_RBRACE] = ACTIONS(3777),
    [anon_sym_interface] = ACTIONS(3775),
    [anon_sym_delegate] = ACTIONS(3775),
    [anon_sym_record] = ACTIONS(3775),
    [anon_sym_abstract] = ACTIONS(3775),
    [anon_sym_async] = ACTIONS(3775),
    [anon_sym_const] = ACTIONS(3775),
    [anon_sym_file] = ACTIONS(3775),
    [anon_sym_fixed] = ACTIONS(3775),
    [anon_sym_internal] = ACTIONS(3775),
    [anon_sym_new] = ACTIONS(3775),
    [anon_sym_override] = ACTIONS(3775),
    [anon_sym_partial] = ACTIONS(3775),
    [anon_sym_private] = ACTIONS(3775),
    [anon_sym_protected] = ACTIONS(3775),
    [anon_sym_public] = ACTIONS(3775),
    [anon_sym_readonly] = ACTIONS(3775),
    [anon_sym_required] = ACTIONS(3775),
    [anon_sym_sealed] = ACTIONS(3775),
    [anon_sym_virtual] = ACTIONS(3775),
    [anon_sym_volatile] = ACTIONS(3775),
    [anon_sym_where] = ACTIONS(3775),
    [anon_sym_notnull] = ACTIONS(3775),
    [anon_sym_unmanaged] = ACTIONS(3775),
    [anon_sym_TILDE] = ACTIONS(3777),
    [anon_sym_implicit] = ACTIONS(3775),
    [anon_sym_explicit] = ACTIONS(3775),
    [anon_sym_scoped] = ACTIONS(3775),
    [anon_sym_var] = ACTIONS(3775),
    [sym_predefined_type] = ACTIONS(3775),
    [anon_sym_yield] = ACTIONS(3775),
    [anon_sym_when] = ACTIONS(3775),
    [anon_sym_from] = ACTIONS(3775),
    [anon_sym_into] = ACTIONS(3775),
    [anon_sym_join] = ACTIONS(3775),
    [anon_sym_on] = ACTIONS(3775),
    [anon_sym_equals] = ACTIONS(3775),
    [anon_sym_let] = ACTIONS(3775),
    [anon_sym_orderby] = ACTIONS(3775),
    [anon_sym_ascending] = ACTIONS(3775),
    [anon_sym_descending] = ACTIONS(3775),
    [anon_sym_group] = ACTIONS(3775),
    [anon_sym_by] = ACTIONS(3775),
    [anon_sym_select] = ACTIONS(3775),
    [aux_sym_preproc_if_token1] = ACTIONS(3777),
    [aux_sym_preproc_if_token3] = ACTIONS(3777),
    [aux_sym_preproc_else_token1] = ACTIONS(3777),
    [aux_sym_preproc_elif_token1] = ACTIONS(3777),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3375] = {
    [sym_preproc_region] = STATE(3375),
    [sym_preproc_endregion] = STATE(3375),
    [sym_preproc_line] = STATE(3375),
    [sym_preproc_pragma] = STATE(3375),
    [sym_preproc_nullable] = STATE(3375),
    [sym_preproc_error] = STATE(3375),
    [sym_preproc_define] = STATE(3375),
    [sym_preproc_undef] = STATE(3375),
    [sym__identifier_token] = ACTIONS(3783),
    [anon_sym_extern] = ACTIONS(3783),
    [anon_sym_alias] = ACTIONS(3783),
    [anon_sym_global] = ACTIONS(3783),
    [anon_sym_using] = ACTIONS(3783),
    [anon_sym_unsafe] = ACTIONS(3783),
    [anon_sym_static] = ACTIONS(3783),
    [anon_sym_LBRACK] = ACTIONS(3785),
    [anon_sym_LPAREN] = ACTIONS(3785),
    [anon_sym_event] = ACTIONS(3783),
    [anon_sym_namespace] = ACTIONS(3783),
    [anon_sym_class] = ACTIONS(3783),
    [anon_sym_ref] = ACTIONS(3783),
    [anon_sym_struct] = ACTIONS(3783),
    [anon_sym_enum] = ACTIONS(3783),
    [anon_sym_RBRACE] = ACTIONS(3785),
    [anon_sym_interface] = ACTIONS(3783),
    [anon_sym_delegate] = ACTIONS(3783),
    [anon_sym_record] = ACTIONS(3783),
    [anon_sym_abstract] = ACTIONS(3783),
    [anon_sym_async] = ACTIONS(3783),
    [anon_sym_const] = ACTIONS(3783),
    [anon_sym_file] = ACTIONS(3783),
    [anon_sym_fixed] = ACTIONS(3783),
    [anon_sym_internal] = ACTIONS(3783),
    [anon_sym_new] = ACTIONS(3783),
    [anon_sym_override] = ACTIONS(3783),
    [anon_sym_partial] = ACTIONS(3783),
    [anon_sym_private] = ACTIONS(3783),
    [anon_sym_protected] = ACTIONS(3783),
    [anon_sym_public] = ACTIONS(3783),
    [anon_sym_readonly] = ACTIONS(3783),
    [anon_sym_required] = ACTIONS(3783),
    [anon_sym_sealed] = ACTIONS(3783),
    [anon_sym_virtual] = ACTIONS(3783),
    [anon_sym_volatile] = ACTIONS(3783),
    [anon_sym_where] = ACTIONS(3783),
    [anon_sym_notnull] = ACTIONS(3783),
    [anon_sym_unmanaged] = ACTIONS(3783),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_implicit] = ACTIONS(3783),
    [anon_sym_explicit] = ACTIONS(3783),
    [anon_sym_scoped] = ACTIONS(3783),
    [anon_sym_var] = ACTIONS(3783),
    [sym_predefined_type] = ACTIONS(3783),
    [anon_sym_yield] = ACTIONS(3783),
    [anon_sym_when] = ACTIONS(3783),
    [anon_sym_from] = ACTIONS(3783),
    [anon_sym_into] = ACTIONS(3783),
    [anon_sym_join] = ACTIONS(3783),
    [anon_sym_on] = ACTIONS(3783),
    [anon_sym_equals] = ACTIONS(3783),
    [anon_sym_let] = ACTIONS(3783),
    [anon_sym_orderby] = ACTIONS(3783),
    [anon_sym_ascending] = ACTIONS(3783),
    [anon_sym_descending] = ACTIONS(3783),
    [anon_sym_group] = ACTIONS(3783),
    [anon_sym_by] = ACTIONS(3783),
    [anon_sym_select] = ACTIONS(3783),
    [aux_sym_preproc_if_token1] = ACTIONS(3785),
    [aux_sym_preproc_if_token3] = ACTIONS(3785),
    [aux_sym_preproc_else_token1] = ACTIONS(3785),
    [aux_sym_preproc_elif_token1] = ACTIONS(3785),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3376] = {
    [sym_preproc_region] = STATE(3376),
    [sym_preproc_endregion] = STATE(3376),
    [sym_preproc_line] = STATE(3376),
    [sym_preproc_pragma] = STATE(3376),
    [sym_preproc_nullable] = STATE(3376),
    [sym_preproc_error] = STATE(3376),
    [sym_preproc_define] = STATE(3376),
    [sym_preproc_undef] = STATE(3376),
    [sym__identifier_token] = ACTIONS(4947),
    [anon_sym_extern] = ACTIONS(4947),
    [anon_sym_alias] = ACTIONS(4947),
    [anon_sym_global] = ACTIONS(4947),
    [anon_sym_using] = ACTIONS(4947),
    [anon_sym_unsafe] = ACTIONS(4947),
    [anon_sym_static] = ACTIONS(4947),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(4949),
    [anon_sym_event] = ACTIONS(4947),
    [anon_sym_namespace] = ACTIONS(4947),
    [anon_sym_class] = ACTIONS(4947),
    [anon_sym_ref] = ACTIONS(4947),
    [anon_sym_struct] = ACTIONS(4947),
    [anon_sym_enum] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_interface] = ACTIONS(4947),
    [anon_sym_delegate] = ACTIONS(4947),
    [anon_sym_record] = ACTIONS(4947),
    [anon_sym_abstract] = ACTIONS(4947),
    [anon_sym_async] = ACTIONS(4947),
    [anon_sym_const] = ACTIONS(4947),
    [anon_sym_file] = ACTIONS(4947),
    [anon_sym_fixed] = ACTIONS(4947),
    [anon_sym_internal] = ACTIONS(4947),
    [anon_sym_new] = ACTIONS(4947),
    [anon_sym_override] = ACTIONS(4947),
    [anon_sym_partial] = ACTIONS(4947),
    [anon_sym_private] = ACTIONS(4947),
    [anon_sym_protected] = ACTIONS(4947),
    [anon_sym_public] = ACTIONS(4947),
    [anon_sym_readonly] = ACTIONS(4947),
    [anon_sym_required] = ACTIONS(4947),
    [anon_sym_sealed] = ACTIONS(4947),
    [anon_sym_virtual] = ACTIONS(4947),
    [anon_sym_volatile] = ACTIONS(4947),
    [anon_sym_where] = ACTIONS(4947),
    [anon_sym_notnull] = ACTIONS(4947),
    [anon_sym_unmanaged] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4949),
    [anon_sym_implicit] = ACTIONS(4947),
    [anon_sym_explicit] = ACTIONS(4947),
    [anon_sym_scoped] = ACTIONS(4947),
    [anon_sym_var] = ACTIONS(4947),
    [sym_predefined_type] = ACTIONS(4947),
    [anon_sym_yield] = ACTIONS(4947),
    [anon_sym_when] = ACTIONS(4947),
    [anon_sym_from] = ACTIONS(4947),
    [anon_sym_into] = ACTIONS(4947),
    [anon_sym_join] = ACTIONS(4947),
    [anon_sym_on] = ACTIONS(4947),
    [anon_sym_equals] = ACTIONS(4947),
    [anon_sym_let] = ACTIONS(4947),
    [anon_sym_orderby] = ACTIONS(4947),
    [anon_sym_ascending] = ACTIONS(4947),
    [anon_sym_descending] = ACTIONS(4947),
    [anon_sym_group] = ACTIONS(4947),
    [anon_sym_by] = ACTIONS(4947),
    [anon_sym_select] = ACTIONS(4947),
    [aux_sym_preproc_if_token1] = ACTIONS(4949),
    [aux_sym_preproc_if_token3] = ACTIONS(4949),
    [aux_sym_preproc_else_token1] = ACTIONS(4949),
    [aux_sym_preproc_elif_token1] = ACTIONS(4949),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3377] = {
    [sym_preproc_region] = STATE(3377),
    [sym_preproc_endregion] = STATE(3377),
    [sym_preproc_line] = STATE(3377),
    [sym_preproc_pragma] = STATE(3377),
    [sym_preproc_nullable] = STATE(3377),
    [sym_preproc_error] = STATE(3377),
    [sym_preproc_define] = STATE(3377),
    [sym_preproc_undef] = STATE(3377),
    [sym__identifier_token] = ACTIONS(4951),
    [anon_sym_extern] = ACTIONS(4951),
    [anon_sym_alias] = ACTIONS(4951),
    [anon_sym_global] = ACTIONS(4951),
    [anon_sym_using] = ACTIONS(4951),
    [anon_sym_unsafe] = ACTIONS(4951),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_LPAREN] = ACTIONS(4953),
    [anon_sym_event] = ACTIONS(4951),
    [anon_sym_namespace] = ACTIONS(4951),
    [anon_sym_class] = ACTIONS(4951),
    [anon_sym_ref] = ACTIONS(4951),
    [anon_sym_struct] = ACTIONS(4951),
    [anon_sym_enum] = ACTIONS(4951),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_interface] = ACTIONS(4951),
    [anon_sym_delegate] = ACTIONS(4951),
    [anon_sym_record] = ACTIONS(4951),
    [anon_sym_abstract] = ACTIONS(4951),
    [anon_sym_async] = ACTIONS(4951),
    [anon_sym_const] = ACTIONS(4951),
    [anon_sym_file] = ACTIONS(4951),
    [anon_sym_fixed] = ACTIONS(4951),
    [anon_sym_internal] = ACTIONS(4951),
    [anon_sym_new] = ACTIONS(4951),
    [anon_sym_override] = ACTIONS(4951),
    [anon_sym_partial] = ACTIONS(4951),
    [anon_sym_private] = ACTIONS(4951),
    [anon_sym_protected] = ACTIONS(4951),
    [anon_sym_public] = ACTIONS(4951),
    [anon_sym_readonly] = ACTIONS(4951),
    [anon_sym_required] = ACTIONS(4951),
    [anon_sym_sealed] = ACTIONS(4951),
    [anon_sym_virtual] = ACTIONS(4951),
    [anon_sym_volatile] = ACTIONS(4951),
    [anon_sym_where] = ACTIONS(4951),
    [anon_sym_notnull] = ACTIONS(4951),
    [anon_sym_unmanaged] = ACTIONS(4951),
    [anon_sym_TILDE] = ACTIONS(4953),
    [anon_sym_implicit] = ACTIONS(4951),
    [anon_sym_explicit] = ACTIONS(4951),
    [anon_sym_scoped] = ACTIONS(4951),
    [anon_sym_var] = ACTIONS(4951),
    [sym_predefined_type] = ACTIONS(4951),
    [anon_sym_yield] = ACTIONS(4951),
    [anon_sym_when] = ACTIONS(4951),
    [anon_sym_from] = ACTIONS(4951),
    [anon_sym_into] = ACTIONS(4951),
    [anon_sym_join] = ACTIONS(4951),
    [anon_sym_on] = ACTIONS(4951),
    [anon_sym_equals] = ACTIONS(4951),
    [anon_sym_let] = ACTIONS(4951),
    [anon_sym_orderby] = ACTIONS(4951),
    [anon_sym_ascending] = ACTIONS(4951),
    [anon_sym_descending] = ACTIONS(4951),
    [anon_sym_group] = ACTIONS(4951),
    [anon_sym_by] = ACTIONS(4951),
    [anon_sym_select] = ACTIONS(4951),
    [aux_sym_preproc_if_token1] = ACTIONS(4953),
    [aux_sym_preproc_if_token3] = ACTIONS(4953),
    [aux_sym_preproc_else_token1] = ACTIONS(4953),
    [aux_sym_preproc_elif_token1] = ACTIONS(4953),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3378] = {
    [sym_preproc_region] = STATE(3378),
    [sym_preproc_endregion] = STATE(3378),
    [sym_preproc_line] = STATE(3378),
    [sym_preproc_pragma] = STATE(3378),
    [sym_preproc_nullable] = STATE(3378),
    [sym_preproc_error] = STATE(3378),
    [sym_preproc_define] = STATE(3378),
    [sym_preproc_undef] = STATE(3378),
    [sym__identifier_token] = ACTIONS(3957),
    [anon_sym_extern] = ACTIONS(3957),
    [anon_sym_alias] = ACTIONS(3957),
    [anon_sym_global] = ACTIONS(3957),
    [anon_sym_using] = ACTIONS(3957),
    [anon_sym_unsafe] = ACTIONS(3957),
    [anon_sym_static] = ACTIONS(3957),
    [anon_sym_LBRACK] = ACTIONS(3959),
    [anon_sym_LPAREN] = ACTIONS(3959),
    [anon_sym_event] = ACTIONS(3957),
    [anon_sym_namespace] = ACTIONS(3957),
    [anon_sym_class] = ACTIONS(3957),
    [anon_sym_ref] = ACTIONS(3957),
    [anon_sym_struct] = ACTIONS(3957),
    [anon_sym_enum] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(3957),
    [anon_sym_delegate] = ACTIONS(3957),
    [anon_sym_record] = ACTIONS(3957),
    [anon_sym_abstract] = ACTIONS(3957),
    [anon_sym_async] = ACTIONS(3957),
    [anon_sym_const] = ACTIONS(3957),
    [anon_sym_file] = ACTIONS(3957),
    [anon_sym_fixed] = ACTIONS(3957),
    [anon_sym_internal] = ACTIONS(3957),
    [anon_sym_new] = ACTIONS(3957),
    [anon_sym_override] = ACTIONS(3957),
    [anon_sym_partial] = ACTIONS(3957),
    [anon_sym_private] = ACTIONS(3957),
    [anon_sym_protected] = ACTIONS(3957),
    [anon_sym_public] = ACTIONS(3957),
    [anon_sym_readonly] = ACTIONS(3957),
    [anon_sym_required] = ACTIONS(3957),
    [anon_sym_sealed] = ACTIONS(3957),
    [anon_sym_virtual] = ACTIONS(3957),
    [anon_sym_volatile] = ACTIONS(3957),
    [anon_sym_where] = ACTIONS(3957),
    [anon_sym_notnull] = ACTIONS(3957),
    [anon_sym_unmanaged] = ACTIONS(3957),
    [anon_sym_TILDE] = ACTIONS(3959),
    [anon_sym_implicit] = ACTIONS(3957),
    [anon_sym_explicit] = ACTIONS(3957),
    [anon_sym_scoped] = ACTIONS(3957),
    [anon_sym_var] = ACTIONS(3957),
    [sym_predefined_type] = ACTIONS(3957),
    [anon_sym_yield] = ACTIONS(3957),
    [anon_sym_when] = ACTIONS(3957),
    [anon_sym_from] = ACTIONS(3957),
    [anon_sym_into] = ACTIONS(3957),
    [anon_sym_join] = ACTIONS(3957),
    [anon_sym_on] = ACTIONS(3957),
    [anon_sym_equals] = ACTIONS(3957),
    [anon_sym_let] = ACTIONS(3957),
    [anon_sym_orderby] = ACTIONS(3957),
    [anon_sym_ascending] = ACTIONS(3957),
    [anon_sym_descending] = ACTIONS(3957),
    [anon_sym_group] = ACTIONS(3957),
    [anon_sym_by] = ACTIONS(3957),
    [anon_sym_select] = ACTIONS(3957),
    [aux_sym_preproc_if_token1] = ACTIONS(3959),
    [aux_sym_preproc_if_token3] = ACTIONS(3959),
    [aux_sym_preproc_else_token1] = ACTIONS(3959),
    [aux_sym_preproc_elif_token1] = ACTIONS(3959),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3379] = {
    [sym_preproc_region] = STATE(3379),
    [sym_preproc_endregion] = STATE(3379),
    [sym_preproc_line] = STATE(3379),
    [sym_preproc_pragma] = STATE(3379),
    [sym_preproc_nullable] = STATE(3379),
    [sym_preproc_error] = STATE(3379),
    [sym_preproc_define] = STATE(3379),
    [sym_preproc_undef] = STATE(3379),
    [sym__identifier_token] = ACTIONS(3811),
    [anon_sym_extern] = ACTIONS(3811),
    [anon_sym_alias] = ACTIONS(3811),
    [anon_sym_global] = ACTIONS(3811),
    [anon_sym_using] = ACTIONS(3811),
    [anon_sym_unsafe] = ACTIONS(3811),
    [anon_sym_static] = ACTIONS(3811),
    [anon_sym_LBRACK] = ACTIONS(3813),
    [anon_sym_LPAREN] = ACTIONS(3813),
    [anon_sym_event] = ACTIONS(3811),
    [anon_sym_namespace] = ACTIONS(3811),
    [anon_sym_class] = ACTIONS(3811),
    [anon_sym_ref] = ACTIONS(3811),
    [anon_sym_struct] = ACTIONS(3811),
    [anon_sym_enum] = ACTIONS(3811),
    [anon_sym_RBRACE] = ACTIONS(3813),
    [anon_sym_interface] = ACTIONS(3811),
    [anon_sym_delegate] = ACTIONS(3811),
    [anon_sym_record] = ACTIONS(3811),
    [anon_sym_abstract] = ACTIONS(3811),
    [anon_sym_async] = ACTIONS(3811),
    [anon_sym_const] = ACTIONS(3811),
    [anon_sym_file] = ACTIONS(3811),
    [anon_sym_fixed] = ACTIONS(3811),
    [anon_sym_internal] = ACTIONS(3811),
    [anon_sym_new] = ACTIONS(3811),
    [anon_sym_override] = ACTIONS(3811),
    [anon_sym_partial] = ACTIONS(3811),
    [anon_sym_private] = ACTIONS(3811),
    [anon_sym_protected] = ACTIONS(3811),
    [anon_sym_public] = ACTIONS(3811),
    [anon_sym_readonly] = ACTIONS(3811),
    [anon_sym_required] = ACTIONS(3811),
    [anon_sym_sealed] = ACTIONS(3811),
    [anon_sym_virtual] = ACTIONS(3811),
    [anon_sym_volatile] = ACTIONS(3811),
    [anon_sym_where] = ACTIONS(3811),
    [anon_sym_notnull] = ACTIONS(3811),
    [anon_sym_unmanaged] = ACTIONS(3811),
    [anon_sym_TILDE] = ACTIONS(3813),
    [anon_sym_implicit] = ACTIONS(3811),
    [anon_sym_explicit] = ACTIONS(3811),
    [anon_sym_scoped] = ACTIONS(3811),
    [anon_sym_var] = ACTIONS(3811),
    [sym_predefined_type] = ACTIONS(3811),
    [anon_sym_yield] = ACTIONS(3811),
    [anon_sym_when] = ACTIONS(3811),
    [anon_sym_from] = ACTIONS(3811),
    [anon_sym_into] = ACTIONS(3811),
    [anon_sym_join] = ACTIONS(3811),
    [anon_sym_on] = ACTIONS(3811),
    [anon_sym_equals] = ACTIONS(3811),
    [anon_sym_let] = ACTIONS(3811),
    [anon_sym_orderby] = ACTIONS(3811),
    [anon_sym_ascending] = ACTIONS(3811),
    [anon_sym_descending] = ACTIONS(3811),
    [anon_sym_group] = ACTIONS(3811),
    [anon_sym_by] = ACTIONS(3811),
    [anon_sym_select] = ACTIONS(3811),
    [aux_sym_preproc_if_token1] = ACTIONS(3813),
    [aux_sym_preproc_if_token3] = ACTIONS(3813),
    [aux_sym_preproc_else_token1] = ACTIONS(3813),
    [aux_sym_preproc_elif_token1] = ACTIONS(3813),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3380] = {
    [sym_preproc_region] = STATE(3380),
    [sym_preproc_endregion] = STATE(3380),
    [sym_preproc_line] = STATE(3380),
    [sym_preproc_pragma] = STATE(3380),
    [sym_preproc_nullable] = STATE(3380),
    [sym_preproc_error] = STATE(3380),
    [sym_preproc_define] = STATE(3380),
    [sym_preproc_undef] = STATE(3380),
    [sym__identifier_token] = ACTIONS(3803),
    [anon_sym_extern] = ACTIONS(3803),
    [anon_sym_alias] = ACTIONS(3803),
    [anon_sym_global] = ACTIONS(3803),
    [anon_sym_using] = ACTIONS(3803),
    [anon_sym_unsafe] = ACTIONS(3803),
    [anon_sym_static] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3805),
    [anon_sym_LPAREN] = ACTIONS(3805),
    [anon_sym_event] = ACTIONS(3803),
    [anon_sym_namespace] = ACTIONS(3803),
    [anon_sym_class] = ACTIONS(3803),
    [anon_sym_ref] = ACTIONS(3803),
    [anon_sym_struct] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(3803),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_interface] = ACTIONS(3803),
    [anon_sym_delegate] = ACTIONS(3803),
    [anon_sym_record] = ACTIONS(3803),
    [anon_sym_abstract] = ACTIONS(3803),
    [anon_sym_async] = ACTIONS(3803),
    [anon_sym_const] = ACTIONS(3803),
    [anon_sym_file] = ACTIONS(3803),
    [anon_sym_fixed] = ACTIONS(3803),
    [anon_sym_internal] = ACTIONS(3803),
    [anon_sym_new] = ACTIONS(3803),
    [anon_sym_override] = ACTIONS(3803),
    [anon_sym_partial] = ACTIONS(3803),
    [anon_sym_private] = ACTIONS(3803),
    [anon_sym_protected] = ACTIONS(3803),
    [anon_sym_public] = ACTIONS(3803),
    [anon_sym_readonly] = ACTIONS(3803),
    [anon_sym_required] = ACTIONS(3803),
    [anon_sym_sealed] = ACTIONS(3803),
    [anon_sym_virtual] = ACTIONS(3803),
    [anon_sym_volatile] = ACTIONS(3803),
    [anon_sym_where] = ACTIONS(3803),
    [anon_sym_notnull] = ACTIONS(3803),
    [anon_sym_unmanaged] = ACTIONS(3803),
    [anon_sym_TILDE] = ACTIONS(3805),
    [anon_sym_implicit] = ACTIONS(3803),
    [anon_sym_explicit] = ACTIONS(3803),
    [anon_sym_scoped] = ACTIONS(3803),
    [anon_sym_var] = ACTIONS(3803),
    [sym_predefined_type] = ACTIONS(3803),
    [anon_sym_yield] = ACTIONS(3803),
    [anon_sym_when] = ACTIONS(3803),
    [anon_sym_from] = ACTIONS(3803),
    [anon_sym_into] = ACTIONS(3803),
    [anon_sym_join] = ACTIONS(3803),
    [anon_sym_on] = ACTIONS(3803),
    [anon_sym_equals] = ACTIONS(3803),
    [anon_sym_let] = ACTIONS(3803),
    [anon_sym_orderby] = ACTIONS(3803),
    [anon_sym_ascending] = ACTIONS(3803),
    [anon_sym_descending] = ACTIONS(3803),
    [anon_sym_group] = ACTIONS(3803),
    [anon_sym_by] = ACTIONS(3803),
    [anon_sym_select] = ACTIONS(3803),
    [aux_sym_preproc_if_token1] = ACTIONS(3805),
    [aux_sym_preproc_if_token3] = ACTIONS(3805),
    [aux_sym_preproc_else_token1] = ACTIONS(3805),
    [aux_sym_preproc_elif_token1] = ACTIONS(3805),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3381] = {
    [sym_preproc_region] = STATE(3381),
    [sym_preproc_endregion] = STATE(3381),
    [sym_preproc_line] = STATE(3381),
    [sym_preproc_pragma] = STATE(3381),
    [sym_preproc_nullable] = STATE(3381),
    [sym_preproc_error] = STATE(3381),
    [sym_preproc_define] = STATE(3381),
    [sym_preproc_undef] = STATE(3381),
    [sym__identifier_token] = ACTIONS(3795),
    [anon_sym_extern] = ACTIONS(3795),
    [anon_sym_alias] = ACTIONS(3795),
    [anon_sym_global] = ACTIONS(3795),
    [anon_sym_using] = ACTIONS(3795),
    [anon_sym_unsafe] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [anon_sym_LPAREN] = ACTIONS(3797),
    [anon_sym_event] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_ref] = ACTIONS(3795),
    [anon_sym_struct] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_delegate] = ACTIONS(3795),
    [anon_sym_record] = ACTIONS(3795),
    [anon_sym_abstract] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [anon_sym_file] = ACTIONS(3795),
    [anon_sym_fixed] = ACTIONS(3795),
    [anon_sym_internal] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [anon_sym_override] = ACTIONS(3795),
    [anon_sym_partial] = ACTIONS(3795),
    [anon_sym_private] = ACTIONS(3795),
    [anon_sym_protected] = ACTIONS(3795),
    [anon_sym_public] = ACTIONS(3795),
    [anon_sym_readonly] = ACTIONS(3795),
    [anon_sym_required] = ACTIONS(3795),
    [anon_sym_sealed] = ACTIONS(3795),
    [anon_sym_virtual] = ACTIONS(3795),
    [anon_sym_volatile] = ACTIONS(3795),
    [anon_sym_where] = ACTIONS(3795),
    [anon_sym_notnull] = ACTIONS(3795),
    [anon_sym_unmanaged] = ACTIONS(3795),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_implicit] = ACTIONS(3795),
    [anon_sym_explicit] = ACTIONS(3795),
    [anon_sym_scoped] = ACTIONS(3795),
    [anon_sym_var] = ACTIONS(3795),
    [sym_predefined_type] = ACTIONS(3795),
    [anon_sym_yield] = ACTIONS(3795),
    [anon_sym_when] = ACTIONS(3795),
    [anon_sym_from] = ACTIONS(3795),
    [anon_sym_into] = ACTIONS(3795),
    [anon_sym_join] = ACTIONS(3795),
    [anon_sym_on] = ACTIONS(3795),
    [anon_sym_equals] = ACTIONS(3795),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_orderby] = ACTIONS(3795),
    [anon_sym_ascending] = ACTIONS(3795),
    [anon_sym_descending] = ACTIONS(3795),
    [anon_sym_group] = ACTIONS(3795),
    [anon_sym_by] = ACTIONS(3795),
    [anon_sym_select] = ACTIONS(3795),
    [aux_sym_preproc_if_token1] = ACTIONS(3797),
    [aux_sym_preproc_if_token3] = ACTIONS(3797),
    [aux_sym_preproc_else_token1] = ACTIONS(3797),
    [aux_sym_preproc_elif_token1] = ACTIONS(3797),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3382] = {
    [sym_preproc_region] = STATE(3382),
    [sym_preproc_endregion] = STATE(3382),
    [sym_preproc_line] = STATE(3382),
    [sym_preproc_pragma] = STATE(3382),
    [sym_preproc_nullable] = STATE(3382),
    [sym_preproc_error] = STATE(3382),
    [sym_preproc_define] = STATE(3382),
    [sym_preproc_undef] = STATE(3382),
    [sym__identifier_token] = ACTIONS(4955),
    [anon_sym_extern] = ACTIONS(4955),
    [anon_sym_alias] = ACTIONS(4955),
    [anon_sym_global] = ACTIONS(4955),
    [anon_sym_using] = ACTIONS(4955),
    [anon_sym_unsafe] = ACTIONS(4955),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_LPAREN] = ACTIONS(4957),
    [anon_sym_event] = ACTIONS(4955),
    [anon_sym_namespace] = ACTIONS(4955),
    [anon_sym_class] = ACTIONS(4955),
    [anon_sym_ref] = ACTIONS(4955),
    [anon_sym_struct] = ACTIONS(4955),
    [anon_sym_enum] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_interface] = ACTIONS(4955),
    [anon_sym_delegate] = ACTIONS(4955),
    [anon_sym_record] = ACTIONS(4955),
    [anon_sym_abstract] = ACTIONS(4955),
    [anon_sym_async] = ACTIONS(4955),
    [anon_sym_const] = ACTIONS(4955),
    [anon_sym_file] = ACTIONS(4955),
    [anon_sym_fixed] = ACTIONS(4955),
    [anon_sym_internal] = ACTIONS(4955),
    [anon_sym_new] = ACTIONS(4955),
    [anon_sym_override] = ACTIONS(4955),
    [anon_sym_partial] = ACTIONS(4955),
    [anon_sym_private] = ACTIONS(4955),
    [anon_sym_protected] = ACTIONS(4955),
    [anon_sym_public] = ACTIONS(4955),
    [anon_sym_readonly] = ACTIONS(4955),
    [anon_sym_required] = ACTIONS(4955),
    [anon_sym_sealed] = ACTIONS(4955),
    [anon_sym_virtual] = ACTIONS(4955),
    [anon_sym_volatile] = ACTIONS(4955),
    [anon_sym_where] = ACTIONS(4955),
    [anon_sym_notnull] = ACTIONS(4955),
    [anon_sym_unmanaged] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4957),
    [anon_sym_implicit] = ACTIONS(4955),
    [anon_sym_explicit] = ACTIONS(4955),
    [anon_sym_scoped] = ACTIONS(4955),
    [anon_sym_var] = ACTIONS(4955),
    [sym_predefined_type] = ACTIONS(4955),
    [anon_sym_yield] = ACTIONS(4955),
    [anon_sym_when] = ACTIONS(4955),
    [anon_sym_from] = ACTIONS(4955),
    [anon_sym_into] = ACTIONS(4955),
    [anon_sym_join] = ACTIONS(4955),
    [anon_sym_on] = ACTIONS(4955),
    [anon_sym_equals] = ACTIONS(4955),
    [anon_sym_let] = ACTIONS(4955),
    [anon_sym_orderby] = ACTIONS(4955),
    [anon_sym_ascending] = ACTIONS(4955),
    [anon_sym_descending] = ACTIONS(4955),
    [anon_sym_group] = ACTIONS(4955),
    [anon_sym_by] = ACTIONS(4955),
    [anon_sym_select] = ACTIONS(4955),
    [aux_sym_preproc_if_token1] = ACTIONS(4957),
    [aux_sym_preproc_if_token3] = ACTIONS(4957),
    [aux_sym_preproc_else_token1] = ACTIONS(4957),
    [aux_sym_preproc_elif_token1] = ACTIONS(4957),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3383] = {
    [sym_preproc_region] = STATE(3383),
    [sym_preproc_endregion] = STATE(3383),
    [sym_preproc_line] = STATE(3383),
    [sym_preproc_pragma] = STATE(3383),
    [sym_preproc_nullable] = STATE(3383),
    [sym_preproc_error] = STATE(3383),
    [sym_preproc_define] = STATE(3383),
    [sym_preproc_undef] = STATE(3383),
    [sym__identifier_token] = ACTIONS(4959),
    [anon_sym_extern] = ACTIONS(4959),
    [anon_sym_alias] = ACTIONS(4959),
    [anon_sym_global] = ACTIONS(4959),
    [anon_sym_using] = ACTIONS(4959),
    [anon_sym_unsafe] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4961),
    [anon_sym_event] = ACTIONS(4959),
    [anon_sym_namespace] = ACTIONS(4959),
    [anon_sym_class] = ACTIONS(4959),
    [anon_sym_ref] = ACTIONS(4959),
    [anon_sym_struct] = ACTIONS(4959),
    [anon_sym_enum] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_interface] = ACTIONS(4959),
    [anon_sym_delegate] = ACTIONS(4959),
    [anon_sym_record] = ACTIONS(4959),
    [anon_sym_abstract] = ACTIONS(4959),
    [anon_sym_async] = ACTIONS(4959),
    [anon_sym_const] = ACTIONS(4959),
    [anon_sym_file] = ACTIONS(4959),
    [anon_sym_fixed] = ACTIONS(4959),
    [anon_sym_internal] = ACTIONS(4959),
    [anon_sym_new] = ACTIONS(4959),
    [anon_sym_override] = ACTIONS(4959),
    [anon_sym_partial] = ACTIONS(4959),
    [anon_sym_private] = ACTIONS(4959),
    [anon_sym_protected] = ACTIONS(4959),
    [anon_sym_public] = ACTIONS(4959),
    [anon_sym_readonly] = ACTIONS(4959),
    [anon_sym_required] = ACTIONS(4959),
    [anon_sym_sealed] = ACTIONS(4959),
    [anon_sym_virtual] = ACTIONS(4959),
    [anon_sym_volatile] = ACTIONS(4959),
    [anon_sym_where] = ACTIONS(4959),
    [anon_sym_notnull] = ACTIONS(4959),
    [anon_sym_unmanaged] = ACTIONS(4959),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_implicit] = ACTIONS(4959),
    [anon_sym_explicit] = ACTIONS(4959),
    [anon_sym_scoped] = ACTIONS(4959),
    [anon_sym_var] = ACTIONS(4959),
    [sym_predefined_type] = ACTIONS(4959),
    [anon_sym_yield] = ACTIONS(4959),
    [anon_sym_when] = ACTIONS(4959),
    [anon_sym_from] = ACTIONS(4959),
    [anon_sym_into] = ACTIONS(4959),
    [anon_sym_join] = ACTIONS(4959),
    [anon_sym_on] = ACTIONS(4959),
    [anon_sym_equals] = ACTIONS(4959),
    [anon_sym_let] = ACTIONS(4959),
    [anon_sym_orderby] = ACTIONS(4959),
    [anon_sym_ascending] = ACTIONS(4959),
    [anon_sym_descending] = ACTIONS(4959),
    [anon_sym_group] = ACTIONS(4959),
    [anon_sym_by] = ACTIONS(4959),
    [anon_sym_select] = ACTIONS(4959),
    [aux_sym_preproc_if_token1] = ACTIONS(4961),
    [aux_sym_preproc_if_token3] = ACTIONS(4961),
    [aux_sym_preproc_else_token1] = ACTIONS(4961),
    [aux_sym_preproc_elif_token1] = ACTIONS(4961),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3384] = {
    [sym_preproc_region] = STATE(3384),
    [sym_preproc_endregion] = STATE(3384),
    [sym_preproc_line] = STATE(3384),
    [sym_preproc_pragma] = STATE(3384),
    [sym_preproc_nullable] = STATE(3384),
    [sym_preproc_error] = STATE(3384),
    [sym_preproc_define] = STATE(3384),
    [sym_preproc_undef] = STATE(3384),
    [sym__identifier_token] = ACTIONS(3791),
    [anon_sym_extern] = ACTIONS(3791),
    [anon_sym_alias] = ACTIONS(3791),
    [anon_sym_global] = ACTIONS(3791),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_unsafe] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3793),
    [anon_sym_event] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_ref] = ACTIONS(3791),
    [anon_sym_struct] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_delegate] = ACTIONS(3791),
    [anon_sym_record] = ACTIONS(3791),
    [anon_sym_abstract] = ACTIONS(3791),
    [anon_sym_async] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [anon_sym_file] = ACTIONS(3791),
    [anon_sym_fixed] = ACTIONS(3791),
    [anon_sym_internal] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [anon_sym_override] = ACTIONS(3791),
    [anon_sym_partial] = ACTIONS(3791),
    [anon_sym_private] = ACTIONS(3791),
    [anon_sym_protected] = ACTIONS(3791),
    [anon_sym_public] = ACTIONS(3791),
    [anon_sym_readonly] = ACTIONS(3791),
    [anon_sym_required] = ACTIONS(3791),
    [anon_sym_sealed] = ACTIONS(3791),
    [anon_sym_virtual] = ACTIONS(3791),
    [anon_sym_volatile] = ACTIONS(3791),
    [anon_sym_where] = ACTIONS(3791),
    [anon_sym_notnull] = ACTIONS(3791),
    [anon_sym_unmanaged] = ACTIONS(3791),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_implicit] = ACTIONS(3791),
    [anon_sym_explicit] = ACTIONS(3791),
    [anon_sym_scoped] = ACTIONS(3791),
    [anon_sym_var] = ACTIONS(3791),
    [sym_predefined_type] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [anon_sym_when] = ACTIONS(3791),
    [anon_sym_from] = ACTIONS(3791),
    [anon_sym_into] = ACTIONS(3791),
    [anon_sym_join] = ACTIONS(3791),
    [anon_sym_on] = ACTIONS(3791),
    [anon_sym_equals] = ACTIONS(3791),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_orderby] = ACTIONS(3791),
    [anon_sym_ascending] = ACTIONS(3791),
    [anon_sym_descending] = ACTIONS(3791),
    [anon_sym_group] = ACTIONS(3791),
    [anon_sym_by] = ACTIONS(3791),
    [anon_sym_select] = ACTIONS(3791),
    [aux_sym_preproc_if_token1] = ACTIONS(3793),
    [aux_sym_preproc_if_token3] = ACTIONS(3793),
    [aux_sym_preproc_else_token1] = ACTIONS(3793),
    [aux_sym_preproc_elif_token1] = ACTIONS(3793),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3385] = {
    [sym_preproc_region] = STATE(3385),
    [sym_preproc_endregion] = STATE(3385),
    [sym_preproc_line] = STATE(3385),
    [sym_preproc_pragma] = STATE(3385),
    [sym_preproc_nullable] = STATE(3385),
    [sym_preproc_error] = STATE(3385),
    [sym_preproc_define] = STATE(3385),
    [sym_preproc_undef] = STATE(3385),
    [sym__identifier_token] = ACTIONS(3771),
    [anon_sym_extern] = ACTIONS(3771),
    [anon_sym_alias] = ACTIONS(3771),
    [anon_sym_global] = ACTIONS(3771),
    [anon_sym_using] = ACTIONS(3771),
    [anon_sym_unsafe] = ACTIONS(3771),
    [anon_sym_static] = ACTIONS(3771),
    [anon_sym_LBRACK] = ACTIONS(3773),
    [anon_sym_LPAREN] = ACTIONS(3773),
    [anon_sym_event] = ACTIONS(3771),
    [anon_sym_namespace] = ACTIONS(3771),
    [anon_sym_class] = ACTIONS(3771),
    [anon_sym_ref] = ACTIONS(3771),
    [anon_sym_struct] = ACTIONS(3771),
    [anon_sym_enum] = ACTIONS(3771),
    [anon_sym_RBRACE] = ACTIONS(3773),
    [anon_sym_interface] = ACTIONS(3771),
    [anon_sym_delegate] = ACTIONS(3771),
    [anon_sym_record] = ACTIONS(3771),
    [anon_sym_abstract] = ACTIONS(3771),
    [anon_sym_async] = ACTIONS(3771),
    [anon_sym_const] = ACTIONS(3771),
    [anon_sym_file] = ACTIONS(3771),
    [anon_sym_fixed] = ACTIONS(3771),
    [anon_sym_internal] = ACTIONS(3771),
    [anon_sym_new] = ACTIONS(3771),
    [anon_sym_override] = ACTIONS(3771),
    [anon_sym_partial] = ACTIONS(3771),
    [anon_sym_private] = ACTIONS(3771),
    [anon_sym_protected] = ACTIONS(3771),
    [anon_sym_public] = ACTIONS(3771),
    [anon_sym_readonly] = ACTIONS(3771),
    [anon_sym_required] = ACTIONS(3771),
    [anon_sym_sealed] = ACTIONS(3771),
    [anon_sym_virtual] = ACTIONS(3771),
    [anon_sym_volatile] = ACTIONS(3771),
    [anon_sym_where] = ACTIONS(3771),
    [anon_sym_notnull] = ACTIONS(3771),
    [anon_sym_unmanaged] = ACTIONS(3771),
    [anon_sym_TILDE] = ACTIONS(3773),
    [anon_sym_implicit] = ACTIONS(3771),
    [anon_sym_explicit] = ACTIONS(3771),
    [anon_sym_scoped] = ACTIONS(3771),
    [anon_sym_var] = ACTIONS(3771),
    [sym_predefined_type] = ACTIONS(3771),
    [anon_sym_yield] = ACTIONS(3771),
    [anon_sym_when] = ACTIONS(3771),
    [anon_sym_from] = ACTIONS(3771),
    [anon_sym_into] = ACTIONS(3771),
    [anon_sym_join] = ACTIONS(3771),
    [anon_sym_on] = ACTIONS(3771),
    [anon_sym_equals] = ACTIONS(3771),
    [anon_sym_let] = ACTIONS(3771),
    [anon_sym_orderby] = ACTIONS(3771),
    [anon_sym_ascending] = ACTIONS(3771),
    [anon_sym_descending] = ACTIONS(3771),
    [anon_sym_group] = ACTIONS(3771),
    [anon_sym_by] = ACTIONS(3771),
    [anon_sym_select] = ACTIONS(3771),
    [aux_sym_preproc_if_token1] = ACTIONS(3773),
    [aux_sym_preproc_if_token3] = ACTIONS(3773),
    [aux_sym_preproc_else_token1] = ACTIONS(3773),
    [aux_sym_preproc_elif_token1] = ACTIONS(3773),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3386] = {
    [sym_preproc_region] = STATE(3386),
    [sym_preproc_endregion] = STATE(3386),
    [sym_preproc_line] = STATE(3386),
    [sym_preproc_pragma] = STATE(3386),
    [sym_preproc_nullable] = STATE(3386),
    [sym_preproc_error] = STATE(3386),
    [sym_preproc_define] = STATE(3386),
    [sym_preproc_undef] = STATE(3386),
    [sym__identifier_token] = ACTIONS(3699),
    [anon_sym_extern] = ACTIONS(3699),
    [anon_sym_alias] = ACTIONS(3699),
    [anon_sym_global] = ACTIONS(3699),
    [anon_sym_using] = ACTIONS(3699),
    [anon_sym_unsafe] = ACTIONS(3699),
    [anon_sym_static] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(3701),
    [anon_sym_event] = ACTIONS(3699),
    [anon_sym_namespace] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_ref] = ACTIONS(3699),
    [anon_sym_struct] = ACTIONS(3699),
    [anon_sym_enum] = ACTIONS(3699),
    [anon_sym_RBRACE] = ACTIONS(3701),
    [anon_sym_interface] = ACTIONS(3699),
    [anon_sym_delegate] = ACTIONS(3699),
    [anon_sym_record] = ACTIONS(3699),
    [anon_sym_abstract] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_file] = ACTIONS(3699),
    [anon_sym_fixed] = ACTIONS(3699),
    [anon_sym_internal] = ACTIONS(3699),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_override] = ACTIONS(3699),
    [anon_sym_partial] = ACTIONS(3699),
    [anon_sym_private] = ACTIONS(3699),
    [anon_sym_protected] = ACTIONS(3699),
    [anon_sym_public] = ACTIONS(3699),
    [anon_sym_readonly] = ACTIONS(3699),
    [anon_sym_required] = ACTIONS(3699),
    [anon_sym_sealed] = ACTIONS(3699),
    [anon_sym_virtual] = ACTIONS(3699),
    [anon_sym_volatile] = ACTIONS(3699),
    [anon_sym_where] = ACTIONS(3699),
    [anon_sym_notnull] = ACTIONS(3699),
    [anon_sym_unmanaged] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(3701),
    [anon_sym_implicit] = ACTIONS(3699),
    [anon_sym_explicit] = ACTIONS(3699),
    [anon_sym_scoped] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3699),
    [sym_predefined_type] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [anon_sym_when] = ACTIONS(3699),
    [anon_sym_from] = ACTIONS(3699),
    [anon_sym_into] = ACTIONS(3699),
    [anon_sym_join] = ACTIONS(3699),
    [anon_sym_on] = ACTIONS(3699),
    [anon_sym_equals] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_orderby] = ACTIONS(3699),
    [anon_sym_ascending] = ACTIONS(3699),
    [anon_sym_descending] = ACTIONS(3699),
    [anon_sym_group] = ACTIONS(3699),
    [anon_sym_by] = ACTIONS(3699),
    [anon_sym_select] = ACTIONS(3699),
    [aux_sym_preproc_if_token1] = ACTIONS(3701),
    [aux_sym_preproc_if_token3] = ACTIONS(3701),
    [aux_sym_preproc_else_token1] = ACTIONS(3701),
    [aux_sym_preproc_elif_token1] = ACTIONS(3701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3387] = {
    [sym_preproc_region] = STATE(3387),
    [sym_preproc_endregion] = STATE(3387),
    [sym_preproc_line] = STATE(3387),
    [sym_preproc_pragma] = STATE(3387),
    [sym_preproc_nullable] = STATE(3387),
    [sym_preproc_error] = STATE(3387),
    [sym_preproc_define] = STATE(3387),
    [sym_preproc_undef] = STATE(3387),
    [sym__identifier_token] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym_alias] = ACTIONS(4963),
    [anon_sym_global] = ACTIONS(4963),
    [anon_sym_using] = ACTIONS(4963),
    [anon_sym_unsafe] = ACTIONS(4963),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_LPAREN] = ACTIONS(4965),
    [anon_sym_event] = ACTIONS(4963),
    [anon_sym_namespace] = ACTIONS(4963),
    [anon_sym_class] = ACTIONS(4963),
    [anon_sym_ref] = ACTIONS(4963),
    [anon_sym_struct] = ACTIONS(4963),
    [anon_sym_enum] = ACTIONS(4963),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_interface] = ACTIONS(4963),
    [anon_sym_delegate] = ACTIONS(4963),
    [anon_sym_record] = ACTIONS(4963),
    [anon_sym_abstract] = ACTIONS(4963),
    [anon_sym_async] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4963),
    [anon_sym_file] = ACTIONS(4963),
    [anon_sym_fixed] = ACTIONS(4963),
    [anon_sym_internal] = ACTIONS(4963),
    [anon_sym_new] = ACTIONS(4963),
    [anon_sym_override] = ACTIONS(4963),
    [anon_sym_partial] = ACTIONS(4963),
    [anon_sym_private] = ACTIONS(4963),
    [anon_sym_protected] = ACTIONS(4963),
    [anon_sym_public] = ACTIONS(4963),
    [anon_sym_readonly] = ACTIONS(4963),
    [anon_sym_required] = ACTIONS(4963),
    [anon_sym_sealed] = ACTIONS(4963),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_volatile] = ACTIONS(4963),
    [anon_sym_where] = ACTIONS(4963),
    [anon_sym_notnull] = ACTIONS(4963),
    [anon_sym_unmanaged] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4965),
    [anon_sym_implicit] = ACTIONS(4963),
    [anon_sym_explicit] = ACTIONS(4963),
    [anon_sym_scoped] = ACTIONS(4963),
    [anon_sym_var] = ACTIONS(4963),
    [sym_predefined_type] = ACTIONS(4963),
    [anon_sym_yield] = ACTIONS(4963),
    [anon_sym_when] = ACTIONS(4963),
    [anon_sym_from] = ACTIONS(4963),
    [anon_sym_into] = ACTIONS(4963),
    [anon_sym_join] = ACTIONS(4963),
    [anon_sym_on] = ACTIONS(4963),
    [anon_sym_equals] = ACTIONS(4963),
    [anon_sym_let] = ACTIONS(4963),
    [anon_sym_orderby] = ACTIONS(4963),
    [anon_sym_ascending] = ACTIONS(4963),
    [anon_sym_descending] = ACTIONS(4963),
    [anon_sym_group] = ACTIONS(4963),
    [anon_sym_by] = ACTIONS(4963),
    [anon_sym_select] = ACTIONS(4963),
    [aux_sym_preproc_if_token1] = ACTIONS(4965),
    [aux_sym_preproc_if_token3] = ACTIONS(4965),
    [aux_sym_preproc_else_token1] = ACTIONS(4965),
    [aux_sym_preproc_elif_token1] = ACTIONS(4965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3388] = {
    [sym_preproc_region] = STATE(3388),
    [sym_preproc_endregion] = STATE(3388),
    [sym_preproc_line] = STATE(3388),
    [sym_preproc_pragma] = STATE(3388),
    [sym_preproc_nullable] = STATE(3388),
    [sym_preproc_error] = STATE(3388),
    [sym_preproc_define] = STATE(3388),
    [sym_preproc_undef] = STATE(3388),
    [sym__identifier_token] = ACTIONS(3695),
    [anon_sym_extern] = ACTIONS(3695),
    [anon_sym_alias] = ACTIONS(3695),
    [anon_sym_global] = ACTIONS(3695),
    [anon_sym_using] = ACTIONS(3695),
    [anon_sym_unsafe] = ACTIONS(3695),
    [anon_sym_static] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_event] = ACTIONS(3695),
    [anon_sym_namespace] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_ref] = ACTIONS(3695),
    [anon_sym_struct] = ACTIONS(3695),
    [anon_sym_enum] = ACTIONS(3695),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_interface] = ACTIONS(3695),
    [anon_sym_delegate] = ACTIONS(3695),
    [anon_sym_record] = ACTIONS(3695),
    [anon_sym_abstract] = ACTIONS(3695),
    [anon_sym_async] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_file] = ACTIONS(3695),
    [anon_sym_fixed] = ACTIONS(3695),
    [anon_sym_internal] = ACTIONS(3695),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_override] = ACTIONS(3695),
    [anon_sym_partial] = ACTIONS(3695),
    [anon_sym_private] = ACTIONS(3695),
    [anon_sym_protected] = ACTIONS(3695),
    [anon_sym_public] = ACTIONS(3695),
    [anon_sym_readonly] = ACTIONS(3695),
    [anon_sym_required] = ACTIONS(3695),
    [anon_sym_sealed] = ACTIONS(3695),
    [anon_sym_virtual] = ACTIONS(3695),
    [anon_sym_volatile] = ACTIONS(3695),
    [anon_sym_where] = ACTIONS(3695),
    [anon_sym_notnull] = ACTIONS(3695),
    [anon_sym_unmanaged] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_implicit] = ACTIONS(3695),
    [anon_sym_explicit] = ACTIONS(3695),
    [anon_sym_scoped] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3695),
    [sym_predefined_type] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3695),
    [anon_sym_when] = ACTIONS(3695),
    [anon_sym_from] = ACTIONS(3695),
    [anon_sym_into] = ACTIONS(3695),
    [anon_sym_join] = ACTIONS(3695),
    [anon_sym_on] = ACTIONS(3695),
    [anon_sym_equals] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_orderby] = ACTIONS(3695),
    [anon_sym_ascending] = ACTIONS(3695),
    [anon_sym_descending] = ACTIONS(3695),
    [anon_sym_group] = ACTIONS(3695),
    [anon_sym_by] = ACTIONS(3695),
    [anon_sym_select] = ACTIONS(3695),
    [aux_sym_preproc_if_token1] = ACTIONS(3697),
    [aux_sym_preproc_if_token3] = ACTIONS(3697),
    [aux_sym_preproc_else_token1] = ACTIONS(3697),
    [aux_sym_preproc_elif_token1] = ACTIONS(3697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3389] = {
    [sym_preproc_region] = STATE(3389),
    [sym_preproc_endregion] = STATE(3389),
    [sym_preproc_line] = STATE(3389),
    [sym_preproc_pragma] = STATE(3389),
    [sym_preproc_nullable] = STATE(3389),
    [sym_preproc_error] = STATE(3389),
    [sym_preproc_define] = STATE(3389),
    [sym_preproc_undef] = STATE(3389),
    [sym__identifier_token] = ACTIONS(3407),
    [anon_sym_extern] = ACTIONS(3407),
    [anon_sym_alias] = ACTIONS(3407),
    [anon_sym_global] = ACTIONS(3407),
    [anon_sym_using] = ACTIONS(3407),
    [anon_sym_unsafe] = ACTIONS(3407),
    [anon_sym_static] = ACTIONS(3407),
    [anon_sym_LBRACK] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_event] = ACTIONS(3407),
    [anon_sym_namespace] = ACTIONS(3407),
    [anon_sym_class] = ACTIONS(3407),
    [anon_sym_ref] = ACTIONS(3407),
    [anon_sym_struct] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3407),
    [anon_sym_RBRACE] = ACTIONS(3409),
    [anon_sym_interface] = ACTIONS(3407),
    [anon_sym_delegate] = ACTIONS(3407),
    [anon_sym_record] = ACTIONS(3407),
    [anon_sym_abstract] = ACTIONS(3407),
    [anon_sym_async] = ACTIONS(3407),
    [anon_sym_const] = ACTIONS(3407),
    [anon_sym_file] = ACTIONS(3407),
    [anon_sym_fixed] = ACTIONS(3407),
    [anon_sym_internal] = ACTIONS(3407),
    [anon_sym_new] = ACTIONS(3407),
    [anon_sym_override] = ACTIONS(3407),
    [anon_sym_partial] = ACTIONS(3407),
    [anon_sym_private] = ACTIONS(3407),
    [anon_sym_protected] = ACTIONS(3407),
    [anon_sym_public] = ACTIONS(3407),
    [anon_sym_readonly] = ACTIONS(3407),
    [anon_sym_required] = ACTIONS(3407),
    [anon_sym_sealed] = ACTIONS(3407),
    [anon_sym_virtual] = ACTIONS(3407),
    [anon_sym_volatile] = ACTIONS(3407),
    [anon_sym_where] = ACTIONS(3407),
    [anon_sym_notnull] = ACTIONS(3407),
    [anon_sym_unmanaged] = ACTIONS(3407),
    [anon_sym_TILDE] = ACTIONS(3409),
    [anon_sym_implicit] = ACTIONS(3407),
    [anon_sym_explicit] = ACTIONS(3407),
    [anon_sym_scoped] = ACTIONS(3407),
    [anon_sym_var] = ACTIONS(3407),
    [sym_predefined_type] = ACTIONS(3407),
    [anon_sym_yield] = ACTIONS(3407),
    [anon_sym_when] = ACTIONS(3407),
    [anon_sym_from] = ACTIONS(3407),
    [anon_sym_into] = ACTIONS(3407),
    [anon_sym_join] = ACTIONS(3407),
    [anon_sym_on] = ACTIONS(3407),
    [anon_sym_equals] = ACTIONS(3407),
    [anon_sym_let] = ACTIONS(3407),
    [anon_sym_orderby] = ACTIONS(3407),
    [anon_sym_ascending] = ACTIONS(3407),
    [anon_sym_descending] = ACTIONS(3407),
    [anon_sym_group] = ACTIONS(3407),
    [anon_sym_by] = ACTIONS(3407),
    [anon_sym_select] = ACTIONS(3407),
    [aux_sym_preproc_if_token1] = ACTIONS(3409),
    [aux_sym_preproc_if_token3] = ACTIONS(3409),
    [aux_sym_preproc_else_token1] = ACTIONS(3409),
    [aux_sym_preproc_elif_token1] = ACTIONS(3409),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3390] = {
    [sym_preproc_region] = STATE(3390),
    [sym_preproc_endregion] = STATE(3390),
    [sym_preproc_line] = STATE(3390),
    [sym_preproc_pragma] = STATE(3390),
    [sym_preproc_nullable] = STATE(3390),
    [sym_preproc_error] = STATE(3390),
    [sym_preproc_define] = STATE(3390),
    [sym_preproc_undef] = STATE(3390),
    [sym__identifier_token] = ACTIONS(4465),
    [anon_sym_alias] = ACTIONS(4465),
    [anon_sym_global] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_file] = ACTIONS(4465),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_where] = ACTIONS(4465),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_notnull] = ACTIONS(4465),
    [anon_sym_unmanaged] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_scoped] = ACTIONS(4465),
    [anon_sym_var] = ACTIONS(4465),
    [anon_sym_yield] = ACTIONS(4465),
    [anon_sym_switch] = ACTIONS(4465),
    [anon_sym_when] = ACTIONS(4465),
    [sym_discard] = ACTIONS(4465),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4465),
    [anon_sym_or] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_from] = ACTIONS(4465),
    [anon_sym_into] = ACTIONS(4465),
    [anon_sym_join] = ACTIONS(4465),
    [anon_sym_on] = ACTIONS(4465),
    [anon_sym_equals] = ACTIONS(4465),
    [anon_sym_let] = ACTIONS(4465),
    [anon_sym_orderby] = ACTIONS(4465),
    [anon_sym_ascending] = ACTIONS(4465),
    [anon_sym_descending] = ACTIONS(4465),
    [anon_sym_group] = ACTIONS(4465),
    [anon_sym_by] = ACTIONS(4465),
    [anon_sym_select] = ACTIONS(4465),
    [anon_sym_as] = ACTIONS(4465),
    [anon_sym_is] = ACTIONS(4465),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4465),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4467),
  },
  [3391] = {
    [sym_preproc_region] = STATE(3391),
    [sym_preproc_endregion] = STATE(3391),
    [sym_preproc_line] = STATE(3391),
    [sym_preproc_pragma] = STATE(3391),
    [sym_preproc_nullable] = STATE(3391),
    [sym_preproc_error] = STATE(3391),
    [sym_preproc_define] = STATE(3391),
    [sym_preproc_undef] = STATE(3391),
    [sym__identifier_token] = ACTIONS(3691),
    [anon_sym_extern] = ACTIONS(3691),
    [anon_sym_alias] = ACTIONS(3691),
    [anon_sym_global] = ACTIONS(3691),
    [anon_sym_using] = ACTIONS(3691),
    [anon_sym_unsafe] = ACTIONS(3691),
    [anon_sym_static] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_event] = ACTIONS(3691),
    [anon_sym_namespace] = ACTIONS(3691),
    [anon_sym_class] = ACTIONS(3691),
    [anon_sym_ref] = ACTIONS(3691),
    [anon_sym_struct] = ACTIONS(3691),
    [anon_sym_enum] = ACTIONS(3691),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_interface] = ACTIONS(3691),
    [anon_sym_delegate] = ACTIONS(3691),
    [anon_sym_record] = ACTIONS(3691),
    [anon_sym_abstract] = ACTIONS(3691),
    [anon_sym_async] = ACTIONS(3691),
    [anon_sym_const] = ACTIONS(3691),
    [anon_sym_file] = ACTIONS(3691),
    [anon_sym_fixed] = ACTIONS(3691),
    [anon_sym_internal] = ACTIONS(3691),
    [anon_sym_new] = ACTIONS(3691),
    [anon_sym_override] = ACTIONS(3691),
    [anon_sym_partial] = ACTIONS(3691),
    [anon_sym_private] = ACTIONS(3691),
    [anon_sym_protected] = ACTIONS(3691),
    [anon_sym_public] = ACTIONS(3691),
    [anon_sym_readonly] = ACTIONS(3691),
    [anon_sym_required] = ACTIONS(3691),
    [anon_sym_sealed] = ACTIONS(3691),
    [anon_sym_virtual] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3691),
    [anon_sym_where] = ACTIONS(3691),
    [anon_sym_notnull] = ACTIONS(3691),
    [anon_sym_unmanaged] = ACTIONS(3691),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_implicit] = ACTIONS(3691),
    [anon_sym_explicit] = ACTIONS(3691),
    [anon_sym_scoped] = ACTIONS(3691),
    [anon_sym_var] = ACTIONS(3691),
    [sym_predefined_type] = ACTIONS(3691),
    [anon_sym_yield] = ACTIONS(3691),
    [anon_sym_when] = ACTIONS(3691),
    [anon_sym_from] = ACTIONS(3691),
    [anon_sym_into] = ACTIONS(3691),
    [anon_sym_join] = ACTIONS(3691),
    [anon_sym_on] = ACTIONS(3691),
    [anon_sym_equals] = ACTIONS(3691),
    [anon_sym_let] = ACTIONS(3691),
    [anon_sym_orderby] = ACTIONS(3691),
    [anon_sym_ascending] = ACTIONS(3691),
    [anon_sym_descending] = ACTIONS(3691),
    [anon_sym_group] = ACTIONS(3691),
    [anon_sym_by] = ACTIONS(3691),
    [anon_sym_select] = ACTIONS(3691),
    [aux_sym_preproc_if_token1] = ACTIONS(3693),
    [aux_sym_preproc_if_token3] = ACTIONS(3693),
    [aux_sym_preproc_else_token1] = ACTIONS(3693),
    [aux_sym_preproc_elif_token1] = ACTIONS(3693),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3392] = {
    [sym_preproc_region] = STATE(3392),
    [sym_preproc_endregion] = STATE(3392),
    [sym_preproc_line] = STATE(3392),
    [sym_preproc_pragma] = STATE(3392),
    [sym_preproc_nullable] = STATE(3392),
    [sym_preproc_error] = STATE(3392),
    [sym_preproc_define] = STATE(3392),
    [sym_preproc_undef] = STATE(3392),
    [sym__identifier_token] = ACTIONS(4967),
    [anon_sym_extern] = ACTIONS(4967),
    [anon_sym_alias] = ACTIONS(4967),
    [anon_sym_global] = ACTIONS(4967),
    [anon_sym_using] = ACTIONS(4967),
    [anon_sym_unsafe] = ACTIONS(4967),
    [anon_sym_static] = ACTIONS(4967),
    [anon_sym_LBRACK] = ACTIONS(4969),
    [anon_sym_LPAREN] = ACTIONS(4969),
    [anon_sym_event] = ACTIONS(4967),
    [anon_sym_namespace] = ACTIONS(4967),
    [anon_sym_class] = ACTIONS(4967),
    [anon_sym_ref] = ACTIONS(4967),
    [anon_sym_struct] = ACTIONS(4967),
    [anon_sym_enum] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4969),
    [anon_sym_interface] = ACTIONS(4967),
    [anon_sym_delegate] = ACTIONS(4967),
    [anon_sym_record] = ACTIONS(4967),
    [anon_sym_abstract] = ACTIONS(4967),
    [anon_sym_async] = ACTIONS(4967),
    [anon_sym_const] = ACTIONS(4967),
    [anon_sym_file] = ACTIONS(4967),
    [anon_sym_fixed] = ACTIONS(4967),
    [anon_sym_internal] = ACTIONS(4967),
    [anon_sym_new] = ACTIONS(4967),
    [anon_sym_override] = ACTIONS(4967),
    [anon_sym_partial] = ACTIONS(4967),
    [anon_sym_private] = ACTIONS(4967),
    [anon_sym_protected] = ACTIONS(4967),
    [anon_sym_public] = ACTIONS(4967),
    [anon_sym_readonly] = ACTIONS(4967),
    [anon_sym_required] = ACTIONS(4967),
    [anon_sym_sealed] = ACTIONS(4967),
    [anon_sym_virtual] = ACTIONS(4967),
    [anon_sym_volatile] = ACTIONS(4967),
    [anon_sym_where] = ACTIONS(4967),
    [anon_sym_notnull] = ACTIONS(4967),
    [anon_sym_unmanaged] = ACTIONS(4967),
    [anon_sym_TILDE] = ACTIONS(4969),
    [anon_sym_implicit] = ACTIONS(4967),
    [anon_sym_explicit] = ACTIONS(4967),
    [anon_sym_scoped] = ACTIONS(4967),
    [anon_sym_var] = ACTIONS(4967),
    [sym_predefined_type] = ACTIONS(4967),
    [anon_sym_yield] = ACTIONS(4967),
    [anon_sym_when] = ACTIONS(4967),
    [anon_sym_from] = ACTIONS(4967),
    [anon_sym_into] = ACTIONS(4967),
    [anon_sym_join] = ACTIONS(4967),
    [anon_sym_on] = ACTIONS(4967),
    [anon_sym_equals] = ACTIONS(4967),
    [anon_sym_let] = ACTIONS(4967),
    [anon_sym_orderby] = ACTIONS(4967),
    [anon_sym_ascending] = ACTIONS(4967),
    [anon_sym_descending] = ACTIONS(4967),
    [anon_sym_group] = ACTIONS(4967),
    [anon_sym_by] = ACTIONS(4967),
    [anon_sym_select] = ACTIONS(4967),
    [aux_sym_preproc_if_token1] = ACTIONS(4969),
    [aux_sym_preproc_if_token3] = ACTIONS(4969),
    [aux_sym_preproc_else_token1] = ACTIONS(4969),
    [aux_sym_preproc_elif_token1] = ACTIONS(4969),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3393] = {
    [sym_preproc_region] = STATE(3393),
    [sym_preproc_endregion] = STATE(3393),
    [sym_preproc_line] = STATE(3393),
    [sym_preproc_pragma] = STATE(3393),
    [sym_preproc_nullable] = STATE(3393),
    [sym_preproc_error] = STATE(3393),
    [sym_preproc_define] = STATE(3393),
    [sym_preproc_undef] = STATE(3393),
    [sym__identifier_token] = ACTIONS(3687),
    [anon_sym_extern] = ACTIONS(3687),
    [anon_sym_alias] = ACTIONS(3687),
    [anon_sym_global] = ACTIONS(3687),
    [anon_sym_using] = ACTIONS(3687),
    [anon_sym_unsafe] = ACTIONS(3687),
    [anon_sym_static] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_event] = ACTIONS(3687),
    [anon_sym_namespace] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_ref] = ACTIONS(3687),
    [anon_sym_struct] = ACTIONS(3687),
    [anon_sym_enum] = ACTIONS(3687),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [anon_sym_interface] = ACTIONS(3687),
    [anon_sym_delegate] = ACTIONS(3687),
    [anon_sym_record] = ACTIONS(3687),
    [anon_sym_abstract] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_const] = ACTIONS(3687),
    [anon_sym_file] = ACTIONS(3687),
    [anon_sym_fixed] = ACTIONS(3687),
    [anon_sym_internal] = ACTIONS(3687),
    [anon_sym_new] = ACTIONS(3687),
    [anon_sym_override] = ACTIONS(3687),
    [anon_sym_partial] = ACTIONS(3687),
    [anon_sym_private] = ACTIONS(3687),
    [anon_sym_protected] = ACTIONS(3687),
    [anon_sym_public] = ACTIONS(3687),
    [anon_sym_readonly] = ACTIONS(3687),
    [anon_sym_required] = ACTIONS(3687),
    [anon_sym_sealed] = ACTIONS(3687),
    [anon_sym_virtual] = ACTIONS(3687),
    [anon_sym_volatile] = ACTIONS(3687),
    [anon_sym_where] = ACTIONS(3687),
    [anon_sym_notnull] = ACTIONS(3687),
    [anon_sym_unmanaged] = ACTIONS(3687),
    [anon_sym_TILDE] = ACTIONS(3689),
    [anon_sym_implicit] = ACTIONS(3687),
    [anon_sym_explicit] = ACTIONS(3687),
    [anon_sym_scoped] = ACTIONS(3687),
    [anon_sym_var] = ACTIONS(3687),
    [sym_predefined_type] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [anon_sym_when] = ACTIONS(3687),
    [anon_sym_from] = ACTIONS(3687),
    [anon_sym_into] = ACTIONS(3687),
    [anon_sym_join] = ACTIONS(3687),
    [anon_sym_on] = ACTIONS(3687),
    [anon_sym_equals] = ACTIONS(3687),
    [anon_sym_let] = ACTIONS(3687),
    [anon_sym_orderby] = ACTIONS(3687),
    [anon_sym_ascending] = ACTIONS(3687),
    [anon_sym_descending] = ACTIONS(3687),
    [anon_sym_group] = ACTIONS(3687),
    [anon_sym_by] = ACTIONS(3687),
    [anon_sym_select] = ACTIONS(3687),
    [aux_sym_preproc_if_token1] = ACTIONS(3689),
    [aux_sym_preproc_if_token3] = ACTIONS(3689),
    [aux_sym_preproc_else_token1] = ACTIONS(3689),
    [aux_sym_preproc_elif_token1] = ACTIONS(3689),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3394] = {
    [sym_preproc_region] = STATE(3394),
    [sym_preproc_endregion] = STATE(3394),
    [sym_preproc_line] = STATE(3394),
    [sym_preproc_pragma] = STATE(3394),
    [sym_preproc_nullable] = STATE(3394),
    [sym_preproc_error] = STATE(3394),
    [sym_preproc_define] = STATE(3394),
    [sym_preproc_undef] = STATE(3394),
    [sym__identifier_token] = ACTIONS(4971),
    [anon_sym_extern] = ACTIONS(4971),
    [anon_sym_alias] = ACTIONS(4971),
    [anon_sym_global] = ACTIONS(4971),
    [anon_sym_using] = ACTIONS(4971),
    [anon_sym_unsafe] = ACTIONS(4971),
    [anon_sym_static] = ACTIONS(4971),
    [anon_sym_LBRACK] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym_event] = ACTIONS(4971),
    [anon_sym_namespace] = ACTIONS(4971),
    [anon_sym_class] = ACTIONS(4971),
    [anon_sym_ref] = ACTIONS(4971),
    [anon_sym_struct] = ACTIONS(4971),
    [anon_sym_enum] = ACTIONS(4971),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_interface] = ACTIONS(4971),
    [anon_sym_delegate] = ACTIONS(4971),
    [anon_sym_record] = ACTIONS(4971),
    [anon_sym_abstract] = ACTIONS(4971),
    [anon_sym_async] = ACTIONS(4971),
    [anon_sym_const] = ACTIONS(4971),
    [anon_sym_file] = ACTIONS(4971),
    [anon_sym_fixed] = ACTIONS(4971),
    [anon_sym_internal] = ACTIONS(4971),
    [anon_sym_new] = ACTIONS(4971),
    [anon_sym_override] = ACTIONS(4971),
    [anon_sym_partial] = ACTIONS(4971),
    [anon_sym_private] = ACTIONS(4971),
    [anon_sym_protected] = ACTIONS(4971),
    [anon_sym_public] = ACTIONS(4971),
    [anon_sym_readonly] = ACTIONS(4971),
    [anon_sym_required] = ACTIONS(4971),
    [anon_sym_sealed] = ACTIONS(4971),
    [anon_sym_virtual] = ACTIONS(4971),
    [anon_sym_volatile] = ACTIONS(4971),
    [anon_sym_where] = ACTIONS(4971),
    [anon_sym_notnull] = ACTIONS(4971),
    [anon_sym_unmanaged] = ACTIONS(4971),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_implicit] = ACTIONS(4971),
    [anon_sym_explicit] = ACTIONS(4971),
    [anon_sym_scoped] = ACTIONS(4971),
    [anon_sym_var] = ACTIONS(4971),
    [sym_predefined_type] = ACTIONS(4971),
    [anon_sym_yield] = ACTIONS(4971),
    [anon_sym_when] = ACTIONS(4971),
    [anon_sym_from] = ACTIONS(4971),
    [anon_sym_into] = ACTIONS(4971),
    [anon_sym_join] = ACTIONS(4971),
    [anon_sym_on] = ACTIONS(4971),
    [anon_sym_equals] = ACTIONS(4971),
    [anon_sym_let] = ACTIONS(4971),
    [anon_sym_orderby] = ACTIONS(4971),
    [anon_sym_ascending] = ACTIONS(4971),
    [anon_sym_descending] = ACTIONS(4971),
    [anon_sym_group] = ACTIONS(4971),
    [anon_sym_by] = ACTIONS(4971),
    [anon_sym_select] = ACTIONS(4971),
    [aux_sym_preproc_if_token1] = ACTIONS(4973),
    [aux_sym_preproc_if_token3] = ACTIONS(4973),
    [aux_sym_preproc_else_token1] = ACTIONS(4973),
    [aux_sym_preproc_elif_token1] = ACTIONS(4973),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3395] = {
    [sym_preproc_region] = STATE(3395),
    [sym_preproc_endregion] = STATE(3395),
    [sym_preproc_line] = STATE(3395),
    [sym_preproc_pragma] = STATE(3395),
    [sym_preproc_nullable] = STATE(3395),
    [sym_preproc_error] = STATE(3395),
    [sym_preproc_define] = STATE(3395),
    [sym_preproc_undef] = STATE(3395),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4975),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3396] = {
    [sym_preproc_region] = STATE(3396),
    [sym_preproc_endregion] = STATE(3396),
    [sym_preproc_line] = STATE(3396),
    [sym_preproc_pragma] = STATE(3396),
    [sym_preproc_nullable] = STATE(3396),
    [sym_preproc_error] = STATE(3396),
    [sym_preproc_define] = STATE(3396),
    [sym_preproc_undef] = STATE(3396),
    [sym__identifier_token] = ACTIONS(3671),
    [anon_sym_extern] = ACTIONS(3671),
    [anon_sym_alias] = ACTIONS(3671),
    [anon_sym_global] = ACTIONS(3671),
    [anon_sym_using] = ACTIONS(3671),
    [anon_sym_unsafe] = ACTIONS(3671),
    [anon_sym_static] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3673),
    [anon_sym_LPAREN] = ACTIONS(3673),
    [anon_sym_event] = ACTIONS(3671),
    [anon_sym_namespace] = ACTIONS(3671),
    [anon_sym_class] = ACTIONS(3671),
    [anon_sym_ref] = ACTIONS(3671),
    [anon_sym_struct] = ACTIONS(3671),
    [anon_sym_enum] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_interface] = ACTIONS(3671),
    [anon_sym_delegate] = ACTIONS(3671),
    [anon_sym_record] = ACTIONS(3671),
    [anon_sym_abstract] = ACTIONS(3671),
    [anon_sym_async] = ACTIONS(3671),
    [anon_sym_const] = ACTIONS(3671),
    [anon_sym_file] = ACTIONS(3671),
    [anon_sym_fixed] = ACTIONS(3671),
    [anon_sym_internal] = ACTIONS(3671),
    [anon_sym_new] = ACTIONS(3671),
    [anon_sym_override] = ACTIONS(3671),
    [anon_sym_partial] = ACTIONS(3671),
    [anon_sym_private] = ACTIONS(3671),
    [anon_sym_protected] = ACTIONS(3671),
    [anon_sym_public] = ACTIONS(3671),
    [anon_sym_readonly] = ACTIONS(3671),
    [anon_sym_required] = ACTIONS(3671),
    [anon_sym_sealed] = ACTIONS(3671),
    [anon_sym_virtual] = ACTIONS(3671),
    [anon_sym_volatile] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_notnull] = ACTIONS(3671),
    [anon_sym_unmanaged] = ACTIONS(3671),
    [anon_sym_TILDE] = ACTIONS(3673),
    [anon_sym_implicit] = ACTIONS(3671),
    [anon_sym_explicit] = ACTIONS(3671),
    [anon_sym_scoped] = ACTIONS(3671),
    [anon_sym_var] = ACTIONS(3671),
    [sym_predefined_type] = ACTIONS(3671),
    [anon_sym_yield] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_from] = ACTIONS(3671),
    [anon_sym_into] = ACTIONS(3671),
    [anon_sym_join] = ACTIONS(3671),
    [anon_sym_on] = ACTIONS(3671),
    [anon_sym_equals] = ACTIONS(3671),
    [anon_sym_let] = ACTIONS(3671),
    [anon_sym_orderby] = ACTIONS(3671),
    [anon_sym_ascending] = ACTIONS(3671),
    [anon_sym_descending] = ACTIONS(3671),
    [anon_sym_group] = ACTIONS(3671),
    [anon_sym_by] = ACTIONS(3671),
    [anon_sym_select] = ACTIONS(3671),
    [aux_sym_preproc_if_token1] = ACTIONS(3673),
    [aux_sym_preproc_if_token3] = ACTIONS(3673),
    [aux_sym_preproc_else_token1] = ACTIONS(3673),
    [aux_sym_preproc_elif_token1] = ACTIONS(3673),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3397] = {
    [sym_preproc_region] = STATE(3397),
    [sym_preproc_endregion] = STATE(3397),
    [sym_preproc_line] = STATE(3397),
    [sym_preproc_pragma] = STATE(3397),
    [sym_preproc_nullable] = STATE(3397),
    [sym_preproc_error] = STATE(3397),
    [sym_preproc_define] = STATE(3397),
    [sym_preproc_undef] = STATE(3397),
    [sym__identifier_token] = ACTIONS(4977),
    [anon_sym_extern] = ACTIONS(4977),
    [anon_sym_alias] = ACTIONS(4977),
    [anon_sym_global] = ACTIONS(4977),
    [anon_sym_using] = ACTIONS(4977),
    [anon_sym_unsafe] = ACTIONS(4977),
    [anon_sym_static] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4979),
    [anon_sym_LPAREN] = ACTIONS(4979),
    [anon_sym_event] = ACTIONS(4977),
    [anon_sym_namespace] = ACTIONS(4977),
    [anon_sym_class] = ACTIONS(4977),
    [anon_sym_ref] = ACTIONS(4977),
    [anon_sym_struct] = ACTIONS(4977),
    [anon_sym_enum] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_interface] = ACTIONS(4977),
    [anon_sym_delegate] = ACTIONS(4977),
    [anon_sym_record] = ACTIONS(4977),
    [anon_sym_abstract] = ACTIONS(4977),
    [anon_sym_async] = ACTIONS(4977),
    [anon_sym_const] = ACTIONS(4977),
    [anon_sym_file] = ACTIONS(4977),
    [anon_sym_fixed] = ACTIONS(4977),
    [anon_sym_internal] = ACTIONS(4977),
    [anon_sym_new] = ACTIONS(4977),
    [anon_sym_override] = ACTIONS(4977),
    [anon_sym_partial] = ACTIONS(4977),
    [anon_sym_private] = ACTIONS(4977),
    [anon_sym_protected] = ACTIONS(4977),
    [anon_sym_public] = ACTIONS(4977),
    [anon_sym_readonly] = ACTIONS(4977),
    [anon_sym_required] = ACTIONS(4977),
    [anon_sym_sealed] = ACTIONS(4977),
    [anon_sym_virtual] = ACTIONS(4977),
    [anon_sym_volatile] = ACTIONS(4977),
    [anon_sym_where] = ACTIONS(4977),
    [anon_sym_notnull] = ACTIONS(4977),
    [anon_sym_unmanaged] = ACTIONS(4977),
    [anon_sym_TILDE] = ACTIONS(4979),
    [anon_sym_implicit] = ACTIONS(4977),
    [anon_sym_explicit] = ACTIONS(4977),
    [anon_sym_scoped] = ACTIONS(4977),
    [anon_sym_var] = ACTIONS(4977),
    [sym_predefined_type] = ACTIONS(4977),
    [anon_sym_yield] = ACTIONS(4977),
    [anon_sym_when] = ACTIONS(4977),
    [anon_sym_from] = ACTIONS(4977),
    [anon_sym_into] = ACTIONS(4977),
    [anon_sym_join] = ACTIONS(4977),
    [anon_sym_on] = ACTIONS(4977),
    [anon_sym_equals] = ACTIONS(4977),
    [anon_sym_let] = ACTIONS(4977),
    [anon_sym_orderby] = ACTIONS(4977),
    [anon_sym_ascending] = ACTIONS(4977),
    [anon_sym_descending] = ACTIONS(4977),
    [anon_sym_group] = ACTIONS(4977),
    [anon_sym_by] = ACTIONS(4977),
    [anon_sym_select] = ACTIONS(4977),
    [aux_sym_preproc_if_token1] = ACTIONS(4979),
    [aux_sym_preproc_if_token3] = ACTIONS(4979),
    [aux_sym_preproc_else_token1] = ACTIONS(4979),
    [aux_sym_preproc_elif_token1] = ACTIONS(4979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3398] = {
    [sym_preproc_region] = STATE(3398),
    [sym_preproc_endregion] = STATE(3398),
    [sym_preproc_line] = STATE(3398),
    [sym_preproc_pragma] = STATE(3398),
    [sym_preproc_nullable] = STATE(3398),
    [sym_preproc_error] = STATE(3398),
    [sym_preproc_define] = STATE(3398),
    [sym_preproc_undef] = STATE(3398),
    [sym__identifier_token] = ACTIONS(3499),
    [anon_sym_extern] = ACTIONS(3499),
    [anon_sym_alias] = ACTIONS(3499),
    [anon_sym_global] = ACTIONS(3499),
    [anon_sym_using] = ACTIONS(3499),
    [anon_sym_unsafe] = ACTIONS(3499),
    [anon_sym_static] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_event] = ACTIONS(3499),
    [anon_sym_namespace] = ACTIONS(3499),
    [anon_sym_class] = ACTIONS(3499),
    [anon_sym_ref] = ACTIONS(3499),
    [anon_sym_struct] = ACTIONS(3499),
    [anon_sym_enum] = ACTIONS(3499),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_interface] = ACTIONS(3499),
    [anon_sym_delegate] = ACTIONS(3499),
    [anon_sym_record] = ACTIONS(3499),
    [anon_sym_abstract] = ACTIONS(3499),
    [anon_sym_async] = ACTIONS(3499),
    [anon_sym_const] = ACTIONS(3499),
    [anon_sym_file] = ACTIONS(3499),
    [anon_sym_fixed] = ACTIONS(3499),
    [anon_sym_internal] = ACTIONS(3499),
    [anon_sym_new] = ACTIONS(3499),
    [anon_sym_override] = ACTIONS(3499),
    [anon_sym_partial] = ACTIONS(3499),
    [anon_sym_private] = ACTIONS(3499),
    [anon_sym_protected] = ACTIONS(3499),
    [anon_sym_public] = ACTIONS(3499),
    [anon_sym_readonly] = ACTIONS(3499),
    [anon_sym_required] = ACTIONS(3499),
    [anon_sym_sealed] = ACTIONS(3499),
    [anon_sym_virtual] = ACTIONS(3499),
    [anon_sym_volatile] = ACTIONS(3499),
    [anon_sym_where] = ACTIONS(3499),
    [anon_sym_notnull] = ACTIONS(3499),
    [anon_sym_unmanaged] = ACTIONS(3499),
    [anon_sym_TILDE] = ACTIONS(3501),
    [anon_sym_implicit] = ACTIONS(3499),
    [anon_sym_explicit] = ACTIONS(3499),
    [anon_sym_scoped] = ACTIONS(3499),
    [anon_sym_var] = ACTIONS(3499),
    [sym_predefined_type] = ACTIONS(3499),
    [anon_sym_yield] = ACTIONS(3499),
    [anon_sym_when] = ACTIONS(3499),
    [anon_sym_from] = ACTIONS(3499),
    [anon_sym_into] = ACTIONS(3499),
    [anon_sym_join] = ACTIONS(3499),
    [anon_sym_on] = ACTIONS(3499),
    [anon_sym_equals] = ACTIONS(3499),
    [anon_sym_let] = ACTIONS(3499),
    [anon_sym_orderby] = ACTIONS(3499),
    [anon_sym_ascending] = ACTIONS(3499),
    [anon_sym_descending] = ACTIONS(3499),
    [anon_sym_group] = ACTIONS(3499),
    [anon_sym_by] = ACTIONS(3499),
    [anon_sym_select] = ACTIONS(3499),
    [aux_sym_preproc_if_token1] = ACTIONS(3501),
    [aux_sym_preproc_if_token3] = ACTIONS(3501),
    [aux_sym_preproc_else_token1] = ACTIONS(3501),
    [aux_sym_preproc_elif_token1] = ACTIONS(3501),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3399] = {
    [sym_preproc_region] = STATE(3399),
    [sym_preproc_endregion] = STATE(3399),
    [sym_preproc_line] = STATE(3399),
    [sym_preproc_pragma] = STATE(3399),
    [sym_preproc_nullable] = STATE(3399),
    [sym_preproc_error] = STATE(3399),
    [sym_preproc_define] = STATE(3399),
    [sym_preproc_undef] = STATE(3399),
    [sym__identifier_token] = ACTIONS(3495),
    [anon_sym_extern] = ACTIONS(3495),
    [anon_sym_alias] = ACTIONS(3495),
    [anon_sym_global] = ACTIONS(3495),
    [anon_sym_using] = ACTIONS(3495),
    [anon_sym_unsafe] = ACTIONS(3495),
    [anon_sym_static] = ACTIONS(3495),
    [anon_sym_LBRACK] = ACTIONS(3497),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_event] = ACTIONS(3495),
    [anon_sym_namespace] = ACTIONS(3495),
    [anon_sym_class] = ACTIONS(3495),
    [anon_sym_ref] = ACTIONS(3495),
    [anon_sym_struct] = ACTIONS(3495),
    [anon_sym_enum] = ACTIONS(3495),
    [anon_sym_RBRACE] = ACTIONS(3497),
    [anon_sym_interface] = ACTIONS(3495),
    [anon_sym_delegate] = ACTIONS(3495),
    [anon_sym_record] = ACTIONS(3495),
    [anon_sym_abstract] = ACTIONS(3495),
    [anon_sym_async] = ACTIONS(3495),
    [anon_sym_const] = ACTIONS(3495),
    [anon_sym_file] = ACTIONS(3495),
    [anon_sym_fixed] = ACTIONS(3495),
    [anon_sym_internal] = ACTIONS(3495),
    [anon_sym_new] = ACTIONS(3495),
    [anon_sym_override] = ACTIONS(3495),
    [anon_sym_partial] = ACTIONS(3495),
    [anon_sym_private] = ACTIONS(3495),
    [anon_sym_protected] = ACTIONS(3495),
    [anon_sym_public] = ACTIONS(3495),
    [anon_sym_readonly] = ACTIONS(3495),
    [anon_sym_required] = ACTIONS(3495),
    [anon_sym_sealed] = ACTIONS(3495),
    [anon_sym_virtual] = ACTIONS(3495),
    [anon_sym_volatile] = ACTIONS(3495),
    [anon_sym_where] = ACTIONS(3495),
    [anon_sym_notnull] = ACTIONS(3495),
    [anon_sym_unmanaged] = ACTIONS(3495),
    [anon_sym_TILDE] = ACTIONS(3497),
    [anon_sym_implicit] = ACTIONS(3495),
    [anon_sym_explicit] = ACTIONS(3495),
    [anon_sym_scoped] = ACTIONS(3495),
    [anon_sym_var] = ACTIONS(3495),
    [sym_predefined_type] = ACTIONS(3495),
    [anon_sym_yield] = ACTIONS(3495),
    [anon_sym_when] = ACTIONS(3495),
    [anon_sym_from] = ACTIONS(3495),
    [anon_sym_into] = ACTIONS(3495),
    [anon_sym_join] = ACTIONS(3495),
    [anon_sym_on] = ACTIONS(3495),
    [anon_sym_equals] = ACTIONS(3495),
    [anon_sym_let] = ACTIONS(3495),
    [anon_sym_orderby] = ACTIONS(3495),
    [anon_sym_ascending] = ACTIONS(3495),
    [anon_sym_descending] = ACTIONS(3495),
    [anon_sym_group] = ACTIONS(3495),
    [anon_sym_by] = ACTIONS(3495),
    [anon_sym_select] = ACTIONS(3495),
    [aux_sym_preproc_if_token1] = ACTIONS(3497),
    [aux_sym_preproc_if_token3] = ACTIONS(3497),
    [aux_sym_preproc_else_token1] = ACTIONS(3497),
    [aux_sym_preproc_elif_token1] = ACTIONS(3497),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3400] = {
    [sym_preproc_region] = STATE(3400),
    [sym_preproc_endregion] = STATE(3400),
    [sym_preproc_line] = STATE(3400),
    [sym_preproc_pragma] = STATE(3400),
    [sym_preproc_nullable] = STATE(3400),
    [sym_preproc_error] = STATE(3400),
    [sym_preproc_define] = STATE(3400),
    [sym_preproc_undef] = STATE(3400),
    [sym__identifier_token] = ACTIONS(4981),
    [anon_sym_extern] = ACTIONS(4981),
    [anon_sym_alias] = ACTIONS(4981),
    [anon_sym_global] = ACTIONS(4981),
    [anon_sym_using] = ACTIONS(4981),
    [anon_sym_unsafe] = ACTIONS(4981),
    [anon_sym_static] = ACTIONS(4981),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_event] = ACTIONS(4981),
    [anon_sym_namespace] = ACTIONS(4981),
    [anon_sym_class] = ACTIONS(4981),
    [anon_sym_ref] = ACTIONS(4981),
    [anon_sym_struct] = ACTIONS(4981),
    [anon_sym_enum] = ACTIONS(4981),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_interface] = ACTIONS(4981),
    [anon_sym_delegate] = ACTIONS(4981),
    [anon_sym_record] = ACTIONS(4981),
    [anon_sym_abstract] = ACTIONS(4981),
    [anon_sym_async] = ACTIONS(4981),
    [anon_sym_const] = ACTIONS(4981),
    [anon_sym_file] = ACTIONS(4981),
    [anon_sym_fixed] = ACTIONS(4981),
    [anon_sym_internal] = ACTIONS(4981),
    [anon_sym_new] = ACTIONS(4981),
    [anon_sym_override] = ACTIONS(4981),
    [anon_sym_partial] = ACTIONS(4981),
    [anon_sym_private] = ACTIONS(4981),
    [anon_sym_protected] = ACTIONS(4981),
    [anon_sym_public] = ACTIONS(4981),
    [anon_sym_readonly] = ACTIONS(4981),
    [anon_sym_required] = ACTIONS(4981),
    [anon_sym_sealed] = ACTIONS(4981),
    [anon_sym_virtual] = ACTIONS(4981),
    [anon_sym_volatile] = ACTIONS(4981),
    [anon_sym_where] = ACTIONS(4981),
    [anon_sym_notnull] = ACTIONS(4981),
    [anon_sym_unmanaged] = ACTIONS(4981),
    [anon_sym_TILDE] = ACTIONS(4983),
    [anon_sym_implicit] = ACTIONS(4981),
    [anon_sym_explicit] = ACTIONS(4981),
    [anon_sym_scoped] = ACTIONS(4981),
    [anon_sym_var] = ACTIONS(4981),
    [sym_predefined_type] = ACTIONS(4981),
    [anon_sym_yield] = ACTIONS(4981),
    [anon_sym_when] = ACTIONS(4981),
    [anon_sym_from] = ACTIONS(4981),
    [anon_sym_into] = ACTIONS(4981),
    [anon_sym_join] = ACTIONS(4981),
    [anon_sym_on] = ACTIONS(4981),
    [anon_sym_equals] = ACTIONS(4981),
    [anon_sym_let] = ACTIONS(4981),
    [anon_sym_orderby] = ACTIONS(4981),
    [anon_sym_ascending] = ACTIONS(4981),
    [anon_sym_descending] = ACTIONS(4981),
    [anon_sym_group] = ACTIONS(4981),
    [anon_sym_by] = ACTIONS(4981),
    [anon_sym_select] = ACTIONS(4981),
    [aux_sym_preproc_if_token1] = ACTIONS(4983),
    [aux_sym_preproc_if_token3] = ACTIONS(4983),
    [aux_sym_preproc_else_token1] = ACTIONS(4983),
    [aux_sym_preproc_elif_token1] = ACTIONS(4983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3401] = {
    [sym_preproc_region] = STATE(3401),
    [sym_preproc_endregion] = STATE(3401),
    [sym_preproc_line] = STATE(3401),
    [sym_preproc_pragma] = STATE(3401),
    [sym_preproc_nullable] = STATE(3401),
    [sym_preproc_error] = STATE(3401),
    [sym_preproc_define] = STATE(3401),
    [sym_preproc_undef] = STATE(3401),
    [sym__identifier_token] = ACTIONS(4985),
    [anon_sym_extern] = ACTIONS(4985),
    [anon_sym_alias] = ACTIONS(4985),
    [anon_sym_global] = ACTIONS(4985),
    [anon_sym_using] = ACTIONS(4985),
    [anon_sym_unsafe] = ACTIONS(4985),
    [anon_sym_static] = ACTIONS(4985),
    [anon_sym_LBRACK] = ACTIONS(4987),
    [anon_sym_LPAREN] = ACTIONS(4987),
    [anon_sym_event] = ACTIONS(4985),
    [anon_sym_namespace] = ACTIONS(4985),
    [anon_sym_class] = ACTIONS(4985),
    [anon_sym_ref] = ACTIONS(4985),
    [anon_sym_struct] = ACTIONS(4985),
    [anon_sym_enum] = ACTIONS(4985),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_interface] = ACTIONS(4985),
    [anon_sym_delegate] = ACTIONS(4985),
    [anon_sym_record] = ACTIONS(4985),
    [anon_sym_abstract] = ACTIONS(4985),
    [anon_sym_async] = ACTIONS(4985),
    [anon_sym_const] = ACTIONS(4985),
    [anon_sym_file] = ACTIONS(4985),
    [anon_sym_fixed] = ACTIONS(4985),
    [anon_sym_internal] = ACTIONS(4985),
    [anon_sym_new] = ACTIONS(4985),
    [anon_sym_override] = ACTIONS(4985),
    [anon_sym_partial] = ACTIONS(4985),
    [anon_sym_private] = ACTIONS(4985),
    [anon_sym_protected] = ACTIONS(4985),
    [anon_sym_public] = ACTIONS(4985),
    [anon_sym_readonly] = ACTIONS(4985),
    [anon_sym_required] = ACTIONS(4985),
    [anon_sym_sealed] = ACTIONS(4985),
    [anon_sym_virtual] = ACTIONS(4985),
    [anon_sym_volatile] = ACTIONS(4985),
    [anon_sym_where] = ACTIONS(4985),
    [anon_sym_notnull] = ACTIONS(4985),
    [anon_sym_unmanaged] = ACTIONS(4985),
    [anon_sym_TILDE] = ACTIONS(4987),
    [anon_sym_implicit] = ACTIONS(4985),
    [anon_sym_explicit] = ACTIONS(4985),
    [anon_sym_scoped] = ACTIONS(4985),
    [anon_sym_var] = ACTIONS(4985),
    [sym_predefined_type] = ACTIONS(4985),
    [anon_sym_yield] = ACTIONS(4985),
    [anon_sym_when] = ACTIONS(4985),
    [anon_sym_from] = ACTIONS(4985),
    [anon_sym_into] = ACTIONS(4985),
    [anon_sym_join] = ACTIONS(4985),
    [anon_sym_on] = ACTIONS(4985),
    [anon_sym_equals] = ACTIONS(4985),
    [anon_sym_let] = ACTIONS(4985),
    [anon_sym_orderby] = ACTIONS(4985),
    [anon_sym_ascending] = ACTIONS(4985),
    [anon_sym_descending] = ACTIONS(4985),
    [anon_sym_group] = ACTIONS(4985),
    [anon_sym_by] = ACTIONS(4985),
    [anon_sym_select] = ACTIONS(4985),
    [aux_sym_preproc_if_token1] = ACTIONS(4987),
    [aux_sym_preproc_if_token3] = ACTIONS(4987),
    [aux_sym_preproc_else_token1] = ACTIONS(4987),
    [aux_sym_preproc_elif_token1] = ACTIONS(4987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3402] = {
    [sym_preproc_region] = STATE(3402),
    [sym_preproc_endregion] = STATE(3402),
    [sym_preproc_line] = STATE(3402),
    [sym_preproc_pragma] = STATE(3402),
    [sym_preproc_nullable] = STATE(3402),
    [sym_preproc_error] = STATE(3402),
    [sym_preproc_define] = STATE(3402),
    [sym_preproc_undef] = STATE(3402),
    [sym__identifier_token] = ACTIONS(4989),
    [anon_sym_extern] = ACTIONS(4989),
    [anon_sym_alias] = ACTIONS(4989),
    [anon_sym_global] = ACTIONS(4989),
    [anon_sym_using] = ACTIONS(4989),
    [anon_sym_unsafe] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4991),
    [anon_sym_LPAREN] = ACTIONS(4991),
    [anon_sym_event] = ACTIONS(4989),
    [anon_sym_namespace] = ACTIONS(4989),
    [anon_sym_class] = ACTIONS(4989),
    [anon_sym_ref] = ACTIONS(4989),
    [anon_sym_struct] = ACTIONS(4989),
    [anon_sym_enum] = ACTIONS(4989),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_interface] = ACTIONS(4989),
    [anon_sym_delegate] = ACTIONS(4989),
    [anon_sym_record] = ACTIONS(4989),
    [anon_sym_abstract] = ACTIONS(4989),
    [anon_sym_async] = ACTIONS(4989),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_file] = ACTIONS(4989),
    [anon_sym_fixed] = ACTIONS(4989),
    [anon_sym_internal] = ACTIONS(4989),
    [anon_sym_new] = ACTIONS(4989),
    [anon_sym_override] = ACTIONS(4989),
    [anon_sym_partial] = ACTIONS(4989),
    [anon_sym_private] = ACTIONS(4989),
    [anon_sym_protected] = ACTIONS(4989),
    [anon_sym_public] = ACTIONS(4989),
    [anon_sym_readonly] = ACTIONS(4989),
    [anon_sym_required] = ACTIONS(4989),
    [anon_sym_sealed] = ACTIONS(4989),
    [anon_sym_virtual] = ACTIONS(4989),
    [anon_sym_volatile] = ACTIONS(4989),
    [anon_sym_where] = ACTIONS(4989),
    [anon_sym_notnull] = ACTIONS(4989),
    [anon_sym_unmanaged] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4991),
    [anon_sym_implicit] = ACTIONS(4989),
    [anon_sym_explicit] = ACTIONS(4989),
    [anon_sym_scoped] = ACTIONS(4989),
    [anon_sym_var] = ACTIONS(4989),
    [sym_predefined_type] = ACTIONS(4989),
    [anon_sym_yield] = ACTIONS(4989),
    [anon_sym_when] = ACTIONS(4989),
    [anon_sym_from] = ACTIONS(4989),
    [anon_sym_into] = ACTIONS(4989),
    [anon_sym_join] = ACTIONS(4989),
    [anon_sym_on] = ACTIONS(4989),
    [anon_sym_equals] = ACTIONS(4989),
    [anon_sym_let] = ACTIONS(4989),
    [anon_sym_orderby] = ACTIONS(4989),
    [anon_sym_ascending] = ACTIONS(4989),
    [anon_sym_descending] = ACTIONS(4989),
    [anon_sym_group] = ACTIONS(4989),
    [anon_sym_by] = ACTIONS(4989),
    [anon_sym_select] = ACTIONS(4989),
    [aux_sym_preproc_if_token1] = ACTIONS(4991),
    [aux_sym_preproc_if_token3] = ACTIONS(4991),
    [aux_sym_preproc_else_token1] = ACTIONS(4991),
    [aux_sym_preproc_elif_token1] = ACTIONS(4991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3403] = {
    [sym_preproc_region] = STATE(3403),
    [sym_preproc_endregion] = STATE(3403),
    [sym_preproc_line] = STATE(3403),
    [sym_preproc_pragma] = STATE(3403),
    [sym_preproc_nullable] = STATE(3403),
    [sym_preproc_error] = STATE(3403),
    [sym_preproc_define] = STATE(3403),
    [sym_preproc_undef] = STATE(3403),
    [sym__identifier_token] = ACTIONS(3483),
    [anon_sym_extern] = ACTIONS(3483),
    [anon_sym_alias] = ACTIONS(3483),
    [anon_sym_global] = ACTIONS(3483),
    [anon_sym_using] = ACTIONS(3483),
    [anon_sym_unsafe] = ACTIONS(3483),
    [anon_sym_static] = ACTIONS(3483),
    [anon_sym_LBRACK] = ACTIONS(3485),
    [anon_sym_LPAREN] = ACTIONS(3485),
    [anon_sym_event] = ACTIONS(3483),
    [anon_sym_namespace] = ACTIONS(3483),
    [anon_sym_class] = ACTIONS(3483),
    [anon_sym_ref] = ACTIONS(3483),
    [anon_sym_struct] = ACTIONS(3483),
    [anon_sym_enum] = ACTIONS(3483),
    [anon_sym_RBRACE] = ACTIONS(3485),
    [anon_sym_interface] = ACTIONS(3483),
    [anon_sym_delegate] = ACTIONS(3483),
    [anon_sym_record] = ACTIONS(3483),
    [anon_sym_abstract] = ACTIONS(3483),
    [anon_sym_async] = ACTIONS(3483),
    [anon_sym_const] = ACTIONS(3483),
    [anon_sym_file] = ACTIONS(3483),
    [anon_sym_fixed] = ACTIONS(3483),
    [anon_sym_internal] = ACTIONS(3483),
    [anon_sym_new] = ACTIONS(3483),
    [anon_sym_override] = ACTIONS(3483),
    [anon_sym_partial] = ACTIONS(3483),
    [anon_sym_private] = ACTIONS(3483),
    [anon_sym_protected] = ACTIONS(3483),
    [anon_sym_public] = ACTIONS(3483),
    [anon_sym_readonly] = ACTIONS(3483),
    [anon_sym_required] = ACTIONS(3483),
    [anon_sym_sealed] = ACTIONS(3483),
    [anon_sym_virtual] = ACTIONS(3483),
    [anon_sym_volatile] = ACTIONS(3483),
    [anon_sym_where] = ACTIONS(3483),
    [anon_sym_notnull] = ACTIONS(3483),
    [anon_sym_unmanaged] = ACTIONS(3483),
    [anon_sym_TILDE] = ACTIONS(3485),
    [anon_sym_implicit] = ACTIONS(3483),
    [anon_sym_explicit] = ACTIONS(3483),
    [anon_sym_scoped] = ACTIONS(3483),
    [anon_sym_var] = ACTIONS(3483),
    [sym_predefined_type] = ACTIONS(3483),
    [anon_sym_yield] = ACTIONS(3483),
    [anon_sym_when] = ACTIONS(3483),
    [anon_sym_from] = ACTIONS(3483),
    [anon_sym_into] = ACTIONS(3483),
    [anon_sym_join] = ACTIONS(3483),
    [anon_sym_on] = ACTIONS(3483),
    [anon_sym_equals] = ACTIONS(3483),
    [anon_sym_let] = ACTIONS(3483),
    [anon_sym_orderby] = ACTIONS(3483),
    [anon_sym_ascending] = ACTIONS(3483),
    [anon_sym_descending] = ACTIONS(3483),
    [anon_sym_group] = ACTIONS(3483),
    [anon_sym_by] = ACTIONS(3483),
    [anon_sym_select] = ACTIONS(3483),
    [aux_sym_preproc_if_token1] = ACTIONS(3485),
    [aux_sym_preproc_if_token3] = ACTIONS(3485),
    [aux_sym_preproc_else_token1] = ACTIONS(3485),
    [aux_sym_preproc_elif_token1] = ACTIONS(3485),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3404] = {
    [sym_preproc_region] = STATE(3404),
    [sym_preproc_endregion] = STATE(3404),
    [sym_preproc_line] = STATE(3404),
    [sym_preproc_pragma] = STATE(3404),
    [sym_preproc_nullable] = STATE(3404),
    [sym_preproc_error] = STATE(3404),
    [sym_preproc_define] = STATE(3404),
    [sym_preproc_undef] = STATE(3404),
    [sym__identifier_token] = ACTIONS(3475),
    [anon_sym_extern] = ACTIONS(3475),
    [anon_sym_alias] = ACTIONS(3475),
    [anon_sym_global] = ACTIONS(3475),
    [anon_sym_using] = ACTIONS(3475),
    [anon_sym_unsafe] = ACTIONS(3475),
    [anon_sym_static] = ACTIONS(3475),
    [anon_sym_LBRACK] = ACTIONS(3477),
    [anon_sym_LPAREN] = ACTIONS(3477),
    [anon_sym_event] = ACTIONS(3475),
    [anon_sym_namespace] = ACTIONS(3475),
    [anon_sym_class] = ACTIONS(3475),
    [anon_sym_ref] = ACTIONS(3475),
    [anon_sym_struct] = ACTIONS(3475),
    [anon_sym_enum] = ACTIONS(3475),
    [anon_sym_RBRACE] = ACTIONS(3477),
    [anon_sym_interface] = ACTIONS(3475),
    [anon_sym_delegate] = ACTIONS(3475),
    [anon_sym_record] = ACTIONS(3475),
    [anon_sym_abstract] = ACTIONS(3475),
    [anon_sym_async] = ACTIONS(3475),
    [anon_sym_const] = ACTIONS(3475),
    [anon_sym_file] = ACTIONS(3475),
    [anon_sym_fixed] = ACTIONS(3475),
    [anon_sym_internal] = ACTIONS(3475),
    [anon_sym_new] = ACTIONS(3475),
    [anon_sym_override] = ACTIONS(3475),
    [anon_sym_partial] = ACTIONS(3475),
    [anon_sym_private] = ACTIONS(3475),
    [anon_sym_protected] = ACTIONS(3475),
    [anon_sym_public] = ACTIONS(3475),
    [anon_sym_readonly] = ACTIONS(3475),
    [anon_sym_required] = ACTIONS(3475),
    [anon_sym_sealed] = ACTIONS(3475),
    [anon_sym_virtual] = ACTIONS(3475),
    [anon_sym_volatile] = ACTIONS(3475),
    [anon_sym_where] = ACTIONS(3475),
    [anon_sym_notnull] = ACTIONS(3475),
    [anon_sym_unmanaged] = ACTIONS(3475),
    [anon_sym_TILDE] = ACTIONS(3477),
    [anon_sym_implicit] = ACTIONS(3475),
    [anon_sym_explicit] = ACTIONS(3475),
    [anon_sym_scoped] = ACTIONS(3475),
    [anon_sym_var] = ACTIONS(3475),
    [sym_predefined_type] = ACTIONS(3475),
    [anon_sym_yield] = ACTIONS(3475),
    [anon_sym_when] = ACTIONS(3475),
    [anon_sym_from] = ACTIONS(3475),
    [anon_sym_into] = ACTIONS(3475),
    [anon_sym_join] = ACTIONS(3475),
    [anon_sym_on] = ACTIONS(3475),
    [anon_sym_equals] = ACTIONS(3475),
    [anon_sym_let] = ACTIONS(3475),
    [anon_sym_orderby] = ACTIONS(3475),
    [anon_sym_ascending] = ACTIONS(3475),
    [anon_sym_descending] = ACTIONS(3475),
    [anon_sym_group] = ACTIONS(3475),
    [anon_sym_by] = ACTIONS(3475),
    [anon_sym_select] = ACTIONS(3475),
    [aux_sym_preproc_if_token1] = ACTIONS(3477),
    [aux_sym_preproc_if_token3] = ACTIONS(3477),
    [aux_sym_preproc_else_token1] = ACTIONS(3477),
    [aux_sym_preproc_elif_token1] = ACTIONS(3477),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3405] = {
    [sym_preproc_region] = STATE(3405),
    [sym_preproc_endregion] = STATE(3405),
    [sym_preproc_line] = STATE(3405),
    [sym_preproc_pragma] = STATE(3405),
    [sym_preproc_nullable] = STATE(3405),
    [sym_preproc_error] = STATE(3405),
    [sym_preproc_define] = STATE(3405),
    [sym_preproc_undef] = STATE(3405),
    [sym__identifier_token] = ACTIONS(3471),
    [anon_sym_extern] = ACTIONS(3471),
    [anon_sym_alias] = ACTIONS(3471),
    [anon_sym_global] = ACTIONS(3471),
    [anon_sym_using] = ACTIONS(3471),
    [anon_sym_unsafe] = ACTIONS(3471),
    [anon_sym_static] = ACTIONS(3471),
    [anon_sym_LBRACK] = ACTIONS(3473),
    [anon_sym_LPAREN] = ACTIONS(3473),
    [anon_sym_event] = ACTIONS(3471),
    [anon_sym_namespace] = ACTIONS(3471),
    [anon_sym_class] = ACTIONS(3471),
    [anon_sym_ref] = ACTIONS(3471),
    [anon_sym_struct] = ACTIONS(3471),
    [anon_sym_enum] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3473),
    [anon_sym_interface] = ACTIONS(3471),
    [anon_sym_delegate] = ACTIONS(3471),
    [anon_sym_record] = ACTIONS(3471),
    [anon_sym_abstract] = ACTIONS(3471),
    [anon_sym_async] = ACTIONS(3471),
    [anon_sym_const] = ACTIONS(3471),
    [anon_sym_file] = ACTIONS(3471),
    [anon_sym_fixed] = ACTIONS(3471),
    [anon_sym_internal] = ACTIONS(3471),
    [anon_sym_new] = ACTIONS(3471),
    [anon_sym_override] = ACTIONS(3471),
    [anon_sym_partial] = ACTIONS(3471),
    [anon_sym_private] = ACTIONS(3471),
    [anon_sym_protected] = ACTIONS(3471),
    [anon_sym_public] = ACTIONS(3471),
    [anon_sym_readonly] = ACTIONS(3471),
    [anon_sym_required] = ACTIONS(3471),
    [anon_sym_sealed] = ACTIONS(3471),
    [anon_sym_virtual] = ACTIONS(3471),
    [anon_sym_volatile] = ACTIONS(3471),
    [anon_sym_where] = ACTIONS(3471),
    [anon_sym_notnull] = ACTIONS(3471),
    [anon_sym_unmanaged] = ACTIONS(3471),
    [anon_sym_TILDE] = ACTIONS(3473),
    [anon_sym_implicit] = ACTIONS(3471),
    [anon_sym_explicit] = ACTIONS(3471),
    [anon_sym_scoped] = ACTIONS(3471),
    [anon_sym_var] = ACTIONS(3471),
    [sym_predefined_type] = ACTIONS(3471),
    [anon_sym_yield] = ACTIONS(3471),
    [anon_sym_when] = ACTIONS(3471),
    [anon_sym_from] = ACTIONS(3471),
    [anon_sym_into] = ACTIONS(3471),
    [anon_sym_join] = ACTIONS(3471),
    [anon_sym_on] = ACTIONS(3471),
    [anon_sym_equals] = ACTIONS(3471),
    [anon_sym_let] = ACTIONS(3471),
    [anon_sym_orderby] = ACTIONS(3471),
    [anon_sym_ascending] = ACTIONS(3471),
    [anon_sym_descending] = ACTIONS(3471),
    [anon_sym_group] = ACTIONS(3471),
    [anon_sym_by] = ACTIONS(3471),
    [anon_sym_select] = ACTIONS(3471),
    [aux_sym_preproc_if_token1] = ACTIONS(3473),
    [aux_sym_preproc_if_token3] = ACTIONS(3473),
    [aux_sym_preproc_else_token1] = ACTIONS(3473),
    [aux_sym_preproc_elif_token1] = ACTIONS(3473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3406] = {
    [sym_preproc_region] = STATE(3406),
    [sym_preproc_endregion] = STATE(3406),
    [sym_preproc_line] = STATE(3406),
    [sym_preproc_pragma] = STATE(3406),
    [sym_preproc_nullable] = STATE(3406),
    [sym_preproc_error] = STATE(3406),
    [sym_preproc_define] = STATE(3406),
    [sym_preproc_undef] = STATE(3406),
    [sym__identifier_token] = ACTIONS(4993),
    [anon_sym_extern] = ACTIONS(4993),
    [anon_sym_alias] = ACTIONS(4993),
    [anon_sym_global] = ACTIONS(4993),
    [anon_sym_using] = ACTIONS(4993),
    [anon_sym_unsafe] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4995),
    [anon_sym_LPAREN] = ACTIONS(4995),
    [anon_sym_event] = ACTIONS(4993),
    [anon_sym_namespace] = ACTIONS(4993),
    [anon_sym_class] = ACTIONS(4993),
    [anon_sym_ref] = ACTIONS(4993),
    [anon_sym_struct] = ACTIONS(4993),
    [anon_sym_enum] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_interface] = ACTIONS(4993),
    [anon_sym_delegate] = ACTIONS(4993),
    [anon_sym_record] = ACTIONS(4993),
    [anon_sym_abstract] = ACTIONS(4993),
    [anon_sym_async] = ACTIONS(4993),
    [anon_sym_const] = ACTIONS(4993),
    [anon_sym_file] = ACTIONS(4993),
    [anon_sym_fixed] = ACTIONS(4993),
    [anon_sym_internal] = ACTIONS(4993),
    [anon_sym_new] = ACTIONS(4993),
    [anon_sym_override] = ACTIONS(4993),
    [anon_sym_partial] = ACTIONS(4993),
    [anon_sym_private] = ACTIONS(4993),
    [anon_sym_protected] = ACTIONS(4993),
    [anon_sym_public] = ACTIONS(4993),
    [anon_sym_readonly] = ACTIONS(4993),
    [anon_sym_required] = ACTIONS(4993),
    [anon_sym_sealed] = ACTIONS(4993),
    [anon_sym_virtual] = ACTIONS(4993),
    [anon_sym_volatile] = ACTIONS(4993),
    [anon_sym_where] = ACTIONS(4993),
    [anon_sym_notnull] = ACTIONS(4993),
    [anon_sym_unmanaged] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4995),
    [anon_sym_implicit] = ACTIONS(4993),
    [anon_sym_explicit] = ACTIONS(4993),
    [anon_sym_scoped] = ACTIONS(4993),
    [anon_sym_var] = ACTIONS(4993),
    [sym_predefined_type] = ACTIONS(4993),
    [anon_sym_yield] = ACTIONS(4993),
    [anon_sym_when] = ACTIONS(4993),
    [anon_sym_from] = ACTIONS(4993),
    [anon_sym_into] = ACTIONS(4993),
    [anon_sym_join] = ACTIONS(4993),
    [anon_sym_on] = ACTIONS(4993),
    [anon_sym_equals] = ACTIONS(4993),
    [anon_sym_let] = ACTIONS(4993),
    [anon_sym_orderby] = ACTIONS(4993),
    [anon_sym_ascending] = ACTIONS(4993),
    [anon_sym_descending] = ACTIONS(4993),
    [anon_sym_group] = ACTIONS(4993),
    [anon_sym_by] = ACTIONS(4993),
    [anon_sym_select] = ACTIONS(4993),
    [aux_sym_preproc_if_token1] = ACTIONS(4995),
    [aux_sym_preproc_if_token3] = ACTIONS(4995),
    [aux_sym_preproc_else_token1] = ACTIONS(4995),
    [aux_sym_preproc_elif_token1] = ACTIONS(4995),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3407] = {
    [sym_preproc_region] = STATE(3407),
    [sym_preproc_endregion] = STATE(3407),
    [sym_preproc_line] = STATE(3407),
    [sym_preproc_pragma] = STATE(3407),
    [sym_preproc_nullable] = STATE(3407),
    [sym_preproc_error] = STATE(3407),
    [sym_preproc_define] = STATE(3407),
    [sym_preproc_undef] = STATE(3407),
    [sym__identifier_token] = ACTIONS(3415),
    [anon_sym_extern] = ACTIONS(3415),
    [anon_sym_alias] = ACTIONS(3415),
    [anon_sym_global] = ACTIONS(3415),
    [anon_sym_using] = ACTIONS(3415),
    [anon_sym_unsafe] = ACTIONS(3415),
    [anon_sym_static] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(3417),
    [anon_sym_LPAREN] = ACTIONS(3417),
    [anon_sym_event] = ACTIONS(3415),
    [anon_sym_namespace] = ACTIONS(3415),
    [anon_sym_class] = ACTIONS(3415),
    [anon_sym_ref] = ACTIONS(3415),
    [anon_sym_struct] = ACTIONS(3415),
    [anon_sym_enum] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [anon_sym_interface] = ACTIONS(3415),
    [anon_sym_delegate] = ACTIONS(3415),
    [anon_sym_record] = ACTIONS(3415),
    [anon_sym_abstract] = ACTIONS(3415),
    [anon_sym_async] = ACTIONS(3415),
    [anon_sym_const] = ACTIONS(3415),
    [anon_sym_file] = ACTIONS(3415),
    [anon_sym_fixed] = ACTIONS(3415),
    [anon_sym_internal] = ACTIONS(3415),
    [anon_sym_new] = ACTIONS(3415),
    [anon_sym_override] = ACTIONS(3415),
    [anon_sym_partial] = ACTIONS(3415),
    [anon_sym_private] = ACTIONS(3415),
    [anon_sym_protected] = ACTIONS(3415),
    [anon_sym_public] = ACTIONS(3415),
    [anon_sym_readonly] = ACTIONS(3415),
    [anon_sym_required] = ACTIONS(3415),
    [anon_sym_sealed] = ACTIONS(3415),
    [anon_sym_virtual] = ACTIONS(3415),
    [anon_sym_volatile] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_notnull] = ACTIONS(3415),
    [anon_sym_unmanaged] = ACTIONS(3415),
    [anon_sym_TILDE] = ACTIONS(3417),
    [anon_sym_implicit] = ACTIONS(3415),
    [anon_sym_explicit] = ACTIONS(3415),
    [anon_sym_scoped] = ACTIONS(3415),
    [anon_sym_var] = ACTIONS(3415),
    [sym_predefined_type] = ACTIONS(3415),
    [anon_sym_yield] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_from] = ACTIONS(3415),
    [anon_sym_into] = ACTIONS(3415),
    [anon_sym_join] = ACTIONS(3415),
    [anon_sym_on] = ACTIONS(3415),
    [anon_sym_equals] = ACTIONS(3415),
    [anon_sym_let] = ACTIONS(3415),
    [anon_sym_orderby] = ACTIONS(3415),
    [anon_sym_ascending] = ACTIONS(3415),
    [anon_sym_descending] = ACTIONS(3415),
    [anon_sym_group] = ACTIONS(3415),
    [anon_sym_by] = ACTIONS(3415),
    [anon_sym_select] = ACTIONS(3415),
    [aux_sym_preproc_if_token1] = ACTIONS(3417),
    [aux_sym_preproc_if_token3] = ACTIONS(3417),
    [aux_sym_preproc_else_token1] = ACTIONS(3417),
    [aux_sym_preproc_elif_token1] = ACTIONS(3417),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3408] = {
    [sym_preproc_region] = STATE(3408),
    [sym_preproc_endregion] = STATE(3408),
    [sym_preproc_line] = STATE(3408),
    [sym_preproc_pragma] = STATE(3408),
    [sym_preproc_nullable] = STATE(3408),
    [sym_preproc_error] = STATE(3408),
    [sym_preproc_define] = STATE(3408),
    [sym_preproc_undef] = STATE(3408),
    [sym__identifier_token] = ACTIONS(3531),
    [anon_sym_extern] = ACTIONS(3531),
    [anon_sym_alias] = ACTIONS(3531),
    [anon_sym_global] = ACTIONS(3531),
    [anon_sym_using] = ACTIONS(3531),
    [anon_sym_unsafe] = ACTIONS(3531),
    [anon_sym_static] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3533),
    [anon_sym_event] = ACTIONS(3531),
    [anon_sym_namespace] = ACTIONS(3531),
    [anon_sym_class] = ACTIONS(3531),
    [anon_sym_ref] = ACTIONS(3531),
    [anon_sym_struct] = ACTIONS(3531),
    [anon_sym_enum] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3533),
    [anon_sym_interface] = ACTIONS(3531),
    [anon_sym_delegate] = ACTIONS(3531),
    [anon_sym_record] = ACTIONS(3531),
    [anon_sym_abstract] = ACTIONS(3531),
    [anon_sym_async] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3531),
    [anon_sym_file] = ACTIONS(3531),
    [anon_sym_fixed] = ACTIONS(3531),
    [anon_sym_internal] = ACTIONS(3531),
    [anon_sym_new] = ACTIONS(3531),
    [anon_sym_override] = ACTIONS(3531),
    [anon_sym_partial] = ACTIONS(3531),
    [anon_sym_private] = ACTIONS(3531),
    [anon_sym_protected] = ACTIONS(3531),
    [anon_sym_public] = ACTIONS(3531),
    [anon_sym_readonly] = ACTIONS(3531),
    [anon_sym_required] = ACTIONS(3531),
    [anon_sym_sealed] = ACTIONS(3531),
    [anon_sym_virtual] = ACTIONS(3531),
    [anon_sym_volatile] = ACTIONS(3531),
    [anon_sym_where] = ACTIONS(3531),
    [anon_sym_notnull] = ACTIONS(3531),
    [anon_sym_unmanaged] = ACTIONS(3531),
    [anon_sym_TILDE] = ACTIONS(3533),
    [anon_sym_implicit] = ACTIONS(3531),
    [anon_sym_explicit] = ACTIONS(3531),
    [anon_sym_scoped] = ACTIONS(3531),
    [anon_sym_var] = ACTIONS(3531),
    [sym_predefined_type] = ACTIONS(3531),
    [anon_sym_yield] = ACTIONS(3531),
    [anon_sym_when] = ACTIONS(3531),
    [anon_sym_from] = ACTIONS(3531),
    [anon_sym_into] = ACTIONS(3531),
    [anon_sym_join] = ACTIONS(3531),
    [anon_sym_on] = ACTIONS(3531),
    [anon_sym_equals] = ACTIONS(3531),
    [anon_sym_let] = ACTIONS(3531),
    [anon_sym_orderby] = ACTIONS(3531),
    [anon_sym_ascending] = ACTIONS(3531),
    [anon_sym_descending] = ACTIONS(3531),
    [anon_sym_group] = ACTIONS(3531),
    [anon_sym_by] = ACTIONS(3531),
    [anon_sym_select] = ACTIONS(3531),
    [aux_sym_preproc_if_token1] = ACTIONS(3533),
    [aux_sym_preproc_if_token3] = ACTIONS(3533),
    [aux_sym_preproc_else_token1] = ACTIONS(3533),
    [aux_sym_preproc_elif_token1] = ACTIONS(3533),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3409] = {
    [sym_preproc_region] = STATE(3409),
    [sym_preproc_endregion] = STATE(3409),
    [sym_preproc_line] = STATE(3409),
    [sym_preproc_pragma] = STATE(3409),
    [sym_preproc_nullable] = STATE(3409),
    [sym_preproc_error] = STATE(3409),
    [sym_preproc_define] = STATE(3409),
    [sym_preproc_undef] = STATE(3409),
    [sym__identifier_token] = ACTIONS(3431),
    [anon_sym_extern] = ACTIONS(3431),
    [anon_sym_alias] = ACTIONS(3431),
    [anon_sym_global] = ACTIONS(3431),
    [anon_sym_using] = ACTIONS(3431),
    [anon_sym_unsafe] = ACTIONS(3431),
    [anon_sym_static] = ACTIONS(3431),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_event] = ACTIONS(3431),
    [anon_sym_namespace] = ACTIONS(3431),
    [anon_sym_class] = ACTIONS(3431),
    [anon_sym_ref] = ACTIONS(3431),
    [anon_sym_struct] = ACTIONS(3431),
    [anon_sym_enum] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3431),
    [anon_sym_delegate] = ACTIONS(3431),
    [anon_sym_record] = ACTIONS(3431),
    [anon_sym_abstract] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3431),
    [anon_sym_const] = ACTIONS(3431),
    [anon_sym_file] = ACTIONS(3431),
    [anon_sym_fixed] = ACTIONS(3431),
    [anon_sym_internal] = ACTIONS(3431),
    [anon_sym_new] = ACTIONS(3431),
    [anon_sym_override] = ACTIONS(3431),
    [anon_sym_partial] = ACTIONS(3431),
    [anon_sym_private] = ACTIONS(3431),
    [anon_sym_protected] = ACTIONS(3431),
    [anon_sym_public] = ACTIONS(3431),
    [anon_sym_readonly] = ACTIONS(3431),
    [anon_sym_required] = ACTIONS(3431),
    [anon_sym_sealed] = ACTIONS(3431),
    [anon_sym_virtual] = ACTIONS(3431),
    [anon_sym_volatile] = ACTIONS(3431),
    [anon_sym_where] = ACTIONS(3431),
    [anon_sym_notnull] = ACTIONS(3431),
    [anon_sym_unmanaged] = ACTIONS(3431),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_implicit] = ACTIONS(3431),
    [anon_sym_explicit] = ACTIONS(3431),
    [anon_sym_scoped] = ACTIONS(3431),
    [anon_sym_var] = ACTIONS(3431),
    [sym_predefined_type] = ACTIONS(3431),
    [anon_sym_yield] = ACTIONS(3431),
    [anon_sym_when] = ACTIONS(3431),
    [anon_sym_from] = ACTIONS(3431),
    [anon_sym_into] = ACTIONS(3431),
    [anon_sym_join] = ACTIONS(3431),
    [anon_sym_on] = ACTIONS(3431),
    [anon_sym_equals] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3431),
    [anon_sym_orderby] = ACTIONS(3431),
    [anon_sym_ascending] = ACTIONS(3431),
    [anon_sym_descending] = ACTIONS(3431),
    [anon_sym_group] = ACTIONS(3431),
    [anon_sym_by] = ACTIONS(3431),
    [anon_sym_select] = ACTIONS(3431),
    [aux_sym_preproc_if_token1] = ACTIONS(3433),
    [aux_sym_preproc_if_token3] = ACTIONS(3433),
    [aux_sym_preproc_else_token1] = ACTIONS(3433),
    [aux_sym_preproc_elif_token1] = ACTIONS(3433),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3410] = {
    [sym_preproc_region] = STATE(3410),
    [sym_preproc_endregion] = STATE(3410),
    [sym_preproc_line] = STATE(3410),
    [sym_preproc_pragma] = STATE(3410),
    [sym_preproc_nullable] = STATE(3410),
    [sym_preproc_error] = STATE(3410),
    [sym_preproc_define] = STATE(3410),
    [sym_preproc_undef] = STATE(3410),
    [sym__identifier_token] = ACTIONS(3435),
    [anon_sym_extern] = ACTIONS(3435),
    [anon_sym_alias] = ACTIONS(3435),
    [anon_sym_global] = ACTIONS(3435),
    [anon_sym_using] = ACTIONS(3435),
    [anon_sym_unsafe] = ACTIONS(3435),
    [anon_sym_static] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3437),
    [anon_sym_LPAREN] = ACTIONS(3437),
    [anon_sym_event] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_ref] = ACTIONS(3435),
    [anon_sym_struct] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3437),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_delegate] = ACTIONS(3435),
    [anon_sym_record] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_file] = ACTIONS(3435),
    [anon_sym_fixed] = ACTIONS(3435),
    [anon_sym_internal] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_override] = ACTIONS(3435),
    [anon_sym_partial] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_readonly] = ACTIONS(3435),
    [anon_sym_required] = ACTIONS(3435),
    [anon_sym_sealed] = ACTIONS(3435),
    [anon_sym_virtual] = ACTIONS(3435),
    [anon_sym_volatile] = ACTIONS(3435),
    [anon_sym_where] = ACTIONS(3435),
    [anon_sym_notnull] = ACTIONS(3435),
    [anon_sym_unmanaged] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3437),
    [anon_sym_implicit] = ACTIONS(3435),
    [anon_sym_explicit] = ACTIONS(3435),
    [anon_sym_scoped] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [sym_predefined_type] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_when] = ACTIONS(3435),
    [anon_sym_from] = ACTIONS(3435),
    [anon_sym_into] = ACTIONS(3435),
    [anon_sym_join] = ACTIONS(3435),
    [anon_sym_on] = ACTIONS(3435),
    [anon_sym_equals] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_orderby] = ACTIONS(3435),
    [anon_sym_ascending] = ACTIONS(3435),
    [anon_sym_descending] = ACTIONS(3435),
    [anon_sym_group] = ACTIONS(3435),
    [anon_sym_by] = ACTIONS(3435),
    [anon_sym_select] = ACTIONS(3435),
    [aux_sym_preproc_if_token1] = ACTIONS(3437),
    [aux_sym_preproc_if_token3] = ACTIONS(3437),
    [aux_sym_preproc_else_token1] = ACTIONS(3437),
    [aux_sym_preproc_elif_token1] = ACTIONS(3437),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3411] = {
    [sym_preproc_region] = STATE(3411),
    [sym_preproc_endregion] = STATE(3411),
    [sym_preproc_line] = STATE(3411),
    [sym_preproc_pragma] = STATE(3411),
    [sym_preproc_nullable] = STATE(3411),
    [sym_preproc_error] = STATE(3411),
    [sym_preproc_define] = STATE(3411),
    [sym_preproc_undef] = STATE(3411),
    [sym__identifier_token] = ACTIONS(3447),
    [anon_sym_extern] = ACTIONS(3447),
    [anon_sym_alias] = ACTIONS(3447),
    [anon_sym_global] = ACTIONS(3447),
    [anon_sym_using] = ACTIONS(3447),
    [anon_sym_unsafe] = ACTIONS(3447),
    [anon_sym_static] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3449),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_event] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_ref] = ACTIONS(3447),
    [anon_sym_struct] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3449),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_delegate] = ACTIONS(3447),
    [anon_sym_record] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [anon_sym_file] = ACTIONS(3447),
    [anon_sym_fixed] = ACTIONS(3447),
    [anon_sym_internal] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_override] = ACTIONS(3447),
    [anon_sym_partial] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_readonly] = ACTIONS(3447),
    [anon_sym_required] = ACTIONS(3447),
    [anon_sym_sealed] = ACTIONS(3447),
    [anon_sym_virtual] = ACTIONS(3447),
    [anon_sym_volatile] = ACTIONS(3447),
    [anon_sym_where] = ACTIONS(3447),
    [anon_sym_notnull] = ACTIONS(3447),
    [anon_sym_unmanaged] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3449),
    [anon_sym_implicit] = ACTIONS(3447),
    [anon_sym_explicit] = ACTIONS(3447),
    [anon_sym_scoped] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [sym_predefined_type] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [anon_sym_when] = ACTIONS(3447),
    [anon_sym_from] = ACTIONS(3447),
    [anon_sym_into] = ACTIONS(3447),
    [anon_sym_join] = ACTIONS(3447),
    [anon_sym_on] = ACTIONS(3447),
    [anon_sym_equals] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_orderby] = ACTIONS(3447),
    [anon_sym_ascending] = ACTIONS(3447),
    [anon_sym_descending] = ACTIONS(3447),
    [anon_sym_group] = ACTIONS(3447),
    [anon_sym_by] = ACTIONS(3447),
    [anon_sym_select] = ACTIONS(3447),
    [aux_sym_preproc_if_token1] = ACTIONS(3449),
    [aux_sym_preproc_if_token3] = ACTIONS(3449),
    [aux_sym_preproc_else_token1] = ACTIONS(3449),
    [aux_sym_preproc_elif_token1] = ACTIONS(3449),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3412] = {
    [sym_preproc_region] = STATE(3412),
    [sym_preproc_endregion] = STATE(3412),
    [sym_preproc_line] = STATE(3412),
    [sym_preproc_pragma] = STATE(3412),
    [sym_preproc_nullable] = STATE(3412),
    [sym_preproc_error] = STATE(3412),
    [sym_preproc_define] = STATE(3412),
    [sym_preproc_undef] = STATE(3412),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3413] = {
    [sym_preproc_region] = STATE(3413),
    [sym_preproc_endregion] = STATE(3413),
    [sym_preproc_line] = STATE(3413),
    [sym_preproc_pragma] = STATE(3413),
    [sym_preproc_nullable] = STATE(3413),
    [sym_preproc_error] = STATE(3413),
    [sym_preproc_define] = STATE(3413),
    [sym_preproc_undef] = STATE(3413),
    [sym__identifier_token] = ACTIONS(3451),
    [anon_sym_extern] = ACTIONS(3451),
    [anon_sym_alias] = ACTIONS(3451),
    [anon_sym_global] = ACTIONS(3451),
    [anon_sym_using] = ACTIONS(3451),
    [anon_sym_unsafe] = ACTIONS(3451),
    [anon_sym_static] = ACTIONS(3451),
    [anon_sym_LBRACK] = ACTIONS(3453),
    [anon_sym_LPAREN] = ACTIONS(3453),
    [anon_sym_event] = ACTIONS(3451),
    [anon_sym_namespace] = ACTIONS(3451),
    [anon_sym_class] = ACTIONS(3451),
    [anon_sym_ref] = ACTIONS(3451),
    [anon_sym_struct] = ACTIONS(3451),
    [anon_sym_enum] = ACTIONS(3451),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_interface] = ACTIONS(3451),
    [anon_sym_delegate] = ACTIONS(3451),
    [anon_sym_record] = ACTIONS(3451),
    [anon_sym_abstract] = ACTIONS(3451),
    [anon_sym_async] = ACTIONS(3451),
    [anon_sym_const] = ACTIONS(3451),
    [anon_sym_file] = ACTIONS(3451),
    [anon_sym_fixed] = ACTIONS(3451),
    [anon_sym_internal] = ACTIONS(3451),
    [anon_sym_new] = ACTIONS(3451),
    [anon_sym_override] = ACTIONS(3451),
    [anon_sym_partial] = ACTIONS(3451),
    [anon_sym_private] = ACTIONS(3451),
    [anon_sym_protected] = ACTIONS(3451),
    [anon_sym_public] = ACTIONS(3451),
    [anon_sym_readonly] = ACTIONS(3451),
    [anon_sym_required] = ACTIONS(3451),
    [anon_sym_sealed] = ACTIONS(3451),
    [anon_sym_virtual] = ACTIONS(3451),
    [anon_sym_volatile] = ACTIONS(3451),
    [anon_sym_where] = ACTIONS(3451),
    [anon_sym_notnull] = ACTIONS(3451),
    [anon_sym_unmanaged] = ACTIONS(3451),
    [anon_sym_TILDE] = ACTIONS(3453),
    [anon_sym_implicit] = ACTIONS(3451),
    [anon_sym_explicit] = ACTIONS(3451),
    [anon_sym_scoped] = ACTIONS(3451),
    [anon_sym_var] = ACTIONS(3451),
    [sym_predefined_type] = ACTIONS(3451),
    [anon_sym_yield] = ACTIONS(3451),
    [anon_sym_when] = ACTIONS(3451),
    [anon_sym_from] = ACTIONS(3451),
    [anon_sym_into] = ACTIONS(3451),
    [anon_sym_join] = ACTIONS(3451),
    [anon_sym_on] = ACTIONS(3451),
    [anon_sym_equals] = ACTIONS(3451),
    [anon_sym_let] = ACTIONS(3451),
    [anon_sym_orderby] = ACTIONS(3451),
    [anon_sym_ascending] = ACTIONS(3451),
    [anon_sym_descending] = ACTIONS(3451),
    [anon_sym_group] = ACTIONS(3451),
    [anon_sym_by] = ACTIONS(3451),
    [anon_sym_select] = ACTIONS(3451),
    [aux_sym_preproc_if_token1] = ACTIONS(3453),
    [aux_sym_preproc_if_token3] = ACTIONS(3453),
    [aux_sym_preproc_else_token1] = ACTIONS(3453),
    [aux_sym_preproc_elif_token1] = ACTIONS(3453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3414] = {
    [sym_preproc_region] = STATE(3414),
    [sym_preproc_endregion] = STATE(3414),
    [sym_preproc_line] = STATE(3414),
    [sym_preproc_pragma] = STATE(3414),
    [sym_preproc_nullable] = STATE(3414),
    [sym_preproc_error] = STATE(3414),
    [sym_preproc_define] = STATE(3414),
    [sym_preproc_undef] = STATE(3414),
    [sym__identifier_token] = ACTIONS(4997),
    [anon_sym_extern] = ACTIONS(4997),
    [anon_sym_alias] = ACTIONS(4997),
    [anon_sym_global] = ACTIONS(4997),
    [anon_sym_using] = ACTIONS(4997),
    [anon_sym_unsafe] = ACTIONS(4997),
    [anon_sym_static] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4999),
    [anon_sym_LPAREN] = ACTIONS(4999),
    [anon_sym_event] = ACTIONS(4997),
    [anon_sym_namespace] = ACTIONS(4997),
    [anon_sym_class] = ACTIONS(4997),
    [anon_sym_ref] = ACTIONS(4997),
    [anon_sym_struct] = ACTIONS(4997),
    [anon_sym_enum] = ACTIONS(4997),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym_interface] = ACTIONS(4997),
    [anon_sym_delegate] = ACTIONS(4997),
    [anon_sym_record] = ACTIONS(4997),
    [anon_sym_abstract] = ACTIONS(4997),
    [anon_sym_async] = ACTIONS(4997),
    [anon_sym_const] = ACTIONS(4997),
    [anon_sym_file] = ACTIONS(4997),
    [anon_sym_fixed] = ACTIONS(4997),
    [anon_sym_internal] = ACTIONS(4997),
    [anon_sym_new] = ACTIONS(4997),
    [anon_sym_override] = ACTIONS(4997),
    [anon_sym_partial] = ACTIONS(4997),
    [anon_sym_private] = ACTIONS(4997),
    [anon_sym_protected] = ACTIONS(4997),
    [anon_sym_public] = ACTIONS(4997),
    [anon_sym_readonly] = ACTIONS(4997),
    [anon_sym_required] = ACTIONS(4997),
    [anon_sym_sealed] = ACTIONS(4997),
    [anon_sym_virtual] = ACTIONS(4997),
    [anon_sym_volatile] = ACTIONS(4997),
    [anon_sym_where] = ACTIONS(4997),
    [anon_sym_notnull] = ACTIONS(4997),
    [anon_sym_unmanaged] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(4999),
    [anon_sym_implicit] = ACTIONS(4997),
    [anon_sym_explicit] = ACTIONS(4997),
    [anon_sym_scoped] = ACTIONS(4997),
    [anon_sym_var] = ACTIONS(4997),
    [sym_predefined_type] = ACTIONS(4997),
    [anon_sym_yield] = ACTIONS(4997),
    [anon_sym_when] = ACTIONS(4997),
    [anon_sym_from] = ACTIONS(4997),
    [anon_sym_into] = ACTIONS(4997),
    [anon_sym_join] = ACTIONS(4997),
    [anon_sym_on] = ACTIONS(4997),
    [anon_sym_equals] = ACTIONS(4997),
    [anon_sym_let] = ACTIONS(4997),
    [anon_sym_orderby] = ACTIONS(4997),
    [anon_sym_ascending] = ACTIONS(4997),
    [anon_sym_descending] = ACTIONS(4997),
    [anon_sym_group] = ACTIONS(4997),
    [anon_sym_by] = ACTIONS(4997),
    [anon_sym_select] = ACTIONS(4997),
    [aux_sym_preproc_if_token1] = ACTIONS(4999),
    [aux_sym_preproc_if_token3] = ACTIONS(4999),
    [aux_sym_preproc_else_token1] = ACTIONS(4999),
    [aux_sym_preproc_elif_token1] = ACTIONS(4999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3415] = {
    [sym_preproc_region] = STATE(3415),
    [sym_preproc_endregion] = STATE(3415),
    [sym_preproc_line] = STATE(3415),
    [sym_preproc_pragma] = STATE(3415),
    [sym_preproc_nullable] = STATE(3415),
    [sym_preproc_error] = STATE(3415),
    [sym_preproc_define] = STATE(3415),
    [sym_preproc_undef] = STATE(3415),
    [sym__identifier_token] = ACTIONS(3503),
    [anon_sym_extern] = ACTIONS(3503),
    [anon_sym_alias] = ACTIONS(3503),
    [anon_sym_global] = ACTIONS(3503),
    [anon_sym_using] = ACTIONS(3503),
    [anon_sym_unsafe] = ACTIONS(3503),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3505),
    [anon_sym_event] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(3503),
    [anon_sym_ref] = ACTIONS(3503),
    [anon_sym_struct] = ACTIONS(3503),
    [anon_sym_enum] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_interface] = ACTIONS(3503),
    [anon_sym_delegate] = ACTIONS(3503),
    [anon_sym_record] = ACTIONS(3503),
    [anon_sym_abstract] = ACTIONS(3503),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_const] = ACTIONS(3503),
    [anon_sym_file] = ACTIONS(3503),
    [anon_sym_fixed] = ACTIONS(3503),
    [anon_sym_internal] = ACTIONS(3503),
    [anon_sym_new] = ACTIONS(3503),
    [anon_sym_override] = ACTIONS(3503),
    [anon_sym_partial] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_readonly] = ACTIONS(3503),
    [anon_sym_required] = ACTIONS(3503),
    [anon_sym_sealed] = ACTIONS(3503),
    [anon_sym_virtual] = ACTIONS(3503),
    [anon_sym_volatile] = ACTIONS(3503),
    [anon_sym_where] = ACTIONS(3503),
    [anon_sym_notnull] = ACTIONS(3503),
    [anon_sym_unmanaged] = ACTIONS(3503),
    [anon_sym_TILDE] = ACTIONS(3505),
    [anon_sym_implicit] = ACTIONS(3503),
    [anon_sym_explicit] = ACTIONS(3503),
    [anon_sym_scoped] = ACTIONS(3503),
    [anon_sym_var] = ACTIONS(3503),
    [sym_predefined_type] = ACTIONS(3503),
    [anon_sym_yield] = ACTIONS(3503),
    [anon_sym_when] = ACTIONS(3503),
    [anon_sym_from] = ACTIONS(3503),
    [anon_sym_into] = ACTIONS(3503),
    [anon_sym_join] = ACTIONS(3503),
    [anon_sym_on] = ACTIONS(3503),
    [anon_sym_equals] = ACTIONS(3503),
    [anon_sym_let] = ACTIONS(3503),
    [anon_sym_orderby] = ACTIONS(3503),
    [anon_sym_ascending] = ACTIONS(3503),
    [anon_sym_descending] = ACTIONS(3503),
    [anon_sym_group] = ACTIONS(3503),
    [anon_sym_by] = ACTIONS(3503),
    [anon_sym_select] = ACTIONS(3503),
    [aux_sym_preproc_if_token1] = ACTIONS(3505),
    [aux_sym_preproc_if_token3] = ACTIONS(3505),
    [aux_sym_preproc_else_token1] = ACTIONS(3505),
    [aux_sym_preproc_elif_token1] = ACTIONS(3505),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3416] = {
    [sym_preproc_region] = STATE(3416),
    [sym_preproc_endregion] = STATE(3416),
    [sym_preproc_line] = STATE(3416),
    [sym_preproc_pragma] = STATE(3416),
    [sym_preproc_nullable] = STATE(3416),
    [sym_preproc_error] = STATE(3416),
    [sym_preproc_define] = STATE(3416),
    [sym_preproc_undef] = STATE(3416),
    [sym__identifier_token] = ACTIONS(4534),
    [anon_sym_alias] = ACTIONS(4534),
    [anon_sym_global] = ACTIONS(4534),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_file] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_where] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_notnull] = ACTIONS(4534),
    [anon_sym_unmanaged] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_scoped] = ACTIONS(4534),
    [anon_sym_var] = ACTIONS(4534),
    [anon_sym_yield] = ACTIONS(4534),
    [anon_sym_switch] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [sym_discard] = ACTIONS(4534),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4534),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_from] = ACTIONS(4534),
    [anon_sym_into] = ACTIONS(4534),
    [anon_sym_join] = ACTIONS(4534),
    [anon_sym_on] = ACTIONS(4534),
    [anon_sym_equals] = ACTIONS(4534),
    [anon_sym_let] = ACTIONS(4534),
    [anon_sym_orderby] = ACTIONS(4534),
    [anon_sym_ascending] = ACTIONS(4534),
    [anon_sym_descending] = ACTIONS(4534),
    [anon_sym_group] = ACTIONS(4534),
    [anon_sym_by] = ACTIONS(4534),
    [anon_sym_select] = ACTIONS(4534),
    [anon_sym_as] = ACTIONS(4534),
    [anon_sym_is] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4534),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4536),
  },
  [3417] = {
    [sym_preproc_region] = STATE(3417),
    [sym_preproc_endregion] = STATE(3417),
    [sym_preproc_line] = STATE(3417),
    [sym_preproc_pragma] = STATE(3417),
    [sym_preproc_nullable] = STATE(3417),
    [sym_preproc_error] = STATE(3417),
    [sym_preproc_define] = STATE(3417),
    [sym_preproc_undef] = STATE(3417),
    [sym__identifier_token] = ACTIONS(5001),
    [anon_sym_extern] = ACTIONS(5001),
    [anon_sym_alias] = ACTIONS(5001),
    [anon_sym_global] = ACTIONS(5001),
    [anon_sym_using] = ACTIONS(5001),
    [anon_sym_unsafe] = ACTIONS(5001),
    [anon_sym_static] = ACTIONS(5001),
    [anon_sym_LBRACK] = ACTIONS(5003),
    [anon_sym_LPAREN] = ACTIONS(5003),
    [anon_sym_event] = ACTIONS(5001),
    [anon_sym_namespace] = ACTIONS(5001),
    [anon_sym_class] = ACTIONS(5001),
    [anon_sym_ref] = ACTIONS(5001),
    [anon_sym_struct] = ACTIONS(5001),
    [anon_sym_enum] = ACTIONS(5001),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_interface] = ACTIONS(5001),
    [anon_sym_delegate] = ACTIONS(5001),
    [anon_sym_record] = ACTIONS(5001),
    [anon_sym_abstract] = ACTIONS(5001),
    [anon_sym_async] = ACTIONS(5001),
    [anon_sym_const] = ACTIONS(5001),
    [anon_sym_file] = ACTIONS(5001),
    [anon_sym_fixed] = ACTIONS(5001),
    [anon_sym_internal] = ACTIONS(5001),
    [anon_sym_new] = ACTIONS(5001),
    [anon_sym_override] = ACTIONS(5001),
    [anon_sym_partial] = ACTIONS(5001),
    [anon_sym_private] = ACTIONS(5001),
    [anon_sym_protected] = ACTIONS(5001),
    [anon_sym_public] = ACTIONS(5001),
    [anon_sym_readonly] = ACTIONS(5001),
    [anon_sym_required] = ACTIONS(5001),
    [anon_sym_sealed] = ACTIONS(5001),
    [anon_sym_virtual] = ACTIONS(5001),
    [anon_sym_volatile] = ACTIONS(5001),
    [anon_sym_where] = ACTIONS(5001),
    [anon_sym_notnull] = ACTIONS(5001),
    [anon_sym_unmanaged] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5003),
    [anon_sym_implicit] = ACTIONS(5001),
    [anon_sym_explicit] = ACTIONS(5001),
    [anon_sym_scoped] = ACTIONS(5001),
    [anon_sym_var] = ACTIONS(5001),
    [sym_predefined_type] = ACTIONS(5001),
    [anon_sym_yield] = ACTIONS(5001),
    [anon_sym_when] = ACTIONS(5001),
    [anon_sym_from] = ACTIONS(5001),
    [anon_sym_into] = ACTIONS(5001),
    [anon_sym_join] = ACTIONS(5001),
    [anon_sym_on] = ACTIONS(5001),
    [anon_sym_equals] = ACTIONS(5001),
    [anon_sym_let] = ACTIONS(5001),
    [anon_sym_orderby] = ACTIONS(5001),
    [anon_sym_ascending] = ACTIONS(5001),
    [anon_sym_descending] = ACTIONS(5001),
    [anon_sym_group] = ACTIONS(5001),
    [anon_sym_by] = ACTIONS(5001),
    [anon_sym_select] = ACTIONS(5001),
    [aux_sym_preproc_if_token1] = ACTIONS(5003),
    [aux_sym_preproc_if_token3] = ACTIONS(5003),
    [aux_sym_preproc_else_token1] = ACTIONS(5003),
    [aux_sym_preproc_elif_token1] = ACTIONS(5003),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3418] = {
    [sym_preproc_region] = STATE(3418),
    [sym_preproc_endregion] = STATE(3418),
    [sym_preproc_line] = STATE(3418),
    [sym_preproc_pragma] = STATE(3418),
    [sym_preproc_nullable] = STATE(3418),
    [sym_preproc_error] = STATE(3418),
    [sym_preproc_define] = STATE(3418),
    [sym_preproc_undef] = STATE(3418),
    [sym__identifier_token] = ACTIONS(3511),
    [anon_sym_extern] = ACTIONS(3511),
    [anon_sym_alias] = ACTIONS(3511),
    [anon_sym_global] = ACTIONS(3511),
    [anon_sym_using] = ACTIONS(3511),
    [anon_sym_unsafe] = ACTIONS(3511),
    [anon_sym_static] = ACTIONS(3511),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3513),
    [anon_sym_event] = ACTIONS(3511),
    [anon_sym_namespace] = ACTIONS(3511),
    [anon_sym_class] = ACTIONS(3511),
    [anon_sym_ref] = ACTIONS(3511),
    [anon_sym_struct] = ACTIONS(3511),
    [anon_sym_enum] = ACTIONS(3511),
    [anon_sym_RBRACE] = ACTIONS(3513),
    [anon_sym_interface] = ACTIONS(3511),
    [anon_sym_delegate] = ACTIONS(3511),
    [anon_sym_record] = ACTIONS(3511),
    [anon_sym_abstract] = ACTIONS(3511),
    [anon_sym_async] = ACTIONS(3511),
    [anon_sym_const] = ACTIONS(3511),
    [anon_sym_file] = ACTIONS(3511),
    [anon_sym_fixed] = ACTIONS(3511),
    [anon_sym_internal] = ACTIONS(3511),
    [anon_sym_new] = ACTIONS(3511),
    [anon_sym_override] = ACTIONS(3511),
    [anon_sym_partial] = ACTIONS(3511),
    [anon_sym_private] = ACTIONS(3511),
    [anon_sym_protected] = ACTIONS(3511),
    [anon_sym_public] = ACTIONS(3511),
    [anon_sym_readonly] = ACTIONS(3511),
    [anon_sym_required] = ACTIONS(3511),
    [anon_sym_sealed] = ACTIONS(3511),
    [anon_sym_virtual] = ACTIONS(3511),
    [anon_sym_volatile] = ACTIONS(3511),
    [anon_sym_where] = ACTIONS(3511),
    [anon_sym_notnull] = ACTIONS(3511),
    [anon_sym_unmanaged] = ACTIONS(3511),
    [anon_sym_TILDE] = ACTIONS(3513),
    [anon_sym_implicit] = ACTIONS(3511),
    [anon_sym_explicit] = ACTIONS(3511),
    [anon_sym_scoped] = ACTIONS(3511),
    [anon_sym_var] = ACTIONS(3511),
    [sym_predefined_type] = ACTIONS(3511),
    [anon_sym_yield] = ACTIONS(3511),
    [anon_sym_when] = ACTIONS(3511),
    [anon_sym_from] = ACTIONS(3511),
    [anon_sym_into] = ACTIONS(3511),
    [anon_sym_join] = ACTIONS(3511),
    [anon_sym_on] = ACTIONS(3511),
    [anon_sym_equals] = ACTIONS(3511),
    [anon_sym_let] = ACTIONS(3511),
    [anon_sym_orderby] = ACTIONS(3511),
    [anon_sym_ascending] = ACTIONS(3511),
    [anon_sym_descending] = ACTIONS(3511),
    [anon_sym_group] = ACTIONS(3511),
    [anon_sym_by] = ACTIONS(3511),
    [anon_sym_select] = ACTIONS(3511),
    [aux_sym_preproc_if_token1] = ACTIONS(3513),
    [aux_sym_preproc_if_token3] = ACTIONS(3513),
    [aux_sym_preproc_else_token1] = ACTIONS(3513),
    [aux_sym_preproc_elif_token1] = ACTIONS(3513),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3419] = {
    [sym_preproc_region] = STATE(3419),
    [sym_preproc_endregion] = STATE(3419),
    [sym_preproc_line] = STATE(3419),
    [sym_preproc_pragma] = STATE(3419),
    [sym_preproc_nullable] = STATE(3419),
    [sym_preproc_error] = STATE(3419),
    [sym_preproc_define] = STATE(3419),
    [sym_preproc_undef] = STATE(3419),
    [sym__identifier_token] = ACTIONS(5005),
    [anon_sym_extern] = ACTIONS(5005),
    [anon_sym_alias] = ACTIONS(5005),
    [anon_sym_global] = ACTIONS(5005),
    [anon_sym_using] = ACTIONS(5005),
    [anon_sym_unsafe] = ACTIONS(5005),
    [anon_sym_static] = ACTIONS(5005),
    [anon_sym_LBRACK] = ACTIONS(5007),
    [anon_sym_LPAREN] = ACTIONS(5007),
    [anon_sym_event] = ACTIONS(5005),
    [anon_sym_namespace] = ACTIONS(5005),
    [anon_sym_class] = ACTIONS(5005),
    [anon_sym_ref] = ACTIONS(5005),
    [anon_sym_struct] = ACTIONS(5005),
    [anon_sym_enum] = ACTIONS(5005),
    [anon_sym_RBRACE] = ACTIONS(5007),
    [anon_sym_interface] = ACTIONS(5005),
    [anon_sym_delegate] = ACTIONS(5005),
    [anon_sym_record] = ACTIONS(5005),
    [anon_sym_abstract] = ACTIONS(5005),
    [anon_sym_async] = ACTIONS(5005),
    [anon_sym_const] = ACTIONS(5005),
    [anon_sym_file] = ACTIONS(5005),
    [anon_sym_fixed] = ACTIONS(5005),
    [anon_sym_internal] = ACTIONS(5005),
    [anon_sym_new] = ACTIONS(5005),
    [anon_sym_override] = ACTIONS(5005),
    [anon_sym_partial] = ACTIONS(5005),
    [anon_sym_private] = ACTIONS(5005),
    [anon_sym_protected] = ACTIONS(5005),
    [anon_sym_public] = ACTIONS(5005),
    [anon_sym_readonly] = ACTIONS(5005),
    [anon_sym_required] = ACTIONS(5005),
    [anon_sym_sealed] = ACTIONS(5005),
    [anon_sym_virtual] = ACTIONS(5005),
    [anon_sym_volatile] = ACTIONS(5005),
    [anon_sym_where] = ACTIONS(5005),
    [anon_sym_notnull] = ACTIONS(5005),
    [anon_sym_unmanaged] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5007),
    [anon_sym_implicit] = ACTIONS(5005),
    [anon_sym_explicit] = ACTIONS(5005),
    [anon_sym_scoped] = ACTIONS(5005),
    [anon_sym_var] = ACTIONS(5005),
    [sym_predefined_type] = ACTIONS(5005),
    [anon_sym_yield] = ACTIONS(5005),
    [anon_sym_when] = ACTIONS(5005),
    [anon_sym_from] = ACTIONS(5005),
    [anon_sym_into] = ACTIONS(5005),
    [anon_sym_join] = ACTIONS(5005),
    [anon_sym_on] = ACTIONS(5005),
    [anon_sym_equals] = ACTIONS(5005),
    [anon_sym_let] = ACTIONS(5005),
    [anon_sym_orderby] = ACTIONS(5005),
    [anon_sym_ascending] = ACTIONS(5005),
    [anon_sym_descending] = ACTIONS(5005),
    [anon_sym_group] = ACTIONS(5005),
    [anon_sym_by] = ACTIONS(5005),
    [anon_sym_select] = ACTIONS(5005),
    [aux_sym_preproc_if_token1] = ACTIONS(5007),
    [aux_sym_preproc_if_token3] = ACTIONS(5007),
    [aux_sym_preproc_else_token1] = ACTIONS(5007),
    [aux_sym_preproc_elif_token1] = ACTIONS(5007),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3420] = {
    [sym_preproc_region] = STATE(3420),
    [sym_preproc_endregion] = STATE(3420),
    [sym_preproc_line] = STATE(3420),
    [sym_preproc_pragma] = STATE(3420),
    [sym_preproc_nullable] = STATE(3420),
    [sym_preproc_error] = STATE(3420),
    [sym_preproc_define] = STATE(3420),
    [sym_preproc_undef] = STATE(3420),
    [sym__identifier_token] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym_alias] = ACTIONS(3040),
    [anon_sym_global] = ACTIONS(3040),
    [anon_sym_using] = ACTIONS(3040),
    [anon_sym_unsafe] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_event] = ACTIONS(3040),
    [anon_sym_namespace] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_ref] = ACTIONS(3040),
    [anon_sym_struct] = ACTIONS(3040),
    [anon_sym_enum] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_interface] = ACTIONS(3040),
    [anon_sym_delegate] = ACTIONS(3040),
    [anon_sym_record] = ACTIONS(3040),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_file] = ACTIONS(3040),
    [anon_sym_fixed] = ACTIONS(3040),
    [anon_sym_internal] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_partial] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_required] = ACTIONS(3040),
    [anon_sym_sealed] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3040),
    [anon_sym_notnull] = ACTIONS(3040),
    [anon_sym_unmanaged] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3042),
    [anon_sym_implicit] = ACTIONS(3040),
    [anon_sym_explicit] = ACTIONS(3040),
    [anon_sym_scoped] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [sym_predefined_type] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_from] = ACTIONS(3040),
    [anon_sym_into] = ACTIONS(3040),
    [anon_sym_join] = ACTIONS(3040),
    [anon_sym_on] = ACTIONS(3040),
    [anon_sym_equals] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_orderby] = ACTIONS(3040),
    [anon_sym_ascending] = ACTIONS(3040),
    [anon_sym_descending] = ACTIONS(3040),
    [anon_sym_group] = ACTIONS(3040),
    [anon_sym_by] = ACTIONS(3040),
    [anon_sym_select] = ACTIONS(3040),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3421] = {
    [sym_preproc_region] = STATE(3421),
    [sym_preproc_endregion] = STATE(3421),
    [sym_preproc_line] = STATE(3421),
    [sym_preproc_pragma] = STATE(3421),
    [sym_preproc_nullable] = STATE(3421),
    [sym_preproc_error] = STATE(3421),
    [sym_preproc_define] = STATE(3421),
    [sym_preproc_undef] = STATE(3421),
    [sym__identifier_token] = ACTIONS(5009),
    [anon_sym_extern] = ACTIONS(5009),
    [anon_sym_alias] = ACTIONS(5009),
    [anon_sym_global] = ACTIONS(5009),
    [anon_sym_using] = ACTIONS(5009),
    [anon_sym_unsafe] = ACTIONS(5009),
    [anon_sym_static] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(5011),
    [anon_sym_LPAREN] = ACTIONS(5011),
    [anon_sym_event] = ACTIONS(5009),
    [anon_sym_namespace] = ACTIONS(5009),
    [anon_sym_class] = ACTIONS(5009),
    [anon_sym_ref] = ACTIONS(5009),
    [anon_sym_struct] = ACTIONS(5009),
    [anon_sym_enum] = ACTIONS(5009),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym_interface] = ACTIONS(5009),
    [anon_sym_delegate] = ACTIONS(5009),
    [anon_sym_record] = ACTIONS(5009),
    [anon_sym_abstract] = ACTIONS(5009),
    [anon_sym_async] = ACTIONS(5009),
    [anon_sym_const] = ACTIONS(5009),
    [anon_sym_file] = ACTIONS(5009),
    [anon_sym_fixed] = ACTIONS(5009),
    [anon_sym_internal] = ACTIONS(5009),
    [anon_sym_new] = ACTIONS(5009),
    [anon_sym_override] = ACTIONS(5009),
    [anon_sym_partial] = ACTIONS(5009),
    [anon_sym_private] = ACTIONS(5009),
    [anon_sym_protected] = ACTIONS(5009),
    [anon_sym_public] = ACTIONS(5009),
    [anon_sym_readonly] = ACTIONS(5009),
    [anon_sym_required] = ACTIONS(5009),
    [anon_sym_sealed] = ACTIONS(5009),
    [anon_sym_virtual] = ACTIONS(5009),
    [anon_sym_volatile] = ACTIONS(5009),
    [anon_sym_where] = ACTIONS(5009),
    [anon_sym_notnull] = ACTIONS(5009),
    [anon_sym_unmanaged] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5011),
    [anon_sym_implicit] = ACTIONS(5009),
    [anon_sym_explicit] = ACTIONS(5009),
    [anon_sym_scoped] = ACTIONS(5009),
    [anon_sym_var] = ACTIONS(5009),
    [sym_predefined_type] = ACTIONS(5009),
    [anon_sym_yield] = ACTIONS(5009),
    [anon_sym_when] = ACTIONS(5009),
    [anon_sym_from] = ACTIONS(5009),
    [anon_sym_into] = ACTIONS(5009),
    [anon_sym_join] = ACTIONS(5009),
    [anon_sym_on] = ACTIONS(5009),
    [anon_sym_equals] = ACTIONS(5009),
    [anon_sym_let] = ACTIONS(5009),
    [anon_sym_orderby] = ACTIONS(5009),
    [anon_sym_ascending] = ACTIONS(5009),
    [anon_sym_descending] = ACTIONS(5009),
    [anon_sym_group] = ACTIONS(5009),
    [anon_sym_by] = ACTIONS(5009),
    [anon_sym_select] = ACTIONS(5009),
    [aux_sym_preproc_if_token1] = ACTIONS(5011),
    [aux_sym_preproc_if_token3] = ACTIONS(5011),
    [aux_sym_preproc_else_token1] = ACTIONS(5011),
    [aux_sym_preproc_elif_token1] = ACTIONS(5011),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3422] = {
    [sym_preproc_region] = STATE(3422),
    [sym_preproc_endregion] = STATE(3422),
    [sym_preproc_line] = STATE(3422),
    [sym_preproc_pragma] = STATE(3422),
    [sym_preproc_nullable] = STATE(3422),
    [sym_preproc_error] = STATE(3422),
    [sym_preproc_define] = STATE(3422),
    [sym_preproc_undef] = STATE(3422),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_using] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_event] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_ref] = ACTIONS(2985),
    [anon_sym_struct] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_delegate] = ACTIONS(2985),
    [anon_sym_record] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_implicit] = ACTIONS(2985),
    [anon_sym_explicit] = ACTIONS(2985),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [sym_predefined_type] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [aux_sym_preproc_if_token1] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3423] = {
    [sym_preproc_region] = STATE(3423),
    [sym_preproc_endregion] = STATE(3423),
    [sym_preproc_line] = STATE(3423),
    [sym_preproc_pragma] = STATE(3423),
    [sym_preproc_nullable] = STATE(3423),
    [sym_preproc_error] = STATE(3423),
    [sym_preproc_define] = STATE(3423),
    [sym_preproc_undef] = STATE(3423),
    [sym__identifier_token] = ACTIONS(5013),
    [anon_sym_extern] = ACTIONS(5013),
    [anon_sym_alias] = ACTIONS(5013),
    [anon_sym_global] = ACTIONS(5013),
    [anon_sym_using] = ACTIONS(5013),
    [anon_sym_unsafe] = ACTIONS(5013),
    [anon_sym_static] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(5015),
    [anon_sym_LPAREN] = ACTIONS(5015),
    [anon_sym_event] = ACTIONS(5013),
    [anon_sym_namespace] = ACTIONS(5013),
    [anon_sym_class] = ACTIONS(5013),
    [anon_sym_ref] = ACTIONS(5013),
    [anon_sym_struct] = ACTIONS(5013),
    [anon_sym_enum] = ACTIONS(5013),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_interface] = ACTIONS(5013),
    [anon_sym_delegate] = ACTIONS(5013),
    [anon_sym_record] = ACTIONS(5013),
    [anon_sym_abstract] = ACTIONS(5013),
    [anon_sym_async] = ACTIONS(5013),
    [anon_sym_const] = ACTIONS(5013),
    [anon_sym_file] = ACTIONS(5013),
    [anon_sym_fixed] = ACTIONS(5013),
    [anon_sym_internal] = ACTIONS(5013),
    [anon_sym_new] = ACTIONS(5013),
    [anon_sym_override] = ACTIONS(5013),
    [anon_sym_partial] = ACTIONS(5013),
    [anon_sym_private] = ACTIONS(5013),
    [anon_sym_protected] = ACTIONS(5013),
    [anon_sym_public] = ACTIONS(5013),
    [anon_sym_readonly] = ACTIONS(5013),
    [anon_sym_required] = ACTIONS(5013),
    [anon_sym_sealed] = ACTIONS(5013),
    [anon_sym_virtual] = ACTIONS(5013),
    [anon_sym_volatile] = ACTIONS(5013),
    [anon_sym_where] = ACTIONS(5013),
    [anon_sym_notnull] = ACTIONS(5013),
    [anon_sym_unmanaged] = ACTIONS(5013),
    [anon_sym_TILDE] = ACTIONS(5015),
    [anon_sym_implicit] = ACTIONS(5013),
    [anon_sym_explicit] = ACTIONS(5013),
    [anon_sym_scoped] = ACTIONS(5013),
    [anon_sym_var] = ACTIONS(5013),
    [sym_predefined_type] = ACTIONS(5013),
    [anon_sym_yield] = ACTIONS(5013),
    [anon_sym_when] = ACTIONS(5013),
    [anon_sym_from] = ACTIONS(5013),
    [anon_sym_into] = ACTIONS(5013),
    [anon_sym_join] = ACTIONS(5013),
    [anon_sym_on] = ACTIONS(5013),
    [anon_sym_equals] = ACTIONS(5013),
    [anon_sym_let] = ACTIONS(5013),
    [anon_sym_orderby] = ACTIONS(5013),
    [anon_sym_ascending] = ACTIONS(5013),
    [anon_sym_descending] = ACTIONS(5013),
    [anon_sym_group] = ACTIONS(5013),
    [anon_sym_by] = ACTIONS(5013),
    [anon_sym_select] = ACTIONS(5013),
    [aux_sym_preproc_if_token1] = ACTIONS(5015),
    [aux_sym_preproc_if_token3] = ACTIONS(5015),
    [aux_sym_preproc_else_token1] = ACTIONS(5015),
    [aux_sym_preproc_elif_token1] = ACTIONS(5015),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3424] = {
    [sym_preproc_region] = STATE(3424),
    [sym_preproc_endregion] = STATE(3424),
    [sym_preproc_line] = STATE(3424),
    [sym_preproc_pragma] = STATE(3424),
    [sym_preproc_nullable] = STATE(3424),
    [sym_preproc_error] = STATE(3424),
    [sym_preproc_define] = STATE(3424),
    [sym_preproc_undef] = STATE(3424),
    [sym__identifier_token] = ACTIONS(5017),
    [anon_sym_extern] = ACTIONS(5017),
    [anon_sym_alias] = ACTIONS(5017),
    [anon_sym_global] = ACTIONS(5017),
    [anon_sym_using] = ACTIONS(5017),
    [anon_sym_unsafe] = ACTIONS(5017),
    [anon_sym_static] = ACTIONS(5017),
    [anon_sym_LBRACK] = ACTIONS(5019),
    [anon_sym_LPAREN] = ACTIONS(5019),
    [anon_sym_event] = ACTIONS(5017),
    [anon_sym_namespace] = ACTIONS(5017),
    [anon_sym_class] = ACTIONS(5017),
    [anon_sym_ref] = ACTIONS(5017),
    [anon_sym_struct] = ACTIONS(5017),
    [anon_sym_enum] = ACTIONS(5017),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [anon_sym_interface] = ACTIONS(5017),
    [anon_sym_delegate] = ACTIONS(5017),
    [anon_sym_record] = ACTIONS(5017),
    [anon_sym_abstract] = ACTIONS(5017),
    [anon_sym_async] = ACTIONS(5017),
    [anon_sym_const] = ACTIONS(5017),
    [anon_sym_file] = ACTIONS(5017),
    [anon_sym_fixed] = ACTIONS(5017),
    [anon_sym_internal] = ACTIONS(5017),
    [anon_sym_new] = ACTIONS(5017),
    [anon_sym_override] = ACTIONS(5017),
    [anon_sym_partial] = ACTIONS(5017),
    [anon_sym_private] = ACTIONS(5017),
    [anon_sym_protected] = ACTIONS(5017),
    [anon_sym_public] = ACTIONS(5017),
    [anon_sym_readonly] = ACTIONS(5017),
    [anon_sym_required] = ACTIONS(5017),
    [anon_sym_sealed] = ACTIONS(5017),
    [anon_sym_virtual] = ACTIONS(5017),
    [anon_sym_volatile] = ACTIONS(5017),
    [anon_sym_where] = ACTIONS(5017),
    [anon_sym_notnull] = ACTIONS(5017),
    [anon_sym_unmanaged] = ACTIONS(5017),
    [anon_sym_TILDE] = ACTIONS(5019),
    [anon_sym_implicit] = ACTIONS(5017),
    [anon_sym_explicit] = ACTIONS(5017),
    [anon_sym_scoped] = ACTIONS(5017),
    [anon_sym_var] = ACTIONS(5017),
    [sym_predefined_type] = ACTIONS(5017),
    [anon_sym_yield] = ACTIONS(5017),
    [anon_sym_when] = ACTIONS(5017),
    [anon_sym_from] = ACTIONS(5017),
    [anon_sym_into] = ACTIONS(5017),
    [anon_sym_join] = ACTIONS(5017),
    [anon_sym_on] = ACTIONS(5017),
    [anon_sym_equals] = ACTIONS(5017),
    [anon_sym_let] = ACTIONS(5017),
    [anon_sym_orderby] = ACTIONS(5017),
    [anon_sym_ascending] = ACTIONS(5017),
    [anon_sym_descending] = ACTIONS(5017),
    [anon_sym_group] = ACTIONS(5017),
    [anon_sym_by] = ACTIONS(5017),
    [anon_sym_select] = ACTIONS(5017),
    [aux_sym_preproc_if_token1] = ACTIONS(5019),
    [aux_sym_preproc_if_token3] = ACTIONS(5019),
    [aux_sym_preproc_else_token1] = ACTIONS(5019),
    [aux_sym_preproc_elif_token1] = ACTIONS(5019),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3425] = {
    [sym_preproc_region] = STATE(3425),
    [sym_preproc_endregion] = STATE(3425),
    [sym_preproc_line] = STATE(3425),
    [sym_preproc_pragma] = STATE(3425),
    [sym_preproc_nullable] = STATE(3425),
    [sym_preproc_error] = STATE(3425),
    [sym_preproc_define] = STATE(3425),
    [sym_preproc_undef] = STATE(3425),
    [sym__identifier_token] = ACTIONS(5021),
    [anon_sym_extern] = ACTIONS(5021),
    [anon_sym_alias] = ACTIONS(5021),
    [anon_sym_global] = ACTIONS(5021),
    [anon_sym_using] = ACTIONS(5021),
    [anon_sym_unsafe] = ACTIONS(5021),
    [anon_sym_static] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(5023),
    [anon_sym_LPAREN] = ACTIONS(5023),
    [anon_sym_event] = ACTIONS(5021),
    [anon_sym_namespace] = ACTIONS(5021),
    [anon_sym_class] = ACTIONS(5021),
    [anon_sym_ref] = ACTIONS(5021),
    [anon_sym_struct] = ACTIONS(5021),
    [anon_sym_enum] = ACTIONS(5021),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_interface] = ACTIONS(5021),
    [anon_sym_delegate] = ACTIONS(5021),
    [anon_sym_record] = ACTIONS(5021),
    [anon_sym_abstract] = ACTIONS(5021),
    [anon_sym_async] = ACTIONS(5021),
    [anon_sym_const] = ACTIONS(5021),
    [anon_sym_file] = ACTIONS(5021),
    [anon_sym_fixed] = ACTIONS(5021),
    [anon_sym_internal] = ACTIONS(5021),
    [anon_sym_new] = ACTIONS(5021),
    [anon_sym_override] = ACTIONS(5021),
    [anon_sym_partial] = ACTIONS(5021),
    [anon_sym_private] = ACTIONS(5021),
    [anon_sym_protected] = ACTIONS(5021),
    [anon_sym_public] = ACTIONS(5021),
    [anon_sym_readonly] = ACTIONS(5021),
    [anon_sym_required] = ACTIONS(5021),
    [anon_sym_sealed] = ACTIONS(5021),
    [anon_sym_virtual] = ACTIONS(5021),
    [anon_sym_volatile] = ACTIONS(5021),
    [anon_sym_where] = ACTIONS(5021),
    [anon_sym_notnull] = ACTIONS(5021),
    [anon_sym_unmanaged] = ACTIONS(5021),
    [anon_sym_TILDE] = ACTIONS(5023),
    [anon_sym_implicit] = ACTIONS(5021),
    [anon_sym_explicit] = ACTIONS(5021),
    [anon_sym_scoped] = ACTIONS(5021),
    [anon_sym_var] = ACTIONS(5021),
    [sym_predefined_type] = ACTIONS(5021),
    [anon_sym_yield] = ACTIONS(5021),
    [anon_sym_when] = ACTIONS(5021),
    [anon_sym_from] = ACTIONS(5021),
    [anon_sym_into] = ACTIONS(5021),
    [anon_sym_join] = ACTIONS(5021),
    [anon_sym_on] = ACTIONS(5021),
    [anon_sym_equals] = ACTIONS(5021),
    [anon_sym_let] = ACTIONS(5021),
    [anon_sym_orderby] = ACTIONS(5021),
    [anon_sym_ascending] = ACTIONS(5021),
    [anon_sym_descending] = ACTIONS(5021),
    [anon_sym_group] = ACTIONS(5021),
    [anon_sym_by] = ACTIONS(5021),
    [anon_sym_select] = ACTIONS(5021),
    [aux_sym_preproc_if_token1] = ACTIONS(5023),
    [aux_sym_preproc_if_token3] = ACTIONS(5023),
    [aux_sym_preproc_else_token1] = ACTIONS(5023),
    [aux_sym_preproc_elif_token1] = ACTIONS(5023),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3426] = {
    [sym_preproc_region] = STATE(3426),
    [sym_preproc_endregion] = STATE(3426),
    [sym_preproc_line] = STATE(3426),
    [sym_preproc_pragma] = STATE(3426),
    [sym_preproc_nullable] = STATE(3426),
    [sym_preproc_error] = STATE(3426),
    [sym_preproc_define] = STATE(3426),
    [sym_preproc_undef] = STATE(3426),
    [sym__identifier_token] = ACTIONS(3559),
    [anon_sym_extern] = ACTIONS(3559),
    [anon_sym_alias] = ACTIONS(3559),
    [anon_sym_global] = ACTIONS(3559),
    [anon_sym_using] = ACTIONS(3559),
    [anon_sym_unsafe] = ACTIONS(3559),
    [anon_sym_static] = ACTIONS(3559),
    [anon_sym_LBRACK] = ACTIONS(3561),
    [anon_sym_LPAREN] = ACTIONS(3561),
    [anon_sym_event] = ACTIONS(3559),
    [anon_sym_namespace] = ACTIONS(3559),
    [anon_sym_class] = ACTIONS(3559),
    [anon_sym_ref] = ACTIONS(3559),
    [anon_sym_struct] = ACTIONS(3559),
    [anon_sym_enum] = ACTIONS(3559),
    [anon_sym_RBRACE] = ACTIONS(3561),
    [anon_sym_interface] = ACTIONS(3559),
    [anon_sym_delegate] = ACTIONS(3559),
    [anon_sym_record] = ACTIONS(3559),
    [anon_sym_abstract] = ACTIONS(3559),
    [anon_sym_async] = ACTIONS(3559),
    [anon_sym_const] = ACTIONS(3559),
    [anon_sym_file] = ACTIONS(3559),
    [anon_sym_fixed] = ACTIONS(3559),
    [anon_sym_internal] = ACTIONS(3559),
    [anon_sym_new] = ACTIONS(3559),
    [anon_sym_override] = ACTIONS(3559),
    [anon_sym_partial] = ACTIONS(3559),
    [anon_sym_private] = ACTIONS(3559),
    [anon_sym_protected] = ACTIONS(3559),
    [anon_sym_public] = ACTIONS(3559),
    [anon_sym_readonly] = ACTIONS(3559),
    [anon_sym_required] = ACTIONS(3559),
    [anon_sym_sealed] = ACTIONS(3559),
    [anon_sym_virtual] = ACTIONS(3559),
    [anon_sym_volatile] = ACTIONS(3559),
    [anon_sym_where] = ACTIONS(3559),
    [anon_sym_notnull] = ACTIONS(3559),
    [anon_sym_unmanaged] = ACTIONS(3559),
    [anon_sym_TILDE] = ACTIONS(3561),
    [anon_sym_implicit] = ACTIONS(3559),
    [anon_sym_explicit] = ACTIONS(3559),
    [anon_sym_scoped] = ACTIONS(3559),
    [anon_sym_var] = ACTIONS(3559),
    [sym_predefined_type] = ACTIONS(3559),
    [anon_sym_yield] = ACTIONS(3559),
    [anon_sym_when] = ACTIONS(3559),
    [anon_sym_from] = ACTIONS(3559),
    [anon_sym_into] = ACTIONS(3559),
    [anon_sym_join] = ACTIONS(3559),
    [anon_sym_on] = ACTIONS(3559),
    [anon_sym_equals] = ACTIONS(3559),
    [anon_sym_let] = ACTIONS(3559),
    [anon_sym_orderby] = ACTIONS(3559),
    [anon_sym_ascending] = ACTIONS(3559),
    [anon_sym_descending] = ACTIONS(3559),
    [anon_sym_group] = ACTIONS(3559),
    [anon_sym_by] = ACTIONS(3559),
    [anon_sym_select] = ACTIONS(3559),
    [aux_sym_preproc_if_token1] = ACTIONS(3561),
    [aux_sym_preproc_if_token3] = ACTIONS(3561),
    [aux_sym_preproc_else_token1] = ACTIONS(3561),
    [aux_sym_preproc_elif_token1] = ACTIONS(3561),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3427] = {
    [sym_preproc_region] = STATE(3427),
    [sym_preproc_endregion] = STATE(3427),
    [sym_preproc_line] = STATE(3427),
    [sym_preproc_pragma] = STATE(3427),
    [sym_preproc_nullable] = STATE(3427),
    [sym_preproc_error] = STATE(3427),
    [sym_preproc_define] = STATE(3427),
    [sym_preproc_undef] = STATE(3427),
    [sym__identifier_token] = ACTIONS(5025),
    [anon_sym_extern] = ACTIONS(5025),
    [anon_sym_alias] = ACTIONS(5025),
    [anon_sym_global] = ACTIONS(5025),
    [anon_sym_using] = ACTIONS(5025),
    [anon_sym_unsafe] = ACTIONS(5025),
    [anon_sym_static] = ACTIONS(5025),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(5027),
    [anon_sym_event] = ACTIONS(5025),
    [anon_sym_namespace] = ACTIONS(5025),
    [anon_sym_class] = ACTIONS(5025),
    [anon_sym_ref] = ACTIONS(5025),
    [anon_sym_struct] = ACTIONS(5025),
    [anon_sym_enum] = ACTIONS(5025),
    [anon_sym_RBRACE] = ACTIONS(5027),
    [anon_sym_interface] = ACTIONS(5025),
    [anon_sym_delegate] = ACTIONS(5025),
    [anon_sym_record] = ACTIONS(5025),
    [anon_sym_abstract] = ACTIONS(5025),
    [anon_sym_async] = ACTIONS(5025),
    [anon_sym_const] = ACTIONS(5025),
    [anon_sym_file] = ACTIONS(5025),
    [anon_sym_fixed] = ACTIONS(5025),
    [anon_sym_internal] = ACTIONS(5025),
    [anon_sym_new] = ACTIONS(5025),
    [anon_sym_override] = ACTIONS(5025),
    [anon_sym_partial] = ACTIONS(5025),
    [anon_sym_private] = ACTIONS(5025),
    [anon_sym_protected] = ACTIONS(5025),
    [anon_sym_public] = ACTIONS(5025),
    [anon_sym_readonly] = ACTIONS(5025),
    [anon_sym_required] = ACTIONS(5025),
    [anon_sym_sealed] = ACTIONS(5025),
    [anon_sym_virtual] = ACTIONS(5025),
    [anon_sym_volatile] = ACTIONS(5025),
    [anon_sym_where] = ACTIONS(5025),
    [anon_sym_notnull] = ACTIONS(5025),
    [anon_sym_unmanaged] = ACTIONS(5025),
    [anon_sym_TILDE] = ACTIONS(5027),
    [anon_sym_implicit] = ACTIONS(5025),
    [anon_sym_explicit] = ACTIONS(5025),
    [anon_sym_scoped] = ACTIONS(5025),
    [anon_sym_var] = ACTIONS(5025),
    [sym_predefined_type] = ACTIONS(5025),
    [anon_sym_yield] = ACTIONS(5025),
    [anon_sym_when] = ACTIONS(5025),
    [anon_sym_from] = ACTIONS(5025),
    [anon_sym_into] = ACTIONS(5025),
    [anon_sym_join] = ACTIONS(5025),
    [anon_sym_on] = ACTIONS(5025),
    [anon_sym_equals] = ACTIONS(5025),
    [anon_sym_let] = ACTIONS(5025),
    [anon_sym_orderby] = ACTIONS(5025),
    [anon_sym_ascending] = ACTIONS(5025),
    [anon_sym_descending] = ACTIONS(5025),
    [anon_sym_group] = ACTIONS(5025),
    [anon_sym_by] = ACTIONS(5025),
    [anon_sym_select] = ACTIONS(5025),
    [aux_sym_preproc_if_token1] = ACTIONS(5027),
    [aux_sym_preproc_if_token3] = ACTIONS(5027),
    [aux_sym_preproc_else_token1] = ACTIONS(5027),
    [aux_sym_preproc_elif_token1] = ACTIONS(5027),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3428] = {
    [sym_preproc_region] = STATE(3428),
    [sym_preproc_endregion] = STATE(3428),
    [sym_preproc_line] = STATE(3428),
    [sym_preproc_pragma] = STATE(3428),
    [sym_preproc_nullable] = STATE(3428),
    [sym_preproc_error] = STATE(3428),
    [sym_preproc_define] = STATE(3428),
    [sym_preproc_undef] = STATE(3428),
    [sym__identifier_token] = ACTIONS(5029),
    [anon_sym_extern] = ACTIONS(5029),
    [anon_sym_alias] = ACTIONS(5029),
    [anon_sym_global] = ACTIONS(5029),
    [anon_sym_using] = ACTIONS(5029),
    [anon_sym_unsafe] = ACTIONS(5029),
    [anon_sym_static] = ACTIONS(5029),
    [anon_sym_LBRACK] = ACTIONS(5031),
    [anon_sym_LPAREN] = ACTIONS(5031),
    [anon_sym_event] = ACTIONS(5029),
    [anon_sym_namespace] = ACTIONS(5029),
    [anon_sym_class] = ACTIONS(5029),
    [anon_sym_ref] = ACTIONS(5029),
    [anon_sym_struct] = ACTIONS(5029),
    [anon_sym_enum] = ACTIONS(5029),
    [anon_sym_RBRACE] = ACTIONS(5031),
    [anon_sym_interface] = ACTIONS(5029),
    [anon_sym_delegate] = ACTIONS(5029),
    [anon_sym_record] = ACTIONS(5029),
    [anon_sym_abstract] = ACTIONS(5029),
    [anon_sym_async] = ACTIONS(5029),
    [anon_sym_const] = ACTIONS(5029),
    [anon_sym_file] = ACTIONS(5029),
    [anon_sym_fixed] = ACTIONS(5029),
    [anon_sym_internal] = ACTIONS(5029),
    [anon_sym_new] = ACTIONS(5029),
    [anon_sym_override] = ACTIONS(5029),
    [anon_sym_partial] = ACTIONS(5029),
    [anon_sym_private] = ACTIONS(5029),
    [anon_sym_protected] = ACTIONS(5029),
    [anon_sym_public] = ACTIONS(5029),
    [anon_sym_readonly] = ACTIONS(5029),
    [anon_sym_required] = ACTIONS(5029),
    [anon_sym_sealed] = ACTIONS(5029),
    [anon_sym_virtual] = ACTIONS(5029),
    [anon_sym_volatile] = ACTIONS(5029),
    [anon_sym_where] = ACTIONS(5029),
    [anon_sym_notnull] = ACTIONS(5029),
    [anon_sym_unmanaged] = ACTIONS(5029),
    [anon_sym_TILDE] = ACTIONS(5031),
    [anon_sym_implicit] = ACTIONS(5029),
    [anon_sym_explicit] = ACTIONS(5029),
    [anon_sym_scoped] = ACTIONS(5029),
    [anon_sym_var] = ACTIONS(5029),
    [sym_predefined_type] = ACTIONS(5029),
    [anon_sym_yield] = ACTIONS(5029),
    [anon_sym_when] = ACTIONS(5029),
    [anon_sym_from] = ACTIONS(5029),
    [anon_sym_into] = ACTIONS(5029),
    [anon_sym_join] = ACTIONS(5029),
    [anon_sym_on] = ACTIONS(5029),
    [anon_sym_equals] = ACTIONS(5029),
    [anon_sym_let] = ACTIONS(5029),
    [anon_sym_orderby] = ACTIONS(5029),
    [anon_sym_ascending] = ACTIONS(5029),
    [anon_sym_descending] = ACTIONS(5029),
    [anon_sym_group] = ACTIONS(5029),
    [anon_sym_by] = ACTIONS(5029),
    [anon_sym_select] = ACTIONS(5029),
    [aux_sym_preproc_if_token1] = ACTIONS(5031),
    [aux_sym_preproc_if_token3] = ACTIONS(5031),
    [aux_sym_preproc_else_token1] = ACTIONS(5031),
    [aux_sym_preproc_elif_token1] = ACTIONS(5031),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3429] = {
    [sym_preproc_region] = STATE(3429),
    [sym_preproc_endregion] = STATE(3429),
    [sym_preproc_line] = STATE(3429),
    [sym_preproc_pragma] = STATE(3429),
    [sym_preproc_nullable] = STATE(3429),
    [sym_preproc_error] = STATE(3429),
    [sym_preproc_define] = STATE(3429),
    [sym_preproc_undef] = STATE(3429),
    [sym__identifier_token] = ACTIONS(5033),
    [anon_sym_extern] = ACTIONS(5033),
    [anon_sym_alias] = ACTIONS(5033),
    [anon_sym_global] = ACTIONS(5033),
    [anon_sym_using] = ACTIONS(5033),
    [anon_sym_unsafe] = ACTIONS(5033),
    [anon_sym_static] = ACTIONS(5033),
    [anon_sym_LBRACK] = ACTIONS(5035),
    [anon_sym_LPAREN] = ACTIONS(5035),
    [anon_sym_event] = ACTIONS(5033),
    [anon_sym_namespace] = ACTIONS(5033),
    [anon_sym_class] = ACTIONS(5033),
    [anon_sym_ref] = ACTIONS(5033),
    [anon_sym_struct] = ACTIONS(5033),
    [anon_sym_enum] = ACTIONS(5033),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_interface] = ACTIONS(5033),
    [anon_sym_delegate] = ACTIONS(5033),
    [anon_sym_record] = ACTIONS(5033),
    [anon_sym_abstract] = ACTIONS(5033),
    [anon_sym_async] = ACTIONS(5033),
    [anon_sym_const] = ACTIONS(5033),
    [anon_sym_file] = ACTIONS(5033),
    [anon_sym_fixed] = ACTIONS(5033),
    [anon_sym_internal] = ACTIONS(5033),
    [anon_sym_new] = ACTIONS(5033),
    [anon_sym_override] = ACTIONS(5033),
    [anon_sym_partial] = ACTIONS(5033),
    [anon_sym_private] = ACTIONS(5033),
    [anon_sym_protected] = ACTIONS(5033),
    [anon_sym_public] = ACTIONS(5033),
    [anon_sym_readonly] = ACTIONS(5033),
    [anon_sym_required] = ACTIONS(5033),
    [anon_sym_sealed] = ACTIONS(5033),
    [anon_sym_virtual] = ACTIONS(5033),
    [anon_sym_volatile] = ACTIONS(5033),
    [anon_sym_where] = ACTIONS(5033),
    [anon_sym_notnull] = ACTIONS(5033),
    [anon_sym_unmanaged] = ACTIONS(5033),
    [anon_sym_TILDE] = ACTIONS(5035),
    [anon_sym_implicit] = ACTIONS(5033),
    [anon_sym_explicit] = ACTIONS(5033),
    [anon_sym_scoped] = ACTIONS(5033),
    [anon_sym_var] = ACTIONS(5033),
    [sym_predefined_type] = ACTIONS(5033),
    [anon_sym_yield] = ACTIONS(5033),
    [anon_sym_when] = ACTIONS(5033),
    [anon_sym_from] = ACTIONS(5033),
    [anon_sym_into] = ACTIONS(5033),
    [anon_sym_join] = ACTIONS(5033),
    [anon_sym_on] = ACTIONS(5033),
    [anon_sym_equals] = ACTIONS(5033),
    [anon_sym_let] = ACTIONS(5033),
    [anon_sym_orderby] = ACTIONS(5033),
    [anon_sym_ascending] = ACTIONS(5033),
    [anon_sym_descending] = ACTIONS(5033),
    [anon_sym_group] = ACTIONS(5033),
    [anon_sym_by] = ACTIONS(5033),
    [anon_sym_select] = ACTIONS(5033),
    [aux_sym_preproc_if_token1] = ACTIONS(5035),
    [aux_sym_preproc_if_token3] = ACTIONS(5035),
    [aux_sym_preproc_else_token1] = ACTIONS(5035),
    [aux_sym_preproc_elif_token1] = ACTIONS(5035),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3430] = {
    [sym_preproc_region] = STATE(3430),
    [sym_preproc_endregion] = STATE(3430),
    [sym_preproc_line] = STATE(3430),
    [sym_preproc_pragma] = STATE(3430),
    [sym_preproc_nullable] = STATE(3430),
    [sym_preproc_error] = STATE(3430),
    [sym_preproc_define] = STATE(3430),
    [sym_preproc_undef] = STATE(3430),
    [sym__identifier_token] = ACTIONS(5037),
    [anon_sym_extern] = ACTIONS(5037),
    [anon_sym_alias] = ACTIONS(5037),
    [anon_sym_global] = ACTIONS(5037),
    [anon_sym_using] = ACTIONS(5037),
    [anon_sym_unsafe] = ACTIONS(5037),
    [anon_sym_static] = ACTIONS(5037),
    [anon_sym_LBRACK] = ACTIONS(5039),
    [anon_sym_LPAREN] = ACTIONS(5039),
    [anon_sym_event] = ACTIONS(5037),
    [anon_sym_namespace] = ACTIONS(5037),
    [anon_sym_class] = ACTIONS(5037),
    [anon_sym_ref] = ACTIONS(5037),
    [anon_sym_struct] = ACTIONS(5037),
    [anon_sym_enum] = ACTIONS(5037),
    [anon_sym_RBRACE] = ACTIONS(5039),
    [anon_sym_interface] = ACTIONS(5037),
    [anon_sym_delegate] = ACTIONS(5037),
    [anon_sym_record] = ACTIONS(5037),
    [anon_sym_abstract] = ACTIONS(5037),
    [anon_sym_async] = ACTIONS(5037),
    [anon_sym_const] = ACTIONS(5037),
    [anon_sym_file] = ACTIONS(5037),
    [anon_sym_fixed] = ACTIONS(5037),
    [anon_sym_internal] = ACTIONS(5037),
    [anon_sym_new] = ACTIONS(5037),
    [anon_sym_override] = ACTIONS(5037),
    [anon_sym_partial] = ACTIONS(5037),
    [anon_sym_private] = ACTIONS(5037),
    [anon_sym_protected] = ACTIONS(5037),
    [anon_sym_public] = ACTIONS(5037),
    [anon_sym_readonly] = ACTIONS(5037),
    [anon_sym_required] = ACTIONS(5037),
    [anon_sym_sealed] = ACTIONS(5037),
    [anon_sym_virtual] = ACTIONS(5037),
    [anon_sym_volatile] = ACTIONS(5037),
    [anon_sym_where] = ACTIONS(5037),
    [anon_sym_notnull] = ACTIONS(5037),
    [anon_sym_unmanaged] = ACTIONS(5037),
    [anon_sym_TILDE] = ACTIONS(5039),
    [anon_sym_implicit] = ACTIONS(5037),
    [anon_sym_explicit] = ACTIONS(5037),
    [anon_sym_scoped] = ACTIONS(5037),
    [anon_sym_var] = ACTIONS(5037),
    [sym_predefined_type] = ACTIONS(5037),
    [anon_sym_yield] = ACTIONS(5037),
    [anon_sym_when] = ACTIONS(5037),
    [anon_sym_from] = ACTIONS(5037),
    [anon_sym_into] = ACTIONS(5037),
    [anon_sym_join] = ACTIONS(5037),
    [anon_sym_on] = ACTIONS(5037),
    [anon_sym_equals] = ACTIONS(5037),
    [anon_sym_let] = ACTIONS(5037),
    [anon_sym_orderby] = ACTIONS(5037),
    [anon_sym_ascending] = ACTIONS(5037),
    [anon_sym_descending] = ACTIONS(5037),
    [anon_sym_group] = ACTIONS(5037),
    [anon_sym_by] = ACTIONS(5037),
    [anon_sym_select] = ACTIONS(5037),
    [aux_sym_preproc_if_token1] = ACTIONS(5039),
    [aux_sym_preproc_if_token3] = ACTIONS(5039),
    [aux_sym_preproc_else_token1] = ACTIONS(5039),
    [aux_sym_preproc_elif_token1] = ACTIONS(5039),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3431] = {
    [sym_preproc_region] = STATE(3431),
    [sym_preproc_endregion] = STATE(3431),
    [sym_preproc_line] = STATE(3431),
    [sym_preproc_pragma] = STATE(3431),
    [sym_preproc_nullable] = STATE(3431),
    [sym_preproc_error] = STATE(3431),
    [sym_preproc_define] = STATE(3431),
    [sym_preproc_undef] = STATE(3431),
    [sym__identifier_token] = ACTIONS(5041),
    [anon_sym_extern] = ACTIONS(5041),
    [anon_sym_alias] = ACTIONS(5041),
    [anon_sym_global] = ACTIONS(5041),
    [anon_sym_using] = ACTIONS(5041),
    [anon_sym_unsafe] = ACTIONS(5041),
    [anon_sym_static] = ACTIONS(5041),
    [anon_sym_LBRACK] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5043),
    [anon_sym_event] = ACTIONS(5041),
    [anon_sym_namespace] = ACTIONS(5041),
    [anon_sym_class] = ACTIONS(5041),
    [anon_sym_ref] = ACTIONS(5041),
    [anon_sym_struct] = ACTIONS(5041),
    [anon_sym_enum] = ACTIONS(5041),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [anon_sym_interface] = ACTIONS(5041),
    [anon_sym_delegate] = ACTIONS(5041),
    [anon_sym_record] = ACTIONS(5041),
    [anon_sym_abstract] = ACTIONS(5041),
    [anon_sym_async] = ACTIONS(5041),
    [anon_sym_const] = ACTIONS(5041),
    [anon_sym_file] = ACTIONS(5041),
    [anon_sym_fixed] = ACTIONS(5041),
    [anon_sym_internal] = ACTIONS(5041),
    [anon_sym_new] = ACTIONS(5041),
    [anon_sym_override] = ACTIONS(5041),
    [anon_sym_partial] = ACTIONS(5041),
    [anon_sym_private] = ACTIONS(5041),
    [anon_sym_protected] = ACTIONS(5041),
    [anon_sym_public] = ACTIONS(5041),
    [anon_sym_readonly] = ACTIONS(5041),
    [anon_sym_required] = ACTIONS(5041),
    [anon_sym_sealed] = ACTIONS(5041),
    [anon_sym_virtual] = ACTIONS(5041),
    [anon_sym_volatile] = ACTIONS(5041),
    [anon_sym_where] = ACTIONS(5041),
    [anon_sym_notnull] = ACTIONS(5041),
    [anon_sym_unmanaged] = ACTIONS(5041),
    [anon_sym_TILDE] = ACTIONS(5043),
    [anon_sym_implicit] = ACTIONS(5041),
    [anon_sym_explicit] = ACTIONS(5041),
    [anon_sym_scoped] = ACTIONS(5041),
    [anon_sym_var] = ACTIONS(5041),
    [sym_predefined_type] = ACTIONS(5041),
    [anon_sym_yield] = ACTIONS(5041),
    [anon_sym_when] = ACTIONS(5041),
    [anon_sym_from] = ACTIONS(5041),
    [anon_sym_into] = ACTIONS(5041),
    [anon_sym_join] = ACTIONS(5041),
    [anon_sym_on] = ACTIONS(5041),
    [anon_sym_equals] = ACTIONS(5041),
    [anon_sym_let] = ACTIONS(5041),
    [anon_sym_orderby] = ACTIONS(5041),
    [anon_sym_ascending] = ACTIONS(5041),
    [anon_sym_descending] = ACTIONS(5041),
    [anon_sym_group] = ACTIONS(5041),
    [anon_sym_by] = ACTIONS(5041),
    [anon_sym_select] = ACTIONS(5041),
    [aux_sym_preproc_if_token1] = ACTIONS(5043),
    [aux_sym_preproc_if_token3] = ACTIONS(5043),
    [aux_sym_preproc_else_token1] = ACTIONS(5043),
    [aux_sym_preproc_elif_token1] = ACTIONS(5043),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3432] = {
    [sym_preproc_region] = STATE(3432),
    [sym_preproc_endregion] = STATE(3432),
    [sym_preproc_line] = STATE(3432),
    [sym_preproc_pragma] = STATE(3432),
    [sym_preproc_nullable] = STATE(3432),
    [sym_preproc_error] = STATE(3432),
    [sym_preproc_define] = STATE(3432),
    [sym_preproc_undef] = STATE(3432),
    [sym__identifier_token] = ACTIONS(3563),
    [anon_sym_extern] = ACTIONS(3563),
    [anon_sym_alias] = ACTIONS(3563),
    [anon_sym_global] = ACTIONS(3563),
    [anon_sym_using] = ACTIONS(3563),
    [anon_sym_unsafe] = ACTIONS(3563),
    [anon_sym_static] = ACTIONS(3563),
    [anon_sym_LBRACK] = ACTIONS(3565),
    [anon_sym_LPAREN] = ACTIONS(3565),
    [anon_sym_event] = ACTIONS(3563),
    [anon_sym_namespace] = ACTIONS(3563),
    [anon_sym_class] = ACTIONS(3563),
    [anon_sym_ref] = ACTIONS(3563),
    [anon_sym_struct] = ACTIONS(3563),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [anon_sym_interface] = ACTIONS(3563),
    [anon_sym_delegate] = ACTIONS(3563),
    [anon_sym_record] = ACTIONS(3563),
    [anon_sym_abstract] = ACTIONS(3563),
    [anon_sym_async] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3563),
    [anon_sym_file] = ACTIONS(3563),
    [anon_sym_fixed] = ACTIONS(3563),
    [anon_sym_internal] = ACTIONS(3563),
    [anon_sym_new] = ACTIONS(3563),
    [anon_sym_override] = ACTIONS(3563),
    [anon_sym_partial] = ACTIONS(3563),
    [anon_sym_private] = ACTIONS(3563),
    [anon_sym_protected] = ACTIONS(3563),
    [anon_sym_public] = ACTIONS(3563),
    [anon_sym_readonly] = ACTIONS(3563),
    [anon_sym_required] = ACTIONS(3563),
    [anon_sym_sealed] = ACTIONS(3563),
    [anon_sym_virtual] = ACTIONS(3563),
    [anon_sym_volatile] = ACTIONS(3563),
    [anon_sym_where] = ACTIONS(3563),
    [anon_sym_notnull] = ACTIONS(3563),
    [anon_sym_unmanaged] = ACTIONS(3563),
    [anon_sym_TILDE] = ACTIONS(3565),
    [anon_sym_implicit] = ACTIONS(3563),
    [anon_sym_explicit] = ACTIONS(3563),
    [anon_sym_scoped] = ACTIONS(3563),
    [anon_sym_var] = ACTIONS(3563),
    [sym_predefined_type] = ACTIONS(3563),
    [anon_sym_yield] = ACTIONS(3563),
    [anon_sym_when] = ACTIONS(3563),
    [anon_sym_from] = ACTIONS(3563),
    [anon_sym_into] = ACTIONS(3563),
    [anon_sym_join] = ACTIONS(3563),
    [anon_sym_on] = ACTIONS(3563),
    [anon_sym_equals] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3563),
    [anon_sym_orderby] = ACTIONS(3563),
    [anon_sym_ascending] = ACTIONS(3563),
    [anon_sym_descending] = ACTIONS(3563),
    [anon_sym_group] = ACTIONS(3563),
    [anon_sym_by] = ACTIONS(3563),
    [anon_sym_select] = ACTIONS(3563),
    [aux_sym_preproc_if_token1] = ACTIONS(3565),
    [aux_sym_preproc_if_token3] = ACTIONS(3565),
    [aux_sym_preproc_else_token1] = ACTIONS(3565),
    [aux_sym_preproc_elif_token1] = ACTIONS(3565),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3433] = {
    [sym_preproc_region] = STATE(3433),
    [sym_preproc_endregion] = STATE(3433),
    [sym_preproc_line] = STATE(3433),
    [sym_preproc_pragma] = STATE(3433),
    [sym_preproc_nullable] = STATE(3433),
    [sym_preproc_error] = STATE(3433),
    [sym_preproc_define] = STATE(3433),
    [sym_preproc_undef] = STATE(3433),
    [sym__identifier_token] = ACTIONS(5045),
    [anon_sym_extern] = ACTIONS(5045),
    [anon_sym_alias] = ACTIONS(5045),
    [anon_sym_global] = ACTIONS(5045),
    [anon_sym_using] = ACTIONS(5045),
    [anon_sym_unsafe] = ACTIONS(5045),
    [anon_sym_static] = ACTIONS(5045),
    [anon_sym_LBRACK] = ACTIONS(5047),
    [anon_sym_LPAREN] = ACTIONS(5047),
    [anon_sym_event] = ACTIONS(5045),
    [anon_sym_namespace] = ACTIONS(5045),
    [anon_sym_class] = ACTIONS(5045),
    [anon_sym_ref] = ACTIONS(5045),
    [anon_sym_struct] = ACTIONS(5045),
    [anon_sym_enum] = ACTIONS(5045),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_interface] = ACTIONS(5045),
    [anon_sym_delegate] = ACTIONS(5045),
    [anon_sym_record] = ACTIONS(5045),
    [anon_sym_abstract] = ACTIONS(5045),
    [anon_sym_async] = ACTIONS(5045),
    [anon_sym_const] = ACTIONS(5045),
    [anon_sym_file] = ACTIONS(5045),
    [anon_sym_fixed] = ACTIONS(5045),
    [anon_sym_internal] = ACTIONS(5045),
    [anon_sym_new] = ACTIONS(5045),
    [anon_sym_override] = ACTIONS(5045),
    [anon_sym_partial] = ACTIONS(5045),
    [anon_sym_private] = ACTIONS(5045),
    [anon_sym_protected] = ACTIONS(5045),
    [anon_sym_public] = ACTIONS(5045),
    [anon_sym_readonly] = ACTIONS(5045),
    [anon_sym_required] = ACTIONS(5045),
    [anon_sym_sealed] = ACTIONS(5045),
    [anon_sym_virtual] = ACTIONS(5045),
    [anon_sym_volatile] = ACTIONS(5045),
    [anon_sym_where] = ACTIONS(5045),
    [anon_sym_notnull] = ACTIONS(5045),
    [anon_sym_unmanaged] = ACTIONS(5045),
    [anon_sym_TILDE] = ACTIONS(5047),
    [anon_sym_implicit] = ACTIONS(5045),
    [anon_sym_explicit] = ACTIONS(5045),
    [anon_sym_scoped] = ACTIONS(5045),
    [anon_sym_var] = ACTIONS(5045),
    [sym_predefined_type] = ACTIONS(5045),
    [anon_sym_yield] = ACTIONS(5045),
    [anon_sym_when] = ACTIONS(5045),
    [anon_sym_from] = ACTIONS(5045),
    [anon_sym_into] = ACTIONS(5045),
    [anon_sym_join] = ACTIONS(5045),
    [anon_sym_on] = ACTIONS(5045),
    [anon_sym_equals] = ACTIONS(5045),
    [anon_sym_let] = ACTIONS(5045),
    [anon_sym_orderby] = ACTIONS(5045),
    [anon_sym_ascending] = ACTIONS(5045),
    [anon_sym_descending] = ACTIONS(5045),
    [anon_sym_group] = ACTIONS(5045),
    [anon_sym_by] = ACTIONS(5045),
    [anon_sym_select] = ACTIONS(5045),
    [aux_sym_preproc_if_token1] = ACTIONS(5047),
    [aux_sym_preproc_if_token3] = ACTIONS(5047),
    [aux_sym_preproc_else_token1] = ACTIONS(5047),
    [aux_sym_preproc_elif_token1] = ACTIONS(5047),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3434] = {
    [sym_preproc_region] = STATE(3434),
    [sym_preproc_endregion] = STATE(3434),
    [sym_preproc_line] = STATE(3434),
    [sym_preproc_pragma] = STATE(3434),
    [sym_preproc_nullable] = STATE(3434),
    [sym_preproc_error] = STATE(3434),
    [sym_preproc_define] = STATE(3434),
    [sym_preproc_undef] = STATE(3434),
    [sym__identifier_token] = ACTIONS(5049),
    [anon_sym_extern] = ACTIONS(5049),
    [anon_sym_alias] = ACTIONS(5049),
    [anon_sym_global] = ACTIONS(5049),
    [anon_sym_using] = ACTIONS(5049),
    [anon_sym_unsafe] = ACTIONS(5049),
    [anon_sym_static] = ACTIONS(5049),
    [anon_sym_LBRACK] = ACTIONS(5051),
    [anon_sym_LPAREN] = ACTIONS(5051),
    [anon_sym_event] = ACTIONS(5049),
    [anon_sym_namespace] = ACTIONS(5049),
    [anon_sym_class] = ACTIONS(5049),
    [anon_sym_ref] = ACTIONS(5049),
    [anon_sym_struct] = ACTIONS(5049),
    [anon_sym_enum] = ACTIONS(5049),
    [anon_sym_RBRACE] = ACTIONS(5051),
    [anon_sym_interface] = ACTIONS(5049),
    [anon_sym_delegate] = ACTIONS(5049),
    [anon_sym_record] = ACTIONS(5049),
    [anon_sym_abstract] = ACTIONS(5049),
    [anon_sym_async] = ACTIONS(5049),
    [anon_sym_const] = ACTIONS(5049),
    [anon_sym_file] = ACTIONS(5049),
    [anon_sym_fixed] = ACTIONS(5049),
    [anon_sym_internal] = ACTIONS(5049),
    [anon_sym_new] = ACTIONS(5049),
    [anon_sym_override] = ACTIONS(5049),
    [anon_sym_partial] = ACTIONS(5049),
    [anon_sym_private] = ACTIONS(5049),
    [anon_sym_protected] = ACTIONS(5049),
    [anon_sym_public] = ACTIONS(5049),
    [anon_sym_readonly] = ACTIONS(5049),
    [anon_sym_required] = ACTIONS(5049),
    [anon_sym_sealed] = ACTIONS(5049),
    [anon_sym_virtual] = ACTIONS(5049),
    [anon_sym_volatile] = ACTIONS(5049),
    [anon_sym_where] = ACTIONS(5049),
    [anon_sym_notnull] = ACTIONS(5049),
    [anon_sym_unmanaged] = ACTIONS(5049),
    [anon_sym_TILDE] = ACTIONS(5051),
    [anon_sym_implicit] = ACTIONS(5049),
    [anon_sym_explicit] = ACTIONS(5049),
    [anon_sym_scoped] = ACTIONS(5049),
    [anon_sym_var] = ACTIONS(5049),
    [sym_predefined_type] = ACTIONS(5049),
    [anon_sym_yield] = ACTIONS(5049),
    [anon_sym_when] = ACTIONS(5049),
    [anon_sym_from] = ACTIONS(5049),
    [anon_sym_into] = ACTIONS(5049),
    [anon_sym_join] = ACTIONS(5049),
    [anon_sym_on] = ACTIONS(5049),
    [anon_sym_equals] = ACTIONS(5049),
    [anon_sym_let] = ACTIONS(5049),
    [anon_sym_orderby] = ACTIONS(5049),
    [anon_sym_ascending] = ACTIONS(5049),
    [anon_sym_descending] = ACTIONS(5049),
    [anon_sym_group] = ACTIONS(5049),
    [anon_sym_by] = ACTIONS(5049),
    [anon_sym_select] = ACTIONS(5049),
    [aux_sym_preproc_if_token1] = ACTIONS(5051),
    [aux_sym_preproc_if_token3] = ACTIONS(5051),
    [aux_sym_preproc_else_token1] = ACTIONS(5051),
    [aux_sym_preproc_elif_token1] = ACTIONS(5051),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3435] = {
    [sym_preproc_region] = STATE(3435),
    [sym_preproc_endregion] = STATE(3435),
    [sym_preproc_line] = STATE(3435),
    [sym_preproc_pragma] = STATE(3435),
    [sym_preproc_nullable] = STATE(3435),
    [sym_preproc_error] = STATE(3435),
    [sym_preproc_define] = STATE(3435),
    [sym_preproc_undef] = STATE(3435),
    [sym__identifier_token] = ACTIONS(3591),
    [anon_sym_extern] = ACTIONS(3591),
    [anon_sym_alias] = ACTIONS(3591),
    [anon_sym_global] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3591),
    [anon_sym_unsafe] = ACTIONS(3591),
    [anon_sym_static] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [anon_sym_LPAREN] = ACTIONS(3593),
    [anon_sym_event] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_ref] = ACTIONS(3591),
    [anon_sym_struct] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_delegate] = ACTIONS(3591),
    [anon_sym_record] = ACTIONS(3591),
    [anon_sym_abstract] = ACTIONS(3591),
    [anon_sym_async] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [anon_sym_file] = ACTIONS(3591),
    [anon_sym_fixed] = ACTIONS(3591),
    [anon_sym_internal] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [anon_sym_override] = ACTIONS(3591),
    [anon_sym_partial] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_readonly] = ACTIONS(3591),
    [anon_sym_required] = ACTIONS(3591),
    [anon_sym_sealed] = ACTIONS(3591),
    [anon_sym_virtual] = ACTIONS(3591),
    [anon_sym_volatile] = ACTIONS(3591),
    [anon_sym_where] = ACTIONS(3591),
    [anon_sym_notnull] = ACTIONS(3591),
    [anon_sym_unmanaged] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3593),
    [anon_sym_implicit] = ACTIONS(3591),
    [anon_sym_explicit] = ACTIONS(3591),
    [anon_sym_scoped] = ACTIONS(3591),
    [anon_sym_var] = ACTIONS(3591),
    [sym_predefined_type] = ACTIONS(3591),
    [anon_sym_yield] = ACTIONS(3591),
    [anon_sym_when] = ACTIONS(3591),
    [anon_sym_from] = ACTIONS(3591),
    [anon_sym_into] = ACTIONS(3591),
    [anon_sym_join] = ACTIONS(3591),
    [anon_sym_on] = ACTIONS(3591),
    [anon_sym_equals] = ACTIONS(3591),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_orderby] = ACTIONS(3591),
    [anon_sym_ascending] = ACTIONS(3591),
    [anon_sym_descending] = ACTIONS(3591),
    [anon_sym_group] = ACTIONS(3591),
    [anon_sym_by] = ACTIONS(3591),
    [anon_sym_select] = ACTIONS(3591),
    [aux_sym_preproc_if_token1] = ACTIONS(3593),
    [aux_sym_preproc_if_token3] = ACTIONS(3593),
    [aux_sym_preproc_else_token1] = ACTIONS(3593),
    [aux_sym_preproc_elif_token1] = ACTIONS(3593),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3436] = {
    [sym_preproc_region] = STATE(3436),
    [sym_preproc_endregion] = STATE(3436),
    [sym_preproc_line] = STATE(3436),
    [sym_preproc_pragma] = STATE(3436),
    [sym_preproc_nullable] = STATE(3436),
    [sym_preproc_error] = STATE(3436),
    [sym_preproc_define] = STATE(3436),
    [sym_preproc_undef] = STATE(3436),
    [sym__identifier_token] = ACTIONS(3635),
    [anon_sym_extern] = ACTIONS(3635),
    [anon_sym_alias] = ACTIONS(3635),
    [anon_sym_global] = ACTIONS(3635),
    [anon_sym_using] = ACTIONS(3635),
    [anon_sym_unsafe] = ACTIONS(3635),
    [anon_sym_static] = ACTIONS(3635),
    [anon_sym_LBRACK] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [anon_sym_event] = ACTIONS(3635),
    [anon_sym_namespace] = ACTIONS(3635),
    [anon_sym_class] = ACTIONS(3635),
    [anon_sym_ref] = ACTIONS(3635),
    [anon_sym_struct] = ACTIONS(3635),
    [anon_sym_enum] = ACTIONS(3635),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_interface] = ACTIONS(3635),
    [anon_sym_delegate] = ACTIONS(3635),
    [anon_sym_record] = ACTIONS(3635),
    [anon_sym_abstract] = ACTIONS(3635),
    [anon_sym_async] = ACTIONS(3635),
    [anon_sym_const] = ACTIONS(3635),
    [anon_sym_file] = ACTIONS(3635),
    [anon_sym_fixed] = ACTIONS(3635),
    [anon_sym_internal] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3635),
    [anon_sym_override] = ACTIONS(3635),
    [anon_sym_partial] = ACTIONS(3635),
    [anon_sym_private] = ACTIONS(3635),
    [anon_sym_protected] = ACTIONS(3635),
    [anon_sym_public] = ACTIONS(3635),
    [anon_sym_readonly] = ACTIONS(3635),
    [anon_sym_required] = ACTIONS(3635),
    [anon_sym_sealed] = ACTIONS(3635),
    [anon_sym_virtual] = ACTIONS(3635),
    [anon_sym_volatile] = ACTIONS(3635),
    [anon_sym_where] = ACTIONS(3635),
    [anon_sym_notnull] = ACTIONS(3635),
    [anon_sym_unmanaged] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3637),
    [anon_sym_implicit] = ACTIONS(3635),
    [anon_sym_explicit] = ACTIONS(3635),
    [anon_sym_scoped] = ACTIONS(3635),
    [anon_sym_var] = ACTIONS(3635),
    [sym_predefined_type] = ACTIONS(3635),
    [anon_sym_yield] = ACTIONS(3635),
    [anon_sym_when] = ACTIONS(3635),
    [anon_sym_from] = ACTIONS(3635),
    [anon_sym_into] = ACTIONS(3635),
    [anon_sym_join] = ACTIONS(3635),
    [anon_sym_on] = ACTIONS(3635),
    [anon_sym_equals] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3635),
    [anon_sym_orderby] = ACTIONS(3635),
    [anon_sym_ascending] = ACTIONS(3635),
    [anon_sym_descending] = ACTIONS(3635),
    [anon_sym_group] = ACTIONS(3635),
    [anon_sym_by] = ACTIONS(3635),
    [anon_sym_select] = ACTIONS(3635),
    [aux_sym_preproc_if_token1] = ACTIONS(3637),
    [aux_sym_preproc_if_token3] = ACTIONS(3637),
    [aux_sym_preproc_else_token1] = ACTIONS(3637),
    [aux_sym_preproc_elif_token1] = ACTIONS(3637),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3437] = {
    [sym_preproc_region] = STATE(3437),
    [sym_preproc_endregion] = STATE(3437),
    [sym_preproc_line] = STATE(3437),
    [sym_preproc_pragma] = STATE(3437),
    [sym_preproc_nullable] = STATE(3437),
    [sym_preproc_error] = STATE(3437),
    [sym_preproc_define] = STATE(3437),
    [sym_preproc_undef] = STATE(3437),
    [sym__identifier_token] = ACTIONS(5053),
    [anon_sym_extern] = ACTIONS(5053),
    [anon_sym_alias] = ACTIONS(5053),
    [anon_sym_global] = ACTIONS(5053),
    [anon_sym_using] = ACTIONS(5053),
    [anon_sym_unsafe] = ACTIONS(5053),
    [anon_sym_static] = ACTIONS(5053),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_LPAREN] = ACTIONS(5055),
    [anon_sym_event] = ACTIONS(5053),
    [anon_sym_namespace] = ACTIONS(5053),
    [anon_sym_class] = ACTIONS(5053),
    [anon_sym_ref] = ACTIONS(5053),
    [anon_sym_struct] = ACTIONS(5053),
    [anon_sym_enum] = ACTIONS(5053),
    [anon_sym_RBRACE] = ACTIONS(5055),
    [anon_sym_interface] = ACTIONS(5053),
    [anon_sym_delegate] = ACTIONS(5053),
    [anon_sym_record] = ACTIONS(5053),
    [anon_sym_abstract] = ACTIONS(5053),
    [anon_sym_async] = ACTIONS(5053),
    [anon_sym_const] = ACTIONS(5053),
    [anon_sym_file] = ACTIONS(5053),
    [anon_sym_fixed] = ACTIONS(5053),
    [anon_sym_internal] = ACTIONS(5053),
    [anon_sym_new] = ACTIONS(5053),
    [anon_sym_override] = ACTIONS(5053),
    [anon_sym_partial] = ACTIONS(5053),
    [anon_sym_private] = ACTIONS(5053),
    [anon_sym_protected] = ACTIONS(5053),
    [anon_sym_public] = ACTIONS(5053),
    [anon_sym_readonly] = ACTIONS(5053),
    [anon_sym_required] = ACTIONS(5053),
    [anon_sym_sealed] = ACTIONS(5053),
    [anon_sym_virtual] = ACTIONS(5053),
    [anon_sym_volatile] = ACTIONS(5053),
    [anon_sym_where] = ACTIONS(5053),
    [anon_sym_notnull] = ACTIONS(5053),
    [anon_sym_unmanaged] = ACTIONS(5053),
    [anon_sym_TILDE] = ACTIONS(5055),
    [anon_sym_implicit] = ACTIONS(5053),
    [anon_sym_explicit] = ACTIONS(5053),
    [anon_sym_scoped] = ACTIONS(5053),
    [anon_sym_var] = ACTIONS(5053),
    [sym_predefined_type] = ACTIONS(5053),
    [anon_sym_yield] = ACTIONS(5053),
    [anon_sym_when] = ACTIONS(5053),
    [anon_sym_from] = ACTIONS(5053),
    [anon_sym_into] = ACTIONS(5053),
    [anon_sym_join] = ACTIONS(5053),
    [anon_sym_on] = ACTIONS(5053),
    [anon_sym_equals] = ACTIONS(5053),
    [anon_sym_let] = ACTIONS(5053),
    [anon_sym_orderby] = ACTIONS(5053),
    [anon_sym_ascending] = ACTIONS(5053),
    [anon_sym_descending] = ACTIONS(5053),
    [anon_sym_group] = ACTIONS(5053),
    [anon_sym_by] = ACTIONS(5053),
    [anon_sym_select] = ACTIONS(5053),
    [aux_sym_preproc_if_token1] = ACTIONS(5055),
    [aux_sym_preproc_if_token3] = ACTIONS(5055),
    [aux_sym_preproc_else_token1] = ACTIONS(5055),
    [aux_sym_preproc_elif_token1] = ACTIONS(5055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3438] = {
    [sym_preproc_region] = STATE(3438),
    [sym_preproc_endregion] = STATE(3438),
    [sym_preproc_line] = STATE(3438),
    [sym_preproc_pragma] = STATE(3438),
    [sym_preproc_nullable] = STATE(3438),
    [sym_preproc_error] = STATE(3438),
    [sym_preproc_define] = STATE(3438),
    [sym_preproc_undef] = STATE(3438),
    [sym__identifier_token] = ACTIONS(5057),
    [anon_sym_extern] = ACTIONS(5057),
    [anon_sym_alias] = ACTIONS(5057),
    [anon_sym_global] = ACTIONS(5057),
    [anon_sym_using] = ACTIONS(5057),
    [anon_sym_unsafe] = ACTIONS(5057),
    [anon_sym_static] = ACTIONS(5057),
    [anon_sym_LBRACK] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(5059),
    [anon_sym_event] = ACTIONS(5057),
    [anon_sym_namespace] = ACTIONS(5057),
    [anon_sym_class] = ACTIONS(5057),
    [anon_sym_ref] = ACTIONS(5057),
    [anon_sym_struct] = ACTIONS(5057),
    [anon_sym_enum] = ACTIONS(5057),
    [anon_sym_RBRACE] = ACTIONS(5059),
    [anon_sym_interface] = ACTIONS(5057),
    [anon_sym_delegate] = ACTIONS(5057),
    [anon_sym_record] = ACTIONS(5057),
    [anon_sym_abstract] = ACTIONS(5057),
    [anon_sym_async] = ACTIONS(5057),
    [anon_sym_const] = ACTIONS(5057),
    [anon_sym_file] = ACTIONS(5057),
    [anon_sym_fixed] = ACTIONS(5057),
    [anon_sym_internal] = ACTIONS(5057),
    [anon_sym_new] = ACTIONS(5057),
    [anon_sym_override] = ACTIONS(5057),
    [anon_sym_partial] = ACTIONS(5057),
    [anon_sym_private] = ACTIONS(5057),
    [anon_sym_protected] = ACTIONS(5057),
    [anon_sym_public] = ACTIONS(5057),
    [anon_sym_readonly] = ACTIONS(5057),
    [anon_sym_required] = ACTIONS(5057),
    [anon_sym_sealed] = ACTIONS(5057),
    [anon_sym_virtual] = ACTIONS(5057),
    [anon_sym_volatile] = ACTIONS(5057),
    [anon_sym_where] = ACTIONS(5057),
    [anon_sym_notnull] = ACTIONS(5057),
    [anon_sym_unmanaged] = ACTIONS(5057),
    [anon_sym_TILDE] = ACTIONS(5059),
    [anon_sym_implicit] = ACTIONS(5057),
    [anon_sym_explicit] = ACTIONS(5057),
    [anon_sym_scoped] = ACTIONS(5057),
    [anon_sym_var] = ACTIONS(5057),
    [sym_predefined_type] = ACTIONS(5057),
    [anon_sym_yield] = ACTIONS(5057),
    [anon_sym_when] = ACTIONS(5057),
    [anon_sym_from] = ACTIONS(5057),
    [anon_sym_into] = ACTIONS(5057),
    [anon_sym_join] = ACTIONS(5057),
    [anon_sym_on] = ACTIONS(5057),
    [anon_sym_equals] = ACTIONS(5057),
    [anon_sym_let] = ACTIONS(5057),
    [anon_sym_orderby] = ACTIONS(5057),
    [anon_sym_ascending] = ACTIONS(5057),
    [anon_sym_descending] = ACTIONS(5057),
    [anon_sym_group] = ACTIONS(5057),
    [anon_sym_by] = ACTIONS(5057),
    [anon_sym_select] = ACTIONS(5057),
    [aux_sym_preproc_if_token1] = ACTIONS(5059),
    [aux_sym_preproc_if_token3] = ACTIONS(5059),
    [aux_sym_preproc_else_token1] = ACTIONS(5059),
    [aux_sym_preproc_elif_token1] = ACTIONS(5059),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3439] = {
    [sym_preproc_region] = STATE(3439),
    [sym_preproc_endregion] = STATE(3439),
    [sym_preproc_line] = STATE(3439),
    [sym_preproc_pragma] = STATE(3439),
    [sym_preproc_nullable] = STATE(3439),
    [sym_preproc_error] = STATE(3439),
    [sym_preproc_define] = STATE(3439),
    [sym_preproc_undef] = STATE(3439),
    [sym__identifier_token] = ACTIONS(3639),
    [anon_sym_extern] = ACTIONS(3639),
    [anon_sym_alias] = ACTIONS(3639),
    [anon_sym_global] = ACTIONS(3639),
    [anon_sym_using] = ACTIONS(3639),
    [anon_sym_unsafe] = ACTIONS(3639),
    [anon_sym_static] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_event] = ACTIONS(3639),
    [anon_sym_namespace] = ACTIONS(3639),
    [anon_sym_class] = ACTIONS(3639),
    [anon_sym_ref] = ACTIONS(3639),
    [anon_sym_struct] = ACTIONS(3639),
    [anon_sym_enum] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_interface] = ACTIONS(3639),
    [anon_sym_delegate] = ACTIONS(3639),
    [anon_sym_record] = ACTIONS(3639),
    [anon_sym_abstract] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_const] = ACTIONS(3639),
    [anon_sym_file] = ACTIONS(3639),
    [anon_sym_fixed] = ACTIONS(3639),
    [anon_sym_internal] = ACTIONS(3639),
    [anon_sym_new] = ACTIONS(3639),
    [anon_sym_override] = ACTIONS(3639),
    [anon_sym_partial] = ACTIONS(3639),
    [anon_sym_private] = ACTIONS(3639),
    [anon_sym_protected] = ACTIONS(3639),
    [anon_sym_public] = ACTIONS(3639),
    [anon_sym_readonly] = ACTIONS(3639),
    [anon_sym_required] = ACTIONS(3639),
    [anon_sym_sealed] = ACTIONS(3639),
    [anon_sym_virtual] = ACTIONS(3639),
    [anon_sym_volatile] = ACTIONS(3639),
    [anon_sym_where] = ACTIONS(3639),
    [anon_sym_notnull] = ACTIONS(3639),
    [anon_sym_unmanaged] = ACTIONS(3639),
    [anon_sym_TILDE] = ACTIONS(3641),
    [anon_sym_implicit] = ACTIONS(3639),
    [anon_sym_explicit] = ACTIONS(3639),
    [anon_sym_scoped] = ACTIONS(3639),
    [anon_sym_var] = ACTIONS(3639),
    [sym_predefined_type] = ACTIONS(3639),
    [anon_sym_yield] = ACTIONS(3639),
    [anon_sym_when] = ACTIONS(3639),
    [anon_sym_from] = ACTIONS(3639),
    [anon_sym_into] = ACTIONS(3639),
    [anon_sym_join] = ACTIONS(3639),
    [anon_sym_on] = ACTIONS(3639),
    [anon_sym_equals] = ACTIONS(3639),
    [anon_sym_let] = ACTIONS(3639),
    [anon_sym_orderby] = ACTIONS(3639),
    [anon_sym_ascending] = ACTIONS(3639),
    [anon_sym_descending] = ACTIONS(3639),
    [anon_sym_group] = ACTIONS(3639),
    [anon_sym_by] = ACTIONS(3639),
    [anon_sym_select] = ACTIONS(3639),
    [aux_sym_preproc_if_token1] = ACTIONS(3641),
    [aux_sym_preproc_if_token3] = ACTIONS(3641),
    [aux_sym_preproc_else_token1] = ACTIONS(3641),
    [aux_sym_preproc_elif_token1] = ACTIONS(3641),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3440] = {
    [sym_preproc_region] = STATE(3440),
    [sym_preproc_endregion] = STATE(3440),
    [sym_preproc_line] = STATE(3440),
    [sym_preproc_pragma] = STATE(3440),
    [sym_preproc_nullable] = STATE(3440),
    [sym_preproc_error] = STATE(3440),
    [sym_preproc_define] = STATE(3440),
    [sym_preproc_undef] = STATE(3440),
    [sym__identifier_token] = ACTIONS(3643),
    [anon_sym_extern] = ACTIONS(3643),
    [anon_sym_alias] = ACTIONS(3643),
    [anon_sym_global] = ACTIONS(3643),
    [anon_sym_using] = ACTIONS(3643),
    [anon_sym_unsafe] = ACTIONS(3643),
    [anon_sym_static] = ACTIONS(3643),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_event] = ACTIONS(3643),
    [anon_sym_namespace] = ACTIONS(3643),
    [anon_sym_class] = ACTIONS(3643),
    [anon_sym_ref] = ACTIONS(3643),
    [anon_sym_struct] = ACTIONS(3643),
    [anon_sym_enum] = ACTIONS(3643),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_interface] = ACTIONS(3643),
    [anon_sym_delegate] = ACTIONS(3643),
    [anon_sym_record] = ACTIONS(3643),
    [anon_sym_abstract] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_const] = ACTIONS(3643),
    [anon_sym_file] = ACTIONS(3643),
    [anon_sym_fixed] = ACTIONS(3643),
    [anon_sym_internal] = ACTIONS(3643),
    [anon_sym_new] = ACTIONS(3643),
    [anon_sym_override] = ACTIONS(3643),
    [anon_sym_partial] = ACTIONS(3643),
    [anon_sym_private] = ACTIONS(3643),
    [anon_sym_protected] = ACTIONS(3643),
    [anon_sym_public] = ACTIONS(3643),
    [anon_sym_readonly] = ACTIONS(3643),
    [anon_sym_required] = ACTIONS(3643),
    [anon_sym_sealed] = ACTIONS(3643),
    [anon_sym_virtual] = ACTIONS(3643),
    [anon_sym_volatile] = ACTIONS(3643),
    [anon_sym_where] = ACTIONS(3643),
    [anon_sym_notnull] = ACTIONS(3643),
    [anon_sym_unmanaged] = ACTIONS(3643),
    [anon_sym_TILDE] = ACTIONS(3645),
    [anon_sym_implicit] = ACTIONS(3643),
    [anon_sym_explicit] = ACTIONS(3643),
    [anon_sym_scoped] = ACTIONS(3643),
    [anon_sym_var] = ACTIONS(3643),
    [sym_predefined_type] = ACTIONS(3643),
    [anon_sym_yield] = ACTIONS(3643),
    [anon_sym_when] = ACTIONS(3643),
    [anon_sym_from] = ACTIONS(3643),
    [anon_sym_into] = ACTIONS(3643),
    [anon_sym_join] = ACTIONS(3643),
    [anon_sym_on] = ACTIONS(3643),
    [anon_sym_equals] = ACTIONS(3643),
    [anon_sym_let] = ACTIONS(3643),
    [anon_sym_orderby] = ACTIONS(3643),
    [anon_sym_ascending] = ACTIONS(3643),
    [anon_sym_descending] = ACTIONS(3643),
    [anon_sym_group] = ACTIONS(3643),
    [anon_sym_by] = ACTIONS(3643),
    [anon_sym_select] = ACTIONS(3643),
    [aux_sym_preproc_if_token1] = ACTIONS(3645),
    [aux_sym_preproc_if_token3] = ACTIONS(3645),
    [aux_sym_preproc_else_token1] = ACTIONS(3645),
    [aux_sym_preproc_elif_token1] = ACTIONS(3645),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3441] = {
    [sym_preproc_region] = STATE(3441),
    [sym_preproc_endregion] = STATE(3441),
    [sym_preproc_line] = STATE(3441),
    [sym_preproc_pragma] = STATE(3441),
    [sym_preproc_nullable] = STATE(3441),
    [sym_preproc_error] = STATE(3441),
    [sym_preproc_define] = STATE(3441),
    [sym_preproc_undef] = STATE(3441),
    [sym__identifier_token] = ACTIONS(3663),
    [anon_sym_extern] = ACTIONS(3663),
    [anon_sym_alias] = ACTIONS(3663),
    [anon_sym_global] = ACTIONS(3663),
    [anon_sym_using] = ACTIONS(3663),
    [anon_sym_unsafe] = ACTIONS(3663),
    [anon_sym_static] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3665),
    [anon_sym_LPAREN] = ACTIONS(3665),
    [anon_sym_event] = ACTIONS(3663),
    [anon_sym_namespace] = ACTIONS(3663),
    [anon_sym_class] = ACTIONS(3663),
    [anon_sym_ref] = ACTIONS(3663),
    [anon_sym_struct] = ACTIONS(3663),
    [anon_sym_enum] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3665),
    [anon_sym_interface] = ACTIONS(3663),
    [anon_sym_delegate] = ACTIONS(3663),
    [anon_sym_record] = ACTIONS(3663),
    [anon_sym_abstract] = ACTIONS(3663),
    [anon_sym_async] = ACTIONS(3663),
    [anon_sym_const] = ACTIONS(3663),
    [anon_sym_file] = ACTIONS(3663),
    [anon_sym_fixed] = ACTIONS(3663),
    [anon_sym_internal] = ACTIONS(3663),
    [anon_sym_new] = ACTIONS(3663),
    [anon_sym_override] = ACTIONS(3663),
    [anon_sym_partial] = ACTIONS(3663),
    [anon_sym_private] = ACTIONS(3663),
    [anon_sym_protected] = ACTIONS(3663),
    [anon_sym_public] = ACTIONS(3663),
    [anon_sym_readonly] = ACTIONS(3663),
    [anon_sym_required] = ACTIONS(3663),
    [anon_sym_sealed] = ACTIONS(3663),
    [anon_sym_virtual] = ACTIONS(3663),
    [anon_sym_volatile] = ACTIONS(3663),
    [anon_sym_where] = ACTIONS(3663),
    [anon_sym_notnull] = ACTIONS(3663),
    [anon_sym_unmanaged] = ACTIONS(3663),
    [anon_sym_TILDE] = ACTIONS(3665),
    [anon_sym_implicit] = ACTIONS(3663),
    [anon_sym_explicit] = ACTIONS(3663),
    [anon_sym_scoped] = ACTIONS(3663),
    [anon_sym_var] = ACTIONS(3663),
    [sym_predefined_type] = ACTIONS(3663),
    [anon_sym_yield] = ACTIONS(3663),
    [anon_sym_when] = ACTIONS(3663),
    [anon_sym_from] = ACTIONS(3663),
    [anon_sym_into] = ACTIONS(3663),
    [anon_sym_join] = ACTIONS(3663),
    [anon_sym_on] = ACTIONS(3663),
    [anon_sym_equals] = ACTIONS(3663),
    [anon_sym_let] = ACTIONS(3663),
    [anon_sym_orderby] = ACTIONS(3663),
    [anon_sym_ascending] = ACTIONS(3663),
    [anon_sym_descending] = ACTIONS(3663),
    [anon_sym_group] = ACTIONS(3663),
    [anon_sym_by] = ACTIONS(3663),
    [anon_sym_select] = ACTIONS(3663),
    [aux_sym_preproc_if_token1] = ACTIONS(3665),
    [aux_sym_preproc_if_token3] = ACTIONS(3665),
    [aux_sym_preproc_else_token1] = ACTIONS(3665),
    [aux_sym_preproc_elif_token1] = ACTIONS(3665),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3442] = {
    [sym_preproc_region] = STATE(3442),
    [sym_preproc_endregion] = STATE(3442),
    [sym_preproc_line] = STATE(3442),
    [sym_preproc_pragma] = STATE(3442),
    [sym_preproc_nullable] = STATE(3442),
    [sym_preproc_error] = STATE(3442),
    [sym_preproc_define] = STATE(3442),
    [sym_preproc_undef] = STATE(3442),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(4167),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_when] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4167),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_on] = ACTIONS(4167),
    [anon_sym_equals] = ACTIONS(4167),
    [anon_sym_by] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_if_token3] = ACTIONS(4167),
    [aux_sym_preproc_else_token1] = ACTIONS(4167),
    [aux_sym_preproc_elif_token1] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3443] = {
    [sym_preproc_region] = STATE(3443),
    [sym_preproc_endregion] = STATE(3443),
    [sym_preproc_line] = STATE(3443),
    [sym_preproc_pragma] = STATE(3443),
    [sym_preproc_nullable] = STATE(3443),
    [sym_preproc_error] = STATE(3443),
    [sym_preproc_define] = STATE(3443),
    [sym_preproc_undef] = STATE(3443),
    [sym__identifier_token] = ACTIONS(3667),
    [anon_sym_extern] = ACTIONS(3667),
    [anon_sym_alias] = ACTIONS(3667),
    [anon_sym_global] = ACTIONS(3667),
    [anon_sym_using] = ACTIONS(3667),
    [anon_sym_unsafe] = ACTIONS(3667),
    [anon_sym_static] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3669),
    [anon_sym_LPAREN] = ACTIONS(3669),
    [anon_sym_event] = ACTIONS(3667),
    [anon_sym_namespace] = ACTIONS(3667),
    [anon_sym_class] = ACTIONS(3667),
    [anon_sym_ref] = ACTIONS(3667),
    [anon_sym_struct] = ACTIONS(3667),
    [anon_sym_enum] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3669),
    [anon_sym_interface] = ACTIONS(3667),
    [anon_sym_delegate] = ACTIONS(3667),
    [anon_sym_record] = ACTIONS(3667),
    [anon_sym_abstract] = ACTIONS(3667),
    [anon_sym_async] = ACTIONS(3667),
    [anon_sym_const] = ACTIONS(3667),
    [anon_sym_file] = ACTIONS(3667),
    [anon_sym_fixed] = ACTIONS(3667),
    [anon_sym_internal] = ACTIONS(3667),
    [anon_sym_new] = ACTIONS(3667),
    [anon_sym_override] = ACTIONS(3667),
    [anon_sym_partial] = ACTIONS(3667),
    [anon_sym_private] = ACTIONS(3667),
    [anon_sym_protected] = ACTIONS(3667),
    [anon_sym_public] = ACTIONS(3667),
    [anon_sym_readonly] = ACTIONS(3667),
    [anon_sym_required] = ACTIONS(3667),
    [anon_sym_sealed] = ACTIONS(3667),
    [anon_sym_virtual] = ACTIONS(3667),
    [anon_sym_volatile] = ACTIONS(3667),
    [anon_sym_where] = ACTIONS(3667),
    [anon_sym_notnull] = ACTIONS(3667),
    [anon_sym_unmanaged] = ACTIONS(3667),
    [anon_sym_TILDE] = ACTIONS(3669),
    [anon_sym_implicit] = ACTIONS(3667),
    [anon_sym_explicit] = ACTIONS(3667),
    [anon_sym_scoped] = ACTIONS(3667),
    [anon_sym_var] = ACTIONS(3667),
    [sym_predefined_type] = ACTIONS(3667),
    [anon_sym_yield] = ACTIONS(3667),
    [anon_sym_when] = ACTIONS(3667),
    [anon_sym_from] = ACTIONS(3667),
    [anon_sym_into] = ACTIONS(3667),
    [anon_sym_join] = ACTIONS(3667),
    [anon_sym_on] = ACTIONS(3667),
    [anon_sym_equals] = ACTIONS(3667),
    [anon_sym_let] = ACTIONS(3667),
    [anon_sym_orderby] = ACTIONS(3667),
    [anon_sym_ascending] = ACTIONS(3667),
    [anon_sym_descending] = ACTIONS(3667),
    [anon_sym_group] = ACTIONS(3667),
    [anon_sym_by] = ACTIONS(3667),
    [anon_sym_select] = ACTIONS(3667),
    [aux_sym_preproc_if_token1] = ACTIONS(3669),
    [aux_sym_preproc_if_token3] = ACTIONS(3669),
    [aux_sym_preproc_else_token1] = ACTIONS(3669),
    [aux_sym_preproc_elif_token1] = ACTIONS(3669),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3444] = {
    [sym_preproc_region] = STATE(3444),
    [sym_preproc_endregion] = STATE(3444),
    [sym_preproc_line] = STATE(3444),
    [sym_preproc_pragma] = STATE(3444),
    [sym_preproc_nullable] = STATE(3444),
    [sym_preproc_error] = STATE(3444),
    [sym_preproc_define] = STATE(3444),
    [sym_preproc_undef] = STATE(3444),
    [sym__identifier_token] = ACTIONS(5061),
    [anon_sym_extern] = ACTIONS(5061),
    [anon_sym_alias] = ACTIONS(5061),
    [anon_sym_global] = ACTIONS(5061),
    [anon_sym_using] = ACTIONS(5061),
    [anon_sym_unsafe] = ACTIONS(5061),
    [anon_sym_static] = ACTIONS(5061),
    [anon_sym_LBRACK] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5063),
    [anon_sym_event] = ACTIONS(5061),
    [anon_sym_namespace] = ACTIONS(5061),
    [anon_sym_class] = ACTIONS(5061),
    [anon_sym_ref] = ACTIONS(5061),
    [anon_sym_struct] = ACTIONS(5061),
    [anon_sym_enum] = ACTIONS(5061),
    [anon_sym_RBRACE] = ACTIONS(5063),
    [anon_sym_interface] = ACTIONS(5061),
    [anon_sym_delegate] = ACTIONS(5061),
    [anon_sym_record] = ACTIONS(5061),
    [anon_sym_abstract] = ACTIONS(5061),
    [anon_sym_async] = ACTIONS(5061),
    [anon_sym_const] = ACTIONS(5061),
    [anon_sym_file] = ACTIONS(5061),
    [anon_sym_fixed] = ACTIONS(5061),
    [anon_sym_internal] = ACTIONS(5061),
    [anon_sym_new] = ACTIONS(5061),
    [anon_sym_override] = ACTIONS(5061),
    [anon_sym_partial] = ACTIONS(5061),
    [anon_sym_private] = ACTIONS(5061),
    [anon_sym_protected] = ACTIONS(5061),
    [anon_sym_public] = ACTIONS(5061),
    [anon_sym_readonly] = ACTIONS(5061),
    [anon_sym_required] = ACTIONS(5061),
    [anon_sym_sealed] = ACTIONS(5061),
    [anon_sym_virtual] = ACTIONS(5061),
    [anon_sym_volatile] = ACTIONS(5061),
    [anon_sym_where] = ACTIONS(5061),
    [anon_sym_notnull] = ACTIONS(5061),
    [anon_sym_unmanaged] = ACTIONS(5061),
    [anon_sym_TILDE] = ACTIONS(5063),
    [anon_sym_implicit] = ACTIONS(5061),
    [anon_sym_explicit] = ACTIONS(5061),
    [anon_sym_scoped] = ACTIONS(5061),
    [anon_sym_var] = ACTIONS(5061),
    [sym_predefined_type] = ACTIONS(5061),
    [anon_sym_yield] = ACTIONS(5061),
    [anon_sym_when] = ACTIONS(5061),
    [anon_sym_from] = ACTIONS(5061),
    [anon_sym_into] = ACTIONS(5061),
    [anon_sym_join] = ACTIONS(5061),
    [anon_sym_on] = ACTIONS(5061),
    [anon_sym_equals] = ACTIONS(5061),
    [anon_sym_let] = ACTIONS(5061),
    [anon_sym_orderby] = ACTIONS(5061),
    [anon_sym_ascending] = ACTIONS(5061),
    [anon_sym_descending] = ACTIONS(5061),
    [anon_sym_group] = ACTIONS(5061),
    [anon_sym_by] = ACTIONS(5061),
    [anon_sym_select] = ACTIONS(5061),
    [aux_sym_preproc_if_token1] = ACTIONS(5063),
    [aux_sym_preproc_if_token3] = ACTIONS(5063),
    [aux_sym_preproc_else_token1] = ACTIONS(5063),
    [aux_sym_preproc_elif_token1] = ACTIONS(5063),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3445] = {
    [sym_preproc_region] = STATE(3445),
    [sym_preproc_endregion] = STATE(3445),
    [sym_preproc_line] = STATE(3445),
    [sym_preproc_pragma] = STATE(3445),
    [sym_preproc_nullable] = STATE(3445),
    [sym_preproc_error] = STATE(3445),
    [sym_preproc_define] = STATE(3445),
    [sym_preproc_undef] = STATE(3445),
    [sym__identifier_token] = ACTIONS(3703),
    [anon_sym_extern] = ACTIONS(3703),
    [anon_sym_alias] = ACTIONS(3703),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_using] = ACTIONS(3703),
    [anon_sym_unsafe] = ACTIONS(3703),
    [anon_sym_static] = ACTIONS(3703),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_event] = ACTIONS(3703),
    [anon_sym_namespace] = ACTIONS(3703),
    [anon_sym_class] = ACTIONS(3703),
    [anon_sym_ref] = ACTIONS(3703),
    [anon_sym_struct] = ACTIONS(3703),
    [anon_sym_enum] = ACTIONS(3703),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_interface] = ACTIONS(3703),
    [anon_sym_delegate] = ACTIONS(3703),
    [anon_sym_record] = ACTIONS(3703),
    [anon_sym_abstract] = ACTIONS(3703),
    [anon_sym_async] = ACTIONS(3703),
    [anon_sym_const] = ACTIONS(3703),
    [anon_sym_file] = ACTIONS(3703),
    [anon_sym_fixed] = ACTIONS(3703),
    [anon_sym_internal] = ACTIONS(3703),
    [anon_sym_new] = ACTIONS(3703),
    [anon_sym_override] = ACTIONS(3703),
    [anon_sym_partial] = ACTIONS(3703),
    [anon_sym_private] = ACTIONS(3703),
    [anon_sym_protected] = ACTIONS(3703),
    [anon_sym_public] = ACTIONS(3703),
    [anon_sym_readonly] = ACTIONS(3703),
    [anon_sym_required] = ACTIONS(3703),
    [anon_sym_sealed] = ACTIONS(3703),
    [anon_sym_virtual] = ACTIONS(3703),
    [anon_sym_volatile] = ACTIONS(3703),
    [anon_sym_where] = ACTIONS(3703),
    [anon_sym_notnull] = ACTIONS(3703),
    [anon_sym_unmanaged] = ACTIONS(3703),
    [anon_sym_TILDE] = ACTIONS(3705),
    [anon_sym_implicit] = ACTIONS(3703),
    [anon_sym_explicit] = ACTIONS(3703),
    [anon_sym_scoped] = ACTIONS(3703),
    [anon_sym_var] = ACTIONS(3703),
    [sym_predefined_type] = ACTIONS(3703),
    [anon_sym_yield] = ACTIONS(3703),
    [anon_sym_when] = ACTIONS(3703),
    [anon_sym_from] = ACTIONS(3703),
    [anon_sym_into] = ACTIONS(3703),
    [anon_sym_join] = ACTIONS(3703),
    [anon_sym_on] = ACTIONS(3703),
    [anon_sym_equals] = ACTIONS(3703),
    [anon_sym_let] = ACTIONS(3703),
    [anon_sym_orderby] = ACTIONS(3703),
    [anon_sym_ascending] = ACTIONS(3703),
    [anon_sym_descending] = ACTIONS(3703),
    [anon_sym_group] = ACTIONS(3703),
    [anon_sym_by] = ACTIONS(3703),
    [anon_sym_select] = ACTIONS(3703),
    [aux_sym_preproc_if_token1] = ACTIONS(3705),
    [aux_sym_preproc_if_token3] = ACTIONS(3705),
    [aux_sym_preproc_else_token1] = ACTIONS(3705),
    [aux_sym_preproc_elif_token1] = ACTIONS(3705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3446] = {
    [sym_preproc_region] = STATE(3446),
    [sym_preproc_endregion] = STATE(3446),
    [sym_preproc_line] = STATE(3446),
    [sym_preproc_pragma] = STATE(3446),
    [sym_preproc_nullable] = STATE(3446),
    [sym_preproc_error] = STATE(3446),
    [sym_preproc_define] = STATE(3446),
    [sym_preproc_undef] = STATE(3446),
    [sym__identifier_token] = ACTIONS(3707),
    [anon_sym_extern] = ACTIONS(3707),
    [anon_sym_alias] = ACTIONS(3707),
    [anon_sym_global] = ACTIONS(3707),
    [anon_sym_using] = ACTIONS(3707),
    [anon_sym_unsafe] = ACTIONS(3707),
    [anon_sym_static] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_event] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_ref] = ACTIONS(3707),
    [anon_sym_struct] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_delegate] = ACTIONS(3707),
    [anon_sym_record] = ACTIONS(3707),
    [anon_sym_abstract] = ACTIONS(3707),
    [anon_sym_async] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [anon_sym_file] = ACTIONS(3707),
    [anon_sym_fixed] = ACTIONS(3707),
    [anon_sym_internal] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_override] = ACTIONS(3707),
    [anon_sym_partial] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_readonly] = ACTIONS(3707),
    [anon_sym_required] = ACTIONS(3707),
    [anon_sym_sealed] = ACTIONS(3707),
    [anon_sym_virtual] = ACTIONS(3707),
    [anon_sym_volatile] = ACTIONS(3707),
    [anon_sym_where] = ACTIONS(3707),
    [anon_sym_notnull] = ACTIONS(3707),
    [anon_sym_unmanaged] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3709),
    [anon_sym_implicit] = ACTIONS(3707),
    [anon_sym_explicit] = ACTIONS(3707),
    [anon_sym_scoped] = ACTIONS(3707),
    [anon_sym_var] = ACTIONS(3707),
    [sym_predefined_type] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3707),
    [anon_sym_when] = ACTIONS(3707),
    [anon_sym_from] = ACTIONS(3707),
    [anon_sym_into] = ACTIONS(3707),
    [anon_sym_join] = ACTIONS(3707),
    [anon_sym_on] = ACTIONS(3707),
    [anon_sym_equals] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_orderby] = ACTIONS(3707),
    [anon_sym_ascending] = ACTIONS(3707),
    [anon_sym_descending] = ACTIONS(3707),
    [anon_sym_group] = ACTIONS(3707),
    [anon_sym_by] = ACTIONS(3707),
    [anon_sym_select] = ACTIONS(3707),
    [aux_sym_preproc_if_token1] = ACTIONS(3709),
    [aux_sym_preproc_if_token3] = ACTIONS(3709),
    [aux_sym_preproc_else_token1] = ACTIONS(3709),
    [aux_sym_preproc_elif_token1] = ACTIONS(3709),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3447] = {
    [sym_preproc_region] = STATE(3447),
    [sym_preproc_endregion] = STATE(3447),
    [sym_preproc_line] = STATE(3447),
    [sym_preproc_pragma] = STATE(3447),
    [sym_preproc_nullable] = STATE(3447),
    [sym_preproc_error] = STATE(3447),
    [sym_preproc_define] = STATE(3447),
    [sym_preproc_undef] = STATE(3447),
    [sym__identifier_token] = ACTIONS(3715),
    [anon_sym_extern] = ACTIONS(3715),
    [anon_sym_alias] = ACTIONS(3715),
    [anon_sym_global] = ACTIONS(3715),
    [anon_sym_using] = ACTIONS(3715),
    [anon_sym_unsafe] = ACTIONS(3715),
    [anon_sym_static] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3717),
    [anon_sym_LPAREN] = ACTIONS(3717),
    [anon_sym_event] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(3715),
    [anon_sym_class] = ACTIONS(3715),
    [anon_sym_ref] = ACTIONS(3715),
    [anon_sym_struct] = ACTIONS(3715),
    [anon_sym_enum] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_interface] = ACTIONS(3715),
    [anon_sym_delegate] = ACTIONS(3715),
    [anon_sym_record] = ACTIONS(3715),
    [anon_sym_abstract] = ACTIONS(3715),
    [anon_sym_async] = ACTIONS(3715),
    [anon_sym_const] = ACTIONS(3715),
    [anon_sym_file] = ACTIONS(3715),
    [anon_sym_fixed] = ACTIONS(3715),
    [anon_sym_internal] = ACTIONS(3715),
    [anon_sym_new] = ACTIONS(3715),
    [anon_sym_override] = ACTIONS(3715),
    [anon_sym_partial] = ACTIONS(3715),
    [anon_sym_private] = ACTIONS(3715),
    [anon_sym_protected] = ACTIONS(3715),
    [anon_sym_public] = ACTIONS(3715),
    [anon_sym_readonly] = ACTIONS(3715),
    [anon_sym_required] = ACTIONS(3715),
    [anon_sym_sealed] = ACTIONS(3715),
    [anon_sym_virtual] = ACTIONS(3715),
    [anon_sym_volatile] = ACTIONS(3715),
    [anon_sym_where] = ACTIONS(3715),
    [anon_sym_notnull] = ACTIONS(3715),
    [anon_sym_unmanaged] = ACTIONS(3715),
    [anon_sym_TILDE] = ACTIONS(3717),
    [anon_sym_implicit] = ACTIONS(3715),
    [anon_sym_explicit] = ACTIONS(3715),
    [anon_sym_scoped] = ACTIONS(3715),
    [anon_sym_var] = ACTIONS(3715),
    [sym_predefined_type] = ACTIONS(3715),
    [anon_sym_yield] = ACTIONS(3715),
    [anon_sym_when] = ACTIONS(3715),
    [anon_sym_from] = ACTIONS(3715),
    [anon_sym_into] = ACTIONS(3715),
    [anon_sym_join] = ACTIONS(3715),
    [anon_sym_on] = ACTIONS(3715),
    [anon_sym_equals] = ACTIONS(3715),
    [anon_sym_let] = ACTIONS(3715),
    [anon_sym_orderby] = ACTIONS(3715),
    [anon_sym_ascending] = ACTIONS(3715),
    [anon_sym_descending] = ACTIONS(3715),
    [anon_sym_group] = ACTIONS(3715),
    [anon_sym_by] = ACTIONS(3715),
    [anon_sym_select] = ACTIONS(3715),
    [aux_sym_preproc_if_token1] = ACTIONS(3717),
    [aux_sym_preproc_if_token3] = ACTIONS(3717),
    [aux_sym_preproc_else_token1] = ACTIONS(3717),
    [aux_sym_preproc_elif_token1] = ACTIONS(3717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3448] = {
    [sym_preproc_region] = STATE(3448),
    [sym_preproc_endregion] = STATE(3448),
    [sym_preproc_line] = STATE(3448),
    [sym_preproc_pragma] = STATE(3448),
    [sym_preproc_nullable] = STATE(3448),
    [sym_preproc_error] = STATE(3448),
    [sym_preproc_define] = STATE(3448),
    [sym_preproc_undef] = STATE(3448),
    [sym__identifier_token] = ACTIONS(5065),
    [anon_sym_extern] = ACTIONS(5065),
    [anon_sym_alias] = ACTIONS(5065),
    [anon_sym_global] = ACTIONS(5065),
    [anon_sym_using] = ACTIONS(5065),
    [anon_sym_unsafe] = ACTIONS(5065),
    [anon_sym_static] = ACTIONS(5065),
    [anon_sym_LBRACK] = ACTIONS(5067),
    [anon_sym_LPAREN] = ACTIONS(5067),
    [anon_sym_event] = ACTIONS(5065),
    [anon_sym_namespace] = ACTIONS(5065),
    [anon_sym_class] = ACTIONS(5065),
    [anon_sym_ref] = ACTIONS(5065),
    [anon_sym_struct] = ACTIONS(5065),
    [anon_sym_enum] = ACTIONS(5065),
    [anon_sym_RBRACE] = ACTIONS(5067),
    [anon_sym_interface] = ACTIONS(5065),
    [anon_sym_delegate] = ACTIONS(5065),
    [anon_sym_record] = ACTIONS(5065),
    [anon_sym_abstract] = ACTIONS(5065),
    [anon_sym_async] = ACTIONS(5065),
    [anon_sym_const] = ACTIONS(5065),
    [anon_sym_file] = ACTIONS(5065),
    [anon_sym_fixed] = ACTIONS(5065),
    [anon_sym_internal] = ACTIONS(5065),
    [anon_sym_new] = ACTIONS(5065),
    [anon_sym_override] = ACTIONS(5065),
    [anon_sym_partial] = ACTIONS(5065),
    [anon_sym_private] = ACTIONS(5065),
    [anon_sym_protected] = ACTIONS(5065),
    [anon_sym_public] = ACTIONS(5065),
    [anon_sym_readonly] = ACTIONS(5065),
    [anon_sym_required] = ACTIONS(5065),
    [anon_sym_sealed] = ACTIONS(5065),
    [anon_sym_virtual] = ACTIONS(5065),
    [anon_sym_volatile] = ACTIONS(5065),
    [anon_sym_where] = ACTIONS(5065),
    [anon_sym_notnull] = ACTIONS(5065),
    [anon_sym_unmanaged] = ACTIONS(5065),
    [anon_sym_TILDE] = ACTIONS(5067),
    [anon_sym_implicit] = ACTIONS(5065),
    [anon_sym_explicit] = ACTIONS(5065),
    [anon_sym_scoped] = ACTIONS(5065),
    [anon_sym_var] = ACTIONS(5065),
    [sym_predefined_type] = ACTIONS(5065),
    [anon_sym_yield] = ACTIONS(5065),
    [anon_sym_when] = ACTIONS(5065),
    [anon_sym_from] = ACTIONS(5065),
    [anon_sym_into] = ACTIONS(5065),
    [anon_sym_join] = ACTIONS(5065),
    [anon_sym_on] = ACTIONS(5065),
    [anon_sym_equals] = ACTIONS(5065),
    [anon_sym_let] = ACTIONS(5065),
    [anon_sym_orderby] = ACTIONS(5065),
    [anon_sym_ascending] = ACTIONS(5065),
    [anon_sym_descending] = ACTIONS(5065),
    [anon_sym_group] = ACTIONS(5065),
    [anon_sym_by] = ACTIONS(5065),
    [anon_sym_select] = ACTIONS(5065),
    [aux_sym_preproc_if_token1] = ACTIONS(5067),
    [aux_sym_preproc_if_token3] = ACTIONS(5067),
    [aux_sym_preproc_else_token1] = ACTIONS(5067),
    [aux_sym_preproc_elif_token1] = ACTIONS(5067),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3449] = {
    [sym_preproc_region] = STATE(3449),
    [sym_preproc_endregion] = STATE(3449),
    [sym_preproc_line] = STATE(3449),
    [sym_preproc_pragma] = STATE(3449),
    [sym_preproc_nullable] = STATE(3449),
    [sym_preproc_error] = STATE(3449),
    [sym_preproc_define] = STATE(3449),
    [sym_preproc_undef] = STATE(3449),
    [sym__identifier_token] = ACTIONS(3727),
    [anon_sym_extern] = ACTIONS(3727),
    [anon_sym_alias] = ACTIONS(3727),
    [anon_sym_global] = ACTIONS(3727),
    [anon_sym_using] = ACTIONS(3727),
    [anon_sym_unsafe] = ACTIONS(3727),
    [anon_sym_static] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(3729),
    [anon_sym_event] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_ref] = ACTIONS(3727),
    [anon_sym_struct] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3729),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_delegate] = ACTIONS(3727),
    [anon_sym_record] = ACTIONS(3727),
    [anon_sym_abstract] = ACTIONS(3727),
    [anon_sym_async] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [anon_sym_file] = ACTIONS(3727),
    [anon_sym_fixed] = ACTIONS(3727),
    [anon_sym_internal] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [anon_sym_override] = ACTIONS(3727),
    [anon_sym_partial] = ACTIONS(3727),
    [anon_sym_private] = ACTIONS(3727),
    [anon_sym_protected] = ACTIONS(3727),
    [anon_sym_public] = ACTIONS(3727),
    [anon_sym_readonly] = ACTIONS(3727),
    [anon_sym_required] = ACTIONS(3727),
    [anon_sym_sealed] = ACTIONS(3727),
    [anon_sym_virtual] = ACTIONS(3727),
    [anon_sym_volatile] = ACTIONS(3727),
    [anon_sym_where] = ACTIONS(3727),
    [anon_sym_notnull] = ACTIONS(3727),
    [anon_sym_unmanaged] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3729),
    [anon_sym_implicit] = ACTIONS(3727),
    [anon_sym_explicit] = ACTIONS(3727),
    [anon_sym_scoped] = ACTIONS(3727),
    [anon_sym_var] = ACTIONS(3727),
    [sym_predefined_type] = ACTIONS(3727),
    [anon_sym_yield] = ACTIONS(3727),
    [anon_sym_when] = ACTIONS(3727),
    [anon_sym_from] = ACTIONS(3727),
    [anon_sym_into] = ACTIONS(3727),
    [anon_sym_join] = ACTIONS(3727),
    [anon_sym_on] = ACTIONS(3727),
    [anon_sym_equals] = ACTIONS(3727),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_orderby] = ACTIONS(3727),
    [anon_sym_ascending] = ACTIONS(3727),
    [anon_sym_descending] = ACTIONS(3727),
    [anon_sym_group] = ACTIONS(3727),
    [anon_sym_by] = ACTIONS(3727),
    [anon_sym_select] = ACTIONS(3727),
    [aux_sym_preproc_if_token1] = ACTIONS(3729),
    [aux_sym_preproc_if_token3] = ACTIONS(3729),
    [aux_sym_preproc_else_token1] = ACTIONS(3729),
    [aux_sym_preproc_elif_token1] = ACTIONS(3729),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3450] = {
    [sym__variable_designation] = STATE(4107),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3450),
    [sym_preproc_endregion] = STATE(3450),
    [sym_preproc_line] = STATE(3450),
    [sym_preproc_pragma] = STATE(3450),
    [sym_preproc_nullable] = STATE(3450),
    [sym_preproc_error] = STATE(3450),
    [sym_preproc_define] = STATE(3450),
    [sym_preproc_undef] = STATE(3450),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_LPAREN] = ACTIONS(4433),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4435),
    [anon_sym_GT] = ACTIONS(4435),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4435),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4435),
    [anon_sym_PLUS_PLUS] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_PIPE] = ACTIONS(4435),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4435),
    [anon_sym_GT_GT_GT] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4433),
    [anon_sym_BANG_EQ] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_DOT] = ACTIONS(4435),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4435),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4435),
    [anon_sym_or] = ACTIONS(4435),
    [anon_sym_AMP_AMP] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4433),
    [anon_sym_QMARK_QMARK] = ACTIONS(4433),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4435),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4435),
    [anon_sym_is] = ACTIONS(4435),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [anon_sym_with] = ACTIONS(4435),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3451] = {
    [sym_preproc_region] = STATE(3451),
    [sym_preproc_endregion] = STATE(3451),
    [sym_preproc_line] = STATE(3451),
    [sym_preproc_pragma] = STATE(3451),
    [sym_preproc_nullable] = STATE(3451),
    [sym_preproc_error] = STATE(3451),
    [sym_preproc_define] = STATE(3451),
    [sym_preproc_undef] = STATE(3451),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_RBRACK] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_in] = ACTIONS(4640),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_EQ_GT] = ACTIONS(4640),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_when] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4640),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_on] = ACTIONS(4640),
    [anon_sym_equals] = ACTIONS(4640),
    [anon_sym_by] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4640),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_if_token3] = ACTIONS(4640),
    [aux_sym_preproc_else_token1] = ACTIONS(4640),
    [aux_sym_preproc_elif_token1] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3452] = {
    [sym_preproc_region] = STATE(3452),
    [sym_preproc_endregion] = STATE(3452),
    [sym_preproc_line] = STATE(3452),
    [sym_preproc_pragma] = STATE(3452),
    [sym_preproc_nullable] = STATE(3452),
    [sym_preproc_error] = STATE(3452),
    [sym_preproc_define] = STATE(3452),
    [sym_preproc_undef] = STATE(3452),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5069),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4853),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3453] = {
    [sym_preproc_region] = STATE(3453),
    [sym_preproc_endregion] = STATE(3453),
    [sym_preproc_line] = STATE(3453),
    [sym_preproc_pragma] = STATE(3453),
    [sym_preproc_nullable] = STATE(3453),
    [sym_preproc_error] = STATE(3453),
    [sym_preproc_define] = STATE(3453),
    [sym_preproc_undef] = STATE(3453),
    [sym__identifier_token] = ACTIONS(4155),
    [anon_sym_alias] = ACTIONS(4155),
    [anon_sym_global] = ACTIONS(4155),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_file] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_where] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_notnull] = ACTIONS(4155),
    [anon_sym_unmanaged] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_scoped] = ACTIONS(4155),
    [anon_sym_var] = ACTIONS(4155),
    [anon_sym_yield] = ACTIONS(4155),
    [anon_sym_switch] = ACTIONS(4155),
    [anon_sym_when] = ACTIONS(4155),
    [sym_discard] = ACTIONS(4155),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4155),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_from] = ACTIONS(4155),
    [anon_sym_into] = ACTIONS(4155),
    [anon_sym_join] = ACTIONS(4155),
    [anon_sym_on] = ACTIONS(4155),
    [anon_sym_equals] = ACTIONS(4155),
    [anon_sym_let] = ACTIONS(4155),
    [anon_sym_orderby] = ACTIONS(4155),
    [anon_sym_ascending] = ACTIONS(4155),
    [anon_sym_descending] = ACTIONS(4155),
    [anon_sym_group] = ACTIONS(4155),
    [anon_sym_by] = ACTIONS(4155),
    [anon_sym_select] = ACTIONS(4155),
    [anon_sym_as] = ACTIONS(4155),
    [anon_sym_is] = ACTIONS(4155),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4155),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4157),
  },
  [3454] = {
    [sym_preproc_region] = STATE(3454),
    [sym_preproc_endregion] = STATE(3454),
    [sym_preproc_line] = STATE(3454),
    [sym_preproc_pragma] = STATE(3454),
    [sym_preproc_nullable] = STATE(3454),
    [sym_preproc_error] = STATE(3454),
    [sym_preproc_define] = STATE(3454),
    [sym_preproc_undef] = STATE(3454),
    [sym__identifier_token] = ACTIONS(3747),
    [anon_sym_extern] = ACTIONS(3747),
    [anon_sym_alias] = ACTIONS(3747),
    [anon_sym_global] = ACTIONS(3747),
    [anon_sym_using] = ACTIONS(3747),
    [anon_sym_unsafe] = ACTIONS(3747),
    [anon_sym_static] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_event] = ACTIONS(3747),
    [anon_sym_namespace] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_ref] = ACTIONS(3747),
    [anon_sym_struct] = ACTIONS(3747),
    [anon_sym_enum] = ACTIONS(3747),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_interface] = ACTIONS(3747),
    [anon_sym_delegate] = ACTIONS(3747),
    [anon_sym_record] = ACTIONS(3747),
    [anon_sym_abstract] = ACTIONS(3747),
    [anon_sym_async] = ACTIONS(3747),
    [anon_sym_const] = ACTIONS(3747),
    [anon_sym_file] = ACTIONS(3747),
    [anon_sym_fixed] = ACTIONS(3747),
    [anon_sym_internal] = ACTIONS(3747),
    [anon_sym_new] = ACTIONS(3747),
    [anon_sym_override] = ACTIONS(3747),
    [anon_sym_partial] = ACTIONS(3747),
    [anon_sym_private] = ACTIONS(3747),
    [anon_sym_protected] = ACTIONS(3747),
    [anon_sym_public] = ACTIONS(3747),
    [anon_sym_readonly] = ACTIONS(3747),
    [anon_sym_required] = ACTIONS(3747),
    [anon_sym_sealed] = ACTIONS(3747),
    [anon_sym_virtual] = ACTIONS(3747),
    [anon_sym_volatile] = ACTIONS(3747),
    [anon_sym_where] = ACTIONS(3747),
    [anon_sym_notnull] = ACTIONS(3747),
    [anon_sym_unmanaged] = ACTIONS(3747),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_implicit] = ACTIONS(3747),
    [anon_sym_explicit] = ACTIONS(3747),
    [anon_sym_scoped] = ACTIONS(3747),
    [anon_sym_var] = ACTIONS(3747),
    [sym_predefined_type] = ACTIONS(3747),
    [anon_sym_yield] = ACTIONS(3747),
    [anon_sym_when] = ACTIONS(3747),
    [anon_sym_from] = ACTIONS(3747),
    [anon_sym_into] = ACTIONS(3747),
    [anon_sym_join] = ACTIONS(3747),
    [anon_sym_on] = ACTIONS(3747),
    [anon_sym_equals] = ACTIONS(3747),
    [anon_sym_let] = ACTIONS(3747),
    [anon_sym_orderby] = ACTIONS(3747),
    [anon_sym_ascending] = ACTIONS(3747),
    [anon_sym_descending] = ACTIONS(3747),
    [anon_sym_group] = ACTIONS(3747),
    [anon_sym_by] = ACTIONS(3747),
    [anon_sym_select] = ACTIONS(3747),
    [aux_sym_preproc_if_token1] = ACTIONS(3749),
    [aux_sym_preproc_if_token3] = ACTIONS(3749),
    [aux_sym_preproc_else_token1] = ACTIONS(3749),
    [aux_sym_preproc_elif_token1] = ACTIONS(3749),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3455] = {
    [sym_preproc_region] = STATE(3455),
    [sym_preproc_endregion] = STATE(3455),
    [sym_preproc_line] = STATE(3455),
    [sym_preproc_pragma] = STATE(3455),
    [sym_preproc_nullable] = STATE(3455),
    [sym_preproc_error] = STATE(3455),
    [sym_preproc_define] = STATE(3455),
    [sym_preproc_undef] = STATE(3455),
    [sym__identifier_token] = ACTIONS(3823),
    [anon_sym_extern] = ACTIONS(3823),
    [anon_sym_alias] = ACTIONS(3823),
    [anon_sym_global] = ACTIONS(3823),
    [anon_sym_using] = ACTIONS(3823),
    [anon_sym_unsafe] = ACTIONS(3823),
    [anon_sym_static] = ACTIONS(3823),
    [anon_sym_LBRACK] = ACTIONS(3825),
    [anon_sym_LPAREN] = ACTIONS(3825),
    [anon_sym_event] = ACTIONS(3823),
    [anon_sym_namespace] = ACTIONS(3823),
    [anon_sym_class] = ACTIONS(3823),
    [anon_sym_ref] = ACTIONS(3823),
    [anon_sym_struct] = ACTIONS(3823),
    [anon_sym_enum] = ACTIONS(3823),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_interface] = ACTIONS(3823),
    [anon_sym_delegate] = ACTIONS(3823),
    [anon_sym_record] = ACTIONS(3823),
    [anon_sym_abstract] = ACTIONS(3823),
    [anon_sym_async] = ACTIONS(3823),
    [anon_sym_const] = ACTIONS(3823),
    [anon_sym_file] = ACTIONS(3823),
    [anon_sym_fixed] = ACTIONS(3823),
    [anon_sym_internal] = ACTIONS(3823),
    [anon_sym_new] = ACTIONS(3823),
    [anon_sym_override] = ACTIONS(3823),
    [anon_sym_partial] = ACTIONS(3823),
    [anon_sym_private] = ACTIONS(3823),
    [anon_sym_protected] = ACTIONS(3823),
    [anon_sym_public] = ACTIONS(3823),
    [anon_sym_readonly] = ACTIONS(3823),
    [anon_sym_required] = ACTIONS(3823),
    [anon_sym_sealed] = ACTIONS(3823),
    [anon_sym_virtual] = ACTIONS(3823),
    [anon_sym_volatile] = ACTIONS(3823),
    [anon_sym_where] = ACTIONS(3823),
    [anon_sym_notnull] = ACTIONS(3823),
    [anon_sym_unmanaged] = ACTIONS(3823),
    [anon_sym_TILDE] = ACTIONS(3825),
    [anon_sym_implicit] = ACTIONS(3823),
    [anon_sym_explicit] = ACTIONS(3823),
    [anon_sym_scoped] = ACTIONS(3823),
    [anon_sym_var] = ACTIONS(3823),
    [sym_predefined_type] = ACTIONS(3823),
    [anon_sym_yield] = ACTIONS(3823),
    [anon_sym_when] = ACTIONS(3823),
    [anon_sym_from] = ACTIONS(3823),
    [anon_sym_into] = ACTIONS(3823),
    [anon_sym_join] = ACTIONS(3823),
    [anon_sym_on] = ACTIONS(3823),
    [anon_sym_equals] = ACTIONS(3823),
    [anon_sym_let] = ACTIONS(3823),
    [anon_sym_orderby] = ACTIONS(3823),
    [anon_sym_ascending] = ACTIONS(3823),
    [anon_sym_descending] = ACTIONS(3823),
    [anon_sym_group] = ACTIONS(3823),
    [anon_sym_by] = ACTIONS(3823),
    [anon_sym_select] = ACTIONS(3823),
    [aux_sym_preproc_if_token1] = ACTIONS(3825),
    [aux_sym_preproc_if_token3] = ACTIONS(3825),
    [aux_sym_preproc_else_token1] = ACTIONS(3825),
    [aux_sym_preproc_elif_token1] = ACTIONS(3825),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3456] = {
    [sym_preproc_region] = STATE(3456),
    [sym_preproc_endregion] = STATE(3456),
    [sym_preproc_line] = STATE(3456),
    [sym_preproc_pragma] = STATE(3456),
    [sym_preproc_nullable] = STATE(3456),
    [sym_preproc_error] = STATE(3456),
    [sym_preproc_define] = STATE(3456),
    [sym_preproc_undef] = STATE(3456),
    [sym__identifier_token] = ACTIONS(5071),
    [anon_sym_extern] = ACTIONS(5071),
    [anon_sym_alias] = ACTIONS(5071),
    [anon_sym_global] = ACTIONS(5071),
    [anon_sym_using] = ACTIONS(5071),
    [anon_sym_unsafe] = ACTIONS(5071),
    [anon_sym_static] = ACTIONS(5071),
    [anon_sym_LBRACK] = ACTIONS(5073),
    [anon_sym_LPAREN] = ACTIONS(5073),
    [anon_sym_event] = ACTIONS(5071),
    [anon_sym_namespace] = ACTIONS(5071),
    [anon_sym_class] = ACTIONS(5071),
    [anon_sym_ref] = ACTIONS(5071),
    [anon_sym_struct] = ACTIONS(5071),
    [anon_sym_enum] = ACTIONS(5071),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_interface] = ACTIONS(5071),
    [anon_sym_delegate] = ACTIONS(5071),
    [anon_sym_record] = ACTIONS(5071),
    [anon_sym_abstract] = ACTIONS(5071),
    [anon_sym_async] = ACTIONS(5071),
    [anon_sym_const] = ACTIONS(5071),
    [anon_sym_file] = ACTIONS(5071),
    [anon_sym_fixed] = ACTIONS(5071),
    [anon_sym_internal] = ACTIONS(5071),
    [anon_sym_new] = ACTIONS(5071),
    [anon_sym_override] = ACTIONS(5071),
    [anon_sym_partial] = ACTIONS(5071),
    [anon_sym_private] = ACTIONS(5071),
    [anon_sym_protected] = ACTIONS(5071),
    [anon_sym_public] = ACTIONS(5071),
    [anon_sym_readonly] = ACTIONS(5071),
    [anon_sym_required] = ACTIONS(5071),
    [anon_sym_sealed] = ACTIONS(5071),
    [anon_sym_virtual] = ACTIONS(5071),
    [anon_sym_volatile] = ACTIONS(5071),
    [anon_sym_where] = ACTIONS(5071),
    [anon_sym_notnull] = ACTIONS(5071),
    [anon_sym_unmanaged] = ACTIONS(5071),
    [anon_sym_TILDE] = ACTIONS(5073),
    [anon_sym_implicit] = ACTIONS(5071),
    [anon_sym_explicit] = ACTIONS(5071),
    [anon_sym_scoped] = ACTIONS(5071),
    [anon_sym_var] = ACTIONS(5071),
    [sym_predefined_type] = ACTIONS(5071),
    [anon_sym_yield] = ACTIONS(5071),
    [anon_sym_when] = ACTIONS(5071),
    [anon_sym_from] = ACTIONS(5071),
    [anon_sym_into] = ACTIONS(5071),
    [anon_sym_join] = ACTIONS(5071),
    [anon_sym_on] = ACTIONS(5071),
    [anon_sym_equals] = ACTIONS(5071),
    [anon_sym_let] = ACTIONS(5071),
    [anon_sym_orderby] = ACTIONS(5071),
    [anon_sym_ascending] = ACTIONS(5071),
    [anon_sym_descending] = ACTIONS(5071),
    [anon_sym_group] = ACTIONS(5071),
    [anon_sym_by] = ACTIONS(5071),
    [anon_sym_select] = ACTIONS(5071),
    [aux_sym_preproc_if_token1] = ACTIONS(5073),
    [aux_sym_preproc_if_token3] = ACTIONS(5073),
    [aux_sym_preproc_else_token1] = ACTIONS(5073),
    [aux_sym_preproc_elif_token1] = ACTIONS(5073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3457] = {
    [sym_preproc_region] = STATE(3457),
    [sym_preproc_endregion] = STATE(3457),
    [sym_preproc_line] = STATE(3457),
    [sym_preproc_pragma] = STATE(3457),
    [sym_preproc_nullable] = STATE(3457),
    [sym_preproc_error] = STATE(3457),
    [sym_preproc_define] = STATE(3457),
    [sym_preproc_undef] = STATE(3457),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3458] = {
    [sym_preproc_region] = STATE(3458),
    [sym_preproc_endregion] = STATE(3458),
    [sym_preproc_line] = STATE(3458),
    [sym_preproc_pragma] = STATE(3458),
    [sym_preproc_nullable] = STATE(3458),
    [sym_preproc_error] = STATE(3458),
    [sym_preproc_define] = STATE(3458),
    [sym_preproc_undef] = STATE(3458),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3459] = {
    [sym_preproc_region] = STATE(3459),
    [sym_preproc_endregion] = STATE(3459),
    [sym_preproc_line] = STATE(3459),
    [sym_preproc_pragma] = STATE(3459),
    [sym_preproc_nullable] = STATE(3459),
    [sym_preproc_error] = STATE(3459),
    [sym_preproc_define] = STATE(3459),
    [sym_preproc_undef] = STATE(3459),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3460] = {
    [sym_preproc_region] = STATE(3460),
    [sym_preproc_endregion] = STATE(3460),
    [sym_preproc_line] = STATE(3460),
    [sym_preproc_pragma] = STATE(3460),
    [sym_preproc_nullable] = STATE(3460),
    [sym_preproc_error] = STATE(3460),
    [sym_preproc_define] = STATE(3460),
    [sym_preproc_undef] = STATE(3460),
    [sym__identifier_token] = ACTIONS(5075),
    [anon_sym_extern] = ACTIONS(5075),
    [anon_sym_alias] = ACTIONS(5075),
    [anon_sym_global] = ACTIONS(5075),
    [anon_sym_using] = ACTIONS(5075),
    [anon_sym_unsafe] = ACTIONS(5075),
    [anon_sym_static] = ACTIONS(5075),
    [anon_sym_LBRACK] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(5077),
    [anon_sym_event] = ACTIONS(5075),
    [anon_sym_namespace] = ACTIONS(5075),
    [anon_sym_class] = ACTIONS(5075),
    [anon_sym_ref] = ACTIONS(5075),
    [anon_sym_struct] = ACTIONS(5075),
    [anon_sym_enum] = ACTIONS(5075),
    [anon_sym_RBRACE] = ACTIONS(5077),
    [anon_sym_interface] = ACTIONS(5075),
    [anon_sym_delegate] = ACTIONS(5075),
    [anon_sym_record] = ACTIONS(5075),
    [anon_sym_abstract] = ACTIONS(5075),
    [anon_sym_async] = ACTIONS(5075),
    [anon_sym_const] = ACTIONS(5075),
    [anon_sym_file] = ACTIONS(5075),
    [anon_sym_fixed] = ACTIONS(5075),
    [anon_sym_internal] = ACTIONS(5075),
    [anon_sym_new] = ACTIONS(5075),
    [anon_sym_override] = ACTIONS(5075),
    [anon_sym_partial] = ACTIONS(5075),
    [anon_sym_private] = ACTIONS(5075),
    [anon_sym_protected] = ACTIONS(5075),
    [anon_sym_public] = ACTIONS(5075),
    [anon_sym_readonly] = ACTIONS(5075),
    [anon_sym_required] = ACTIONS(5075),
    [anon_sym_sealed] = ACTIONS(5075),
    [anon_sym_virtual] = ACTIONS(5075),
    [anon_sym_volatile] = ACTIONS(5075),
    [anon_sym_where] = ACTIONS(5075),
    [anon_sym_notnull] = ACTIONS(5075),
    [anon_sym_unmanaged] = ACTIONS(5075),
    [anon_sym_TILDE] = ACTIONS(5077),
    [anon_sym_implicit] = ACTIONS(5075),
    [anon_sym_explicit] = ACTIONS(5075),
    [anon_sym_scoped] = ACTIONS(5075),
    [anon_sym_var] = ACTIONS(5075),
    [sym_predefined_type] = ACTIONS(5075),
    [anon_sym_yield] = ACTIONS(5075),
    [anon_sym_when] = ACTIONS(5075),
    [anon_sym_from] = ACTIONS(5075),
    [anon_sym_into] = ACTIONS(5075),
    [anon_sym_join] = ACTIONS(5075),
    [anon_sym_on] = ACTIONS(5075),
    [anon_sym_equals] = ACTIONS(5075),
    [anon_sym_let] = ACTIONS(5075),
    [anon_sym_orderby] = ACTIONS(5075),
    [anon_sym_ascending] = ACTIONS(5075),
    [anon_sym_descending] = ACTIONS(5075),
    [anon_sym_group] = ACTIONS(5075),
    [anon_sym_by] = ACTIONS(5075),
    [anon_sym_select] = ACTIONS(5075),
    [aux_sym_preproc_if_token1] = ACTIONS(5077),
    [aux_sym_preproc_if_token3] = ACTIONS(5077),
    [aux_sym_preproc_else_token1] = ACTIONS(5077),
    [aux_sym_preproc_elif_token1] = ACTIONS(5077),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3461] = {
    [sym_preproc_region] = STATE(3461),
    [sym_preproc_endregion] = STATE(3461),
    [sym_preproc_line] = STATE(3461),
    [sym_preproc_pragma] = STATE(3461),
    [sym_preproc_nullable] = STATE(3461),
    [sym_preproc_error] = STATE(3461),
    [sym_preproc_define] = STATE(3461),
    [sym_preproc_undef] = STATE(3461),
    [sym__identifier_token] = ACTIONS(3763),
    [anon_sym_extern] = ACTIONS(3763),
    [anon_sym_alias] = ACTIONS(3763),
    [anon_sym_global] = ACTIONS(3763),
    [anon_sym_using] = ACTIONS(3763),
    [anon_sym_unsafe] = ACTIONS(3763),
    [anon_sym_static] = ACTIONS(3763),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_event] = ACTIONS(3763),
    [anon_sym_namespace] = ACTIONS(3763),
    [anon_sym_class] = ACTIONS(3763),
    [anon_sym_ref] = ACTIONS(3763),
    [anon_sym_struct] = ACTIONS(3763),
    [anon_sym_enum] = ACTIONS(3763),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_interface] = ACTIONS(3763),
    [anon_sym_delegate] = ACTIONS(3763),
    [anon_sym_record] = ACTIONS(3763),
    [anon_sym_abstract] = ACTIONS(3763),
    [anon_sym_async] = ACTIONS(3763),
    [anon_sym_const] = ACTIONS(3763),
    [anon_sym_file] = ACTIONS(3763),
    [anon_sym_fixed] = ACTIONS(3763),
    [anon_sym_internal] = ACTIONS(3763),
    [anon_sym_new] = ACTIONS(3763),
    [anon_sym_override] = ACTIONS(3763),
    [anon_sym_partial] = ACTIONS(3763),
    [anon_sym_private] = ACTIONS(3763),
    [anon_sym_protected] = ACTIONS(3763),
    [anon_sym_public] = ACTIONS(3763),
    [anon_sym_readonly] = ACTIONS(3763),
    [anon_sym_required] = ACTIONS(3763),
    [anon_sym_sealed] = ACTIONS(3763),
    [anon_sym_virtual] = ACTIONS(3763),
    [anon_sym_volatile] = ACTIONS(3763),
    [anon_sym_where] = ACTIONS(3763),
    [anon_sym_notnull] = ACTIONS(3763),
    [anon_sym_unmanaged] = ACTIONS(3763),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_implicit] = ACTIONS(3763),
    [anon_sym_explicit] = ACTIONS(3763),
    [anon_sym_scoped] = ACTIONS(3763),
    [anon_sym_var] = ACTIONS(3763),
    [sym_predefined_type] = ACTIONS(3763),
    [anon_sym_yield] = ACTIONS(3763),
    [anon_sym_when] = ACTIONS(3763),
    [anon_sym_from] = ACTIONS(3763),
    [anon_sym_into] = ACTIONS(3763),
    [anon_sym_join] = ACTIONS(3763),
    [anon_sym_on] = ACTIONS(3763),
    [anon_sym_equals] = ACTIONS(3763),
    [anon_sym_let] = ACTIONS(3763),
    [anon_sym_orderby] = ACTIONS(3763),
    [anon_sym_ascending] = ACTIONS(3763),
    [anon_sym_descending] = ACTIONS(3763),
    [anon_sym_group] = ACTIONS(3763),
    [anon_sym_by] = ACTIONS(3763),
    [anon_sym_select] = ACTIONS(3763),
    [aux_sym_preproc_if_token1] = ACTIONS(3765),
    [aux_sym_preproc_if_token3] = ACTIONS(3765),
    [aux_sym_preproc_else_token1] = ACTIONS(3765),
    [aux_sym_preproc_elif_token1] = ACTIONS(3765),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3462] = {
    [sym__variable_designation] = STATE(4201),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3462),
    [sym_preproc_endregion] = STATE(3462),
    [sym_preproc_line] = STATE(3462),
    [sym_preproc_pragma] = STATE(3462),
    [sym_preproc_nullable] = STATE(3462),
    [sym_preproc_error] = STATE(3462),
    [sym_preproc_define] = STATE(3462),
    [sym_preproc_undef] = STATE(3462),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(4443),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(4445),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4445),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4443),
    [anon_sym_DASH_DASH] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4443),
    [anon_sym_SLASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4443),
    [anon_sym_CARET] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(4445),
    [anon_sym_AMP] = ACTIONS(4445),
    [anon_sym_LT_LT] = ACTIONS(4443),
    [anon_sym_GT_GT] = ACTIONS(4445),
    [anon_sym_GT_GT_GT] = ACTIONS(4443),
    [anon_sym_EQ_EQ] = ACTIONS(4443),
    [anon_sym_BANG_EQ] = ACTIONS(4443),
    [anon_sym_GT_EQ] = ACTIONS(4443),
    [anon_sym_LT_EQ] = ACTIONS(4443),
    [anon_sym_DOT] = ACTIONS(4445),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4445),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4443),
    [anon_sym_and] = ACTIONS(4445),
    [anon_sym_or] = ACTIONS(4445),
    [anon_sym_AMP_AMP] = ACTIONS(4443),
    [anon_sym_PIPE_PIPE] = ACTIONS(4443),
    [anon_sym_QMARK_QMARK] = ACTIONS(4443),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4445),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4445),
    [anon_sym_is] = ACTIONS(4445),
    [anon_sym_DASH_GT] = ACTIONS(4443),
    [anon_sym_with] = ACTIONS(4445),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3463] = {
    [sym_preproc_region] = STATE(3463),
    [sym_preproc_endregion] = STATE(3463),
    [sym_preproc_line] = STATE(3463),
    [sym_preproc_pragma] = STATE(3463),
    [sym_preproc_nullable] = STATE(3463),
    [sym_preproc_error] = STATE(3463),
    [sym_preproc_define] = STATE(3463),
    [sym_preproc_undef] = STATE(3463),
    [sym__identifier_token] = ACTIONS(3807),
    [anon_sym_extern] = ACTIONS(3807),
    [anon_sym_alias] = ACTIONS(3807),
    [anon_sym_global] = ACTIONS(3807),
    [anon_sym_using] = ACTIONS(3807),
    [anon_sym_unsafe] = ACTIONS(3807),
    [anon_sym_static] = ACTIONS(3807),
    [anon_sym_LBRACK] = ACTIONS(3809),
    [anon_sym_LPAREN] = ACTIONS(3809),
    [anon_sym_event] = ACTIONS(3807),
    [anon_sym_namespace] = ACTIONS(3807),
    [anon_sym_class] = ACTIONS(3807),
    [anon_sym_ref] = ACTIONS(3807),
    [anon_sym_struct] = ACTIONS(3807),
    [anon_sym_enum] = ACTIONS(3807),
    [anon_sym_RBRACE] = ACTIONS(3809),
    [anon_sym_interface] = ACTIONS(3807),
    [anon_sym_delegate] = ACTIONS(3807),
    [anon_sym_record] = ACTIONS(3807),
    [anon_sym_abstract] = ACTIONS(3807),
    [anon_sym_async] = ACTIONS(3807),
    [anon_sym_const] = ACTIONS(3807),
    [anon_sym_file] = ACTIONS(3807),
    [anon_sym_fixed] = ACTIONS(3807),
    [anon_sym_internal] = ACTIONS(3807),
    [anon_sym_new] = ACTIONS(3807),
    [anon_sym_override] = ACTIONS(3807),
    [anon_sym_partial] = ACTIONS(3807),
    [anon_sym_private] = ACTIONS(3807),
    [anon_sym_protected] = ACTIONS(3807),
    [anon_sym_public] = ACTIONS(3807),
    [anon_sym_readonly] = ACTIONS(3807),
    [anon_sym_required] = ACTIONS(3807),
    [anon_sym_sealed] = ACTIONS(3807),
    [anon_sym_virtual] = ACTIONS(3807),
    [anon_sym_volatile] = ACTIONS(3807),
    [anon_sym_where] = ACTIONS(3807),
    [anon_sym_notnull] = ACTIONS(3807),
    [anon_sym_unmanaged] = ACTIONS(3807),
    [anon_sym_TILDE] = ACTIONS(3809),
    [anon_sym_implicit] = ACTIONS(3807),
    [anon_sym_explicit] = ACTIONS(3807),
    [anon_sym_scoped] = ACTIONS(3807),
    [anon_sym_var] = ACTIONS(3807),
    [sym_predefined_type] = ACTIONS(3807),
    [anon_sym_yield] = ACTIONS(3807),
    [anon_sym_when] = ACTIONS(3807),
    [anon_sym_from] = ACTIONS(3807),
    [anon_sym_into] = ACTIONS(3807),
    [anon_sym_join] = ACTIONS(3807),
    [anon_sym_on] = ACTIONS(3807),
    [anon_sym_equals] = ACTIONS(3807),
    [anon_sym_let] = ACTIONS(3807),
    [anon_sym_orderby] = ACTIONS(3807),
    [anon_sym_ascending] = ACTIONS(3807),
    [anon_sym_descending] = ACTIONS(3807),
    [anon_sym_group] = ACTIONS(3807),
    [anon_sym_by] = ACTIONS(3807),
    [anon_sym_select] = ACTIONS(3807),
    [aux_sym_preproc_if_token1] = ACTIONS(3809),
    [aux_sym_preproc_if_token3] = ACTIONS(3809),
    [aux_sym_preproc_else_token1] = ACTIONS(3809),
    [aux_sym_preproc_elif_token1] = ACTIONS(3809),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3464] = {
    [sym__variable_designation] = STATE(4197),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3464),
    [sym_preproc_endregion] = STATE(3464),
    [sym_preproc_line] = STATE(3464),
    [sym_preproc_pragma] = STATE(3464),
    [sym_preproc_nullable] = STATE(3464),
    [sym_preproc_error] = STATE(3464),
    [sym_preproc_define] = STATE(3464),
    [sym_preproc_undef] = STATE(3464),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4403),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(4405),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4405),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4405),
    [anon_sym_PLUS_PLUS] = ACTIONS(4403),
    [anon_sym_DASH_DASH] = ACTIONS(4403),
    [anon_sym_PLUS] = ACTIONS(4405),
    [anon_sym_DASH] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(4403),
    [anon_sym_SLASH] = ACTIONS(4405),
    [anon_sym_PERCENT] = ACTIONS(4403),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_AMP] = ACTIONS(4405),
    [anon_sym_LT_LT] = ACTIONS(4403),
    [anon_sym_GT_GT] = ACTIONS(4405),
    [anon_sym_GT_GT_GT] = ACTIONS(4403),
    [anon_sym_EQ_EQ] = ACTIONS(4403),
    [anon_sym_BANG_EQ] = ACTIONS(4403),
    [anon_sym_GT_EQ] = ACTIONS(4403),
    [anon_sym_LT_EQ] = ACTIONS(4403),
    [anon_sym_DOT] = ACTIONS(4405),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4405),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4403),
    [anon_sym_and] = ACTIONS(4405),
    [anon_sym_or] = ACTIONS(4405),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [anon_sym_QMARK_QMARK] = ACTIONS(4403),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4405),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4405),
    [anon_sym_is] = ACTIONS(4405),
    [anon_sym_DASH_GT] = ACTIONS(4403),
    [anon_sym_with] = ACTIONS(4405),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3465] = {
    [sym_preproc_region] = STATE(3465),
    [sym_preproc_endregion] = STATE(3465),
    [sym_preproc_line] = STATE(3465),
    [sym_preproc_pragma] = STATE(3465),
    [sym_preproc_nullable] = STATE(3465),
    [sym_preproc_error] = STATE(3465),
    [sym_preproc_define] = STATE(3465),
    [sym_preproc_undef] = STATE(3465),
    [sym__identifier_token] = ACTIONS(3815),
    [anon_sym_extern] = ACTIONS(3815),
    [anon_sym_alias] = ACTIONS(3815),
    [anon_sym_global] = ACTIONS(3815),
    [anon_sym_using] = ACTIONS(3815),
    [anon_sym_unsafe] = ACTIONS(3815),
    [anon_sym_static] = ACTIONS(3815),
    [anon_sym_LBRACK] = ACTIONS(3817),
    [anon_sym_LPAREN] = ACTIONS(3817),
    [anon_sym_event] = ACTIONS(3815),
    [anon_sym_namespace] = ACTIONS(3815),
    [anon_sym_class] = ACTIONS(3815),
    [anon_sym_ref] = ACTIONS(3815),
    [anon_sym_struct] = ACTIONS(3815),
    [anon_sym_enum] = ACTIONS(3815),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_interface] = ACTIONS(3815),
    [anon_sym_delegate] = ACTIONS(3815),
    [anon_sym_record] = ACTIONS(3815),
    [anon_sym_abstract] = ACTIONS(3815),
    [anon_sym_async] = ACTIONS(3815),
    [anon_sym_const] = ACTIONS(3815),
    [anon_sym_file] = ACTIONS(3815),
    [anon_sym_fixed] = ACTIONS(3815),
    [anon_sym_internal] = ACTIONS(3815),
    [anon_sym_new] = ACTIONS(3815),
    [anon_sym_override] = ACTIONS(3815),
    [anon_sym_partial] = ACTIONS(3815),
    [anon_sym_private] = ACTIONS(3815),
    [anon_sym_protected] = ACTIONS(3815),
    [anon_sym_public] = ACTIONS(3815),
    [anon_sym_readonly] = ACTIONS(3815),
    [anon_sym_required] = ACTIONS(3815),
    [anon_sym_sealed] = ACTIONS(3815),
    [anon_sym_virtual] = ACTIONS(3815),
    [anon_sym_volatile] = ACTIONS(3815),
    [anon_sym_where] = ACTIONS(3815),
    [anon_sym_notnull] = ACTIONS(3815),
    [anon_sym_unmanaged] = ACTIONS(3815),
    [anon_sym_TILDE] = ACTIONS(3817),
    [anon_sym_implicit] = ACTIONS(3815),
    [anon_sym_explicit] = ACTIONS(3815),
    [anon_sym_scoped] = ACTIONS(3815),
    [anon_sym_var] = ACTIONS(3815),
    [sym_predefined_type] = ACTIONS(3815),
    [anon_sym_yield] = ACTIONS(3815),
    [anon_sym_when] = ACTIONS(3815),
    [anon_sym_from] = ACTIONS(3815),
    [anon_sym_into] = ACTIONS(3815),
    [anon_sym_join] = ACTIONS(3815),
    [anon_sym_on] = ACTIONS(3815),
    [anon_sym_equals] = ACTIONS(3815),
    [anon_sym_let] = ACTIONS(3815),
    [anon_sym_orderby] = ACTIONS(3815),
    [anon_sym_ascending] = ACTIONS(3815),
    [anon_sym_descending] = ACTIONS(3815),
    [anon_sym_group] = ACTIONS(3815),
    [anon_sym_by] = ACTIONS(3815),
    [anon_sym_select] = ACTIONS(3815),
    [aux_sym_preproc_if_token1] = ACTIONS(3817),
    [aux_sym_preproc_if_token3] = ACTIONS(3817),
    [aux_sym_preproc_else_token1] = ACTIONS(3817),
    [aux_sym_preproc_elif_token1] = ACTIONS(3817),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3466] = {
    [sym_preproc_region] = STATE(3466),
    [sym_preproc_endregion] = STATE(3466),
    [sym_preproc_line] = STATE(3466),
    [sym_preproc_pragma] = STATE(3466),
    [sym_preproc_nullable] = STATE(3466),
    [sym_preproc_error] = STATE(3466),
    [sym_preproc_define] = STATE(3466),
    [sym_preproc_undef] = STATE(3466),
    [sym__identifier_token] = ACTIONS(3819),
    [anon_sym_extern] = ACTIONS(3819),
    [anon_sym_alias] = ACTIONS(3819),
    [anon_sym_global] = ACTIONS(3819),
    [anon_sym_using] = ACTIONS(3819),
    [anon_sym_unsafe] = ACTIONS(3819),
    [anon_sym_static] = ACTIONS(3819),
    [anon_sym_LBRACK] = ACTIONS(3821),
    [anon_sym_LPAREN] = ACTIONS(3821),
    [anon_sym_event] = ACTIONS(3819),
    [anon_sym_namespace] = ACTIONS(3819),
    [anon_sym_class] = ACTIONS(3819),
    [anon_sym_ref] = ACTIONS(3819),
    [anon_sym_struct] = ACTIONS(3819),
    [anon_sym_enum] = ACTIONS(3819),
    [anon_sym_RBRACE] = ACTIONS(3821),
    [anon_sym_interface] = ACTIONS(3819),
    [anon_sym_delegate] = ACTIONS(3819),
    [anon_sym_record] = ACTIONS(3819),
    [anon_sym_abstract] = ACTIONS(3819),
    [anon_sym_async] = ACTIONS(3819),
    [anon_sym_const] = ACTIONS(3819),
    [anon_sym_file] = ACTIONS(3819),
    [anon_sym_fixed] = ACTIONS(3819),
    [anon_sym_internal] = ACTIONS(3819),
    [anon_sym_new] = ACTIONS(3819),
    [anon_sym_override] = ACTIONS(3819),
    [anon_sym_partial] = ACTIONS(3819),
    [anon_sym_private] = ACTIONS(3819),
    [anon_sym_protected] = ACTIONS(3819),
    [anon_sym_public] = ACTIONS(3819),
    [anon_sym_readonly] = ACTIONS(3819),
    [anon_sym_required] = ACTIONS(3819),
    [anon_sym_sealed] = ACTIONS(3819),
    [anon_sym_virtual] = ACTIONS(3819),
    [anon_sym_volatile] = ACTIONS(3819),
    [anon_sym_where] = ACTIONS(3819),
    [anon_sym_notnull] = ACTIONS(3819),
    [anon_sym_unmanaged] = ACTIONS(3819),
    [anon_sym_TILDE] = ACTIONS(3821),
    [anon_sym_implicit] = ACTIONS(3819),
    [anon_sym_explicit] = ACTIONS(3819),
    [anon_sym_scoped] = ACTIONS(3819),
    [anon_sym_var] = ACTIONS(3819),
    [sym_predefined_type] = ACTIONS(3819),
    [anon_sym_yield] = ACTIONS(3819),
    [anon_sym_when] = ACTIONS(3819),
    [anon_sym_from] = ACTIONS(3819),
    [anon_sym_into] = ACTIONS(3819),
    [anon_sym_join] = ACTIONS(3819),
    [anon_sym_on] = ACTIONS(3819),
    [anon_sym_equals] = ACTIONS(3819),
    [anon_sym_let] = ACTIONS(3819),
    [anon_sym_orderby] = ACTIONS(3819),
    [anon_sym_ascending] = ACTIONS(3819),
    [anon_sym_descending] = ACTIONS(3819),
    [anon_sym_group] = ACTIONS(3819),
    [anon_sym_by] = ACTIONS(3819),
    [anon_sym_select] = ACTIONS(3819),
    [aux_sym_preproc_if_token1] = ACTIONS(3821),
    [aux_sym_preproc_if_token3] = ACTIONS(3821),
    [aux_sym_preproc_else_token1] = ACTIONS(3821),
    [aux_sym_preproc_elif_token1] = ACTIONS(3821),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3467] = {
    [sym_preproc_region] = STATE(3467),
    [sym_preproc_endregion] = STATE(3467),
    [sym_preproc_line] = STATE(3467),
    [sym_preproc_pragma] = STATE(3467),
    [sym_preproc_nullable] = STATE(3467),
    [sym_preproc_error] = STATE(3467),
    [sym_preproc_define] = STATE(3467),
    [sym_preproc_undef] = STATE(3467),
    [sym__identifier_token] = ACTIONS(3835),
    [anon_sym_extern] = ACTIONS(3835),
    [anon_sym_alias] = ACTIONS(3835),
    [anon_sym_global] = ACTIONS(3835),
    [anon_sym_using] = ACTIONS(3835),
    [anon_sym_unsafe] = ACTIONS(3835),
    [anon_sym_static] = ACTIONS(3835),
    [anon_sym_LBRACK] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3837),
    [anon_sym_event] = ACTIONS(3835),
    [anon_sym_namespace] = ACTIONS(3835),
    [anon_sym_class] = ACTIONS(3835),
    [anon_sym_ref] = ACTIONS(3835),
    [anon_sym_struct] = ACTIONS(3835),
    [anon_sym_enum] = ACTIONS(3835),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_interface] = ACTIONS(3835),
    [anon_sym_delegate] = ACTIONS(3835),
    [anon_sym_record] = ACTIONS(3835),
    [anon_sym_abstract] = ACTIONS(3835),
    [anon_sym_async] = ACTIONS(3835),
    [anon_sym_const] = ACTIONS(3835),
    [anon_sym_file] = ACTIONS(3835),
    [anon_sym_fixed] = ACTIONS(3835),
    [anon_sym_internal] = ACTIONS(3835),
    [anon_sym_new] = ACTIONS(3835),
    [anon_sym_override] = ACTIONS(3835),
    [anon_sym_partial] = ACTIONS(3835),
    [anon_sym_private] = ACTIONS(3835),
    [anon_sym_protected] = ACTIONS(3835),
    [anon_sym_public] = ACTIONS(3835),
    [anon_sym_readonly] = ACTIONS(3835),
    [anon_sym_required] = ACTIONS(3835),
    [anon_sym_sealed] = ACTIONS(3835),
    [anon_sym_virtual] = ACTIONS(3835),
    [anon_sym_volatile] = ACTIONS(3835),
    [anon_sym_where] = ACTIONS(3835),
    [anon_sym_notnull] = ACTIONS(3835),
    [anon_sym_unmanaged] = ACTIONS(3835),
    [anon_sym_TILDE] = ACTIONS(3837),
    [anon_sym_implicit] = ACTIONS(3835),
    [anon_sym_explicit] = ACTIONS(3835),
    [anon_sym_scoped] = ACTIONS(3835),
    [anon_sym_var] = ACTIONS(3835),
    [sym_predefined_type] = ACTIONS(3835),
    [anon_sym_yield] = ACTIONS(3835),
    [anon_sym_when] = ACTIONS(3835),
    [anon_sym_from] = ACTIONS(3835),
    [anon_sym_into] = ACTIONS(3835),
    [anon_sym_join] = ACTIONS(3835),
    [anon_sym_on] = ACTIONS(3835),
    [anon_sym_equals] = ACTIONS(3835),
    [anon_sym_let] = ACTIONS(3835),
    [anon_sym_orderby] = ACTIONS(3835),
    [anon_sym_ascending] = ACTIONS(3835),
    [anon_sym_descending] = ACTIONS(3835),
    [anon_sym_group] = ACTIONS(3835),
    [anon_sym_by] = ACTIONS(3835),
    [anon_sym_select] = ACTIONS(3835),
    [aux_sym_preproc_if_token1] = ACTIONS(3837),
    [aux_sym_preproc_if_token3] = ACTIONS(3837),
    [aux_sym_preproc_else_token1] = ACTIONS(3837),
    [aux_sym_preproc_elif_token1] = ACTIONS(3837),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3468] = {
    [sym_preproc_region] = STATE(3468),
    [sym_preproc_endregion] = STATE(3468),
    [sym_preproc_line] = STATE(3468),
    [sym_preproc_pragma] = STATE(3468),
    [sym_preproc_nullable] = STATE(3468),
    [sym_preproc_error] = STATE(3468),
    [sym_preproc_define] = STATE(3468),
    [sym_preproc_undef] = STATE(3468),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4801),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_in] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(4804),
    [anon_sym_BANG] = ACTIONS(4804),
    [anon_sym_PLUS_PLUS] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4801),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(4804),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_CARET] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_GT_GT_GT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4801),
    [anon_sym_BANG_EQ] = ACTIONS(4801),
    [anon_sym_GT_EQ] = ACTIONS(4801),
    [anon_sym_LT_EQ] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(4801),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(4801),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE] = ACTIONS(4801),
    [anon_sym_QMARK_QMARK] = ACTIONS(4804),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(4801),
    [anon_sym_is] = ACTIONS(4801),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4801),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3469] = {
    [sym_preproc_region] = STATE(3469),
    [sym_preproc_endregion] = STATE(3469),
    [sym_preproc_line] = STATE(3469),
    [sym_preproc_pragma] = STATE(3469),
    [sym_preproc_nullable] = STATE(3469),
    [sym_preproc_error] = STATE(3469),
    [sym_preproc_define] = STATE(3469),
    [sym_preproc_undef] = STATE(3469),
    [sym__identifier_token] = ACTIONS(5079),
    [anon_sym_extern] = ACTIONS(5079),
    [anon_sym_alias] = ACTIONS(5079),
    [anon_sym_global] = ACTIONS(5079),
    [anon_sym_using] = ACTIONS(5079),
    [anon_sym_unsafe] = ACTIONS(5079),
    [anon_sym_static] = ACTIONS(5079),
    [anon_sym_LBRACK] = ACTIONS(5081),
    [anon_sym_LPAREN] = ACTIONS(5081),
    [anon_sym_event] = ACTIONS(5079),
    [anon_sym_namespace] = ACTIONS(5079),
    [anon_sym_class] = ACTIONS(5079),
    [anon_sym_ref] = ACTIONS(5079),
    [anon_sym_struct] = ACTIONS(5079),
    [anon_sym_enum] = ACTIONS(5079),
    [anon_sym_RBRACE] = ACTIONS(5081),
    [anon_sym_interface] = ACTIONS(5079),
    [anon_sym_delegate] = ACTIONS(5079),
    [anon_sym_record] = ACTIONS(5079),
    [anon_sym_abstract] = ACTIONS(5079),
    [anon_sym_async] = ACTIONS(5079),
    [anon_sym_const] = ACTIONS(5079),
    [anon_sym_file] = ACTIONS(5079),
    [anon_sym_fixed] = ACTIONS(5079),
    [anon_sym_internal] = ACTIONS(5079),
    [anon_sym_new] = ACTIONS(5079),
    [anon_sym_override] = ACTIONS(5079),
    [anon_sym_partial] = ACTIONS(5079),
    [anon_sym_private] = ACTIONS(5079),
    [anon_sym_protected] = ACTIONS(5079),
    [anon_sym_public] = ACTIONS(5079),
    [anon_sym_readonly] = ACTIONS(5079),
    [anon_sym_required] = ACTIONS(5079),
    [anon_sym_sealed] = ACTIONS(5079),
    [anon_sym_virtual] = ACTIONS(5079),
    [anon_sym_volatile] = ACTIONS(5079),
    [anon_sym_where] = ACTIONS(5079),
    [anon_sym_notnull] = ACTIONS(5079),
    [anon_sym_unmanaged] = ACTIONS(5079),
    [anon_sym_TILDE] = ACTIONS(5081),
    [anon_sym_implicit] = ACTIONS(5079),
    [anon_sym_explicit] = ACTIONS(5079),
    [anon_sym_scoped] = ACTIONS(5079),
    [anon_sym_var] = ACTIONS(5079),
    [sym_predefined_type] = ACTIONS(5079),
    [anon_sym_yield] = ACTIONS(5079),
    [anon_sym_when] = ACTIONS(5079),
    [anon_sym_from] = ACTIONS(5079),
    [anon_sym_into] = ACTIONS(5079),
    [anon_sym_join] = ACTIONS(5079),
    [anon_sym_on] = ACTIONS(5079),
    [anon_sym_equals] = ACTIONS(5079),
    [anon_sym_let] = ACTIONS(5079),
    [anon_sym_orderby] = ACTIONS(5079),
    [anon_sym_ascending] = ACTIONS(5079),
    [anon_sym_descending] = ACTIONS(5079),
    [anon_sym_group] = ACTIONS(5079),
    [anon_sym_by] = ACTIONS(5079),
    [anon_sym_select] = ACTIONS(5079),
    [aux_sym_preproc_if_token1] = ACTIONS(5081),
    [aux_sym_preproc_if_token3] = ACTIONS(5081),
    [aux_sym_preproc_else_token1] = ACTIONS(5081),
    [aux_sym_preproc_elif_token1] = ACTIONS(5081),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3470] = {
    [sym_preproc_region] = STATE(3470),
    [sym_preproc_endregion] = STATE(3470),
    [sym_preproc_line] = STATE(3470),
    [sym_preproc_pragma] = STATE(3470),
    [sym_preproc_nullable] = STATE(3470),
    [sym_preproc_error] = STATE(3470),
    [sym_preproc_define] = STATE(3470),
    [sym_preproc_undef] = STATE(3470),
    [sym__identifier_token] = ACTIONS(3855),
    [anon_sym_extern] = ACTIONS(3855),
    [anon_sym_alias] = ACTIONS(3855),
    [anon_sym_global] = ACTIONS(3855),
    [anon_sym_using] = ACTIONS(3855),
    [anon_sym_unsafe] = ACTIONS(3855),
    [anon_sym_static] = ACTIONS(3855),
    [anon_sym_LBRACK] = ACTIONS(3857),
    [anon_sym_LPAREN] = ACTIONS(3857),
    [anon_sym_event] = ACTIONS(3855),
    [anon_sym_namespace] = ACTIONS(3855),
    [anon_sym_class] = ACTIONS(3855),
    [anon_sym_ref] = ACTIONS(3855),
    [anon_sym_struct] = ACTIONS(3855),
    [anon_sym_enum] = ACTIONS(3855),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_interface] = ACTIONS(3855),
    [anon_sym_delegate] = ACTIONS(3855),
    [anon_sym_record] = ACTIONS(3855),
    [anon_sym_abstract] = ACTIONS(3855),
    [anon_sym_async] = ACTIONS(3855),
    [anon_sym_const] = ACTIONS(3855),
    [anon_sym_file] = ACTIONS(3855),
    [anon_sym_fixed] = ACTIONS(3855),
    [anon_sym_internal] = ACTIONS(3855),
    [anon_sym_new] = ACTIONS(3855),
    [anon_sym_override] = ACTIONS(3855),
    [anon_sym_partial] = ACTIONS(3855),
    [anon_sym_private] = ACTIONS(3855),
    [anon_sym_protected] = ACTIONS(3855),
    [anon_sym_public] = ACTIONS(3855),
    [anon_sym_readonly] = ACTIONS(3855),
    [anon_sym_required] = ACTIONS(3855),
    [anon_sym_sealed] = ACTIONS(3855),
    [anon_sym_virtual] = ACTIONS(3855),
    [anon_sym_volatile] = ACTIONS(3855),
    [anon_sym_where] = ACTIONS(3855),
    [anon_sym_notnull] = ACTIONS(3855),
    [anon_sym_unmanaged] = ACTIONS(3855),
    [anon_sym_TILDE] = ACTIONS(3857),
    [anon_sym_implicit] = ACTIONS(3855),
    [anon_sym_explicit] = ACTIONS(3855),
    [anon_sym_scoped] = ACTIONS(3855),
    [anon_sym_var] = ACTIONS(3855),
    [sym_predefined_type] = ACTIONS(3855),
    [anon_sym_yield] = ACTIONS(3855),
    [anon_sym_when] = ACTIONS(3855),
    [anon_sym_from] = ACTIONS(3855),
    [anon_sym_into] = ACTIONS(3855),
    [anon_sym_join] = ACTIONS(3855),
    [anon_sym_on] = ACTIONS(3855),
    [anon_sym_equals] = ACTIONS(3855),
    [anon_sym_let] = ACTIONS(3855),
    [anon_sym_orderby] = ACTIONS(3855),
    [anon_sym_ascending] = ACTIONS(3855),
    [anon_sym_descending] = ACTIONS(3855),
    [anon_sym_group] = ACTIONS(3855),
    [anon_sym_by] = ACTIONS(3855),
    [anon_sym_select] = ACTIONS(3855),
    [aux_sym_preproc_if_token1] = ACTIONS(3857),
    [aux_sym_preproc_if_token3] = ACTIONS(3857),
    [aux_sym_preproc_else_token1] = ACTIONS(3857),
    [aux_sym_preproc_elif_token1] = ACTIONS(3857),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3471] = {
    [sym_preproc_region] = STATE(3471),
    [sym_preproc_endregion] = STATE(3471),
    [sym_preproc_line] = STATE(3471),
    [sym_preproc_pragma] = STATE(3471),
    [sym_preproc_nullable] = STATE(3471),
    [sym_preproc_error] = STATE(3471),
    [sym_preproc_define] = STATE(3471),
    [sym_preproc_undef] = STATE(3471),
    [sym__identifier_token] = ACTIONS(5083),
    [anon_sym_extern] = ACTIONS(5083),
    [anon_sym_alias] = ACTIONS(5083),
    [anon_sym_global] = ACTIONS(5083),
    [anon_sym_using] = ACTIONS(5083),
    [anon_sym_unsafe] = ACTIONS(5083),
    [anon_sym_static] = ACTIONS(5083),
    [anon_sym_LBRACK] = ACTIONS(5085),
    [anon_sym_LPAREN] = ACTIONS(5085),
    [anon_sym_event] = ACTIONS(5083),
    [anon_sym_namespace] = ACTIONS(5083),
    [anon_sym_class] = ACTIONS(5083),
    [anon_sym_ref] = ACTIONS(5083),
    [anon_sym_struct] = ACTIONS(5083),
    [anon_sym_enum] = ACTIONS(5083),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_interface] = ACTIONS(5083),
    [anon_sym_delegate] = ACTIONS(5083),
    [anon_sym_record] = ACTIONS(5083),
    [anon_sym_abstract] = ACTIONS(5083),
    [anon_sym_async] = ACTIONS(5083),
    [anon_sym_const] = ACTIONS(5083),
    [anon_sym_file] = ACTIONS(5083),
    [anon_sym_fixed] = ACTIONS(5083),
    [anon_sym_internal] = ACTIONS(5083),
    [anon_sym_new] = ACTIONS(5083),
    [anon_sym_override] = ACTIONS(5083),
    [anon_sym_partial] = ACTIONS(5083),
    [anon_sym_private] = ACTIONS(5083),
    [anon_sym_protected] = ACTIONS(5083),
    [anon_sym_public] = ACTIONS(5083),
    [anon_sym_readonly] = ACTIONS(5083),
    [anon_sym_required] = ACTIONS(5083),
    [anon_sym_sealed] = ACTIONS(5083),
    [anon_sym_virtual] = ACTIONS(5083),
    [anon_sym_volatile] = ACTIONS(5083),
    [anon_sym_where] = ACTIONS(5083),
    [anon_sym_notnull] = ACTIONS(5083),
    [anon_sym_unmanaged] = ACTIONS(5083),
    [anon_sym_TILDE] = ACTIONS(5085),
    [anon_sym_implicit] = ACTIONS(5083),
    [anon_sym_explicit] = ACTIONS(5083),
    [anon_sym_scoped] = ACTIONS(5083),
    [anon_sym_var] = ACTIONS(5083),
    [sym_predefined_type] = ACTIONS(5083),
    [anon_sym_yield] = ACTIONS(5083),
    [anon_sym_when] = ACTIONS(5083),
    [anon_sym_from] = ACTIONS(5083),
    [anon_sym_into] = ACTIONS(5083),
    [anon_sym_join] = ACTIONS(5083),
    [anon_sym_on] = ACTIONS(5083),
    [anon_sym_equals] = ACTIONS(5083),
    [anon_sym_let] = ACTIONS(5083),
    [anon_sym_orderby] = ACTIONS(5083),
    [anon_sym_ascending] = ACTIONS(5083),
    [anon_sym_descending] = ACTIONS(5083),
    [anon_sym_group] = ACTIONS(5083),
    [anon_sym_by] = ACTIONS(5083),
    [anon_sym_select] = ACTIONS(5083),
    [aux_sym_preproc_if_token1] = ACTIONS(5085),
    [aux_sym_preproc_if_token3] = ACTIONS(5085),
    [aux_sym_preproc_else_token1] = ACTIONS(5085),
    [aux_sym_preproc_elif_token1] = ACTIONS(5085),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3472] = {
    [sym_preproc_region] = STATE(3472),
    [sym_preproc_endregion] = STATE(3472),
    [sym_preproc_line] = STATE(3472),
    [sym_preproc_pragma] = STATE(3472),
    [sym_preproc_nullable] = STATE(3472),
    [sym_preproc_error] = STATE(3472),
    [sym_preproc_define] = STATE(3472),
    [sym_preproc_undef] = STATE(3472),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4848),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4879),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4453),
  },
  [3473] = {
    [sym_preproc_region] = STATE(3473),
    [sym_preproc_endregion] = STATE(3473),
    [sym_preproc_line] = STATE(3473),
    [sym_preproc_pragma] = STATE(3473),
    [sym_preproc_nullable] = STATE(3473),
    [sym_preproc_error] = STATE(3473),
    [sym_preproc_define] = STATE(3473),
    [sym_preproc_undef] = STATE(3473),
    [sym__identifier_token] = ACTIONS(3859),
    [anon_sym_extern] = ACTIONS(3859),
    [anon_sym_alias] = ACTIONS(3859),
    [anon_sym_global] = ACTIONS(3859),
    [anon_sym_using] = ACTIONS(3859),
    [anon_sym_unsafe] = ACTIONS(3859),
    [anon_sym_static] = ACTIONS(3859),
    [anon_sym_LBRACK] = ACTIONS(3861),
    [anon_sym_LPAREN] = ACTIONS(3861),
    [anon_sym_event] = ACTIONS(3859),
    [anon_sym_namespace] = ACTIONS(3859),
    [anon_sym_class] = ACTIONS(3859),
    [anon_sym_ref] = ACTIONS(3859),
    [anon_sym_struct] = ACTIONS(3859),
    [anon_sym_enum] = ACTIONS(3859),
    [anon_sym_RBRACE] = ACTIONS(3861),
    [anon_sym_interface] = ACTIONS(3859),
    [anon_sym_delegate] = ACTIONS(3859),
    [anon_sym_record] = ACTIONS(3859),
    [anon_sym_abstract] = ACTIONS(3859),
    [anon_sym_async] = ACTIONS(3859),
    [anon_sym_const] = ACTIONS(3859),
    [anon_sym_file] = ACTIONS(3859),
    [anon_sym_fixed] = ACTIONS(3859),
    [anon_sym_internal] = ACTIONS(3859),
    [anon_sym_new] = ACTIONS(3859),
    [anon_sym_override] = ACTIONS(3859),
    [anon_sym_partial] = ACTIONS(3859),
    [anon_sym_private] = ACTIONS(3859),
    [anon_sym_protected] = ACTIONS(3859),
    [anon_sym_public] = ACTIONS(3859),
    [anon_sym_readonly] = ACTIONS(3859),
    [anon_sym_required] = ACTIONS(3859),
    [anon_sym_sealed] = ACTIONS(3859),
    [anon_sym_virtual] = ACTIONS(3859),
    [anon_sym_volatile] = ACTIONS(3859),
    [anon_sym_where] = ACTIONS(3859),
    [anon_sym_notnull] = ACTIONS(3859),
    [anon_sym_unmanaged] = ACTIONS(3859),
    [anon_sym_TILDE] = ACTIONS(3861),
    [anon_sym_implicit] = ACTIONS(3859),
    [anon_sym_explicit] = ACTIONS(3859),
    [anon_sym_scoped] = ACTIONS(3859),
    [anon_sym_var] = ACTIONS(3859),
    [sym_predefined_type] = ACTIONS(3859),
    [anon_sym_yield] = ACTIONS(3859),
    [anon_sym_when] = ACTIONS(3859),
    [anon_sym_from] = ACTIONS(3859),
    [anon_sym_into] = ACTIONS(3859),
    [anon_sym_join] = ACTIONS(3859),
    [anon_sym_on] = ACTIONS(3859),
    [anon_sym_equals] = ACTIONS(3859),
    [anon_sym_let] = ACTIONS(3859),
    [anon_sym_orderby] = ACTIONS(3859),
    [anon_sym_ascending] = ACTIONS(3859),
    [anon_sym_descending] = ACTIONS(3859),
    [anon_sym_group] = ACTIONS(3859),
    [anon_sym_by] = ACTIONS(3859),
    [anon_sym_select] = ACTIONS(3859),
    [aux_sym_preproc_if_token1] = ACTIONS(3861),
    [aux_sym_preproc_if_token3] = ACTIONS(3861),
    [aux_sym_preproc_else_token1] = ACTIONS(3861),
    [aux_sym_preproc_elif_token1] = ACTIONS(3861),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3474] = {
    [sym_preproc_region] = STATE(3474),
    [sym_preproc_endregion] = STATE(3474),
    [sym_preproc_line] = STATE(3474),
    [sym_preproc_pragma] = STATE(3474),
    [sym_preproc_nullable] = STATE(3474),
    [sym_preproc_error] = STATE(3474),
    [sym_preproc_define] = STATE(3474),
    [sym_preproc_undef] = STATE(3474),
    [sym__identifier_token] = ACTIONS(3941),
    [anon_sym_extern] = ACTIONS(3941),
    [anon_sym_alias] = ACTIONS(3941),
    [anon_sym_global] = ACTIONS(3941),
    [anon_sym_using] = ACTIONS(3941),
    [anon_sym_unsafe] = ACTIONS(3941),
    [anon_sym_static] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3943),
    [anon_sym_event] = ACTIONS(3941),
    [anon_sym_namespace] = ACTIONS(3941),
    [anon_sym_class] = ACTIONS(3941),
    [anon_sym_ref] = ACTIONS(3941),
    [anon_sym_struct] = ACTIONS(3941),
    [anon_sym_enum] = ACTIONS(3941),
    [anon_sym_RBRACE] = ACTIONS(3943),
    [anon_sym_interface] = ACTIONS(3941),
    [anon_sym_delegate] = ACTIONS(3941),
    [anon_sym_record] = ACTIONS(3941),
    [anon_sym_abstract] = ACTIONS(3941),
    [anon_sym_async] = ACTIONS(3941),
    [anon_sym_const] = ACTIONS(3941),
    [anon_sym_file] = ACTIONS(3941),
    [anon_sym_fixed] = ACTIONS(3941),
    [anon_sym_internal] = ACTIONS(3941),
    [anon_sym_new] = ACTIONS(3941),
    [anon_sym_override] = ACTIONS(3941),
    [anon_sym_partial] = ACTIONS(3941),
    [anon_sym_private] = ACTIONS(3941),
    [anon_sym_protected] = ACTIONS(3941),
    [anon_sym_public] = ACTIONS(3941),
    [anon_sym_readonly] = ACTIONS(3941),
    [anon_sym_required] = ACTIONS(3941),
    [anon_sym_sealed] = ACTIONS(3941),
    [anon_sym_virtual] = ACTIONS(3941),
    [anon_sym_volatile] = ACTIONS(3941),
    [anon_sym_where] = ACTIONS(3941),
    [anon_sym_notnull] = ACTIONS(3941),
    [anon_sym_unmanaged] = ACTIONS(3941),
    [anon_sym_TILDE] = ACTIONS(3943),
    [anon_sym_implicit] = ACTIONS(3941),
    [anon_sym_explicit] = ACTIONS(3941),
    [anon_sym_scoped] = ACTIONS(3941),
    [anon_sym_var] = ACTIONS(3941),
    [sym_predefined_type] = ACTIONS(3941),
    [anon_sym_yield] = ACTIONS(3941),
    [anon_sym_when] = ACTIONS(3941),
    [anon_sym_from] = ACTIONS(3941),
    [anon_sym_into] = ACTIONS(3941),
    [anon_sym_join] = ACTIONS(3941),
    [anon_sym_on] = ACTIONS(3941),
    [anon_sym_equals] = ACTIONS(3941),
    [anon_sym_let] = ACTIONS(3941),
    [anon_sym_orderby] = ACTIONS(3941),
    [anon_sym_ascending] = ACTIONS(3941),
    [anon_sym_descending] = ACTIONS(3941),
    [anon_sym_group] = ACTIONS(3941),
    [anon_sym_by] = ACTIONS(3941),
    [anon_sym_select] = ACTIONS(3941),
    [aux_sym_preproc_if_token1] = ACTIONS(3943),
    [aux_sym_preproc_if_token3] = ACTIONS(3943),
    [aux_sym_preproc_else_token1] = ACTIONS(3943),
    [aux_sym_preproc_elif_token1] = ACTIONS(3943),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3475] = {
    [sym_preproc_region] = STATE(3475),
    [sym_preproc_endregion] = STATE(3475),
    [sym_preproc_line] = STATE(3475),
    [sym_preproc_pragma] = STATE(3475),
    [sym_preproc_nullable] = STATE(3475),
    [sym_preproc_error] = STATE(3475),
    [sym_preproc_define] = STATE(3475),
    [sym_preproc_undef] = STATE(3475),
    [sym__identifier_token] = ACTIONS(3977),
    [anon_sym_extern] = ACTIONS(3977),
    [anon_sym_alias] = ACTIONS(3977),
    [anon_sym_global] = ACTIONS(3977),
    [anon_sym_using] = ACTIONS(3977),
    [anon_sym_unsafe] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LPAREN] = ACTIONS(3979),
    [anon_sym_event] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_ref] = ACTIONS(3977),
    [anon_sym_struct] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_delegate] = ACTIONS(3977),
    [anon_sym_record] = ACTIONS(3977),
    [anon_sym_abstract] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_file] = ACTIONS(3977),
    [anon_sym_fixed] = ACTIONS(3977),
    [anon_sym_internal] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_override] = ACTIONS(3977),
    [anon_sym_partial] = ACTIONS(3977),
    [anon_sym_private] = ACTIONS(3977),
    [anon_sym_protected] = ACTIONS(3977),
    [anon_sym_public] = ACTIONS(3977),
    [anon_sym_readonly] = ACTIONS(3977),
    [anon_sym_required] = ACTIONS(3977),
    [anon_sym_sealed] = ACTIONS(3977),
    [anon_sym_virtual] = ACTIONS(3977),
    [anon_sym_volatile] = ACTIONS(3977),
    [anon_sym_where] = ACTIONS(3977),
    [anon_sym_notnull] = ACTIONS(3977),
    [anon_sym_unmanaged] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3979),
    [anon_sym_implicit] = ACTIONS(3977),
    [anon_sym_explicit] = ACTIONS(3977),
    [anon_sym_scoped] = ACTIONS(3977),
    [anon_sym_var] = ACTIONS(3977),
    [sym_predefined_type] = ACTIONS(3977),
    [anon_sym_yield] = ACTIONS(3977),
    [anon_sym_when] = ACTIONS(3977),
    [anon_sym_from] = ACTIONS(3977),
    [anon_sym_into] = ACTIONS(3977),
    [anon_sym_join] = ACTIONS(3977),
    [anon_sym_on] = ACTIONS(3977),
    [anon_sym_equals] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_orderby] = ACTIONS(3977),
    [anon_sym_ascending] = ACTIONS(3977),
    [anon_sym_descending] = ACTIONS(3977),
    [anon_sym_group] = ACTIONS(3977),
    [anon_sym_by] = ACTIONS(3977),
    [anon_sym_select] = ACTIONS(3977),
    [aux_sym_preproc_if_token1] = ACTIONS(3979),
    [aux_sym_preproc_if_token3] = ACTIONS(3979),
    [aux_sym_preproc_else_token1] = ACTIONS(3979),
    [aux_sym_preproc_elif_token1] = ACTIONS(3979),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3476] = {
    [sym__variable_designation] = STATE(4213),
    [sym_parenthesized_variable_designation] = STATE(4227),
    [sym_identifier] = STATE(4223),
    [sym__reserved_identifier] = STATE(3936),
    [sym_preproc_region] = STATE(3476),
    [sym_preproc_endregion] = STATE(3476),
    [sym_preproc_line] = STATE(3476),
    [sym_preproc_pragma] = STATE(3476),
    [sym_preproc_nullable] = STATE(3476),
    [sym_preproc_error] = STATE(3476),
    [sym_preproc_define] = STATE(3476),
    [sym_preproc_undef] = STATE(3476),
    [sym__identifier_token] = ACTIONS(4335),
    [anon_sym_alias] = ACTIONS(4337),
    [anon_sym_global] = ACTIONS(4337),
    [anon_sym_LBRACK] = ACTIONS(4395),
    [anon_sym_LPAREN] = ACTIONS(4395),
    [anon_sym_file] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(4397),
    [anon_sym_GT] = ACTIONS(4397),
    [anon_sym_where] = ACTIONS(4337),
    [anon_sym_QMARK] = ACTIONS(4397),
    [anon_sym_notnull] = ACTIONS(4337),
    [anon_sym_unmanaged] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4397),
    [anon_sym_PLUS_PLUS] = ACTIONS(4395),
    [anon_sym_DASH_DASH] = ACTIONS(4395),
    [anon_sym_PLUS] = ACTIONS(4397),
    [anon_sym_DASH] = ACTIONS(4397),
    [anon_sym_STAR] = ACTIONS(4395),
    [anon_sym_SLASH] = ACTIONS(4397),
    [anon_sym_PERCENT] = ACTIONS(4395),
    [anon_sym_CARET] = ACTIONS(4395),
    [anon_sym_PIPE] = ACTIONS(4397),
    [anon_sym_AMP] = ACTIONS(4397),
    [anon_sym_LT_LT] = ACTIONS(4395),
    [anon_sym_GT_GT] = ACTIONS(4397),
    [anon_sym_GT_GT_GT] = ACTIONS(4395),
    [anon_sym_EQ_EQ] = ACTIONS(4395),
    [anon_sym_BANG_EQ] = ACTIONS(4395),
    [anon_sym_GT_EQ] = ACTIONS(4395),
    [anon_sym_LT_EQ] = ACTIONS(4395),
    [anon_sym_DOT] = ACTIONS(4397),
    [anon_sym_scoped] = ACTIONS(4337),
    [anon_sym_var] = ACTIONS(4337),
    [anon_sym_yield] = ACTIONS(4337),
    [anon_sym_switch] = ACTIONS(4397),
    [anon_sym_when] = ACTIONS(4337),
    [sym_discard] = ACTIONS(4357),
    [anon_sym_DOT_DOT] = ACTIONS(4395),
    [anon_sym_and] = ACTIONS(4397),
    [anon_sym_or] = ACTIONS(4397),
    [anon_sym_AMP_AMP] = ACTIONS(4395),
    [anon_sym_PIPE_PIPE] = ACTIONS(4395),
    [anon_sym_QMARK_QMARK] = ACTIONS(4395),
    [anon_sym_from] = ACTIONS(4337),
    [anon_sym_into] = ACTIONS(4337),
    [anon_sym_join] = ACTIONS(4337),
    [anon_sym_on] = ACTIONS(4337),
    [anon_sym_equals] = ACTIONS(4337),
    [anon_sym_let] = ACTIONS(4337),
    [anon_sym_orderby] = ACTIONS(4337),
    [anon_sym_ascending] = ACTIONS(4337),
    [anon_sym_descending] = ACTIONS(4337),
    [anon_sym_group] = ACTIONS(4337),
    [anon_sym_by] = ACTIONS(4397),
    [anon_sym_select] = ACTIONS(4337),
    [anon_sym_as] = ACTIONS(4397),
    [anon_sym_is] = ACTIONS(4397),
    [anon_sym_DASH_GT] = ACTIONS(4395),
    [anon_sym_with] = ACTIONS(4397),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3477] = {
    [sym_preproc_region] = STATE(3477),
    [sym_preproc_endregion] = STATE(3477),
    [sym_preproc_line] = STATE(3477),
    [sym_preproc_pragma] = STATE(3477),
    [sym_preproc_nullable] = STATE(3477),
    [sym_preproc_error] = STATE(3477),
    [sym_preproc_define] = STATE(3477),
    [sym_preproc_undef] = STATE(3477),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_in] = ACTIONS(4650),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_EQ_GT] = ACTIONS(4650),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_when] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4650),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_on] = ACTIONS(4650),
    [anon_sym_equals] = ACTIONS(4650),
    [anon_sym_by] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4650),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_if_token3] = ACTIONS(4650),
    [aux_sym_preproc_else_token1] = ACTIONS(4650),
    [aux_sym_preproc_elif_token1] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3478] = {
    [sym_preproc_region] = STATE(3478),
    [sym_preproc_endregion] = STATE(3478),
    [sym_preproc_line] = STATE(3478),
    [sym_preproc_pragma] = STATE(3478),
    [sym_preproc_nullable] = STATE(3478),
    [sym_preproc_error] = STATE(3478),
    [sym_preproc_define] = STATE(3478),
    [sym_preproc_undef] = STATE(3478),
    [sym__identifier_token] = ACTIONS(3981),
    [anon_sym_extern] = ACTIONS(3981),
    [anon_sym_alias] = ACTIONS(3981),
    [anon_sym_global] = ACTIONS(3981),
    [anon_sym_using] = ACTIONS(3981),
    [anon_sym_unsafe] = ACTIONS(3981),
    [anon_sym_static] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3983),
    [anon_sym_event] = ACTIONS(3981),
    [anon_sym_namespace] = ACTIONS(3981),
    [anon_sym_class] = ACTIONS(3981),
    [anon_sym_ref] = ACTIONS(3981),
    [anon_sym_struct] = ACTIONS(3981),
    [anon_sym_enum] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_interface] = ACTIONS(3981),
    [anon_sym_delegate] = ACTIONS(3981),
    [anon_sym_record] = ACTIONS(3981),
    [anon_sym_abstract] = ACTIONS(3981),
    [anon_sym_async] = ACTIONS(3981),
    [anon_sym_const] = ACTIONS(3981),
    [anon_sym_file] = ACTIONS(3981),
    [anon_sym_fixed] = ACTIONS(3981),
    [anon_sym_internal] = ACTIONS(3981),
    [anon_sym_new] = ACTIONS(3981),
    [anon_sym_override] = ACTIONS(3981),
    [anon_sym_partial] = ACTIONS(3981),
    [anon_sym_private] = ACTIONS(3981),
    [anon_sym_protected] = ACTIONS(3981),
    [anon_sym_public] = ACTIONS(3981),
    [anon_sym_readonly] = ACTIONS(3981),
    [anon_sym_required] = ACTIONS(3981),
    [anon_sym_sealed] = ACTIONS(3981),
    [anon_sym_virtual] = ACTIONS(3981),
    [anon_sym_volatile] = ACTIONS(3981),
    [anon_sym_where] = ACTIONS(3981),
    [anon_sym_notnull] = ACTIONS(3981),
    [anon_sym_unmanaged] = ACTIONS(3981),
    [anon_sym_TILDE] = ACTIONS(3983),
    [anon_sym_implicit] = ACTIONS(3981),
    [anon_sym_explicit] = ACTIONS(3981),
    [anon_sym_scoped] = ACTIONS(3981),
    [anon_sym_var] = ACTIONS(3981),
    [sym_predefined_type] = ACTIONS(3981),
    [anon_sym_yield] = ACTIONS(3981),
    [anon_sym_when] = ACTIONS(3981),
    [anon_sym_from] = ACTIONS(3981),
    [anon_sym_into] = ACTIONS(3981),
    [anon_sym_join] = ACTIONS(3981),
    [anon_sym_on] = ACTIONS(3981),
    [anon_sym_equals] = ACTIONS(3981),
    [anon_sym_let] = ACTIONS(3981),
    [anon_sym_orderby] = ACTIONS(3981),
    [anon_sym_ascending] = ACTIONS(3981),
    [anon_sym_descending] = ACTIONS(3981),
    [anon_sym_group] = ACTIONS(3981),
    [anon_sym_by] = ACTIONS(3981),
    [anon_sym_select] = ACTIONS(3981),
    [aux_sym_preproc_if_token1] = ACTIONS(3983),
    [aux_sym_preproc_if_token3] = ACTIONS(3983),
    [aux_sym_preproc_else_token1] = ACTIONS(3983),
    [aux_sym_preproc_elif_token1] = ACTIONS(3983),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3479] = {
    [sym_preproc_region] = STATE(3479),
    [sym_preproc_endregion] = STATE(3479),
    [sym_preproc_line] = STATE(3479),
    [sym_preproc_pragma] = STATE(3479),
    [sym_preproc_nullable] = STATE(3479),
    [sym_preproc_error] = STATE(3479),
    [sym_preproc_define] = STATE(3479),
    [sym_preproc_undef] = STATE(3479),
    [sym__identifier_token] = ACTIONS(3953),
    [anon_sym_extern] = ACTIONS(3953),
    [anon_sym_alias] = ACTIONS(3953),
    [anon_sym_global] = ACTIONS(3953),
    [anon_sym_using] = ACTIONS(3953),
    [anon_sym_unsafe] = ACTIONS(3953),
    [anon_sym_static] = ACTIONS(3953),
    [anon_sym_LBRACK] = ACTIONS(3955),
    [anon_sym_LPAREN] = ACTIONS(3955),
    [anon_sym_event] = ACTIONS(3953),
    [anon_sym_namespace] = ACTIONS(3953),
    [anon_sym_class] = ACTIONS(3953),
    [anon_sym_ref] = ACTIONS(3953),
    [anon_sym_struct] = ACTIONS(3953),
    [anon_sym_enum] = ACTIONS(3953),
    [anon_sym_RBRACE] = ACTIONS(3955),
    [anon_sym_interface] = ACTIONS(3953),
    [anon_sym_delegate] = ACTIONS(3953),
    [anon_sym_record] = ACTIONS(3953),
    [anon_sym_abstract] = ACTIONS(3953),
    [anon_sym_async] = ACTIONS(3953),
    [anon_sym_const] = ACTIONS(3953),
    [anon_sym_file] = ACTIONS(3953),
    [anon_sym_fixed] = ACTIONS(3953),
    [anon_sym_internal] = ACTIONS(3953),
    [anon_sym_new] = ACTIONS(3953),
    [anon_sym_override] = ACTIONS(3953),
    [anon_sym_partial] = ACTIONS(3953),
    [anon_sym_private] = ACTIONS(3953),
    [anon_sym_protected] = ACTIONS(3953),
    [anon_sym_public] = ACTIONS(3953),
    [anon_sym_readonly] = ACTIONS(3953),
    [anon_sym_required] = ACTIONS(3953),
    [anon_sym_sealed] = ACTIONS(3953),
    [anon_sym_virtual] = ACTIONS(3953),
    [anon_sym_volatile] = ACTIONS(3953),
    [anon_sym_where] = ACTIONS(3953),
    [anon_sym_notnull] = ACTIONS(3953),
    [anon_sym_unmanaged] = ACTIONS(3953),
    [anon_sym_TILDE] = ACTIONS(3955),
    [anon_sym_implicit] = ACTIONS(3953),
    [anon_sym_explicit] = ACTIONS(3953),
    [anon_sym_scoped] = ACTIONS(3953),
    [anon_sym_var] = ACTIONS(3953),
    [sym_predefined_type] = ACTIONS(3953),
    [anon_sym_yield] = ACTIONS(3953),
    [anon_sym_when] = ACTIONS(3953),
    [anon_sym_from] = ACTIONS(3953),
    [anon_sym_into] = ACTIONS(3953),
    [anon_sym_join] = ACTIONS(3953),
    [anon_sym_on] = ACTIONS(3953),
    [anon_sym_equals] = ACTIONS(3953),
    [anon_sym_let] = ACTIONS(3953),
    [anon_sym_orderby] = ACTIONS(3953),
    [anon_sym_ascending] = ACTIONS(3953),
    [anon_sym_descending] = ACTIONS(3953),
    [anon_sym_group] = ACTIONS(3953),
    [anon_sym_by] = ACTIONS(3953),
    [anon_sym_select] = ACTIONS(3953),
    [aux_sym_preproc_if_token1] = ACTIONS(3955),
    [aux_sym_preproc_if_token3] = ACTIONS(3955),
    [aux_sym_preproc_else_token1] = ACTIONS(3955),
    [aux_sym_preproc_elif_token1] = ACTIONS(3955),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3480] = {
    [sym_preproc_region] = STATE(3480),
    [sym_preproc_endregion] = STATE(3480),
    [sym_preproc_line] = STATE(3480),
    [sym_preproc_pragma] = STATE(3480),
    [sym_preproc_nullable] = STATE(3480),
    [sym_preproc_error] = STATE(3480),
    [sym_preproc_define] = STATE(3480),
    [sym_preproc_undef] = STATE(3480),
    [sym__identifier_token] = ACTIONS(3973),
    [anon_sym_extern] = ACTIONS(3973),
    [anon_sym_alias] = ACTIONS(3973),
    [anon_sym_global] = ACTIONS(3973),
    [anon_sym_using] = ACTIONS(3973),
    [anon_sym_unsafe] = ACTIONS(3973),
    [anon_sym_static] = ACTIONS(3973),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [anon_sym_LPAREN] = ACTIONS(3975),
    [anon_sym_event] = ACTIONS(3973),
    [anon_sym_namespace] = ACTIONS(3973),
    [anon_sym_class] = ACTIONS(3973),
    [anon_sym_ref] = ACTIONS(3973),
    [anon_sym_struct] = ACTIONS(3973),
    [anon_sym_enum] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_interface] = ACTIONS(3973),
    [anon_sym_delegate] = ACTIONS(3973),
    [anon_sym_record] = ACTIONS(3973),
    [anon_sym_abstract] = ACTIONS(3973),
    [anon_sym_async] = ACTIONS(3973),
    [anon_sym_const] = ACTIONS(3973),
    [anon_sym_file] = ACTIONS(3973),
    [anon_sym_fixed] = ACTIONS(3973),
    [anon_sym_internal] = ACTIONS(3973),
    [anon_sym_new] = ACTIONS(3973),
    [anon_sym_override] = ACTIONS(3973),
    [anon_sym_partial] = ACTIONS(3973),
    [anon_sym_private] = ACTIONS(3973),
    [anon_sym_protected] = ACTIONS(3973),
    [anon_sym_public] = ACTIONS(3973),
    [anon_sym_readonly] = ACTIONS(3973),
    [anon_sym_required] = ACTIONS(3973),
    [anon_sym_sealed] = ACTIONS(3973),
    [anon_sym_virtual] = ACTIONS(3973),
    [anon_sym_volatile] = ACTIONS(3973),
    [anon_sym_where] = ACTIONS(3973),
    [anon_sym_notnull] = ACTIONS(3973),
    [anon_sym_unmanaged] = ACTIONS(3973),
    [anon_sym_TILDE] = ACTIONS(3975),
    [anon_sym_implicit] = ACTIONS(3973),
    [anon_sym_explicit] = ACTIONS(3973),
    [anon_sym_scoped] = ACTIONS(3973),
    [anon_sym_var] = ACTIONS(3973),
    [sym_predefined_type] = ACTIONS(3973),
    [anon_sym_yield] = ACTIONS(3973),
    [anon_sym_when] = ACTIONS(3973),
    [anon_sym_from] = ACTIONS(3973),
    [anon_sym_into] = ACTIONS(3973),
    [anon_sym_join] = ACTIONS(3973),
    [anon_sym_on] = ACTIONS(3973),
    [anon_sym_equals] = ACTIONS(3973),
    [anon_sym_let] = ACTIONS(3973),
    [anon_sym_orderby] = ACTIONS(3973),
    [anon_sym_ascending] = ACTIONS(3973),
    [anon_sym_descending] = ACTIONS(3973),
    [anon_sym_group] = ACTIONS(3973),
    [anon_sym_by] = ACTIONS(3973),
    [anon_sym_select] = ACTIONS(3973),
    [aux_sym_preproc_if_token1] = ACTIONS(3975),
    [aux_sym_preproc_if_token3] = ACTIONS(3975),
    [aux_sym_preproc_else_token1] = ACTIONS(3975),
    [aux_sym_preproc_elif_token1] = ACTIONS(3975),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3481] = {
    [sym_preproc_region] = STATE(3481),
    [sym_preproc_endregion] = STATE(3481),
    [sym_preproc_line] = STATE(3481),
    [sym_preproc_pragma] = STATE(3481),
    [sym_preproc_nullable] = STATE(3481),
    [sym_preproc_error] = STATE(3481),
    [sym_preproc_define] = STATE(3481),
    [sym_preproc_undef] = STATE(3481),
    [sym__identifier_token] = ACTIONS(3969),
    [anon_sym_extern] = ACTIONS(3969),
    [anon_sym_alias] = ACTIONS(3969),
    [anon_sym_global] = ACTIONS(3969),
    [anon_sym_using] = ACTIONS(3969),
    [anon_sym_unsafe] = ACTIONS(3969),
    [anon_sym_static] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_event] = ACTIONS(3969),
    [anon_sym_namespace] = ACTIONS(3969),
    [anon_sym_class] = ACTIONS(3969),
    [anon_sym_ref] = ACTIONS(3969),
    [anon_sym_struct] = ACTIONS(3969),
    [anon_sym_enum] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3969),
    [anon_sym_delegate] = ACTIONS(3969),
    [anon_sym_record] = ACTIONS(3969),
    [anon_sym_abstract] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_const] = ACTIONS(3969),
    [anon_sym_file] = ACTIONS(3969),
    [anon_sym_fixed] = ACTIONS(3969),
    [anon_sym_internal] = ACTIONS(3969),
    [anon_sym_new] = ACTIONS(3969),
    [anon_sym_override] = ACTIONS(3969),
    [anon_sym_partial] = ACTIONS(3969),
    [anon_sym_private] = ACTIONS(3969),
    [anon_sym_protected] = ACTIONS(3969),
    [anon_sym_public] = ACTIONS(3969),
    [anon_sym_readonly] = ACTIONS(3969),
    [anon_sym_required] = ACTIONS(3969),
    [anon_sym_sealed] = ACTIONS(3969),
    [anon_sym_virtual] = ACTIONS(3969),
    [anon_sym_volatile] = ACTIONS(3969),
    [anon_sym_where] = ACTIONS(3969),
    [anon_sym_notnull] = ACTIONS(3969),
    [anon_sym_unmanaged] = ACTIONS(3969),
    [anon_sym_TILDE] = ACTIONS(3971),
    [anon_sym_implicit] = ACTIONS(3969),
    [anon_sym_explicit] = ACTIONS(3969),
    [anon_sym_scoped] = ACTIONS(3969),
    [anon_sym_var] = ACTIONS(3969),
    [sym_predefined_type] = ACTIONS(3969),
    [anon_sym_yield] = ACTIONS(3969),
    [anon_sym_when] = ACTIONS(3969),
    [anon_sym_from] = ACTIONS(3969),
    [anon_sym_into] = ACTIONS(3969),
    [anon_sym_join] = ACTIONS(3969),
    [anon_sym_on] = ACTIONS(3969),
    [anon_sym_equals] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3969),
    [anon_sym_orderby] = ACTIONS(3969),
    [anon_sym_ascending] = ACTIONS(3969),
    [anon_sym_descending] = ACTIONS(3969),
    [anon_sym_group] = ACTIONS(3969),
    [anon_sym_by] = ACTIONS(3969),
    [anon_sym_select] = ACTIONS(3969),
    [aux_sym_preproc_if_token1] = ACTIONS(3971),
    [aux_sym_preproc_if_token3] = ACTIONS(3971),
    [aux_sym_preproc_else_token1] = ACTIONS(3971),
    [aux_sym_preproc_elif_token1] = ACTIONS(3971),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3482] = {
    [sym_preproc_region] = STATE(3482),
    [sym_preproc_endregion] = STATE(3482),
    [sym_preproc_line] = STATE(3482),
    [sym_preproc_pragma] = STATE(3482),
    [sym_preproc_nullable] = STATE(3482),
    [sym_preproc_error] = STATE(3482),
    [sym_preproc_define] = STATE(3482),
    [sym_preproc_undef] = STATE(3482),
    [sym__identifier_token] = ACTIONS(3965),
    [anon_sym_extern] = ACTIONS(3965),
    [anon_sym_alias] = ACTIONS(3965),
    [anon_sym_global] = ACTIONS(3965),
    [anon_sym_using] = ACTIONS(3965),
    [anon_sym_unsafe] = ACTIONS(3965),
    [anon_sym_static] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3967),
    [anon_sym_event] = ACTIONS(3965),
    [anon_sym_namespace] = ACTIONS(3965),
    [anon_sym_class] = ACTIONS(3965),
    [anon_sym_ref] = ACTIONS(3965),
    [anon_sym_struct] = ACTIONS(3965),
    [anon_sym_enum] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3967),
    [anon_sym_interface] = ACTIONS(3965),
    [anon_sym_delegate] = ACTIONS(3965),
    [anon_sym_record] = ACTIONS(3965),
    [anon_sym_abstract] = ACTIONS(3965),
    [anon_sym_async] = ACTIONS(3965),
    [anon_sym_const] = ACTIONS(3965),
    [anon_sym_file] = ACTIONS(3965),
    [anon_sym_fixed] = ACTIONS(3965),
    [anon_sym_internal] = ACTIONS(3965),
    [anon_sym_new] = ACTIONS(3965),
    [anon_sym_override] = ACTIONS(3965),
    [anon_sym_partial] = ACTIONS(3965),
    [anon_sym_private] = ACTIONS(3965),
    [anon_sym_protected] = ACTIONS(3965),
    [anon_sym_public] = ACTIONS(3965),
    [anon_sym_readonly] = ACTIONS(3965),
    [anon_sym_required] = ACTIONS(3965),
    [anon_sym_sealed] = ACTIONS(3965),
    [anon_sym_virtual] = ACTIONS(3965),
    [anon_sym_volatile] = ACTIONS(3965),
    [anon_sym_where] = ACTIONS(3965),
    [anon_sym_notnull] = ACTIONS(3965),
    [anon_sym_unmanaged] = ACTIONS(3965),
    [anon_sym_TILDE] = ACTIONS(3967),
    [anon_sym_implicit] = ACTIONS(3965),
    [anon_sym_explicit] = ACTIONS(3965),
    [anon_sym_scoped] = ACTIONS(3965),
    [anon_sym_var] = ACTIONS(3965),
    [sym_predefined_type] = ACTIONS(3965),
    [anon_sym_yield] = ACTIONS(3965),
    [anon_sym_when] = ACTIONS(3965),
    [anon_sym_from] = ACTIONS(3965),
    [anon_sym_into] = ACTIONS(3965),
    [anon_sym_join] = ACTIONS(3965),
    [anon_sym_on] = ACTIONS(3965),
    [anon_sym_equals] = ACTIONS(3965),
    [anon_sym_let] = ACTIONS(3965),
    [anon_sym_orderby] = ACTIONS(3965),
    [anon_sym_ascending] = ACTIONS(3965),
    [anon_sym_descending] = ACTIONS(3965),
    [anon_sym_group] = ACTIONS(3965),
    [anon_sym_by] = ACTIONS(3965),
    [anon_sym_select] = ACTIONS(3965),
    [aux_sym_preproc_if_token1] = ACTIONS(3967),
    [aux_sym_preproc_if_token3] = ACTIONS(3967),
    [aux_sym_preproc_else_token1] = ACTIONS(3967),
    [aux_sym_preproc_elif_token1] = ACTIONS(3967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3483] = {
    [sym_preproc_region] = STATE(3483),
    [sym_preproc_endregion] = STATE(3483),
    [sym_preproc_line] = STATE(3483),
    [sym_preproc_pragma] = STATE(3483),
    [sym_preproc_nullable] = STATE(3483),
    [sym_preproc_error] = STATE(3483),
    [sym_preproc_define] = STATE(3483),
    [sym_preproc_undef] = STATE(3483),
    [sym__identifier_token] = ACTIONS(5087),
    [anon_sym_extern] = ACTIONS(5087),
    [anon_sym_alias] = ACTIONS(5087),
    [anon_sym_global] = ACTIONS(5087),
    [anon_sym_using] = ACTIONS(5087),
    [anon_sym_unsafe] = ACTIONS(5087),
    [anon_sym_static] = ACTIONS(5087),
    [anon_sym_LBRACK] = ACTIONS(5089),
    [anon_sym_LPAREN] = ACTIONS(5089),
    [anon_sym_event] = ACTIONS(5087),
    [anon_sym_namespace] = ACTIONS(5087),
    [anon_sym_class] = ACTIONS(5087),
    [anon_sym_ref] = ACTIONS(5087),
    [anon_sym_struct] = ACTIONS(5087),
    [anon_sym_enum] = ACTIONS(5087),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_interface] = ACTIONS(5087),
    [anon_sym_delegate] = ACTIONS(5087),
    [anon_sym_record] = ACTIONS(5087),
    [anon_sym_abstract] = ACTIONS(5087),
    [anon_sym_async] = ACTIONS(5087),
    [anon_sym_const] = ACTIONS(5087),
    [anon_sym_file] = ACTIONS(5087),
    [anon_sym_fixed] = ACTIONS(5087),
    [anon_sym_internal] = ACTIONS(5087),
    [anon_sym_new] = ACTIONS(5087),
    [anon_sym_override] = ACTIONS(5087),
    [anon_sym_partial] = ACTIONS(5087),
    [anon_sym_private] = ACTIONS(5087),
    [anon_sym_protected] = ACTIONS(5087),
    [anon_sym_public] = ACTIONS(5087),
    [anon_sym_readonly] = ACTIONS(5087),
    [anon_sym_required] = ACTIONS(5087),
    [anon_sym_sealed] = ACTIONS(5087),
    [anon_sym_virtual] = ACTIONS(5087),
    [anon_sym_volatile] = ACTIONS(5087),
    [anon_sym_where] = ACTIONS(5087),
    [anon_sym_notnull] = ACTIONS(5087),
    [anon_sym_unmanaged] = ACTIONS(5087),
    [anon_sym_TILDE] = ACTIONS(5089),
    [anon_sym_implicit] = ACTIONS(5087),
    [anon_sym_explicit] = ACTIONS(5087),
    [anon_sym_scoped] = ACTIONS(5087),
    [anon_sym_var] = ACTIONS(5087),
    [sym_predefined_type] = ACTIONS(5087),
    [anon_sym_yield] = ACTIONS(5087),
    [anon_sym_when] = ACTIONS(5087),
    [anon_sym_from] = ACTIONS(5087),
    [anon_sym_into] = ACTIONS(5087),
    [anon_sym_join] = ACTIONS(5087),
    [anon_sym_on] = ACTIONS(5087),
    [anon_sym_equals] = ACTIONS(5087),
    [anon_sym_let] = ACTIONS(5087),
    [anon_sym_orderby] = ACTIONS(5087),
    [anon_sym_ascending] = ACTIONS(5087),
    [anon_sym_descending] = ACTIONS(5087),
    [anon_sym_group] = ACTIONS(5087),
    [anon_sym_by] = ACTIONS(5087),
    [anon_sym_select] = ACTIONS(5087),
    [aux_sym_preproc_if_token1] = ACTIONS(5089),
    [aux_sym_preproc_if_token3] = ACTIONS(5089),
    [aux_sym_preproc_else_token1] = ACTIONS(5089),
    [aux_sym_preproc_elif_token1] = ACTIONS(5089),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3484] = {
    [sym_preproc_region] = STATE(3484),
    [sym_preproc_endregion] = STATE(3484),
    [sym_preproc_line] = STATE(3484),
    [sym_preproc_pragma] = STATE(3484),
    [sym_preproc_nullable] = STATE(3484),
    [sym_preproc_error] = STATE(3484),
    [sym_preproc_define] = STATE(3484),
    [sym_preproc_undef] = STATE(3484),
    [sym__identifier_token] = ACTIONS(5091),
    [anon_sym_extern] = ACTIONS(5091),
    [anon_sym_alias] = ACTIONS(5091),
    [anon_sym_global] = ACTIONS(5091),
    [anon_sym_using] = ACTIONS(5091),
    [anon_sym_unsafe] = ACTIONS(5091),
    [anon_sym_static] = ACTIONS(5091),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_LPAREN] = ACTIONS(5093),
    [anon_sym_event] = ACTIONS(5091),
    [anon_sym_namespace] = ACTIONS(5091),
    [anon_sym_class] = ACTIONS(5091),
    [anon_sym_ref] = ACTIONS(5091),
    [anon_sym_struct] = ACTIONS(5091),
    [anon_sym_enum] = ACTIONS(5091),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_interface] = ACTIONS(5091),
    [anon_sym_delegate] = ACTIONS(5091),
    [anon_sym_record] = ACTIONS(5091),
    [anon_sym_abstract] = ACTIONS(5091),
    [anon_sym_async] = ACTIONS(5091),
    [anon_sym_const] = ACTIONS(5091),
    [anon_sym_file] = ACTIONS(5091),
    [anon_sym_fixed] = ACTIONS(5091),
    [anon_sym_internal] = ACTIONS(5091),
    [anon_sym_new] = ACTIONS(5091),
    [anon_sym_override] = ACTIONS(5091),
    [anon_sym_partial] = ACTIONS(5091),
    [anon_sym_private] = ACTIONS(5091),
    [anon_sym_protected] = ACTIONS(5091),
    [anon_sym_public] = ACTIONS(5091),
    [anon_sym_readonly] = ACTIONS(5091),
    [anon_sym_required] = ACTIONS(5091),
    [anon_sym_sealed] = ACTIONS(5091),
    [anon_sym_virtual] = ACTIONS(5091),
    [anon_sym_volatile] = ACTIONS(5091),
    [anon_sym_where] = ACTIONS(5091),
    [anon_sym_notnull] = ACTIONS(5091),
    [anon_sym_unmanaged] = ACTIONS(5091),
    [anon_sym_TILDE] = ACTIONS(5093),
    [anon_sym_implicit] = ACTIONS(5091),
    [anon_sym_explicit] = ACTIONS(5091),
    [anon_sym_scoped] = ACTIONS(5091),
    [anon_sym_var] = ACTIONS(5091),
    [sym_predefined_type] = ACTIONS(5091),
    [anon_sym_yield] = ACTIONS(5091),
    [anon_sym_when] = ACTIONS(5091),
    [anon_sym_from] = ACTIONS(5091),
    [anon_sym_into] = ACTIONS(5091),
    [anon_sym_join] = ACTIONS(5091),
    [anon_sym_on] = ACTIONS(5091),
    [anon_sym_equals] = ACTIONS(5091),
    [anon_sym_let] = ACTIONS(5091),
    [anon_sym_orderby] = ACTIONS(5091),
    [anon_sym_ascending] = ACTIONS(5091),
    [anon_sym_descending] = ACTIONS(5091),
    [anon_sym_group] = ACTIONS(5091),
    [anon_sym_by] = ACTIONS(5091),
    [anon_sym_select] = ACTIONS(5091),
    [aux_sym_preproc_if_token1] = ACTIONS(5093),
    [aux_sym_preproc_if_token3] = ACTIONS(5093),
    [aux_sym_preproc_else_token1] = ACTIONS(5093),
    [aux_sym_preproc_elif_token1] = ACTIONS(5093),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3485] = {
    [sym_preproc_region] = STATE(3485),
    [sym_preproc_endregion] = STATE(3485),
    [sym_preproc_line] = STATE(3485),
    [sym_preproc_pragma] = STATE(3485),
    [sym_preproc_nullable] = STATE(3485),
    [sym_preproc_error] = STATE(3485),
    [sym_preproc_define] = STATE(3485),
    [sym_preproc_undef] = STATE(3485),
    [sym__identifier_token] = ACTIONS(5095),
    [anon_sym_extern] = ACTIONS(5095),
    [anon_sym_alias] = ACTIONS(5095),
    [anon_sym_global] = ACTIONS(5095),
    [anon_sym_using] = ACTIONS(5095),
    [anon_sym_unsafe] = ACTIONS(5095),
    [anon_sym_static] = ACTIONS(5095),
    [anon_sym_LBRACK] = ACTIONS(5097),
    [anon_sym_LPAREN] = ACTIONS(5097),
    [anon_sym_event] = ACTIONS(5095),
    [anon_sym_namespace] = ACTIONS(5095),
    [anon_sym_class] = ACTIONS(5095),
    [anon_sym_ref] = ACTIONS(5095),
    [anon_sym_struct] = ACTIONS(5095),
    [anon_sym_enum] = ACTIONS(5095),
    [anon_sym_RBRACE] = ACTIONS(5097),
    [anon_sym_interface] = ACTIONS(5095),
    [anon_sym_delegate] = ACTIONS(5095),
    [anon_sym_record] = ACTIONS(5095),
    [anon_sym_abstract] = ACTIONS(5095),
    [anon_sym_async] = ACTIONS(5095),
    [anon_sym_const] = ACTIONS(5095),
    [anon_sym_file] = ACTIONS(5095),
    [anon_sym_fixed] = ACTIONS(5095),
    [anon_sym_internal] = ACTIONS(5095),
    [anon_sym_new] = ACTIONS(5095),
    [anon_sym_override] = ACTIONS(5095),
    [anon_sym_partial] = ACTIONS(5095),
    [anon_sym_private] = ACTIONS(5095),
    [anon_sym_protected] = ACTIONS(5095),
    [anon_sym_public] = ACTIONS(5095),
    [anon_sym_readonly] = ACTIONS(5095),
    [anon_sym_required] = ACTIONS(5095),
    [anon_sym_sealed] = ACTIONS(5095),
    [anon_sym_virtual] = ACTIONS(5095),
    [anon_sym_volatile] = ACTIONS(5095),
    [anon_sym_where] = ACTIONS(5095),
    [anon_sym_notnull] = ACTIONS(5095),
    [anon_sym_unmanaged] = ACTIONS(5095),
    [anon_sym_TILDE] = ACTIONS(5097),
    [anon_sym_implicit] = ACTIONS(5095),
    [anon_sym_explicit] = ACTIONS(5095),
    [anon_sym_scoped] = ACTIONS(5095),
    [anon_sym_var] = ACTIONS(5095),
    [sym_predefined_type] = ACTIONS(5095),
    [anon_sym_yield] = ACTIONS(5095),
    [anon_sym_when] = ACTIONS(5095),
    [anon_sym_from] = ACTIONS(5095),
    [anon_sym_into] = ACTIONS(5095),
    [anon_sym_join] = ACTIONS(5095),
    [anon_sym_on] = ACTIONS(5095),
    [anon_sym_equals] = ACTIONS(5095),
    [anon_sym_let] = ACTIONS(5095),
    [anon_sym_orderby] = ACTIONS(5095),
    [anon_sym_ascending] = ACTIONS(5095),
    [anon_sym_descending] = ACTIONS(5095),
    [anon_sym_group] = ACTIONS(5095),
    [anon_sym_by] = ACTIONS(5095),
    [anon_sym_select] = ACTIONS(5095),
    [aux_sym_preproc_if_token1] = ACTIONS(5097),
    [aux_sym_preproc_if_token3] = ACTIONS(5097),
    [aux_sym_preproc_else_token1] = ACTIONS(5097),
    [aux_sym_preproc_elif_token1] = ACTIONS(5097),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3486] = {
    [sym_preproc_region] = STATE(3486),
    [sym_preproc_endregion] = STATE(3486),
    [sym_preproc_line] = STATE(3486),
    [sym_preproc_pragma] = STATE(3486),
    [sym_preproc_nullable] = STATE(3486),
    [sym_preproc_error] = STATE(3486),
    [sym_preproc_define] = STATE(3486),
    [sym_preproc_undef] = STATE(3486),
    [sym__identifier_token] = ACTIONS(4608),
    [anon_sym_alias] = ACTIONS(4608),
    [anon_sym_global] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_file] = ACTIONS(4608),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_where] = ACTIONS(4608),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_notnull] = ACTIONS(4608),
    [anon_sym_unmanaged] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_scoped] = ACTIONS(4608),
    [anon_sym_var] = ACTIONS(4608),
    [anon_sym_yield] = ACTIONS(4608),
    [anon_sym_switch] = ACTIONS(4608),
    [anon_sym_when] = ACTIONS(4608),
    [sym_discard] = ACTIONS(4608),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4608),
    [anon_sym_or] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_from] = ACTIONS(4608),
    [anon_sym_into] = ACTIONS(4608),
    [anon_sym_join] = ACTIONS(4608),
    [anon_sym_on] = ACTIONS(4608),
    [anon_sym_equals] = ACTIONS(4608),
    [anon_sym_let] = ACTIONS(4608),
    [anon_sym_orderby] = ACTIONS(4608),
    [anon_sym_ascending] = ACTIONS(4608),
    [anon_sym_descending] = ACTIONS(4608),
    [anon_sym_group] = ACTIONS(4608),
    [anon_sym_by] = ACTIONS(4608),
    [anon_sym_select] = ACTIONS(4608),
    [anon_sym_as] = ACTIONS(4608),
    [anon_sym_is] = ACTIONS(4608),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4608),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4610),
  },
  [3487] = {
    [sym_preproc_region] = STATE(3487),
    [sym_preproc_endregion] = STATE(3487),
    [sym_preproc_line] = STATE(3487),
    [sym_preproc_pragma] = STATE(3487),
    [sym_preproc_nullable] = STATE(3487),
    [sym_preproc_error] = STATE(3487),
    [sym_preproc_define] = STATE(3487),
    [sym_preproc_undef] = STATE(3487),
    [sym__identifier_token] = ACTIONS(5099),
    [anon_sym_extern] = ACTIONS(5099),
    [anon_sym_alias] = ACTIONS(5099),
    [anon_sym_global] = ACTIONS(5099),
    [anon_sym_using] = ACTIONS(5099),
    [anon_sym_unsafe] = ACTIONS(5099),
    [anon_sym_static] = ACTIONS(5099),
    [anon_sym_LBRACK] = ACTIONS(5101),
    [anon_sym_LPAREN] = ACTIONS(5101),
    [anon_sym_event] = ACTIONS(5099),
    [anon_sym_namespace] = ACTIONS(5099),
    [anon_sym_class] = ACTIONS(5099),
    [anon_sym_ref] = ACTIONS(5099),
    [anon_sym_struct] = ACTIONS(5099),
    [anon_sym_enum] = ACTIONS(5099),
    [anon_sym_RBRACE] = ACTIONS(5101),
    [anon_sym_interface] = ACTIONS(5099),
    [anon_sym_delegate] = ACTIONS(5099),
    [anon_sym_record] = ACTIONS(5099),
    [anon_sym_abstract] = ACTIONS(5099),
    [anon_sym_async] = ACTIONS(5099),
    [anon_sym_const] = ACTIONS(5099),
    [anon_sym_file] = ACTIONS(5099),
    [anon_sym_fixed] = ACTIONS(5099),
    [anon_sym_internal] = ACTIONS(5099),
    [anon_sym_new] = ACTIONS(5099),
    [anon_sym_override] = ACTIONS(5099),
    [anon_sym_partial] = ACTIONS(5099),
    [anon_sym_private] = ACTIONS(5099),
    [anon_sym_protected] = ACTIONS(5099),
    [anon_sym_public] = ACTIONS(5099),
    [anon_sym_readonly] = ACTIONS(5099),
    [anon_sym_required] = ACTIONS(5099),
    [anon_sym_sealed] = ACTIONS(5099),
    [anon_sym_virtual] = ACTIONS(5099),
    [anon_sym_volatile] = ACTIONS(5099),
    [anon_sym_where] = ACTIONS(5099),
    [anon_sym_notnull] = ACTIONS(5099),
    [anon_sym_unmanaged] = ACTIONS(5099),
    [anon_sym_TILDE] = ACTIONS(5101),
    [anon_sym_implicit] = ACTIONS(5099),
    [anon_sym_explicit] = ACTIONS(5099),
    [anon_sym_scoped] = ACTIONS(5099),
    [anon_sym_var] = ACTIONS(5099),
    [sym_predefined_type] = ACTIONS(5099),
    [anon_sym_yield] = ACTIONS(5099),
    [anon_sym_when] = ACTIONS(5099),
    [anon_sym_from] = ACTIONS(5099),
    [anon_sym_into] = ACTIONS(5099),
    [anon_sym_join] = ACTIONS(5099),
    [anon_sym_on] = ACTIONS(5099),
    [anon_sym_equals] = ACTIONS(5099),
    [anon_sym_let] = ACTIONS(5099),
    [anon_sym_orderby] = ACTIONS(5099),
    [anon_sym_ascending] = ACTIONS(5099),
    [anon_sym_descending] = ACTIONS(5099),
    [anon_sym_group] = ACTIONS(5099),
    [anon_sym_by] = ACTIONS(5099),
    [anon_sym_select] = ACTIONS(5099),
    [aux_sym_preproc_if_token1] = ACTIONS(5101),
    [aux_sym_preproc_if_token3] = ACTIONS(5101),
    [aux_sym_preproc_else_token1] = ACTIONS(5101),
    [aux_sym_preproc_elif_token1] = ACTIONS(5101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3488] = {
    [sym_preproc_region] = STATE(3488),
    [sym_preproc_endregion] = STATE(3488),
    [sym_preproc_line] = STATE(3488),
    [sym_preproc_pragma] = STATE(3488),
    [sym_preproc_nullable] = STATE(3488),
    [sym_preproc_error] = STATE(3488),
    [sym_preproc_define] = STATE(3488),
    [sym_preproc_undef] = STATE(3488),
    [sym__identifier_token] = ACTIONS(5103),
    [anon_sym_extern] = ACTIONS(5103),
    [anon_sym_alias] = ACTIONS(5103),
    [anon_sym_global] = ACTIONS(5103),
    [anon_sym_using] = ACTIONS(5103),
    [anon_sym_unsafe] = ACTIONS(5103),
    [anon_sym_static] = ACTIONS(5103),
    [anon_sym_LBRACK] = ACTIONS(5105),
    [anon_sym_LPAREN] = ACTIONS(5105),
    [anon_sym_event] = ACTIONS(5103),
    [anon_sym_namespace] = ACTIONS(5103),
    [anon_sym_class] = ACTIONS(5103),
    [anon_sym_ref] = ACTIONS(5103),
    [anon_sym_struct] = ACTIONS(5103),
    [anon_sym_enum] = ACTIONS(5103),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_interface] = ACTIONS(5103),
    [anon_sym_delegate] = ACTIONS(5103),
    [anon_sym_record] = ACTIONS(5103),
    [anon_sym_abstract] = ACTIONS(5103),
    [anon_sym_async] = ACTIONS(5103),
    [anon_sym_const] = ACTIONS(5103),
    [anon_sym_file] = ACTIONS(5103),
    [anon_sym_fixed] = ACTIONS(5103),
    [anon_sym_internal] = ACTIONS(5103),
    [anon_sym_new] = ACTIONS(5103),
    [anon_sym_override] = ACTIONS(5103),
    [anon_sym_partial] = ACTIONS(5103),
    [anon_sym_private] = ACTIONS(5103),
    [anon_sym_protected] = ACTIONS(5103),
    [anon_sym_public] = ACTIONS(5103),
    [anon_sym_readonly] = ACTIONS(5103),
    [anon_sym_required] = ACTIONS(5103),
    [anon_sym_sealed] = ACTIONS(5103),
    [anon_sym_virtual] = ACTIONS(5103),
    [anon_sym_volatile] = ACTIONS(5103),
    [anon_sym_where] = ACTIONS(5103),
    [anon_sym_notnull] = ACTIONS(5103),
    [anon_sym_unmanaged] = ACTIONS(5103),
    [anon_sym_TILDE] = ACTIONS(5105),
    [anon_sym_implicit] = ACTIONS(5103),
    [anon_sym_explicit] = ACTIONS(5103),
    [anon_sym_scoped] = ACTIONS(5103),
    [anon_sym_var] = ACTIONS(5103),
    [sym_predefined_type] = ACTIONS(5103),
    [anon_sym_yield] = ACTIONS(5103),
    [anon_sym_when] = ACTIONS(5103),
    [anon_sym_from] = ACTIONS(5103),
    [anon_sym_into] = ACTIONS(5103),
    [anon_sym_join] = ACTIONS(5103),
    [anon_sym_on] = ACTIONS(5103),
    [anon_sym_equals] = ACTIONS(5103),
    [anon_sym_let] = ACTIONS(5103),
    [anon_sym_orderby] = ACTIONS(5103),
    [anon_sym_ascending] = ACTIONS(5103),
    [anon_sym_descending] = ACTIONS(5103),
    [anon_sym_group] = ACTIONS(5103),
    [anon_sym_by] = ACTIONS(5103),
    [anon_sym_select] = ACTIONS(5103),
    [aux_sym_preproc_if_token1] = ACTIONS(5105),
    [aux_sym_preproc_if_token3] = ACTIONS(5105),
    [aux_sym_preproc_else_token1] = ACTIONS(5105),
    [aux_sym_preproc_elif_token1] = ACTIONS(5105),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3489] = {
    [sym_preproc_region] = STATE(3489),
    [sym_preproc_endregion] = STATE(3489),
    [sym_preproc_line] = STATE(3489),
    [sym_preproc_pragma] = STATE(3489),
    [sym_preproc_nullable] = STATE(3489),
    [sym_preproc_error] = STATE(3489),
    [sym_preproc_define] = STATE(3489),
    [sym_preproc_undef] = STATE(3489),
    [sym__identifier_token] = ACTIONS(5107),
    [anon_sym_extern] = ACTIONS(5107),
    [anon_sym_alias] = ACTIONS(5107),
    [anon_sym_global] = ACTIONS(5107),
    [anon_sym_using] = ACTIONS(5107),
    [anon_sym_unsafe] = ACTIONS(5107),
    [anon_sym_static] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(5109),
    [anon_sym_LPAREN] = ACTIONS(5109),
    [anon_sym_event] = ACTIONS(5107),
    [anon_sym_namespace] = ACTIONS(5107),
    [anon_sym_class] = ACTIONS(5107),
    [anon_sym_ref] = ACTIONS(5107),
    [anon_sym_struct] = ACTIONS(5107),
    [anon_sym_enum] = ACTIONS(5107),
    [anon_sym_RBRACE] = ACTIONS(5109),
    [anon_sym_interface] = ACTIONS(5107),
    [anon_sym_delegate] = ACTIONS(5107),
    [anon_sym_record] = ACTIONS(5107),
    [anon_sym_abstract] = ACTIONS(5107),
    [anon_sym_async] = ACTIONS(5107),
    [anon_sym_const] = ACTIONS(5107),
    [anon_sym_file] = ACTIONS(5107),
    [anon_sym_fixed] = ACTIONS(5107),
    [anon_sym_internal] = ACTIONS(5107),
    [anon_sym_new] = ACTIONS(5107),
    [anon_sym_override] = ACTIONS(5107),
    [anon_sym_partial] = ACTIONS(5107),
    [anon_sym_private] = ACTIONS(5107),
    [anon_sym_protected] = ACTIONS(5107),
    [anon_sym_public] = ACTIONS(5107),
    [anon_sym_readonly] = ACTIONS(5107),
    [anon_sym_required] = ACTIONS(5107),
    [anon_sym_sealed] = ACTIONS(5107),
    [anon_sym_virtual] = ACTIONS(5107),
    [anon_sym_volatile] = ACTIONS(5107),
    [anon_sym_where] = ACTIONS(5107),
    [anon_sym_notnull] = ACTIONS(5107),
    [anon_sym_unmanaged] = ACTIONS(5107),
    [anon_sym_TILDE] = ACTIONS(5109),
    [anon_sym_implicit] = ACTIONS(5107),
    [anon_sym_explicit] = ACTIONS(5107),
    [anon_sym_scoped] = ACTIONS(5107),
    [anon_sym_var] = ACTIONS(5107),
    [sym_predefined_type] = ACTIONS(5107),
    [anon_sym_yield] = ACTIONS(5107),
    [anon_sym_when] = ACTIONS(5107),
    [anon_sym_from] = ACTIONS(5107),
    [anon_sym_into] = ACTIONS(5107),
    [anon_sym_join] = ACTIONS(5107),
    [anon_sym_on] = ACTIONS(5107),
    [anon_sym_equals] = ACTIONS(5107),
    [anon_sym_let] = ACTIONS(5107),
    [anon_sym_orderby] = ACTIONS(5107),
    [anon_sym_ascending] = ACTIONS(5107),
    [anon_sym_descending] = ACTIONS(5107),
    [anon_sym_group] = ACTIONS(5107),
    [anon_sym_by] = ACTIONS(5107),
    [anon_sym_select] = ACTIONS(5107),
    [aux_sym_preproc_if_token1] = ACTIONS(5109),
    [aux_sym_preproc_if_token3] = ACTIONS(5109),
    [aux_sym_preproc_else_token1] = ACTIONS(5109),
    [aux_sym_preproc_elif_token1] = ACTIONS(5109),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3490] = {
    [sym_preproc_region] = STATE(3490),
    [sym_preproc_endregion] = STATE(3490),
    [sym_preproc_line] = STATE(3490),
    [sym_preproc_pragma] = STATE(3490),
    [sym_preproc_nullable] = STATE(3490),
    [sym_preproc_error] = STATE(3490),
    [sym_preproc_define] = STATE(3490),
    [sym_preproc_undef] = STATE(3490),
    [sym__identifier_token] = ACTIONS(5111),
    [anon_sym_extern] = ACTIONS(5111),
    [anon_sym_alias] = ACTIONS(5111),
    [anon_sym_global] = ACTIONS(5111),
    [anon_sym_using] = ACTIONS(5111),
    [anon_sym_unsafe] = ACTIONS(5111),
    [anon_sym_static] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(5113),
    [anon_sym_LPAREN] = ACTIONS(5113),
    [anon_sym_event] = ACTIONS(5111),
    [anon_sym_namespace] = ACTIONS(5111),
    [anon_sym_class] = ACTIONS(5111),
    [anon_sym_ref] = ACTIONS(5111),
    [anon_sym_struct] = ACTIONS(5111),
    [anon_sym_enum] = ACTIONS(5111),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_interface] = ACTIONS(5111),
    [anon_sym_delegate] = ACTIONS(5111),
    [anon_sym_record] = ACTIONS(5111),
    [anon_sym_abstract] = ACTIONS(5111),
    [anon_sym_async] = ACTIONS(5111),
    [anon_sym_const] = ACTIONS(5111),
    [anon_sym_file] = ACTIONS(5111),
    [anon_sym_fixed] = ACTIONS(5111),
    [anon_sym_internal] = ACTIONS(5111),
    [anon_sym_new] = ACTIONS(5111),
    [anon_sym_override] = ACTIONS(5111),
    [anon_sym_partial] = ACTIONS(5111),
    [anon_sym_private] = ACTIONS(5111),
    [anon_sym_protected] = ACTIONS(5111),
    [anon_sym_public] = ACTIONS(5111),
    [anon_sym_readonly] = ACTIONS(5111),
    [anon_sym_required] = ACTIONS(5111),
    [anon_sym_sealed] = ACTIONS(5111),
    [anon_sym_virtual] = ACTIONS(5111),
    [anon_sym_volatile] = ACTIONS(5111),
    [anon_sym_where] = ACTIONS(5111),
    [anon_sym_notnull] = ACTIONS(5111),
    [anon_sym_unmanaged] = ACTIONS(5111),
    [anon_sym_TILDE] = ACTIONS(5113),
    [anon_sym_implicit] = ACTIONS(5111),
    [anon_sym_explicit] = ACTIONS(5111),
    [anon_sym_scoped] = ACTIONS(5111),
    [anon_sym_var] = ACTIONS(5111),
    [sym_predefined_type] = ACTIONS(5111),
    [anon_sym_yield] = ACTIONS(5111),
    [anon_sym_when] = ACTIONS(5111),
    [anon_sym_from] = ACTIONS(5111),
    [anon_sym_into] = ACTIONS(5111),
    [anon_sym_join] = ACTIONS(5111),
    [anon_sym_on] = ACTIONS(5111),
    [anon_sym_equals] = ACTIONS(5111),
    [anon_sym_let] = ACTIONS(5111),
    [anon_sym_orderby] = ACTIONS(5111),
    [anon_sym_ascending] = ACTIONS(5111),
    [anon_sym_descending] = ACTIONS(5111),
    [anon_sym_group] = ACTIONS(5111),
    [anon_sym_by] = ACTIONS(5111),
    [anon_sym_select] = ACTIONS(5111),
    [aux_sym_preproc_if_token1] = ACTIONS(5113),
    [aux_sym_preproc_if_token3] = ACTIONS(5113),
    [aux_sym_preproc_else_token1] = ACTIONS(5113),
    [aux_sym_preproc_elif_token1] = ACTIONS(5113),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3491] = {
    [sym_preproc_region] = STATE(3491),
    [sym_preproc_endregion] = STATE(3491),
    [sym_preproc_line] = STATE(3491),
    [sym_preproc_pragma] = STATE(3491),
    [sym_preproc_nullable] = STATE(3491),
    [sym_preproc_error] = STATE(3491),
    [sym_preproc_define] = STATE(3491),
    [sym_preproc_undef] = STATE(3491),
    [sym__identifier_token] = ACTIONS(3961),
    [anon_sym_extern] = ACTIONS(3961),
    [anon_sym_alias] = ACTIONS(3961),
    [anon_sym_global] = ACTIONS(3961),
    [anon_sym_using] = ACTIONS(3961),
    [anon_sym_unsafe] = ACTIONS(3961),
    [anon_sym_static] = ACTIONS(3961),
    [anon_sym_LBRACK] = ACTIONS(3963),
    [anon_sym_LPAREN] = ACTIONS(3963),
    [anon_sym_event] = ACTIONS(3961),
    [anon_sym_namespace] = ACTIONS(3961),
    [anon_sym_class] = ACTIONS(3961),
    [anon_sym_ref] = ACTIONS(3961),
    [anon_sym_struct] = ACTIONS(3961),
    [anon_sym_enum] = ACTIONS(3961),
    [anon_sym_RBRACE] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(3961),
    [anon_sym_delegate] = ACTIONS(3961),
    [anon_sym_record] = ACTIONS(3961),
    [anon_sym_abstract] = ACTIONS(3961),
    [anon_sym_async] = ACTIONS(3961),
    [anon_sym_const] = ACTIONS(3961),
    [anon_sym_file] = ACTIONS(3961),
    [anon_sym_fixed] = ACTIONS(3961),
    [anon_sym_internal] = ACTIONS(3961),
    [anon_sym_new] = ACTIONS(3961),
    [anon_sym_override] = ACTIONS(3961),
    [anon_sym_partial] = ACTIONS(3961),
    [anon_sym_private] = ACTIONS(3961),
    [anon_sym_protected] = ACTIONS(3961),
    [anon_sym_public] = ACTIONS(3961),
    [anon_sym_readonly] = ACTIONS(3961),
    [anon_sym_required] = ACTIONS(3961),
    [anon_sym_sealed] = ACTIONS(3961),
    [anon_sym_virtual] = ACTIONS(3961),
    [anon_sym_volatile] = ACTIONS(3961),
    [anon_sym_where] = ACTIONS(3961),
    [anon_sym_notnull] = ACTIONS(3961),
    [anon_sym_unmanaged] = ACTIONS(3961),
    [anon_sym_TILDE] = ACTIONS(3963),
    [anon_sym_implicit] = ACTIONS(3961),
    [anon_sym_explicit] = ACTIONS(3961),
    [anon_sym_scoped] = ACTIONS(3961),
    [anon_sym_var] = ACTIONS(3961),
    [sym_predefined_type] = ACTIONS(3961),
    [anon_sym_yield] = ACTIONS(3961),
    [anon_sym_when] = ACTIONS(3961),
    [anon_sym_from] = ACTIONS(3961),
    [anon_sym_into] = ACTIONS(3961),
    [anon_sym_join] = ACTIONS(3961),
    [anon_sym_on] = ACTIONS(3961),
    [anon_sym_equals] = ACTIONS(3961),
    [anon_sym_let] = ACTIONS(3961),
    [anon_sym_orderby] = ACTIONS(3961),
    [anon_sym_ascending] = ACTIONS(3961),
    [anon_sym_descending] = ACTIONS(3961),
    [anon_sym_group] = ACTIONS(3961),
    [anon_sym_by] = ACTIONS(3961),
    [anon_sym_select] = ACTIONS(3961),
    [aux_sym_preproc_if_token1] = ACTIONS(3963),
    [aux_sym_preproc_if_token3] = ACTIONS(3963),
    [aux_sym_preproc_else_token1] = ACTIONS(3963),
    [aux_sym_preproc_elif_token1] = ACTIONS(3963),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3492] = {
    [sym_preproc_region] = STATE(3492),
    [sym_preproc_endregion] = STATE(3492),
    [sym_preproc_line] = STATE(3492),
    [sym_preproc_pragma] = STATE(3492),
    [sym_preproc_nullable] = STATE(3492),
    [sym_preproc_error] = STATE(3492),
    [sym_preproc_define] = STATE(3492),
    [sym_preproc_undef] = STATE(3492),
    [sym__identifier_token] = ACTIONS(5115),
    [anon_sym_extern] = ACTIONS(5115),
    [anon_sym_alias] = ACTIONS(5115),
    [anon_sym_global] = ACTIONS(5115),
    [anon_sym_using] = ACTIONS(5115),
    [anon_sym_unsafe] = ACTIONS(5115),
    [anon_sym_static] = ACTIONS(5115),
    [anon_sym_LBRACK] = ACTIONS(5117),
    [anon_sym_LPAREN] = ACTIONS(5117),
    [anon_sym_event] = ACTIONS(5115),
    [anon_sym_namespace] = ACTIONS(5115),
    [anon_sym_class] = ACTIONS(5115),
    [anon_sym_ref] = ACTIONS(5115),
    [anon_sym_struct] = ACTIONS(5115),
    [anon_sym_enum] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5117),
    [anon_sym_interface] = ACTIONS(5115),
    [anon_sym_delegate] = ACTIONS(5115),
    [anon_sym_record] = ACTIONS(5115),
    [anon_sym_abstract] = ACTIONS(5115),
    [anon_sym_async] = ACTIONS(5115),
    [anon_sym_const] = ACTIONS(5115),
    [anon_sym_file] = ACTIONS(5115),
    [anon_sym_fixed] = ACTIONS(5115),
    [anon_sym_internal] = ACTIONS(5115),
    [anon_sym_new] = ACTIONS(5115),
    [anon_sym_override] = ACTIONS(5115),
    [anon_sym_partial] = ACTIONS(5115),
    [anon_sym_private] = ACTIONS(5115),
    [anon_sym_protected] = ACTIONS(5115),
    [anon_sym_public] = ACTIONS(5115),
    [anon_sym_readonly] = ACTIONS(5115),
    [anon_sym_required] = ACTIONS(5115),
    [anon_sym_sealed] = ACTIONS(5115),
    [anon_sym_virtual] = ACTIONS(5115),
    [anon_sym_volatile] = ACTIONS(5115),
    [anon_sym_where] = ACTIONS(5115),
    [anon_sym_notnull] = ACTIONS(5115),
    [anon_sym_unmanaged] = ACTIONS(5115),
    [anon_sym_TILDE] = ACTIONS(5117),
    [anon_sym_implicit] = ACTIONS(5115),
    [anon_sym_explicit] = ACTIONS(5115),
    [anon_sym_scoped] = ACTIONS(5115),
    [anon_sym_var] = ACTIONS(5115),
    [sym_predefined_type] = ACTIONS(5115),
    [anon_sym_yield] = ACTIONS(5115),
    [anon_sym_when] = ACTIONS(5115),
    [anon_sym_from] = ACTIONS(5115),
    [anon_sym_into] = ACTIONS(5115),
    [anon_sym_join] = ACTIONS(5115),
    [anon_sym_on] = ACTIONS(5115),
    [anon_sym_equals] = ACTIONS(5115),
    [anon_sym_let] = ACTIONS(5115),
    [anon_sym_orderby] = ACTIONS(5115),
    [anon_sym_ascending] = ACTIONS(5115),
    [anon_sym_descending] = ACTIONS(5115),
    [anon_sym_group] = ACTIONS(5115),
    [anon_sym_by] = ACTIONS(5115),
    [anon_sym_select] = ACTIONS(5115),
    [aux_sym_preproc_if_token1] = ACTIONS(5117),
    [aux_sym_preproc_if_token3] = ACTIONS(5117),
    [aux_sym_preproc_else_token1] = ACTIONS(5117),
    [aux_sym_preproc_elif_token1] = ACTIONS(5117),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3493] = {
    [sym_preproc_region] = STATE(3493),
    [sym_preproc_endregion] = STATE(3493),
    [sym_preproc_line] = STATE(3493),
    [sym_preproc_pragma] = STATE(3493),
    [sym_preproc_nullable] = STATE(3493),
    [sym_preproc_error] = STATE(3493),
    [sym_preproc_define] = STATE(3493),
    [sym_preproc_undef] = STATE(3493),
    [sym__identifier_token] = ACTIONS(5119),
    [anon_sym_extern] = ACTIONS(5119),
    [anon_sym_alias] = ACTIONS(5119),
    [anon_sym_global] = ACTIONS(5119),
    [anon_sym_using] = ACTIONS(5119),
    [anon_sym_unsafe] = ACTIONS(5119),
    [anon_sym_static] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(5121),
    [anon_sym_LPAREN] = ACTIONS(5121),
    [anon_sym_event] = ACTIONS(5119),
    [anon_sym_namespace] = ACTIONS(5119),
    [anon_sym_class] = ACTIONS(5119),
    [anon_sym_ref] = ACTIONS(5119),
    [anon_sym_struct] = ACTIONS(5119),
    [anon_sym_enum] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_interface] = ACTIONS(5119),
    [anon_sym_delegate] = ACTIONS(5119),
    [anon_sym_record] = ACTIONS(5119),
    [anon_sym_abstract] = ACTIONS(5119),
    [anon_sym_async] = ACTIONS(5119),
    [anon_sym_const] = ACTIONS(5119),
    [anon_sym_file] = ACTIONS(5119),
    [anon_sym_fixed] = ACTIONS(5119),
    [anon_sym_internal] = ACTIONS(5119),
    [anon_sym_new] = ACTIONS(5119),
    [anon_sym_override] = ACTIONS(5119),
    [anon_sym_partial] = ACTIONS(5119),
    [anon_sym_private] = ACTIONS(5119),
    [anon_sym_protected] = ACTIONS(5119),
    [anon_sym_public] = ACTIONS(5119),
    [anon_sym_readonly] = ACTIONS(5119),
    [anon_sym_required] = ACTIONS(5119),
    [anon_sym_sealed] = ACTIONS(5119),
    [anon_sym_virtual] = ACTIONS(5119),
    [anon_sym_volatile] = ACTIONS(5119),
    [anon_sym_where] = ACTIONS(5119),
    [anon_sym_notnull] = ACTIONS(5119),
    [anon_sym_unmanaged] = ACTIONS(5119),
    [anon_sym_TILDE] = ACTIONS(5121),
    [anon_sym_implicit] = ACTIONS(5119),
    [anon_sym_explicit] = ACTIONS(5119),
    [anon_sym_scoped] = ACTIONS(5119),
    [anon_sym_var] = ACTIONS(5119),
    [sym_predefined_type] = ACTIONS(5119),
    [anon_sym_yield] = ACTIONS(5119),
    [anon_sym_when] = ACTIONS(5119),
    [anon_sym_from] = ACTIONS(5119),
    [anon_sym_into] = ACTIONS(5119),
    [anon_sym_join] = ACTIONS(5119),
    [anon_sym_on] = ACTIONS(5119),
    [anon_sym_equals] = ACTIONS(5119),
    [anon_sym_let] = ACTIONS(5119),
    [anon_sym_orderby] = ACTIONS(5119),
    [anon_sym_ascending] = ACTIONS(5119),
    [anon_sym_descending] = ACTIONS(5119),
    [anon_sym_group] = ACTIONS(5119),
    [anon_sym_by] = ACTIONS(5119),
    [anon_sym_select] = ACTIONS(5119),
    [aux_sym_preproc_if_token1] = ACTIONS(5121),
    [aux_sym_preproc_if_token3] = ACTIONS(5121),
    [aux_sym_preproc_else_token1] = ACTIONS(5121),
    [aux_sym_preproc_elif_token1] = ACTIONS(5121),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3494] = {
    [sym_preproc_region] = STATE(3494),
    [sym_preproc_endregion] = STATE(3494),
    [sym_preproc_line] = STATE(3494),
    [sym_preproc_pragma] = STATE(3494),
    [sym_preproc_nullable] = STATE(3494),
    [sym_preproc_error] = STATE(3494),
    [sym_preproc_define] = STATE(3494),
    [sym_preproc_undef] = STATE(3494),
    [sym__identifier_token] = ACTIONS(5123),
    [anon_sym_extern] = ACTIONS(5123),
    [anon_sym_alias] = ACTIONS(5123),
    [anon_sym_global] = ACTIONS(5123),
    [anon_sym_using] = ACTIONS(5123),
    [anon_sym_unsafe] = ACTIONS(5123),
    [anon_sym_static] = ACTIONS(5123),
    [anon_sym_LBRACK] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(5125),
    [anon_sym_event] = ACTIONS(5123),
    [anon_sym_namespace] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(5123),
    [anon_sym_ref] = ACTIONS(5123),
    [anon_sym_struct] = ACTIONS(5123),
    [anon_sym_enum] = ACTIONS(5123),
    [anon_sym_RBRACE] = ACTIONS(5125),
    [anon_sym_interface] = ACTIONS(5123),
    [anon_sym_delegate] = ACTIONS(5123),
    [anon_sym_record] = ACTIONS(5123),
    [anon_sym_abstract] = ACTIONS(5123),
    [anon_sym_async] = ACTIONS(5123),
    [anon_sym_const] = ACTIONS(5123),
    [anon_sym_file] = ACTIONS(5123),
    [anon_sym_fixed] = ACTIONS(5123),
    [anon_sym_internal] = ACTIONS(5123),
    [anon_sym_new] = ACTIONS(5123),
    [anon_sym_override] = ACTIONS(5123),
    [anon_sym_partial] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_readonly] = ACTIONS(5123),
    [anon_sym_required] = ACTIONS(5123),
    [anon_sym_sealed] = ACTIONS(5123),
    [anon_sym_virtual] = ACTIONS(5123),
    [anon_sym_volatile] = ACTIONS(5123),
    [anon_sym_where] = ACTIONS(5123),
    [anon_sym_notnull] = ACTIONS(5123),
    [anon_sym_unmanaged] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(5125),
    [anon_sym_implicit] = ACTIONS(5123),
    [anon_sym_explicit] = ACTIONS(5123),
    [anon_sym_scoped] = ACTIONS(5123),
    [anon_sym_var] = ACTIONS(5123),
    [sym_predefined_type] = ACTIONS(5123),
    [anon_sym_yield] = ACTIONS(5123),
    [anon_sym_when] = ACTIONS(5123),
    [anon_sym_from] = ACTIONS(5123),
    [anon_sym_into] = ACTIONS(5123),
    [anon_sym_join] = ACTIONS(5123),
    [anon_sym_on] = ACTIONS(5123),
    [anon_sym_equals] = ACTIONS(5123),
    [anon_sym_let] = ACTIONS(5123),
    [anon_sym_orderby] = ACTIONS(5123),
    [anon_sym_ascending] = ACTIONS(5123),
    [anon_sym_descending] = ACTIONS(5123),
    [anon_sym_group] = ACTIONS(5123),
    [anon_sym_by] = ACTIONS(5123),
    [anon_sym_select] = ACTIONS(5123),
    [aux_sym_preproc_if_token1] = ACTIONS(5125),
    [aux_sym_preproc_if_token3] = ACTIONS(5125),
    [aux_sym_preproc_else_token1] = ACTIONS(5125),
    [aux_sym_preproc_elif_token1] = ACTIONS(5125),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3495] = {
    [sym_preproc_region] = STATE(3495),
    [sym_preproc_endregion] = STATE(3495),
    [sym_preproc_line] = STATE(3495),
    [sym_preproc_pragma] = STATE(3495),
    [sym_preproc_nullable] = STATE(3495),
    [sym_preproc_error] = STATE(3495),
    [sym_preproc_define] = STATE(3495),
    [sym_preproc_undef] = STATE(3495),
    [sym__identifier_token] = ACTIONS(5127),
    [anon_sym_extern] = ACTIONS(5127),
    [anon_sym_alias] = ACTIONS(5127),
    [anon_sym_global] = ACTIONS(5127),
    [anon_sym_using] = ACTIONS(5127),
    [anon_sym_unsafe] = ACTIONS(5127),
    [anon_sym_static] = ACTIONS(5127),
    [anon_sym_LBRACK] = ACTIONS(5129),
    [anon_sym_LPAREN] = ACTIONS(5129),
    [anon_sym_event] = ACTIONS(5127),
    [anon_sym_namespace] = ACTIONS(5127),
    [anon_sym_class] = ACTIONS(5127),
    [anon_sym_ref] = ACTIONS(5127),
    [anon_sym_struct] = ACTIONS(5127),
    [anon_sym_enum] = ACTIONS(5127),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_interface] = ACTIONS(5127),
    [anon_sym_delegate] = ACTIONS(5127),
    [anon_sym_record] = ACTIONS(5127),
    [anon_sym_abstract] = ACTIONS(5127),
    [anon_sym_async] = ACTIONS(5127),
    [anon_sym_const] = ACTIONS(5127),
    [anon_sym_file] = ACTIONS(5127),
    [anon_sym_fixed] = ACTIONS(5127),
    [anon_sym_internal] = ACTIONS(5127),
    [anon_sym_new] = ACTIONS(5127),
    [anon_sym_override] = ACTIONS(5127),
    [anon_sym_partial] = ACTIONS(5127),
    [anon_sym_private] = ACTIONS(5127),
    [anon_sym_protected] = ACTIONS(5127),
    [anon_sym_public] = ACTIONS(5127),
    [anon_sym_readonly] = ACTIONS(5127),
    [anon_sym_required] = ACTIONS(5127),
    [anon_sym_sealed] = ACTIONS(5127),
    [anon_sym_virtual] = ACTIONS(5127),
    [anon_sym_volatile] = ACTIONS(5127),
    [anon_sym_where] = ACTIONS(5127),
    [anon_sym_notnull] = ACTIONS(5127),
    [anon_sym_unmanaged] = ACTIONS(5127),
    [anon_sym_TILDE] = ACTIONS(5129),
    [anon_sym_implicit] = ACTIONS(5127),
    [anon_sym_explicit] = ACTIONS(5127),
    [anon_sym_scoped] = ACTIONS(5127),
    [anon_sym_var] = ACTIONS(5127),
    [sym_predefined_type] = ACTIONS(5127),
    [anon_sym_yield] = ACTIONS(5127),
    [anon_sym_when] = ACTIONS(5127),
    [anon_sym_from] = ACTIONS(5127),
    [anon_sym_into] = ACTIONS(5127),
    [anon_sym_join] = ACTIONS(5127),
    [anon_sym_on] = ACTIONS(5127),
    [anon_sym_equals] = ACTIONS(5127),
    [anon_sym_let] = ACTIONS(5127),
    [anon_sym_orderby] = ACTIONS(5127),
    [anon_sym_ascending] = ACTIONS(5127),
    [anon_sym_descending] = ACTIONS(5127),
    [anon_sym_group] = ACTIONS(5127),
    [anon_sym_by] = ACTIONS(5127),
    [anon_sym_select] = ACTIONS(5127),
    [aux_sym_preproc_if_token1] = ACTIONS(5129),
    [aux_sym_preproc_if_token3] = ACTIONS(5129),
    [aux_sym_preproc_else_token1] = ACTIONS(5129),
    [aux_sym_preproc_elif_token1] = ACTIONS(5129),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3496] = {
    [sym_preproc_region] = STATE(3496),
    [sym_preproc_endregion] = STATE(3496),
    [sym_preproc_line] = STATE(3496),
    [sym_preproc_pragma] = STATE(3496),
    [sym_preproc_nullable] = STATE(3496),
    [sym_preproc_error] = STATE(3496),
    [sym_preproc_define] = STATE(3496),
    [sym_preproc_undef] = STATE(3496),
    [sym__identifier_token] = ACTIONS(3949),
    [anon_sym_extern] = ACTIONS(3949),
    [anon_sym_alias] = ACTIONS(3949),
    [anon_sym_global] = ACTIONS(3949),
    [anon_sym_using] = ACTIONS(3949),
    [anon_sym_unsafe] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [anon_sym_LPAREN] = ACTIONS(3951),
    [anon_sym_event] = ACTIONS(3949),
    [anon_sym_namespace] = ACTIONS(3949),
    [anon_sym_class] = ACTIONS(3949),
    [anon_sym_ref] = ACTIONS(3949),
    [anon_sym_struct] = ACTIONS(3949),
    [anon_sym_enum] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_interface] = ACTIONS(3949),
    [anon_sym_delegate] = ACTIONS(3949),
    [anon_sym_record] = ACTIONS(3949),
    [anon_sym_abstract] = ACTIONS(3949),
    [anon_sym_async] = ACTIONS(3949),
    [anon_sym_const] = ACTIONS(3949),
    [anon_sym_file] = ACTIONS(3949),
    [anon_sym_fixed] = ACTIONS(3949),
    [anon_sym_internal] = ACTIONS(3949),
    [anon_sym_new] = ACTIONS(3949),
    [anon_sym_override] = ACTIONS(3949),
    [anon_sym_partial] = ACTIONS(3949),
    [anon_sym_private] = ACTIONS(3949),
    [anon_sym_protected] = ACTIONS(3949),
    [anon_sym_public] = ACTIONS(3949),
    [anon_sym_readonly] = ACTIONS(3949),
    [anon_sym_required] = ACTIONS(3949),
    [anon_sym_sealed] = ACTIONS(3949),
    [anon_sym_virtual] = ACTIONS(3949),
    [anon_sym_volatile] = ACTIONS(3949),
    [anon_sym_where] = ACTIONS(3949),
    [anon_sym_notnull] = ACTIONS(3949),
    [anon_sym_unmanaged] = ACTIONS(3949),
    [anon_sym_TILDE] = ACTIONS(3951),
    [anon_sym_implicit] = ACTIONS(3949),
    [anon_sym_explicit] = ACTIONS(3949),
    [anon_sym_scoped] = ACTIONS(3949),
    [anon_sym_var] = ACTIONS(3949),
    [sym_predefined_type] = ACTIONS(3949),
    [anon_sym_yield] = ACTIONS(3949),
    [anon_sym_when] = ACTIONS(3949),
    [anon_sym_from] = ACTIONS(3949),
    [anon_sym_into] = ACTIONS(3949),
    [anon_sym_join] = ACTIONS(3949),
    [anon_sym_on] = ACTIONS(3949),
    [anon_sym_equals] = ACTIONS(3949),
    [anon_sym_let] = ACTIONS(3949),
    [anon_sym_orderby] = ACTIONS(3949),
    [anon_sym_ascending] = ACTIONS(3949),
    [anon_sym_descending] = ACTIONS(3949),
    [anon_sym_group] = ACTIONS(3949),
    [anon_sym_by] = ACTIONS(3949),
    [anon_sym_select] = ACTIONS(3949),
    [aux_sym_preproc_if_token1] = ACTIONS(3951),
    [aux_sym_preproc_if_token3] = ACTIONS(3951),
    [aux_sym_preproc_else_token1] = ACTIONS(3951),
    [aux_sym_preproc_elif_token1] = ACTIONS(3951),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3497] = {
    [sym_preproc_region] = STATE(3497),
    [sym_preproc_endregion] = STATE(3497),
    [sym_preproc_line] = STATE(3497),
    [sym_preproc_pragma] = STATE(3497),
    [sym_preproc_nullable] = STATE(3497),
    [sym_preproc_error] = STATE(3497),
    [sym_preproc_define] = STATE(3497),
    [sym_preproc_undef] = STATE(3497),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_RBRACK] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_in] = ACTIONS(4636),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_EQ_GT] = ACTIONS(4636),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_when] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4636),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_on] = ACTIONS(4636),
    [anon_sym_equals] = ACTIONS(4636),
    [anon_sym_by] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_if_token3] = ACTIONS(4636),
    [aux_sym_preproc_else_token1] = ACTIONS(4636),
    [aux_sym_preproc_elif_token1] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3498] = {
    [sym_preproc_region] = STATE(3498),
    [sym_preproc_endregion] = STATE(3498),
    [sym_preproc_line] = STATE(3498),
    [sym_preproc_pragma] = STATE(3498),
    [sym_preproc_nullable] = STATE(3498),
    [sym_preproc_error] = STATE(3498),
    [sym_preproc_define] = STATE(3498),
    [sym_preproc_undef] = STATE(3498),
    [sym__identifier_token] = ACTIONS(5131),
    [anon_sym_extern] = ACTIONS(5131),
    [anon_sym_alias] = ACTIONS(5131),
    [anon_sym_global] = ACTIONS(5131),
    [anon_sym_using] = ACTIONS(5131),
    [anon_sym_unsafe] = ACTIONS(5131),
    [anon_sym_static] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(5133),
    [anon_sym_LPAREN] = ACTIONS(5133),
    [anon_sym_event] = ACTIONS(5131),
    [anon_sym_namespace] = ACTIONS(5131),
    [anon_sym_class] = ACTIONS(5131),
    [anon_sym_ref] = ACTIONS(5131),
    [anon_sym_struct] = ACTIONS(5131),
    [anon_sym_enum] = ACTIONS(5131),
    [anon_sym_RBRACE] = ACTIONS(5133),
    [anon_sym_interface] = ACTIONS(5131),
    [anon_sym_delegate] = ACTIONS(5131),
    [anon_sym_record] = ACTIONS(5131),
    [anon_sym_abstract] = ACTIONS(5131),
    [anon_sym_async] = ACTIONS(5131),
    [anon_sym_const] = ACTIONS(5131),
    [anon_sym_file] = ACTIONS(5131),
    [anon_sym_fixed] = ACTIONS(5131),
    [anon_sym_internal] = ACTIONS(5131),
    [anon_sym_new] = ACTIONS(5131),
    [anon_sym_override] = ACTIONS(5131),
    [anon_sym_partial] = ACTIONS(5131),
    [anon_sym_private] = ACTIONS(5131),
    [anon_sym_protected] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(5131),
    [anon_sym_readonly] = ACTIONS(5131),
    [anon_sym_required] = ACTIONS(5131),
    [anon_sym_sealed] = ACTIONS(5131),
    [anon_sym_virtual] = ACTIONS(5131),
    [anon_sym_volatile] = ACTIONS(5131),
    [anon_sym_where] = ACTIONS(5131),
    [anon_sym_notnull] = ACTIONS(5131),
    [anon_sym_unmanaged] = ACTIONS(5131),
    [anon_sym_TILDE] = ACTIONS(5133),
    [anon_sym_implicit] = ACTIONS(5131),
    [anon_sym_explicit] = ACTIONS(5131),
    [anon_sym_scoped] = ACTIONS(5131),
    [anon_sym_var] = ACTIONS(5131),
    [sym_predefined_type] = ACTIONS(5131),
    [anon_sym_yield] = ACTIONS(5131),
    [anon_sym_when] = ACTIONS(5131),
    [anon_sym_from] = ACTIONS(5131),
    [anon_sym_into] = ACTIONS(5131),
    [anon_sym_join] = ACTIONS(5131),
    [anon_sym_on] = ACTIONS(5131),
    [anon_sym_equals] = ACTIONS(5131),
    [anon_sym_let] = ACTIONS(5131),
    [anon_sym_orderby] = ACTIONS(5131),
    [anon_sym_ascending] = ACTIONS(5131),
    [anon_sym_descending] = ACTIONS(5131),
    [anon_sym_group] = ACTIONS(5131),
    [anon_sym_by] = ACTIONS(5131),
    [anon_sym_select] = ACTIONS(5131),
    [aux_sym_preproc_if_token1] = ACTIONS(5133),
    [aux_sym_preproc_if_token3] = ACTIONS(5133),
    [aux_sym_preproc_else_token1] = ACTIONS(5133),
    [aux_sym_preproc_elif_token1] = ACTIONS(5133),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3499] = {
    [sym_preproc_region] = STATE(3499),
    [sym_preproc_endregion] = STATE(3499),
    [sym_preproc_line] = STATE(3499),
    [sym_preproc_pragma] = STATE(3499),
    [sym_preproc_nullable] = STATE(3499),
    [sym_preproc_error] = STATE(3499),
    [sym_preproc_define] = STATE(3499),
    [sym_preproc_undef] = STATE(3499),
    [sym__identifier_token] = ACTIONS(5135),
    [anon_sym_extern] = ACTIONS(5135),
    [anon_sym_alias] = ACTIONS(5135),
    [anon_sym_global] = ACTIONS(5135),
    [anon_sym_using] = ACTIONS(5135),
    [anon_sym_unsafe] = ACTIONS(5135),
    [anon_sym_static] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5137),
    [anon_sym_LPAREN] = ACTIONS(5137),
    [anon_sym_event] = ACTIONS(5135),
    [anon_sym_namespace] = ACTIONS(5135),
    [anon_sym_class] = ACTIONS(5135),
    [anon_sym_ref] = ACTIONS(5135),
    [anon_sym_struct] = ACTIONS(5135),
    [anon_sym_enum] = ACTIONS(5135),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_interface] = ACTIONS(5135),
    [anon_sym_delegate] = ACTIONS(5135),
    [anon_sym_record] = ACTIONS(5135),
    [anon_sym_abstract] = ACTIONS(5135),
    [anon_sym_async] = ACTIONS(5135),
    [anon_sym_const] = ACTIONS(5135),
    [anon_sym_file] = ACTIONS(5135),
    [anon_sym_fixed] = ACTIONS(5135),
    [anon_sym_internal] = ACTIONS(5135),
    [anon_sym_new] = ACTIONS(5135),
    [anon_sym_override] = ACTIONS(5135),
    [anon_sym_partial] = ACTIONS(5135),
    [anon_sym_private] = ACTIONS(5135),
    [anon_sym_protected] = ACTIONS(5135),
    [anon_sym_public] = ACTIONS(5135),
    [anon_sym_readonly] = ACTIONS(5135),
    [anon_sym_required] = ACTIONS(5135),
    [anon_sym_sealed] = ACTIONS(5135),
    [anon_sym_virtual] = ACTIONS(5135),
    [anon_sym_volatile] = ACTIONS(5135),
    [anon_sym_where] = ACTIONS(5135),
    [anon_sym_notnull] = ACTIONS(5135),
    [anon_sym_unmanaged] = ACTIONS(5135),
    [anon_sym_TILDE] = ACTIONS(5137),
    [anon_sym_implicit] = ACTIONS(5135),
    [anon_sym_explicit] = ACTIONS(5135),
    [anon_sym_scoped] = ACTIONS(5135),
    [anon_sym_var] = ACTIONS(5135),
    [sym_predefined_type] = ACTIONS(5135),
    [anon_sym_yield] = ACTIONS(5135),
    [anon_sym_when] = ACTIONS(5135),
    [anon_sym_from] = ACTIONS(5135),
    [anon_sym_into] = ACTIONS(5135),
    [anon_sym_join] = ACTIONS(5135),
    [anon_sym_on] = ACTIONS(5135),
    [anon_sym_equals] = ACTIONS(5135),
    [anon_sym_let] = ACTIONS(5135),
    [anon_sym_orderby] = ACTIONS(5135),
    [anon_sym_ascending] = ACTIONS(5135),
    [anon_sym_descending] = ACTIONS(5135),
    [anon_sym_group] = ACTIONS(5135),
    [anon_sym_by] = ACTIONS(5135),
    [anon_sym_select] = ACTIONS(5135),
    [aux_sym_preproc_if_token1] = ACTIONS(5137),
    [aux_sym_preproc_if_token3] = ACTIONS(5137),
    [aux_sym_preproc_else_token1] = ACTIONS(5137),
    [aux_sym_preproc_elif_token1] = ACTIONS(5137),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3500] = {
    [sym_preproc_region] = STATE(3500),
    [sym_preproc_endregion] = STATE(3500),
    [sym_preproc_line] = STATE(3500),
    [sym_preproc_pragma] = STATE(3500),
    [sym_preproc_nullable] = STATE(3500),
    [sym_preproc_error] = STATE(3500),
    [sym_preproc_define] = STATE(3500),
    [sym_preproc_undef] = STATE(3500),
    [sym__identifier_token] = ACTIONS(5139),
    [anon_sym_extern] = ACTIONS(5139),
    [anon_sym_alias] = ACTIONS(5139),
    [anon_sym_global] = ACTIONS(5139),
    [anon_sym_using] = ACTIONS(5139),
    [anon_sym_unsafe] = ACTIONS(5139),
    [anon_sym_static] = ACTIONS(5139),
    [anon_sym_LBRACK] = ACTIONS(5141),
    [anon_sym_LPAREN] = ACTIONS(5141),
    [anon_sym_event] = ACTIONS(5139),
    [anon_sym_namespace] = ACTIONS(5139),
    [anon_sym_class] = ACTIONS(5139),
    [anon_sym_ref] = ACTIONS(5139),
    [anon_sym_struct] = ACTIONS(5139),
    [anon_sym_enum] = ACTIONS(5139),
    [anon_sym_RBRACE] = ACTIONS(5141),
    [anon_sym_interface] = ACTIONS(5139),
    [anon_sym_delegate] = ACTIONS(5139),
    [anon_sym_record] = ACTIONS(5139),
    [anon_sym_abstract] = ACTIONS(5139),
    [anon_sym_async] = ACTIONS(5139),
    [anon_sym_const] = ACTIONS(5139),
    [anon_sym_file] = ACTIONS(5139),
    [anon_sym_fixed] = ACTIONS(5139),
    [anon_sym_internal] = ACTIONS(5139),
    [anon_sym_new] = ACTIONS(5139),
    [anon_sym_override] = ACTIONS(5139),
    [anon_sym_partial] = ACTIONS(5139),
    [anon_sym_private] = ACTIONS(5139),
    [anon_sym_protected] = ACTIONS(5139),
    [anon_sym_public] = ACTIONS(5139),
    [anon_sym_readonly] = ACTIONS(5139),
    [anon_sym_required] = ACTIONS(5139),
    [anon_sym_sealed] = ACTIONS(5139),
    [anon_sym_virtual] = ACTIONS(5139),
    [anon_sym_volatile] = ACTIONS(5139),
    [anon_sym_where] = ACTIONS(5139),
    [anon_sym_notnull] = ACTIONS(5139),
    [anon_sym_unmanaged] = ACTIONS(5139),
    [anon_sym_TILDE] = ACTIONS(5141),
    [anon_sym_implicit] = ACTIONS(5139),
    [anon_sym_explicit] = ACTIONS(5139),
    [anon_sym_scoped] = ACTIONS(5139),
    [anon_sym_var] = ACTIONS(5139),
    [sym_predefined_type] = ACTIONS(5139),
    [anon_sym_yield] = ACTIONS(5139),
    [anon_sym_when] = ACTIONS(5139),
    [anon_sym_from] = ACTIONS(5139),
    [anon_sym_into] = ACTIONS(5139),
    [anon_sym_join] = ACTIONS(5139),
    [anon_sym_on] = ACTIONS(5139),
    [anon_sym_equals] = ACTIONS(5139),
    [anon_sym_let] = ACTIONS(5139),
    [anon_sym_orderby] = ACTIONS(5139),
    [anon_sym_ascending] = ACTIONS(5139),
    [anon_sym_descending] = ACTIONS(5139),
    [anon_sym_group] = ACTIONS(5139),
    [anon_sym_by] = ACTIONS(5139),
    [anon_sym_select] = ACTIONS(5139),
    [aux_sym_preproc_if_token1] = ACTIONS(5141),
    [aux_sym_preproc_if_token3] = ACTIONS(5141),
    [aux_sym_preproc_else_token1] = ACTIONS(5141),
    [aux_sym_preproc_elif_token1] = ACTIONS(5141),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3501] = {
    [sym_preproc_region] = STATE(3501),
    [sym_preproc_endregion] = STATE(3501),
    [sym_preproc_line] = STATE(3501),
    [sym_preproc_pragma] = STATE(3501),
    [sym_preproc_nullable] = STATE(3501),
    [sym_preproc_error] = STATE(3501),
    [sym_preproc_define] = STATE(3501),
    [sym_preproc_undef] = STATE(3501),
    [sym__identifier_token] = ACTIONS(3945),
    [anon_sym_extern] = ACTIONS(3945),
    [anon_sym_alias] = ACTIONS(3945),
    [anon_sym_global] = ACTIONS(3945),
    [anon_sym_using] = ACTIONS(3945),
    [anon_sym_unsafe] = ACTIONS(3945),
    [anon_sym_static] = ACTIONS(3945),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LPAREN] = ACTIONS(3947),
    [anon_sym_event] = ACTIONS(3945),
    [anon_sym_namespace] = ACTIONS(3945),
    [anon_sym_class] = ACTIONS(3945),
    [anon_sym_ref] = ACTIONS(3945),
    [anon_sym_struct] = ACTIONS(3945),
    [anon_sym_enum] = ACTIONS(3945),
    [anon_sym_RBRACE] = ACTIONS(3947),
    [anon_sym_interface] = ACTIONS(3945),
    [anon_sym_delegate] = ACTIONS(3945),
    [anon_sym_record] = ACTIONS(3945),
    [anon_sym_abstract] = ACTIONS(3945),
    [anon_sym_async] = ACTIONS(3945),
    [anon_sym_const] = ACTIONS(3945),
    [anon_sym_file] = ACTIONS(3945),
    [anon_sym_fixed] = ACTIONS(3945),
    [anon_sym_internal] = ACTIONS(3945),
    [anon_sym_new] = ACTIONS(3945),
    [anon_sym_override] = ACTIONS(3945),
    [anon_sym_partial] = ACTIONS(3945),
    [anon_sym_private] = ACTIONS(3945),
    [anon_sym_protected] = ACTIONS(3945),
    [anon_sym_public] = ACTIONS(3945),
    [anon_sym_readonly] = ACTIONS(3945),
    [anon_sym_required] = ACTIONS(3945),
    [anon_sym_sealed] = ACTIONS(3945),
    [anon_sym_virtual] = ACTIONS(3945),
    [anon_sym_volatile] = ACTIONS(3945),
    [anon_sym_where] = ACTIONS(3945),
    [anon_sym_notnull] = ACTIONS(3945),
    [anon_sym_unmanaged] = ACTIONS(3945),
    [anon_sym_TILDE] = ACTIONS(3947),
    [anon_sym_implicit] = ACTIONS(3945),
    [anon_sym_explicit] = ACTIONS(3945),
    [anon_sym_scoped] = ACTIONS(3945),
    [anon_sym_var] = ACTIONS(3945),
    [sym_predefined_type] = ACTIONS(3945),
    [anon_sym_yield] = ACTIONS(3945),
    [anon_sym_when] = ACTIONS(3945),
    [anon_sym_from] = ACTIONS(3945),
    [anon_sym_into] = ACTIONS(3945),
    [anon_sym_join] = ACTIONS(3945),
    [anon_sym_on] = ACTIONS(3945),
    [anon_sym_equals] = ACTIONS(3945),
    [anon_sym_let] = ACTIONS(3945),
    [anon_sym_orderby] = ACTIONS(3945),
    [anon_sym_ascending] = ACTIONS(3945),
    [anon_sym_descending] = ACTIONS(3945),
    [anon_sym_group] = ACTIONS(3945),
    [anon_sym_by] = ACTIONS(3945),
    [anon_sym_select] = ACTIONS(3945),
    [aux_sym_preproc_if_token1] = ACTIONS(3947),
    [aux_sym_preproc_if_token3] = ACTIONS(3947),
    [aux_sym_preproc_else_token1] = ACTIONS(3947),
    [aux_sym_preproc_elif_token1] = ACTIONS(3947),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3502] = {
    [sym_preproc_region] = STATE(3502),
    [sym_preproc_endregion] = STATE(3502),
    [sym_preproc_line] = STATE(3502),
    [sym_preproc_pragma] = STATE(3502),
    [sym_preproc_nullable] = STATE(3502),
    [sym_preproc_error] = STATE(3502),
    [sym_preproc_define] = STATE(3502),
    [sym_preproc_undef] = STATE(3502),
    [sym__identifier_token] = ACTIONS(5143),
    [anon_sym_extern] = ACTIONS(5143),
    [anon_sym_alias] = ACTIONS(5143),
    [anon_sym_global] = ACTIONS(5143),
    [anon_sym_using] = ACTIONS(5143),
    [anon_sym_unsafe] = ACTIONS(5143),
    [anon_sym_static] = ACTIONS(5143),
    [anon_sym_LBRACK] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_event] = ACTIONS(5143),
    [anon_sym_namespace] = ACTIONS(5143),
    [anon_sym_class] = ACTIONS(5143),
    [anon_sym_ref] = ACTIONS(5143),
    [anon_sym_struct] = ACTIONS(5143),
    [anon_sym_enum] = ACTIONS(5143),
    [anon_sym_RBRACE] = ACTIONS(5145),
    [anon_sym_interface] = ACTIONS(5143),
    [anon_sym_delegate] = ACTIONS(5143),
    [anon_sym_record] = ACTIONS(5143),
    [anon_sym_abstract] = ACTIONS(5143),
    [anon_sym_async] = ACTIONS(5143),
    [anon_sym_const] = ACTIONS(5143),
    [anon_sym_file] = ACTIONS(5143),
    [anon_sym_fixed] = ACTIONS(5143),
    [anon_sym_internal] = ACTIONS(5143),
    [anon_sym_new] = ACTIONS(5143),
    [anon_sym_override] = ACTIONS(5143),
    [anon_sym_partial] = ACTIONS(5143),
    [anon_sym_private] = ACTIONS(5143),
    [anon_sym_protected] = ACTIONS(5143),
    [anon_sym_public] = ACTIONS(5143),
    [anon_sym_readonly] = ACTIONS(5143),
    [anon_sym_required] = ACTIONS(5143),
    [anon_sym_sealed] = ACTIONS(5143),
    [anon_sym_virtual] = ACTIONS(5143),
    [anon_sym_volatile] = ACTIONS(5143),
    [anon_sym_where] = ACTIONS(5143),
    [anon_sym_notnull] = ACTIONS(5143),
    [anon_sym_unmanaged] = ACTIONS(5143),
    [anon_sym_TILDE] = ACTIONS(5145),
    [anon_sym_implicit] = ACTIONS(5143),
    [anon_sym_explicit] = ACTIONS(5143),
    [anon_sym_scoped] = ACTIONS(5143),
    [anon_sym_var] = ACTIONS(5143),
    [sym_predefined_type] = ACTIONS(5143),
    [anon_sym_yield] = ACTIONS(5143),
    [anon_sym_when] = ACTIONS(5143),
    [anon_sym_from] = ACTIONS(5143),
    [anon_sym_into] = ACTIONS(5143),
    [anon_sym_join] = ACTIONS(5143),
    [anon_sym_on] = ACTIONS(5143),
    [anon_sym_equals] = ACTIONS(5143),
    [anon_sym_let] = ACTIONS(5143),
    [anon_sym_orderby] = ACTIONS(5143),
    [anon_sym_ascending] = ACTIONS(5143),
    [anon_sym_descending] = ACTIONS(5143),
    [anon_sym_group] = ACTIONS(5143),
    [anon_sym_by] = ACTIONS(5143),
    [anon_sym_select] = ACTIONS(5143),
    [aux_sym_preproc_if_token1] = ACTIONS(5145),
    [aux_sym_preproc_if_token3] = ACTIONS(5145),
    [aux_sym_preproc_else_token1] = ACTIONS(5145),
    [aux_sym_preproc_elif_token1] = ACTIONS(5145),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3503] = {
    [sym_preproc_region] = STATE(3503),
    [sym_preproc_endregion] = STATE(3503),
    [sym_preproc_line] = STATE(3503),
    [sym_preproc_pragma] = STATE(3503),
    [sym_preproc_nullable] = STATE(3503),
    [sym_preproc_error] = STATE(3503),
    [sym_preproc_define] = STATE(3503),
    [sym_preproc_undef] = STATE(3503),
    [anon_sym_SEMI] = ACTIONS(4695),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_RBRACK] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_RPAREN] = ACTIONS(4695),
    [anon_sym_RBRACE] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_EQ_GT] = ACTIONS(4695),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_when] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_on] = ACTIONS(4695),
    [anon_sym_equals] = ACTIONS(4695),
    [anon_sym_by] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_if_token3] = ACTIONS(4695),
    [aux_sym_preproc_else_token1] = ACTIONS(4695),
    [aux_sym_preproc_elif_token1] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3504] = {
    [sym_preproc_region] = STATE(3504),
    [sym_preproc_endregion] = STATE(3504),
    [sym_preproc_line] = STATE(3504),
    [sym_preproc_pragma] = STATE(3504),
    [sym_preproc_nullable] = STATE(3504),
    [sym_preproc_error] = STATE(3504),
    [sym_preproc_define] = STATE(3504),
    [sym_preproc_undef] = STATE(3504),
    [sym__identifier_token] = ACTIONS(3839),
    [anon_sym_extern] = ACTIONS(3839),
    [anon_sym_alias] = ACTIONS(3839),
    [anon_sym_global] = ACTIONS(3839),
    [anon_sym_using] = ACTIONS(3839),
    [anon_sym_unsafe] = ACTIONS(3839),
    [anon_sym_static] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_event] = ACTIONS(3839),
    [anon_sym_namespace] = ACTIONS(3839),
    [anon_sym_class] = ACTIONS(3839),
    [anon_sym_ref] = ACTIONS(3839),
    [anon_sym_struct] = ACTIONS(3839),
    [anon_sym_enum] = ACTIONS(3839),
    [anon_sym_RBRACE] = ACTIONS(3841),
    [anon_sym_interface] = ACTIONS(3839),
    [anon_sym_delegate] = ACTIONS(3839),
    [anon_sym_record] = ACTIONS(3839),
    [anon_sym_abstract] = ACTIONS(3839),
    [anon_sym_async] = ACTIONS(3839),
    [anon_sym_const] = ACTIONS(3839),
    [anon_sym_file] = ACTIONS(3839),
    [anon_sym_fixed] = ACTIONS(3839),
    [anon_sym_internal] = ACTIONS(3839),
    [anon_sym_new] = ACTIONS(3839),
    [anon_sym_override] = ACTIONS(3839),
    [anon_sym_partial] = ACTIONS(3839),
    [anon_sym_private] = ACTIONS(3839),
    [anon_sym_protected] = ACTIONS(3839),
    [anon_sym_public] = ACTIONS(3839),
    [anon_sym_readonly] = ACTIONS(3839),
    [anon_sym_required] = ACTIONS(3839),
    [anon_sym_sealed] = ACTIONS(3839),
    [anon_sym_virtual] = ACTIONS(3839),
    [anon_sym_volatile] = ACTIONS(3839),
    [anon_sym_where] = ACTIONS(3839),
    [anon_sym_notnull] = ACTIONS(3839),
    [anon_sym_unmanaged] = ACTIONS(3839),
    [anon_sym_TILDE] = ACTIONS(3841),
    [anon_sym_implicit] = ACTIONS(3839),
    [anon_sym_explicit] = ACTIONS(3839),
    [anon_sym_scoped] = ACTIONS(3839),
    [anon_sym_var] = ACTIONS(3839),
    [sym_predefined_type] = ACTIONS(3839),
    [anon_sym_yield] = ACTIONS(3839),
    [anon_sym_when] = ACTIONS(3839),
    [anon_sym_from] = ACTIONS(3839),
    [anon_sym_into] = ACTIONS(3839),
    [anon_sym_join] = ACTIONS(3839),
    [anon_sym_on] = ACTIONS(3839),
    [anon_sym_equals] = ACTIONS(3839),
    [anon_sym_let] = ACTIONS(3839),
    [anon_sym_orderby] = ACTIONS(3839),
    [anon_sym_ascending] = ACTIONS(3839),
    [anon_sym_descending] = ACTIONS(3839),
    [anon_sym_group] = ACTIONS(3839),
    [anon_sym_by] = ACTIONS(3839),
    [anon_sym_select] = ACTIONS(3839),
    [aux_sym_preproc_if_token1] = ACTIONS(3841),
    [aux_sym_preproc_if_token3] = ACTIONS(3841),
    [aux_sym_preproc_else_token1] = ACTIONS(3841),
    [aux_sym_preproc_elif_token1] = ACTIONS(3841),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3505] = {
    [sym_preproc_region] = STATE(3505),
    [sym_preproc_endregion] = STATE(3505),
    [sym_preproc_line] = STATE(3505),
    [sym_preproc_pragma] = STATE(3505),
    [sym_preproc_nullable] = STATE(3505),
    [sym_preproc_error] = STATE(3505),
    [sym_preproc_define] = STATE(3505),
    [sym_preproc_undef] = STATE(3505),
    [sym__identifier_token] = ACTIONS(5147),
    [anon_sym_extern] = ACTIONS(5147),
    [anon_sym_alias] = ACTIONS(5147),
    [anon_sym_global] = ACTIONS(5147),
    [anon_sym_using] = ACTIONS(5147),
    [anon_sym_unsafe] = ACTIONS(5147),
    [anon_sym_static] = ACTIONS(5147),
    [anon_sym_LBRACK] = ACTIONS(5149),
    [anon_sym_LPAREN] = ACTIONS(5149),
    [anon_sym_event] = ACTIONS(5147),
    [anon_sym_namespace] = ACTIONS(5147),
    [anon_sym_class] = ACTIONS(5147),
    [anon_sym_ref] = ACTIONS(5147),
    [anon_sym_struct] = ACTIONS(5147),
    [anon_sym_enum] = ACTIONS(5147),
    [anon_sym_RBRACE] = ACTIONS(5149),
    [anon_sym_interface] = ACTIONS(5147),
    [anon_sym_delegate] = ACTIONS(5147),
    [anon_sym_record] = ACTIONS(5147),
    [anon_sym_abstract] = ACTIONS(5147),
    [anon_sym_async] = ACTIONS(5147),
    [anon_sym_const] = ACTIONS(5147),
    [anon_sym_file] = ACTIONS(5147),
    [anon_sym_fixed] = ACTIONS(5147),
    [anon_sym_internal] = ACTIONS(5147),
    [anon_sym_new] = ACTIONS(5147),
    [anon_sym_override] = ACTIONS(5147),
    [anon_sym_partial] = ACTIONS(5147),
    [anon_sym_private] = ACTIONS(5147),
    [anon_sym_protected] = ACTIONS(5147),
    [anon_sym_public] = ACTIONS(5147),
    [anon_sym_readonly] = ACTIONS(5147),
    [anon_sym_required] = ACTIONS(5147),
    [anon_sym_sealed] = ACTIONS(5147),
    [anon_sym_virtual] = ACTIONS(5147),
    [anon_sym_volatile] = ACTIONS(5147),
    [anon_sym_where] = ACTIONS(5147),
    [anon_sym_notnull] = ACTIONS(5147),
    [anon_sym_unmanaged] = ACTIONS(5147),
    [anon_sym_TILDE] = ACTIONS(5149),
    [anon_sym_implicit] = ACTIONS(5147),
    [anon_sym_explicit] = ACTIONS(5147),
    [anon_sym_scoped] = ACTIONS(5147),
    [anon_sym_var] = ACTIONS(5147),
    [sym_predefined_type] = ACTIONS(5147),
    [anon_sym_yield] = ACTIONS(5147),
    [anon_sym_when] = ACTIONS(5147),
    [anon_sym_from] = ACTIONS(5147),
    [anon_sym_into] = ACTIONS(5147),
    [anon_sym_join] = ACTIONS(5147),
    [anon_sym_on] = ACTIONS(5147),
    [anon_sym_equals] = ACTIONS(5147),
    [anon_sym_let] = ACTIONS(5147),
    [anon_sym_orderby] = ACTIONS(5147),
    [anon_sym_ascending] = ACTIONS(5147),
    [anon_sym_descending] = ACTIONS(5147),
    [anon_sym_group] = ACTIONS(5147),
    [anon_sym_by] = ACTIONS(5147),
    [anon_sym_select] = ACTIONS(5147),
    [aux_sym_preproc_if_token1] = ACTIONS(5149),
    [aux_sym_preproc_if_token3] = ACTIONS(5149),
    [aux_sym_preproc_else_token1] = ACTIONS(5149),
    [aux_sym_preproc_elif_token1] = ACTIONS(5149),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3506] = {
    [sym_preproc_region] = STATE(3506),
    [sym_preproc_endregion] = STATE(3506),
    [sym_preproc_line] = STATE(3506),
    [sym_preproc_pragma] = STATE(3506),
    [sym_preproc_nullable] = STATE(3506),
    [sym_preproc_error] = STATE(3506),
    [sym_preproc_define] = STATE(3506),
    [sym_preproc_undef] = STATE(3506),
    [sym__identifier_token] = ACTIONS(3831),
    [anon_sym_extern] = ACTIONS(3831),
    [anon_sym_alias] = ACTIONS(3831),
    [anon_sym_global] = ACTIONS(3831),
    [anon_sym_using] = ACTIONS(3831),
    [anon_sym_unsafe] = ACTIONS(3831),
    [anon_sym_static] = ACTIONS(3831),
    [anon_sym_LBRACK] = ACTIONS(3833),
    [anon_sym_LPAREN] = ACTIONS(3833),
    [anon_sym_event] = ACTIONS(3831),
    [anon_sym_namespace] = ACTIONS(3831),
    [anon_sym_class] = ACTIONS(3831),
    [anon_sym_ref] = ACTIONS(3831),
    [anon_sym_struct] = ACTIONS(3831),
    [anon_sym_enum] = ACTIONS(3831),
    [anon_sym_RBRACE] = ACTIONS(3833),
    [anon_sym_interface] = ACTIONS(3831),
    [anon_sym_delegate] = ACTIONS(3831),
    [anon_sym_record] = ACTIONS(3831),
    [anon_sym_abstract] = ACTIONS(3831),
    [anon_sym_async] = ACTIONS(3831),
    [anon_sym_const] = ACTIONS(3831),
    [anon_sym_file] = ACTIONS(3831),
    [anon_sym_fixed] = ACTIONS(3831),
    [anon_sym_internal] = ACTIONS(3831),
    [anon_sym_new] = ACTIONS(3831),
    [anon_sym_override] = ACTIONS(3831),
    [anon_sym_partial] = ACTIONS(3831),
    [anon_sym_private] = ACTIONS(3831),
    [anon_sym_protected] = ACTIONS(3831),
    [anon_sym_public] = ACTIONS(3831),
    [anon_sym_readonly] = ACTIONS(3831),
    [anon_sym_required] = ACTIONS(3831),
    [anon_sym_sealed] = ACTIONS(3831),
    [anon_sym_virtual] = ACTIONS(3831),
    [anon_sym_volatile] = ACTIONS(3831),
    [anon_sym_where] = ACTIONS(3831),
    [anon_sym_notnull] = ACTIONS(3831),
    [anon_sym_unmanaged] = ACTIONS(3831),
    [anon_sym_TILDE] = ACTIONS(3833),
    [anon_sym_implicit] = ACTIONS(3831),
    [anon_sym_explicit] = ACTIONS(3831),
    [anon_sym_scoped] = ACTIONS(3831),
    [anon_sym_var] = ACTIONS(3831),
    [sym_predefined_type] = ACTIONS(3831),
    [anon_sym_yield] = ACTIONS(3831),
    [anon_sym_when] = ACTIONS(3831),
    [anon_sym_from] = ACTIONS(3831),
    [anon_sym_into] = ACTIONS(3831),
    [anon_sym_join] = ACTIONS(3831),
    [anon_sym_on] = ACTIONS(3831),
    [anon_sym_equals] = ACTIONS(3831),
    [anon_sym_let] = ACTIONS(3831),
    [anon_sym_orderby] = ACTIONS(3831),
    [anon_sym_ascending] = ACTIONS(3831),
    [anon_sym_descending] = ACTIONS(3831),
    [anon_sym_group] = ACTIONS(3831),
    [anon_sym_by] = ACTIONS(3831),
    [anon_sym_select] = ACTIONS(3831),
    [aux_sym_preproc_if_token1] = ACTIONS(3833),
    [aux_sym_preproc_if_token3] = ACTIONS(3833),
    [aux_sym_preproc_else_token1] = ACTIONS(3833),
    [aux_sym_preproc_elif_token1] = ACTIONS(3833),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3507] = {
    [sym_preproc_region] = STATE(3507),
    [sym_preproc_endregion] = STATE(3507),
    [sym_preproc_line] = STATE(3507),
    [sym_preproc_pragma] = STATE(3507),
    [sym_preproc_nullable] = STATE(3507),
    [sym_preproc_error] = STATE(3507),
    [sym_preproc_define] = STATE(3507),
    [sym_preproc_undef] = STATE(3507),
    [sym__identifier_token] = ACTIONS(3827),
    [anon_sym_extern] = ACTIONS(3827),
    [anon_sym_alias] = ACTIONS(3827),
    [anon_sym_global] = ACTIONS(3827),
    [anon_sym_using] = ACTIONS(3827),
    [anon_sym_unsafe] = ACTIONS(3827),
    [anon_sym_static] = ACTIONS(3827),
    [anon_sym_LBRACK] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_event] = ACTIONS(3827),
    [anon_sym_namespace] = ACTIONS(3827),
    [anon_sym_class] = ACTIONS(3827),
    [anon_sym_ref] = ACTIONS(3827),
    [anon_sym_struct] = ACTIONS(3827),
    [anon_sym_enum] = ACTIONS(3827),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_interface] = ACTIONS(3827),
    [anon_sym_delegate] = ACTIONS(3827),
    [anon_sym_record] = ACTIONS(3827),
    [anon_sym_abstract] = ACTIONS(3827),
    [anon_sym_async] = ACTIONS(3827),
    [anon_sym_const] = ACTIONS(3827),
    [anon_sym_file] = ACTIONS(3827),
    [anon_sym_fixed] = ACTIONS(3827),
    [anon_sym_internal] = ACTIONS(3827),
    [anon_sym_new] = ACTIONS(3827),
    [anon_sym_override] = ACTIONS(3827),
    [anon_sym_partial] = ACTIONS(3827),
    [anon_sym_private] = ACTIONS(3827),
    [anon_sym_protected] = ACTIONS(3827),
    [anon_sym_public] = ACTIONS(3827),
    [anon_sym_readonly] = ACTIONS(3827),
    [anon_sym_required] = ACTIONS(3827),
    [anon_sym_sealed] = ACTIONS(3827),
    [anon_sym_virtual] = ACTIONS(3827),
    [anon_sym_volatile] = ACTIONS(3827),
    [anon_sym_where] = ACTIONS(3827),
    [anon_sym_notnull] = ACTIONS(3827),
    [anon_sym_unmanaged] = ACTIONS(3827),
    [anon_sym_TILDE] = ACTIONS(3829),
    [anon_sym_implicit] = ACTIONS(3827),
    [anon_sym_explicit] = ACTIONS(3827),
    [anon_sym_scoped] = ACTIONS(3827),
    [anon_sym_var] = ACTIONS(3827),
    [sym_predefined_type] = ACTIONS(3827),
    [anon_sym_yield] = ACTIONS(3827),
    [anon_sym_when] = ACTIONS(3827),
    [anon_sym_from] = ACTIONS(3827),
    [anon_sym_into] = ACTIONS(3827),
    [anon_sym_join] = ACTIONS(3827),
    [anon_sym_on] = ACTIONS(3827),
    [anon_sym_equals] = ACTIONS(3827),
    [anon_sym_let] = ACTIONS(3827),
    [anon_sym_orderby] = ACTIONS(3827),
    [anon_sym_ascending] = ACTIONS(3827),
    [anon_sym_descending] = ACTIONS(3827),
    [anon_sym_group] = ACTIONS(3827),
    [anon_sym_by] = ACTIONS(3827),
    [anon_sym_select] = ACTIONS(3827),
    [aux_sym_preproc_if_token1] = ACTIONS(3829),
    [aux_sym_preproc_if_token3] = ACTIONS(3829),
    [aux_sym_preproc_else_token1] = ACTIONS(3829),
    [aux_sym_preproc_elif_token1] = ACTIONS(3829),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3508] = {
    [sym_preproc_region] = STATE(3508),
    [sym_preproc_endregion] = STATE(3508),
    [sym_preproc_line] = STATE(3508),
    [sym_preproc_pragma] = STATE(3508),
    [sym_preproc_nullable] = STATE(3508),
    [sym_preproc_error] = STATE(3508),
    [sym_preproc_define] = STATE(3508),
    [sym_preproc_undef] = STATE(3508),
    [sym__identifier_token] = ACTIONS(5151),
    [anon_sym_extern] = ACTIONS(5151),
    [anon_sym_alias] = ACTIONS(5151),
    [anon_sym_global] = ACTIONS(5151),
    [anon_sym_using] = ACTIONS(5151),
    [anon_sym_unsafe] = ACTIONS(5151),
    [anon_sym_static] = ACTIONS(5151),
    [anon_sym_LBRACK] = ACTIONS(5153),
    [anon_sym_LPAREN] = ACTIONS(5153),
    [anon_sym_event] = ACTIONS(5151),
    [anon_sym_namespace] = ACTIONS(5151),
    [anon_sym_class] = ACTIONS(5151),
    [anon_sym_ref] = ACTIONS(5151),
    [anon_sym_struct] = ACTIONS(5151),
    [anon_sym_enum] = ACTIONS(5151),
    [anon_sym_RBRACE] = ACTIONS(5153),
    [anon_sym_interface] = ACTIONS(5151),
    [anon_sym_delegate] = ACTIONS(5151),
    [anon_sym_record] = ACTIONS(5151),
    [anon_sym_abstract] = ACTIONS(5151),
    [anon_sym_async] = ACTIONS(5151),
    [anon_sym_const] = ACTIONS(5151),
    [anon_sym_file] = ACTIONS(5151),
    [anon_sym_fixed] = ACTIONS(5151),
    [anon_sym_internal] = ACTIONS(5151),
    [anon_sym_new] = ACTIONS(5151),
    [anon_sym_override] = ACTIONS(5151),
    [anon_sym_partial] = ACTIONS(5151),
    [anon_sym_private] = ACTIONS(5151),
    [anon_sym_protected] = ACTIONS(5151),
    [anon_sym_public] = ACTIONS(5151),
    [anon_sym_readonly] = ACTIONS(5151),
    [anon_sym_required] = ACTIONS(5151),
    [anon_sym_sealed] = ACTIONS(5151),
    [anon_sym_virtual] = ACTIONS(5151),
    [anon_sym_volatile] = ACTIONS(5151),
    [anon_sym_where] = ACTIONS(5151),
    [anon_sym_notnull] = ACTIONS(5151),
    [anon_sym_unmanaged] = ACTIONS(5151),
    [anon_sym_TILDE] = ACTIONS(5153),
    [anon_sym_implicit] = ACTIONS(5151),
    [anon_sym_explicit] = ACTIONS(5151),
    [anon_sym_scoped] = ACTIONS(5151),
    [anon_sym_var] = ACTIONS(5151),
    [sym_predefined_type] = ACTIONS(5151),
    [anon_sym_yield] = ACTIONS(5151),
    [anon_sym_when] = ACTIONS(5151),
    [anon_sym_from] = ACTIONS(5151),
    [anon_sym_into] = ACTIONS(5151),
    [anon_sym_join] = ACTIONS(5151),
    [anon_sym_on] = ACTIONS(5151),
    [anon_sym_equals] = ACTIONS(5151),
    [anon_sym_let] = ACTIONS(5151),
    [anon_sym_orderby] = ACTIONS(5151),
    [anon_sym_ascending] = ACTIONS(5151),
    [anon_sym_descending] = ACTIONS(5151),
    [anon_sym_group] = ACTIONS(5151),
    [anon_sym_by] = ACTIONS(5151),
    [anon_sym_select] = ACTIONS(5151),
    [aux_sym_preproc_if_token1] = ACTIONS(5153),
    [aux_sym_preproc_if_token3] = ACTIONS(5153),
    [aux_sym_preproc_else_token1] = ACTIONS(5153),
    [aux_sym_preproc_elif_token1] = ACTIONS(5153),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3509] = {
    [sym_preproc_region] = STATE(3509),
    [sym_preproc_endregion] = STATE(3509),
    [sym_preproc_line] = STATE(3509),
    [sym_preproc_pragma] = STATE(3509),
    [sym_preproc_nullable] = STATE(3509),
    [sym_preproc_error] = STATE(3509),
    [sym_preproc_define] = STATE(3509),
    [sym_preproc_undef] = STATE(3509),
    [sym__identifier_token] = ACTIONS(5155),
    [anon_sym_extern] = ACTIONS(5155),
    [anon_sym_alias] = ACTIONS(5155),
    [anon_sym_global] = ACTIONS(5155),
    [anon_sym_using] = ACTIONS(5155),
    [anon_sym_unsafe] = ACTIONS(5155),
    [anon_sym_static] = ACTIONS(5155),
    [anon_sym_LBRACK] = ACTIONS(5157),
    [anon_sym_LPAREN] = ACTIONS(5157),
    [anon_sym_event] = ACTIONS(5155),
    [anon_sym_namespace] = ACTIONS(5155),
    [anon_sym_class] = ACTIONS(5155),
    [anon_sym_ref] = ACTIONS(5155),
    [anon_sym_struct] = ACTIONS(5155),
    [anon_sym_enum] = ACTIONS(5155),
    [anon_sym_RBRACE] = ACTIONS(5157),
    [anon_sym_interface] = ACTIONS(5155),
    [anon_sym_delegate] = ACTIONS(5155),
    [anon_sym_record] = ACTIONS(5155),
    [anon_sym_abstract] = ACTIONS(5155),
    [anon_sym_async] = ACTIONS(5155),
    [anon_sym_const] = ACTIONS(5155),
    [anon_sym_file] = ACTIONS(5155),
    [anon_sym_fixed] = ACTIONS(5155),
    [anon_sym_internal] = ACTIONS(5155),
    [anon_sym_new] = ACTIONS(5155),
    [anon_sym_override] = ACTIONS(5155),
    [anon_sym_partial] = ACTIONS(5155),
    [anon_sym_private] = ACTIONS(5155),
    [anon_sym_protected] = ACTIONS(5155),
    [anon_sym_public] = ACTIONS(5155),
    [anon_sym_readonly] = ACTIONS(5155),
    [anon_sym_required] = ACTIONS(5155),
    [anon_sym_sealed] = ACTIONS(5155),
    [anon_sym_virtual] = ACTIONS(5155),
    [anon_sym_volatile] = ACTIONS(5155),
    [anon_sym_where] = ACTIONS(5155),
    [anon_sym_notnull] = ACTIONS(5155),
    [anon_sym_unmanaged] = ACTIONS(5155),
    [anon_sym_TILDE] = ACTIONS(5157),
    [anon_sym_implicit] = ACTIONS(5155),
    [anon_sym_explicit] = ACTIONS(5155),
    [anon_sym_scoped] = ACTIONS(5155),
    [anon_sym_var] = ACTIONS(5155),
    [sym_predefined_type] = ACTIONS(5155),
    [anon_sym_yield] = ACTIONS(5155),
    [anon_sym_when] = ACTIONS(5155),
    [anon_sym_from] = ACTIONS(5155),
    [anon_sym_into] = ACTIONS(5155),
    [anon_sym_join] = ACTIONS(5155),
    [anon_sym_on] = ACTIONS(5155),
    [anon_sym_equals] = ACTIONS(5155),
    [anon_sym_let] = ACTIONS(5155),
    [anon_sym_orderby] = ACTIONS(5155),
    [anon_sym_ascending] = ACTIONS(5155),
    [anon_sym_descending] = ACTIONS(5155),
    [anon_sym_group] = ACTIONS(5155),
    [anon_sym_by] = ACTIONS(5155),
    [anon_sym_select] = ACTIONS(5155),
    [aux_sym_preproc_if_token1] = ACTIONS(5157),
    [aux_sym_preproc_if_token3] = ACTIONS(5157),
    [aux_sym_preproc_else_token1] = ACTIONS(5157),
    [aux_sym_preproc_elif_token1] = ACTIONS(5157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3510] = {
    [sym_preproc_region] = STATE(3510),
    [sym_preproc_endregion] = STATE(3510),
    [sym_preproc_line] = STATE(3510),
    [sym_preproc_pragma] = STATE(3510),
    [sym_preproc_nullable] = STATE(3510),
    [sym_preproc_error] = STATE(3510),
    [sym_preproc_define] = STATE(3510),
    [sym_preproc_undef] = STATE(3510),
    [sym__identifier_token] = ACTIONS(5159),
    [anon_sym_extern] = ACTIONS(5159),
    [anon_sym_alias] = ACTIONS(5159),
    [anon_sym_global] = ACTIONS(5159),
    [anon_sym_using] = ACTIONS(5159),
    [anon_sym_unsafe] = ACTIONS(5159),
    [anon_sym_static] = ACTIONS(5159),
    [anon_sym_LBRACK] = ACTIONS(5161),
    [anon_sym_LPAREN] = ACTIONS(5161),
    [anon_sym_event] = ACTIONS(5159),
    [anon_sym_namespace] = ACTIONS(5159),
    [anon_sym_class] = ACTIONS(5159),
    [anon_sym_ref] = ACTIONS(5159),
    [anon_sym_struct] = ACTIONS(5159),
    [anon_sym_enum] = ACTIONS(5159),
    [anon_sym_RBRACE] = ACTIONS(5161),
    [anon_sym_interface] = ACTIONS(5159),
    [anon_sym_delegate] = ACTIONS(5159),
    [anon_sym_record] = ACTIONS(5159),
    [anon_sym_abstract] = ACTIONS(5159),
    [anon_sym_async] = ACTIONS(5159),
    [anon_sym_const] = ACTIONS(5159),
    [anon_sym_file] = ACTIONS(5159),
    [anon_sym_fixed] = ACTIONS(5159),
    [anon_sym_internal] = ACTIONS(5159),
    [anon_sym_new] = ACTIONS(5159),
    [anon_sym_override] = ACTIONS(5159),
    [anon_sym_partial] = ACTIONS(5159),
    [anon_sym_private] = ACTIONS(5159),
    [anon_sym_protected] = ACTIONS(5159),
    [anon_sym_public] = ACTIONS(5159),
    [anon_sym_readonly] = ACTIONS(5159),
    [anon_sym_required] = ACTIONS(5159),
    [anon_sym_sealed] = ACTIONS(5159),
    [anon_sym_virtual] = ACTIONS(5159),
    [anon_sym_volatile] = ACTIONS(5159),
    [anon_sym_where] = ACTIONS(5159),
    [anon_sym_notnull] = ACTIONS(5159),
    [anon_sym_unmanaged] = ACTIONS(5159),
    [anon_sym_TILDE] = ACTIONS(5161),
    [anon_sym_implicit] = ACTIONS(5159),
    [anon_sym_explicit] = ACTIONS(5159),
    [anon_sym_scoped] = ACTIONS(5159),
    [anon_sym_var] = ACTIONS(5159),
    [sym_predefined_type] = ACTIONS(5159),
    [anon_sym_yield] = ACTIONS(5159),
    [anon_sym_when] = ACTIONS(5159),
    [anon_sym_from] = ACTIONS(5159),
    [anon_sym_into] = ACTIONS(5159),
    [anon_sym_join] = ACTIONS(5159),
    [anon_sym_on] = ACTIONS(5159),
    [anon_sym_equals] = ACTIONS(5159),
    [anon_sym_let] = ACTIONS(5159),
    [anon_sym_orderby] = ACTIONS(5159),
    [anon_sym_ascending] = ACTIONS(5159),
    [anon_sym_descending] = ACTIONS(5159),
    [anon_sym_group] = ACTIONS(5159),
    [anon_sym_by] = ACTIONS(5159),
    [anon_sym_select] = ACTIONS(5159),
    [aux_sym_preproc_if_token1] = ACTIONS(5161),
    [aux_sym_preproc_if_token3] = ACTIONS(5161),
    [aux_sym_preproc_else_token1] = ACTIONS(5161),
    [aux_sym_preproc_elif_token1] = ACTIONS(5161),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3511] = {
    [sym_preproc_region] = STATE(3511),
    [sym_preproc_endregion] = STATE(3511),
    [sym_preproc_line] = STATE(3511),
    [sym_preproc_pragma] = STATE(3511),
    [sym_preproc_nullable] = STATE(3511),
    [sym_preproc_error] = STATE(3511),
    [sym_preproc_define] = STATE(3511),
    [sym_preproc_undef] = STATE(3511),
    [sym__identifier_token] = ACTIONS(5163),
    [anon_sym_extern] = ACTIONS(5163),
    [anon_sym_alias] = ACTIONS(5163),
    [anon_sym_global] = ACTIONS(5163),
    [anon_sym_using] = ACTIONS(5163),
    [anon_sym_unsafe] = ACTIONS(5163),
    [anon_sym_static] = ACTIONS(5163),
    [anon_sym_LBRACK] = ACTIONS(5165),
    [anon_sym_LPAREN] = ACTIONS(5165),
    [anon_sym_event] = ACTIONS(5163),
    [anon_sym_namespace] = ACTIONS(5163),
    [anon_sym_class] = ACTIONS(5163),
    [anon_sym_ref] = ACTIONS(5163),
    [anon_sym_struct] = ACTIONS(5163),
    [anon_sym_enum] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5165),
    [anon_sym_interface] = ACTIONS(5163),
    [anon_sym_delegate] = ACTIONS(5163),
    [anon_sym_record] = ACTIONS(5163),
    [anon_sym_abstract] = ACTIONS(5163),
    [anon_sym_async] = ACTIONS(5163),
    [anon_sym_const] = ACTIONS(5163),
    [anon_sym_file] = ACTIONS(5163),
    [anon_sym_fixed] = ACTIONS(5163),
    [anon_sym_internal] = ACTIONS(5163),
    [anon_sym_new] = ACTIONS(5163),
    [anon_sym_override] = ACTIONS(5163),
    [anon_sym_partial] = ACTIONS(5163),
    [anon_sym_private] = ACTIONS(5163),
    [anon_sym_protected] = ACTIONS(5163),
    [anon_sym_public] = ACTIONS(5163),
    [anon_sym_readonly] = ACTIONS(5163),
    [anon_sym_required] = ACTIONS(5163),
    [anon_sym_sealed] = ACTIONS(5163),
    [anon_sym_virtual] = ACTIONS(5163),
    [anon_sym_volatile] = ACTIONS(5163),
    [anon_sym_where] = ACTIONS(5163),
    [anon_sym_notnull] = ACTIONS(5163),
    [anon_sym_unmanaged] = ACTIONS(5163),
    [anon_sym_TILDE] = ACTIONS(5165),
    [anon_sym_implicit] = ACTIONS(5163),
    [anon_sym_explicit] = ACTIONS(5163),
    [anon_sym_scoped] = ACTIONS(5163),
    [anon_sym_var] = ACTIONS(5163),
    [sym_predefined_type] = ACTIONS(5163),
    [anon_sym_yield] = ACTIONS(5163),
    [anon_sym_when] = ACTIONS(5163),
    [anon_sym_from] = ACTIONS(5163),
    [anon_sym_into] = ACTIONS(5163),
    [anon_sym_join] = ACTIONS(5163),
    [anon_sym_on] = ACTIONS(5163),
    [anon_sym_equals] = ACTIONS(5163),
    [anon_sym_let] = ACTIONS(5163),
    [anon_sym_orderby] = ACTIONS(5163),
    [anon_sym_ascending] = ACTIONS(5163),
    [anon_sym_descending] = ACTIONS(5163),
    [anon_sym_group] = ACTIONS(5163),
    [anon_sym_by] = ACTIONS(5163),
    [anon_sym_select] = ACTIONS(5163),
    [aux_sym_preproc_if_token1] = ACTIONS(5165),
    [aux_sym_preproc_if_token3] = ACTIONS(5165),
    [aux_sym_preproc_else_token1] = ACTIONS(5165),
    [aux_sym_preproc_elif_token1] = ACTIONS(5165),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3512] = {
    [sym_preproc_region] = STATE(3512),
    [sym_preproc_endregion] = STATE(3512),
    [sym_preproc_line] = STATE(3512),
    [sym_preproc_pragma] = STATE(3512),
    [sym_preproc_nullable] = STATE(3512),
    [sym_preproc_error] = STATE(3512),
    [sym_preproc_define] = STATE(3512),
    [sym_preproc_undef] = STATE(3512),
    [sym__identifier_token] = ACTIONS(5167),
    [anon_sym_extern] = ACTIONS(5167),
    [anon_sym_alias] = ACTIONS(5167),
    [anon_sym_global] = ACTIONS(5167),
    [anon_sym_using] = ACTIONS(5167),
    [anon_sym_unsafe] = ACTIONS(5167),
    [anon_sym_static] = ACTIONS(5167),
    [anon_sym_LBRACK] = ACTIONS(5169),
    [anon_sym_LPAREN] = ACTIONS(5169),
    [anon_sym_event] = ACTIONS(5167),
    [anon_sym_namespace] = ACTIONS(5167),
    [anon_sym_class] = ACTIONS(5167),
    [anon_sym_ref] = ACTIONS(5167),
    [anon_sym_struct] = ACTIONS(5167),
    [anon_sym_enum] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_interface] = ACTIONS(5167),
    [anon_sym_delegate] = ACTIONS(5167),
    [anon_sym_record] = ACTIONS(5167),
    [anon_sym_abstract] = ACTIONS(5167),
    [anon_sym_async] = ACTIONS(5167),
    [anon_sym_const] = ACTIONS(5167),
    [anon_sym_file] = ACTIONS(5167),
    [anon_sym_fixed] = ACTIONS(5167),
    [anon_sym_internal] = ACTIONS(5167),
    [anon_sym_new] = ACTIONS(5167),
    [anon_sym_override] = ACTIONS(5167),
    [anon_sym_partial] = ACTIONS(5167),
    [anon_sym_private] = ACTIONS(5167),
    [anon_sym_protected] = ACTIONS(5167),
    [anon_sym_public] = ACTIONS(5167),
    [anon_sym_readonly] = ACTIONS(5167),
    [anon_sym_required] = ACTIONS(5167),
    [anon_sym_sealed] = ACTIONS(5167),
    [anon_sym_virtual] = ACTIONS(5167),
    [anon_sym_volatile] = ACTIONS(5167),
    [anon_sym_where] = ACTIONS(5167),
    [anon_sym_notnull] = ACTIONS(5167),
    [anon_sym_unmanaged] = ACTIONS(5167),
    [anon_sym_TILDE] = ACTIONS(5169),
    [anon_sym_implicit] = ACTIONS(5167),
    [anon_sym_explicit] = ACTIONS(5167),
    [anon_sym_scoped] = ACTIONS(5167),
    [anon_sym_var] = ACTIONS(5167),
    [sym_predefined_type] = ACTIONS(5167),
    [anon_sym_yield] = ACTIONS(5167),
    [anon_sym_when] = ACTIONS(5167),
    [anon_sym_from] = ACTIONS(5167),
    [anon_sym_into] = ACTIONS(5167),
    [anon_sym_join] = ACTIONS(5167),
    [anon_sym_on] = ACTIONS(5167),
    [anon_sym_equals] = ACTIONS(5167),
    [anon_sym_let] = ACTIONS(5167),
    [anon_sym_orderby] = ACTIONS(5167),
    [anon_sym_ascending] = ACTIONS(5167),
    [anon_sym_descending] = ACTIONS(5167),
    [anon_sym_group] = ACTIONS(5167),
    [anon_sym_by] = ACTIONS(5167),
    [anon_sym_select] = ACTIONS(5167),
    [aux_sym_preproc_if_token1] = ACTIONS(5169),
    [aux_sym_preproc_if_token3] = ACTIONS(5169),
    [aux_sym_preproc_else_token1] = ACTIONS(5169),
    [aux_sym_preproc_elif_token1] = ACTIONS(5169),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3513] = {
    [sym_preproc_region] = STATE(3513),
    [sym_preproc_endregion] = STATE(3513),
    [sym_preproc_line] = STATE(3513),
    [sym_preproc_pragma] = STATE(3513),
    [sym_preproc_nullable] = STATE(3513),
    [sym_preproc_error] = STATE(3513),
    [sym_preproc_define] = STATE(3513),
    [sym_preproc_undef] = STATE(3513),
    [sym__identifier_token] = ACTIONS(5171),
    [anon_sym_extern] = ACTIONS(5171),
    [anon_sym_alias] = ACTIONS(5171),
    [anon_sym_global] = ACTIONS(5171),
    [anon_sym_using] = ACTIONS(5171),
    [anon_sym_unsafe] = ACTIONS(5171),
    [anon_sym_static] = ACTIONS(5171),
    [anon_sym_LBRACK] = ACTIONS(5173),
    [anon_sym_LPAREN] = ACTIONS(5173),
    [anon_sym_event] = ACTIONS(5171),
    [anon_sym_namespace] = ACTIONS(5171),
    [anon_sym_class] = ACTIONS(5171),
    [anon_sym_ref] = ACTIONS(5171),
    [anon_sym_struct] = ACTIONS(5171),
    [anon_sym_enum] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_interface] = ACTIONS(5171),
    [anon_sym_delegate] = ACTIONS(5171),
    [anon_sym_record] = ACTIONS(5171),
    [anon_sym_abstract] = ACTIONS(5171),
    [anon_sym_async] = ACTIONS(5171),
    [anon_sym_const] = ACTIONS(5171),
    [anon_sym_file] = ACTIONS(5171),
    [anon_sym_fixed] = ACTIONS(5171),
    [anon_sym_internal] = ACTIONS(5171),
    [anon_sym_new] = ACTIONS(5171),
    [anon_sym_override] = ACTIONS(5171),
    [anon_sym_partial] = ACTIONS(5171),
    [anon_sym_private] = ACTIONS(5171),
    [anon_sym_protected] = ACTIONS(5171),
    [anon_sym_public] = ACTIONS(5171),
    [anon_sym_readonly] = ACTIONS(5171),
    [anon_sym_required] = ACTIONS(5171),
    [anon_sym_sealed] = ACTIONS(5171),
    [anon_sym_virtual] = ACTIONS(5171),
    [anon_sym_volatile] = ACTIONS(5171),
    [anon_sym_where] = ACTIONS(5171),
    [anon_sym_notnull] = ACTIONS(5171),
    [anon_sym_unmanaged] = ACTIONS(5171),
    [anon_sym_TILDE] = ACTIONS(5173),
    [anon_sym_implicit] = ACTIONS(5171),
    [anon_sym_explicit] = ACTIONS(5171),
    [anon_sym_scoped] = ACTIONS(5171),
    [anon_sym_var] = ACTIONS(5171),
    [sym_predefined_type] = ACTIONS(5171),
    [anon_sym_yield] = ACTIONS(5171),
    [anon_sym_when] = ACTIONS(5171),
    [anon_sym_from] = ACTIONS(5171),
    [anon_sym_into] = ACTIONS(5171),
    [anon_sym_join] = ACTIONS(5171),
    [anon_sym_on] = ACTIONS(5171),
    [anon_sym_equals] = ACTIONS(5171),
    [anon_sym_let] = ACTIONS(5171),
    [anon_sym_orderby] = ACTIONS(5171),
    [anon_sym_ascending] = ACTIONS(5171),
    [anon_sym_descending] = ACTIONS(5171),
    [anon_sym_group] = ACTIONS(5171),
    [anon_sym_by] = ACTIONS(5171),
    [anon_sym_select] = ACTIONS(5171),
    [aux_sym_preproc_if_token1] = ACTIONS(5173),
    [aux_sym_preproc_if_token3] = ACTIONS(5173),
    [aux_sym_preproc_else_token1] = ACTIONS(5173),
    [aux_sym_preproc_elif_token1] = ACTIONS(5173),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3514] = {
    [sym_preproc_region] = STATE(3514),
    [sym_preproc_endregion] = STATE(3514),
    [sym_preproc_line] = STATE(3514),
    [sym_preproc_pragma] = STATE(3514),
    [sym_preproc_nullable] = STATE(3514),
    [sym_preproc_error] = STATE(3514),
    [sym_preproc_define] = STATE(3514),
    [sym_preproc_undef] = STATE(3514),
    [sym__identifier_token] = ACTIONS(5175),
    [anon_sym_extern] = ACTIONS(5175),
    [anon_sym_alias] = ACTIONS(5175),
    [anon_sym_global] = ACTIONS(5175),
    [anon_sym_using] = ACTIONS(5175),
    [anon_sym_unsafe] = ACTIONS(5175),
    [anon_sym_static] = ACTIONS(5175),
    [anon_sym_LBRACK] = ACTIONS(5177),
    [anon_sym_LPAREN] = ACTIONS(5177),
    [anon_sym_event] = ACTIONS(5175),
    [anon_sym_namespace] = ACTIONS(5175),
    [anon_sym_class] = ACTIONS(5175),
    [anon_sym_ref] = ACTIONS(5175),
    [anon_sym_struct] = ACTIONS(5175),
    [anon_sym_enum] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_interface] = ACTIONS(5175),
    [anon_sym_delegate] = ACTIONS(5175),
    [anon_sym_record] = ACTIONS(5175),
    [anon_sym_abstract] = ACTIONS(5175),
    [anon_sym_async] = ACTIONS(5175),
    [anon_sym_const] = ACTIONS(5175),
    [anon_sym_file] = ACTIONS(5175),
    [anon_sym_fixed] = ACTIONS(5175),
    [anon_sym_internal] = ACTIONS(5175),
    [anon_sym_new] = ACTIONS(5175),
    [anon_sym_override] = ACTIONS(5175),
    [anon_sym_partial] = ACTIONS(5175),
    [anon_sym_private] = ACTIONS(5175),
    [anon_sym_protected] = ACTIONS(5175),
    [anon_sym_public] = ACTIONS(5175),
    [anon_sym_readonly] = ACTIONS(5175),
    [anon_sym_required] = ACTIONS(5175),
    [anon_sym_sealed] = ACTIONS(5175),
    [anon_sym_virtual] = ACTIONS(5175),
    [anon_sym_volatile] = ACTIONS(5175),
    [anon_sym_where] = ACTIONS(5175),
    [anon_sym_notnull] = ACTIONS(5175),
    [anon_sym_unmanaged] = ACTIONS(5175),
    [anon_sym_TILDE] = ACTIONS(5177),
    [anon_sym_implicit] = ACTIONS(5175),
    [anon_sym_explicit] = ACTIONS(5175),
    [anon_sym_scoped] = ACTIONS(5175),
    [anon_sym_var] = ACTIONS(5175),
    [sym_predefined_type] = ACTIONS(5175),
    [anon_sym_yield] = ACTIONS(5175),
    [anon_sym_when] = ACTIONS(5175),
    [anon_sym_from] = ACTIONS(5175),
    [anon_sym_into] = ACTIONS(5175),
    [anon_sym_join] = ACTIONS(5175),
    [anon_sym_on] = ACTIONS(5175),
    [anon_sym_equals] = ACTIONS(5175),
    [anon_sym_let] = ACTIONS(5175),
    [anon_sym_orderby] = ACTIONS(5175),
    [anon_sym_ascending] = ACTIONS(5175),
    [anon_sym_descending] = ACTIONS(5175),
    [anon_sym_group] = ACTIONS(5175),
    [anon_sym_by] = ACTIONS(5175),
    [anon_sym_select] = ACTIONS(5175),
    [aux_sym_preproc_if_token1] = ACTIONS(5177),
    [aux_sym_preproc_if_token3] = ACTIONS(5177),
    [aux_sym_preproc_else_token1] = ACTIONS(5177),
    [aux_sym_preproc_elif_token1] = ACTIONS(5177),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3515] = {
    [sym_preproc_region] = STATE(3515),
    [sym_preproc_endregion] = STATE(3515),
    [sym_preproc_line] = STATE(3515),
    [sym_preproc_pragma] = STATE(3515),
    [sym_preproc_nullable] = STATE(3515),
    [sym_preproc_error] = STATE(3515),
    [sym_preproc_define] = STATE(3515),
    [sym_preproc_undef] = STATE(3515),
    [sym__identifier_token] = ACTIONS(5179),
    [anon_sym_extern] = ACTIONS(5179),
    [anon_sym_alias] = ACTIONS(5179),
    [anon_sym_global] = ACTIONS(5179),
    [anon_sym_using] = ACTIONS(5179),
    [anon_sym_unsafe] = ACTIONS(5179),
    [anon_sym_static] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5181),
    [anon_sym_LPAREN] = ACTIONS(5181),
    [anon_sym_event] = ACTIONS(5179),
    [anon_sym_namespace] = ACTIONS(5179),
    [anon_sym_class] = ACTIONS(5179),
    [anon_sym_ref] = ACTIONS(5179),
    [anon_sym_struct] = ACTIONS(5179),
    [anon_sym_enum] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_interface] = ACTIONS(5179),
    [anon_sym_delegate] = ACTIONS(5179),
    [anon_sym_record] = ACTIONS(5179),
    [anon_sym_abstract] = ACTIONS(5179),
    [anon_sym_async] = ACTIONS(5179),
    [anon_sym_const] = ACTIONS(5179),
    [anon_sym_file] = ACTIONS(5179),
    [anon_sym_fixed] = ACTIONS(5179),
    [anon_sym_internal] = ACTIONS(5179),
    [anon_sym_new] = ACTIONS(5179),
    [anon_sym_override] = ACTIONS(5179),
    [anon_sym_partial] = ACTIONS(5179),
    [anon_sym_private] = ACTIONS(5179),
    [anon_sym_protected] = ACTIONS(5179),
    [anon_sym_public] = ACTIONS(5179),
    [anon_sym_readonly] = ACTIONS(5179),
    [anon_sym_required] = ACTIONS(5179),
    [anon_sym_sealed] = ACTIONS(5179),
    [anon_sym_virtual] = ACTIONS(5179),
    [anon_sym_volatile] = ACTIONS(5179),
    [anon_sym_where] = ACTIONS(5179),
    [anon_sym_notnull] = ACTIONS(5179),
    [anon_sym_unmanaged] = ACTIONS(5179),
    [anon_sym_TILDE] = ACTIONS(5181),
    [anon_sym_implicit] = ACTIONS(5179),
    [anon_sym_explicit] = ACTIONS(5179),
    [anon_sym_scoped] = ACTIONS(5179),
    [anon_sym_var] = ACTIONS(5179),
    [sym_predefined_type] = ACTIONS(5179),
    [anon_sym_yield] = ACTIONS(5179),
    [anon_sym_when] = ACTIONS(5179),
    [anon_sym_from] = ACTIONS(5179),
    [anon_sym_into] = ACTIONS(5179),
    [anon_sym_join] = ACTIONS(5179),
    [anon_sym_on] = ACTIONS(5179),
    [anon_sym_equals] = ACTIONS(5179),
    [anon_sym_let] = ACTIONS(5179),
    [anon_sym_orderby] = ACTIONS(5179),
    [anon_sym_ascending] = ACTIONS(5179),
    [anon_sym_descending] = ACTIONS(5179),
    [anon_sym_group] = ACTIONS(5179),
    [anon_sym_by] = ACTIONS(5179),
    [anon_sym_select] = ACTIONS(5179),
    [aux_sym_preproc_if_token1] = ACTIONS(5181),
    [aux_sym_preproc_if_token3] = ACTIONS(5181),
    [aux_sym_preproc_else_token1] = ACTIONS(5181),
    [aux_sym_preproc_elif_token1] = ACTIONS(5181),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3516] = {
    [sym_preproc_region] = STATE(3516),
    [sym_preproc_endregion] = STATE(3516),
    [sym_preproc_line] = STATE(3516),
    [sym_preproc_pragma] = STATE(3516),
    [sym_preproc_nullable] = STATE(3516),
    [sym_preproc_error] = STATE(3516),
    [sym_preproc_define] = STATE(3516),
    [sym_preproc_undef] = STATE(3516),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_RBRACK] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_EQ_GT] = ACTIONS(4691),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_on] = ACTIONS(4691),
    [anon_sym_equals] = ACTIONS(4691),
    [anon_sym_by] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4691),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_if_token3] = ACTIONS(4691),
    [aux_sym_preproc_else_token1] = ACTIONS(4691),
    [aux_sym_preproc_elif_token1] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3517] = {
    [sym_preproc_region] = STATE(3517),
    [sym_preproc_endregion] = STATE(3517),
    [sym_preproc_line] = STATE(3517),
    [sym_preproc_pragma] = STATE(3517),
    [sym_preproc_nullable] = STATE(3517),
    [sym_preproc_error] = STATE(3517),
    [sym_preproc_define] = STATE(3517),
    [sym_preproc_undef] = STATE(3517),
    [sym__identifier_token] = ACTIONS(5183),
    [anon_sym_extern] = ACTIONS(5183),
    [anon_sym_alias] = ACTIONS(5183),
    [anon_sym_global] = ACTIONS(5183),
    [anon_sym_using] = ACTIONS(5183),
    [anon_sym_unsafe] = ACTIONS(5183),
    [anon_sym_static] = ACTIONS(5183),
    [anon_sym_LBRACK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5185),
    [anon_sym_event] = ACTIONS(5183),
    [anon_sym_namespace] = ACTIONS(5183),
    [anon_sym_class] = ACTIONS(5183),
    [anon_sym_ref] = ACTIONS(5183),
    [anon_sym_struct] = ACTIONS(5183),
    [anon_sym_enum] = ACTIONS(5183),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_interface] = ACTIONS(5183),
    [anon_sym_delegate] = ACTIONS(5183),
    [anon_sym_record] = ACTIONS(5183),
    [anon_sym_abstract] = ACTIONS(5183),
    [anon_sym_async] = ACTIONS(5183),
    [anon_sym_const] = ACTIONS(5183),
    [anon_sym_file] = ACTIONS(5183),
    [anon_sym_fixed] = ACTIONS(5183),
    [anon_sym_internal] = ACTIONS(5183),
    [anon_sym_new] = ACTIONS(5183),
    [anon_sym_override] = ACTIONS(5183),
    [anon_sym_partial] = ACTIONS(5183),
    [anon_sym_private] = ACTIONS(5183),
    [anon_sym_protected] = ACTIONS(5183),
    [anon_sym_public] = ACTIONS(5183),
    [anon_sym_readonly] = ACTIONS(5183),
    [anon_sym_required] = ACTIONS(5183),
    [anon_sym_sealed] = ACTIONS(5183),
    [anon_sym_virtual] = ACTIONS(5183),
    [anon_sym_volatile] = ACTIONS(5183),
    [anon_sym_where] = ACTIONS(5183),
    [anon_sym_notnull] = ACTIONS(5183),
    [anon_sym_unmanaged] = ACTIONS(5183),
    [anon_sym_TILDE] = ACTIONS(5185),
    [anon_sym_implicit] = ACTIONS(5183),
    [anon_sym_explicit] = ACTIONS(5183),
    [anon_sym_scoped] = ACTIONS(5183),
    [anon_sym_var] = ACTIONS(5183),
    [sym_predefined_type] = ACTIONS(5183),
    [anon_sym_yield] = ACTIONS(5183),
    [anon_sym_when] = ACTIONS(5183),
    [anon_sym_from] = ACTIONS(5183),
    [anon_sym_into] = ACTIONS(5183),
    [anon_sym_join] = ACTIONS(5183),
    [anon_sym_on] = ACTIONS(5183),
    [anon_sym_equals] = ACTIONS(5183),
    [anon_sym_let] = ACTIONS(5183),
    [anon_sym_orderby] = ACTIONS(5183),
    [anon_sym_ascending] = ACTIONS(5183),
    [anon_sym_descending] = ACTIONS(5183),
    [anon_sym_group] = ACTIONS(5183),
    [anon_sym_by] = ACTIONS(5183),
    [anon_sym_select] = ACTIONS(5183),
    [aux_sym_preproc_if_token1] = ACTIONS(5185),
    [aux_sym_preproc_if_token3] = ACTIONS(5185),
    [aux_sym_preproc_else_token1] = ACTIONS(5185),
    [aux_sym_preproc_elif_token1] = ACTIONS(5185),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3518] = {
    [sym_preproc_region] = STATE(3518),
    [sym_preproc_endregion] = STATE(3518),
    [sym_preproc_line] = STATE(3518),
    [sym_preproc_pragma] = STATE(3518),
    [sym_preproc_nullable] = STATE(3518),
    [sym_preproc_error] = STATE(3518),
    [sym_preproc_define] = STATE(3518),
    [sym_preproc_undef] = STATE(3518),
    [sym__identifier_token] = ACTIONS(5187),
    [anon_sym_extern] = ACTIONS(5187),
    [anon_sym_alias] = ACTIONS(5187),
    [anon_sym_global] = ACTIONS(5187),
    [anon_sym_using] = ACTIONS(5187),
    [anon_sym_unsafe] = ACTIONS(5187),
    [anon_sym_static] = ACTIONS(5187),
    [anon_sym_LBRACK] = ACTIONS(5189),
    [anon_sym_LPAREN] = ACTIONS(5189),
    [anon_sym_event] = ACTIONS(5187),
    [anon_sym_namespace] = ACTIONS(5187),
    [anon_sym_class] = ACTIONS(5187),
    [anon_sym_ref] = ACTIONS(5187),
    [anon_sym_struct] = ACTIONS(5187),
    [anon_sym_enum] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym_interface] = ACTIONS(5187),
    [anon_sym_delegate] = ACTIONS(5187),
    [anon_sym_record] = ACTIONS(5187),
    [anon_sym_abstract] = ACTIONS(5187),
    [anon_sym_async] = ACTIONS(5187),
    [anon_sym_const] = ACTIONS(5187),
    [anon_sym_file] = ACTIONS(5187),
    [anon_sym_fixed] = ACTIONS(5187),
    [anon_sym_internal] = ACTIONS(5187),
    [anon_sym_new] = ACTIONS(5187),
    [anon_sym_override] = ACTIONS(5187),
    [anon_sym_partial] = ACTIONS(5187),
    [anon_sym_private] = ACTIONS(5187),
    [anon_sym_protected] = ACTIONS(5187),
    [anon_sym_public] = ACTIONS(5187),
    [anon_sym_readonly] = ACTIONS(5187),
    [anon_sym_required] = ACTIONS(5187),
    [anon_sym_sealed] = ACTIONS(5187),
    [anon_sym_virtual] = ACTIONS(5187),
    [anon_sym_volatile] = ACTIONS(5187),
    [anon_sym_where] = ACTIONS(5187),
    [anon_sym_notnull] = ACTIONS(5187),
    [anon_sym_unmanaged] = ACTIONS(5187),
    [anon_sym_TILDE] = ACTIONS(5189),
    [anon_sym_implicit] = ACTIONS(5187),
    [anon_sym_explicit] = ACTIONS(5187),
    [anon_sym_scoped] = ACTIONS(5187),
    [anon_sym_var] = ACTIONS(5187),
    [sym_predefined_type] = ACTIONS(5187),
    [anon_sym_yield] = ACTIONS(5187),
    [anon_sym_when] = ACTIONS(5187),
    [anon_sym_from] = ACTIONS(5187),
    [anon_sym_into] = ACTIONS(5187),
    [anon_sym_join] = ACTIONS(5187),
    [anon_sym_on] = ACTIONS(5187),
    [anon_sym_equals] = ACTIONS(5187),
    [anon_sym_let] = ACTIONS(5187),
    [anon_sym_orderby] = ACTIONS(5187),
    [anon_sym_ascending] = ACTIONS(5187),
    [anon_sym_descending] = ACTIONS(5187),
    [anon_sym_group] = ACTIONS(5187),
    [anon_sym_by] = ACTIONS(5187),
    [anon_sym_select] = ACTIONS(5187),
    [aux_sym_preproc_if_token1] = ACTIONS(5189),
    [aux_sym_preproc_if_token3] = ACTIONS(5189),
    [aux_sym_preproc_else_token1] = ACTIONS(5189),
    [aux_sym_preproc_elif_token1] = ACTIONS(5189),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3519] = {
    [sym_preproc_region] = STATE(3519),
    [sym_preproc_endregion] = STATE(3519),
    [sym_preproc_line] = STATE(3519),
    [sym_preproc_pragma] = STATE(3519),
    [sym_preproc_nullable] = STATE(3519),
    [sym_preproc_error] = STATE(3519),
    [sym_preproc_define] = STATE(3519),
    [sym_preproc_undef] = STATE(3519),
    [anon_sym_SEMI] = ACTIONS(4681),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_RBRACK] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_RPAREN] = ACTIONS(4681),
    [anon_sym_RBRACE] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_in] = ACTIONS(4681),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_EQ_GT] = ACTIONS(4681),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_when] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4681),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_on] = ACTIONS(4681),
    [anon_sym_equals] = ACTIONS(4681),
    [anon_sym_by] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4681),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_if_token3] = ACTIONS(4681),
    [aux_sym_preproc_else_token1] = ACTIONS(4681),
    [aux_sym_preproc_elif_token1] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3520] = {
    [sym_preproc_region] = STATE(3520),
    [sym_preproc_endregion] = STATE(3520),
    [sym_preproc_line] = STATE(3520),
    [sym_preproc_pragma] = STATE(3520),
    [sym_preproc_nullable] = STATE(3520),
    [sym_preproc_error] = STATE(3520),
    [sym_preproc_define] = STATE(3520),
    [sym_preproc_undef] = STATE(3520),
    [sym__identifier_token] = ACTIONS(5191),
    [anon_sym_extern] = ACTIONS(5191),
    [anon_sym_alias] = ACTIONS(5191),
    [anon_sym_global] = ACTIONS(5191),
    [anon_sym_using] = ACTIONS(5191),
    [anon_sym_unsafe] = ACTIONS(5191),
    [anon_sym_static] = ACTIONS(5191),
    [anon_sym_LBRACK] = ACTIONS(5193),
    [anon_sym_LPAREN] = ACTIONS(5193),
    [anon_sym_event] = ACTIONS(5191),
    [anon_sym_namespace] = ACTIONS(5191),
    [anon_sym_class] = ACTIONS(5191),
    [anon_sym_ref] = ACTIONS(5191),
    [anon_sym_struct] = ACTIONS(5191),
    [anon_sym_enum] = ACTIONS(5191),
    [anon_sym_RBRACE] = ACTIONS(5193),
    [anon_sym_interface] = ACTIONS(5191),
    [anon_sym_delegate] = ACTIONS(5191),
    [anon_sym_record] = ACTIONS(5191),
    [anon_sym_abstract] = ACTIONS(5191),
    [anon_sym_async] = ACTIONS(5191),
    [anon_sym_const] = ACTIONS(5191),
    [anon_sym_file] = ACTIONS(5191),
    [anon_sym_fixed] = ACTIONS(5191),
    [anon_sym_internal] = ACTIONS(5191),
    [anon_sym_new] = ACTIONS(5191),
    [anon_sym_override] = ACTIONS(5191),
    [anon_sym_partial] = ACTIONS(5191),
    [anon_sym_private] = ACTIONS(5191),
    [anon_sym_protected] = ACTIONS(5191),
    [anon_sym_public] = ACTIONS(5191),
    [anon_sym_readonly] = ACTIONS(5191),
    [anon_sym_required] = ACTIONS(5191),
    [anon_sym_sealed] = ACTIONS(5191),
    [anon_sym_virtual] = ACTIONS(5191),
    [anon_sym_volatile] = ACTIONS(5191),
    [anon_sym_where] = ACTIONS(5191),
    [anon_sym_notnull] = ACTIONS(5191),
    [anon_sym_unmanaged] = ACTIONS(5191),
    [anon_sym_TILDE] = ACTIONS(5193),
    [anon_sym_implicit] = ACTIONS(5191),
    [anon_sym_explicit] = ACTIONS(5191),
    [anon_sym_scoped] = ACTIONS(5191),
    [anon_sym_var] = ACTIONS(5191),
    [sym_predefined_type] = ACTIONS(5191),
    [anon_sym_yield] = ACTIONS(5191),
    [anon_sym_when] = ACTIONS(5191),
    [anon_sym_from] = ACTIONS(5191),
    [anon_sym_into] = ACTIONS(5191),
    [anon_sym_join] = ACTIONS(5191),
    [anon_sym_on] = ACTIONS(5191),
    [anon_sym_equals] = ACTIONS(5191),
    [anon_sym_let] = ACTIONS(5191),
    [anon_sym_orderby] = ACTIONS(5191),
    [anon_sym_ascending] = ACTIONS(5191),
    [anon_sym_descending] = ACTIONS(5191),
    [anon_sym_group] = ACTIONS(5191),
    [anon_sym_by] = ACTIONS(5191),
    [anon_sym_select] = ACTIONS(5191),
    [aux_sym_preproc_if_token1] = ACTIONS(5193),
    [aux_sym_preproc_if_token3] = ACTIONS(5193),
    [aux_sym_preproc_else_token1] = ACTIONS(5193),
    [aux_sym_preproc_elif_token1] = ACTIONS(5193),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3521] = {
    [sym_preproc_region] = STATE(3521),
    [sym_preproc_endregion] = STATE(3521),
    [sym_preproc_line] = STATE(3521),
    [sym_preproc_pragma] = STATE(3521),
    [sym_preproc_nullable] = STATE(3521),
    [sym_preproc_error] = STATE(3521),
    [sym_preproc_define] = STATE(3521),
    [sym_preproc_undef] = STATE(3521),
    [sym__identifier_token] = ACTIONS(5195),
    [anon_sym_extern] = ACTIONS(5195),
    [anon_sym_alias] = ACTIONS(5195),
    [anon_sym_global] = ACTIONS(5195),
    [anon_sym_using] = ACTIONS(5195),
    [anon_sym_unsafe] = ACTIONS(5195),
    [anon_sym_static] = ACTIONS(5195),
    [anon_sym_LBRACK] = ACTIONS(5197),
    [anon_sym_LPAREN] = ACTIONS(5197),
    [anon_sym_event] = ACTIONS(5195),
    [anon_sym_namespace] = ACTIONS(5195),
    [anon_sym_class] = ACTIONS(5195),
    [anon_sym_ref] = ACTIONS(5195),
    [anon_sym_struct] = ACTIONS(5195),
    [anon_sym_enum] = ACTIONS(5195),
    [anon_sym_RBRACE] = ACTIONS(5197),
    [anon_sym_interface] = ACTIONS(5195),
    [anon_sym_delegate] = ACTIONS(5195),
    [anon_sym_record] = ACTIONS(5195),
    [anon_sym_abstract] = ACTIONS(5195),
    [anon_sym_async] = ACTIONS(5195),
    [anon_sym_const] = ACTIONS(5195),
    [anon_sym_file] = ACTIONS(5195),
    [anon_sym_fixed] = ACTIONS(5195),
    [anon_sym_internal] = ACTIONS(5195),
    [anon_sym_new] = ACTIONS(5195),
    [anon_sym_override] = ACTIONS(5195),
    [anon_sym_partial] = ACTIONS(5195),
    [anon_sym_private] = ACTIONS(5195),
    [anon_sym_protected] = ACTIONS(5195),
    [anon_sym_public] = ACTIONS(5195),
    [anon_sym_readonly] = ACTIONS(5195),
    [anon_sym_required] = ACTIONS(5195),
    [anon_sym_sealed] = ACTIONS(5195),
    [anon_sym_virtual] = ACTIONS(5195),
    [anon_sym_volatile] = ACTIONS(5195),
    [anon_sym_where] = ACTIONS(5195),
    [anon_sym_notnull] = ACTIONS(5195),
    [anon_sym_unmanaged] = ACTIONS(5195),
    [anon_sym_TILDE] = ACTIONS(5197),
    [anon_sym_implicit] = ACTIONS(5195),
    [anon_sym_explicit] = ACTIONS(5195),
    [anon_sym_scoped] = ACTIONS(5195),
    [anon_sym_var] = ACTIONS(5195),
    [sym_predefined_type] = ACTIONS(5195),
    [anon_sym_yield] = ACTIONS(5195),
    [anon_sym_when] = ACTIONS(5195),
    [anon_sym_from] = ACTIONS(5195),
    [anon_sym_into] = ACTIONS(5195),
    [anon_sym_join] = ACTIONS(5195),
    [anon_sym_on] = ACTIONS(5195),
    [anon_sym_equals] = ACTIONS(5195),
    [anon_sym_let] = ACTIONS(5195),
    [anon_sym_orderby] = ACTIONS(5195),
    [anon_sym_ascending] = ACTIONS(5195),
    [anon_sym_descending] = ACTIONS(5195),
    [anon_sym_group] = ACTIONS(5195),
    [anon_sym_by] = ACTIONS(5195),
    [anon_sym_select] = ACTIONS(5195),
    [aux_sym_preproc_if_token1] = ACTIONS(5197),
    [aux_sym_preproc_if_token3] = ACTIONS(5197),
    [aux_sym_preproc_else_token1] = ACTIONS(5197),
    [aux_sym_preproc_elif_token1] = ACTIONS(5197),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3522] = {
    [sym_preproc_region] = STATE(3522),
    [sym_preproc_endregion] = STATE(3522),
    [sym_preproc_line] = STATE(3522),
    [sym_preproc_pragma] = STATE(3522),
    [sym_preproc_nullable] = STATE(3522),
    [sym_preproc_error] = STATE(3522),
    [sym_preproc_define] = STATE(3522),
    [sym_preproc_undef] = STATE(3522),
    [sym__identifier_token] = ACTIONS(5199),
    [anon_sym_extern] = ACTIONS(5199),
    [anon_sym_alias] = ACTIONS(5199),
    [anon_sym_global] = ACTIONS(5199),
    [anon_sym_using] = ACTIONS(5199),
    [anon_sym_unsafe] = ACTIONS(5199),
    [anon_sym_static] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(5201),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_event] = ACTIONS(5199),
    [anon_sym_namespace] = ACTIONS(5199),
    [anon_sym_class] = ACTIONS(5199),
    [anon_sym_ref] = ACTIONS(5199),
    [anon_sym_struct] = ACTIONS(5199),
    [anon_sym_enum] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_interface] = ACTIONS(5199),
    [anon_sym_delegate] = ACTIONS(5199),
    [anon_sym_record] = ACTIONS(5199),
    [anon_sym_abstract] = ACTIONS(5199),
    [anon_sym_async] = ACTIONS(5199),
    [anon_sym_const] = ACTIONS(5199),
    [anon_sym_file] = ACTIONS(5199),
    [anon_sym_fixed] = ACTIONS(5199),
    [anon_sym_internal] = ACTIONS(5199),
    [anon_sym_new] = ACTIONS(5199),
    [anon_sym_override] = ACTIONS(5199),
    [anon_sym_partial] = ACTIONS(5199),
    [anon_sym_private] = ACTIONS(5199),
    [anon_sym_protected] = ACTIONS(5199),
    [anon_sym_public] = ACTIONS(5199),
    [anon_sym_readonly] = ACTIONS(5199),
    [anon_sym_required] = ACTIONS(5199),
    [anon_sym_sealed] = ACTIONS(5199),
    [anon_sym_virtual] = ACTIONS(5199),
    [anon_sym_volatile] = ACTIONS(5199),
    [anon_sym_where] = ACTIONS(5199),
    [anon_sym_notnull] = ACTIONS(5199),
    [anon_sym_unmanaged] = ACTIONS(5199),
    [anon_sym_TILDE] = ACTIONS(5201),
    [anon_sym_implicit] = ACTIONS(5199),
    [anon_sym_explicit] = ACTIONS(5199),
    [anon_sym_scoped] = ACTIONS(5199),
    [anon_sym_var] = ACTIONS(5199),
    [sym_predefined_type] = ACTIONS(5199),
    [anon_sym_yield] = ACTIONS(5199),
    [anon_sym_when] = ACTIONS(5199),
    [anon_sym_from] = ACTIONS(5199),
    [anon_sym_into] = ACTIONS(5199),
    [anon_sym_join] = ACTIONS(5199),
    [anon_sym_on] = ACTIONS(5199),
    [anon_sym_equals] = ACTIONS(5199),
    [anon_sym_let] = ACTIONS(5199),
    [anon_sym_orderby] = ACTIONS(5199),
    [anon_sym_ascending] = ACTIONS(5199),
    [anon_sym_descending] = ACTIONS(5199),
    [anon_sym_group] = ACTIONS(5199),
    [anon_sym_by] = ACTIONS(5199),
    [anon_sym_select] = ACTIONS(5199),
    [aux_sym_preproc_if_token1] = ACTIONS(5201),
    [aux_sym_preproc_if_token3] = ACTIONS(5201),
    [aux_sym_preproc_else_token1] = ACTIONS(5201),
    [aux_sym_preproc_elif_token1] = ACTIONS(5201),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3523] = {
    [sym_preproc_region] = STATE(3523),
    [sym_preproc_endregion] = STATE(3523),
    [sym_preproc_line] = STATE(3523),
    [sym_preproc_pragma] = STATE(3523),
    [sym_preproc_nullable] = STATE(3523),
    [sym_preproc_error] = STATE(3523),
    [sym_preproc_define] = STATE(3523),
    [sym_preproc_undef] = STATE(3523),
    [sym__identifier_token] = ACTIONS(5203),
    [anon_sym_extern] = ACTIONS(5203),
    [anon_sym_alias] = ACTIONS(5203),
    [anon_sym_global] = ACTIONS(5203),
    [anon_sym_using] = ACTIONS(5203),
    [anon_sym_unsafe] = ACTIONS(5203),
    [anon_sym_static] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5205),
    [anon_sym_LPAREN] = ACTIONS(5205),
    [anon_sym_event] = ACTIONS(5203),
    [anon_sym_namespace] = ACTIONS(5203),
    [anon_sym_class] = ACTIONS(5203),
    [anon_sym_ref] = ACTIONS(5203),
    [anon_sym_struct] = ACTIONS(5203),
    [anon_sym_enum] = ACTIONS(5203),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_interface] = ACTIONS(5203),
    [anon_sym_delegate] = ACTIONS(5203),
    [anon_sym_record] = ACTIONS(5203),
    [anon_sym_abstract] = ACTIONS(5203),
    [anon_sym_async] = ACTIONS(5203),
    [anon_sym_const] = ACTIONS(5203),
    [anon_sym_file] = ACTIONS(5203),
    [anon_sym_fixed] = ACTIONS(5203),
    [anon_sym_internal] = ACTIONS(5203),
    [anon_sym_new] = ACTIONS(5203),
    [anon_sym_override] = ACTIONS(5203),
    [anon_sym_partial] = ACTIONS(5203),
    [anon_sym_private] = ACTIONS(5203),
    [anon_sym_protected] = ACTIONS(5203),
    [anon_sym_public] = ACTIONS(5203),
    [anon_sym_readonly] = ACTIONS(5203),
    [anon_sym_required] = ACTIONS(5203),
    [anon_sym_sealed] = ACTIONS(5203),
    [anon_sym_virtual] = ACTIONS(5203),
    [anon_sym_volatile] = ACTIONS(5203),
    [anon_sym_where] = ACTIONS(5203),
    [anon_sym_notnull] = ACTIONS(5203),
    [anon_sym_unmanaged] = ACTIONS(5203),
    [anon_sym_TILDE] = ACTIONS(5205),
    [anon_sym_implicit] = ACTIONS(5203),
    [anon_sym_explicit] = ACTIONS(5203),
    [anon_sym_scoped] = ACTIONS(5203),
    [anon_sym_var] = ACTIONS(5203),
    [sym_predefined_type] = ACTIONS(5203),
    [anon_sym_yield] = ACTIONS(5203),
    [anon_sym_when] = ACTIONS(5203),
    [anon_sym_from] = ACTIONS(5203),
    [anon_sym_into] = ACTIONS(5203),
    [anon_sym_join] = ACTIONS(5203),
    [anon_sym_on] = ACTIONS(5203),
    [anon_sym_equals] = ACTIONS(5203),
    [anon_sym_let] = ACTIONS(5203),
    [anon_sym_orderby] = ACTIONS(5203),
    [anon_sym_ascending] = ACTIONS(5203),
    [anon_sym_descending] = ACTIONS(5203),
    [anon_sym_group] = ACTIONS(5203),
    [anon_sym_by] = ACTIONS(5203),
    [anon_sym_select] = ACTIONS(5203),
    [aux_sym_preproc_if_token1] = ACTIONS(5205),
    [aux_sym_preproc_if_token3] = ACTIONS(5205),
    [aux_sym_preproc_else_token1] = ACTIONS(5205),
    [aux_sym_preproc_elif_token1] = ACTIONS(5205),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3524] = {
    [sym_preproc_region] = STATE(3524),
    [sym_preproc_endregion] = STATE(3524),
    [sym_preproc_line] = STATE(3524),
    [sym_preproc_pragma] = STATE(3524),
    [sym_preproc_nullable] = STATE(3524),
    [sym_preproc_error] = STATE(3524),
    [sym_preproc_define] = STATE(3524),
    [sym_preproc_undef] = STATE(3524),
    [sym__identifier_token] = ACTIONS(5207),
    [anon_sym_extern] = ACTIONS(5207),
    [anon_sym_alias] = ACTIONS(5207),
    [anon_sym_global] = ACTIONS(5207),
    [anon_sym_using] = ACTIONS(5207),
    [anon_sym_unsafe] = ACTIONS(5207),
    [anon_sym_static] = ACTIONS(5207),
    [anon_sym_LBRACK] = ACTIONS(5209),
    [anon_sym_LPAREN] = ACTIONS(5209),
    [anon_sym_event] = ACTIONS(5207),
    [anon_sym_namespace] = ACTIONS(5207),
    [anon_sym_class] = ACTIONS(5207),
    [anon_sym_ref] = ACTIONS(5207),
    [anon_sym_struct] = ACTIONS(5207),
    [anon_sym_enum] = ACTIONS(5207),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [anon_sym_interface] = ACTIONS(5207),
    [anon_sym_delegate] = ACTIONS(5207),
    [anon_sym_record] = ACTIONS(5207),
    [anon_sym_abstract] = ACTIONS(5207),
    [anon_sym_async] = ACTIONS(5207),
    [anon_sym_const] = ACTIONS(5207),
    [anon_sym_file] = ACTIONS(5207),
    [anon_sym_fixed] = ACTIONS(5207),
    [anon_sym_internal] = ACTIONS(5207),
    [anon_sym_new] = ACTIONS(5207),
    [anon_sym_override] = ACTIONS(5207),
    [anon_sym_partial] = ACTIONS(5207),
    [anon_sym_private] = ACTIONS(5207),
    [anon_sym_protected] = ACTIONS(5207),
    [anon_sym_public] = ACTIONS(5207),
    [anon_sym_readonly] = ACTIONS(5207),
    [anon_sym_required] = ACTIONS(5207),
    [anon_sym_sealed] = ACTIONS(5207),
    [anon_sym_virtual] = ACTIONS(5207),
    [anon_sym_volatile] = ACTIONS(5207),
    [anon_sym_where] = ACTIONS(5207),
    [anon_sym_notnull] = ACTIONS(5207),
    [anon_sym_unmanaged] = ACTIONS(5207),
    [anon_sym_TILDE] = ACTIONS(5209),
    [anon_sym_implicit] = ACTIONS(5207),
    [anon_sym_explicit] = ACTIONS(5207),
    [anon_sym_scoped] = ACTIONS(5207),
    [anon_sym_var] = ACTIONS(5207),
    [sym_predefined_type] = ACTIONS(5207),
    [anon_sym_yield] = ACTIONS(5207),
    [anon_sym_when] = ACTIONS(5207),
    [anon_sym_from] = ACTIONS(5207),
    [anon_sym_into] = ACTIONS(5207),
    [anon_sym_join] = ACTIONS(5207),
    [anon_sym_on] = ACTIONS(5207),
    [anon_sym_equals] = ACTIONS(5207),
    [anon_sym_let] = ACTIONS(5207),
    [anon_sym_orderby] = ACTIONS(5207),
    [anon_sym_ascending] = ACTIONS(5207),
    [anon_sym_descending] = ACTIONS(5207),
    [anon_sym_group] = ACTIONS(5207),
    [anon_sym_by] = ACTIONS(5207),
    [anon_sym_select] = ACTIONS(5207),
    [aux_sym_preproc_if_token1] = ACTIONS(5209),
    [aux_sym_preproc_if_token3] = ACTIONS(5209),
    [aux_sym_preproc_else_token1] = ACTIONS(5209),
    [aux_sym_preproc_elif_token1] = ACTIONS(5209),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3525] = {
    [sym_preproc_region] = STATE(3525),
    [sym_preproc_endregion] = STATE(3525),
    [sym_preproc_line] = STATE(3525),
    [sym_preproc_pragma] = STATE(3525),
    [sym_preproc_nullable] = STATE(3525),
    [sym_preproc_error] = STATE(3525),
    [sym_preproc_define] = STATE(3525),
    [sym_preproc_undef] = STATE(3525),
    [sym__identifier_token] = ACTIONS(5211),
    [anon_sym_extern] = ACTIONS(5211),
    [anon_sym_alias] = ACTIONS(5211),
    [anon_sym_global] = ACTIONS(5211),
    [anon_sym_using] = ACTIONS(5211),
    [anon_sym_unsafe] = ACTIONS(5211),
    [anon_sym_static] = ACTIONS(5211),
    [anon_sym_LBRACK] = ACTIONS(5213),
    [anon_sym_LPAREN] = ACTIONS(5213),
    [anon_sym_event] = ACTIONS(5211),
    [anon_sym_namespace] = ACTIONS(5211),
    [anon_sym_class] = ACTIONS(5211),
    [anon_sym_ref] = ACTIONS(5211),
    [anon_sym_struct] = ACTIONS(5211),
    [anon_sym_enum] = ACTIONS(5211),
    [anon_sym_RBRACE] = ACTIONS(5213),
    [anon_sym_interface] = ACTIONS(5211),
    [anon_sym_delegate] = ACTIONS(5211),
    [anon_sym_record] = ACTIONS(5211),
    [anon_sym_abstract] = ACTIONS(5211),
    [anon_sym_async] = ACTIONS(5211),
    [anon_sym_const] = ACTIONS(5211),
    [anon_sym_file] = ACTIONS(5211),
    [anon_sym_fixed] = ACTIONS(5211),
    [anon_sym_internal] = ACTIONS(5211),
    [anon_sym_new] = ACTIONS(5211),
    [anon_sym_override] = ACTIONS(5211),
    [anon_sym_partial] = ACTIONS(5211),
    [anon_sym_private] = ACTIONS(5211),
    [anon_sym_protected] = ACTIONS(5211),
    [anon_sym_public] = ACTIONS(5211),
    [anon_sym_readonly] = ACTIONS(5211),
    [anon_sym_required] = ACTIONS(5211),
    [anon_sym_sealed] = ACTIONS(5211),
    [anon_sym_virtual] = ACTIONS(5211),
    [anon_sym_volatile] = ACTIONS(5211),
    [anon_sym_where] = ACTIONS(5211),
    [anon_sym_notnull] = ACTIONS(5211),
    [anon_sym_unmanaged] = ACTIONS(5211),
    [anon_sym_TILDE] = ACTIONS(5213),
    [anon_sym_implicit] = ACTIONS(5211),
    [anon_sym_explicit] = ACTIONS(5211),
    [anon_sym_scoped] = ACTIONS(5211),
    [anon_sym_var] = ACTIONS(5211),
    [sym_predefined_type] = ACTIONS(5211),
    [anon_sym_yield] = ACTIONS(5211),
    [anon_sym_when] = ACTIONS(5211),
    [anon_sym_from] = ACTIONS(5211),
    [anon_sym_into] = ACTIONS(5211),
    [anon_sym_join] = ACTIONS(5211),
    [anon_sym_on] = ACTIONS(5211),
    [anon_sym_equals] = ACTIONS(5211),
    [anon_sym_let] = ACTIONS(5211),
    [anon_sym_orderby] = ACTIONS(5211),
    [anon_sym_ascending] = ACTIONS(5211),
    [anon_sym_descending] = ACTIONS(5211),
    [anon_sym_group] = ACTIONS(5211),
    [anon_sym_by] = ACTIONS(5211),
    [anon_sym_select] = ACTIONS(5211),
    [aux_sym_preproc_if_token1] = ACTIONS(5213),
    [aux_sym_preproc_if_token3] = ACTIONS(5213),
    [aux_sym_preproc_else_token1] = ACTIONS(5213),
    [aux_sym_preproc_elif_token1] = ACTIONS(5213),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3526] = {
    [sym_preproc_region] = STATE(3526),
    [sym_preproc_endregion] = STATE(3526),
    [sym_preproc_line] = STATE(3526),
    [sym_preproc_pragma] = STATE(3526),
    [sym_preproc_nullable] = STATE(3526),
    [sym_preproc_error] = STATE(3526),
    [sym_preproc_define] = STATE(3526),
    [sym_preproc_undef] = STATE(3526),
    [sym__identifier_token] = ACTIONS(5215),
    [anon_sym_extern] = ACTIONS(5215),
    [anon_sym_alias] = ACTIONS(5215),
    [anon_sym_global] = ACTIONS(5215),
    [anon_sym_using] = ACTIONS(5215),
    [anon_sym_unsafe] = ACTIONS(5215),
    [anon_sym_static] = ACTIONS(5215),
    [anon_sym_LBRACK] = ACTIONS(5217),
    [anon_sym_LPAREN] = ACTIONS(5217),
    [anon_sym_event] = ACTIONS(5215),
    [anon_sym_namespace] = ACTIONS(5215),
    [anon_sym_class] = ACTIONS(5215),
    [anon_sym_ref] = ACTIONS(5215),
    [anon_sym_struct] = ACTIONS(5215),
    [anon_sym_enum] = ACTIONS(5215),
    [anon_sym_RBRACE] = ACTIONS(5217),
    [anon_sym_interface] = ACTIONS(5215),
    [anon_sym_delegate] = ACTIONS(5215),
    [anon_sym_record] = ACTIONS(5215),
    [anon_sym_abstract] = ACTIONS(5215),
    [anon_sym_async] = ACTIONS(5215),
    [anon_sym_const] = ACTIONS(5215),
    [anon_sym_file] = ACTIONS(5215),
    [anon_sym_fixed] = ACTIONS(5215),
    [anon_sym_internal] = ACTIONS(5215),
    [anon_sym_new] = ACTIONS(5215),
    [anon_sym_override] = ACTIONS(5215),
    [anon_sym_partial] = ACTIONS(5215),
    [anon_sym_private] = ACTIONS(5215),
    [anon_sym_protected] = ACTIONS(5215),
    [anon_sym_public] = ACTIONS(5215),
    [anon_sym_readonly] = ACTIONS(5215),
    [anon_sym_required] = ACTIONS(5215),
    [anon_sym_sealed] = ACTIONS(5215),
    [anon_sym_virtual] = ACTIONS(5215),
    [anon_sym_volatile] = ACTIONS(5215),
    [anon_sym_where] = ACTIONS(5215),
    [anon_sym_notnull] = ACTIONS(5215),
    [anon_sym_unmanaged] = ACTIONS(5215),
    [anon_sym_TILDE] = ACTIONS(5217),
    [anon_sym_implicit] = ACTIONS(5215),
    [anon_sym_explicit] = ACTIONS(5215),
    [anon_sym_scoped] = ACTIONS(5215),
    [anon_sym_var] = ACTIONS(5215),
    [sym_predefined_type] = ACTIONS(5215),
    [anon_sym_yield] = ACTIONS(5215),
    [anon_sym_when] = ACTIONS(5215),
    [anon_sym_from] = ACTIONS(5215),
    [anon_sym_into] = ACTIONS(5215),
    [anon_sym_join] = ACTIONS(5215),
    [anon_sym_on] = ACTIONS(5215),
    [anon_sym_equals] = ACTIONS(5215),
    [anon_sym_let] = ACTIONS(5215),
    [anon_sym_orderby] = ACTIONS(5215),
    [anon_sym_ascending] = ACTIONS(5215),
    [anon_sym_descending] = ACTIONS(5215),
    [anon_sym_group] = ACTIONS(5215),
    [anon_sym_by] = ACTIONS(5215),
    [anon_sym_select] = ACTIONS(5215),
    [aux_sym_preproc_if_token1] = ACTIONS(5217),
    [aux_sym_preproc_if_token3] = ACTIONS(5217),
    [aux_sym_preproc_else_token1] = ACTIONS(5217),
    [aux_sym_preproc_elif_token1] = ACTIONS(5217),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3527] = {
    [sym_preproc_region] = STATE(3527),
    [sym_preproc_endregion] = STATE(3527),
    [sym_preproc_line] = STATE(3527),
    [sym_preproc_pragma] = STATE(3527),
    [sym_preproc_nullable] = STATE(3527),
    [sym_preproc_error] = STATE(3527),
    [sym_preproc_define] = STATE(3527),
    [sym_preproc_undef] = STATE(3527),
    [sym__identifier_token] = ACTIONS(5219),
    [anon_sym_extern] = ACTIONS(5219),
    [anon_sym_alias] = ACTIONS(5219),
    [anon_sym_global] = ACTIONS(5219),
    [anon_sym_using] = ACTIONS(5219),
    [anon_sym_unsafe] = ACTIONS(5219),
    [anon_sym_static] = ACTIONS(5219),
    [anon_sym_LBRACK] = ACTIONS(5221),
    [anon_sym_LPAREN] = ACTIONS(5221),
    [anon_sym_event] = ACTIONS(5219),
    [anon_sym_namespace] = ACTIONS(5219),
    [anon_sym_class] = ACTIONS(5219),
    [anon_sym_ref] = ACTIONS(5219),
    [anon_sym_struct] = ACTIONS(5219),
    [anon_sym_enum] = ACTIONS(5219),
    [anon_sym_RBRACE] = ACTIONS(5221),
    [anon_sym_interface] = ACTIONS(5219),
    [anon_sym_delegate] = ACTIONS(5219),
    [anon_sym_record] = ACTIONS(5219),
    [anon_sym_abstract] = ACTIONS(5219),
    [anon_sym_async] = ACTIONS(5219),
    [anon_sym_const] = ACTIONS(5219),
    [anon_sym_file] = ACTIONS(5219),
    [anon_sym_fixed] = ACTIONS(5219),
    [anon_sym_internal] = ACTIONS(5219),
    [anon_sym_new] = ACTIONS(5219),
    [anon_sym_override] = ACTIONS(5219),
    [anon_sym_partial] = ACTIONS(5219),
    [anon_sym_private] = ACTIONS(5219),
    [anon_sym_protected] = ACTIONS(5219),
    [anon_sym_public] = ACTIONS(5219),
    [anon_sym_readonly] = ACTIONS(5219),
    [anon_sym_required] = ACTIONS(5219),
    [anon_sym_sealed] = ACTIONS(5219),
    [anon_sym_virtual] = ACTIONS(5219),
    [anon_sym_volatile] = ACTIONS(5219),
    [anon_sym_where] = ACTIONS(5219),
    [anon_sym_notnull] = ACTIONS(5219),
    [anon_sym_unmanaged] = ACTIONS(5219),
    [anon_sym_TILDE] = ACTIONS(5221),
    [anon_sym_implicit] = ACTIONS(5219),
    [anon_sym_explicit] = ACTIONS(5219),
    [anon_sym_scoped] = ACTIONS(5219),
    [anon_sym_var] = ACTIONS(5219),
    [sym_predefined_type] = ACTIONS(5219),
    [anon_sym_yield] = ACTIONS(5219),
    [anon_sym_when] = ACTIONS(5219),
    [anon_sym_from] = ACTIONS(5219),
    [anon_sym_into] = ACTIONS(5219),
    [anon_sym_join] = ACTIONS(5219),
    [anon_sym_on] = ACTIONS(5219),
    [anon_sym_equals] = ACTIONS(5219),
    [anon_sym_let] = ACTIONS(5219),
    [anon_sym_orderby] = ACTIONS(5219),
    [anon_sym_ascending] = ACTIONS(5219),
    [anon_sym_descending] = ACTIONS(5219),
    [anon_sym_group] = ACTIONS(5219),
    [anon_sym_by] = ACTIONS(5219),
    [anon_sym_select] = ACTIONS(5219),
    [aux_sym_preproc_if_token1] = ACTIONS(5221),
    [aux_sym_preproc_if_token3] = ACTIONS(5221),
    [aux_sym_preproc_else_token1] = ACTIONS(5221),
    [aux_sym_preproc_elif_token1] = ACTIONS(5221),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3528] = {
    [sym_preproc_region] = STATE(3528),
    [sym_preproc_endregion] = STATE(3528),
    [sym_preproc_line] = STATE(3528),
    [sym_preproc_pragma] = STATE(3528),
    [sym_preproc_nullable] = STATE(3528),
    [sym_preproc_error] = STATE(3528),
    [sym_preproc_define] = STATE(3528),
    [sym_preproc_undef] = STATE(3528),
    [sym__identifier_token] = ACTIONS(5223),
    [anon_sym_extern] = ACTIONS(5223),
    [anon_sym_alias] = ACTIONS(5223),
    [anon_sym_global] = ACTIONS(5223),
    [anon_sym_using] = ACTIONS(5223),
    [anon_sym_unsafe] = ACTIONS(5223),
    [anon_sym_static] = ACTIONS(5223),
    [anon_sym_LBRACK] = ACTIONS(5225),
    [anon_sym_LPAREN] = ACTIONS(5225),
    [anon_sym_event] = ACTIONS(5223),
    [anon_sym_namespace] = ACTIONS(5223),
    [anon_sym_class] = ACTIONS(5223),
    [anon_sym_ref] = ACTIONS(5223),
    [anon_sym_struct] = ACTIONS(5223),
    [anon_sym_enum] = ACTIONS(5223),
    [anon_sym_RBRACE] = ACTIONS(5225),
    [anon_sym_interface] = ACTIONS(5223),
    [anon_sym_delegate] = ACTIONS(5223),
    [anon_sym_record] = ACTIONS(5223),
    [anon_sym_abstract] = ACTIONS(5223),
    [anon_sym_async] = ACTIONS(5223),
    [anon_sym_const] = ACTIONS(5223),
    [anon_sym_file] = ACTIONS(5223),
    [anon_sym_fixed] = ACTIONS(5223),
    [anon_sym_internal] = ACTIONS(5223),
    [anon_sym_new] = ACTIONS(5223),
    [anon_sym_override] = ACTIONS(5223),
    [anon_sym_partial] = ACTIONS(5223),
    [anon_sym_private] = ACTIONS(5223),
    [anon_sym_protected] = ACTIONS(5223),
    [anon_sym_public] = ACTIONS(5223),
    [anon_sym_readonly] = ACTIONS(5223),
    [anon_sym_required] = ACTIONS(5223),
    [anon_sym_sealed] = ACTIONS(5223),
    [anon_sym_virtual] = ACTIONS(5223),
    [anon_sym_volatile] = ACTIONS(5223),
    [anon_sym_where] = ACTIONS(5223),
    [anon_sym_notnull] = ACTIONS(5223),
    [anon_sym_unmanaged] = ACTIONS(5223),
    [anon_sym_TILDE] = ACTIONS(5225),
    [anon_sym_implicit] = ACTIONS(5223),
    [anon_sym_explicit] = ACTIONS(5223),
    [anon_sym_scoped] = ACTIONS(5223),
    [anon_sym_var] = ACTIONS(5223),
    [sym_predefined_type] = ACTIONS(5223),
    [anon_sym_yield] = ACTIONS(5223),
    [anon_sym_when] = ACTIONS(5223),
    [anon_sym_from] = ACTIONS(5223),
    [anon_sym_into] = ACTIONS(5223),
    [anon_sym_join] = ACTIONS(5223),
    [anon_sym_on] = ACTIONS(5223),
    [anon_sym_equals] = ACTIONS(5223),
    [anon_sym_let] = ACTIONS(5223),
    [anon_sym_orderby] = ACTIONS(5223),
    [anon_sym_ascending] = ACTIONS(5223),
    [anon_sym_descending] = ACTIONS(5223),
    [anon_sym_group] = ACTIONS(5223),
    [anon_sym_by] = ACTIONS(5223),
    [anon_sym_select] = ACTIONS(5223),
    [aux_sym_preproc_if_token1] = ACTIONS(5225),
    [aux_sym_preproc_if_token3] = ACTIONS(5225),
    [aux_sym_preproc_else_token1] = ACTIONS(5225),
    [aux_sym_preproc_elif_token1] = ACTIONS(5225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3529] = {
    [sym_preproc_region] = STATE(3529),
    [sym_preproc_endregion] = STATE(3529),
    [sym_preproc_line] = STATE(3529),
    [sym_preproc_pragma] = STATE(3529),
    [sym_preproc_nullable] = STATE(3529),
    [sym_preproc_error] = STATE(3529),
    [sym_preproc_define] = STATE(3529),
    [sym_preproc_undef] = STATE(3529),
    [sym__identifier_token] = ACTIONS(4711),
    [anon_sym_alias] = ACTIONS(4711),
    [anon_sym_global] = ACTIONS(4711),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_COLON] = ACTIONS(4713),
    [anon_sym_COMMA] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_file] = ACTIONS(4711),
    [anon_sym_LT] = ACTIONS(4711),
    [anon_sym_GT] = ACTIONS(4711),
    [anon_sym_where] = ACTIONS(4711),
    [anon_sym_QMARK] = ACTIONS(4711),
    [anon_sym_notnull] = ACTIONS(4711),
    [anon_sym_unmanaged] = ACTIONS(4711),
    [anon_sym_BANG] = ACTIONS(4711),
    [anon_sym_PLUS_PLUS] = ACTIONS(4713),
    [anon_sym_DASH_DASH] = ACTIONS(4713),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_SLASH] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4713),
    [anon_sym_CARET] = ACTIONS(4713),
    [anon_sym_PIPE] = ACTIONS(4711),
    [anon_sym_AMP] = ACTIONS(4711),
    [anon_sym_LT_LT] = ACTIONS(4713),
    [anon_sym_GT_GT] = ACTIONS(4711),
    [anon_sym_GT_GT_GT] = ACTIONS(4713),
    [anon_sym_EQ_EQ] = ACTIONS(4713),
    [anon_sym_BANG_EQ] = ACTIONS(4713),
    [anon_sym_GT_EQ] = ACTIONS(4713),
    [anon_sym_LT_EQ] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4711),
    [anon_sym_scoped] = ACTIONS(4711),
    [anon_sym_var] = ACTIONS(4711),
    [anon_sym_yield] = ACTIONS(4711),
    [anon_sym_switch] = ACTIONS(4711),
    [anon_sym_when] = ACTIONS(4711),
    [sym_discard] = ACTIONS(4711),
    [anon_sym_DOT_DOT] = ACTIONS(4713),
    [anon_sym_and] = ACTIONS(4711),
    [anon_sym_or] = ACTIONS(4711),
    [anon_sym_AMP_AMP] = ACTIONS(4713),
    [anon_sym_PIPE_PIPE] = ACTIONS(4713),
    [anon_sym_QMARK_QMARK] = ACTIONS(4713),
    [anon_sym_from] = ACTIONS(4711),
    [anon_sym_into] = ACTIONS(4711),
    [anon_sym_join] = ACTIONS(4711),
    [anon_sym_on] = ACTIONS(4711),
    [anon_sym_equals] = ACTIONS(4711),
    [anon_sym_let] = ACTIONS(4711),
    [anon_sym_orderby] = ACTIONS(4711),
    [anon_sym_ascending] = ACTIONS(4711),
    [anon_sym_descending] = ACTIONS(4711),
    [anon_sym_group] = ACTIONS(4711),
    [anon_sym_by] = ACTIONS(4711),
    [anon_sym_select] = ACTIONS(4711),
    [anon_sym_as] = ACTIONS(4711),
    [anon_sym_is] = ACTIONS(4711),
    [anon_sym_DASH_GT] = ACTIONS(4713),
    [anon_sym_with] = ACTIONS(4711),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4713),
  },
  [3530] = {
    [sym_preproc_region] = STATE(3530),
    [sym_preproc_endregion] = STATE(3530),
    [sym_preproc_line] = STATE(3530),
    [sym_preproc_pragma] = STATE(3530),
    [sym_preproc_nullable] = STATE(3530),
    [sym_preproc_error] = STATE(3530),
    [sym_preproc_define] = STATE(3530),
    [sym_preproc_undef] = STATE(3530),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_COMMA] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(4668),
    [anon_sym_GT] = ACTIONS(4668),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(4668),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_SLASH] = ACTIONS(4668),
    [anon_sym_PERCENT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(4670),
    [anon_sym_PIPE] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4668),
    [anon_sym_LT_LT] = ACTIONS(4670),
    [anon_sym_GT_GT] = ACTIONS(4668),
    [anon_sym_GT_GT_GT] = ACTIONS(4670),
    [anon_sym_EQ_EQ] = ACTIONS(4670),
    [anon_sym_BANG_EQ] = ACTIONS(4670),
    [anon_sym_GT_EQ] = ACTIONS(4670),
    [anon_sym_LT_EQ] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4668),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(4668),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(4670),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(4670),
    [anon_sym_PIPE_PIPE] = ACTIONS(4670),
    [anon_sym_QMARK_QMARK] = ACTIONS(4670),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(4668),
    [anon_sym_is] = ACTIONS(4668),
    [anon_sym_DASH_GT] = ACTIONS(4670),
    [anon_sym_with] = ACTIONS(4668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4670),
  },
  [3531] = {
    [sym_preproc_region] = STATE(3531),
    [sym_preproc_endregion] = STATE(3531),
    [sym_preproc_line] = STATE(3531),
    [sym_preproc_pragma] = STATE(3531),
    [sym_preproc_nullable] = STATE(3531),
    [sym_preproc_error] = STATE(3531),
    [sym_preproc_define] = STATE(3531),
    [sym_preproc_undef] = STATE(3531),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_COMMA] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_GT] = ACTIONS(4664),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4664),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_SLASH] = ACTIONS(4664),
    [anon_sym_PERCENT] = ACTIONS(4666),
    [anon_sym_CARET] = ACTIONS(4666),
    [anon_sym_PIPE] = ACTIONS(4664),
    [anon_sym_AMP] = ACTIONS(4664),
    [anon_sym_LT_LT] = ACTIONS(4666),
    [anon_sym_GT_GT] = ACTIONS(4664),
    [anon_sym_GT_GT_GT] = ACTIONS(4666),
    [anon_sym_EQ_EQ] = ACTIONS(4666),
    [anon_sym_BANG_EQ] = ACTIONS(4666),
    [anon_sym_GT_EQ] = ACTIONS(4666),
    [anon_sym_LT_EQ] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4664),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4664),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4666),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4666),
    [anon_sym_QMARK_QMARK] = ACTIONS(4666),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4664),
    [anon_sym_is] = ACTIONS(4664),
    [anon_sym_DASH_GT] = ACTIONS(4666),
    [anon_sym_with] = ACTIONS(4664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4666),
  },
  [3532] = {
    [sym_preproc_region] = STATE(3532),
    [sym_preproc_endregion] = STATE(3532),
    [sym_preproc_line] = STATE(3532),
    [sym_preproc_pragma] = STATE(3532),
    [sym_preproc_nullable] = STATE(3532),
    [sym_preproc_error] = STATE(3532),
    [sym_preproc_define] = STATE(3532),
    [sym_preproc_undef] = STATE(3532),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_COMMA] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(4668),
    [anon_sym_GT] = ACTIONS(4668),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(4668),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_SLASH] = ACTIONS(4668),
    [anon_sym_PERCENT] = ACTIONS(4670),
    [anon_sym_CARET] = ACTIONS(4670),
    [anon_sym_PIPE] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4668),
    [anon_sym_LT_LT] = ACTIONS(4670),
    [anon_sym_GT_GT] = ACTIONS(4668),
    [anon_sym_GT_GT_GT] = ACTIONS(4670),
    [anon_sym_EQ_EQ] = ACTIONS(4670),
    [anon_sym_BANG_EQ] = ACTIONS(4670),
    [anon_sym_GT_EQ] = ACTIONS(4670),
    [anon_sym_LT_EQ] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4668),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(4668),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(4670),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(4670),
    [anon_sym_PIPE_PIPE] = ACTIONS(4670),
    [anon_sym_QMARK_QMARK] = ACTIONS(4670),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(4668),
    [anon_sym_is] = ACTIONS(4668),
    [anon_sym_DASH_GT] = ACTIONS(4670),
    [anon_sym_with] = ACTIONS(4668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4670),
  },
  [3533] = {
    [sym_preproc_region] = STATE(3533),
    [sym_preproc_endregion] = STATE(3533),
    [sym_preproc_line] = STATE(3533),
    [sym_preproc_pragma] = STATE(3533),
    [sym_preproc_nullable] = STATE(3533),
    [sym_preproc_error] = STATE(3533),
    [sym_preproc_define] = STATE(3533),
    [sym_preproc_undef] = STATE(3533),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_COMMA] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_GT] = ACTIONS(4664),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4664),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_SLASH] = ACTIONS(4664),
    [anon_sym_PERCENT] = ACTIONS(4666),
    [anon_sym_CARET] = ACTIONS(4666),
    [anon_sym_PIPE] = ACTIONS(4664),
    [anon_sym_AMP] = ACTIONS(4664),
    [anon_sym_LT_LT] = ACTIONS(4666),
    [anon_sym_GT_GT] = ACTIONS(4664),
    [anon_sym_GT_GT_GT] = ACTIONS(4666),
    [anon_sym_EQ_EQ] = ACTIONS(4666),
    [anon_sym_BANG_EQ] = ACTIONS(4666),
    [anon_sym_GT_EQ] = ACTIONS(4666),
    [anon_sym_LT_EQ] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4664),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4664),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4666),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4666),
    [anon_sym_PIPE_PIPE] = ACTIONS(4666),
    [anon_sym_QMARK_QMARK] = ACTIONS(4666),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4664),
    [anon_sym_is] = ACTIONS(4664),
    [anon_sym_DASH_GT] = ACTIONS(4666),
    [anon_sym_with] = ACTIONS(4664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4666),
  },
  [3534] = {
    [sym_preproc_region] = STATE(3534),
    [sym_preproc_endregion] = STATE(3534),
    [sym_preproc_line] = STATE(3534),
    [sym_preproc_pragma] = STATE(3534),
    [sym_preproc_nullable] = STATE(3534),
    [sym_preproc_error] = STATE(3534),
    [sym_preproc_define] = STATE(3534),
    [sym_preproc_undef] = STATE(3534),
    [sym__identifier_token] = ACTIONS(4701),
    [anon_sym_alias] = ACTIONS(4701),
    [anon_sym_global] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4703),
    [anon_sym_COLON] = ACTIONS(4703),
    [anon_sym_COMMA] = ACTIONS(4703),
    [anon_sym_LPAREN] = ACTIONS(4703),
    [anon_sym_file] = ACTIONS(4701),
    [anon_sym_LT] = ACTIONS(4701),
    [anon_sym_GT] = ACTIONS(4701),
    [anon_sym_where] = ACTIONS(4701),
    [anon_sym_QMARK] = ACTIONS(4701),
    [anon_sym_notnull] = ACTIONS(4701),
    [anon_sym_unmanaged] = ACTIONS(4701),
    [anon_sym_BANG] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4703),
    [anon_sym_DASH_DASH] = ACTIONS(4703),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4703),
    [anon_sym_SLASH] = ACTIONS(4701),
    [anon_sym_PERCENT] = ACTIONS(4703),
    [anon_sym_CARET] = ACTIONS(4703),
    [anon_sym_PIPE] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_LT_LT] = ACTIONS(4703),
    [anon_sym_GT_GT] = ACTIONS(4701),
    [anon_sym_GT_GT_GT] = ACTIONS(4703),
    [anon_sym_EQ_EQ] = ACTIONS(4703),
    [anon_sym_BANG_EQ] = ACTIONS(4703),
    [anon_sym_GT_EQ] = ACTIONS(4703),
    [anon_sym_LT_EQ] = ACTIONS(4703),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_scoped] = ACTIONS(4701),
    [anon_sym_var] = ACTIONS(4701),
    [anon_sym_yield] = ACTIONS(4701),
    [anon_sym_switch] = ACTIONS(4701),
    [anon_sym_when] = ACTIONS(4701),
    [sym_discard] = ACTIONS(4701),
    [anon_sym_DOT_DOT] = ACTIONS(4703),
    [anon_sym_and] = ACTIONS(4701),
    [anon_sym_or] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4703),
    [anon_sym_PIPE_PIPE] = ACTIONS(4703),
    [anon_sym_QMARK_QMARK] = ACTIONS(4703),
    [anon_sym_from] = ACTIONS(4701),
    [anon_sym_into] = ACTIONS(4701),
    [anon_sym_join] = ACTIONS(4701),
    [anon_sym_on] = ACTIONS(4701),
    [anon_sym_equals] = ACTIONS(4701),
    [anon_sym_let] = ACTIONS(4701),
    [anon_sym_orderby] = ACTIONS(4701),
    [anon_sym_ascending] = ACTIONS(4701),
    [anon_sym_descending] = ACTIONS(4701),
    [anon_sym_group] = ACTIONS(4701),
    [anon_sym_by] = ACTIONS(4701),
    [anon_sym_select] = ACTIONS(4701),
    [anon_sym_as] = ACTIONS(4701),
    [anon_sym_is] = ACTIONS(4701),
    [anon_sym_DASH_GT] = ACTIONS(4703),
    [anon_sym_with] = ACTIONS(4701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4703),
  },
  [3535] = {
    [sym_preproc_region] = STATE(3535),
    [sym_preproc_endregion] = STATE(3535),
    [sym_preproc_line] = STATE(3535),
    [sym_preproc_pragma] = STATE(3535),
    [sym_preproc_nullable] = STATE(3535),
    [sym_preproc_error] = STATE(3535),
    [sym_preproc_define] = STATE(3535),
    [sym_preproc_undef] = STATE(3535),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4557),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3536] = {
    [sym_preproc_region] = STATE(3536),
    [sym_preproc_endregion] = STATE(3536),
    [sym_preproc_line] = STATE(3536),
    [sym_preproc_pragma] = STATE(3536),
    [sym_preproc_nullable] = STATE(3536),
    [sym_preproc_error] = STATE(3536),
    [sym_preproc_define] = STATE(3536),
    [sym_preproc_undef] = STATE(3536),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3537] = {
    [sym_preproc_region] = STATE(3537),
    [sym_preproc_endregion] = STATE(3537),
    [sym_preproc_line] = STATE(3537),
    [sym_preproc_pragma] = STATE(3537),
    [sym_preproc_nullable] = STATE(3537),
    [sym_preproc_error] = STATE(3537),
    [sym_preproc_define] = STATE(3537),
    [sym_preproc_undef] = STATE(3537),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5231),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3538] = {
    [sym_preproc_region] = STATE(3538),
    [sym_preproc_endregion] = STATE(3538),
    [sym_preproc_line] = STATE(3538),
    [sym_preproc_pragma] = STATE(3538),
    [sym_preproc_nullable] = STATE(3538),
    [sym_preproc_error] = STATE(3538),
    [sym_preproc_define] = STATE(3538),
    [sym_preproc_undef] = STATE(3538),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5233),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3539] = {
    [sym_preproc_region] = STATE(3539),
    [sym_preproc_endregion] = STATE(3539),
    [sym_preproc_line] = STATE(3539),
    [sym_preproc_pragma] = STATE(3539),
    [sym_preproc_nullable] = STATE(3539),
    [sym_preproc_error] = STATE(3539),
    [sym_preproc_define] = STATE(3539),
    [sym_preproc_undef] = STATE(3539),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5235),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3540] = {
    [sym_preproc_region] = STATE(3540),
    [sym_preproc_endregion] = STATE(3540),
    [sym_preproc_line] = STATE(3540),
    [sym_preproc_pragma] = STATE(3540),
    [sym_preproc_nullable] = STATE(3540),
    [sym_preproc_error] = STATE(3540),
    [sym_preproc_define] = STATE(3540),
    [sym_preproc_undef] = STATE(3540),
    [sym__identifier_token] = ACTIONS(4555),
    [anon_sym_alias] = ACTIONS(4555),
    [anon_sym_global] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(4557),
    [anon_sym_LBRACE] = ACTIONS(4557),
    [anon_sym_file] = ACTIONS(4555),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(4555),
    [anon_sym_where] = ACTIONS(4555),
    [anon_sym_QMARK] = ACTIONS(4555),
    [anon_sym_notnull] = ACTIONS(4555),
    [anon_sym_unmanaged] = ACTIONS(4555),
    [anon_sym_BANG] = ACTIONS(4555),
    [anon_sym_PLUS_PLUS] = ACTIONS(4557),
    [anon_sym_DASH_DASH] = ACTIONS(4557),
    [anon_sym_PLUS] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(4555),
    [anon_sym_STAR] = ACTIONS(4557),
    [anon_sym_SLASH] = ACTIONS(4555),
    [anon_sym_PERCENT] = ACTIONS(4557),
    [anon_sym_CARET] = ACTIONS(4557),
    [anon_sym_PIPE] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(4555),
    [anon_sym_LT_LT] = ACTIONS(4557),
    [anon_sym_GT_GT] = ACTIONS(4555),
    [anon_sym_GT_GT_GT] = ACTIONS(4557),
    [anon_sym_EQ_EQ] = ACTIONS(4557),
    [anon_sym_BANG_EQ] = ACTIONS(4557),
    [anon_sym_GT_EQ] = ACTIONS(4557),
    [anon_sym_LT_EQ] = ACTIONS(4557),
    [anon_sym_DOT] = ACTIONS(4555),
    [anon_sym_scoped] = ACTIONS(4555),
    [anon_sym_EQ_GT] = ACTIONS(4557),
    [anon_sym_var] = ACTIONS(4555),
    [anon_sym_yield] = ACTIONS(4555),
    [anon_sym_switch] = ACTIONS(4555),
    [anon_sym_when] = ACTIONS(4555),
    [sym_discard] = ACTIONS(4555),
    [anon_sym_DOT_DOT] = ACTIONS(4557),
    [anon_sym_and] = ACTIONS(4555),
    [anon_sym_or] = ACTIONS(4555),
    [anon_sym_AMP_AMP] = ACTIONS(4557),
    [anon_sym_PIPE_PIPE] = ACTIONS(4557),
    [anon_sym_QMARK_QMARK] = ACTIONS(4557),
    [anon_sym_from] = ACTIONS(4555),
    [anon_sym_into] = ACTIONS(4555),
    [anon_sym_join] = ACTIONS(4555),
    [anon_sym_on] = ACTIONS(4555),
    [anon_sym_equals] = ACTIONS(4555),
    [anon_sym_let] = ACTIONS(4555),
    [anon_sym_orderby] = ACTIONS(4555),
    [anon_sym_ascending] = ACTIONS(4555),
    [anon_sym_descending] = ACTIONS(4555),
    [anon_sym_group] = ACTIONS(4555),
    [anon_sym_by] = ACTIONS(4555),
    [anon_sym_select] = ACTIONS(4555),
    [anon_sym_as] = ACTIONS(4555),
    [anon_sym_is] = ACTIONS(4555),
    [anon_sym_DASH_GT] = ACTIONS(4557),
    [anon_sym_with] = ACTIONS(4555),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3541] = {
    [sym_preproc_region] = STATE(3541),
    [sym_preproc_endregion] = STATE(3541),
    [sym_preproc_line] = STATE(3541),
    [sym_preproc_pragma] = STATE(3541),
    [sym_preproc_nullable] = STATE(3541),
    [sym_preproc_error] = STATE(3541),
    [sym_preproc_define] = STATE(3541),
    [sym_preproc_undef] = STATE(3541),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5237),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3542] = {
    [sym_preproc_region] = STATE(3542),
    [sym_preproc_endregion] = STATE(3542),
    [sym_preproc_line] = STATE(3542),
    [sym_preproc_pragma] = STATE(3542),
    [sym_preproc_nullable] = STATE(3542),
    [sym_preproc_error] = STATE(3542),
    [sym_preproc_define] = STATE(3542),
    [sym_preproc_undef] = STATE(3542),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5239),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3543] = {
    [sym_preproc_region] = STATE(3543),
    [sym_preproc_endregion] = STATE(3543),
    [sym_preproc_line] = STATE(3543),
    [sym_preproc_pragma] = STATE(3543),
    [sym_preproc_nullable] = STATE(3543),
    [sym_preproc_error] = STATE(3543),
    [sym_preproc_define] = STATE(3543),
    [sym_preproc_undef] = STATE(3543),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5241),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3544] = {
    [sym_preproc_region] = STATE(3544),
    [sym_preproc_endregion] = STATE(3544),
    [sym_preproc_line] = STATE(3544),
    [sym_preproc_pragma] = STATE(3544),
    [sym_preproc_nullable] = STATE(3544),
    [sym_preproc_error] = STATE(3544),
    [sym_preproc_define] = STATE(3544),
    [sym_preproc_undef] = STATE(3544),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5243),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3545] = {
    [sym_preproc_region] = STATE(3545),
    [sym_preproc_endregion] = STATE(3545),
    [sym_preproc_line] = STATE(3545),
    [sym_preproc_pragma] = STATE(3545),
    [sym_preproc_nullable] = STATE(3545),
    [sym_preproc_error] = STATE(3545),
    [sym_preproc_define] = STATE(3545),
    [sym_preproc_undef] = STATE(3545),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4693),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_from] = ACTIONS(4691),
    [anon_sym_into] = ACTIONS(4691),
    [anon_sym_join] = ACTIONS(4691),
    [anon_sym_let] = ACTIONS(4691),
    [anon_sym_orderby] = ACTIONS(4691),
    [anon_sym_ascending] = ACTIONS(4691),
    [anon_sym_descending] = ACTIONS(4691),
    [anon_sym_group] = ACTIONS(4691),
    [anon_sym_select] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4693),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3546] = {
    [sym_preproc_region] = STATE(3546),
    [sym_preproc_endregion] = STATE(3546),
    [sym_preproc_line] = STATE(3546),
    [sym_preproc_pragma] = STATE(3546),
    [sym_preproc_nullable] = STATE(3546),
    [sym_preproc_error] = STATE(3546),
    [sym_preproc_define] = STATE(3546),
    [sym_preproc_undef] = STATE(3546),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_where] = ACTIONS(4705),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4707),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_from] = ACTIONS(4705),
    [anon_sym_into] = ACTIONS(4705),
    [anon_sym_join] = ACTIONS(4705),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_orderby] = ACTIONS(4705),
    [anon_sym_ascending] = ACTIONS(4705),
    [anon_sym_descending] = ACTIONS(4705),
    [anon_sym_group] = ACTIONS(4705),
    [anon_sym_select] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4707),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3547] = {
    [sym_preproc_region] = STATE(3547),
    [sym_preproc_endregion] = STATE(3547),
    [sym_preproc_line] = STATE(3547),
    [sym_preproc_pragma] = STATE(3547),
    [sym_preproc_nullable] = STATE(3547),
    [sym_preproc_error] = STATE(3547),
    [sym_preproc_define] = STATE(3547),
    [sym_preproc_undef] = STATE(3547),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5247),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3548] = {
    [sym_preproc_region] = STATE(3548),
    [sym_preproc_endregion] = STATE(3548),
    [sym_preproc_line] = STATE(3548),
    [sym_preproc_pragma] = STATE(3548),
    [sym_preproc_nullable] = STATE(3548),
    [sym_preproc_error] = STATE(3548),
    [sym_preproc_define] = STATE(3548),
    [sym_preproc_undef] = STATE(3548),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5249),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3549] = {
    [sym_preproc_region] = STATE(3549),
    [sym_preproc_endregion] = STATE(3549),
    [sym_preproc_line] = STATE(3549),
    [sym_preproc_pragma] = STATE(3549),
    [sym_preproc_nullable] = STATE(3549),
    [sym_preproc_error] = STATE(3549),
    [sym_preproc_define] = STATE(3549),
    [sym_preproc_undef] = STATE(3549),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_catch] = ACTIONS(2987),
    [anon_sym_finally] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3550] = {
    [sym_preproc_region] = STATE(3550),
    [sym_preproc_endregion] = STATE(3550),
    [sym_preproc_line] = STATE(3550),
    [sym_preproc_pragma] = STATE(3550),
    [sym_preproc_nullable] = STATE(3550),
    [sym_preproc_error] = STATE(3550),
    [sym_preproc_define] = STATE(3550),
    [sym_preproc_undef] = STATE(3550),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5251),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3551] = {
    [sym_preproc_region] = STATE(3551),
    [sym_preproc_endregion] = STATE(3551),
    [sym_preproc_line] = STATE(3551),
    [sym_preproc_pragma] = STATE(3551),
    [sym_preproc_nullable] = STATE(3551),
    [sym_preproc_error] = STATE(3551),
    [sym_preproc_define] = STATE(3551),
    [sym_preproc_undef] = STATE(3551),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3552] = {
    [sym_preproc_region] = STATE(3552),
    [sym_preproc_endregion] = STATE(3552),
    [sym_preproc_line] = STATE(3552),
    [sym_preproc_pragma] = STATE(3552),
    [sym_preproc_nullable] = STATE(3552),
    [sym_preproc_error] = STATE(3552),
    [sym_preproc_define] = STATE(3552),
    [sym_preproc_undef] = STATE(3552),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5255),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3553] = {
    [sym_preproc_region] = STATE(3553),
    [sym_preproc_endregion] = STATE(3553),
    [sym_preproc_line] = STATE(3553),
    [sym_preproc_pragma] = STATE(3553),
    [sym_preproc_nullable] = STATE(3553),
    [sym_preproc_error] = STATE(3553),
    [sym_preproc_define] = STATE(3553),
    [sym_preproc_undef] = STATE(3553),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5257),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3554] = {
    [sym_preproc_region] = STATE(3554),
    [sym_preproc_endregion] = STATE(3554),
    [sym_preproc_line] = STATE(3554),
    [sym_preproc_pragma] = STATE(3554),
    [sym_preproc_nullable] = STATE(3554),
    [sym_preproc_error] = STATE(3554),
    [sym_preproc_define] = STATE(3554),
    [sym_preproc_undef] = STATE(3554),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5259),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3555] = {
    [sym_preproc_region] = STATE(3555),
    [sym_preproc_endregion] = STATE(3555),
    [sym_preproc_line] = STATE(3555),
    [sym_preproc_pragma] = STATE(3555),
    [sym_preproc_nullable] = STATE(3555),
    [sym_preproc_error] = STATE(3555),
    [sym_preproc_define] = STATE(3555),
    [sym_preproc_undef] = STATE(3555),
    [sym__identifier_token] = ACTIONS(4664),
    [anon_sym_alias] = ACTIONS(4664),
    [anon_sym_global] = ACTIONS(4664),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_file] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_where] = ACTIONS(4664),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_notnull] = ACTIONS(4664),
    [anon_sym_unmanaged] = ACTIONS(4664),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_scoped] = ACTIONS(4664),
    [anon_sym_var] = ACTIONS(4664),
    [anon_sym_yield] = ACTIONS(4664),
    [anon_sym_switch] = ACTIONS(4765),
    [anon_sym_when] = ACTIONS(4664),
    [sym_discard] = ACTIONS(4664),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4664),
    [anon_sym_or] = ACTIONS(4664),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_from] = ACTIONS(4664),
    [anon_sym_into] = ACTIONS(4664),
    [anon_sym_join] = ACTIONS(4664),
    [anon_sym_on] = ACTIONS(4664),
    [anon_sym_equals] = ACTIONS(4664),
    [anon_sym_let] = ACTIONS(4664),
    [anon_sym_orderby] = ACTIONS(4664),
    [anon_sym_ascending] = ACTIONS(4664),
    [anon_sym_descending] = ACTIONS(4664),
    [anon_sym_group] = ACTIONS(4664),
    [anon_sym_by] = ACTIONS(4664),
    [anon_sym_select] = ACTIONS(4664),
    [anon_sym_as] = ACTIONS(4765),
    [anon_sym_is] = ACTIONS(4765),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4765),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3556] = {
    [sym_preproc_region] = STATE(3556),
    [sym_preproc_endregion] = STATE(3556),
    [sym_preproc_line] = STATE(3556),
    [sym_preproc_pragma] = STATE(3556),
    [sym_preproc_nullable] = STATE(3556),
    [sym_preproc_error] = STATE(3556),
    [sym_preproc_define] = STATE(3556),
    [sym_preproc_undef] = STATE(3556),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_where] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4656),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_from] = ACTIONS(4654),
    [anon_sym_into] = ACTIONS(4654),
    [anon_sym_join] = ACTIONS(4654),
    [anon_sym_let] = ACTIONS(4654),
    [anon_sym_orderby] = ACTIONS(4654),
    [anon_sym_ascending] = ACTIONS(4654),
    [anon_sym_descending] = ACTIONS(4654),
    [anon_sym_group] = ACTIONS(4654),
    [anon_sym_select] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4656),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3557] = {
    [sym_preproc_region] = STATE(3557),
    [sym_preproc_endregion] = STATE(3557),
    [sym_preproc_line] = STATE(3557),
    [sym_preproc_pragma] = STATE(3557),
    [sym_preproc_nullable] = STATE(3557),
    [sym_preproc_error] = STATE(3557),
    [sym_preproc_define] = STATE(3557),
    [sym_preproc_undef] = STATE(3557),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_where] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3040),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_catch] = ACTIONS(3042),
    [anon_sym_finally] = ACTIONS(3042),
    [anon_sym_else] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_QMARK_QMARK] = ACTIONS(3042),
    [anon_sym_from] = ACTIONS(3042),
    [anon_sym_join] = ACTIONS(3042),
    [anon_sym_on] = ACTIONS(3042),
    [anon_sym_equals] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_orderby] = ACTIONS(3042),
    [anon_sym_group] = ACTIONS(3042),
    [anon_sym_by] = ACTIONS(3042),
    [anon_sym_select] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_DASH_GT] = ACTIONS(3042),
    [anon_sym_with] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3558] = {
    [sym_preproc_region] = STATE(3558),
    [sym_preproc_endregion] = STATE(3558),
    [sym_preproc_line] = STATE(3558),
    [sym_preproc_pragma] = STATE(3558),
    [sym_preproc_nullable] = STATE(3558),
    [sym_preproc_error] = STATE(3558),
    [sym_preproc_define] = STATE(3558),
    [sym_preproc_undef] = STATE(3558),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_where] = ACTIONS(4636),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4642),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_from] = ACTIONS(4636),
    [anon_sym_into] = ACTIONS(4636),
    [anon_sym_join] = ACTIONS(4636),
    [anon_sym_let] = ACTIONS(4636),
    [anon_sym_orderby] = ACTIONS(4636),
    [anon_sym_ascending] = ACTIONS(4636),
    [anon_sym_descending] = ACTIONS(4636),
    [anon_sym_group] = ACTIONS(4636),
    [anon_sym_select] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4642),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3559] = {
    [sym_preproc_region] = STATE(3559),
    [sym_preproc_endregion] = STATE(3559),
    [sym_preproc_line] = STATE(3559),
    [sym_preproc_pragma] = STATE(3559),
    [sym_preproc_nullable] = STATE(3559),
    [sym_preproc_error] = STATE(3559),
    [sym_preproc_define] = STATE(3559),
    [sym_preproc_undef] = STATE(3559),
    [sym__identifier_token] = ACTIONS(4451),
    [anon_sym_alias] = ACTIONS(4451),
    [anon_sym_global] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_file] = ACTIONS(4451),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4541),
    [anon_sym_notnull] = ACTIONS(4451),
    [anon_sym_unmanaged] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5261),
    [anon_sym_scoped] = ACTIONS(4451),
    [anon_sym_var] = ACTIONS(4451),
    [anon_sym_yield] = ACTIONS(4451),
    [anon_sym_switch] = ACTIONS(4451),
    [anon_sym_when] = ACTIONS(4451),
    [sym_discard] = ACTIONS(4451),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4451),
    [anon_sym_into] = ACTIONS(4451),
    [anon_sym_join] = ACTIONS(4451),
    [anon_sym_on] = ACTIONS(4451),
    [anon_sym_equals] = ACTIONS(4451),
    [anon_sym_let] = ACTIONS(4451),
    [anon_sym_orderby] = ACTIONS(4451),
    [anon_sym_ascending] = ACTIONS(4451),
    [anon_sym_descending] = ACTIONS(4451),
    [anon_sym_group] = ACTIONS(4451),
    [anon_sym_by] = ACTIONS(4451),
    [anon_sym_select] = ACTIONS(4451),
    [anon_sym_as] = ACTIONS(4451),
    [anon_sym_is] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(4451),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3560] = {
    [sym_preproc_region] = STATE(3560),
    [sym_preproc_endregion] = STATE(3560),
    [sym_preproc_line] = STATE(3560),
    [sym_preproc_pragma] = STATE(3560),
    [sym_preproc_nullable] = STATE(3560),
    [sym_preproc_error] = STATE(3560),
    [sym_preproc_define] = STATE(3560),
    [sym_preproc_undef] = STATE(3560),
    [sym__identifier_token] = ACTIONS(4668),
    [anon_sym_alias] = ACTIONS(4668),
    [anon_sym_global] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_file] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(4668),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(4668),
    [anon_sym_unmanaged] = ACTIONS(4668),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_scoped] = ACTIONS(4668),
    [anon_sym_var] = ACTIONS(4668),
    [anon_sym_yield] = ACTIONS(4668),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(4668),
    [sym_discard] = ACTIONS(4668),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(4668),
    [anon_sym_or] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(4668),
    [anon_sym_into] = ACTIONS(4668),
    [anon_sym_join] = ACTIONS(4668),
    [anon_sym_on] = ACTIONS(4668),
    [anon_sym_equals] = ACTIONS(4668),
    [anon_sym_let] = ACTIONS(4668),
    [anon_sym_orderby] = ACTIONS(4668),
    [anon_sym_ascending] = ACTIONS(4668),
    [anon_sym_descending] = ACTIONS(4668),
    [anon_sym_group] = ACTIONS(4668),
    [anon_sym_by] = ACTIONS(4668),
    [anon_sym_select] = ACTIONS(4668),
    [anon_sym_as] = ACTIONS(2989),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3561] = {
    [sym_argument_list] = STATE(3576),
    [sym_initializer_expression] = STATE(3729),
    [sym_preproc_region] = STATE(3561),
    [sym_preproc_endregion] = STATE(3561),
    [sym_preproc_line] = STATE(3561),
    [sym_preproc_pragma] = STATE(3561),
    [sym_preproc_nullable] = STATE(3561),
    [sym_preproc_error] = STATE(3561),
    [sym_preproc_define] = STATE(3561),
    [sym_preproc_undef] = STATE(3561),
    [anon_sym_SEMI] = ACTIONS(5263),
    [anon_sym_LBRACK] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5263),
    [anon_sym_COMMA] = ACTIONS(5263),
    [anon_sym_RBRACK] = ACTIONS(5263),
    [anon_sym_LPAREN] = ACTIONS(5265),
    [anon_sym_RPAREN] = ACTIONS(5263),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5267),
    [anon_sym_in] = ACTIONS(5267),
    [anon_sym_where] = ACTIONS(5263),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5263),
    [anon_sym_DASH_DASH] = ACTIONS(5263),
    [anon_sym_PLUS] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_SLASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5263),
    [anon_sym_CARET] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_LT_LT] = ACTIONS(5263),
    [anon_sym_GT_GT] = ACTIONS(5267),
    [anon_sym_GT_GT_GT] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_DOT] = ACTIONS(5267),
    [anon_sym_EQ_GT] = ACTIONS(5263),
    [anon_sym_switch] = ACTIONS(5263),
    [anon_sym_DOT_DOT] = ACTIONS(5263),
    [anon_sym_and] = ACTIONS(5263),
    [anon_sym_or] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_QMARK_QMARK] = ACTIONS(5263),
    [anon_sym_from] = ACTIONS(5263),
    [anon_sym_into] = ACTIONS(5263),
    [anon_sym_join] = ACTIONS(5263),
    [anon_sym_on] = ACTIONS(5263),
    [anon_sym_equals] = ACTIONS(5263),
    [anon_sym_let] = ACTIONS(5263),
    [anon_sym_orderby] = ACTIONS(5263),
    [anon_sym_group] = ACTIONS(5263),
    [anon_sym_by] = ACTIONS(5263),
    [anon_sym_select] = ACTIONS(5263),
    [anon_sym_as] = ACTIONS(5263),
    [anon_sym_is] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5263),
    [anon_sym_with] = ACTIONS(5263),
    [aux_sym_preproc_if_token3] = ACTIONS(5263),
    [aux_sym_preproc_else_token1] = ACTIONS(5263),
    [aux_sym_preproc_elif_token1] = ACTIONS(5263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3562] = {
    [sym_preproc_region] = STATE(3562),
    [sym_preproc_endregion] = STATE(3562),
    [sym_preproc_line] = STATE(3562),
    [sym_preproc_pragma] = STATE(3562),
    [sym_preproc_nullable] = STATE(3562),
    [sym_preproc_error] = STATE(3562),
    [sym_preproc_define] = STATE(3562),
    [sym_preproc_undef] = STATE(3562),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_where] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4122),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_join] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_orderby] = ACTIONS(4122),
    [anon_sym_group] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_select] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3563] = {
    [sym_type_argument_list] = STATE(3591),
    [sym_preproc_region] = STATE(3563),
    [sym_preproc_endregion] = STATE(3563),
    [sym_preproc_line] = STATE(3563),
    [sym_preproc_pragma] = STATE(3563),
    [sym_preproc_nullable] = STATE(3563),
    [sym_preproc_error] = STATE(3563),
    [sym_preproc_define] = STATE(3563),
    [sym_preproc_undef] = STATE(3563),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3564] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym_tuple_pattern] = STATE(8662),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6757),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3564),
    [sym_preproc_endregion] = STATE(3564),
    [sym_preproc_line] = STATE(3564),
    [sym_preproc_pragma] = STATE(3564),
    [sym_preproc_nullable] = STATE(3564),
    [sym_preproc_error] = STATE(3564),
    [sym_preproc_define] = STATE(3564),
    [sym_preproc_undef] = STATE(3564),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(5274),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [sym_discard] = ACTIONS(5280),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3565] = {
    [sym_preproc_region] = STATE(3565),
    [sym_preproc_endregion] = STATE(3565),
    [sym_preproc_line] = STATE(3565),
    [sym_preproc_pragma] = STATE(3565),
    [sym_preproc_nullable] = STATE(3565),
    [sym_preproc_error] = STATE(3565),
    [sym_preproc_define] = STATE(3565),
    [sym_preproc_undef] = STATE(3565),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_where] = ACTIONS(4681),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4683),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_from] = ACTIONS(4681),
    [anon_sym_into] = ACTIONS(4681),
    [anon_sym_join] = ACTIONS(4681),
    [anon_sym_let] = ACTIONS(4681),
    [anon_sym_orderby] = ACTIONS(4681),
    [anon_sym_ascending] = ACTIONS(4681),
    [anon_sym_descending] = ACTIONS(4681),
    [anon_sym_group] = ACTIONS(4681),
    [anon_sym_select] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4683),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3566] = {
    [sym_argument_list] = STATE(3689),
    [sym_bracketed_argument_list] = STATE(3016),
    [sym_preproc_region] = STATE(3566),
    [sym_preproc_endregion] = STATE(3566),
    [sym_preproc_line] = STATE(3566),
    [sym_preproc_pragma] = STATE(3566),
    [sym_preproc_nullable] = STATE(3566),
    [sym_preproc_error] = STATE(3566),
    [sym_preproc_define] = STATE(3566),
    [sym_preproc_undef] = STATE(3566),
    [anon_sym_SEMI] = ACTIONS(5282),
    [anon_sym_LBRACK] = ACTIONS(5284),
    [anon_sym_COLON] = ACTIONS(5282),
    [anon_sym_COMMA] = ACTIONS(5282),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(5265),
    [anon_sym_RPAREN] = ACTIONS(5282),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LT] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_in] = ACTIONS(5286),
    [anon_sym_where] = ACTIONS(5282),
    [anon_sym_QMARK] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_PLUS_PLUS] = ACTIONS(5290),
    [anon_sym_DASH_DASH] = ACTIONS(5290),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_DASH] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5282),
    [anon_sym_SLASH] = ACTIONS(5286),
    [anon_sym_PERCENT] = ACTIONS(5282),
    [anon_sym_CARET] = ACTIONS(5282),
    [anon_sym_PIPE] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5286),
    [anon_sym_LT_LT] = ACTIONS(5282),
    [anon_sym_GT_GT] = ACTIONS(5286),
    [anon_sym_GT_GT_GT] = ACTIONS(5282),
    [anon_sym_EQ_EQ] = ACTIONS(5282),
    [anon_sym_BANG_EQ] = ACTIONS(5282),
    [anon_sym_GT_EQ] = ACTIONS(5282),
    [anon_sym_LT_EQ] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_EQ_GT] = ACTIONS(5282),
    [anon_sym_switch] = ACTIONS(5282),
    [anon_sym_DOT_DOT] = ACTIONS(5282),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_or] = ACTIONS(5286),
    [anon_sym_AMP_AMP] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5282),
    [anon_sym_QMARK_QMARK] = ACTIONS(5282),
    [anon_sym_from] = ACTIONS(5282),
    [anon_sym_into] = ACTIONS(5282),
    [anon_sym_join] = ACTIONS(5282),
    [anon_sym_on] = ACTIONS(5282),
    [anon_sym_equals] = ACTIONS(5282),
    [anon_sym_let] = ACTIONS(5282),
    [anon_sym_orderby] = ACTIONS(5282),
    [anon_sym_group] = ACTIONS(5282),
    [anon_sym_by] = ACTIONS(5282),
    [anon_sym_select] = ACTIONS(5282),
    [anon_sym_as] = ACTIONS(5282),
    [anon_sym_is] = ACTIONS(5282),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(5282),
    [aux_sym_preproc_if_token3] = ACTIONS(5282),
    [aux_sym_preproc_else_token1] = ACTIONS(5282),
    [aux_sym_preproc_elif_token1] = ACTIONS(5282),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3567] = {
    [sym_preproc_region] = STATE(3567),
    [sym_preproc_endregion] = STATE(3567),
    [sym_preproc_line] = STATE(3567),
    [sym_preproc_pragma] = STATE(3567),
    [sym_preproc_nullable] = STATE(3567),
    [sym_preproc_error] = STATE(3567),
    [sym_preproc_define] = STATE(3567),
    [sym_preproc_undef] = STATE(3567),
    [anon_sym_EQ] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5298),
    [anon_sym_DASH_EQ] = ACTIONS(5298),
    [anon_sym_STAR_EQ] = ACTIONS(5298),
    [anon_sym_SLASH_EQ] = ACTIONS(5298),
    [anon_sym_PERCENT_EQ] = ACTIONS(5298),
    [anon_sym_AMP_EQ] = ACTIONS(5298),
    [anon_sym_CARET_EQ] = ACTIONS(5298),
    [anon_sym_PIPE_EQ] = ACTIONS(5298),
    [anon_sym_LT_LT_EQ] = ACTIONS(5298),
    [anon_sym_GT_GT_EQ] = ACTIONS(5298),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5298),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5298),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_ascending] = ACTIONS(5294),
    [anon_sym_descending] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5296),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3568] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7056),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9039),
    [sym_identifier] = STATE(6694),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3568),
    [sym_preproc_endregion] = STATE(3568),
    [sym_preproc_line] = STATE(3568),
    [sym_preproc_pragma] = STATE(3568),
    [sym_preproc_nullable] = STATE(3568),
    [sym_preproc_error] = STATE(3568),
    [sym_preproc_define] = STATE(3568),
    [sym_preproc_undef] = STATE(3568),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4209),
    [aux_sym_lambda_expression_repeat1] = STATE(4325),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5300),
    [anon_sym_params] = ACTIONS(5302),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3569] = {
    [sym_initializer_expression] = STATE(3726),
    [sym_preproc_region] = STATE(3569),
    [sym_preproc_endregion] = STATE(3569),
    [sym_preproc_line] = STATE(3569),
    [sym_preproc_pragma] = STATE(3569),
    [sym_preproc_nullable] = STATE(3569),
    [sym_preproc_error] = STATE(3569),
    [sym_preproc_define] = STATE(3569),
    [sym_preproc_undef] = STATE(3569),
    [anon_sym_SEMI] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5304),
    [anon_sym_RBRACK] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(5304),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_in] = ACTIONS(5309),
    [anon_sym_where] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5309),
    [anon_sym_BANG] = ACTIONS(5309),
    [anon_sym_PLUS_PLUS] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_GT_GT_GT] = ACTIONS(5304),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_GT_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5304),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_EQ_GT] = ACTIONS(5304),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_DOT_DOT] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5304),
    [anon_sym_PIPE_PIPE] = ACTIONS(5304),
    [anon_sym_QMARK_QMARK] = ACTIONS(5304),
    [anon_sym_from] = ACTIONS(5304),
    [anon_sym_into] = ACTIONS(5304),
    [anon_sym_join] = ACTIONS(5304),
    [anon_sym_on] = ACTIONS(5304),
    [anon_sym_equals] = ACTIONS(5304),
    [anon_sym_let] = ACTIONS(5304),
    [anon_sym_orderby] = ACTIONS(5304),
    [anon_sym_group] = ACTIONS(5304),
    [anon_sym_by] = ACTIONS(5304),
    [anon_sym_select] = ACTIONS(5304),
    [anon_sym_as] = ACTIONS(5304),
    [anon_sym_is] = ACTIONS(5304),
    [anon_sym_DASH_GT] = ACTIONS(5304),
    [anon_sym_with] = ACTIONS(5304),
    [aux_sym_preproc_if_token3] = ACTIONS(5304),
    [aux_sym_preproc_else_token1] = ACTIONS(5304),
    [aux_sym_preproc_elif_token1] = ACTIONS(5304),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3570] = {
    [sym_preproc_region] = STATE(3570),
    [sym_preproc_endregion] = STATE(3570),
    [sym_preproc_line] = STATE(3570),
    [sym_preproc_pragma] = STATE(3570),
    [sym_preproc_nullable] = STATE(3570),
    [sym_preproc_error] = STATE(3570),
    [sym_preproc_define] = STATE(3570),
    [sym_preproc_undef] = STATE(3570),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_where] = ACTIONS(4640),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4638),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_from] = ACTIONS(4640),
    [anon_sym_into] = ACTIONS(4640),
    [anon_sym_join] = ACTIONS(4640),
    [anon_sym_let] = ACTIONS(4640),
    [anon_sym_orderby] = ACTIONS(4640),
    [anon_sym_ascending] = ACTIONS(4640),
    [anon_sym_descending] = ACTIONS(4640),
    [anon_sym_group] = ACTIONS(4640),
    [anon_sym_select] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4638),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3571] = {
    [sym_preproc_region] = STATE(3571),
    [sym_preproc_endregion] = STATE(3571),
    [sym_preproc_line] = STATE(3571),
    [sym_preproc_pragma] = STATE(3571),
    [sym_preproc_nullable] = STATE(3571),
    [sym_preproc_error] = STATE(3571),
    [sym_preproc_define] = STATE(3571),
    [sym_preproc_undef] = STATE(3571),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3572] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7015),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9741),
    [sym_identifier] = STATE(6694),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3572),
    [sym_preproc_endregion] = STATE(3572),
    [sym_preproc_line] = STATE(3572),
    [sym_preproc_pragma] = STATE(3572),
    [sym_preproc_nullable] = STATE(3572),
    [sym_preproc_error] = STATE(3572),
    [sym_preproc_define] = STATE(3572),
    [sym_preproc_undef] = STATE(3572),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4209),
    [aux_sym_lambda_expression_repeat1] = STATE(4215),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5300),
    [anon_sym_params] = ACTIONS(5302),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3573] = {
    [sym_argument_list] = STATE(3689),
    [sym_bracketed_argument_list] = STATE(3016),
    [sym_preproc_region] = STATE(3573),
    [sym_preproc_endregion] = STATE(3573),
    [sym_preproc_line] = STATE(3573),
    [sym_preproc_pragma] = STATE(3573),
    [sym_preproc_nullable] = STATE(3573),
    [sym_preproc_error] = STATE(3573),
    [sym_preproc_define] = STATE(3573),
    [sym_preproc_undef] = STATE(3573),
    [anon_sym_SEMI] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5284),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_RBRACK] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(5265),
    [anon_sym_RPAREN] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5313),
    [anon_sym_in] = ACTIONS(5313),
    [anon_sym_where] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_PLUS_PLUS] = ACTIONS(5290),
    [anon_sym_DASH_DASH] = ACTIONS(5290),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5313),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_GT_GT_GT] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5311),
    [anon_sym_BANG_EQ] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_EQ_GT] = ACTIONS(5311),
    [anon_sym_switch] = ACTIONS(5311),
    [anon_sym_DOT_DOT] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_or] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_QMARK_QMARK] = ACTIONS(5311),
    [anon_sym_from] = ACTIONS(5311),
    [anon_sym_into] = ACTIONS(5311),
    [anon_sym_join] = ACTIONS(5311),
    [anon_sym_on] = ACTIONS(5311),
    [anon_sym_equals] = ACTIONS(5311),
    [anon_sym_let] = ACTIONS(5311),
    [anon_sym_orderby] = ACTIONS(5311),
    [anon_sym_group] = ACTIONS(5311),
    [anon_sym_by] = ACTIONS(5311),
    [anon_sym_select] = ACTIONS(5311),
    [anon_sym_as] = ACTIONS(5311),
    [anon_sym_is] = ACTIONS(5311),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(5311),
    [aux_sym_preproc_if_token3] = ACTIONS(5311),
    [aux_sym_preproc_else_token1] = ACTIONS(5311),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3574] = {
    [sym_preproc_region] = STATE(3574),
    [sym_preproc_endregion] = STATE(3574),
    [sym_preproc_line] = STATE(3574),
    [sym_preproc_pragma] = STATE(3574),
    [sym_preproc_nullable] = STATE(3574),
    [sym_preproc_error] = STATE(3574),
    [sym_preproc_define] = STATE(3574),
    [sym_preproc_undef] = STATE(3574),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_COMMA] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_LT] = ACTIONS(4646),
    [anon_sym_GT] = ACTIONS(4646),
    [anon_sym_where] = ACTIONS(4644),
    [anon_sym_QMARK] = ACTIONS(4646),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_STAR] = ACTIONS(4646),
    [anon_sym_SLASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4646),
    [anon_sym_AMP] = ACTIONS(4646),
    [anon_sym_LT_LT] = ACTIONS(4646),
    [anon_sym_GT_GT] = ACTIONS(4646),
    [anon_sym_GT_GT_GT] = ACTIONS(4646),
    [anon_sym_EQ_EQ] = ACTIONS(4644),
    [anon_sym_BANG_EQ] = ACTIONS(4644),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_LT_EQ] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_switch] = ACTIONS(4644),
    [anon_sym_DOT_DOT] = ACTIONS(4644),
    [anon_sym_and] = ACTIONS(4644),
    [anon_sym_or] = ACTIONS(4646),
    [anon_sym_PLUS_EQ] = ACTIONS(4644),
    [anon_sym_DASH_EQ] = ACTIONS(4644),
    [anon_sym_STAR_EQ] = ACTIONS(4644),
    [anon_sym_SLASH_EQ] = ACTIONS(4644),
    [anon_sym_PERCENT_EQ] = ACTIONS(4644),
    [anon_sym_AMP_EQ] = ACTIONS(4644),
    [anon_sym_CARET_EQ] = ACTIONS(4644),
    [anon_sym_PIPE_EQ] = ACTIONS(4644),
    [anon_sym_LT_LT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4644),
    [anon_sym_AMP_AMP] = ACTIONS(4644),
    [anon_sym_PIPE_PIPE] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK] = ACTIONS(4646),
    [anon_sym_from] = ACTIONS(4644),
    [anon_sym_into] = ACTIONS(4644),
    [anon_sym_join] = ACTIONS(4644),
    [anon_sym_let] = ACTIONS(4644),
    [anon_sym_orderby] = ACTIONS(4644),
    [anon_sym_ascending] = ACTIONS(4644),
    [anon_sym_descending] = ACTIONS(4644),
    [anon_sym_group] = ACTIONS(4644),
    [anon_sym_select] = ACTIONS(4644),
    [anon_sym_as] = ACTIONS(4646),
    [anon_sym_is] = ACTIONS(4644),
    [anon_sym_DASH_GT] = ACTIONS(4644),
    [anon_sym_with] = ACTIONS(4644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3575] = {
    [sym_preproc_region] = STATE(3575),
    [sym_preproc_endregion] = STATE(3575),
    [sym_preproc_line] = STATE(3575),
    [sym_preproc_pragma] = STATE(3575),
    [sym_preproc_nullable] = STATE(3575),
    [sym_preproc_error] = STATE(3575),
    [sym_preproc_define] = STATE(3575),
    [sym_preproc_undef] = STATE(3575),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_where] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4159),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_from] = ACTIONS(4167),
    [anon_sym_into] = ACTIONS(4167),
    [anon_sym_join] = ACTIONS(4167),
    [anon_sym_let] = ACTIONS(4167),
    [anon_sym_orderby] = ACTIONS(4167),
    [anon_sym_ascending] = ACTIONS(4167),
    [anon_sym_descending] = ACTIONS(4167),
    [anon_sym_group] = ACTIONS(4167),
    [anon_sym_select] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3576] = {
    [sym_initializer_expression] = STATE(3687),
    [sym_preproc_region] = STATE(3576),
    [sym_preproc_endregion] = STATE(3576),
    [sym_preproc_line] = STATE(3576),
    [sym_preproc_pragma] = STATE(3576),
    [sym_preproc_nullable] = STATE(3576),
    [sym_preproc_error] = STATE(3576),
    [sym_preproc_define] = STATE(3576),
    [sym_preproc_undef] = STATE(3576),
    [anon_sym_SEMI] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [anon_sym_LPAREN] = ACTIONS(5315),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_in] = ACTIONS(5317),
    [anon_sym_where] = ACTIONS(5315),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_PIPE] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5317),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_GT_GT_GT] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5315),
    [anon_sym_BANG_EQ] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5315),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_DOT] = ACTIONS(5317),
    [anon_sym_EQ_GT] = ACTIONS(5315),
    [anon_sym_switch] = ACTIONS(5315),
    [anon_sym_DOT_DOT] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_or] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5315),
    [anon_sym_QMARK_QMARK] = ACTIONS(5315),
    [anon_sym_from] = ACTIONS(5315),
    [anon_sym_into] = ACTIONS(5315),
    [anon_sym_join] = ACTIONS(5315),
    [anon_sym_on] = ACTIONS(5315),
    [anon_sym_equals] = ACTIONS(5315),
    [anon_sym_let] = ACTIONS(5315),
    [anon_sym_orderby] = ACTIONS(5315),
    [anon_sym_group] = ACTIONS(5315),
    [anon_sym_by] = ACTIONS(5315),
    [anon_sym_select] = ACTIONS(5315),
    [anon_sym_as] = ACTIONS(5315),
    [anon_sym_is] = ACTIONS(5315),
    [anon_sym_DASH_GT] = ACTIONS(5315),
    [anon_sym_with] = ACTIONS(5315),
    [aux_sym_preproc_if_token3] = ACTIONS(5315),
    [aux_sym_preproc_else_token1] = ACTIONS(5315),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3577] = {
    [sym_initializer_expression] = STATE(3730),
    [sym_preproc_region] = STATE(3577),
    [sym_preproc_endregion] = STATE(3577),
    [sym_preproc_line] = STATE(3577),
    [sym_preproc_pragma] = STATE(3577),
    [sym_preproc_nullable] = STATE(3577),
    [sym_preproc_error] = STATE(3577),
    [sym_preproc_define] = STATE(3577),
    [sym_preproc_undef] = STATE(3577),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_where] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_from] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_join] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_let] = ACTIONS(5319),
    [anon_sym_orderby] = ACTIONS(5319),
    [anon_sym_group] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_select] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3578] = {
    [sym_preproc_region] = STATE(3578),
    [sym_preproc_endregion] = STATE(3578),
    [sym_preproc_line] = STATE(3578),
    [sym_preproc_pragma] = STATE(3578),
    [sym_preproc_nullable] = STATE(3578),
    [sym_preproc_error] = STATE(3578),
    [sym_preproc_define] = STATE(3578),
    [sym_preproc_undef] = STATE(3578),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_where] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(4086),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_from] = ACTIONS(4086),
    [anon_sym_into] = ACTIONS(4086),
    [anon_sym_join] = ACTIONS(4086),
    [anon_sym_on] = ACTIONS(4086),
    [anon_sym_equals] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_orderby] = ACTIONS(4086),
    [anon_sym_group] = ACTIONS(4086),
    [anon_sym_by] = ACTIONS(4086),
    [anon_sym_select] = ACTIONS(4086),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_is] = ACTIONS(4086),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3579] = {
    [sym_preproc_region] = STATE(3579),
    [sym_preproc_endregion] = STATE(3579),
    [sym_preproc_line] = STATE(3579),
    [sym_preproc_pragma] = STATE(3579),
    [sym_preproc_nullable] = STATE(3579),
    [sym_preproc_error] = STATE(3579),
    [sym_preproc_define] = STATE(3579),
    [sym_preproc_undef] = STATE(3579),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4695),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_from] = ACTIONS(4695),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_join] = ACTIONS(4695),
    [anon_sym_let] = ACTIONS(4695),
    [anon_sym_orderby] = ACTIONS(4695),
    [anon_sym_ascending] = ACTIONS(4695),
    [anon_sym_descending] = ACTIONS(4695),
    [anon_sym_group] = ACTIONS(4695),
    [anon_sym_select] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4697),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3580] = {
    [sym_preproc_region] = STATE(3580),
    [sym_preproc_endregion] = STATE(3580),
    [sym_preproc_line] = STATE(3580),
    [sym_preproc_pragma] = STATE(3580),
    [sym_preproc_nullable] = STATE(3580),
    [sym_preproc_error] = STATE(3580),
    [sym_preproc_define] = STATE(3580),
    [sym_preproc_undef] = STATE(3580),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_where] = ACTIONS(4650),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4652),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_from] = ACTIONS(4650),
    [anon_sym_into] = ACTIONS(4650),
    [anon_sym_join] = ACTIONS(4650),
    [anon_sym_let] = ACTIONS(4650),
    [anon_sym_orderby] = ACTIONS(4650),
    [anon_sym_ascending] = ACTIONS(4650),
    [anon_sym_descending] = ACTIONS(4650),
    [anon_sym_group] = ACTIONS(4650),
    [anon_sym_select] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4652),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3581] = {
    [sym_preproc_region] = STATE(3581),
    [sym_preproc_endregion] = STATE(3581),
    [sym_preproc_line] = STATE(3581),
    [sym_preproc_pragma] = STATE(3581),
    [sym_preproc_nullable] = STATE(3581),
    [sym_preproc_error] = STATE(3581),
    [sym_preproc_define] = STATE(3581),
    [sym_preproc_undef] = STATE(3581),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4801),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_where] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(4804),
    [anon_sym_BANG] = ACTIONS(4804),
    [anon_sym_PLUS_PLUS] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4801),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(4804),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_CARET] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_GT_GT_GT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4801),
    [anon_sym_BANG_EQ] = ACTIONS(4801),
    [anon_sym_GT_EQ] = ACTIONS(4801),
    [anon_sym_LT_EQ] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_switch] = ACTIONS(4801),
    [anon_sym_DOT_DOT] = ACTIONS(4801),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4807),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE] = ACTIONS(4801),
    [anon_sym_QMARK_QMARK] = ACTIONS(4804),
    [anon_sym_from] = ACTIONS(4799),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_join] = ACTIONS(4799),
    [anon_sym_let] = ACTIONS(4799),
    [anon_sym_orderby] = ACTIONS(4799),
    [anon_sym_ascending] = ACTIONS(4799),
    [anon_sym_descending] = ACTIONS(4799),
    [anon_sym_group] = ACTIONS(4799),
    [anon_sym_select] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(4804),
    [anon_sym_is] = ACTIONS(4801),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3582] = {
    [sym_preproc_region] = STATE(3582),
    [sym_preproc_endregion] = STATE(3582),
    [sym_preproc_line] = STATE(3582),
    [sym_preproc_pragma] = STATE(3582),
    [sym_preproc_nullable] = STATE(3582),
    [sym_preproc_error] = STATE(3582),
    [sym_preproc_define] = STATE(3582),
    [sym_preproc_undef] = STATE(3582),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_where] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4171),
    [anon_sym_or] = ACTIONS(4173),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_from] = ACTIONS(4171),
    [anon_sym_into] = ACTIONS(4171),
    [anon_sym_join] = ACTIONS(4171),
    [anon_sym_let] = ACTIONS(4171),
    [anon_sym_orderby] = ACTIONS(4171),
    [anon_sym_ascending] = ACTIONS(4171),
    [anon_sym_descending] = ACTIONS(4171),
    [anon_sym_group] = ACTIONS(4171),
    [anon_sym_select] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4173),
    [anon_sym_is] = ACTIONS(4171),
    [anon_sym_DASH_GT] = ACTIONS(4171),
    [anon_sym_with] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3583] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7003),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9074),
    [sym_identifier] = STATE(6694),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3583),
    [sym_preproc_endregion] = STATE(3583),
    [sym_preproc_line] = STATE(3583),
    [sym_preproc_pragma] = STATE(3583),
    [sym_preproc_nullable] = STATE(3583),
    [sym_preproc_error] = STATE(3583),
    [sym_preproc_define] = STATE(3583),
    [sym_preproc_undef] = STATE(3583),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4209),
    [aux_sym_lambda_expression_repeat1] = STATE(4181),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5300),
    [anon_sym_params] = ACTIONS(5302),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3584] = {
    [sym_argument_list] = STATE(3689),
    [sym_bracketed_argument_list] = STATE(3016),
    [sym_preproc_region] = STATE(3584),
    [sym_preproc_endregion] = STATE(3584),
    [sym_preproc_line] = STATE(3584),
    [sym_preproc_pragma] = STATE(3584),
    [sym_preproc_nullable] = STATE(3584),
    [sym_preproc_error] = STATE(3584),
    [sym_preproc_define] = STATE(3584),
    [sym_preproc_undef] = STATE(3584),
    [anon_sym_SEMI] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5284),
    [anon_sym_COLON] = ACTIONS(5323),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5265),
    [anon_sym_RPAREN] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_in] = ACTIONS(5325),
    [anon_sym_where] = ACTIONS(5323),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_BANG] = ACTIONS(5288),
    [anon_sym_PLUS_PLUS] = ACTIONS(5290),
    [anon_sym_DASH_DASH] = ACTIONS(5290),
    [anon_sym_PLUS] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5323),
    [anon_sym_SLASH] = ACTIONS(5325),
    [anon_sym_PERCENT] = ACTIONS(5323),
    [anon_sym_CARET] = ACTIONS(5323),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5323),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_GT_GT_GT] = ACTIONS(5323),
    [anon_sym_EQ_EQ] = ACTIONS(5323),
    [anon_sym_BANG_EQ] = ACTIONS(5323),
    [anon_sym_GT_EQ] = ACTIONS(5323),
    [anon_sym_LT_EQ] = ACTIONS(5323),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_EQ_GT] = ACTIONS(5323),
    [anon_sym_switch] = ACTIONS(5323),
    [anon_sym_DOT_DOT] = ACTIONS(5323),
    [anon_sym_and] = ACTIONS(5323),
    [anon_sym_or] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5323),
    [anon_sym_QMARK_QMARK] = ACTIONS(5323),
    [anon_sym_from] = ACTIONS(5323),
    [anon_sym_into] = ACTIONS(5323),
    [anon_sym_join] = ACTIONS(5323),
    [anon_sym_on] = ACTIONS(5323),
    [anon_sym_equals] = ACTIONS(5323),
    [anon_sym_let] = ACTIONS(5323),
    [anon_sym_orderby] = ACTIONS(5323),
    [anon_sym_group] = ACTIONS(5323),
    [anon_sym_by] = ACTIONS(5323),
    [anon_sym_select] = ACTIONS(5323),
    [anon_sym_as] = ACTIONS(5323),
    [anon_sym_is] = ACTIONS(5323),
    [anon_sym_DASH_GT] = ACTIONS(5245),
    [anon_sym_with] = ACTIONS(5323),
    [aux_sym_preproc_if_token3] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3585] = {
    [sym_preproc_region] = STATE(3585),
    [sym_preproc_endregion] = STATE(3585),
    [sym_preproc_line] = STATE(3585),
    [sym_preproc_pragma] = STATE(3585),
    [sym_preproc_nullable] = STATE(3585),
    [sym_preproc_error] = STATE(3585),
    [sym_preproc_define] = STATE(3585),
    [sym_preproc_undef] = STATE(3585),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4132),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_from] = ACTIONS(4132),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_join] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_let] = ACTIONS(4132),
    [anon_sym_orderby] = ACTIONS(4132),
    [anon_sym_group] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_select] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3586] = {
    [sym_initializer_expression] = STATE(3763),
    [sym_preproc_region] = STATE(3586),
    [sym_preproc_endregion] = STATE(3586),
    [sym_preproc_line] = STATE(3586),
    [sym_preproc_pragma] = STATE(3586),
    [sym_preproc_nullable] = STATE(3586),
    [sym_preproc_error] = STATE(3586),
    [sym_preproc_define] = STATE(3586),
    [sym_preproc_undef] = STATE(3586),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RBRACK] = ACTIONS(5331),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5334),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5337),
    [anon_sym_GT] = ACTIONS(5337),
    [anon_sym_in] = ACTIONS(5331),
    [anon_sym_where] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(5340),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_PLUS_PLUS] = ACTIONS(5331),
    [anon_sym_DASH_DASH] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_STAR] = ACTIONS(5331),
    [anon_sym_SLASH] = ACTIONS(5337),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_CARET] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5337),
    [anon_sym_AMP] = ACTIONS(5337),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5337),
    [anon_sym_GT_GT_GT] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_BANG_EQ] = ACTIONS(5331),
    [anon_sym_GT_EQ] = ACTIONS(5331),
    [anon_sym_LT_EQ] = ACTIONS(5331),
    [anon_sym_DOT] = ACTIONS(5337),
    [anon_sym_EQ_GT] = ACTIONS(5331),
    [anon_sym_switch] = ACTIONS(5331),
    [anon_sym_DOT_DOT] = ACTIONS(5331),
    [anon_sym_and] = ACTIONS(5331),
    [anon_sym_or] = ACTIONS(5337),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_from] = ACTIONS(5331),
    [anon_sym_join] = ACTIONS(5331),
    [anon_sym_on] = ACTIONS(5331),
    [anon_sym_equals] = ACTIONS(5331),
    [anon_sym_let] = ACTIONS(5331),
    [anon_sym_orderby] = ACTIONS(5331),
    [anon_sym_group] = ACTIONS(5331),
    [anon_sym_by] = ACTIONS(5331),
    [anon_sym_select] = ACTIONS(5331),
    [anon_sym_as] = ACTIONS(5331),
    [anon_sym_is] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [anon_sym_with] = ACTIONS(5331),
    [aux_sym_preproc_if_token3] = ACTIONS(5331),
    [aux_sym_preproc_else_token1] = ACTIONS(5331),
    [aux_sym_preproc_elif_token1] = ACTIONS(5331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3587] = {
    [sym_preproc_region] = STATE(3587),
    [sym_preproc_endregion] = STATE(3587),
    [sym_preproc_line] = STATE(3587),
    [sym_preproc_pragma] = STATE(3587),
    [sym_preproc_nullable] = STATE(3587),
    [sym_preproc_error] = STATE(3587),
    [sym_preproc_define] = STATE(3587),
    [sym_preproc_undef] = STATE(3587),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_RBRACK] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_in] = ACTIONS(4498),
    [anon_sym_where] = ACTIONS(4500),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_switch] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4500),
    [anon_sym_or] = ACTIONS(4498),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_from] = ACTIONS(4500),
    [anon_sym_into] = ACTIONS(4500),
    [anon_sym_join] = ACTIONS(4500),
    [anon_sym_on] = ACTIONS(4500),
    [anon_sym_equals] = ACTIONS(4500),
    [anon_sym_let] = ACTIONS(4500),
    [anon_sym_orderby] = ACTIONS(4500),
    [anon_sym_group] = ACTIONS(4500),
    [anon_sym_by] = ACTIONS(4500),
    [anon_sym_select] = ACTIONS(4500),
    [anon_sym_as] = ACTIONS(4500),
    [anon_sym_is] = ACTIONS(4500),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4500),
    [aux_sym_preproc_if_token3] = ACTIONS(4500),
    [aux_sym_preproc_else_token1] = ACTIONS(4500),
    [aux_sym_preproc_elif_token1] = ACTIONS(4500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3588] = {
    [sym_preproc_region] = STATE(3588),
    [sym_preproc_endregion] = STATE(3588),
    [sym_preproc_line] = STATE(3588),
    [sym_preproc_pragma] = STATE(3588),
    [sym_preproc_nullable] = STATE(3588),
    [sym_preproc_error] = STATE(3588),
    [sym_preproc_define] = STATE(3588),
    [sym_preproc_undef] = STATE(3588),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3589] = {
    [sym_initializer_expression] = STATE(3749),
    [sym_preproc_region] = STATE(3589),
    [sym_preproc_endregion] = STATE(3589),
    [sym_preproc_line] = STATE(3589),
    [sym_preproc_pragma] = STATE(3589),
    [sym_preproc_nullable] = STATE(3589),
    [sym_preproc_error] = STATE(3589),
    [sym_preproc_define] = STATE(3589),
    [sym_preproc_undef] = STATE(3589),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5319),
    [anon_sym_where] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_from] = ACTIONS(5319),
    [anon_sym_join] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_let] = ACTIONS(5319),
    [anon_sym_orderby] = ACTIONS(5319),
    [anon_sym_group] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_select] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3590] = {
    [sym_preproc_region] = STATE(3590),
    [sym_preproc_endregion] = STATE(3590),
    [sym_preproc_line] = STATE(3590),
    [sym_preproc_pragma] = STATE(3590),
    [sym_preproc_nullable] = STATE(3590),
    [sym_preproc_error] = STATE(3590),
    [sym_preproc_define] = STATE(3590),
    [sym_preproc_undef] = STATE(3590),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4122),
    [anon_sym_where] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4120),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_from] = ACTIONS(4122),
    [anon_sym_join] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_orderby] = ACTIONS(4122),
    [anon_sym_group] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_select] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3591] = {
    [sym_preproc_region] = STATE(3591),
    [sym_preproc_endregion] = STATE(3591),
    [sym_preproc_line] = STATE(3591),
    [sym_preproc_pragma] = STATE(3591),
    [sym_preproc_nullable] = STATE(3591),
    [sym_preproc_error] = STATE(3591),
    [sym_preproc_define] = STATE(3591),
    [sym_preproc_undef] = STATE(3591),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3592] = {
    [sym_preproc_region] = STATE(3592),
    [sym_preproc_endregion] = STATE(3592),
    [sym_preproc_line] = STATE(3592),
    [sym_preproc_pragma] = STATE(3592),
    [sym_preproc_nullable] = STATE(3592),
    [sym_preproc_error] = STATE(3592),
    [sym_preproc_define] = STATE(3592),
    [sym_preproc_undef] = STATE(3592),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_RBRACK] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_in] = ACTIONS(4622),
    [anon_sym_where] = ACTIONS(4624),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_EQ_GT] = ACTIONS(4624),
    [anon_sym_switch] = ACTIONS(4624),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4624),
    [anon_sym_or] = ACTIONS(4622),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_from] = ACTIONS(4624),
    [anon_sym_into] = ACTIONS(4624),
    [anon_sym_join] = ACTIONS(4624),
    [anon_sym_on] = ACTIONS(4624),
    [anon_sym_equals] = ACTIONS(4624),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_orderby] = ACTIONS(4624),
    [anon_sym_group] = ACTIONS(4624),
    [anon_sym_by] = ACTIONS(4624),
    [anon_sym_select] = ACTIONS(4624),
    [anon_sym_as] = ACTIONS(4624),
    [anon_sym_is] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4624),
    [aux_sym_preproc_if_token3] = ACTIONS(4624),
    [aux_sym_preproc_else_token1] = ACTIONS(4624),
    [aux_sym_preproc_elif_token1] = ACTIONS(4624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3593] = {
    [sym_preproc_region] = STATE(3593),
    [sym_preproc_endregion] = STATE(3593),
    [sym_preproc_line] = STATE(3593),
    [sym_preproc_pragma] = STATE(3593),
    [sym_preproc_nullable] = STATE(3593),
    [sym_preproc_error] = STATE(3593),
    [sym_preproc_define] = STATE(3593),
    [sym_preproc_undef] = STATE(3593),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_in] = ACTIONS(4577),
    [anon_sym_where] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_EQ_GT] = ACTIONS(4579),
    [anon_sym_switch] = ACTIONS(4579),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4579),
    [anon_sym_or] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_from] = ACTIONS(4579),
    [anon_sym_into] = ACTIONS(4579),
    [anon_sym_join] = ACTIONS(4579),
    [anon_sym_on] = ACTIONS(4579),
    [anon_sym_equals] = ACTIONS(4579),
    [anon_sym_let] = ACTIONS(4579),
    [anon_sym_orderby] = ACTIONS(4579),
    [anon_sym_group] = ACTIONS(4579),
    [anon_sym_by] = ACTIONS(4579),
    [anon_sym_select] = ACTIONS(4579),
    [anon_sym_as] = ACTIONS(4579),
    [anon_sym_is] = ACTIONS(4579),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4579),
    [aux_sym_preproc_if_token3] = ACTIONS(4579),
    [aux_sym_preproc_else_token1] = ACTIONS(4579),
    [aux_sym_preproc_elif_token1] = ACTIONS(4579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3594] = {
    [sym_preproc_region] = STATE(3594),
    [sym_preproc_endregion] = STATE(3594),
    [sym_preproc_line] = STATE(3594),
    [sym_preproc_pragma] = STATE(3594),
    [sym_preproc_nullable] = STATE(3594),
    [sym_preproc_error] = STATE(3594),
    [sym_preproc_define] = STATE(3594),
    [sym_preproc_undef] = STATE(3594),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_from] = ACTIONS(3991),
    [anon_sym_join] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_let] = ACTIONS(3991),
    [anon_sym_orderby] = ACTIONS(3991),
    [anon_sym_group] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_select] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3595] = {
    [sym_preproc_region] = STATE(3595),
    [sym_preproc_endregion] = STATE(3595),
    [sym_preproc_line] = STATE(3595),
    [sym_preproc_pragma] = STATE(3595),
    [sym_preproc_nullable] = STATE(3595),
    [sym_preproc_error] = STATE(3595),
    [sym_preproc_define] = STATE(3595),
    [sym_preproc_undef] = STATE(3595),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4620),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_switch] = ACTIONS(4620),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4620),
    [anon_sym_or] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_from] = ACTIONS(4620),
    [anon_sym_into] = ACTIONS(4620),
    [anon_sym_join] = ACTIONS(4620),
    [anon_sym_on] = ACTIONS(4620),
    [anon_sym_equals] = ACTIONS(4620),
    [anon_sym_let] = ACTIONS(4620),
    [anon_sym_orderby] = ACTIONS(4620),
    [anon_sym_group] = ACTIONS(4620),
    [anon_sym_by] = ACTIONS(4620),
    [anon_sym_select] = ACTIONS(4620),
    [anon_sym_as] = ACTIONS(4620),
    [anon_sym_is] = ACTIONS(4620),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4620),
    [aux_sym_preproc_if_token3] = ACTIONS(4620),
    [aux_sym_preproc_else_token1] = ACTIONS(4620),
    [aux_sym_preproc_elif_token1] = ACTIONS(4620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3596] = {
    [sym_preproc_region] = STATE(3596),
    [sym_preproc_endregion] = STATE(3596),
    [sym_preproc_line] = STATE(3596),
    [sym_preproc_pragma] = STATE(3596),
    [sym_preproc_nullable] = STATE(3596),
    [sym_preproc_error] = STATE(3596),
    [sym_preproc_define] = STATE(3596),
    [sym_preproc_undef] = STATE(3596),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4136),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_from] = ACTIONS(4136),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_join] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_let] = ACTIONS(4136),
    [anon_sym_orderby] = ACTIONS(4136),
    [anon_sym_group] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_select] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3597] = {
    [sym_preproc_region] = STATE(3597),
    [sym_preproc_endregion] = STATE(3597),
    [sym_preproc_line] = STATE(3597),
    [sym_preproc_pragma] = STATE(3597),
    [sym_preproc_nullable] = STATE(3597),
    [sym_preproc_error] = STATE(3597),
    [sym_preproc_define] = STATE(3597),
    [sym_preproc_undef] = STATE(3597),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_where] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4178),
    [anon_sym_into] = ACTIONS(4178),
    [anon_sym_join] = ACTIONS(4178),
    [anon_sym_on] = ACTIONS(4178),
    [anon_sym_equals] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_orderby] = ACTIONS(4178),
    [anon_sym_group] = ACTIONS(4178),
    [anon_sym_by] = ACTIONS(4178),
    [anon_sym_select] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4178),
    [anon_sym_is] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4178),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3598] = {
    [sym_preproc_region] = STATE(3598),
    [sym_preproc_endregion] = STATE(3598),
    [sym_preproc_line] = STATE(3598),
    [sym_preproc_pragma] = STATE(3598),
    [sym_preproc_nullable] = STATE(3598),
    [sym_preproc_error] = STATE(3598),
    [sym_preproc_define] = STATE(3598),
    [sym_preproc_undef] = STATE(3598),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_in] = ACTIONS(4602),
    [anon_sym_where] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4602),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_from] = ACTIONS(4604),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_join] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_orderby] = ACTIONS(4604),
    [anon_sym_group] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_select] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3599] = {
    [sym_preproc_region] = STATE(3599),
    [sym_preproc_endregion] = STATE(3599),
    [sym_preproc_line] = STATE(3599),
    [sym_preproc_pragma] = STATE(3599),
    [sym_preproc_nullable] = STATE(3599),
    [sym_preproc_error] = STATE(3599),
    [sym_preproc_define] = STATE(3599),
    [sym_preproc_undef] = STATE(3599),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_RBRACK] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_in] = ACTIONS(4471),
    [anon_sym_where] = ACTIONS(4473),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4473),
    [anon_sym_switch] = ACTIONS(4473),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4473),
    [anon_sym_or] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_from] = ACTIONS(4473),
    [anon_sym_into] = ACTIONS(4473),
    [anon_sym_join] = ACTIONS(4473),
    [anon_sym_on] = ACTIONS(4473),
    [anon_sym_equals] = ACTIONS(4473),
    [anon_sym_let] = ACTIONS(4473),
    [anon_sym_orderby] = ACTIONS(4473),
    [anon_sym_group] = ACTIONS(4473),
    [anon_sym_by] = ACTIONS(4473),
    [anon_sym_select] = ACTIONS(4473),
    [anon_sym_as] = ACTIONS(4473),
    [anon_sym_is] = ACTIONS(4473),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4473),
    [aux_sym_preproc_if_token3] = ACTIONS(4473),
    [aux_sym_preproc_else_token1] = ACTIONS(4473),
    [aux_sym_preproc_elif_token1] = ACTIONS(4473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3600] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7285),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_identifier] = STATE(6768),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3600),
    [sym_preproc_endregion] = STATE(3600),
    [sym_preproc_line] = STATE(3600),
    [sym_preproc_pragma] = STATE(3600),
    [sym_preproc_nullable] = STATE(3600),
    [sym_preproc_error] = STATE(3600),
    [sym_preproc_define] = STATE(3600),
    [sym_preproc_undef] = STATE(3600),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3601] = {
    [sym_preproc_region] = STATE(3601),
    [sym_preproc_endregion] = STATE(3601),
    [sym_preproc_line] = STATE(3601),
    [sym_preproc_pragma] = STATE(3601),
    [sym_preproc_nullable] = STATE(3601),
    [sym_preproc_error] = STATE(3601),
    [sym_preproc_define] = STATE(3601),
    [sym_preproc_undef] = STATE(3601),
    [anon_sym_SEMI] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_RBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(4465),
    [anon_sym_where] = ACTIONS(4467),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4467),
    [anon_sym_switch] = ACTIONS(4467),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4467),
    [anon_sym_or] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_from] = ACTIONS(4467),
    [anon_sym_into] = ACTIONS(4467),
    [anon_sym_join] = ACTIONS(4467),
    [anon_sym_on] = ACTIONS(4467),
    [anon_sym_equals] = ACTIONS(4467),
    [anon_sym_let] = ACTIONS(4467),
    [anon_sym_orderby] = ACTIONS(4467),
    [anon_sym_group] = ACTIONS(4467),
    [anon_sym_by] = ACTIONS(4467),
    [anon_sym_select] = ACTIONS(4467),
    [anon_sym_as] = ACTIONS(4467),
    [anon_sym_is] = ACTIONS(4467),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4467),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3602] = {
    [sym_preproc_region] = STATE(3602),
    [sym_preproc_endregion] = STATE(3602),
    [sym_preproc_line] = STATE(3602),
    [sym_preproc_pragma] = STATE(3602),
    [sym_preproc_nullable] = STATE(3602),
    [sym_preproc_error] = STATE(3602),
    [sym_preproc_define] = STATE(3602),
    [sym_preproc_undef] = STATE(3602),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4086),
    [anon_sym_where] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(4086),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4089),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_from] = ACTIONS(4086),
    [anon_sym_join] = ACTIONS(4086),
    [anon_sym_on] = ACTIONS(4086),
    [anon_sym_equals] = ACTIONS(4086),
    [anon_sym_let] = ACTIONS(4086),
    [anon_sym_orderby] = ACTIONS(4086),
    [anon_sym_group] = ACTIONS(4086),
    [anon_sym_by] = ACTIONS(4086),
    [anon_sym_select] = ACTIONS(4086),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_is] = ACTIONS(4086),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3603] = {
    [sym_type_argument_list] = STATE(3728),
    [sym_preproc_region] = STATE(3603),
    [sym_preproc_endregion] = STATE(3603),
    [sym_preproc_line] = STATE(3603),
    [sym_preproc_pragma] = STATE(3603),
    [sym_preproc_nullable] = STATE(3603),
    [sym_preproc_error] = STATE(3603),
    [sym_preproc_define] = STATE(3603),
    [sym_preproc_undef] = STATE(3603),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(5349),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3604] = {
    [sym_preproc_region] = STATE(3604),
    [sym_preproc_endregion] = STATE(3604),
    [sym_preproc_line] = STATE(3604),
    [sym_preproc_pragma] = STATE(3604),
    [sym_preproc_nullable] = STATE(3604),
    [sym_preproc_error] = STATE(3604),
    [sym_preproc_define] = STATE(3604),
    [sym_preproc_undef] = STATE(3604),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RBRACK] = ACTIONS(5351),
    [anon_sym_LPAREN] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5353),
    [anon_sym_GT] = ACTIONS(5353),
    [anon_sym_in] = ACTIONS(5353),
    [anon_sym_where] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_BANG] = ACTIONS(5353),
    [anon_sym_PLUS_PLUS] = ACTIONS(5351),
    [anon_sym_DASH_DASH] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5353),
    [anon_sym_DASH] = ACTIONS(5353),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5353),
    [anon_sym_PERCENT] = ACTIONS(5351),
    [anon_sym_CARET] = ACTIONS(5351),
    [anon_sym_PIPE] = ACTIONS(5353),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_LT_LT] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5353),
    [anon_sym_GT_GT_GT] = ACTIONS(5351),
    [anon_sym_EQ_EQ] = ACTIONS(5351),
    [anon_sym_BANG_EQ] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5353),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_switch] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5351),
    [anon_sym_and] = ACTIONS(5351),
    [anon_sym_or] = ACTIONS(5353),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_from] = ACTIONS(5351),
    [anon_sym_into] = ACTIONS(5351),
    [anon_sym_join] = ACTIONS(5351),
    [anon_sym_on] = ACTIONS(5351),
    [anon_sym_equals] = ACTIONS(5351),
    [anon_sym_let] = ACTIONS(5351),
    [anon_sym_orderby] = ACTIONS(5351),
    [anon_sym_group] = ACTIONS(5351),
    [anon_sym_by] = ACTIONS(5351),
    [anon_sym_select] = ACTIONS(5351),
    [anon_sym_as] = ACTIONS(5351),
    [anon_sym_is] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_with] = ACTIONS(5351),
    [sym_string_literal_encoding] = ACTIONS(5355),
    [aux_sym_preproc_if_token3] = ACTIONS(5351),
    [aux_sym_preproc_else_token1] = ACTIONS(5351),
    [aux_sym_preproc_elif_token1] = ACTIONS(5351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3605] = {
    [sym_initializer_expression] = STATE(3742),
    [sym_preproc_region] = STATE(3605),
    [sym_preproc_endregion] = STATE(3605),
    [sym_preproc_line] = STATE(3605),
    [sym_preproc_pragma] = STATE(3605),
    [sym_preproc_nullable] = STATE(3605),
    [sym_preproc_error] = STATE(3605),
    [sym_preproc_define] = STATE(3605),
    [sym_preproc_undef] = STATE(3605),
    [anon_sym_SEMI] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5304),
    [anon_sym_RBRACK] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(5304),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_in] = ACTIONS(5304),
    [anon_sym_where] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5309),
    [anon_sym_BANG] = ACTIONS(5309),
    [anon_sym_PLUS_PLUS] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_GT_GT_GT] = ACTIONS(5304),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_GT_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5304),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_EQ_GT] = ACTIONS(5304),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_DOT_DOT] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5304),
    [anon_sym_PIPE_PIPE] = ACTIONS(5304),
    [anon_sym_QMARK_QMARK] = ACTIONS(5304),
    [anon_sym_from] = ACTIONS(5304),
    [anon_sym_join] = ACTIONS(5304),
    [anon_sym_on] = ACTIONS(5304),
    [anon_sym_equals] = ACTIONS(5304),
    [anon_sym_let] = ACTIONS(5304),
    [anon_sym_orderby] = ACTIONS(5304),
    [anon_sym_group] = ACTIONS(5304),
    [anon_sym_by] = ACTIONS(5304),
    [anon_sym_select] = ACTIONS(5304),
    [anon_sym_as] = ACTIONS(5304),
    [anon_sym_is] = ACTIONS(5304),
    [anon_sym_DASH_GT] = ACTIONS(5304),
    [anon_sym_with] = ACTIONS(5304),
    [aux_sym_preproc_if_token3] = ACTIONS(5304),
    [aux_sym_preproc_else_token1] = ACTIONS(5304),
    [aux_sym_preproc_elif_token1] = ACTIONS(5304),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3606] = {
    [sym_attribute_list] = STATE(3778),
    [sym_preproc_region] = STATE(3606),
    [sym_preproc_endregion] = STATE(3606),
    [sym_preproc_line] = STATE(3606),
    [sym_preproc_pragma] = STATE(3606),
    [sym_preproc_nullable] = STATE(3606),
    [sym_preproc_error] = STATE(3606),
    [sym_preproc_define] = STATE(3606),
    [sym_preproc_undef] = STATE(3606),
    [aux_sym_class_declaration_repeat1] = STATE(3606),
    [sym__identifier_token] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym_alias] = ACTIONS(5357),
    [anon_sym_global] = ACTIONS(5357),
    [anon_sym_unsafe] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5359),
    [anon_sym_LPAREN] = ACTIONS(5362),
    [anon_sym_event] = ACTIONS(5357),
    [anon_sym_class] = ACTIONS(5357),
    [anon_sym_ref] = ACTIONS(5357),
    [anon_sym_struct] = ACTIONS(5357),
    [anon_sym_enum] = ACTIONS(5357),
    [anon_sym_interface] = ACTIONS(5357),
    [anon_sym_delegate] = ACTIONS(5357),
    [anon_sym_record] = ACTIONS(5357),
    [anon_sym_abstract] = ACTIONS(5357),
    [anon_sym_async] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_file] = ACTIONS(5357),
    [anon_sym_fixed] = ACTIONS(5357),
    [anon_sym_internal] = ACTIONS(5357),
    [anon_sym_new] = ACTIONS(5357),
    [anon_sym_override] = ACTIONS(5357),
    [anon_sym_partial] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_readonly] = ACTIONS(5357),
    [anon_sym_required] = ACTIONS(5357),
    [anon_sym_sealed] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_where] = ACTIONS(5357),
    [anon_sym_notnull] = ACTIONS(5357),
    [anon_sym_unmanaged] = ACTIONS(5357),
    [anon_sym_TILDE] = ACTIONS(5362),
    [anon_sym_implicit] = ACTIONS(5357),
    [anon_sym_explicit] = ACTIONS(5357),
    [anon_sym_scoped] = ACTIONS(5357),
    [anon_sym_var] = ACTIONS(5357),
    [sym_predefined_type] = ACTIONS(5357),
    [anon_sym_yield] = ACTIONS(5357),
    [anon_sym_when] = ACTIONS(5357),
    [anon_sym_from] = ACTIONS(5357),
    [anon_sym_into] = ACTIONS(5357),
    [anon_sym_join] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_orderby] = ACTIONS(5357),
    [anon_sym_ascending] = ACTIONS(5357),
    [anon_sym_descending] = ACTIONS(5357),
    [anon_sym_group] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_select] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3607] = {
    [sym_preproc_region] = STATE(3607),
    [sym_preproc_endregion] = STATE(3607),
    [sym_preproc_line] = STATE(3607),
    [sym_preproc_pragma] = STATE(3607),
    [sym_preproc_nullable] = STATE(3607),
    [sym_preproc_error] = STATE(3607),
    [sym_preproc_define] = STATE(3607),
    [sym_preproc_undef] = STATE(3607),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_where] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_EQ_GT] = ACTIONS(4536),
    [anon_sym_switch] = ACTIONS(4536),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_from] = ACTIONS(4536),
    [anon_sym_into] = ACTIONS(4536),
    [anon_sym_join] = ACTIONS(4536),
    [anon_sym_on] = ACTIONS(4536),
    [anon_sym_equals] = ACTIONS(4536),
    [anon_sym_let] = ACTIONS(4536),
    [anon_sym_orderby] = ACTIONS(4536),
    [anon_sym_group] = ACTIONS(4536),
    [anon_sym_by] = ACTIONS(4536),
    [anon_sym_select] = ACTIONS(4536),
    [anon_sym_as] = ACTIONS(4536),
    [anon_sym_is] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4536),
    [aux_sym_preproc_if_token3] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3608] = {
    [sym_preproc_region] = STATE(3608),
    [sym_preproc_endregion] = STATE(3608),
    [sym_preproc_line] = STATE(3608),
    [sym_preproc_pragma] = STATE(3608),
    [sym_preproc_nullable] = STATE(3608),
    [sym_preproc_error] = STATE(3608),
    [sym_preproc_define] = STATE(3608),
    [sym_preproc_undef] = STATE(3608),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_from] = ACTIONS(4128),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_join] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_let] = ACTIONS(4128),
    [anon_sym_orderby] = ACTIONS(4128),
    [anon_sym_group] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_select] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3609] = {
    [sym_preproc_region] = STATE(3609),
    [sym_preproc_endregion] = STATE(3609),
    [sym_preproc_line] = STATE(3609),
    [sym_preproc_pragma] = STATE(3609),
    [sym_preproc_nullable] = STATE(3609),
    [sym_preproc_error] = STATE(3609),
    [sym_preproc_define] = STATE(3609),
    [sym_preproc_undef] = STATE(3609),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_LPAREN] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_in] = ACTIONS(5366),
    [anon_sym_where] = ACTIONS(5364),
    [anon_sym_QMARK] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5364),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5366),
    [anon_sym_GT_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_EQ] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5366),
    [anon_sym_EQ_GT] = ACTIONS(5364),
    [anon_sym_switch] = ACTIONS(5364),
    [anon_sym_DOT_DOT] = ACTIONS(5364),
    [anon_sym_and] = ACTIONS(5364),
    [anon_sym_or] = ACTIONS(5366),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_QMARK_QMARK] = ACTIONS(5364),
    [anon_sym_from] = ACTIONS(5364),
    [anon_sym_into] = ACTIONS(5364),
    [anon_sym_join] = ACTIONS(5364),
    [anon_sym_on] = ACTIONS(5364),
    [anon_sym_equals] = ACTIONS(5364),
    [anon_sym_let] = ACTIONS(5364),
    [anon_sym_orderby] = ACTIONS(5364),
    [anon_sym_group] = ACTIONS(5364),
    [anon_sym_by] = ACTIONS(5364),
    [anon_sym_select] = ACTIONS(5364),
    [anon_sym_as] = ACTIONS(5364),
    [anon_sym_is] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [anon_sym_with] = ACTIONS(5364),
    [aux_sym_raw_string_literal_token1] = ACTIONS(5368),
    [aux_sym_preproc_if_token3] = ACTIONS(5364),
    [aux_sym_preproc_else_token1] = ACTIONS(5364),
    [aux_sym_preproc_elif_token1] = ACTIONS(5364),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3610] = {
    [sym_preproc_region] = STATE(3610),
    [sym_preproc_endregion] = STATE(3610),
    [sym_preproc_line] = STATE(3610),
    [sym_preproc_pragma] = STATE(3610),
    [sym_preproc_nullable] = STATE(3610),
    [sym_preproc_error] = STATE(3610),
    [sym_preproc_define] = STATE(3610),
    [sym_preproc_undef] = STATE(3610),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COMMA] = ACTIONS(5370),
    [anon_sym_RBRACK] = ACTIONS(5370),
    [anon_sym_LPAREN] = ACTIONS(5370),
    [anon_sym_RPAREN] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5370),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5372),
    [anon_sym_in] = ACTIONS(5372),
    [anon_sym_where] = ACTIONS(5370),
    [anon_sym_QMARK] = ACTIONS(5372),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5370),
    [anon_sym_DASH_DASH] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5370),
    [anon_sym_SLASH] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_LT_LT] = ACTIONS(5370),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_GT_GT_GT] = ACTIONS(5370),
    [anon_sym_EQ_EQ] = ACTIONS(5370),
    [anon_sym_BANG_EQ] = ACTIONS(5370),
    [anon_sym_GT_EQ] = ACTIONS(5370),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(5372),
    [anon_sym_EQ_GT] = ACTIONS(5370),
    [anon_sym_switch] = ACTIONS(5370),
    [anon_sym_DOT_DOT] = ACTIONS(5370),
    [anon_sym_and] = ACTIONS(5370),
    [anon_sym_or] = ACTIONS(5372),
    [anon_sym_AMP_AMP] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE] = ACTIONS(5370),
    [anon_sym_QMARK_QMARK] = ACTIONS(5370),
    [anon_sym_from] = ACTIONS(5370),
    [anon_sym_into] = ACTIONS(5370),
    [anon_sym_join] = ACTIONS(5370),
    [anon_sym_on] = ACTIONS(5370),
    [anon_sym_equals] = ACTIONS(5370),
    [anon_sym_let] = ACTIONS(5370),
    [anon_sym_orderby] = ACTIONS(5370),
    [anon_sym_group] = ACTIONS(5370),
    [anon_sym_by] = ACTIONS(5370),
    [anon_sym_select] = ACTIONS(5370),
    [anon_sym_as] = ACTIONS(5370),
    [anon_sym_is] = ACTIONS(5370),
    [anon_sym_DASH_GT] = ACTIONS(5370),
    [anon_sym_with] = ACTIONS(5370),
    [aux_sym_preproc_if_token3] = ACTIONS(5370),
    [aux_sym_preproc_else_token1] = ACTIONS(5370),
    [aux_sym_preproc_elif_token1] = ACTIONS(5370),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3611] = {
    [sym_preproc_region] = STATE(3611),
    [sym_preproc_endregion] = STATE(3611),
    [sym_preproc_line] = STATE(3611),
    [sym_preproc_pragma] = STATE(3611),
    [sym_preproc_nullable] = STATE(3611),
    [sym_preproc_error] = STATE(3611),
    [sym_preproc_define] = STATE(3611),
    [sym_preproc_undef] = STATE(3611),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_RBRACK] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_EQ_GT] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4496),
    [aux_sym_preproc_else_token1] = ACTIONS(4496),
    [aux_sym_preproc_elif_token1] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3612] = {
    [sym_type_argument_list] = STATE(3728),
    [sym_preproc_region] = STATE(3612),
    [sym_preproc_endregion] = STATE(3612),
    [sym_preproc_line] = STATE(3612),
    [sym_preproc_pragma] = STATE(3612),
    [sym_preproc_nullable] = STATE(3612),
    [sym_preproc_error] = STATE(3612),
    [sym_preproc_define] = STATE(3612),
    [sym_preproc_undef] = STATE(3612),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3613] = {
    [sym_preproc_region] = STATE(3613),
    [sym_preproc_endregion] = STATE(3613),
    [sym_preproc_line] = STATE(3613),
    [sym_preproc_pragma] = STATE(3613),
    [sym_preproc_nullable] = STATE(3613),
    [sym_preproc_error] = STATE(3613),
    [sym_preproc_define] = STATE(3613),
    [sym_preproc_undef] = STATE(3613),
    [anon_sym_EQ] = ACTIONS(5374),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5376),
    [anon_sym_DASH_EQ] = ACTIONS(5376),
    [anon_sym_STAR_EQ] = ACTIONS(5376),
    [anon_sym_SLASH_EQ] = ACTIONS(5376),
    [anon_sym_PERCENT_EQ] = ACTIONS(5376),
    [anon_sym_AMP_EQ] = ACTIONS(5376),
    [anon_sym_CARET_EQ] = ACTIONS(5376),
    [anon_sym_PIPE_EQ] = ACTIONS(5376),
    [anon_sym_LT_LT_EQ] = ACTIONS(5376),
    [anon_sym_GT_GT_EQ] = ACTIONS(5376),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5376),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5376),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_ascending] = ACTIONS(5294),
    [anon_sym_descending] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5296),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3614] = {
    [sym_preproc_region] = STATE(3614),
    [sym_preproc_endregion] = STATE(3614),
    [sym_preproc_line] = STATE(3614),
    [sym_preproc_pragma] = STATE(3614),
    [sym_preproc_nullable] = STATE(3614),
    [sym_preproc_error] = STATE(3614),
    [sym_preproc_define] = STATE(3614),
    [sym_preproc_undef] = STATE(3614),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4429),
    [anon_sym_where] = ACTIONS(4431),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_switch] = ACTIONS(4431),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4431),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4431),
    [anon_sym_into] = ACTIONS(4431),
    [anon_sym_join] = ACTIONS(4431),
    [anon_sym_on] = ACTIONS(4431),
    [anon_sym_equals] = ACTIONS(4431),
    [anon_sym_let] = ACTIONS(4431),
    [anon_sym_orderby] = ACTIONS(4431),
    [anon_sym_group] = ACTIONS(4431),
    [anon_sym_by] = ACTIONS(4431),
    [anon_sym_select] = ACTIONS(4431),
    [anon_sym_as] = ACTIONS(4431),
    [anon_sym_is] = ACTIONS(4431),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4431),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3615] = {
    [sym_preproc_region] = STATE(3615),
    [sym_preproc_endregion] = STATE(3615),
    [sym_preproc_line] = STATE(3615),
    [sym_preproc_pragma] = STATE(3615),
    [sym_preproc_nullable] = STATE(3615),
    [sym_preproc_error] = STATE(3615),
    [sym_preproc_define] = STATE(3615),
    [sym_preproc_undef] = STATE(3615),
    [anon_sym_SEMI] = ACTIONS(4457),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_RBRACK] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4457),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_in] = ACTIONS(4455),
    [anon_sym_where] = ACTIONS(4457),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_EQ_GT] = ACTIONS(4457),
    [anon_sym_switch] = ACTIONS(4457),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4457),
    [anon_sym_or] = ACTIONS(4455),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_from] = ACTIONS(4457),
    [anon_sym_into] = ACTIONS(4457),
    [anon_sym_join] = ACTIONS(4457),
    [anon_sym_on] = ACTIONS(4457),
    [anon_sym_equals] = ACTIONS(4457),
    [anon_sym_let] = ACTIONS(4457),
    [anon_sym_orderby] = ACTIONS(4457),
    [anon_sym_group] = ACTIONS(4457),
    [anon_sym_by] = ACTIONS(4457),
    [anon_sym_select] = ACTIONS(4457),
    [anon_sym_as] = ACTIONS(4457),
    [anon_sym_is] = ACTIONS(4457),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4457),
    [aux_sym_preproc_if_token3] = ACTIONS(4457),
    [aux_sym_preproc_else_token1] = ACTIONS(4457),
    [aux_sym_preproc_elif_token1] = ACTIONS(4457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3616] = {
    [sym_preproc_region] = STATE(3616),
    [sym_preproc_endregion] = STATE(3616),
    [sym_preproc_line] = STATE(3616),
    [sym_preproc_pragma] = STATE(3616),
    [sym_preproc_nullable] = STATE(3616),
    [sym_preproc_error] = STATE(3616),
    [sym_preproc_define] = STATE(3616),
    [sym_preproc_undef] = STATE(3616),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_RBRACK] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4608),
    [anon_sym_where] = ACTIONS(4610),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_EQ_GT] = ACTIONS(4610),
    [anon_sym_switch] = ACTIONS(4610),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4610),
    [anon_sym_or] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_from] = ACTIONS(4610),
    [anon_sym_into] = ACTIONS(4610),
    [anon_sym_join] = ACTIONS(4610),
    [anon_sym_on] = ACTIONS(4610),
    [anon_sym_equals] = ACTIONS(4610),
    [anon_sym_let] = ACTIONS(4610),
    [anon_sym_orderby] = ACTIONS(4610),
    [anon_sym_group] = ACTIONS(4610),
    [anon_sym_by] = ACTIONS(4610),
    [anon_sym_select] = ACTIONS(4610),
    [anon_sym_as] = ACTIONS(4610),
    [anon_sym_is] = ACTIONS(4610),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4610),
    [aux_sym_preproc_if_token3] = ACTIONS(4610),
    [aux_sym_preproc_else_token1] = ACTIONS(4610),
    [aux_sym_preproc_elif_token1] = ACTIONS(4610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3617] = {
    [sym_preproc_region] = STATE(3617),
    [sym_preproc_endregion] = STATE(3617),
    [sym_preproc_line] = STATE(3617),
    [sym_preproc_pragma] = STATE(3617),
    [sym_preproc_nullable] = STATE(3617),
    [sym_preproc_error] = STATE(3617),
    [sym_preproc_define] = STATE(3617),
    [sym_preproc_undef] = STATE(3617),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_COLON] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_RPAREN] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_in] = ACTIONS(5380),
    [anon_sym_where] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5380),
    [anon_sym_BANG] = ACTIONS(5380),
    [anon_sym_PLUS_PLUS] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5378),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5378),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5378),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_GT_GT_GT] = ACTIONS(5378),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_EQ_GT] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_DOT_DOT] = ACTIONS(5378),
    [anon_sym_and] = ACTIONS(5378),
    [anon_sym_or] = ACTIONS(5380),
    [anon_sym_AMP_AMP] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE] = ACTIONS(5378),
    [anon_sym_QMARK_QMARK] = ACTIONS(5378),
    [anon_sym_from] = ACTIONS(5378),
    [anon_sym_into] = ACTIONS(5378),
    [anon_sym_join] = ACTIONS(5378),
    [anon_sym_on] = ACTIONS(5378),
    [anon_sym_equals] = ACTIONS(5378),
    [anon_sym_let] = ACTIONS(5378),
    [anon_sym_orderby] = ACTIONS(5378),
    [anon_sym_group] = ACTIONS(5378),
    [anon_sym_by] = ACTIONS(5378),
    [anon_sym_select] = ACTIONS(5378),
    [anon_sym_as] = ACTIONS(5378),
    [anon_sym_is] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_with] = ACTIONS(5378),
    [aux_sym_preproc_if_token3] = ACTIONS(5378),
    [aux_sym_preproc_else_token1] = ACTIONS(5378),
    [aux_sym_preproc_elif_token1] = ACTIONS(5378),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3618] = {
    [sym_preproc_region] = STATE(3618),
    [sym_preproc_endregion] = STATE(3618),
    [sym_preproc_line] = STATE(3618),
    [sym_preproc_pragma] = STATE(3618),
    [sym_preproc_nullable] = STATE(3618),
    [sym_preproc_error] = STATE(3618),
    [sym_preproc_define] = STATE(3618),
    [sym_preproc_undef] = STATE(3618),
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_RBRACK] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_where] = ACTIONS(4490),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_EQ_GT] = ACTIONS(4490),
    [anon_sym_switch] = ACTIONS(4490),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4490),
    [anon_sym_or] = ACTIONS(4488),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_from] = ACTIONS(4490),
    [anon_sym_into] = ACTIONS(4490),
    [anon_sym_join] = ACTIONS(4490),
    [anon_sym_on] = ACTIONS(4490),
    [anon_sym_equals] = ACTIONS(4490),
    [anon_sym_let] = ACTIONS(4490),
    [anon_sym_orderby] = ACTIONS(4490),
    [anon_sym_group] = ACTIONS(4490),
    [anon_sym_by] = ACTIONS(4490),
    [anon_sym_select] = ACTIONS(4490),
    [anon_sym_as] = ACTIONS(4490),
    [anon_sym_is] = ACTIONS(4490),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4490),
    [aux_sym_preproc_if_token3] = ACTIONS(4490),
    [aux_sym_preproc_else_token1] = ACTIONS(4490),
    [aux_sym_preproc_elif_token1] = ACTIONS(4490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3619] = {
    [sym_preproc_region] = STATE(3619),
    [sym_preproc_endregion] = STATE(3619),
    [sym_preproc_line] = STATE(3619),
    [sym_preproc_pragma] = STATE(3619),
    [sym_preproc_nullable] = STATE(3619),
    [sym_preproc_error] = STATE(3619),
    [sym_preproc_define] = STATE(3619),
    [sym_preproc_undef] = STATE(3619),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_RBRACK] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_in] = ACTIONS(4484),
    [anon_sym_where] = ACTIONS(4486),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_EQ_GT] = ACTIONS(4486),
    [anon_sym_switch] = ACTIONS(4486),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4484),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_from] = ACTIONS(4486),
    [anon_sym_into] = ACTIONS(4486),
    [anon_sym_join] = ACTIONS(4486),
    [anon_sym_on] = ACTIONS(4486),
    [anon_sym_equals] = ACTIONS(4486),
    [anon_sym_let] = ACTIONS(4486),
    [anon_sym_orderby] = ACTIONS(4486),
    [anon_sym_group] = ACTIONS(4486),
    [anon_sym_by] = ACTIONS(4486),
    [anon_sym_select] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(4486),
    [anon_sym_is] = ACTIONS(4486),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4486),
    [aux_sym_preproc_if_token3] = ACTIONS(4486),
    [aux_sym_preproc_else_token1] = ACTIONS(4486),
    [aux_sym_preproc_elif_token1] = ACTIONS(4486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3620] = {
    [sym_preproc_region] = STATE(3620),
    [sym_preproc_endregion] = STATE(3620),
    [sym_preproc_line] = STATE(3620),
    [sym_preproc_pragma] = STATE(3620),
    [sym_preproc_nullable] = STATE(3620),
    [sym_preproc_error] = STATE(3620),
    [sym_preproc_define] = STATE(3620),
    [sym_preproc_undef] = STATE(3620),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_where] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4482),
    [anon_sym_into] = ACTIONS(4482),
    [anon_sym_join] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_let] = ACTIONS(4482),
    [anon_sym_orderby] = ACTIONS(4482),
    [anon_sym_group] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_select] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3621] = {
    [sym_preproc_region] = STATE(3621),
    [sym_preproc_endregion] = STATE(3621),
    [sym_preproc_line] = STATE(3621),
    [sym_preproc_pragma] = STATE(3621),
    [sym_preproc_nullable] = STATE(3621),
    [sym_preproc_error] = STATE(3621),
    [sym_preproc_define] = STATE(3621),
    [sym_preproc_undef] = STATE(3621),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5384),
    [anon_sym_where] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_from] = ACTIONS(5382),
    [anon_sym_into] = ACTIONS(5382),
    [anon_sym_join] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_let] = ACTIONS(5382),
    [anon_sym_orderby] = ACTIONS(5382),
    [anon_sym_group] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_select] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [sym_string_literal_encoding] = ACTIONS(5386),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3622] = {
    [sym_preproc_region] = STATE(3622),
    [sym_preproc_endregion] = STATE(3622),
    [sym_preproc_line] = STATE(3622),
    [sym_preproc_pragma] = STATE(3622),
    [sym_preproc_nullable] = STATE(3622),
    [sym_preproc_error] = STATE(3622),
    [sym_preproc_define] = STATE(3622),
    [sym_preproc_undef] = STATE(3622),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3623] = {
    [sym_initializer_expression] = STATE(3744),
    [sym_preproc_region] = STATE(3623),
    [sym_preproc_endregion] = STATE(3623),
    [sym_preproc_line] = STATE(3623),
    [sym_preproc_pragma] = STATE(3623),
    [sym_preproc_nullable] = STATE(3623),
    [sym_preproc_error] = STATE(3623),
    [sym_preproc_define] = STATE(3623),
    [sym_preproc_undef] = STATE(3623),
    [anon_sym_SEMI] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [anon_sym_LPAREN] = ACTIONS(5315),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_in] = ACTIONS(5315),
    [anon_sym_where] = ACTIONS(5315),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_PIPE] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5317),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_GT_GT_GT] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5315),
    [anon_sym_BANG_EQ] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5315),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_DOT] = ACTIONS(5317),
    [anon_sym_EQ_GT] = ACTIONS(5315),
    [anon_sym_switch] = ACTIONS(5315),
    [anon_sym_DOT_DOT] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_or] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5315),
    [anon_sym_QMARK_QMARK] = ACTIONS(5315),
    [anon_sym_from] = ACTIONS(5315),
    [anon_sym_join] = ACTIONS(5315),
    [anon_sym_on] = ACTIONS(5315),
    [anon_sym_equals] = ACTIONS(5315),
    [anon_sym_let] = ACTIONS(5315),
    [anon_sym_orderby] = ACTIONS(5315),
    [anon_sym_group] = ACTIONS(5315),
    [anon_sym_by] = ACTIONS(5315),
    [anon_sym_select] = ACTIONS(5315),
    [anon_sym_as] = ACTIONS(5315),
    [anon_sym_is] = ACTIONS(5315),
    [anon_sym_DASH_GT] = ACTIONS(5315),
    [anon_sym_with] = ACTIONS(5315),
    [aux_sym_preproc_if_token3] = ACTIONS(5315),
    [aux_sym_preproc_else_token1] = ACTIONS(5315),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3624] = {
    [sym_preproc_region] = STATE(3624),
    [sym_preproc_endregion] = STATE(3624),
    [sym_preproc_line] = STATE(3624),
    [sym_preproc_pragma] = STATE(3624),
    [sym_preproc_nullable] = STATE(3624),
    [sym_preproc_error] = STATE(3624),
    [sym_preproc_define] = STATE(3624),
    [sym_preproc_undef] = STATE(3624),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3625] = {
    [sym_preproc_region] = STATE(3625),
    [sym_preproc_endregion] = STATE(3625),
    [sym_preproc_line] = STATE(3625),
    [sym_preproc_pragma] = STATE(3625),
    [sym_preproc_nullable] = STATE(3625),
    [sym_preproc_error] = STATE(3625),
    [sym_preproc_define] = STATE(3625),
    [sym_preproc_undef] = STATE(3625),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3626] = {
    [sym_preproc_region] = STATE(3626),
    [sym_preproc_endregion] = STATE(3626),
    [sym_preproc_line] = STATE(3626),
    [sym_preproc_pragma] = STATE(3626),
    [sym_preproc_nullable] = STATE(3626),
    [sym_preproc_error] = STATE(3626),
    [sym_preproc_define] = STATE(3626),
    [sym_preproc_undef] = STATE(3626),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3627] = {
    [sym_preproc_region] = STATE(3627),
    [sym_preproc_endregion] = STATE(3627),
    [sym_preproc_line] = STATE(3627),
    [sym_preproc_pragma] = STATE(3627),
    [sym_preproc_nullable] = STATE(3627),
    [sym_preproc_error] = STATE(3627),
    [sym_preproc_define] = STATE(3627),
    [sym_preproc_undef] = STATE(3627),
    [anon_sym_SEMI] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5391),
    [anon_sym_COLON] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_RBRACK] = ACTIONS(5391),
    [anon_sym_LPAREN] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5393),
    [anon_sym_in] = ACTIONS(5393),
    [anon_sym_where] = ACTIONS(5391),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_SLASH] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5391),
    [anon_sym_CARET] = ACTIONS(5391),
    [anon_sym_PIPE] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5393),
    [anon_sym_LT_LT] = ACTIONS(5391),
    [anon_sym_GT_GT] = ACTIONS(5393),
    [anon_sym_GT_GT_GT] = ACTIONS(5391),
    [anon_sym_EQ_EQ] = ACTIONS(5391),
    [anon_sym_BANG_EQ] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5391),
    [anon_sym_LT_EQ] = ACTIONS(5391),
    [anon_sym_DOT] = ACTIONS(5393),
    [anon_sym_EQ_GT] = ACTIONS(5391),
    [anon_sym_switch] = ACTIONS(5391),
    [anon_sym_DOT_DOT] = ACTIONS(5391),
    [anon_sym_and] = ACTIONS(5391),
    [anon_sym_or] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5391),
    [anon_sym_PIPE_PIPE] = ACTIONS(5391),
    [anon_sym_QMARK_QMARK] = ACTIONS(5391),
    [anon_sym_from] = ACTIONS(5391),
    [anon_sym_into] = ACTIONS(5391),
    [anon_sym_join] = ACTIONS(5391),
    [anon_sym_on] = ACTIONS(5391),
    [anon_sym_equals] = ACTIONS(5391),
    [anon_sym_let] = ACTIONS(5391),
    [anon_sym_orderby] = ACTIONS(5391),
    [anon_sym_group] = ACTIONS(5391),
    [anon_sym_by] = ACTIONS(5391),
    [anon_sym_select] = ACTIONS(5391),
    [anon_sym_as] = ACTIONS(5391),
    [anon_sym_is] = ACTIONS(5391),
    [anon_sym_DASH_GT] = ACTIONS(5391),
    [anon_sym_with] = ACTIONS(5391),
    [aux_sym_preproc_if_token3] = ACTIONS(5391),
    [aux_sym_preproc_else_token1] = ACTIONS(5391),
    [aux_sym_preproc_elif_token1] = ACTIONS(5391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3628] = {
    [sym_preproc_region] = STATE(3628),
    [sym_preproc_endregion] = STATE(3628),
    [sym_preproc_line] = STATE(3628),
    [sym_preproc_pragma] = STATE(3628),
    [sym_preproc_nullable] = STATE(3628),
    [sym_preproc_error] = STATE(3628),
    [sym_preproc_define] = STATE(3628),
    [sym_preproc_undef] = STATE(3628),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(5395),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5397),
    [anon_sym_DASH_EQ] = ACTIONS(5397),
    [anon_sym_STAR_EQ] = ACTIONS(5397),
    [anon_sym_SLASH_EQ] = ACTIONS(5397),
    [anon_sym_PERCENT_EQ] = ACTIONS(5397),
    [anon_sym_AMP_EQ] = ACTIONS(5397),
    [anon_sym_CARET_EQ] = ACTIONS(5397),
    [anon_sym_PIPE_EQ] = ACTIONS(5397),
    [anon_sym_LT_LT_EQ] = ACTIONS(5397),
    [anon_sym_GT_GT_EQ] = ACTIONS(5397),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5397),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5397),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3629] = {
    [sym_preproc_region] = STATE(3629),
    [sym_preproc_endregion] = STATE(3629),
    [sym_preproc_line] = STATE(3629),
    [sym_preproc_pragma] = STATE(3629),
    [sym_preproc_nullable] = STATE(3629),
    [sym_preproc_error] = STATE(3629),
    [sym_preproc_define] = STATE(3629),
    [sym_preproc_undef] = STATE(3629),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4155),
    [anon_sym_where] = ACTIONS(4157),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_switch] = ACTIONS(4157),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4157),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_from] = ACTIONS(4157),
    [anon_sym_into] = ACTIONS(4157),
    [anon_sym_join] = ACTIONS(4157),
    [anon_sym_on] = ACTIONS(4157),
    [anon_sym_equals] = ACTIONS(4157),
    [anon_sym_let] = ACTIONS(4157),
    [anon_sym_orderby] = ACTIONS(4157),
    [anon_sym_group] = ACTIONS(4157),
    [anon_sym_by] = ACTIONS(4157),
    [anon_sym_select] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4157),
    [anon_sym_is] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4157),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3630] = {
    [sym_preproc_region] = STATE(3630),
    [sym_preproc_endregion] = STATE(3630),
    [sym_preproc_line] = STATE(3630),
    [sym_preproc_pragma] = STATE(3630),
    [sym_preproc_nullable] = STATE(3630),
    [sym_preproc_error] = STATE(3630),
    [sym_preproc_define] = STATE(3630),
    [sym_preproc_undef] = STATE(3630),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5384),
    [anon_sym_where] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5384),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_from] = ACTIONS(5382),
    [anon_sym_into] = ACTIONS(5382),
    [anon_sym_join] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_let] = ACTIONS(5382),
    [anon_sym_orderby] = ACTIONS(5382),
    [anon_sym_group] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_select] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3631] = {
    [sym_preproc_region] = STATE(3631),
    [sym_preproc_endregion] = STATE(3631),
    [sym_preproc_line] = STATE(3631),
    [sym_preproc_pragma] = STATE(3631),
    [sym_preproc_nullable] = STATE(3631),
    [sym_preproc_error] = STATE(3631),
    [sym_preproc_define] = STATE(3631),
    [sym_preproc_undef] = STATE(3631),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COMMA] = ACTIONS(5399),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [anon_sym_RPAREN] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5401),
    [anon_sym_in] = ACTIONS(5401),
    [anon_sym_where] = ACTIONS(5399),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5401),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5401),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5401),
    [anon_sym_GT_GT_GT] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5399),
    [anon_sym_BANG_EQ] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5399),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_DOT] = ACTIONS(5401),
    [anon_sym_EQ_GT] = ACTIONS(5399),
    [anon_sym_switch] = ACTIONS(5399),
    [anon_sym_DOT_DOT] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_or] = ACTIONS(5401),
    [anon_sym_AMP_AMP] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5399),
    [anon_sym_QMARK_QMARK] = ACTIONS(5399),
    [anon_sym_from] = ACTIONS(5399),
    [anon_sym_into] = ACTIONS(5399),
    [anon_sym_join] = ACTIONS(5399),
    [anon_sym_on] = ACTIONS(5399),
    [anon_sym_equals] = ACTIONS(5399),
    [anon_sym_let] = ACTIONS(5399),
    [anon_sym_orderby] = ACTIONS(5399),
    [anon_sym_group] = ACTIONS(5399),
    [anon_sym_by] = ACTIONS(5399),
    [anon_sym_select] = ACTIONS(5399),
    [anon_sym_as] = ACTIONS(5399),
    [anon_sym_is] = ACTIONS(5399),
    [anon_sym_DASH_GT] = ACTIONS(5399),
    [anon_sym_with] = ACTIONS(5399),
    [aux_sym_preproc_if_token3] = ACTIONS(5399),
    [aux_sym_preproc_else_token1] = ACTIONS(5399),
    [aux_sym_preproc_elif_token1] = ACTIONS(5399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3632] = {
    [sym_preproc_region] = STATE(3632),
    [sym_preproc_endregion] = STATE(3632),
    [sym_preproc_line] = STATE(3632),
    [sym_preproc_pragma] = STATE(3632),
    [sym_preproc_nullable] = STATE(3632),
    [sym_preproc_error] = STATE(3632),
    [sym_preproc_define] = STATE(3632),
    [sym_preproc_undef] = STATE(3632),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5405),
    [anon_sym_where] = ACTIONS(5403),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_from] = ACTIONS(5403),
    [anon_sym_into] = ACTIONS(5403),
    [anon_sym_join] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_let] = ACTIONS(5403),
    [anon_sym_orderby] = ACTIONS(5403),
    [anon_sym_group] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_select] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3633] = {
    [sym_preproc_region] = STATE(3633),
    [sym_preproc_endregion] = STATE(3633),
    [sym_preproc_line] = STATE(3633),
    [sym_preproc_pragma] = STATE(3633),
    [sym_preproc_nullable] = STATE(3633),
    [sym_preproc_error] = STATE(3633),
    [sym_preproc_define] = STATE(3633),
    [sym_preproc_undef] = STATE(3633),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_COLON] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_where] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_EQ_GT] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_DOT_DOT] = ACTIONS(2999),
    [anon_sym_and] = ACTIONS(2999),
    [anon_sym_or] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_from] = ACTIONS(2999),
    [anon_sym_into] = ACTIONS(2999),
    [anon_sym_join] = ACTIONS(2999),
    [anon_sym_on] = ACTIONS(2999),
    [anon_sym_equals] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_orderby] = ACTIONS(2999),
    [anon_sym_group] = ACTIONS(2999),
    [anon_sym_by] = ACTIONS(2999),
    [anon_sym_select] = ACTIONS(2999),
    [anon_sym_as] = ACTIONS(2999),
    [anon_sym_is] = ACTIONS(2999),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [aux_sym_preproc_if_token3] = ACTIONS(2999),
    [aux_sym_preproc_else_token1] = ACTIONS(2999),
    [aux_sym_preproc_elif_token1] = ACTIONS(2999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3634] = {
    [sym_preproc_region] = STATE(3634),
    [sym_preproc_endregion] = STATE(3634),
    [sym_preproc_line] = STATE(3634),
    [sym_preproc_pragma] = STATE(3634),
    [sym_preproc_nullable] = STATE(3634),
    [sym_preproc_error] = STATE(3634),
    [sym_preproc_define] = STATE(3634),
    [sym_preproc_undef] = STATE(3634),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_RBRACK] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_in] = ACTIONS(4473),
    [anon_sym_where] = ACTIONS(4473),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4473),
    [anon_sym_switch] = ACTIONS(4473),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4473),
    [anon_sym_or] = ACTIONS(4471),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_from] = ACTIONS(4473),
    [anon_sym_join] = ACTIONS(4473),
    [anon_sym_on] = ACTIONS(4473),
    [anon_sym_equals] = ACTIONS(4473),
    [anon_sym_let] = ACTIONS(4473),
    [anon_sym_orderby] = ACTIONS(4473),
    [anon_sym_group] = ACTIONS(4473),
    [anon_sym_by] = ACTIONS(4473),
    [anon_sym_select] = ACTIONS(4473),
    [anon_sym_as] = ACTIONS(4473),
    [anon_sym_is] = ACTIONS(4473),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4473),
    [aux_sym_preproc_if_token3] = ACTIONS(4473),
    [aux_sym_preproc_else_token1] = ACTIONS(4473),
    [aux_sym_preproc_elif_token1] = ACTIONS(4473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3635] = {
    [sym_preproc_region] = STATE(3635),
    [sym_preproc_endregion] = STATE(3635),
    [sym_preproc_line] = STATE(3635),
    [sym_preproc_pragma] = STATE(3635),
    [sym_preproc_nullable] = STATE(3635),
    [sym_preproc_error] = STATE(3635),
    [sym_preproc_define] = STATE(3635),
    [sym_preproc_undef] = STATE(3635),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5409),
    [anon_sym_where] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_from] = ACTIONS(5407),
    [anon_sym_into] = ACTIONS(5407),
    [anon_sym_join] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_let] = ACTIONS(5407),
    [anon_sym_orderby] = ACTIONS(5407),
    [anon_sym_group] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_select] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3636] = {
    [sym_preproc_region] = STATE(3636),
    [sym_preproc_endregion] = STATE(3636),
    [sym_preproc_line] = STATE(3636),
    [sym_preproc_pragma] = STATE(3636),
    [sym_preproc_nullable] = STATE(3636),
    [sym_preproc_error] = STATE(3636),
    [sym_preproc_define] = STATE(3636),
    [sym_preproc_undef] = STATE(3636),
    [anon_sym_SEMI] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_RBRACK] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_RPAREN] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_in] = ACTIONS(5413),
    [anon_sym_where] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_from] = ACTIONS(5411),
    [anon_sym_into] = ACTIONS(5411),
    [anon_sym_join] = ACTIONS(5411),
    [anon_sym_on] = ACTIONS(5411),
    [anon_sym_equals] = ACTIONS(5411),
    [anon_sym_let] = ACTIONS(5411),
    [anon_sym_orderby] = ACTIONS(5411),
    [anon_sym_group] = ACTIONS(5411),
    [anon_sym_by] = ACTIONS(5411),
    [anon_sym_select] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5411),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_if_token3] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3637] = {
    [sym_preproc_region] = STATE(3637),
    [sym_preproc_endregion] = STATE(3637),
    [sym_preproc_line] = STATE(3637),
    [sym_preproc_pragma] = STATE(3637),
    [sym_preproc_nullable] = STATE(3637),
    [sym_preproc_error] = STATE(3637),
    [sym_preproc_define] = STATE(3637),
    [sym_preproc_undef] = STATE(3637),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3040),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_QMARK_QMARK] = ACTIONS(3042),
    [anon_sym_from] = ACTIONS(3042),
    [anon_sym_into] = ACTIONS(3042),
    [anon_sym_join] = ACTIONS(3042),
    [anon_sym_on] = ACTIONS(3042),
    [anon_sym_equals] = ACTIONS(3042),
    [anon_sym_let] = ACTIONS(3042),
    [anon_sym_orderby] = ACTIONS(3042),
    [anon_sym_group] = ACTIONS(3042),
    [anon_sym_by] = ACTIONS(3042),
    [anon_sym_select] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_DASH_GT] = ACTIONS(3042),
    [anon_sym_with] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3638] = {
    [sym_preproc_region] = STATE(3638),
    [sym_preproc_endregion] = STATE(3638),
    [sym_preproc_line] = STATE(3638),
    [sym_preproc_pragma] = STATE(3638),
    [sym_preproc_nullable] = STATE(3638),
    [sym_preproc_error] = STATE(3638),
    [sym_preproc_define] = STATE(3638),
    [sym_preproc_undef] = STATE(3638),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4136),
    [anon_sym_where] = ACTIONS(4136),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_from] = ACTIONS(4136),
    [anon_sym_join] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_let] = ACTIONS(4136),
    [anon_sym_orderby] = ACTIONS(4136),
    [anon_sym_group] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_select] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3639] = {
    [sym_preproc_region] = STATE(3639),
    [sym_preproc_endregion] = STATE(3639),
    [sym_preproc_line] = STATE(3639),
    [sym_preproc_pragma] = STATE(3639),
    [sym_preproc_nullable] = STATE(3639),
    [sym_preproc_error] = STATE(3639),
    [sym_preproc_define] = STATE(3639),
    [sym_preproc_undef] = STATE(3639),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_in] = ACTIONS(4604),
    [anon_sym_where] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4602),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_from] = ACTIONS(4604),
    [anon_sym_join] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_let] = ACTIONS(4604),
    [anon_sym_orderby] = ACTIONS(4604),
    [anon_sym_group] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_select] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3640] = {
    [sym_preproc_region] = STATE(3640),
    [sym_preproc_endregion] = STATE(3640),
    [sym_preproc_line] = STATE(3640),
    [sym_preproc_pragma] = STATE(3640),
    [sym_preproc_nullable] = STATE(3640),
    [sym_preproc_error] = STATE(3640),
    [sym_preproc_define] = STATE(3640),
    [sym_preproc_undef] = STATE(3640),
    [anon_sym_SEMI] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_COLON] = ACTIONS(5415),
    [anon_sym_COMMA] = ACTIONS(5415),
    [anon_sym_RBRACK] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_in] = ACTIONS(5417),
    [anon_sym_where] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_BANG] = ACTIONS(5417),
    [anon_sym_PLUS_PLUS] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5415),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5415),
    [anon_sym_CARET] = ACTIONS(5415),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5415),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_GT_GT_GT] = ACTIONS(5415),
    [anon_sym_EQ_EQ] = ACTIONS(5415),
    [anon_sym_BANG_EQ] = ACTIONS(5415),
    [anon_sym_GT_EQ] = ACTIONS(5415),
    [anon_sym_LT_EQ] = ACTIONS(5415),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_EQ_GT] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_DOT_DOT] = ACTIONS(5415),
    [anon_sym_and] = ACTIONS(5415),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5415),
    [anon_sym_PIPE_PIPE] = ACTIONS(5415),
    [anon_sym_QMARK_QMARK] = ACTIONS(5415),
    [anon_sym_from] = ACTIONS(5415),
    [anon_sym_into] = ACTIONS(5415),
    [anon_sym_join] = ACTIONS(5415),
    [anon_sym_on] = ACTIONS(5415),
    [anon_sym_equals] = ACTIONS(5415),
    [anon_sym_let] = ACTIONS(5415),
    [anon_sym_orderby] = ACTIONS(5415),
    [anon_sym_group] = ACTIONS(5415),
    [anon_sym_by] = ACTIONS(5415),
    [anon_sym_select] = ACTIONS(5415),
    [anon_sym_as] = ACTIONS(5415),
    [anon_sym_is] = ACTIONS(5415),
    [anon_sym_DASH_GT] = ACTIONS(5415),
    [anon_sym_with] = ACTIONS(5415),
    [aux_sym_preproc_if_token3] = ACTIONS(5415),
    [aux_sym_preproc_else_token1] = ACTIONS(5415),
    [aux_sym_preproc_elif_token1] = ACTIONS(5415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3641] = {
    [sym_preproc_region] = STATE(3641),
    [sym_preproc_endregion] = STATE(3641),
    [sym_preproc_line] = STATE(3641),
    [sym_preproc_pragma] = STATE(3641),
    [sym_preproc_nullable] = STATE(3641),
    [sym_preproc_error] = STATE(3641),
    [sym_preproc_define] = STATE(3641),
    [sym_preproc_undef] = STATE(3641),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3642] = {
    [sym_preproc_region] = STATE(3642),
    [sym_preproc_endregion] = STATE(3642),
    [sym_preproc_line] = STATE(3642),
    [sym_preproc_pragma] = STATE(3642),
    [sym_preproc_nullable] = STATE(3642),
    [sym_preproc_error] = STATE(3642),
    [sym_preproc_define] = STATE(3642),
    [sym_preproc_undef] = STATE(3642),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_in] = ACTIONS(5421),
    [anon_sym_where] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5419),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5419),
    [anon_sym_CARET] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5419),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5419),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5419),
    [anon_sym_DOT_DOT] = ACTIONS(5419),
    [anon_sym_and] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_QMARK_QMARK] = ACTIONS(5419),
    [anon_sym_from] = ACTIONS(5419),
    [anon_sym_into] = ACTIONS(5419),
    [anon_sym_join] = ACTIONS(5419),
    [anon_sym_on] = ACTIONS(5419),
    [anon_sym_equals] = ACTIONS(5419),
    [anon_sym_let] = ACTIONS(5419),
    [anon_sym_orderby] = ACTIONS(5419),
    [anon_sym_group] = ACTIONS(5419),
    [anon_sym_by] = ACTIONS(5419),
    [anon_sym_select] = ACTIONS(5419),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_with] = ACTIONS(5419),
    [aux_sym_preproc_if_token3] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3643] = {
    [sym_preproc_region] = STATE(3643),
    [sym_preproc_endregion] = STATE(3643),
    [sym_preproc_line] = STATE(3643),
    [sym_preproc_pragma] = STATE(3643),
    [sym_preproc_nullable] = STATE(3643),
    [sym_preproc_error] = STATE(3643),
    [sym_preproc_define] = STATE(3643),
    [sym_preproc_undef] = STATE(3643),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(5425),
    [anon_sym_where] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_GT_GT] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5423),
    [anon_sym_DOT_DOT] = ACTIONS(5423),
    [anon_sym_and] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_QMARK_QMARK] = ACTIONS(5423),
    [anon_sym_from] = ACTIONS(5423),
    [anon_sym_into] = ACTIONS(5423),
    [anon_sym_join] = ACTIONS(5423),
    [anon_sym_on] = ACTIONS(5423),
    [anon_sym_equals] = ACTIONS(5423),
    [anon_sym_let] = ACTIONS(5423),
    [anon_sym_orderby] = ACTIONS(5423),
    [anon_sym_group] = ACTIONS(5423),
    [anon_sym_by] = ACTIONS(5423),
    [anon_sym_select] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_is] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_with] = ACTIONS(5423),
    [aux_sym_preproc_if_token3] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3644] = {
    [sym_preproc_region] = STATE(3644),
    [sym_preproc_endregion] = STATE(3644),
    [sym_preproc_line] = STATE(3644),
    [sym_preproc_pragma] = STATE(3644),
    [sym_preproc_nullable] = STATE(3644),
    [sym_preproc_error] = STATE(3644),
    [sym_preproc_define] = STATE(3644),
    [sym_preproc_undef] = STATE(3644),
    [anon_sym_SEMI] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_RBRACK] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5427),
    [anon_sym_RPAREN] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5429),
    [anon_sym_GT] = ACTIONS(5429),
    [anon_sym_in] = ACTIONS(5429),
    [anon_sym_where] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_PLUS_PLUS] = ACTIONS(5427),
    [anon_sym_DASH_DASH] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_SLASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_CARET] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_GT_GT] = ACTIONS(5429),
    [anon_sym_GT_GT_GT] = ACTIONS(5427),
    [anon_sym_EQ_EQ] = ACTIONS(5427),
    [anon_sym_BANG_EQ] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_LT_EQ] = ACTIONS(5427),
    [anon_sym_DOT] = ACTIONS(5429),
    [anon_sym_EQ_GT] = ACTIONS(5427),
    [anon_sym_switch] = ACTIONS(5427),
    [anon_sym_DOT_DOT] = ACTIONS(5427),
    [anon_sym_and] = ACTIONS(5427),
    [anon_sym_or] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5427),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_QMARK_QMARK] = ACTIONS(5427),
    [anon_sym_from] = ACTIONS(5427),
    [anon_sym_into] = ACTIONS(5427),
    [anon_sym_join] = ACTIONS(5427),
    [anon_sym_on] = ACTIONS(5427),
    [anon_sym_equals] = ACTIONS(5427),
    [anon_sym_let] = ACTIONS(5427),
    [anon_sym_orderby] = ACTIONS(5427),
    [anon_sym_group] = ACTIONS(5427),
    [anon_sym_by] = ACTIONS(5427),
    [anon_sym_select] = ACTIONS(5427),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_is] = ACTIONS(5427),
    [anon_sym_DASH_GT] = ACTIONS(5427),
    [anon_sym_with] = ACTIONS(5427),
    [aux_sym_preproc_if_token3] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3645] = {
    [sym_preproc_region] = STATE(3645),
    [sym_preproc_endregion] = STATE(3645),
    [sym_preproc_line] = STATE(3645),
    [sym_preproc_pragma] = STATE(3645),
    [sym_preproc_nullable] = STATE(3645),
    [sym_preproc_error] = STATE(3645),
    [sym_preproc_define] = STATE(3645),
    [sym_preproc_undef] = STATE(3645),
    [anon_sym_SEMI] = ACTIONS(5431),
    [anon_sym_LBRACK] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5431),
    [anon_sym_COMMA] = ACTIONS(5431),
    [anon_sym_RBRACK] = ACTIONS(5431),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [anon_sym_RPAREN] = ACTIONS(5431),
    [anon_sym_RBRACE] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5433),
    [anon_sym_in] = ACTIONS(5433),
    [anon_sym_where] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_BANG] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5433),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5433),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_PIPE] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5433),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_GT_GT_GT] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5431),
    [anon_sym_BANG_EQ] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5431),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_DOT] = ACTIONS(5433),
    [anon_sym_EQ_GT] = ACTIONS(5431),
    [anon_sym_switch] = ACTIONS(5431),
    [anon_sym_DOT_DOT] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_or] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5431),
    [anon_sym_QMARK_QMARK] = ACTIONS(5431),
    [anon_sym_from] = ACTIONS(5431),
    [anon_sym_into] = ACTIONS(5431),
    [anon_sym_join] = ACTIONS(5431),
    [anon_sym_on] = ACTIONS(5431),
    [anon_sym_equals] = ACTIONS(5431),
    [anon_sym_let] = ACTIONS(5431),
    [anon_sym_orderby] = ACTIONS(5431),
    [anon_sym_group] = ACTIONS(5431),
    [anon_sym_by] = ACTIONS(5431),
    [anon_sym_select] = ACTIONS(5431),
    [anon_sym_as] = ACTIONS(5431),
    [anon_sym_is] = ACTIONS(5431),
    [anon_sym_DASH_GT] = ACTIONS(5431),
    [anon_sym_with] = ACTIONS(5431),
    [aux_sym_preproc_if_token3] = ACTIONS(5431),
    [aux_sym_preproc_else_token1] = ACTIONS(5431),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3646] = {
    [sym_preproc_region] = STATE(3646),
    [sym_preproc_endregion] = STATE(3646),
    [sym_preproc_line] = STATE(3646),
    [sym_preproc_pragma] = STATE(3646),
    [sym_preproc_nullable] = STATE(3646),
    [sym_preproc_error] = STATE(3646),
    [sym_preproc_define] = STATE(3646),
    [sym_preproc_undef] = STATE(3646),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_COLON] = ACTIONS(1965),
    [anon_sym_COMMA] = ACTIONS(1965),
    [anon_sym_RBRACK] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(5435),
    [anon_sym_RPAREN] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_where] = ACTIONS(1965),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(1965),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(1963),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_EQ_GT] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_DOT_DOT] = ACTIONS(1965),
    [anon_sym_and] = ACTIONS(1965),
    [anon_sym_or] = ACTIONS(1963),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_from] = ACTIONS(1965),
    [anon_sym_into] = ACTIONS(1965),
    [anon_sym_join] = ACTIONS(1965),
    [anon_sym_on] = ACTIONS(1965),
    [anon_sym_equals] = ACTIONS(1965),
    [anon_sym_let] = ACTIONS(1965),
    [anon_sym_orderby] = ACTIONS(1965),
    [anon_sym_group] = ACTIONS(1965),
    [anon_sym_by] = ACTIONS(1965),
    [anon_sym_select] = ACTIONS(1965),
    [anon_sym_as] = ACTIONS(1965),
    [anon_sym_is] = ACTIONS(1965),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_with] = ACTIONS(1965),
    [aux_sym_preproc_if_token3] = ACTIONS(1965),
    [aux_sym_preproc_else_token1] = ACTIONS(1965),
    [aux_sym_preproc_elif_token1] = ACTIONS(1965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3647] = {
    [sym_preproc_region] = STATE(3647),
    [sym_preproc_endregion] = STATE(3647),
    [sym_preproc_line] = STATE(3647),
    [sym_preproc_pragma] = STATE(3647),
    [sym_preproc_nullable] = STATE(3647),
    [sym_preproc_error] = STATE(3647),
    [sym_preproc_define] = STATE(3647),
    [sym_preproc_undef] = STATE(3647),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3648] = {
    [sym_preproc_region] = STATE(3648),
    [sym_preproc_endregion] = STATE(3648),
    [sym_preproc_line] = STATE(3648),
    [sym_preproc_pragma] = STATE(3648),
    [sym_preproc_nullable] = STATE(3648),
    [sym_preproc_error] = STATE(3648),
    [sym_preproc_define] = STATE(3648),
    [sym_preproc_undef] = STATE(3648),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3649] = {
    [sym_preproc_region] = STATE(3649),
    [sym_preproc_endregion] = STATE(3649),
    [sym_preproc_line] = STATE(3649),
    [sym_preproc_pragma] = STATE(3649),
    [sym_preproc_nullable] = STATE(3649),
    [sym_preproc_error] = STATE(3649),
    [sym_preproc_define] = STATE(3649),
    [sym_preproc_undef] = STATE(3649),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5442),
    [anon_sym_where] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_from] = ACTIONS(5440),
    [anon_sym_into] = ACTIONS(5440),
    [anon_sym_join] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_let] = ACTIONS(5440),
    [anon_sym_orderby] = ACTIONS(5440),
    [anon_sym_group] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_select] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3650] = {
    [sym_preproc_region] = STATE(3650),
    [sym_preproc_endregion] = STATE(3650),
    [sym_preproc_line] = STATE(3650),
    [sym_preproc_pragma] = STATE(3650),
    [sym_preproc_nullable] = STATE(3650),
    [sym_preproc_error] = STATE(3650),
    [sym_preproc_define] = STATE(3650),
    [sym_preproc_undef] = STATE(3650),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5446),
    [anon_sym_where] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_from] = ACTIONS(5444),
    [anon_sym_into] = ACTIONS(5444),
    [anon_sym_join] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_let] = ACTIONS(5444),
    [anon_sym_orderby] = ACTIONS(5444),
    [anon_sym_group] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_select] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3651] = {
    [sym_preproc_region] = STATE(3651),
    [sym_preproc_endregion] = STATE(3651),
    [sym_preproc_line] = STATE(3651),
    [sym_preproc_pragma] = STATE(3651),
    [sym_preproc_nullable] = STATE(3651),
    [sym_preproc_error] = STATE(3651),
    [sym_preproc_define] = STATE(3651),
    [sym_preproc_undef] = STATE(3651),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5450),
    [anon_sym_where] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_from] = ACTIONS(5448),
    [anon_sym_into] = ACTIONS(5448),
    [anon_sym_join] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_let] = ACTIONS(5448),
    [anon_sym_orderby] = ACTIONS(5448),
    [anon_sym_group] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_select] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3652] = {
    [sym_preproc_region] = STATE(3652),
    [sym_preproc_endregion] = STATE(3652),
    [sym_preproc_line] = STATE(3652),
    [sym_preproc_pragma] = STATE(3652),
    [sym_preproc_nullable] = STATE(3652),
    [sym_preproc_error] = STATE(3652),
    [sym_preproc_define] = STATE(3652),
    [sym_preproc_undef] = STATE(3652),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3653] = {
    [sym_preproc_region] = STATE(3653),
    [sym_preproc_endregion] = STATE(3653),
    [sym_preproc_line] = STATE(3653),
    [sym_preproc_pragma] = STATE(3653),
    [sym_preproc_nullable] = STATE(3653),
    [sym_preproc_error] = STATE(3653),
    [sym_preproc_define] = STATE(3653),
    [sym_preproc_undef] = STATE(3653),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_RBRACK] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_in] = ACTIONS(4624),
    [anon_sym_where] = ACTIONS(4624),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_EQ_GT] = ACTIONS(4624),
    [anon_sym_switch] = ACTIONS(4624),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4624),
    [anon_sym_or] = ACTIONS(4622),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_from] = ACTIONS(4624),
    [anon_sym_join] = ACTIONS(4624),
    [anon_sym_on] = ACTIONS(4624),
    [anon_sym_equals] = ACTIONS(4624),
    [anon_sym_let] = ACTIONS(4624),
    [anon_sym_orderby] = ACTIONS(4624),
    [anon_sym_group] = ACTIONS(4624),
    [anon_sym_by] = ACTIONS(4624),
    [anon_sym_select] = ACTIONS(4624),
    [anon_sym_as] = ACTIONS(4624),
    [anon_sym_is] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4624),
    [aux_sym_preproc_if_token3] = ACTIONS(4624),
    [aux_sym_preproc_else_token1] = ACTIONS(4624),
    [aux_sym_preproc_elif_token1] = ACTIONS(4624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3654] = {
    [sym_preproc_region] = STATE(3654),
    [sym_preproc_endregion] = STATE(3654),
    [sym_preproc_line] = STATE(3654),
    [sym_preproc_pragma] = STATE(3654),
    [sym_preproc_nullable] = STATE(3654),
    [sym_preproc_error] = STATE(3654),
    [sym_preproc_define] = STATE(3654),
    [sym_preproc_undef] = STATE(3654),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_where] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_from] = ACTIONS(5452),
    [anon_sym_into] = ACTIONS(5452),
    [anon_sym_join] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_let] = ACTIONS(5452),
    [anon_sym_orderby] = ACTIONS(5452),
    [anon_sym_group] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_select] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3655] = {
    [sym_preproc_region] = STATE(3655),
    [sym_preproc_endregion] = STATE(3655),
    [sym_preproc_line] = STATE(3655),
    [sym_preproc_pragma] = STATE(3655),
    [sym_preproc_nullable] = STATE(3655),
    [sym_preproc_error] = STATE(3655),
    [sym_preproc_define] = STATE(3655),
    [sym_preproc_undef] = STATE(3655),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3656] = {
    [sym_preproc_region] = STATE(3656),
    [sym_preproc_endregion] = STATE(3656),
    [sym_preproc_line] = STATE(3656),
    [sym_preproc_pragma] = STATE(3656),
    [sym_preproc_nullable] = STATE(3656),
    [sym_preproc_error] = STATE(3656),
    [sym_preproc_define] = STATE(3656),
    [sym_preproc_undef] = STATE(3656),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LPAREN] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_in] = ACTIONS(5458),
    [anon_sym_where] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5458),
    [anon_sym_BANG] = ACTIONS(5458),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5456),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_GT_GT_GT] = ACTIONS(5456),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_EQ_GT] = ACTIONS(5456),
    [anon_sym_switch] = ACTIONS(5456),
    [anon_sym_DOT_DOT] = ACTIONS(5456),
    [anon_sym_and] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_QMARK_QMARK] = ACTIONS(5456),
    [anon_sym_from] = ACTIONS(5456),
    [anon_sym_into] = ACTIONS(5456),
    [anon_sym_join] = ACTIONS(5456),
    [anon_sym_on] = ACTIONS(5456),
    [anon_sym_equals] = ACTIONS(5456),
    [anon_sym_let] = ACTIONS(5456),
    [anon_sym_orderby] = ACTIONS(5456),
    [anon_sym_group] = ACTIONS(5456),
    [anon_sym_by] = ACTIONS(5456),
    [anon_sym_select] = ACTIONS(5456),
    [anon_sym_as] = ACTIONS(5456),
    [anon_sym_is] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_with] = ACTIONS(5456),
    [aux_sym_preproc_if_token3] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3657] = {
    [sym_preproc_region] = STATE(3657),
    [sym_preproc_endregion] = STATE(3657),
    [sym_preproc_line] = STATE(3657),
    [sym_preproc_pragma] = STATE(3657),
    [sym_preproc_nullable] = STATE(3657),
    [sym_preproc_error] = STATE(3657),
    [sym_preproc_define] = STATE(3657),
    [sym_preproc_undef] = STATE(3657),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_in] = ACTIONS(5462),
    [anon_sym_where] = ACTIONS(5460),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_BANG] = ACTIONS(5462),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5460),
    [anon_sym_CARET] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5460),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_GT_GT_GT] = ACTIONS(5460),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_EQ_GT] = ACTIONS(5460),
    [anon_sym_switch] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5460),
    [anon_sym_and] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_QMARK_QMARK] = ACTIONS(5460),
    [anon_sym_from] = ACTIONS(5460),
    [anon_sym_into] = ACTIONS(5460),
    [anon_sym_join] = ACTIONS(5460),
    [anon_sym_on] = ACTIONS(5460),
    [anon_sym_equals] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_orderby] = ACTIONS(5460),
    [anon_sym_group] = ACTIONS(5460),
    [anon_sym_by] = ACTIONS(5460),
    [anon_sym_select] = ACTIONS(5460),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_is] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_with] = ACTIONS(5460),
    [aux_sym_preproc_if_token3] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3658] = {
    [sym_preproc_region] = STATE(3658),
    [sym_preproc_endregion] = STATE(3658),
    [sym_preproc_line] = STATE(3658),
    [sym_preproc_pragma] = STATE(3658),
    [sym_preproc_nullable] = STATE(3658),
    [sym_preproc_error] = STATE(3658),
    [sym_preproc_define] = STATE(3658),
    [sym_preproc_undef] = STATE(3658),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_in] = ACTIONS(5466),
    [anon_sym_where] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_BANG] = ACTIONS(5466),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_SLASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5464),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_GT_GT_GT] = ACTIONS(5464),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_EQ_GT] = ACTIONS(5464),
    [anon_sym_switch] = ACTIONS(5464),
    [anon_sym_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_QMARK_QMARK] = ACTIONS(5464),
    [anon_sym_from] = ACTIONS(5464),
    [anon_sym_into] = ACTIONS(5464),
    [anon_sym_join] = ACTIONS(5464),
    [anon_sym_on] = ACTIONS(5464),
    [anon_sym_equals] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_orderby] = ACTIONS(5464),
    [anon_sym_group] = ACTIONS(5464),
    [anon_sym_by] = ACTIONS(5464),
    [anon_sym_select] = ACTIONS(5464),
    [anon_sym_as] = ACTIONS(5464),
    [anon_sym_is] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_with] = ACTIONS(5464),
    [aux_sym_preproc_if_token3] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3659] = {
    [sym_preproc_region] = STATE(3659),
    [sym_preproc_endregion] = STATE(3659),
    [sym_preproc_line] = STATE(3659),
    [sym_preproc_pragma] = STATE(3659),
    [sym_preproc_nullable] = STATE(3659),
    [sym_preproc_error] = STATE(3659),
    [sym_preproc_define] = STATE(3659),
    [sym_preproc_undef] = STATE(3659),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_COLON] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_RBRACK] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_RPAREN] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_in] = ACTIONS(5470),
    [anon_sym_where] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5470),
    [anon_sym_BANG] = ACTIONS(5470),
    [anon_sym_PLUS_PLUS] = ACTIONS(5468),
    [anon_sym_DASH_DASH] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5468),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_GT_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_EQ_GT] = ACTIONS(5468),
    [anon_sym_switch] = ACTIONS(5468),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE] = ACTIONS(5468),
    [anon_sym_QMARK_QMARK] = ACTIONS(5468),
    [anon_sym_from] = ACTIONS(5468),
    [anon_sym_into] = ACTIONS(5468),
    [anon_sym_join] = ACTIONS(5468),
    [anon_sym_on] = ACTIONS(5468),
    [anon_sym_equals] = ACTIONS(5468),
    [anon_sym_let] = ACTIONS(5468),
    [anon_sym_orderby] = ACTIONS(5468),
    [anon_sym_group] = ACTIONS(5468),
    [anon_sym_by] = ACTIONS(5468),
    [anon_sym_select] = ACTIONS(5468),
    [anon_sym_as] = ACTIONS(5468),
    [anon_sym_is] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_with] = ACTIONS(5468),
    [aux_sym_preproc_if_token3] = ACTIONS(5468),
    [aux_sym_preproc_else_token1] = ACTIONS(5468),
    [aux_sym_preproc_elif_token1] = ACTIONS(5468),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3660] = {
    [sym_preproc_region] = STATE(3660),
    [sym_preproc_endregion] = STATE(3660),
    [sym_preproc_line] = STATE(3660),
    [sym_preproc_pragma] = STATE(3660),
    [sym_preproc_nullable] = STATE(3660),
    [sym_preproc_error] = STATE(3660),
    [sym_preproc_define] = STATE(3660),
    [sym_preproc_undef] = STATE(3660),
    [anon_sym_SEMI] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_RBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(4467),
    [anon_sym_where] = ACTIONS(4467),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4467),
    [anon_sym_switch] = ACTIONS(4467),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4467),
    [anon_sym_or] = ACTIONS(4465),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_from] = ACTIONS(4467),
    [anon_sym_join] = ACTIONS(4467),
    [anon_sym_on] = ACTIONS(4467),
    [anon_sym_equals] = ACTIONS(4467),
    [anon_sym_let] = ACTIONS(4467),
    [anon_sym_orderby] = ACTIONS(4467),
    [anon_sym_group] = ACTIONS(4467),
    [anon_sym_by] = ACTIONS(4467),
    [anon_sym_select] = ACTIONS(4467),
    [anon_sym_as] = ACTIONS(4467),
    [anon_sym_is] = ACTIONS(4467),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4467),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3661] = {
    [sym_preproc_region] = STATE(3661),
    [sym_preproc_endregion] = STATE(3661),
    [sym_preproc_line] = STATE(3661),
    [sym_preproc_pragma] = STATE(3661),
    [sym_preproc_nullable] = STATE(3661),
    [sym_preproc_error] = STATE(3661),
    [sym_preproc_define] = STATE(3661),
    [sym_preproc_undef] = STATE(3661),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_in] = ACTIONS(4178),
    [anon_sym_where] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4169),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_from] = ACTIONS(4178),
    [anon_sym_join] = ACTIONS(4178),
    [anon_sym_on] = ACTIONS(4178),
    [anon_sym_equals] = ACTIONS(4178),
    [anon_sym_let] = ACTIONS(4178),
    [anon_sym_orderby] = ACTIONS(4178),
    [anon_sym_group] = ACTIONS(4178),
    [anon_sym_by] = ACTIONS(4178),
    [anon_sym_select] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4178),
    [anon_sym_is] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4178),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3662] = {
    [sym_preproc_region] = STATE(3662),
    [sym_preproc_endregion] = STATE(3662),
    [sym_preproc_line] = STATE(3662),
    [sym_preproc_pragma] = STATE(3662),
    [sym_preproc_nullable] = STATE(3662),
    [sym_preproc_error] = STATE(3662),
    [sym_preproc_define] = STATE(3662),
    [sym_preproc_undef] = STATE(3662),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_where] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5472),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_GT_GT_GT] = ACTIONS(5472),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_EQ_GT] = ACTIONS(5472),
    [anon_sym_switch] = ACTIONS(5472),
    [anon_sym_DOT_DOT] = ACTIONS(5472),
    [anon_sym_and] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_QMARK_QMARK] = ACTIONS(5472),
    [anon_sym_from] = ACTIONS(5472),
    [anon_sym_into] = ACTIONS(5472),
    [anon_sym_join] = ACTIONS(5472),
    [anon_sym_on] = ACTIONS(5472),
    [anon_sym_equals] = ACTIONS(5472),
    [anon_sym_let] = ACTIONS(5472),
    [anon_sym_orderby] = ACTIONS(5472),
    [anon_sym_group] = ACTIONS(5472),
    [anon_sym_by] = ACTIONS(5472),
    [anon_sym_select] = ACTIONS(5472),
    [anon_sym_as] = ACTIONS(5472),
    [anon_sym_is] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_with] = ACTIONS(5472),
    [aux_sym_preproc_if_token3] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5472),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3663] = {
    [sym_preproc_region] = STATE(3663),
    [sym_preproc_endregion] = STATE(3663),
    [sym_preproc_line] = STATE(3663),
    [sym_preproc_pragma] = STATE(3663),
    [sym_preproc_nullable] = STATE(3663),
    [sym_preproc_error] = STATE(3663),
    [sym_preproc_define] = STATE(3663),
    [sym_preproc_undef] = STATE(3663),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym_LBRACK] = ACTIONS(5476),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_RBRACK] = ACTIONS(5476),
    [anon_sym_LPAREN] = ACTIONS(5476),
    [anon_sym_RPAREN] = ACTIONS(5476),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_where] = ACTIONS(5476),
    [anon_sym_QMARK] = ACTIONS(5478),
    [anon_sym_BANG] = ACTIONS(5478),
    [anon_sym_PLUS_PLUS] = ACTIONS(5476),
    [anon_sym_DASH_DASH] = ACTIONS(5476),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_CARET] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5476),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_GT_GT_GT] = ACTIONS(5476),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5476),
    [anon_sym_GT_EQ] = ACTIONS(5476),
    [anon_sym_LT_EQ] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_EQ_GT] = ACTIONS(5476),
    [anon_sym_switch] = ACTIONS(5476),
    [anon_sym_DOT_DOT] = ACTIONS(5476),
    [anon_sym_and] = ACTIONS(5476),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_PIPE_PIPE] = ACTIONS(5476),
    [anon_sym_QMARK_QMARK] = ACTIONS(5476),
    [anon_sym_from] = ACTIONS(5476),
    [anon_sym_into] = ACTIONS(5476),
    [anon_sym_join] = ACTIONS(5476),
    [anon_sym_on] = ACTIONS(5476),
    [anon_sym_equals] = ACTIONS(5476),
    [anon_sym_let] = ACTIONS(5476),
    [anon_sym_orderby] = ACTIONS(5476),
    [anon_sym_group] = ACTIONS(5476),
    [anon_sym_by] = ACTIONS(5476),
    [anon_sym_select] = ACTIONS(5476),
    [anon_sym_as] = ACTIONS(5476),
    [anon_sym_is] = ACTIONS(5476),
    [anon_sym_DASH_GT] = ACTIONS(5476),
    [anon_sym_with] = ACTIONS(5476),
    [aux_sym_preproc_if_token3] = ACTIONS(5476),
    [aux_sym_preproc_else_token1] = ACTIONS(5476),
    [aux_sym_preproc_elif_token1] = ACTIONS(5476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3664] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter] = STATE(8586),
    [sym__parameter_array] = STATE(8604),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6748),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3664),
    [sym_preproc_endregion] = STATE(3664),
    [sym_preproc_line] = STATE(3664),
    [sym_preproc_pragma] = STATE(3664),
    [sym_preproc_nullable] = STATE(3664),
    [sym_preproc_error] = STATE(3664),
    [sym_preproc_define] = STATE(3664),
    [sym_preproc_undef] = STATE(3664),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_RBRACK] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3665] = {
    [sym_preproc_region] = STATE(3665),
    [sym_preproc_endregion] = STATE(3665),
    [sym_preproc_line] = STATE(3665),
    [sym_preproc_pragma] = STATE(3665),
    [sym_preproc_nullable] = STATE(3665),
    [sym_preproc_error] = STATE(3665),
    [sym_preproc_define] = STATE(3665),
    [sym_preproc_undef] = STATE(3665),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4536),
    [anon_sym_where] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_EQ_GT] = ACTIONS(4536),
    [anon_sym_switch] = ACTIONS(4536),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_from] = ACTIONS(4536),
    [anon_sym_join] = ACTIONS(4536),
    [anon_sym_on] = ACTIONS(4536),
    [anon_sym_equals] = ACTIONS(4536),
    [anon_sym_let] = ACTIONS(4536),
    [anon_sym_orderby] = ACTIONS(4536),
    [anon_sym_group] = ACTIONS(4536),
    [anon_sym_by] = ACTIONS(4536),
    [anon_sym_select] = ACTIONS(4536),
    [anon_sym_as] = ACTIONS(4536),
    [anon_sym_is] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4536),
    [aux_sym_preproc_if_token3] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3666] = {
    [sym_preproc_region] = STATE(3666),
    [sym_preproc_endregion] = STATE(3666),
    [sym_preproc_line] = STATE(3666),
    [sym_preproc_pragma] = STATE(3666),
    [sym_preproc_nullable] = STATE(3666),
    [sym_preproc_error] = STATE(3666),
    [sym_preproc_define] = STATE(3666),
    [sym_preproc_undef] = STATE(3666),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5484),
    [anon_sym_where] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_from] = ACTIONS(5482),
    [anon_sym_into] = ACTIONS(5482),
    [anon_sym_join] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_let] = ACTIONS(5482),
    [anon_sym_orderby] = ACTIONS(5482),
    [anon_sym_group] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_select] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3667] = {
    [sym_preproc_region] = STATE(3667),
    [sym_preproc_endregion] = STATE(3667),
    [sym_preproc_line] = STATE(3667),
    [sym_preproc_pragma] = STATE(3667),
    [sym_preproc_nullable] = STATE(3667),
    [sym_preproc_error] = STATE(3667),
    [sym_preproc_define] = STATE(3667),
    [sym_preproc_undef] = STATE(3667),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_where] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_from] = ACTIONS(5486),
    [anon_sym_into] = ACTIONS(5486),
    [anon_sym_join] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_let] = ACTIONS(5486),
    [anon_sym_orderby] = ACTIONS(5486),
    [anon_sym_group] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_select] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3668] = {
    [sym_attribute_list] = STATE(4403),
    [sym_modifier] = STATE(4531),
    [sym_accessor_declaration] = STATE(4347),
    [sym_identifier] = STATE(7902),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3668),
    [sym_preproc_endregion] = STATE(3668),
    [sym_preproc_line] = STATE(3668),
    [sym_preproc_pragma] = STATE(3668),
    [sym_preproc_nullable] = STATE(3668),
    [sym_preproc_error] = STATE(3668),
    [sym_preproc_define] = STATE(3668),
    [sym_preproc_undef] = STATE(3668),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_class_declaration_repeat2] = STATE(3961),
    [aux_sym_accessor_list_repeat1] = STATE(3694),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_abstract] = ACTIONS(5490),
    [anon_sym_async] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_file] = ACTIONS(5496),
    [anon_sym_fixed] = ACTIONS(5490),
    [anon_sym_internal] = ACTIONS(5490),
    [anon_sym_new] = ACTIONS(5490),
    [anon_sym_override] = ACTIONS(5490),
    [anon_sym_partial] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_readonly] = ACTIONS(5490),
    [anon_sym_required] = ACTIONS(5490),
    [anon_sym_sealed] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5498),
    [anon_sym_set] = ACTIONS(5498),
    [anon_sym_add] = ACTIONS(5498),
    [anon_sym_remove] = ACTIONS(5498),
    [anon_sym_init] = ACTIONS(5498),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3669] = {
    [sym_preproc_region] = STATE(3669),
    [sym_preproc_endregion] = STATE(3669),
    [sym_preproc_line] = STATE(3669),
    [sym_preproc_pragma] = STATE(3669),
    [sym_preproc_nullable] = STATE(3669),
    [sym_preproc_error] = STATE(3669),
    [sym_preproc_define] = STATE(3669),
    [sym_preproc_undef] = STATE(3669),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_in] = ACTIONS(5502),
    [anon_sym_where] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_BANG] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_EQ_GT] = ACTIONS(5500),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_from] = ACTIONS(5500),
    [anon_sym_into] = ACTIONS(5500),
    [anon_sym_join] = ACTIONS(5500),
    [anon_sym_on] = ACTIONS(5500),
    [anon_sym_equals] = ACTIONS(5500),
    [anon_sym_let] = ACTIONS(5500),
    [anon_sym_orderby] = ACTIONS(5500),
    [anon_sym_group] = ACTIONS(5500),
    [anon_sym_by] = ACTIONS(5500),
    [anon_sym_select] = ACTIONS(5500),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3670] = {
    [sym_preproc_region] = STATE(3670),
    [sym_preproc_endregion] = STATE(3670),
    [sym_preproc_line] = STATE(3670),
    [sym_preproc_pragma] = STATE(3670),
    [sym_preproc_nullable] = STATE(3670),
    [sym_preproc_error] = STATE(3670),
    [sym_preproc_define] = STATE(3670),
    [sym_preproc_undef] = STATE(3670),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4157),
    [anon_sym_where] = ACTIONS(4157),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_switch] = ACTIONS(4157),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4157),
    [anon_sym_or] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_from] = ACTIONS(4157),
    [anon_sym_join] = ACTIONS(4157),
    [anon_sym_on] = ACTIONS(4157),
    [anon_sym_equals] = ACTIONS(4157),
    [anon_sym_let] = ACTIONS(4157),
    [anon_sym_orderby] = ACTIONS(4157),
    [anon_sym_group] = ACTIONS(4157),
    [anon_sym_by] = ACTIONS(4157),
    [anon_sym_select] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4157),
    [anon_sym_is] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4157),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3671] = {
    [sym_preproc_region] = STATE(3671),
    [sym_preproc_endregion] = STATE(3671),
    [sym_preproc_line] = STATE(3671),
    [sym_preproc_pragma] = STATE(3671),
    [sym_preproc_nullable] = STATE(3671),
    [sym_preproc_error] = STATE(3671),
    [sym_preproc_define] = STATE(3671),
    [sym_preproc_undef] = STATE(3671),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3672] = {
    [sym_preproc_region] = STATE(3672),
    [sym_preproc_endregion] = STATE(3672),
    [sym_preproc_line] = STATE(3672),
    [sym_preproc_pragma] = STATE(3672),
    [sym_preproc_nullable] = STATE(3672),
    [sym_preproc_error] = STATE(3672),
    [sym_preproc_define] = STATE(3672),
    [sym_preproc_undef] = STATE(3672),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5508),
    [anon_sym_where] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_from] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(5506),
    [anon_sym_join] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_let] = ACTIONS(5506),
    [anon_sym_orderby] = ACTIONS(5506),
    [anon_sym_group] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_select] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3673] = {
    [sym_preproc_region] = STATE(3673),
    [sym_preproc_endregion] = STATE(3673),
    [sym_preproc_line] = STATE(3673),
    [sym_preproc_pragma] = STATE(3673),
    [sym_preproc_nullable] = STATE(3673),
    [sym_preproc_error] = STATE(3673),
    [sym_preproc_define] = STATE(3673),
    [sym_preproc_undef] = STATE(3673),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5512),
    [anon_sym_where] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_from] = ACTIONS(5510),
    [anon_sym_into] = ACTIONS(5510),
    [anon_sym_join] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_orderby] = ACTIONS(5510),
    [anon_sym_group] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_select] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3674] = {
    [sym_preproc_region] = STATE(3674),
    [sym_preproc_endregion] = STATE(3674),
    [sym_preproc_line] = STATE(3674),
    [sym_preproc_pragma] = STATE(3674),
    [sym_preproc_nullable] = STATE(3674),
    [sym_preproc_error] = STATE(3674),
    [sym_preproc_define] = STATE(3674),
    [sym_preproc_undef] = STATE(3674),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5516),
    [anon_sym_where] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_from] = ACTIONS(5514),
    [anon_sym_into] = ACTIONS(5514),
    [anon_sym_join] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_orderby] = ACTIONS(5514),
    [anon_sym_group] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_select] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3675] = {
    [sym_preproc_region] = STATE(3675),
    [sym_preproc_endregion] = STATE(3675),
    [sym_preproc_line] = STATE(3675),
    [sym_preproc_pragma] = STATE(3675),
    [sym_preproc_nullable] = STATE(3675),
    [sym_preproc_error] = STATE(3675),
    [sym_preproc_define] = STATE(3675),
    [sym_preproc_undef] = STATE(3675),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5520),
    [anon_sym_where] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_from] = ACTIONS(5518),
    [anon_sym_into] = ACTIONS(5518),
    [anon_sym_join] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_orderby] = ACTIONS(5518),
    [anon_sym_group] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_select] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3676] = {
    [sym_preproc_region] = STATE(3676),
    [sym_preproc_endregion] = STATE(3676),
    [sym_preproc_line] = STATE(3676),
    [sym_preproc_pragma] = STATE(3676),
    [sym_preproc_nullable] = STATE(3676),
    [sym_preproc_error] = STATE(3676),
    [sym_preproc_define] = STATE(3676),
    [sym_preproc_undef] = STATE(3676),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4138),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3677] = {
    [sym_preproc_region] = STATE(3677),
    [sym_preproc_endregion] = STATE(3677),
    [sym_preproc_line] = STATE(3677),
    [sym_preproc_pragma] = STATE(3677),
    [sym_preproc_nullable] = STATE(3677),
    [sym_preproc_error] = STATE(3677),
    [sym_preproc_define] = STATE(3677),
    [sym_preproc_undef] = STATE(3677),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5524),
    [anon_sym_where] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5524),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_from] = ACTIONS(5522),
    [anon_sym_into] = ACTIONS(5522),
    [anon_sym_join] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_let] = ACTIONS(5522),
    [anon_sym_orderby] = ACTIONS(5522),
    [anon_sym_group] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_select] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3678] = {
    [sym_preproc_region] = STATE(3678),
    [sym_preproc_endregion] = STATE(3678),
    [sym_preproc_line] = STATE(3678),
    [sym_preproc_pragma] = STATE(3678),
    [sym_preproc_nullable] = STATE(3678),
    [sym_preproc_error] = STATE(3678),
    [sym_preproc_define] = STATE(3678),
    [sym_preproc_undef] = STATE(3678),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4128),
    [anon_sym_where] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_from] = ACTIONS(4128),
    [anon_sym_join] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_let] = ACTIONS(4128),
    [anon_sym_orderby] = ACTIONS(4128),
    [anon_sym_group] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_select] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3679] = {
    [sym_preproc_region] = STATE(3679),
    [sym_preproc_endregion] = STATE(3679),
    [sym_preproc_line] = STATE(3679),
    [sym_preproc_pragma] = STATE(3679),
    [sym_preproc_nullable] = STATE(3679),
    [sym_preproc_error] = STATE(3679),
    [sym_preproc_define] = STATE(3679),
    [sym_preproc_undef] = STATE(3679),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_where] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_from] = ACTIONS(5526),
    [anon_sym_into] = ACTIONS(5526),
    [anon_sym_join] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_orderby] = ACTIONS(5526),
    [anon_sym_group] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_select] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3680] = {
    [sym_preproc_region] = STATE(3680),
    [sym_preproc_endregion] = STATE(3680),
    [sym_preproc_line] = STATE(3680),
    [sym_preproc_pragma] = STATE(3680),
    [sym_preproc_nullable] = STATE(3680),
    [sym_preproc_error] = STATE(3680),
    [sym_preproc_define] = STATE(3680),
    [sym_preproc_undef] = STATE(3680),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_COMMA] = ACTIONS(5530),
    [anon_sym_RBRACK] = ACTIONS(5530),
    [anon_sym_LPAREN] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_where] = ACTIONS(5530),
    [anon_sym_QMARK] = ACTIONS(5532),
    [anon_sym_BANG] = ACTIONS(5532),
    [anon_sym_PLUS_PLUS] = ACTIONS(5530),
    [anon_sym_DASH_DASH] = ACTIONS(5530),
    [anon_sym_PLUS] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_SLASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_CARET] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_GT_GT_GT] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5530),
    [anon_sym_BANG_EQ] = ACTIONS(5530),
    [anon_sym_GT_EQ] = ACTIONS(5530),
    [anon_sym_LT_EQ] = ACTIONS(5530),
    [anon_sym_DOT] = ACTIONS(5532),
    [anon_sym_EQ_GT] = ACTIONS(5530),
    [anon_sym_switch] = ACTIONS(5530),
    [anon_sym_DOT_DOT] = ACTIONS(5530),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_or] = ACTIONS(5532),
    [anon_sym_AMP_AMP] = ACTIONS(5530),
    [anon_sym_PIPE_PIPE] = ACTIONS(5530),
    [anon_sym_QMARK_QMARK] = ACTIONS(5530),
    [anon_sym_from] = ACTIONS(5530),
    [anon_sym_into] = ACTIONS(5530),
    [anon_sym_join] = ACTIONS(5530),
    [anon_sym_on] = ACTIONS(5530),
    [anon_sym_equals] = ACTIONS(5530),
    [anon_sym_let] = ACTIONS(5530),
    [anon_sym_orderby] = ACTIONS(5530),
    [anon_sym_group] = ACTIONS(5530),
    [anon_sym_by] = ACTIONS(5530),
    [anon_sym_select] = ACTIONS(5530),
    [anon_sym_as] = ACTIONS(5530),
    [anon_sym_is] = ACTIONS(5530),
    [anon_sym_DASH_GT] = ACTIONS(5530),
    [anon_sym_with] = ACTIONS(5530),
    [aux_sym_preproc_if_token3] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3681] = {
    [sym_preproc_region] = STATE(3681),
    [sym_preproc_endregion] = STATE(3681),
    [sym_preproc_line] = STATE(3681),
    [sym_preproc_pragma] = STATE(3681),
    [sym_preproc_nullable] = STATE(3681),
    [sym_preproc_error] = STATE(3681),
    [sym_preproc_define] = STATE(3681),
    [sym_preproc_undef] = STATE(3681),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COMMA] = ACTIONS(5534),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5536),
    [anon_sym_GT] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_where] = ACTIONS(5534),
    [anon_sym_QMARK] = ACTIONS(5536),
    [anon_sym_BANG] = ACTIONS(5536),
    [anon_sym_PLUS_PLUS] = ACTIONS(5534),
    [anon_sym_DASH_DASH] = ACTIONS(5534),
    [anon_sym_PLUS] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_SLASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_CARET] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_GT_GT_GT] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_BANG_EQ] = ACTIONS(5534),
    [anon_sym_GT_EQ] = ACTIONS(5534),
    [anon_sym_LT_EQ] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(5536),
    [anon_sym_EQ_GT] = ACTIONS(5534),
    [anon_sym_switch] = ACTIONS(5534),
    [anon_sym_DOT_DOT] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5534),
    [anon_sym_or] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK] = ACTIONS(5534),
    [anon_sym_from] = ACTIONS(5534),
    [anon_sym_into] = ACTIONS(5534),
    [anon_sym_join] = ACTIONS(5534),
    [anon_sym_on] = ACTIONS(5534),
    [anon_sym_equals] = ACTIONS(5534),
    [anon_sym_let] = ACTIONS(5534),
    [anon_sym_orderby] = ACTIONS(5534),
    [anon_sym_group] = ACTIONS(5534),
    [anon_sym_by] = ACTIONS(5534),
    [anon_sym_select] = ACTIONS(5534),
    [anon_sym_as] = ACTIONS(5534),
    [anon_sym_is] = ACTIONS(5534),
    [anon_sym_DASH_GT] = ACTIONS(5534),
    [anon_sym_with] = ACTIONS(5534),
    [aux_sym_preproc_if_token3] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3682] = {
    [sym_preproc_region] = STATE(3682),
    [sym_preproc_endregion] = STATE(3682),
    [sym_preproc_line] = STATE(3682),
    [sym_preproc_pragma] = STATE(3682),
    [sym_preproc_nullable] = STATE(3682),
    [sym_preproc_error] = STATE(3682),
    [sym_preproc_define] = STATE(3682),
    [sym_preproc_undef] = STATE(3682),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RBRACK] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5540),
    [anon_sym_GT] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5540),
    [anon_sym_where] = ACTIONS(5538),
    [anon_sym_QMARK] = ACTIONS(5540),
    [anon_sym_BANG] = ACTIONS(5540),
    [anon_sym_PLUS_PLUS] = ACTIONS(5538),
    [anon_sym_DASH_DASH] = ACTIONS(5538),
    [anon_sym_PLUS] = ACTIONS(5540),
    [anon_sym_DASH] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_SLASH] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_CARET] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_GT_GT_GT] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_BANG_EQ] = ACTIONS(5538),
    [anon_sym_GT_EQ] = ACTIONS(5538),
    [anon_sym_LT_EQ] = ACTIONS(5538),
    [anon_sym_DOT] = ACTIONS(5540),
    [anon_sym_EQ_GT] = ACTIONS(5538),
    [anon_sym_switch] = ACTIONS(5538),
    [anon_sym_DOT_DOT] = ACTIONS(5538),
    [anon_sym_and] = ACTIONS(5538),
    [anon_sym_or] = ACTIONS(5540),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_QMARK_QMARK] = ACTIONS(5538),
    [anon_sym_from] = ACTIONS(5538),
    [anon_sym_into] = ACTIONS(5538),
    [anon_sym_join] = ACTIONS(5538),
    [anon_sym_on] = ACTIONS(5538),
    [anon_sym_equals] = ACTIONS(5538),
    [anon_sym_let] = ACTIONS(5538),
    [anon_sym_orderby] = ACTIONS(5538),
    [anon_sym_group] = ACTIONS(5538),
    [anon_sym_by] = ACTIONS(5538),
    [anon_sym_select] = ACTIONS(5538),
    [anon_sym_as] = ACTIONS(5538),
    [anon_sym_is] = ACTIONS(5538),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [anon_sym_with] = ACTIONS(5538),
    [aux_sym_preproc_if_token3] = ACTIONS(5538),
    [aux_sym_preproc_else_token1] = ACTIONS(5538),
    [aux_sym_preproc_elif_token1] = ACTIONS(5538),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3683] = {
    [sym_attribute_list] = STATE(4403),
    [sym_modifier] = STATE(4531),
    [sym_accessor_declaration] = STATE(4347),
    [sym_identifier] = STATE(7902),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3683),
    [sym_preproc_endregion] = STATE(3683),
    [sym_preproc_line] = STATE(3683),
    [sym_preproc_pragma] = STATE(3683),
    [sym_preproc_nullable] = STATE(3683),
    [sym_preproc_error] = STATE(3683),
    [sym_preproc_define] = STATE(3683),
    [sym_preproc_undef] = STATE(3683),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_class_declaration_repeat2] = STATE(3961),
    [aux_sym_accessor_list_repeat1] = STATE(3683),
    [sym__identifier_token] = ACTIONS(5542),
    [anon_sym_extern] = ACTIONS(5545),
    [anon_sym_alias] = ACTIONS(5548),
    [anon_sym_global] = ACTIONS(5548),
    [anon_sym_unsafe] = ACTIONS(5545),
    [anon_sym_static] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_abstract] = ACTIONS(5545),
    [anon_sym_async] = ACTIONS(5545),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_file] = ACTIONS(5556),
    [anon_sym_fixed] = ACTIONS(5545),
    [anon_sym_internal] = ACTIONS(5545),
    [anon_sym_new] = ACTIONS(5545),
    [anon_sym_override] = ACTIONS(5545),
    [anon_sym_partial] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5545),
    [anon_sym_protected] = ACTIONS(5545),
    [anon_sym_public] = ACTIONS(5545),
    [anon_sym_readonly] = ACTIONS(5545),
    [anon_sym_required] = ACTIONS(5545),
    [anon_sym_sealed] = ACTIONS(5545),
    [anon_sym_virtual] = ACTIONS(5545),
    [anon_sym_volatile] = ACTIONS(5545),
    [anon_sym_where] = ACTIONS(5548),
    [anon_sym_notnull] = ACTIONS(5548),
    [anon_sym_unmanaged] = ACTIONS(5548),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_add] = ACTIONS(5559),
    [anon_sym_remove] = ACTIONS(5559),
    [anon_sym_init] = ACTIONS(5559),
    [anon_sym_scoped] = ACTIONS(5548),
    [anon_sym_var] = ACTIONS(5548),
    [anon_sym_yield] = ACTIONS(5548),
    [anon_sym_when] = ACTIONS(5548),
    [anon_sym_from] = ACTIONS(5548),
    [anon_sym_into] = ACTIONS(5548),
    [anon_sym_join] = ACTIONS(5548),
    [anon_sym_on] = ACTIONS(5548),
    [anon_sym_equals] = ACTIONS(5548),
    [anon_sym_let] = ACTIONS(5548),
    [anon_sym_orderby] = ACTIONS(5548),
    [anon_sym_ascending] = ACTIONS(5548),
    [anon_sym_descending] = ACTIONS(5548),
    [anon_sym_group] = ACTIONS(5548),
    [anon_sym_by] = ACTIONS(5548),
    [anon_sym_select] = ACTIONS(5548),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3684] = {
    [sym_preproc_region] = STATE(3684),
    [sym_preproc_endregion] = STATE(3684),
    [sym_preproc_line] = STATE(3684),
    [sym_preproc_pragma] = STATE(3684),
    [sym_preproc_nullable] = STATE(3684),
    [sym_preproc_error] = STATE(3684),
    [sym_preproc_define] = STATE(3684),
    [sym_preproc_undef] = STATE(3684),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_RBRACK] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_in] = ACTIONS(1969),
    [anon_sym_where] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1967),
    [anon_sym_BANG_EQ] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_EQ_GT] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_DOT_DOT] = ACTIONS(1967),
    [anon_sym_and] = ACTIONS(1967),
    [anon_sym_or] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_QMARK_QMARK] = ACTIONS(1967),
    [anon_sym_from] = ACTIONS(1967),
    [anon_sym_into] = ACTIONS(1967),
    [anon_sym_join] = ACTIONS(1967),
    [anon_sym_on] = ACTIONS(1967),
    [anon_sym_equals] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_orderby] = ACTIONS(1967),
    [anon_sym_group] = ACTIONS(1967),
    [anon_sym_by] = ACTIONS(1967),
    [anon_sym_select] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_is] = ACTIONS(1967),
    [anon_sym_DASH_GT] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [aux_sym_preproc_if_token3] = ACTIONS(1967),
    [aux_sym_preproc_else_token1] = ACTIONS(1967),
    [aux_sym_preproc_elif_token1] = ACTIONS(1967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3685] = {
    [sym_preproc_region] = STATE(3685),
    [sym_preproc_endregion] = STATE(3685),
    [sym_preproc_line] = STATE(3685),
    [sym_preproc_pragma] = STATE(3685),
    [sym_preproc_nullable] = STATE(3685),
    [sym_preproc_error] = STATE(3685),
    [sym_preproc_define] = STATE(3685),
    [sym_preproc_undef] = STATE(3685),
    [anon_sym_SEMI] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_RBRACK] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5562),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_where] = ACTIONS(5562),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5562),
    [anon_sym_DASH_DASH] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_CARET] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_GT_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5562),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_GT_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5562),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5562),
    [anon_sym_switch] = ACTIONS(5562),
    [anon_sym_DOT_DOT] = ACTIONS(5562),
    [anon_sym_and] = ACTIONS(5562),
    [anon_sym_or] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_QMARK_QMARK] = ACTIONS(5562),
    [anon_sym_from] = ACTIONS(5562),
    [anon_sym_into] = ACTIONS(5562),
    [anon_sym_join] = ACTIONS(5562),
    [anon_sym_on] = ACTIONS(5562),
    [anon_sym_equals] = ACTIONS(5562),
    [anon_sym_let] = ACTIONS(5562),
    [anon_sym_orderby] = ACTIONS(5562),
    [anon_sym_group] = ACTIONS(5562),
    [anon_sym_by] = ACTIONS(5562),
    [anon_sym_select] = ACTIONS(5562),
    [anon_sym_as] = ACTIONS(5562),
    [anon_sym_is] = ACTIONS(5562),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_with] = ACTIONS(5562),
    [aux_sym_preproc_if_token3] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3686] = {
    [sym_preproc_region] = STATE(3686),
    [sym_preproc_endregion] = STATE(3686),
    [sym_preproc_line] = STATE(3686),
    [sym_preproc_pragma] = STATE(3686),
    [sym_preproc_nullable] = STATE(3686),
    [sym_preproc_error] = STATE(3686),
    [sym_preproc_define] = STATE(3686),
    [sym_preproc_undef] = STATE(3686),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3687] = {
    [sym_preproc_region] = STATE(3687),
    [sym_preproc_endregion] = STATE(3687),
    [sym_preproc_line] = STATE(3687),
    [sym_preproc_pragma] = STATE(3687),
    [sym_preproc_nullable] = STATE(3687),
    [sym_preproc_error] = STATE(3687),
    [sym_preproc_define] = STATE(3687),
    [sym_preproc_undef] = STATE(3687),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_where] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_BANG] = ACTIONS(5568),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_GT_GT_GT] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_EQ_GT] = ACTIONS(5566),
    [anon_sym_switch] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_and] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_QMARK_QMARK] = ACTIONS(5566),
    [anon_sym_from] = ACTIONS(5566),
    [anon_sym_into] = ACTIONS(5566),
    [anon_sym_join] = ACTIONS(5566),
    [anon_sym_on] = ACTIONS(5566),
    [anon_sym_equals] = ACTIONS(5566),
    [anon_sym_let] = ACTIONS(5566),
    [anon_sym_orderby] = ACTIONS(5566),
    [anon_sym_group] = ACTIONS(5566),
    [anon_sym_by] = ACTIONS(5566),
    [anon_sym_select] = ACTIONS(5566),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_is] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [anon_sym_with] = ACTIONS(5566),
    [aux_sym_preproc_if_token3] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3688] = {
    [sym_preproc_region] = STATE(3688),
    [sym_preproc_endregion] = STATE(3688),
    [sym_preproc_line] = STATE(3688),
    [sym_preproc_pragma] = STATE(3688),
    [sym_preproc_nullable] = STATE(3688),
    [sym_preproc_error] = STATE(3688),
    [sym_preproc_define] = STATE(3688),
    [sym_preproc_undef] = STATE(3688),
    [anon_sym_SEMI] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_COLON] = ACTIONS(5570),
    [anon_sym_COMMA] = ACTIONS(5570),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_LPAREN] = ACTIONS(5570),
    [anon_sym_RPAREN] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(5572),
    [anon_sym_GT] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_where] = ACTIONS(5570),
    [anon_sym_QMARK] = ACTIONS(5572),
    [anon_sym_BANG] = ACTIONS(5572),
    [anon_sym_PLUS_PLUS] = ACTIONS(5570),
    [anon_sym_DASH_DASH] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_SLASH] = ACTIONS(5572),
    [anon_sym_PERCENT] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PIPE] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym_LT_LT] = ACTIONS(5570),
    [anon_sym_GT_GT] = ACTIONS(5572),
    [anon_sym_GT_GT_GT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5570),
    [anon_sym_BANG_EQ] = ACTIONS(5570),
    [anon_sym_GT_EQ] = ACTIONS(5570),
    [anon_sym_LT_EQ] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(5572),
    [anon_sym_EQ_GT] = ACTIONS(5570),
    [anon_sym_switch] = ACTIONS(5570),
    [anon_sym_DOT_DOT] = ACTIONS(5570),
    [anon_sym_and] = ACTIONS(5570),
    [anon_sym_or] = ACTIONS(5572),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE] = ACTIONS(5570),
    [anon_sym_QMARK_QMARK] = ACTIONS(5570),
    [anon_sym_from] = ACTIONS(5570),
    [anon_sym_into] = ACTIONS(5570),
    [anon_sym_join] = ACTIONS(5570),
    [anon_sym_on] = ACTIONS(5570),
    [anon_sym_equals] = ACTIONS(5570),
    [anon_sym_let] = ACTIONS(5570),
    [anon_sym_orderby] = ACTIONS(5570),
    [anon_sym_group] = ACTIONS(5570),
    [anon_sym_by] = ACTIONS(5570),
    [anon_sym_select] = ACTIONS(5570),
    [anon_sym_as] = ACTIONS(5570),
    [anon_sym_is] = ACTIONS(5570),
    [anon_sym_DASH_GT] = ACTIONS(5570),
    [anon_sym_with] = ACTIONS(5570),
    [aux_sym_preproc_if_token3] = ACTIONS(5570),
    [aux_sym_preproc_else_token1] = ACTIONS(5570),
    [aux_sym_preproc_elif_token1] = ACTIONS(5570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3689] = {
    [sym_preproc_region] = STATE(3689),
    [sym_preproc_endregion] = STATE(3689),
    [sym_preproc_line] = STATE(3689),
    [sym_preproc_pragma] = STATE(3689),
    [sym_preproc_nullable] = STATE(3689),
    [sym_preproc_error] = STATE(3689),
    [sym_preproc_define] = STATE(3689),
    [sym_preproc_undef] = STATE(3689),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_COMMA] = ACTIONS(5574),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_LPAREN] = ACTIONS(5574),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_LT] = ACTIONS(5576),
    [anon_sym_GT] = ACTIONS(5576),
    [anon_sym_in] = ACTIONS(5576),
    [anon_sym_where] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5576),
    [anon_sym_BANG] = ACTIONS(5576),
    [anon_sym_PLUS_PLUS] = ACTIONS(5574),
    [anon_sym_DASH_DASH] = ACTIONS(5574),
    [anon_sym_PLUS] = ACTIONS(5576),
    [anon_sym_DASH] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_SLASH] = ACTIONS(5576),
    [anon_sym_PERCENT] = ACTIONS(5574),
    [anon_sym_CARET] = ACTIONS(5574),
    [anon_sym_PIPE] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5576),
    [anon_sym_LT_LT] = ACTIONS(5574),
    [anon_sym_GT_GT] = ACTIONS(5576),
    [anon_sym_GT_GT_GT] = ACTIONS(5574),
    [anon_sym_EQ_EQ] = ACTIONS(5574),
    [anon_sym_BANG_EQ] = ACTIONS(5574),
    [anon_sym_GT_EQ] = ACTIONS(5574),
    [anon_sym_LT_EQ] = ACTIONS(5574),
    [anon_sym_DOT] = ACTIONS(5576),
    [anon_sym_EQ_GT] = ACTIONS(5574),
    [anon_sym_switch] = ACTIONS(5574),
    [anon_sym_DOT_DOT] = ACTIONS(5574),
    [anon_sym_and] = ACTIONS(5574),
    [anon_sym_or] = ACTIONS(5576),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_PIPE_PIPE] = ACTIONS(5574),
    [anon_sym_QMARK_QMARK] = ACTIONS(5574),
    [anon_sym_from] = ACTIONS(5574),
    [anon_sym_into] = ACTIONS(5574),
    [anon_sym_join] = ACTIONS(5574),
    [anon_sym_on] = ACTIONS(5574),
    [anon_sym_equals] = ACTIONS(5574),
    [anon_sym_let] = ACTIONS(5574),
    [anon_sym_orderby] = ACTIONS(5574),
    [anon_sym_group] = ACTIONS(5574),
    [anon_sym_by] = ACTIONS(5574),
    [anon_sym_select] = ACTIONS(5574),
    [anon_sym_as] = ACTIONS(5574),
    [anon_sym_is] = ACTIONS(5574),
    [anon_sym_DASH_GT] = ACTIONS(5574),
    [anon_sym_with] = ACTIONS(5574),
    [aux_sym_preproc_if_token3] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5574),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3690] = {
    [sym_preproc_region] = STATE(3690),
    [sym_preproc_endregion] = STATE(3690),
    [sym_preproc_line] = STATE(3690),
    [sym_preproc_pragma] = STATE(3690),
    [sym_preproc_nullable] = STATE(3690),
    [sym_preproc_error] = STATE(3690),
    [sym_preproc_define] = STATE(3690),
    [sym_preproc_undef] = STATE(3690),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5578),
    [anon_sym_COMMA] = ACTIONS(5578),
    [anon_sym_RBRACK] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(5578),
    [anon_sym_RPAREN] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5580),
    [anon_sym_in] = ACTIONS(5580),
    [anon_sym_where] = ACTIONS(5578),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_BANG] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5578),
    [anon_sym_SLASH] = ACTIONS(5580),
    [anon_sym_PERCENT] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5580),
    [anon_sym_LT_LT] = ACTIONS(5578),
    [anon_sym_GT_GT] = ACTIONS(5580),
    [anon_sym_GT_GT_GT] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5578),
    [anon_sym_BANG_EQ] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5578),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(5580),
    [anon_sym_EQ_GT] = ACTIONS(5578),
    [anon_sym_switch] = ACTIONS(5578),
    [anon_sym_DOT_DOT] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_or] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE] = ACTIONS(5578),
    [anon_sym_QMARK_QMARK] = ACTIONS(5578),
    [anon_sym_from] = ACTIONS(5578),
    [anon_sym_into] = ACTIONS(5578),
    [anon_sym_join] = ACTIONS(5578),
    [anon_sym_on] = ACTIONS(5578),
    [anon_sym_equals] = ACTIONS(5578),
    [anon_sym_let] = ACTIONS(5578),
    [anon_sym_orderby] = ACTIONS(5578),
    [anon_sym_group] = ACTIONS(5578),
    [anon_sym_by] = ACTIONS(5578),
    [anon_sym_select] = ACTIONS(5578),
    [anon_sym_as] = ACTIONS(5578),
    [anon_sym_is] = ACTIONS(5578),
    [anon_sym_DASH_GT] = ACTIONS(5578),
    [anon_sym_with] = ACTIONS(5578),
    [aux_sym_preproc_if_token3] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3691] = {
    [sym_preproc_region] = STATE(3691),
    [sym_preproc_endregion] = STATE(3691),
    [sym_preproc_line] = STATE(3691),
    [sym_preproc_pragma] = STATE(3691),
    [sym_preproc_nullable] = STATE(3691),
    [sym_preproc_error] = STATE(3691),
    [sym_preproc_define] = STATE(3691),
    [sym_preproc_undef] = STATE(3691),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4620),
    [anon_sym_where] = ACTIONS(4620),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_switch] = ACTIONS(4620),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4620),
    [anon_sym_or] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_from] = ACTIONS(4620),
    [anon_sym_join] = ACTIONS(4620),
    [anon_sym_on] = ACTIONS(4620),
    [anon_sym_equals] = ACTIONS(4620),
    [anon_sym_let] = ACTIONS(4620),
    [anon_sym_orderby] = ACTIONS(4620),
    [anon_sym_group] = ACTIONS(4620),
    [anon_sym_by] = ACTIONS(4620),
    [anon_sym_select] = ACTIONS(4620),
    [anon_sym_as] = ACTIONS(4620),
    [anon_sym_is] = ACTIONS(4620),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4620),
    [aux_sym_preproc_if_token3] = ACTIONS(4620),
    [aux_sym_preproc_else_token1] = ACTIONS(4620),
    [aux_sym_preproc_elif_token1] = ACTIONS(4620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3692] = {
    [sym_preproc_region] = STATE(3692),
    [sym_preproc_endregion] = STATE(3692),
    [sym_preproc_line] = STATE(3692),
    [sym_preproc_pragma] = STATE(3692),
    [sym_preproc_nullable] = STATE(3692),
    [sym_preproc_error] = STATE(3692),
    [sym_preproc_define] = STATE(3692),
    [sym_preproc_undef] = STATE(3692),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5584),
    [anon_sym_where] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5584),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_from] = ACTIONS(5582),
    [anon_sym_into] = ACTIONS(5582),
    [anon_sym_join] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_let] = ACTIONS(5582),
    [anon_sym_orderby] = ACTIONS(5582),
    [anon_sym_group] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_select] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3693] = {
    [sym_preproc_region] = STATE(3693),
    [sym_preproc_endregion] = STATE(3693),
    [sym_preproc_line] = STATE(3693),
    [sym_preproc_pragma] = STATE(3693),
    [sym_preproc_nullable] = STATE(3693),
    [sym_preproc_error] = STATE(3693),
    [sym_preproc_define] = STATE(3693),
    [sym_preproc_undef] = STATE(3693),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5588),
    [anon_sym_where] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_from] = ACTIONS(5586),
    [anon_sym_into] = ACTIONS(5586),
    [anon_sym_join] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_orderby] = ACTIONS(5586),
    [anon_sym_group] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_select] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3694] = {
    [sym_attribute_list] = STATE(4403),
    [sym_modifier] = STATE(4531),
    [sym_accessor_declaration] = STATE(4347),
    [sym_identifier] = STATE(7902),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3694),
    [sym_preproc_endregion] = STATE(3694),
    [sym_preproc_line] = STATE(3694),
    [sym_preproc_pragma] = STATE(3694),
    [sym_preproc_nullable] = STATE(3694),
    [sym_preproc_error] = STATE(3694),
    [sym_preproc_define] = STATE(3694),
    [sym_preproc_undef] = STATE(3694),
    [aux_sym_class_declaration_repeat1] = STATE(3807),
    [aux_sym_class_declaration_repeat2] = STATE(3961),
    [aux_sym_accessor_list_repeat1] = STATE(3683),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_abstract] = ACTIONS(5490),
    [anon_sym_async] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_file] = ACTIONS(5496),
    [anon_sym_fixed] = ACTIONS(5490),
    [anon_sym_internal] = ACTIONS(5490),
    [anon_sym_new] = ACTIONS(5490),
    [anon_sym_override] = ACTIONS(5490),
    [anon_sym_partial] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_readonly] = ACTIONS(5490),
    [anon_sym_required] = ACTIONS(5490),
    [anon_sym_sealed] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5498),
    [anon_sym_set] = ACTIONS(5498),
    [anon_sym_add] = ACTIONS(5498),
    [anon_sym_remove] = ACTIONS(5498),
    [anon_sym_init] = ACTIONS(5498),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3695] = {
    [sym_preproc_region] = STATE(3695),
    [sym_preproc_endregion] = STATE(3695),
    [sym_preproc_line] = STATE(3695),
    [sym_preproc_pragma] = STATE(3695),
    [sym_preproc_nullable] = STATE(3695),
    [sym_preproc_error] = STATE(3695),
    [sym_preproc_define] = STATE(3695),
    [sym_preproc_undef] = STATE(3695),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_RBRACK] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4496),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_EQ_GT] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4496),
    [aux_sym_preproc_else_token1] = ACTIONS(4496),
    [aux_sym_preproc_elif_token1] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3696] = {
    [sym_preproc_region] = STATE(3696),
    [sym_preproc_endregion] = STATE(3696),
    [sym_preproc_line] = STATE(3696),
    [sym_preproc_pragma] = STATE(3696),
    [sym_preproc_nullable] = STATE(3696),
    [sym_preproc_error] = STATE(3696),
    [sym_preproc_define] = STATE(3696),
    [sym_preproc_undef] = STATE(3696),
    [anon_sym_EQ] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_ascending] = ACTIONS(5294),
    [anon_sym_descending] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5296),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3697] = {
    [sym_preproc_region] = STATE(3697),
    [sym_preproc_endregion] = STATE(3697),
    [sym_preproc_line] = STATE(3697),
    [sym_preproc_pragma] = STATE(3697),
    [sym_preproc_nullable] = STATE(3697),
    [sym_preproc_error] = STATE(3697),
    [sym_preproc_define] = STATE(3697),
    [sym_preproc_undef] = STATE(3697),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4482),
    [anon_sym_where] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4482),
    [anon_sym_join] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_let] = ACTIONS(4482),
    [anon_sym_orderby] = ACTIONS(4482),
    [anon_sym_group] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_select] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3698] = {
    [sym_preproc_region] = STATE(3698),
    [sym_preproc_endregion] = STATE(3698),
    [sym_preproc_line] = STATE(3698),
    [sym_preproc_pragma] = STATE(3698),
    [sym_preproc_nullable] = STATE(3698),
    [sym_preproc_error] = STATE(3698),
    [sym_preproc_define] = STATE(3698),
    [sym_preproc_undef] = STATE(3698),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5596),
    [anon_sym_RBRACK] = ACTIONS(5596),
    [anon_sym_LPAREN] = ACTIONS(5596),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_where] = ACTIONS(5596),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_BANG] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5598),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_GT_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_DOT] = ACTIONS(5598),
    [anon_sym_EQ_GT] = ACTIONS(5596),
    [anon_sym_switch] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_or] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_QMARK_QMARK] = ACTIONS(5596),
    [anon_sym_from] = ACTIONS(5596),
    [anon_sym_into] = ACTIONS(5596),
    [anon_sym_join] = ACTIONS(5596),
    [anon_sym_on] = ACTIONS(5596),
    [anon_sym_equals] = ACTIONS(5596),
    [anon_sym_let] = ACTIONS(5596),
    [anon_sym_orderby] = ACTIONS(5596),
    [anon_sym_group] = ACTIONS(5596),
    [anon_sym_by] = ACTIONS(5596),
    [anon_sym_select] = ACTIONS(5596),
    [anon_sym_as] = ACTIONS(5596),
    [anon_sym_is] = ACTIONS(5596),
    [anon_sym_DASH_GT] = ACTIONS(5596),
    [anon_sym_with] = ACTIONS(5596),
    [aux_sym_preproc_if_token3] = ACTIONS(5596),
    [aux_sym_preproc_else_token1] = ACTIONS(5596),
    [aux_sym_preproc_elif_token1] = ACTIONS(5596),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3699] = {
    [sym_preproc_region] = STATE(3699),
    [sym_preproc_endregion] = STATE(3699),
    [sym_preproc_line] = STATE(3699),
    [sym_preproc_pragma] = STATE(3699),
    [sym_preproc_nullable] = STATE(3699),
    [sym_preproc_error] = STATE(3699),
    [sym_preproc_define] = STATE(3699),
    [sym_preproc_undef] = STATE(3699),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COMMA] = ACTIONS(5600),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LPAREN] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5602),
    [anon_sym_where] = ACTIONS(5600),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_BANG] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_SLASH] = ACTIONS(5602),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_GT_GT_GT] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5600),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_DOT] = ACTIONS(5602),
    [anon_sym_EQ_GT] = ACTIONS(5600),
    [anon_sym_switch] = ACTIONS(5600),
    [anon_sym_DOT_DOT] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_or] = ACTIONS(5602),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE] = ACTIONS(5600),
    [anon_sym_QMARK_QMARK] = ACTIONS(5600),
    [anon_sym_from] = ACTIONS(5600),
    [anon_sym_into] = ACTIONS(5600),
    [anon_sym_join] = ACTIONS(5600),
    [anon_sym_on] = ACTIONS(5600),
    [anon_sym_equals] = ACTIONS(5600),
    [anon_sym_let] = ACTIONS(5600),
    [anon_sym_orderby] = ACTIONS(5600),
    [anon_sym_group] = ACTIONS(5600),
    [anon_sym_by] = ACTIONS(5600),
    [anon_sym_select] = ACTIONS(5600),
    [anon_sym_as] = ACTIONS(5600),
    [anon_sym_is] = ACTIONS(5600),
    [anon_sym_DASH_GT] = ACTIONS(5600),
    [anon_sym_with] = ACTIONS(5600),
    [aux_sym_preproc_if_token3] = ACTIONS(5600),
    [aux_sym_preproc_else_token1] = ACTIONS(5600),
    [aux_sym_preproc_elif_token1] = ACTIONS(5600),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3700] = {
    [sym_preproc_region] = STATE(3700),
    [sym_preproc_endregion] = STATE(3700),
    [sym_preproc_line] = STATE(3700),
    [sym_preproc_pragma] = STATE(3700),
    [sym_preproc_nullable] = STATE(3700),
    [sym_preproc_error] = STATE(3700),
    [sym_preproc_define] = STATE(3700),
    [sym_preproc_undef] = STATE(3700),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_RBRACK] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_in] = ACTIONS(4486),
    [anon_sym_where] = ACTIONS(4486),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_EQ_GT] = ACTIONS(4486),
    [anon_sym_switch] = ACTIONS(4486),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4484),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_from] = ACTIONS(4486),
    [anon_sym_join] = ACTIONS(4486),
    [anon_sym_on] = ACTIONS(4486),
    [anon_sym_equals] = ACTIONS(4486),
    [anon_sym_let] = ACTIONS(4486),
    [anon_sym_orderby] = ACTIONS(4486),
    [anon_sym_group] = ACTIONS(4486),
    [anon_sym_by] = ACTIONS(4486),
    [anon_sym_select] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(4486),
    [anon_sym_is] = ACTIONS(4486),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4486),
    [aux_sym_preproc_if_token3] = ACTIONS(4486),
    [aux_sym_preproc_else_token1] = ACTIONS(4486),
    [aux_sym_preproc_elif_token1] = ACTIONS(4486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3701] = {
    [sym_preproc_region] = STATE(3701),
    [sym_preproc_endregion] = STATE(3701),
    [sym_preproc_line] = STATE(3701),
    [sym_preproc_pragma] = STATE(3701),
    [sym_preproc_nullable] = STATE(3701),
    [sym_preproc_error] = STATE(3701),
    [sym_preproc_define] = STATE(3701),
    [sym_preproc_undef] = STATE(3701),
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_RBRACK] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_in] = ACTIONS(4490),
    [anon_sym_where] = ACTIONS(4490),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_EQ_GT] = ACTIONS(4490),
    [anon_sym_switch] = ACTIONS(4490),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4490),
    [anon_sym_or] = ACTIONS(4488),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_from] = ACTIONS(4490),
    [anon_sym_join] = ACTIONS(4490),
    [anon_sym_on] = ACTIONS(4490),
    [anon_sym_equals] = ACTIONS(4490),
    [anon_sym_let] = ACTIONS(4490),
    [anon_sym_orderby] = ACTIONS(4490),
    [anon_sym_group] = ACTIONS(4490),
    [anon_sym_by] = ACTIONS(4490),
    [anon_sym_select] = ACTIONS(4490),
    [anon_sym_as] = ACTIONS(4490),
    [anon_sym_is] = ACTIONS(4490),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4490),
    [aux_sym_preproc_if_token3] = ACTIONS(4490),
    [aux_sym_preproc_else_token1] = ACTIONS(4490),
    [aux_sym_preproc_elif_token1] = ACTIONS(4490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3702] = {
    [sym_preproc_region] = STATE(3702),
    [sym_preproc_endregion] = STATE(3702),
    [sym_preproc_line] = STATE(3702),
    [sym_preproc_pragma] = STATE(3702),
    [sym_preproc_nullable] = STATE(3702),
    [sym_preproc_error] = STATE(3702),
    [sym_preproc_define] = STATE(3702),
    [sym_preproc_undef] = STATE(3702),
    [anon_sym_SEMI] = ACTIONS(5604),
    [anon_sym_LBRACK] = ACTIONS(5604),
    [anon_sym_COLON] = ACTIONS(5604),
    [anon_sym_COMMA] = ACTIONS(5604),
    [anon_sym_RBRACK] = ACTIONS(5604),
    [anon_sym_LPAREN] = ACTIONS(5604),
    [anon_sym_RPAREN] = ACTIONS(5604),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_LT] = ACTIONS(5606),
    [anon_sym_GT] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_where] = ACTIONS(5604),
    [anon_sym_QMARK] = ACTIONS(5606),
    [anon_sym_BANG] = ACTIONS(5606),
    [anon_sym_PLUS_PLUS] = ACTIONS(5604),
    [anon_sym_DASH_DASH] = ACTIONS(5604),
    [anon_sym_PLUS] = ACTIONS(5606),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_SLASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5604),
    [anon_sym_CARET] = ACTIONS(5604),
    [anon_sym_PIPE] = ACTIONS(5606),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym_LT_LT] = ACTIONS(5604),
    [anon_sym_GT_GT] = ACTIONS(5606),
    [anon_sym_GT_GT_GT] = ACTIONS(5604),
    [anon_sym_EQ_EQ] = ACTIONS(5604),
    [anon_sym_BANG_EQ] = ACTIONS(5604),
    [anon_sym_GT_EQ] = ACTIONS(5604),
    [anon_sym_LT_EQ] = ACTIONS(5604),
    [anon_sym_DOT] = ACTIONS(5606),
    [anon_sym_EQ_GT] = ACTIONS(5604),
    [anon_sym_switch] = ACTIONS(5604),
    [anon_sym_DOT_DOT] = ACTIONS(5604),
    [anon_sym_and] = ACTIONS(5604),
    [anon_sym_or] = ACTIONS(5606),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_PIPE_PIPE] = ACTIONS(5604),
    [anon_sym_QMARK_QMARK] = ACTIONS(5604),
    [anon_sym_from] = ACTIONS(5604),
    [anon_sym_into] = ACTIONS(5604),
    [anon_sym_join] = ACTIONS(5604),
    [anon_sym_on] = ACTIONS(5604),
    [anon_sym_equals] = ACTIONS(5604),
    [anon_sym_let] = ACTIONS(5604),
    [anon_sym_orderby] = ACTIONS(5604),
    [anon_sym_group] = ACTIONS(5604),
    [anon_sym_by] = ACTIONS(5604),
    [anon_sym_select] = ACTIONS(5604),
    [anon_sym_as] = ACTIONS(5604),
    [anon_sym_is] = ACTIONS(5604),
    [anon_sym_DASH_GT] = ACTIONS(5604),
    [anon_sym_with] = ACTIONS(5604),
    [aux_sym_preproc_if_token3] = ACTIONS(5604),
    [aux_sym_preproc_else_token1] = ACTIONS(5604),
    [aux_sym_preproc_elif_token1] = ACTIONS(5604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3703] = {
    [sym_preproc_region] = STATE(3703),
    [sym_preproc_endregion] = STATE(3703),
    [sym_preproc_line] = STATE(3703),
    [sym_preproc_pragma] = STATE(3703),
    [sym_preproc_nullable] = STATE(3703),
    [sym_preproc_error] = STATE(3703),
    [sym_preproc_define] = STATE(3703),
    [sym_preproc_undef] = STATE(3703),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym_LBRACK] = ACTIONS(5608),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(5608),
    [anon_sym_RBRACK] = ACTIONS(5608),
    [anon_sym_LPAREN] = ACTIONS(5608),
    [anon_sym_RPAREN] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_LT] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_where] = ACTIONS(5608),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_BANG] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5608),
    [anon_sym_DASH_DASH] = ACTIONS(5608),
    [anon_sym_PLUS] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5610),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_SLASH] = ACTIONS(5610),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_CARET] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym_LT_LT] = ACTIONS(5608),
    [anon_sym_GT_GT] = ACTIONS(5610),
    [anon_sym_GT_GT_GT] = ACTIONS(5608),
    [anon_sym_EQ_EQ] = ACTIONS(5608),
    [anon_sym_BANG_EQ] = ACTIONS(5608),
    [anon_sym_GT_EQ] = ACTIONS(5608),
    [anon_sym_LT_EQ] = ACTIONS(5608),
    [anon_sym_DOT] = ACTIONS(5610),
    [anon_sym_EQ_GT] = ACTIONS(5608),
    [anon_sym_switch] = ACTIONS(5608),
    [anon_sym_DOT_DOT] = ACTIONS(5608),
    [anon_sym_and] = ACTIONS(5608),
    [anon_sym_or] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_QMARK_QMARK] = ACTIONS(5608),
    [anon_sym_from] = ACTIONS(5608),
    [anon_sym_into] = ACTIONS(5608),
    [anon_sym_join] = ACTIONS(5608),
    [anon_sym_on] = ACTIONS(5608),
    [anon_sym_equals] = ACTIONS(5608),
    [anon_sym_let] = ACTIONS(5608),
    [anon_sym_orderby] = ACTIONS(5608),
    [anon_sym_group] = ACTIONS(5608),
    [anon_sym_by] = ACTIONS(5608),
    [anon_sym_select] = ACTIONS(5608),
    [anon_sym_as] = ACTIONS(5608),
    [anon_sym_is] = ACTIONS(5608),
    [anon_sym_DASH_GT] = ACTIONS(5608),
    [anon_sym_with] = ACTIONS(5608),
    [aux_sym_preproc_if_token3] = ACTIONS(5608),
    [aux_sym_preproc_else_token1] = ACTIONS(5608),
    [aux_sym_preproc_elif_token1] = ACTIONS(5608),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3704] = {
    [sym_preproc_region] = STATE(3704),
    [sym_preproc_endregion] = STATE(3704),
    [sym_preproc_line] = STATE(3704),
    [sym_preproc_pragma] = STATE(3704),
    [sym_preproc_nullable] = STATE(3704),
    [sym_preproc_error] = STATE(3704),
    [sym_preproc_define] = STATE(3704),
    [sym_preproc_undef] = STATE(3704),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_RBRACK] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4610),
    [anon_sym_where] = ACTIONS(4610),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_EQ_GT] = ACTIONS(4610),
    [anon_sym_switch] = ACTIONS(4610),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4610),
    [anon_sym_or] = ACTIONS(4608),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_from] = ACTIONS(4610),
    [anon_sym_join] = ACTIONS(4610),
    [anon_sym_on] = ACTIONS(4610),
    [anon_sym_equals] = ACTIONS(4610),
    [anon_sym_let] = ACTIONS(4610),
    [anon_sym_orderby] = ACTIONS(4610),
    [anon_sym_group] = ACTIONS(4610),
    [anon_sym_by] = ACTIONS(4610),
    [anon_sym_select] = ACTIONS(4610),
    [anon_sym_as] = ACTIONS(4610),
    [anon_sym_is] = ACTIONS(4610),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4610),
    [aux_sym_preproc_if_token3] = ACTIONS(4610),
    [aux_sym_preproc_else_token1] = ACTIONS(4610),
    [aux_sym_preproc_elif_token1] = ACTIONS(4610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3705] = {
    [sym_preproc_region] = STATE(3705),
    [sym_preproc_endregion] = STATE(3705),
    [sym_preproc_line] = STATE(3705),
    [sym_preproc_pragma] = STATE(3705),
    [sym_preproc_nullable] = STATE(3705),
    [sym_preproc_error] = STATE(3705),
    [sym_preproc_define] = STATE(3705),
    [sym_preproc_undef] = STATE(3705),
    [anon_sym_SEMI] = ACTIONS(4457),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_RBRACK] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4457),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_in] = ACTIONS(4457),
    [anon_sym_where] = ACTIONS(4457),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_EQ_GT] = ACTIONS(4457),
    [anon_sym_switch] = ACTIONS(4457),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4457),
    [anon_sym_or] = ACTIONS(4455),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_from] = ACTIONS(4457),
    [anon_sym_join] = ACTIONS(4457),
    [anon_sym_on] = ACTIONS(4457),
    [anon_sym_equals] = ACTIONS(4457),
    [anon_sym_let] = ACTIONS(4457),
    [anon_sym_orderby] = ACTIONS(4457),
    [anon_sym_group] = ACTIONS(4457),
    [anon_sym_by] = ACTIONS(4457),
    [anon_sym_select] = ACTIONS(4457),
    [anon_sym_as] = ACTIONS(4457),
    [anon_sym_is] = ACTIONS(4457),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4457),
    [aux_sym_preproc_if_token3] = ACTIONS(4457),
    [aux_sym_preproc_else_token1] = ACTIONS(4457),
    [aux_sym_preproc_elif_token1] = ACTIONS(4457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3706] = {
    [sym_preproc_region] = STATE(3706),
    [sym_preproc_endregion] = STATE(3706),
    [sym_preproc_line] = STATE(3706),
    [sym_preproc_pragma] = STATE(3706),
    [sym_preproc_nullable] = STATE(3706),
    [sym_preproc_error] = STATE(3706),
    [sym_preproc_define] = STATE(3706),
    [sym_preproc_undef] = STATE(3706),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4132),
    [anon_sym_where] = ACTIONS(4132),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4130),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_from] = ACTIONS(4132),
    [anon_sym_join] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_let] = ACTIONS(4132),
    [anon_sym_orderby] = ACTIONS(4132),
    [anon_sym_group] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_select] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3707] = {
    [sym_preproc_region] = STATE(3707),
    [sym_preproc_endregion] = STATE(3707),
    [sym_preproc_line] = STATE(3707),
    [sym_preproc_pragma] = STATE(3707),
    [sym_preproc_nullable] = STATE(3707),
    [sym_preproc_error] = STATE(3707),
    [sym_preproc_define] = STATE(3707),
    [sym_preproc_undef] = STATE(3707),
    [anon_sym_SEMI] = ACTIONS(5612),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COMMA] = ACTIONS(5612),
    [anon_sym_RBRACK] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(5612),
    [anon_sym_RPAREN] = ACTIONS(5612),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5614),
    [anon_sym_GT] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5614),
    [anon_sym_where] = ACTIONS(5612),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_BANG] = ACTIONS(5614),
    [anon_sym_PLUS_PLUS] = ACTIONS(5612),
    [anon_sym_DASH_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5614),
    [anon_sym_DASH] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_PIPE] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5614),
    [anon_sym_GT_GT_GT] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5612),
    [anon_sym_BANG_EQ] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5612),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(5614),
    [anon_sym_EQ_GT] = ACTIONS(5612),
    [anon_sym_switch] = ACTIONS(5612),
    [anon_sym_DOT_DOT] = ACTIONS(5612),
    [anon_sym_and] = ACTIONS(5612),
    [anon_sym_or] = ACTIONS(5614),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5612),
    [anon_sym_QMARK_QMARK] = ACTIONS(5612),
    [anon_sym_from] = ACTIONS(5612),
    [anon_sym_into] = ACTIONS(5612),
    [anon_sym_join] = ACTIONS(5612),
    [anon_sym_on] = ACTIONS(5612),
    [anon_sym_equals] = ACTIONS(5612),
    [anon_sym_let] = ACTIONS(5612),
    [anon_sym_orderby] = ACTIONS(5612),
    [anon_sym_group] = ACTIONS(5612),
    [anon_sym_by] = ACTIONS(5612),
    [anon_sym_select] = ACTIONS(5612),
    [anon_sym_as] = ACTIONS(5612),
    [anon_sym_is] = ACTIONS(5612),
    [anon_sym_DASH_GT] = ACTIONS(5612),
    [anon_sym_with] = ACTIONS(5612),
    [aux_sym_preproc_if_token3] = ACTIONS(5612),
    [aux_sym_preproc_else_token1] = ACTIONS(5612),
    [aux_sym_preproc_elif_token1] = ACTIONS(5612),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3708] = {
    [sym_preproc_region] = STATE(3708),
    [sym_preproc_endregion] = STATE(3708),
    [sym_preproc_line] = STATE(3708),
    [sym_preproc_pragma] = STATE(3708),
    [sym_preproc_nullable] = STATE(3708),
    [sym_preproc_error] = STATE(3708),
    [sym_preproc_define] = STATE(3708),
    [sym_preproc_undef] = STATE(3708),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_where] = ACTIONS(2991),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2991),
    [anon_sym_or] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2991),
    [anon_sym_into] = ACTIONS(2991),
    [anon_sym_join] = ACTIONS(2991),
    [anon_sym_on] = ACTIONS(2991),
    [anon_sym_equals] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_orderby] = ACTIONS(2991),
    [anon_sym_group] = ACTIONS(2991),
    [anon_sym_by] = ACTIONS(2991),
    [anon_sym_select] = ACTIONS(2991),
    [anon_sym_as] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2991),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [aux_sym_preproc_if_token3] = ACTIONS(2991),
    [aux_sym_preproc_else_token1] = ACTIONS(2991),
    [aux_sym_preproc_elif_token1] = ACTIONS(2991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3709] = {
    [sym_preproc_region] = STATE(3709),
    [sym_preproc_endregion] = STATE(3709),
    [sym_preproc_line] = STATE(3709),
    [sym_preproc_pragma] = STATE(3709),
    [sym_preproc_nullable] = STATE(3709),
    [sym_preproc_error] = STATE(3709),
    [sym_preproc_define] = STATE(3709),
    [sym_preproc_undef] = STATE(3709),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_COLON] = ACTIONS(5616),
    [anon_sym_COMMA] = ACTIONS(5616),
    [anon_sym_RBRACK] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [anon_sym_RPAREN] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5618),
    [anon_sym_where] = ACTIONS(5616),
    [anon_sym_QMARK] = ACTIONS(5618),
    [anon_sym_BANG] = ACTIONS(5618),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5616),
    [anon_sym_CARET] = ACTIONS(5616),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5616),
    [anon_sym_GT_GT] = ACTIONS(5618),
    [anon_sym_GT_GT_GT] = ACTIONS(5616),
    [anon_sym_EQ_EQ] = ACTIONS(5616),
    [anon_sym_BANG_EQ] = ACTIONS(5616),
    [anon_sym_GT_EQ] = ACTIONS(5616),
    [anon_sym_LT_EQ] = ACTIONS(5616),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5616),
    [anon_sym_switch] = ACTIONS(5616),
    [anon_sym_DOT_DOT] = ACTIONS(5616),
    [anon_sym_and] = ACTIONS(5616),
    [anon_sym_or] = ACTIONS(5618),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_PIPE_PIPE] = ACTIONS(5616),
    [anon_sym_QMARK_QMARK] = ACTIONS(5616),
    [anon_sym_from] = ACTIONS(5616),
    [anon_sym_into] = ACTIONS(5616),
    [anon_sym_join] = ACTIONS(5616),
    [anon_sym_on] = ACTIONS(5616),
    [anon_sym_equals] = ACTIONS(5616),
    [anon_sym_let] = ACTIONS(5616),
    [anon_sym_orderby] = ACTIONS(5616),
    [anon_sym_group] = ACTIONS(5616),
    [anon_sym_by] = ACTIONS(5616),
    [anon_sym_select] = ACTIONS(5616),
    [anon_sym_as] = ACTIONS(5616),
    [anon_sym_is] = ACTIONS(5616),
    [anon_sym_DASH_GT] = ACTIONS(5616),
    [anon_sym_with] = ACTIONS(5616),
    [aux_sym_preproc_if_token3] = ACTIONS(5616),
    [aux_sym_preproc_else_token1] = ACTIONS(5616),
    [aux_sym_preproc_elif_token1] = ACTIONS(5616),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3710] = {
    [sym_preproc_region] = STATE(3710),
    [sym_preproc_endregion] = STATE(3710),
    [sym_preproc_line] = STATE(3710),
    [sym_preproc_pragma] = STATE(3710),
    [sym_preproc_nullable] = STATE(3710),
    [sym_preproc_error] = STATE(3710),
    [sym_preproc_define] = STATE(3710),
    [sym_preproc_undef] = STATE(3710),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_in] = ACTIONS(4579),
    [anon_sym_where] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_EQ_GT] = ACTIONS(4579),
    [anon_sym_switch] = ACTIONS(4579),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4579),
    [anon_sym_or] = ACTIONS(4577),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_from] = ACTIONS(4579),
    [anon_sym_join] = ACTIONS(4579),
    [anon_sym_on] = ACTIONS(4579),
    [anon_sym_equals] = ACTIONS(4579),
    [anon_sym_let] = ACTIONS(4579),
    [anon_sym_orderby] = ACTIONS(4579),
    [anon_sym_group] = ACTIONS(4579),
    [anon_sym_by] = ACTIONS(4579),
    [anon_sym_select] = ACTIONS(4579),
    [anon_sym_as] = ACTIONS(4579),
    [anon_sym_is] = ACTIONS(4579),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4579),
    [aux_sym_preproc_if_token3] = ACTIONS(4579),
    [aux_sym_preproc_else_token1] = ACTIONS(4579),
    [aux_sym_preproc_elif_token1] = ACTIONS(4579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3711] = {
    [sym_preproc_region] = STATE(3711),
    [sym_preproc_endregion] = STATE(3711),
    [sym_preproc_line] = STATE(3711),
    [sym_preproc_pragma] = STATE(3711),
    [sym_preproc_nullable] = STATE(3711),
    [sym_preproc_error] = STATE(3711),
    [sym_preproc_define] = STATE(3711),
    [sym_preproc_undef] = STATE(3711),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5622),
    [anon_sym_where] = ACTIONS(5620),
    [anon_sym_QMARK] = ACTIONS(5622),
    [anon_sym_BANG] = ACTIONS(5622),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_GT_GT] = ACTIONS(5622),
    [anon_sym_GT_GT_GT] = ACTIONS(5620),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_EQ_GT] = ACTIONS(5620),
    [anon_sym_switch] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5620),
    [anon_sym_and] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5622),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_QMARK_QMARK] = ACTIONS(5620),
    [anon_sym_from] = ACTIONS(5620),
    [anon_sym_into] = ACTIONS(5620),
    [anon_sym_join] = ACTIONS(5620),
    [anon_sym_on] = ACTIONS(5620),
    [anon_sym_equals] = ACTIONS(5620),
    [anon_sym_let] = ACTIONS(5620),
    [anon_sym_orderby] = ACTIONS(5620),
    [anon_sym_group] = ACTIONS(5620),
    [anon_sym_by] = ACTIONS(5620),
    [anon_sym_select] = ACTIONS(5620),
    [anon_sym_as] = ACTIONS(5620),
    [anon_sym_is] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [anon_sym_with] = ACTIONS(5620),
    [aux_sym_preproc_if_token3] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3712] = {
    [sym_preproc_region] = STATE(3712),
    [sym_preproc_endregion] = STATE(3712),
    [sym_preproc_line] = STATE(3712),
    [sym_preproc_pragma] = STATE(3712),
    [sym_preproc_nullable] = STATE(3712),
    [sym_preproc_error] = STATE(3712),
    [sym_preproc_define] = STATE(3712),
    [sym_preproc_undef] = STATE(3712),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5626),
    [anon_sym_where] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5626),
    [anon_sym_BANG] = ACTIONS(5626),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_CARET] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5624),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_GT_GT_GT] = ACTIONS(5624),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5624),
    [anon_sym_switch] = ACTIONS(5624),
    [anon_sym_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_QMARK_QMARK] = ACTIONS(5624),
    [anon_sym_from] = ACTIONS(5624),
    [anon_sym_into] = ACTIONS(5624),
    [anon_sym_join] = ACTIONS(5624),
    [anon_sym_on] = ACTIONS(5624),
    [anon_sym_equals] = ACTIONS(5624),
    [anon_sym_let] = ACTIONS(5624),
    [anon_sym_orderby] = ACTIONS(5624),
    [anon_sym_group] = ACTIONS(5624),
    [anon_sym_by] = ACTIONS(5624),
    [anon_sym_select] = ACTIONS(5624),
    [anon_sym_as] = ACTIONS(5624),
    [anon_sym_is] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [anon_sym_with] = ACTIONS(5624),
    [aux_sym_preproc_if_token3] = ACTIONS(5624),
    [aux_sym_preproc_else_token1] = ACTIONS(5624),
    [aux_sym_preproc_elif_token1] = ACTIONS(5624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3713] = {
    [sym_preproc_region] = STATE(3713),
    [sym_preproc_endregion] = STATE(3713),
    [sym_preproc_line] = STATE(3713),
    [sym_preproc_pragma] = STATE(3713),
    [sym_preproc_nullable] = STATE(3713),
    [sym_preproc_error] = STATE(3713),
    [sym_preproc_define] = STATE(3713),
    [sym_preproc_undef] = STATE(3713),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_where] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_BANG] = ACTIONS(5630),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_GT_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_switch] = ACTIONS(5628),
    [anon_sym_DOT_DOT] = ACTIONS(5628),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_QMARK_QMARK] = ACTIONS(5628),
    [anon_sym_from] = ACTIONS(5628),
    [anon_sym_into] = ACTIONS(5628),
    [anon_sym_join] = ACTIONS(5628),
    [anon_sym_on] = ACTIONS(5628),
    [anon_sym_equals] = ACTIONS(5628),
    [anon_sym_let] = ACTIONS(5628),
    [anon_sym_orderby] = ACTIONS(5628),
    [anon_sym_group] = ACTIONS(5628),
    [anon_sym_by] = ACTIONS(5628),
    [anon_sym_select] = ACTIONS(5628),
    [anon_sym_as] = ACTIONS(5628),
    [anon_sym_is] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [anon_sym_with] = ACTIONS(5628),
    [aux_sym_preproc_if_token3] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3714] = {
    [sym_preproc_region] = STATE(3714),
    [sym_preproc_endregion] = STATE(3714),
    [sym_preproc_line] = STATE(3714),
    [sym_preproc_pragma] = STATE(3714),
    [sym_preproc_nullable] = STATE(3714),
    [sym_preproc_error] = STATE(3714),
    [sym_preproc_define] = STATE(3714),
    [sym_preproc_undef] = STATE(3714),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_where] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5634),
    [anon_sym_BANG] = ACTIONS(5634),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5634),
    [anon_sym_GT_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_EQ_GT] = ACTIONS(5632),
    [anon_sym_switch] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_and] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5634),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_QMARK_QMARK] = ACTIONS(5632),
    [anon_sym_from] = ACTIONS(5632),
    [anon_sym_into] = ACTIONS(5632),
    [anon_sym_join] = ACTIONS(5632),
    [anon_sym_on] = ACTIONS(5632),
    [anon_sym_equals] = ACTIONS(5632),
    [anon_sym_let] = ACTIONS(5632),
    [anon_sym_orderby] = ACTIONS(5632),
    [anon_sym_group] = ACTIONS(5632),
    [anon_sym_by] = ACTIONS(5632),
    [anon_sym_select] = ACTIONS(5632),
    [anon_sym_as] = ACTIONS(5632),
    [anon_sym_is] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [anon_sym_with] = ACTIONS(5632),
    [aux_sym_preproc_if_token3] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5632),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3715] = {
    [sym_preproc_region] = STATE(3715),
    [sym_preproc_endregion] = STATE(3715),
    [sym_preproc_line] = STATE(3715),
    [sym_preproc_pragma] = STATE(3715),
    [sym_preproc_nullable] = STATE(3715),
    [sym_preproc_error] = STATE(3715),
    [sym_preproc_define] = STATE(3715),
    [sym_preproc_undef] = STATE(3715),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5638),
    [anon_sym_where] = ACTIONS(5636),
    [anon_sym_QMARK] = ACTIONS(5638),
    [anon_sym_BANG] = ACTIONS(5638),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_CARET] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5636),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_GT_GT_GT] = ACTIONS(5636),
    [anon_sym_EQ_EQ] = ACTIONS(5636),
    [anon_sym_BANG_EQ] = ACTIONS(5636),
    [anon_sym_GT_EQ] = ACTIONS(5636),
    [anon_sym_LT_EQ] = ACTIONS(5636),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5636),
    [anon_sym_switch] = ACTIONS(5636),
    [anon_sym_DOT_DOT] = ACTIONS(5636),
    [anon_sym_and] = ACTIONS(5636),
    [anon_sym_or] = ACTIONS(5638),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_QMARK_QMARK] = ACTIONS(5636),
    [anon_sym_from] = ACTIONS(5636),
    [anon_sym_into] = ACTIONS(5636),
    [anon_sym_join] = ACTIONS(5636),
    [anon_sym_on] = ACTIONS(5636),
    [anon_sym_equals] = ACTIONS(5636),
    [anon_sym_let] = ACTIONS(5636),
    [anon_sym_orderby] = ACTIONS(5636),
    [anon_sym_group] = ACTIONS(5636),
    [anon_sym_by] = ACTIONS(5636),
    [anon_sym_select] = ACTIONS(5636),
    [anon_sym_as] = ACTIONS(5636),
    [anon_sym_is] = ACTIONS(5636),
    [anon_sym_DASH_GT] = ACTIONS(5636),
    [anon_sym_with] = ACTIONS(5636),
    [aux_sym_preproc_if_token3] = ACTIONS(5636),
    [aux_sym_preproc_else_token1] = ACTIONS(5636),
    [aux_sym_preproc_elif_token1] = ACTIONS(5636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3716] = {
    [sym_preproc_region] = STATE(3716),
    [sym_preproc_endregion] = STATE(3716),
    [sym_preproc_line] = STATE(3716),
    [sym_preproc_pragma] = STATE(3716),
    [sym_preproc_nullable] = STATE(3716),
    [sym_preproc_error] = STATE(3716),
    [sym_preproc_define] = STATE(3716),
    [sym_preproc_undef] = STATE(3716),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4763),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_in] = ACTIONS(4765),
    [anon_sym_where] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_switch] = ACTIONS(4763),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4763),
    [anon_sym_or] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_from] = ACTIONS(4763),
    [anon_sym_into] = ACTIONS(4763),
    [anon_sym_join] = ACTIONS(4763),
    [anon_sym_on] = ACTIONS(4763),
    [anon_sym_equals] = ACTIONS(4763),
    [anon_sym_let] = ACTIONS(4763),
    [anon_sym_orderby] = ACTIONS(4763),
    [anon_sym_group] = ACTIONS(4763),
    [anon_sym_by] = ACTIONS(4763),
    [anon_sym_select] = ACTIONS(4763),
    [anon_sym_as] = ACTIONS(4763),
    [anon_sym_is] = ACTIONS(4763),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4763),
    [aux_sym_preproc_if_token3] = ACTIONS(4763),
    [aux_sym_preproc_else_token1] = ACTIONS(4763),
    [aux_sym_preproc_elif_token1] = ACTIONS(4763),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3717] = {
    [sym_preproc_region] = STATE(3717),
    [sym_preproc_endregion] = STATE(3717),
    [sym_preproc_line] = STATE(3717),
    [sym_preproc_pragma] = STATE(3717),
    [sym_preproc_nullable] = STATE(3717),
    [sym_preproc_error] = STATE(3717),
    [sym_preproc_define] = STATE(3717),
    [sym_preproc_undef] = STATE(3717),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5642),
    [anon_sym_where] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_BANG] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_GT_GT_GT] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_EQ_GT] = ACTIONS(5640),
    [anon_sym_switch] = ACTIONS(5640),
    [anon_sym_DOT_DOT] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_QMARK_QMARK] = ACTIONS(5640),
    [anon_sym_from] = ACTIONS(5640),
    [anon_sym_into] = ACTIONS(5640),
    [anon_sym_join] = ACTIONS(5640),
    [anon_sym_on] = ACTIONS(5640),
    [anon_sym_equals] = ACTIONS(5640),
    [anon_sym_let] = ACTIONS(5640),
    [anon_sym_orderby] = ACTIONS(5640),
    [anon_sym_group] = ACTIONS(5640),
    [anon_sym_by] = ACTIONS(5640),
    [anon_sym_select] = ACTIONS(5640),
    [anon_sym_as] = ACTIONS(5640),
    [anon_sym_is] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [anon_sym_with] = ACTIONS(5640),
    [aux_sym_preproc_if_token3] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3718] = {
    [sym_preproc_region] = STATE(3718),
    [sym_preproc_endregion] = STATE(3718),
    [sym_preproc_line] = STATE(3718),
    [sym_preproc_pragma] = STATE(3718),
    [sym_preproc_nullable] = STATE(3718),
    [sym_preproc_error] = STATE(3718),
    [sym_preproc_define] = STATE(3718),
    [sym_preproc_undef] = STATE(3718),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_LPAREN] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5646),
    [anon_sym_where] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_GT_GT_GT] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_EQ_GT] = ACTIONS(5644),
    [anon_sym_switch] = ACTIONS(5644),
    [anon_sym_DOT_DOT] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5646),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_QMARK_QMARK] = ACTIONS(5644),
    [anon_sym_from] = ACTIONS(5644),
    [anon_sym_into] = ACTIONS(5644),
    [anon_sym_join] = ACTIONS(5644),
    [anon_sym_on] = ACTIONS(5644),
    [anon_sym_equals] = ACTIONS(5644),
    [anon_sym_let] = ACTIONS(5644),
    [anon_sym_orderby] = ACTIONS(5644),
    [anon_sym_group] = ACTIONS(5644),
    [anon_sym_by] = ACTIONS(5644),
    [anon_sym_select] = ACTIONS(5644),
    [anon_sym_as] = ACTIONS(5644),
    [anon_sym_is] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [anon_sym_with] = ACTIONS(5644),
    [aux_sym_preproc_if_token3] = ACTIONS(5644),
    [aux_sym_preproc_else_token1] = ACTIONS(5644),
    [aux_sym_preproc_elif_token1] = ACTIONS(5644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3719] = {
    [sym_preproc_region] = STATE(3719),
    [sym_preproc_endregion] = STATE(3719),
    [sym_preproc_line] = STATE(3719),
    [sym_preproc_pragma] = STATE(3719),
    [sym_preproc_nullable] = STATE(3719),
    [sym_preproc_error] = STATE(3719),
    [sym_preproc_define] = STATE(3719),
    [sym_preproc_undef] = STATE(3719),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4431),
    [anon_sym_where] = ACTIONS(4431),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_switch] = ACTIONS(4431),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4431),
    [anon_sym_or] = ACTIONS(4429),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_from] = ACTIONS(4431),
    [anon_sym_join] = ACTIONS(4431),
    [anon_sym_on] = ACTIONS(4431),
    [anon_sym_equals] = ACTIONS(4431),
    [anon_sym_let] = ACTIONS(4431),
    [anon_sym_orderby] = ACTIONS(4431),
    [anon_sym_group] = ACTIONS(4431),
    [anon_sym_by] = ACTIONS(4431),
    [anon_sym_select] = ACTIONS(4431),
    [anon_sym_as] = ACTIONS(4431),
    [anon_sym_is] = ACTIONS(4431),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4431),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3720] = {
    [sym_preproc_region] = STATE(3720),
    [sym_preproc_endregion] = STATE(3720),
    [sym_preproc_line] = STATE(3720),
    [sym_preproc_pragma] = STATE(3720),
    [sym_preproc_nullable] = STATE(3720),
    [sym_preproc_error] = STATE(3720),
    [sym_preproc_define] = STATE(3720),
    [sym_preproc_undef] = STATE(3720),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_LPAREN] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_where] = ACTIONS(5648),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_BANG] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5650),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5650),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5650),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5650),
    [anon_sym_GT_GT_GT] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5650),
    [anon_sym_EQ_GT] = ACTIONS(5648),
    [anon_sym_switch] = ACTIONS(5648),
    [anon_sym_DOT_DOT] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5650),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_QMARK_QMARK] = ACTIONS(5648),
    [anon_sym_from] = ACTIONS(5648),
    [anon_sym_into] = ACTIONS(5648),
    [anon_sym_join] = ACTIONS(5648),
    [anon_sym_on] = ACTIONS(5648),
    [anon_sym_equals] = ACTIONS(5648),
    [anon_sym_let] = ACTIONS(5648),
    [anon_sym_orderby] = ACTIONS(5648),
    [anon_sym_group] = ACTIONS(5648),
    [anon_sym_by] = ACTIONS(5648),
    [anon_sym_select] = ACTIONS(5648),
    [anon_sym_as] = ACTIONS(5648),
    [anon_sym_is] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [anon_sym_with] = ACTIONS(5648),
    [aux_sym_preproc_if_token3] = ACTIONS(5648),
    [aux_sym_preproc_else_token1] = ACTIONS(5648),
    [aux_sym_preproc_elif_token1] = ACTIONS(5648),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3721] = {
    [sym_preproc_region] = STATE(3721),
    [sym_preproc_endregion] = STATE(3721),
    [sym_preproc_line] = STATE(3721),
    [sym_preproc_pragma] = STATE(3721),
    [sym_preproc_nullable] = STATE(3721),
    [sym_preproc_error] = STATE(3721),
    [sym_preproc_define] = STATE(3721),
    [sym_preproc_undef] = STATE(3721),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5294),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3722] = {
    [sym_preproc_region] = STATE(3722),
    [sym_preproc_endregion] = STATE(3722),
    [sym_preproc_line] = STATE(3722),
    [sym_preproc_pragma] = STATE(3722),
    [sym_preproc_nullable] = STATE(3722),
    [sym_preproc_error] = STATE(3722),
    [sym_preproc_define] = STATE(3722),
    [sym_preproc_undef] = STATE(3722),
    [anon_sym_SEMI] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COMMA] = ACTIONS(5652),
    [anon_sym_RBRACK] = ACTIONS(5652),
    [anon_sym_LPAREN] = ACTIONS(5652),
    [anon_sym_RPAREN] = ACTIONS(5652),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5654),
    [anon_sym_where] = ACTIONS(5652),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_BANG] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5652),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_GT_GT_GT] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5652),
    [anon_sym_BANG_EQ] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5652),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_EQ_GT] = ACTIONS(5652),
    [anon_sym_switch] = ACTIONS(5652),
    [anon_sym_DOT_DOT] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_or] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5652),
    [anon_sym_QMARK_QMARK] = ACTIONS(5652),
    [anon_sym_from] = ACTIONS(5652),
    [anon_sym_into] = ACTIONS(5652),
    [anon_sym_join] = ACTIONS(5652),
    [anon_sym_on] = ACTIONS(5652),
    [anon_sym_equals] = ACTIONS(5652),
    [anon_sym_let] = ACTIONS(5652),
    [anon_sym_orderby] = ACTIONS(5652),
    [anon_sym_group] = ACTIONS(5652),
    [anon_sym_by] = ACTIONS(5652),
    [anon_sym_select] = ACTIONS(5652),
    [anon_sym_as] = ACTIONS(5652),
    [anon_sym_is] = ACTIONS(5652),
    [anon_sym_DASH_GT] = ACTIONS(5652),
    [anon_sym_with] = ACTIONS(5652),
    [aux_sym_preproc_if_token3] = ACTIONS(5652),
    [aux_sym_preproc_else_token1] = ACTIONS(5652),
    [aux_sym_preproc_elif_token1] = ACTIONS(5652),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3723] = {
    [sym_preproc_region] = STATE(3723),
    [sym_preproc_endregion] = STATE(3723),
    [sym_preproc_line] = STATE(3723),
    [sym_preproc_pragma] = STATE(3723),
    [sym_preproc_nullable] = STATE(3723),
    [sym_preproc_error] = STATE(3723),
    [sym_preproc_define] = STATE(3723),
    [sym_preproc_undef] = STATE(3723),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_LPAREN] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LT] = ACTIONS(5658),
    [anon_sym_GT] = ACTIONS(5658),
    [anon_sym_in] = ACTIONS(5658),
    [anon_sym_where] = ACTIONS(5656),
    [anon_sym_QMARK] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5656),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_GT_GT_GT] = ACTIONS(5656),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5658),
    [anon_sym_EQ_GT] = ACTIONS(5656),
    [anon_sym_switch] = ACTIONS(5656),
    [anon_sym_DOT_DOT] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_QMARK_QMARK] = ACTIONS(5656),
    [anon_sym_from] = ACTIONS(5656),
    [anon_sym_into] = ACTIONS(5656),
    [anon_sym_join] = ACTIONS(5656),
    [anon_sym_on] = ACTIONS(5656),
    [anon_sym_equals] = ACTIONS(5656),
    [anon_sym_let] = ACTIONS(5656),
    [anon_sym_orderby] = ACTIONS(5656),
    [anon_sym_group] = ACTIONS(5656),
    [anon_sym_by] = ACTIONS(5656),
    [anon_sym_select] = ACTIONS(5656),
    [anon_sym_as] = ACTIONS(5656),
    [anon_sym_is] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [anon_sym_with] = ACTIONS(5656),
    [aux_sym_preproc_if_token3] = ACTIONS(5656),
    [aux_sym_preproc_else_token1] = ACTIONS(5656),
    [aux_sym_preproc_elif_token1] = ACTIONS(5656),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3724] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter] = STATE(8674),
    [sym__parameter_array] = STATE(8698),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6748),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3724),
    [sym_preproc_endregion] = STATE(3724),
    [sym_preproc_line] = STATE(3724),
    [sym_preproc_pragma] = STATE(3724),
    [sym_preproc_nullable] = STATE(3724),
    [sym_preproc_error] = STATE(3724),
    [sym_preproc_define] = STATE(3724),
    [sym_preproc_undef] = STATE(3724),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3725] = {
    [sym_preproc_region] = STATE(3725),
    [sym_preproc_endregion] = STATE(3725),
    [sym_preproc_line] = STATE(3725),
    [sym_preproc_pragma] = STATE(3725),
    [sym_preproc_nullable] = STATE(3725),
    [sym_preproc_error] = STATE(3725),
    [sym_preproc_define] = STATE(3725),
    [sym_preproc_undef] = STATE(3725),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_RBRACK] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_in] = ACTIONS(4500),
    [anon_sym_where] = ACTIONS(4500),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_switch] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4500),
    [anon_sym_or] = ACTIONS(4498),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_from] = ACTIONS(4500),
    [anon_sym_join] = ACTIONS(4500),
    [anon_sym_on] = ACTIONS(4500),
    [anon_sym_equals] = ACTIONS(4500),
    [anon_sym_let] = ACTIONS(4500),
    [anon_sym_orderby] = ACTIONS(4500),
    [anon_sym_group] = ACTIONS(4500),
    [anon_sym_by] = ACTIONS(4500),
    [anon_sym_select] = ACTIONS(4500),
    [anon_sym_as] = ACTIONS(4500),
    [anon_sym_is] = ACTIONS(4500),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4500),
    [aux_sym_preproc_if_token3] = ACTIONS(4500),
    [aux_sym_preproc_else_token1] = ACTIONS(4500),
    [aux_sym_preproc_elif_token1] = ACTIONS(4500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3726] = {
    [sym_preproc_region] = STATE(3726),
    [sym_preproc_endregion] = STATE(3726),
    [sym_preproc_line] = STATE(3726),
    [sym_preproc_pragma] = STATE(3726),
    [sym_preproc_nullable] = STATE(3726),
    [sym_preproc_error] = STATE(3726),
    [sym_preproc_define] = STATE(3726),
    [sym_preproc_undef] = STATE(3726),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_COMMA] = ACTIONS(5660),
    [anon_sym_RBRACK] = ACTIONS(5660),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5660),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5662),
    [anon_sym_in] = ACTIONS(5662),
    [anon_sym_where] = ACTIONS(5660),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_BANG] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5662),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5662),
    [anon_sym_GT_GT_GT] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5660),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_DOT] = ACTIONS(5662),
    [anon_sym_EQ_GT] = ACTIONS(5660),
    [anon_sym_switch] = ACTIONS(5660),
    [anon_sym_DOT_DOT] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_or] = ACTIONS(5662),
    [anon_sym_AMP_AMP] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5660),
    [anon_sym_QMARK_QMARK] = ACTIONS(5660),
    [anon_sym_from] = ACTIONS(5660),
    [anon_sym_into] = ACTIONS(5660),
    [anon_sym_join] = ACTIONS(5660),
    [anon_sym_on] = ACTIONS(5660),
    [anon_sym_equals] = ACTIONS(5660),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_orderby] = ACTIONS(5660),
    [anon_sym_group] = ACTIONS(5660),
    [anon_sym_by] = ACTIONS(5660),
    [anon_sym_select] = ACTIONS(5660),
    [anon_sym_as] = ACTIONS(5660),
    [anon_sym_is] = ACTIONS(5660),
    [anon_sym_DASH_GT] = ACTIONS(5660),
    [anon_sym_with] = ACTIONS(5660),
    [aux_sym_preproc_if_token3] = ACTIONS(5660),
    [aux_sym_preproc_else_token1] = ACTIONS(5660),
    [aux_sym_preproc_elif_token1] = ACTIONS(5660),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3727] = {
    [sym_preproc_region] = STATE(3727),
    [sym_preproc_endregion] = STATE(3727),
    [sym_preproc_line] = STATE(3727),
    [sym_preproc_pragma] = STATE(3727),
    [sym_preproc_nullable] = STATE(3727),
    [sym_preproc_error] = STATE(3727),
    [sym_preproc_define] = STATE(3727),
    [sym_preproc_undef] = STATE(3727),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5664),
    [anon_sym_COMMA] = ACTIONS(5664),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(5664),
    [anon_sym_RPAREN] = ACTIONS(5664),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_where] = ACTIONS(5664),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_BANG] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_PIPE] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_GT_GT_GT] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5664),
    [anon_sym_BANG_EQ] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5664),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_DOT] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5664),
    [anon_sym_switch] = ACTIONS(5664),
    [anon_sym_DOT_DOT] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5664),
    [anon_sym_QMARK_QMARK] = ACTIONS(5664),
    [anon_sym_from] = ACTIONS(5664),
    [anon_sym_into] = ACTIONS(5664),
    [anon_sym_join] = ACTIONS(5664),
    [anon_sym_on] = ACTIONS(5664),
    [anon_sym_equals] = ACTIONS(5664),
    [anon_sym_let] = ACTIONS(5664),
    [anon_sym_orderby] = ACTIONS(5664),
    [anon_sym_group] = ACTIONS(5664),
    [anon_sym_by] = ACTIONS(5664),
    [anon_sym_select] = ACTIONS(5664),
    [anon_sym_as] = ACTIONS(5664),
    [anon_sym_is] = ACTIONS(5664),
    [anon_sym_DASH_GT] = ACTIONS(5664),
    [anon_sym_with] = ACTIONS(5664),
    [aux_sym_preproc_if_token3] = ACTIONS(5664),
    [aux_sym_preproc_else_token1] = ACTIONS(5664),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3728] = {
    [sym_preproc_region] = STATE(3728),
    [sym_preproc_endregion] = STATE(3728),
    [sym_preproc_line] = STATE(3728),
    [sym_preproc_pragma] = STATE(3728),
    [sym_preproc_nullable] = STATE(3728),
    [sym_preproc_error] = STATE(3728),
    [sym_preproc_define] = STATE(3728),
    [sym_preproc_undef] = STATE(3728),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4144),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4142),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3729] = {
    [sym_preproc_region] = STATE(3729),
    [sym_preproc_endregion] = STATE(3729),
    [sym_preproc_line] = STATE(3729),
    [sym_preproc_pragma] = STATE(3729),
    [sym_preproc_nullable] = STATE(3729),
    [sym_preproc_error] = STATE(3729),
    [sym_preproc_define] = STATE(3729),
    [sym_preproc_undef] = STATE(3729),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_in] = ACTIONS(5670),
    [anon_sym_where] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_BANG] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_GT_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5670),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_QMARK_QMARK] = ACTIONS(5668),
    [anon_sym_from] = ACTIONS(5668),
    [anon_sym_into] = ACTIONS(5668),
    [anon_sym_join] = ACTIONS(5668),
    [anon_sym_on] = ACTIONS(5668),
    [anon_sym_equals] = ACTIONS(5668),
    [anon_sym_let] = ACTIONS(5668),
    [anon_sym_orderby] = ACTIONS(5668),
    [anon_sym_group] = ACTIONS(5668),
    [anon_sym_by] = ACTIONS(5668),
    [anon_sym_select] = ACTIONS(5668),
    [anon_sym_as] = ACTIONS(5668),
    [anon_sym_is] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [anon_sym_with] = ACTIONS(5668),
    [aux_sym_preproc_if_token3] = ACTIONS(5668),
    [aux_sym_preproc_else_token1] = ACTIONS(5668),
    [aux_sym_preproc_elif_token1] = ACTIONS(5668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3730] = {
    [sym_preproc_region] = STATE(3730),
    [sym_preproc_endregion] = STATE(3730),
    [sym_preproc_line] = STATE(3730),
    [sym_preproc_pragma] = STATE(3730),
    [sym_preproc_nullable] = STATE(3730),
    [sym_preproc_error] = STATE(3730),
    [sym_preproc_define] = STATE(3730),
    [sym_preproc_undef] = STATE(3730),
    [anon_sym_SEMI] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5672),
    [anon_sym_RPAREN] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5674),
    [anon_sym_where] = ACTIONS(5672),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5672),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_GT_GT_GT] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BANG_EQ] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5674),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_switch] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_or] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_from] = ACTIONS(5672),
    [anon_sym_into] = ACTIONS(5672),
    [anon_sym_join] = ACTIONS(5672),
    [anon_sym_on] = ACTIONS(5672),
    [anon_sym_equals] = ACTIONS(5672),
    [anon_sym_let] = ACTIONS(5672),
    [anon_sym_orderby] = ACTIONS(5672),
    [anon_sym_group] = ACTIONS(5672),
    [anon_sym_by] = ACTIONS(5672),
    [anon_sym_select] = ACTIONS(5672),
    [anon_sym_as] = ACTIONS(5672),
    [anon_sym_is] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_with] = ACTIONS(5672),
    [aux_sym_preproc_if_token3] = ACTIONS(5672),
    [aux_sym_preproc_else_token1] = ACTIONS(5672),
    [aux_sym_preproc_elif_token1] = ACTIONS(5672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3731] = {
    [sym_preproc_region] = STATE(3731),
    [sym_preproc_endregion] = STATE(3731),
    [sym_preproc_line] = STATE(3731),
    [sym_preproc_pragma] = STATE(3731),
    [sym_preproc_nullable] = STATE(3731),
    [sym_preproc_error] = STATE(3731),
    [sym_preproc_define] = STATE(3731),
    [sym_preproc_undef] = STATE(3731),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5678),
    [anon_sym_in] = ACTIONS(5678),
    [anon_sym_where] = ACTIONS(5676),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_GT_GT_GT] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_switch] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_or] = ACTIONS(5678),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_from] = ACTIONS(5676),
    [anon_sym_into] = ACTIONS(5676),
    [anon_sym_join] = ACTIONS(5676),
    [anon_sym_on] = ACTIONS(5676),
    [anon_sym_equals] = ACTIONS(5676),
    [anon_sym_let] = ACTIONS(5676),
    [anon_sym_orderby] = ACTIONS(5676),
    [anon_sym_group] = ACTIONS(5676),
    [anon_sym_by] = ACTIONS(5676),
    [anon_sym_select] = ACTIONS(5676),
    [anon_sym_as] = ACTIONS(5676),
    [anon_sym_is] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_with] = ACTIONS(5676),
    [aux_sym_preproc_if_token3] = ACTIONS(5676),
    [aux_sym_preproc_else_token1] = ACTIONS(5676),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3732] = {
    [sym_preproc_region] = STATE(3732),
    [sym_preproc_endregion] = STATE(3732),
    [sym_preproc_line] = STATE(3732),
    [sym_preproc_pragma] = STATE(3732),
    [sym_preproc_nullable] = STATE(3732),
    [sym_preproc_error] = STATE(3732),
    [sym_preproc_define] = STATE(3732),
    [sym_preproc_undef] = STATE(3732),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5294),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5294),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3733] = {
    [sym_preproc_region] = STATE(3733),
    [sym_preproc_endregion] = STATE(3733),
    [sym_preproc_line] = STATE(3733),
    [sym_preproc_pragma] = STATE(3733),
    [sym_preproc_nullable] = STATE(3733),
    [sym_preproc_error] = STATE(3733),
    [sym_preproc_define] = STATE(3733),
    [sym_preproc_undef] = STATE(3733),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_LPAREN] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5648),
    [anon_sym_where] = ACTIONS(5648),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_BANG] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5650),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5650),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5650),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5650),
    [anon_sym_GT_GT_GT] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5650),
    [anon_sym_EQ_GT] = ACTIONS(5648),
    [anon_sym_switch] = ACTIONS(5648),
    [anon_sym_DOT_DOT] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5650),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_QMARK_QMARK] = ACTIONS(5648),
    [anon_sym_from] = ACTIONS(5648),
    [anon_sym_join] = ACTIONS(5648),
    [anon_sym_on] = ACTIONS(5648),
    [anon_sym_equals] = ACTIONS(5648),
    [anon_sym_let] = ACTIONS(5648),
    [anon_sym_orderby] = ACTIONS(5648),
    [anon_sym_group] = ACTIONS(5648),
    [anon_sym_by] = ACTIONS(5648),
    [anon_sym_select] = ACTIONS(5648),
    [anon_sym_as] = ACTIONS(5648),
    [anon_sym_is] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [anon_sym_with] = ACTIONS(5648),
    [aux_sym_preproc_if_token3] = ACTIONS(5648),
    [aux_sym_preproc_else_token1] = ACTIONS(5648),
    [aux_sym_preproc_elif_token1] = ACTIONS(5648),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3734] = {
    [sym_preproc_region] = STATE(3734),
    [sym_preproc_endregion] = STATE(3734),
    [sym_preproc_line] = STATE(3734),
    [sym_preproc_pragma] = STATE(3734),
    [sym_preproc_nullable] = STATE(3734),
    [sym_preproc_error] = STATE(3734),
    [sym_preproc_define] = STATE(3734),
    [sym_preproc_undef] = STATE(3734),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(5423),
    [anon_sym_where] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_GT_GT] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5423),
    [anon_sym_DOT_DOT] = ACTIONS(5423),
    [anon_sym_and] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_QMARK_QMARK] = ACTIONS(5423),
    [anon_sym_from] = ACTIONS(5423),
    [anon_sym_join] = ACTIONS(5423),
    [anon_sym_on] = ACTIONS(5423),
    [anon_sym_equals] = ACTIONS(5423),
    [anon_sym_let] = ACTIONS(5423),
    [anon_sym_orderby] = ACTIONS(5423),
    [anon_sym_group] = ACTIONS(5423),
    [anon_sym_by] = ACTIONS(5423),
    [anon_sym_select] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_is] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_with] = ACTIONS(5423),
    [aux_sym_preproc_if_token3] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3735] = {
    [sym_preproc_region] = STATE(3735),
    [sym_preproc_endregion] = STATE(3735),
    [sym_preproc_line] = STATE(3735),
    [sym_preproc_pragma] = STATE(3735),
    [sym_preproc_nullable] = STATE(3735),
    [sym_preproc_error] = STATE(3735),
    [sym_preproc_define] = STATE(3735),
    [sym_preproc_undef] = STATE(3735),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2991),
    [anon_sym_where] = ACTIONS(2991),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2991),
    [anon_sym_or] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2991),
    [anon_sym_join] = ACTIONS(2991),
    [anon_sym_on] = ACTIONS(2991),
    [anon_sym_equals] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_orderby] = ACTIONS(2991),
    [anon_sym_group] = ACTIONS(2991),
    [anon_sym_by] = ACTIONS(2991),
    [anon_sym_select] = ACTIONS(2991),
    [anon_sym_as] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2991),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [aux_sym_preproc_if_token3] = ACTIONS(2991),
    [aux_sym_preproc_else_token1] = ACTIONS(2991),
    [aux_sym_preproc_elif_token1] = ACTIONS(2991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3736] = {
    [sym_preproc_region] = STATE(3736),
    [sym_preproc_endregion] = STATE(3736),
    [sym_preproc_line] = STATE(3736),
    [sym_preproc_pragma] = STATE(3736),
    [sym_preproc_nullable] = STATE(3736),
    [sym_preproc_error] = STATE(3736),
    [sym_preproc_define] = STATE(3736),
    [sym_preproc_undef] = STATE(3736),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5596),
    [anon_sym_RBRACK] = ACTIONS(5596),
    [anon_sym_LPAREN] = ACTIONS(5596),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5596),
    [anon_sym_where] = ACTIONS(5596),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_BANG] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5598),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_GT_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_DOT] = ACTIONS(5598),
    [anon_sym_EQ_GT] = ACTIONS(5596),
    [anon_sym_switch] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_or] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_QMARK_QMARK] = ACTIONS(5596),
    [anon_sym_from] = ACTIONS(5596),
    [anon_sym_join] = ACTIONS(5596),
    [anon_sym_on] = ACTIONS(5596),
    [anon_sym_equals] = ACTIONS(5596),
    [anon_sym_let] = ACTIONS(5596),
    [anon_sym_orderby] = ACTIONS(5596),
    [anon_sym_group] = ACTIONS(5596),
    [anon_sym_by] = ACTIONS(5596),
    [anon_sym_select] = ACTIONS(5596),
    [anon_sym_as] = ACTIONS(5596),
    [anon_sym_is] = ACTIONS(5596),
    [anon_sym_DASH_GT] = ACTIONS(5596),
    [anon_sym_with] = ACTIONS(5596),
    [aux_sym_preproc_if_token3] = ACTIONS(5596),
    [aux_sym_preproc_else_token1] = ACTIONS(5596),
    [aux_sym_preproc_elif_token1] = ACTIONS(5596),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3737] = {
    [sym_preproc_region] = STATE(3737),
    [sym_preproc_endregion] = STATE(3737),
    [sym_preproc_line] = STATE(3737),
    [sym_preproc_pragma] = STATE(3737),
    [sym_preproc_nullable] = STATE(3737),
    [sym_preproc_error] = STATE(3737),
    [sym_preproc_define] = STATE(3737),
    [sym_preproc_undef] = STATE(3737),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_where] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_from] = ACTIONS(5452),
    [anon_sym_join] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_let] = ACTIONS(5452),
    [anon_sym_orderby] = ACTIONS(5452),
    [anon_sym_group] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_select] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3738] = {
    [sym_preproc_region] = STATE(3738),
    [sym_preproc_endregion] = STATE(3738),
    [sym_preproc_line] = STATE(3738),
    [sym_preproc_pragma] = STATE(3738),
    [sym_preproc_nullable] = STATE(3738),
    [sym_preproc_error] = STATE(3738),
    [sym_preproc_define] = STATE(3738),
    [sym_preproc_undef] = STATE(3738),
    [anon_sym_SEMI] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COMMA] = ACTIONS(5652),
    [anon_sym_RBRACK] = ACTIONS(5652),
    [anon_sym_LPAREN] = ACTIONS(5652),
    [anon_sym_RPAREN] = ACTIONS(5652),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5652),
    [anon_sym_where] = ACTIONS(5652),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_BANG] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5652),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_GT_GT_GT] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5652),
    [anon_sym_BANG_EQ] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5652),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_EQ_GT] = ACTIONS(5652),
    [anon_sym_switch] = ACTIONS(5652),
    [anon_sym_DOT_DOT] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_or] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5652),
    [anon_sym_QMARK_QMARK] = ACTIONS(5652),
    [anon_sym_from] = ACTIONS(5652),
    [anon_sym_join] = ACTIONS(5652),
    [anon_sym_on] = ACTIONS(5652),
    [anon_sym_equals] = ACTIONS(5652),
    [anon_sym_let] = ACTIONS(5652),
    [anon_sym_orderby] = ACTIONS(5652),
    [anon_sym_group] = ACTIONS(5652),
    [anon_sym_by] = ACTIONS(5652),
    [anon_sym_select] = ACTIONS(5652),
    [anon_sym_as] = ACTIONS(5652),
    [anon_sym_is] = ACTIONS(5652),
    [anon_sym_DASH_GT] = ACTIONS(5652),
    [anon_sym_with] = ACTIONS(5652),
    [aux_sym_preproc_if_token3] = ACTIONS(5652),
    [aux_sym_preproc_else_token1] = ACTIONS(5652),
    [aux_sym_preproc_elif_token1] = ACTIONS(5652),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3739] = {
    [sym_preproc_region] = STATE(3739),
    [sym_preproc_endregion] = STATE(3739),
    [sym_preproc_line] = STATE(3739),
    [sym_preproc_pragma] = STATE(3739),
    [sym_preproc_nullable] = STATE(3739),
    [sym_preproc_error] = STATE(3739),
    [sym_preproc_define] = STATE(3739),
    [sym_preproc_undef] = STATE(3739),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_in] = ACTIONS(5668),
    [anon_sym_where] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_BANG] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_GT_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5670),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_QMARK_QMARK] = ACTIONS(5668),
    [anon_sym_from] = ACTIONS(5668),
    [anon_sym_join] = ACTIONS(5668),
    [anon_sym_on] = ACTIONS(5668),
    [anon_sym_equals] = ACTIONS(5668),
    [anon_sym_let] = ACTIONS(5668),
    [anon_sym_orderby] = ACTIONS(5668),
    [anon_sym_group] = ACTIONS(5668),
    [anon_sym_by] = ACTIONS(5668),
    [anon_sym_select] = ACTIONS(5668),
    [anon_sym_as] = ACTIONS(5668),
    [anon_sym_is] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [anon_sym_with] = ACTIONS(5668),
    [aux_sym_preproc_if_token3] = ACTIONS(5668),
    [aux_sym_preproc_else_token1] = ACTIONS(5668),
    [aux_sym_preproc_elif_token1] = ACTIONS(5668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3740] = {
    [sym_preproc_region] = STATE(3740),
    [sym_preproc_endregion] = STATE(3740),
    [sym_preproc_line] = STATE(3740),
    [sym_preproc_pragma] = STATE(3740),
    [sym_preproc_nullable] = STATE(3740),
    [sym_preproc_error] = STATE(3740),
    [sym_preproc_define] = STATE(3740),
    [sym_preproc_undef] = STATE(3740),
    [sym__identifier_token] = ACTIONS(5680),
    [anon_sym_extern] = ACTIONS(5680),
    [anon_sym_alias] = ACTIONS(5680),
    [anon_sym_global] = ACTIONS(5680),
    [anon_sym_unsafe] = ACTIONS(5680),
    [anon_sym_static] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_LPAREN] = ACTIONS(5682),
    [anon_sym_event] = ACTIONS(5680),
    [anon_sym_class] = ACTIONS(5680),
    [anon_sym_ref] = ACTIONS(5680),
    [anon_sym_struct] = ACTIONS(5680),
    [anon_sym_enum] = ACTIONS(5680),
    [anon_sym_interface] = ACTIONS(5680),
    [anon_sym_delegate] = ACTIONS(5680),
    [anon_sym_record] = ACTIONS(5680),
    [anon_sym_abstract] = ACTIONS(5680),
    [anon_sym_async] = ACTIONS(5680),
    [anon_sym_const] = ACTIONS(5680),
    [anon_sym_file] = ACTIONS(5680),
    [anon_sym_fixed] = ACTIONS(5680),
    [anon_sym_internal] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(5680),
    [anon_sym_override] = ACTIONS(5680),
    [anon_sym_partial] = ACTIONS(5680),
    [anon_sym_private] = ACTIONS(5680),
    [anon_sym_protected] = ACTIONS(5680),
    [anon_sym_public] = ACTIONS(5680),
    [anon_sym_readonly] = ACTIONS(5680),
    [anon_sym_required] = ACTIONS(5680),
    [anon_sym_sealed] = ACTIONS(5680),
    [anon_sym_virtual] = ACTIONS(5680),
    [anon_sym_volatile] = ACTIONS(5680),
    [anon_sym_where] = ACTIONS(5680),
    [anon_sym_notnull] = ACTIONS(5680),
    [anon_sym_unmanaged] = ACTIONS(5680),
    [anon_sym_TILDE] = ACTIONS(5682),
    [anon_sym_implicit] = ACTIONS(5680),
    [anon_sym_explicit] = ACTIONS(5680),
    [anon_sym_scoped] = ACTIONS(5680),
    [anon_sym_var] = ACTIONS(5680),
    [sym_predefined_type] = ACTIONS(5680),
    [anon_sym_yield] = ACTIONS(5680),
    [anon_sym_when] = ACTIONS(5680),
    [anon_sym_from] = ACTIONS(5680),
    [anon_sym_into] = ACTIONS(5680),
    [anon_sym_join] = ACTIONS(5680),
    [anon_sym_on] = ACTIONS(5680),
    [anon_sym_equals] = ACTIONS(5680),
    [anon_sym_let] = ACTIONS(5680),
    [anon_sym_orderby] = ACTIONS(5680),
    [anon_sym_ascending] = ACTIONS(5680),
    [anon_sym_descending] = ACTIONS(5680),
    [anon_sym_group] = ACTIONS(5680),
    [anon_sym_by] = ACTIONS(5680),
    [anon_sym_select] = ACTIONS(5680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3741] = {
    [sym_preproc_region] = STATE(3741),
    [sym_preproc_endregion] = STATE(3741),
    [sym_preproc_line] = STATE(3741),
    [sym_preproc_pragma] = STATE(3741),
    [sym_preproc_nullable] = STATE(3741),
    [sym_preproc_error] = STATE(3741),
    [sym_preproc_define] = STATE(3741),
    [sym_preproc_undef] = STATE(3741),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COMMA] = ACTIONS(5600),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LPAREN] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5600),
    [anon_sym_where] = ACTIONS(5600),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_BANG] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_SLASH] = ACTIONS(5602),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_GT_GT_GT] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5600),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_DOT] = ACTIONS(5602),
    [anon_sym_EQ_GT] = ACTIONS(5600),
    [anon_sym_switch] = ACTIONS(5600),
    [anon_sym_DOT_DOT] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_or] = ACTIONS(5602),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE] = ACTIONS(5600),
    [anon_sym_QMARK_QMARK] = ACTIONS(5600),
    [anon_sym_from] = ACTIONS(5600),
    [anon_sym_join] = ACTIONS(5600),
    [anon_sym_on] = ACTIONS(5600),
    [anon_sym_equals] = ACTIONS(5600),
    [anon_sym_let] = ACTIONS(5600),
    [anon_sym_orderby] = ACTIONS(5600),
    [anon_sym_group] = ACTIONS(5600),
    [anon_sym_by] = ACTIONS(5600),
    [anon_sym_select] = ACTIONS(5600),
    [anon_sym_as] = ACTIONS(5600),
    [anon_sym_is] = ACTIONS(5600),
    [anon_sym_DASH_GT] = ACTIONS(5600),
    [anon_sym_with] = ACTIONS(5600),
    [aux_sym_preproc_if_token3] = ACTIONS(5600),
    [aux_sym_preproc_else_token1] = ACTIONS(5600),
    [aux_sym_preproc_elif_token1] = ACTIONS(5600),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3742] = {
    [sym_preproc_region] = STATE(3742),
    [sym_preproc_endregion] = STATE(3742),
    [sym_preproc_line] = STATE(3742),
    [sym_preproc_pragma] = STATE(3742),
    [sym_preproc_nullable] = STATE(3742),
    [sym_preproc_error] = STATE(3742),
    [sym_preproc_define] = STATE(3742),
    [sym_preproc_undef] = STATE(3742),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_COMMA] = ACTIONS(5660),
    [anon_sym_RBRACK] = ACTIONS(5660),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5660),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5662),
    [anon_sym_in] = ACTIONS(5660),
    [anon_sym_where] = ACTIONS(5660),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_BANG] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5662),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5662),
    [anon_sym_GT_GT_GT] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5660),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_DOT] = ACTIONS(5662),
    [anon_sym_EQ_GT] = ACTIONS(5660),
    [anon_sym_switch] = ACTIONS(5660),
    [anon_sym_DOT_DOT] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_or] = ACTIONS(5662),
    [anon_sym_AMP_AMP] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5660),
    [anon_sym_QMARK_QMARK] = ACTIONS(5660),
    [anon_sym_from] = ACTIONS(5660),
    [anon_sym_join] = ACTIONS(5660),
    [anon_sym_on] = ACTIONS(5660),
    [anon_sym_equals] = ACTIONS(5660),
    [anon_sym_let] = ACTIONS(5660),
    [anon_sym_orderby] = ACTIONS(5660),
    [anon_sym_group] = ACTIONS(5660),
    [anon_sym_by] = ACTIONS(5660),
    [anon_sym_select] = ACTIONS(5660),
    [anon_sym_as] = ACTIONS(5660),
    [anon_sym_is] = ACTIONS(5660),
    [anon_sym_DASH_GT] = ACTIONS(5660),
    [anon_sym_with] = ACTIONS(5660),
    [aux_sym_preproc_if_token3] = ACTIONS(5660),
    [aux_sym_preproc_else_token1] = ACTIONS(5660),
    [aux_sym_preproc_elif_token1] = ACTIONS(5660),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3743] = {
    [sym_preproc_region] = STATE(3743),
    [sym_preproc_endregion] = STATE(3743),
    [sym_preproc_line] = STATE(3743),
    [sym_preproc_pragma] = STATE(3743),
    [sym_preproc_nullable] = STATE(3743),
    [sym_preproc_error] = STATE(3743),
    [sym_preproc_define] = STATE(3743),
    [sym_preproc_undef] = STATE(3743),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_where] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5588),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_from] = ACTIONS(5586),
    [anon_sym_join] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_let] = ACTIONS(5586),
    [anon_sym_orderby] = ACTIONS(5586),
    [anon_sym_group] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_select] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3744] = {
    [sym_preproc_region] = STATE(3744),
    [sym_preproc_endregion] = STATE(3744),
    [sym_preproc_line] = STATE(3744),
    [sym_preproc_pragma] = STATE(3744),
    [sym_preproc_nullable] = STATE(3744),
    [sym_preproc_error] = STATE(3744),
    [sym_preproc_define] = STATE(3744),
    [sym_preproc_undef] = STATE(3744),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5566),
    [anon_sym_where] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_BANG] = ACTIONS(5568),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_GT_GT_GT] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_EQ_GT] = ACTIONS(5566),
    [anon_sym_switch] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_and] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_QMARK_QMARK] = ACTIONS(5566),
    [anon_sym_from] = ACTIONS(5566),
    [anon_sym_join] = ACTIONS(5566),
    [anon_sym_on] = ACTIONS(5566),
    [anon_sym_equals] = ACTIONS(5566),
    [anon_sym_let] = ACTIONS(5566),
    [anon_sym_orderby] = ACTIONS(5566),
    [anon_sym_group] = ACTIONS(5566),
    [anon_sym_by] = ACTIONS(5566),
    [anon_sym_select] = ACTIONS(5566),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_is] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [anon_sym_with] = ACTIONS(5566),
    [aux_sym_preproc_if_token3] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3745] = {
    [sym_preproc_region] = STATE(3745),
    [sym_preproc_endregion] = STATE(3745),
    [sym_preproc_line] = STATE(3745),
    [sym_preproc_pragma] = STATE(3745),
    [sym_preproc_nullable] = STATE(3745),
    [sym_preproc_error] = STATE(3745),
    [sym_preproc_define] = STATE(3745),
    [sym_preproc_undef] = STATE(3745),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_in] = ACTIONS(5419),
    [anon_sym_where] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5419),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5419),
    [anon_sym_CARET] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5419),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5419),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5419),
    [anon_sym_DOT_DOT] = ACTIONS(5419),
    [anon_sym_and] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_QMARK_QMARK] = ACTIONS(5419),
    [anon_sym_from] = ACTIONS(5419),
    [anon_sym_join] = ACTIONS(5419),
    [anon_sym_on] = ACTIONS(5419),
    [anon_sym_equals] = ACTIONS(5419),
    [anon_sym_let] = ACTIONS(5419),
    [anon_sym_orderby] = ACTIONS(5419),
    [anon_sym_group] = ACTIONS(5419),
    [anon_sym_by] = ACTIONS(5419),
    [anon_sym_select] = ACTIONS(5419),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_with] = ACTIONS(5419),
    [aux_sym_preproc_if_token3] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3746] = {
    [sym_preproc_region] = STATE(3746),
    [sym_preproc_endregion] = STATE(3746),
    [sym_preproc_line] = STATE(3746),
    [sym_preproc_pragma] = STATE(3746),
    [sym_preproc_nullable] = STATE(3746),
    [sym_preproc_error] = STATE(3746),
    [sym_preproc_define] = STATE(3746),
    [sym_preproc_undef] = STATE(3746),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_where] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5446),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_from] = ACTIONS(5444),
    [anon_sym_join] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_let] = ACTIONS(5444),
    [anon_sym_orderby] = ACTIONS(5444),
    [anon_sym_group] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_select] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3747] = {
    [sym_preproc_region] = STATE(3747),
    [sym_preproc_endregion] = STATE(3747),
    [sym_preproc_line] = STATE(3747),
    [sym_preproc_pragma] = STATE(3747),
    [sym_preproc_nullable] = STATE(3747),
    [sym_preproc_error] = STATE(3747),
    [sym_preproc_define] = STATE(3747),
    [sym_preproc_undef] = STATE(3747),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_where] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_from] = ACTIONS(5407),
    [anon_sym_join] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_let] = ACTIONS(5407),
    [anon_sym_orderby] = ACTIONS(5407),
    [anon_sym_group] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_select] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3748] = {
    [sym_preproc_region] = STATE(3748),
    [sym_preproc_endregion] = STATE(3748),
    [sym_preproc_line] = STATE(3748),
    [sym_preproc_pragma] = STATE(3748),
    [sym_preproc_nullable] = STATE(3748),
    [sym_preproc_error] = STATE(3748),
    [sym_preproc_define] = STATE(3748),
    [sym_preproc_undef] = STATE(3748),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_where] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_from] = ACTIONS(5482),
    [anon_sym_join] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_let] = ACTIONS(5482),
    [anon_sym_orderby] = ACTIONS(5482),
    [anon_sym_group] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_select] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3749] = {
    [sym_preproc_region] = STATE(3749),
    [sym_preproc_endregion] = STATE(3749),
    [sym_preproc_line] = STATE(3749),
    [sym_preproc_pragma] = STATE(3749),
    [sym_preproc_nullable] = STATE(3749),
    [sym_preproc_error] = STATE(3749),
    [sym_preproc_define] = STATE(3749),
    [sym_preproc_undef] = STATE(3749),
    [anon_sym_SEMI] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5672),
    [anon_sym_RPAREN] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5672),
    [anon_sym_where] = ACTIONS(5672),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5672),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_GT_GT_GT] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BANG_EQ] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5674),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_switch] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_or] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_from] = ACTIONS(5672),
    [anon_sym_join] = ACTIONS(5672),
    [anon_sym_on] = ACTIONS(5672),
    [anon_sym_equals] = ACTIONS(5672),
    [anon_sym_let] = ACTIONS(5672),
    [anon_sym_orderby] = ACTIONS(5672),
    [anon_sym_group] = ACTIONS(5672),
    [anon_sym_by] = ACTIONS(5672),
    [anon_sym_select] = ACTIONS(5672),
    [anon_sym_as] = ACTIONS(5672),
    [anon_sym_is] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_with] = ACTIONS(5672),
    [aux_sym_preproc_if_token3] = ACTIONS(5672),
    [aux_sym_preproc_else_token1] = ACTIONS(5672),
    [aux_sym_preproc_elif_token1] = ACTIONS(5672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3750] = {
    [sym_preproc_region] = STATE(3750),
    [sym_preproc_endregion] = STATE(3750),
    [sym_preproc_line] = STATE(3750),
    [sym_preproc_pragma] = STATE(3750),
    [sym_preproc_nullable] = STATE(3750),
    [sym_preproc_error] = STATE(3750),
    [sym_preproc_define] = STATE(3750),
    [sym_preproc_undef] = STATE(3750),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5440),
    [anon_sym_where] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5442),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_from] = ACTIONS(5440),
    [anon_sym_join] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_let] = ACTIONS(5440),
    [anon_sym_orderby] = ACTIONS(5440),
    [anon_sym_group] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_select] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3751] = {
    [sym_preproc_region] = STATE(3751),
    [sym_preproc_endregion] = STATE(3751),
    [sym_preproc_line] = STATE(3751),
    [sym_preproc_pragma] = STATE(3751),
    [sym_preproc_nullable] = STATE(3751),
    [sym_preproc_error] = STATE(3751),
    [sym_preproc_define] = STATE(3751),
    [sym_preproc_undef] = STATE(3751),
    [anon_sym_SEMI] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_RBRACK] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5562),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5562),
    [anon_sym_where] = ACTIONS(5562),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5562),
    [anon_sym_DASH_DASH] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_CARET] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_GT_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5562),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_GT_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5562),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5562),
    [anon_sym_switch] = ACTIONS(5562),
    [anon_sym_DOT_DOT] = ACTIONS(5562),
    [anon_sym_and] = ACTIONS(5562),
    [anon_sym_or] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_QMARK_QMARK] = ACTIONS(5562),
    [anon_sym_from] = ACTIONS(5562),
    [anon_sym_join] = ACTIONS(5562),
    [anon_sym_on] = ACTIONS(5562),
    [anon_sym_equals] = ACTIONS(5562),
    [anon_sym_let] = ACTIONS(5562),
    [anon_sym_orderby] = ACTIONS(5562),
    [anon_sym_group] = ACTIONS(5562),
    [anon_sym_by] = ACTIONS(5562),
    [anon_sym_select] = ACTIONS(5562),
    [anon_sym_as] = ACTIONS(5562),
    [anon_sym_is] = ACTIONS(5562),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_with] = ACTIONS(5562),
    [aux_sym_preproc_if_token3] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3752] = {
    [sym_preproc_region] = STATE(3752),
    [sym_preproc_endregion] = STATE(3752),
    [sym_preproc_line] = STATE(3752),
    [sym_preproc_pragma] = STATE(3752),
    [sym_preproc_nullable] = STATE(3752),
    [sym_preproc_error] = STATE(3752),
    [sym_preproc_define] = STATE(3752),
    [sym_preproc_undef] = STATE(3752),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_LPAREN] = ACTIONS(4801),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_where] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(4804),
    [anon_sym_BANG] = ACTIONS(4804),
    [anon_sym_PLUS_PLUS] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4801),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(4804),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_CARET] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_GT_GT_GT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4801),
    [anon_sym_BANG_EQ] = ACTIONS(4801),
    [anon_sym_GT_EQ] = ACTIONS(4801),
    [anon_sym_LT_EQ] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_switch] = ACTIONS(4801),
    [anon_sym_DOT_DOT] = ACTIONS(4801),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4807),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE] = ACTIONS(4801),
    [anon_sym_QMARK_QMARK] = ACTIONS(4804),
    [anon_sym_from] = ACTIONS(4799),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_join] = ACTIONS(4799),
    [anon_sym_let] = ACTIONS(4799),
    [anon_sym_orderby] = ACTIONS(4799),
    [anon_sym_group] = ACTIONS(4799),
    [anon_sym_select] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(4801),
    [anon_sym_is] = ACTIONS(4801),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3753] = {
    [sym_preproc_region] = STATE(3753),
    [sym_preproc_endregion] = STATE(3753),
    [sym_preproc_line] = STATE(3753),
    [sym_preproc_pragma] = STATE(3753),
    [sym_preproc_nullable] = STATE(3753),
    [sym_preproc_error] = STATE(3753),
    [sym_preproc_define] = STATE(3753),
    [sym_preproc_undef] = STATE(3753),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_where] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_BANG] = ACTIONS(5466),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_SLASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5464),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_GT_GT_GT] = ACTIONS(5464),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_EQ_GT] = ACTIONS(5464),
    [anon_sym_switch] = ACTIONS(5464),
    [anon_sym_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_QMARK_QMARK] = ACTIONS(5464),
    [anon_sym_from] = ACTIONS(5464),
    [anon_sym_join] = ACTIONS(5464),
    [anon_sym_on] = ACTIONS(5464),
    [anon_sym_equals] = ACTIONS(5464),
    [anon_sym_let] = ACTIONS(5464),
    [anon_sym_orderby] = ACTIONS(5464),
    [anon_sym_group] = ACTIONS(5464),
    [anon_sym_by] = ACTIONS(5464),
    [anon_sym_select] = ACTIONS(5464),
    [anon_sym_as] = ACTIONS(5464),
    [anon_sym_is] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_with] = ACTIONS(5464),
    [aux_sym_preproc_if_token3] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3754] = {
    [sym_preproc_region] = STATE(3754),
    [sym_preproc_endregion] = STATE(3754),
    [sym_preproc_line] = STATE(3754),
    [sym_preproc_pragma] = STATE(3754),
    [sym_preproc_nullable] = STATE(3754),
    [sym_preproc_error] = STATE(3754),
    [sym_preproc_define] = STATE(3754),
    [sym_preproc_undef] = STATE(3754),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4763),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_in] = ACTIONS(4763),
    [anon_sym_where] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_switch] = ACTIONS(4763),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4763),
    [anon_sym_or] = ACTIONS(4765),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_from] = ACTIONS(4763),
    [anon_sym_join] = ACTIONS(4763),
    [anon_sym_on] = ACTIONS(4763),
    [anon_sym_equals] = ACTIONS(4763),
    [anon_sym_let] = ACTIONS(4763),
    [anon_sym_orderby] = ACTIONS(4763),
    [anon_sym_group] = ACTIONS(4763),
    [anon_sym_by] = ACTIONS(4763),
    [anon_sym_select] = ACTIONS(4763),
    [anon_sym_as] = ACTIONS(4763),
    [anon_sym_is] = ACTIONS(4763),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4763),
    [aux_sym_preproc_if_token3] = ACTIONS(4763),
    [aux_sym_preproc_else_token1] = ACTIONS(4763),
    [aux_sym_preproc_elif_token1] = ACTIONS(4763),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3755] = {
    [sym_preproc_region] = STATE(3755),
    [sym_preproc_endregion] = STATE(3755),
    [sym_preproc_line] = STATE(3755),
    [sym_preproc_pragma] = STATE(3755),
    [sym_preproc_nullable] = STATE(3755),
    [sym_preproc_error] = STATE(3755),
    [sym_preproc_define] = STATE(3755),
    [sym_preproc_undef] = STATE(3755),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COMMA] = ACTIONS(5534),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5536),
    [anon_sym_GT] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5534),
    [anon_sym_where] = ACTIONS(5534),
    [anon_sym_QMARK] = ACTIONS(5536),
    [anon_sym_BANG] = ACTIONS(5536),
    [anon_sym_PLUS_PLUS] = ACTIONS(5534),
    [anon_sym_DASH_DASH] = ACTIONS(5534),
    [anon_sym_PLUS] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_SLASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_CARET] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_GT_GT_GT] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_BANG_EQ] = ACTIONS(5534),
    [anon_sym_GT_EQ] = ACTIONS(5534),
    [anon_sym_LT_EQ] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(5536),
    [anon_sym_EQ_GT] = ACTIONS(5534),
    [anon_sym_switch] = ACTIONS(5534),
    [anon_sym_DOT_DOT] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5534),
    [anon_sym_or] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK] = ACTIONS(5534),
    [anon_sym_from] = ACTIONS(5534),
    [anon_sym_join] = ACTIONS(5534),
    [anon_sym_on] = ACTIONS(5534),
    [anon_sym_equals] = ACTIONS(5534),
    [anon_sym_let] = ACTIONS(5534),
    [anon_sym_orderby] = ACTIONS(5534),
    [anon_sym_group] = ACTIONS(5534),
    [anon_sym_by] = ACTIONS(5534),
    [anon_sym_select] = ACTIONS(5534),
    [anon_sym_as] = ACTIONS(5534),
    [anon_sym_is] = ACTIONS(5534),
    [anon_sym_DASH_GT] = ACTIONS(5534),
    [anon_sym_with] = ACTIONS(5534),
    [aux_sym_preproc_if_token3] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3756] = {
    [sym_preproc_region] = STATE(3756),
    [sym_preproc_endregion] = STATE(3756),
    [sym_preproc_line] = STATE(3756),
    [sym_preproc_pragma] = STATE(3756),
    [sym_preproc_nullable] = STATE(3756),
    [sym_preproc_error] = STATE(3756),
    [sym_preproc_define] = STATE(3756),
    [sym_preproc_undef] = STATE(3756),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COMMA] = ACTIONS(5399),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [anon_sym_RPAREN] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5401),
    [anon_sym_in] = ACTIONS(5399),
    [anon_sym_where] = ACTIONS(5399),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5401),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5401),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5401),
    [anon_sym_GT_GT_GT] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5399),
    [anon_sym_BANG_EQ] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5399),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_DOT] = ACTIONS(5401),
    [anon_sym_EQ_GT] = ACTIONS(5399),
    [anon_sym_switch] = ACTIONS(5399),
    [anon_sym_DOT_DOT] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_or] = ACTIONS(5401),
    [anon_sym_AMP_AMP] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5399),
    [anon_sym_QMARK_QMARK] = ACTIONS(5399),
    [anon_sym_from] = ACTIONS(5399),
    [anon_sym_join] = ACTIONS(5399),
    [anon_sym_on] = ACTIONS(5399),
    [anon_sym_equals] = ACTIONS(5399),
    [anon_sym_let] = ACTIONS(5399),
    [anon_sym_orderby] = ACTIONS(5399),
    [anon_sym_group] = ACTIONS(5399),
    [anon_sym_by] = ACTIONS(5399),
    [anon_sym_select] = ACTIONS(5399),
    [anon_sym_as] = ACTIONS(5399),
    [anon_sym_is] = ACTIONS(5399),
    [anon_sym_DASH_GT] = ACTIONS(5399),
    [anon_sym_with] = ACTIONS(5399),
    [aux_sym_preproc_if_token3] = ACTIONS(5399),
    [aux_sym_preproc_else_token1] = ACTIONS(5399),
    [aux_sym_preproc_elif_token1] = ACTIONS(5399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3757] = {
    [sym_preproc_region] = STATE(3757),
    [sym_preproc_endregion] = STATE(3757),
    [sym_preproc_line] = STATE(3757),
    [sym_preproc_pragma] = STATE(3757),
    [sym_preproc_nullable] = STATE(3757),
    [sym_preproc_error] = STATE(3757),
    [sym_preproc_define] = STATE(3757),
    [sym_preproc_undef] = STATE(3757),
    [anon_sym_SEMI] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_COLON] = ACTIONS(5415),
    [anon_sym_COMMA] = ACTIONS(5415),
    [anon_sym_RBRACK] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_in] = ACTIONS(5415),
    [anon_sym_where] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_BANG] = ACTIONS(5417),
    [anon_sym_PLUS_PLUS] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5415),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5415),
    [anon_sym_CARET] = ACTIONS(5415),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5415),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_GT_GT_GT] = ACTIONS(5415),
    [anon_sym_EQ_EQ] = ACTIONS(5415),
    [anon_sym_BANG_EQ] = ACTIONS(5415),
    [anon_sym_GT_EQ] = ACTIONS(5415),
    [anon_sym_LT_EQ] = ACTIONS(5415),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_EQ_GT] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_DOT_DOT] = ACTIONS(5415),
    [anon_sym_and] = ACTIONS(5415),
    [anon_sym_or] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5415),
    [anon_sym_PIPE_PIPE] = ACTIONS(5415),
    [anon_sym_QMARK_QMARK] = ACTIONS(5415),
    [anon_sym_from] = ACTIONS(5415),
    [anon_sym_join] = ACTIONS(5415),
    [anon_sym_on] = ACTIONS(5415),
    [anon_sym_equals] = ACTIONS(5415),
    [anon_sym_let] = ACTIONS(5415),
    [anon_sym_orderby] = ACTIONS(5415),
    [anon_sym_group] = ACTIONS(5415),
    [anon_sym_by] = ACTIONS(5415),
    [anon_sym_select] = ACTIONS(5415),
    [anon_sym_as] = ACTIONS(5415),
    [anon_sym_is] = ACTIONS(5415),
    [anon_sym_DASH_GT] = ACTIONS(5415),
    [anon_sym_with] = ACTIONS(5415),
    [aux_sym_preproc_if_token3] = ACTIONS(5415),
    [aux_sym_preproc_else_token1] = ACTIONS(5415),
    [aux_sym_preproc_elif_token1] = ACTIONS(5415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3758] = {
    [sym_preproc_region] = STATE(3758),
    [sym_preproc_endregion] = STATE(3758),
    [sym_preproc_line] = STATE(3758),
    [sym_preproc_pragma] = STATE(3758),
    [sym_preproc_nullable] = STATE(3758),
    [sym_preproc_error] = STATE(3758),
    [sym_preproc_define] = STATE(3758),
    [sym_preproc_undef] = STATE(3758),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4482),
    [anon_sym_where] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4480),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_from] = ACTIONS(4482),
    [anon_sym_join] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_let] = ACTIONS(4482),
    [anon_sym_orderby] = ACTIONS(4482),
    [anon_sym_group] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_select] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3759] = {
    [sym_preproc_region] = STATE(3759),
    [sym_preproc_endregion] = STATE(3759),
    [sym_preproc_line] = STATE(3759),
    [sym_preproc_pragma] = STATE(3759),
    [sym_preproc_nullable] = STATE(3759),
    [sym_preproc_error] = STATE(3759),
    [sym_preproc_define] = STATE(3759),
    [sym_preproc_undef] = STATE(3759),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5506),
    [anon_sym_where] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_from] = ACTIONS(5506),
    [anon_sym_join] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_let] = ACTIONS(5506),
    [anon_sym_orderby] = ACTIONS(5506),
    [anon_sym_group] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_select] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3760] = {
    [sym_preproc_region] = STATE(3760),
    [sym_preproc_endregion] = STATE(3760),
    [sym_preproc_line] = STATE(3760),
    [sym_preproc_pragma] = STATE(3760),
    [sym_preproc_nullable] = STATE(3760),
    [sym_preproc_error] = STATE(3760),
    [sym_preproc_define] = STATE(3760),
    [sym_preproc_undef] = STATE(3760),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5624),
    [anon_sym_where] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5626),
    [anon_sym_BANG] = ACTIONS(5626),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_CARET] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5624),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_GT_GT_GT] = ACTIONS(5624),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5624),
    [anon_sym_switch] = ACTIONS(5624),
    [anon_sym_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_QMARK_QMARK] = ACTIONS(5624),
    [anon_sym_from] = ACTIONS(5624),
    [anon_sym_join] = ACTIONS(5624),
    [anon_sym_on] = ACTIONS(5624),
    [anon_sym_equals] = ACTIONS(5624),
    [anon_sym_let] = ACTIONS(5624),
    [anon_sym_orderby] = ACTIONS(5624),
    [anon_sym_group] = ACTIONS(5624),
    [anon_sym_by] = ACTIONS(5624),
    [anon_sym_select] = ACTIONS(5624),
    [anon_sym_as] = ACTIONS(5624),
    [anon_sym_is] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [anon_sym_with] = ACTIONS(5624),
    [aux_sym_preproc_if_token3] = ACTIONS(5624),
    [aux_sym_preproc_else_token1] = ACTIONS(5624),
    [aux_sym_preproc_elif_token1] = ACTIONS(5624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3761] = {
    [sym_preproc_region] = STATE(3761),
    [sym_preproc_endregion] = STATE(3761),
    [sym_preproc_line] = STATE(3761),
    [sym_preproc_pragma] = STATE(3761),
    [sym_preproc_nullable] = STATE(3761),
    [sym_preproc_error] = STATE(3761),
    [sym_preproc_define] = STATE(3761),
    [sym_preproc_undef] = STATE(3761),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_where] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_from] = ACTIONS(5514),
    [anon_sym_join] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_let] = ACTIONS(5514),
    [anon_sym_orderby] = ACTIONS(5514),
    [anon_sym_group] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_select] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3762] = {
    [sym_modifier] = STATE(3802),
    [sym_preproc_region] = STATE(3762),
    [sym_preproc_endregion] = STATE(3762),
    [sym_preproc_line] = STATE(3762),
    [sym_preproc_pragma] = STATE(3762),
    [sym_preproc_nullable] = STATE(3762),
    [sym_preproc_error] = STATE(3762),
    [sym_preproc_define] = STATE(3762),
    [sym_preproc_undef] = STATE(3762),
    [aux_sym_class_declaration_repeat2] = STATE(3762),
    [sym__identifier_token] = ACTIONS(5686),
    [anon_sym_extern] = ACTIONS(5688),
    [anon_sym_alias] = ACTIONS(5686),
    [anon_sym_global] = ACTIONS(5686),
    [anon_sym_unsafe] = ACTIONS(5688),
    [anon_sym_static] = ACTIONS(5688),
    [anon_sym_LPAREN] = ACTIONS(5691),
    [anon_sym_event] = ACTIONS(5686),
    [anon_sym_class] = ACTIONS(5686),
    [anon_sym_ref] = ACTIONS(5686),
    [anon_sym_struct] = ACTIONS(5686),
    [anon_sym_enum] = ACTIONS(5686),
    [anon_sym_interface] = ACTIONS(5686),
    [anon_sym_delegate] = ACTIONS(5686),
    [anon_sym_record] = ACTIONS(5686),
    [anon_sym_abstract] = ACTIONS(5688),
    [anon_sym_async] = ACTIONS(5688),
    [anon_sym_const] = ACTIONS(5688),
    [anon_sym_file] = ACTIONS(5688),
    [anon_sym_fixed] = ACTIONS(5688),
    [anon_sym_internal] = ACTIONS(5688),
    [anon_sym_new] = ACTIONS(5688),
    [anon_sym_override] = ACTIONS(5688),
    [anon_sym_partial] = ACTIONS(5688),
    [anon_sym_private] = ACTIONS(5688),
    [anon_sym_protected] = ACTIONS(5688),
    [anon_sym_public] = ACTIONS(5688),
    [anon_sym_readonly] = ACTIONS(5688),
    [anon_sym_required] = ACTIONS(5688),
    [anon_sym_sealed] = ACTIONS(5688),
    [anon_sym_virtual] = ACTIONS(5688),
    [anon_sym_volatile] = ACTIONS(5688),
    [anon_sym_where] = ACTIONS(5686),
    [anon_sym_notnull] = ACTIONS(5686),
    [anon_sym_unmanaged] = ACTIONS(5686),
    [anon_sym_implicit] = ACTIONS(5686),
    [anon_sym_explicit] = ACTIONS(5686),
    [anon_sym_scoped] = ACTIONS(5686),
    [anon_sym_var] = ACTIONS(5686),
    [sym_predefined_type] = ACTIONS(5686),
    [anon_sym_yield] = ACTIONS(5686),
    [anon_sym_when] = ACTIONS(5686),
    [anon_sym_from] = ACTIONS(5686),
    [anon_sym_into] = ACTIONS(5686),
    [anon_sym_join] = ACTIONS(5686),
    [anon_sym_on] = ACTIONS(5686),
    [anon_sym_equals] = ACTIONS(5686),
    [anon_sym_let] = ACTIONS(5686),
    [anon_sym_orderby] = ACTIONS(5686),
    [anon_sym_ascending] = ACTIONS(5686),
    [anon_sym_descending] = ACTIONS(5686),
    [anon_sym_group] = ACTIONS(5686),
    [anon_sym_by] = ACTIONS(5686),
    [anon_sym_select] = ACTIONS(5686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3763] = {
    [sym_preproc_region] = STATE(3763),
    [sym_preproc_endregion] = STATE(3763),
    [sym_preproc_line] = STATE(3763),
    [sym_preproc_pragma] = STATE(3763),
    [sym_preproc_nullable] = STATE(3763),
    [sym_preproc_error] = STATE(3763),
    [sym_preproc_define] = STATE(3763),
    [sym_preproc_undef] = STATE(3763),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5664),
    [anon_sym_COMMA] = ACTIONS(5664),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(5664),
    [anon_sym_RPAREN] = ACTIONS(5664),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5664),
    [anon_sym_where] = ACTIONS(5664),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_BANG] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_PIPE] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_GT_GT_GT] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5664),
    [anon_sym_BANG_EQ] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5664),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_DOT] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5664),
    [anon_sym_switch] = ACTIONS(5664),
    [anon_sym_DOT_DOT] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_or] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5664),
    [anon_sym_QMARK_QMARK] = ACTIONS(5664),
    [anon_sym_from] = ACTIONS(5664),
    [anon_sym_join] = ACTIONS(5664),
    [anon_sym_on] = ACTIONS(5664),
    [anon_sym_equals] = ACTIONS(5664),
    [anon_sym_let] = ACTIONS(5664),
    [anon_sym_orderby] = ACTIONS(5664),
    [anon_sym_group] = ACTIONS(5664),
    [anon_sym_by] = ACTIONS(5664),
    [anon_sym_select] = ACTIONS(5664),
    [anon_sym_as] = ACTIONS(5664),
    [anon_sym_is] = ACTIONS(5664),
    [anon_sym_DASH_GT] = ACTIONS(5664),
    [anon_sym_with] = ACTIONS(5664),
    [aux_sym_preproc_if_token3] = ACTIONS(5664),
    [aux_sym_preproc_else_token1] = ACTIONS(5664),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3764] = {
    [sym_preproc_region] = STATE(3764),
    [sym_preproc_endregion] = STATE(3764),
    [sym_preproc_line] = STATE(3764),
    [sym_preproc_pragma] = STATE(3764),
    [sym_preproc_nullable] = STATE(3764),
    [sym_preproc_error] = STATE(3764),
    [sym_preproc_define] = STATE(3764),
    [sym_preproc_undef] = STATE(3764),
    [anon_sym_SEMI] = ACTIONS(5612),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COMMA] = ACTIONS(5612),
    [anon_sym_RBRACK] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(5612),
    [anon_sym_RPAREN] = ACTIONS(5612),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5614),
    [anon_sym_GT] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5612),
    [anon_sym_where] = ACTIONS(5612),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_BANG] = ACTIONS(5614),
    [anon_sym_PLUS_PLUS] = ACTIONS(5612),
    [anon_sym_DASH_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5614),
    [anon_sym_DASH] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_PIPE] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5614),
    [anon_sym_GT_GT_GT] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5612),
    [anon_sym_BANG_EQ] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5612),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(5614),
    [anon_sym_EQ_GT] = ACTIONS(5612),
    [anon_sym_switch] = ACTIONS(5612),
    [anon_sym_DOT_DOT] = ACTIONS(5612),
    [anon_sym_and] = ACTIONS(5612),
    [anon_sym_or] = ACTIONS(5614),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5612),
    [anon_sym_QMARK_QMARK] = ACTIONS(5612),
    [anon_sym_from] = ACTIONS(5612),
    [anon_sym_join] = ACTIONS(5612),
    [anon_sym_on] = ACTIONS(5612),
    [anon_sym_equals] = ACTIONS(5612),
    [anon_sym_let] = ACTIONS(5612),
    [anon_sym_orderby] = ACTIONS(5612),
    [anon_sym_group] = ACTIONS(5612),
    [anon_sym_by] = ACTIONS(5612),
    [anon_sym_select] = ACTIONS(5612),
    [anon_sym_as] = ACTIONS(5612),
    [anon_sym_is] = ACTIONS(5612),
    [anon_sym_DASH_GT] = ACTIONS(5612),
    [anon_sym_with] = ACTIONS(5612),
    [aux_sym_preproc_if_token3] = ACTIONS(5612),
    [aux_sym_preproc_else_token1] = ACTIONS(5612),
    [aux_sym_preproc_elif_token1] = ACTIONS(5612),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3765] = {
    [sym_preproc_region] = STATE(3765),
    [sym_preproc_endregion] = STATE(3765),
    [sym_preproc_line] = STATE(3765),
    [sym_preproc_pragma] = STATE(3765),
    [sym_preproc_nullable] = STATE(3765),
    [sym_preproc_error] = STATE(3765),
    [sym_preproc_define] = STATE(3765),
    [sym_preproc_undef] = STATE(3765),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_where] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_BANG] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_EQ_GT] = ACTIONS(5500),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_from] = ACTIONS(5500),
    [anon_sym_join] = ACTIONS(5500),
    [anon_sym_on] = ACTIONS(5500),
    [anon_sym_equals] = ACTIONS(5500),
    [anon_sym_let] = ACTIONS(5500),
    [anon_sym_orderby] = ACTIONS(5500),
    [anon_sym_group] = ACTIONS(5500),
    [anon_sym_by] = ACTIONS(5500),
    [anon_sym_select] = ACTIONS(5500),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3766] = {
    [sym_preproc_region] = STATE(3766),
    [sym_preproc_endregion] = STATE(3766),
    [sym_preproc_line] = STATE(3766),
    [sym_preproc_pragma] = STATE(3766),
    [sym_preproc_nullable] = STATE(3766),
    [sym_preproc_error] = STATE(3766),
    [sym_preproc_define] = STATE(3766),
    [sym_preproc_undef] = STATE(3766),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5578),
    [anon_sym_COMMA] = ACTIONS(5578),
    [anon_sym_RBRACK] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(5578),
    [anon_sym_RPAREN] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5580),
    [anon_sym_in] = ACTIONS(5578),
    [anon_sym_where] = ACTIONS(5578),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_BANG] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5578),
    [anon_sym_SLASH] = ACTIONS(5580),
    [anon_sym_PERCENT] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5580),
    [anon_sym_LT_LT] = ACTIONS(5578),
    [anon_sym_GT_GT] = ACTIONS(5580),
    [anon_sym_GT_GT_GT] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5578),
    [anon_sym_BANG_EQ] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5578),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(5580),
    [anon_sym_EQ_GT] = ACTIONS(5578),
    [anon_sym_switch] = ACTIONS(5578),
    [anon_sym_DOT_DOT] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_or] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE] = ACTIONS(5578),
    [anon_sym_QMARK_QMARK] = ACTIONS(5578),
    [anon_sym_from] = ACTIONS(5578),
    [anon_sym_join] = ACTIONS(5578),
    [anon_sym_on] = ACTIONS(5578),
    [anon_sym_equals] = ACTIONS(5578),
    [anon_sym_let] = ACTIONS(5578),
    [anon_sym_orderby] = ACTIONS(5578),
    [anon_sym_group] = ACTIONS(5578),
    [anon_sym_by] = ACTIONS(5578),
    [anon_sym_select] = ACTIONS(5578),
    [anon_sym_as] = ACTIONS(5578),
    [anon_sym_is] = ACTIONS(5578),
    [anon_sym_DASH_GT] = ACTIONS(5578),
    [anon_sym_with] = ACTIONS(5578),
    [aux_sym_preproc_if_token3] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3767] = {
    [sym_preproc_region] = STATE(3767),
    [sym_preproc_endregion] = STATE(3767),
    [sym_preproc_line] = STATE(3767),
    [sym_preproc_pragma] = STATE(3767),
    [sym_preproc_nullable] = STATE(3767),
    [sym_preproc_error] = STATE(3767),
    [sym_preproc_define] = STATE(3767),
    [sym_preproc_undef] = STATE(3767),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5437),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(4453),
    [anon_sym_join] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_let] = ACTIONS(4453),
    [anon_sym_orderby] = ACTIONS(4453),
    [anon_sym_group] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_select] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3768] = {
    [sym_preproc_region] = STATE(3768),
    [sym_preproc_endregion] = STATE(3768),
    [sym_preproc_line] = STATE(3768),
    [sym_preproc_pragma] = STATE(3768),
    [sym_preproc_nullable] = STATE(3768),
    [sym_preproc_error] = STATE(3768),
    [sym_preproc_define] = STATE(3768),
    [sym_preproc_undef] = STATE(3768),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_where] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_from] = ACTIONS(5510),
    [anon_sym_join] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_let] = ACTIONS(5510),
    [anon_sym_orderby] = ACTIONS(5510),
    [anon_sym_group] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_select] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3769] = {
    [sym_preproc_region] = STATE(3769),
    [sym_preproc_endregion] = STATE(3769),
    [sym_preproc_line] = STATE(3769),
    [sym_preproc_pragma] = STATE(3769),
    [sym_preproc_nullable] = STATE(3769),
    [sym_preproc_error] = STATE(3769),
    [sym_preproc_define] = STATE(3769),
    [sym_preproc_undef] = STATE(3769),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_where] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5450),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_from] = ACTIONS(5448),
    [anon_sym_join] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_let] = ACTIONS(5448),
    [anon_sym_orderby] = ACTIONS(5448),
    [anon_sym_group] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_select] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3770] = {
    [sym_preproc_region] = STATE(3770),
    [sym_preproc_endregion] = STATE(3770),
    [sym_preproc_line] = STATE(3770),
    [sym_preproc_pragma] = STATE(3770),
    [sym_preproc_nullable] = STATE(3770),
    [sym_preproc_error] = STATE(3770),
    [sym_preproc_define] = STATE(3770),
    [sym_preproc_undef] = STATE(3770),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5632),
    [anon_sym_where] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5634),
    [anon_sym_BANG] = ACTIONS(5634),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5634),
    [anon_sym_GT_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_EQ_GT] = ACTIONS(5632),
    [anon_sym_switch] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_and] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5634),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_QMARK_QMARK] = ACTIONS(5632),
    [anon_sym_from] = ACTIONS(5632),
    [anon_sym_join] = ACTIONS(5632),
    [anon_sym_on] = ACTIONS(5632),
    [anon_sym_equals] = ACTIONS(5632),
    [anon_sym_let] = ACTIONS(5632),
    [anon_sym_orderby] = ACTIONS(5632),
    [anon_sym_group] = ACTIONS(5632),
    [anon_sym_by] = ACTIONS(5632),
    [anon_sym_select] = ACTIONS(5632),
    [anon_sym_as] = ACTIONS(5632),
    [anon_sym_is] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [anon_sym_with] = ACTIONS(5632),
    [aux_sym_preproc_if_token3] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5632),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3771] = {
    [sym_preproc_region] = STATE(3771),
    [sym_preproc_endregion] = STATE(3771),
    [sym_preproc_line] = STATE(3771),
    [sym_preproc_pragma] = STATE(3771),
    [sym_preproc_nullable] = STATE(3771),
    [sym_preproc_error] = STATE(3771),
    [sym_preproc_define] = STATE(3771),
    [sym_preproc_undef] = STATE(3771),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_where] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5472),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_GT_GT_GT] = ACTIONS(5472),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_EQ_GT] = ACTIONS(5472),
    [anon_sym_switch] = ACTIONS(5472),
    [anon_sym_DOT_DOT] = ACTIONS(5472),
    [anon_sym_and] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_QMARK_QMARK] = ACTIONS(5472),
    [anon_sym_from] = ACTIONS(5472),
    [anon_sym_join] = ACTIONS(5472),
    [anon_sym_on] = ACTIONS(5472),
    [anon_sym_equals] = ACTIONS(5472),
    [anon_sym_let] = ACTIONS(5472),
    [anon_sym_orderby] = ACTIONS(5472),
    [anon_sym_group] = ACTIONS(5472),
    [anon_sym_by] = ACTIONS(5472),
    [anon_sym_select] = ACTIONS(5472),
    [anon_sym_as] = ACTIONS(5472),
    [anon_sym_is] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_with] = ACTIONS(5472),
    [aux_sym_preproc_if_token3] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5472),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3772] = {
    [sym_preproc_region] = STATE(3772),
    [sym_preproc_endregion] = STATE(3772),
    [sym_preproc_line] = STATE(3772),
    [sym_preproc_pragma] = STATE(3772),
    [sym_preproc_nullable] = STATE(3772),
    [sym_preproc_error] = STATE(3772),
    [sym_preproc_define] = STATE(3772),
    [sym_preproc_undef] = STATE(3772),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5620),
    [anon_sym_where] = ACTIONS(5620),
    [anon_sym_QMARK] = ACTIONS(5622),
    [anon_sym_BANG] = ACTIONS(5622),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_GT_GT] = ACTIONS(5622),
    [anon_sym_GT_GT_GT] = ACTIONS(5620),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_EQ_GT] = ACTIONS(5620),
    [anon_sym_switch] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5620),
    [anon_sym_and] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5622),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_QMARK_QMARK] = ACTIONS(5620),
    [anon_sym_from] = ACTIONS(5620),
    [anon_sym_join] = ACTIONS(5620),
    [anon_sym_on] = ACTIONS(5620),
    [anon_sym_equals] = ACTIONS(5620),
    [anon_sym_let] = ACTIONS(5620),
    [anon_sym_orderby] = ACTIONS(5620),
    [anon_sym_group] = ACTIONS(5620),
    [anon_sym_by] = ACTIONS(5620),
    [anon_sym_select] = ACTIONS(5620),
    [anon_sym_as] = ACTIONS(5620),
    [anon_sym_is] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [anon_sym_with] = ACTIONS(5620),
    [aux_sym_preproc_if_token3] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3773] = {
    [sym_preproc_region] = STATE(3773),
    [sym_preproc_endregion] = STATE(3773),
    [sym_preproc_line] = STATE(3773),
    [sym_preproc_pragma] = STATE(3773),
    [sym_preproc_nullable] = STATE(3773),
    [sym_preproc_error] = STATE(3773),
    [sym_preproc_define] = STATE(3773),
    [sym_preproc_undef] = STATE(3773),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym_LBRACK] = ACTIONS(5476),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_RBRACK] = ACTIONS(5476),
    [anon_sym_LPAREN] = ACTIONS(5476),
    [anon_sym_RPAREN] = ACTIONS(5476),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5476),
    [anon_sym_where] = ACTIONS(5476),
    [anon_sym_QMARK] = ACTIONS(5478),
    [anon_sym_BANG] = ACTIONS(5478),
    [anon_sym_PLUS_PLUS] = ACTIONS(5476),
    [anon_sym_DASH_DASH] = ACTIONS(5476),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_CARET] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5476),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_GT_GT_GT] = ACTIONS(5476),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5476),
    [anon_sym_GT_EQ] = ACTIONS(5476),
    [anon_sym_LT_EQ] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_EQ_GT] = ACTIONS(5476),
    [anon_sym_switch] = ACTIONS(5476),
    [anon_sym_DOT_DOT] = ACTIONS(5476),
    [anon_sym_and] = ACTIONS(5476),
    [anon_sym_or] = ACTIONS(5478),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_PIPE_PIPE] = ACTIONS(5476),
    [anon_sym_QMARK_QMARK] = ACTIONS(5476),
    [anon_sym_from] = ACTIONS(5476),
    [anon_sym_join] = ACTIONS(5476),
    [anon_sym_on] = ACTIONS(5476),
    [anon_sym_equals] = ACTIONS(5476),
    [anon_sym_let] = ACTIONS(5476),
    [anon_sym_orderby] = ACTIONS(5476),
    [anon_sym_group] = ACTIONS(5476),
    [anon_sym_by] = ACTIONS(5476),
    [anon_sym_select] = ACTIONS(5476),
    [anon_sym_as] = ACTIONS(5476),
    [anon_sym_is] = ACTIONS(5476),
    [anon_sym_DASH_GT] = ACTIONS(5476),
    [anon_sym_with] = ACTIONS(5476),
    [aux_sym_preproc_if_token3] = ACTIONS(5476),
    [aux_sym_preproc_else_token1] = ACTIONS(5476),
    [aux_sym_preproc_elif_token1] = ACTIONS(5476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3774] = {
    [sym_preproc_region] = STATE(3774),
    [sym_preproc_endregion] = STATE(3774),
    [sym_preproc_line] = STATE(3774),
    [sym_preproc_pragma] = STATE(3774),
    [sym_preproc_nullable] = STATE(3774),
    [sym_preproc_error] = STATE(3774),
    [sym_preproc_define] = STATE(3774),
    [sym_preproc_undef] = STATE(3774),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_COLON] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2999),
    [anon_sym_where] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_EQ_GT] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_DOT_DOT] = ACTIONS(2999),
    [anon_sym_and] = ACTIONS(2999),
    [anon_sym_or] = ACTIONS(2997),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_from] = ACTIONS(2999),
    [anon_sym_join] = ACTIONS(2999),
    [anon_sym_on] = ACTIONS(2999),
    [anon_sym_equals] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_orderby] = ACTIONS(2999),
    [anon_sym_group] = ACTIONS(2999),
    [anon_sym_by] = ACTIONS(2999),
    [anon_sym_select] = ACTIONS(2999),
    [anon_sym_as] = ACTIONS(2999),
    [anon_sym_is] = ACTIONS(2999),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [aux_sym_preproc_if_token3] = ACTIONS(2999),
    [aux_sym_preproc_else_token1] = ACTIONS(2999),
    [aux_sym_preproc_elif_token1] = ACTIONS(2999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3775] = {
    [sym_preproc_region] = STATE(3775),
    [sym_preproc_endregion] = STATE(3775),
    [sym_preproc_line] = STATE(3775),
    [sym_preproc_pragma] = STATE(3775),
    [sym_preproc_nullable] = STATE(3775),
    [sym_preproc_error] = STATE(3775),
    [sym_preproc_define] = STATE(3775),
    [sym_preproc_undef] = STATE(3775),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5678),
    [anon_sym_in] = ACTIONS(5676),
    [anon_sym_where] = ACTIONS(5676),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_GT_GT_GT] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_switch] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_or] = ACTIONS(5678),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_from] = ACTIONS(5676),
    [anon_sym_join] = ACTIONS(5676),
    [anon_sym_on] = ACTIONS(5676),
    [anon_sym_equals] = ACTIONS(5676),
    [anon_sym_let] = ACTIONS(5676),
    [anon_sym_orderby] = ACTIONS(5676),
    [anon_sym_group] = ACTIONS(5676),
    [anon_sym_by] = ACTIONS(5676),
    [anon_sym_select] = ACTIONS(5676),
    [anon_sym_as] = ACTIONS(5676),
    [anon_sym_is] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_with] = ACTIONS(5676),
    [aux_sym_preproc_if_token3] = ACTIONS(5676),
    [aux_sym_preproc_else_token1] = ACTIONS(5676),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3776] = {
    [sym_preproc_region] = STATE(3776),
    [sym_preproc_endregion] = STATE(3776),
    [sym_preproc_line] = STATE(3776),
    [sym_preproc_pragma] = STATE(3776),
    [sym_preproc_nullable] = STATE(3776),
    [sym_preproc_error] = STATE(3776),
    [sym_preproc_define] = STATE(3776),
    [sym_preproc_undef] = STATE(3776),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_where] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_BANG] = ACTIONS(5630),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_GT_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_switch] = ACTIONS(5628),
    [anon_sym_DOT_DOT] = ACTIONS(5628),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_QMARK_QMARK] = ACTIONS(5628),
    [anon_sym_from] = ACTIONS(5628),
    [anon_sym_join] = ACTIONS(5628),
    [anon_sym_on] = ACTIONS(5628),
    [anon_sym_equals] = ACTIONS(5628),
    [anon_sym_let] = ACTIONS(5628),
    [anon_sym_orderby] = ACTIONS(5628),
    [anon_sym_group] = ACTIONS(5628),
    [anon_sym_by] = ACTIONS(5628),
    [anon_sym_select] = ACTIONS(5628),
    [anon_sym_as] = ACTIONS(5628),
    [anon_sym_is] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [anon_sym_with] = ACTIONS(5628),
    [aux_sym_preproc_if_token3] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3777] = {
    [sym_preproc_region] = STATE(3777),
    [sym_preproc_endregion] = STATE(3777),
    [sym_preproc_line] = STATE(3777),
    [sym_preproc_pragma] = STATE(3777),
    [sym_preproc_nullable] = STATE(3777),
    [sym_preproc_error] = STATE(3777),
    [sym_preproc_define] = STATE(3777),
    [sym_preproc_undef] = STATE(3777),
    [anon_sym_EQ] = ACTIONS(5693),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5695),
    [anon_sym_DASH_EQ] = ACTIONS(5695),
    [anon_sym_STAR_EQ] = ACTIONS(5695),
    [anon_sym_SLASH_EQ] = ACTIONS(5695),
    [anon_sym_PERCENT_EQ] = ACTIONS(5695),
    [anon_sym_AMP_EQ] = ACTIONS(5695),
    [anon_sym_CARET_EQ] = ACTIONS(5695),
    [anon_sym_PIPE_EQ] = ACTIONS(5695),
    [anon_sym_LT_LT_EQ] = ACTIONS(5695),
    [anon_sym_GT_GT_EQ] = ACTIONS(5695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5695),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3778] = {
    [sym_preproc_region] = STATE(3778),
    [sym_preproc_endregion] = STATE(3778),
    [sym_preproc_line] = STATE(3778),
    [sym_preproc_pragma] = STATE(3778),
    [sym_preproc_nullable] = STATE(3778),
    [sym_preproc_error] = STATE(3778),
    [sym_preproc_define] = STATE(3778),
    [sym_preproc_undef] = STATE(3778),
    [sym__identifier_token] = ACTIONS(5697),
    [anon_sym_extern] = ACTIONS(5697),
    [anon_sym_alias] = ACTIONS(5697),
    [anon_sym_global] = ACTIONS(5697),
    [anon_sym_unsafe] = ACTIONS(5697),
    [anon_sym_static] = ACTIONS(5697),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_LPAREN] = ACTIONS(5699),
    [anon_sym_event] = ACTIONS(5697),
    [anon_sym_class] = ACTIONS(5697),
    [anon_sym_ref] = ACTIONS(5697),
    [anon_sym_struct] = ACTIONS(5697),
    [anon_sym_enum] = ACTIONS(5697),
    [anon_sym_interface] = ACTIONS(5697),
    [anon_sym_delegate] = ACTIONS(5697),
    [anon_sym_record] = ACTIONS(5697),
    [anon_sym_abstract] = ACTIONS(5697),
    [anon_sym_async] = ACTIONS(5697),
    [anon_sym_const] = ACTIONS(5697),
    [anon_sym_file] = ACTIONS(5697),
    [anon_sym_fixed] = ACTIONS(5697),
    [anon_sym_internal] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5697),
    [anon_sym_override] = ACTIONS(5697),
    [anon_sym_partial] = ACTIONS(5697),
    [anon_sym_private] = ACTIONS(5697),
    [anon_sym_protected] = ACTIONS(5697),
    [anon_sym_public] = ACTIONS(5697),
    [anon_sym_readonly] = ACTIONS(5697),
    [anon_sym_required] = ACTIONS(5697),
    [anon_sym_sealed] = ACTIONS(5697),
    [anon_sym_virtual] = ACTIONS(5697),
    [anon_sym_volatile] = ACTIONS(5697),
    [anon_sym_where] = ACTIONS(5697),
    [anon_sym_notnull] = ACTIONS(5697),
    [anon_sym_unmanaged] = ACTIONS(5697),
    [anon_sym_TILDE] = ACTIONS(5699),
    [anon_sym_implicit] = ACTIONS(5697),
    [anon_sym_explicit] = ACTIONS(5697),
    [anon_sym_scoped] = ACTIONS(5697),
    [anon_sym_var] = ACTIONS(5697),
    [sym_predefined_type] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5697),
    [anon_sym_when] = ACTIONS(5697),
    [anon_sym_from] = ACTIONS(5697),
    [anon_sym_into] = ACTIONS(5697),
    [anon_sym_join] = ACTIONS(5697),
    [anon_sym_on] = ACTIONS(5697),
    [anon_sym_equals] = ACTIONS(5697),
    [anon_sym_let] = ACTIONS(5697),
    [anon_sym_orderby] = ACTIONS(5697),
    [anon_sym_ascending] = ACTIONS(5697),
    [anon_sym_descending] = ACTIONS(5697),
    [anon_sym_group] = ACTIONS(5697),
    [anon_sym_by] = ACTIONS(5697),
    [anon_sym_select] = ACTIONS(5697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3779] = {
    [sym_preproc_region] = STATE(3779),
    [sym_preproc_endregion] = STATE(3779),
    [sym_preproc_line] = STATE(3779),
    [sym_preproc_pragma] = STATE(3779),
    [sym_preproc_nullable] = STATE(3779),
    [sym_preproc_error] = STATE(3779),
    [sym_preproc_define] = STATE(3779),
    [sym_preproc_undef] = STATE(3779),
    [sym__identifier_token] = ACTIONS(5701),
    [anon_sym_extern] = ACTIONS(5701),
    [anon_sym_alias] = ACTIONS(5701),
    [anon_sym_global] = ACTIONS(5701),
    [anon_sym_unsafe] = ACTIONS(5701),
    [anon_sym_static] = ACTIONS(5701),
    [anon_sym_LBRACK] = ACTIONS(5703),
    [anon_sym_LPAREN] = ACTIONS(5703),
    [anon_sym_event] = ACTIONS(5701),
    [anon_sym_class] = ACTIONS(5701),
    [anon_sym_ref] = ACTIONS(5701),
    [anon_sym_struct] = ACTIONS(5701),
    [anon_sym_enum] = ACTIONS(5701),
    [anon_sym_interface] = ACTIONS(5701),
    [anon_sym_delegate] = ACTIONS(5701),
    [anon_sym_record] = ACTIONS(5701),
    [anon_sym_abstract] = ACTIONS(5701),
    [anon_sym_async] = ACTIONS(5701),
    [anon_sym_const] = ACTIONS(5701),
    [anon_sym_file] = ACTIONS(5701),
    [anon_sym_fixed] = ACTIONS(5701),
    [anon_sym_internal] = ACTIONS(5701),
    [anon_sym_new] = ACTIONS(5701),
    [anon_sym_override] = ACTIONS(5701),
    [anon_sym_partial] = ACTIONS(5701),
    [anon_sym_private] = ACTIONS(5701),
    [anon_sym_protected] = ACTIONS(5701),
    [anon_sym_public] = ACTIONS(5701),
    [anon_sym_readonly] = ACTIONS(5701),
    [anon_sym_required] = ACTIONS(5701),
    [anon_sym_sealed] = ACTIONS(5701),
    [anon_sym_virtual] = ACTIONS(5701),
    [anon_sym_volatile] = ACTIONS(5701),
    [anon_sym_where] = ACTIONS(5701),
    [anon_sym_notnull] = ACTIONS(5701),
    [anon_sym_unmanaged] = ACTIONS(5701),
    [anon_sym_TILDE] = ACTIONS(5703),
    [anon_sym_implicit] = ACTIONS(5701),
    [anon_sym_explicit] = ACTIONS(5701),
    [anon_sym_scoped] = ACTIONS(5701),
    [anon_sym_var] = ACTIONS(5701),
    [sym_predefined_type] = ACTIONS(5701),
    [anon_sym_yield] = ACTIONS(5701),
    [anon_sym_when] = ACTIONS(5701),
    [anon_sym_from] = ACTIONS(5701),
    [anon_sym_into] = ACTIONS(5701),
    [anon_sym_join] = ACTIONS(5701),
    [anon_sym_on] = ACTIONS(5701),
    [anon_sym_equals] = ACTIONS(5701),
    [anon_sym_let] = ACTIONS(5701),
    [anon_sym_orderby] = ACTIONS(5701),
    [anon_sym_ascending] = ACTIONS(5701),
    [anon_sym_descending] = ACTIONS(5701),
    [anon_sym_group] = ACTIONS(5701),
    [anon_sym_by] = ACTIONS(5701),
    [anon_sym_select] = ACTIONS(5701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3780] = {
    [sym_preproc_region] = STATE(3780),
    [sym_preproc_endregion] = STATE(3780),
    [sym_preproc_line] = STATE(3780),
    [sym_preproc_pragma] = STATE(3780),
    [sym_preproc_nullable] = STATE(3780),
    [sym_preproc_error] = STATE(3780),
    [sym_preproc_define] = STATE(3780),
    [sym_preproc_undef] = STATE(3780),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_COLON] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_RBRACK] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_RPAREN] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_where] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5470),
    [anon_sym_BANG] = ACTIONS(5470),
    [anon_sym_PLUS_PLUS] = ACTIONS(5468),
    [anon_sym_DASH_DASH] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5468),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_GT_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_EQ_GT] = ACTIONS(5468),
    [anon_sym_switch] = ACTIONS(5468),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE] = ACTIONS(5468),
    [anon_sym_QMARK_QMARK] = ACTIONS(5468),
    [anon_sym_from] = ACTIONS(5468),
    [anon_sym_join] = ACTIONS(5468),
    [anon_sym_on] = ACTIONS(5468),
    [anon_sym_equals] = ACTIONS(5468),
    [anon_sym_let] = ACTIONS(5468),
    [anon_sym_orderby] = ACTIONS(5468),
    [anon_sym_group] = ACTIONS(5468),
    [anon_sym_by] = ACTIONS(5468),
    [anon_sym_select] = ACTIONS(5468),
    [anon_sym_as] = ACTIONS(5468),
    [anon_sym_is] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_with] = ACTIONS(5468),
    [aux_sym_preproc_if_token3] = ACTIONS(5468),
    [aux_sym_preproc_else_token1] = ACTIONS(5468),
    [aux_sym_preproc_elif_token1] = ACTIONS(5468),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3781] = {
    [sym_preproc_region] = STATE(3781),
    [sym_preproc_endregion] = STATE(3781),
    [sym_preproc_line] = STATE(3781),
    [sym_preproc_pragma] = STATE(3781),
    [sym_preproc_nullable] = STATE(3781),
    [sym_preproc_error] = STATE(3781),
    [sym_preproc_define] = STATE(3781),
    [sym_preproc_undef] = STATE(3781),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_where] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_from] = ACTIONS(2987),
    [anon_sym_join] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_orderby] = ACTIONS(2987),
    [anon_sym_group] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_select] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3782] = {
    [sym_preproc_region] = STATE(3782),
    [sym_preproc_endregion] = STATE(3782),
    [sym_preproc_line] = STATE(3782),
    [sym_preproc_pragma] = STATE(3782),
    [sym_preproc_nullable] = STATE(3782),
    [sym_preproc_error] = STATE(3782),
    [sym_preproc_define] = STATE(3782),
    [sym_preproc_undef] = STATE(3782),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_where] = ACTIONS(5460),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_BANG] = ACTIONS(5462),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5460),
    [anon_sym_CARET] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5460),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_GT_GT_GT] = ACTIONS(5460),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_EQ_GT] = ACTIONS(5460),
    [anon_sym_switch] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5460),
    [anon_sym_and] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5462),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_QMARK_QMARK] = ACTIONS(5460),
    [anon_sym_from] = ACTIONS(5460),
    [anon_sym_join] = ACTIONS(5460),
    [anon_sym_on] = ACTIONS(5460),
    [anon_sym_equals] = ACTIONS(5460),
    [anon_sym_let] = ACTIONS(5460),
    [anon_sym_orderby] = ACTIONS(5460),
    [anon_sym_group] = ACTIONS(5460),
    [anon_sym_by] = ACTIONS(5460),
    [anon_sym_select] = ACTIONS(5460),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_is] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_with] = ACTIONS(5460),
    [aux_sym_preproc_if_token3] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3783] = {
    [sym_preproc_region] = STATE(3783),
    [sym_preproc_endregion] = STATE(3783),
    [sym_preproc_line] = STATE(3783),
    [sym_preproc_pragma] = STATE(3783),
    [sym_preproc_nullable] = STATE(3783),
    [sym_preproc_error] = STATE(3783),
    [sym_preproc_define] = STATE(3783),
    [sym_preproc_undef] = STATE(3783),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LPAREN] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_in] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5458),
    [anon_sym_BANG] = ACTIONS(5458),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5456),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_GT_GT_GT] = ACTIONS(5456),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_EQ_GT] = ACTIONS(5456),
    [anon_sym_switch] = ACTIONS(5456),
    [anon_sym_DOT_DOT] = ACTIONS(5456),
    [anon_sym_and] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5458),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_QMARK_QMARK] = ACTIONS(5456),
    [anon_sym_from] = ACTIONS(5456),
    [anon_sym_join] = ACTIONS(5456),
    [anon_sym_on] = ACTIONS(5456),
    [anon_sym_equals] = ACTIONS(5456),
    [anon_sym_let] = ACTIONS(5456),
    [anon_sym_orderby] = ACTIONS(5456),
    [anon_sym_group] = ACTIONS(5456),
    [anon_sym_by] = ACTIONS(5456),
    [anon_sym_select] = ACTIONS(5456),
    [anon_sym_as] = ACTIONS(5456),
    [anon_sym_is] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_with] = ACTIONS(5456),
    [aux_sym_preproc_if_token3] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3784] = {
    [sym_preproc_region] = STATE(3784),
    [sym_preproc_endregion] = STATE(3784),
    [sym_preproc_line] = STATE(3784),
    [sym_preproc_pragma] = STATE(3784),
    [sym_preproc_nullable] = STATE(3784),
    [sym_preproc_error] = STATE(3784),
    [sym_preproc_define] = STATE(3784),
    [sym_preproc_undef] = STATE(3784),
    [sym__identifier_token] = ACTIONS(5705),
    [anon_sym_extern] = ACTIONS(5705),
    [anon_sym_alias] = ACTIONS(5705),
    [anon_sym_global] = ACTIONS(5705),
    [anon_sym_unsafe] = ACTIONS(5705),
    [anon_sym_static] = ACTIONS(5705),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_LPAREN] = ACTIONS(5707),
    [anon_sym_event] = ACTIONS(5705),
    [anon_sym_class] = ACTIONS(5705),
    [anon_sym_ref] = ACTIONS(5705),
    [anon_sym_struct] = ACTIONS(5705),
    [anon_sym_enum] = ACTIONS(5705),
    [anon_sym_interface] = ACTIONS(5705),
    [anon_sym_delegate] = ACTIONS(5705),
    [anon_sym_record] = ACTIONS(5705),
    [anon_sym_abstract] = ACTIONS(5705),
    [anon_sym_async] = ACTIONS(5705),
    [anon_sym_const] = ACTIONS(5705),
    [anon_sym_file] = ACTIONS(5705),
    [anon_sym_fixed] = ACTIONS(5705),
    [anon_sym_internal] = ACTIONS(5705),
    [anon_sym_new] = ACTIONS(5705),
    [anon_sym_override] = ACTIONS(5705),
    [anon_sym_partial] = ACTIONS(5705),
    [anon_sym_private] = ACTIONS(5705),
    [anon_sym_protected] = ACTIONS(5705),
    [anon_sym_public] = ACTIONS(5705),
    [anon_sym_readonly] = ACTIONS(5705),
    [anon_sym_required] = ACTIONS(5705),
    [anon_sym_sealed] = ACTIONS(5705),
    [anon_sym_virtual] = ACTIONS(5705),
    [anon_sym_volatile] = ACTIONS(5705),
    [anon_sym_where] = ACTIONS(5705),
    [anon_sym_notnull] = ACTIONS(5705),
    [anon_sym_unmanaged] = ACTIONS(5705),
    [anon_sym_TILDE] = ACTIONS(5707),
    [anon_sym_implicit] = ACTIONS(5705),
    [anon_sym_explicit] = ACTIONS(5705),
    [anon_sym_scoped] = ACTIONS(5705),
    [anon_sym_var] = ACTIONS(5705),
    [sym_predefined_type] = ACTIONS(5705),
    [anon_sym_yield] = ACTIONS(5705),
    [anon_sym_when] = ACTIONS(5705),
    [anon_sym_from] = ACTIONS(5705),
    [anon_sym_into] = ACTIONS(5705),
    [anon_sym_join] = ACTIONS(5705),
    [anon_sym_on] = ACTIONS(5705),
    [anon_sym_equals] = ACTIONS(5705),
    [anon_sym_let] = ACTIONS(5705),
    [anon_sym_orderby] = ACTIONS(5705),
    [anon_sym_ascending] = ACTIONS(5705),
    [anon_sym_descending] = ACTIONS(5705),
    [anon_sym_group] = ACTIONS(5705),
    [anon_sym_by] = ACTIONS(5705),
    [anon_sym_select] = ACTIONS(5705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3785] = {
    [sym_preproc_region] = STATE(3785),
    [sym_preproc_endregion] = STATE(3785),
    [sym_preproc_line] = STATE(3785),
    [sym_preproc_pragma] = STATE(3785),
    [sym_preproc_nullable] = STATE(3785),
    [sym_preproc_error] = STATE(3785),
    [sym_preproc_define] = STATE(3785),
    [sym_preproc_undef] = STATE(3785),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5403),
    [anon_sym_where] = ACTIONS(5403),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_from] = ACTIONS(5403),
    [anon_sym_join] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_let] = ACTIONS(5403),
    [anon_sym_orderby] = ACTIONS(5403),
    [anon_sym_group] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_select] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3786] = {
    [sym_preproc_region] = STATE(3786),
    [sym_preproc_endregion] = STATE(3786),
    [sym_preproc_line] = STATE(3786),
    [sym_preproc_pragma] = STATE(3786),
    [sym_preproc_nullable] = STATE(3786),
    [sym_preproc_error] = STATE(3786),
    [sym_preproc_define] = STATE(3786),
    [sym_preproc_undef] = STATE(3786),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_LPAREN] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5644),
    [anon_sym_where] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_GT_GT_GT] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_EQ_GT] = ACTIONS(5644),
    [anon_sym_switch] = ACTIONS(5644),
    [anon_sym_DOT_DOT] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5646),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_QMARK_QMARK] = ACTIONS(5644),
    [anon_sym_from] = ACTIONS(5644),
    [anon_sym_join] = ACTIONS(5644),
    [anon_sym_on] = ACTIONS(5644),
    [anon_sym_equals] = ACTIONS(5644),
    [anon_sym_let] = ACTIONS(5644),
    [anon_sym_orderby] = ACTIONS(5644),
    [anon_sym_group] = ACTIONS(5644),
    [anon_sym_by] = ACTIONS(5644),
    [anon_sym_select] = ACTIONS(5644),
    [anon_sym_as] = ACTIONS(5644),
    [anon_sym_is] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [anon_sym_with] = ACTIONS(5644),
    [aux_sym_preproc_if_token3] = ACTIONS(5644),
    [aux_sym_preproc_else_token1] = ACTIONS(5644),
    [aux_sym_preproc_elif_token1] = ACTIONS(5644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3787] = {
    [sym_preproc_region] = STATE(3787),
    [sym_preproc_endregion] = STATE(3787),
    [sym_preproc_line] = STATE(3787),
    [sym_preproc_pragma] = STATE(3787),
    [sym_preproc_nullable] = STATE(3787),
    [sym_preproc_error] = STATE(3787),
    [sym_preproc_define] = STATE(3787),
    [sym_preproc_undef] = STATE(3787),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(5709),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5711),
    [anon_sym_DASH_EQ] = ACTIONS(5711),
    [anon_sym_STAR_EQ] = ACTIONS(5711),
    [anon_sym_SLASH_EQ] = ACTIONS(5711),
    [anon_sym_PERCENT_EQ] = ACTIONS(5711),
    [anon_sym_AMP_EQ] = ACTIONS(5711),
    [anon_sym_CARET_EQ] = ACTIONS(5711),
    [anon_sym_PIPE_EQ] = ACTIONS(5711),
    [anon_sym_LT_LT_EQ] = ACTIONS(5711),
    [anon_sym_GT_GT_EQ] = ACTIONS(5711),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5711),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5711),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3788] = {
    [sym_preproc_region] = STATE(3788),
    [sym_preproc_endregion] = STATE(3788),
    [sym_preproc_line] = STATE(3788),
    [sym_preproc_pragma] = STATE(3788),
    [sym_preproc_nullable] = STATE(3788),
    [sym_preproc_error] = STATE(3788),
    [sym_preproc_define] = STATE(3788),
    [sym_preproc_undef] = STATE(3788),
    [anon_sym_EQ] = ACTIONS(5713),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5715),
    [anon_sym_DASH_EQ] = ACTIONS(5715),
    [anon_sym_STAR_EQ] = ACTIONS(5715),
    [anon_sym_SLASH_EQ] = ACTIONS(5715),
    [anon_sym_PERCENT_EQ] = ACTIONS(5715),
    [anon_sym_AMP_EQ] = ACTIONS(5715),
    [anon_sym_CARET_EQ] = ACTIONS(5715),
    [anon_sym_PIPE_EQ] = ACTIONS(5715),
    [anon_sym_LT_LT_EQ] = ACTIONS(5715),
    [anon_sym_GT_GT_EQ] = ACTIONS(5715),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5715),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5715),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_ascending] = ACTIONS(5294),
    [anon_sym_descending] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5296),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3789] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter] = STATE(8487),
    [sym__parameter_array] = STATE(8477),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7328),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6748),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3789),
    [sym_preproc_endregion] = STATE(3789),
    [sym_preproc_line] = STATE(3789),
    [sym_preproc_pragma] = STATE(3789),
    [sym_preproc_nullable] = STATE(3789),
    [sym_preproc_error] = STATE(3789),
    [sym_preproc_define] = STATE(3789),
    [sym_preproc_undef] = STATE(3789),
    [aux_sym_class_declaration_repeat1] = STATE(3803),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4310),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3790] = {
    [sym_preproc_region] = STATE(3790),
    [sym_preproc_endregion] = STATE(3790),
    [sym_preproc_line] = STATE(3790),
    [sym_preproc_pragma] = STATE(3790),
    [sym_preproc_nullable] = STATE(3790),
    [sym_preproc_error] = STATE(3790),
    [sym_preproc_define] = STATE(3790),
    [sym_preproc_undef] = STATE(3790),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_where] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5528),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_from] = ACTIONS(5526),
    [anon_sym_join] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_let] = ACTIONS(5526),
    [anon_sym_orderby] = ACTIONS(5526),
    [anon_sym_group] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_select] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3791] = {
    [sym_preproc_region] = STATE(3791),
    [sym_preproc_endregion] = STATE(3791),
    [sym_preproc_line] = STATE(3791),
    [sym_preproc_pragma] = STATE(3791),
    [sym_preproc_nullable] = STATE(3791),
    [sym_preproc_error] = STATE(3791),
    [sym_preproc_define] = STATE(3791),
    [sym_preproc_undef] = STATE(3791),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5640),
    [anon_sym_where] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_BANG] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_GT_GT_GT] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_EQ_GT] = ACTIONS(5640),
    [anon_sym_switch] = ACTIONS(5640),
    [anon_sym_DOT_DOT] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_QMARK_QMARK] = ACTIONS(5640),
    [anon_sym_from] = ACTIONS(5640),
    [anon_sym_join] = ACTIONS(5640),
    [anon_sym_on] = ACTIONS(5640),
    [anon_sym_equals] = ACTIONS(5640),
    [anon_sym_let] = ACTIONS(5640),
    [anon_sym_orderby] = ACTIONS(5640),
    [anon_sym_group] = ACTIONS(5640),
    [anon_sym_by] = ACTIONS(5640),
    [anon_sym_select] = ACTIONS(5640),
    [anon_sym_as] = ACTIONS(5640),
    [anon_sym_is] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [anon_sym_with] = ACTIONS(5640),
    [aux_sym_preproc_if_token3] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3792] = {
    [sym_preproc_region] = STATE(3792),
    [sym_preproc_endregion] = STATE(3792),
    [sym_preproc_line] = STATE(3792),
    [sym_preproc_pragma] = STATE(3792),
    [sym_preproc_nullable] = STATE(3792),
    [sym_preproc_error] = STATE(3792),
    [sym_preproc_define] = STATE(3792),
    [sym_preproc_undef] = STATE(3792),
    [sym__identifier_token] = ACTIONS(5717),
    [anon_sym_extern] = ACTIONS(5717),
    [anon_sym_alias] = ACTIONS(5717),
    [anon_sym_global] = ACTIONS(5717),
    [anon_sym_unsafe] = ACTIONS(5717),
    [anon_sym_static] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5719),
    [anon_sym_LPAREN] = ACTIONS(5719),
    [anon_sym_event] = ACTIONS(5717),
    [anon_sym_class] = ACTIONS(5717),
    [anon_sym_ref] = ACTIONS(5717),
    [anon_sym_struct] = ACTIONS(5717),
    [anon_sym_enum] = ACTIONS(5717),
    [anon_sym_interface] = ACTIONS(5717),
    [anon_sym_delegate] = ACTIONS(5717),
    [anon_sym_record] = ACTIONS(5717),
    [anon_sym_abstract] = ACTIONS(5717),
    [anon_sym_async] = ACTIONS(5717),
    [anon_sym_const] = ACTIONS(5717),
    [anon_sym_file] = ACTIONS(5717),
    [anon_sym_fixed] = ACTIONS(5717),
    [anon_sym_internal] = ACTIONS(5717),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_override] = ACTIONS(5717),
    [anon_sym_partial] = ACTIONS(5717),
    [anon_sym_private] = ACTIONS(5717),
    [anon_sym_protected] = ACTIONS(5717),
    [anon_sym_public] = ACTIONS(5717),
    [anon_sym_readonly] = ACTIONS(5717),
    [anon_sym_required] = ACTIONS(5717),
    [anon_sym_sealed] = ACTIONS(5717),
    [anon_sym_virtual] = ACTIONS(5717),
    [anon_sym_volatile] = ACTIONS(5717),
    [anon_sym_where] = ACTIONS(5717),
    [anon_sym_notnull] = ACTIONS(5717),
    [anon_sym_unmanaged] = ACTIONS(5717),
    [anon_sym_TILDE] = ACTIONS(5719),
    [anon_sym_implicit] = ACTIONS(5717),
    [anon_sym_explicit] = ACTIONS(5717),
    [anon_sym_scoped] = ACTIONS(5717),
    [anon_sym_var] = ACTIONS(5717),
    [sym_predefined_type] = ACTIONS(5717),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_when] = ACTIONS(5717),
    [anon_sym_from] = ACTIONS(5717),
    [anon_sym_into] = ACTIONS(5717),
    [anon_sym_join] = ACTIONS(5717),
    [anon_sym_on] = ACTIONS(5717),
    [anon_sym_equals] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_orderby] = ACTIONS(5717),
    [anon_sym_ascending] = ACTIONS(5717),
    [anon_sym_descending] = ACTIONS(5717),
    [anon_sym_group] = ACTIONS(5717),
    [anon_sym_by] = ACTIONS(5717),
    [anon_sym_select] = ACTIONS(5717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3793] = {
    [sym_preproc_region] = STATE(3793),
    [sym_preproc_endregion] = STATE(3793),
    [sym_preproc_line] = STATE(3793),
    [sym_preproc_pragma] = STATE(3793),
    [sym_preproc_nullable] = STATE(3793),
    [sym_preproc_error] = STATE(3793),
    [sym_preproc_define] = STATE(3793),
    [sym_preproc_undef] = STATE(3793),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_where] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_from] = ACTIONS(5518),
    [anon_sym_join] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_orderby] = ACTIONS(5518),
    [anon_sym_group] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_select] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3794] = {
    [sym_preproc_region] = STATE(3794),
    [sym_preproc_endregion] = STATE(3794),
    [sym_preproc_line] = STATE(3794),
    [sym_preproc_pragma] = STATE(3794),
    [sym_preproc_nullable] = STATE(3794),
    [sym_preproc_error] = STATE(3794),
    [sym_preproc_define] = STATE(3794),
    [sym_preproc_undef] = STATE(3794),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_event] = ACTIONS(4040),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_TILDE] = ACTIONS(5721),
    [anon_sym_implicit] = ACTIONS(4040),
    [anon_sym_explicit] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3795] = {
    [sym_preproc_region] = STATE(3795),
    [sym_preproc_endregion] = STATE(3795),
    [sym_preproc_line] = STATE(3795),
    [sym_preproc_pragma] = STATE(3795),
    [sym_preproc_nullable] = STATE(3795),
    [sym_preproc_error] = STATE(3795),
    [sym_preproc_define] = STATE(3795),
    [sym_preproc_undef] = STATE(3795),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4801),
    [anon_sym_RBRACK] = ACTIONS(4801),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4801),
    [anon_sym_RBRACE] = ACTIONS(4801),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3796] = {
    [sym_preproc_region] = STATE(3796),
    [sym_preproc_endregion] = STATE(3796),
    [sym_preproc_line] = STATE(3796),
    [sym_preproc_pragma] = STATE(3796),
    [sym_preproc_nullable] = STATE(3796),
    [sym_preproc_error] = STATE(3796),
    [sym_preproc_define] = STATE(3796),
    [sym_preproc_undef] = STATE(3796),
    [anon_sym_EQ] = ACTIONS(5723),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5296),
    [anon_sym_PLUS_EQ] = ACTIONS(5725),
    [anon_sym_DASH_EQ] = ACTIONS(5725),
    [anon_sym_STAR_EQ] = ACTIONS(5725),
    [anon_sym_SLASH_EQ] = ACTIONS(5725),
    [anon_sym_PERCENT_EQ] = ACTIONS(5725),
    [anon_sym_AMP_EQ] = ACTIONS(5725),
    [anon_sym_CARET_EQ] = ACTIONS(5725),
    [anon_sym_PIPE_EQ] = ACTIONS(5725),
    [anon_sym_LT_LT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5725),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3797] = {
    [sym_preproc_region] = STATE(3797),
    [sym_preproc_endregion] = STATE(3797),
    [sym_preproc_line] = STATE(3797),
    [sym_preproc_pragma] = STATE(3797),
    [sym_preproc_nullable] = STATE(3797),
    [sym_preproc_error] = STATE(3797),
    [sym_preproc_define] = STATE(3797),
    [sym_preproc_undef] = STATE(3797),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3798] = {
    [sym_preproc_region] = STATE(3798),
    [sym_preproc_endregion] = STATE(3798),
    [sym_preproc_line] = STATE(3798),
    [sym_preproc_pragma] = STATE(3798),
    [sym_preproc_nullable] = STATE(3798),
    [sym_preproc_error] = STATE(3798),
    [sym_preproc_define] = STATE(3798),
    [sym_preproc_undef] = STATE(3798),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_event] = ACTIONS(4040),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_implicit] = ACTIONS(4040),
    [anon_sym_explicit] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3799] = {
    [sym_preproc_region] = STATE(3799),
    [sym_preproc_endregion] = STATE(3799),
    [sym_preproc_line] = STATE(3799),
    [sym_preproc_pragma] = STATE(3799),
    [sym_preproc_nullable] = STATE(3799),
    [sym_preproc_error] = STATE(3799),
    [sym_preproc_define] = STATE(3799),
    [sym_preproc_undef] = STATE(3799),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4636),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_when] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4636),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_into] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3800] = {
    [sym_attribute_list] = STATE(7291),
    [sym_type_parameter] = STATE(8400),
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8589),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(7662),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3800),
    [sym_preproc_endregion] = STATE(3800),
    [sym_preproc_line] = STATE(3800),
    [sym_preproc_pragma] = STATE(3800),
    [sym_preproc_nullable] = STATE(3800),
    [sym_preproc_error] = STATE(3800),
    [sym_preproc_define] = STATE(3800),
    [sym_preproc_undef] = STATE(3800),
    [aux_sym_class_declaration_repeat1] = STATE(6827),
    [aux_sym_type_argument_list_repeat1] = STATE(8653),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5727),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(5735),
    [anon_sym_in] = ACTIONS(5737),
    [anon_sym_out] = ACTIONS(5737),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3801] = {
    [sym_preproc_region] = STATE(3801),
    [sym_preproc_endregion] = STATE(3801),
    [sym_preproc_line] = STATE(3801),
    [sym_preproc_pragma] = STATE(3801),
    [sym_preproc_nullable] = STATE(3801),
    [sym_preproc_error] = STATE(3801),
    [sym_preproc_define] = STATE(3801),
    [sym_preproc_undef] = STATE(3801),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3802] = {
    [sym_preproc_region] = STATE(3802),
    [sym_preproc_endregion] = STATE(3802),
    [sym_preproc_line] = STATE(3802),
    [sym_preproc_pragma] = STATE(3802),
    [sym_preproc_nullable] = STATE(3802),
    [sym_preproc_error] = STATE(3802),
    [sym_preproc_define] = STATE(3802),
    [sym_preproc_undef] = STATE(3802),
    [sym__identifier_token] = ACTIONS(5747),
    [anon_sym_extern] = ACTIONS(5747),
    [anon_sym_alias] = ACTIONS(5747),
    [anon_sym_global] = ACTIONS(5747),
    [anon_sym_unsafe] = ACTIONS(5747),
    [anon_sym_static] = ACTIONS(5747),
    [anon_sym_LPAREN] = ACTIONS(5749),
    [anon_sym_event] = ACTIONS(5747),
    [anon_sym_class] = ACTIONS(5747),
    [anon_sym_ref] = ACTIONS(5747),
    [anon_sym_struct] = ACTIONS(5747),
    [anon_sym_enum] = ACTIONS(5747),
    [anon_sym_interface] = ACTIONS(5747),
    [anon_sym_delegate] = ACTIONS(5747),
    [anon_sym_record] = ACTIONS(5747),
    [anon_sym_abstract] = ACTIONS(5747),
    [anon_sym_async] = ACTIONS(5747),
    [anon_sym_const] = ACTIONS(5747),
    [anon_sym_file] = ACTIONS(5747),
    [anon_sym_fixed] = ACTIONS(5747),
    [anon_sym_internal] = ACTIONS(5747),
    [anon_sym_new] = ACTIONS(5747),
    [anon_sym_override] = ACTIONS(5747),
    [anon_sym_partial] = ACTIONS(5747),
    [anon_sym_private] = ACTIONS(5747),
    [anon_sym_protected] = ACTIONS(5747),
    [anon_sym_public] = ACTIONS(5747),
    [anon_sym_readonly] = ACTIONS(5747),
    [anon_sym_required] = ACTIONS(5747),
    [anon_sym_sealed] = ACTIONS(5747),
    [anon_sym_virtual] = ACTIONS(5747),
    [anon_sym_volatile] = ACTIONS(5747),
    [anon_sym_where] = ACTIONS(5747),
    [anon_sym_notnull] = ACTIONS(5747),
    [anon_sym_unmanaged] = ACTIONS(5747),
    [anon_sym_implicit] = ACTIONS(5747),
    [anon_sym_explicit] = ACTIONS(5747),
    [anon_sym_scoped] = ACTIONS(5747),
    [anon_sym_var] = ACTIONS(5747),
    [sym_predefined_type] = ACTIONS(5747),
    [anon_sym_yield] = ACTIONS(5747),
    [anon_sym_when] = ACTIONS(5747),
    [anon_sym_from] = ACTIONS(5747),
    [anon_sym_into] = ACTIONS(5747),
    [anon_sym_join] = ACTIONS(5747),
    [anon_sym_on] = ACTIONS(5747),
    [anon_sym_equals] = ACTIONS(5747),
    [anon_sym_let] = ACTIONS(5747),
    [anon_sym_orderby] = ACTIONS(5747),
    [anon_sym_ascending] = ACTIONS(5747),
    [anon_sym_descending] = ACTIONS(5747),
    [anon_sym_group] = ACTIONS(5747),
    [anon_sym_by] = ACTIONS(5747),
    [anon_sym_select] = ACTIONS(5747),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3803] = {
    [sym_attribute_list] = STATE(6722),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7331),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(6745),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3803),
    [sym_preproc_endregion] = STATE(3803),
    [sym_preproc_line] = STATE(3803),
    [sym_preproc_pragma] = STATE(3803),
    [sym_preproc_nullable] = STATE(3803),
    [sym_preproc_error] = STATE(3803),
    [sym_preproc_define] = STATE(3803),
    [sym_preproc_undef] = STATE(3803),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(4209),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_params] = ACTIONS(5302),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3804] = {
    [sym_type_argument_list] = STATE(3893),
    [sym_preproc_region] = STATE(3804),
    [sym_preproc_endregion] = STATE(3804),
    [sym_preproc_line] = STATE(3804),
    [sym_preproc_pragma] = STATE(3804),
    [sym_preproc_nullable] = STATE(3804),
    [sym_preproc_error] = STATE(3804),
    [sym_preproc_define] = STATE(3804),
    [sym_preproc_undef] = STATE(3804),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(5754),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3805] = {
    [sym_argument_list] = STATE(3848),
    [sym_initializer_expression] = STATE(3983),
    [sym_preproc_region] = STATE(3805),
    [sym_preproc_endregion] = STATE(3805),
    [sym_preproc_line] = STATE(3805),
    [sym_preproc_pragma] = STATE(3805),
    [sym_preproc_nullable] = STATE(3805),
    [sym_preproc_error] = STATE(3805),
    [sym_preproc_define] = STATE(3805),
    [sym_preproc_undef] = STATE(3805),
    [anon_sym_SEMI] = ACTIONS(5263),
    [anon_sym_LBRACK] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5263),
    [anon_sym_COMMA] = ACTIONS(5263),
    [anon_sym_RBRACK] = ACTIONS(5263),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5263),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5267),
    [anon_sym_in] = ACTIONS(5267),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5263),
    [anon_sym_DASH_DASH] = ACTIONS(5263),
    [anon_sym_PLUS] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_SLASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5263),
    [anon_sym_CARET] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_LT_LT] = ACTIONS(5263),
    [anon_sym_GT_GT] = ACTIONS(5267),
    [anon_sym_GT_GT_GT] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_DOT] = ACTIONS(5267),
    [anon_sym_EQ_GT] = ACTIONS(5263),
    [anon_sym_switch] = ACTIONS(5263),
    [anon_sym_when] = ACTIONS(5263),
    [anon_sym_DOT_DOT] = ACTIONS(5263),
    [anon_sym_and] = ACTIONS(5263),
    [anon_sym_or] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_QMARK_QMARK] = ACTIONS(5263),
    [anon_sym_into] = ACTIONS(5263),
    [anon_sym_on] = ACTIONS(5263),
    [anon_sym_equals] = ACTIONS(5263),
    [anon_sym_by] = ACTIONS(5263),
    [anon_sym_as] = ACTIONS(5263),
    [anon_sym_is] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5263),
    [anon_sym_with] = ACTIONS(5263),
    [aux_sym_preproc_if_token3] = ACTIONS(5263),
    [aux_sym_preproc_else_token1] = ACTIONS(5263),
    [aux_sym_preproc_elif_token1] = ACTIONS(5263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3806] = {
    [sym_preproc_region] = STATE(3806),
    [sym_preproc_endregion] = STATE(3806),
    [sym_preproc_line] = STATE(3806),
    [sym_preproc_pragma] = STATE(3806),
    [sym_preproc_nullable] = STATE(3806),
    [sym_preproc_error] = STATE(3806),
    [sym_preproc_define] = STATE(3806),
    [sym_preproc_undef] = STATE(3806),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_event] = ACTIONS(4040),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_implicit] = ACTIONS(4040),
    [anon_sym_explicit] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3807] = {
    [sym_attribute_list] = STATE(4403),
    [sym_modifier] = STATE(4531),
    [sym_identifier] = STATE(7777),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3807),
    [sym_preproc_endregion] = STATE(3807),
    [sym_preproc_line] = STATE(3807),
    [sym_preproc_pragma] = STATE(3807),
    [sym_preproc_nullable] = STATE(3807),
    [sym_preproc_error] = STATE(3807),
    [sym_preproc_define] = STATE(3807),
    [sym_preproc_undef] = STATE(3807),
    [aux_sym_class_declaration_repeat1] = STATE(4202),
    [aux_sym_class_declaration_repeat2] = STATE(4002),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5492),
    [anon_sym_abstract] = ACTIONS(5490),
    [anon_sym_async] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_file] = ACTIONS(5496),
    [anon_sym_fixed] = ACTIONS(5490),
    [anon_sym_internal] = ACTIONS(5490),
    [anon_sym_new] = ACTIONS(5490),
    [anon_sym_override] = ACTIONS(5490),
    [anon_sym_partial] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_readonly] = ACTIONS(5490),
    [anon_sym_required] = ACTIONS(5490),
    [anon_sym_sealed] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5758),
    [anon_sym_set] = ACTIONS(5758),
    [anon_sym_add] = ACTIONS(5758),
    [anon_sym_remove] = ACTIONS(5758),
    [anon_sym_init] = ACTIONS(5758),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3808] = {
    [sym_initializer_expression] = STATE(3988),
    [sym_preproc_region] = STATE(3808),
    [sym_preproc_endregion] = STATE(3808),
    [sym_preproc_line] = STATE(3808),
    [sym_preproc_pragma] = STATE(3808),
    [sym_preproc_nullable] = STATE(3808),
    [sym_preproc_error] = STATE(3808),
    [sym_preproc_define] = STATE(3808),
    [sym_preproc_undef] = STATE(3808),
    [anon_sym_SEMI] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5304),
    [anon_sym_RBRACK] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(5304),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_in] = ACTIONS(5309),
    [anon_sym_QMARK] = ACTIONS(5309),
    [anon_sym_BANG] = ACTIONS(5309),
    [anon_sym_PLUS_PLUS] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_GT_GT_GT] = ACTIONS(5304),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_GT_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5304),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_EQ_GT] = ACTIONS(5304),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_when] = ACTIONS(5304),
    [anon_sym_DOT_DOT] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5304),
    [anon_sym_AMP_AMP] = ACTIONS(5304),
    [anon_sym_PIPE_PIPE] = ACTIONS(5304),
    [anon_sym_QMARK_QMARK] = ACTIONS(5304),
    [anon_sym_into] = ACTIONS(5304),
    [anon_sym_on] = ACTIONS(5304),
    [anon_sym_equals] = ACTIONS(5304),
    [anon_sym_by] = ACTIONS(5304),
    [anon_sym_as] = ACTIONS(5304),
    [anon_sym_is] = ACTIONS(5304),
    [anon_sym_DASH_GT] = ACTIONS(5304),
    [anon_sym_with] = ACTIONS(5304),
    [aux_sym_preproc_if_token3] = ACTIONS(5304),
    [aux_sym_preproc_else_token1] = ACTIONS(5304),
    [aux_sym_preproc_elif_token1] = ACTIONS(5304),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3809] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9056),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3809),
    [sym_preproc_endregion] = STATE(3809),
    [sym_preproc_line] = STATE(3809),
    [sym_preproc_pragma] = STATE(3809),
    [sym_preproc_nullable] = STATE(3809),
    [sym_preproc_error] = STATE(3809),
    [sym_preproc_define] = STATE(3809),
    [sym_preproc_undef] = STATE(3809),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4179),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3810] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9563),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3810),
    [sym_preproc_endregion] = STATE(3810),
    [sym_preproc_line] = STATE(3810),
    [sym_preproc_pragma] = STATE(3810),
    [sym_preproc_nullable] = STATE(3810),
    [sym_preproc_error] = STATE(3810),
    [sym_preproc_define] = STATE(3810),
    [sym_preproc_undef] = STATE(3810),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4140),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3811] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7149),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9313),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3811),
    [sym_preproc_endregion] = STATE(3811),
    [sym_preproc_line] = STATE(3811),
    [sym_preproc_pragma] = STATE(3811),
    [sym_preproc_nullable] = STATE(3811),
    [sym_preproc_error] = STATE(3811),
    [sym_preproc_define] = STATE(3811),
    [sym_preproc_undef] = STATE(3811),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4093),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3812] = {
    [sym_block] = STATE(2497),
    [sym_preproc_region] = STATE(3812),
    [sym_preproc_endregion] = STATE(3812),
    [sym_preproc_line] = STATE(3812),
    [sym_preproc_pragma] = STATE(3812),
    [sym_preproc_nullable] = STATE(3812),
    [sym_preproc_error] = STATE(3812),
    [sym_preproc_define] = STATE(3812),
    [sym_preproc_undef] = STATE(3812),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3813] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6997),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9520),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3813),
    [sym_preproc_endregion] = STATE(3813),
    [sym_preproc_line] = STATE(3813),
    [sym_preproc_pragma] = STATE(3813),
    [sym_preproc_nullable] = STATE(3813),
    [sym_preproc_error] = STATE(3813),
    [sym_preproc_define] = STATE(3813),
    [sym_preproc_undef] = STATE(3813),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4308),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3814] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9405),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3814),
    [sym_preproc_endregion] = STATE(3814),
    [sym_preproc_line] = STATE(3814),
    [sym_preproc_pragma] = STATE(3814),
    [sym_preproc_nullable] = STATE(3814),
    [sym_preproc_error] = STATE(3814),
    [sym_preproc_define] = STATE(3814),
    [sym_preproc_undef] = STATE(3814),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4158),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3815] = {
    [sym_initializer_expression] = STATE(3982),
    [sym_preproc_region] = STATE(3815),
    [sym_preproc_endregion] = STATE(3815),
    [sym_preproc_line] = STATE(3815),
    [sym_preproc_pragma] = STATE(3815),
    [sym_preproc_nullable] = STATE(3815),
    [sym_preproc_error] = STATE(3815),
    [sym_preproc_define] = STATE(3815),
    [sym_preproc_undef] = STATE(3815),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5321),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3816] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6990),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9155),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3816),
    [sym_preproc_endregion] = STATE(3816),
    [sym_preproc_line] = STATE(3816),
    [sym_preproc_pragma] = STATE(3816),
    [sym_preproc_nullable] = STATE(3816),
    [sym_preproc_error] = STATE(3816),
    [sym_preproc_define] = STATE(3816),
    [sym_preproc_undef] = STATE(3816),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4294),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3817] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7157),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9293),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3817),
    [sym_preproc_endregion] = STATE(3817),
    [sym_preproc_line] = STATE(3817),
    [sym_preproc_pragma] = STATE(3817),
    [sym_preproc_nullable] = STATE(3817),
    [sym_preproc_error] = STATE(3817),
    [sym_preproc_define] = STATE(3817),
    [sym_preproc_undef] = STATE(3817),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4108),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3818] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9572),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3818),
    [sym_preproc_endregion] = STATE(3818),
    [sym_preproc_line] = STATE(3818),
    [sym_preproc_pragma] = STATE(3818),
    [sym_preproc_nullable] = STATE(3818),
    [sym_preproc_error] = STATE(3818),
    [sym_preproc_define] = STATE(3818),
    [sym_preproc_undef] = STATE(3818),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4186),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3819] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7042),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9514),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3819),
    [sym_preproc_endregion] = STATE(3819),
    [sym_preproc_line] = STATE(3819),
    [sym_preproc_pragma] = STATE(3819),
    [sym_preproc_nullable] = STATE(3819),
    [sym_preproc_error] = STATE(3819),
    [sym_preproc_define] = STATE(3819),
    [sym_preproc_undef] = STATE(3819),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4279),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3820] = {
    [sym_argument_list] = STATE(3978),
    [sym_bracketed_argument_list] = STATE(3199),
    [sym_preproc_region] = STATE(3820),
    [sym_preproc_endregion] = STATE(3820),
    [sym_preproc_line] = STATE(3820),
    [sym_preproc_pragma] = STATE(3820),
    [sym_preproc_nullable] = STATE(3820),
    [sym_preproc_error] = STATE(3820),
    [sym_preproc_define] = STATE(3820),
    [sym_preproc_undef] = STATE(3820),
    [anon_sym_SEMI] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5323),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_in] = ACTIONS(5325),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_BANG] = ACTIONS(5764),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5323),
    [anon_sym_SLASH] = ACTIONS(5325),
    [anon_sym_PERCENT] = ACTIONS(5323),
    [anon_sym_CARET] = ACTIONS(5323),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5323),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_GT_GT_GT] = ACTIONS(5323),
    [anon_sym_EQ_EQ] = ACTIONS(5323),
    [anon_sym_BANG_EQ] = ACTIONS(5323),
    [anon_sym_GT_EQ] = ACTIONS(5323),
    [anon_sym_LT_EQ] = ACTIONS(5323),
    [anon_sym_DOT] = ACTIONS(4630),
    [anon_sym_EQ_GT] = ACTIONS(5323),
    [anon_sym_switch] = ACTIONS(5323),
    [anon_sym_when] = ACTIONS(5323),
    [anon_sym_DOT_DOT] = ACTIONS(5323),
    [anon_sym_and] = ACTIONS(5323),
    [anon_sym_or] = ACTIONS(5323),
    [anon_sym_AMP_AMP] = ACTIONS(5323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5323),
    [anon_sym_QMARK_QMARK] = ACTIONS(5323),
    [anon_sym_into] = ACTIONS(5323),
    [anon_sym_on] = ACTIONS(5323),
    [anon_sym_equals] = ACTIONS(5323),
    [anon_sym_by] = ACTIONS(5323),
    [anon_sym_as] = ACTIONS(5323),
    [anon_sym_is] = ACTIONS(5323),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(5323),
    [aux_sym_preproc_if_token3] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3821] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6965),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9147),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3821),
    [sym_preproc_endregion] = STATE(3821),
    [sym_preproc_line] = STATE(3821),
    [sym_preproc_pragma] = STATE(3821),
    [sym_preproc_nullable] = STATE(3821),
    [sym_preproc_error] = STATE(3821),
    [sym_preproc_define] = STATE(3821),
    [sym_preproc_undef] = STATE(3821),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4123),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3822] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7103),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9257),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3822),
    [sym_preproc_endregion] = STATE(3822),
    [sym_preproc_line] = STATE(3822),
    [sym_preproc_pragma] = STATE(3822),
    [sym_preproc_nullable] = STATE(3822),
    [sym_preproc_error] = STATE(3822),
    [sym_preproc_define] = STATE(3822),
    [sym_preproc_undef] = STATE(3822),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4115),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3823] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3823),
    [sym_preproc_endregion] = STATE(3823),
    [sym_preproc_line] = STATE(3823),
    [sym_preproc_pragma] = STATE(3823),
    [sym_preproc_nullable] = STATE(3823),
    [sym_preproc_error] = STATE(3823),
    [sym_preproc_define] = STATE(3823),
    [sym_preproc_undef] = STATE(3823),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4257),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3824] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7052),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9544),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3824),
    [sym_preproc_endregion] = STATE(3824),
    [sym_preproc_line] = STATE(3824),
    [sym_preproc_pragma] = STATE(3824),
    [sym_preproc_nullable] = STATE(3824),
    [sym_preproc_error] = STATE(3824),
    [sym_preproc_define] = STATE(3824),
    [sym_preproc_undef] = STATE(3824),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4192),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3825] = {
    [sym_argument_list] = STATE(3978),
    [sym_bracketed_argument_list] = STATE(3199),
    [sym_preproc_region] = STATE(3825),
    [sym_preproc_endregion] = STATE(3825),
    [sym_preproc_line] = STATE(3825),
    [sym_preproc_pragma] = STATE(3825),
    [sym_preproc_nullable] = STATE(3825),
    [sym_preproc_error] = STATE(3825),
    [sym_preproc_define] = STATE(3825),
    [sym_preproc_undef] = STATE(3825),
    [anon_sym_SEMI] = ACTIONS(5282),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5282),
    [anon_sym_COMMA] = ACTIONS(5282),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5282),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LT] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_in] = ACTIONS(5286),
    [anon_sym_QMARK] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5764),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_DASH] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5282),
    [anon_sym_SLASH] = ACTIONS(5286),
    [anon_sym_PERCENT] = ACTIONS(5282),
    [anon_sym_CARET] = ACTIONS(5282),
    [anon_sym_PIPE] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5286),
    [anon_sym_LT_LT] = ACTIONS(5282),
    [anon_sym_GT_GT] = ACTIONS(5286),
    [anon_sym_GT_GT_GT] = ACTIONS(5282),
    [anon_sym_EQ_EQ] = ACTIONS(5282),
    [anon_sym_BANG_EQ] = ACTIONS(5282),
    [anon_sym_GT_EQ] = ACTIONS(5282),
    [anon_sym_LT_EQ] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(4630),
    [anon_sym_EQ_GT] = ACTIONS(5282),
    [anon_sym_switch] = ACTIONS(5282),
    [anon_sym_when] = ACTIONS(5282),
    [anon_sym_DOT_DOT] = ACTIONS(5282),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_AMP_AMP] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5282),
    [anon_sym_QMARK_QMARK] = ACTIONS(5282),
    [anon_sym_into] = ACTIONS(5282),
    [anon_sym_on] = ACTIONS(5282),
    [anon_sym_equals] = ACTIONS(5282),
    [anon_sym_by] = ACTIONS(5282),
    [anon_sym_as] = ACTIONS(5282),
    [anon_sym_is] = ACTIONS(5282),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(5282),
    [aux_sym_preproc_if_token3] = ACTIONS(5282),
    [aux_sym_preproc_else_token1] = ACTIONS(5282),
    [aux_sym_preproc_elif_token1] = ACTIONS(5282),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3826] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7146),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9332),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3826),
    [sym_preproc_endregion] = STATE(3826),
    [sym_preproc_line] = STATE(3826),
    [sym_preproc_pragma] = STATE(3826),
    [sym_preproc_nullable] = STATE(3826),
    [sym_preproc_error] = STATE(3826),
    [sym_preproc_define] = STATE(3826),
    [sym_preproc_undef] = STATE(3826),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4098),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3827] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6994),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9429),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3827),
    [sym_preproc_endregion] = STATE(3827),
    [sym_preproc_line] = STATE(3827),
    [sym_preproc_pragma] = STATE(3827),
    [sym_preproc_nullable] = STATE(3827),
    [sym_preproc_error] = STATE(3827),
    [sym_preproc_define] = STATE(3827),
    [sym_preproc_undef] = STATE(3827),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4300),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3828] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9444),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3828),
    [sym_preproc_endregion] = STATE(3828),
    [sym_preproc_line] = STATE(3828),
    [sym_preproc_pragma] = STATE(3828),
    [sym_preproc_nullable] = STATE(3828),
    [sym_preproc_error] = STATE(3828),
    [sym_preproc_define] = STATE(3828),
    [sym_preproc_undef] = STATE(3828),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4222),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3829] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9118),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3829),
    [sym_preproc_endregion] = STATE(3829),
    [sym_preproc_line] = STATE(3829),
    [sym_preproc_pragma] = STATE(3829),
    [sym_preproc_nullable] = STATE(3829),
    [sym_preproc_error] = STATE(3829),
    [sym_preproc_define] = STATE(3829),
    [sym_preproc_undef] = STATE(3829),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4314),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3830] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7121),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9136),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3830),
    [sym_preproc_endregion] = STATE(3830),
    [sym_preproc_line] = STATE(3830),
    [sym_preproc_pragma] = STATE(3830),
    [sym_preproc_nullable] = STATE(3830),
    [sym_preproc_error] = STATE(3830),
    [sym_preproc_define] = STATE(3830),
    [sym_preproc_undef] = STATE(3830),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4128),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3831] = {
    [sym_preproc_region] = STATE(3831),
    [sym_preproc_endregion] = STATE(3831),
    [sym_preproc_line] = STATE(3831),
    [sym_preproc_pragma] = STATE(3831),
    [sym_preproc_nullable] = STATE(3831),
    [sym_preproc_error] = STATE(3831),
    [sym_preproc_define] = STATE(3831),
    [sym_preproc_undef] = STATE(3831),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_when] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3832] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7012),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9410),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3832),
    [sym_preproc_endregion] = STATE(3832),
    [sym_preproc_line] = STATE(3832),
    [sym_preproc_pragma] = STATE(3832),
    [sym_preproc_nullable] = STATE(3832),
    [sym_preproc_error] = STATE(3832),
    [sym_preproc_define] = STATE(3832),
    [sym_preproc_undef] = STATE(3832),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4262),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3833] = {
    [sym_preproc_region] = STATE(3833),
    [sym_preproc_endregion] = STATE(3833),
    [sym_preproc_line] = STATE(3833),
    [sym_preproc_pragma] = STATE(3833),
    [sym_preproc_nullable] = STATE(3833),
    [sym_preproc_error] = STATE(3833),
    [sym_preproc_define] = STATE(3833),
    [sym_preproc_undef] = STATE(3833),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3834] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6975),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9653),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3834),
    [sym_preproc_endregion] = STATE(3834),
    [sym_preproc_line] = STATE(3834),
    [sym_preproc_pragma] = STATE(3834),
    [sym_preproc_nullable] = STATE(3834),
    [sym_preproc_error] = STATE(3834),
    [sym_preproc_define] = STATE(3834),
    [sym_preproc_undef] = STATE(3834),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4289),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3835] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6951),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9927),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3835),
    [sym_preproc_endregion] = STATE(3835),
    [sym_preproc_line] = STATE(3835),
    [sym_preproc_pragma] = STATE(3835),
    [sym_preproc_nullable] = STATE(3835),
    [sym_preproc_error] = STATE(3835),
    [sym_preproc_define] = STATE(3835),
    [sym_preproc_undef] = STATE(3835),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4288),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3836] = {
    [sym_preproc_region] = STATE(3836),
    [sym_preproc_endregion] = STATE(3836),
    [sym_preproc_line] = STATE(3836),
    [sym_preproc_pragma] = STATE(3836),
    [sym_preproc_nullable] = STATE(3836),
    [sym_preproc_error] = STATE(3836),
    [sym_preproc_define] = STATE(3836),
    [sym_preproc_undef] = STATE(3836),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3837] = {
    [sym_initializer_expression] = STATE(3984),
    [sym_preproc_region] = STATE(3837),
    [sym_preproc_endregion] = STATE(3837),
    [sym_preproc_line] = STATE(3837),
    [sym_preproc_pragma] = STATE(3837),
    [sym_preproc_nullable] = STATE(3837),
    [sym_preproc_error] = STATE(3837),
    [sym_preproc_define] = STATE(3837),
    [sym_preproc_undef] = STATE(3837),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RBRACK] = ACTIONS(5331),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5337),
    [anon_sym_GT] = ACTIONS(5337),
    [anon_sym_in] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5771),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_PLUS_PLUS] = ACTIONS(5331),
    [anon_sym_DASH_DASH] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_STAR] = ACTIONS(5331),
    [anon_sym_SLASH] = ACTIONS(5337),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_CARET] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5337),
    [anon_sym_AMP] = ACTIONS(5337),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5337),
    [anon_sym_GT_GT_GT] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_BANG_EQ] = ACTIONS(5331),
    [anon_sym_GT_EQ] = ACTIONS(5331),
    [anon_sym_LT_EQ] = ACTIONS(5331),
    [anon_sym_DOT] = ACTIONS(5337),
    [anon_sym_EQ_GT] = ACTIONS(5331),
    [anon_sym_switch] = ACTIONS(5331),
    [anon_sym_when] = ACTIONS(5331),
    [anon_sym_DOT_DOT] = ACTIONS(5331),
    [anon_sym_and] = ACTIONS(5331),
    [anon_sym_or] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_into] = ACTIONS(5331),
    [anon_sym_on] = ACTIONS(5331),
    [anon_sym_equals] = ACTIONS(5331),
    [anon_sym_by] = ACTIONS(5331),
    [anon_sym_as] = ACTIONS(5331),
    [anon_sym_is] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [anon_sym_with] = ACTIONS(5331),
    [aux_sym_preproc_if_token3] = ACTIONS(5331),
    [aux_sym_preproc_else_token1] = ACTIONS(5331),
    [aux_sym_preproc_elif_token1] = ACTIONS(5331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3838] = {
    [sym_preproc_region] = STATE(3838),
    [sym_preproc_endregion] = STATE(3838),
    [sym_preproc_line] = STATE(3838),
    [sym_preproc_pragma] = STATE(3838),
    [sym_preproc_nullable] = STATE(3838),
    [sym_preproc_error] = STATE(3838),
    [sym_preproc_define] = STATE(3838),
    [sym_preproc_undef] = STATE(3838),
    [anon_sym_EQ] = ACTIONS(5775),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_where] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5777),
    [anon_sym_DASH_EQ] = ACTIONS(5777),
    [anon_sym_STAR_EQ] = ACTIONS(5777),
    [anon_sym_SLASH_EQ] = ACTIONS(5777),
    [anon_sym_PERCENT_EQ] = ACTIONS(5777),
    [anon_sym_AMP_EQ] = ACTIONS(5777),
    [anon_sym_CARET_EQ] = ACTIONS(5777),
    [anon_sym_PIPE_EQ] = ACTIONS(5777),
    [anon_sym_LT_LT_EQ] = ACTIONS(5777),
    [anon_sym_GT_GT_EQ] = ACTIONS(5777),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5777),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5777),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_from] = ACTIONS(5294),
    [anon_sym_join] = ACTIONS(5294),
    [anon_sym_let] = ACTIONS(5294),
    [anon_sym_orderby] = ACTIONS(5294),
    [anon_sym_group] = ACTIONS(5294),
    [anon_sym_select] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3839] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7136),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9156),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3839),
    [sym_preproc_endregion] = STATE(3839),
    [sym_preproc_line] = STATE(3839),
    [sym_preproc_pragma] = STATE(3839),
    [sym_preproc_nullable] = STATE(3839),
    [sym_preproc_error] = STATE(3839),
    [sym_preproc_define] = STATE(3839),
    [sym_preproc_undef] = STATE(3839),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4138),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3840] = {
    [sym__name] = STATE(8985),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_identifier] = STATE(7895),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3840),
    [sym_preproc_endregion] = STATE(3840),
    [sym_preproc_line] = STATE(3840),
    [sym_preproc_pragma] = STATE(3840),
    [sym_preproc_nullable] = STATE(3840),
    [sym_preproc_error] = STATE(3840),
    [sym_preproc_define] = STATE(3840),
    [sym_preproc_undef] = STATE(3840),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3841] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9655),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3841),
    [sym_preproc_endregion] = STATE(3841),
    [sym_preproc_line] = STATE(3841),
    [sym_preproc_pragma] = STATE(3841),
    [sym_preproc_nullable] = STATE(3841),
    [sym_preproc_error] = STATE(3841),
    [sym_preproc_define] = STATE(3841),
    [sym_preproc_undef] = STATE(3841),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4217),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3842] = {
    [sym_type_argument_list] = STATE(3893),
    [sym_preproc_region] = STATE(3842),
    [sym_preproc_endregion] = STATE(3842),
    [sym_preproc_line] = STATE(3842),
    [sym_preproc_pragma] = STATE(3842),
    [sym_preproc_nullable] = STATE(3842),
    [sym_preproc_error] = STATE(3842),
    [sym_preproc_define] = STATE(3842),
    [sym_preproc_undef] = STATE(3842),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5751),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3843] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7131),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9501),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3843),
    [sym_preproc_endregion] = STATE(3843),
    [sym_preproc_line] = STATE(3843),
    [sym_preproc_pragma] = STATE(3843),
    [sym_preproc_nullable] = STATE(3843),
    [sym_preproc_error] = STATE(3843),
    [sym_preproc_define] = STATE(3843),
    [sym_preproc_undef] = STATE(3843),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4142),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3844] = {
    [sym__name] = STATE(8922),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3844),
    [sym_preproc_endregion] = STATE(3844),
    [sym_preproc_line] = STATE(3844),
    [sym_preproc_pragma] = STATE(3844),
    [sym_preproc_nullable] = STATE(3844),
    [sym_preproc_error] = STATE(3844),
    [sym_preproc_define] = STATE(3844),
    [sym_preproc_undef] = STATE(3844),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5779),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3845] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7141),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9368),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3845),
    [sym_preproc_endregion] = STATE(3845),
    [sym_preproc_line] = STATE(3845),
    [sym_preproc_pragma] = STATE(3845),
    [sym_preproc_nullable] = STATE(3845),
    [sym_preproc_error] = STATE(3845),
    [sym_preproc_define] = STATE(3845),
    [sym_preproc_undef] = STATE(3845),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4104),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3846] = {
    [sym__name] = STATE(8922),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_identifier] = STATE(7928),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3846),
    [sym_preproc_endregion] = STATE(3846),
    [sym_preproc_line] = STATE(3846),
    [sym_preproc_pragma] = STATE(3846),
    [sym_preproc_nullable] = STATE(3846),
    [sym_preproc_error] = STATE(3846),
    [sym_preproc_define] = STATE(3846),
    [sym_preproc_undef] = STATE(3846),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3847] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6982),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9446),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3847),
    [sym_preproc_endregion] = STATE(3847),
    [sym_preproc_line] = STATE(3847),
    [sym_preproc_pragma] = STATE(3847),
    [sym_preproc_nullable] = STATE(3847),
    [sym_preproc_error] = STATE(3847),
    [sym_preproc_define] = STATE(3847),
    [sym_preproc_undef] = STATE(3847),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4106),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3848] = {
    [sym_initializer_expression] = STATE(3967),
    [sym_preproc_region] = STATE(3848),
    [sym_preproc_endregion] = STATE(3848),
    [sym_preproc_line] = STATE(3848),
    [sym_preproc_pragma] = STATE(3848),
    [sym_preproc_nullable] = STATE(3848),
    [sym_preproc_error] = STATE(3848),
    [sym_preproc_define] = STATE(3848),
    [sym_preproc_undef] = STATE(3848),
    [anon_sym_SEMI] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [anon_sym_LPAREN] = ACTIONS(5315),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_in] = ACTIONS(5317),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_PIPE] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5317),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_GT_GT_GT] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5315),
    [anon_sym_BANG_EQ] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5315),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_DOT] = ACTIONS(5317),
    [anon_sym_EQ_GT] = ACTIONS(5315),
    [anon_sym_switch] = ACTIONS(5315),
    [anon_sym_when] = ACTIONS(5315),
    [anon_sym_DOT_DOT] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_or] = ACTIONS(5315),
    [anon_sym_AMP_AMP] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5315),
    [anon_sym_QMARK_QMARK] = ACTIONS(5315),
    [anon_sym_into] = ACTIONS(5315),
    [anon_sym_on] = ACTIONS(5315),
    [anon_sym_equals] = ACTIONS(5315),
    [anon_sym_by] = ACTIONS(5315),
    [anon_sym_as] = ACTIONS(5315),
    [anon_sym_is] = ACTIONS(5315),
    [anon_sym_DASH_GT] = ACTIONS(5315),
    [anon_sym_with] = ACTIONS(5315),
    [aux_sym_preproc_if_token3] = ACTIONS(5315),
    [aux_sym_preproc_else_token1] = ACTIONS(5315),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3849] = {
    [sym_argument_list] = STATE(3942),
    [sym_initializer_expression] = STATE(4306),
    [sym_preproc_region] = STATE(3849),
    [sym_preproc_endregion] = STATE(3849),
    [sym_preproc_line] = STATE(3849),
    [sym_preproc_pragma] = STATE(3849),
    [sym_preproc_nullable] = STATE(3849),
    [sym_preproc_error] = STATE(3849),
    [sym_preproc_define] = STATE(3849),
    [sym_preproc_undef] = STATE(3849),
    [anon_sym_SEMI] = ACTIONS(5263),
    [anon_sym_LBRACK] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5263),
    [anon_sym_COMMA] = ACTIONS(5263),
    [anon_sym_RBRACK] = ACTIONS(5263),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5263),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5267),
    [anon_sym_in] = ACTIONS(5263),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5263),
    [anon_sym_DASH_DASH] = ACTIONS(5263),
    [anon_sym_PLUS] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_SLASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5263),
    [anon_sym_CARET] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_LT_LT] = ACTIONS(5263),
    [anon_sym_GT_GT] = ACTIONS(5267),
    [anon_sym_GT_GT_GT] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_DOT] = ACTIONS(5267),
    [anon_sym_EQ_GT] = ACTIONS(5263),
    [anon_sym_switch] = ACTIONS(5263),
    [anon_sym_when] = ACTIONS(5263),
    [anon_sym_DOT_DOT] = ACTIONS(5263),
    [anon_sym_and] = ACTIONS(5263),
    [anon_sym_or] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_QMARK_QMARK] = ACTIONS(5263),
    [anon_sym_on] = ACTIONS(5263),
    [anon_sym_equals] = ACTIONS(5263),
    [anon_sym_by] = ACTIONS(5263),
    [anon_sym_as] = ACTIONS(5263),
    [anon_sym_is] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5263),
    [anon_sym_with] = ACTIONS(5263),
    [aux_sym_preproc_if_token3] = ACTIONS(5263),
    [aux_sym_preproc_else_token1] = ACTIONS(5263),
    [aux_sym_preproc_elif_token1] = ACTIONS(5263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3850] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7123),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9386),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3850),
    [sym_preproc_endregion] = STATE(3850),
    [sym_preproc_line] = STATE(3850),
    [sym_preproc_pragma] = STATE(3850),
    [sym_preproc_nullable] = STATE(3850),
    [sym_preproc_error] = STATE(3850),
    [sym_preproc_define] = STATE(3850),
    [sym_preproc_undef] = STATE(3850),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4147),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3851] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9183),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3851),
    [sym_preproc_endregion] = STATE(3851),
    [sym_preproc_line] = STATE(3851),
    [sym_preproc_pragma] = STATE(3851),
    [sym_preproc_nullable] = STATE(3851),
    [sym_preproc_error] = STATE(3851),
    [sym_preproc_define] = STATE(3851),
    [sym_preproc_undef] = STATE(3851),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4251),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3852] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9141),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3852),
    [sym_preproc_endregion] = STATE(3852),
    [sym_preproc_line] = STATE(3852),
    [sym_preproc_pragma] = STATE(3852),
    [sym_preproc_nullable] = STATE(3852),
    [sym_preproc_error] = STATE(3852),
    [sym_preproc_define] = STATE(3852),
    [sym_preproc_undef] = STATE(3852),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4230),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3853] = {
    [sym_type_argument_list] = STATE(3909),
    [sym_preproc_region] = STATE(3853),
    [sym_preproc_endregion] = STATE(3853),
    [sym_preproc_line] = STATE(3853),
    [sym_preproc_pragma] = STATE(3853),
    [sym_preproc_nullable] = STATE(3853),
    [sym_preproc_error] = STATE(3853),
    [sym_preproc_define] = STATE(3853),
    [sym_preproc_undef] = STATE(3853),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [3854] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7070),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9453),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3854),
    [sym_preproc_endregion] = STATE(3854),
    [sym_preproc_line] = STATE(3854),
    [sym_preproc_pragma] = STATE(3854),
    [sym_preproc_nullable] = STATE(3854),
    [sym_preproc_error] = STATE(3854),
    [sym_preproc_define] = STATE(3854),
    [sym_preproc_undef] = STATE(3854),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4177),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3855] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7007),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9637),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3855),
    [sym_preproc_endregion] = STATE(3855),
    [sym_preproc_line] = STATE(3855),
    [sym_preproc_pragma] = STATE(3855),
    [sym_preproc_nullable] = STATE(3855),
    [sym_preproc_error] = STATE(3855),
    [sym_preproc_define] = STATE(3855),
    [sym_preproc_undef] = STATE(3855),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4281),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3856] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7127),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9146),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3856),
    [sym_preproc_endregion] = STATE(3856),
    [sym_preproc_line] = STATE(3856),
    [sym_preproc_pragma] = STATE(3856),
    [sym_preproc_nullable] = STATE(3856),
    [sym_preproc_error] = STATE(3856),
    [sym_preproc_define] = STATE(3856),
    [sym_preproc_undef] = STATE(3856),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4318),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3857] = {
    [sym_argument_list] = STATE(3978),
    [sym_bracketed_argument_list] = STATE(3199),
    [sym_preproc_region] = STATE(3857),
    [sym_preproc_endregion] = STATE(3857),
    [sym_preproc_line] = STATE(3857),
    [sym_preproc_pragma] = STATE(3857),
    [sym_preproc_nullable] = STATE(3857),
    [sym_preproc_error] = STATE(3857),
    [sym_preproc_define] = STATE(3857),
    [sym_preproc_undef] = STATE(3857),
    [anon_sym_SEMI] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_RBRACK] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5313),
    [anon_sym_in] = ACTIONS(5313),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5764),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5313),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_GT_GT_GT] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5311),
    [anon_sym_BANG_EQ] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_DOT] = ACTIONS(4630),
    [anon_sym_EQ_GT] = ACTIONS(5311),
    [anon_sym_switch] = ACTIONS(5311),
    [anon_sym_when] = ACTIONS(5311),
    [anon_sym_DOT_DOT] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_or] = ACTIONS(5311),
    [anon_sym_AMP_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_QMARK_QMARK] = ACTIONS(5311),
    [anon_sym_into] = ACTIONS(5311),
    [anon_sym_on] = ACTIONS(5311),
    [anon_sym_equals] = ACTIONS(5311),
    [anon_sym_by] = ACTIONS(5311),
    [anon_sym_as] = ACTIONS(5311),
    [anon_sym_is] = ACTIONS(5311),
    [anon_sym_DASH_GT] = ACTIONS(4632),
    [anon_sym_with] = ACTIONS(5311),
    [aux_sym_preproc_if_token3] = ACTIONS(5311),
    [aux_sym_preproc_else_token1] = ACTIONS(5311),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3858] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7093),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9010),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3858),
    [sym_preproc_endregion] = STATE(3858),
    [sym_preproc_line] = STATE(3858),
    [sym_preproc_pragma] = STATE(3858),
    [sym_preproc_nullable] = STATE(3858),
    [sym_preproc_error] = STATE(3858),
    [sym_preproc_define] = STATE(3858),
    [sym_preproc_undef] = STATE(3858),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4176),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3859] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7115),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9486),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3859),
    [sym_preproc_endregion] = STATE(3859),
    [sym_preproc_line] = STATE(3859),
    [sym_preproc_pragma] = STATE(3859),
    [sym_preproc_nullable] = STATE(3859),
    [sym_preproc_error] = STATE(3859),
    [sym_preproc_define] = STATE(3859),
    [sym_preproc_undef] = STATE(3859),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4151),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3860] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7124),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9093),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3860),
    [sym_preproc_endregion] = STATE(3860),
    [sym_preproc_line] = STATE(3860),
    [sym_preproc_pragma] = STATE(3860),
    [sym_preproc_nullable] = STATE(3860),
    [sym_preproc_error] = STATE(3860),
    [sym_preproc_define] = STATE(3860),
    [sym_preproc_undef] = STATE(3860),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4152),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3861] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6996),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9203),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3861),
    [sym_preproc_endregion] = STATE(3861),
    [sym_preproc_line] = STATE(3861),
    [sym_preproc_pragma] = STATE(3861),
    [sym_preproc_nullable] = STATE(3861),
    [sym_preproc_error] = STATE(3861),
    [sym_preproc_define] = STATE(3861),
    [sym_preproc_undef] = STATE(3861),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4313),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3862] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6977),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9939),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3862),
    [sym_preproc_endregion] = STATE(3862),
    [sym_preproc_line] = STATE(3862),
    [sym_preproc_pragma] = STATE(3862),
    [sym_preproc_nullable] = STATE(3862),
    [sym_preproc_error] = STATE(3862),
    [sym_preproc_define] = STATE(3862),
    [sym_preproc_undef] = STATE(3862),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4129),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3863] = {
    [sym__name] = STATE(8985),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3863),
    [sym_preproc_endregion] = STATE(3863),
    [sym_preproc_line] = STATE(3863),
    [sym_preproc_pragma] = STATE(3863),
    [sym_preproc_nullable] = STATE(3863),
    [sym_preproc_error] = STATE(3863),
    [sym_preproc_define] = STATE(3863),
    [sym_preproc_undef] = STATE(3863),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5786),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(27),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3864] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7019),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9932),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3864),
    [sym_preproc_endregion] = STATE(3864),
    [sym_preproc_line] = STATE(3864),
    [sym_preproc_pragma] = STATE(3864),
    [sym_preproc_nullable] = STATE(3864),
    [sym_preproc_error] = STATE(3864),
    [sym_preproc_define] = STATE(3864),
    [sym_preproc_undef] = STATE(3864),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4277),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3865] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3865),
    [sym_preproc_endregion] = STATE(3865),
    [sym_preproc_line] = STATE(3865),
    [sym_preproc_pragma] = STATE(3865),
    [sym_preproc_nullable] = STATE(3865),
    [sym_preproc_error] = STATE(3865),
    [sym_preproc_define] = STATE(3865),
    [sym_preproc_undef] = STATE(3865),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4167),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3866] = {
    [sym_block] = STATE(2227),
    [sym_preproc_region] = STATE(3866),
    [sym_preproc_endregion] = STATE(3866),
    [sym_preproc_line] = STATE(3866),
    [sym_preproc_pragma] = STATE(3866),
    [sym_preproc_nullable] = STATE(3866),
    [sym_preproc_error] = STATE(3866),
    [sym_preproc_define] = STATE(3866),
    [sym_preproc_undef] = STATE(3866),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3867] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7024),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9590),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3867),
    [sym_preproc_endregion] = STATE(3867),
    [sym_preproc_line] = STATE(3867),
    [sym_preproc_pragma] = STATE(3867),
    [sym_preproc_nullable] = STATE(3867),
    [sym_preproc_error] = STATE(3867),
    [sym_preproc_define] = STATE(3867),
    [sym_preproc_undef] = STATE(3867),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4328),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3868] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7071),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9017),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3868),
    [sym_preproc_endregion] = STATE(3868),
    [sym_preproc_line] = STATE(3868),
    [sym_preproc_pragma] = STATE(3868),
    [sym_preproc_nullable] = STATE(3868),
    [sym_preproc_error] = STATE(3868),
    [sym_preproc_define] = STATE(3868),
    [sym_preproc_undef] = STATE(3868),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4315),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3869] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7051),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9184),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3869),
    [sym_preproc_endregion] = STATE(3869),
    [sym_preproc_line] = STATE(3869),
    [sym_preproc_pragma] = STATE(3869),
    [sym_preproc_nullable] = STATE(3869),
    [sym_preproc_error] = STATE(3869),
    [sym_preproc_define] = STATE(3869),
    [sym_preproc_undef] = STATE(3869),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4249),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3870] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7049),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9074),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3870),
    [sym_preproc_endregion] = STATE(3870),
    [sym_preproc_line] = STATE(3870),
    [sym_preproc_pragma] = STATE(3870),
    [sym_preproc_nullable] = STATE(3870),
    [sym_preproc_error] = STATE(3870),
    [sym_preproc_define] = STATE(3870),
    [sym_preproc_undef] = STATE(3870),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4181),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3871] = {
    [sym_preproc_region] = STATE(3871),
    [sym_preproc_endregion] = STATE(3871),
    [sym_preproc_line] = STATE(3871),
    [sym_preproc_pragma] = STATE(3871),
    [sym_preproc_nullable] = STATE(3871),
    [sym_preproc_error] = STATE(3871),
    [sym_preproc_define] = STATE(3871),
    [sym_preproc_undef] = STATE(3871),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(4086),
    [anon_sym_when] = ACTIONS(4086),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_into] = ACTIONS(4086),
    [anon_sym_on] = ACTIONS(4086),
    [anon_sym_equals] = ACTIONS(4086),
    [anon_sym_by] = ACTIONS(4086),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_is] = ACTIONS(4086),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3872] = {
    [sym_preproc_region] = STATE(3872),
    [sym_preproc_endregion] = STATE(3872),
    [sym_preproc_line] = STATE(3872),
    [sym_preproc_pragma] = STATE(3872),
    [sym_preproc_nullable] = STATE(3872),
    [sym_preproc_error] = STATE(3872),
    [sym_preproc_define] = STATE(3872),
    [sym_preproc_undef] = STATE(3872),
    [anon_sym_EQ] = ACTIONS(5790),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5792),
    [anon_sym_DASH_EQ] = ACTIONS(5792),
    [anon_sym_STAR_EQ] = ACTIONS(5792),
    [anon_sym_SLASH_EQ] = ACTIONS(5792),
    [anon_sym_PERCENT_EQ] = ACTIONS(5792),
    [anon_sym_AMP_EQ] = ACTIONS(5792),
    [anon_sym_CARET_EQ] = ACTIONS(5792),
    [anon_sym_PIPE_EQ] = ACTIONS(5792),
    [anon_sym_LT_LT_EQ] = ACTIONS(5792),
    [anon_sym_GT_GT_EQ] = ACTIONS(5792),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5792),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5792),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3873] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7087),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9039),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3873),
    [sym_preproc_endregion] = STATE(3873),
    [sym_preproc_line] = STATE(3873),
    [sym_preproc_pragma] = STATE(3873),
    [sym_preproc_nullable] = STATE(3873),
    [sym_preproc_error] = STATE(3873),
    [sym_preproc_define] = STATE(3873),
    [sym_preproc_undef] = STATE(3873),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4325),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3874] = {
    [sym_preproc_region] = STATE(3874),
    [sym_preproc_endregion] = STATE(3874),
    [sym_preproc_line] = STATE(3874),
    [sym_preproc_pragma] = STATE(3874),
    [sym_preproc_nullable] = STATE(3874),
    [sym_preproc_error] = STATE(3874),
    [sym_preproc_define] = STATE(3874),
    [sym_preproc_undef] = STATE(3874),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5796),
    [anon_sym_DASH_EQ] = ACTIONS(5796),
    [anon_sym_STAR_EQ] = ACTIONS(5796),
    [anon_sym_SLASH_EQ] = ACTIONS(5796),
    [anon_sym_PERCENT_EQ] = ACTIONS(5796),
    [anon_sym_AMP_EQ] = ACTIONS(5796),
    [anon_sym_CARET_EQ] = ACTIONS(5796),
    [anon_sym_PIPE_EQ] = ACTIONS(5796),
    [anon_sym_LT_LT_EQ] = ACTIONS(5796),
    [anon_sym_GT_GT_EQ] = ACTIONS(5796),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5796),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5796),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3875] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7032),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9492),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3875),
    [sym_preproc_endregion] = STATE(3875),
    [sym_preproc_line] = STATE(3875),
    [sym_preproc_pragma] = STATE(3875),
    [sym_preproc_nullable] = STATE(3875),
    [sym_preproc_error] = STATE(3875),
    [sym_preproc_define] = STATE(3875),
    [sym_preproc_undef] = STATE(3875),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4309),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3876] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7147),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9540),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3876),
    [sym_preproc_endregion] = STATE(3876),
    [sym_preproc_line] = STATE(3876),
    [sym_preproc_pragma] = STATE(3876),
    [sym_preproc_nullable] = STATE(3876),
    [sym_preproc_error] = STATE(3876),
    [sym_preproc_define] = STATE(3876),
    [sym_preproc_undef] = STATE(3876),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4121),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3877] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9424),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3877),
    [sym_preproc_endregion] = STATE(3877),
    [sym_preproc_line] = STATE(3877),
    [sym_preproc_pragma] = STATE(3877),
    [sym_preproc_nullable] = STATE(3877),
    [sym_preproc_error] = STATE(3877),
    [sym_preproc_define] = STATE(3877),
    [sym_preproc_undef] = STATE(3877),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4170),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3878] = {
    [sym_attribute_list] = STATE(6722),
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7004),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9741),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(3878),
    [sym_preproc_endregion] = STATE(3878),
    [sym_preproc_line] = STATE(3878),
    [sym_preproc_pragma] = STATE(3878),
    [sym_preproc_nullable] = STATE(3878),
    [sym_preproc_error] = STATE(3878),
    [sym_preproc_define] = STATE(3878),
    [sym_preproc_undef] = STATE(3878),
    [aux_sym_class_declaration_repeat1] = STATE(6232),
    [aux_sym_lambda_expression_repeat1] = STATE(4215),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(5272),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3879] = {
    [sym_preproc_region] = STATE(3879),
    [sym_preproc_endregion] = STATE(3879),
    [sym_preproc_line] = STATE(3879),
    [sym_preproc_pragma] = STATE(3879),
    [sym_preproc_nullable] = STATE(3879),
    [sym_preproc_error] = STATE(3879),
    [sym_preproc_define] = STATE(3879),
    [sym_preproc_undef] = STATE(3879),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_RBRACK] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_in] = ACTIONS(4484),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_EQ_GT] = ACTIONS(4486),
    [anon_sym_switch] = ACTIONS(4486),
    [anon_sym_when] = ACTIONS(4486),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4486),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_into] = ACTIONS(4486),
    [anon_sym_on] = ACTIONS(4486),
    [anon_sym_equals] = ACTIONS(4486),
    [anon_sym_by] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(4486),
    [anon_sym_is] = ACTIONS(4486),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4486),
    [aux_sym_preproc_if_token3] = ACTIONS(4486),
    [aux_sym_preproc_else_token1] = ACTIONS(4486),
    [aux_sym_preproc_elif_token1] = ACTIONS(4486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3880] = {
    [sym_initializer_expression] = STATE(4285),
    [sym_preproc_region] = STATE(3880),
    [sym_preproc_endregion] = STATE(3880),
    [sym_preproc_line] = STATE(3880),
    [sym_preproc_pragma] = STATE(3880),
    [sym_preproc_nullable] = STATE(3880),
    [sym_preproc_error] = STATE(3880),
    [sym_preproc_define] = STATE(3880),
    [sym_preproc_undef] = STATE(3880),
    [anon_sym_SEMI] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_RBRACK] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(5319),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_in] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_EQ_GT] = ACTIONS(5319),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_when] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5319),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_on] = ACTIONS(5319),
    [anon_sym_equals] = ACTIONS(5319),
    [anon_sym_by] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5319),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_if_token3] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3881] = {
    [sym_preproc_region] = STATE(3881),
    [sym_preproc_endregion] = STATE(3881),
    [sym_preproc_line] = STATE(3881),
    [sym_preproc_pragma] = STATE(3881),
    [sym_preproc_nullable] = STATE(3881),
    [sym_preproc_error] = STATE(3881),
    [sym_preproc_define] = STATE(3881),
    [sym_preproc_undef] = STATE(3881),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_COLON] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_LT] = ACTIONS(4652),
    [anon_sym_GT] = ACTIONS(4652),
    [anon_sym_QMARK] = ACTIONS(4652),
    [anon_sym_BANG] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4650),
    [anon_sym_DASH_DASH] = ACTIONS(4650),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_STAR] = ACTIONS(4652),
    [anon_sym_SLASH] = ACTIONS(4652),
    [anon_sym_PERCENT] = ACTIONS(4652),
    [anon_sym_CARET] = ACTIONS(4652),
    [anon_sym_PIPE] = ACTIONS(4652),
    [anon_sym_AMP] = ACTIONS(4652),
    [anon_sym_LT_LT] = ACTIONS(4652),
    [anon_sym_GT_GT] = ACTIONS(4652),
    [anon_sym_GT_GT_GT] = ACTIONS(4652),
    [anon_sym_EQ_EQ] = ACTIONS(4650),
    [anon_sym_BANG_EQ] = ACTIONS(4650),
    [anon_sym_GT_EQ] = ACTIONS(4650),
    [anon_sym_LT_EQ] = ACTIONS(4650),
    [anon_sym_DOT] = ACTIONS(4652),
    [anon_sym_switch] = ACTIONS(4650),
    [anon_sym_DOT_DOT] = ACTIONS(4650),
    [anon_sym_and] = ACTIONS(4650),
    [anon_sym_or] = ACTIONS(4650),
    [anon_sym_PLUS_EQ] = ACTIONS(4650),
    [anon_sym_DASH_EQ] = ACTIONS(4650),
    [anon_sym_STAR_EQ] = ACTIONS(4650),
    [anon_sym_SLASH_EQ] = ACTIONS(4650),
    [anon_sym_PERCENT_EQ] = ACTIONS(4650),
    [anon_sym_AMP_EQ] = ACTIONS(4650),
    [anon_sym_CARET_EQ] = ACTIONS(4650),
    [anon_sym_PIPE_EQ] = ACTIONS(4650),
    [anon_sym_LT_LT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4650),
    [anon_sym_AMP_AMP] = ACTIONS(4650),
    [anon_sym_PIPE_PIPE] = ACTIONS(4650),
    [anon_sym_QMARK_QMARK] = ACTIONS(4652),
    [anon_sym_into] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(4650),
    [anon_sym_is] = ACTIONS(4650),
    [anon_sym_DASH_GT] = ACTIONS(4650),
    [anon_sym_with] = ACTIONS(4650),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4650),
  },
  [3882] = {
    [sym_preproc_region] = STATE(3882),
    [sym_preproc_endregion] = STATE(3882),
    [sym_preproc_line] = STATE(3882),
    [sym_preproc_pragma] = STATE(3882),
    [sym_preproc_nullable] = STATE(3882),
    [sym_preproc_error] = STATE(3882),
    [sym_preproc_define] = STATE(3882),
    [sym_preproc_undef] = STATE(3882),
    [anon_sym_EQ] = ACTIONS(4134),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4134),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4134),
    [anon_sym_CARET] = ACTIONS(4134),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4134),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4134),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4136),
    [anon_sym_PLUS_EQ] = ACTIONS(4136),
    [anon_sym_DASH_EQ] = ACTIONS(4136),
    [anon_sym_STAR_EQ] = ACTIONS(4136),
    [anon_sym_SLASH_EQ] = ACTIONS(4136),
    [anon_sym_PERCENT_EQ] = ACTIONS(4136),
    [anon_sym_AMP_EQ] = ACTIONS(4136),
    [anon_sym_CARET_EQ] = ACTIONS(4136),
    [anon_sym_PIPE_EQ] = ACTIONS(4136),
    [anon_sym_LT_LT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4134),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4136),
  },
  [3883] = {
    [sym_preproc_region] = STATE(3883),
    [sym_preproc_endregion] = STATE(3883),
    [sym_preproc_line] = STATE(3883),
    [sym_preproc_pragma] = STATE(3883),
    [sym_preproc_nullable] = STATE(3883),
    [sym_preproc_error] = STATE(3883),
    [sym_preproc_define] = STATE(3883),
    [sym_preproc_undef] = STATE(3883),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_in] = ACTIONS(4602),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_when] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_into] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3884] = {
    [sym_preproc_region] = STATE(3884),
    [sym_preproc_endregion] = STATE(3884),
    [sym_preproc_line] = STATE(3884),
    [sym_preproc_pragma] = STATE(3884),
    [sym_preproc_nullable] = STATE(3884),
    [sym_preproc_error] = STATE(3884),
    [sym_preproc_define] = STATE(3884),
    [sym_preproc_undef] = STATE(3884),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_COLON] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(4638),
    [anon_sym_GT] = ACTIONS(4638),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_BANG] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_SLASH] = ACTIONS(4638),
    [anon_sym_PERCENT] = ACTIONS(4638),
    [anon_sym_CARET] = ACTIONS(4638),
    [anon_sym_PIPE] = ACTIONS(4638),
    [anon_sym_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4638),
    [anon_sym_GT_GT] = ACTIONS(4638),
    [anon_sym_GT_GT_GT] = ACTIONS(4638),
    [anon_sym_EQ_EQ] = ACTIONS(4640),
    [anon_sym_BANG_EQ] = ACTIONS(4640),
    [anon_sym_GT_EQ] = ACTIONS(4640),
    [anon_sym_LT_EQ] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4638),
    [anon_sym_switch] = ACTIONS(4640),
    [anon_sym_DOT_DOT] = ACTIONS(4640),
    [anon_sym_and] = ACTIONS(4640),
    [anon_sym_or] = ACTIONS(4640),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4640),
    [anon_sym_PIPE_PIPE] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK] = ACTIONS(4638),
    [anon_sym_into] = ACTIONS(4640),
    [anon_sym_as] = ACTIONS(4640),
    [anon_sym_is] = ACTIONS(4640),
    [anon_sym_DASH_GT] = ACTIONS(4640),
    [anon_sym_with] = ACTIONS(4640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4640),
  },
  [3885] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3503),
    [sym_preproc_region] = STATE(3885),
    [sym_preproc_endregion] = STATE(3885),
    [sym_preproc_line] = STATE(3885),
    [sym_preproc_pragma] = STATE(3885),
    [sym_preproc_nullable] = STATE(3885),
    [sym_preproc_error] = STATE(3885),
    [sym_preproc_define] = STATE(3885),
    [sym_preproc_undef] = STATE(3885),
    [anon_sym_SEMI] = ACTIONS(5282),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5282),
    [anon_sym_COMMA] = ACTIONS(5282),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5282),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LT] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_in] = ACTIONS(5282),
    [anon_sym_QMARK] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_DASH] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5282),
    [anon_sym_SLASH] = ACTIONS(5286),
    [anon_sym_PERCENT] = ACTIONS(5282),
    [anon_sym_CARET] = ACTIONS(5282),
    [anon_sym_PIPE] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5286),
    [anon_sym_LT_LT] = ACTIONS(5282),
    [anon_sym_GT_GT] = ACTIONS(5286),
    [anon_sym_GT_GT_GT] = ACTIONS(5282),
    [anon_sym_EQ_EQ] = ACTIONS(5282),
    [anon_sym_BANG_EQ] = ACTIONS(5282),
    [anon_sym_GT_EQ] = ACTIONS(5282),
    [anon_sym_LT_EQ] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5282),
    [anon_sym_switch] = ACTIONS(5282),
    [anon_sym_when] = ACTIONS(5282),
    [anon_sym_DOT_DOT] = ACTIONS(5282),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_or] = ACTIONS(5282),
    [anon_sym_AMP_AMP] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5282),
    [anon_sym_QMARK_QMARK] = ACTIONS(5282),
    [anon_sym_on] = ACTIONS(5282),
    [anon_sym_equals] = ACTIONS(5282),
    [anon_sym_by] = ACTIONS(5282),
    [anon_sym_as] = ACTIONS(5282),
    [anon_sym_is] = ACTIONS(5282),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5282),
    [aux_sym_preproc_if_token3] = ACTIONS(5282),
    [aux_sym_preproc_else_token1] = ACTIONS(5282),
    [aux_sym_preproc_elif_token1] = ACTIONS(5282),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3886] = {
    [sym_preproc_region] = STATE(3886),
    [sym_preproc_endregion] = STATE(3886),
    [sym_preproc_line] = STATE(3886),
    [sym_preproc_pragma] = STATE(3886),
    [sym_preproc_nullable] = STATE(3886),
    [sym_preproc_error] = STATE(3886),
    [sym_preproc_define] = STATE(3886),
    [sym_preproc_undef] = STATE(3886),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3991),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3887] = {
    [sym_preproc_region] = STATE(3887),
    [sym_preproc_endregion] = STATE(3887),
    [sym_preproc_line] = STATE(3887),
    [sym_preproc_pragma] = STATE(3887),
    [sym_preproc_nullable] = STATE(3887),
    [sym_preproc_error] = STATE(3887),
    [sym_preproc_define] = STATE(3887),
    [sym_preproc_undef] = STATE(3887),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4120),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4122),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_COLON_COLON] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_when] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3888] = {
    [sym_preproc_region] = STATE(3888),
    [sym_preproc_endregion] = STATE(3888),
    [sym_preproc_line] = STATE(3888),
    [sym_preproc_pragma] = STATE(3888),
    [sym_preproc_nullable] = STATE(3888),
    [sym_preproc_error] = STATE(3888),
    [sym_preproc_define] = STATE(3888),
    [sym_preproc_undef] = STATE(3888),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4167),
    [anon_sym_or] = ACTIONS(4167),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_into] = ACTIONS(4167),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4167),
  },
  [3889] = {
    [sym_preproc_region] = STATE(3889),
    [sym_preproc_endregion] = STATE(3889),
    [sym_preproc_line] = STATE(3889),
    [sym_preproc_pragma] = STATE(3889),
    [sym_preproc_nullable] = STATE(3889),
    [sym_preproc_error] = STATE(3889),
    [sym_preproc_define] = STATE(3889),
    [sym_preproc_undef] = STATE(3889),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_when] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_into] = ACTIONS(4178),
    [anon_sym_on] = ACTIONS(4178),
    [anon_sym_equals] = ACTIONS(4178),
    [anon_sym_by] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4178),
    [anon_sym_is] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4178),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3890] = {
    [sym_preproc_region] = STATE(3890),
    [sym_preproc_endregion] = STATE(3890),
    [sym_preproc_line] = STATE(3890),
    [sym_preproc_pragma] = STATE(3890),
    [sym_preproc_nullable] = STATE(3890),
    [sym_preproc_error] = STATE(3890),
    [sym_preproc_define] = STATE(3890),
    [sym_preproc_undef] = STATE(3890),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_switch] = ACTIONS(4620),
    [anon_sym_when] = ACTIONS(4620),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4620),
    [anon_sym_or] = ACTIONS(4620),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_into] = ACTIONS(4620),
    [anon_sym_on] = ACTIONS(4620),
    [anon_sym_equals] = ACTIONS(4620),
    [anon_sym_by] = ACTIONS(4620),
    [anon_sym_as] = ACTIONS(4620),
    [anon_sym_is] = ACTIONS(4620),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4620),
    [aux_sym_preproc_if_token3] = ACTIONS(4620),
    [aux_sym_preproc_else_token1] = ACTIONS(4620),
    [aux_sym_preproc_elif_token1] = ACTIONS(4620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3891] = {
    [sym_preproc_region] = STATE(3891),
    [sym_preproc_endregion] = STATE(3891),
    [sym_preproc_line] = STATE(3891),
    [sym_preproc_pragma] = STATE(3891),
    [sym_preproc_nullable] = STATE(3891),
    [sym_preproc_error] = STATE(3891),
    [sym_preproc_define] = STATE(3891),
    [sym_preproc_undef] = STATE(3891),
    [anon_sym_EQ] = ACTIONS(4697),
    [anon_sym_LBRACK] = ACTIONS(4695),
    [anon_sym_COLON] = ACTIONS(4695),
    [anon_sym_COMMA] = ACTIONS(4695),
    [anon_sym_LPAREN] = ACTIONS(4695),
    [anon_sym_LT] = ACTIONS(4697),
    [anon_sym_GT] = ACTIONS(4697),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_BANG] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4695),
    [anon_sym_DASH_DASH] = ACTIONS(4695),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_STAR] = ACTIONS(4697),
    [anon_sym_SLASH] = ACTIONS(4697),
    [anon_sym_PERCENT] = ACTIONS(4697),
    [anon_sym_CARET] = ACTIONS(4697),
    [anon_sym_PIPE] = ACTIONS(4697),
    [anon_sym_AMP] = ACTIONS(4697),
    [anon_sym_LT_LT] = ACTIONS(4697),
    [anon_sym_GT_GT] = ACTIONS(4697),
    [anon_sym_GT_GT_GT] = ACTIONS(4697),
    [anon_sym_EQ_EQ] = ACTIONS(4695),
    [anon_sym_BANG_EQ] = ACTIONS(4695),
    [anon_sym_GT_EQ] = ACTIONS(4695),
    [anon_sym_LT_EQ] = ACTIONS(4695),
    [anon_sym_DOT] = ACTIONS(4697),
    [anon_sym_switch] = ACTIONS(4695),
    [anon_sym_DOT_DOT] = ACTIONS(4695),
    [anon_sym_and] = ACTIONS(4695),
    [anon_sym_or] = ACTIONS(4695),
    [anon_sym_PLUS_EQ] = ACTIONS(4695),
    [anon_sym_DASH_EQ] = ACTIONS(4695),
    [anon_sym_STAR_EQ] = ACTIONS(4695),
    [anon_sym_SLASH_EQ] = ACTIONS(4695),
    [anon_sym_PERCENT_EQ] = ACTIONS(4695),
    [anon_sym_AMP_EQ] = ACTIONS(4695),
    [anon_sym_CARET_EQ] = ACTIONS(4695),
    [anon_sym_PIPE_EQ] = ACTIONS(4695),
    [anon_sym_LT_LT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4695),
    [anon_sym_AMP_AMP] = ACTIONS(4695),
    [anon_sym_PIPE_PIPE] = ACTIONS(4695),
    [anon_sym_QMARK_QMARK] = ACTIONS(4697),
    [anon_sym_into] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(4695),
    [anon_sym_is] = ACTIONS(4695),
    [anon_sym_DASH_GT] = ACTIONS(4695),
    [anon_sym_with] = ACTIONS(4695),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4695),
  },
  [3892] = {
    [sym_preproc_region] = STATE(3892),
    [sym_preproc_endregion] = STATE(3892),
    [sym_preproc_line] = STATE(3892),
    [sym_preproc_pragma] = STATE(3892),
    [sym_preproc_nullable] = STATE(3892),
    [sym_preproc_error] = STATE(3892),
    [sym_preproc_define] = STATE(3892),
    [sym_preproc_undef] = STATE(3892),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3893] = {
    [sym_preproc_region] = STATE(3893),
    [sym_preproc_endregion] = STATE(3893),
    [sym_preproc_line] = STATE(3893),
    [sym_preproc_pragma] = STATE(3893),
    [sym_preproc_nullable] = STATE(3893),
    [sym_preproc_error] = STATE(3893),
    [sym_preproc_define] = STATE(3893),
    [sym_preproc_undef] = STATE(3893),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3894] = {
    [sym_preproc_region] = STATE(3894),
    [sym_preproc_endregion] = STATE(3894),
    [sym_preproc_line] = STATE(3894),
    [sym_preproc_pragma] = STATE(3894),
    [sym_preproc_nullable] = STATE(3894),
    [sym_preproc_error] = STATE(3894),
    [sym_preproc_define] = STATE(3894),
    [sym_preproc_undef] = STATE(3894),
    [sym__identifier_token] = ACTIONS(4037),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4037),
    [anon_sym_global] = ACTIONS(4037),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4037),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4037),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4037),
    [anon_sym_unmanaged] = ACTIONS(4037),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4037),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4037),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4037),
    [anon_sym_when] = ACTIONS(4037),
    [anon_sym_from] = ACTIONS(4037),
    [anon_sym_into] = ACTIONS(4037),
    [anon_sym_join] = ACTIONS(4037),
    [anon_sym_on] = ACTIONS(4037),
    [anon_sym_equals] = ACTIONS(4037),
    [anon_sym_let] = ACTIONS(4037),
    [anon_sym_orderby] = ACTIONS(4037),
    [anon_sym_ascending] = ACTIONS(4037),
    [anon_sym_descending] = ACTIONS(4037),
    [anon_sym_group] = ACTIONS(4037),
    [anon_sym_by] = ACTIONS(4037),
    [anon_sym_select] = ACTIONS(4037),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3895] = {
    [sym_preproc_region] = STATE(3895),
    [sym_preproc_endregion] = STATE(3895),
    [sym_preproc_line] = STATE(3895),
    [sym_preproc_pragma] = STATE(3895),
    [sym_preproc_nullable] = STATE(3895),
    [sym_preproc_error] = STATE(3895),
    [sym_preproc_define] = STATE(3895),
    [sym_preproc_undef] = STATE(3895),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(5804),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5806),
    [anon_sym_DASH_EQ] = ACTIONS(5806),
    [anon_sym_STAR_EQ] = ACTIONS(5806),
    [anon_sym_SLASH_EQ] = ACTIONS(5806),
    [anon_sym_PERCENT_EQ] = ACTIONS(5806),
    [anon_sym_AMP_EQ] = ACTIONS(5806),
    [anon_sym_CARET_EQ] = ACTIONS(5806),
    [anon_sym_PIPE_EQ] = ACTIONS(5806),
    [anon_sym_LT_LT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5806),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5806),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3896] = {
    [sym_preproc_region] = STATE(3896),
    [sym_preproc_endregion] = STATE(3896),
    [sym_preproc_line] = STATE(3896),
    [sym_preproc_pragma] = STATE(3896),
    [sym_preproc_nullable] = STATE(3896),
    [sym_preproc_error] = STATE(3896),
    [sym_preproc_define] = STATE(3896),
    [sym_preproc_undef] = STATE(3896),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_RBRACK] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_in] = ACTIONS(4622),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_EQ_GT] = ACTIONS(4624),
    [anon_sym_switch] = ACTIONS(4624),
    [anon_sym_when] = ACTIONS(4624),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4624),
    [anon_sym_or] = ACTIONS(4624),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_into] = ACTIONS(4624),
    [anon_sym_on] = ACTIONS(4624),
    [anon_sym_equals] = ACTIONS(4624),
    [anon_sym_by] = ACTIONS(4624),
    [anon_sym_as] = ACTIONS(4624),
    [anon_sym_is] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4624),
    [aux_sym_preproc_if_token3] = ACTIONS(4624),
    [aux_sym_preproc_else_token1] = ACTIONS(4624),
    [aux_sym_preproc_elif_token1] = ACTIONS(4624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3897] = {
    [sym_preproc_region] = STATE(3897),
    [sym_preproc_endregion] = STATE(3897),
    [sym_preproc_line] = STATE(3897),
    [sym_preproc_pragma] = STATE(3897),
    [sym_preproc_nullable] = STATE(3897),
    [sym_preproc_error] = STATE(3897),
    [sym_preproc_define] = STATE(3897),
    [sym_preproc_undef] = STATE(3897),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_EQ_GT] = ACTIONS(4536),
    [anon_sym_switch] = ACTIONS(4536),
    [anon_sym_when] = ACTIONS(4536),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_into] = ACTIONS(4536),
    [anon_sym_on] = ACTIONS(4536),
    [anon_sym_equals] = ACTIONS(4536),
    [anon_sym_by] = ACTIONS(4536),
    [anon_sym_as] = ACTIONS(4536),
    [anon_sym_is] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4536),
    [aux_sym_preproc_if_token3] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3898] = {
    [sym_preproc_region] = STATE(3898),
    [sym_preproc_endregion] = STATE(3898),
    [sym_preproc_line] = STATE(3898),
    [sym_preproc_pragma] = STATE(3898),
    [sym_preproc_nullable] = STATE(3898),
    [sym_preproc_error] = STATE(3898),
    [sym_preproc_define] = STATE(3898),
    [sym_preproc_undef] = STATE(3898),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4134),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_when] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3899] = {
    [sym_preproc_region] = STATE(3899),
    [sym_preproc_endregion] = STATE(3899),
    [sym_preproc_line] = STATE(3899),
    [sym_preproc_pragma] = STATE(3899),
    [sym_preproc_nullable] = STATE(3899),
    [sym_preproc_error] = STATE(3899),
    [sym_preproc_define] = STATE(3899),
    [sym_preproc_undef] = STATE(3899),
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4130),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4130),
    [anon_sym_CARET] = ACTIONS(4130),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4130),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4130),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4132),
    [anon_sym_PLUS_EQ] = ACTIONS(4132),
    [anon_sym_DASH_EQ] = ACTIONS(4132),
    [anon_sym_STAR_EQ] = ACTIONS(4132),
    [anon_sym_SLASH_EQ] = ACTIONS(4132),
    [anon_sym_PERCENT_EQ] = ACTIONS(4132),
    [anon_sym_AMP_EQ] = ACTIONS(4132),
    [anon_sym_CARET_EQ] = ACTIONS(4132),
    [anon_sym_PIPE_EQ] = ACTIONS(4132),
    [anon_sym_LT_LT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4130),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4132),
  },
  [3900] = {
    [sym_preproc_region] = STATE(3900),
    [sym_preproc_endregion] = STATE(3900),
    [sym_preproc_line] = STATE(3900),
    [sym_preproc_pragma] = STATE(3900),
    [sym_preproc_nullable] = STATE(3900),
    [sym_preproc_error] = STATE(3900),
    [sym_preproc_define] = STATE(3900),
    [sym_preproc_undef] = STATE(3900),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5384),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_into] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [sym_string_literal_encoding] = ACTIONS(5808),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3901] = {
    [sym_type_argument_list] = STATE(4063),
    [sym_preproc_region] = STATE(3901),
    [sym_preproc_endregion] = STATE(3901),
    [sym_preproc_line] = STATE(3901),
    [sym_preproc_pragma] = STATE(3901),
    [sym_preproc_nullable] = STATE(3901),
    [sym_preproc_error] = STATE(3901),
    [sym_preproc_define] = STATE(3901),
    [sym_preproc_undef] = STATE(3901),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3902] = {
    [sym_preproc_region] = STATE(3902),
    [sym_preproc_endregion] = STATE(3902),
    [sym_preproc_line] = STATE(3902),
    [sym_preproc_pragma] = STATE(3902),
    [sym_preproc_nullable] = STATE(3902),
    [sym_preproc_error] = STATE(3902),
    [sym_preproc_define] = STATE(3902),
    [sym_preproc_undef] = STATE(3902),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_RBRACK] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_EQ_GT] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4496),
    [aux_sym_preproc_else_token1] = ACTIONS(4496),
    [aux_sym_preproc_elif_token1] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3903] = {
    [sym_preproc_region] = STATE(3903),
    [sym_preproc_endregion] = STATE(3903),
    [sym_preproc_line] = STATE(3903),
    [sym_preproc_pragma] = STATE(3903),
    [sym_preproc_nullable] = STATE(3903),
    [sym_preproc_error] = STATE(3903),
    [sym_preproc_define] = STATE(3903),
    [sym_preproc_undef] = STATE(3903),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RBRACK] = ACTIONS(5351),
    [anon_sym_LPAREN] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5353),
    [anon_sym_GT] = ACTIONS(5353),
    [anon_sym_in] = ACTIONS(5351),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_BANG] = ACTIONS(5353),
    [anon_sym_PLUS_PLUS] = ACTIONS(5351),
    [anon_sym_DASH_DASH] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5353),
    [anon_sym_DASH] = ACTIONS(5353),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5353),
    [anon_sym_PERCENT] = ACTIONS(5351),
    [anon_sym_CARET] = ACTIONS(5351),
    [anon_sym_PIPE] = ACTIONS(5353),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_LT_LT] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5353),
    [anon_sym_GT_GT_GT] = ACTIONS(5351),
    [anon_sym_EQ_EQ] = ACTIONS(5351),
    [anon_sym_BANG_EQ] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5353),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_switch] = ACTIONS(5351),
    [anon_sym_when] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5351),
    [anon_sym_and] = ACTIONS(5351),
    [anon_sym_or] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_on] = ACTIONS(5351),
    [anon_sym_equals] = ACTIONS(5351),
    [anon_sym_by] = ACTIONS(5351),
    [anon_sym_as] = ACTIONS(5351),
    [anon_sym_is] = ACTIONS(5351),
    [anon_sym_DQUOTE] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_with] = ACTIONS(5351),
    [sym_string_literal_encoding] = ACTIONS(5813),
    [aux_sym_preproc_if_token3] = ACTIONS(5351),
    [aux_sym_preproc_else_token1] = ACTIONS(5351),
    [aux_sym_preproc_elif_token1] = ACTIONS(5351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3904] = {
    [sym_preproc_region] = STATE(3904),
    [sym_preproc_endregion] = STATE(3904),
    [sym_preproc_line] = STATE(3904),
    [sym_preproc_pragma] = STATE(3904),
    [sym_preproc_nullable] = STATE(3904),
    [sym_preproc_error] = STATE(3904),
    [sym_preproc_define] = STATE(3904),
    [sym_preproc_undef] = STATE(3904),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_RBRACK] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_in] = ACTIONS(4498),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_switch] = ACTIONS(4500),
    [anon_sym_when] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4500),
    [anon_sym_or] = ACTIONS(4500),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_into] = ACTIONS(4500),
    [anon_sym_on] = ACTIONS(4500),
    [anon_sym_equals] = ACTIONS(4500),
    [anon_sym_by] = ACTIONS(4500),
    [anon_sym_as] = ACTIONS(4500),
    [anon_sym_is] = ACTIONS(4500),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4500),
    [aux_sym_preproc_if_token3] = ACTIONS(4500),
    [aux_sym_preproc_else_token1] = ACTIONS(4500),
    [aux_sym_preproc_elif_token1] = ACTIONS(4500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3905] = {
    [sym_preproc_region] = STATE(3905),
    [sym_preproc_endregion] = STATE(3905),
    [sym_preproc_line] = STATE(3905),
    [sym_preproc_pragma] = STATE(3905),
    [sym_preproc_nullable] = STATE(3905),
    [sym_preproc_error] = STATE(3905),
    [sym_preproc_define] = STATE(3905),
    [sym_preproc_undef] = STATE(3905),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_in] = ACTIONS(4577),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_EQ_GT] = ACTIONS(4579),
    [anon_sym_switch] = ACTIONS(4579),
    [anon_sym_when] = ACTIONS(4579),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4579),
    [anon_sym_or] = ACTIONS(4579),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_into] = ACTIONS(4579),
    [anon_sym_on] = ACTIONS(4579),
    [anon_sym_equals] = ACTIONS(4579),
    [anon_sym_by] = ACTIONS(4579),
    [anon_sym_as] = ACTIONS(4579),
    [anon_sym_is] = ACTIONS(4579),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4579),
    [aux_sym_preproc_if_token3] = ACTIONS(4579),
    [aux_sym_preproc_else_token1] = ACTIONS(4579),
    [aux_sym_preproc_elif_token1] = ACTIONS(4579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3906] = {
    [sym_preproc_region] = STATE(3906),
    [sym_preproc_endregion] = STATE(3906),
    [sym_preproc_line] = STATE(3906),
    [sym_preproc_pragma] = STATE(3906),
    [sym_preproc_nullable] = STATE(3906),
    [sym_preproc_error] = STATE(3906),
    [sym_preproc_define] = STATE(3906),
    [sym_preproc_undef] = STATE(3906),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_RBRACK] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_in] = ACTIONS(4471),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4473),
    [anon_sym_switch] = ACTIONS(4473),
    [anon_sym_when] = ACTIONS(4473),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4473),
    [anon_sym_or] = ACTIONS(4473),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_into] = ACTIONS(4473),
    [anon_sym_on] = ACTIONS(4473),
    [anon_sym_equals] = ACTIONS(4473),
    [anon_sym_by] = ACTIONS(4473),
    [anon_sym_as] = ACTIONS(4473),
    [anon_sym_is] = ACTIONS(4473),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4473),
    [aux_sym_preproc_if_token3] = ACTIONS(4473),
    [aux_sym_preproc_else_token1] = ACTIONS(4473),
    [aux_sym_preproc_elif_token1] = ACTIONS(4473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3907] = {
    [sym_preproc_region] = STATE(3907),
    [sym_preproc_endregion] = STATE(3907),
    [sym_preproc_line] = STATE(3907),
    [sym_preproc_pragma] = STATE(3907),
    [sym_preproc_nullable] = STATE(3907),
    [sym_preproc_error] = STATE(3907),
    [sym_preproc_define] = STATE(3907),
    [sym_preproc_undef] = STATE(3907),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4429),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_switch] = ACTIONS(4431),
    [anon_sym_when] = ACTIONS(4431),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4431),
    [anon_sym_or] = ACTIONS(4431),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_into] = ACTIONS(4431),
    [anon_sym_on] = ACTIONS(4431),
    [anon_sym_equals] = ACTIONS(4431),
    [anon_sym_by] = ACTIONS(4431),
    [anon_sym_as] = ACTIONS(4431),
    [anon_sym_is] = ACTIONS(4431),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4431),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3908] = {
    [sym_preproc_region] = STATE(3908),
    [sym_preproc_endregion] = STATE(3908),
    [sym_preproc_line] = STATE(3908),
    [sym_preproc_pragma] = STATE(3908),
    [sym_preproc_nullable] = STATE(3908),
    [sym_preproc_error] = STATE(3908),
    [sym_preproc_define] = STATE(3908),
    [sym_preproc_undef] = STATE(3908),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COMMA] = ACTIONS(5370),
    [anon_sym_RBRACK] = ACTIONS(5370),
    [anon_sym_LPAREN] = ACTIONS(5370),
    [anon_sym_RPAREN] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5370),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5372),
    [anon_sym_in] = ACTIONS(5370),
    [anon_sym_where] = ACTIONS(5370),
    [anon_sym_QMARK] = ACTIONS(5372),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5370),
    [anon_sym_DASH_DASH] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5370),
    [anon_sym_SLASH] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_LT_LT] = ACTIONS(5370),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_GT_GT_GT] = ACTIONS(5370),
    [anon_sym_EQ_EQ] = ACTIONS(5370),
    [anon_sym_BANG_EQ] = ACTIONS(5370),
    [anon_sym_GT_EQ] = ACTIONS(5370),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(5372),
    [anon_sym_EQ_GT] = ACTIONS(5370),
    [anon_sym_switch] = ACTIONS(5370),
    [anon_sym_when] = ACTIONS(5370),
    [anon_sym_DOT_DOT] = ACTIONS(5370),
    [anon_sym_and] = ACTIONS(5370),
    [anon_sym_or] = ACTIONS(5370),
    [anon_sym_AMP_AMP] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE] = ACTIONS(5370),
    [anon_sym_QMARK_QMARK] = ACTIONS(5370),
    [anon_sym_on] = ACTIONS(5370),
    [anon_sym_equals] = ACTIONS(5370),
    [anon_sym_by] = ACTIONS(5370),
    [anon_sym_as] = ACTIONS(5370),
    [anon_sym_is] = ACTIONS(5370),
    [anon_sym_DASH_GT] = ACTIONS(5370),
    [anon_sym_with] = ACTIONS(5370),
    [aux_sym_preproc_if_token3] = ACTIONS(5370),
    [aux_sym_preproc_else_token1] = ACTIONS(5370),
    [aux_sym_preproc_elif_token1] = ACTIONS(5370),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3909] = {
    [sym_preproc_region] = STATE(3909),
    [sym_preproc_endregion] = STATE(3909),
    [sym_preproc_line] = STATE(3909),
    [sym_preproc_pragma] = STATE(3909),
    [sym_preproc_nullable] = STATE(3909),
    [sym_preproc_error] = STATE(3909),
    [sym_preproc_define] = STATE(3909),
    [sym_preproc_undef] = STATE(3909),
    [anon_sym_EQ] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4142),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4142),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4142),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_PLUS_EQ] = ACTIONS(4144),
    [anon_sym_DASH_EQ] = ACTIONS(4144),
    [anon_sym_STAR_EQ] = ACTIONS(4144),
    [anon_sym_SLASH_EQ] = ACTIONS(4144),
    [anon_sym_PERCENT_EQ] = ACTIONS(4144),
    [anon_sym_AMP_EQ] = ACTIONS(4144),
    [anon_sym_CARET_EQ] = ACTIONS(4144),
    [anon_sym_PIPE_EQ] = ACTIONS(4144),
    [anon_sym_LT_LT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4142),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4144),
  },
  [3910] = {
    [sym_preproc_region] = STATE(3910),
    [sym_preproc_endregion] = STATE(3910),
    [sym_preproc_line] = STATE(3910),
    [sym_preproc_pragma] = STATE(3910),
    [sym_preproc_nullable] = STATE(3910),
    [sym_preproc_error] = STATE(3910),
    [sym_preproc_define] = STATE(3910),
    [sym_preproc_undef] = STATE(3910),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_LBRACK] = ACTIONS(4086),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_RBRACK] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(4086),
    [anon_sym_RPAREN] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_in] = ACTIONS(4086),
    [anon_sym_QMARK] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(4086),
    [anon_sym_DASH_DASH] = ACTIONS(4086),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_STAR] = ACTIONS(4086),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4086),
    [anon_sym_CARET] = ACTIONS(4086),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_LT_LT] = ACTIONS(4086),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(4086),
    [anon_sym_EQ_EQ] = ACTIONS(4086),
    [anon_sym_BANG_EQ] = ACTIONS(4086),
    [anon_sym_GT_EQ] = ACTIONS(4086),
    [anon_sym_LT_EQ] = ACTIONS(4086),
    [anon_sym_DOT] = ACTIONS(4089),
    [anon_sym_EQ_GT] = ACTIONS(4086),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(4086),
    [anon_sym_when] = ACTIONS(4086),
    [anon_sym_DOT_DOT] = ACTIONS(4086),
    [anon_sym_and] = ACTIONS(4086),
    [anon_sym_or] = ACTIONS(4086),
    [anon_sym_AMP_AMP] = ACTIONS(4086),
    [anon_sym_PIPE_PIPE] = ACTIONS(4086),
    [anon_sym_QMARK_QMARK] = ACTIONS(4086),
    [anon_sym_on] = ACTIONS(4086),
    [anon_sym_equals] = ACTIONS(4086),
    [anon_sym_by] = ACTIONS(4086),
    [anon_sym_as] = ACTIONS(4086),
    [anon_sym_is] = ACTIONS(4086),
    [anon_sym_DASH_GT] = ACTIONS(4086),
    [anon_sym_with] = ACTIONS(4086),
    [aux_sym_preproc_if_token3] = ACTIONS(4086),
    [aux_sym_preproc_else_token1] = ACTIONS(4086),
    [aux_sym_preproc_elif_token1] = ACTIONS(4086),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3911] = {
    [sym_preproc_region] = STATE(3911),
    [sym_preproc_endregion] = STATE(3911),
    [sym_preproc_line] = STATE(3911),
    [sym_preproc_pragma] = STATE(3911),
    [sym_preproc_nullable] = STATE(3911),
    [sym_preproc_error] = STATE(3911),
    [sym_preproc_define] = STATE(3911),
    [sym_preproc_undef] = STATE(3911),
    [anon_sym_SEMI] = ACTIONS(4457),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_RBRACK] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4457),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_in] = ACTIONS(4455),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_EQ_GT] = ACTIONS(4457),
    [anon_sym_switch] = ACTIONS(4457),
    [anon_sym_when] = ACTIONS(4457),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4457),
    [anon_sym_or] = ACTIONS(4457),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_into] = ACTIONS(4457),
    [anon_sym_on] = ACTIONS(4457),
    [anon_sym_equals] = ACTIONS(4457),
    [anon_sym_by] = ACTIONS(4457),
    [anon_sym_as] = ACTIONS(4457),
    [anon_sym_is] = ACTIONS(4457),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4457),
    [aux_sym_preproc_if_token3] = ACTIONS(4457),
    [aux_sym_preproc_else_token1] = ACTIONS(4457),
    [aux_sym_preproc_elif_token1] = ACTIONS(4457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3912] = {
    [sym_preproc_region] = STATE(3912),
    [sym_preproc_endregion] = STATE(3912),
    [sym_preproc_line] = STATE(3912),
    [sym_preproc_pragma] = STATE(3912),
    [sym_preproc_nullable] = STATE(3912),
    [sym_preproc_error] = STATE(3912),
    [sym_preproc_define] = STATE(3912),
    [sym_preproc_undef] = STATE(3912),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_RBRACK] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4608),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_EQ_GT] = ACTIONS(4610),
    [anon_sym_switch] = ACTIONS(4610),
    [anon_sym_when] = ACTIONS(4610),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4610),
    [anon_sym_or] = ACTIONS(4610),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_into] = ACTIONS(4610),
    [anon_sym_on] = ACTIONS(4610),
    [anon_sym_equals] = ACTIONS(4610),
    [anon_sym_by] = ACTIONS(4610),
    [anon_sym_as] = ACTIONS(4610),
    [anon_sym_is] = ACTIONS(4610),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4610),
    [aux_sym_preproc_if_token3] = ACTIONS(4610),
    [aux_sym_preproc_else_token1] = ACTIONS(4610),
    [aux_sym_preproc_elif_token1] = ACTIONS(4610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3913] = {
    [sym_preproc_region] = STATE(3913),
    [sym_preproc_endregion] = STATE(3913),
    [sym_preproc_line] = STATE(3913),
    [sym_preproc_pragma] = STATE(3913),
    [sym_preproc_nullable] = STATE(3913),
    [sym_preproc_error] = STATE(3913),
    [sym_preproc_define] = STATE(3913),
    [sym_preproc_undef] = STATE(3913),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4128),
    [anon_sym_PLUS_EQ] = ACTIONS(4128),
    [anon_sym_DASH_EQ] = ACTIONS(4128),
    [anon_sym_STAR_EQ] = ACTIONS(4128),
    [anon_sym_SLASH_EQ] = ACTIONS(4128),
    [anon_sym_PERCENT_EQ] = ACTIONS(4128),
    [anon_sym_AMP_EQ] = ACTIONS(4128),
    [anon_sym_CARET_EQ] = ACTIONS(4128),
    [anon_sym_PIPE_EQ] = ACTIONS(4128),
    [anon_sym_LT_LT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4126),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4128),
  },
  [3914] = {
    [sym_preproc_region] = STATE(3914),
    [sym_preproc_endregion] = STATE(3914),
    [sym_preproc_line] = STATE(3914),
    [sym_preproc_pragma] = STATE(3914),
    [sym_preproc_nullable] = STATE(3914),
    [sym_preproc_error] = STATE(3914),
    [sym_preproc_define] = STATE(3914),
    [sym_preproc_undef] = STATE(3914),
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_RBRACK] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_EQ_GT] = ACTIONS(4490),
    [anon_sym_switch] = ACTIONS(4490),
    [anon_sym_when] = ACTIONS(4490),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4490),
    [anon_sym_or] = ACTIONS(4490),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_into] = ACTIONS(4490),
    [anon_sym_on] = ACTIONS(4490),
    [anon_sym_equals] = ACTIONS(4490),
    [anon_sym_by] = ACTIONS(4490),
    [anon_sym_as] = ACTIONS(4490),
    [anon_sym_is] = ACTIONS(4490),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4490),
    [aux_sym_preproc_if_token3] = ACTIONS(4490),
    [aux_sym_preproc_else_token1] = ACTIONS(4490),
    [aux_sym_preproc_elif_token1] = ACTIONS(4490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3915] = {
    [sym_preproc_region] = STATE(3915),
    [sym_preproc_endregion] = STATE(3915),
    [sym_preproc_line] = STATE(3915),
    [sym_preproc_pragma] = STATE(3915),
    [sym_preproc_nullable] = STATE(3915),
    [sym_preproc_error] = STATE(3915),
    [sym_preproc_define] = STATE(3915),
    [sym_preproc_undef] = STATE(3915),
    [anon_sym_EQ] = ACTIONS(5815),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5817),
    [anon_sym_DASH_EQ] = ACTIONS(5817),
    [anon_sym_STAR_EQ] = ACTIONS(5817),
    [anon_sym_SLASH_EQ] = ACTIONS(5817),
    [anon_sym_PERCENT_EQ] = ACTIONS(5817),
    [anon_sym_AMP_EQ] = ACTIONS(5817),
    [anon_sym_CARET_EQ] = ACTIONS(5817),
    [anon_sym_PIPE_EQ] = ACTIONS(5817),
    [anon_sym_LT_LT_EQ] = ACTIONS(5817),
    [anon_sym_GT_GT_EQ] = ACTIONS(5817),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5817),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5817),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5294),
  },
  [3916] = {
    [sym_initializer_expression] = STATE(4269),
    [sym_preproc_region] = STATE(3916),
    [sym_preproc_endregion] = STATE(3916),
    [sym_preproc_line] = STATE(3916),
    [sym_preproc_pragma] = STATE(3916),
    [sym_preproc_nullable] = STATE(3916),
    [sym_preproc_error] = STATE(3916),
    [sym_preproc_define] = STATE(3916),
    [sym_preproc_undef] = STATE(3916),
    [anon_sym_SEMI] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_COLON] = ACTIONS(5304),
    [anon_sym_COMMA] = ACTIONS(5304),
    [anon_sym_RBRACK] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [anon_sym_RPAREN] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(5304),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_in] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5309),
    [anon_sym_BANG] = ACTIONS(5309),
    [anon_sym_PLUS_PLUS] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_GT_GT_GT] = ACTIONS(5304),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_GT_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5304),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_EQ_GT] = ACTIONS(5304),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_when] = ACTIONS(5304),
    [anon_sym_DOT_DOT] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5304),
    [anon_sym_AMP_AMP] = ACTIONS(5304),
    [anon_sym_PIPE_PIPE] = ACTIONS(5304),
    [anon_sym_QMARK_QMARK] = ACTIONS(5304),
    [anon_sym_on] = ACTIONS(5304),
    [anon_sym_equals] = ACTIONS(5304),
    [anon_sym_by] = ACTIONS(5304),
    [anon_sym_as] = ACTIONS(5304),
    [anon_sym_is] = ACTIONS(5304),
    [anon_sym_DASH_GT] = ACTIONS(5304),
    [anon_sym_with] = ACTIONS(5304),
    [aux_sym_preproc_if_token3] = ACTIONS(5304),
    [aux_sym_preproc_else_token1] = ACTIONS(5304),
    [aux_sym_preproc_elif_token1] = ACTIONS(5304),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3917] = {
    [sym_preproc_region] = STATE(3917),
    [sym_preproc_endregion] = STATE(3917),
    [sym_preproc_line] = STATE(3917),
    [sym_preproc_pragma] = STATE(3917),
    [sym_preproc_nullable] = STATE(3917),
    [sym_preproc_error] = STATE(3917),
    [sym_preproc_define] = STATE(3917),
    [sym_preproc_undef] = STATE(3917),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4130),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_when] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3918] = {
    [sym_preproc_region] = STATE(3918),
    [sym_preproc_endregion] = STATE(3918),
    [sym_preproc_line] = STATE(3918),
    [sym_preproc_pragma] = STATE(3918),
    [sym_preproc_nullable] = STATE(3918),
    [sym_preproc_error] = STATE(3918),
    [sym_preproc_define] = STATE(3918),
    [sym_preproc_undef] = STATE(3918),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_when] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4482),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_into] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3919] = {
    [sym_preproc_region] = STATE(3919),
    [sym_preproc_endregion] = STATE(3919),
    [sym_preproc_line] = STATE(3919),
    [sym_preproc_pragma] = STATE(3919),
    [sym_preproc_nullable] = STATE(3919),
    [sym_preproc_error] = STATE(3919),
    [sym_preproc_define] = STATE(3919),
    [sym_preproc_undef] = STATE(3919),
    [anon_sym_SEMI] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_RBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(4465),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4467),
    [anon_sym_switch] = ACTIONS(4467),
    [anon_sym_when] = ACTIONS(4467),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4467),
    [anon_sym_or] = ACTIONS(4467),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_into] = ACTIONS(4467),
    [anon_sym_on] = ACTIONS(4467),
    [anon_sym_equals] = ACTIONS(4467),
    [anon_sym_by] = ACTIONS(4467),
    [anon_sym_as] = ACTIONS(4467),
    [anon_sym_is] = ACTIONS(4467),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4467),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3920] = {
    [sym_preproc_region] = STATE(3920),
    [sym_preproc_endregion] = STATE(3920),
    [sym_preproc_line] = STATE(3920),
    [sym_preproc_pragma] = STATE(3920),
    [sym_preproc_nullable] = STATE(3920),
    [sym_preproc_error] = STATE(3920),
    [sym_preproc_define] = STATE(3920),
    [sym_preproc_undef] = STATE(3920),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3993),
    [anon_sym_CARET] = ACTIONS(3993),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3993),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3993),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_PLUS_EQ] = ACTIONS(3991),
    [anon_sym_DASH_EQ] = ACTIONS(3991),
    [anon_sym_STAR_EQ] = ACTIONS(3991),
    [anon_sym_SLASH_EQ] = ACTIONS(3991),
    [anon_sym_PERCENT_EQ] = ACTIONS(3991),
    [anon_sym_AMP_EQ] = ACTIONS(3991),
    [anon_sym_CARET_EQ] = ACTIONS(3991),
    [anon_sym_PIPE_EQ] = ACTIONS(3991),
    [anon_sym_LT_LT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3993),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(3991),
  },
  [3921] = {
    [sym_preproc_region] = STATE(3921),
    [sym_preproc_endregion] = STATE(3921),
    [sym_preproc_line] = STATE(3921),
    [sym_preproc_pragma] = STATE(3921),
    [sym_preproc_nullable] = STATE(3921),
    [sym_preproc_error] = STATE(3921),
    [sym_preproc_define] = STATE(3921),
    [sym_preproc_undef] = STATE(3921),
    [anon_sym_EQ] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [anon_sym_CARET] = ACTIONS(4120),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4120),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4120),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_PLUS_EQ] = ACTIONS(4122),
    [anon_sym_DASH_EQ] = ACTIONS(4122),
    [anon_sym_STAR_EQ] = ACTIONS(4122),
    [anon_sym_SLASH_EQ] = ACTIONS(4122),
    [anon_sym_PERCENT_EQ] = ACTIONS(4122),
    [anon_sym_AMP_EQ] = ACTIONS(4122),
    [anon_sym_CARET_EQ] = ACTIONS(4122),
    [anon_sym_PIPE_EQ] = ACTIONS(4122),
    [anon_sym_LT_LT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4122),
  },
  [3922] = {
    [sym_preproc_region] = STATE(3922),
    [sym_preproc_endregion] = STATE(3922),
    [sym_preproc_line] = STATE(3922),
    [sym_preproc_pragma] = STATE(3922),
    [sym_preproc_nullable] = STATE(3922),
    [sym_preproc_error] = STATE(3922),
    [sym_preproc_define] = STATE(3922),
    [sym_preproc_undef] = STATE(3922),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(5819),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_when] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4482),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_into] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3923] = {
    [sym_preproc_region] = STATE(3923),
    [sym_preproc_endregion] = STATE(3923),
    [sym_preproc_line] = STATE(3923),
    [sym_preproc_pragma] = STATE(3923),
    [sym_preproc_nullable] = STATE(3923),
    [sym_preproc_error] = STATE(3923),
    [sym_preproc_define] = STATE(3923),
    [sym_preproc_undef] = STATE(3923),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(5821),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(5819),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3924] = {
    [sym_preproc_region] = STATE(3924),
    [sym_preproc_endregion] = STATE(3924),
    [sym_preproc_line] = STATE(3924),
    [sym_preproc_pragma] = STATE(3924),
    [sym_preproc_nullable] = STATE(3924),
    [sym_preproc_error] = STATE(3924),
    [sym_preproc_define] = STATE(3924),
    [sym_preproc_undef] = STATE(3924),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_LPAREN] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_in] = ACTIONS(5366),
    [anon_sym_QMARK] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5364),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5366),
    [anon_sym_GT_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_EQ] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5366),
    [anon_sym_EQ_GT] = ACTIONS(5364),
    [anon_sym_switch] = ACTIONS(5364),
    [anon_sym_when] = ACTIONS(5364),
    [anon_sym_DOT_DOT] = ACTIONS(5364),
    [anon_sym_and] = ACTIONS(5364),
    [anon_sym_or] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_QMARK_QMARK] = ACTIONS(5364),
    [anon_sym_into] = ACTIONS(5364),
    [anon_sym_on] = ACTIONS(5364),
    [anon_sym_equals] = ACTIONS(5364),
    [anon_sym_by] = ACTIONS(5364),
    [anon_sym_as] = ACTIONS(5364),
    [anon_sym_is] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [anon_sym_with] = ACTIONS(5364),
    [aux_sym_raw_string_literal_token1] = ACTIONS(5824),
    [aux_sym_preproc_if_token3] = ACTIONS(5364),
    [aux_sym_preproc_else_token1] = ACTIONS(5364),
    [aux_sym_preproc_elif_token1] = ACTIONS(5364),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3925] = {
    [sym_preproc_region] = STATE(3925),
    [sym_preproc_endregion] = STATE(3925),
    [sym_preproc_line] = STATE(3925),
    [sym_preproc_pragma] = STATE(3925),
    [sym_preproc_nullable] = STATE(3925),
    [sym_preproc_error] = STATE(3925),
    [sym_preproc_define] = STATE(3925),
    [sym_preproc_undef] = STATE(3925),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COMMA] = ACTIONS(5370),
    [anon_sym_RBRACK] = ACTIONS(5370),
    [anon_sym_LPAREN] = ACTIONS(5370),
    [anon_sym_RPAREN] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5370),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5372),
    [anon_sym_in] = ACTIONS(5372),
    [anon_sym_QMARK] = ACTIONS(5372),
    [anon_sym_BANG] = ACTIONS(5372),
    [anon_sym_PLUS_PLUS] = ACTIONS(5370),
    [anon_sym_DASH_DASH] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5370),
    [anon_sym_SLASH] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_LT_LT] = ACTIONS(5370),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_GT_GT_GT] = ACTIONS(5370),
    [anon_sym_EQ_EQ] = ACTIONS(5370),
    [anon_sym_BANG_EQ] = ACTIONS(5370),
    [anon_sym_GT_EQ] = ACTIONS(5370),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(5372),
    [anon_sym_EQ_GT] = ACTIONS(5370),
    [anon_sym_switch] = ACTIONS(5370),
    [anon_sym_when] = ACTIONS(5370),
    [anon_sym_DOT_DOT] = ACTIONS(5370),
    [anon_sym_and] = ACTIONS(5370),
    [anon_sym_or] = ACTIONS(5370),
    [anon_sym_AMP_AMP] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE] = ACTIONS(5370),
    [anon_sym_QMARK_QMARK] = ACTIONS(5370),
    [anon_sym_into] = ACTIONS(5370),
    [anon_sym_on] = ACTIONS(5370),
    [anon_sym_equals] = ACTIONS(5370),
    [anon_sym_by] = ACTIONS(5370),
    [anon_sym_as] = ACTIONS(5370),
    [anon_sym_is] = ACTIONS(5370),
    [anon_sym_DASH_GT] = ACTIONS(5370),
    [anon_sym_with] = ACTIONS(5370),
    [aux_sym_preproc_if_token3] = ACTIONS(5370),
    [aux_sym_preproc_else_token1] = ACTIONS(5370),
    [aux_sym_preproc_elif_token1] = ACTIONS(5370),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3926] = {
    [sym_preproc_region] = STATE(3926),
    [sym_preproc_endregion] = STATE(3926),
    [sym_preproc_line] = STATE(3926),
    [sym_preproc_pragma] = STATE(3926),
    [sym_preproc_nullable] = STATE(3926),
    [sym_preproc_error] = STATE(3926),
    [sym_preproc_define] = STATE(3926),
    [sym_preproc_undef] = STATE(3926),
    [anon_sym_EQ] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_COLON] = ACTIONS(4636),
    [anon_sym_COMMA] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_LT] = ACTIONS(4642),
    [anon_sym_GT] = ACTIONS(4642),
    [anon_sym_QMARK] = ACTIONS(4642),
    [anon_sym_BANG] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_STAR] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(4642),
    [anon_sym_PERCENT] = ACTIONS(4642),
    [anon_sym_CARET] = ACTIONS(4642),
    [anon_sym_PIPE] = ACTIONS(4642),
    [anon_sym_AMP] = ACTIONS(4642),
    [anon_sym_LT_LT] = ACTIONS(4642),
    [anon_sym_GT_GT] = ACTIONS(4642),
    [anon_sym_GT_GT_GT] = ACTIONS(4642),
    [anon_sym_EQ_EQ] = ACTIONS(4636),
    [anon_sym_BANG_EQ] = ACTIONS(4636),
    [anon_sym_GT_EQ] = ACTIONS(4636),
    [anon_sym_LT_EQ] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4642),
    [anon_sym_switch] = ACTIONS(4636),
    [anon_sym_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4636),
    [anon_sym_or] = ACTIONS(4636),
    [anon_sym_PLUS_EQ] = ACTIONS(4640),
    [anon_sym_DASH_EQ] = ACTIONS(4640),
    [anon_sym_STAR_EQ] = ACTIONS(4640),
    [anon_sym_SLASH_EQ] = ACTIONS(4640),
    [anon_sym_PERCENT_EQ] = ACTIONS(4640),
    [anon_sym_AMP_EQ] = ACTIONS(4640),
    [anon_sym_CARET_EQ] = ACTIONS(4640),
    [anon_sym_PIPE_EQ] = ACTIONS(4640),
    [anon_sym_LT_LT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4640),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4640),
    [anon_sym_AMP_AMP] = ACTIONS(4636),
    [anon_sym_PIPE_PIPE] = ACTIONS(4636),
    [anon_sym_QMARK_QMARK] = ACTIONS(4642),
    [anon_sym_into] = ACTIONS(4636),
    [anon_sym_as] = ACTIONS(4636),
    [anon_sym_is] = ACTIONS(4636),
    [anon_sym_DASH_GT] = ACTIONS(4636),
    [anon_sym_with] = ACTIONS(4636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4636),
  },
  [3927] = {
    [sym_preproc_region] = STATE(3927),
    [sym_preproc_endregion] = STATE(3927),
    [sym_preproc_line] = STATE(3927),
    [sym_preproc_pragma] = STATE(3927),
    [sym_preproc_nullable] = STATE(3927),
    [sym_preproc_error] = STATE(3927),
    [sym_preproc_define] = STATE(3927),
    [sym_preproc_undef] = STATE(3927),
    [anon_sym_EQ] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5828),
    [anon_sym_DASH_EQ] = ACTIONS(5828),
    [anon_sym_STAR_EQ] = ACTIONS(5828),
    [anon_sym_SLASH_EQ] = ACTIONS(5828),
    [anon_sym_PERCENT_EQ] = ACTIONS(5828),
    [anon_sym_AMP_EQ] = ACTIONS(5828),
    [anon_sym_CARET_EQ] = ACTIONS(5828),
    [anon_sym_PIPE_EQ] = ACTIONS(5828),
    [anon_sym_LT_LT_EQ] = ACTIONS(5828),
    [anon_sym_GT_GT_EQ] = ACTIONS(5828),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5828),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5828),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3928] = {
    [sym_preproc_region] = STATE(3928),
    [sym_preproc_endregion] = STATE(3928),
    [sym_preproc_line] = STATE(3928),
    [sym_preproc_pragma] = STATE(3928),
    [sym_preproc_nullable] = STATE(3928),
    [sym_preproc_error] = STATE(3928),
    [sym_preproc_define] = STATE(3928),
    [sym_preproc_undef] = STATE(3928),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_COLON] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_QMARK] = ACTIONS(4693),
    [anon_sym_BANG] = ACTIONS(4693),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_CARET] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_GT_GT_GT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_switch] = ACTIONS(4691),
    [anon_sym_DOT_DOT] = ACTIONS(4691),
    [anon_sym_and] = ACTIONS(4691),
    [anon_sym_or] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE] = ACTIONS(4691),
    [anon_sym_QMARK_QMARK] = ACTIONS(4693),
    [anon_sym_into] = ACTIONS(4691),
    [anon_sym_as] = ACTIONS(4691),
    [anon_sym_is] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_with] = ACTIONS(4691),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4691),
  },
  [3929] = {
    [sym_preproc_region] = STATE(3929),
    [sym_preproc_endregion] = STATE(3929),
    [sym_preproc_line] = STATE(3929),
    [sym_preproc_pragma] = STATE(3929),
    [sym_preproc_nullable] = STATE(3929),
    [sym_preproc_error] = STATE(3929),
    [sym_preproc_define] = STATE(3929),
    [sym_preproc_undef] = STATE(3929),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_COLON] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_RPAREN] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_in] = ACTIONS(5380),
    [anon_sym_QMARK] = ACTIONS(5380),
    [anon_sym_BANG] = ACTIONS(5380),
    [anon_sym_PLUS_PLUS] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5378),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5378),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5378),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_GT_GT_GT] = ACTIONS(5378),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_EQ_GT] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_DOT_DOT] = ACTIONS(5378),
    [anon_sym_and] = ACTIONS(5378),
    [anon_sym_or] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE] = ACTIONS(5378),
    [anon_sym_QMARK_QMARK] = ACTIONS(5378),
    [anon_sym_into] = ACTIONS(5378),
    [anon_sym_on] = ACTIONS(5378),
    [anon_sym_equals] = ACTIONS(5378),
    [anon_sym_by] = ACTIONS(5378),
    [anon_sym_as] = ACTIONS(5378),
    [anon_sym_is] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_with] = ACTIONS(5378),
    [aux_sym_preproc_if_token3] = ACTIONS(5378),
    [aux_sym_preproc_else_token1] = ACTIONS(5378),
    [aux_sym_preproc_elif_token1] = ACTIONS(5378),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3930] = {
    [sym_preproc_region] = STATE(3930),
    [sym_preproc_endregion] = STATE(3930),
    [sym_preproc_line] = STATE(3930),
    [sym_preproc_pragma] = STATE(3930),
    [sym_preproc_nullable] = STATE(3930),
    [sym_preproc_error] = STATE(3930),
    [sym_preproc_define] = STATE(3930),
    [sym_preproc_undef] = STATE(3930),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_when] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3931] = {
    [sym_preproc_region] = STATE(3931),
    [sym_preproc_endregion] = STATE(3931),
    [sym_preproc_line] = STATE(3931),
    [sym_preproc_pragma] = STATE(3931),
    [sym_preproc_nullable] = STATE(3931),
    [sym_preproc_error] = STATE(3931),
    [sym_preproc_define] = STATE(3931),
    [sym_preproc_undef] = STATE(3931),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(5821),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3932] = {
    [sym_preproc_region] = STATE(3932),
    [sym_preproc_endregion] = STATE(3932),
    [sym_preproc_line] = STATE(3932),
    [sym_preproc_pragma] = STATE(3932),
    [sym_preproc_nullable] = STATE(3932),
    [sym_preproc_error] = STATE(3932),
    [sym_preproc_define] = STATE(3932),
    [sym_preproc_undef] = STATE(3932),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3933] = {
    [sym_type_argument_list] = STATE(4063),
    [sym_preproc_region] = STATE(3933),
    [sym_preproc_endregion] = STATE(3933),
    [sym_preproc_line] = STATE(3933),
    [sym_preproc_pragma] = STATE(3933),
    [sym_preproc_nullable] = STATE(3933),
    [sym_preproc_error] = STATE(3933),
    [sym_preproc_define] = STATE(3933),
    [sym_preproc_undef] = STATE(3933),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5810),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(5830),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3934] = {
    [sym_preproc_region] = STATE(3934),
    [sym_preproc_endregion] = STATE(3934),
    [sym_preproc_line] = STATE(3934),
    [sym_preproc_pragma] = STATE(3934),
    [sym_preproc_nullable] = STATE(3934),
    [sym_preproc_error] = STATE(3934),
    [sym_preproc_define] = STATE(3934),
    [sym_preproc_undef] = STATE(3934),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(5821),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3935] = {
    [sym_preproc_region] = STATE(3935),
    [sym_preproc_endregion] = STATE(3935),
    [sym_preproc_line] = STATE(3935),
    [sym_preproc_pragma] = STATE(3935),
    [sym_preproc_nullable] = STATE(3935),
    [sym_preproc_error] = STATE(3935),
    [sym_preproc_define] = STATE(3935),
    [sym_preproc_undef] = STATE(3935),
    [anon_sym_EQ] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_QMARK] = ACTIONS(4173),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4173),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_LT_LT] = ACTIONS(4173),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4173),
    [anon_sym_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_DOT] = ACTIONS(4173),
    [anon_sym_switch] = ACTIONS(4171),
    [anon_sym_DOT_DOT] = ACTIONS(4171),
    [anon_sym_and] = ACTIONS(4171),
    [anon_sym_or] = ACTIONS(4171),
    [anon_sym_PLUS_EQ] = ACTIONS(4171),
    [anon_sym_DASH_EQ] = ACTIONS(4171),
    [anon_sym_STAR_EQ] = ACTIONS(4171),
    [anon_sym_SLASH_EQ] = ACTIONS(4171),
    [anon_sym_PERCENT_EQ] = ACTIONS(4171),
    [anon_sym_AMP_EQ] = ACTIONS(4171),
    [anon_sym_CARET_EQ] = ACTIONS(4171),
    [anon_sym_PIPE_EQ] = ACTIONS(4171),
    [anon_sym_LT_LT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_QMARK_QMARK] = ACTIONS(4173),
    [anon_sym_into] = ACTIONS(4171),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_is] = ACTIONS(4171),
    [anon_sym_DASH_GT] = ACTIONS(4171),
    [anon_sym_with] = ACTIONS(4171),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4171),
  },
  [3936] = {
    [sym_preproc_region] = STATE(3936),
    [sym_preproc_endregion] = STATE(3936),
    [sym_preproc_line] = STATE(3936),
    [sym_preproc_pragma] = STATE(3936),
    [sym_preproc_nullable] = STATE(3936),
    [sym_preproc_error] = STATE(3936),
    [sym_preproc_define] = STATE(3936),
    [sym_preproc_undef] = STATE(3936),
    [anon_sym_SEMI] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_COLON] = ACTIONS(4122),
    [anon_sym_COMMA] = ACTIONS(4122),
    [anon_sym_RBRACK] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_RPAREN] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4120),
    [anon_sym_GT] = ACTIONS(4120),
    [anon_sym_in] = ACTIONS(4120),
    [anon_sym_QMARK] = ACTIONS(4120),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_PLUS_PLUS] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4120),
    [anon_sym_STAR] = ACTIONS(4122),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4122),
    [anon_sym_CARET] = ACTIONS(4122),
    [anon_sym_PIPE] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4120),
    [anon_sym_LT_LT] = ACTIONS(4122),
    [anon_sym_GT_GT] = ACTIONS(4120),
    [anon_sym_GT_GT_GT] = ACTIONS(4122),
    [anon_sym_EQ_EQ] = ACTIONS(4122),
    [anon_sym_BANG_EQ] = ACTIONS(4122),
    [anon_sym_GT_EQ] = ACTIONS(4122),
    [anon_sym_LT_EQ] = ACTIONS(4122),
    [anon_sym_DOT] = ACTIONS(4120),
    [anon_sym_EQ_GT] = ACTIONS(4122),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_when] = ACTIONS(4122),
    [anon_sym_DOT_DOT] = ACTIONS(4122),
    [anon_sym_and] = ACTIONS(4122),
    [anon_sym_or] = ACTIONS(4122),
    [anon_sym_AMP_AMP] = ACTIONS(4122),
    [anon_sym_PIPE_PIPE] = ACTIONS(4122),
    [anon_sym_QMARK_QMARK] = ACTIONS(4122),
    [anon_sym_into] = ACTIONS(4122),
    [anon_sym_on] = ACTIONS(4122),
    [anon_sym_equals] = ACTIONS(4122),
    [anon_sym_by] = ACTIONS(4122),
    [anon_sym_as] = ACTIONS(4122),
    [anon_sym_is] = ACTIONS(4122),
    [anon_sym_DASH_GT] = ACTIONS(4122),
    [anon_sym_with] = ACTIONS(4122),
    [aux_sym_preproc_if_token3] = ACTIONS(4122),
    [aux_sym_preproc_else_token1] = ACTIONS(4122),
    [aux_sym_preproc_elif_token1] = ACTIONS(4122),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3937] = {
    [sym_preproc_region] = STATE(3937),
    [sym_preproc_endregion] = STATE(3937),
    [sym_preproc_line] = STATE(3937),
    [sym_preproc_pragma] = STATE(3937),
    [sym_preproc_nullable] = STATE(3937),
    [sym_preproc_error] = STATE(3937),
    [sym_preproc_define] = STATE(3937),
    [sym_preproc_undef] = STATE(3937),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4801),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_QMARK] = ACTIONS(4804),
    [anon_sym_BANG] = ACTIONS(4804),
    [anon_sym_PLUS_PLUS] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4801),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(4804),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_CARET] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_GT_GT_GT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4801),
    [anon_sym_BANG_EQ] = ACTIONS(4801),
    [anon_sym_GT_EQ] = ACTIONS(4801),
    [anon_sym_LT_EQ] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_switch] = ACTIONS(4801),
    [anon_sym_DOT_DOT] = ACTIONS(4801),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4801),
    [anon_sym_PIPE_PIPE] = ACTIONS(4801),
    [anon_sym_QMARK_QMARK] = ACTIONS(4804),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(4801),
    [anon_sym_is] = ACTIONS(4801),
    [anon_sym_DASH_GT] = ACTIONS(4801),
    [anon_sym_with] = ACTIONS(4801),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4799),
  },
  [3938] = {
    [sym_preproc_region] = STATE(3938),
    [sym_preproc_endregion] = STATE(3938),
    [sym_preproc_line] = STATE(3938),
    [sym_preproc_pragma] = STATE(3938),
    [sym_preproc_nullable] = STATE(3938),
    [sym_preproc_error] = STATE(3938),
    [sym_preproc_define] = STATE(3938),
    [sym_preproc_undef] = STATE(3938),
    [anon_sym_EQ] = ACTIONS(4683),
    [anon_sym_LBRACK] = ACTIONS(4681),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_COMMA] = ACTIONS(4681),
    [anon_sym_LPAREN] = ACTIONS(4681),
    [anon_sym_LT] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(4683),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_BANG] = ACTIONS(4683),
    [anon_sym_PLUS_PLUS] = ACTIONS(4681),
    [anon_sym_DASH_DASH] = ACTIONS(4681),
    [anon_sym_PLUS] = ACTIONS(4683),
    [anon_sym_DASH] = ACTIONS(4683),
    [anon_sym_STAR] = ACTIONS(4683),
    [anon_sym_SLASH] = ACTIONS(4683),
    [anon_sym_PERCENT] = ACTIONS(4683),
    [anon_sym_CARET] = ACTIONS(4683),
    [anon_sym_PIPE] = ACTIONS(4683),
    [anon_sym_AMP] = ACTIONS(4683),
    [anon_sym_LT_LT] = ACTIONS(4683),
    [anon_sym_GT_GT] = ACTIONS(4683),
    [anon_sym_GT_GT_GT] = ACTIONS(4683),
    [anon_sym_EQ_EQ] = ACTIONS(4681),
    [anon_sym_BANG_EQ] = ACTIONS(4681),
    [anon_sym_GT_EQ] = ACTIONS(4681),
    [anon_sym_LT_EQ] = ACTIONS(4681),
    [anon_sym_DOT] = ACTIONS(4683),
    [anon_sym_switch] = ACTIONS(4681),
    [anon_sym_DOT_DOT] = ACTIONS(4681),
    [anon_sym_and] = ACTIONS(4681),
    [anon_sym_or] = ACTIONS(4681),
    [anon_sym_PLUS_EQ] = ACTIONS(4681),
    [anon_sym_DASH_EQ] = ACTIONS(4681),
    [anon_sym_STAR_EQ] = ACTIONS(4681),
    [anon_sym_SLASH_EQ] = ACTIONS(4681),
    [anon_sym_PERCENT_EQ] = ACTIONS(4681),
    [anon_sym_AMP_EQ] = ACTIONS(4681),
    [anon_sym_CARET_EQ] = ACTIONS(4681),
    [anon_sym_PIPE_EQ] = ACTIONS(4681),
    [anon_sym_LT_LT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4681),
    [anon_sym_AMP_AMP] = ACTIONS(4681),
    [anon_sym_PIPE_PIPE] = ACTIONS(4681),
    [anon_sym_QMARK_QMARK] = ACTIONS(4683),
    [anon_sym_into] = ACTIONS(4681),
    [anon_sym_as] = ACTIONS(4681),
    [anon_sym_is] = ACTIONS(4681),
    [anon_sym_DASH_GT] = ACTIONS(4681),
    [anon_sym_with] = ACTIONS(4681),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4681),
  },
  [3939] = {
    [sym_preproc_region] = STATE(3939),
    [sym_preproc_endregion] = STATE(3939),
    [sym_preproc_line] = STATE(3939),
    [sym_preproc_pragma] = STATE(3939),
    [sym_preproc_nullable] = STATE(3939),
    [sym_preproc_error] = STATE(3939),
    [sym_preproc_define] = STATE(3939),
    [sym_preproc_undef] = STATE(3939),
    [anon_sym_SEMI] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5391),
    [anon_sym_COLON] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_RBRACK] = ACTIONS(5391),
    [anon_sym_LPAREN] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5393),
    [anon_sym_in] = ACTIONS(5391),
    [anon_sym_where] = ACTIONS(5391),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_SLASH] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5391),
    [anon_sym_CARET] = ACTIONS(5391),
    [anon_sym_PIPE] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5393),
    [anon_sym_LT_LT] = ACTIONS(5391),
    [anon_sym_GT_GT] = ACTIONS(5393),
    [anon_sym_GT_GT_GT] = ACTIONS(5391),
    [anon_sym_EQ_EQ] = ACTIONS(5391),
    [anon_sym_BANG_EQ] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5391),
    [anon_sym_LT_EQ] = ACTIONS(5391),
    [anon_sym_DOT] = ACTIONS(5393),
    [anon_sym_EQ_GT] = ACTIONS(5391),
    [anon_sym_switch] = ACTIONS(5391),
    [anon_sym_when] = ACTIONS(5391),
    [anon_sym_DOT_DOT] = ACTIONS(5391),
    [anon_sym_and] = ACTIONS(5391),
    [anon_sym_or] = ACTIONS(5391),
    [anon_sym_AMP_AMP] = ACTIONS(5391),
    [anon_sym_PIPE_PIPE] = ACTIONS(5391),
    [anon_sym_QMARK_QMARK] = ACTIONS(5391),
    [anon_sym_on] = ACTIONS(5391),
    [anon_sym_equals] = ACTIONS(5391),
    [anon_sym_by] = ACTIONS(5391),
    [anon_sym_as] = ACTIONS(5391),
    [anon_sym_is] = ACTIONS(5391),
    [anon_sym_DASH_GT] = ACTIONS(5391),
    [anon_sym_with] = ACTIONS(5391),
    [aux_sym_preproc_if_token3] = ACTIONS(5391),
    [aux_sym_preproc_else_token1] = ACTIONS(5391),
    [aux_sym_preproc_elif_token1] = ACTIONS(5391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3940] = {
    [sym_preproc_region] = STATE(3940),
    [sym_preproc_endregion] = STATE(3940),
    [sym_preproc_line] = STATE(3940),
    [sym_preproc_pragma] = STATE(3940),
    [sym_preproc_nullable] = STATE(3940),
    [sym_preproc_error] = STATE(3940),
    [sym_preproc_define] = STATE(3940),
    [sym_preproc_undef] = STATE(3940),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3941] = {
    [sym_preproc_region] = STATE(3941),
    [sym_preproc_endregion] = STATE(3941),
    [sym_preproc_line] = STATE(3941),
    [sym_preproc_pragma] = STATE(3941),
    [sym_preproc_nullable] = STATE(3941),
    [sym_preproc_error] = STATE(3941),
    [sym_preproc_define] = STATE(3941),
    [sym_preproc_undef] = STATE(3941),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(3993),
    [anon_sym_GT] = ACTIONS(3993),
    [anon_sym_in] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_BANG] = ACTIONS(3993),
    [anon_sym_PLUS_PLUS] = ACTIONS(3991),
    [anon_sym_DASH_DASH] = ACTIONS(3991),
    [anon_sym_PLUS] = ACTIONS(3993),
    [anon_sym_DASH] = ACTIONS(3993),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_SLASH] = ACTIONS(3993),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3991),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_AMP] = ACTIONS(3993),
    [anon_sym_LT_LT] = ACTIONS(3991),
    [anon_sym_GT_GT] = ACTIONS(3993),
    [anon_sym_GT_GT_GT] = ACTIONS(3991),
    [anon_sym_EQ_EQ] = ACTIONS(3991),
    [anon_sym_BANG_EQ] = ACTIONS(3991),
    [anon_sym_GT_EQ] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3993),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_switch] = ACTIONS(3991),
    [anon_sym_when] = ACTIONS(3991),
    [anon_sym_DOT_DOT] = ACTIONS(3991),
    [anon_sym_and] = ACTIONS(3991),
    [anon_sym_or] = ACTIONS(3991),
    [anon_sym_AMP_AMP] = ACTIONS(3991),
    [anon_sym_PIPE_PIPE] = ACTIONS(3991),
    [anon_sym_QMARK_QMARK] = ACTIONS(3991),
    [anon_sym_into] = ACTIONS(3991),
    [anon_sym_on] = ACTIONS(3991),
    [anon_sym_equals] = ACTIONS(3991),
    [anon_sym_by] = ACTIONS(3991),
    [anon_sym_as] = ACTIONS(3991),
    [anon_sym_is] = ACTIONS(3991),
    [anon_sym_DASH_GT] = ACTIONS(3991),
    [anon_sym_with] = ACTIONS(3991),
    [aux_sym_preproc_if_token3] = ACTIONS(3991),
    [aux_sym_preproc_else_token1] = ACTIONS(3991),
    [aux_sym_preproc_elif_token1] = ACTIONS(3991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3942] = {
    [sym_initializer_expression] = STATE(4120),
    [sym_preproc_region] = STATE(3942),
    [sym_preproc_endregion] = STATE(3942),
    [sym_preproc_line] = STATE(3942),
    [sym_preproc_pragma] = STATE(3942),
    [sym_preproc_nullable] = STATE(3942),
    [sym_preproc_error] = STATE(3942),
    [sym_preproc_define] = STATE(3942),
    [sym_preproc_undef] = STATE(3942),
    [anon_sym_SEMI] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_RBRACK] = ACTIONS(5315),
    [anon_sym_LPAREN] = ACTIONS(5315),
    [anon_sym_RPAREN] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(5315),
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_in] = ACTIONS(5315),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_PIPE] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5317),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_GT_GT_GT] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5315),
    [anon_sym_BANG_EQ] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5315),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_DOT] = ACTIONS(5317),
    [anon_sym_EQ_GT] = ACTIONS(5315),
    [anon_sym_switch] = ACTIONS(5315),
    [anon_sym_when] = ACTIONS(5315),
    [anon_sym_DOT_DOT] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_or] = ACTIONS(5315),
    [anon_sym_AMP_AMP] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5315),
    [anon_sym_QMARK_QMARK] = ACTIONS(5315),
    [anon_sym_on] = ACTIONS(5315),
    [anon_sym_equals] = ACTIONS(5315),
    [anon_sym_by] = ACTIONS(5315),
    [anon_sym_as] = ACTIONS(5315),
    [anon_sym_is] = ACTIONS(5315),
    [anon_sym_DASH_GT] = ACTIONS(5315),
    [anon_sym_with] = ACTIONS(5315),
    [aux_sym_preproc_if_token3] = ACTIONS(5315),
    [aux_sym_preproc_else_token1] = ACTIONS(5315),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3943] = {
    [sym_preproc_region] = STATE(3943),
    [sym_preproc_endregion] = STATE(3943),
    [sym_preproc_line] = STATE(3943),
    [sym_preproc_pragma] = STATE(3943),
    [sym_preproc_nullable] = STATE(3943),
    [sym_preproc_error] = STATE(3943),
    [sym_preproc_define] = STATE(3943),
    [sym_preproc_undef] = STATE(3943),
    [anon_sym_EQ] = ACTIONS(4138),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4138),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4138),
    [anon_sym_CARET] = ACTIONS(4138),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_PLUS_EQ] = ACTIONS(4140),
    [anon_sym_DASH_EQ] = ACTIONS(4140),
    [anon_sym_STAR_EQ] = ACTIONS(4140),
    [anon_sym_SLASH_EQ] = ACTIONS(4140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4140),
    [anon_sym_AMP_EQ] = ACTIONS(4140),
    [anon_sym_CARET_EQ] = ACTIONS(4140),
    [anon_sym_PIPE_EQ] = ACTIONS(4140),
    [anon_sym_LT_LT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4138),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4140),
  },
  [3944] = {
    [sym_preproc_region] = STATE(3944),
    [sym_preproc_endregion] = STATE(3944),
    [sym_preproc_line] = STATE(3944),
    [sym_preproc_pragma] = STATE(3944),
    [sym_preproc_nullable] = STATE(3944),
    [sym_preproc_error] = STATE(3944),
    [sym_preproc_define] = STATE(3944),
    [sym_preproc_undef] = STATE(3944),
    [anon_sym_EQ] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_COLON] = ACTIONS(4654),
    [anon_sym_COMMA] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_LT] = ACTIONS(4656),
    [anon_sym_GT] = ACTIONS(4656),
    [anon_sym_QMARK] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_STAR] = ACTIONS(4656),
    [anon_sym_SLASH] = ACTIONS(4656),
    [anon_sym_PERCENT] = ACTIONS(4656),
    [anon_sym_CARET] = ACTIONS(4656),
    [anon_sym_PIPE] = ACTIONS(4656),
    [anon_sym_AMP] = ACTIONS(4656),
    [anon_sym_LT_LT] = ACTIONS(4656),
    [anon_sym_GT_GT] = ACTIONS(4656),
    [anon_sym_GT_GT_GT] = ACTIONS(4656),
    [anon_sym_EQ_EQ] = ACTIONS(4654),
    [anon_sym_BANG_EQ] = ACTIONS(4654),
    [anon_sym_GT_EQ] = ACTIONS(4654),
    [anon_sym_LT_EQ] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4656),
    [anon_sym_switch] = ACTIONS(4654),
    [anon_sym_DOT_DOT] = ACTIONS(4654),
    [anon_sym_and] = ACTIONS(4654),
    [anon_sym_or] = ACTIONS(4654),
    [anon_sym_PLUS_EQ] = ACTIONS(4654),
    [anon_sym_DASH_EQ] = ACTIONS(4654),
    [anon_sym_STAR_EQ] = ACTIONS(4654),
    [anon_sym_SLASH_EQ] = ACTIONS(4654),
    [anon_sym_PERCENT_EQ] = ACTIONS(4654),
    [anon_sym_AMP_EQ] = ACTIONS(4654),
    [anon_sym_CARET_EQ] = ACTIONS(4654),
    [anon_sym_PIPE_EQ] = ACTIONS(4654),
    [anon_sym_LT_LT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(4654),
    [anon_sym_PIPE_PIPE] = ACTIONS(4654),
    [anon_sym_QMARK_QMARK] = ACTIONS(4656),
    [anon_sym_into] = ACTIONS(4654),
    [anon_sym_as] = ACTIONS(4654),
    [anon_sym_is] = ACTIONS(4654),
    [anon_sym_DASH_GT] = ACTIONS(4654),
    [anon_sym_with] = ACTIONS(4654),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4654),
  },
  [3945] = {
    [sym_preproc_region] = STATE(3945),
    [sym_preproc_endregion] = STATE(3945),
    [sym_preproc_line] = STATE(3945),
    [sym_preproc_pragma] = STATE(3945),
    [sym_preproc_nullable] = STATE(3945),
    [sym_preproc_error] = STATE(3945),
    [sym_preproc_define] = STATE(3945),
    [sym_preproc_undef] = STATE(3945),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_LBRACK] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RBRACK] = ACTIONS(5351),
    [anon_sym_LPAREN] = ACTIONS(5351),
    [anon_sym_RPAREN] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_LT] = ACTIONS(5353),
    [anon_sym_GT] = ACTIONS(5353),
    [anon_sym_in] = ACTIONS(5353),
    [anon_sym_QMARK] = ACTIONS(5353),
    [anon_sym_BANG] = ACTIONS(5353),
    [anon_sym_PLUS_PLUS] = ACTIONS(5351),
    [anon_sym_DASH_DASH] = ACTIONS(5351),
    [anon_sym_PLUS] = ACTIONS(5353),
    [anon_sym_DASH] = ACTIONS(5353),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_SLASH] = ACTIONS(5353),
    [anon_sym_PERCENT] = ACTIONS(5351),
    [anon_sym_CARET] = ACTIONS(5351),
    [anon_sym_PIPE] = ACTIONS(5353),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_LT_LT] = ACTIONS(5351),
    [anon_sym_GT_GT] = ACTIONS(5353),
    [anon_sym_GT_GT_GT] = ACTIONS(5351),
    [anon_sym_EQ_EQ] = ACTIONS(5351),
    [anon_sym_BANG_EQ] = ACTIONS(5351),
    [anon_sym_GT_EQ] = ACTIONS(5351),
    [anon_sym_LT_EQ] = ACTIONS(5351),
    [anon_sym_DOT] = ACTIONS(5353),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [anon_sym_switch] = ACTIONS(5351),
    [anon_sym_when] = ACTIONS(5351),
    [anon_sym_DOT_DOT] = ACTIONS(5351),
    [anon_sym_and] = ACTIONS(5351),
    [anon_sym_or] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_PIPE_PIPE] = ACTIONS(5351),
    [anon_sym_QMARK_QMARK] = ACTIONS(5351),
    [anon_sym_into] = ACTIONS(5351),
    [anon_sym_on] = ACTIONS(5351),
    [anon_sym_equals] = ACTIONS(5351),
    [anon_sym_by] = ACTIONS(5351),
    [anon_sym_as] = ACTIONS(5351),
    [anon_sym_is] = ACTIONS(5351),
    [anon_sym_DASH_GT] = ACTIONS(5351),
    [anon_sym_with] = ACTIONS(5351),
    [sym_string_literal_encoding] = ACTIONS(5832),
    [aux_sym_preproc_if_token3] = ACTIONS(5351),
    [aux_sym_preproc_else_token1] = ACTIONS(5351),
    [aux_sym_preproc_elif_token1] = ACTIONS(5351),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3946] = {
    [sym_preproc_region] = STATE(3946),
    [sym_preproc_endregion] = STATE(3946),
    [sym_preproc_line] = STATE(3946),
    [sym_preproc_pragma] = STATE(3946),
    [sym_preproc_nullable] = STATE(3946),
    [sym_preproc_error] = STATE(3946),
    [sym_preproc_define] = STATE(3946),
    [sym_preproc_undef] = STATE(3946),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_COLON] = ACTIONS(4644),
    [anon_sym_COMMA] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_LT] = ACTIONS(4646),
    [anon_sym_GT] = ACTIONS(4646),
    [anon_sym_QMARK] = ACTIONS(4646),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_STAR] = ACTIONS(4646),
    [anon_sym_SLASH] = ACTIONS(4646),
    [anon_sym_PERCENT] = ACTIONS(4646),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PIPE] = ACTIONS(4646),
    [anon_sym_AMP] = ACTIONS(4646),
    [anon_sym_LT_LT] = ACTIONS(4646),
    [anon_sym_GT_GT] = ACTIONS(4646),
    [anon_sym_GT_GT_GT] = ACTIONS(4646),
    [anon_sym_EQ_EQ] = ACTIONS(4644),
    [anon_sym_BANG_EQ] = ACTIONS(4644),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_LT_EQ] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4646),
    [anon_sym_switch] = ACTIONS(4644),
    [anon_sym_DOT_DOT] = ACTIONS(4644),
    [anon_sym_and] = ACTIONS(4644),
    [anon_sym_or] = ACTIONS(4644),
    [anon_sym_PLUS_EQ] = ACTIONS(4644),
    [anon_sym_DASH_EQ] = ACTIONS(4644),
    [anon_sym_STAR_EQ] = ACTIONS(4644),
    [anon_sym_SLASH_EQ] = ACTIONS(4644),
    [anon_sym_PERCENT_EQ] = ACTIONS(4644),
    [anon_sym_AMP_EQ] = ACTIONS(4644),
    [anon_sym_CARET_EQ] = ACTIONS(4644),
    [anon_sym_PIPE_EQ] = ACTIONS(4644),
    [anon_sym_LT_LT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4644),
    [anon_sym_AMP_AMP] = ACTIONS(4644),
    [anon_sym_PIPE_PIPE] = ACTIONS(4644),
    [anon_sym_QMARK_QMARK] = ACTIONS(4646),
    [anon_sym_into] = ACTIONS(4644),
    [anon_sym_as] = ACTIONS(4644),
    [anon_sym_is] = ACTIONS(4644),
    [anon_sym_DASH_GT] = ACTIONS(4644),
    [anon_sym_with] = ACTIONS(4644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4644),
  },
  [3947] = {
    [sym_preproc_region] = STATE(3947),
    [sym_preproc_endregion] = STATE(3947),
    [sym_preproc_line] = STATE(3947),
    [sym_preproc_pragma] = STATE(3947),
    [sym_preproc_nullable] = STATE(3947),
    [sym_preproc_error] = STATE(3947),
    [sym_preproc_define] = STATE(3947),
    [sym_preproc_undef] = STATE(3947),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_switch] = ACTIONS(4157),
    [anon_sym_when] = ACTIONS(4157),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4157),
    [anon_sym_or] = ACTIONS(4157),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_into] = ACTIONS(4157),
    [anon_sym_on] = ACTIONS(4157),
    [anon_sym_equals] = ACTIONS(4157),
    [anon_sym_by] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4157),
    [anon_sym_is] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4157),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3948] = {
    [sym_preproc_region] = STATE(3948),
    [sym_preproc_endregion] = STATE(3948),
    [sym_preproc_line] = STATE(3948),
    [sym_preproc_pragma] = STATE(3948),
    [sym_preproc_nullable] = STATE(3948),
    [sym_preproc_error] = STATE(3948),
    [sym_preproc_define] = STATE(3948),
    [sym_preproc_undef] = STATE(3948),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DQUOTE] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [sym_string_literal_encoding] = ACTIONS(5834),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3949] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3503),
    [sym_preproc_region] = STATE(3949),
    [sym_preproc_endregion] = STATE(3949),
    [sym_preproc_line] = STATE(3949),
    [sym_preproc_pragma] = STATE(3949),
    [sym_preproc_nullable] = STATE(3949),
    [sym_preproc_error] = STATE(3949),
    [sym_preproc_define] = STATE(3949),
    [sym_preproc_undef] = STATE(3949),
    [anon_sym_SEMI] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_RBRACK] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5313),
    [anon_sym_in] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5313),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_GT_GT_GT] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5311),
    [anon_sym_BANG_EQ] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5311),
    [anon_sym_switch] = ACTIONS(5311),
    [anon_sym_when] = ACTIONS(5311),
    [anon_sym_DOT_DOT] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_or] = ACTIONS(5311),
    [anon_sym_AMP_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_QMARK_QMARK] = ACTIONS(5311),
    [anon_sym_on] = ACTIONS(5311),
    [anon_sym_equals] = ACTIONS(5311),
    [anon_sym_by] = ACTIONS(5311),
    [anon_sym_as] = ACTIONS(5311),
    [anon_sym_is] = ACTIONS(5311),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5311),
    [aux_sym_preproc_if_token3] = ACTIONS(5311),
    [aux_sym_preproc_else_token1] = ACTIONS(5311),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3950] = {
    [sym_preproc_region] = STATE(3950),
    [sym_preproc_endregion] = STATE(3950),
    [sym_preproc_line] = STATE(3950),
    [sym_preproc_pragma] = STATE(3950),
    [sym_preproc_nullable] = STATE(3950),
    [sym_preproc_error] = STATE(3950),
    [sym_preproc_define] = STATE(3950),
    [sym_preproc_undef] = STATE(3950),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_COLON] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_RPAREN] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_in] = ACTIONS(5378),
    [anon_sym_where] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5380),
    [anon_sym_BANG] = ACTIONS(5380),
    [anon_sym_PLUS_PLUS] = ACTIONS(5378),
    [anon_sym_DASH_DASH] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5378),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5378),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5378),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_GT_GT_GT] = ACTIONS(5378),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_EQ_GT] = ACTIONS(5378),
    [anon_sym_switch] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_DOT_DOT] = ACTIONS(5378),
    [anon_sym_and] = ACTIONS(5378),
    [anon_sym_or] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE] = ACTIONS(5378),
    [anon_sym_QMARK_QMARK] = ACTIONS(5378),
    [anon_sym_on] = ACTIONS(5378),
    [anon_sym_equals] = ACTIONS(5378),
    [anon_sym_by] = ACTIONS(5378),
    [anon_sym_as] = ACTIONS(5378),
    [anon_sym_is] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_with] = ACTIONS(5378),
    [aux_sym_preproc_if_token3] = ACTIONS(5378),
    [aux_sym_preproc_else_token1] = ACTIONS(5378),
    [aux_sym_preproc_elif_token1] = ACTIONS(5378),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3951] = {
    [sym_preproc_region] = STATE(3951),
    [sym_preproc_endregion] = STATE(3951),
    [sym_preproc_line] = STATE(3951),
    [sym_preproc_pragma] = STATE(3951),
    [sym_preproc_nullable] = STATE(3951),
    [sym_preproc_error] = STATE(3951),
    [sym_preproc_define] = STATE(3951),
    [sym_preproc_undef] = STATE(3951),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_LBRACK] = ACTIONS(4705),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COMMA] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(4705),
    [anon_sym_LT] = ACTIONS(4707),
    [anon_sym_GT] = ACTIONS(4707),
    [anon_sym_QMARK] = ACTIONS(4707),
    [anon_sym_BANG] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4705),
    [anon_sym_DASH_DASH] = ACTIONS(4705),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_STAR] = ACTIONS(4707),
    [anon_sym_SLASH] = ACTIONS(4707),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_PIPE] = ACTIONS(4707),
    [anon_sym_AMP] = ACTIONS(4707),
    [anon_sym_LT_LT] = ACTIONS(4707),
    [anon_sym_GT_GT] = ACTIONS(4707),
    [anon_sym_GT_GT_GT] = ACTIONS(4707),
    [anon_sym_EQ_EQ] = ACTIONS(4705),
    [anon_sym_BANG_EQ] = ACTIONS(4705),
    [anon_sym_GT_EQ] = ACTIONS(4705),
    [anon_sym_LT_EQ] = ACTIONS(4705),
    [anon_sym_DOT] = ACTIONS(4707),
    [anon_sym_switch] = ACTIONS(4705),
    [anon_sym_DOT_DOT] = ACTIONS(4705),
    [anon_sym_and] = ACTIONS(4705),
    [anon_sym_or] = ACTIONS(4705),
    [anon_sym_PLUS_EQ] = ACTIONS(4705),
    [anon_sym_DASH_EQ] = ACTIONS(4705),
    [anon_sym_STAR_EQ] = ACTIONS(4705),
    [anon_sym_SLASH_EQ] = ACTIONS(4705),
    [anon_sym_PERCENT_EQ] = ACTIONS(4705),
    [anon_sym_AMP_EQ] = ACTIONS(4705),
    [anon_sym_CARET_EQ] = ACTIONS(4705),
    [anon_sym_PIPE_EQ] = ACTIONS(4705),
    [anon_sym_LT_LT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4705),
    [anon_sym_AMP_AMP] = ACTIONS(4705),
    [anon_sym_PIPE_PIPE] = ACTIONS(4705),
    [anon_sym_QMARK_QMARK] = ACTIONS(4707),
    [anon_sym_into] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(4705),
    [anon_sym_is] = ACTIONS(4705),
    [anon_sym_DASH_GT] = ACTIONS(4705),
    [anon_sym_with] = ACTIONS(4705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(4705),
  },
  [3952] = {
    [sym_preproc_region] = STATE(3952),
    [sym_preproc_endregion] = STATE(3952),
    [sym_preproc_line] = STATE(3952),
    [sym_preproc_pragma] = STATE(3952),
    [sym_preproc_nullable] = STATE(3952),
    [sym_preproc_error] = STATE(3952),
    [sym_preproc_define] = STATE(3952),
    [sym_preproc_undef] = STATE(3952),
    [anon_sym_SEMI] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5391),
    [anon_sym_COLON] = ACTIONS(5391),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_RBRACK] = ACTIONS(5391),
    [anon_sym_LPAREN] = ACTIONS(5391),
    [anon_sym_RPAREN] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5393),
    [anon_sym_in] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_BANG] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5393),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_SLASH] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5391),
    [anon_sym_CARET] = ACTIONS(5391),
    [anon_sym_PIPE] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5393),
    [anon_sym_LT_LT] = ACTIONS(5391),
    [anon_sym_GT_GT] = ACTIONS(5393),
    [anon_sym_GT_GT_GT] = ACTIONS(5391),
    [anon_sym_EQ_EQ] = ACTIONS(5391),
    [anon_sym_BANG_EQ] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5391),
    [anon_sym_LT_EQ] = ACTIONS(5391),
    [anon_sym_DOT] = ACTIONS(5393),
    [anon_sym_EQ_GT] = ACTIONS(5391),
    [anon_sym_switch] = ACTIONS(5391),
    [anon_sym_when] = ACTIONS(5391),
    [anon_sym_DOT_DOT] = ACTIONS(5391),
    [anon_sym_and] = ACTIONS(5391),
    [anon_sym_or] = ACTIONS(5391),
    [anon_sym_AMP_AMP] = ACTIONS(5391),
    [anon_sym_PIPE_PIPE] = ACTIONS(5391),
    [anon_sym_QMARK_QMARK] = ACTIONS(5391),
    [anon_sym_into] = ACTIONS(5391),
    [anon_sym_on] = ACTIONS(5391),
    [anon_sym_equals] = ACTIONS(5391),
    [anon_sym_by] = ACTIONS(5391),
    [anon_sym_as] = ACTIONS(5391),
    [anon_sym_is] = ACTIONS(5391),
    [anon_sym_DASH_GT] = ACTIONS(5391),
    [anon_sym_with] = ACTIONS(5391),
    [aux_sym_preproc_if_token3] = ACTIONS(5391),
    [aux_sym_preproc_else_token1] = ACTIONS(5391),
    [aux_sym_preproc_elif_token1] = ACTIONS(5391),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3953] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3503),
    [sym_preproc_region] = STATE(3953),
    [sym_preproc_endregion] = STATE(3953),
    [sym_preproc_line] = STATE(3953),
    [sym_preproc_pragma] = STATE(3953),
    [sym_preproc_nullable] = STATE(3953),
    [sym_preproc_error] = STATE(3953),
    [sym_preproc_define] = STATE(3953),
    [sym_preproc_undef] = STATE(3953),
    [anon_sym_SEMI] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5798),
    [anon_sym_COLON] = ACTIONS(5323),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_in] = ACTIONS(5323),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5323),
    [anon_sym_SLASH] = ACTIONS(5325),
    [anon_sym_PERCENT] = ACTIONS(5323),
    [anon_sym_CARET] = ACTIONS(5323),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5323),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_GT_GT_GT] = ACTIONS(5323),
    [anon_sym_EQ_EQ] = ACTIONS(5323),
    [anon_sym_BANG_EQ] = ACTIONS(5323),
    [anon_sym_GT_EQ] = ACTIONS(5323),
    [anon_sym_LT_EQ] = ACTIONS(5323),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5323),
    [anon_sym_switch] = ACTIONS(5323),
    [anon_sym_when] = ACTIONS(5323),
    [anon_sym_DOT_DOT] = ACTIONS(5323),
    [anon_sym_and] = ACTIONS(5323),
    [anon_sym_or] = ACTIONS(5323),
    [anon_sym_AMP_AMP] = ACTIONS(5323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5323),
    [anon_sym_QMARK_QMARK] = ACTIONS(5323),
    [anon_sym_on] = ACTIONS(5323),
    [anon_sym_equals] = ACTIONS(5323),
    [anon_sym_by] = ACTIONS(5323),
    [anon_sym_as] = ACTIONS(5323),
    [anon_sym_is] = ACTIONS(5323),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5323),
    [aux_sym_preproc_if_token3] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3954] = {
    [sym_preproc_region] = STATE(3954),
    [sym_preproc_endregion] = STATE(3954),
    [sym_preproc_line] = STATE(3954),
    [sym_preproc_pragma] = STATE(3954),
    [sym_preproc_nullable] = STATE(3954),
    [sym_preproc_error] = STATE(3954),
    [sym_preproc_define] = STATE(3954),
    [sym_preproc_undef] = STATE(3954),
    [anon_sym_SEMI] = ACTIONS(4579),
    [anon_sym_LBRACK] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4579),
    [anon_sym_COMMA] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4579),
    [anon_sym_LPAREN] = ACTIONS(4579),
    [anon_sym_RPAREN] = ACTIONS(4579),
    [anon_sym_LBRACE] = ACTIONS(4579),
    [anon_sym_RBRACE] = ACTIONS(4579),
    [anon_sym_LT] = ACTIONS(4577),
    [anon_sym_GT] = ACTIONS(4577),
    [anon_sym_in] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(4577),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_PLUS_PLUS] = ACTIONS(4579),
    [anon_sym_DASH_DASH] = ACTIONS(4579),
    [anon_sym_PLUS] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4577),
    [anon_sym_STAR] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(4577),
    [anon_sym_PERCENT] = ACTIONS(4579),
    [anon_sym_CARET] = ACTIONS(4579),
    [anon_sym_PIPE] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(4577),
    [anon_sym_LT_LT] = ACTIONS(4579),
    [anon_sym_GT_GT] = ACTIONS(4577),
    [anon_sym_GT_GT_GT] = ACTIONS(4579),
    [anon_sym_EQ_EQ] = ACTIONS(4579),
    [anon_sym_BANG_EQ] = ACTIONS(4579),
    [anon_sym_GT_EQ] = ACTIONS(4579),
    [anon_sym_LT_EQ] = ACTIONS(4579),
    [anon_sym_DOT] = ACTIONS(4577),
    [anon_sym_EQ_GT] = ACTIONS(4579),
    [anon_sym_switch] = ACTIONS(4579),
    [anon_sym_when] = ACTIONS(4579),
    [anon_sym_DOT_DOT] = ACTIONS(4579),
    [anon_sym_and] = ACTIONS(4579),
    [anon_sym_or] = ACTIONS(4579),
    [anon_sym_AMP_AMP] = ACTIONS(4579),
    [anon_sym_PIPE_PIPE] = ACTIONS(4579),
    [anon_sym_QMARK_QMARK] = ACTIONS(4579),
    [anon_sym_on] = ACTIONS(4579),
    [anon_sym_equals] = ACTIONS(4579),
    [anon_sym_by] = ACTIONS(4579),
    [anon_sym_as] = ACTIONS(4579),
    [anon_sym_is] = ACTIONS(4579),
    [anon_sym_DASH_GT] = ACTIONS(4579),
    [anon_sym_with] = ACTIONS(4579),
    [aux_sym_preproc_if_token3] = ACTIONS(4579),
    [aux_sym_preproc_else_token1] = ACTIONS(4579),
    [aux_sym_preproc_elif_token1] = ACTIONS(4579),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3955] = {
    [sym_preproc_region] = STATE(3955),
    [sym_preproc_endregion] = STATE(3955),
    [sym_preproc_line] = STATE(3955),
    [sym_preproc_pragma] = STATE(3955),
    [sym_preproc_nullable] = STATE(3955),
    [sym_preproc_error] = STATE(3955),
    [sym_preproc_define] = STATE(3955),
    [sym_preproc_undef] = STATE(3955),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5588),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_when] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_into] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3956] = {
    [sym_preproc_region] = STATE(3956),
    [sym_preproc_endregion] = STATE(3956),
    [sym_preproc_line] = STATE(3956),
    [sym_preproc_pragma] = STATE(3956),
    [sym_preproc_nullable] = STATE(3956),
    [sym_preproc_error] = STATE(3956),
    [sym_preproc_define] = STATE(3956),
    [sym_preproc_undef] = STATE(3956),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(5836),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3957] = {
    [sym_preproc_region] = STATE(3957),
    [sym_preproc_endregion] = STATE(3957),
    [sym_preproc_line] = STATE(3957),
    [sym_preproc_pragma] = STATE(3957),
    [sym_preproc_nullable] = STATE(3957),
    [sym_preproc_error] = STATE(3957),
    [sym_preproc_define] = STATE(3957),
    [sym_preproc_undef] = STATE(3957),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_LBRACK] = ACTIONS(4473),
    [anon_sym_COLON] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(4473),
    [anon_sym_RBRACK] = ACTIONS(4473),
    [anon_sym_LPAREN] = ACTIONS(4473),
    [anon_sym_RPAREN] = ACTIONS(4473),
    [anon_sym_LBRACE] = ACTIONS(4473),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_LT] = ACTIONS(4471),
    [anon_sym_GT] = ACTIONS(4471),
    [anon_sym_in] = ACTIONS(4473),
    [anon_sym_QMARK] = ACTIONS(4471),
    [anon_sym_BANG] = ACTIONS(4471),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS] = ACTIONS(4471),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_STAR] = ACTIONS(4473),
    [anon_sym_SLASH] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4473),
    [anon_sym_CARET] = ACTIONS(4473),
    [anon_sym_PIPE] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT_LT] = ACTIONS(4473),
    [anon_sym_GT_GT] = ACTIONS(4471),
    [anon_sym_GT_GT_GT] = ACTIONS(4473),
    [anon_sym_EQ_EQ] = ACTIONS(4473),
    [anon_sym_BANG_EQ] = ACTIONS(4473),
    [anon_sym_GT_EQ] = ACTIONS(4473),
    [anon_sym_LT_EQ] = ACTIONS(4473),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_EQ_GT] = ACTIONS(4473),
    [anon_sym_switch] = ACTIONS(4473),
    [anon_sym_when] = ACTIONS(4473),
    [anon_sym_DOT_DOT] = ACTIONS(4473),
    [anon_sym_and] = ACTIONS(4473),
    [anon_sym_or] = ACTIONS(4473),
    [anon_sym_AMP_AMP] = ACTIONS(4473),
    [anon_sym_PIPE_PIPE] = ACTIONS(4473),
    [anon_sym_QMARK_QMARK] = ACTIONS(4473),
    [anon_sym_on] = ACTIONS(4473),
    [anon_sym_equals] = ACTIONS(4473),
    [anon_sym_by] = ACTIONS(4473),
    [anon_sym_as] = ACTIONS(4473),
    [anon_sym_is] = ACTIONS(4473),
    [anon_sym_DASH_GT] = ACTIONS(4473),
    [anon_sym_with] = ACTIONS(4473),
    [aux_sym_preproc_if_token3] = ACTIONS(4473),
    [aux_sym_preproc_else_token1] = ACTIONS(4473),
    [aux_sym_preproc_elif_token1] = ACTIONS(4473),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3958] = {
    [sym_preproc_region] = STATE(3958),
    [sym_preproc_endregion] = STATE(3958),
    [sym_preproc_line] = STATE(3958),
    [sym_preproc_pragma] = STATE(3958),
    [sym_preproc_nullable] = STATE(3958),
    [sym_preproc_error] = STATE(3958),
    [sym_preproc_define] = STATE(3958),
    [sym_preproc_undef] = STATE(3958),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_in] = ACTIONS(5502),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_BANG] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_EQ_GT] = ACTIONS(5500),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_when] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_into] = ACTIONS(5500),
    [anon_sym_on] = ACTIONS(5500),
    [anon_sym_equals] = ACTIONS(5500),
    [anon_sym_by] = ACTIONS(5500),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3959] = {
    [sym_preproc_region] = STATE(3959),
    [sym_preproc_endregion] = STATE(3959),
    [sym_preproc_line] = STATE(3959),
    [sym_preproc_pragma] = STATE(3959),
    [sym_preproc_nullable] = STATE(3959),
    [sym_preproc_error] = STATE(3959),
    [sym_preproc_define] = STATE(3959),
    [sym_preproc_undef] = STATE(3959),
    [anon_sym_SEMI] = ACTIONS(4467),
    [anon_sym_LBRACK] = ACTIONS(4467),
    [anon_sym_COLON] = ACTIONS(4467),
    [anon_sym_COMMA] = ACTIONS(4467),
    [anon_sym_RBRACK] = ACTIONS(4467),
    [anon_sym_LPAREN] = ACTIONS(4467),
    [anon_sym_RPAREN] = ACTIONS(4467),
    [anon_sym_LBRACE] = ACTIONS(4467),
    [anon_sym_RBRACE] = ACTIONS(4467),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(4465),
    [anon_sym_in] = ACTIONS(4467),
    [anon_sym_QMARK] = ACTIONS(4465),
    [anon_sym_BANG] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4465),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_SLASH] = ACTIONS(4465),
    [anon_sym_PERCENT] = ACTIONS(4467),
    [anon_sym_CARET] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(4465),
    [anon_sym_AMP] = ACTIONS(4465),
    [anon_sym_LT_LT] = ACTIONS(4467),
    [anon_sym_GT_GT] = ACTIONS(4465),
    [anon_sym_GT_GT_GT] = ACTIONS(4467),
    [anon_sym_EQ_EQ] = ACTIONS(4467),
    [anon_sym_BANG_EQ] = ACTIONS(4467),
    [anon_sym_GT_EQ] = ACTIONS(4467),
    [anon_sym_LT_EQ] = ACTIONS(4467),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_EQ_GT] = ACTIONS(4467),
    [anon_sym_switch] = ACTIONS(4467),
    [anon_sym_when] = ACTIONS(4467),
    [anon_sym_DOT_DOT] = ACTIONS(4467),
    [anon_sym_and] = ACTIONS(4467),
    [anon_sym_or] = ACTIONS(4467),
    [anon_sym_AMP_AMP] = ACTIONS(4467),
    [anon_sym_PIPE_PIPE] = ACTIONS(4467),
    [anon_sym_QMARK_QMARK] = ACTIONS(4467),
    [anon_sym_on] = ACTIONS(4467),
    [anon_sym_equals] = ACTIONS(4467),
    [anon_sym_by] = ACTIONS(4467),
    [anon_sym_as] = ACTIONS(4467),
    [anon_sym_is] = ACTIONS(4467),
    [anon_sym_DASH_GT] = ACTIONS(4467),
    [anon_sym_with] = ACTIONS(4467),
    [aux_sym_preproc_if_token3] = ACTIONS(4467),
    [aux_sym_preproc_else_token1] = ACTIONS(4467),
    [aux_sym_preproc_elif_token1] = ACTIONS(4467),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3960] = {
    [sym_type_argument_list] = STATE(3591),
    [sym_preproc_region] = STATE(3960),
    [sym_preproc_endregion] = STATE(3960),
    [sym_preproc_line] = STATE(3960),
    [sym_preproc_pragma] = STATE(3960),
    [sym_preproc_nullable] = STATE(3960),
    [sym_preproc_error] = STATE(3960),
    [sym_preproc_define] = STATE(3960),
    [sym_preproc_undef] = STATE(3960),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(5269),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4138),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_COLON_COLON] = ACTIONS(5838),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3961] = {
    [sym_modifier] = STATE(4531),
    [sym_identifier] = STATE(7777),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(3961),
    [sym_preproc_endregion] = STATE(3961),
    [sym_preproc_line] = STATE(3961),
    [sym_preproc_pragma] = STATE(3961),
    [sym_preproc_nullable] = STATE(3961),
    [sym_preproc_error] = STATE(3961),
    [sym_preproc_define] = STATE(3961),
    [sym_preproc_undef] = STATE(3961),
    [aux_sym_class_declaration_repeat2] = STATE(4348),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_abstract] = ACTIONS(5490),
    [anon_sym_async] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_file] = ACTIONS(5496),
    [anon_sym_fixed] = ACTIONS(5490),
    [anon_sym_internal] = ACTIONS(5490),
    [anon_sym_new] = ACTIONS(5490),
    [anon_sym_override] = ACTIONS(5490),
    [anon_sym_partial] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_readonly] = ACTIONS(5490),
    [anon_sym_required] = ACTIONS(5490),
    [anon_sym_sealed] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5758),
    [anon_sym_set] = ACTIONS(5758),
    [anon_sym_add] = ACTIONS(5758),
    [anon_sym_remove] = ACTIONS(5758),
    [anon_sym_init] = ACTIONS(5758),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3962] = {
    [sym_preproc_region] = STATE(3962),
    [sym_preproc_endregion] = STATE(3962),
    [sym_preproc_line] = STATE(3962),
    [sym_preproc_pragma] = STATE(3962),
    [sym_preproc_nullable] = STATE(3962),
    [sym_preproc_error] = STATE(3962),
    [sym_preproc_define] = STATE(3962),
    [sym_preproc_undef] = STATE(3962),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_RBRACK] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_in] = ACTIONS(1969),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1967),
    [anon_sym_BANG_EQ] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_EQ_GT] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_when] = ACTIONS(1967),
    [anon_sym_DOT_DOT] = ACTIONS(1967),
    [anon_sym_and] = ACTIONS(1967),
    [anon_sym_or] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_QMARK_QMARK] = ACTIONS(1967),
    [anon_sym_into] = ACTIONS(1967),
    [anon_sym_on] = ACTIONS(1967),
    [anon_sym_equals] = ACTIONS(1967),
    [anon_sym_by] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_is] = ACTIONS(1967),
    [anon_sym_DASH_GT] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [aux_sym_preproc_if_token3] = ACTIONS(1967),
    [aux_sym_preproc_else_token1] = ACTIONS(1967),
    [aux_sym_preproc_elif_token1] = ACTIONS(1967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3963] = {
    [sym_preproc_region] = STATE(3963),
    [sym_preproc_endregion] = STATE(3963),
    [sym_preproc_line] = STATE(3963),
    [sym_preproc_pragma] = STATE(3963),
    [sym_preproc_nullable] = STATE(3963),
    [sym_preproc_error] = STATE(3963),
    [sym_preproc_define] = STATE(3963),
    [sym_preproc_undef] = STATE(3963),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym_LBRACK] = ACTIONS(5476),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_RBRACK] = ACTIONS(5476),
    [anon_sym_LPAREN] = ACTIONS(5476),
    [anon_sym_RPAREN] = ACTIONS(5476),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5478),
    [anon_sym_QMARK] = ACTIONS(5478),
    [anon_sym_BANG] = ACTIONS(5478),
    [anon_sym_PLUS_PLUS] = ACTIONS(5476),
    [anon_sym_DASH_DASH] = ACTIONS(5476),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_CARET] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5476),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_GT_GT_GT] = ACTIONS(5476),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5476),
    [anon_sym_GT_EQ] = ACTIONS(5476),
    [anon_sym_LT_EQ] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_EQ_GT] = ACTIONS(5476),
    [anon_sym_switch] = ACTIONS(5476),
    [anon_sym_when] = ACTIONS(5476),
    [anon_sym_DOT_DOT] = ACTIONS(5476),
    [anon_sym_and] = ACTIONS(5476),
    [anon_sym_or] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_PIPE_PIPE] = ACTIONS(5476),
    [anon_sym_QMARK_QMARK] = ACTIONS(5476),
    [anon_sym_into] = ACTIONS(5476),
    [anon_sym_on] = ACTIONS(5476),
    [anon_sym_equals] = ACTIONS(5476),
    [anon_sym_by] = ACTIONS(5476),
    [anon_sym_as] = ACTIONS(5476),
    [anon_sym_is] = ACTIONS(5476),
    [anon_sym_DASH_GT] = ACTIONS(5476),
    [anon_sym_with] = ACTIONS(5476),
    [aux_sym_preproc_if_token3] = ACTIONS(5476),
    [aux_sym_preproc_else_token1] = ACTIONS(5476),
    [aux_sym_preproc_elif_token1] = ACTIONS(5476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3964] = {
    [sym_preproc_region] = STATE(3964),
    [sym_preproc_endregion] = STATE(3964),
    [sym_preproc_line] = STATE(3964),
    [sym_preproc_pragma] = STATE(3964),
    [sym_preproc_nullable] = STATE(3964),
    [sym_preproc_error] = STATE(3964),
    [sym_preproc_define] = STATE(3964),
    [sym_preproc_undef] = STATE(3964),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5294),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3965] = {
    [sym_preproc_region] = STATE(3965),
    [sym_preproc_endregion] = STATE(3965),
    [sym_preproc_line] = STATE(3965),
    [sym_preproc_pragma] = STATE(3965),
    [sym_preproc_nullable] = STATE(3965),
    [sym_preproc_error] = STATE(3965),
    [sym_preproc_define] = STATE(3965),
    [sym_preproc_undef] = STATE(3965),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_COLON] = ACTIONS(4500),
    [anon_sym_COMMA] = ACTIONS(4500),
    [anon_sym_RBRACK] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LT] = ACTIONS(4498),
    [anon_sym_GT] = ACTIONS(4498),
    [anon_sym_in] = ACTIONS(4500),
    [anon_sym_QMARK] = ACTIONS(4498),
    [anon_sym_BANG] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_SLASH] = ACTIONS(4498),
    [anon_sym_PERCENT] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4500),
    [anon_sym_PIPE] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4500),
    [anon_sym_GT_GT] = ACTIONS(4498),
    [anon_sym_GT_GT_GT] = ACTIONS(4500),
    [anon_sym_EQ_EQ] = ACTIONS(4500),
    [anon_sym_BANG_EQ] = ACTIONS(4500),
    [anon_sym_GT_EQ] = ACTIONS(4500),
    [anon_sym_LT_EQ] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4498),
    [anon_sym_EQ_GT] = ACTIONS(4500),
    [anon_sym_switch] = ACTIONS(4500),
    [anon_sym_when] = ACTIONS(4500),
    [anon_sym_DOT_DOT] = ACTIONS(4500),
    [anon_sym_and] = ACTIONS(4500),
    [anon_sym_or] = ACTIONS(4500),
    [anon_sym_AMP_AMP] = ACTIONS(4500),
    [anon_sym_PIPE_PIPE] = ACTIONS(4500),
    [anon_sym_QMARK_QMARK] = ACTIONS(4500),
    [anon_sym_on] = ACTIONS(4500),
    [anon_sym_equals] = ACTIONS(4500),
    [anon_sym_by] = ACTIONS(4500),
    [anon_sym_as] = ACTIONS(4500),
    [anon_sym_is] = ACTIONS(4500),
    [anon_sym_DASH_GT] = ACTIONS(4500),
    [anon_sym_with] = ACTIONS(4500),
    [aux_sym_preproc_if_token3] = ACTIONS(4500),
    [aux_sym_preproc_else_token1] = ACTIONS(4500),
    [aux_sym_preproc_elif_token1] = ACTIONS(4500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3966] = {
    [sym_preproc_region] = STATE(3966),
    [sym_preproc_endregion] = STATE(3966),
    [sym_preproc_line] = STATE(3966),
    [sym_preproc_pragma] = STATE(3966),
    [sym_preproc_nullable] = STATE(3966),
    [sym_preproc_error] = STATE(3966),
    [sym_preproc_define] = STATE(3966),
    [sym_preproc_undef] = STATE(3966),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5840),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3967] = {
    [sym_preproc_region] = STATE(3967),
    [sym_preproc_endregion] = STATE(3967),
    [sym_preproc_line] = STATE(3967),
    [sym_preproc_pragma] = STATE(3967),
    [sym_preproc_nullable] = STATE(3967),
    [sym_preproc_error] = STATE(3967),
    [sym_preproc_define] = STATE(3967),
    [sym_preproc_undef] = STATE(3967),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5568),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_BANG] = ACTIONS(5568),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_GT_GT_GT] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_EQ_GT] = ACTIONS(5566),
    [anon_sym_switch] = ACTIONS(5566),
    [anon_sym_when] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_and] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_QMARK_QMARK] = ACTIONS(5566),
    [anon_sym_into] = ACTIONS(5566),
    [anon_sym_on] = ACTIONS(5566),
    [anon_sym_equals] = ACTIONS(5566),
    [anon_sym_by] = ACTIONS(5566),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_is] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [anon_sym_with] = ACTIONS(5566),
    [aux_sym_preproc_if_token3] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3968] = {
    [sym_preproc_region] = STATE(3968),
    [sym_preproc_endregion] = STATE(3968),
    [sym_preproc_line] = STATE(3968),
    [sym_preproc_pragma] = STATE(3968),
    [sym_preproc_nullable] = STATE(3968),
    [sym_preproc_error] = STATE(3968),
    [sym_preproc_define] = STATE(3968),
    [sym_preproc_undef] = STATE(3968),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_COLON] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(4624),
    [anon_sym_RBRACK] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LT] = ACTIONS(4622),
    [anon_sym_GT] = ACTIONS(4622),
    [anon_sym_in] = ACTIONS(4624),
    [anon_sym_QMARK] = ACTIONS(4622),
    [anon_sym_BANG] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_SLASH] = ACTIONS(4622),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [anon_sym_CARET] = ACTIONS(4624),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_AMP] = ACTIONS(4622),
    [anon_sym_LT_LT] = ACTIONS(4624),
    [anon_sym_GT_GT] = ACTIONS(4622),
    [anon_sym_GT_GT_GT] = ACTIONS(4624),
    [anon_sym_EQ_EQ] = ACTIONS(4624),
    [anon_sym_BANG_EQ] = ACTIONS(4624),
    [anon_sym_GT_EQ] = ACTIONS(4624),
    [anon_sym_LT_EQ] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4622),
    [anon_sym_EQ_GT] = ACTIONS(4624),
    [anon_sym_switch] = ACTIONS(4624),
    [anon_sym_when] = ACTIONS(4624),
    [anon_sym_DOT_DOT] = ACTIONS(4624),
    [anon_sym_and] = ACTIONS(4624),
    [anon_sym_or] = ACTIONS(4624),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_QMARK_QMARK] = ACTIONS(4624),
    [anon_sym_on] = ACTIONS(4624),
    [anon_sym_equals] = ACTIONS(4624),
    [anon_sym_by] = ACTIONS(4624),
    [anon_sym_as] = ACTIONS(4624),
    [anon_sym_is] = ACTIONS(4624),
    [anon_sym_DASH_GT] = ACTIONS(4624),
    [anon_sym_with] = ACTIONS(4624),
    [aux_sym_preproc_if_token3] = ACTIONS(4624),
    [aux_sym_preproc_else_token1] = ACTIONS(4624),
    [aux_sym_preproc_elif_token1] = ACTIONS(4624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3969] = {
    [sym_preproc_region] = STATE(3969),
    [sym_preproc_endregion] = STATE(3969),
    [sym_preproc_line] = STATE(3969),
    [sym_preproc_pragma] = STATE(3969),
    [sym_preproc_nullable] = STATE(3969),
    [sym_preproc_error] = STATE(3969),
    [sym_preproc_define] = STATE(3969),
    [sym_preproc_undef] = STATE(3969),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_COMMA] = ACTIONS(4620),
    [anon_sym_RBRACK] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LT] = ACTIONS(4618),
    [anon_sym_GT] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4620),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_BANG] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_SLASH] = ACTIONS(4618),
    [anon_sym_PERCENT] = ACTIONS(4620),
    [anon_sym_CARET] = ACTIONS(4620),
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_AMP] = ACTIONS(4618),
    [anon_sym_LT_LT] = ACTIONS(4620),
    [anon_sym_GT_GT] = ACTIONS(4618),
    [anon_sym_GT_GT_GT] = ACTIONS(4620),
    [anon_sym_EQ_EQ] = ACTIONS(4620),
    [anon_sym_BANG_EQ] = ACTIONS(4620),
    [anon_sym_GT_EQ] = ACTIONS(4620),
    [anon_sym_LT_EQ] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_EQ_GT] = ACTIONS(4620),
    [anon_sym_switch] = ACTIONS(4620),
    [anon_sym_when] = ACTIONS(4620),
    [anon_sym_DOT_DOT] = ACTIONS(4620),
    [anon_sym_and] = ACTIONS(4620),
    [anon_sym_or] = ACTIONS(4620),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_QMARK_QMARK] = ACTIONS(4620),
    [anon_sym_on] = ACTIONS(4620),
    [anon_sym_equals] = ACTIONS(4620),
    [anon_sym_by] = ACTIONS(4620),
    [anon_sym_as] = ACTIONS(4620),
    [anon_sym_is] = ACTIONS(4620),
    [anon_sym_DASH_GT] = ACTIONS(4620),
    [anon_sym_with] = ACTIONS(4620),
    [aux_sym_preproc_if_token3] = ACTIONS(4620),
    [aux_sym_preproc_else_token1] = ACTIONS(4620),
    [aux_sym_preproc_elif_token1] = ACTIONS(4620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3970] = {
    [sym_preproc_region] = STATE(3970),
    [sym_preproc_endregion] = STATE(3970),
    [sym_preproc_line] = STATE(3970),
    [sym_preproc_pragma] = STATE(3970),
    [sym_preproc_nullable] = STATE(3970),
    [sym_preproc_error] = STATE(3970),
    [sym_preproc_define] = STATE(3970),
    [sym_preproc_undef] = STATE(3970),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [anon_sym_RBRACK] = ACTIONS(4178),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_RPAREN] = ACTIONS(4178),
    [anon_sym_LBRACE] = ACTIONS(4178),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_in] = ACTIONS(4178),
    [anon_sym_QMARK] = ACTIONS(4169),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4178),
    [anon_sym_DASH_DASH] = ACTIONS(4178),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_STAR] = ACTIONS(4178),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4178),
    [anon_sym_CARET] = ACTIONS(4178),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_LT_LT] = ACTIONS(4178),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4178),
    [anon_sym_EQ_EQ] = ACTIONS(4178),
    [anon_sym_BANG_EQ] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4178),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_DOT] = ACTIONS(4169),
    [anon_sym_EQ_GT] = ACTIONS(4178),
    [anon_sym_switch] = ACTIONS(4178),
    [anon_sym_when] = ACTIONS(4178),
    [anon_sym_DOT_DOT] = ACTIONS(4178),
    [anon_sym_and] = ACTIONS(4178),
    [anon_sym_or] = ACTIONS(4178),
    [anon_sym_AMP_AMP] = ACTIONS(4178),
    [anon_sym_PIPE_PIPE] = ACTIONS(4178),
    [anon_sym_QMARK_QMARK] = ACTIONS(4178),
    [anon_sym_on] = ACTIONS(4178),
    [anon_sym_equals] = ACTIONS(4178),
    [anon_sym_by] = ACTIONS(4178),
    [anon_sym_as] = ACTIONS(4178),
    [anon_sym_is] = ACTIONS(4178),
    [anon_sym_DASH_GT] = ACTIONS(4178),
    [anon_sym_with] = ACTIONS(4178),
    [aux_sym_preproc_if_token3] = ACTIONS(4178),
    [aux_sym_preproc_else_token1] = ACTIONS(4178),
    [aux_sym_preproc_elif_token1] = ACTIONS(4178),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3971] = {
    [sym_preproc_region] = STATE(3971),
    [sym_preproc_endregion] = STATE(3971),
    [sym_preproc_line] = STATE(3971),
    [sym_preproc_pragma] = STATE(3971),
    [sym_preproc_nullable] = STATE(3971),
    [sym_preproc_error] = STATE(3971),
    [sym_preproc_define] = STATE(3971),
    [sym_preproc_undef] = STATE(3971),
    [anon_sym_SEMI] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_RBRACK] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_RPAREN] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_in] = ACTIONS(5411),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_when] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_on] = ACTIONS(5411),
    [anon_sym_equals] = ACTIONS(5411),
    [anon_sym_by] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5411),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DQUOTE] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_if_token3] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3972] = {
    [sym_preproc_region] = STATE(3972),
    [sym_preproc_endregion] = STATE(3972),
    [sym_preproc_line] = STATE(3972),
    [sym_preproc_pragma] = STATE(3972),
    [sym_preproc_nullable] = STATE(3972),
    [sym_preproc_error] = STATE(3972),
    [sym_preproc_define] = STATE(3972),
    [sym_preproc_undef] = STATE(3972),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5638),
    [anon_sym_QMARK] = ACTIONS(5638),
    [anon_sym_BANG] = ACTIONS(5638),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_CARET] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5636),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_GT_GT_GT] = ACTIONS(5636),
    [anon_sym_EQ_EQ] = ACTIONS(5636),
    [anon_sym_BANG_EQ] = ACTIONS(5636),
    [anon_sym_GT_EQ] = ACTIONS(5636),
    [anon_sym_LT_EQ] = ACTIONS(5636),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5636),
    [anon_sym_switch] = ACTIONS(5636),
    [anon_sym_when] = ACTIONS(5636),
    [anon_sym_DOT_DOT] = ACTIONS(5636),
    [anon_sym_and] = ACTIONS(5636),
    [anon_sym_or] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_QMARK_QMARK] = ACTIONS(5636),
    [anon_sym_into] = ACTIONS(5636),
    [anon_sym_on] = ACTIONS(5636),
    [anon_sym_equals] = ACTIONS(5636),
    [anon_sym_by] = ACTIONS(5636),
    [anon_sym_as] = ACTIONS(5636),
    [anon_sym_is] = ACTIONS(5636),
    [anon_sym_DASH_GT] = ACTIONS(5636),
    [anon_sym_with] = ACTIONS(5636),
    [aux_sym_preproc_if_token3] = ACTIONS(5636),
    [aux_sym_preproc_else_token1] = ACTIONS(5636),
    [aux_sym_preproc_elif_token1] = ACTIONS(5636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3973] = {
    [sym_preproc_region] = STATE(3973),
    [sym_preproc_endregion] = STATE(3973),
    [sym_preproc_line] = STATE(3973),
    [sym_preproc_pragma] = STATE(3973),
    [sym_preproc_nullable] = STATE(3973),
    [sym_preproc_error] = STATE(3973),
    [sym_preproc_define] = STATE(3973),
    [sym_preproc_undef] = STATE(3973),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_in] = ACTIONS(5466),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_BANG] = ACTIONS(5466),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_SLASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5464),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_GT_GT_GT] = ACTIONS(5464),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_EQ_GT] = ACTIONS(5464),
    [anon_sym_switch] = ACTIONS(5464),
    [anon_sym_when] = ACTIONS(5464),
    [anon_sym_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_QMARK_QMARK] = ACTIONS(5464),
    [anon_sym_into] = ACTIONS(5464),
    [anon_sym_on] = ACTIONS(5464),
    [anon_sym_equals] = ACTIONS(5464),
    [anon_sym_by] = ACTIONS(5464),
    [anon_sym_as] = ACTIONS(5464),
    [anon_sym_is] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_with] = ACTIONS(5464),
    [aux_sym_preproc_if_token3] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3974] = {
    [sym_preproc_region] = STATE(3974),
    [sym_preproc_endregion] = STATE(3974),
    [sym_preproc_line] = STATE(3974),
    [sym_preproc_pragma] = STATE(3974),
    [sym_preproc_nullable] = STATE(3974),
    [sym_preproc_error] = STATE(3974),
    [sym_preproc_define] = STATE(3974),
    [sym_preproc_undef] = STATE(3974),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_COLON] = ACTIONS(4604),
    [anon_sym_COMMA] = ACTIONS(4604),
    [anon_sym_RBRACK] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LT] = ACTIONS(4602),
    [anon_sym_GT] = ACTIONS(4602),
    [anon_sym_in] = ACTIONS(4604),
    [anon_sym_QMARK] = ACTIONS(4602),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(4602),
    [anon_sym_PERCENT] = ACTIONS(4604),
    [anon_sym_CARET] = ACTIONS(4604),
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_AMP] = ACTIONS(4602),
    [anon_sym_LT_LT] = ACTIONS(4604),
    [anon_sym_GT_GT] = ACTIONS(4602),
    [anon_sym_GT_GT_GT] = ACTIONS(4604),
    [anon_sym_EQ_EQ] = ACTIONS(4604),
    [anon_sym_BANG_EQ] = ACTIONS(4604),
    [anon_sym_GT_EQ] = ACTIONS(4604),
    [anon_sym_LT_EQ] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4602),
    [anon_sym_EQ_GT] = ACTIONS(4604),
    [anon_sym_switch] = ACTIONS(4604),
    [anon_sym_when] = ACTIONS(4604),
    [anon_sym_DOT_DOT] = ACTIONS(4604),
    [anon_sym_and] = ACTIONS(4604),
    [anon_sym_or] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_QMARK_QMARK] = ACTIONS(4604),
    [anon_sym_on] = ACTIONS(4604),
    [anon_sym_equals] = ACTIONS(4604),
    [anon_sym_by] = ACTIONS(4604),
    [anon_sym_as] = ACTIONS(4604),
    [anon_sym_is] = ACTIONS(4604),
    [anon_sym_DASH_GT] = ACTIONS(4604),
    [anon_sym_with] = ACTIONS(4604),
    [aux_sym_preproc_if_token3] = ACTIONS(4604),
    [aux_sym_preproc_else_token1] = ACTIONS(4604),
    [aux_sym_preproc_elif_token1] = ACTIONS(4604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3975] = {
    [sym_preproc_region] = STATE(3975),
    [sym_preproc_endregion] = STATE(3975),
    [sym_preproc_line] = STATE(3975),
    [sym_preproc_pragma] = STATE(3975),
    [sym_preproc_nullable] = STATE(3975),
    [sym_preproc_error] = STATE(3975),
    [sym_preproc_define] = STATE(3975),
    [sym_preproc_undef] = STATE(3975),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5578),
    [anon_sym_COMMA] = ACTIONS(5578),
    [anon_sym_RBRACK] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(5578),
    [anon_sym_RPAREN] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5580),
    [anon_sym_in] = ACTIONS(5580),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_BANG] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5578),
    [anon_sym_SLASH] = ACTIONS(5580),
    [anon_sym_PERCENT] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5580),
    [anon_sym_LT_LT] = ACTIONS(5578),
    [anon_sym_GT_GT] = ACTIONS(5580),
    [anon_sym_GT_GT_GT] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5578),
    [anon_sym_BANG_EQ] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5578),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(5580),
    [anon_sym_EQ_GT] = ACTIONS(5578),
    [anon_sym_switch] = ACTIONS(5578),
    [anon_sym_when] = ACTIONS(5578),
    [anon_sym_DOT_DOT] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_AMP_AMP] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE] = ACTIONS(5578),
    [anon_sym_QMARK_QMARK] = ACTIONS(5578),
    [anon_sym_into] = ACTIONS(5578),
    [anon_sym_on] = ACTIONS(5578),
    [anon_sym_equals] = ACTIONS(5578),
    [anon_sym_by] = ACTIONS(5578),
    [anon_sym_as] = ACTIONS(5578),
    [anon_sym_is] = ACTIONS(5578),
    [anon_sym_DASH_GT] = ACTIONS(5578),
    [anon_sym_with] = ACTIONS(5578),
    [aux_sym_preproc_if_token3] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3976] = {
    [sym_preproc_region] = STATE(3976),
    [sym_preproc_endregion] = STATE(3976),
    [sym_preproc_line] = STATE(3976),
    [sym_preproc_pragma] = STATE(3976),
    [sym_preproc_nullable] = STATE(3976),
    [sym_preproc_error] = STATE(3976),
    [sym_preproc_define] = STATE(3976),
    [sym_preproc_undef] = STATE(3976),
    [anon_sym_SEMI] = ACTIONS(5604),
    [anon_sym_LBRACK] = ACTIONS(5604),
    [anon_sym_COLON] = ACTIONS(5604),
    [anon_sym_COMMA] = ACTIONS(5604),
    [anon_sym_RBRACK] = ACTIONS(5604),
    [anon_sym_LPAREN] = ACTIONS(5604),
    [anon_sym_RPAREN] = ACTIONS(5604),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_LT] = ACTIONS(5606),
    [anon_sym_GT] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_QMARK] = ACTIONS(5606),
    [anon_sym_BANG] = ACTIONS(5606),
    [anon_sym_PLUS_PLUS] = ACTIONS(5604),
    [anon_sym_DASH_DASH] = ACTIONS(5604),
    [anon_sym_PLUS] = ACTIONS(5606),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_SLASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5604),
    [anon_sym_CARET] = ACTIONS(5604),
    [anon_sym_PIPE] = ACTIONS(5606),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym_LT_LT] = ACTIONS(5604),
    [anon_sym_GT_GT] = ACTIONS(5606),
    [anon_sym_GT_GT_GT] = ACTIONS(5604),
    [anon_sym_EQ_EQ] = ACTIONS(5604),
    [anon_sym_BANG_EQ] = ACTIONS(5604),
    [anon_sym_GT_EQ] = ACTIONS(5604),
    [anon_sym_LT_EQ] = ACTIONS(5604),
    [anon_sym_DOT] = ACTIONS(5606),
    [anon_sym_EQ_GT] = ACTIONS(5604),
    [anon_sym_switch] = ACTIONS(5604),
    [anon_sym_when] = ACTIONS(5604),
    [anon_sym_DOT_DOT] = ACTIONS(5604),
    [anon_sym_and] = ACTIONS(5604),
    [anon_sym_or] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_PIPE_PIPE] = ACTIONS(5604),
    [anon_sym_QMARK_QMARK] = ACTIONS(5604),
    [anon_sym_into] = ACTIONS(5604),
    [anon_sym_on] = ACTIONS(5604),
    [anon_sym_equals] = ACTIONS(5604),
    [anon_sym_by] = ACTIONS(5604),
    [anon_sym_as] = ACTIONS(5604),
    [anon_sym_is] = ACTIONS(5604),
    [anon_sym_DASH_GT] = ACTIONS(5604),
    [anon_sym_with] = ACTIONS(5604),
    [aux_sym_preproc_if_token3] = ACTIONS(5604),
    [aux_sym_preproc_else_token1] = ACTIONS(5604),
    [aux_sym_preproc_elif_token1] = ACTIONS(5604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3977] = {
    [sym_preproc_region] = STATE(3977),
    [sym_preproc_endregion] = STATE(3977),
    [sym_preproc_line] = STATE(3977),
    [sym_preproc_pragma] = STATE(3977),
    [sym_preproc_nullable] = STATE(3977),
    [sym_preproc_error] = STATE(3977),
    [sym_preproc_define] = STATE(3977),
    [sym_preproc_undef] = STATE(3977),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_when] = ACTIONS(2991),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2991),
    [anon_sym_or] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_into] = ACTIONS(2991),
    [anon_sym_on] = ACTIONS(2991),
    [anon_sym_equals] = ACTIONS(2991),
    [anon_sym_by] = ACTIONS(2991),
    [anon_sym_as] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2991),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [aux_sym_preproc_if_token3] = ACTIONS(2991),
    [aux_sym_preproc_else_token1] = ACTIONS(2991),
    [aux_sym_preproc_elif_token1] = ACTIONS(2991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3978] = {
    [sym_preproc_region] = STATE(3978),
    [sym_preproc_endregion] = STATE(3978),
    [sym_preproc_line] = STATE(3978),
    [sym_preproc_pragma] = STATE(3978),
    [sym_preproc_nullable] = STATE(3978),
    [sym_preproc_error] = STATE(3978),
    [sym_preproc_define] = STATE(3978),
    [sym_preproc_undef] = STATE(3978),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_COMMA] = ACTIONS(5574),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_LPAREN] = ACTIONS(5574),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_LT] = ACTIONS(5576),
    [anon_sym_GT] = ACTIONS(5576),
    [anon_sym_in] = ACTIONS(5576),
    [anon_sym_QMARK] = ACTIONS(5576),
    [anon_sym_BANG] = ACTIONS(5576),
    [anon_sym_PLUS_PLUS] = ACTIONS(5574),
    [anon_sym_DASH_DASH] = ACTIONS(5574),
    [anon_sym_PLUS] = ACTIONS(5576),
    [anon_sym_DASH] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_SLASH] = ACTIONS(5576),
    [anon_sym_PERCENT] = ACTIONS(5574),
    [anon_sym_CARET] = ACTIONS(5574),
    [anon_sym_PIPE] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5576),
    [anon_sym_LT_LT] = ACTIONS(5574),
    [anon_sym_GT_GT] = ACTIONS(5576),
    [anon_sym_GT_GT_GT] = ACTIONS(5574),
    [anon_sym_EQ_EQ] = ACTIONS(5574),
    [anon_sym_BANG_EQ] = ACTIONS(5574),
    [anon_sym_GT_EQ] = ACTIONS(5574),
    [anon_sym_LT_EQ] = ACTIONS(5574),
    [anon_sym_DOT] = ACTIONS(5576),
    [anon_sym_EQ_GT] = ACTIONS(5574),
    [anon_sym_switch] = ACTIONS(5574),
    [anon_sym_when] = ACTIONS(5574),
    [anon_sym_DOT_DOT] = ACTIONS(5574),
    [anon_sym_and] = ACTIONS(5574),
    [anon_sym_or] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_PIPE_PIPE] = ACTIONS(5574),
    [anon_sym_QMARK_QMARK] = ACTIONS(5574),
    [anon_sym_into] = ACTIONS(5574),
    [anon_sym_on] = ACTIONS(5574),
    [anon_sym_equals] = ACTIONS(5574),
    [anon_sym_by] = ACTIONS(5574),
    [anon_sym_as] = ACTIONS(5574),
    [anon_sym_is] = ACTIONS(5574),
    [anon_sym_DASH_GT] = ACTIONS(5574),
    [anon_sym_with] = ACTIONS(5574),
    [aux_sym_preproc_if_token3] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5574),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3979] = {
    [sym_preproc_region] = STATE(3979),
    [sym_preproc_endregion] = STATE(3979),
    [sym_preproc_line] = STATE(3979),
    [sym_preproc_pragma] = STATE(3979),
    [sym_preproc_nullable] = STATE(3979),
    [sym_preproc_error] = STATE(3979),
    [sym_preproc_define] = STATE(3979),
    [sym_preproc_undef] = STATE(3979),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4763),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_in] = ACTIONS(4765),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_switch] = ACTIONS(4763),
    [anon_sym_when] = ACTIONS(4763),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4763),
    [anon_sym_or] = ACTIONS(4763),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_into] = ACTIONS(4763),
    [anon_sym_on] = ACTIONS(4763),
    [anon_sym_equals] = ACTIONS(4763),
    [anon_sym_by] = ACTIONS(4763),
    [anon_sym_as] = ACTIONS(4763),
    [anon_sym_is] = ACTIONS(4763),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4763),
    [aux_sym_preproc_if_token3] = ACTIONS(4763),
    [aux_sym_preproc_else_token1] = ACTIONS(4763),
    [aux_sym_preproc_elif_token1] = ACTIONS(4763),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3980] = {
    [sym_preproc_region] = STATE(3980),
    [sym_preproc_endregion] = STATE(3980),
    [sym_preproc_line] = STATE(3980),
    [sym_preproc_pragma] = STATE(3980),
    [sym_preproc_nullable] = STATE(3980),
    [sym_preproc_error] = STATE(3980),
    [sym_preproc_define] = STATE(3980),
    [sym_preproc_undef] = STATE(3980),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5642),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_BANG] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_GT_GT_GT] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_EQ_GT] = ACTIONS(5640),
    [anon_sym_switch] = ACTIONS(5640),
    [anon_sym_when] = ACTIONS(5640),
    [anon_sym_DOT_DOT] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_QMARK_QMARK] = ACTIONS(5640),
    [anon_sym_into] = ACTIONS(5640),
    [anon_sym_on] = ACTIONS(5640),
    [anon_sym_equals] = ACTIONS(5640),
    [anon_sym_by] = ACTIONS(5640),
    [anon_sym_as] = ACTIONS(5640),
    [anon_sym_is] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [anon_sym_with] = ACTIONS(5640),
    [aux_sym_preproc_if_token3] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3981] = {
    [sym_preproc_region] = STATE(3981),
    [sym_preproc_endregion] = STATE(3981),
    [sym_preproc_line] = STATE(3981),
    [sym_preproc_pragma] = STATE(3981),
    [sym_preproc_nullable] = STATE(3981),
    [sym_preproc_error] = STATE(3981),
    [sym_preproc_define] = STATE(3981),
    [sym_preproc_undef] = STATE(3981),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5678),
    [anon_sym_in] = ACTIONS(5678),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_GT_GT_GT] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_switch] = ACTIONS(5676),
    [anon_sym_when] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_or] = ACTIONS(5676),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_into] = ACTIONS(5676),
    [anon_sym_on] = ACTIONS(5676),
    [anon_sym_equals] = ACTIONS(5676),
    [anon_sym_by] = ACTIONS(5676),
    [anon_sym_as] = ACTIONS(5676),
    [anon_sym_is] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_with] = ACTIONS(5676),
    [aux_sym_preproc_if_token3] = ACTIONS(5676),
    [aux_sym_preproc_else_token1] = ACTIONS(5676),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3982] = {
    [sym_preproc_region] = STATE(3982),
    [sym_preproc_endregion] = STATE(3982),
    [sym_preproc_line] = STATE(3982),
    [sym_preproc_pragma] = STATE(3982),
    [sym_preproc_nullable] = STATE(3982),
    [sym_preproc_error] = STATE(3982),
    [sym_preproc_define] = STATE(3982),
    [sym_preproc_undef] = STATE(3982),
    [anon_sym_SEMI] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5672),
    [anon_sym_RPAREN] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5672),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_GT_GT_GT] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BANG_EQ] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5674),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_switch] = ACTIONS(5672),
    [anon_sym_when] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_or] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_into] = ACTIONS(5672),
    [anon_sym_on] = ACTIONS(5672),
    [anon_sym_equals] = ACTIONS(5672),
    [anon_sym_by] = ACTIONS(5672),
    [anon_sym_as] = ACTIONS(5672),
    [anon_sym_is] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_with] = ACTIONS(5672),
    [aux_sym_preproc_if_token3] = ACTIONS(5672),
    [aux_sym_preproc_else_token1] = ACTIONS(5672),
    [aux_sym_preproc_elif_token1] = ACTIONS(5672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3983] = {
    [sym_preproc_region] = STATE(3983),
    [sym_preproc_endregion] = STATE(3983),
    [sym_preproc_line] = STATE(3983),
    [sym_preproc_pragma] = STATE(3983),
    [sym_preproc_nullable] = STATE(3983),
    [sym_preproc_error] = STATE(3983),
    [sym_preproc_define] = STATE(3983),
    [sym_preproc_undef] = STATE(3983),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_in] = ACTIONS(5670),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_BANG] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_GT_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5668),
    [anon_sym_when] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_QMARK_QMARK] = ACTIONS(5668),
    [anon_sym_into] = ACTIONS(5668),
    [anon_sym_on] = ACTIONS(5668),
    [anon_sym_equals] = ACTIONS(5668),
    [anon_sym_by] = ACTIONS(5668),
    [anon_sym_as] = ACTIONS(5668),
    [anon_sym_is] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [anon_sym_with] = ACTIONS(5668),
    [aux_sym_preproc_if_token3] = ACTIONS(5668),
    [aux_sym_preproc_else_token1] = ACTIONS(5668),
    [aux_sym_preproc_elif_token1] = ACTIONS(5668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3984] = {
    [sym_preproc_region] = STATE(3984),
    [sym_preproc_endregion] = STATE(3984),
    [sym_preproc_line] = STATE(3984),
    [sym_preproc_pragma] = STATE(3984),
    [sym_preproc_nullable] = STATE(3984),
    [sym_preproc_error] = STATE(3984),
    [sym_preproc_define] = STATE(3984),
    [sym_preproc_undef] = STATE(3984),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5664),
    [anon_sym_COMMA] = ACTIONS(5664),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(5664),
    [anon_sym_RPAREN] = ACTIONS(5664),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_BANG] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_PIPE] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_GT_GT_GT] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5664),
    [anon_sym_BANG_EQ] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5664),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_DOT] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5664),
    [anon_sym_switch] = ACTIONS(5664),
    [anon_sym_when] = ACTIONS(5664),
    [anon_sym_DOT_DOT] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_or] = ACTIONS(5664),
    [anon_sym_AMP_AMP] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5664),
    [anon_sym_QMARK_QMARK] = ACTIONS(5664),
    [anon_sym_into] = ACTIONS(5664),
    [anon_sym_on] = ACTIONS(5664),
    [anon_sym_equals] = ACTIONS(5664),
    [anon_sym_by] = ACTIONS(5664),
    [anon_sym_as] = ACTIONS(5664),
    [anon_sym_is] = ACTIONS(5664),
    [anon_sym_DASH_GT] = ACTIONS(5664),
    [anon_sym_with] = ACTIONS(5664),
    [aux_sym_preproc_if_token3] = ACTIONS(5664),
    [aux_sym_preproc_else_token1] = ACTIONS(5664),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3985] = {
    [sym_preproc_region] = STATE(3985),
    [sym_preproc_endregion] = STATE(3985),
    [sym_preproc_line] = STATE(3985),
    [sym_preproc_pragma] = STATE(3985),
    [sym_preproc_nullable] = STATE(3985),
    [sym_preproc_error] = STATE(3985),
    [sym_preproc_define] = STATE(3985),
    [sym_preproc_undef] = STATE(3985),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(5364),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_COMMA] = ACTIONS(5364),
    [anon_sym_RBRACK] = ACTIONS(5364),
    [anon_sym_LPAREN] = ACTIONS(5364),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_LT] = ACTIONS(5366),
    [anon_sym_GT] = ACTIONS(5366),
    [anon_sym_in] = ACTIONS(5364),
    [anon_sym_QMARK] = ACTIONS(5366),
    [anon_sym_BANG] = ACTIONS(5366),
    [anon_sym_PLUS_PLUS] = ACTIONS(5364),
    [anon_sym_DASH_DASH] = ACTIONS(5364),
    [anon_sym_PLUS] = ACTIONS(5366),
    [anon_sym_DASH] = ACTIONS(5366),
    [anon_sym_STAR] = ACTIONS(5364),
    [anon_sym_SLASH] = ACTIONS(5366),
    [anon_sym_PERCENT] = ACTIONS(5364),
    [anon_sym_CARET] = ACTIONS(5364),
    [anon_sym_PIPE] = ACTIONS(5366),
    [anon_sym_AMP] = ACTIONS(5366),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5366),
    [anon_sym_GT_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5364),
    [anon_sym_BANG_EQ] = ACTIONS(5364),
    [anon_sym_GT_EQ] = ACTIONS(5364),
    [anon_sym_LT_EQ] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(5366),
    [anon_sym_EQ_GT] = ACTIONS(5364),
    [anon_sym_switch] = ACTIONS(5364),
    [anon_sym_when] = ACTIONS(5364),
    [anon_sym_DOT_DOT] = ACTIONS(5364),
    [anon_sym_and] = ACTIONS(5364),
    [anon_sym_or] = ACTIONS(5364),
    [anon_sym_AMP_AMP] = ACTIONS(5364),
    [anon_sym_PIPE_PIPE] = ACTIONS(5364),
    [anon_sym_QMARK_QMARK] = ACTIONS(5364),
    [anon_sym_on] = ACTIONS(5364),
    [anon_sym_equals] = ACTIONS(5364),
    [anon_sym_by] = ACTIONS(5364),
    [anon_sym_as] = ACTIONS(5364),
    [anon_sym_is] = ACTIONS(5364),
    [anon_sym_DASH_GT] = ACTIONS(5364),
    [anon_sym_with] = ACTIONS(5364),
    [aux_sym_raw_string_literal_token1] = ACTIONS(5842),
    [aux_sym_preproc_if_token3] = ACTIONS(5364),
    [aux_sym_preproc_else_token1] = ACTIONS(5364),
    [aux_sym_preproc_elif_token1] = ACTIONS(5364),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3986] = {
    [sym_preproc_region] = STATE(3986),
    [sym_preproc_endregion] = STATE(3986),
    [sym_preproc_line] = STATE(3986),
    [sym_preproc_pragma] = STATE(3986),
    [sym_preproc_nullable] = STATE(3986),
    [sym_preproc_error] = STATE(3986),
    [sym_preproc_define] = STATE(3986),
    [sym_preproc_undef] = STATE(3986),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_RBRACK] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LT] = ACTIONS(4534),
    [anon_sym_GT] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_BANG] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4534),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_CARET] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4534),
    [anon_sym_AMP] = ACTIONS(4534),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4534),
    [anon_sym_GT_GT_GT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4536),
    [anon_sym_BANG_EQ] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4536),
    [anon_sym_LT_EQ] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_EQ_GT] = ACTIONS(4536),
    [anon_sym_switch] = ACTIONS(4536),
    [anon_sym_when] = ACTIONS(4536),
    [anon_sym_DOT_DOT] = ACTIONS(4536),
    [anon_sym_and] = ACTIONS(4536),
    [anon_sym_or] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_QMARK_QMARK] = ACTIONS(4536),
    [anon_sym_on] = ACTIONS(4536),
    [anon_sym_equals] = ACTIONS(4536),
    [anon_sym_by] = ACTIONS(4536),
    [anon_sym_as] = ACTIONS(4536),
    [anon_sym_is] = ACTIONS(4536),
    [anon_sym_DASH_GT] = ACTIONS(4536),
    [anon_sym_with] = ACTIONS(4536),
    [aux_sym_preproc_if_token3] = ACTIONS(4536),
    [aux_sym_preproc_else_token1] = ACTIONS(4536),
    [aux_sym_preproc_elif_token1] = ACTIONS(4536),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3987] = {
    [sym_preproc_region] = STATE(3987),
    [sym_preproc_endregion] = STATE(3987),
    [sym_preproc_line] = STATE(3987),
    [sym_preproc_pragma] = STATE(3987),
    [sym_preproc_nullable] = STATE(3987),
    [sym_preproc_error] = STATE(3987),
    [sym_preproc_define] = STATE(3987),
    [sym_preproc_undef] = STATE(3987),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5384),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_into] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3988] = {
    [sym_preproc_region] = STATE(3988),
    [sym_preproc_endregion] = STATE(3988),
    [sym_preproc_line] = STATE(3988),
    [sym_preproc_pragma] = STATE(3988),
    [sym_preproc_nullable] = STATE(3988),
    [sym_preproc_error] = STATE(3988),
    [sym_preproc_define] = STATE(3988),
    [sym_preproc_undef] = STATE(3988),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_COMMA] = ACTIONS(5660),
    [anon_sym_RBRACK] = ACTIONS(5660),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5660),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5662),
    [anon_sym_in] = ACTIONS(5662),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_BANG] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5662),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5662),
    [anon_sym_GT_GT_GT] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5660),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_DOT] = ACTIONS(5662),
    [anon_sym_EQ_GT] = ACTIONS(5660),
    [anon_sym_switch] = ACTIONS(5660),
    [anon_sym_when] = ACTIONS(5660),
    [anon_sym_DOT_DOT] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_or] = ACTIONS(5660),
    [anon_sym_AMP_AMP] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5660),
    [anon_sym_QMARK_QMARK] = ACTIONS(5660),
    [anon_sym_into] = ACTIONS(5660),
    [anon_sym_on] = ACTIONS(5660),
    [anon_sym_equals] = ACTIONS(5660),
    [anon_sym_by] = ACTIONS(5660),
    [anon_sym_as] = ACTIONS(5660),
    [anon_sym_is] = ACTIONS(5660),
    [anon_sym_DASH_GT] = ACTIONS(5660),
    [anon_sym_with] = ACTIONS(5660),
    [aux_sym_preproc_if_token3] = ACTIONS(5660),
    [aux_sym_preproc_else_token1] = ACTIONS(5660),
    [aux_sym_preproc_elif_token1] = ACTIONS(5660),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3989] = {
    [sym_preproc_region] = STATE(3989),
    [sym_preproc_endregion] = STATE(3989),
    [sym_preproc_line] = STATE(3989),
    [sym_preproc_pragma] = STATE(3989),
    [sym_preproc_nullable] = STATE(3989),
    [sym_preproc_error] = STATE(3989),
    [sym_preproc_define] = STATE(3989),
    [sym_preproc_undef] = STATE(3989),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5584),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_into] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3990] = {
    [sym_preproc_region] = STATE(3990),
    [sym_preproc_endregion] = STATE(3990),
    [sym_preproc_line] = STATE(3990),
    [sym_preproc_pragma] = STATE(3990),
    [sym_preproc_nullable] = STATE(3990),
    [sym_preproc_error] = STATE(3990),
    [sym_preproc_define] = STATE(3990),
    [sym_preproc_undef] = STATE(3990),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_COMMA] = ACTIONS(4496),
    [anon_sym_RBRACK] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LT] = ACTIONS(4494),
    [anon_sym_GT] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4496),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4494),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4494),
    [anon_sym_AMP] = ACTIONS(4494),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4494),
    [anon_sym_GT_GT_GT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4496),
    [anon_sym_BANG_EQ] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4496),
    [anon_sym_LT_EQ] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4494),
    [anon_sym_EQ_GT] = ACTIONS(4496),
    [anon_sym_switch] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [anon_sym_DOT_DOT] = ACTIONS(4496),
    [anon_sym_and] = ACTIONS(4496),
    [anon_sym_or] = ACTIONS(4496),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_QMARK_QMARK] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_as] = ACTIONS(4496),
    [anon_sym_is] = ACTIONS(4496),
    [anon_sym_DASH_GT] = ACTIONS(4496),
    [anon_sym_with] = ACTIONS(4496),
    [aux_sym_preproc_if_token3] = ACTIONS(4496),
    [aux_sym_preproc_else_token1] = ACTIONS(4496),
    [aux_sym_preproc_elif_token1] = ACTIONS(4496),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3991] = {
    [sym_preproc_region] = STATE(3991),
    [sym_preproc_endregion] = STATE(3991),
    [sym_preproc_line] = STATE(3991),
    [sym_preproc_pragma] = STATE(3991),
    [sym_preproc_nullable] = STATE(3991),
    [sym_preproc_error] = STATE(3991),
    [sym_preproc_define] = STATE(3991),
    [sym_preproc_undef] = STATE(3991),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_when] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_into] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3992] = {
    [sym_preproc_region] = STATE(3992),
    [sym_preproc_endregion] = STATE(3992),
    [sym_preproc_line] = STATE(3992),
    [sym_preproc_pragma] = STATE(3992),
    [sym_preproc_nullable] = STATE(3992),
    [sym_preproc_error] = STATE(3992),
    [sym_preproc_define] = STATE(3992),
    [sym_preproc_undef] = STATE(3992),
    [anon_sym_EQ] = ACTIONS(5844),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5846),
    [anon_sym_DASH_EQ] = ACTIONS(5846),
    [anon_sym_STAR_EQ] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_PERCENT_EQ] = ACTIONS(5846),
    [anon_sym_AMP_EQ] = ACTIONS(5846),
    [anon_sym_CARET_EQ] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_LT_LT_EQ] = ACTIONS(5846),
    [anon_sym_GT_GT_EQ] = ACTIONS(5846),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5846),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5846),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5294),
  },
  [3993] = {
    [sym_preproc_region] = STATE(3993),
    [sym_preproc_endregion] = STATE(3993),
    [sym_preproc_line] = STATE(3993),
    [sym_preproc_pragma] = STATE(3993),
    [sym_preproc_nullable] = STATE(3993),
    [sym_preproc_error] = STATE(3993),
    [sym_preproc_define] = STATE(3993),
    [sym_preproc_undef] = STATE(3993),
    [anon_sym_SEMI] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_COLON] = ACTIONS(5570),
    [anon_sym_COMMA] = ACTIONS(5570),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_LPAREN] = ACTIONS(5570),
    [anon_sym_RPAREN] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(5572),
    [anon_sym_GT] = ACTIONS(5572),
    [anon_sym_in] = ACTIONS(5572),
    [anon_sym_QMARK] = ACTIONS(5572),
    [anon_sym_BANG] = ACTIONS(5572),
    [anon_sym_PLUS_PLUS] = ACTIONS(5570),
    [anon_sym_DASH_DASH] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_SLASH] = ACTIONS(5572),
    [anon_sym_PERCENT] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PIPE] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym_LT_LT] = ACTIONS(5570),
    [anon_sym_GT_GT] = ACTIONS(5572),
    [anon_sym_GT_GT_GT] = ACTIONS(5570),
    [anon_sym_EQ_EQ] = ACTIONS(5570),
    [anon_sym_BANG_EQ] = ACTIONS(5570),
    [anon_sym_GT_EQ] = ACTIONS(5570),
    [anon_sym_LT_EQ] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(5572),
    [anon_sym_EQ_GT] = ACTIONS(5570),
    [anon_sym_switch] = ACTIONS(5570),
    [anon_sym_when] = ACTIONS(5570),
    [anon_sym_DOT_DOT] = ACTIONS(5570),
    [anon_sym_and] = ACTIONS(5570),
    [anon_sym_or] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE] = ACTIONS(5570),
    [anon_sym_QMARK_QMARK] = ACTIONS(5570),
    [anon_sym_into] = ACTIONS(5570),
    [anon_sym_on] = ACTIONS(5570),
    [anon_sym_equals] = ACTIONS(5570),
    [anon_sym_by] = ACTIONS(5570),
    [anon_sym_as] = ACTIONS(5570),
    [anon_sym_is] = ACTIONS(5570),
    [anon_sym_DASH_GT] = ACTIONS(5570),
    [anon_sym_with] = ACTIONS(5570),
    [aux_sym_preproc_if_token3] = ACTIONS(5570),
    [aux_sym_preproc_else_token1] = ACTIONS(5570),
    [aux_sym_preproc_elif_token1] = ACTIONS(5570),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3994] = {
    [sym_preproc_region] = STATE(3994),
    [sym_preproc_endregion] = STATE(3994),
    [sym_preproc_line] = STATE(3994),
    [sym_preproc_pragma] = STATE(3994),
    [sym_preproc_nullable] = STATE(3994),
    [sym_preproc_error] = STATE(3994),
    [sym_preproc_define] = STATE(3994),
    [sym_preproc_undef] = STATE(3994),
    [anon_sym_SEMI] = ACTIONS(4431),
    [anon_sym_LBRACK] = ACTIONS(4431),
    [anon_sym_COLON] = ACTIONS(4431),
    [anon_sym_COMMA] = ACTIONS(4431),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LPAREN] = ACTIONS(4431),
    [anon_sym_RPAREN] = ACTIONS(4431),
    [anon_sym_LBRACE] = ACTIONS(4431),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(4429),
    [anon_sym_in] = ACTIONS(4431),
    [anon_sym_QMARK] = ACTIONS(4429),
    [anon_sym_BANG] = ACTIONS(4429),
    [anon_sym_PLUS_PLUS] = ACTIONS(4431),
    [anon_sym_DASH_DASH] = ACTIONS(4431),
    [anon_sym_PLUS] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_STAR] = ACTIONS(4431),
    [anon_sym_SLASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4431),
    [anon_sym_CARET] = ACTIONS(4431),
    [anon_sym_PIPE] = ACTIONS(4429),
    [anon_sym_AMP] = ACTIONS(4429),
    [anon_sym_LT_LT] = ACTIONS(4431),
    [anon_sym_GT_GT] = ACTIONS(4429),
    [anon_sym_GT_GT_GT] = ACTIONS(4431),
    [anon_sym_EQ_EQ] = ACTIONS(4431),
    [anon_sym_BANG_EQ] = ACTIONS(4431),
    [anon_sym_GT_EQ] = ACTIONS(4431),
    [anon_sym_LT_EQ] = ACTIONS(4431),
    [anon_sym_DOT] = ACTIONS(4429),
    [anon_sym_EQ_GT] = ACTIONS(4431),
    [anon_sym_switch] = ACTIONS(4431),
    [anon_sym_when] = ACTIONS(4431),
    [anon_sym_DOT_DOT] = ACTIONS(4431),
    [anon_sym_and] = ACTIONS(4431),
    [anon_sym_or] = ACTIONS(4431),
    [anon_sym_AMP_AMP] = ACTIONS(4431),
    [anon_sym_PIPE_PIPE] = ACTIONS(4431),
    [anon_sym_QMARK_QMARK] = ACTIONS(4431),
    [anon_sym_on] = ACTIONS(4431),
    [anon_sym_equals] = ACTIONS(4431),
    [anon_sym_by] = ACTIONS(4431),
    [anon_sym_as] = ACTIONS(4431),
    [anon_sym_is] = ACTIONS(4431),
    [anon_sym_DASH_GT] = ACTIONS(4431),
    [anon_sym_with] = ACTIONS(4431),
    [aux_sym_preproc_if_token3] = ACTIONS(4431),
    [aux_sym_preproc_else_token1] = ACTIONS(4431),
    [aux_sym_preproc_elif_token1] = ACTIONS(4431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3995] = {
    [sym_preproc_region] = STATE(3995),
    [sym_preproc_endregion] = STATE(3995),
    [sym_preproc_line] = STATE(3995),
    [sym_preproc_pragma] = STATE(3995),
    [sym_preproc_nullable] = STATE(3995),
    [sym_preproc_error] = STATE(3995),
    [sym_preproc_define] = STATE(3995),
    [sym_preproc_undef] = STATE(3995),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_COLON] = ACTIONS(5848),
    [anon_sym_COMMA] = ACTIONS(5848),
    [anon_sym_RBRACK] = ACTIONS(5848),
    [anon_sym_LPAREN] = ACTIONS(5848),
    [anon_sym_RPAREN] = ACTIONS(5848),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_LT] = ACTIONS(5850),
    [anon_sym_GT] = ACTIONS(5850),
    [anon_sym_in] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_BANG] = ACTIONS(5850),
    [anon_sym_PLUS_PLUS] = ACTIONS(5848),
    [anon_sym_DASH_DASH] = ACTIONS(5848),
    [anon_sym_PLUS] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_STAR] = ACTIONS(5848),
    [anon_sym_SLASH] = ACTIONS(5850),
    [anon_sym_PERCENT] = ACTIONS(5848),
    [anon_sym_CARET] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(5850),
    [anon_sym_AMP] = ACTIONS(5850),
    [anon_sym_LT_LT] = ACTIONS(5848),
    [anon_sym_GT_GT] = ACTIONS(5850),
    [anon_sym_GT_GT_GT] = ACTIONS(5848),
    [anon_sym_EQ_EQ] = ACTIONS(5848),
    [anon_sym_BANG_EQ] = ACTIONS(5848),
    [anon_sym_GT_EQ] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5848),
    [anon_sym_switch] = ACTIONS(5848),
    [anon_sym_when] = ACTIONS(5848),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_and] = ACTIONS(5848),
    [anon_sym_or] = ACTIONS(5848),
    [anon_sym_AMP_AMP] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5848),
    [anon_sym_QMARK_QMARK] = ACTIONS(5848),
    [anon_sym_into] = ACTIONS(5848),
    [anon_sym_on] = ACTIONS(5848),
    [anon_sym_equals] = ACTIONS(5848),
    [anon_sym_by] = ACTIONS(5848),
    [anon_sym_as] = ACTIONS(5848),
    [anon_sym_is] = ACTIONS(5848),
    [anon_sym_DASH_GT] = ACTIONS(5848),
    [anon_sym_with] = ACTIONS(5848),
    [aux_sym_preproc_if_token3] = ACTIONS(5848),
    [aux_sym_preproc_else_token1] = ACTIONS(5848),
    [aux_sym_preproc_elif_token1] = ACTIONS(5848),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3996] = {
    [sym_preproc_region] = STATE(3996),
    [sym_preproc_endregion] = STATE(3996),
    [sym_preproc_line] = STATE(3996),
    [sym_preproc_pragma] = STATE(3996),
    [sym_preproc_nullable] = STATE(3996),
    [sym_preproc_error] = STATE(3996),
    [sym_preproc_define] = STATE(3996),
    [sym_preproc_undef] = STATE(3996),
    [anon_sym_EQ] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5854),
    [anon_sym_DASH_EQ] = ACTIONS(5854),
    [anon_sym_STAR_EQ] = ACTIONS(5854),
    [anon_sym_SLASH_EQ] = ACTIONS(5854),
    [anon_sym_PERCENT_EQ] = ACTIONS(5854),
    [anon_sym_AMP_EQ] = ACTIONS(5854),
    [anon_sym_CARET_EQ] = ACTIONS(5854),
    [anon_sym_PIPE_EQ] = ACTIONS(5854),
    [anon_sym_LT_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT_GT_EQ] = ACTIONS(5854),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5854),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3997] = {
    [sym_preproc_region] = STATE(3997),
    [sym_preproc_endregion] = STATE(3997),
    [sym_preproc_line] = STATE(3997),
    [sym_preproc_pragma] = STATE(3997),
    [sym_preproc_nullable] = STATE(3997),
    [sym_preproc_error] = STATE(3997),
    [sym_preproc_define] = STATE(3997),
    [sym_preproc_undef] = STATE(3997),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5858),
    [anon_sym_BANG] = ACTIONS(5858),
    [anon_sym_PLUS_PLUS] = ACTIONS(5856),
    [anon_sym_DASH_DASH] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_STAR] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_GT_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_switch] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_into] = ACTIONS(5856),
    [anon_sym_on] = ACTIONS(5856),
    [anon_sym_equals] = ACTIONS(5856),
    [anon_sym_by] = ACTIONS(5856),
    [anon_sym_as] = ACTIONS(5856),
    [anon_sym_is] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [anon_sym_with] = ACTIONS(5856),
    [aux_sym_preproc_if_token3] = ACTIONS(5856),
    [aux_sym_preproc_else_token1] = ACTIONS(5856),
    [aux_sym_preproc_elif_token1] = ACTIONS(5856),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3998] = {
    [sym_preproc_region] = STATE(3998),
    [sym_preproc_endregion] = STATE(3998),
    [sym_preproc_line] = STATE(3998),
    [sym_preproc_pragma] = STATE(3998),
    [sym_preproc_nullable] = STATE(3998),
    [sym_preproc_error] = STATE(3998),
    [sym_preproc_define] = STATE(3998),
    [sym_preproc_undef] = STATE(3998),
    [anon_sym_SEMI] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COMMA] = ACTIONS(5652),
    [anon_sym_RBRACK] = ACTIONS(5652),
    [anon_sym_LPAREN] = ACTIONS(5652),
    [anon_sym_RPAREN] = ACTIONS(5652),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_BANG] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5652),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_GT_GT_GT] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5652),
    [anon_sym_BANG_EQ] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5652),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_EQ_GT] = ACTIONS(5652),
    [anon_sym_switch] = ACTIONS(5652),
    [anon_sym_when] = ACTIONS(5652),
    [anon_sym_DOT_DOT] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_or] = ACTIONS(5652),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5652),
    [anon_sym_QMARK_QMARK] = ACTIONS(5652),
    [anon_sym_into] = ACTIONS(5652),
    [anon_sym_on] = ACTIONS(5652),
    [anon_sym_equals] = ACTIONS(5652),
    [anon_sym_by] = ACTIONS(5652),
    [anon_sym_as] = ACTIONS(5652),
    [anon_sym_is] = ACTIONS(5652),
    [anon_sym_DASH_GT] = ACTIONS(5652),
    [anon_sym_with] = ACTIONS(5652),
    [aux_sym_preproc_if_token3] = ACTIONS(5652),
    [aux_sym_preproc_else_token1] = ACTIONS(5652),
    [aux_sym_preproc_elif_token1] = ACTIONS(5652),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [3999] = {
    [sym_preproc_region] = STATE(3999),
    [sym_preproc_endregion] = STATE(3999),
    [sym_preproc_line] = STATE(3999),
    [sym_preproc_pragma] = STATE(3999),
    [sym_preproc_nullable] = STATE(3999),
    [sym_preproc_error] = STATE(3999),
    [sym_preproc_define] = STATE(3999),
    [sym_preproc_undef] = STATE(3999),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5862),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_PLUS_PLUS] = ACTIONS(5860),
    [anon_sym_DASH_DASH] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_GT_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5860),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_switch] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_into] = ACTIONS(5860),
    [anon_sym_on] = ACTIONS(5860),
    [anon_sym_equals] = ACTIONS(5860),
    [anon_sym_by] = ACTIONS(5860),
    [anon_sym_as] = ACTIONS(5860),
    [anon_sym_is] = ACTIONS(5860),
    [anon_sym_DASH_GT] = ACTIONS(5860),
    [anon_sym_with] = ACTIONS(5860),
    [aux_sym_preproc_if_token3] = ACTIONS(5860),
    [aux_sym_preproc_else_token1] = ACTIONS(5860),
    [aux_sym_preproc_elif_token1] = ACTIONS(5860),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4000] = {
    [sym_preproc_region] = STATE(4000),
    [sym_preproc_endregion] = STATE(4000),
    [sym_preproc_line] = STATE(4000),
    [sym_preproc_pragma] = STATE(4000),
    [sym_preproc_nullable] = STATE(4000),
    [sym_preproc_error] = STATE(4000),
    [sym_preproc_define] = STATE(4000),
    [sym_preproc_undef] = STATE(4000),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RBRACK] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5540),
    [anon_sym_GT] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5540),
    [anon_sym_QMARK] = ACTIONS(5540),
    [anon_sym_BANG] = ACTIONS(5540),
    [anon_sym_PLUS_PLUS] = ACTIONS(5538),
    [anon_sym_DASH_DASH] = ACTIONS(5538),
    [anon_sym_PLUS] = ACTIONS(5540),
    [anon_sym_DASH] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_SLASH] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_CARET] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_GT_GT_GT] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_BANG_EQ] = ACTIONS(5538),
    [anon_sym_GT_EQ] = ACTIONS(5538),
    [anon_sym_LT_EQ] = ACTIONS(5538),
    [anon_sym_DOT] = ACTIONS(5540),
    [anon_sym_EQ_GT] = ACTIONS(5538),
    [anon_sym_switch] = ACTIONS(5538),
    [anon_sym_when] = ACTIONS(5538),
    [anon_sym_DOT_DOT] = ACTIONS(5538),
    [anon_sym_and] = ACTIONS(5538),
    [anon_sym_or] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_QMARK_QMARK] = ACTIONS(5538),
    [anon_sym_into] = ACTIONS(5538),
    [anon_sym_on] = ACTIONS(5538),
    [anon_sym_equals] = ACTIONS(5538),
    [anon_sym_by] = ACTIONS(5538),
    [anon_sym_as] = ACTIONS(5538),
    [anon_sym_is] = ACTIONS(5538),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [anon_sym_with] = ACTIONS(5538),
    [aux_sym_preproc_if_token3] = ACTIONS(5538),
    [aux_sym_preproc_else_token1] = ACTIONS(5538),
    [aux_sym_preproc_elif_token1] = ACTIONS(5538),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4001] = {
    [sym_preproc_region] = STATE(4001),
    [sym_preproc_endregion] = STATE(4001),
    [sym_preproc_line] = STATE(4001),
    [sym_preproc_pragma] = STATE(4001),
    [sym_preproc_nullable] = STATE(4001),
    [sym_preproc_error] = STATE(4001),
    [sym_preproc_define] = STATE(4001),
    [sym_preproc_undef] = STATE(4001),
    [anon_sym_SEMI] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_COLON] = ACTIONS(5864),
    [anon_sym_COMMA] = ACTIONS(5864),
    [anon_sym_RBRACK] = ACTIONS(5864),
    [anon_sym_LPAREN] = ACTIONS(5864),
    [anon_sym_RPAREN] = ACTIONS(5864),
    [anon_sym_RBRACE] = ACTIONS(5864),
    [anon_sym_LT] = ACTIONS(5866),
    [anon_sym_GT] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_QMARK] = ACTIONS(5866),
    [anon_sym_BANG] = ACTIONS(5866),
    [anon_sym_PLUS_PLUS] = ACTIONS(5864),
    [anon_sym_DASH_DASH] = ACTIONS(5864),
    [anon_sym_PLUS] = ACTIONS(5866),
    [anon_sym_DASH] = ACTIONS(5866),
    [anon_sym_STAR] = ACTIONS(5864),
    [anon_sym_SLASH] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5864),
    [anon_sym_CARET] = ACTIONS(5864),
    [anon_sym_PIPE] = ACTIONS(5866),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5864),
    [anon_sym_GT_GT] = ACTIONS(5866),
    [anon_sym_GT_GT_GT] = ACTIONS(5864),
    [anon_sym_EQ_EQ] = ACTIONS(5864),
    [anon_sym_BANG_EQ] = ACTIONS(5864),
    [anon_sym_GT_EQ] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5866),
    [anon_sym_EQ_GT] = ACTIONS(5864),
    [anon_sym_switch] = ACTIONS(5864),
    [anon_sym_when] = ACTIONS(5864),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_and] = ACTIONS(5864),
    [anon_sym_or] = ACTIONS(5864),
    [anon_sym_AMP_AMP] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5864),
    [anon_sym_QMARK_QMARK] = ACTIONS(5864),
    [anon_sym_into] = ACTIONS(5864),
    [anon_sym_on] = ACTIONS(5864),
    [anon_sym_equals] = ACTIONS(5864),
    [anon_sym_by] = ACTIONS(5864),
    [anon_sym_as] = ACTIONS(5864),
    [anon_sym_is] = ACTIONS(5864),
    [anon_sym_DASH_GT] = ACTIONS(5864),
    [anon_sym_with] = ACTIONS(5864),
    [aux_sym_preproc_if_token3] = ACTIONS(5864),
    [aux_sym_preproc_else_token1] = ACTIONS(5864),
    [aux_sym_preproc_elif_token1] = ACTIONS(5864),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4002] = {
    [sym_modifier] = STATE(4531),
    [sym_identifier] = STATE(7847),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(4002),
    [sym_preproc_endregion] = STATE(4002),
    [sym_preproc_line] = STATE(4002),
    [sym_preproc_pragma] = STATE(4002),
    [sym_preproc_nullable] = STATE(4002),
    [sym_preproc_error] = STATE(4002),
    [sym_preproc_define] = STATE(4002),
    [sym_preproc_undef] = STATE(4002),
    [aux_sym_class_declaration_repeat2] = STATE(4348),
    [sym__identifier_token] = ACTIONS(23),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym_alias] = ACTIONS(27),
    [anon_sym_global] = ACTIONS(27),
    [anon_sym_unsafe] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_abstract] = ACTIONS(5490),
    [anon_sym_async] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_file] = ACTIONS(5496),
    [anon_sym_fixed] = ACTIONS(5490),
    [anon_sym_internal] = ACTIONS(5490),
    [anon_sym_new] = ACTIONS(5490),
    [anon_sym_override] = ACTIONS(5490),
    [anon_sym_partial] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_readonly] = ACTIONS(5490),
    [anon_sym_required] = ACTIONS(5490),
    [anon_sym_sealed] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_where] = ACTIONS(27),
    [anon_sym_notnull] = ACTIONS(27),
    [anon_sym_unmanaged] = ACTIONS(27),
    [anon_sym_get] = ACTIONS(5868),
    [anon_sym_set] = ACTIONS(5868),
    [anon_sym_add] = ACTIONS(5868),
    [anon_sym_remove] = ACTIONS(5868),
    [anon_sym_init] = ACTIONS(5868),
    [anon_sym_scoped] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_yield] = ACTIONS(27),
    [anon_sym_when] = ACTIONS(27),
    [anon_sym_from] = ACTIONS(27),
    [anon_sym_into] = ACTIONS(27),
    [anon_sym_join] = ACTIONS(27),
    [anon_sym_on] = ACTIONS(27),
    [anon_sym_equals] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(27),
    [anon_sym_orderby] = ACTIONS(27),
    [anon_sym_ascending] = ACTIONS(27),
    [anon_sym_descending] = ACTIONS(27),
    [anon_sym_group] = ACTIONS(27),
    [anon_sym_by] = ACTIONS(27),
    [anon_sym_select] = ACTIONS(27),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4003] = {
    [sym_preproc_region] = STATE(4003),
    [sym_preproc_endregion] = STATE(4003),
    [sym_preproc_line] = STATE(4003),
    [sym_preproc_pragma] = STATE(4003),
    [sym_preproc_nullable] = STATE(4003),
    [sym_preproc_error] = STATE(4003),
    [sym_preproc_define] = STATE(4003),
    [sym_preproc_undef] = STATE(4003),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5870),
    [anon_sym_COLON] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5870),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5872),
    [anon_sym_QMARK] = ACTIONS(5872),
    [anon_sym_BANG] = ACTIONS(5872),
    [anon_sym_PLUS_PLUS] = ACTIONS(5870),
    [anon_sym_DASH_DASH] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5870),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5870),
    [anon_sym_CARET] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_GT_GT_GT] = ACTIONS(5870),
    [anon_sym_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BANG_EQ] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_LT_EQ] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_switch] = ACTIONS(5870),
    [anon_sym_when] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5870),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [anon_sym_AMP_AMP] = ACTIONS(5870),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_into] = ACTIONS(5870),
    [anon_sym_on] = ACTIONS(5870),
    [anon_sym_equals] = ACTIONS(5870),
    [anon_sym_by] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5870),
    [anon_sym_is] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_with] = ACTIONS(5870),
    [aux_sym_preproc_if_token3] = ACTIONS(5870),
    [aux_sym_preproc_else_token1] = ACTIONS(5870),
    [aux_sym_preproc_elif_token1] = ACTIONS(5870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4004] = {
    [sym_preproc_region] = STATE(4004),
    [sym_preproc_endregion] = STATE(4004),
    [sym_preproc_line] = STATE(4004),
    [sym_preproc_pragma] = STATE(4004),
    [sym_preproc_nullable] = STATE(4004),
    [sym_preproc_error] = STATE(4004),
    [sym_preproc_define] = STATE(4004),
    [sym_preproc_undef] = STATE(4004),
    [anon_sym_SEMI] = ACTIONS(4457),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_COLON] = ACTIONS(4457),
    [anon_sym_COMMA] = ACTIONS(4457),
    [anon_sym_RBRACK] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4457),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [anon_sym_LBRACE] = ACTIONS(4457),
    [anon_sym_RBRACE] = ACTIONS(4457),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_in] = ACTIONS(4457),
    [anon_sym_QMARK] = ACTIONS(4455),
    [anon_sym_BANG] = ACTIONS(4455),
    [anon_sym_PLUS_PLUS] = ACTIONS(4457),
    [anon_sym_DASH_DASH] = ACTIONS(4457),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4457),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4457),
    [anon_sym_CARET] = ACTIONS(4457),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4457),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_GT_GT_GT] = ACTIONS(4457),
    [anon_sym_EQ_EQ] = ACTIONS(4457),
    [anon_sym_BANG_EQ] = ACTIONS(4457),
    [anon_sym_GT_EQ] = ACTIONS(4457),
    [anon_sym_LT_EQ] = ACTIONS(4457),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_EQ_GT] = ACTIONS(4457),
    [anon_sym_switch] = ACTIONS(4457),
    [anon_sym_when] = ACTIONS(4457),
    [anon_sym_DOT_DOT] = ACTIONS(4457),
    [anon_sym_and] = ACTIONS(4457),
    [anon_sym_or] = ACTIONS(4457),
    [anon_sym_AMP_AMP] = ACTIONS(4457),
    [anon_sym_PIPE_PIPE] = ACTIONS(4457),
    [anon_sym_QMARK_QMARK] = ACTIONS(4457),
    [anon_sym_on] = ACTIONS(4457),
    [anon_sym_equals] = ACTIONS(4457),
    [anon_sym_by] = ACTIONS(4457),
    [anon_sym_as] = ACTIONS(4457),
    [anon_sym_is] = ACTIONS(4457),
    [anon_sym_DASH_GT] = ACTIONS(4457),
    [anon_sym_with] = ACTIONS(4457),
    [aux_sym_preproc_if_token3] = ACTIONS(4457),
    [aux_sym_preproc_else_token1] = ACTIONS(4457),
    [aux_sym_preproc_elif_token1] = ACTIONS(4457),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4005] = {
    [sym_preproc_region] = STATE(4005),
    [sym_preproc_endregion] = STATE(4005),
    [sym_preproc_line] = STATE(4005),
    [sym_preproc_pragma] = STATE(4005),
    [sym_preproc_nullable] = STATE(4005),
    [sym_preproc_error] = STATE(4005),
    [sym_preproc_define] = STATE(4005),
    [sym_preproc_undef] = STATE(4005),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5876),
    [anon_sym_DASH_EQ] = ACTIONS(5876),
    [anon_sym_STAR_EQ] = ACTIONS(5876),
    [anon_sym_SLASH_EQ] = ACTIONS(5876),
    [anon_sym_PERCENT_EQ] = ACTIONS(5876),
    [anon_sym_AMP_EQ] = ACTIONS(5876),
    [anon_sym_CARET_EQ] = ACTIONS(5876),
    [anon_sym_PIPE_EQ] = ACTIONS(5876),
    [anon_sym_LT_LT_EQ] = ACTIONS(5876),
    [anon_sym_GT_GT_EQ] = ACTIONS(5876),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5876),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5876),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4006] = {
    [sym_preproc_region] = STATE(4006),
    [sym_preproc_endregion] = STATE(4006),
    [sym_preproc_line] = STATE(4006),
    [sym_preproc_pragma] = STATE(4006),
    [sym_preproc_nullable] = STATE(4006),
    [sym_preproc_error] = STATE(4006),
    [sym_preproc_define] = STATE(4006),
    [sym_preproc_undef] = STATE(4006),
    [anon_sym_SEMI] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(4610),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_COMMA] = ACTIONS(4610),
    [anon_sym_RBRACK] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4610),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_LBRACE] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4610),
    [anon_sym_LT] = ACTIONS(4608),
    [anon_sym_GT] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(4610),
    [anon_sym_QMARK] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_PLUS_PLUS] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4610),
    [anon_sym_SLASH] = ACTIONS(4608),
    [anon_sym_PERCENT] = ACTIONS(4610),
    [anon_sym_CARET] = ACTIONS(4610),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_LT_LT] = ACTIONS(4610),
    [anon_sym_GT_GT] = ACTIONS(4608),
    [anon_sym_GT_GT_GT] = ACTIONS(4610),
    [anon_sym_EQ_EQ] = ACTIONS(4610),
    [anon_sym_BANG_EQ] = ACTIONS(4610),
    [anon_sym_GT_EQ] = ACTIONS(4610),
    [anon_sym_LT_EQ] = ACTIONS(4610),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_EQ_GT] = ACTIONS(4610),
    [anon_sym_switch] = ACTIONS(4610),
    [anon_sym_when] = ACTIONS(4610),
    [anon_sym_DOT_DOT] = ACTIONS(4610),
    [anon_sym_and] = ACTIONS(4610),
    [anon_sym_or] = ACTIONS(4610),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_QMARK_QMARK] = ACTIONS(4610),
    [anon_sym_on] = ACTIONS(4610),
    [anon_sym_equals] = ACTIONS(4610),
    [anon_sym_by] = ACTIONS(4610),
    [anon_sym_as] = ACTIONS(4610),
    [anon_sym_is] = ACTIONS(4610),
    [anon_sym_DASH_GT] = ACTIONS(4610),
    [anon_sym_with] = ACTIONS(4610),
    [aux_sym_preproc_if_token3] = ACTIONS(4610),
    [aux_sym_preproc_else_token1] = ACTIONS(4610),
    [aux_sym_preproc_elif_token1] = ACTIONS(4610),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4007] = {
    [sym_preproc_region] = STATE(4007),
    [sym_preproc_endregion] = STATE(4007),
    [sym_preproc_line] = STATE(4007),
    [sym_preproc_pragma] = STATE(4007),
    [sym_preproc_nullable] = STATE(4007),
    [sym_preproc_error] = STATE(4007),
    [sym_preproc_define] = STATE(4007),
    [sym_preproc_undef] = STATE(4007),
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_COLON] = ACTIONS(4490),
    [anon_sym_COMMA] = ACTIONS(4490),
    [anon_sym_RBRACK] = ACTIONS(4490),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_RPAREN] = ACTIONS(4490),
    [anon_sym_LBRACE] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_LT] = ACTIONS(4488),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_in] = ACTIONS(4490),
    [anon_sym_QMARK] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_PLUS_PLUS] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4490),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4490),
    [anon_sym_SLASH] = ACTIONS(4488),
    [anon_sym_PERCENT] = ACTIONS(4490),
    [anon_sym_CARET] = ACTIONS(4490),
    [anon_sym_PIPE] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_LT_LT] = ACTIONS(4490),
    [anon_sym_GT_GT] = ACTIONS(4488),
    [anon_sym_GT_GT_GT] = ACTIONS(4490),
    [anon_sym_EQ_EQ] = ACTIONS(4490),
    [anon_sym_BANG_EQ] = ACTIONS(4490),
    [anon_sym_GT_EQ] = ACTIONS(4490),
    [anon_sym_LT_EQ] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_EQ_GT] = ACTIONS(4490),
    [anon_sym_switch] = ACTIONS(4490),
    [anon_sym_when] = ACTIONS(4490),
    [anon_sym_DOT_DOT] = ACTIONS(4490),
    [anon_sym_and] = ACTIONS(4490),
    [anon_sym_or] = ACTIONS(4490),
    [anon_sym_AMP_AMP] = ACTIONS(4490),
    [anon_sym_PIPE_PIPE] = ACTIONS(4490),
    [anon_sym_QMARK_QMARK] = ACTIONS(4490),
    [anon_sym_on] = ACTIONS(4490),
    [anon_sym_equals] = ACTIONS(4490),
    [anon_sym_by] = ACTIONS(4490),
    [anon_sym_as] = ACTIONS(4490),
    [anon_sym_is] = ACTIONS(4490),
    [anon_sym_DASH_GT] = ACTIONS(4490),
    [anon_sym_with] = ACTIONS(4490),
    [aux_sym_preproc_if_token3] = ACTIONS(4490),
    [aux_sym_preproc_else_token1] = ACTIONS(4490),
    [aux_sym_preproc_elif_token1] = ACTIONS(4490),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4008] = {
    [sym_preproc_region] = STATE(4008),
    [sym_preproc_endregion] = STATE(4008),
    [sym_preproc_line] = STATE(4008),
    [sym_preproc_pragma] = STATE(4008),
    [sym_preproc_nullable] = STATE(4008),
    [sym_preproc_error] = STATE(4008),
    [sym_preproc_define] = STATE(4008),
    [sym_preproc_undef] = STATE(4008),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5878),
    [anon_sym_RPAREN] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5880),
    [anon_sym_in] = ACTIONS(5880),
    [anon_sym_QMARK] = ACTIONS(5880),
    [anon_sym_BANG] = ACTIONS(5880),
    [anon_sym_PLUS_PLUS] = ACTIONS(5878),
    [anon_sym_DASH_DASH] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_CARET] = ACTIONS(5878),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5878),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_GT_GT_GT] = ACTIONS(5878),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(5878),
    [anon_sym_GT_EQ] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5878),
    [anon_sym_switch] = ACTIONS(5878),
    [anon_sym_when] = ACTIONS(5878),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5878),
    [anon_sym_QMARK_QMARK] = ACTIONS(5878),
    [anon_sym_into] = ACTIONS(5878),
    [anon_sym_on] = ACTIONS(5878),
    [anon_sym_equals] = ACTIONS(5878),
    [anon_sym_by] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5878),
    [anon_sym_is] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(5878),
    [anon_sym_with] = ACTIONS(5878),
    [aux_sym_preproc_if_token3] = ACTIONS(5878),
    [aux_sym_preproc_else_token1] = ACTIONS(5878),
    [aux_sym_preproc_elif_token1] = ACTIONS(5878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4009] = {
    [sym_preproc_region] = STATE(4009),
    [sym_preproc_endregion] = STATE(4009),
    [sym_preproc_line] = STATE(4009),
    [sym_preproc_pragma] = STATE(4009),
    [sym_preproc_nullable] = STATE(4009),
    [sym_preproc_error] = STATE(4009),
    [sym_preproc_define] = STATE(4009),
    [sym_preproc_undef] = STATE(4009),
    [anon_sym_SEMI] = ACTIONS(4486),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_COLON] = ACTIONS(4486),
    [anon_sym_COMMA] = ACTIONS(4486),
    [anon_sym_RBRACK] = ACTIONS(4486),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_RPAREN] = ACTIONS(4486),
    [anon_sym_LBRACE] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_LT] = ACTIONS(4484),
    [anon_sym_GT] = ACTIONS(4484),
    [anon_sym_in] = ACTIONS(4486),
    [anon_sym_QMARK] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_PLUS_PLUS] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4486),
    [anon_sym_PLUS] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_SLASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4486),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_PIPE] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_LT_LT] = ACTIONS(4486),
    [anon_sym_GT_GT] = ACTIONS(4484),
    [anon_sym_GT_GT_GT] = ACTIONS(4486),
    [anon_sym_EQ_EQ] = ACTIONS(4486),
    [anon_sym_BANG_EQ] = ACTIONS(4486),
    [anon_sym_GT_EQ] = ACTIONS(4486),
    [anon_sym_LT_EQ] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_EQ_GT] = ACTIONS(4486),
    [anon_sym_switch] = ACTIONS(4486),
    [anon_sym_when] = ACTIONS(4486),
    [anon_sym_DOT_DOT] = ACTIONS(4486),
    [anon_sym_and] = ACTIONS(4486),
    [anon_sym_or] = ACTIONS(4486),
    [anon_sym_AMP_AMP] = ACTIONS(4486),
    [anon_sym_PIPE_PIPE] = ACTIONS(4486),
    [anon_sym_QMARK_QMARK] = ACTIONS(4486),
    [anon_sym_on] = ACTIONS(4486),
    [anon_sym_equals] = ACTIONS(4486),
    [anon_sym_by] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(4486),
    [anon_sym_is] = ACTIONS(4486),
    [anon_sym_DASH_GT] = ACTIONS(4486),
    [anon_sym_with] = ACTIONS(4486),
    [aux_sym_preproc_if_token3] = ACTIONS(4486),
    [aux_sym_preproc_else_token1] = ACTIONS(4486),
    [aux_sym_preproc_elif_token1] = ACTIONS(4486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4010] = {
    [sym_preproc_region] = STATE(4010),
    [sym_preproc_endregion] = STATE(4010),
    [sym_preproc_line] = STATE(4010),
    [sym_preproc_pragma] = STATE(4010),
    [sym_preproc_nullable] = STATE(4010),
    [sym_preproc_error] = STATE(4010),
    [sym_preproc_define] = STATE(4010),
    [sym_preproc_undef] = STATE(4010),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4482),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_when] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4482),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4011] = {
    [sym_preproc_region] = STATE(4011),
    [sym_preproc_endregion] = STATE(4011),
    [sym_preproc_line] = STATE(4011),
    [sym_preproc_pragma] = STATE(4011),
    [sym_preproc_nullable] = STATE(4011),
    [sym_preproc_error] = STATE(4011),
    [sym_preproc_define] = STATE(4011),
    [sym_preproc_undef] = STATE(4011),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_LPAREN] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_BANG] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5650),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5650),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5650),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5650),
    [anon_sym_GT_GT_GT] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5650),
    [anon_sym_EQ_GT] = ACTIONS(5648),
    [anon_sym_switch] = ACTIONS(5648),
    [anon_sym_when] = ACTIONS(5648),
    [anon_sym_DOT_DOT] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_QMARK_QMARK] = ACTIONS(5648),
    [anon_sym_into] = ACTIONS(5648),
    [anon_sym_on] = ACTIONS(5648),
    [anon_sym_equals] = ACTIONS(5648),
    [anon_sym_by] = ACTIONS(5648),
    [anon_sym_as] = ACTIONS(5648),
    [anon_sym_is] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [anon_sym_with] = ACTIONS(5648),
    [aux_sym_preproc_if_token3] = ACTIONS(5648),
    [aux_sym_preproc_else_token1] = ACTIONS(5648),
    [aux_sym_preproc_elif_token1] = ACTIONS(5648),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4012] = {
    [sym_preproc_region] = STATE(4012),
    [sym_preproc_endregion] = STATE(4012),
    [sym_preproc_line] = STATE(4012),
    [sym_preproc_pragma] = STATE(4012),
    [sym_preproc_nullable] = STATE(4012),
    [sym_preproc_error] = STATE(4012),
    [sym_preproc_define] = STATE(4012),
    [sym_preproc_undef] = STATE(4012),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5882),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4013] = {
    [sym_preproc_region] = STATE(4013),
    [sym_preproc_endregion] = STATE(4013),
    [sym_preproc_line] = STATE(4013),
    [sym_preproc_pragma] = STATE(4013),
    [sym_preproc_nullable] = STATE(4013),
    [sym_preproc_error] = STATE(4013),
    [sym_preproc_define] = STATE(4013),
    [sym_preproc_undef] = STATE(4013),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4014] = {
    [sym_preproc_region] = STATE(4014),
    [sym_preproc_endregion] = STATE(4014),
    [sym_preproc_line] = STATE(4014),
    [sym_preproc_pragma] = STATE(4014),
    [sym_preproc_nullable] = STATE(4014),
    [sym_preproc_error] = STATE(4014),
    [sym_preproc_define] = STATE(4014),
    [sym_preproc_undef] = STATE(4014),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(5882),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4015] = {
    [sym_preproc_region] = STATE(4015),
    [sym_preproc_endregion] = STATE(4015),
    [sym_preproc_line] = STATE(4015),
    [sym_preproc_pragma] = STATE(4015),
    [sym_preproc_nullable] = STATE(4015),
    [sym_preproc_error] = STATE(4015),
    [sym_preproc_define] = STATE(4015),
    [sym_preproc_undef] = STATE(4015),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4451),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4016] = {
    [sym_preproc_region] = STATE(4016),
    [sym_preproc_endregion] = STATE(4016),
    [sym_preproc_line] = STATE(4016),
    [sym_preproc_pragma] = STATE(4016),
    [sym_preproc_nullable] = STATE(4016),
    [sym_preproc_error] = STATE(4016),
    [sym_preproc_define] = STATE(4016),
    [sym_preproc_undef] = STATE(4016),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_LPAREN] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LT] = ACTIONS(5658),
    [anon_sym_GT] = ACTIONS(5658),
    [anon_sym_in] = ACTIONS(5658),
    [anon_sym_QMARK] = ACTIONS(5658),
    [anon_sym_BANG] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5658),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5658),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5656),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_GT_GT_GT] = ACTIONS(5656),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5658),
    [anon_sym_EQ_GT] = ACTIONS(5656),
    [anon_sym_switch] = ACTIONS(5656),
    [anon_sym_when] = ACTIONS(5656),
    [anon_sym_DOT_DOT] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_QMARK_QMARK] = ACTIONS(5656),
    [anon_sym_into] = ACTIONS(5656),
    [anon_sym_on] = ACTIONS(5656),
    [anon_sym_equals] = ACTIONS(5656),
    [anon_sym_by] = ACTIONS(5656),
    [anon_sym_as] = ACTIONS(5656),
    [anon_sym_is] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [anon_sym_with] = ACTIONS(5656),
    [aux_sym_preproc_if_token3] = ACTIONS(5656),
    [aux_sym_preproc_else_token1] = ACTIONS(5656),
    [aux_sym_preproc_elif_token1] = ACTIONS(5656),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4017] = {
    [sym_preproc_region] = STATE(4017),
    [sym_preproc_endregion] = STATE(4017),
    [sym_preproc_line] = STATE(4017),
    [sym_preproc_pragma] = STATE(4017),
    [sym_preproc_nullable] = STATE(4017),
    [sym_preproc_error] = STATE(4017),
    [sym_preproc_define] = STATE(4017),
    [sym_preproc_undef] = STATE(4017),
    [anon_sym_SEMI] = ACTIONS(5885),
    [anon_sym_LBRACK] = ACTIONS(5885),
    [anon_sym_COLON] = ACTIONS(5885),
    [anon_sym_COMMA] = ACTIONS(5885),
    [anon_sym_RBRACK] = ACTIONS(5885),
    [anon_sym_LPAREN] = ACTIONS(5885),
    [anon_sym_RPAREN] = ACTIONS(5885),
    [anon_sym_RBRACE] = ACTIONS(5885),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_in] = ACTIONS(5887),
    [anon_sym_QMARK] = ACTIONS(5887),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS_PLUS] = ACTIONS(5885),
    [anon_sym_DASH_DASH] = ACTIONS(5885),
    [anon_sym_PLUS] = ACTIONS(5887),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_STAR] = ACTIONS(5885),
    [anon_sym_SLASH] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5885),
    [anon_sym_CARET] = ACTIONS(5885),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_LT_LT] = ACTIONS(5885),
    [anon_sym_GT_GT] = ACTIONS(5887),
    [anon_sym_GT_GT_GT] = ACTIONS(5885),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5885),
    [anon_sym_GT_EQ] = ACTIONS(5885),
    [anon_sym_LT_EQ] = ACTIONS(5885),
    [anon_sym_DOT] = ACTIONS(5887),
    [anon_sym_EQ_GT] = ACTIONS(5885),
    [anon_sym_switch] = ACTIONS(5885),
    [anon_sym_when] = ACTIONS(5885),
    [anon_sym_DOT_DOT] = ACTIONS(5885),
    [anon_sym_and] = ACTIONS(5885),
    [anon_sym_or] = ACTIONS(5885),
    [anon_sym_AMP_AMP] = ACTIONS(5885),
    [anon_sym_PIPE_PIPE] = ACTIONS(5885),
    [anon_sym_QMARK_QMARK] = ACTIONS(5885),
    [anon_sym_into] = ACTIONS(5885),
    [anon_sym_on] = ACTIONS(5885),
    [anon_sym_equals] = ACTIONS(5885),
    [anon_sym_by] = ACTIONS(5885),
    [anon_sym_as] = ACTIONS(5885),
    [anon_sym_is] = ACTIONS(5885),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [anon_sym_with] = ACTIONS(5885),
    [aux_sym_preproc_if_token3] = ACTIONS(5885),
    [aux_sym_preproc_else_token1] = ACTIONS(5885),
    [aux_sym_preproc_elif_token1] = ACTIONS(5885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4018] = {
    [sym_preproc_region] = STATE(4018),
    [sym_preproc_endregion] = STATE(4018),
    [sym_preproc_line] = STATE(4018),
    [sym_preproc_pragma] = STATE(4018),
    [sym_preproc_nullable] = STATE(4018),
    [sym_preproc_error] = STATE(4018),
    [sym_preproc_define] = STATE(4018),
    [sym_preproc_undef] = STATE(4018),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_LPAREN] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5891),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5891),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_SLASH] = ACTIONS(5891),
    [anon_sym_PERCENT] = ACTIONS(5889),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_GT_GT_GT] = ACTIONS(5889),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5891),
    [anon_sym_EQ_GT] = ACTIONS(5889),
    [anon_sym_switch] = ACTIONS(5889),
    [anon_sym_when] = ACTIONS(5889),
    [anon_sym_DOT_DOT] = ACTIONS(5889),
    [anon_sym_and] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_QMARK_QMARK] = ACTIONS(5889),
    [anon_sym_into] = ACTIONS(5889),
    [anon_sym_on] = ACTIONS(5889),
    [anon_sym_equals] = ACTIONS(5889),
    [anon_sym_by] = ACTIONS(5889),
    [anon_sym_as] = ACTIONS(5889),
    [anon_sym_is] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [anon_sym_with] = ACTIONS(5889),
    [aux_sym_preproc_if_token3] = ACTIONS(5889),
    [aux_sym_preproc_else_token1] = ACTIONS(5889),
    [aux_sym_preproc_elif_token1] = ACTIONS(5889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4019] = {
    [sym_preproc_region] = STATE(4019),
    [sym_preproc_endregion] = STATE(4019),
    [sym_preproc_line] = STATE(4019),
    [sym_preproc_pragma] = STATE(4019),
    [sym_preproc_nullable] = STATE(4019),
    [sym_preproc_error] = STATE(4019),
    [sym_preproc_define] = STATE(4019),
    [sym_preproc_undef] = STATE(4019),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_LPAREN] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5891),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5891),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_SLASH] = ACTIONS(5891),
    [anon_sym_PERCENT] = ACTIONS(5889),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_GT_GT_GT] = ACTIONS(5889),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5891),
    [anon_sym_EQ_GT] = ACTIONS(5889),
    [anon_sym_switch] = ACTIONS(5889),
    [anon_sym_when] = ACTIONS(5889),
    [anon_sym_DOT_DOT] = ACTIONS(5889),
    [anon_sym_and] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_QMARK_QMARK] = ACTIONS(5889),
    [anon_sym_into] = ACTIONS(5889),
    [anon_sym_on] = ACTIONS(5889),
    [anon_sym_equals] = ACTIONS(5889),
    [anon_sym_by] = ACTIONS(5889),
    [anon_sym_as] = ACTIONS(5889),
    [anon_sym_is] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [anon_sym_with] = ACTIONS(5889),
    [aux_sym_preproc_if_token3] = ACTIONS(5889),
    [aux_sym_preproc_else_token1] = ACTIONS(5889),
    [aux_sym_preproc_elif_token1] = ACTIONS(5889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4020] = {
    [sym_preproc_region] = STATE(4020),
    [sym_preproc_endregion] = STATE(4020),
    [sym_preproc_line] = STATE(4020),
    [sym_preproc_pragma] = STATE(4020),
    [sym_preproc_nullable] = STATE(4020),
    [sym_preproc_error] = STATE(4020),
    [sym_preproc_define] = STATE(4020),
    [sym_preproc_undef] = STATE(4020),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_in] = ACTIONS(4807),
    [anon_sym_QMARK] = ACTIONS(5896),
    [anon_sym_BANG] = ACTIONS(5896),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(5893),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(5893),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_QMARK_QMARK] = ACTIONS(5893),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_is] = ACTIONS(5893),
    [anon_sym_DASH_GT] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(5893),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4021] = {
    [sym_preproc_region] = STATE(4021),
    [sym_preproc_endregion] = STATE(4021),
    [sym_preproc_line] = STATE(4021),
    [sym_preproc_pragma] = STATE(4021),
    [sym_preproc_nullable] = STATE(4021),
    [sym_preproc_error] = STATE(4021),
    [sym_preproc_define] = STATE(4021),
    [sym_preproc_undef] = STATE(4021),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(5899),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_in] = ACTIONS(4807),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_BANG] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5899),
    [anon_sym_DASH_DASH] = ACTIONS(5899),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5899),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5899),
    [anon_sym_CARET] = ACTIONS(5899),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_GT] = ACTIONS(5899),
    [anon_sym_EQ_EQ] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5899),
    [anon_sym_GT_EQ] = ACTIONS(5899),
    [anon_sym_LT_EQ] = ACTIONS(5899),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(5899),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(5899),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_AMP_AMP] = ACTIONS(5899),
    [anon_sym_PIPE_PIPE] = ACTIONS(5899),
    [anon_sym_QMARK_QMARK] = ACTIONS(5899),
    [anon_sym_into] = ACTIONS(4799),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(5899),
    [anon_sym_is] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5899),
    [anon_sym_with] = ACTIONS(5899),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4022] = {
    [sym_preproc_region] = STATE(4022),
    [sym_preproc_endregion] = STATE(4022),
    [sym_preproc_line] = STATE(4022),
    [sym_preproc_pragma] = STATE(4022),
    [sym_preproc_nullable] = STATE(4022),
    [sym_preproc_error] = STATE(4022),
    [sym_preproc_define] = STATE(4022),
    [sym_preproc_undef] = STATE(4022),
    [anon_sym_SEMI] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(4157),
    [anon_sym_LPAREN] = ACTIONS(4157),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4157),
    [anon_sym_LT] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4157),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4155),
    [anon_sym_PLUS_PLUS] = ACTIONS(4157),
    [anon_sym_DASH_DASH] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4157),
    [anon_sym_PIPE] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4157),
    [anon_sym_GT_GT] = ACTIONS(4155),
    [anon_sym_GT_GT_GT] = ACTIONS(4157),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_GT_EQ] = ACTIONS(4157),
    [anon_sym_LT_EQ] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_EQ_GT] = ACTIONS(4157),
    [anon_sym_switch] = ACTIONS(4157),
    [anon_sym_when] = ACTIONS(4157),
    [anon_sym_DOT_DOT] = ACTIONS(4157),
    [anon_sym_and] = ACTIONS(4157),
    [anon_sym_or] = ACTIONS(4157),
    [anon_sym_AMP_AMP] = ACTIONS(4157),
    [anon_sym_PIPE_PIPE] = ACTIONS(4157),
    [anon_sym_QMARK_QMARK] = ACTIONS(4157),
    [anon_sym_on] = ACTIONS(4157),
    [anon_sym_equals] = ACTIONS(4157),
    [anon_sym_by] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4157),
    [anon_sym_is] = ACTIONS(4157),
    [anon_sym_DASH_GT] = ACTIONS(4157),
    [anon_sym_with] = ACTIONS(4157),
    [aux_sym_preproc_if_token3] = ACTIONS(4157),
    [aux_sym_preproc_else_token1] = ACTIONS(4157),
    [aux_sym_preproc_elif_token1] = ACTIONS(4157),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4023] = {
    [sym_preproc_region] = STATE(4023),
    [sym_preproc_endregion] = STATE(4023),
    [sym_preproc_line] = STATE(4023),
    [sym_preproc_pragma] = STATE(4023),
    [sym_preproc_nullable] = STATE(4023),
    [sym_preproc_error] = STATE(4023),
    [sym_preproc_define] = STATE(4023),
    [sym_preproc_undef] = STATE(4023),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_COLON] = ACTIONS(1965),
    [anon_sym_COMMA] = ACTIONS(1965),
    [anon_sym_RBRACK] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(5905),
    [anon_sym_RPAREN] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(1965),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(1963),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_EQ_GT] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_when] = ACTIONS(1965),
    [anon_sym_DOT_DOT] = ACTIONS(1965),
    [anon_sym_and] = ACTIONS(1965),
    [anon_sym_or] = ACTIONS(1965),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_into] = ACTIONS(1965),
    [anon_sym_on] = ACTIONS(1965),
    [anon_sym_equals] = ACTIONS(1965),
    [anon_sym_by] = ACTIONS(1965),
    [anon_sym_as] = ACTIONS(1965),
    [anon_sym_is] = ACTIONS(1965),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_with] = ACTIONS(1965),
    [aux_sym_preproc_if_token3] = ACTIONS(1965),
    [aux_sym_preproc_else_token1] = ACTIONS(1965),
    [aux_sym_preproc_elif_token1] = ACTIONS(1965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4024] = {
    [sym_preproc_region] = STATE(4024),
    [sym_preproc_endregion] = STATE(4024),
    [sym_preproc_line] = STATE(4024),
    [sym_preproc_pragma] = STATE(4024),
    [sym_preproc_nullable] = STATE(4024),
    [sym_preproc_error] = STATE(4024),
    [sym_preproc_define] = STATE(4024),
    [sym_preproc_undef] = STATE(4024),
    [anon_sym_SEMI] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_RBRACK] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5427),
    [anon_sym_RPAREN] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5429),
    [anon_sym_GT] = ACTIONS(5429),
    [anon_sym_in] = ACTIONS(5429),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_PLUS_PLUS] = ACTIONS(5427),
    [anon_sym_DASH_DASH] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_SLASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_CARET] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_GT_GT] = ACTIONS(5429),
    [anon_sym_GT_GT_GT] = ACTIONS(5427),
    [anon_sym_EQ_EQ] = ACTIONS(5427),
    [anon_sym_BANG_EQ] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_LT_EQ] = ACTIONS(5427),
    [anon_sym_DOT] = ACTIONS(5429),
    [anon_sym_EQ_GT] = ACTIONS(5427),
    [anon_sym_switch] = ACTIONS(5427),
    [anon_sym_when] = ACTIONS(5427),
    [anon_sym_DOT_DOT] = ACTIONS(5427),
    [anon_sym_and] = ACTIONS(5427),
    [anon_sym_or] = ACTIONS(5427),
    [anon_sym_AMP_AMP] = ACTIONS(5427),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_QMARK_QMARK] = ACTIONS(5427),
    [anon_sym_into] = ACTIONS(5427),
    [anon_sym_on] = ACTIONS(5427),
    [anon_sym_equals] = ACTIONS(5427),
    [anon_sym_by] = ACTIONS(5427),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_is] = ACTIONS(5427),
    [anon_sym_DASH_GT] = ACTIONS(5427),
    [anon_sym_with] = ACTIONS(5427),
    [aux_sym_preproc_if_token3] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4025] = {
    [sym_preproc_region] = STATE(4025),
    [sym_preproc_endregion] = STATE(4025),
    [sym_preproc_line] = STATE(4025),
    [sym_preproc_pragma] = STATE(4025),
    [sym_preproc_nullable] = STATE(4025),
    [sym_preproc_error] = STATE(4025),
    [sym_preproc_define] = STATE(4025),
    [sym_preproc_undef] = STATE(4025),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_LPAREN] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5646),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_GT_GT_GT] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_EQ_GT] = ACTIONS(5644),
    [anon_sym_switch] = ACTIONS(5644),
    [anon_sym_when] = ACTIONS(5644),
    [anon_sym_DOT_DOT] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_QMARK_QMARK] = ACTIONS(5644),
    [anon_sym_into] = ACTIONS(5644),
    [anon_sym_on] = ACTIONS(5644),
    [anon_sym_equals] = ACTIONS(5644),
    [anon_sym_by] = ACTIONS(5644),
    [anon_sym_as] = ACTIONS(5644),
    [anon_sym_is] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [anon_sym_with] = ACTIONS(5644),
    [aux_sym_preproc_if_token3] = ACTIONS(5644),
    [aux_sym_preproc_else_token1] = ACTIONS(5644),
    [aux_sym_preproc_elif_token1] = ACTIONS(5644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4026] = {
    [sym_preproc_region] = STATE(4026),
    [sym_preproc_endregion] = STATE(4026),
    [sym_preproc_line] = STATE(4026),
    [sym_preproc_pragma] = STATE(4026),
    [sym_preproc_nullable] = STATE(4026),
    [sym_preproc_error] = STATE(4026),
    [sym_preproc_define] = STATE(4026),
    [sym_preproc_undef] = STATE(4026),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5626),
    [anon_sym_QMARK] = ACTIONS(5626),
    [anon_sym_BANG] = ACTIONS(5626),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_CARET] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5624),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_GT_GT_GT] = ACTIONS(5624),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5624),
    [anon_sym_switch] = ACTIONS(5624),
    [anon_sym_when] = ACTIONS(5624),
    [anon_sym_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_QMARK_QMARK] = ACTIONS(5624),
    [anon_sym_into] = ACTIONS(5624),
    [anon_sym_on] = ACTIONS(5624),
    [anon_sym_equals] = ACTIONS(5624),
    [anon_sym_by] = ACTIONS(5624),
    [anon_sym_as] = ACTIONS(5624),
    [anon_sym_is] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [anon_sym_with] = ACTIONS(5624),
    [aux_sym_preproc_if_token3] = ACTIONS(5624),
    [aux_sym_preproc_else_token1] = ACTIONS(5624),
    [aux_sym_preproc_elif_token1] = ACTIONS(5624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4027] = {
    [sym_preproc_region] = STATE(4027),
    [sym_preproc_endregion] = STATE(4027),
    [sym_preproc_line] = STATE(4027),
    [sym_preproc_pragma] = STATE(4027),
    [sym_preproc_nullable] = STATE(4027),
    [sym_preproc_error] = STATE(4027),
    [sym_preproc_define] = STATE(4027),
    [sym_preproc_undef] = STATE(4027),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5508),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4028] = {
    [sym_preproc_region] = STATE(4028),
    [sym_preproc_endregion] = STATE(4028),
    [sym_preproc_line] = STATE(4028),
    [sym_preproc_pragma] = STATE(4028),
    [sym_preproc_nullable] = STATE(4028),
    [sym_preproc_error] = STATE(4028),
    [sym_preproc_define] = STATE(4028),
    [sym_preproc_undef] = STATE(4028),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_into] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4029] = {
    [sym_preproc_region] = STATE(4029),
    [sym_preproc_endregion] = STATE(4029),
    [sym_preproc_line] = STATE(4029),
    [sym_preproc_pragma] = STATE(4029),
    [sym_preproc_nullable] = STATE(4029),
    [sym_preproc_error] = STATE(4029),
    [sym_preproc_define] = STATE(4029),
    [sym_preproc_undef] = STATE(4029),
    [anon_sym_SEMI] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4128),
    [anon_sym_COLON] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4128),
    [anon_sym_CARET] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4128),
    [anon_sym_GT_GT] = ACTIONS(4126),
    [anon_sym_GT_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4128),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_EQ_GT] = ACTIONS(4128),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_when] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(4128),
    [anon_sym_or] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4128),
    [anon_sym_PIPE_PIPE] = ACTIONS(4128),
    [anon_sym_QMARK_QMARK] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_as] = ACTIONS(4128),
    [anon_sym_is] = ACTIONS(4128),
    [anon_sym_DASH_GT] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [aux_sym_preproc_if_token3] = ACTIONS(4128),
    [aux_sym_preproc_else_token1] = ACTIONS(4128),
    [aux_sym_preproc_elif_token1] = ACTIONS(4128),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4030] = {
    [sym_preproc_region] = STATE(4030),
    [sym_preproc_endregion] = STATE(4030),
    [sym_preproc_line] = STATE(4030),
    [sym_preproc_pragma] = STATE(4030),
    [sym_preproc_nullable] = STATE(4030),
    [sym_preproc_error] = STATE(4030),
    [sym_preproc_define] = STATE(4030),
    [sym_preproc_undef] = STATE(4030),
    [anon_sym_SEMI] = ACTIONS(5612),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COMMA] = ACTIONS(5612),
    [anon_sym_RBRACK] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(5612),
    [anon_sym_RPAREN] = ACTIONS(5612),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5614),
    [anon_sym_GT] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5614),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_BANG] = ACTIONS(5614),
    [anon_sym_PLUS_PLUS] = ACTIONS(5612),
    [anon_sym_DASH_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5614),
    [anon_sym_DASH] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_PIPE] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5614),
    [anon_sym_GT_GT_GT] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5612),
    [anon_sym_BANG_EQ] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5612),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(5614),
    [anon_sym_EQ_GT] = ACTIONS(5612),
    [anon_sym_switch] = ACTIONS(5612),
    [anon_sym_when] = ACTIONS(5612),
    [anon_sym_DOT_DOT] = ACTIONS(5612),
    [anon_sym_and] = ACTIONS(5612),
    [anon_sym_or] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5612),
    [anon_sym_QMARK_QMARK] = ACTIONS(5612),
    [anon_sym_into] = ACTIONS(5612),
    [anon_sym_on] = ACTIONS(5612),
    [anon_sym_equals] = ACTIONS(5612),
    [anon_sym_by] = ACTIONS(5612),
    [anon_sym_as] = ACTIONS(5612),
    [anon_sym_is] = ACTIONS(5612),
    [anon_sym_DASH_GT] = ACTIONS(5612),
    [anon_sym_with] = ACTIONS(5612),
    [aux_sym_preproc_if_token3] = ACTIONS(5612),
    [aux_sym_preproc_else_token1] = ACTIONS(5612),
    [aux_sym_preproc_elif_token1] = ACTIONS(5612),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4031] = {
    [sym_preproc_region] = STATE(4031),
    [sym_preproc_endregion] = STATE(4031),
    [sym_preproc_line] = STATE(4031),
    [sym_preproc_pragma] = STATE(4031),
    [sym_preproc_nullable] = STATE(4031),
    [sym_preproc_error] = STATE(4031),
    [sym_preproc_define] = STATE(4031),
    [sym_preproc_undef] = STATE(4031),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5446),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_into] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4032] = {
    [sym_preproc_region] = STATE(4032),
    [sym_preproc_endregion] = STATE(4032),
    [sym_preproc_line] = STATE(4032),
    [sym_preproc_pragma] = STATE(4032),
    [sym_preproc_nullable] = STATE(4032),
    [sym_preproc_error] = STATE(4032),
    [sym_preproc_define] = STATE(4032),
    [sym_preproc_undef] = STATE(4032),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5442),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_when] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_into] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4033] = {
    [sym_preproc_region] = STATE(4033),
    [sym_preproc_endregion] = STATE(4033),
    [sym_preproc_line] = STATE(4033),
    [sym_preproc_pragma] = STATE(4033),
    [sym_preproc_nullable] = STATE(4033),
    [sym_preproc_error] = STATE(4033),
    [sym_preproc_define] = STATE(4033),
    [sym_preproc_undef] = STATE(4033),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COMMA] = ACTIONS(5534),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5536),
    [anon_sym_GT] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_QMARK] = ACTIONS(5536),
    [anon_sym_BANG] = ACTIONS(5536),
    [anon_sym_PLUS_PLUS] = ACTIONS(5534),
    [anon_sym_DASH_DASH] = ACTIONS(5534),
    [anon_sym_PLUS] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_SLASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_CARET] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_GT_GT_GT] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_BANG_EQ] = ACTIONS(5534),
    [anon_sym_GT_EQ] = ACTIONS(5534),
    [anon_sym_LT_EQ] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(5536),
    [anon_sym_EQ_GT] = ACTIONS(5534),
    [anon_sym_switch] = ACTIONS(5534),
    [anon_sym_when] = ACTIONS(5534),
    [anon_sym_DOT_DOT] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5534),
    [anon_sym_or] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK] = ACTIONS(5534),
    [anon_sym_into] = ACTIONS(5534),
    [anon_sym_on] = ACTIONS(5534),
    [anon_sym_equals] = ACTIONS(5534),
    [anon_sym_by] = ACTIONS(5534),
    [anon_sym_as] = ACTIONS(5534),
    [anon_sym_is] = ACTIONS(5534),
    [anon_sym_DASH_GT] = ACTIONS(5534),
    [anon_sym_with] = ACTIONS(5534),
    [aux_sym_preproc_if_token3] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4034] = {
    [sym_preproc_region] = STATE(4034),
    [sym_preproc_endregion] = STATE(4034),
    [sym_preproc_line] = STATE(4034),
    [sym_preproc_pragma] = STATE(4034),
    [sym_preproc_nullable] = STATE(4034),
    [sym_preproc_error] = STATE(4034),
    [sym_preproc_define] = STATE(4034),
    [sym_preproc_undef] = STATE(4034),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5622),
    [anon_sym_QMARK] = ACTIONS(5622),
    [anon_sym_BANG] = ACTIONS(5622),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_GT_GT] = ACTIONS(5622),
    [anon_sym_GT_GT_GT] = ACTIONS(5620),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_EQ_GT] = ACTIONS(5620),
    [anon_sym_switch] = ACTIONS(5620),
    [anon_sym_when] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5620),
    [anon_sym_and] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_QMARK_QMARK] = ACTIONS(5620),
    [anon_sym_into] = ACTIONS(5620),
    [anon_sym_on] = ACTIONS(5620),
    [anon_sym_equals] = ACTIONS(5620),
    [anon_sym_by] = ACTIONS(5620),
    [anon_sym_as] = ACTIONS(5620),
    [anon_sym_is] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [anon_sym_with] = ACTIONS(5620),
    [aux_sym_preproc_if_token3] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4035] = {
    [sym_preproc_region] = STATE(4035),
    [sym_preproc_endregion] = STATE(4035),
    [sym_preproc_line] = STATE(4035),
    [sym_preproc_pragma] = STATE(4035),
    [sym_preproc_nullable] = STATE(4035),
    [sym_preproc_error] = STATE(4035),
    [sym_preproc_define] = STATE(4035),
    [sym_preproc_undef] = STATE(4035),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5520),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_when] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5518),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_into] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4036] = {
    [sym_preproc_region] = STATE(4036),
    [sym_preproc_endregion] = STATE(4036),
    [sym_preproc_line] = STATE(4036),
    [sym_preproc_pragma] = STATE(4036),
    [sym_preproc_nullable] = STATE(4036),
    [sym_preproc_error] = STATE(4036),
    [sym_preproc_define] = STATE(4036),
    [sym_preproc_undef] = STATE(4036),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4132),
    [anon_sym_COLON] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_RBRACK] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4132),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_LBRACE] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_LT] = ACTIONS(4130),
    [anon_sym_GT] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(4132),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_BANG] = ACTIONS(4130),
    [anon_sym_PLUS_PLUS] = ACTIONS(4132),
    [anon_sym_DASH_DASH] = ACTIONS(4132),
    [anon_sym_PLUS] = ACTIONS(4130),
    [anon_sym_DASH] = ACTIONS(4130),
    [anon_sym_STAR] = ACTIONS(4132),
    [anon_sym_SLASH] = ACTIONS(4130),
    [anon_sym_PERCENT] = ACTIONS(4132),
    [anon_sym_CARET] = ACTIONS(4132),
    [anon_sym_PIPE] = ACTIONS(4130),
    [anon_sym_AMP] = ACTIONS(4130),
    [anon_sym_LT_LT] = ACTIONS(4132),
    [anon_sym_GT_GT] = ACTIONS(4130),
    [anon_sym_GT_GT_GT] = ACTIONS(4132),
    [anon_sym_EQ_EQ] = ACTIONS(4132),
    [anon_sym_BANG_EQ] = ACTIONS(4132),
    [anon_sym_GT_EQ] = ACTIONS(4132),
    [anon_sym_LT_EQ] = ACTIONS(4132),
    [anon_sym_DOT] = ACTIONS(4130),
    [anon_sym_EQ_GT] = ACTIONS(4132),
    [anon_sym_switch] = ACTIONS(4132),
    [anon_sym_when] = ACTIONS(4132),
    [anon_sym_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4132),
    [anon_sym_or] = ACTIONS(4132),
    [anon_sym_AMP_AMP] = ACTIONS(4132),
    [anon_sym_PIPE_PIPE] = ACTIONS(4132),
    [anon_sym_QMARK_QMARK] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_as] = ACTIONS(4132),
    [anon_sym_is] = ACTIONS(4132),
    [anon_sym_DASH_GT] = ACTIONS(4132),
    [anon_sym_with] = ACTIONS(4132),
    [aux_sym_preproc_if_token3] = ACTIONS(4132),
    [aux_sym_preproc_else_token1] = ACTIONS(4132),
    [aux_sym_preproc_elif_token1] = ACTIONS(4132),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4037] = {
    [sym_preproc_region] = STATE(4037),
    [sym_preproc_endregion] = STATE(4037),
    [sym_preproc_line] = STATE(4037),
    [sym_preproc_pragma] = STATE(4037),
    [sym_preproc_nullable] = STATE(4037),
    [sym_preproc_error] = STATE(4037),
    [sym_preproc_define] = STATE(4037),
    [sym_preproc_undef] = STATE(4037),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COMMA] = ACTIONS(5600),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LPAREN] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5602),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_BANG] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_SLASH] = ACTIONS(5602),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_GT_GT_GT] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5600),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_DOT] = ACTIONS(5602),
    [anon_sym_EQ_GT] = ACTIONS(5600),
    [anon_sym_switch] = ACTIONS(5600),
    [anon_sym_when] = ACTIONS(5600),
    [anon_sym_DOT_DOT] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE] = ACTIONS(5600),
    [anon_sym_QMARK_QMARK] = ACTIONS(5600),
    [anon_sym_into] = ACTIONS(5600),
    [anon_sym_on] = ACTIONS(5600),
    [anon_sym_equals] = ACTIONS(5600),
    [anon_sym_by] = ACTIONS(5600),
    [anon_sym_as] = ACTIONS(5600),
    [anon_sym_is] = ACTIONS(5600),
    [anon_sym_DASH_GT] = ACTIONS(5600),
    [anon_sym_with] = ACTIONS(5600),
    [aux_sym_preproc_if_token3] = ACTIONS(5600),
    [aux_sym_preproc_else_token1] = ACTIONS(5600),
    [aux_sym_preproc_elif_token1] = ACTIONS(5600),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4038] = {
    [sym_preproc_region] = STATE(4038),
    [sym_preproc_endregion] = STATE(4038),
    [sym_preproc_line] = STATE(4038),
    [sym_preproc_pragma] = STATE(4038),
    [sym_preproc_nullable] = STATE(4038),
    [sym_preproc_error] = STATE(4038),
    [sym_preproc_define] = STATE(4038),
    [sym_preproc_undef] = STATE(4038),
    [anon_sym_SEMI] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(5907),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_COMMA] = ACTIONS(5907),
    [anon_sym_RBRACK] = ACTIONS(5907),
    [anon_sym_LPAREN] = ACTIONS(5907),
    [anon_sym_RPAREN] = ACTIONS(5907),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LT] = ACTIONS(5909),
    [anon_sym_GT] = ACTIONS(5909),
    [anon_sym_in] = ACTIONS(5909),
    [anon_sym_QMARK] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5909),
    [anon_sym_PLUS_PLUS] = ACTIONS(5907),
    [anon_sym_DASH_DASH] = ACTIONS(5907),
    [anon_sym_PLUS] = ACTIONS(5909),
    [anon_sym_DASH] = ACTIONS(5909),
    [anon_sym_STAR] = ACTIONS(5907),
    [anon_sym_SLASH] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5907),
    [anon_sym_CARET] = ACTIONS(5907),
    [anon_sym_PIPE] = ACTIONS(5909),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_LT_LT] = ACTIONS(5907),
    [anon_sym_GT_GT] = ACTIONS(5909),
    [anon_sym_GT_GT_GT] = ACTIONS(5907),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_GT_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5907),
    [anon_sym_DOT] = ACTIONS(5909),
    [anon_sym_EQ_GT] = ACTIONS(5907),
    [anon_sym_switch] = ACTIONS(5907),
    [anon_sym_when] = ACTIONS(5907),
    [anon_sym_DOT_DOT] = ACTIONS(5907),
    [anon_sym_and] = ACTIONS(5907),
    [anon_sym_or] = ACTIONS(5907),
    [anon_sym_AMP_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5907),
    [anon_sym_QMARK_QMARK] = ACTIONS(5907),
    [anon_sym_into] = ACTIONS(5907),
    [anon_sym_on] = ACTIONS(5907),
    [anon_sym_equals] = ACTIONS(5907),
    [anon_sym_by] = ACTIONS(5907),
    [anon_sym_as] = ACTIONS(5907),
    [anon_sym_is] = ACTIONS(5907),
    [anon_sym_DASH_GT] = ACTIONS(5907),
    [anon_sym_with] = ACTIONS(5907),
    [aux_sym_preproc_if_token3] = ACTIONS(5907),
    [aux_sym_preproc_else_token1] = ACTIONS(5907),
    [aux_sym_preproc_elif_token1] = ACTIONS(5907),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4039] = {
    [sym_preproc_region] = STATE(4039),
    [sym_preproc_endregion] = STATE(4039),
    [sym_preproc_line] = STATE(4039),
    [sym_preproc_pragma] = STATE(4039),
    [sym_preproc_nullable] = STATE(4039),
    [sym_preproc_error] = STATE(4039),
    [sym_preproc_define] = STATE(4039),
    [sym_preproc_undef] = STATE(4039),
    [anon_sym_SEMI] = ACTIONS(5911),
    [anon_sym_LBRACK] = ACTIONS(5911),
    [anon_sym_COLON] = ACTIONS(5911),
    [anon_sym_COMMA] = ACTIONS(5911),
    [anon_sym_RBRACK] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5911),
    [anon_sym_RPAREN] = ACTIONS(5911),
    [anon_sym_RBRACE] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_in] = ACTIONS(5913),
    [anon_sym_QMARK] = ACTIONS(5913),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_PLUS_PLUS] = ACTIONS(5911),
    [anon_sym_DASH_DASH] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5911),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_CARET] = ACTIONS(5911),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5911),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym_GT_GT_GT] = ACTIONS(5911),
    [anon_sym_EQ_EQ] = ACTIONS(5911),
    [anon_sym_BANG_EQ] = ACTIONS(5911),
    [anon_sym_GT_EQ] = ACTIONS(5911),
    [anon_sym_LT_EQ] = ACTIONS(5911),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_EQ_GT] = ACTIONS(5911),
    [anon_sym_switch] = ACTIONS(5911),
    [anon_sym_when] = ACTIONS(5911),
    [anon_sym_DOT_DOT] = ACTIONS(5911),
    [anon_sym_and] = ACTIONS(5911),
    [anon_sym_or] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_PIPE_PIPE] = ACTIONS(5911),
    [anon_sym_QMARK_QMARK] = ACTIONS(5911),
    [anon_sym_into] = ACTIONS(5911),
    [anon_sym_on] = ACTIONS(5911),
    [anon_sym_equals] = ACTIONS(5911),
    [anon_sym_by] = ACTIONS(5911),
    [anon_sym_as] = ACTIONS(5911),
    [anon_sym_is] = ACTIONS(5911),
    [anon_sym_DASH_GT] = ACTIONS(5911),
    [anon_sym_with] = ACTIONS(5911),
    [aux_sym_preproc_if_token3] = ACTIONS(5911),
    [aux_sym_preproc_else_token1] = ACTIONS(5911),
    [aux_sym_preproc_elif_token1] = ACTIONS(5911),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4040] = {
    [sym_preproc_region] = STATE(4040),
    [sym_preproc_endregion] = STATE(4040),
    [sym_preproc_line] = STATE(4040),
    [sym_preproc_pragma] = STATE(4040),
    [sym_preproc_nullable] = STATE(4040),
    [sym_preproc_error] = STATE(4040),
    [sym_preproc_define] = STATE(4040),
    [sym_preproc_undef] = STATE(4040),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5596),
    [anon_sym_RBRACK] = ACTIONS(5596),
    [anon_sym_LPAREN] = ACTIONS(5596),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_BANG] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5598),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_GT_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_DOT] = ACTIONS(5598),
    [anon_sym_EQ_GT] = ACTIONS(5596),
    [anon_sym_switch] = ACTIONS(5596),
    [anon_sym_when] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_QMARK_QMARK] = ACTIONS(5596),
    [anon_sym_into] = ACTIONS(5596),
    [anon_sym_on] = ACTIONS(5596),
    [anon_sym_equals] = ACTIONS(5596),
    [anon_sym_by] = ACTIONS(5596),
    [anon_sym_as] = ACTIONS(5596),
    [anon_sym_is] = ACTIONS(5596),
    [anon_sym_DASH_GT] = ACTIONS(5596),
    [anon_sym_with] = ACTIONS(5596),
    [aux_sym_preproc_if_token3] = ACTIONS(5596),
    [aux_sym_preproc_else_token1] = ACTIONS(5596),
    [aux_sym_preproc_elif_token1] = ACTIONS(5596),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4041] = {
    [sym_preproc_region] = STATE(4041),
    [sym_preproc_endregion] = STATE(4041),
    [sym_preproc_line] = STATE(4041),
    [sym_preproc_pragma] = STATE(4041),
    [sym_preproc_nullable] = STATE(4041),
    [sym_preproc_error] = STATE(4041),
    [sym_preproc_define] = STATE(4041),
    [sym_preproc_undef] = STATE(4041),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_in] = ACTIONS(5917),
    [anon_sym_QMARK] = ACTIONS(5917),
    [anon_sym_BANG] = ACTIONS(5917),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym_GT_GT_GT] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_EQ_GT] = ACTIONS(5915),
    [anon_sym_switch] = ACTIONS(5915),
    [anon_sym_when] = ACTIONS(5915),
    [anon_sym_DOT_DOT] = ACTIONS(5915),
    [anon_sym_and] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_QMARK_QMARK] = ACTIONS(5915),
    [anon_sym_into] = ACTIONS(5915),
    [anon_sym_on] = ACTIONS(5915),
    [anon_sym_equals] = ACTIONS(5915),
    [anon_sym_by] = ACTIONS(5915),
    [anon_sym_as] = ACTIONS(5915),
    [anon_sym_is] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [anon_sym_with] = ACTIONS(5915),
    [aux_sym_preproc_if_token3] = ACTIONS(5915),
    [aux_sym_preproc_else_token1] = ACTIONS(5915),
    [aux_sym_preproc_elif_token1] = ACTIONS(5915),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4042] = {
    [sym_preproc_region] = STATE(4042),
    [sym_preproc_endregion] = STATE(4042),
    [sym_preproc_line] = STATE(4042),
    [sym_preproc_pragma] = STATE(4042),
    [sym_preproc_nullable] = STATE(4042),
    [sym_preproc_error] = STATE(4042),
    [sym_preproc_define] = STATE(4042),
    [sym_preproc_undef] = STATE(4042),
    [anon_sym_EQ] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(5921),
    [anon_sym_DASH_EQ] = ACTIONS(5921),
    [anon_sym_STAR_EQ] = ACTIONS(5921),
    [anon_sym_SLASH_EQ] = ACTIONS(5921),
    [anon_sym_PERCENT_EQ] = ACTIONS(5921),
    [anon_sym_AMP_EQ] = ACTIONS(5921),
    [anon_sym_CARET_EQ] = ACTIONS(5921),
    [anon_sym_PIPE_EQ] = ACTIONS(5921),
    [anon_sym_LT_LT_EQ] = ACTIONS(5921),
    [anon_sym_GT_GT_EQ] = ACTIONS(5921),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5921),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(5921),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4043] = {
    [sym_preproc_region] = STATE(4043),
    [sym_preproc_endregion] = STATE(4043),
    [sym_preproc_line] = STATE(4043),
    [sym_preproc_pragma] = STATE(4043),
    [sym_preproc_nullable] = STATE(4043),
    [sym_preproc_error] = STATE(4043),
    [sym_preproc_define] = STATE(4043),
    [sym_preproc_undef] = STATE(4043),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_COLON] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_RBRACK] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_RPAREN] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_in] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5470),
    [anon_sym_BANG] = ACTIONS(5470),
    [anon_sym_PLUS_PLUS] = ACTIONS(5468),
    [anon_sym_DASH_DASH] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5468),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_GT_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_EQ_GT] = ACTIONS(5468),
    [anon_sym_switch] = ACTIONS(5468),
    [anon_sym_when] = ACTIONS(5468),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_or] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE] = ACTIONS(5468),
    [anon_sym_QMARK_QMARK] = ACTIONS(5468),
    [anon_sym_into] = ACTIONS(5468),
    [anon_sym_on] = ACTIONS(5468),
    [anon_sym_equals] = ACTIONS(5468),
    [anon_sym_by] = ACTIONS(5468),
    [anon_sym_as] = ACTIONS(5468),
    [anon_sym_is] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_with] = ACTIONS(5468),
    [aux_sym_preproc_if_token3] = ACTIONS(5468),
    [aux_sym_preproc_else_token1] = ACTIONS(5468),
    [aux_sym_preproc_elif_token1] = ACTIONS(5468),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4044] = {
    [sym_preproc_region] = STATE(4044),
    [sym_preproc_endregion] = STATE(4044),
    [sym_preproc_line] = STATE(4044),
    [sym_preproc_pragma] = STATE(4044),
    [sym_preproc_nullable] = STATE(4044),
    [sym_preproc_error] = STATE(4044),
    [sym_preproc_define] = STATE(4044),
    [sym_preproc_undef] = STATE(4044),
    [anon_sym_SEMI] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_COLON] = ACTIONS(5415),
    [anon_sym_COMMA] = ACTIONS(5415),
    [anon_sym_RBRACK] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_in] = ACTIONS(5417),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_BANG] = ACTIONS(5417),
    [anon_sym_PLUS_PLUS] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5415),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5415),
    [anon_sym_CARET] = ACTIONS(5415),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5415),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_GT_GT_GT] = ACTIONS(5415),
    [anon_sym_EQ_EQ] = ACTIONS(5415),
    [anon_sym_BANG_EQ] = ACTIONS(5415),
    [anon_sym_GT_EQ] = ACTIONS(5415),
    [anon_sym_LT_EQ] = ACTIONS(5415),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_EQ_GT] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_when] = ACTIONS(5415),
    [anon_sym_DOT_DOT] = ACTIONS(5415),
    [anon_sym_and] = ACTIONS(5415),
    [anon_sym_or] = ACTIONS(5415),
    [anon_sym_AMP_AMP] = ACTIONS(5415),
    [anon_sym_PIPE_PIPE] = ACTIONS(5415),
    [anon_sym_QMARK_QMARK] = ACTIONS(5415),
    [anon_sym_into] = ACTIONS(5415),
    [anon_sym_on] = ACTIONS(5415),
    [anon_sym_equals] = ACTIONS(5415),
    [anon_sym_by] = ACTIONS(5415),
    [anon_sym_as] = ACTIONS(5415),
    [anon_sym_is] = ACTIONS(5415),
    [anon_sym_DASH_GT] = ACTIONS(5415),
    [anon_sym_with] = ACTIONS(5415),
    [aux_sym_preproc_if_token3] = ACTIONS(5415),
    [aux_sym_preproc_else_token1] = ACTIONS(5415),
    [aux_sym_preproc_elif_token1] = ACTIONS(5415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4045] = {
    [sym_preproc_region] = STATE(4045),
    [sym_preproc_endregion] = STATE(4045),
    [sym_preproc_line] = STATE(4045),
    [sym_preproc_pragma] = STATE(4045),
    [sym_preproc_nullable] = STATE(4045),
    [sym_preproc_error] = STATE(4045),
    [sym_preproc_define] = STATE(4045),
    [sym_preproc_undef] = STATE(4045),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RBRACK] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_in] = ACTIONS(5925),
    [anon_sym_QMARK] = ACTIONS(5925),
    [anon_sym_BANG] = ACTIONS(5925),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_CARET] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5923),
    [anon_sym_GT_GT] = ACTIONS(5925),
    [anon_sym_GT_GT_GT] = ACTIONS(5923),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_EQ_GT] = ACTIONS(5923),
    [anon_sym_switch] = ACTIONS(5923),
    [anon_sym_when] = ACTIONS(5923),
    [anon_sym_DOT_DOT] = ACTIONS(5923),
    [anon_sym_and] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_QMARK_QMARK] = ACTIONS(5923),
    [anon_sym_into] = ACTIONS(5923),
    [anon_sym_on] = ACTIONS(5923),
    [anon_sym_equals] = ACTIONS(5923),
    [anon_sym_by] = ACTIONS(5923),
    [anon_sym_as] = ACTIONS(5923),
    [anon_sym_is] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [anon_sym_with] = ACTIONS(5923),
    [aux_sym_preproc_if_token3] = ACTIONS(5923),
    [aux_sym_preproc_else_token1] = ACTIONS(5923),
    [aux_sym_preproc_elif_token1] = ACTIONS(5923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4046] = {
    [sym_preproc_region] = STATE(4046),
    [sym_preproc_endregion] = STATE(4046),
    [sym_preproc_line] = STATE(4046),
    [sym_preproc_pragma] = STATE(4046),
    [sym_preproc_nullable] = STATE(4046),
    [sym_preproc_error] = STATE(4046),
    [sym_preproc_define] = STATE(4046),
    [sym_preproc_undef] = STATE(4046),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_in] = ACTIONS(5421),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5419),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5419),
    [anon_sym_CARET] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5419),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5419),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5419),
    [anon_sym_when] = ACTIONS(5419),
    [anon_sym_DOT_DOT] = ACTIONS(5419),
    [anon_sym_and] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_QMARK_QMARK] = ACTIONS(5419),
    [anon_sym_into] = ACTIONS(5419),
    [anon_sym_on] = ACTIONS(5419),
    [anon_sym_equals] = ACTIONS(5419),
    [anon_sym_by] = ACTIONS(5419),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_with] = ACTIONS(5419),
    [aux_sym_preproc_if_token3] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4047] = {
    [sym_preproc_region] = STATE(4047),
    [sym_preproc_endregion] = STATE(4047),
    [sym_preproc_line] = STATE(4047),
    [sym_preproc_pragma] = STATE(4047),
    [sym_preproc_nullable] = STATE(4047),
    [sym_preproc_error] = STATE(4047),
    [sym_preproc_define] = STATE(4047),
    [sym_preproc_undef] = STATE(4047),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5484),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_into] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4048] = {
    [sym_preproc_region] = STATE(4048),
    [sym_preproc_endregion] = STATE(4048),
    [sym_preproc_line] = STATE(4048),
    [sym_preproc_pragma] = STATE(4048),
    [sym_preproc_nullable] = STATE(4048),
    [sym_preproc_error] = STATE(4048),
    [sym_preproc_define] = STATE(4048),
    [sym_preproc_undef] = STATE(4048),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(4136),
    [anon_sym_COMMA] = ACTIONS(4136),
    [anon_sym_RBRACK] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4136),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_LBRACE] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(4134),
    [anon_sym_GT] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(4136),
    [anon_sym_QMARK] = ACTIONS(4134),
    [anon_sym_BANG] = ACTIONS(4134),
    [anon_sym_PLUS_PLUS] = ACTIONS(4136),
    [anon_sym_DASH_DASH] = ACTIONS(4136),
    [anon_sym_PLUS] = ACTIONS(4134),
    [anon_sym_DASH] = ACTIONS(4134),
    [anon_sym_STAR] = ACTIONS(4136),
    [anon_sym_SLASH] = ACTIONS(4134),
    [anon_sym_PERCENT] = ACTIONS(4136),
    [anon_sym_CARET] = ACTIONS(4136),
    [anon_sym_PIPE] = ACTIONS(4134),
    [anon_sym_AMP] = ACTIONS(4134),
    [anon_sym_LT_LT] = ACTIONS(4136),
    [anon_sym_GT_GT] = ACTIONS(4134),
    [anon_sym_GT_GT_GT] = ACTIONS(4136),
    [anon_sym_EQ_EQ] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_GT_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4136),
    [anon_sym_DOT] = ACTIONS(4134),
    [anon_sym_EQ_GT] = ACTIONS(4136),
    [anon_sym_switch] = ACTIONS(4136),
    [anon_sym_when] = ACTIONS(4136),
    [anon_sym_DOT_DOT] = ACTIONS(4136),
    [anon_sym_and] = ACTIONS(4136),
    [anon_sym_or] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_QMARK_QMARK] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_as] = ACTIONS(4136),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_DASH_GT] = ACTIONS(4136),
    [anon_sym_with] = ACTIONS(4136),
    [aux_sym_preproc_if_token3] = ACTIONS(4136),
    [aux_sym_preproc_else_token1] = ACTIONS(4136),
    [aux_sym_preproc_elif_token1] = ACTIONS(4136),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4049] = {
    [sym_preproc_region] = STATE(4049),
    [sym_preproc_endregion] = STATE(4049),
    [sym_preproc_line] = STATE(4049),
    [sym_preproc_pragma] = STATE(4049),
    [sym_preproc_nullable] = STATE(4049),
    [sym_preproc_error] = STATE(4049),
    [sym_preproc_define] = STATE(4049),
    [sym_preproc_undef] = STATE(4049),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5927),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4050] = {
    [sym_preproc_region] = STATE(4050),
    [sym_preproc_endregion] = STATE(4050),
    [sym_preproc_line] = STATE(4050),
    [sym_preproc_pragma] = STATE(4050),
    [sym_preproc_nullable] = STATE(4050),
    [sym_preproc_error] = STATE(4050),
    [sym_preproc_define] = STATE(4050),
    [sym_preproc_undef] = STATE(4050),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5528),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_into] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4051] = {
    [sym_preproc_region] = STATE(4051),
    [sym_preproc_endregion] = STATE(4051),
    [sym_preproc_line] = STATE(4051),
    [sym_preproc_pragma] = STATE(4051),
    [sym_preproc_nullable] = STATE(4051),
    [sym_preproc_error] = STATE(4051),
    [sym_preproc_define] = STATE(4051),
    [sym_preproc_undef] = STATE(4051),
    [anon_sym_SEMI] = ACTIONS(5929),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_COLON] = ACTIONS(5929),
    [anon_sym_COMMA] = ACTIONS(5929),
    [anon_sym_RBRACK] = ACTIONS(5929),
    [anon_sym_LPAREN] = ACTIONS(5929),
    [anon_sym_RPAREN] = ACTIONS(5929),
    [anon_sym_RBRACE] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5931),
    [anon_sym_in] = ACTIONS(5931),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_BANG] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5929),
    [anon_sym_DASH_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5931),
    [anon_sym_STAR] = ACTIONS(5929),
    [anon_sym_SLASH] = ACTIONS(5931),
    [anon_sym_PERCENT] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5929),
    [anon_sym_PIPE] = ACTIONS(5931),
    [anon_sym_AMP] = ACTIONS(5931),
    [anon_sym_LT_LT] = ACTIONS(5929),
    [anon_sym_GT_GT] = ACTIONS(5931),
    [anon_sym_GT_GT_GT] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5929),
    [anon_sym_BANG_EQ] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5929),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_DOT] = ACTIONS(5931),
    [anon_sym_EQ_GT] = ACTIONS(5929),
    [anon_sym_switch] = ACTIONS(5929),
    [anon_sym_when] = ACTIONS(5929),
    [anon_sym_DOT_DOT] = ACTIONS(5929),
    [anon_sym_and] = ACTIONS(5929),
    [anon_sym_or] = ACTIONS(5929),
    [anon_sym_AMP_AMP] = ACTIONS(5929),
    [anon_sym_PIPE_PIPE] = ACTIONS(5929),
    [anon_sym_QMARK_QMARK] = ACTIONS(5929),
    [anon_sym_into] = ACTIONS(5929),
    [anon_sym_on] = ACTIONS(5929),
    [anon_sym_equals] = ACTIONS(5929),
    [anon_sym_by] = ACTIONS(5929),
    [anon_sym_as] = ACTIONS(5929),
    [anon_sym_is] = ACTIONS(5929),
    [anon_sym_DASH_GT] = ACTIONS(5929),
    [anon_sym_with] = ACTIONS(5929),
    [aux_sym_preproc_if_token3] = ACTIONS(5929),
    [aux_sym_preproc_else_token1] = ACTIONS(5929),
    [aux_sym_preproc_elif_token1] = ACTIONS(5929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4052] = {
    [sym_preproc_region] = STATE(4052),
    [sym_preproc_endregion] = STATE(4052),
    [sym_preproc_line] = STATE(4052),
    [sym_preproc_pragma] = STATE(4052),
    [sym_preproc_nullable] = STATE(4052),
    [sym_preproc_error] = STATE(4052),
    [sym_preproc_define] = STATE(4052),
    [sym_preproc_undef] = STATE(4052),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_QMARK] = ACTIONS(5634),
    [anon_sym_BANG] = ACTIONS(5634),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5634),
    [anon_sym_GT_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_EQ_GT] = ACTIONS(5632),
    [anon_sym_switch] = ACTIONS(5632),
    [anon_sym_when] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_and] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_QMARK_QMARK] = ACTIONS(5632),
    [anon_sym_into] = ACTIONS(5632),
    [anon_sym_on] = ACTIONS(5632),
    [anon_sym_equals] = ACTIONS(5632),
    [anon_sym_by] = ACTIONS(5632),
    [anon_sym_as] = ACTIONS(5632),
    [anon_sym_is] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [anon_sym_with] = ACTIONS(5632),
    [aux_sym_preproc_if_token3] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5632),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4053] = {
    [sym_preproc_region] = STATE(4053),
    [sym_preproc_endregion] = STATE(4053),
    [sym_preproc_line] = STATE(4053),
    [sym_preproc_pragma] = STATE(4053),
    [sym_preproc_nullable] = STATE(4053),
    [sym_preproc_error] = STATE(4053),
    [sym_preproc_define] = STATE(4053),
    [sym_preproc_undef] = STATE(4053),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5630),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_BANG] = ACTIONS(5630),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_GT_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_switch] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_DOT_DOT] = ACTIONS(5628),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_QMARK_QMARK] = ACTIONS(5628),
    [anon_sym_into] = ACTIONS(5628),
    [anon_sym_on] = ACTIONS(5628),
    [anon_sym_equals] = ACTIONS(5628),
    [anon_sym_by] = ACTIONS(5628),
    [anon_sym_as] = ACTIONS(5628),
    [anon_sym_is] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [anon_sym_with] = ACTIONS(5628),
    [aux_sym_preproc_if_token3] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4054] = {
    [sym_preproc_region] = STATE(4054),
    [sym_preproc_endregion] = STATE(4054),
    [sym_preproc_line] = STATE(4054),
    [sym_preproc_pragma] = STATE(4054),
    [sym_preproc_nullable] = STATE(4054),
    [sym_preproc_error] = STATE(4054),
    [sym_preproc_define] = STATE(4054),
    [sym_preproc_undef] = STATE(4054),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5405),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_when] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_into] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4055] = {
    [sym_preproc_region] = STATE(4055),
    [sym_preproc_endregion] = STATE(4055),
    [sym_preproc_line] = STATE(4055),
    [sym_preproc_pragma] = STATE(4055),
    [sym_preproc_nullable] = STATE(4055),
    [sym_preproc_error] = STATE(4055),
    [sym_preproc_define] = STATE(4055),
    [sym_preproc_undef] = STATE(4055),
    [anon_sym_SEMI] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_COLON] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RBRACK] = ACTIONS(5933),
    [anon_sym_LPAREN] = ACTIONS(5933),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_RBRACE] = ACTIONS(5933),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_in] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5935),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_PLUS_PLUS] = ACTIONS(5933),
    [anon_sym_DASH_DASH] = ACTIONS(5933),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5933),
    [anon_sym_CARET] = ACTIONS(5933),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5933),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_GT_GT_GT] = ACTIONS(5933),
    [anon_sym_EQ_EQ] = ACTIONS(5933),
    [anon_sym_BANG_EQ] = ACTIONS(5933),
    [anon_sym_GT_EQ] = ACTIONS(5933),
    [anon_sym_LT_EQ] = ACTIONS(5933),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_EQ_GT] = ACTIONS(5933),
    [anon_sym_switch] = ACTIONS(5933),
    [anon_sym_when] = ACTIONS(5933),
    [anon_sym_DOT_DOT] = ACTIONS(5933),
    [anon_sym_and] = ACTIONS(5933),
    [anon_sym_or] = ACTIONS(5933),
    [anon_sym_AMP_AMP] = ACTIONS(5933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5933),
    [anon_sym_QMARK_QMARK] = ACTIONS(5933),
    [anon_sym_into] = ACTIONS(5933),
    [anon_sym_on] = ACTIONS(5933),
    [anon_sym_equals] = ACTIONS(5933),
    [anon_sym_by] = ACTIONS(5933),
    [anon_sym_as] = ACTIONS(5933),
    [anon_sym_is] = ACTIONS(5933),
    [anon_sym_DASH_GT] = ACTIONS(5933),
    [anon_sym_with] = ACTIONS(5933),
    [aux_sym_preproc_if_token3] = ACTIONS(5933),
    [aux_sym_preproc_else_token1] = ACTIONS(5933),
    [aux_sym_preproc_elif_token1] = ACTIONS(5933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4056] = {
    [sym_initializer_expression] = STATE(4274),
    [sym_preproc_region] = STATE(4056),
    [sym_preproc_endregion] = STATE(4056),
    [sym_preproc_line] = STATE(4056),
    [sym_preproc_pragma] = STATE(4056),
    [sym_preproc_nullable] = STATE(4056),
    [sym_preproc_error] = STATE(4056),
    [sym_preproc_define] = STATE(4056),
    [sym_preproc_undef] = STATE(4056),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RBRACK] = ACTIONS(5331),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5337),
    [anon_sym_GT] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(5940),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_PLUS_PLUS] = ACTIONS(5331),
    [anon_sym_DASH_DASH] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_STAR] = ACTIONS(5331),
    [anon_sym_SLASH] = ACTIONS(5337),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_CARET] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5337),
    [anon_sym_AMP] = ACTIONS(5337),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5337),
    [anon_sym_GT_GT_GT] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_BANG_EQ] = ACTIONS(5331),
    [anon_sym_GT_EQ] = ACTIONS(5331),
    [anon_sym_LT_EQ] = ACTIONS(5331),
    [anon_sym_DOT] = ACTIONS(5337),
    [anon_sym_EQ_GT] = ACTIONS(5331),
    [anon_sym_switch] = ACTIONS(5331),
    [anon_sym_when] = ACTIONS(5331),
    [anon_sym_DOT_DOT] = ACTIONS(5331),
    [anon_sym_and] = ACTIONS(5331),
    [anon_sym_or] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_on] = ACTIONS(5331),
    [anon_sym_equals] = ACTIONS(5331),
    [anon_sym_by] = ACTIONS(5331),
    [anon_sym_as] = ACTIONS(5331),
    [anon_sym_is] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [anon_sym_with] = ACTIONS(5331),
    [aux_sym_preproc_if_token3] = ACTIONS(5331),
    [aux_sym_preproc_else_token1] = ACTIONS(5331),
    [aux_sym_preproc_elif_token1] = ACTIONS(5331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4057] = {
    [sym_preproc_region] = STATE(4057),
    [sym_preproc_endregion] = STATE(4057),
    [sym_preproc_line] = STATE(4057),
    [sym_preproc_pragma] = STATE(4057),
    [sym_preproc_nullable] = STATE(4057),
    [sym_preproc_error] = STATE(4057),
    [sym_preproc_define] = STATE(4057),
    [sym_preproc_undef] = STATE(4057),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_COLON] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_EQ_GT] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_when] = ACTIONS(2999),
    [anon_sym_DOT_DOT] = ACTIONS(2999),
    [anon_sym_and] = ACTIONS(2999),
    [anon_sym_or] = ACTIONS(2999),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_into] = ACTIONS(2999),
    [anon_sym_on] = ACTIONS(2999),
    [anon_sym_equals] = ACTIONS(2999),
    [anon_sym_by] = ACTIONS(2999),
    [anon_sym_as] = ACTIONS(2999),
    [anon_sym_is] = ACTIONS(2999),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [aux_sym_preproc_if_token3] = ACTIONS(2999),
    [aux_sym_preproc_else_token1] = ACTIONS(2999),
    [aux_sym_preproc_elif_token1] = ACTIONS(2999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4058] = {
    [sym_preproc_region] = STATE(4058),
    [sym_preproc_endregion] = STATE(4058),
    [sym_preproc_line] = STATE(4058),
    [sym_preproc_pragma] = STATE(4058),
    [sym_preproc_nullable] = STATE(4058),
    [sym_preproc_error] = STATE(4058),
    [sym_preproc_define] = STATE(4058),
    [sym_preproc_undef] = STATE(4058),
    [anon_sym_SEMI] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_COLON] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RBRACK] = ACTIONS(5933),
    [anon_sym_LPAREN] = ACTIONS(5933),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_RBRACE] = ACTIONS(5933),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_in] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5935),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_PLUS_PLUS] = ACTIONS(5933),
    [anon_sym_DASH_DASH] = ACTIONS(5933),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5933),
    [anon_sym_CARET] = ACTIONS(5933),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5933),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_GT_GT_GT] = ACTIONS(5933),
    [anon_sym_EQ_EQ] = ACTIONS(5933),
    [anon_sym_BANG_EQ] = ACTIONS(5933),
    [anon_sym_GT_EQ] = ACTIONS(5933),
    [anon_sym_LT_EQ] = ACTIONS(5933),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_EQ_GT] = ACTIONS(5933),
    [anon_sym_switch] = ACTIONS(5933),
    [anon_sym_when] = ACTIONS(5933),
    [anon_sym_DOT_DOT] = ACTIONS(5933),
    [anon_sym_and] = ACTIONS(5933),
    [anon_sym_or] = ACTIONS(5933),
    [anon_sym_AMP_AMP] = ACTIONS(5933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5933),
    [anon_sym_QMARK_QMARK] = ACTIONS(5933),
    [anon_sym_into] = ACTIONS(5933),
    [anon_sym_on] = ACTIONS(5933),
    [anon_sym_equals] = ACTIONS(5933),
    [anon_sym_by] = ACTIONS(5933),
    [anon_sym_as] = ACTIONS(5933),
    [anon_sym_is] = ACTIONS(5933),
    [anon_sym_DASH_GT] = ACTIONS(5933),
    [anon_sym_with] = ACTIONS(5933),
    [aux_sym_preproc_if_token3] = ACTIONS(5933),
    [aux_sym_preproc_else_token1] = ACTIONS(5933),
    [aux_sym_preproc_elif_token1] = ACTIONS(5933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4059] = {
    [sym_preproc_region] = STATE(4059),
    [sym_preproc_endregion] = STATE(4059),
    [sym_preproc_line] = STATE(4059),
    [sym_preproc_pragma] = STATE(4059),
    [sym_preproc_nullable] = STATE(4059),
    [sym_preproc_error] = STATE(4059),
    [sym_preproc_define] = STATE(4059),
    [sym_preproc_undef] = STATE(4059),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_COLON] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_RPAREN] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_in] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5384),
    [anon_sym_BANG] = ACTIONS(5384),
    [anon_sym_PLUS_PLUS] = ACTIONS(5382),
    [anon_sym_DASH_DASH] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5382),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5382),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5382),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_GT_GT_GT] = ACTIONS(5382),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_EQ_GT] = ACTIONS(5382),
    [anon_sym_switch] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_DOT_DOT] = ACTIONS(5382),
    [anon_sym_and] = ACTIONS(5382),
    [anon_sym_or] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE] = ACTIONS(5382),
    [anon_sym_QMARK_QMARK] = ACTIONS(5382),
    [anon_sym_on] = ACTIONS(5382),
    [anon_sym_equals] = ACTIONS(5382),
    [anon_sym_by] = ACTIONS(5382),
    [anon_sym_as] = ACTIONS(5382),
    [anon_sym_is] = ACTIONS(5382),
    [anon_sym_DQUOTE] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_with] = ACTIONS(5382),
    [aux_sym_preproc_if_token3] = ACTIONS(5382),
    [aux_sym_preproc_else_token1] = ACTIONS(5382),
    [aux_sym_preproc_elif_token1] = ACTIONS(5382),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4060] = {
    [sym_preproc_region] = STATE(4060),
    [sym_preproc_endregion] = STATE(4060),
    [sym_preproc_line] = STATE(4060),
    [sym_preproc_pragma] = STATE(4060),
    [sym_preproc_nullable] = STATE(4060),
    [sym_preproc_error] = STATE(4060),
    [sym_preproc_define] = STATE(4060),
    [sym_preproc_undef] = STATE(4060),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3040),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_QMARK_QMARK] = ACTIONS(3042),
    [anon_sym_into] = ACTIONS(3042),
    [anon_sym_on] = ACTIONS(3042),
    [anon_sym_equals] = ACTIONS(3042),
    [anon_sym_by] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_DASH_GT] = ACTIONS(3042),
    [anon_sym_with] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4061] = {
    [sym_preproc_region] = STATE(4061),
    [sym_preproc_endregion] = STATE(4061),
    [sym_preproc_line] = STATE(4061),
    [sym_preproc_pragma] = STATE(4061),
    [sym_preproc_nullable] = STATE(4061),
    [sym_preproc_error] = STATE(4061),
    [sym_preproc_define] = STATE(4061),
    [sym_preproc_undef] = STATE(4061),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_COLON] = ACTIONS(5616),
    [anon_sym_COMMA] = ACTIONS(5616),
    [anon_sym_RBRACK] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [anon_sym_RPAREN] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5618),
    [anon_sym_QMARK] = ACTIONS(5618),
    [anon_sym_BANG] = ACTIONS(5618),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5616),
    [anon_sym_CARET] = ACTIONS(5616),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5616),
    [anon_sym_GT_GT] = ACTIONS(5618),
    [anon_sym_GT_GT_GT] = ACTIONS(5616),
    [anon_sym_EQ_EQ] = ACTIONS(5616),
    [anon_sym_BANG_EQ] = ACTIONS(5616),
    [anon_sym_GT_EQ] = ACTIONS(5616),
    [anon_sym_LT_EQ] = ACTIONS(5616),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5616),
    [anon_sym_switch] = ACTIONS(5616),
    [anon_sym_when] = ACTIONS(5616),
    [anon_sym_DOT_DOT] = ACTIONS(5616),
    [anon_sym_and] = ACTIONS(5616),
    [anon_sym_or] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_PIPE_PIPE] = ACTIONS(5616),
    [anon_sym_QMARK_QMARK] = ACTIONS(5616),
    [anon_sym_into] = ACTIONS(5616),
    [anon_sym_on] = ACTIONS(5616),
    [anon_sym_equals] = ACTIONS(5616),
    [anon_sym_by] = ACTIONS(5616),
    [anon_sym_as] = ACTIONS(5616),
    [anon_sym_is] = ACTIONS(5616),
    [anon_sym_DASH_GT] = ACTIONS(5616),
    [anon_sym_with] = ACTIONS(5616),
    [aux_sym_preproc_if_token3] = ACTIONS(5616),
    [aux_sym_preproc_else_token1] = ACTIONS(5616),
    [aux_sym_preproc_elif_token1] = ACTIONS(5616),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4062] = {
    [sym_preproc_region] = STATE(4062),
    [sym_preproc_endregion] = STATE(4062),
    [sym_preproc_line] = STATE(4062),
    [sym_preproc_pragma] = STATE(4062),
    [sym_preproc_nullable] = STATE(4062),
    [sym_preproc_error] = STATE(4062),
    [sym_preproc_define] = STATE(4062),
    [sym_preproc_undef] = STATE(4062),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4063] = {
    [sym_preproc_region] = STATE(4063),
    [sym_preproc_endregion] = STATE(4063),
    [sym_preproc_line] = STATE(4063),
    [sym_preproc_pragma] = STATE(4063),
    [sym_preproc_nullable] = STATE(4063),
    [sym_preproc_error] = STATE(4063),
    [sym_preproc_define] = STATE(4063),
    [sym_preproc_undef] = STATE(4063),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [anon_sym_COLON] = ACTIONS(4144),
    [anon_sym_COMMA] = ACTIONS(4144),
    [anon_sym_RBRACK] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_LT] = ACTIONS(4142),
    [anon_sym_GT] = ACTIONS(4142),
    [anon_sym_in] = ACTIONS(4144),
    [anon_sym_QMARK] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_PERCENT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_AMP] = ACTIONS(4142),
    [anon_sym_LT_LT] = ACTIONS(4144),
    [anon_sym_GT_GT] = ACTIONS(4142),
    [anon_sym_GT_GT_GT] = ACTIONS(4144),
    [anon_sym_EQ_EQ] = ACTIONS(4144),
    [anon_sym_BANG_EQ] = ACTIONS(4144),
    [anon_sym_GT_EQ] = ACTIONS(4144),
    [anon_sym_LT_EQ] = ACTIONS(4144),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_EQ_GT] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_DOT_DOT] = ACTIONS(4144),
    [anon_sym_and] = ACTIONS(4144),
    [anon_sym_or] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_QMARK_QMARK] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_as] = ACTIONS(4144),
    [anon_sym_is] = ACTIONS(4144),
    [anon_sym_DASH_GT] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4144),
    [aux_sym_preproc_if_token3] = ACTIONS(4144),
    [aux_sym_preproc_else_token1] = ACTIONS(4144),
    [aux_sym_preproc_elif_token1] = ACTIONS(4144),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4064] = {
    [sym_preproc_region] = STATE(4064),
    [sym_preproc_endregion] = STATE(4064),
    [sym_preproc_line] = STATE(4064),
    [sym_preproc_pragma] = STATE(4064),
    [sym_preproc_nullable] = STATE(4064),
    [sym_preproc_error] = STATE(4064),
    [sym_preproc_define] = STATE(4064),
    [sym_preproc_undef] = STATE(4064),
    [anon_sym_SEMI] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4140),
    [anon_sym_COLON] = ACTIONS(4140),
    [anon_sym_COMMA] = ACTIONS(4140),
    [anon_sym_RBRACK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_LBRACE] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4140),
    [anon_sym_LT] = ACTIONS(4138),
    [anon_sym_GT] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(4140),
    [anon_sym_QMARK] = ACTIONS(4138),
    [anon_sym_BANG] = ACTIONS(4138),
    [anon_sym_PLUS_PLUS] = ACTIONS(4140),
    [anon_sym_DASH_DASH] = ACTIONS(4140),
    [anon_sym_PLUS] = ACTIONS(4138),
    [anon_sym_DASH] = ACTIONS(4138),
    [anon_sym_STAR] = ACTIONS(4140),
    [anon_sym_SLASH] = ACTIONS(4138),
    [anon_sym_PERCENT] = ACTIONS(4140),
    [anon_sym_CARET] = ACTIONS(4140),
    [anon_sym_PIPE] = ACTIONS(4138),
    [anon_sym_AMP] = ACTIONS(4138),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_GT_GT_GT] = ACTIONS(4140),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4140),
    [anon_sym_GT_EQ] = ACTIONS(4140),
    [anon_sym_LT_EQ] = ACTIONS(4140),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_EQ_GT] = ACTIONS(4140),
    [anon_sym_switch] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_DOT_DOT] = ACTIONS(4140),
    [anon_sym_and] = ACTIONS(4140),
    [anon_sym_or] = ACTIONS(4140),
    [anon_sym_AMP_AMP] = ACTIONS(4140),
    [anon_sym_PIPE_PIPE] = ACTIONS(4140),
    [anon_sym_QMARK_QMARK] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_as] = ACTIONS(4140),
    [anon_sym_is] = ACTIONS(4140),
    [anon_sym_DASH_GT] = ACTIONS(4140),
    [anon_sym_with] = ACTIONS(4140),
    [aux_sym_preproc_if_token3] = ACTIONS(4140),
    [aux_sym_preproc_else_token1] = ACTIONS(4140),
    [aux_sym_preproc_elif_token1] = ACTIONS(4140),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4065] = {
    [sym_preproc_region] = STATE(4065),
    [sym_preproc_endregion] = STATE(4065),
    [sym_preproc_line] = STATE(4065),
    [sym_preproc_pragma] = STATE(4065),
    [sym_preproc_nullable] = STATE(4065),
    [sym_preproc_error] = STATE(4065),
    [sym_preproc_define] = STATE(4065),
    [sym_preproc_undef] = STATE(4065),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym_LBRACK] = ACTIONS(5608),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(5608),
    [anon_sym_RBRACK] = ACTIONS(5608),
    [anon_sym_LPAREN] = ACTIONS(5608),
    [anon_sym_RPAREN] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_LT] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_BANG] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5608),
    [anon_sym_DASH_DASH] = ACTIONS(5608),
    [anon_sym_PLUS] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5610),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_SLASH] = ACTIONS(5610),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_CARET] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym_LT_LT] = ACTIONS(5608),
    [anon_sym_GT_GT] = ACTIONS(5610),
    [anon_sym_GT_GT_GT] = ACTIONS(5608),
    [anon_sym_EQ_EQ] = ACTIONS(5608),
    [anon_sym_BANG_EQ] = ACTIONS(5608),
    [anon_sym_GT_EQ] = ACTIONS(5608),
    [anon_sym_LT_EQ] = ACTIONS(5608),
    [anon_sym_DOT] = ACTIONS(5610),
    [anon_sym_EQ_GT] = ACTIONS(5608),
    [anon_sym_switch] = ACTIONS(5608),
    [anon_sym_when] = ACTIONS(5608),
    [anon_sym_DOT_DOT] = ACTIONS(5608),
    [anon_sym_and] = ACTIONS(5608),
    [anon_sym_or] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_QMARK_QMARK] = ACTIONS(5608),
    [anon_sym_into] = ACTIONS(5608),
    [anon_sym_on] = ACTIONS(5608),
    [anon_sym_equals] = ACTIONS(5608),
    [anon_sym_by] = ACTIONS(5608),
    [anon_sym_as] = ACTIONS(5608),
    [anon_sym_is] = ACTIONS(5608),
    [anon_sym_DASH_GT] = ACTIONS(5608),
    [anon_sym_with] = ACTIONS(5608),
    [aux_sym_preproc_if_token3] = ACTIONS(5608),
    [aux_sym_preproc_else_token1] = ACTIONS(5608),
    [aux_sym_preproc_elif_token1] = ACTIONS(5608),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4066] = {
    [sym_preproc_region] = STATE(4066),
    [sym_preproc_endregion] = STATE(4066),
    [sym_preproc_line] = STATE(4066),
    [sym_preproc_pragma] = STATE(4066),
    [sym_preproc_nullable] = STATE(4066),
    [sym_preproc_error] = STATE(4066),
    [sym_preproc_define] = STATE(4066),
    [sym_preproc_undef] = STATE(4066),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5409),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_into] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4067] = {
    [sym_preproc_region] = STATE(4067),
    [sym_preproc_endregion] = STATE(4067),
    [sym_preproc_line] = STATE(4067),
    [sym_preproc_pragma] = STATE(4067),
    [sym_preproc_nullable] = STATE(4067),
    [sym_preproc_error] = STATE(4067),
    [sym_preproc_define] = STATE(4067),
    [sym_preproc_undef] = STATE(4067),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(5425),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_GT_GT] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5423),
    [anon_sym_when] = ACTIONS(5423),
    [anon_sym_DOT_DOT] = ACTIONS(5423),
    [anon_sym_and] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_QMARK_QMARK] = ACTIONS(5423),
    [anon_sym_into] = ACTIONS(5423),
    [anon_sym_on] = ACTIONS(5423),
    [anon_sym_equals] = ACTIONS(5423),
    [anon_sym_by] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_is] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_with] = ACTIONS(5423),
    [aux_sym_preproc_if_token3] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4068] = {
    [sym_preproc_region] = STATE(4068),
    [sym_preproc_endregion] = STATE(4068),
    [sym_preproc_line] = STATE(4068),
    [sym_preproc_pragma] = STATE(4068),
    [sym_preproc_nullable] = STATE(4068),
    [sym_preproc_error] = STATE(4068),
    [sym_preproc_define] = STATE(4068),
    [sym_preproc_undef] = STATE(4068),
    [anon_sym_SEMI] = ACTIONS(5944),
    [anon_sym_LBRACK] = ACTIONS(5944),
    [anon_sym_COLON] = ACTIONS(5944),
    [anon_sym_COMMA] = ACTIONS(5944),
    [anon_sym_RBRACK] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(5944),
    [anon_sym_RBRACE] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_in] = ACTIONS(5946),
    [anon_sym_QMARK] = ACTIONS(5946),
    [anon_sym_BANG] = ACTIONS(5946),
    [anon_sym_PLUS_PLUS] = ACTIONS(5944),
    [anon_sym_DASH_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5946),
    [anon_sym_DASH] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(5944),
    [anon_sym_SLASH] = ACTIONS(5946),
    [anon_sym_PERCENT] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5944),
    [anon_sym_PIPE] = ACTIONS(5946),
    [anon_sym_AMP] = ACTIONS(5946),
    [anon_sym_LT_LT] = ACTIONS(5944),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_GT_GT_GT] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5944),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5944),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_DOT] = ACTIONS(5946),
    [anon_sym_EQ_GT] = ACTIONS(5944),
    [anon_sym_switch] = ACTIONS(5944),
    [anon_sym_when] = ACTIONS(5944),
    [anon_sym_DOT_DOT] = ACTIONS(5944),
    [anon_sym_and] = ACTIONS(5944),
    [anon_sym_or] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5944),
    [anon_sym_PIPE_PIPE] = ACTIONS(5944),
    [anon_sym_QMARK_QMARK] = ACTIONS(5944),
    [anon_sym_into] = ACTIONS(5944),
    [anon_sym_on] = ACTIONS(5944),
    [anon_sym_equals] = ACTIONS(5944),
    [anon_sym_by] = ACTIONS(5944),
    [anon_sym_as] = ACTIONS(5944),
    [anon_sym_is] = ACTIONS(5944),
    [anon_sym_DASH_GT] = ACTIONS(5944),
    [anon_sym_with] = ACTIONS(5944),
    [aux_sym_preproc_if_token3] = ACTIONS(5944),
    [aux_sym_preproc_else_token1] = ACTIONS(5944),
    [aux_sym_preproc_elif_token1] = ACTIONS(5944),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4069] = {
    [sym_preproc_region] = STATE(4069),
    [sym_preproc_endregion] = STATE(4069),
    [sym_preproc_line] = STATE(4069),
    [sym_preproc_pragma] = STATE(4069),
    [sym_preproc_nullable] = STATE(4069),
    [sym_preproc_error] = STATE(4069),
    [sym_preproc_define] = STATE(4069),
    [sym_preproc_undef] = STATE(4069),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5450),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_into] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4070] = {
    [sym_preproc_region] = STATE(4070),
    [sym_preproc_endregion] = STATE(4070),
    [sym_preproc_line] = STATE(4070),
    [sym_preproc_pragma] = STATE(4070),
    [sym_preproc_nullable] = STATE(4070),
    [sym_preproc_error] = STATE(4070),
    [sym_preproc_define] = STATE(4070),
    [sym_preproc_undef] = STATE(4070),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_COLON] = ACTIONS(4320),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LT] = ACTIONS(5948),
    [anon_sym_GT] = ACTIONS(5948),
    [anon_sym_in] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5948),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_SLASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(4320),
    [anon_sym_CARET] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(5948),
    [anon_sym_AMP] = ACTIONS(5948),
    [anon_sym_LT_LT] = ACTIONS(4320),
    [anon_sym_GT_GT] = ACTIONS(5948),
    [anon_sym_GT_GT_GT] = ACTIONS(4320),
    [anon_sym_EQ_EQ] = ACTIONS(4320),
    [anon_sym_BANG_EQ] = ACTIONS(4320),
    [anon_sym_GT_EQ] = ACTIONS(4320),
    [anon_sym_LT_EQ] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(5948),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_switch] = ACTIONS(4320),
    [anon_sym_when] = ACTIONS(4320),
    [anon_sym_DOT_DOT] = ACTIONS(4320),
    [anon_sym_and] = ACTIONS(4320),
    [anon_sym_or] = ACTIONS(4320),
    [anon_sym_AMP_AMP] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(4320),
    [anon_sym_QMARK_QMARK] = ACTIONS(4320),
    [anon_sym_into] = ACTIONS(4320),
    [anon_sym_on] = ACTIONS(4320),
    [anon_sym_equals] = ACTIONS(4320),
    [anon_sym_by] = ACTIONS(4320),
    [anon_sym_as] = ACTIONS(4320),
    [anon_sym_is] = ACTIONS(4320),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [anon_sym_with] = ACTIONS(4320),
    [aux_sym_preproc_if_token3] = ACTIONS(4320),
    [aux_sym_preproc_else_token1] = ACTIONS(4320),
    [aux_sym_preproc_elif_token1] = ACTIONS(4320),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4071] = {
    [sym_preproc_region] = STATE(4071),
    [sym_preproc_endregion] = STATE(4071),
    [sym_preproc_line] = STATE(4071),
    [sym_preproc_pragma] = STATE(4071),
    [sym_preproc_nullable] = STATE(4071),
    [sym_preproc_error] = STATE(4071),
    [sym_preproc_define] = STATE(4071),
    [sym_preproc_undef] = STATE(4071),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_COLON] = ACTIONS(4320),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LT] = ACTIONS(5948),
    [anon_sym_GT] = ACTIONS(5948),
    [anon_sym_in] = ACTIONS(5948),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5948),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_SLASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(4320),
    [anon_sym_CARET] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(5948),
    [anon_sym_AMP] = ACTIONS(5948),
    [anon_sym_LT_LT] = ACTIONS(4320),
    [anon_sym_GT_GT] = ACTIONS(5948),
    [anon_sym_GT_GT_GT] = ACTIONS(4320),
    [anon_sym_EQ_EQ] = ACTIONS(4320),
    [anon_sym_BANG_EQ] = ACTIONS(4320),
    [anon_sym_GT_EQ] = ACTIONS(4320),
    [anon_sym_LT_EQ] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(5948),
    [anon_sym_EQ_GT] = ACTIONS(4320),
    [anon_sym_switch] = ACTIONS(4320),
    [anon_sym_when] = ACTIONS(4320),
    [anon_sym_DOT_DOT] = ACTIONS(4320),
    [anon_sym_and] = ACTIONS(4320),
    [anon_sym_or] = ACTIONS(4320),
    [anon_sym_AMP_AMP] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(4320),
    [anon_sym_QMARK_QMARK] = ACTIONS(4320),
    [anon_sym_into] = ACTIONS(4320),
    [anon_sym_on] = ACTIONS(4320),
    [anon_sym_equals] = ACTIONS(4320),
    [anon_sym_by] = ACTIONS(4320),
    [anon_sym_as] = ACTIONS(4320),
    [anon_sym_is] = ACTIONS(4320),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [anon_sym_with] = ACTIONS(4320),
    [aux_sym_preproc_if_token3] = ACTIONS(4320),
    [aux_sym_preproc_else_token1] = ACTIONS(4320),
    [aux_sym_preproc_elif_token1] = ACTIONS(4320),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4072] = {
    [sym_preproc_region] = STATE(4072),
    [sym_preproc_endregion] = STATE(4072),
    [sym_preproc_line] = STATE(4072),
    [sym_preproc_pragma] = STATE(4072),
    [sym_preproc_nullable] = STATE(4072),
    [sym_preproc_error] = STATE(4072),
    [sym_preproc_define] = STATE(4072),
    [sym_preproc_undef] = STATE(4072),
    [anon_sym_SEMI] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [anon_sym_COLON] = ACTIONS(5950),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_RBRACK] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_RBRACE] = ACTIONS(5950),
    [anon_sym_LT] = ACTIONS(5952),
    [anon_sym_GT] = ACTIONS(5952),
    [anon_sym_in] = ACTIONS(5952),
    [anon_sym_QMARK] = ACTIONS(5952),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_PLUS_PLUS] = ACTIONS(5950),
    [anon_sym_DASH_DASH] = ACTIONS(5950),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_STAR] = ACTIONS(5950),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5950),
    [anon_sym_CARET] = ACTIONS(5950),
    [anon_sym_PIPE] = ACTIONS(5952),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_LT_LT] = ACTIONS(5950),
    [anon_sym_GT_GT] = ACTIONS(5952),
    [anon_sym_GT_GT_GT] = ACTIONS(5950),
    [anon_sym_EQ_EQ] = ACTIONS(5950),
    [anon_sym_BANG_EQ] = ACTIONS(5950),
    [anon_sym_GT_EQ] = ACTIONS(5950),
    [anon_sym_LT_EQ] = ACTIONS(5950),
    [anon_sym_DOT] = ACTIONS(5952),
    [anon_sym_EQ_GT] = ACTIONS(5950),
    [anon_sym_switch] = ACTIONS(5950),
    [anon_sym_when] = ACTIONS(5950),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_and] = ACTIONS(5950),
    [anon_sym_or] = ACTIONS(5950),
    [anon_sym_AMP_AMP] = ACTIONS(5950),
    [anon_sym_PIPE_PIPE] = ACTIONS(5950),
    [anon_sym_QMARK_QMARK] = ACTIONS(5950),
    [anon_sym_into] = ACTIONS(5950),
    [anon_sym_on] = ACTIONS(5950),
    [anon_sym_equals] = ACTIONS(5950),
    [anon_sym_by] = ACTIONS(5950),
    [anon_sym_as] = ACTIONS(5950),
    [anon_sym_is] = ACTIONS(5950),
    [anon_sym_DASH_GT] = ACTIONS(5950),
    [anon_sym_with] = ACTIONS(5950),
    [aux_sym_preproc_if_token3] = ACTIONS(5950),
    [aux_sym_preproc_else_token1] = ACTIONS(5950),
    [aux_sym_preproc_elif_token1] = ACTIONS(5950),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4073] = {
    [sym_preproc_region] = STATE(4073),
    [sym_preproc_endregion] = STATE(4073),
    [sym_preproc_line] = STATE(4073),
    [sym_preproc_pragma] = STATE(4073),
    [sym_preproc_nullable] = STATE(4073),
    [sym_preproc_error] = STATE(4073),
    [sym_preproc_define] = STATE(4073),
    [sym_preproc_undef] = STATE(4073),
    [anon_sym_SEMI] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_LT] = ACTIONS(5956),
    [anon_sym_GT] = ACTIONS(5956),
    [anon_sym_in] = ACTIONS(5956),
    [anon_sym_QMARK] = ACTIONS(5956),
    [anon_sym_BANG] = ACTIONS(5956),
    [anon_sym_PLUS_PLUS] = ACTIONS(5954),
    [anon_sym_DASH_DASH] = ACTIONS(5954),
    [anon_sym_PLUS] = ACTIONS(5956),
    [anon_sym_DASH] = ACTIONS(5956),
    [anon_sym_STAR] = ACTIONS(5954),
    [anon_sym_SLASH] = ACTIONS(5956),
    [anon_sym_PERCENT] = ACTIONS(5954),
    [anon_sym_CARET] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5954),
    [anon_sym_GT_GT] = ACTIONS(5956),
    [anon_sym_GT_GT_GT] = ACTIONS(5954),
    [anon_sym_EQ_EQ] = ACTIONS(5954),
    [anon_sym_BANG_EQ] = ACTIONS(5954),
    [anon_sym_GT_EQ] = ACTIONS(5954),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5956),
    [anon_sym_EQ_GT] = ACTIONS(5954),
    [anon_sym_switch] = ACTIONS(5954),
    [anon_sym_when] = ACTIONS(5954),
    [anon_sym_DOT_DOT] = ACTIONS(5954),
    [anon_sym_and] = ACTIONS(5954),
    [anon_sym_or] = ACTIONS(5954),
    [anon_sym_AMP_AMP] = ACTIONS(5954),
    [anon_sym_PIPE_PIPE] = ACTIONS(5954),
    [anon_sym_QMARK_QMARK] = ACTIONS(5954),
    [anon_sym_into] = ACTIONS(5954),
    [anon_sym_on] = ACTIONS(5954),
    [anon_sym_equals] = ACTIONS(5954),
    [anon_sym_by] = ACTIONS(5954),
    [anon_sym_as] = ACTIONS(5954),
    [anon_sym_is] = ACTIONS(5954),
    [anon_sym_DASH_GT] = ACTIONS(5954),
    [anon_sym_with] = ACTIONS(5954),
    [aux_sym_preproc_if_token3] = ACTIONS(5954),
    [aux_sym_preproc_else_token1] = ACTIONS(5954),
    [aux_sym_preproc_elif_token1] = ACTIONS(5954),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4074] = {
    [sym_preproc_region] = STATE(4074),
    [sym_preproc_endregion] = STATE(4074),
    [sym_preproc_line] = STATE(4074),
    [sym_preproc_pragma] = STATE(4074),
    [sym_preproc_nullable] = STATE(4074),
    [sym_preproc_error] = STATE(4074),
    [sym_preproc_define] = STATE(4074),
    [sym_preproc_undef] = STATE(4074),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LPAREN] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_in] = ACTIONS(5458),
    [anon_sym_QMARK] = ACTIONS(5458),
    [anon_sym_BANG] = ACTIONS(5458),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5456),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_GT_GT_GT] = ACTIONS(5456),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_EQ_GT] = ACTIONS(5456),
    [anon_sym_switch] = ACTIONS(5456),
    [anon_sym_when] = ACTIONS(5456),
    [anon_sym_DOT_DOT] = ACTIONS(5456),
    [anon_sym_and] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_QMARK_QMARK] = ACTIONS(5456),
    [anon_sym_into] = ACTIONS(5456),
    [anon_sym_on] = ACTIONS(5456),
    [anon_sym_equals] = ACTIONS(5456),
    [anon_sym_by] = ACTIONS(5456),
    [anon_sym_as] = ACTIONS(5456),
    [anon_sym_is] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_with] = ACTIONS(5456),
    [aux_sym_preproc_if_token3] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4075] = {
    [sym_preproc_region] = STATE(4075),
    [sym_preproc_endregion] = STATE(4075),
    [sym_preproc_line] = STATE(4075),
    [sym_preproc_pragma] = STATE(4075),
    [sym_preproc_nullable] = STATE(4075),
    [sym_preproc_error] = STATE(4075),
    [sym_preproc_define] = STATE(4075),
    [sym_preproc_undef] = STATE(4075),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5960),
    [anon_sym_in] = ACTIONS(5960),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_BANG] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5960),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5960),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(5960),
    [anon_sym_AMP] = ACTIONS(5960),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5960),
    [anon_sym_GT_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_BANG_EQ] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5958),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_DOT] = ACTIONS(5960),
    [anon_sym_EQ_GT] = ACTIONS(5958),
    [anon_sym_switch] = ACTIONS(5958),
    [anon_sym_when] = ACTIONS(5958),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5958),
    [anon_sym_QMARK_QMARK] = ACTIONS(5958),
    [anon_sym_into] = ACTIONS(5958),
    [anon_sym_on] = ACTIONS(5958),
    [anon_sym_equals] = ACTIONS(5958),
    [anon_sym_by] = ACTIONS(5958),
    [anon_sym_as] = ACTIONS(5958),
    [anon_sym_is] = ACTIONS(5958),
    [anon_sym_DASH_GT] = ACTIONS(5958),
    [anon_sym_with] = ACTIONS(5958),
    [aux_sym_preproc_if_token3] = ACTIONS(5958),
    [aux_sym_preproc_else_token1] = ACTIONS(5958),
    [aux_sym_preproc_elif_token1] = ACTIONS(5958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4076] = {
    [sym_preproc_region] = STATE(4076),
    [sym_preproc_endregion] = STATE(4076),
    [sym_preproc_line] = STATE(4076),
    [sym_preproc_pragma] = STATE(4076),
    [sym_preproc_nullable] = STATE(4076),
    [sym_preproc_error] = STATE(4076),
    [sym_preproc_define] = STATE(4076),
    [sym_preproc_undef] = STATE(4076),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_in] = ACTIONS(5462),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_BANG] = ACTIONS(5462),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5460),
    [anon_sym_CARET] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5460),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_GT_GT_GT] = ACTIONS(5460),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_EQ_GT] = ACTIONS(5460),
    [anon_sym_switch] = ACTIONS(5460),
    [anon_sym_when] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5460),
    [anon_sym_and] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_QMARK_QMARK] = ACTIONS(5460),
    [anon_sym_into] = ACTIONS(5460),
    [anon_sym_on] = ACTIONS(5460),
    [anon_sym_equals] = ACTIONS(5460),
    [anon_sym_by] = ACTIONS(5460),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_is] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_with] = ACTIONS(5460),
    [aux_sym_preproc_if_token3] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4077] = {
    [sym_preproc_region] = STATE(4077),
    [sym_preproc_endregion] = STATE(4077),
    [sym_preproc_line] = STATE(4077),
    [sym_preproc_pragma] = STATE(4077),
    [sym_preproc_nullable] = STATE(4077),
    [sym_preproc_error] = STATE(4077),
    [sym_preproc_define] = STATE(4077),
    [sym_preproc_undef] = STATE(4077),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5474),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5472),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_GT_GT_GT] = ACTIONS(5472),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_EQ_GT] = ACTIONS(5472),
    [anon_sym_switch] = ACTIONS(5472),
    [anon_sym_when] = ACTIONS(5472),
    [anon_sym_DOT_DOT] = ACTIONS(5472),
    [anon_sym_and] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_QMARK_QMARK] = ACTIONS(5472),
    [anon_sym_into] = ACTIONS(5472),
    [anon_sym_on] = ACTIONS(5472),
    [anon_sym_equals] = ACTIONS(5472),
    [anon_sym_by] = ACTIONS(5472),
    [anon_sym_as] = ACTIONS(5472),
    [anon_sym_is] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_with] = ACTIONS(5472),
    [aux_sym_preproc_if_token3] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5472),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4078] = {
    [sym_preproc_region] = STATE(4078),
    [sym_preproc_endregion] = STATE(4078),
    [sym_preproc_line] = STATE(4078),
    [sym_preproc_pragma] = STATE(4078),
    [sym_preproc_nullable] = STATE(4078),
    [sym_preproc_error] = STATE(4078),
    [sym_preproc_define] = STATE(4078),
    [sym_preproc_undef] = STATE(4078),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_when] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_into] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4079] = {
    [sym_preproc_region] = STATE(4079),
    [sym_preproc_endregion] = STATE(4079),
    [sym_preproc_line] = STATE(4079),
    [sym_preproc_pragma] = STATE(4079),
    [sym_preproc_nullable] = STATE(4079),
    [sym_preproc_error] = STATE(4079),
    [sym_preproc_define] = STATE(4079),
    [sym_preproc_undef] = STATE(4079),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5516),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_when] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_into] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4080] = {
    [sym_preproc_region] = STATE(4080),
    [sym_preproc_endregion] = STATE(4080),
    [sym_preproc_line] = STATE(4080),
    [sym_preproc_pragma] = STATE(4080),
    [sym_preproc_nullable] = STATE(4080),
    [sym_preproc_error] = STATE(4080),
    [sym_preproc_define] = STATE(4080),
    [sym_preproc_undef] = STATE(4080),
    [anon_sym_SEMI] = ACTIONS(5431),
    [anon_sym_LBRACK] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5431),
    [anon_sym_COMMA] = ACTIONS(5431),
    [anon_sym_RBRACK] = ACTIONS(5431),
    [anon_sym_LPAREN] = ACTIONS(5431),
    [anon_sym_RPAREN] = ACTIONS(5431),
    [anon_sym_RBRACE] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5433),
    [anon_sym_in] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_BANG] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5433),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5433),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_PIPE] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5433),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_GT_GT_GT] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5431),
    [anon_sym_BANG_EQ] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5431),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_DOT] = ACTIONS(5433),
    [anon_sym_EQ_GT] = ACTIONS(5431),
    [anon_sym_switch] = ACTIONS(5431),
    [anon_sym_when] = ACTIONS(5431),
    [anon_sym_DOT_DOT] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_AMP_AMP] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5431),
    [anon_sym_QMARK_QMARK] = ACTIONS(5431),
    [anon_sym_into] = ACTIONS(5431),
    [anon_sym_on] = ACTIONS(5431),
    [anon_sym_equals] = ACTIONS(5431),
    [anon_sym_by] = ACTIONS(5431),
    [anon_sym_as] = ACTIONS(5431),
    [anon_sym_is] = ACTIONS(5431),
    [anon_sym_DASH_GT] = ACTIONS(5431),
    [anon_sym_with] = ACTIONS(5431),
    [aux_sym_preproc_if_token3] = ACTIONS(5431),
    [aux_sym_preproc_else_token1] = ACTIONS(5431),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4081] = {
    [sym_preproc_region] = STATE(4081),
    [sym_preproc_endregion] = STATE(4081),
    [sym_preproc_line] = STATE(4081),
    [sym_preproc_pragma] = STATE(4081),
    [sym_preproc_nullable] = STATE(4081),
    [sym_preproc_error] = STATE(4081),
    [sym_preproc_define] = STATE(4081),
    [sym_preproc_undef] = STATE(4081),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4082] = {
    [sym_preproc_region] = STATE(4082),
    [sym_preproc_endregion] = STATE(4082),
    [sym_preproc_line] = STATE(4082),
    [sym_preproc_pragma] = STATE(4082),
    [sym_preproc_nullable] = STATE(4082),
    [sym_preproc_error] = STATE(4082),
    [sym_preproc_define] = STATE(4082),
    [sym_preproc_undef] = STATE(4082),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COMMA] = ACTIONS(5399),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [anon_sym_RPAREN] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5401),
    [anon_sym_in] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5401),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5401),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5401),
    [anon_sym_GT_GT_GT] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5399),
    [anon_sym_BANG_EQ] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5399),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_DOT] = ACTIONS(5401),
    [anon_sym_EQ_GT] = ACTIONS(5399),
    [anon_sym_switch] = ACTIONS(5399),
    [anon_sym_when] = ACTIONS(5399),
    [anon_sym_DOT_DOT] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_or] = ACTIONS(5399),
    [anon_sym_AMP_AMP] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5399),
    [anon_sym_QMARK_QMARK] = ACTIONS(5399),
    [anon_sym_into] = ACTIONS(5399),
    [anon_sym_on] = ACTIONS(5399),
    [anon_sym_equals] = ACTIONS(5399),
    [anon_sym_by] = ACTIONS(5399),
    [anon_sym_as] = ACTIONS(5399),
    [anon_sym_is] = ACTIONS(5399),
    [anon_sym_DASH_GT] = ACTIONS(5399),
    [anon_sym_with] = ACTIONS(5399),
    [aux_sym_preproc_if_token3] = ACTIONS(5399),
    [aux_sym_preproc_else_token1] = ACTIONS(5399),
    [aux_sym_preproc_elif_token1] = ACTIONS(5399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4083] = {
    [sym_preproc_region] = STATE(4083),
    [sym_preproc_endregion] = STATE(4083),
    [sym_preproc_line] = STATE(4083),
    [sym_preproc_pragma] = STATE(4083),
    [sym_preproc_nullable] = STATE(4083),
    [sym_preproc_error] = STATE(4083),
    [sym_preproc_define] = STATE(4083),
    [sym_preproc_undef] = STATE(4083),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_into] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4084] = {
    [sym_preproc_region] = STATE(4084),
    [sym_preproc_endregion] = STATE(4084),
    [sym_preproc_line] = STATE(4084),
    [sym_preproc_pragma] = STATE(4084),
    [sym_preproc_nullable] = STATE(4084),
    [sym_preproc_error] = STATE(4084),
    [sym_preproc_define] = STATE(4084),
    [sym_preproc_undef] = STATE(4084),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(5962),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_class] = ACTIONS(4040),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_struct] = ACTIONS(4040),
    [anon_sym_enum] = ACTIONS(4040),
    [anon_sym_interface] = ACTIONS(4040),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_record] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4085] = {
    [sym_preproc_region] = STATE(4085),
    [sym_preproc_endregion] = STATE(4085),
    [sym_preproc_line] = STATE(4085),
    [sym_preproc_pragma] = STATE(4085),
    [sym_preproc_nullable] = STATE(4085),
    [sym_preproc_error] = STATE(4085),
    [sym_preproc_define] = STATE(4085),
    [sym_preproc_undef] = STATE(4085),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5524),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_into] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4086] = {
    [sym_preproc_region] = STATE(4086),
    [sym_preproc_endregion] = STATE(4086),
    [sym_preproc_line] = STATE(4086),
    [sym_preproc_pragma] = STATE(4086),
    [sym_preproc_nullable] = STATE(4086),
    [sym_preproc_error] = STATE(4086),
    [sym_preproc_define] = STATE(4086),
    [sym_preproc_undef] = STATE(4086),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_COMMA] = ACTIONS(5530),
    [anon_sym_RBRACK] = ACTIONS(5530),
    [anon_sym_LPAREN] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5532),
    [anon_sym_QMARK] = ACTIONS(5532),
    [anon_sym_BANG] = ACTIONS(5532),
    [anon_sym_PLUS_PLUS] = ACTIONS(5530),
    [anon_sym_DASH_DASH] = ACTIONS(5530),
    [anon_sym_PLUS] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_SLASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_CARET] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_GT_GT_GT] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5530),
    [anon_sym_BANG_EQ] = ACTIONS(5530),
    [anon_sym_GT_EQ] = ACTIONS(5530),
    [anon_sym_LT_EQ] = ACTIONS(5530),
    [anon_sym_DOT] = ACTIONS(5532),
    [anon_sym_EQ_GT] = ACTIONS(5530),
    [anon_sym_switch] = ACTIONS(5530),
    [anon_sym_when] = ACTIONS(5530),
    [anon_sym_DOT_DOT] = ACTIONS(5530),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_or] = ACTIONS(5530),
    [anon_sym_AMP_AMP] = ACTIONS(5530),
    [anon_sym_PIPE_PIPE] = ACTIONS(5530),
    [anon_sym_QMARK_QMARK] = ACTIONS(5530),
    [anon_sym_into] = ACTIONS(5530),
    [anon_sym_on] = ACTIONS(5530),
    [anon_sym_equals] = ACTIONS(5530),
    [anon_sym_by] = ACTIONS(5530),
    [anon_sym_as] = ACTIONS(5530),
    [anon_sym_is] = ACTIONS(5530),
    [anon_sym_DASH_GT] = ACTIONS(5530),
    [anon_sym_with] = ACTIONS(5530),
    [aux_sym_preproc_if_token3] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4087] = {
    [sym_preproc_region] = STATE(4087),
    [sym_preproc_endregion] = STATE(4087),
    [sym_preproc_line] = STATE(4087),
    [sym_preproc_pragma] = STATE(4087),
    [sym_preproc_nullable] = STATE(4087),
    [sym_preproc_error] = STATE(4087),
    [sym_preproc_define] = STATE(4087),
    [sym_preproc_undef] = STATE(4087),
    [anon_sym_SEMI] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_COLON] = ACTIONS(5411),
    [anon_sym_COMMA] = ACTIONS(5411),
    [anon_sym_RBRACK] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5411),
    [anon_sym_RPAREN] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_LT] = ACTIONS(5413),
    [anon_sym_GT] = ACTIONS(5413),
    [anon_sym_in] = ACTIONS(5413),
    [anon_sym_QMARK] = ACTIONS(5413),
    [anon_sym_BANG] = ACTIONS(5413),
    [anon_sym_PLUS_PLUS] = ACTIONS(5411),
    [anon_sym_DASH_DASH] = ACTIONS(5411),
    [anon_sym_PLUS] = ACTIONS(5413),
    [anon_sym_DASH] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_SLASH] = ACTIONS(5413),
    [anon_sym_PERCENT] = ACTIONS(5411),
    [anon_sym_CARET] = ACTIONS(5411),
    [anon_sym_PIPE] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5413),
    [anon_sym_LT_LT] = ACTIONS(5411),
    [anon_sym_GT_GT] = ACTIONS(5413),
    [anon_sym_GT_GT_GT] = ACTIONS(5411),
    [anon_sym_EQ_EQ] = ACTIONS(5411),
    [anon_sym_BANG_EQ] = ACTIONS(5411),
    [anon_sym_GT_EQ] = ACTIONS(5411),
    [anon_sym_LT_EQ] = ACTIONS(5411),
    [anon_sym_DOT] = ACTIONS(5413),
    [anon_sym_EQ_GT] = ACTIONS(5411),
    [anon_sym_switch] = ACTIONS(5411),
    [anon_sym_when] = ACTIONS(5411),
    [anon_sym_DOT_DOT] = ACTIONS(5411),
    [anon_sym_and] = ACTIONS(5411),
    [anon_sym_or] = ACTIONS(5411),
    [anon_sym_AMP_AMP] = ACTIONS(5411),
    [anon_sym_PIPE_PIPE] = ACTIONS(5411),
    [anon_sym_QMARK_QMARK] = ACTIONS(5411),
    [anon_sym_into] = ACTIONS(5411),
    [anon_sym_on] = ACTIONS(5411),
    [anon_sym_equals] = ACTIONS(5411),
    [anon_sym_by] = ACTIONS(5411),
    [anon_sym_as] = ACTIONS(5411),
    [anon_sym_is] = ACTIONS(5411),
    [anon_sym_DASH_GT] = ACTIONS(5411),
    [anon_sym_with] = ACTIONS(5411),
    [aux_sym_preproc_if_token3] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4088] = {
    [sym_preproc_region] = STATE(4088),
    [sym_preproc_endregion] = STATE(4088),
    [sym_preproc_line] = STATE(4088),
    [sym_preproc_pragma] = STATE(4088),
    [sym_preproc_nullable] = STATE(4088),
    [sym_preproc_error] = STATE(4088),
    [sym_preproc_define] = STATE(4088),
    [sym_preproc_undef] = STATE(4088),
    [anon_sym_SEMI] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_RBRACK] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5562),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5562),
    [anon_sym_DASH_DASH] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_CARET] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_GT_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5562),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_GT_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5562),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5562),
    [anon_sym_switch] = ACTIONS(5562),
    [anon_sym_when] = ACTIONS(5562),
    [anon_sym_DOT_DOT] = ACTIONS(5562),
    [anon_sym_and] = ACTIONS(5562),
    [anon_sym_or] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_QMARK_QMARK] = ACTIONS(5562),
    [anon_sym_into] = ACTIONS(5562),
    [anon_sym_on] = ACTIONS(5562),
    [anon_sym_equals] = ACTIONS(5562),
    [anon_sym_by] = ACTIONS(5562),
    [anon_sym_as] = ACTIONS(5562),
    [anon_sym_is] = ACTIONS(5562),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_with] = ACTIONS(5562),
    [aux_sym_preproc_if_token3] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4089] = {
    [sym_preproc_region] = STATE(4089),
    [sym_preproc_endregion] = STATE(4089),
    [sym_preproc_line] = STATE(4089),
    [sym_preproc_pragma] = STATE(4089),
    [sym_preproc_nullable] = STATE(4089),
    [sym_preproc_error] = STATE(4089),
    [sym_preproc_define] = STATE(4089),
    [sym_preproc_undef] = STATE(4089),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4090] = {
    [sym_preproc_region] = STATE(4090),
    [sym_preproc_endregion] = STATE(4090),
    [sym_preproc_line] = STATE(4090),
    [sym_preproc_pragma] = STATE(4090),
    [sym_preproc_nullable] = STATE(4090),
    [sym_preproc_error] = STATE(4090),
    [sym_preproc_define] = STATE(4090),
    [sym_preproc_undef] = STATE(4090),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_COLON] = ACTIONS(1965),
    [anon_sym_COMMA] = ACTIONS(1965),
    [anon_sym_RBRACK] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(5964),
    [anon_sym_RPAREN] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [anon_sym_in] = ACTIONS(1965),
    [anon_sym_QMARK] = ACTIONS(1963),
    [anon_sym_BANG] = ACTIONS(1963),
    [anon_sym_PLUS_PLUS] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1963),
    [anon_sym_PERCENT] = ACTIONS(1965),
    [anon_sym_CARET] = ACTIONS(1965),
    [anon_sym_PIPE] = ACTIONS(1963),
    [anon_sym_AMP] = ACTIONS(1963),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_GT_GT] = ACTIONS(1963),
    [anon_sym_GT_GT_GT] = ACTIONS(1965),
    [anon_sym_EQ_EQ] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_EQ_GT] = ACTIONS(1965),
    [anon_sym_switch] = ACTIONS(1965),
    [anon_sym_when] = ACTIONS(1965),
    [anon_sym_DOT_DOT] = ACTIONS(1965),
    [anon_sym_and] = ACTIONS(1965),
    [anon_sym_or] = ACTIONS(1965),
    [anon_sym_AMP_AMP] = ACTIONS(1965),
    [anon_sym_PIPE_PIPE] = ACTIONS(1965),
    [anon_sym_QMARK_QMARK] = ACTIONS(1965),
    [anon_sym_on] = ACTIONS(1965),
    [anon_sym_equals] = ACTIONS(1965),
    [anon_sym_by] = ACTIONS(1965),
    [anon_sym_as] = ACTIONS(1965),
    [anon_sym_is] = ACTIONS(1965),
    [anon_sym_DASH_GT] = ACTIONS(1965),
    [anon_sym_with] = ACTIONS(1965),
    [aux_sym_preproc_if_token3] = ACTIONS(1965),
    [aux_sym_preproc_else_token1] = ACTIONS(1965),
    [aux_sym_preproc_elif_token1] = ACTIONS(1965),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4091] = {
    [sym_preproc_region] = STATE(4091),
    [sym_preproc_endregion] = STATE(4091),
    [sym_preproc_line] = STATE(4091),
    [sym_preproc_pragma] = STATE(4091),
    [sym_preproc_nullable] = STATE(4091),
    [sym_preproc_error] = STATE(4091),
    [sym_preproc_define] = STATE(4091),
    [sym_preproc_undef] = STATE(4091),
    [anon_sym_SEMI] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_COMMA] = ACTIONS(5399),
    [anon_sym_RBRACK] = ACTIONS(5399),
    [anon_sym_LPAREN] = ACTIONS(5399),
    [anon_sym_RPAREN] = ACTIONS(5399),
    [anon_sym_RBRACE] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5401),
    [anon_sym_in] = ACTIONS(5399),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_BANG] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5401),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5401),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_PIPE] = ACTIONS(5401),
    [anon_sym_AMP] = ACTIONS(5401),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5401),
    [anon_sym_GT_GT_GT] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5399),
    [anon_sym_BANG_EQ] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5399),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_DOT] = ACTIONS(5401),
    [anon_sym_EQ_GT] = ACTIONS(5399),
    [anon_sym_switch] = ACTIONS(5399),
    [anon_sym_when] = ACTIONS(5399),
    [anon_sym_DOT_DOT] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_or] = ACTIONS(5399),
    [anon_sym_AMP_AMP] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5399),
    [anon_sym_QMARK_QMARK] = ACTIONS(5399),
    [anon_sym_on] = ACTIONS(5399),
    [anon_sym_equals] = ACTIONS(5399),
    [anon_sym_by] = ACTIONS(5399),
    [anon_sym_as] = ACTIONS(5399),
    [anon_sym_is] = ACTIONS(5399),
    [anon_sym_DASH_GT] = ACTIONS(5399),
    [anon_sym_with] = ACTIONS(5399),
    [aux_sym_preproc_if_token3] = ACTIONS(5399),
    [aux_sym_preproc_else_token1] = ACTIONS(5399),
    [aux_sym_preproc_elif_token1] = ACTIONS(5399),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4092] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7149),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9313),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4092),
    [sym_preproc_endregion] = STATE(4092),
    [sym_preproc_line] = STATE(4092),
    [sym_preproc_pragma] = STATE(4092),
    [sym_preproc_nullable] = STATE(4092),
    [sym_preproc_error] = STATE(4092),
    [sym_preproc_define] = STATE(4092),
    [sym_preproc_undef] = STATE(4092),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4093] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7148),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9315),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4093),
    [sym_preproc_endregion] = STATE(4093),
    [sym_preproc_line] = STATE(4093),
    [sym_preproc_pragma] = STATE(4093),
    [sym_preproc_nullable] = STATE(4093),
    [sym_preproc_error] = STATE(4093),
    [sym_preproc_define] = STATE(4093),
    [sym_preproc_undef] = STATE(4093),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4094] = {
    [sym_preproc_region] = STATE(4094),
    [sym_preproc_endregion] = STATE(4094),
    [sym_preproc_line] = STATE(4094),
    [sym_preproc_pragma] = STATE(4094),
    [sym_preproc_nullable] = STATE(4094),
    [sym_preproc_error] = STATE(4094),
    [sym_preproc_define] = STATE(4094),
    [sym_preproc_undef] = STATE(4094),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4095] = {
    [sym_preproc_region] = STATE(4095),
    [sym_preproc_endregion] = STATE(4095),
    [sym_preproc_line] = STATE(4095),
    [sym_preproc_pragma] = STATE(4095),
    [sym_preproc_nullable] = STATE(4095),
    [sym_preproc_error] = STATE(4095),
    [sym_preproc_define] = STATE(4095),
    [sym_preproc_undef] = STATE(4095),
    [anon_sym_SEMI] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_COLON] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(3042),
    [anon_sym_RBRACK] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(3042),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_in] = ACTIONS(3042),
    [anon_sym_QMARK] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3042),
    [anon_sym_CARET] = ACTIONS(3042),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_LT_LT] = ACTIONS(3042),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3042),
    [anon_sym_EQ_EQ] = ACTIONS(3042),
    [anon_sym_BANG_EQ] = ACTIONS(3042),
    [anon_sym_GT_EQ] = ACTIONS(3042),
    [anon_sym_LT_EQ] = ACTIONS(3042),
    [anon_sym_DOT] = ACTIONS(3040),
    [anon_sym_EQ_GT] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_when] = ACTIONS(3042),
    [anon_sym_DOT_DOT] = ACTIONS(3042),
    [anon_sym_and] = ACTIONS(3042),
    [anon_sym_or] = ACTIONS(3042),
    [anon_sym_AMP_AMP] = ACTIONS(3042),
    [anon_sym_PIPE_PIPE] = ACTIONS(3042),
    [anon_sym_QMARK_QMARK] = ACTIONS(3042),
    [anon_sym_on] = ACTIONS(3042),
    [anon_sym_equals] = ACTIONS(3042),
    [anon_sym_by] = ACTIONS(3042),
    [anon_sym_as] = ACTIONS(3042),
    [anon_sym_is] = ACTIONS(3042),
    [anon_sym_DASH_GT] = ACTIONS(3042),
    [anon_sym_with] = ACTIONS(3042),
    [aux_sym_preproc_if_token3] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4096] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7146),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9332),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4096),
    [sym_preproc_endregion] = STATE(4096),
    [sym_preproc_line] = STATE(4096),
    [sym_preproc_pragma] = STATE(4096),
    [sym_preproc_nullable] = STATE(4096),
    [sym_preproc_error] = STATE(4096),
    [sym_preproc_define] = STATE(4096),
    [sym_preproc_undef] = STATE(4096),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4097] = {
    [sym_preproc_region] = STATE(4097),
    [sym_preproc_endregion] = STATE(4097),
    [sym_preproc_line] = STATE(4097),
    [sym_preproc_pragma] = STATE(4097),
    [sym_preproc_nullable] = STATE(4097),
    [sym_preproc_error] = STATE(4097),
    [sym_preproc_define] = STATE(4097),
    [sym_preproc_undef] = STATE(4097),
    [anon_sym_SEMI] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5514),
    [anon_sym_COMMA] = ACTIONS(5514),
    [anon_sym_RBRACK] = ACTIONS(5514),
    [anon_sym_LPAREN] = ACTIONS(5514),
    [anon_sym_RPAREN] = ACTIONS(5514),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5516),
    [anon_sym_in] = ACTIONS(5514),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_BANG] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_PIPE] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5516),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_GT_GT_GT] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5514),
    [anon_sym_BANG_EQ] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5514),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(5516),
    [anon_sym_EQ_GT] = ACTIONS(5514),
    [anon_sym_switch] = ACTIONS(5514),
    [anon_sym_when] = ACTIONS(5514),
    [anon_sym_DOT_DOT] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_AMP_AMP] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5514),
    [anon_sym_QMARK_QMARK] = ACTIONS(5514),
    [anon_sym_on] = ACTIONS(5514),
    [anon_sym_equals] = ACTIONS(5514),
    [anon_sym_by] = ACTIONS(5514),
    [anon_sym_as] = ACTIONS(5514),
    [anon_sym_is] = ACTIONS(5514),
    [anon_sym_DASH_GT] = ACTIONS(5514),
    [anon_sym_with] = ACTIONS(5514),
    [aux_sym_preproc_if_token3] = ACTIONS(5514),
    [aux_sym_preproc_else_token1] = ACTIONS(5514),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4098] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7145),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9343),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4098),
    [sym_preproc_endregion] = STATE(4098),
    [sym_preproc_line] = STATE(4098),
    [sym_preproc_pragma] = STATE(4098),
    [sym_preproc_nullable] = STATE(4098),
    [sym_preproc_error] = STATE(4098),
    [sym_preproc_define] = STATE(4098),
    [sym_preproc_undef] = STATE(4098),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4099] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6951),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9927),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4099),
    [sym_preproc_endregion] = STATE(4099),
    [sym_preproc_line] = STATE(4099),
    [sym_preproc_pragma] = STATE(4099),
    [sym_preproc_nullable] = STATE(4099),
    [sym_preproc_error] = STATE(4099),
    [sym_preproc_define] = STATE(4099),
    [sym_preproc_undef] = STATE(4099),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4100] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7141),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9368),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4100),
    [sym_preproc_endregion] = STATE(4100),
    [sym_preproc_line] = STATE(4100),
    [sym_preproc_pragma] = STATE(4100),
    [sym_preproc_nullable] = STATE(4100),
    [sym_preproc_error] = STATE(4100),
    [sym_preproc_define] = STATE(4100),
    [sym_preproc_undef] = STATE(4100),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4101] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7114),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9563),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4101),
    [sym_preproc_endregion] = STATE(4101),
    [sym_preproc_line] = STATE(4101),
    [sym_preproc_pragma] = STATE(4101),
    [sym_preproc_nullable] = STATE(4101),
    [sym_preproc_error] = STATE(4101),
    [sym_preproc_define] = STATE(4101),
    [sym_preproc_undef] = STATE(4101),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4102] = {
    [sym_preproc_region] = STATE(4102),
    [sym_preproc_endregion] = STATE(4102),
    [sym_preproc_line] = STATE(4102),
    [sym_preproc_pragma] = STATE(4102),
    [sym_preproc_nullable] = STATE(4102),
    [sym_preproc_error] = STATE(4102),
    [sym_preproc_define] = STATE(4102),
    [sym_preproc_undef] = STATE(4102),
    [anon_sym_SEMI] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5864),
    [anon_sym_COLON] = ACTIONS(5864),
    [anon_sym_COMMA] = ACTIONS(5864),
    [anon_sym_RBRACK] = ACTIONS(5864),
    [anon_sym_LPAREN] = ACTIONS(5864),
    [anon_sym_RPAREN] = ACTIONS(5864),
    [anon_sym_RBRACE] = ACTIONS(5864),
    [anon_sym_LT] = ACTIONS(5866),
    [anon_sym_GT] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5864),
    [anon_sym_QMARK] = ACTIONS(5866),
    [anon_sym_BANG] = ACTIONS(5866),
    [anon_sym_PLUS_PLUS] = ACTIONS(5864),
    [anon_sym_DASH_DASH] = ACTIONS(5864),
    [anon_sym_PLUS] = ACTIONS(5866),
    [anon_sym_DASH] = ACTIONS(5866),
    [anon_sym_STAR] = ACTIONS(5864),
    [anon_sym_SLASH] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5864),
    [anon_sym_CARET] = ACTIONS(5864),
    [anon_sym_PIPE] = ACTIONS(5866),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5864),
    [anon_sym_GT_GT] = ACTIONS(5866),
    [anon_sym_GT_GT_GT] = ACTIONS(5864),
    [anon_sym_EQ_EQ] = ACTIONS(5864),
    [anon_sym_BANG_EQ] = ACTIONS(5864),
    [anon_sym_GT_EQ] = ACTIONS(5864),
    [anon_sym_LT_EQ] = ACTIONS(5864),
    [anon_sym_DOT] = ACTIONS(5866),
    [anon_sym_EQ_GT] = ACTIONS(5864),
    [anon_sym_switch] = ACTIONS(5864),
    [anon_sym_when] = ACTIONS(5864),
    [anon_sym_DOT_DOT] = ACTIONS(5864),
    [anon_sym_and] = ACTIONS(5864),
    [anon_sym_or] = ACTIONS(5864),
    [anon_sym_AMP_AMP] = ACTIONS(5864),
    [anon_sym_PIPE_PIPE] = ACTIONS(5864),
    [anon_sym_QMARK_QMARK] = ACTIONS(5864),
    [anon_sym_on] = ACTIONS(5864),
    [anon_sym_equals] = ACTIONS(5864),
    [anon_sym_by] = ACTIONS(5864),
    [anon_sym_as] = ACTIONS(5864),
    [anon_sym_is] = ACTIONS(5864),
    [anon_sym_DASH_GT] = ACTIONS(5864),
    [anon_sym_with] = ACTIONS(5864),
    [aux_sym_preproc_if_token3] = ACTIONS(5864),
    [aux_sym_preproc_else_token1] = ACTIONS(5864),
    [aux_sym_preproc_elif_token1] = ACTIONS(5864),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4103] = {
    [sym_preproc_region] = STATE(4103),
    [sym_preproc_endregion] = STATE(4103),
    [sym_preproc_line] = STATE(4103),
    [sym_preproc_pragma] = STATE(4103),
    [sym_preproc_nullable] = STATE(4103),
    [sym_preproc_error] = STATE(4103),
    [sym_preproc_define] = STATE(4103),
    [sym_preproc_undef] = STATE(4103),
    [anon_sym_SEMI] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COMMA] = ACTIONS(5510),
    [anon_sym_RBRACK] = ACTIONS(5510),
    [anon_sym_LPAREN] = ACTIONS(5510),
    [anon_sym_RPAREN] = ACTIONS(5510),
    [anon_sym_RBRACE] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5512),
    [anon_sym_in] = ACTIONS(5510),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_BANG] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5512),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5512),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_PIPE] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5512),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_GT_GT_GT] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5510),
    [anon_sym_BANG_EQ] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5510),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(5512),
    [anon_sym_EQ_GT] = ACTIONS(5510),
    [anon_sym_switch] = ACTIONS(5510),
    [anon_sym_when] = ACTIONS(5510),
    [anon_sym_DOT_DOT] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_AMP_AMP] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5510),
    [anon_sym_QMARK_QMARK] = ACTIONS(5510),
    [anon_sym_on] = ACTIONS(5510),
    [anon_sym_equals] = ACTIONS(5510),
    [anon_sym_by] = ACTIONS(5510),
    [anon_sym_as] = ACTIONS(5510),
    [anon_sym_is] = ACTIONS(5510),
    [anon_sym_DASH_GT] = ACTIONS(5510),
    [anon_sym_with] = ACTIONS(5510),
    [aux_sym_preproc_if_token3] = ACTIONS(5510),
    [aux_sym_preproc_else_token1] = ACTIONS(5510),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4104] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7140),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9371),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4104),
    [sym_preproc_endregion] = STATE(4104),
    [sym_preproc_line] = STATE(4104),
    [sym_preproc_pragma] = STATE(4104),
    [sym_preproc_nullable] = STATE(4104),
    [sym_preproc_error] = STATE(4104),
    [sym_preproc_define] = STATE(4104),
    [sym_preproc_undef] = STATE(4104),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4105] = {
    [sym_preproc_region] = STATE(4105),
    [sym_preproc_endregion] = STATE(4105),
    [sym_preproc_line] = STATE(4105),
    [sym_preproc_pragma] = STATE(4105),
    [sym_preproc_nullable] = STATE(4105),
    [sym_preproc_error] = STATE(4105),
    [sym_preproc_define] = STATE(4105),
    [sym_preproc_undef] = STATE(4105),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_COLON] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5474),
    [anon_sym_BANG] = ACTIONS(5474),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5472),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_GT_GT_GT] = ACTIONS(5472),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_EQ_GT] = ACTIONS(5472),
    [anon_sym_switch] = ACTIONS(5472),
    [anon_sym_when] = ACTIONS(5472),
    [anon_sym_DOT_DOT] = ACTIONS(5472),
    [anon_sym_and] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_QMARK_QMARK] = ACTIONS(5472),
    [anon_sym_on] = ACTIONS(5472),
    [anon_sym_equals] = ACTIONS(5472),
    [anon_sym_by] = ACTIONS(5472),
    [anon_sym_as] = ACTIONS(5472),
    [anon_sym_is] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_with] = ACTIONS(5472),
    [aux_sym_preproc_if_token3] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5472),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4106] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6992),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9398),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4106),
    [sym_preproc_endregion] = STATE(4106),
    [sym_preproc_line] = STATE(4106),
    [sym_preproc_pragma] = STATE(4106),
    [sym_preproc_nullable] = STATE(4106),
    [sym_preproc_error] = STATE(4106),
    [sym_preproc_define] = STATE(4106),
    [sym_preproc_undef] = STATE(4106),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4107] = {
    [sym_preproc_region] = STATE(4107),
    [sym_preproc_endregion] = STATE(4107),
    [sym_preproc_line] = STATE(4107),
    [sym_preproc_pragma] = STATE(4107),
    [sym_preproc_nullable] = STATE(4107),
    [sym_preproc_error] = STATE(4107),
    [sym_preproc_define] = STATE(4107),
    [sym_preproc_undef] = STATE(4107),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_LPAREN] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5862),
    [anon_sym_BANG] = ACTIONS(5862),
    [anon_sym_PLUS_PLUS] = ACTIONS(5860),
    [anon_sym_DASH_DASH] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5862),
    [anon_sym_STAR] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_GT_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5860),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_switch] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_QMARK_QMARK] = ACTIONS(5860),
    [anon_sym_on] = ACTIONS(5860),
    [anon_sym_equals] = ACTIONS(5860),
    [anon_sym_by] = ACTIONS(5860),
    [anon_sym_as] = ACTIONS(5860),
    [anon_sym_is] = ACTIONS(5860),
    [anon_sym_DASH_GT] = ACTIONS(5860),
    [anon_sym_with] = ACTIONS(5860),
    [aux_sym_preproc_if_token3] = ACTIONS(5860),
    [aux_sym_preproc_else_token1] = ACTIONS(5860),
    [aux_sym_preproc_elif_token1] = ACTIONS(5860),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4108] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7153),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9304),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4108),
    [sym_preproc_endregion] = STATE(4108),
    [sym_preproc_line] = STATE(4108),
    [sym_preproc_pragma] = STATE(4108),
    [sym_preproc_nullable] = STATE(4108),
    [sym_preproc_error] = STATE(4108),
    [sym_preproc_define] = STATE(4108),
    [sym_preproc_undef] = STATE(4108),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4109] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9090),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4109),
    [sym_preproc_endregion] = STATE(4109),
    [sym_preproc_line] = STATE(4109),
    [sym_preproc_pragma] = STATE(4109),
    [sym_preproc_nullable] = STATE(4109),
    [sym_preproc_error] = STATE(4109),
    [sym_preproc_define] = STATE(4109),
    [sym_preproc_undef] = STATE(4109),
    [aux_sym_function_pointer_type_repeat1] = STATE(4317),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4110] = {
    [sym_preproc_region] = STATE(4110),
    [sym_preproc_endregion] = STATE(4110),
    [sym_preproc_line] = STATE(4110),
    [sym_preproc_pragma] = STATE(4110),
    [sym_preproc_nullable] = STATE(4110),
    [sym_preproc_error] = STATE(4110),
    [sym_preproc_define] = STATE(4110),
    [sym_preproc_undef] = STATE(4110),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_RBRACK] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_RPAREN] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5588),
    [anon_sym_BANG] = ACTIONS(5588),
    [anon_sym_PLUS_PLUS] = ACTIONS(5586),
    [anon_sym_DASH_DASH] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5586),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5586),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5586),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_GT_GT_GT] = ACTIONS(5586),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_EQ_GT] = ACTIONS(5586),
    [anon_sym_switch] = ACTIONS(5586),
    [anon_sym_when] = ACTIONS(5586),
    [anon_sym_DOT_DOT] = ACTIONS(5586),
    [anon_sym_and] = ACTIONS(5586),
    [anon_sym_or] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE] = ACTIONS(5586),
    [anon_sym_QMARK_QMARK] = ACTIONS(5586),
    [anon_sym_on] = ACTIONS(5586),
    [anon_sym_equals] = ACTIONS(5586),
    [anon_sym_by] = ACTIONS(5586),
    [anon_sym_as] = ACTIONS(5586),
    [anon_sym_is] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_with] = ACTIONS(5586),
    [aux_sym_preproc_if_token3] = ACTIONS(5586),
    [aux_sym_preproc_else_token1] = ACTIONS(5586),
    [aux_sym_preproc_elif_token1] = ACTIONS(5586),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4111] = {
    [sym_preproc_region] = STATE(4111),
    [sym_preproc_endregion] = STATE(4111),
    [sym_preproc_line] = STATE(4111),
    [sym_preproc_pragma] = STATE(4111),
    [sym_preproc_nullable] = STATE(4111),
    [sym_preproc_error] = STATE(4111),
    [sym_preproc_define] = STATE(4111),
    [sym_preproc_undef] = STATE(4111),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym_LBRACK] = ACTIONS(5460),
    [anon_sym_COLON] = ACTIONS(5460),
    [anon_sym_COMMA] = ACTIONS(5460),
    [anon_sym_RBRACK] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(5460),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LT] = ACTIONS(5462),
    [anon_sym_GT] = ACTIONS(5462),
    [anon_sym_in] = ACTIONS(5460),
    [anon_sym_QMARK] = ACTIONS(5462),
    [anon_sym_BANG] = ACTIONS(5462),
    [anon_sym_PLUS_PLUS] = ACTIONS(5460),
    [anon_sym_DASH_DASH] = ACTIONS(5460),
    [anon_sym_PLUS] = ACTIONS(5462),
    [anon_sym_DASH] = ACTIONS(5462),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_SLASH] = ACTIONS(5462),
    [anon_sym_PERCENT] = ACTIONS(5460),
    [anon_sym_CARET] = ACTIONS(5460),
    [anon_sym_PIPE] = ACTIONS(5462),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_LT_LT] = ACTIONS(5460),
    [anon_sym_GT_GT] = ACTIONS(5462),
    [anon_sym_GT_GT_GT] = ACTIONS(5460),
    [anon_sym_EQ_EQ] = ACTIONS(5460),
    [anon_sym_BANG_EQ] = ACTIONS(5460),
    [anon_sym_GT_EQ] = ACTIONS(5460),
    [anon_sym_LT_EQ] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(5462),
    [anon_sym_EQ_GT] = ACTIONS(5460),
    [anon_sym_switch] = ACTIONS(5460),
    [anon_sym_when] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5460),
    [anon_sym_and] = ACTIONS(5460),
    [anon_sym_or] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_PIPE_PIPE] = ACTIONS(5460),
    [anon_sym_QMARK_QMARK] = ACTIONS(5460),
    [anon_sym_on] = ACTIONS(5460),
    [anon_sym_equals] = ACTIONS(5460),
    [anon_sym_by] = ACTIONS(5460),
    [anon_sym_as] = ACTIONS(5460),
    [anon_sym_is] = ACTIONS(5460),
    [anon_sym_DASH_GT] = ACTIONS(5460),
    [anon_sym_with] = ACTIONS(5460),
    [aux_sym_preproc_if_token3] = ACTIONS(5460),
    [aux_sym_preproc_else_token1] = ACTIONS(5460),
    [aux_sym_preproc_elif_token1] = ACTIONS(5460),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4112] = {
    [sym_type_parameter_constraint] = STATE(7837),
    [sym_constructor_constraint] = STATE(8132),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8128),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4112),
    [sym_preproc_endregion] = STATE(4112),
    [sym_preproc_line] = STATE(4112),
    [sym_preproc_pragma] = STATE(4112),
    [sym_preproc_nullable] = STATE(4112),
    [sym_preproc_error] = STATE(4112),
    [sym_preproc_define] = STATE(4112),
    [sym_preproc_undef] = STATE(4112),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(5982),
    [anon_sym_ref] = ACTIONS(5984),
    [anon_sym_struct] = ACTIONS(5986),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_new] = ACTIONS(5988),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(5990),
    [anon_sym_unmanaged] = ACTIONS(5990),
    [anon_sym_scoped] = ACTIONS(5992),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4113] = {
    [sym_preproc_region] = STATE(4113),
    [sym_preproc_endregion] = STATE(4113),
    [sym_preproc_line] = STATE(4113),
    [sym_preproc_pragma] = STATE(4113),
    [sym_preproc_nullable] = STATE(4113),
    [sym_preproc_error] = STATE(4113),
    [sym_preproc_define] = STATE(4113),
    [sym_preproc_undef] = STATE(4113),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LPAREN] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_in] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5458),
    [anon_sym_BANG] = ACTIONS(5458),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5456),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_GT_GT_GT] = ACTIONS(5456),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_EQ_GT] = ACTIONS(5456),
    [anon_sym_switch] = ACTIONS(5456),
    [anon_sym_when] = ACTIONS(5456),
    [anon_sym_DOT_DOT] = ACTIONS(5456),
    [anon_sym_and] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_QMARK_QMARK] = ACTIONS(5456),
    [anon_sym_on] = ACTIONS(5456),
    [anon_sym_equals] = ACTIONS(5456),
    [anon_sym_by] = ACTIONS(5456),
    [anon_sym_as] = ACTIONS(5456),
    [anon_sym_is] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_with] = ACTIONS(5456),
    [aux_sym_preproc_if_token3] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5456),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4114] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7157),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9293),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4114),
    [sym_preproc_endregion] = STATE(4114),
    [sym_preproc_line] = STATE(4114),
    [sym_preproc_pragma] = STATE(4114),
    [sym_preproc_nullable] = STATE(4114),
    [sym_preproc_error] = STATE(4114),
    [sym_preproc_define] = STATE(4114),
    [sym_preproc_undef] = STATE(4114),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4115] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7102),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9266),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4115),
    [sym_preproc_endregion] = STATE(4115),
    [sym_preproc_line] = STATE(4115),
    [sym_preproc_pragma] = STATE(4115),
    [sym_preproc_nullable] = STATE(4115),
    [sym_preproc_error] = STATE(4115),
    [sym_preproc_define] = STATE(4115),
    [sym_preproc_undef] = STATE(4115),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4116] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6965),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9147),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4116),
    [sym_preproc_endregion] = STATE(4116),
    [sym_preproc_line] = STATE(4116),
    [sym_preproc_pragma] = STATE(4116),
    [sym_preproc_nullable] = STATE(4116),
    [sym_preproc_error] = STATE(4116),
    [sym_preproc_define] = STATE(4116),
    [sym_preproc_undef] = STATE(4116),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5996),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4117] = {
    [sym_type_parameter_constraint] = STATE(8143),
    [sym_constructor_constraint] = STATE(8132),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8128),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4117),
    [sym_preproc_endregion] = STATE(4117),
    [sym_preproc_line] = STATE(4117),
    [sym_preproc_pragma] = STATE(4117),
    [sym_preproc_nullable] = STATE(4117),
    [sym_preproc_error] = STATE(4117),
    [sym_preproc_define] = STATE(4117),
    [sym_preproc_undef] = STATE(4117),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_class] = ACTIONS(5982),
    [anon_sym_ref] = ACTIONS(5984),
    [anon_sym_struct] = ACTIONS(5986),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_new] = ACTIONS(5988),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(5990),
    [anon_sym_unmanaged] = ACTIONS(5990),
    [anon_sym_scoped] = ACTIONS(5992),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4118] = {
    [sym_preproc_region] = STATE(4118),
    [sym_preproc_endregion] = STATE(4118),
    [sym_preproc_line] = STATE(4118),
    [sym_preproc_pragma] = STATE(4118),
    [sym_preproc_nullable] = STATE(4118),
    [sym_preproc_error] = STATE(4118),
    [sym_preproc_define] = STATE(4118),
    [sym_preproc_undef] = STATE(4118),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5596),
    [anon_sym_COMMA] = ACTIONS(5596),
    [anon_sym_RBRACK] = ACTIONS(5596),
    [anon_sym_LPAREN] = ACTIONS(5596),
    [anon_sym_RPAREN] = ACTIONS(5596),
    [anon_sym_RBRACE] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5596),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_BANG] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5598),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_PIPE] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_GT_GT_GT] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5596),
    [anon_sym_BANG_EQ] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5596),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_DOT] = ACTIONS(5598),
    [anon_sym_EQ_GT] = ACTIONS(5596),
    [anon_sym_switch] = ACTIONS(5596),
    [anon_sym_when] = ACTIONS(5596),
    [anon_sym_DOT_DOT] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_AMP_AMP] = ACTIONS(5596),
    [anon_sym_PIPE_PIPE] = ACTIONS(5596),
    [anon_sym_QMARK_QMARK] = ACTIONS(5596),
    [anon_sym_on] = ACTIONS(5596),
    [anon_sym_equals] = ACTIONS(5596),
    [anon_sym_by] = ACTIONS(5596),
    [anon_sym_as] = ACTIONS(5596),
    [anon_sym_is] = ACTIONS(5596),
    [anon_sym_DASH_GT] = ACTIONS(5596),
    [anon_sym_with] = ACTIONS(5596),
    [aux_sym_preproc_if_token3] = ACTIONS(5596),
    [aux_sym_preproc_else_token1] = ACTIONS(5596),
    [aux_sym_preproc_elif_token1] = ACTIONS(5596),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4119] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9845),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4119),
    [sym_preproc_endregion] = STATE(4119),
    [sym_preproc_line] = STATE(4119),
    [sym_preproc_pragma] = STATE(4119),
    [sym_preproc_nullable] = STATE(4119),
    [sym_preproc_error] = STATE(4119),
    [sym_preproc_define] = STATE(4119),
    [sym_preproc_undef] = STATE(4119),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4120] = {
    [sym_preproc_region] = STATE(4120),
    [sym_preproc_endregion] = STATE(4120),
    [sym_preproc_line] = STATE(4120),
    [sym_preproc_pragma] = STATE(4120),
    [sym_preproc_nullable] = STATE(4120),
    [sym_preproc_error] = STATE(4120),
    [sym_preproc_define] = STATE(4120),
    [sym_preproc_undef] = STATE(4120),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_in] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5568),
    [anon_sym_BANG] = ACTIONS(5568),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_GT_GT_GT] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_EQ_GT] = ACTIONS(5566),
    [anon_sym_switch] = ACTIONS(5566),
    [anon_sym_when] = ACTIONS(5566),
    [anon_sym_DOT_DOT] = ACTIONS(5566),
    [anon_sym_and] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_QMARK_QMARK] = ACTIONS(5566),
    [anon_sym_on] = ACTIONS(5566),
    [anon_sym_equals] = ACTIONS(5566),
    [anon_sym_by] = ACTIONS(5566),
    [anon_sym_as] = ACTIONS(5566),
    [anon_sym_is] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [anon_sym_with] = ACTIONS(5566),
    [aux_sym_preproc_if_token3] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5566),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4121] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7100),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9532),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4121),
    [sym_preproc_endregion] = STATE(4121),
    [sym_preproc_line] = STATE(4121),
    [sym_preproc_pragma] = STATE(4121),
    [sym_preproc_nullable] = STATE(4121),
    [sym_preproc_error] = STATE(4121),
    [sym_preproc_define] = STATE(4121),
    [sym_preproc_undef] = STATE(4121),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4122] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7103),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9257),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4122),
    [sym_preproc_endregion] = STATE(4122),
    [sym_preproc_line] = STATE(4122),
    [sym_preproc_pragma] = STATE(4122),
    [sym_preproc_nullable] = STATE(4122),
    [sym_preproc_error] = STATE(4122),
    [sym_preproc_define] = STATE(4122),
    [sym_preproc_undef] = STATE(4122),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4123] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6961),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9080),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4123),
    [sym_preproc_endregion] = STATE(4123),
    [sym_preproc_line] = STATE(4123),
    [sym_preproc_pragma] = STATE(4123),
    [sym_preproc_nullable] = STATE(4123),
    [sym_preproc_error] = STATE(4123),
    [sym_preproc_define] = STATE(4123),
    [sym_preproc_undef] = STATE(4123),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4124] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9069),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4124),
    [sym_preproc_endregion] = STATE(4124),
    [sym_preproc_line] = STATE(4124),
    [sym_preproc_pragma] = STATE(4124),
    [sym_preproc_nullable] = STATE(4124),
    [sym_preproc_error] = STATE(4124),
    [sym_preproc_define] = STATE(4124),
    [sym_preproc_undef] = STATE(4124),
    [aux_sym_function_pointer_type_repeat1] = STATE(4126),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4125] = {
    [sym_preproc_region] = STATE(4125),
    [sym_preproc_endregion] = STATE(4125),
    [sym_preproc_line] = STATE(4125),
    [sym_preproc_pragma] = STATE(4125),
    [sym_preproc_nullable] = STATE(4125),
    [sym_preproc_error] = STATE(4125),
    [sym_preproc_define] = STATE(4125),
    [sym_preproc_undef] = STATE(4125),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COMMA] = ACTIONS(5600),
    [anon_sym_RBRACK] = ACTIONS(5600),
    [anon_sym_LPAREN] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5602),
    [anon_sym_in] = ACTIONS(5600),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_BANG] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_SLASH] = ACTIONS(5602),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_GT_GT_GT] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5600),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_DOT] = ACTIONS(5602),
    [anon_sym_EQ_GT] = ACTIONS(5600),
    [anon_sym_switch] = ACTIONS(5600),
    [anon_sym_when] = ACTIONS(5600),
    [anon_sym_DOT_DOT] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE] = ACTIONS(5600),
    [anon_sym_QMARK_QMARK] = ACTIONS(5600),
    [anon_sym_on] = ACTIONS(5600),
    [anon_sym_equals] = ACTIONS(5600),
    [anon_sym_by] = ACTIONS(5600),
    [anon_sym_as] = ACTIONS(5600),
    [anon_sym_is] = ACTIONS(5600),
    [anon_sym_DASH_GT] = ACTIONS(5600),
    [anon_sym_with] = ACTIONS(5600),
    [aux_sym_preproc_if_token3] = ACTIONS(5600),
    [aux_sym_preproc_else_token1] = ACTIONS(5600),
    [aux_sym_preproc_elif_token1] = ACTIONS(5600),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4126] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9040),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4126),
    [sym_preproc_endregion] = STATE(4126),
    [sym_preproc_line] = STATE(4126),
    [sym_preproc_pragma] = STATE(4126),
    [sym_preproc_nullable] = STATE(4126),
    [sym_preproc_error] = STATE(4126),
    [sym_preproc_define] = STATE(4126),
    [sym_preproc_undef] = STATE(4126),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4127] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9040),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4127),
    [sym_preproc_endregion] = STATE(4127),
    [sym_preproc_line] = STATE(4127),
    [sym_preproc_pragma] = STATE(4127),
    [sym_preproc_nullable] = STATE(4127),
    [sym_preproc_error] = STATE(4127),
    [sym_preproc_define] = STATE(4127),
    [sym_preproc_undef] = STATE(4127),
    [aux_sym_function_pointer_type_repeat1] = STATE(4130),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4128] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7120),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9238),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4128),
    [sym_preproc_endregion] = STATE(4128),
    [sym_preproc_line] = STATE(4128),
    [sym_preproc_pragma] = STATE(4128),
    [sym_preproc_nullable] = STATE(4128),
    [sym_preproc_error] = STATE(4128),
    [sym_preproc_define] = STATE(4128),
    [sym_preproc_undef] = STATE(4128),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4129] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6978),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9169),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4129),
    [sym_preproc_endregion] = STATE(4129),
    [sym_preproc_line] = STATE(4129),
    [sym_preproc_pragma] = STATE(4129),
    [sym_preproc_nullable] = STATE(4129),
    [sym_preproc_error] = STATE(4129),
    [sym_preproc_define] = STATE(4129),
    [sym_preproc_undef] = STATE(4129),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4130] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9024),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4130),
    [sym_preproc_endregion] = STATE(4130),
    [sym_preproc_line] = STATE(4130),
    [sym_preproc_pragma] = STATE(4130),
    [sym_preproc_nullable] = STATE(4130),
    [sym_preproc_error] = STATE(4130),
    [sym_preproc_define] = STATE(4130),
    [sym_preproc_undef] = STATE(4130),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4131] = {
    [sym_preproc_region] = STATE(4131),
    [sym_preproc_endregion] = STATE(4131),
    [sym_preproc_line] = STATE(4131),
    [sym_preproc_pragma] = STATE(4131),
    [sym_preproc_nullable] = STATE(4131),
    [sym_preproc_error] = STATE(4131),
    [sym_preproc_define] = STATE(4131),
    [sym_preproc_undef] = STATE(4131),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2991),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2991),
    [anon_sym_CARET] = ACTIONS(2991),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2991),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_GT_GT_GT] = ACTIONS(2991),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_when] = ACTIONS(2991),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_and] = ACTIONS(2991),
    [anon_sym_or] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2991),
    [anon_sym_on] = ACTIONS(2991),
    [anon_sym_equals] = ACTIONS(2991),
    [anon_sym_by] = ACTIONS(2991),
    [anon_sym_as] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2991),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [aux_sym_preproc_if_token3] = ACTIONS(2991),
    [aux_sym_preproc_else_token1] = ACTIONS(2991),
    [aux_sym_preproc_elif_token1] = ACTIONS(2991),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4132] = {
    [sym_preproc_region] = STATE(4132),
    [sym_preproc_endregion] = STATE(4132),
    [sym_preproc_line] = STATE(4132),
    [sym_preproc_pragma] = STATE(4132),
    [sym_preproc_nullable] = STATE(4132),
    [sym_preproc_error] = STATE(4132),
    [sym_preproc_define] = STATE(4132),
    [sym_preproc_undef] = STATE(4132),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_COLON] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_RBRACK] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5450),
    [anon_sym_BANG] = ACTIONS(5450),
    [anon_sym_PLUS_PLUS] = ACTIONS(5448),
    [anon_sym_DASH_DASH] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(5450),
    [anon_sym_PERCENT] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5448),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5448),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_GT_GT_GT] = ACTIONS(5448),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_EQ_GT] = ACTIONS(5448),
    [anon_sym_switch] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_DOT_DOT] = ACTIONS(5448),
    [anon_sym_and] = ACTIONS(5448),
    [anon_sym_or] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE] = ACTIONS(5448),
    [anon_sym_QMARK_QMARK] = ACTIONS(5448),
    [anon_sym_on] = ACTIONS(5448),
    [anon_sym_equals] = ACTIONS(5448),
    [anon_sym_by] = ACTIONS(5448),
    [anon_sym_as] = ACTIONS(5448),
    [anon_sym_is] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_with] = ACTIONS(5448),
    [aux_sym_preproc_if_token3] = ACTIONS(5448),
    [aux_sym_preproc_else_token1] = ACTIONS(5448),
    [aux_sym_preproc_elif_token1] = ACTIONS(5448),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4133] = {
    [sym_preproc_region] = STATE(4133),
    [sym_preproc_endregion] = STATE(4133),
    [sym_preproc_line] = STATE(4133),
    [sym_preproc_pragma] = STATE(4133),
    [sym_preproc_nullable] = STATE(4133),
    [sym_preproc_error] = STATE(4133),
    [sym_preproc_define] = STATE(4133),
    [sym_preproc_undef] = STATE(4133),
    [anon_sym_EQ] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6000),
    [anon_sym_DASH_EQ] = ACTIONS(6000),
    [anon_sym_STAR_EQ] = ACTIONS(6000),
    [anon_sym_SLASH_EQ] = ACTIONS(6000),
    [anon_sym_PERCENT_EQ] = ACTIONS(6000),
    [anon_sym_AMP_EQ] = ACTIONS(6000),
    [anon_sym_CARET_EQ] = ACTIONS(6000),
    [anon_sym_PIPE_EQ] = ACTIONS(6000),
    [anon_sym_LT_LT_EQ] = ACTIONS(6000),
    [anon_sym_GT_GT_EQ] = ACTIONS(6000),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6000),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6000),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4134] = {
    [sym_preproc_region] = STATE(4134),
    [sym_preproc_endregion] = STATE(4134),
    [sym_preproc_line] = STATE(4134),
    [sym_preproc_pragma] = STATE(4134),
    [sym_preproc_nullable] = STATE(4134),
    [sym_preproc_error] = STATE(4134),
    [sym_preproc_define] = STATE(4134),
    [sym_preproc_undef] = STATE(4134),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_LPAREN] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_in] = ACTIONS(5620),
    [anon_sym_QMARK] = ACTIONS(5622),
    [anon_sym_BANG] = ACTIONS(5622),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_GT_GT] = ACTIONS(5622),
    [anon_sym_GT_GT_GT] = ACTIONS(5620),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_EQ_GT] = ACTIONS(5620),
    [anon_sym_switch] = ACTIONS(5620),
    [anon_sym_when] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5620),
    [anon_sym_and] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_QMARK_QMARK] = ACTIONS(5620),
    [anon_sym_on] = ACTIONS(5620),
    [anon_sym_equals] = ACTIONS(5620),
    [anon_sym_by] = ACTIONS(5620),
    [anon_sym_as] = ACTIONS(5620),
    [anon_sym_is] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [anon_sym_with] = ACTIONS(5620),
    [aux_sym_preproc_if_token3] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5620),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4135] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7131),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9501),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4135),
    [sym_preproc_endregion] = STATE(4135),
    [sym_preproc_line] = STATE(4135),
    [sym_preproc_pragma] = STATE(4135),
    [sym_preproc_nullable] = STATE(4135),
    [sym_preproc_error] = STATE(4135),
    [sym_preproc_define] = STATE(4135),
    [sym_preproc_undef] = STATE(4135),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4136] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7121),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9136),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4136),
    [sym_preproc_endregion] = STATE(4136),
    [sym_preproc_line] = STATE(4136),
    [sym_preproc_pragma] = STATE(4136),
    [sym_preproc_nullable] = STATE(4136),
    [sym_preproc_error] = STATE(4136),
    [sym_preproc_define] = STATE(4136),
    [sym_preproc_undef] = STATE(4136),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4137] = {
    [sym_preproc_region] = STATE(4137),
    [sym_preproc_endregion] = STATE(4137),
    [sym_preproc_line] = STATE(4137),
    [sym_preproc_pragma] = STATE(4137),
    [sym_preproc_nullable] = STATE(4137),
    [sym_preproc_error] = STATE(4137),
    [sym_preproc_define] = STATE(4137),
    [sym_preproc_undef] = STATE(4137),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_COLON] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_STAR] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2987),
    [anon_sym_CARET] = ACTIONS(2987),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2987),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_GT_GT_GT] = ACTIONS(2987),
    [anon_sym_EQ_EQ] = ACTIONS(2987),
    [anon_sym_BANG_EQ] = ACTIONS(2987),
    [anon_sym_GT_EQ] = ACTIONS(2987),
    [anon_sym_LT_EQ] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_when] = ACTIONS(2987),
    [anon_sym_DOT_DOT] = ACTIONS(2987),
    [anon_sym_and] = ACTIONS(2987),
    [anon_sym_or] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_QMARK_QMARK] = ACTIONS(2987),
    [anon_sym_on] = ACTIONS(2987),
    [anon_sym_equals] = ACTIONS(2987),
    [anon_sym_by] = ACTIONS(2987),
    [anon_sym_as] = ACTIONS(2987),
    [anon_sym_is] = ACTIONS(2987),
    [anon_sym_DASH_GT] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [aux_sym_preproc_if_token3] = ACTIONS(2987),
    [aux_sym_preproc_else_token1] = ACTIONS(2987),
    [aux_sym_preproc_elif_token1] = ACTIONS(2987),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4138] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7134),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9216),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4138),
    [sym_preproc_endregion] = STATE(4138),
    [sym_preproc_line] = STATE(4138),
    [sym_preproc_pragma] = STATE(4138),
    [sym_preproc_nullable] = STATE(4138),
    [sym_preproc_error] = STATE(4138),
    [sym_preproc_define] = STATE(4138),
    [sym_preproc_undef] = STATE(4138),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4139] = {
    [sym_preproc_region] = STATE(4139),
    [sym_preproc_endregion] = STATE(4139),
    [sym_preproc_line] = STATE(4139),
    [sym_preproc_pragma] = STATE(4139),
    [sym_preproc_nullable] = STATE(4139),
    [sym_preproc_error] = STATE(4139),
    [sym_preproc_define] = STATE(4139),
    [sym_preproc_undef] = STATE(4139),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_in] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5626),
    [anon_sym_BANG] = ACTIONS(5626),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_CARET] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5624),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_GT_GT_GT] = ACTIONS(5624),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_EQ_GT] = ACTIONS(5624),
    [anon_sym_switch] = ACTIONS(5624),
    [anon_sym_when] = ACTIONS(5624),
    [anon_sym_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_QMARK_QMARK] = ACTIONS(5624),
    [anon_sym_on] = ACTIONS(5624),
    [anon_sym_equals] = ACTIONS(5624),
    [anon_sym_by] = ACTIONS(5624),
    [anon_sym_as] = ACTIONS(5624),
    [anon_sym_is] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [anon_sym_with] = ACTIONS(5624),
    [aux_sym_preproc_if_token3] = ACTIONS(5624),
    [aux_sym_preproc_else_token1] = ACTIONS(5624),
    [aux_sym_preproc_elif_token1] = ACTIONS(5624),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4140] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7122),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9681),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4140),
    [sym_preproc_endregion] = STATE(4140),
    [sym_preproc_line] = STATE(4140),
    [sym_preproc_pragma] = STATE(4140),
    [sym_preproc_nullable] = STATE(4140),
    [sym_preproc_error] = STATE(4140),
    [sym_preproc_define] = STATE(4140),
    [sym_preproc_undef] = STATE(4140),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4141] = {
    [sym_preproc_region] = STATE(4141),
    [sym_preproc_endregion] = STATE(4141),
    [sym_preproc_line] = STATE(4141),
    [sym_preproc_pragma] = STATE(4141),
    [sym_preproc_nullable] = STATE(4141),
    [sym_preproc_error] = STATE(4141),
    [sym_preproc_define] = STATE(4141),
    [sym_preproc_undef] = STATE(4141),
    [anon_sym_EQ] = ACTIONS(6002),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6004),
    [anon_sym_DASH_EQ] = ACTIONS(6004),
    [anon_sym_STAR_EQ] = ACTIONS(6004),
    [anon_sym_SLASH_EQ] = ACTIONS(6004),
    [anon_sym_PERCENT_EQ] = ACTIONS(6004),
    [anon_sym_AMP_EQ] = ACTIONS(6004),
    [anon_sym_CARET_EQ] = ACTIONS(6004),
    [anon_sym_PIPE_EQ] = ACTIONS(6004),
    [anon_sym_LT_LT_EQ] = ACTIONS(6004),
    [anon_sym_GT_GT_EQ] = ACTIONS(6004),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6004),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6004),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4142] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7129),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9499),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4142),
    [sym_preproc_endregion] = STATE(4142),
    [sym_preproc_line] = STATE(4142),
    [sym_preproc_pragma] = STATE(4142),
    [sym_preproc_nullable] = STATE(4142),
    [sym_preproc_error] = STATE(4142),
    [sym_preproc_define] = STATE(4142),
    [sym_preproc_undef] = STATE(4142),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4143] = {
    [sym_preproc_region] = STATE(4143),
    [sym_preproc_endregion] = STATE(4143),
    [sym_preproc_line] = STATE(4143),
    [sym_preproc_pragma] = STATE(4143),
    [sym_preproc_nullable] = STATE(4143),
    [sym_preproc_error] = STATE(4143),
    [sym_preproc_define] = STATE(4143),
    [sym_preproc_undef] = STATE(4143),
    [anon_sym_SEMI] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_COLON] = ACTIONS(5423),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_RBRACK] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(5423),
    [anon_sym_RPAREN] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(5425),
    [anon_sym_GT] = ACTIONS(5425),
    [anon_sym_in] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(5425),
    [anon_sym_BANG] = ACTIONS(5425),
    [anon_sym_PLUS_PLUS] = ACTIONS(5423),
    [anon_sym_DASH_DASH] = ACTIONS(5423),
    [anon_sym_PLUS] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5423),
    [anon_sym_SLASH] = ACTIONS(5425),
    [anon_sym_PERCENT] = ACTIONS(5423),
    [anon_sym_CARET] = ACTIONS(5423),
    [anon_sym_PIPE] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5425),
    [anon_sym_LT_LT] = ACTIONS(5423),
    [anon_sym_GT_GT] = ACTIONS(5425),
    [anon_sym_GT_GT_GT] = ACTIONS(5423),
    [anon_sym_EQ_EQ] = ACTIONS(5423),
    [anon_sym_BANG_EQ] = ACTIONS(5423),
    [anon_sym_GT_EQ] = ACTIONS(5423),
    [anon_sym_LT_EQ] = ACTIONS(5423),
    [anon_sym_DOT] = ACTIONS(5425),
    [anon_sym_EQ_GT] = ACTIONS(5423),
    [anon_sym_switch] = ACTIONS(5423),
    [anon_sym_when] = ACTIONS(5423),
    [anon_sym_DOT_DOT] = ACTIONS(5423),
    [anon_sym_and] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5423),
    [anon_sym_AMP_AMP] = ACTIONS(5423),
    [anon_sym_PIPE_PIPE] = ACTIONS(5423),
    [anon_sym_QMARK_QMARK] = ACTIONS(5423),
    [anon_sym_on] = ACTIONS(5423),
    [anon_sym_equals] = ACTIONS(5423),
    [anon_sym_by] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(5423),
    [anon_sym_is] = ACTIONS(5423),
    [anon_sym_DASH_GT] = ACTIONS(5423),
    [anon_sym_with] = ACTIONS(5423),
    [aux_sym_preproc_if_token3] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4144] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7123),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9386),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4144),
    [sym_preproc_endregion] = STATE(4144),
    [sym_preproc_line] = STATE(4144),
    [sym_preproc_pragma] = STATE(4144),
    [sym_preproc_nullable] = STATE(4144),
    [sym_preproc_error] = STATE(4144),
    [sym_preproc_define] = STATE(4144),
    [sym_preproc_undef] = STATE(4144),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4145] = {
    [sym_preproc_region] = STATE(4145),
    [sym_preproc_endregion] = STATE(4145),
    [sym_preproc_line] = STATE(4145),
    [sym_preproc_pragma] = STATE(4145),
    [sym_preproc_nullable] = STATE(4145),
    [sym_preproc_error] = STATE(4145),
    [sym_preproc_define] = STATE(4145),
    [sym_preproc_undef] = STATE(4145),
    [anon_sym_SEMI] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_COMMA] = ACTIONS(5582),
    [anon_sym_RBRACK] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5582),
    [anon_sym_RPAREN] = ACTIONS(5582),
    [anon_sym_RBRACE] = ACTIONS(5582),
    [anon_sym_LT] = ACTIONS(5584),
    [anon_sym_GT] = ACTIONS(5584),
    [anon_sym_in] = ACTIONS(5582),
    [anon_sym_QMARK] = ACTIONS(5584),
    [anon_sym_BANG] = ACTIONS(5584),
    [anon_sym_PLUS_PLUS] = ACTIONS(5582),
    [anon_sym_DASH_DASH] = ACTIONS(5582),
    [anon_sym_PLUS] = ACTIONS(5584),
    [anon_sym_DASH] = ACTIONS(5584),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_CARET] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5584),
    [anon_sym_AMP] = ACTIONS(5584),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5584),
    [anon_sym_GT_GT_GT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5582),
    [anon_sym_BANG_EQ] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5582),
    [anon_sym_LT_EQ] = ACTIONS(5582),
    [anon_sym_DOT] = ACTIONS(5584),
    [anon_sym_EQ_GT] = ACTIONS(5582),
    [anon_sym_switch] = ACTIONS(5582),
    [anon_sym_when] = ACTIONS(5582),
    [anon_sym_DOT_DOT] = ACTIONS(5582),
    [anon_sym_and] = ACTIONS(5582),
    [anon_sym_or] = ACTIONS(5582),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_QMARK_QMARK] = ACTIONS(5582),
    [anon_sym_on] = ACTIONS(5582),
    [anon_sym_equals] = ACTIONS(5582),
    [anon_sym_by] = ACTIONS(5582),
    [anon_sym_as] = ACTIONS(5582),
    [anon_sym_is] = ACTIONS(5582),
    [anon_sym_DASH_GT] = ACTIONS(5582),
    [anon_sym_with] = ACTIONS(5582),
    [aux_sym_preproc_if_token3] = ACTIONS(5582),
    [aux_sym_preproc_else_token1] = ACTIONS(5582),
    [aux_sym_preproc_elif_token1] = ACTIONS(5582),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4146] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9699),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4146),
    [sym_preproc_endregion] = STATE(4146),
    [sym_preproc_line] = STATE(4146),
    [sym_preproc_pragma] = STATE(4146),
    [sym_preproc_nullable] = STATE(4146),
    [sym_preproc_error] = STATE(4146),
    [sym_preproc_define] = STATE(4146),
    [sym_preproc_undef] = STATE(4146),
    [aux_sym_function_pointer_type_repeat1] = STATE(4199),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4147] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7119),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9391),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4147),
    [sym_preproc_endregion] = STATE(4147),
    [sym_preproc_line] = STATE(4147),
    [sym_preproc_pragma] = STATE(4147),
    [sym_preproc_nullable] = STATE(4147),
    [sym_preproc_error] = STATE(4147),
    [sym_preproc_define] = STATE(4147),
    [sym_preproc_undef] = STATE(4147),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4148] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7136),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9156),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4148),
    [sym_preproc_endregion] = STATE(4148),
    [sym_preproc_line] = STATE(4148),
    [sym_preproc_pragma] = STATE(4148),
    [sym_preproc_nullable] = STATE(4148),
    [sym_preproc_error] = STATE(4148),
    [sym_preproc_define] = STATE(4148),
    [sym_preproc_undef] = STATE(4148),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4149] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7115),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9486),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4149),
    [sym_preproc_endregion] = STATE(4149),
    [sym_preproc_line] = STATE(4149),
    [sym_preproc_pragma] = STATE(4149),
    [sym_preproc_nullable] = STATE(4149),
    [sym_preproc_error] = STATE(4149),
    [sym_preproc_define] = STATE(4149),
    [sym_preproc_undef] = STATE(4149),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5996),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4150] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7023),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9118),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4150),
    [sym_preproc_endregion] = STATE(4150),
    [sym_preproc_line] = STATE(4150),
    [sym_preproc_pragma] = STATE(4150),
    [sym_preproc_nullable] = STATE(4150),
    [sym_preproc_error] = STATE(4150),
    [sym_preproc_define] = STATE(4150),
    [sym_preproc_undef] = STATE(4150),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4151] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7107),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9491),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4151),
    [sym_preproc_endregion] = STATE(4151),
    [sym_preproc_line] = STATE(4151),
    [sym_preproc_pragma] = STATE(4151),
    [sym_preproc_nullable] = STATE(4151),
    [sym_preproc_error] = STATE(4151),
    [sym_preproc_define] = STATE(4151),
    [sym_preproc_undef] = STATE(4151),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4152] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7156),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9110),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4152),
    [sym_preproc_endregion] = STATE(4152),
    [sym_preproc_line] = STATE(4152),
    [sym_preproc_pragma] = STATE(4152),
    [sym_preproc_nullable] = STATE(4152),
    [sym_preproc_error] = STATE(4152),
    [sym_preproc_define] = STATE(4152),
    [sym_preproc_undef] = STATE(4152),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4153] = {
    [sym_preproc_region] = STATE(4153),
    [sym_preproc_endregion] = STATE(4153),
    [sym_preproc_line] = STATE(4153),
    [sym_preproc_pragma] = STATE(4153),
    [sym_preproc_nullable] = STATE(4153),
    [sym_preproc_error] = STATE(4153),
    [sym_preproc_define] = STATE(4153),
    [sym_preproc_undef] = STATE(4153),
    [anon_sym_SEMI] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_COLON] = ACTIONS(5407),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACK] = ACTIONS(5407),
    [anon_sym_LPAREN] = ACTIONS(5407),
    [anon_sym_RPAREN] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_LT] = ACTIONS(5409),
    [anon_sym_GT] = ACTIONS(5409),
    [anon_sym_in] = ACTIONS(5407),
    [anon_sym_QMARK] = ACTIONS(5409),
    [anon_sym_BANG] = ACTIONS(5409),
    [anon_sym_PLUS_PLUS] = ACTIONS(5407),
    [anon_sym_DASH_DASH] = ACTIONS(5407),
    [anon_sym_PLUS] = ACTIONS(5409),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5407),
    [anon_sym_SLASH] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5407),
    [anon_sym_CARET] = ACTIONS(5407),
    [anon_sym_PIPE] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5409),
    [anon_sym_LT_LT] = ACTIONS(5407),
    [anon_sym_GT_GT] = ACTIONS(5409),
    [anon_sym_GT_GT_GT] = ACTIONS(5407),
    [anon_sym_EQ_EQ] = ACTIONS(5407),
    [anon_sym_BANG_EQ] = ACTIONS(5407),
    [anon_sym_GT_EQ] = ACTIONS(5407),
    [anon_sym_LT_EQ] = ACTIONS(5407),
    [anon_sym_DOT] = ACTIONS(5409),
    [anon_sym_EQ_GT] = ACTIONS(5407),
    [anon_sym_switch] = ACTIONS(5407),
    [anon_sym_when] = ACTIONS(5407),
    [anon_sym_DOT_DOT] = ACTIONS(5407),
    [anon_sym_and] = ACTIONS(5407),
    [anon_sym_or] = ACTIONS(5407),
    [anon_sym_AMP_AMP] = ACTIONS(5407),
    [anon_sym_PIPE_PIPE] = ACTIONS(5407),
    [anon_sym_QMARK_QMARK] = ACTIONS(5407),
    [anon_sym_on] = ACTIONS(5407),
    [anon_sym_equals] = ACTIONS(5407),
    [anon_sym_by] = ACTIONS(5407),
    [anon_sym_as] = ACTIONS(5407),
    [anon_sym_is] = ACTIONS(5407),
    [anon_sym_DASH_GT] = ACTIONS(5407),
    [anon_sym_with] = ACTIONS(5407),
    [aux_sym_preproc_if_token3] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4154] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7096),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9405),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4154),
    [sym_preproc_endregion] = STATE(4154),
    [sym_preproc_line] = STATE(4154),
    [sym_preproc_pragma] = STATE(4154),
    [sym_preproc_nullable] = STATE(4154),
    [sym_preproc_error] = STATE(4154),
    [sym_preproc_define] = STATE(4154),
    [sym_preproc_undef] = STATE(4154),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4155] = {
    [sym_preproc_region] = STATE(4155),
    [sym_preproc_endregion] = STATE(4155),
    [sym_preproc_line] = STATE(4155),
    [sym_preproc_pragma] = STATE(4155),
    [sym_preproc_nullable] = STATE(4155),
    [sym_preproc_error] = STATE(4155),
    [sym_preproc_define] = STATE(4155),
    [sym_preproc_undef] = STATE(4155),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5858),
    [anon_sym_BANG] = ACTIONS(5858),
    [anon_sym_PLUS_PLUS] = ACTIONS(5856),
    [anon_sym_DASH_DASH] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_STAR] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_GT_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_switch] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_QMARK_QMARK] = ACTIONS(5856),
    [anon_sym_on] = ACTIONS(5856),
    [anon_sym_equals] = ACTIONS(5856),
    [anon_sym_by] = ACTIONS(5856),
    [anon_sym_as] = ACTIONS(5856),
    [anon_sym_is] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [anon_sym_with] = ACTIONS(5856),
    [aux_sym_preproc_if_token3] = ACTIONS(5856),
    [aux_sym_preproc_else_token1] = ACTIONS(5856),
    [aux_sym_preproc_elif_token1] = ACTIONS(5856),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4156] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7124),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9093),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4156),
    [sym_preproc_endregion] = STATE(4156),
    [sym_preproc_line] = STATE(4156),
    [sym_preproc_pragma] = STATE(4156),
    [sym_preproc_nullable] = STATE(4156),
    [sym_preproc_error] = STATE(4156),
    [sym_preproc_define] = STATE(4156),
    [sym_preproc_undef] = STATE(4156),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4157] = {
    [sym_preproc_region] = STATE(4157),
    [sym_preproc_endregion] = STATE(4157),
    [sym_preproc_line] = STATE(4157),
    [sym_preproc_pragma] = STATE(4157),
    [sym_preproc_nullable] = STATE(4157),
    [sym_preproc_error] = STATE(4157),
    [sym_preproc_define] = STATE(4157),
    [sym_preproc_undef] = STATE(4157),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2999),
    [anon_sym_COLON] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_GT] = ACTIONS(2997),
    [anon_sym_in] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(2997),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_PLUS_PLUS] = ACTIONS(2999),
    [anon_sym_DASH_DASH] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2997),
    [anon_sym_DASH] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_SLASH] = ACTIONS(2997),
    [anon_sym_PERCENT] = ACTIONS(2999),
    [anon_sym_CARET] = ACTIONS(2999),
    [anon_sym_PIPE] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
    [anon_sym_LT_LT] = ACTIONS(2999),
    [anon_sym_GT_GT] = ACTIONS(2997),
    [anon_sym_GT_GT_GT] = ACTIONS(2999),
    [anon_sym_EQ_EQ] = ACTIONS(2999),
    [anon_sym_BANG_EQ] = ACTIONS(2999),
    [anon_sym_GT_EQ] = ACTIONS(2999),
    [anon_sym_LT_EQ] = ACTIONS(2999),
    [anon_sym_DOT] = ACTIONS(2997),
    [anon_sym_EQ_GT] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_when] = ACTIONS(2999),
    [anon_sym_DOT_DOT] = ACTIONS(2999),
    [anon_sym_and] = ACTIONS(2999),
    [anon_sym_or] = ACTIONS(2999),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_QMARK_QMARK] = ACTIONS(2999),
    [anon_sym_on] = ACTIONS(2999),
    [anon_sym_equals] = ACTIONS(2999),
    [anon_sym_by] = ACTIONS(2999),
    [anon_sym_as] = ACTIONS(2999),
    [anon_sym_is] = ACTIONS(2999),
    [anon_sym_DASH_GT] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [aux_sym_preproc_if_token3] = ACTIONS(2999),
    [aux_sym_preproc_else_token1] = ACTIONS(2999),
    [aux_sym_preproc_elif_token1] = ACTIONS(2999),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4158] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7095),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9412),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4158),
    [sym_preproc_endregion] = STATE(4158),
    [sym_preproc_line] = STATE(4158),
    [sym_preproc_pragma] = STATE(4158),
    [sym_preproc_nullable] = STATE(4158),
    [sym_preproc_error] = STATE(4158),
    [sym_preproc_define] = STATE(4158),
    [sym_preproc_undef] = STATE(4158),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4159] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7085),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9424),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4159),
    [sym_preproc_endregion] = STATE(4159),
    [sym_preproc_line] = STATE(4159),
    [sym_preproc_pragma] = STATE(4159),
    [sym_preproc_nullable] = STATE(4159),
    [sym_preproc_error] = STATE(4159),
    [sym_preproc_define] = STATE(4159),
    [sym_preproc_undef] = STATE(4159),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4160] = {
    [sym_preproc_region] = STATE(4160),
    [sym_preproc_endregion] = STATE(4160),
    [sym_preproc_line] = STATE(4160),
    [sym_preproc_pragma] = STATE(4160),
    [sym_preproc_nullable] = STATE(4160),
    [sym_preproc_error] = STATE(4160),
    [sym_preproc_define] = STATE(4160),
    [sym_preproc_undef] = STATE(4160),
    [anon_sym_EQ] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4801),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4159),
    [anon_sym_GT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [anon_sym_PLUS] = ACTIONS(4159),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_SLASH] = ACTIONS(4159),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_switch] = ACTIONS(4167),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(4167),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_PLUS_EQ] = ACTIONS(4167),
    [anon_sym_DASH_EQ] = ACTIONS(4167),
    [anon_sym_STAR_EQ] = ACTIONS(4167),
    [anon_sym_SLASH_EQ] = ACTIONS(4167),
    [anon_sym_PERCENT_EQ] = ACTIONS(4167),
    [anon_sym_AMP_EQ] = ACTIONS(4167),
    [anon_sym_CARET_EQ] = ACTIONS(4167),
    [anon_sym_PIPE_EQ] = ACTIONS(4167),
    [anon_sym_LT_LT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_QMARK_QMARK] = ACTIONS(4159),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_is] = ACTIONS(4167),
    [anon_sym_DASH_GT] = ACTIONS(4167),
    [anon_sym_with] = ACTIONS(4167),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4161] = {
    [sym_preproc_region] = STATE(4161),
    [sym_preproc_endregion] = STATE(4161),
    [sym_preproc_line] = STATE(4161),
    [sym_preproc_pragma] = STATE(4161),
    [sym_preproc_nullable] = STATE(4161),
    [sym_preproc_error] = STATE(4161),
    [sym_preproc_define] = STATE(4161),
    [sym_preproc_undef] = STATE(4161),
    [anon_sym_SEMI] = ACTIONS(5929),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_COLON] = ACTIONS(5929),
    [anon_sym_COMMA] = ACTIONS(5929),
    [anon_sym_RBRACK] = ACTIONS(5929),
    [anon_sym_LPAREN] = ACTIONS(5929),
    [anon_sym_RPAREN] = ACTIONS(5929),
    [anon_sym_RBRACE] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5931),
    [anon_sym_in] = ACTIONS(5929),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_BANG] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5929),
    [anon_sym_DASH_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5931),
    [anon_sym_STAR] = ACTIONS(5929),
    [anon_sym_SLASH] = ACTIONS(5931),
    [anon_sym_PERCENT] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5929),
    [anon_sym_PIPE] = ACTIONS(5931),
    [anon_sym_AMP] = ACTIONS(5931),
    [anon_sym_LT_LT] = ACTIONS(5929),
    [anon_sym_GT_GT] = ACTIONS(5931),
    [anon_sym_GT_GT_GT] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5929),
    [anon_sym_BANG_EQ] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5929),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_DOT] = ACTIONS(5931),
    [anon_sym_EQ_GT] = ACTIONS(5929),
    [anon_sym_switch] = ACTIONS(5929),
    [anon_sym_when] = ACTIONS(5929),
    [anon_sym_DOT_DOT] = ACTIONS(5929),
    [anon_sym_and] = ACTIONS(5929),
    [anon_sym_or] = ACTIONS(5929),
    [anon_sym_AMP_AMP] = ACTIONS(5929),
    [anon_sym_PIPE_PIPE] = ACTIONS(5929),
    [anon_sym_QMARK_QMARK] = ACTIONS(5929),
    [anon_sym_on] = ACTIONS(5929),
    [anon_sym_equals] = ACTIONS(5929),
    [anon_sym_by] = ACTIONS(5929),
    [anon_sym_as] = ACTIONS(5929),
    [anon_sym_is] = ACTIONS(5929),
    [anon_sym_DASH_GT] = ACTIONS(5929),
    [anon_sym_with] = ACTIONS(5929),
    [aux_sym_preproc_if_token3] = ACTIONS(5929),
    [aux_sym_preproc_else_token1] = ACTIONS(5929),
    [aux_sym_preproc_elif_token1] = ACTIONS(5929),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4162] = {
    [sym_preproc_region] = STATE(4162),
    [sym_preproc_endregion] = STATE(4162),
    [sym_preproc_line] = STATE(4162),
    [sym_preproc_pragma] = STATE(4162),
    [sym_preproc_nullable] = STATE(4162),
    [sym_preproc_error] = STATE(4162),
    [sym_preproc_define] = STATE(4162),
    [sym_preproc_undef] = STATE(4162),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5848),
    [anon_sym_COLON] = ACTIONS(5848),
    [anon_sym_COMMA] = ACTIONS(5848),
    [anon_sym_RBRACK] = ACTIONS(5848),
    [anon_sym_LPAREN] = ACTIONS(5848),
    [anon_sym_RPAREN] = ACTIONS(5848),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_LT] = ACTIONS(5850),
    [anon_sym_GT] = ACTIONS(5850),
    [anon_sym_in] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_BANG] = ACTIONS(5850),
    [anon_sym_PLUS_PLUS] = ACTIONS(5848),
    [anon_sym_DASH_DASH] = ACTIONS(5848),
    [anon_sym_PLUS] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5850),
    [anon_sym_STAR] = ACTIONS(5848),
    [anon_sym_SLASH] = ACTIONS(5850),
    [anon_sym_PERCENT] = ACTIONS(5848),
    [anon_sym_CARET] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(5850),
    [anon_sym_AMP] = ACTIONS(5850),
    [anon_sym_LT_LT] = ACTIONS(5848),
    [anon_sym_GT_GT] = ACTIONS(5850),
    [anon_sym_GT_GT_GT] = ACTIONS(5848),
    [anon_sym_EQ_EQ] = ACTIONS(5848),
    [anon_sym_BANG_EQ] = ACTIONS(5848),
    [anon_sym_GT_EQ] = ACTIONS(5848),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_DOT] = ACTIONS(5850),
    [anon_sym_EQ_GT] = ACTIONS(5848),
    [anon_sym_switch] = ACTIONS(5848),
    [anon_sym_when] = ACTIONS(5848),
    [anon_sym_DOT_DOT] = ACTIONS(5848),
    [anon_sym_and] = ACTIONS(5848),
    [anon_sym_or] = ACTIONS(5848),
    [anon_sym_AMP_AMP] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5848),
    [anon_sym_QMARK_QMARK] = ACTIONS(5848),
    [anon_sym_on] = ACTIONS(5848),
    [anon_sym_equals] = ACTIONS(5848),
    [anon_sym_by] = ACTIONS(5848),
    [anon_sym_as] = ACTIONS(5848),
    [anon_sym_is] = ACTIONS(5848),
    [anon_sym_DASH_GT] = ACTIONS(5848),
    [anon_sym_with] = ACTIONS(5848),
    [aux_sym_preproc_if_token3] = ACTIONS(5848),
    [aux_sym_preproc_else_token1] = ACTIONS(5848),
    [aux_sym_preproc_elif_token1] = ACTIONS(5848),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4163] = {
    [sym_preproc_region] = STATE(4163),
    [sym_preproc_endregion] = STATE(4163),
    [sym_preproc_line] = STATE(4163),
    [sym_preproc_pragma] = STATE(4163),
    [sym_preproc_nullable] = STATE(4163),
    [sym_preproc_error] = STATE(4163),
    [sym_preproc_define] = STATE(4163),
    [sym_preproc_undef] = STATE(4163),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(6006),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_when] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_and] = ACTIONS(4482),
    [anon_sym_or] = ACTIONS(4482),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4164] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6952),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9127),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4164),
    [sym_preproc_endregion] = STATE(4164),
    [sym_preproc_line] = STATE(4164),
    [sym_preproc_pragma] = STATE(4164),
    [sym_preproc_nullable] = STATE(4164),
    [sym_preproc_error] = STATE(4164),
    [sym_preproc_define] = STATE(4164),
    [sym_preproc_undef] = STATE(4164),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4165] = {
    [sym_preproc_region] = STATE(4165),
    [sym_preproc_endregion] = STATE(4165),
    [sym_preproc_line] = STATE(4165),
    [sym_preproc_pragma] = STATE(4165),
    [sym_preproc_nullable] = STATE(4165),
    [sym_preproc_error] = STATE(4165),
    [sym_preproc_define] = STATE(4165),
    [sym_preproc_undef] = STATE(4165),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_LPAREN] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_in] = ACTIONS(5915),
    [anon_sym_QMARK] = ACTIONS(5917),
    [anon_sym_BANG] = ACTIONS(5917),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym_GT_GT_GT] = ACTIONS(5915),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_EQ_GT] = ACTIONS(5915),
    [anon_sym_switch] = ACTIONS(5915),
    [anon_sym_when] = ACTIONS(5915),
    [anon_sym_DOT_DOT] = ACTIONS(5915),
    [anon_sym_and] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_QMARK_QMARK] = ACTIONS(5915),
    [anon_sym_on] = ACTIONS(5915),
    [anon_sym_equals] = ACTIONS(5915),
    [anon_sym_by] = ACTIONS(5915),
    [anon_sym_as] = ACTIONS(5915),
    [anon_sym_is] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [anon_sym_with] = ACTIONS(5915),
    [aux_sym_preproc_if_token3] = ACTIONS(5915),
    [aux_sym_preproc_else_token1] = ACTIONS(5915),
    [aux_sym_preproc_elif_token1] = ACTIONS(5915),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4166] = {
    [sym_initializer_expression] = STATE(3727),
    [sym_preproc_region] = STATE(4166),
    [sym_preproc_endregion] = STATE(4166),
    [sym_preproc_line] = STATE(4166),
    [sym_preproc_pragma] = STATE(4166),
    [sym_preproc_nullable] = STATE(4166),
    [sym_preproc_error] = STATE(4166),
    [sym_preproc_define] = STATE(4166),
    [sym_preproc_undef] = STATE(4166),
    [anon_sym_SEMI] = ACTIONS(5331),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_COLON] = ACTIONS(5331),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_RBRACK] = ACTIONS(5331),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [anon_sym_RPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(6008),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_LT] = ACTIONS(5337),
    [anon_sym_GT] = ACTIONS(5337),
    [anon_sym_in] = ACTIONS(5337),
    [anon_sym_QMARK] = ACTIONS(6011),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_PLUS_PLUS] = ACTIONS(5331),
    [anon_sym_DASH_DASH] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_STAR] = ACTIONS(5331),
    [anon_sym_SLASH] = ACTIONS(5337),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_CARET] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5337),
    [anon_sym_AMP] = ACTIONS(5337),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5337),
    [anon_sym_GT_GT_GT] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_BANG_EQ] = ACTIONS(5331),
    [anon_sym_GT_EQ] = ACTIONS(5331),
    [anon_sym_LT_EQ] = ACTIONS(5331),
    [anon_sym_DOT] = ACTIONS(5337),
    [anon_sym_EQ_GT] = ACTIONS(5331),
    [anon_sym_switch] = ACTIONS(5331),
    [anon_sym_DOT_DOT] = ACTIONS(5331),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_into] = ACTIONS(5331),
    [anon_sym_on] = ACTIONS(5331),
    [anon_sym_equals] = ACTIONS(5331),
    [anon_sym_by] = ACTIONS(5331),
    [anon_sym_as] = ACTIONS(5331),
    [anon_sym_is] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [anon_sym_with] = ACTIONS(5331),
    [aux_sym_preproc_if_token3] = ACTIONS(5331),
    [aux_sym_preproc_else_token1] = ACTIONS(5331),
    [aux_sym_preproc_elif_token1] = ACTIONS(5331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4167] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6953),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9140),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4167),
    [sym_preproc_endregion] = STATE(4167),
    [sym_preproc_line] = STATE(4167),
    [sym_preproc_pragma] = STATE(4167),
    [sym_preproc_nullable] = STATE(4167),
    [sym_preproc_error] = STATE(4167),
    [sym_preproc_define] = STATE(4167),
    [sym_preproc_undef] = STATE(4167),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4168] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7147),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9540),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4168),
    [sym_preproc_endregion] = STATE(4168),
    [sym_preproc_line] = STATE(4168),
    [sym_preproc_pragma] = STATE(4168),
    [sym_preproc_nullable] = STATE(4168),
    [sym_preproc_error] = STATE(4168),
    [sym_preproc_define] = STATE(4168),
    [sym_preproc_undef] = STATE(4168),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5996),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4169] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9148),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4169),
    [sym_preproc_endregion] = STATE(4169),
    [sym_preproc_line] = STATE(4169),
    [sym_preproc_pragma] = STATE(4169),
    [sym_preproc_nullable] = STATE(4169),
    [sym_preproc_error] = STATE(4169),
    [sym_preproc_define] = STATE(4169),
    [sym_preproc_undef] = STATE(4169),
    [aux_sym_function_pointer_type_repeat1] = STATE(4172),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4170] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7079),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9430),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4170),
    [sym_preproc_endregion] = STATE(4170),
    [sym_preproc_line] = STATE(4170),
    [sym_preproc_pragma] = STATE(4170),
    [sym_preproc_nullable] = STATE(4170),
    [sym_preproc_error] = STATE(4170),
    [sym_preproc_define] = STATE(4170),
    [sym_preproc_undef] = STATE(4170),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4171] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9077),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4171),
    [sym_preproc_endregion] = STATE(4171),
    [sym_preproc_line] = STATE(4171),
    [sym_preproc_pragma] = STATE(4171),
    [sym_preproc_nullable] = STATE(4171),
    [sym_preproc_error] = STATE(4171),
    [sym_preproc_define] = STATE(4171),
    [sym_preproc_undef] = STATE(4171),
    [aux_sym_function_pointer_type_repeat1] = STATE(4206),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4172] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9198),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4172),
    [sym_preproc_endregion] = STATE(4172),
    [sym_preproc_line] = STATE(4172),
    [sym_preproc_pragma] = STATE(4172),
    [sym_preproc_nullable] = STATE(4172),
    [sym_preproc_error] = STATE(4172),
    [sym_preproc_define] = STATE(4172),
    [sym_preproc_undef] = STATE(4172),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4173] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7070),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9453),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4173),
    [sym_preproc_endregion] = STATE(4173),
    [sym_preproc_line] = STATE(4173),
    [sym_preproc_pragma] = STATE(4173),
    [sym_preproc_nullable] = STATE(4173),
    [sym_preproc_error] = STATE(4173),
    [sym_preproc_define] = STATE(4173),
    [sym_preproc_undef] = STATE(4173),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4174] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9198),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4174),
    [sym_preproc_endregion] = STATE(4174),
    [sym_preproc_line] = STATE(4174),
    [sym_preproc_pragma] = STATE(4174),
    [sym_preproc_nullable] = STATE(4174),
    [sym_preproc_error] = STATE(4174),
    [sym_preproc_define] = STATE(4174),
    [sym_preproc_undef] = STATE(4174),
    [aux_sym_function_pointer_type_repeat1] = STATE(4180),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4175] = {
    [sym_preproc_region] = STATE(4175),
    [sym_preproc_endregion] = STATE(4175),
    [sym_preproc_line] = STATE(4175),
    [sym_preproc_pragma] = STATE(4175),
    [sym_preproc_nullable] = STATE(4175),
    [sym_preproc_error] = STATE(4175),
    [sym_preproc_define] = STATE(4175),
    [sym_preproc_undef] = STATE(4175),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(5882),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(6006),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_and] = ACTIONS(4453),
    [anon_sym_or] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4176] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7094),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9041),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4176),
    [sym_preproc_endregion] = STATE(4176),
    [sym_preproc_line] = STATE(4176),
    [sym_preproc_pragma] = STATE(4176),
    [sym_preproc_nullable] = STATE(4176),
    [sym_preproc_error] = STATE(4176),
    [sym_preproc_define] = STATE(4176),
    [sym_preproc_undef] = STATE(4176),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4177] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7069),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9465),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4177),
    [sym_preproc_endregion] = STATE(4177),
    [sym_preproc_line] = STATE(4177),
    [sym_preproc_pragma] = STATE(4177),
    [sym_preproc_nullable] = STATE(4177),
    [sym_preproc_error] = STATE(4177),
    [sym_preproc_define] = STATE(4177),
    [sym_preproc_undef] = STATE(4177),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4178] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7052),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9544),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4178),
    [sym_preproc_endregion] = STATE(4178),
    [sym_preproc_line] = STATE(4178),
    [sym_preproc_pragma] = STATE(4178),
    [sym_preproc_nullable] = STATE(4178),
    [sym_preproc_error] = STATE(4178),
    [sym_preproc_define] = STATE(4178),
    [sym_preproc_undef] = STATE(4178),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4179] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7138),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9179),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4179),
    [sym_preproc_endregion] = STATE(4179),
    [sym_preproc_line] = STATE(4179),
    [sym_preproc_pragma] = STATE(4179),
    [sym_preproc_nullable] = STATE(4179),
    [sym_preproc_error] = STATE(4179),
    [sym_preproc_define] = STATE(4179),
    [sym_preproc_undef] = STATE(4179),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4180] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9214),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4180),
    [sym_preproc_endregion] = STATE(4180),
    [sym_preproc_line] = STATE(4180),
    [sym_preproc_pragma] = STATE(4180),
    [sym_preproc_nullable] = STATE(4180),
    [sym_preproc_error] = STATE(4180),
    [sym_preproc_define] = STATE(4180),
    [sym_preproc_undef] = STATE(4180),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4181] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7041),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9085),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4181),
    [sym_preproc_endregion] = STATE(4181),
    [sym_preproc_line] = STATE(4181),
    [sym_preproc_pragma] = STATE(4181),
    [sym_preproc_nullable] = STATE(4181),
    [sym_preproc_error] = STATE(4181),
    [sym_preproc_define] = STATE(4181),
    [sym_preproc_undef] = STATE(4181),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4182] = {
    [sym_preproc_region] = STATE(4182),
    [sym_preproc_endregion] = STATE(4182),
    [sym_preproc_line] = STATE(4182),
    [sym_preproc_pragma] = STATE(4182),
    [sym_preproc_nullable] = STATE(4182),
    [sym_preproc_error] = STATE(4182),
    [sym_preproc_define] = STATE(4182),
    [sym_preproc_undef] = STATE(4182),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6017),
    [anon_sym_DASH_EQ] = ACTIONS(6017),
    [anon_sym_STAR_EQ] = ACTIONS(6017),
    [anon_sym_SLASH_EQ] = ACTIONS(6017),
    [anon_sym_PERCENT_EQ] = ACTIONS(6017),
    [anon_sym_AMP_EQ] = ACTIONS(6017),
    [anon_sym_CARET_EQ] = ACTIONS(6017),
    [anon_sym_PIPE_EQ] = ACTIONS(6017),
    [anon_sym_LT_LT_EQ] = ACTIONS(6017),
    [anon_sym_GT_GT_EQ] = ACTIONS(6017),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6017),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4183] = {
    [sym_preproc_region] = STATE(4183),
    [sym_preproc_endregion] = STATE(4183),
    [sym_preproc_line] = STATE(4183),
    [sym_preproc_pragma] = STATE(4183),
    [sym_preproc_nullable] = STATE(4183),
    [sym_preproc_error] = STATE(4183),
    [sym_preproc_define] = STATE(4183),
    [sym_preproc_undef] = STATE(4183),
    [anon_sym_SEMI] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_COLON] = ACTIONS(5403),
    [anon_sym_COMMA] = ACTIONS(5403),
    [anon_sym_RBRACK] = ACTIONS(5403),
    [anon_sym_LPAREN] = ACTIONS(5403),
    [anon_sym_RPAREN] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5403),
    [anon_sym_LT] = ACTIONS(5405),
    [anon_sym_GT] = ACTIONS(5405),
    [anon_sym_in] = ACTIONS(5403),
    [anon_sym_QMARK] = ACTIONS(5405),
    [anon_sym_BANG] = ACTIONS(5405),
    [anon_sym_PLUS_PLUS] = ACTIONS(5403),
    [anon_sym_DASH_DASH] = ACTIONS(5403),
    [anon_sym_PLUS] = ACTIONS(5405),
    [anon_sym_DASH] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5403),
    [anon_sym_SLASH] = ACTIONS(5405),
    [anon_sym_PERCENT] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5403),
    [anon_sym_PIPE] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5405),
    [anon_sym_LT_LT] = ACTIONS(5403),
    [anon_sym_GT_GT] = ACTIONS(5405),
    [anon_sym_GT_GT_GT] = ACTIONS(5403),
    [anon_sym_EQ_EQ] = ACTIONS(5403),
    [anon_sym_BANG_EQ] = ACTIONS(5403),
    [anon_sym_GT_EQ] = ACTIONS(5403),
    [anon_sym_LT_EQ] = ACTIONS(5403),
    [anon_sym_DOT] = ACTIONS(5405),
    [anon_sym_EQ_GT] = ACTIONS(5403),
    [anon_sym_switch] = ACTIONS(5403),
    [anon_sym_when] = ACTIONS(5403),
    [anon_sym_DOT_DOT] = ACTIONS(5403),
    [anon_sym_and] = ACTIONS(5403),
    [anon_sym_or] = ACTIONS(5403),
    [anon_sym_AMP_AMP] = ACTIONS(5403),
    [anon_sym_PIPE_PIPE] = ACTIONS(5403),
    [anon_sym_QMARK_QMARK] = ACTIONS(5403),
    [anon_sym_on] = ACTIONS(5403),
    [anon_sym_equals] = ACTIONS(5403),
    [anon_sym_by] = ACTIONS(5403),
    [anon_sym_as] = ACTIONS(5403),
    [anon_sym_is] = ACTIONS(5403),
    [anon_sym_DASH_GT] = ACTIONS(5403),
    [anon_sym_with] = ACTIONS(5403),
    [aux_sym_preproc_if_token3] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4184] = {
    [sym_preproc_region] = STATE(4184),
    [sym_preproc_endregion] = STATE(4184),
    [sym_preproc_line] = STATE(4184),
    [sym_preproc_pragma] = STATE(4184),
    [sym_preproc_nullable] = STATE(4184),
    [sym_preproc_error] = STATE(4184),
    [sym_preproc_define] = STATE(4184),
    [sym_preproc_undef] = STATE(4184),
    [anon_sym_SEMI] = ACTIONS(5911),
    [anon_sym_LBRACK] = ACTIONS(5911),
    [anon_sym_COLON] = ACTIONS(5911),
    [anon_sym_COMMA] = ACTIONS(5911),
    [anon_sym_RBRACK] = ACTIONS(5911),
    [anon_sym_LPAREN] = ACTIONS(5911),
    [anon_sym_RPAREN] = ACTIONS(5911),
    [anon_sym_RBRACE] = ACTIONS(5911),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_in] = ACTIONS(5911),
    [anon_sym_QMARK] = ACTIONS(5913),
    [anon_sym_BANG] = ACTIONS(5913),
    [anon_sym_PLUS_PLUS] = ACTIONS(5911),
    [anon_sym_DASH_DASH] = ACTIONS(5911),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5911),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5911),
    [anon_sym_CARET] = ACTIONS(5911),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5911),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym_GT_GT_GT] = ACTIONS(5911),
    [anon_sym_EQ_EQ] = ACTIONS(5911),
    [anon_sym_BANG_EQ] = ACTIONS(5911),
    [anon_sym_GT_EQ] = ACTIONS(5911),
    [anon_sym_LT_EQ] = ACTIONS(5911),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_EQ_GT] = ACTIONS(5911),
    [anon_sym_switch] = ACTIONS(5911),
    [anon_sym_when] = ACTIONS(5911),
    [anon_sym_DOT_DOT] = ACTIONS(5911),
    [anon_sym_and] = ACTIONS(5911),
    [anon_sym_or] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_PIPE_PIPE] = ACTIONS(5911),
    [anon_sym_QMARK_QMARK] = ACTIONS(5911),
    [anon_sym_on] = ACTIONS(5911),
    [anon_sym_equals] = ACTIONS(5911),
    [anon_sym_by] = ACTIONS(5911),
    [anon_sym_as] = ACTIONS(5911),
    [anon_sym_is] = ACTIONS(5911),
    [anon_sym_DASH_GT] = ACTIONS(5911),
    [anon_sym_with] = ACTIONS(5911),
    [aux_sym_preproc_if_token3] = ACTIONS(5911),
    [aux_sym_preproc_else_token1] = ACTIONS(5911),
    [aux_sym_preproc_elif_token1] = ACTIONS(5911),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4185] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7093),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9010),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4185),
    [sym_preproc_endregion] = STATE(4185),
    [sym_preproc_line] = STATE(4185),
    [sym_preproc_pragma] = STATE(4185),
    [sym_preproc_nullable] = STATE(4185),
    [sym_preproc_error] = STATE(4185),
    [sym_preproc_define] = STATE(4185),
    [sym_preproc_undef] = STATE(4185),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4186] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7086),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9566),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4186),
    [sym_preproc_endregion] = STATE(4186),
    [sym_preproc_line] = STATE(4186),
    [sym_preproc_pragma] = STATE(4186),
    [sym_preproc_nullable] = STATE(4186),
    [sym_preproc_error] = STATE(4186),
    [sym_preproc_define] = STATE(4186),
    [sym_preproc_undef] = STATE(4186),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4187] = {
    [sym_preproc_region] = STATE(4187),
    [sym_preproc_endregion] = STATE(4187),
    [sym_preproc_line] = STATE(4187),
    [sym_preproc_pragma] = STATE(4187),
    [sym_preproc_nullable] = STATE(4187),
    [sym_preproc_error] = STATE(4187),
    [sym_preproc_define] = STATE(4187),
    [sym_preproc_undef] = STATE(4187),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5630),
    [anon_sym_BANG] = ACTIONS(5630),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_GT_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_EQ_GT] = ACTIONS(5628),
    [anon_sym_switch] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_DOT_DOT] = ACTIONS(5628),
    [anon_sym_and] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_QMARK_QMARK] = ACTIONS(5628),
    [anon_sym_on] = ACTIONS(5628),
    [anon_sym_equals] = ACTIONS(5628),
    [anon_sym_by] = ACTIONS(5628),
    [anon_sym_as] = ACTIONS(5628),
    [anon_sym_is] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [anon_sym_with] = ACTIONS(5628),
    [aux_sym_preproc_if_token3] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5628),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4188] = {
    [sym_preproc_region] = STATE(4188),
    [sym_preproc_endregion] = STATE(4188),
    [sym_preproc_line] = STATE(4188),
    [sym_preproc_pragma] = STATE(4188),
    [sym_preproc_nullable] = STATE(4188),
    [sym_preproc_error] = STATE(4188),
    [sym_preproc_define] = STATE(4188),
    [sym_preproc_undef] = STATE(4188),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_COLON] = ACTIONS(5486),
    [anon_sym_COMMA] = ACTIONS(5486),
    [anon_sym_RBRACK] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(5486),
    [anon_sym_RPAREN] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LT] = ACTIONS(5488),
    [anon_sym_GT] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5486),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_BANG] = ACTIONS(5488),
    [anon_sym_PLUS_PLUS] = ACTIONS(5486),
    [anon_sym_DASH_DASH] = ACTIONS(5486),
    [anon_sym_PLUS] = ACTIONS(5488),
    [anon_sym_DASH] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(5488),
    [anon_sym_PERCENT] = ACTIONS(5486),
    [anon_sym_CARET] = ACTIONS(5486),
    [anon_sym_PIPE] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5488),
    [anon_sym_LT_LT] = ACTIONS(5486),
    [anon_sym_GT_GT] = ACTIONS(5488),
    [anon_sym_GT_GT_GT] = ACTIONS(5486),
    [anon_sym_EQ_EQ] = ACTIONS(5486),
    [anon_sym_BANG_EQ] = ACTIONS(5486),
    [anon_sym_GT_EQ] = ACTIONS(5486),
    [anon_sym_LT_EQ] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(5488),
    [anon_sym_EQ_GT] = ACTIONS(5486),
    [anon_sym_switch] = ACTIONS(5486),
    [anon_sym_when] = ACTIONS(5486),
    [anon_sym_DOT_DOT] = ACTIONS(5486),
    [anon_sym_and] = ACTIONS(5486),
    [anon_sym_or] = ACTIONS(5486),
    [anon_sym_AMP_AMP] = ACTIONS(5486),
    [anon_sym_PIPE_PIPE] = ACTIONS(5486),
    [anon_sym_QMARK_QMARK] = ACTIONS(5486),
    [anon_sym_on] = ACTIONS(5486),
    [anon_sym_equals] = ACTIONS(5486),
    [anon_sym_by] = ACTIONS(5486),
    [anon_sym_as] = ACTIONS(5486),
    [anon_sym_is] = ACTIONS(5486),
    [anon_sym_DASH_GT] = ACTIONS(5486),
    [anon_sym_with] = ACTIONS(5486),
    [aux_sym_preproc_if_token3] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4189] = {
    [sym_preproc_region] = STATE(4189),
    [sym_preproc_endregion] = STATE(4189),
    [sym_preproc_line] = STATE(4189),
    [sym_preproc_pragma] = STATE(4189),
    [sym_preproc_nullable] = STATE(4189),
    [sym_preproc_error] = STATE(4189),
    [sym_preproc_define] = STATE(4189),
    [sym_preproc_undef] = STATE(4189),
    [anon_sym_SEMI] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(5907),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_COMMA] = ACTIONS(5907),
    [anon_sym_RBRACK] = ACTIONS(5907),
    [anon_sym_LPAREN] = ACTIONS(5907),
    [anon_sym_RPAREN] = ACTIONS(5907),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LT] = ACTIONS(5909),
    [anon_sym_GT] = ACTIONS(5909),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_QMARK] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5909),
    [anon_sym_PLUS_PLUS] = ACTIONS(5907),
    [anon_sym_DASH_DASH] = ACTIONS(5907),
    [anon_sym_PLUS] = ACTIONS(5909),
    [anon_sym_DASH] = ACTIONS(5909),
    [anon_sym_STAR] = ACTIONS(5907),
    [anon_sym_SLASH] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5907),
    [anon_sym_CARET] = ACTIONS(5907),
    [anon_sym_PIPE] = ACTIONS(5909),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_LT_LT] = ACTIONS(5907),
    [anon_sym_GT_GT] = ACTIONS(5909),
    [anon_sym_GT_GT_GT] = ACTIONS(5907),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_GT_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5907),
    [anon_sym_DOT] = ACTIONS(5909),
    [anon_sym_EQ_GT] = ACTIONS(5907),
    [anon_sym_switch] = ACTIONS(5907),
    [anon_sym_when] = ACTIONS(5907),
    [anon_sym_DOT_DOT] = ACTIONS(5907),
    [anon_sym_and] = ACTIONS(5907),
    [anon_sym_or] = ACTIONS(5907),
    [anon_sym_AMP_AMP] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5907),
    [anon_sym_QMARK_QMARK] = ACTIONS(5907),
    [anon_sym_on] = ACTIONS(5907),
    [anon_sym_equals] = ACTIONS(5907),
    [anon_sym_by] = ACTIONS(5907),
    [anon_sym_as] = ACTIONS(5907),
    [anon_sym_is] = ACTIONS(5907),
    [anon_sym_DASH_GT] = ACTIONS(5907),
    [anon_sym_with] = ACTIONS(5907),
    [aux_sym_preproc_if_token3] = ACTIONS(5907),
    [aux_sym_preproc_else_token1] = ACTIONS(5907),
    [aux_sym_preproc_elif_token1] = ACTIONS(5907),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4190] = {
    [sym_preproc_region] = STATE(4190),
    [sym_preproc_endregion] = STATE(4190),
    [sym_preproc_line] = STATE(4190),
    [sym_preproc_pragma] = STATE(4190),
    [sym_preproc_nullable] = STATE(4190),
    [sym_preproc_error] = STATE(4190),
    [sym_preproc_define] = STATE(4190),
    [sym_preproc_undef] = STATE(4190),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LT] = ACTIONS(5634),
    [anon_sym_GT] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5634),
    [anon_sym_BANG] = ACTIONS(5634),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS] = ACTIONS(5634),
    [anon_sym_DASH] = ACTIONS(5634),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5634),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5634),
    [anon_sym_AMP] = ACTIONS(5634),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5634),
    [anon_sym_GT_GT_GT] = ACTIONS(5632),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5634),
    [anon_sym_EQ_GT] = ACTIONS(5632),
    [anon_sym_switch] = ACTIONS(5632),
    [anon_sym_when] = ACTIONS(5632),
    [anon_sym_DOT_DOT] = ACTIONS(5632),
    [anon_sym_and] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_QMARK_QMARK] = ACTIONS(5632),
    [anon_sym_on] = ACTIONS(5632),
    [anon_sym_equals] = ACTIONS(5632),
    [anon_sym_by] = ACTIONS(5632),
    [anon_sym_as] = ACTIONS(5632),
    [anon_sym_is] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [anon_sym_with] = ACTIONS(5632),
    [aux_sym_preproc_if_token3] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5632),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4191] = {
    [sym_preproc_region] = STATE(4191),
    [sym_preproc_endregion] = STATE(4191),
    [sym_preproc_line] = STATE(4191),
    [sym_preproc_pragma] = STATE(4191),
    [sym_preproc_nullable] = STATE(4191),
    [sym_preproc_error] = STATE(4191),
    [sym_preproc_define] = STATE(4191),
    [sym_preproc_undef] = STATE(4191),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_COLON] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACK] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5528),
    [anon_sym_BANG] = ACTIONS(5528),
    [anon_sym_PLUS_PLUS] = ACTIONS(5526),
    [anon_sym_DASH_DASH] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5526),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5526),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5526),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_GT_GT_GT] = ACTIONS(5526),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_EQ_GT] = ACTIONS(5526),
    [anon_sym_switch] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_DOT_DOT] = ACTIONS(5526),
    [anon_sym_and] = ACTIONS(5526),
    [anon_sym_or] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE] = ACTIONS(5526),
    [anon_sym_QMARK_QMARK] = ACTIONS(5526),
    [anon_sym_on] = ACTIONS(5526),
    [anon_sym_equals] = ACTIONS(5526),
    [anon_sym_by] = ACTIONS(5526),
    [anon_sym_as] = ACTIONS(5526),
    [anon_sym_is] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_with] = ACTIONS(5526),
    [aux_sym_preproc_if_token3] = ACTIONS(5526),
    [aux_sym_preproc_else_token1] = ACTIONS(5526),
    [aux_sym_preproc_elif_token1] = ACTIONS(5526),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4192] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7048),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9549),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4192),
    [sym_preproc_endregion] = STATE(4192),
    [sym_preproc_line] = STATE(4192),
    [sym_preproc_pragma] = STATE(4192),
    [sym_preproc_nullable] = STATE(4192),
    [sym_preproc_error] = STATE(4192),
    [sym_preproc_define] = STATE(4192),
    [sym_preproc_undef] = STATE(4192),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4193] = {
    [sym_preproc_region] = STATE(4193),
    [sym_preproc_endregion] = STATE(4193),
    [sym_preproc_line] = STATE(4193),
    [sym_preproc_pragma] = STATE(4193),
    [sym_preproc_nullable] = STATE(4193),
    [sym_preproc_error] = STATE(4193),
    [sym_preproc_define] = STATE(4193),
    [sym_preproc_undef] = STATE(4193),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_COLON] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_RBRACK] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(5482),
    [anon_sym_RPAREN] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5484),
    [anon_sym_BANG] = ACTIONS(5484),
    [anon_sym_PLUS_PLUS] = ACTIONS(5482),
    [anon_sym_DASH_DASH] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5482),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5482),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_GT_GT_GT] = ACTIONS(5482),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_EQ_GT] = ACTIONS(5482),
    [anon_sym_switch] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_DOT_DOT] = ACTIONS(5482),
    [anon_sym_and] = ACTIONS(5482),
    [anon_sym_or] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE] = ACTIONS(5482),
    [anon_sym_QMARK_QMARK] = ACTIONS(5482),
    [anon_sym_on] = ACTIONS(5482),
    [anon_sym_equals] = ACTIONS(5482),
    [anon_sym_by] = ACTIONS(5482),
    [anon_sym_as] = ACTIONS(5482),
    [anon_sym_is] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_with] = ACTIONS(5482),
    [aux_sym_preproc_if_token3] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4194] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9598),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4194),
    [sym_preproc_endregion] = STATE(4194),
    [sym_preproc_line] = STATE(4194),
    [sym_preproc_pragma] = STATE(4194),
    [sym_preproc_nullable] = STATE(4194),
    [sym_preproc_error] = STATE(4194),
    [sym_preproc_define] = STATE(4194),
    [sym_preproc_undef] = STATE(4194),
    [aux_sym_function_pointer_type_repeat1] = STATE(4119),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4195] = {
    [sym_preproc_region] = STATE(4195),
    [sym_preproc_endregion] = STATE(4195),
    [sym_preproc_line] = STATE(4195),
    [sym_preproc_pragma] = STATE(4195),
    [sym_preproc_nullable] = STATE(4195),
    [sym_preproc_error] = STATE(4195),
    [sym_preproc_define] = STATE(4195),
    [sym_preproc_undef] = STATE(4195),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_LPAREN] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5889),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5891),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_SLASH] = ACTIONS(5891),
    [anon_sym_PERCENT] = ACTIONS(5889),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_GT_GT_GT] = ACTIONS(5889),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5891),
    [anon_sym_EQ_GT] = ACTIONS(5889),
    [anon_sym_switch] = ACTIONS(5889),
    [anon_sym_when] = ACTIONS(5889),
    [anon_sym_DOT_DOT] = ACTIONS(5889),
    [anon_sym_and] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_QMARK_QMARK] = ACTIONS(5889),
    [anon_sym_on] = ACTIONS(5889),
    [anon_sym_equals] = ACTIONS(5889),
    [anon_sym_by] = ACTIONS(5889),
    [anon_sym_as] = ACTIONS(5889),
    [anon_sym_is] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [anon_sym_with] = ACTIONS(5889),
    [aux_sym_preproc_if_token3] = ACTIONS(5889),
    [aux_sym_preproc_else_token1] = ACTIONS(5889),
    [aux_sym_preproc_elif_token1] = ACTIONS(5889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4196] = {
    [sym_preproc_region] = STATE(4196),
    [sym_preproc_endregion] = STATE(4196),
    [sym_preproc_line] = STATE(4196),
    [sym_preproc_pragma] = STATE(4196),
    [sym_preproc_nullable] = STATE(4196),
    [sym_preproc_error] = STATE(4196),
    [sym_preproc_define] = STATE(4196),
    [sym_preproc_undef] = STATE(4196),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6021),
    [anon_sym_DASH_EQ] = ACTIONS(6021),
    [anon_sym_STAR_EQ] = ACTIONS(6021),
    [anon_sym_SLASH_EQ] = ACTIONS(6021),
    [anon_sym_PERCENT_EQ] = ACTIONS(6021),
    [anon_sym_AMP_EQ] = ACTIONS(6021),
    [anon_sym_CARET_EQ] = ACTIONS(6021),
    [anon_sym_PIPE_EQ] = ACTIONS(6021),
    [anon_sym_LT_LT_EQ] = ACTIONS(6021),
    [anon_sym_GT_GT_EQ] = ACTIONS(6021),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6021),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4197] = {
    [sym_preproc_region] = STATE(4197),
    [sym_preproc_endregion] = STATE(4197),
    [sym_preproc_line] = STATE(4197),
    [sym_preproc_pragma] = STATE(4197),
    [sym_preproc_nullable] = STATE(4197),
    [sym_preproc_error] = STATE(4197),
    [sym_preproc_define] = STATE(4197),
    [sym_preproc_undef] = STATE(4197),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_LPAREN] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_in] = ACTIONS(5889),
    [anon_sym_QMARK] = ACTIONS(5891),
    [anon_sym_BANG] = ACTIONS(5891),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_SLASH] = ACTIONS(5891),
    [anon_sym_PERCENT] = ACTIONS(5889),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_GT_GT_GT] = ACTIONS(5889),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5891),
    [anon_sym_EQ_GT] = ACTIONS(5889),
    [anon_sym_switch] = ACTIONS(5889),
    [anon_sym_when] = ACTIONS(5889),
    [anon_sym_DOT_DOT] = ACTIONS(5889),
    [anon_sym_and] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_QMARK_QMARK] = ACTIONS(5889),
    [anon_sym_on] = ACTIONS(5889),
    [anon_sym_equals] = ACTIONS(5889),
    [anon_sym_by] = ACTIONS(5889),
    [anon_sym_as] = ACTIONS(5889),
    [anon_sym_is] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [anon_sym_with] = ACTIONS(5889),
    [aux_sym_preproc_if_token3] = ACTIONS(5889),
    [aux_sym_preproc_else_token1] = ACTIONS(5889),
    [aux_sym_preproc_elif_token1] = ACTIONS(5889),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4198] = {
    [sym_preproc_region] = STATE(4198),
    [sym_preproc_endregion] = STATE(4198),
    [sym_preproc_line] = STATE(4198),
    [sym_preproc_pragma] = STATE(4198),
    [sym_preproc_nullable] = STATE(4198),
    [sym_preproc_error] = STATE(4198),
    [sym_preproc_define] = STATE(4198),
    [sym_preproc_undef] = STATE(4198),
    [anon_sym_SEMI] = ACTIONS(5885),
    [anon_sym_LBRACK] = ACTIONS(5885),
    [anon_sym_COLON] = ACTIONS(5885),
    [anon_sym_COMMA] = ACTIONS(5885),
    [anon_sym_RBRACK] = ACTIONS(5885),
    [anon_sym_LPAREN] = ACTIONS(5885),
    [anon_sym_RPAREN] = ACTIONS(5885),
    [anon_sym_RBRACE] = ACTIONS(5885),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_in] = ACTIONS(5885),
    [anon_sym_QMARK] = ACTIONS(5887),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_PLUS_PLUS] = ACTIONS(5885),
    [anon_sym_DASH_DASH] = ACTIONS(5885),
    [anon_sym_PLUS] = ACTIONS(5887),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_STAR] = ACTIONS(5885),
    [anon_sym_SLASH] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5885),
    [anon_sym_CARET] = ACTIONS(5885),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_LT_LT] = ACTIONS(5885),
    [anon_sym_GT_GT] = ACTIONS(5887),
    [anon_sym_GT_GT_GT] = ACTIONS(5885),
    [anon_sym_EQ_EQ] = ACTIONS(5885),
    [anon_sym_BANG_EQ] = ACTIONS(5885),
    [anon_sym_GT_EQ] = ACTIONS(5885),
    [anon_sym_LT_EQ] = ACTIONS(5885),
    [anon_sym_DOT] = ACTIONS(5887),
    [anon_sym_EQ_GT] = ACTIONS(5885),
    [anon_sym_switch] = ACTIONS(5885),
    [anon_sym_when] = ACTIONS(5885),
    [anon_sym_DOT_DOT] = ACTIONS(5885),
    [anon_sym_and] = ACTIONS(5885),
    [anon_sym_or] = ACTIONS(5885),
    [anon_sym_AMP_AMP] = ACTIONS(5885),
    [anon_sym_PIPE_PIPE] = ACTIONS(5885),
    [anon_sym_QMARK_QMARK] = ACTIONS(5885),
    [anon_sym_on] = ACTIONS(5885),
    [anon_sym_equals] = ACTIONS(5885),
    [anon_sym_by] = ACTIONS(5885),
    [anon_sym_as] = ACTIONS(5885),
    [anon_sym_is] = ACTIONS(5885),
    [anon_sym_DASH_GT] = ACTIONS(5885),
    [anon_sym_with] = ACTIONS(5885),
    [aux_sym_preproc_if_token3] = ACTIONS(5885),
    [aux_sym_preproc_else_token1] = ACTIONS(5885),
    [aux_sym_preproc_elif_token1] = ACTIONS(5885),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4199] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9770),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4199),
    [sym_preproc_endregion] = STATE(4199),
    [sym_preproc_line] = STATE(4199),
    [sym_preproc_pragma] = STATE(4199),
    [sym_preproc_nullable] = STATE(4199),
    [sym_preproc_error] = STATE(4199),
    [sym_preproc_define] = STATE(4199),
    [sym_preproc_undef] = STATE(4199),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4200] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7004),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9741),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4200),
    [sym_preproc_endregion] = STATE(4200),
    [sym_preproc_line] = STATE(4200),
    [sym_preproc_pragma] = STATE(4200),
    [sym_preproc_nullable] = STATE(4200),
    [sym_preproc_error] = STATE(4200),
    [sym_preproc_define] = STATE(4200),
    [sym_preproc_undef] = STATE(4200),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4201] = {
    [sym_preproc_region] = STATE(4201),
    [sym_preproc_endregion] = STATE(4201),
    [sym_preproc_line] = STATE(4201),
    [sym_preproc_pragma] = STATE(4201),
    [sym_preproc_nullable] = STATE(4201),
    [sym_preproc_error] = STATE(4201),
    [sym_preproc_define] = STATE(4201),
    [sym_preproc_undef] = STATE(4201),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_RBRACK] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5878),
    [anon_sym_RPAREN] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5880),
    [anon_sym_in] = ACTIONS(5878),
    [anon_sym_QMARK] = ACTIONS(5880),
    [anon_sym_BANG] = ACTIONS(5880),
    [anon_sym_PLUS_PLUS] = ACTIONS(5878),
    [anon_sym_DASH_DASH] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(5878),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_CARET] = ACTIONS(5878),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5878),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_GT_GT_GT] = ACTIONS(5878),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(5878),
    [anon_sym_GT_EQ] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5880),
    [anon_sym_EQ_GT] = ACTIONS(5878),
    [anon_sym_switch] = ACTIONS(5878),
    [anon_sym_when] = ACTIONS(5878),
    [anon_sym_DOT_DOT] = ACTIONS(5878),
    [anon_sym_and] = ACTIONS(5878),
    [anon_sym_or] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE] = ACTIONS(5878),
    [anon_sym_QMARK_QMARK] = ACTIONS(5878),
    [anon_sym_on] = ACTIONS(5878),
    [anon_sym_equals] = ACTIONS(5878),
    [anon_sym_by] = ACTIONS(5878),
    [anon_sym_as] = ACTIONS(5878),
    [anon_sym_is] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(5878),
    [anon_sym_with] = ACTIONS(5878),
    [aux_sym_preproc_if_token3] = ACTIONS(5878),
    [aux_sym_preproc_else_token1] = ACTIONS(5878),
    [aux_sym_preproc_elif_token1] = ACTIONS(5878),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4202] = {
    [sym_attribute_list] = STATE(4403),
    [sym_preproc_region] = STATE(4202),
    [sym_preproc_endregion] = STATE(4202),
    [sym_preproc_line] = STATE(4202),
    [sym_preproc_pragma] = STATE(4202),
    [sym_preproc_nullable] = STATE(4202),
    [sym_preproc_error] = STATE(4202),
    [sym_preproc_define] = STATE(4202),
    [sym_preproc_undef] = STATE(4202),
    [aux_sym_class_declaration_repeat1] = STATE(4202),
    [sym__identifier_token] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym_alias] = ACTIONS(5357),
    [anon_sym_global] = ACTIONS(5357),
    [anon_sym_unsafe] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(6023),
    [anon_sym_abstract] = ACTIONS(5357),
    [anon_sym_async] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_file] = ACTIONS(5357),
    [anon_sym_fixed] = ACTIONS(5357),
    [anon_sym_internal] = ACTIONS(5357),
    [anon_sym_new] = ACTIONS(5357),
    [anon_sym_override] = ACTIONS(5357),
    [anon_sym_partial] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_readonly] = ACTIONS(5357),
    [anon_sym_required] = ACTIONS(5357),
    [anon_sym_sealed] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_where] = ACTIONS(5357),
    [anon_sym_notnull] = ACTIONS(5357),
    [anon_sym_unmanaged] = ACTIONS(5357),
    [anon_sym_get] = ACTIONS(5357),
    [anon_sym_set] = ACTIONS(5357),
    [anon_sym_add] = ACTIONS(5357),
    [anon_sym_remove] = ACTIONS(5357),
    [anon_sym_init] = ACTIONS(5357),
    [anon_sym_scoped] = ACTIONS(5357),
    [anon_sym_var] = ACTIONS(5357),
    [anon_sym_yield] = ACTIONS(5357),
    [anon_sym_when] = ACTIONS(5357),
    [anon_sym_from] = ACTIONS(5357),
    [anon_sym_into] = ACTIONS(5357),
    [anon_sym_join] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_orderby] = ACTIONS(5357),
    [anon_sym_ascending] = ACTIONS(5357),
    [anon_sym_descending] = ACTIONS(5357),
    [anon_sym_group] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_select] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4203] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9770),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4203),
    [sym_preproc_endregion] = STATE(4203),
    [sym_preproc_line] = STATE(4203),
    [sym_preproc_pragma] = STATE(4203),
    [sym_preproc_nullable] = STATE(4203),
    [sym_preproc_error] = STATE(4203),
    [sym_preproc_define] = STATE(4203),
    [sym_preproc_undef] = STATE(4203),
    [aux_sym_function_pointer_type_repeat1] = STATE(4231),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4204] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7082),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9572),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4204),
    [sym_preproc_endregion] = STATE(4204),
    [sym_preproc_line] = STATE(4204),
    [sym_preproc_pragma] = STATE(4204),
    [sym_preproc_nullable] = STATE(4204),
    [sym_preproc_error] = STATE(4204),
    [sym_preproc_define] = STATE(4204),
    [sym_preproc_undef] = STATE(4204),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4205] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6959),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9444),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4205),
    [sym_preproc_endregion] = STATE(4205),
    [sym_preproc_line] = STATE(4205),
    [sym_preproc_pragma] = STATE(4205),
    [sym_preproc_nullable] = STATE(4205),
    [sym_preproc_error] = STATE(4205),
    [sym_preproc_define] = STATE(4205),
    [sym_preproc_undef] = STATE(4205),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4206] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9598),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4206),
    [sym_preproc_endregion] = STATE(4206),
    [sym_preproc_line] = STATE(4206),
    [sym_preproc_pragma] = STATE(4206),
    [sym_preproc_nullable] = STATE(4206),
    [sym_preproc_error] = STATE(4206),
    [sym_preproc_define] = STATE(4206),
    [sym_preproc_undef] = STATE(4206),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4207] = {
    [sym_preproc_region] = STATE(4207),
    [sym_preproc_endregion] = STATE(4207),
    [sym_preproc_line] = STATE(4207),
    [sym_preproc_pragma] = STATE(4207),
    [sym_preproc_nullable] = STATE(4207),
    [sym_preproc_error] = STATE(4207),
    [sym_preproc_define] = STATE(4207),
    [sym_preproc_undef] = STATE(4207),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(5648),
    [anon_sym_RBRACK] = ACTIONS(5648),
    [anon_sym_LPAREN] = ACTIONS(5648),
    [anon_sym_RPAREN] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5648),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_BANG] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5650),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5650),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_PIPE] = ACTIONS(5650),
    [anon_sym_AMP] = ACTIONS(5650),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5650),
    [anon_sym_GT_GT_GT] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5648),
    [anon_sym_BANG_EQ] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5648),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_DOT] = ACTIONS(5650),
    [anon_sym_EQ_GT] = ACTIONS(5648),
    [anon_sym_switch] = ACTIONS(5648),
    [anon_sym_when] = ACTIONS(5648),
    [anon_sym_DOT_DOT] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_or] = ACTIONS(5648),
    [anon_sym_AMP_AMP] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5648),
    [anon_sym_QMARK_QMARK] = ACTIONS(5648),
    [anon_sym_on] = ACTIONS(5648),
    [anon_sym_equals] = ACTIONS(5648),
    [anon_sym_by] = ACTIONS(5648),
    [anon_sym_as] = ACTIONS(5648),
    [anon_sym_is] = ACTIONS(5648),
    [anon_sym_DASH_GT] = ACTIONS(5648),
    [anon_sym_with] = ACTIONS(5648),
    [aux_sym_preproc_if_token3] = ACTIONS(5648),
    [aux_sym_preproc_else_token1] = ACTIONS(5648),
    [aux_sym_preproc_elif_token1] = ACTIONS(5648),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4208] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6982),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9446),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4208),
    [sym_preproc_endregion] = STATE(4208),
    [sym_preproc_line] = STATE(4208),
    [sym_preproc_pragma] = STATE(4208),
    [sym_preproc_nullable] = STATE(4208),
    [sym_preproc_error] = STATE(4208),
    [sym_preproc_define] = STATE(4208),
    [sym_preproc_undef] = STATE(4208),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4209] = {
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7351),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4209),
    [sym_preproc_endregion] = STATE(4209),
    [sym_preproc_line] = STATE(4209),
    [sym_preproc_pragma] = STATE(4209),
    [sym_preproc_nullable] = STATE(4209),
    [sym_preproc_error] = STATE(4209),
    [sym_preproc_define] = STATE(4209),
    [sym_preproc_undef] = STATE(4209),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(6785),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4210] = {
    [sym_preproc_region] = STATE(4210),
    [sym_preproc_endregion] = STATE(4210),
    [sym_preproc_line] = STATE(4210),
    [sym_preproc_pragma] = STATE(4210),
    [sym_preproc_nullable] = STATE(4210),
    [sym_preproc_error] = STATE(4210),
    [sym_preproc_define] = STATE(4210),
    [sym_preproc_undef] = STATE(4210),
    [anon_sym_SEMI] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5578),
    [anon_sym_COMMA] = ACTIONS(5578),
    [anon_sym_RBRACK] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(5578),
    [anon_sym_RPAREN] = ACTIONS(5578),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5580),
    [anon_sym_in] = ACTIONS(5578),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_BANG] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5580),
    [anon_sym_STAR] = ACTIONS(5578),
    [anon_sym_SLASH] = ACTIONS(5580),
    [anon_sym_PERCENT] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5578),
    [anon_sym_PIPE] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5580),
    [anon_sym_LT_LT] = ACTIONS(5578),
    [anon_sym_GT_GT] = ACTIONS(5580),
    [anon_sym_GT_GT_GT] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5578),
    [anon_sym_BANG_EQ] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5578),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(5580),
    [anon_sym_EQ_GT] = ACTIONS(5578),
    [anon_sym_switch] = ACTIONS(5578),
    [anon_sym_when] = ACTIONS(5578),
    [anon_sym_DOT_DOT] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_AMP_AMP] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE] = ACTIONS(5578),
    [anon_sym_QMARK_QMARK] = ACTIONS(5578),
    [anon_sym_on] = ACTIONS(5578),
    [anon_sym_equals] = ACTIONS(5578),
    [anon_sym_by] = ACTIONS(5578),
    [anon_sym_as] = ACTIONS(5578),
    [anon_sym_is] = ACTIONS(5578),
    [anon_sym_DASH_GT] = ACTIONS(5578),
    [anon_sym_with] = ACTIONS(5578),
    [aux_sym_preproc_if_token3] = ACTIONS(5578),
    [aux_sym_preproc_else_token1] = ACTIONS(5578),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4211] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9344),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4211),
    [sym_preproc_endregion] = STATE(4211),
    [sym_preproc_line] = STATE(4211),
    [sym_preproc_pragma] = STATE(4211),
    [sym_preproc_nullable] = STATE(4211),
    [sym_preproc_error] = STATE(4211),
    [sym_preproc_define] = STATE(4211),
    [sym_preproc_undef] = STATE(4211),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4212] = {
    [sym_preproc_region] = STATE(4212),
    [sym_preproc_endregion] = STATE(4212),
    [sym_preproc_line] = STATE(4212),
    [sym_preproc_pragma] = STATE(4212),
    [sym_preproc_nullable] = STATE(4212),
    [sym_preproc_error] = STATE(4212),
    [sym_preproc_define] = STATE(4212),
    [sym_preproc_undef] = STATE(4212),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_RBRACK] = ACTIONS(5636),
    [anon_sym_LPAREN] = ACTIONS(5636),
    [anon_sym_RPAREN] = ACTIONS(5636),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_LT] = ACTIONS(5638),
    [anon_sym_GT] = ACTIONS(5638),
    [anon_sym_in] = ACTIONS(5636),
    [anon_sym_QMARK] = ACTIONS(5638),
    [anon_sym_BANG] = ACTIONS(5638),
    [anon_sym_PLUS_PLUS] = ACTIONS(5636),
    [anon_sym_DASH_DASH] = ACTIONS(5636),
    [anon_sym_PLUS] = ACTIONS(5638),
    [anon_sym_DASH] = ACTIONS(5638),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5638),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_CARET] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5638),
    [anon_sym_AMP] = ACTIONS(5638),
    [anon_sym_LT_LT] = ACTIONS(5636),
    [anon_sym_GT_GT] = ACTIONS(5638),
    [anon_sym_GT_GT_GT] = ACTIONS(5636),
    [anon_sym_EQ_EQ] = ACTIONS(5636),
    [anon_sym_BANG_EQ] = ACTIONS(5636),
    [anon_sym_GT_EQ] = ACTIONS(5636),
    [anon_sym_LT_EQ] = ACTIONS(5636),
    [anon_sym_DOT] = ACTIONS(5638),
    [anon_sym_EQ_GT] = ACTIONS(5636),
    [anon_sym_switch] = ACTIONS(5636),
    [anon_sym_when] = ACTIONS(5636),
    [anon_sym_DOT_DOT] = ACTIONS(5636),
    [anon_sym_and] = ACTIONS(5636),
    [anon_sym_or] = ACTIONS(5636),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_QMARK_QMARK] = ACTIONS(5636),
    [anon_sym_on] = ACTIONS(5636),
    [anon_sym_equals] = ACTIONS(5636),
    [anon_sym_by] = ACTIONS(5636),
    [anon_sym_as] = ACTIONS(5636),
    [anon_sym_is] = ACTIONS(5636),
    [anon_sym_DASH_GT] = ACTIONS(5636),
    [anon_sym_with] = ACTIONS(5636),
    [aux_sym_preproc_if_token3] = ACTIONS(5636),
    [aux_sym_preproc_else_token1] = ACTIONS(5636),
    [aux_sym_preproc_elif_token1] = ACTIONS(5636),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4213] = {
    [sym_preproc_region] = STATE(4213),
    [sym_preproc_endregion] = STATE(4213),
    [sym_preproc_line] = STATE(4213),
    [sym_preproc_pragma] = STATE(4213),
    [sym_preproc_nullable] = STATE(4213),
    [sym_preproc_error] = STATE(4213),
    [sym_preproc_define] = STATE(4213),
    [sym_preproc_undef] = STATE(4213),
    [anon_sym_SEMI] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_COLON] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RBRACK] = ACTIONS(5933),
    [anon_sym_LPAREN] = ACTIONS(5933),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_RBRACE] = ACTIONS(5933),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_in] = ACTIONS(5933),
    [anon_sym_QMARK] = ACTIONS(5935),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_PLUS_PLUS] = ACTIONS(5933),
    [anon_sym_DASH_DASH] = ACTIONS(5933),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5933),
    [anon_sym_CARET] = ACTIONS(5933),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5933),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_GT_GT_GT] = ACTIONS(5933),
    [anon_sym_EQ_EQ] = ACTIONS(5933),
    [anon_sym_BANG_EQ] = ACTIONS(5933),
    [anon_sym_GT_EQ] = ACTIONS(5933),
    [anon_sym_LT_EQ] = ACTIONS(5933),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_EQ_GT] = ACTIONS(5933),
    [anon_sym_switch] = ACTIONS(5933),
    [anon_sym_when] = ACTIONS(5933),
    [anon_sym_DOT_DOT] = ACTIONS(5933),
    [anon_sym_and] = ACTIONS(5933),
    [anon_sym_or] = ACTIONS(5933),
    [anon_sym_AMP_AMP] = ACTIONS(5933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5933),
    [anon_sym_QMARK_QMARK] = ACTIONS(5933),
    [anon_sym_on] = ACTIONS(5933),
    [anon_sym_equals] = ACTIONS(5933),
    [anon_sym_by] = ACTIONS(5933),
    [anon_sym_as] = ACTIONS(5933),
    [anon_sym_is] = ACTIONS(5933),
    [anon_sym_DASH_GT] = ACTIONS(5933),
    [anon_sym_with] = ACTIONS(5933),
    [aux_sym_preproc_if_token3] = ACTIONS(5933),
    [aux_sym_preproc_else_token1] = ACTIONS(5933),
    [aux_sym_preproc_elif_token1] = ACTIONS(5933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4214] = {
    [sym_preproc_region] = STATE(4214),
    [sym_preproc_endregion] = STATE(4214),
    [sym_preproc_line] = STATE(4214),
    [sym_preproc_pragma] = STATE(4214),
    [sym_preproc_nullable] = STATE(4214),
    [sym_preproc_error] = STATE(4214),
    [sym_preproc_define] = STATE(4214),
    [sym_preproc_undef] = STATE(4214),
    [anon_sym_SEMI] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5933),
    [anon_sym_COLON] = ACTIONS(5933),
    [anon_sym_COMMA] = ACTIONS(5933),
    [anon_sym_RBRACK] = ACTIONS(5933),
    [anon_sym_LPAREN] = ACTIONS(5933),
    [anon_sym_RPAREN] = ACTIONS(5933),
    [anon_sym_RBRACE] = ACTIONS(5933),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_in] = ACTIONS(5933),
    [anon_sym_QMARK] = ACTIONS(5935),
    [anon_sym_BANG] = ACTIONS(5935),
    [anon_sym_PLUS_PLUS] = ACTIONS(5933),
    [anon_sym_DASH_DASH] = ACTIONS(5933),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5933),
    [anon_sym_CARET] = ACTIONS(5933),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5933),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_GT_GT_GT] = ACTIONS(5933),
    [anon_sym_EQ_EQ] = ACTIONS(5933),
    [anon_sym_BANG_EQ] = ACTIONS(5933),
    [anon_sym_GT_EQ] = ACTIONS(5933),
    [anon_sym_LT_EQ] = ACTIONS(5933),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_EQ_GT] = ACTIONS(5933),
    [anon_sym_switch] = ACTIONS(5933),
    [anon_sym_when] = ACTIONS(5933),
    [anon_sym_DOT_DOT] = ACTIONS(5933),
    [anon_sym_and] = ACTIONS(5933),
    [anon_sym_or] = ACTIONS(5933),
    [anon_sym_AMP_AMP] = ACTIONS(5933),
    [anon_sym_PIPE_PIPE] = ACTIONS(5933),
    [anon_sym_QMARK_QMARK] = ACTIONS(5933),
    [anon_sym_on] = ACTIONS(5933),
    [anon_sym_equals] = ACTIONS(5933),
    [anon_sym_by] = ACTIONS(5933),
    [anon_sym_as] = ACTIONS(5933),
    [anon_sym_is] = ACTIONS(5933),
    [anon_sym_DASH_GT] = ACTIONS(5933),
    [anon_sym_with] = ACTIONS(5933),
    [aux_sym_preproc_if_token3] = ACTIONS(5933),
    [aux_sym_preproc_else_token1] = ACTIONS(5933),
    [aux_sym_preproc_elif_token1] = ACTIONS(5933),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4215] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6987),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9919),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4215),
    [sym_preproc_endregion] = STATE(4215),
    [sym_preproc_line] = STATE(4215),
    [sym_preproc_pragma] = STATE(4215),
    [sym_preproc_nullable] = STATE(4215),
    [sym_preproc_error] = STATE(4215),
    [sym_preproc_define] = STATE(4215),
    [sym_preproc_undef] = STATE(4215),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4216] = {
    [sym_preproc_region] = STATE(4216),
    [sym_preproc_endregion] = STATE(4216),
    [sym_preproc_line] = STATE(4216),
    [sym_preproc_pragma] = STATE(4216),
    [sym_preproc_nullable] = STATE(4216),
    [sym_preproc_error] = STATE(4216),
    [sym_preproc_define] = STATE(4216),
    [sym_preproc_undef] = STATE(4216),
    [anon_sym_SEMI] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_COMMA] = ACTIONS(5419),
    [anon_sym_RBRACK] = ACTIONS(5419),
    [anon_sym_LPAREN] = ACTIONS(5419),
    [anon_sym_RPAREN] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5419),
    [anon_sym_LT] = ACTIONS(5421),
    [anon_sym_GT] = ACTIONS(5421),
    [anon_sym_in] = ACTIONS(5419),
    [anon_sym_QMARK] = ACTIONS(5421),
    [anon_sym_BANG] = ACTIONS(5421),
    [anon_sym_PLUS_PLUS] = ACTIONS(5419),
    [anon_sym_DASH_DASH] = ACTIONS(5419),
    [anon_sym_PLUS] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5419),
    [anon_sym_SLASH] = ACTIONS(5421),
    [anon_sym_PERCENT] = ACTIONS(5419),
    [anon_sym_CARET] = ACTIONS(5419),
    [anon_sym_PIPE] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5421),
    [anon_sym_LT_LT] = ACTIONS(5419),
    [anon_sym_GT_GT] = ACTIONS(5421),
    [anon_sym_GT_GT_GT] = ACTIONS(5419),
    [anon_sym_EQ_EQ] = ACTIONS(5419),
    [anon_sym_BANG_EQ] = ACTIONS(5419),
    [anon_sym_GT_EQ] = ACTIONS(5419),
    [anon_sym_LT_EQ] = ACTIONS(5419),
    [anon_sym_DOT] = ACTIONS(5421),
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [anon_sym_switch] = ACTIONS(5419),
    [anon_sym_when] = ACTIONS(5419),
    [anon_sym_DOT_DOT] = ACTIONS(5419),
    [anon_sym_and] = ACTIONS(5419),
    [anon_sym_or] = ACTIONS(5419),
    [anon_sym_AMP_AMP] = ACTIONS(5419),
    [anon_sym_PIPE_PIPE] = ACTIONS(5419),
    [anon_sym_QMARK_QMARK] = ACTIONS(5419),
    [anon_sym_on] = ACTIONS(5419),
    [anon_sym_equals] = ACTIONS(5419),
    [anon_sym_by] = ACTIONS(5419),
    [anon_sym_as] = ACTIONS(5419),
    [anon_sym_is] = ACTIONS(5419),
    [anon_sym_DASH_GT] = ACTIONS(5419),
    [anon_sym_with] = ACTIONS(5419),
    [aux_sym_preproc_if_token3] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4217] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7073),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9651),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4217),
    [sym_preproc_endregion] = STATE(4217),
    [sym_preproc_line] = STATE(4217),
    [sym_preproc_pragma] = STATE(4217),
    [sym_preproc_nullable] = STATE(4217),
    [sym_preproc_error] = STATE(4217),
    [sym_preproc_define] = STATE(4217),
    [sym_preproc_undef] = STATE(4217),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4218] = {
    [sym_preproc_region] = STATE(4218),
    [sym_preproc_endregion] = STATE(4218),
    [sym_preproc_line] = STATE(4218),
    [sym_preproc_pragma] = STATE(4218),
    [sym_preproc_nullable] = STATE(4218),
    [sym_preproc_error] = STATE(4218),
    [sym_preproc_define] = STATE(4218),
    [sym_preproc_undef] = STATE(4218),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_COLON] = ACTIONS(4320),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LT] = ACTIONS(5948),
    [anon_sym_GT] = ACTIONS(5948),
    [anon_sym_in] = ACTIONS(4320),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5948),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_SLASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(4320),
    [anon_sym_CARET] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(5948),
    [anon_sym_AMP] = ACTIONS(5948),
    [anon_sym_LT_LT] = ACTIONS(4320),
    [anon_sym_GT_GT] = ACTIONS(5948),
    [anon_sym_GT_GT_GT] = ACTIONS(4320),
    [anon_sym_EQ_EQ] = ACTIONS(4320),
    [anon_sym_BANG_EQ] = ACTIONS(4320),
    [anon_sym_GT_EQ] = ACTIONS(4320),
    [anon_sym_LT_EQ] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(5948),
    [anon_sym_EQ_GT] = ACTIONS(4149),
    [anon_sym_switch] = ACTIONS(4320),
    [anon_sym_when] = ACTIONS(4320),
    [anon_sym_DOT_DOT] = ACTIONS(4320),
    [anon_sym_and] = ACTIONS(4320),
    [anon_sym_or] = ACTIONS(4320),
    [anon_sym_AMP_AMP] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(4320),
    [anon_sym_QMARK_QMARK] = ACTIONS(4320),
    [anon_sym_on] = ACTIONS(4320),
    [anon_sym_equals] = ACTIONS(4320),
    [anon_sym_by] = ACTIONS(4320),
    [anon_sym_as] = ACTIONS(4320),
    [anon_sym_is] = ACTIONS(4320),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [anon_sym_with] = ACTIONS(4320),
    [aux_sym_preproc_if_token3] = ACTIONS(4320),
    [aux_sym_preproc_else_token1] = ACTIONS(4320),
    [aux_sym_preproc_elif_token1] = ACTIONS(4320),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4219] = {
    [sym_preproc_region] = STATE(4219),
    [sym_preproc_endregion] = STATE(4219),
    [sym_preproc_line] = STATE(4219),
    [sym_preproc_pragma] = STATE(4219),
    [sym_preproc_nullable] = STATE(4219),
    [sym_preproc_error] = STATE(4219),
    [sym_preproc_define] = STATE(4219),
    [sym_preproc_undef] = STATE(4219),
    [anon_sym_SEMI] = ACTIONS(5944),
    [anon_sym_LBRACK] = ACTIONS(5944),
    [anon_sym_COLON] = ACTIONS(5944),
    [anon_sym_COMMA] = ACTIONS(5944),
    [anon_sym_RBRACK] = ACTIONS(5944),
    [anon_sym_LPAREN] = ACTIONS(5944),
    [anon_sym_RPAREN] = ACTIONS(5944),
    [anon_sym_RBRACE] = ACTIONS(5944),
    [anon_sym_LT] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5946),
    [anon_sym_in] = ACTIONS(5944),
    [anon_sym_QMARK] = ACTIONS(5946),
    [anon_sym_BANG] = ACTIONS(5946),
    [anon_sym_PLUS_PLUS] = ACTIONS(5944),
    [anon_sym_DASH_DASH] = ACTIONS(5944),
    [anon_sym_PLUS] = ACTIONS(5946),
    [anon_sym_DASH] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(5944),
    [anon_sym_SLASH] = ACTIONS(5946),
    [anon_sym_PERCENT] = ACTIONS(5944),
    [anon_sym_CARET] = ACTIONS(5944),
    [anon_sym_PIPE] = ACTIONS(5946),
    [anon_sym_AMP] = ACTIONS(5946),
    [anon_sym_LT_LT] = ACTIONS(5944),
    [anon_sym_GT_GT] = ACTIONS(5946),
    [anon_sym_GT_GT_GT] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5944),
    [anon_sym_BANG_EQ] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5944),
    [anon_sym_LT_EQ] = ACTIONS(5944),
    [anon_sym_DOT] = ACTIONS(5946),
    [anon_sym_EQ_GT] = ACTIONS(5944),
    [anon_sym_switch] = ACTIONS(5944),
    [anon_sym_when] = ACTIONS(5944),
    [anon_sym_DOT_DOT] = ACTIONS(5944),
    [anon_sym_and] = ACTIONS(5944),
    [anon_sym_or] = ACTIONS(5944),
    [anon_sym_AMP_AMP] = ACTIONS(5944),
    [anon_sym_PIPE_PIPE] = ACTIONS(5944),
    [anon_sym_QMARK_QMARK] = ACTIONS(5944),
    [anon_sym_on] = ACTIONS(5944),
    [anon_sym_equals] = ACTIONS(5944),
    [anon_sym_by] = ACTIONS(5944),
    [anon_sym_as] = ACTIONS(5944),
    [anon_sym_is] = ACTIONS(5944),
    [anon_sym_DASH_GT] = ACTIONS(5944),
    [anon_sym_with] = ACTIONS(5944),
    [aux_sym_preproc_if_token3] = ACTIONS(5944),
    [aux_sym_preproc_else_token1] = ACTIONS(5944),
    [aux_sym_preproc_elif_token1] = ACTIONS(5944),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4220] = {
    [sym_preproc_region] = STATE(4220),
    [sym_preproc_endregion] = STATE(4220),
    [sym_preproc_line] = STATE(4220),
    [sym_preproc_pragma] = STATE(4220),
    [sym_preproc_nullable] = STATE(4220),
    [sym_preproc_error] = STATE(4220),
    [sym_preproc_define] = STATE(4220),
    [sym_preproc_undef] = STATE(4220),
    [anon_sym_SEMI] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_COLON] = ACTIONS(5415),
    [anon_sym_COMMA] = ACTIONS(5415),
    [anon_sym_RBRACK] = ACTIONS(5415),
    [anon_sym_LPAREN] = ACTIONS(5415),
    [anon_sym_RPAREN] = ACTIONS(5415),
    [anon_sym_RBRACE] = ACTIONS(5415),
    [anon_sym_LT] = ACTIONS(5417),
    [anon_sym_GT] = ACTIONS(5417),
    [anon_sym_in] = ACTIONS(5415),
    [anon_sym_QMARK] = ACTIONS(5417),
    [anon_sym_BANG] = ACTIONS(5417),
    [anon_sym_PLUS_PLUS] = ACTIONS(5415),
    [anon_sym_DASH_DASH] = ACTIONS(5415),
    [anon_sym_PLUS] = ACTIONS(5417),
    [anon_sym_DASH] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5415),
    [anon_sym_SLASH] = ACTIONS(5417),
    [anon_sym_PERCENT] = ACTIONS(5415),
    [anon_sym_CARET] = ACTIONS(5415),
    [anon_sym_PIPE] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5417),
    [anon_sym_LT_LT] = ACTIONS(5415),
    [anon_sym_GT_GT] = ACTIONS(5417),
    [anon_sym_GT_GT_GT] = ACTIONS(5415),
    [anon_sym_EQ_EQ] = ACTIONS(5415),
    [anon_sym_BANG_EQ] = ACTIONS(5415),
    [anon_sym_GT_EQ] = ACTIONS(5415),
    [anon_sym_LT_EQ] = ACTIONS(5415),
    [anon_sym_DOT] = ACTIONS(5417),
    [anon_sym_EQ_GT] = ACTIONS(5415),
    [anon_sym_switch] = ACTIONS(5415),
    [anon_sym_when] = ACTIONS(5415),
    [anon_sym_DOT_DOT] = ACTIONS(5415),
    [anon_sym_and] = ACTIONS(5415),
    [anon_sym_or] = ACTIONS(5415),
    [anon_sym_AMP_AMP] = ACTIONS(5415),
    [anon_sym_PIPE_PIPE] = ACTIONS(5415),
    [anon_sym_QMARK_QMARK] = ACTIONS(5415),
    [anon_sym_on] = ACTIONS(5415),
    [anon_sym_equals] = ACTIONS(5415),
    [anon_sym_by] = ACTIONS(5415),
    [anon_sym_as] = ACTIONS(5415),
    [anon_sym_is] = ACTIONS(5415),
    [anon_sym_DASH_GT] = ACTIONS(5415),
    [anon_sym_with] = ACTIONS(5415),
    [aux_sym_preproc_if_token3] = ACTIONS(5415),
    [aux_sym_preproc_else_token1] = ACTIONS(5415),
    [aux_sym_preproc_elif_token1] = ACTIONS(5415),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4221] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6977),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9939),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4221),
    [sym_preproc_endregion] = STATE(4221),
    [sym_preproc_line] = STATE(4221),
    [sym_preproc_pragma] = STATE(4221),
    [sym_preproc_nullable] = STATE(4221),
    [sym_preproc_error] = STATE(4221),
    [sym_preproc_define] = STATE(4221),
    [sym_preproc_undef] = STATE(4221),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4222] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6960),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9479),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4222),
    [sym_preproc_endregion] = STATE(4222),
    [sym_preproc_line] = STATE(4222),
    [sym_preproc_pragma] = STATE(4222),
    [sym_preproc_nullable] = STATE(4222),
    [sym_preproc_error] = STATE(4222),
    [sym_preproc_define] = STATE(4222),
    [sym_preproc_undef] = STATE(4222),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4223] = {
    [sym_preproc_region] = STATE(4223),
    [sym_preproc_endregion] = STATE(4223),
    [sym_preproc_line] = STATE(4223),
    [sym_preproc_pragma] = STATE(4223),
    [sym_preproc_nullable] = STATE(4223),
    [sym_preproc_error] = STATE(4223),
    [sym_preproc_define] = STATE(4223),
    [sym_preproc_undef] = STATE(4223),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_COLON] = ACTIONS(4320),
    [anon_sym_COMMA] = ACTIONS(4320),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LT] = ACTIONS(5948),
    [anon_sym_GT] = ACTIONS(5948),
    [anon_sym_in] = ACTIONS(4320),
    [anon_sym_QMARK] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5948),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(5948),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_SLASH] = ACTIONS(5948),
    [anon_sym_PERCENT] = ACTIONS(4320),
    [anon_sym_CARET] = ACTIONS(4320),
    [anon_sym_PIPE] = ACTIONS(5948),
    [anon_sym_AMP] = ACTIONS(5948),
    [anon_sym_LT_LT] = ACTIONS(4320),
    [anon_sym_GT_GT] = ACTIONS(5948),
    [anon_sym_GT_GT_GT] = ACTIONS(4320),
    [anon_sym_EQ_EQ] = ACTIONS(4320),
    [anon_sym_BANG_EQ] = ACTIONS(4320),
    [anon_sym_GT_EQ] = ACTIONS(4320),
    [anon_sym_LT_EQ] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(5948),
    [anon_sym_EQ_GT] = ACTIONS(4320),
    [anon_sym_switch] = ACTIONS(4320),
    [anon_sym_when] = ACTIONS(4320),
    [anon_sym_DOT_DOT] = ACTIONS(4320),
    [anon_sym_and] = ACTIONS(4320),
    [anon_sym_or] = ACTIONS(4320),
    [anon_sym_AMP_AMP] = ACTIONS(4320),
    [anon_sym_PIPE_PIPE] = ACTIONS(4320),
    [anon_sym_QMARK_QMARK] = ACTIONS(4320),
    [anon_sym_on] = ACTIONS(4320),
    [anon_sym_equals] = ACTIONS(4320),
    [anon_sym_by] = ACTIONS(4320),
    [anon_sym_as] = ACTIONS(4320),
    [anon_sym_is] = ACTIONS(4320),
    [anon_sym_DASH_GT] = ACTIONS(4320),
    [anon_sym_with] = ACTIONS(4320),
    [aux_sym_preproc_if_token3] = ACTIONS(4320),
    [aux_sym_preproc_else_token1] = ACTIONS(4320),
    [aux_sym_preproc_elif_token1] = ACTIONS(4320),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4224] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9671),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4224),
    [sym_preproc_endregion] = STATE(4224),
    [sym_preproc_line] = STATE(4224),
    [sym_preproc_pragma] = STATE(4224),
    [sym_preproc_nullable] = STATE(4224),
    [sym_preproc_error] = STATE(4224),
    [sym_preproc_define] = STATE(4224),
    [sym_preproc_undef] = STATE(4224),
    [aux_sym_function_pointer_type_repeat1] = STATE(4236),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4225] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9480),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4225),
    [sym_preproc_endregion] = STATE(4225),
    [sym_preproc_line] = STATE(4225),
    [sym_preproc_pragma] = STATE(4225),
    [sym_preproc_nullable] = STATE(4225),
    [sym_preproc_error] = STATE(4225),
    [sym_preproc_define] = STATE(4225),
    [sym_preproc_undef] = STATE(4225),
    [aux_sym_function_pointer_type_repeat1] = STATE(4229),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4226] = {
    [sym_preproc_region] = STATE(4226),
    [sym_preproc_endregion] = STATE(4226),
    [sym_preproc_line] = STATE(4226),
    [sym_preproc_pragma] = STATE(4226),
    [sym_preproc_nullable] = STATE(4226),
    [sym_preproc_error] = STATE(4226),
    [sym_preproc_define] = STATE(4226),
    [sym_preproc_undef] = STATE(4226),
    [anon_sym_SEMI] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [anon_sym_COLON] = ACTIONS(5950),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_RBRACK] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_RBRACE] = ACTIONS(5950),
    [anon_sym_LT] = ACTIONS(5952),
    [anon_sym_GT] = ACTIONS(5952),
    [anon_sym_in] = ACTIONS(5950),
    [anon_sym_QMARK] = ACTIONS(5952),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_PLUS_PLUS] = ACTIONS(5950),
    [anon_sym_DASH_DASH] = ACTIONS(5950),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_STAR] = ACTIONS(5950),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_PERCENT] = ACTIONS(5950),
    [anon_sym_CARET] = ACTIONS(5950),
    [anon_sym_PIPE] = ACTIONS(5952),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_LT_LT] = ACTIONS(5950),
    [anon_sym_GT_GT] = ACTIONS(5952),
    [anon_sym_GT_GT_GT] = ACTIONS(5950),
    [anon_sym_EQ_EQ] = ACTIONS(5950),
    [anon_sym_BANG_EQ] = ACTIONS(5950),
    [anon_sym_GT_EQ] = ACTIONS(5950),
    [anon_sym_LT_EQ] = ACTIONS(5950),
    [anon_sym_DOT] = ACTIONS(5952),
    [anon_sym_EQ_GT] = ACTIONS(5950),
    [anon_sym_switch] = ACTIONS(5950),
    [anon_sym_when] = ACTIONS(5950),
    [anon_sym_DOT_DOT] = ACTIONS(5950),
    [anon_sym_and] = ACTIONS(5950),
    [anon_sym_or] = ACTIONS(5950),
    [anon_sym_AMP_AMP] = ACTIONS(5950),
    [anon_sym_PIPE_PIPE] = ACTIONS(5950),
    [anon_sym_QMARK_QMARK] = ACTIONS(5950),
    [anon_sym_on] = ACTIONS(5950),
    [anon_sym_equals] = ACTIONS(5950),
    [anon_sym_by] = ACTIONS(5950),
    [anon_sym_as] = ACTIONS(5950),
    [anon_sym_is] = ACTIONS(5950),
    [anon_sym_DASH_GT] = ACTIONS(5950),
    [anon_sym_with] = ACTIONS(5950),
    [aux_sym_preproc_if_token3] = ACTIONS(5950),
    [aux_sym_preproc_else_token1] = ACTIONS(5950),
    [aux_sym_preproc_elif_token1] = ACTIONS(5950),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4227] = {
    [sym_preproc_region] = STATE(4227),
    [sym_preproc_endregion] = STATE(4227),
    [sym_preproc_line] = STATE(4227),
    [sym_preproc_pragma] = STATE(4227),
    [sym_preproc_nullable] = STATE(4227),
    [sym_preproc_error] = STATE(4227),
    [sym_preproc_define] = STATE(4227),
    [sym_preproc_undef] = STATE(4227),
    [anon_sym_SEMI] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_LT] = ACTIONS(5956),
    [anon_sym_GT] = ACTIONS(5956),
    [anon_sym_in] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5956),
    [anon_sym_BANG] = ACTIONS(5956),
    [anon_sym_PLUS_PLUS] = ACTIONS(5954),
    [anon_sym_DASH_DASH] = ACTIONS(5954),
    [anon_sym_PLUS] = ACTIONS(5956),
    [anon_sym_DASH] = ACTIONS(5956),
    [anon_sym_STAR] = ACTIONS(5954),
    [anon_sym_SLASH] = ACTIONS(5956),
    [anon_sym_PERCENT] = ACTIONS(5954),
    [anon_sym_CARET] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_AMP] = ACTIONS(5956),
    [anon_sym_LT_LT] = ACTIONS(5954),
    [anon_sym_GT_GT] = ACTIONS(5956),
    [anon_sym_GT_GT_GT] = ACTIONS(5954),
    [anon_sym_EQ_EQ] = ACTIONS(5954),
    [anon_sym_BANG_EQ] = ACTIONS(5954),
    [anon_sym_GT_EQ] = ACTIONS(5954),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5956),
    [anon_sym_EQ_GT] = ACTIONS(5954),
    [anon_sym_switch] = ACTIONS(5954),
    [anon_sym_when] = ACTIONS(5954),
    [anon_sym_DOT_DOT] = ACTIONS(5954),
    [anon_sym_and] = ACTIONS(5954),
    [anon_sym_or] = ACTIONS(5954),
    [anon_sym_AMP_AMP] = ACTIONS(5954),
    [anon_sym_PIPE_PIPE] = ACTIONS(5954),
    [anon_sym_QMARK_QMARK] = ACTIONS(5954),
    [anon_sym_on] = ACTIONS(5954),
    [anon_sym_equals] = ACTIONS(5954),
    [anon_sym_by] = ACTIONS(5954),
    [anon_sym_as] = ACTIONS(5954),
    [anon_sym_is] = ACTIONS(5954),
    [anon_sym_DASH_GT] = ACTIONS(5954),
    [anon_sym_with] = ACTIONS(5954),
    [aux_sym_preproc_if_token3] = ACTIONS(5954),
    [aux_sym_preproc_else_token1] = ACTIONS(5954),
    [aux_sym_preproc_elif_token1] = ACTIONS(5954),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4228] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7072),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9655),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4228),
    [sym_preproc_endregion] = STATE(4228),
    [sym_preproc_line] = STATE(4228),
    [sym_preproc_pragma] = STATE(4228),
    [sym_preproc_nullable] = STATE(4228),
    [sym_preproc_error] = STATE(4228),
    [sym_preproc_define] = STATE(4228),
    [sym_preproc_undef] = STATE(4228),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4229] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9536),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4229),
    [sym_preproc_endregion] = STATE(4229),
    [sym_preproc_line] = STATE(4229),
    [sym_preproc_pragma] = STATE(4229),
    [sym_preproc_nullable] = STATE(4229),
    [sym_preproc_error] = STATE(4229),
    [sym_preproc_define] = STATE(4229),
    [sym_preproc_undef] = STATE(4229),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4230] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7062),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9138),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4230),
    [sym_preproc_endregion] = STATE(4230),
    [sym_preproc_line] = STATE(4230),
    [sym_preproc_pragma] = STATE(4230),
    [sym_preproc_nullable] = STATE(4230),
    [sym_preproc_error] = STATE(4230),
    [sym_preproc_define] = STATE(4230),
    [sym_preproc_undef] = STATE(4230),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4231] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9956),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4231),
    [sym_preproc_endregion] = STATE(4231),
    [sym_preproc_line] = STATE(4231),
    [sym_preproc_pragma] = STATE(4231),
    [sym_preproc_nullable] = STATE(4231),
    [sym_preproc_error] = STATE(4231),
    [sym_preproc_define] = STATE(4231),
    [sym_preproc_undef] = STATE(4231),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4232] = {
    [sym_preproc_region] = STATE(4232),
    [sym_preproc_endregion] = STATE(4232),
    [sym_preproc_line] = STATE(4232),
    [sym_preproc_pragma] = STATE(4232),
    [sym_preproc_nullable] = STATE(4232),
    [sym_preproc_error] = STATE(4232),
    [sym_preproc_define] = STATE(4232),
    [sym_preproc_undef] = STATE(4232),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_COLON] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_RBRACK] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(5468),
    [anon_sym_RPAREN] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5470),
    [anon_sym_BANG] = ACTIONS(5470),
    [anon_sym_PLUS_PLUS] = ACTIONS(5468),
    [anon_sym_DASH_DASH] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5468),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_GT_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_EQ_GT] = ACTIONS(5468),
    [anon_sym_switch] = ACTIONS(5468),
    [anon_sym_when] = ACTIONS(5468),
    [anon_sym_DOT_DOT] = ACTIONS(5468),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_or] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE] = ACTIONS(5468),
    [anon_sym_QMARK_QMARK] = ACTIONS(5468),
    [anon_sym_on] = ACTIONS(5468),
    [anon_sym_equals] = ACTIONS(5468),
    [anon_sym_by] = ACTIONS(5468),
    [anon_sym_as] = ACTIONS(5468),
    [anon_sym_is] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_with] = ACTIONS(5468),
    [aux_sym_preproc_if_token3] = ACTIONS(5468),
    [aux_sym_preproc_else_token1] = ACTIONS(5468),
    [aux_sym_preproc_elif_token1] = ACTIONS(5468),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4233] = {
    [sym_preproc_region] = STATE(4233),
    [sym_preproc_endregion] = STATE(4233),
    [sym_preproc_line] = STATE(4233),
    [sym_preproc_pragma] = STATE(4233),
    [sym_preproc_nullable] = STATE(4233),
    [sym_preproc_error] = STATE(4233),
    [sym_preproc_define] = STATE(4233),
    [sym_preproc_undef] = STATE(4233),
    [anon_sym_SEMI] = ACTIONS(5518),
    [anon_sym_LBRACK] = ACTIONS(5518),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_RBRACK] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(5518),
    [anon_sym_RPAREN] = ACTIONS(5518),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LT] = ACTIONS(5520),
    [anon_sym_GT] = ACTIONS(5520),
    [anon_sym_in] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(5520),
    [anon_sym_BANG] = ACTIONS(5520),
    [anon_sym_PLUS_PLUS] = ACTIONS(5518),
    [anon_sym_DASH_DASH] = ACTIONS(5518),
    [anon_sym_PLUS] = ACTIONS(5520),
    [anon_sym_DASH] = ACTIONS(5520),
    [anon_sym_STAR] = ACTIONS(5518),
    [anon_sym_SLASH] = ACTIONS(5520),
    [anon_sym_PERCENT] = ACTIONS(5518),
    [anon_sym_CARET] = ACTIONS(5518),
    [anon_sym_PIPE] = ACTIONS(5520),
    [anon_sym_AMP] = ACTIONS(5520),
    [anon_sym_LT_LT] = ACTIONS(5518),
    [anon_sym_GT_GT] = ACTIONS(5520),
    [anon_sym_GT_GT_GT] = ACTIONS(5518),
    [anon_sym_EQ_EQ] = ACTIONS(5518),
    [anon_sym_BANG_EQ] = ACTIONS(5518),
    [anon_sym_GT_EQ] = ACTIONS(5518),
    [anon_sym_LT_EQ] = ACTIONS(5518),
    [anon_sym_DOT] = ACTIONS(5520),
    [anon_sym_EQ_GT] = ACTIONS(5518),
    [anon_sym_switch] = ACTIONS(5518),
    [anon_sym_when] = ACTIONS(5518),
    [anon_sym_DOT_DOT] = ACTIONS(5518),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5518),
    [anon_sym_AMP_AMP] = ACTIONS(5518),
    [anon_sym_PIPE_PIPE] = ACTIONS(5518),
    [anon_sym_QMARK_QMARK] = ACTIONS(5518),
    [anon_sym_on] = ACTIONS(5518),
    [anon_sym_equals] = ACTIONS(5518),
    [anon_sym_by] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(5518),
    [anon_sym_is] = ACTIONS(5518),
    [anon_sym_DASH_GT] = ACTIONS(5518),
    [anon_sym_with] = ACTIONS(5518),
    [aux_sym_preproc_if_token3] = ACTIONS(5518),
    [aux_sym_preproc_else_token1] = ACTIONS(5518),
    [aux_sym_preproc_elif_token1] = ACTIONS(5518),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4234] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9388),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4234),
    [sym_preproc_endregion] = STATE(4234),
    [sym_preproc_line] = STATE(4234),
    [sym_preproc_pragma] = STATE(4234),
    [sym_preproc_nullable] = STATE(4234),
    [sym_preproc_error] = STATE(4234),
    [sym_preproc_define] = STATE(4234),
    [sym_preproc_undef] = STATE(4234),
    [aux_sym_function_pointer_type_repeat1] = STATE(4211),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4235] = {
    [sym_preproc_region] = STATE(4235),
    [sym_preproc_endregion] = STATE(4235),
    [sym_preproc_line] = STATE(4235),
    [sym_preproc_pragma] = STATE(4235),
    [sym_preproc_nullable] = STATE(4235),
    [sym_preproc_error] = STATE(4235),
    [sym_preproc_define] = STATE(4235),
    [sym_preproc_undef] = STATE(4235),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5960),
    [anon_sym_GT] = ACTIONS(5960),
    [anon_sym_in] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5960),
    [anon_sym_BANG] = ACTIONS(5960),
    [anon_sym_PLUS_PLUS] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5960),
    [anon_sym_DASH] = ACTIONS(5960),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5960),
    [anon_sym_PERCENT] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(5960),
    [anon_sym_AMP] = ACTIONS(5960),
    [anon_sym_LT_LT] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5960),
    [anon_sym_GT_GT_GT] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_BANG_EQ] = ACTIONS(5958),
    [anon_sym_GT_EQ] = ACTIONS(5958),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_DOT] = ACTIONS(5960),
    [anon_sym_EQ_GT] = ACTIONS(5958),
    [anon_sym_switch] = ACTIONS(5958),
    [anon_sym_when] = ACTIONS(5958),
    [anon_sym_DOT_DOT] = ACTIONS(5958),
    [anon_sym_and] = ACTIONS(5958),
    [anon_sym_or] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5958),
    [anon_sym_QMARK_QMARK] = ACTIONS(5958),
    [anon_sym_on] = ACTIONS(5958),
    [anon_sym_equals] = ACTIONS(5958),
    [anon_sym_by] = ACTIONS(5958),
    [anon_sym_as] = ACTIONS(5958),
    [anon_sym_is] = ACTIONS(5958),
    [anon_sym_DASH_GT] = ACTIONS(5958),
    [anon_sym_with] = ACTIONS(5958),
    [aux_sym_preproc_if_token3] = ACTIONS(5958),
    [aux_sym_preproc_else_token1] = ACTIONS(5958),
    [aux_sym_preproc_elif_token1] = ACTIONS(5958),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4236] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9673),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4236),
    [sym_preproc_endregion] = STATE(4236),
    [sym_preproc_line] = STATE(4236),
    [sym_preproc_pragma] = STATE(4236),
    [sym_preproc_nullable] = STATE(4236),
    [sym_preproc_error] = STATE(4236),
    [sym_preproc_define] = STATE(4236),
    [sym_preproc_undef] = STATE(4236),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4237] = {
    [sym_preproc_region] = STATE(4237),
    [sym_preproc_endregion] = STATE(4237),
    [sym_preproc_line] = STATE(4237),
    [sym_preproc_pragma] = STATE(4237),
    [sym_preproc_nullable] = STATE(4237),
    [sym_preproc_error] = STATE(4237),
    [sym_preproc_define] = STATE(4237),
    [sym_preproc_undef] = STATE(4237),
    [anon_sym_SEMI] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_COMMA] = ACTIONS(5427),
    [anon_sym_RBRACK] = ACTIONS(5427),
    [anon_sym_LPAREN] = ACTIONS(5427),
    [anon_sym_RPAREN] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5427),
    [anon_sym_LT] = ACTIONS(5429),
    [anon_sym_GT] = ACTIONS(5429),
    [anon_sym_in] = ACTIONS(5427),
    [anon_sym_QMARK] = ACTIONS(5429),
    [anon_sym_BANG] = ACTIONS(5429),
    [anon_sym_PLUS_PLUS] = ACTIONS(5427),
    [anon_sym_DASH_DASH] = ACTIONS(5427),
    [anon_sym_PLUS] = ACTIONS(5429),
    [anon_sym_DASH] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_SLASH] = ACTIONS(5429),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_CARET] = ACTIONS(5427),
    [anon_sym_PIPE] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5429),
    [anon_sym_LT_LT] = ACTIONS(5427),
    [anon_sym_GT_GT] = ACTIONS(5429),
    [anon_sym_GT_GT_GT] = ACTIONS(5427),
    [anon_sym_EQ_EQ] = ACTIONS(5427),
    [anon_sym_BANG_EQ] = ACTIONS(5427),
    [anon_sym_GT_EQ] = ACTIONS(5427),
    [anon_sym_LT_EQ] = ACTIONS(5427),
    [anon_sym_DOT] = ACTIONS(5429),
    [anon_sym_EQ_GT] = ACTIONS(5427),
    [anon_sym_switch] = ACTIONS(5427),
    [anon_sym_when] = ACTIONS(5427),
    [anon_sym_DOT_DOT] = ACTIONS(5427),
    [anon_sym_and] = ACTIONS(5427),
    [anon_sym_or] = ACTIONS(5427),
    [anon_sym_AMP_AMP] = ACTIONS(5427),
    [anon_sym_PIPE_PIPE] = ACTIONS(5427),
    [anon_sym_QMARK_QMARK] = ACTIONS(5427),
    [anon_sym_on] = ACTIONS(5427),
    [anon_sym_equals] = ACTIONS(5427),
    [anon_sym_by] = ACTIONS(5427),
    [anon_sym_as] = ACTIONS(5427),
    [anon_sym_is] = ACTIONS(5427),
    [anon_sym_DASH_GT] = ACTIONS(5427),
    [anon_sym_with] = ACTIONS(5427),
    [aux_sym_preproc_if_token3] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4238] = {
    [sym_preproc_region] = STATE(4238),
    [sym_preproc_endregion] = STATE(4238),
    [sym_preproc_line] = STATE(4238),
    [sym_preproc_pragma] = STATE(4238),
    [sym_preproc_nullable] = STATE(4238),
    [sym_preproc_error] = STATE(4238),
    [sym_preproc_define] = STATE(4238),
    [sym_preproc_undef] = STATE(4238),
    [anon_sym_SEMI] = ACTIONS(5534),
    [anon_sym_LBRACK] = ACTIONS(5534),
    [anon_sym_COLON] = ACTIONS(5534),
    [anon_sym_COMMA] = ACTIONS(5534),
    [anon_sym_RBRACK] = ACTIONS(5534),
    [anon_sym_LPAREN] = ACTIONS(5534),
    [anon_sym_RPAREN] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LT] = ACTIONS(5536),
    [anon_sym_GT] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5534),
    [anon_sym_QMARK] = ACTIONS(5536),
    [anon_sym_BANG] = ACTIONS(5536),
    [anon_sym_PLUS_PLUS] = ACTIONS(5534),
    [anon_sym_DASH_DASH] = ACTIONS(5534),
    [anon_sym_PLUS] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [anon_sym_STAR] = ACTIONS(5534),
    [anon_sym_SLASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5534),
    [anon_sym_CARET] = ACTIONS(5534),
    [anon_sym_PIPE] = ACTIONS(5536),
    [anon_sym_AMP] = ACTIONS(5536),
    [anon_sym_LT_LT] = ACTIONS(5534),
    [anon_sym_GT_GT] = ACTIONS(5536),
    [anon_sym_GT_GT_GT] = ACTIONS(5534),
    [anon_sym_EQ_EQ] = ACTIONS(5534),
    [anon_sym_BANG_EQ] = ACTIONS(5534),
    [anon_sym_GT_EQ] = ACTIONS(5534),
    [anon_sym_LT_EQ] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(5536),
    [anon_sym_EQ_GT] = ACTIONS(5534),
    [anon_sym_switch] = ACTIONS(5534),
    [anon_sym_when] = ACTIONS(5534),
    [anon_sym_DOT_DOT] = ACTIONS(5534),
    [anon_sym_and] = ACTIONS(5534),
    [anon_sym_or] = ACTIONS(5534),
    [anon_sym_AMP_AMP] = ACTIONS(5534),
    [anon_sym_PIPE_PIPE] = ACTIONS(5534),
    [anon_sym_QMARK_QMARK] = ACTIONS(5534),
    [anon_sym_on] = ACTIONS(5534),
    [anon_sym_equals] = ACTIONS(5534),
    [anon_sym_by] = ACTIONS(5534),
    [anon_sym_as] = ACTIONS(5534),
    [anon_sym_is] = ACTIONS(5534),
    [anon_sym_DASH_GT] = ACTIONS(5534),
    [anon_sym_with] = ACTIONS(5534),
    [aux_sym_preproc_if_token3] = ACTIONS(5534),
    [aux_sym_preproc_else_token1] = ACTIONS(5534),
    [aux_sym_preproc_elif_token1] = ACTIONS(5534),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4239] = {
    [sym_preproc_region] = STATE(4239),
    [sym_preproc_endregion] = STATE(4239),
    [sym_preproc_line] = STATE(4239),
    [sym_preproc_pragma] = STATE(4239),
    [sym_preproc_nullable] = STATE(4239),
    [sym_preproc_error] = STATE(4239),
    [sym_preproc_define] = STATE(4239),
    [sym_preproc_undef] = STATE(4239),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(5440),
    [anon_sym_COMMA] = ACTIONS(5440),
    [anon_sym_RBRACK] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(5440),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LT] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(5442),
    [anon_sym_in] = ACTIONS(5440),
    [anon_sym_QMARK] = ACTIONS(5442),
    [anon_sym_BANG] = ACTIONS(5442),
    [anon_sym_PLUS_PLUS] = ACTIONS(5440),
    [anon_sym_DASH_DASH] = ACTIONS(5440),
    [anon_sym_PLUS] = ACTIONS(5442),
    [anon_sym_DASH] = ACTIONS(5442),
    [anon_sym_STAR] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(5442),
    [anon_sym_PERCENT] = ACTIONS(5440),
    [anon_sym_CARET] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(5442),
    [anon_sym_AMP] = ACTIONS(5442),
    [anon_sym_LT_LT] = ACTIONS(5440),
    [anon_sym_GT_GT] = ACTIONS(5442),
    [anon_sym_GT_GT_GT] = ACTIONS(5440),
    [anon_sym_EQ_EQ] = ACTIONS(5440),
    [anon_sym_BANG_EQ] = ACTIONS(5440),
    [anon_sym_GT_EQ] = ACTIONS(5440),
    [anon_sym_LT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(5442),
    [anon_sym_EQ_GT] = ACTIONS(5440),
    [anon_sym_switch] = ACTIONS(5440),
    [anon_sym_when] = ACTIONS(5440),
    [anon_sym_DOT_DOT] = ACTIONS(5440),
    [anon_sym_and] = ACTIONS(5440),
    [anon_sym_or] = ACTIONS(5440),
    [anon_sym_AMP_AMP] = ACTIONS(5440),
    [anon_sym_PIPE_PIPE] = ACTIONS(5440),
    [anon_sym_QMARK_QMARK] = ACTIONS(5440),
    [anon_sym_on] = ACTIONS(5440),
    [anon_sym_equals] = ACTIONS(5440),
    [anon_sym_by] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(5440),
    [anon_sym_is] = ACTIONS(5440),
    [anon_sym_DASH_GT] = ACTIONS(5440),
    [anon_sym_with] = ACTIONS(5440),
    [aux_sym_preproc_if_token3] = ACTIONS(5440),
    [aux_sym_preproc_else_token1] = ACTIONS(5440),
    [aux_sym_preproc_elif_token1] = ACTIONS(5440),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4240] = {
    [sym_preproc_region] = STATE(4240),
    [sym_preproc_endregion] = STATE(4240),
    [sym_preproc_line] = STATE(4240),
    [sym_preproc_pragma] = STATE(4240),
    [sym_preproc_nullable] = STATE(4240),
    [sym_preproc_error] = STATE(4240),
    [sym_preproc_define] = STATE(4240),
    [sym_preproc_undef] = STATE(4240),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_RBRACK] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5446),
    [anon_sym_BANG] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(5444),
    [anon_sym_DASH_DASH] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5444),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5444),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_GT_GT_GT] = ACTIONS(5444),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(5444),
    [anon_sym_switch] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_DOT_DOT] = ACTIONS(5444),
    [anon_sym_and] = ACTIONS(5444),
    [anon_sym_or] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE] = ACTIONS(5444),
    [anon_sym_QMARK_QMARK] = ACTIONS(5444),
    [anon_sym_on] = ACTIONS(5444),
    [anon_sym_equals] = ACTIONS(5444),
    [anon_sym_by] = ACTIONS(5444),
    [anon_sym_as] = ACTIONS(5444),
    [anon_sym_is] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_with] = ACTIONS(5444),
    [aux_sym_preproc_if_token3] = ACTIONS(5444),
    [aux_sym_preproc_else_token1] = ACTIONS(5444),
    [aux_sym_preproc_elif_token1] = ACTIONS(5444),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4241] = {
    [sym_preproc_region] = STATE(4241),
    [sym_preproc_endregion] = STATE(4241),
    [sym_preproc_line] = STATE(4241),
    [sym_preproc_pragma] = STATE(4241),
    [sym_preproc_nullable] = STATE(4241),
    [sym_preproc_error] = STATE(4241),
    [sym_preproc_define] = STATE(4241),
    [sym_preproc_undef] = STATE(4241),
    [anon_sym_SEMI] = ACTIONS(5612),
    [anon_sym_LBRACK] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_COMMA] = ACTIONS(5612),
    [anon_sym_RBRACK] = ACTIONS(5612),
    [anon_sym_LPAREN] = ACTIONS(5612),
    [anon_sym_RPAREN] = ACTIONS(5612),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_LT] = ACTIONS(5614),
    [anon_sym_GT] = ACTIONS(5614),
    [anon_sym_in] = ACTIONS(5612),
    [anon_sym_QMARK] = ACTIONS(5614),
    [anon_sym_BANG] = ACTIONS(5614),
    [anon_sym_PLUS_PLUS] = ACTIONS(5612),
    [anon_sym_DASH_DASH] = ACTIONS(5612),
    [anon_sym_PLUS] = ACTIONS(5614),
    [anon_sym_DASH] = ACTIONS(5614),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_CARET] = ACTIONS(5612),
    [anon_sym_PIPE] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5614),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5614),
    [anon_sym_GT_GT_GT] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5612),
    [anon_sym_BANG_EQ] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5612),
    [anon_sym_LT_EQ] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(5614),
    [anon_sym_EQ_GT] = ACTIONS(5612),
    [anon_sym_switch] = ACTIONS(5612),
    [anon_sym_when] = ACTIONS(5612),
    [anon_sym_DOT_DOT] = ACTIONS(5612),
    [anon_sym_and] = ACTIONS(5612),
    [anon_sym_or] = ACTIONS(5612),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5612),
    [anon_sym_QMARK_QMARK] = ACTIONS(5612),
    [anon_sym_on] = ACTIONS(5612),
    [anon_sym_equals] = ACTIONS(5612),
    [anon_sym_by] = ACTIONS(5612),
    [anon_sym_as] = ACTIONS(5612),
    [anon_sym_is] = ACTIONS(5612),
    [anon_sym_DASH_GT] = ACTIONS(5612),
    [anon_sym_with] = ACTIONS(5612),
    [aux_sym_preproc_if_token3] = ACTIONS(5612),
    [aux_sym_preproc_else_token1] = ACTIONS(5612),
    [aux_sym_preproc_elif_token1] = ACTIONS(5612),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4242] = {
    [sym_preproc_region] = STATE(4242),
    [sym_preproc_endregion] = STATE(4242),
    [sym_preproc_line] = STATE(4242),
    [sym_preproc_pragma] = STATE(4242),
    [sym_preproc_nullable] = STATE(4242),
    [sym_preproc_error] = STATE(4242),
    [sym_preproc_define] = STATE(4242),
    [sym_preproc_undef] = STATE(4242),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_RBRACK] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_RPAREN] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5454),
    [anon_sym_BANG] = ACTIONS(5454),
    [anon_sym_PLUS_PLUS] = ACTIONS(5452),
    [anon_sym_DASH_DASH] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5452),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5452),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_GT_GT_GT] = ACTIONS(5452),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_EQ_GT] = ACTIONS(5452),
    [anon_sym_switch] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_DOT_DOT] = ACTIONS(5452),
    [anon_sym_and] = ACTIONS(5452),
    [anon_sym_or] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE] = ACTIONS(5452),
    [anon_sym_QMARK_QMARK] = ACTIONS(5452),
    [anon_sym_on] = ACTIONS(5452),
    [anon_sym_equals] = ACTIONS(5452),
    [anon_sym_by] = ACTIONS(5452),
    [anon_sym_as] = ACTIONS(5452),
    [anon_sym_is] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_with] = ACTIONS(5452),
    [aux_sym_preproc_if_token3] = ACTIONS(5452),
    [aux_sym_preproc_else_token1] = ACTIONS(5452),
    [aux_sym_preproc_elif_token1] = ACTIONS(5452),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4243] = {
    [sym_preproc_region] = STATE(4243),
    [sym_preproc_endregion] = STATE(4243),
    [sym_preproc_line] = STATE(4243),
    [sym_preproc_pragma] = STATE(4243),
    [sym_preproc_nullable] = STATE(4243),
    [sym_preproc_error] = STATE(4243),
    [sym_preproc_define] = STATE(4243),
    [sym_preproc_undef] = STATE(4243),
    [anon_sym_SEMI] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5506),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_RBRACK] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5506),
    [anon_sym_RPAREN] = ACTIONS(5506),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5508),
    [anon_sym_in] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_BANG] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5508),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5508),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_PIPE] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5508),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_GT_GT_GT] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5506),
    [anon_sym_BANG_EQ] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5506),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(5508),
    [anon_sym_EQ_GT] = ACTIONS(5506),
    [anon_sym_switch] = ACTIONS(5506),
    [anon_sym_when] = ACTIONS(5506),
    [anon_sym_DOT_DOT] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_AMP_AMP] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5506),
    [anon_sym_QMARK_QMARK] = ACTIONS(5506),
    [anon_sym_on] = ACTIONS(5506),
    [anon_sym_equals] = ACTIONS(5506),
    [anon_sym_by] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(5506),
    [anon_sym_is] = ACTIONS(5506),
    [anon_sym_DASH_GT] = ACTIONS(5506),
    [anon_sym_with] = ACTIONS(5506),
    [aux_sym_preproc_if_token3] = ACTIONS(5506),
    [aux_sym_preproc_else_token1] = ACTIONS(5506),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4244] = {
    [sym_preproc_region] = STATE(4244),
    [sym_preproc_endregion] = STATE(4244),
    [sym_preproc_line] = STATE(4244),
    [sym_preproc_pragma] = STATE(4244),
    [sym_preproc_nullable] = STATE(4244),
    [sym_preproc_error] = STATE(4244),
    [sym_preproc_define] = STATE(4244),
    [sym_preproc_undef] = STATE(4244),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_COLON] = ACTIONS(5616),
    [anon_sym_COMMA] = ACTIONS(5616),
    [anon_sym_RBRACK] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [anon_sym_RPAREN] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_in] = ACTIONS(5616),
    [anon_sym_QMARK] = ACTIONS(5618),
    [anon_sym_BANG] = ACTIONS(5618),
    [anon_sym_PLUS_PLUS] = ACTIONS(5616),
    [anon_sym_DASH_DASH] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5616),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5616),
    [anon_sym_CARET] = ACTIONS(5616),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5616),
    [anon_sym_GT_GT] = ACTIONS(5618),
    [anon_sym_GT_GT_GT] = ACTIONS(5616),
    [anon_sym_EQ_EQ] = ACTIONS(5616),
    [anon_sym_BANG_EQ] = ACTIONS(5616),
    [anon_sym_GT_EQ] = ACTIONS(5616),
    [anon_sym_LT_EQ] = ACTIONS(5616),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5616),
    [anon_sym_switch] = ACTIONS(5616),
    [anon_sym_when] = ACTIONS(5616),
    [anon_sym_DOT_DOT] = ACTIONS(5616),
    [anon_sym_and] = ACTIONS(5616),
    [anon_sym_or] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5616),
    [anon_sym_PIPE_PIPE] = ACTIONS(5616),
    [anon_sym_QMARK_QMARK] = ACTIONS(5616),
    [anon_sym_on] = ACTIONS(5616),
    [anon_sym_equals] = ACTIONS(5616),
    [anon_sym_by] = ACTIONS(5616),
    [anon_sym_as] = ACTIONS(5616),
    [anon_sym_is] = ACTIONS(5616),
    [anon_sym_DASH_GT] = ACTIONS(5616),
    [anon_sym_with] = ACTIONS(5616),
    [aux_sym_preproc_if_token3] = ACTIONS(5616),
    [aux_sym_preproc_else_token1] = ACTIONS(5616),
    [aux_sym_preproc_elif_token1] = ACTIONS(5616),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4245] = {
    [sym_preproc_region] = STATE(4245),
    [sym_preproc_endregion] = STATE(4245),
    [sym_preproc_line] = STATE(4245),
    [sym_preproc_pragma] = STATE(4245),
    [sym_preproc_nullable] = STATE(4245),
    [sym_preproc_error] = STATE(4245),
    [sym_preproc_define] = STATE(4245),
    [sym_preproc_undef] = STATE(4245),
    [anon_sym_EQ] = ACTIONS(6026),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6028),
    [anon_sym_DASH_EQ] = ACTIONS(6028),
    [anon_sym_STAR_EQ] = ACTIONS(6028),
    [anon_sym_SLASH_EQ] = ACTIONS(6028),
    [anon_sym_PERCENT_EQ] = ACTIONS(6028),
    [anon_sym_AMP_EQ] = ACTIONS(6028),
    [anon_sym_CARET_EQ] = ACTIONS(6028),
    [anon_sym_PIPE_EQ] = ACTIONS(6028),
    [anon_sym_LT_LT_EQ] = ACTIONS(6028),
    [anon_sym_GT_GT_EQ] = ACTIONS(6028),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6028),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6028),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4246] = {
    [sym_preproc_region] = STATE(4246),
    [sym_preproc_endregion] = STATE(4246),
    [sym_preproc_line] = STATE(4246),
    [sym_preproc_pragma] = STATE(4246),
    [sym_preproc_nullable] = STATE(4246),
    [sym_preproc_error] = STATE(4246),
    [sym_preproc_define] = STATE(4246),
    [sym_preproc_undef] = STATE(4246),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(6030),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6032),
    [anon_sym_DASH_EQ] = ACTIONS(6032),
    [anon_sym_STAR_EQ] = ACTIONS(6032),
    [anon_sym_SLASH_EQ] = ACTIONS(6032),
    [anon_sym_PERCENT_EQ] = ACTIONS(6032),
    [anon_sym_AMP_EQ] = ACTIONS(6032),
    [anon_sym_CARET_EQ] = ACTIONS(6032),
    [anon_sym_PIPE_EQ] = ACTIONS(6032),
    [anon_sym_LT_LT_EQ] = ACTIONS(6032),
    [anon_sym_GT_GT_EQ] = ACTIONS(6032),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6032),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6032),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4247] = {
    [sym_preproc_region] = STATE(4247),
    [sym_preproc_endregion] = STATE(4247),
    [sym_preproc_line] = STATE(4247),
    [sym_preproc_pragma] = STATE(4247),
    [sym_preproc_nullable] = STATE(4247),
    [sym_preproc_error] = STATE(4247),
    [sym_preproc_define] = STATE(4247),
    [sym_preproc_undef] = STATE(4247),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_RBRACK] = ACTIONS(5644),
    [anon_sym_LPAREN] = ACTIONS(5644),
    [anon_sym_RPAREN] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_in] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_BANG] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_GT_GT_GT] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(5646),
    [anon_sym_EQ_GT] = ACTIONS(5644),
    [anon_sym_switch] = ACTIONS(5644),
    [anon_sym_when] = ACTIONS(5644),
    [anon_sym_DOT_DOT] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_or] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5644),
    [anon_sym_QMARK_QMARK] = ACTIONS(5644),
    [anon_sym_on] = ACTIONS(5644),
    [anon_sym_equals] = ACTIONS(5644),
    [anon_sym_by] = ACTIONS(5644),
    [anon_sym_as] = ACTIONS(5644),
    [anon_sym_is] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(5644),
    [anon_sym_with] = ACTIONS(5644),
    [aux_sym_preproc_if_token3] = ACTIONS(5644),
    [aux_sym_preproc_else_token1] = ACTIONS(5644),
    [aux_sym_preproc_elif_token1] = ACTIONS(5644),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4248] = {
    [sym_preproc_region] = STATE(4248),
    [sym_preproc_endregion] = STATE(4248),
    [sym_preproc_line] = STATE(4248),
    [sym_preproc_pragma] = STATE(4248),
    [sym_preproc_nullable] = STATE(4248),
    [sym_preproc_error] = STATE(4248),
    [sym_preproc_define] = STATE(4248),
    [sym_preproc_undef] = STATE(4248),
    [anon_sym_EQ] = ACTIONS(6034),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6036),
    [anon_sym_DASH_EQ] = ACTIONS(6036),
    [anon_sym_STAR_EQ] = ACTIONS(6036),
    [anon_sym_SLASH_EQ] = ACTIONS(6036),
    [anon_sym_PERCENT_EQ] = ACTIONS(6036),
    [anon_sym_AMP_EQ] = ACTIONS(6036),
    [anon_sym_CARET_EQ] = ACTIONS(6036),
    [anon_sym_PIPE_EQ] = ACTIONS(6036),
    [anon_sym_LT_LT_EQ] = ACTIONS(6036),
    [anon_sym_GT_GT_EQ] = ACTIONS(6036),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6036),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6036),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5294),
  },
  [4249] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7053),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9225),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4249),
    [sym_preproc_endregion] = STATE(4249),
    [sym_preproc_line] = STATE(4249),
    [sym_preproc_pragma] = STATE(4249),
    [sym_preproc_nullable] = STATE(4249),
    [sym_preproc_error] = STATE(4249),
    [sym_preproc_define] = STATE(4249),
    [sym_preproc_undef] = STATE(4249),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4250] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6996),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9203),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4250),
    [sym_preproc_endregion] = STATE(4250),
    [sym_preproc_line] = STATE(4250),
    [sym_preproc_pragma] = STATE(4250),
    [sym_preproc_nullable] = STATE(4250),
    [sym_preproc_error] = STATE(4250),
    [sym_preproc_define] = STATE(4250),
    [sym_preproc_undef] = STATE(4250),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4251] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6983),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9191),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4251),
    [sym_preproc_endregion] = STATE(4251),
    [sym_preproc_line] = STATE(4251),
    [sym_preproc_pragma] = STATE(4251),
    [sym_preproc_nullable] = STATE(4251),
    [sym_preproc_error] = STATE(4251),
    [sym_preproc_define] = STATE(4251),
    [sym_preproc_undef] = STATE(4251),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4252] = {
    [sym_preproc_region] = STATE(4252),
    [sym_preproc_endregion] = STATE(4252),
    [sym_preproc_line] = STATE(4252),
    [sym_preproc_pragma] = STATE(4252),
    [sym_preproc_nullable] = STATE(4252),
    [sym_preproc_error] = STATE(4252),
    [sym_preproc_define] = STATE(4252),
    [sym_preproc_undef] = STATE(4252),
    [anon_sym_SEMI] = ACTIONS(5604),
    [anon_sym_LBRACK] = ACTIONS(5604),
    [anon_sym_COLON] = ACTIONS(5604),
    [anon_sym_COMMA] = ACTIONS(5604),
    [anon_sym_RBRACK] = ACTIONS(5604),
    [anon_sym_LPAREN] = ACTIONS(5604),
    [anon_sym_RPAREN] = ACTIONS(5604),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_LT] = ACTIONS(5606),
    [anon_sym_GT] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5604),
    [anon_sym_QMARK] = ACTIONS(5606),
    [anon_sym_BANG] = ACTIONS(5606),
    [anon_sym_PLUS_PLUS] = ACTIONS(5604),
    [anon_sym_DASH_DASH] = ACTIONS(5604),
    [anon_sym_PLUS] = ACTIONS(5606),
    [anon_sym_DASH] = ACTIONS(5606),
    [anon_sym_STAR] = ACTIONS(5604),
    [anon_sym_SLASH] = ACTIONS(5606),
    [anon_sym_PERCENT] = ACTIONS(5604),
    [anon_sym_CARET] = ACTIONS(5604),
    [anon_sym_PIPE] = ACTIONS(5606),
    [anon_sym_AMP] = ACTIONS(5606),
    [anon_sym_LT_LT] = ACTIONS(5604),
    [anon_sym_GT_GT] = ACTIONS(5606),
    [anon_sym_GT_GT_GT] = ACTIONS(5604),
    [anon_sym_EQ_EQ] = ACTIONS(5604),
    [anon_sym_BANG_EQ] = ACTIONS(5604),
    [anon_sym_GT_EQ] = ACTIONS(5604),
    [anon_sym_LT_EQ] = ACTIONS(5604),
    [anon_sym_DOT] = ACTIONS(5606),
    [anon_sym_EQ_GT] = ACTIONS(5604),
    [anon_sym_switch] = ACTIONS(5604),
    [anon_sym_when] = ACTIONS(5604),
    [anon_sym_DOT_DOT] = ACTIONS(5604),
    [anon_sym_and] = ACTIONS(5604),
    [anon_sym_or] = ACTIONS(5604),
    [anon_sym_AMP_AMP] = ACTIONS(5604),
    [anon_sym_PIPE_PIPE] = ACTIONS(5604),
    [anon_sym_QMARK_QMARK] = ACTIONS(5604),
    [anon_sym_on] = ACTIONS(5604),
    [anon_sym_equals] = ACTIONS(5604),
    [anon_sym_by] = ACTIONS(5604),
    [anon_sym_as] = ACTIONS(5604),
    [anon_sym_is] = ACTIONS(5604),
    [anon_sym_DASH_GT] = ACTIONS(5604),
    [anon_sym_with] = ACTIONS(5604),
    [aux_sym_preproc_if_token3] = ACTIONS(5604),
    [aux_sym_preproc_else_token1] = ACTIONS(5604),
    [aux_sym_preproc_elif_token1] = ACTIONS(5604),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4253] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9536),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4253),
    [sym_preproc_endregion] = STATE(4253),
    [sym_preproc_line] = STATE(4253),
    [sym_preproc_pragma] = STATE(4253),
    [sym_preproc_nullable] = STATE(4253),
    [sym_preproc_error] = STATE(4253),
    [sym_preproc_define] = STATE(4253),
    [sym_preproc_undef] = STATE(4253),
    [aux_sym_function_pointer_type_repeat1] = STATE(4266),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4254] = {
    [sym_preproc_region] = STATE(4254),
    [sym_preproc_endregion] = STATE(4254),
    [sym_preproc_line] = STATE(4254),
    [sym_preproc_pragma] = STATE(4254),
    [sym_preproc_nullable] = STATE(4254),
    [sym_preproc_error] = STATE(4254),
    [sym_preproc_define] = STATE(4254),
    [sym_preproc_undef] = STATE(4254),
    [anon_sym_SEMI] = ACTIONS(5562),
    [anon_sym_LBRACK] = ACTIONS(5562),
    [anon_sym_COLON] = ACTIONS(5562),
    [anon_sym_COMMA] = ACTIONS(5562),
    [anon_sym_RBRACK] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(5562),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5562),
    [anon_sym_QMARK] = ACTIONS(5564),
    [anon_sym_BANG] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5562),
    [anon_sym_DASH_DASH] = ACTIONS(5562),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5562),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5562),
    [anon_sym_CARET] = ACTIONS(5562),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5562),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_GT_GT_GT] = ACTIONS(5562),
    [anon_sym_EQ_EQ] = ACTIONS(5562),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_GT_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5562),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_EQ_GT] = ACTIONS(5562),
    [anon_sym_switch] = ACTIONS(5562),
    [anon_sym_when] = ACTIONS(5562),
    [anon_sym_DOT_DOT] = ACTIONS(5562),
    [anon_sym_and] = ACTIONS(5562),
    [anon_sym_or] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_QMARK_QMARK] = ACTIONS(5562),
    [anon_sym_on] = ACTIONS(5562),
    [anon_sym_equals] = ACTIONS(5562),
    [anon_sym_by] = ACTIONS(5562),
    [anon_sym_as] = ACTIONS(5562),
    [anon_sym_is] = ACTIONS(5562),
    [anon_sym_DASH_GT] = ACTIONS(5562),
    [anon_sym_with] = ACTIONS(5562),
    [aux_sym_preproc_if_token3] = ACTIONS(5562),
    [aux_sym_preproc_else_token1] = ACTIONS(5562),
    [aux_sym_preproc_elif_token1] = ACTIONS(5562),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4255] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6950),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9614),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4255),
    [sym_preproc_endregion] = STATE(4255),
    [sym_preproc_line] = STATE(4255),
    [sym_preproc_pragma] = STATE(4255),
    [sym_preproc_nullable] = STATE(4255),
    [sym_preproc_error] = STATE(4255),
    [sym_preproc_define] = STATE(4255),
    [sym_preproc_undef] = STATE(4255),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4256] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7012),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9410),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4256),
    [sym_preproc_endregion] = STATE(4256),
    [sym_preproc_line] = STATE(4256),
    [sym_preproc_pragma] = STATE(4256),
    [sym_preproc_nullable] = STATE(4256),
    [sym_preproc_error] = STATE(4256),
    [sym_preproc_define] = STATE(4256),
    [sym_preproc_undef] = STATE(4256),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4257] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6981),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9176),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4257),
    [sym_preproc_endregion] = STATE(4257),
    [sym_preproc_line] = STATE(4257),
    [sym_preproc_pragma] = STATE(4257),
    [sym_preproc_nullable] = STATE(4257),
    [sym_preproc_error] = STATE(4257),
    [sym_preproc_define] = STATE(4257),
    [sym_preproc_undef] = STATE(4257),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4258] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9388),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4258),
    [sym_preproc_endregion] = STATE(4258),
    [sym_preproc_line] = STATE(4258),
    [sym_preproc_pragma] = STATE(4258),
    [sym_preproc_nullable] = STATE(4258),
    [sym_preproc_error] = STATE(4258),
    [sym_preproc_define] = STATE(4258),
    [sym_preproc_undef] = STATE(4258),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4259] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6997),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9520),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4259),
    [sym_preproc_endregion] = STATE(4259),
    [sym_preproc_line] = STATE(4259),
    [sym_preproc_pragma] = STATE(4259),
    [sym_preproc_nullable] = STATE(4259),
    [sym_preproc_error] = STATE(4259),
    [sym_preproc_define] = STATE(4259),
    [sym_preproc_undef] = STATE(4259),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4260] = {
    [sym_preproc_region] = STATE(4260),
    [sym_preproc_endregion] = STATE(4260),
    [sym_preproc_line] = STATE(4260),
    [sym_preproc_pragma] = STATE(4260),
    [sym_preproc_nullable] = STATE(4260),
    [sym_preproc_error] = STATE(4260),
    [sym_preproc_define] = STATE(4260),
    [sym_preproc_undef] = STATE(4260),
    [anon_sym_SEMI] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COMMA] = ACTIONS(5652),
    [anon_sym_RBRACK] = ACTIONS(5652),
    [anon_sym_LPAREN] = ACTIONS(5652),
    [anon_sym_RPAREN] = ACTIONS(5652),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5652),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_BANG] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5652),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_GT_GT_GT] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5652),
    [anon_sym_BANG_EQ] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5652),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_EQ_GT] = ACTIONS(5652),
    [anon_sym_switch] = ACTIONS(5652),
    [anon_sym_when] = ACTIONS(5652),
    [anon_sym_DOT_DOT] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_or] = ACTIONS(5652),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5652),
    [anon_sym_QMARK_QMARK] = ACTIONS(5652),
    [anon_sym_on] = ACTIONS(5652),
    [anon_sym_equals] = ACTIONS(5652),
    [anon_sym_by] = ACTIONS(5652),
    [anon_sym_as] = ACTIONS(5652),
    [anon_sym_is] = ACTIONS(5652),
    [anon_sym_DASH_GT] = ACTIONS(5652),
    [anon_sym_with] = ACTIONS(5652),
    [aux_sym_preproc_if_token3] = ACTIONS(5652),
    [aux_sym_preproc_else_token1] = ACTIONS(5652),
    [aux_sym_preproc_elif_token1] = ACTIONS(5652),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4261] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7046),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9056),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4261),
    [sym_preproc_endregion] = STATE(4261),
    [sym_preproc_line] = STATE(4261),
    [sym_preproc_pragma] = STATE(4261),
    [sym_preproc_nullable] = STATE(4261),
    [sym_preproc_error] = STATE(4261),
    [sym_preproc_define] = STATE(4261),
    [sym_preproc_undef] = STATE(4261),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4262] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7014),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9526),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4262),
    [sym_preproc_endregion] = STATE(4262),
    [sym_preproc_line] = STATE(4262),
    [sym_preproc_pragma] = STATE(4262),
    [sym_preproc_nullable] = STATE(4262),
    [sym_preproc_error] = STATE(4262),
    [sym_preproc_define] = STATE(4262),
    [sym_preproc_undef] = STATE(4262),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4263] = {
    [sym_preproc_region] = STATE(4263),
    [sym_preproc_endregion] = STATE(4263),
    [sym_preproc_line] = STATE(4263),
    [sym_preproc_pragma] = STATE(4263),
    [sym_preproc_nullable] = STATE(4263),
    [sym_preproc_error] = STATE(4263),
    [sym_preproc_define] = STATE(4263),
    [sym_preproc_undef] = STATE(4263),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_COMMA] = ACTIONS(5574),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_LPAREN] = ACTIONS(5574),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_LT] = ACTIONS(5576),
    [anon_sym_GT] = ACTIONS(5576),
    [anon_sym_in] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5576),
    [anon_sym_BANG] = ACTIONS(5576),
    [anon_sym_PLUS_PLUS] = ACTIONS(5574),
    [anon_sym_DASH_DASH] = ACTIONS(5574),
    [anon_sym_PLUS] = ACTIONS(5576),
    [anon_sym_DASH] = ACTIONS(5576),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_SLASH] = ACTIONS(5576),
    [anon_sym_PERCENT] = ACTIONS(5574),
    [anon_sym_CARET] = ACTIONS(5574),
    [anon_sym_PIPE] = ACTIONS(5576),
    [anon_sym_AMP] = ACTIONS(5576),
    [anon_sym_LT_LT] = ACTIONS(5574),
    [anon_sym_GT_GT] = ACTIONS(5576),
    [anon_sym_GT_GT_GT] = ACTIONS(5574),
    [anon_sym_EQ_EQ] = ACTIONS(5574),
    [anon_sym_BANG_EQ] = ACTIONS(5574),
    [anon_sym_GT_EQ] = ACTIONS(5574),
    [anon_sym_LT_EQ] = ACTIONS(5574),
    [anon_sym_DOT] = ACTIONS(5576),
    [anon_sym_EQ_GT] = ACTIONS(5574),
    [anon_sym_switch] = ACTIONS(5574),
    [anon_sym_when] = ACTIONS(5574),
    [anon_sym_DOT_DOT] = ACTIONS(5574),
    [anon_sym_and] = ACTIONS(5574),
    [anon_sym_or] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_PIPE_PIPE] = ACTIONS(5574),
    [anon_sym_QMARK_QMARK] = ACTIONS(5574),
    [anon_sym_on] = ACTIONS(5574),
    [anon_sym_equals] = ACTIONS(5574),
    [anon_sym_by] = ACTIONS(5574),
    [anon_sym_as] = ACTIONS(5574),
    [anon_sym_is] = ACTIONS(5574),
    [anon_sym_DASH_GT] = ACTIONS(5574),
    [anon_sym_with] = ACTIONS(5574),
    [aux_sym_preproc_if_token3] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5574),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4264] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7019),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9932),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4264),
    [sym_preproc_endregion] = STATE(4264),
    [sym_preproc_line] = STATE(4264),
    [sym_preproc_pragma] = STATE(4264),
    [sym_preproc_nullable] = STATE(4264),
    [sym_preproc_error] = STATE(4264),
    [sym_preproc_define] = STATE(4264),
    [sym_preproc_undef] = STATE(4264),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4265] = {
    [sym_preproc_region] = STATE(4265),
    [sym_preproc_endregion] = STATE(4265),
    [sym_preproc_line] = STATE(4265),
    [sym_preproc_pragma] = STATE(4265),
    [sym_preproc_nullable] = STATE(4265),
    [sym_preproc_error] = STATE(4265),
    [sym_preproc_define] = STATE(4265),
    [sym_preproc_undef] = STATE(4265),
    [anon_sym_SEMI] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5538),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RBRACK] = ACTIONS(5538),
    [anon_sym_LPAREN] = ACTIONS(5538),
    [anon_sym_RPAREN] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5540),
    [anon_sym_GT] = ACTIONS(5540),
    [anon_sym_in] = ACTIONS(5538),
    [anon_sym_QMARK] = ACTIONS(5540),
    [anon_sym_BANG] = ACTIONS(5540),
    [anon_sym_PLUS_PLUS] = ACTIONS(5538),
    [anon_sym_DASH_DASH] = ACTIONS(5538),
    [anon_sym_PLUS] = ACTIONS(5540),
    [anon_sym_DASH] = ACTIONS(5540),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_SLASH] = ACTIONS(5540),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_CARET] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5540),
    [anon_sym_AMP] = ACTIONS(5540),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5540),
    [anon_sym_GT_GT_GT] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5538),
    [anon_sym_BANG_EQ] = ACTIONS(5538),
    [anon_sym_GT_EQ] = ACTIONS(5538),
    [anon_sym_LT_EQ] = ACTIONS(5538),
    [anon_sym_DOT] = ACTIONS(5540),
    [anon_sym_EQ_GT] = ACTIONS(5538),
    [anon_sym_switch] = ACTIONS(5538),
    [anon_sym_when] = ACTIONS(5538),
    [anon_sym_DOT_DOT] = ACTIONS(5538),
    [anon_sym_and] = ACTIONS(5538),
    [anon_sym_or] = ACTIONS(5538),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_QMARK_QMARK] = ACTIONS(5538),
    [anon_sym_on] = ACTIONS(5538),
    [anon_sym_equals] = ACTIONS(5538),
    [anon_sym_by] = ACTIONS(5538),
    [anon_sym_as] = ACTIONS(5538),
    [anon_sym_is] = ACTIONS(5538),
    [anon_sym_DASH_GT] = ACTIONS(5538),
    [anon_sym_with] = ACTIONS(5538),
    [aux_sym_preproc_if_token3] = ACTIONS(5538),
    [aux_sym_preproc_else_token1] = ACTIONS(5538),
    [aux_sym_preproc_elif_token1] = ACTIONS(5538),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4266] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9506),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4266),
    [sym_preproc_endregion] = STATE(4266),
    [sym_preproc_line] = STATE(4266),
    [sym_preproc_pragma] = STATE(4266),
    [sym_preproc_nullable] = STATE(4266),
    [sym_preproc_error] = STATE(4266),
    [sym_preproc_define] = STATE(4266),
    [sym_preproc_undef] = STATE(4266),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4267] = {
    [sym_preproc_region] = STATE(4267),
    [sym_preproc_endregion] = STATE(4267),
    [sym_preproc_line] = STATE(4267),
    [sym_preproc_pragma] = STATE(4267),
    [sym_preproc_nullable] = STATE(4267),
    [sym_preproc_error] = STATE(4267),
    [sym_preproc_define] = STATE(4267),
    [sym_preproc_undef] = STATE(4267),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_COLON] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_RBRACK] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_RPAREN] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5524),
    [anon_sym_BANG] = ACTIONS(5524),
    [anon_sym_PLUS_PLUS] = ACTIONS(5522),
    [anon_sym_DASH_DASH] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5522),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5522),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5522),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_GT_GT_GT] = ACTIONS(5522),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_EQ_GT] = ACTIONS(5522),
    [anon_sym_switch] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_DOT_DOT] = ACTIONS(5522),
    [anon_sym_and] = ACTIONS(5522),
    [anon_sym_or] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE] = ACTIONS(5522),
    [anon_sym_QMARK_QMARK] = ACTIONS(5522),
    [anon_sym_on] = ACTIONS(5522),
    [anon_sym_equals] = ACTIONS(5522),
    [anon_sym_by] = ACTIONS(5522),
    [anon_sym_as] = ACTIONS(5522),
    [anon_sym_is] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_with] = ACTIONS(5522),
    [aux_sym_preproc_if_token3] = ACTIONS(5522),
    [aux_sym_preproc_else_token1] = ACTIONS(5522),
    [aux_sym_preproc_elif_token1] = ACTIONS(5522),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4268] = {
    [sym_preproc_region] = STATE(4268),
    [sym_preproc_endregion] = STATE(4268),
    [sym_preproc_line] = STATE(4268),
    [sym_preproc_pragma] = STATE(4268),
    [sym_preproc_nullable] = STATE(4268),
    [sym_preproc_error] = STATE(4268),
    [sym_preproc_define] = STATE(4268),
    [sym_preproc_undef] = STATE(4268),
    [anon_sym_SEMI] = ACTIONS(5530),
    [anon_sym_LBRACK] = ACTIONS(5530),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_COMMA] = ACTIONS(5530),
    [anon_sym_RBRACK] = ACTIONS(5530),
    [anon_sym_LPAREN] = ACTIONS(5530),
    [anon_sym_RPAREN] = ACTIONS(5530),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_LT] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5532),
    [anon_sym_in] = ACTIONS(5530),
    [anon_sym_QMARK] = ACTIONS(5532),
    [anon_sym_BANG] = ACTIONS(5532),
    [anon_sym_PLUS_PLUS] = ACTIONS(5530),
    [anon_sym_DASH_DASH] = ACTIONS(5530),
    [anon_sym_PLUS] = ACTIONS(5532),
    [anon_sym_DASH] = ACTIONS(5532),
    [anon_sym_STAR] = ACTIONS(5530),
    [anon_sym_SLASH] = ACTIONS(5532),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_CARET] = ACTIONS(5530),
    [anon_sym_PIPE] = ACTIONS(5532),
    [anon_sym_AMP] = ACTIONS(5532),
    [anon_sym_LT_LT] = ACTIONS(5530),
    [anon_sym_GT_GT] = ACTIONS(5532),
    [anon_sym_GT_GT_GT] = ACTIONS(5530),
    [anon_sym_EQ_EQ] = ACTIONS(5530),
    [anon_sym_BANG_EQ] = ACTIONS(5530),
    [anon_sym_GT_EQ] = ACTIONS(5530),
    [anon_sym_LT_EQ] = ACTIONS(5530),
    [anon_sym_DOT] = ACTIONS(5532),
    [anon_sym_EQ_GT] = ACTIONS(5530),
    [anon_sym_switch] = ACTIONS(5530),
    [anon_sym_when] = ACTIONS(5530),
    [anon_sym_DOT_DOT] = ACTIONS(5530),
    [anon_sym_and] = ACTIONS(5530),
    [anon_sym_or] = ACTIONS(5530),
    [anon_sym_AMP_AMP] = ACTIONS(5530),
    [anon_sym_PIPE_PIPE] = ACTIONS(5530),
    [anon_sym_QMARK_QMARK] = ACTIONS(5530),
    [anon_sym_on] = ACTIONS(5530),
    [anon_sym_equals] = ACTIONS(5530),
    [anon_sym_by] = ACTIONS(5530),
    [anon_sym_as] = ACTIONS(5530),
    [anon_sym_is] = ACTIONS(5530),
    [anon_sym_DASH_GT] = ACTIONS(5530),
    [anon_sym_with] = ACTIONS(5530),
    [aux_sym_preproc_if_token3] = ACTIONS(5530),
    [aux_sym_preproc_else_token1] = ACTIONS(5530),
    [aux_sym_preproc_elif_token1] = ACTIONS(5530),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4269] = {
    [sym_preproc_region] = STATE(4269),
    [sym_preproc_endregion] = STATE(4269),
    [sym_preproc_line] = STATE(4269),
    [sym_preproc_pragma] = STATE(4269),
    [sym_preproc_nullable] = STATE(4269),
    [sym_preproc_error] = STATE(4269),
    [sym_preproc_define] = STATE(4269),
    [sym_preproc_undef] = STATE(4269),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_COMMA] = ACTIONS(5660),
    [anon_sym_RBRACK] = ACTIONS(5660),
    [anon_sym_LPAREN] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5660),
    [anon_sym_RBRACE] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5662),
    [anon_sym_in] = ACTIONS(5660),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_BANG] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5662),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5662),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5662),
    [anon_sym_AMP] = ACTIONS(5662),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5662),
    [anon_sym_GT_GT_GT] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5660),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_DOT] = ACTIONS(5662),
    [anon_sym_EQ_GT] = ACTIONS(5660),
    [anon_sym_switch] = ACTIONS(5660),
    [anon_sym_when] = ACTIONS(5660),
    [anon_sym_DOT_DOT] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_or] = ACTIONS(5660),
    [anon_sym_AMP_AMP] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5660),
    [anon_sym_QMARK_QMARK] = ACTIONS(5660),
    [anon_sym_on] = ACTIONS(5660),
    [anon_sym_equals] = ACTIONS(5660),
    [anon_sym_by] = ACTIONS(5660),
    [anon_sym_as] = ACTIONS(5660),
    [anon_sym_is] = ACTIONS(5660),
    [anon_sym_DASH_GT] = ACTIONS(5660),
    [anon_sym_with] = ACTIONS(5660),
    [aux_sym_preproc_if_token3] = ACTIONS(5660),
    [aux_sym_preproc_else_token1] = ACTIONS(5660),
    [aux_sym_preproc_elif_token1] = ACTIONS(5660),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4270] = {
    [sym_preproc_region] = STATE(4270),
    [sym_preproc_endregion] = STATE(4270),
    [sym_preproc_line] = STATE(4270),
    [sym_preproc_pragma] = STATE(4270),
    [sym_preproc_nullable] = STATE(4270),
    [sym_preproc_error] = STATE(4270),
    [sym_preproc_define] = STATE(4270),
    [sym_preproc_undef] = STATE(4270),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4271] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7051),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9184),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4271),
    [sym_preproc_endregion] = STATE(4271),
    [sym_preproc_line] = STATE(4271),
    [sym_preproc_pragma] = STATE(4271),
    [sym_preproc_nullable] = STATE(4271),
    [sym_preproc_error] = STATE(4271),
    [sym_preproc_define] = STATE(4271),
    [sym_preproc_undef] = STATE(4271),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4272] = {
    [sym_preproc_region] = STATE(4272),
    [sym_preproc_endregion] = STATE(4272),
    [sym_preproc_line] = STATE(4272),
    [sym_preproc_pragma] = STATE(4272),
    [sym_preproc_nullable] = STATE(4272),
    [sym_preproc_error] = STATE(4272),
    [sym_preproc_define] = STATE(4272),
    [sym_preproc_undef] = STATE(4272),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RBRACK] = ACTIONS(5923),
    [anon_sym_LPAREN] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_in] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(5925),
    [anon_sym_BANG] = ACTIONS(5925),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_CARET] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5923),
    [anon_sym_GT_GT] = ACTIONS(5925),
    [anon_sym_GT_GT_GT] = ACTIONS(5923),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_EQ_GT] = ACTIONS(5923),
    [anon_sym_switch] = ACTIONS(5923),
    [anon_sym_when] = ACTIONS(5923),
    [anon_sym_DOT_DOT] = ACTIONS(5923),
    [anon_sym_and] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_QMARK_QMARK] = ACTIONS(5923),
    [anon_sym_on] = ACTIONS(5923),
    [anon_sym_equals] = ACTIONS(5923),
    [anon_sym_by] = ACTIONS(5923),
    [anon_sym_as] = ACTIONS(5923),
    [anon_sym_is] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [anon_sym_with] = ACTIONS(5923),
    [aux_sym_preproc_if_token3] = ACTIONS(5923),
    [aux_sym_preproc_else_token1] = ACTIONS(5923),
    [aux_sym_preproc_elif_token1] = ACTIONS(5923),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4273] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7087),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9039),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4273),
    [sym_preproc_endregion] = STATE(4273),
    [sym_preproc_line] = STATE(4273),
    [sym_preproc_pragma] = STATE(4273),
    [sym_preproc_nullable] = STATE(4273),
    [sym_preproc_error] = STATE(4273),
    [sym_preproc_define] = STATE(4273),
    [sym_preproc_undef] = STATE(4273),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4274] = {
    [sym_preproc_region] = STATE(4274),
    [sym_preproc_endregion] = STATE(4274),
    [sym_preproc_line] = STATE(4274),
    [sym_preproc_pragma] = STATE(4274),
    [sym_preproc_nullable] = STATE(4274),
    [sym_preproc_error] = STATE(4274),
    [sym_preproc_define] = STATE(4274),
    [sym_preproc_undef] = STATE(4274),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5664),
    [anon_sym_COMMA] = ACTIONS(5664),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(5664),
    [anon_sym_RPAREN] = ACTIONS(5664),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5664),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_BANG] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5666),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5666),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_PIPE] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5666),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_GT_GT_GT] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5664),
    [anon_sym_BANG_EQ] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5664),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_DOT] = ACTIONS(5666),
    [anon_sym_EQ_GT] = ACTIONS(5664),
    [anon_sym_switch] = ACTIONS(5664),
    [anon_sym_when] = ACTIONS(5664),
    [anon_sym_DOT_DOT] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_or] = ACTIONS(5664),
    [anon_sym_AMP_AMP] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5664),
    [anon_sym_QMARK_QMARK] = ACTIONS(5664),
    [anon_sym_on] = ACTIONS(5664),
    [anon_sym_equals] = ACTIONS(5664),
    [anon_sym_by] = ACTIONS(5664),
    [anon_sym_as] = ACTIONS(5664),
    [anon_sym_is] = ACTIONS(5664),
    [anon_sym_DASH_GT] = ACTIONS(5664),
    [anon_sym_with] = ACTIONS(5664),
    [aux_sym_preproc_if_token3] = ACTIONS(5664),
    [aux_sym_preproc_else_token1] = ACTIONS(5664),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4275] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(4275),
    [sym_preproc_endregion] = STATE(4275),
    [sym_preproc_line] = STATE(4275),
    [sym_preproc_pragma] = STATE(4275),
    [sym_preproc_nullable] = STATE(4275),
    [sym_preproc_error] = STATE(4275),
    [sym_preproc_define] = STATE(4275),
    [sym_preproc_undef] = STATE(4275),
    [sym__identifier_token] = ACTIONS(4051),
    [anon_sym_alias] = ACTIONS(4055),
    [anon_sym_global] = ACTIONS(4055),
    [anon_sym_EQ] = ACTIONS(3993),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_file] = ACTIONS(4055),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4055),
    [anon_sym_unmanaged] = ACTIONS(4055),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4055),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4055),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(4055),
    [anon_sym_when] = ACTIONS(4055),
    [anon_sym_from] = ACTIONS(4055),
    [anon_sym_into] = ACTIONS(4055),
    [anon_sym_join] = ACTIONS(4055),
    [anon_sym_on] = ACTIONS(4055),
    [anon_sym_equals] = ACTIONS(4055),
    [anon_sym_let] = ACTIONS(4055),
    [anon_sym_orderby] = ACTIONS(4055),
    [anon_sym_ascending] = ACTIONS(4055),
    [anon_sym_descending] = ACTIONS(4055),
    [anon_sym_group] = ACTIONS(4055),
    [anon_sym_by] = ACTIONS(4055),
    [anon_sym_select] = ACTIONS(4055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4276] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7007),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9637),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4276),
    [sym_preproc_endregion] = STATE(4276),
    [sym_preproc_line] = STATE(4276),
    [sym_preproc_pragma] = STATE(4276),
    [sym_preproc_nullable] = STATE(4276),
    [sym_preproc_error] = STATE(4276),
    [sym_preproc_define] = STATE(4276),
    [sym_preproc_undef] = STATE(4276),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4277] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7021),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9761),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4277),
    [sym_preproc_endregion] = STATE(4277),
    [sym_preproc_line] = STATE(4277),
    [sym_preproc_pragma] = STATE(4277),
    [sym_preproc_nullable] = STATE(4277),
    [sym_preproc_error] = STATE(4277),
    [sym_preproc_define] = STATE(4277),
    [sym_preproc_undef] = STATE(4277),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4278] = {
    [sym_preproc_region] = STATE(4278),
    [sym_preproc_endregion] = STATE(4278),
    [sym_preproc_line] = STATE(4278),
    [sym_preproc_pragma] = STATE(4278),
    [sym_preproc_nullable] = STATE(4278),
    [sym_preproc_error] = STATE(4278),
    [sym_preproc_define] = STATE(4278),
    [sym_preproc_undef] = STATE(4278),
    [anon_sym_EQ] = ACTIONS(6042),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6044),
    [anon_sym_DASH_EQ] = ACTIONS(6044),
    [anon_sym_STAR_EQ] = ACTIONS(6044),
    [anon_sym_SLASH_EQ] = ACTIONS(6044),
    [anon_sym_PERCENT_EQ] = ACTIONS(6044),
    [anon_sym_AMP_EQ] = ACTIONS(6044),
    [anon_sym_CARET_EQ] = ACTIONS(6044),
    [anon_sym_PIPE_EQ] = ACTIONS(6044),
    [anon_sym_LT_LT_EQ] = ACTIONS(6044),
    [anon_sym_GT_GT_EQ] = ACTIONS(6044),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6044),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6044),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4279] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7045),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9510),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4279),
    [sym_preproc_endregion] = STATE(4279),
    [sym_preproc_line] = STATE(4279),
    [sym_preproc_pragma] = STATE(4279),
    [sym_preproc_nullable] = STATE(4279),
    [sym_preproc_error] = STATE(4279),
    [sym_preproc_define] = STATE(4279),
    [sym_preproc_undef] = STATE(4279),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4280] = {
    [sym_preproc_region] = STATE(4280),
    [sym_preproc_endregion] = STATE(4280),
    [sym_preproc_line] = STATE(4280),
    [sym_preproc_pragma] = STATE(4280),
    [sym_preproc_nullable] = STATE(4280),
    [sym_preproc_error] = STATE(4280),
    [sym_preproc_define] = STATE(4280),
    [sym_preproc_undef] = STATE(4280),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_RBRACK] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(5464),
    [anon_sym_RPAREN] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5466),
    [anon_sym_BANG] = ACTIONS(5466),
    [anon_sym_PLUS_PLUS] = ACTIONS(5464),
    [anon_sym_DASH_DASH] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_SLASH] = ACTIONS(5466),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5464),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5464),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_GT_GT_GT] = ACTIONS(5464),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_EQ_GT] = ACTIONS(5464),
    [anon_sym_switch] = ACTIONS(5464),
    [anon_sym_when] = ACTIONS(5464),
    [anon_sym_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5464),
    [anon_sym_or] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE] = ACTIONS(5464),
    [anon_sym_QMARK_QMARK] = ACTIONS(5464),
    [anon_sym_on] = ACTIONS(5464),
    [anon_sym_equals] = ACTIONS(5464),
    [anon_sym_by] = ACTIONS(5464),
    [anon_sym_as] = ACTIONS(5464),
    [anon_sym_is] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_with] = ACTIONS(5464),
    [aux_sym_preproc_if_token3] = ACTIONS(5464),
    [aux_sym_preproc_else_token1] = ACTIONS(5464),
    [aux_sym_preproc_elif_token1] = ACTIONS(5464),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4281] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7009),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9640),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4281),
    [sym_preproc_endregion] = STATE(4281),
    [sym_preproc_line] = STATE(4281),
    [sym_preproc_pragma] = STATE(4281),
    [sym_preproc_nullable] = STATE(4281),
    [sym_preproc_error] = STATE(4281),
    [sym_preproc_define] = STATE(4281),
    [sym_preproc_undef] = STATE(4281),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4282] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6994),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9429),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4282),
    [sym_preproc_endregion] = STATE(4282),
    [sym_preproc_line] = STATE(4282),
    [sym_preproc_pragma] = STATE(4282),
    [sym_preproc_nullable] = STATE(4282),
    [sym_preproc_error] = STATE(4282),
    [sym_preproc_define] = STATE(4282),
    [sym_preproc_undef] = STATE(4282),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4283] = {
    [sym_preproc_region] = STATE(4283),
    [sym_preproc_endregion] = STATE(4283),
    [sym_preproc_line] = STATE(4283),
    [sym_preproc_pragma] = STATE(4283),
    [sym_preproc_nullable] = STATE(4283),
    [sym_preproc_error] = STATE(4283),
    [sym_preproc_define] = STATE(4283),
    [sym_preproc_undef] = STATE(4283),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_get] = ACTIONS(4040),
    [anon_sym_set] = ACTIONS(4040),
    [anon_sym_add] = ACTIONS(4040),
    [anon_sym_remove] = ACTIONS(4040),
    [anon_sym_init] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4284] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6975),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9653),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4284),
    [sym_preproc_endregion] = STATE(4284),
    [sym_preproc_line] = STATE(4284),
    [sym_preproc_pragma] = STATE(4284),
    [sym_preproc_nullable] = STATE(4284),
    [sym_preproc_error] = STATE(4284),
    [sym_preproc_define] = STATE(4284),
    [sym_preproc_undef] = STATE(4284),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5966),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4285] = {
    [sym_preproc_region] = STATE(4285),
    [sym_preproc_endregion] = STATE(4285),
    [sym_preproc_line] = STATE(4285),
    [sym_preproc_pragma] = STATE(4285),
    [sym_preproc_nullable] = STATE(4285),
    [sym_preproc_error] = STATE(4285),
    [sym_preproc_define] = STATE(4285),
    [sym_preproc_undef] = STATE(4285),
    [anon_sym_SEMI] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COMMA] = ACTIONS(5672),
    [anon_sym_RBRACK] = ACTIONS(5672),
    [anon_sym_LPAREN] = ACTIONS(5672),
    [anon_sym_RPAREN] = ACTIONS(5672),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5672),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5672),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_GT_GT_GT] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5672),
    [anon_sym_BANG_EQ] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5672),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(5674),
    [anon_sym_EQ_GT] = ACTIONS(5672),
    [anon_sym_switch] = ACTIONS(5672),
    [anon_sym_when] = ACTIONS(5672),
    [anon_sym_DOT_DOT] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_or] = ACTIONS(5672),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_QMARK_QMARK] = ACTIONS(5672),
    [anon_sym_on] = ACTIONS(5672),
    [anon_sym_equals] = ACTIONS(5672),
    [anon_sym_by] = ACTIONS(5672),
    [anon_sym_as] = ACTIONS(5672),
    [anon_sym_is] = ACTIONS(5672),
    [anon_sym_DASH_GT] = ACTIONS(5672),
    [anon_sym_with] = ACTIONS(5672),
    [aux_sym_preproc_if_token3] = ACTIONS(5672),
    [aux_sym_preproc_else_token1] = ACTIONS(5672),
    [aux_sym_preproc_elif_token1] = ACTIONS(5672),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4286] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6984),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9183),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4286),
    [sym_preproc_endregion] = STATE(4286),
    [sym_preproc_line] = STATE(4286),
    [sym_preproc_pragma] = STATE(4286),
    [sym_preproc_nullable] = STATE(4286),
    [sym_preproc_error] = STATE(4286),
    [sym_preproc_define] = STATE(4286),
    [sym_preproc_undef] = STATE(4286),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4287] = {
    [sym_preproc_region] = STATE(4287),
    [sym_preproc_endregion] = STATE(4287),
    [sym_preproc_line] = STATE(4287),
    [sym_preproc_pragma] = STATE(4287),
    [sym_preproc_nullable] = STATE(4287),
    [sym_preproc_error] = STATE(4287),
    [sym_preproc_define] = STATE(4287),
    [sym_preproc_undef] = STATE(4287),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(5893),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_in] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(5896),
    [anon_sym_BANG] = ACTIONS(5896),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5893),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5893),
    [anon_sym_CARET] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5893),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_GT_GT_GT] = ACTIONS(5893),
    [anon_sym_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(5893),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(5893),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(5893),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_QMARK_QMARK] = ACTIONS(5893),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(5893),
    [anon_sym_is] = ACTIONS(5893),
    [anon_sym_DASH_GT] = ACTIONS(5893),
    [anon_sym_with] = ACTIONS(5893),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4288] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6991),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9936),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4288),
    [sym_preproc_endregion] = STATE(4288),
    [sym_preproc_line] = STATE(4288),
    [sym_preproc_pragma] = STATE(4288),
    [sym_preproc_nullable] = STATE(4288),
    [sym_preproc_error] = STATE(4288),
    [sym_preproc_define] = STATE(4288),
    [sym_preproc_undef] = STATE(4288),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4289] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6971),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9661),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4289),
    [sym_preproc_endregion] = STATE(4289),
    [sym_preproc_line] = STATE(4289),
    [sym_preproc_pragma] = STATE(4289),
    [sym_preproc_nullable] = STATE(4289),
    [sym_preproc_error] = STATE(4289),
    [sym_preproc_define] = STATE(4289),
    [sym_preproc_undef] = STATE(4289),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4290] = {
    [sym_preproc_region] = STATE(4290),
    [sym_preproc_endregion] = STATE(4290),
    [sym_preproc_line] = STATE(4290),
    [sym_preproc_pragma] = STATE(4290),
    [sym_preproc_nullable] = STATE(4290),
    [sym_preproc_error] = STATE(4290),
    [sym_preproc_define] = STATE(4290),
    [sym_preproc_undef] = STATE(4290),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5294),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5294),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5294),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5294),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_when] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4291] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9664),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4291),
    [sym_preproc_endregion] = STATE(4291),
    [sym_preproc_line] = STATE(4291),
    [sym_preproc_pragma] = STATE(4291),
    [sym_preproc_nullable] = STATE(4291),
    [sym_preproc_error] = STATE(4291),
    [sym_preproc_define] = STATE(4291),
    [sym_preproc_undef] = STATE(4291),
    [aux_sym_function_pointer_type_repeat1] = STATE(4297),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4292] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7061),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9141),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4292),
    [sym_preproc_endregion] = STATE(4292),
    [sym_preproc_line] = STATE(4292),
    [sym_preproc_pragma] = STATE(4292),
    [sym_preproc_nullable] = STATE(4292),
    [sym_preproc_error] = STATE(4292),
    [sym_preproc_define] = STATE(4292),
    [sym_preproc_undef] = STATE(4292),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5994),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4293] = {
    [sym_preproc_region] = STATE(4293),
    [sym_preproc_endregion] = STATE(4293),
    [sym_preproc_line] = STATE(4293),
    [sym_preproc_pragma] = STATE(4293),
    [sym_preproc_nullable] = STATE(4293),
    [sym_preproc_error] = STATE(4293),
    [sym_preproc_define] = STATE(4293),
    [sym_preproc_undef] = STATE(4293),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym_LBRACK] = ACTIONS(5476),
    [anon_sym_COLON] = ACTIONS(5476),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_RBRACK] = ACTIONS(5476),
    [anon_sym_LPAREN] = ACTIONS(5476),
    [anon_sym_RPAREN] = ACTIONS(5476),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_LT] = ACTIONS(5478),
    [anon_sym_GT] = ACTIONS(5478),
    [anon_sym_in] = ACTIONS(5476),
    [anon_sym_QMARK] = ACTIONS(5478),
    [anon_sym_BANG] = ACTIONS(5478),
    [anon_sym_PLUS_PLUS] = ACTIONS(5476),
    [anon_sym_DASH_DASH] = ACTIONS(5476),
    [anon_sym_PLUS] = ACTIONS(5478),
    [anon_sym_DASH] = ACTIONS(5478),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_SLASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5476),
    [anon_sym_CARET] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(5478),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_LT_LT] = ACTIONS(5476),
    [anon_sym_GT_GT] = ACTIONS(5478),
    [anon_sym_GT_GT_GT] = ACTIONS(5476),
    [anon_sym_EQ_EQ] = ACTIONS(5476),
    [anon_sym_BANG_EQ] = ACTIONS(5476),
    [anon_sym_GT_EQ] = ACTIONS(5476),
    [anon_sym_LT_EQ] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(5478),
    [anon_sym_EQ_GT] = ACTIONS(5476),
    [anon_sym_switch] = ACTIONS(5476),
    [anon_sym_when] = ACTIONS(5476),
    [anon_sym_DOT_DOT] = ACTIONS(5476),
    [anon_sym_and] = ACTIONS(5476),
    [anon_sym_or] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_PIPE_PIPE] = ACTIONS(5476),
    [anon_sym_QMARK_QMARK] = ACTIONS(5476),
    [anon_sym_on] = ACTIONS(5476),
    [anon_sym_equals] = ACTIONS(5476),
    [anon_sym_by] = ACTIONS(5476),
    [anon_sym_as] = ACTIONS(5476),
    [anon_sym_is] = ACTIONS(5476),
    [anon_sym_DASH_GT] = ACTIONS(5476),
    [anon_sym_with] = ACTIONS(5476),
    [aux_sym_preproc_if_token3] = ACTIONS(5476),
    [aux_sym_preproc_else_token1] = ACTIONS(5476),
    [aux_sym_preproc_elif_token1] = ACTIONS(5476),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4294] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6989),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9163),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4294),
    [sym_preproc_endregion] = STATE(4294),
    [sym_preproc_line] = STATE(4294),
    [sym_preproc_pragma] = STATE(4294),
    [sym_preproc_nullable] = STATE(4294),
    [sym_preproc_error] = STATE(4294),
    [sym_preproc_define] = STATE(4294),
    [sym_preproc_undef] = STATE(4294),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4295] = {
    [sym_preproc_region] = STATE(4295),
    [sym_preproc_endregion] = STATE(4295),
    [sym_preproc_line] = STATE(4295),
    [sym_preproc_pragma] = STATE(4295),
    [sym_preproc_nullable] = STATE(4295),
    [sym_preproc_error] = STATE(4295),
    [sym_preproc_define] = STATE(4295),
    [sym_preproc_undef] = STATE(4295),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_COLON] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4799),
    [anon_sym_RBRACK] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(5899),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_in] = ACTIONS(4799),
    [anon_sym_QMARK] = ACTIONS(5902),
    [anon_sym_BANG] = ACTIONS(5902),
    [anon_sym_PLUS_PLUS] = ACTIONS(5899),
    [anon_sym_DASH_DASH] = ACTIONS(5899),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5899),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5899),
    [anon_sym_CARET] = ACTIONS(5899),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_GT_GT_GT] = ACTIONS(5899),
    [anon_sym_EQ_EQ] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5899),
    [anon_sym_GT_EQ] = ACTIONS(5899),
    [anon_sym_LT_EQ] = ACTIONS(5899),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_EQ_GT] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(5899),
    [anon_sym_when] = ACTIONS(4799),
    [anon_sym_DOT_DOT] = ACTIONS(5899),
    [anon_sym_and] = ACTIONS(4799),
    [anon_sym_or] = ACTIONS(4799),
    [anon_sym_AMP_AMP] = ACTIONS(5899),
    [anon_sym_PIPE_PIPE] = ACTIONS(5899),
    [anon_sym_QMARK_QMARK] = ACTIONS(5899),
    [anon_sym_on] = ACTIONS(4799),
    [anon_sym_equals] = ACTIONS(4799),
    [anon_sym_by] = ACTIONS(4799),
    [anon_sym_as] = ACTIONS(5899),
    [anon_sym_is] = ACTIONS(5899),
    [anon_sym_DASH_GT] = ACTIONS(5899),
    [anon_sym_with] = ACTIONS(5899),
    [aux_sym_preproc_if_token3] = ACTIONS(4799),
    [aux_sym_preproc_else_token1] = ACTIONS(4799),
    [aux_sym_preproc_elif_token1] = ACTIONS(4799),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4296] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7024),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9590),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4296),
    [sym_preproc_endregion] = STATE(4296),
    [sym_preproc_line] = STATE(4296),
    [sym_preproc_pragma] = STATE(4296),
    [sym_preproc_nullable] = STATE(4296),
    [sym_preproc_error] = STATE(4296),
    [sym_preproc_define] = STATE(4296),
    [sym_preproc_undef] = STATE(4296),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5996),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4297] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9671),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4297),
    [sym_preproc_endregion] = STATE(4297),
    [sym_preproc_line] = STATE(4297),
    [sym_preproc_pragma] = STATE(4297),
    [sym_preproc_nullable] = STATE(4297),
    [sym_preproc_error] = STATE(4297),
    [sym_preproc_define] = STATE(4297),
    [sym_preproc_undef] = STATE(4297),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4298] = {
    [sym_argument_list] = STATE(3623),
    [sym_initializer_expression] = STATE(3739),
    [sym_preproc_region] = STATE(4298),
    [sym_preproc_endregion] = STATE(4298),
    [sym_preproc_line] = STATE(4298),
    [sym_preproc_pragma] = STATE(4298),
    [sym_preproc_nullable] = STATE(4298),
    [sym_preproc_error] = STATE(4298),
    [sym_preproc_define] = STATE(4298),
    [sym_preproc_undef] = STATE(4298),
    [anon_sym_SEMI] = ACTIONS(5263),
    [anon_sym_LBRACK] = ACTIONS(5263),
    [anon_sym_COLON] = ACTIONS(5263),
    [anon_sym_COMMA] = ACTIONS(5263),
    [anon_sym_RBRACK] = ACTIONS(5263),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5263),
    [anon_sym_LBRACE] = ACTIONS(1515),
    [anon_sym_RBRACE] = ACTIONS(5263),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5267),
    [anon_sym_in] = ACTIONS(5263),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5263),
    [anon_sym_DASH_DASH] = ACTIONS(5263),
    [anon_sym_PLUS] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_SLASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5263),
    [anon_sym_CARET] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_LT_LT] = ACTIONS(5263),
    [anon_sym_GT_GT] = ACTIONS(5267),
    [anon_sym_GT_GT_GT] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_DOT] = ACTIONS(5267),
    [anon_sym_EQ_GT] = ACTIONS(5263),
    [anon_sym_switch] = ACTIONS(5263),
    [anon_sym_DOT_DOT] = ACTIONS(5263),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_QMARK_QMARK] = ACTIONS(5263),
    [anon_sym_on] = ACTIONS(5263),
    [anon_sym_equals] = ACTIONS(5263),
    [anon_sym_by] = ACTIONS(5263),
    [anon_sym_as] = ACTIONS(5263),
    [anon_sym_is] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5263),
    [anon_sym_with] = ACTIONS(5263),
    [aux_sym_preproc_if_token3] = ACTIONS(5263),
    [aux_sym_preproc_else_token1] = ACTIONS(5263),
    [aux_sym_preproc_elif_token1] = ACTIONS(5263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4299] = {
    [sym_preproc_region] = STATE(4299),
    [sym_preproc_endregion] = STATE(4299),
    [sym_preproc_line] = STATE(4299),
    [sym_preproc_pragma] = STATE(4299),
    [sym_preproc_nullable] = STATE(4299),
    [sym_preproc_error] = STATE(4299),
    [sym_preproc_define] = STATE(4299),
    [sym_preproc_undef] = STATE(4299),
    [anon_sym_EQ] = ACTIONS(6046),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6048),
    [anon_sym_DASH_EQ] = ACTIONS(6048),
    [anon_sym_STAR_EQ] = ACTIONS(6048),
    [anon_sym_SLASH_EQ] = ACTIONS(6048),
    [anon_sym_PERCENT_EQ] = ACTIONS(6048),
    [anon_sym_AMP_EQ] = ACTIONS(6048),
    [anon_sym_CARET_EQ] = ACTIONS(6048),
    [anon_sym_PIPE_EQ] = ACTIONS(6048),
    [anon_sym_LT_LT_EQ] = ACTIONS(6048),
    [anon_sym_GT_GT_EQ] = ACTIONS(6048),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6048),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6048),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4300] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7083),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9395),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4300),
    [sym_preproc_endregion] = STATE(4300),
    [sym_preproc_line] = STATE(4300),
    [sym_preproc_pragma] = STATE(4300),
    [sym_preproc_nullable] = STATE(4300),
    [sym_preproc_error] = STATE(4300),
    [sym_preproc_define] = STATE(4300),
    [sym_preproc_undef] = STATE(4300),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4301] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7049),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9074),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4301),
    [sym_preproc_endregion] = STATE(4301),
    [sym_preproc_line] = STATE(4301),
    [sym_preproc_pragma] = STATE(4301),
    [sym_preproc_nullable] = STATE(4301),
    [sym_preproc_error] = STATE(4301),
    [sym_preproc_define] = STATE(4301),
    [sym_preproc_undef] = STATE(4301),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4302] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7042),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9514),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4302),
    [sym_preproc_endregion] = STATE(4302),
    [sym_preproc_line] = STATE(4302),
    [sym_preproc_pragma] = STATE(4302),
    [sym_preproc_nullable] = STATE(4302),
    [sym_preproc_error] = STATE(4302),
    [sym_preproc_define] = STATE(4302),
    [sym_preproc_undef] = STATE(4302),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4303] = {
    [sym_preproc_region] = STATE(4303),
    [sym_preproc_endregion] = STATE(4303),
    [sym_preproc_line] = STATE(4303),
    [sym_preproc_pragma] = STATE(4303),
    [sym_preproc_nullable] = STATE(4303),
    [sym_preproc_error] = STATE(4303),
    [sym_preproc_define] = STATE(4303),
    [sym_preproc_undef] = STATE(4303),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym_LBRACK] = ACTIONS(5608),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_COMMA] = ACTIONS(5608),
    [anon_sym_RBRACK] = ACTIONS(5608),
    [anon_sym_LPAREN] = ACTIONS(5608),
    [anon_sym_RPAREN] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5608),
    [anon_sym_LT] = ACTIONS(5610),
    [anon_sym_GT] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5608),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_BANG] = ACTIONS(5610),
    [anon_sym_PLUS_PLUS] = ACTIONS(5608),
    [anon_sym_DASH_DASH] = ACTIONS(5608),
    [anon_sym_PLUS] = ACTIONS(5610),
    [anon_sym_DASH] = ACTIONS(5610),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_SLASH] = ACTIONS(5610),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_CARET] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5610),
    [anon_sym_AMP] = ACTIONS(5610),
    [anon_sym_LT_LT] = ACTIONS(5608),
    [anon_sym_GT_GT] = ACTIONS(5610),
    [anon_sym_GT_GT_GT] = ACTIONS(5608),
    [anon_sym_EQ_EQ] = ACTIONS(5608),
    [anon_sym_BANG_EQ] = ACTIONS(5608),
    [anon_sym_GT_EQ] = ACTIONS(5608),
    [anon_sym_LT_EQ] = ACTIONS(5608),
    [anon_sym_DOT] = ACTIONS(5610),
    [anon_sym_EQ_GT] = ACTIONS(5608),
    [anon_sym_switch] = ACTIONS(5608),
    [anon_sym_when] = ACTIONS(5608),
    [anon_sym_DOT_DOT] = ACTIONS(5608),
    [anon_sym_and] = ACTIONS(5608),
    [anon_sym_or] = ACTIONS(5608),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_QMARK_QMARK] = ACTIONS(5608),
    [anon_sym_on] = ACTIONS(5608),
    [anon_sym_equals] = ACTIONS(5608),
    [anon_sym_by] = ACTIONS(5608),
    [anon_sym_as] = ACTIONS(5608),
    [anon_sym_is] = ACTIONS(5608),
    [anon_sym_DASH_GT] = ACTIONS(5608),
    [anon_sym_with] = ACTIONS(5608),
    [aux_sym_preproc_if_token3] = ACTIONS(5608),
    [aux_sym_preproc_else_token1] = ACTIONS(5608),
    [aux_sym_preproc_elif_token1] = ACTIONS(5608),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4304] = {
    [sym_preproc_region] = STATE(4304),
    [sym_preproc_endregion] = STATE(4304),
    [sym_preproc_line] = STATE(4304),
    [sym_preproc_pragma] = STATE(4304),
    [sym_preproc_nullable] = STATE(4304),
    [sym_preproc_error] = STATE(4304),
    [sym_preproc_define] = STATE(4304),
    [sym_preproc_undef] = STATE(4304),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_in] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5502),
    [anon_sym_BANG] = ACTIONS(5502),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_GT_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_EQ_GT] = ACTIONS(5500),
    [anon_sym_switch] = ACTIONS(5500),
    [anon_sym_when] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_and] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_QMARK_QMARK] = ACTIONS(5500),
    [anon_sym_on] = ACTIONS(5500),
    [anon_sym_equals] = ACTIONS(5500),
    [anon_sym_by] = ACTIONS(5500),
    [anon_sym_as] = ACTIONS(5500),
    [anon_sym_is] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [anon_sym_with] = ACTIONS(5500),
    [aux_sym_preproc_if_token3] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5500),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4305] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7127),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9146),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4305),
    [sym_preproc_endregion] = STATE(4305),
    [sym_preproc_line] = STATE(4305),
    [sym_preproc_pragma] = STATE(4305),
    [sym_preproc_nullable] = STATE(4305),
    [sym_preproc_error] = STATE(4305),
    [sym_preproc_define] = STATE(4305),
    [sym_preproc_undef] = STATE(4305),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4306] = {
    [sym_preproc_region] = STATE(4306),
    [sym_preproc_endregion] = STATE(4306),
    [sym_preproc_line] = STATE(4306),
    [sym_preproc_pragma] = STATE(4306),
    [sym_preproc_nullable] = STATE(4306),
    [sym_preproc_error] = STATE(4306),
    [sym_preproc_define] = STATE(4306),
    [sym_preproc_undef] = STATE(4306),
    [anon_sym_SEMI] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_COMMA] = ACTIONS(5668),
    [anon_sym_RBRACK] = ACTIONS(5668),
    [anon_sym_LPAREN] = ACTIONS(5668),
    [anon_sym_RPAREN] = ACTIONS(5668),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5670),
    [anon_sym_in] = ACTIONS(5668),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_BANG] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5670),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5670),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5670),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_GT_GT_GT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5668),
    [anon_sym_BANG_EQ] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5668),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(5670),
    [anon_sym_EQ_GT] = ACTIONS(5668),
    [anon_sym_switch] = ACTIONS(5668),
    [anon_sym_when] = ACTIONS(5668),
    [anon_sym_DOT_DOT] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_QMARK_QMARK] = ACTIONS(5668),
    [anon_sym_on] = ACTIONS(5668),
    [anon_sym_equals] = ACTIONS(5668),
    [anon_sym_by] = ACTIONS(5668),
    [anon_sym_as] = ACTIONS(5668),
    [anon_sym_is] = ACTIONS(5668),
    [anon_sym_DASH_GT] = ACTIONS(5668),
    [anon_sym_with] = ACTIONS(5668),
    [aux_sym_preproc_if_token3] = ACTIONS(5668),
    [aux_sym_preproc_else_token1] = ACTIONS(5668),
    [aux_sym_preproc_elif_token1] = ACTIONS(5668),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4307] = {
    [sym_preproc_region] = STATE(4307),
    [sym_preproc_endregion] = STATE(4307),
    [sym_preproc_line] = STATE(4307),
    [sym_preproc_pragma] = STATE(4307),
    [sym_preproc_nullable] = STATE(4307),
    [sym_preproc_error] = STATE(4307),
    [sym_preproc_define] = STATE(4307),
    [sym_preproc_undef] = STATE(4307),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_RBRACK] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_RBRACE] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1969),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_QMARK] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1969),
    [anon_sym_PERCENT] = ACTIONS(1967),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_GT_GT] = ACTIONS(1969),
    [anon_sym_GT_GT_GT] = ACTIONS(1967),
    [anon_sym_EQ_EQ] = ACTIONS(1967),
    [anon_sym_BANG_EQ] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_EQ_GT] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_when] = ACTIONS(1967),
    [anon_sym_DOT_DOT] = ACTIONS(1967),
    [anon_sym_and] = ACTIONS(1967),
    [anon_sym_or] = ACTIONS(1967),
    [anon_sym_AMP_AMP] = ACTIONS(1967),
    [anon_sym_PIPE_PIPE] = ACTIONS(1967),
    [anon_sym_QMARK_QMARK] = ACTIONS(1967),
    [anon_sym_on] = ACTIONS(1967),
    [anon_sym_equals] = ACTIONS(1967),
    [anon_sym_by] = ACTIONS(1967),
    [anon_sym_as] = ACTIONS(1967),
    [anon_sym_is] = ACTIONS(1967),
    [anon_sym_DASH_GT] = ACTIONS(1967),
    [anon_sym_with] = ACTIONS(1967),
    [aux_sym_preproc_if_token3] = ACTIONS(1967),
    [aux_sym_preproc_else_token1] = ACTIONS(1967),
    [aux_sym_preproc_elif_token1] = ACTIONS(1967),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4308] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7013),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9440),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4308),
    [sym_preproc_endregion] = STATE(4308),
    [sym_preproc_line] = STATE(4308),
    [sym_preproc_pragma] = STATE(4308),
    [sym_preproc_nullable] = STATE(4308),
    [sym_preproc_error] = STATE(4308),
    [sym_preproc_define] = STATE(4308),
    [sym_preproc_undef] = STATE(4308),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4309] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7033),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9463),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4309),
    [sym_preproc_endregion] = STATE(4309),
    [sym_preproc_line] = STATE(4309),
    [sym_preproc_pragma] = STATE(4309),
    [sym_preproc_nullable] = STATE(4309),
    [sym_preproc_error] = STATE(4309),
    [sym_preproc_define] = STATE(4309),
    [sym_preproc_undef] = STATE(4309),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4310] = {
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7331),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4310),
    [sym_preproc_endregion] = STATE(4310),
    [sym_preproc_line] = STATE(4310),
    [sym_preproc_pragma] = STATE(4310),
    [sym_preproc_nullable] = STATE(4310),
    [sym_preproc_error] = STATE(4310),
    [sym_preproc_define] = STATE(4310),
    [sym_preproc_undef] = STATE(4310),
    [aux_sym__parameter_type_with_modifiers_repeat1] = STATE(6785),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5276),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_readonly] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_out] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_this] = ACTIONS(1111),
    [anon_sym_scoped] = ACTIONS(5278),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4311] = {
    [sym_preproc_region] = STATE(4311),
    [sym_preproc_endregion] = STATE(4311),
    [sym_preproc_line] = STATE(4311),
    [sym_preproc_pragma] = STATE(4311),
    [sym_preproc_nullable] = STATE(4311),
    [sym_preproc_error] = STATE(4311),
    [sym_preproc_define] = STATE(4311),
    [sym_preproc_undef] = STATE(4311),
    [anon_sym_SEMI] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5870),
    [anon_sym_COLON] = ACTIONS(5870),
    [anon_sym_COMMA] = ACTIONS(5870),
    [anon_sym_RBRACK] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(5870),
    [anon_sym_RPAREN] = ACTIONS(5870),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5870),
    [anon_sym_QMARK] = ACTIONS(5872),
    [anon_sym_BANG] = ACTIONS(5872),
    [anon_sym_PLUS_PLUS] = ACTIONS(5870),
    [anon_sym_DASH_DASH] = ACTIONS(5870),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5870),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5870),
    [anon_sym_CARET] = ACTIONS(5870),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5870),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_GT_GT_GT] = ACTIONS(5870),
    [anon_sym_EQ_EQ] = ACTIONS(5870),
    [anon_sym_BANG_EQ] = ACTIONS(5870),
    [anon_sym_GT_EQ] = ACTIONS(5870),
    [anon_sym_LT_EQ] = ACTIONS(5870),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [anon_sym_switch] = ACTIONS(5870),
    [anon_sym_when] = ACTIONS(5870),
    [anon_sym_DOT_DOT] = ACTIONS(5870),
    [anon_sym_and] = ACTIONS(5870),
    [anon_sym_or] = ACTIONS(5870),
    [anon_sym_AMP_AMP] = ACTIONS(5870),
    [anon_sym_PIPE_PIPE] = ACTIONS(5870),
    [anon_sym_QMARK_QMARK] = ACTIONS(5870),
    [anon_sym_on] = ACTIONS(5870),
    [anon_sym_equals] = ACTIONS(5870),
    [anon_sym_by] = ACTIONS(5870),
    [anon_sym_as] = ACTIONS(5870),
    [anon_sym_is] = ACTIONS(5870),
    [anon_sym_DASH_GT] = ACTIONS(5870),
    [anon_sym_with] = ACTIONS(5870),
    [aux_sym_preproc_if_token3] = ACTIONS(5870),
    [aux_sym_preproc_else_token1] = ACTIONS(5870),
    [aux_sym_preproc_elif_token1] = ACTIONS(5870),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4312] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(6990),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9155),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4312),
    [sym_preproc_endregion] = STATE(4312),
    [sym_preproc_line] = STATE(4312),
    [sym_preproc_pragma] = STATE(4312),
    [sym_preproc_nullable] = STATE(4312),
    [sym_preproc_error] = STATE(4312),
    [sym_preproc_define] = STATE(4312),
    [sym_preproc_undef] = STATE(4312),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4313] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7005),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9009),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4313),
    [sym_preproc_endregion] = STATE(4313),
    [sym_preproc_line] = STATE(4313),
    [sym_preproc_pragma] = STATE(4313),
    [sym_preproc_nullable] = STATE(4313),
    [sym_preproc_error] = STATE(4313),
    [sym_preproc_define] = STATE(4313),
    [sym_preproc_undef] = STATE(4313),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4314] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7020),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9128),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4314),
    [sym_preproc_endregion] = STATE(4314),
    [sym_preproc_line] = STATE(4314),
    [sym_preproc_pragma] = STATE(4314),
    [sym_preproc_nullable] = STATE(4314),
    [sym_preproc_error] = STATE(4314),
    [sym_preproc_define] = STATE(4314),
    [sym_preproc_undef] = STATE(4314),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4315] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7063),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9030),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4315),
    [sym_preproc_endregion] = STATE(4315),
    [sym_preproc_line] = STATE(4315),
    [sym_preproc_pragma] = STATE(4315),
    [sym_preproc_nullable] = STATE(4315),
    [sym_preproc_error] = STATE(4315),
    [sym_preproc_define] = STATE(4315),
    [sym_preproc_undef] = STATE(4315),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4316] = {
    [sym_preproc_region] = STATE(4316),
    [sym_preproc_endregion] = STATE(4316),
    [sym_preproc_line] = STATE(4316),
    [sym_preproc_pragma] = STATE(4316),
    [sym_preproc_nullable] = STATE(4316),
    [sym_preproc_error] = STATE(4316),
    [sym_preproc_define] = STATE(4316),
    [sym_preproc_undef] = STATE(4316),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_COMMA] = ACTIONS(5676),
    [anon_sym_RBRACK] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5676),
    [anon_sym_RPAREN] = ACTIONS(5676),
    [anon_sym_RBRACE] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5678),
    [anon_sym_in] = ACTIONS(5676),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_BANG] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_GT_GT_GT] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_BANG_EQ] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5676),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(5678),
    [anon_sym_EQ_GT] = ACTIONS(5676),
    [anon_sym_switch] = ACTIONS(5676),
    [anon_sym_when] = ACTIONS(5676),
    [anon_sym_DOT_DOT] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_or] = ACTIONS(5676),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_QMARK_QMARK] = ACTIONS(5676),
    [anon_sym_on] = ACTIONS(5676),
    [anon_sym_equals] = ACTIONS(5676),
    [anon_sym_by] = ACTIONS(5676),
    [anon_sym_as] = ACTIONS(5676),
    [anon_sym_is] = ACTIONS(5676),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [anon_sym_with] = ACTIONS(5676),
    [aux_sym_preproc_if_token3] = ACTIONS(5676),
    [aux_sym_preproc_else_token1] = ACTIONS(5676),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4317] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9230),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4317),
    [sym_preproc_endregion] = STATE(4317),
    [sym_preproc_line] = STATE(4317),
    [sym_preproc_pragma] = STATE(4317),
    [sym_preproc_nullable] = STATE(4317),
    [sym_preproc_error] = STATE(4317),
    [sym_preproc_define] = STATE(4317),
    [sym_preproc_undef] = STATE(4317),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4318] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7155),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9132),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4318),
    [sym_preproc_endregion] = STATE(4318),
    [sym_preproc_line] = STATE(4318),
    [sym_preproc_pragma] = STATE(4318),
    [sym_preproc_nullable] = STATE(4318),
    [sym_preproc_error] = STATE(4318),
    [sym_preproc_define] = STATE(4318),
    [sym_preproc_undef] = STATE(4318),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4319] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(4319),
    [sym_preproc_endregion] = STATE(4319),
    [sym_preproc_line] = STATE(4319),
    [sym_preproc_pragma] = STATE(4319),
    [sym_preproc_nullable] = STATE(4319),
    [sym_preproc_error] = STATE(4319),
    [sym_preproc_define] = STATE(4319),
    [sym_preproc_undef] = STATE(4319),
    [sym__identifier_token] = ACTIONS(4051),
    [anon_sym_alias] = ACTIONS(4055),
    [anon_sym_global] = ACTIONS(4055),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_file] = ACTIONS(4055),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4055),
    [anon_sym_unmanaged] = ACTIONS(4055),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4055),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4055),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(4055),
    [anon_sym_when] = ACTIONS(4055),
    [anon_sym_from] = ACTIONS(4055),
    [anon_sym_into] = ACTIONS(4055),
    [anon_sym_join] = ACTIONS(4055),
    [anon_sym_on] = ACTIONS(4055),
    [anon_sym_equals] = ACTIONS(4055),
    [anon_sym_let] = ACTIONS(4055),
    [anon_sym_orderby] = ACTIONS(4055),
    [anon_sym_ascending] = ACTIONS(4055),
    [anon_sym_descending] = ACTIONS(4055),
    [anon_sym_group] = ACTIONS(4055),
    [anon_sym_by] = ACTIONS(4055),
    [anon_sym_select] = ACTIONS(4055),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4320] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9432),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4320),
    [sym_preproc_endregion] = STATE(4320),
    [sym_preproc_line] = STATE(4320),
    [sym_preproc_pragma] = STATE(4320),
    [sym_preproc_nullable] = STATE(4320),
    [sym_preproc_error] = STATE(4320),
    [sym_preproc_define] = STATE(4320),
    [sym_preproc_undef] = STATE(4320),
    [aux_sym_function_pointer_type_repeat1] = STATE(4258),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4321] = {
    [sym_preproc_region] = STATE(4321),
    [sym_preproc_endregion] = STATE(4321),
    [sym_preproc_line] = STATE(4321),
    [sym_preproc_pragma] = STATE(4321),
    [sym_preproc_nullable] = STATE(4321),
    [sym_preproc_error] = STATE(4321),
    [sym_preproc_define] = STATE(4321),
    [sym_preproc_undef] = STATE(4321),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_RBRACK] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_in] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_BANG] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_GT_GT_GT] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_EQ_GT] = ACTIONS(5640),
    [anon_sym_switch] = ACTIONS(5640),
    [anon_sym_when] = ACTIONS(5640),
    [anon_sym_DOT_DOT] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_or] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5640),
    [anon_sym_QMARK_QMARK] = ACTIONS(5640),
    [anon_sym_on] = ACTIONS(5640),
    [anon_sym_equals] = ACTIONS(5640),
    [anon_sym_by] = ACTIONS(5640),
    [anon_sym_as] = ACTIONS(5640),
    [anon_sym_is] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [anon_sym_with] = ACTIONS(5640),
    [aux_sym_preproc_if_token3] = ACTIONS(5640),
    [aux_sym_preproc_else_token1] = ACTIONS(5640),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4322] = {
    [sym_preproc_region] = STATE(4322),
    [sym_preproc_endregion] = STATE(4322),
    [sym_preproc_line] = STATE(4322),
    [sym_preproc_pragma] = STATE(4322),
    [sym_preproc_nullable] = STATE(4322),
    [sym_preproc_error] = STATE(4322),
    [sym_preproc_define] = STATE(4322),
    [sym_preproc_undef] = STATE(4322),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_COLON] = ACTIONS(4763),
    [anon_sym_COMMA] = ACTIONS(4763),
    [anon_sym_RBRACK] = ACTIONS(4763),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym_RPAREN] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_LT] = ACTIONS(4765),
    [anon_sym_GT] = ACTIONS(4765),
    [anon_sym_in] = ACTIONS(4763),
    [anon_sym_QMARK] = ACTIONS(4765),
    [anon_sym_BANG] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_STAR] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_PERCENT] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(4763),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_AMP] = ACTIONS(4765),
    [anon_sym_LT_LT] = ACTIONS(4763),
    [anon_sym_GT_GT] = ACTIONS(4765),
    [anon_sym_GT_GT_GT] = ACTIONS(4763),
    [anon_sym_EQ_EQ] = ACTIONS(4763),
    [anon_sym_BANG_EQ] = ACTIONS(4763),
    [anon_sym_GT_EQ] = ACTIONS(4763),
    [anon_sym_LT_EQ] = ACTIONS(4763),
    [anon_sym_DOT] = ACTIONS(4765),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_switch] = ACTIONS(4763),
    [anon_sym_when] = ACTIONS(4763),
    [anon_sym_DOT_DOT] = ACTIONS(4763),
    [anon_sym_and] = ACTIONS(4763),
    [anon_sym_or] = ACTIONS(4763),
    [anon_sym_AMP_AMP] = ACTIONS(4763),
    [anon_sym_PIPE_PIPE] = ACTIONS(4763),
    [anon_sym_QMARK_QMARK] = ACTIONS(4763),
    [anon_sym_on] = ACTIONS(4763),
    [anon_sym_equals] = ACTIONS(4763),
    [anon_sym_by] = ACTIONS(4763),
    [anon_sym_as] = ACTIONS(4763),
    [anon_sym_is] = ACTIONS(4763),
    [anon_sym_DASH_GT] = ACTIONS(4763),
    [anon_sym_with] = ACTIONS(4763),
    [aux_sym_preproc_if_token3] = ACTIONS(4763),
    [aux_sym_preproc_else_token1] = ACTIONS(4763),
    [aux_sym_preproc_elif_token1] = ACTIONS(4763),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4323] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9272),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4323),
    [sym_preproc_endregion] = STATE(4323),
    [sym_preproc_line] = STATE(4323),
    [sym_preproc_pragma] = STATE(4323),
    [sym_preproc_nullable] = STATE(4323),
    [sym_preproc_error] = STATE(4323),
    [sym_preproc_define] = STATE(4323),
    [sym_preproc_undef] = STATE(4323),
    [aux_sym_function_pointer_type_repeat1] = STATE(4522),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4324] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7032),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9492),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4324),
    [sym_preproc_endregion] = STATE(4324),
    [sym_preproc_line] = STATE(4324),
    [sym_preproc_pragma] = STATE(4324),
    [sym_preproc_nullable] = STATE(4324),
    [sym_preproc_error] = STATE(4324),
    [sym_preproc_define] = STATE(4324),
    [sym_preproc_undef] = STATE(4324),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5968),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4325] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7084),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9027),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4325),
    [sym_preproc_endregion] = STATE(4325),
    [sym_preproc_line] = STATE(4325),
    [sym_preproc_pragma] = STATE(4325),
    [sym_preproc_nullable] = STATE(4325),
    [sym_preproc_error] = STATE(4325),
    [sym_preproc_define] = STATE(4325),
    [sym_preproc_undef] = STATE(4325),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4326] = {
    [sym__name] = STATE(7801),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(9230),
    [sym_implicit_type] = STATE(8912),
    [sym_array_type] = STATE(8363),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(8350),
    [sym_pointer_type] = STATE(8350),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(8350),
    [sym_function_pointer_parameter] = STATE(9096),
    [sym_ref_type] = STATE(8763),
    [sym__ref_base_type] = STATE(9098),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(8036),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4326),
    [sym_preproc_endregion] = STATE(4326),
    [sym_preproc_line] = STATE(4326),
    [sym_preproc_pragma] = STATE(4326),
    [sym_preproc_nullable] = STATE(4326),
    [sym_preproc_error] = STATE(4326),
    [sym_preproc_define] = STATE(4326),
    [sym_preproc_undef] = STATE(4326),
    [aux_sym_function_pointer_type_repeat1] = STATE(4323),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5974),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_out] = ACTIONS(5976),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5978),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4327] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7071),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9017),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4327),
    [sym_preproc_endregion] = STATE(4327),
    [sym_preproc_line] = STATE(4327),
    [sym_preproc_pragma] = STATE(4327),
    [sym_preproc_nullable] = STATE(4327),
    [sym_preproc_error] = STATE(4327),
    [sym_preproc_define] = STATE(4327),
    [sym_preproc_undef] = STATE(4327),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(5970),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4328] = {
    [sym_parameter_list] = STATE(9912),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7028),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym__lambda_parameters] = STATE(9575),
    [sym_identifier] = STATE(6792),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4328),
    [sym_preproc_endregion] = STATE(4328),
    [sym_preproc_line] = STATE(4328),
    [sym_preproc_pragma] = STATE(4328),
    [sym_preproc_nullable] = STATE(4328),
    [sym_preproc_error] = STATE(4328),
    [sym_preproc_define] = STATE(4328),
    [sym_preproc_undef] = STATE(4328),
    [aux_sym_lambda_expression_repeat1] = STATE(6839),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4329] = {
    [sym_parameter_list] = STATE(8745),
    [sym_block] = STATE(3765),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7375),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4329),
    [sym_preproc_endregion] = STATE(4329),
    [sym_preproc_line] = STATE(4329),
    [sym_preproc_pragma] = STATE(4329),
    [sym_preproc_nullable] = STATE(4329),
    [sym_preproc_error] = STATE(4329),
    [sym_preproc_define] = STATE(4329),
    [sym_preproc_undef] = STATE(4329),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(6052),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4330] = {
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(5838),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4330),
    [sym_preproc_endregion] = STATE(4330),
    [sym_preproc_line] = STATE(4330),
    [sym_preproc_pragma] = STATE(4330),
    [sym_preproc_nullable] = STATE(4330),
    [sym_preproc_error] = STATE(4330),
    [sym_preproc_define] = STATE(4330),
    [sym_preproc_undef] = STATE(4330),
    [sym__identifier_token] = ACTIONS(2667),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2667),
    [anon_sym_LPAREN] = ACTIONS(2711),
    [anon_sym_ref] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2667),
    [anon_sym_file] = ACTIONS(2667),
    [anon_sym_readonly] = ACTIONS(2667),
    [anon_sym_in] = ACTIONS(2667),
    [anon_sym_out] = ACTIONS(2667),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_this] = ACTIONS(2667),
    [anon_sym_scoped] = ACTIONS(2667),
    [anon_sym_var] = ACTIONS(2667),
    [sym_predefined_type] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4331] = {
    [sym_preproc_region] = STATE(4331),
    [sym_preproc_endregion] = STATE(4331),
    [sym_preproc_line] = STATE(4331),
    [sym_preproc_pragma] = STATE(4331),
    [sym_preproc_nullable] = STATE(4331),
    [sym_preproc_error] = STATE(4331),
    [sym_preproc_define] = STATE(4331),
    [sym_preproc_undef] = STATE(4331),
    [anon_sym_SEMI] = ACTIONS(4482),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_COLON] = ACTIONS(4482),
    [anon_sym_COMMA] = ACTIONS(4482),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_RPAREN] = ACTIONS(4482),
    [anon_sym_LBRACE] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(4480),
    [anon_sym_GT] = ACTIONS(4480),
    [anon_sym_in] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4482),
    [anon_sym_SLASH] = ACTIONS(4480),
    [anon_sym_PERCENT] = ACTIONS(4482),
    [anon_sym_CARET] = ACTIONS(4482),
    [anon_sym_PIPE] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_LT_LT] = ACTIONS(4482),
    [anon_sym_GT_GT] = ACTIONS(4480),
    [anon_sym_GT_GT_GT] = ACTIONS(4482),
    [anon_sym_EQ_EQ] = ACTIONS(4482),
    [anon_sym_BANG_EQ] = ACTIONS(4482),
    [anon_sym_GT_EQ] = ACTIONS(4482),
    [anon_sym_LT_EQ] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(6054),
    [anon_sym_EQ_GT] = ACTIONS(4482),
    [anon_sym_switch] = ACTIONS(4482),
    [anon_sym_DOT_DOT] = ACTIONS(4482),
    [anon_sym_AMP_AMP] = ACTIONS(4482),
    [anon_sym_PIPE_PIPE] = ACTIONS(4482),
    [anon_sym_QMARK_QMARK] = ACTIONS(4482),
    [anon_sym_into] = ACTIONS(4482),
    [anon_sym_on] = ACTIONS(4482),
    [anon_sym_equals] = ACTIONS(4482),
    [anon_sym_by] = ACTIONS(4482),
    [anon_sym_as] = ACTIONS(4482),
    [anon_sym_is] = ACTIONS(4482),
    [anon_sym_DASH_GT] = ACTIONS(4482),
    [anon_sym_with] = ACTIONS(4482),
    [aux_sym_preproc_if_token3] = ACTIONS(4482),
    [aux_sym_preproc_else_token1] = ACTIONS(4482),
    [aux_sym_preproc_elif_token1] = ACTIONS(4482),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4332] = {
    [sym_preproc_region] = STATE(4332),
    [sym_preproc_endregion] = STATE(4332),
    [sym_preproc_line] = STATE(4332),
    [sym_preproc_pragma] = STATE(4332),
    [sym_preproc_nullable] = STATE(4332),
    [sym_preproc_error] = STATE(4332),
    [sym_preproc_define] = STATE(4332),
    [sym_preproc_undef] = STATE(4332),
    [anon_sym_EQ] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6058),
    [anon_sym_DASH_EQ] = ACTIONS(6058),
    [anon_sym_STAR_EQ] = ACTIONS(6058),
    [anon_sym_SLASH_EQ] = ACTIONS(6058),
    [anon_sym_PERCENT_EQ] = ACTIONS(6058),
    [anon_sym_AMP_EQ] = ACTIONS(6058),
    [anon_sym_CARET_EQ] = ACTIONS(6058),
    [anon_sym_PIPE_EQ] = ACTIONS(6058),
    [anon_sym_LT_LT_EQ] = ACTIONS(6058),
    [anon_sym_GT_GT_EQ] = ACTIONS(6058),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6058),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6058),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4333] = {
    [sym_preproc_region] = STATE(4333),
    [sym_preproc_endregion] = STATE(4333),
    [sym_preproc_line] = STATE(4333),
    [sym_preproc_pragma] = STATE(4333),
    [sym_preproc_nullable] = STATE(4333),
    [sym_preproc_error] = STATE(4333),
    [sym_preproc_define] = STATE(4333),
    [sym_preproc_undef] = STATE(4333),
    [sym__identifier_token] = ACTIONS(6060),
    [anon_sym_extern] = ACTIONS(6060),
    [anon_sym_alias] = ACTIONS(6060),
    [anon_sym_global] = ACTIONS(6060),
    [anon_sym_unsafe] = ACTIONS(6060),
    [anon_sym_static] = ACTIONS(6060),
    [anon_sym_LBRACK] = ACTIONS(6062),
    [anon_sym_RBRACE] = ACTIONS(6062),
    [anon_sym_abstract] = ACTIONS(6060),
    [anon_sym_async] = ACTIONS(6060),
    [anon_sym_const] = ACTIONS(6060),
    [anon_sym_file] = ACTIONS(6060),
    [anon_sym_fixed] = ACTIONS(6060),
    [anon_sym_internal] = ACTIONS(6060),
    [anon_sym_new] = ACTIONS(6060),
    [anon_sym_override] = ACTIONS(6060),
    [anon_sym_partial] = ACTIONS(6060),
    [anon_sym_private] = ACTIONS(6060),
    [anon_sym_protected] = ACTIONS(6060),
    [anon_sym_public] = ACTIONS(6060),
    [anon_sym_readonly] = ACTIONS(6060),
    [anon_sym_required] = ACTIONS(6060),
    [anon_sym_sealed] = ACTIONS(6060),
    [anon_sym_virtual] = ACTIONS(6060),
    [anon_sym_volatile] = ACTIONS(6060),
    [anon_sym_where] = ACTIONS(6060),
    [anon_sym_notnull] = ACTIONS(6060),
    [anon_sym_unmanaged] = ACTIONS(6060),
    [anon_sym_get] = ACTIONS(6060),
    [anon_sym_set] = ACTIONS(6060),
    [anon_sym_add] = ACTIONS(6060),
    [anon_sym_remove] = ACTIONS(6060),
    [anon_sym_init] = ACTIONS(6060),
    [anon_sym_scoped] = ACTIONS(6060),
    [anon_sym_var] = ACTIONS(6060),
    [anon_sym_yield] = ACTIONS(6060),
    [anon_sym_when] = ACTIONS(6060),
    [anon_sym_from] = ACTIONS(6060),
    [anon_sym_into] = ACTIONS(6060),
    [anon_sym_join] = ACTIONS(6060),
    [anon_sym_on] = ACTIONS(6060),
    [anon_sym_equals] = ACTIONS(6060),
    [anon_sym_let] = ACTIONS(6060),
    [anon_sym_orderby] = ACTIONS(6060),
    [anon_sym_ascending] = ACTIONS(6060),
    [anon_sym_descending] = ACTIONS(6060),
    [anon_sym_group] = ACTIONS(6060),
    [anon_sym_by] = ACTIONS(6060),
    [anon_sym_select] = ACTIONS(6060),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4334] = {
    [sym_preproc_region] = STATE(4334),
    [sym_preproc_endregion] = STATE(4334),
    [sym_preproc_line] = STATE(4334),
    [sym_preproc_pragma] = STATE(4334),
    [sym_preproc_nullable] = STATE(4334),
    [sym_preproc_error] = STATE(4334),
    [sym_preproc_define] = STATE(4334),
    [sym_preproc_undef] = STATE(4334),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(4538),
    [anon_sym_COLON] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(4451),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4453),
    [anon_sym_DASH_DASH] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_SLASH] = ACTIONS(4451),
    [anon_sym_PERCENT] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4451),
    [anon_sym_LT_LT] = ACTIONS(4453),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_GT_GT_GT] = ACTIONS(4453),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(6054),
    [anon_sym_EQ_GT] = ACTIONS(4453),
    [anon_sym_switch] = ACTIONS(4453),
    [anon_sym_DOT_DOT] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE] = ACTIONS(4453),
    [anon_sym_QMARK_QMARK] = ACTIONS(4453),
    [anon_sym_into] = ACTIONS(4453),
    [anon_sym_on] = ACTIONS(4453),
    [anon_sym_equals] = ACTIONS(4453),
    [anon_sym_by] = ACTIONS(4453),
    [anon_sym_as] = ACTIONS(4453),
    [anon_sym_is] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_with] = ACTIONS(4453),
    [aux_sym_preproc_if_token3] = ACTIONS(4453),
    [aux_sym_preproc_else_token1] = ACTIONS(4453),
    [aux_sym_preproc_elif_token1] = ACTIONS(4453),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4335] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3038),
    [sym_preproc_region] = STATE(4335),
    [sym_preproc_endregion] = STATE(4335),
    [sym_preproc_line] = STATE(4335),
    [sym_preproc_pragma] = STATE(4335),
    [sym_preproc_nullable] = STATE(4335),
    [sym_preproc_error] = STATE(4335),
    [sym_preproc_define] = STATE(4335),
    [sym_preproc_undef] = STATE(4335),
    [anon_sym_SEMI] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(6064),
    [anon_sym_COLON] = ACTIONS(5311),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_RBRACK] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5311),
    [anon_sym_LT] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5313),
    [anon_sym_in] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5313),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_GT_GT_GT] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5311),
    [anon_sym_BANG_EQ] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5311),
    [anon_sym_switch] = ACTIONS(5311),
    [anon_sym_DOT_DOT] = ACTIONS(5311),
    [anon_sym_AMP_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_QMARK_QMARK] = ACTIONS(5311),
    [anon_sym_on] = ACTIONS(5311),
    [anon_sym_equals] = ACTIONS(5311),
    [anon_sym_by] = ACTIONS(5311),
    [anon_sym_as] = ACTIONS(5311),
    [anon_sym_is] = ACTIONS(5311),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5311),
    [aux_sym_preproc_if_token3] = ACTIONS(5311),
    [aux_sym_preproc_else_token1] = ACTIONS(5311),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4336] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3038),
    [sym_preproc_region] = STATE(4336),
    [sym_preproc_endregion] = STATE(4336),
    [sym_preproc_line] = STATE(4336),
    [sym_preproc_pragma] = STATE(4336),
    [sym_preproc_nullable] = STATE(4336),
    [sym_preproc_error] = STATE(4336),
    [sym_preproc_define] = STATE(4336),
    [sym_preproc_undef] = STATE(4336),
    [anon_sym_SEMI] = ACTIONS(5282),
    [anon_sym_LBRACK] = ACTIONS(6064),
    [anon_sym_COLON] = ACTIONS(5282),
    [anon_sym_COMMA] = ACTIONS(5282),
    [anon_sym_RBRACK] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5282),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LT] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_in] = ACTIONS(5282),
    [anon_sym_QMARK] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_DASH] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5282),
    [anon_sym_SLASH] = ACTIONS(5286),
    [anon_sym_PERCENT] = ACTIONS(5282),
    [anon_sym_CARET] = ACTIONS(5282),
    [anon_sym_PIPE] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5286),
    [anon_sym_LT_LT] = ACTIONS(5282),
    [anon_sym_GT_GT] = ACTIONS(5286),
    [anon_sym_GT_GT_GT] = ACTIONS(5282),
    [anon_sym_EQ_EQ] = ACTIONS(5282),
    [anon_sym_BANG_EQ] = ACTIONS(5282),
    [anon_sym_GT_EQ] = ACTIONS(5282),
    [anon_sym_LT_EQ] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5282),
    [anon_sym_switch] = ACTIONS(5282),
    [anon_sym_DOT_DOT] = ACTIONS(5282),
    [anon_sym_AMP_AMP] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5282),
    [anon_sym_QMARK_QMARK] = ACTIONS(5282),
    [anon_sym_on] = ACTIONS(5282),
    [anon_sym_equals] = ACTIONS(5282),
    [anon_sym_by] = ACTIONS(5282),
    [anon_sym_as] = ACTIONS(5282),
    [anon_sym_is] = ACTIONS(5282),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5282),
    [aux_sym_preproc_if_token3] = ACTIONS(5282),
    [aux_sym_preproc_else_token1] = ACTIONS(5282),
    [aux_sym_preproc_elif_token1] = ACTIONS(5282),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4337] = {
    [sym_preproc_region] = STATE(4337),
    [sym_preproc_endregion] = STATE(4337),
    [sym_preproc_line] = STATE(4337),
    [sym_preproc_pragma] = STATE(4337),
    [sym_preproc_nullable] = STATE(4337),
    [sym_preproc_error] = STATE(4337),
    [sym_preproc_define] = STATE(4337),
    [sym_preproc_undef] = STATE(4337),
    [anon_sym_EQ] = ACTIONS(6066),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6068),
    [anon_sym_DASH_EQ] = ACTIONS(6068),
    [anon_sym_STAR_EQ] = ACTIONS(6068),
    [anon_sym_SLASH_EQ] = ACTIONS(6068),
    [anon_sym_PERCENT_EQ] = ACTIONS(6068),
    [anon_sym_AMP_EQ] = ACTIONS(6068),
    [anon_sym_CARET_EQ] = ACTIONS(6068),
    [anon_sym_PIPE_EQ] = ACTIONS(6068),
    [anon_sym_LT_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT_GT_EQ] = ACTIONS(6068),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6068),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6068),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4338] = {
    [sym_preproc_region] = STATE(4338),
    [sym_preproc_endregion] = STATE(4338),
    [sym_preproc_line] = STATE(4338),
    [sym_preproc_pragma] = STATE(4338),
    [sym_preproc_nullable] = STATE(4338),
    [sym_preproc_error] = STATE(4338),
    [sym_preproc_define] = STATE(4338),
    [sym_preproc_undef] = STATE(4338),
    [sym__identifier_token] = ACTIONS(6070),
    [anon_sym_extern] = ACTIONS(6070),
    [anon_sym_alias] = ACTIONS(6070),
    [anon_sym_global] = ACTIONS(6070),
    [anon_sym_unsafe] = ACTIONS(6070),
    [anon_sym_static] = ACTIONS(6070),
    [anon_sym_LBRACK] = ACTIONS(6072),
    [anon_sym_RBRACE] = ACTIONS(6072),
    [anon_sym_abstract] = ACTIONS(6070),
    [anon_sym_async] = ACTIONS(6070),
    [anon_sym_const] = ACTIONS(6070),
    [anon_sym_file] = ACTIONS(6070),
    [anon_sym_fixed] = ACTIONS(6070),
    [anon_sym_internal] = ACTIONS(6070),
    [anon_sym_new] = ACTIONS(6070),
    [anon_sym_override] = ACTIONS(6070),
    [anon_sym_partial] = ACTIONS(6070),
    [anon_sym_private] = ACTIONS(6070),
    [anon_sym_protected] = ACTIONS(6070),
    [anon_sym_public] = ACTIONS(6070),
    [anon_sym_readonly] = ACTIONS(6070),
    [anon_sym_required] = ACTIONS(6070),
    [anon_sym_sealed] = ACTIONS(6070),
    [anon_sym_virtual] = ACTIONS(6070),
    [anon_sym_volatile] = ACTIONS(6070),
    [anon_sym_where] = ACTIONS(6070),
    [anon_sym_notnull] = ACTIONS(6070),
    [anon_sym_unmanaged] = ACTIONS(6070),
    [anon_sym_get] = ACTIONS(6070),
    [anon_sym_set] = ACTIONS(6070),
    [anon_sym_add] = ACTIONS(6070),
    [anon_sym_remove] = ACTIONS(6070),
    [anon_sym_init] = ACTIONS(6070),
    [anon_sym_scoped] = ACTIONS(6070),
    [anon_sym_var] = ACTIONS(6070),
    [anon_sym_yield] = ACTIONS(6070),
    [anon_sym_when] = ACTIONS(6070),
    [anon_sym_from] = ACTIONS(6070),
    [anon_sym_into] = ACTIONS(6070),
    [anon_sym_join] = ACTIONS(6070),
    [anon_sym_on] = ACTIONS(6070),
    [anon_sym_equals] = ACTIONS(6070),
    [anon_sym_let] = ACTIONS(6070),
    [anon_sym_orderby] = ACTIONS(6070),
    [anon_sym_ascending] = ACTIONS(6070),
    [anon_sym_descending] = ACTIONS(6070),
    [anon_sym_group] = ACTIONS(6070),
    [anon_sym_by] = ACTIONS(6070),
    [anon_sym_select] = ACTIONS(6070),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4339] = {
    [sym_preproc_region] = STATE(4339),
    [sym_preproc_endregion] = STATE(4339),
    [sym_preproc_line] = STATE(4339),
    [sym_preproc_pragma] = STATE(4339),
    [sym_preproc_nullable] = STATE(4339),
    [sym_preproc_error] = STATE(4339),
    [sym_preproc_define] = STATE(4339),
    [sym_preproc_undef] = STATE(4339),
    [sym__identifier_token] = ACTIONS(6074),
    [anon_sym_extern] = ACTIONS(6074),
    [anon_sym_alias] = ACTIONS(6074),
    [anon_sym_global] = ACTIONS(6074),
    [anon_sym_unsafe] = ACTIONS(6074),
    [anon_sym_static] = ACTIONS(6074),
    [anon_sym_LBRACK] = ACTIONS(6076),
    [anon_sym_RBRACE] = ACTIONS(6076),
    [anon_sym_abstract] = ACTIONS(6074),
    [anon_sym_async] = ACTIONS(6074),
    [anon_sym_const] = ACTIONS(6074),
    [anon_sym_file] = ACTIONS(6074),
    [anon_sym_fixed] = ACTIONS(6074),
    [anon_sym_internal] = ACTIONS(6074),
    [anon_sym_new] = ACTIONS(6074),
    [anon_sym_override] = ACTIONS(6074),
    [anon_sym_partial] = ACTIONS(6074),
    [anon_sym_private] = ACTIONS(6074),
    [anon_sym_protected] = ACTIONS(6074),
    [anon_sym_public] = ACTIONS(6074),
    [anon_sym_readonly] = ACTIONS(6074),
    [anon_sym_required] = ACTIONS(6074),
    [anon_sym_sealed] = ACTIONS(6074),
    [anon_sym_virtual] = ACTIONS(6074),
    [anon_sym_volatile] = ACTIONS(6074),
    [anon_sym_where] = ACTIONS(6074),
    [anon_sym_notnull] = ACTIONS(6074),
    [anon_sym_unmanaged] = ACTIONS(6074),
    [anon_sym_get] = ACTIONS(6074),
    [anon_sym_set] = ACTIONS(6074),
    [anon_sym_add] = ACTIONS(6074),
    [anon_sym_remove] = ACTIONS(6074),
    [anon_sym_init] = ACTIONS(6074),
    [anon_sym_scoped] = ACTIONS(6074),
    [anon_sym_var] = ACTIONS(6074),
    [anon_sym_yield] = ACTIONS(6074),
    [anon_sym_when] = ACTIONS(6074),
    [anon_sym_from] = ACTIONS(6074),
    [anon_sym_into] = ACTIONS(6074),
    [anon_sym_join] = ACTIONS(6074),
    [anon_sym_on] = ACTIONS(6074),
    [anon_sym_equals] = ACTIONS(6074),
    [anon_sym_let] = ACTIONS(6074),
    [anon_sym_orderby] = ACTIONS(6074),
    [anon_sym_ascending] = ACTIONS(6074),
    [anon_sym_descending] = ACTIONS(6074),
    [anon_sym_group] = ACTIONS(6074),
    [anon_sym_by] = ACTIONS(6074),
    [anon_sym_select] = ACTIONS(6074),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4340] = {
    [sym_argument_list] = STATE(4438),
    [sym_initializer_expression] = STATE(4665),
    [sym_preproc_region] = STATE(4340),
    [sym_preproc_endregion] = STATE(4340),
    [sym_preproc_line] = STATE(4340),
    [sym_preproc_pragma] = STATE(4340),
    [sym_preproc_nullable] = STATE(4340),
    [sym_preproc_error] = STATE(4340),
    [sym_preproc_define] = STATE(4340),
    [sym_preproc_undef] = STATE(4340),
    [anon_sym_LBRACK] = ACTIONS(5263),
    [anon_sym_COMMA] = ACTIONS(5263),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(5267),
    [anon_sym_GT] = ACTIONS(5267),
    [anon_sym_where] = ACTIONS(5263),
    [anon_sym_QMARK] = ACTIONS(5267),
    [anon_sym_BANG] = ACTIONS(5267),
    [anon_sym_PLUS_PLUS] = ACTIONS(5263),
    [anon_sym_DASH_DASH] = ACTIONS(5263),
    [anon_sym_PLUS] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_SLASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5263),
    [anon_sym_CARET] = ACTIONS(5263),
    [anon_sym_PIPE] = ACTIONS(5267),
    [anon_sym_AMP] = ACTIONS(5267),
    [anon_sym_LT_LT] = ACTIONS(5263),
    [anon_sym_GT_GT] = ACTIONS(5267),
    [anon_sym_GT_GT_GT] = ACTIONS(5263),
    [anon_sym_EQ_EQ] = ACTIONS(5263),
    [anon_sym_BANG_EQ] = ACTIONS(5263),
    [anon_sym_GT_EQ] = ACTIONS(5263),
    [anon_sym_LT_EQ] = ACTIONS(5263),
    [anon_sym_DOT] = ACTIONS(5267),
    [anon_sym_switch] = ACTIONS(5263),
    [anon_sym_DOT_DOT] = ACTIONS(5263),
    [anon_sym_and] = ACTIONS(5263),
    [anon_sym_or] = ACTIONS(5267),
    [anon_sym_AMP_AMP] = ACTIONS(5263),
    [anon_sym_PIPE_PIPE] = ACTIONS(5263),
    [anon_sym_QMARK_QMARK] = ACTIONS(5263),
    [anon_sym_from] = ACTIONS(5263),
    [anon_sym_into] = ACTIONS(5263),
    [anon_sym_join] = ACTIONS(5263),
    [anon_sym_let] = ACTIONS(5263),
    [anon_sym_orderby] = ACTIONS(5263),
    [anon_sym_ascending] = ACTIONS(5263),
    [anon_sym_descending] = ACTIONS(5263),
    [anon_sym_group] = ACTIONS(5263),
    [anon_sym_select] = ACTIONS(5263),
    [anon_sym_as] = ACTIONS(5267),
    [anon_sym_is] = ACTIONS(5263),
    [anon_sym_DASH_GT] = ACTIONS(5263),
    [anon_sym_with] = ACTIONS(5263),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4341] = {
    [sym_preproc_region] = STATE(4341),
    [sym_preproc_endregion] = STATE(4341),
    [sym_preproc_line] = STATE(4341),
    [sym_preproc_pragma] = STATE(4341),
    [sym_preproc_nullable] = STATE(4341),
    [sym_preproc_error] = STATE(4341),
    [sym_preproc_define] = STATE(4341),
    [sym_preproc_undef] = STATE(4341),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_EQ] = ACTIONS(6080),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6082),
    [anon_sym_DASH_EQ] = ACTIONS(6082),
    [anon_sym_STAR_EQ] = ACTIONS(6082),
    [anon_sym_SLASH_EQ] = ACTIONS(6082),
    [anon_sym_PERCENT_EQ] = ACTIONS(6082),
    [anon_sym_AMP_EQ] = ACTIONS(6082),
    [anon_sym_CARET_EQ] = ACTIONS(6082),
    [anon_sym_PIPE_EQ] = ACTIONS(6082),
    [anon_sym_LT_LT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6082),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6082),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4342] = {
    [sym_preproc_region] = STATE(4342),
    [sym_preproc_endregion] = STATE(4342),
    [sym_preproc_line] = STATE(4342),
    [sym_preproc_pragma] = STATE(4342),
    [sym_preproc_nullable] = STATE(4342),
    [sym_preproc_error] = STATE(4342),
    [sym_preproc_define] = STATE(4342),
    [sym_preproc_undef] = STATE(4342),
    [anon_sym_EQ] = ACTIONS(6084),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6086),
    [anon_sym_DASH_EQ] = ACTIONS(6086),
    [anon_sym_STAR_EQ] = ACTIONS(6086),
    [anon_sym_SLASH_EQ] = ACTIONS(6086),
    [anon_sym_PERCENT_EQ] = ACTIONS(6086),
    [anon_sym_AMP_EQ] = ACTIONS(6086),
    [anon_sym_CARET_EQ] = ACTIONS(6086),
    [anon_sym_PIPE_EQ] = ACTIONS(6086),
    [anon_sym_LT_LT_EQ] = ACTIONS(6086),
    [anon_sym_GT_GT_EQ] = ACTIONS(6086),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6086),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6086),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4343] = {
    [sym_preproc_region] = STATE(4343),
    [sym_preproc_endregion] = STATE(4343),
    [sym_preproc_line] = STATE(4343),
    [sym_preproc_pragma] = STATE(4343),
    [sym_preproc_nullable] = STATE(4343),
    [sym_preproc_error] = STATE(4343),
    [sym_preproc_define] = STATE(4343),
    [sym_preproc_undef] = STATE(4343),
    [anon_sym_EQ] = ACTIONS(6088),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_in] = ACTIONS(5294),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6090),
    [anon_sym_DASH_EQ] = ACTIONS(6090),
    [anon_sym_STAR_EQ] = ACTIONS(6090),
    [anon_sym_SLASH_EQ] = ACTIONS(6090),
    [anon_sym_PERCENT_EQ] = ACTIONS(6090),
    [anon_sym_AMP_EQ] = ACTIONS(6090),
    [anon_sym_CARET_EQ] = ACTIONS(6090),
    [anon_sym_PIPE_EQ] = ACTIONS(6090),
    [anon_sym_LT_LT_EQ] = ACTIONS(6090),
    [anon_sym_GT_GT_EQ] = ACTIONS(6090),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6090),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6090),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4344] = {
    [sym_preproc_region] = STATE(4344),
    [sym_preproc_endregion] = STATE(4344),
    [sym_preproc_line] = STATE(4344),
    [sym_preproc_pragma] = STATE(4344),
    [sym_preproc_nullable] = STATE(4344),
    [sym_preproc_error] = STATE(4344),
    [sym_preproc_define] = STATE(4344),
    [sym_preproc_undef] = STATE(4344),
    [anon_sym_EQ] = ACTIONS(6092),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6094),
    [anon_sym_DASH_EQ] = ACTIONS(6094),
    [anon_sym_STAR_EQ] = ACTIONS(6094),
    [anon_sym_SLASH_EQ] = ACTIONS(6094),
    [anon_sym_PERCENT_EQ] = ACTIONS(6094),
    [anon_sym_AMP_EQ] = ACTIONS(6094),
    [anon_sym_CARET_EQ] = ACTIONS(6094),
    [anon_sym_PIPE_EQ] = ACTIONS(6094),
    [anon_sym_LT_LT_EQ] = ACTIONS(6094),
    [anon_sym_GT_GT_EQ] = ACTIONS(6094),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6094),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6094),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
    [sym_interpolation_close_brace] = ACTIONS(5294),
  },
  [4345] = {
    [sym_attribute_list] = STATE(4530),
    [sym_preproc_region] = STATE(4345),
    [sym_preproc_endregion] = STATE(4345),
    [sym_preproc_line] = STATE(4345),
    [sym_preproc_pragma] = STATE(4345),
    [sym_preproc_nullable] = STATE(4345),
    [sym_preproc_error] = STATE(4345),
    [sym_preproc_define] = STATE(4345),
    [sym_preproc_undef] = STATE(4345),
    [aux_sym_class_declaration_repeat1] = STATE(4345),
    [sym__identifier_token] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym_alias] = ACTIONS(5357),
    [anon_sym_global] = ACTIONS(5357),
    [anon_sym_unsafe] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(6096),
    [anon_sym_LPAREN] = ACTIONS(5362),
    [anon_sym_ref] = ACTIONS(5357),
    [anon_sym_delegate] = ACTIONS(5357),
    [anon_sym_abstract] = ACTIONS(5357),
    [anon_sym_async] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_file] = ACTIONS(5357),
    [anon_sym_fixed] = ACTIONS(5357),
    [anon_sym_internal] = ACTIONS(5357),
    [anon_sym_new] = ACTIONS(5357),
    [anon_sym_override] = ACTIONS(5357),
    [anon_sym_partial] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_readonly] = ACTIONS(5357),
    [anon_sym_required] = ACTIONS(5357),
    [anon_sym_sealed] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_where] = ACTIONS(5357),
    [anon_sym_notnull] = ACTIONS(5357),
    [anon_sym_unmanaged] = ACTIONS(5357),
    [anon_sym_scoped] = ACTIONS(5357),
    [anon_sym_var] = ACTIONS(5357),
    [sym_predefined_type] = ACTIONS(5357),
    [anon_sym_yield] = ACTIONS(5357),
    [anon_sym_when] = ACTIONS(5357),
    [anon_sym_from] = ACTIONS(5357),
    [anon_sym_into] = ACTIONS(5357),
    [anon_sym_join] = ACTIONS(5357),
    [anon_sym_on] = ACTIONS(5357),
    [anon_sym_equals] = ACTIONS(5357),
    [anon_sym_let] = ACTIONS(5357),
    [anon_sym_orderby] = ACTIONS(5357),
    [anon_sym_ascending] = ACTIONS(5357),
    [anon_sym_descending] = ACTIONS(5357),
    [anon_sym_group] = ACTIONS(5357),
    [anon_sym_by] = ACTIONS(5357),
    [anon_sym_select] = ACTIONS(5357),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4346] = {
    [sym_preproc_region] = STATE(4346),
    [sym_preproc_endregion] = STATE(4346),
    [sym_preproc_line] = STATE(4346),
    [sym_preproc_pragma] = STATE(4346),
    [sym_preproc_nullable] = STATE(4346),
    [sym_preproc_error] = STATE(4346),
    [sym_preproc_define] = STATE(4346),
    [sym_preproc_undef] = STATE(4346),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6017),
    [anon_sym_DASH_EQ] = ACTIONS(6017),
    [anon_sym_STAR_EQ] = ACTIONS(6017),
    [anon_sym_SLASH_EQ] = ACTIONS(6017),
    [anon_sym_PERCENT_EQ] = ACTIONS(6017),
    [anon_sym_AMP_EQ] = ACTIONS(6017),
    [anon_sym_CARET_EQ] = ACTIONS(6017),
    [anon_sym_PIPE_EQ] = ACTIONS(6017),
    [anon_sym_LT_LT_EQ] = ACTIONS(6017),
    [anon_sym_GT_GT_EQ] = ACTIONS(6017),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6017),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4347] = {
    [sym_preproc_region] = STATE(4347),
    [sym_preproc_endregion] = STATE(4347),
    [sym_preproc_line] = STATE(4347),
    [sym_preproc_pragma] = STATE(4347),
    [sym_preproc_nullable] = STATE(4347),
    [sym_preproc_error] = STATE(4347),
    [sym_preproc_define] = STATE(4347),
    [sym_preproc_undef] = STATE(4347),
    [sym__identifier_token] = ACTIONS(6101),
    [anon_sym_extern] = ACTIONS(6101),
    [anon_sym_alias] = ACTIONS(6101),
    [anon_sym_global] = ACTIONS(6101),
    [anon_sym_unsafe] = ACTIONS(6101),
    [anon_sym_static] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(6103),
    [anon_sym_RBRACE] = ACTIONS(6103),
    [anon_sym_abstract] = ACTIONS(6101),
    [anon_sym_async] = ACTIONS(6101),
    [anon_sym_const] = ACTIONS(6101),
    [anon_sym_file] = ACTIONS(6101),
    [anon_sym_fixed] = ACTIONS(6101),
    [anon_sym_internal] = ACTIONS(6101),
    [anon_sym_new] = ACTIONS(6101),
    [anon_sym_override] = ACTIONS(6101),
    [anon_sym_partial] = ACTIONS(6101),
    [anon_sym_private] = ACTIONS(6101),
    [anon_sym_protected] = ACTIONS(6101),
    [anon_sym_public] = ACTIONS(6101),
    [anon_sym_readonly] = ACTIONS(6101),
    [anon_sym_required] = ACTIONS(6101),
    [anon_sym_sealed] = ACTIONS(6101),
    [anon_sym_virtual] = ACTIONS(6101),
    [anon_sym_volatile] = ACTIONS(6101),
    [anon_sym_where] = ACTIONS(6101),
    [anon_sym_notnull] = ACTIONS(6101),
    [anon_sym_unmanaged] = ACTIONS(6101),
    [anon_sym_get] = ACTIONS(6101),
    [anon_sym_set] = ACTIONS(6101),
    [anon_sym_add] = ACTIONS(6101),
    [anon_sym_remove] = ACTIONS(6101),
    [anon_sym_init] = ACTIONS(6101),
    [anon_sym_scoped] = ACTIONS(6101),
    [anon_sym_var] = ACTIONS(6101),
    [anon_sym_yield] = ACTIONS(6101),
    [anon_sym_when] = ACTIONS(6101),
    [anon_sym_from] = ACTIONS(6101),
    [anon_sym_into] = ACTIONS(6101),
    [anon_sym_join] = ACTIONS(6101),
    [anon_sym_on] = ACTIONS(6101),
    [anon_sym_equals] = ACTIONS(6101),
    [anon_sym_let] = ACTIONS(6101),
    [anon_sym_orderby] = ACTIONS(6101),
    [anon_sym_ascending] = ACTIONS(6101),
    [anon_sym_descending] = ACTIONS(6101),
    [anon_sym_group] = ACTIONS(6101),
    [anon_sym_by] = ACTIONS(6101),
    [anon_sym_select] = ACTIONS(6101),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4348] = {
    [sym_modifier] = STATE(4531),
    [sym_preproc_region] = STATE(4348),
    [sym_preproc_endregion] = STATE(4348),
    [sym_preproc_line] = STATE(4348),
    [sym_preproc_pragma] = STATE(4348),
    [sym_preproc_nullable] = STATE(4348),
    [sym_preproc_error] = STATE(4348),
    [sym_preproc_define] = STATE(4348),
    [sym_preproc_undef] = STATE(4348),
    [aux_sym_class_declaration_repeat2] = STATE(4348),
    [sym__identifier_token] = ACTIONS(5686),
    [anon_sym_extern] = ACTIONS(6105),
    [anon_sym_alias] = ACTIONS(5686),
    [anon_sym_global] = ACTIONS(5686),
    [anon_sym_unsafe] = ACTIONS(6105),
    [anon_sym_static] = ACTIONS(6105),
    [anon_sym_abstract] = ACTIONS(6105),
    [anon_sym_async] = ACTIONS(6105),
    [anon_sym_const] = ACTIONS(6105),
    [anon_sym_file] = ACTIONS(6105),
    [anon_sym_fixed] = ACTIONS(6105),
    [anon_sym_internal] = ACTIONS(6105),
    [anon_sym_new] = ACTIONS(6105),
    [anon_sym_override] = ACTIONS(6105),
    [anon_sym_partial] = ACTIONS(6105),
    [anon_sym_private] = ACTIONS(6105),
    [anon_sym_protected] = ACTIONS(6105),
    [anon_sym_public] = ACTIONS(6105),
    [anon_sym_readonly] = ACTIONS(6105),
    [anon_sym_required] = ACTIONS(6105),
    [anon_sym_sealed] = ACTIONS(6105),
    [anon_sym_virtual] = ACTIONS(6105),
    [anon_sym_volatile] = ACTIONS(6105),
    [anon_sym_where] = ACTIONS(5686),
    [anon_sym_notnull] = ACTIONS(5686),
    [anon_sym_unmanaged] = ACTIONS(5686),
    [anon_sym_get] = ACTIONS(5686),
    [anon_sym_set] = ACTIONS(5686),
    [anon_sym_add] = ACTIONS(5686),
    [anon_sym_remove] = ACTIONS(5686),
    [anon_sym_init] = ACTIONS(5686),
    [anon_sym_scoped] = ACTIONS(5686),
    [anon_sym_var] = ACTIONS(5686),
    [anon_sym_yield] = ACTIONS(5686),
    [anon_sym_when] = ACTIONS(5686),
    [anon_sym_from] = ACTIONS(5686),
    [anon_sym_into] = ACTIONS(5686),
    [anon_sym_join] = ACTIONS(5686),
    [anon_sym_on] = ACTIONS(5686),
    [anon_sym_equals] = ACTIONS(5686),
    [anon_sym_let] = ACTIONS(5686),
    [anon_sym_orderby] = ACTIONS(5686),
    [anon_sym_ascending] = ACTIONS(5686),
    [anon_sym_descending] = ACTIONS(5686),
    [anon_sym_group] = ACTIONS(5686),
    [anon_sym_by] = ACTIONS(5686),
    [anon_sym_select] = ACTIONS(5686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4349] = {
    [sym_preproc_region] = STATE(4349),
    [sym_preproc_endregion] = STATE(4349),
    [sym_preproc_line] = STATE(4349),
    [sym_preproc_pragma] = STATE(4349),
    [sym_preproc_nullable] = STATE(4349),
    [sym_preproc_error] = STATE(4349),
    [sym_preproc_define] = STATE(4349),
    [sym_preproc_undef] = STATE(4349),
    [anon_sym_EQ] = ACTIONS(6108),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6110),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4350] = {
    [sym_argument_list] = STATE(4263),
    [sym_bracketed_argument_list] = STATE(3038),
    [sym_preproc_region] = STATE(4350),
    [sym_preproc_endregion] = STATE(4350),
    [sym_preproc_line] = STATE(4350),
    [sym_preproc_pragma] = STATE(4350),
    [sym_preproc_nullable] = STATE(4350),
    [sym_preproc_error] = STATE(4350),
    [sym_preproc_define] = STATE(4350),
    [sym_preproc_undef] = STATE(4350),
    [anon_sym_SEMI] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(6064),
    [anon_sym_COLON] = ACTIONS(5323),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_RBRACK] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5781),
    [anon_sym_RPAREN] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_in] = ACTIONS(5323),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_BANG] = ACTIONS(5800),
    [anon_sym_PLUS_PLUS] = ACTIONS(5802),
    [anon_sym_DASH_DASH] = ACTIONS(5802),
    [anon_sym_PLUS] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5323),
    [anon_sym_SLASH] = ACTIONS(5325),
    [anon_sym_PERCENT] = ACTIONS(5323),
    [anon_sym_CARET] = ACTIONS(5323),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5323),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_GT_GT_GT] = ACTIONS(5323),
    [anon_sym_EQ_EQ] = ACTIONS(5323),
    [anon_sym_BANG_EQ] = ACTIONS(5323),
    [anon_sym_GT_EQ] = ACTIONS(5323),
    [anon_sym_LT_EQ] = ACTIONS(5323),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_EQ_GT] = ACTIONS(5323),
    [anon_sym_switch] = ACTIONS(5323),
    [anon_sym_DOT_DOT] = ACTIONS(5323),
    [anon_sym_AMP_AMP] = ACTIONS(5323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5323),
    [anon_sym_QMARK_QMARK] = ACTIONS(5323),
    [anon_sym_on] = ACTIONS(5323),
    [anon_sym_equals] = ACTIONS(5323),
    [anon_sym_by] = ACTIONS(5323),
    [anon_sym_as] = ACTIONS(5323),
    [anon_sym_is] = ACTIONS(5323),
    [anon_sym_DASH_GT] = ACTIONS(4583),
    [anon_sym_with] = ACTIONS(5323),
    [aux_sym_preproc_if_token3] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4351] = {
    [sym_preproc_region] = STATE(4351),
    [sym_preproc_endregion] = STATE(4351),
    [sym_preproc_line] = STATE(4351),
    [sym_preproc_pragma] = STATE(4351),
    [sym_preproc_nullable] = STATE(4351),
    [sym_preproc_error] = STATE(4351),
    [sym_preproc_define] = STATE(4351),
    [sym_preproc_undef] = STATE(4351),
    [sym__identifier_token] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym_alias] = ACTIONS(3103),
    [anon_sym_global] = ACTIONS(3103),
    [anon_sym_unsafe] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3105),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3103),
    [anon_sym_async] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_file] = ACTIONS(3103),
    [anon_sym_fixed] = ACTIONS(3103),
    [anon_sym_internal] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_override] = ACTIONS(3103),
    [anon_sym_partial] = ACTIONS(3103),
    [anon_sym_private] = ACTIONS(3103),
    [anon_sym_protected] = ACTIONS(3103),
    [anon_sym_public] = ACTIONS(3103),
    [anon_sym_readonly] = ACTIONS(3103),
    [anon_sym_required] = ACTIONS(3103),
    [anon_sym_sealed] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_where] = ACTIONS(3103),
    [anon_sym_notnull] = ACTIONS(3103),
    [anon_sym_unmanaged] = ACTIONS(3103),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_add] = ACTIONS(3103),
    [anon_sym_remove] = ACTIONS(3103),
    [anon_sym_init] = ACTIONS(3103),
    [anon_sym_scoped] = ACTIONS(3103),
    [anon_sym_var] = ACTIONS(3103),
    [anon_sym_yield] = ACTIONS(3103),
    [anon_sym_when] = ACTIONS(3103),
    [anon_sym_from] = ACTIONS(3103),
    [anon_sym_into] = ACTIONS(3103),
    [anon_sym_join] = ACTIONS(3103),
    [anon_sym_on] = ACTIONS(3103),
    [anon_sym_equals] = ACTIONS(3103),
    [anon_sym_let] = ACTIONS(3103),
    [anon_sym_orderby] = ACTIONS(3103),
    [anon_sym_ascending] = ACTIONS(3103),
    [anon_sym_descending] = ACTIONS(3103),
    [anon_sym_group] = ACTIONS(3103),
    [anon_sym_by] = ACTIONS(3103),
    [anon_sym_select] = ACTIONS(3103),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4352] = {
    [sym_preproc_region] = STATE(4352),
    [sym_preproc_endregion] = STATE(4352),
    [sym_preproc_line] = STATE(4352),
    [sym_preproc_pragma] = STATE(4352),
    [sym_preproc_nullable] = STATE(4352),
    [sym_preproc_error] = STATE(4352),
    [sym_preproc_define] = STATE(4352),
    [sym_preproc_undef] = STATE(4352),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_and] = ACTIONS(5294),
    [anon_sym_or] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6114),
    [anon_sym_DASH_EQ] = ACTIONS(6114),
    [anon_sym_STAR_EQ] = ACTIONS(6114),
    [anon_sym_SLASH_EQ] = ACTIONS(6114),
    [anon_sym_PERCENT_EQ] = ACTIONS(6114),
    [anon_sym_AMP_EQ] = ACTIONS(6114),
    [anon_sym_CARET_EQ] = ACTIONS(6114),
    [anon_sym_PIPE_EQ] = ACTIONS(6114),
    [anon_sym_LT_LT_EQ] = ACTIONS(6114),
    [anon_sym_GT_GT_EQ] = ACTIONS(6114),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6114),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6114),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4353] = {
    [sym_preproc_region] = STATE(4353),
    [sym_preproc_endregion] = STATE(4353),
    [sym_preproc_line] = STATE(4353),
    [sym_preproc_pragma] = STATE(4353),
    [sym_preproc_nullable] = STATE(4353),
    [sym_preproc_error] = STATE(4353),
    [sym_preproc_define] = STATE(4353),
    [sym_preproc_undef] = STATE(4353),
    [sym__identifier_token] = ACTIONS(2985),
    [anon_sym_extern] = ACTIONS(2985),
    [anon_sym_alias] = ACTIONS(2985),
    [anon_sym_global] = ACTIONS(2985),
    [anon_sym_unsafe] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_file] = ACTIONS(2985),
    [anon_sym_fixed] = ACTIONS(2985),
    [anon_sym_internal] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_override] = ACTIONS(2985),
    [anon_sym_partial] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_readonly] = ACTIONS(2985),
    [anon_sym_required] = ACTIONS(2985),
    [anon_sym_sealed] = ACTIONS(2985),
    [anon_sym_virtual] = ACTIONS(2985),
    [anon_sym_volatile] = ACTIONS(2985),
    [anon_sym_where] = ACTIONS(2985),
    [anon_sym_notnull] = ACTIONS(2985),
    [anon_sym_unmanaged] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_add] = ACTIONS(2985),
    [anon_sym_remove] = ACTIONS(2985),
    [anon_sym_init] = ACTIONS(2985),
    [anon_sym_scoped] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_when] = ACTIONS(2985),
    [anon_sym_from] = ACTIONS(2985),
    [anon_sym_into] = ACTIONS(2985),
    [anon_sym_join] = ACTIONS(2985),
    [anon_sym_on] = ACTIONS(2985),
    [anon_sym_equals] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_orderby] = ACTIONS(2985),
    [anon_sym_ascending] = ACTIONS(2985),
    [anon_sym_descending] = ACTIONS(2985),
    [anon_sym_group] = ACTIONS(2985),
    [anon_sym_by] = ACTIONS(2985),
    [anon_sym_select] = ACTIONS(2985),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4354] = {
    [sym_preproc_region] = STATE(4354),
    [sym_preproc_endregion] = STATE(4354),
    [sym_preproc_line] = STATE(4354),
    [sym_preproc_pragma] = STATE(4354),
    [sym_preproc_nullable] = STATE(4354),
    [sym_preproc_error] = STATE(4354),
    [sym_preproc_define] = STATE(4354),
    [sym_preproc_undef] = STATE(4354),
    [sym__identifier_token] = ACTIONS(3040),
    [anon_sym_extern] = ACTIONS(3040),
    [anon_sym_alias] = ACTIONS(3040),
    [anon_sym_global] = ACTIONS(3040),
    [anon_sym_unsafe] = ACTIONS(3040),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3042),
    [anon_sym_abstract] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_const] = ACTIONS(3040),
    [anon_sym_file] = ACTIONS(3040),
    [anon_sym_fixed] = ACTIONS(3040),
    [anon_sym_internal] = ACTIONS(3040),
    [anon_sym_new] = ACTIONS(3040),
    [anon_sym_override] = ACTIONS(3040),
    [anon_sym_partial] = ACTIONS(3040),
    [anon_sym_private] = ACTIONS(3040),
    [anon_sym_protected] = ACTIONS(3040),
    [anon_sym_public] = ACTIONS(3040),
    [anon_sym_readonly] = ACTIONS(3040),
    [anon_sym_required] = ACTIONS(3040),
    [anon_sym_sealed] = ACTIONS(3040),
    [anon_sym_virtual] = ACTIONS(3040),
    [anon_sym_volatile] = ACTIONS(3040),
    [anon_sym_where] = ACTIONS(3040),
    [anon_sym_notnull] = ACTIONS(3040),
    [anon_sym_unmanaged] = ACTIONS(3040),
    [anon_sym_get] = ACTIONS(3040),
    [anon_sym_set] = ACTIONS(3040),
    [anon_sym_add] = ACTIONS(3040),
    [anon_sym_remove] = ACTIONS(3040),
    [anon_sym_init] = ACTIONS(3040),
    [anon_sym_scoped] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(3040),
    [anon_sym_yield] = ACTIONS(3040),
    [anon_sym_when] = ACTIONS(3040),
    [anon_sym_from] = ACTIONS(3040),
    [anon_sym_into] = ACTIONS(3040),
    [anon_sym_join] = ACTIONS(3040),
    [anon_sym_on] = ACTIONS(3040),
    [anon_sym_equals] = ACTIONS(3040),
    [anon_sym_let] = ACTIONS(3040),
    [anon_sym_orderby] = ACTIONS(3040),
    [anon_sym_ascending] = ACTIONS(3040),
    [anon_sym_descending] = ACTIONS(3040),
    [anon_sym_group] = ACTIONS(3040),
    [anon_sym_by] = ACTIONS(3040),
    [anon_sym_select] = ACTIONS(3040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4355] = {
    [sym__name] = STATE(6249),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(2751),
    [sym_ref_type] = STATE(2906),
    [sym__scoped_base_type] = STATE(2907),
    [sym_identifier] = STATE(5271),
    [sym__reserved_identifier] = STATE(2744),
    [sym_preproc_region] = STATE(4355),
    [sym_preproc_endregion] = STATE(4355),
    [sym_preproc_line] = STATE(4355),
    [sym_preproc_pragma] = STATE(4355),
    [sym_preproc_nullable] = STATE(4355),
    [sym_preproc_error] = STATE(4355),
    [sym_preproc_define] = STATE(4355),
    [sym_preproc_undef] = STATE(4355),
    [sym__identifier_token] = ACTIONS(4070),
    [anon_sym_alias] = ACTIONS(4073),
    [anon_sym_global] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(3991),
    [anon_sym_COMMA] = ACTIONS(3991),
    [anon_sym_RBRACK] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(3991),
    [anon_sym_RPAREN] = ACTIONS(3991),
    [anon_sym_ref] = ACTIONS(4076),
    [anon_sym_LBRACE] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_file] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_where] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(3991),
    [anon_sym_notnull] = ACTIONS(4073),
    [anon_sym_unmanaged] = ACTIONS(4073),
    [anon_sym_STAR] = ACTIONS(3991),
    [anon_sym_DOT] = ACTIONS(3991),
    [anon_sym_scoped] = ACTIONS(4073),
    [anon_sym_EQ_GT] = ACTIONS(3991),
    [anon_sym_COLON_COLON] = ACTIONS(3991),
    [anon_sym_var] = ACTIONS(4073),
    [anon_sym_yield] = ACTIONS(4073),
    [anon_sym_when] = ACTIONS(4073),
    [sym_discard] = ACTIONS(3993),
    [anon_sym_and] = ACTIONS(3993),
    [anon_sym_or] = ACTIONS(3993),
    [anon_sym_from] = ACTIONS(4073),
    [anon_sym_into] = ACTIONS(4073),
    [anon_sym_join] = ACTIONS(4073),
    [anon_sym_on] = ACTIONS(4073),
    [anon_sym_equals] = ACTIONS(4073),
    [anon_sym_let] = ACTIONS(4073),
    [anon_sym_orderby] = ACTIONS(4073),
    [anon_sym_ascending] = ACTIONS(4073),
    [anon_sym_descending] = ACTIONS(4073),
    [anon_sym_group] = ACTIONS(4073),
    [anon_sym_by] = ACTIONS(4073),
    [anon_sym_select] = ACTIONS(4073),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4356] = {
    [sym_parameter_list] = STATE(8745),
    [sym_block] = STATE(3765),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7342),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4356),
    [sym_preproc_endregion] = STATE(4356),
    [sym_preproc_line] = STATE(4356),
    [sym_preproc_pragma] = STATE(4356),
    [sym_preproc_nullable] = STATE(4356),
    [sym_preproc_error] = STATE(4356),
    [sym_preproc_define] = STATE(4356),
    [sym_preproc_undef] = STATE(4356),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_ref] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(6052),
    [anon_sym_scoped] = ACTIONS(3153),
    [anon_sym_var] = ACTIONS(3155),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4357] = {
    [sym_preproc_region] = STATE(4357),
    [sym_preproc_endregion] = STATE(4357),
    [sym_preproc_line] = STATE(4357),
    [sym_preproc_pragma] = STATE(4357),
    [sym_preproc_nullable] = STATE(4357),
    [sym_preproc_error] = STATE(4357),
    [sym_preproc_define] = STATE(4357),
    [sym_preproc_undef] = STATE(4357),
    [sym__identifier_token] = ACTIONS(3361),
    [anon_sym_extern] = ACTIONS(3361),
    [anon_sym_alias] = ACTIONS(3361),
    [anon_sym_global] = ACTIONS(3361),
    [anon_sym_unsafe] = ACTIONS(3361),
    [anon_sym_static] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(3363),
    [anon_sym_RBRACE] = ACTIONS(3363),
    [anon_sym_abstract] = ACTIONS(3361),
    [anon_sym_async] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_file] = ACTIONS(3361),
    [anon_sym_fixed] = ACTIONS(3361),
    [anon_sym_internal] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(3361),
    [anon_sym_override] = ACTIONS(3361),
    [anon_sym_partial] = ACTIONS(3361),
    [anon_sym_private] = ACTIONS(3361),
    [anon_sym_protected] = ACTIONS(3361),
    [anon_sym_public] = ACTIONS(3361),
    [anon_sym_readonly] = ACTIONS(3361),
    [anon_sym_required] = ACTIONS(3361),
    [anon_sym_sealed] = ACTIONS(3361),
    [anon_sym_virtual] = ACTIONS(3361),
    [anon_sym_volatile] = ACTIONS(3361),
    [anon_sym_where] = ACTIONS(3361),
    [anon_sym_notnull] = ACTIONS(3361),
    [anon_sym_unmanaged] = ACTIONS(3361),
    [anon_sym_get] = ACTIONS(3361),
    [anon_sym_set] = ACTIONS(3361),
    [anon_sym_add] = ACTIONS(3361),
    [anon_sym_remove] = ACTIONS(3361),
    [anon_sym_init] = ACTIONS(3361),
    [anon_sym_scoped] = ACTIONS(3361),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_yield] = ACTIONS(3361),
    [anon_sym_when] = ACTIONS(3361),
    [anon_sym_from] = ACTIONS(3361),
    [anon_sym_into] = ACTIONS(3361),
    [anon_sym_join] = ACTIONS(3361),
    [anon_sym_on] = ACTIONS(3361),
    [anon_sym_equals] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_orderby] = ACTIONS(3361),
    [anon_sym_ascending] = ACTIONS(3361),
    [anon_sym_descending] = ACTIONS(3361),
    [anon_sym_group] = ACTIONS(3361),
    [anon_sym_by] = ACTIONS(3361),
    [anon_sym_select] = ACTIONS(3361),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4358] = {
    [sym_preproc_region] = STATE(4358),
    [sym_preproc_endregion] = STATE(4358),
    [sym_preproc_line] = STATE(4358),
    [sym_preproc_pragma] = STATE(4358),
    [sym_preproc_nullable] = STATE(4358),
    [sym_preproc_error] = STATE(4358),
    [sym_preproc_define] = STATE(4358),
    [sym_preproc_undef] = STATE(4358),
    [sym__identifier_token] = ACTIONS(3365),
    [anon_sym_extern] = ACTIONS(3365),
    [anon_sym_alias] = ACTIONS(3365),
    [anon_sym_global] = ACTIONS(3365),
    [anon_sym_unsafe] = ACTIONS(3365),
    [anon_sym_static] = ACTIONS(3365),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_abstract] = ACTIONS(3365),
    [anon_sym_async] = ACTIONS(3365),
    [anon_sym_const] = ACTIONS(3365),
    [anon_sym_file] = ACTIONS(3365),
    [anon_sym_fixed] = ACTIONS(3365),
    [anon_sym_internal] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3365),
    [anon_sym_override] = ACTIONS(3365),
    [anon_sym_partial] = ACTIONS(3365),
    [anon_sym_private] = ACTIONS(3365),
    [anon_sym_protected] = ACTIONS(3365),
    [anon_sym_public] = ACTIONS(3365),
    [anon_sym_readonly] = ACTIONS(3365),
    [anon_sym_required] = ACTIONS(3365),
    [anon_sym_sealed] = ACTIONS(3365),
    [anon_sym_virtual] = ACTIONS(3365),
    [anon_sym_volatile] = ACTIONS(3365),
    [anon_sym_where] = ACTIONS(3365),
    [anon_sym_notnull] = ACTIONS(3365),
    [anon_sym_unmanaged] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3365),
    [anon_sym_set] = ACTIONS(3365),
    [anon_sym_add] = ACTIONS(3365),
    [anon_sym_remove] = ACTIONS(3365),
    [anon_sym_init] = ACTIONS(3365),
    [anon_sym_scoped] = ACTIONS(3365),
    [anon_sym_var] = ACTIONS(3365),
    [anon_sym_yield] = ACTIONS(3365),
    [anon_sym_when] = ACTIONS(3365),
    [anon_sym_from] = ACTIONS(3365),
    [anon_sym_into] = ACTIONS(3365),
    [anon_sym_join] = ACTIONS(3365),
    [anon_sym_on] = ACTIONS(3365),
    [anon_sym_equals] = ACTIONS(3365),
    [anon_sym_let] = ACTIONS(3365),
    [anon_sym_orderby] = ACTIONS(3365),
    [anon_sym_ascending] = ACTIONS(3365),
    [anon_sym_descending] = ACTIONS(3365),
    [anon_sym_group] = ACTIONS(3365),
    [anon_sym_by] = ACTIONS(3365),
    [anon_sym_select] = ACTIONS(3365),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4359] = {
    [sym_preproc_region] = STATE(4359),
    [sym_preproc_endregion] = STATE(4359),
    [sym_preproc_line] = STATE(4359),
    [sym_preproc_pragma] = STATE(4359),
    [sym_preproc_nullable] = STATE(4359),
    [sym_preproc_error] = STATE(4359),
    [sym_preproc_define] = STATE(4359),
    [sym_preproc_undef] = STATE(4359),
    [anon_sym_EQ] = ACTIONS(6116),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6118),
    [anon_sym_DASH_EQ] = ACTIONS(6118),
    [anon_sym_STAR_EQ] = ACTIONS(6118),
    [anon_sym_SLASH_EQ] = ACTIONS(6118),
    [anon_sym_PERCENT_EQ] = ACTIONS(6118),
    [anon_sym_AMP_EQ] = ACTIONS(6118),
    [anon_sym_CARET_EQ] = ACTIONS(6118),
    [anon_sym_PIPE_EQ] = ACTIONS(6118),
    [anon_sym_LT_LT_EQ] = ACTIONS(6118),
    [anon_sym_GT_GT_EQ] = ACTIONS(6118),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6118),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6118),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_if_token3] = ACTIONS(5294),
    [aux_sym_preproc_else_token1] = ACTIONS(5294),
    [aux_sym_preproc_elif_token1] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4360] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(6000),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(5363),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4360),
    [sym_preproc_endregion] = STATE(4360),
    [sym_preproc_line] = STATE(4360),
    [sym_preproc_pragma] = STATE(4360),
    [sym_preproc_nullable] = STATE(4360),
    [sym_preproc_error] = STATE(4360),
    [sym_preproc_define] = STATE(4360),
    [sym_preproc_undef] = STATE(4360),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(6120),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4361] = {
    [sym_tuple_pattern] = STATE(8662),
    [sym__name] = STATE(5261),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(7218),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(5440),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(5340),
    [sym_tuple_element] = STATE(8709),
    [sym_identifier] = STATE(6760),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4361),
    [sym_preproc_endregion] = STATE(4361),
    [sym_preproc_line] = STATE(4361),
    [sym_preproc_pragma] = STATE(4361),
    [sym_preproc_nullable] = STATE(4361),
    [sym_preproc_error] = STATE(4361),
    [sym_preproc_define] = STATE(4361),
    [sym_preproc_undef] = STATE(4361),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(5274),
    [anon_sym_ref] = ACTIONS(4076),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(6122),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(3157),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [sym_discard] = ACTIONS(5280),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4362] = {
    [sym_preproc_region] = STATE(4362),
    [sym_preproc_endregion] = STATE(4362),
    [sym_preproc_line] = STATE(4362),
    [sym_preproc_pragma] = STATE(4362),
    [sym_preproc_nullable] = STATE(4362),
    [sym_preproc_error] = STATE(4362),
    [sym_preproc_define] = STATE(4362),
    [sym_preproc_undef] = STATE(4362),
    [anon_sym_EQ] = ACTIONS(6124),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6126),
    [anon_sym_DASH_EQ] = ACTIONS(6126),
    [anon_sym_STAR_EQ] = ACTIONS(6126),
    [anon_sym_SLASH_EQ] = ACTIONS(6126),
    [anon_sym_PERCENT_EQ] = ACTIONS(6126),
    [anon_sym_AMP_EQ] = ACTIONS(6126),
    [anon_sym_CARET_EQ] = ACTIONS(6126),
    [anon_sym_PIPE_EQ] = ACTIONS(6126),
    [anon_sym_LT_LT_EQ] = ACTIONS(6126),
    [anon_sym_GT_GT_EQ] = ACTIONS(6126),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6126),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_by] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4363] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4363),
    [sym_preproc_endregion] = STATE(4363),
    [sym_preproc_line] = STATE(4363),
    [sym_preproc_pragma] = STATE(4363),
    [sym_preproc_nullable] = STATE(4363),
    [sym_preproc_error] = STATE(4363),
    [sym_preproc_define] = STATE(4363),
    [sym_preproc_undef] = STATE(4363),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6130),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6130),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6130),
    [anon_sym_or] = ACTIONS(6164),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6130),
    [anon_sym_into] = ACTIONS(6130),
    [anon_sym_join] = ACTIONS(6130),
    [anon_sym_let] = ACTIONS(6130),
    [anon_sym_orderby] = ACTIONS(6130),
    [anon_sym_ascending] = ACTIONS(6130),
    [anon_sym_descending] = ACTIONS(6130),
    [anon_sym_group] = ACTIONS(6130),
    [anon_sym_select] = ACTIONS(6130),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4364] = {
    [sym_preproc_region] = STATE(4364),
    [sym_preproc_endregion] = STATE(4364),
    [sym_preproc_line] = STATE(4364),
    [sym_preproc_pragma] = STATE(4364),
    [sym_preproc_nullable] = STATE(4364),
    [sym_preproc_error] = STATE(4364),
    [sym_preproc_define] = STATE(4364),
    [sym_preproc_undef] = STATE(4364),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6178),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4365] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4365),
    [sym_preproc_endregion] = STATE(4365),
    [sym_preproc_line] = STATE(4365),
    [sym_preproc_pragma] = STATE(4365),
    [sym_preproc_nullable] = STATE(4365),
    [sym_preproc_error] = STATE(4365),
    [sym_preproc_define] = STATE(4365),
    [sym_preproc_undef] = STATE(4365),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4366] = {
    [sym_argument_list] = STATE(3577),
    [sym__name] = STATE(4334),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_type] = STATE(3561),
    [sym_implicit_type] = STATE(3622),
    [sym_array_type] = STATE(4166),
    [sym__array_base_type] = STATE(8987),
    [sym_nullable_type] = STATE(3625),
    [sym_pointer_type] = STATE(3625),
    [sym__pointer_base_type] = STATE(9581),
    [sym_function_pointer_type] = STATE(3625),
    [sym_ref_type] = STATE(3622),
    [sym_scoped_type] = STATE(3622),
    [sym_tuple_type] = STATE(3626),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(4366),
    [sym_preproc_endregion] = STATE(4366),
    [sym_preproc_line] = STATE(4366),
    [sym_preproc_pragma] = STATE(4366),
    [sym_preproc_nullable] = STATE(4366),
    [sym_preproc_error] = STATE(4366),
    [sym_preproc_define] = STATE(4366),
    [sym_preproc_undef] = STATE(4366),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_ref] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_delegate] = ACTIONS(6190),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_scoped] = ACTIONS(6192),
    [anon_sym_var] = ACTIONS(6194),
    [sym_predefined_type] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4367] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4367),
    [sym_preproc_endregion] = STATE(4367),
    [sym_preproc_line] = STATE(4367),
    [sym_preproc_pragma] = STATE(4367),
    [sym_preproc_nullable] = STATE(4367),
    [sym_preproc_error] = STATE(4367),
    [sym_preproc_define] = STATE(4367),
    [sym_preproc_undef] = STATE(4367),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4368] = {
    [sym_argument_list] = STATE(3577),
    [sym__name] = STATE(4334),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_type] = STATE(3561),
    [sym_implicit_type] = STATE(3622),
    [sym_array_type] = STATE(4166),
    [sym__array_base_type] = STATE(8987),
    [sym_nullable_type] = STATE(3625),
    [sym_pointer_type] = STATE(3625),
    [sym__pointer_base_type] = STATE(9581),
    [sym_function_pointer_type] = STATE(3625),
    [sym_ref_type] = STATE(3622),
    [sym_scoped_type] = STATE(3622),
    [sym_tuple_type] = STATE(3626),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(4368),
    [sym_preproc_endregion] = STATE(4368),
    [sym_preproc_line] = STATE(4368),
    [sym_preproc_pragma] = STATE(4368),
    [sym_preproc_nullable] = STATE(4368),
    [sym_preproc_error] = STATE(4368),
    [sym_preproc_define] = STATE(4368),
    [sym_preproc_undef] = STATE(4368),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_ref] = ACTIONS(4290),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_delegate] = ACTIONS(6190),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_scoped] = ACTIONS(6198),
    [anon_sym_var] = ACTIONS(6194),
    [sym_predefined_type] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4369] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4369),
    [sym_preproc_endregion] = STATE(4369),
    [sym_preproc_line] = STATE(4369),
    [sym_preproc_pragma] = STATE(4369),
    [sym_preproc_nullable] = STATE(4369),
    [sym_preproc_error] = STATE(4369),
    [sym_preproc_define] = STATE(4369),
    [sym_preproc_undef] = STATE(4369),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4370] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(4175),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(4056),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4370),
    [sym_preproc_endregion] = STATE(4370),
    [sym_preproc_line] = STATE(4370),
    [sym_preproc_pragma] = STATE(4370),
    [sym_preproc_nullable] = STATE(4370),
    [sym_preproc_error] = STATE(4370),
    [sym_preproc_define] = STATE(4370),
    [sym_preproc_undef] = STATE(4370),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4507),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6208),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4371] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4371),
    [sym_preproc_endregion] = STATE(4371),
    [sym_preproc_line] = STATE(4371),
    [sym_preproc_pragma] = STATE(4371),
    [sym_preproc_nullable] = STATE(4371),
    [sym_preproc_error] = STATE(4371),
    [sym_preproc_define] = STATE(4371),
    [sym_preproc_undef] = STATE(4371),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6214),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6214),
    [anon_sym_or] = ACTIONS(6216),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6214),
    [anon_sym_into] = ACTIONS(6214),
    [anon_sym_join] = ACTIONS(6214),
    [anon_sym_let] = ACTIONS(6214),
    [anon_sym_orderby] = ACTIONS(6214),
    [anon_sym_ascending] = ACTIONS(6214),
    [anon_sym_descending] = ACTIONS(6214),
    [anon_sym_group] = ACTIONS(6214),
    [anon_sym_select] = ACTIONS(6214),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4372] = {
    [sym_preproc_region] = STATE(4372),
    [sym_preproc_endregion] = STATE(4372),
    [sym_preproc_line] = STATE(4372),
    [sym_preproc_pragma] = STATE(4372),
    [sym_preproc_nullable] = STATE(4372),
    [sym_preproc_error] = STATE(4372),
    [sym_preproc_define] = STATE(4372),
    [sym_preproc_undef] = STATE(4372),
    [sym__identifier_token] = ACTIONS(5680),
    [anon_sym_extern] = ACTIONS(5680),
    [anon_sym_alias] = ACTIONS(5680),
    [anon_sym_global] = ACTIONS(5680),
    [anon_sym_unsafe] = ACTIONS(5680),
    [anon_sym_static] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_abstract] = ACTIONS(5680),
    [anon_sym_async] = ACTIONS(5680),
    [anon_sym_const] = ACTIONS(5680),
    [anon_sym_file] = ACTIONS(5680),
    [anon_sym_fixed] = ACTIONS(5680),
    [anon_sym_internal] = ACTIONS(5680),
    [anon_sym_new] = ACTIONS(5680),
    [anon_sym_override] = ACTIONS(5680),
    [anon_sym_partial] = ACTIONS(5680),
    [anon_sym_private] = ACTIONS(5680),
    [anon_sym_protected] = ACTIONS(5680),
    [anon_sym_public] = ACTIONS(5680),
    [anon_sym_readonly] = ACTIONS(5680),
    [anon_sym_required] = ACTIONS(5680),
    [anon_sym_sealed] = ACTIONS(5680),
    [anon_sym_virtual] = ACTIONS(5680),
    [anon_sym_volatile] = ACTIONS(5680),
    [anon_sym_where] = ACTIONS(5680),
    [anon_sym_notnull] = ACTIONS(5680),
    [anon_sym_unmanaged] = ACTIONS(5680),
    [anon_sym_get] = ACTIONS(5680),
    [anon_sym_set] = ACTIONS(5680),
    [anon_sym_add] = ACTIONS(5680),
    [anon_sym_remove] = ACTIONS(5680),
    [anon_sym_init] = ACTIONS(5680),
    [anon_sym_scoped] = ACTIONS(5680),
    [anon_sym_var] = ACTIONS(5680),
    [anon_sym_yield] = ACTIONS(5680),
    [anon_sym_when] = ACTIONS(5680),
    [anon_sym_from] = ACTIONS(5680),
    [anon_sym_into] = ACTIONS(5680),
    [anon_sym_join] = ACTIONS(5680),
    [anon_sym_on] = ACTIONS(5680),
    [anon_sym_equals] = ACTIONS(5680),
    [anon_sym_let] = ACTIONS(5680),
    [anon_sym_orderby] = ACTIONS(5680),
    [anon_sym_ascending] = ACTIONS(5680),
    [anon_sym_descending] = ACTIONS(5680),
    [anon_sym_group] = ACTIONS(5680),
    [anon_sym_by] = ACTIONS(5680),
    [anon_sym_select] = ACTIONS(5680),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4373] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(5155),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4373),
    [sym_preproc_endregion] = STATE(4373),
    [sym_preproc_line] = STATE(4373),
    [sym_preproc_pragma] = STATE(4373),
    [sym_preproc_nullable] = STATE(4373),
    [sym_preproc_error] = STATE(4373),
    [sym_preproc_define] = STATE(4373),
    [sym_preproc_undef] = STATE(4373),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(4524),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4374] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4374),
    [sym_preproc_endregion] = STATE(4374),
    [sym_preproc_line] = STATE(4374),
    [sym_preproc_pragma] = STATE(4374),
    [sym_preproc_nullable] = STATE(4374),
    [sym_preproc_error] = STATE(4374),
    [sym_preproc_define] = STATE(4374),
    [sym_preproc_undef] = STATE(4374),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4375] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4375),
    [sym_preproc_endregion] = STATE(4375),
    [sym_preproc_line] = STATE(4375),
    [sym_preproc_pragma] = STATE(4375),
    [sym_preproc_nullable] = STATE(4375),
    [sym_preproc_error] = STATE(4375),
    [sym_preproc_define] = STATE(4375),
    [sym_preproc_undef] = STATE(4375),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5311),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(5313),
    [anon_sym_GT] = ACTIONS(5313),
    [anon_sym_where] = ACTIONS(5311),
    [anon_sym_QMARK] = ACTIONS(5313),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5311),
    [anon_sym_SLASH] = ACTIONS(5313),
    [anon_sym_PERCENT] = ACTIONS(5311),
    [anon_sym_CARET] = ACTIONS(5311),
    [anon_sym_PIPE] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5313),
    [anon_sym_LT_LT] = ACTIONS(5311),
    [anon_sym_GT_GT] = ACTIONS(5313),
    [anon_sym_GT_GT_GT] = ACTIONS(5311),
    [anon_sym_EQ_EQ] = ACTIONS(5311),
    [anon_sym_BANG_EQ] = ACTIONS(5311),
    [anon_sym_GT_EQ] = ACTIONS(5311),
    [anon_sym_LT_EQ] = ACTIONS(5311),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(5311),
    [anon_sym_DOT_DOT] = ACTIONS(5311),
    [anon_sym_and] = ACTIONS(5311),
    [anon_sym_or] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5311),
    [anon_sym_PIPE_PIPE] = ACTIONS(5311),
    [anon_sym_QMARK_QMARK] = ACTIONS(5311),
    [anon_sym_from] = ACTIONS(5311),
    [anon_sym_into] = ACTIONS(5311),
    [anon_sym_join] = ACTIONS(5311),
    [anon_sym_let] = ACTIONS(5311),
    [anon_sym_orderby] = ACTIONS(5311),
    [anon_sym_ascending] = ACTIONS(5311),
    [anon_sym_descending] = ACTIONS(5311),
    [anon_sym_group] = ACTIONS(5311),
    [anon_sym_select] = ACTIONS(5311),
    [anon_sym_as] = ACTIONS(5313),
    [anon_sym_is] = ACTIONS(5311),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(5311),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4376] = {
    [sym_block] = STATE(2227),
    [sym_preproc_region] = STATE(4376),
    [sym_preproc_endregion] = STATE(4376),
    [sym_preproc_line] = STATE(4376),
    [sym_preproc_pragma] = STATE(4376),
    [sym_preproc_nullable] = STATE(4376),
    [sym_preproc_error] = STATE(4376),
    [sym_preproc_define] = STATE(4376),
    [sym_preproc_undef] = STATE(4376),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(5788),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4377] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4377),
    [sym_preproc_endregion] = STATE(4377),
    [sym_preproc_line] = STATE(4377),
    [sym_preproc_pragma] = STATE(4377),
    [sym_preproc_nullable] = STATE(4377),
    [sym_preproc_error] = STATE(4377),
    [sym_preproc_define] = STATE(4377),
    [sym_preproc_undef] = STATE(4377),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4378] = {
    [sym_block] = STATE(2695),
    [sym_preproc_region] = STATE(4378),
    [sym_preproc_endregion] = STATE(4378),
    [sym_preproc_line] = STATE(4378),
    [sym_preproc_pragma] = STATE(4378),
    [sym_preproc_nullable] = STATE(4378),
    [sym_preproc_error] = STATE(4378),
    [sym_preproc_define] = STATE(4378),
    [sym_preproc_undef] = STATE(4378),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(6218),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4379] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8545),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4379),
    [sym_preproc_endregion] = STATE(4379),
    [sym_preproc_line] = STATE(4379),
    [sym_preproc_pragma] = STATE(4379),
    [sym_preproc_nullable] = STATE(4379),
    [sym_preproc_error] = STATE(4379),
    [sym_preproc_define] = STATE(4379),
    [sym_preproc_undef] = STATE(4379),
    [aux_sym_type_argument_list_repeat1] = STATE(8550),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6220),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4380] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8551),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4380),
    [sym_preproc_endregion] = STATE(4380),
    [sym_preproc_line] = STATE(4380),
    [sym_preproc_pragma] = STATE(4380),
    [sym_preproc_nullable] = STATE(4380),
    [sym_preproc_error] = STATE(4380),
    [sym_preproc_define] = STATE(4380),
    [sym_preproc_undef] = STATE(4380),
    [aux_sym_type_argument_list_repeat1] = STATE(8557),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4381] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8578),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4381),
    [sym_preproc_endregion] = STATE(4381),
    [sym_preproc_line] = STATE(4381),
    [sym_preproc_pragma] = STATE(4381),
    [sym_preproc_nullable] = STATE(4381),
    [sym_preproc_error] = STATE(4381),
    [sym_preproc_define] = STATE(4381),
    [sym_preproc_undef] = STATE(4381),
    [aux_sym_type_argument_list_repeat1] = STATE(8580),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6224),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4382] = {
    [sym_preproc_region] = STATE(4382),
    [sym_preproc_endregion] = STATE(4382),
    [sym_preproc_line] = STATE(4382),
    [sym_preproc_pragma] = STATE(4382),
    [sym_preproc_nullable] = STATE(4382),
    [sym_preproc_error] = STATE(4382),
    [sym_preproc_define] = STATE(4382),
    [sym_preproc_undef] = STATE(4382),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6226),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4383] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4383),
    [sym_preproc_endregion] = STATE(4383),
    [sym_preproc_line] = STATE(4383),
    [sym_preproc_pragma] = STATE(4383),
    [sym_preproc_nullable] = STATE(4383),
    [sym_preproc_error] = STATE(4383),
    [sym_preproc_define] = STATE(4383),
    [sym_preproc_undef] = STATE(4383),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4355),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(4524),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4384] = {
    [sym_argument_list] = STATE(3577),
    [sym__name] = STATE(4334),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_type] = STATE(3561),
    [sym_implicit_type] = STATE(3622),
    [sym_array_type] = STATE(4166),
    [sym__array_base_type] = STATE(8987),
    [sym_nullable_type] = STATE(3625),
    [sym_pointer_type] = STATE(3625),
    [sym__pointer_base_type] = STATE(9581),
    [sym_function_pointer_type] = STATE(3625),
    [sym_ref_type] = STATE(3622),
    [sym_scoped_type] = STATE(3622),
    [sym_tuple_type] = STATE(3626),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(4384),
    [sym_preproc_endregion] = STATE(4384),
    [sym_preproc_line] = STATE(4384),
    [sym_preproc_pragma] = STATE(4384),
    [sym_preproc_nullable] = STATE(4384),
    [sym_preproc_error] = STATE(4384),
    [sym_preproc_define] = STATE(4384),
    [sym_preproc_undef] = STATE(4384),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_ref] = ACTIONS(4719),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_delegate] = ACTIONS(6190),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_scoped] = ACTIONS(6228),
    [anon_sym_var] = ACTIONS(6194),
    [sym_predefined_type] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4385] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4385),
    [sym_preproc_endregion] = STATE(4385),
    [sym_preproc_line] = STATE(4385),
    [sym_preproc_pragma] = STATE(4385),
    [sym_preproc_nullable] = STATE(4385),
    [sym_preproc_error] = STATE(4385),
    [sym_preproc_define] = STATE(4385),
    [sym_preproc_undef] = STATE(4385),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5474),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5472),
    [anon_sym_into] = ACTIONS(5472),
    [anon_sym_join] = ACTIONS(5472),
    [anon_sym_let] = ACTIONS(5472),
    [anon_sym_orderby] = ACTIONS(5472),
    [anon_sym_ascending] = ACTIONS(5472),
    [anon_sym_descending] = ACTIONS(5472),
    [anon_sym_group] = ACTIONS(5472),
    [anon_sym_select] = ACTIONS(5472),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4386] = {
    [sym_argument_list] = STATE(3577),
    [sym__name] = STATE(4964),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_type] = STATE(3561),
    [sym_implicit_type] = STATE(3622),
    [sym_array_type] = STATE(4919),
    [sym__array_base_type] = STATE(8987),
    [sym_nullable_type] = STATE(3625),
    [sym_pointer_type] = STATE(3625),
    [sym__pointer_base_type] = STATE(9581),
    [sym_function_pointer_type] = STATE(3625),
    [sym_ref_type] = STATE(3622),
    [sym_scoped_type] = STATE(3622),
    [sym_tuple_type] = STATE(3626),
    [sym_identifier] = STATE(4618),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(4386),
    [sym_preproc_endregion] = STATE(4386),
    [sym_preproc_line] = STATE(4386),
    [sym_preproc_pragma] = STATE(4386),
    [sym_preproc_nullable] = STATE(4386),
    [sym_preproc_error] = STATE(4386),
    [sym_preproc_define] = STATE(4386),
    [sym_preproc_undef] = STATE(4386),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_ref] = ACTIONS(4709),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_delegate] = ACTIONS(6190),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_scoped] = ACTIONS(6230),
    [anon_sym_var] = ACTIONS(6194),
    [sym_predefined_type] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4387] = {
    [sym_initializer_expression] = STATE(4684),
    [sym_preproc_region] = STATE(4387),
    [sym_preproc_endregion] = STATE(4387),
    [sym_preproc_line] = STATE(4387),
    [sym_preproc_pragma] = STATE(4387),
    [sym_preproc_nullable] = STATE(4387),
    [sym_preproc_error] = STATE(4387),
    [sym_preproc_define] = STATE(4387),
    [sym_preproc_undef] = STATE(4387),
    [anon_sym_LBRACK] = ACTIONS(5327),
    [anon_sym_COMMA] = ACTIONS(5331),
    [anon_sym_LPAREN] = ACTIONS(5331),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(5337),
    [anon_sym_GT] = ACTIONS(5337),
    [anon_sym_where] = ACTIONS(5331),
    [anon_sym_QMARK] = ACTIONS(6235),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_PLUS_PLUS] = ACTIONS(5331),
    [anon_sym_DASH_DASH] = ACTIONS(5331),
    [anon_sym_PLUS] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_STAR] = ACTIONS(5331),
    [anon_sym_SLASH] = ACTIONS(5337),
    [anon_sym_PERCENT] = ACTIONS(5331),
    [anon_sym_CARET] = ACTIONS(5331),
    [anon_sym_PIPE] = ACTIONS(5337),
    [anon_sym_AMP] = ACTIONS(5337),
    [anon_sym_LT_LT] = ACTIONS(5331),
    [anon_sym_GT_GT] = ACTIONS(5337),
    [anon_sym_GT_GT_GT] = ACTIONS(5331),
    [anon_sym_EQ_EQ] = ACTIONS(5331),
    [anon_sym_BANG_EQ] = ACTIONS(5331),
    [anon_sym_GT_EQ] = ACTIONS(5331),
    [anon_sym_LT_EQ] = ACTIONS(5331),
    [anon_sym_DOT] = ACTIONS(5337),
    [anon_sym_switch] = ACTIONS(5331),
    [anon_sym_DOT_DOT] = ACTIONS(5331),
    [anon_sym_and] = ACTIONS(5331),
    [anon_sym_or] = ACTIONS(5337),
    [anon_sym_AMP_AMP] = ACTIONS(5331),
    [anon_sym_PIPE_PIPE] = ACTIONS(5331),
    [anon_sym_QMARK_QMARK] = ACTIONS(5331),
    [anon_sym_from] = ACTIONS(5331),
    [anon_sym_into] = ACTIONS(5331),
    [anon_sym_join] = ACTIONS(5331),
    [anon_sym_let] = ACTIONS(5331),
    [anon_sym_orderby] = ACTIONS(5331),
    [anon_sym_ascending] = ACTIONS(5331),
    [anon_sym_descending] = ACTIONS(5331),
    [anon_sym_group] = ACTIONS(5331),
    [anon_sym_select] = ACTIONS(5331),
    [anon_sym_as] = ACTIONS(5337),
    [anon_sym_is] = ACTIONS(5331),
    [anon_sym_DASH_GT] = ACTIONS(5331),
    [anon_sym_with] = ACTIONS(5331),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4388] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(4175),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(4056),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4388),
    [sym_preproc_endregion] = STATE(4388),
    [sym_preproc_line] = STATE(4388),
    [sym_preproc_pragma] = STATE(4388),
    [sym_preproc_nullable] = STATE(4388),
    [sym_preproc_error] = STATE(4388),
    [sym_preproc_define] = STATE(4388),
    [sym_preproc_undef] = STATE(4388),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4660),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6239),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4389] = {
    [sym_preproc_region] = STATE(4389),
    [sym_preproc_endregion] = STATE(4389),
    [sym_preproc_line] = STATE(4389),
    [sym_preproc_pragma] = STATE(4389),
    [sym_preproc_nullable] = STATE(4389),
    [sym_preproc_error] = STATE(4389),
    [sym_preproc_define] = STATE(4389),
    [sym_preproc_undef] = STATE(4389),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4390] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(4175),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(4056),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4390),
    [sym_preproc_endregion] = STATE(4390),
    [sym_preproc_line] = STATE(4390),
    [sym_preproc_pragma] = STATE(4390),
    [sym_preproc_nullable] = STATE(4390),
    [sym_preproc_error] = STATE(4390),
    [sym_preproc_define] = STATE(4390),
    [sym_preproc_undef] = STATE(4390),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4260),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6241),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4391] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4391),
    [sym_preproc_endregion] = STATE(4391),
    [sym_preproc_line] = STATE(4391),
    [sym_preproc_pragma] = STATE(4391),
    [sym_preproc_nullable] = STATE(4391),
    [sym_preproc_error] = STATE(4391),
    [sym_preproc_define] = STATE(4391),
    [sym_preproc_undef] = STATE(4391),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5468),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5468),
    [anon_sym_into] = ACTIONS(5468),
    [anon_sym_join] = ACTIONS(5468),
    [anon_sym_let] = ACTIONS(5468),
    [anon_sym_orderby] = ACTIONS(5468),
    [anon_sym_ascending] = ACTIONS(5468),
    [anon_sym_descending] = ACTIONS(5468),
    [anon_sym_group] = ACTIONS(5468),
    [anon_sym_select] = ACTIONS(5468),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4392] = {
    [sym_argument_list] = STATE(3815),
    [sym__name] = STATE(3923),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_type] = STATE(3805),
    [sym_implicit_type] = STATE(3940),
    [sym_array_type] = STATE(3837),
    [sym__array_base_type] = STATE(8981),
    [sym_nullable_type] = STATE(3932),
    [sym_pointer_type] = STATE(3932),
    [sym__pointer_base_type] = STATE(9571),
    [sym_function_pointer_type] = STATE(3932),
    [sym_ref_type] = STATE(3940),
    [sym_scoped_type] = STATE(3940),
    [sym_tuple_type] = STATE(3931),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(4392),
    [sym_preproc_endregion] = STATE(4392),
    [sym_preproc_line] = STATE(4392),
    [sym_preproc_pragma] = STATE(4392),
    [sym_preproc_nullable] = STATE(4392),
    [sym_preproc_error] = STATE(4392),
    [sym_preproc_define] = STATE(4392),
    [sym_preproc_undef] = STATE(4392),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(6245),
    [anon_sym_ref] = ACTIONS(4530),
    [anon_sym_LBRACE] = ACTIONS(6247),
    [anon_sym_delegate] = ACTIONS(6249),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_scoped] = ACTIONS(6251),
    [anon_sym_var] = ACTIONS(6253),
    [sym_predefined_type] = ACTIONS(6255),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4223),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4393] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8501),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4393),
    [sym_preproc_endregion] = STATE(4393),
    [sym_preproc_line] = STATE(4393),
    [sym_preproc_pragma] = STATE(4393),
    [sym_preproc_nullable] = STATE(4393),
    [sym_preproc_error] = STATE(4393),
    [sym_preproc_define] = STATE(4393),
    [sym_preproc_undef] = STATE(4393),
    [aux_sym_type_argument_list_repeat1] = STATE(8382),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4394] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4394),
    [sym_preproc_endregion] = STATE(4394),
    [sym_preproc_line] = STATE(4394),
    [sym_preproc_pragma] = STATE(4394),
    [sym_preproc_nullable] = STATE(4394),
    [sym_preproc_error] = STATE(4394),
    [sym_preproc_define] = STATE(4394),
    [sym_preproc_undef] = STATE(4394),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5624),
    [anon_sym_into] = ACTIONS(5624),
    [anon_sym_join] = ACTIONS(5624),
    [anon_sym_let] = ACTIONS(5624),
    [anon_sym_orderby] = ACTIONS(5624),
    [anon_sym_ascending] = ACTIONS(5624),
    [anon_sym_descending] = ACTIONS(5624),
    [anon_sym_group] = ACTIONS(5624),
    [anon_sym_select] = ACTIONS(5624),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4395] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4395),
    [sym_preproc_endregion] = STATE(4395),
    [sym_preproc_line] = STATE(4395),
    [sym_preproc_pragma] = STATE(4395),
    [sym_preproc_nullable] = STATE(4395),
    [sym_preproc_error] = STATE(4395),
    [sym_preproc_define] = STATE(4395),
    [sym_preproc_undef] = STATE(4395),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5518),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5518),
    [anon_sym_or] = ACTIONS(5520),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5518),
    [anon_sym_into] = ACTIONS(5518),
    [anon_sym_join] = ACTIONS(5518),
    [anon_sym_let] = ACTIONS(5518),
    [anon_sym_orderby] = ACTIONS(5518),
    [anon_sym_ascending] = ACTIONS(5518),
    [anon_sym_descending] = ACTIONS(5518),
    [anon_sym_group] = ACTIONS(5518),
    [anon_sym_select] = ACTIONS(5518),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4396] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(4175),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(4056),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4396),
    [sym_preproc_endregion] = STATE(4396),
    [sym_preproc_line] = STATE(4396),
    [sym_preproc_pragma] = STATE(4396),
    [sym_preproc_nullable] = STATE(4396),
    [sym_preproc_error] = STATE(4396),
    [sym_preproc_define] = STATE(4396),
    [sym_preproc_undef] = STATE(4396),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6259),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4397] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4397),
    [sym_preproc_endregion] = STATE(4397),
    [sym_preproc_line] = STATE(4397),
    [sym_preproc_pragma] = STATE(4397),
    [sym_preproc_nullable] = STATE(4397),
    [sym_preproc_error] = STATE(4397),
    [sym_preproc_define] = STATE(4397),
    [sym_preproc_undef] = STATE(4397),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5506),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_or] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5506),
    [anon_sym_into] = ACTIONS(5506),
    [anon_sym_join] = ACTIONS(5506),
    [anon_sym_let] = ACTIONS(5506),
    [anon_sym_orderby] = ACTIONS(5506),
    [anon_sym_ascending] = ACTIONS(5506),
    [anon_sym_descending] = ACTIONS(5506),
    [anon_sym_group] = ACTIONS(5506),
    [anon_sym_select] = ACTIONS(5506),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4398] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4398),
    [sym_preproc_endregion] = STATE(4398),
    [sym_preproc_line] = STATE(4398),
    [sym_preproc_pragma] = STATE(4398),
    [sym_preproc_nullable] = STATE(4398),
    [sym_preproc_error] = STATE(4398),
    [sym_preproc_define] = STATE(4398),
    [sym_preproc_undef] = STATE(4398),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6261),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6261),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6261),
    [anon_sym_or] = ACTIONS(6263),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6261),
    [anon_sym_into] = ACTIONS(6261),
    [anon_sym_join] = ACTIONS(6261),
    [anon_sym_let] = ACTIONS(6261),
    [anon_sym_orderby] = ACTIONS(6261),
    [anon_sym_ascending] = ACTIONS(6261),
    [anon_sym_descending] = ACTIONS(6261),
    [anon_sym_group] = ACTIONS(6261),
    [anon_sym_select] = ACTIONS(6261),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4399] = {
    [sym_argument_list] = STATE(3815),
    [sym__name] = STATE(3923),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_type] = STATE(3805),
    [sym_implicit_type] = STATE(3940),
    [sym_array_type] = STATE(3837),
    [sym__array_base_type] = STATE(8981),
    [sym_nullable_type] = STATE(3932),
    [sym_pointer_type] = STATE(3932),
    [sym__pointer_base_type] = STATE(9571),
    [sym_function_pointer_type] = STATE(3932),
    [sym_ref_type] = STATE(3940),
    [sym_scoped_type] = STATE(3940),
    [sym_tuple_type] = STATE(3931),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(4399),
    [sym_preproc_endregion] = STATE(4399),
    [sym_preproc_line] = STATE(4399),
    [sym_preproc_pragma] = STATE(4399),
    [sym_preproc_nullable] = STATE(4399),
    [sym_preproc_error] = STATE(4399),
    [sym_preproc_define] = STATE(4399),
    [sym_preproc_undef] = STATE(4399),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(6245),
    [anon_sym_ref] = ACTIONS(4225),
    [anon_sym_LBRACE] = ACTIONS(6247),
    [anon_sym_delegate] = ACTIONS(6249),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_scoped] = ACTIONS(6265),
    [anon_sym_var] = ACTIONS(6253),
    [sym_predefined_type] = ACTIONS(6255),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4223),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4400] = {
    [sym_argument_list] = STATE(5213),
    [sym__name] = STATE(5266),
    [sym_alias_qualified_name] = STATE(5396),
    [sym__simple_name] = STATE(5396),
    [sym_qualified_name] = STATE(5396),
    [sym_generic_name] = STATE(5280),
    [sym_type] = STATE(5096),
    [sym_implicit_type] = STATE(5276),
    [sym_array_type] = STATE(5217),
    [sym__array_base_type] = STATE(8779),
    [sym_nullable_type] = STATE(5243),
    [sym_pointer_type] = STATE(5243),
    [sym__pointer_base_type] = STATE(9212),
    [sym_function_pointer_type] = STATE(5243),
    [sym_ref_type] = STATE(5276),
    [sym_scoped_type] = STATE(5276),
    [sym_tuple_type] = STATE(5242),
    [sym_identifier] = STATE(5110),
    [sym__reserved_identifier] = STATE(5191),
    [sym_preproc_region] = STATE(4400),
    [sym_preproc_endregion] = STATE(4400),
    [sym_preproc_line] = STATE(4400),
    [sym_preproc_pragma] = STATE(4400),
    [sym_preproc_nullable] = STATE(4400),
    [sym_preproc_error] = STATE(4400),
    [sym_preproc_define] = STATE(4400),
    [sym_preproc_undef] = STATE(4400),
    [sym__identifier_token] = ACTIONS(4459),
    [anon_sym_alias] = ACTIONS(4461),
    [anon_sym_global] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_LPAREN] = ACTIONS(6269),
    [anon_sym_ref] = ACTIONS(4463),
    [anon_sym_LBRACE] = ACTIONS(6271),
    [anon_sym_delegate] = ACTIONS(6273),
    [anon_sym_file] = ACTIONS(4461),
    [anon_sym_where] = ACTIONS(4461),
    [anon_sym_notnull] = ACTIONS(4461),
    [anon_sym_unmanaged] = ACTIONS(4461),
    [anon_sym_scoped] = ACTIONS(6275),
    [anon_sym_var] = ACTIONS(6277),
    [sym_predefined_type] = ACTIONS(6279),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_when] = ACTIONS(4461),
    [anon_sym_from] = ACTIONS(4461),
    [anon_sym_into] = ACTIONS(4461),
    [anon_sym_join] = ACTIONS(4461),
    [anon_sym_on] = ACTIONS(4461),
    [anon_sym_equals] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_orderby] = ACTIONS(4461),
    [anon_sym_ascending] = ACTIONS(4461),
    [anon_sym_descending] = ACTIONS(4461),
    [anon_sym_group] = ACTIONS(4461),
    [anon_sym_by] = ACTIONS(4461),
    [anon_sym_select] = ACTIONS(4461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4401] = {
    [sym_block] = STATE(2497),
    [sym_preproc_region] = STATE(4401),
    [sym_preproc_endregion] = STATE(4401),
    [sym_preproc_line] = STATE(4401),
    [sym_preproc_pragma] = STATE(4401),
    [sym_preproc_nullable] = STATE(4401),
    [sym_preproc_error] = STATE(4401),
    [sym_preproc_define] = STATE(4401),
    [sym_preproc_undef] = STATE(4401),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4402] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8490),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4402),
    [sym_preproc_endregion] = STATE(4402),
    [sym_preproc_line] = STATE(4402),
    [sym_preproc_pragma] = STATE(4402),
    [sym_preproc_nullable] = STATE(4402),
    [sym_preproc_error] = STATE(4402),
    [sym_preproc_define] = STATE(4402),
    [sym_preproc_undef] = STATE(4402),
    [aux_sym_type_argument_list_repeat1] = STATE(8488),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6281),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4403] = {
    [sym_preproc_region] = STATE(4403),
    [sym_preproc_endregion] = STATE(4403),
    [sym_preproc_line] = STATE(4403),
    [sym_preproc_pragma] = STATE(4403),
    [sym_preproc_nullable] = STATE(4403),
    [sym_preproc_error] = STATE(4403),
    [sym_preproc_define] = STATE(4403),
    [sym_preproc_undef] = STATE(4403),
    [sym__identifier_token] = ACTIONS(5697),
    [anon_sym_extern] = ACTIONS(5697),
    [anon_sym_alias] = ACTIONS(5697),
    [anon_sym_global] = ACTIONS(5697),
    [anon_sym_unsafe] = ACTIONS(5697),
    [anon_sym_static] = ACTIONS(5697),
    [anon_sym_LBRACK] = ACTIONS(5699),
    [anon_sym_abstract] = ACTIONS(5697),
    [anon_sym_async] = ACTIONS(5697),
    [anon_sym_const] = ACTIONS(5697),
    [anon_sym_file] = ACTIONS(5697),
    [anon_sym_fixed] = ACTIONS(5697),
    [anon_sym_internal] = ACTIONS(5697),
    [anon_sym_new] = ACTIONS(5697),
    [anon_sym_override] = ACTIONS(5697),
    [anon_sym_partial] = ACTIONS(5697),
    [anon_sym_private] = ACTIONS(5697),
    [anon_sym_protected] = ACTIONS(5697),
    [anon_sym_public] = ACTIONS(5697),
    [anon_sym_readonly] = ACTIONS(5697),
    [anon_sym_required] = ACTIONS(5697),
    [anon_sym_sealed] = ACTIONS(5697),
    [anon_sym_virtual] = ACTIONS(5697),
    [anon_sym_volatile] = ACTIONS(5697),
    [anon_sym_where] = ACTIONS(5697),
    [anon_sym_notnull] = ACTIONS(5697),
    [anon_sym_unmanaged] = ACTIONS(5697),
    [anon_sym_get] = ACTIONS(5697),
    [anon_sym_set] = ACTIONS(5697),
    [anon_sym_add] = ACTIONS(5697),
    [anon_sym_remove] = ACTIONS(5697),
    [anon_sym_init] = ACTIONS(5697),
    [anon_sym_scoped] = ACTIONS(5697),
    [anon_sym_var] = ACTIONS(5697),
    [anon_sym_yield] = ACTIONS(5697),
    [anon_sym_when] = ACTIONS(5697),
    [anon_sym_from] = ACTIONS(5697),
    [anon_sym_into] = ACTIONS(5697),
    [anon_sym_join] = ACTIONS(5697),
    [anon_sym_on] = ACTIONS(5697),
    [anon_sym_equals] = ACTIONS(5697),
    [anon_sym_let] = ACTIONS(5697),
    [anon_sym_orderby] = ACTIONS(5697),
    [anon_sym_ascending] = ACTIONS(5697),
    [anon_sym_descending] = ACTIONS(5697),
    [anon_sym_group] = ACTIONS(5697),
    [anon_sym_by] = ACTIONS(5697),
    [anon_sym_select] = ACTIONS(5697),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4404] = {
    [sym_preproc_region] = STATE(4404),
    [sym_preproc_endregion] = STATE(4404),
    [sym_preproc_line] = STATE(4404),
    [sym_preproc_pragma] = STATE(4404),
    [sym_preproc_nullable] = STATE(4404),
    [sym_preproc_error] = STATE(4404),
    [sym_preproc_define] = STATE(4404),
    [sym_preproc_undef] = STATE(4404),
    [anon_sym_EQ] = ACTIONS(6283),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6285),
    [anon_sym_DASH_EQ] = ACTIONS(6285),
    [anon_sym_STAR_EQ] = ACTIONS(6285),
    [anon_sym_SLASH_EQ] = ACTIONS(6285),
    [anon_sym_PERCENT_EQ] = ACTIONS(6285),
    [anon_sym_AMP_EQ] = ACTIONS(6285),
    [anon_sym_CARET_EQ] = ACTIONS(6285),
    [anon_sym_PIPE_EQ] = ACTIONS(6285),
    [anon_sym_LT_LT_EQ] = ACTIONS(6285),
    [anon_sym_GT_GT_EQ] = ACTIONS(6285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6285),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6285),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4405] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8623),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4405),
    [sym_preproc_endregion] = STATE(4405),
    [sym_preproc_line] = STATE(4405),
    [sym_preproc_pragma] = STATE(4405),
    [sym_preproc_nullable] = STATE(4405),
    [sym_preproc_error] = STATE(4405),
    [sym_preproc_define] = STATE(4405),
    [sym_preproc_undef] = STATE(4405),
    [aux_sym_type_argument_list_repeat1] = STATE(8627),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6287),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4406] = {
    [sym_argument_list] = STATE(3815),
    [sym__name] = STATE(3923),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_type] = STATE(3805),
    [sym_implicit_type] = STATE(3940),
    [sym_array_type] = STATE(3837),
    [sym__array_base_type] = STATE(8981),
    [sym_nullable_type] = STATE(3932),
    [sym_pointer_type] = STATE(3932),
    [sym__pointer_base_type] = STATE(9571),
    [sym_function_pointer_type] = STATE(3932),
    [sym_ref_type] = STATE(3940),
    [sym_scoped_type] = STATE(3940),
    [sym_tuple_type] = STATE(3931),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(4406),
    [sym_preproc_endregion] = STATE(4406),
    [sym_preproc_line] = STATE(4406),
    [sym_preproc_pragma] = STATE(4406),
    [sym_preproc_nullable] = STATE(4406),
    [sym_preproc_error] = STATE(4406),
    [sym_preproc_define] = STATE(4406),
    [sym_preproc_undef] = STATE(4406),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(6245),
    [anon_sym_ref] = ACTIONS(4689),
    [anon_sym_LBRACE] = ACTIONS(6247),
    [anon_sym_delegate] = ACTIONS(6249),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_scoped] = ACTIONS(6289),
    [anon_sym_var] = ACTIONS(6253),
    [sym_predefined_type] = ACTIONS(6255),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4223),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4407] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4407),
    [sym_preproc_endregion] = STATE(4407),
    [sym_preproc_line] = STATE(4407),
    [sym_preproc_pragma] = STATE(4407),
    [sym_preproc_nullable] = STATE(4407),
    [sym_preproc_error] = STATE(4407),
    [sym_preproc_define] = STATE(4407),
    [sym_preproc_undef] = STATE(4407),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4408] = {
    [sym_argument_list] = STATE(4409),
    [sym__name] = STATE(3012),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_type] = STATE(4340),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(4387),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(4408),
    [sym_preproc_endregion] = STATE(4408),
    [sym_preproc_line] = STATE(4408),
    [sym_preproc_pragma] = STATE(4408),
    [sym_preproc_nullable] = STATE(4408),
    [sym_preproc_error] = STATE(4408),
    [sym_preproc_define] = STATE(4408),
    [sym_preproc_undef] = STATE(4408),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [anon_sym_ref] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(6295),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_where] = ACTIONS(4614),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_scoped] = ACTIONS(6297),
    [anon_sym_var] = ACTIONS(6299),
    [sym_predefined_type] = ACTIONS(6301),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_when] = ACTIONS(4614),
    [anon_sym_from] = ACTIONS(4614),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4614),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4614),
    [anon_sym_orderby] = ACTIONS(4614),
    [anon_sym_ascending] = ACTIONS(4614),
    [anon_sym_descending] = ACTIONS(4614),
    [anon_sym_group] = ACTIONS(4614),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4614),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4409] = {
    [sym_initializer_expression] = STATE(4667),
    [sym_preproc_region] = STATE(4409),
    [sym_preproc_endregion] = STATE(4409),
    [sym_preproc_line] = STATE(4409),
    [sym_preproc_pragma] = STATE(4409),
    [sym_preproc_nullable] = STATE(4409),
    [sym_preproc_error] = STATE(4409),
    [sym_preproc_define] = STATE(4409),
    [sym_preproc_undef] = STATE(4409),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_COMMA] = ACTIONS(5319),
    [anon_sym_LPAREN] = ACTIONS(5319),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(5321),
    [anon_sym_GT] = ACTIONS(5321),
    [anon_sym_where] = ACTIONS(5319),
    [anon_sym_QMARK] = ACTIONS(5321),
    [anon_sym_BANG] = ACTIONS(5321),
    [anon_sym_PLUS_PLUS] = ACTIONS(5319),
    [anon_sym_DASH_DASH] = ACTIONS(5319),
    [anon_sym_PLUS] = ACTIONS(5321),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5319),
    [anon_sym_SLASH] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5319),
    [anon_sym_CARET] = ACTIONS(5319),
    [anon_sym_PIPE] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5321),
    [anon_sym_LT_LT] = ACTIONS(5319),
    [anon_sym_GT_GT] = ACTIONS(5321),
    [anon_sym_GT_GT_GT] = ACTIONS(5319),
    [anon_sym_EQ_EQ] = ACTIONS(5319),
    [anon_sym_BANG_EQ] = ACTIONS(5319),
    [anon_sym_GT_EQ] = ACTIONS(5319),
    [anon_sym_LT_EQ] = ACTIONS(5319),
    [anon_sym_DOT] = ACTIONS(5321),
    [anon_sym_switch] = ACTIONS(5319),
    [anon_sym_DOT_DOT] = ACTIONS(5319),
    [anon_sym_and] = ACTIONS(5319),
    [anon_sym_or] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5319),
    [anon_sym_PIPE_PIPE] = ACTIONS(5319),
    [anon_sym_QMARK_QMARK] = ACTIONS(5319),
    [anon_sym_from] = ACTIONS(5319),
    [anon_sym_into] = ACTIONS(5319),
    [anon_sym_join] = ACTIONS(5319),
    [anon_sym_let] = ACTIONS(5319),
    [anon_sym_orderby] = ACTIONS(5319),
    [anon_sym_ascending] = ACTIONS(5319),
    [anon_sym_descending] = ACTIONS(5319),
    [anon_sym_group] = ACTIONS(5319),
    [anon_sym_select] = ACTIONS(5319),
    [anon_sym_as] = ACTIONS(5321),
    [anon_sym_is] = ACTIONS(5319),
    [anon_sym_DASH_GT] = ACTIONS(5319),
    [anon_sym_with] = ACTIONS(5319),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4410] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8589),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4410),
    [sym_preproc_endregion] = STATE(4410),
    [sym_preproc_line] = STATE(4410),
    [sym_preproc_pragma] = STATE(4410),
    [sym_preproc_nullable] = STATE(4410),
    [sym_preproc_error] = STATE(4410),
    [sym_preproc_define] = STATE(4410),
    [sym_preproc_undef] = STATE(4410),
    [aux_sym_type_argument_list_repeat1] = STATE(8653),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(5735),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4411] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4411),
    [sym_preproc_endregion] = STATE(4411),
    [sym_preproc_line] = STATE(4411),
    [sym_preproc_pragma] = STATE(4411),
    [sym_preproc_nullable] = STATE(4411),
    [sym_preproc_error] = STATE(4411),
    [sym_preproc_define] = STATE(4411),
    [sym_preproc_undef] = STATE(4411),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6303),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6303),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6303),
    [anon_sym_or] = ACTIONS(6305),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6303),
    [anon_sym_into] = ACTIONS(6303),
    [anon_sym_join] = ACTIONS(6303),
    [anon_sym_let] = ACTIONS(6303),
    [anon_sym_orderby] = ACTIONS(6303),
    [anon_sym_ascending] = ACTIONS(6303),
    [anon_sym_descending] = ACTIONS(6303),
    [anon_sym_group] = ACTIONS(6303),
    [anon_sym_select] = ACTIONS(6303),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4412] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4412),
    [sym_preproc_endregion] = STATE(4412),
    [sym_preproc_line] = STATE(4412),
    [sym_preproc_pragma] = STATE(4412),
    [sym_preproc_nullable] = STATE(4412),
    [sym_preproc_error] = STATE(4412),
    [sym_preproc_define] = STATE(4412),
    [sym_preproc_undef] = STATE(4412),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4721),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(6307),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4413] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4413),
    [sym_preproc_endregion] = STATE(4413),
    [sym_preproc_line] = STATE(4413),
    [sym_preproc_pragma] = STATE(4413),
    [sym_preproc_nullable] = STATE(4413),
    [sym_preproc_error] = STATE(4413),
    [sym_preproc_define] = STATE(4413),
    [sym_preproc_undef] = STATE(4413),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6180),
    [anon_sym_GT_GT] = ACTIONS(6182),
    [anon_sym_GT_GT_GT] = ACTIONS(6180),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT_EQ] = ACTIONS(6180),
    [anon_sym_LT_EQ] = ACTIONS(6180),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6182),
    [anon_sym_is] = ACTIONS(6180),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4414] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4414),
    [sym_preproc_endregion] = STATE(4414),
    [sym_preproc_line] = STATE(4414),
    [sym_preproc_pragma] = STATE(4414),
    [sym_preproc_nullable] = STATE(4414),
    [sym_preproc_error] = STATE(4414),
    [sym_preproc_define] = STATE(4414),
    [sym_preproc_undef] = STATE(4414),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6182),
    [anon_sym_DASH] = ACTIONS(6182),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6182),
    [anon_sym_PERCENT] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6180),
    [anon_sym_GT_GT] = ACTIONS(6182),
    [anon_sym_GT_GT_GT] = ACTIONS(6180),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT_EQ] = ACTIONS(6180),
    [anon_sym_LT_EQ] = ACTIONS(6180),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6182),
    [anon_sym_is] = ACTIONS(6180),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4415] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4415),
    [sym_preproc_endregion] = STATE(4415),
    [sym_preproc_line] = STATE(4415),
    [sym_preproc_pragma] = STATE(4415),
    [sym_preproc_nullable] = STATE(4415),
    [sym_preproc_error] = STATE(4415),
    [sym_preproc_define] = STATE(4415),
    [sym_preproc_undef] = STATE(4415),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6182),
    [anon_sym_DASH] = ACTIONS(6182),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6180),
    [anon_sym_GT_GT] = ACTIONS(6182),
    [anon_sym_GT_GT_GT] = ACTIONS(6180),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT_EQ] = ACTIONS(6180),
    [anon_sym_LT_EQ] = ACTIONS(6180),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6182),
    [anon_sym_is] = ACTIONS(6180),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4416] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4416),
    [sym_preproc_endregion] = STATE(4416),
    [sym_preproc_line] = STATE(4416),
    [sym_preproc_pragma] = STATE(4416),
    [sym_preproc_nullable] = STATE(4416),
    [sym_preproc_error] = STATE(4416),
    [sym_preproc_define] = STATE(4416),
    [sym_preproc_undef] = STATE(4416),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6309),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6309),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6309),
    [anon_sym_or] = ACTIONS(6311),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6309),
    [anon_sym_into] = ACTIONS(6309),
    [anon_sym_join] = ACTIONS(6309),
    [anon_sym_let] = ACTIONS(6309),
    [anon_sym_orderby] = ACTIONS(6309),
    [anon_sym_ascending] = ACTIONS(6309),
    [anon_sym_descending] = ACTIONS(6309),
    [anon_sym_group] = ACTIONS(6309),
    [anon_sym_select] = ACTIONS(6309),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4417] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8458),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4417),
    [sym_preproc_endregion] = STATE(4417),
    [sym_preproc_line] = STATE(4417),
    [sym_preproc_pragma] = STATE(4417),
    [sym_preproc_nullable] = STATE(4417),
    [sym_preproc_error] = STATE(4417),
    [sym_preproc_define] = STATE(4417),
    [sym_preproc_undef] = STATE(4417),
    [aux_sym_type_argument_list_repeat1] = STATE(8446),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6313),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4418] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4418),
    [sym_preproc_endregion] = STATE(4418),
    [sym_preproc_line] = STATE(4418),
    [sym_preproc_pragma] = STATE(4418),
    [sym_preproc_nullable] = STATE(4418),
    [sym_preproc_error] = STATE(4418),
    [sym_preproc_define] = STATE(4418),
    [sym_preproc_undef] = STATE(4418),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6315),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6315),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6315),
    [anon_sym_or] = ACTIONS(6317),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6315),
    [anon_sym_into] = ACTIONS(6315),
    [anon_sym_join] = ACTIONS(6315),
    [anon_sym_let] = ACTIONS(6315),
    [anon_sym_orderby] = ACTIONS(6315),
    [anon_sym_ascending] = ACTIONS(6315),
    [anon_sym_descending] = ACTIONS(6315),
    [anon_sym_group] = ACTIONS(6315),
    [anon_sym_select] = ACTIONS(6315),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4419] = {
    [sym_preproc_region] = STATE(4419),
    [sym_preproc_endregion] = STATE(4419),
    [sym_preproc_line] = STATE(4419),
    [sym_preproc_pragma] = STATE(4419),
    [sym_preproc_nullable] = STATE(4419),
    [sym_preproc_error] = STATE(4419),
    [sym_preproc_define] = STATE(4419),
    [sym_preproc_undef] = STATE(4419),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6319),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4420] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4420),
    [sym_preproc_endregion] = STATE(4420),
    [sym_preproc_line] = STATE(4420),
    [sym_preproc_pragma] = STATE(4420),
    [sym_preproc_nullable] = STATE(4420),
    [sym_preproc_error] = STATE(4420),
    [sym_preproc_define] = STATE(4420),
    [sym_preproc_undef] = STATE(4420),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(5286),
    [anon_sym_GT] = ACTIONS(5286),
    [anon_sym_where] = ACTIONS(5282),
    [anon_sym_QMARK] = ACTIONS(5286),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(5286),
    [anon_sym_DASH] = ACTIONS(5286),
    [anon_sym_STAR] = ACTIONS(5282),
    [anon_sym_SLASH] = ACTIONS(5286),
    [anon_sym_PERCENT] = ACTIONS(5282),
    [anon_sym_CARET] = ACTIONS(5282),
    [anon_sym_PIPE] = ACTIONS(5286),
    [anon_sym_AMP] = ACTIONS(5286),
    [anon_sym_LT_LT] = ACTIONS(5282),
    [anon_sym_GT_GT] = ACTIONS(5286),
    [anon_sym_GT_GT_GT] = ACTIONS(5282),
    [anon_sym_EQ_EQ] = ACTIONS(5282),
    [anon_sym_BANG_EQ] = ACTIONS(5282),
    [anon_sym_GT_EQ] = ACTIONS(5282),
    [anon_sym_LT_EQ] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(5282),
    [anon_sym_DOT_DOT] = ACTIONS(5282),
    [anon_sym_and] = ACTIONS(5282),
    [anon_sym_or] = ACTIONS(5286),
    [anon_sym_AMP_AMP] = ACTIONS(5282),
    [anon_sym_PIPE_PIPE] = ACTIONS(5282),
    [anon_sym_QMARK_QMARK] = ACTIONS(5282),
    [anon_sym_from] = ACTIONS(5282),
    [anon_sym_into] = ACTIONS(5282),
    [anon_sym_join] = ACTIONS(5282),
    [anon_sym_let] = ACTIONS(5282),
    [anon_sym_orderby] = ACTIONS(5282),
    [anon_sym_ascending] = ACTIONS(5282),
    [anon_sym_descending] = ACTIONS(5282),
    [anon_sym_group] = ACTIONS(5282),
    [anon_sym_select] = ACTIONS(5282),
    [anon_sym_as] = ACTIONS(5286),
    [anon_sym_is] = ACTIONS(5282),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(5282),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4421] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4421),
    [sym_preproc_endregion] = STATE(4421),
    [sym_preproc_line] = STATE(4421),
    [sym_preproc_pragma] = STATE(4421),
    [sym_preproc_nullable] = STATE(4421),
    [sym_preproc_error] = STATE(4421),
    [sym_preproc_define] = STATE(4421),
    [sym_preproc_undef] = STATE(4421),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6180),
    [anon_sym_BANG_EQ] = ACTIONS(6180),
    [anon_sym_GT_EQ] = ACTIONS(6180),
    [anon_sym_LT_EQ] = ACTIONS(6180),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6182),
    [anon_sym_is] = ACTIONS(6180),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4422] = {
    [sym_initializer_expression] = STATE(4661),
    [sym_preproc_region] = STATE(4422),
    [sym_preproc_endregion] = STATE(4422),
    [sym_preproc_line] = STATE(4422),
    [sym_preproc_pragma] = STATE(4422),
    [sym_preproc_nullable] = STATE(4422),
    [sym_preproc_error] = STATE(4422),
    [sym_preproc_define] = STATE(4422),
    [sym_preproc_undef] = STATE(4422),
    [anon_sym_LBRACK] = ACTIONS(5306),
    [anon_sym_COMMA] = ACTIONS(5304),
    [anon_sym_LPAREN] = ACTIONS(5304),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(5309),
    [anon_sym_GT] = ACTIONS(5309),
    [anon_sym_where] = ACTIONS(5304),
    [anon_sym_QMARK] = ACTIONS(5309),
    [anon_sym_BANG] = ACTIONS(5309),
    [anon_sym_PLUS_PLUS] = ACTIONS(5304),
    [anon_sym_DASH_DASH] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5304),
    [anon_sym_SLASH] = ACTIONS(5309),
    [anon_sym_PERCENT] = ACTIONS(5304),
    [anon_sym_CARET] = ACTIONS(5304),
    [anon_sym_PIPE] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5309),
    [anon_sym_LT_LT] = ACTIONS(5304),
    [anon_sym_GT_GT] = ACTIONS(5309),
    [anon_sym_GT_GT_GT] = ACTIONS(5304),
    [anon_sym_EQ_EQ] = ACTIONS(5304),
    [anon_sym_BANG_EQ] = ACTIONS(5304),
    [anon_sym_GT_EQ] = ACTIONS(5304),
    [anon_sym_LT_EQ] = ACTIONS(5304),
    [anon_sym_DOT] = ACTIONS(5309),
    [anon_sym_switch] = ACTIONS(5304),
    [anon_sym_DOT_DOT] = ACTIONS(5304),
    [anon_sym_and] = ACTIONS(5304),
    [anon_sym_or] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5304),
    [anon_sym_PIPE_PIPE] = ACTIONS(5304),
    [anon_sym_QMARK_QMARK] = ACTIONS(5304),
    [anon_sym_from] = ACTIONS(5304),
    [anon_sym_into] = ACTIONS(5304),
    [anon_sym_join] = ACTIONS(5304),
    [anon_sym_let] = ACTIONS(5304),
    [anon_sym_orderby] = ACTIONS(5304),
    [anon_sym_ascending] = ACTIONS(5304),
    [anon_sym_descending] = ACTIONS(5304),
    [anon_sym_group] = ACTIONS(5304),
    [anon_sym_select] = ACTIONS(5304),
    [anon_sym_as] = ACTIONS(5309),
    [anon_sym_is] = ACTIONS(5304),
    [anon_sym_DASH_GT] = ACTIONS(5304),
    [anon_sym_with] = ACTIONS(5304),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4423] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(6143),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(6055),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(5496),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4423),
    [sym_preproc_endregion] = STATE(4423),
    [sym_preproc_line] = STATE(4423),
    [sym_preproc_pragma] = STATE(4423),
    [sym_preproc_nullable] = STATE(4423),
    [sym_preproc_error] = STATE(4423),
    [sym_preproc_define] = STATE(4423),
    [sym_preproc_undef] = STATE(4423),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4606),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6321),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4424] = {
    [sym_argument_list] = STATE(5213),
    [sym__name] = STATE(5266),
    [sym_alias_qualified_name] = STATE(5396),
    [sym__simple_name] = STATE(5396),
    [sym_qualified_name] = STATE(5396),
    [sym_generic_name] = STATE(5280),
    [sym_type] = STATE(5096),
    [sym_implicit_type] = STATE(5276),
    [sym_array_type] = STATE(5217),
    [sym__array_base_type] = STATE(8779),
    [sym_nullable_type] = STATE(5243),
    [sym_pointer_type] = STATE(5243),
    [sym__pointer_base_type] = STATE(9212),
    [sym_function_pointer_type] = STATE(5243),
    [sym_ref_type] = STATE(5276),
    [sym_scoped_type] = STATE(5276),
    [sym_tuple_type] = STATE(5242),
    [sym_identifier] = STATE(5110),
    [sym__reserved_identifier] = STATE(5191),
    [sym_preproc_region] = STATE(4424),
    [sym_preproc_endregion] = STATE(4424),
    [sym_preproc_line] = STATE(4424),
    [sym_preproc_pragma] = STATE(4424),
    [sym_preproc_nullable] = STATE(4424),
    [sym_preproc_error] = STATE(4424),
    [sym_preproc_define] = STATE(4424),
    [sym_preproc_undef] = STATE(4424),
    [sym__identifier_token] = ACTIONS(4459),
    [anon_sym_alias] = ACTIONS(4461),
    [anon_sym_global] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(6267),
    [anon_sym_LPAREN] = ACTIONS(6269),
    [anon_sym_ref] = ACTIONS(4475),
    [anon_sym_LBRACE] = ACTIONS(6271),
    [anon_sym_delegate] = ACTIONS(6273),
    [anon_sym_file] = ACTIONS(4461),
    [anon_sym_where] = ACTIONS(4461),
    [anon_sym_notnull] = ACTIONS(4461),
    [anon_sym_unmanaged] = ACTIONS(4461),
    [anon_sym_scoped] = ACTIONS(6323),
    [anon_sym_var] = ACTIONS(6277),
    [sym_predefined_type] = ACTIONS(6279),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_when] = ACTIONS(4461),
    [anon_sym_from] = ACTIONS(4461),
    [anon_sym_into] = ACTIONS(4461),
    [anon_sym_join] = ACTIONS(4461),
    [anon_sym_on] = ACTIONS(4461),
    [anon_sym_equals] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_orderby] = ACTIONS(4461),
    [anon_sym_ascending] = ACTIONS(4461),
    [anon_sym_descending] = ACTIONS(4461),
    [anon_sym_group] = ACTIONS(4461),
    [anon_sym_by] = ACTIONS(4461),
    [anon_sym_select] = ACTIONS(4461),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4425] = {
    [sym_preproc_region] = STATE(4425),
    [sym_preproc_endregion] = STATE(4425),
    [sym_preproc_line] = STATE(4425),
    [sym_preproc_pragma] = STATE(4425),
    [sym_preproc_nullable] = STATE(4425),
    [sym_preproc_error] = STATE(4425),
    [sym_preproc_define] = STATE(4425),
    [sym_preproc_undef] = STATE(4425),
    [anon_sym_EQ] = ACTIONS(6325),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6327),
    [anon_sym_DASH_EQ] = ACTIONS(6327),
    [anon_sym_STAR_EQ] = ACTIONS(6327),
    [anon_sym_SLASH_EQ] = ACTIONS(6327),
    [anon_sym_PERCENT_EQ] = ACTIONS(6327),
    [anon_sym_AMP_EQ] = ACTIONS(6327),
    [anon_sym_CARET_EQ] = ACTIONS(6327),
    [anon_sym_PIPE_EQ] = ACTIONS(6327),
    [anon_sym_LT_LT_EQ] = ACTIONS(6327),
    [anon_sym_GT_GT_EQ] = ACTIONS(6327),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6327),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6327),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_equals] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4426] = {
    [sym_preproc_region] = STATE(4426),
    [sym_preproc_endregion] = STATE(4426),
    [sym_preproc_line] = STATE(4426),
    [sym_preproc_pragma] = STATE(4426),
    [sym_preproc_nullable] = STATE(4426),
    [sym_preproc_error] = STATE(4426),
    [sym_preproc_define] = STATE(4426),
    [sym_preproc_undef] = STATE(4426),
    [sym__identifier_token] = ACTIONS(5717),
    [anon_sym_extern] = ACTIONS(5717),
    [anon_sym_alias] = ACTIONS(5717),
    [anon_sym_global] = ACTIONS(5717),
    [anon_sym_unsafe] = ACTIONS(5717),
    [anon_sym_static] = ACTIONS(5717),
    [anon_sym_LBRACK] = ACTIONS(5719),
    [anon_sym_abstract] = ACTIONS(5717),
    [anon_sym_async] = ACTIONS(5717),
    [anon_sym_const] = ACTIONS(5717),
    [anon_sym_file] = ACTIONS(5717),
    [anon_sym_fixed] = ACTIONS(5717),
    [anon_sym_internal] = ACTIONS(5717),
    [anon_sym_new] = ACTIONS(5717),
    [anon_sym_override] = ACTIONS(5717),
    [anon_sym_partial] = ACTIONS(5717),
    [anon_sym_private] = ACTIONS(5717),
    [anon_sym_protected] = ACTIONS(5717),
    [anon_sym_public] = ACTIONS(5717),
    [anon_sym_readonly] = ACTIONS(5717),
    [anon_sym_required] = ACTIONS(5717),
    [anon_sym_sealed] = ACTIONS(5717),
    [anon_sym_virtual] = ACTIONS(5717),
    [anon_sym_volatile] = ACTIONS(5717),
    [anon_sym_where] = ACTIONS(5717),
    [anon_sym_notnull] = ACTIONS(5717),
    [anon_sym_unmanaged] = ACTIONS(5717),
    [anon_sym_get] = ACTIONS(5717),
    [anon_sym_set] = ACTIONS(5717),
    [anon_sym_add] = ACTIONS(5717),
    [anon_sym_remove] = ACTIONS(5717),
    [anon_sym_init] = ACTIONS(5717),
    [anon_sym_scoped] = ACTIONS(5717),
    [anon_sym_var] = ACTIONS(5717),
    [anon_sym_yield] = ACTIONS(5717),
    [anon_sym_when] = ACTIONS(5717),
    [anon_sym_from] = ACTIONS(5717),
    [anon_sym_into] = ACTIONS(5717),
    [anon_sym_join] = ACTIONS(5717),
    [anon_sym_on] = ACTIONS(5717),
    [anon_sym_equals] = ACTIONS(5717),
    [anon_sym_let] = ACTIONS(5717),
    [anon_sym_orderby] = ACTIONS(5717),
    [anon_sym_ascending] = ACTIONS(5717),
    [anon_sym_descending] = ACTIONS(5717),
    [anon_sym_group] = ACTIONS(5717),
    [anon_sym_by] = ACTIONS(5717),
    [anon_sym_select] = ACTIONS(5717),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4427] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4427),
    [sym_preproc_endregion] = STATE(4427),
    [sym_preproc_line] = STATE(4427),
    [sym_preproc_pragma] = STATE(4427),
    [sym_preproc_nullable] = STATE(4427),
    [sym_preproc_error] = STATE(4427),
    [sym_preproc_define] = STATE(4427),
    [sym_preproc_undef] = STATE(4427),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6329),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6331),
    [anon_sym_GT] = ACTIONS(6331),
    [anon_sym_where] = ACTIONS(6329),
    [anon_sym_QMARK] = ACTIONS(6331),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6331),
    [anon_sym_DASH] = ACTIONS(6331),
    [anon_sym_STAR] = ACTIONS(6329),
    [anon_sym_SLASH] = ACTIONS(6331),
    [anon_sym_PERCENT] = ACTIONS(6329),
    [anon_sym_CARET] = ACTIONS(6329),
    [anon_sym_PIPE] = ACTIONS(6331),
    [anon_sym_AMP] = ACTIONS(6331),
    [anon_sym_LT_LT] = ACTIONS(6329),
    [anon_sym_GT_GT] = ACTIONS(6331),
    [anon_sym_GT_GT_GT] = ACTIONS(6329),
    [anon_sym_EQ_EQ] = ACTIONS(6329),
    [anon_sym_BANG_EQ] = ACTIONS(6329),
    [anon_sym_GT_EQ] = ACTIONS(6329),
    [anon_sym_LT_EQ] = ACTIONS(6329),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6329),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6329),
    [anon_sym_or] = ACTIONS(6331),
    [anon_sym_AMP_AMP] = ACTIONS(6329),
    [anon_sym_PIPE_PIPE] = ACTIONS(6329),
    [anon_sym_QMARK_QMARK] = ACTIONS(6329),
    [anon_sym_from] = ACTIONS(6329),
    [anon_sym_into] = ACTIONS(6329),
    [anon_sym_join] = ACTIONS(6329),
    [anon_sym_let] = ACTIONS(6329),
    [anon_sym_orderby] = ACTIONS(6329),
    [anon_sym_ascending] = ACTIONS(6329),
    [anon_sym_descending] = ACTIONS(6329),
    [anon_sym_group] = ACTIONS(6329),
    [anon_sym_select] = ACTIONS(6329),
    [anon_sym_as] = ACTIONS(6331),
    [anon_sym_is] = ACTIONS(6329),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6329),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4428] = {
    [sym_argument_list] = STATE(3815),
    [sym__name] = STATE(3923),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_type] = STATE(3805),
    [sym_implicit_type] = STATE(3940),
    [sym_array_type] = STATE(3837),
    [sym__array_base_type] = STATE(8981),
    [sym_nullable_type] = STATE(3932),
    [sym_pointer_type] = STATE(3932),
    [sym__pointer_base_type] = STATE(9571),
    [sym_function_pointer_type] = STATE(3932),
    [sym_ref_type] = STATE(3940),
    [sym_scoped_type] = STATE(3940),
    [sym_tuple_type] = STATE(3931),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(4428),
    [sym_preproc_endregion] = STATE(4428),
    [sym_preproc_line] = STATE(4428),
    [sym_preproc_pragma] = STATE(4428),
    [sym_preproc_nullable] = STATE(4428),
    [sym_preproc_error] = STATE(4428),
    [sym_preproc_define] = STATE(4428),
    [sym_preproc_undef] = STATE(4428),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(6245),
    [anon_sym_ref] = ACTIONS(4687),
    [anon_sym_LBRACE] = ACTIONS(6247),
    [anon_sym_delegate] = ACTIONS(6249),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_scoped] = ACTIONS(6333),
    [anon_sym_var] = ACTIONS(6253),
    [sym_predefined_type] = ACTIONS(6255),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4223),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4429] = {
    [sym_block] = STATE(8807),
    [sym_preproc_region] = STATE(4429),
    [sym_preproc_endregion] = STATE(4429),
    [sym_preproc_line] = STATE(4429),
    [sym_preproc_pragma] = STATE(4429),
    [sym_preproc_nullable] = STATE(4429),
    [sym_preproc_error] = STATE(4429),
    [sym_preproc_define] = STATE(4429),
    [sym_preproc_undef] = STATE(4429),
    [sym__identifier_token] = ACTIONS(4040),
    [anon_sym_extern] = ACTIONS(4040),
    [anon_sym_alias] = ACTIONS(4040),
    [anon_sym_global] = ACTIONS(4040),
    [anon_sym_unsafe] = ACTIONS(4040),
    [anon_sym_static] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(5504),
    [anon_sym_ref] = ACTIONS(4040),
    [anon_sym_LBRACE] = ACTIONS(6050),
    [anon_sym_delegate] = ACTIONS(4040),
    [anon_sym_abstract] = ACTIONS(4040),
    [anon_sym_async] = ACTIONS(4040),
    [anon_sym_const] = ACTIONS(4040),
    [anon_sym_file] = ACTIONS(4040),
    [anon_sym_fixed] = ACTIONS(4040),
    [anon_sym_internal] = ACTIONS(4040),
    [anon_sym_new] = ACTIONS(4040),
    [anon_sym_override] = ACTIONS(4040),
    [anon_sym_partial] = ACTIONS(4040),
    [anon_sym_private] = ACTIONS(4040),
    [anon_sym_protected] = ACTIONS(4040),
    [anon_sym_public] = ACTIONS(4040),
    [anon_sym_readonly] = ACTIONS(4040),
    [anon_sym_required] = ACTIONS(4040),
    [anon_sym_sealed] = ACTIONS(4040),
    [anon_sym_virtual] = ACTIONS(4040),
    [anon_sym_volatile] = ACTIONS(4040),
    [anon_sym_where] = ACTIONS(4040),
    [anon_sym_notnull] = ACTIONS(4040),
    [anon_sym_unmanaged] = ACTIONS(4040),
    [anon_sym_scoped] = ACTIONS(4040),
    [anon_sym_var] = ACTIONS(4040),
    [sym_predefined_type] = ACTIONS(4040),
    [anon_sym_yield] = ACTIONS(4040),
    [anon_sym_when] = ACTIONS(4040),
    [anon_sym_from] = ACTIONS(4040),
    [anon_sym_into] = ACTIONS(4040),
    [anon_sym_join] = ACTIONS(4040),
    [anon_sym_on] = ACTIONS(4040),
    [anon_sym_equals] = ACTIONS(4040),
    [anon_sym_let] = ACTIONS(4040),
    [anon_sym_orderby] = ACTIONS(4040),
    [anon_sym_ascending] = ACTIONS(4040),
    [anon_sym_descending] = ACTIONS(4040),
    [anon_sym_group] = ACTIONS(4040),
    [anon_sym_by] = ACTIONS(4040),
    [anon_sym_select] = ACTIONS(4040),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4430] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4430),
    [sym_preproc_endregion] = STATE(4430),
    [sym_preproc_line] = STATE(4430),
    [sym_preproc_pragma] = STATE(4430),
    [sym_preproc_nullable] = STATE(4430),
    [sym_preproc_error] = STATE(4430),
    [sym_preproc_define] = STATE(4430),
    [sym_preproc_undef] = STATE(4430),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(5325),
    [anon_sym_GT] = ACTIONS(5325),
    [anon_sym_where] = ACTIONS(5323),
    [anon_sym_QMARK] = ACTIONS(5325),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(5325),
    [anon_sym_DASH] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5323),
    [anon_sym_SLASH] = ACTIONS(5325),
    [anon_sym_PERCENT] = ACTIONS(5323),
    [anon_sym_CARET] = ACTIONS(5323),
    [anon_sym_PIPE] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5325),
    [anon_sym_LT_LT] = ACTIONS(5323),
    [anon_sym_GT_GT] = ACTIONS(5325),
    [anon_sym_GT_GT_GT] = ACTIONS(5323),
    [anon_sym_EQ_EQ] = ACTIONS(5323),
    [anon_sym_BANG_EQ] = ACTIONS(5323),
    [anon_sym_GT_EQ] = ACTIONS(5323),
    [anon_sym_LT_EQ] = ACTIONS(5323),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(5323),
    [anon_sym_DOT_DOT] = ACTIONS(5323),
    [anon_sym_and] = ACTIONS(5323),
    [anon_sym_or] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5323),
    [anon_sym_PIPE_PIPE] = ACTIONS(5323),
    [anon_sym_QMARK_QMARK] = ACTIONS(5323),
    [anon_sym_from] = ACTIONS(5323),
    [anon_sym_into] = ACTIONS(5323),
    [anon_sym_join] = ACTIONS(5323),
    [anon_sym_let] = ACTIONS(5323),
    [anon_sym_orderby] = ACTIONS(5323),
    [anon_sym_ascending] = ACTIONS(5323),
    [anon_sym_descending] = ACTIONS(5323),
    [anon_sym_group] = ACTIONS(5323),
    [anon_sym_select] = ACTIONS(5323),
    [anon_sym_as] = ACTIONS(5325),
    [anon_sym_is] = ACTIONS(5323),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(5323),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4431] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8383),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4431),
    [sym_preproc_endregion] = STATE(4431),
    [sym_preproc_line] = STATE(4431),
    [sym_preproc_pragma] = STATE(4431),
    [sym_preproc_nullable] = STATE(4431),
    [sym_preproc_error] = STATE(4431),
    [sym_preproc_define] = STATE(4431),
    [sym_preproc_undef] = STATE(4431),
    [aux_sym_type_argument_list_repeat1] = STATE(8387),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6335),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4432] = {
    [sym_argument_list] = STATE(3880),
    [sym__name] = STATE(4175),
    [sym_alias_qualified_name] = STATE(4022),
    [sym__simple_name] = STATE(4022),
    [sym_qualified_name] = STATE(4022),
    [sym_generic_name] = STATE(4064),
    [sym_type] = STATE(3849),
    [sym_implicit_type] = STATE(4015),
    [sym_array_type] = STATE(4056),
    [sym__array_base_type] = STATE(8906),
    [sym_nullable_type] = STATE(4013),
    [sym_pointer_type] = STATE(4013),
    [sym__pointer_base_type] = STATE(9081),
    [sym_function_pointer_type] = STATE(4013),
    [sym_ref_type] = STATE(4015),
    [sym_scoped_type] = STATE(4015),
    [sym_tuple_type] = STATE(4012),
    [sym_identifier] = STATE(3933),
    [sym__reserved_identifier] = STATE(3887),
    [sym_preproc_region] = STATE(4432),
    [sym_preproc_endregion] = STATE(4432),
    [sym_preproc_line] = STATE(4432),
    [sym_preproc_pragma] = STATE(4432),
    [sym_preproc_nullable] = STATE(4432),
    [sym_preproc_error] = STATE(4432),
    [sym_preproc_define] = STATE(4432),
    [sym_preproc_undef] = STATE(4432),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4258),
    [anon_sym_global] = ACTIONS(4258),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6202),
    [anon_sym_ref] = ACTIONS(4658),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_delegate] = ACTIONS(6206),
    [anon_sym_file] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4258),
    [anon_sym_notnull] = ACTIONS(4258),
    [anon_sym_unmanaged] = ACTIONS(4258),
    [anon_sym_scoped] = ACTIONS(6337),
    [anon_sym_var] = ACTIONS(6210),
    [sym_predefined_type] = ACTIONS(6212),
    [anon_sym_yield] = ACTIONS(4258),
    [anon_sym_when] = ACTIONS(4258),
    [anon_sym_from] = ACTIONS(4258),
    [anon_sym_into] = ACTIONS(4258),
    [anon_sym_join] = ACTIONS(4258),
    [anon_sym_on] = ACTIONS(4258),
    [anon_sym_equals] = ACTIONS(4258),
    [anon_sym_let] = ACTIONS(4258),
    [anon_sym_orderby] = ACTIONS(4258),
    [anon_sym_ascending] = ACTIONS(4258),
    [anon_sym_descending] = ACTIONS(4258),
    [anon_sym_group] = ACTIONS(4258),
    [anon_sym_by] = ACTIONS(4258),
    [anon_sym_select] = ACTIONS(4258),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4433] = {
    [sym_preproc_region] = STATE(4433),
    [sym_preproc_endregion] = STATE(4433),
    [sym_preproc_line] = STATE(4433),
    [sym_preproc_pragma] = STATE(4433),
    [sym_preproc_nullable] = STATE(4433),
    [sym_preproc_error] = STATE(4433),
    [sym_preproc_define] = STATE(4433),
    [sym_preproc_undef] = STATE(4433),
    [sym__identifier_token] = ACTIONS(5701),
    [anon_sym_extern] = ACTIONS(5701),
    [anon_sym_alias] = ACTIONS(5701),
    [anon_sym_global] = ACTIONS(5701),
    [anon_sym_unsafe] = ACTIONS(5701),
    [anon_sym_static] = ACTIONS(5701),
    [anon_sym_LBRACK] = ACTIONS(5703),
    [anon_sym_abstract] = ACTIONS(5701),
    [anon_sym_async] = ACTIONS(5701),
    [anon_sym_const] = ACTIONS(5701),
    [anon_sym_file] = ACTIONS(5701),
    [anon_sym_fixed] = ACTIONS(5701),
    [anon_sym_internal] = ACTIONS(5701),
    [anon_sym_new] = ACTIONS(5701),
    [anon_sym_override] = ACTIONS(5701),
    [anon_sym_partial] = ACTIONS(5701),
    [anon_sym_private] = ACTIONS(5701),
    [anon_sym_protected] = ACTIONS(5701),
    [anon_sym_public] = ACTIONS(5701),
    [anon_sym_readonly] = ACTIONS(5701),
    [anon_sym_required] = ACTIONS(5701),
    [anon_sym_sealed] = ACTIONS(5701),
    [anon_sym_virtual] = ACTIONS(5701),
    [anon_sym_volatile] = ACTIONS(5701),
    [anon_sym_where] = ACTIONS(5701),
    [anon_sym_notnull] = ACTIONS(5701),
    [anon_sym_unmanaged] = ACTIONS(5701),
    [anon_sym_get] = ACTIONS(5701),
    [anon_sym_set] = ACTIONS(5701),
    [anon_sym_add] = ACTIONS(5701),
    [anon_sym_remove] = ACTIONS(5701),
    [anon_sym_init] = ACTIONS(5701),
    [anon_sym_scoped] = ACTIONS(5701),
    [anon_sym_var] = ACTIONS(5701),
    [anon_sym_yield] = ACTIONS(5701),
    [anon_sym_when] = ACTIONS(5701),
    [anon_sym_from] = ACTIONS(5701),
    [anon_sym_into] = ACTIONS(5701),
    [anon_sym_join] = ACTIONS(5701),
    [anon_sym_on] = ACTIONS(5701),
    [anon_sym_equals] = ACTIONS(5701),
    [anon_sym_let] = ACTIONS(5701),
    [anon_sym_orderby] = ACTIONS(5701),
    [anon_sym_ascending] = ACTIONS(5701),
    [anon_sym_descending] = ACTIONS(5701),
    [anon_sym_group] = ACTIONS(5701),
    [anon_sym_by] = ACTIONS(5701),
    [anon_sym_select] = ACTIONS(5701),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4434] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4434),
    [sym_preproc_endregion] = STATE(4434),
    [sym_preproc_line] = STATE(4434),
    [sym_preproc_pragma] = STATE(4434),
    [sym_preproc_nullable] = STATE(4434),
    [sym_preproc_error] = STATE(4434),
    [sym_preproc_define] = STATE(4434),
    [sym_preproc_undef] = STATE(4434),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6180),
    [anon_sym_QMARK] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_AMP] = ACTIONS(6182),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6180),
    [anon_sym_or] = ACTIONS(6182),
    [anon_sym_AMP_AMP] = ACTIONS(6180),
    [anon_sym_PIPE_PIPE] = ACTIONS(6180),
    [anon_sym_QMARK_QMARK] = ACTIONS(6180),
    [anon_sym_from] = ACTIONS(6180),
    [anon_sym_into] = ACTIONS(6180),
    [anon_sym_join] = ACTIONS(6180),
    [anon_sym_let] = ACTIONS(6180),
    [anon_sym_orderby] = ACTIONS(6180),
    [anon_sym_ascending] = ACTIONS(6180),
    [anon_sym_descending] = ACTIONS(6180),
    [anon_sym_group] = ACTIONS(6180),
    [anon_sym_select] = ACTIONS(6180),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4435] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8467),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4435),
    [sym_preproc_endregion] = STATE(4435),
    [sym_preproc_line] = STATE(4435),
    [sym_preproc_pragma] = STATE(4435),
    [sym_preproc_nullable] = STATE(4435),
    [sym_preproc_error] = STATE(4435),
    [sym_preproc_define] = STATE(4435),
    [sym_preproc_undef] = STATE(4435),
    [aux_sym_type_argument_list_repeat1] = STATE(8403),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6339),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4436] = {
    [sym_preproc_region] = STATE(4436),
    [sym_preproc_endregion] = STATE(4436),
    [sym_preproc_line] = STATE(4436),
    [sym_preproc_pragma] = STATE(4436),
    [sym_preproc_nullable] = STATE(4436),
    [sym_preproc_error] = STATE(4436),
    [sym_preproc_define] = STATE(4436),
    [sym_preproc_undef] = STATE(4436),
    [sym__identifier_token] = ACTIONS(5705),
    [anon_sym_extern] = ACTIONS(5705),
    [anon_sym_alias] = ACTIONS(5705),
    [anon_sym_global] = ACTIONS(5705),
    [anon_sym_unsafe] = ACTIONS(5705),
    [anon_sym_static] = ACTIONS(5705),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_abstract] = ACTIONS(5705),
    [anon_sym_async] = ACTIONS(5705),
    [anon_sym_const] = ACTIONS(5705),
    [anon_sym_file] = ACTIONS(5705),
    [anon_sym_fixed] = ACTIONS(5705),
    [anon_sym_internal] = ACTIONS(5705),
    [anon_sym_new] = ACTIONS(5705),
    [anon_sym_override] = ACTIONS(5705),
    [anon_sym_partial] = ACTIONS(5705),
    [anon_sym_private] = ACTIONS(5705),
    [anon_sym_protected] = ACTIONS(5705),
    [anon_sym_public] = ACTIONS(5705),
    [anon_sym_readonly] = ACTIONS(5705),
    [anon_sym_required] = ACTIONS(5705),
    [anon_sym_sealed] = ACTIONS(5705),
    [anon_sym_virtual] = ACTIONS(5705),
    [anon_sym_volatile] = ACTIONS(5705),
    [anon_sym_where] = ACTIONS(5705),
    [anon_sym_notnull] = ACTIONS(5705),
    [anon_sym_unmanaged] = ACTIONS(5705),
    [anon_sym_get] = ACTIONS(5705),
    [anon_sym_set] = ACTIONS(5705),
    [anon_sym_add] = ACTIONS(5705),
    [anon_sym_remove] = ACTIONS(5705),
    [anon_sym_init] = ACTIONS(5705),
    [anon_sym_scoped] = ACTIONS(5705),
    [anon_sym_var] = ACTIONS(5705),
    [anon_sym_yield] = ACTIONS(5705),
    [anon_sym_when] = ACTIONS(5705),
    [anon_sym_from] = ACTIONS(5705),
    [anon_sym_into] = ACTIONS(5705),
    [anon_sym_join] = ACTIONS(5705),
    [anon_sym_on] = ACTIONS(5705),
    [anon_sym_equals] = ACTIONS(5705),
    [anon_sym_let] = ACTIONS(5705),
    [anon_sym_orderby] = ACTIONS(5705),
    [anon_sym_ascending] = ACTIONS(5705),
    [anon_sym_descending] = ACTIONS(5705),
    [anon_sym_group] = ACTIONS(5705),
    [anon_sym_by] = ACTIONS(5705),
    [anon_sym_select] = ACTIONS(5705),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4437] = {
    [sym_argument_list] = STATE(3577),
    [sym__name] = STATE(4334),
    [sym_alias_qualified_name] = STATE(3629),
    [sym__simple_name] = STATE(3629),
    [sym_qualified_name] = STATE(3629),
    [sym_generic_name] = STATE(3588),
    [sym_type] = STATE(3561),
    [sym_implicit_type] = STATE(3622),
    [sym_array_type] = STATE(4166),
    [sym__array_base_type] = STATE(8987),
    [sym_nullable_type] = STATE(3625),
    [sym_pointer_type] = STATE(3625),
    [sym__pointer_base_type] = STATE(9581),
    [sym_function_pointer_type] = STATE(3625),
    [sym_ref_type] = STATE(3622),
    [sym_scoped_type] = STATE(3622),
    [sym_tuple_type] = STATE(3626),
    [sym_identifier] = STATE(3960),
    [sym__reserved_identifier] = STATE(3562),
    [sym_preproc_region] = STATE(4437),
    [sym_preproc_endregion] = STATE(4437),
    [sym_preproc_line] = STATE(4437),
    [sym_preproc_pragma] = STATE(4437),
    [sym_preproc_nullable] = STATE(4437),
    [sym_preproc_error] = STATE(4437),
    [sym_preproc_define] = STATE(4437),
    [sym_preproc_undef] = STATE(4437),
    [sym__identifier_token] = ACTIONS(4286),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6186),
    [anon_sym_ref] = ACTIONS(4729),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_delegate] = ACTIONS(6190),
    [anon_sym_file] = ACTIONS(4288),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_scoped] = ACTIONS(6341),
    [anon_sym_var] = ACTIONS(6194),
    [sym_predefined_type] = ACTIONS(6196),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4438] = {
    [sym_initializer_expression] = STATE(4651),
    [sym_preproc_region] = STATE(4438),
    [sym_preproc_endregion] = STATE(4438),
    [sym_preproc_line] = STATE(4438),
    [sym_preproc_pragma] = STATE(4438),
    [sym_preproc_nullable] = STATE(4438),
    [sym_preproc_error] = STATE(4438),
    [sym_preproc_define] = STATE(4438),
    [sym_preproc_undef] = STATE(4438),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_COMMA] = ACTIONS(5315),
    [anon_sym_LPAREN] = ACTIONS(5315),
    [anon_sym_LBRACE] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(5317),
    [anon_sym_GT] = ACTIONS(5317),
    [anon_sym_where] = ACTIONS(5315),
    [anon_sym_QMARK] = ACTIONS(5317),
    [anon_sym_BANG] = ACTIONS(5317),
    [anon_sym_PLUS_PLUS] = ACTIONS(5315),
    [anon_sym_DASH_DASH] = ACTIONS(5315),
    [anon_sym_PLUS] = ACTIONS(5317),
    [anon_sym_DASH] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5315),
    [anon_sym_SLASH] = ACTIONS(5317),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_CARET] = ACTIONS(5315),
    [anon_sym_PIPE] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5317),
    [anon_sym_LT_LT] = ACTIONS(5315),
    [anon_sym_GT_GT] = ACTIONS(5317),
    [anon_sym_GT_GT_GT] = ACTIONS(5315),
    [anon_sym_EQ_EQ] = ACTIONS(5315),
    [anon_sym_BANG_EQ] = ACTIONS(5315),
    [anon_sym_GT_EQ] = ACTIONS(5315),
    [anon_sym_LT_EQ] = ACTIONS(5315),
    [anon_sym_DOT] = ACTIONS(5317),
    [anon_sym_switch] = ACTIONS(5315),
    [anon_sym_DOT_DOT] = ACTIONS(5315),
    [anon_sym_and] = ACTIONS(5315),
    [anon_sym_or] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5315),
    [anon_sym_PIPE_PIPE] = ACTIONS(5315),
    [anon_sym_QMARK_QMARK] = ACTIONS(5315),
    [anon_sym_from] = ACTIONS(5315),
    [anon_sym_into] = ACTIONS(5315),
    [anon_sym_join] = ACTIONS(5315),
    [anon_sym_let] = ACTIONS(5315),
    [anon_sym_orderby] = ACTIONS(5315),
    [anon_sym_ascending] = ACTIONS(5315),
    [anon_sym_descending] = ACTIONS(5315),
    [anon_sym_group] = ACTIONS(5315),
    [anon_sym_select] = ACTIONS(5315),
    [anon_sym_as] = ACTIONS(5317),
    [anon_sym_is] = ACTIONS(5315),
    [anon_sym_DASH_GT] = ACTIONS(5315),
    [anon_sym_with] = ACTIONS(5315),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4439] = {
    [sym_argument_list] = STATE(3815),
    [sym__name] = STATE(3923),
    [sym_alias_qualified_name] = STATE(3947),
    [sym__simple_name] = STATE(3947),
    [sym_qualified_name] = STATE(3947),
    [sym_generic_name] = STATE(3892),
    [sym_type] = STATE(3805),
    [sym_implicit_type] = STATE(3940),
    [sym_array_type] = STATE(3837),
    [sym__array_base_type] = STATE(8981),
    [sym_nullable_type] = STATE(3932),
    [sym_pointer_type] = STATE(3932),
    [sym__pointer_base_type] = STATE(9571),
    [sym_function_pointer_type] = STATE(3932),
    [sym_ref_type] = STATE(3940),
    [sym_scoped_type] = STATE(3940),
    [sym_tuple_type] = STATE(3931),
    [sym_identifier] = STATE(3804),
    [sym__reserved_identifier] = STATE(3831),
    [sym_preproc_region] = STATE(4439),
    [sym_preproc_endregion] = STATE(4439),
    [sym_preproc_line] = STATE(4439),
    [sym_preproc_pragma] = STATE(4439),
    [sym_preproc_nullable] = STATE(4439),
    [sym_preproc_error] = STATE(4439),
    [sym_preproc_define] = STATE(4439),
    [sym_preproc_undef] = STATE(4439),
    [sym__identifier_token] = ACTIONS(4221),
    [anon_sym_alias] = ACTIONS(4223),
    [anon_sym_global] = ACTIONS(4223),
    [anon_sym_LBRACK] = ACTIONS(6243),
    [anon_sym_LPAREN] = ACTIONS(6245),
    [anon_sym_ref] = ACTIONS(4679),
    [anon_sym_LBRACE] = ACTIONS(6247),
    [anon_sym_delegate] = ACTIONS(6249),
    [anon_sym_file] = ACTIONS(4223),
    [anon_sym_where] = ACTIONS(4223),
    [anon_sym_notnull] = ACTIONS(4223),
    [anon_sym_unmanaged] = ACTIONS(4223),
    [anon_sym_scoped] = ACTIONS(6343),
    [anon_sym_var] = ACTIONS(6253),
    [sym_predefined_type] = ACTIONS(6255),
    [anon_sym_yield] = ACTIONS(4223),
    [anon_sym_when] = ACTIONS(4223),
    [anon_sym_from] = ACTIONS(4223),
    [anon_sym_into] = ACTIONS(4223),
    [anon_sym_join] = ACTIONS(4223),
    [anon_sym_on] = ACTIONS(4223),
    [anon_sym_equals] = ACTIONS(4223),
    [anon_sym_let] = ACTIONS(4223),
    [anon_sym_orderby] = ACTIONS(4223),
    [anon_sym_ascending] = ACTIONS(4223),
    [anon_sym_descending] = ACTIONS(4223),
    [anon_sym_group] = ACTIONS(4223),
    [anon_sym_by] = ACTIONS(4223),
    [anon_sym_select] = ACTIONS(4223),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4440] = {
    [sym_preproc_region] = STATE(4440),
    [sym_preproc_endregion] = STATE(4440),
    [sym_preproc_line] = STATE(4440),
    [sym_preproc_pragma] = STATE(4440),
    [sym_preproc_nullable] = STATE(4440),
    [sym_preproc_error] = STATE(4440),
    [sym_preproc_define] = STATE(4440),
    [sym_preproc_undef] = STATE(4440),
    [anon_sym_EQ] = ACTIONS(6345),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6347),
    [anon_sym_DASH_EQ] = ACTIONS(6347),
    [anon_sym_STAR_EQ] = ACTIONS(6347),
    [anon_sym_SLASH_EQ] = ACTIONS(6347),
    [anon_sym_PERCENT_EQ] = ACTIONS(6347),
    [anon_sym_AMP_EQ] = ACTIONS(6347),
    [anon_sym_CARET_EQ] = ACTIONS(6347),
    [anon_sym_PIPE_EQ] = ACTIONS(6347),
    [anon_sym_LT_LT_EQ] = ACTIONS(6347),
    [anon_sym_GT_GT_EQ] = ACTIONS(6347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6347),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6347),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_into] = ACTIONS(5294),
    [anon_sym_on] = ACTIONS(5294),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4441] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4441),
    [sym_preproc_endregion] = STATE(4441),
    [sym_preproc_line] = STATE(4441),
    [sym_preproc_pragma] = STATE(4441),
    [sym_preproc_nullable] = STATE(4441),
    [sym_preproc_error] = STATE(4441),
    [sym_preproc_define] = STATE(4441),
    [sym_preproc_undef] = STATE(4441),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_where] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(1225),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK_QMARK] = ACTIONS(1225),
    [anon_sym_from] = ACTIONS(1225),
    [anon_sym_into] = ACTIONS(1225),
    [anon_sym_join] = ACTIONS(1225),
    [anon_sym_let] = ACTIONS(1225),
    [anon_sym_orderby] = ACTIONS(1225),
    [anon_sym_ascending] = ACTIONS(1225),
    [anon_sym_descending] = ACTIONS(1225),
    [anon_sym_group] = ACTIONS(1225),
    [anon_sym_select] = ACTIONS(1225),
    [anon_sym_as] = ACTIONS(1227),
    [anon_sym_is] = ACTIONS(1225),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(1225),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4442] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8620),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4442),
    [sym_preproc_endregion] = STATE(4442),
    [sym_preproc_line] = STATE(4442),
    [sym_preproc_pragma] = STATE(4442),
    [sym_preproc_nullable] = STATE(4442),
    [sym_preproc_error] = STATE(4442),
    [sym_preproc_define] = STATE(4442),
    [sym_preproc_undef] = STATE(4442),
    [aux_sym_type_argument_list_repeat1] = STATE(8629),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6349),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4443] = {
    [sym_argument_list] = STATE(4409),
    [sym__name] = STATE(3012),
    [sym_alias_qualified_name] = STATE(2948),
    [sym__simple_name] = STATE(2948),
    [sym_qualified_name] = STATE(2948),
    [sym_generic_name] = STATE(2961),
    [sym_type] = STATE(4340),
    [sym_implicit_type] = STATE(2883),
    [sym_array_type] = STATE(4387),
    [sym__array_base_type] = STATE(8934),
    [sym_nullable_type] = STATE(2945),
    [sym_pointer_type] = STATE(2945),
    [sym__pointer_base_type] = STATE(9906),
    [sym_function_pointer_type] = STATE(2945),
    [sym_ref_type] = STATE(2883),
    [sym_scoped_type] = STATE(2883),
    [sym_tuple_type] = STATE(2944),
    [sym_identifier] = STATE(2938),
    [sym__reserved_identifier] = STATE(2925),
    [sym_preproc_region] = STATE(4443),
    [sym_preproc_endregion] = STATE(4443),
    [sym_preproc_line] = STATE(4443),
    [sym_preproc_pragma] = STATE(4443),
    [sym_preproc_nullable] = STATE(4443),
    [sym_preproc_error] = STATE(4443),
    [sym_preproc_define] = STATE(4443),
    [sym_preproc_undef] = STATE(4443),
    [sym__identifier_token] = ACTIONS(4612),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_LPAREN] = ACTIONS(6293),
    [anon_sym_ref] = ACTIONS(4616),
    [anon_sym_LBRACE] = ACTIONS(6295),
    [anon_sym_delegate] = ACTIONS(4000),
    [anon_sym_file] = ACTIONS(4614),
    [anon_sym_where] = ACTIONS(4614),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_scoped] = ACTIONS(6351),
    [anon_sym_var] = ACTIONS(6299),
    [sym_predefined_type] = ACTIONS(6301),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_when] = ACTIONS(4614),
    [anon_sym_from] = ACTIONS(4614),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4614),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4614),
    [anon_sym_orderby] = ACTIONS(4614),
    [anon_sym_ascending] = ACTIONS(4614),
    [anon_sym_descending] = ACTIONS(4614),
    [anon_sym_group] = ACTIONS(4614),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4614),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4444] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8497),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4444),
    [sym_preproc_endregion] = STATE(4444),
    [sym_preproc_line] = STATE(4444),
    [sym_preproc_pragma] = STATE(4444),
    [sym_preproc_nullable] = STATE(4444),
    [sym_preproc_error] = STATE(4444),
    [sym_preproc_define] = STATE(4444),
    [sym_preproc_undef] = STATE(4444),
    [aux_sym_type_argument_list_repeat1] = STATE(8499),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6353),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4445] = {
    [sym_preproc_region] = STATE(4445),
    [sym_preproc_endregion] = STATE(4445),
    [sym_preproc_line] = STATE(4445),
    [sym_preproc_pragma] = STATE(4445),
    [sym_preproc_nullable] = STATE(4445),
    [sym_preproc_error] = STATE(4445),
    [sym_preproc_define] = STATE(4445),
    [sym_preproc_undef] = STATE(4445),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6355),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4446] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4446),
    [sym_preproc_endregion] = STATE(4446),
    [sym_preproc_line] = STATE(4446),
    [sym_preproc_pragma] = STATE(4446),
    [sym_preproc_nullable] = STATE(4446),
    [sym_preproc_error] = STATE(4446),
    [sym_preproc_define] = STATE(4446),
    [sym_preproc_undef] = STATE(4446),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(6357),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4447] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8492),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4447),
    [sym_preproc_endregion] = STATE(4447),
    [sym_preproc_line] = STATE(4447),
    [sym_preproc_pragma] = STATE(4447),
    [sym_preproc_nullable] = STATE(4447),
    [sym_preproc_error] = STATE(4447),
    [sym_preproc_define] = STATE(4447),
    [sym_preproc_undef] = STATE(4447),
    [aux_sym_type_argument_list_repeat1] = STATE(8476),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6359),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4448] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4830),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4448),
    [sym_preproc_endregion] = STATE(4448),
    [sym_preproc_line] = STATE(4448),
    [sym_preproc_pragma] = STATE(4448),
    [sym_preproc_nullable] = STATE(4448),
    [sym_preproc_error] = STATE(4448),
    [sym_preproc_define] = STATE(4448),
    [sym_preproc_undef] = STATE(4448),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(6361),
    [anon_sym_ref] = ACTIONS(4674),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(6363),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4449] = {
    [sym__name] = STATE(7800),
    [sym_alias_qualified_name] = STATE(5035),
    [sym__simple_name] = STATE(5035),
    [sym_qualified_name] = STATE(5035),
    [sym_generic_name] = STATE(4988),
    [sym_type] = STATE(8428),
    [sym_implicit_type] = STATE(8763),
    [sym_array_type] = STATE(8334),
    [sym__array_base_type] = STATE(8909),
    [sym_nullable_type] = STATE(5342),
    [sym_pointer_type] = STATE(5342),
    [sym__pointer_base_type] = STATE(9524),
    [sym_function_pointer_type] = STATE(5342),
    [sym_ref_type] = STATE(8763),
    [sym_scoped_type] = STATE(8763),
    [sym_tuple_type] = STATE(7991),
    [sym_identifier] = STATE(4949),
    [sym__reserved_identifier] = STATE(4535),
    [sym_preproc_region] = STATE(4449),
    [sym_preproc_endregion] = STATE(4449),
    [sym_preproc_line] = STATE(4449),
    [sym_preproc_pragma] = STATE(4449),
    [sym_preproc_nullable] = STATE(4449),
    [sym_preproc_error] = STATE(4449),
    [sym_preproc_define] = STATE(4449),
    [sym_preproc_undef] = STATE(4449),
    [aux_sym_type_argument_list_repeat1] = STATE(8405),
    [sym__identifier_token] = ACTIONS(3115),
    [anon_sym_alias] = ACTIONS(3119),
    [anon_sym_global] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_ref] = ACTIONS(5731),
    [anon_sym_delegate] = ACTIONS(5733),
    [anon_sym_file] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(6365),
    [anon_sym_where] = ACTIONS(3119),
    [anon_sym_notnull] = ACTIONS(3119),
    [anon_sym_unmanaged] = ACTIONS(3119),
    [anon_sym_scoped] = ACTIONS(5739),
    [anon_sym_var] = ACTIONS(5344),
    [sym_predefined_type] = ACTIONS(5741),
    [anon_sym_yield] = ACTIONS(3119),
    [anon_sym_when] = ACTIONS(3119),
    [anon_sym_from] = ACTIONS(3119),
    [anon_sym_into] = ACTIONS(3119),
    [anon_sym_join] = ACTIONS(3119),
    [anon_sym_on] = ACTIONS(3119),
    [anon_sym_equals] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_orderby] = ACTIONS(3119),
    [anon_sym_ascending] = ACTIONS(3119),
    [anon_sym_descending] = ACTIONS(3119),
    [anon_sym_group] = ACTIONS(3119),
    [anon_sym_by] = ACTIONS(3119),
    [anon_sym_select] = ACTIONS(3119),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4450] = {
    [sym_argument_list] = STATE(3589),
    [sym__name] = STATE(3767),
    [sym_alias_qualified_name] = STATE(3670),
    [sym__simple_name] = STATE(3670),
    [sym_qualified_name] = STATE(3670),
    [sym_generic_name] = STATE(3676),
    [sym_type] = STATE(4298),
    [sym_implicit_type] = STATE(3655),
    [sym_array_type] = STATE(3586),
    [sym__array_base_type] = STATE(8881),
    [sym_nullable_type] = STATE(3647),
    [sym_pointer_type] = STATE(3647),
    [sym__pointer_base_type] = STATE(9106),
    [sym_function_pointer_type] = STATE(3647),
    [sym_ref_type] = STATE(3655),
    [sym_scoped_type] = STATE(3655),
    [sym_tuple_type] = STATE(3648),
    [sym_identifier] = STATE(3603),
    [sym__reserved_identifier] = STATE(3590),
    [sym_preproc_region] = STATE(4450),
    [sym_preproc_endregion] = STATE(4450),
    [sym_preproc_line] = STATE(4450),
    [sym_preproc_pragma] = STATE(4450),
    [sym_preproc_nullable] = STATE(4450),
    [sym_preproc_error] = STATE(4450),
    [sym_preproc_define] = STATE(4450),
    [sym_preproc_undef] = STATE(4450),
    [sym__identifier_token] = ACTIONS(4351),
    [anon_sym_alias] = ACTIONS(4353),
    [anon_sym_global] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_ref] = ACTIONS(4725),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4522),
    [anon_sym_file] = ACTIONS(4353),
    [anon_sym_where] = ACTIONS(4353),
    [anon_sym_notnull] = ACTIONS(4353),
    [anon_sym_unmanaged] = ACTIONS(4353),
    [anon_sym_scoped] = ACTIONS(6367),
    [anon_sym_var] = ACTIONS(4526),
    [sym_predefined_type] = ACTIONS(4528),
    [anon_sym_yield] = ACTIONS(4353),
    [anon_sym_when] = ACTIONS(4353),
    [anon_sym_from] = ACTIONS(4353),
    [anon_sym_into] = ACTIONS(4353),
    [anon_sym_join] = ACTIONS(4353),
    [anon_sym_on] = ACTIONS(4353),
    [anon_sym_equals] = ACTIONS(4353),
    [anon_sym_let] = ACTIONS(4353),
    [anon_sym_orderby] = ACTIONS(4353),
    [anon_sym_ascending] = ACTIONS(4353),
    [anon_sym_descending] = ACTIONS(4353),
    [anon_sym_group] = ACTIONS(4353),
    [anon_sym_by] = ACTIONS(4353),
    [anon_sym_select] = ACTIONS(4353),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4451] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4451),
    [sym_preproc_endregion] = STATE(4451),
    [sym_preproc_line] = STATE(4451),
    [sym_preproc_pragma] = STATE(4451),
    [sym_preproc_nullable] = STATE(4451),
    [sym_preproc_error] = STATE(4451),
    [sym_preproc_define] = STATE(4451),
    [sym_preproc_undef] = STATE(4451),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(5423),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(5423),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(5423),
    [anon_sym_or] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(5423),
    [anon_sym_into] = ACTIONS(5423),
    [anon_sym_join] = ACTIONS(5423),
    [anon_sym_let] = ACTIONS(5423),
    [anon_sym_orderby] = ACTIONS(5423),
    [anon_sym_ascending] = ACTIONS(5423),
    [anon_sym_descending] = ACTIONS(5423),
    [anon_sym_group] = ACTIONS(5423),
    [anon_sym_select] = ACTIONS(5423),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4452] = {
    [sym_argument_list] = STATE(4678),
    [sym_bracketed_argument_list] = STATE(3579),
    [sym_preproc_region] = STATE(4452),
    [sym_preproc_endregion] = STATE(4452),
    [sym_preproc_line] = STATE(4452),
    [sym_preproc_pragma] = STATE(4452),
    [sym_preproc_nullable] = STATE(4452),
    [sym_preproc_error] = STATE(4452),
    [sym_preproc_define] = STATE(4452),
    [sym_preproc_undef] = STATE(4452),
    [anon_sym_LBRACK] = ACTIONS(6128),
    [anon_sym_COMMA] = ACTIONS(6369),
    [anon_sym_LPAREN] = ACTIONS(6078),
    [anon_sym_LT] = ACTIONS(6132),
    [anon_sym_GT] = ACTIONS(6132),
    [anon_sym_where] = ACTIONS(6369),
    [anon_sym_QMARK] = ACTIONS(6134),
    [anon_sym_BANG] = ACTIONS(6136),
    [anon_sym_PLUS_PLUS] = ACTIONS(6138),
    [anon_sym_DASH_DASH] = ACTIONS(6138),
    [anon_sym_PLUS] = ACTIONS(6140),
    [anon_sym_DASH] = ACTIONS(6140),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6144),
    [anon_sym_PERCENT] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_AMP] = ACTIONS(6150),
    [anon_sym_LT_LT] = ACTIONS(6152),
    [anon_sym_GT_GT] = ACTIONS(6154),
    [anon_sym_GT_GT_GT] = ACTIONS(6152),
    [anon_sym_EQ_EQ] = ACTIONS(6156),
    [anon_sym_BANG_EQ] = ACTIONS(6156),
    [anon_sym_GT_EQ] = ACTIONS(6158),
    [anon_sym_LT_EQ] = ACTIONS(6158),
    [anon_sym_DOT] = ACTIONS(5227),
    [anon_sym_switch] = ACTIONS(6160),
    [anon_sym_DOT_DOT] = ACTIONS(6162),
    [anon_sym_and] = ACTIONS(6369),
    [anon_sym_or] = ACTIONS(6371),
    [anon_sym_AMP_AMP] = ACTIONS(6166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6168),
    [anon_sym_QMARK_QMARK] = ACTIONS(6170),
    [anon_sym_from] = ACTIONS(6369),
    [anon_sym_into] = ACTIONS(6369),
    [anon_sym_join] = ACTIONS(6369),
    [anon_sym_let] = ACTIONS(6369),
    [anon_sym_orderby] = ACTIONS(6369),
    [anon_sym_ascending] = ACTIONS(6369),
    [anon_sym_descending] = ACTIONS(6369),
    [anon_sym_group] = ACTIONS(6369),
    [anon_sym_select] = ACTIONS(6369),
    [anon_sym_as] = ACTIONS(6172),
    [anon_sym_is] = ACTIONS(6174),
    [anon_sym_DASH_GT] = ACTIONS(5229),
    [anon_sym_with] = ACTIONS(6176),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4453] = {
    [sym_modifier] = STATE(4685),
    [sym_preproc_region] = STATE(4453),
    [sym_preproc_endregion] = STATE(4453),
    [sym_preproc_line] = STATE(4453),
    [sym_preproc_pragma] = STATE(4453),
    [sym_preproc_nullable] = STATE(4453),
    [sym_preproc_error] = STATE(4453),
    [sym_preproc_define] = STATE(4453),
    [sym_preproc_undef] = STATE(4453),
    [aux_sym_class_declaration_repeat2] = STATE(4453),
    [sym__identifier_token] = ACTIONS(5686),
    [anon_sym_extern] = ACTIONS(6373),
    [anon_sym_alias] = ACTIONS(5686),
    [anon_sym_global] = ACTIONS(5686),
    [anon_sym_unsafe] = ACTIONS(6373),
    [anon_sym_static] = ACTIONS(6373),
    [anon_sym_LPAREN] = ACTIONS(5691),
    [anon_sym_ref] = ACTIONS(5686),
    [anon_sym_delegate] = ACTIONS(5686),
    [anon_sym_abstract] = ACTIONS(6373),
    [anon_sym_async] = ACTIONS(6373),
    [anon_sym_const] = ACTIONS(6373),
    [anon_sym_file] = ACTIONS(6373),
    [anon_sym_fixed] = ACTIONS(6373),
    [anon_sym_internal] = ACTIONS(6373),
    [anon_sym_new] = ACTIONS(6373),
    [anon_sym_override] = ACTIONS(6373),
    [anon_sym_partial] = ACTIONS(6373),
    [anon_sym_private] = ACTIONS(6373),
    [anon_sym_protected] = ACTIONS(6373),
    [anon_sym_public] = ACTIONS(6373),
    [anon_sym_readonly] = ACTIONS(6373),
    [anon_sym_required] = ACTIONS(6373),
    [anon_sym_sealed] = ACTIONS(6373),
    [anon_sym_virtual] = ACTIONS(6373),
    [anon_sym_volatile] = ACTIONS(6373),
    [anon_sym_where] = ACTIONS(5686),
    [anon_sym_notnull] = ACTIONS(5686),
    [anon_sym_unmanaged] = ACTIONS(5686),
    [anon_sym_scoped] = ACTIONS(5686),
    [anon_sym_var] = ACTIONS(5686),
    [sym_predefined_type] = ACTIONS(5686),
    [anon_sym_yield] = ACTIONS(5686),
    [anon_sym_when] = ACTIONS(5686),
    [anon_sym_from] = ACTIONS(5686),
    [anon_sym_into] = ACTIONS(5686),
    [anon_sym_join] = ACTIONS(5686),
    [anon_sym_on] = ACTIONS(5686),
    [anon_sym_equals] = ACTIONS(5686),
    [anon_sym_let] = ACTIONS(5686),
    [anon_sym_orderby] = ACTIONS(5686),
    [anon_sym_ascending] = ACTIONS(5686),
    [anon_sym_descending] = ACTIONS(5686),
    [anon_sym_group] = ACTIONS(5686),
    [anon_sym_by] = ACTIONS(5686),
    [anon_sym_select] = ACTIONS(5686),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
  [4454] = {
    [sym_preproc_region] = STATE(4454),
    [sym_preproc_endregion] = STATE(4454),
    [sym_preproc_line] = STATE(4454),
    [sym_preproc_pragma] = STATE(4454),
    [sym_preproc_nullable] = STATE(4454),
    [sym_preproc_error] = STATE(4454),
    [sym_preproc_define] = STATE(4454),
    [sym_preproc_undef] = STATE(4454),
    [anon_sym_EQ] = ACTIONS(6038),
    [anon_sym_LBRACK] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_LPAREN] = ACTIONS(5294),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(5296),
    [anon_sym_GT] = ACTIONS(5296),
    [anon_sym_QMARK] = ACTIONS(5296),
    [anon_sym_BANG] = ACTIONS(5296),
    [anon_sym_PLUS_PLUS] = ACTIONS(5294),
    [anon_sym_DASH_DASH] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(5296),
    [anon_sym_DASH] = ACTIONS(5296),
    [anon_sym_STAR] = ACTIONS(5296),
    [anon_sym_SLASH] = ACTIONS(5296),
    [anon_sym_PERCENT] = ACTIONS(5296),
    [anon_sym_CARET] = ACTIONS(5296),
    [anon_sym_PIPE] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
    [anon_sym_LT_LT] = ACTIONS(5296),
    [anon_sym_GT_GT] = ACTIONS(5296),
    [anon_sym_GT_GT_GT] = ACTIONS(5296),
    [anon_sym_EQ_EQ] = ACTIONS(5294),
    [anon_sym_BANG_EQ] = ACTIONS(5294),
    [anon_sym_GT_EQ] = ACTIONS(5294),
    [anon_sym_LT_EQ] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(5296),
    [anon_sym_switch] = ACTIONS(5294),
    [anon_sym_DOT_DOT] = ACTIONS(5294),
    [anon_sym_PLUS_EQ] = ACTIONS(6040),
    [anon_sym_DASH_EQ] = ACTIONS(6040),
    [anon_sym_STAR_EQ] = ACTIONS(6040),
    [anon_sym_SLASH_EQ] = ACTIONS(6040),
    [anon_sym_PERCENT_EQ] = ACTIONS(6040),
    [anon_sym_AMP_EQ] = ACTIONS(6040),
    [anon_sym_CARET_EQ] = ACTIONS(6040),
    [anon_sym_PIPE_EQ] = ACTIONS(6040),
    [anon_sym_LT_LT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6040),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(6040),
    [anon_sym_AMP_AMP] = ACTIONS(5294),
    [anon_sym_PIPE_PIPE] = ACTIONS(5294),
    [anon_sym_QMARK_QMARK] = ACTIONS(5296),
    [anon_sym_as] = ACTIONS(5294),
    [anon_sym_is] = ACTIONS(5294),
    [anon_sym_DASH_GT] = ACTIONS(5294),
    [anon_sym_with] = ACTIONS(5294),
    [aux_sym_preproc_region_token1] = ACTIONS(3),
    [aux_sym_preproc_endregion_token1] = ACTIONS(5),
    [aux_sym_preproc_line_token1] = ACTIONS(7),
    [aux_sym_preproc_pragma_token1] = ACTIONS(9),
    [aux_sym_preproc_nullable_token1] = ACTIONS(11),
    [aux_sym_preproc_error_token1] = ACTIONS(13),
    [aux_sym_preproc_define_token1] = ACTIONS(15),
    [aux_sym_preproc_undef_token1] = ACTIONS(17),
    [sym_comment] = ACTIONS(19),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6180), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [111] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    STATE(4456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [228] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [367] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [510] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1225), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [617] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5380), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5378), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [706] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6180), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [821] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_as,
    STATE(4462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [942] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5425), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1087] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [1224] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5474), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1369] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6263), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [1514] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6454), 1,
      anon_sym_EQ,
    STATE(4467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6456), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [1607] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5626), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [1752] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5626), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1897] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6216), 1,
      anon_sym_or,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2042] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6458), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [2171] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5474), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [2316] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5470), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2461] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [2568] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6460), 1,
      aux_sym_raw_string_literal_token1,
    STATE(4475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5366), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5364), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [2659] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6317), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6315), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [2804] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5520), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2949] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6311), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6309), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [3094] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5508), 1,
      anon_sym_or,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3239] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6462), 1,
      anon_sym_EQ,
    STATE(4480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6464), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [3332] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6164), 1,
      anon_sym_or,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3477] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5425), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [3622] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6263), 1,
      anon_sym_or,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3767] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6305), 1,
      anon_sym_or,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [3912] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6216), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4057] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5470), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4202] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4415), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4331] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5520), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4476] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5508), 1,
      anon_sym_in,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4621] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4272), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [4750] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_into,
    STATE(4496), 1,
      aux_sym__query_body_repeat2,
    STATE(4491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6466), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [4843] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [4972] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5372), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5370), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5061] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6329), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [5168] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [5285] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_into,
    STATE(4505), 1,
      aux_sym__query_body_repeat2,
    STATE(4496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6472), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [5378] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6476), 1,
      anon_sym_EQ,
    STATE(4497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6478), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [5471] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [5602] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6164), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [5747] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6480), 1,
      anon_sym_EQ,
    STATE(4500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6482), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [5840] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6371), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6369), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [5985] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    STATE(4502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4320), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [6076] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6211] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_into,
    STATE(4508), 1,
      aux_sym__query_body_repeat2,
    STATE(4504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6472), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [6304] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6488), 1,
      anon_sym_into,
    STATE(4505), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6484), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [6395] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6491), 1,
      anon_sym_EQ,
    STATE(4506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6493), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [6488] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6621] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_into,
    STATE(4505), 1,
      aux_sym__query_body_repeat2,
    STATE(4508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6495), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [6714] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6825] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [6940] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6418), 1,
      anon_sym_with,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7061] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5393), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5391), 34,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [7150] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6499), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7279] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6305), 1,
      anon_sym_in,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6416), 1,
      anon_sym_is,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6452), 1,
      anon_sym_QMARK,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [7424] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6501), 1,
      sym_string_literal_encoding,
    STATE(4515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5384), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5382), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [7515] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5978), 1,
      anon_sym_scoped,
    ACTIONS(5980), 1,
      sym_predefined_type,
    ACTIONS(6503), 1,
      anon_sym_ref,
    ACTIONS(6505), 1,
      anon_sym_readonly,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5838), 1,
      sym_type,
    STATE(7801), 1,
      sym__name,
    STATE(8036), 1,
      sym_tuple_type,
    STATE(8363), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8912), 1,
      sym_implicit_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(9593), 1,
      sym__ref_base_type,
    STATE(8763), 2,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8350), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5719), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5717), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [7735] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4592), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7864] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4565), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [7993] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6507), 1,
      anon_sym_struct,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8122] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [8255] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6509), 1,
      sym__identifier_token,
    ACTIONS(6515), 1,
      anon_sym_LPAREN,
    ACTIONS(6521), 1,
      anon_sym_delegate,
    ACTIONS(6524), 1,
      anon_sym_var,
    ACTIONS(6527), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8024), 1,
      sym__name,
    STATE(8341), 1,
      sym_tuple_type,
    STATE(8474), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9096), 1,
      sym_function_pointer_parameter,
    STATE(9098), 1,
      sym__ref_base_type,
    STATE(9594), 1,
      sym_implicit_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    ACTIONS(6518), 3,
      anon_sym_ref,
      anon_sym_in,
      anon_sym_out,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8456), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4522), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_function_pointer_type_repeat1,
    ACTIONS(6512), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [8380] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5705), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [8469] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [8604] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [8735] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5703), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5701), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [8824] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6371), 1,
      anon_sym_or,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6369), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [8969] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 47,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [9056] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [9185] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5699), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5697), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [9274] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5747), 47,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [9361] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [9498] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6410), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [9605] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [9744] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4122), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
    ACTIONS(4120), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [9833] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6378), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6450), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [9976] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6530), 1,
      sym_string_literal_encoding,
    STATE(4537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5353), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5351), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10067] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6532), 1,
      anon_sym_EQ,
    STATE(4538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6534), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5294), 17,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
    ACTIONS(5296), 17,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_DOT,
      anon_sym_QMARK_QMARK,
  [10160] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5682), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(4539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5680), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [10249] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 16,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
    ACTIONS(3993), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [10338] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6538), 1,
      anon_sym_checked,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8845), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10464] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5433), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5431), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10552] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5946), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5944), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10640] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4727), 1,
      anon_sym_ref,
    ACTIONS(6357), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6544), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10766] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4320), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [10854] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4725), 1,
      anon_sym_ref,
    ACTIONS(6367), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6546), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [10980] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5952), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5950), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11068] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4070), 1,
      sym__identifier_token,
    ACTIONS(4102), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    ACTIONS(3993), 3,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 10,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(4073), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11176] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5956), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5954), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11264] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5960), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5958), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11352] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6752), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9773), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11478] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7359), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11604] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5413), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5411), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11692] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7388), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [11818] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5925), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5923), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [11906] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4616), 1,
      anon_sym_ref,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6351), 1,
      anon_sym_scoped,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6550), 1,
      anon_sym_readonly,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2950), 1,
      sym_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12032] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4225), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6265), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6554), 1,
      anon_sym_readonly,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3907), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12158] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7340), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12284] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5917), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5915), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12372] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5913), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5911), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12460] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5909), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5907), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [12548] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    ACTIONS(6556), 1,
      anon_sym_checked,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8715), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12674] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4507), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6560), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12800] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7366), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [12926] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5889), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13014] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5889), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13102] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5887), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5885), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13190] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5878), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [13278] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13410] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13544] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13674] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13802] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13938] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [14218] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5584), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5582), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14306] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5384), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5382), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14394] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5741), 1,
      sym_predefined_type,
    ACTIONS(5978), 1,
      anon_sym_scoped,
    ACTIONS(6503), 1,
      anon_sym_ref,
    ACTIONS(6505), 1,
      anon_sym_readonly,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5838), 1,
      sym_type,
    STATE(7800), 1,
      sym__name,
    STATE(7991), 1,
      sym_tuple_type,
    STATE(8334), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8763), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14520] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2721), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [14646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5870), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14734] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5866), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5864), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14822] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5862), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5860), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [14910] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7035), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9648), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15036] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5933), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15124] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2915), 1,
      anon_sym_readonly,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4068), 1,
      anon_sym_ref,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6594), 1,
      anon_sym_scoped,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2950), 1,
      sym_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15250] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8896), 1,
      sym_tuple_element,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15376] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4606), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6321), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6596), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(5496), 1,
      sym_identifier,
    STATE(6143), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [15502] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5486), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15590] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5658), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5656), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15678] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5858), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5856), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15766] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5850), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5848), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15854] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5646), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5644), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [15942] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4729), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6341), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    ACTIONS(6600), 1,
      anon_sym_readonly,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3614), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16068] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5840), 1,
      anon_sym_LPAREN,
    STATE(4594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [16156] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5508), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5506), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16244] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7035), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9402), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16370] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5984), 1,
      anon_sym_ref,
    ACTIONS(5992), 1,
      anon_sym_scoped,
    ACTIONS(6602), 1,
      anon_sym_readonly,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [16496] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5454), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5452), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16584] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5614), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5612), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16672] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5446), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5444), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16760] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5442), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5440), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16848] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5536), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5534), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [16936] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4290), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6198), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    ACTIONS(6604), 1,
      anon_sym_readonly,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3614), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17062] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8709), 1,
      sym_tuple_element,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17188] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2999), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5520), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5518), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17364] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17490] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5470), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5468), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6315), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [17720] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6814), 1,
      sym_identifier,
    STATE(7363), 1,
      sym_type,
    STATE(8723), 1,
      sym__join_header,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [17846] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5417), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5415), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [17934] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7310), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18060] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4672), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6259), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6608), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18186] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5731), 1,
      anon_sym_ref,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5739), 1,
      anon_sym_scoped,
    ACTIONS(5741), 1,
      sym_predefined_type,
    ACTIONS(6610), 1,
      anon_sym_readonly,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5838), 1,
      sym_type,
    STATE(7800), 1,
      sym__name,
    STATE(7991), 1,
      sym_tuple_type,
    STATE(8334), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8763), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18312] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_into,
    STATE(4631), 1,
      aux_sym__query_body_repeat2,
    STATE(4615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [18404] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_readonly,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4100), 1,
      anon_sym_ref,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6614), 1,
      anon_sym_scoped,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2950), 1,
      sym_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3127), 1,
      sym_identifier,
    STATE(3179), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [18530] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5421), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5419), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18618] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5269), 1,
      anon_sym_LT,
    ACTIONS(6616), 1,
      anon_sym_COLON_COLON,
    STATE(3591), 1,
      sym_type_argument_list,
    STATE(4618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 11,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4140), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18712] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2985), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2987), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18800] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5484), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5482), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18888] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5528), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5526), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [18976] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5634), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5632), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19064] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5630), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5628), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19152] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4532), 1,
      anon_sym_ref,
    ACTIONS(6120), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6618), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(5363), 1,
      sym_identifier,
    STATE(6000), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19278] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6620), 1,
      anon_sym_LPAREN,
    STATE(4625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [19366] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4102), 1,
      anon_sym_ref,
    ACTIONS(6622), 1,
      anon_sym_scoped,
    ACTIONS(6624), 1,
      anon_sym_var,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8921), 1,
      sym_tuple_element,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19492] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6628), 1,
      anon_sym_readonly,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [19618] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5405), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5403), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19706] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_or,
    STATE(4629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4799), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5896), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5893), 21,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19798] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_or,
    STATE(4630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4799), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5902), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5899), 21,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [19890] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_into,
    STATE(4648), 1,
      aux_sym__query_body_repeat2,
    STATE(4631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [19982] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_into,
    STATE(4649), 1,
      aux_sym__query_body_repeat2,
    STATE(4632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [20074] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5409), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5407), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20162] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5425), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5423), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20250] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_and,
    ACTIONS(6638), 1,
      anon_sym_or,
    STATE(4635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6632), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20342] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5450), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5448), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20430] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5458), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5456), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20518] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    ACTIONS(6640), 1,
      anon_sym_checked,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8801), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [20644] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_and,
    ACTIONS(6638), 1,
      anon_sym_or,
    STATE(4639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5929), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20736] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5462), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5460), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20824] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5474), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5472), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [20912] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5512), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5510), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21000] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5516), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5514), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21088] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5524), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5522), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21176] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5532), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5530), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21264] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5401), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5399), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21352] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1969), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1967), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21440] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6642), 1,
      anon_sym_into,
    STATE(4648), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [21530] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6612), 1,
      anon_sym_into,
    STATE(4648), 1,
      aux_sym__query_body_repeat2,
    STATE(4649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [21622] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5564), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5562), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21710] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5568), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5566), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [21798] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6741), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9130), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [21924] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5588), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5586), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22012] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5598), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5596), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22100] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5602), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5600), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22188] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5610), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5608), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22276] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5618), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5616), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22364] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5622), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5620), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22452] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5626), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5624), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22540] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6309), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [22682] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5662), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5660), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22770] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5650), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5648), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22858] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5654), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5652), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [22946] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5429), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5427), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23034] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5670), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5668), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23122] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_and,
    STATE(4666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6645), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23212] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5674), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5672), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23300] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5678), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5676), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23388] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5642), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5640), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23476] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4765), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(4763), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23564] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(1225), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [23670] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5638), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5636), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23758] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2989), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2991), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [23846] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [23988] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5606), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5604), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24076] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5572), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5570), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24164] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5580), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5578), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24252] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5576), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5574), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24340] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5540), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5538), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24428] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5502), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5500), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24516] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4355), 1,
      anon_sym_ref,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4524), 1,
      anon_sym_scoped,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [24642] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5476), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24730] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5294), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24818] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5666), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5664), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [24906] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5749), 1,
      anon_sym_LPAREN,
    STATE(4685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5747), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [24994] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5464), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25082] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6651), 1,
      anon_sym_LPAREN,
    STATE(4687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1963), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(1965), 32,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25172] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4070), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3993), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_operator,
      anon_sym_this,
    STATE(4688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(4073), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [25280] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym_LPAREN,
    STATE(4689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [25368] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5927), 1,
      anon_sym_LPAREN,
    STATE(4690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [25456] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7035), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9472), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [25582] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5504), 1,
      anon_sym_LPAREN,
    STATE(4692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [25670] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5504), 1,
      anon_sym_LPAREN,
    STATE(4693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4040), 45,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_unsafe,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_file,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_required,
      anon_sym_sealed,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [25758] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    ACTIONS(6655), 1,
      anon_sym_readonly,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [25884] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3040), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(3042), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [25972] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4721), 1,
      anon_sym_ref,
    ACTIONS(6307), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6657), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26098] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7335), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26224] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6275), 1,
      anon_sym_scoped,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    ACTIONS(6661), 1,
      anon_sym_readonly,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5316), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26350] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8804), 1,
      sym_tuple_element,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26476] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2907), 1,
      anon_sym_readonly,
    ACTIONS(4110), 1,
      anon_sym_ref,
    ACTIONS(6663), 1,
      sym__identifier_token,
    ACTIONS(6667), 1,
      anon_sym_LPAREN,
    ACTIONS(6669), 1,
      anon_sym_delegate,
    ACTIONS(6671), 1,
      anon_sym_scoped,
    ACTIONS(6673), 1,
      anon_sym_var,
    ACTIONS(6675), 1,
      sym_predefined_type,
    STATE(3152), 1,
      sym_identifier,
    STATE(3207), 1,
      sym__reserved_identifier,
    STATE(3257), 1,
      sym_type,
    STATE(3371), 1,
      sym_generic_name,
    STATE(3457), 1,
      sym_array_type,
    STATE(3459), 1,
      sym_tuple_type,
    STATE(3472), 1,
      sym__name,
    STATE(8737), 1,
      sym__array_base_type,
    STATE(9246), 1,
      sym__pointer_base_type,
    STATE(3310), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3453), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3458), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6665), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26602] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4475), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6323), 1,
      anon_sym_scoped,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    ACTIONS(6677), 1,
      anon_sym_readonly,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5316), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [26728] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2985), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(2987), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [26816] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [26932] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4530), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6251), 1,
      anon_sym_scoped,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6679), 1,
      anon_sym_readonly,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3907), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27058] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6180), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [27168] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6180), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [27282] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
    STATE(4707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 20,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [27402] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8876), 1,
      sym_tuple_element,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27528] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    ACTIONS(6681), 1,
      anon_sym_checked,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8782), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27654] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4719), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6228), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    ACTIONS(6683), 1,
      anon_sym_readonly,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3614), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27780] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4723), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6192), 1,
      anon_sym_scoped,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    ACTIONS(6685), 1,
      anon_sym_readonly,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3614), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [27906] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4260), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6241), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6687), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [28032] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5929), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [28120] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28262] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28404] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28546] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6691), 1,
      anon_sym_readonly,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [28672] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28814] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28956] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8917), 1,
      sym_tuple_element,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [29082] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2831), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4102), 1,
      anon_sym_ref,
    ACTIONS(6622), 1,
      anon_sym_scoped,
    ACTIONS(6624), 1,
      anon_sym_var,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [29208] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [29350] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4660), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6239), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6695), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [29476] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [29618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [29760] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6329), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [29866] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6172), 1,
      anon_sym_as,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6568), 1,
      anon_sym_SLASH,
    ACTIONS(6570), 1,
      anon_sym_AMP,
    ACTIONS(6574), 1,
      anon_sym_GT_GT,
    ACTIONS(6580), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6582), 1,
      anon_sym_is,
    ACTIONS(6584), 1,
      anon_sym_CARET,
    ACTIONS(6586), 1,
      anon_sym_PIPE,
    ACTIONS(6588), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6592), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6606), 1,
      anon_sym_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6564), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6566), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6576), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6578), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [30008] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8751), 1,
      sym_tuple_element,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30134] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6753), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9600), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30260] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4634), 1,
      anon_sym_ref,
    ACTIONS(6297), 1,
      anon_sym_scoped,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6697), 1,
      anon_sym_readonly,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2950), 1,
      sym_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30386] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7035), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8996), 1,
      sym_variable_declaration,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30512] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4658), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6337), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    ACTIONS(6699), 1,
      anon_sym_readonly,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3994), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30638] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7344), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30764] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2875), 1,
      anon_sym_readonly,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4124), 1,
      anon_sym_ref,
    ACTIONS(6701), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(5838), 1,
      sym_type,
    STATE(6396), 1,
      sym_identifier,
    STATE(6763), 1,
      sym__name,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [30890] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8988), 1,
      sym_tuple_element,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31016] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4674), 1,
      anon_sym_ref,
    ACTIONS(6363), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    ACTIONS(6703), 1,
      anon_sym_readonly,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3719), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31142] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4679), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6343), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6705), 1,
      anon_sym_readonly,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3907), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31268] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4687), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6333), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6707), 1,
      anon_sym_readonly,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3907), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31394] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4689), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6289), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6709), 1,
      anon_sym_readonly,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3907), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31520] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7218), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8931), 1,
      sym_tuple_element,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31646] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(5933), 33,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [31734] = 31,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4709), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6230), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    ACTIONS(6711), 1,
      anon_sym_readonly,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3614), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(4618), 1,
      sym_identifier,
    STATE(4964), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31860] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5984), 1,
      anon_sym_ref,
    ACTIONS(5992), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7812), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [31983] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9005), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32106] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4727), 1,
      anon_sym_ref,
    ACTIONS(6357), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32229] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4507), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32352] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [32481] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4674), 1,
      anon_sym_ref,
    ACTIONS(6363), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32604] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4689), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6289), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3902), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32727] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4658), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6337), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(4207), 1,
      sym_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32850] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4660), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6239), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(4207), 1,
      sym_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [32973] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4723), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6192), 1,
      anon_sym_scoped,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3720), 1,
      sym_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33096] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4719), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6228), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3720), 1,
      sym_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33219] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4530), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6251), 1,
      anon_sym_scoped,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(4011), 1,
      sym_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33342] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9112), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [33465] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5470), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [33608] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [33749] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_and,
    ACTIONS(6789), 1,
      anon_sym_or,
    STATE(4758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6632), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [33840] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [33983] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5508), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [34126] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [34257] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [34390] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [34531] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [34660] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [34787] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4679), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6343), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(4011), 1,
      sym_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [34910] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9108), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35033] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9481), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35156] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [35297] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [35438] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_and,
    ACTIONS(6793), 1,
      anon_sym_or,
    STATE(4771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [35529] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4672), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6259), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(4207), 1,
      sym_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35652] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4687), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6333), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3902), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35775] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9038), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [35898] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9105), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36021] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5425), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [36164] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4225), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6265), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(4011), 1,
      sym_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36287] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4679), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6343), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3902), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36410] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4100), 1,
      anon_sym_ref,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6614), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3127), 1,
      sym_identifier,
    STATE(3179), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [36533] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_and,
    ACTIONS(6789), 1,
      anon_sym_or,
    STATE(4780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(5929), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [36624] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [36759] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [36896] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4616), 1,
      anon_sym_ref,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6351), 1,
      anon_sym_scoped,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    STATE(2914), 1,
      sym_type,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37019] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4225), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6265), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3902), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37142] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6329), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [37247] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [37388] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8845), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37511] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [37652] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_ref,
    ACTIONS(6663), 1,
      sym__identifier_token,
    ACTIONS(6667), 1,
      anon_sym_LPAREN,
    ACTIONS(6669), 1,
      anon_sym_delegate,
    ACTIONS(6671), 1,
      anon_sym_scoped,
    ACTIONS(6673), 1,
      anon_sym_var,
    ACTIONS(6675), 1,
      sym_predefined_type,
    STATE(3152), 1,
      sym_identifier,
    STATE(3207), 1,
      sym__reserved_identifier,
    STATE(3255), 1,
      sym_type,
    STATE(3371), 1,
      sym_generic_name,
    STATE(3457), 1,
      sym_array_type,
    STATE(3459), 1,
      sym_tuple_type,
    STATE(3472), 1,
      sym__name,
    STATE(8737), 1,
      sym__array_base_type,
    STATE(9246), 1,
      sym__pointer_base_type,
    STATE(3310), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3453), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(3458), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6665), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37775] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4674), 1,
      anon_sym_ref,
    ACTIONS(6363), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [37898] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(1225), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_with,
  [38003] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4721), 1,
      anon_sym_ref,
    ACTIONS(6307), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38126] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4658), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6337), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38249] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4606), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6321), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4207), 1,
      sym_type,
    STATE(5496), 1,
      sym_identifier,
    STATE(6143), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38372] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [38505] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [38610] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4290), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6198), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3720), 1,
      sym_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38733] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4725), 1,
      anon_sym_ref,
    ACTIONS(6367), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38856] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4687), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6333), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(4011), 1,
      sym_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [38979] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6305), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [39122] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9743), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39245] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9243), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39368] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_into,
    STATE(4856), 1,
      aux_sym__query_body_repeat2,
    STATE(4803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6472), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [39459] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_into,
    STATE(4861), 1,
      aux_sym__query_body_repeat2,
    STATE(4804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6472), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [39550] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [39681] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4124), 1,
      anon_sym_ref,
    ACTIONS(6701), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6396), 1,
      sym_identifier,
    STATE(6763), 1,
      sym__name,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [39804] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [39945] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5470), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5468), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40088] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6263), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [40231] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40374] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5626), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [40517] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5508), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40660] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6216), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [40803] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6833), 1,
      anon_sym_LT,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(4814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4140), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4138), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [40894] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5518), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [41035] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [41176] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4355), 1,
      anon_sym_ref,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4524), 1,
      anon_sym_scoped,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [41299] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6180), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [41408] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_as,
    STATE(4819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [41527] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7993), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [41650] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9119), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [41773] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [41896] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6275), 1,
      anon_sym_scoped,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5321), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42019] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4076), 1,
      anon_sym_ref,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6122), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42142] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(9966), 1,
      sym_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42265] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8140), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42388] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6305), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [42531] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5741), 1,
      sym_predefined_type,
    ACTIONS(5978), 1,
      anon_sym_scoped,
    ACTIONS(6503), 1,
      anon_sym_ref,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(7800), 1,
      sym__name,
    STATE(7991), 1,
      sym_tuple_type,
    STATE(8334), 1,
      sym_array_type,
    STATE(8770), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8763), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [42654] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6837), 2,
      anon_sym_ascending,
      anon_sym_descending,
    ACTIONS(6835), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [42797] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_LBRACE,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    STATE(3623), 1,
      sym_argument_list,
    STATE(3739), 1,
      sym_initializer_expression,
    STATE(4830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5267), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5263), 29,
      anon_sym_LBRACK,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [42892] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3993), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(4086), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_GT,
    STATE(4831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(4089), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [42983] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6303), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [43124] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9385), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43247] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4507), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6208), 1,
      anon_sym_scoped,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(4207), 1,
      sym_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43370] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4634), 1,
      anon_sym_ref,
    ACTIONS(6297), 1,
      anon_sym_scoped,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    STATE(2914), 1,
      sym_type,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43493] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5474), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43636] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_and,
    STATE(4837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 32,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [43725] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4729), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6341), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3720), 1,
      sym_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43848] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9630), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [43971] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9002), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44094] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6311), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6309), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [44237] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5474), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5472), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [44380] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4709), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6230), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3720), 1,
      sym_type,
    STATE(4618), 1,
      sym_identifier,
    STATE(4964), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44503] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9477), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44626] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44749] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4102), 1,
      anon_sym_ref,
    ACTIONS(6622), 1,
      anon_sym_scoped,
    ACTIONS(6624), 1,
      anon_sym_var,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(7292), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44872] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9004), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [44995] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4070), 1,
      sym__identifier_token,
    ACTIONS(4124), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(6766), 1,
      sym_identifier,
    STATE(6890), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3993), 4,
      anon_sym_COLON,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3991), 8,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(4848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4073), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45102] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [45221] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [45334] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4660), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6239), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45457] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4463), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6275), 1,
      anon_sym_scoped,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5713), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45580] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9043), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45703] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8801), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [45826] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    STATE(4855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [45941] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_into,
    STATE(4861), 1,
      aux_sym__query_body_repeat2,
    STATE(4856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6495), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [46032] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4616), 1,
      anon_sym_ref,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6351), 1,
      anon_sym_scoped,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(4662), 1,
      sym_type,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46155] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5626), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5624), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [46298] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6263), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6261), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [46441] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4727), 1,
      anon_sym_ref,
    ACTIONS(6357), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46564] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym_into,
    STATE(4861), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6484), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [46653] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4689), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6289), 1,
      anon_sym_scoped,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(4011), 1,
      sym_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46776] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9265), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [46899] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5425), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5423), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [47042] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9149), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47165] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9239), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47288] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6329), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [47393] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6311), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6309), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [47536] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4102), 1,
      anon_sym_ref,
    ACTIONS(6622), 1,
      anon_sym_scoped,
    ACTIONS(6624), 1,
      anon_sym_var,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47659] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4723), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6192), 1,
      anon_sym_scoped,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3611), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [47782] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6216), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6214), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [47925] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4709), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6230), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3611), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(4618), 1,
      sym_identifier,
    STATE(4964), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48048] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4260), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6241), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48171] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4672), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6259), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48294] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4725), 1,
      anon_sym_ref,
    ACTIONS(6367), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48417] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4475), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6323), 1,
      anon_sym_scoped,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5713), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48540] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6317), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6315), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48683] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9662), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [48806] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6164), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48949] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8782), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49072] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4068), 1,
      anon_sym_ref,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    ACTIONS(6594), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49195] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4719), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6228), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3611), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49318] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4606), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6321), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3990), 1,
      sym_type,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(5496), 1,
      sym_identifier,
    STATE(6143), 1,
      sym__name,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49441] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9667), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49564] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    ACTIONS(4260), 1,
      anon_sym_ref,
    ACTIONS(6206), 1,
      anon_sym_delegate,
    ACTIONS(6210), 1,
      anon_sym_var,
    ACTIONS(6212), 1,
      sym_predefined_type,
    ACTIONS(6241), 1,
      anon_sym_scoped,
    ACTIONS(6558), 1,
      anon_sym_LPAREN,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3933), 1,
      sym_identifier,
    STATE(4012), 1,
      sym_tuple_type,
    STATE(4014), 1,
      sym_array_type,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4175), 1,
      sym__name,
    STATE(4207), 1,
      sym_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9081), 1,
      sym__pointer_base_type,
    STATE(4013), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4015), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4022), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49687] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9668), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49810] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [49933] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6787), 1,
      anon_sym_and,
    STATE(4888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 13,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
      anon_sym_as,
    ACTIONS(6645), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [50022] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9686), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50145] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [50282] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [50417] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6317), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6315), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [50560] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5984), 1,
      anon_sym_ref,
    ACTIONS(5992), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [50683] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_as,
    ACTIONS(6180), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
  [50796] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [50937] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9467), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51060] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6371), 1,
      anon_sym_or,
    ACTIONS(6735), 1,
      anon_sym_QMARK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6769), 1,
      anon_sym_is,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6369), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [51203] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3153), 1,
      anon_sym_scoped,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(3998), 1,
      anon_sym_ref,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(6812), 1,
      sym_identifier,
    STATE(7320), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51326] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4532), 1,
      anon_sym_ref,
    ACTIONS(6120), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3695), 1,
      sym_type,
    STATE(5363), 1,
      sym_identifier,
    STATE(6000), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51449] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_into,
    STATE(4804), 1,
      aux_sym__query_body_repeat2,
    STATE(4900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_as,
    ACTIONS(6466), 31,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [51540] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [51667] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6689), 1,
      anon_sym_ref,
    ACTIONS(6693), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9760), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51790] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4532), 1,
      anon_sym_ref,
    ACTIONS(6120), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(5363), 1,
      sym_identifier,
    STATE(6000), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [51913] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(4721), 1,
      anon_sym_ref,
    ACTIONS(6307), 1,
      anon_sym_scoped,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52036] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5731), 1,
      anon_sym_ref,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5739), 1,
      anon_sym_scoped,
    ACTIONS(5741), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(7800), 1,
      sym__name,
    STATE(7991), 1,
      sym_tuple_type,
    STATE(8334), 1,
      sym_array_type,
    STATE(8762), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8763), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52159] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9358), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52282] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6160), 1,
      anon_sym_switch,
    ACTIONS(6176), 1,
      anon_sym_with,
    ACTIONS(6448), 1,
      anon_sym_as,
    ACTIONS(6719), 1,
      anon_sym_SLASH,
    ACTIONS(6723), 1,
      anon_sym_GT_GT,
    ACTIONS(6729), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6731), 1,
      anon_sym_is,
    ACTIONS(6773), 1,
      anon_sym_QMARK,
    ACTIONS(6775), 1,
      anon_sym_CARET,
    ACTIONS(6777), 1,
      anon_sym_PIPE,
    ACTIONS(6779), 1,
      anon_sym_AMP,
    ACTIONS(6781), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6783), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6785), 1,
      anon_sym_QMARK_QMARK,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6713), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6715), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6721), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6725), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6727), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5506), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [52423] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5984), 1,
      anon_sym_ref,
    ACTIONS(5992), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8140), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52546] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(5731), 1,
      anon_sym_ref,
    ACTIONS(5733), 1,
      anon_sym_delegate,
    ACTIONS(5739), 1,
      anon_sym_scoped,
    ACTIONS(5741), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(7800), 1,
      sym__name,
    STATE(7991), 1,
      sym_tuple_type,
    STATE(8334), 1,
      sym_array_type,
    STATE(8770), 1,
      sym_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9524), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(8763), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(4909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52669] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4290), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6198), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3611), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52792] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(8936), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [52915] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6164), 1,
      anon_sym_in,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6797), 1,
      anon_sym_QMARK,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6130), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [53058] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4221), 1,
      sym__identifier_token,
    ACTIONS(4530), 1,
      anon_sym_ref,
    ACTIONS(6249), 1,
      anon_sym_delegate,
    ACTIONS(6251), 1,
      anon_sym_scoped,
    ACTIONS(6253), 1,
      anon_sym_var,
    ACTIONS(6255), 1,
      sym_predefined_type,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    STATE(3804), 1,
      sym_identifier,
    STATE(3831), 1,
      sym__reserved_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3902), 1,
      sym_type,
    STATE(3923), 1,
      sym__name,
    STATE(3931), 1,
      sym_tuple_type,
    STATE(3934), 1,
      sym_array_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9571), 1,
      sym__pointer_base_type,
    STATE(3932), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3940), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3947), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4223), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53181] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1225), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [53286] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    ACTIONS(4355), 1,
      anon_sym_ref,
    ACTIONS(4522), 1,
      anon_sym_delegate,
    ACTIONS(4524), 1,
      anon_sym_scoped,
    ACTIONS(4526), 1,
      anon_sym_var,
    ACTIONS(4528), 1,
      sym_predefined_type,
    ACTIONS(6542), 1,
      anon_sym_LPAREN,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3603), 1,
      sym_identifier,
    STATE(3648), 1,
      sym_tuple_type,
    STATE(3652), 1,
      sym_array_type,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3733), 1,
      sym_type,
    STATE(3767), 1,
      sym__name,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9106), 1,
      sym__pointer_base_type,
    STATE(3647), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3655), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3670), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [53409] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [53518] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [53649] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(4918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [53782] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACK,
    ACTIONS(6008), 1,
      anon_sym_LBRACE,
    ACTIONS(6011), 1,
      anon_sym_QMARK,
    STATE(3727), 1,
      sym_initializer_expression,
    STATE(4919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5331), 30,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [53877] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9342), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54000] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9339), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54123] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9787), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54246] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [54361] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6624), 1,
      anon_sym_var,
    ACTIONS(6626), 1,
      anon_sym_ref,
    ACTIONS(6630), 1,
      anon_sym_scoped,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9468), 1,
      sym_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54484] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4459), 1,
      sym__identifier_token,
    ACTIONS(4475), 1,
      anon_sym_ref,
    ACTIONS(6273), 1,
      anon_sym_delegate,
    ACTIONS(6277), 1,
      anon_sym_var,
    ACTIONS(6279), 1,
      sym_predefined_type,
    ACTIONS(6323), 1,
      anon_sym_scoped,
    ACTIONS(6659), 1,
      anon_sym_LPAREN,
    STATE(5110), 1,
      sym_identifier,
    STATE(5191), 1,
      sym__reserved_identifier,
    STATE(5242), 1,
      sym_tuple_type,
    STATE(5245), 1,
      sym_array_type,
    STATE(5266), 1,
      sym__name,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5321), 1,
      sym_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9212), 1,
      sym__pointer_base_type,
    STATE(5243), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5276), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5396), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4461), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54607] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    ACTIONS(4729), 1,
      anon_sym_ref,
    ACTIONS(6190), 1,
      anon_sym_delegate,
    ACTIONS(6194), 1,
      anon_sym_var,
    ACTIONS(6196), 1,
      sym_predefined_type,
    ACTIONS(6341), 1,
      anon_sym_scoped,
    ACTIONS(6598), 1,
      anon_sym_LPAREN,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3611), 1,
      sym_type,
    STATE(3624), 1,
      sym_array_type,
    STATE(3626), 1,
      sym_tuple_type,
    STATE(3960), 1,
      sym_identifier,
    STATE(4334), 1,
      sym__name,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9581), 1,
      sym__pointer_base_type,
    STATE(3622), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(3625), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(3629), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [54730] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [54835] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6180), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [54944] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6180), 21,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [55057] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6791), 1,
      anon_sym_and,
    ACTIONS(6793), 1,
      anon_sym_or,
    STATE(4930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 31,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55148] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(4612), 1,
      sym__identifier_token,
    ACTIONS(4634), 1,
      anon_sym_ref,
    ACTIONS(6297), 1,
      anon_sym_scoped,
    ACTIONS(6299), 1,
      anon_sym_var,
    ACTIONS(6301), 1,
      sym_predefined_type,
    ACTIONS(6548), 1,
      anon_sym_LPAREN,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2938), 1,
      sym_identifier,
    STATE(2944), 1,
      sym_tuple_type,
    STATE(2946), 1,
      sym_array_type,
    STATE(2961), 1,
      sym_generic_name,
    STATE(3012), 1,
      sym__name,
    STATE(4662), 1,
      sym_type,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(2945), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(2948), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55271] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6823), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6825), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55412] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55549] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6805), 1,
      anon_sym_CARET,
    ACTIONS(6807), 1,
      anon_sym_PIPE,
    ACTIONS(6809), 1,
      anon_sym_AMP,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [55684] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6759), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6771), 1,
      anon_sym_with,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [55803] = 30,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(3155), 1,
      anon_sym_var,
    ACTIONS(3157), 1,
      sym_predefined_type,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(6536), 1,
      anon_sym_ref,
    ACTIONS(6540), 1,
      anon_sym_scoped,
    STATE(2914), 1,
      sym_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5261), 1,
      sym__name,
    STATE(5340), 1,
      sym_tuple_type,
    STATE(5440), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(2883), 3,
      sym_implicit_type,
      sym_ref_type,
      sym_scoped_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5342), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(4936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 20,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [55926] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [56053] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(4938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [56168] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6803), 1,
      anon_sym_SLASH,
    ACTIONS(6813), 1,
      anon_sym_GT_GT,
    ACTIONS(6819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(6829), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6795), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6799), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6801), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6817), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(4939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [56297] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6371), 1,
      anon_sym_or,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [56439] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5286), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5282), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [56541] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4073), 1,
      anon_sym_where,
    ACTIONS(5984), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 11,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
    ACTIONS(27), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [56647] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6882), 1,
      anon_sym_into,
    STATE(4943), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [56735] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_into,
    STATE(4943), 1,
      aux_sym__query_body_repeat2,
    STATE(4944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [56825] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    STATE(4945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [56939] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_into,
    STATE(4961), 1,
      aux_sym__query_body_repeat2,
    STATE(4946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [57029] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(1225), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [57133] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5313), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5311), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [57235] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(4949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4140), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4138), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [57327] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [57467] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57603] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(4952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57737] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57863] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 4,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [57991] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [58123] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
    STATE(4956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [58253] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6887), 1,
      anon_sym_DOT,
    STATE(4957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4482), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58341] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_into,
    STATE(4944), 1,
      aux_sym__query_body_repeat2,
    STATE(4958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [58431] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_into,
    STATE(4973), 1,
      aux_sym__query_body_repeat2,
    STATE(4959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6472), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58521] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_into,
    STATE(4962), 1,
      aux_sym__query_body_repeat2,
    STATE(4960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6472), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58611] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6885), 1,
      anon_sym_into,
    STATE(4943), 1,
      aux_sym__query_body_repeat2,
    STATE(4961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 30,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [58701] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_into,
    STATE(4973), 1,
      aux_sym__query_body_repeat2,
    STATE(4962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6495), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58791] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6889), 1,
      anon_sym_into,
    STATE(4959), 1,
      aux_sym__query_body_repeat2,
    STATE(4963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6466), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58881] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    ACTIONS(5388), 1,
      anon_sym_QMARK,
    ACTIONS(6887), 1,
      anon_sym_DOT,
    STATE(4964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(4453), 30,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [58975] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5508), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59117] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5520), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59259] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5470), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59401] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6164), 1,
      anon_sym_or,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59543] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6216), 1,
      anon_sym_or,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59685] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5425), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59827] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5474), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [59969] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6180), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [60077] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6891), 1,
      anon_sym_into,
    STATE(4973), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6484), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [60165] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(5626), 1,
      anon_sym_or,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [60307] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6263), 1,
      anon_sym_or,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [60449] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    STATE(4976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6180), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [60561] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
    STATE(4977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [60679] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6305), 1,
      anon_sym_or,
    ACTIONS(6844), 1,
      anon_sym_QMARK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6878), 1,
      anon_sym_is,
    ACTIONS(6880), 1,
      anon_sym_with,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [60821] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(6329), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [60925] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(4980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_or,
    ACTIONS(5323), 25,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [61027] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    STATE(4981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4320), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61115] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [61254] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5917), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5915), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61339] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5889), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61424] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4128), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4126), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [61509] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5889), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61594] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5913), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5911), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61679] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4140), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4138), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [61764] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5878), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [61849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4604), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4602), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [61934] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5909), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5907), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62019] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5887), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5885), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62104] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5850), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5848), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62189] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5929), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62274] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5870), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62359] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5866), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5864), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62444] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4144), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4142), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [62529] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(4998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5862), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5860), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62614] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(4999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [62753] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5858), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5856), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62838] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_and,
    STATE(5001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6645), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [62925] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63064] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [63199] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [63338] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [63471] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6689), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 10,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [63574] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [63699] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5933), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [63784] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4132), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4130), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [63869] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [63982] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [64109] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [64240] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5933), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64325] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5946), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5944), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64410] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(4320), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64495] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5952), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5950), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64580] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5956), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5954), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [64665] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [64794] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 22,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [64901] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 20,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [65012] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5960), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5958), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65097] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [65214] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_and,
    ACTIONS(6930), 1,
      anon_sym_or,
    STATE(5023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65303] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [65442] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6928), 1,
      anon_sym_and,
    ACTIONS(6930), 1,
      anon_sym_or,
    STATE(5025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65531] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [65670] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5925), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(5923), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [65755] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [65894] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66033] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66172] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66311] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66450] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4136), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4134), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [66535] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [66638] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4157), 15,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_DASH_GT,
    ACTIONS(4155), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [66723] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [66862] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6932), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67001] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_or,
    STATE(5038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4799), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5896), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5893), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67090] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4807), 1,
      anon_sym_or,
    STATE(5039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4799), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5902), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5899), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [67179] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 24,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [67282] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6767), 1,
      anon_sym_as,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6896), 1,
      anon_sym_QMARK,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6904), 1,
      anon_sym_CARET,
    ACTIONS(6906), 1,
      anon_sym_PIPE,
    ACTIONS(6908), 1,
      anon_sym_AMP,
    ACTIONS(6912), 1,
      anon_sym_GT_GT,
    ACTIONS(6918), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6920), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6922), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6924), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6926), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6894), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6898), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6900), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6914), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6916), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67421] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67559] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67697] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [67835] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(5344), 1,
      anon_sym_var,
    ACTIONS(6968), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8024), 1,
      sym__name,
    STATE(8341), 1,
      sym_tuple_type,
    STATE(8474), 1,
      sym_array_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9593), 1,
      sym__ref_base_type,
    STATE(9594), 1,
      sym_implicit_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8456), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [67951] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [68089] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [68205] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [68315] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [68421] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68549] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68679] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [68805] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [68917] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [69041] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_where,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [69175] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [69307] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [69441] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69579] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7002), 1,
      anon_sym_and,
    ACTIONS(7004), 1,
      anon_sym_or,
    STATE(5059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69667] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5893), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [69755] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [69893] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70031] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5899), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5476), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [70119] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70257] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70395] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [70533] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [70665] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [70789] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [70901] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [71027] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71165] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71303] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71441] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_where,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [71571] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7000), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [71699] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 21,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [71805] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [71943] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72081] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [72187] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [72325] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [72441] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [72551] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_where,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
  [72667] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [72777] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [72905] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73035] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73161] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [73273] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [73375] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [73477] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73601] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73733] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [73867] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74005] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74143] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    STATE(5194), 1,
      sym_argument_list,
    STATE(5699), 1,
      sym_initializer_expression,
    STATE(5096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5267), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5263), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [74235] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74373] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7050), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4178), 14,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4169), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [74595] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74733] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [74871] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75009] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_into,
    STATE(5116), 1,
      aux_sym__query_body_repeat2,
    STATE(5103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75097] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75235] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_into,
    STATE(5122), 1,
      aux_sym__query_body_repeat2,
    STATE(5105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75323] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_into,
    STATE(5103), 1,
      aux_sym__query_body_repeat2,
    STATE(5106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75411] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 23,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [75513] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75651] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [75789] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7054), 1,
      anon_sym_LT,
    ACTIONS(7057), 1,
      anon_sym_COLON_COLON,
    STATE(5285), 1,
      sym_type_argument_list,
    STATE(5110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4140), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [75879] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76017] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76155] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7002), 1,
      anon_sym_and,
    ACTIONS(7004), 1,
      anon_sym_or,
    STATE(5113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [76243] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76381] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7002), 1,
      anon_sym_and,
    STATE(5115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 12,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_or,
    ACTIONS(6645), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [76467] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7059), 1,
      anon_sym_into,
    STATE(5116), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [76553] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76691] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 23,
      anon_sym_where,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [76793] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [76931] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7062), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77069] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77207] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7052), 1,
      anon_sym_into,
    STATE(5116), 1,
      aux_sym__query_body_repeat2,
    STATE(5122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [77295] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77397] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77535] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77673] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [77811] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [77913] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78051] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_QMARK,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7032), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7042), 1,
      anon_sym_is,
    ACTIONS(7044), 1,
      anon_sym_with,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78189] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7064), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78327] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3993), 1,
      anon_sym_EQ,
    ACTIONS(3991), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    ACTIONS(4086), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    STATE(5131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4089), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [78415] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6976), 1,
      anon_sym_SLASH,
    ACTIONS(6978), 1,
      anon_sym_CARET,
    ACTIONS(6980), 1,
      anon_sym_PIPE,
    ACTIONS(6982), 1,
      anon_sym_AMP,
    ACTIONS(6986), 1,
      anon_sym_GT_GT,
    ACTIONS(6992), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6996), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6998), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7000), 1,
      anon_sym_is,
    ACTIONS(7046), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6970), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6972), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6974), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6984), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6988), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6990), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7066), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(5132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78553] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(6936), 1,
      anon_sym_QMARK,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6958), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6966), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78691] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78828] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [78965] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3993), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3991), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [79048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79185] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [79318] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7102), 1,
      anon_sym_LBRACK,
    ACTIONS(7104), 1,
      sym_predefined_type,
    STATE(3569), 1,
      sym_array_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8987), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [79429] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [79560] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [79683] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [79794] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [79919] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [80048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [80185] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [80322] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [80449] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [80550] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [80665] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [80774] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [80911] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [81048] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [81185] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [81318] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACK,
    ACTIONS(5334), 1,
      anon_sym_LBRACE,
    ACTIONS(5340), 1,
      anon_sym_QMARK,
    STATE(3763), 1,
      sym_initializer_expression,
    STATE(5155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5331), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [81409] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [81540] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [81655] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [81792] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [81907] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [82030] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [82155] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [82292] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [82421] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [82530] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [82657] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [82766] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    ACTIONS(7184), 1,
      anon_sym_LBRACK,
    STATE(3605), 1,
      sym_array_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8881), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [82877] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [82978] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(6503), 1,
      anon_sym_ref,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8643), 1,
      sym__name,
    STATE(8766), 1,
      sym_ref_type,
    STATE(8767), 1,
      sym__scoped_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3991), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [83079] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 22,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [83180] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [83285] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [83422] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [83559] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [83664] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    ACTIONS(7188), 1,
      anon_sym_LBRACK,
    STATE(3916), 1,
      sym_array_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8906), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [83775] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [83902] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [84013] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [84114] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [84243] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7054), 1,
      anon_sym_LT,
    STATE(5285), 1,
      sym_type_argument_list,
    STATE(5180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4140), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [84330] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84467] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [84604] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [84729] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 18,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [84840] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [84963] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 22,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [85064] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [85195] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85328] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85465] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    ACTIONS(7190), 1,
      anon_sym_LBRACK,
    STATE(4422), 1,
      sym_array_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8934), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [85576] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4120), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4122), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85659] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3991), 1,
      anon_sym_COLON_COLON,
    STATE(5192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4089), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4086), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85744] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [85881] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(5734), 1,
      sym_initializer_expression,
    STATE(5194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5317), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5315), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [85968] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3993), 12,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3991), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86051] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    ACTIONS(5306), 1,
      anon_sym_LBRACK,
    STATE(5710), 1,
      sym_initializer_expression,
    STATE(5196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5309), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5304), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [86140] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86277] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5286), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5282), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [86376] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4620), 13,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_EQ_GT,
    ACTIONS(4618), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [86459] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [86596] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [86701] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5325), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5323), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [86800] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    ACTIONS(7192), 1,
      anon_sym_LBRACK,
    STATE(3808), 1,
      sym_array_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8981), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [86911] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87048] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    ACTIONS(7194), 1,
      anon_sym_LBRACK,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5196), 1,
      sym_array_type,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8779), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(8838), 3,
      sym_nullable_type,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [87159] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(5731), 1,
      anon_sym_ref,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(8643), 1,
      sym__name,
    STATE(8766), 1,
      sym_ref_type,
    STATE(8767), 1,
      sym__scoped_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3991), 8,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [87260] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87397] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87534] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87671] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4120), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4122), 30,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [87754] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5313), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(5311), 23,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [87853] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [87990] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(5705), 1,
      sym_initializer_expression,
    STATE(5213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5321), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5319), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88077] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88214] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88351] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88488] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACK,
    ACTIONS(7196), 1,
      anon_sym_LBRACE,
    ACTIONS(7199), 1,
      anon_sym_QMARK,
    STATE(5700), 1,
      sym_initializer_expression,
    STATE(5217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5331), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88579] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_into,
    STATE(5220), 1,
      aux_sym__query_body_repeat2,
    STATE(5218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88666] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [88803] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_into,
    STATE(5220), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88888] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_into,
    STATE(5227), 1,
      aux_sym__query_body_repeat2,
    STATE(5221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [88975] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89112] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_into,
    STATE(5218), 1,
      aux_sym__query_body_repeat2,
    STATE(5223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89199] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89336] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89473] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89610] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7203), 1,
      anon_sym_into,
    STATE(5220), 1,
      aux_sym__query_body_repeat2,
    STATE(5227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [89697] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89834] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7182), 1,
      anon_sym_is,
    ACTIONS(7186), 1,
      anon_sym_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [89971] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90108] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90245] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7070), 1,
      anon_sym_QMARK,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7092), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7100), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90382] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 22,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [90483] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90620] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7108), 1,
      anon_sym_QMARK,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7130), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7138), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 6,
      anon_sym_SEMI,
      anon_sym_and,
      anon_sym_or,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90757] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    ACTIONS(7210), 1,
      anon_sym_COMMA,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    ACTIONS(7248), 1,
      sym_interpolation_close_brace,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    STATE(8482), 1,
      sym_interpolation_alignment_clause,
    STATE(9476), 1,
      sym_interpolation_format_clause,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [90901] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4608), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4610), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [90983] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91119] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91255] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91391] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91527] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_QMARK,
    STATE(5242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4453), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [91615] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    STATE(5243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4453), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [91701] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [91837] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(7320), 1,
      anon_sym_QMARK,
    STATE(5245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4453), 28,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [91923] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92059] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92195] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6626), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3991), 7,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [92295] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [92405] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [92509] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [92617] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [92731] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [92867] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [93003] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [93139] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [93243] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [93353] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [93453] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4622), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4624), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [93535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4579), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4577), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [93617] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(4453), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [93707] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_and,
    ACTIONS(7353), 1,
      anon_sym_or,
    STATE(5262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [93793] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_and,
    ACTIONS(7357), 1,
      anon_sym_or,
    STATE(5263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [93879] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94015] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94151] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    ACTIONS(7320), 1,
      anon_sym_QMARK,
    ACTIONS(7359), 1,
      anon_sym_DOT,
    STATE(5266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4453), 27,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [94241] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94377] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7397), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9632), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94519] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(6536), 1,
      anon_sym_ref,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2906), 1,
      sym_ref_type,
    STATE(2907), 1,
      sym__scoped_base_type,
    STATE(5271), 1,
      sym_identifier,
    STATE(6249), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(3991), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(5269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [94619] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94755] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(5271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4140), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4138), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [94843] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [94979] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95115] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4465), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4467), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95197] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95333] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4453), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95415] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [95539] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [95675] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(7277), 1,
      sym_nullable_type,
    STATE(7278), 1,
      sym_array_type,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(8838), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [95785] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4140), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [95867] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [95981] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [96081] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [96191] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96327] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4142), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4144), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [96409] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96545] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96681] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96817] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [96953] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97089] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97225] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97361] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97497] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7359), 1,
      anon_sym_DOT,
    STATE(5294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4482), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [97581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [97665] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [97773] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    STATE(5297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5476), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [97857] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [97993] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4482), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98075] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_and,
    ACTIONS(7357), 1,
      anon_sym_or,
    STATE(5300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98161] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4134), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4136), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98243] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [98379] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [98493] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [98629] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4536), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4534), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [98711] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(5306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4140), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_EQ_GT,
    ACTIONS(4138), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [98797] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4484), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4486), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [98879] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99015] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4490), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99097] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    STATE(5310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4320), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99181] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7451), 1,
      sym_string_literal_encoding,
    STATE(5311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5353), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5351), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99265] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4130), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4132), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99347] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4126), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4128), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99429] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4455), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4457), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99511] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7453), 1,
      aux_sym_raw_string_literal_token1,
    STATE(5315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5366), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5364), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99595] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4431), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99677] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4610), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4608), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [99759] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [99895] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4471), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4473), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [99977] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7455), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9788), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100119] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4494), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4496), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5372), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5370), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [100283] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100419] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [100555] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [100669] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [100777] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4624), 12,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
    ACTIONS(4622), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [100859] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 19,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [100963] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101099] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7252), 1,
      anon_sym_QMARK,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101235] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [101361] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4618), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4620), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [101443] = 43,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    ACTIONS(7210), 1,
      anon_sym_COMMA,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    ACTIONS(7457), 1,
      sym_interpolation_close_brace,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    STATE(8619), 1,
      sym_interpolation_alignment_clause,
    STATE(9204), 1,
      sym_interpolation_format_clause,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101587] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4218), 1,
      sym_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4349), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [101695] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7465), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9384), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101837] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [101965] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [102069] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [102193] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4577), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4579), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [102275] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(5340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    ACTIONS(4451), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [102363] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [102473] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(5342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4453), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(4451), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [102559] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [102681] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [102807] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7467), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9240), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [102949] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103079] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103207] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [103331] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [103453] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [103553] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103683] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103815] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [103951] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104083] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104219] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 21,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [104319] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104455] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104591] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [104691] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104823] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [104953] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7415), 1,
      anon_sym_QMARK,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105089] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5346), 1,
      anon_sym_LT,
    ACTIONS(7469), 1,
      anon_sym_COLON_COLON,
    STATE(3728), 1,
      sym_type_argument_list,
    STATE(5363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 11,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4140), 26,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [105177] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_and,
    STATE(5364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [105261] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [105385] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105513] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [105639] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_and,
    STATE(5368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 28,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [105723] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_and,
    ACTIONS(7353), 1,
      anon_sym_or,
    STATE(5369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [105809] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [105945] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106081] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 21,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [106181] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106317] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106453] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [106561] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [106697] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(5379), 1,
      aux_sym__query_body_repeat2,
    STATE(5377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106783] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 21,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [106883] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(5383), 1,
      aux_sym__query_body_repeat2,
    STATE(5379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [106969] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107105] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(5384), 1,
      aux_sym__query_body_repeat2,
    STATE(5381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107191] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107327] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7473), 1,
      anon_sym_into,
    STATE(5383), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107411] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(5383), 1,
      aux_sym__query_body_repeat2,
    STATE(5384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [107497] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107633] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107769] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7476), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9519), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [107911] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 21,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [108011] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7478), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9199), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [108153] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7480), 1,
      sym_string_literal_encoding,
    STATE(5390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5384), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5382), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108237] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5380), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5378), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108319] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5393), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5391), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108401] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4498), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4500), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108483] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7329), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7431), 1,
      anon_sym_QMARK,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7449), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 5,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [108619] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4534), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4536), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108701] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4155), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4157), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [108783] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [108909] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109037] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(3127), 1,
      anon_sym_LPAREN,
    ACTIONS(4000), 1,
      anon_sym_delegate,
    ACTIONS(7104), 1,
      sym_predefined_type,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4949), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(7187), 1,
      sym_nullable_type,
    STATE(7192), 1,
      sym_array_type,
    STATE(8289), 1,
      sym__name,
    STATE(8568), 1,
      sym_tuple_type,
    STATE(8909), 1,
      sym__array_base_type,
    STATE(9906), 1,
      sym__pointer_base_type,
    STATE(8838), 2,
      sym_pointer_type,
      sym_function_pointer_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(5399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [109147] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [109269] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109399] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2629), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(2631), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7482), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(9036), 2,
      sym_preproc_else_in_expression,
      sym_preproc_elif_in_expression,
    STATE(5402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109541] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109673] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(7288), 1,
      anon_sym_QMARK,
    ACTIONS(7294), 1,
      anon_sym_SLASH,
    ACTIONS(7296), 1,
      anon_sym_CARET,
    ACTIONS(7298), 1,
      anon_sym_PIPE,
    ACTIONS(7300), 1,
      anon_sym_AMP,
    ACTIONS(7304), 1,
      anon_sym_GT_GT,
    ACTIONS(7310), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7312), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7314), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7316), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7318), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7286), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7290), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7292), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7306), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7308), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 5,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    STATE(5404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [109809] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7274), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7282), 1,
      anon_sym_as,
    ACTIONS(7284), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [109931] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7335), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7413), 1,
      anon_sym_is,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(5406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110067] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4602), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4604), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110149] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4169), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4178), 29,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [110231] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [110338] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110473] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110608] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110743] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [110874] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111003] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111138] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [111237] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [111358] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [111467] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111590] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [111717] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [111830] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [111937] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7602), 1,
      anon_sym_and,
    ACTIONS(7604), 1,
      anon_sym_or,
    STATE(5423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [112022] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112147] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112274] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(4583), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4453), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(5426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [112363] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112486] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [112595] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [112716] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112845] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [112976] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113111] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7602), 1,
      anon_sym_and,
    ACTIONS(7604), 1,
      anon_sym_or,
    STATE(5433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [113196] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113321] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [113424] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [113531] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [113644] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113779] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [113914] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    STATE(5440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4453), 9,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    ACTIONS(4451), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [113999] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [114098] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [114201] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [114304] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [114403] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [114538] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [114637] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [114736] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [114871] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115006] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115141] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115276] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [115379] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115514] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [115613] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115748] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [115883] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116018] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [116117] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116252] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116387] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116522] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116657] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [116792] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [116891] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117026] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117161] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(6810), 1,
      sym_attribute_target_specifier,
    STATE(7955), 1,
      sym__name,
    STATE(8480), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1067), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [117258] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [117357] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117492] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117627] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117762] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [117897] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [117996] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118131] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118266] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(6806), 1,
      sym_attribute_target_specifier,
    STATE(7955), 1,
      sym__name,
    STATE(8612), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1067), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [118363] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118498] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118633] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118768] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [118903] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119034] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119163] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
  [119284] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119407] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119534] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119669] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(5487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119794] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7630), 1,
      anon_sym_QMARK,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7660), 1,
      anon_sym_as,
    ACTIONS(7662), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_on,
    STATE(5488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [119929] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120064] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [120167] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120302] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120437] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120572] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7600), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7616), 1,
      anon_sym_is,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7738), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [120707] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [120788] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5810), 1,
      anon_sym_LT,
    ACTIONS(7774), 1,
      anon_sym_COLON_COLON,
    STATE(4063), 1,
      sym_type_argument_list,
    STATE(5496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 10,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4140), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [120875] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2985), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2987), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [120956] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3040), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3042), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [121037] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [121146] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [121253] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [121366] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121501] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121636] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121771] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [121906] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122041] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122176] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122311] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [122446] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_into,
    STATE(5534), 1,
      aux_sym__query_body_repeat2,
    STATE(5510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [122531] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7778), 1,
      anon_sym_and,
    ACTIONS(7780), 1,
      anon_sym_or,
    STATE(5511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [122616] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_into,
    STATE(5537), 1,
      aux_sym__query_body_repeat2,
    STATE(5512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [122701] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5902), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5899), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [122784] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5896), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5893), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [122867] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [122980] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [123087] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123212] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123339] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7802), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123462] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [123571] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7802), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [123692] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123821] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [123952] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124087] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124222] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124357] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2985), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2987), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124438] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124573] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7814), 1,
      anon_sym_into,
    STATE(5531), 1,
      aux_sym__query_body_repeat2,
    STATE(5529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124658] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [124793] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7816), 1,
      anon_sym_into,
    STATE(5531), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124876] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7814), 1,
      anon_sym_into,
    STATE(5529), 1,
      aux_sym__query_body_repeat2,
    STATE(5532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [124961] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7814), 1,
      anon_sym_into,
    STATE(5531), 1,
      aux_sym__query_body_repeat2,
    STATE(5533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [125046] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7819), 1,
      anon_sym_into,
    STATE(5534), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [125129] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7814), 1,
      anon_sym_into,
    STATE(5533), 1,
      aux_sym__query_body_repeat2,
    STATE(5535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [125214] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125349] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_into,
    STATE(5534), 1,
      aux_sym__query_body_repeat2,
    STATE(5537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [125434] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125569] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125704] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125839] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [125974] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126109] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126240] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126369] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
  [126490] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126613] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5850), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5848), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [126694] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5858), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5856), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [126775] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [126902] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(5550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127027] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7706), 1,
      anon_sym_QMARK,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7734), 1,
      anon_sym_as,
    ACTIONS(7736), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_equals,
    STATE(5551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127162] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5862), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5860), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127243] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5866), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5864), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127324] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [127459] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5872), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5870), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127540] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5880), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5878), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127621] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5887), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5885), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127702] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5889), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5891), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5889), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127864] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5909), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5907), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [127945] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [128044] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128179] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128314] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [128413] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [128512] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [128647] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [128756] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [128863] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [128976] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129111] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5913), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5911), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129192] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5917), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5915), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129273] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129408] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5925), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5923), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129489] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [129588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [129723] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5933), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129804] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5935), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5933), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [129885] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130020] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5946), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5944), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130101] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130236] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130371] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4320), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130452] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5952), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5950), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130533] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5956), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5954), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [130614] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [130749] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [130862] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [130969] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [131078] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7664), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [131177] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5960), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5958), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131258] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131393] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131528] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [131663] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_and,
    ACTIONS(7852), 1,
      anon_sym_or,
    STATE(5595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131748] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_and,
    ACTIONS(7852), 1,
      anon_sym_or,
    STATE(5596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131833] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5413), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5411), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131914] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5488), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5486), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [131995] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5584), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5582), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [132076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132211] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [132314] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [132427] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5384), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5382), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [132508] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132643] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [132778] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [132881] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133006] = 42,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    ACTIONS(7854), 1,
      anon_sym_COLON,
    ACTIONS(7856), 1,
      anon_sym_COMMA,
    ACTIONS(7858), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8512), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133147] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133274] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133409] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133532] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133667] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133802] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [133937] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134062] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134189] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134312] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [134433] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [134532] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134661] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134792] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [134927] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135062] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135197] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135328] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135463] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135592] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [135691] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [135826] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [135947] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136082] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136217] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [136326] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136461] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136596] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136719] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136846] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [136971] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137106] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137209] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137316] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7778), 1,
      anon_sym_and,
    ACTIONS(7780), 1,
      anon_sym_or,
    STATE(5642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 26,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137401] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7614), 1,
      anon_sym_as,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7792), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7802), 1,
      anon_sym_is,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7860), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 4,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(5643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [137536] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137649] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7778), 1,
      anon_sym_and,
    STATE(5645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [137732] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
  [137853] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5646), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5644), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [137934] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138015] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 20,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [138114] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7862), 1,
      anon_sym_LPAREN,
    STATE(5650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1963), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1965), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138197] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138326] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5508), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5506), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138407] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5429), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5427), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [138488] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(5654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138619] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [138754] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [138867] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [138974] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139055] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5476), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [139136] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139261] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139388] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139511] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [139614] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
  [139735] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139860] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [139989] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(5667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140120] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140255] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140382] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140505] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140640] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [140749] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [140884] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 10,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [141005] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [141104] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141233] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5502), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5500), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [141314] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141449] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_SEMI,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141584] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141715] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141850] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [141985] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5442), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5440), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142066] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5540), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5538), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142147] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(6803), 1,
      sym_attribute_target_specifier,
    STATE(7955), 1,
      sym__name,
    STATE(8641), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1067), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [142244] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5576), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5574), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142325] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5580), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5578), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [142541] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [142676] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5572), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5570), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142757] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5606), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5604), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142838] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2989), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2991), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [142919] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5638), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5636), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143000] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [143135] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4765), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4763), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143216] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5642), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5640), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143297] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5678), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5676), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143378] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5658), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5656), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143459] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5670), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5668), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143540] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5666), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5664), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143621] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [143724] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5454), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5452), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143805] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_into,
    STATE(5704), 1,
      aux_sym__query_body_repeat2,
    STATE(5703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143890] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7866), 1,
      anon_sym_into,
    STATE(5704), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [143973] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5674), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5672), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144054] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_into,
    STATE(5703), 1,
      aux_sym__query_body_repeat2,
    STATE(5706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144139] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_into,
    STATE(5704), 1,
      aux_sym__query_body_repeat2,
    STATE(5707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144224] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [144359] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5614), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5612), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144440] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5662), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5660), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144521] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_into,
    STATE(5707), 1,
      aux_sym__query_body_repeat2,
    STATE(5711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144606] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5654), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5652), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144687] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5650), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5648), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144768] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4218), 1,
      sym_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(9048), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4349), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [144875] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_and,
    STATE(5715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 27,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [144958] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145093] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6309), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145228] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145363] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6414), 1,
      anon_sym_as,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7492), 1,
      anon_sym_QMARK,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7522), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    STATE(5719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145498] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(6816), 1,
      sym_attribute_target_specifier,
    STATE(7955), 1,
      sym__name,
    STATE(8434), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1067), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [145595] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145730] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5626), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5624), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [145811] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [145946] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 20,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [146045] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [146154] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [146261] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7652), 1,
      anon_sym_DOT_DOT,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [146374] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5622), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5620), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146455] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5618), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5616), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146536] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5610), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5608), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146617] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5602), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5600), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146698] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5598), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5596), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146779] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5588), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5586), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146860] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5568), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5566), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [146941] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5446), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5444), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147022] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5564), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5562), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147103] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1969), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(1967), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147184] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147319] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147454] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147589] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5450), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5448), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147670] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5401), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5399), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [147751] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7869), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [147888] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148023] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5532), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5530), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148104] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 16,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [148213] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [148348] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5524), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5522), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148429] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5536), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5534), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148510] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5520), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5518), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148591] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5516), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5514), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148672] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5470), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5468), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148753] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5433), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5431), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148834] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5512), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5510), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [148915] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7180), 1,
      anon_sym_as,
    ACTIONS(7486), 1,
      anon_sym_SLASH,
    ACTIONS(7488), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7824), 1,
      anon_sym_QMARK,
    ACTIONS(7828), 1,
      anon_sym_CARET,
    ACTIONS(7830), 1,
      anon_sym_PIPE,
    ACTIONS(7832), 1,
      anon_sym_AMP,
    ACTIONS(7836), 1,
      anon_sym_GT_GT,
    ACTIONS(7842), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7844), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7846), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7848), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7484), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7822), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7826), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7834), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7838), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7840), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6315), 4,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_into,
    STATE(5755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149050] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5472), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5417), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5415), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149212] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5421), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5419), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149293] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149428] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7602), 1,
      anon_sym_and,
    STATE(5760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149511] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5484), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5482), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149592] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [149727] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5462), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5460), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149808] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5458), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5456), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149889] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5528), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5526), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [149970] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150105] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_into,
    STATE(5510), 1,
      aux_sym__query_body_repeat2,
    STATE(5767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [150190] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150325] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150460] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150595] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150730] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5632), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [150811] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [150946] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5425), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5423), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [151027] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(6819), 1,
      sym_attribute_target_specifier,
    STATE(7955), 1,
      sym__name,
    STATE(8398), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1067), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    STATE(5775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [151124] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5630), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5628), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [151205] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5409), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5407), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [151286] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151421] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2999), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [151502] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5405), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5403), 28,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [151583] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6408), 1,
      anon_sym_switch,
    ACTIONS(6418), 1,
      anon_sym_with,
    ACTIONS(7666), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7742), 1,
      anon_sym_QMARK,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7770), 1,
      anon_sym_as,
    ACTIONS(7772), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    STATE(5781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [151718] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7874), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [151826] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [151928] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_into,
    STATE(5784), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [152010] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152144] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7881), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [152252] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7883), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [152360] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(7887), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8500), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152498] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(7889), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8511), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152636] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7891), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [152744] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [152878] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7929), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153012] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [153110] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153244] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153378] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153508] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153636] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
  [153756] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [153864] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [153986] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154112] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(5802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154236] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [154342] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [154454] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7931), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154722] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [154856] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7933), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [154964] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155098] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7935), 1,
      anon_sym_COMMA,
    ACTIONS(7937), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8540), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155236] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7939), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155504] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155638] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7939), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155772] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [155906] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7941), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [156014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156148] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7943), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156282] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7945), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8552), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156420] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7947), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [156528] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [156640] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156774] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_RPAREN,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7943), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [156910] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [157016] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [157118] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157242] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157368] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157490] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [157598] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [157718] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7971), 1,
      anon_sym_COMMA,
    ACTIONS(7973), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8461), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [157856] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [157954] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158082] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158212] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158346] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158480] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_into,
    STATE(5949), 1,
      aux_sym__query_body_repeat2,
    STATE(5837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [158564] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4431), 10,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_GT,
      anon_sym_EQ_GT,
    ACTIONS(4429), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [158644] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_into,
    STATE(5784), 1,
      aux_sym__query_body_repeat2,
    STATE(5839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [158728] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [158830] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [158964] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159098] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159232] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159366] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [159464] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8023), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [159572] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159706] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8025), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8391), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159844] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [159978] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8027), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8608), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160116] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_into,
    STATE(5839), 1,
      aux_sym__query_body_repeat2,
    STATE(5851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [160200] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [160298] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8029), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8679), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160436] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8031), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [160544] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160678] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160812] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8067), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8588), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [160950] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161084] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161218] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [161316] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(5861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161450] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161584] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161718] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161852] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [161986] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [162094] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162228] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162362] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162496] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [162598] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162732] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8105), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8473), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [162870] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163004] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163138] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163272] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163540] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [163638] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8107), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8660), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163776] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [163910] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(5881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164044] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164178] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8109), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164286] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8111), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8573), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164424] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8113), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [164532] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164666] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [164800] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [164912] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [165018] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165142] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165268] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8139), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [165376] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165498] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [165606] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(8160), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4349), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(5895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [165712] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [165846] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [165944] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8141), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [166052] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_and,
    ACTIONS(8145), 1,
      anon_sym_or,
    STATE(5899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166136] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
  [166256] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166386] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [166484] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8147), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8610), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166622] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8149), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [166884] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8143), 1,
      anon_sym_and,
    STATE(5906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 26,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [166966] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167094] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(5908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167224] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8155), 1,
      anon_sym_and,
    ACTIONS(8157), 1,
      anon_sym_or,
    STATE(5909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [167308] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167442] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167576] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    ACTIONS(8163), 1,
      anon_sym_SEMI,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8429), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [167714] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [167834] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [167942] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168076] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(8169), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8563), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168214] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(5917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5948), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4320), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [168294] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [168392] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168526] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168660] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168794] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [168928] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169062] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169184] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8171), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169318] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4218), 1,
      sym_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4349), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [169424] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8173), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8613), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169562] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8175), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8617), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169700] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(8177), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8661), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169838] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [169972] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8155), 1,
      anon_sym_and,
    ACTIONS(8157), 1,
      anon_sym_or,
    STATE(5931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [170056] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170190] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170324] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_and,
    ACTIONS(8181), 1,
      anon_sym_or,
    STATE(5934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [170408] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170534] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(5936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170668] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170802] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [170936] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8183), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8621), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171074] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8185), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8622), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171212] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(5941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171346] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171470] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [171578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7895), 1,
      anon_sym_QMARK,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7925), 1,
      anon_sym_as,
    ACTIONS(7927), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    STATE(5944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171712] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8189), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8624), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171850] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8191), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [171984] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [172086] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8193), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(5948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_into,
    STATE(5784), 1,
      aux_sym__query_body_repeat2,
    STATE(5949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [172304] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [172412] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172546] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172676] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172804] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [172938] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [173058] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [173170] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8203), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [173278] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173412] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173546] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_into,
    STATE(5965), 1,
      aux_sym__query_body_repeat2,
    STATE(5960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [173630] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173764] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [173898] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174032] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174166] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8207), 1,
      anon_sym_into,
    STATE(5965), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [174248] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174382] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [174490] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174624] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174758] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [174856] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [174990] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8035), 1,
      anon_sym_QMARK,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(5972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175124] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_into,
    STATE(5960), 1,
      aux_sym__query_body_repeat2,
    STATE(5973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [175208] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175330] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8210), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8630), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175468] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175594] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_into,
    STATE(5965), 1,
      aux_sym__query_body_repeat2,
    STATE(5977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [175678] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(5978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [175802] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(5979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [175908] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8099), 1,
      anon_sym_as,
    ACTIONS(8101), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    STATE(5980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176042] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(5981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [176154] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_into,
    STATE(5977), 1,
      aux_sym__query_body_repeat2,
    STATE(5982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [176238] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7917), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(5983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [176336] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8212), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8447), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176474] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8214), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8472), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176612] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(5986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [176720] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8218), 1,
      anon_sym_COMMA,
    ACTIONS(8220), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8543), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176858] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [176992] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8222), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8628), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177130] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8224), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8635), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177268] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_into,
    STATE(5996), 1,
      aux_sym__query_body_repeat2,
    STATE(5991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [177352] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(5992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177486] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7676), 1,
      anon_sym_SLASH,
    ACTIONS(7678), 1,
      anon_sym_CARET,
    ACTIONS(7680), 1,
      anon_sym_PIPE,
    ACTIONS(7682), 1,
      anon_sym_AMP,
    ACTIONS(7686), 1,
      anon_sym_GT_GT,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7694), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7696), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7698), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    ACTIONS(7943), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(7668), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7672), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7674), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7684), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7688), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7690), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177622] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8228), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(5994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [177756] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8230), 1,
      anon_sym_DOT,
    STATE(5995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4482), 27,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [177838] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8232), 1,
      anon_sym_into,
    STATE(5996), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [177920] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8235), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8640), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178058] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8237), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8648), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178196] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8239), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8672), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(5999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178334] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    ACTIONS(5437), 1,
      anon_sym_QMARK,
    ACTIONS(8230), 1,
      anon_sym_DOT,
    STATE(6000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4453), 25,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [178422] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178556] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_into,
    STATE(5991), 1,
      aux_sym__query_body_repeat2,
    STATE(6002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [178640] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8241), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8441), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178778] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(8243), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8695), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [178916] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [179028] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8245), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179162] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    ACTIONS(8247), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6303), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179298] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_into,
    STATE(5996), 1,
      aux_sym__query_body_repeat2,
    STATE(6008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [179382] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8249), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8436), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179520] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8251), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [179628] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8253), 1,
      anon_sym_COMMA,
    ACTIONS(8255), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8396), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179766] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8226), 1,
      anon_sym_into,
    STATE(6008), 1,
      aux_sym__query_body_repeat2,
    STATE(6012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [179850] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [179984] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8285), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8437), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180122] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180256] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [180362] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8287), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [180470] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [180568] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180702] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [180836] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [180942] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181076] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8289), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [181184] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [181286] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181410] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181544] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181670] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181804] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [181938] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [182036] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182158] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182292] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182426] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_into,
    STATE(6035), 1,
      aux_sym__query_body_repeat2,
    STATE(6034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182510] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8293), 1,
      anon_sym_into,
    STATE(6035), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182592] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8296), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8638), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [182730] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_into,
    STATE(6034), 1,
      aux_sym__query_body_repeat2,
    STATE(6037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182814] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_into,
    STATE(6035), 1,
      aux_sym__query_body_repeat2,
    STATE(6038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182898] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8291), 1,
      anon_sym_into,
    STATE(6038), 1,
      aux_sym__query_body_repeat2,
    STATE(6039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [182982] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [183080] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6303), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183214] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8298), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [183322] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7876), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8133), 1,
      anon_sym_as,
    ACTIONS(8135), 1,
      anon_sym_is,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8167), 1,
      anon_sym_QMARK,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    STATE(6043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [183456] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [183558] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [183666] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [183786] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8300), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [183894] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [183992] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8302), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8685), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184130] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8304), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8690), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184268] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6261), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184402] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [184500] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184634] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184762] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5327), 1,
      anon_sym_LBRACK,
    ACTIONS(5937), 1,
      anon_sym_LBRACE,
    ACTIONS(5940), 1,
      anon_sym_QMARK,
    STATE(4274), 1,
      sym_initializer_expression,
    STATE(6055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5337), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5331), 24,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [184850] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8306), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [184984] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185114] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185248] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5423), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185382] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185516] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6214), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185650] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5468), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [185784] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [185896] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186030] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [186136] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5506), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186270] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186394] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186520] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186642] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    STATE(6070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186776] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [186906] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187034] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [187154] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [187262] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187384] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187510] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8065), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187634] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [187740] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8057), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [187852] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5472), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [187986] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [188098] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [188204] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7856), 1,
      anon_sym_COMMA,
    ACTIONS(7858), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8512), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188342] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [188444] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188568] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188694] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [188816] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 15,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [188924] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(8310), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8633), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189062] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5624), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(6090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189196] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [189316] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189444] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 9,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
  [189564] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_into,
    STATE(6095), 1,
      aux_sym__query_body_repeat2,
    STATE(6094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [189648] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_into,
    STATE(6099), 1,
      aux_sym__query_body_repeat2,
    STATE(6095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [189732] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189862] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      sym_interpolation_close_brace,
      anon_sym_COLON,
      anon_sym_COMMA,
    STATE(6097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [189996] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_into,
    STATE(6100), 1,
      aux_sym__query_body_repeat2,
    STATE(6098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190080] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8314), 1,
      anon_sym_into,
    STATE(6099), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190162] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_into,
    STATE(6099), 1,
      aux_sym__query_body_repeat2,
    STATE(6100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190246] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8155), 1,
      anon_sym_and,
    STATE(6101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 26,
      sym_interpolation_close_brace,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [190328] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8317), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [190436] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6130), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190570] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190698] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [190796] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7040), 1,
      anon_sym_as,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(7985), 1,
      anon_sym_QMARK,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8015), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    STATE(6106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [190930] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8319), 1,
      anon_sym_RBRACK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8591), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191068] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 19,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [191166] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8007), 1,
      anon_sym_DOT_DOT,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [191268] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8259), 1,
      anon_sym_QMARK,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6369), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191402] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8321), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [191510] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8179), 1,
      anon_sym_and,
    STATE(6112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [191592] = 41,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8323), 1,
      anon_sym_COMMA,
    ACTIONS(8325), 1,
      anon_sym_RBRACE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    STATE(8527), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191730] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(8327), 1,
      anon_sym_RPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7787), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [191838] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [191968] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(7030), 1,
      anon_sym_switch,
    ACTIONS(7044), 1,
      anon_sym_with,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8201), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8281), 1,
      anon_sym_as,
    ACTIONS(8283), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    STATE(6116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192102] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7156), 1,
      anon_sym_switch,
    ACTIONS(7160), 1,
      anon_sym_with,
    ACTIONS(7214), 1,
      anon_sym_QMARK,
    ACTIONS(7220), 1,
      anon_sym_SLASH,
    ACTIONS(7222), 1,
      anon_sym_CARET,
    ACTIONS(7224), 1,
      anon_sym_PIPE,
    ACTIONS(7226), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_GT,
    ACTIONS(7236), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7242), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7244), 1,
      anon_sym_as,
    ACTIONS(7246), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7216), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7218), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7228), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7232), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7234), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8329), 2,
      sym_interpolation_close_brace,
      anon_sym_COLON,
    STATE(6117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192235] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6303), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192368] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192491] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192616] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6261), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192749] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [192870] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193003] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193122] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193255] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5472), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193388] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8228), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193521] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193650] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6180), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [193783] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [193864] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4799), 4,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5476), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [193945] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8308), 1,
      anon_sym_COMMA,
    ACTIONS(8401), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194080] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6261), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194213] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5624), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194346] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5472), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194479] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5423), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194612] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6214), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [194745] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(7966), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [194840] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_and,
    STATE(6139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [194921] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6309), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195054] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6303), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195187] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5468), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195320] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_LBRACK,
    ACTIONS(4544), 1,
      anon_sym_STAR,
    ACTIONS(5882), 1,
      anon_sym_QMARK,
    ACTIONS(8455), 1,
      anon_sym_DOT,
    STATE(6143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4453), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [195407] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5518), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195540] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5506), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195673] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8455), 1,
      anon_sym_DOT,
    STATE(6146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 10,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(4482), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [195754] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [195851] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
    STATE(6148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [195978] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8105), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [196073] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8457), 1,
      anon_sym_and,
    STATE(6150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [196154] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5893), 1,
      anon_sym_COLON,
    ACTIONS(4799), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [196237] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_and,
    ACTIONS(8461), 1,
      anon_sym_or,
    STATE(6152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [196320] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(7959), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [196415] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196548] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [196681] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [196778] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8004), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [196873] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_COLON,
    ACTIONS(4799), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5478), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5476), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [196956] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8457), 1,
      anon_sym_and,
    ACTIONS(8463), 1,
      anon_sym_or,
    STATE(6159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [197039] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8457), 1,
      anon_sym_and,
    ACTIONS(8463), 1,
      anon_sym_or,
    STATE(6160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [197122] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8308), 1,
      anon_sym_COMMA,
    ACTIONS(8465), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197257] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5624), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197390] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197517] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5423), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197650] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8467), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [197783] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8469), 1,
      anon_sym_and,
    ACTIONS(8471), 1,
      anon_sym_or,
    STATE(6166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [197866] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4349), 1,
      anon_sym_COLON,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4218), 1,
      sym_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6687), 1,
      sym_positional_pattern_clause,
    STATE(6759), 1,
      sym_property_pattern_clause,
    STATE(9048), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [197971] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6214), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198104] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6180), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198237] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198366] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [198467] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198586] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [198693] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198814] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [198939] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
    STATE(6176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199062] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8473), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199195] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [199300] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [199411] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8475), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199544] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199677] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5468), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199810] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8477), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [199943] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5518), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200076] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5506), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200209] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8479), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200342] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5506), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200475] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5518), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200608] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5468), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200741] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6214), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [200874] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5423), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201007] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8481), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201140] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_and,
    ACTIONS(8485), 1,
      anon_sym_or,
    STATE(6193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [201223] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8487), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201356] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5472), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201489] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_and,
    STATE(6196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [201570] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5624), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201703] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6261), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [201836] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [201933] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8421), 1,
      anon_sym_QMARK,
    ACTIONS(8427), 1,
      anon_sym_SLASH,
    ACTIONS(8429), 1,
      anon_sym_CARET,
    ACTIONS(8431), 1,
      anon_sym_PIPE,
    ACTIONS(8433), 1,
      anon_sym_AMP,
    ACTIONS(8437), 1,
      anon_sym_GT_GT,
    ACTIONS(8443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8445), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8447), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8449), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8451), 1,
      anon_sym_as,
    ACTIONS(8453), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6303), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(8419), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8423), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8425), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8435), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202066] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [202177] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [202282] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [202383] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6309), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202516] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7944), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [202611] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202734] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202859] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [202980] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [203087] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8020), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [203182] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203301] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203428] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
    STATE(6213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203557] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6180), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203690] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8068), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [203785] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8306), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [203918] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8061), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204013] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8060), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204108] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8040), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204203] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8477), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204336] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204469] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8043), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [204564] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [204697] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [204794] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [204891] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8479), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205024] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8047), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [205119] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8531), 1,
      anon_sym_and,
    ACTIONS(8533), 1,
      anon_sym_or,
    STATE(6228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [205202] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6180), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205335] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8535), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205468] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8153), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [205563] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5362), 1,
      anon_sym_LPAREN,
    ACTIONS(8537), 1,
      anon_sym_LBRACK,
    STATE(6722), 1,
      sym_attribute_list,
    STATE(6232), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat1,
    ACTIONS(5357), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [205646] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205775] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7943), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [205908] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206035] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 8,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206154] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [206261] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8165), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [206356] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206477] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206602] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 6,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
    STATE(6241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [206725] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [206826] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [206931] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [207042] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8167), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [207137] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8171), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [207232] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8308), 1,
      anon_sym_COMMA,
    ACTIONS(8540), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207367] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8483), 1,
      anon_sym_and,
    ACTIONS(8485), 1,
      anon_sym_or,
    STATE(6248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [207450] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(4482), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(6249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [207531] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8544), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207664] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 12,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [207775] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5506), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [207908] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5518), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208041] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5468), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208174] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6214), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208307] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5423), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208440] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5472), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208573] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5624), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [208706] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_and,
    ACTIONS(8461), 1,
      anon_sym_or,
    STATE(6259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [208789] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8101), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [208884] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6261), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209017] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8546), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209150] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8093), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [209245] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8548), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209378] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [209475] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8417), 1,
      anon_sym_and,
    ACTIONS(8550), 1,
      anon_sym_or,
    STATE(6266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [209558] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8491), 1,
      anon_sym_QMARK,
    ACTIONS(8497), 1,
      anon_sym_SLASH,
    ACTIONS(8499), 1,
      anon_sym_CARET,
    ACTIONS(8501), 1,
      anon_sym_PIPE,
    ACTIONS(8503), 1,
      anon_sym_AMP,
    ACTIONS(8507), 1,
      anon_sym_GT_GT,
    ACTIONS(8513), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8519), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8521), 1,
      anon_sym_as,
    ACTIONS(8523), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6303), 2,
      anon_sym_into,
      anon_sym_equals,
    ACTIONS(8489), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8493), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8505), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8509), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8511), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209691] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4349), 1,
      anon_sym_EQ_GT,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8552), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(5917), 1,
      sym_identifier,
    STATE(6687), 1,
      sym_positional_pattern_clause,
    STATE(6759), 1,
      sym_property_pattern_clause,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [209796] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7670), 1,
      anon_sym_QMARK,
    ACTIONS(7692), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7702), 1,
      anon_sym_is,
    ACTIONS(7854), 1,
      anon_sym_COLON,
    ACTIONS(8308), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [209931] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(8554), 1,
      anon_sym_DOT,
    ACTIONS(4453), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [210020] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [210117] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210250] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8109), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [210345] = 40,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8308), 1,
      anon_sym_COMMA,
    ACTIONS(8556), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210480] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8469), 1,
      anon_sym_and,
    STATE(6275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [210561] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4349), 1,
      anon_sym_COMMA,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6299), 1,
      sym_positional_pattern_clause,
    STATE(6708), 1,
      sym_property_pattern_clause,
    STATE(7879), 1,
      sym_identifier,
    STATE(9048), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(6276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [210666] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8487), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210799] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6315), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [210932] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(7979), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211027] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(141), 1,
      anon_sym_SQUOTE,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      anon_sym_BANG,
    ACTIONS(8529), 1,
      sym_integer_literal,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8224), 1,
      sym__preproc_expression,
    ACTIONS(75), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8144), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211122] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8215), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211217] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7953), 1,
      anon_sym_SLASH,
    ACTIONS(7957), 1,
      anon_sym_GT_GT,
    ACTIONS(7959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7969), 1,
      anon_sym_CARET,
    ACTIONS(7975), 1,
      anon_sym_PIPE,
    ACTIONS(7977), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7979), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7981), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8021), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7949), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7951), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7955), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7961), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7965), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7967), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8481), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(6282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211350] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4349), 1,
      anon_sym_COLON,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(7463), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4218), 1,
      sym_identifier,
    STATE(4219), 1,
      sym__variable_designation,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6687), 1,
      sym_positional_pattern_clause,
    STATE(6759), 1,
      sym_property_pattern_clause,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4347), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211455] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(7949), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [211550] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8531), 1,
      anon_sym_and,
    STATE(6285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [211631] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(8558), 1,
      anon_sym_DOT,
    ACTIONS(4453), 6,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
    STATE(6286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [211720] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8531), 1,
      anon_sym_and,
    ACTIONS(8533), 1,
      anon_sym_or,
    STATE(6287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [211803] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8560), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [211936] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8367), 1,
      anon_sym_QMARK,
    ACTIONS(8373), 1,
      anon_sym_SLASH,
    ACTIONS(8375), 1,
      anon_sym_CARET,
    ACTIONS(8377), 1,
      anon_sym_PIPE,
    ACTIONS(8379), 1,
      anon_sym_AMP,
    ACTIONS(8383), 1,
      anon_sym_GT_GT,
    ACTIONS(8389), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8391), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8393), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8395), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8397), 1,
      anon_sym_as,
    ACTIONS(8399), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6309), 2,
      anon_sym_into,
      anon_sym_on,
    ACTIONS(8365), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8369), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8371), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8381), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8385), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8387), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212069] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_SEMI,
    STATE(6290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
  [212150] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8179), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212245] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4214), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6707), 1,
      sym_property_pattern_clause,
    ACTIONS(4397), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4395), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212344] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8459), 1,
      anon_sym_and,
    STATE(6293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 25,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [212425] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8177), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212520] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8245), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212653] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8147), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212748] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(8407), 1,
      anon_sym_LPAREN,
    ACTIONS(8409), 1,
      anon_sym_BANG,
    ACTIONS(8413), 1,
      anon_sym_SQUOTE,
    ACTIONS(8415), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8079), 1,
      sym__preproc_expression,
    ACTIONS(8411), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(8115), 6,
      sym_character_literal,
      sym_boolean_literal,
      sym_identifier,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    STATE(6297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [212843] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8566), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(6298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [212976] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4195), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6693), 1,
      sym_property_pattern_clause,
    ACTIONS(4405), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4403), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [213075] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 18,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [213172] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [213279] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 16,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [213380] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(6827), 1,
      anon_sym_as,
    ACTIONS(8333), 1,
      anon_sym_QMARK,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8341), 1,
      anon_sym_CARET,
    ACTIONS(8343), 1,
      anon_sym_PIPE,
    ACTIONS(8345), 1,
      anon_sym_AMP,
    ACTIONS(8349), 1,
      anon_sym_GT_GT,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8357), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8359), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8361), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8363), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6309), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(8331), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8335), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8347), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8351), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8353), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213513] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6757), 1,
      anon_sym_switch,
    ACTIONS(6771), 1,
      anon_sym_with,
    ACTIONS(8339), 1,
      anon_sym_SLASH,
    ACTIONS(8355), 1,
      anon_sym_DOT_DOT,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8337), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 14,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_into,
      anon_sym_as,
      anon_sym_is,
  [213618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_SEMI,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213750] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [213868] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_and,
    ACTIONS(8588), 1,
      anon_sym_or,
    STATE(6307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [213950] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8590), 1,
      anon_sym_COLON,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214082] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8658), 1,
      anon_sym_by,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214214] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8664), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214346] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8666), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214478] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [214574] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214706] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214838] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8684), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [214970] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8686), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215102] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8688), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215234] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215366] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215498] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8690), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215630] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8692), 1,
      anon_sym_and,
    STATE(6321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [215710] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8694), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [215974] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8696), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216106] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    ACTIONS(8700), 1,
      anon_sym_operator,
    ACTIONS(8702), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7261), 1,
      sym_explicit_interface_specifier,
    STATE(7501), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [216206] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_COLON,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216338] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216470] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8706), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216602] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8708), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216734] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_COLON,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216866] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [216998] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_by,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217130] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8710), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217262] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8712), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217394] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217526] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8716), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217658] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8718), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217790] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8720), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [217922] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [218032] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8734), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218164] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8736), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218296] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8738), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218428] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8740), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218560] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8742), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218692] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8744), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218824] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [218956] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8746), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219088] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8748), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219220] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8750), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219352] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8752), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219484] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8754), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219616] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8756), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219748] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    ACTIONS(8758), 1,
      anon_sym_operator,
    ACTIONS(8760), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7225), 1,
      sym_explicit_interface_specifier,
    STATE(7502), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [219848] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8762), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [219980] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [220084] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [220184] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8764), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220316] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8766), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220448] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220580] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8770), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220712] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220834] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [220958] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221078] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8786), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221210] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8788), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221342] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8790), 1,
      anon_sym_and,
    ACTIONS(8792), 1,
      anon_sym_or,
    STATE(6366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [221424] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8794), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221556] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8796), 1,
      anon_sym_RPAREN,
    STATE(6368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [221636] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8798), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221768] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_COLON,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [221900] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_equals,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222032] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
  [222138] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8790), 1,
      anon_sym_and,
    ACTIONS(8792), 1,
      anon_sym_or,
    STATE(6373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [222220] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_COLON,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222352] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222480] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222606] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [222702] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [222820] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [222926] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223046] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223170] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8692), 1,
      anon_sym_and,
    ACTIONS(8810), 1,
      anon_sym_or,
    STATE(6382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [223252] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223374] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [223474] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [223578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8812), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [223710] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LBRACE,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(8554), 1,
      anon_sym_DOT,
    ACTIONS(8817), 1,
      anon_sym_LPAREN,
    STATE(8927), 1,
      sym_attribute_argument_list,
    ACTIONS(8814), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [223804] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_COLON,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [223914] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8820), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224046] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8822), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224178] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym_into,
    STATE(6400), 1,
      aux_sym__query_body_repeat2,
    STATE(6391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [224260] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8826), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224392] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym_into,
    STATE(6407), 1,
      aux_sym__query_body_repeat2,
    STATE(6393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [224474] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8828), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224606] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224724] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [224808] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [224940] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8832), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225072] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8692), 1,
      anon_sym_and,
    ACTIONS(8810), 1,
      anon_sym_or,
    STATE(6399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [225154] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8834), 1,
      anon_sym_into,
    STATE(6400), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [225234] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [225330] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225456] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_equals,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225588] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8837), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225720] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8839), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225852] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8841), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [225984] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym_into,
    STATE(6400), 1,
      aux_sym__query_body_repeat2,
    STATE(6407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [226066] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8843), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226198] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2033), 1,
      anon_sym_SEMI,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226330] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [226426] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [226522] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_COLON,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226654] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8845), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226786] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8847), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [226918] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8849), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227050] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
    STATE(6416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227178] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8851), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227310] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8853), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227442] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    ACTIONS(8855), 1,
      anon_sym_operator,
    ACTIONS(8857), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7205), 1,
      sym_explicit_interface_specifier,
    STATE(7503), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [227542] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8859), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227674] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8861), 1,
      anon_sym_and,
    ACTIONS(8863), 1,
      anon_sym_or,
    STATE(6421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [227756] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8865), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [227888] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8867), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228020] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_and,
    ACTIONS(8871), 1,
      anon_sym_or,
    STATE(6424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228102] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_equals,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228234] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8873), 1,
      anon_sym_RPAREN,
    STATE(6426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228314] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8875), 1,
      anon_sym_into,
    STATE(6498), 1,
      aux_sym__query_body_repeat2,
    STATE(6427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [228396] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8877), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228528] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228660] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8879), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228792] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8881), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [228924] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8883), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229056] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_and,
    ACTIONS(8871), 1,
      anon_sym_or,
    STATE(6433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [229138] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8885), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229270] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8887), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229402] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8889), 1,
      anon_sym_RPAREN,
    STATE(6436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [229482] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_equals,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229614] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1959), 1,
      anon_sym_SEMI,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229746] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [229878] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8891), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230010] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8893), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230142] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230274] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8895), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230406] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8897), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230538] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8899), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230670] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230802] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8901), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [230934] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8903), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231066] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_on,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231198] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [231294] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8941), 1,
      anon_sym_into,
    STATE(6507), 1,
      aux_sym__query_body_repeat2,
    STATE(6451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [231376] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8943), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231508] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8945), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231640] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8861), 1,
      anon_sym_and,
    ACTIONS(8863), 1,
      anon_sym_or,
    STATE(6454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [231722] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8947), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231854] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(8949), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [231986] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [232082] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8951), 1,
      anon_sym_RPAREN,
    STATE(6458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [232162] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8941), 1,
      anon_sym_into,
    STATE(6544), 1,
      aux_sym__query_body_repeat2,
    STATE(6459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [232244] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8953), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232376] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8955), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232508] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232640] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(8957), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232772] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8959), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [232904] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [233000] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(8961), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233132] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8963), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233264] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8965), 1,
      anon_sym_SEMI,
    STATE(6468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 24,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [233344] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8967), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233476] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4086), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(3991), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(6470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4089), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [233556] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_EQ_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233688] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9003), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [233820] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(1227), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(1225), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [233916] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9005), 1,
      anon_sym_DOT,
    ACTIONS(4453), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [234004] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9007), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234136] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9009), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234268] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8875), 1,
      anon_sym_into,
    STATE(6478), 1,
      aux_sym__query_body_repeat2,
    STATE(6477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [234350] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9011), 1,
      anon_sym_into,
    STATE(6478), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [234430] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9014), 1,
      anon_sym_and,
    ACTIONS(9016), 1,
      anon_sym_or,
    STATE(6479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [234512] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [234618] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9018), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234750] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [234882] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9020), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235014] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9022), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235146] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9024), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235278] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9026), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235410] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_in,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [235510] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9028), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235642] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9030), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235774] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9032), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [235906] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [236010] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_EQ_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236142] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9034), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236274] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9036), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236406] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9038), 1,
      anon_sym_RPAREN,
    STATE(6495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5296), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5294), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [236486] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8875), 1,
      anon_sym_into,
    STATE(6477), 1,
      aux_sym__query_body_repeat2,
    STATE(6496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [236568] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [236678] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8875), 1,
      anon_sym_into,
    STATE(6478), 1,
      aux_sym__query_body_repeat2,
    STATE(6498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [236760] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9040), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [236892] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9042), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237024] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9044), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237156] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9046), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237288] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9014), 1,
      anon_sym_and,
    ACTIONS(9016), 1,
      anon_sym_or,
    STATE(6503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5931), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5929), 23,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [237370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9048), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237502] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9050), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237634] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237766] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9052), 1,
      anon_sym_into,
    STATE(6507), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [237846] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9055), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [237978] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [238088] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238220] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9057), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238352] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [238456] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [238556] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238678] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238802] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [238922] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
  [239028] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239146] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9059), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239278] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [239374] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239500] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_by,
    STATE(6522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239628] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_by,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239760] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [239892] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_EQ_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240024] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9061), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240156] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240288] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9063), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240420] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_EQ_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240552] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240684] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [240788] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9065), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [240920] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [241020] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9067), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241152] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9069), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241284] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241416] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241538] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [241648] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9071), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241780] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [241904] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9073), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242036] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9075), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242168] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9077), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242300] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8941), 1,
      anon_sym_into,
    STATE(6507), 1,
      aux_sym__query_body_repeat2,
    STATE(6544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [242382] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9079), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242514] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242646] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9081), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242778] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_EQ_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [242910] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243042] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_EQ_GT,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243174] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_EQ_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243302] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_and,
    ACTIONS(8588), 1,
      anon_sym_or,
    STATE(6552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6634), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6632), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [243384] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9014), 1,
      anon_sym_and,
    STATE(6553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [243464] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243590] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9083), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243722] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(7854), 1,
      anon_sym_COLON,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243854] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_equals,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [243986] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9085), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244118] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [244214] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244346] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244464] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9087), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244596] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244716] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [244822] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [244942] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9089), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245074] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_by,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245206] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245338] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_by,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245470] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8790), 1,
      anon_sym_and,
    STATE(6570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [245550] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245674] = 26,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
  [245780] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [245912] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(9001), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 5,
      anon_sym_CARET,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246034] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246166] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6182), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6180), 15,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [246266] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6182), 8,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    STATE(6577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 13,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [246370] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_by,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246502] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9091), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246634] = 28,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6182), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    STATE(6580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6180), 11,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
  [246744] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9093), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [246876] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9095), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247008] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9097), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247140] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247272] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_equals,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247404] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9099), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247536] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9101), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247668] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9103), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247800] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9105), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [247932] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9107), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248064] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9109), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248196] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9111), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248328] = 32,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 7,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248446] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8726), 1,
      anon_sym_SLASH,
    ACTIONS(8730), 1,
      anon_sym_GT_GT,
    ACTIONS(8732), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8774), 1,
      anon_sym_AMP,
    ACTIONS(8780), 1,
      anon_sym_as,
    ACTIONS(8782), 1,
      anon_sym_is,
    ACTIONS(8784), 1,
      anon_sym_CARET,
    ACTIONS(8800), 1,
      anon_sym_QMARK,
    ACTIONS(8802), 1,
      anon_sym_PIPE,
    ACTIONS(8804), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8806), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8808), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9113), 1,
      anon_sym_equals,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8722), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8724), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8728), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8772), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8776), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8778), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9115), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248710] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9117), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9119), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [248974] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9121), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249106] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(6599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6331), 9,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
    ACTIONS(6329), 17,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_with,
  [249202] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9123), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249334] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9125), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249466] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6130), 1,
      anon_sym_in,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249598] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9127), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249730] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9129), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249862] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9131), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [249994] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9133), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250126] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9135), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250258] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 4,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250384] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    ACTIONS(9137), 1,
      anon_sym_on,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250516] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9139), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250648] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9141), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250780] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9143), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [250912] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(9145), 1,
      aux_sym_preproc_if_token3,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251044] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9147), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251176] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9149), 1,
      anon_sym_into,
    STATE(6672), 1,
      aux_sym__query_body_repeat2,
    STATE(6615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [251258] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    ACTIONS(9151), 1,
      anon_sym_on,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251390] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9153), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251522] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9155), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251654] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9157), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251786] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6303), 1,
      anon_sym_on,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [251918] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9159), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252050] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9161), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252182] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9163), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252314] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9165), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252446] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_on,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252578] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_COLON,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252710] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9167), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252842] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9169), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [252974] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9171), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253106] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9173), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253238] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym_into,
    STATE(6391), 1,
      aux_sym__query_body_repeat2,
    STATE(6631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [253320] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9175), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253452] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9177), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253584] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9179), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253716] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2071), 1,
      anon_sym_SEMI,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253848] = 34,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6180), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [253970] = 35,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6182), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6180), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254094] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8869), 1,
      anon_sym_and,
    STATE(6638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [254174] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9181), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254306] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_and,
    STATE(6640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [254386] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9183), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254518] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8941), 1,
      anon_sym_into,
    STATE(6451), 1,
      aux_sym__query_body_repeat2,
    STATE(6642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6468), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6466), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_equals,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [254600] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9048), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4431), 6,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [254686] = 33,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6182), 3,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6180), 5,
      anon_sym_in,
      anon_sym_CARET,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254806] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6180), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_on,
    STATE(6645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [254934] = 36,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6180), 4,
      anon_sym_in,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255060] = 37,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6180), 3,
      anon_sym_in,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
    STATE(6647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255188] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_in,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255320] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_on,
    ACTIONS(6182), 1,
      anon_sym_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255452] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9185), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255584] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    ACTIONS(9187), 1,
      anon_sym_by,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255716] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9189), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255848] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7700), 1,
      anon_sym_as,
    ACTIONS(8594), 1,
      anon_sym_QMARK,
    ACTIONS(8600), 1,
      anon_sym_SLASH,
    ACTIONS(8602), 1,
      anon_sym_CARET,
    ACTIONS(8604), 1,
      anon_sym_PIPE,
    ACTIONS(8606), 1,
      anon_sym_AMP,
    ACTIONS(8610), 1,
      anon_sym_GT_GT,
    ACTIONS(8616), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8618), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8620), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8622), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8624), 1,
      anon_sym_is,
    ACTIONS(9191), 1,
      anon_sym_COLON,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8596), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8598), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8608), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8612), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8614), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [255980] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6261), 1,
      anon_sym_by,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8628), 1,
      anon_sym_QMARK,
    ACTIONS(8634), 1,
      anon_sym_SLASH,
    ACTIONS(8636), 1,
      anon_sym_CARET,
    ACTIONS(8638), 1,
      anon_sym_PIPE,
    ACTIONS(8640), 1,
      anon_sym_AMP,
    ACTIONS(8644), 1,
      anon_sym_GT_GT,
    ACTIONS(8650), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8652), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8654), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8656), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8660), 1,
      anon_sym_as,
    ACTIONS(8662), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8626), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8630), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8632), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8646), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8648), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256112] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256244] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5506), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256376] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5518), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256508] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5468), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256640] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9193), 1,
      anon_sym_COMMA,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256772] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9195), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [256904] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6214), 1,
      anon_sym_on,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257036] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9197), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257168] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9199), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257300] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9149), 1,
      anon_sym_into,
    STATE(6668), 1,
      aux_sym__query_body_repeat2,
    STATE(6664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6497), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [257382] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9201), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257514] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257646] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8971), 1,
      anon_sym_QMARK,
    ACTIONS(8977), 1,
      anon_sym_SLASH,
    ACTIONS(8979), 1,
      anon_sym_CARET,
    ACTIONS(8981), 1,
      anon_sym_PIPE,
    ACTIONS(8983), 1,
      anon_sym_AMP,
    ACTIONS(8987), 1,
      anon_sym_GT_GT,
    ACTIONS(8993), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8995), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8997), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8999), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9001), 1,
      anon_sym_is,
    ACTIONS(9165), 1,
      anon_sym_EQ_GT,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8969), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8973), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8975), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8985), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8989), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8991), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [257778] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9203), 1,
      anon_sym_into,
    STATE(6668), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat2,
    ACTIONS(6486), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6484), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [257858] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8861), 1,
      anon_sym_and,
    STATE(6669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6647), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6645), 24,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_or,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [257938] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258070] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9149), 1,
      anon_sym_into,
    STATE(6664), 1,
      aux_sym__query_body_repeat2,
    STATE(6671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [258152] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9149), 1,
      anon_sym_into,
    STATE(6668), 1,
      aux_sym__query_body_repeat2,
    STATE(6672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(6474), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6472), 23,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [258234] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5472), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258366] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9206), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258498] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9208), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258630] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9210), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258762] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9212), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [258894] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7562), 1,
      anon_sym_SLASH,
    ACTIONS(7564), 1,
      anon_sym_CARET,
    ACTIONS(7566), 1,
      anon_sym_PIPE,
    ACTIONS(7568), 1,
      anon_sym_AMP,
    ACTIONS(7572), 1,
      anon_sym_GT_GT,
    ACTIONS(7578), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7580), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7582), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7584), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7586), 1,
      anon_sym_is,
    ACTIONS(7588), 1,
      anon_sym_QMARK,
    ACTIONS(9214), 1,
      anon_sym_RPAREN,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7558), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7560), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7570), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7574), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7576), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259026] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(9216), 1,
      anon_sym_in,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259158] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5423), 1,
      anon_sym_in,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(8574), 1,
      anon_sym_SLASH,
    ACTIONS(8578), 1,
      anon_sym_GT_GT,
    ACTIONS(8582), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8584), 1,
      anon_sym_is,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_CARET,
    ACTIONS(8672), 1,
      anon_sym_PIPE,
    ACTIONS(8674), 1,
      anon_sym_AMP,
    ACTIONS(8678), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8680), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8682), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8570), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8572), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8576), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8580), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8676), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(6680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259290] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7526), 1,
      anon_sym_QMARK,
    ACTIONS(7532), 1,
      anon_sym_SLASH,
    ACTIONS(7534), 1,
      anon_sym_CARET,
    ACTIONS(7536), 1,
      anon_sym_PIPE,
    ACTIONS(7538), 1,
      anon_sym_AMP,
    ACTIONS(7542), 1,
      anon_sym_GT_GT,
    ACTIONS(7548), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7552), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7554), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8247), 1,
      anon_sym_SEMI,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7524), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7528), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7530), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7540), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7544), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7546), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259422] = 39,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5624), 1,
      anon_sym_on,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(8907), 1,
      anon_sym_QMARK,
    ACTIONS(8913), 1,
      anon_sym_SLASH,
    ACTIONS(8915), 1,
      anon_sym_CARET,
    ACTIONS(8917), 1,
      anon_sym_PIPE,
    ACTIONS(8919), 1,
      anon_sym_AMP,
    ACTIONS(8923), 1,
      anon_sym_GT_GT,
    ACTIONS(8929), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8931), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8933), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8935), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(8937), 1,
      anon_sym_as,
    ACTIONS(8939), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8905), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8909), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8911), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8921), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8925), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8927), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259554] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6144), 1,
      anon_sym_SLASH,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6154), 1,
      anon_sym_GT_GT,
    ACTIONS(6166), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6168), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6170), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6132), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6140), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6142), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6156), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6158), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259683] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7150), 1,
      anon_sym_SLASH,
    ACTIONS(7154), 1,
      anon_sym_GT_GT,
    ACTIONS(7164), 1,
      anon_sym_CARET,
    ACTIONS(7166), 1,
      anon_sym_PIPE,
    ACTIONS(7168), 1,
      anon_sym_AMP,
    ACTIONS(7174), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7176), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7178), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7146), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7148), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7162), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7170), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7172), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [259812] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5703), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5701), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [259889] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7048), 1,
      anon_sym_LPAREN,
    ACTIONS(7142), 1,
      anon_sym_BANG,
    ACTIONS(7341), 1,
      anon_sym_SLASH,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7407), 1,
      anon_sym_GT_GT,
    ACTIONS(7417), 1,
      anon_sym_CARET,
    ACTIONS(7419), 1,
      anon_sym_PIPE,
    ACTIONS(7421), 1,
      anon_sym_AMP,
    ACTIONS(7423), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7427), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(5686), 1,
      sym_argument_list,
    ACTIONS(7144), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7337), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7339), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7403), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7405), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7409), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7411), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260018] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4195), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6765), 1,
      sym_property_pattern_clause,
    ACTIONS(4403), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4405), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [260115] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4431), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260200] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6850), 1,
      anon_sym_SLASH,
    ACTIONS(6852), 1,
      anon_sym_CARET,
    ACTIONS(6854), 1,
      anon_sym_PIPE,
    ACTIONS(6856), 1,
      anon_sym_AMP,
    ACTIONS(6860), 1,
      anon_sym_GT_GT,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6872), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6874), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6842), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6846), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6848), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6858), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6862), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6864), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260329] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5705), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260406] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260535] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7786), 1,
      anon_sym_SLASH,
    ACTIONS(7790), 1,
      anon_sym_GT_GT,
    ACTIONS(7796), 1,
      anon_sym_AMP,
    ACTIONS(7804), 1,
      anon_sym_CARET,
    ACTIONS(7806), 1,
      anon_sym_PIPE,
    ACTIONS(7808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7810), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7812), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7782), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7784), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7788), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7794), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7798), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7800), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [260664] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4107), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4435), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4433), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [260757] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9218), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(9220), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(4140), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260846] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9222), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [260933] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7498), 1,
      anon_sym_SLASH,
    ACTIONS(7500), 1,
      anon_sym_CARET,
    ACTIONS(7502), 1,
      anon_sym_PIPE,
    ACTIONS(7504), 1,
      anon_sym_AMP,
    ACTIONS(7508), 1,
      anon_sym_GT_GT,
    ACTIONS(7516), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7518), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7520), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7490), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7496), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7506), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7510), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7512), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261062] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9224), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [261149] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9226), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [261236] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6392), 1,
      anon_sym_SLASH,
    ACTIONS(6394), 1,
      anon_sym_CARET,
    ACTIONS(6396), 1,
      anon_sym_PIPE,
    ACTIONS(6398), 1,
      anon_sym_AMP,
    ACTIONS(6402), 1,
      anon_sym_GT_GT,
    ACTIONS(6412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6420), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6422), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6386), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6390), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6400), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6404), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6406), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261365] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7258), 1,
      anon_sym_SLASH,
    ACTIONS(7260), 1,
      anon_sym_CARET,
    ACTIONS(7262), 1,
      anon_sym_PIPE,
    ACTIONS(7264), 1,
      anon_sym_AMP,
    ACTIONS(7268), 1,
      anon_sym_GT_GT,
    ACTIONS(7276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7278), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7280), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7250), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7254), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7256), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7266), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7270), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7272), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261494] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6128), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3579), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261623] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7636), 1,
      anon_sym_SLASH,
    ACTIONS(7638), 1,
      anon_sym_CARET,
    ACTIONS(7640), 1,
      anon_sym_PIPE,
    ACTIONS(7642), 1,
      anon_sym_AMP,
    ACTIONS(7646), 1,
      anon_sym_GT_GT,
    ACTIONS(7654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7656), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7658), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7628), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7632), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7634), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7644), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7648), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7650), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261752] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7014), 1,
      anon_sym_SLASH,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_PIPE,
    ACTIONS(7020), 1,
      anon_sym_AMP,
    ACTIONS(7024), 1,
      anon_sym_GT_GT,
    ACTIONS(7034), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7036), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7038), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7006), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7010), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7012), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7026), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7028), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [261881] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7712), 1,
      anon_sym_SLASH,
    ACTIONS(7714), 1,
      anon_sym_CARET,
    ACTIONS(7716), 1,
      anon_sym_PIPE,
    ACTIONS(7718), 1,
      anon_sym_AMP,
    ACTIONS(7722), 1,
      anon_sym_GT_GT,
    ACTIONS(7728), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7730), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7732), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7704), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7708), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7710), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7720), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7724), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7726), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262010] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7594), 1,
      anon_sym_SLASH,
    ACTIONS(7598), 1,
      anon_sym_GT_GT,
    ACTIONS(7608), 1,
      anon_sym_AMP,
    ACTIONS(7618), 1,
      anon_sym_CARET,
    ACTIONS(7620), 1,
      anon_sym_PIPE,
    ACTIONS(7622), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7624), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7626), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7590), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7592), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7596), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7606), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7612), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262139] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7327), 1,
      anon_sym_SLASH,
    ACTIONS(7333), 1,
      anon_sym_GT_GT,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7433), 1,
      anon_sym_CARET,
    ACTIONS(7435), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7443), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7445), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7447), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7323), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7325), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7331), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7429), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7439), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7441), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262268] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4201), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4445), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4443), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [262361] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4197), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4405), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4403), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [262454] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7991), 1,
      anon_sym_SLASH,
    ACTIONS(7993), 1,
      anon_sym_CARET,
    ACTIONS(7995), 1,
      anon_sym_PIPE,
    ACTIONS(7997), 1,
      anon_sym_AMP,
    ACTIONS(8001), 1,
      anon_sym_GT_GT,
    ACTIONS(8009), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8011), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8013), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7983), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7987), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7989), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7999), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8003), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8005), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262583] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(8041), 1,
      anon_sym_SLASH,
    ACTIONS(8043), 1,
      anon_sym_CARET,
    ACTIONS(8045), 1,
      anon_sym_PIPE,
    ACTIONS(8047), 1,
      anon_sym_AMP,
    ACTIONS(8051), 1,
      anon_sym_GT_GT,
    ACTIONS(8059), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8061), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8063), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8033), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8037), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8039), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8053), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8055), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [262712] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(6711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3991), 9,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3993), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [262789] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(6712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4122), 9,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4120), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [262866] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9228), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [262953] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5719), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5717), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [263030] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(4921), 1,
      anon_sym_DOT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7140), 1,
      anon_sym_LBRACK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3891), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263159] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263288] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7114), 1,
      anon_sym_SLASH,
    ACTIONS(7116), 1,
      anon_sym_CARET,
    ACTIONS(7118), 1,
      anon_sym_PIPE,
    ACTIONS(7120), 1,
      anon_sym_AMP,
    ACTIONS(7124), 1,
      anon_sym_GT_GT,
    ACTIONS(7132), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7134), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7136), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7106), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7110), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7112), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7122), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7126), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7128), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263417] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7748), 1,
      anon_sym_SLASH,
    ACTIONS(7750), 1,
      anon_sym_CARET,
    ACTIONS(7752), 1,
      anon_sym_PIPE,
    ACTIONS(7754), 1,
      anon_sym_AMP,
    ACTIONS(7758), 1,
      anon_sym_GT_GT,
    ACTIONS(7764), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7768), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7740), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7744), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7746), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7756), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7760), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7762), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [263546] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4214), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(6764), 1,
      sym_property_pattern_clause,
    ACTIONS(4395), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4397), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [263643] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2995), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2997), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2999), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [263722] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4431), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [263807] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5699), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5697), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [263884] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5284), 1,
      anon_sym_LBRACK,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3016), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264013] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(8077), 1,
      anon_sym_SLASH,
    ACTIONS(8079), 1,
      anon_sym_CARET,
    ACTIONS(8081), 1,
      anon_sym_PIPE,
    ACTIONS(8083), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      anon_sym_GT_GT,
    ACTIONS(8093), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8095), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8097), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8069), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8073), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8075), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8085), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8089), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8091), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264142] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2987), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(6725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2989), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2991), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [264221] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(8199), 1,
      anon_sym_SLASH,
    ACTIONS(8261), 1,
      anon_sym_CARET,
    ACTIONS(8263), 1,
      anon_sym_PIPE,
    ACTIONS(8265), 1,
      anon_sym_AMP,
    ACTIONS(8269), 1,
      anon_sym_GT_GT,
    ACTIONS(8275), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8277), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8279), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8197), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8267), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8271), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8273), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264350] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5682), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    STATE(6727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5680), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_params,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264427] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4213), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4397), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(4395), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [264520] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_DOT,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6078), 1,
      anon_sym_LPAREN,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6384), 1,
      anon_sym_SLASH,
    ACTIONS(6426), 1,
      anon_sym_GT_GT,
    ACTIONS(6432), 1,
      anon_sym_CARET,
    ACTIONS(6434), 1,
      anon_sym_PIPE,
    ACTIONS(6436), 1,
      anon_sym_AMP,
    ACTIONS(6442), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6444), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6446), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4678), 1,
      sym_argument_list,
    ACTIONS(6138), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6380), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6382), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6424), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6438), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6440), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264649] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9230), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [264736] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7076), 1,
      anon_sym_SLASH,
    ACTIONS(7078), 1,
      anon_sym_CARET,
    ACTIONS(7080), 1,
      anon_sym_PIPE,
    ACTIONS(7082), 1,
      anon_sym_AMP,
    ACTIONS(7086), 1,
      anon_sym_GT_GT,
    ACTIONS(7094), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7096), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7098), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7068), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7072), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7074), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7084), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7088), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7090), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264865] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(8119), 1,
      anon_sym_SLASH,
    ACTIONS(8123), 1,
      anon_sym_GT_GT,
    ACTIONS(8127), 1,
      anon_sym_AMP,
    ACTIONS(8137), 1,
      anon_sym_CARET,
    ACTIONS(8151), 1,
      anon_sym_PIPE,
    ACTIONS(8153), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8159), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8161), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(8115), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(8117), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8121), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(8125), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8129), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8131), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [264994] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    ACTIONS(7901), 1,
      anon_sym_SLASH,
    ACTIONS(7903), 1,
      anon_sym_CARET,
    ACTIONS(7905), 1,
      anon_sym_PIPE,
    ACTIONS(7907), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_GT_GT,
    ACTIONS(7919), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7921), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7923), 1,
      anon_sym_QMARK_QMARK,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7893), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7897), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7899), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7909), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7915), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265123] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8343), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4431), 5,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [265208] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(5253), 1,
      anon_sym_DOT,
    ACTIONS(5265), 1,
      anon_sym_LPAREN,
    ACTIONS(5288), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6741), 1,
      anon_sym_SLASH,
    ACTIONS(6743), 1,
      anon_sym_CARET,
    ACTIONS(6745), 1,
      anon_sym_PIPE,
    ACTIONS(6747), 1,
      anon_sym_AMP,
    ACTIONS(6751), 1,
      anon_sym_GT_GT,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6763), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6765), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym_argument_list,
    ACTIONS(5290), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6733), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6737), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6739), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6749), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6755), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265337] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5762), 1,
      anon_sym_LBRACK,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3199), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265466] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9232), 1,
      anon_sym_DOT,
    ACTIONS(4453), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    STATE(6737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [265553] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4630), 1,
      anon_sym_DOT,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(5756), 1,
      anon_sym_LPAREN,
    ACTIONS(5764), 1,
      anon_sym_BANG,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(6942), 1,
      anon_sym_SLASH,
    ACTIONS(6944), 1,
      anon_sym_CARET,
    ACTIONS(6946), 1,
      anon_sym_PIPE,
    ACTIONS(6948), 1,
      anon_sym_AMP,
    ACTIONS(6952), 1,
      anon_sym_GT_GT,
    ACTIONS(6960), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6962), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6964), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3038), 1,
      sym_bracketed_argument_list,
    STATE(3978), 1,
      sym_argument_list,
    ACTIONS(5766), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6934), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6938), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6940), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6950), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(6954), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6956), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265682] = 38,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(5798), 1,
      anon_sym_LBRACK,
    ACTIONS(5800), 1,
      anon_sym_BANG,
    ACTIONS(6866), 1,
      anon_sym_switch,
    ACTIONS(6880), 1,
      anon_sym_with,
    ACTIONS(7363), 1,
      anon_sym_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SLASH,
    ACTIONS(7371), 1,
      anon_sym_CARET,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7375), 1,
      anon_sym_AMP,
    ACTIONS(7379), 1,
      anon_sym_GT_GT,
    ACTIONS(7385), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7387), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7389), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7391), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_as,
    ACTIONS(7395), 1,
      anon_sym_is,
    STATE(3503), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym_argument_list,
    ACTIONS(5802), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7361), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7365), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7367), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7377), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(7381), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7383), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    STATE(6739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [265811] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9234), 1,
      anon_sym_DOT,
    ACTIONS(4453), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(6740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [265897] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7318), 1,
      sym_explicit_interface_specifier,
    STATE(7531), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [265991] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9236), 1,
      anon_sym_LPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(7699), 1,
      sym_parameter_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266077] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9239), 1,
      aux_sym_preproc_if_token3,
    ACTIONS(9241), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9243), 1,
      aux_sym_preproc_elif_token1,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6985), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8122), 1,
      sym_enum_member_declaration,
    STATE(8367), 1,
      sym_identifier,
    STATE(9346), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [266173] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9236), 1,
      anon_sym_LPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(7693), 1,
      sym_parameter_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266259] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9245), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(9220), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266345] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9247), 1,
      anon_sym_DOT,
    ACTIONS(4453), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266431] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9249), 1,
      anon_sym_DOT,
    ACTIONS(4453), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266517] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9251), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(9253), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266603] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9255), 1,
      anon_sym_DOT,
    ACTIONS(4453), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [266689] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9241), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9243), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(9257), 1,
      aux_sym_preproc_if_token3,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6985), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8034), 1,
      sym_enum_member_declaration,
    STATE(8367), 1,
      sym_identifier,
    STATE(9884), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(6750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [266785] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9259), 1,
      anon_sym_SEMI,
    STATE(6751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [266863] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7329), 1,
      sym_explicit_interface_specifier,
    STATE(7524), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [266957] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7385), 1,
      sym_explicit_interface_specifier,
    STATE(7526), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9219), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267051] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9261), 1,
      anon_sym_SEMI,
    STATE(6754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5466), 11,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5464), 22,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_with,
  [267129] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9236), 1,
      anon_sym_LPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(7681), 1,
      sym_parameter_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267215] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8343), 1,
      sym_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    ACTIONS(4431), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    STATE(6756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267299] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9251), 1,
      anon_sym_EQ,
    ACTIONS(9263), 1,
      anon_sym_COMMA,
    ACTIONS(9266), 1,
      anon_sym_RPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(8636), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267389] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9269), 1,
      anon_sym_COMMA,
    ACTIONS(9271), 1,
      anon_sym_RBRACE,
    ACTIONS(9273), 1,
      aux_sym_preproc_if_token1,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6966), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8419), 1,
      sym_identifier,
    STATE(8408), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267482] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4197), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4403), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4405), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [267573] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9275), 1,
      anon_sym_COMMA,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    STATE(8636), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267660] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9280), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267743] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9282), 1,
      anon_sym_EQ,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 6,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267826] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9284), 1,
      anon_sym_DOT,
    ACTIONS(4453), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [267909] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4201), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4443), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4445), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268000] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4107), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4433), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4435), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268091] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(9286), 1,
      anon_sym_COLON_COLON,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DOT,
    STATE(6766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_COLON,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [268172] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9288), 1,
      anon_sym_using,
    ACTIONS(3991), 7,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(6767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3993), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_operator,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [268249] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4298), 1,
      anon_sym_COMMA,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9251), 1,
      anon_sym_EQ,
    ACTIONS(9253), 1,
      anon_sym_RPAREN,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [268336] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(4213), 1,
      sym__variable_designation,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    ACTIONS(4395), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    ACTIONS(4397), 3,
      anon_sym_when,
      anon_sym_and,
      anon_sym_or,
    STATE(6769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268427] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9290), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268515] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9292), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268603] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9294), 1,
      anon_sym_unsafe,
    ACTIONS(9296), 1,
      anon_sym_static,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7798), 1,
      sym_identifier,
    STATE(8953), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268691] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9298), 1,
      anon_sym_operator,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(9116), 1,
      sym_explicit_interface_specifier,
    STATE(9556), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268779] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9300), 1,
      anon_sym_unsafe,
    ACTIONS(9302), 1,
      anon_sym_static,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7895), 1,
      sym_identifier,
    STATE(8985), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268867] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9304), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [268955] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9306), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269043] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9308), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269131] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9310), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269219] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9312), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269307] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9314), 1,
      anon_sym_operator,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(9554), 1,
      sym_explicit_interface_specifier,
    STATE(9556), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269395] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9316), 1,
      anon_sym_unsafe,
    ACTIONS(9318), 1,
      anon_sym_static,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7928), 1,
      sym_identifier,
    STATE(8922), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269483] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9320), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269571] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9322), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269659] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9324), 1,
      anon_sym_unsafe,
    ACTIONS(9326), 1,
      anon_sym_static,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7873), 1,
      sym_identifier,
    STATE(8951), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269747] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9330), 1,
      anon_sym_LPAREN,
    ACTIONS(9332), 6,
      anon_sym_ref,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_this,
      anon_sym_scoped,
    STATE(6785), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__parameter_type_with_modifiers_repeat1,
    ACTIONS(9328), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [269823] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9335), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269911] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9337), 1,
      anon_sym_operator,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(9556), 1,
      sym__name,
    STATE(9774), 1,
      sym_explicit_interface_specifier,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [269999] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9339), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270087] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9341), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270175] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9343), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270263] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9345), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270351] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [270433] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9347), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270521] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9349), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270609] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9351), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270697] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9353), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6966), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8419), 1,
      sym_identifier,
    STATE(8756), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270787] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(9355), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6966), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8419), 1,
      sym_identifier,
    STATE(8756), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270877] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9357), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [270965] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(8554), 1,
      anon_sym_DOT,
    ACTIONS(8817), 1,
      anon_sym_LPAREN,
    STATE(8927), 1,
      sym_attribute_argument_list,
    ACTIONS(9359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(6799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271053] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9361), 1,
      anon_sym_RBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271141] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(6827), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8400), 1,
      sym_type_parameter,
    STATE(8972), 1,
      sym_identifier,
    ACTIONS(5737), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271228] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    STATE(6802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(2667), 30,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_readonly,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_this,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271301] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8439), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271386] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4559), 1,
      anon_sym_EQ_GT,
    ACTIONS(5907), 1,
      anon_sym_RPAREN,
    ACTIONS(4557), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4555), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [271463] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7689), 1,
      sym__name,
    STATE(8331), 1,
      sym_primary_constructor_base_type,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271548] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8544), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271633] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9363), 1,
      anon_sym_unsafe,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8951), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271718] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8423), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271803] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8878), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271888] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8414), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [271973] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(6827), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8718), 1,
      sym_type_parameter,
    STATE(8972), 1,
      sym_identifier,
    ACTIONS(5737), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272060] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9365), 1,
      anon_sym_in,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [272141] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9367), 1,
      anon_sym_unsafe,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8772), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272226] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    ACTIONS(9369), 1,
      anon_sym_in,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(6814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4138), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [272307] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9371), 1,
      anon_sym_unsafe,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8947), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272392] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8507), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272477] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8525), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272562] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9273), 1,
      aux_sym_preproc_if_token1,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6966), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8419), 1,
      sym_identifier,
    STATE(8756), 2,
      sym_enum_member_declaration,
      sym_preproc_if_in_enum_member_declaration,
    STATE(6818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272649] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7955), 1,
      sym__name,
    STATE(8448), 1,
      sym_attribute,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272734] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9373), 1,
      anon_sym_unsafe,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8834), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272819] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9379), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272905] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8328), 1,
      sym_identifier,
    STATE(8533), 1,
      sym_using_variable_declarator,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [272991] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7838), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9436), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273077] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8023), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273163] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7548), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273249] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7947), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273335] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(7137), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8973), 1,
      sym_identifier,
    ACTIONS(9383), 2,
      anon_sym_in,
      anon_sym_out,
    STATE(6827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273419] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7547), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273505] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9385), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273591] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8947), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273673] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7890), 1,
      sym_identifier,
    STATE(8947), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273755] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    ACTIONS(9387), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8618), 1,
      sym__variable_designation,
    STATE(6832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273841] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7930), 1,
      sym_identifier,
    STATE(8772), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [273923] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9389), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274009] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8327), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274095] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7547), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274181] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274267] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8407), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274349] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9398), 1,
      anon_sym_LPAREN,
    ACTIONS(9395), 2,
      anon_sym_static,
      anon_sym_async,
    STATE(6839), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_lambda_expression_repeat1,
    ACTIONS(9393), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [274423] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7838), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9165), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274509] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8141), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274595] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8276), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274677] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    ACTIONS(9400), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8416), 1,
      sym__variable_designation,
    STATE(6843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274763] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8091), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274845] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8353), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [274927] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7933), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275013] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7873), 1,
      sym_identifier,
    STATE(8951), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275095] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9402), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275181] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7881), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275267] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(7843), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275349] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8113), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275435] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8772), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275517] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8103), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275603] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9404), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275689] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    ACTIONS(9406), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8602), 1,
      sym__variable_designation,
    STATE(6855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275775] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7891), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275861] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9408), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [275947] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7874), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276033] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276119] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(7809), 1,
      sym_identifier,
    STATE(8834), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276201] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8321), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276287] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8289), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276373] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8298), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276459] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8834), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276541] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8251), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276627] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9410), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276713] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9412), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276799] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7883), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276885] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8031), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [276971] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9414), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277057] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7546), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277143] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    ACTIONS(9416), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8689), 1,
      sym__variable_designation,
    STATE(6872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277229] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9418), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277315] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9420), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277401] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9422), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277487] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9424), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277573] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9426), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277659] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9428), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277745] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8203), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277831] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8139), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [277917] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8287), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278003] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9430), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278089] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9432), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278175] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8300), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278261] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    ACTIONS(9434), 1,
      aux_sym_preproc_if_token3,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(6985), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8367), 1,
      sym_identifier,
    STATE(9379), 1,
      sym_enum_member_declaration,
    STATE(6885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278347] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9436), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278433] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9438), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278519] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7556), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278605] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8904), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278687] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9440), 1,
      anon_sym_DOT,
    ACTIONS(4482), 3,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    STATE(6890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4480), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      sym_discard,
      anon_sym_and,
      anon_sym_or,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [278761] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278847] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8778), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [278929] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8109), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279015] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8317), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279101] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5271), 1,
      sym_identifier,
    STATE(8706), 1,
      sym__name,
    STATE(5035), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(6895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279183] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279269] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9446), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279355] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9448), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279441] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7941), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279527] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8187), 1,
      anon_sym_RPAREN,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8342), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279613] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    ACTIONS(9450), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8683), 1,
      sym__variable_designation,
    STATE(6901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279699] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8747), 1,
      sym_identifier,
    STATE(9732), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [279782] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9452), 1,
      anon_sym_DOT,
    STATE(6903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279863] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9454), 1,
      anon_sym_DOT,
    STATE(6904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [279944] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8965), 1,
      sym_identifier,
    STATE(9553), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280027] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9456), 1,
      anon_sym_DOT,
    STATE(6906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280108] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9458), 1,
      anon_sym_DOT,
    STATE(6907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280189] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8749), 1,
      sym_identifier,
    STATE(9727), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280272] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(9460), 1,
      anon_sym_SEMI,
    STATE(6909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280353] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8942), 1,
      sym_identifier,
    STATE(9543), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280436] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9462), 1,
      anon_sym_DOT,
    STATE(6911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280517] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8556), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280600] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8483), 1,
      sym_identifier,
    ACTIONS(9464), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(6913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [280677] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(5229), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280756] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_DOT,
    STATE(6915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280837] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9468), 1,
      anon_sym_DOT,
    STATE(6916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280918] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9470), 1,
      anon_sym_DOT,
    STATE(6917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [280999] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8841), 1,
      sym_identifier,
    ACTIONS(9472), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    STATE(6918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281076] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9474), 1,
      anon_sym_DOT,
    STATE(6919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281157] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9476), 1,
      anon_sym_DOT,
    STATE(6920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281238] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9478), 1,
      anon_sym_DOT,
    STATE(6921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281319] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(4357), 1,
      sym_discard,
    ACTIONS(8564), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(4223), 1,
      sym_identifier,
    STATE(4227), 1,
      sym_parenthesized_variable_designation,
    STATE(8717), 1,
      sym__variable_designation,
    STATE(6922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281402] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8854), 1,
      sym_identifier,
    STATE(9625), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [281485] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(6924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281566] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(4853), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281645] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9482), 1,
      anon_sym_DOT,
    STATE(6926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281726] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9470), 1,
      anon_sym_DOT,
    STATE(6927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281807] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4853), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9484), 1,
      anon_sym_DOT,
    STATE(6928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281888] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(4632), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [281967] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9488), 1,
      anon_sym_LPAREN,
    STATE(6930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9486), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282038] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9456), 1,
      anon_sym_DOT,
    STATE(6931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282119] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8806), 1,
      sym_identifier,
    STATE(9185), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282202] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9490), 1,
      anon_sym_DOT,
    STATE(6933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282283] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(5245), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    STATE(6934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282362] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9466), 1,
      anon_sym_DOT,
    STATE(6935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282443] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4583), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9492), 1,
      anon_sym_DOT,
    STATE(6936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282524] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9494), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5099), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    ACTIONS(9500), 2,
      anon_sym_operator,
      anon_sym_this,
    STATE(6937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9497), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282605] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8725), 1,
      sym_identifier,
    STATE(9781), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282688] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9502), 1,
      anon_sym_DOT,
    STATE(6939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282769] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5229), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9504), 1,
      anon_sym_DOT,
    STATE(6940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [282850] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    ACTIONS(9381), 1,
      anon_sym_LPAREN,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8726), 1,
      sym_identifier,
    STATE(9783), 1,
      sym_tuple_pattern,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [282933] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(5245), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9506), 1,
      anon_sym_DOT,
    STATE(6942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283014] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    STATE(6943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283095] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9510), 1,
      anon_sym_DOT,
    STATE(6944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283176] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9514), 1,
      anon_sym_LPAREN,
    STATE(6945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9512), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_ref,
      anon_sym_delegate,
      anon_sym_async,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283247] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9506), 1,
      anon_sym_DOT,
    STATE(6946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283328] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_DASH_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(9480), 1,
      anon_sym_DOT,
    STATE(6947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4451), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283409] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9623), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283487] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9285), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283567] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9211), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283647] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9933), 1,
      sym__lambda_parameters,
    STATE(6951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283727] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9137), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283807] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9196), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [283887] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [283965] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9102), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [284043] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9102), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284123] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9377), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284203] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9377), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [284281] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9474), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284361] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9496), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284441] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9042), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284521] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8088), 1,
      sym_identifier,
    STATE(9211), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284601] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9621), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284681] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9621), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [284759] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9084), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284839] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7137), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8380), 1,
      sym_identifier,
    STATE(6966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284919] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8089), 1,
      sym_identifier,
    STATE(9211), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [284999] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9180), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285077] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9180), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285157] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9806), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285237] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9670), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285317] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9924), 1,
      sym__lambda_parameters,
    STATE(6972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285397] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5280), 1,
      sym_discard,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8526), 1,
      sym_identifier,
    STATE(8662), 1,
      sym_tuple_pattern,
    STATE(6973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285477] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7568), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(6974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285557] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9659), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285637] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9806), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [285715] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9899), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285795] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9878), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285875] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9724), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [285955] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9724), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286033] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9448), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286113] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9406), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286193] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9194), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286273] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9189), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286353] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(5727), 1,
      anon_sym_LBRACK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7137), 1,
      aux_sym_class_declaration_repeat1,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(8368), 1,
      sym_identifier,
    STATE(6985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286433] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9182), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [286511] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9955), 1,
      sym__lambda_parameters,
    STATE(6987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286591] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9182), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286671] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9167), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286751] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9161), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286831] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(9938), 1,
      sym__lambda_parameters,
    STATE(6991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286911] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9369), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [286991] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9120), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287071] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9397), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287151] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9120), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [287229] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9054), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287309] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9449), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287389] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7630), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(6998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287469] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9154), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(6999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287549] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9636), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287629] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7960), 1,
      sym_identifier,
    STATE(9211), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287709] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9636), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [287787] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8365), 1,
      sym_identifier,
    STATE(9083), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287867] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9910), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [287947] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9035), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288027] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9537), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [288105] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9639), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288185] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9537), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288265] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9641), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288345] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9250), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288425] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9250), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [288503] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9523), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288583] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9389), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288663] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9438), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288743] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8365), 1,
      sym_identifier,
    STATE(9910), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288823] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    ACTIONS(9516), 1,
      sym_discard,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8849), 1,
      sym_identifier,
    STATE(8852), 1,
      sym_tuple_pattern,
    STATE(7016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288903] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9663), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [288983] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9663), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289061] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9799), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289141] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9134), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289221] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9723), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289301] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9623), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289381] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9126), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289461] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9577), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289541] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9117), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289619] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9436), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289697] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9534), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [289775] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9570), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289855] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9629), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [289935] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9515), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290015] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9515), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290093] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9466), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290173] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9454), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290253] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9057), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290333] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8013), 1,
      sym_tuple_pattern,
    STATE(8084), 1,
      sym_identifier,
    STATE(8463), 1,
      sym_variable_declarator,
    STATE(7035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290413] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9057), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290491] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9516), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290571] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9117), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290651] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9516), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [290729] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290809] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9091), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290889] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9513), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [290969] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7960), 1,
      sym_identifier,
    STATE(9910), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291049] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7569), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(7044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291129] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9509), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291209] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9023), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291289] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9363), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291369] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9550), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291449] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9083), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291529] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9363), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [291607] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9236), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291687] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9547), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291767] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9217), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291847] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9073), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [291927] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9143), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292007] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8365), 1,
      sym_identifier,
    STATE(9029), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292087] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9143), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [292165] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9381), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292245] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7964), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(7059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292325] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9500), 1,
      anon_sym_operator,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5099), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    STATE(7060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292405] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9139), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292485] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9135), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292565] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9037), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292645] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9656), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292725] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9656), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [292803] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9534), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292883] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9560), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [292963] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9560), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293041] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9483), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293121] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9458), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293201] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9028), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293281] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9652), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293361] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9649), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293441] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9014), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293519] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8013), 1,
      sym_tuple_pattern,
    STATE(8084), 1,
      sym_identifier,
    STATE(8657), 1,
      sym_variable_declarator,
    STATE(7075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293599] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9578), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293679] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9451), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293757] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9451), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293837] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9435), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [293917] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9578), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [293995] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9014), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294075] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9569), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294155] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9364), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294235] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9018), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294315] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9552), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294395] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9562), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294475] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9029), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294555] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9423), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294633] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9076), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294713] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9076), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [294791] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8343), 1,
      sym_identifier,
    STATE(9782), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294871] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9423), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [294951] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9001), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295031] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9050), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295111] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9418), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295191] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9411), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295271] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7964), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8657), 1,
      sym_variable_declarator,
    STATE(7097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295351] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9541), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295431] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9541), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [295509] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9528), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295589] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9154), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [295667] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9231), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295747] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9263), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [295827] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9381), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [295905] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9404), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [295983] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9404), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296063] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9490), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296143] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9255), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296221] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9165), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296301] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9255), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296381] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8198), 1,
      sym_identifier,
    STATE(9211), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296461] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9165), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296539] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(8698), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7595), 1,
      sym_identifier,
    STATE(8106), 1,
      sym_tuple_pattern,
    STATE(8538), 1,
      sym_variable_declarator,
    STATE(7113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296619] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9672), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296699] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9493), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296779] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8992), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [296857] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8992), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [296937] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9436), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297017] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9362), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297097] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9242), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297177] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9232), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297257] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9758), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297337] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9387), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297417] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9100), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297497] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9427), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297575] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9427), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297655] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9133), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297735] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9228), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [297813] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9498), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297893] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9048), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [297973] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9500), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298053] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9228), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298133] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9502), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [298211] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9218), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298291] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9502), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298371] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9331), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298451] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9518), 1,
      anon_sym_LBRACK,
    STATE(7291), 1,
      sym_attribute_list,
    STATE(7137), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat1,
    ACTIONS(5357), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [298523] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9202), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298603] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9144), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [298681] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9372), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298761] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9370), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298841] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9367), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [298919] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9144), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [298999] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9367), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299079] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9345), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299159] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9333), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299239] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9488), 1,
      sym_identifier,
    STATE(9533), 1,
      sym__lambda_parameters,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299319] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9322), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299399] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9314), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299479] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9310), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [299557] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9089), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [299635] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9310), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299715] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9305), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299795] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9089), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299875] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9122), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [299955] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9111), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300035] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9301), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300115] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4431), 1,
      anon_sym_LPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9285), 1,
      sym__lambda_parameters,
    STATE(9488), 1,
      sym_identifier,
    STATE(9912), 1,
      sym_parameter_list,
    STATE(7158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4429), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [300193] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      sym__identifier_token,
    STATE(5180), 1,
      sym_identifier,
    STATE(5210), 1,
      sym__reserved_identifier,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5407), 1,
      sym__simple_name,
    STATE(7159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4549), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300270] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3901), 1,
      sym_identifier,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4111), 1,
      sym__simple_name,
    STATE(7160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300347] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2768), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300424] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9525), 1,
      sym__identifier_token,
    STATE(4814), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(4990), 1,
      sym__simple_name,
    STATE(6712), 1,
      sym__reserved_identifier,
    STATE(7162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9527), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300501] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3901), 1,
      sym_identifier,
    STATE(3970), 1,
      sym__simple_name,
    STATE(4064), 1,
      sym_generic_name,
    STATE(7163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300578] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2768), 1,
      sym__simple_name,
    STATE(7164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300655] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4256), 1,
      sym__identifier_token,
    STATE(3887), 1,
      sym__reserved_identifier,
    STATE(3901), 1,
      sym_identifier,
    STATE(3974), 1,
      sym__simple_name,
    STATE(4064), 1,
      sym_generic_name,
    STATE(7165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4258), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300732] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2905), 1,
      sym__simple_name,
    STATE(7166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300809] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2931), 1,
      sym__simple_name,
    STATE(7167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300886] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3901), 1,
      sym_identifier,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(3974), 1,
      sym__simple_name,
    STATE(4064), 1,
      sym_generic_name,
    STATE(7168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [300963] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9529), 1,
      sym__identifier_token,
    STATE(2920), 1,
      sym_identifier,
    STATE(2961), 1,
      sym_generic_name,
    STATE(2976), 1,
      sym__simple_name,
    STATE(3178), 1,
      sym__reserved_identifier,
    STATE(7169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9531), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301040] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3842), 1,
      sym_identifier,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(4076), 1,
      sym__simple_name,
    STATE(7170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301117] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9533), 1,
      sym__identifier_token,
    STATE(2810), 1,
      sym_identifier,
    STATE(2825), 1,
      sym__reserved_identifier,
    STATE(2843), 1,
      sym_generic_name,
    STATE(2860), 1,
      sym__simple_name,
    STATE(7171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9535), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301194] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2759), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301271] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9537), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8601), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301348] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2953), 1,
      sym__simple_name,
    STATE(7174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301425] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3612), 1,
      sym_identifier,
    STATE(3639), 1,
      sym__simple_name,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301502] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7511), 1,
      sym_identifier,
    ACTIONS(9539), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301577] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3901), 1,
      sym_identifier,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(3970), 1,
      sym__simple_name,
    STATE(4064), 1,
      sym_generic_name,
    STATE(7177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301654] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3901), 1,
      sym_identifier,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(4064), 1,
      sym_generic_name,
    STATE(4111), 1,
      sym__simple_name,
    STATE(7178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301731] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4814), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(4990), 1,
      sym__simple_name,
    STATE(7179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301808] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9533), 1,
      sym__identifier_token,
    STATE(2810), 1,
      sym_identifier,
    STATE(2825), 1,
      sym__reserved_identifier,
    STATE(2841), 1,
      sym__simple_name,
    STATE(2843), 1,
      sym_generic_name,
    STATE(7180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9535), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301885] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2941), 1,
      sym__simple_name,
    STATE(7181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [301962] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3842), 1,
      sym_identifier,
    STATE(3883), 1,
      sym__simple_name,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302039] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3842), 1,
      sym_identifier,
    STATE(3889), 1,
      sym__simple_name,
    STATE(3892), 1,
      sym_generic_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302116] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3612), 1,
      sym_identifier,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3782), 1,
      sym__simple_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302193] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2901), 1,
      sym__simple_name,
    STATE(7185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302270] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2792), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302347] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8426), 1,
      sym_identifier,
    STATE(7187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302424] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2954), 1,
      sym__simple_name,
    STATE(7188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302501] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7512), 1,
      sym_identifier,
    ACTIONS(9541), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302576] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3657), 1,
      sym__simple_name,
    STATE(7190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302653] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(3582), 1,
      sym__simple_name,
    STATE(7191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302730] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8426), 1,
      sym_identifier,
    STATE(7192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302807] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2850), 1,
      sym__simple_name,
    STATE(7193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302884] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9525), 1,
      sym__identifier_token,
    STATE(4814), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5099), 1,
      sym__simple_name,
    STATE(6712), 1,
      sym__reserved_identifier,
    STATE(7194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9527), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [302961] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2758), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303038] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(4990), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    STATE(7196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303115] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9533), 1,
      sym__identifier_token,
    STATE(2810), 1,
      sym_identifier,
    STATE(2825), 1,
      sym__reserved_identifier,
    STATE(2840), 1,
      sym__simple_name,
    STATE(2843), 1,
      sym_generic_name,
    STATE(7197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9535), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303192] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3598), 1,
      sym__simple_name,
    STATE(7198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303269] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7505), 1,
      sym_identifier,
    ACTIONS(9543), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303344] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(5099), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    STATE(7200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303421] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3612), 1,
      sym_identifier,
    STATE(3661), 1,
      sym__simple_name,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303498] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2973), 1,
      sym__simple_name,
    STATE(7202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303575] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3612), 1,
      sym_identifier,
    STATE(3676), 1,
      sym_generic_name,
    STATE(3782), 1,
      sym__simple_name,
    STATE(7203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303652] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2885), 1,
      sym__simple_name,
    STATE(7204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303729] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9545), 1,
      anon_sym_operator,
    ACTIONS(9547), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7682), 1,
      sym_identifier,
    STATE(7205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303806] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9529), 1,
      sym__identifier_token,
    STATE(2920), 1,
      sym_identifier,
    STATE(2961), 1,
      sym_generic_name,
    STATE(2974), 1,
      sym__simple_name,
    STATE(3178), 1,
      sym__reserved_identifier,
    STATE(7206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9531), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303883] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2901), 1,
      sym__simple_name,
    STATE(7207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [303960] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(5099), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    STATE(7208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304037] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9549), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8424), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304114] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      sym__identifier_token,
    STATE(5180), 1,
      sym_identifier,
    STATE(5210), 1,
      sym__reserved_identifier,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5763), 1,
      sym__simple_name,
    STATE(7210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4549), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304191] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2866), 1,
      sym__simple_name,
    STATE(7211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304268] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2872), 1,
      sym__simple_name,
    STATE(7212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304345] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2864), 1,
      sym__simple_name,
    STATE(7213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304422] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7516), 1,
      sym_identifier,
    ACTIONS(9551), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304497] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2760), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304574] = 16,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(9553), 1,
      sym_integer_literal,
    ACTIONS(9555), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8566), 1,
      sym_identifier,
    STATE(7216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304651] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9533), 1,
      sym__identifier_token,
    STATE(2810), 1,
      sym_identifier,
    STATE(2825), 1,
      sym__reserved_identifier,
    STATE(2843), 1,
      sym_generic_name,
    STATE(2879), 1,
      sym__simple_name,
    STATE(7217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9535), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304728] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8799), 1,
      sym_identifier,
    ACTIONS(9375), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(7218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304803] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7506), 1,
      sym_identifier,
    ACTIONS(9575), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304878] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3612), 1,
      sym_identifier,
    STATE(3661), 1,
      sym__simple_name,
    STATE(3676), 1,
      sym_generic_name,
    STATE(7220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [304955] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2933), 1,
      sym__simple_name,
    STATE(7221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305032] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2940), 1,
      sym__simple_name,
    STATE(7222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305109] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2822), 1,
      sym__simple_name,
    STATE(7223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305186] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(3227), 1,
      sym_identifier,
    STATE(3314), 1,
      sym_generic_name,
    STATE(3333), 1,
      sym__simple_name,
    STATE(7224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305263] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9577), 1,
      anon_sym_operator,
    ACTIONS(9579), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7671), 1,
      sym_identifier,
    STATE(7225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305340] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2904), 1,
      sym__simple_name,
    STATE(7226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305417] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9581), 1,
      sym__identifier_token,
    STATE(3225), 1,
      sym_identifier,
    STATE(3254), 1,
      sym__simple_name,
    STATE(3265), 1,
      sym__reserved_identifier,
    STATE(3371), 1,
      sym_generic_name,
    STATE(7227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9583), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305494] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(4990), 1,
      sym__simple_name,
    STATE(5306), 1,
      sym_identifier,
    STATE(7228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305571] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2891), 1,
      sym__simple_name,
    STATE(7229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305648] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9585), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8571), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305725] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9533), 1,
      sym__identifier_token,
    STATE(2810), 1,
      sym_identifier,
    STATE(2825), 1,
      sym__reserved_identifier,
    STATE(2838), 1,
      sym__simple_name,
    STATE(2843), 1,
      sym_generic_name,
    STATE(7231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9535), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305802] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(4814), 1,
      sym_identifier,
    STATE(4988), 1,
      sym_generic_name,
    STATE(5099), 1,
      sym__simple_name,
    STATE(7232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305879] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2761), 1,
      sym__simple_name,
    STATE(7233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [305956] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9587), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8626), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306033] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4351), 1,
      sym__identifier_token,
    STATE(3590), 1,
      sym__reserved_identifier,
    STATE(3612), 1,
      sym_identifier,
    STATE(3639), 1,
      sym__simple_name,
    STATE(3676), 1,
      sym_generic_name,
    STATE(7235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4353), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306110] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3657), 1,
      sym__simple_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306187] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2769), 1,
      sym__simple_name,
    STATE(7237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306264] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7509), 1,
      sym_identifier,
    ACTIONS(9589), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306339] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2769), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306416] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2850), 1,
      sym__simple_name,
    STATE(7240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306493] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2979), 1,
      sym__simple_name,
    STATE(7241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306570] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7514), 1,
      sym_identifier,
    ACTIONS(9591), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306645] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2761), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306722] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9593), 1,
      sym__identifier_token,
    STATE(2963), 1,
      sym_identifier,
    STATE(2996), 1,
      sym_generic_name,
    STATE(3008), 1,
      sym__simple_name,
    STATE(3019), 1,
      sym__reserved_identifier,
    STATE(7244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9595), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306799] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2849), 1,
      sym__simple_name,
    STATE(7245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306876] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4612), 1,
      sym__identifier_token,
    STATE(2920), 1,
      sym_identifier,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2961), 1,
      sym_generic_name,
    STATE(2974), 1,
      sym__simple_name,
    STATE(7246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [306953] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7510), 1,
      sym_identifier,
    ACTIONS(9597), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307028] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2792), 1,
      sym__simple_name,
    STATE(7248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307105] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2760), 1,
      sym__simple_name,
    STATE(7249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307182] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2919), 1,
      sym__simple_name,
    STATE(7250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307259] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3598), 1,
      sym__simple_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307336] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2912), 1,
      sym__simple_name,
    STATE(7252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307413] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9599), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8682), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307490] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2855), 1,
      sym__simple_name,
    STATE(7254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307567] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4612), 1,
      sym__identifier_token,
    STATE(2920), 1,
      sym_identifier,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2961), 1,
      sym_generic_name,
    STATE(4640), 1,
      sym__simple_name,
    STATE(7255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307644] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2894), 1,
      sym__simple_name,
    STATE(7256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307721] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2890), 1,
      sym__simple_name,
    STATE(7257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307798] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9601), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8595), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307875] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2880), 1,
      sym__simple_name,
    STATE(7259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [307952] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2965), 1,
      sym__simple_name,
    STATE(7260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308029] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9603), 1,
      anon_sym_operator,
    ACTIONS(9605), 1,
      anon_sym_this,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7687), 1,
      sym_identifier,
    STATE(7261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308106] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9581), 1,
      sym__identifier_token,
    STATE(3225), 1,
      sym_identifier,
    STATE(3265), 1,
      sym__reserved_identifier,
    STATE(3277), 1,
      sym__simple_name,
    STATE(3371), 1,
      sym_generic_name,
    STATE(7262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9583), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308183] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2759), 1,
      sym__simple_name,
    STATE(7263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308260] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4286), 1,
      sym__identifier_token,
    STATE(3562), 1,
      sym__reserved_identifier,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3597), 1,
      sym__simple_name,
    STATE(7264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4288), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308337] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2822), 1,
      sym__simple_name,
    STATE(7265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308414] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2855), 1,
      sym__simple_name,
    STATE(7266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308491] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9607), 1,
      sym__identifier_token,
    STATE(3144), 1,
      sym_identifier,
    STATE(3186), 1,
      sym__simple_name,
    STATE(3193), 1,
      sym_generic_name,
    STATE(3222), 1,
      sym__reserved_identifier,
    STATE(7267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9609), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308568] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(2828), 1,
      sym__simple_name,
    STATE(7268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308645] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9611), 1,
      sym__identifier_token,
    STATE(3853), 1,
      sym_identifier,
    STATE(3921), 1,
      sym__reserved_identifier,
    STATE(3935), 1,
      sym__simple_name,
    STATE(3943), 1,
      sym_generic_name,
    STATE(7269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9613), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308722] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2758), 1,
      sym__simple_name,
    STATE(7270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308799] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2798), 1,
      sym__simple_name,
    STATE(7271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308876] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7508), 1,
      sym_identifier,
    ACTIONS(9615), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(7272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [308951] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2893), 1,
      sym__simple_name,
    STATE(7273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309028] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2849), 1,
      sym__simple_name,
    STATE(7274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309105] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9521), 1,
      sym__identifier_token,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2798), 1,
      sym__simple_name,
    STATE(2818), 1,
      sym__reserved_identifier,
    STATE(7275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9523), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309182] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4335), 1,
      sym__identifier_token,
    STATE(3563), 1,
      sym_identifier,
    STATE(3588), 1,
      sym_generic_name,
    STATE(3597), 1,
      sym__simple_name,
    STATE(3936), 1,
      sym__reserved_identifier,
    STATE(7276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4337), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309259] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8489), 1,
      sym_identifier,
    STATE(7277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309336] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8489), 1,
      sym_identifier,
    STATE(7278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309413] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4547), 1,
      sym__identifier_token,
    STATE(5180), 1,
      sym_identifier,
    STATE(5210), 1,
      sym__reserved_identifier,
    STATE(5280), 1,
      sym_generic_name,
    STATE(5408), 1,
      sym__simple_name,
    STATE(7279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4549), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309490] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2949), 1,
      sym__simple_name,
    STATE(7280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309567] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(2751), 1,
      sym_generic_name,
    STATE(2755), 1,
      sym_identifier,
    STATE(2890), 1,
      sym__simple_name,
    STATE(7281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309644] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4612), 1,
      sym__identifier_token,
    STATE(2920), 1,
      sym_identifier,
    STATE(2925), 1,
      sym__reserved_identifier,
    STATE(2961), 1,
      sym_generic_name,
    STATE(2976), 1,
      sym__simple_name,
    STATE(7282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(4614), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309721] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8817), 1,
      sym_with_initializer,
    STATE(9374), 1,
      sym_identifier,
    STATE(7283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309795] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8684), 1,
      sym_identifier,
    STATE(8733), 1,
      sym_using_variable_declarator,
    STATE(7284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309869] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9375), 1,
      anon_sym_COMMA,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8452), 1,
      sym_identifier,
    STATE(7285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [309943] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8403), 1,
      sym__identifier_token,
    ACTIONS(9617), 1,
      sym_integer_literal,
    STATE(7781), 1,
      sym__reserved_identifier,
    STATE(8739), 1,
      sym_identifier,
    STATE(7286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(8405), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310017] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5707), 1,
      anon_sym_LBRACK,
    STATE(7287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5705), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310085] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5703), 1,
      anon_sym_LBRACK,
    STATE(7288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5701), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310153] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5719), 1,
      anon_sym_LBRACK,
    STATE(7289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5717), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310221] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5682), 1,
      anon_sym_LBRACK,
    STATE(7290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5680), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310289] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5699), 1,
      anon_sym_LBRACK,
    STATE(7291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(5697), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_in,
      anon_sym_out,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [310357] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    ACTIONS(9619), 1,
      anon_sym_RPAREN,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9950), 1,
      sym_identifier,
    STATE(7292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310431] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8317), 1,
      sym_identifier,
    STATE(7293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310502] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9576), 1,
      sym_identifier,
    STATE(7294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310573] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7538), 1,
      sym_identifier,
    STATE(7295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310644] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7523), 1,
      sym_identifier,
    STATE(7296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310715] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7508), 1,
      sym_identifier,
    STATE(7297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310786] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7539), 1,
      sym_identifier,
    STATE(7298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310857] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7452), 1,
      sym_identifier,
    STATE(7299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310928] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7517), 1,
      sym_identifier,
    STATE(7300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [310999] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7533), 1,
      sym_identifier,
    STATE(7301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311070] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7661), 1,
      sym_identifier,
    STATE(7302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311141] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7446), 1,
      sym_identifier,
    STATE(7303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311212] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7649), 1,
      sym_identifier,
    STATE(7304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311283] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7537), 1,
      sym_identifier,
    STATE(7305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311354] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7512), 1,
      sym_identifier,
    STATE(7306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311425] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8319), 1,
      sym_identifier,
    STATE(7307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311496] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7479), 1,
      sym_identifier,
    STATE(7308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311567] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8266), 1,
      sym_identifier,
    STATE(7309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311638] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8311), 1,
      sym_identifier,
    STATE(7310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311709] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8300), 1,
      sym_identifier,
    STATE(7311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311780] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8354), 1,
      sym_identifier,
    STATE(7312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311851] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8269), 1,
      sym_identifier,
    STATE(7313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311922] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7525), 1,
      sym_identifier,
    STATE(7314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [311993] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7447), 1,
      sym_identifier,
    STATE(7315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312064] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(8973), 1,
      sym_identifier,
    STATE(7316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312135] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7588), 1,
      sym_identifier,
    STATE(7317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312206] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8565), 1,
      sym_identifier,
    STATE(7318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312277] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7602), 1,
      sym_identifier,
    STATE(7319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312348] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(9347), 1,
      sym_identifier,
    STATE(7320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312419] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7471), 1,
      sym_identifier,
    STATE(7321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312490] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7535), 1,
      sym_identifier,
    STATE(7322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312561] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8318), 1,
      sym_identifier,
    STATE(7323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312632] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7441), 1,
      sym_identifier,
    STATE(7324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312703] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8724), 1,
      sym_identifier,
    STATE(7325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312774] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7456), 1,
      sym_identifier,
    STATE(7326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312845] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7448), 1,
      sym_identifier,
    STATE(7327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312916] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8315), 1,
      sym_identifier,
    STATE(7328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [312987] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8663), 1,
      sym_identifier,
    STATE(7329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313058] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7753), 1,
      sym_identifier,
    STATE(7330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313129] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8366), 1,
      sym_identifier,
    STATE(7331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313200] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7485), 1,
      sym_identifier,
    STATE(7332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313271] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7610), 1,
      sym_identifier,
    STATE(7333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313342] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7494), 1,
      sym_identifier,
    STATE(7334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313413] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8254), 1,
      sym_identifier,
    STATE(7335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313484] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7496), 1,
      sym_identifier,
    STATE(7336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313555] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(9008), 1,
      sym_identifier,
    STATE(7337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313626] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7511), 1,
      sym_identifier,
    STATE(7338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313697] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7520), 1,
      sym_identifier,
    STATE(7339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313768] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8340), 1,
      sym_identifier,
    STATE(7340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313839] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7443), 1,
      sym_identifier,
    STATE(7341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313910] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8298), 1,
      sym_identifier,
    STATE(7342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [313981] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7513), 1,
      sym_identifier,
    STATE(7343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314052] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8323), 1,
      sym_identifier,
    STATE(7344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314123] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3115), 1,
      sym__identifier_token,
    STATE(4535), 1,
      sym__reserved_identifier,
    STATE(8722), 1,
      sym_identifier,
    STATE(7345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(3119), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314194] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7453), 1,
      sym_identifier,
    STATE(7346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314265] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7454), 1,
      sym_identifier,
    STATE(7347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314336] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8964), 1,
      sym_identifier,
    STATE(7348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314407] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9247), 1,
      sym_identifier,
    STATE(7349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314478] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7521), 1,
      sym_identifier,
    STATE(7350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314549] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8361), 1,
      sym_identifier,
    STATE(7351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314620] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7536), 1,
      sym_identifier,
    STATE(7352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314691] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7579), 1,
      sym_identifier,
    STATE(7353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314762] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8326), 1,
      sym_identifier,
    STATE(7354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314833] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7481), 1,
      sym_identifier,
    STATE(7355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314904] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7657), 1,
      sym_identifier,
    STATE(7356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [314975] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7507), 1,
      sym_identifier,
    STATE(7357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315046] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7515), 1,
      sym_identifier,
    STATE(7358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315117] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8257), 1,
      sym_identifier,
    STATE(7359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315188] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(9034), 1,
      sym_identifier,
    STATE(7360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315259] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7486), 1,
      sym_identifier,
    STATE(7361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315330] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7532), 1,
      sym_identifier,
    STATE(7362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315401] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(9375), 1,
      sym_identifier,
    STATE(7363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315472] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7567), 1,
      sym_identifier,
    STATE(7364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315543] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7528), 1,
      sym_identifier,
    STATE(7365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315614] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8373), 1,
      sym_identifier,
    STATE(7366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315685] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8251), 1,
      sym_identifier,
    STATE(7367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315756] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7519), 1,
      sym_identifier,
    STATE(7368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315827] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7516), 1,
      sym_identifier,
    STATE(7369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315898] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7518), 1,
      sym_identifier,
    STATE(7370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [315969] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8372), 1,
      sym_identifier,
    STATE(7371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316040] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7488), 1,
      sym_identifier,
    STATE(7372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316111] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8256), 1,
      sym_identifier,
    STATE(7373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316182] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7541), 1,
      sym_identifier,
    STATE(7374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316253] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8290), 1,
      sym_identifier,
    STATE(7375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316324] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7534), 1,
      sym_identifier,
    STATE(7376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316395] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7527), 1,
      sym_identifier,
    STATE(7377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316466] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7506), 1,
      sym_identifier,
    STATE(7378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316537] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7522), 1,
      sym_identifier,
    STATE(7379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316608] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8281), 1,
      sym_identifier,
    STATE(7380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316679] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(8262), 1,
      sym_identifier,
    STATE(7381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316750] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7566), 1,
      sym_identifier,
    STATE(7382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316821] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7540), 1,
      sym_identifier,
    STATE(7383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316892] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7461), 1,
      sym_identifier,
    STATE(7384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [316963] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8411), 1,
      sym_identifier,
    STATE(7385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317034] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7499), 1,
      sym_identifier,
    STATE(7386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317105] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7529), 1,
      sym_identifier,
    STATE(7387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317176] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8258), 1,
      sym_identifier,
    STATE(7388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317247] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(7449), 1,
      sym_identifier,
    STATE(7389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317318] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7459), 1,
      sym__identifier_token,
    STATE(3150), 1,
      sym__reserved_identifier,
    STATE(7505), 1,
      sym_identifier,
    STATE(7390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(7461), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317389] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(23), 1,
      sym__identifier_token,
    STATE(2744), 1,
      sym__reserved_identifier,
    STATE(8703), 1,
      sym_identifier,
    STATE(7391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(27), 22,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
  [317460] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_checked,
    ACTIONS(9621), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9625), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317528] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9629), 1,
      anon_sym_checked,
    ACTIONS(9627), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9631), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317596] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9635), 1,
      anon_sym_checked,
    ACTIONS(9633), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9637), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317664] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9641), 1,
      anon_sym_checked,
    ACTIONS(9639), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9643), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317732] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9647), 1,
      anon_sym_checked,
    ACTIONS(9645), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9649), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317800] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9653), 1,
      anon_sym_checked,
    ACTIONS(9651), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9655), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317868] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9657), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9659), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317933] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9621), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9625), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [317998] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9661), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9663), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [318063] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9627), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9631), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [318128] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9639), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9643), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [318193] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9665), 7,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    STATE(7403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9667), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [318258] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    STATE(7404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
    ACTIONS(9669), 23,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_file,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_scoped,
      anon_sym_var,
      anon_sym_yield,
      anon_sym_when,
      anon_sym_from,
      anon_sym_into,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
  [318321] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9681), 1,
      anon_sym_group,
    ACTIONS(9683), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(5711), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318403] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9685), 1,
      anon_sym_group,
    ACTIONS(9687), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(5767), 1,
      sym__select_or_group_clause,
    STATE(7459), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318485] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9689), 1,
      anon_sym_group,
    ACTIONS(9691), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(6094), 1,
      sym__select_or_group_clause,
    STATE(7445), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318567] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9693), 1,
      anon_sym_group,
    ACTIONS(9695), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(6615), 1,
      sym__select_or_group_clause,
    STATE(7478), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318649] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9697), 1,
      anon_sym_group,
    ACTIONS(9699), 1,
      anon_sym_select,
    STATE(5687), 1,
      sym__query_body,
    STATE(5851), 1,
      sym__select_or_group_clause,
    STATE(7468), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318731] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9689), 1,
      anon_sym_group,
    ACTIONS(9691), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(6094), 1,
      sym__select_or_group_clause,
    STATE(7445), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318813] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9701), 1,
      anon_sym_group,
    ACTIONS(9703), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(6642), 1,
      sym__select_or_group_clause,
    STATE(7474), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318895] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9705), 1,
      anon_sym_group,
    ACTIONS(9707), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(5221), 1,
      sym__select_or_group_clause,
    STATE(7484), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [318977] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9685), 1,
      anon_sym_group,
    ACTIONS(9687), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(5767), 1,
      sym__select_or_group_clause,
    STATE(7459), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319059] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9709), 1,
      anon_sym_group,
    ACTIONS(9711), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(5535), 1,
      sym__select_or_group_clause,
    STATE(7465), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319141] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9693), 1,
      anon_sym_group,
    ACTIONS(9695), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(6615), 1,
      sym__select_or_group_clause,
    STATE(7478), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319223] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9713), 1,
      anon_sym_group,
    ACTIONS(9715), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(6631), 1,
      sym__select_or_group_clause,
    STATE(7497), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319305] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9717), 1,
      anon_sym_group,
    ACTIONS(9719), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(6012), 1,
      sym__select_or_group_clause,
    STATE(7500), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319387] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9721), 1,
      anon_sym_group,
    ACTIONS(9723), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(6039), 1,
      sym__select_or_group_clause,
    STATE(7473), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319469] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9725), 1,
      anon_sym_group,
    ACTIONS(9727), 1,
      anon_sym_select,
    STATE(5377), 1,
      sym__select_or_group_clause,
    STATE(5687), 1,
      sym__query_body,
    STATE(7490), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319551] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9729), 1,
      anon_sym_group,
    ACTIONS(9731), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(5982), 1,
      sym__select_or_group_clause,
    STATE(7467), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319633] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9733), 1,
      anon_sym_group,
    ACTIONS(9735), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(4615), 1,
      sym__select_or_group_clause,
    STATE(7475), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319715] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9737), 1,
      anon_sym_group,
    ACTIONS(9739), 1,
      anon_sym_select,
    STATE(4491), 1,
      sym__select_or_group_clause,
    STATE(4677), 1,
      sym__query_body,
    STATE(7493), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319797] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9741), 1,
      anon_sym_group,
    ACTIONS(9743), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(6427), 1,
      sym__select_or_group_clause,
    STATE(7455), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319879] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9681), 1,
      anon_sym_group,
    ACTIONS(9683), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(5711), 1,
      sym__select_or_group_clause,
    STATE(7476), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [319961] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9729), 1,
      anon_sym_group,
    ACTIONS(9731), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(5982), 1,
      sym__select_or_group_clause,
    STATE(7467), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320043] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9717), 1,
      anon_sym_group,
    ACTIONS(9719), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(6012), 1,
      sym__select_or_group_clause,
    STATE(7500), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320125] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9745), 1,
      anon_sym_group,
    ACTIONS(9747), 1,
      anon_sym_select,
    STATE(4677), 1,
      sym__query_body,
    STATE(4900), 1,
      sym__select_or_group_clause,
    STATE(7442), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320207] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9749), 1,
      anon_sym_group,
    ACTIONS(9751), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(4963), 1,
      sym__select_or_group_clause,
    STATE(7472), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320289] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9753), 1,
      anon_sym_group,
    ACTIONS(9755), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(4946), 1,
      sym__select_or_group_clause,
    STATE(7469), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320371] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9705), 1,
      anon_sym_group,
    ACTIONS(9707), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(5221), 1,
      sym__select_or_group_clause,
    STATE(7484), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320453] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9713), 1,
      anon_sym_group,
    ACTIONS(9715), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(6631), 1,
      sym__select_or_group_clause,
    STATE(7497), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320535] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9749), 1,
      anon_sym_group,
    ACTIONS(9751), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(4963), 1,
      sym__select_or_group_clause,
    STATE(7472), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320617] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9709), 1,
      anon_sym_group,
    ACTIONS(9711), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(5535), 1,
      sym__select_or_group_clause,
    STATE(7465), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320699] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9741), 1,
      anon_sym_group,
    ACTIONS(9743), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(6427), 1,
      sym__select_or_group_clause,
    STATE(7455), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320781] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9757), 1,
      anon_sym_group,
    ACTIONS(9759), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(5106), 1,
      sym__select_or_group_clause,
    STATE(7492), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320863] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9757), 1,
      anon_sym_group,
    ACTIONS(9759), 1,
      anon_sym_select,
    STATE(3766), 1,
      sym__query_body,
    STATE(5106), 1,
      sym__select_or_group_clause,
    STATE(7492), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [320945] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9721), 1,
      anon_sym_group,
    ACTIONS(9723), 1,
      anon_sym_select,
    STATE(3975), 1,
      sym__query_body,
    STATE(6039), 1,
      sym__select_or_group_clause,
    STATE(7473), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321027] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9733), 1,
      anon_sym_group,
    ACTIONS(9735), 1,
      anon_sym_select,
    STATE(4210), 1,
      sym__query_body,
    STATE(4615), 1,
      sym__select_or_group_clause,
    STATE(7475), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321109] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9701), 1,
      anon_sym_group,
    ACTIONS(9703), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(6642), 1,
      sym__select_or_group_clause,
    STATE(7474), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321191] = 23,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9753), 1,
      anon_sym_group,
    ACTIONS(9755), 1,
      anon_sym_select,
    STATE(3690), 1,
      sym__query_body,
    STATE(4946), 1,
      sym__select_or_group_clause,
    STATE(7469), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321273] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9733), 1,
      anon_sym_group,
    ACTIONS(9735), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7482), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321352] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9745), 1,
      anon_sym_group,
    ACTIONS(9747), 1,
      anon_sym_select,
    STATE(4803), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321431] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9701), 1,
      anon_sym_group,
    ACTIONS(9703), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7463), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321510] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9741), 1,
      anon_sym_group,
    ACTIONS(9743), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321589] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9689), 1,
      anon_sym_group,
    ACTIONS(9691), 1,
      anon_sym_select,
    STATE(6098), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321668] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9709), 1,
      anon_sym_group,
    ACTIONS(9711), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7451), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321747] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9697), 1,
      anon_sym_group,
    ACTIONS(9699), 1,
      anon_sym_select,
    STATE(5753), 1,
      sym__select_or_group_clause,
    STATE(7458), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321826] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9713), 1,
      anon_sym_group,
    ACTIONS(9715), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7462), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321905] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9741), 1,
      anon_sym_group,
    ACTIONS(9743), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7444), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [321984] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9757), 1,
      anon_sym_group,
    ACTIONS(9759), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322063] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9709), 1,
      anon_sym_group,
    ACTIONS(9711), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322142] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9757), 1,
      anon_sym_group,
    ACTIONS(9759), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7450), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322221] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9753), 1,
      anon_sym_group,
    ACTIONS(9755), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7464), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322300] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9689), 1,
      anon_sym_group,
    ACTIONS(9691), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7457), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322379] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9741), 1,
      anon_sym_group,
    ACTIONS(9743), 1,
      anon_sym_select,
    STATE(6496), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322458] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9685), 1,
      anon_sym_group,
    ACTIONS(9687), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7466), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322537] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9689), 1,
      anon_sym_group,
    ACTIONS(9691), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322616] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9697), 1,
      anon_sym_group,
    ACTIONS(9699), 1,
      anon_sym_select,
    STATE(5698), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322695] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9685), 1,
      anon_sym_group,
    ACTIONS(9687), 1,
      anon_sym_select,
    STATE(5512), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322774] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9729), 1,
      anon_sym_group,
    ACTIONS(9731), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322853] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9729), 1,
      anon_sym_group,
    ACTIONS(9731), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7460), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [322932] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9713), 1,
      anon_sym_group,
    ACTIONS(9715), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323011] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9701), 1,
      anon_sym_group,
    ACTIONS(9703), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323090] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9753), 1,
      anon_sym_group,
    ACTIONS(9755), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323169] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9709), 1,
      anon_sym_group,
    ACTIONS(9711), 1,
      anon_sym_select,
    STATE(5532), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323248] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9685), 1,
      anon_sym_group,
    ACTIONS(9687), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323327] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9729), 1,
      anon_sym_group,
    ACTIONS(9731), 1,
      anon_sym_select,
    STATE(5973), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323406] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9697), 1,
      anon_sym_group,
    ACTIONS(9699), 1,
      anon_sym_select,
    STATE(5837), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323485] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9753), 1,
      anon_sym_group,
    ACTIONS(9755), 1,
      anon_sym_select,
    STATE(4958), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323564] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9749), 1,
      anon_sym_group,
    ACTIONS(9751), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323643] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9749), 1,
      anon_sym_group,
    ACTIONS(9751), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7470), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323722] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9749), 1,
      anon_sym_group,
    ACTIONS(9751), 1,
      anon_sym_select,
    STATE(4960), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323801] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9721), 1,
      anon_sym_group,
    ACTIONS(9723), 1,
      anon_sym_select,
    STATE(6037), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323880] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9701), 1,
      anon_sym_group,
    ACTIONS(9703), 1,
      anon_sym_select,
    STATE(6459), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [323959] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9733), 1,
      anon_sym_group,
    ACTIONS(9735), 1,
      anon_sym_select,
    STATE(4632), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324038] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9681), 1,
      anon_sym_group,
    ACTIONS(9683), 1,
      anon_sym_select,
    STATE(5706), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324117] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9745), 1,
      anon_sym_group,
    ACTIONS(9747), 1,
      anon_sym_select,
    STATE(4589), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324196] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9693), 1,
      anon_sym_group,
    ACTIONS(9695), 1,
      anon_sym_select,
    STATE(6671), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324275] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9745), 1,
      anon_sym_group,
    ACTIONS(9747), 1,
      anon_sym_select,
    STATE(4542), 1,
      sym__select_or_group_clause,
    STATE(7477), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324354] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9705), 1,
      anon_sym_group,
    ACTIONS(9707), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324433] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9705), 1,
      anon_sym_group,
    ACTIONS(9707), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7480), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324512] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9733), 1,
      anon_sym_group,
    ACTIONS(9735), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324591] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9725), 1,
      anon_sym_group,
    ACTIONS(9727), 1,
      anon_sym_select,
    STATE(5698), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324670] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9705), 1,
      anon_sym_group,
    ACTIONS(9707), 1,
      anon_sym_select,
    STATE(5223), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324749] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9725), 1,
      anon_sym_group,
    ACTIONS(9727), 1,
      anon_sym_select,
    STATE(5753), 1,
      sym__select_or_group_clause,
    STATE(7483), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324828] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9721), 1,
      anon_sym_group,
    ACTIONS(9723), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7489), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324907] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9717), 1,
      anon_sym_group,
    ACTIONS(9719), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [324986] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9717), 1,
      anon_sym_group,
    ACTIONS(9719), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7487), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325065] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9721), 1,
      anon_sym_group,
    ACTIONS(9723), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325144] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9725), 1,
      anon_sym_group,
    ACTIONS(9727), 1,
      anon_sym_select,
    STATE(5381), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(5690), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325223] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9693), 1,
      anon_sym_group,
    ACTIONS(9695), 1,
      anon_sym_select,
    STATE(3723), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325302] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9757), 1,
      anon_sym_group,
    ACTIONS(9759), 1,
      anon_sym_select,
    STATE(5105), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325381] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9737), 1,
      anon_sym_group,
    ACTIONS(9739), 1,
      anon_sym_select,
    STATE(4504), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325460] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9737), 1,
      anon_sym_group,
    ACTIONS(9739), 1,
      anon_sym_select,
    STATE(4542), 1,
      sym__select_or_group_clause,
    STATE(7495), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325539] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9737), 1,
      anon_sym_group,
    ACTIONS(9739), 1,
      anon_sym_select,
    STATE(4589), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(4676), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325618] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9693), 1,
      anon_sym_group,
    ACTIONS(9695), 1,
      anon_sym_select,
    STATE(3645), 1,
      sym__select_or_group_clause,
    STATE(7491), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325697] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9713), 1,
      anon_sym_group,
    ACTIONS(9715), 1,
      anon_sym_select,
    STATE(6393), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3688), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325776] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9681), 1,
      anon_sym_group,
    ACTIONS(9683), 1,
      anon_sym_select,
    STATE(4016), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325855] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9681), 1,
      anon_sym_group,
    ACTIONS(9683), 1,
      anon_sym_select,
    STATE(4080), 1,
      sym__select_or_group_clause,
    STATE(7498), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [325934] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9671), 1,
      anon_sym_where,
    ACTIONS(9673), 1,
      anon_sym_from,
    ACTIONS(9675), 1,
      anon_sym_join,
    ACTIONS(9677), 1,
      anon_sym_let,
    ACTIONS(9679), 1,
      anon_sym_orderby,
    ACTIONS(9717), 1,
      anon_sym_group,
    ACTIONS(9719), 1,
      anon_sym_select,
    STATE(6002), 1,
      sym__select_or_group_clause,
    STATE(7504), 1,
      aux_sym__query_body_repeat1,
    STATE(7718), 1,
      sym__query_clause,
    STATE(3993), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326013] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9767), 1,
      anon_sym_LT,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3181), 1,
      sym_accessor_list,
    STATE(7578), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8705), 1,
      sym_type_parameter_list,
    STATE(9762), 1,
      sym_arrow_expression_clause,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326097] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9767), 1,
      anon_sym_LT,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3206), 1,
      sym_accessor_list,
    STATE(7652), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8743), 1,
      sym_type_parameter_list,
    STATE(9330), 1,
      sym_arrow_expression_clause,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326181] = 25,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9767), 1,
      anon_sym_LT,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3191), 1,
      sym_accessor_list,
    STATE(7611), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8760), 1,
      sym_type_parameter_list,
    STATE(9221), 1,
      sym_arrow_expression_clause,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326265] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9771), 1,
      anon_sym_where,
    ACTIONS(9774), 1,
      anon_sym_from,
    ACTIONS(9777), 1,
      anon_sym_join,
    ACTIONS(9780), 1,
      anon_sym_let,
    ACTIONS(9783), 1,
      anon_sym_orderby,
    STATE(7718), 1,
      sym__query_clause,
    ACTIONS(9786), 2,
      anon_sym_group,
      anon_sym_select,
    STATE(7715), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
    STATE(7504), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym__query_body_repeat1,
  [326333] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9788), 1,
      anon_sym_SEMI,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7551), 1,
      sym_type_parameter_list,
    STATE(7685), 1,
      sym_parameter_list,
    STATE(7905), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7907), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9188), 1,
      sym_declaration_list,
    STATE(7505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326407] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9798), 1,
      anon_sym_SEMI,
    STATE(7555), 1,
      sym_type_parameter_list,
    STATE(7697), 1,
      sym_parameter_list,
    STATE(7822), 1,
      sym_record_base,
    STATE(7931), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9702), 1,
      sym_declaration_list,
    STATE(7506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326481] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9800), 1,
      anon_sym_SEMI,
    STATE(7557), 1,
      sym_type_parameter_list,
    STATE(7669), 1,
      sym_parameter_list,
    STATE(7776), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7784), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9628), 1,
      sym_declaration_list,
    STATE(7507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326555] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9802), 1,
      anon_sym_SEMI,
    STATE(7550), 1,
      sym_type_parameter_list,
    STATE(7673), 1,
      sym_parameter_list,
    STATE(7900), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7903), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9259), 1,
      sym_declaration_list,
    STATE(7508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326629] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9804), 1,
      anon_sym_SEMI,
    STATE(7545), 1,
      sym_type_parameter_list,
    STATE(7675), 1,
      sym_parameter_list,
    STATE(7872), 1,
      sym_record_base,
    STATE(7875), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8995), 1,
      sym_declaration_list,
    STATE(7509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326703] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9806), 1,
      anon_sym_SEMI,
    STATE(7553), 1,
      sym_type_parameter_list,
    STATE(7686), 1,
      sym_parameter_list,
    STATE(7853), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7854), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9409), 1,
      sym_declaration_list,
    STATE(7510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326777] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9808), 1,
      anon_sym_SEMI,
    STATE(7554), 1,
      sym_type_parameter_list,
    STATE(7701), 1,
      sym_parameter_list,
    STATE(7933), 1,
      sym_record_base,
    STATE(7936), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9095), 1,
      sym_declaration_list,
    STATE(7511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326851] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9810), 1,
      anon_sym_SEMI,
    STATE(7544), 1,
      sym_type_parameter_list,
    STATE(7694), 1,
      sym_parameter_list,
    STATE(7799), 1,
      sym_record_base,
    STATE(7802), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9715), 1,
      sym_declaration_list,
    STATE(7512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326925] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9812), 1,
      anon_sym_SEMI,
    STATE(7543), 1,
      sym_type_parameter_list,
    STATE(7676), 1,
      sym_parameter_list,
    STATE(7868), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7876), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9295), 1,
      sym_declaration_list,
    STATE(7513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [326999] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9814), 1,
      anon_sym_SEMI,
    STATE(7549), 1,
      sym_type_parameter_list,
    STATE(7683), 1,
      sym_parameter_list,
    STATE(7920), 1,
      sym_record_base,
    STATE(7924), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9647), 1,
      sym_declaration_list,
    STATE(7514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327073] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9816), 1,
      anon_sym_SEMI,
    STATE(7542), 1,
      sym_type_parameter_list,
    STATE(7677), 1,
      sym_parameter_list,
    STATE(7877), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7878), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9891), 1,
      sym_declaration_list,
    STATE(7515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327147] = 22,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9818), 1,
      anon_sym_SEMI,
    STATE(7552), 1,
      sym_type_parameter_list,
    STATE(7690), 1,
      sym_parameter_list,
    STATE(7793), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7794), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9113), 1,
      sym_declaration_list,
    STATE(7516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327221] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7575), 1,
      sym_type_parameter_list,
    STATE(7762), 1,
      sym_parameter_list,
    STATE(8208), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8212), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9728), 1,
      sym_declaration_list,
    STATE(7517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327292] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7636), 1,
      sym_type_parameter_list,
    STATE(7750), 1,
      sym_parameter_list,
    STATE(8083), 1,
      sym_base_list,
    STATE(8086), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9447), 1,
      sym_declaration_list,
    STATE(7518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327363] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7650), 1,
      sym_type_parameter_list,
    STATE(7741), 1,
      sym_parameter_list,
    STATE(8168), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8170), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9903), 1,
      sym_declaration_list,
    STATE(7519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327434] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7653), 1,
      sym_type_parameter_list,
    STATE(7743), 1,
      sym_parameter_list,
    STATE(8050), 1,
      sym_base_list,
    STATE(8052), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9289), 1,
      sym_declaration_list,
    STATE(7520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327505] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7643), 1,
      sym_type_parameter_list,
    STATE(7725), 1,
      sym_parameter_list,
    STATE(8103), 1,
      sym_base_list,
    STATE(8107), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9633), 1,
      sym_declaration_list,
    STATE(7521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327576] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7593), 1,
      sym_type_parameter_list,
    STATE(7712), 1,
      sym_parameter_list,
    STATE(8181), 1,
      sym_base_list,
    STATE(8185), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9744), 1,
      sym_declaration_list,
    STATE(7522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327647] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7634), 1,
      sym_type_parameter_list,
    STATE(7729), 1,
      sym_parameter_list,
    STATE(8003), 1,
      sym_base_list,
    STATE(8005), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9252), 1,
      sym_declaration_list,
    STATE(7523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327718] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9822), 1,
      anon_sym_SEMI,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3437), 1,
      sym_accessor_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(7524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327789] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7581), 1,
      sym_type_parameter_list,
    STATE(7759), 1,
      sym_parameter_list,
    STATE(8220), 1,
      sym_base_list,
    STATE(8232), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9713), 1,
      sym_declaration_list,
    STATE(7525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327860] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    ACTIONS(9827), 1,
      anon_sym_SEMI,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3527), 1,
      sym_accessor_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(7526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [327931] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7635), 1,
      sym_type_parameter_list,
    STATE(7749), 1,
      sym_parameter_list,
    STATE(8076), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8077), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9020), 1,
      sym_declaration_list,
    STATE(7527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328002] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7572), 1,
      sym_type_parameter_list,
    STATE(7706), 1,
      sym_parameter_list,
    STATE(8152), 1,
      sym_base_list,
    STATE(8156), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9689), 1,
      sym_declaration_list,
    STATE(7528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328073] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7647), 1,
      sym_type_parameter_list,
    STATE(7728), 1,
      sym_parameter_list,
    STATE(8222), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8226), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9802), 1,
      sym_declaration_list,
    STATE(7529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328144] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9830), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    ACTIONS(3991), 6,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(7530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328197] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4140), 1,
      anon_sym_DOT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    ACTIONS(9833), 1,
      anon_sym_SEMI,
    STATE(2752), 1,
      sym_type_argument_list,
    STATE(3513), 1,
      sym_accessor_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(7531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328268] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7646), 1,
      sym_type_parameter_list,
    STATE(7747), 1,
      sym_parameter_list,
    STATE(8032), 1,
      sym_base_list,
    STATE(8033), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9470), 1,
      sym_declaration_list,
    STATE(7532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328339] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7574), 1,
      sym_type_parameter_list,
    STATE(7709), 1,
      sym_parameter_list,
    STATE(7956), 1,
      sym_base_list,
    STATE(7958), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9192), 1,
      sym_declaration_list,
    STATE(7533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328410] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7607), 1,
      sym_type_parameter_list,
    STATE(7717), 1,
      sym_parameter_list,
    STATE(7985), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7986), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9063), 1,
      sym_declaration_list,
    STATE(7534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328481] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7584), 1,
      sym_type_parameter_list,
    STATE(7768), 1,
      sym_parameter_list,
    STATE(8231), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8234), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9706), 1,
      sym_declaration_list,
    STATE(7535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328552] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7633), 1,
      sym_type_parameter_list,
    STATE(7722), 1,
      sym_parameter_list,
    STATE(8108), 1,
      sym_base_list,
    STATE(8110), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9635), 1,
      sym_declaration_list,
    STATE(7536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328623] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7648), 1,
      sym_type_parameter_list,
    STATE(7711), 1,
      sym_parameter_list,
    STATE(8134), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8139), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9401), 1,
      sym_declaration_list,
    STATE(7537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328694] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7558), 1,
      sym_type_parameter_list,
    STATE(7769), 1,
      sym_parameter_list,
    STATE(7951), 1,
      sym_base_list,
    STATE(7953), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9003), 1,
      sym_declaration_list,
    STATE(7538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328765] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7664), 1,
      sym_type_parameter_list,
    STATE(7734), 1,
      sym_parameter_list,
    STATE(8016), 1,
      sym_base_list,
    STATE(8018), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9260), 1,
      sym_declaration_list,
    STATE(7539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328836] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7667), 1,
      sym_type_parameter_list,
    STATE(7732), 1,
      sym_parameter_list,
    STATE(8200), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8204), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9856), 1,
      sym_declaration_list,
    STATE(7540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328907] = 21,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7642), 1,
      sym_type_parameter_list,
    STATE(7745), 1,
      sym_parameter_list,
    STATE(8072), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8075), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9012), 1,
      sym_declaration_list,
    STATE(7541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [328978] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9836), 1,
      anon_sym_SEMI,
    STATE(7678), 1,
      sym_parameter_list,
    STATE(7858), 1,
      sym_record_base,
    STATE(7861), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9850), 1,
      sym_declaration_list,
    STATE(7542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329046] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9838), 1,
      anon_sym_SEMI,
    STATE(7679), 1,
      sym_parameter_list,
    STATE(7857), 1,
      sym_record_base,
    STATE(7859), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(7543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329114] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9840), 1,
      anon_sym_SEMI,
    STATE(7700), 1,
      sym_parameter_list,
    STATE(7817), 1,
      sym_record_base,
    STATE(7818), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9735), 1,
      sym_declaration_list,
    STATE(7544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329182] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9842), 1,
      anon_sym_SEMI,
    STATE(7698), 1,
      sym_parameter_list,
    STATE(7937), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7938), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9099), 1,
      sym_declaration_list,
    STATE(7545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329250] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7597), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8738), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329316] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7571), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8833), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329382] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7600), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8836), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329448] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9844), 1,
      anon_sym_SEMI,
    STATE(7695), 1,
      sym_parameter_list,
    STATE(7774), 1,
      sym_record_base,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9704), 1,
      sym_declaration_list,
    STATE(7549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329516] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9846), 1,
      anon_sym_SEMI,
    STATE(7672), 1,
      sym_parameter_list,
    STATE(7883), 1,
      sym_record_base,
    STATE(7884), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9287), 1,
      sym_declaration_list,
    STATE(7550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329584] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9848), 1,
      anon_sym_SEMI,
    STATE(7674), 1,
      sym_parameter_list,
    STATE(7881), 1,
      sym_record_base,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9905), 1,
      sym_declaration_list,
    STATE(7551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329652] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9850), 1,
      anon_sym_SEMI,
    STATE(7684), 1,
      sym_parameter_list,
    STATE(7772), 1,
      sym_record_base,
    STATE(7855), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9603), 1,
      sym_declaration_list,
    STATE(7552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329720] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9852), 1,
      anon_sym_SEMI,
    STATE(7688), 1,
      sym_parameter_list,
    STATE(7790), 1,
      sym_record_base,
    STATE(7791), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9129), 1,
      sym_declaration_list,
    STATE(7553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329788] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9854), 1,
      anon_sym_SEMI,
    STATE(7670), 1,
      sym_parameter_list,
    STATE(7921), 1,
      sym_record_base,
    STATE(7923), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9234), 1,
      sym_declaration_list,
    STATE(7554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329856] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9856), 1,
      anon_sym_SEMI,
    STATE(7680), 1,
      sym_parameter_list,
    STATE(7915), 1,
      sym_record_base,
    STATE(7919), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329924] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7641), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8842), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [329990] = 20,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9858), 1,
      anon_sym_SEMI,
    STATE(7696), 1,
      sym_parameter_list,
    STATE(7833), 1,
      sym_record_base,
    STATE(7836), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9376), 1,
      sym_declaration_list,
    STATE(7557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330058] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7758), 1,
      sym_parameter_list,
    STATE(8002), 1,
      sym_base_list,
    STATE(8010), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9582), 1,
      sym_declaration_list,
    STATE(7558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330123] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8835), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330188] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2478), 1,
      sym__function_body,
    STATE(2484), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330253] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2729), 1,
      sym__function_body,
    STATE(7583), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330318] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3502), 1,
      sym__function_body,
    STATE(7609), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330383] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2701), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330448] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2662), 1,
      sym__function_body,
    STATE(2678), 1,
      sym_block,
    STATE(7589), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330513] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2436), 1,
      sym__function_body,
    STATE(2484), 1,
      sym_block,
    STATE(7624), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330578] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7707), 1,
      sym_type_parameter_list,
    STATE(8187), 1,
      sym_base_list,
    STATE(8193), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9754), 1,
      sym_declaration_list,
    STATE(7566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330643] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7744), 1,
      sym_type_parameter_list,
    STATE(8063), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8067), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9007), 1,
      sym_declaration_list,
    STATE(7567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330708] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(7668), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8884), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330771] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(7564), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8790), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330834] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2493), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330899] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2679), 1,
      sym__function_body,
    STATE(7563), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [330964] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7716), 1,
      sym_parameter_list,
    STATE(8205), 1,
      sym_base_list,
    STATE(8210), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9765), 1,
      sym_declaration_list,
    STATE(7572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331029] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8805), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331094] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7724), 1,
      sym_parameter_list,
    STATE(7999), 1,
      sym_base_list,
    STATE(8001), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9251), 1,
      sym_declaration_list,
    STATE(7574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331159] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7765), 1,
      sym_parameter_list,
    STATE(8207), 1,
      sym_base_list,
    STATE(8214), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9725), 1,
      sym_declaration_list,
    STATE(7575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331224] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2463), 1,
      sym__function_body,
    STATE(2484), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331289] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2514), 1,
      sym__function_body,
    STATE(7570), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331354] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3248), 1,
      sym__function_body,
    STATE(7655), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331419] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7751), 1,
      sym_type_parameter_list,
    STATE(8094), 1,
      sym_base_list,
    STATE(8095), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9434), 1,
      sym_declaration_list,
    STATE(7579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331484] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2697), 1,
      sym__function_body,
    STATE(7598), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331549] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7726), 1,
      sym_parameter_list,
    STATE(8019), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8031), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9591), 1,
      sym_declaration_list,
    STATE(7581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331614] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7637), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8943), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331679] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2696), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331744] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7755), 1,
      sym_parameter_list,
    STATE(8149), 1,
      sym_base_list,
    STATE(8159), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9763), 1,
      sym_declaration_list,
    STATE(7584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331809] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9868), 1,
      anon_sym_COMMA,
    STATE(7586), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9870), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331862] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9872), 1,
      anon_sym_COMMA,
    ACTIONS(9875), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7586), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_order_by_clause_repeat1,
  [331913] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_into,
    STATE(7761), 1,
      sym_join_into_clause,
    ACTIONS(9877), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [331966] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7720), 1,
      sym_type_parameter_list,
    STATE(8098), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8100), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9428), 1,
      sym_declaration_list,
    STATE(7588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332031] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2682), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332096] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2692), 1,
      sym__function_body,
    STATE(7594), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332161] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2719), 1,
      sym__function_body,
    STATE(7596), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332226] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9868), 1,
      anon_sym_COMMA,
    STATE(7585), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(9881), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332279] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      sym_parameter_list,
    STATE(8233), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8238), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9800), 1,
      sym_declaration_list,
    STATE(7593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332344] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2718), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332409] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(7632), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8728), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332472] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2706), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332537] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2487), 1,
      sym__function_body,
    STATE(7626), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332602] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9864), 1,
      anon_sym_SEMI,
    STATE(2678), 1,
      sym_block,
    STATE(2722), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9164), 1,
      sym_arrow_expression_clause,
    STATE(7598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332667] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3517), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332732] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7631), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8962), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332797] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3528), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332862] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7735), 1,
      sym_type_parameter_list,
    STATE(8022), 1,
      sym_base_list,
    STATE(8023), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9262), 1,
      sym_declaration_list,
    STATE(7602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332927] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2453), 1,
      sym__function_body,
    STATE(2484), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [332992] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3400), 1,
      sym__function_body,
    STATE(7618), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333057] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3488), 1,
      sym__function_body,
    STATE(7601), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333122] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2240), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7621), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333187] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7713), 1,
      sym_parameter_list,
    STATE(7974), 1,
      sym_base_list,
    STATE(7976), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9224), 1,
      sym_declaration_list,
    STATE(7607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333252] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2272), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333317] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3397), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333382] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7733), 1,
      sym_type_parameter_list,
    STATE(8195), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8196), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9895), 1,
      sym_declaration_list,
    STATE(7610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333447] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3444), 1,
      sym__function_body,
    STATE(7645), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333512] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3489), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333577] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2295), 1,
      sym_block,
    STATE(2303), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333642] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2223), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333707] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2490), 1,
      sym__function_body,
    STATE(7560), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333772] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3490), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333837] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2262), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7613), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333902] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3279), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [333967] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2260), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334032] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2229), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7614), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334097] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2263), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334162] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2289), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7619), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334227] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2488), 1,
      sym__function_body,
    STATE(7603), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334292] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2489), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334357] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2224), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7608), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334422] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2461), 1,
      sym__function_body,
    STATE(2484), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334487] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3309), 1,
      sym__function_body,
    STATE(7599), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334552] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7573), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8839), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334617] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2236), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334682] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(7625), 1,
      sym_parameter_list,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    STATE(8820), 1,
      sym_type_parameter_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334745] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8941), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334810] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7639), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8935), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334875] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7705), 1,
      sym_parameter_list,
    STATE(8158), 1,
      sym_base_list,
    STATE(8164), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9690), 1,
      sym_declaration_list,
    STATE(7633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [334940] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7736), 1,
      sym_parameter_list,
    STATE(8039), 1,
      sym_base_list,
    STATE(8041), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9282), 1,
      sym_declaration_list,
    STATE(7634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335005] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7719), 1,
      sym_parameter_list,
    STATE(7987), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7988), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335070] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7767), 1,
      sym_parameter_list,
    STATE(7954), 1,
      sym_base_list,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8997), 1,
      sym_declaration_list,
    STATE(7636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335135] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8913), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335200] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7654), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8901), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335265] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8895), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335330] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7559), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8893), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335395] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9883), 1,
      anon_sym_SEMI,
    STATE(2294), 1,
      sym__function_body,
    STATE(2295), 1,
      sym_block,
    STATE(7629), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9413), 1,
      sym_arrow_expression_clause,
    STATE(7641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335460] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7714), 1,
      sym_parameter_list,
    STATE(7983), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7984), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9070), 1,
      sym_declaration_list,
    STATE(7642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335525] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7708), 1,
      sym_parameter_list,
    STATE(8145), 1,
      sym_base_list,
    STATE(8146), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9688), 1,
      sym_declaration_list,
    STATE(7643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335590] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3508), 1,
      sym__function_body,
    STATE(7651), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335655] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3509), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335720] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7702), 1,
      sym_parameter_list,
    STATE(7945), 1,
      sym_base_list,
    STATE(7946), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(7646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335785] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7737), 1,
      sym_parameter_list,
    STATE(8180), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8182), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9922), 1,
      sym_declaration_list,
    STATE(7647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335850] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7766), 1,
      sym_parameter_list,
    STATE(8236), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8239), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9700), 1,
      sym_declaration_list,
    STATE(7648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335915] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7710), 1,
      sym_type_parameter_list,
    STATE(7962), 1,
      sym_base_list,
    STATE(7963), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9195), 1,
      sym_declaration_list,
    STATE(7649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [335980] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7748), 1,
      sym_parameter_list,
    STATE(7942), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8137), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9860), 1,
      sym_declaration_list,
    STATE(7650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336045] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3383), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336110] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3521), 1,
      sym__function_body,
    STATE(7666), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336175] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7746), 1,
      sym_parameter_list,
    STATE(8071), 1,
      sym_base_list,
    STATE(8073), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9319), 1,
      sym_declaration_list,
    STATE(7653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336240] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    STATE(3142), 1,
      sym_block,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8857), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336305] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3433), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336370] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3430), 1,
      sym__function_body,
    STATE(7612), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336435] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7721), 1,
      sym_type_parameter_list,
    STATE(8118), 1,
      sym_base_list,
    STATE(8121), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9645), 1,
      sym_declaration_list,
    STATE(7657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336500] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3471), 1,
      sym__function_body,
    STATE(7616), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336565] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3327), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336630] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3315), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336695] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9794), 1,
      anon_sym_LT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7764), 1,
      sym_type_parameter_list,
    STATE(8199), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8202), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9613), 1,
      sym_declaration_list,
    STATE(7661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336760] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4151), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6833), 1,
      anon_sym_LT,
    STATE(4997), 1,
      sym_type_argument_list,
    ACTIONS(9885), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(4140), 4,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DOT,
    STATE(7662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336817] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3284), 1,
      sym__function_body,
    STATE(7660), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336882] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7738), 1,
      sym_parameter_list,
    STATE(8046), 1,
      sym_base_list,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(7664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [336947] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3262), 1,
      sym__function_body,
    STATE(7659), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337012] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3234), 1,
      sym__function_body,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337077] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7740), 1,
      sym_parameter_list,
    STATE(8174), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8176), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9904), 1,
      sym_declaration_list,
    STATE(7667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337142] = 19,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9862), 1,
      anon_sym_SEMI,
    STATE(2484), 1,
      sym_block,
    STATE(2513), 1,
      sym__function_body,
    STATE(7576), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9244), 1,
      sym_arrow_expression_clause,
    STATE(7668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337207] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9858), 1,
      anon_sym_SEMI,
    STATE(7833), 1,
      sym_record_base,
    STATE(7836), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9376), 1,
      sym_declaration_list,
    STATE(7669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337269] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9888), 1,
      anon_sym_SEMI,
    STATE(7887), 1,
      sym_record_base,
    STATE(7888), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9275), 1,
      sym_declaration_list,
    STATE(7670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337331] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(3198), 1,
      sym_accessor_list,
    STATE(7663), 1,
      sym_parameter_list,
    STATE(8880), 1,
      sym_type_parameter_list,
    STATE(9896), 1,
      sym_arrow_expression_clause,
    STATE(7671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337393] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9890), 1,
      anon_sym_SEMI,
    STATE(7864), 1,
      sym_record_base,
    STATE(7865), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9317), 1,
      sym_declaration_list,
    STATE(7672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337455] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9846), 1,
      anon_sym_SEMI,
    STATE(7883), 1,
      sym_record_base,
    STATE(7884), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9287), 1,
      sym_declaration_list,
    STATE(7673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337517] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9892), 1,
      anon_sym_SEMI,
    STATE(7862), 1,
      sym_record_base,
    STATE(7863), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9862), 1,
      sym_declaration_list,
    STATE(7674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337579] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9842), 1,
      anon_sym_SEMI,
    STATE(7937), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7938), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9099), 1,
      sym_declaration_list,
    STATE(7675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337641] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9838), 1,
      anon_sym_SEMI,
    STATE(7857), 1,
      sym_record_base,
    STATE(7859), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(7676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337703] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9836), 1,
      anon_sym_SEMI,
    STATE(7858), 1,
      sym_record_base,
    STATE(7861), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9850), 1,
      sym_declaration_list,
    STATE(7677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337765] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9894), 1,
      anon_sym_SEMI,
    STATE(7771), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7829), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9829), 1,
      sym_declaration_list,
    STATE(7678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337827] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9896), 1,
      anon_sym_SEMI,
    STATE(7850), 1,
      sym_record_base,
    STATE(7851), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9348), 1,
      sym_declaration_list,
    STATE(7679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337889] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9898), 1,
      anon_sym_SEMI,
    STATE(7896), 1,
      sym_record_base,
    STATE(7899), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9952), 1,
      sym_declaration_list,
    STATE(7680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [337951] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_COLON,
    STATE(3142), 1,
      sym_block,
    STATE(3387), 1,
      sym__function_body,
    STATE(7828), 1,
      sym_constructor_initializer,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338013] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(3212), 1,
      sym_accessor_list,
    STATE(7562), 1,
      sym_parameter_list,
    STATE(8721), 1,
      sym_type_parameter_list,
    STATE(9273), 1,
      sym_arrow_expression_clause,
    STATE(7682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338075] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9844), 1,
      anon_sym_SEMI,
    STATE(7774), 1,
      sym_record_base,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9704), 1,
      sym_declaration_list,
    STATE(7683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338137] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9902), 1,
      anon_sym_SEMI,
    STATE(7841), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7842), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9851), 1,
      sym_declaration_list,
    STATE(7684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338199] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9848), 1,
      anon_sym_SEMI,
    STATE(7881), 1,
      sym_record_base,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9905), 1,
      sym_declaration_list,
    STATE(7685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338261] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9852), 1,
      anon_sym_SEMI,
    STATE(7790), 1,
      sym_record_base,
    STATE(7791), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9129), 1,
      sym_declaration_list,
    STATE(7686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338323] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(3192), 1,
      sym_accessor_list,
    STATE(7656), 1,
      sym_parameter_list,
    STATE(8771), 1,
      sym_type_parameter_list,
    STATE(9323), 1,
      sym_arrow_expression_clause,
    STATE(7687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338385] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9904), 1,
      anon_sym_SEMI,
    STATE(7778), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7779), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9618), 1,
      sym_declaration_list,
    STATE(7688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338447] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    STATE(8059), 1,
      aux_sym_record_base_repeat1,
    STATE(8324), 1,
      sym_argument_list,
    ACTIONS(9906), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338505] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9850), 1,
      anon_sym_SEMI,
    STATE(7772), 1,
      sym_record_base,
    STATE(7855), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9603), 1,
      sym_declaration_list,
    STATE(7690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338567] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9875), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338615] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9910), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338663] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_COLON,
    STATE(3142), 1,
      sym_block,
    STATE(3349), 1,
      sym__function_body,
    STATE(7788), 1,
      sym_constructor_initializer,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338725] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9840), 1,
      anon_sym_SEMI,
    STATE(7817), 1,
      sym_record_base,
    STATE(7818), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9735), 1,
      sym_declaration_list,
    STATE(7694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338787] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9912), 1,
      anon_sym_SEMI,
    STATE(7908), 1,
      sym_record_base,
    STATE(7911), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9785), 1,
      sym_declaration_list,
    STATE(7695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338849] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9914), 1,
      anon_sym_SEMI,
    STATE(7807), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7808), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9721), 1,
      sym_declaration_list,
    STATE(7696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338911] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9856), 1,
      anon_sym_SEMI,
    STATE(7915), 1,
      sym_record_base,
    STATE(7919), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [338973] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9916), 1,
      anon_sym_SEMI,
    STATE(7916), 1,
      sym_record_base,
    STATE(7918), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9237), 1,
      sym_declaration_list,
    STATE(7698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339035] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    ACTIONS(9900), 1,
      anon_sym_COLON,
    STATE(3142), 1,
      sym_block,
    STATE(3469), 1,
      sym__function_body,
    STATE(7897), 1,
      sym_constructor_initializer,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339097] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9918), 1,
      anon_sym_SEMI,
    STATE(7939), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7941), 1,
      sym_record_base,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9872), 1,
      sym_declaration_list,
    STATE(7700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339159] = 18,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9790), 1,
      anon_sym_COLON,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9854), 1,
      anon_sym_SEMI,
    STATE(7921), 1,
      sym_record_base,
    STATE(7923), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9234), 1,
      sym_declaration_list,
    STATE(7701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339221] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7996), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7998), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9561), 1,
      sym_declaration_list,
    STATE(7702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339280] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9920), 1,
      anon_sym_catch,
    ACTIONS(9922), 1,
      anon_sym_finally,
    STATE(7752), 1,
      aux_sym_try_statement_repeat1,
    STATE(8356), 1,
      sym_catch_clause,
    STATE(8990), 1,
      sym_finally_clause,
    ACTIONS(3011), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339337] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9924), 1,
      anon_sym_DQUOTE,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    STATE(7723), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339394] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8211), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8213), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9766), 1,
      sym_declaration_list,
    STATE(7705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339453] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8205), 1,
      sym_base_list,
    STATE(8210), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9765), 1,
      sym_declaration_list,
    STATE(7706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339512] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8217), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8221), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9805), 1,
      sym_declaration_list,
    STATE(7707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339571] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8197), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8201), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9764), 1,
      sym_declaration_list,
    STATE(7708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339630] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7999), 1,
      sym_base_list,
    STATE(8001), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9251), 1,
      sym_declaration_list,
    STATE(7709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339689] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8006), 1,
      sym_base_list,
    STATE(8007), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9254), 1,
      sym_declaration_list,
    STATE(7710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339748] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8236), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8239), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9700), 1,
      sym_declaration_list,
    STATE(7711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339807] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8233), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8238), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9800), 1,
      sym_declaration_list,
    STATE(7712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339866] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8028), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8029), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9269), 1,
      sym_declaration_list,
    STATE(7713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339925] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7977), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7978), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9226), 1,
      sym_declaration_list,
    STATE(7714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [339984] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9930), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340031] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8190), 1,
      sym_base_list,
    STATE(8191), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9961), 1,
      sym_declaration_list,
    STATE(7716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340090] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7974), 1,
      sym_base_list,
    STATE(7976), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9224), 1,
      sym_declaration_list,
    STATE(7717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340149] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9932), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340196] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7972), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7973), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9223), 1,
      sym_declaration_list,
    STATE(7719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340255] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8227), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8229), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9708), 1,
      sym_declaration_list,
    STATE(7720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340314] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7943), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8169), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9694), 1,
      sym_declaration_list,
    STATE(7721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340373] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8158), 1,
      sym_base_list,
    STATE(8164), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9690), 1,
      sym_declaration_list,
    STATE(7722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340432] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9934), 1,
      anon_sym_DQUOTE,
    STATE(7756), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340489] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8037), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8038), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9281), 1,
      sym_declaration_list,
    STATE(7724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340548] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8145), 1,
      sym_base_list,
    STATE(8146), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9688), 1,
      sym_declaration_list,
    STATE(7725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340607] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8209), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8218), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9682), 1,
      sym_declaration_list,
    STATE(7726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340666] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8183), 1,
      sym_base_list,
    STATE(8184), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9930), 1,
      sym_declaration_list,
    STATE(7727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340725] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8180), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8182), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9922), 1,
      sym_declaration_list,
    STATE(7728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340784] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8039), 1,
      sym_base_list,
    STATE(8041), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9282), 1,
      sym_declaration_list,
    STATE(7729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340843] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9936), 1,
      anon_sym_DQUOTE,
    STATE(7756), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340900] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9938), 1,
      anon_sym_DQUOTE,
    STATE(7742), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [340957] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8174), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8176), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9904), 1,
      sym_declaration_list,
    STATE(7732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341016] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8162), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8166), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9900), 1,
      sym_declaration_list,
    STATE(7733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341075] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8046), 1,
      sym_base_list,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(7734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341134] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8053), 1,
      sym_base_list,
    STATE(8054), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9291), 1,
      sym_declaration_list,
    STATE(7735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341193] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8065), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8066), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9311), 1,
      sym_declaration_list,
    STATE(7736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341252] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8148), 1,
      sym_base_list,
    STATE(8150), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9868), 1,
      sym_declaration_list,
    STATE(7737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341311] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8069), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8070), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9318), 1,
      sym_declaration_list,
    STATE(7738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341370] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9940), 1,
      anon_sym_DQUOTE,
    STATE(7730), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341427] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8141), 1,
      sym_base_list,
    STATE(8142), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9861), 1,
      sym_declaration_list,
    STATE(7740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341486] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7942), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8137), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9860), 1,
      sym_declaration_list,
    STATE(7741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341545] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9942), 1,
      anon_sym_DQUOTE,
    STATE(7756), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341602] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8071), 1,
      sym_base_list,
    STATE(8073), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9319), 1,
      sym_declaration_list,
    STATE(7743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341661] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7967), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7969), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9078), 1,
      sym_declaration_list,
    STATE(7744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341720] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7983), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7984), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9070), 1,
      sym_declaration_list,
    STATE(7745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341779] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8081), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8082), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9340), 1,
      sym_declaration_list,
    STATE(7746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341838] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7945), 1,
      sym_base_list,
    STATE(7946), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(7747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341897] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8127), 1,
      sym_base_list,
    STATE(8129), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9838), 1,
      sym_declaration_list,
    STATE(7748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [341956] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7987), 1,
      aux_sym_class_declaration_repeat3,
    STATE(7988), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(7749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342015] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7954), 1,
      sym_base_list,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8997), 1,
      sym_declaration_list,
    STATE(7750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342074] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7971), 1,
      sym_base_list,
    STATE(7989), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9052), 1,
      sym_declaration_list,
    STATE(7751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342133] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9920), 1,
      anon_sym_catch,
    ACTIONS(9922), 1,
      anon_sym_finally,
    STATE(7831), 1,
      aux_sym_try_statement_repeat1,
    STATE(8356), 1,
      sym_catch_clause,
    STATE(8966), 1,
      sym_finally_clause,
    ACTIONS(3003), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(7752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342190] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9944), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342237] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9946), 1,
      anon_sym_DQUOTE,
    STATE(7757), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342294] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(7961), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8230), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9669), 1,
      sym_declaration_list,
    STATE(7755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342353] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9948), 1,
      anon_sym_DQUOTE,
    ACTIONS(9953), 1,
      sym_interpolation_open_brace,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9950), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7756), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat1,
  [342408] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9956), 1,
      anon_sym_DQUOTE,
    STATE(7756), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342465] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8113), 1,
      sym_base_list,
    STATE(8116), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9793), 1,
      sym_declaration_list,
    STATE(7758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342524] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8019), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8031), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9591), 1,
      sym_declaration_list,
    STATE(7759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342583] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9958), 1,
      anon_sym_DQUOTE,
    STATE(7756), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342640] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9960), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    STATE(7761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342687] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8207), 1,
      sym_base_list,
    STATE(8214), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9725), 1,
      sym_declaration_list,
    STATE(7762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342746] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9962), 1,
      anon_sym_DQUOTE,
    STATE(7760), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(8335), 1,
      sym_interpolation,
    STATE(8339), 1,
      sym__interpolated_string_content,
    ACTIONS(9926), 2,
      sym_interpolation_string_content,
      sym_escape_sequence,
    STATE(7763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342803] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8235), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8237), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9692), 1,
      sym_declaration_list,
    STATE(7764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342862] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8104), 1,
      sym_base_list,
    STATE(8206), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9855), 1,
      sym_declaration_list,
    STATE(7765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342921] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8114), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8130), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9825), 1,
      sym_declaration_list,
    STATE(7766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [342980] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8012), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8017), 1,
      sym_base_list,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9587), 1,
      sym_declaration_list,
    STATE(7767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343039] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8149), 1,
      sym_base_list,
    STATE(8159), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9763), 1,
      sym_declaration_list,
    STATE(7768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343098] = 17,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9820), 1,
      anon_sym_COLON,
    STATE(8002), 1,
      sym_base_list,
    STATE(8010), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9582), 1,
      sym_declaration_list,
    STATE(7769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343157] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3499), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343213] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9964), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9817), 1,
      sym_declaration_list,
    STATE(7771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343269] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9902), 1,
      anon_sym_SEMI,
    STATE(7841), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9851), 1,
      sym_declaration_list,
    STATE(7772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343325] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9966), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9907), 1,
      sym_declaration_list,
    STATE(7773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343381] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9912), 1,
      anon_sym_SEMI,
    STATE(7911), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9785), 1,
      sym_declaration_list,
    STATE(7774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343437] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3493), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343493] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9858), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9376), 1,
      sym_declaration_list,
    STATE(7776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343549] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9968), 1,
      anon_sym_SEMI,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(4333), 1,
      sym__function_body,
    STATE(4357), 1,
      sym_block,
    STATE(9058), 1,
      sym_arrow_expression_clause,
    STATE(7777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343605] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9972), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9875), 1,
      sym_declaration_list,
    STATE(7778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343661] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9972), 1,
      anon_sym_SEMI,
    STATE(7909), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9875), 1,
      sym_declaration_list,
    STATE(7779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343717] = 12,
    ACTIONS(3991), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(3993), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(7780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343765] = 12,
    ACTIONS(4122), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(4120), 5,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(7781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343813] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9974), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343859] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9976), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343905] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9858), 1,
      anon_sym_SEMI,
    STATE(7836), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9376), 1,
      sym_declaration_list,
    STATE(7784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [343961] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9978), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344007] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9980), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
    STATE(7786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344053] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9982), 1,
      anon_sym_EQ,
    ACTIONS(4320), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    STATE(7787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344103] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3456), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344159] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9984), 1,
      anon_sym_DQUOTE,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    STATE(7795), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344215] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9904), 1,
      anon_sym_SEMI,
    STATE(7778), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9618), 1,
      sym_declaration_list,
    STATE(7790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344271] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9904), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9618), 1,
      sym_declaration_list,
    STATE(7791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344327] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(9992), 1,
      anon_sym_DQUOTE,
    STATE(7804), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344383] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9850), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9603), 1,
      sym_declaration_list,
    STATE(7793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344439] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9850), 1,
      anon_sym_SEMI,
    STATE(7855), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9603), 1,
      sym_declaration_list,
    STATE(7794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344495] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(9994), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344551] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9962), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7805), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344607] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9962), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7806), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344663] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10002), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344717] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9840), 1,
      anon_sym_SEMI,
    STATE(7818), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9735), 1,
      sym_declaration_list,
    STATE(7799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344773] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(4453), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344827] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(7801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344883] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9840), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9735), 1,
      sym_declaration_list,
    STATE(7802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344939] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3485), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [344995] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10008), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345051] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9958), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7823), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345107] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9958), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7816), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345163] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10010), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9885), 1,
      sym_declaration_list,
    STATE(7807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345219] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10010), 1,
      anon_sym_SEMI,
    STATE(7940), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9885), 1,
      sym_declaration_list,
    STATE(7808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345275] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10012), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345329] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10016), 1,
      anon_sym_where,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    ACTIONS(10014), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(7810), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_class_declaration_repeat3,
  [345379] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3401), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345435] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(10019), 1,
      anon_sym_COMMA,
    STATE(8345), 1,
      aux_sym_base_list_repeat1,
    STATE(8346), 1,
      sym_argument_list,
    ACTIONS(10021), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345489] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3368), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345545] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10023), 1,
      anon_sym_DQUOTE,
    STATE(7925), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345601] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9956), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7816), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345657] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10025), 1,
      sym_interpolation_end_quote,
    ACTIONS(10027), 1,
      sym_interpolation_open_brace,
    ACTIONS(10030), 1,
      sym_interpolation_string_content,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7816), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat3,
  [345711] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9918), 1,
      anon_sym_SEMI,
    STATE(7939), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9872), 1,
      sym_declaration_list,
    STATE(7817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345767] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9918), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9872), 1,
      sym_declaration_list,
    STATE(7818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345823] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9956), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7823), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345879] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_COMMA,
    STATE(7922), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(10033), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345929] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3282), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [345985] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9856), 1,
      anon_sym_SEMI,
    STATE(7919), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346041] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10037), 1,
      anon_sym_DQUOTE,
    ACTIONS(10039), 1,
      sym_interpolation_open_brace,
    ACTIONS(10042), 1,
      sym_interpolation_string_content,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7823), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_interpolated_string_expression_repeat2,
  [346095] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10045), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9812), 1,
      sym_declaration_list,
    STATE(7824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346151] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3522), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346207] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10047), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346263] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9946), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7815), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346319] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3299), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346375] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9964), 1,
      anon_sym_SEMI,
    STATE(7824), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9817), 1,
      sym_declaration_list,
    STATE(7829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346431] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9946), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7819), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346487] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10049), 1,
      anon_sym_catch,
    STATE(8356), 1,
      sym_catch_clause,
    ACTIONS(3015), 3,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_else,
    STATE(7831), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_try_statement_repeat1,
  [346537] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10052), 1,
      anon_sym_DQUOTE,
    STATE(7826), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346593] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9914), 1,
      anon_sym_SEMI,
    STATE(7807), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9721), 1,
      sym_declaration_list,
    STATE(7833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346649] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10056), 1,
      anon_sym_QMARK,
    ACTIONS(10054), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346697] = 15,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10058), 1,
      anon_sym_DQUOTE,
    ACTIONS(10060), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10063), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(10066), 1,
      sym_escape_sequence,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7835), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_string_literal_repeat1,
  [346751] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9914), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9721), 1,
      sym_declaration_list,
    STATE(7836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346807] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_COMMA,
    STATE(7820), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(10069), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346857] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346911] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3520), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [346967] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3428), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347023] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10071), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9439), 1,
      sym_declaration_list,
    STATE(7841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347079] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10071), 1,
      anon_sym_SEMI,
    STATE(7860), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9439), 1,
      sym_declaration_list,
    STATE(7842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347135] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    STATE(8026), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10073), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347187] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3414), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347243] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3526), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347299] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(10075), 1,
      anon_sym_LPAREN,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2239), 1,
      sym_block,
    STATE(8327), 1,
      sym_catch_declaration,
    STATE(8816), 1,
      sym_catch_filter_clause,
    STATE(7846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347355] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9968), 1,
      anon_sym_SEMI,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(4338), 1,
      sym__function_body,
    STATE(4357), 1,
      sym_block,
    STATE(9058), 1,
      sym_arrow_expression_clause,
    STATE(7847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347411] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10079), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9360), 1,
      sym_declaration_list,
    STATE(7848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347467] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3495), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347523] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10081), 1,
      anon_sym_SEMI,
    STATE(7848), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9356), 1,
      sym_declaration_list,
    STATE(7850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347579] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10081), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9356), 1,
      sym_declaration_list,
    STATE(7851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347635] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10083), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9352), 1,
      sym_declaration_list,
    STATE(7852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347691] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9852), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9129), 1,
      sym_declaration_list,
    STATE(7853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347747] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9852), 1,
      anon_sym_SEMI,
    STATE(7791), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9129), 1,
      sym_declaration_list,
    STATE(7854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347803] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9902), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9851), 1,
      sym_declaration_list,
    STATE(7855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347859] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10085), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9821), 1,
      sym_declaration_list,
    STATE(7856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347915] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9896), 1,
      anon_sym_SEMI,
    STATE(7851), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9348), 1,
      sym_declaration_list,
    STATE(7857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [347971] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9894), 1,
      anon_sym_SEMI,
    STATE(7771), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9829), 1,
      sym_declaration_list,
    STATE(7858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348027] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9896), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9348), 1,
      sym_declaration_list,
    STATE(7859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348083] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9441), 1,
      sym_declaration_list,
    STATE(7860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348139] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9894), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9829), 1,
      sym_declaration_list,
    STATE(7861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348195] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10089), 1,
      anon_sym_SEMI,
    STATE(7856), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9841), 1,
      sym_declaration_list,
    STATE(7862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348251] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10089), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9841), 1,
      sym_declaration_list,
    STATE(7863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348307] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10091), 1,
      anon_sym_SEMI,
    STATE(7852), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9337), 1,
      sym_declaration_list,
    STATE(7864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348363] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10091), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9337), 1,
      sym_declaration_list,
    STATE(7865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348419] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10093), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9847), 1,
      sym_declaration_list,
    STATE(7866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348475] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10095), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9329), 1,
      sym_declaration_list,
    STATE(7867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348531] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9838), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(7868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348587] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(10075), 1,
      anon_sym_LPAREN,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2217), 1,
      sym_block,
    STATE(8301), 1,
      sym_catch_declaration,
    STATE(8853), 1,
      sym_catch_filter_clause,
    STATE(7869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348643] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10097), 1,
      anon_sym_DQUOTE,
    STATE(7893), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348699] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9942), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7816), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348755] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9842), 1,
      anon_sym_SEMI,
    STATE(7937), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9099), 1,
      sym_declaration_list,
    STATE(7872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348811] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10099), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348865] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9942), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7823), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348921] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9842), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9099), 1,
      sym_declaration_list,
    STATE(7875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [348977] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9838), 1,
      anon_sym_SEMI,
    STATE(7859), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9326), 1,
      sym_declaration_list,
    STATE(7876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349033] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9836), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9850), 1,
      sym_declaration_list,
    STATE(7877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349089] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9836), 1,
      anon_sym_SEMI,
    STATE(7861), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9850), 1,
      sym_declaration_list,
    STATE(7878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349145] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9982), 1,
      anon_sym_EQ,
    ACTIONS(10101), 1,
      anon_sym_RPAREN,
    ACTIONS(4320), 3,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_or,
    STATE(7879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349197] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3421), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349253] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9892), 1,
      anon_sym_SEMI,
    STATE(7863), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9862), 1,
      sym_declaration_list,
    STATE(7881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349309] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9940), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7906), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349365] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9890), 1,
      anon_sym_SEMI,
    STATE(7865), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9317), 1,
      sym_declaration_list,
    STATE(7883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349421] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9890), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9317), 1,
      sym_declaration_list,
    STATE(7884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349477] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9892), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9862), 1,
      sym_declaration_list,
    STATE(7885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349533] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10103), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9303), 1,
      sym_declaration_list,
    STATE(7886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349589] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10105), 1,
      anon_sym_SEMI,
    STATE(7867), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9300), 1,
      sym_declaration_list,
    STATE(7887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349645] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10105), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9300), 1,
      sym_declaration_list,
    STATE(7888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349701] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9940), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7913), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349757] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10107), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349811] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10109), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349867] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10111), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9879), 1,
      sym_declaration_list,
    STATE(7892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349923] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10113), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [349979] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9938), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7871), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350035] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10115), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350089] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10117), 1,
      anon_sym_SEMI,
    STATE(7866), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9881), 1,
      sym_declaration_list,
    STATE(7896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350145] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3524), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350201] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9938), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7874), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350257] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10117), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9881), 1,
      sym_declaration_list,
    STATE(7899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350313] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9846), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9287), 1,
      sym_declaration_list,
    STATE(7900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350369] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9934), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7816), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350425] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9968), 1,
      anon_sym_SEMI,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(4339), 1,
      sym__function_body,
    STATE(4357), 1,
      sym_block,
    STATE(9058), 1,
      sym_arrow_expression_clause,
    STATE(7902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350481] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9846), 1,
      anon_sym_SEMI,
    STATE(7884), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9287), 1,
      sym_declaration_list,
    STATE(7903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350537] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9934), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7823), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350593] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9848), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9905), 1,
      sym_declaration_list,
    STATE(7905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350649] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9936), 1,
      anon_sym_DQUOTE,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7823), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350705] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9848), 1,
      anon_sym_SEMI,
    STATE(7885), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9905), 1,
      sym_declaration_list,
    STATE(7907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350761] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10119), 1,
      anon_sym_SEMI,
    STATE(7892), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9949), 1,
      sym_declaration_list,
    STATE(7908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350817] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10121), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9512), 1,
      sym_declaration_list,
    STATE(7909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350873] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10123), 1,
      anon_sym_DQUOTE,
    STATE(7891), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350929] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10119), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9949), 1,
      sym_declaration_list,
    STATE(7911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [350985] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3285), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351041] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9936), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7816), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351097] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3274), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351153] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9898), 1,
      anon_sym_SEMI,
    STATE(7899), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9952), 1,
      sym_declaration_list,
    STATE(7915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351209] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10125), 1,
      anon_sym_SEMI,
    STATE(7886), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9277), 1,
      sym_declaration_list,
    STATE(7916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351265] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3425), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351321] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10125), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9277), 1,
      sym_declaration_list,
    STATE(7918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351377] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9898), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9952), 1,
      sym_declaration_list,
    STATE(7919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351433] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9844), 1,
      anon_sym_SEMI,
    STATE(7935), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9704), 1,
      sym_declaration_list,
    STATE(7920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351489] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9888), 1,
      anon_sym_SEMI,
    STATE(7888), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9275), 1,
      sym_declaration_list,
    STATE(7921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351545] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10129), 1,
      anon_sym_COMMA,
    ACTIONS(10127), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7922), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_constraints_clause_repeat1,
  [351593] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9888), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9275), 1,
      sym_declaration_list,
    STATE(7923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351649] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9844), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9704), 1,
      sym_declaration_list,
    STATE(7924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351705] = 16,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(9986), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(9988), 1,
      aux_sym_string_literal_content_token2,
    ACTIONS(9990), 1,
      sym_escape_sequence,
    ACTIONS(10132), 1,
      anon_sym_DQUOTE,
    STATE(7835), 1,
      aux_sym_string_literal_repeat1,
    STATE(8322), 1,
      sym_string_literal_content,
    STATE(7925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351761] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    ACTIONS(9860), 1,
      anon_sym_SEMI,
    ACTIONS(9866), 1,
      anon_sym_LBRACE,
    STATE(3142), 1,
      sym_block,
    STATE(3483), 1,
      sym__function_body,
    STATE(9722), 1,
      sym_arrow_expression_clause,
    STATE(7926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351817] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(10075), 1,
      anon_sym_LPAREN,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(8247), 1,
      sym_catch_declaration,
    STATE(8357), 1,
      sym_block,
    STATE(8753), 1,
      sym_catch_filter_clause,
    STATE(7927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351873] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10134), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351927] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(10075), 1,
      anon_sym_LPAREN,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2649), 1,
      sym_block,
    STATE(8351), 1,
      sym_catch_declaration,
    STATE(8827), 1,
      sym_catch_filter_clause,
    STATE(7929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [351983] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7399), 1,
      anon_sym_LT,
    ACTIONS(7401), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10136), 1,
      anon_sym_EQ,
    STATE(2752), 1,
      sym_type_argument_list,
    ACTIONS(4140), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
    STATE(7930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352037] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9856), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9777), 1,
      sym_declaration_list,
    STATE(7931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352093] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9924), 1,
      anon_sym_DQUOTE,
    ACTIONS(9928), 1,
      sym_interpolation_open_brace,
    ACTIONS(9996), 1,
      sym_interpolation_string_content,
    STATE(7904), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(8379), 1,
      sym__interpolated_verbatim_string_content,
    STATE(8559), 1,
      sym_interpolation,
    STATE(7932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352149] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9854), 1,
      anon_sym_SEMI,
    STATE(7923), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9234), 1,
      sym_declaration_list,
    STATE(7933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352205] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9924), 1,
      sym_interpolation_end_quote,
    ACTIONS(9998), 1,
      sym_interpolation_open_brace,
    ACTIONS(10000), 1,
      sym_interpolation_string_content,
    STATE(7901), 1,
      aux_sym_interpolated_string_expression_repeat3,
    STATE(8384), 1,
      sym_interpolation,
    STATE(8388), 1,
      sym__interpolated_raw_string_content,
    STATE(7934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352261] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9912), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9785), 1,
      sym_declaration_list,
    STATE(7935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352317] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9854), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9234), 1,
      sym_declaration_list,
    STATE(7936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352373] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9916), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9237), 1,
      sym_declaration_list,
    STATE(7937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352429] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(9916), 1,
      anon_sym_SEMI,
    STATE(7918), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9237), 1,
      sym_declaration_list,
    STATE(7938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352485] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10138), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9494), 1,
      sym_declaration_list,
    STATE(7939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352541] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10140), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9854), 1,
      sym_declaration_list,
    STATE(7940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352597] = 16,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10138), 1,
      anon_sym_SEMI,
    STATE(7773), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9494), 1,
      sym_declaration_list,
    STATE(7941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352653] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9838), 1,
      sym_declaration_list,
    STATE(7942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352706] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9767), 1,
      sym_declaration_list,
    STATE(7943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352759] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10142), 1,
      anon_sym_RPAREN,
    ACTIONS(10146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10144), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352810] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7996), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9561), 1,
      sym_declaration_list,
    STATE(7945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352863] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9561), 1,
      sym_declaration_list,
    STATE(7946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352916] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10150), 1,
      anon_sym_LBRACE,
    STATE(4658), 1,
      sym_block,
    STATE(8948), 1,
      sym_parameter_list,
    STATE(7947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [352969] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10152), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(7948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353014] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10160), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353065] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10162), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353110] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8010), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9582), 1,
      sym_declaration_list,
    STATE(7951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353163] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10164), 1,
      anon_sym_RBRACE,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    STATE(8045), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(7952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353216] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9582), 1,
      sym_declaration_list,
    STATE(7953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353269] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8012), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9587), 1,
      sym_declaration_list,
    STATE(7954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353322] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(10170), 1,
      anon_sym_LPAREN,
    STATE(8927), 1,
      sym_attribute_argument_list,
    ACTIONS(9359), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353373] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8001), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9251), 1,
      sym_declaration_list,
    STATE(7956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353426] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9587), 1,
      sym_declaration_list,
    STATE(7957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353479] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9251), 1,
      sym_declaration_list,
    STATE(7958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353532] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10172), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353583] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7564), 1,
      sym_parameter_list,
    STATE(8790), 1,
      sym_type_parameter_list,
    STATE(7960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353636] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9666), 1,
      sym_declaration_list,
    STATE(7961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353689] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8008), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9256), 1,
      sym_declaration_list,
    STATE(7962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353742] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9256), 1,
      sym_declaration_list,
    STATE(7963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353795] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_EQ,
    STATE(8681), 1,
      sym_bracketed_argument_list,
    ACTIONS(9761), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(7964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353846] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9229), 1,
      sym_declaration_list,
    STATE(7965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353899] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10174), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [353950] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9227), 1,
      sym_declaration_list,
    STATE(7967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354003] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10176), 1,
      anon_sym_LBRACE,
    STATE(5728), 1,
      sym_block,
    STATE(8885), 1,
      sym_parameter_list,
    STATE(7968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354056] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7980), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9227), 1,
      sym_declaration_list,
    STATE(7969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354109] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10176), 1,
      anon_sym_LBRACE,
    STATE(5677), 1,
      sym_block,
    STATE(8961), 1,
      sym_parameter_list,
    STATE(7970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354162] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8021), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9589), 1,
      sym_declaration_list,
    STATE(7971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354215] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9268), 1,
      sym_declaration_list,
    STATE(7972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354268] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8027), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9268), 1,
      sym_declaration_list,
    STATE(7973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354321] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8028), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9269), 1,
      sym_declaration_list,
    STATE(7974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354374] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(3711), 1,
      sym_block,
    STATE(8775), 1,
      sym_parameter_list,
    STATE(7975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354427] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9269), 1,
      sym_declaration_list,
    STATE(7976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354480] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(7977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354533] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8030), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9270), 1,
      sym_declaration_list,
    STATE(7978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354586] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10180), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(7979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354637] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9271), 1,
      sym_declaration_list,
    STATE(7980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354690] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10182), 1,
      anon_sym_COMMA,
    ACTIONS(10184), 1,
      anon_sym_RBRACK,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    STATE(8417), 1,
      aux_sym_list_pattern_repeat1,
    STATE(7981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354743] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9778), 1,
      sym_declaration_list,
    STATE(7982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354796] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9226), 1,
      sym_declaration_list,
    STATE(7983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354849] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7977), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9226), 1,
      sym_declaration_list,
    STATE(7984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354902] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9224), 1,
      sym_declaration_list,
    STATE(7985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [354955] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7976), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9224), 1,
      sym_declaration_list,
    STATE(7986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355008] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9223), 1,
      sym_declaration_list,
    STATE(7987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355061] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7972), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9223), 1,
      sym_declaration_list,
    STATE(7988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355114] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9589), 1,
      sym_declaration_list,
    STATE(7989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355167] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9696), 1,
      sym_declaration_list,
    STATE(7990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355220] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(4453), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(7991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355271] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9592), 1,
      sym_declaration_list,
    STATE(7992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355324] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    ACTIONS(10021), 1,
      anon_sym_LBRACE,
    ACTIONS(10190), 1,
      anon_sym_COMMA,
    STATE(8646), 1,
      sym_argument_list,
    STATE(8649), 1,
      aux_sym_base_list_repeat1,
    STATE(7993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355377] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10192), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355422] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10194), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(7995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355467] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9790), 1,
      sym_declaration_list,
    STATE(7996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355520] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10196), 1,
      anon_sym_STAR,
    STATE(3765), 1,
      sym_block,
    STATE(8745), 1,
      sym_parameter_list,
    STATE(7997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355573] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8126), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9790), 1,
      sym_declaration_list,
    STATE(7998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355626] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8037), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9281), 1,
      sym_declaration_list,
    STATE(7999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355679] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8993), 1,
      sym_declaration_list,
    STATE(8000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355732] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9281), 1,
      sym_declaration_list,
    STATE(8001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355785] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8116), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9793), 1,
      sym_declaration_list,
    STATE(8002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355838] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8041), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9282), 1,
      sym_declaration_list,
    STATE(8003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355891] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10198), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355942] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9282), 1,
      sym_declaration_list,
    STATE(8005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [355995] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8042), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9283), 1,
      sym_declaration_list,
    STATE(8006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356048] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9283), 1,
      sym_declaration_list,
    STATE(8007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356101] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9284), 1,
      sym_declaration_list,
    STATE(8008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356154] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10200), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356199] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9793), 1,
      sym_declaration_list,
    STATE(8010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356252] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(3669), 1,
      sym_block,
    STATE(8938), 1,
      sym_parameter_list,
    STATE(8011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356305] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9809), 1,
      sym_declaration_list,
    STATE(8012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356358] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(10202), 1,
      anon_sym_EQ,
    STATE(8569), 1,
      sym_bracketed_argument_list,
    ACTIONS(10204), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356409] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10206), 1,
      anon_sym_LBRACE,
    STATE(3958), 1,
      sym_block,
    STATE(8891), 1,
      sym_parameter_list,
    STATE(8014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356462] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10150), 1,
      anon_sym_LBRACE,
    STATE(4680), 1,
      sym_block,
    STATE(8911), 1,
      sym_parameter_list,
    STATE(8015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356515] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8048), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(8016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356568] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8111), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9809), 1,
      sym_declaration_list,
    STATE(8017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356621] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9288), 1,
      sym_declaration_list,
    STATE(8018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356674] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9682), 1,
      sym_declaration_list,
    STATE(8019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356727] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10208), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356778] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9831), 1,
      sym_declaration_list,
    STATE(8021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356831] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8055), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9292), 1,
      sym_declaration_list,
    STATE(8022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356884] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9292), 1,
      sym_declaration_list,
    STATE(8023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356937] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [356990] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10210), 1,
      anon_sym_RBRACE,
    STATE(8099), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357043] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    STATE(8090), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10212), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357092] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9296), 1,
      sym_declaration_list,
    STATE(8027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357145] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9297), 1,
      sym_declaration_list,
    STATE(8028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357198] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8062), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9297), 1,
      sym_declaration_list,
    STATE(8029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357251] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9298), 1,
      sym_declaration_list,
    STATE(8030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357304] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8209), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9682), 1,
      sym_declaration_list,
    STATE(8031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357357] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7946), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(8032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357410] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9000), 1,
      sym_declaration_list,
    STATE(8033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357463] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9241), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9243), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10214), 1,
      aux_sym_preproc_if_token3,
    STATE(9807), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(8034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357514] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10206), 1,
      anon_sym_LBRACE,
    STATE(4034), 1,
      sym_block,
    STATE(8792), 1,
      sym_parameter_list,
    STATE(8035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357567] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357620] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9309), 1,
      sym_declaration_list,
    STATE(8037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357673] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8064), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9309), 1,
      sym_declaration_list,
    STATE(8038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357726] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8065), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9311), 1,
      sym_declaration_list,
    STATE(8039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357779] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10216), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357830] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9311), 1,
      sym_declaration_list,
    STATE(8041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357883] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9312), 1,
      sym_declaration_list,
    STATE(8042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357936] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10218), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [357987] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(4134), 1,
      sym_block,
    STATE(8905), 1,
      sym_parameter_list,
    STATE(8044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358040] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10222), 1,
      anon_sym_RBRACE,
    STATE(8097), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358093] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8069), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9318), 1,
      sym_declaration_list,
    STATE(8046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358146] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10224), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358197] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9318), 1,
      sym_declaration_list,
    STATE(8048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358250] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10226), 1,
      anon_sym_RBRACE,
    STATE(8097), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358303] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8073), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9319), 1,
      sym_declaration_list,
    STATE(8050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358356] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10228), 1,
      anon_sym_COMMA,
    ACTIONS(10230), 1,
      anon_sym_RBRACK,
    STATE(8669), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358409] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9319), 1,
      sym_declaration_list,
    STATE(8052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358462] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8074), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9320), 1,
      sym_declaration_list,
    STATE(8053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358515] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9320), 1,
      sym_declaration_list,
    STATE(8054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358568] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9321), 1,
      sym_declaration_list,
    STATE(8055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358621] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(3772), 1,
      sym_block,
    STATE(8813), 1,
      sym_parameter_list,
    STATE(8056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358674] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(6645), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_or,
    STATE(8057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358721] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10234), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10232), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358768] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9908), 1,
      anon_sym_COMMA,
    STATE(8090), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(10236), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358817] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10240), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10238), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358864] = 13,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10240), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10238), 2,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358913] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9327), 1,
      sym_declaration_list,
    STATE(8062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [358966] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9082), 1,
      sym_declaration_list,
    STATE(8063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359019] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9334), 1,
      sym_declaration_list,
    STATE(8064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359072] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9335), 1,
      sym_declaration_list,
    STATE(8065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359125] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8078), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9335), 1,
      sym_declaration_list,
    STATE(8066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359178] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7965), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9082), 1,
      sym_declaration_list,
    STATE(8067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359231] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10238), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10240), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359282] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9338), 1,
      sym_declaration_list,
    STATE(8069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359335] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8080), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9338), 1,
      sym_declaration_list,
    STATE(8070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359388] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8081), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9340), 1,
      sym_declaration_list,
    STATE(8071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359441] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9070), 1,
      sym_declaration_list,
    STATE(8072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359494] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9340), 1,
      sym_declaration_list,
    STATE(8073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359547] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9341), 1,
      sym_declaration_list,
    STATE(8074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359600] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7983), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9070), 1,
      sym_declaration_list,
    STATE(8075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359653] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(8076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359706] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7987), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9060), 1,
      sym_declaration_list,
    STATE(8077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359759] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9350), 1,
      sym_declaration_list,
    STATE(8078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359812] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10242), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359863] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9353), 1,
      sym_declaration_list,
    STATE(8080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359916] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9354), 1,
      sym_declaration_list,
    STATE(8081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [359969] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8085), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9354), 1,
      sym_declaration_list,
    STATE(8082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360022] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7957), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8997), 1,
      sym_declaration_list,
    STATE(8083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360075] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(10244), 1,
      anon_sym_EQ,
    STATE(8562), 1,
      sym_bracketed_argument_list,
    ACTIONS(9761), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360126] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9357), 1,
      sym_declaration_list,
    STATE(8085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360179] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8997), 1,
      sym_declaration_list,
    STATE(8086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360232] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(4304), 1,
      sym_block,
    STATE(8803), 1,
      sym_parameter_list,
    STATE(8087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360285] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7668), 1,
      sym_parameter_list,
    STATE(8884), 1,
      sym_type_parameter_list,
    STATE(8088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360338] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7625), 1,
      sym_parameter_list,
    STATE(8820), 1,
      sym_type_parameter_list,
    STATE(8089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360391] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10248), 1,
      anon_sym_COMMA,
    ACTIONS(10246), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8090), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_record_base_repeat1,
  [360438] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(10246), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360485] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9365), 1,
      sym_declaration_list,
    STATE(8092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360538] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10251), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360589] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7992), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9055), 1,
      sym_declaration_list,
    STATE(8094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360642] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9055), 1,
      sym_declaration_list,
    STATE(8095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360695] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8706), 1,
      anon_sym_COLON,
    ACTIONS(10253), 1,
      anon_sym_when,
    ACTIONS(10255), 1,
      anon_sym_and,
    ACTIONS(10257), 1,
      anon_sym_or,
    STATE(9940), 1,
      sym_when_clause,
    STATE(8096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360748] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10259), 1,
      anon_sym_RBRACE,
    ACTIONS(10261), 1,
      anon_sym_case,
    ACTIONS(10264), 1,
      anon_sym_default,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8097), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_switch_body_repeat1,
  [360799] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(8098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360852] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10267), 1,
      anon_sym_RBRACE,
    STATE(8097), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360905] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8225), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9711), 1,
      sym_declaration_list,
    STATE(8100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [360958] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10269), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361009] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_block,
    STATE(8745), 1,
      sym_parameter_list,
    STATE(8102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361062] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8146), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9688), 1,
      sym_declaration_list,
    STATE(8103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361115] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8112), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9642), 1,
      sym_declaration_list,
    STATE(8104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361168] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10271), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361219] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6064), 1,
      anon_sym_LBRACK,
    ACTIONS(10273), 1,
      anon_sym_EQ,
    STATE(8664), 1,
      sym_bracketed_argument_list,
    ACTIONS(10204), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361270] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9688), 1,
      sym_declaration_list,
    STATE(8107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361323] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8164), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9690), 1,
      sym_declaration_list,
    STATE(8108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361376] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10275), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361427] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9690), 1,
      sym_declaration_list,
    STATE(8110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361480] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9208), 1,
      sym_declaration_list,
    STATE(8111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361533] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9909), 1,
      sym_declaration_list,
    STATE(8112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361586] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8092), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9162), 1,
      sym_declaration_list,
    STATE(8113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361639] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9622), 1,
      sym_declaration_list,
    STATE(8114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361692] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10279), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10277), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361739] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9162), 1,
      sym_declaration_list,
    STATE(8116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361792] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4559), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361837] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8175), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9695), 1,
      sym_declaration_list,
    STATE(8118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361890] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10281), 1,
      anon_sym_EQ_GT,
    ACTIONS(10283), 1,
      anon_sym_when,
    ACTIONS(10285), 1,
      anon_sym_and,
    ACTIONS(10287), 1,
      anon_sym_or,
    STATE(9665), 1,
      sym_when_clause,
    STATE(8119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361943] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10289), 1,
      anon_sym_COMMA,
    ACTIONS(10291), 1,
      anon_sym_RBRACK,
    STATE(8587), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [361996] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9695), 1,
      sym_declaration_list,
    STATE(8121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362049] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9241), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(9243), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10293), 1,
      aux_sym_preproc_if_token3,
    STATE(9399), 2,
      sym_preproc_else_in_enum_member_declaration,
      sym_preproc_elif_in_enum_member_declaration,
    STATE(8122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362100] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9816), 1,
      sym_declaration_list,
    STATE(8123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362153] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10295), 1,
      anon_sym_COMMA,
    ACTIONS(10297), 1,
      anon_sym_RBRACK,
    STATE(8599), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362206] = 12,
    ACTIONS(5486), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(5488), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362253] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9142), 1,
      sym_declaration_list,
    STATE(8126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362306] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8123), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9819), 1,
      sym_declaration_list,
    STATE(8127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362359] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10299), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362404] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9819), 1,
      sym_declaration_list,
    STATE(8129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362457] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8138), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9622), 1,
      sym_declaration_list,
    STATE(8130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362510] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9820), 1,
      sym_declaration_list,
    STATE(8131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362563] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10054), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362608] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9827), 1,
      sym_declaration_list,
    STATE(8133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362661] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9700), 1,
      sym_declaration_list,
    STATE(8134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362714] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9836), 1,
      sym_declaration_list,
    STATE(8135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362767] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10301), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362812] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8129), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9838), 1,
      sym_declaration_list,
    STATE(8137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362865] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9546), 1,
      sym_declaration_list,
    STATE(8138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362918] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8236), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9700), 1,
      sym_declaration_list,
    STATE(8139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [362971] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    STATE(8484), 1,
      sym_argument_list,
    ACTIONS(10303), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363020] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8131), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9840), 1,
      sym_declaration_list,
    STATE(8141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363073] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9840), 1,
      sym_declaration_list,
    STATE(8142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363126] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10127), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363171] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10279), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363216] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8197), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9764), 1,
      sym_declaration_list,
    STATE(8145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363269] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9764), 1,
      sym_declaration_list,
    STATE(8146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363322] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10305), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363373] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8133), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9843), 1,
      sym_declaration_list,
    STATE(8148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363426] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7961), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9669), 1,
      sym_declaration_list,
    STATE(8149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363479] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9843), 1,
      sym_declaration_list,
    STATE(8150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363532] = 12,
    ACTIONS(5582), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(5584), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363579] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8210), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9765), 1,
      sym_declaration_list,
    STATE(8152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363632] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10307), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363677] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9844), 1,
      sym_declaration_list,
    STATE(8154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363730] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10309), 1,
      anon_sym_RBRACE,
    STATE(8219), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363783] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9765), 1,
      sym_declaration_list,
    STATE(8156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363836] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9849), 1,
      sym_declaration_list,
    STATE(8157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363889] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8211), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9766), 1,
      sym_declaration_list,
    STATE(8158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363942] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9669), 1,
      sym_declaration_list,
    STATE(8159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [363995] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(4320), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    STATE(8160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364042] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9858), 1,
      sym_declaration_list,
    STATE(8161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364095] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9859), 1,
      sym_declaration_list,
    STATE(8162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364148] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10234), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364193] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9766), 1,
      sym_declaration_list,
    STATE(8164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364246] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10240), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364291] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8135), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9859), 1,
      sym_declaration_list,
    STATE(8166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364344] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10144), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10240), 3,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364391] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9860), 1,
      sym_declaration_list,
    STATE(8168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364444] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8223), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9767), 1,
      sym_declaration_list,
    STATE(8169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364497] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7942), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9860), 1,
      sym_declaration_list,
    STATE(8170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364550] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10144), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10240), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
    STATE(8171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364599] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10311), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364644] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9714), 1,
      sym_declaration_list,
    STATE(8173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364697] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9861), 1,
      sym_declaration_list,
    STATE(8174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364750] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9769), 1,
      sym_declaration_list,
    STATE(8175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364803] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8142), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9861), 1,
      sym_declaration_list,
    STATE(8176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364856] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10313), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364907] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9865), 1,
      sym_declaration_list,
    STATE(8178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [364960] = 14,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10156), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10158), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10315), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365011] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9868), 1,
      sym_declaration_list,
    STATE(8180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365064] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8233), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9800), 1,
      sym_declaration_list,
    STATE(8181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365117] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8150), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9868), 1,
      sym_declaration_list,
    STATE(8182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365170] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8154), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9869), 1,
      sym_declaration_list,
    STATE(8183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365223] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9869), 1,
      sym_declaration_list,
    STATE(8184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365276] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9800), 1,
      sym_declaration_list,
    STATE(8185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365329] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10317), 1,
      anon_sym_RBRACE,
    STATE(8049), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365382] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8216), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9808), 1,
      sym_declaration_list,
    STATE(8187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365435] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9883), 1,
      sym_declaration_list,
    STATE(8188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365488] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(6632), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(8189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365537] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8157), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9887), 1,
      sym_declaration_list,
    STATE(8190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365590] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9887), 1,
      sym_declaration_list,
    STATE(8191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365643] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9888), 1,
      sym_declaration_list,
    STATE(8192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365696] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9808), 1,
      sym_declaration_list,
    STATE(8193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365749] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9538), 1,
      sym_declaration_list,
    STATE(8194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365802] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9897), 1,
      sym_declaration_list,
    STATE(8195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365855] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8161), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9897), 1,
      sym_declaration_list,
    STATE(8196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365908] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9965), 1,
      sym_declaration_list,
    STATE(8197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [365961] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7632), 1,
      sym_parameter_list,
    STATE(8728), 1,
      sym_type_parameter_list,
    STATE(8198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366014] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9685), 1,
      sym_declaration_list,
    STATE(8199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366067] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9904), 1,
      sym_declaration_list,
    STATE(8200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366120] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8192), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9965), 1,
      sym_declaration_list,
    STATE(8201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366173] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8194), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9685), 1,
      sym_declaration_list,
    STATE(8202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366226] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10319), 1,
      anon_sym_COMMA,
    ACTIONS(10321), 1,
      anon_sym_RBRACK,
    STATE(8688), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366279] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8174), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9904), 1,
      sym_declaration_list,
    STATE(8204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366332] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8191), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9961), 1,
      sym_declaration_list,
    STATE(8205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366385] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9642), 1,
      sym_declaration_list,
    STATE(8206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366438] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8206), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9855), 1,
      sym_declaration_list,
    STATE(8207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366491] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9725), 1,
      sym_declaration_list,
    STATE(8208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366544] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9915), 1,
      sym_declaration_list,
    STATE(8209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366597] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9961), 1,
      sym_declaration_list,
    STATE(8210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366650] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9958), 1,
      sym_declaration_list,
    STATE(8211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366703] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8214), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9725), 1,
      sym_declaration_list,
    STATE(8212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366756] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8188), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9958), 1,
      sym_declaration_list,
    STATE(8213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366809] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9855), 1,
      sym_declaration_list,
    STATE(8214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366862] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10307), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10323), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    STATE(8215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366909] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9914), 1,
      sym_declaration_list,
    STATE(8216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [366962] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9920), 1,
      sym_declaration_list,
    STATE(8217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367015] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8000), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9915), 1,
      sym_declaration_list,
    STATE(8218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367068] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10166), 1,
      anon_sym_case,
    ACTIONS(10168), 1,
      anon_sym_default,
    ACTIONS(10325), 1,
      anon_sym_RBRACE,
    STATE(8097), 1,
      aux_sym_switch_body_repeat1,
    STATE(8574), 1,
      sym_switch_section,
    STATE(8219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367121] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8019), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9591), 1,
      sym_declaration_list,
    STATE(8220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367174] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8178), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9920), 1,
      sym_declaration_list,
    STATE(8221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367227] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9922), 1,
      sym_declaration_list,
    STATE(8222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367280] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9957), 1,
      sym_declaration_list,
    STATE(8223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367333] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10148), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10327), 1,
      anon_sym_RPAREN,
    ACTIONS(10144), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    STATE(8224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367384] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9755), 1,
      sym_declaration_list,
    STATE(8225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367437] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8180), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9922), 1,
      sym_declaration_list,
    STATE(8226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367490] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9759), 1,
      sym_declaration_list,
    STATE(8227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367543] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10329), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367588] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8173), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9759), 1,
      sym_declaration_list,
    STATE(8229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367641] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7982), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9666), 1,
      sym_declaration_list,
    STATE(8230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367694] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9763), 1,
      sym_declaration_list,
    STATE(8231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367747] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9591), 1,
      sym_declaration_list,
    STATE(8232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367800] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9930), 1,
      sym_declaration_list,
    STATE(8233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367853] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8159), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9763), 1,
      sym_declaration_list,
    STATE(8234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367906] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9574), 1,
      sym_declaration_list,
    STATE(8235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [367959] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9825), 1,
      sym_declaration_list,
    STATE(8236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368012] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(7990), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9574), 1,
      sym_declaration_list,
    STATE(8237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368065] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8184), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9930), 1,
      sym_declaration_list,
    STATE(8238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368118] = 15,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(9796), 1,
      anon_sym_where,
    STATE(8114), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(9825), 1,
      sym_declaration_list,
    STATE(8239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368171] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10331), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368219] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10333), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368269] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10335), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368319] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10337), 1,
      anon_sym_LT,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    STATE(9709), 1,
      sym_calling_convention,
    STATE(8243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368369] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3429), 1,
      sym_accessor_list,
    STATE(9131), 1,
      sym_arrow_expression_clause,
    STATE(8244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368419] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10343), 1,
      anon_sym_SEMI,
    STATE(8278), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368469] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10345), 1,
      anon_sym_SEMI,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8338), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368519] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(8347), 1,
      sym_block,
    STATE(8727), 1,
      sym_catch_filter_clause,
    STATE(8247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368569] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10347), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368619] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10349), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368669] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10351), 1,
      anon_sym_SEMI,
    STATE(8241), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368719] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8796), 1,
      sym_base_list,
    STATE(9013), 1,
      sym_enum_member_declaration_list,
    STATE(8251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368769] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10285), 1,
      anon_sym_and,
    ACTIONS(6645), 3,
      anon_sym_EQ_GT,
      anon_sym_when,
      anon_sym_or,
    STATE(8252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368815] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_COMMA,
    ACTIONS(10357), 1,
      anon_sym_RPAREN,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    STATE(8253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368865] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8284), 1,
      sym_parameter_list,
    STATE(8787), 1,
      sym_type_parameter_list,
    STATE(8254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368915] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10363), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [368965] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8748), 1,
      sym_base_list,
    STATE(9792), 1,
      sym_enum_member_declaration_list,
    STATE(8256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369015] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8352), 1,
      sym_parameter_list,
    STATE(8828), 1,
      sym_type_parameter_list,
    STATE(8257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369065] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8295), 1,
      sym_parameter_list,
    STATE(8754), 1,
      sym_type_parameter_list,
    STATE(8258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369115] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10365), 1,
      anon_sym_LT,
    STATE(9422), 1,
      sym_calling_convention,
    STATE(8259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369165] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5923), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5954), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369211] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10367), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369255] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8889), 1,
      sym_base_list,
    STATE(9443), 1,
      sym_enum_member_declaration_list,
    STATE(8262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369305] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10369), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369355] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10371), 1,
      anon_sym_SEMI,
    STATE(8248), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369405] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3515), 1,
      sym_accessor_list,
    STATE(9889), 1,
      sym_arrow_expression_clause,
    STATE(8265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369455] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7620), 1,
      sym_parameter_list,
    STATE(8800), 1,
      sym_type_parameter_list,
    STATE(8266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369505] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(6645), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_or,
    STATE(8267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369551] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10373), 1,
      anon_sym_SEMI,
    STATE(8249), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369601] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7640), 1,
      sym_parameter_list,
    STATE(8978), 1,
      sym_type_parameter_list,
    STATE(8269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369651] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3296), 1,
      sym_accessor_list,
    STATE(9006), 1,
      sym_arrow_expression_clause,
    STATE(8270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369701] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10375), 1,
      anon_sym_SEMI,
    STATE(8255), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369751] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10377), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369801] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10379), 1,
      anon_sym_LT,
    STATE(9771), 1,
      sym_calling_convention,
    STATE(8273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369851] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10383), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10381), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369897] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10383), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10381), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369943] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(10385), 1,
      anon_sym_SEMI,
    STATE(9366), 1,
      sym_declaration_list,
    STATE(8276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [369993] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10387), 1,
      anon_sym_SEMI,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8375), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370043] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10389), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370093] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10391), 1,
      anon_sym_SEMI,
    STATE(8307), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370143] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10019), 1,
      anon_sym_COMMA,
    STATE(8283), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(10393), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370191] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8785), 1,
      sym_base_list,
    STATE(9753), 1,
      sym_enum_member_declaration_list,
    STATE(8281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370241] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10255), 1,
      anon_sym_and,
    ACTIONS(10257), 1,
      anon_sym_or,
    ACTIONS(6632), 2,
      anon_sym_COLON,
      anon_sym_when,
    STATE(8282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370289] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10395), 1,
      anon_sym_COMMA,
    ACTIONS(10303), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8283), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [370335] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10398), 1,
      anon_sym_SEMI,
    STATE(8288), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370385] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10400), 1,
      anon_sym_SEMI,
    STATE(8263), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370435] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_COMMA,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10402), 1,
      anon_sym_RPAREN,
    STATE(8286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370485] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3500), 1,
      sym_accessor_list,
    STATE(9870), 1,
      sym_arrow_expression_clause,
    STATE(8287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370535] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10404), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370585] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    STATE(8289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370635] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8245), 1,
      sym_parameter_list,
    STATE(8810), 1,
      sym_type_parameter_list,
    STATE(8290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370685] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_COMMA,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10406), 1,
      anon_sym_RPAREN,
    STATE(8291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370735] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10408), 1,
      anon_sym_COMMA,
    ACTIONS(10411), 2,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(8292), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_argument_list_repeat1,
  [370781] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3438), 1,
      sym_accessor_list,
    STATE(9249), 1,
      sym_arrow_expression_clause,
    STATE(8293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370831] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10413), 1,
      anon_sym_LT,
    STATE(9813), 1,
      sym_calling_convention,
    STATE(8294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370881] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10415), 1,
      anon_sym_SEMI,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8355), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370931] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10255), 1,
      anon_sym_and,
    ACTIONS(6645), 3,
      anon_sym_COLON,
      anon_sym_when,
      anon_sym_or,
    STATE(8296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [370977] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10417), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371027] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8336), 1,
      sym_parameter_list,
    STATE(8886), 1,
      sym_type_parameter_list,
    STATE(8298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371077] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10419), 1,
      anon_sym_SEMI,
    STATE(8272), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371127] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8840), 1,
      sym_base_list,
    STATE(9407), 1,
      sym_enum_member_declaration_list,
    STATE(8300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371177] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2215), 1,
      sym_block,
    STATE(8808), 1,
      sym_catch_filter_clause,
    STATE(8301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371227] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4490), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371271] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10421), 1,
      anon_sym_SEMI,
    STATE(8308), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371321] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4457), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371365] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10423), 1,
      anon_sym_LT,
    STATE(9837), 1,
      sym_calling_convention,
    STATE(8305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371415] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4500), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371459] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10425), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371509] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10427), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371559] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4473), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371603] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4467), 4,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_STAR,
    STATE(8310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371647] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8246), 1,
      sym_parameter_list,
    STATE(8758), 1,
      sym_type_parameter_list,
    STATE(8311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371697] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10429), 1,
      anon_sym_LT,
    STATE(9857), 1,
      sym_calling_convention,
    STATE(8312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371747] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10431), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371797] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10433), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371847] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10435), 1,
      anon_sym_EQ,
    ACTIONS(10101), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371893] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10437), 1,
      anon_sym_LT,
    STATE(9876), 1,
      sym_calling_convention,
    STATE(8316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371943] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8742), 1,
      sym_base_list,
    STATE(9730), 1,
      sym_enum_member_declaration_list,
    STATE(8317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [371993] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7590), 1,
      sym_parameter_list,
    STATE(8719), 1,
      sym_type_parameter_list,
    STATE(8318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372043] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(7565), 1,
      sym_parameter_list,
    STATE(8746), 1,
      sym_type_parameter_list,
    STATE(8319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372093] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10439), 1,
      anon_sym_SEMI,
    STATE(8242), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372143] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10285), 1,
      anon_sym_and,
    ACTIONS(10287), 1,
      anon_sym_or,
    ACTIONS(6632), 2,
      anon_sym_EQ_GT,
      anon_sym_when,
    STATE(8321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372191] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10443), 1,
      aux_sym_string_literal_content_token1,
    ACTIONS(10441), 3,
      anon_sym_DQUOTE,
      aux_sym_string_literal_content_token2,
      sym_escape_sequence,
    STATE(8322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372237] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8349), 1,
      sym_parameter_list,
    STATE(8976), 1,
      sym_type_parameter_list,
    STATE(8323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372287] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10445), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372331] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_COMMA,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10447), 1,
      anon_sym_RPAREN,
    STATE(8325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372381] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8702), 1,
      sym_base_list,
    STATE(9638), 1,
      sym_enum_member_declaration_list,
    STATE(8326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372431] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2277), 1,
      sym_block,
    STATE(8860), 1,
      sym_catch_filter_clause,
    STATE(8327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372481] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(10449), 1,
      anon_sym_EQ,
    ACTIONS(10451), 1,
      anon_sym_COMMA,
    ACTIONS(10454), 1,
      anon_sym_RPAREN,
    STATE(8328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372531] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10456), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ_GT,
    STATE(8329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372575] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10458), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372619] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10460), 1,
      anon_sym_COMMA,
    ACTIONS(9906), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372665] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10462), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372715] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(3293), 1,
      sym_accessor_list,
    STATE(9937), 1,
      sym_arrow_expression_clause,
    STATE(8333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372765] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(4453), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372813] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10464), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372857] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10466), 1,
      anon_sym_SEMI,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8332), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372907] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10339), 1,
      anon_sym_unmanaged,
    ACTIONS(10341), 1,
      anon_sym_managed,
    ACTIONS(10468), 1,
      anon_sym_LT,
    STATE(9517), 1,
      sym_calling_convention,
    STATE(8337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [372957] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10470), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373007] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10472), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373051] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8268), 1,
      sym_parameter_list,
    STATE(8819), 1,
      sym_type_parameter_list,
    STATE(8340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373101] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373151] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(9982), 1,
      anon_sym_EQ,
    ACTIONS(10101), 1,
      anon_sym_RPAREN,
    ACTIONS(10474), 1,
      anon_sym_COMMA,
    STATE(8342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(10478), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373247] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(10480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373295] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10019), 1,
      anon_sym_COMMA,
    STATE(8283), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(10482), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373343] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10019), 1,
      anon_sym_COMMA,
    STATE(8280), 1,
      aux_sym_base_list_repeat1,
    ACTIONS(10482), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373391] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3026), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10331), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373483] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10484), 1,
      anon_sym_SEMI,
    STATE(8297), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373533] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373583] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(10077), 1,
      anon_sym_when,
    STATE(2650), 1,
      sym_block,
    STATE(8752), 1,
      sym_catch_filter_clause,
    STATE(8351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373633] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10486), 1,
      anon_sym_SEMI,
    STATE(8313), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373683] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    ACTIONS(10488), 1,
      anon_sym_SEMI,
    STATE(9631), 1,
      sym_declaration_list,
    STATE(8353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373733] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8967), 1,
      sym_base_list,
    STATE(9193), 1,
      sym_enum_member_declaration_list,
    STATE(8354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373783] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10490), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373833] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3038), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373877] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3034), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373921] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10480), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [373969] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10492), 4,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
      sym_escape_sequence,
    STATE(8359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374013] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10494), 1,
      anon_sym_SEMI,
    STATE(8314), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374063] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_EQ,
    ACTIONS(10498), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374109] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3030), 4,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_else,
    STATE(8362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374153] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_GT,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym_QMARK,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374203] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10500), 1,
      anon_sym_COMMA,
    ACTIONS(10503), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8364), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_bracketed_parameter_list_repeat1,
  [374249] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(10505), 1,
      anon_sym_EQ,
    ACTIONS(10507), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374297] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10509), 1,
      anon_sym_EQ,
    ACTIONS(10507), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374343] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10511), 1,
      anon_sym_EQ,
    ACTIONS(10513), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(8367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374389] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10515), 1,
      anon_sym_EQ,
    ACTIONS(10517), 3,
      aux_sym_preproc_if_token3,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elif_token1,
    STATE(8368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374435] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10331), 1,
      anon_sym_COMMA,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(10519), 1,
      anon_sym_RPAREN,
    STATE(8369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374485] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10521), 1,
      anon_sym_COMMA,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(8370), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_for_statement_repeat1,
  [374531] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10359), 1,
      anon_sym_and,
    ACTIONS(10361), 1,
      anon_sym_or,
    ACTIONS(6632), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374579] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10353), 1,
      anon_sym_COLON,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(8892), 1,
      sym_base_list,
    STATE(9261), 1,
      sym_enum_member_declaration_list,
    STATE(8372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374629] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    ACTIONS(9794), 1,
      anon_sym_LT,
    STATE(8285), 1,
      sym_parameter_list,
    STATE(8910), 1,
      sym_type_parameter_list,
    STATE(8373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374679] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10186), 1,
      anon_sym_and,
    ACTIONS(10188), 1,
      anon_sym_or,
    ACTIONS(1889), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374727] = 14,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9796), 1,
      anon_sym_where,
    ACTIONS(10524), 1,
      anon_sym_SEMI,
    STATE(7810), 1,
      aux_sym_class_declaration_repeat3,
    STATE(8329), 1,
      sym_type_parameter_constraints_clause,
    STATE(8375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374777] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10526), 1,
      anon_sym_LPAREN,
    ACTIONS(10530), 1,
      sym_integer_literal,
    ACTIONS(10528), 2,
      anon_sym_default,
      anon_sym_hidden,
    STATE(8376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374825] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10534), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374872] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10536), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374919] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10538), 3,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
    STATE(8379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [374962] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10540), 1,
      anon_sym_EQ,
    ACTIONS(10517), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375007] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9353), 1,
      anon_sym_RBRACE,
    ACTIONS(10542), 1,
      anon_sym_COMMA,
    STATE(8642), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(8381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375054] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10544), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375101] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10546), 1,
      anon_sym_GT,
    STATE(8390), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375148] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10548), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375191] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10550), 1,
      anon_sym_RBRACK,
    STATE(8404), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375238] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10552), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375285] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10546), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375332] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10554), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375375] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10556), 1,
      anon_sym_COMMA,
    ACTIONS(10559), 1,
      anon_sym_RPAREN,
    STATE(8389), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [375420] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10561), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375467] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10563), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375514] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10565), 3,
      anon_sym_disable,
      anon_sym_restore,
      anon_sym_enable,
    STATE(8392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375557] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10567), 1,
      anon_sym_COMMA,
    ACTIONS(10569), 1,
      anon_sym_RBRACE,
    STATE(8531), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375604] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10573), 1,
      anon_sym_RPAREN,
    STATE(8528), 1,
      aux_sym_argument_list_repeat1,
    STATE(8394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375651] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10575), 1,
      anon_sym_COMMA,
    ACTIONS(10577), 1,
      anon_sym_GT,
    STATE(8696), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(8395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375698] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_RBRACE,
    ACTIONS(10579), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375745] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10581), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375788] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10583), 1,
      anon_sym_COMMA,
    ACTIONS(10585), 1,
      anon_sym_RBRACK,
    STATE(8444), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375835] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10587), 1,
      anon_sym_COMMA,
    ACTIONS(10590), 1,
      anon_sym_RBRACE,
    STATE(8399), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_switch_expression_repeat1,
  [375880] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10575), 1,
      anon_sym_COMMA,
    ACTIONS(10592), 1,
      anon_sym_GT,
    STATE(8395), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(8400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375927] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10594), 1,
      anon_sym_COMMA,
    ACTIONS(10596), 1,
      anon_sym_RBRACK,
    STATE(8450), 1,
      aux_sym_argument_list_repeat1,
    STATE(8401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [375974] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(10600), 1,
      anon_sym_RPAREN,
    STATE(8485), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376021] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10602), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376068] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10604), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376115] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10606), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376162] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10610), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376209] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(9792), 1,
      anon_sym_LBRACE,
    STATE(9022), 1,
      sym_declaration_list,
    STATE(8407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376256] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10612), 1,
      anon_sym_COMMA,
    ACTIONS(10614), 1,
      anon_sym_RBRACE,
    STATE(8381), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(8408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376303] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10616), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376350] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8111), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376397] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(10618), 1,
      anon_sym_SEMI,
    STATE(3419), 1,
      sym_accessor_list,
    STATE(8411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376444] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(10622), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376491] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_RBRACK,
    ACTIONS(10624), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376538] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9322), 1,
      anon_sym_RBRACK,
    ACTIONS(10626), 1,
      anon_sym_COMMA,
    STATE(8427), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376585] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9322), 1,
      anon_sym_RBRACK,
    ACTIONS(10626), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376632] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(10628), 1,
      anon_sym_RPAREN,
    STATE(8402), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376679] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_RBRACK,
    ACTIONS(10630), 1,
      anon_sym_COMMA,
    STATE(8449), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376726] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10632), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376773] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10634), 1,
      anon_sym_EQ,
    ACTIONS(10513), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376818] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    ACTIONS(10636), 1,
      anon_sym_LPAREN,
    STATE(2469), 1,
      sym_block,
    STATE(8420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376865] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_RBRACE,
    ACTIONS(10638), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376912] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10640), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [376959] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10642), 1,
      anon_sym_COMMA,
    ACTIONS(10644), 1,
      anon_sym_RBRACK,
    STATE(8644), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377006] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(10646), 1,
      anon_sym_RBRACE,
    STATE(8412), 1,
      aux_sym_with_expression_repeat1,
    STATE(8424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377053] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7943), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377096] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10648), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377139] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9361), 1,
      anon_sym_RBRACK,
    ACTIONS(10650), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377186] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10606), 1,
      anon_sym_GT,
    STATE(8386), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377233] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(10652), 1,
      anon_sym_SEMI,
    STATE(8431), 1,
      aux_sym_for_statement_repeat1,
    STATE(8429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377280] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10654), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377327] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8228), 1,
      anon_sym_SEMI,
    ACTIONS(10656), 1,
      anon_sym_COMMA,
    STATE(8431), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_for_statement_repeat1,
  [377372] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10659), 1,
      anon_sym_COMMA,
    ACTIONS(10661), 1,
      anon_sym_RBRACE,
    STATE(8421), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377419] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10663), 1,
      anon_sym_COMMA,
    ACTIONS(10665), 1,
      anon_sym_RBRACK,
    STATE(8520), 1,
      aux_sym_argument_list_repeat1,
    STATE(8433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377466] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10667), 1,
      anon_sym_COMMA,
    ACTIONS(10669), 1,
      anon_sym_RBRACK,
    STATE(8504), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377513] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10671), 1,
      anon_sym_RBRACK,
    STATE(8418), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377560] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10673), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377607] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10675), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377654] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9347), 1,
      anon_sym_RBRACK,
    ACTIONS(10677), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377701] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9347), 1,
      anon_sym_RBRACK,
    ACTIONS(10677), 1,
      anon_sym_COMMA,
    STATE(8517), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377748] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7939), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377791] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10679), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377838] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10581), 1,
      anon_sym_RPAREN,
    ACTIONS(10681), 1,
      anon_sym_COMMA,
    STATE(8442), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [377883] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2643), 1,
      anon_sym_RBRACK,
    ACTIONS(10684), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377930] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9308), 1,
      anon_sym_RBRACK,
    ACTIONS(10686), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [377977] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10688), 1,
      anon_sym_COMMA,
    ACTIONS(10690), 1,
      anon_sym_RPAREN,
    STATE(8693), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(8445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378024] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10692), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378071] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(10694), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378118] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9308), 1,
      anon_sym_RBRACK,
    ACTIONS(10686), 1,
      anon_sym_COMMA,
    STATE(8516), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378165] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_RBRACK,
    ACTIONS(10696), 1,
      anon_sym_COMMA,
    STATE(8449), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_list_pattern_repeat1,
  [378210] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_RBRACK,
    ACTIONS(10699), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378257] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10701), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378304] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10101), 1,
      anon_sym_RPAREN,
    ACTIONS(10435), 1,
      anon_sym_EQ,
    ACTIONS(10703), 1,
      anon_sym_COMMA,
    STATE(8452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378351] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(10708), 1,
      anon_sym_RPAREN,
    STATE(8364), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378398] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(10710), 1,
      anon_sym_RPAREN,
    STATE(8364), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378445] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10712), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378492] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378539] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10714), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378586] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10692), 1,
      anon_sym_GT,
    STATE(8409), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378633] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10716), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378680] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2787), 1,
      anon_sym_RBRACE,
    ACTIONS(10718), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378727] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_RBRACE,
    ACTIONS(10720), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378774] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10722), 1,
      anon_sym_COMMA,
    ACTIONS(10725), 1,
      anon_sym_RPAREN,
    STATE(8462), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_type_repeat1,
  [378819] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10727), 1,
      anon_sym_COMMA,
    ACTIONS(10729), 1,
      anon_sym_RPAREN,
    STATE(8564), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378866] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10731), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378913] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(10733), 1,
      anon_sym_RPAREN,
    STATE(8485), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [378960] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10735), 1,
      anon_sym_RPAREN,
    STATE(8523), 1,
      aux_sym_argument_list_repeat1,
    STATE(8466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379007] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10602), 1,
      anon_sym_GT,
    STATE(8606), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379054] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_RBRACK,
    ACTIONS(10737), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379101] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10739), 1,
      anon_sym_COMMA,
    ACTIONS(10741), 1,
      anon_sym_RBRACE,
    STATE(8524), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379148] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9310), 1,
      anon_sym_RBRACK,
    ACTIONS(10743), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379195] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10745), 1,
      anon_sym_COMMA,
    ACTIONS(10747), 1,
      anon_sym_RPAREN,
    STATE(8686), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(8471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379242] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10749), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379289] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(10751), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379336] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379383] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10753), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379430] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10755), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379477] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10757), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379520] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10759), 1,
      anon_sym_COMMA,
    ACTIONS(10761), 1,
      anon_sym_RBRACE,
    STATE(8654), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379567] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10763), 1,
      anon_sym_COMMA,
    ACTIONS(10765), 1,
      anon_sym_RBRACK,
    STATE(8413), 1,
      aux_sym_argument_list_repeat1,
    STATE(8479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379614] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10767), 1,
      anon_sym_COMMA,
    ACTIONS(10769), 1,
      anon_sym_RBRACK,
    STATE(8415), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379661] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10771), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(8481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379704] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    ACTIONS(10773), 1,
      sym_interpolation_close_brace,
    STATE(9733), 1,
      sym_interpolation_format_clause,
    STATE(8482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379751] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10775), 1,
      anon_sym_COMMA,
    ACTIONS(10777), 1,
      anon_sym_RBRACK,
    STATE(8637), 1,
      aux_sym_calling_convention_repeat1,
    STATE(8483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379798] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10779), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
    STATE(8484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379841] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10781), 1,
      anon_sym_COMMA,
    ACTIONS(10784), 1,
      anon_sym_RPAREN,
    STATE(8485), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_parenthesized_variable_designation_repeat1,
  [379886] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10786), 1,
      anon_sym_COMMA,
    ACTIONS(10788), 1,
      anon_sym_RBRACK,
    STATE(8541), 1,
      aux_sym_argument_list_repeat1,
    STATE(8486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379933] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10790), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [379976] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10792), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380023] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10794), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380066] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10792), 1,
      anon_sym_GT,
    STATE(8377), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380113] = 13,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10796), 1,
      anon_sym_COMMA,
    ACTIONS(10798), 1,
      aux_sym_preproc_if_token2,
    STATE(8676), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(8491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380160] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10755), 1,
      anon_sym_GT,
    STATE(8430), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380207] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(7945), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380254] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10771), 1,
      anon_sym_RPAREN,
    ACTIONS(10800), 1,
      anon_sym_COMMA,
    STATE(8494), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [380299] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    ACTIONS(10636), 1,
      anon_sym_LPAREN,
    STATE(8821), 1,
      sym_block,
    STATE(8495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380346] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_RBRACE,
    ACTIONS(10803), 1,
      anon_sym_COMMA,
    STATE(8535), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380393] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10805), 1,
      anon_sym_GT,
    STATE(8576), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380440] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8105), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380487] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10805), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380534] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10807), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10544), 1,
      anon_sym_GT,
    STATE(8422), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380628] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10809), 1,
      anon_sym_RBRACK,
    STATE(8555), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380675] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    ACTIONS(10636), 1,
      anon_sym_LPAREN,
    STATE(2235), 1,
      sym_block,
    STATE(8503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380722] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9349), 1,
      anon_sym_RBRACK,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380769] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8191), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380812] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10813), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380859] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9349), 1,
      anon_sym_RBRACK,
    ACTIONS(10811), 1,
      anon_sym_COMMA,
    STATE(8639), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380906] = 13,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10815), 1,
      anon_sym_DQUOTE,
    ACTIONS(10817), 1,
      aux_sym_preproc_if_token2,
    STATE(9605), 1,
      sym_string_literal,
    STATE(8508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [380953] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10819), 1,
      anon_sym_COMMA,
    ACTIONS(10822), 1,
      anon_sym_RBRACE,
    STATE(8509), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [380998] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10688), 1,
      anon_sym_COMMA,
    ACTIONS(10824), 1,
      anon_sym_RPAREN,
    STATE(8445), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(8510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381045] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(10826), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381092] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2887), 1,
      anon_sym_RBRACE,
    ACTIONS(10828), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381139] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(10830), 1,
      anon_sym_RBRACK,
    STATE(8364), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381186] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10581), 1,
      anon_sym_RBRACK,
    ACTIONS(10832), 1,
      anon_sym_COMMA,
    STATE(8514), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_argument_list_repeat1,
  [381231] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8212), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381278] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9306), 1,
      anon_sym_RBRACK,
    ACTIONS(10835), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381325] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9320), 1,
      anon_sym_RBRACK,
    ACTIONS(10837), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381372] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10839), 1,
      anon_sym_COMMA,
    ACTIONS(10842), 1,
      anon_sym_RBRACK,
    STATE(8518), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_global_attribute_repeat1,
  [381417] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10844), 1,
      anon_sym_COMMA,
    ACTIONS(10846), 1,
      anon_sym_RBRACE,
    STATE(8460), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381464] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_RBRACK,
    ACTIONS(10848), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381511] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10850), 1,
      anon_sym_RPAREN,
    STATE(8464), 1,
      aux_sym_argument_list_repeat1,
    STATE(8521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381558] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(10852), 1,
      anon_sym_RBRACK,
    STATE(8364), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381605] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10854), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381652] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2793), 1,
      anon_sym_RBRACE,
    ACTIONS(10856), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381699] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10858), 1,
      anon_sym_COMMA,
    ACTIONS(10860), 1,
      anon_sym_RBRACK,
    STATE(8468), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381746] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    STATE(8636), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381793] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_RBRACE,
    ACTIONS(10864), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381840] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10866), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381887] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(10636), 1,
      anon_sym_LPAREN,
    STATE(2690), 1,
      sym_block,
    STATE(8529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381934] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10868), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [381981] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_RBRACE,
    ACTIONS(10870), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382028] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10872), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382075] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10745), 1,
      anon_sym_COMMA,
    ACTIONS(10874), 1,
      anon_sym_RPAREN,
    STATE(8471), 1,
      aux_sym_using_variable_declaration_repeat1,
    STATE(8533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382122] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10876), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382169] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10771), 1,
      anon_sym_RBRACE,
    ACTIONS(10878), 1,
      anon_sym_COMMA,
    STATE(8535), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_positional_pattern_clause_repeat1,
  [382214] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10881), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10883), 2,
      anon_sym_annotations,
      anon_sym_warnings,
    STATE(8536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382259] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10885), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382306] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10729), 1,
      anon_sym_SEMI,
    ACTIONS(10887), 1,
      anon_sym_COMMA,
    STATE(8668), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382353] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_RBRACK,
    ACTIONS(10889), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382400] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2873), 1,
      anon_sym_RBRACE,
    ACTIONS(10891), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382447] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_RBRACK,
    ACTIONS(10893), 1,
      anon_sym_COMMA,
    STATE(8514), 1,
      aux_sym_argument_list_repeat1,
    STATE(8541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382494] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10895), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382541] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_RBRACE,
    ACTIONS(10897), 1,
      anon_sym_COMMA,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382588] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_RBRACK,
    ACTIONS(10899), 1,
      anon_sym_COMMA,
    STATE(8470), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382635] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10901), 1,
      anon_sym_GT,
    STATE(8600), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382682] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10903), 1,
      anon_sym_COMMA,
    ACTIONS(10906), 1,
      anon_sym_RPAREN,
    STATE(8546), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_tuple_pattern_repeat1,
  [382727] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10908), 1,
      anon_sym_COMMA,
    ACTIONS(10910), 1,
      anon_sym_RBRACE,
    STATE(8583), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382774] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10912), 1,
      anon_sym_COMMA,
    ACTIONS(10915), 1,
      anon_sym_RBRACK,
    STATE(8548), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_calling_convention_repeat1,
  [382819] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8319), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382866] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10901), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382913] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10917), 1,
      anon_sym_GT,
    STATE(8605), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [382960] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(10919), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383007] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10921), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383054] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10923), 1,
      anon_sym_COMMA,
    ACTIONS(10925), 1,
      anon_sym_RBRACE,
    STATE(8598), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383101] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10927), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383148] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(10478), 1,
      anon_sym_RPAREN,
    ACTIONS(10929), 1,
      anon_sym_COMMA,
    STATE(8556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383195] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10917), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383242] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_RBRACE,
    ACTIONS(10932), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383289] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10934), 3,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
      anon_sym_DQUOTE,
    STATE(8559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383332] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_RBRACK,
    ACTIONS(10899), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383379] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    ACTIONS(10936), 1,
      anon_sym_RPAREN,
    STATE(8462), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383426] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10938), 1,
      anon_sym_EQ,
    ACTIONS(10940), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383471] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(10942), 1,
      anon_sym_SEMI,
    STATE(8431), 1,
      aux_sym_for_statement_repeat1,
    STATE(8563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383518] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10727), 1,
      anon_sym_COMMA,
    ACTIONS(10944), 1,
      anon_sym_RPAREN,
    STATE(8389), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383565] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(10946), 1,
      anon_sym_SEMI,
    STATE(3376), 1,
      sym_accessor_list,
    STATE(8565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383612] = 13,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10796), 1,
      anon_sym_COMMA,
    ACTIONS(10948), 1,
      aux_sym_preproc_if_token2,
    STATE(8491), 1,
      aux_sym_preproc_pragma_repeat1,
    STATE(8566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383659] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10950), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_GT,
    STATE(8567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383702] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7345), 1,
      anon_sym_QMARK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(8568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383749] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10952), 1,
      anon_sym_EQ,
    ACTIONS(10954), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383794] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8067), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383841] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(10956), 1,
      anon_sym_RBRACE,
    STATE(8603), 1,
      aux_sym_with_expression_repeat1,
    STATE(8571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383888] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10958), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383935] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(10960), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [383982] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10962), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(8574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384025] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10964), 1,
      anon_sym_RPAREN,
    STATE(8553), 1,
      aux_sym_argument_list_repeat1,
    STATE(8575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384072] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10966), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384119] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(10968), 1,
      anon_sym_RPAREN,
    STATE(8485), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384166] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10970), 1,
      anon_sym_GT,
    STATE(8615), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384213] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10972), 1,
      anon_sym_COMMA,
    ACTIONS(10974), 1,
      anon_sym_RBRACE,
    STATE(8667), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384260] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10970), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384307] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10976), 1,
      anon_sym_RBRACK,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384354] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(10978), 1,
      anon_sym_RPAREN,
    STATE(8651), 1,
      aux_sym_argument_list_repeat1,
    STATE(8582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384401] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2741), 1,
      anon_sym_RBRACE,
    ACTIONS(10980), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384448] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10982), 1,
      anon_sym_COMMA,
    ACTIONS(10984), 1,
      anon_sym_RBRACE,
    STATE(8666), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384495] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2199), 1,
      anon_sym_RBRACE,
    ACTIONS(10986), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384542] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(10988), 1,
      anon_sym_RBRACK,
    STATE(8513), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384589] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2307), 1,
      anon_sym_RBRACK,
    ACTIONS(10990), 1,
      anon_sym_COMMA,
    STATE(8449), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384636] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(10992), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384683] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(10994), 1,
      anon_sym_GT,
    STATE(8592), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384730] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10996), 1,
      anon_sym_COMMA,
    ACTIONS(10998), 1,
      anon_sym_RPAREN,
    STATE(8494), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384777] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(11000), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384824] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11002), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384871] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(11004), 1,
      anon_sym_RBRACK,
    STATE(8378), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384918] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11006), 1,
      anon_sym_COMMA,
    ACTIONS(11008), 1,
      anon_sym_RBRACE,
    STATE(8680), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [384965] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11010), 1,
      anon_sym_RBRACE,
    STATE(8694), 1,
      aux_sym_with_expression_repeat1,
    STATE(8595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385012] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11012), 1,
      anon_sym_COMMA,
    ACTIONS(11014), 1,
      anon_sym_RBRACE,
    STATE(8558), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385059] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11016), 1,
      anon_sym_COMMA,
    ACTIONS(11018), 1,
      anon_sym_RBRACE,
    STATE(8614), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385106] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_RBRACE,
    ACTIONS(11020), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385153] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2311), 1,
      anon_sym_RBRACK,
    ACTIONS(11022), 1,
      anon_sym_COMMA,
    STATE(8449), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385200] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11024), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385247] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11026), 1,
      anon_sym_RBRACE,
    STATE(8616), 1,
      aux_sym_with_expression_repeat1,
    STATE(8601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385294] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11028), 1,
      anon_sym_RPAREN,
    STATE(8611), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385341] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11030), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385388] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(11032), 1,
      anon_sym_RBRACK,
    STATE(8522), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385435] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11034), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385482] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11036), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385529] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11038), 1,
      anon_sym_COMMA,
    ACTIONS(11041), 1,
      anon_sym_RBRACE,
    STATE(8607), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_with_expression_repeat1,
  [385574] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11043), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385621] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11045), 1,
      anon_sym_COMMA,
    ACTIONS(11047), 1,
      anon_sym_RBRACK,
    STATE(8539), 1,
      aux_sym_argument_list_repeat1,
    STATE(8609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385668] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11049), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385715] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11051), 1,
      anon_sym_RPAREN,
    STATE(8485), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385762] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11053), 1,
      anon_sym_COMMA,
    ACTIONS(11055), 1,
      anon_sym_RBRACK,
    STATE(8560), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385809] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11057), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385856] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2247), 1,
      anon_sym_RBRACE,
    ACTIONS(11059), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385903] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11061), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385950] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [385997] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11065), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386044] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11067), 1,
      anon_sym_RPAREN,
    STATE(8577), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386091] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7208), 1,
      anon_sym_COLON,
    ACTIONS(11069), 1,
      sym_interpolation_close_brace,
    STATE(9264), 1,
      sym_interpolation_format_clause,
    STATE(8619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386138] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11071), 1,
      anon_sym_GT,
    STATE(8675), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386185] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11073), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386232] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11075), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386279] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11077), 1,
      anon_sym_GT,
    STATE(8687), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386326] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11079), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386373] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    ACTIONS(11081), 1,
      anon_sym_RPAREN,
    STATE(8546), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386420] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11083), 1,
      anon_sym_RBRACE,
    STATE(8632), 1,
      aux_sym_with_expression_repeat1,
    STATE(8626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386467] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(11077), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386514] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11085), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386561] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(11071), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386608] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11087), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386655] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10492), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386698] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11089), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386745] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11091), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386792] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10367), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386835] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11093), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386882] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    ACTIONS(11095), 1,
      anon_sym_RPAREN,
    STATE(8546), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386929] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10775), 1,
      anon_sym_COMMA,
    ACTIONS(11097), 1,
      anon_sym_RBRACK,
    STATE(8548), 1,
      aux_sym_calling_convention_repeat1,
    STATE(8637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [386976] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11099), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387023] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9335), 1,
      anon_sym_RBRACK,
    ACTIONS(11101), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387070] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11103), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387117] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11105), 1,
      anon_sym_COMMA,
    ACTIONS(11107), 1,
      anon_sym_RBRACK,
    STATE(8438), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387164] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11109), 1,
      anon_sym_COMMA,
    ACTIONS(11112), 1,
      anon_sym_RBRACE,
    STATE(8642), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_enum_member_declaration_list_repeat1,
  [387209] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(4482), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387254] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9351), 1,
      anon_sym_RBRACK,
    ACTIONS(11114), 1,
      anon_sym_COMMA,
    STATE(8518), 1,
      aux_sym_global_attribute_repeat1,
    STATE(8644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387301] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11116), 1,
      anon_sym_COMMA,
    ACTIONS(11118), 1,
      anon_sym_RBRACE,
    STATE(8496), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387348] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10190), 1,
      anon_sym_COMMA,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(8697), 1,
      aux_sym_base_list_repeat1,
    STATE(8646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387395] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11120), 1,
      anon_sym_COMMA,
    ACTIONS(11123), 1,
      anon_sym_GT,
    STATE(8647), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_argument_list_repeat2,
  [387440] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11125), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387487] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10190), 1,
      anon_sym_COMMA,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(8699), 1,
      aux_sym_base_list_repeat1,
    STATE(8649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387534] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11127), 1,
      anon_sym_COMMA,
    ACTIONS(11129), 1,
      anon_sym_RBRACK,
    STATE(8443), 1,
      aux_sym_argument_list_repeat1,
    STATE(8650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387581] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    ACTIONS(11131), 1,
      anon_sym_RPAREN,
    STATE(8442), 1,
      aux_sym_argument_list_repeat1,
    STATE(8651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387628] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(11133), 1,
      anon_sym_RBRACK,
    STATE(8572), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387675] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(10994), 1,
      anon_sym_GT,
    STATE(8292), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387722] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_RBRACE,
    ACTIONS(11135), 1,
      anon_sym_COMMA,
    STATE(8509), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(8654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387769] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11137), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387812] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11139), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387859] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10559), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387902] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10559), 1,
      anon_sym_SEMI,
    ACTIONS(11141), 1,
      anon_sym_COMMA,
    STATE(8658), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_variable_declaration_repeat1,
  [387947] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8308), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(8659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [387990] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(11144), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388037] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(11146), 1,
      anon_sym_SEMI,
    STATE(8431), 1,
      aux_sym_for_statement_repeat1,
    STATE(8661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388084] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    ACTIONS(11148), 1,
      anon_sym_RPAREN,
    STATE(8625), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(8662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388131] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9765), 1,
      anon_sym_LBRACE,
    ACTIONS(11150), 1,
      anon_sym_SEMI,
    STATE(3498), 1,
      sym_accessor_list,
    STATE(8663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388178] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11152), 1,
      anon_sym_EQ,
    ACTIONS(10954), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388223] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(11154), 1,
      anon_sym_RBRACK,
    STATE(8581), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(8665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388270] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_RBRACE,
    ACTIONS(11156), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388317] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_RBRACE,
    ACTIONS(11158), 1,
      anon_sym_COMMA,
    STATE(8399), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388364] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10887), 1,
      anon_sym_COMMA,
    ACTIONS(10944), 1,
      anon_sym_SEMI,
    STATE(8658), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(8668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388411] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_RBRACK,
    ACTIONS(11160), 1,
      anon_sym_COMMA,
    STATE(8449), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388458] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10996), 1,
      anon_sym_COMMA,
    ACTIONS(11162), 1,
      anon_sym_RPAREN,
    STATE(8494), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388505] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11164), 1,
      anon_sym_DQUOTE,
    ACTIONS(11166), 1,
      sym_integer_literal,
    STATE(9803), 1,
      sym_string_literal,
    STATE(8671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388552] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(11168), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388599] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8548), 1,
      anon_sym_RBRACK,
    ACTIONS(11170), 1,
      anon_sym_COMMA,
    STATE(8673), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_array_rank_specifier_repeat1,
  [388644] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(11173), 1,
      anon_sym_RPAREN,
    STATE(8453), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388691] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11175), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388738] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11177), 1,
      anon_sym_COMMA,
    ACTIONS(11180), 1,
      aux_sym_preproc_if_token2,
    STATE(8676), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_preproc_pragma_repeat1,
  [388783] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11182), 1,
      anon_sym_COMMA,
    ACTIONS(11184), 1,
      anon_sym_RBRACE,
    STATE(8585), 1,
      aux_sym_switch_expression_repeat1,
    STATE(8677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388830] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10458), 3,
      sym_interpolation_end_quote,
      sym_interpolation_open_brace,
      sym_interpolation_string_content,
    STATE(8678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388873] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11186), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388920] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_RBRACE,
    ACTIONS(11188), 1,
      anon_sym_COMMA,
    STATE(8535), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [388967] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_EQ,
    ACTIONS(10940), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(8681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389012] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11192), 1,
      anon_sym_RBRACE,
    STATE(8656), 1,
      aux_sym_with_expression_repeat1,
    STATE(8682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389059] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11194), 1,
      anon_sym_RPAREN,
    STATE(8465), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389106] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11196), 1,
      anon_sym_EQ,
    ACTIONS(10454), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389151] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11198), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389198] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11200), 1,
      anon_sym_COMMA,
    ACTIONS(11203), 1,
      anon_sym_RPAREN,
    STATE(8686), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_using_variable_declaration_repeat1,
  [389243] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    ACTIONS(11205), 1,
      anon_sym_GT,
    STATE(8647), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(8687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389290] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_RBRACK,
    ACTIONS(11207), 1,
      anon_sym_COMMA,
    STATE(8449), 1,
      aux_sym_list_pattern_repeat1,
    STATE(8688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389337] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11209), 1,
      anon_sym_RPAREN,
    STATE(8700), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389384] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7885), 1,
      anon_sym_COMMA,
    ACTIONS(11211), 1,
      anon_sym_RPAREN,
    STATE(8370), 1,
      aux_sym_for_statement_repeat1,
    STATE(8690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389431] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8107), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389478] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(8239), 1,
      anon_sym_RBRACK,
    STATE(8673), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(8692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389525] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11213), 1,
      anon_sym_COMMA,
    ACTIONS(11216), 1,
      anon_sym_RPAREN,
    STATE(8693), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_attribute_argument_list_repeat1,
  [389570] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10620), 1,
      anon_sym_COMMA,
    ACTIONS(11218), 1,
      anon_sym_RBRACE,
    STATE(8607), 1,
      aux_sym_with_expression_repeat1,
    STATE(8694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389617] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8165), 1,
      anon_sym_COMMA,
    ACTIONS(11220), 1,
      anon_sym_SEMI,
    STATE(8431), 1,
      aux_sym_for_statement_repeat1,
    STATE(8695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389664] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11222), 1,
      anon_sym_COMMA,
    ACTIONS(11225), 1,
      anon_sym_GT,
    STATE(8696), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_type_parameter_list_repeat1,
  [389709] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10190), 1,
      anon_sym_COMMA,
    ACTIONS(10393), 1,
      anon_sym_LBRACE,
    STATE(8699), 1,
      aux_sym_base_list_repeat1,
    STATE(8697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389756] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10706), 1,
      anon_sym_COMMA,
    ACTIONS(11227), 1,
      anon_sym_RPAREN,
    STATE(8454), 1,
      aux_sym_bracketed_parameter_list_repeat1,
    STATE(8698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389803] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(11229), 1,
      anon_sym_COMMA,
    STATE(8699), 9,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
      aux_sym_base_list_repeat1,
  [389848] = 13,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10598), 1,
      anon_sym_COMMA,
    ACTIONS(11232), 1,
      anon_sym_RPAREN,
    STATE(8485), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(8700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389895] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_LBRACE,
    STATE(4082), 1,
      sym_initializer_expression,
    STATE(8701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389939] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9693), 1,
      sym_enum_member_declaration_list,
    STATE(8702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [389983] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7775), 1,
      sym_parameter_list,
    STATE(8703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390027] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8244), 1,
      sym_bracketed_parameter_list,
    STATE(8704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7658), 1,
      sym_parameter_list,
    STATE(8705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390115] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11236), 1,
      anon_sym_SEMI,
    STATE(8706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390159] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7917), 1,
      sym_parameter_list,
    STATE(8707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390203] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11238), 2,
      anon_sym_this,
      anon_sym_base,
    STATE(8708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390245] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8457), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390289] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8293), 1,
      sym_bracketed_parameter_list,
    STATE(8710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390333] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7770), 1,
      sym_parameter_list,
    STATE(8711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390377] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11240), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390419] = 12,
    ACTIONS(5351), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11242), 1,
      sym_string_literal_encoding,
    STATE(8713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390463] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(8455), 1,
      aux_sym_argument_list_repeat1,
    STATE(8714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390507] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7880), 1,
      sym_parameter_list,
    STATE(8715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11244), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11246), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390635] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11225), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390677] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7591), 1,
      sym_parameter_list,
    STATE(8719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390721] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7813), 1,
      sym_parameter_list,
    STATE(8720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390765] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7604), 1,
      sym_parameter_list,
    STATE(8721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390809] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11248), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390851] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11250), 1,
      anon_sym_on,
    STATE(7587), 1,
      sym__join_body,
    STATE(8723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390895] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7844), 1,
      sym_parameter_list,
    STATE(8724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390939] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11252), 1,
      anon_sym_in,
    STATE(8725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [390983] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11254), 1,
      anon_sym_in,
    STATE(8726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391027] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(8362), 1,
      sym_block,
    STATE(8727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391071] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7638), 1,
      sym_parameter_list,
    STATE(8728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391115] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11256), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391157] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5781), 1,
      anon_sym_LPAREN,
    STATE(8655), 1,
      sym_argument_list,
    STATE(8730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391201] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11216), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391243] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10996), 1,
      anon_sym_COMMA,
    STATE(8590), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391287] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11203), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391329] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3177), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391371] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3351), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391413] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8333), 1,
      sym_bracketed_parameter_list,
    STATE(8736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391457] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11258), 1,
      anon_sym_LBRACK,
    STATE(3486), 1,
      sym_array_rank_specifier,
    STATE(8737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391501] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7623), 1,
      sym_parameter_list,
    STATE(8738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391545] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11180), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11260), 1,
      anon_sym_COMMA,
    STATE(8739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391589] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3355), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391631] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11164), 1,
      anon_sym_DQUOTE,
    STATE(9794), 1,
      sym_string_literal,
    STATE(8741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391675] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9705), 1,
      sym_enum_member_declaration_list,
    STATE(8742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391719] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7665), 1,
      sym_parameter_list,
    STATE(8743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391763] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3327), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391805] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(3791), 1,
      sym_block,
    STATE(8745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391849] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7615), 1,
      sym_parameter_list,
    STATE(8746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391893] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11262), 1,
      anon_sym_in,
    STATE(8747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391937] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9901), 1,
      sym_enum_member_declaration_list,
    STATE(8748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [391981] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11264), 1,
      anon_sym_in,
    STATE(8749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392025] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8287), 1,
      sym_bracketed_parameter_list,
    STATE(8750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392069] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8406), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392113] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    STATE(2652), 1,
      sym_block,
    STATE(8752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392157] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(8347), 1,
      sym_block,
    STATE(8753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392201] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8360), 1,
      sym_parameter_list,
    STATE(8754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392245] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(8475), 1,
      aux_sym_argument_list_repeat1,
    STATE(8755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392289] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11112), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392331] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(8955), 1,
      sym_switch_body,
    STATE(8757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392375] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8264), 1,
      sym_parameter_list,
    STATE(8758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392419] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1243), 1,
      anon_sym_LBRACE,
    STATE(3713), 1,
      sym_initializer_expression,
    STATE(8759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392463] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7644), 1,
      sym_parameter_list,
    STATE(8760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392507] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(2481), 1,
      sym_switch_body,
    STATE(8761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11123), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392635] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3347), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392677] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3335), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392719] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4482), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392761] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4486), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392803] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3331), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392845] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3319), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392887] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4496), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392929] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7605), 1,
      sym_parameter_list,
    STATE(8771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [392973] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11270), 1,
      anon_sym_SEMI,
    STATE(8772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393017] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_LBRACE,
    STATE(3756), 1,
      sym_initializer_expression,
    STATE(8773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393061] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3085), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393103] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(3635), 1,
      sym_block,
    STATE(8775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393147] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11272), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393189] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    STATE(2459), 1,
      sym_block,
    STATE(8777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393233] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11274), 1,
      anon_sym_SEMI,
    STATE(8778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393277] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11276), 1,
      anon_sym_LBRACK,
    STATE(5237), 1,
      sym_array_rank_specifier,
    STATE(8779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393321] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11278), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393363] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1243), 1,
      anon_sym_LBRACE,
    STATE(3631), 1,
      sym_initializer_expression,
    STATE(8781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393407] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7811), 1,
      sym_parameter_list,
    STATE(8782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393451] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3065), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393493] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11280), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11282), 1,
      sym_preproc_arg,
    STATE(8784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393537] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9804), 1,
      sym_enum_member_declaration_list,
    STATE(8785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393581] = 12,
    ACTIONS(5382), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11284), 1,
      sym_string_literal_encoding,
    STATE(8786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393625] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8320), 1,
      sym_parameter_list,
    STATE(8787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393669] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7914), 1,
      sym_parameter_list,
    STATE(8788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393713] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11286), 1,
      anon_sym_LPAREN,
    STATE(8945), 1,
      sym_tuple_expression,
    STATE(8789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393757] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7580), 1,
      sym_parameter_list,
    STATE(8790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393801] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11288), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393843] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10206), 1,
      anon_sym_LBRACE,
    STATE(4066), 1,
      sym_block,
    STATE(8792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393887] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7912), 1,
      sym_parameter_list,
    STATE(8793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393931] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3235), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [393973] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(5742), 1,
      sym_initializer_expression,
    STATE(8795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394017] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9071), 1,
      sym_enum_member_declaration_list,
    STATE(8796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394061] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3405), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394103] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3401), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394145] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11290), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394187] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7617), 1,
      sym_parameter_list,
    STATE(8800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394231] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7926), 1,
      sym_parameter_list,
    STATE(8801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394275] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(8451), 1,
      aux_sym_argument_list_repeat1,
    STATE(8802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394319] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(4321), 1,
      sym_block,
    STATE(8803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394363] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8459), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394407] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3391), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394449] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11292), 1,
      anon_sym_in,
    STATE(8806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394493] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3069), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394535] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    STATE(2216), 1,
      sym_block,
    STATE(8808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394579] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3049), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394621] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8277), 1,
      sym_parameter_list,
    STATE(8810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394665] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3387), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394707] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(8969), 1,
      sym_block,
    STATE(8812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394751] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(3747), 1,
      sym_block,
    STATE(8813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394795] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11294), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394837] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11296), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394879] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    STATE(2277), 1,
      sym_block,
    STATE(8816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394923] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11041), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [394965] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_LBRACE,
    STATE(4053), 1,
      sym_initializer_expression,
    STATE(8818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395009] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8250), 1,
      sym_parameter_list,
    STATE(8819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395053] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7622), 1,
      sym_parameter_list,
    STATE(8820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395097] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3097), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395139] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3303), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395181] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3299), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395223] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11268), 1,
      anon_sym_LBRACE,
    STATE(2446), 1,
      sym_switch_body,
    STATE(8824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395267] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_LBRACE,
    STATE(3736), 1,
      sym_initializer_expression,
    STATE(8825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395311] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3295), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395353] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    STATE(2650), 1,
      sym_block,
    STATE(8827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395397] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8279), 1,
      sym_parameter_list,
    STATE(8828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395441] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3109), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395483] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11164), 1,
      anon_sym_DQUOTE,
    STATE(9473), 1,
      sym_string_literal,
    STATE(8830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395527] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3291), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395569] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3275), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395611] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7561), 1,
      sym_parameter_list,
    STATE(8833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395655] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11298), 1,
      anon_sym_SEMI,
    STATE(8834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395699] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3053), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395741] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7582), 1,
      sym_parameter_list,
    STATE(8836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395785] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3173), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395827] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7343), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym_STAR,
    STATE(8838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395871] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3251), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395913] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9707), 1,
      sym_enum_member_declaration_list,
    STATE(8840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395957] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10915), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [395999] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7606), 1,
      sym_parameter_list,
    STATE(8842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396043] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7803), 1,
      sym_parameter_list,
    STATE(8843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396087] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1243), 1,
      anon_sym_LBRACE,
    STATE(3698), 1,
      sym_initializer_expression,
    STATE(8844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7821), 1,
      sym_parameter_list,
    STATE(8845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396175] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11300), 1,
      anon_sym_LPAREN,
    STATE(8923), 1,
      sym_tuple_expression,
    STATE(8846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396219] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7849), 1,
      sym_parameter_list,
    STATE(8847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396263] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_LBRACE,
    STATE(4040), 1,
      sym_initializer_expression,
    STATE(8848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396307] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11302), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396349] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(2715), 1,
      sym_switch_body,
    STATE(8850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396393] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11306), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396435] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11308), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396477] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    STATE(2215), 1,
      sym_block,
    STATE(8853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396521] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11310), 1,
      anon_sym_in,
    STATE(8854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396565] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_LBRACE,
    STATE(3776), 1,
      sym_initializer_expression,
    STATE(8855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396609] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11312), 1,
      anon_sym_LBRACK,
    ACTIONS(11314), 1,
      anon_sym_LT,
    STATE(8856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396653] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3243), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396695] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7845), 1,
      sym_parameter_list,
    STATE(8858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396739] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(125), 1,
      anon_sym_DQUOTE,
    STATE(8898), 1,
      sym_string_literal,
    STATE(8859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396783] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    STATE(2265), 1,
      sym_block,
    STATE(8860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396827] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3223), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396869] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3219), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396911] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3093), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396953] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3089), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [396995] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3081), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397037] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3207), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397079] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_LBRACE,
    STATE(4118), 1,
      sym_initializer_expression,
    STATE(8867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397123] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    STATE(2510), 1,
      sym_block,
    STATE(8868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397167] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11316), 1,
      anon_sym_LBRACE,
    STATE(2249), 1,
      sym_switch_body,
    STATE(8869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397211] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3231), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397253] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10590), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397295] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(5776), 1,
      sym_initializer_expression,
    STATE(8872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397339] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3239), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397381] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11318), 2,
      anon_sym_disable,
      anon_sym_restore,
    STATE(8874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397423] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11320), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397465] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8561), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397509] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_LBRACE,
    STATE(4091), 1,
      sym_initializer_expression,
    STATE(8877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397553] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10842), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397595] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3247), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397637] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7627), 1,
      sym_parameter_list,
    STATE(8880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397681] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11322), 1,
      anon_sym_LBRACK,
    STATE(3704), 1,
      sym_array_rank_specifier,
    STATE(8881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397725] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3061), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397767] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1643), 1,
      anon_sym_LBRACE,
    STATE(4623), 1,
      sym_initializer_expression,
    STATE(8883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397811] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7577), 1,
      sym_parameter_list,
    STATE(8884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397855] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10176), 1,
      anon_sym_LBRACE,
    STATE(5777), 1,
      sym_block,
    STATE(8885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397899] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8303), 1,
      sym_parameter_list,
    STATE(8886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397943] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11324), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [397985] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3077), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398027] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9049), 1,
      sym_enum_member_declaration_list,
    STATE(8889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398071] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10822), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398113] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10206), 1,
      anon_sym_LBRACE,
    STATE(3980), 1,
      sym_block,
    STATE(8891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398157] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9290), 1,
      sym_enum_member_declaration_list,
    STATE(8892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398201] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3073), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398243] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3259), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398285] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3279), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398327] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8537), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398371] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(8534), 1,
      aux_sym_argument_list_repeat1,
    STATE(8897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398415] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(125), 1,
      anon_sym_DQUOTE,
    STATE(8830), 1,
      sym_string_literal,
    STATE(8898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398459] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11326), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(8899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398501] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(8900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398543] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3339), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398585] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    STATE(2274), 1,
      sym_block,
    STATE(8902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398629] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3263), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398671] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11330), 1,
      anon_sym_SEMI,
    STATE(8904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398715] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10220), 1,
      anon_sym_LBRACE,
    STATE(4153), 1,
      sym_block,
    STATE(8905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398759] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11332), 1,
      anon_sym_LBRACK,
    STATE(4006), 1,
      sym_array_rank_specifier,
    STATE(8906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398803] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11334), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398845] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11336), 1,
      anon_sym_LPAREN,
    STATE(8960), 1,
      sym_tuple_expression,
    STATE(8908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398889] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11338), 1,
      anon_sym_LBRACK,
    STATE(5317), 1,
      sym_array_rank_specifier,
    STATE(8909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398933] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8271), 1,
      sym_parameter_list,
    STATE(8910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [398977] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10150), 1,
      anon_sym_LBRACE,
    STATE(4669), 1,
      sym_block,
    STATE(8911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399021] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_GT,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(8912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399065] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3255), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399107] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11340), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399149] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(5732), 1,
      sym_initializer_expression,
    STATE(8915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399193] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_LBRACE,
    STATE(4187), 1,
      sym_initializer_expression,
    STATE(8916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399237] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8506), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399281] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5788), 1,
      anon_sym_LBRACE,
    STATE(2211), 1,
      sym_block,
    STATE(8918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399325] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8265), 1,
      sym_bracketed_parameter_list,
    STATE(8919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399369] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11342), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399411] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10725), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(8921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399453] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11344), 1,
      anon_sym_SEMI,
    STATE(8922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399497] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11304), 1,
      anon_sym_LBRACE,
    STATE(2661), 1,
      sym_switch_body,
    STATE(8923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399541] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6050), 1,
      anon_sym_LBRACE,
    STATE(7703), 1,
      sym_block,
    STATE(8924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399585] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3371), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399627] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3343), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399669] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11346), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399711] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7839), 1,
      sym_parameter_list,
    STATE(8928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399755] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10571), 1,
      anon_sym_COMMA,
    STATE(8532), 1,
      aux_sym_argument_list_repeat1,
    STATE(8929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399799] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3383), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399841] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8530), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399885] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11348), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(8932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399927] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3311), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [399969] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11350), 1,
      anon_sym_LBRACK,
    STATE(2980), 1,
      sym_array_rank_specifier,
    STATE(8934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400013] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3057), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400055] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7840), 1,
      sym_parameter_list,
    STATE(8936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400099] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(5760), 1,
      anon_sym_LBRACE,
    STATE(2214), 1,
      sym_block,
    STATE(8937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400143] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10178), 1,
      anon_sym_LBRACE,
    STATE(3717), 1,
      sym_block,
    STATE(8938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400187] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11352), 2,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(8939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400229] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11354), 1,
      anon_sym_LPAREN,
    STATE(8761), 1,
      sym_tuple_expression,
    STATE(8940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400273] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3101), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400315] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11356), 1,
      anon_sym_in,
    STATE(8942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400359] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3113), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400401] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3169), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400443] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11316), 1,
      anon_sym_LBRACE,
    STATE(2266), 1,
      sym_switch_body,
    STATE(8945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400487] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3181), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400529] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11358), 1,
      anon_sym_SEMI,
    STATE(8947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400573] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10150), 1,
      anon_sym_LBRACE,
    STATE(4633), 1,
      sym_block,
    STATE(8948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400617] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_while,
    ACTIONS(11360), 1,
      anon_sym_else,
    STATE(8949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400661] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    STATE(2670), 1,
      sym_block,
    STATE(8950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400705] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11362), 1,
      anon_sym_SEMI,
    STATE(8951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400749] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3191), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400791] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11364), 1,
      anon_sym_SEMI,
    STATE(8953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400835] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3195), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400877] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3199), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400919] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3203), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [400961] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3211), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401003] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3215), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401045] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3227), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401087] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11266), 1,
      anon_sym_LBRACE,
    STATE(8903), 1,
      sym_switch_body,
    STATE(8960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401131] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10176), 1,
      anon_sym_LBRACE,
    STATE(5696), 1,
      sym_block,
    STATE(8961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401175] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3359), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401217] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3379), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401259] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7825), 1,
      sym_parameter_list,
    STATE(8964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401303] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    ACTIONS(11366), 1,
      anon_sym_in,
    STATE(8965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401347] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3395), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401389] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10355), 1,
      anon_sym_LBRACE,
    STATE(9253), 1,
      sym_enum_member_declaration_list,
    STATE(8967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401433] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11234), 1,
      anon_sym_LBRACK,
    STATE(8270), 1,
      sym_bracketed_parameter_list,
    STATE(8968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401477] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3287), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401519] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3307), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401561] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3323), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401603] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11368), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401645] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11370), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    STATE(8973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401687] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3375), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401729] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1643), 1,
      anon_sym_LBRACE,
    STATE(4654), 1,
      sym_initializer_expression,
    STATE(8975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401773] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(8299), 1,
      sym_parameter_list,
    STATE(8976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401817] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3315), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401859] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9377), 1,
      anon_sym_LPAREN,
    STATE(7628), 1,
      sym_parameter_list,
    STATE(8978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401903] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11372), 2,
      anon_sym_LBRACE,
      anon_sym_when,
    STATE(8979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401945] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3283), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [401987] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11374), 1,
      anon_sym_LBRACK,
    STATE(3912), 1,
      sym_array_rank_specifier,
    STATE(8981), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402031] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10996), 1,
      anon_sym_COMMA,
    STATE(8670), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(8982), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402075] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11376), 2,
      sym_character_literal_content,
      sym_escape_sequence,
    STATE(8983), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402117] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_warning,
    ACTIONS(11380), 1,
      anon_sym_checksum,
    STATE(8984), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402161] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_DOT,
    ACTIONS(11382), 1,
      anon_sym_SEMI,
    STATE(8985), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402205] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(1643), 1,
      anon_sym_LBRACE,
    STATE(4646), 1,
      sym_initializer_expression,
    STATE(8986), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402249] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11384), 1,
      anon_sym_LBRACK,
    STATE(3616), 1,
      sym_array_rank_specifier,
    STATE(8987), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402293] = 12,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10608), 1,
      anon_sym_COMMA,
    STATE(8542), 1,
      aux_sym_tuple_type_repeat1,
    STATE(8988), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402337] = 12,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(11386), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11388), 1,
      sym_preproc_arg,
    STATE(8989), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402381] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3003), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8990), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402423] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(3267), 2,
      anon_sym_while,
      anon_sym_else,
    STATE(8991), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402465] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11390), 1,
      anon_sym_EQ_GT,
    STATE(8992), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402506] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11392), 1,
      sym__optional_semi,
    STATE(8993), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402547] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10569), 1,
      anon_sym_RBRACE,
    STATE(8994), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402588] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11394), 1,
      sym__optional_semi,
    STATE(8995), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402629] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11396), 1,
      anon_sym_RPAREN,
    STATE(8996), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402670] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11398), 1,
      sym__optional_semi,
    STATE(8997), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402711] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11400), 1,
      anon_sym_EQ_GT,
    STATE(8998), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402752] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11402), 1,
      aux_sym_preproc_if_token3,
    STATE(8999), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402793] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11404), 1,
      sym__optional_semi,
    STATE(9000), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402834] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11406), 1,
      anon_sym_EQ_GT,
    STATE(9001), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402875] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11408), 1,
      anon_sym_RPAREN,
    STATE(9002), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402916] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11410), 1,
      sym__optional_semi,
    STATE(9003), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402957] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11412), 1,
      anon_sym_RPAREN,
    STATE(9004), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [402998] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11414), 1,
      anon_sym_RPAREN,
    STATE(9005), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403039] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11416), 1,
      anon_sym_SEMI,
    STATE(9006), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403080] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11418), 1,
      sym__optional_semi,
    STATE(9007), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403121] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11420), 1,
      anon_sym_COLON,
    STATE(9008), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403162] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11422), 1,
      anon_sym_EQ_GT,
    STATE(9009), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403203] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11424), 1,
      anon_sym_EQ_GT,
    STATE(9010), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403244] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11426), 1,
      anon_sym_RBRACK,
    STATE(9011), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403285] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11428), 1,
      sym__optional_semi,
    STATE(9012), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403326] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11430), 1,
      sym__optional_semi,
    STATE(9013), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403367] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11432), 1,
      anon_sym_EQ_GT,
    STATE(9014), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403408] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11434), 1,
      anon_sym_LBRACE,
    STATE(9015), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403449] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11436), 1,
      anon_sym_LBRACE,
    STATE(9016), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403490] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11438), 1,
      anon_sym_EQ_GT,
    STATE(9017), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403531] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11440), 1,
      anon_sym_EQ_GT,
    STATE(9018), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403572] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11442), 1,
      anon_sym_SQUOTE,
    STATE(9019), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403613] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11444), 1,
      sym__optional_semi,
    STATE(9020), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403654] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11446), 1,
      anon_sym_EQ_GT,
    STATE(9021), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403695] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11448), 1,
      sym__optional_semi,
    STATE(9022), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403736] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_EQ_GT,
    STATE(9023), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403777] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11452), 1,
      anon_sym_GT,
    STATE(9024), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403818] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10614), 1,
      anon_sym_RBRACE,
    STATE(9025), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403859] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11454), 1,
      sym__optional_semi,
    STATE(9026), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403900] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11456), 1,
      anon_sym_EQ_GT,
    STATE(9027), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403941] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11458), 1,
      anon_sym_EQ_GT,
    STATE(9028), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [403982] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11460), 1,
      anon_sym_EQ_GT,
    STATE(9029), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404023] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11462), 1,
      anon_sym_EQ_GT,
    STATE(9030), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404064] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11464), 1,
      anon_sym_SEMI,
    STATE(9031), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404105] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8841), 1,
      anon_sym_RPAREN,
    STATE(9032), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404146] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11466), 1,
      anon_sym_SEMI,
    STATE(9033), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404187] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11468), 1,
      anon_sym_SEMI,
    STATE(9034), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404228] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11470), 1,
      anon_sym_EQ_GT,
    STATE(9035), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404269] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11472), 1,
      aux_sym_preproc_if_token3,
    STATE(9036), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404310] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11474), 1,
      anon_sym_EQ_GT,
    STATE(9037), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404351] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11476), 1,
      anon_sym_RPAREN,
    STATE(9038), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404392] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11478), 1,
      anon_sym_EQ_GT,
    STATE(9039), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404433] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11480), 1,
      anon_sym_GT,
    STATE(9040), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404474] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11482), 1,
      anon_sym_EQ_GT,
    STATE(9041), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404515] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11484), 1,
      anon_sym_EQ_GT,
    STATE(9042), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404556] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11486), 1,
      anon_sym_SEMI,
    STATE(9043), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404597] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11488), 1,
      anon_sym_LBRACE,
    STATE(9044), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404638] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11490), 1,
      anon_sym_EQ_GT,
    STATE(9045), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404679] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11492), 1,
      sym__optional_semi,
    STATE(9046), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404720] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11494), 1,
      anon_sym_LBRACE,
    STATE(9047), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404761] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11496), 1,
      anon_sym_EQ_GT,
    STATE(9048), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404802] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11498), 1,
      sym__optional_semi,
    STATE(9049), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404843] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11500), 1,
      anon_sym_EQ_GT,
    STATE(9050), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404884] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11502), 1,
      anon_sym_RBRACK,
    STATE(9051), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404925] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11504), 1,
      sym__optional_semi,
    STATE(9052), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [404966] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10661), 1,
      anon_sym_RBRACE,
    STATE(9053), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405007] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11506), 1,
      anon_sym_EQ_GT,
    STATE(9054), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405048] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11508), 1,
      sym__optional_semi,
    STATE(9055), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405089] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11510), 1,
      anon_sym_EQ_GT,
    STATE(9056), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405130] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11512), 1,
      anon_sym_EQ_GT,
    STATE(9057), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405171] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11514), 1,
      anon_sym_SEMI,
    STATE(9058), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405212] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11516), 1,
      aux_sym_preproc_if_token3,
    STATE(9059), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405253] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11518), 1,
      sym__optional_semi,
    STATE(9060), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405294] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11520), 1,
      anon_sym_SQUOTE,
    STATE(9061), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405335] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11522), 1,
      anon_sym_EQ_GT,
    STATE(9062), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405376] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11524), 1,
      sym__optional_semi,
    STATE(9063), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405417] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11526), 1,
      anon_sym_EQ_GT,
    STATE(9064), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405458] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_EQ_GT,
    STATE(9065), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405499] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11530), 1,
      anon_sym_SEMI,
    STATE(9066), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405540] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11532), 1,
      sym_raw_string_content,
    STATE(9067), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405581] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11534), 1,
      sym_interpolation_start_quote,
    STATE(9068), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405622] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11536), 1,
      anon_sym_GT,
    STATE(9069), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405663] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11538), 1,
      sym__optional_semi,
    STATE(9070), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405704] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11540), 1,
      sym__optional_semi,
    STATE(9071), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405745] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11542), 1,
      anon_sym_DQUOTE,
    STATE(9072), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405786] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11544), 1,
      anon_sym_EQ_GT,
    STATE(9073), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405827] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11546), 1,
      anon_sym_EQ_GT,
    STATE(9074), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405868] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11548), 1,
      anon_sym_DQUOTE,
    STATE(9075), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405909] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11550), 1,
      anon_sym_EQ_GT,
    STATE(9076), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405950] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11552), 1,
      anon_sym_GT,
    STATE(9077), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [405991] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11554), 1,
      sym__optional_semi,
    STATE(9078), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406032] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8255), 1,
      anon_sym_RBRACE,
    STATE(9079), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406073] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11556), 1,
      anon_sym_EQ_GT,
    STATE(9080), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406114] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11558), 1,
      anon_sym_STAR,
    STATE(9081), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406155] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11560), 1,
      sym__optional_semi,
    STATE(9082), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406196] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11562), 1,
      anon_sym_EQ_GT,
    STATE(9083), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406237] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11564), 1,
      anon_sym_EQ_GT,
    STATE(9084), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406278] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11566), 1,
      anon_sym_EQ_GT,
    STATE(9085), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406319] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11568), 1,
      anon_sym_EQ_GT,
    STATE(9086), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406360] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11570), 1,
      anon_sym_SEMI,
    STATE(9087), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406401] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11572), 1,
      sym_raw_string_end,
    STATE(9088), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406442] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11574), 1,
      anon_sym_EQ_GT,
    STATE(9089), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406483] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11576), 1,
      anon_sym_GT,
    STATE(9090), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406524] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11578), 1,
      anon_sym_EQ_GT,
    STATE(9091), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406565] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8220), 1,
      anon_sym_RBRACE,
    STATE(9092), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406606] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_EQ_GT,
    STATE(9093), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406647] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11582), 1,
      sym__optional_semi,
    STATE(9094), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406688] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11584), 1,
      sym__optional_semi,
    STATE(9095), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406729] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11586), 1,
      anon_sym_COMMA,
    STATE(9096), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406770] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11588), 1,
      sym__optional_semi,
    STATE(9097), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406811] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11590), 1,
      anon_sym_COMMA,
    STATE(9098), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406852] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11592), 1,
      sym__optional_semi,
    STATE(9099), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406893] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11594), 1,
      anon_sym_EQ_GT,
    STATE(9100), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406934] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10910), 1,
      anon_sym_RBRACE,
    STATE(9101), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [406975] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11596), 1,
      anon_sym_EQ_GT,
    STATE(9102), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407016] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11598), 1,
      anon_sym_RPAREN,
    STATE(9103), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407057] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11600), 1,
      anon_sym_EQ_GT,
    STATE(9104), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407098] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11602), 1,
      anon_sym_RPAREN,
    STATE(9105), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407139] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11604), 1,
      anon_sym_STAR,
    STATE(9106), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407180] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11606), 1,
      anon_sym_EQ_GT,
    STATE(9107), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407221] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11608), 1,
      anon_sym_RPAREN,
    STATE(9108), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407262] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11610), 1,
      sym__optional_semi,
    STATE(9109), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407303] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11612), 1,
      anon_sym_EQ_GT,
    STATE(9110), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407344] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11614), 1,
      anon_sym_EQ_GT,
    STATE(9111), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407385] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11616), 1,
      anon_sym_RPAREN,
    STATE(9112), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407426] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11618), 1,
      sym__optional_semi,
    STATE(9113), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407467] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10846), 1,
      anon_sym_RBRACE,
    STATE(9114), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407508] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11620), 1,
      anon_sym_SEMI,
    STATE(9115), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407549] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11622), 1,
      anon_sym_operator,
    STATE(9116), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407590] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11624), 1,
      anon_sym_EQ_GT,
    STATE(9117), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407631] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11626), 1,
      anon_sym_EQ_GT,
    STATE(9118), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407672] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11628), 1,
      anon_sym_SEMI,
    STATE(9119), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407713] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11630), 1,
      anon_sym_EQ_GT,
    STATE(9120), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407754] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11632), 1,
      sym__optional_semi,
    STATE(9121), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407795] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_EQ_GT,
    STATE(9122), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407836] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11636), 1,
      anon_sym_SEMI,
    STATE(9123), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407877] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11638), 1,
      anon_sym_SEMI,
    STATE(9124), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407918] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11640), 1,
      anon_sym_EQ_GT,
    STATE(9125), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [407959] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11642), 1,
      anon_sym_EQ_GT,
    STATE(9126), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408000] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11644), 1,
      anon_sym_EQ_GT,
    STATE(9127), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408041] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11646), 1,
      anon_sym_EQ_GT,
    STATE(9128), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408082] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11648), 1,
      sym__optional_semi,
    STATE(9129), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408123] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11650), 1,
      anon_sym_SEMI,
    STATE(9130), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408164] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11652), 1,
      anon_sym_SEMI,
    STATE(9131), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408205] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11654), 1,
      anon_sym_EQ_GT,
    STATE(9132), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408246] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11656), 1,
      anon_sym_EQ_GT,
    STATE(9133), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408287] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11658), 1,
      anon_sym_EQ_GT,
    STATE(9134), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408328] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11660), 1,
      anon_sym_EQ_GT,
    STATE(9135), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408369] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11662), 1,
      anon_sym_EQ_GT,
    STATE(9136), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408410] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11664), 1,
      anon_sym_EQ_GT,
    STATE(9137), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408451] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11666), 1,
      anon_sym_EQ_GT,
    STATE(9138), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408492] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11668), 1,
      anon_sym_EQ_GT,
    STATE(9139), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408533] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11670), 1,
      anon_sym_EQ_GT,
    STATE(9140), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408574] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11672), 1,
      anon_sym_EQ_GT,
    STATE(9141), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408615] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11674), 1,
      sym__optional_semi,
    STATE(9142), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408656] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11676), 1,
      anon_sym_EQ_GT,
    STATE(9143), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408697] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11678), 1,
      anon_sym_EQ_GT,
    STATE(9144), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408738] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11680), 1,
      anon_sym_EQ_GT,
    STATE(9145), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408779] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11682), 1,
      anon_sym_EQ_GT,
    STATE(9146), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408820] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11684), 1,
      anon_sym_EQ_GT,
    STATE(9147), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408861] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11686), 1,
      anon_sym_GT,
    STATE(9148), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408902] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11688), 1,
      anon_sym_SEMI,
    STATE(9149), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408943] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11690), 1,
      sym_integer_literal,
    STATE(9150), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [408984] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11692), 1,
      aux_sym_preproc_if_token3,
    STATE(9151), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409025] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11694), 1,
      anon_sym_LBRACE,
    STATE(9152), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409066] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11696), 1,
      anon_sym_LBRACE,
    STATE(9153), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409107] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11698), 1,
      anon_sym_EQ_GT,
    STATE(9154), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409148] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11700), 1,
      anon_sym_EQ_GT,
    STATE(9155), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409189] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11702), 1,
      anon_sym_EQ_GT,
    STATE(9156), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409230] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8943), 1,
      anon_sym_RPAREN,
    STATE(9157), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409271] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11704), 1,
      anon_sym_SEMI,
    STATE(9158), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409312] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11706), 1,
      aux_sym_preproc_if_token3,
    STATE(9159), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409353] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11708), 1,
      aux_sym_preproc_if_token3,
    STATE(9160), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409394] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11710), 1,
      anon_sym_EQ_GT,
    STATE(9161), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409435] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11712), 1,
      sym__optional_semi,
    STATE(9162), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409476] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11714), 1,
      anon_sym_EQ_GT,
    STATE(9163), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409517] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11716), 1,
      anon_sym_SEMI,
    STATE(9164), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409558] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11718), 1,
      anon_sym_EQ_GT,
    STATE(9165), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409599] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10974), 1,
      anon_sym_RBRACE,
    STATE(9166), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409640] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11720), 1,
      anon_sym_EQ_GT,
    STATE(9167), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409681] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11722), 1,
      anon_sym_COLON,
    STATE(9168), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409722] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11724), 1,
      anon_sym_EQ_GT,
    STATE(9169), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409763] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11726), 1,
      anon_sym_RBRACK,
    STATE(9170), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409804] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11728), 1,
      sym_integer_literal,
    STATE(9171), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409845] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11730), 1,
      anon_sym_LPAREN,
    STATE(9172), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409886] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9073), 1,
      anon_sym_RPAREN,
    STATE(9173), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409927] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11732), 1,
      anon_sym_EQ_GT,
    STATE(9174), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [409968] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11734), 1,
      anon_sym_SEMI,
    STATE(9175), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410009] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11736), 1,
      anon_sym_EQ_GT,
    STATE(9176), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410050] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11738), 1,
      anon_sym_RBRACE,
    STATE(9177), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410091] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11740), 1,
      aux_sym_preproc_if_token3,
    STATE(9178), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410132] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11742), 1,
      anon_sym_EQ_GT,
    STATE(9179), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410173] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11744), 1,
      anon_sym_EQ_GT,
    STATE(9180), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410214] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11746), 1,
      anon_sym_SQUOTE,
    STATE(9181), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410255] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11748), 1,
      anon_sym_EQ_GT,
    STATE(9182), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410296] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11750), 1,
      anon_sym_EQ_GT,
    STATE(9183), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410337] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11752), 1,
      anon_sym_EQ_GT,
    STATE(9184), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410378] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11292), 1,
      anon_sym_in,
    STATE(9185), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410419] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11754), 1,
      sym_integer_literal,
    STATE(9186), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410460] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11018), 1,
      anon_sym_RBRACE,
    STATE(9187), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410501] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11756), 1,
      sym__optional_semi,
    STATE(9188), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410542] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11758), 1,
      anon_sym_EQ_GT,
    STATE(9189), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410583] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8325), 1,
      anon_sym_RBRACE,
    STATE(9190), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410624] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11760), 1,
      anon_sym_EQ_GT,
    STATE(9191), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410665] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11762), 1,
      sym__optional_semi,
    STATE(9192), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410706] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11764), 1,
      sym__optional_semi,
    STATE(9193), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410747] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11766), 1,
      anon_sym_EQ_GT,
    STATE(9194), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410788] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11768), 1,
      sym__optional_semi,
    STATE(9195), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410829] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11770), 1,
      anon_sym_EQ_GT,
    STATE(9196), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410870] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11772), 1,
      anon_sym_EQ_GT,
    STATE(9197), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410911] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11774), 1,
      anon_sym_GT,
    STATE(9198), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410952] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11776), 1,
      aux_sym_preproc_if_token3,
    STATE(9199), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [410993] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11778), 1,
      aux_sym_preproc_if_token3,
    STATE(9200), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411034] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11780), 1,
      aux_sym_preproc_if_token3,
    STATE(9201), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411075] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11782), 1,
      anon_sym_EQ_GT,
    STATE(9202), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411116] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11784), 1,
      anon_sym_EQ_GT,
    STATE(9203), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411157] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11069), 1,
      sym_interpolation_close_brace,
    STATE(9204), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411198] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11786), 1,
      sym_raw_string_content,
    STATE(9205), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411239] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11788), 1,
      sym_raw_string_end,
    STATE(9206), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411280] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11790), 1,
      sym_interpolation_start_quote,
    STATE(9207), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411321] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11792), 1,
      sym__optional_semi,
    STATE(9208), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411362] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11794), 1,
      anon_sym_DQUOTE,
    STATE(9209), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411403] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11796), 1,
      anon_sym_EQ_GT,
    STATE(9210), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411444] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11798), 1,
      anon_sym_EQ_GT,
    STATE(9211), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411485] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11800), 1,
      anon_sym_STAR,
    STATE(9212), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411526] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11802), 1,
      anon_sym_DQUOTE,
    STATE(9213), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411567] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11804), 1,
      anon_sym_GT,
    STATE(9214), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411608] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11806), 1,
      anon_sym_EQ_GT,
    STATE(9215), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411649] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11808), 1,
      anon_sym_EQ_GT,
    STATE(9216), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411690] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11810), 1,
      anon_sym_EQ_GT,
    STATE(9217), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411731] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11812), 1,
      anon_sym_EQ_GT,
    STATE(9218), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411772] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11814), 1,
      anon_sym_DOT,
    STATE(9219), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411813] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11816), 1,
      anon_sym_EQ_GT,
    STATE(9220), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411854] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11818), 1,
      anon_sym_SEMI,
    STATE(9221), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411895] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11820), 1,
      anon_sym_EQ_GT,
    STATE(9222), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411936] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11822), 1,
      sym__optional_semi,
    STATE(9223), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [411977] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11824), 1,
      sym__optional_semi,
    STATE(9224), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412018] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11826), 1,
      anon_sym_EQ_GT,
    STATE(9225), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412059] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11828), 1,
      sym__optional_semi,
    STATE(9226), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412100] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11830), 1,
      sym__optional_semi,
    STATE(9227), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412141] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11832), 1,
      anon_sym_EQ_GT,
    STATE(9228), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412182] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11834), 1,
      sym__optional_semi,
    STATE(9229), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412223] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11836), 1,
      anon_sym_GT,
    STATE(9230), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412264] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11838), 1,
      anon_sym_EQ_GT,
    STATE(9231), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412305] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11840), 1,
      anon_sym_EQ_GT,
    STATE(9232), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412346] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11842), 1,
      sym__optional_semi,
    STATE(9233), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412387] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11844), 1,
      sym__optional_semi,
    STATE(9234), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412428] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11846), 1,
      sym__optional_semi,
    STATE(9235), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412469] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11848), 1,
      anon_sym_EQ_GT,
    STATE(9236), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412510] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11850), 1,
      sym__optional_semi,
    STATE(9237), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412551] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11852), 1,
      anon_sym_EQ_GT,
    STATE(9238), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412592] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11854), 1,
      anon_sym_RPAREN,
    STATE(9239), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412633] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11856), 1,
      aux_sym_preproc_if_token3,
    STATE(9240), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412674] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11858), 1,
      aux_sym_preproc_if_token3,
    STATE(9241), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412715] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11860), 1,
      anon_sym_EQ_GT,
    STATE(9242), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412756] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11862), 1,
      anon_sym_RPAREN,
    STATE(9243), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412797] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11864), 1,
      anon_sym_SEMI,
    STATE(9244), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412838] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11866), 1,
      anon_sym_EQ_GT,
    STATE(9245), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412879] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11868), 1,
      anon_sym_STAR,
    STATE(9246), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412920] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11870), 1,
      anon_sym_EQ,
    STATE(9247), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [412961] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11184), 1,
      anon_sym_RBRACE,
    STATE(9248), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413002] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11872), 1,
      anon_sym_SEMI,
    STATE(9249), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413043] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11874), 1,
      anon_sym_EQ_GT,
    STATE(9250), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413084] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11876), 1,
      sym__optional_semi,
    STATE(9251), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413125] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11878), 1,
      sym__optional_semi,
    STATE(9252), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413166] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11880), 1,
      sym__optional_semi,
    STATE(9253), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413207] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11882), 1,
      sym__optional_semi,
    STATE(9254), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413248] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11884), 1,
      anon_sym_EQ_GT,
    STATE(9255), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413289] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11886), 1,
      sym__optional_semi,
    STATE(9256), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413330] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11888), 1,
      anon_sym_EQ_GT,
    STATE(9257), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413371] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11890), 1,
      sym__optional_semi,
    STATE(9258), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413412] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11892), 1,
      sym__optional_semi,
    STATE(9259), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413453] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11894), 1,
      sym__optional_semi,
    STATE(9260), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413494] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11896), 1,
      sym__optional_semi,
    STATE(9261), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413535] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11898), 1,
      sym__optional_semi,
    STATE(9262), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413576] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11900), 1,
      anon_sym_EQ_GT,
    STATE(9263), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413617] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11902), 1,
      sym_interpolation_close_brace,
    STATE(9264), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413658] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11904), 1,
      anon_sym_SEMI,
    STATE(9265), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413699] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11906), 1,
      anon_sym_EQ_GT,
    STATE(9266), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413740] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11908), 1,
      anon_sym_EQ_GT,
    STATE(9267), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413781] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11910), 1,
      sym__optional_semi,
    STATE(9268), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413822] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11912), 1,
      sym__optional_semi,
    STATE(9269), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413863] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11914), 1,
      sym__optional_semi,
    STATE(9270), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413904] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11916), 1,
      sym__optional_semi,
    STATE(9271), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413945] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11918), 1,
      anon_sym_GT,
    STATE(9272), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [413986] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11920), 1,
      anon_sym_SEMI,
    STATE(9273), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414027] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11922), 1,
      sym__optional_semi,
    STATE(9274), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414068] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11924), 1,
      sym__optional_semi,
    STATE(9275), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414109] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11926), 1,
      sym__optional_semi,
    STATE(9276), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414150] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11928), 1,
      sym__optional_semi,
    STATE(9277), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414191] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11930), 1,
      anon_sym_SEMI,
    STATE(9278), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414232] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11932), 1,
      sym__optional_semi,
    STATE(9279), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414273] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11934), 1,
      anon_sym_EQ_GT,
    STATE(9280), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414314] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11936), 1,
      sym__optional_semi,
    STATE(9281), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414355] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11938), 1,
      sym__optional_semi,
    STATE(9282), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414396] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11940), 1,
      sym__optional_semi,
    STATE(9283), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414437] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11942), 1,
      sym__optional_semi,
    STATE(9284), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414478] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11944), 1,
      anon_sym_EQ_GT,
    STATE(9285), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414519] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11946), 1,
      sym__optional_semi,
    STATE(9286), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414560] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11948), 1,
      sym__optional_semi,
    STATE(9287), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414601] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11950), 1,
      sym__optional_semi,
    STATE(9288), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414642] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11952), 1,
      sym__optional_semi,
    STATE(9289), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414683] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11954), 1,
      sym__optional_semi,
    STATE(9290), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414724] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11956), 1,
      sym__optional_semi,
    STATE(9291), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414765] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11958), 1,
      sym__optional_semi,
    STATE(9292), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414806] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11960), 1,
      anon_sym_EQ_GT,
    STATE(9293), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414847] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11962), 1,
      sym__optional_semi,
    STATE(9294), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414888] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11964), 1,
      sym__optional_semi,
    STATE(9295), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414929] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11966), 1,
      sym__optional_semi,
    STATE(9296), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [414970] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11968), 1,
      sym__optional_semi,
    STATE(9297), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415011] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11970), 1,
      sym__optional_semi,
    STATE(9298), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415052] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11972), 1,
      sym__optional_semi,
    STATE(9299), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415093] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11974), 1,
      sym__optional_semi,
    STATE(9300), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415134] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11976), 1,
      anon_sym_EQ_GT,
    STATE(9301), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415175] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11978), 1,
      sym__optional_semi,
    STATE(9302), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415216] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11980), 1,
      sym__optional_semi,
    STATE(9303), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415257] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11982), 1,
      anon_sym_EQ_GT,
    STATE(9304), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415298] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11984), 1,
      anon_sym_EQ_GT,
    STATE(9305), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415339] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym_EQ_GT,
    STATE(9306), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415380] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11988), 1,
      sym__optional_semi,
    STATE(9307), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415421] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11990), 1,
      anon_sym_RBRACE,
    STATE(9308), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415462] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11992), 1,
      sym__optional_semi,
    STATE(9309), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415503] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11994), 1,
      anon_sym_EQ_GT,
    STATE(9310), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415544] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11996), 1,
      sym__optional_semi,
    STATE(9311), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415585] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11998), 1,
      sym__optional_semi,
    STATE(9312), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415626] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12000), 1,
      anon_sym_EQ_GT,
    STATE(9313), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415667] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12002), 1,
      anon_sym_EQ_GT,
    STATE(9314), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415708] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12004), 1,
      anon_sym_EQ_GT,
    STATE(9315), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415749] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12006), 1,
      sym__optional_semi,
    STATE(9316), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415790] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12008), 1,
      sym__optional_semi,
    STATE(9317), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415831] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12010), 1,
      sym__optional_semi,
    STATE(9318), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415872] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12012), 1,
      sym__optional_semi,
    STATE(9319), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415913] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12014), 1,
      sym__optional_semi,
    STATE(9320), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415954] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12016), 1,
      sym__optional_semi,
    STATE(9321), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [415995] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12018), 1,
      anon_sym_EQ_GT,
    STATE(9322), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416036] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12020), 1,
      anon_sym_SEMI,
    STATE(9323), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416077] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12022), 1,
      anon_sym_EQ_GT,
    STATE(9324), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416118] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12024), 1,
      sym__optional_semi,
    STATE(9325), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416159] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12026), 1,
      sym__optional_semi,
    STATE(9326), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416200] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12028), 1,
      sym__optional_semi,
    STATE(9327), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416241] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12030), 1,
      sym__optional_semi,
    STATE(9328), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416282] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12032), 1,
      sym__optional_semi,
    STATE(9329), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416323] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12034), 1,
      anon_sym_SEMI,
    STATE(9330), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416364] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_EQ_GT,
    STATE(9331), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416405] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12038), 1,
      anon_sym_EQ_GT,
    STATE(9332), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416446] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12040), 1,
      anon_sym_EQ_GT,
    STATE(9333), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416487] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12042), 1,
      sym__optional_semi,
    STATE(9334), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416528] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12044), 1,
      sym__optional_semi,
    STATE(9335), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416569] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12046), 1,
      sym__optional_semi,
    STATE(9336), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416610] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12048), 1,
      sym__optional_semi,
    STATE(9337), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416651] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12050), 1,
      sym__optional_semi,
    STATE(9338), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416692] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12052), 1,
      anon_sym_RPAREN,
    STATE(9339), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416733] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12054), 1,
      sym__optional_semi,
    STATE(9340), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416774] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12056), 1,
      sym__optional_semi,
    STATE(9341), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416815] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12058), 1,
      anon_sym_RPAREN,
    STATE(9342), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416856] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12060), 1,
      anon_sym_EQ_GT,
    STATE(9343), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416897] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12062), 1,
      anon_sym_GT,
    STATE(9344), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416938] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12064), 1,
      anon_sym_EQ_GT,
    STATE(9345), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [416979] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12066), 1,
      aux_sym_preproc_if_token3,
    STATE(9346), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417020] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12068), 1,
      anon_sym_in,
    STATE(9347), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417061] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12070), 1,
      sym__optional_semi,
    STATE(9348), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417102] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12072), 1,
      anon_sym_COMMA,
    STATE(9349), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417143] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12074), 1,
      sym__optional_semi,
    STATE(9350), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417184] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12076), 1,
      sym__optional_semi,
    STATE(9351), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417225] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12078), 1,
      sym__optional_semi,
    STATE(9352), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417266] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12080), 1,
      sym__optional_semi,
    STATE(9353), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417307] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12082), 1,
      sym__optional_semi,
    STATE(9354), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417348] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12084), 1,
      sym__optional_semi,
    STATE(9355), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417389] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12086), 1,
      sym__optional_semi,
    STATE(9356), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417430] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12088), 1,
      sym__optional_semi,
    STATE(9357), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417471] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12090), 1,
      anon_sym_RPAREN,
    STATE(9358), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417512] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12092), 1,
      sym__optional_semi,
    STATE(9359), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417553] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12094), 1,
      sym__optional_semi,
    STATE(9360), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417594] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12096), 1,
      sym__optional_semi,
    STATE(9361), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417635] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12098), 1,
      anon_sym_EQ_GT,
    STATE(9362), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417676] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12100), 1,
      anon_sym_EQ_GT,
    STATE(9363), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417717] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12102), 1,
      anon_sym_EQ_GT,
    STATE(9364), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417758] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12104), 1,
      sym__optional_semi,
    STATE(9365), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417799] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12106), 1,
      sym__optional_semi,
    STATE(9366), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417840] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12108), 1,
      anon_sym_EQ_GT,
    STATE(9367), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417881] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12110), 1,
      anon_sym_EQ_GT,
    STATE(9368), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417922] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12112), 1,
      anon_sym_EQ_GT,
    STATE(9369), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [417963] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12114), 1,
      anon_sym_EQ_GT,
    STATE(9370), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418004] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12116), 1,
      anon_sym_EQ_GT,
    STATE(9371), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418045] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12118), 1,
      anon_sym_EQ_GT,
    STATE(9372), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418086] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12120), 1,
      anon_sym_SEMI,
    STATE(9373), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418127] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12122), 1,
      anon_sym_EQ,
    STATE(9374), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418168] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12124), 1,
      anon_sym_in,
    STATE(9375), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418209] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12126), 1,
      sym__optional_semi,
    STATE(9376), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418250] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12128), 1,
      anon_sym_EQ_GT,
    STATE(9377), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418291] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8169), 1,
      anon_sym_SEMI,
    STATE(9378), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418332] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12130), 1,
      aux_sym_preproc_if_token3,
    STATE(9379), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418373] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12132), 1,
      anon_sym_EQ_GT,
    STATE(9380), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418414] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12134), 1,
      anon_sym_EQ_GT,
    STATE(9381), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418455] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12136), 1,
      anon_sym_LPAREN,
    STATE(9382), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418496] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12138), 1,
      aux_sym_preproc_if_token3,
    STATE(9383), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418537] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12140), 1,
      aux_sym_preproc_if_token3,
    STATE(9384), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418578] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12142), 1,
      anon_sym_RPAREN,
    STATE(9385), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418619] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12144), 1,
      anon_sym_EQ_GT,
    STATE(9386), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418660] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12146), 1,
      anon_sym_EQ_GT,
    STATE(9387), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418701] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12148), 1,
      anon_sym_GT,
    STATE(9388), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418742] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12150), 1,
      anon_sym_EQ_GT,
    STATE(9389), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418783] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11014), 1,
      anon_sym_RBRACE,
    STATE(9390), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418824] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12152), 1,
      anon_sym_EQ_GT,
    STATE(9391), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418865] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12154), 1,
      sym_interpolation_start_quote,
    STATE(9392), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418906] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym_EQ_GT,
    STATE(9393), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418947] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12158), 1,
      anon_sym_EQ_GT,
    STATE(9394), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [418988] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12160), 1,
      anon_sym_EQ_GT,
    STATE(9395), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419029] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12162), 1,
      sym__optional_semi,
    STATE(9396), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419070] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12164), 1,
      anon_sym_EQ_GT,
    STATE(9397), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419111] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12166), 1,
      anon_sym_EQ_GT,
    STATE(9398), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419152] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12168), 1,
      aux_sym_preproc_if_token3,
    STATE(9399), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419193] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12170), 1,
      anon_sym_RBRACE,
    STATE(9400), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419234] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12172), 1,
      sym__optional_semi,
    STATE(9401), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419275] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12174), 1,
      anon_sym_RPAREN,
    STATE(9402), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419316] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12176), 1,
      anon_sym_EQ_GT,
    STATE(9403), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419357] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12178), 1,
      anon_sym_EQ_GT,
    STATE(9404), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419398] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12180), 1,
      anon_sym_EQ_GT,
    STATE(9405), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419439] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12182), 1,
      anon_sym_EQ_GT,
    STATE(9406), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419480] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12184), 1,
      sym__optional_semi,
    STATE(9407), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419521] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10925), 1,
      anon_sym_RBRACE,
    STATE(9408), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419562] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12186), 1,
      sym__optional_semi,
    STATE(9409), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419603] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12188), 1,
      anon_sym_EQ_GT,
    STATE(9410), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419644] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12190), 1,
      anon_sym_EQ_GT,
    STATE(9411), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419685] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_EQ_GT,
    STATE(9412), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419726] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12194), 1,
      anon_sym_SEMI,
    STATE(9413), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419767] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_LT,
    STATE(9414), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419808] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12198), 1,
      aux_sym_preproc_if_token3,
    STATE(9415), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419849] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12200), 1,
      aux_sym_preproc_if_token3,
    STATE(9416), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419890] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12202), 1,
      sym__optional_semi,
    STATE(9417), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419931] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12204), 1,
      anon_sym_EQ_GT,
    STATE(9418), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [419972] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12206), 1,
      anon_sym_EQ_GT,
    STATE(9419), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420013] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12208), 1,
      anon_sym_SEMI,
    STATE(9420), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420054] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8762), 1,
      anon_sym_RPAREN,
    STATE(9421), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420095] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12210), 1,
      anon_sym_LT,
    STATE(9422), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420136] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12212), 1,
      anon_sym_EQ_GT,
    STATE(9423), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420177] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12214), 1,
      anon_sym_EQ_GT,
    STATE(9424), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420218] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11314), 1,
      anon_sym_LT,
    STATE(9425), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420259] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12216), 1,
      sym__optional_semi,
    STATE(9426), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420300] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12218), 1,
      anon_sym_EQ_GT,
    STATE(9427), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420341] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12220), 1,
      sym__optional_semi,
    STATE(9428), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420382] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12222), 1,
      anon_sym_EQ_GT,
    STATE(9429), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420423] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12224), 1,
      anon_sym_EQ_GT,
    STATE(9430), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420464] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12226), 1,
      anon_sym_LBRACE,
    STATE(9431), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420505] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12228), 1,
      anon_sym_GT,
    STATE(9432), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420546] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12230), 1,
      anon_sym_LBRACE,
    STATE(9433), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420587] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12232), 1,
      sym__optional_semi,
    STATE(9434), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420628] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12234), 1,
      anon_sym_EQ_GT,
    STATE(9435), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420669] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12236), 1,
      anon_sym_EQ_GT,
    STATE(9436), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420710] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12238), 1,
      aux_sym_preproc_if_token3,
    STATE(9437), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420751] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12240), 1,
      anon_sym_EQ_GT,
    STATE(9438), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420792] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12242), 1,
      sym__optional_semi,
    STATE(9439), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420833] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12244), 1,
      anon_sym_EQ_GT,
    STATE(9440), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420874] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12246), 1,
      sym__optional_semi,
    STATE(9441), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420915] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12248), 1,
      anon_sym_RBRACK,
    STATE(9442), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420956] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12250), 1,
      sym__optional_semi,
    STATE(9443), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [420997] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12252), 1,
      anon_sym_EQ_GT,
    STATE(9444), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421038] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12254), 1,
      anon_sym_EQ_GT,
    STATE(9445), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421079] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12256), 1,
      anon_sym_EQ_GT,
    STATE(9446), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421120] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12258), 1,
      sym__optional_semi,
    STATE(9447), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421161] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12260), 1,
      anon_sym_EQ_GT,
    STATE(9448), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421202] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12262), 1,
      anon_sym_EQ_GT,
    STATE(9449), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421243] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12264), 1,
      anon_sym_RPAREN,
    STATE(9450), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421284] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12266), 1,
      anon_sym_EQ_GT,
    STATE(9451), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421325] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12268), 1,
      anon_sym_LPAREN,
    STATE(9452), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421366] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12270), 1,
      anon_sym_EQ_GT,
    STATE(9453), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421407] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12272), 1,
      anon_sym_EQ_GT,
    STATE(9454), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421448] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12274), 1,
      anon_sym_LPAREN,
    STATE(9455), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421489] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12276), 1,
      anon_sym_LPAREN,
    STATE(9456), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421530] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12278), 1,
      anon_sym_LPAREN,
    STATE(9457), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421571] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12280), 1,
      anon_sym_EQ_GT,
    STATE(9458), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421612] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12282), 1,
      anon_sym_LPAREN,
    STATE(9459), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421653] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12284), 1,
      anon_sym_LPAREN,
    STATE(9460), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421694] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12286), 1,
      anon_sym_LPAREN,
    STATE(9461), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421735] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12288), 1,
      anon_sym_LPAREN,
    STATE(9462), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421776] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12290), 1,
      anon_sym_EQ_GT,
    STATE(9463), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421817] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12292), 1,
      anon_sym_SEMI,
    STATE(9464), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421858] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12294), 1,
      anon_sym_EQ_GT,
    STATE(9465), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421899] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12296), 1,
      anon_sym_EQ_GT,
    STATE(9466), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421940] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12298), 1,
      anon_sym_RPAREN,
    STATE(9467), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [421981] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12300), 1,
      anon_sym_RPAREN,
    STATE(9468), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422022] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12302), 1,
      anon_sym_COLON,
    STATE(9469), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422063] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12304), 1,
      sym__optional_semi,
    STATE(9470), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422104] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12306), 1,
      anon_sym_LPAREN,
    STATE(9471), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422145] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12308), 1,
      anon_sym_RPAREN,
    STATE(9472), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422186] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10798), 1,
      aux_sym_preproc_if_token2,
    STATE(9473), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422227] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12310), 1,
      anon_sym_EQ_GT,
    STATE(9474), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422268] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(12312), 1,
      aux_sym_interpolation_format_clause_token1,
    STATE(9475), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422309] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10773), 1,
      sym_interpolation_close_brace,
    STATE(9476), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422350] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12314), 1,
      anon_sym_RPAREN,
    STATE(9477), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422391] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12316), 1,
      anon_sym_EQ_GT,
    STATE(9478), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422432] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12318), 1,
      anon_sym_EQ_GT,
    STATE(9479), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422473] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12320), 1,
      anon_sym_GT,
    STATE(9480), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422514] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12322), 1,
      anon_sym_SEMI,
    STATE(9481), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422555] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10741), 1,
      anon_sym_RBRACE,
    STATE(9482), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422596] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12324), 1,
      anon_sym_EQ_GT,
    STATE(9483), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422637] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12326), 1,
      sym_raw_string_content,
    STATE(9484), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422678] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12328), 1,
      anon_sym_SEMI,
    STATE(9485), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422719] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12330), 1,
      anon_sym_EQ_GT,
    STATE(9486), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422760] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12332), 1,
      anon_sym_DQUOTE,
    STATE(9487), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422801] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(4149), 1,
      anon_sym_EQ_GT,
    STATE(9488), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422842] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_DQUOTE,
    STATE(9489), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422883] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12336), 1,
      anon_sym_EQ_GT,
    STATE(9490), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422924] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12338), 1,
      anon_sym_EQ_GT,
    STATE(9491), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [422965] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_EQ_GT,
    STATE(9492), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423006] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12342), 1,
      anon_sym_EQ_GT,
    STATE(9493), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423047] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12344), 1,
      sym__optional_semi,
    STATE(9494), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423088] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12346), 1,
      sym__optional_semi,
    STATE(9495), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423129] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12348), 1,
      anon_sym_EQ_GT,
    STATE(9496), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423170] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12350), 1,
      anon_sym_EQ_GT,
    STATE(9497), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423211] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12352), 1,
      anon_sym_EQ_GT,
    STATE(9498), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423252] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_EQ_GT,
    STATE(9499), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423293] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12356), 1,
      anon_sym_EQ_GT,
    STATE(9500), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423334] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12358), 1,
      anon_sym_EQ_GT,
    STATE(9501), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423375] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12360), 1,
      anon_sym_EQ_GT,
    STATE(9502), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423416] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym_SEMI,
    STATE(9503), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423457] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12364), 1,
      anon_sym_EQ_GT,
    STATE(9504), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423498] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12366), 1,
      anon_sym_EQ_GT,
    STATE(9505), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423539] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12368), 1,
      anon_sym_GT,
    STATE(9506), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423580] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12370), 1,
      anon_sym_SEMI,
    STATE(9507), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423621] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(9085), 1,
      anon_sym_RPAREN,
    STATE(9508), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423662] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12372), 1,
      anon_sym_EQ_GT,
    STATE(9509), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423703] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12374), 1,
      anon_sym_EQ_GT,
    STATE(9510), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423744] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12376), 1,
      sym__optional_semi,
    STATE(9511), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423785] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12378), 1,
      sym__optional_semi,
    STATE(9512), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423826] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12380), 1,
      anon_sym_EQ_GT,
    STATE(9513), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423867] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12382), 1,
      anon_sym_EQ_GT,
    STATE(9514), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423908] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12384), 1,
      anon_sym_EQ_GT,
    STATE(9515), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423949] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_EQ_GT,
    STATE(9516), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [423990] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12388), 1,
      anon_sym_LT,
    STATE(9517), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424031] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8163), 1,
      anon_sym_SEMI,
    STATE(9518), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424072] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12390), 1,
      aux_sym_preproc_if_token3,
    STATE(9519), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424113] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12392), 1,
      anon_sym_EQ_GT,
    STATE(9520), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424154] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12394), 1,
      anon_sym_SEMI,
    STATE(9521), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424195] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12396), 1,
      anon_sym_EQ_GT,
    STATE(9522), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424236] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12398), 1,
      anon_sym_EQ_GT,
    STATE(9523), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424277] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12400), 1,
      anon_sym_STAR,
    STATE(9524), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424318] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12402), 1,
      anon_sym_EQ_GT,
    STATE(9525), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424359] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12404), 1,
      anon_sym_EQ_GT,
    STATE(9526), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424400] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12406), 1,
      aux_sym_preproc_if_token3,
    STATE(9527), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424441] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12408), 1,
      anon_sym_EQ_GT,
    STATE(9528), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424482] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12410), 1,
      anon_sym_EQ_GT,
    STATE(9529), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424523] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12412), 1,
      sym_raw_string_end,
    STATE(9530), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424564] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12414), 1,
      anon_sym_SEMI,
    STATE(9531), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424605] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12416), 1,
      anon_sym_EQ_GT,
    STATE(9532), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424646] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12418), 1,
      anon_sym_EQ_GT,
    STATE(9533), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424687] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12420), 1,
      anon_sym_EQ_GT,
    STATE(9534), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424728] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7937), 1,
      anon_sym_RBRACE,
    STATE(9535), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424769] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12422), 1,
      anon_sym_GT,
    STATE(9536), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424810] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12424), 1,
      anon_sym_EQ_GT,
    STATE(9537), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424851] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12426), 1,
      sym__optional_semi,
    STATE(9538), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424892] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12428), 1,
      anon_sym_SQUOTE,
    STATE(9539), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424933] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12430), 1,
      anon_sym_EQ_GT,
    STATE(9540), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [424974] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12432), 1,
      anon_sym_EQ_GT,
    STATE(9541), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425015] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12434), 1,
      anon_sym_SEMI,
    STATE(9542), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425056] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11356), 1,
      anon_sym_in,
    STATE(9543), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425097] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12436), 1,
      anon_sym_EQ_GT,
    STATE(9544), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425138] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12438), 1,
      anon_sym_EQ_GT,
    STATE(9545), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425179] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12440), 1,
      sym__optional_semi,
    STATE(9546), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425220] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12442), 1,
      anon_sym_EQ_GT,
    STATE(9547), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425261] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12444), 1,
      anon_sym_SEMI,
    STATE(9548), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425302] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12446), 1,
      anon_sym_EQ_GT,
    STATE(9549), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425343] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12448), 1,
      anon_sym_EQ_GT,
    STATE(9550), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425384] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7973), 1,
      anon_sym_RBRACE,
    STATE(9551), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425425] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12450), 1,
      anon_sym_EQ_GT,
    STATE(9552), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425466] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11366), 1,
      anon_sym_in,
    STATE(9553), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425507] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12452), 1,
      anon_sym_operator,
    STATE(9554), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425548] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12454), 1,
      anon_sym_SQUOTE,
    STATE(9555), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425589] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12456), 1,
      anon_sym_DOT,
    STATE(9556), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425630] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12458), 1,
      sym__optional_semi,
    STATE(9557), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425671] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12460), 1,
      anon_sym_SEMI,
    STATE(9558), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425712] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12462), 1,
      sym__optional_semi,
    STATE(9559), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425753] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12464), 1,
      anon_sym_EQ_GT,
    STATE(9560), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425794] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12466), 1,
      sym__optional_semi,
    STATE(9561), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425835] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12468), 1,
      anon_sym_EQ_GT,
    STATE(9562), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425876] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12470), 1,
      anon_sym_EQ_GT,
    STATE(9563), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425917] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12472), 1,
      anon_sym_SEMI,
    STATE(9564), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425958] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12474), 1,
      anon_sym_LBRACE,
    STATE(9565), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [425999] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12476), 1,
      anon_sym_EQ_GT,
    STATE(9566), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426040] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8750), 1,
      anon_sym_RPAREN,
    STATE(9567), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426081] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12478), 1,
      sym_raw_string_end,
    STATE(9568), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426122] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12480), 1,
      anon_sym_EQ_GT,
    STATE(9569), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426163] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12482), 1,
      anon_sym_EQ_GT,
    STATE(9570), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426204] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12484), 1,
      anon_sym_STAR,
    STATE(9571), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426245] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12486), 1,
      anon_sym_EQ_GT,
    STATE(9572), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426286] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12488), 1,
      aux_sym_preproc_if_token3,
    STATE(9573), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426327] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12490), 1,
      sym__optional_semi,
    STATE(9574), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426368] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12492), 1,
      anon_sym_EQ_GT,
    STATE(9575), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426409] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12494), 1,
      anon_sym_SEMI,
    STATE(9576), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426450] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12496), 1,
      anon_sym_EQ_GT,
    STATE(9577), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426491] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12498), 1,
      anon_sym_EQ_GT,
    STATE(9578), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426532] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12500), 1,
      anon_sym_EQ_GT,
    STATE(9579), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426573] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12502), 1,
      anon_sym_EQ_GT,
    STATE(9580), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426614] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12504), 1,
      anon_sym_STAR,
    STATE(9581), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426655] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12506), 1,
      sym__optional_semi,
    STATE(9582), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426696] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12508), 1,
      anon_sym_SEMI,
    STATE(9583), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426737] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12510), 1,
      anon_sym_EQ_GT,
    STATE(9584), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426778] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12512), 1,
      anon_sym_LPAREN,
    STATE(9585), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426819] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12514), 1,
      aux_sym_preproc_if_token3,
    STATE(9586), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426860] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12516), 1,
      sym__optional_semi,
    STATE(9587), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426901] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12518), 1,
      sym__optional_semi,
    STATE(9588), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426942] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12520), 1,
      sym__optional_semi,
    STATE(9589), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [426983] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12522), 1,
      anon_sym_EQ_GT,
    STATE(9590), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427024] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12524), 1,
      sym__optional_semi,
    STATE(9591), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427065] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12526), 1,
      sym__optional_semi,
    STATE(9592), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427106] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12528), 1,
      anon_sym_COMMA,
    STATE(9593), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427147] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10006), 1,
      anon_sym_COMMA,
    STATE(9594), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427188] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12530), 1,
      anon_sym_LPAREN,
    STATE(9595), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427229] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_LPAREN,
    STATE(9596), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427270] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12534), 1,
      anon_sym_while,
    STATE(9597), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427311] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12536), 1,
      anon_sym_GT,
    STATE(9598), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427352] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(12538), 1,
      aux_sym_preproc_if_token2,
    STATE(9599), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427393] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_SEMI,
    STATE(9600), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427434] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12542), 1,
      sym__optional_semi,
    STATE(9601), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427475] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12544), 1,
      anon_sym_LPAREN,
    STATE(9602), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427516] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12546), 1,
      sym__optional_semi,
    STATE(9603), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427557] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12548), 1,
      anon_sym_DQUOTE,
    STATE(9604), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427598] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(12550), 1,
      aux_sym_preproc_if_token2,
    STATE(9605), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427639] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12552), 1,
      anon_sym_LPAREN,
    STATE(9606), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427680] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12554), 1,
      anon_sym_COMMA,
    STATE(9607), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427721] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12556), 1,
      anon_sym_LPAREN,
    STATE(9608), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427762] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12558), 1,
      anon_sym_while,
    STATE(9609), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427803] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    STATE(9610), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427844] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12560), 1,
      anon_sym_SEMI,
    STATE(9611), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427885] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12562), 1,
      anon_sym_DQUOTE,
    STATE(9612), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427926] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12564), 1,
      sym__optional_semi,
    STATE(9613), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [427967] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12566), 1,
      anon_sym_EQ_GT,
    STATE(9614), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428008] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12568), 1,
      anon_sym_SEMI,
    STATE(9615), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428049] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12570), 1,
      sym__optional_semi,
    STATE(9616), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428090] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12572), 1,
      anon_sym_SEMI,
    STATE(9617), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428131] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12574), 1,
      sym__optional_semi,
    STATE(9618), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428172] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12576), 1,
      sym_interpolation_start_quote,
    STATE(9619), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428213] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12578), 1,
      sym_raw_string_content,
    STATE(9620), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428254] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12580), 1,
      anon_sym_EQ_GT,
    STATE(9621), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428295] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12582), 1,
      sym__optional_semi,
    STATE(9622), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428336] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12584), 1,
      anon_sym_EQ_GT,
    STATE(9623), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428377] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12586), 1,
      anon_sym_EQ_GT,
    STATE(9624), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428418] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11310), 1,
      anon_sym_in,
    STATE(9625), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428459] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12588), 1,
      anon_sym_LBRACE,
    STATE(9626), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428500] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12590), 1,
      anon_sym_LBRACE,
    STATE(9627), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428541] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12592), 1,
      sym__optional_semi,
    STATE(9628), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428582] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12594), 1,
      anon_sym_EQ_GT,
    STATE(9629), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428623] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12596), 1,
      anon_sym_RPAREN,
    STATE(9630), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428664] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12598), 1,
      sym__optional_semi,
    STATE(9631), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428705] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12600), 1,
      aux_sym_preproc_if_token3,
    STATE(9632), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428746] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12602), 1,
      sym__optional_semi,
    STATE(9633), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428787] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12604), 1,
      anon_sym_EQ_GT,
    STATE(9634), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428828] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12606), 1,
      sym__optional_semi,
    STATE(9635), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428869] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12608), 1,
      anon_sym_EQ_GT,
    STATE(9636), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428910] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12610), 1,
      anon_sym_EQ_GT,
    STATE(9637), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428951] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12612), 1,
      sym__optional_semi,
    STATE(9638), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [428992] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12614), 1,
      anon_sym_EQ_GT,
    STATE(9639), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429033] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12616), 1,
      anon_sym_EQ_GT,
    STATE(9640), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429074] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12618), 1,
      anon_sym_EQ_GT,
    STATE(9641), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429115] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12620), 1,
      sym__optional_semi,
    STATE(9642), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429156] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12622), 1,
      aux_sym_preproc_if_token3,
    STATE(9643), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429197] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12624), 1,
      sym__optional_semi,
    STATE(9644), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429238] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12626), 1,
      sym__optional_semi,
    STATE(9645), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429279] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12628), 1,
      sym__optional_semi,
    STATE(9646), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429320] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12630), 1,
      sym__optional_semi,
    STATE(9647), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429361] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12632), 1,
      anon_sym_RPAREN,
    STATE(9648), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429402] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12634), 1,
      anon_sym_EQ_GT,
    STATE(9649), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429443] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12636), 1,
      anon_sym_SQUOTE,
    STATE(9650), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429484] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12638), 1,
      anon_sym_EQ_GT,
    STATE(9651), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429525] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12640), 1,
      anon_sym_EQ_GT,
    STATE(9652), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429566] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12642), 1,
      anon_sym_EQ_GT,
    STATE(9653), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429607] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12644), 1,
      anon_sym_RBRACK,
    STATE(9654), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429648] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12646), 1,
      anon_sym_EQ_GT,
    STATE(9655), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429689] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12648), 1,
      anon_sym_EQ_GT,
    STATE(9656), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429730] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10761), 1,
      anon_sym_RBRACE,
    STATE(9657), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429771] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12650), 1,
      anon_sym_EQ_GT,
    STATE(9658), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429812] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12652), 1,
      anon_sym_EQ_GT,
    STATE(9659), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429853] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12654), 1,
      anon_sym_EQ_GT,
    STATE(9660), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429894] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12656), 1,
      anon_sym_EQ_GT,
    STATE(9661), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429935] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12658), 1,
      anon_sym_RPAREN,
    STATE(9662), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [429976] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12660), 1,
      anon_sym_EQ_GT,
    STATE(9663), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430017] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12662), 1,
      anon_sym_GT,
    STATE(9664), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430058] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12664), 1,
      anon_sym_EQ_GT,
    STATE(9665), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430099] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12666), 1,
      sym__optional_semi,
    STATE(9666), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430140] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12668), 1,
      anon_sym_RPAREN,
    STATE(9667), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430181] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12670), 1,
      anon_sym_RPAREN,
    STATE(9668), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430222] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12672), 1,
      sym__optional_semi,
    STATE(9669), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430263] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12674), 1,
      anon_sym_EQ_GT,
    STATE(9670), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430304] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12676), 1,
      anon_sym_GT,
    STATE(9671), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430345] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12678), 1,
      anon_sym_EQ_GT,
    STATE(9672), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430386] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12680), 1,
      anon_sym_GT,
    STATE(9673), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430427] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12682), 1,
      anon_sym_LPAREN,
    STATE(9674), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430468] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12684), 1,
      anon_sym_LPAREN,
    STATE(9675), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430509] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12686), 1,
      anon_sym_LPAREN,
    STATE(9676), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430550] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12688), 1,
      anon_sym_LPAREN,
    STATE(9677), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430591] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12690), 1,
      anon_sym_LPAREN,
    STATE(9678), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430632] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12692), 1,
      anon_sym_LPAREN,
    STATE(9679), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430673] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_LPAREN,
    STATE(9680), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430714] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12696), 1,
      anon_sym_EQ_GT,
    STATE(9681), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430755] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12698), 1,
      sym__optional_semi,
    STATE(9682), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430796] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11118), 1,
      anon_sym_RBRACE,
    STATE(9683), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430837] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_LPAREN,
    STATE(9684), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430878] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym__optional_semi,
    STATE(9685), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430919] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12704), 1,
      anon_sym_SEMI,
    STATE(9686), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [430960] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12706), 1,
      anon_sym_EQ_GT,
    STATE(9687), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431001] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12708), 1,
      sym__optional_semi,
    STATE(9688), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431042] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12710), 1,
      sym__optional_semi,
    STATE(9689), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431083] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12712), 1,
      sym__optional_semi,
    STATE(9690), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431124] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_LPAREN,
    STATE(9691), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431165] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12716), 1,
      sym__optional_semi,
    STATE(9692), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431206] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12718), 1,
      sym__optional_semi,
    STATE(9693), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431247] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12720), 1,
      sym__optional_semi,
    STATE(9694), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431288] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12722), 1,
      sym__optional_semi,
    STATE(9695), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431329] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12724), 1,
      sym__optional_semi,
    STATE(9696), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431370] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12726), 1,
      anon_sym_SEMI,
    STATE(9697), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431411] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12728), 1,
      anon_sym_while,
    STATE(9698), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431452] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12730), 1,
      anon_sym_GT,
    STATE(9699), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431493] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12732), 1,
      sym__optional_semi,
    STATE(9700), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431534] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12734), 1,
      sym__optional_semi,
    STATE(9701), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431575] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12736), 1,
      sym__optional_semi,
    STATE(9702), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431616] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12738), 1,
      sym__optional_semi,
    STATE(9703), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431657] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12740), 1,
      sym__optional_semi,
    STATE(9704), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431698] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12742), 1,
      sym__optional_semi,
    STATE(9705), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431739] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12744), 1,
      sym__optional_semi,
    STATE(9706), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431780] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12746), 1,
      sym__optional_semi,
    STATE(9707), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431821] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12748), 1,
      sym__optional_semi,
    STATE(9708), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431862] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12750), 1,
      anon_sym_LT,
    STATE(9709), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431903] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8177), 1,
      anon_sym_SEMI,
    STATE(9710), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431944] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12752), 1,
      sym__optional_semi,
    STATE(9711), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [431985] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12754), 1,
      sym__optional_semi,
    STATE(9712), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432026] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12756), 1,
      sym__optional_semi,
    STATE(9713), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432067] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12758), 1,
      sym__optional_semi,
    STATE(9714), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432108] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12760), 1,
      sym__optional_semi,
    STATE(9715), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432149] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12762), 1,
      sym__optional_semi,
    STATE(9716), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432190] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8740), 1,
      anon_sym_RPAREN,
    STATE(9717), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432231] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12764), 1,
      anon_sym_SEMI,
    STATE(9718), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432272] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12766), 1,
      aux_sym_preproc_if_token3,
    STATE(9719), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432313] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12768), 1,
      aux_sym_preproc_if_token3,
    STATE(9720), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432354] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12770), 1,
      sym__optional_semi,
    STATE(9721), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432395] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12772), 1,
      anon_sym_SEMI,
    STATE(9722), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432436] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12774), 1,
      anon_sym_EQ_GT,
    STATE(9723), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432477] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12776), 1,
      anon_sym_EQ_GT,
    STATE(9724), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432518] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12778), 1,
      sym__optional_semi,
    STATE(9725), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432559] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10984), 1,
      anon_sym_RBRACE,
    STATE(9726), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432600] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11264), 1,
      anon_sym_in,
    STATE(9727), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432641] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12780), 1,
      sym__optional_semi,
    STATE(9728), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432682] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12782), 1,
      sym__optional_semi,
    STATE(9729), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432723] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12784), 1,
      sym__optional_semi,
    STATE(9730), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432764] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11008), 1,
      anon_sym_RBRACE,
    STATE(9731), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432805] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11262), 1,
      anon_sym_in,
    STATE(9732), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432846] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12786), 1,
      sym_interpolation_close_brace,
    STATE(9733), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432887] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12788), 1,
      anon_sym_RBRACE,
    STATE(9734), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432928] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12790), 1,
      sym__optional_semi,
    STATE(9735), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [432969] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12792), 1,
      sym__optional_semi,
    STATE(9736), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433010] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12794), 1,
      anon_sym_DASH,
    STATE(9737), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433051] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12796), 1,
      anon_sym_LPAREN,
    STATE(9738), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433092] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(7858), 1,
      anon_sym_RBRACE,
    STATE(9739), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433133] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12798), 1,
      sym_interpolation_close_brace,
    STATE(9740), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433174] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12800), 1,
      anon_sym_EQ_GT,
    STATE(9741), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433215] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12802), 1,
      sym__optional_semi,
    STATE(9742), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433256] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12804), 1,
      anon_sym_SEMI,
    STATE(9743), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433297] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12806), 1,
      sym__optional_semi,
    STATE(9744), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433338] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(6052), 1,
      anon_sym_STAR,
    STATE(9745), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433379] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12808), 1,
      anon_sym_LPAREN,
    STATE(9746), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433420] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12810), 1,
      anon_sym_LPAREN,
    STATE(9747), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433461] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12812), 1,
      anon_sym_LPAREN,
    STATE(9748), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433502] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12814), 1,
      anon_sym_LPAREN,
    STATE(9749), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433543] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12816), 1,
      anon_sym_LPAREN,
    STATE(9750), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433584] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12818), 1,
      anon_sym_LPAREN,
    STATE(9751), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433625] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12820), 1,
      anon_sym_LPAREN,
    STATE(9752), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433666] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12822), 1,
      sym__optional_semi,
    STATE(9753), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433707] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12824), 1,
      sym__optional_semi,
    STATE(9754), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433748] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12826), 1,
      sym__optional_semi,
    STATE(9755), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433789] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12828), 1,
      anon_sym_LPAREN,
    STATE(9756), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433830] = 11,
    ACTIONS(5382), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    STATE(9757), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433871] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12830), 1,
      anon_sym_EQ_GT,
    STATE(9758), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433912] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12832), 1,
      sym__optional_semi,
    STATE(9759), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433953] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12834), 1,
      anon_sym_SEMI,
    STATE(9760), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [433994] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12836), 1,
      anon_sym_EQ_GT,
    STATE(9761), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434035] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12838), 1,
      anon_sym_SEMI,
    STATE(9762), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434076] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12840), 1,
      sym__optional_semi,
    STATE(9763), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434117] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12842), 1,
      sym__optional_semi,
    STATE(9764), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434158] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12844), 1,
      sym__optional_semi,
    STATE(9765), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434199] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12846), 1,
      sym__optional_semi,
    STATE(9766), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434240] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12848), 1,
      sym__optional_semi,
    STATE(9767), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434281] = 11,
    ACTIONS(5411), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    STATE(9768), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434322] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12850), 1,
      sym__optional_semi,
    STATE(9769), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434363] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12852), 1,
      anon_sym_GT,
    STATE(9770), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434404] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12854), 1,
      anon_sym_LT,
    STATE(9771), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434445] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(8243), 1,
      anon_sym_SEMI,
    STATE(9772), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434486] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12856), 1,
      anon_sym_SEMI,
    STATE(9773), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434527] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12858), 1,
      anon_sym_operator,
    STATE(9774), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434568] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12860), 1,
      anon_sym_RBRACK,
    STATE(9775), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434609] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12862), 1,
      anon_sym_SEMI,
    STATE(9776), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434650] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12864), 1,
      sym__optional_semi,
    STATE(9777), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434691] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12866), 1,
      sym__optional_semi,
    STATE(9778), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434732] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12868), 1,
      anon_sym_EQ_GT,
    STATE(9779), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434773] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12870), 1,
      sym__optional_semi,
    STATE(9780), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434814] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11252), 1,
      anon_sym_in,
    STATE(9781), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434855] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12872), 1,
      anon_sym_EQ_GT,
    STATE(9782), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434896] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(11254), 1,
      anon_sym_in,
    STATE(9783), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434937] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12874), 1,
      anon_sym_LPAREN,
    STATE(9784), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [434978] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12876), 1,
      sym__optional_semi,
    STATE(9785), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435019] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12878), 1,
      anon_sym_LBRACE,
    STATE(9786), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435060] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12880), 1,
      anon_sym_RPAREN,
    STATE(9787), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435101] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12882), 1,
      aux_sym_preproc_if_token3,
    STATE(9788), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435142] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12884), 1,
      aux_sym_preproc_if_token3,
    STATE(9789), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435183] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12886), 1,
      sym__optional_semi,
    STATE(9790), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435224] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12888), 1,
      anon_sym_LPAREN,
    STATE(9791), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435265] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12890), 1,
      sym__optional_semi,
    STATE(9792), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435306] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12892), 1,
      sym__optional_semi,
    STATE(9793), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435347] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(12894), 1,
      aux_sym_preproc_if_token2,
    STATE(9794), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435388] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12896), 1,
      anon_sym_LPAREN,
    STATE(9795), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435429] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12898), 1,
      anon_sym_LPAREN,
    STATE(9796), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435470] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12900), 1,
      anon_sym_LPAREN,
    STATE(9797), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435511] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12902), 1,
      anon_sym_LPAREN,
    STATE(9798), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435552] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12904), 1,
      anon_sym_EQ_GT,
    STATE(9799), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435593] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12906), 1,
      sym__optional_semi,
    STATE(9800), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435634] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12908), 1,
      anon_sym_LPAREN,
    STATE(9801), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435675] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12910), 1,
      sym__optional_semi,
    STATE(9802), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435716] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(12912), 1,
      aux_sym_preproc_if_token2,
    STATE(9803), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435757] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12914), 1,
      sym__optional_semi,
    STATE(9804), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435798] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12916), 1,
      sym__optional_semi,
    STATE(9805), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435839] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12918), 1,
      anon_sym_EQ_GT,
    STATE(9806), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435880] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12920), 1,
      aux_sym_preproc_if_token3,
    STATE(9807), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435921] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12922), 1,
      sym__optional_semi,
    STATE(9808), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [435962] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12924), 1,
      sym__optional_semi,
    STATE(9809), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436003] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12926), 1,
      sym__optional_semi,
    STATE(9810), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436044] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12928), 1,
      anon_sym_LBRACE,
    STATE(9811), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436085] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12930), 1,
      sym__optional_semi,
    STATE(9812), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436126] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12932), 1,
      anon_sym_LT,
    STATE(9813), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436167] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12934), 1,
      sym__optional_semi,
    STATE(9814), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436208] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12936), 1,
      sym__optional_semi,
    STATE(9815), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436249] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12938), 1,
      sym__optional_semi,
    STATE(9816), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436290] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12940), 1,
      sym__optional_semi,
    STATE(9817), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436331] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12942), 1,
      sym__optional_semi,
    STATE(9818), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436372] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12944), 1,
      sym__optional_semi,
    STATE(9819), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436413] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12946), 1,
      sym__optional_semi,
    STATE(9820), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436454] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12948), 1,
      sym__optional_semi,
    STATE(9821), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436495] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12950), 1,
      sym__optional_semi,
    STATE(9822), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436536] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12952), 1,
      anon_sym_LPAREN,
    STATE(9823), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436577] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12954), 1,
      anon_sym_LPAREN,
    STATE(9824), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436618] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12956), 1,
      sym__optional_semi,
    STATE(9825), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436659] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12958), 1,
      anon_sym_LPAREN,
    STATE(9826), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436700] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12960), 1,
      sym__optional_semi,
    STATE(9827), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436741] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12962), 1,
      aux_sym_preproc_if_token3,
    STATE(9828), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436782] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12964), 1,
      sym__optional_semi,
    STATE(9829), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436823] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12966), 1,
      sym__optional_semi,
    STATE(9830), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436864] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12968), 1,
      sym__optional_semi,
    STATE(9831), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436905] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10636), 1,
      anon_sym_LPAREN,
    STATE(9832), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436946] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12970), 1,
      anon_sym_RPAREN,
    STATE(9833), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [436987] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12972), 1,
      anon_sym_LT,
    STATE(9834), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437028] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COLON,
    STATE(9835), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437069] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12976), 1,
      sym__optional_semi,
    STATE(9836), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437110] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12978), 1,
      anon_sym_LT,
    STATE(9837), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437151] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12980), 1,
      sym__optional_semi,
    STATE(9838), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437192] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12982), 1,
      anon_sym_COLON,
    STATE(9839), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437233] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12984), 1,
      sym__optional_semi,
    STATE(9840), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437274] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12986), 1,
      sym__optional_semi,
    STATE(9841), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437315] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12988), 1,
      sym__optional_semi,
    STATE(9842), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437356] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12990), 1,
      sym__optional_semi,
    STATE(9843), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437397] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12992), 1,
      sym__optional_semi,
    STATE(9844), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437438] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12994), 1,
      anon_sym_GT,
    STATE(9845), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437479] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12996), 1,
      sym__optional_semi,
    STATE(9846), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437520] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(12998), 1,
      sym__optional_semi,
    STATE(9847), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437561] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13000), 1,
      sym__optional_semi,
    STATE(9848), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437602] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13002), 1,
      sym__optional_semi,
    STATE(9849), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437643] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13004), 1,
      sym__optional_semi,
    STATE(9850), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437684] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13006), 1,
      sym__optional_semi,
    STATE(9851), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437725] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13008), 1,
      sym__optional_semi,
    STATE(9852), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437766] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13010), 1,
      anon_sym_SEMI,
    STATE(9853), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437807] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13012), 1,
      sym__optional_semi,
    STATE(9854), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437848] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13014), 1,
      sym__optional_semi,
    STATE(9855), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437889] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13016), 1,
      sym__optional_semi,
    STATE(9856), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437930] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13018), 1,
      anon_sym_LT,
    STATE(9857), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [437971] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym__optional_semi,
    STATE(9858), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438012] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13022), 1,
      sym__optional_semi,
    STATE(9859), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438053] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13024), 1,
      sym__optional_semi,
    STATE(9860), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438094] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13026), 1,
      sym__optional_semi,
    STATE(9861), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438135] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13028), 1,
      sym__optional_semi,
    STATE(9862), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438176] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13030), 1,
      sym__optional_semi,
    STATE(9863), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438217] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13032), 1,
      sym__optional_semi,
    STATE(9864), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438258] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13034), 1,
      sym__optional_semi,
    STATE(9865), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438299] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13036), 1,
      sym_raw_string_end,
    STATE(9866), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438340] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13038), 1,
      anon_sym_EQ_GT,
    STATE(9867), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438381] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13040), 1,
      sym__optional_semi,
    STATE(9868), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438422] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13042), 1,
      sym__optional_semi,
    STATE(9869), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438463] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13044), 1,
      anon_sym_SEMI,
    STATE(9870), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438504] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13046), 1,
      sym__optional_semi,
    STATE(9871), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438545] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13048), 1,
      sym__optional_semi,
    STATE(9872), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438586] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13050), 1,
      aux_sym_preproc_if_token2,
    STATE(9873), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438627] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13052), 1,
      aux_sym_preproc_if_token2,
    STATE(9874), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438668] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13054), 1,
      sym__optional_semi,
    STATE(9875), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438709] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13056), 1,
      anon_sym_LT,
    STATE(9876), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438750] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13058), 1,
      aux_sym_preproc_if_token2,
    STATE(9877), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438791] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13060), 1,
      anon_sym_EQ_GT,
    STATE(9878), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438832] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13062), 1,
      sym__optional_semi,
    STATE(9879), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438873] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13064), 1,
      sym__optional_semi,
    STATE(9880), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438914] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13066), 1,
      sym__optional_semi,
    STATE(9881), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438955] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13068), 1,
      sym__optional_semi,
    STATE(9882), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [438996] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13070), 1,
      sym__optional_semi,
    STATE(9883), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439037] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13072), 1,
      aux_sym_preproc_if_token3,
    STATE(9884), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439078] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13074), 1,
      sym__optional_semi,
    STATE(9885), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439119] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_SEMI,
    STATE(9886), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439160] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13078), 1,
      sym__optional_semi,
    STATE(9887), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439201] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13080), 1,
      sym__optional_semi,
    STATE(9888), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439242] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13082), 1,
      anon_sym_SEMI,
    STATE(9889), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439283] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(10817), 1,
      aux_sym_preproc_if_token2,
    STATE(9890), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439324] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13084), 1,
      sym__optional_semi,
    STATE(9891), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439365] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13086), 1,
      sym__optional_semi,
    STATE(9892), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439406] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13088), 1,
      sym_integer_literal,
    STATE(9893), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439447] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13090), 1,
      aux_sym_preproc_if_token2,
    STATE(9894), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439488] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13092), 1,
      sym__optional_semi,
    STATE(9895), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439529] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13094), 1,
      anon_sym_SEMI,
    STATE(9896), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439570] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13096), 1,
      sym__optional_semi,
    STATE(9897), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439611] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13098), 1,
      aux_sym_preproc_if_token2,
    STATE(9898), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439652] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13100), 1,
      anon_sym_EQ_GT,
    STATE(9899), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439693] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13102), 1,
      sym__optional_semi,
    STATE(9900), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439734] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13104), 1,
      sym__optional_semi,
    STATE(9901), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439775] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13106), 1,
      anon_sym_EQ_GT,
    STATE(9902), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439816] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13108), 1,
      sym__optional_semi,
    STATE(9903), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439857] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13110), 1,
      sym__optional_semi,
    STATE(9904), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439898] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13112), 1,
      sym__optional_semi,
    STATE(9905), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439939] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13114), 1,
      anon_sym_STAR,
    STATE(9906), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [439980] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13116), 1,
      sym__optional_semi,
    STATE(9907), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440021] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13118), 1,
      sym__optional_semi,
    STATE(9908), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440062] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13120), 1,
      sym__optional_semi,
    STATE(9909), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440103] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13122), 1,
      anon_sym_EQ_GT,
    STATE(9910), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440144] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13124), 1,
      anon_sym_SEMI,
    STATE(9911), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440185] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13126), 1,
      anon_sym_EQ_GT,
    STATE(9912), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440226] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13128), 1,
      ts_builtin_sym_end,
    STATE(9913), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440267] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13130), 1,
      sym__optional_semi,
    STATE(9914), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440308] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13132), 1,
      sym__optional_semi,
    STATE(9915), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440349] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13134), 1,
      anon_sym_LPAREN,
    STATE(9916), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440390] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13136), 1,
      anon_sym_EQ_GT,
    STATE(9917), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440431] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13138), 1,
      anon_sym_STAR,
    STATE(9918), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440472] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13140), 1,
      anon_sym_EQ_GT,
    STATE(9919), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440513] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13142), 1,
      sym__optional_semi,
    STATE(9920), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440554] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13144), 1,
      anon_sym_LPAREN,
    STATE(9921), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440595] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13146), 1,
      sym__optional_semi,
    STATE(9922), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440636] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13148), 1,
      anon_sym_LPAREN,
    STATE(9923), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440677] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13150), 1,
      anon_sym_EQ_GT,
    STATE(9924), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440718] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13152), 1,
      anon_sym_LPAREN,
    STATE(9925), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440759] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13154), 1,
      anon_sym_LPAREN,
    STATE(9926), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440800] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13156), 1,
      anon_sym_EQ_GT,
    STATE(9927), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440841] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13158), 1,
      anon_sym_LPAREN,
    STATE(9928), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440882] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13160), 1,
      anon_sym_LPAREN,
    STATE(9929), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440923] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13162), 1,
      sym__optional_semi,
    STATE(9930), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [440964] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13164), 1,
      sym__optional_semi,
    STATE(9931), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441005] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13166), 1,
      anon_sym_EQ_GT,
    STATE(9932), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441046] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13168), 1,
      anon_sym_EQ_GT,
    STATE(9933), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441087] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13170), 1,
      anon_sym_LPAREN,
    STATE(9934), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441128] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13172), 1,
      anon_sym_LPAREN,
    STATE(9935), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441169] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13174), 1,
      anon_sym_EQ_GT,
    STATE(9936), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441210] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13176), 1,
      anon_sym_SEMI,
    STATE(9937), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441251] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13178), 1,
      anon_sym_EQ_GT,
    STATE(9938), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441292] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13180), 1,
      anon_sym_EQ_GT,
    STATE(9939), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441333] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13182), 1,
      anon_sym_COLON,
    STATE(9940), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441374] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13184), 1,
      anon_sym_LPAREN,
    STATE(9941), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441415] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13186), 1,
      anon_sym_LPAREN,
    STATE(9942), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441456] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13188), 1,
      anon_sym_LPAREN,
    STATE(9943), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441497] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_SEMI,
    STATE(9944), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441538] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13192), 1,
      anon_sym_SEMI,
    STATE(9945), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441579] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13194), 1,
      anon_sym_SEMI,
    STATE(9946), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441620] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13196), 1,
      anon_sym_LPAREN,
    STATE(9947), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441661] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13198), 1,
      anon_sym_STAR,
    STATE(9948), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441702] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym__optional_semi,
    STATE(9949), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441743] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13202), 1,
      anon_sym_RPAREN,
    STATE(9950), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441784] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13204), 1,
      sym__optional_semi,
    STATE(9951), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441825] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13206), 1,
      sym__optional_semi,
    STATE(9952), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441866] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13208), 1,
      anon_sym_LPAREN,
    STATE(9953), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441907] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13210), 1,
      sym__optional_semi,
    STATE(9954), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441948] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13212), 1,
      anon_sym_EQ_GT,
    STATE(9955), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [441989] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13214), 1,
      anon_sym_GT,
    STATE(9956), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442030] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13216), 1,
      sym__optional_semi,
    STATE(9957), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442071] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13218), 1,
      sym__optional_semi,
    STATE(9958), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442112] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13220), 1,
      anon_sym_LPAREN,
    STATE(9959), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442153] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13222), 1,
      anon_sym_STAR,
    STATE(9960), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442194] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13224), 1,
      sym__optional_semi,
    STATE(9961), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442235] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13226), 1,
      sym_raw_string_content,
    STATE(9962), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442276] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13228), 1,
      anon_sym_LPAREN,
    STATE(9963), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442317] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13230), 1,
      sym_interpolation_start_quote,
    STATE(9964), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442358] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13232), 1,
      sym__optional_semi,
    STATE(9965), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442399] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13234), 1,
      anon_sym_SEMI,
    STATE(9966), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442440] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_STAR,
    STATE(9967), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442481] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13238), 1,
      anon_sym_DQUOTE,
    STATE(9968), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442522] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13240), 1,
      anon_sym_STAR,
    STATE(9969), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442563] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13242), 1,
      anon_sym_DQUOTE,
    STATE(9970), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442604] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13244), 1,
      anon_sym_STAR,
    STATE(9971), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442645] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(10196), 1,
      anon_sym_STAR,
    STATE(9972), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442686] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13246), 1,
      sym_preproc_arg,
    STATE(9973), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442727] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13248), 1,
      anon_sym_LPAREN,
    STATE(9974), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442768] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13250), 1,
      anon_sym_LPAREN,
    STATE(9975), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442809] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13252), 1,
      sym_preproc_arg,
    STATE(9976), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442850] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13254), 1,
      sym__optional_semi,
    STATE(9977), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442891] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13256), 1,
      anon_sym_while,
    STATE(9978), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442932] = 11,
    ACTIONS(3), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(5), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(7), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(11), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(13), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(15), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(17), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(13258), 1,
      anon_sym_LPAREN,
    STATE(9979), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [442973] = 11,
    ACTIONS(9557), 1,
      aux_sym_preproc_region_token1,
    ACTIONS(9559), 1,
      aux_sym_preproc_endregion_token1,
    ACTIONS(9561), 1,
      aux_sym_preproc_line_token1,
    ACTIONS(9563), 1,
      aux_sym_preproc_pragma_token1,
    ACTIONS(9565), 1,
      aux_sym_preproc_nullable_token1,
    ACTIONS(9567), 1,
      aux_sym_preproc_error_token1,
    ACTIONS(9569), 1,
      aux_sym_preproc_define_token1,
    ACTIONS(9571), 1,
      aux_sym_preproc_undef_token1,
    ACTIONS(9573), 1,
      sym_comment,
    ACTIONS(13260), 1,
      sym_preproc_arg,
    STATE(9980), 8,
      sym_preproc_region,
      sym_preproc_endregion,
      sym_preproc_line,
      sym_preproc_pragma,
      sym_preproc_nullable,
      sym_preproc_error,
      sym_preproc_define,
      sym_preproc_undef,
  [443014] = 1,
    ACTIONS(13262), 1,
      ts_builtin_sym_end,
  [443018] = 1,
    ACTIONS(13264), 1,
      ts_builtin_sym_end,
  [443022] = 1,
    ACTIONS(13266), 1,
      ts_builtin_sym_end,
  [443026] = 1,
    ACTIONS(13268), 1,
      ts_builtin_sym_end,
  [443030] = 1,
    ACTIONS(13270), 1,
      ts_builtin_sym_end,
  [443034] = 1,
    ACTIONS(13272), 1,
      ts_builtin_sym_end,
  [443038] = 1,
    ACTIONS(13274), 1,
      ts_builtin_sym_end,
  [443042] = 1,
    ACTIONS(13276), 1,
      ts_builtin_sym_end,
  [443046] = 1,
    ACTIONS(13278), 1,
      ts_builtin_sym_end,
  [443050] = 1,
    ACTIONS(13280), 1,
      ts_builtin_sym_end,
  [443054] = 1,
    ACTIONS(13282), 1,
      ts_builtin_sym_end,
  [443058] = 1,
    ACTIONS(13284), 1,
      ts_builtin_sym_end,
  [443062] = 1,
    ACTIONS(13286), 1,
      ts_builtin_sym_end,
  [443066] = 1,
    ACTIONS(13288), 1,
      ts_builtin_sym_end,
  [443070] = 1,
    ACTIONS(13290), 1,
      ts_builtin_sym_end,
  [443074] = 1,
    ACTIONS(13292), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(4455)] = 0,
  [SMALL_STATE(4456)] = 111,
  [SMALL_STATE(4457)] = 228,
  [SMALL_STATE(4458)] = 367,
  [SMALL_STATE(4459)] = 510,
  [SMALL_STATE(4460)] = 617,
  [SMALL_STATE(4461)] = 706,
  [SMALL_STATE(4462)] = 821,
  [SMALL_STATE(4463)] = 942,
  [SMALL_STATE(4464)] = 1087,
  [SMALL_STATE(4465)] = 1224,
  [SMALL_STATE(4466)] = 1369,
  [SMALL_STATE(4467)] = 1514,
  [SMALL_STATE(4468)] = 1607,
  [SMALL_STATE(4469)] = 1752,
  [SMALL_STATE(4470)] = 1897,
  [SMALL_STATE(4471)] = 2042,
  [SMALL_STATE(4472)] = 2171,
  [SMALL_STATE(4473)] = 2316,
  [SMALL_STATE(4474)] = 2461,
  [SMALL_STATE(4475)] = 2568,
  [SMALL_STATE(4476)] = 2659,
  [SMALL_STATE(4477)] = 2804,
  [SMALL_STATE(4478)] = 2949,
  [SMALL_STATE(4479)] = 3094,
  [SMALL_STATE(4480)] = 3239,
  [SMALL_STATE(4481)] = 3332,
  [SMALL_STATE(4482)] = 3477,
  [SMALL_STATE(4483)] = 3622,
  [SMALL_STATE(4484)] = 3767,
  [SMALL_STATE(4485)] = 3912,
  [SMALL_STATE(4486)] = 4057,
  [SMALL_STATE(4487)] = 4202,
  [SMALL_STATE(4488)] = 4331,
  [SMALL_STATE(4489)] = 4476,
  [SMALL_STATE(4490)] = 4621,
  [SMALL_STATE(4491)] = 4750,
  [SMALL_STATE(4492)] = 4843,
  [SMALL_STATE(4493)] = 4972,
  [SMALL_STATE(4494)] = 5061,
  [SMALL_STATE(4495)] = 5168,
  [SMALL_STATE(4496)] = 5285,
  [SMALL_STATE(4497)] = 5378,
  [SMALL_STATE(4498)] = 5471,
  [SMALL_STATE(4499)] = 5602,
  [SMALL_STATE(4500)] = 5747,
  [SMALL_STATE(4501)] = 5840,
  [SMALL_STATE(4502)] = 5985,
  [SMALL_STATE(4503)] = 6076,
  [SMALL_STATE(4504)] = 6211,
  [SMALL_STATE(4505)] = 6304,
  [SMALL_STATE(4506)] = 6395,
  [SMALL_STATE(4507)] = 6488,
  [SMALL_STATE(4508)] = 6621,
  [SMALL_STATE(4509)] = 6714,
  [SMALL_STATE(4510)] = 6825,
  [SMALL_STATE(4511)] = 6940,
  [SMALL_STATE(4512)] = 7061,
  [SMALL_STATE(4513)] = 7150,
  [SMALL_STATE(4514)] = 7279,
  [SMALL_STATE(4515)] = 7424,
  [SMALL_STATE(4516)] = 7515,
  [SMALL_STATE(4517)] = 7646,
  [SMALL_STATE(4518)] = 7735,
  [SMALL_STATE(4519)] = 7864,
  [SMALL_STATE(4520)] = 7993,
  [SMALL_STATE(4521)] = 8122,
  [SMALL_STATE(4522)] = 8255,
  [SMALL_STATE(4523)] = 8380,
  [SMALL_STATE(4524)] = 8469,
  [SMALL_STATE(4525)] = 8604,
  [SMALL_STATE(4526)] = 8735,
  [SMALL_STATE(4527)] = 8824,
  [SMALL_STATE(4528)] = 8969,
  [SMALL_STATE(4529)] = 9056,
  [SMALL_STATE(4530)] = 9185,
  [SMALL_STATE(4531)] = 9274,
  [SMALL_STATE(4532)] = 9361,
  [SMALL_STATE(4533)] = 9498,
  [SMALL_STATE(4534)] = 9605,
  [SMALL_STATE(4535)] = 9744,
  [SMALL_STATE(4536)] = 9833,
  [SMALL_STATE(4537)] = 9976,
  [SMALL_STATE(4538)] = 10067,
  [SMALL_STATE(4539)] = 10160,
  [SMALL_STATE(4540)] = 10249,
  [SMALL_STATE(4541)] = 10338,
  [SMALL_STATE(4542)] = 10464,
  [SMALL_STATE(4543)] = 10552,
  [SMALL_STATE(4544)] = 10640,
  [SMALL_STATE(4545)] = 10766,
  [SMALL_STATE(4546)] = 10854,
  [SMALL_STATE(4547)] = 10980,
  [SMALL_STATE(4548)] = 11068,
  [SMALL_STATE(4549)] = 11176,
  [SMALL_STATE(4550)] = 11264,
  [SMALL_STATE(4551)] = 11352,
  [SMALL_STATE(4552)] = 11478,
  [SMALL_STATE(4553)] = 11604,
  [SMALL_STATE(4554)] = 11692,
  [SMALL_STATE(4555)] = 11818,
  [SMALL_STATE(4556)] = 11906,
  [SMALL_STATE(4557)] = 12032,
  [SMALL_STATE(4558)] = 12158,
  [SMALL_STATE(4559)] = 12284,
  [SMALL_STATE(4560)] = 12372,
  [SMALL_STATE(4561)] = 12460,
  [SMALL_STATE(4562)] = 12548,
  [SMALL_STATE(4563)] = 12674,
  [SMALL_STATE(4564)] = 12800,
  [SMALL_STATE(4565)] = 12926,
  [SMALL_STATE(4566)] = 13014,
  [SMALL_STATE(4567)] = 13102,
  [SMALL_STATE(4568)] = 13190,
  [SMALL_STATE(4569)] = 13278,
  [SMALL_STATE(4570)] = 13410,
  [SMALL_STATE(4571)] = 13544,
  [SMALL_STATE(4572)] = 13674,
  [SMALL_STATE(4573)] = 13802,
  [SMALL_STATE(4574)] = 13938,
  [SMALL_STATE(4575)] = 14076,
  [SMALL_STATE(4576)] = 14218,
  [SMALL_STATE(4577)] = 14306,
  [SMALL_STATE(4578)] = 14394,
  [SMALL_STATE(4579)] = 14520,
  [SMALL_STATE(4580)] = 14646,
  [SMALL_STATE(4581)] = 14734,
  [SMALL_STATE(4582)] = 14822,
  [SMALL_STATE(4583)] = 14910,
  [SMALL_STATE(4584)] = 15036,
  [SMALL_STATE(4585)] = 15124,
  [SMALL_STATE(4586)] = 15250,
  [SMALL_STATE(4587)] = 15376,
  [SMALL_STATE(4588)] = 15502,
  [SMALL_STATE(4589)] = 15590,
  [SMALL_STATE(4590)] = 15678,
  [SMALL_STATE(4591)] = 15766,
  [SMALL_STATE(4592)] = 15854,
  [SMALL_STATE(4593)] = 15942,
  [SMALL_STATE(4594)] = 16068,
  [SMALL_STATE(4595)] = 16156,
  [SMALL_STATE(4596)] = 16244,
  [SMALL_STATE(4597)] = 16370,
  [SMALL_STATE(4598)] = 16496,
  [SMALL_STATE(4599)] = 16584,
  [SMALL_STATE(4600)] = 16672,
  [SMALL_STATE(4601)] = 16760,
  [SMALL_STATE(4602)] = 16848,
  [SMALL_STATE(4603)] = 16936,
  [SMALL_STATE(4604)] = 17062,
  [SMALL_STATE(4605)] = 17188,
  [SMALL_STATE(4606)] = 17276,
  [SMALL_STATE(4607)] = 17364,
  [SMALL_STATE(4608)] = 17490,
  [SMALL_STATE(4609)] = 17578,
  [SMALL_STATE(4610)] = 17720,
  [SMALL_STATE(4611)] = 17846,
  [SMALL_STATE(4612)] = 17934,
  [SMALL_STATE(4613)] = 18060,
  [SMALL_STATE(4614)] = 18186,
  [SMALL_STATE(4615)] = 18312,
  [SMALL_STATE(4616)] = 18404,
  [SMALL_STATE(4617)] = 18530,
  [SMALL_STATE(4618)] = 18618,
  [SMALL_STATE(4619)] = 18712,
  [SMALL_STATE(4620)] = 18800,
  [SMALL_STATE(4621)] = 18888,
  [SMALL_STATE(4622)] = 18976,
  [SMALL_STATE(4623)] = 19064,
  [SMALL_STATE(4624)] = 19152,
  [SMALL_STATE(4625)] = 19278,
  [SMALL_STATE(4626)] = 19366,
  [SMALL_STATE(4627)] = 19492,
  [SMALL_STATE(4628)] = 19618,
  [SMALL_STATE(4629)] = 19706,
  [SMALL_STATE(4630)] = 19798,
  [SMALL_STATE(4631)] = 19890,
  [SMALL_STATE(4632)] = 19982,
  [SMALL_STATE(4633)] = 20074,
  [SMALL_STATE(4634)] = 20162,
  [SMALL_STATE(4635)] = 20250,
  [SMALL_STATE(4636)] = 20342,
  [SMALL_STATE(4637)] = 20430,
  [SMALL_STATE(4638)] = 20518,
  [SMALL_STATE(4639)] = 20644,
  [SMALL_STATE(4640)] = 20736,
  [SMALL_STATE(4641)] = 20824,
  [SMALL_STATE(4642)] = 20912,
  [SMALL_STATE(4643)] = 21000,
  [SMALL_STATE(4644)] = 21088,
  [SMALL_STATE(4645)] = 21176,
  [SMALL_STATE(4646)] = 21264,
  [SMALL_STATE(4647)] = 21352,
  [SMALL_STATE(4648)] = 21440,
  [SMALL_STATE(4649)] = 21530,
  [SMALL_STATE(4650)] = 21622,
  [SMALL_STATE(4651)] = 21710,
  [SMALL_STATE(4652)] = 21798,
  [SMALL_STATE(4653)] = 21924,
  [SMALL_STATE(4654)] = 22012,
  [SMALL_STATE(4655)] = 22100,
  [SMALL_STATE(4656)] = 22188,
  [SMALL_STATE(4657)] = 22276,
  [SMALL_STATE(4658)] = 22364,
  [SMALL_STATE(4659)] = 22452,
  [SMALL_STATE(4660)] = 22540,
  [SMALL_STATE(4661)] = 22682,
  [SMALL_STATE(4662)] = 22770,
  [SMALL_STATE(4663)] = 22858,
  [SMALL_STATE(4664)] = 22946,
  [SMALL_STATE(4665)] = 23034,
  [SMALL_STATE(4666)] = 23122,
  [SMALL_STATE(4667)] = 23212,
  [SMALL_STATE(4668)] = 23300,
  [SMALL_STATE(4669)] = 23388,
  [SMALL_STATE(4670)] = 23476,
  [SMALL_STATE(4671)] = 23564,
  [SMALL_STATE(4672)] = 23670,
  [SMALL_STATE(4673)] = 23758,
  [SMALL_STATE(4674)] = 23846,
  [SMALL_STATE(4675)] = 23988,
  [SMALL_STATE(4676)] = 24076,
  [SMALL_STATE(4677)] = 24164,
  [SMALL_STATE(4678)] = 24252,
  [SMALL_STATE(4679)] = 24340,
  [SMALL_STATE(4680)] = 24428,
  [SMALL_STATE(4681)] = 24516,
  [SMALL_STATE(4682)] = 24642,
  [SMALL_STATE(4683)] = 24730,
  [SMALL_STATE(4684)] = 24818,
  [SMALL_STATE(4685)] = 24906,
  [SMALL_STATE(4686)] = 24994,
  [SMALL_STATE(4687)] = 25082,
  [SMALL_STATE(4688)] = 25172,
  [SMALL_STATE(4689)] = 25280,
  [SMALL_STATE(4690)] = 25368,
  [SMALL_STATE(4691)] = 25456,
  [SMALL_STATE(4692)] = 25582,
  [SMALL_STATE(4693)] = 25670,
  [SMALL_STATE(4694)] = 25758,
  [SMALL_STATE(4695)] = 25884,
  [SMALL_STATE(4696)] = 25972,
  [SMALL_STATE(4697)] = 26098,
  [SMALL_STATE(4698)] = 26224,
  [SMALL_STATE(4699)] = 26350,
  [SMALL_STATE(4700)] = 26476,
  [SMALL_STATE(4701)] = 26602,
  [SMALL_STATE(4702)] = 26728,
  [SMALL_STATE(4703)] = 26816,
  [SMALL_STATE(4704)] = 26932,
  [SMALL_STATE(4705)] = 27058,
  [SMALL_STATE(4706)] = 27168,
  [SMALL_STATE(4707)] = 27282,
  [SMALL_STATE(4708)] = 27402,
  [SMALL_STATE(4709)] = 27528,
  [SMALL_STATE(4710)] = 27654,
  [SMALL_STATE(4711)] = 27780,
  [SMALL_STATE(4712)] = 27906,
  [SMALL_STATE(4713)] = 28032,
  [SMALL_STATE(4714)] = 28120,
  [SMALL_STATE(4715)] = 28262,
  [SMALL_STATE(4716)] = 28404,
  [SMALL_STATE(4717)] = 28546,
  [SMALL_STATE(4718)] = 28672,
  [SMALL_STATE(4719)] = 28814,
  [SMALL_STATE(4720)] = 28956,
  [SMALL_STATE(4721)] = 29082,
  [SMALL_STATE(4722)] = 29208,
  [SMALL_STATE(4723)] = 29350,
  [SMALL_STATE(4724)] = 29476,
  [SMALL_STATE(4725)] = 29618,
  [SMALL_STATE(4726)] = 29760,
  [SMALL_STATE(4727)] = 29866,
  [SMALL_STATE(4728)] = 30008,
  [SMALL_STATE(4729)] = 30134,
  [SMALL_STATE(4730)] = 30260,
  [SMALL_STATE(4731)] = 30386,
  [SMALL_STATE(4732)] = 30512,
  [SMALL_STATE(4733)] = 30638,
  [SMALL_STATE(4734)] = 30764,
  [SMALL_STATE(4735)] = 30890,
  [SMALL_STATE(4736)] = 31016,
  [SMALL_STATE(4737)] = 31142,
  [SMALL_STATE(4738)] = 31268,
  [SMALL_STATE(4739)] = 31394,
  [SMALL_STATE(4740)] = 31520,
  [SMALL_STATE(4741)] = 31646,
  [SMALL_STATE(4742)] = 31734,
  [SMALL_STATE(4743)] = 31860,
  [SMALL_STATE(4744)] = 31983,
  [SMALL_STATE(4745)] = 32106,
  [SMALL_STATE(4746)] = 32229,
  [SMALL_STATE(4747)] = 32352,
  [SMALL_STATE(4748)] = 32481,
  [SMALL_STATE(4749)] = 32604,
  [SMALL_STATE(4750)] = 32727,
  [SMALL_STATE(4751)] = 32850,
  [SMALL_STATE(4752)] = 32973,
  [SMALL_STATE(4753)] = 33096,
  [SMALL_STATE(4754)] = 33219,
  [SMALL_STATE(4755)] = 33342,
  [SMALL_STATE(4756)] = 33465,
  [SMALL_STATE(4757)] = 33608,
  [SMALL_STATE(4758)] = 33749,
  [SMALL_STATE(4759)] = 33840,
  [SMALL_STATE(4760)] = 33983,
  [SMALL_STATE(4761)] = 34126,
  [SMALL_STATE(4762)] = 34257,
  [SMALL_STATE(4763)] = 34390,
  [SMALL_STATE(4764)] = 34531,
  [SMALL_STATE(4765)] = 34660,
  [SMALL_STATE(4766)] = 34787,
  [SMALL_STATE(4767)] = 34910,
  [SMALL_STATE(4768)] = 35033,
  [SMALL_STATE(4769)] = 35156,
  [SMALL_STATE(4770)] = 35297,
  [SMALL_STATE(4771)] = 35438,
  [SMALL_STATE(4772)] = 35529,
  [SMALL_STATE(4773)] = 35652,
  [SMALL_STATE(4774)] = 35775,
  [SMALL_STATE(4775)] = 35898,
  [SMALL_STATE(4776)] = 36021,
  [SMALL_STATE(4777)] = 36164,
  [SMALL_STATE(4778)] = 36287,
  [SMALL_STATE(4779)] = 36410,
  [SMALL_STATE(4780)] = 36533,
  [SMALL_STATE(4781)] = 36624,
  [SMALL_STATE(4782)] = 36759,
  [SMALL_STATE(4783)] = 36896,
  [SMALL_STATE(4784)] = 37019,
  [SMALL_STATE(4785)] = 37142,
  [SMALL_STATE(4786)] = 37247,
  [SMALL_STATE(4787)] = 37388,
  [SMALL_STATE(4788)] = 37511,
  [SMALL_STATE(4789)] = 37652,
  [SMALL_STATE(4790)] = 37775,
  [SMALL_STATE(4791)] = 37898,
  [SMALL_STATE(4792)] = 38003,
  [SMALL_STATE(4793)] = 38126,
  [SMALL_STATE(4794)] = 38249,
  [SMALL_STATE(4795)] = 38372,
  [SMALL_STATE(4796)] = 38505,
  [SMALL_STATE(4797)] = 38610,
  [SMALL_STATE(4798)] = 38733,
  [SMALL_STATE(4799)] = 38856,
  [SMALL_STATE(4800)] = 38979,
  [SMALL_STATE(4801)] = 39122,
  [SMALL_STATE(4802)] = 39245,
  [SMALL_STATE(4803)] = 39368,
  [SMALL_STATE(4804)] = 39459,
  [SMALL_STATE(4805)] = 39550,
  [SMALL_STATE(4806)] = 39681,
  [SMALL_STATE(4807)] = 39804,
  [SMALL_STATE(4808)] = 39945,
  [SMALL_STATE(4809)] = 40088,
  [SMALL_STATE(4810)] = 40231,
  [SMALL_STATE(4811)] = 40374,
  [SMALL_STATE(4812)] = 40517,
  [SMALL_STATE(4813)] = 40660,
  [SMALL_STATE(4814)] = 40803,
  [SMALL_STATE(4815)] = 40894,
  [SMALL_STATE(4816)] = 41035,
  [SMALL_STATE(4817)] = 41176,
  [SMALL_STATE(4818)] = 41299,
  [SMALL_STATE(4819)] = 41408,
  [SMALL_STATE(4820)] = 41527,
  [SMALL_STATE(4821)] = 41650,
  [SMALL_STATE(4822)] = 41773,
  [SMALL_STATE(4823)] = 41896,
  [SMALL_STATE(4824)] = 42019,
  [SMALL_STATE(4825)] = 42142,
  [SMALL_STATE(4826)] = 42265,
  [SMALL_STATE(4827)] = 42388,
  [SMALL_STATE(4828)] = 42531,
  [SMALL_STATE(4829)] = 42654,
  [SMALL_STATE(4830)] = 42797,
  [SMALL_STATE(4831)] = 42892,
  [SMALL_STATE(4832)] = 42983,
  [SMALL_STATE(4833)] = 43124,
  [SMALL_STATE(4834)] = 43247,
  [SMALL_STATE(4835)] = 43370,
  [SMALL_STATE(4836)] = 43493,
  [SMALL_STATE(4837)] = 43636,
  [SMALL_STATE(4838)] = 43725,
  [SMALL_STATE(4839)] = 43848,
  [SMALL_STATE(4840)] = 43971,
  [SMALL_STATE(4841)] = 44094,
  [SMALL_STATE(4842)] = 44237,
  [SMALL_STATE(4843)] = 44380,
  [SMALL_STATE(4844)] = 44503,
  [SMALL_STATE(4845)] = 44626,
  [SMALL_STATE(4846)] = 44749,
  [SMALL_STATE(4847)] = 44872,
  [SMALL_STATE(4848)] = 44995,
  [SMALL_STATE(4849)] = 45102,
  [SMALL_STATE(4850)] = 45221,
  [SMALL_STATE(4851)] = 45334,
  [SMALL_STATE(4852)] = 45457,
  [SMALL_STATE(4853)] = 45580,
  [SMALL_STATE(4854)] = 45703,
  [SMALL_STATE(4855)] = 45826,
  [SMALL_STATE(4856)] = 45941,
  [SMALL_STATE(4857)] = 46032,
  [SMALL_STATE(4858)] = 46155,
  [SMALL_STATE(4859)] = 46298,
  [SMALL_STATE(4860)] = 46441,
  [SMALL_STATE(4861)] = 46564,
  [SMALL_STATE(4862)] = 46653,
  [SMALL_STATE(4863)] = 46776,
  [SMALL_STATE(4864)] = 46899,
  [SMALL_STATE(4865)] = 47042,
  [SMALL_STATE(4866)] = 47165,
  [SMALL_STATE(4867)] = 47288,
  [SMALL_STATE(4868)] = 47393,
  [SMALL_STATE(4869)] = 47536,
  [SMALL_STATE(4870)] = 47659,
  [SMALL_STATE(4871)] = 47782,
  [SMALL_STATE(4872)] = 47925,
  [SMALL_STATE(4873)] = 48048,
  [SMALL_STATE(4874)] = 48171,
  [SMALL_STATE(4875)] = 48294,
  [SMALL_STATE(4876)] = 48417,
  [SMALL_STATE(4877)] = 48540,
  [SMALL_STATE(4878)] = 48683,
  [SMALL_STATE(4879)] = 48806,
  [SMALL_STATE(4880)] = 48949,
  [SMALL_STATE(4881)] = 49072,
  [SMALL_STATE(4882)] = 49195,
  [SMALL_STATE(4883)] = 49318,
  [SMALL_STATE(4884)] = 49441,
  [SMALL_STATE(4885)] = 49564,
  [SMALL_STATE(4886)] = 49687,
  [SMALL_STATE(4887)] = 49810,
  [SMALL_STATE(4888)] = 49933,
  [SMALL_STATE(4889)] = 50022,
  [SMALL_STATE(4890)] = 50145,
  [SMALL_STATE(4891)] = 50282,
  [SMALL_STATE(4892)] = 50417,
  [SMALL_STATE(4893)] = 50560,
  [SMALL_STATE(4894)] = 50683,
  [SMALL_STATE(4895)] = 50796,
  [SMALL_STATE(4896)] = 50937,
  [SMALL_STATE(4897)] = 51060,
  [SMALL_STATE(4898)] = 51203,
  [SMALL_STATE(4899)] = 51326,
  [SMALL_STATE(4900)] = 51449,
  [SMALL_STATE(4901)] = 51540,
  [SMALL_STATE(4902)] = 51667,
  [SMALL_STATE(4903)] = 51790,
  [SMALL_STATE(4904)] = 51913,
  [SMALL_STATE(4905)] = 52036,
  [SMALL_STATE(4906)] = 52159,
  [SMALL_STATE(4907)] = 52282,
  [SMALL_STATE(4908)] = 52423,
  [SMALL_STATE(4909)] = 52546,
  [SMALL_STATE(4910)] = 52669,
  [SMALL_STATE(4911)] = 52792,
  [SMALL_STATE(4912)] = 52915,
  [SMALL_STATE(4913)] = 53058,
  [SMALL_STATE(4914)] = 53181,
  [SMALL_STATE(4915)] = 53286,
  [SMALL_STATE(4916)] = 53409,
  [SMALL_STATE(4917)] = 53518,
  [SMALL_STATE(4918)] = 53649,
  [SMALL_STATE(4919)] = 53782,
  [SMALL_STATE(4920)] = 53877,
  [SMALL_STATE(4921)] = 54000,
  [SMALL_STATE(4922)] = 54123,
  [SMALL_STATE(4923)] = 54246,
  [SMALL_STATE(4924)] = 54361,
  [SMALL_STATE(4925)] = 54484,
  [SMALL_STATE(4926)] = 54607,
  [SMALL_STATE(4927)] = 54730,
  [SMALL_STATE(4928)] = 54835,
  [SMALL_STATE(4929)] = 54944,
  [SMALL_STATE(4930)] = 55057,
  [SMALL_STATE(4931)] = 55148,
  [SMALL_STATE(4932)] = 55271,
  [SMALL_STATE(4933)] = 55412,
  [SMALL_STATE(4934)] = 55549,
  [SMALL_STATE(4935)] = 55684,
  [SMALL_STATE(4936)] = 55803,
  [SMALL_STATE(4937)] = 55926,
  [SMALL_STATE(4938)] = 56053,
  [SMALL_STATE(4939)] = 56168,
  [SMALL_STATE(4940)] = 56297,
  [SMALL_STATE(4941)] = 56439,
  [SMALL_STATE(4942)] = 56541,
  [SMALL_STATE(4943)] = 56647,
  [SMALL_STATE(4944)] = 56735,
  [SMALL_STATE(4945)] = 56825,
  [SMALL_STATE(4946)] = 56939,
  [SMALL_STATE(4947)] = 57029,
  [SMALL_STATE(4948)] = 57133,
  [SMALL_STATE(4949)] = 57235,
  [SMALL_STATE(4950)] = 57327,
  [SMALL_STATE(4951)] = 57467,
  [SMALL_STATE(4952)] = 57603,
  [SMALL_STATE(4953)] = 57737,
  [SMALL_STATE(4954)] = 57863,
  [SMALL_STATE(4955)] = 57991,
  [SMALL_STATE(4956)] = 58123,
  [SMALL_STATE(4957)] = 58253,
  [SMALL_STATE(4958)] = 58341,
  [SMALL_STATE(4959)] = 58431,
  [SMALL_STATE(4960)] = 58521,
  [SMALL_STATE(4961)] = 58611,
  [SMALL_STATE(4962)] = 58701,
  [SMALL_STATE(4963)] = 58791,
  [SMALL_STATE(4964)] = 58881,
  [SMALL_STATE(4965)] = 58975,
  [SMALL_STATE(4966)] = 59117,
  [SMALL_STATE(4967)] = 59259,
  [SMALL_STATE(4968)] = 59401,
  [SMALL_STATE(4969)] = 59543,
  [SMALL_STATE(4970)] = 59685,
  [SMALL_STATE(4971)] = 59827,
  [SMALL_STATE(4972)] = 59969,
  [SMALL_STATE(4973)] = 60077,
  [SMALL_STATE(4974)] = 60165,
  [SMALL_STATE(4975)] = 60307,
  [SMALL_STATE(4976)] = 60449,
  [SMALL_STATE(4977)] = 60561,
  [SMALL_STATE(4978)] = 60679,
  [SMALL_STATE(4979)] = 60821,
  [SMALL_STATE(4980)] = 60925,
  [SMALL_STATE(4981)] = 61027,
  [SMALL_STATE(4982)] = 61115,
  [SMALL_STATE(4983)] = 61254,
  [SMALL_STATE(4984)] = 61339,
  [SMALL_STATE(4985)] = 61424,
  [SMALL_STATE(4986)] = 61509,
  [SMALL_STATE(4987)] = 61594,
  [SMALL_STATE(4988)] = 61679,
  [SMALL_STATE(4989)] = 61764,
  [SMALL_STATE(4990)] = 61849,
  [SMALL_STATE(4991)] = 61934,
  [SMALL_STATE(4992)] = 62019,
  [SMALL_STATE(4993)] = 62104,
  [SMALL_STATE(4994)] = 62189,
  [SMALL_STATE(4995)] = 62274,
  [SMALL_STATE(4996)] = 62359,
  [SMALL_STATE(4997)] = 62444,
  [SMALL_STATE(4998)] = 62529,
  [SMALL_STATE(4999)] = 62614,
  [SMALL_STATE(5000)] = 62753,
  [SMALL_STATE(5001)] = 62838,
  [SMALL_STATE(5002)] = 62925,
  [SMALL_STATE(5003)] = 63064,
  [SMALL_STATE(5004)] = 63199,
  [SMALL_STATE(5005)] = 63338,
  [SMALL_STATE(5006)] = 63471,
  [SMALL_STATE(5007)] = 63574,
  [SMALL_STATE(5008)] = 63699,
  [SMALL_STATE(5009)] = 63784,
  [SMALL_STATE(5010)] = 63869,
  [SMALL_STATE(5011)] = 63982,
  [SMALL_STATE(5012)] = 64109,
  [SMALL_STATE(5013)] = 64240,
  [SMALL_STATE(5014)] = 64325,
  [SMALL_STATE(5015)] = 64410,
  [SMALL_STATE(5016)] = 64495,
  [SMALL_STATE(5017)] = 64580,
  [SMALL_STATE(5018)] = 64665,
  [SMALL_STATE(5019)] = 64794,
  [SMALL_STATE(5020)] = 64901,
  [SMALL_STATE(5021)] = 65012,
  [SMALL_STATE(5022)] = 65097,
  [SMALL_STATE(5023)] = 65214,
  [SMALL_STATE(5024)] = 65303,
  [SMALL_STATE(5025)] = 65442,
  [SMALL_STATE(5026)] = 65531,
  [SMALL_STATE(5027)] = 65670,
  [SMALL_STATE(5028)] = 65755,
  [SMALL_STATE(5029)] = 65894,
  [SMALL_STATE(5030)] = 66033,
  [SMALL_STATE(5031)] = 66172,
  [SMALL_STATE(5032)] = 66311,
  [SMALL_STATE(5033)] = 66450,
  [SMALL_STATE(5034)] = 66535,
  [SMALL_STATE(5035)] = 66638,
  [SMALL_STATE(5036)] = 66723,
  [SMALL_STATE(5037)] = 66862,
  [SMALL_STATE(5038)] = 67001,
  [SMALL_STATE(5039)] = 67090,
  [SMALL_STATE(5040)] = 67179,
  [SMALL_STATE(5041)] = 67282,
  [SMALL_STATE(5042)] = 67421,
  [SMALL_STATE(5043)] = 67559,
  [SMALL_STATE(5044)] = 67697,
  [SMALL_STATE(5045)] = 67835,
  [SMALL_STATE(5046)] = 67951,
  [SMALL_STATE(5047)] = 68089,
  [SMALL_STATE(5048)] = 68205,
  [SMALL_STATE(5049)] = 68315,
  [SMALL_STATE(5050)] = 68421,
  [SMALL_STATE(5051)] = 68549,
  [SMALL_STATE(5052)] = 68679,
  [SMALL_STATE(5053)] = 68805,
  [SMALL_STATE(5054)] = 68917,
  [SMALL_STATE(5055)] = 69041,
  [SMALL_STATE(5056)] = 69175,
  [SMALL_STATE(5057)] = 69307,
  [SMALL_STATE(5058)] = 69441,
  [SMALL_STATE(5059)] = 69579,
  [SMALL_STATE(5060)] = 69667,
  [SMALL_STATE(5061)] = 69755,
  [SMALL_STATE(5062)] = 69893,
  [SMALL_STATE(5063)] = 70031,
  [SMALL_STATE(5064)] = 70119,
  [SMALL_STATE(5065)] = 70257,
  [SMALL_STATE(5066)] = 70395,
  [SMALL_STATE(5067)] = 70533,
  [SMALL_STATE(5068)] = 70665,
  [SMALL_STATE(5069)] = 70789,
  [SMALL_STATE(5070)] = 70901,
  [SMALL_STATE(5071)] = 71027,
  [SMALL_STATE(5072)] = 71165,
  [SMALL_STATE(5073)] = 71303,
  [SMALL_STATE(5074)] = 71441,
  [SMALL_STATE(5075)] = 71571,
  [SMALL_STATE(5076)] = 71699,
  [SMALL_STATE(5077)] = 71805,
  [SMALL_STATE(5078)] = 71943,
  [SMALL_STATE(5079)] = 72081,
  [SMALL_STATE(5080)] = 72187,
  [SMALL_STATE(5081)] = 72325,
  [SMALL_STATE(5082)] = 72441,
  [SMALL_STATE(5083)] = 72551,
  [SMALL_STATE(5084)] = 72667,
  [SMALL_STATE(5085)] = 72777,
  [SMALL_STATE(5086)] = 72905,
  [SMALL_STATE(5087)] = 73035,
  [SMALL_STATE(5088)] = 73161,
  [SMALL_STATE(5089)] = 73273,
  [SMALL_STATE(5090)] = 73375,
  [SMALL_STATE(5091)] = 73477,
  [SMALL_STATE(5092)] = 73601,
  [SMALL_STATE(5093)] = 73733,
  [SMALL_STATE(5094)] = 73867,
  [SMALL_STATE(5095)] = 74005,
  [SMALL_STATE(5096)] = 74143,
  [SMALL_STATE(5097)] = 74235,
  [SMALL_STATE(5098)] = 74373,
  [SMALL_STATE(5099)] = 74511,
  [SMALL_STATE(5100)] = 74595,
  [SMALL_STATE(5101)] = 74733,
  [SMALL_STATE(5102)] = 74871,
  [SMALL_STATE(5103)] = 75009,
  [SMALL_STATE(5104)] = 75097,
  [SMALL_STATE(5105)] = 75235,
  [SMALL_STATE(5106)] = 75323,
  [SMALL_STATE(5107)] = 75411,
  [SMALL_STATE(5108)] = 75513,
  [SMALL_STATE(5109)] = 75651,
  [SMALL_STATE(5110)] = 75789,
  [SMALL_STATE(5111)] = 75879,
  [SMALL_STATE(5112)] = 76017,
  [SMALL_STATE(5113)] = 76155,
  [SMALL_STATE(5114)] = 76243,
  [SMALL_STATE(5115)] = 76381,
  [SMALL_STATE(5116)] = 76467,
  [SMALL_STATE(5117)] = 76553,
  [SMALL_STATE(5118)] = 76691,
  [SMALL_STATE(5119)] = 76793,
  [SMALL_STATE(5120)] = 76931,
  [SMALL_STATE(5121)] = 77069,
  [SMALL_STATE(5122)] = 77207,
  [SMALL_STATE(5123)] = 77295,
  [SMALL_STATE(5124)] = 77397,
  [SMALL_STATE(5125)] = 77535,
  [SMALL_STATE(5126)] = 77673,
  [SMALL_STATE(5127)] = 77811,
  [SMALL_STATE(5128)] = 77913,
  [SMALL_STATE(5129)] = 78051,
  [SMALL_STATE(5130)] = 78189,
  [SMALL_STATE(5131)] = 78327,
  [SMALL_STATE(5132)] = 78415,
  [SMALL_STATE(5133)] = 78553,
  [SMALL_STATE(5134)] = 78691,
  [SMALL_STATE(5135)] = 78828,
  [SMALL_STATE(5136)] = 78965,
  [SMALL_STATE(5137)] = 79048,
  [SMALL_STATE(5138)] = 79185,
  [SMALL_STATE(5139)] = 79318,
  [SMALL_STATE(5140)] = 79429,
  [SMALL_STATE(5141)] = 79560,
  [SMALL_STATE(5142)] = 79683,
  [SMALL_STATE(5143)] = 79794,
  [SMALL_STATE(5144)] = 79919,
  [SMALL_STATE(5145)] = 80048,
  [SMALL_STATE(5146)] = 80185,
  [SMALL_STATE(5147)] = 80322,
  [SMALL_STATE(5148)] = 80449,
  [SMALL_STATE(5149)] = 80550,
  [SMALL_STATE(5150)] = 80665,
  [SMALL_STATE(5151)] = 80774,
  [SMALL_STATE(5152)] = 80911,
  [SMALL_STATE(5153)] = 81048,
  [SMALL_STATE(5154)] = 81185,
  [SMALL_STATE(5155)] = 81318,
  [SMALL_STATE(5156)] = 81409,
  [SMALL_STATE(5157)] = 81540,
  [SMALL_STATE(5158)] = 81655,
  [SMALL_STATE(5159)] = 81792,
  [SMALL_STATE(5160)] = 81907,
  [SMALL_STATE(5161)] = 82030,
  [SMALL_STATE(5162)] = 82155,
  [SMALL_STATE(5163)] = 82292,
  [SMALL_STATE(5164)] = 82421,
  [SMALL_STATE(5165)] = 82530,
  [SMALL_STATE(5166)] = 82657,
  [SMALL_STATE(5167)] = 82766,
  [SMALL_STATE(5168)] = 82877,
  [SMALL_STATE(5169)] = 82978,
  [SMALL_STATE(5170)] = 83079,
  [SMALL_STATE(5171)] = 83180,
  [SMALL_STATE(5172)] = 83285,
  [SMALL_STATE(5173)] = 83422,
  [SMALL_STATE(5174)] = 83559,
  [SMALL_STATE(5175)] = 83664,
  [SMALL_STATE(5176)] = 83775,
  [SMALL_STATE(5177)] = 83902,
  [SMALL_STATE(5178)] = 84013,
  [SMALL_STATE(5179)] = 84114,
  [SMALL_STATE(5180)] = 84243,
  [SMALL_STATE(5181)] = 84330,
  [SMALL_STATE(5182)] = 84467,
  [SMALL_STATE(5183)] = 84604,
  [SMALL_STATE(5184)] = 84729,
  [SMALL_STATE(5185)] = 84840,
  [SMALL_STATE(5186)] = 84963,
  [SMALL_STATE(5187)] = 85064,
  [SMALL_STATE(5188)] = 85195,
  [SMALL_STATE(5189)] = 85328,
  [SMALL_STATE(5190)] = 85465,
  [SMALL_STATE(5191)] = 85576,
  [SMALL_STATE(5192)] = 85659,
  [SMALL_STATE(5193)] = 85744,
  [SMALL_STATE(5194)] = 85881,
  [SMALL_STATE(5195)] = 85968,
  [SMALL_STATE(5196)] = 86051,
  [SMALL_STATE(5197)] = 86140,
  [SMALL_STATE(5198)] = 86277,
  [SMALL_STATE(5199)] = 86376,
  [SMALL_STATE(5200)] = 86459,
  [SMALL_STATE(5201)] = 86596,
  [SMALL_STATE(5202)] = 86701,
  [SMALL_STATE(5203)] = 86800,
  [SMALL_STATE(5204)] = 86911,
  [SMALL_STATE(5205)] = 87048,
  [SMALL_STATE(5206)] = 87159,
  [SMALL_STATE(5207)] = 87260,
  [SMALL_STATE(5208)] = 87397,
  [SMALL_STATE(5209)] = 87534,
  [SMALL_STATE(5210)] = 87671,
  [SMALL_STATE(5211)] = 87754,
  [SMALL_STATE(5212)] = 87853,
  [SMALL_STATE(5213)] = 87990,
  [SMALL_STATE(5214)] = 88077,
  [SMALL_STATE(5215)] = 88214,
  [SMALL_STATE(5216)] = 88351,
  [SMALL_STATE(5217)] = 88488,
  [SMALL_STATE(5218)] = 88579,
  [SMALL_STATE(5219)] = 88666,
  [SMALL_STATE(5220)] = 88803,
  [SMALL_STATE(5221)] = 88888,
  [SMALL_STATE(5222)] = 88975,
  [SMALL_STATE(5223)] = 89112,
  [SMALL_STATE(5224)] = 89199,
  [SMALL_STATE(5225)] = 89336,
  [SMALL_STATE(5226)] = 89473,
  [SMALL_STATE(5227)] = 89610,
  [SMALL_STATE(5228)] = 89697,
  [SMALL_STATE(5229)] = 89834,
  [SMALL_STATE(5230)] = 89971,
  [SMALL_STATE(5231)] = 90108,
  [SMALL_STATE(5232)] = 90245,
  [SMALL_STATE(5233)] = 90382,
  [SMALL_STATE(5234)] = 90483,
  [SMALL_STATE(5235)] = 90620,
  [SMALL_STATE(5236)] = 90757,
  [SMALL_STATE(5237)] = 90901,
  [SMALL_STATE(5238)] = 90983,
  [SMALL_STATE(5239)] = 91119,
  [SMALL_STATE(5240)] = 91255,
  [SMALL_STATE(5241)] = 91391,
  [SMALL_STATE(5242)] = 91527,
  [SMALL_STATE(5243)] = 91615,
  [SMALL_STATE(5244)] = 91701,
  [SMALL_STATE(5245)] = 91837,
  [SMALL_STATE(5246)] = 91923,
  [SMALL_STATE(5247)] = 92059,
  [SMALL_STATE(5248)] = 92195,
  [SMALL_STATE(5249)] = 92295,
  [SMALL_STATE(5250)] = 92405,
  [SMALL_STATE(5251)] = 92509,
  [SMALL_STATE(5252)] = 92617,
  [SMALL_STATE(5253)] = 92731,
  [SMALL_STATE(5254)] = 92867,
  [SMALL_STATE(5255)] = 93003,
  [SMALL_STATE(5256)] = 93139,
  [SMALL_STATE(5257)] = 93243,
  [SMALL_STATE(5258)] = 93353,
  [SMALL_STATE(5259)] = 93453,
  [SMALL_STATE(5260)] = 93535,
  [SMALL_STATE(5261)] = 93617,
  [SMALL_STATE(5262)] = 93707,
  [SMALL_STATE(5263)] = 93793,
  [SMALL_STATE(5264)] = 93879,
  [SMALL_STATE(5265)] = 94015,
  [SMALL_STATE(5266)] = 94151,
  [SMALL_STATE(5267)] = 94241,
  [SMALL_STATE(5268)] = 94377,
  [SMALL_STATE(5269)] = 94519,
  [SMALL_STATE(5270)] = 94619,
  [SMALL_STATE(5271)] = 94755,
  [SMALL_STATE(5272)] = 94843,
  [SMALL_STATE(5273)] = 94979,
  [SMALL_STATE(5274)] = 95115,
  [SMALL_STATE(5275)] = 95197,
  [SMALL_STATE(5276)] = 95333,
  [SMALL_STATE(5277)] = 95415,
  [SMALL_STATE(5278)] = 95539,
  [SMALL_STATE(5279)] = 95675,
  [SMALL_STATE(5280)] = 95785,
  [SMALL_STATE(5281)] = 95867,
  [SMALL_STATE(5282)] = 95981,
  [SMALL_STATE(5283)] = 96081,
  [SMALL_STATE(5284)] = 96191,
  [SMALL_STATE(5285)] = 96327,
  [SMALL_STATE(5286)] = 96409,
  [SMALL_STATE(5287)] = 96545,
  [SMALL_STATE(5288)] = 96681,
  [SMALL_STATE(5289)] = 96817,
  [SMALL_STATE(5290)] = 96953,
  [SMALL_STATE(5291)] = 97089,
  [SMALL_STATE(5292)] = 97225,
  [SMALL_STATE(5293)] = 97361,
  [SMALL_STATE(5294)] = 97497,
  [SMALL_STATE(5295)] = 97581,
  [SMALL_STATE(5296)] = 97665,
  [SMALL_STATE(5297)] = 97773,
  [SMALL_STATE(5298)] = 97857,
  [SMALL_STATE(5299)] = 97993,
  [SMALL_STATE(5300)] = 98075,
  [SMALL_STATE(5301)] = 98161,
  [SMALL_STATE(5302)] = 98243,
  [SMALL_STATE(5303)] = 98379,
  [SMALL_STATE(5304)] = 98493,
  [SMALL_STATE(5305)] = 98629,
  [SMALL_STATE(5306)] = 98711,
  [SMALL_STATE(5307)] = 98797,
  [SMALL_STATE(5308)] = 98879,
  [SMALL_STATE(5309)] = 99015,
  [SMALL_STATE(5310)] = 99097,
  [SMALL_STATE(5311)] = 99181,
  [SMALL_STATE(5312)] = 99265,
  [SMALL_STATE(5313)] = 99347,
  [SMALL_STATE(5314)] = 99429,
  [SMALL_STATE(5315)] = 99511,
  [SMALL_STATE(5316)] = 99595,
  [SMALL_STATE(5317)] = 99677,
  [SMALL_STATE(5318)] = 99759,
  [SMALL_STATE(5319)] = 99895,
  [SMALL_STATE(5320)] = 99977,
  [SMALL_STATE(5321)] = 100119,
  [SMALL_STATE(5322)] = 100201,
  [SMALL_STATE(5323)] = 100283,
  [SMALL_STATE(5324)] = 100419,
  [SMALL_STATE(5325)] = 100555,
  [SMALL_STATE(5326)] = 100669,
  [SMALL_STATE(5327)] = 100777,
  [SMALL_STATE(5328)] = 100859,
  [SMALL_STATE(5329)] = 100963,
  [SMALL_STATE(5330)] = 101099,
  [SMALL_STATE(5331)] = 101235,
  [SMALL_STATE(5332)] = 101361,
  [SMALL_STATE(5333)] = 101443,
  [SMALL_STATE(5334)] = 101587,
  [SMALL_STATE(5335)] = 101695,
  [SMALL_STATE(5336)] = 101837,
  [SMALL_STATE(5337)] = 101965,
  [SMALL_STATE(5338)] = 102069,
  [SMALL_STATE(5339)] = 102193,
  [SMALL_STATE(5340)] = 102275,
  [SMALL_STATE(5341)] = 102363,
  [SMALL_STATE(5342)] = 102473,
  [SMALL_STATE(5343)] = 102559,
  [SMALL_STATE(5344)] = 102681,
  [SMALL_STATE(5345)] = 102807,
  [SMALL_STATE(5346)] = 102949,
  [SMALL_STATE(5347)] = 103079,
  [SMALL_STATE(5348)] = 103207,
  [SMALL_STATE(5349)] = 103331,
  [SMALL_STATE(5350)] = 103453,
  [SMALL_STATE(5351)] = 103553,
  [SMALL_STATE(5352)] = 103683,
  [SMALL_STATE(5353)] = 103815,
  [SMALL_STATE(5354)] = 103951,
  [SMALL_STATE(5355)] = 104083,
  [SMALL_STATE(5356)] = 104219,
  [SMALL_STATE(5357)] = 104319,
  [SMALL_STATE(5358)] = 104455,
  [SMALL_STATE(5359)] = 104591,
  [SMALL_STATE(5360)] = 104691,
  [SMALL_STATE(5361)] = 104823,
  [SMALL_STATE(5362)] = 104953,
  [SMALL_STATE(5363)] = 105089,
  [SMALL_STATE(5364)] = 105177,
  [SMALL_STATE(5365)] = 105261,
  [SMALL_STATE(5366)] = 105385,
  [SMALL_STATE(5367)] = 105513,
  [SMALL_STATE(5368)] = 105639,
  [SMALL_STATE(5369)] = 105723,
  [SMALL_STATE(5370)] = 105809,
  [SMALL_STATE(5371)] = 105945,
  [SMALL_STATE(5372)] = 106081,
  [SMALL_STATE(5373)] = 106181,
  [SMALL_STATE(5374)] = 106317,
  [SMALL_STATE(5375)] = 106453,
  [SMALL_STATE(5376)] = 106561,
  [SMALL_STATE(5377)] = 106697,
  [SMALL_STATE(5378)] = 106783,
  [SMALL_STATE(5379)] = 106883,
  [SMALL_STATE(5380)] = 106969,
  [SMALL_STATE(5381)] = 107105,
  [SMALL_STATE(5382)] = 107191,
  [SMALL_STATE(5383)] = 107327,
  [SMALL_STATE(5384)] = 107411,
  [SMALL_STATE(5385)] = 107497,
  [SMALL_STATE(5386)] = 107633,
  [SMALL_STATE(5387)] = 107769,
  [SMALL_STATE(5388)] = 107911,
  [SMALL_STATE(5389)] = 108011,
  [SMALL_STATE(5390)] = 108153,
  [SMALL_STATE(5391)] = 108237,
  [SMALL_STATE(5392)] = 108319,
  [SMALL_STATE(5393)] = 108401,
  [SMALL_STATE(5394)] = 108483,
  [SMALL_STATE(5395)] = 108619,
  [SMALL_STATE(5396)] = 108701,
  [SMALL_STATE(5397)] = 108783,
  [SMALL_STATE(5398)] = 108909,
  [SMALL_STATE(5399)] = 109037,
  [SMALL_STATE(5400)] = 109147,
  [SMALL_STATE(5401)] = 109269,
  [SMALL_STATE(5402)] = 109399,
  [SMALL_STATE(5403)] = 109541,
  [SMALL_STATE(5404)] = 109673,
  [SMALL_STATE(5405)] = 109809,
  [SMALL_STATE(5406)] = 109931,
  [SMALL_STATE(5407)] = 110067,
  [SMALL_STATE(5408)] = 110149,
  [SMALL_STATE(5409)] = 110231,
  [SMALL_STATE(5410)] = 110338,
  [SMALL_STATE(5411)] = 110473,
  [SMALL_STATE(5412)] = 110608,
  [SMALL_STATE(5413)] = 110743,
  [SMALL_STATE(5414)] = 110874,
  [SMALL_STATE(5415)] = 111003,
  [SMALL_STATE(5416)] = 111138,
  [SMALL_STATE(5417)] = 111237,
  [SMALL_STATE(5418)] = 111358,
  [SMALL_STATE(5419)] = 111467,
  [SMALL_STATE(5420)] = 111590,
  [SMALL_STATE(5421)] = 111717,
  [SMALL_STATE(5422)] = 111830,
  [SMALL_STATE(5423)] = 111937,
  [SMALL_STATE(5424)] = 112022,
  [SMALL_STATE(5425)] = 112147,
  [SMALL_STATE(5426)] = 112274,
  [SMALL_STATE(5427)] = 112363,
  [SMALL_STATE(5428)] = 112486,
  [SMALL_STATE(5429)] = 112595,
  [SMALL_STATE(5430)] = 112716,
  [SMALL_STATE(5431)] = 112845,
  [SMALL_STATE(5432)] = 112976,
  [SMALL_STATE(5433)] = 113111,
  [SMALL_STATE(5434)] = 113196,
  [SMALL_STATE(5435)] = 113321,
  [SMALL_STATE(5436)] = 113424,
  [SMALL_STATE(5437)] = 113531,
  [SMALL_STATE(5438)] = 113644,
  [SMALL_STATE(5439)] = 113779,
  [SMALL_STATE(5440)] = 113914,
  [SMALL_STATE(5441)] = 113999,
  [SMALL_STATE(5442)] = 114098,
  [SMALL_STATE(5443)] = 114201,
  [SMALL_STATE(5444)] = 114304,
  [SMALL_STATE(5445)] = 114403,
  [SMALL_STATE(5446)] = 114538,
  [SMALL_STATE(5447)] = 114637,
  [SMALL_STATE(5448)] = 114736,
  [SMALL_STATE(5449)] = 114871,
  [SMALL_STATE(5450)] = 115006,
  [SMALL_STATE(5451)] = 115141,
  [SMALL_STATE(5452)] = 115276,
  [SMALL_STATE(5453)] = 115379,
  [SMALL_STATE(5454)] = 115514,
  [SMALL_STATE(5455)] = 115613,
  [SMALL_STATE(5456)] = 115748,
  [SMALL_STATE(5457)] = 115883,
  [SMALL_STATE(5458)] = 116018,
  [SMALL_STATE(5459)] = 116117,
  [SMALL_STATE(5460)] = 116252,
  [SMALL_STATE(5461)] = 116387,
  [SMALL_STATE(5462)] = 116522,
  [SMALL_STATE(5463)] = 116657,
  [SMALL_STATE(5464)] = 116792,
  [SMALL_STATE(5465)] = 116891,
  [SMALL_STATE(5466)] = 117026,
  [SMALL_STATE(5467)] = 117161,
  [SMALL_STATE(5468)] = 117258,
  [SMALL_STATE(5469)] = 117357,
  [SMALL_STATE(5470)] = 117492,
  [SMALL_STATE(5471)] = 117627,
  [SMALL_STATE(5472)] = 117762,
  [SMALL_STATE(5473)] = 117897,
  [SMALL_STATE(5474)] = 117996,
  [SMALL_STATE(5475)] = 118131,
  [SMALL_STATE(5476)] = 118266,
  [SMALL_STATE(5477)] = 118363,
  [SMALL_STATE(5478)] = 118498,
  [SMALL_STATE(5479)] = 118633,
  [SMALL_STATE(5480)] = 118768,
  [SMALL_STATE(5481)] = 118903,
  [SMALL_STATE(5482)] = 119034,
  [SMALL_STATE(5483)] = 119163,
  [SMALL_STATE(5484)] = 119284,
  [SMALL_STATE(5485)] = 119407,
  [SMALL_STATE(5486)] = 119534,
  [SMALL_STATE(5487)] = 119669,
  [SMALL_STATE(5488)] = 119794,
  [SMALL_STATE(5489)] = 119929,
  [SMALL_STATE(5490)] = 120064,
  [SMALL_STATE(5491)] = 120167,
  [SMALL_STATE(5492)] = 120302,
  [SMALL_STATE(5493)] = 120437,
  [SMALL_STATE(5494)] = 120572,
  [SMALL_STATE(5495)] = 120707,
  [SMALL_STATE(5496)] = 120788,
  [SMALL_STATE(5497)] = 120875,
  [SMALL_STATE(5498)] = 120956,
  [SMALL_STATE(5499)] = 121037,
  [SMALL_STATE(5500)] = 121146,
  [SMALL_STATE(5501)] = 121253,
  [SMALL_STATE(5502)] = 121366,
  [SMALL_STATE(5503)] = 121501,
  [SMALL_STATE(5504)] = 121636,
  [SMALL_STATE(5505)] = 121771,
  [SMALL_STATE(5506)] = 121906,
  [SMALL_STATE(5507)] = 122041,
  [SMALL_STATE(5508)] = 122176,
  [SMALL_STATE(5509)] = 122311,
  [SMALL_STATE(5510)] = 122446,
  [SMALL_STATE(5511)] = 122531,
  [SMALL_STATE(5512)] = 122616,
  [SMALL_STATE(5513)] = 122701,
  [SMALL_STATE(5514)] = 122784,
  [SMALL_STATE(5515)] = 122867,
  [SMALL_STATE(5516)] = 122980,
  [SMALL_STATE(5517)] = 123087,
  [SMALL_STATE(5518)] = 123212,
  [SMALL_STATE(5519)] = 123339,
  [SMALL_STATE(5520)] = 123462,
  [SMALL_STATE(5521)] = 123571,
  [SMALL_STATE(5522)] = 123692,
  [SMALL_STATE(5523)] = 123821,
  [SMALL_STATE(5524)] = 123952,
  [SMALL_STATE(5525)] = 124087,
  [SMALL_STATE(5526)] = 124222,
  [SMALL_STATE(5527)] = 124357,
  [SMALL_STATE(5528)] = 124438,
  [SMALL_STATE(5529)] = 124573,
  [SMALL_STATE(5530)] = 124658,
  [SMALL_STATE(5531)] = 124793,
  [SMALL_STATE(5532)] = 124876,
  [SMALL_STATE(5533)] = 124961,
  [SMALL_STATE(5534)] = 125046,
  [SMALL_STATE(5535)] = 125129,
  [SMALL_STATE(5536)] = 125214,
  [SMALL_STATE(5537)] = 125349,
  [SMALL_STATE(5538)] = 125434,
  [SMALL_STATE(5539)] = 125569,
  [SMALL_STATE(5540)] = 125704,
  [SMALL_STATE(5541)] = 125839,
  [SMALL_STATE(5542)] = 125974,
  [SMALL_STATE(5543)] = 126109,
  [SMALL_STATE(5544)] = 126240,
  [SMALL_STATE(5545)] = 126369,
  [SMALL_STATE(5546)] = 126490,
  [SMALL_STATE(5547)] = 126613,
  [SMALL_STATE(5548)] = 126694,
  [SMALL_STATE(5549)] = 126775,
  [SMALL_STATE(5550)] = 126902,
  [SMALL_STATE(5551)] = 127027,
  [SMALL_STATE(5552)] = 127162,
  [SMALL_STATE(5553)] = 127243,
  [SMALL_STATE(5554)] = 127324,
  [SMALL_STATE(5555)] = 127459,
  [SMALL_STATE(5556)] = 127540,
  [SMALL_STATE(5557)] = 127621,
  [SMALL_STATE(5558)] = 127702,
  [SMALL_STATE(5559)] = 127783,
  [SMALL_STATE(5560)] = 127864,
  [SMALL_STATE(5561)] = 127945,
  [SMALL_STATE(5562)] = 128044,
  [SMALL_STATE(5563)] = 128179,
  [SMALL_STATE(5564)] = 128314,
  [SMALL_STATE(5565)] = 128413,
  [SMALL_STATE(5566)] = 128512,
  [SMALL_STATE(5567)] = 128647,
  [SMALL_STATE(5568)] = 128756,
  [SMALL_STATE(5569)] = 128863,
  [SMALL_STATE(5570)] = 128976,
  [SMALL_STATE(5571)] = 129111,
  [SMALL_STATE(5572)] = 129192,
  [SMALL_STATE(5573)] = 129273,
  [SMALL_STATE(5574)] = 129408,
  [SMALL_STATE(5575)] = 129489,
  [SMALL_STATE(5576)] = 129588,
  [SMALL_STATE(5577)] = 129723,
  [SMALL_STATE(5578)] = 129804,
  [SMALL_STATE(5579)] = 129885,
  [SMALL_STATE(5580)] = 130020,
  [SMALL_STATE(5581)] = 130101,
  [SMALL_STATE(5582)] = 130236,
  [SMALL_STATE(5583)] = 130371,
  [SMALL_STATE(5584)] = 130452,
  [SMALL_STATE(5585)] = 130533,
  [SMALL_STATE(5586)] = 130614,
  [SMALL_STATE(5587)] = 130749,
  [SMALL_STATE(5588)] = 130862,
  [SMALL_STATE(5589)] = 130969,
  [SMALL_STATE(5590)] = 131078,
  [SMALL_STATE(5591)] = 131177,
  [SMALL_STATE(5592)] = 131258,
  [SMALL_STATE(5593)] = 131393,
  [SMALL_STATE(5594)] = 131528,
  [SMALL_STATE(5595)] = 131663,
  [SMALL_STATE(5596)] = 131748,
  [SMALL_STATE(5597)] = 131833,
  [SMALL_STATE(5598)] = 131914,
  [SMALL_STATE(5599)] = 131995,
  [SMALL_STATE(5600)] = 132076,
  [SMALL_STATE(5601)] = 132211,
  [SMALL_STATE(5602)] = 132314,
  [SMALL_STATE(5603)] = 132427,
  [SMALL_STATE(5604)] = 132508,
  [SMALL_STATE(5605)] = 132643,
  [SMALL_STATE(5606)] = 132778,
  [SMALL_STATE(5607)] = 132881,
  [SMALL_STATE(5608)] = 133006,
  [SMALL_STATE(5609)] = 133147,
  [SMALL_STATE(5610)] = 133274,
  [SMALL_STATE(5611)] = 133409,
  [SMALL_STATE(5612)] = 133532,
  [SMALL_STATE(5613)] = 133667,
  [SMALL_STATE(5614)] = 133802,
  [SMALL_STATE(5615)] = 133937,
  [SMALL_STATE(5616)] = 134062,
  [SMALL_STATE(5617)] = 134189,
  [SMALL_STATE(5618)] = 134312,
  [SMALL_STATE(5619)] = 134433,
  [SMALL_STATE(5620)] = 134532,
  [SMALL_STATE(5621)] = 134661,
  [SMALL_STATE(5622)] = 134792,
  [SMALL_STATE(5623)] = 134927,
  [SMALL_STATE(5624)] = 135062,
  [SMALL_STATE(5625)] = 135197,
  [SMALL_STATE(5626)] = 135328,
  [SMALL_STATE(5627)] = 135463,
  [SMALL_STATE(5628)] = 135592,
  [SMALL_STATE(5629)] = 135691,
  [SMALL_STATE(5630)] = 135826,
  [SMALL_STATE(5631)] = 135947,
  [SMALL_STATE(5632)] = 136082,
  [SMALL_STATE(5633)] = 136217,
  [SMALL_STATE(5634)] = 136326,
  [SMALL_STATE(5635)] = 136461,
  [SMALL_STATE(5636)] = 136596,
  [SMALL_STATE(5637)] = 136719,
  [SMALL_STATE(5638)] = 136846,
  [SMALL_STATE(5639)] = 136971,
  [SMALL_STATE(5640)] = 137106,
  [SMALL_STATE(5641)] = 137209,
  [SMALL_STATE(5642)] = 137316,
  [SMALL_STATE(5643)] = 137401,
  [SMALL_STATE(5644)] = 137536,
  [SMALL_STATE(5645)] = 137649,
  [SMALL_STATE(5646)] = 137732,
  [SMALL_STATE(5647)] = 137853,
  [SMALL_STATE(5648)] = 137934,
  [SMALL_STATE(5649)] = 138015,
  [SMALL_STATE(5650)] = 138114,
  [SMALL_STATE(5651)] = 138197,
  [SMALL_STATE(5652)] = 138326,
  [SMALL_STATE(5653)] = 138407,
  [SMALL_STATE(5654)] = 138488,
  [SMALL_STATE(5655)] = 138619,
  [SMALL_STATE(5656)] = 138754,
  [SMALL_STATE(5657)] = 138867,
  [SMALL_STATE(5658)] = 138974,
  [SMALL_STATE(5659)] = 139055,
  [SMALL_STATE(5660)] = 139136,
  [SMALL_STATE(5661)] = 139261,
  [SMALL_STATE(5662)] = 139388,
  [SMALL_STATE(5663)] = 139511,
  [SMALL_STATE(5664)] = 139614,
  [SMALL_STATE(5665)] = 139735,
  [SMALL_STATE(5666)] = 139860,
  [SMALL_STATE(5667)] = 139989,
  [SMALL_STATE(5668)] = 140120,
  [SMALL_STATE(5669)] = 140255,
  [SMALL_STATE(5670)] = 140382,
  [SMALL_STATE(5671)] = 140505,
  [SMALL_STATE(5672)] = 140640,
  [SMALL_STATE(5673)] = 140749,
  [SMALL_STATE(5674)] = 140884,
  [SMALL_STATE(5675)] = 141005,
  [SMALL_STATE(5676)] = 141104,
  [SMALL_STATE(5677)] = 141233,
  [SMALL_STATE(5678)] = 141314,
  [SMALL_STATE(5679)] = 141449,
  [SMALL_STATE(5680)] = 141584,
  [SMALL_STATE(5681)] = 141715,
  [SMALL_STATE(5682)] = 141850,
  [SMALL_STATE(5683)] = 141985,
  [SMALL_STATE(5684)] = 142066,
  [SMALL_STATE(5685)] = 142147,
  [SMALL_STATE(5686)] = 142244,
  [SMALL_STATE(5687)] = 142325,
  [SMALL_STATE(5688)] = 142406,
  [SMALL_STATE(5689)] = 142541,
  [SMALL_STATE(5690)] = 142676,
  [SMALL_STATE(5691)] = 142757,
  [SMALL_STATE(5692)] = 142838,
  [SMALL_STATE(5693)] = 142919,
  [SMALL_STATE(5694)] = 143000,
  [SMALL_STATE(5695)] = 143135,
  [SMALL_STATE(5696)] = 143216,
  [SMALL_STATE(5697)] = 143297,
  [SMALL_STATE(5698)] = 143378,
  [SMALL_STATE(5699)] = 143459,
  [SMALL_STATE(5700)] = 143540,
  [SMALL_STATE(5701)] = 143621,
  [SMALL_STATE(5702)] = 143724,
  [SMALL_STATE(5703)] = 143805,
  [SMALL_STATE(5704)] = 143890,
  [SMALL_STATE(5705)] = 143973,
  [SMALL_STATE(5706)] = 144054,
  [SMALL_STATE(5707)] = 144139,
  [SMALL_STATE(5708)] = 144224,
  [SMALL_STATE(5709)] = 144359,
  [SMALL_STATE(5710)] = 144440,
  [SMALL_STATE(5711)] = 144521,
  [SMALL_STATE(5712)] = 144606,
  [SMALL_STATE(5713)] = 144687,
  [SMALL_STATE(5714)] = 144768,
  [SMALL_STATE(5715)] = 144875,
  [SMALL_STATE(5716)] = 144958,
  [SMALL_STATE(5717)] = 145093,
  [SMALL_STATE(5718)] = 145228,
  [SMALL_STATE(5719)] = 145363,
  [SMALL_STATE(5720)] = 145498,
  [SMALL_STATE(5721)] = 145595,
  [SMALL_STATE(5722)] = 145730,
  [SMALL_STATE(5723)] = 145811,
  [SMALL_STATE(5724)] = 145946,
  [SMALL_STATE(5725)] = 146045,
  [SMALL_STATE(5726)] = 146154,
  [SMALL_STATE(5727)] = 146261,
  [SMALL_STATE(5728)] = 146374,
  [SMALL_STATE(5729)] = 146455,
  [SMALL_STATE(5730)] = 146536,
  [SMALL_STATE(5731)] = 146617,
  [SMALL_STATE(5732)] = 146698,
  [SMALL_STATE(5733)] = 146779,
  [SMALL_STATE(5734)] = 146860,
  [SMALL_STATE(5735)] = 146941,
  [SMALL_STATE(5736)] = 147022,
  [SMALL_STATE(5737)] = 147103,
  [SMALL_STATE(5738)] = 147184,
  [SMALL_STATE(5739)] = 147319,
  [SMALL_STATE(5740)] = 147454,
  [SMALL_STATE(5741)] = 147589,
  [SMALL_STATE(5742)] = 147670,
  [SMALL_STATE(5743)] = 147751,
  [SMALL_STATE(5744)] = 147888,
  [SMALL_STATE(5745)] = 148023,
  [SMALL_STATE(5746)] = 148104,
  [SMALL_STATE(5747)] = 148213,
  [SMALL_STATE(5748)] = 148348,
  [SMALL_STATE(5749)] = 148429,
  [SMALL_STATE(5750)] = 148510,
  [SMALL_STATE(5751)] = 148591,
  [SMALL_STATE(5752)] = 148672,
  [SMALL_STATE(5753)] = 148753,
  [SMALL_STATE(5754)] = 148834,
  [SMALL_STATE(5755)] = 148915,
  [SMALL_STATE(5756)] = 149050,
  [SMALL_STATE(5757)] = 149131,
  [SMALL_STATE(5758)] = 149212,
  [SMALL_STATE(5759)] = 149293,
  [SMALL_STATE(5760)] = 149428,
  [SMALL_STATE(5761)] = 149511,
  [SMALL_STATE(5762)] = 149592,
  [SMALL_STATE(5763)] = 149727,
  [SMALL_STATE(5764)] = 149808,
  [SMALL_STATE(5765)] = 149889,
  [SMALL_STATE(5766)] = 149970,
  [SMALL_STATE(5767)] = 150105,
  [SMALL_STATE(5768)] = 150190,
  [SMALL_STATE(5769)] = 150325,
  [SMALL_STATE(5770)] = 150460,
  [SMALL_STATE(5771)] = 150595,
  [SMALL_STATE(5772)] = 150730,
  [SMALL_STATE(5773)] = 150811,
  [SMALL_STATE(5774)] = 150946,
  [SMALL_STATE(5775)] = 151027,
  [SMALL_STATE(5776)] = 151124,
  [SMALL_STATE(5777)] = 151205,
  [SMALL_STATE(5778)] = 151286,
  [SMALL_STATE(5779)] = 151421,
  [SMALL_STATE(5780)] = 151502,
  [SMALL_STATE(5781)] = 151583,
  [SMALL_STATE(5782)] = 151718,
  [SMALL_STATE(5783)] = 151826,
  [SMALL_STATE(5784)] = 151928,
  [SMALL_STATE(5785)] = 152010,
  [SMALL_STATE(5786)] = 152144,
  [SMALL_STATE(5787)] = 152252,
  [SMALL_STATE(5788)] = 152360,
  [SMALL_STATE(5789)] = 152498,
  [SMALL_STATE(5790)] = 152636,
  [SMALL_STATE(5791)] = 152744,
  [SMALL_STATE(5792)] = 152878,
  [SMALL_STATE(5793)] = 153012,
  [SMALL_STATE(5794)] = 153110,
  [SMALL_STATE(5795)] = 153244,
  [SMALL_STATE(5796)] = 153378,
  [SMALL_STATE(5797)] = 153508,
  [SMALL_STATE(5798)] = 153636,
  [SMALL_STATE(5799)] = 153756,
  [SMALL_STATE(5800)] = 153864,
  [SMALL_STATE(5801)] = 153986,
  [SMALL_STATE(5802)] = 154112,
  [SMALL_STATE(5803)] = 154236,
  [SMALL_STATE(5804)] = 154342,
  [SMALL_STATE(5805)] = 154454,
  [SMALL_STATE(5806)] = 154588,
  [SMALL_STATE(5807)] = 154722,
  [SMALL_STATE(5808)] = 154856,
  [SMALL_STATE(5809)] = 154964,
  [SMALL_STATE(5810)] = 155098,
  [SMALL_STATE(5811)] = 155236,
  [SMALL_STATE(5812)] = 155370,
  [SMALL_STATE(5813)] = 155504,
  [SMALL_STATE(5814)] = 155638,
  [SMALL_STATE(5815)] = 155772,
  [SMALL_STATE(5816)] = 155906,
  [SMALL_STATE(5817)] = 156014,
  [SMALL_STATE(5818)] = 156148,
  [SMALL_STATE(5819)] = 156282,
  [SMALL_STATE(5820)] = 156420,
  [SMALL_STATE(5821)] = 156528,
  [SMALL_STATE(5822)] = 156640,
  [SMALL_STATE(5823)] = 156774,
  [SMALL_STATE(5824)] = 156910,
  [SMALL_STATE(5825)] = 157016,
  [SMALL_STATE(5826)] = 157118,
  [SMALL_STATE(5827)] = 157242,
  [SMALL_STATE(5828)] = 157368,
  [SMALL_STATE(5829)] = 157490,
  [SMALL_STATE(5830)] = 157598,
  [SMALL_STATE(5831)] = 157718,
  [SMALL_STATE(5832)] = 157856,
  [SMALL_STATE(5833)] = 157954,
  [SMALL_STATE(5834)] = 158082,
  [SMALL_STATE(5835)] = 158212,
  [SMALL_STATE(5836)] = 158346,
  [SMALL_STATE(5837)] = 158480,
  [SMALL_STATE(5838)] = 158564,
  [SMALL_STATE(5839)] = 158644,
  [SMALL_STATE(5840)] = 158728,
  [SMALL_STATE(5841)] = 158830,
  [SMALL_STATE(5842)] = 158964,
  [SMALL_STATE(5843)] = 159098,
  [SMALL_STATE(5844)] = 159232,
  [SMALL_STATE(5845)] = 159366,
  [SMALL_STATE(5846)] = 159464,
  [SMALL_STATE(5847)] = 159572,
  [SMALL_STATE(5848)] = 159706,
  [SMALL_STATE(5849)] = 159844,
  [SMALL_STATE(5850)] = 159978,
  [SMALL_STATE(5851)] = 160116,
  [SMALL_STATE(5852)] = 160200,
  [SMALL_STATE(5853)] = 160298,
  [SMALL_STATE(5854)] = 160436,
  [SMALL_STATE(5855)] = 160544,
  [SMALL_STATE(5856)] = 160678,
  [SMALL_STATE(5857)] = 160812,
  [SMALL_STATE(5858)] = 160950,
  [SMALL_STATE(5859)] = 161084,
  [SMALL_STATE(5860)] = 161218,
  [SMALL_STATE(5861)] = 161316,
  [SMALL_STATE(5862)] = 161450,
  [SMALL_STATE(5863)] = 161584,
  [SMALL_STATE(5864)] = 161718,
  [SMALL_STATE(5865)] = 161852,
  [SMALL_STATE(5866)] = 161986,
  [SMALL_STATE(5867)] = 162094,
  [SMALL_STATE(5868)] = 162228,
  [SMALL_STATE(5869)] = 162362,
  [SMALL_STATE(5870)] = 162496,
  [SMALL_STATE(5871)] = 162598,
  [SMALL_STATE(5872)] = 162732,
  [SMALL_STATE(5873)] = 162870,
  [SMALL_STATE(5874)] = 163004,
  [SMALL_STATE(5875)] = 163138,
  [SMALL_STATE(5876)] = 163272,
  [SMALL_STATE(5877)] = 163406,
  [SMALL_STATE(5878)] = 163540,
  [SMALL_STATE(5879)] = 163638,
  [SMALL_STATE(5880)] = 163776,
  [SMALL_STATE(5881)] = 163910,
  [SMALL_STATE(5882)] = 164044,
  [SMALL_STATE(5883)] = 164178,
  [SMALL_STATE(5884)] = 164286,
  [SMALL_STATE(5885)] = 164424,
  [SMALL_STATE(5886)] = 164532,
  [SMALL_STATE(5887)] = 164666,
  [SMALL_STATE(5888)] = 164800,
  [SMALL_STATE(5889)] = 164912,
  [SMALL_STATE(5890)] = 165018,
  [SMALL_STATE(5891)] = 165142,
  [SMALL_STATE(5892)] = 165268,
  [SMALL_STATE(5893)] = 165376,
  [SMALL_STATE(5894)] = 165498,
  [SMALL_STATE(5895)] = 165606,
  [SMALL_STATE(5896)] = 165712,
  [SMALL_STATE(5897)] = 165846,
  [SMALL_STATE(5898)] = 165944,
  [SMALL_STATE(5899)] = 166052,
  [SMALL_STATE(5900)] = 166136,
  [SMALL_STATE(5901)] = 166256,
  [SMALL_STATE(5902)] = 166386,
  [SMALL_STATE(5903)] = 166484,
  [SMALL_STATE(5904)] = 166622,
  [SMALL_STATE(5905)] = 166750,
  [SMALL_STATE(5906)] = 166884,
  [SMALL_STATE(5907)] = 166966,
  [SMALL_STATE(5908)] = 167094,
  [SMALL_STATE(5909)] = 167224,
  [SMALL_STATE(5910)] = 167308,
  [SMALL_STATE(5911)] = 167442,
  [SMALL_STATE(5912)] = 167576,
  [SMALL_STATE(5913)] = 167714,
  [SMALL_STATE(5914)] = 167834,
  [SMALL_STATE(5915)] = 167942,
  [SMALL_STATE(5916)] = 168076,
  [SMALL_STATE(5917)] = 168214,
  [SMALL_STATE(5918)] = 168294,
  [SMALL_STATE(5919)] = 168392,
  [SMALL_STATE(5920)] = 168526,
  [SMALL_STATE(5921)] = 168660,
  [SMALL_STATE(5922)] = 168794,
  [SMALL_STATE(5923)] = 168928,
  [SMALL_STATE(5924)] = 169062,
  [SMALL_STATE(5925)] = 169184,
  [SMALL_STATE(5926)] = 169318,
  [SMALL_STATE(5927)] = 169424,
  [SMALL_STATE(5928)] = 169562,
  [SMALL_STATE(5929)] = 169700,
  [SMALL_STATE(5930)] = 169838,
  [SMALL_STATE(5931)] = 169972,
  [SMALL_STATE(5932)] = 170056,
  [SMALL_STATE(5933)] = 170190,
  [SMALL_STATE(5934)] = 170324,
  [SMALL_STATE(5935)] = 170408,
  [SMALL_STATE(5936)] = 170534,
  [SMALL_STATE(5937)] = 170668,
  [SMALL_STATE(5938)] = 170802,
  [SMALL_STATE(5939)] = 170936,
  [SMALL_STATE(5940)] = 171074,
  [SMALL_STATE(5941)] = 171212,
  [SMALL_STATE(5942)] = 171346,
  [SMALL_STATE(5943)] = 171470,
  [SMALL_STATE(5944)] = 171578,
  [SMALL_STATE(5945)] = 171712,
  [SMALL_STATE(5946)] = 171850,
  [SMALL_STATE(5947)] = 171984,
  [SMALL_STATE(5948)] = 172086,
  [SMALL_STATE(5949)] = 172220,
  [SMALL_STATE(5950)] = 172304,
  [SMALL_STATE(5951)] = 172412,
  [SMALL_STATE(5952)] = 172546,
  [SMALL_STATE(5953)] = 172676,
  [SMALL_STATE(5954)] = 172804,
  [SMALL_STATE(5955)] = 172938,
  [SMALL_STATE(5956)] = 173058,
  [SMALL_STATE(5957)] = 173170,
  [SMALL_STATE(5958)] = 173278,
  [SMALL_STATE(5959)] = 173412,
  [SMALL_STATE(5960)] = 173546,
  [SMALL_STATE(5961)] = 173630,
  [SMALL_STATE(5962)] = 173764,
  [SMALL_STATE(5963)] = 173898,
  [SMALL_STATE(5964)] = 174032,
  [SMALL_STATE(5965)] = 174166,
  [SMALL_STATE(5966)] = 174248,
  [SMALL_STATE(5967)] = 174382,
  [SMALL_STATE(5968)] = 174490,
  [SMALL_STATE(5969)] = 174624,
  [SMALL_STATE(5970)] = 174758,
  [SMALL_STATE(5971)] = 174856,
  [SMALL_STATE(5972)] = 174990,
  [SMALL_STATE(5973)] = 175124,
  [SMALL_STATE(5974)] = 175208,
  [SMALL_STATE(5975)] = 175330,
  [SMALL_STATE(5976)] = 175468,
  [SMALL_STATE(5977)] = 175594,
  [SMALL_STATE(5978)] = 175678,
  [SMALL_STATE(5979)] = 175802,
  [SMALL_STATE(5980)] = 175908,
  [SMALL_STATE(5981)] = 176042,
  [SMALL_STATE(5982)] = 176154,
  [SMALL_STATE(5983)] = 176238,
  [SMALL_STATE(5984)] = 176336,
  [SMALL_STATE(5985)] = 176474,
  [SMALL_STATE(5986)] = 176612,
  [SMALL_STATE(5987)] = 176720,
  [SMALL_STATE(5988)] = 176858,
  [SMALL_STATE(5989)] = 176992,
  [SMALL_STATE(5990)] = 177130,
  [SMALL_STATE(5991)] = 177268,
  [SMALL_STATE(5992)] = 177352,
  [SMALL_STATE(5993)] = 177486,
  [SMALL_STATE(5994)] = 177622,
  [SMALL_STATE(5995)] = 177756,
  [SMALL_STATE(5996)] = 177838,
  [SMALL_STATE(5997)] = 177920,
  [SMALL_STATE(5998)] = 178058,
  [SMALL_STATE(5999)] = 178196,
  [SMALL_STATE(6000)] = 178334,
  [SMALL_STATE(6001)] = 178422,
  [SMALL_STATE(6002)] = 178556,
  [SMALL_STATE(6003)] = 178640,
  [SMALL_STATE(6004)] = 178778,
  [SMALL_STATE(6005)] = 178916,
  [SMALL_STATE(6006)] = 179028,
  [SMALL_STATE(6007)] = 179162,
  [SMALL_STATE(6008)] = 179298,
  [SMALL_STATE(6009)] = 179382,
  [SMALL_STATE(6010)] = 179520,
  [SMALL_STATE(6011)] = 179628,
  [SMALL_STATE(6012)] = 179766,
  [SMALL_STATE(6013)] = 179850,
  [SMALL_STATE(6014)] = 179984,
  [SMALL_STATE(6015)] = 180122,
  [SMALL_STATE(6016)] = 180256,
  [SMALL_STATE(6017)] = 180362,
  [SMALL_STATE(6018)] = 180470,
  [SMALL_STATE(6019)] = 180568,
  [SMALL_STATE(6020)] = 180702,
  [SMALL_STATE(6021)] = 180836,
  [SMALL_STATE(6022)] = 180942,
  [SMALL_STATE(6023)] = 181076,
  [SMALL_STATE(6024)] = 181184,
  [SMALL_STATE(6025)] = 181286,
  [SMALL_STATE(6026)] = 181410,
  [SMALL_STATE(6027)] = 181544,
  [SMALL_STATE(6028)] = 181670,
  [SMALL_STATE(6029)] = 181804,
  [SMALL_STATE(6030)] = 181938,
  [SMALL_STATE(6031)] = 182036,
  [SMALL_STATE(6032)] = 182158,
  [SMALL_STATE(6033)] = 182292,
  [SMALL_STATE(6034)] = 182426,
  [SMALL_STATE(6035)] = 182510,
  [SMALL_STATE(6036)] = 182592,
  [SMALL_STATE(6037)] = 182730,
  [SMALL_STATE(6038)] = 182814,
  [SMALL_STATE(6039)] = 182898,
  [SMALL_STATE(6040)] = 182982,
  [SMALL_STATE(6041)] = 183080,
  [SMALL_STATE(6042)] = 183214,
  [SMALL_STATE(6043)] = 183322,
  [SMALL_STATE(6044)] = 183456,
  [SMALL_STATE(6045)] = 183558,
  [SMALL_STATE(6046)] = 183666,
  [SMALL_STATE(6047)] = 183786,
  [SMALL_STATE(6048)] = 183894,
  [SMALL_STATE(6049)] = 183992,
  [SMALL_STATE(6050)] = 184130,
  [SMALL_STATE(6051)] = 184268,
  [SMALL_STATE(6052)] = 184402,
  [SMALL_STATE(6053)] = 184500,
  [SMALL_STATE(6054)] = 184634,
  [SMALL_STATE(6055)] = 184762,
  [SMALL_STATE(6056)] = 184850,
  [SMALL_STATE(6057)] = 184984,
  [SMALL_STATE(6058)] = 185114,
  [SMALL_STATE(6059)] = 185248,
  [SMALL_STATE(6060)] = 185382,
  [SMALL_STATE(6061)] = 185516,
  [SMALL_STATE(6062)] = 185650,
  [SMALL_STATE(6063)] = 185784,
  [SMALL_STATE(6064)] = 185896,
  [SMALL_STATE(6065)] = 186030,
  [SMALL_STATE(6066)] = 186136,
  [SMALL_STATE(6067)] = 186270,
  [SMALL_STATE(6068)] = 186394,
  [SMALL_STATE(6069)] = 186520,
  [SMALL_STATE(6070)] = 186642,
  [SMALL_STATE(6071)] = 186776,
  [SMALL_STATE(6072)] = 186906,
  [SMALL_STATE(6073)] = 187034,
  [SMALL_STATE(6074)] = 187154,
  [SMALL_STATE(6075)] = 187262,
  [SMALL_STATE(6076)] = 187384,
  [SMALL_STATE(6077)] = 187510,
  [SMALL_STATE(6078)] = 187634,
  [SMALL_STATE(6079)] = 187740,
  [SMALL_STATE(6080)] = 187852,
  [SMALL_STATE(6081)] = 187986,
  [SMALL_STATE(6082)] = 188098,
  [SMALL_STATE(6083)] = 188204,
  [SMALL_STATE(6084)] = 188342,
  [SMALL_STATE(6085)] = 188444,
  [SMALL_STATE(6086)] = 188568,
  [SMALL_STATE(6087)] = 188694,
  [SMALL_STATE(6088)] = 188816,
  [SMALL_STATE(6089)] = 188924,
  [SMALL_STATE(6090)] = 189062,
  [SMALL_STATE(6091)] = 189196,
  [SMALL_STATE(6092)] = 189316,
  [SMALL_STATE(6093)] = 189444,
  [SMALL_STATE(6094)] = 189564,
  [SMALL_STATE(6095)] = 189648,
  [SMALL_STATE(6096)] = 189732,
  [SMALL_STATE(6097)] = 189862,
  [SMALL_STATE(6098)] = 189996,
  [SMALL_STATE(6099)] = 190080,
  [SMALL_STATE(6100)] = 190162,
  [SMALL_STATE(6101)] = 190246,
  [SMALL_STATE(6102)] = 190328,
  [SMALL_STATE(6103)] = 190436,
  [SMALL_STATE(6104)] = 190570,
  [SMALL_STATE(6105)] = 190698,
  [SMALL_STATE(6106)] = 190796,
  [SMALL_STATE(6107)] = 190930,
  [SMALL_STATE(6108)] = 191068,
  [SMALL_STATE(6109)] = 191166,
  [SMALL_STATE(6110)] = 191268,
  [SMALL_STATE(6111)] = 191402,
  [SMALL_STATE(6112)] = 191510,
  [SMALL_STATE(6113)] = 191592,
  [SMALL_STATE(6114)] = 191730,
  [SMALL_STATE(6115)] = 191838,
  [SMALL_STATE(6116)] = 191968,
  [SMALL_STATE(6117)] = 192102,
  [SMALL_STATE(6118)] = 192235,
  [SMALL_STATE(6119)] = 192368,
  [SMALL_STATE(6120)] = 192491,
  [SMALL_STATE(6121)] = 192616,
  [SMALL_STATE(6122)] = 192749,
  [SMALL_STATE(6123)] = 192870,
  [SMALL_STATE(6124)] = 193003,
  [SMALL_STATE(6125)] = 193122,
  [SMALL_STATE(6126)] = 193255,
  [SMALL_STATE(6127)] = 193388,
  [SMALL_STATE(6128)] = 193521,
  [SMALL_STATE(6129)] = 193650,
  [SMALL_STATE(6130)] = 193783,
  [SMALL_STATE(6131)] = 193864,
  [SMALL_STATE(6132)] = 193945,
  [SMALL_STATE(6133)] = 194080,
  [SMALL_STATE(6134)] = 194213,
  [SMALL_STATE(6135)] = 194346,
  [SMALL_STATE(6136)] = 194479,
  [SMALL_STATE(6137)] = 194612,
  [SMALL_STATE(6138)] = 194745,
  [SMALL_STATE(6139)] = 194840,
  [SMALL_STATE(6140)] = 194921,
  [SMALL_STATE(6141)] = 195054,
  [SMALL_STATE(6142)] = 195187,
  [SMALL_STATE(6143)] = 195320,
  [SMALL_STATE(6144)] = 195407,
  [SMALL_STATE(6145)] = 195540,
  [SMALL_STATE(6146)] = 195673,
  [SMALL_STATE(6147)] = 195754,
  [SMALL_STATE(6148)] = 195851,
  [SMALL_STATE(6149)] = 195978,
  [SMALL_STATE(6150)] = 196073,
  [SMALL_STATE(6151)] = 196154,
  [SMALL_STATE(6152)] = 196237,
  [SMALL_STATE(6153)] = 196320,
  [SMALL_STATE(6154)] = 196415,
  [SMALL_STATE(6155)] = 196548,
  [SMALL_STATE(6156)] = 196681,
  [SMALL_STATE(6157)] = 196778,
  [SMALL_STATE(6158)] = 196873,
  [SMALL_STATE(6159)] = 196956,
  [SMALL_STATE(6160)] = 197039,
  [SMALL_STATE(6161)] = 197122,
  [SMALL_STATE(6162)] = 197257,
  [SMALL_STATE(6163)] = 197390,
  [SMALL_STATE(6164)] = 197517,
  [SMALL_STATE(6165)] = 197650,
  [SMALL_STATE(6166)] = 197783,
  [SMALL_STATE(6167)] = 197866,
  [SMALL_STATE(6168)] = 197971,
  [SMALL_STATE(6169)] = 198104,
  [SMALL_STATE(6170)] = 198237,
  [SMALL_STATE(6171)] = 198366,
  [SMALL_STATE(6172)] = 198467,
  [SMALL_STATE(6173)] = 198586,
  [SMALL_STATE(6174)] = 198693,
  [SMALL_STATE(6175)] = 198814,
  [SMALL_STATE(6176)] = 198939,
  [SMALL_STATE(6177)] = 199062,
  [SMALL_STATE(6178)] = 199195,
  [SMALL_STATE(6179)] = 199300,
  [SMALL_STATE(6180)] = 199411,
  [SMALL_STATE(6181)] = 199544,
  [SMALL_STATE(6182)] = 199677,
  [SMALL_STATE(6183)] = 199810,
  [SMALL_STATE(6184)] = 199943,
  [SMALL_STATE(6185)] = 200076,
  [SMALL_STATE(6186)] = 200209,
  [SMALL_STATE(6187)] = 200342,
  [SMALL_STATE(6188)] = 200475,
  [SMALL_STATE(6189)] = 200608,
  [SMALL_STATE(6190)] = 200741,
  [SMALL_STATE(6191)] = 200874,
  [SMALL_STATE(6192)] = 201007,
  [SMALL_STATE(6193)] = 201140,
  [SMALL_STATE(6194)] = 201223,
  [SMALL_STATE(6195)] = 201356,
  [SMALL_STATE(6196)] = 201489,
  [SMALL_STATE(6197)] = 201570,
  [SMALL_STATE(6198)] = 201703,
  [SMALL_STATE(6199)] = 201836,
  [SMALL_STATE(6200)] = 201933,
  [SMALL_STATE(6201)] = 202066,
  [SMALL_STATE(6202)] = 202177,
  [SMALL_STATE(6203)] = 202282,
  [SMALL_STATE(6204)] = 202383,
  [SMALL_STATE(6205)] = 202516,
  [SMALL_STATE(6206)] = 202611,
  [SMALL_STATE(6207)] = 202734,
  [SMALL_STATE(6208)] = 202859,
  [SMALL_STATE(6209)] = 202980,
  [SMALL_STATE(6210)] = 203087,
  [SMALL_STATE(6211)] = 203182,
  [SMALL_STATE(6212)] = 203301,
  [SMALL_STATE(6213)] = 203428,
  [SMALL_STATE(6214)] = 203557,
  [SMALL_STATE(6215)] = 203690,
  [SMALL_STATE(6216)] = 203785,
  [SMALL_STATE(6217)] = 203918,
  [SMALL_STATE(6218)] = 204013,
  [SMALL_STATE(6219)] = 204108,
  [SMALL_STATE(6220)] = 204203,
  [SMALL_STATE(6221)] = 204336,
  [SMALL_STATE(6222)] = 204469,
  [SMALL_STATE(6223)] = 204564,
  [SMALL_STATE(6224)] = 204697,
  [SMALL_STATE(6225)] = 204794,
  [SMALL_STATE(6226)] = 204891,
  [SMALL_STATE(6227)] = 205024,
  [SMALL_STATE(6228)] = 205119,
  [SMALL_STATE(6229)] = 205202,
  [SMALL_STATE(6230)] = 205335,
  [SMALL_STATE(6231)] = 205468,
  [SMALL_STATE(6232)] = 205563,
  [SMALL_STATE(6233)] = 205646,
  [SMALL_STATE(6234)] = 205775,
  [SMALL_STATE(6235)] = 205908,
  [SMALL_STATE(6236)] = 206035,
  [SMALL_STATE(6237)] = 206154,
  [SMALL_STATE(6238)] = 206261,
  [SMALL_STATE(6239)] = 206356,
  [SMALL_STATE(6240)] = 206477,
  [SMALL_STATE(6241)] = 206602,
  [SMALL_STATE(6242)] = 206725,
  [SMALL_STATE(6243)] = 206826,
  [SMALL_STATE(6244)] = 206931,
  [SMALL_STATE(6245)] = 207042,
  [SMALL_STATE(6246)] = 207137,
  [SMALL_STATE(6247)] = 207232,
  [SMALL_STATE(6248)] = 207367,
  [SMALL_STATE(6249)] = 207450,
  [SMALL_STATE(6250)] = 207531,
  [SMALL_STATE(6251)] = 207664,
  [SMALL_STATE(6252)] = 207775,
  [SMALL_STATE(6253)] = 207908,
  [SMALL_STATE(6254)] = 208041,
  [SMALL_STATE(6255)] = 208174,
  [SMALL_STATE(6256)] = 208307,
  [SMALL_STATE(6257)] = 208440,
  [SMALL_STATE(6258)] = 208573,
  [SMALL_STATE(6259)] = 208706,
  [SMALL_STATE(6260)] = 208789,
  [SMALL_STATE(6261)] = 208884,
  [SMALL_STATE(6262)] = 209017,
  [SMALL_STATE(6263)] = 209150,
  [SMALL_STATE(6264)] = 209245,
  [SMALL_STATE(6265)] = 209378,
  [SMALL_STATE(6266)] = 209475,
  [SMALL_STATE(6267)] = 209558,
  [SMALL_STATE(6268)] = 209691,
  [SMALL_STATE(6269)] = 209796,
  [SMALL_STATE(6270)] = 209931,
  [SMALL_STATE(6271)] = 210020,
  [SMALL_STATE(6272)] = 210117,
  [SMALL_STATE(6273)] = 210250,
  [SMALL_STATE(6274)] = 210345,
  [SMALL_STATE(6275)] = 210480,
  [SMALL_STATE(6276)] = 210561,
  [SMALL_STATE(6277)] = 210666,
  [SMALL_STATE(6278)] = 210799,
  [SMALL_STATE(6279)] = 210932,
  [SMALL_STATE(6280)] = 211027,
  [SMALL_STATE(6281)] = 211122,
  [SMALL_STATE(6282)] = 211217,
  [SMALL_STATE(6283)] = 211350,
  [SMALL_STATE(6284)] = 211455,
  [SMALL_STATE(6285)] = 211550,
  [SMALL_STATE(6286)] = 211631,
  [SMALL_STATE(6287)] = 211720,
  [SMALL_STATE(6288)] = 211803,
  [SMALL_STATE(6289)] = 211936,
  [SMALL_STATE(6290)] = 212069,
  [SMALL_STATE(6291)] = 212150,
  [SMALL_STATE(6292)] = 212245,
  [SMALL_STATE(6293)] = 212344,
  [SMALL_STATE(6294)] = 212425,
  [SMALL_STATE(6295)] = 212520,
  [SMALL_STATE(6296)] = 212653,
  [SMALL_STATE(6297)] = 212748,
  [SMALL_STATE(6298)] = 212843,
  [SMALL_STATE(6299)] = 212976,
  [SMALL_STATE(6300)] = 213075,
  [SMALL_STATE(6301)] = 213172,
  [SMALL_STATE(6302)] = 213279,
  [SMALL_STATE(6303)] = 213380,
  [SMALL_STATE(6304)] = 213513,
  [SMALL_STATE(6305)] = 213618,
  [SMALL_STATE(6306)] = 213750,
  [SMALL_STATE(6307)] = 213868,
  [SMALL_STATE(6308)] = 213950,
  [SMALL_STATE(6309)] = 214082,
  [SMALL_STATE(6310)] = 214214,
  [SMALL_STATE(6311)] = 214346,
  [SMALL_STATE(6312)] = 214478,
  [SMALL_STATE(6313)] = 214574,
  [SMALL_STATE(6314)] = 214706,
  [SMALL_STATE(6315)] = 214838,
  [SMALL_STATE(6316)] = 214970,
  [SMALL_STATE(6317)] = 215102,
  [SMALL_STATE(6318)] = 215234,
  [SMALL_STATE(6319)] = 215366,
  [SMALL_STATE(6320)] = 215498,
  [SMALL_STATE(6321)] = 215630,
  [SMALL_STATE(6322)] = 215710,
  [SMALL_STATE(6323)] = 215842,
  [SMALL_STATE(6324)] = 215974,
  [SMALL_STATE(6325)] = 216106,
  [SMALL_STATE(6326)] = 216206,
  [SMALL_STATE(6327)] = 216338,
  [SMALL_STATE(6328)] = 216470,
  [SMALL_STATE(6329)] = 216602,
  [SMALL_STATE(6330)] = 216734,
  [SMALL_STATE(6331)] = 216866,
  [SMALL_STATE(6332)] = 216998,
  [SMALL_STATE(6333)] = 217130,
  [SMALL_STATE(6334)] = 217262,
  [SMALL_STATE(6335)] = 217394,
  [SMALL_STATE(6336)] = 217526,
  [SMALL_STATE(6337)] = 217658,
  [SMALL_STATE(6338)] = 217790,
  [SMALL_STATE(6339)] = 217922,
  [SMALL_STATE(6340)] = 218032,
  [SMALL_STATE(6341)] = 218164,
  [SMALL_STATE(6342)] = 218296,
  [SMALL_STATE(6343)] = 218428,
  [SMALL_STATE(6344)] = 218560,
  [SMALL_STATE(6345)] = 218692,
  [SMALL_STATE(6346)] = 218824,
  [SMALL_STATE(6347)] = 218956,
  [SMALL_STATE(6348)] = 219088,
  [SMALL_STATE(6349)] = 219220,
  [SMALL_STATE(6350)] = 219352,
  [SMALL_STATE(6351)] = 219484,
  [SMALL_STATE(6352)] = 219616,
  [SMALL_STATE(6353)] = 219748,
  [SMALL_STATE(6354)] = 219848,
  [SMALL_STATE(6355)] = 219980,
  [SMALL_STATE(6356)] = 220084,
  [SMALL_STATE(6357)] = 220184,
  [SMALL_STATE(6358)] = 220316,
  [SMALL_STATE(6359)] = 220448,
  [SMALL_STATE(6360)] = 220580,
  [SMALL_STATE(6361)] = 220712,
  [SMALL_STATE(6362)] = 220834,
  [SMALL_STATE(6363)] = 220958,
  [SMALL_STATE(6364)] = 221078,
  [SMALL_STATE(6365)] = 221210,
  [SMALL_STATE(6366)] = 221342,
  [SMALL_STATE(6367)] = 221424,
  [SMALL_STATE(6368)] = 221556,
  [SMALL_STATE(6369)] = 221636,
  [SMALL_STATE(6370)] = 221768,
  [SMALL_STATE(6371)] = 221900,
  [SMALL_STATE(6372)] = 222032,
  [SMALL_STATE(6373)] = 222138,
  [SMALL_STATE(6374)] = 222220,
  [SMALL_STATE(6375)] = 222352,
  [SMALL_STATE(6376)] = 222480,
  [SMALL_STATE(6377)] = 222606,
  [SMALL_STATE(6378)] = 222702,
  [SMALL_STATE(6379)] = 222820,
  [SMALL_STATE(6380)] = 222926,
  [SMALL_STATE(6381)] = 223046,
  [SMALL_STATE(6382)] = 223170,
  [SMALL_STATE(6383)] = 223252,
  [SMALL_STATE(6384)] = 223374,
  [SMALL_STATE(6385)] = 223474,
  [SMALL_STATE(6386)] = 223578,
  [SMALL_STATE(6387)] = 223710,
  [SMALL_STATE(6388)] = 223804,
  [SMALL_STATE(6389)] = 223914,
  [SMALL_STATE(6390)] = 224046,
  [SMALL_STATE(6391)] = 224178,
  [SMALL_STATE(6392)] = 224260,
  [SMALL_STATE(6393)] = 224392,
  [SMALL_STATE(6394)] = 224474,
  [SMALL_STATE(6395)] = 224606,
  [SMALL_STATE(6396)] = 224724,
  [SMALL_STATE(6397)] = 224808,
  [SMALL_STATE(6398)] = 224940,
  [SMALL_STATE(6399)] = 225072,
  [SMALL_STATE(6400)] = 225154,
  [SMALL_STATE(6401)] = 225234,
  [SMALL_STATE(6402)] = 225330,
  [SMALL_STATE(6403)] = 225456,
  [SMALL_STATE(6404)] = 225588,
  [SMALL_STATE(6405)] = 225720,
  [SMALL_STATE(6406)] = 225852,
  [SMALL_STATE(6407)] = 225984,
  [SMALL_STATE(6408)] = 226066,
  [SMALL_STATE(6409)] = 226198,
  [SMALL_STATE(6410)] = 226330,
  [SMALL_STATE(6411)] = 226426,
  [SMALL_STATE(6412)] = 226522,
  [SMALL_STATE(6413)] = 226654,
  [SMALL_STATE(6414)] = 226786,
  [SMALL_STATE(6415)] = 226918,
  [SMALL_STATE(6416)] = 227050,
  [SMALL_STATE(6417)] = 227178,
  [SMALL_STATE(6418)] = 227310,
  [SMALL_STATE(6419)] = 227442,
  [SMALL_STATE(6420)] = 227542,
  [SMALL_STATE(6421)] = 227674,
  [SMALL_STATE(6422)] = 227756,
  [SMALL_STATE(6423)] = 227888,
  [SMALL_STATE(6424)] = 228020,
  [SMALL_STATE(6425)] = 228102,
  [SMALL_STATE(6426)] = 228234,
  [SMALL_STATE(6427)] = 228314,
  [SMALL_STATE(6428)] = 228396,
  [SMALL_STATE(6429)] = 228528,
  [SMALL_STATE(6430)] = 228660,
  [SMALL_STATE(6431)] = 228792,
  [SMALL_STATE(6432)] = 228924,
  [SMALL_STATE(6433)] = 229056,
  [SMALL_STATE(6434)] = 229138,
  [SMALL_STATE(6435)] = 229270,
  [SMALL_STATE(6436)] = 229402,
  [SMALL_STATE(6437)] = 229482,
  [SMALL_STATE(6438)] = 229614,
  [SMALL_STATE(6439)] = 229746,
  [SMALL_STATE(6440)] = 229878,
  [SMALL_STATE(6441)] = 230010,
  [SMALL_STATE(6442)] = 230142,
  [SMALL_STATE(6443)] = 230274,
  [SMALL_STATE(6444)] = 230406,
  [SMALL_STATE(6445)] = 230538,
  [SMALL_STATE(6446)] = 230670,
  [SMALL_STATE(6447)] = 230802,
  [SMALL_STATE(6448)] = 230934,
  [SMALL_STATE(6449)] = 231066,
  [SMALL_STATE(6450)] = 231198,
  [SMALL_STATE(6451)] = 231294,
  [SMALL_STATE(6452)] = 231376,
  [SMALL_STATE(6453)] = 231508,
  [SMALL_STATE(6454)] = 231640,
  [SMALL_STATE(6455)] = 231722,
  [SMALL_STATE(6456)] = 231854,
  [SMALL_STATE(6457)] = 231986,
  [SMALL_STATE(6458)] = 232082,
  [SMALL_STATE(6459)] = 232162,
  [SMALL_STATE(6460)] = 232244,
  [SMALL_STATE(6461)] = 232376,
  [SMALL_STATE(6462)] = 232508,
  [SMALL_STATE(6463)] = 232640,
  [SMALL_STATE(6464)] = 232772,
  [SMALL_STATE(6465)] = 232904,
  [SMALL_STATE(6466)] = 233000,
  [SMALL_STATE(6467)] = 233132,
  [SMALL_STATE(6468)] = 233264,
  [SMALL_STATE(6469)] = 233344,
  [SMALL_STATE(6470)] = 233476,
  [SMALL_STATE(6471)] = 233556,
  [SMALL_STATE(6472)] = 233688,
  [SMALL_STATE(6473)] = 233820,
  [SMALL_STATE(6474)] = 233916,
  [SMALL_STATE(6475)] = 234004,
  [SMALL_STATE(6476)] = 234136,
  [SMALL_STATE(6477)] = 234268,
  [SMALL_STATE(6478)] = 234350,
  [SMALL_STATE(6479)] = 234430,
  [SMALL_STATE(6480)] = 234512,
  [SMALL_STATE(6481)] = 234618,
  [SMALL_STATE(6482)] = 234750,
  [SMALL_STATE(6483)] = 234882,
  [SMALL_STATE(6484)] = 235014,
  [SMALL_STATE(6485)] = 235146,
  [SMALL_STATE(6486)] = 235278,
  [SMALL_STATE(6487)] = 235410,
  [SMALL_STATE(6488)] = 235510,
  [SMALL_STATE(6489)] = 235642,
  [SMALL_STATE(6490)] = 235774,
  [SMALL_STATE(6491)] = 235906,
  [SMALL_STATE(6492)] = 236010,
  [SMALL_STATE(6493)] = 236142,
  [SMALL_STATE(6494)] = 236274,
  [SMALL_STATE(6495)] = 236406,
  [SMALL_STATE(6496)] = 236486,
  [SMALL_STATE(6497)] = 236568,
  [SMALL_STATE(6498)] = 236678,
  [SMALL_STATE(6499)] = 236760,
  [SMALL_STATE(6500)] = 236892,
  [SMALL_STATE(6501)] = 237024,
  [SMALL_STATE(6502)] = 237156,
  [SMALL_STATE(6503)] = 237288,
  [SMALL_STATE(6504)] = 237370,
  [SMALL_STATE(6505)] = 237502,
  [SMALL_STATE(6506)] = 237634,
  [SMALL_STATE(6507)] = 237766,
  [SMALL_STATE(6508)] = 237846,
  [SMALL_STATE(6509)] = 237978,
  [SMALL_STATE(6510)] = 238088,
  [SMALL_STATE(6511)] = 238220,
  [SMALL_STATE(6512)] = 238352,
  [SMALL_STATE(6513)] = 238456,
  [SMALL_STATE(6514)] = 238556,
  [SMALL_STATE(6515)] = 238678,
  [SMALL_STATE(6516)] = 238802,
  [SMALL_STATE(6517)] = 238922,
  [SMALL_STATE(6518)] = 239028,
  [SMALL_STATE(6519)] = 239146,
  [SMALL_STATE(6520)] = 239278,
  [SMALL_STATE(6521)] = 239374,
  [SMALL_STATE(6522)] = 239500,
  [SMALL_STATE(6523)] = 239628,
  [SMALL_STATE(6524)] = 239760,
  [SMALL_STATE(6525)] = 239892,
  [SMALL_STATE(6526)] = 240024,
  [SMALL_STATE(6527)] = 240156,
  [SMALL_STATE(6528)] = 240288,
  [SMALL_STATE(6529)] = 240420,
  [SMALL_STATE(6530)] = 240552,
  [SMALL_STATE(6531)] = 240684,
  [SMALL_STATE(6532)] = 240788,
  [SMALL_STATE(6533)] = 240920,
  [SMALL_STATE(6534)] = 241020,
  [SMALL_STATE(6535)] = 241152,
  [SMALL_STATE(6536)] = 241284,
  [SMALL_STATE(6537)] = 241416,
  [SMALL_STATE(6538)] = 241538,
  [SMALL_STATE(6539)] = 241648,
  [SMALL_STATE(6540)] = 241780,
  [SMALL_STATE(6541)] = 241904,
  [SMALL_STATE(6542)] = 242036,
  [SMALL_STATE(6543)] = 242168,
  [SMALL_STATE(6544)] = 242300,
  [SMALL_STATE(6545)] = 242382,
  [SMALL_STATE(6546)] = 242514,
  [SMALL_STATE(6547)] = 242646,
  [SMALL_STATE(6548)] = 242778,
  [SMALL_STATE(6549)] = 242910,
  [SMALL_STATE(6550)] = 243042,
  [SMALL_STATE(6551)] = 243174,
  [SMALL_STATE(6552)] = 243302,
  [SMALL_STATE(6553)] = 243384,
  [SMALL_STATE(6554)] = 243464,
  [SMALL_STATE(6555)] = 243590,
  [SMALL_STATE(6556)] = 243722,
  [SMALL_STATE(6557)] = 243854,
  [SMALL_STATE(6558)] = 243986,
  [SMALL_STATE(6559)] = 244118,
  [SMALL_STATE(6560)] = 244214,
  [SMALL_STATE(6561)] = 244346,
  [SMALL_STATE(6562)] = 244464,
  [SMALL_STATE(6563)] = 244596,
  [SMALL_STATE(6564)] = 244716,
  [SMALL_STATE(6565)] = 244822,
  [SMALL_STATE(6566)] = 244942,
  [SMALL_STATE(6567)] = 245074,
  [SMALL_STATE(6568)] = 245206,
  [SMALL_STATE(6569)] = 245338,
  [SMALL_STATE(6570)] = 245470,
  [SMALL_STATE(6571)] = 245550,
  [SMALL_STATE(6572)] = 245674,
  [SMALL_STATE(6573)] = 245780,
  [SMALL_STATE(6574)] = 245912,
  [SMALL_STATE(6575)] = 246034,
  [SMALL_STATE(6576)] = 246166,
  [SMALL_STATE(6577)] = 246266,
  [SMALL_STATE(6578)] = 246370,
  [SMALL_STATE(6579)] = 246502,
  [SMALL_STATE(6580)] = 246634,
  [SMALL_STATE(6581)] = 246744,
  [SMALL_STATE(6582)] = 246876,
  [SMALL_STATE(6583)] = 247008,
  [SMALL_STATE(6584)] = 247140,
  [SMALL_STATE(6585)] = 247272,
  [SMALL_STATE(6586)] = 247404,
  [SMALL_STATE(6587)] = 247536,
  [SMALL_STATE(6588)] = 247668,
  [SMALL_STATE(6589)] = 247800,
  [SMALL_STATE(6590)] = 247932,
  [SMALL_STATE(6591)] = 248064,
  [SMALL_STATE(6592)] = 248196,
  [SMALL_STATE(6593)] = 248328,
  [SMALL_STATE(6594)] = 248446,
  [SMALL_STATE(6595)] = 248578,
  [SMALL_STATE(6596)] = 248710,
  [SMALL_STATE(6597)] = 248842,
  [SMALL_STATE(6598)] = 248974,
  [SMALL_STATE(6599)] = 249106,
  [SMALL_STATE(6600)] = 249202,
  [SMALL_STATE(6601)] = 249334,
  [SMALL_STATE(6602)] = 249466,
  [SMALL_STATE(6603)] = 249598,
  [SMALL_STATE(6604)] = 249730,
  [SMALL_STATE(6605)] = 249862,
  [SMALL_STATE(6606)] = 249994,
  [SMALL_STATE(6607)] = 250126,
  [SMALL_STATE(6608)] = 250258,
  [SMALL_STATE(6609)] = 250384,
  [SMALL_STATE(6610)] = 250516,
  [SMALL_STATE(6611)] = 250648,
  [SMALL_STATE(6612)] = 250780,
  [SMALL_STATE(6613)] = 250912,
  [SMALL_STATE(6614)] = 251044,
  [SMALL_STATE(6615)] = 251176,
  [SMALL_STATE(6616)] = 251258,
  [SMALL_STATE(6617)] = 251390,
  [SMALL_STATE(6618)] = 251522,
  [SMALL_STATE(6619)] = 251654,
  [SMALL_STATE(6620)] = 251786,
  [SMALL_STATE(6621)] = 251918,
  [SMALL_STATE(6622)] = 252050,
  [SMALL_STATE(6623)] = 252182,
  [SMALL_STATE(6624)] = 252314,
  [SMALL_STATE(6625)] = 252446,
  [SMALL_STATE(6626)] = 252578,
  [SMALL_STATE(6627)] = 252710,
  [SMALL_STATE(6628)] = 252842,
  [SMALL_STATE(6629)] = 252974,
  [SMALL_STATE(6630)] = 253106,
  [SMALL_STATE(6631)] = 253238,
  [SMALL_STATE(6632)] = 253320,
  [SMALL_STATE(6633)] = 253452,
  [SMALL_STATE(6634)] = 253584,
  [SMALL_STATE(6635)] = 253716,
  [SMALL_STATE(6636)] = 253848,
  [SMALL_STATE(6637)] = 253970,
  [SMALL_STATE(6638)] = 254094,
  [SMALL_STATE(6639)] = 254174,
  [SMALL_STATE(6640)] = 254306,
  [SMALL_STATE(6641)] = 254386,
  [SMALL_STATE(6642)] = 254518,
  [SMALL_STATE(6643)] = 254600,
  [SMALL_STATE(6644)] = 254686,
  [SMALL_STATE(6645)] = 254806,
  [SMALL_STATE(6646)] = 254934,
  [SMALL_STATE(6647)] = 255060,
  [SMALL_STATE(6648)] = 255188,
  [SMALL_STATE(6649)] = 255320,
  [SMALL_STATE(6650)] = 255452,
  [SMALL_STATE(6651)] = 255584,
  [SMALL_STATE(6652)] = 255716,
  [SMALL_STATE(6653)] = 255848,
  [SMALL_STATE(6654)] = 255980,
  [SMALL_STATE(6655)] = 256112,
  [SMALL_STATE(6656)] = 256244,
  [SMALL_STATE(6657)] = 256376,
  [SMALL_STATE(6658)] = 256508,
  [SMALL_STATE(6659)] = 256640,
  [SMALL_STATE(6660)] = 256772,
  [SMALL_STATE(6661)] = 256904,
  [SMALL_STATE(6662)] = 257036,
  [SMALL_STATE(6663)] = 257168,
  [SMALL_STATE(6664)] = 257300,
  [SMALL_STATE(6665)] = 257382,
  [SMALL_STATE(6666)] = 257514,
  [SMALL_STATE(6667)] = 257646,
  [SMALL_STATE(6668)] = 257778,
  [SMALL_STATE(6669)] = 257858,
  [SMALL_STATE(6670)] = 257938,
  [SMALL_STATE(6671)] = 258070,
  [SMALL_STATE(6672)] = 258152,
  [SMALL_STATE(6673)] = 258234,
  [SMALL_STATE(6674)] = 258366,
  [SMALL_STATE(6675)] = 258498,
  [SMALL_STATE(6676)] = 258630,
  [SMALL_STATE(6677)] = 258762,
  [SMALL_STATE(6678)] = 258894,
  [SMALL_STATE(6679)] = 259026,
  [SMALL_STATE(6680)] = 259158,
  [SMALL_STATE(6681)] = 259290,
  [SMALL_STATE(6682)] = 259422,
  [SMALL_STATE(6683)] = 259554,
  [SMALL_STATE(6684)] = 259683,
  [SMALL_STATE(6685)] = 259812,
  [SMALL_STATE(6686)] = 259889,
  [SMALL_STATE(6687)] = 260018,
  [SMALL_STATE(6688)] = 260115,
  [SMALL_STATE(6689)] = 260200,
  [SMALL_STATE(6690)] = 260329,
  [SMALL_STATE(6691)] = 260406,
  [SMALL_STATE(6692)] = 260535,
  [SMALL_STATE(6693)] = 260664,
  [SMALL_STATE(6694)] = 260757,
  [SMALL_STATE(6695)] = 260846,
  [SMALL_STATE(6696)] = 260933,
  [SMALL_STATE(6697)] = 261062,
  [SMALL_STATE(6698)] = 261149,
  [SMALL_STATE(6699)] = 261236,
  [SMALL_STATE(6700)] = 261365,
  [SMALL_STATE(6701)] = 261494,
  [SMALL_STATE(6702)] = 261623,
  [SMALL_STATE(6703)] = 261752,
  [SMALL_STATE(6704)] = 261881,
  [SMALL_STATE(6705)] = 262010,
  [SMALL_STATE(6706)] = 262139,
  [SMALL_STATE(6707)] = 262268,
  [SMALL_STATE(6708)] = 262361,
  [SMALL_STATE(6709)] = 262454,
  [SMALL_STATE(6710)] = 262583,
  [SMALL_STATE(6711)] = 262712,
  [SMALL_STATE(6712)] = 262789,
  [SMALL_STATE(6713)] = 262866,
  [SMALL_STATE(6714)] = 262953,
  [SMALL_STATE(6715)] = 263030,
  [SMALL_STATE(6716)] = 263159,
  [SMALL_STATE(6717)] = 263288,
  [SMALL_STATE(6718)] = 263417,
  [SMALL_STATE(6719)] = 263546,
  [SMALL_STATE(6720)] = 263643,
  [SMALL_STATE(6721)] = 263722,
  [SMALL_STATE(6722)] = 263807,
  [SMALL_STATE(6723)] = 263884,
  [SMALL_STATE(6724)] = 264013,
  [SMALL_STATE(6725)] = 264142,
  [SMALL_STATE(6726)] = 264221,
  [SMALL_STATE(6727)] = 264350,
  [SMALL_STATE(6728)] = 264427,
  [SMALL_STATE(6729)] = 264520,
  [SMALL_STATE(6730)] = 264649,
  [SMALL_STATE(6731)] = 264736,
  [SMALL_STATE(6732)] = 264865,
  [SMALL_STATE(6733)] = 264994,
  [SMALL_STATE(6734)] = 265123,
  [SMALL_STATE(6735)] = 265208,
  [SMALL_STATE(6736)] = 265337,
  [SMALL_STATE(6737)] = 265466,
  [SMALL_STATE(6738)] = 265553,
  [SMALL_STATE(6739)] = 265682,
  [SMALL_STATE(6740)] = 265811,
  [SMALL_STATE(6741)] = 265897,
  [SMALL_STATE(6742)] = 265991,
  [SMALL_STATE(6743)] = 266077,
  [SMALL_STATE(6744)] = 266173,
  [SMALL_STATE(6745)] = 266259,
  [SMALL_STATE(6746)] = 266345,
  [SMALL_STATE(6747)] = 266431,
  [SMALL_STATE(6748)] = 266517,
  [SMALL_STATE(6749)] = 266603,
  [SMALL_STATE(6750)] = 266689,
  [SMALL_STATE(6751)] = 266785,
  [SMALL_STATE(6752)] = 266863,
  [SMALL_STATE(6753)] = 266957,
  [SMALL_STATE(6754)] = 267051,
  [SMALL_STATE(6755)] = 267129,
  [SMALL_STATE(6756)] = 267215,
  [SMALL_STATE(6757)] = 267299,
  [SMALL_STATE(6758)] = 267389,
  [SMALL_STATE(6759)] = 267482,
  [SMALL_STATE(6760)] = 267573,
  [SMALL_STATE(6761)] = 267660,
  [SMALL_STATE(6762)] = 267743,
  [SMALL_STATE(6763)] = 267826,
  [SMALL_STATE(6764)] = 267909,
  [SMALL_STATE(6765)] = 268000,
  [SMALL_STATE(6766)] = 268091,
  [SMALL_STATE(6767)] = 268172,
  [SMALL_STATE(6768)] = 268249,
  [SMALL_STATE(6769)] = 268336,
  [SMALL_STATE(6770)] = 268427,
  [SMALL_STATE(6771)] = 268515,
  [SMALL_STATE(6772)] = 268603,
  [SMALL_STATE(6773)] = 268691,
  [SMALL_STATE(6774)] = 268779,
  [SMALL_STATE(6775)] = 268867,
  [SMALL_STATE(6776)] = 268955,
  [SMALL_STATE(6777)] = 269043,
  [SMALL_STATE(6778)] = 269131,
  [SMALL_STATE(6779)] = 269219,
  [SMALL_STATE(6780)] = 269307,
  [SMALL_STATE(6781)] = 269395,
  [SMALL_STATE(6782)] = 269483,
  [SMALL_STATE(6783)] = 269571,
  [SMALL_STATE(6784)] = 269659,
  [SMALL_STATE(6785)] = 269747,
  [SMALL_STATE(6786)] = 269823,
  [SMALL_STATE(6787)] = 269911,
  [SMALL_STATE(6788)] = 269999,
  [SMALL_STATE(6789)] = 270087,
  [SMALL_STATE(6790)] = 270175,
  [SMALL_STATE(6791)] = 270263,
  [SMALL_STATE(6792)] = 270351,
  [SMALL_STATE(6793)] = 270433,
  [SMALL_STATE(6794)] = 270521,
  [SMALL_STATE(6795)] = 270609,
  [SMALL_STATE(6796)] = 270697,
  [SMALL_STATE(6797)] = 270787,
  [SMALL_STATE(6798)] = 270877,
  [SMALL_STATE(6799)] = 270965,
  [SMALL_STATE(6800)] = 271053,
  [SMALL_STATE(6801)] = 271141,
  [SMALL_STATE(6802)] = 271228,
  [SMALL_STATE(6803)] = 271301,
  [SMALL_STATE(6804)] = 271386,
  [SMALL_STATE(6805)] = 271463,
  [SMALL_STATE(6806)] = 271548,
  [SMALL_STATE(6807)] = 271633,
  [SMALL_STATE(6808)] = 271718,
  [SMALL_STATE(6809)] = 271803,
  [SMALL_STATE(6810)] = 271888,
  [SMALL_STATE(6811)] = 271973,
  [SMALL_STATE(6812)] = 272060,
  [SMALL_STATE(6813)] = 272141,
  [SMALL_STATE(6814)] = 272226,
  [SMALL_STATE(6815)] = 272307,
  [SMALL_STATE(6816)] = 272392,
  [SMALL_STATE(6817)] = 272477,
  [SMALL_STATE(6818)] = 272562,
  [SMALL_STATE(6819)] = 272649,
  [SMALL_STATE(6820)] = 272734,
  [SMALL_STATE(6821)] = 272819,
  [SMALL_STATE(6822)] = 272905,
  [SMALL_STATE(6823)] = 272991,
  [SMALL_STATE(6824)] = 273077,
  [SMALL_STATE(6825)] = 273163,
  [SMALL_STATE(6826)] = 273249,
  [SMALL_STATE(6827)] = 273335,
  [SMALL_STATE(6828)] = 273419,
  [SMALL_STATE(6829)] = 273505,
  [SMALL_STATE(6830)] = 273591,
  [SMALL_STATE(6831)] = 273673,
  [SMALL_STATE(6832)] = 273755,
  [SMALL_STATE(6833)] = 273841,
  [SMALL_STATE(6834)] = 273923,
  [SMALL_STATE(6835)] = 274009,
  [SMALL_STATE(6836)] = 274095,
  [SMALL_STATE(6837)] = 274181,
  [SMALL_STATE(6838)] = 274267,
  [SMALL_STATE(6839)] = 274349,
  [SMALL_STATE(6840)] = 274423,
  [SMALL_STATE(6841)] = 274509,
  [SMALL_STATE(6842)] = 274595,
  [SMALL_STATE(6843)] = 274677,
  [SMALL_STATE(6844)] = 274763,
  [SMALL_STATE(6845)] = 274845,
  [SMALL_STATE(6846)] = 274927,
  [SMALL_STATE(6847)] = 275013,
  [SMALL_STATE(6848)] = 275095,
  [SMALL_STATE(6849)] = 275181,
  [SMALL_STATE(6850)] = 275267,
  [SMALL_STATE(6851)] = 275349,
  [SMALL_STATE(6852)] = 275435,
  [SMALL_STATE(6853)] = 275517,
  [SMALL_STATE(6854)] = 275603,
  [SMALL_STATE(6855)] = 275689,
  [SMALL_STATE(6856)] = 275775,
  [SMALL_STATE(6857)] = 275861,
  [SMALL_STATE(6858)] = 275947,
  [SMALL_STATE(6859)] = 276033,
  [SMALL_STATE(6860)] = 276119,
  [SMALL_STATE(6861)] = 276201,
  [SMALL_STATE(6862)] = 276287,
  [SMALL_STATE(6863)] = 276373,
  [SMALL_STATE(6864)] = 276459,
  [SMALL_STATE(6865)] = 276541,
  [SMALL_STATE(6866)] = 276627,
  [SMALL_STATE(6867)] = 276713,
  [SMALL_STATE(6868)] = 276799,
  [SMALL_STATE(6869)] = 276885,
  [SMALL_STATE(6870)] = 276971,
  [SMALL_STATE(6871)] = 277057,
  [SMALL_STATE(6872)] = 277143,
  [SMALL_STATE(6873)] = 277229,
  [SMALL_STATE(6874)] = 277315,
  [SMALL_STATE(6875)] = 277401,
  [SMALL_STATE(6876)] = 277487,
  [SMALL_STATE(6877)] = 277573,
  [SMALL_STATE(6878)] = 277659,
  [SMALL_STATE(6879)] = 277745,
  [SMALL_STATE(6880)] = 277831,
  [SMALL_STATE(6881)] = 277917,
  [SMALL_STATE(6882)] = 278003,
  [SMALL_STATE(6883)] = 278089,
  [SMALL_STATE(6884)] = 278175,
  [SMALL_STATE(6885)] = 278261,
  [SMALL_STATE(6886)] = 278347,
  [SMALL_STATE(6887)] = 278433,
  [SMALL_STATE(6888)] = 278519,
  [SMALL_STATE(6889)] = 278605,
  [SMALL_STATE(6890)] = 278687,
  [SMALL_STATE(6891)] = 278761,
  [SMALL_STATE(6892)] = 278847,
  [SMALL_STATE(6893)] = 278929,
  [SMALL_STATE(6894)] = 279015,
  [SMALL_STATE(6895)] = 279101,
  [SMALL_STATE(6896)] = 279183,
  [SMALL_STATE(6897)] = 279269,
  [SMALL_STATE(6898)] = 279355,
  [SMALL_STATE(6899)] = 279441,
  [SMALL_STATE(6900)] = 279527,
  [SMALL_STATE(6901)] = 279613,
  [SMALL_STATE(6902)] = 279699,
  [SMALL_STATE(6903)] = 279782,
  [SMALL_STATE(6904)] = 279863,
  [SMALL_STATE(6905)] = 279944,
  [SMALL_STATE(6906)] = 280027,
  [SMALL_STATE(6907)] = 280108,
  [SMALL_STATE(6908)] = 280189,
  [SMALL_STATE(6909)] = 280272,
  [SMALL_STATE(6910)] = 280353,
  [SMALL_STATE(6911)] = 280436,
  [SMALL_STATE(6912)] = 280517,
  [SMALL_STATE(6913)] = 280600,
  [SMALL_STATE(6914)] = 280677,
  [SMALL_STATE(6915)] = 280756,
  [SMALL_STATE(6916)] = 280837,
  [SMALL_STATE(6917)] = 280918,
  [SMALL_STATE(6918)] = 280999,
  [SMALL_STATE(6919)] = 281076,
  [SMALL_STATE(6920)] = 281157,
  [SMALL_STATE(6921)] = 281238,
  [SMALL_STATE(6922)] = 281319,
  [SMALL_STATE(6923)] = 281402,
  [SMALL_STATE(6924)] = 281485,
  [SMALL_STATE(6925)] = 281566,
  [SMALL_STATE(6926)] = 281645,
  [SMALL_STATE(6927)] = 281726,
  [SMALL_STATE(6928)] = 281807,
  [SMALL_STATE(6929)] = 281888,
  [SMALL_STATE(6930)] = 281967,
  [SMALL_STATE(6931)] = 282038,
  [SMALL_STATE(6932)] = 282119,
  [SMALL_STATE(6933)] = 282202,
  [SMALL_STATE(6934)] = 282283,
  [SMALL_STATE(6935)] = 282362,
  [SMALL_STATE(6936)] = 282443,
  [SMALL_STATE(6937)] = 282524,
  [SMALL_STATE(6938)] = 282605,
  [SMALL_STATE(6939)] = 282688,
  [SMALL_STATE(6940)] = 282769,
  [SMALL_STATE(6941)] = 282850,
  [SMALL_STATE(6942)] = 282933,
  [SMALL_STATE(6943)] = 283014,
  [SMALL_STATE(6944)] = 283095,
  [SMALL_STATE(6945)] = 283176,
  [SMALL_STATE(6946)] = 283247,
  [SMALL_STATE(6947)] = 283328,
  [SMALL_STATE(6948)] = 283409,
  [SMALL_STATE(6949)] = 283487,
  [SMALL_STATE(6950)] = 283567,
  [SMALL_STATE(6951)] = 283647,
  [SMALL_STATE(6952)] = 283727,
  [SMALL_STATE(6953)] = 283807,
  [SMALL_STATE(6954)] = 283887,
  [SMALL_STATE(6955)] = 283965,
  [SMALL_STATE(6956)] = 284043,
  [SMALL_STATE(6957)] = 284123,
  [SMALL_STATE(6958)] = 284203,
  [SMALL_STATE(6959)] = 284281,
  [SMALL_STATE(6960)] = 284361,
  [SMALL_STATE(6961)] = 284441,
  [SMALL_STATE(6962)] = 284521,
  [SMALL_STATE(6963)] = 284601,
  [SMALL_STATE(6964)] = 284681,
  [SMALL_STATE(6965)] = 284759,
  [SMALL_STATE(6966)] = 284839,
  [SMALL_STATE(6967)] = 284919,
  [SMALL_STATE(6968)] = 284999,
  [SMALL_STATE(6969)] = 285077,
  [SMALL_STATE(6970)] = 285157,
  [SMALL_STATE(6971)] = 285237,
  [SMALL_STATE(6972)] = 285317,
  [SMALL_STATE(6973)] = 285397,
  [SMALL_STATE(6974)] = 285477,
  [SMALL_STATE(6975)] = 285557,
  [SMALL_STATE(6976)] = 285637,
  [SMALL_STATE(6977)] = 285715,
  [SMALL_STATE(6978)] = 285795,
  [SMALL_STATE(6979)] = 285875,
  [SMALL_STATE(6980)] = 285955,
  [SMALL_STATE(6981)] = 286033,
  [SMALL_STATE(6982)] = 286113,
  [SMALL_STATE(6983)] = 286193,
  [SMALL_STATE(6984)] = 286273,
  [SMALL_STATE(6985)] = 286353,
  [SMALL_STATE(6986)] = 286433,
  [SMALL_STATE(6987)] = 286511,
  [SMALL_STATE(6988)] = 286591,
  [SMALL_STATE(6989)] = 286671,
  [SMALL_STATE(6990)] = 286751,
  [SMALL_STATE(6991)] = 286831,
  [SMALL_STATE(6992)] = 286911,
  [SMALL_STATE(6993)] = 286991,
  [SMALL_STATE(6994)] = 287071,
  [SMALL_STATE(6995)] = 287151,
  [SMALL_STATE(6996)] = 287229,
  [SMALL_STATE(6997)] = 287309,
  [SMALL_STATE(6998)] = 287389,
  [SMALL_STATE(6999)] = 287469,
  [SMALL_STATE(7000)] = 287549,
  [SMALL_STATE(7001)] = 287629,
  [SMALL_STATE(7002)] = 287709,
  [SMALL_STATE(7003)] = 287787,
  [SMALL_STATE(7004)] = 287867,
  [SMALL_STATE(7005)] = 287947,
  [SMALL_STATE(7006)] = 288027,
  [SMALL_STATE(7007)] = 288105,
  [SMALL_STATE(7008)] = 288185,
  [SMALL_STATE(7009)] = 288265,
  [SMALL_STATE(7010)] = 288345,
  [SMALL_STATE(7011)] = 288425,
  [SMALL_STATE(7012)] = 288503,
  [SMALL_STATE(7013)] = 288583,
  [SMALL_STATE(7014)] = 288663,
  [SMALL_STATE(7015)] = 288743,
  [SMALL_STATE(7016)] = 288823,
  [SMALL_STATE(7017)] = 288903,
  [SMALL_STATE(7018)] = 288983,
  [SMALL_STATE(7019)] = 289061,
  [SMALL_STATE(7020)] = 289141,
  [SMALL_STATE(7021)] = 289221,
  [SMALL_STATE(7022)] = 289301,
  [SMALL_STATE(7023)] = 289381,
  [SMALL_STATE(7024)] = 289461,
  [SMALL_STATE(7025)] = 289541,
  [SMALL_STATE(7026)] = 289619,
  [SMALL_STATE(7027)] = 289697,
  [SMALL_STATE(7028)] = 289775,
  [SMALL_STATE(7029)] = 289855,
  [SMALL_STATE(7030)] = 289935,
  [SMALL_STATE(7031)] = 290015,
  [SMALL_STATE(7032)] = 290093,
  [SMALL_STATE(7033)] = 290173,
  [SMALL_STATE(7034)] = 290253,
  [SMALL_STATE(7035)] = 290333,
  [SMALL_STATE(7036)] = 290413,
  [SMALL_STATE(7037)] = 290491,
  [SMALL_STATE(7038)] = 290571,
  [SMALL_STATE(7039)] = 290651,
  [SMALL_STATE(7040)] = 290729,
  [SMALL_STATE(7041)] = 290809,
  [SMALL_STATE(7042)] = 290889,
  [SMALL_STATE(7043)] = 290969,
  [SMALL_STATE(7044)] = 291049,
  [SMALL_STATE(7045)] = 291129,
  [SMALL_STATE(7046)] = 291209,
  [SMALL_STATE(7047)] = 291289,
  [SMALL_STATE(7048)] = 291369,
  [SMALL_STATE(7049)] = 291449,
  [SMALL_STATE(7050)] = 291529,
  [SMALL_STATE(7051)] = 291607,
  [SMALL_STATE(7052)] = 291687,
  [SMALL_STATE(7053)] = 291767,
  [SMALL_STATE(7054)] = 291847,
  [SMALL_STATE(7055)] = 291927,
  [SMALL_STATE(7056)] = 292007,
  [SMALL_STATE(7057)] = 292087,
  [SMALL_STATE(7058)] = 292165,
  [SMALL_STATE(7059)] = 292245,
  [SMALL_STATE(7060)] = 292325,
  [SMALL_STATE(7061)] = 292405,
  [SMALL_STATE(7062)] = 292485,
  [SMALL_STATE(7063)] = 292565,
  [SMALL_STATE(7064)] = 292645,
  [SMALL_STATE(7065)] = 292725,
  [SMALL_STATE(7066)] = 292803,
  [SMALL_STATE(7067)] = 292883,
  [SMALL_STATE(7068)] = 292963,
  [SMALL_STATE(7069)] = 293041,
  [SMALL_STATE(7070)] = 293121,
  [SMALL_STATE(7071)] = 293201,
  [SMALL_STATE(7072)] = 293281,
  [SMALL_STATE(7073)] = 293361,
  [SMALL_STATE(7074)] = 293441,
  [SMALL_STATE(7075)] = 293519,
  [SMALL_STATE(7076)] = 293599,
  [SMALL_STATE(7077)] = 293679,
  [SMALL_STATE(7078)] = 293757,
  [SMALL_STATE(7079)] = 293837,
  [SMALL_STATE(7080)] = 293917,
  [SMALL_STATE(7081)] = 293995,
  [SMALL_STATE(7082)] = 294075,
  [SMALL_STATE(7083)] = 294155,
  [SMALL_STATE(7084)] = 294235,
  [SMALL_STATE(7085)] = 294315,
  [SMALL_STATE(7086)] = 294395,
  [SMALL_STATE(7087)] = 294475,
  [SMALL_STATE(7088)] = 294555,
  [SMALL_STATE(7089)] = 294633,
  [SMALL_STATE(7090)] = 294713,
  [SMALL_STATE(7091)] = 294791,
  [SMALL_STATE(7092)] = 294871,
  [SMALL_STATE(7093)] = 294951,
  [SMALL_STATE(7094)] = 295031,
  [SMALL_STATE(7095)] = 295111,
  [SMALL_STATE(7096)] = 295191,
  [SMALL_STATE(7097)] = 295271,
  [SMALL_STATE(7098)] = 295351,
  [SMALL_STATE(7099)] = 295431,
  [SMALL_STATE(7100)] = 295509,
  [SMALL_STATE(7101)] = 295589,
  [SMALL_STATE(7102)] = 295667,
  [SMALL_STATE(7103)] = 295747,
  [SMALL_STATE(7104)] = 295827,
  [SMALL_STATE(7105)] = 295905,
  [SMALL_STATE(7106)] = 295983,
  [SMALL_STATE(7107)] = 296063,
  [SMALL_STATE(7108)] = 296143,
  [SMALL_STATE(7109)] = 296221,
  [SMALL_STATE(7110)] = 296301,
  [SMALL_STATE(7111)] = 296381,
  [SMALL_STATE(7112)] = 296461,
  [SMALL_STATE(7113)] = 296539,
  [SMALL_STATE(7114)] = 296619,
  [SMALL_STATE(7115)] = 296699,
  [SMALL_STATE(7116)] = 296779,
  [SMALL_STATE(7117)] = 296857,
  [SMALL_STATE(7118)] = 296937,
  [SMALL_STATE(7119)] = 297017,
  [SMALL_STATE(7120)] = 297097,
  [SMALL_STATE(7121)] = 297177,
  [SMALL_STATE(7122)] = 297257,
  [SMALL_STATE(7123)] = 297337,
  [SMALL_STATE(7124)] = 297417,
  [SMALL_STATE(7125)] = 297497,
  [SMALL_STATE(7126)] = 297575,
  [SMALL_STATE(7127)] = 297655,
  [SMALL_STATE(7128)] = 297735,
  [SMALL_STATE(7129)] = 297813,
  [SMALL_STATE(7130)] = 297893,
  [SMALL_STATE(7131)] = 297973,
  [SMALL_STATE(7132)] = 298053,
  [SMALL_STATE(7133)] = 298133,
  [SMALL_STATE(7134)] = 298211,
  [SMALL_STATE(7135)] = 298291,
  [SMALL_STATE(7136)] = 298371,
  [SMALL_STATE(7137)] = 298451,
  [SMALL_STATE(7138)] = 298523,
  [SMALL_STATE(7139)] = 298603,
  [SMALL_STATE(7140)] = 298681,
  [SMALL_STATE(7141)] = 298761,
  [SMALL_STATE(7142)] = 298841,
  [SMALL_STATE(7143)] = 298919,
  [SMALL_STATE(7144)] = 298999,
  [SMALL_STATE(7145)] = 299079,
  [SMALL_STATE(7146)] = 299159,
  [SMALL_STATE(7147)] = 299239,
  [SMALL_STATE(7148)] = 299319,
  [SMALL_STATE(7149)] = 299399,
  [SMALL_STATE(7150)] = 299479,
  [SMALL_STATE(7151)] = 299557,
  [SMALL_STATE(7152)] = 299635,
  [SMALL_STATE(7153)] = 299715,
  [SMALL_STATE(7154)] = 299795,
  [SMALL_STATE(7155)] = 299875,
  [SMALL_STATE(7156)] = 299955,
  [SMALL_STATE(7157)] = 300035,
  [SMALL_STATE(7158)] = 300115,
  [SMALL_STATE(7159)] = 300193,
  [SMALL_STATE(7160)] = 300270,
  [SMALL_STATE(7161)] = 300347,
  [SMALL_STATE(7162)] = 300424,
  [SMALL_STATE(7163)] = 300501,
  [SMALL_STATE(7164)] = 300578,
  [SMALL_STATE(7165)] = 300655,
  [SMALL_STATE(7166)] = 300732,
  [SMALL_STATE(7167)] = 300809,
  [SMALL_STATE(7168)] = 300886,
  [SMALL_STATE(7169)] = 300963,
  [SMALL_STATE(7170)] = 301040,
  [SMALL_STATE(7171)] = 301117,
  [SMALL_STATE(7172)] = 301194,
  [SMALL_STATE(7173)] = 301271,
  [SMALL_STATE(7174)] = 301348,
  [SMALL_STATE(7175)] = 301425,
  [SMALL_STATE(7176)] = 301502,
  [SMALL_STATE(7177)] = 301577,
  [SMALL_STATE(7178)] = 301654,
  [SMALL_STATE(7179)] = 301731,
  [SMALL_STATE(7180)] = 301808,
  [SMALL_STATE(7181)] = 301885,
  [SMALL_STATE(7182)] = 301962,
  [SMALL_STATE(7183)] = 302039,
  [SMALL_STATE(7184)] = 302116,
  [SMALL_STATE(7185)] = 302193,
  [SMALL_STATE(7186)] = 302270,
  [SMALL_STATE(7187)] = 302347,
  [SMALL_STATE(7188)] = 302424,
  [SMALL_STATE(7189)] = 302501,
  [SMALL_STATE(7190)] = 302576,
  [SMALL_STATE(7191)] = 302653,
  [SMALL_STATE(7192)] = 302730,
  [SMALL_STATE(7193)] = 302807,
  [SMALL_STATE(7194)] = 302884,
  [SMALL_STATE(7195)] = 302961,
  [SMALL_STATE(7196)] = 303038,
  [SMALL_STATE(7197)] = 303115,
  [SMALL_STATE(7198)] = 303192,
  [SMALL_STATE(7199)] = 303269,
  [SMALL_STATE(7200)] = 303344,
  [SMALL_STATE(7201)] = 303421,
  [SMALL_STATE(7202)] = 303498,
  [SMALL_STATE(7203)] = 303575,
  [SMALL_STATE(7204)] = 303652,
  [SMALL_STATE(7205)] = 303729,
  [SMALL_STATE(7206)] = 303806,
  [SMALL_STATE(7207)] = 303883,
  [SMALL_STATE(7208)] = 303960,
  [SMALL_STATE(7209)] = 304037,
  [SMALL_STATE(7210)] = 304114,
  [SMALL_STATE(7211)] = 304191,
  [SMALL_STATE(7212)] = 304268,
  [SMALL_STATE(7213)] = 304345,
  [SMALL_STATE(7214)] = 304422,
  [SMALL_STATE(7215)] = 304497,
  [SMALL_STATE(7216)] = 304574,
  [SMALL_STATE(7217)] = 304651,
  [SMALL_STATE(7218)] = 304728,
  [SMALL_STATE(7219)] = 304803,
  [SMALL_STATE(7220)] = 304878,
  [SMALL_STATE(7221)] = 304955,
  [SMALL_STATE(7222)] = 305032,
  [SMALL_STATE(7223)] = 305109,
  [SMALL_STATE(7224)] = 305186,
  [SMALL_STATE(7225)] = 305263,
  [SMALL_STATE(7226)] = 305340,
  [SMALL_STATE(7227)] = 305417,
  [SMALL_STATE(7228)] = 305494,
  [SMALL_STATE(7229)] = 305571,
  [SMALL_STATE(7230)] = 305648,
  [SMALL_STATE(7231)] = 305725,
  [SMALL_STATE(7232)] = 305802,
  [SMALL_STATE(7233)] = 305879,
  [SMALL_STATE(7234)] = 305956,
  [SMALL_STATE(7235)] = 306033,
  [SMALL_STATE(7236)] = 306110,
  [SMALL_STATE(7237)] = 306187,
  [SMALL_STATE(7238)] = 306264,
  [SMALL_STATE(7239)] = 306339,
  [SMALL_STATE(7240)] = 306416,
  [SMALL_STATE(7241)] = 306493,
  [SMALL_STATE(7242)] = 306570,
  [SMALL_STATE(7243)] = 306645,
  [SMALL_STATE(7244)] = 306722,
  [SMALL_STATE(7245)] = 306799,
  [SMALL_STATE(7246)] = 306876,
  [SMALL_STATE(7247)] = 306953,
  [SMALL_STATE(7248)] = 307028,
  [SMALL_STATE(7249)] = 307105,
  [SMALL_STATE(7250)] = 307182,
  [SMALL_STATE(7251)] = 307259,
  [SMALL_STATE(7252)] = 307336,
  [SMALL_STATE(7253)] = 307413,
  [SMALL_STATE(7254)] = 307490,
  [SMALL_STATE(7255)] = 307567,
  [SMALL_STATE(7256)] = 307644,
  [SMALL_STATE(7257)] = 307721,
  [SMALL_STATE(7258)] = 307798,
  [SMALL_STATE(7259)] = 307875,
  [SMALL_STATE(7260)] = 307952,
  [SMALL_STATE(7261)] = 308029,
  [SMALL_STATE(7262)] = 308106,
  [SMALL_STATE(7263)] = 308183,
  [SMALL_STATE(7264)] = 308260,
  [SMALL_STATE(7265)] = 308337,
  [SMALL_STATE(7266)] = 308414,
  [SMALL_STATE(7267)] = 308491,
  [SMALL_STATE(7268)] = 308568,
  [SMALL_STATE(7269)] = 308645,
  [SMALL_STATE(7270)] = 308722,
  [SMALL_STATE(7271)] = 308799,
  [SMALL_STATE(7272)] = 308876,
  [SMALL_STATE(7273)] = 308951,
  [SMALL_STATE(7274)] = 309028,
  [SMALL_STATE(7275)] = 309105,
  [SMALL_STATE(7276)] = 309182,
  [SMALL_STATE(7277)] = 309259,
  [SMALL_STATE(7278)] = 309336,
  [SMALL_STATE(7279)] = 309413,
  [SMALL_STATE(7280)] = 309490,
  [SMALL_STATE(7281)] = 309567,
  [SMALL_STATE(7282)] = 309644,
  [SMALL_STATE(7283)] = 309721,
  [SMALL_STATE(7284)] = 309795,
  [SMALL_STATE(7285)] = 309869,
  [SMALL_STATE(7286)] = 309943,
  [SMALL_STATE(7287)] = 310017,
  [SMALL_STATE(7288)] = 310085,
  [SMALL_STATE(7289)] = 310153,
  [SMALL_STATE(7290)] = 310221,
  [SMALL_STATE(7291)] = 310289,
  [SMALL_STATE(7292)] = 310357,
  [SMALL_STATE(7293)] = 310431,
  [SMALL_STATE(7294)] = 310502,
  [SMALL_STATE(7295)] = 310573,
  [SMALL_STATE(7296)] = 310644,
  [SMALL_STATE(7297)] = 310715,
  [SMALL_STATE(7298)] = 310786,
  [SMALL_STATE(7299)] = 310857,
  [SMALL_STATE(7300)] = 310928,
  [SMALL_STATE(7301)] = 310999,
  [SMALL_STATE(7302)] = 311070,
  [SMALL_STATE(7303)] = 311141,
  [SMALL_STATE(7304)] = 311212,
  [SMALL_STATE(7305)] = 311283,
  [SMALL_STATE(7306)] = 311354,
  [SMALL_STATE(7307)] = 311425,
  [SMALL_STATE(7308)] = 311496,
  [SMALL_STATE(7309)] = 311567,
  [SMALL_STATE(7310)] = 311638,
  [SMALL_STATE(7311)] = 311709,
  [SMALL_STATE(7312)] = 311780,
  [SMALL_STATE(7313)] = 311851,
  [SMALL_STATE(7314)] = 311922,
  [SMALL_STATE(7315)] = 311993,
  [SMALL_STATE(7316)] = 312064,
  [SMALL_STATE(7317)] = 312135,
  [SMALL_STATE(7318)] = 312206,
  [SMALL_STATE(7319)] = 312277,
  [SMALL_STATE(7320)] = 312348,
  [SMALL_STATE(7321)] = 312419,
  [SMALL_STATE(7322)] = 312490,
  [SMALL_STATE(7323)] = 312561,
  [SMALL_STATE(7324)] = 312632,
  [SMALL_STATE(7325)] = 312703,
  [SMALL_STATE(7326)] = 312774,
  [SMALL_STATE(7327)] = 312845,
  [SMALL_STATE(7328)] = 312916,
  [SMALL_STATE(7329)] = 312987,
  [SMALL_STATE(7330)] = 313058,
  [SMALL_STATE(7331)] = 313129,
  [SMALL_STATE(7332)] = 313200,
  [SMALL_STATE(7333)] = 313271,
  [SMALL_STATE(7334)] = 313342,
  [SMALL_STATE(7335)] = 313413,
  [SMALL_STATE(7336)] = 313484,
  [SMALL_STATE(7337)] = 313555,
  [SMALL_STATE(7338)] = 313626,
  [SMALL_STATE(7339)] = 313697,
  [SMALL_STATE(7340)] = 313768,
  [SMALL_STATE(7341)] = 313839,
  [SMALL_STATE(7342)] = 313910,
  [SMALL_STATE(7343)] = 313981,
  [SMALL_STATE(7344)] = 314052,
  [SMALL_STATE(7345)] = 314123,
  [SMALL_STATE(7346)] = 314194,
  [SMALL_STATE(7347)] = 314265,
  [SMALL_STATE(7348)] = 314336,
  [SMALL_STATE(7349)] = 314407,
  [SMALL_STATE(7350)] = 314478,
  [SMALL_STATE(7351)] = 314549,
  [SMALL_STATE(7352)] = 314620,
  [SMALL_STATE(7353)] = 314691,
  [SMALL_STATE(7354)] = 314762,
  [SMALL_STATE(7355)] = 314833,
  [SMALL_STATE(7356)] = 314904,
  [SMALL_STATE(7357)] = 314975,
  [SMALL_STATE(7358)] = 315046,
  [SMALL_STATE(7359)] = 315117,
  [SMALL_STATE(7360)] = 315188,
  [SMALL_STATE(7361)] = 315259,
  [SMALL_STATE(7362)] = 315330,
  [SMALL_STATE(7363)] = 315401,
  [SMALL_STATE(7364)] = 315472,
  [SMALL_STATE(7365)] = 315543,
  [SMALL_STATE(7366)] = 315614,
  [SMALL_STATE(7367)] = 315685,
  [SMALL_STATE(7368)] = 315756,
  [SMALL_STATE(7369)] = 315827,
  [SMALL_STATE(7370)] = 315898,
  [SMALL_STATE(7371)] = 315969,
  [SMALL_STATE(7372)] = 316040,
  [SMALL_STATE(7373)] = 316111,
  [SMALL_STATE(7374)] = 316182,
  [SMALL_STATE(7375)] = 316253,
  [SMALL_STATE(7376)] = 316324,
  [SMALL_STATE(7377)] = 316395,
  [SMALL_STATE(7378)] = 316466,
  [SMALL_STATE(7379)] = 316537,
  [SMALL_STATE(7380)] = 316608,
  [SMALL_STATE(7381)] = 316679,
  [SMALL_STATE(7382)] = 316750,
  [SMALL_STATE(7383)] = 316821,
  [SMALL_STATE(7384)] = 316892,
  [SMALL_STATE(7385)] = 316963,
  [SMALL_STATE(7386)] = 317034,
  [SMALL_STATE(7387)] = 317105,
  [SMALL_STATE(7388)] = 317176,
  [SMALL_STATE(7389)] = 317247,
  [SMALL_STATE(7390)] = 317318,
  [SMALL_STATE(7391)] = 317389,
  [SMALL_STATE(7392)] = 317460,
  [SMALL_STATE(7393)] = 317528,
  [SMALL_STATE(7394)] = 317596,
  [SMALL_STATE(7395)] = 317664,
  [SMALL_STATE(7396)] = 317732,
  [SMALL_STATE(7397)] = 317800,
  [SMALL_STATE(7398)] = 317868,
  [SMALL_STATE(7399)] = 317933,
  [SMALL_STATE(7400)] = 317998,
  [SMALL_STATE(7401)] = 318063,
  [SMALL_STATE(7402)] = 318128,
  [SMALL_STATE(7403)] = 318193,
  [SMALL_STATE(7404)] = 318258,
  [SMALL_STATE(7405)] = 318321,
  [SMALL_STATE(7406)] = 318403,
  [SMALL_STATE(7407)] = 318485,
  [SMALL_STATE(7408)] = 318567,
  [SMALL_STATE(7409)] = 318649,
  [SMALL_STATE(7410)] = 318731,
  [SMALL_STATE(7411)] = 318813,
  [SMALL_STATE(7412)] = 318895,
  [SMALL_STATE(7413)] = 318977,
  [SMALL_STATE(7414)] = 319059,
  [SMALL_STATE(7415)] = 319141,
  [SMALL_STATE(7416)] = 319223,
  [SMALL_STATE(7417)] = 319305,
  [SMALL_STATE(7418)] = 319387,
  [SMALL_STATE(7419)] = 319469,
  [SMALL_STATE(7420)] = 319551,
  [SMALL_STATE(7421)] = 319633,
  [SMALL_STATE(7422)] = 319715,
  [SMALL_STATE(7423)] = 319797,
  [SMALL_STATE(7424)] = 319879,
  [SMALL_STATE(7425)] = 319961,
  [SMALL_STATE(7426)] = 320043,
  [SMALL_STATE(7427)] = 320125,
  [SMALL_STATE(7428)] = 320207,
  [SMALL_STATE(7429)] = 320289,
  [SMALL_STATE(7430)] = 320371,
  [SMALL_STATE(7431)] = 320453,
  [SMALL_STATE(7432)] = 320535,
  [SMALL_STATE(7433)] = 320617,
  [SMALL_STATE(7434)] = 320699,
  [SMALL_STATE(7435)] = 320781,
  [SMALL_STATE(7436)] = 320863,
  [SMALL_STATE(7437)] = 320945,
  [SMALL_STATE(7438)] = 321027,
  [SMALL_STATE(7439)] = 321109,
  [SMALL_STATE(7440)] = 321191,
  [SMALL_STATE(7441)] = 321273,
  [SMALL_STATE(7442)] = 321352,
  [SMALL_STATE(7443)] = 321431,
  [SMALL_STATE(7444)] = 321510,
  [SMALL_STATE(7445)] = 321589,
  [SMALL_STATE(7446)] = 321668,
  [SMALL_STATE(7447)] = 321747,
  [SMALL_STATE(7448)] = 321826,
  [SMALL_STATE(7449)] = 321905,
  [SMALL_STATE(7450)] = 321984,
  [SMALL_STATE(7451)] = 322063,
  [SMALL_STATE(7452)] = 322142,
  [SMALL_STATE(7453)] = 322221,
  [SMALL_STATE(7454)] = 322300,
  [SMALL_STATE(7455)] = 322379,
  [SMALL_STATE(7456)] = 322458,
  [SMALL_STATE(7457)] = 322537,
  [SMALL_STATE(7458)] = 322616,
  [SMALL_STATE(7459)] = 322695,
  [SMALL_STATE(7460)] = 322774,
  [SMALL_STATE(7461)] = 322853,
  [SMALL_STATE(7462)] = 322932,
  [SMALL_STATE(7463)] = 323011,
  [SMALL_STATE(7464)] = 323090,
  [SMALL_STATE(7465)] = 323169,
  [SMALL_STATE(7466)] = 323248,
  [SMALL_STATE(7467)] = 323327,
  [SMALL_STATE(7468)] = 323406,
  [SMALL_STATE(7469)] = 323485,
  [SMALL_STATE(7470)] = 323564,
  [SMALL_STATE(7471)] = 323643,
  [SMALL_STATE(7472)] = 323722,
  [SMALL_STATE(7473)] = 323801,
  [SMALL_STATE(7474)] = 323880,
  [SMALL_STATE(7475)] = 323959,
  [SMALL_STATE(7476)] = 324038,
  [SMALL_STATE(7477)] = 324117,
  [SMALL_STATE(7478)] = 324196,
  [SMALL_STATE(7479)] = 324275,
  [SMALL_STATE(7480)] = 324354,
  [SMALL_STATE(7481)] = 324433,
  [SMALL_STATE(7482)] = 324512,
  [SMALL_STATE(7483)] = 324591,
  [SMALL_STATE(7484)] = 324670,
  [SMALL_STATE(7485)] = 324749,
  [SMALL_STATE(7486)] = 324828,
  [SMALL_STATE(7487)] = 324907,
  [SMALL_STATE(7488)] = 324986,
  [SMALL_STATE(7489)] = 325065,
  [SMALL_STATE(7490)] = 325144,
  [SMALL_STATE(7491)] = 325223,
  [SMALL_STATE(7492)] = 325302,
  [SMALL_STATE(7493)] = 325381,
  [SMALL_STATE(7494)] = 325460,
  [SMALL_STATE(7495)] = 325539,
  [SMALL_STATE(7496)] = 325618,
  [SMALL_STATE(7497)] = 325697,
  [SMALL_STATE(7498)] = 325776,
  [SMALL_STATE(7499)] = 325855,
  [SMALL_STATE(7500)] = 325934,
  [SMALL_STATE(7501)] = 326013,
  [SMALL_STATE(7502)] = 326097,
  [SMALL_STATE(7503)] = 326181,
  [SMALL_STATE(7504)] = 326265,
  [SMALL_STATE(7505)] = 326333,
  [SMALL_STATE(7506)] = 326407,
  [SMALL_STATE(7507)] = 326481,
  [SMALL_STATE(7508)] = 326555,
  [SMALL_STATE(7509)] = 326629,
  [SMALL_STATE(7510)] = 326703,
  [SMALL_STATE(7511)] = 326777,
  [SMALL_STATE(7512)] = 326851,
  [SMALL_STATE(7513)] = 326925,
  [SMALL_STATE(7514)] = 326999,
  [SMALL_STATE(7515)] = 327073,
  [SMALL_STATE(7516)] = 327147,
  [SMALL_STATE(7517)] = 327221,
  [SMALL_STATE(7518)] = 327292,
  [SMALL_STATE(7519)] = 327363,
  [SMALL_STATE(7520)] = 327434,
  [SMALL_STATE(7521)] = 327505,
  [SMALL_STATE(7522)] = 327576,
  [SMALL_STATE(7523)] = 327647,
  [SMALL_STATE(7524)] = 327718,
  [SMALL_STATE(7525)] = 327789,
  [SMALL_STATE(7526)] = 327860,
  [SMALL_STATE(7527)] = 327931,
  [SMALL_STATE(7528)] = 328002,
  [SMALL_STATE(7529)] = 328073,
  [SMALL_STATE(7530)] = 328144,
  [SMALL_STATE(7531)] = 328197,
  [SMALL_STATE(7532)] = 328268,
  [SMALL_STATE(7533)] = 328339,
  [SMALL_STATE(7534)] = 328410,
  [SMALL_STATE(7535)] = 328481,
  [SMALL_STATE(7536)] = 328552,
  [SMALL_STATE(7537)] = 328623,
  [SMALL_STATE(7538)] = 328694,
  [SMALL_STATE(7539)] = 328765,
  [SMALL_STATE(7540)] = 328836,
  [SMALL_STATE(7541)] = 328907,
  [SMALL_STATE(7542)] = 328978,
  [SMALL_STATE(7543)] = 329046,
  [SMALL_STATE(7544)] = 329114,
  [SMALL_STATE(7545)] = 329182,
  [SMALL_STATE(7546)] = 329250,
  [SMALL_STATE(7547)] = 329316,
  [SMALL_STATE(7548)] = 329382,
  [SMALL_STATE(7549)] = 329448,
  [SMALL_STATE(7550)] = 329516,
  [SMALL_STATE(7551)] = 329584,
  [SMALL_STATE(7552)] = 329652,
  [SMALL_STATE(7553)] = 329720,
  [SMALL_STATE(7554)] = 329788,
  [SMALL_STATE(7555)] = 329856,
  [SMALL_STATE(7556)] = 329924,
  [SMALL_STATE(7557)] = 329990,
  [SMALL_STATE(7558)] = 330058,
  [SMALL_STATE(7559)] = 330123,
  [SMALL_STATE(7560)] = 330188,
  [SMALL_STATE(7561)] = 330253,
  [SMALL_STATE(7562)] = 330318,
  [SMALL_STATE(7563)] = 330383,
  [SMALL_STATE(7564)] = 330448,
  [SMALL_STATE(7565)] = 330513,
  [SMALL_STATE(7566)] = 330578,
  [SMALL_STATE(7567)] = 330643,
  [SMALL_STATE(7568)] = 330708,
  [SMALL_STATE(7569)] = 330771,
  [SMALL_STATE(7570)] = 330834,
  [SMALL_STATE(7571)] = 330899,
  [SMALL_STATE(7572)] = 330964,
  [SMALL_STATE(7573)] = 331029,
  [SMALL_STATE(7574)] = 331094,
  [SMALL_STATE(7575)] = 331159,
  [SMALL_STATE(7576)] = 331224,
  [SMALL_STATE(7577)] = 331289,
  [SMALL_STATE(7578)] = 331354,
  [SMALL_STATE(7579)] = 331419,
  [SMALL_STATE(7580)] = 331484,
  [SMALL_STATE(7581)] = 331549,
  [SMALL_STATE(7582)] = 331614,
  [SMALL_STATE(7583)] = 331679,
  [SMALL_STATE(7584)] = 331744,
  [SMALL_STATE(7585)] = 331809,
  [SMALL_STATE(7586)] = 331862,
  [SMALL_STATE(7587)] = 331913,
  [SMALL_STATE(7588)] = 331966,
  [SMALL_STATE(7589)] = 332031,
  [SMALL_STATE(7590)] = 332096,
  [SMALL_STATE(7591)] = 332161,
  [SMALL_STATE(7592)] = 332226,
  [SMALL_STATE(7593)] = 332279,
  [SMALL_STATE(7594)] = 332344,
  [SMALL_STATE(7595)] = 332409,
  [SMALL_STATE(7596)] = 332472,
  [SMALL_STATE(7597)] = 332537,
  [SMALL_STATE(7598)] = 332602,
  [SMALL_STATE(7599)] = 332667,
  [SMALL_STATE(7600)] = 332732,
  [SMALL_STATE(7601)] = 332797,
  [SMALL_STATE(7602)] = 332862,
  [SMALL_STATE(7603)] = 332927,
  [SMALL_STATE(7604)] = 332992,
  [SMALL_STATE(7605)] = 333057,
  [SMALL_STATE(7606)] = 333122,
  [SMALL_STATE(7607)] = 333187,
  [SMALL_STATE(7608)] = 333252,
  [SMALL_STATE(7609)] = 333317,
  [SMALL_STATE(7610)] = 333382,
  [SMALL_STATE(7611)] = 333447,
  [SMALL_STATE(7612)] = 333512,
  [SMALL_STATE(7613)] = 333577,
  [SMALL_STATE(7614)] = 333642,
  [SMALL_STATE(7615)] = 333707,
  [SMALL_STATE(7616)] = 333772,
  [SMALL_STATE(7617)] = 333837,
  [SMALL_STATE(7618)] = 333902,
  [SMALL_STATE(7619)] = 333967,
  [SMALL_STATE(7620)] = 334032,
  [SMALL_STATE(7621)] = 334097,
  [SMALL_STATE(7622)] = 334162,
  [SMALL_STATE(7623)] = 334227,
  [SMALL_STATE(7624)] = 334292,
  [SMALL_STATE(7625)] = 334357,
  [SMALL_STATE(7626)] = 334422,
  [SMALL_STATE(7627)] = 334487,
  [SMALL_STATE(7628)] = 334552,
  [SMALL_STATE(7629)] = 334617,
  [SMALL_STATE(7630)] = 334682,
  [SMALL_STATE(7631)] = 334745,
  [SMALL_STATE(7632)] = 334810,
  [SMALL_STATE(7633)] = 334875,
  [SMALL_STATE(7634)] = 334940,
  [SMALL_STATE(7635)] = 335005,
  [SMALL_STATE(7636)] = 335070,
  [SMALL_STATE(7637)] = 335135,
  [SMALL_STATE(7638)] = 335200,
  [SMALL_STATE(7639)] = 335265,
  [SMALL_STATE(7640)] = 335330,
  [SMALL_STATE(7641)] = 335395,
  [SMALL_STATE(7642)] = 335460,
  [SMALL_STATE(7643)] = 335525,
  [SMALL_STATE(7644)] = 335590,
  [SMALL_STATE(7645)] = 335655,
  [SMALL_STATE(7646)] = 335720,
  [SMALL_STATE(7647)] = 335785,
  [SMALL_STATE(7648)] = 335850,
  [SMALL_STATE(7649)] = 335915,
  [SMALL_STATE(7650)] = 335980,
  [SMALL_STATE(7651)] = 336045,
  [SMALL_STATE(7652)] = 336110,
  [SMALL_STATE(7653)] = 336175,
  [SMALL_STATE(7654)] = 336240,
  [SMALL_STATE(7655)] = 336305,
  [SMALL_STATE(7656)] = 336370,
  [SMALL_STATE(7657)] = 336435,
  [SMALL_STATE(7658)] = 336500,
  [SMALL_STATE(7659)] = 336565,
  [SMALL_STATE(7660)] = 336630,
  [SMALL_STATE(7661)] = 336695,
  [SMALL_STATE(7662)] = 336760,
  [SMALL_STATE(7663)] = 336817,
  [SMALL_STATE(7664)] = 336882,
  [SMALL_STATE(7665)] = 336947,
  [SMALL_STATE(7666)] = 337012,
  [SMALL_STATE(7667)] = 337077,
  [SMALL_STATE(7668)] = 337142,
  [SMALL_STATE(7669)] = 337207,
  [SMALL_STATE(7670)] = 337269,
  [SMALL_STATE(7671)] = 337331,
  [SMALL_STATE(7672)] = 337393,
  [SMALL_STATE(7673)] = 337455,
  [SMALL_STATE(7674)] = 337517,
  [SMALL_STATE(7675)] = 337579,
  [SMALL_STATE(7676)] = 337641,
  [SMALL_STATE(7677)] = 337703,
  [SMALL_STATE(7678)] = 337765,
  [SMALL_STATE(7679)] = 337827,
  [SMALL_STATE(7680)] = 337889,
  [SMALL_STATE(7681)] = 337951,
  [SMALL_STATE(7682)] = 338013,
  [SMALL_STATE(7683)] = 338075,
  [SMALL_STATE(7684)] = 338137,
  [SMALL_STATE(7685)] = 338199,
  [SMALL_STATE(7686)] = 338261,
  [SMALL_STATE(7687)] = 338323,
  [SMALL_STATE(7688)] = 338385,
  [SMALL_STATE(7689)] = 338447,
  [SMALL_STATE(7690)] = 338505,
  [SMALL_STATE(7691)] = 338567,
  [SMALL_STATE(7692)] = 338615,
  [SMALL_STATE(7693)] = 338663,
  [SMALL_STATE(7694)] = 338725,
  [SMALL_STATE(7695)] = 338787,
  [SMALL_STATE(7696)] = 338849,
  [SMALL_STATE(7697)] = 338911,
  [SMALL_STATE(7698)] = 338973,
  [SMALL_STATE(7699)] = 339035,
  [SMALL_STATE(7700)] = 339097,
  [SMALL_STATE(7701)] = 339159,
  [SMALL_STATE(7702)] = 339221,
  [SMALL_STATE(7703)] = 339280,
  [SMALL_STATE(7704)] = 339337,
  [SMALL_STATE(7705)] = 339394,
  [SMALL_STATE(7706)] = 339453,
  [SMALL_STATE(7707)] = 339512,
  [SMALL_STATE(7708)] = 339571,
  [SMALL_STATE(7709)] = 339630,
  [SMALL_STATE(7710)] = 339689,
  [SMALL_STATE(7711)] = 339748,
  [SMALL_STATE(7712)] = 339807,
  [SMALL_STATE(7713)] = 339866,
  [SMALL_STATE(7714)] = 339925,
  [SMALL_STATE(7715)] = 339984,
  [SMALL_STATE(7716)] = 340031,
  [SMALL_STATE(7717)] = 340090,
  [SMALL_STATE(7718)] = 340149,
  [SMALL_STATE(7719)] = 340196,
  [SMALL_STATE(7720)] = 340255,
  [SMALL_STATE(7721)] = 340314,
  [SMALL_STATE(7722)] = 340373,
  [SMALL_STATE(7723)] = 340432,
  [SMALL_STATE(7724)] = 340489,
  [SMALL_STATE(7725)] = 340548,
  [SMALL_STATE(7726)] = 340607,
  [SMALL_STATE(7727)] = 340666,
  [SMALL_STATE(7728)] = 340725,
  [SMALL_STATE(7729)] = 340784,
  [SMALL_STATE(7730)] = 340843,
  [SMALL_STATE(7731)] = 340900,
  [SMALL_STATE(7732)] = 340957,
  [SMALL_STATE(7733)] = 341016,
  [SMALL_STATE(7734)] = 341075,
  [SMALL_STATE(7735)] = 341134,
  [SMALL_STATE(7736)] = 341193,
  [SMALL_STATE(7737)] = 341252,
  [SMALL_STATE(7738)] = 341311,
  [SMALL_STATE(7739)] = 341370,
  [SMALL_STATE(7740)] = 341427,
  [SMALL_STATE(7741)] = 341486,
  [SMALL_STATE(7742)] = 341545,
  [SMALL_STATE(7743)] = 341602,
  [SMALL_STATE(7744)] = 341661,
  [SMALL_STATE(7745)] = 341720,
  [SMALL_STATE(7746)] = 341779,
  [SMALL_STATE(7747)] = 341838,
  [SMALL_STATE(7748)] = 341897,
  [SMALL_STATE(7749)] = 341956,
  [SMALL_STATE(7750)] = 342015,
  [SMALL_STATE(7751)] = 342074,
  [SMALL_STATE(7752)] = 342133,
  [SMALL_STATE(7753)] = 342190,
  [SMALL_STATE(7754)] = 342237,
  [SMALL_STATE(7755)] = 342294,
  [SMALL_STATE(7756)] = 342353,
  [SMALL_STATE(7757)] = 342408,
  [SMALL_STATE(7758)] = 342465,
  [SMALL_STATE(7759)] = 342524,
  [SMALL_STATE(7760)] = 342583,
  [SMALL_STATE(7761)] = 342640,
  [SMALL_STATE(7762)] = 342687,
  [SMALL_STATE(7763)] = 342746,
  [SMALL_STATE(7764)] = 342803,
  [SMALL_STATE(7765)] = 342862,
  [SMALL_STATE(7766)] = 342921,
  [SMALL_STATE(7767)] = 342980,
  [SMALL_STATE(7768)] = 343039,
  [SMALL_STATE(7769)] = 343098,
  [SMALL_STATE(7770)] = 343157,
  [SMALL_STATE(7771)] = 343213,
  [SMALL_STATE(7772)] = 343269,
  [SMALL_STATE(7773)] = 343325,
  [SMALL_STATE(7774)] = 343381,
  [SMALL_STATE(7775)] = 343437,
  [SMALL_STATE(7776)] = 343493,
  [SMALL_STATE(7777)] = 343549,
  [SMALL_STATE(7778)] = 343605,
  [SMALL_STATE(7779)] = 343661,
  [SMALL_STATE(7780)] = 343717,
  [SMALL_STATE(7781)] = 343765,
  [SMALL_STATE(7782)] = 343813,
  [SMALL_STATE(7783)] = 343859,
  [SMALL_STATE(7784)] = 343905,
  [SMALL_STATE(7785)] = 343961,
  [SMALL_STATE(7786)] = 344007,
  [SMALL_STATE(7787)] = 344053,
  [SMALL_STATE(7788)] = 344103,
  [SMALL_STATE(7789)] = 344159,
  [SMALL_STATE(7790)] = 344215,
  [SMALL_STATE(7791)] = 344271,
  [SMALL_STATE(7792)] = 344327,
  [SMALL_STATE(7793)] = 344383,
  [SMALL_STATE(7794)] = 344439,
  [SMALL_STATE(7795)] = 344495,
  [SMALL_STATE(7796)] = 344551,
  [SMALL_STATE(7797)] = 344607,
  [SMALL_STATE(7798)] = 344663,
  [SMALL_STATE(7799)] = 344717,
  [SMALL_STATE(7800)] = 344773,
  [SMALL_STATE(7801)] = 344827,
  [SMALL_STATE(7802)] = 344883,
  [SMALL_STATE(7803)] = 344939,
  [SMALL_STATE(7804)] = 344995,
  [SMALL_STATE(7805)] = 345051,
  [SMALL_STATE(7806)] = 345107,
  [SMALL_STATE(7807)] = 345163,
  [SMALL_STATE(7808)] = 345219,
  [SMALL_STATE(7809)] = 345275,
  [SMALL_STATE(7810)] = 345329,
  [SMALL_STATE(7811)] = 345379,
  [SMALL_STATE(7812)] = 345435,
  [SMALL_STATE(7813)] = 345489,
  [SMALL_STATE(7814)] = 345545,
  [SMALL_STATE(7815)] = 345601,
  [SMALL_STATE(7816)] = 345657,
  [SMALL_STATE(7817)] = 345711,
  [SMALL_STATE(7818)] = 345767,
  [SMALL_STATE(7819)] = 345823,
  [SMALL_STATE(7820)] = 345879,
  [SMALL_STATE(7821)] = 345929,
  [SMALL_STATE(7822)] = 345985,
  [SMALL_STATE(7823)] = 346041,
  [SMALL_STATE(7824)] = 346095,
  [SMALL_STATE(7825)] = 346151,
  [SMALL_STATE(7826)] = 346207,
  [SMALL_STATE(7827)] = 346263,
  [SMALL_STATE(7828)] = 346319,
  [SMALL_STATE(7829)] = 346375,
  [SMALL_STATE(7830)] = 346431,
  [SMALL_STATE(7831)] = 346487,
  [SMALL_STATE(7832)] = 346537,
  [SMALL_STATE(7833)] = 346593,
  [SMALL_STATE(7834)] = 346649,
  [SMALL_STATE(7835)] = 346697,
  [SMALL_STATE(7836)] = 346751,
  [SMALL_STATE(7837)] = 346807,
  [SMALL_STATE(7838)] = 346857,
  [SMALL_STATE(7839)] = 346911,
  [SMALL_STATE(7840)] = 346967,
  [SMALL_STATE(7841)] = 347023,
  [SMALL_STATE(7842)] = 347079,
  [SMALL_STATE(7843)] = 347135,
  [SMALL_STATE(7844)] = 347187,
  [SMALL_STATE(7845)] = 347243,
  [SMALL_STATE(7846)] = 347299,
  [SMALL_STATE(7847)] = 347355,
  [SMALL_STATE(7848)] = 347411,
  [SMALL_STATE(7849)] = 347467,
  [SMALL_STATE(7850)] = 347523,
  [SMALL_STATE(7851)] = 347579,
  [SMALL_STATE(7852)] = 347635,
  [SMALL_STATE(7853)] = 347691,
  [SMALL_STATE(7854)] = 347747,
  [SMALL_STATE(7855)] = 347803,
  [SMALL_STATE(7856)] = 347859,
  [SMALL_STATE(7857)] = 347915,
  [SMALL_STATE(7858)] = 347971,
  [SMALL_STATE(7859)] = 348027,
  [SMALL_STATE(7860)] = 348083,
  [SMALL_STATE(7861)] = 348139,
  [SMALL_STATE(7862)] = 348195,
  [SMALL_STATE(7863)] = 348251,
  [SMALL_STATE(7864)] = 348307,
  [SMALL_STATE(7865)] = 348363,
  [SMALL_STATE(7866)] = 348419,
  [SMALL_STATE(7867)] = 348475,
  [SMALL_STATE(7868)] = 348531,
  [SMALL_STATE(7869)] = 348587,
  [SMALL_STATE(7870)] = 348643,
  [SMALL_STATE(7871)] = 348699,
  [SMALL_STATE(7872)] = 348755,
  [SMALL_STATE(7873)] = 348811,
  [SMALL_STATE(7874)] = 348865,
  [SMALL_STATE(7875)] = 348921,
  [SMALL_STATE(7876)] = 348977,
  [SMALL_STATE(7877)] = 349033,
  [SMALL_STATE(7878)] = 349089,
  [SMALL_STATE(7879)] = 349145,
  [SMALL_STATE(7880)] = 349197,
  [SMALL_STATE(7881)] = 349253,
  [SMALL_STATE(7882)] = 349309,
  [SMALL_STATE(7883)] = 349365,
  [SMALL_STATE(7884)] = 349421,
  [SMALL_STATE(7885)] = 349477,
  [SMALL_STATE(7886)] = 349533,
  [SMALL_STATE(7887)] = 349589,
  [SMALL_STATE(7888)] = 349645,
  [SMALL_STATE(7889)] = 349701,
  [SMALL_STATE(7890)] = 349757,
  [SMALL_STATE(7891)] = 349811,
  [SMALL_STATE(7892)] = 349867,
  [SMALL_STATE(7893)] = 349923,
  [SMALL_STATE(7894)] = 349979,
  [SMALL_STATE(7895)] = 350035,
  [SMALL_STATE(7896)] = 350089,
  [SMALL_STATE(7897)] = 350145,
  [SMALL_STATE(7898)] = 350201,
  [SMALL_STATE(7899)] = 350257,
  [SMALL_STATE(7900)] = 350313,
  [SMALL_STATE(7901)] = 350369,
  [SMALL_STATE(7902)] = 350425,
  [SMALL_STATE(7903)] = 350481,
  [SMALL_STATE(7904)] = 350537,
  [SMALL_STATE(7905)] = 350593,
  [SMALL_STATE(7906)] = 350649,
  [SMALL_STATE(7907)] = 350705,
  [SMALL_STATE(7908)] = 350761,
  [SMALL_STATE(7909)] = 350817,
  [SMALL_STATE(7910)] = 350873,
  [SMALL_STATE(7911)] = 350929,
  [SMALL_STATE(7912)] = 350985,
  [SMALL_STATE(7913)] = 351041,
  [SMALL_STATE(7914)] = 351097,
  [SMALL_STATE(7915)] = 351153,
  [SMALL_STATE(7916)] = 351209,
  [SMALL_STATE(7917)] = 351265,
  [SMALL_STATE(7918)] = 351321,
  [SMALL_STATE(7919)] = 351377,
  [SMALL_STATE(7920)] = 351433,
  [SMALL_STATE(7921)] = 351489,
  [SMALL_STATE(7922)] = 351545,
  [SMALL_STATE(7923)] = 351593,
  [SMALL_STATE(7924)] = 351649,
  [SMALL_STATE(7925)] = 351705,
  [SMALL_STATE(7926)] = 351761,
  [SMALL_STATE(7927)] = 351817,
  [SMALL_STATE(7928)] = 351873,
  [SMALL_STATE(7929)] = 351927,
  [SMALL_STATE(7930)] = 351983,
  [SMALL_STATE(7931)] = 352037,
  [SMALL_STATE(7932)] = 352093,
  [SMALL_STATE(7933)] = 352149,
  [SMALL_STATE(7934)] = 352205,
  [SMALL_STATE(7935)] = 352261,
  [SMALL_STATE(7936)] = 352317,
  [SMALL_STATE(7937)] = 352373,
  [SMALL_STATE(7938)] = 352429,
  [SMALL_STATE(7939)] = 352485,
  [SMALL_STATE(7940)] = 352541,
  [SMALL_STATE(7941)] = 352597,
  [SMALL_STATE(7942)] = 352653,
  [SMALL_STATE(7943)] = 352706,
  [SMALL_STATE(7944)] = 352759,
  [SMALL_STATE(7945)] = 352810,
  [SMALL_STATE(7946)] = 352863,
  [SMALL_STATE(7947)] = 352916,
  [SMALL_STATE(7948)] = 352969,
  [SMALL_STATE(7949)] = 353014,
  [SMALL_STATE(7950)] = 353065,
  [SMALL_STATE(7951)] = 353110,
  [SMALL_STATE(7952)] = 353163,
  [SMALL_STATE(7953)] = 353216,
  [SMALL_STATE(7954)] = 353269,
  [SMALL_STATE(7955)] = 353322,
  [SMALL_STATE(7956)] = 353373,
  [SMALL_STATE(7957)] = 353426,
  [SMALL_STATE(7958)] = 353479,
  [SMALL_STATE(7959)] = 353532,
  [SMALL_STATE(7960)] = 353583,
  [SMALL_STATE(7961)] = 353636,
  [SMALL_STATE(7962)] = 353689,
  [SMALL_STATE(7963)] = 353742,
  [SMALL_STATE(7964)] = 353795,
  [SMALL_STATE(7965)] = 353846,
  [SMALL_STATE(7966)] = 353899,
  [SMALL_STATE(7967)] = 353950,
  [SMALL_STATE(7968)] = 354003,
  [SMALL_STATE(7969)] = 354056,
  [SMALL_STATE(7970)] = 354109,
  [SMALL_STATE(7971)] = 354162,
  [SMALL_STATE(7972)] = 354215,
  [SMALL_STATE(7973)] = 354268,
  [SMALL_STATE(7974)] = 354321,
  [SMALL_STATE(7975)] = 354374,
  [SMALL_STATE(7976)] = 354427,
  [SMALL_STATE(7977)] = 354480,
  [SMALL_STATE(7978)] = 354533,
  [SMALL_STATE(7979)] = 354586,
  [SMALL_STATE(7980)] = 354637,
  [SMALL_STATE(7981)] = 354690,
  [SMALL_STATE(7982)] = 354743,
  [SMALL_STATE(7983)] = 354796,
  [SMALL_STATE(7984)] = 354849,
  [SMALL_STATE(7985)] = 354902,
  [SMALL_STATE(7986)] = 354955,
  [SMALL_STATE(7987)] = 355008,
  [SMALL_STATE(7988)] = 355061,
  [SMALL_STATE(7989)] = 355114,
  [SMALL_STATE(7990)] = 355167,
  [SMALL_STATE(7991)] = 355220,
  [SMALL_STATE(7992)] = 355271,
  [SMALL_STATE(7993)] = 355324,
  [SMALL_STATE(7994)] = 355377,
  [SMALL_STATE(7995)] = 355422,
  [SMALL_STATE(7996)] = 355467,
  [SMALL_STATE(7997)] = 355520,
  [SMALL_STATE(7998)] = 355573,
  [SMALL_STATE(7999)] = 355626,
  [SMALL_STATE(8000)] = 355679,
  [SMALL_STATE(8001)] = 355732,
  [SMALL_STATE(8002)] = 355785,
  [SMALL_STATE(8003)] = 355838,
  [SMALL_STATE(8004)] = 355891,
  [SMALL_STATE(8005)] = 355942,
  [SMALL_STATE(8006)] = 355995,
  [SMALL_STATE(8007)] = 356048,
  [SMALL_STATE(8008)] = 356101,
  [SMALL_STATE(8009)] = 356154,
  [SMALL_STATE(8010)] = 356199,
  [SMALL_STATE(8011)] = 356252,
  [SMALL_STATE(8012)] = 356305,
  [SMALL_STATE(8013)] = 356358,
  [SMALL_STATE(8014)] = 356409,
  [SMALL_STATE(8015)] = 356462,
  [SMALL_STATE(8016)] = 356515,
  [SMALL_STATE(8017)] = 356568,
  [SMALL_STATE(8018)] = 356621,
  [SMALL_STATE(8019)] = 356674,
  [SMALL_STATE(8020)] = 356727,
  [SMALL_STATE(8021)] = 356778,
  [SMALL_STATE(8022)] = 356831,
  [SMALL_STATE(8023)] = 356884,
  [SMALL_STATE(8024)] = 356937,
  [SMALL_STATE(8025)] = 356990,
  [SMALL_STATE(8026)] = 357043,
  [SMALL_STATE(8027)] = 357092,
  [SMALL_STATE(8028)] = 357145,
  [SMALL_STATE(8029)] = 357198,
  [SMALL_STATE(8030)] = 357251,
  [SMALL_STATE(8031)] = 357304,
  [SMALL_STATE(8032)] = 357357,
  [SMALL_STATE(8033)] = 357410,
  [SMALL_STATE(8034)] = 357463,
  [SMALL_STATE(8035)] = 357514,
  [SMALL_STATE(8036)] = 357567,
  [SMALL_STATE(8037)] = 357620,
  [SMALL_STATE(8038)] = 357673,
  [SMALL_STATE(8039)] = 357726,
  [SMALL_STATE(8040)] = 357779,
  [SMALL_STATE(8041)] = 357830,
  [SMALL_STATE(8042)] = 357883,
  [SMALL_STATE(8043)] = 357936,
  [SMALL_STATE(8044)] = 357987,
  [SMALL_STATE(8045)] = 358040,
  [SMALL_STATE(8046)] = 358093,
  [SMALL_STATE(8047)] = 358146,
  [SMALL_STATE(8048)] = 358197,
  [SMALL_STATE(8049)] = 358250,
  [SMALL_STATE(8050)] = 358303,
  [SMALL_STATE(8051)] = 358356,
  [SMALL_STATE(8052)] = 358409,
  [SMALL_STATE(8053)] = 358462,
  [SMALL_STATE(8054)] = 358515,
  [SMALL_STATE(8055)] = 358568,
  [SMALL_STATE(8056)] = 358621,
  [SMALL_STATE(8057)] = 358674,
  [SMALL_STATE(8058)] = 358721,
  [SMALL_STATE(8059)] = 358768,
  [SMALL_STATE(8060)] = 358817,
  [SMALL_STATE(8061)] = 358864,
  [SMALL_STATE(8062)] = 358913,
  [SMALL_STATE(8063)] = 358966,
  [SMALL_STATE(8064)] = 359019,
  [SMALL_STATE(8065)] = 359072,
  [SMALL_STATE(8066)] = 359125,
  [SMALL_STATE(8067)] = 359178,
  [SMALL_STATE(8068)] = 359231,
  [SMALL_STATE(8069)] = 359282,
  [SMALL_STATE(8070)] = 359335,
  [SMALL_STATE(8071)] = 359388,
  [SMALL_STATE(8072)] = 359441,
  [SMALL_STATE(8073)] = 359494,
  [SMALL_STATE(8074)] = 359547,
  [SMALL_STATE(8075)] = 359600,
  [SMALL_STATE(8076)] = 359653,
  [SMALL_STATE(8077)] = 359706,
  [SMALL_STATE(8078)] = 359759,
  [SMALL_STATE(8079)] = 359812,
  [SMALL_STATE(8080)] = 359863,
  [SMALL_STATE(8081)] = 359916,
  [SMALL_STATE(8082)] = 359969,
  [SMALL_STATE(8083)] = 360022,
  [SMALL_STATE(8084)] = 360075,
  [SMALL_STATE(8085)] = 360126,
  [SMALL_STATE(8086)] = 360179,
  [SMALL_STATE(8087)] = 360232,
  [SMALL_STATE(8088)] = 360285,
  [SMALL_STATE(8089)] = 360338,
  [SMALL_STATE(8090)] = 360391,
  [SMALL_STATE(8091)] = 360438,
  [SMALL_STATE(8092)] = 360485,
  [SMALL_STATE(8093)] = 360538,
  [SMALL_STATE(8094)] = 360589,
  [SMALL_STATE(8095)] = 360642,
  [SMALL_STATE(8096)] = 360695,
  [SMALL_STATE(8097)] = 360748,
  [SMALL_STATE(8098)] = 360799,
  [SMALL_STATE(8099)] = 360852,
  [SMALL_STATE(8100)] = 360905,
  [SMALL_STATE(8101)] = 360958,
  [SMALL_STATE(8102)] = 361009,
  [SMALL_STATE(8103)] = 361062,
  [SMALL_STATE(8104)] = 361115,
  [SMALL_STATE(8105)] = 361168,
  [SMALL_STATE(8106)] = 361219,
  [SMALL_STATE(8107)] = 361270,
  [SMALL_STATE(8108)] = 361323,
  [SMALL_STATE(8109)] = 361376,
  [SMALL_STATE(8110)] = 361427,
  [SMALL_STATE(8111)] = 361480,
  [SMALL_STATE(8112)] = 361533,
  [SMALL_STATE(8113)] = 361586,
  [SMALL_STATE(8114)] = 361639,
  [SMALL_STATE(8115)] = 361692,
  [SMALL_STATE(8116)] = 361739,
  [SMALL_STATE(8117)] = 361792,
  [SMALL_STATE(8118)] = 361837,
  [SMALL_STATE(8119)] = 361890,
  [SMALL_STATE(8120)] = 361943,
  [SMALL_STATE(8121)] = 361996,
  [SMALL_STATE(8122)] = 362049,
  [SMALL_STATE(8123)] = 362100,
  [SMALL_STATE(8124)] = 362153,
  [SMALL_STATE(8125)] = 362206,
  [SMALL_STATE(8126)] = 362253,
  [SMALL_STATE(8127)] = 362306,
  [SMALL_STATE(8128)] = 362359,
  [SMALL_STATE(8129)] = 362404,
  [SMALL_STATE(8130)] = 362457,
  [SMALL_STATE(8131)] = 362510,
  [SMALL_STATE(8132)] = 362563,
  [SMALL_STATE(8133)] = 362608,
  [SMALL_STATE(8134)] = 362661,
  [SMALL_STATE(8135)] = 362714,
  [SMALL_STATE(8136)] = 362767,
  [SMALL_STATE(8137)] = 362812,
  [SMALL_STATE(8138)] = 362865,
  [SMALL_STATE(8139)] = 362918,
  [SMALL_STATE(8140)] = 362971,
  [SMALL_STATE(8141)] = 363020,
  [SMALL_STATE(8142)] = 363073,
  [SMALL_STATE(8143)] = 363126,
  [SMALL_STATE(8144)] = 363171,
  [SMALL_STATE(8145)] = 363216,
  [SMALL_STATE(8146)] = 363269,
  [SMALL_STATE(8147)] = 363322,
  [SMALL_STATE(8148)] = 363373,
  [SMALL_STATE(8149)] = 363426,
  [SMALL_STATE(8150)] = 363479,
  [SMALL_STATE(8151)] = 363532,
  [SMALL_STATE(8152)] = 363579,
  [SMALL_STATE(8153)] = 363632,
  [SMALL_STATE(8154)] = 363677,
  [SMALL_STATE(8155)] = 363730,
  [SMALL_STATE(8156)] = 363783,
  [SMALL_STATE(8157)] = 363836,
  [SMALL_STATE(8158)] = 363889,
  [SMALL_STATE(8159)] = 363942,
  [SMALL_STATE(8160)] = 363995,
  [SMALL_STATE(8161)] = 364042,
  [SMALL_STATE(8162)] = 364095,
  [SMALL_STATE(8163)] = 364148,
  [SMALL_STATE(8164)] = 364193,
  [SMALL_STATE(8165)] = 364246,
  [SMALL_STATE(8166)] = 364291,
  [SMALL_STATE(8167)] = 364344,
  [SMALL_STATE(8168)] = 364391,
  [SMALL_STATE(8169)] = 364444,
  [SMALL_STATE(8170)] = 364497,
  [SMALL_STATE(8171)] = 364550,
  [SMALL_STATE(8172)] = 364599,
  [SMALL_STATE(8173)] = 364644,
  [SMALL_STATE(8174)] = 364697,
  [SMALL_STATE(8175)] = 364750,
  [SMALL_STATE(8176)] = 364803,
  [SMALL_STATE(8177)] = 364856,
  [SMALL_STATE(8178)] = 364907,
  [SMALL_STATE(8179)] = 364960,
  [SMALL_STATE(8180)] = 365011,
  [SMALL_STATE(8181)] = 365064,
  [SMALL_STATE(8182)] = 365117,
  [SMALL_STATE(8183)] = 365170,
  [SMALL_STATE(8184)] = 365223,
  [SMALL_STATE(8185)] = 365276,
  [SMALL_STATE(8186)] = 365329,
  [SMALL_STATE(8187)] = 365382,
  [SMALL_STATE(8188)] = 365435,
  [SMALL_STATE(8189)] = 365488,
  [SMALL_STATE(8190)] = 365537,
  [SMALL_STATE(8191)] = 365590,
  [SMALL_STATE(8192)] = 365643,
  [SMALL_STATE(8193)] = 365696,
  [SMALL_STATE(8194)] = 365749,
  [SMALL_STATE(8195)] = 365802,
  [SMALL_STATE(8196)] = 365855,
  [SMALL_STATE(8197)] = 365908,
  [SMALL_STATE(8198)] = 365961,
  [SMALL_STATE(8199)] = 366014,
  [SMALL_STATE(8200)] = 366067,
  [SMALL_STATE(8201)] = 366120,
  [SMALL_STATE(8202)] = 366173,
  [SMALL_STATE(8203)] = 366226,
  [SMALL_STATE(8204)] = 366279,
  [SMALL_STATE(8205)] = 366332,
  [SMALL_STATE(8206)] = 366385,
  [SMALL_STATE(8207)] = 366438,
  [SMALL_STATE(8208)] = 366491,
  [SMALL_STATE(8209)] = 366544,
  [SMALL_STATE(8210)] = 366597,
  [SMALL_STATE(8211)] = 366650,
  [SMALL_STATE(8212)] = 366703,
  [SMALL_STATE(8213)] = 366756,
  [SMALL_STATE(8214)] = 366809,
  [SMALL_STATE(8215)] = 366862,
  [SMALL_STATE(8216)] = 366909,
  [SMALL_STATE(8217)] = 366962,
  [SMALL_STATE(8218)] = 367015,
  [SMALL_STATE(8219)] = 367068,
  [SMALL_STATE(8220)] = 367121,
  [SMALL_STATE(8221)] = 367174,
  [SMALL_STATE(8222)] = 367227,
  [SMALL_STATE(8223)] = 367280,
  [SMALL_STATE(8224)] = 367333,
  [SMALL_STATE(8225)] = 367384,
  [SMALL_STATE(8226)] = 367437,
  [SMALL_STATE(8227)] = 367490,
  [SMALL_STATE(8228)] = 367543,
  [SMALL_STATE(8229)] = 367588,
  [SMALL_STATE(8230)] = 367641,
  [SMALL_STATE(8231)] = 367694,
  [SMALL_STATE(8232)] = 367747,
  [SMALL_STATE(8233)] = 367800,
  [SMALL_STATE(8234)] = 367853,
  [SMALL_STATE(8235)] = 367906,
  [SMALL_STATE(8236)] = 367959,
  [SMALL_STATE(8237)] = 368012,
  [SMALL_STATE(8238)] = 368065,
  [SMALL_STATE(8239)] = 368118,
  [SMALL_STATE(8240)] = 368171,
  [SMALL_STATE(8241)] = 368219,
  [SMALL_STATE(8242)] = 368269,
  [SMALL_STATE(8243)] = 368319,
  [SMALL_STATE(8244)] = 368369,
  [SMALL_STATE(8245)] = 368419,
  [SMALL_STATE(8246)] = 368469,
  [SMALL_STATE(8247)] = 368519,
  [SMALL_STATE(8248)] = 368569,
  [SMALL_STATE(8249)] = 368619,
  [SMALL_STATE(8250)] = 368669,
  [SMALL_STATE(8251)] = 368719,
  [SMALL_STATE(8252)] = 368769,
  [SMALL_STATE(8253)] = 368815,
  [SMALL_STATE(8254)] = 368865,
  [SMALL_STATE(8255)] = 368915,
  [SMALL_STATE(8256)] = 368965,
  [SMALL_STATE(8257)] = 369015,
  [SMALL_STATE(8258)] = 369065,
  [SMALL_STATE(8259)] = 369115,
  [SMALL_STATE(8260)] = 369165,
  [SMALL_STATE(8261)] = 369211,
  [SMALL_STATE(8262)] = 369255,
  [SMALL_STATE(8263)] = 369305,
  [SMALL_STATE(8264)] = 369355,
  [SMALL_STATE(8265)] = 369405,
  [SMALL_STATE(8266)] = 369455,
  [SMALL_STATE(8267)] = 369505,
  [SMALL_STATE(8268)] = 369551,
  [SMALL_STATE(8269)] = 369601,
  [SMALL_STATE(8270)] = 369651,
  [SMALL_STATE(8271)] = 369701,
  [SMALL_STATE(8272)] = 369751,
  [SMALL_STATE(8273)] = 369801,
  [SMALL_STATE(8274)] = 369851,
  [SMALL_STATE(8275)] = 369897,
  [SMALL_STATE(8276)] = 369943,
  [SMALL_STATE(8277)] = 369993,
  [SMALL_STATE(8278)] = 370043,
  [SMALL_STATE(8279)] = 370093,
  [SMALL_STATE(8280)] = 370143,
  [SMALL_STATE(8281)] = 370191,
  [SMALL_STATE(8282)] = 370241,
  [SMALL_STATE(8283)] = 370289,
  [SMALL_STATE(8284)] = 370335,
  [SMALL_STATE(8285)] = 370385,
  [SMALL_STATE(8286)] = 370435,
  [SMALL_STATE(8287)] = 370485,
  [SMALL_STATE(8288)] = 370535,
  [SMALL_STATE(8289)] = 370585,
  [SMALL_STATE(8290)] = 370635,
  [SMALL_STATE(8291)] = 370685,
  [SMALL_STATE(8292)] = 370735,
  [SMALL_STATE(8293)] = 370781,
  [SMALL_STATE(8294)] = 370831,
  [SMALL_STATE(8295)] = 370881,
  [SMALL_STATE(8296)] = 370931,
  [SMALL_STATE(8297)] = 370977,
  [SMALL_STATE(8298)] = 371027,
  [SMALL_STATE(8299)] = 371077,
  [SMALL_STATE(8300)] = 371127,
  [SMALL_STATE(8301)] = 371177,
  [SMALL_STATE(8302)] = 371227,
  [SMALL_STATE(8303)] = 371271,
  [SMALL_STATE(8304)] = 371321,
  [SMALL_STATE(8305)] = 371365,
  [SMALL_STATE(8306)] = 371415,
  [SMALL_STATE(8307)] = 371459,
  [SMALL_STATE(8308)] = 371509,
  [SMALL_STATE(8309)] = 371559,
  [SMALL_STATE(8310)] = 371603,
  [SMALL_STATE(8311)] = 371647,
  [SMALL_STATE(8312)] = 371697,
  [SMALL_STATE(8313)] = 371747,
  [SMALL_STATE(8314)] = 371797,
  [SMALL_STATE(8315)] = 371847,
  [SMALL_STATE(8316)] = 371893,
  [SMALL_STATE(8317)] = 371943,
  [SMALL_STATE(8318)] = 371993,
  [SMALL_STATE(8319)] = 372043,
  [SMALL_STATE(8320)] = 372093,
  [SMALL_STATE(8321)] = 372143,
  [SMALL_STATE(8322)] = 372191,
  [SMALL_STATE(8323)] = 372237,
  [SMALL_STATE(8324)] = 372287,
  [SMALL_STATE(8325)] = 372331,
  [SMALL_STATE(8326)] = 372381,
  [SMALL_STATE(8327)] = 372431,
  [SMALL_STATE(8328)] = 372481,
  [SMALL_STATE(8329)] = 372531,
  [SMALL_STATE(8330)] = 372575,
  [SMALL_STATE(8331)] = 372619,
  [SMALL_STATE(8332)] = 372665,
  [SMALL_STATE(8333)] = 372715,
  [SMALL_STATE(8334)] = 372765,
  [SMALL_STATE(8335)] = 372813,
  [SMALL_STATE(8336)] = 372857,
  [SMALL_STATE(8337)] = 372907,
  [SMALL_STATE(8338)] = 372957,
  [SMALL_STATE(8339)] = 373007,
  [SMALL_STATE(8340)] = 373051,
  [SMALL_STATE(8341)] = 373101,
  [SMALL_STATE(8342)] = 373151,
  [SMALL_STATE(8343)] = 373201,
  [SMALL_STATE(8344)] = 373247,
  [SMALL_STATE(8345)] = 373295,
  [SMALL_STATE(8346)] = 373343,
  [SMALL_STATE(8347)] = 373391,
  [SMALL_STATE(8348)] = 373435,
  [SMALL_STATE(8349)] = 373483,
  [SMALL_STATE(8350)] = 373533,
  [SMALL_STATE(8351)] = 373583,
  [SMALL_STATE(8352)] = 373633,
  [SMALL_STATE(8353)] = 373683,
  [SMALL_STATE(8354)] = 373733,
  [SMALL_STATE(8355)] = 373783,
  [SMALL_STATE(8356)] = 373833,
  [SMALL_STATE(8357)] = 373877,
  [SMALL_STATE(8358)] = 373921,
  [SMALL_STATE(8359)] = 373969,
  [SMALL_STATE(8360)] = 374013,
  [SMALL_STATE(8361)] = 374063,
  [SMALL_STATE(8362)] = 374109,
  [SMALL_STATE(8363)] = 374153,
  [SMALL_STATE(8364)] = 374203,
  [SMALL_STATE(8365)] = 374249,
  [SMALL_STATE(8366)] = 374297,
  [SMALL_STATE(8367)] = 374343,
  [SMALL_STATE(8368)] = 374389,
  [SMALL_STATE(8369)] = 374435,
  [SMALL_STATE(8370)] = 374485,
  [SMALL_STATE(8371)] = 374531,
  [SMALL_STATE(8372)] = 374579,
  [SMALL_STATE(8373)] = 374629,
  [SMALL_STATE(8374)] = 374679,
  [SMALL_STATE(8375)] = 374727,
  [SMALL_STATE(8376)] = 374777,
  [SMALL_STATE(8377)] = 374825,
  [SMALL_STATE(8378)] = 374872,
  [SMALL_STATE(8379)] = 374919,
  [SMALL_STATE(8380)] = 374962,
  [SMALL_STATE(8381)] = 375007,
  [SMALL_STATE(8382)] = 375054,
  [SMALL_STATE(8383)] = 375101,
  [SMALL_STATE(8384)] = 375148,
  [SMALL_STATE(8385)] = 375191,
  [SMALL_STATE(8386)] = 375238,
  [SMALL_STATE(8387)] = 375285,
  [SMALL_STATE(8388)] = 375332,
  [SMALL_STATE(8389)] = 375375,
  [SMALL_STATE(8390)] = 375420,
  [SMALL_STATE(8391)] = 375467,
  [SMALL_STATE(8392)] = 375514,
  [SMALL_STATE(8393)] = 375557,
  [SMALL_STATE(8394)] = 375604,
  [SMALL_STATE(8395)] = 375651,
  [SMALL_STATE(8396)] = 375698,
  [SMALL_STATE(8397)] = 375745,
  [SMALL_STATE(8398)] = 375788,
  [SMALL_STATE(8399)] = 375835,
  [SMALL_STATE(8400)] = 375880,
  [SMALL_STATE(8401)] = 375927,
  [SMALL_STATE(8402)] = 375974,
  [SMALL_STATE(8403)] = 376021,
  [SMALL_STATE(8404)] = 376068,
  [SMALL_STATE(8405)] = 376115,
  [SMALL_STATE(8406)] = 376162,
  [SMALL_STATE(8407)] = 376209,
  [SMALL_STATE(8408)] = 376256,
  [SMALL_STATE(8409)] = 376303,
  [SMALL_STATE(8410)] = 376350,
  [SMALL_STATE(8411)] = 376397,
  [SMALL_STATE(8412)] = 376444,
  [SMALL_STATE(8413)] = 376491,
  [SMALL_STATE(8414)] = 376538,
  [SMALL_STATE(8415)] = 376585,
  [SMALL_STATE(8416)] = 376632,
  [SMALL_STATE(8417)] = 376679,
  [SMALL_STATE(8418)] = 376726,
  [SMALL_STATE(8419)] = 376773,
  [SMALL_STATE(8420)] = 376818,
  [SMALL_STATE(8421)] = 376865,
  [SMALL_STATE(8422)] = 376912,
  [SMALL_STATE(8423)] = 376959,
  [SMALL_STATE(8424)] = 377006,
  [SMALL_STATE(8425)] = 377053,
  [SMALL_STATE(8426)] = 377096,
  [SMALL_STATE(8427)] = 377139,
  [SMALL_STATE(8428)] = 377186,
  [SMALL_STATE(8429)] = 377233,
  [SMALL_STATE(8430)] = 377280,
  [SMALL_STATE(8431)] = 377327,
  [SMALL_STATE(8432)] = 377372,
  [SMALL_STATE(8433)] = 377419,
  [SMALL_STATE(8434)] = 377466,
  [SMALL_STATE(8435)] = 377513,
  [SMALL_STATE(8436)] = 377560,
  [SMALL_STATE(8437)] = 377607,
  [SMALL_STATE(8438)] = 377654,
  [SMALL_STATE(8439)] = 377701,
  [SMALL_STATE(8440)] = 377748,
  [SMALL_STATE(8441)] = 377791,
  [SMALL_STATE(8442)] = 377838,
  [SMALL_STATE(8443)] = 377883,
  [SMALL_STATE(8444)] = 377930,
  [SMALL_STATE(8445)] = 377977,
  [SMALL_STATE(8446)] = 378024,
  [SMALL_STATE(8447)] = 378071,
  [SMALL_STATE(8448)] = 378118,
  [SMALL_STATE(8449)] = 378165,
  [SMALL_STATE(8450)] = 378210,
  [SMALL_STATE(8451)] = 378257,
  [SMALL_STATE(8452)] = 378304,
  [SMALL_STATE(8453)] = 378351,
  [SMALL_STATE(8454)] = 378398,
  [SMALL_STATE(8455)] = 378445,
  [SMALL_STATE(8456)] = 378492,
  [SMALL_STATE(8457)] = 378539,
  [SMALL_STATE(8458)] = 378586,
  [SMALL_STATE(8459)] = 378633,
  [SMALL_STATE(8460)] = 378680,
  [SMALL_STATE(8461)] = 378727,
  [SMALL_STATE(8462)] = 378774,
  [SMALL_STATE(8463)] = 378819,
  [SMALL_STATE(8464)] = 378866,
  [SMALL_STATE(8465)] = 378913,
  [SMALL_STATE(8466)] = 378960,
  [SMALL_STATE(8467)] = 379007,
  [SMALL_STATE(8468)] = 379054,
  [SMALL_STATE(8469)] = 379101,
  [SMALL_STATE(8470)] = 379148,
  [SMALL_STATE(8471)] = 379195,
  [SMALL_STATE(8472)] = 379242,
  [SMALL_STATE(8473)] = 379289,
  [SMALL_STATE(8474)] = 379336,
  [SMALL_STATE(8475)] = 379383,
  [SMALL_STATE(8476)] = 379430,
  [SMALL_STATE(8477)] = 379477,
  [SMALL_STATE(8478)] = 379520,
  [SMALL_STATE(8479)] = 379567,
  [SMALL_STATE(8480)] = 379614,
  [SMALL_STATE(8481)] = 379661,
  [SMALL_STATE(8482)] = 379704,
  [SMALL_STATE(8483)] = 379751,
  [SMALL_STATE(8484)] = 379798,
  [SMALL_STATE(8485)] = 379841,
  [SMALL_STATE(8486)] = 379886,
  [SMALL_STATE(8487)] = 379933,
  [SMALL_STATE(8488)] = 379976,
  [SMALL_STATE(8489)] = 380023,
  [SMALL_STATE(8490)] = 380066,
  [SMALL_STATE(8491)] = 380113,
  [SMALL_STATE(8492)] = 380160,
  [SMALL_STATE(8493)] = 380207,
  [SMALL_STATE(8494)] = 380254,
  [SMALL_STATE(8495)] = 380299,
  [SMALL_STATE(8496)] = 380346,
  [SMALL_STATE(8497)] = 380393,
  [SMALL_STATE(8498)] = 380440,
  [SMALL_STATE(8499)] = 380487,
  [SMALL_STATE(8500)] = 380534,
  [SMALL_STATE(8501)] = 380581,
  [SMALL_STATE(8502)] = 380628,
  [SMALL_STATE(8503)] = 380675,
  [SMALL_STATE(8504)] = 380722,
  [SMALL_STATE(8505)] = 380769,
  [SMALL_STATE(8506)] = 380812,
  [SMALL_STATE(8507)] = 380859,
  [SMALL_STATE(8508)] = 380906,
  [SMALL_STATE(8509)] = 380953,
  [SMALL_STATE(8510)] = 380998,
  [SMALL_STATE(8511)] = 381045,
  [SMALL_STATE(8512)] = 381092,
  [SMALL_STATE(8513)] = 381139,
  [SMALL_STATE(8514)] = 381186,
  [SMALL_STATE(8515)] = 381231,
  [SMALL_STATE(8516)] = 381278,
  [SMALL_STATE(8517)] = 381325,
  [SMALL_STATE(8518)] = 381372,
  [SMALL_STATE(8519)] = 381417,
  [SMALL_STATE(8520)] = 381464,
  [SMALL_STATE(8521)] = 381511,
  [SMALL_STATE(8522)] = 381558,
  [SMALL_STATE(8523)] = 381605,
  [SMALL_STATE(8524)] = 381652,
  [SMALL_STATE(8525)] = 381699,
  [SMALL_STATE(8526)] = 381746,
  [SMALL_STATE(8527)] = 381793,
  [SMALL_STATE(8528)] = 381840,
  [SMALL_STATE(8529)] = 381887,
  [SMALL_STATE(8530)] = 381934,
  [SMALL_STATE(8531)] = 381981,
  [SMALL_STATE(8532)] = 382028,
  [SMALL_STATE(8533)] = 382075,
  [SMALL_STATE(8534)] = 382122,
  [SMALL_STATE(8535)] = 382169,
  [SMALL_STATE(8536)] = 382214,
  [SMALL_STATE(8537)] = 382259,
  [SMALL_STATE(8538)] = 382306,
  [SMALL_STATE(8539)] = 382353,
  [SMALL_STATE(8540)] = 382400,
  [SMALL_STATE(8541)] = 382447,
  [SMALL_STATE(8542)] = 382494,
  [SMALL_STATE(8543)] = 382541,
  [SMALL_STATE(8544)] = 382588,
  [SMALL_STATE(8545)] = 382635,
  [SMALL_STATE(8546)] = 382682,
  [SMALL_STATE(8547)] = 382727,
  [SMALL_STATE(8548)] = 382774,
  [SMALL_STATE(8549)] = 382819,
  [SMALL_STATE(8550)] = 382866,
  [SMALL_STATE(8551)] = 382913,
  [SMALL_STATE(8552)] = 382960,
  [SMALL_STATE(8553)] = 383007,
  [SMALL_STATE(8554)] = 383054,
  [SMALL_STATE(8555)] = 383101,
  [SMALL_STATE(8556)] = 383148,
  [SMALL_STATE(8557)] = 383195,
  [SMALL_STATE(8558)] = 383242,
  [SMALL_STATE(8559)] = 383289,
  [SMALL_STATE(8560)] = 383332,
  [SMALL_STATE(8561)] = 383379,
  [SMALL_STATE(8562)] = 383426,
  [SMALL_STATE(8563)] = 383471,
  [SMALL_STATE(8564)] = 383518,
  [SMALL_STATE(8565)] = 383565,
  [SMALL_STATE(8566)] = 383612,
  [SMALL_STATE(8567)] = 383659,
  [SMALL_STATE(8568)] = 383702,
  [SMALL_STATE(8569)] = 383749,
  [SMALL_STATE(8570)] = 383794,
  [SMALL_STATE(8571)] = 383841,
  [SMALL_STATE(8572)] = 383888,
  [SMALL_STATE(8573)] = 383935,
  [SMALL_STATE(8574)] = 383982,
  [SMALL_STATE(8575)] = 384025,
  [SMALL_STATE(8576)] = 384072,
  [SMALL_STATE(8577)] = 384119,
  [SMALL_STATE(8578)] = 384166,
  [SMALL_STATE(8579)] = 384213,
  [SMALL_STATE(8580)] = 384260,
  [SMALL_STATE(8581)] = 384307,
  [SMALL_STATE(8582)] = 384354,
  [SMALL_STATE(8583)] = 384401,
  [SMALL_STATE(8584)] = 384448,
  [SMALL_STATE(8585)] = 384495,
  [SMALL_STATE(8586)] = 384542,
  [SMALL_STATE(8587)] = 384589,
  [SMALL_STATE(8588)] = 384636,
  [SMALL_STATE(8589)] = 384683,
  [SMALL_STATE(8590)] = 384730,
  [SMALL_STATE(8591)] = 384777,
  [SMALL_STATE(8592)] = 384824,
  [SMALL_STATE(8593)] = 384871,
  [SMALL_STATE(8594)] = 384918,
  [SMALL_STATE(8595)] = 384965,
  [SMALL_STATE(8596)] = 385012,
  [SMALL_STATE(8597)] = 385059,
  [SMALL_STATE(8598)] = 385106,
  [SMALL_STATE(8599)] = 385153,
  [SMALL_STATE(8600)] = 385200,
  [SMALL_STATE(8601)] = 385247,
  [SMALL_STATE(8602)] = 385294,
  [SMALL_STATE(8603)] = 385341,
  [SMALL_STATE(8604)] = 385388,
  [SMALL_STATE(8605)] = 385435,
  [SMALL_STATE(8606)] = 385482,
  [SMALL_STATE(8607)] = 385529,
  [SMALL_STATE(8608)] = 385574,
  [SMALL_STATE(8609)] = 385621,
  [SMALL_STATE(8610)] = 385668,
  [SMALL_STATE(8611)] = 385715,
  [SMALL_STATE(8612)] = 385762,
  [SMALL_STATE(8613)] = 385809,
  [SMALL_STATE(8614)] = 385856,
  [SMALL_STATE(8615)] = 385903,
  [SMALL_STATE(8616)] = 385950,
  [SMALL_STATE(8617)] = 385997,
  [SMALL_STATE(8618)] = 386044,
  [SMALL_STATE(8619)] = 386091,
  [SMALL_STATE(8620)] = 386138,
  [SMALL_STATE(8621)] = 386185,
  [SMALL_STATE(8622)] = 386232,
  [SMALL_STATE(8623)] = 386279,
  [SMALL_STATE(8624)] = 386326,
  [SMALL_STATE(8625)] = 386373,
  [SMALL_STATE(8626)] = 386420,
  [SMALL_STATE(8627)] = 386467,
  [SMALL_STATE(8628)] = 386514,
  [SMALL_STATE(8629)] = 386561,
  [SMALL_STATE(8630)] = 386608,
  [SMALL_STATE(8631)] = 386655,
  [SMALL_STATE(8632)] = 386698,
  [SMALL_STATE(8633)] = 386745,
  [SMALL_STATE(8634)] = 386792,
  [SMALL_STATE(8635)] = 386835,
  [SMALL_STATE(8636)] = 386882,
  [SMALL_STATE(8637)] = 386929,
  [SMALL_STATE(8638)] = 386976,
  [SMALL_STATE(8639)] = 387023,
  [SMALL_STATE(8640)] = 387070,
  [SMALL_STATE(8641)] = 387117,
  [SMALL_STATE(8642)] = 387164,
  [SMALL_STATE(8643)] = 387209,
  [SMALL_STATE(8644)] = 387254,
  [SMALL_STATE(8645)] = 387301,
  [SMALL_STATE(8646)] = 387348,
  [SMALL_STATE(8647)] = 387395,
  [SMALL_STATE(8648)] = 387440,
  [SMALL_STATE(8649)] = 387487,
  [SMALL_STATE(8650)] = 387534,
  [SMALL_STATE(8651)] = 387581,
  [SMALL_STATE(8652)] = 387628,
  [SMALL_STATE(8653)] = 387675,
  [SMALL_STATE(8654)] = 387722,
  [SMALL_STATE(8655)] = 387769,
  [SMALL_STATE(8656)] = 387812,
  [SMALL_STATE(8657)] = 387859,
  [SMALL_STATE(8658)] = 387902,
  [SMALL_STATE(8659)] = 387947,
  [SMALL_STATE(8660)] = 387990,
  [SMALL_STATE(8661)] = 388037,
  [SMALL_STATE(8662)] = 388084,
  [SMALL_STATE(8663)] = 388131,
  [SMALL_STATE(8664)] = 388178,
  [SMALL_STATE(8665)] = 388223,
  [SMALL_STATE(8666)] = 388270,
  [SMALL_STATE(8667)] = 388317,
  [SMALL_STATE(8668)] = 388364,
  [SMALL_STATE(8669)] = 388411,
  [SMALL_STATE(8670)] = 388458,
  [SMALL_STATE(8671)] = 388505,
  [SMALL_STATE(8672)] = 388552,
  [SMALL_STATE(8673)] = 388599,
  [SMALL_STATE(8674)] = 388644,
  [SMALL_STATE(8675)] = 388691,
  [SMALL_STATE(8676)] = 388738,
  [SMALL_STATE(8677)] = 388783,
  [SMALL_STATE(8678)] = 388830,
  [SMALL_STATE(8679)] = 388873,
  [SMALL_STATE(8680)] = 388920,
  [SMALL_STATE(8681)] = 388967,
  [SMALL_STATE(8682)] = 389012,
  [SMALL_STATE(8683)] = 389059,
  [SMALL_STATE(8684)] = 389106,
  [SMALL_STATE(8685)] = 389151,
  [SMALL_STATE(8686)] = 389198,
  [SMALL_STATE(8687)] = 389243,
  [SMALL_STATE(8688)] = 389290,
  [SMALL_STATE(8689)] = 389337,
  [SMALL_STATE(8690)] = 389384,
  [SMALL_STATE(8691)] = 389431,
  [SMALL_STATE(8692)] = 389478,
  [SMALL_STATE(8693)] = 389525,
  [SMALL_STATE(8694)] = 389570,
  [SMALL_STATE(8695)] = 389617,
  [SMALL_STATE(8696)] = 389664,
  [SMALL_STATE(8697)] = 389709,
  [SMALL_STATE(8698)] = 389756,
  [SMALL_STATE(8699)] = 389803,
  [SMALL_STATE(8700)] = 389848,
  [SMALL_STATE(8701)] = 389895,
  [SMALL_STATE(8702)] = 389939,
  [SMALL_STATE(8703)] = 389983,
  [SMALL_STATE(8704)] = 390027,
  [SMALL_STATE(8705)] = 390071,
  [SMALL_STATE(8706)] = 390115,
  [SMALL_STATE(8707)] = 390159,
  [SMALL_STATE(8708)] = 390203,
  [SMALL_STATE(8709)] = 390245,
  [SMALL_STATE(8710)] = 390289,
  [SMALL_STATE(8711)] = 390333,
  [SMALL_STATE(8712)] = 390377,
  [SMALL_STATE(8713)] = 390419,
  [SMALL_STATE(8714)] = 390463,
  [SMALL_STATE(8715)] = 390507,
  [SMALL_STATE(8716)] = 390551,
  [SMALL_STATE(8717)] = 390593,
  [SMALL_STATE(8718)] = 390635,
  [SMALL_STATE(8719)] = 390677,
  [SMALL_STATE(8720)] = 390721,
  [SMALL_STATE(8721)] = 390765,
  [SMALL_STATE(8722)] = 390809,
  [SMALL_STATE(8723)] = 390851,
  [SMALL_STATE(8724)] = 390895,
  [SMALL_STATE(8725)] = 390939,
  [SMALL_STATE(8726)] = 390983,
  [SMALL_STATE(8727)] = 391027,
  [SMALL_STATE(8728)] = 391071,
  [SMALL_STATE(8729)] = 391115,
  [SMALL_STATE(8730)] = 391157,
  [SMALL_STATE(8731)] = 391201,
  [SMALL_STATE(8732)] = 391243,
  [SMALL_STATE(8733)] = 391287,
  [SMALL_STATE(8734)] = 391329,
  [SMALL_STATE(8735)] = 391371,
  [SMALL_STATE(8736)] = 391413,
  [SMALL_STATE(8737)] = 391457,
  [SMALL_STATE(8738)] = 391501,
  [SMALL_STATE(8739)] = 391545,
  [SMALL_STATE(8740)] = 391589,
  [SMALL_STATE(8741)] = 391631,
  [SMALL_STATE(8742)] = 391675,
  [SMALL_STATE(8743)] = 391719,
  [SMALL_STATE(8744)] = 391763,
  [SMALL_STATE(8745)] = 391805,
  [SMALL_STATE(8746)] = 391849,
  [SMALL_STATE(8747)] = 391893,
  [SMALL_STATE(8748)] = 391937,
  [SMALL_STATE(8749)] = 391981,
  [SMALL_STATE(8750)] = 392025,
  [SMALL_STATE(8751)] = 392069,
  [SMALL_STATE(8752)] = 392113,
  [SMALL_STATE(8753)] = 392157,
  [SMALL_STATE(8754)] = 392201,
  [SMALL_STATE(8755)] = 392245,
  [SMALL_STATE(8756)] = 392289,
  [SMALL_STATE(8757)] = 392331,
  [SMALL_STATE(8758)] = 392375,
  [SMALL_STATE(8759)] = 392419,
  [SMALL_STATE(8760)] = 392463,
  [SMALL_STATE(8761)] = 392507,
  [SMALL_STATE(8762)] = 392551,
  [SMALL_STATE(8763)] = 392593,
  [SMALL_STATE(8764)] = 392635,
  [SMALL_STATE(8765)] = 392677,
  [SMALL_STATE(8766)] = 392719,
  [SMALL_STATE(8767)] = 392761,
  [SMALL_STATE(8768)] = 392803,
  [SMALL_STATE(8769)] = 392845,
  [SMALL_STATE(8770)] = 392887,
  [SMALL_STATE(8771)] = 392929,
  [SMALL_STATE(8772)] = 392973,
  [SMALL_STATE(8773)] = 393017,
  [SMALL_STATE(8774)] = 393061,
  [SMALL_STATE(8775)] = 393103,
  [SMALL_STATE(8776)] = 393147,
  [SMALL_STATE(8777)] = 393189,
  [SMALL_STATE(8778)] = 393233,
  [SMALL_STATE(8779)] = 393277,
  [SMALL_STATE(8780)] = 393321,
  [SMALL_STATE(8781)] = 393363,
  [SMALL_STATE(8782)] = 393407,
  [SMALL_STATE(8783)] = 393451,
  [SMALL_STATE(8784)] = 393493,
  [SMALL_STATE(8785)] = 393537,
  [SMALL_STATE(8786)] = 393581,
  [SMALL_STATE(8787)] = 393625,
  [SMALL_STATE(8788)] = 393669,
  [SMALL_STATE(8789)] = 393713,
  [SMALL_STATE(8790)] = 393757,
  [SMALL_STATE(8791)] = 393801,
  [SMALL_STATE(8792)] = 393843,
  [SMALL_STATE(8793)] = 393887,
  [SMALL_STATE(8794)] = 393931,
  [SMALL_STATE(8795)] = 393973,
  [SMALL_STATE(8796)] = 394017,
  [SMALL_STATE(8797)] = 394061,
  [SMALL_STATE(8798)] = 394103,
  [SMALL_STATE(8799)] = 394145,
  [SMALL_STATE(8800)] = 394187,
  [SMALL_STATE(8801)] = 394231,
  [SMALL_STATE(8802)] = 394275,
  [SMALL_STATE(8803)] = 394319,
  [SMALL_STATE(8804)] = 394363,
  [SMALL_STATE(8805)] = 394407,
  [SMALL_STATE(8806)] = 394449,
  [SMALL_STATE(8807)] = 394493,
  [SMALL_STATE(8808)] = 394535,
  [SMALL_STATE(8809)] = 394579,
  [SMALL_STATE(8810)] = 394621,
  [SMALL_STATE(8811)] = 394665,
  [SMALL_STATE(8812)] = 394707,
  [SMALL_STATE(8813)] = 394751,
  [SMALL_STATE(8814)] = 394795,
  [SMALL_STATE(8815)] = 394837,
  [SMALL_STATE(8816)] = 394879,
  [SMALL_STATE(8817)] = 394923,
  [SMALL_STATE(8818)] = 394965,
  [SMALL_STATE(8819)] = 395009,
  [SMALL_STATE(8820)] = 395053,
  [SMALL_STATE(8821)] = 395097,
  [SMALL_STATE(8822)] = 395139,
  [SMALL_STATE(8823)] = 395181,
  [SMALL_STATE(8824)] = 395223,
  [SMALL_STATE(8825)] = 395267,
  [SMALL_STATE(8826)] = 395311,
  [SMALL_STATE(8827)] = 395353,
  [SMALL_STATE(8828)] = 395397,
  [SMALL_STATE(8829)] = 395441,
  [SMALL_STATE(8830)] = 395483,
  [SMALL_STATE(8831)] = 395527,
  [SMALL_STATE(8832)] = 395569,
  [SMALL_STATE(8833)] = 395611,
  [SMALL_STATE(8834)] = 395655,
  [SMALL_STATE(8835)] = 395699,
  [SMALL_STATE(8836)] = 395741,
  [SMALL_STATE(8837)] = 395785,
  [SMALL_STATE(8838)] = 395827,
  [SMALL_STATE(8839)] = 395871,
  [SMALL_STATE(8840)] = 395913,
  [SMALL_STATE(8841)] = 395957,
  [SMALL_STATE(8842)] = 395999,
  [SMALL_STATE(8843)] = 396043,
  [SMALL_STATE(8844)] = 396087,
  [SMALL_STATE(8845)] = 396131,
  [SMALL_STATE(8846)] = 396175,
  [SMALL_STATE(8847)] = 396219,
  [SMALL_STATE(8848)] = 396263,
  [SMALL_STATE(8849)] = 396307,
  [SMALL_STATE(8850)] = 396349,
  [SMALL_STATE(8851)] = 396393,
  [SMALL_STATE(8852)] = 396435,
  [SMALL_STATE(8853)] = 396477,
  [SMALL_STATE(8854)] = 396521,
  [SMALL_STATE(8855)] = 396565,
  [SMALL_STATE(8856)] = 396609,
  [SMALL_STATE(8857)] = 396653,
  [SMALL_STATE(8858)] = 396695,
  [SMALL_STATE(8859)] = 396739,
  [SMALL_STATE(8860)] = 396783,
  [SMALL_STATE(8861)] = 396827,
  [SMALL_STATE(8862)] = 396869,
  [SMALL_STATE(8863)] = 396911,
  [SMALL_STATE(8864)] = 396953,
  [SMALL_STATE(8865)] = 396995,
  [SMALL_STATE(8866)] = 397037,
  [SMALL_STATE(8867)] = 397079,
  [SMALL_STATE(8868)] = 397123,
  [SMALL_STATE(8869)] = 397167,
  [SMALL_STATE(8870)] = 397211,
  [SMALL_STATE(8871)] = 397253,
  [SMALL_STATE(8872)] = 397295,
  [SMALL_STATE(8873)] = 397339,
  [SMALL_STATE(8874)] = 397381,
  [SMALL_STATE(8875)] = 397423,
  [SMALL_STATE(8876)] = 397465,
  [SMALL_STATE(8877)] = 397509,
  [SMALL_STATE(8878)] = 397553,
  [SMALL_STATE(8879)] = 397595,
  [SMALL_STATE(8880)] = 397637,
  [SMALL_STATE(8881)] = 397681,
  [SMALL_STATE(8882)] = 397725,
  [SMALL_STATE(8883)] = 397767,
  [SMALL_STATE(8884)] = 397811,
  [SMALL_STATE(8885)] = 397855,
  [SMALL_STATE(8886)] = 397899,
  [SMALL_STATE(8887)] = 397943,
  [SMALL_STATE(8888)] = 397985,
  [SMALL_STATE(8889)] = 398027,
  [SMALL_STATE(8890)] = 398071,
  [SMALL_STATE(8891)] = 398113,
  [SMALL_STATE(8892)] = 398157,
  [SMALL_STATE(8893)] = 398201,
  [SMALL_STATE(8894)] = 398243,
  [SMALL_STATE(8895)] = 398285,
  [SMALL_STATE(8896)] = 398327,
  [SMALL_STATE(8897)] = 398371,
  [SMALL_STATE(8898)] = 398415,
  [SMALL_STATE(8899)] = 398459,
  [SMALL_STATE(8900)] = 398501,
  [SMALL_STATE(8901)] = 398543,
  [SMALL_STATE(8902)] = 398585,
  [SMALL_STATE(8903)] = 398629,
  [SMALL_STATE(8904)] = 398671,
  [SMALL_STATE(8905)] = 398715,
  [SMALL_STATE(8906)] = 398759,
  [SMALL_STATE(8907)] = 398803,
  [SMALL_STATE(8908)] = 398845,
  [SMALL_STATE(8909)] = 398889,
  [SMALL_STATE(8910)] = 398933,
  [SMALL_STATE(8911)] = 398977,
  [SMALL_STATE(8912)] = 399021,
  [SMALL_STATE(8913)] = 399065,
  [SMALL_STATE(8914)] = 399107,
  [SMALL_STATE(8915)] = 399149,
  [SMALL_STATE(8916)] = 399193,
  [SMALL_STATE(8917)] = 399237,
  [SMALL_STATE(8918)] = 399281,
  [SMALL_STATE(8919)] = 399325,
  [SMALL_STATE(8920)] = 399369,
  [SMALL_STATE(8921)] = 399411,
  [SMALL_STATE(8922)] = 399453,
  [SMALL_STATE(8923)] = 399497,
  [SMALL_STATE(8924)] = 399541,
  [SMALL_STATE(8925)] = 399585,
  [SMALL_STATE(8926)] = 399627,
  [SMALL_STATE(8927)] = 399669,
  [SMALL_STATE(8928)] = 399711,
  [SMALL_STATE(8929)] = 399755,
  [SMALL_STATE(8930)] = 399799,
  [SMALL_STATE(8931)] = 399841,
  [SMALL_STATE(8932)] = 399885,
  [SMALL_STATE(8933)] = 399927,
  [SMALL_STATE(8934)] = 399969,
  [SMALL_STATE(8935)] = 400013,
  [SMALL_STATE(8936)] = 400055,
  [SMALL_STATE(8937)] = 400099,
  [SMALL_STATE(8938)] = 400143,
  [SMALL_STATE(8939)] = 400187,
  [SMALL_STATE(8940)] = 400229,
  [SMALL_STATE(8941)] = 400273,
  [SMALL_STATE(8942)] = 400315,
  [SMALL_STATE(8943)] = 400359,
  [SMALL_STATE(8944)] = 400401,
  [SMALL_STATE(8945)] = 400443,
  [SMALL_STATE(8946)] = 400487,
  [SMALL_STATE(8947)] = 400529,
  [SMALL_STATE(8948)] = 400573,
  [SMALL_STATE(8949)] = 400617,
  [SMALL_STATE(8950)] = 400661,
  [SMALL_STATE(8951)] = 400705,
  [SMALL_STATE(8952)] = 400749,
  [SMALL_STATE(8953)] = 400791,
  [SMALL_STATE(8954)] = 400835,
  [SMALL_STATE(8955)] = 400877,
  [SMALL_STATE(8956)] = 400919,
  [SMALL_STATE(8957)] = 400961,
  [SMALL_STATE(8958)] = 401003,
  [SMALL_STATE(8959)] = 401045,
  [SMALL_STATE(8960)] = 401087,
  [SMALL_STATE(8961)] = 401131,
  [SMALL_STATE(8962)] = 401175,
  [SMALL_STATE(8963)] = 401217,
  [SMALL_STATE(8964)] = 401259,
  [SMALL_STATE(8965)] = 401303,
  [SMALL_STATE(8966)] = 401347,
  [SMALL_STATE(8967)] = 401389,
  [SMALL_STATE(8968)] = 401433,
  [SMALL_STATE(8969)] = 401477,
  [SMALL_STATE(8970)] = 401519,
  [SMALL_STATE(8971)] = 401561,
  [SMALL_STATE(8972)] = 401603,
  [SMALL_STATE(8973)] = 401645,
  [SMALL_STATE(8974)] = 401687,
  [SMALL_STATE(8975)] = 401729,
  [SMALL_STATE(8976)] = 401773,
  [SMALL_STATE(8977)] = 401817,
  [SMALL_STATE(8978)] = 401859,
  [SMALL_STATE(8979)] = 401903,
  [SMALL_STATE(8980)] = 401945,
  [SMALL_STATE(8981)] = 401987,
  [SMALL_STATE(8982)] = 402031,
  [SMALL_STATE(8983)] = 402075,
  [SMALL_STATE(8984)] = 402117,
  [SMALL_STATE(8985)] = 402161,
  [SMALL_STATE(8986)] = 402205,
  [SMALL_STATE(8987)] = 402249,
  [SMALL_STATE(8988)] = 402293,
  [SMALL_STATE(8989)] = 402337,
  [SMALL_STATE(8990)] = 402381,
  [SMALL_STATE(8991)] = 402423,
  [SMALL_STATE(8992)] = 402465,
  [SMALL_STATE(8993)] = 402506,
  [SMALL_STATE(8994)] = 402547,
  [SMALL_STATE(8995)] = 402588,
  [SMALL_STATE(8996)] = 402629,
  [SMALL_STATE(8997)] = 402670,
  [SMALL_STATE(8998)] = 402711,
  [SMALL_STATE(8999)] = 402752,
  [SMALL_STATE(9000)] = 402793,
  [SMALL_STATE(9001)] = 402834,
  [SMALL_STATE(9002)] = 402875,
  [SMALL_STATE(9003)] = 402916,
  [SMALL_STATE(9004)] = 402957,
  [SMALL_STATE(9005)] = 402998,
  [SMALL_STATE(9006)] = 403039,
  [SMALL_STATE(9007)] = 403080,
  [SMALL_STATE(9008)] = 403121,
  [SMALL_STATE(9009)] = 403162,
  [SMALL_STATE(9010)] = 403203,
  [SMALL_STATE(9011)] = 403244,
  [SMALL_STATE(9012)] = 403285,
  [SMALL_STATE(9013)] = 403326,
  [SMALL_STATE(9014)] = 403367,
  [SMALL_STATE(9015)] = 403408,
  [SMALL_STATE(9016)] = 403449,
  [SMALL_STATE(9017)] = 403490,
  [SMALL_STATE(9018)] = 403531,
  [SMALL_STATE(9019)] = 403572,
  [SMALL_STATE(9020)] = 403613,
  [SMALL_STATE(9021)] = 403654,
  [SMALL_STATE(9022)] = 403695,
  [SMALL_STATE(9023)] = 403736,
  [SMALL_STATE(9024)] = 403777,
  [SMALL_STATE(9025)] = 403818,
  [SMALL_STATE(9026)] = 403859,
  [SMALL_STATE(9027)] = 403900,
  [SMALL_STATE(9028)] = 403941,
  [SMALL_STATE(9029)] = 403982,
  [SMALL_STATE(9030)] = 404023,
  [SMALL_STATE(9031)] = 404064,
  [SMALL_STATE(9032)] = 404105,
  [SMALL_STATE(9033)] = 404146,
  [SMALL_STATE(9034)] = 404187,
  [SMALL_STATE(9035)] = 404228,
  [SMALL_STATE(9036)] = 404269,
  [SMALL_STATE(9037)] = 404310,
  [SMALL_STATE(9038)] = 404351,
  [SMALL_STATE(9039)] = 404392,
  [SMALL_STATE(9040)] = 404433,
  [SMALL_STATE(9041)] = 404474,
  [SMALL_STATE(9042)] = 404515,
  [SMALL_STATE(9043)] = 404556,
  [SMALL_STATE(9044)] = 404597,
  [SMALL_STATE(9045)] = 404638,
  [SMALL_STATE(9046)] = 404679,
  [SMALL_STATE(9047)] = 404720,
  [SMALL_STATE(9048)] = 404761,
  [SMALL_STATE(9049)] = 404802,
  [SMALL_STATE(9050)] = 404843,
  [SMALL_STATE(9051)] = 404884,
  [SMALL_STATE(9052)] = 404925,
  [SMALL_STATE(9053)] = 404966,
  [SMALL_STATE(9054)] = 405007,
  [SMALL_STATE(9055)] = 405048,
  [SMALL_STATE(9056)] = 405089,
  [SMALL_STATE(9057)] = 405130,
  [SMALL_STATE(9058)] = 405171,
  [SMALL_STATE(9059)] = 405212,
  [SMALL_STATE(9060)] = 405253,
  [SMALL_STATE(9061)] = 405294,
  [SMALL_STATE(9062)] = 405335,
  [SMALL_STATE(9063)] = 405376,
  [SMALL_STATE(9064)] = 405417,
  [SMALL_STATE(9065)] = 405458,
  [SMALL_STATE(9066)] = 405499,
  [SMALL_STATE(9067)] = 405540,
  [SMALL_STATE(9068)] = 405581,
  [SMALL_STATE(9069)] = 405622,
  [SMALL_STATE(9070)] = 405663,
  [SMALL_STATE(9071)] = 405704,
  [SMALL_STATE(9072)] = 405745,
  [SMALL_STATE(9073)] = 405786,
  [SMALL_STATE(9074)] = 405827,
  [SMALL_STATE(9075)] = 405868,
  [SMALL_STATE(9076)] = 405909,
  [SMALL_STATE(9077)] = 405950,
  [SMALL_STATE(9078)] = 405991,
  [SMALL_STATE(9079)] = 406032,
  [SMALL_STATE(9080)] = 406073,
  [SMALL_STATE(9081)] = 406114,
  [SMALL_STATE(9082)] = 406155,
  [SMALL_STATE(9083)] = 406196,
  [SMALL_STATE(9084)] = 406237,
  [SMALL_STATE(9085)] = 406278,
  [SMALL_STATE(9086)] = 406319,
  [SMALL_STATE(9087)] = 406360,
  [SMALL_STATE(9088)] = 406401,
  [SMALL_STATE(9089)] = 406442,
  [SMALL_STATE(9090)] = 406483,
  [SMALL_STATE(9091)] = 406524,
  [SMALL_STATE(9092)] = 406565,
  [SMALL_STATE(9093)] = 406606,
  [SMALL_STATE(9094)] = 406647,
  [SMALL_STATE(9095)] = 406688,
  [SMALL_STATE(9096)] = 406729,
  [SMALL_STATE(9097)] = 406770,
  [SMALL_STATE(9098)] = 406811,
  [SMALL_STATE(9099)] = 406852,
  [SMALL_STATE(9100)] = 406893,
  [SMALL_STATE(9101)] = 406934,
  [SMALL_STATE(9102)] = 406975,
  [SMALL_STATE(9103)] = 407016,
  [SMALL_STATE(9104)] = 407057,
  [SMALL_STATE(9105)] = 407098,
  [SMALL_STATE(9106)] = 407139,
  [SMALL_STATE(9107)] = 407180,
  [SMALL_STATE(9108)] = 407221,
  [SMALL_STATE(9109)] = 407262,
  [SMALL_STATE(9110)] = 407303,
  [SMALL_STATE(9111)] = 407344,
  [SMALL_STATE(9112)] = 407385,
  [SMALL_STATE(9113)] = 407426,
  [SMALL_STATE(9114)] = 407467,
  [SMALL_STATE(9115)] = 407508,
  [SMALL_STATE(9116)] = 407549,
  [SMALL_STATE(9117)] = 407590,
  [SMALL_STATE(9118)] = 407631,
  [SMALL_STATE(9119)] = 407672,
  [SMALL_STATE(9120)] = 407713,
  [SMALL_STATE(9121)] = 407754,
  [SMALL_STATE(9122)] = 407795,
  [SMALL_STATE(9123)] = 407836,
  [SMALL_STATE(9124)] = 407877,
  [SMALL_STATE(9125)] = 407918,
  [SMALL_STATE(9126)] = 407959,
  [SMALL_STATE(9127)] = 408000,
  [SMALL_STATE(9128)] = 408041,
  [SMALL_STATE(9129)] = 408082,
  [SMALL_STATE(9130)] = 408123,
  [SMALL_STATE(9131)] = 408164,
  [SMALL_STATE(9132)] = 408205,
  [SMALL_STATE(9133)] = 408246,
  [SMALL_STATE(9134)] = 408287,
  [SMALL_STATE(9135)] = 408328,
  [SMALL_STATE(9136)] = 408369,
  [SMALL_STATE(9137)] = 408410,
  [SMALL_STATE(9138)] = 408451,
  [SMALL_STATE(9139)] = 408492,
  [SMALL_STATE(9140)] = 408533,
  [SMALL_STATE(9141)] = 408574,
  [SMALL_STATE(9142)] = 408615,
  [SMALL_STATE(9143)] = 408656,
  [SMALL_STATE(9144)] = 408697,
  [SMALL_STATE(9145)] = 408738,
  [SMALL_STATE(9146)] = 408779,
  [SMALL_STATE(9147)] = 408820,
  [SMALL_STATE(9148)] = 408861,
  [SMALL_STATE(9149)] = 408902,
  [SMALL_STATE(9150)] = 408943,
  [SMALL_STATE(9151)] = 408984,
  [SMALL_STATE(9152)] = 409025,
  [SMALL_STATE(9153)] = 409066,
  [SMALL_STATE(9154)] = 409107,
  [SMALL_STATE(9155)] = 409148,
  [SMALL_STATE(9156)] = 409189,
  [SMALL_STATE(9157)] = 409230,
  [SMALL_STATE(9158)] = 409271,
  [SMALL_STATE(9159)] = 409312,
  [SMALL_STATE(9160)] = 409353,
  [SMALL_STATE(9161)] = 409394,
  [SMALL_STATE(9162)] = 409435,
  [SMALL_STATE(9163)] = 409476,
  [SMALL_STATE(9164)] = 409517,
  [SMALL_STATE(9165)] = 409558,
  [SMALL_STATE(9166)] = 409599,
  [SMALL_STATE(9167)] = 409640,
  [SMALL_STATE(9168)] = 409681,
  [SMALL_STATE(9169)] = 409722,
  [SMALL_STATE(9170)] = 409763,
  [SMALL_STATE(9171)] = 409804,
  [SMALL_STATE(9172)] = 409845,
  [SMALL_STATE(9173)] = 409886,
  [SMALL_STATE(9174)] = 409927,
  [SMALL_STATE(9175)] = 409968,
  [SMALL_STATE(9176)] = 410009,
  [SMALL_STATE(9177)] = 410050,
  [SMALL_STATE(9178)] = 410091,
  [SMALL_STATE(9179)] = 410132,
  [SMALL_STATE(9180)] = 410173,
  [SMALL_STATE(9181)] = 410214,
  [SMALL_STATE(9182)] = 410255,
  [SMALL_STATE(9183)] = 410296,
  [SMALL_STATE(9184)] = 410337,
  [SMALL_STATE(9185)] = 410378,
  [SMALL_STATE(9186)] = 410419,
  [SMALL_STATE(9187)] = 410460,
  [SMALL_STATE(9188)] = 410501,
  [SMALL_STATE(9189)] = 410542,
  [SMALL_STATE(9190)] = 410583,
  [SMALL_STATE(9191)] = 410624,
  [SMALL_STATE(9192)] = 410665,
  [SMALL_STATE(9193)] = 410706,
  [SMALL_STATE(9194)] = 410747,
  [SMALL_STATE(9195)] = 410788,
  [SMALL_STATE(9196)] = 410829,
  [SMALL_STATE(9197)] = 410870,
  [SMALL_STATE(9198)] = 410911,
  [SMALL_STATE(9199)] = 410952,
  [SMALL_STATE(9200)] = 410993,
  [SMALL_STATE(9201)] = 411034,
  [SMALL_STATE(9202)] = 411075,
  [SMALL_STATE(9203)] = 411116,
  [SMALL_STATE(9204)] = 411157,
  [SMALL_STATE(9205)] = 411198,
  [SMALL_STATE(9206)] = 411239,
  [SMALL_STATE(9207)] = 411280,
  [SMALL_STATE(9208)] = 411321,
  [SMALL_STATE(9209)] = 411362,
  [SMALL_STATE(9210)] = 411403,
  [SMALL_STATE(9211)] = 411444,
  [SMALL_STATE(9212)] = 411485,
  [SMALL_STATE(9213)] = 411526,
  [SMALL_STATE(9214)] = 411567,
  [SMALL_STATE(9215)] = 411608,
  [SMALL_STATE(9216)] = 411649,
  [SMALL_STATE(9217)] = 411690,
  [SMALL_STATE(9218)] = 411731,
  [SMALL_STATE(9219)] = 411772,
  [SMALL_STATE(9220)] = 411813,
  [SMALL_STATE(9221)] = 411854,
  [SMALL_STATE(9222)] = 411895,
  [SMALL_STATE(9223)] = 411936,
  [SMALL_STATE(9224)] = 411977,
  [SMALL_STATE(9225)] = 412018,
  [SMALL_STATE(9226)] = 412059,
  [SMALL_STATE(9227)] = 412100,
  [SMALL_STATE(9228)] = 412141,
  [SMALL_STATE(9229)] = 412182,
  [SMALL_STATE(9230)] = 412223,
  [SMALL_STATE(9231)] = 412264,
  [SMALL_STATE(9232)] = 412305,
  [SMALL_STATE(9233)] = 412346,
  [SMALL_STATE(9234)] = 412387,
  [SMALL_STATE(9235)] = 412428,
  [SMALL_STATE(9236)] = 412469,
  [SMALL_STATE(9237)] = 412510,
  [SMALL_STATE(9238)] = 412551,
  [SMALL_STATE(9239)] = 412592,
  [SMALL_STATE(9240)] = 412633,
  [SMALL_STATE(9241)] = 412674,
  [SMALL_STATE(9242)] = 412715,
  [SMALL_STATE(9243)] = 412756,
  [SMALL_STATE(9244)] = 412797,
  [SMALL_STATE(9245)] = 412838,
  [SMALL_STATE(9246)] = 412879,
  [SMALL_STATE(9247)] = 412920,
  [SMALL_STATE(9248)] = 412961,
  [SMALL_STATE(9249)] = 413002,
  [SMALL_STATE(9250)] = 413043,
  [SMALL_STATE(9251)] = 413084,
  [SMALL_STATE(9252)] = 413125,
  [SMALL_STATE(9253)] = 413166,
  [SMALL_STATE(9254)] = 413207,
  [SMALL_STATE(9255)] = 413248,
  [SMALL_STATE(9256)] = 413289,
  [SMALL_STATE(9257)] = 413330,
  [SMALL_STATE(9258)] = 413371,
  [SMALL_STATE(9259)] = 413412,
  [SMALL_STATE(9260)] = 413453,
  [SMALL_STATE(9261)] = 413494,
  [SMALL_STATE(9262)] = 413535,
  [SMALL_STATE(9263)] = 413576,
  [SMALL_STATE(9264)] = 413617,
  [SMALL_STATE(9265)] = 413658,
  [SMALL_STATE(9266)] = 413699,
  [SMALL_STATE(9267)] = 413740,
  [SMALL_STATE(9268)] = 413781,
  [SMALL_STATE(9269)] = 413822,
  [SMALL_STATE(9270)] = 413863,
  [SMALL_STATE(9271)] = 413904,
  [SMALL_STATE(9272)] = 413945,
  [SMALL_STATE(9273)] = 413986,
  [SMALL_STATE(9274)] = 414027,
  [SMALL_STATE(9275)] = 414068,
  [SMALL_STATE(9276)] = 414109,
  [SMALL_STATE(9277)] = 414150,
  [SMALL_STATE(9278)] = 414191,
  [SMALL_STATE(9279)] = 414232,
  [SMALL_STATE(9280)] = 414273,
  [SMALL_STATE(9281)] = 414314,
  [SMALL_STATE(9282)] = 414355,
  [SMALL_STATE(9283)] = 414396,
  [SMALL_STATE(9284)] = 414437,
  [SMALL_STATE(9285)] = 414478,
  [SMALL_STATE(9286)] = 414519,
  [SMALL_STATE(9287)] = 414560,
  [SMALL_STATE(9288)] = 414601,
  [SMALL_STATE(9289)] = 414642,
  [SMALL_STATE(9290)] = 414683,
  [SMALL_STATE(9291)] = 414724,
  [SMALL_STATE(9292)] = 414765,
  [SMALL_STATE(9293)] = 414806,
  [SMALL_STATE(9294)] = 414847,
  [SMALL_STATE(9295)] = 414888,
  [SMALL_STATE(9296)] = 414929,
  [SMALL_STATE(9297)] = 414970,
  [SMALL_STATE(9298)] = 415011,
  [SMALL_STATE(9299)] = 415052,
  [SMALL_STATE(9300)] = 415093,
  [SMALL_STATE(9301)] = 415134,
  [SMALL_STATE(9302)] = 415175,
  [SMALL_STATE(9303)] = 415216,
  [SMALL_STATE(9304)] = 415257,
  [SMALL_STATE(9305)] = 415298,
  [SMALL_STATE(9306)] = 415339,
  [SMALL_STATE(9307)] = 415380,
  [SMALL_STATE(9308)] = 415421,
  [SMALL_STATE(9309)] = 415462,
  [SMALL_STATE(9310)] = 415503,
  [SMALL_STATE(9311)] = 415544,
  [SMALL_STATE(9312)] = 415585,
  [SMALL_STATE(9313)] = 415626,
  [SMALL_STATE(9314)] = 415667,
  [SMALL_STATE(9315)] = 415708,
  [SMALL_STATE(9316)] = 415749,
  [SMALL_STATE(9317)] = 415790,
  [SMALL_STATE(9318)] = 415831,
  [SMALL_STATE(9319)] = 415872,
  [SMALL_STATE(9320)] = 415913,
  [SMALL_STATE(9321)] = 415954,
  [SMALL_STATE(9322)] = 415995,
  [SMALL_STATE(9323)] = 416036,
  [SMALL_STATE(9324)] = 416077,
  [SMALL_STATE(9325)] = 416118,
  [SMALL_STATE(9326)] = 416159,
  [SMALL_STATE(9327)] = 416200,
  [SMALL_STATE(9328)] = 416241,
  [SMALL_STATE(9329)] = 416282,
  [SMALL_STATE(9330)] = 416323,
  [SMALL_STATE(9331)] = 416364,
  [SMALL_STATE(9332)] = 416405,
  [SMALL_STATE(9333)] = 416446,
  [SMALL_STATE(9334)] = 416487,
  [SMALL_STATE(9335)] = 416528,
  [SMALL_STATE(9336)] = 416569,
  [SMALL_STATE(9337)] = 416610,
  [SMALL_STATE(9338)] = 416651,
  [SMALL_STATE(9339)] = 416692,
  [SMALL_STATE(9340)] = 416733,
  [SMALL_STATE(9341)] = 416774,
  [SMALL_STATE(9342)] = 416815,
  [SMALL_STATE(9343)] = 416856,
  [SMALL_STATE(9344)] = 416897,
  [SMALL_STATE(9345)] = 416938,
  [SMALL_STATE(9346)] = 416979,
  [SMALL_STATE(9347)] = 417020,
  [SMALL_STATE(9348)] = 417061,
  [SMALL_STATE(9349)] = 417102,
  [SMALL_STATE(9350)] = 417143,
  [SMALL_STATE(9351)] = 417184,
  [SMALL_STATE(9352)] = 417225,
  [SMALL_STATE(9353)] = 417266,
  [SMALL_STATE(9354)] = 417307,
  [SMALL_STATE(9355)] = 417348,
  [SMALL_STATE(9356)] = 417389,
  [SMALL_STATE(9357)] = 417430,
  [SMALL_STATE(9358)] = 417471,
  [SMALL_STATE(9359)] = 417512,
  [SMALL_STATE(9360)] = 417553,
  [SMALL_STATE(9361)] = 417594,
  [SMALL_STATE(9362)] = 417635,
  [SMALL_STATE(9363)] = 417676,
  [SMALL_STATE(9364)] = 417717,
  [SMALL_STATE(9365)] = 417758,
  [SMALL_STATE(9366)] = 417799,
  [SMALL_STATE(9367)] = 417840,
  [SMALL_STATE(9368)] = 417881,
  [SMALL_STATE(9369)] = 417922,
  [SMALL_STATE(9370)] = 417963,
  [SMALL_STATE(9371)] = 418004,
  [SMALL_STATE(9372)] = 418045,
  [SMALL_STATE(9373)] = 418086,
  [SMALL_STATE(9374)] = 418127,
  [SMALL_STATE(9375)] = 418168,
  [SMALL_STATE(9376)] = 418209,
  [SMALL_STATE(9377)] = 418250,
  [SMALL_STATE(9378)] = 418291,
  [SMALL_STATE(9379)] = 418332,
  [SMALL_STATE(9380)] = 418373,
  [SMALL_STATE(9381)] = 418414,
  [SMALL_STATE(9382)] = 418455,
  [SMALL_STATE(9383)] = 418496,
  [SMALL_STATE(9384)] = 418537,
  [SMALL_STATE(9385)] = 418578,
  [SMALL_STATE(9386)] = 418619,
  [SMALL_STATE(9387)] = 418660,
  [SMALL_STATE(9388)] = 418701,
  [SMALL_STATE(9389)] = 418742,
  [SMALL_STATE(9390)] = 418783,
  [SMALL_STATE(9391)] = 418824,
  [SMALL_STATE(9392)] = 418865,
  [SMALL_STATE(9393)] = 418906,
  [SMALL_STATE(9394)] = 418947,
  [SMALL_STATE(9395)] = 418988,
  [SMALL_STATE(9396)] = 419029,
  [SMALL_STATE(9397)] = 419070,
  [SMALL_STATE(9398)] = 419111,
  [SMALL_STATE(9399)] = 419152,
  [SMALL_STATE(9400)] = 419193,
  [SMALL_STATE(9401)] = 419234,
  [SMALL_STATE(9402)] = 419275,
  [SMALL_STATE(9403)] = 419316,
  [SMALL_STATE(9404)] = 419357,
  [SMALL_STATE(9405)] = 419398,
  [SMALL_STATE(9406)] = 419439,
  [SMALL_STATE(9407)] = 419480,
  [SMALL_STATE(9408)] = 419521,
  [SMALL_STATE(9409)] = 419562,
  [SMALL_STATE(9410)] = 419603,
  [SMALL_STATE(9411)] = 419644,
  [SMALL_STATE(9412)] = 419685,
  [SMALL_STATE(9413)] = 419726,
  [SMALL_STATE(9414)] = 419767,
  [SMALL_STATE(9415)] = 419808,
  [SMALL_STATE(9416)] = 419849,
  [SMALL_STATE(9417)] = 419890,
  [SMALL_STATE(9418)] = 419931,
  [SMALL_STATE(9419)] = 419972,
  [SMALL_STATE(9420)] = 420013,
  [SMALL_STATE(9421)] = 420054,
  [SMALL_STATE(9422)] = 420095,
  [SMALL_STATE(9423)] = 420136,
  [SMALL_STATE(9424)] = 420177,
  [SMALL_STATE(9425)] = 420218,
  [SMALL_STATE(9426)] = 420259,
  [SMALL_STATE(9427)] = 420300,
  [SMALL_STATE(9428)] = 420341,
  [SMALL_STATE(9429)] = 420382,
  [SMALL_STATE(9430)] = 420423,
  [SMALL_STATE(9431)] = 420464,
  [SMALL_STATE(9432)] = 420505,
  [SMALL_STATE(9433)] = 420546,
  [SMALL_STATE(9434)] = 420587,
  [SMALL_STATE(9435)] = 420628,
  [SMALL_STATE(9436)] = 420669,
  [SMALL_STATE(9437)] = 420710,
  [SMALL_STATE(9438)] = 420751,
  [SMALL_STATE(9439)] = 420792,
  [SMALL_STATE(9440)] = 420833,
  [SMALL_STATE(9441)] = 420874,
  [SMALL_STATE(9442)] = 420915,
  [SMALL_STATE(9443)] = 420956,
  [SMALL_STATE(9444)] = 420997,
  [SMALL_STATE(9445)] = 421038,
  [SMALL_STATE(9446)] = 421079,
  [SMALL_STATE(9447)] = 421120,
  [SMALL_STATE(9448)] = 421161,
  [SMALL_STATE(9449)] = 421202,
  [SMALL_STATE(9450)] = 421243,
  [SMALL_STATE(9451)] = 421284,
  [SMALL_STATE(9452)] = 421325,
  [SMALL_STATE(9453)] = 421366,
  [SMALL_STATE(9454)] = 421407,
  [SMALL_STATE(9455)] = 421448,
  [SMALL_STATE(9456)] = 421489,
  [SMALL_STATE(9457)] = 421530,
  [SMALL_STATE(9458)] = 421571,
  [SMALL_STATE(9459)] = 421612,
  [SMALL_STATE(9460)] = 421653,
  [SMALL_STATE(9461)] = 421694,
  [SMALL_STATE(9462)] = 421735,
  [SMALL_STATE(9463)] = 421776,
  [SMALL_STATE(9464)] = 421817,
  [SMALL_STATE(9465)] = 421858,
  [SMALL_STATE(9466)] = 421899,
  [SMALL_STATE(9467)] = 421940,
  [SMALL_STATE(9468)] = 421981,
  [SMALL_STATE(9469)] = 422022,
  [SMALL_STATE(9470)] = 422063,
  [SMALL_STATE(9471)] = 422104,
  [SMALL_STATE(9472)] = 422145,
  [SMALL_STATE(9473)] = 422186,
  [SMALL_STATE(9474)] = 422227,
  [SMALL_STATE(9475)] = 422268,
  [SMALL_STATE(9476)] = 422309,
  [SMALL_STATE(9477)] = 422350,
  [SMALL_STATE(9478)] = 422391,
  [SMALL_STATE(9479)] = 422432,
  [SMALL_STATE(9480)] = 422473,
  [SMALL_STATE(9481)] = 422514,
  [SMALL_STATE(9482)] = 422555,
  [SMALL_STATE(9483)] = 422596,
  [SMALL_STATE(9484)] = 422637,
  [SMALL_STATE(9485)] = 422678,
  [SMALL_STATE(9486)] = 422719,
  [SMALL_STATE(9487)] = 422760,
  [SMALL_STATE(9488)] = 422801,
  [SMALL_STATE(9489)] = 422842,
  [SMALL_STATE(9490)] = 422883,
  [SMALL_STATE(9491)] = 422924,
  [SMALL_STATE(9492)] = 422965,
  [SMALL_STATE(9493)] = 423006,
  [SMALL_STATE(9494)] = 423047,
  [SMALL_STATE(9495)] = 423088,
  [SMALL_STATE(9496)] = 423129,
  [SMALL_STATE(9497)] = 423170,
  [SMALL_STATE(9498)] = 423211,
  [SMALL_STATE(9499)] = 423252,
  [SMALL_STATE(9500)] = 423293,
  [SMALL_STATE(9501)] = 423334,
  [SMALL_STATE(9502)] = 423375,
  [SMALL_STATE(9503)] = 423416,
  [SMALL_STATE(9504)] = 423457,
  [SMALL_STATE(9505)] = 423498,
  [SMALL_STATE(9506)] = 423539,
  [SMALL_STATE(9507)] = 423580,
  [SMALL_STATE(9508)] = 423621,
  [SMALL_STATE(9509)] = 423662,
  [SMALL_STATE(9510)] = 423703,
  [SMALL_STATE(9511)] = 423744,
  [SMALL_STATE(9512)] = 423785,
  [SMALL_STATE(9513)] = 423826,
  [SMALL_STATE(9514)] = 423867,
  [SMALL_STATE(9515)] = 423908,
  [SMALL_STATE(9516)] = 423949,
  [SMALL_STATE(9517)] = 423990,
  [SMALL_STATE(9518)] = 424031,
  [SMALL_STATE(9519)] = 424072,
  [SMALL_STATE(9520)] = 424113,
  [SMALL_STATE(9521)] = 424154,
  [SMALL_STATE(9522)] = 424195,
  [SMALL_STATE(9523)] = 424236,
  [SMALL_STATE(9524)] = 424277,
  [SMALL_STATE(9525)] = 424318,
  [SMALL_STATE(9526)] = 424359,
  [SMALL_STATE(9527)] = 424400,
  [SMALL_STATE(9528)] = 424441,
  [SMALL_STATE(9529)] = 424482,
  [SMALL_STATE(9530)] = 424523,
  [SMALL_STATE(9531)] = 424564,
  [SMALL_STATE(9532)] = 424605,
  [SMALL_STATE(9533)] = 424646,
  [SMALL_STATE(9534)] = 424687,
  [SMALL_STATE(9535)] = 424728,
  [SMALL_STATE(9536)] = 424769,
  [SMALL_STATE(9537)] = 424810,
  [SMALL_STATE(9538)] = 424851,
  [SMALL_STATE(9539)] = 424892,
  [SMALL_STATE(9540)] = 424933,
  [SMALL_STATE(9541)] = 424974,
  [SMALL_STATE(9542)] = 425015,
  [SMALL_STATE(9543)] = 425056,
  [SMALL_STATE(9544)] = 425097,
  [SMALL_STATE(9545)] = 425138,
  [SMALL_STATE(9546)] = 425179,
  [SMALL_STATE(9547)] = 425220,
  [SMALL_STATE(9548)] = 425261,
  [SMALL_STATE(9549)] = 425302,
  [SMALL_STATE(9550)] = 425343,
  [SMALL_STATE(9551)] = 425384,
  [SMALL_STATE(9552)] = 425425,
  [SMALL_STATE(9553)] = 425466,
  [SMALL_STATE(9554)] = 425507,
  [SMALL_STATE(9555)] = 425548,
  [SMALL_STATE(9556)] = 425589,
  [SMALL_STATE(9557)] = 425630,
  [SMALL_STATE(9558)] = 425671,
  [SMALL_STATE(9559)] = 425712,
  [SMALL_STATE(9560)] = 425753,
  [SMALL_STATE(9561)] = 425794,
  [SMALL_STATE(9562)] = 425835,
  [SMALL_STATE(9563)] = 425876,
  [SMALL_STATE(9564)] = 425917,
  [SMALL_STATE(9565)] = 425958,
  [SMALL_STATE(9566)] = 425999,
  [SMALL_STATE(9567)] = 426040,
  [SMALL_STATE(9568)] = 426081,
  [SMALL_STATE(9569)] = 426122,
  [SMALL_STATE(9570)] = 426163,
  [SMALL_STATE(9571)] = 426204,
  [SMALL_STATE(9572)] = 426245,
  [SMALL_STATE(9573)] = 426286,
  [SMALL_STATE(9574)] = 426327,
  [SMALL_STATE(9575)] = 426368,
  [SMALL_STATE(9576)] = 426409,
  [SMALL_STATE(9577)] = 426450,
  [SMALL_STATE(9578)] = 426491,
  [SMALL_STATE(9579)] = 426532,
  [SMALL_STATE(9580)] = 426573,
  [SMALL_STATE(9581)] = 426614,
  [SMALL_STATE(9582)] = 426655,
  [SMALL_STATE(9583)] = 426696,
  [SMALL_STATE(9584)] = 426737,
  [SMALL_STATE(9585)] = 426778,
  [SMALL_STATE(9586)] = 426819,
  [SMALL_STATE(9587)] = 426860,
  [SMALL_STATE(9588)] = 426901,
  [SMALL_STATE(9589)] = 426942,
  [SMALL_STATE(9590)] = 426983,
  [SMALL_STATE(9591)] = 427024,
  [SMALL_STATE(9592)] = 427065,
  [SMALL_STATE(9593)] = 427106,
  [SMALL_STATE(9594)] = 427147,
  [SMALL_STATE(9595)] = 427188,
  [SMALL_STATE(9596)] = 427229,
  [SMALL_STATE(9597)] = 427270,
  [SMALL_STATE(9598)] = 427311,
  [SMALL_STATE(9599)] = 427352,
  [SMALL_STATE(9600)] = 427393,
  [SMALL_STATE(9601)] = 427434,
  [SMALL_STATE(9602)] = 427475,
  [SMALL_STATE(9603)] = 427516,
  [SMALL_STATE(9604)] = 427557,
  [SMALL_STATE(9605)] = 427598,
  [SMALL_STATE(9606)] = 427639,
  [SMALL_STATE(9607)] = 427680,
  [SMALL_STATE(9608)] = 427721,
  [SMALL_STATE(9609)] = 427762,
  [SMALL_STATE(9610)] = 427803,
  [SMALL_STATE(9611)] = 427844,
  [SMALL_STATE(9612)] = 427885,
  [SMALL_STATE(9613)] = 427926,
  [SMALL_STATE(9614)] = 427967,
  [SMALL_STATE(9615)] = 428008,
  [SMALL_STATE(9616)] = 428049,
  [SMALL_STATE(9617)] = 428090,
  [SMALL_STATE(9618)] = 428131,
  [SMALL_STATE(9619)] = 428172,
  [SMALL_STATE(9620)] = 428213,
  [SMALL_STATE(9621)] = 428254,
  [SMALL_STATE(9622)] = 428295,
  [SMALL_STATE(9623)] = 428336,
  [SMALL_STATE(9624)] = 428377,
  [SMALL_STATE(9625)] = 428418,
  [SMALL_STATE(9626)] = 428459,
  [SMALL_STATE(9627)] = 428500,
  [SMALL_STATE(9628)] = 428541,
  [SMALL_STATE(9629)] = 428582,
  [SMALL_STATE(9630)] = 428623,
  [SMALL_STATE(9631)] = 428664,
  [SMALL_STATE(9632)] = 428705,
  [SMALL_STATE(9633)] = 428746,
  [SMALL_STATE(9634)] = 428787,
  [SMALL_STATE(9635)] = 428828,
  [SMALL_STATE(9636)] = 428869,
  [SMALL_STATE(9637)] = 428910,
  [SMALL_STATE(9638)] = 428951,
  [SMALL_STATE(9639)] = 428992,
  [SMALL_STATE(9640)] = 429033,
  [SMALL_STATE(9641)] = 429074,
  [SMALL_STATE(9642)] = 429115,
  [SMALL_STATE(9643)] = 429156,
  [SMALL_STATE(9644)] = 429197,
  [SMALL_STATE(9645)] = 429238,
  [SMALL_STATE(9646)] = 429279,
  [SMALL_STATE(9647)] = 429320,
  [SMALL_STATE(9648)] = 429361,
  [SMALL_STATE(9649)] = 429402,
  [SMALL_STATE(9650)] = 429443,
  [SMALL_STATE(9651)] = 429484,
  [SMALL_STATE(9652)] = 429525,
  [SMALL_STATE(9653)] = 429566,
  [SMALL_STATE(9654)] = 429607,
  [SMALL_STATE(9655)] = 429648,
  [SMALL_STATE(9656)] = 429689,
  [SMALL_STATE(9657)] = 429730,
  [SMALL_STATE(9658)] = 429771,
  [SMALL_STATE(9659)] = 429812,
  [SMALL_STATE(9660)] = 429853,
  [SMALL_STATE(9661)] = 429894,
  [SMALL_STATE(9662)] = 429935,
  [SMALL_STATE(9663)] = 429976,
  [SMALL_STATE(9664)] = 430017,
  [SMALL_STATE(9665)] = 430058,
  [SMALL_STATE(9666)] = 430099,
  [SMALL_STATE(9667)] = 430140,
  [SMALL_STATE(9668)] = 430181,
  [SMALL_STATE(9669)] = 430222,
  [SMALL_STATE(9670)] = 430263,
  [SMALL_STATE(9671)] = 430304,
  [SMALL_STATE(9672)] = 430345,
  [SMALL_STATE(9673)] = 430386,
  [SMALL_STATE(9674)] = 430427,
  [SMALL_STATE(9675)] = 430468,
  [SMALL_STATE(9676)] = 430509,
  [SMALL_STATE(9677)] = 430550,
  [SMALL_STATE(9678)] = 430591,
  [SMALL_STATE(9679)] = 430632,
  [SMALL_STATE(9680)] = 430673,
  [SMALL_STATE(9681)] = 430714,
  [SMALL_STATE(9682)] = 430755,
  [SMALL_STATE(9683)] = 430796,
  [SMALL_STATE(9684)] = 430837,
  [SMALL_STATE(9685)] = 430878,
  [SMALL_STATE(9686)] = 430919,
  [SMALL_STATE(9687)] = 430960,
  [SMALL_STATE(9688)] = 431001,
  [SMALL_STATE(9689)] = 431042,
  [SMALL_STATE(9690)] = 431083,
  [SMALL_STATE(9691)] = 431124,
  [SMALL_STATE(9692)] = 431165,
  [SMALL_STATE(9693)] = 431206,
  [SMALL_STATE(9694)] = 431247,
  [SMALL_STATE(9695)] = 431288,
  [SMALL_STATE(9696)] = 431329,
  [SMALL_STATE(9697)] = 431370,
  [SMALL_STATE(9698)] = 431411,
  [SMALL_STATE(9699)] = 431452,
  [SMALL_STATE(9700)] = 431493,
  [SMALL_STATE(9701)] = 431534,
  [SMALL_STATE(9702)] = 431575,
  [SMALL_STATE(9703)] = 431616,
  [SMALL_STATE(9704)] = 431657,
  [SMALL_STATE(9705)] = 431698,
  [SMALL_STATE(9706)] = 431739,
  [SMALL_STATE(9707)] = 431780,
  [SMALL_STATE(9708)] = 431821,
  [SMALL_STATE(9709)] = 431862,
  [SMALL_STATE(9710)] = 431903,
  [SMALL_STATE(9711)] = 431944,
  [SMALL_STATE(9712)] = 431985,
  [SMALL_STATE(9713)] = 432026,
  [SMALL_STATE(9714)] = 432067,
  [SMALL_STATE(9715)] = 432108,
  [SMALL_STATE(9716)] = 432149,
  [SMALL_STATE(9717)] = 432190,
  [SMALL_STATE(9718)] = 432231,
  [SMALL_STATE(9719)] = 432272,
  [SMALL_STATE(9720)] = 432313,
  [SMALL_STATE(9721)] = 432354,
  [SMALL_STATE(9722)] = 432395,
  [SMALL_STATE(9723)] = 432436,
  [SMALL_STATE(9724)] = 432477,
  [SMALL_STATE(9725)] = 432518,
  [SMALL_STATE(9726)] = 432559,
  [SMALL_STATE(9727)] = 432600,
  [SMALL_STATE(9728)] = 432641,
  [SMALL_STATE(9729)] = 432682,
  [SMALL_STATE(9730)] = 432723,
  [SMALL_STATE(9731)] = 432764,
  [SMALL_STATE(9732)] = 432805,
  [SMALL_STATE(9733)] = 432846,
  [SMALL_STATE(9734)] = 432887,
  [SMALL_STATE(9735)] = 432928,
  [SMALL_STATE(9736)] = 432969,
  [SMALL_STATE(9737)] = 433010,
  [SMALL_STATE(9738)] = 433051,
  [SMALL_STATE(9739)] = 433092,
  [SMALL_STATE(9740)] = 433133,
  [SMALL_STATE(9741)] = 433174,
  [SMALL_STATE(9742)] = 433215,
  [SMALL_STATE(9743)] = 433256,
  [SMALL_STATE(9744)] = 433297,
  [SMALL_STATE(9745)] = 433338,
  [SMALL_STATE(9746)] = 433379,
  [SMALL_STATE(9747)] = 433420,
  [SMALL_STATE(9748)] = 433461,
  [SMALL_STATE(9749)] = 433502,
  [SMALL_STATE(9750)] = 433543,
  [SMALL_STATE(9751)] = 433584,
  [SMALL_STATE(9752)] = 433625,
  [SMALL_STATE(9753)] = 433666,
  [SMALL_STATE(9754)] = 433707,
  [SMALL_STATE(9755)] = 433748,
  [SMALL_STATE(9756)] = 433789,
  [SMALL_STATE(9757)] = 433830,
  [SMALL_STATE(9758)] = 433871,
  [SMALL_STATE(9759)] = 433912,
  [SMALL_STATE(9760)] = 433953,
  [SMALL_STATE(9761)] = 433994,
  [SMALL_STATE(9762)] = 434035,
  [SMALL_STATE(9763)] = 434076,
  [SMALL_STATE(9764)] = 434117,
  [SMALL_STATE(9765)] = 434158,
  [SMALL_STATE(9766)] = 434199,
  [SMALL_STATE(9767)] = 434240,
  [SMALL_STATE(9768)] = 434281,
  [SMALL_STATE(9769)] = 434322,
  [SMALL_STATE(9770)] = 434363,
  [SMALL_STATE(9771)] = 434404,
  [SMALL_STATE(9772)] = 434445,
  [SMALL_STATE(9773)] = 434486,
  [SMALL_STATE(9774)] = 434527,
  [SMALL_STATE(9775)] = 434568,
  [SMALL_STATE(9776)] = 434609,
  [SMALL_STATE(9777)] = 434650,
  [SMALL_STATE(9778)] = 434691,
  [SMALL_STATE(9779)] = 434732,
  [SMALL_STATE(9780)] = 434773,
  [SMALL_STATE(9781)] = 434814,
  [SMALL_STATE(9782)] = 434855,
  [SMALL_STATE(9783)] = 434896,
  [SMALL_STATE(9784)] = 434937,
  [SMALL_STATE(9785)] = 434978,
  [SMALL_STATE(9786)] = 435019,
  [SMALL_STATE(9787)] = 435060,
  [SMALL_STATE(9788)] = 435101,
  [SMALL_STATE(9789)] = 435142,
  [SMALL_STATE(9790)] = 435183,
  [SMALL_STATE(9791)] = 435224,
  [SMALL_STATE(9792)] = 435265,
  [SMALL_STATE(9793)] = 435306,
  [SMALL_STATE(9794)] = 435347,
  [SMALL_STATE(9795)] = 435388,
  [SMALL_STATE(9796)] = 435429,
  [SMALL_STATE(9797)] = 435470,
  [SMALL_STATE(9798)] = 435511,
  [SMALL_STATE(9799)] = 435552,
  [SMALL_STATE(9800)] = 435593,
  [SMALL_STATE(9801)] = 435634,
  [SMALL_STATE(9802)] = 435675,
  [SMALL_STATE(9803)] = 435716,
  [SMALL_STATE(9804)] = 435757,
  [SMALL_STATE(9805)] = 435798,
  [SMALL_STATE(9806)] = 435839,
  [SMALL_STATE(9807)] = 435880,
  [SMALL_STATE(9808)] = 435921,
  [SMALL_STATE(9809)] = 435962,
  [SMALL_STATE(9810)] = 436003,
  [SMALL_STATE(9811)] = 436044,
  [SMALL_STATE(9812)] = 436085,
  [SMALL_STATE(9813)] = 436126,
  [SMALL_STATE(9814)] = 436167,
  [SMALL_STATE(9815)] = 436208,
  [SMALL_STATE(9816)] = 436249,
  [SMALL_STATE(9817)] = 436290,
  [SMALL_STATE(9818)] = 436331,
  [SMALL_STATE(9819)] = 436372,
  [SMALL_STATE(9820)] = 436413,
  [SMALL_STATE(9821)] = 436454,
  [SMALL_STATE(9822)] = 436495,
  [SMALL_STATE(9823)] = 436536,
  [SMALL_STATE(9824)] = 436577,
  [SMALL_STATE(9825)] = 436618,
  [SMALL_STATE(9826)] = 436659,
  [SMALL_STATE(9827)] = 436700,
  [SMALL_STATE(9828)] = 436741,
  [SMALL_STATE(9829)] = 436782,
  [SMALL_STATE(9830)] = 436823,
  [SMALL_STATE(9831)] = 436864,
  [SMALL_STATE(9832)] = 436905,
  [SMALL_STATE(9833)] = 436946,
  [SMALL_STATE(9834)] = 436987,
  [SMALL_STATE(9835)] = 437028,
  [SMALL_STATE(9836)] = 437069,
  [SMALL_STATE(9837)] = 437110,
  [SMALL_STATE(9838)] = 437151,
  [SMALL_STATE(9839)] = 437192,
  [SMALL_STATE(9840)] = 437233,
  [SMALL_STATE(9841)] = 437274,
  [SMALL_STATE(9842)] = 437315,
  [SMALL_STATE(9843)] = 437356,
  [SMALL_STATE(9844)] = 437397,
  [SMALL_STATE(9845)] = 437438,
  [SMALL_STATE(9846)] = 437479,
  [SMALL_STATE(9847)] = 437520,
  [SMALL_STATE(9848)] = 437561,
  [SMALL_STATE(9849)] = 437602,
  [SMALL_STATE(9850)] = 437643,
  [SMALL_STATE(9851)] = 437684,
  [SMALL_STATE(9852)] = 437725,
  [SMALL_STATE(9853)] = 437766,
  [SMALL_STATE(9854)] = 437807,
  [SMALL_STATE(9855)] = 437848,
  [SMALL_STATE(9856)] = 437889,
  [SMALL_STATE(9857)] = 437930,
  [SMALL_STATE(9858)] = 437971,
  [SMALL_STATE(9859)] = 438012,
  [SMALL_STATE(9860)] = 438053,
  [SMALL_STATE(9861)] = 438094,
  [SMALL_STATE(9862)] = 438135,
  [SMALL_STATE(9863)] = 438176,
  [SMALL_STATE(9864)] = 438217,
  [SMALL_STATE(9865)] = 438258,
  [SMALL_STATE(9866)] = 438299,
  [SMALL_STATE(9867)] = 438340,
  [SMALL_STATE(9868)] = 438381,
  [SMALL_STATE(9869)] = 438422,
  [SMALL_STATE(9870)] = 438463,
  [SMALL_STATE(9871)] = 438504,
  [SMALL_STATE(9872)] = 438545,
  [SMALL_STATE(9873)] = 438586,
  [SMALL_STATE(9874)] = 438627,
  [SMALL_STATE(9875)] = 438668,
  [SMALL_STATE(9876)] = 438709,
  [SMALL_STATE(9877)] = 438750,
  [SMALL_STATE(9878)] = 438791,
  [SMALL_STATE(9879)] = 438832,
  [SMALL_STATE(9880)] = 438873,
  [SMALL_STATE(9881)] = 438914,
  [SMALL_STATE(9882)] = 438955,
  [SMALL_STATE(9883)] = 438996,
  [SMALL_STATE(9884)] = 439037,
  [SMALL_STATE(9885)] = 439078,
  [SMALL_STATE(9886)] = 439119,
  [SMALL_STATE(9887)] = 439160,
  [SMALL_STATE(9888)] = 439201,
  [SMALL_STATE(9889)] = 439242,
  [SMALL_STATE(9890)] = 439283,
  [SMALL_STATE(9891)] = 439324,
  [SMALL_STATE(9892)] = 439365,
  [SMALL_STATE(9893)] = 439406,
  [SMALL_STATE(9894)] = 439447,
  [SMALL_STATE(9895)] = 439488,
  [SMALL_STATE(9896)] = 439529,
  [SMALL_STATE(9897)] = 439570,
  [SMALL_STATE(9898)] = 439611,
  [SMALL_STATE(9899)] = 439652,
  [SMALL_STATE(9900)] = 439693,
  [SMALL_STATE(9901)] = 439734,
  [SMALL_STATE(9902)] = 439775,
  [SMALL_STATE(9903)] = 439816,
  [SMALL_STATE(9904)] = 439857,
  [SMALL_STATE(9905)] = 439898,
  [SMALL_STATE(9906)] = 439939,
  [SMALL_STATE(9907)] = 439980,
  [SMALL_STATE(9908)] = 440021,
  [SMALL_STATE(9909)] = 440062,
  [SMALL_STATE(9910)] = 440103,
  [SMALL_STATE(9911)] = 440144,
  [SMALL_STATE(9912)] = 440185,
  [SMALL_STATE(9913)] = 440226,
  [SMALL_STATE(9914)] = 440267,
  [SMALL_STATE(9915)] = 440308,
  [SMALL_STATE(9916)] = 440349,
  [SMALL_STATE(9917)] = 440390,
  [SMALL_STATE(9918)] = 440431,
  [SMALL_STATE(9919)] = 440472,
  [SMALL_STATE(9920)] = 440513,
  [SMALL_STATE(9921)] = 440554,
  [SMALL_STATE(9922)] = 440595,
  [SMALL_STATE(9923)] = 440636,
  [SMALL_STATE(9924)] = 440677,
  [SMALL_STATE(9925)] = 440718,
  [SMALL_STATE(9926)] = 440759,
  [SMALL_STATE(9927)] = 440800,
  [SMALL_STATE(9928)] = 440841,
  [SMALL_STATE(9929)] = 440882,
  [SMALL_STATE(9930)] = 440923,
  [SMALL_STATE(9931)] = 440964,
  [SMALL_STATE(9932)] = 441005,
  [SMALL_STATE(9933)] = 441046,
  [SMALL_STATE(9934)] = 441087,
  [SMALL_STATE(9935)] = 441128,
  [SMALL_STATE(9936)] = 441169,
  [SMALL_STATE(9937)] = 441210,
  [SMALL_STATE(9938)] = 441251,
  [SMALL_STATE(9939)] = 441292,
  [SMALL_STATE(9940)] = 441333,
  [SMALL_STATE(9941)] = 441374,
  [SMALL_STATE(9942)] = 441415,
  [SMALL_STATE(9943)] = 441456,
  [SMALL_STATE(9944)] = 441497,
  [SMALL_STATE(9945)] = 441538,
  [SMALL_STATE(9946)] = 441579,
  [SMALL_STATE(9947)] = 441620,
  [SMALL_STATE(9948)] = 441661,
  [SMALL_STATE(9949)] = 441702,
  [SMALL_STATE(9950)] = 441743,
  [SMALL_STATE(9951)] = 441784,
  [SMALL_STATE(9952)] = 441825,
  [SMALL_STATE(9953)] = 441866,
  [SMALL_STATE(9954)] = 441907,
  [SMALL_STATE(9955)] = 441948,
  [SMALL_STATE(9956)] = 441989,
  [SMALL_STATE(9957)] = 442030,
  [SMALL_STATE(9958)] = 442071,
  [SMALL_STATE(9959)] = 442112,
  [SMALL_STATE(9960)] = 442153,
  [SMALL_STATE(9961)] = 442194,
  [SMALL_STATE(9962)] = 442235,
  [SMALL_STATE(9963)] = 442276,
  [SMALL_STATE(9964)] = 442317,
  [SMALL_STATE(9965)] = 442358,
  [SMALL_STATE(9966)] = 442399,
  [SMALL_STATE(9967)] = 442440,
  [SMALL_STATE(9968)] = 442481,
  [SMALL_STATE(9969)] = 442522,
  [SMALL_STATE(9970)] = 442563,
  [SMALL_STATE(9971)] = 442604,
  [SMALL_STATE(9972)] = 442645,
  [SMALL_STATE(9973)] = 442686,
  [SMALL_STATE(9974)] = 442727,
  [SMALL_STATE(9975)] = 442768,
  [SMALL_STATE(9976)] = 442809,
  [SMALL_STATE(9977)] = 442850,
  [SMALL_STATE(9978)] = 442891,
  [SMALL_STATE(9979)] = 442932,
  [SMALL_STATE(9980)] = 442973,
  [SMALL_STATE(9981)] = 443014,
  [SMALL_STATE(9982)] = 443018,
  [SMALL_STATE(9983)] = 443022,
  [SMALL_STATE(9984)] = 443026,
  [SMALL_STATE(9985)] = 443030,
  [SMALL_STATE(9986)] = 443034,
  [SMALL_STATE(9987)] = 443038,
  [SMALL_STATE(9988)] = 443042,
  [SMALL_STATE(9989)] = 443046,
  [SMALL_STATE(9990)] = 443050,
  [SMALL_STATE(9991)] = 443054,
  [SMALL_STATE(9992)] = 443058,
  [SMALL_STATE(9993)] = 443062,
  [SMALL_STATE(9994)] = 443066,
  [SMALL_STATE(9995)] = 443070,
  [SMALL_STATE(9996)] = 443074,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8989),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9980),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9973),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [21] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 0, 0, 0),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3812),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4081),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6842),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7381),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7353),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4356),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7247),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8420),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9946),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9944),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9943),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9942),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9941),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8940),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8937),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9935),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9934),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5167),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9929),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9926),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9925),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9923),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9921),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8914),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6273),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9970),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9968),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9964),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6845),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7350),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7352),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7356),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8503),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9615),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9611),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9746),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9959),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9747),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8918),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9606),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9748),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 3, 0, 37),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 37),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8944),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 2, 0, 0),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2744),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4084),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2745),
  [264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2491),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2917),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3112),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3812),
  [276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4081),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(513),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1002),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6842),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7362),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(645),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7370),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7381),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(29),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7353),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4356),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7247),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3806),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2655),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4049),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2928),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8420),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4188),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1683),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2737),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3753),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5426),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9946),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9944),
  [363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9943),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9942),
  [372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9941),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2871),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8940),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4090),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(952),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8937),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9935),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(668),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9934),
  [402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2456),
  [408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5167),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9926),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9925),
  [423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9923),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9921),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8914),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6273),
  [441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9970),
  [444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9968),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9964),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9962),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 1, 0, 0),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2744),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3956),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2745),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2225),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2834),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3098),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3866),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4081),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(512),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6845),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7350),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(673),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7352),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7354),
  [503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4329),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7242),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3806),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2655),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3966),
  [524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2928),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8503),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4188),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(1683),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2737),
  [548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(3753),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5426),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9615),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9611),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9746),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9959),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9747),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2814),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8789),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4090),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(928),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8918),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9606),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(675),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9748),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(2456),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(5167),
  [614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9926),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9925),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9923),
  [626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9921),
  [629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(8914),
  [635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(6227),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9970),
  [646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9968),
  [649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9964),
  [652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 2, 0, 0), SHIFT_REPEAT(9962),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 1, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_top_level, 2, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4378),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8102),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4689),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8529),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9124),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9123),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9455),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9916),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9456),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8846),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9974),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9457),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2744),
  [734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4692),
  [737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2745),
  [740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2710),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3117),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4378),
  [749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4693),
  [752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(518),
  [755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(981),
  [761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1009),
  [764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8102),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2732),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4689),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3118),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8529),
  [784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4188),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(1683),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2737),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(3753),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5426),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9124),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9123),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9455),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9916),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9456),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2820),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8846),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4090),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(911),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8868),
  [846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9974),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9457),
  [858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(2456),
  [864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(7814),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5167),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9929),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9926),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9925),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9923),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9921),
  [885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(8914),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4237),
  [894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6296),
  [897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9970),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9968),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9964),
  [906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(9962),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9190),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 5, 0, 0),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 5, 0, 0),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 3, 0, 0),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 3, 0, 0),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 2, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 2, 0, 0),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9535),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 4, 0, 0),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 4, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3107),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8495),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9521),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9464),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9674),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9947),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9675),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8908),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8924),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9791),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9676),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4401),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4376),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9835),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9832),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4360),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8260),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8014),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9826),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3991),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4023),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1766),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5203),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9795),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9796),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9823),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9824),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9452),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4024),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2, 0, 0),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8011),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6934),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7870),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9459),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9460),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9679),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9680),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9738),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6260),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9612),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9620),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [1313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8087),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4390),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9801),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [1339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5175),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9797),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9595),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7970),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9756),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5598),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [1429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5648),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5650),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5205),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9749),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9750),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9751),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9752),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9602),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5653),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8920),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6219),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9213),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9209),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9205),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4424),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4370),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8015),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9471),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4588),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4687),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9677),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9678),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9461),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9462),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9975),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4664),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4443),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4432),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1902),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4396),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4386),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4448),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1816),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9400),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 1, 0, 0),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 4, 0, 15),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 4, 0, 15),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9734),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9166),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8980),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9726),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9187),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9683),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9408),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1551),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [2175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4446),
  [2187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4366),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4412),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9596),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9979),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9608),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [2331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [2355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [2383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [2403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3551),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [2471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [2509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7997),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [2541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5574),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1866),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9469),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9839),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 3, 0, 37),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8994),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9101),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7190),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4887),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7295),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7210),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7170),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [2761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7255),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7236),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7184),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 1, 0, 0),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8887),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4806),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8734),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4881),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 1, 0, 0),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 2, 0, 0),
  [2993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 37),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 4, 0, 37),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 37),
  [2999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 4, 0, 37),
  [3001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 7),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 7),
  [3005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7869),
  [3007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8902),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, 0, 7),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, 0, 7),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [3017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7869),
  [3020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7846),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8777),
  [3024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 55),
  [3026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 55),
  [3028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, 0, 77),
  [3030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 77),
  [3032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 7),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 7),
  [3036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [3038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1, 0, 0),
  [3040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [3042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [3044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7846),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 118),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 118),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 66),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 66),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_statement, 2, 0, 0),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 88),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 88),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 7, 0, 102),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 7, 0, 102),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 103),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 103),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 178),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 178),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 104),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 104),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 105),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 105),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_statement, 2, 0, 0),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 62),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 62),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 39),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 39),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, 0, 61),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, 0, 61),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4535),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [3123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7377),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4490),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7374),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7367),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4733),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7238),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7348),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6780),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5340),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 37),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 37),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 37),
  [3171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [3179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 57),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 5, 0, 57),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 56),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 56),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [3189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 5, 0, 0),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3, 0, 0),
  [3197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, 0, 54),
  [3199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 54),
  [3201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_statement, 5, 0, 0),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, 0, 0),
  [3209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 53),
  [3211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 53),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_statement, 5, 0, 0),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, 0, 106),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, 0, 106),
  [3221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 107),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 107),
  [3225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 5, 0, 46),
  [3227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 5, 0, 46),
  [3229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 2, 0, 0),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 3, 0, 0),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 112),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 112),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [3249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, 0, 117),
  [3251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, 0, 117),
  [3253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 80),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 80),
  [3257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3, 0, 0),
  [3261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 20),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 20),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [3269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 3, 0, 37),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 138),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 138),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 87),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 87),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 0),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 139),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 139),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 140),
  [3295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 140),
  [3297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 141),
  [3299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 141),
  [3301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 142),
  [3303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 142),
  [3305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2, 0, 0),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 76),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 76),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 0),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 179),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 179),
  [3321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 4, 0, 0),
  [3325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, 0, 220),
  [3327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, 0, 220),
  [3329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 180),
  [3331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 180),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, 0, 181),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, 0, 181),
  [3337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, 0, 86),
  [3339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, 0, 86),
  [3341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, 0, 143),
  [3343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, 0, 143),
  [3345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 205),
  [3347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 205),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 206),
  [3351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 206),
  [3353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, 0, 207),
  [3355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, 0, 207),
  [3357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 4, 0, 40),
  [3359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 4, 0, 40),
  [3361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 39),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 39),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, 0, 0),
  [3367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, 0, 0),
  [3369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 79),
  [3371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_top_level, 6, 0, 79),
  [3373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 4, 0, 0),
  [3377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 4, 0, 0),
  [3381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 6, 0, 76),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 6, 0, 76),
  [3385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, 0, 144),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, 0, 144),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 8, 0, 150),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 8, 0, 150),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 7),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 7),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [3399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 176),
  [3401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 176),
  [3403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 177),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 177),
  [3407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 109),
  [3409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 109),
  [3411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 29),
  [3413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 29),
  [3415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3, 0, 0),
  [3419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 29),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 29),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 71),
  [3425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 71),
  [3427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 14),
  [3429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 14),
  [3431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 29),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 29),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 137),
  [3437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 137),
  [3439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 50),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 50),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 70),
  [3445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 70),
  [3447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 14),
  [3449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 14),
  [3451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 136),
  [3453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 136),
  [3455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 49),
  [3457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 49),
  [3459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 49),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 49),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 49),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 49),
  [3467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 136),
  [3469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 136),
  [3471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 137),
  [3473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 137),
  [3475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 136),
  [3477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 136),
  [3479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_top_level_repeat1, 1, 0, 0),
  [3483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 113),
  [3485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 113),
  [3487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 116),
  [3489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 116),
  [3491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 5, 0, 0),
  [3495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 115),
  [3497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 115),
  [3499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 109),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 109),
  [3503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 137),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 137),
  [3507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 71),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 71),
  [3511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 145),
  [3513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 145),
  [3515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, 0, 48),
  [3517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, 0, 48),
  [3519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 82),
  [3521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 82),
  [3523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 1, 0, 0),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 71),
  [3529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 71),
  [3531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [3533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, 0, 48),
  [3535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 83),
  [3537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 83),
  [3539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 71),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 71),
  [3543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 84),
  [3545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 84),
  [3547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, 0, 48),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 48),
  [3551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, 0, 35),
  [3553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, 0, 35),
  [3555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 48),
  [3557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 48),
  [3559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 146),
  [3561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 146),
  [3563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 111),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 111),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, 0, 14),
  [3569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, 0, 14),
  [3571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 35),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 35),
  [3575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 85),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 85),
  [3579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, 0, 35),
  [3581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, 0, 35),
  [3583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, 0, 35),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, 0, 35),
  [3587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, 0, 82),
  [3589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, 0, 82),
  [3591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 85),
  [3593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 85),
  [3595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, 0, 35),
  [3597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, 0, 35),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 4, 0, 35),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 4, 0, 35),
  [3603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 82),
  [3605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 82),
  [3607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 5, 0, 52),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 5, 0, 52),
  [3611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, 0, 82),
  [3613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 82),
  [3615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 29),
  [3617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 29),
  [3619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 49),
  [3621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 49),
  [3623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 82),
  [3625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 82),
  [3627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 14),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 14),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, 0, 48),
  [3633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, 0, 48),
  [3635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 145),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 145),
  [3639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, 0, 145),
  [3641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, 0, 145),
  [3643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, 0, 147),
  [3645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 147),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 7, 0, 85),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 7, 0, 85),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 97),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 97),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, 0, 49),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 49),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 98),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 98),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 148),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 148),
  [3667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, 0, 145),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, 0, 145),
  [3671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 114),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 114),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 97),
  [3677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 97),
  [3679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 100),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 100),
  [3683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 52),
  [3685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 52),
  [3687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, 0, 109),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, 0, 109),
  [3691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 113),
  [3693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 113),
  [3695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 109),
  [3697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 109),
  [3699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 85),
  [3701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 85),
  [3703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 149),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 149),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, 0, 115),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, 0, 115),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, 0, 75),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, 0, 75),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 116),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 116),
  [3719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 75),
  [3721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 75),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 29),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 29),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, 0, 147),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, 0, 147),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 14),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 3, 0, 14),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 6, 0, 0),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 6, 0, 0),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 4, 0, 0),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 70),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 70),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 175),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 175),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 98),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 98),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 14),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 14),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_alias_directive, 4, 0, 29),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_alias_directive, 4, 0, 29),
  [3763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 175),
  [3765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 175),
  [3767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 7, 0, 0),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 84),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 84),
  [3775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 14),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 14),
  [3779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute, 6, 0, 0),
  [3783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, 0, 97),
  [3785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, 0, 97),
  [3787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, 0, 73),
  [3789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, 0, 73),
  [3791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, 0, 111),
  [3793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, 0, 111),
  [3795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 98),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 98),
  [3799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 0),
  [3803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, 0, 110),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, 0, 110),
  [3807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 175),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 175),
  [3811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, 0, 109),
  [3813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 109),
  [3815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 182),
  [3817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 182),
  [3819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 85),
  [3821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 85),
  [3823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 11, 0, 221),
  [3825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 11, 0, 221),
  [3827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 11, 0, 116),
  [3829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 11, 0, 116),
  [3831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 11, 0, 221),
  [3833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 11, 0, 221),
  [3835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 182),
  [3837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 182),
  [3839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 209),
  [3841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 209),
  [3843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 70),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 70),
  [3847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, 0, 71),
  [3849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 71),
  [3851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [3853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, 0, 70),
  [3855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, 0, 182),
  [3857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, 0, 182),
  [3859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, 0, 183),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 183),
  [3863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4535),
  [3866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3798),
  [3869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4540),
  [3872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6767),
  [3875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6772),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3806),
  [3881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5685),
  [3884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4604),
  [3887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4729),
  [3890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6838),
  [3893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7377),
  [3896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4490),
  [3899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7374),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7367),
  [3905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0),
  [3907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7364),
  [3910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4733),
  [3913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7238),
  [3916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3334),
  [3919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7348),
  [3922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6780),
  [3925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4688),
  [3928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4831),
  [3931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5340),
  [3934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6279),
  [3937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 6, 0, 29),
  [3939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 6, 0, 29),
  [3941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, 0, 184),
  [3943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, 0, 184),
  [3945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 116),
  [3947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 116),
  [3949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 10, 0, 209),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 10, 0, 209),
  [3953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 9, 0, 149),
  [3955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 9, 0, 149),
  [3957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, 0, 98),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, 0, 98),
  [3961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 10, 0, 208),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 10, 0, 208),
  [3965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 208),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 208),
  [3969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 10, 0, 85),
  [3971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 10, 0, 85),
  [3973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 10, 0, 208),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 10, 0, 208),
  [3977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 116),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 116),
  [3981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, 0, 183),
  [3983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, 0, 183),
  [3985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4535),
  [3988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4540),
  [3991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0),
  [3995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4604),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9745),
  [4002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4688),
  [4005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4831),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7929),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8950),
  [4014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 1, 0, 0),
  [4016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 1, 0, 0),
  [4018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [4020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0),
  [4022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [4024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 1, 0, 0),
  [4026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7929),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9046),
  [4031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [4037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier, 1, 0, 0),
  [4042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [4047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [4051] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2744),
  [4055] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1), SHIFT(2745),
  [4059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__reserved_identifier, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [4062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2925),
  [4065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2927),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4585),
  [4070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2744),
  [4073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2745),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4607),
  [4078] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3936),
  [4082] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3941),
  [4086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [4092] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6855),
  [4096] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4073),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4616),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [4104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3207),
  [4107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3218),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [4112] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6832),
  [4116] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4227),
  [4120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [4122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [4126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [4128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 4, 0, 0),
  [4130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [4132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 3, 0, 0),
  [4134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [4136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 2, 0, 0),
  [4138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0),
  [4140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0),
  [4142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_name, 2, 0, 0),
  [4144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_name, 2, 0, 0),
  [4146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4410),
  [4149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 3),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [4155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1, 0, 0),
  [4157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1, 0, 0),
  [4159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 22),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, 0, 19),
  [4173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, 0, 19),
  [4175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 22), REDUCE(sym_member_access_expression, 3, 0, 19),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 3, 0, 22),
  [4180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_name, 3, 0, 22), REDUCE(sym_member_access_expression, 3, 0, 19),
  [4183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [4186] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4190] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1, 0, 0), REDUCE(sym_constant_pattern, 1, 0, 0),
  [4197] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3150),
  [4201] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3165),
  [4205] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5210),
  [4209] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5136),
  [4213] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6843),
  [4217] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5585),
  [4221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [4227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3836),
  [4230] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3887),
  [4234] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3886),
  [4238] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2925),
  [4242] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(2927),
  [4246] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6901),
  [4250] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(4549),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [4256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [4260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [4262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [4264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3794),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4551),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7301),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7376),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7176),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6787),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [4292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3571),
  [4295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(1754),
  [4298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), REDUCE(sym__simple_name, 1, 0, 0),
  [4301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 0), REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 1, 0, 1),
  [4304] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3590),
  [4308] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3594),
  [4312] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(6872),
  [4316] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5017),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 4),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4393),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [4327] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3562),
  [4331] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_implicit_type, 1, 1, 0), REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3571),
  [4335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [4339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 3, 0, 23),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 3, 0, 23),
  [4345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [4347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_pattern, 1, 0, 5),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_pattern, 1, 0, 5),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3590),
  [4353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [4355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [4357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4227),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7379),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [4365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7380),
  [4367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7382),
  [4369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7219),
  [4373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [4375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9548),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [4379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7305),
  [4381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4519),
  [4383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7317),
  [4387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4612),
  [4389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7214),
  [4391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [4397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 1, 0, 0),
  [4399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [4401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6781),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 5),
  [4405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 5),
  [4407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [4409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7298),
  [4413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7296),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7319),
  [4421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7272),
  [4425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [4429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 2, 0, 6),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 2, 0, 6),
  [4433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 5),
  [4435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 5),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9697),
  [4441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [4445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 0),
  [4447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [4449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9542),
  [4451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [4453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [4455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 5),
  [4457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 5),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5191),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5195),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [4465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 7, 0, 101),
  [4467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 7, 0, 101),
  [4469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [4471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 6, 0, 74),
  [4473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 6, 0, 74),
  [4475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4701),
  [4477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(5195),
  [4480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scoped_base_type, 1, 0, 0),
  [4484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type, 2, 0, 6),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type, 2, 0, 6),
  [4488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 2, 0, 5),
  [4490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 2, 0, 5),
  [4492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 3, 0, 15),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 3, 0, 15),
  [4498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 5, 0, 51),
  [4500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 5, 0, 51),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [4504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4380),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4563),
  [4509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3886),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9918),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3648),
  [4530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 2, 0, 0),
  [4538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0),
  [4541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(2909),
  [4544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__pointer_base_type, 1, 0, 0),
  [4547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5210),
  [4549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5136),
  [4551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [4553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5585),
  [4555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 2, 0, 0),
  [4559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [4561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7300),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4513),
  [4565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7322),
  [4567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7293),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [4571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4697),
  [4573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7189),
  [4575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3671),
  [4577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 4, 0, 0),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7224),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [4585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4379),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7383),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7387),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7373),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7333),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4552),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [4602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_qualified_name, 3, 0, 28),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_qualified_name, 3, 0, 28),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [4608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 8),
  [4610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 8),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4556),
  [4618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [4622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 3, 0, 0),
  [4626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 4, 0, 0),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 24),
  [4638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lvalue_expression, 1, 0, 2),
  [4642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 24),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_indirection_expression, 2, 0, 0),
  [4654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 4, 0, 0),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [4660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7263),
  [4664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 3, 0, 0),
  [4668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 2, 0, 0),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4613),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4736),
  [4676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__reserved_identifier, 1, 0, 0), SHIFT(3594),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4737),
  [4681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parenthesized_lvalue_expression, 3, 0, 0),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7282),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [4691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 3, 0, 0),
  [4695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_access_expression, 2, 0, 10),
  [4697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_access_expression, 2, 0, 10),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [4701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 5, 0, 0),
  [4705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 5, 0, 0),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 5, 0, 0),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 4, 0, 0),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4549),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [4719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [4723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4711),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4546),
  [4727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4544),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4593),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [4749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [4755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [4757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4431),
  [4760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4447),
  [4763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 3, 0, 0),
  [4767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7169),
  [4769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 3, 0, 68),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3, 0, 68),
  [4775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7243),
  [4777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 90),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [4781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 90),
  [4783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 93),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 93),
  [4789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 2, 0, 0),
  [4793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 161),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 161),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_lvalue_expression, 1, 0, 0),
  [4807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0),
  [4809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [4813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 131),
  [4815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 121),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 121),
  [4821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 3, 0, 0),
  [4825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [4827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7215),
  [4829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4444),
  [4832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 204),
  [4834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 204),
  [4836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, 0, 94),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, 0, 94),
  [4840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 203),
  [4842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 203),
  [4844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 202),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 202),
  [4848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3286),
  [4851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7231),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 211),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 211),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 212),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 212),
  [4863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 185),
  [4865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 7, 0, 185),
  [4867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 213),
  [4869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 213),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 201),
  [4873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 201),
  [4875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 8, 0, 214),
  [4877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 8, 0, 214),
  [4879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7227),
  [4881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 8, 0, 215),
  [4883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 8, 0, 215),
  [4885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 3, 1, 0),
  [4889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 200),
  [4891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 200),
  [4893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, 0, 95),
  [4895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, 0, 95),
  [4897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 4, 0, 92),
  [4899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 4, 0, 92),
  [4901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, 0, 96),
  [4903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, 0, 96),
  [4905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 37),
  [4907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 37),
  [4909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 216),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 216),
  [4913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 4, 1, 0),
  [4917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 217),
  [4919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 217),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [4923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, 0, 218),
  [4925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, 0, 218),
  [4927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, 0, 219),
  [4929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, 0, 219),
  [4931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 199),
  [4933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 199),
  [4935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, 0, 91),
  [4937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, 0, 91),
  [4939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 0),
  [4943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 198),
  [4945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 198),
  [4947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 197),
  [4949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 197),
  [4951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, 0, 196),
  [4953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, 0, 196),
  [4955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 195),
  [4957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 195),
  [4959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 194),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 194),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, 0, 69),
  [4965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, 0, 69),
  [4967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1, 0, 0),
  [4971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7197),
  [4977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 193),
  [4979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 193),
  [4981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 192),
  [4983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 192),
  [4985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 8, 0, 210),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 8, 0, 210),
  [4989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 0),
  [4993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, 0, 191),
  [4995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, 0, 191),
  [4997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 5, 0, 119),
  [4999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 5, 0, 119),
  [5001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 120),
  [5003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 120),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 121),
  [5007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 121),
  [5009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 122),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 5, 0, 122),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 57),
  [5015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 57),
  [5017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 37),
  [5019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 37),
  [5021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 5, 0, 123),
  [5023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, 0, 123),
  [5025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 124),
  [5027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 124),
  [5029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 9, 0, 222),
  [5031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 9, 0, 222),
  [5033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 125),
  [5035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 125),
  [5037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [5039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 126),
  [5041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 127),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 127),
  [5045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [5047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 130),
  [5049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 47),
  [5051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 47),
  [5053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, 0, 131),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, 0, 131),
  [5057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, 0, 132),
  [5059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, 0, 132),
  [5061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 133),
  [5063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 133),
  [5065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, 0, 134),
  [5067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, 0, 134),
  [5069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7180),
  [5071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, 0, 135),
  [5073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, 0, 135),
  [5075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [5077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 5, 1, 0),
  [5079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, 0, 119),
  [5081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, 0, 119),
  [5083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, 0, 129),
  [5085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, 0, 129),
  [5087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [5089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 6, 0, 151),
  [5091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 79),
  [5093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 79),
  [5095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [5097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 152),
  [5099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [5101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 153),
  [5103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 154),
  [5105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 154),
  [5107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [5109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 155),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 157),
  [5115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 158),
  [5117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 158),
  [5119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 6, 0, 159),
  [5121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 6, 0, 159),
  [5123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [5125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 160),
  [5127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 190),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 190),
  [5131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 161),
  [5133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 161),
  [5135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, 0, 162),
  [5137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, 0, 162),
  [5139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 164),
  [5141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 164),
  [5143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 165),
  [5145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 165),
  [5147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 166),
  [5149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 166),
  [5151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 167),
  [5153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 167),
  [5155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 168),
  [5157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 168),
  [5159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [5161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 0),
  [5163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 30),
  [5165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 30),
  [5167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 169),
  [5169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 169),
  [5171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, 0, 170),
  [5173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, 0, 170),
  [5175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 9, 0, 225),
  [5177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 9, 0, 225),
  [5179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 171),
  [5181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 171),
  [5183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 9, 0, 224),
  [5185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 9, 0, 224),
  [5187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, 0, 188),
  [5189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, 0, 188),
  [5191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 9, 0, 223),
  [5193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 9, 0, 223),
  [5195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, 0, 172),
  [5197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, 0, 172),
  [5199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 4, 0, 91),
  [5201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 4, 0, 91),
  [5203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, 0, 173),
  [5205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, 0, 173),
  [5207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 6, 0, 174),
  [5209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 6, 0, 174),
  [5211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, 0, 163),
  [5213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, 0, 163),
  [5215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, 0, 186),
  [5217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, 0, 186),
  [5219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, 0, 90),
  [5221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, 0, 90),
  [5223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [5225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, 0, 187),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7191),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7254),
  [5233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7274),
  [5235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7266),
  [5237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7259),
  [5239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [5241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7213),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7273),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [5247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [5253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7244),
  [5255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7250),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7252),
  [5259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7226),
  [5261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [5263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2, 0, 6),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2, 0, 6),
  [5269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4402),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4330),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8662),
  [5282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [5286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2, 0, 0),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3682),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [5292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [5294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [5296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [5304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 2, 0, 6),
  [5311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [5313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unary_expression, 2, 0, 0),
  [5315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 17),
  [5317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 17),
  [5319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [5321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 2, 0, 0),
  [5323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 1, 34),
  [5325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 1, 34),
  [5327] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym__array_base_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(720),
  [5337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6),
  [5340] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3701),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [5346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4405),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [5359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5685),
  [5362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0),
  [5364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [5366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 3, 0, 0),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [5370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [5374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [5380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [5382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [5388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3618),
  [5391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_stackalloc_expression, 4, 0, 0),
  [5403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 5, 0, 0),
  [5407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4, 0, 45),
  [5409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4, 0, 45),
  [5411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 4, 0, 0),
  [5415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 5, 0, 0),
  [5417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 5, 0, 0),
  [5419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 5, 0, 0),
  [5421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 5, 0, 0),
  [5423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 44),
  [5425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 44),
  [5427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [5429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [5431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 3, 0, 0),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [5437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3701),
  [5440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_refvalue_expression, 6, 0, 78),
  [5442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_refvalue_expression, 6, 0, 78),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 79),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 6, 0, 79),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 4, 0, 0),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 4, 0, 0),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 6, 0, 0),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 6, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 4, 0, 0),
  [5458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 4, 0, 0),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_binding_expression, 2, 0, 14),
  [5462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_binding_expression, 2, 0, 14),
  [5464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 65),
  [5470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 65),
  [5472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 38),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 38),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [5482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 57),
  [5484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 57),
  [5486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4528),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [5496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7902),
  [5500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 2, 0, 0),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 1, 0, 0),
  [5506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 6, 0, 89),
  [5508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 6, 0, 89),
  [5510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [5512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reftype_expression, 4, 0, 0),
  [5514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_makeref_expression, 4, 0, 0),
  [5518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 67),
  [5520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 67),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeof_expression, 4, 0, 15),
  [5524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeof_expression, 4, 0, 15),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 37),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_expression, 5, 0, 37),
  [5530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 15),
  [5532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 15),
  [5534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 6, 0, 0),
  [5538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_unary_expression, 2, 0, 0),
  [5542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2744),
  [5545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4528),
  [5548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2745),
  [5551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5476),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0),
  [5556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4283),
  [5559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7902),
  [5562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_expression, 4, 0, 0),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, 0, 36),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, 0, 36),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__select_or_group_clause, 1, 0, 0),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation_expression, 2, 0, 9),
  [5576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation_expression, 2, 0, 9),
  [5578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_query_expression, 2, 0, 0),
  [5582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 3, 0, 0),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 4, 0, 0),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [5596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 4, 0, 0),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 4, 0, 0),
  [5604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 3, 0, 0),
  [5608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 4, 0, 0),
  [5610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 4, 0, 0),
  [5612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [5614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 6, 0, 0),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 4, 0, 0),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 0),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 27),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 27),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 5, 0, 0),
  [5632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 5, 0, 0),
  [5636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3, 0, 16),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3, 0, 16),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 7, 0, 0),
  [5648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, 0, 23),
  [5650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, 0, 23),
  [5652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, 0, 25),
  [5654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, 0, 25),
  [5656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 4, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stackalloc_expression, 3, 0, 6),
  [5662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stackalloc_expression, 3, 0, 6),
  [5664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, 17, 6),
  [5666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, 17, 6),
  [5668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, 0, 18),
  [5670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, 0, 18),
  [5672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 3, 0, 0),
  [5676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 3, 0, 0),
  [5680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 3, 0, 0),
  [5684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7220),
  [5686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0),
  [5688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(3806),
  [5691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat1, 1, 0, 0),
  [5699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 1, 0, 0),
  [5701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [5703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 5, 0, 0),
  [5705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [5707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 6, 0, 0),
  [5709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [5713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [5719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 4, 0, 0),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [5723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [5731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4614),
  [5733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9948),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7316),
  [5739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7991),
  [5743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [5747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 1, 0, 0),
  [5749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat2, 1, 0, 0),
  [5751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4442),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7777),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [5768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(659),
  [5771] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3914),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [5779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4417),
  [5786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [5794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4265),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [5808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [5810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4449),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [5815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [5819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7183),
  [5821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(3914),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [5826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7360),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [5848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 108),
  [5850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 4, 0, 108),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [5858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 5, 0, 0),
  [5860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 4, 0, 81),
  [5862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 4, 0, 81),
  [5864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 41),
  [5866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 3, 0, 41),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7847),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [5872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 4, 0, 0),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 58),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 58),
  [5882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(4007),
  [5885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_and_pattern, 3, 0, 23),
  [5887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_and_pattern, 3, 0, 23),
  [5889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3, 0, 64),
  [5891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3, 0, 64),
  [5893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym_non_lvalue_expression, 1, 0, 0),
  [5899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1, 0, 0), REDUCE(sym__expression_statement_expression, 1, 0, 0),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [5907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 2, 0, 0),
  [5911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3, 0, 0),
  [5915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [5917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [5919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [5921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [5925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [5929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_pattern_expression, 3, 0, 26),
  [5931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_pattern_expression, 3, 0, 26),
  [5933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2, 0, 41),
  [5935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2, 0, 41),
  [5937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(667),
  [5940] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(4007),
  [5944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_pattern, 2, 0, 42),
  [5946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_pattern, 2, 0, 42),
  [5948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 4),
  [5950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_pattern, 2, 0, 41),
  [5952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_pattern, 2, 0, 41),
  [5954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1, 0, 0),
  [5958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [5962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [5966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7975),
  [5968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8044),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8056),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7947),
  [5974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5045),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8036),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7834),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4597),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8132),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9784),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7530),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8035),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7968),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [6008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(730),
  [6011] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(3618),
  [6015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [6019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [6023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5476),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [6038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7276),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 3, 0, 156),
  [6062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 3, 0, 156),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [6066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [6070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 4, 0, 189),
  [6072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 4, 0, 189),
  [6074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 2, 0, 128),
  [6076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 2, 0, 128),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [6096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5720),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [6101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [6103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 1, 0, 0),
  [6105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(4528),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [6112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [6116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [6124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [6130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [6132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [6136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [6154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [6164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_expression, 2, 0, 0),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [6172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 23),
  [6182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 23),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9960),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3626),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9969),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3910),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [6214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 63),
  [6216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 63),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [6232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(657),
  [6235] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(2909),
  [6239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [6241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [6249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9971),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [6253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [6259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [6261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 23),
  [6263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 23),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2771),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9967),
  [6275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [6277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5192),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5242),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8665),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [6303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [6305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2, 0, 0),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3063),
  [6309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_clause, 2, 0, 0),
  [6311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_clause, 2, 0, 0),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [6315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_clause, 4, 0, 0),
  [6317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group_clause, 4, 0, 0),
  [6319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [6325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [6329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [6331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [6333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [6337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [6341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [6343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [6345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [6357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [6363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [6367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [6369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [6371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_pattern, 2, 0, 0),
  [6373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(4692),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [6380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [6384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [6386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [6388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [6392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [6396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [6398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [6402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [6428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [6430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [6448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4931),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [6452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [6458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7339),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [6462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [6466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 1, 0, 0),
  [6468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 1, 0, 0),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [6472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 2, 0, 0),
  [6474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 2, 0, 0),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [6480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0),
  [6488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7334),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 3, 0, 0),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 3, 0, 0),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7314),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [6509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4535),
  [6512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4540),
  [6515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4604),
  [6518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5045),
  [6521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9745),
  [6524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5131),
  [6527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8341),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [6532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4880),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5269),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [6544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4783),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [6554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4784),
  [6556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [6562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1892),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [6570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [6574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [6586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [6594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [6596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4883),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4910),
  [6606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [6618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4899),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [6622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4548),
  [6624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [6626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4627),
  [6628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4845),
  [6630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5248),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_pattern, 2, 0, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [6638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [6640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [6642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7324),
  [6645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3, 0, 23),
  [6647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_pattern, 3, 0, 23),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [6653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9972),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [6677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4925),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4913),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4911),
  [6683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4870),
  [6687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4717),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [6693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4851),
  [6697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [6699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [6701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [6703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [6705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [6709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [6711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4872),
  [6713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [6717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [6721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [6735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [6745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [6747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [6757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [6771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [6773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [6777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [6797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [6803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [6805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [6807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2052),
  [6809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [6811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7308),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [6835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 1, 0, 0),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [6839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7308),
  [6842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [6854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [6856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9626),
  [6882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7346),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7321),
  [6891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7321),
  [6894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [6898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [6906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1946),
  [6908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [6912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [6930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [6932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_body, 4, 0, 0),
  [6934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [6936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [6938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [6942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [6946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [6948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [6952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [6968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8341),
  [6970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [6976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [6980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [7010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2113),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [7020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9047),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9044),
  [7046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [7050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 5, 0, 30),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7299),
  [7054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(4381),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [7059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7299),
  [7062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 4, 0, 0),
  [7064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 4, 0, 14),
  [7066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [7070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [7082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [7086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8568),
  [7106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [7108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2122),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [7114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2127),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [7142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5684),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [7146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [7150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9153),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9152),
  [7162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [7166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [7168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9051),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9011),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9170),
  [7196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(669),
  [7199] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), REDUCE(sym_array_creation_expression, 2, 17, 6), SHIFT(5309),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [7205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7355),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [7212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [7216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1921),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [7220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1920),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [7224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [7226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8330),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [7252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [7254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [7258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [7268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [7288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [7294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [7298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [7320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type, 1, 0, 0), SHIFT(5309),
  [7323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [7327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [7333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [7337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [7343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_base_type, 1, 0, 0),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [7347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_base_type, 1, 0, 0),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7279),
  [7361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [7363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [7365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [7369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [7379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [7397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [7403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [7407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [7421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [7429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [7431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1930),
  [7437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [7459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [7461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7332),
  [7473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7332),
  [7476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 37),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [7486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [7498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [7504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [7508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [7524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [7526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [7528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [7532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [7538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [7556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [7558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [7566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [7568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [7572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [7588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [7590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [7594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [7606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [7608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [7620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [7628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [7630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [7632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [7636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [7640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [7646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [7668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [7670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [7672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [7676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [7682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [7686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [7704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [7706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [7712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [7716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [7718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [7722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [7738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [7740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [7744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [7748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [7752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [7754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [7758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [7782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [7786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [7790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [7794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [7796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [7806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [7816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7303),
  [7819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7326),
  [7822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [7824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [7826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [7830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [7832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [7860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [7866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7386),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [7871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 5), REDUCE(sym_type_pattern, 1, 0, 5),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [7878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7315),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [7895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [7905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [7907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [7929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 14),
  [7931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 12),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [7939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 4, 0, 4),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [7943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2, 0, 0),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [7949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [7953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [7957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [7963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [7975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [7983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [7985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [7987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [7991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [7995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1789),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [8001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [8021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [8035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [8037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [8041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [8045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [8047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [8051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [8069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [8071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [8083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [8087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [8119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [8125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [8149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 4),
  [8151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [8167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [8171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 30),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [8191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3, 0, 4),
  [8193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6, 0, 47),
  [8195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [8199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [8207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7384),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [8228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [8230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7201),
  [8232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7372),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [8245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 4, 0, 99),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [8257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1945),
  [8259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [8263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [8265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [8269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1923),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [8293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7361),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [8306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 3, 0, 72),
  [8308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [8314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7347),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [8329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_alignment_clause, 2, 0, 0),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [8335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [8339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [8345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [8349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [8359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [8365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [8367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [8369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [8373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [8377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [8379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2065),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [8383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7781),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7780),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [8411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8125),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [8419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [8421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [8423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [8427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [8431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [8433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [8437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [8443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [8445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [8455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7163),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [8465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [8467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 3, 0, 0),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [8473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 3, 0, 4),
  [8475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_initializer, 3, 0, 0),
  [8477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 0),
  [8479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, 0, 4),
  [8481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 0),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [8487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 4, 0, 4),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [8491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [8497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [8501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [8503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [8507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [8535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 1, 0, 0),
  [8537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5467),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [8544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 3, 0, 0),
  [8546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 1, 0, 0),
  [8548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [8560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 3, 0, 0),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [8566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 4, 0, 0),
  [8568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [8570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [8574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [8592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [8596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [8600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [8606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [8610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [8626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [8628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [8634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [8638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [8644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [8666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_expression_clause, 2, 0, 0),
  [8668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [8672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [8674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [8700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [8702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8968),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9886),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [8722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [8726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [8730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [8758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7397),
  [8760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8919),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [8772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [8774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [8800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [8802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [8814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 4), REDUCE(sym_type, 1, 0, 0),
  [8817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type, 1, 0, 0), SHIFT(728),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [8834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7327),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [8847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [8853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [8855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7396),
  [8857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [8861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [8867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [8873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7389),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [8879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [8885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [8891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [8897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [8903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [8905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [8907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [8911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [8913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [8917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [8919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [8923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7341),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [8969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [8971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [8973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [8977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [8981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [8983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [8987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [8995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [8999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [9003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9373),
  [9011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7389),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [9052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7341),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [9065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [9067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [9129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [9137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 3, 0, 0),
  [9139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [9141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [9143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [9145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_expression, 2, 0, 0),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [9151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__join_header, 4, 0, 5),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [9165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 2, 0, 0),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [9177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9278),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [9189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9565),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [9203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat2, 2, 0, 0), SHIFT_REPEAT(7336),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [9218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [9220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 14),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [9236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(3724),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8780),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [9253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [9257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 3, 0, 37),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [9263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), SHIFT(7016),
  [9266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 4), SHIFT(7783),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9025),
  [9271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [9275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1, 0, 0), SHIFT(7016),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [9288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [9296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6807),
  [9298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [9302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [9314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4562),
  [9316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6833),
  [9318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [9324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6831),
  [9326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6815),
  [9328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [9330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0),
  [9332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parameter_type_with_modifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(6802),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [9337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9361),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [9359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 4),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [9363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [9365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [9367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6895),
  [9369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1682),
  [9371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [9373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [9375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 1, 0, 5),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [9383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7345),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [9393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0),
  [9395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6945),
  [9398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 2, 0, 0),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [9404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [9406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [9408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [9434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 1, 0, 0),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8483),
  [9466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [9470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [9472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8841),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [9478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7239),
  [9480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [9486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2, 0, 0),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7167),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [9494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2744),
  [9497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0), SHIFT(2745),
  [9500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2, 0, 0),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [9504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [9512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lambda_expression_repeat1, 1, 0, 1),
  [9514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_expression_repeat1, 1, 0, 1),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8852),
  [9518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5775),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [9523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6712),
  [9527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6711),
  [9529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [9531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [9533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [9537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [9539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [9541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [9543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [9545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7395),
  [9547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8750),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [9551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7306),
  [9553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8566),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [9557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8784),
  [9559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8989),
  [9561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8376),
  [9563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8984),
  [9565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8392),
  [9567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9980),
  [9569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9976),
  [9571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9973),
  [9573] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7390),
  [9577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [9579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8736),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [9583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [9589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7338),
  [9591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7378),
  [9593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [9595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [9597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [9599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [9603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7392),
  [9605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8704),
  [9607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [9609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [9611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3920),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7343),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [9621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [9627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8793),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [9633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8707),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [9639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [9645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8711),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8711),
  [9651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8720),
  [9653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [9657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8928),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [9661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8858),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8788),
  [9669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_target_specifier, 2, 0, 0),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [9677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [9737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [9761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4),
  [9763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [9769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [9771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(1614),
  [9774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4898),
  [9777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(4610),
  [9780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(7349),
  [9783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0), SHIFT_REPEAT(971),
  [9786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2, 0, 0),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [9792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [9794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [9798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9258),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9294),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9892),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9109),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [9822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3434),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [9827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3511),
  [9830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0), REDUCE(sym__reserved_identifier, 1, 0, 0),
  [9833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 4), SHIFT(3512),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9325),
  [9840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [9842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [9846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9286),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9233),
  [9856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [9870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 3, 0, 0),
  [9872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(943),
  [9875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2, 0, 0),
  [9877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 3, 0, 43),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [9881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 2, 0, 0),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [9885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 4), REDUCE(sym__simple_name, 1, 0, 0),
  [9888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [9890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9316),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [9894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9279),
  [9898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [9900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [9902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9846),
  [9904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [9906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 2, 0, 0),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [9910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 2, 0, 0),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [9914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9235),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [9920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7927),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8335),
  [9928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [9930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_clause, 1, 0, 0),
  [9932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 1, 0, 0),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [9942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [9944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_into_clause, 2, 0, 0),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [9948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0),
  [9950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(8335),
  [9953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1411),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [9958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [9960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 4, 0, 43),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9818),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9977),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [9974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 58),
  [9976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 14),
  [9978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 60),
  [9980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [9982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [9984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [9988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8275),
  [9990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8322),
  [9992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8713),
  [9994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8384),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8302),
  [10006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ref_base_type, 1, 0, 0),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8786),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [10014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 2, 0, 0),
  [10016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 2, 0, 0), SHIFT_REPEAT(7337),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [10021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 2, 0, 0),
  [10023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [10025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0),
  [10027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(1464),
  [10030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 2, 0, 0), SHIFT_REPEAT(8384),
  [10033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 5, 0, 0),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [10037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0),
  [10039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(1411),
  [10042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2, 0, 0), SHIFT_REPEAT(8559),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [10047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [10049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7927),
  [10052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5311),
  [10054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 0),
  [10056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [10058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [10060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8274),
  [10063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8275),
  [10066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8322),
  [10069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 4, 0, 0),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9307),
  [10073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 4, 0, 0),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9172),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9359),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9351),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9822),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9336),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9328),
  [10097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [10101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9299),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [10109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4515),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9880),
  [10113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3621),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9882),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [10123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4537),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [10127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0),
  [10129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4117),
  [10132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [10136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [10138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [10140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [10142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [10146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [10148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [10150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [10152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3, 0, 0),
  [10154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [10156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [10158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [10162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 2, 0, 0),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [10192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 13),
  [10194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 33),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8312),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [10200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 31),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [10204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, 0, 0),
  [10206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [10212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 5, 0, 0),
  [10214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 37),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [10232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 3, 0, 0),
  [10238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 23),
  [10240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 23),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [10246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0),
  [10248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2, 0, 0), SHIFT_REPEAT(6844),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [10259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0),
  [10261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [10264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2, 0, 0), SHIFT_REPEAT(9168),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [10277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [10285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [10287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [10289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [10299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1, 0, 5),
  [10301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4, 0, 0),
  [10303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [10307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 21),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [10311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [10323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 21),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [10329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_constraint, 3, 0, 0),
  [10331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 1, 0, 0),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8856),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [10353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [10367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 0),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [10381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal_content, 1, 0, 0),
  [10385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [10393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 4, 0, 0),
  [10395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4908),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [10408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8567),
  [10411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2, 0, 0),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [10439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [10441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [10445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constructor_base_type, 2, 0, 5),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [10449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [10451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 4), REDUCE(sym_tuple_element, 2, 0, 12),
  [10454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declarator, 1, 0, 4),
  [10456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_declaration_repeat3, 1, 0, 0),
  [10458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [10464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string_content, 1, 0, 0),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [10472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 1, 0, 0),
  [10474] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12), REDUCE(sym_tuple_element, 2, 0, 12), REDUCE(sym_declaration_expression, 2, 1, 12),
  [10478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, 1, 12),
  [10480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 3, 0, 0),
  [10482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 3, 0, 0),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [10492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 0),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [10498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 47),
  [10500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 32), SHIFT_REPEAT(3789),
  [10503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 32),
  [10505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [10507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 30),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [10513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 1, 0, 4),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [10517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 2, 0, 14),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [10521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1419),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9893),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8872),
  [10538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 1, 0, 0),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [10548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_raw_string_content, 1, 0, 0),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8848),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [10554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat3, 1, 0, 0),
  [10556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7075),
  [10559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8536),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [10581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [10587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [10590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2, 0, 0),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7948),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8818),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9588),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [10622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [10628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [10634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [10638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [10648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 4, 0, 47),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [10652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [10656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1981),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [10671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [10681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [10696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(377),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [10703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 12), REDUCE(sym_tuple_element, 2, 0, 12),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8009),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7995),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [10722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4626),
  [10725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [10729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 5),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7284),
  [10747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 3, 0, 5),
  [10749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [10757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 13),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [10771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8261),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [10779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 3, 0, 0),
  [10781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 59), SHIFT_REPEAT(6922),
  [10784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 59),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [10790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_parameter_list_repeat1, 2, 0, 0),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [10794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 3, 0, 30),
  [10796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [10800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(364),
  [10803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [10815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7792),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [10819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1035),
  [10822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2, 0, 0),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8716),
  [10832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(621),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [10839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(6809),
  [10842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_attribute_repeat1, 2, 0, 0),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [10874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_variable_declaration, 2, 0, 5),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [10878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(358),
  [10881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [10883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9599),
  [10885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [10891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [10893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [10895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [10897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [10899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [10901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [10903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 59), SHIFT_REPEAT(7016),
  [10906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 59),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [10912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0), SHIFT_REPEAT(6918),
  [10915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_calling_convention_repeat1, 2, 0, 0),
  [10917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [10919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [10921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [10923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [10927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [10929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 12), REDUCE(sym_declaration_expression, 2, 1, 12),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [10934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_verbatim_string_content, 1, 0, 0),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [10940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 4),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [10944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 5),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [10950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 1, 0, 0),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [10954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, 0, 0),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [10962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1, 0, 0),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8883),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8915),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [11010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [11012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [11014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [11016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [11018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [11020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [11022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [11024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [11028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [11030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [11032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [11034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [11036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [11038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7283),
  [11041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_expression_repeat1, 2, 0, 0),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [11089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [11095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [11099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [11109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6818),
  [11112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2, 0, 0),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [11120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2, 0, 0), SHIFT_REPEAT(4905),
  [11123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2, 0, 0),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8825),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [11137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_initializer, 3, 0, 0),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [11141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7097),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [11170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(716),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [11177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0), SHIFT_REPEAT(7286),
  [11180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [11194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [11200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7284),
  [11203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_using_variable_declaration_repeat1, 2, 0, 0),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [11213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1010),
  [11216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2, 0, 0),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [11222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6811),
  [11225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2, 0, 0),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [11229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4826),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [11234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [11238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [11240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 33),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [11244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 4, 0, 31),
  [11246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2, 0, 41),
  [11248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 29),
  [11250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [11252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [11254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [11256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 4, 0, 0),
  [11258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [11260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_pragma_repeat1, 2, 0, 0),
  [11262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [11264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [11266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [11268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [11272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [11278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 4, 0, 37),
  [11280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9981),
  [11282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9898),
  [11284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [11286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [11288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9539),
  [11290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 2, 0, 12),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [11294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 2, 0, 0),
  [11296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 37),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [11300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [11302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 14),
  [11304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [11306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 5, 0, 57),
  [11308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [11310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [11312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [11314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1, 0, 0),
  [11316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [11320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 13),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [11324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 2, 0, 0),
  [11326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3, 0, 0),
  [11328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enum_member_declaration, 6, 0, 79),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [11334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9555),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [11340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9650),
  [11342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9181),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [11346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 4),
  [11348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 3, 0, 0),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [11352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 3, 0, 6),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [11356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [11368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, 0, 4),
  [11370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, 0, 14),
  [11372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 4, 0, 30),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [11376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9019),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [11386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9982),
  [11388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9894),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [11396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [11404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [11410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [11416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [11446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [11454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 2, 0, 0),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [11484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9206),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7827),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [11558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [11588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [11590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 1, 0, 5),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [11632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [11656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [11658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [11662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [11664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [11668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [11674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [11676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [11692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 57),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [11706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9349),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [11762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [11764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [11766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [11768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [11774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [11782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [11784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [11806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [11822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [11824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [11826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [11828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [11830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [11832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [11834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [11836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [11838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [11840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [11842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [11862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [11886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [11888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [11890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [11892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [11894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [11896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [11898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [11900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [11902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [11904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [11906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [11908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [11910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [11912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [11914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [11916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [11918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [11920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [11938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [11994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [12006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [12016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [12018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [12022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [12044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [12046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [12048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [12056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [12058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [12060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [12062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [12070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [12072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [12074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [12076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [12078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [12080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [12088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [12090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [12092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [12094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [12096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 5, 0, 0),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [12100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [12102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [12108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [12116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [12120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [12122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [12126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [12130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enum_member_declaration, 2, 0, 0),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [12136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [12196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 5, 0, 0),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [12220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [12234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [12312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9740),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [12390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 5, 0, 79),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8829),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8304),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [12406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 5, 0, 79),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [12412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8894),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [12462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [12474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_filter_clause, 4, 0, 0),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [12488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_top_level, 4, 0, 57),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [12512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9186),
  [12514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_expression, 4, 0, 57),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [12518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 3, 0, 0),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [12528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 2, 0, 6),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9996),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9994),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9171),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7763),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7797),
  [12578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9088),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [12670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [12798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_format_clause, 2, 0, 0),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [12816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [12834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [12842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [12844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [12860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9984),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [12920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 5, 0, 79),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [12936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 4, 0, 0),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [12962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 79),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8671),
  [12972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 4, 0, 0),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9990),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [13072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enum_member_declaration, 4, 0, 57),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9607),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [13126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_parameters, 1, 0, 0),
  [13128] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8337),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8979),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8310),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8294),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8305),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [13246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9873),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [13252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9874),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [13260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9877),
  [13262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 2, 0, 0),
  [13264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 2, 0, 0),
  [13266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 14, 0, 0),
  [13268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 15, 0, 0),
  [13270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 6, 0, 0),
  [13272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_region, 3, 0, 11),
  [13274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_endregion, 3, 0, 11),
  [13276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 3, 0, 0),
  [13278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 3, 0, 0),
  [13280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_error, 3, 0, 0),
  [13282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_define, 3, 0, 0),
  [13284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_undef, 3, 0, 0),
  [13286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 5, 0, 0),
  [13288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_line, 4, 0, 0),
  [13290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_pragma, 4, 0, 0),
  [13292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_nullable, 4, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__optional_semi = 0,
  ts_external_token_interpolation_regular_start = 1,
  ts_external_token_interpolation_verbatim_start = 2,
  ts_external_token_interpolation_raw_start = 3,
  ts_external_token_interpolation_start_quote = 4,
  ts_external_token_interpolation_end_quote = 5,
  ts_external_token_interpolation_open_brace = 6,
  ts_external_token_interpolation_close_brace = 7,
  ts_external_token_interpolation_string_content = 8,
  ts_external_token_raw_string_start = 9,
  ts_external_token_raw_string_end = 10,
  ts_external_token_raw_string_content = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__optional_semi] = sym__optional_semi,
  [ts_external_token_interpolation_regular_start] = sym_interpolation_regular_start,
  [ts_external_token_interpolation_verbatim_start] = sym_interpolation_verbatim_start,
  [ts_external_token_interpolation_raw_start] = sym_interpolation_raw_start,
  [ts_external_token_interpolation_start_quote] = sym_interpolation_start_quote,
  [ts_external_token_interpolation_end_quote] = sym_interpolation_end_quote,
  [ts_external_token_interpolation_open_brace] = sym_interpolation_open_brace,
  [ts_external_token_interpolation_close_brace] = sym_interpolation_close_brace,
  [ts_external_token_interpolation_string_content] = sym_interpolation_string_content,
  [ts_external_token_raw_string_start] = sym_raw_string_start,
  [ts_external_token_raw_string_end] = sym_raw_string_end,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[11][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__optional_semi] = true,
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_start_quote] = true,
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_close_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
    [ts_external_token_raw_string_start] = true,
    [ts_external_token_raw_string_end] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_raw_string_start] = true,
  },
  [3] = {
    [ts_external_token_interpolation_regular_start] = true,
    [ts_external_token_interpolation_verbatim_start] = true,
    [ts_external_token_interpolation_raw_start] = true,
    [ts_external_token_interpolation_close_brace] = true,
    [ts_external_token_raw_string_start] = true,
  },
  [4] = {
    [ts_external_token_interpolation_close_brace] = true,
  },
  [5] = {
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [6] = {
    [ts_external_token_interpolation_end_quote] = true,
    [ts_external_token_interpolation_open_brace] = true,
    [ts_external_token_interpolation_string_content] = true,
  },
  [7] = {
    [ts_external_token__optional_semi] = true,
  },
  [8] = {
    [ts_external_token_raw_string_content] = true,
  },
  [9] = {
    [ts_external_token_interpolation_start_quote] = true,
  },
  [10] = {
    [ts_external_token_raw_string_end] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_c_sharp_external_scanner_create(void);
void tree_sitter_c_sharp_external_scanner_destroy(void *);
bool tree_sitter_c_sharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_c_sharp_external_scanner_serialize(void *, char *);
void tree_sitter_c_sharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_c_sharp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier_token,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_c_sharp_external_scanner_create,
      tree_sitter_c_sharp_external_scanner_destroy,
      tree_sitter_c_sharp_external_scanner_scan,
      tree_sitter_c_sharp_external_scanner_serialize,
      tree_sitter_c_sharp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
